
/* /web/static/src/module_loader.js */
(function(odoo){"use strict";if(odoo.loader){return;}
class ModuleLoader{bus=new EventTarget();checkErrorProm=null;factories=new Map();failed=new Set();jobs=new Set();modules=new Map();constructor(root){this.root=root;}
addJob(name){this.jobs.add(name);this.startModules();}
define(name,deps,factory,lazy=false){if(typeof name!=="string"){throw new Error(`Module name should be a string, got: ${String(name)}`);}
if(!Array.isArray(deps)){throw new Error(`Module dependencies should be a list of strings, got: ${String(deps)}`);}
if(typeof factory!=="function"){throw new Error(`Module factory should be a function, got: ${String(factory)}`);}
if(this.factories.has(name)){return;}
this.factories.set(name,{deps,fn:factory,ignoreMissingDeps:globalThis.__odooIgnoreMissingDependencies,});if(!lazy){this.addJob(name);this.checkErrorProm||=Promise.resolve().then(()=>{this.checkErrorProm=null;this.reportErrors(this.findErrors());});}}
findErrors(moduleNames){const findCycle=(currentModuleNames,visited)=>{for(const name of currentModuleNames||[]){if(visited.has(name)){const cycleModuleNames=[...visited,name];return cycleModuleNames.slice(cycleModuleNames.indexOf(name)).map((j)=>`"${j}"`).join(" => ");}
const cycle=findCycle(dependencyGraph[name],new Set(visited).add(name));if(cycle){return cycle;}}
return null;};moduleNames||=this.jobs;const dependencyGraph=Object.create(null);const missing=new Set();const unloaded=new Set();for(const moduleName of moduleNames){const{deps,ignoreMissingDeps}=this.factories.get(moduleName);dependencyGraph[moduleName]=deps;if(ignoreMissingDeps){continue;}
unloaded.add(moduleName);for(const dep of deps){if(!this.factories.has(dep)){missing.add(dep);}}}
const cycle=findCycle(moduleNames,new Set());const errors={};if(cycle){errors.cycle=cycle;}
if(this.failed.size){errors.failed=this.failed;}
if(missing.size){errors.missing=missing;}
if(unloaded.size){errors.unloaded=unloaded;}
return errors;}
findJob(){for(const job of this.jobs){if(this.factories.get(job).deps.every((dep)=>this.modules.has(dep))){return job;}}
return null;}
async reportErrors(errors){if(!Object.keys(errors).length){return;}
if(errors.failed){console.error("The following modules failed to load because of an error:",[...errors.failed,]);}
if(errors.missing){console.error("The following modules are needed by other modules but have not been defined, they may not be present in the correct asset bundle:",[...errors.missing]);}
if(errors.cycle){console.error("The following modules could not be loaded because they form a dependency cycle:",errors.cycle);}
if(errors.unloaded){console.error("The following modules could not be loaded because they have unmet dependencies, this is a secondary error which is likely caused by one of the above problems:",[...errors.unloaded]);}
const document=this.root?.ownerDocument||globalThis.document;if(document.readyState==="loading"){await new Promise((resolve)=>document.addEventListener("DOMContentLoaded",resolve));}
const debug=new URLSearchParams(location.search).get("debug");if(debug&&debug!=="0"){const style=document.createElement("style");style.className="o_module_error_banner";style.textContent=`
                    body::before {
                        font-weight: bold;
                        content: "An error occurred while loading javascript modules, you may find more information in the devtools console";
                        position: fixed;
                        left: 0;
                        bottom: 0;
                        z-index: 100000000000;
                        background-color: #C00;
                        color: #DDD;
                    }
                `;document.head.appendChild(style);}}
startModules(){let job;while((job=this.findJob())){this.startModule(job);}}
startModule(name){const require=(dependency)=>this.modules.get(dependency);this.jobs.delete(name);const factory=this.factories.get(name);let module=null;try{module=factory.fn(require);}catch(error){this.failed.add(name);throw new Error(`Error while loading "${name}":\n${error}`);}
this.modules.set(name,module);this.bus.dispatchEvent(new CustomEvent("module-started",{detail:{moduleName:name,module},}));return module;}}
if(odoo.debug&&!new URLSearchParams(location.search).has("debug")){odoo.debug="";}
const loader=new ModuleLoader();odoo.define=loader.define.bind(loader);odoo.loader=loader;})((globalThis.odoo||={}));;

/* /web/static/lib/luxon/luxon.js */
var luxon=(function(exports){'use strict';class LuxonError extends Error{}
class InvalidDateTimeError extends LuxonError{constructor(reason){super(`Invalid DateTime: ${reason.toMessage()}`);}}
class InvalidIntervalError extends LuxonError{constructor(reason){super(`Invalid Interval: ${reason.toMessage()}`);}}
class InvalidDurationError extends LuxonError{constructor(reason){super(`Invalid Duration: ${reason.toMessage()}`);}}
class ConflictingSpecificationError extends LuxonError{}
class InvalidUnitError extends LuxonError{constructor(unit){super(`Invalid unit ${unit}`);}}
class InvalidArgumentError extends LuxonError{}
class ZoneIsAbstractError extends LuxonError{constructor(){super("Zone is an abstract class");}}
const n="numeric",s="short",l="long";const DATE_SHORT={year:n,month:n,day:n,};const DATE_MED={year:n,month:s,day:n,};const DATE_MED_WITH_WEEKDAY={year:n,month:s,day:n,weekday:s,};const DATE_FULL={year:n,month:l,day:n,};const DATE_HUGE={year:n,month:l,day:n,weekday:l,};const TIME_SIMPLE={hour:n,minute:n,};const TIME_WITH_SECONDS={hour:n,minute:n,second:n,};const TIME_WITH_SHORT_OFFSET={hour:n,minute:n,second:n,timeZoneName:s,};const TIME_WITH_LONG_OFFSET={hour:n,minute:n,second:n,timeZoneName:l,};const TIME_24_SIMPLE={hour:n,minute:n,hourCycle:"h23",};const TIME_24_WITH_SECONDS={hour:n,minute:n,second:n,hourCycle:"h23",};const TIME_24_WITH_SHORT_OFFSET={hour:n,minute:n,second:n,hourCycle:"h23",timeZoneName:s,};const TIME_24_WITH_LONG_OFFSET={hour:n,minute:n,second:n,hourCycle:"h23",timeZoneName:l,};const DATETIME_SHORT={year:n,month:n,day:n,hour:n,minute:n,};const DATETIME_SHORT_WITH_SECONDS={year:n,month:n,day:n,hour:n,minute:n,second:n,};const DATETIME_MED={year:n,month:s,day:n,hour:n,minute:n,};const DATETIME_MED_WITH_SECONDS={year:n,month:s,day:n,hour:n,minute:n,second:n,};const DATETIME_MED_WITH_WEEKDAY={year:n,month:s,day:n,weekday:s,hour:n,minute:n,};const DATETIME_FULL={year:n,month:l,day:n,hour:n,minute:n,timeZoneName:s,};const DATETIME_FULL_WITH_SECONDS={year:n,month:l,day:n,hour:n,minute:n,second:n,timeZoneName:s,};const DATETIME_HUGE={year:n,month:l,day:n,weekday:l,hour:n,minute:n,timeZoneName:l,};const DATETIME_HUGE_WITH_SECONDS={year:n,month:l,day:n,weekday:l,hour:n,minute:n,second:n,timeZoneName:l,};class Zone{get type(){throw new ZoneIsAbstractError();}
get name(){throw new ZoneIsAbstractError();}
get ianaName(){return this.name;}
get isUniversal(){throw new ZoneIsAbstractError();}
offsetName(ts,opts){throw new ZoneIsAbstractError();}
formatOffset(ts,format){throw new ZoneIsAbstractError();}
offset(ts){throw new ZoneIsAbstractError();}
equals(otherZone){throw new ZoneIsAbstractError();}
get isValid(){throw new ZoneIsAbstractError();}}
let singleton$1=null;class SystemZone extends Zone{static get instance(){if(singleton$1===null){singleton$1=new SystemZone();}
return singleton$1;}
get type(){return"system";}
get name(){return new Intl.DateTimeFormat().resolvedOptions().timeZone;}
get isUniversal(){return false;}
offsetName(ts,{format,locale}){return parseZoneInfo(ts,format,locale);}
formatOffset(ts,format){return formatOffset(this.offset(ts),format);}
offset(ts){return-new Date(ts).getTimezoneOffset();}
equals(otherZone){return otherZone.type==="system";}
get isValid(){return true;}}
let dtfCache={};function makeDTF(zone){if(!dtfCache[zone]){dtfCache[zone]=new Intl.DateTimeFormat("en-US",{hour12:false,timeZone:zone,year:"numeric",month:"2-digit",day:"2-digit",hour:"2-digit",minute:"2-digit",second:"2-digit",era:"short",});}
return dtfCache[zone];}
const typeToPos={year:0,month:1,day:2,era:3,hour:4,minute:5,second:6,};function hackyOffset(dtf,date){const formatted=dtf.format(date).replace(/\u200E/g,""),parsed=/(\d+)\/(\d+)\/(\d+) (AD|BC),? (\d+):(\d+):(\d+)/.exec(formatted),[,fMonth,fDay,fYear,fadOrBc,fHour,fMinute,fSecond]=parsed;return[fYear,fMonth,fDay,fadOrBc,fHour,fMinute,fSecond];}
function partsOffset(dtf,date){const formatted=dtf.formatToParts(date);const filled=[];for(let i=0;i<formatted.length;i++){const{type,value}=formatted[i];const pos=typeToPos[type];if(type==="era"){filled[pos]=value;}else if(!isUndefined(pos)){filled[pos]=parseInt(value,10);}}
return filled;}
let ianaZoneCache={};class IANAZone extends Zone{static create(name){if(!ianaZoneCache[name]){ianaZoneCache[name]=new IANAZone(name);}
return ianaZoneCache[name];}
static resetCache(){ianaZoneCache={};dtfCache={};}
static isValidSpecifier(s){return this.isValidZone(s);}
static isValidZone(zone){if(!zone){return false;}
try{new Intl.DateTimeFormat("en-US",{timeZone:zone}).format();return true;}catch(e){return false;}}
constructor(name){super();this.zoneName=name;this.valid=IANAZone.isValidZone(name);}
get type(){return"iana";}
get name(){return this.zoneName;}
get isUniversal(){return false;}
offsetName(ts,{format,locale}){return parseZoneInfo(ts,format,locale,this.name);}
formatOffset(ts,format){return formatOffset(this.offset(ts),format);}
offset(ts){const date=new Date(ts);if(isNaN(date))return NaN;const dtf=makeDTF(this.name);let[year,month,day,adOrBc,hour,minute,second]=dtf.formatToParts?partsOffset(dtf,date):hackyOffset(dtf,date);if(adOrBc==="BC"){year=-Math.abs(year)+1;}
const adjustedHour=hour===24?0:hour;const asUTC=objToLocalTS({year,month,day,hour:adjustedHour,minute,second,millisecond:0,});let asTS=+date;const over=asTS%1000;asTS-=over>=0?over:1000+over;return(asUTC-asTS)/(60*1000);}
equals(otherZone){return otherZone.type==="iana"&&otherZone.name===this.name;}
get isValid(){return this.valid;}}
let intlLFCache={};function getCachedLF(locString,opts={}){const key=JSON.stringify([locString,opts]);let dtf=intlLFCache[key];if(!dtf){dtf=new Intl.ListFormat(locString,opts);intlLFCache[key]=dtf;}
return dtf;}
let intlDTCache={};function getCachedDTF(locString,opts={}){const key=JSON.stringify([locString,opts]);let dtf=intlDTCache[key];if(!dtf){dtf=new Intl.DateTimeFormat(locString,opts);intlDTCache[key]=dtf;}
return dtf;}
let intlNumCache={};function getCachedINF(locString,opts={}){const key=JSON.stringify([locString,opts]);let inf=intlNumCache[key];if(!inf){inf=new Intl.NumberFormat(locString,opts);intlNumCache[key]=inf;}
return inf;}
let intlRelCache={};function getCachedRTF(locString,opts={}){const{base,...cacheKeyOpts}=opts;const key=JSON.stringify([locString,cacheKeyOpts]);let inf=intlRelCache[key];if(!inf){inf=new Intl.RelativeTimeFormat(locString,opts);intlRelCache[key]=inf;}
return inf;}
let sysLocaleCache=null;function systemLocale(){if(sysLocaleCache){return sysLocaleCache;}else{sysLocaleCache=new Intl.DateTimeFormat().resolvedOptions().locale;return sysLocaleCache;}}
let weekInfoCache={};function getCachedWeekInfo(locString){let data=weekInfoCache[locString];if(!data){const locale=new Intl.Locale(locString);data="getWeekInfo"in locale?locale.getWeekInfo():locale.weekInfo;weekInfoCache[locString]=data;}
return data;}
function parseLocaleString(localeStr){const xIndex=localeStr.indexOf("-x-");if(xIndex!==-1){localeStr=localeStr.substring(0,xIndex);}
const uIndex=localeStr.indexOf("-u-");if(uIndex===-1){return[localeStr];}else{let options;let selectedStr;try{options=getCachedDTF(localeStr).resolvedOptions();selectedStr=localeStr;}catch(e){const smaller=localeStr.substring(0,uIndex);options=getCachedDTF(smaller).resolvedOptions();selectedStr=smaller;}
const{numberingSystem,calendar}=options;return[selectedStr,numberingSystem,calendar];}}
function intlConfigString(localeStr,numberingSystem,outputCalendar){if(outputCalendar||numberingSystem){if(!localeStr.includes("-u-")){localeStr+="-u";}
if(outputCalendar){localeStr+=`-ca-${outputCalendar}`;}
if(numberingSystem){localeStr+=`-nu-${numberingSystem}`;}
return localeStr;}else{return localeStr;}}
function mapMonths(f){const ms=[];for(let i=1;i<=12;i++){const dt=DateTime.utc(2009,i,1);ms.push(f(dt));}
return ms;}
function mapWeekdays(f){const ms=[];for(let i=1;i<=7;i++){const dt=DateTime.utc(2016,11,13+i);ms.push(f(dt));}
return ms;}
function listStuff(loc,length,englishFn,intlFn){const mode=loc.listingMode();if(mode==="error"){return null;}else if(mode==="en"){return englishFn(length);}else{return intlFn(length);}}
function supportsFastNumbers(loc){if(loc.numberingSystem&&loc.numberingSystem!=="latn"){return false;}else{return(loc.numberingSystem==="latn"||!loc.locale||loc.locale.startsWith("en")||new Intl.DateTimeFormat(loc.intl).resolvedOptions().numberingSystem==="latn");}}
class PolyNumberFormatter{constructor(intl,forceSimple,opts){this.padTo=opts.padTo||0;this.floor=opts.floor||false;const{padTo,floor,...otherOpts}=opts;if(!forceSimple||Object.keys(otherOpts).length>0){const intlOpts={useGrouping:false,...opts};if(opts.padTo>0)intlOpts.minimumIntegerDigits=opts.padTo;this.inf=getCachedINF(intl,intlOpts);}}
format(i){if(this.inf){const fixed=this.floor?Math.floor(i):i;return this.inf.format(fixed);}else{const fixed=this.floor?Math.floor(i):roundTo(i,3);return padStart(fixed,this.padTo);}}}
class PolyDateFormatter{constructor(dt,intl,opts){this.opts=opts;this.originalZone=undefined;let z=undefined;if(this.opts.timeZone){this.dt=dt;}else if(dt.zone.type==="fixed"){const gmtOffset=-1*(dt.offset/60);const offsetZ=gmtOffset>=0?`Etc/GMT+${gmtOffset}`:`Etc/GMT${gmtOffset}`;if(dt.offset!==0&&IANAZone.create(offsetZ).valid){z=offsetZ;this.dt=dt;}else{z="UTC";this.dt=dt.offset===0?dt:dt.setZone("UTC").plus({minutes:dt.offset});this.originalZone=dt.zone;}}else if(dt.zone.type==="system"){this.dt=dt;}else if(dt.zone.type==="iana"){this.dt=dt;z=dt.zone.name;}else{z="UTC";this.dt=dt.setZone("UTC").plus({minutes:dt.offset});this.originalZone=dt.zone;}
const intlOpts={...this.opts};intlOpts.timeZone=intlOpts.timeZone||z;this.dtf=getCachedDTF(intl,intlOpts);}
format(){if(this.originalZone){return this.formatToParts().map(({value})=>value).join("");}
return this.dtf.format(this.dt.toJSDate());}
formatToParts(){const parts=this.dtf.formatToParts(this.dt.toJSDate());if(this.originalZone){return parts.map((part)=>{if(part.type==="timeZoneName"){const offsetName=this.originalZone.offsetName(this.dt.ts,{locale:this.dt.locale,format:this.opts.timeZoneName,});return{...part,value:offsetName,};}else{return part;}});}
return parts;}
resolvedOptions(){return this.dtf.resolvedOptions();}}
class PolyRelFormatter{constructor(intl,isEnglish,opts){this.opts={style:"long",...opts};if(!isEnglish&&hasRelative()){this.rtf=getCachedRTF(intl,opts);}}
format(count,unit){if(this.rtf){return this.rtf.format(count,unit);}else{return formatRelativeTime(unit,count,this.opts.numeric,this.opts.style!=="long");}}
formatToParts(count,unit){if(this.rtf){return this.rtf.formatToParts(count,unit);}else{return[];}}}
const fallbackWeekSettings={firstDay:1,minimalDays:4,weekend:[6,7],};class Locale{static fromOpts(opts){return Locale.create(opts.locale,opts.numberingSystem,opts.outputCalendar,opts.weekSettings,opts.defaultToEN);}
static create(locale,numberingSystem,outputCalendar,weekSettings,defaultToEN=false){const specifiedLocale=locale||Settings.defaultLocale;const localeR=specifiedLocale||(defaultToEN?"en-US":systemLocale());const numberingSystemR=numberingSystem||Settings.defaultNumberingSystem;const outputCalendarR=outputCalendar||Settings.defaultOutputCalendar;const weekSettingsR=validateWeekSettings(weekSettings)||Settings.defaultWeekSettings;return new Locale(localeR,numberingSystemR,outputCalendarR,weekSettingsR,specifiedLocale);}
static resetCache(){sysLocaleCache=null;intlDTCache={};intlNumCache={};intlRelCache={};}
static fromObject({locale,numberingSystem,outputCalendar,weekSettings}={}){return Locale.create(locale,numberingSystem,outputCalendar,weekSettings);}
constructor(locale,numbering,outputCalendar,weekSettings,specifiedLocale){const[parsedLocale,parsedNumberingSystem,parsedOutputCalendar]=parseLocaleString(locale);this.locale=parsedLocale;this.numberingSystem=numbering||parsedNumberingSystem||null;this.outputCalendar=outputCalendar||parsedOutputCalendar||null;this.weekSettings=weekSettings;this.intl=intlConfigString(this.locale,this.numberingSystem,this.outputCalendar);this.weekdaysCache={format:{},standalone:{}};this.monthsCache={format:{},standalone:{}};this.meridiemCache=null;this.eraCache={};this.specifiedLocale=specifiedLocale;this.fastNumbersCached=null;}
get fastNumbers(){if(this.fastNumbersCached==null){this.fastNumbersCached=supportsFastNumbers(this);}
return this.fastNumbersCached;}
listingMode(){const isActuallyEn=this.isEnglish();const hasNoWeirdness=(this.numberingSystem===null||this.numberingSystem==="latn")&&(this.outputCalendar===null||this.outputCalendar==="gregory");return isActuallyEn&&hasNoWeirdness?"en":"intl";}
clone(alts){if(!alts||Object.getOwnPropertyNames(alts).length===0){return this;}else{return Locale.create(alts.locale||this.specifiedLocale,alts.numberingSystem||this.numberingSystem,alts.outputCalendar||this.outputCalendar,validateWeekSettings(alts.weekSettings)||this.weekSettings,alts.defaultToEN||false);}}
redefaultToEN(alts={}){return this.clone({...alts,defaultToEN:true});}
redefaultToSystem(alts={}){return this.clone({...alts,defaultToEN:false});}
months(length,format=false){return listStuff(this,length,months,()=>{const intl=format?{month:length,day:"numeric"}:{month:length},formatStr=format?"format":"standalone";if(!this.monthsCache[formatStr][length]){this.monthsCache[formatStr][length]=mapMonths((dt)=>this.extract(dt,intl,"month"));}
return this.monthsCache[formatStr][length];});}
weekdays(length,format=false){return listStuff(this,length,weekdays,()=>{const intl=format?{weekday:length,year:"numeric",month:"long",day:"numeric"}:{weekday:length},formatStr=format?"format":"standalone";if(!this.weekdaysCache[formatStr][length]){this.weekdaysCache[formatStr][length]=mapWeekdays((dt)=>this.extract(dt,intl,"weekday"));}
return this.weekdaysCache[formatStr][length];});}
meridiems(){return listStuff(this,undefined,()=>meridiems,()=>{if(!this.meridiemCache){const intl={hour:"numeric",hourCycle:"h12"};this.meridiemCache=[DateTime.utc(2016,11,13,9),DateTime.utc(2016,11,13,19)].map((dt)=>this.extract(dt,intl,"dayperiod"));}
return this.meridiemCache;});}
eras(length){return listStuff(this,length,eras,()=>{const intl={era:length};if(!this.eraCache[length]){this.eraCache[length]=[DateTime.utc(-40,1,1),DateTime.utc(2017,1,1)].map((dt)=>this.extract(dt,intl,"era"));}
return this.eraCache[length];});}
extract(dt,intlOpts,field){const df=this.dtFormatter(dt,intlOpts),results=df.formatToParts(),matching=results.find((m)=>m.type.toLowerCase()===field);return matching?matching.value:null;}
numberFormatter(opts={}){return new PolyNumberFormatter(this.intl,opts.forceSimple||this.fastNumbers,opts);}
dtFormatter(dt,intlOpts={}){return new PolyDateFormatter(dt,this.intl,intlOpts);}
relFormatter(opts={}){return new PolyRelFormatter(this.intl,this.isEnglish(),opts);}
listFormatter(opts={}){return getCachedLF(this.intl,opts);}
isEnglish(){return(this.locale==="en"||this.locale.toLowerCase()==="en-us"||new Intl.DateTimeFormat(this.intl).resolvedOptions().locale.startsWith("en-us"));}
getWeekSettings(){if(this.weekSettings){return this.weekSettings;}else if(!hasLocaleWeekInfo()){return fallbackWeekSettings;}else{return getCachedWeekInfo(this.locale);}}
getStartOfWeek(){return this.getWeekSettings().firstDay;}
getMinDaysInFirstWeek(){return this.getWeekSettings().minimalDays;}
getWeekendDays(){return this.getWeekSettings().weekend;}
equals(other){return(this.locale===other.locale&&this.numberingSystem===other.numberingSystem&&this.outputCalendar===other.outputCalendar);}}
let singleton=null;class FixedOffsetZone extends Zone{static get utcInstance(){if(singleton===null){singleton=new FixedOffsetZone(0);}
return singleton;}
static instance(offset){return offset===0?FixedOffsetZone.utcInstance:new FixedOffsetZone(offset);}
static parseSpecifier(s){if(s){const r=s.match(/^utc(?:([+-]\d{1,2})(?::(\d{2}))?)?$/i);if(r){return new FixedOffsetZone(signedOffset(r[1],r[2]));}}
return null;}
constructor(offset){super();this.fixed=offset;}
get type(){return"fixed";}
get name(){return this.fixed===0?"UTC":`UTC${formatOffset(this.fixed, "narrow")}`;}
get ianaName(){if(this.fixed===0){return"Etc/UTC";}else{return`Etc/GMT${formatOffset(-this.fixed, "narrow")}`;}}
offsetName(){return this.name;}
formatOffset(ts,format){return formatOffset(this.fixed,format);}
get isUniversal(){return true;}
offset(){return this.fixed;}
equals(otherZone){return otherZone.type==="fixed"&&otherZone.fixed===this.fixed;}
get isValid(){return true;}}
class InvalidZone extends Zone{constructor(zoneName){super();this.zoneName=zoneName;}
get type(){return"invalid";}
get name(){return this.zoneName;}
get isUniversal(){return false;}
offsetName(){return null;}
formatOffset(){return"";}
offset(){return NaN;}
equals(){return false;}
get isValid(){return false;}}
function normalizeZone(input,defaultZone){if(isUndefined(input)||input===null){return defaultZone;}else if(input instanceof Zone){return input;}else if(isString(input)){const lowered=input.toLowerCase();if(lowered==="default")return defaultZone;else if(lowered==="local"||lowered==="system")return SystemZone.instance;else if(lowered==="utc"||lowered==="gmt")return FixedOffsetZone.utcInstance;else return FixedOffsetZone.parseSpecifier(lowered)||IANAZone.create(input);}else if(isNumber(input)){return FixedOffsetZone.instance(input);}else if(typeof input==="object"&&"offset"in input&&typeof input.offset==="function"){return input;}else{return new InvalidZone(input);}}
let now=()=>Date.now(),defaultZone="system",defaultLocale=null,defaultNumberingSystem=null,defaultOutputCalendar=null,twoDigitCutoffYear=60,throwOnInvalid,defaultWeekSettings=null;class Settings{static get now(){return now;}
static set now(n){now=n;}
static set defaultZone(zone){defaultZone=zone;}
static get defaultZone(){return normalizeZone(defaultZone,SystemZone.instance);}
static get defaultLocale(){return defaultLocale;}
static set defaultLocale(locale){defaultLocale=locale;}
static get defaultNumberingSystem(){return defaultNumberingSystem;}
static set defaultNumberingSystem(numberingSystem){defaultNumberingSystem=numberingSystem;}
static get defaultOutputCalendar(){return defaultOutputCalendar;}
static set defaultOutputCalendar(outputCalendar){defaultOutputCalendar=outputCalendar;}
static get defaultWeekSettings(){return defaultWeekSettings;}
static set defaultWeekSettings(weekSettings){defaultWeekSettings=validateWeekSettings(weekSettings);}
static get twoDigitCutoffYear(){return twoDigitCutoffYear;}
static set twoDigitCutoffYear(cutoffYear){twoDigitCutoffYear=cutoffYear%100;}
static get throwOnInvalid(){return throwOnInvalid;}
static set throwOnInvalid(t){throwOnInvalid=t;}
static resetCaches(){Locale.resetCache();IANAZone.resetCache();}}
class Invalid{constructor(reason,explanation){this.reason=reason;this.explanation=explanation;}
toMessage(){if(this.explanation){return`${this.reason}: ${this.explanation}`;}else{return this.reason;}}}
const nonLeapLadder=[0,31,59,90,120,151,181,212,243,273,304,334],leapLadder=[0,31,60,91,121,152,182,213,244,274,305,335];function unitOutOfRange(unit,value){return new Invalid("unit out of range",`you specified ${value} (of type ${typeof value}) as a ${unit}, which is invalid`);}
function dayOfWeek(year,month,day){const d=new Date(Date.UTC(year,month-1,day));if(year<100&&year>=0){d.setUTCFullYear(d.getUTCFullYear()-1900);}
const js=d.getUTCDay();return js===0?7:js;}
function computeOrdinal(year,month,day){return day+(isLeapYear(year)?leapLadder:nonLeapLadder)[month-1];}
function uncomputeOrdinal(year,ordinal){const table=isLeapYear(year)?leapLadder:nonLeapLadder,month0=table.findIndex((i)=>i<ordinal),day=ordinal-table[month0];return{month:month0+1,day};}
function isoWeekdayToLocal(isoWeekday,startOfWeek){return((isoWeekday-startOfWeek+7)%7)+1;}
function gregorianToWeek(gregObj,minDaysInFirstWeek=4,startOfWeek=1){const{year,month,day}=gregObj,ordinal=computeOrdinal(year,month,day),weekday=isoWeekdayToLocal(dayOfWeek(year,month,day),startOfWeek);let weekNumber=Math.floor((ordinal-weekday+14-minDaysInFirstWeek)/7),weekYear;if(weekNumber<1){weekYear=year-1;weekNumber=weeksInWeekYear(weekYear,minDaysInFirstWeek,startOfWeek);}else if(weekNumber>weeksInWeekYear(year,minDaysInFirstWeek,startOfWeek)){weekYear=year+1;weekNumber=1;}else{weekYear=year;}
return{weekYear,weekNumber,weekday,...timeObject(gregObj)};}
function weekToGregorian(weekData,minDaysInFirstWeek=4,startOfWeek=1){const{weekYear,weekNumber,weekday}=weekData,weekdayOfJan4=isoWeekdayToLocal(dayOfWeek(weekYear,1,minDaysInFirstWeek),startOfWeek),yearInDays=daysInYear(weekYear);let ordinal=weekNumber*7+weekday-weekdayOfJan4-7+minDaysInFirstWeek,year;if(ordinal<1){year=weekYear-1;ordinal+=daysInYear(year);}else if(ordinal>yearInDays){year=weekYear+1;ordinal-=daysInYear(weekYear);}else{year=weekYear;}
const{month,day}=uncomputeOrdinal(year,ordinal);return{year,month,day,...timeObject(weekData)};}
function gregorianToOrdinal(gregData){const{year,month,day}=gregData;const ordinal=computeOrdinal(year,month,day);return{year,ordinal,...timeObject(gregData)};}
function ordinalToGregorian(ordinalData){const{year,ordinal}=ordinalData;const{month,day}=uncomputeOrdinal(year,ordinal);return{year,month,day,...timeObject(ordinalData)};}
function usesLocalWeekValues(obj,loc){const hasLocaleWeekData=!isUndefined(obj.localWeekday)||!isUndefined(obj.localWeekNumber)||!isUndefined(obj.localWeekYear);if(hasLocaleWeekData){const hasIsoWeekData=!isUndefined(obj.weekday)||!isUndefined(obj.weekNumber)||!isUndefined(obj.weekYear);if(hasIsoWeekData){throw new ConflictingSpecificationError("Cannot mix locale-based week fields with ISO-based week fields");}
if(!isUndefined(obj.localWeekday))obj.weekday=obj.localWeekday;if(!isUndefined(obj.localWeekNumber))obj.weekNumber=obj.localWeekNumber;if(!isUndefined(obj.localWeekYear))obj.weekYear=obj.localWeekYear;delete obj.localWeekday;delete obj.localWeekNumber;delete obj.localWeekYear;return{minDaysInFirstWeek:loc.getMinDaysInFirstWeek(),startOfWeek:loc.getStartOfWeek(),};}else{return{minDaysInFirstWeek:4,startOfWeek:1};}}
function hasInvalidWeekData(obj,minDaysInFirstWeek=4,startOfWeek=1){const validYear=isInteger(obj.weekYear),validWeek=integerBetween(obj.weekNumber,1,weeksInWeekYear(obj.weekYear,minDaysInFirstWeek,startOfWeek)),validWeekday=integerBetween(obj.weekday,1,7);if(!validYear){return unitOutOfRange("weekYear",obj.weekYear);}else if(!validWeek){return unitOutOfRange("week",obj.weekNumber);}else if(!validWeekday){return unitOutOfRange("weekday",obj.weekday);}else return false;}
function hasInvalidOrdinalData(obj){const validYear=isInteger(obj.year),validOrdinal=integerBetween(obj.ordinal,1,daysInYear(obj.year));if(!validYear){return unitOutOfRange("year",obj.year);}else if(!validOrdinal){return unitOutOfRange("ordinal",obj.ordinal);}else return false;}
function hasInvalidGregorianData(obj){const validYear=isInteger(obj.year),validMonth=integerBetween(obj.month,1,12),validDay=integerBetween(obj.day,1,daysInMonth(obj.year,obj.month));if(!validYear){return unitOutOfRange("year",obj.year);}else if(!validMonth){return unitOutOfRange("month",obj.month);}else if(!validDay){return unitOutOfRange("day",obj.day);}else return false;}
function hasInvalidTimeData(obj){const{hour,minute,second,millisecond}=obj;const validHour=integerBetween(hour,0,23)||(hour===24&&minute===0&&second===0&&millisecond===0),validMinute=integerBetween(minute,0,59),validSecond=integerBetween(second,0,59),validMillisecond=integerBetween(millisecond,0,999);if(!validHour){return unitOutOfRange("hour",hour);}else if(!validMinute){return unitOutOfRange("minute",minute);}else if(!validSecond){return unitOutOfRange("second",second);}else if(!validMillisecond){return unitOutOfRange("millisecond",millisecond);}else return false;}
function isUndefined(o){return typeof o==="undefined";}
function isNumber(o){return typeof o==="number";}
function isInteger(o){return typeof o==="number"&&o%1===0;}
function isString(o){return typeof o==="string";}
function isDate(o){return Object.prototype.toString.call(o)==="[object Date]";}
function hasRelative(){try{return typeof Intl!=="undefined"&&!!Intl.RelativeTimeFormat;}catch(e){return false;}}
function hasLocaleWeekInfo(){try{return(typeof Intl!=="undefined"&&!!Intl.Locale&&("weekInfo"in Intl.Locale.prototype||"getWeekInfo"in Intl.Locale.prototype));}catch(e){return false;}}
function maybeArray(thing){return Array.isArray(thing)?thing:[thing];}
function bestBy(arr,by,compare){if(arr.length===0){return undefined;}
return arr.reduce((best,next)=>{const pair=[by(next),next];if(!best){return pair;}else if(compare(best[0],pair[0])===best[0]){return best;}else{return pair;}},null)[1];}
function pick(obj,keys){return keys.reduce((a,k)=>{a[k]=obj[k];return a;},{});}
function hasOwnProperty(obj,prop){return Object.prototype.hasOwnProperty.call(obj,prop);}
function validateWeekSettings(settings){if(settings==null){return null;}else if(typeof settings!=="object"){throw new InvalidArgumentError("Week settings must be an object");}else{if(!integerBetween(settings.firstDay,1,7)||!integerBetween(settings.minimalDays,1,7)||!Array.isArray(settings.weekend)||settings.weekend.some((v)=>!integerBetween(v,1,7))){throw new InvalidArgumentError("Invalid week settings");}
return{firstDay:settings.firstDay,minimalDays:settings.minimalDays,weekend:Array.from(settings.weekend),};}}
function integerBetween(thing,bottom,top){return isInteger(thing)&&thing>=bottom&&thing<=top;}
function floorMod(x,n){return x-n*Math.floor(x/n);}
function padStart(input,n=2){const isNeg=input<0;let padded;if(isNeg){padded="-"+(""+-input).padStart(n,"0");}else{padded=(""+input).padStart(n,"0");}
return padded;}
function parseInteger(string){if(isUndefined(string)||string===null||string===""){return undefined;}else{return parseInt(string,10);}}
function parseFloating(string){if(isUndefined(string)||string===null||string===""){return undefined;}else{return parseFloat(string);}}
function parseMillis(fraction){if(isUndefined(fraction)||fraction===null||fraction===""){return undefined;}else{const f=parseFloat("0."+fraction)*1000;return Math.floor(f);}}
function roundTo(number,digits,towardZero=false){const factor=10**digits,rounder=towardZero?Math.trunc:Math.round;return rounder(number*factor)/factor;}
function isLeapYear(year){return year%4===0&&(year%100!==0||year%400===0);}
function daysInYear(year){return isLeapYear(year)?366:365;}
function daysInMonth(year,month){const modMonth=floorMod(month-1,12)+1,modYear=year+(month-modMonth)/12;if(modMonth===2){return isLeapYear(modYear)?29:28;}else{return[31,null,31,30,31,30,31,31,30,31,30,31][modMonth-1];}}
function objToLocalTS(obj){let d=Date.UTC(obj.year,obj.month-1,obj.day,obj.hour,obj.minute,obj.second,obj.millisecond);if(obj.year<100&&obj.year>=0){d=new Date(d);d.setUTCFullYear(obj.year,obj.month-1,obj.day);}
return+d;}
function firstWeekOffset(year,minDaysInFirstWeek,startOfWeek){const fwdlw=isoWeekdayToLocal(dayOfWeek(year,1,minDaysInFirstWeek),startOfWeek);return-fwdlw+minDaysInFirstWeek-1;}
function weeksInWeekYear(weekYear,minDaysInFirstWeek=4,startOfWeek=1){const weekOffset=firstWeekOffset(weekYear,minDaysInFirstWeek,startOfWeek);const weekOffsetNext=firstWeekOffset(weekYear+1,minDaysInFirstWeek,startOfWeek);return(daysInYear(weekYear)-weekOffset+weekOffsetNext)/7;}
function untruncateYear(year){if(year>99){return year;}else return year>Settings.twoDigitCutoffYear?1900+year:2000+year;}
function parseZoneInfo(ts,offsetFormat,locale,timeZone=null){const date=new Date(ts),intlOpts={hourCycle:"h23",year:"numeric",month:"2-digit",day:"2-digit",hour:"2-digit",minute:"2-digit",};if(timeZone){intlOpts.timeZone=timeZone;}
const modified={timeZoneName:offsetFormat,...intlOpts};const parsed=new Intl.DateTimeFormat(locale,modified).formatToParts(date).find((m)=>m.type.toLowerCase()==="timezonename");return parsed?parsed.value:null;}
function signedOffset(offHourStr,offMinuteStr){let offHour=parseInt(offHourStr,10);if(Number.isNaN(offHour)){offHour=0;}
const offMin=parseInt(offMinuteStr,10)||0,offMinSigned=offHour<0||Object.is(offHour,-0)?-offMin:offMin;return offHour*60+offMinSigned;}
function asNumber(value){const numericValue=Number(value);if(typeof value==="boolean"||value===""||Number.isNaN(numericValue))
throw new InvalidArgumentError(`Invalid unit value ${value}`);return numericValue;}
function normalizeObject(obj,normalizer){const normalized={};for(const u in obj){if(hasOwnProperty(obj,u)){const v=obj[u];if(v===undefined||v===null)continue;normalized[normalizer(u)]=asNumber(v);}}
return normalized;}
function formatOffset(offset,format){const hours=Math.trunc(Math.abs(offset/60)),minutes=Math.trunc(Math.abs(offset%60)),sign=offset>=0?"+":"-";switch(format){case"short":return`${sign}${padStart(hours, 2)}:${padStart(minutes, 2)}`;case"narrow":return`${sign}${hours}${minutes > 0 ? `:${minutes}` : ""}`;case"techie":return`${sign}${padStart(hours, 2)}${padStart(minutes, 2)}`;default:throw new RangeError(`Value format ${format} is out of range for property format`);}}
function timeObject(obj){return pick(obj,["hour","minute","second","millisecond"]);}
const monthsLong=["January","February","March","April","May","June","July","August","September","October","November","December",];const monthsShort=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec",];const monthsNarrow=["J","F","M","A","M","J","J","A","S","O","N","D"];function months(length){switch(length){case"narrow":return[...monthsNarrow];case"short":return[...monthsShort];case"long":return[...monthsLong];case"numeric":return["1","2","3","4","5","6","7","8","9","10","11","12"];case"2-digit":return["01","02","03","04","05","06","07","08","09","10","11","12"];default:return null;}}
const weekdaysLong=["Monday","Tuesday","Wednesday","Thursday","Friday","Saturday","Sunday",];const weekdaysShort=["Mon","Tue","Wed","Thu","Fri","Sat","Sun"];const weekdaysNarrow=["M","T","W","T","F","S","S"];function weekdays(length){switch(length){case"narrow":return[...weekdaysNarrow];case"short":return[...weekdaysShort];case"long":return[...weekdaysLong];case"numeric":return["1","2","3","4","5","6","7"];default:return null;}}
const meridiems=["AM","PM"];const erasLong=["Before Christ","Anno Domini"];const erasShort=["BC","AD"];const erasNarrow=["B","A"];function eras(length){switch(length){case"narrow":return[...erasNarrow];case"short":return[...erasShort];case"long":return[...erasLong];default:return null;}}
function meridiemForDateTime(dt){return meridiems[dt.hour<12?0:1];}
function weekdayForDateTime(dt,length){return weekdays(length)[dt.weekday-1];}
function monthForDateTime(dt,length){return months(length)[dt.month-1];}
function eraForDateTime(dt,length){return eras(length)[dt.year<0?0:1];}
function formatRelativeTime(unit,count,numeric="always",narrow=false){const units={years:["year","yr."],quarters:["quarter","qtr."],months:["month","mo."],weeks:["week","wk."],days:["day","day","days"],hours:["hour","hr."],minutes:["minute","min."],seconds:["second","sec."],};const lastable=["hours","minutes","seconds"].indexOf(unit)===-1;if(numeric==="auto"&&lastable){const isDay=unit==="days";switch(count){case 1:return isDay?"tomorrow":`next ${units[unit][0]}`;case-1:return isDay?"yesterday":`last ${units[unit][0]}`;case 0:return isDay?"today":`this ${units[unit][0]}`;}}
const isInPast=Object.is(count,-0)||count<0,fmtValue=Math.abs(count),singular=fmtValue===1,lilUnits=units[unit],fmtUnit=narrow?singular?lilUnits[1]:lilUnits[2]||lilUnits[1]:singular?units[unit][0]:unit;return isInPast?`${fmtValue} ${fmtUnit} ago`:`in ${fmtValue} ${fmtUnit}`;}
function stringifyTokens(splits,tokenToString){let s="";for(const token of splits){if(token.literal){s+=token.val;}else{s+=tokenToString(token.val);}}
return s;}
const macroTokenToFormatOpts={D:DATE_SHORT,DD:DATE_MED,DDD:DATE_FULL,DDDD:DATE_HUGE,t:TIME_SIMPLE,tt:TIME_WITH_SECONDS,ttt:TIME_WITH_SHORT_OFFSET,tttt:TIME_WITH_LONG_OFFSET,T:TIME_24_SIMPLE,TT:TIME_24_WITH_SECONDS,TTT:TIME_24_WITH_SHORT_OFFSET,TTTT:TIME_24_WITH_LONG_OFFSET,f:DATETIME_SHORT,ff:DATETIME_MED,fff:DATETIME_FULL,ffff:DATETIME_HUGE,F:DATETIME_SHORT_WITH_SECONDS,FF:DATETIME_MED_WITH_SECONDS,FFF:DATETIME_FULL_WITH_SECONDS,FFFF:DATETIME_HUGE_WITH_SECONDS,};class Formatter{static create(locale,opts={}){return new Formatter(locale,opts);}
static parseFormat(fmt){let current=null,currentFull="",bracketed=false;const splits=[];for(let i=0;i<fmt.length;i++){const c=fmt.charAt(i);if(c==="'"){if(currentFull.length>0){splits.push({literal:bracketed||/^\s+$/.test(currentFull),val:currentFull});}
current=null;currentFull="";bracketed=!bracketed;}else if(bracketed){currentFull+=c;}else if(c===current){currentFull+=c;}else{if(currentFull.length>0){splits.push({literal:/^\s+$/.test(currentFull),val:currentFull});}
currentFull=c;current=c;}}
if(currentFull.length>0){splits.push({literal:bracketed||/^\s+$/.test(currentFull),val:currentFull});}
return splits;}
static macroTokenToFormatOpts(token){return macroTokenToFormatOpts[token];}
constructor(locale,formatOpts){this.opts=formatOpts;this.loc=locale;this.systemLoc=null;}
formatWithSystemDefault(dt,opts){if(this.systemLoc===null){this.systemLoc=this.loc.redefaultToSystem();}
const df=this.systemLoc.dtFormatter(dt,{...this.opts,...opts});return df.format();}
dtFormatter(dt,opts={}){return this.loc.dtFormatter(dt,{...this.opts,...opts});}
formatDateTime(dt,opts){return this.dtFormatter(dt,opts).format();}
formatDateTimeParts(dt,opts){return this.dtFormatter(dt,opts).formatToParts();}
formatInterval(interval,opts){const df=this.dtFormatter(interval.start,opts);return df.dtf.formatRange(interval.start.toJSDate(),interval.end.toJSDate());}
resolvedOptions(dt,opts){return this.dtFormatter(dt,opts).resolvedOptions();}
num(n,p=0){if(this.opts.forceSimple){return padStart(n,p);}
const opts={...this.opts};if(p>0){opts.padTo=p;}
return this.loc.numberFormatter(opts).format(n);}
formatDateTimeFromString(dt,fmt){const knownEnglish=this.loc.listingMode()==="en",useDateTimeFormatter=this.loc.outputCalendar&&this.loc.outputCalendar!=="gregory",string=(opts,extract)=>this.loc.extract(dt,opts,extract),formatOffset=(opts)=>{if(dt.isOffsetFixed&&dt.offset===0&&opts.allowZ){return"Z";}
return dt.isValid?dt.zone.formatOffset(dt.ts,opts.format):"";},meridiem=()=>knownEnglish?meridiemForDateTime(dt):string({hour:"numeric",hourCycle:"h12"},"dayperiod"),month=(length,standalone)=>knownEnglish?monthForDateTime(dt,length):string(standalone?{month:length}:{month:length,day:"numeric"},"month"),weekday=(length,standalone)=>knownEnglish?weekdayForDateTime(dt,length):string(standalone?{weekday:length}:{weekday:length,month:"long",day:"numeric"},"weekday"),maybeMacro=(token)=>{const formatOpts=Formatter.macroTokenToFormatOpts(token);if(formatOpts){return this.formatWithSystemDefault(dt,formatOpts);}else{return token;}},era=(length)=>knownEnglish?eraForDateTime(dt,length):string({era:length},"era"),tokenToString=(token)=>{switch(token){case"S":return this.num(dt.millisecond);case"u":case"SSS":return this.num(dt.millisecond,3);case"s":return this.num(dt.second);case"ss":return this.num(dt.second,2);case"uu":return this.num(Math.floor(dt.millisecond/10),2);case"uuu":return this.num(Math.floor(dt.millisecond/100));case"m":return this.num(dt.minute);case"mm":return this.num(dt.minute,2);case"h":return this.num(dt.hour%12===0?12:dt.hour%12);case"hh":return this.num(dt.hour%12===0?12:dt.hour%12,2);case"H":return this.num(dt.hour);case"HH":return this.num(dt.hour,2);case"Z":return formatOffset({format:"narrow",allowZ:this.opts.allowZ});case"ZZ":return formatOffset({format:"short",allowZ:this.opts.allowZ});case"ZZZ":return formatOffset({format:"techie",allowZ:this.opts.allowZ});case"ZZZZ":return dt.zone.offsetName(dt.ts,{format:"short",locale:this.loc.locale});case"ZZZZZ":return dt.zone.offsetName(dt.ts,{format:"long",locale:this.loc.locale});case"z":return dt.zoneName;case"a":return meridiem();case"d":return useDateTimeFormatter?string({day:"numeric"},"day"):this.num(dt.day);case"dd":return useDateTimeFormatter?string({day:"2-digit"},"day"):this.num(dt.day,2);case"c":return this.num(dt.weekday);case"ccc":return weekday("short",true);case"cccc":return weekday("long",true);case"ccccc":return weekday("narrow",true);case"E":return this.num(dt.weekday);case"EEE":return weekday("short",false);case"EEEE":return weekday("long",false);case"EEEEE":return weekday("narrow",false);case"L":return useDateTimeFormatter?string({month:"numeric",day:"numeric"},"month"):this.num(dt.month);case"LL":return useDateTimeFormatter?string({month:"2-digit",day:"numeric"},"month"):this.num(dt.month,2);case"LLL":return month("short",true);case"LLLL":return month("long",true);case"LLLLL":return month("narrow",true);case"M":return useDateTimeFormatter?string({month:"numeric"},"month"):this.num(dt.month);case"MM":return useDateTimeFormatter?string({month:"2-digit"},"month"):this.num(dt.month,2);case"MMM":return month("short",false);case"MMMM":return month("long",false);case"MMMMM":return month("narrow",false);case"y":return useDateTimeFormatter?string({year:"numeric"},"year"):this.num(dt.year);case"yy":return useDateTimeFormatter?string({year:"2-digit"},"year"):this.num(dt.year.toString().slice(-2),2);case"yyyy":return useDateTimeFormatter?string({year:"numeric"},"year"):this.num(dt.year,4);case"yyyyyy":return useDateTimeFormatter?string({year:"numeric"},"year"):this.num(dt.year,6);case"G":return era("short");case"GG":return era("long");case"GGGGG":return era("narrow");case"kk":return this.num(dt.weekYear.toString().slice(-2),2);case"kkkk":return this.num(dt.weekYear,4);case"W":return this.num(dt.weekNumber);case"WW":return this.num(dt.weekNumber,2);case"n":return this.num(dt.localWeekNumber);case"nn":return this.num(dt.localWeekNumber,2);case"ii":return this.num(dt.localWeekYear.toString().slice(-2),2);case"iiii":return this.num(dt.localWeekYear,4);case"o":return this.num(dt.ordinal);case"ooo":return this.num(dt.ordinal,3);case"q":return this.num(dt.quarter);case"qq":return this.num(dt.quarter,2);case"X":return this.num(Math.floor(dt.ts/1000));case"x":return this.num(dt.ts);default:return maybeMacro(token);}};return stringifyTokens(Formatter.parseFormat(fmt),tokenToString);}
formatDurationFromString(dur,fmt){const tokenToField=(token)=>{switch(token[0]){case"S":return"millisecond";case"s":return"second";case"m":return"minute";case"h":return"hour";case"d":return"day";case"w":return"week";case"M":return"month";case"y":return"year";default:return null;}},tokenToString=(lildur)=>(token)=>{const mapped=tokenToField(token);if(mapped){return this.num(lildur.get(mapped),token.length);}else{return token;}},tokens=Formatter.parseFormat(fmt),realTokens=tokens.reduce((found,{literal,val})=>(literal?found:found.concat(val)),[]),collapsed=dur.shiftTo(...realTokens.map(tokenToField).filter((t)=>t));return stringifyTokens(tokens,tokenToString(collapsed));}}
const ianaRegex=/[A-Za-z_+-]{1,256}(?::?\/[A-Za-z0-9_+-]{1,256}(?:\/[A-Za-z0-9_+-]{1,256})?)?/;function combineRegexes(...regexes){const full=regexes.reduce((f,r)=>f+r.source,"");return RegExp(`^${full}$`);}
function combineExtractors(...extractors){return(m)=>extractors.reduce(([mergedVals,mergedZone,cursor],ex)=>{const[val,zone,next]=ex(m,cursor);return[{...mergedVals,...val},zone||mergedZone,next];},[{},null,1]).slice(0,2);}
function parse(s,...patterns){if(s==null){return[null,null];}
for(const[regex,extractor]of patterns){const m=regex.exec(s);if(m){return extractor(m);}}
return[null,null];}
function simpleParse(...keys){return(match,cursor)=>{const ret={};let i;for(i=0;i<keys.length;i++){ret[keys[i]]=parseInteger(match[cursor+i]);}
return[ret,null,cursor+i];};}
const offsetRegex=/(?:(Z)|([+-]\d\d)(?::?(\d\d))?)/;const isoExtendedZone=`(?:${offsetRegex.source}?(?:\\[(${ianaRegex.source})\\])?)?`;const isoTimeBaseRegex=/(\d\d)(?::?(\d\d)(?::?(\d\d)(?:[.,](\d{1,30}))?)?)?/;const isoTimeRegex=RegExp(`${isoTimeBaseRegex.source}${isoExtendedZone}`);const isoTimeExtensionRegex=RegExp(`(?:T${isoTimeRegex.source})?`);const isoYmdRegex=/([+-]\d{6}|\d{4})(?:-?(\d\d)(?:-?(\d\d))?)?/;const isoWeekRegex=/(\d{4})-?W(\d\d)(?:-?(\d))?/;const isoOrdinalRegex=/(\d{4})-?(\d{3})/;const extractISOWeekData=simpleParse("weekYear","weekNumber","weekDay");const extractISOOrdinalData=simpleParse("year","ordinal");const sqlYmdRegex=/(\d{4})-(\d\d)-(\d\d)/;const sqlTimeRegex=RegExp(`${isoTimeBaseRegex.source} ?(?:${offsetRegex.source}|(${ianaRegex.source}))?`);const sqlTimeExtensionRegex=RegExp(`(?: ${sqlTimeRegex.source})?`);function int(match,pos,fallback){const m=match[pos];return isUndefined(m)?fallback:parseInteger(m);}
function extractISOYmd(match,cursor){const item={year:int(match,cursor),month:int(match,cursor+1,1),day:int(match,cursor+2,1),};return[item,null,cursor+3];}
function extractISOTime(match,cursor){const item={hours:int(match,cursor,0),minutes:int(match,cursor+1,0),seconds:int(match,cursor+2,0),milliseconds:parseMillis(match[cursor+3]),};return[item,null,cursor+4];}
function extractISOOffset(match,cursor){const local=!match[cursor]&&!match[cursor+1],fullOffset=signedOffset(match[cursor+1],match[cursor+2]),zone=local?null:FixedOffsetZone.instance(fullOffset);return[{},zone,cursor+3];}
function extractIANAZone(match,cursor){const zone=match[cursor]?IANAZone.create(match[cursor]):null;return[{},zone,cursor+1];}
const isoTimeOnly=RegExp(`^T?${isoTimeBaseRegex.source}$`);const isoDuration=/^-?P(?:(?:(-?\d{1,20}(?:\.\d{1,20})?)Y)?(?:(-?\d{1,20}(?:\.\d{1,20})?)M)?(?:(-?\d{1,20}(?:\.\d{1,20})?)W)?(?:(-?\d{1,20}(?:\.\d{1,20})?)D)?(?:T(?:(-?\d{1,20}(?:\.\d{1,20})?)H)?(?:(-?\d{1,20}(?:\.\d{1,20})?)M)?(?:(-?\d{1,20})(?:[.,](-?\d{1,20}))?S)?)?)$/;function extractISODuration(match){const[s,yearStr,monthStr,weekStr,dayStr,hourStr,minuteStr,secondStr,millisecondsStr]=match;const hasNegativePrefix=s[0]==="-";const negativeSeconds=secondStr&&secondStr[0]==="-";const maybeNegate=(num,force=false)=>num!==undefined&&(force||(num&&hasNegativePrefix))?-num:num;return[{years:maybeNegate(parseFloating(yearStr)),months:maybeNegate(parseFloating(monthStr)),weeks:maybeNegate(parseFloating(weekStr)),days:maybeNegate(parseFloating(dayStr)),hours:maybeNegate(parseFloating(hourStr)),minutes:maybeNegate(parseFloating(minuteStr)),seconds:maybeNegate(parseFloating(secondStr),secondStr==="-0"),milliseconds:maybeNegate(parseMillis(millisecondsStr),negativeSeconds),},];}
const obsOffsets={GMT:0,EDT:-4*60,EST:-5*60,CDT:-5*60,CST:-6*60,MDT:-6*60,MST:-7*60,PDT:-7*60,PST:-8*60,};function fromStrings(weekdayStr,yearStr,monthStr,dayStr,hourStr,minuteStr,secondStr){const result={year:yearStr.length===2?untruncateYear(parseInteger(yearStr)):parseInteger(yearStr),month:monthsShort.indexOf(monthStr)+1,day:parseInteger(dayStr),hour:parseInteger(hourStr),minute:parseInteger(minuteStr),};if(secondStr)result.second=parseInteger(secondStr);if(weekdayStr){result.weekday=weekdayStr.length>3?weekdaysLong.indexOf(weekdayStr)+1:weekdaysShort.indexOf(weekdayStr)+1;}
return result;}
const rfc2822=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|(?:([+-]\d\d)(\d\d)))$/;function extractRFC2822(match){const[,weekdayStr,dayStr,monthStr,yearStr,hourStr,minuteStr,secondStr,obsOffset,milOffset,offHourStr,offMinuteStr,]=match,result=fromStrings(weekdayStr,yearStr,monthStr,dayStr,hourStr,minuteStr,secondStr);let offset;if(obsOffset){offset=obsOffsets[obsOffset];}else if(milOffset){offset=0;}else{offset=signedOffset(offHourStr,offMinuteStr);}
return[result,new FixedOffsetZone(offset)];}
function preprocessRFC2822(s){return s.replace(/\([^()]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").trim();}
const rfc1123=/^(Mon|Tue|Wed|Thu|Fri|Sat|Sun), (\d\d) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) (\d{4}) (\d\d):(\d\d):(\d\d) GMT$/,rfc850=/^(Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday), (\d\d)-(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)-(\d\d) (\d\d):(\d\d):(\d\d) GMT$/,ascii=/^(Mon|Tue|Wed|Thu|Fri|Sat|Sun) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) ( \d|\d\d) (\d\d):(\d\d):(\d\d) (\d{4})$/;function extractRFC1123Or850(match){const[,weekdayStr,dayStr,monthStr,yearStr,hourStr,minuteStr,secondStr]=match,result=fromStrings(weekdayStr,yearStr,monthStr,dayStr,hourStr,minuteStr,secondStr);return[result,FixedOffsetZone.utcInstance];}
function extractASCII(match){const[,weekdayStr,monthStr,dayStr,hourStr,minuteStr,secondStr,yearStr]=match,result=fromStrings(weekdayStr,yearStr,monthStr,dayStr,hourStr,minuteStr,secondStr);return[result,FixedOffsetZone.utcInstance];}
const isoYmdWithTimeExtensionRegex=combineRegexes(isoYmdRegex,isoTimeExtensionRegex);const isoWeekWithTimeExtensionRegex=combineRegexes(isoWeekRegex,isoTimeExtensionRegex);const isoOrdinalWithTimeExtensionRegex=combineRegexes(isoOrdinalRegex,isoTimeExtensionRegex);const isoTimeCombinedRegex=combineRegexes(isoTimeRegex);const extractISOYmdTimeAndOffset=combineExtractors(extractISOYmd,extractISOTime,extractISOOffset,extractIANAZone);const extractISOWeekTimeAndOffset=combineExtractors(extractISOWeekData,extractISOTime,extractISOOffset,extractIANAZone);const extractISOOrdinalDateAndTime=combineExtractors(extractISOOrdinalData,extractISOTime,extractISOOffset,extractIANAZone);const extractISOTimeAndOffset=combineExtractors(extractISOTime,extractISOOffset,extractIANAZone);function parseISODate(s){return parse(s,[isoYmdWithTimeExtensionRegex,extractISOYmdTimeAndOffset],[isoWeekWithTimeExtensionRegex,extractISOWeekTimeAndOffset],[isoOrdinalWithTimeExtensionRegex,extractISOOrdinalDateAndTime],[isoTimeCombinedRegex,extractISOTimeAndOffset]);}
function parseRFC2822Date(s){return parse(preprocessRFC2822(s),[rfc2822,extractRFC2822]);}
function parseHTTPDate(s){return parse(s,[rfc1123,extractRFC1123Or850],[rfc850,extractRFC1123Or850],[ascii,extractASCII]);}
function parseISODuration(s){return parse(s,[isoDuration,extractISODuration]);}
const extractISOTimeOnly=combineExtractors(extractISOTime);function parseISOTimeOnly(s){return parse(s,[isoTimeOnly,extractISOTimeOnly]);}
const sqlYmdWithTimeExtensionRegex=combineRegexes(sqlYmdRegex,sqlTimeExtensionRegex);const sqlTimeCombinedRegex=combineRegexes(sqlTimeRegex);const extractISOTimeOffsetAndIANAZone=combineExtractors(extractISOTime,extractISOOffset,extractIANAZone);function parseSQL(s){return parse(s,[sqlYmdWithTimeExtensionRegex,extractISOYmdTimeAndOffset],[sqlTimeCombinedRegex,extractISOTimeOffsetAndIANAZone]);}
const INVALID$2="Invalid Duration";const lowOrderMatrix={weeks:{days:7,hours:7*24,minutes:7*24*60,seconds:7*24*60*60,milliseconds:7*24*60*60*1000,},days:{hours:24,minutes:24*60,seconds:24*60*60,milliseconds:24*60*60*1000,},hours:{minutes:60,seconds:60*60,milliseconds:60*60*1000},minutes:{seconds:60,milliseconds:60*1000},seconds:{milliseconds:1000},},casualMatrix={years:{quarters:4,months:12,weeks:52,days:365,hours:365*24,minutes:365*24*60,seconds:365*24*60*60,milliseconds:365*24*60*60*1000,},quarters:{months:3,weeks:13,days:91,hours:91*24,minutes:91*24*60,seconds:91*24*60*60,milliseconds:91*24*60*60*1000,},months:{weeks:4,days:30,hours:30*24,minutes:30*24*60,seconds:30*24*60*60,milliseconds:30*24*60*60*1000,},...lowOrderMatrix,},daysInYearAccurate=146097.0/400,daysInMonthAccurate=146097.0/4800,accurateMatrix={years:{quarters:4,months:12,weeks:daysInYearAccurate/7,days:daysInYearAccurate,hours:daysInYearAccurate*24,minutes:daysInYearAccurate*24*60,seconds:daysInYearAccurate*24*60*60,milliseconds:daysInYearAccurate*24*60*60*1000,},quarters:{months:3,weeks:daysInYearAccurate/28,days:daysInYearAccurate/4,hours:(daysInYearAccurate*24)/4,minutes:(daysInYearAccurate*24*60)/4,seconds:(daysInYearAccurate*24*60*60)/4,milliseconds:(daysInYearAccurate*24*60*60*1000)/4,},months:{weeks:daysInMonthAccurate/7,days:daysInMonthAccurate,hours:daysInMonthAccurate*24,minutes:daysInMonthAccurate*24*60,seconds:daysInMonthAccurate*24*60*60,milliseconds:daysInMonthAccurate*24*60*60*1000,},...lowOrderMatrix,};const orderedUnits$1=["years","quarters","months","weeks","days","hours","minutes","seconds","milliseconds",];const reverseUnits=orderedUnits$1.slice(0).reverse();function clone$1(dur,alts,clear=false){const conf={values:clear?alts.values:{...dur.values,...(alts.values||{})},loc:dur.loc.clone(alts.loc),conversionAccuracy:alts.conversionAccuracy||dur.conversionAccuracy,matrix:alts.matrix||dur.matrix,};return new Duration(conf);}
function durationToMillis(matrix,vals){let sum=vals.milliseconds??0;for(const unit of reverseUnits.slice(1)){if(vals[unit]){sum+=vals[unit]*matrix[unit]["milliseconds"];}}
return sum;}
function normalizeValues(matrix,vals){const factor=durationToMillis(matrix,vals)<0?-1:1;orderedUnits$1.reduceRight((previous,current)=>{if(!isUndefined(vals[current])){if(previous){const previousVal=vals[previous]*factor;const conv=matrix[current][previous];const rollUp=Math.floor(previousVal/conv);vals[current]+=rollUp*factor;vals[previous]-=rollUp*conv*factor;}
return current;}else{return previous;}},null);orderedUnits$1.reduce((previous,current)=>{if(!isUndefined(vals[current])){if(previous){const fraction=vals[previous]%1;vals[previous]-=fraction;vals[current]+=fraction*matrix[previous][current];}
return current;}else{return previous;}},null);}
function removeZeroes(vals){const newVals={};for(const[key,value]of Object.entries(vals)){if(value!==0){newVals[key]=value;}}
return newVals;}
class Duration{constructor(config){const accurate=config.conversionAccuracy==="longterm"||false;let matrix=accurate?accurateMatrix:casualMatrix;if(config.matrix){matrix=config.matrix;}
this.values=config.values;this.loc=config.loc||Locale.create();this.conversionAccuracy=accurate?"longterm":"casual";this.invalid=config.invalid||null;this.matrix=matrix;this.isLuxonDuration=true;}
static fromMillis(count,opts){return Duration.fromObject({milliseconds:count},opts);}
static fromObject(obj,opts={}){if(obj==null||typeof obj!=="object"){throw new InvalidArgumentError(`Duration.fromObject: argument expected to be an object, got ${
          obj === null ? "null" : typeof obj
        }`);}
return new Duration({values:normalizeObject(obj,Duration.normalizeUnit),loc:Locale.fromObject(opts),conversionAccuracy:opts.conversionAccuracy,matrix:opts.matrix,});}
static fromDurationLike(durationLike){if(isNumber(durationLike)){return Duration.fromMillis(durationLike);}else if(Duration.isDuration(durationLike)){return durationLike;}else if(typeof durationLike==="object"){return Duration.fromObject(durationLike);}else{throw new InvalidArgumentError(`Unknown duration argument ${durationLike} of type ${typeof durationLike}`);}}
static fromISO(text,opts){const[parsed]=parseISODuration(text);if(parsed){return Duration.fromObject(parsed,opts);}else{return Duration.invalid("unparsable",`the input "${text}" can't be parsed as ISO 8601`);}}
static fromISOTime(text,opts){const[parsed]=parseISOTimeOnly(text);if(parsed){return Duration.fromObject(parsed,opts);}else{return Duration.invalid("unparsable",`the input "${text}" can't be parsed as ISO 8601`);}}
static invalid(reason,explanation=null){if(!reason){throw new InvalidArgumentError("need to specify a reason the Duration is invalid");}
const invalid=reason instanceof Invalid?reason:new Invalid(reason,explanation);if(Settings.throwOnInvalid){throw new InvalidDurationError(invalid);}else{return new Duration({invalid});}}
static normalizeUnit(unit){const normalized={year:"years",years:"years",quarter:"quarters",quarters:"quarters",month:"months",months:"months",week:"weeks",weeks:"weeks",day:"days",days:"days",hour:"hours",hours:"hours",minute:"minutes",minutes:"minutes",second:"seconds",seconds:"seconds",millisecond:"milliseconds",milliseconds:"milliseconds",}[unit?unit.toLowerCase():unit];if(!normalized)throw new InvalidUnitError(unit);return normalized;}
static isDuration(o){return(o&&o.isLuxonDuration)||false;}
get locale(){return this.isValid?this.loc.locale:null;}
get numberingSystem(){return this.isValid?this.loc.numberingSystem:null;}
toFormat(fmt,opts={}){const fmtOpts={...opts,floor:opts.round!==false&&opts.floor!==false,};return this.isValid?Formatter.create(this.loc,fmtOpts).formatDurationFromString(this,fmt):INVALID$2;}
toHuman(opts={}){if(!this.isValid)return INVALID$2;const l=orderedUnits$1.map((unit)=>{const val=this.values[unit];if(isUndefined(val)){return null;}
return this.loc.numberFormatter({style:"unit",unitDisplay:"long",...opts,unit:unit.slice(0,-1)}).format(val);}).filter((n)=>n);return this.loc.listFormatter({type:"conjunction",style:opts.listStyle||"narrow",...opts}).format(l);}
toObject(){if(!this.isValid)return{};return{...this.values};}
toISO(){if(!this.isValid)return null;let s="P";if(this.years!==0)s+=this.years+"Y";if(this.months!==0||this.quarters!==0)s+=this.months+this.quarters*3+"M";if(this.weeks!==0)s+=this.weeks+"W";if(this.days!==0)s+=this.days+"D";if(this.hours!==0||this.minutes!==0||this.seconds!==0||this.milliseconds!==0)
s+="T";if(this.hours!==0)s+=this.hours+"H";if(this.minutes!==0)s+=this.minutes+"M";if(this.seconds!==0||this.milliseconds!==0)
s+=roundTo(this.seconds+this.milliseconds/1000,3)+"S";if(s==="P")s+="T0S";return s;}
toISOTime(opts={}){if(!this.isValid)return null;const millis=this.toMillis();if(millis<0||millis>=86400000)return null;opts={suppressMilliseconds:false,suppressSeconds:false,includePrefix:false,format:"extended",...opts,includeOffset:false,};const dateTime=DateTime.fromMillis(millis,{zone:"UTC"});return dateTime.toISOTime(opts);}
toJSON(){return this.toISO();}
toString(){return this.toISO();}
[Symbol.for("nodejs.util.inspect.custom")](){if(this.isValid){return`Duration { values: ${JSON.stringify(this.values)} }`;}else{return`Duration { Invalid, reason: ${this.invalidReason} }`;}}
toMillis(){if(!this.isValid)return NaN;return durationToMillis(this.matrix,this.values);}
valueOf(){return this.toMillis();}
plus(duration){if(!this.isValid)return this;const dur=Duration.fromDurationLike(duration),result={};for(const k of orderedUnits$1){if(hasOwnProperty(dur.values,k)||hasOwnProperty(this.values,k)){result[k]=dur.get(k)+this.get(k);}}
return clone$1(this,{values:result},true);}
minus(duration){if(!this.isValid)return this;const dur=Duration.fromDurationLike(duration);return this.plus(dur.negate());}
mapUnits(fn){if(!this.isValid)return this;const result={};for(const k of Object.keys(this.values)){result[k]=asNumber(fn(this.values[k],k));}
return clone$1(this,{values:result},true);}
get(unit){return this[Duration.normalizeUnit(unit)];}
set(values){if(!this.isValid)return this;const mixed={...this.values,...normalizeObject(values,Duration.normalizeUnit)};return clone$1(this,{values:mixed});}
reconfigure({locale,numberingSystem,conversionAccuracy,matrix}={}){const loc=this.loc.clone({locale,numberingSystem});const opts={loc,matrix,conversionAccuracy};return clone$1(this,opts);}
as(unit){return this.isValid?this.shiftTo(unit).get(unit):NaN;}
normalize(){if(!this.isValid)return this;const vals=this.toObject();normalizeValues(this.matrix,vals);return clone$1(this,{values:vals},true);}
rescale(){if(!this.isValid)return this;const vals=removeZeroes(this.normalize().shiftToAll().toObject());return clone$1(this,{values:vals},true);}
shiftTo(...units){if(!this.isValid)return this;if(units.length===0){return this;}
units=units.map((u)=>Duration.normalizeUnit(u));const built={},accumulated={},vals=this.toObject();let lastUnit;for(const k of orderedUnits$1){if(units.indexOf(k)>=0){lastUnit=k;let own=0;for(const ak in accumulated){own+=this.matrix[ak][k]*accumulated[ak];accumulated[ak]=0;}
if(isNumber(vals[k])){own+=vals[k];}
const i=Math.trunc(own);built[k]=i;accumulated[k]=(own*1000-i*1000)/1000;}else if(isNumber(vals[k])){accumulated[k]=vals[k];}}
for(const key in accumulated){if(accumulated[key]!==0){built[lastUnit]+=key===lastUnit?accumulated[key]:accumulated[key]/this.matrix[lastUnit][key];}}
normalizeValues(this.matrix,built);return clone$1(this,{values:built},true);}
shiftToAll(){if(!this.isValid)return this;return this.shiftTo("years","months","weeks","days","hours","minutes","seconds","milliseconds");}
negate(){if(!this.isValid)return this;const negated={};for(const k of Object.keys(this.values)){negated[k]=this.values[k]===0?0:-this.values[k];}
return clone$1(this,{values:negated},true);}
get years(){return this.isValid?this.values.years||0:NaN;}
get quarters(){return this.isValid?this.values.quarters||0:NaN;}
get months(){return this.isValid?this.values.months||0:NaN;}
get weeks(){return this.isValid?this.values.weeks||0:NaN;}
get days(){return this.isValid?this.values.days||0:NaN;}
get hours(){return this.isValid?this.values.hours||0:NaN;}
get minutes(){return this.isValid?this.values.minutes||0:NaN;}
get seconds(){return this.isValid?this.values.seconds||0:NaN;}
get milliseconds(){return this.isValid?this.values.milliseconds||0:NaN;}
get isValid(){return this.invalid===null;}
get invalidReason(){return this.invalid?this.invalid.reason:null;}
get invalidExplanation(){return this.invalid?this.invalid.explanation:null;}
equals(other){if(!this.isValid||!other.isValid){return false;}
if(!this.loc.equals(other.loc)){return false;}
function eq(v1,v2){if(v1===undefined||v1===0)return v2===undefined||v2===0;return v1===v2;}
for(const u of orderedUnits$1){if(!eq(this.values[u],other.values[u])){return false;}}
return true;}}
const INVALID$1="Invalid Interval";function validateStartEnd(start,end){if(!start||!start.isValid){return Interval.invalid("missing or invalid start");}else if(!end||!end.isValid){return Interval.invalid("missing or invalid end");}else if(end<start){return Interval.invalid("end before start",`The end of an interval must be after its start, but you had start=${start.toISO()} and end=${end.toISO()}`);}else{return null;}}
class Interval{constructor(config){this.s=config.start;this.e=config.end;this.invalid=config.invalid||null;this.isLuxonInterval=true;}
static invalid(reason,explanation=null){if(!reason){throw new InvalidArgumentError("need to specify a reason the Interval is invalid");}
const invalid=reason instanceof Invalid?reason:new Invalid(reason,explanation);if(Settings.throwOnInvalid){throw new InvalidIntervalError(invalid);}else{return new Interval({invalid});}}
static fromDateTimes(start,end){const builtStart=friendlyDateTime(start),builtEnd=friendlyDateTime(end);const validateError=validateStartEnd(builtStart,builtEnd);if(validateError==null){return new Interval({start:builtStart,end:builtEnd,});}else{return validateError;}}
static after(start,duration){const dur=Duration.fromDurationLike(duration),dt=friendlyDateTime(start);return Interval.fromDateTimes(dt,dt.plus(dur));}
static before(end,duration){const dur=Duration.fromDurationLike(duration),dt=friendlyDateTime(end);return Interval.fromDateTimes(dt.minus(dur),dt);}
static fromISO(text,opts){const[s,e]=(text||"").split("/",2);if(s&&e){let start,startIsValid;try{start=DateTime.fromISO(s,opts);startIsValid=start.isValid;}catch(e){startIsValid=false;}
let end,endIsValid;try{end=DateTime.fromISO(e,opts);endIsValid=end.isValid;}catch(e){endIsValid=false;}
if(startIsValid&&endIsValid){return Interval.fromDateTimes(start,end);}
if(startIsValid){const dur=Duration.fromISO(e,opts);if(dur.isValid){return Interval.after(start,dur);}}else if(endIsValid){const dur=Duration.fromISO(s,opts);if(dur.isValid){return Interval.before(end,dur);}}}
return Interval.invalid("unparsable",`the input "${text}" can't be parsed as ISO 8601`);}
static isInterval(o){return(o&&o.isLuxonInterval)||false;}
get start(){return this.isValid?this.s:null;}
get end(){return this.isValid?this.e:null;}
get isValid(){return this.invalidReason===null;}
get invalidReason(){return this.invalid?this.invalid.reason:null;}
get invalidExplanation(){return this.invalid?this.invalid.explanation:null;}
length(unit="milliseconds"){return this.isValid?this.toDuration(...[unit]).get(unit):NaN;}
count(unit="milliseconds",opts){if(!this.isValid)return NaN;const start=this.start.startOf(unit,opts);let end;if(opts?.useLocaleWeeks){end=this.end.reconfigure({locale:start.locale});}else{end=this.end;}
end=end.startOf(unit,opts);return Math.floor(end.diff(start,unit).get(unit))+(end.valueOf()!==this.end.valueOf());}
hasSame(unit){return this.isValid?this.isEmpty()||this.e.minus(1).hasSame(this.s,unit):false;}
isEmpty(){return this.s.valueOf()===this.e.valueOf();}
isAfter(dateTime){if(!this.isValid)return false;return this.s>dateTime;}
isBefore(dateTime){if(!this.isValid)return false;return this.e<=dateTime;}
contains(dateTime){if(!this.isValid)return false;return this.s<=dateTime&&this.e>dateTime;}
set({start,end}={}){if(!this.isValid)return this;return Interval.fromDateTimes(start||this.s,end||this.e);}
splitAt(...dateTimes){if(!this.isValid)return[];const sorted=dateTimes.map(friendlyDateTime).filter((d)=>this.contains(d)).sort((a,b)=>a.toMillis()-b.toMillis()),results=[];let{s}=this,i=0;while(s<this.e){const added=sorted[i]||this.e,next=+added>+this.e?this.e:added;results.push(Interval.fromDateTimes(s,next));s=next;i+=1;}
return results;}
splitBy(duration){const dur=Duration.fromDurationLike(duration);if(!this.isValid||!dur.isValid||dur.as("milliseconds")===0){return[];}
let{s}=this,idx=1,next;const results=[];while(s<this.e){const added=this.start.plus(dur.mapUnits((x)=>x*idx));next=+added>+this.e?this.e:added;results.push(Interval.fromDateTimes(s,next));s=next;idx+=1;}
return results;}
divideEqually(numberOfParts){if(!this.isValid)return[];return this.splitBy(this.length()/numberOfParts).slice(0,numberOfParts);}
overlaps(other){return this.e>other.s&&this.s<other.e;}
abutsStart(other){if(!this.isValid)return false;return+this.e===+other.s;}
abutsEnd(other){if(!this.isValid)return false;return+other.e===+this.s;}
engulfs(other){if(!this.isValid)return false;return this.s<=other.s&&this.e>=other.e;}
equals(other){if(!this.isValid||!other.isValid){return false;}
return this.s.equals(other.s)&&this.e.equals(other.e);}
intersection(other){if(!this.isValid)return this;const s=this.s>other.s?this.s:other.s,e=this.e<other.e?this.e:other.e;if(s>=e){return null;}else{return Interval.fromDateTimes(s,e);}}
union(other){if(!this.isValid)return this;const s=this.s<other.s?this.s:other.s,e=this.e>other.e?this.e:other.e;return Interval.fromDateTimes(s,e);}
static merge(intervals){const[found,final]=intervals.sort((a,b)=>a.s-b.s).reduce(([sofar,current],item)=>{if(!current){return[sofar,item];}else if(current.overlaps(item)||current.abutsStart(item)){return[sofar,current.union(item)];}else{return[sofar.concat([current]),item];}},[[],null]);if(final){found.push(final);}
return found;}
static xor(intervals){let start=null,currentCount=0;const results=[],ends=intervals.map((i)=>[{time:i.s,type:"s"},{time:i.e,type:"e"},]),flattened=Array.prototype.concat(...ends),arr=flattened.sort((a,b)=>a.time-b.time);for(const i of arr){currentCount+=i.type==="s"?1:-1;if(currentCount===1){start=i.time;}else{if(start&&+start!==+i.time){results.push(Interval.fromDateTimes(start,i.time));}
start=null;}}
return Interval.merge(results);}
difference(...intervals){return Interval.xor([this].concat(intervals)).map((i)=>this.intersection(i)).filter((i)=>i&&!i.isEmpty());}
toString(){if(!this.isValid)return INVALID$1;return`[${this.s.toISO()} – ${this.e.toISO()})`;}
[Symbol.for("nodejs.util.inspect.custom")](){if(this.isValid){return`Interval { start: ${this.s.toISO()}, end: ${this.e.toISO()} }`;}else{return`Interval { Invalid, reason: ${this.invalidReason} }`;}}
toLocaleString(formatOpts=DATE_SHORT,opts={}){return this.isValid?Formatter.create(this.s.loc.clone(opts),formatOpts).formatInterval(this):INVALID$1;}
toISO(opts){if(!this.isValid)return INVALID$1;return`${this.s.toISO(opts)}/${this.e.toISO(opts)}`;}
toISODate(){if(!this.isValid)return INVALID$1;return`${this.s.toISODate()}/${this.e.toISODate()}`;}
toISOTime(opts){if(!this.isValid)return INVALID$1;return`${this.s.toISOTime(opts)}/${this.e.toISOTime(opts)}`;}
toFormat(dateFormat,{separator=" – "}={}){if(!this.isValid)return INVALID$1;return`${this.s.toFormat(dateFormat)}${separator}${this.e.toFormat(dateFormat)}`;}
toDuration(unit,opts){if(!this.isValid){return Duration.invalid(this.invalidReason);}
return this.e.diff(this.s,unit,opts);}
mapEndpoints(mapFn){return Interval.fromDateTimes(mapFn(this.s),mapFn(this.e));}}
class Info{static hasDST(zone=Settings.defaultZone){const proto=DateTime.now().setZone(zone).set({month:12});return!zone.isUniversal&&proto.offset!==proto.set({month:6}).offset;}
static isValidIANAZone(zone){return IANAZone.isValidZone(zone);}
static normalizeZone(input){return normalizeZone(input,Settings.defaultZone);}
static getStartOfWeek({locale=null,locObj=null}={}){return(locObj||Locale.create(locale)).getStartOfWeek();}
static getMinimumDaysInFirstWeek({locale=null,locObj=null}={}){return(locObj||Locale.create(locale)).getMinDaysInFirstWeek();}
static getWeekendWeekdays({locale=null,locObj=null}={}){return(locObj||Locale.create(locale)).getWeekendDays().slice();}
static months(length="long",{locale=null,numberingSystem=null,locObj=null,outputCalendar="gregory"}={}){return(locObj||Locale.create(locale,numberingSystem,outputCalendar)).months(length);}
static monthsFormat(length="long",{locale=null,numberingSystem=null,locObj=null,outputCalendar="gregory"}={}){return(locObj||Locale.create(locale,numberingSystem,outputCalendar)).months(length,true);}
static weekdays(length="long",{locale=null,numberingSystem=null,locObj=null}={}){return(locObj||Locale.create(locale,numberingSystem,null)).weekdays(length);}
static weekdaysFormat(length="long",{locale=null,numberingSystem=null,locObj=null}={}){return(locObj||Locale.create(locale,numberingSystem,null)).weekdays(length,true);}
static meridiems({locale=null}={}){return Locale.create(locale).meridiems();}
static eras(length="short",{locale=null}={}){return Locale.create(locale,null,"gregory").eras(length);}
static features(){return{relative:hasRelative(),localeWeek:hasLocaleWeekInfo()};}}
function dayDiff(earlier,later){const utcDayStart=(dt)=>dt.toUTC(0,{keepLocalTime:true}).startOf("day").valueOf(),ms=utcDayStart(later)-utcDayStart(earlier);return Math.floor(Duration.fromMillis(ms).as("days"));}
function highOrderDiffs(cursor,later,units){const differs=[["years",(a,b)=>b.year-a.year],["quarters",(a,b)=>b.quarter-a.quarter+(b.year-a.year)*4],["months",(a,b)=>b.month-a.month+(b.year-a.year)*12],["weeks",(a,b)=>{const days=dayDiff(a,b);return(days-(days%7))/7;},],["days",dayDiff],];const results={};const earlier=cursor;let lowestOrder,highWater;for(const[unit,differ]of differs){if(units.indexOf(unit)>=0){lowestOrder=unit;results[unit]=differ(cursor,later);highWater=earlier.plus(results);if(highWater>later){results[unit]--;cursor=earlier.plus(results);if(cursor>later){highWater=cursor;results[unit]--;cursor=earlier.plus(results);}}else{cursor=highWater;}}}
return[cursor,results,highWater,lowestOrder];}
function diff(earlier,later,units,opts){let[cursor,results,highWater,lowestOrder]=highOrderDiffs(earlier,later,units);const remainingMillis=later-cursor;const lowerOrderUnits=units.filter((u)=>["hours","minutes","seconds","milliseconds"].indexOf(u)>=0);if(lowerOrderUnits.length===0){if(highWater<later){highWater=cursor.plus({[lowestOrder]:1});}
if(highWater!==cursor){results[lowestOrder]=(results[lowestOrder]||0)+remainingMillis/(highWater-cursor);}}
const duration=Duration.fromObject(results,opts);if(lowerOrderUnits.length>0){return Duration.fromMillis(remainingMillis,opts).shiftTo(...lowerOrderUnits).plus(duration);}else{return duration;}}
const numberingSystems={arab:"[\u0660-\u0669]",arabext:"[\u06F0-\u06F9]",bali:"[\u1B50-\u1B59]",beng:"[\u09E6-\u09EF]",deva:"[\u0966-\u096F]",fullwide:"[\uFF10-\uFF19]",gujr:"[\u0AE6-\u0AEF]",hanidec:"[〇|一|二|三|四|五|六|七|八|九]",khmr:"[\u17E0-\u17E9]",knda:"[\u0CE6-\u0CEF]",laoo:"[\u0ED0-\u0ED9]",limb:"[\u1946-\u194F]",mlym:"[\u0D66-\u0D6F]",mong:"[\u1810-\u1819]",mymr:"[\u1040-\u1049]",orya:"[\u0B66-\u0B6F]",tamldec:"[\u0BE6-\u0BEF]",telu:"[\u0C66-\u0C6F]",thai:"[\u0E50-\u0E59]",tibt:"[\u0F20-\u0F29]",latn:"\\d",};const numberingSystemsUTF16={arab:[1632,1641],arabext:[1776,1785],bali:[6992,7001],beng:[2534,2543],deva:[2406,2415],fullwide:[65296,65303],gujr:[2790,2799],khmr:[6112,6121],knda:[3302,3311],laoo:[3792,3801],limb:[6470,6479],mlym:[3430,3439],mong:[6160,6169],mymr:[4160,4169],orya:[2918,2927],tamldec:[3046,3055],telu:[3174,3183],thai:[3664,3673],tibt:[3872,3881],};const hanidecChars=numberingSystems.hanidec.replace(/[\[|\]]/g,"").split("");function parseDigits(str){let value=parseInt(str,10);if(isNaN(value)){value="";for(let i=0;i<str.length;i++){const code=str.charCodeAt(i);if(str[i].search(numberingSystems.hanidec)!==-1){value+=hanidecChars.indexOf(str[i]);}else{for(const key in numberingSystemsUTF16){const[min,max]=numberingSystemsUTF16[key];if(code>=min&&code<=max){value+=code-min;}}}}
return parseInt(value,10);}else{return value;}}
function digitRegex({numberingSystem},append=""){return new RegExp(`${numberingSystems[numberingSystem || "latn"]}${append}`);}
const MISSING_FTP="missing Intl.DateTimeFormat.formatToParts support";function intUnit(regex,post=(i)=>i){return{regex,deser:([s])=>post(parseDigits(s))};}
const NBSP=String.fromCharCode(160);const spaceOrNBSP=`[ ${NBSP}]`;const spaceOrNBSPRegExp=new RegExp(spaceOrNBSP,"g");function fixListRegex(s){return s.replace(/\./g,"\\.?").replace(spaceOrNBSPRegExp,spaceOrNBSP);}
function stripInsensitivities(s){return s.replace(/\./g,"").replace(spaceOrNBSPRegExp," ").toLowerCase();}
function oneOf(strings,startIndex){if(strings===null){return null;}else{return{regex:RegExp(strings.map(fixListRegex).join("|")),deser:([s])=>strings.findIndex((i)=>stripInsensitivities(s)===stripInsensitivities(i))+startIndex,};}}
function offset(regex,groups){return{regex,deser:([,h,m])=>signedOffset(h,m),groups};}
function simple(regex){return{regex,deser:([s])=>s};}
function escapeToken(value){return value.replace(/[\-\[\]{}()*+?.,\\\^$|#\s]/g,"\\$&");}
function unitForToken(token,loc){const one=digitRegex(loc),two=digitRegex(loc,"{2}"),three=digitRegex(loc,"{3}"),four=digitRegex(loc,"{4}"),six=digitRegex(loc,"{6}"),oneOrTwo=digitRegex(loc,"{1,2}"),oneToThree=digitRegex(loc,"{1,3}"),oneToSix=digitRegex(loc,"{1,6}"),oneToNine=digitRegex(loc,"{1,9}"),twoToFour=digitRegex(loc,"{2,4}"),fourToSix=digitRegex(loc,"{4,6}"),literal=(t)=>({regex:RegExp(escapeToken(t.val)),deser:([s])=>s,literal:true}),unitate=(t)=>{if(token.literal){return literal(t);}
switch(t.val){case"G":return oneOf(loc.eras("short"),0);case"GG":return oneOf(loc.eras("long"),0);case"y":return intUnit(oneToSix);case"yy":return intUnit(twoToFour,untruncateYear);case"yyyy":return intUnit(four);case"yyyyy":return intUnit(fourToSix);case"yyyyyy":return intUnit(six);case"M":return intUnit(oneOrTwo);case"MM":return intUnit(two);case"MMM":return oneOf(loc.months("short",true),1);case"MMMM":return oneOf(loc.months("long",true),1);case"L":return intUnit(oneOrTwo);case"LL":return intUnit(two);case"LLL":return oneOf(loc.months("short",false),1);case"LLLL":return oneOf(loc.months("long",false),1);case"d":return intUnit(oneOrTwo);case"dd":return intUnit(two);case"o":return intUnit(oneToThree);case"ooo":return intUnit(three);case"HH":return intUnit(two);case"H":return intUnit(oneOrTwo);case"hh":return intUnit(two);case"h":return intUnit(oneOrTwo);case"mm":return intUnit(two);case"m":return intUnit(oneOrTwo);case"q":return intUnit(oneOrTwo);case"qq":return intUnit(two);case"s":return intUnit(oneOrTwo);case"ss":return intUnit(two);case"S":return intUnit(oneToThree);case"SSS":return intUnit(three);case"u":return simple(oneToNine);case"uu":return simple(oneOrTwo);case"uuu":return intUnit(one);case"a":return oneOf(loc.meridiems(),0);case"kkkk":return intUnit(four);case"kk":return intUnit(twoToFour,untruncateYear);case"W":return intUnit(oneOrTwo);case"WW":return intUnit(two);case"E":case"c":return intUnit(one);case"EEE":return oneOf(loc.weekdays("short",false),1);case"EEEE":return oneOf(loc.weekdays("long",false),1);case"ccc":return oneOf(loc.weekdays("short",true),1);case"cccc":return oneOf(loc.weekdays("long",true),1);case"Z":case"ZZ":return offset(new RegExp(`([+-]${oneOrTwo.source})(?::(${two.source}))?`),2);case"ZZZ":return offset(new RegExp(`([+-]${oneOrTwo.source})(${two.source})?`),2);case"z":return simple(/[a-z_+-/]{1,256}?/i);case" ":return simple(/[^\S\n\r]/);default:return literal(t);}};const unit=unitate(token)||{invalidReason:MISSING_FTP,};unit.token=token;return unit;}
const partTypeStyleToTokenVal={year:{"2-digit":"yy",numeric:"yyyyy",},month:{numeric:"M","2-digit":"MM",short:"MMM",long:"MMMM",},day:{numeric:"d","2-digit":"dd",},weekday:{short:"EEE",long:"EEEE",},dayperiod:"a",dayPeriod:"a",hour12:{numeric:"h","2-digit":"hh",},hour24:{numeric:"H","2-digit":"HH",},minute:{numeric:"m","2-digit":"mm",},second:{numeric:"s","2-digit":"ss",},timeZoneName:{long:"ZZZZZ",short:"ZZZ",},};function tokenForPart(part,formatOpts,resolvedOpts){const{type,value}=part;if(type==="literal"){const isSpace=/^\s+$/.test(value);return{literal:!isSpace,val:isSpace?" ":value,};}
const style=formatOpts[type];let actualType=type;if(type==="hour"){if(formatOpts.hour12!=null){actualType=formatOpts.hour12?"hour12":"hour24";}else if(formatOpts.hourCycle!=null){if(formatOpts.hourCycle==="h11"||formatOpts.hourCycle==="h12"){actualType="hour12";}else{actualType="hour24";}}else{actualType=resolvedOpts.hour12?"hour12":"hour24";}}
let val=partTypeStyleToTokenVal[actualType];if(typeof val==="object"){val=val[style];}
if(val){return{literal:false,val,};}
return undefined;}
function buildRegex(units){const re=units.map((u)=>u.regex).reduce((f,r)=>`${f}(${r.source})`,"");return[`^${re}$`,units];}
function match(input,regex,handlers){const matches=input.match(regex);if(matches){const all={};let matchIndex=1;for(const i in handlers){if(hasOwnProperty(handlers,i)){const h=handlers[i],groups=h.groups?h.groups+1:1;if(!h.literal&&h.token){all[h.token.val[0]]=h.deser(matches.slice(matchIndex,matchIndex+groups));}
matchIndex+=groups;}}
return[matches,all];}else{return[matches,{}];}}
function dateTimeFromMatches(matches){const toField=(token)=>{switch(token){case"S":return"millisecond";case"s":return"second";case"m":return"minute";case"h":case"H":return"hour";case"d":return"day";case"o":return"ordinal";case"L":case"M":return"month";case"y":return"year";case"E":case"c":return"weekday";case"W":return"weekNumber";case"k":return"weekYear";case"q":return"quarter";default:return null;}};let zone=null;let specificOffset;if(!isUndefined(matches.z)){zone=IANAZone.create(matches.z);}
if(!isUndefined(matches.Z)){if(!zone){zone=new FixedOffsetZone(matches.Z);}
specificOffset=matches.Z;}
if(!isUndefined(matches.q)){matches.M=(matches.q-1)*3+1;}
if(!isUndefined(matches.h)){if(matches.h<12&&matches.a===1){matches.h+=12;}else if(matches.h===12&&matches.a===0){matches.h=0;}}
if(matches.G===0&&matches.y){matches.y=-matches.y;}
if(!isUndefined(matches.u)){matches.S=parseMillis(matches.u);}
const vals=Object.keys(matches).reduce((r,k)=>{const f=toField(k);if(f){r[f]=matches[k];}
return r;},{});return[vals,zone,specificOffset];}
let dummyDateTimeCache=null;function getDummyDateTime(){if(!dummyDateTimeCache){dummyDateTimeCache=DateTime.fromMillis(1555555555555);}
return dummyDateTimeCache;}
function maybeExpandMacroToken(token,locale){if(token.literal){return token;}
const formatOpts=Formatter.macroTokenToFormatOpts(token.val);const tokens=formatOptsToTokens(formatOpts,locale);if(tokens==null||tokens.includes(undefined)){return token;}
return tokens;}
function expandMacroTokens(tokens,locale){return Array.prototype.concat(...tokens.map((t)=>maybeExpandMacroToken(t,locale)));}
function explainFromTokens(locale,input,format){const tokens=expandMacroTokens(Formatter.parseFormat(format),locale),units=tokens.map((t)=>unitForToken(t,locale)),disqualifyingUnit=units.find((t)=>t.invalidReason);if(disqualifyingUnit){return{input,tokens,invalidReason:disqualifyingUnit.invalidReason};}else{const[regexString,handlers]=buildRegex(units),regex=RegExp(regexString,"i"),[rawMatches,matches]=match(input,regex,handlers),[result,zone,specificOffset]=matches?dateTimeFromMatches(matches):[null,null,undefined];if(hasOwnProperty(matches,"a")&&hasOwnProperty(matches,"H")){throw new ConflictingSpecificationError("Can't include meridiem when specifying 24-hour format");}
return{input,tokens,regex,rawMatches,matches,result,zone,specificOffset};}}
function parseFromTokens(locale,input,format){const{result,zone,specificOffset,invalidReason}=explainFromTokens(locale,input,format);return[result,zone,specificOffset,invalidReason];}
function formatOptsToTokens(formatOpts,locale){if(!formatOpts){return null;}
const formatter=Formatter.create(locale,formatOpts);const df=formatter.dtFormatter(getDummyDateTime());const parts=df.formatToParts();const resolvedOpts=df.resolvedOptions();return parts.map((p)=>tokenForPart(p,formatOpts,resolvedOpts));}
const INVALID="Invalid DateTime";const MAX_DATE=8.64e15;function unsupportedZone(zone){return new Invalid("unsupported zone",`the zone "${zone.name}" is not supported`);}
function possiblyCachedWeekData(dt){if(dt.weekData===null){dt.weekData=gregorianToWeek(dt.c);}
return dt.weekData;}
function possiblyCachedLocalWeekData(dt){if(dt.localWeekData===null){dt.localWeekData=gregorianToWeek(dt.c,dt.loc.getMinDaysInFirstWeek(),dt.loc.getStartOfWeek());}
return dt.localWeekData;}
function clone(inst,alts){const current={ts:inst.ts,zone:inst.zone,c:inst.c,o:inst.o,loc:inst.loc,invalid:inst.invalid,};return new DateTime({...current,...alts,old:current});}
function fixOffset(localTS,o,tz){let utcGuess=localTS-o*60*1000;const o2=tz.offset(utcGuess);if(o===o2){return[utcGuess,o];}
utcGuess-=(o2-o)*60*1000;const o3=tz.offset(utcGuess);if(o2===o3){return[utcGuess,o2];}
return[localTS-Math.min(o2,o3)*60*1000,Math.max(o2,o3)];}
function tsToObj(ts,offset){ts+=offset*60*1000;const d=new Date(ts);return{year:d.getUTCFullYear(),month:d.getUTCMonth()+1,day:d.getUTCDate(),hour:d.getUTCHours(),minute:d.getUTCMinutes(),second:d.getUTCSeconds(),millisecond:d.getUTCMilliseconds(),};}
function objToTS(obj,offset,zone){return fixOffset(objToLocalTS(obj),offset,zone);}
function adjustTime(inst,dur){const oPre=inst.o,year=inst.c.year+Math.trunc(dur.years),month=inst.c.month+Math.trunc(dur.months)+Math.trunc(dur.quarters)*3,c={...inst.c,year,month,day:Math.min(inst.c.day,daysInMonth(year,month))+
Math.trunc(dur.days)+
Math.trunc(dur.weeks)*7,},millisToAdd=Duration.fromObject({years:dur.years-Math.trunc(dur.years),quarters:dur.quarters-Math.trunc(dur.quarters),months:dur.months-Math.trunc(dur.months),weeks:dur.weeks-Math.trunc(dur.weeks),days:dur.days-Math.trunc(dur.days),hours:dur.hours,minutes:dur.minutes,seconds:dur.seconds,milliseconds:dur.milliseconds,}).as("milliseconds"),localTS=objToLocalTS(c);let[ts,o]=fixOffset(localTS,oPre,inst.zone);if(millisToAdd!==0){ts+=millisToAdd;o=inst.zone.offset(ts);}
return{ts,o};}
function parseDataToDateTime(parsed,parsedZone,opts,format,text,specificOffset){const{setZone,zone}=opts;if((parsed&&Object.keys(parsed).length!==0)||parsedZone){const interpretationZone=parsedZone||zone,inst=DateTime.fromObject(parsed,{...opts,zone:interpretationZone,specificOffset,});return setZone?inst:inst.setZone(zone);}else{return DateTime.invalid(new Invalid("unparsable",`the input "${text}" can't be parsed as ${format}`));}}
function toTechFormat(dt,format,allowZ=true){return dt.isValid?Formatter.create(Locale.create("en-US"),{allowZ,forceSimple:true,}).formatDateTimeFromString(dt,format):null;}
function toISODate(o,extended){const longFormat=o.c.year>9999||o.c.year<0;let c="";if(longFormat&&o.c.year>=0)c+="+";c+=padStart(o.c.year,longFormat?6:4);if(extended){c+="-";c+=padStart(o.c.month);c+="-";c+=padStart(o.c.day);}else{c+=padStart(o.c.month);c+=padStart(o.c.day);}
return c;}
function toISOTime(o,extended,suppressSeconds,suppressMilliseconds,includeOffset,extendedZone){let c=padStart(o.c.hour);if(extended){c+=":";c+=padStart(o.c.minute);if(o.c.millisecond!==0||o.c.second!==0||!suppressSeconds){c+=":";}}else{c+=padStart(o.c.minute);}
if(o.c.millisecond!==0||o.c.second!==0||!suppressSeconds){c+=padStart(o.c.second);if(o.c.millisecond!==0||!suppressMilliseconds){c+=".";c+=padStart(o.c.millisecond,3);}}
if(includeOffset){if(o.isOffsetFixed&&o.offset===0&&!extendedZone){c+="Z";}else if(o.o<0){c+="-";c+=padStart(Math.trunc(-o.o/60));c+=":";c+=padStart(Math.trunc(-o.o%60));}else{c+="+";c+=padStart(Math.trunc(o.o/60));c+=":";c+=padStart(Math.trunc(o.o%60));}}
if(extendedZone){c+="["+o.zone.ianaName+"]";}
return c;}
const defaultUnitValues={month:1,day:1,hour:0,minute:0,second:0,millisecond:0,},defaultWeekUnitValues={weekNumber:1,weekday:1,hour:0,minute:0,second:0,millisecond:0,},defaultOrdinalUnitValues={ordinal:1,hour:0,minute:0,second:0,millisecond:0,};const orderedUnits=["year","month","day","hour","minute","second","millisecond"],orderedWeekUnits=["weekYear","weekNumber","weekday","hour","minute","second","millisecond",],orderedOrdinalUnits=["year","ordinal","hour","minute","second","millisecond"];function normalizeUnit(unit){const normalized={year:"year",years:"year",month:"month",months:"month",day:"day",days:"day",hour:"hour",hours:"hour",minute:"minute",minutes:"minute",quarter:"quarter",quarters:"quarter",second:"second",seconds:"second",millisecond:"millisecond",milliseconds:"millisecond",weekday:"weekday",weekdays:"weekday",weeknumber:"weekNumber",weeksnumber:"weekNumber",weeknumbers:"weekNumber",weekyear:"weekYear",weekyears:"weekYear",ordinal:"ordinal",}[unit.toLowerCase()];if(!normalized)throw new InvalidUnitError(unit);return normalized;}
function normalizeUnitWithLocalWeeks(unit){switch(unit.toLowerCase()){case"localweekday":case"localweekdays":return"localWeekday";case"localweeknumber":case"localweeknumbers":return"localWeekNumber";case"localweekyear":case"localweekyears":return"localWeekYear";default:return normalizeUnit(unit);}}
function quickDT(obj,opts){const zone=normalizeZone(opts.zone,Settings.defaultZone),loc=Locale.fromObject(opts),tsNow=Settings.now();let ts,o;if(!isUndefined(obj.year)){for(const u of orderedUnits){if(isUndefined(obj[u])){obj[u]=defaultUnitValues[u];}}
const invalid=hasInvalidGregorianData(obj)||hasInvalidTimeData(obj);if(invalid){return DateTime.invalid(invalid);}
const offsetProvis=zone.offset(tsNow);[ts,o]=objToTS(obj,offsetProvis,zone);}else{ts=tsNow;}
return new DateTime({ts,zone,loc,o});}
function diffRelative(start,end,opts){const round=isUndefined(opts.round)?true:opts.round,format=(c,unit)=>{c=roundTo(c,round||opts.calendary?0:2,true);const formatter=end.loc.clone(opts).relFormatter(opts);return formatter.format(c,unit);},differ=(unit)=>{if(opts.calendary){if(!end.hasSame(start,unit)){return end.startOf(unit).diff(start.startOf(unit),unit).get(unit);}else return 0;}else{return end.diff(start,unit).get(unit);}};if(opts.unit){return format(differ(opts.unit),opts.unit);}
for(const unit of opts.units){const count=differ(unit);if(Math.abs(count)>=1){return format(count,unit);}}
return format(start>end?-0:0,opts.units[opts.units.length-1]);}
function lastOpts(argList){let opts={},args;if(argList.length>0&&typeof argList[argList.length-1]==="object"){opts=argList[argList.length-1];args=Array.from(argList).slice(0,argList.length-1);}else{args=Array.from(argList);}
return[opts,args];}
class DateTime{constructor(config){const zone=config.zone||Settings.defaultZone;let invalid=config.invalid||(Number.isNaN(config.ts)?new Invalid("invalid input"):null)||(!zone.isValid?unsupportedZone(zone):null);this.ts=isUndefined(config.ts)?Settings.now():config.ts;let c=null,o=null;if(!invalid){const unchanged=config.old&&config.old.ts===this.ts&&config.old.zone.equals(zone);if(unchanged){[c,o]=[config.old.c,config.old.o];}else{const ot=zone.offset(this.ts);c=tsToObj(this.ts,ot);invalid=Number.isNaN(c.year)?new Invalid("invalid input"):null;c=invalid?null:c;o=invalid?null:ot;}}
this._zone=zone;this.loc=config.loc||Locale.create();this.invalid=invalid;this.weekData=null;this.localWeekData=null;this.c=c;this.o=o;this.isLuxonDateTime=true;}
static now(){return new DateTime({});}
static local(){const[opts,args]=lastOpts(arguments),[year,month,day,hour,minute,second,millisecond]=args;return quickDT({year,month,day,hour,minute,second,millisecond},opts);}
static utc(){const[opts,args]=lastOpts(arguments),[year,month,day,hour,minute,second,millisecond]=args;opts.zone=FixedOffsetZone.utcInstance;return quickDT({year,month,day,hour,minute,second,millisecond},opts);}
static fromJSDate(date,options={}){const ts=isDate(date)?date.valueOf():NaN;if(Number.isNaN(ts)){return DateTime.invalid("invalid input");}
const zoneToUse=normalizeZone(options.zone,Settings.defaultZone);if(!zoneToUse.isValid){return DateTime.invalid(unsupportedZone(zoneToUse));}
return new DateTime({ts:ts,zone:zoneToUse,loc:Locale.fromObject(options),});}
static fromMillis(milliseconds,options={}){if(!isNumber(milliseconds)){throw new InvalidArgumentError(`fromMillis requires a numerical input, but received a ${typeof milliseconds} with value ${milliseconds}`);}else if(milliseconds<-MAX_DATE||milliseconds>MAX_DATE){return DateTime.invalid("Timestamp out of range");}else{return new DateTime({ts:milliseconds,zone:normalizeZone(options.zone,Settings.defaultZone),loc:Locale.fromObject(options),});}}
static fromSeconds(seconds,options={}){if(!isNumber(seconds)){throw new InvalidArgumentError("fromSeconds requires a numerical input");}else{return new DateTime({ts:seconds*1000,zone:normalizeZone(options.zone,Settings.defaultZone),loc:Locale.fromObject(options),});}}
static fromObject(obj,opts={}){obj=obj||{};const zoneToUse=normalizeZone(opts.zone,Settings.defaultZone);if(!zoneToUse.isValid){return DateTime.invalid(unsupportedZone(zoneToUse));}
const loc=Locale.fromObject(opts);const normalized=normalizeObject(obj,normalizeUnitWithLocalWeeks);const{minDaysInFirstWeek,startOfWeek}=usesLocalWeekValues(normalized,loc);const tsNow=Settings.now(),offsetProvis=!isUndefined(opts.specificOffset)?opts.specificOffset:zoneToUse.offset(tsNow),containsOrdinal=!isUndefined(normalized.ordinal),containsGregorYear=!isUndefined(normalized.year),containsGregorMD=!isUndefined(normalized.month)||!isUndefined(normalized.day),containsGregor=containsGregorYear||containsGregorMD,definiteWeekDef=normalized.weekYear||normalized.weekNumber;if((containsGregor||containsOrdinal)&&definiteWeekDef){throw new ConflictingSpecificationError("Can't mix weekYear/weekNumber units with year/month/day or ordinals");}
if(containsGregorMD&&containsOrdinal){throw new ConflictingSpecificationError("Can't mix ordinal dates with month/day");}
const useWeekData=definiteWeekDef||(normalized.weekday&&!containsGregor);let units,defaultValues,objNow=tsToObj(tsNow,offsetProvis);if(useWeekData){units=orderedWeekUnits;defaultValues=defaultWeekUnitValues;objNow=gregorianToWeek(objNow,minDaysInFirstWeek,startOfWeek);}else if(containsOrdinal){units=orderedOrdinalUnits;defaultValues=defaultOrdinalUnitValues;objNow=gregorianToOrdinal(objNow);}else{units=orderedUnits;defaultValues=defaultUnitValues;}
let foundFirst=false;for(const u of units){const v=normalized[u];if(!isUndefined(v)){foundFirst=true;}else if(foundFirst){normalized[u]=defaultValues[u];}else{normalized[u]=objNow[u];}}
const higherOrderInvalid=useWeekData?hasInvalidWeekData(normalized,minDaysInFirstWeek,startOfWeek):containsOrdinal?hasInvalidOrdinalData(normalized):hasInvalidGregorianData(normalized),invalid=higherOrderInvalid||hasInvalidTimeData(normalized);if(invalid){return DateTime.invalid(invalid);}
const gregorian=useWeekData?weekToGregorian(normalized,minDaysInFirstWeek,startOfWeek):containsOrdinal?ordinalToGregorian(normalized):normalized,[tsFinal,offsetFinal]=objToTS(gregorian,offsetProvis,zoneToUse),inst=new DateTime({ts:tsFinal,zone:zoneToUse,o:offsetFinal,loc,});if(normalized.weekday&&containsGregor&&obj.weekday!==inst.weekday){return DateTime.invalid("mismatched weekday",`you can't specify both a weekday of ${normalized.weekday} and a date of ${inst.toISO()}`);}
if(!inst.isValid){return DateTime.invalid(inst.invalid);}
return inst;}
static fromISO(text,opts={}){const[vals,parsedZone]=parseISODate(text);return parseDataToDateTime(vals,parsedZone,opts,"ISO 8601",text);}
static fromRFC2822(text,opts={}){const[vals,parsedZone]=parseRFC2822Date(text);return parseDataToDateTime(vals,parsedZone,opts,"RFC 2822",text);}
static fromHTTP(text,opts={}){const[vals,parsedZone]=parseHTTPDate(text);return parseDataToDateTime(vals,parsedZone,opts,"HTTP",opts);}
static fromFormat(text,fmt,opts={}){if(isUndefined(text)||isUndefined(fmt)){throw new InvalidArgumentError("fromFormat requires an input string and a format");}
const{locale=null,numberingSystem=null}=opts,localeToUse=Locale.fromOpts({locale,numberingSystem,defaultToEN:true,}),[vals,parsedZone,specificOffset,invalid]=parseFromTokens(localeToUse,text,fmt);if(invalid){return DateTime.invalid(invalid);}else{return parseDataToDateTime(vals,parsedZone,opts,`format ${fmt}`,text,specificOffset);}}
static fromString(text,fmt,opts={}){return DateTime.fromFormat(text,fmt,opts);}
static fromSQL(text,opts={}){const[vals,parsedZone]=parseSQL(text);return parseDataToDateTime(vals,parsedZone,opts,"SQL",text);}
static invalid(reason,explanation=null){if(!reason){throw new InvalidArgumentError("need to specify a reason the DateTime is invalid");}
const invalid=reason instanceof Invalid?reason:new Invalid(reason,explanation);if(Settings.throwOnInvalid){throw new InvalidDateTimeError(invalid);}else{return new DateTime({invalid});}}
static isDateTime(o){return(o&&o.isLuxonDateTime)||false;}
static parseFormatForOpts(formatOpts,localeOpts={}){const tokenList=formatOptsToTokens(formatOpts,Locale.fromObject(localeOpts));return!tokenList?null:tokenList.map((t)=>(t?t.val:null)).join("");}
static expandFormat(fmt,localeOpts={}){const expanded=expandMacroTokens(Formatter.parseFormat(fmt),Locale.fromObject(localeOpts));return expanded.map((t)=>t.val).join("");}
get(unit){return this[unit];}
get isValid(){return this.invalid===null;}
get invalidReason(){return this.invalid?this.invalid.reason:null;}
get invalidExplanation(){return this.invalid?this.invalid.explanation:null;}
get locale(){return this.isValid?this.loc.locale:null;}
get numberingSystem(){return this.isValid?this.loc.numberingSystem:null;}
get outputCalendar(){return this.isValid?this.loc.outputCalendar:null;}
get zone(){return this._zone;}
get zoneName(){return this.isValid?this.zone.name:null;}
get year(){return this.isValid?this.c.year:NaN;}
get quarter(){return this.isValid?Math.ceil(this.c.month/3):NaN;}
get month(){return this.isValid?this.c.month:NaN;}
get day(){return this.isValid?this.c.day:NaN;}
get hour(){return this.isValid?this.c.hour:NaN;}
get minute(){return this.isValid?this.c.minute:NaN;}
get second(){return this.isValid?this.c.second:NaN;}
get millisecond(){return this.isValid?this.c.millisecond:NaN;}
get weekYear(){return this.isValid?possiblyCachedWeekData(this).weekYear:NaN;}
get weekNumber(){return this.isValid?possiblyCachedWeekData(this).weekNumber:NaN;}
get weekday(){return this.isValid?possiblyCachedWeekData(this).weekday:NaN;}
get isWeekend(){return this.isValid&&this.loc.getWeekendDays().includes(this.weekday);}
get localWeekday(){return this.isValid?possiblyCachedLocalWeekData(this).weekday:NaN;}
get localWeekNumber(){return this.isValid?possiblyCachedLocalWeekData(this).weekNumber:NaN;}
get localWeekYear(){return this.isValid?possiblyCachedLocalWeekData(this).weekYear:NaN;}
get ordinal(){return this.isValid?gregorianToOrdinal(this.c).ordinal:NaN;}
get monthShort(){return this.isValid?Info.months("short",{locObj:this.loc})[this.month-1]:null;}
get monthLong(){return this.isValid?Info.months("long",{locObj:this.loc})[this.month-1]:null;}
get weekdayShort(){return this.isValid?Info.weekdays("short",{locObj:this.loc})[this.weekday-1]:null;}
get weekdayLong(){return this.isValid?Info.weekdays("long",{locObj:this.loc})[this.weekday-1]:null;}
get offset(){return this.isValid?+this.o:NaN;}
get offsetNameShort(){if(this.isValid){return this.zone.offsetName(this.ts,{format:"short",locale:this.locale,});}else{return null;}}
get offsetNameLong(){if(this.isValid){return this.zone.offsetName(this.ts,{format:"long",locale:this.locale,});}else{return null;}}
get isOffsetFixed(){return this.isValid?this.zone.isUniversal:null;}
get isInDST(){if(this.isOffsetFixed){return false;}else{return(this.offset>this.set({month:1,day:1}).offset||this.offset>this.set({month:5}).offset);}}
getPossibleOffsets(){if(!this.isValid||this.isOffsetFixed){return[this];}
const dayMs=86400000;const minuteMs=60000;const localTS=objToLocalTS(this.c);const oEarlier=this.zone.offset(localTS-dayMs);const oLater=this.zone.offset(localTS+dayMs);const o1=this.zone.offset(localTS-oEarlier*minuteMs);const o2=this.zone.offset(localTS-oLater*minuteMs);if(o1===o2){return[this];}
const ts1=localTS-o1*minuteMs;const ts2=localTS-o2*minuteMs;const c1=tsToObj(ts1,o1);const c2=tsToObj(ts2,o2);if(c1.hour===c2.hour&&c1.minute===c2.minute&&c1.second===c2.second&&c1.millisecond===c2.millisecond){return[clone(this,{ts:ts1}),clone(this,{ts:ts2})];}
return[this];}
get isInLeapYear(){return isLeapYear(this.year);}
get daysInMonth(){return daysInMonth(this.year,this.month);}
get daysInYear(){return this.isValid?daysInYear(this.year):NaN;}
get weeksInWeekYear(){return this.isValid?weeksInWeekYear(this.weekYear):NaN;}
get weeksInLocalWeekYear(){return this.isValid?weeksInWeekYear(this.localWeekYear,this.loc.getMinDaysInFirstWeek(),this.loc.getStartOfWeek()):NaN;}
resolvedLocaleOptions(opts={}){const{locale,numberingSystem,calendar}=Formatter.create(this.loc.clone(opts),opts).resolvedOptions(this);return{locale,numberingSystem,outputCalendar:calendar};}
toUTC(offset=0,opts={}){return this.setZone(FixedOffsetZone.instance(offset),opts);}
toLocal(){return this.setZone(Settings.defaultZone);}
setZone(zone,{keepLocalTime=false,keepCalendarTime=false}={}){zone=normalizeZone(zone,Settings.defaultZone);if(zone.equals(this.zone)){return this;}else if(!zone.isValid){return DateTime.invalid(unsupportedZone(zone));}else{let newTS=this.ts;if(keepLocalTime||keepCalendarTime){const offsetGuess=zone.offset(this.ts);const asObj=this.toObject();[newTS]=objToTS(asObj,offsetGuess,zone);}
return clone(this,{ts:newTS,zone});}}
reconfigure({locale,numberingSystem,outputCalendar}={}){const loc=this.loc.clone({locale,numberingSystem,outputCalendar});return clone(this,{loc});}
setLocale(locale){return this.reconfigure({locale});}
set(values){if(!this.isValid)return this;const normalized=normalizeObject(values,normalizeUnitWithLocalWeeks);const{minDaysInFirstWeek,startOfWeek}=usesLocalWeekValues(normalized,this.loc);const settingWeekStuff=!isUndefined(normalized.weekYear)||!isUndefined(normalized.weekNumber)||!isUndefined(normalized.weekday),containsOrdinal=!isUndefined(normalized.ordinal),containsGregorYear=!isUndefined(normalized.year),containsGregorMD=!isUndefined(normalized.month)||!isUndefined(normalized.day),containsGregor=containsGregorYear||containsGregorMD,definiteWeekDef=normalized.weekYear||normalized.weekNumber;if((containsGregor||containsOrdinal)&&definiteWeekDef){throw new ConflictingSpecificationError("Can't mix weekYear/weekNumber units with year/month/day or ordinals");}
if(containsGregorMD&&containsOrdinal){throw new ConflictingSpecificationError("Can't mix ordinal dates with month/day");}
let mixed;if(settingWeekStuff){mixed=weekToGregorian({...gregorianToWeek(this.c,minDaysInFirstWeek,startOfWeek),...normalized},minDaysInFirstWeek,startOfWeek);}else if(!isUndefined(normalized.ordinal)){mixed=ordinalToGregorian({...gregorianToOrdinal(this.c),...normalized});}else{mixed={...this.toObject(),...normalized};if(isUndefined(normalized.day)){mixed.day=Math.min(daysInMonth(mixed.year,mixed.month),mixed.day);}}
const[ts,o]=objToTS(mixed,this.o,this.zone);return clone(this,{ts,o});}
plus(duration){if(!this.isValid)return this;const dur=Duration.fromDurationLike(duration);return clone(this,adjustTime(this,dur));}
minus(duration){if(!this.isValid)return this;const dur=Duration.fromDurationLike(duration).negate();return clone(this,adjustTime(this,dur));}
startOf(unit,{useLocaleWeeks=false}={}){if(!this.isValid)return this;const o={},normalizedUnit=Duration.normalizeUnit(unit);switch(normalizedUnit){case"years":o.month=1;case"quarters":case"months":o.day=1;case"weeks":case"days":o.hour=0;case"hours":o.minute=0;case"minutes":o.second=0;case"seconds":o.millisecond=0;break;}
if(normalizedUnit==="weeks"){if(useLocaleWeeks){const startOfWeek=this.loc.getStartOfWeek();const{weekday}=this;if(weekday<startOfWeek){o.weekNumber=this.weekNumber-1;}
o.weekday=startOfWeek;}else{o.weekday=1;}}
if(normalizedUnit==="quarters"){const q=Math.ceil(this.month/3);o.month=(q-1)*3+1;}
return this.set(o);}
endOf(unit,opts){return this.isValid?this.plus({[unit]:1}).startOf(unit,opts).minus(1):this;}
toFormat(fmt,opts={}){return this.isValid?Formatter.create(this.loc.redefaultToEN(opts)).formatDateTimeFromString(this,fmt):INVALID;}
toLocaleString(formatOpts=DATE_SHORT,opts={}){return this.isValid?Formatter.create(this.loc.clone(opts),formatOpts).formatDateTime(this):INVALID;}
toLocaleParts(opts={}){return this.isValid?Formatter.create(this.loc.clone(opts),opts).formatDateTimeParts(this):[];}
toISO({format="extended",suppressSeconds=false,suppressMilliseconds=false,includeOffset=true,extendedZone=false,}={}){if(!this.isValid){return null;}
const ext=format==="extended";let c=toISODate(this,ext);c+="T";c+=toISOTime(this,ext,suppressSeconds,suppressMilliseconds,includeOffset,extendedZone);return c;}
toISODate({format="extended"}={}){if(!this.isValid){return null;}
return toISODate(this,format==="extended");}
toISOWeekDate(){return toTechFormat(this,"kkkk-'W'WW-c");}
toISOTime({suppressMilliseconds=false,suppressSeconds=false,includeOffset=true,includePrefix=false,extendedZone=false,format="extended",}={}){if(!this.isValid){return null;}
let c=includePrefix?"T":"";return(c+
toISOTime(this,format==="extended",suppressSeconds,suppressMilliseconds,includeOffset,extendedZone));}
toRFC2822(){return toTechFormat(this,"EEE, dd LLL yyyy HH:mm:ss ZZZ",false);}
toHTTP(){return toTechFormat(this.toUTC(),"EEE, dd LLL yyyy HH:mm:ss 'GMT'");}
toSQLDate(){if(!this.isValid){return null;}
return toISODate(this,true);}
toSQLTime({includeOffset=true,includeZone=false,includeOffsetSpace=true}={}){let fmt="HH:mm:ss.SSS";if(includeZone||includeOffset){if(includeOffsetSpace){fmt+=" ";}
if(includeZone){fmt+="z";}else if(includeOffset){fmt+="ZZ";}}
return toTechFormat(this,fmt,true);}
toSQL(opts={}){if(!this.isValid){return null;}
return`${this.toSQLDate()} ${this.toSQLTime(opts)}`;}
toString(){return this.isValid?this.toISO():INVALID;}
[Symbol.for("nodejs.util.inspect.custom")](){if(this.isValid){return`DateTime { ts: ${this.toISO()}, zone: ${this.zone.name}, locale: ${this.locale} }`;}else{return`DateTime { Invalid, reason: ${this.invalidReason} }`;}}
valueOf(){return this.toMillis();}
toMillis(){return this.isValid?this.ts:NaN;}
toSeconds(){return this.isValid?this.ts/1000:NaN;}
toUnixInteger(){return this.isValid?Math.floor(this.ts/1000):NaN;}
toJSON(){return this.toISO();}
toBSON(){return this.toJSDate();}
toObject(opts={}){if(!this.isValid)return{};const base={...this.c};if(opts.includeConfig){base.outputCalendar=this.outputCalendar;base.numberingSystem=this.loc.numberingSystem;base.locale=this.loc.locale;}
return base;}
toJSDate(){return new Date(this.isValid?this.ts:NaN);}
diff(otherDateTime,unit="milliseconds",opts={}){if(!this.isValid||!otherDateTime.isValid){return Duration.invalid("created by diffing an invalid DateTime");}
const durOpts={locale:this.locale,numberingSystem:this.numberingSystem,...opts};const units=maybeArray(unit).map(Duration.normalizeUnit),otherIsLater=otherDateTime.valueOf()>this.valueOf(),earlier=otherIsLater?this:otherDateTime,later=otherIsLater?otherDateTime:this,diffed=diff(earlier,later,units,durOpts);return otherIsLater?diffed.negate():diffed;}
diffNow(unit="milliseconds",opts={}){return this.diff(DateTime.now(),unit,opts);}
until(otherDateTime){return this.isValid?Interval.fromDateTimes(this,otherDateTime):this;}
hasSame(otherDateTime,unit,opts){if(!this.isValid)return false;const inputMs=otherDateTime.valueOf();const adjustedToZone=this.setZone(otherDateTime.zone,{keepLocalTime:true});return(adjustedToZone.startOf(unit,opts)<=inputMs&&inputMs<=adjustedToZone.endOf(unit,opts));}
equals(other){return(this.isValid&&other.isValid&&this.valueOf()===other.valueOf()&&this.zone.equals(other.zone)&&this.loc.equals(other.loc));}
toRelative(options={}){if(!this.isValid)return null;const base=options.base||DateTime.fromObject({},{zone:this.zone}),padding=options.padding?(this<base?-options.padding:options.padding):0;let units=["years","months","days","hours","minutes","seconds"];let unit=options.unit;if(Array.isArray(options.unit)){units=options.unit;unit=undefined;}
return diffRelative(base,this.plus(padding),{...options,numeric:"always",units,unit,});}
toRelativeCalendar(options={}){if(!this.isValid)return null;return diffRelative(options.base||DateTime.fromObject({},{zone:this.zone}),this,{...options,numeric:"auto",units:["years","months","days"],calendary:true,});}
static min(...dateTimes){if(!dateTimes.every(DateTime.isDateTime)){throw new InvalidArgumentError("min requires all arguments be DateTimes");}
return bestBy(dateTimes,(i)=>i.valueOf(),Math.min);}
static max(...dateTimes){if(!dateTimes.every(DateTime.isDateTime)){throw new InvalidArgumentError("max requires all arguments be DateTimes");}
return bestBy(dateTimes,(i)=>i.valueOf(),Math.max);}
static fromFormatExplain(text,fmt,options={}){const{locale=null,numberingSystem=null}=options,localeToUse=Locale.fromOpts({locale,numberingSystem,defaultToEN:true,});return explainFromTokens(localeToUse,text,fmt);}
static fromStringExplain(text,fmt,options={}){return DateTime.fromFormatExplain(text,fmt,options);}
static get DATE_SHORT(){return DATE_SHORT;}
static get DATE_MED(){return DATE_MED;}
static get DATE_MED_WITH_WEEKDAY(){return DATE_MED_WITH_WEEKDAY;}
static get DATE_FULL(){return DATE_FULL;}
static get DATE_HUGE(){return DATE_HUGE;}
static get TIME_SIMPLE(){return TIME_SIMPLE;}
static get TIME_WITH_SECONDS(){return TIME_WITH_SECONDS;}
static get TIME_WITH_SHORT_OFFSET(){return TIME_WITH_SHORT_OFFSET;}
static get TIME_WITH_LONG_OFFSET(){return TIME_WITH_LONG_OFFSET;}
static get TIME_24_SIMPLE(){return TIME_24_SIMPLE;}
static get TIME_24_WITH_SECONDS(){return TIME_24_WITH_SECONDS;}
static get TIME_24_WITH_SHORT_OFFSET(){return TIME_24_WITH_SHORT_OFFSET;}
static get TIME_24_WITH_LONG_OFFSET(){return TIME_24_WITH_LONG_OFFSET;}
static get DATETIME_SHORT(){return DATETIME_SHORT;}
static get DATETIME_SHORT_WITH_SECONDS(){return DATETIME_SHORT_WITH_SECONDS;}
static get DATETIME_MED(){return DATETIME_MED;}
static get DATETIME_MED_WITH_SECONDS(){return DATETIME_MED_WITH_SECONDS;}
static get DATETIME_MED_WITH_WEEKDAY(){return DATETIME_MED_WITH_WEEKDAY;}
static get DATETIME_FULL(){return DATETIME_FULL;}
static get DATETIME_FULL_WITH_SECONDS(){return DATETIME_FULL_WITH_SECONDS;}
static get DATETIME_HUGE(){return DATETIME_HUGE;}
static get DATETIME_HUGE_WITH_SECONDS(){return DATETIME_HUGE_WITH_SECONDS;}}
function friendlyDateTime(dateTimeish){if(DateTime.isDateTime(dateTimeish)){return dateTimeish;}else if(dateTimeish&&dateTimeish.valueOf&&isNumber(dateTimeish.valueOf())){return DateTime.fromJSDate(dateTimeish);}else if(dateTimeish&&typeof dateTimeish==="object"){return DateTime.fromObject(dateTimeish);}else{throw new InvalidArgumentError(`Unknown datetime argument: ${dateTimeish}, of type ${typeof dateTimeish}`);}}
const VERSION="3.4.4";exports.DateTime=DateTime;exports.Duration=Duration;exports.FixedOffsetZone=FixedOffsetZone;exports.IANAZone=IANAZone;exports.Info=Info;exports.Interval=Interval;exports.InvalidZone=InvalidZone;exports.Settings=Settings;exports.SystemZone=SystemZone;exports.VERSION=VERSION;exports.Zone=Zone;Object.defineProperty(exports,'__esModule',{value:true});return exports;})({});luxon.DateTime.prototype[Symbol.toStringTag]="LuxonDateTime";luxon.Duration.prototype[Symbol.toStringTag]="LuxonDuration";luxon.Interval.prototype[Symbol.toStringTag]="LuxonInterval";luxon.Settings.prototype[Symbol.toStringTag]="LuxonSettings";luxon.Info.prototype[Symbol.toStringTag]="LuxonInfo";luxon.Zone.prototype[Symbol.toStringTag]="LuxonZone";;

/* /web/static/lib/owl/owl.js */
(function(exports){'use strict';function filterOutModifiersFromData(dataList){dataList=dataList.slice();const modifiers=[];let elm;while((elm=dataList[0])&&typeof elm==="string"){modifiers.push(dataList.shift());}
return{modifiers,data:dataList};}
const config={shouldNormalizeDom:true,mainEventHandler:(data,ev,currentTarget)=>{if(typeof data==="function"){data(ev);}
else if(Array.isArray(data)){data=filterOutModifiersFromData(data).data;data[0](data[1],ev);}
return false;},};class VToggler{constructor(key,child){this.key=key;this.child=child;}
mount(parent,afterNode){this.parentEl=parent;this.child.mount(parent,afterNode);}
moveBeforeDOMNode(node,parent){this.child.moveBeforeDOMNode(node,parent);}
moveBeforeVNode(other,afterNode){this.moveBeforeDOMNode((other&&other.firstNode())||afterNode);}
patch(other,withBeforeRemove){if(this===other){return;}
let child1=this.child;let child2=other.child;if(this.key===other.key){child1.patch(child2,withBeforeRemove);}
else{child2.mount(this.parentEl,child1.firstNode());if(withBeforeRemove){child1.beforeRemove();}
child1.remove();this.child=child2;this.key=other.key;}}
beforeRemove(){this.child.beforeRemove();}
remove(){this.child.remove();}
firstNode(){return this.child.firstNode();}
toString(){return this.child.toString();}}
function toggler(key,child){return new VToggler(key,child);}
class OwlError extends Error{}
const{setAttribute:elemSetAttribute,removeAttribute}=Element.prototype;const tokenList=DOMTokenList.prototype;const tokenListAdd=tokenList.add;const tokenListRemove=tokenList.remove;const isArray=Array.isArray;const{split,trim}=String.prototype;const wordRegexp=/\s+/;function setAttribute(key,value){switch(value){case false:case undefined:removeAttribute.call(this,key);break;case true:elemSetAttribute.call(this,key,"");break;default:elemSetAttribute.call(this,key,value);}}
function createAttrUpdater(attr){return function(value){setAttribute.call(this,attr,value);};}
function attrsSetter(attrs){if(isArray(attrs)){if(attrs[0]==="class"){setClass.call(this,attrs[1]);}
else{setAttribute.call(this,attrs[0],attrs[1]);}}
else{for(let k in attrs){if(k==="class"){setClass.call(this,attrs[k]);}
else{setAttribute.call(this,k,attrs[k]);}}}}
function attrsUpdater(attrs,oldAttrs){if(isArray(attrs)){const name=attrs[0];const val=attrs[1];if(name===oldAttrs[0]){if(val===oldAttrs[1]){return;}
if(name==="class"){updateClass.call(this,val,oldAttrs[1]);}
else{setAttribute.call(this,name,val);}}
else{removeAttribute.call(this,oldAttrs[0]);setAttribute.call(this,name,val);}}
else{for(let k in oldAttrs){if(!(k in attrs)){if(k==="class"){updateClass.call(this,"",oldAttrs[k]);}
else{removeAttribute.call(this,k);}}}
for(let k in attrs){const val=attrs[k];if(val!==oldAttrs[k]){if(k==="class"){updateClass.call(this,val,oldAttrs[k]);}
else{setAttribute.call(this,k,val);}}}}}
function toClassObj(expr){const result={};switch(typeof expr){case"string":const str=trim.call(expr);if(!str){return{};}
let words=split.call(str,wordRegexp);for(let i=0,l=words.length;i<l;i++){result[words[i]]=true;}
return result;case"object":for(let key in expr){const value=expr[key];if(value){key=trim.call(key);if(!key){continue;}
const words=split.call(key,wordRegexp);for(let word of words){result[word]=value;}}}
return result;case"undefined":return{};case"number":return{[expr]:true};default:return{[expr]:true};}}
function setClass(val){val=val===""?{}:toClassObj(val);const cl=this.classList;for(let c in val){tokenListAdd.call(cl,c);}}
function updateClass(val,oldVal){oldVal=oldVal===""?{}:toClassObj(oldVal);val=val===""?{}:toClassObj(val);const cl=this.classList;for(let c in oldVal){if(!(c in val)){tokenListRemove.call(cl,c);}}
for(let c in val){if(!(c in oldVal)){tokenListAdd.call(cl,c);}}}
function batched(callback){let scheduled=false;return async(...args)=>{if(!scheduled){scheduled=true;await Promise.resolve();scheduled=false;callback(...args);}};}
function inOwnerDocument(el){if(!el){return false;}
if(el.ownerDocument.contains(el)){return true;}
const rootNode=el.getRootNode();return rootNode instanceof ShadowRoot&&el.ownerDocument.contains(rootNode.host);}
function isAttachedToDocument(element,documentElement){let current=element;const shadowRoot=documentElement.defaultView.ShadowRoot;while(current){if(current===documentElement){return true;}
if(current.parentNode){current=current.parentNode;}
else if(current instanceof shadowRoot&&current.host){current=current.host;}
else{return false;}}
return false;}
function validateTarget(target){const document=target&&target.ownerDocument;if(document){if(!document.defaultView){throw new OwlError("Cannot mount a component: the target document is not attached to a window (defaultView is missing)");}
const HTMLElement=document.defaultView.HTMLElement;if(target instanceof HTMLElement||target instanceof ShadowRoot){if(!isAttachedToDocument(target,document)){throw new OwlError("Cannot mount a component on a detached dom node");}
return;}}
throw new OwlError("Cannot mount component: the target is not a valid DOM element");}
class EventBus extends EventTarget{trigger(name,payload){this.dispatchEvent(new CustomEvent(name,{detail:payload}));}}
function whenReady(fn){return new Promise(function(resolve){if(document.readyState!=="loading"){resolve(true);}
else{document.addEventListener("DOMContentLoaded",resolve,false);}}).then(fn||function(){});}
async function loadFile(url){const result=await fetch(url);if(!result.ok){throw new OwlError("Error while fetching xml templates");}
return await result.text();}
class Markup extends String{}
function htmlEscape(str){if(str instanceof Markup){return str;}
if(str===undefined){return markup("");}
if(typeof str==="number"){return markup(String(str));}
[["&","&amp;"],["<","&lt;"],[">","&gt;"],["'","&#x27;"],['"',"&quot;"],["`","&#x60;"],].forEach((pairs)=>{str=String(str).replace(new RegExp(pairs[0],"g"),pairs[1]);});return markup(str);}
function markup(valueOrStrings,...placeholders){if(!Array.isArray(valueOrStrings)){return new Markup(valueOrStrings);}
const strings=valueOrStrings;let acc="";let i=0;for(;i<placeholders.length;++i){acc+=strings[i]+htmlEscape(placeholders[i]);}
acc+=strings[i];return new Markup(acc);}
function createEventHandler(rawEvent){const eventName=rawEvent.split(".")[0];const capture=rawEvent.includes(".capture");if(rawEvent.includes(".synthetic")){return createSyntheticHandler(eventName,capture);}
else{return createElementHandler(eventName,capture);}}
let nextNativeEventId=1;function createElementHandler(evName,capture=false){let eventKey=`__event__${evName}_${nextNativeEventId++}`;if(capture){eventKey=`${eventKey}_capture`;}
function listener(ev){const currentTarget=ev.currentTarget;if(!currentTarget||!inOwnerDocument(currentTarget))
return;const data=currentTarget[eventKey];if(!data)
return;config.mainEventHandler(data,ev,currentTarget);}
function setup(data){this[eventKey]=data;this.addEventListener(evName,listener,{capture});}
function remove(){delete this[eventKey];this.removeEventListener(evName,listener,{capture});}
function update(data){this[eventKey]=data;}
return{setup,update,remove};}
let nextSyntheticEventId=1;function createSyntheticHandler(evName,capture=false){let eventKey=`__event__synthetic_${evName}`;if(capture){eventKey=`${eventKey}_capture`;}
setupSyntheticEvent(evName,eventKey,capture);const currentId=nextSyntheticEventId++;function setup(data){const _data=this[eventKey]||{};_data[currentId]=data;this[eventKey]=_data;}
function remove(){delete this[eventKey];}
return{setup,update:setup,remove};}
function nativeToSyntheticEvent(eventKey,event){let dom=event.target;while(dom!==null){const _data=dom[eventKey];if(_data){for(const data of Object.values(_data)){const stopped=config.mainEventHandler(data,event,dom);if(stopped)
return;}}
dom=dom.parentNode;}}
const CONFIGURED_SYNTHETIC_EVENTS={};function setupSyntheticEvent(evName,eventKey,capture=false){if(CONFIGURED_SYNTHETIC_EVENTS[eventKey]){return;}
document.addEventListener(evName,(event)=>nativeToSyntheticEvent(eventKey,event),{capture,});CONFIGURED_SYNTHETIC_EVENTS[eventKey]=true;}
const getDescriptor$3=(o,p)=>Object.getOwnPropertyDescriptor(o,p);const nodeProto$4=Node.prototype;const nodeInsertBefore$3=nodeProto$4.insertBefore;const nodeSetTextContent$1=getDescriptor$3(nodeProto$4,"textContent").set;const nodeRemoveChild$3=nodeProto$4.removeChild;class VMulti{constructor(children){this.children=children;}
mount(parent,afterNode){const children=this.children;const l=children.length;const anchors=new Array(l);for(let i=0;i<l;i++){let child=children[i];if(child){child.mount(parent,afterNode);}
else{const childAnchor=document.createTextNode("");anchors[i]=childAnchor;nodeInsertBefore$3.call(parent,childAnchor,afterNode);}}
this.anchors=anchors;this.parentEl=parent;}
moveBeforeDOMNode(node,parent=this.parentEl){this.parentEl=parent;const children=this.children;const anchors=this.anchors;for(let i=0,l=children.length;i<l;i++){let child=children[i];if(child){child.moveBeforeDOMNode(node,parent);}
else{const anchor=anchors[i];nodeInsertBefore$3.call(parent,anchor,node);}}}
moveBeforeVNode(other,afterNode){if(other){const next=other.children[0];afterNode=(next?next.firstNode():other.anchors[0])||null;}
const children=this.children;const parent=this.parentEl;const anchors=this.anchors;for(let i=0,l=children.length;i<l;i++){let child=children[i];if(child){child.moveBeforeVNode(null,afterNode);}
else{const anchor=anchors[i];nodeInsertBefore$3.call(parent,anchor,afterNode);}}}
patch(other,withBeforeRemove){if(this===other){return;}
const children1=this.children;const children2=other.children;const anchors=this.anchors;const parentEl=this.parentEl;for(let i=0,l=children1.length;i<l;i++){const vn1=children1[i];const vn2=children2[i];if(vn1){if(vn2){vn1.patch(vn2,withBeforeRemove);}
else{const afterNode=vn1.firstNode();const anchor=document.createTextNode("");anchors[i]=anchor;nodeInsertBefore$3.call(parentEl,anchor,afterNode);if(withBeforeRemove){vn1.beforeRemove();}
vn1.remove();children1[i]=undefined;}}
else if(vn2){children1[i]=vn2;const anchor=anchors[i];vn2.mount(parentEl,anchor);nodeRemoveChild$3.call(parentEl,anchor);}}}
beforeRemove(){const children=this.children;for(let i=0,l=children.length;i<l;i++){const child=children[i];if(child){child.beforeRemove();}}}
remove(){const parentEl=this.parentEl;if(this.isOnlyChild){nodeSetTextContent$1.call(parentEl,"");}
else{const children=this.children;const anchors=this.anchors;for(let i=0,l=children.length;i<l;i++){const child=children[i];if(child){child.remove();}
else{nodeRemoveChild$3.call(parentEl,anchors[i]);}}}}
firstNode(){const child=this.children[0];return child?child.firstNode():this.anchors[0];}
toString(){return this.children.map((c)=>(c?c.toString():"")).join("");}}
function multi(children){return new VMulti(children);}
const getDescriptor$2=(o,p)=>Object.getOwnPropertyDescriptor(o,p);const nodeProto$3=Node.prototype;const characterDataProto$1=CharacterData.prototype;const nodeInsertBefore$2=nodeProto$3.insertBefore;const characterDataSetData$1=getDescriptor$2(characterDataProto$1,"data").set;const nodeRemoveChild$2=nodeProto$3.removeChild;class VSimpleNode{constructor(text){this.text=text;}
mountNode(node,parent,afterNode){this.parentEl=parent;nodeInsertBefore$2.call(parent,node,afterNode);this.el=node;}
moveBeforeDOMNode(node,parent=this.parentEl){this.parentEl=parent;nodeInsertBefore$2.call(parent,this.el,node);}
moveBeforeVNode(other,afterNode){nodeInsertBefore$2.call(this.parentEl,this.el,other?other.el:afterNode);}
beforeRemove(){}
remove(){nodeRemoveChild$2.call(this.parentEl,this.el);}
firstNode(){return this.el;}
toString(){return this.text;}}
class VText$1 extends VSimpleNode{mount(parent,afterNode){this.mountNode(document.createTextNode(toText(this.text)),parent,afterNode);}
patch(other){const text2=other.text;if(this.text!==text2){characterDataSetData$1.call(this.el,toText(text2));this.text=text2;}}}
class VComment extends VSimpleNode{mount(parent,afterNode){this.mountNode(document.createComment(toText(this.text)),parent,afterNode);}
patch(){}}
function text(str){return new VText$1(str);}
function comment(str){return new VComment(str);}
function toText(value){switch(typeof value){case"string":return value;case"number":return String(value);case"boolean":return value?"true":"false";default:return value||"";}}
const getDescriptor$1=(o,p)=>Object.getOwnPropertyDescriptor(o,p);const nodeProto$2=Node.prototype;const elementProto=Element.prototype;const characterDataProto=CharacterData.prototype;const characterDataSetData=getDescriptor$1(characterDataProto,"data").set;const nodeGetFirstChild=getDescriptor$1(nodeProto$2,"firstChild").get;const nodeGetNextSibling=getDescriptor$1(nodeProto$2,"nextSibling").get;const NO_OP=()=>{};function makePropSetter(name){return function setProp(value){this[name]=value===0?0:value?value.valueOf():"";};}
const cache$1={};function createBlock(str){if(str in cache$1){return cache$1[str];}
const doc=new DOMParser().parseFromString(`<t>${str}</t>`,"text/xml");const node=doc.firstChild.firstChild;if(config.shouldNormalizeDom){normalizeNode(node);}
const tree=buildTree(node);const context=buildContext(tree);const template=tree.el;const Block=buildBlock(template,context);cache$1[str]=Block;return Block;}
function normalizeNode(node){if(node.nodeType===Node.TEXT_NODE){if(!/\S/.test(node.textContent)){node.remove();return;}}
if(node.nodeType===Node.ELEMENT_NODE){if(node.tagName==="pre"){return;}}
for(let i=node.childNodes.length-1;i>=0;--i){normalizeNode(node.childNodes.item(i));}}
function buildTree(node,parent=null,domParentTree=null){switch(node.nodeType){case Node.ELEMENT_NODE:{let currentNS=domParentTree&&domParentTree.currentNS;const tagName=node.tagName;let el=undefined;const info=[];if(tagName.startsWith("block-text-")){const index=parseInt(tagName.slice(11),10);info.push({type:"text",idx:index});el=document.createTextNode("");}
if(tagName.startsWith("block-child-")){if(!domParentTree.isRef){addRef(domParentTree);}
const index=parseInt(tagName.slice(12),10);info.push({type:"child",idx:index});el=document.createTextNode("");}
currentNS||(currentNS=node.namespaceURI);if(!el){el=currentNS?document.createElementNS(currentNS,tagName):document.createElement(tagName);}
if(el instanceof Element){if(!domParentTree){const fragment=document.createElement("template").content;fragment.appendChild(el);}
const attrs=node.attributes;for(let i=0;i<attrs.length;i++){const attrName=attrs[i].name;const attrValue=attrs[i].value;if(attrName.startsWith("block-handler-")){const idx=parseInt(attrName.slice(14),10);info.push({type:"handler",idx,event:attrValue,});}
else if(attrName.startsWith("block-attribute-")){const idx=parseInt(attrName.slice(16),10);info.push({type:"attribute",idx,name:attrValue,tag:tagName,});}
else if(attrName.startsWith("block-property-")){const idx=parseInt(attrName.slice(15),10);info.push({type:"property",idx,name:attrValue,tag:tagName,});}
else if(attrName==="block-attributes"){info.push({type:"attributes",idx:parseInt(attrValue,10),});}
else if(attrName==="block-ref"){info.push({type:"ref",idx:parseInt(attrValue,10),});}
else{el.setAttribute(attrs[i].name,attrValue);}}}
const tree={parent,firstChild:null,nextSibling:null,el,info,refN:0,currentNS,};if(node.firstChild){const childNode=node.childNodes[0];if(node.childNodes.length===1&&childNode.nodeType===Node.ELEMENT_NODE&&childNode.tagName.startsWith("block-child-")){const tagName=childNode.tagName;const index=parseInt(tagName.slice(12),10);info.push({idx:index,type:"child",isOnlyChild:true});}
else{tree.firstChild=buildTree(node.firstChild,tree,tree);el.appendChild(tree.firstChild.el);let curNode=node.firstChild;let curTree=tree.firstChild;while((curNode=curNode.nextSibling)){curTree.nextSibling=buildTree(curNode,curTree,tree);el.appendChild(curTree.nextSibling.el);curTree=curTree.nextSibling;}}}
if(tree.info.length){addRef(tree);}
return tree;}
case Node.TEXT_NODE:case Node.COMMENT_NODE:{const el=node.nodeType===Node.TEXT_NODE?document.createTextNode(node.textContent):document.createComment(node.textContent);return{parent:parent,firstChild:null,nextSibling:null,el,info:[],refN:0,currentNS:null,};}}
throw new OwlError("boom");}
function addRef(tree){tree.isRef=true;do{tree.refN++;}while((tree=tree.parent));}
function parentTree(tree){let parent=tree.parent;while(parent&&parent.nextSibling===tree){tree=parent;parent=parent.parent;}
return parent;}
function buildContext(tree,ctx,fromIdx){if(!ctx){const children=new Array(tree.info.filter((v)=>v.type==="child").length);ctx={collectors:[],locations:[],children,cbRefs:[],refN:tree.refN,refList:[]};fromIdx=0;}
if(tree.refN){const initialIdx=fromIdx;const isRef=tree.isRef;const firstChild=tree.firstChild?tree.firstChild.refN:0;const nextSibling=tree.nextSibling?tree.nextSibling.refN:0;if(isRef){for(let info of tree.info){info.refIdx=initialIdx;}
tree.refIdx=initialIdx;updateCtx(ctx,tree);fromIdx++;}
if(nextSibling){const idx=fromIdx+firstChild;ctx.collectors.push({idx,prevIdx:initialIdx,getVal:nodeGetNextSibling});buildContext(tree.nextSibling,ctx,idx);}
if(firstChild){ctx.collectors.push({idx:fromIdx,prevIdx:initialIdx,getVal:nodeGetFirstChild});buildContext(tree.firstChild,ctx,fromIdx);}}
return ctx;}
function updateCtx(ctx,tree){for(let info of tree.info){switch(info.type){case"text":ctx.locations.push({idx:info.idx,refIdx:info.refIdx,setData:setText,updateData:setText,});break;case"child":if(info.isOnlyChild){ctx.children[info.idx]={parentRefIdx:info.refIdx,isOnlyChild:true,};}
else{ctx.children[info.idx]={parentRefIdx:parentTree(tree).refIdx,afterRefIdx:info.refIdx,};}
break;case"property":{const refIdx=info.refIdx;const setProp=makePropSetter(info.name);ctx.locations.push({idx:info.idx,refIdx,setData:setProp,updateData:setProp,});break;}
case"attribute":{const refIdx=info.refIdx;let updater;let setter;if(info.name==="class"){setter=setClass;updater=updateClass;}
else{setter=createAttrUpdater(info.name);updater=setter;}
ctx.locations.push({idx:info.idx,refIdx,setData:setter,updateData:updater,});break;}
case"attributes":ctx.locations.push({idx:info.idx,refIdx:info.refIdx,setData:attrsSetter,updateData:attrsUpdater,});break;case"handler":{const{setup,update}=createEventHandler(info.event);ctx.locations.push({idx:info.idx,refIdx:info.refIdx,setData:setup,updateData:update,});break;}
case"ref":const index=ctx.cbRefs.push(info.idx)-1;ctx.locations.push({idx:info.idx,refIdx:info.refIdx,setData:makeRefSetter(index,ctx.refList),updateData:NO_OP,});}}}
function buildBlock(template,ctx){let B=createBlockClass(template,ctx);if(ctx.cbRefs.length){const cbRefs=ctx.cbRefs;const refList=ctx.refList;let cbRefsNumber=cbRefs.length;B=class extends B{mount(parent,afterNode){refList.push(new Array(cbRefsNumber));super.mount(parent,afterNode);for(let cbRef of refList.pop()){cbRef();}}
remove(){super.remove();for(let cbRef of cbRefs){let fn=this.data[cbRef];fn(null);}}};}
if(ctx.children.length){B=class extends B{constructor(data,children){super(data);this.children=children;}};B.prototype.beforeRemove=VMulti.prototype.beforeRemove;return(data,children=[])=>new B(data,children);}
return(data)=>new B(data);}
function createBlockClass(template,ctx){const{refN,collectors,children}=ctx;const colN=collectors.length;ctx.locations.sort((a,b)=>a.idx-b.idx);const locations=ctx.locations.map((loc)=>({refIdx:loc.refIdx,setData:loc.setData,updateData:loc.updateData,}));const locN=locations.length;const childN=children.length;const childrenLocs=children;const isDynamic=refN>0;const nodeCloneNode=nodeProto$2.cloneNode;const nodeInsertBefore=nodeProto$2.insertBefore;const elementRemove=elementProto.remove;class Block{constructor(data){this.data=data;}
beforeRemove(){}
remove(){elementRemove.call(this.el);}
firstNode(){return this.el;}
moveBeforeDOMNode(node,parent=this.parentEl){this.parentEl=parent;nodeInsertBefore.call(parent,this.el,node);}
moveBeforeVNode(other,afterNode){nodeInsertBefore.call(this.parentEl,this.el,other?other.el:afterNode);}
toString(){const div=document.createElement("div");this.mount(div,null);return div.innerHTML;}
mount(parent,afterNode){const el=nodeCloneNode.call(template,true);nodeInsertBefore.call(parent,el,afterNode);this.el=el;this.parentEl=parent;}
patch(other,withBeforeRemove){}}
if(isDynamic){Block.prototype.mount=function mount(parent,afterNode){const el=nodeCloneNode.call(template,true);const refs=new Array(refN);this.refs=refs;refs[0]=el;for(let i=0;i<colN;i++){const w=collectors[i];refs[w.idx]=w.getVal.call(refs[w.prevIdx]);}
if(locN){const data=this.data;for(let i=0;i<locN;i++){const loc=locations[i];loc.setData.call(refs[loc.refIdx],data[i]);}}
nodeInsertBefore.call(parent,el,afterNode);if(childN){const children=this.children;for(let i=0;i<childN;i++){const child=children[i];if(child){const loc=childrenLocs[i];const afterNode=loc.afterRefIdx?refs[loc.afterRefIdx]:null;child.isOnlyChild=loc.isOnlyChild;child.mount(refs[loc.parentRefIdx],afterNode);}}}
this.el=el;this.parentEl=parent;};Block.prototype.patch=function patch(other,withBeforeRemove){if(this===other){return;}
const refs=this.refs;if(locN){const data1=this.data;const data2=other.data;for(let i=0;i<locN;i++){const val1=data1[i];const val2=data2[i];if(val1!==val2){const loc=locations[i];loc.updateData.call(refs[loc.refIdx],val2,val1);}}
this.data=data2;}
if(childN){let children1=this.children;const children2=other.children;for(let i=0;i<childN;i++){const child1=children1[i];const child2=children2[i];if(child1){if(child2){child1.patch(child2,withBeforeRemove);}
else{if(withBeforeRemove){child1.beforeRemove();}
child1.remove();children1[i]=undefined;}}
else if(child2){const loc=childrenLocs[i];const afterNode=loc.afterRefIdx?refs[loc.afterRefIdx]:null;child2.mount(refs[loc.parentRefIdx],afterNode);children1[i]=child2;}}}};}
return Block;}
function setText(value){characterDataSetData.call(this,toText(value));}
function makeRefSetter(index,refs){return function setRef(fn){refs[refs.length-1][index]=()=>fn(this);};}
const getDescriptor=(o,p)=>Object.getOwnPropertyDescriptor(o,p);const nodeProto$1=Node.prototype;const nodeInsertBefore$1=nodeProto$1.insertBefore;const nodeAppendChild=nodeProto$1.appendChild;const nodeRemoveChild$1=nodeProto$1.removeChild;const nodeSetTextContent=getDescriptor(nodeProto$1,"textContent").set;class VList{constructor(children){this.children=children;}
mount(parent,afterNode){const children=this.children;const _anchor=document.createTextNode("");this.anchor=_anchor;nodeInsertBefore$1.call(parent,_anchor,afterNode);const l=children.length;if(l){const mount=children[0].mount;for(let i=0;i<l;i++){mount.call(children[i],parent,_anchor);}}
this.parentEl=parent;}
moveBeforeDOMNode(node,parent=this.parentEl){this.parentEl=parent;const children=this.children;for(let i=0,l=children.length;i<l;i++){children[i].moveBeforeDOMNode(node,parent);}
parent.insertBefore(this.anchor,node);}
moveBeforeVNode(other,afterNode){if(other){const next=other.children[0];afterNode=(next?next.firstNode():other.anchor)||null;}
const children=this.children;for(let i=0,l=children.length;i<l;i++){children[i].moveBeforeVNode(null,afterNode);}
this.parentEl.insertBefore(this.anchor,afterNode);}
patch(other,withBeforeRemove){if(this===other){return;}
const ch1=this.children;const ch2=other.children;if(ch2.length===0&&ch1.length===0){return;}
this.children=ch2;const proto=ch2[0]||ch1[0];const{mount:cMount,patch:cPatch,remove:cRemove,beforeRemove,moveBeforeVNode:cMoveBefore,firstNode:cFirstNode,}=proto;const _anchor=this.anchor;const isOnlyChild=this.isOnlyChild;const parent=this.parentEl;if(ch2.length===0&&isOnlyChild){if(withBeforeRemove){for(let i=0,l=ch1.length;i<l;i++){beforeRemove.call(ch1[i]);}}
nodeSetTextContent.call(parent,"");nodeAppendChild.call(parent,_anchor);return;}
let startIdx1=0;let startIdx2=0;let startVn1=ch1[0];let startVn2=ch2[0];let endIdx1=ch1.length-1;let endIdx2=ch2.length-1;let endVn1=ch1[endIdx1];let endVn2=ch2[endIdx2];let mapping=undefined;while(startIdx1<=endIdx1&&startIdx2<=endIdx2){if(startVn1===null){startVn1=ch1[++startIdx1];continue;}
if(endVn1===null){endVn1=ch1[--endIdx1];continue;}
let startKey1=startVn1.key;let startKey2=startVn2.key;if(startKey1===startKey2){cPatch.call(startVn1,startVn2,withBeforeRemove);ch2[startIdx2]=startVn1;startVn1=ch1[++startIdx1];startVn2=ch2[++startIdx2];continue;}
let endKey1=endVn1.key;let endKey2=endVn2.key;if(endKey1===endKey2){cPatch.call(endVn1,endVn2,withBeforeRemove);ch2[endIdx2]=endVn1;endVn1=ch1[--endIdx1];endVn2=ch2[--endIdx2];continue;}
if(startKey1===endKey2){cPatch.call(startVn1,endVn2,withBeforeRemove);ch2[endIdx2]=startVn1;const nextChild=ch2[endIdx2+1];cMoveBefore.call(startVn1,nextChild,_anchor);startVn1=ch1[++startIdx1];endVn2=ch2[--endIdx2];continue;}
if(endKey1===startKey2){cPatch.call(endVn1,startVn2,withBeforeRemove);ch2[startIdx2]=endVn1;const nextChild=ch1[startIdx1];cMoveBefore.call(endVn1,nextChild,_anchor);endVn1=ch1[--endIdx1];startVn2=ch2[++startIdx2];continue;}
mapping=mapping||createMapping(ch1,startIdx1,endIdx1);let idxInOld=mapping[startKey2];if(idxInOld===undefined){cMount.call(startVn2,parent,cFirstNode.call(startVn1)||null);}
else{const elmToMove=ch1[idxInOld];cMoveBefore.call(elmToMove,startVn1,null);cPatch.call(elmToMove,startVn2,withBeforeRemove);ch2[startIdx2]=elmToMove;ch1[idxInOld]=null;}
startVn2=ch2[++startIdx2];}
if(startIdx1<=endIdx1||startIdx2<=endIdx2){if(startIdx1>endIdx1){const nextChild=ch2[endIdx2+1];const anchor=nextChild?cFirstNode.call(nextChild)||null:_anchor;for(let i=startIdx2;i<=endIdx2;i++){cMount.call(ch2[i],parent,anchor);}}
else{for(let i=startIdx1;i<=endIdx1;i++){let ch=ch1[i];if(ch){if(withBeforeRemove){beforeRemove.call(ch);}
cRemove.call(ch);}}}}}
beforeRemove(){const children=this.children;const l=children.length;if(l){const beforeRemove=children[0].beforeRemove;for(let i=0;i<l;i++){beforeRemove.call(children[i]);}}}
remove(){const{parentEl,anchor}=this;if(this.isOnlyChild){nodeSetTextContent.call(parentEl,"");}
else{const children=this.children;const l=children.length;if(l){const remove=children[0].remove;for(let i=0;i<l;i++){remove.call(children[i]);}}
nodeRemoveChild$1.call(parentEl,anchor);}}
firstNode(){const child=this.children[0];return child?child.firstNode():undefined;}
toString(){return this.children.map((c)=>c.toString()).join("");}}
function list(children){return new VList(children);}
function createMapping(ch1,startIdx1,endIdx2){let mapping={};for(let i=startIdx1;i<=endIdx2;i++){mapping[ch1[i].key]=i;}
return mapping;}
const nodeProto=Node.prototype;const nodeInsertBefore=nodeProto.insertBefore;const nodeRemoveChild=nodeProto.removeChild;class VHtml{constructor(html){this.content=[];this.html=html;}
mount(parent,afterNode){this.parentEl=parent;const template=document.createElement("template");template.innerHTML=this.html;this.content=[...template.content.childNodes];for(let elem of this.content){nodeInsertBefore.call(parent,elem,afterNode);}
if(!this.content.length){const textNode=document.createTextNode("");this.content.push(textNode);nodeInsertBefore.call(parent,textNode,afterNode);}}
moveBeforeDOMNode(node,parent=this.parentEl){this.parentEl=parent;for(let elem of this.content){nodeInsertBefore.call(parent,elem,node);}}
moveBeforeVNode(other,afterNode){const target=other?other.content[0]:afterNode;this.moveBeforeDOMNode(target);}
patch(other){if(this===other){return;}
const html2=other.html;if(this.html!==html2){const parent=this.parentEl;const afterNode=this.content[0];const template=document.createElement("template");template.innerHTML=html2;const content=[...template.content.childNodes];for(let elem of content){nodeInsertBefore.call(parent,elem,afterNode);}
if(!content.length){const textNode=document.createTextNode("");content.push(textNode);nodeInsertBefore.call(parent,textNode,afterNode);}
this.remove();this.content=content;this.html=other.html;}}
beforeRemove(){}
remove(){const parent=this.parentEl;for(let elem of this.content){nodeRemoveChild.call(parent,elem);}}
firstNode(){return this.content[0];}
toString(){return this.html;}}
function html(str){return new VHtml(str);}
function createCatcher(eventsSpec){const n=Object.keys(eventsSpec).length;class VCatcher{constructor(child,handlers){this.handlerFns=[];this.afterNode=null;this.child=child;this.handlerData=handlers;}
mount(parent,afterNode){this.parentEl=parent;this.child.mount(parent,afterNode);this.afterNode=document.createTextNode("");parent.insertBefore(this.afterNode,afterNode);this.wrapHandlerData();for(let name in eventsSpec){const index=eventsSpec[name];const handler=createEventHandler(name);this.handlerFns[index]=handler;handler.setup.call(parent,this.handlerData[index]);}}
wrapHandlerData(){for(let i=0;i<n;i++){let handler=this.handlerData[i];let idx=handler.length-2;let origFn=handler[idx];const self=this;handler[idx]=function(ev){const target=ev.target;let currentNode=self.child.firstNode();const afterNode=self.afterNode;while(currentNode&&currentNode!==afterNode){if(currentNode.contains(target)){return origFn.call(this,ev);}
currentNode=currentNode.nextSibling;}};}}
moveBeforeDOMNode(node,parent=this.parentEl){this.parentEl=parent;this.child.moveBeforeDOMNode(node,parent);parent.insertBefore(this.afterNode,node);}
moveBeforeVNode(other,afterNode){if(other){afterNode=other.firstNode()||afterNode;}
this.child.moveBeforeVNode(other?other.child:null,afterNode);this.parentEl.insertBefore(this.afterNode,afterNode);}
patch(other,withBeforeRemove){if(this===other){return;}
this.handlerData=other.handlerData;this.wrapHandlerData();for(let i=0;i<n;i++){this.handlerFns[i].update.call(this.parentEl,this.handlerData[i]);}
this.child.patch(other.child,withBeforeRemove);}
beforeRemove(){this.child.beforeRemove();}
remove(){for(let i=0;i<n;i++){this.handlerFns[i].remove.call(this.parentEl);}
this.child.remove();this.afterNode.remove();}
firstNode(){return this.child.firstNode();}
toString(){return this.child.toString();}}
return function(child,handlers){return new VCatcher(child,handlers);};}
function mount$1(vnode,fixture,afterNode=null){vnode.mount(fixture,afterNode);}
function patch(vnode1,vnode2,withBeforeRemove=false){vnode1.patch(vnode2,withBeforeRemove);}
function remove(vnode,withBeforeRemove=false){if(withBeforeRemove){vnode.beforeRemove();}
vnode.remove();}
const fibersInError=new WeakMap();const nodeErrorHandlers=new WeakMap();function _handleError(node,error){if(!node){return false;}
const fiber=node.fiber;if(fiber){fibersInError.set(fiber,error);}
const errorHandlers=nodeErrorHandlers.get(node);if(errorHandlers){let handled=false;for(let i=errorHandlers.length-1;i>=0;i--){try{errorHandlers[i](error);handled=true;break;}
catch(e){error=e;}}
if(handled){return true;}}
return _handleError(node.parent,error);}
function handleError(params){let{error}=params;if(!(error instanceof OwlError)){error=Object.assign(new OwlError(`An error occured in the owl lifecycle (see this Error's "cause" property)`),{cause:error});}
const node="node"in params?params.node:params.fiber.node;const fiber="fiber"in params?params.fiber:node.fiber;if(fiber){let current=fiber;do{current.node.fiber=current;current=current.parent;}while(current);fibersInError.set(fiber.root,error);}
const handled=_handleError(node,error);if(!handled){console.warn(`[Owl] Unhandled error. Destroying the root component`);try{node.app.destroy();}
catch(e){console.error(e);}
throw error;}}
function makeChildFiber(node,parent){let current=node.fiber;if(current){cancelFibers(current.children);current.root=null;}
return new Fiber(node,parent);}
function makeRootFiber(node){let current=node.fiber;if(current){let root=current.root;root.locked=true;root.setCounter(root.counter+1-cancelFibers(current.children));root.locked=false;current.children=[];current.childrenMap={};current.bdom=null;if(fibersInError.has(current)){fibersInError.delete(current);fibersInError.delete(root);current.appliedToDom=false;if(current instanceof RootFiber){current.mounted=current instanceof MountFiber?[current]:[];}}
return current;}
const fiber=new RootFiber(node,null);if(node.willPatch.length){fiber.willPatch.push(fiber);}
if(node.patched.length){fiber.patched.push(fiber);}
return fiber;}
function throwOnRender(){throw new OwlError("Attempted to render cancelled fiber");}
function cancelFibers(fibers){let result=0;for(let fiber of fibers){let node=fiber.node;fiber.render=throwOnRender;if(node.status===0){node.cancel();}
node.fiber=null;if(fiber.bdom){node.forceNextRender=true;}
else{result++;}
result+=cancelFibers(fiber.children);}
return result;}
class Fiber{constructor(node,parent){this.bdom=null;this.children=[];this.appliedToDom=false;this.deep=false;this.childrenMap={};this.node=node;this.parent=parent;if(parent){this.deep=parent.deep;const root=parent.root;root.setCounter(root.counter+1);this.root=root;parent.children.push(this);}
else{this.root=this;}}
render(){let prev=this.root.node;let scheduler=prev.app.scheduler;let current=prev.parent;while(current){if(current.fiber){let root=current.fiber.root;if(root.counter===0&&prev.parentKey in current.fiber.childrenMap){current=root.node;}
else{scheduler.delayedRenders.push(this);return;}}
prev=current;current=current.parent;}
this._render();}
_render(){const node=this.node;const root=this.root;if(root){try{this.bdom=true;this.bdom=node.renderFn();}
catch(e){node.app.handleError({node,error:e});}
root.setCounter(root.counter-1);}}}
class RootFiber extends Fiber{constructor(){super(...arguments);this.counter=1;this.willPatch=[];this.patched=[];this.mounted=[];this.locked=false;}
complete(){const node=this.node;this.locked=true;let current=undefined;let mountedFibers=this.mounted;try{for(current of this.willPatch){let node=current.node;if(node.fiber===current){const component=node.component;for(let cb of node.willPatch){cb.call(component);}}}
current=undefined;node._patch();this.locked=false;while((current=mountedFibers.pop())){current=current;if(current.appliedToDom){for(let cb of current.node.mounted){cb();}}}
let patchedFibers=this.patched;while((current=patchedFibers.pop())){current=current;if(current.appliedToDom){for(let cb of current.node.patched){cb();}}}}
catch(e){for(let fiber of mountedFibers){fiber.node.willUnmount=[];}
this.locked=false;node.app.handleError({fiber:current||this,error:e});}}
setCounter(newValue){this.counter=newValue;if(newValue===0){this.node.app.scheduler.flush();}}}
class MountFiber extends RootFiber{constructor(node,target,options={}){super(node,null);this.target=target;this.position=options.position||"last-child";}
complete(){let current=this;try{const node=this.node;node.children=this.childrenMap;node.app.constructor.validateTarget(this.target);if(node.bdom){node.updateDom();}
else{node.bdom=this.bdom;if(this.position==="last-child"||this.target.childNodes.length===0){mount$1(node.bdom,this.target);}
else{const firstChild=this.target.childNodes[0];mount$1(node.bdom,this.target,firstChild);}}
node.fiber=null;node.status=1;this.appliedToDom=true;let mountedFibers=this.mounted;while((current=mountedFibers.pop())){if(current.appliedToDom){for(let cb of current.node.mounted){cb();}}}}
catch(e){this.node.app.handleError({fiber:current,error:e});}}}
const KEYCHANGES=Symbol("Key changes");const NO_CALLBACK=()=>{throw new Error("Called NO_CALLBACK. Owl is broken, please report this to the maintainers.");};const objectToString=Object.prototype.toString;const objectHasOwnProperty=Object.prototype.hasOwnProperty;const SUPPORTED_RAW_TYPES=["Object","Array","Set","Map","WeakMap"];const COLLECTION_RAW_TYPES=["Set","Map","WeakMap"];function rawType(obj){return objectToString.call(toRaw(obj)).slice(8,-1);}
function canBeMadeReactive(value){if(typeof value!=="object"){return false;}
return SUPPORTED_RAW_TYPES.includes(rawType(value));}
function possiblyReactive(val,cb){return canBeMadeReactive(val)?reactive(val,cb):val;}
const skipped=new WeakSet();function markRaw(value){skipped.add(value);return value;}
function toRaw(value){return targets.has(value)?targets.get(value):value;}
const targetToKeysToCallbacks=new WeakMap();function observeTargetKey(target,key,callback){if(callback===NO_CALLBACK){return;}
if(!targetToKeysToCallbacks.get(target)){targetToKeysToCallbacks.set(target,new Map());}
const keyToCallbacks=targetToKeysToCallbacks.get(target);if(!keyToCallbacks.get(key)){keyToCallbacks.set(key,new Set());}
keyToCallbacks.get(key).add(callback);if(!callbacksToTargets.has(callback)){callbacksToTargets.set(callback,new Set());}
callbacksToTargets.get(callback).add(target);}
function notifyReactives(target,key){const keyToCallbacks=targetToKeysToCallbacks.get(target);if(!keyToCallbacks){return;}
const callbacks=keyToCallbacks.get(key);if(!callbacks){return;}
for(const callback of[...callbacks]){clearReactivesForCallback(callback);callback();}}
const callbacksToTargets=new WeakMap();function clearReactivesForCallback(callback){const targetsToClear=callbacksToTargets.get(callback);if(!targetsToClear){return;}
for(const target of targetsToClear){const observedKeys=targetToKeysToCallbacks.get(target);if(!observedKeys){continue;}
for(const[key,callbacks]of observedKeys.entries()){callbacks.delete(callback);if(!callbacks.size){observedKeys.delete(key);}}}
targetsToClear.clear();}
function getSubscriptions(callback){const targets=callbacksToTargets.get(callback)||[];return[...targets].map((target)=>{const keysToCallbacks=targetToKeysToCallbacks.get(target);let keys=[];if(keysToCallbacks){for(const[key,cbs]of keysToCallbacks){if(cbs.has(callback)){keys.push(key);}}}
return{target,keys};});}
const targets=new WeakMap();const reactiveCache=new WeakMap();function reactive(target,callback=NO_CALLBACK){if(!canBeMadeReactive(target)){throw new OwlError(`Cannot make the given value reactive`);}
if(skipped.has(target)){return target;}
if(targets.has(target)){return reactive(targets.get(target),callback);}
if(!reactiveCache.has(target)){reactiveCache.set(target,new WeakMap());}
const reactivesForTarget=reactiveCache.get(target);if(!reactivesForTarget.has(callback)){const targetRawType=rawType(target);const handler=COLLECTION_RAW_TYPES.includes(targetRawType)?collectionsProxyHandler(target,callback,targetRawType):basicProxyHandler(callback);const proxy=new Proxy(target,handler);reactivesForTarget.set(callback,proxy);targets.set(proxy,target);}
return reactivesForTarget.get(callback);}
function basicProxyHandler(callback){return{get(target,key,receiver){const desc=Object.getOwnPropertyDescriptor(target,key);if(desc&&!desc.writable&&!desc.configurable){return Reflect.get(target,key,receiver);}
observeTargetKey(target,key,callback);return possiblyReactive(Reflect.get(target,key,receiver),callback);},set(target,key,value,receiver){const hadKey=objectHasOwnProperty.call(target,key);const originalValue=Reflect.get(target,key,receiver);const ret=Reflect.set(target,key,toRaw(value),receiver);if(!hadKey&&objectHasOwnProperty.call(target,key)){notifyReactives(target,KEYCHANGES);}
if(originalValue!==Reflect.get(target,key,receiver)||(key==="length"&&Array.isArray(target))){notifyReactives(target,key);}
return ret;},deleteProperty(target,key){const ret=Reflect.deleteProperty(target,key);notifyReactives(target,KEYCHANGES);notifyReactives(target,key);return ret;},ownKeys(target){observeTargetKey(target,KEYCHANGES,callback);return Reflect.ownKeys(target);},has(target,key){observeTargetKey(target,KEYCHANGES,callback);return Reflect.has(target,key);},};}
function makeKeyObserver(methodName,target,callback){return(key)=>{key=toRaw(key);observeTargetKey(target,key,callback);return possiblyReactive(target[methodName](key),callback);};}
function makeIteratorObserver(methodName,target,callback){return function*(){observeTargetKey(target,KEYCHANGES,callback);const keys=target.keys();for(const item of target[methodName]()){const key=keys.next().value;observeTargetKey(target,key,callback);yield possiblyReactive(item,callback);}};}
function makeForEachObserver(target,callback){return function forEach(forEachCb,thisArg){observeTargetKey(target,KEYCHANGES,callback);target.forEach(function(val,key,targetObj){observeTargetKey(target,key,callback);forEachCb.call(thisArg,possiblyReactive(val,callback),possiblyReactive(key,callback),possiblyReactive(targetObj,callback));},thisArg);};}
function delegateAndNotify(setterName,getterName,target){return(key,value)=>{key=toRaw(key);const hadKey=target.has(key);const originalValue=target[getterName](key);const ret=target[setterName](key,value);const hasKey=target.has(key);if(hadKey!==hasKey){notifyReactives(target,KEYCHANGES);}
if(originalValue!==target[getterName](key)){notifyReactives(target,key);}
return ret;};}
function makeClearNotifier(target){return()=>{const allKeys=[...target.keys()];target.clear();notifyReactives(target,KEYCHANGES);for(const key of allKeys){notifyReactives(target,key);}};}
const rawTypeToFuncHandlers={Set:(target,callback)=>({has:makeKeyObserver("has",target,callback),add:delegateAndNotify("add","has",target),delete:delegateAndNotify("delete","has",target),keys:makeIteratorObserver("keys",target,callback),values:makeIteratorObserver("values",target,callback),entries:makeIteratorObserver("entries",target,callback),[Symbol.iterator]:makeIteratorObserver(Symbol.iterator,target,callback),forEach:makeForEachObserver(target,callback),clear:makeClearNotifier(target),get size(){observeTargetKey(target,KEYCHANGES,callback);return target.size;},}),Map:(target,callback)=>({has:makeKeyObserver("has",target,callback),get:makeKeyObserver("get",target,callback),set:delegateAndNotify("set","get",target),delete:delegateAndNotify("delete","has",target),keys:makeIteratorObserver("keys",target,callback),values:makeIteratorObserver("values",target,callback),entries:makeIteratorObserver("entries",target,callback),[Symbol.iterator]:makeIteratorObserver(Symbol.iterator,target,callback),forEach:makeForEachObserver(target,callback),clear:makeClearNotifier(target),get size(){observeTargetKey(target,KEYCHANGES,callback);return target.size;},}),WeakMap:(target,callback)=>({has:makeKeyObserver("has",target,callback),get:makeKeyObserver("get",target,callback),set:delegateAndNotify("set","get",target),delete:delegateAndNotify("delete","has",target),}),};function collectionsProxyHandler(target,callback,targetRawType){const specialHandlers=rawTypeToFuncHandlers[targetRawType](target,callback);return Object.assign(basicProxyHandler(callback),{get(target,key){if(objectHasOwnProperty.call(specialHandlers,key)){return specialHandlers[key];}
observeTargetKey(target,key,callback);return possiblyReactive(target[key],callback);},});}
let currentNode=null;function saveCurrent(){let n=currentNode;return()=>{currentNode=n;};}
function getCurrent(){if(!currentNode){throw new OwlError("No active component (a hook function should only be called in 'setup')");}
return currentNode;}
function useComponent(){return currentNode.component;}
function applyDefaultProps(props,defaultProps){for(let propName in defaultProps){if(props[propName]===undefined){props[propName]=defaultProps[propName];}}}
const batchedRenderFunctions=new WeakMap();function useState(state){const node=getCurrent();let render=batchedRenderFunctions.get(node);if(!render){render=batched(node.render.bind(node,false));batchedRenderFunctions.set(node,render);node.willDestroy.push(clearReactivesForCallback.bind(null,render));}
return reactive(state,render);}
class ComponentNode{constructor(C,props,app,parent,parentKey){this.fiber=null;this.bdom=null;this.status=0;this.forceNextRender=false;this.nextProps=null;this.children=Object.create(null);this.refs={};this.willStart=[];this.willUpdateProps=[];this.willUnmount=[];this.mounted=[];this.willPatch=[];this.patched=[];this.willDestroy=[];currentNode=this;this.app=app;this.parent=parent;this.props=props;this.parentKey=parentKey;const defaultProps=C.defaultProps;props=Object.assign({},props);if(defaultProps){applyDefaultProps(props,defaultProps);}
const env=(parent&&parent.childEnv)||app.env;this.childEnv=env;for(const key in props){const prop=props[key];if(prop&&typeof prop==="object"&&targets.has(prop)){props[key]=useState(prop);}}
this.component=new C(props,env,this);const ctx=Object.assign(Object.create(this.component),{this:this.component});this.renderFn=app.getTemplate(C.template).bind(this.component,ctx,this);this.component.setup();currentNode=null;}
mountComponent(target,options){const fiber=new MountFiber(this,target,options);this.app.scheduler.addFiber(fiber);this.initiateRender(fiber);}
async initiateRender(fiber){this.fiber=fiber;if(this.mounted.length){fiber.root.mounted.push(fiber);}
const component=this.component;try{await Promise.all(this.willStart.map((f)=>f.call(component)));}
catch(e){this.app.handleError({node:this,error:e});return;}
if(this.status===0&&this.fiber===fiber){fiber.render();}}
async render(deep){if(this.status>=2){return;}
let current=this.fiber;if(current&&(current.root.locked||current.bdom===true)){await Promise.resolve();current=this.fiber;}
if(current){if(!current.bdom&&!fibersInError.has(current)){if(deep){current.deep=deep;}
return;}
deep=deep||current.deep;}
else if(!this.bdom){return;}
const fiber=makeRootFiber(this);fiber.deep=deep;this.fiber=fiber;this.app.scheduler.addFiber(fiber);await Promise.resolve();if(this.status>=2){return;}
if(this.fiber===fiber&&(current||!fiber.parent)){fiber.render();}}
cancel(){this._cancel();delete this.parent.children[this.parentKey];this.app.scheduler.scheduleDestroy(this);}
_cancel(){this.status=2;const children=this.children;for(let childKey in children){children[childKey]._cancel();}}
destroy(){let shouldRemove=this.status===1;this._destroy();if(shouldRemove){this.bdom.remove();}}
_destroy(){const component=this.component;if(this.status===1){for(let cb of this.willUnmount){cb.call(component);}}
for(let child of Object.values(this.children)){child._destroy();}
if(this.willDestroy.length){try{for(let cb of this.willDestroy){cb.call(component);}}
catch(e){this.app.handleError({error:e,node:this});}}
this.status=3;}
async updateAndRender(props,parentFiber){this.nextProps=props;props=Object.assign({},props);const fiber=makeChildFiber(this,parentFiber);this.fiber=fiber;const component=this.component;const defaultProps=component.constructor.defaultProps;if(defaultProps){applyDefaultProps(props,defaultProps);}
currentNode=this;for(const key in props){const prop=props[key];if(prop&&typeof prop==="object"&&targets.has(prop)){props[key]=useState(prop);}}
currentNode=null;const prom=Promise.all(this.willUpdateProps.map((f)=>f.call(component,props)));await prom;if(fiber!==this.fiber){return;}
component.props=props;fiber.render();const parentRoot=parentFiber.root;if(this.willPatch.length){parentRoot.willPatch.push(fiber);}
if(this.patched.length){parentRoot.patched.push(fiber);}}
updateDom(){if(!this.fiber){return;}
if(this.bdom===this.fiber.bdom){for(let k in this.children){const child=this.children[k];child.updateDom();}}
else{this.bdom.patch(this.fiber.bdom,false);this.fiber.appliedToDom=true;this.fiber=null;}}
setRef(name,el){if(el){this.refs[name]=el;}}
firstNode(){const bdom=this.bdom;return bdom?bdom.firstNode():undefined;}
mount(parent,anchor){const bdom=this.fiber.bdom;this.bdom=bdom;bdom.mount(parent,anchor);this.status=1;this.fiber.appliedToDom=true;this.children=this.fiber.childrenMap;this.fiber=null;}
moveBeforeDOMNode(node,parent){this.bdom.moveBeforeDOMNode(node,parent);}
moveBeforeVNode(other,afterNode){this.bdom.moveBeforeVNode(other?other.bdom:null,afterNode);}
patch(){if(this.fiber&&this.fiber.parent){this._patch();this.props=this.nextProps;}}
_patch(){let hasChildren=false;for(let _k in this.children){hasChildren=true;break;}
const fiber=this.fiber;this.children=fiber.childrenMap;this.bdom.patch(fiber.bdom,hasChildren);fiber.appliedToDom=true;this.fiber=null;}
beforeRemove(){this._destroy();}
remove(){this.bdom.remove();}
get name(){return this.component.constructor.name;}
get subscriptions(){const render=batchedRenderFunctions.get(this);return render?getSubscriptions(render):[];}}
const TIMEOUT=Symbol("timeout");const HOOK_TIMEOUT={onWillStart:3000,onWillUpdateProps:3000,};function wrapError(fn,hookName){const error=new OwlError();const timeoutError=new OwlError();const node=getCurrent();return(...args)=>{const onError=(cause)=>{error.cause=cause;error.message=cause instanceof Error?`The following error occurred in ${hookName}: "${cause.message}"`:`Something that is not an Error was thrown in ${hookName} (see this Error's "cause" property)`;throw error;};let result;try{result=fn(...args);}
catch(cause){onError(cause);}
if(!(result instanceof Promise)){return result;}
const timeout=HOOK_TIMEOUT[hookName];if(timeout){const fiber=node.fiber;Promise.race([result.catch(()=>{}),new Promise((resolve)=>setTimeout(()=>resolve(TIMEOUT),timeout)),]).then((res)=>{if(res===TIMEOUT&&node.fiber===fiber&&node.status<=2){timeoutError.message=`${hookName}'s promise hasn't resolved after ${timeout / 1000} seconds`;console.log(timeoutError);}});}
return result.catch(onError);};}
function onWillStart(fn){const node=getCurrent();const decorate=node.app.dev?wrapError:(fn)=>fn;node.willStart.push(decorate(fn.bind(node.component),"onWillStart"));}
function onWillUpdateProps(fn){const node=getCurrent();const decorate=node.app.dev?wrapError:(fn)=>fn;node.willUpdateProps.push(decorate(fn.bind(node.component),"onWillUpdateProps"));}
function onMounted(fn){const node=getCurrent();const decorate=node.app.dev?wrapError:(fn)=>fn;node.mounted.push(decorate(fn.bind(node.component),"onMounted"));}
function onWillPatch(fn){const node=getCurrent();const decorate=node.app.dev?wrapError:(fn)=>fn;node.willPatch.unshift(decorate(fn.bind(node.component),"onWillPatch"));}
function onPatched(fn){const node=getCurrent();const decorate=node.app.dev?wrapError:(fn)=>fn;node.patched.push(decorate(fn.bind(node.component),"onPatched"));}
function onWillUnmount(fn){const node=getCurrent();const decorate=node.app.dev?wrapError:(fn)=>fn;node.willUnmount.unshift(decorate(fn.bind(node.component),"onWillUnmount"));}
function onWillDestroy(fn){const node=getCurrent();const decorate=node.app.dev?wrapError:(fn)=>fn;node.willDestroy.push(decorate(fn.bind(node.component),"onWillDestroy"));}
function onWillRender(fn){const node=getCurrent();const renderFn=node.renderFn;const decorate=node.app.dev?wrapError:(fn)=>fn;fn=decorate(fn.bind(node.component),"onWillRender");node.renderFn=()=>{fn();return renderFn();};}
function onRendered(fn){const node=getCurrent();const renderFn=node.renderFn;const decorate=node.app.dev?wrapError:(fn)=>fn;fn=decorate(fn.bind(node.component),"onRendered");node.renderFn=()=>{const result=renderFn();fn();return result;};}
function onError(callback){const node=getCurrent();let handlers=nodeErrorHandlers.get(node);if(!handlers){handlers=[];nodeErrorHandlers.set(node,handlers);}
handlers.push(callback.bind(node.component));}
class Component{constructor(props,env,node){this.props=props;this.env=env;this.__owl__=node;}
setup(){}
render(deep=false){this.__owl__.render(deep===true);}}
Component.template="";const VText=text("").constructor;class VPortal extends VText{constructor(selector,content){super("");this.target=null;this.selector=selector;this.content=content;}
mount(parent,anchor){super.mount(parent,anchor);this.target=document.querySelector(this.selector);if(this.target){this.content.mount(this.target,null);}
else{this.content.mount(parent,anchor);}}
beforeRemove(){this.content.beforeRemove();}
remove(){if(this.content){super.remove();this.content.remove();this.content=null;}}
patch(other){super.patch(other);if(this.content){this.content.patch(other.content,true);}
else{this.content=other.content;this.content.mount(this.target,null);}}}
function portalTemplate(app,bdom,helpers){let{callSlot}=helpers;return function template(ctx,node,key=""){return new VPortal(ctx.props.target,callSlot(ctx,node,key,"default",false,null));};}
class Portal extends Component{setup(){const node=this.__owl__;onMounted(()=>{const portal=node.bdom;if(!portal.target){const target=document.querySelector(this.props.target);if(target){portal.content.moveBeforeDOMNode(target.firstChild,target);}
else{throw new OwlError("invalid portal target");}}});onWillUnmount(()=>{const portal=node.bdom;portal.remove();});}}
Portal.template="__portal__";Portal.props={target:{type:String,},slots:true,};const isUnionType=(t)=>Array.isArray(t);const isBaseType=(t)=>typeof t!=="object";const isValueType=(t)=>typeof t==="object"&&t&&"value"in t;function isOptional(t){return typeof t==="object"&&"optional"in t?t.optional||false:false;}
function describeType(type){return type==="*"||type===true?"value":type.name.toLowerCase();}
function describe(info){if(isBaseType(info)){return describeType(info);}
else if(isUnionType(info)){return info.map(describe).join(" or ");}
else if(isValueType(info)){return String(info.value);}
if("element"in info){return`list of ${describe({ type: info.element, optional: false })}s`;}
if("shape"in info){return`object`;}
return describe(info.type||"*");}
function toSchema(spec){return Object.fromEntries(spec.map((e)=>e.endsWith("?")?[e.slice(0,-1),{optional:true}]:[e,{type:"*",optional:false}]));}
function validate(obj,spec){let errors=validateSchema(obj,spec);if(errors.length){throw new OwlError("Invalid object: "+errors.join(", "));}}
function validateSchema(obj,schema){if(Array.isArray(schema)){schema=toSchema(schema);}
obj=toRaw(obj);let errors=[];for(let key in obj){if(key in schema){let result=validateType(key,obj[key],schema[key]);if(result){errors.push(result);}}
else if(!("*"in schema)){errors.push(`unknown key '${key}'`);}}
for(let key in schema){const spec=schema[key];if(key!=="*"&&!isOptional(spec)&&!(key in obj)){const isObj=typeof spec==="object"&&!Array.isArray(spec);const isAny=spec==="*"||(isObj&&"type"in spec?spec.type==="*":isObj);let detail=isAny?"":` (should be a ${describe(spec)})`;errors.push(`'${key}' is missing${detail}`);}}
return errors;}
function validateBaseType(key,value,type){if(typeof type==="function"){if(typeof value==="object"){if(!(value instanceof type)){return`'${key}' is not a ${describeType(type)}`;}}
else if(typeof value!==type.name.toLowerCase()){return`'${key}' is not a ${describeType(type)}`;}}
return null;}
function validateArrayType(key,value,descr){if(!Array.isArray(value)){return`'${key}' is not a list of ${describe(descr)}s`;}
for(let i=0;i<value.length;i++){const error=validateType(`${key}[${i}]`,value[i],descr);if(error){return error;}}
return null;}
function validateType(key,value,descr){if(value===undefined){return isOptional(descr)?null:`'${key}' is undefined (should be a ${describe(descr)})`;}
else if(isBaseType(descr)){return validateBaseType(key,value,descr);}
else if(isValueType(descr)){return value===descr.value?null:`'${key}' is not equal to '${descr.value}'`;}
else if(isUnionType(descr)){let validDescr=descr.find((p)=>!validateType(key,value,p));return validDescr?null:`'${key}' is not a ${describe(descr)}`;}
let result=null;if("element"in descr){result=validateArrayType(key,value,descr.element);}
else if("shape"in descr){if(typeof value!=="object"||Array.isArray(value)){result=`'${key}' is not an object`;}
else{const errors=validateSchema(value,descr.shape);if(errors.length){result=`'${key}' doesn't have the correct shape (${errors.join(", ")})`;}}}
else if("values"in descr){if(typeof value!=="object"||Array.isArray(value)){result=`'${key}' is not an object`;}
else{const errors=Object.entries(value).map(([key,value])=>validateType(key,value,descr.values)).filter(Boolean);if(errors.length){result=`some of the values in '${key}' are invalid (${errors.join(", ")})`;}}}
if("type"in descr&&!result){result=validateType(key,value,descr.type);}
if("validate"in descr&&!result){result=!descr.validate(value)?`'${key}' is not valid`:null;}
return result;}
const ObjectCreate=Object.create;function withDefault(value,defaultValue){return value===undefined||value===null||value===false?defaultValue:value;}
function callSlot(ctx,parent,key,name,dynamic,extra,defaultContent){key=key+"__slot_"+name;const slots=ctx.props.slots||{};const{__render,__ctx,__scope}=slots[name]||{};const slotScope=ObjectCreate(__ctx||{});if(__scope){slotScope[__scope]=extra;}
const slotBDom=__render?__render(slotScope,parent,key):null;if(defaultContent){let child1=undefined;let child2=undefined;if(slotBDom){child1=dynamic?toggler(name,slotBDom):slotBDom;}
else{child2=defaultContent(ctx,parent,key);}
return multi([child1,child2]);}
return slotBDom||text("");}
function capture(ctx){const result=ObjectCreate(ctx);for(let k in ctx){result[k]=ctx[k];}
return result;}
function withKey(elem,k){elem.key=k;return elem;}
function prepareList(collection){let keys;let values;if(Array.isArray(collection)){keys=collection;values=collection;}
else if(collection instanceof Map){keys=[...collection.keys()];values=[...collection.values()];}
else if(Symbol.iterator in Object(collection)){keys=[...collection];values=keys;}
else if(collection&&typeof collection==="object"){values=Object.values(collection);keys=Object.keys(collection);}
else{throw new OwlError(`Invalid loop expression: "${collection}" is not iterable`);}
const n=values.length;return[keys,values,n,new Array(n)];}
const isBoundary=Symbol("isBoundary");function setContextValue(ctx,key,value){const ctx0=ctx;while(!ctx.hasOwnProperty(key)&&!ctx.hasOwnProperty(isBoundary)){const newCtx=ctx.__proto__;if(!newCtx){ctx=ctx0;break;}
ctx=newCtx;}
ctx[key]=value;}
function toNumber(val){const n=parseFloat(val);return isNaN(n)?val:n;}
function shallowEqual(l1,l2){for(let i=0,l=l1.length;i<l;i++){if(l1[i]!==l2[i]){return false;}}
return true;}
class LazyValue{constructor(fn,ctx,component,node,key){this.fn=fn;this.ctx=capture(ctx);this.component=component;this.node=node;this.key=key;}
evaluate(){return this.fn.call(this.component,this.ctx,this.node,this.key);}
toString(){return this.evaluate().toString();}}
function safeOutput(value,defaultValue){if(value===undefined||value===null){return defaultValue?toggler("default",defaultValue):toggler("undefined",text(""));}
let safeKey;let block;switch(typeof value){case"object":if(value instanceof Markup){safeKey=`string_safe`;block=html(value);}
else if(value instanceof LazyValue){safeKey=`lazy_value`;block=value.evaluate();}
else if(value instanceof String){safeKey="string_unsafe";block=text(value);}
else{safeKey="block_safe";block=value;}
break;case"string":safeKey="string_unsafe";block=text(value);break;default:safeKey="string_unsafe";block=text(String(value));}
return toggler(safeKey,block);}
function validateProps(name,props,comp){const ComponentClass=typeof name!=="string"?name:comp.constructor.components[name];if(!ComponentClass){return;}
const schema=ComponentClass.props;if(!schema){if(comp.__owl__.app.warnIfNoStaticProps){console.warn(`Component '${ComponentClass.name}' does not have a static props description`);}
return;}
const defaultProps=ComponentClass.defaultProps;if(defaultProps){let isMandatory=(name)=>Array.isArray(schema)?schema.includes(name):name in schema&&!("*"in schema)&&!isOptional(schema[name]);for(let p in defaultProps){if(isMandatory(p)){throw new OwlError(`A default value cannot be defined for a mandatory prop (name: '${p}', component: ${ComponentClass.name})`);}}}
const errors=validateSchema(props,schema);if(errors.length){throw new OwlError(`Invalid props for component '${ComponentClass.name}': `+errors.join(", "));}}
function makeRefWrapper(node){let refNames=new Set();return(name,fn)=>{if(refNames.has(name)){throw new OwlError(`Cannot set the same ref more than once in the same component, ref "${name}" was set multiple times in ${node.name}`);}
refNames.add(name);return fn;};}
const helpers={withDefault,zero:Symbol("zero"),isBoundary,callSlot,capture,withKey,prepareList,setContextValue,shallowEqual,toNumber,validateProps,LazyValue,safeOutput,createCatcher,markRaw,OwlError,makeRefWrapper,};function parseXML(xml){const parser=new DOMParser();const doc=parser.parseFromString(xml,"text/xml");if(doc.getElementsByTagName("parsererror").length){let msg="Invalid XML in template.";const parsererrorText=doc.getElementsByTagName("parsererror")[0].textContent;if(parsererrorText){msg+="\nThe parser has produced the following error message:\n"+parsererrorText;const re=/\d+/g;const firstMatch=re.exec(parsererrorText);if(firstMatch){const lineNumber=Number(firstMatch[0]);const line=xml.split("\n")[lineNumber-1];const secondMatch=re.exec(parsererrorText);if(line&&secondMatch){const columnIndex=Number(secondMatch[0])-1;if(line[columnIndex]){msg+=`\nThe error might be located at xml line ${lineNumber} column ${columnIndex}\n`+`${line}\n${"-".repeat(columnIndex - 1)}^`;}}}}
throw new OwlError(msg);}
return doc;}
const bdom={text,createBlock,list,multi,html,toggler,comment};class TemplateSet{constructor(config={}){this.rawTemplates=Object.create(globalTemplates);this.templates={};this.Portal=Portal;this.dev=config.dev||false;this.translateFn=config.translateFn;this.translatableAttributes=config.translatableAttributes;if(config.templates){if(config.templates instanceof Document||typeof config.templates==="string"){this.addTemplates(config.templates);}
else{for(const name in config.templates){this.addTemplate(name,config.templates[name]);}}}
this.getRawTemplate=config.getTemplate;this.customDirectives=config.customDirectives||{};this.runtimeUtils={...helpers,__globals__:config.globalValues||{}};this.hasGlobalValues=Boolean(config.globalValues&&Object.keys(config.globalValues).length);}
static registerTemplate(name,fn){globalTemplates[name]=fn;}
addTemplate(name,template){if(name in this.rawTemplates){if(!this.dev){return;}
const rawTemplate=this.rawTemplates[name];const currentAsString=typeof rawTemplate==="string"?rawTemplate:rawTemplate instanceof Element?rawTemplate.outerHTML:rawTemplate.toString();const newAsString=typeof template==="string"?template:template.outerHTML;if(currentAsString===newAsString){return;}
throw new OwlError(`Template ${name} already defined with different content`);}
this.rawTemplates[name]=template;}
addTemplates(xml){if(!xml){return;}
xml=xml instanceof Document?xml:parseXML(xml);for(const template of xml.querySelectorAll("[t-name]")){const name=template.getAttribute("t-name");this.addTemplate(name,template);}}
getTemplate(name){var _a;if(!(name in this.templates)){const rawTemplate=((_a=this.getRawTemplate)===null||_a===void 0?void 0:_a.call(this,name))||this.rawTemplates[name];if(rawTemplate===undefined){let extraInfo="";try{const componentName=getCurrent().component.constructor.name;extraInfo=` (for component "${componentName}")`;}
catch{}
throw new OwlError(`Missing template: "${name}"${extraInfo}`);}
const isFn=typeof rawTemplate==="function"&&!(rawTemplate instanceof Element);const templateFn=isFn?rawTemplate:this._compileTemplate(name,rawTemplate);const templates=this.templates;this.templates[name]=function(context,parent){return templates[name].call(this,context,parent);};const template=templateFn(this,bdom,this.runtimeUtils);this.templates[name]=template;}
return this.templates[name];}
_compileTemplate(name,template){throw new OwlError(`Unable to compile a template. Please use owl full build instead`);}
callTemplate(owner,subTemplate,ctx,parent,key){const template=this.getTemplate(subTemplate);return toggler(subTemplate,template.call(owner,ctx,parent,key+subTemplate));}}
const globalTemplates={};function xml(...args){const name=`__template__${xml.nextId++}`;const value=String.raw(...args);globalTemplates[name]=value;return name;}
xml.nextId=1;TemplateSet.registerTemplate("__portal__",portalTemplate);const RESERVED_WORDS="true,false,NaN,null,undefined,debugger,console,window,in,instanceof,new,function,return,eval,void,Math,RegExp,Array,Object,Date,__globals__".split(",");const WORD_REPLACEMENT=Object.assign(Object.create(null),{and:"&&",or:"||",gt:">",gte:">=",lt:"<",lte:"<=",});const STATIC_TOKEN_MAP=Object.assign(Object.create(null),{"{":"LEFT_BRACE","}":"RIGHT_BRACE","[":"LEFT_BRACKET","]":"RIGHT_BRACKET",":":"COLON",",":"COMMA","(":"LEFT_PAREN",")":"RIGHT_PAREN",});const OPERATORS="...,.,===,==,+,!==,!=,!,||,&&,>=,>,<=,<,?,-,*,/,%,typeof ,=>,=,;,in ,new ,|,&,^,~".split(",");let tokenizeString=function(expr){let s=expr[0];let start=s;if(s!=="'"&&s!=='"'&&s!=="`"){return false;}
let i=1;let cur;while(expr[i]&&expr[i]!==start){cur=expr[i];s+=cur;if(cur==="\\"){i++;cur=expr[i];if(!cur){throw new OwlError("Invalid expression");}
s+=cur;}
i++;}
if(expr[i]!==start){throw new OwlError("Invalid expression");}
s+=start;if(start==="`"){return{type:"TEMPLATE_STRING",value:s,replace(replacer){return s.replace(/\$\{(.*?)\}/g,(match,group)=>{return"${"+replacer(group)+"}";});},};}
return{type:"VALUE",value:s};};let tokenizeNumber=function(expr){let s=expr[0];if(s&&s.match(/[0-9]/)){let i=1;while(expr[i]&&expr[i].match(/[0-9]|\./)){s+=expr[i];i++;}
return{type:"VALUE",value:s};}
else{return false;}};let tokenizeSymbol=function(expr){let s=expr[0];if(s&&s.match(/[a-zA-Z_\$]/)){let i=1;while(expr[i]&&expr[i].match(/\w/)){s+=expr[i];i++;}
if(s in WORD_REPLACEMENT){return{type:"OPERATOR",value:WORD_REPLACEMENT[s],size:s.length};}
return{type:"SYMBOL",value:s};}
else{return false;}};const tokenizeStatic=function(expr){const char=expr[0];if(char&&char in STATIC_TOKEN_MAP){return{type:STATIC_TOKEN_MAP[char],value:char};}
return false;};const tokenizeOperator=function(expr){for(let op of OPERATORS){if(expr.startsWith(op)){return{type:"OPERATOR",value:op};}}
return false;};const TOKENIZERS=[tokenizeString,tokenizeNumber,tokenizeOperator,tokenizeSymbol,tokenizeStatic,];function tokenize(expr){const result=[];let token=true;let error;let current=expr;try{while(token){current=current.trim();if(current){for(let tokenizer of TOKENIZERS){token=tokenizer(current);if(token){result.push(token);current=current.slice(token.size||token.value.length);break;}}}
else{token=false;}}}
catch(e){error=e;}
if(current.length||error){throw new OwlError(`Tokenizer error: could not tokenize \`${expr}\``);}
return result;}
const isLeftSeparator=(token)=>token&&(token.type==="LEFT_BRACE"||token.type==="COMMA");const isRightSeparator=(token)=>token&&(token.type==="RIGHT_BRACE"||token.type==="COMMA");function compileExprToArray(expr){const localVars=new Set();const tokens=tokenize(expr);let i=0;let stack=[];while(i<tokens.length){let token=tokens[i];let prevToken=tokens[i-1];let nextToken=tokens[i+1];let groupType=stack[stack.length-1];switch(token.type){case"LEFT_BRACE":case"LEFT_BRACKET":case"LEFT_PAREN":stack.push(token.type);break;case"RIGHT_BRACE":case"RIGHT_BRACKET":case"RIGHT_PAREN":stack.pop();}
let isVar=token.type==="SYMBOL"&&!RESERVED_WORDS.includes(token.value);if(token.type==="SYMBOL"&&!RESERVED_WORDS.includes(token.value)){if(prevToken){if(groupType==="LEFT_BRACE"&&isLeftSeparator(prevToken)&&isRightSeparator(nextToken)){tokens.splice(i+1,0,{type:"COLON",value:":"},{...token});nextToken=tokens[i+1];}
if(prevToken.type==="OPERATOR"&&prevToken.value==="."){isVar=false;}
else if(prevToken.type==="LEFT_BRACE"||prevToken.type==="COMMA"){if(nextToken&&nextToken.type==="COLON"){isVar=false;}}}}
if(token.type==="TEMPLATE_STRING"){token.value=token.replace((expr)=>compileExpr(expr));}
if(nextToken&&nextToken.type==="OPERATOR"&&nextToken.value==="=>"){if(token.type==="RIGHT_PAREN"){let j=i-1;while(j>0&&tokens[j].type!=="LEFT_PAREN"){if(tokens[j].type==="SYMBOL"&&tokens[j].originalValue){tokens[j].value=tokens[j].originalValue;localVars.add(tokens[j].value);}
j--;}}
else{localVars.add(token.value);}}
if(isVar){token.varName=token.value;if(!localVars.has(token.value)){token.originalValue=token.value;token.value=`ctx['${token.value}']`;}}
i++;}
for(const token of tokens){if(token.type==="SYMBOL"&&token.varName&&localVars.has(token.value)){token.originalValue=token.value;token.value=`_${token.value}`;token.isLocal=true;}}
return tokens;}
const paddedValues=new Map([["in "," in "]]);function compileExpr(expr){return compileExprToArray(expr).map((t)=>paddedValues.get(t.value)||t.value).join("");}
const INTERP_REGEXP=/\{\{.*?\}\}|\#\{.*?\}/g;function replaceDynamicParts(s,replacer){let matches=s.match(INTERP_REGEXP);if(matches&&matches[0].length===s.length){return`(${replacer(s.slice(2, matches[0][0] === "{" ? -2 : -1))})`;}
let r=s.replace(INTERP_REGEXP,(s)=>"${"+replacer(s.slice(2,s[0]==="{"?-2:-1))+"}");return"`"+r+"`";}
function interpolate(s){return replaceDynamicParts(s,compileExpr);}
const whitespaceRE=/\s+/g;const xmlDoc=document.implementation.createDocument(null,null,null);const MODS=new Set(["stop","capture","prevent","self","synthetic"]);let nextDataIds={};function generateId(prefix=""){nextDataIds[prefix]=(nextDataIds[prefix]||0)+1;return prefix+nextDataIds[prefix];}
function isProp(tag,key){switch(tag){case"input":return(key==="checked"||key==="indeterminate"||key==="value"||key==="readonly"||key==="readOnly"||key==="disabled");case"option":return key==="selected"||key==="disabled";case"textarea":return key==="value"||key==="readonly"||key==="readOnly"||key==="disabled";case"select":return key==="value"||key==="disabled";case"button":case"optgroup":return key==="disabled";}
return false;}
function toStringExpression(str){return`\`${str.replace(/\\/g, "\\\\").replace(/`/g,"\\`").replace(/\$\{/,"\\${")}\``;}
class BlockDescription{constructor(target,type){this.dynamicTagName=null;this.isRoot=false;this.hasDynamicChildren=false;this.children=[];this.data=[];this.childNumber=0;this.parentVar="";this.id=BlockDescription.nextBlockId++;this.varName="b"+this.id;this.blockName="block"+this.id;this.target=target;this.type=type;}
insertData(str,prefix="d"){const id=generateId(prefix);this.target.addLine(`let ${id} = ${str};`);return this.data.push(id)-1;}
insert(dom){if(this.currentDom){this.currentDom.appendChild(dom);}
else{this.dom=dom;}}
generateExpr(expr){if(this.type==="block"){const hasChildren=this.children.length;let params=this.data.length?`[${this.data.join(", ")}]`:hasChildren?"[]":"";if(hasChildren){params+=", ["+this.children.map((c)=>c.varName).join(", ")+"]";}
if(this.dynamicTagName){return`toggler(${this.dynamicTagName}, ${this.blockName}(${this.dynamicTagName})(${params}))`;}
return`${this.blockName}(${params})`;}
else if(this.type==="list"){return`list(c_block${this.id})`;}
return expr;}
asXmlString(){const t=xmlDoc.createElement("t");t.appendChild(this.dom);return t.innerHTML;}}
BlockDescription.nextBlockId=1;function createContext(parentCtx,params){return Object.assign({block:null,index:0,forceNewBlock:true,translate:parentCtx.translate,translationCtx:parentCtx.translationCtx,tKeyExpr:null,nameSpace:parentCtx.nameSpace,tModelSelectedExpr:parentCtx.tModelSelectedExpr,},params);}
class CodeTarget{constructor(name,on){this.indentLevel=0;this.loopLevel=0;this.code=[];this.hasRoot=false;this.hasCache=false;this.shouldProtectScope=false;this.hasRefWrapper=false;this.name=name;this.on=on||null;}
addLine(line,idx){const prefix=new Array(this.indentLevel+2).join("  ");if(idx===undefined){this.code.push(prefix+line);}
else{this.code.splice(idx,0,prefix+line);}}
generateCode(){let result=[];result.push(`function ${this.name}(ctx, node, key = "") {`);if(this.shouldProtectScope){result.push(`  ctx = Object.create(ctx);`);result.push(`  ctx[isBoundary] = 1`);}
if(this.hasRefWrapper){result.push(`  let refWrapper = makeRefWrapper(this.__owl__);`);}
if(this.hasCache){result.push(`  let cache = ctx.cache || {};`);result.push(`  let nextCache = ctx.cache = {};`);}
for(let line of this.code){result.push(line);}
if(!this.hasRoot){result.push(`return text('');`);}
result.push(`}`);return result.join("\n  ");}
currentKey(ctx){let key=this.loopLevel?`key${this.loopLevel}`:"key";if(ctx.tKeyExpr){key=`${ctx.tKeyExpr} + ${key}`;}
return key;}}
const TRANSLATABLE_ATTRS=["label","title","placeholder","alt"];const translationRE=/^(\s*)([\s\S]+?)(\s*)$/;class CodeGenerator{constructor(ast,options){this.blocks=[];this.nextBlockId=1;this.isDebug=false;this.targets=[];this.target=new CodeTarget("template");this.translatableAttributes=TRANSLATABLE_ATTRS;this.staticDefs=[];this.slotNames=new Set();this.helpers=new Set();this.translateFn=options.translateFn||((s)=>s);if(options.translatableAttributes){const attrs=new Set(TRANSLATABLE_ATTRS);for(let attr of options.translatableAttributes){if(attr.startsWith("-")){attrs.delete(attr.slice(1));}
else{attrs.add(attr);}}
this.translatableAttributes=[...attrs];}
this.hasSafeContext=options.hasSafeContext||false;this.dev=options.dev||false;this.ast=ast;this.templateName=options.name;if(options.hasGlobalValues){this.helpers.add("__globals__");}}
generateCode(){const ast=this.ast;this.isDebug=ast.type===12;BlockDescription.nextBlockId=1;nextDataIds={};this.compileAST(ast,{block:null,index:0,forceNewBlock:false,isLast:true,translate:true,translationCtx:"",tKeyExpr:null,});let mainCode=[`  let { text, createBlock, list, multi, html, toggler, comment } = bdom;`];if(this.helpers.size){mainCode.push(`let { ${[...this.helpers].join(", ")} } = helpers;`);}
if(this.templateName){mainCode.push(`// Template name: "${this.templateName}"`);}
for(let{id,expr}of this.staticDefs){mainCode.push(`const ${id} = ${expr};`);}
if(this.blocks.length){mainCode.push(``);for(let block of this.blocks){if(block.dom){let xmlString=toStringExpression(block.asXmlString());if(block.dynamicTagName){xmlString=xmlString.replace(/^`<\w+/,`\`<\${tag || '${block.dom.nodeName}'}`);xmlString=xmlString.replace(/\w+>`$/,`\${tag || '${block.dom.nodeName}'}>\``);mainCode.push(`let ${block.blockName} = tag => createBlock(${xmlString});`);}
else{mainCode.push(`let ${block.blockName} = createBlock(${xmlString});`);}}}}
if(this.targets.length){for(let fn of this.targets){mainCode.push("");mainCode=mainCode.concat(fn.generateCode());}}
mainCode.push("");mainCode=mainCode.concat("return "+this.target.generateCode());const code=mainCode.join("\n  ");if(this.isDebug){const msg=`[Owl Debug]\n${code}`;console.log(msg);}
return code;}
compileInNewTarget(prefix,ast,ctx,on){const name=generateId(prefix);const initialTarget=this.target;const target=new CodeTarget(name,on);this.targets.push(target);this.target=target;this.compileAST(ast,createContext(ctx));this.target=initialTarget;return name;}
addLine(line,idx){this.target.addLine(line,idx);}
define(varName,expr){this.addLine(`const ${varName} = ${expr};`);}
insertAnchor(block,index=block.children.length){const tag=`block-child-${index}`;const anchor=xmlDoc.createElement(tag);block.insert(anchor);}
createBlock(parentBlock,type,ctx){const hasRoot=this.target.hasRoot;const block=new BlockDescription(this.target,type);if(!hasRoot){this.target.hasRoot=true;block.isRoot=true;}
if(parentBlock){parentBlock.children.push(block);if(parentBlock.type==="list"){block.parentVar=`c_block${parentBlock.id}`;}}
return block;}
insertBlock(expression,block,ctx){let blockExpr=block.generateExpr(expression);if(block.parentVar){let key=this.target.currentKey(ctx);this.helpers.add("withKey");this.addLine(`${block.parentVar}[${ctx.index}] = withKey(${blockExpr}, ${key});`);return;}
if(ctx.tKeyExpr){blockExpr=`toggler(${ctx.tKeyExpr}, ${blockExpr})`;}
if(block.isRoot){if(this.target.on){blockExpr=this.wrapWithEventCatcher(blockExpr,this.target.on);}
this.addLine(`return ${blockExpr};`);}
else{this.define(block.varName,blockExpr);}}
captureExpression(expr,forceCapture=false){if(!forceCapture&&!expr.includes("=>")){return compileExpr(expr);}
const tokens=compileExprToArray(expr);const mapping=new Map();return tokens.map((tok)=>{if(tok.varName&&!tok.isLocal){if(!mapping.has(tok.varName)){const varId=generateId("v");mapping.set(tok.varName,varId);this.define(varId,tok.value);}
tok.value=mapping.get(tok.varName);}
return tok.value;}).join("");}
translate(str,translationCtx){const match=translationRE.exec(str);return match[1]+this.translateFn(match[2],translationCtx)+match[3];}
compileAST(ast,ctx){switch(ast.type){case 1:return this.compileComment(ast,ctx);case 0:return this.compileText(ast,ctx);case 2:return this.compileTDomNode(ast,ctx);case 4:return this.compileTEsc(ast,ctx);case 8:return this.compileTOut(ast,ctx);case 5:return this.compileTIf(ast,ctx);case 9:return this.compileTForeach(ast,ctx);case 10:return this.compileTKey(ast,ctx);case 3:return this.compileMulti(ast,ctx);case 7:return this.compileTCall(ast,ctx);case 15:return this.compileTCallBlock(ast,ctx);case 6:return this.compileTSet(ast,ctx);case 11:return this.compileComponent(ast,ctx);case 12:return this.compileDebug(ast,ctx);case 13:return this.compileLog(ast,ctx);case 14:return this.compileTSlot(ast,ctx);case 16:return this.compileTTranslation(ast,ctx);case 17:return this.compileTTranslationContext(ast,ctx);case 18:return this.compileTPortal(ast,ctx);}}
compileDebug(ast,ctx){this.addLine(`debugger;`);if(ast.content){return this.compileAST(ast.content,ctx);}
return null;}
compileLog(ast,ctx){this.addLine(`console.log(${compileExpr(ast.expr)});`);if(ast.content){return this.compileAST(ast.content,ctx);}
return null;}
compileComment(ast,ctx){let{block,forceNewBlock}=ctx;const isNewBlock=!block||forceNewBlock;if(isNewBlock){block=this.createBlock(block,"comment",ctx);this.insertBlock(`comment(${toStringExpression(ast.value)})`,block,{...ctx,forceNewBlock:forceNewBlock&&!block,});}
else{const text=xmlDoc.createComment(ast.value);block.insert(text);}
return block.varName;}
compileText(ast,ctx){let{block,forceNewBlock}=ctx;let value=ast.value;if(value&&ctx.translate!==false){value=this.translate(value,ctx.translationCtx);}
if(!ctx.inPreTag){value=value.replace(whitespaceRE," ");}
if(!block||forceNewBlock){block=this.createBlock(block,"text",ctx);this.insertBlock(`text(${toStringExpression(value)})`,block,{...ctx,forceNewBlock:forceNewBlock&&!block,});}
else{const createFn=ast.type===0?xmlDoc.createTextNode:xmlDoc.createComment;block.insert(createFn.call(xmlDoc,value));}
return block.varName;}
generateHandlerCode(rawEvent,handler){const modifiers=rawEvent.split(".").slice(1).map((m)=>{if(!MODS.has(m)){throw new OwlError(`Unknown event modifier: '${m}'`);}
return`"${m}"`;});let modifiersCode="";if(modifiers.length){modifiersCode=`${modifiers.join(",")}, `;}
return`[${modifiersCode}${this.captureExpression(handler)}, ctx]`;}
compileTDomNode(ast,ctx){var _a;let{block,forceNewBlock}=ctx;const isNewBlock=!block||forceNewBlock||ast.dynamicTag!==null||ast.ns;let codeIdx=this.target.code.length;if(isNewBlock){if((ast.dynamicTag||ctx.tKeyExpr||ast.ns)&&ctx.block){this.insertAnchor(ctx.block);}
block=this.createBlock(block,"block",ctx);this.blocks.push(block);if(ast.dynamicTag){const tagExpr=generateId("tag");this.define(tagExpr,compileExpr(ast.dynamicTag));block.dynamicTagName=tagExpr;}}
const attrs={};for(let key in ast.attrs){let expr,attrName;if(key.startsWith("t-attf")){expr=interpolate(ast.attrs[key]);const idx=block.insertData(expr,"attr");attrName=key.slice(7);attrs["block-attribute-"+idx]=attrName;}
else if(key.startsWith("t-att")){attrName=key==="t-att"?null:key.slice(6);expr=compileExpr(ast.attrs[key]);if(attrName&&isProp(ast.tag,attrName)){if(attrName==="readonly"){attrName="readOnly";}
if(attrName==="value"){expr=`new String((${expr}) === 0 ? 0 : ((${expr}) || ""))`;}
else{expr=`new Boolean(${expr})`;}
const idx=block.insertData(expr,"prop");attrs[`block-property-${idx}`]=attrName;}
else{const idx=block.insertData(expr,"attr");if(key==="t-att"){attrs[`block-attributes`]=String(idx);}
else{attrs[`block-attribute-${idx}`]=attrName;}}}
else if(this.translatableAttributes.includes(key)){const attrTranslationCtx=((_a=ast.attrsTranslationCtx)===null||_a===void 0?void 0:_a[key])||ctx.translationCtx;attrs[key]=this.translateFn(ast.attrs[key],attrTranslationCtx);}
else{expr=`"${ast.attrs[key]}"`;attrName=key;attrs[key]=ast.attrs[key];}
if(attrName==="value"&&ctx.tModelSelectedExpr){let selectedId=block.insertData(`${ctx.tModelSelectedExpr} === ${expr}`,"attr");attrs[`block-attribute-${selectedId}`]="selected";}}
let tModelSelectedExpr;if(ast.model){const{hasDynamicChildren,baseExpr,expr,eventType,shouldNumberize,shouldTrim,targetAttr,specialInitTargetAttr,}=ast.model;const baseExpression=compileExpr(baseExpr);const bExprId=generateId("bExpr");this.define(bExprId,baseExpression);const expression=compileExpr(expr);const exprId=generateId("expr");this.define(exprId,expression);const fullExpression=`${bExprId}[${exprId}]`;let idx;if(specialInitTargetAttr){let targetExpr=targetAttr in attrs&&`'${attrs[targetAttr]}'`;if(!targetExpr&&ast.attrs){const dynamicTgExpr=ast.attrs[`t-att-${targetAttr}`];if(dynamicTgExpr){targetExpr=compileExpr(dynamicTgExpr);}}
idx=block.insertData(`${fullExpression} === ${targetExpr}`,"prop");attrs[`block-property-${idx}`]=specialInitTargetAttr;}
else if(hasDynamicChildren){const bValueId=generateId("bValue");tModelSelectedExpr=`${bValueId}`;this.define(tModelSelectedExpr,fullExpression);}
else{idx=block.insertData(`${fullExpression}`,"prop");attrs[`block-property-${idx}`]=targetAttr;}
this.helpers.add("toNumber");let valueCode=`ev.target.${targetAttr}`;valueCode=shouldTrim?`${valueCode}.trim()`:valueCode;valueCode=shouldNumberize?`toNumber(${valueCode})`:valueCode;const handler=`[(ev) => { ${fullExpression} = ${valueCode}; }]`;idx=block.insertData(handler,"hdlr");attrs[`block-handler-${idx}`]=eventType;}
for(let ev in ast.on){const name=this.generateHandlerCode(ev,ast.on[ev]);const idx=block.insertData(name,"hdlr");attrs[`block-handler-${idx}`]=ev;}
if(ast.ref){if(this.dev){this.helpers.add("makeRefWrapper");this.target.hasRefWrapper=true;}
const isDynamic=INTERP_REGEXP.test(ast.ref);let name=`\`${ast.ref}\``;if(isDynamic){name=replaceDynamicParts(ast.ref,(expr)=>this.captureExpression(expr,true));}
let setRefStr=`(el) => this.__owl__.setRef((${name}), el)`;if(this.dev){setRefStr=`refWrapper(${name}, ${setRefStr})`;}
const idx=block.insertData(setRefStr,"ref");attrs["block-ref"]=String(idx);}
const nameSpace=ast.ns||ctx.nameSpace;const dom=nameSpace?xmlDoc.createElementNS(nameSpace,ast.tag):xmlDoc.createElement(ast.tag);for(const[attr,val]of Object.entries(attrs)){if(!(attr==="class"&&val==="")){dom.setAttribute(attr,val);}}
block.insert(dom);if(ast.content.length){const initialDom=block.currentDom;block.currentDom=dom;const children=ast.content;for(let i=0;i<children.length;i++){const child=ast.content[i];const subCtx=createContext(ctx,{block,index:block.childNumber,forceNewBlock:false,isLast:ctx.isLast&&i===children.length-1,tKeyExpr:ctx.tKeyExpr,nameSpace,tModelSelectedExpr,inPreTag:ctx.inPreTag||ast.tag==="pre",});this.compileAST(child,subCtx);}
block.currentDom=initialDom;}
if(isNewBlock){this.insertBlock(`${block.blockName}(ddd)`,block,ctx);if(block.children.length&&block.hasDynamicChildren){const code=this.target.code;const children=block.children.slice();let current=children.shift();for(let i=codeIdx;i<code.length;i++){if(code[i].trimStart().startsWith(`const ${current.varName} `)){code[i]=code[i].replace(`const ${current.varName}`,current.varName);current=children.shift();if(!current)
break;}}
this.addLine(`let ${block.children.map((c) => c.varName).join(", ")};`,codeIdx);}}
return block.varName;}
compileTEsc(ast,ctx){let{block,forceNewBlock}=ctx;let expr;if(ast.expr==="0"){this.helpers.add("zero");expr=`ctx[zero]`;}
else{expr=compileExpr(ast.expr);if(ast.defaultValue){this.helpers.add("withDefault");expr=`withDefault(${expr}, ${toStringExpression(ast.defaultValue)})`;}}
if(!block||forceNewBlock){block=this.createBlock(block,"text",ctx);this.insertBlock(`text(${expr})`,block,{...ctx,forceNewBlock:forceNewBlock&&!block});}
else{const idx=block.insertData(expr,"txt");const text=xmlDoc.createElement(`block-text-${idx}`);block.insert(text);}
return block.varName;}
compileTOut(ast,ctx){let{block}=ctx;if(block){this.insertAnchor(block);}
block=this.createBlock(block,"html",ctx);let blockStr;if(ast.expr==="0"){this.helpers.add("zero");blockStr=`ctx[zero]`;}
else if(ast.body){let bodyValue=null;bodyValue=BlockDescription.nextBlockId;const subCtx=createContext(ctx);this.compileAST({type:3,content:ast.body},subCtx);this.helpers.add("safeOutput");blockStr=`safeOutput(${compileExpr(ast.expr)}, b${bodyValue})`;}
else{this.helpers.add("safeOutput");blockStr=`safeOutput(${compileExpr(ast.expr)})`;}
this.insertBlock(blockStr,block,ctx);return block.varName;}
compileTIfBranch(content,block,ctx){this.target.indentLevel++;let childN=block.children.length;this.compileAST(content,createContext(ctx,{block,index:ctx.index}));if(block.children.length>childN){this.insertAnchor(block,childN);}
this.target.indentLevel--;}
compileTIf(ast,ctx,nextNode){let{block,forceNewBlock}=ctx;const codeIdx=this.target.code.length;const isNewBlock=!block||(block.type!=="multi"&&forceNewBlock);if(block){block.hasDynamicChildren=true;}
if(!block||(block.type!=="multi"&&forceNewBlock)){block=this.createBlock(block,"multi",ctx);}
this.addLine(`if (${compileExpr(ast.condition)}) {`);this.compileTIfBranch(ast.content,block,ctx);if(ast.tElif){for(let clause of ast.tElif){this.addLine(`} else if (${compileExpr(clause.condition)}) {`);this.compileTIfBranch(clause.content,block,ctx);}}
if(ast.tElse){this.addLine(`} else {`);this.compileTIfBranch(ast.tElse,block,ctx);}
this.addLine("}");if(isNewBlock){if(block.children.length){const code=this.target.code;const children=block.children.slice();let current=children.shift();for(let i=codeIdx;i<code.length;i++){if(code[i].trimStart().startsWith(`const ${current.varName} `)){code[i]=code[i].replace(`const ${current.varName}`,current.varName);current=children.shift();if(!current)
break;}}
this.addLine(`let ${block.children.map((c) => c.varName).join(", ")};`,codeIdx);}
const args=block.children.map((c)=>c.varName).join(", ");this.insertBlock(`multi([${args}])`,block,ctx);}
return block.varName;}
compileTForeach(ast,ctx){let{block}=ctx;if(block){this.insertAnchor(block);}
block=this.createBlock(block,"list",ctx);this.target.loopLevel++;const loopVar=`i${this.target.loopLevel}`;this.addLine(`ctx = Object.create(ctx);`);const vals=`v_block${block.id}`;const keys=`k_block${block.id}`;const l=`l_block${block.id}`;const c=`c_block${block.id}`;this.helpers.add("prepareList");this.define(`[${keys}, ${vals}, ${l}, ${c}]`,`prepareList(${compileExpr(ast.collection)});`);if(this.dev){this.define(`keys${block.id}`,`new Set()`);}
this.addLine(`for (let ${loopVar} = 0; ${loopVar} < ${l}; ${loopVar}++) {`);this.target.indentLevel++;this.addLine(`ctx[\`${ast.elem}\`] = ${keys}[${loopVar}];`);if(!ast.hasNoFirst){this.addLine(`ctx[\`${ast.elem}_first\`] = ${loopVar} === 0;`);}
if(!ast.hasNoLast){this.addLine(`ctx[\`${ast.elem}_last\`] = ${loopVar} === ${keys}.length - 1;`);}
if(!ast.hasNoIndex){this.addLine(`ctx[\`${ast.elem}_index\`] = ${loopVar};`);}
if(!ast.hasNoValue){this.addLine(`ctx[\`${ast.elem}_value\`] = ${vals}[${loopVar}];`);}
this.define(`key${this.target.loopLevel}`,ast.key?compileExpr(ast.key):loopVar);if(this.dev){this.helpers.add("OwlError");this.addLine(`if (keys${block.id}.has(String(key${this.target.loopLevel}))) { throw new OwlError(\`Got duplicate key in t-foreach: \${key${this.target.loopLevel}}\`)}`);this.addLine(`keys${block.id}.add(String(key${this.target.loopLevel}));`);}
let id;if(ast.memo){this.target.hasCache=true;id=generateId();this.define(`memo${id}`,compileExpr(ast.memo));this.define(`vnode${id}`,`cache[key${this.target.loopLevel}];`);this.addLine(`if (vnode${id}) {`);this.target.indentLevel++;this.addLine(`if (shallowEqual(vnode${id}.memo, memo${id})) {`);this.target.indentLevel++;this.addLine(`${c}[${loopVar}] = vnode${id};`);this.addLine(`nextCache[key${this.target.loopLevel}] = vnode${id};`);this.addLine(`continue;`);this.target.indentLevel--;this.addLine("}");this.target.indentLevel--;this.addLine("}");}
const subCtx=createContext(ctx,{block,index:loopVar});this.compileAST(ast.body,subCtx);if(ast.memo){this.addLine(`nextCache[key${this.target.loopLevel}] = Object.assign(${c}[${loopVar}], {memo: memo${id}});`);}
this.target.indentLevel--;this.target.loopLevel--;this.addLine(`}`);if(!ctx.isLast){this.addLine(`ctx = ctx.__proto__;`);}
this.insertBlock("l",block,ctx);return block.varName;}
compileTKey(ast,ctx){const tKeyExpr=generateId("tKey_");this.define(tKeyExpr,compileExpr(ast.expr));ctx=createContext(ctx,{tKeyExpr,block:ctx.block,index:ctx.index,});return this.compileAST(ast.content,ctx);}
compileMulti(ast,ctx){let{block,forceNewBlock}=ctx;const isNewBlock=!block||forceNewBlock;let codeIdx=this.target.code.length;if(isNewBlock){const n=ast.content.filter((c)=>c.type!==6).length;let result=null;if(n<=1){for(let child of ast.content){const blockName=this.compileAST(child,ctx);result=result||blockName;}
return result;}
block=this.createBlock(block,"multi",ctx);}
let index=0;for(let i=0,l=ast.content.length;i<l;i++){const child=ast.content[i];const isTSet=child.type===6;const subCtx=createContext(ctx,{block,index,forceNewBlock:!isTSet,isLast:ctx.isLast&&i===l-1,});this.compileAST(child,subCtx);if(!isTSet){index++;}}
if(isNewBlock){if(block.hasDynamicChildren&&block.children.length){const code=this.target.code;const children=block.children.slice();let current=children.shift();for(let i=codeIdx;i<code.length;i++){if(code[i].trimStart().startsWith(`const ${current.varName} `)){code[i]=code[i].replace(`const ${current.varName}`,current.varName);current=children.shift();if(!current)
break;}}
this.addLine(`let ${block.children.map((c) => c.varName).join(", ")};`,codeIdx);}
const args=block.children.map((c)=>c.varName).join(", ");this.insertBlock(`multi([${args}])`,block,ctx);}
return block.varName;}
compileTCall(ast,ctx){let{block,forceNewBlock}=ctx;let ctxVar=ctx.ctxVar||"ctx";if(ast.context){ctxVar=generateId("ctx");this.addLine(`let ${ctxVar} = ${compileExpr(ast.context)};`);}
const isDynamic=INTERP_REGEXP.test(ast.name);const subTemplate=isDynamic?interpolate(ast.name):"`"+ast.name+"`";if(block&&!forceNewBlock){this.insertAnchor(block);}
block=this.createBlock(block,"multi",ctx);if(ast.body){this.addLine(`${ctxVar} = Object.create(${ctxVar});`);this.addLine(`${ctxVar}[isBoundary] = 1;`);this.helpers.add("isBoundary");const subCtx=createContext(ctx,{ctxVar});const bl=this.compileMulti({type:3,content:ast.body},subCtx);if(bl){this.helpers.add("zero");this.addLine(`${ctxVar}[zero] = ${bl};`);}}
const key=this.generateComponentKey();if(isDynamic){const templateVar=generateId("template");if(!this.staticDefs.find((d)=>d.id==="call")){this.staticDefs.push({id:"call",expr:`app.callTemplate.bind(app)`});}
this.define(templateVar,subTemplate);this.insertBlock(`call(this, ${templateVar}, ${ctxVar}, node, ${key})`,block,{...ctx,forceNewBlock:!block,});}
else{const id=generateId(`callTemplate_`);this.staticDefs.push({id,expr:`app.getTemplate(${subTemplate})`});this.insertBlock(`${id}.call(this, ${ctxVar}, node, ${key})`,block,{...ctx,forceNewBlock:!block,});}
if(ast.body&&!ctx.isLast){this.addLine(`${ctxVar} = ${ctxVar}.__proto__;`);}
return block.varName;}
compileTCallBlock(ast,ctx){let{block,forceNewBlock}=ctx;if(block){if(!forceNewBlock){this.insertAnchor(block);}}
block=this.createBlock(block,"multi",ctx);this.insertBlock(compileExpr(ast.name),block,{...ctx,forceNewBlock:!block});return block.varName;}
compileTSet(ast,ctx){this.target.shouldProtectScope=true;this.helpers.add("isBoundary").add("withDefault");const expr=ast.value?compileExpr(ast.value||""):"null";if(ast.body){this.helpers.add("LazyValue");const bodyAst={type:3,content:ast.body};const name=this.compileInNewTarget("value",bodyAst,ctx);let key=this.target.currentKey(ctx);let value=`new LazyValue(${name}, ctx, this, node, ${key})`;value=ast.value?(value?`withDefault(${expr}, ${value})`:expr):value;this.addLine(`ctx[\`${ast.name}\`] = ${value};`);}
else{let value;if(ast.defaultValue){const defaultValue=toStringExpression(ctx.translate?this.translate(ast.defaultValue,ctx.translationCtx):ast.defaultValue);if(ast.value){value=`withDefault(${expr}, ${defaultValue})`;}
else{value=defaultValue;}}
else{value=expr;}
this.helpers.add("setContextValue");this.addLine(`setContextValue(${ctx.ctxVar || "ctx"}, "${ast.name}", ${value});`);}
return null;}
generateComponentKey(currentKey="key"){const parts=[generateId("__")];for(let i=0;i<this.target.loopLevel;i++){parts.push(`\${key${i + 1}}`);}
return`${currentKey} + \`${parts.join("__")}\``;}
formatProp(name,value,attrsTranslationCtx,translationCtx){if(name.endsWith(".translate")){const attrTranslationCtx=(attrsTranslationCtx===null||attrsTranslationCtx===void 0?void 0:attrsTranslationCtx[name])||translationCtx;value=toStringExpression(this.translateFn(value,attrTranslationCtx));}
else{value=this.captureExpression(value);}
if(name.includes(".")){let[_name,suffix]=name.split(".");name=_name;switch(suffix){case"bind":value=`(${value}).bind(this)`;break;case"alike":case"translate":break;default:throw new OwlError(`Invalid prop suffix: ${suffix}`);}}
name=/^[a-z_]+$/i.test(name)?name:`'${name}'`;return`${name}: ${value || undefined}`;}
formatPropObject(obj,attrsTranslationCtx,translationCtx){return Object.entries(obj).map(([k,v])=>this.formatProp(k,v,attrsTranslationCtx,translationCtx));}
getPropString(props,dynProps){let propString=`{${props.join(",")}}`;if(dynProps){propString=`Object.assign({}, ${compileExpr(dynProps)}${props.length ? ", " + propString : ""})`;}
return propString;}
compileComponent(ast,ctx){let{block}=ctx;const hasSlotsProp="slots"in(ast.props||{});const props=ast.props?this.formatPropObject(ast.props,ast.propsTranslationCtx,ctx.translationCtx):[];let slotDef="";if(ast.slots){let ctxStr="ctx";if(this.target.loopLevel||!this.hasSafeContext){ctxStr=generateId("ctx");this.helpers.add("capture");this.define(ctxStr,`capture(ctx)`);}
let slotStr=[];for(let slotName in ast.slots){const slotAst=ast.slots[slotName];const params=[];if(slotAst.content){const name=this.compileInNewTarget("slot",slotAst.content,ctx,slotAst.on);params.push(`__render: ${name}.bind(this), __ctx: ${ctxStr}`);}
const scope=ast.slots[slotName].scope;if(scope){params.push(`__scope: "${scope}"`);}
if(ast.slots[slotName].attrs){params.push(...this.formatPropObject(ast.slots[slotName].attrs,ast.slots[slotName].attrsTranslationCtx,ctx.translationCtx));}
const slotInfo=`{${params.join(", ")}}`;slotStr.push(`'${slotName}': ${slotInfo}`);}
slotDef=`{${slotStr.join(", ")}}`;}
if(slotDef&&!(ast.dynamicProps||hasSlotsProp)){this.helpers.add("markRaw");props.push(`slots: markRaw(${slotDef})`);}
let propString=this.getPropString(props,ast.dynamicProps);let propVar;if((slotDef&&(ast.dynamicProps||hasSlotsProp))||this.dev){propVar=generateId("props");this.define(propVar,propString);propString=propVar;}
if(slotDef&&(ast.dynamicProps||hasSlotsProp)){this.helpers.add("markRaw");this.addLine(`${propVar}.slots = markRaw(Object.assign(${slotDef}, ${propVar}.slots))`);}
let expr;if(ast.isDynamic){expr=generateId("Comp");this.define(expr,compileExpr(ast.name));}
else{expr=`\`${ast.name}\``;}
if(this.dev){this.addLine(`helpers.validateProps(${expr}, ${propVar}, this);`);}
if(block&&(ctx.forceNewBlock===false||ctx.tKeyExpr)){this.insertAnchor(block);}
let keyArg=this.generateComponentKey();if(ctx.tKeyExpr){keyArg=`${ctx.tKeyExpr} + ${keyArg}`;}
let id=generateId("comp");const propList=[];for(let p in ast.props||{}){let[name,suffix]=p.split(".");if(!suffix){propList.push(`"${name}"`);}}
this.staticDefs.push({id,expr:`app.createComponent(${ast.isDynamic ? null : expr}, ${!ast.isDynamic}, ${!!ast.slots}, ${!!ast.dynamicProps}, [${propList}])`,});if(ast.isDynamic){keyArg=`(${expr}).name + ${keyArg}`;}
let blockExpr=`${id}(${propString}, ${keyArg}, node, this, ${ast.isDynamic ? expr : null})`;if(ast.isDynamic){blockExpr=`toggler(${expr}, ${blockExpr})`;}
if(ast.on){blockExpr=this.wrapWithEventCatcher(blockExpr,ast.on);}
block=this.createBlock(block,"multi",ctx);this.insertBlock(blockExpr,block,ctx);return block.varName;}
wrapWithEventCatcher(expr,on){this.helpers.add("createCatcher");let name=generateId("catcher");let spec={};let handlers=[];for(let ev in on){let handlerId=generateId("hdlr");let idx=handlers.push(handlerId)-1;spec[ev]=idx;const handler=this.generateHandlerCode(ev,on[ev]);this.define(handlerId,handler);}
this.staticDefs.push({id:name,expr:`createCatcher(${JSON.stringify(spec)})`});return`${name}(${expr}, [${handlers.join(",")}])`;}
compileTSlot(ast,ctx){this.helpers.add("callSlot");let{block}=ctx;let blockString;let slotName;let dynamic=false;let isMultiple=false;if(ast.name.match(INTERP_REGEXP)){dynamic=true;isMultiple=true;slotName=interpolate(ast.name);}
else{slotName="'"+ast.name+"'";isMultiple=isMultiple||this.slotNames.has(ast.name);this.slotNames.add(ast.name);}
const attrs={...ast.attrs};const dynProps=attrs["t-props"];delete attrs["t-props"];let key=this.target.loopLevel?`key${this.target.loopLevel}`:"key";if(isMultiple){key=this.generateComponentKey(key);}
const props=ast.attrs?this.formatPropObject(attrs,ast.attrsTranslationCtx,ctx.translationCtx):[];const scope=this.getPropString(props,dynProps);if(ast.defaultContent){const name=this.compileInNewTarget("defaultContent",ast.defaultContent,ctx);blockString=`callSlot(ctx, node, ${key}, ${slotName}, ${dynamic}, ${scope}, ${name}.bind(this))`;}
else{if(dynamic){let name=generateId("slot");this.define(name,slotName);blockString=`toggler(${name}, callSlot(ctx, node, ${key}, ${name}, ${dynamic}, ${scope}))`;}
else{blockString=`callSlot(ctx, node, ${key}, ${slotName}, ${dynamic}, ${scope})`;}}
if(ast.on){blockString=this.wrapWithEventCatcher(blockString,ast.on);}
if(block){this.insertAnchor(block);}
block=this.createBlock(block,"multi",ctx);this.insertBlock(blockString,block,{...ctx,forceNewBlock:false});return block.varName;}
compileTTranslation(ast,ctx){if(ast.content){return this.compileAST(ast.content,Object.assign({},ctx,{translate:false}));}
return null;}
compileTTranslationContext(ast,ctx){if(ast.content){return this.compileAST(ast.content,Object.assign({},ctx,{translationCtx:ast.translationCtx}));}
return null;}
compileTPortal(ast,ctx){if(!this.staticDefs.find((d)=>d.id==="Portal")){this.staticDefs.push({id:"Portal",expr:`app.Portal`});}
let{block}=ctx;const name=this.compileInNewTarget("slot",ast.content,ctx);let ctxStr="ctx";if(this.target.loopLevel||!this.hasSafeContext){ctxStr=generateId("ctx");this.helpers.add("capture");this.define(ctxStr,`capture(ctx)`);}
let id=generateId("comp");this.staticDefs.push({id,expr:`app.createComponent(null, false, true, false, false)`,});const target=compileExpr(ast.target);const key=this.generateComponentKey();const blockString=`${id}({target: ${target},slots: {'default': {__render: ${name}.bind(this), __ctx: ${ctxStr}}}}, ${key}, node, ctx, Portal)`;if(block){this.insertAnchor(block);}
block=this.createBlock(block,"multi",ctx);this.insertBlock(blockString,block,{...ctx,forceNewBlock:false});return block.varName;}}
const cache=new WeakMap();function parse(xml,customDir){const ctx={inPreTag:false,customDirectives:customDir,};if(typeof xml==="string"){const elem=parseXML(`<t>${xml}</t>`).firstChild;return _parse(elem,ctx);}
let ast=cache.get(xml);if(!ast){ast=_parse(xml.cloneNode(true),ctx);cache.set(xml,ast);}
return ast;}
function _parse(xml,ctx){normalizeXML(xml);return parseNode(xml,ctx)||{type:0,value:""};}
function parseNode(node,ctx){if(!(node instanceof Element)){return parseTextCommentNode(node,ctx);}
return(parseTCustom(node,ctx)||parseTDebugLog(node,ctx)||parseTForEach(node,ctx)||parseTIf(node,ctx)||parseTPortal(node,ctx)||parseTCall(node,ctx)||parseTCallBlock(node)||parseTEscNode(node,ctx)||parseTOutNode(node,ctx)||parseTKey(node,ctx)||parseTTranslation(node,ctx)||parseTTranslationContext(node,ctx)||parseTSlot(node,ctx)||parseComponent(node,ctx)||parseDOMNode(node,ctx)||parseTSetNode(node,ctx)||parseTNode(node,ctx));}
function parseTNode(node,ctx){if(node.tagName!=="t"){return null;}
return parseChildNodes(node,ctx);}
const lineBreakRE=/[\r\n]/;function parseTextCommentNode(node,ctx){if(node.nodeType===Node.TEXT_NODE){let value=node.textContent||"";if(!ctx.inPreTag&&lineBreakRE.test(value)&&!value.trim()){return null;}
return{type:0,value};}
else if(node.nodeType===Node.COMMENT_NODE){return{type:1,value:node.textContent||""};}
return null;}
function parseTCustom(node,ctx){if(!ctx.customDirectives){return null;}
const nodeAttrsNames=node.getAttributeNames();for(let attr of nodeAttrsNames){if(attr==="t-custom"||attr==="t-custom-"){throw new OwlError("Missing custom directive name with t-custom directive");}
if(attr.startsWith("t-custom-")){const directiveName=attr.split(".")[0].slice(9);const customDirective=ctx.customDirectives[directiveName];if(!customDirective){throw new OwlError(`Custom directive "${directiveName}" is not defined`);}
const value=node.getAttribute(attr);const modifiers=attr.split(".").slice(1);node.removeAttribute(attr);try{customDirective(node,value,modifiers);}
catch(error){throw new OwlError(`Custom directive "${directiveName}" throw the following error: ${error}`);}
return parseNode(node,ctx);}}
return null;}
function parseTDebugLog(node,ctx){if(node.hasAttribute("t-debug")){node.removeAttribute("t-debug");return{type:12,content:parseNode(node,ctx),};}
if(node.hasAttribute("t-log")){const expr=node.getAttribute("t-log");node.removeAttribute("t-log");return{type:13,expr,content:parseNode(node,ctx),};}
return null;}
const hasDotAtTheEnd=/\.[\w_]+\s*$/;const hasBracketsAtTheEnd=/\[[^\[]+\]\s*$/;const ROOT_SVG_TAGS=new Set(["svg","g","path"]);function parseDOMNode(node,ctx){const{tagName}=node;const dynamicTag=node.getAttribute("t-tag");node.removeAttribute("t-tag");if(tagName==="t"&&!dynamicTag){return null;}
if(tagName.startsWith("block-")){throw new OwlError(`Invalid tag name: '${tagName}'`);}
ctx=Object.assign({},ctx);if(tagName==="pre"){ctx.inPreTag=true;}
let ns=!ctx.nameSpace&&ROOT_SVG_TAGS.has(tagName)?"http://www.w3.org/2000/svg":null;const ref=node.getAttribute("t-ref");node.removeAttribute("t-ref");const nodeAttrsNames=node.getAttributeNames();let attrs=null;let attrsTranslationCtx=null;let on=null;let model=null;for(let attr of nodeAttrsNames){const value=node.getAttribute(attr);if(attr==="t-on"||attr==="t-on-"){throw new OwlError("Missing event name with t-on directive");}
if(attr.startsWith("t-on-")){on=on||{};on[attr.slice(5)]=value;}
else if(attr.startsWith("t-model")){if(!["input","select","textarea"].includes(tagName)){throw new OwlError("The t-model directive only works with <input>, <textarea> and <select>");}
let baseExpr,expr;if(hasDotAtTheEnd.test(value)){const index=value.lastIndexOf(".");baseExpr=value.slice(0,index);expr=`'${value.slice(index + 1)}'`;}
else if(hasBracketsAtTheEnd.test(value)){const index=value.lastIndexOf("[");baseExpr=value.slice(0,index);expr=value.slice(index+1,-1);}
else{throw new OwlError(`Invalid t-model expression: "${value}" (it should be assignable)`);}
const typeAttr=node.getAttribute("type");const isInput=tagName==="input";const isSelect=tagName==="select";const isCheckboxInput=isInput&&typeAttr==="checkbox";const isRadioInput=isInput&&typeAttr==="radio";const hasTrimMod=attr.includes(".trim");const hasLazyMod=hasTrimMod||attr.includes(".lazy");const hasNumberMod=attr.includes(".number");const eventType=isRadioInput?"click":isSelect||hasLazyMod?"change":"input";model={baseExpr,expr,targetAttr:isCheckboxInput?"checked":"value",specialInitTargetAttr:isRadioInput?"checked":null,eventType,hasDynamicChildren:false,shouldTrim:hasTrimMod,shouldNumberize:hasNumberMod,};if(isSelect){ctx=Object.assign({},ctx);ctx.tModelInfo=model;}}
else if(attr.startsWith("block-")){throw new OwlError(`Invalid attribute: '${attr}'`);}
else if(attr==="xmlns"){ns=value;}
else if(attr.startsWith("t-translation-context-")){const attrName=attr.slice(22);attrsTranslationCtx=attrsTranslationCtx||{};attrsTranslationCtx[attrName]=value;}
else if(attr!=="t-name"){if(attr.startsWith("t-")&&!attr.startsWith("t-att")){throw new OwlError(`Unknown QWeb directive: '${attr}'`);}
const tModel=ctx.tModelInfo;if(tModel&&["t-att-value","t-attf-value"].includes(attr)){tModel.hasDynamicChildren=true;}
attrs=attrs||{};attrs[attr]=value;}}
if(ns){ctx.nameSpace=ns;}
const children=parseChildren(node,ctx);return{type:2,tag:tagName,dynamicTag,attrs,attrsTranslationCtx,on,ref,content:children,model,ns,};}
function parseTEscNode(node,ctx){if(!node.hasAttribute("t-esc")){return null;}
const escValue=node.getAttribute("t-esc");node.removeAttribute("t-esc");const tesc={type:4,expr:escValue,defaultValue:node.textContent||"",};let ref=node.getAttribute("t-ref");node.removeAttribute("t-ref");const ast=parseNode(node,ctx);if(!ast){return tesc;}
if(ast.type===2){return{...ast,ref,content:[tesc],};}
return tesc;}
function parseTOutNode(node,ctx){if(!node.hasAttribute("t-out")&&!node.hasAttribute("t-raw")){return null;}
if(node.hasAttribute("t-raw")){console.warn(`t-raw has been deprecated in favor of t-out. If the value to render is not wrapped by the "markup" function, it will be escaped`);}
const expr=(node.getAttribute("t-out")||node.getAttribute("t-raw"));node.removeAttribute("t-out");node.removeAttribute("t-raw");const tOut={type:8,expr,body:null};const ref=node.getAttribute("t-ref");node.removeAttribute("t-ref");const ast=parseNode(node,ctx);if(!ast){return tOut;}
if(ast.type===2){tOut.body=ast.content.length?ast.content:null;return{...ast,ref,content:[tOut],};}
return tOut;}
function parseTForEach(node,ctx){if(!node.hasAttribute("t-foreach")){return null;}
const html=node.outerHTML;const collection=node.getAttribute("t-foreach");node.removeAttribute("t-foreach");const elem=node.getAttribute("t-as")||"";node.removeAttribute("t-as");const key=node.getAttribute("t-key");if(!key){throw new OwlError(`"Directive t-foreach should always be used with a t-key!" (expression: t-foreach="${collection}" t-as="${elem}")`);}
node.removeAttribute("t-key");const memo=node.getAttribute("t-memo")||"";node.removeAttribute("t-memo");const body=parseNode(node,ctx);if(!body){return null;}
const hasNoTCall=!html.includes("t-call");const hasNoFirst=hasNoTCall&&!html.includes(`${elem}_first`);const hasNoLast=hasNoTCall&&!html.includes(`${elem}_last`);const hasNoIndex=hasNoTCall&&!html.includes(`${elem}_index`);const hasNoValue=hasNoTCall&&!html.includes(`${elem}_value`);return{type:9,collection,elem,body,memo,key,hasNoFirst,hasNoLast,hasNoIndex,hasNoValue,};}
function parseTKey(node,ctx){if(!node.hasAttribute("t-key")){return null;}
const key=node.getAttribute("t-key");node.removeAttribute("t-key");const body=parseNode(node,ctx);if(!body){return null;}
return{type:10,expr:key,content:body};}
function parseTCall(node,ctx){if(!node.hasAttribute("t-call")){return null;}
const subTemplate=node.getAttribute("t-call");const context=node.getAttribute("t-call-context");node.removeAttribute("t-call");node.removeAttribute("t-call-context");if(node.tagName!=="t"){const ast=parseNode(node,ctx);const tcall={type:7,name:subTemplate,body:null,context};if(ast&&ast.type===2){ast.content=[tcall];return ast;}
if(ast&&ast.type===11){return{...ast,slots:{default:{content:tcall,scope:null,on:null,attrs:null,attrsTranslationCtx:null,},},};}}
const body=parseChildren(node,ctx);return{type:7,name:subTemplate,body:body.length?body:null,context,};}
function parseTCallBlock(node,ctx){if(!node.hasAttribute("t-call-block")){return null;}
const name=node.getAttribute("t-call-block");return{type:15,name,};}
function parseTIf(node,ctx){if(!node.hasAttribute("t-if")){return null;}
const condition=node.getAttribute("t-if");node.removeAttribute("t-if");const content=parseNode(node,ctx)||{type:0,value:""};let nextElement=node.nextElementSibling;const tElifs=[];while(nextElement&&nextElement.hasAttribute("t-elif")){const condition=nextElement.getAttribute("t-elif");nextElement.removeAttribute("t-elif");const tElif=parseNode(nextElement,ctx);const next=nextElement.nextElementSibling;nextElement.remove();nextElement=next;if(tElif){tElifs.push({condition,content:tElif});}}
let tElse=null;if(nextElement&&nextElement.hasAttribute("t-else")){nextElement.removeAttribute("t-else");tElse=parseNode(nextElement,ctx);nextElement.remove();}
return{type:5,condition,content,tElif:tElifs.length?tElifs:null,tElse,};}
function parseTSetNode(node,ctx){if(!node.hasAttribute("t-set")){return null;}
const name=node.getAttribute("t-set");const value=node.getAttribute("t-value")||null;const defaultValue=node.innerHTML===node.textContent?node.textContent||null:null;let body=null;if(node.textContent!==node.innerHTML){body=parseChildren(node,ctx);}
return{type:6,name,value,defaultValue,body};}
const directiveErrorMap=new Map([["t-ref","t-ref is no longer supported on components. Consider exposing only the public part of the component's API through a callback prop.",],["t-att","t-att makes no sense on component: props are already treated as expressions"],["t-attf","t-attf is not supported on components: use template strings for string interpolation in props",],]);function parseComponent(node,ctx){let name=node.tagName;const firstLetter=name[0];let isDynamic=node.hasAttribute("t-component");if(isDynamic&&name!=="t"){throw new OwlError(`Directive 't-component' can only be used on <t> nodes (used on a <${name}>)`);}
if(!(firstLetter===firstLetter.toUpperCase()||isDynamic)){return null;}
if(isDynamic){name=node.getAttribute("t-component");node.removeAttribute("t-component");}
const dynamicProps=node.getAttribute("t-props");node.removeAttribute("t-props");const defaultSlotScope=node.getAttribute("t-slot-scope");node.removeAttribute("t-slot-scope");let on=null;let props=null;let propsTranslationCtx=null;for(let name of node.getAttributeNames()){const value=node.getAttribute(name);if(name.startsWith("t-translation-context-")){const attrName=name.slice(22);propsTranslationCtx=propsTranslationCtx||{};propsTranslationCtx[attrName]=value;}
else if(name.startsWith("t-")){if(name.startsWith("t-on-")){on=on||{};on[name.slice(5)]=value;}
else{const message=directiveErrorMap.get(name.split("-").slice(0,2).join("-"));throw new OwlError(message||`unsupported directive on Component: ${name}`);}}
else{props=props||{};props[name]=value;}}
let slots=null;if(node.hasChildNodes()){const clone=node.cloneNode(true);const slotNodes=Array.from(clone.querySelectorAll("[t-set-slot]"));for(let slotNode of slotNodes){if(slotNode.tagName!=="t"){throw new OwlError(`Directive 't-set-slot' can only be used on <t> nodes (used on a <${slotNode.tagName}>)`);}
const name=slotNode.getAttribute("t-set-slot");let el=slotNode.parentElement;let isInSubComponent=false;while(el&&el!==clone){if(el.hasAttribute("t-component")||el.tagName[0]===el.tagName[0].toUpperCase()){isInSubComponent=true;break;}
el=el.parentElement;}
if(isInSubComponent||!el){continue;}
slotNode.removeAttribute("t-set-slot");slotNode.remove();const slotAst=parseNode(slotNode,ctx);let on=null;let attrs=null;let attrsTranslationCtx=null;let scope=null;for(let attributeName of slotNode.getAttributeNames()){const value=slotNode.getAttribute(attributeName);if(attributeName==="t-slot-scope"){scope=value;continue;}
else if(attributeName.startsWith("t-translation-context-")){const attrName=attributeName.slice(22);attrsTranslationCtx=attrsTranslationCtx||{};attrsTranslationCtx[attrName]=value;}
else if(attributeName.startsWith("t-on-")){on=on||{};on[attributeName.slice(5)]=value;}
else{attrs=attrs||{};attrs[attributeName]=value;}}
slots=slots||{};slots[name]={content:slotAst,on,attrs,attrsTranslationCtx,scope};}
const defaultContent=parseChildNodes(clone,ctx);slots=slots||{};if(defaultContent&&!slots.default){slots.default={content:defaultContent,on,attrs:null,attrsTranslationCtx:null,scope:defaultSlotScope,};}}
return{type:11,name,isDynamic,dynamicProps,props,propsTranslationCtx,slots,on,};}
function parseTSlot(node,ctx){if(!node.hasAttribute("t-slot")){return null;}
const name=node.getAttribute("t-slot");node.removeAttribute("t-slot");let attrs=null;let attrsTranslationCtx=null;let on=null;for(let attributeName of node.getAttributeNames()){const value=node.getAttribute(attributeName);if(attributeName.startsWith("t-on-")){on=on||{};on[attributeName.slice(5)]=value;}
else if(attributeName.startsWith("t-translation-context-")){const attrName=attributeName.slice(22);attrsTranslationCtx=attrsTranslationCtx||{};attrsTranslationCtx[attrName]=value;}
else{attrs=attrs||{};attrs[attributeName]=value;}}
return{type:14,name,attrs,attrsTranslationCtx,on,defaultContent:parseChildNodes(node,ctx),};}
function parseTTranslation(node,ctx){if(node.getAttribute("t-translation")!=="off"){return null;}
node.removeAttribute("t-translation");return{type:16,content:parseNode(node,ctx),};}
function parseTTranslationContext(node,ctx){const translationCtx=node.getAttribute("t-translation-context");if(!translationCtx){return null;}
node.removeAttribute("t-translation-context");return{type:17,content:parseNode(node,ctx),translationCtx,};}
function parseTPortal(node,ctx){if(!node.hasAttribute("t-portal")){return null;}
const target=node.getAttribute("t-portal");node.removeAttribute("t-portal");const content=parseNode(node,ctx);if(!content){return{type:0,value:"",};}
return{type:18,target,content,};}
function parseChildren(node,ctx){const children=[];for(let child of node.childNodes){const childAst=parseNode(child,ctx);if(childAst){if(childAst.type===3){children.push(...childAst.content);}
else{children.push(childAst);}}}
return children;}
function parseChildNodes(node,ctx){const children=parseChildren(node,ctx);switch(children.length){case 0:return null;case 1:return children[0];default:return{type:3,content:children};}}
function normalizeTIf(el){let tbranch=el.querySelectorAll("[t-elif], [t-else]");for(let i=0,ilen=tbranch.length;i<ilen;i++){let node=tbranch[i];let prevElem=node.previousElementSibling;let pattr=(name)=>prevElem.getAttribute(name);let nattr=(name)=>+!!node.getAttribute(name);if(prevElem&&(pattr("t-if")||pattr("t-elif"))){if(pattr("t-foreach")){throw new OwlError("t-if cannot stay at the same level as t-foreach when using t-elif or t-else");}
if(["t-if","t-elif","t-else"].map(nattr).reduce(function(a,b){return a+b;})>1){throw new OwlError("Only one conditional branching directive is allowed per node");}
let textNode;while((textNode=node.previousSibling)!==prevElem){if(textNode.nodeValue.trim().length&&textNode.nodeType!==8){throw new OwlError("text is not allowed between branching directives");}
textNode.remove();}}
else{throw new OwlError("t-elif and t-else directives must be preceded by a t-if or t-elif directive");}}}
function normalizeTEscTOut(el){for(const d of["t-esc","t-out"]){const elements=[...el.querySelectorAll(`[${d}]`)].filter((el)=>el.tagName[0]===el.tagName[0].toUpperCase()||el.hasAttribute("t-component"));for(const el of elements){if(el.childNodes.length){throw new OwlError(`Cannot have ${d} on a component that already has content`);}
const value=el.getAttribute(d);el.removeAttribute(d);const t=el.ownerDocument.createElement("t");if(value!=null){t.setAttribute(d,value);}
el.appendChild(t);}}}
function normalizeXML(el){normalizeTIf(el);normalizeTEscTOut(el);}
function compile(template,options={hasGlobalValues:false,}){const ast=parse(template,options.customDirectives);const hasSafeContext=template instanceof Node?!(template instanceof Element)||template.querySelector("[t-set], [t-call]")===null:!template.includes("t-set")&&!template.includes("t-call");const codeGenerator=new CodeGenerator(ast,{...options,hasSafeContext});const code=codeGenerator.generateCode();try{return new Function("app, bdom, helpers",code);}
catch(originalError){const{name}=options;const nameStr=name?`template "${name}"`:"anonymous template";const err=new OwlError(`Failed to compile ${nameStr}: ${originalError.message}\n\ngenerated code:\nfunction(app, bdom, helpers) {\n${code}\n}`);err.cause=originalError;throw err;}}
const version="2.7.0";class Scheduler{constructor(){this.tasks=new Set();this.frame=0;this.delayedRenders=[];this.cancelledNodes=new Set();this.processing=false;this.requestAnimationFrame=Scheduler.requestAnimationFrame;}
addFiber(fiber){this.tasks.add(fiber.root);}
scheduleDestroy(node){this.cancelledNodes.add(node);if(this.frame===0){this.frame=this.requestAnimationFrame(()=>this.processTasks());}}
flush(){if(this.delayedRenders.length){let renders=this.delayedRenders;this.delayedRenders=[];for(let f of renders){if(f.root&&f.node.status!==3&&f.node.fiber===f){f.render();}}}
if(this.frame===0){this.frame=this.requestAnimationFrame(()=>this.processTasks());}}
processTasks(){if(this.processing){return;}
this.processing=true;this.frame=0;for(let node of this.cancelledNodes){node._destroy();}
this.cancelledNodes.clear();for(let task of this.tasks){this.processFiber(task);}
for(let task of this.tasks){if(task.node.status===3){this.tasks.delete(task);}}
this.processing=false;}
processFiber(fiber){if(fiber.root!==fiber){this.tasks.delete(fiber);return;}
const hasError=fibersInError.has(fiber);if(hasError&&fiber.counter!==0){this.tasks.delete(fiber);return;}
if(fiber.node.status===3){this.tasks.delete(fiber);return;}
if(fiber.counter===0){if(!hasError){fiber.complete();}
if(fiber.appliedToDom){this.tasks.delete(fiber);}}}}
Scheduler.requestAnimationFrame=window.requestAnimationFrame.bind(window);let hasBeenLogged=false;const apps=new Set();window.__OWL_DEVTOOLS__||(window.__OWL_DEVTOOLS__={apps,Fiber,RootFiber,toRaw,reactive});class App extends TemplateSet{constructor(Root,config={}){super(config);this.scheduler=new Scheduler();this.subRoots=new Set();this.root=null;this.name=config.name||"";this.Root=Root;apps.add(this);if(config.test){this.dev=true;}
this.warnIfNoStaticProps=config.warnIfNoStaticProps||false;if(this.dev&&!config.test&&!hasBeenLogged){console.info(`Owl is running in 'dev' mode.`);hasBeenLogged=true;}
const env=config.env||{};const descrs=Object.getOwnPropertyDescriptors(env);this.env=Object.freeze(Object.create(Object.getPrototypeOf(env),descrs));this.props=config.props||{};}
mount(target,options){const root=this.createRoot(this.Root,{props:this.props});this.root=root.node;this.subRoots.delete(root.node);return root.mount(target,options);}
createRoot(Root,config={}){const props=config.props||{};const env=this.env;if(config.env){this.env=config.env;}
const restore=saveCurrent();const node=this.makeNode(Root,props);restore();if(config.env){this.env=env;}
this.subRoots.add(node);return{node,mount:(target,options)=>{App.validateTarget(target);if(this.dev){validateProps(Root,props,{__owl__:{app:this}});}
const prom=this.mountNode(node,target,options);return prom;},destroy:()=>{this.subRoots.delete(node);node.destroy();this.scheduler.processTasks();},};}
makeNode(Component,props){return new ComponentNode(Component,props,this,null,null);}
mountNode(node,target,options){const promise=new Promise((resolve,reject)=>{let isResolved=false;node.mounted.push(()=>{resolve(node.component);isResolved=true;});let handlers=nodeErrorHandlers.get(node);if(!handlers){handlers=[];nodeErrorHandlers.set(node,handlers);}
handlers.unshift((e)=>{if(!isResolved){reject(e);}
throw e;});});node.mountComponent(target,options);return promise;}
destroy(){if(this.root){for(let subroot of this.subRoots){subroot.destroy();}
this.root.destroy();this.scheduler.processTasks();}
apps.delete(this);}
createComponent(name,isStatic,hasSlotsProp,hasDynamicPropList,propList){const isDynamic=!isStatic;let arePropsDifferent;const hasNoProp=propList.length===0;if(hasSlotsProp){arePropsDifferent=(_1,_2)=>true;}
else if(hasDynamicPropList){arePropsDifferent=function(props1,props2){for(let k in props1){if(props1[k]!==props2[k]){return true;}}
return Object.keys(props1).length!==Object.keys(props2).length;};}
else if(hasNoProp){arePropsDifferent=(_1,_2)=>false;}
else{arePropsDifferent=function(props1,props2){for(let p of propList){if(props1[p]!==props2[p]){return true;}}
return false;};}
const updateAndRender=ComponentNode.prototype.updateAndRender;const initiateRender=ComponentNode.prototype.initiateRender;return(props,key,ctx,parent,C)=>{let children=ctx.children;let node=children[key];if(isDynamic&&node&&node.component.constructor!==C){node=undefined;}
const parentFiber=ctx.fiber;if(node){if(arePropsDifferent(node.props,props)||parentFiber.deep||node.forceNextRender){node.forceNextRender=false;updateAndRender.call(node,props,parentFiber);}}
else{if(isStatic){const components=parent.constructor.components;if(!components){throw new OwlError(`Cannot find the definition of component "${name}", missing static components key in parent`);}
C=components[name];if(!C){throw new OwlError(`Cannot find the definition of component "${name}"`);}
else if(!(C.prototype instanceof Component)){throw new OwlError(`"${name}" is not a Component. It must inherit from the Component class`);}}
node=new ComponentNode(C,props,this,ctx,key);children[key]=node;initiateRender.call(node,new Fiber(node,parentFiber));}
parentFiber.childrenMap[key]=node;return node;};}
handleError(...args){return handleError(...args);}}
App.validateTarget=validateTarget;App.apps=apps;App.version=version;async function mount(C,target,config={}){return new App(C,config).mount(target,config);}
const mainEventHandler=(data,ev,currentTarget)=>{const{data:_data,modifiers}=filterOutModifiersFromData(data);data=_data;let stopped=false;if(modifiers.length){let selfMode=false;const isSelf=ev.target===currentTarget;for(const mod of modifiers){switch(mod){case"self":selfMode=true;if(isSelf){continue;}
else{return stopped;}
case"prevent":if((selfMode&&isSelf)||!selfMode)
ev.preventDefault();continue;case"stop":if((selfMode&&isSelf)||!selfMode)
ev.stopPropagation();stopped=true;continue;}}}
if(Object.hasOwnProperty.call(data,0)){const handler=data[0];if(typeof handler!=="function"){throw new OwlError(`Invalid handler (expected a function, received: '${handler}')`);}
let node=data[1]?data[1].__owl__:null;if(node?node.status===1:true){handler.call(node?node.component:null,ev);}}
return stopped;};function status(component){switch(component.__owl__.status){case 0:return"new";case 2:return"cancelled";case 1:return"mounted";case 3:return"destroyed";}}
function useRef(name){const node=getCurrent();const refs=node.refs;return{get el(){const el=refs[name];return inOwnerDocument(el)?el:null;},};}
function useEnv(){return getCurrent().component.env;}
function extendEnv(currentEnv,extension){const env=Object.create(currentEnv);const descrs=Object.getOwnPropertyDescriptors(extension);return Object.freeze(Object.defineProperties(env,descrs));}
function useSubEnv(envExtension){const node=getCurrent();node.component.env=extendEnv(node.component.env,envExtension);useChildSubEnv(envExtension);}
function useChildSubEnv(envExtension){const node=getCurrent();node.childEnv=extendEnv(node.childEnv,envExtension);}
function useEffect(effect,computeDependencies=()=>[NaN]){let cleanup;let dependencies;onMounted(()=>{dependencies=computeDependencies();cleanup=effect(...dependencies);});onPatched(()=>{const newDeps=computeDependencies();const shouldReapply=newDeps.some((val,i)=>val!==dependencies[i]);if(shouldReapply){dependencies=newDeps;if(cleanup){cleanup();}
cleanup=effect(...dependencies);}});onWillUnmount(()=>cleanup&&cleanup());}
function useExternalListener(target,eventName,handler,eventParams){const node=getCurrent();const boundHandler=handler.bind(node.component);onMounted(()=>target.addEventListener(eventName,boundHandler,eventParams));onWillUnmount(()=>target.removeEventListener(eventName,boundHandler,eventParams));}
config.shouldNormalizeDom=false;config.mainEventHandler=mainEventHandler;const blockDom={config,mount:mount$1,patch,remove,list,multi,text,toggler,createBlock,html,comment,};const __info__={version:App.version,};TemplateSet.prototype._compileTemplate=function _compileTemplate(name,template){return compile(template,{name,dev:this.dev,translateFn:this.translateFn,translatableAttributes:this.translatableAttributes,customDirectives:this.customDirectives,hasGlobalValues:this.hasGlobalValues,});};exports.App=App;exports.Component=Component;exports.EventBus=EventBus;exports.OwlError=OwlError;exports.__info__=__info__;exports.batched=batched;exports.blockDom=blockDom;exports.htmlEscape=htmlEscape;exports.loadFile=loadFile;exports.markRaw=markRaw;exports.markup=markup;exports.mount=mount;exports.onError=onError;exports.onMounted=onMounted;exports.onPatched=onPatched;exports.onRendered=onRendered;exports.onWillDestroy=onWillDestroy;exports.onWillPatch=onWillPatch;exports.onWillRender=onWillRender;exports.onWillStart=onWillStart;exports.onWillUnmount=onWillUnmount;exports.onWillUpdateProps=onWillUpdateProps;exports.reactive=reactive;exports.status=status;exports.toRaw=toRaw;exports.useChildSubEnv=useChildSubEnv;exports.useComponent=useComponent;exports.useEffect=useEffect;exports.useEnv=useEnv;exports.useExternalListener=useExternalListener;exports.useRef=useRef;exports.useState=useState;exports.useSubEnv=useSubEnv;exports.validate=validate;exports.validateType=validateType;exports.whenReady=whenReady;exports.xml=xml;Object.defineProperty(exports,'__esModule',{value:true});__info__.date='2025-03-26T12:58:40.935Z';__info__.hash='e788e36';__info__.url='https://github.com/odoo/owl';})(this.owl=this.owl||{});;

/* /web/static/lib/owl/odoo_module.js */
odoo.define("@odoo/owl",[],function(){"use strict";return owl;});;

/* /web/static/src/env.js */
odoo.define('@web/env',['@odoo/owl','@web/core/utils/hooks','@web/core/registry','@web/core/templates','@web/core/l10n/translation','@web/session'],function(require){'use strict';let __exports={};const{App,EventBus}=require("@odoo/owl");const{SERVICES_METADATA}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const{getTemplate}=require("@web/core/templates");const{_t}=require("@web/core/l10n/translation");const{session}=require("@web/session");__exports.makeEnv=makeEnv;function makeEnv(){return{bus:new EventBus(),services:{},debug:odoo.debug,get isSmall(){throw new Error("UI service not initialized!");},};}
const serviceRegistry=registry.category("services");serviceRegistry.addValidation({start:Function,dependencies:{type:Array,element:String,optional:true},async:{type:[{type:Array,element:String},{value:true}],optional:true},"*":true,});let startServicesPromise=null;__exports.startServices=startServices;async function startServices(env){await Promise.resolve();const toStart=new Map();serviceRegistry.addEventListener("UPDATE",async(ev)=>{await Promise.resolve();const{operation,key:name,value:service}=ev.detail;if(operation==="delete"){return;}
if(toStart.size){const namedService=Object.assign(Object.create(service),{name});toStart.set(name,namedService);}else{await _startServices(env,toStart);}});await _startServices(env,toStart);}
async function _startServices(env,toStart){if(startServicesPromise){return startServicesPromise.then(()=>_startServices(env,toStart));}
const services=env.services;for(const[name,service]of serviceRegistry.getEntries()){if(!(name in services)){const namedService=Object.assign(Object.create(service),{name});toStart.set(name,namedService);}}
async function start(){let service=null;const proms=[];while((service=findNext())){const name=service.name;toStart.delete(name);const entries=(service.dependencies||[]).map((dep)=>[dep,services[dep]]);const dependencies=Object.fromEntries(entries);if(name in services){continue;}
const value=service.start(env,dependencies);if("async"in service){SERVICES_METADATA[name]=service.async;}
proms.push(Promise.resolve(value).then((val)=>{services[name]=val||null;}));}
await Promise.all(proms);if(proms.length){return start();}}
startServicesPromise=start().finally(()=>{startServicesPromise=null;});await startServicesPromise;if(toStart.size){const missingDeps=new Set();for(const service of toStart.values()){for(const dependency of service.dependencies){if(!(dependency in services)&&!toStart.has(dependency)){missingDeps.add(dependency);}}}
const depNames=[...missingDeps].join(", ");throw new Error(`Some services could not be started: ${[
                ...toStart.keys(),
            ]}. Missing dependencies: ${depNames}`);}
function findNext(){for(const s of toStart.values()){if(s.dependencies){if(s.dependencies.every((d)=>d in services)){return s;}}else{return s;}}
return null;}}
__exports.mountComponent=mountComponent;async function mountComponent(component,target,appConfig={}){let{env}=appConfig;const isRoot=!env;if(isRoot){env=await makeEnv();await startServices(env);}
const app=new App(component,{env,getTemplate,dev:env.debug||session.test_mode,warnIfNoStaticProps:!session.test_mode,name:component.constructor.name,translatableAttributes:["data-tooltip"],translateFn:_t,...appConfig,});const root=await app.mount(target);if(isRoot){odoo.__WOWL_DEBUG__={root};}
return app;}
return __exports;});;

/* /web/static/src/session.js */
odoo.define('@web/session',[],function(require){'use strict';let __exports={};const session=__exports.session=odoo.__session_info__||{};delete odoo.__session_info__;return __exports;});;

/* /web/static/src/core/action_swiper/action_swiper.js */
odoo.define('@web/core/action_swiper/action_swiper',['@web/core/browser/browser','@web/core/l10n/localization','@web/core/utils/numbers','@odoo/owl','@web/core/utils/concurrency'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{localization}=require("@web/core/l10n/localization");const{clamp}=require("@web/core/utils/numbers");const{Component,onMounted,onWillUnmount,useRef,useState}=require("@odoo/owl");const{Deferred}=require("@web/core/utils/concurrency");const isScrollSwipable=(scrollables)=>{return{left:!scrollables.filter((e)=>e.scrollLeft!==0).length,right:!scrollables.filter((e)=>e.scrollLeft+Math.round(e.getBoundingClientRect().width)!==e.scrollWidth).length,};};const ActionSwiper=__exports.ActionSwiper=class ActionSwiper extends Component{static template="web.ActionSwiper";static props={onLeftSwipe:{type:Object,args:{action:Function,icon:String,bgColor:String,},optional:true,},onRightSwipe:{type:Object,args:{action:Function,icon:String,bgColor:String,},optional:true,},slots:Object,animationOnMove:{type:Boolean,optional:true},animationType:{type:String,optional:true},swipeDistanceRatio:{type:Number,optional:true},swipeInvalid:{type:Function,optional:true},};static defaultProps={onLeftSwipe:undefined,onRightSwipe:undefined,animationOnMove:true,animationType:"bounce",swipeDistanceRatio:2,};setup(){this.actionTimeoutId=null;this.resetTimeoutId=null;this.defaultState={containerStyle:"",isSwiping:false,width:undefined,};this.root=useRef("root");this.targetContainer=useRef("targetContainer");this.state=useState({...this.defaultState});this.scrollables=undefined;this.startX=undefined;this.swipedDistance=0;this.isScrollValidated=false;onMounted(()=>{if(this.targetContainer.el){this.state.width=this.targetContainer.el.getBoundingClientRect().width;}
if(this.props.onLeftSwipe||this.props.onRightSwipe){const classes=new Set(this.root.el.classList);classes.delete("o_actionswiper");for(const className of classes){this.targetContainer.el.firstChild.classList.add(className);this.root.el.classList.remove(className);}}});onWillUnmount(()=>{browser.clearTimeout(this.actionTimeoutId);browser.clearTimeout(this.resetTimeoutId);});}
get localizedProps(){return{onLeftSwipe:localization.direction==="rtl"?this.props.onRightSwipe:this.props.onLeftSwipe,onRightSwipe:localization.direction==="rtl"?this.props.onLeftSwipe:this.props.onRightSwipe,};}
_onTouchEndSwipe(){if(this.state.isSwiping){this.state.isSwiping=false;if(this.localizedProps.onRightSwipe&&this.swipedDistance>this.state.width/this.props.swipeDistanceRatio){this.swipedDistance=this.state.width;this.handleSwipe(this.localizedProps.onRightSwipe.action);}else if(this.localizedProps.onLeftSwipe&&this.swipedDistance<-this.state.width/this.props.swipeDistanceRatio){this.swipedDistance=-this.state.width;this.handleSwipe(this.localizedProps.onLeftSwipe.action);}else{this.state.containerStyle="";}}}
_onTouchMoveSwipe(ev){if(this.state.isSwiping){if(this.props.swipeInvalid&&this.props.swipeInvalid()){this.state.isSwiping=false;return;}
const{onLeftSwipe,onRightSwipe}=this.localizedProps;this.swipedDistance=clamp(ev.touches[0].clientX-this.startX,onLeftSwipe?-this.state.width:0,onRightSwipe?this.state.width:0);if(Math.abs(this.swipedDistance)>40){ev.preventDefault();}
if(!this.isScrollValidated&&this.scrollables&&!isScrollSwipable(this.scrollables)[this.swipedDistance>0?"left":"right"]){return this._reset();}
this.isScrollValidated=true;if(this.props.animationOnMove){this.state.containerStyle=`transform: translateX(${this.swipedDistance}px)`;}}}
_onTouchStartSwipe(ev){this.scrollables=ev.composedPath().filter((e)=>e.nodeType===1&&this.targetContainer.el.contains(e)&&e.scrollWidth>e.getBoundingClientRect().width&&["auto","scroll"].includes(window.getComputedStyle(e)["overflow-x"]));if(!this.state.width){this.state.width=this.targetContainer&&this.targetContainer.el.getBoundingClientRect().width;}
this.state.isSwiping=true;this.isScrollValidated=false;this.startX=ev.touches[0].clientX;}
_reset(){Object.assign(this.state,{...this.defaultState});this.scrollables=undefined;this.startX=undefined;this.swipedDistance=0;this.isScrollValidated=false;}
handleSwipe(action){if(this.props.animationType==="bounce"){this.state.containerStyle=`transform: translateX(${this.swipedDistance}px)`;this.actionTimeoutId=browser.setTimeout(async()=>{await action(Promise.resolve());this._reset();},500);}else if(this.props.animationType==="forwards"){this.state.containerStyle=`transform: translateX(${this.swipedDistance}px)`;this.actionTimeoutId=browser.setTimeout(async()=>{const prom=new Deferred();await action(prom);this.state.isSwiping=true;this.state.containerStyle=`transform: translateX(${-this.swipedDistance}px)`;this.resetTimeoutId=browser.setTimeout(()=>{prom.resolve();this._reset();},100);},100);}else{return action(Promise.resolve());}}}
return __exports;});;

/* /web/static/src/core/anchor_scroll_prevention.js */
odoo.define('@web/core/anchor_scroll_prevention',['@web/core/browser/browser'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");browser.addEventListener("click",(ev)=>{const href=ev.target.closest("a")?.getAttribute("href");if(href&&href==="#"){ev.preventDefault();return;}});return __exports;});;

/* /web/static/src/core/assets.js */
odoo.define('@web/core/assets',['@odoo/owl','@web/session','@web/core/registry'],function(require){'use strict';let __exports={};const{Component,onWillStart,whenReady,xml}=require("@odoo/owl");const{session}=require("@web/session");const{registry}=require("@web/core/registry");const computeCacheMap=()=>{for(const script of document.head.querySelectorAll("script[src]")){cacheMap.set(script.src,Promise.resolve());}
for(const link of document.head.querySelectorAll("link[rel=stylesheet][href]")){cacheMap.set(link.href,Promise.resolve());}};const onLoadAndError=(el,onLoad,onError)=>{const onLoadListener=(event)=>{removeListeners();onLoad(event);};const onErrorListener=(error)=>{removeListeners();onError(error);};const removeListeners=()=>{el.removeEventListener("load",onLoadListener);el.removeEventListener("error",onErrorListener);};el.addEventListener("load",onLoadListener);el.addEventListener("error",onErrorListener);};const cacheMap=new Map();whenReady(computeCacheMap);__exports.getBundle=getBundle;function getBundle(){return assets.getBundle(...arguments);}
__exports.loadBundle=loadBundle;function loadBundle(){return assets.loadBundle(...arguments);}
__exports.loadJS=loadJS;function loadJS(){return assets.loadJS(...arguments);}
__exports.loadCSS=loadCSS;function loadCSS(){return assets.loadCSS(...arguments);}
const AssetsLoadingError=__exports.AssetsLoadingError=class AssetsLoadingError extends Error{}
const LazyComponent=__exports.LazyComponent=class LazyComponent extends Component{static template=xml`<t t-component="Component" t-props="props.props"/>`;static props={Component:String,bundle:String,props:{type:Object,optional:true},};setup(){onWillStart(async()=>{await loadBundle(this.props.bundle);this.Component=registry.category("lazy_components").get(this.props.Component);});}}
const assets=__exports.assets={retries:{count:3,delay:5000,extraDelay:2500,},getBundle(bundleName){if(cacheMap.has(bundleName)){return cacheMap.get(bundleName);}
const url=new URL(`/web/bundle/${bundleName}`,location.origin);for(const[key,value]of Object.entries(session.bundle_params||{})){url.searchParams.set(key,value);}
const promise=fetch(url).then(async(response)=>{const cssLibs=[];const jsLibs=[];if(!response.bodyUsed){const result=await response.json();for(const{src,type}of Object.values(result)){if(type==="link"&&src){cssLibs.push(src);}else if(type==="script"&&src){jsLibs.push(src);}}}
return{cssLibs,jsLibs};}).catch((reason)=>{cacheMap.delete(bundleName);throw reason;});cacheMap.set(bundleName,promise);return promise;},loadBundle(bundleName){if(typeof bundleName!=="string"){throw new Error(`loadBundle(bundleName:string) accepts only bundleName argument as a string ! Not ${JSON.stringify(
                    bundleName
                )} as ${typeof bundleName}`);}
return getBundle(bundleName).then(({cssLibs,jsLibs})=>Promise.all([...cssLibs.map(loadCSS),...jsLibs.map(loadJS)]));},loadCSS(url,retryCount=0){if(cacheMap.has(url)){return cacheMap.get(url);}
const linkEl=document.createElement("link");linkEl.type="text/css";linkEl.rel="stylesheet";linkEl.href=url;const promise=new Promise((resolve,reject)=>onLoadAndError(linkEl,resolve,async()=>{cacheMap.delete(url);if(retryCount<assets.retries.count){const delay=assets.retries.delay+assets.retries.extraDelay*retryCount;await new Promise((res)=>setTimeout(res,delay));linkEl.remove();loadCSS(url,retryCount+1).then(resolve).catch((reason)=>{cacheMap.delete(url);reject(reason);});}else{reject(new AssetsLoadingError(`The loading of ${url} failed`));}}));cacheMap.set(url,promise);document.head.appendChild(linkEl);return promise;},loadJS(url){if(cacheMap.has(url)){return cacheMap.get(url);}
const scriptEl=document.createElement("script");scriptEl.type=url.includes("web/static/lib/pdfjs/")?"module":"text/javascript";scriptEl.src=url;const promise=new Promise((resolve,reject)=>onLoadAndError(scriptEl,resolve,()=>{cacheMap.delete(url);reject(new AssetsLoadingError(`The loading of ${url} failed`));}));cacheMap.set(url,promise);document.head.appendChild(scriptEl);return promise;},};return __exports;});;

/* /web/static/src/core/autocomplete/autocomplete.js */
odoo.define('@web/core/autocomplete/autocomplete',['@web/core/utils/concurrency','@web/core/utils/hooks','@web/core/utils/scrolling','@web/core/utils/timing','@web/core/hotkeys/hotkey_service','@web/core/position/position_hook','@odoo/owl'],function(require){'use strict';let __exports={};const{Deferred}=require("@web/core/utils/concurrency");const{useAutofocus,useForwardRefToParent,useService}=require("@web/core/utils/hooks");const{isScrollableY,scrollTo}=require("@web/core/utils/scrolling");const{useDebounced}=require("@web/core/utils/timing");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const{usePosition}=require("@web/core/position/position_hook");const{Component,onWillUpdateProps,useExternalListener,useRef,useState}=require("@odoo/owl");const AutoComplete=__exports.AutoComplete=class AutoComplete extends Component{static template="web.AutoComplete";static props={value:{type:String,optional:true},id:{type:String,optional:true},onSelect:{type:Function},sources:{type:Array,element:{type:Object,shape:{placeholder:{type:String,optional:true},optionTemplate:{type:String,optional:true},options:[Array,Function],},},},placeholder:{type:String,optional:true},autoSelect:{type:Boolean,optional:true},resetOnSelect:{type:Boolean,optional:true},onInput:{type:Function,optional:true},onCancel:{type:Function,optional:true},onChange:{type:Function,optional:true},onBlur:{type:Function,optional:true},onFocus:{type:Function,optional:true},input:{type:Function,optional:true},dropdown:{type:Boolean,optional:true},autofocus:{type:Boolean,optional:true},class:{type:String,optional:true},};static defaultProps={value:"",placeholder:"",autoSelect:false,dropdown:true,onInput:()=>{},onCancel:()=>{},onChange:()=>{},onBlur:()=>{},onFocus:()=>{},};setup(){this.nextSourceId=0;this.nextOptionId=0;this.sources=[];this.inEdition=false;this.timeout=250;this.state=useState({navigationRev:0,optionsRev:0,open:false,activeSourceOption:null,value:this.props.value,});this.inputRef=useForwardRefToParent("input");this.listRef=useRef("sourcesList");if(this.props.autofocus){useAutofocus({refName:"input"});}
this.root=useRef("root");this.debouncedProcessInput=useDebounced(async()=>{const currentPromise=this.pendingPromise;this.pendingPromise=null;this.props.onInput({inputValue:this.inputRef.el.value,});try{await this.open(true);currentPromise.resolve();}catch{currentPromise.reject();}finally{if(currentPromise===this.loadingPromise){this.loadingPromise=null;}}},this.timeout);useExternalListener(window,"scroll",this.externalClose,true);useExternalListener(window,"pointerdown",this.externalClose,true);this.hotkey=useService("hotkey");this.hotkeysToRemove=[];onWillUpdateProps((nextProps)=>{if(this.props.value!==nextProps.value||this.forceValFromProp){this.forceValFromProp=false;if(!this.inEdition){this.state.value=nextProps.value;this.inputRef.el.value=nextProps.value;}
this.close();}});if(this.props.dropdown){usePosition("sourcesList",()=>this.targetDropdown,this.dropdownOptions);}else{this.open(false);}}
get targetDropdown(){return this.inputRef.el;}
get activeSourceOptionId(){if(!this.isOpened||!this.state.activeSourceOption){return undefined;}
const[sourceIndex,optionIndex]=this.state.activeSourceOption;const source=this.sources[sourceIndex];return`${this.props.id || "autocomplete"}_${sourceIndex}_${
            source.isLoading ? "loading" : optionIndex
        }`;}
get dropdownOptions(){return{position:"bottom-start",};}
get isOpened(){return this.state.open;}
get hasOptions(){for(const source of this.sources){if(source.isLoading||source.options.length){return true;}}
return false;}
get activeOption(){const[sourceIndex,optionIndex]=this.state.activeSourceOption;return this.sources[sourceIndex].options[optionIndex];}
open(useInput=false){this.state.open=true;return this.loadSources(useInput);}
close(){this.state.open=false;this.state.activeSourceOption=null;}
cancel(){if(this.inputRef.el.value.length){if(this.props.autoSelect){this.inputRef.el.value=this.props.value;this.props.onCancel();}}
this.close();}
async loadSources(useInput){this.sources=[];this.state.activeSourceOption=null;const proms=[];for(const pSource of this.props.sources){const source=this.makeSource(pSource);this.sources.push(source);const options=this.loadOptions(pSource.options,useInput?this.inputRef.el.value.trim():"");if(options instanceof Promise){source.isLoading=true;const prom=options.then((options)=>{source.options=options.map((option)=>this.makeOption(option));source.isLoading=false;this.state.optionsRev++;});proms.push(prom);}else{source.options=options.map((option)=>this.makeOption(option));}}
await Promise.all(proms);this.navigate(0);}
get displayOptions(){return!this.props.dropdown||(this.isOpened&&this.hasOptions);}
loadOptions(options,request){if(typeof options==="function"){return options(request);}else{return options;}}
makeOption(option){return Object.assign(Object.create(option),{id:++this.nextOptionId,});}
makeSource(source){return{id:++this.nextSourceId,options:[],isLoading:false,placeholder:source.placeholder,optionTemplate:source.optionTemplate,};}
isActiveSourceOption([sourceIndex,optionIndex]){return(this.state.activeSourceOption&&this.state.activeSourceOption[0]===sourceIndex&&this.state.activeSourceOption[1]===optionIndex);}
selectOption(option,params={}){this.inEdition=false;if(option.unselectable){this.inputRef.el.value="";this.close();return;}
if(this.props.resetOnSelect){this.inputRef.el.value="";}
this.forceValFromProp=true;this.props.onSelect(option,{...params,input:this.inputRef.el,});this.close();}
navigate(direction){let step=Math.sign(direction);if(!step){this.state.activeSourceOption=null;step=1;}else{this.state.navigationRev++;}
if(this.state.activeSourceOption){let[sourceIndex,optionIndex]=this.state.activeSourceOption;let source=this.sources[sourceIndex];optionIndex+=step;if(0>optionIndex||optionIndex>=source.options.length){sourceIndex+=step;source=this.sources[sourceIndex];while(source&&source.isLoading){sourceIndex+=step;source=this.sources[sourceIndex];}
if(source){optionIndex=step<0?source.options.length-1:0;}}
this.state.activeSourceOption=source?[sourceIndex,optionIndex]:null;}else{let sourceIndex=step<0?this.sources.length-1:0;let source=this.sources[sourceIndex];while(source&&source.isLoading){sourceIndex+=step;source=this.sources[sourceIndex];}
if(source){const optionIndex=step<0?source.options.length-1:0;if(optionIndex<source.options.length){this.state.activeSourceOption=[sourceIndex,optionIndex];}}}}
onInputBlur(){if(this.ignoreBlur){this.ignoreBlur=false;return;}
this.props.onBlur({inputValue:this.inputRef.el.value,});this.inEdition=false;}
onInputClick(){if(!this.isOpened){this.open(this.inputRef.el.value.trim()!==this.props.value.trim());}else{this.close();}}
onInputChange(ev){if(this.ignoreBlur){ev.stopImmediatePropagation();}
this.props.onChange({inputValue:this.inputRef.el.value,});}
async onInput(){this.inEdition=true;this.pendingPromise=this.pendingPromise||new Deferred();this.loadingPromise=this.pendingPromise;this.debouncedProcessInput();}
onInputFocus(ev){this.inputRef.el.setSelectionRange(0,this.inputRef.el.value.length);this.props.onFocus(ev);}
get autoCompleteRootClass(){let classList="";if(this.props.class){classList+=this.props.class;}
if(this.props.dropdown){classList+=" dropdown";}
return classList;}
get ulDropdownClass(){let classList="";if(this.props.dropdown){classList+=" dropdown-menu ui-autocomplete";}else{classList+=" list-group";}
return classList;}
async onInputKeydown(ev){const hotkey=getActiveHotkey(ev);const isSelectKey=hotkey==="enter"||hotkey==="tab";if(this.loadingPromise&&isSelectKey){if(hotkey==="enter"){ev.stopPropagation();ev.preventDefault();}
await this.loadingPromise;}
switch(hotkey){case"enter":if(!this.isOpened||!this.state.activeSourceOption){return;}
this.selectOption(this.activeOption);break;case"escape":if(!this.isOpened){return;}
this.cancel();break;case"tab":case"shift+tab":if(!this.isOpened){return;}
if(this.props.autoSelect&&this.state.activeSourceOption&&(this.state.navigationRev>0||this.inputRef.el.value.length>0)){this.selectOption(this.activeOption);}
this.close();return;case"arrowup":this.navigate(-1);if(!this.isOpened){this.open(true);}
this.scroll();break;case"arrowdown":this.navigate(+1);if(!this.isOpened){this.open(true);}
this.scroll();break;default:return;}
ev.stopPropagation();ev.preventDefault();}
onOptionMouseEnter(indices){this.state.activeSourceOption=indices;}
onOptionMouseLeave(){this.state.activeSourceOption=null;}
onOptionClick(option){this.selectOption(option);this.inputRef.el.focus();}
externalClose(ev){if(this.isOpened&&!this.root.el.contains(ev.target)){this.cancel();}}
scroll(){if(!this.activeSourceOptionId){return;}
if(isScrollableY(this.listRef.el)){scrollTo(this.listRef.el.querySelector(`#${this.activeSourceOptionId}`));}}}
return __exports;});;

/* /web/static/src/core/barcode/ZXingBarcodeDetector.js */
odoo.define('@web/core/barcode/ZXingBarcodeDetector',[],function(require){'use strict';let __exports={};__exports.buildZXingBarcodeDetector=buildZXingBarcodeDetector;function buildZXingBarcodeDetector(ZXing){const ZXingFormats=new Map([["aztec",ZXing.BarcodeFormat.AZTEC],["code_39",ZXing.BarcodeFormat.CODE_39],["code_128",ZXing.BarcodeFormat.CODE_128],["data_matrix",ZXing.BarcodeFormat.DATA_MATRIX],["ean_8",ZXing.BarcodeFormat.EAN_8],["ean_13",ZXing.BarcodeFormat.EAN_13],["itf",ZXing.BarcodeFormat.ITF],["pdf417",ZXing.BarcodeFormat.PDF_417],["qr_code",ZXing.BarcodeFormat.QR_CODE],["upc_a",ZXing.BarcodeFormat.UPC_A],["upc_e",ZXing.BarcodeFormat.UPC_E],]);const allSupportedFormats=Array.from(ZXingFormats.keys());ZXing.HTMLCanvasElementLuminanceSource.toGrayscaleBuffer=function(imageBuffer,width,height){const grayscaleBuffer=new Uint8ClampedArray(width*height);for(let i=0,j=0,length=imageBuffer.length;i<length;i+=4,j++){let gray;const alpha=imageBuffer[i+3];if(alpha===0){gray=0xff;}else{const pixelR=imageBuffer[i];const pixelG=imageBuffer[i+1];const pixelB=imageBuffer[i+2];gray=(306*pixelR+601*pixelG+117*pixelB+0x200)>>10;}
grayscaleBuffer[j]=gray;}
return grayscaleBuffer;};class ZXingBarcodeDetector{constructor(opts={}){const formats=opts.formats||allSupportedFormats;const hints=new Map([[ZXing.DecodeHintType.POSSIBLE_FORMATS,formats.map((format)=>ZXingFormats.get(format)),],[ZXing.DecodeHintType.TRY_HARDER,true],]);this.reader=new ZXing.MultiFormatReader();this.reader.setHints(hints);}
async detect(video){if(!(video instanceof HTMLVideoElement)){throw new DOMException("imageDataFrom() requires an HTMLVideoElement","InvalidArgumentError");}
if(!isVideoElementReady(video)){throw new DOMException("HTMLVideoElement is not ready","InvalidStateError");}
const canvas=document.createElement("canvas");let barcodeArea;if(this.cropArea&&(this.cropArea.x||this.cropArea.y)){barcodeArea=this.cropArea;}else{barcodeArea={x:0,y:0,width:video.videoWidth,height:video.videoHeight,};}
canvas.width=barcodeArea.width;canvas.height=barcodeArea.height;const ctx=canvas.getContext("2d");ctx.drawImage(video,barcodeArea.x,barcodeArea.y,barcodeArea.width,barcodeArea.height,0,0,barcodeArea.width,barcodeArea.height);const luminanceSource=new ZXing.HTMLCanvasElementLuminanceSource(canvas);const binaryBitmap=new ZXing.BinaryBitmap(new ZXing.HybridBinarizer(luminanceSource));try{const result=this.reader.decodeWithState(binaryBitmap);const{resultPoints}=result;const boundingBox=DOMRectReadOnly.fromRect({x:resultPoints[0].x,y:resultPoints[0].y,height:Math.max(1,Math.abs(resultPoints[1].y-resultPoints[0].y)),width:Math.max(1,Math.abs(resultPoints[1].x-resultPoints[0].x)),});const cornerPoints=resultPoints;const format=Array.from(ZXingFormats).find(([k,val])=>val===result.getBarcodeFormat());const rawValue=result.getText();return[{boundingBox,cornerPoints,format,rawValue,},];}catch(err){if(err.name==="NotFoundException"){return[];}
throw err;}}
setCropArea(cropArea){this.cropArea=cropArea;}}
ZXingBarcodeDetector.getSupportedFormats=async()=>allSupportedFormats;return ZXingBarcodeDetector;}
const HAVE_NOTHING=0;const HAVE_METADATA=1;__exports.isVideoElementReady=isVideoElementReady;function isVideoElementReady(video){return![HAVE_NOTHING,HAVE_METADATA].includes(video.readyState);}
return __exports;});;

/* /web/static/src/core/barcode/barcode_dialog.js */
odoo.define('@web/core/barcode/barcode_dialog',['@web/core/l10n/translation','@web/core/dialog/dialog','@odoo/owl','@web/core/barcode/barcode_video_scanner'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Dialog}=require("@web/core/dialog/dialog");const{Component,useState}=require("@odoo/owl");const{BarcodeVideoScanner,isBarcodeScannerSupported}=require("@web/core/barcode/barcode_video_scanner");const BarcodeDialog=__exports.BarcodeDialog=class BarcodeDialog extends Component{static template="web.BarcodeDialog";static components={BarcodeVideoScanner,Dialog,};static props=["facingMode","close","onResult","onError"];setup(){this.state=useState({barcodeScannerSupported:isBarcodeScannerSupported(),errorMessage:_t("Check your browser permissions"),});}
onResult(result){this.props.close();this.props.onResult(result);}
onError(error){this.state.barcodeScannerSupported=false;this.state.errorMessage=error.message;}}
__exports.scanBarcode=scanBarcode;async function scanBarcode(env,facingMode="environment"){let res;let rej;const promise=new Promise((resolve,reject)=>{res=resolve;rej=reject;});env.services.dialog.add(BarcodeDialog,{facingMode,onResult:(result)=>res(result),onError:(error)=>rej(error),});return promise;}
return __exports;});;

/* /web/static/src/core/barcode/barcode_video_scanner.js */
odoo.define('@web/core/barcode/barcode_video_scanner',['@web/core/browser/browser','@web/core/utils/concurrency','@web/core/assets','@web/core/barcode/ZXingBarcodeDetector','@web/core/barcode/crop_overlay','@odoo/owl','@web/core/l10n/translation','@web/core/utils/objects'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{delay}=require("@web/core/utils/concurrency");const{loadJS}=require("@web/core/assets");const{isVideoElementReady,buildZXingBarcodeDetector}=require("@web/core/barcode/ZXingBarcodeDetector");const{CropOverlay}=require("@web/core/barcode/crop_overlay");const{Component,onMounted,onWillStart,onWillUnmount,useRef,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{pick}=require("@web/core/utils/objects");const BarcodeVideoScanner=__exports.BarcodeVideoScanner=class BarcodeVideoScanner extends Component{static template="web.BarcodeVideoScanner";static components={CropOverlay,};static props={cssClass:{type:String,optional:true},facingMode:{type:String,validate:(fm)=>["environment","left","right","user"].includes(fm),},close:{type:Function,optional:true},onReady:{type:Function,optional:true},onResult:Function,onError:Function,delayBetweenScan:{type:Number,optional:true},};static defaultProps={cssClass:"w-100 h-100",};setup(){this.videoPreviewRef=useRef("videoPreview");this.detectorTimeout=null;this.stream=null;this.detector=null;this.overlayInfo={};this.zoomRatio=1;this.scanPaused=false;this.state=useState({isReady:false,});onWillStart(async()=>{let DetectorClass;if("BarcodeDetector"in window){DetectorClass=BarcodeDetector;}else{await loadJS("/web/static/lib/zxing-library/zxing-library.js");DetectorClass=buildZXingBarcodeDetector(window.ZXing);}
const formats=await DetectorClass.getSupportedFormats();this.detector=new DetectorClass({formats});});onMounted(async()=>{const constraints={video:{facingMode:this.props.facingMode},audio:false,};try{this.stream=await browser.navigator.mediaDevices.getUserMedia(constraints);}catch(err){const errors={NotFoundError:_t("No device can be found."),NotAllowedError:_t("Odoo needs your authorization first."),};const errorMessage=_t("Could not start scanning. %(message)s",{message:errors[err.name]||err.message,});this.props.onError(new Error(errorMessage));return;}
if(!this.videoPreviewRef.el){this.cleanStreamAndTimeout();const errorMessage=_t("Barcode Video Scanner could not be mounted properly.");this.props.onError(new Error(errorMessage));return;}
this.videoPreviewRef.el.srcObject=this.stream;await this.isVideoReady();const{height,width}=getComputedStyle(this.videoPreviewRef.el);const divWidth=width.slice(0,-2);const divHeight=height.slice(0,-2);const tracks=this.stream.getVideoTracks();if(tracks.length){const[track]=tracks;const settings=track.getSettings();this.zoomRatio=Math.min(divWidth/settings.width,divHeight/settings.height);}
this.detectorTimeout=setTimeout(this.detectCode.bind(this),100);});onWillUnmount(()=>this.cleanStreamAndTimeout());}
cleanStreamAndTimeout(){clearTimeout(this.detectorTimeout);this.detectorTimeout=null;if(this.stream){this.stream.getTracks().forEach((track)=>track.stop());this.stream=null;}}
isZXingBarcodeDetector(){return this.detector&&this.detector.__proto__.constructor.name==="ZXingBarcodeDetector";}
async isVideoReady(){while(!isVideoElementReady(this.videoPreviewRef.el)){await delay(10);}
this.state.isReady=true;if(this.props.onReady){this.props.onReady();}}
onResize(overlayInfo){this.overlayInfo=overlayInfo;if(this.isZXingBarcodeDetector()){this.detector.setCropArea(this.adaptValuesWithRatio(this.overlayInfo,true));}}
async detectCode(){let barcodeDetected=false;let codes=[];try{codes=await this.detector.detect(this.videoPreviewRef.el);}catch(err){this.props.onError(err);}
for(const code of codes){if(!this.isZXingBarcodeDetector()&&this.overlayInfo.x!==undefined&&this.overlayInfo.y!==undefined){const{x,y,width,height}=this.adaptValuesWithRatio(code.boundingBox);if(x<this.overlayInfo.x||x+width>this.overlayInfo.x+this.overlayInfo.width||y<this.overlayInfo.y||y+height>this.overlayInfo.y+this.overlayInfo.height){continue;}}
barcodeDetected=true;this.barcodeDetected(code.rawValue);break;}
if(this.stream&&(!barcodeDetected||!this.props.delayBetweenScan)){this.detectorTimeout=setTimeout(this.detectCode.bind(this),100);}}
barcodeDetected(barcode){if(this.props.delayBetweenScan&&!this.scanPaused){this.scanPaused=true;this.detectorTimeout=setTimeout(()=>{this.scanPaused=false;this.detectorTimeout=setTimeout(this.detectCode.bind(this),100);},this.props.delayBetweenScan);}
this.props.onResult(barcode);}
adaptValuesWithRatio(domRect,dividerRatio=false){const newObject=pick(domRect,"x","y","width","height");for(const key of Object.keys(newObject)){if(dividerRatio){newObject[key]/=this.zoomRatio;}else{newObject[key]*=this.zoomRatio;}}
return newObject;}}
__exports.isBarcodeScannerSupported=isBarcodeScannerSupported;function isBarcodeScannerSupported(){return Boolean(browser.navigator.mediaDevices&&browser.navigator.mediaDevices.getUserMedia);}
return __exports;});;

/* /web/static/src/core/barcode/crop_overlay.js */
odoo.define('@web/core/barcode/crop_overlay',['@odoo/owl','@web/core/browser/browser','@web/core/utils/numbers'],function(require){'use strict';let __exports={};const{Component,useRef,onPatched}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{clamp}=require("@web/core/utils/numbers");const CropOverlay=__exports.CropOverlay=class CropOverlay extends Component{static template="web.CropOverlay";static props={onResize:Function,isReady:Boolean,slots:{type:Object,shape:{default:{},},},};setup(){this.localStorageKey="o-barcode-scanner-overlay";this.cropContainerRef=useRef("crop-container");this.isMoving=false;this.boundaryOverlay={};this.relativePosition={x:0,y:0,};onPatched(()=>{this.setupCropRect();});}
setupCropRect(){if(!this.props.isReady){return;}
this.computeDefaultPoint();this.computeOverlayPosition();this.calculateAndSetTransparentRect();this.executeOnResizeCallback();}
boundPoint(pointValue,boundaryRect){return{x:clamp(pointValue.x,boundaryRect.left,boundaryRect.left+boundaryRect.width),y:clamp(pointValue.y,boundaryRect.top,boundaryRect.top+boundaryRect.height),};}
calculateAndSetTransparentRect(){const cropTransparentRect=this.getTransparentRec(this.relativePosition,this.boundaryOverlay);this.setCropValue(cropTransparentRect,this.relativePosition);}
computeOverlayPosition(){const cropOverlayElement=this.cropContainerRef.el.querySelector(".o_crop_overlay");this.boundaryOverlay=cropOverlayElement.getBoundingClientRect();}
executeOnResizeCallback(){const transparentRec=this.getTransparentRec(this.relativePosition,this.boundaryOverlay);browser.localStorage.setItem(this.localStorageKey,JSON.stringify(transparentRec));this.props.onResize({...transparentRec,width:this.boundaryOverlay.width-2*transparentRec.x,height:this.boundaryOverlay.height-2*transparentRec.y,});}
computeDefaultPoint(){const firstChildComputedStyle=getComputedStyle(this.cropContainerRef.el.firstChild);const elementWidth=firstChildComputedStyle.width.slice(0,-2);const elementHeight=firstChildComputedStyle.height.slice(0,-2);const stringSavedPoint=browser.localStorage.getItem(this.localStorageKey);if(stringSavedPoint){const savedPoint=JSON.parse(stringSavedPoint);this.relativePosition={x:clamp(savedPoint.x,0,elementWidth),y:clamp(savedPoint.y,0,elementHeight),};}else{const stepWidth=elementWidth/10;const width=stepWidth*8;const height=width/4;const startY=elementHeight/2-height/2;this.relativePosition={x:stepWidth+width,y:startY+height,};}}
getTransparentRec(point,rect){const middleX=rect.width/2;const middleY=rect.height/2;const newDeltaX=Math.abs(point.x-middleX);const newDeltaY=Math.abs(point.y-middleY);return{x:middleX-newDeltaX,y:middleY-newDeltaY,};}
setCropValue(point,iconPoint){if(!iconPoint){iconPoint=point;}
this.cropContainerRef.el.style.setProperty("--o-crop-x",`${point.x}px`);this.cropContainerRef.el.style.setProperty("--o-crop-y",`${point.y}px`);this.cropContainerRef.el.style.setProperty("--o-crop-icon-x",`${iconPoint.x}px`);this.cropContainerRef.el.style.setProperty("--o-crop-icon-y",`${iconPoint.y}px`);}
pointerDown(event){event.preventDefault();if(event.target.matches(".o_crop_icon")){this.computeOverlayPosition();this.isMoving=true;}}
pointerMove(event){if(!this.isMoving){return;}
let eventPosition;if(event.touches&&event.touches.length){eventPosition=event.touches[0];}else{eventPosition=event;}
const{clientX,clientY}=eventPosition;const restrictedPosition=this.boundPoint({x:clientX,y:clientY,},this.boundaryOverlay);this.relativePosition={x:restrictedPosition.x-this.boundaryOverlay.left,y:restrictedPosition.y-this.boundaryOverlay.top,};this.calculateAndSetTransparentRect(this.relativePosition);}
pointerUp(event){this.isMoving=false;this.executeOnResizeCallback();}}
return __exports;});;

/* /web/static/src/core/browser/browser.js */
odoo.define('@web/core/browser/browser',[],function(require){'use strict';let __exports={};let sessionStorage;let localStorage;try{sessionStorage=window.sessionStorage;localStorage=window.localStorage;localStorage.setItem("__localStorage__","true");localStorage.removeItem("__localStorage__");}catch{localStorage=makeRAMLocalStorage();sessionStorage=makeRAMLocalStorage();}
const browser=__exports.browser={addEventListener:window.addEventListener.bind(window),dispatchEvent:window.dispatchEvent.bind(window),AnalyserNode:window.AnalyserNode,Audio:window.Audio,AudioBufferSourceNode:window.AudioBufferSourceNode,AudioContext:window.AudioContext,AudioWorkletNode:window.AudioWorkletNode,BeforeInstallPromptEvent:window.BeforeInstallPromptEvent?.bind(window),GainNode:window.GainNode,MediaStreamAudioSourceNode:window.MediaStreamAudioSourceNode,removeEventListener:window.removeEventListener.bind(window),setTimeout:window.setTimeout.bind(window),clearTimeout:window.clearTimeout.bind(window),setInterval:window.setInterval.bind(window),clearInterval:window.clearInterval.bind(window),performance:window.performance,requestAnimationFrame:window.requestAnimationFrame.bind(window),cancelAnimationFrame:window.cancelAnimationFrame.bind(window),console:window.console,history:window.history,matchMedia:window.matchMedia.bind(window),navigator,Notification:window.Notification,open:window.open.bind(window),SharedWorker:window.SharedWorker,Worker:window.Worker,XMLHttpRequest:window.XMLHttpRequest,localStorage,sessionStorage,fetch:window.fetch.bind(window),innerHeight:window.innerHeight,innerWidth:window.innerWidth,ontouchstart:window.ontouchstart,BroadcastChannel:window.BroadcastChannel,};Object.defineProperty(browser,"location",{set(val){window.location=val;},get(){return window.location;},configurable:true,});Object.defineProperty(browser,"innerHeight",{get:()=>window.innerHeight,configurable:true,});Object.defineProperty(browser,"innerWidth",{get:()=>window.innerWidth,configurable:true,});__exports.makeRAMLocalStorage=makeRAMLocalStorage;function makeRAMLocalStorage(){let store={};return{setItem(key,value){const newValue=String(value);store[key]=newValue;window.dispatchEvent(new StorageEvent("storage",{key,newValue}));},getItem(key){return store[key]??null;},clear(){store={};},removeItem(key){delete store[key];window.dispatchEvent(new StorageEvent("storage",{key,newValue:null}));},get length(){return Object.keys(store).length;},key(){return"";},};}
return __exports;});;

/* /web/static/src/core/browser/cookie.js */
odoo.define('@web/core/browser/cookie',[],function(require){'use strict';let __exports={};const COOKIE_TTL=24*60*60*365;const cookie=__exports.cookie={get _cookieMonster(){return document.cookie;},set _cookieMonster(value){document.cookie=value;},get(str){const parts=this._cookieMonster.split("; ");for(const part of parts){const[key,value]=part.split(/=(.*)/);if(key===str){return value||"";}}},set(key,value,ttl=COOKIE_TTL){let fullCookie=[];if(value!==undefined){fullCookie.push(`${key}=${value}`);}
fullCookie=fullCookie.concat(["path=/",`max-age=${Math.floor(ttl)}`]);this._cookieMonster=fullCookie.join("; ");},delete(key){this.set(key,"kill",0);},};return __exports;});;

/* /web/static/src/core/browser/feature_detection.js */
odoo.define('@web/core/browser/feature_detection',['@web/core/browser/browser'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");__exports.isBrowserChrome=isBrowserChrome;function isBrowserChrome(){return/Chrome/i.test(browser.navigator.userAgent);}
__exports.isBrowserFirefox=isBrowserFirefox;function isBrowserFirefox(){return/Firefox/i.test(browser.navigator.userAgent);}
__exports.isBrowserMicrosoftEdge=isBrowserMicrosoftEdge;function isBrowserMicrosoftEdge(){return/Edg/i.test(browser.navigator.userAgent);}
__exports.isBrowserSafari=isBrowserSafari;function isBrowserSafari(){return!isBrowserChrome()&&browser.navigator.userAgent?.includes("Safari");}
__exports.isAndroid=isAndroid;function isAndroid(){return/Android/i.test(browser.navigator.userAgent);}
__exports.isIOS=isIOS;function isIOS(){return(/(iPad|iPhone|iPod)/i.test(browser.navigator.userAgent)||(browser.navigator.platform==="MacIntel"&&maxTouchPoints()>1));}
__exports.isOtherMobileOS=isOtherMobileOS;function isOtherMobileOS(){return/(webOS|BlackBerry|Windows Phone)/i.test(browser.navigator.userAgent);}
__exports.isMacOS=isMacOS;function isMacOS(){return/Mac/i.test(browser.navigator.userAgent);}
__exports.isMobileOS=isMobileOS;function isMobileOS(){return isAndroid()||isIOS()||isOtherMobileOS();}
__exports.isIosApp=isIosApp;function isIosApp(){return/OdooMobile \(iOS\)/i.test(browser.navigator.userAgent);}
__exports.isAndroidApp=isAndroidApp;function isAndroidApp(){return/OdooMobile.+Android/i.test(browser.navigator.userAgent);}
__exports.isDisplayStandalone=isDisplayStandalone;function isDisplayStandalone(){return browser.matchMedia("(display-mode: standalone)").matches;}
__exports.hasTouch=hasTouch;function hasTouch(){return browser.ontouchstart!==undefined||browser.matchMedia("(pointer:coarse)").matches;}
__exports.maxTouchPoints=maxTouchPoints;function maxTouchPoints(){return browser.navigator.maxTouchPoints||1;}
return __exports;});;

/* /web/static/src/core/browser/router.js */
odoo.define('@web/core/browser/router',['@odoo/owl','@web/core/utils/objects','@web/core/utils/urls','@web/core/browser/browser','@web/core/browser/feature_detection','@web/core/utils/arrays','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{EventBus}=require("@odoo/owl");const{omit,pick}=require("@web/core/utils/objects");const{compareUrls,objectToUrlEncodedString}=require("@web/core/utils/urls");const{browser}=require("@web/core/browser/browser");const{isDisplayStandalone}=require("@web/core/browser/feature_detection");const{slidingWindow}=require("@web/core/utils/arrays");const{isNumeric}=require("@web/core/utils/strings");const PATH_KEYS=__exports.PATH_KEYS=["resId","action","active_id","model"];const routerBus=__exports.routerBus=new EventBus();function isScopedApp(){return browser.location.href.includes("/scoped_app")&&isDisplayStandalone();}
function cast(value){return!value||isNaN(value)?value:Number(value);}
function parseString(str){const parts=str.split("&");const result={};for(const part of parts){const[key,value]=part.split("=");const decoded=decodeURIComponent(value||"");result[key]=cast(decoded);}
return result;}
function computeNextState(values,replace){const nextState=replace?pick(state,..._lockedKeys):{...state};Object.assign(nextState,values);if(nextState.actionStack?.length){Object.assign(nextState.actionStack.at(-1),pick(nextState,...PATH_KEYS));}
return sanitizeSearch(nextState);}
function sanitize(obj,valueToRemove){return Object.fromEntries(Object.entries(obj).filter(([,v])=>v!==valueToRemove).map(([k,v])=>[k,cast(v)]));}
function sanitizeSearch(search){return sanitize(search);}
function sanitizeHash(hash){return sanitize(hash,"");}
__exports.parseHash=parseHash;function parseHash(hash){return hash&&hash!=="#"?parseString(hash.slice(1)):{};}
__exports.parseSearchQuery=parseSearchQuery;function parseSearchQuery(search){return search?parseString(search.slice(1)):{};}
function pathFromActionState(state){const path=[];const{action,model,active_id,resId}=state;if(active_id&&typeof active_id==="number"){path.push(active_id);}
if(action){if(typeof action==="number"||action.includes(".")){path.push(`action-${action}`);}else{path.push(action);}}else if(model){if(model.includes(".")){path.push(model);}else{path.push(`m-${model}`);}}
if(resId&&(typeof resId==="number"||resId==="new")){path.push(resId);}
return path.join("/");}
__exports.stateToUrl=stateToUrl;function stateToUrl(state){let path="";const pathKeysToOmit=[..._hiddenKeysFromUrl];const actionStack=(state.actionStack||[state]).map((a)=>({...a}));if(actionStack.at(-1)?.action!=="menu"){for(const[prevAct,currentAct]of slidingWindow(actionStack,2).reverse()){const{action:prevAction,resId:prevResId,active_id:prevActiveId}=prevAct;const{action:currentAction,active_id:currentActiveId}=currentAct;if(currentActiveId===prevResId){delete currentAct.active_id;}
if(prevAction===currentAction&&!prevResId&&currentActiveId===prevActiveId){delete currentAct.action;delete currentAct.active_id;}}
const pathSegments=actionStack.map(pathFromActionState).filter(Boolean);if(pathSegments.length){path=`/${pathSegments.join("/")}`;}}
if(state.active_id&&typeof state.active_id!=="number"){pathKeysToOmit.splice(pathKeysToOmit.indexOf("active_id"),1);}
if(state.resId&&typeof state.resId!=="number"&&state.resId!=="new"){pathKeysToOmit.splice(pathKeysToOmit.indexOf("resId"),1);}
const search=objectToUrlEncodedString(omit(state,...pathKeysToOmit));const start_url=isScopedApp()?"scoped_app":"odoo";return`/${start_url}${path}${search ? `?${search}` : ""}`;}
__exports.urlToState=urlToState;function urlToState(urlObj){const{pathname,hash,search}=urlObj;const state=parseSearchQuery(search);if(pathname==="/web"){const sanitizedHash=sanitizeHash(parseHash(hash));if(sanitizedHash.id){sanitizedHash.resId=sanitizedHash.id;delete sanitizedHash.id;delete sanitizedHash.view_type;}else if(sanitizedHash.view_type==="form"){sanitizedHash.resId="new";delete sanitizedHash.view_type;}
Object.assign(state,sanitizedHash);const url=browser.location.origin+router.stateToUrl(state);urlObj.href=url;}
const[prefix,...splitPath]=urlObj.pathname.split("/").filter(Boolean);if(prefix==="odoo"||isScopedApp()){const actionParts=[...splitPath.entries()].filter(([_,part])=>!isNumeric(part)&&part!=="new");const actions=[];for(const[i,part]of actionParts){const action={};const[left,right]=[splitPath[i-1],splitPath[i+1]];if(isNumeric(left)){action.active_id=parseInt(left);}
if(right==="new"){action.resId="new";}else if(isNumeric(right)){action.resId=parseInt(right);}
if(part.startsWith("action-")){const actionId=part.slice(7);action.action=isNumeric(actionId)?parseInt(actionId):actionId;}else if(part.startsWith("m-")){action.model=part.slice(2);}else if(part.includes(".")){action.model=part;}else{action.action=part;}
if(action.resId&&action.action){actions.push(omit(action,"resId"));}
if(action.action||action.resId||i===splitPath.length-1){actions.push(action);}}
const activeAction=actions.at(-1);if(activeAction){Object.assign(state,activeAction);state.actionStack=actions;}}
return state;}
let state;let pushTimeout;let pushArgs;let _lockedKeys;let _hiddenKeysFromUrl=new Set();__exports.startRouter=startRouter;function startRouter(){const url=new URL(browser.location);state=router.urlToState(url);if(browser.location.pathname==="/web"){browser.history.replaceState(browser.history.state,null,url.href);}
pushTimeout=null;pushArgs={replace:false,reload:false,state:{},};_lockedKeys=new Set(["debug","lang"]);_hiddenKeysFromUrl=new Set([...PATH_KEYS,"actionStack"]);}
browser.addEventListener("popstate",(ev)=>{browser.clearTimeout(pushTimeout);if(!ev.state){browser.history.replaceState({nextState:state},"",browser.location.href);return;}
state=ev.state?.nextState||router.urlToState(new URL(browser.location));if(!ev.state?.skipRouteChange&&!router.skipLoad){routerBus.trigger("ROUTE_CHANGE");}
router.skipLoad=false;});browser.addEventListener("pageshow",(ev)=>{if(ev.persisted){browser.clearTimeout(pushTimeout);routerBus.trigger("ROUTE_CHANGE");}});browser.addEventListener("click",(ev)=>{if(ev.defaultPrevented||ev.target.closest("[contenteditable]")){return;}
const href=ev.target.closest("a")?.getAttribute("href");if(href&&!href.startsWith("#")){let url;try{url=new URL(ev.target.closest("a").href);}catch{return;}
if(browser.location.host===url.host&&browser.location.pathname.startsWith("/odoo")&&(["/web","/odoo"].includes(url.pathname)||url.pathname.startsWith("/odoo/"))&&ev.target.target!=="_blank"){ev.preventDefault();state=router.urlToState(url);if(url.pathname.startsWith("/odoo")&&url.hash){browser.history.pushState({},"",url.href);}
new Promise((res)=>setTimeout(res,0)).then(()=>routerBus.trigger("ROUTE_CHANGE"));}}});function makeDebouncedPush(mode){function doPush(){const nextState=computeNextState(pushArgs.state,pushArgs.replace);const url=browser.location.origin+router.stateToUrl(nextState);if(!compareUrls(url+browser.location.hash,browser.location.href)){if(mode==="push"){const originalTitle=document.title;document.title=pushArgs.title;browser.history.pushState({nextState},"",url);document.title=originalTitle;}else{browser.history.replaceState({nextState},"",url);}}else{browser.history.replaceState({nextState},"",browser.location.href);}
state=nextState;if(pushArgs.reload){browser.location.reload();}}
return function pushOrReplaceState(state,options={}){pushArgs.replace||=options.replace;pushArgs.reload||=options.reload;pushArgs.title=document.title;Object.assign(pushArgs.state,state);browser.clearTimeout(pushTimeout);const push=()=>{doPush();pushTimeout=null;pushArgs={replace:false,reload:false,state:{},};};if(options.sync){push();}else{pushTimeout=browser.setTimeout(()=>{push();});}};}
const router=__exports.router={get current(){return state;},stateToUrl,urlToState,pushState:makeDebouncedPush("push"),replaceState:makeDebouncedPush("replace"),cancelPushes:()=>browser.clearTimeout(pushTimeout),addLockedKey:(key)=>_lockedKeys.add(key),hideKeyFromUrl:(key)=>_hiddenKeysFromUrl.add(key),skipLoad:false,};startRouter();__exports.objectToQuery=objectToQuery;function objectToQuery(obj){const query={};Object.entries(obj).forEach(([k,v])=>{query[k]=v?String(v):v;});return query;}
return __exports;});;

/* /web/static/src/core/browser/title_service.js */
odoo.define('@web/core/browser/title_service',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const titleService=__exports.titleService={start(){const titleCounters={};const titleParts={};function getParts(){return Object.assign({},titleParts);}
function setCounters(counters){for(const key in counters){const val=counters[key];if(!val){delete titleCounters[key];}else{titleCounters[key]=val;}}
updateTitle();}
function setParts(parts){for(const key in parts){const val=parts[key];if(!val){delete titleParts[key];}else{titleParts[key]=val;}}
updateTitle();}
function updateTitle(){const counter=Object.values(titleCounters).reduce((acc,count)=>acc+count,0);const name=Object.values(titleParts).join(" - ")||"Odoo";if(!counter){document.title=name;}else{document.title=`(${counter}) ${name}`;}}
return{get current(){return document.title;},getParts,setCounters,setParts,};},};registry.category("services").add("title",titleService);return __exports;});;

/* /web/static/src/core/checkbox/checkbox.js */
odoo.define('@web/core/checkbox/checkbox',['@web/core/hotkeys/hotkey_hook','@odoo/owl'],function(require){'use strict';let __exports={};const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{Component,useRef}=require("@odoo/owl");const CheckBox=__exports.CheckBox=class CheckBox extends Component{static template="web.CheckBox";static nextId=1;static defaultProps={onChange:()=>{},};static props={id:{type:true,optional:true,},disabled:{type:Boolean,optional:true,},value:{type:Boolean,optional:true,},slots:{type:Object,optional:true,},onChange:{type:Function,optional:true,},className:{type:String,optional:true,},name:{type:String,optional:true,},};setup(){this.id=`checkbox-comp-${CheckBox.nextId++}`;this.rootRef=useRef("root");useHotkey("Enter",({area})=>{const oldValue=area.querySelector("input").checked;this.props.onChange(!oldValue);},{area:()=>this.rootRef.el,bypassEditableProtection:true});}
onClick(ev){if(ev.composedPath().find((el)=>["INPUT","LABEL"].includes(el.tagName))){ev.stopPropagation();return;}
const input=this.rootRef.el.querySelector("input");input.focus();if(!this.props.disabled){ev.stopPropagation();input.checked=!input.checked;this.props.onChange(input.checked);}}
onChange(ev){if(!this.props.disabled){this.props.onChange(ev.target.checked);}}}
return __exports;});;

/* /web/static/src/core/code_editor/code_editor.js */
odoo.define('@web/core/code_editor/code_editor',['@odoo/owl','@web/core/assets','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{Component,onWillDestroy,onWillStart,useEffect,useRef,useState}=require("@odoo/owl");const{loadBundle}=require("@web/core/assets");const{useDebounced}=require("@web/core/utils/timing");function onResized(ref,callback){const _ref=typeof ref==="string"?useRef(ref):ref;const resizeObserver=new ResizeObserver(callback);useEffect((el)=>{if(el){resizeObserver.observe(el);return()=>resizeObserver.unobserve(el);}},()=>[_ref.el]);onWillDestroy(()=>{resizeObserver.disconnect();});}
const CodeEditor=__exports.CodeEditor=class CodeEditor extends Component{static template="web.CodeEditor";static components={};static props={mode:{type:String,optional:true,validate:(mode)=>CodeEditor.MODES.includes(mode),},value:{validate:(v)=>typeof v==="string",optional:true},readonly:{type:Boolean,optional:true},onChange:{type:Function,optional:true},onBlur:{type:Function,optional:true},class:{type:String,optional:true},theme:{type:String,optional:true,validate:(theme)=>CodeEditor.THEMES.includes(theme),},maxLines:{type:Number,optional:true},sessionId:{type:[Number,String],optional:true},};static defaultProps={readonly:false,value:"",onChange:()=>{},class:"",theme:"",sessionId:1,};static MODES=["javascript","xml","qweb","scss","python"];static THEMES=["","monokai"];setup(){this.editorRef=useRef("editorRef");this.state=useState({activeMode:undefined,});onWillStart(async()=>await loadBundle("web.ace_lib"));const sessions={};let ignoredAceChange=false;useEffect((el)=>{if(!el){return;}
const aceEditor=window.ace.edit(el);this.aceEditor=aceEditor;this.aceEditor.setOptions({maxLines:this.props.maxLines,showPrintMargin:false,useWorker:false,});this.aceEditor.$blockScrolling=true;this.aceEditor.on("changeMode",()=>{this.state.activeMode=this.aceEditor.getSession().$modeId.split("/").at(-1);});const session=aceEditor.getSession();if(!sessions[this.props.sessionId]){sessions[this.props.sessionId]=session;}
session.setValue(this.props.value);session.on("change",()=>{if(this.props.onChange&&!ignoredAceChange){this.props.onChange(this.aceEditor.getValue());}});this.aceEditor.on("blur",()=>{if(this.props.onBlur){this.props.onBlur();}});return()=>{aceEditor.destroy();};},()=>[this.editorRef.el]);useEffect((theme)=>this.aceEditor.setTheme(theme?`ace/theme/${theme}`:""),()=>[this.props.theme]);useEffect((readonly)=>{this.aceEditor.setOptions({readOnly:readonly,highlightActiveLine:!readonly,highlightGutterLine:!readonly,});this.aceEditor.renderer.setOptions({displayIndentGuides:!readonly,showGutter:!readonly,});this.aceEditor.renderer.$cursorLayer.element.style.display=readonly?"none":"block";},()=>[this.props.readonly]);useEffect((sessionId,mode,value)=>{let session=sessions[sessionId];if(session){if(session.getValue()!==value){ignoredAceChange=true;session.setValue(value);ignoredAceChange=false;}}else{session=new window.ace.EditSession(value);session.setUndoManager(new window.ace.UndoManager());session.setOptions({useWorker:false,tabSize:2,useSoftTabs:true,});session.on("change",()=>{if(this.props.onChange&&!ignoredAceChange){this.props.onChange(this.aceEditor.getValue());}});sessions[sessionId]=session;}
session.setMode(mode?`ace/mode/${mode}`:"");this.aceEditor.setSession(session);},()=>[this.props.sessionId,this.props.mode,this.props.value]);const debouncedResize=useDebounced(()=>{if(this.aceEditor){this.aceEditor.resize();}},250);onResized(this.editorRef,debouncedResize);}}
return __exports;});;

/* /web/static/src/core/colorlist/colorlist.js */
odoo.define('@web/core/colorlist/colorlist',['@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component,useRef,useState,useExternalListener}=require("@odoo/owl");const ColorList=__exports.ColorList=class ColorList extends Component{static COLORS=[_t("No color"),_t("Red"),_t("Orange"),_t("Yellow"),_t("Cyan"),_t("Purple"),_t("Almond"),_t("Teal"),_t("Blue"),_t("Raspberry"),_t("Green"),_t("Violet"),];static template="web.ColorList";static defaultProps={forceExpanded:false,isExpanded:false,};static props={canToggle:{type:Boolean,optional:true},colors:Array,forceExpanded:{type:Boolean,optional:true},isExpanded:{type:Boolean,optional:true},onColorSelected:Function,selectedColor:{type:Number,optional:true},};setup(){this.colorlistRef=useRef("colorlist");this.state=useState({isExpanded:this.props.isExpanded});useExternalListener(window,"click",this.onOutsideClick);}
get colors(){return this.constructor.COLORS;}
onColorSelected(id){this.props.onColorSelected(id);if(!this.props.forceExpanded){this.state.isExpanded=false;}}
onOutsideClick(ev){if(this.colorlistRef.el.contains(ev.target)||this.props.forceExpanded){return;}
this.state.isExpanded=false;}
onToggle(ev){if(this.props.canToggle){ev.preventDefault();ev.stopPropagation();this.state.isExpanded=!this.state.isExpanded;this.colorlistRef.el.firstElementChild.focus();}}}
return __exports;});;

/* /web/static/src/core/colorpicker/colorpicker.js */
odoo.define('@web/core/colorpicker/colorpicker',['@web/core/utils/colors','@web/core/utils/functions','@web/core/utils/numbers','@web/core/utils/timing','@odoo/owl'],function(require){'use strict';let __exports={};const{convertCSSColorToRgba,convertHslToRgb,convertRgbaToCSSColor,convertRgbToHsl,}=require("@web/core/utils/colors");const{uniqueId}=require("@web/core/utils/functions");const{clamp}=require("@web/core/utils/numbers");const{debounce,useThrottleForAnimation}=require("@web/core/utils/timing");const{Component,onMounted,onWillUpdateProps,useExternalListener,useRef}=require("@odoo/owl");const Colorpicker=__exports.Colorpicker=class Colorpicker extends Component{static template="web.Colorpicker";static props={document:{type:true,optional:true},defaultColor:{type:String,optional:true},selectedColor:{type:String,optional:true},noTransparency:{type:Boolean,optional:true},stopClickPropagation:{type:Boolean,optional:true},onColorSelect:{type:Function,optional:true},onColorPreview:{type:Function,optional:true},onInputEnter:{type:Function,optional:true},};static defaultProps={document:window.document,defaultColor:"#FF0000",noTransparency:false,stopClickPropagation:false,onColorSelect:()=>{},onColorPreview:()=>{},onInputEnter:()=>{},};setup(){this.pickerFlag=false;this.sliderFlag=false;this.opacitySliderFlag=false;this.colorComponents={};this.uniqueId=uniqueId("colorpicker");this.selectedHexValue="";this.debouncedOnChangeInputs=debounce(this.onChangeInputs.bind(this),10,true);this.elRef=useRef("el");this.colorPickerAreaRef=useRef("colorPickerArea");this.colorPickerPointerRef=useRef("colorPickerPointer");this.colorSliderRef=useRef("colorSlider");this.colorSliderPointerRef=useRef("colorSliderPointer");this.opacitySliderRef=useRef("opacitySlider");this.opacitySliderPointerRef=useRef("opacitySliderPointer");const documents=[window.top,...Array.from(window.top.frames).filter((frame)=>{try{const document=frame.document;return!!document;}catch{return false;}}),].map((w)=>w.document);this.throttleOnMouseMove=useThrottleForAnimation((ev)=>{this.onMouseMovePicker(ev);this.onMouseMoveSlider(ev);this.onMouseMoveOpacitySlider(ev);});for(const doc of documents){useExternalListener(doc,"mousemove",this.throttleOnMouseMove);useExternalListener(doc,"mouseup",this.onMouseUp.bind(this));}
onMounted(async()=>{const defaultCssColor=this.props.selectedColor?this.props.selectedColor:this.props.defaultColor;const rgba=convertCSSColorToRgba(defaultCssColor);if(rgba){this._updateRgba(rgba.red,rgba.green,rgba.blue,rgba.opacity);}
this.previewActive=true;this._updateUI();});onWillUpdateProps((newProps)=>{const newSelectedColor=newProps.selectedColor?newProps.selectedColor:newProps.defaultColor;this.setSelectedColor(newSelectedColor);});}
setSelectedColor(color){const rgba=convertCSSColorToRgba(color);if(rgba){const oldPreviewActive=this.previewActive;this.previewActive=false;this._updateRgba(rgba.red,rgba.green,rgba.blue,rgba.opacity);this.previewActive=oldPreviewActive;this._updateUI();}}
get el(){return this.elRef.el;}
_updateUI(){for(const[color,value]of Object.entries(this.colorComponents)){const input=this.el.querySelector(`.o_${color}_input`);if(input){input.value=value;}}
const colorPickerArea=this.colorPickerAreaRef.el;colorPickerArea.style.backgroundColor=`hsl(${this.colorComponents.hue}, 100%, 50%)`;const top=((100-this.colorComponents.lightness)*colorPickerArea.clientHeight)/100;const left=(this.colorComponents.saturation*colorPickerArea.clientWidth)/100;const colorpickerPointer=this.colorPickerPointerRef.el;colorpickerPointer.style.top=top-5+"px";colorpickerPointer.style.left=left-5+"px";const colorSlider=this.colorSliderRef.el;const height=colorSlider.clientHeight;const y=(this.colorComponents.hue*height)/360;this.colorSliderPointerRef.el.style.top=`${Math.round(y - 2)}px`;if(!this.props.noTransparency){const opacitySlider=this.opacitySliderRef.el;const heightOpacity=opacitySlider.clientHeight;const z=heightOpacity*(1-this.colorComponents.opacity/100.0);this.opacitySliderPointerRef.el.style.top=`${Math.round(z - 2)}px`;opacitySlider.style.background=`linear-gradient(${this.colorComponents.hex} 0%, transparent 100%)`;}}
_updateHex(hex){const rgb=convertCSSColorToRgba(hex);if(!rgb){return;}
Object.assign(this.colorComponents,{hex:hex},rgb,convertRgbToHsl(rgb.red,rgb.green,rgb.blue));this._updateCssColor();}
_updateRgba(r,g,b,a){const opacity=a||this.colorComponents.opacity;if(opacity<0.1&&(r>0.1||g>0.1||b>0.1)){a=100;}
const hex=convertRgbaToCSSColor(r,g,b);if(!hex){return;}
Object.assign(this.colorComponents,{red:r,green:g,blue:b},a===undefined?{}:{opacity:a},{hex:hex},convertRgbToHsl(r,g,b));this._updateCssColor();}
_updateHsl(h,s,l){let a=this.colorComponents.opacity;if(a<0.1&&l>0.1){a=100;}
const rgb=convertHslToRgb(h,s,l);if(!rgb){return;}
const hex=convertRgbaToCSSColor(rgb.red,rgb.green,rgb.blue);Object.assign(this.colorComponents,{hue:h,saturation:s,lightness:l},rgb,{hex:hex},{opacity:a});this._updateCssColor();}
_updateOpacity(a){if(a<0||a>100){return;}
Object.assign(this.colorComponents,{opacity:a});this._updateCssColor();}
_colorSelected(){this.props.onColorSelect(this.colorComponents);}
_updateCssColor(){const r=this.colorComponents.red;const g=this.colorComponents.green;const b=this.colorComponents.blue;const a=this.colorComponents.opacity;Object.assign(this.colorComponents,{cssColor:convertRgbaToCSSColor(r,g,b,a)});if(this.previewActive){this.props.onColorPreview(this.colorComponents);}}
onKeydown(ev){if(ev.key==="Enter"){if(ev.target.tagName==="INPUT"){this.onChangeInputs(ev);}
ev.preventDefault();this.props.onInputEnter(ev);}}
onClick(ev){if(this.props.stopClickPropagation){ev.stopPropagation();}
ev.__isColorpickerClick=true;if(ev.target.dataset.colorMethod==="hex"&&!this.selectedHexValue){ev.target.select();this.selectedHexValue=ev.target.value;return;}
this.selectedHexValue="";}
onMouseUp(){if(this.pickerFlag||this.sliderFlag||this.opacitySliderFlag){this._colorSelected();}
this.pickerFlag=false;this.sliderFlag=false;this.opacitySliderFlag=false;}
onMouseDownPicker(ev){this.pickerFlag=true;ev.preventDefault();this.onMouseMovePicker(ev);}
onMouseMovePicker(ev){if(!this.pickerFlag){return;}
const colorPickerArea=this.colorPickerAreaRef.el;const rect=colorPickerArea.getClientRects()[0];const top=ev.pageY-rect.top;const left=ev.pageX-rect.left;let saturation=Math.round((100*left)/colorPickerArea.clientWidth);let lightness=Math.round((100*(colorPickerArea.clientHeight-top))/colorPickerArea.clientHeight);saturation=clamp(saturation,0,100);lightness=clamp(lightness,0,100);this._updateHsl(this.colorComponents.hue,saturation,lightness);this._updateUI();}
onMouseDownSlider(ev){this.sliderFlag=true;ev.preventDefault();this.onMouseMoveSlider(ev);}
onMouseMoveSlider(ev){if(!this.sliderFlag){return;}
const colorSlider=this.colorSliderRef.el;const y=ev.pageY-colorSlider.getClientRects()[0].top;let hue=Math.round((360*y)/colorSlider.clientHeight);hue=clamp(hue,0,360);this._updateHsl(hue,this.colorComponents.saturation,this.colorComponents.lightness);this._updateUI();}
onMouseDownOpacitySlider(ev){this.opacitySliderFlag=true;ev.preventDefault();this.onMouseMoveOpacitySlider(ev);}
onMouseMoveOpacitySlider(ev){if(!this.opacitySliderFlag||this.props.noTransparency){return;}
const opacitySlider=this.opacitySliderRef.el;const y=ev.pageY-opacitySlider.getClientRects()[0].top;let opacity=Math.round(100*(1-y/opacitySlider.clientHeight));opacity=clamp(opacity,0,100);this._updateOpacity(opacity);this._updateUI();}
onChangeInputs(ev){switch(ev.target.dataset.colorMethod){case"hex":return;case"rgb":this._updateRgba(parseInt(this.el.querySelector(".o_red_input").value),parseInt(this.el.querySelector(".o_green_input").value),parseInt(this.el.querySelector(".o_blue_input").value));break;case"hsl":this._updateHsl(parseInt(this.el.querySelector(".o_hue_input").value),parseInt(this.el.querySelector(".o_saturation_input").value),parseInt(this.el.querySelector(".o_lightness_input").value));break;case"opacity":this._updateOpacity(parseInt(this.el.querySelector(".o_opacity_input").value));break;}
this._updateUI();this._colorSelected();}
onHexColorInput(ev){const hexColorValue=ev.target.value.replaceAll("#","");if(hexColorValue.length===6){this._updateHex(`#${hexColorValue}`);this._updateUI();this._colorSelected();}}}
return __exports;});;

/* /web/static/src/core/colors/colors.js */
odoo.define('@web/core/colors/colors',['@web/core/utils/numbers'],function(require){'use strict';let __exports={};const{clamp}=require("@web/core/utils/numbers");const COLORS_ENT_BRIGHT=["#875A7B","#A5D8D7","#DCD0D9"];const COLORS_ENT_DARK=["#6B3E66","#147875","#5A395A"];const COLORS_SM=["#4EA7F2","#EA6175","#43C5B1","#F4A261","#8481DD","#FFD86D",];const COLORS_MD=["#4EA7F2","#3188E6","#43C5B1","#00A78D","#EA6175","#CE4257","#F4A261","#F48935","#8481DD","#5752D1","#FFD86D","#FFBC2C",];const COLORS_LG=["#4EA7F2","#3188E6","#056BD9","#A76DBC","#7F4295","#6D2387","#EA6175","#CE4257","#982738","#43C5B1","#00A78D","#0E8270","#F4A261","#F48935","#BE5D10","#8481DD","#5752D1","#3A3580","#A4A8B6","#7E8290","#545B70","#FFD86D","#FFBC2C","#C08A16",];const COLORS_XL=["#4EA7F2","#3188E6","#056BD9","#155193","#A76DBC","#7F4295","#6D2387","#4F1565","#EA6175","#CE4257","#982738","#791B29","#43C5B1","#00A78D","#0E8270","#105F53","#F4A261","#F48935","#BE5D10","#7D380D","#8481DD","#5752D1","#3A3580","#26235F","#A4A8B6","#7E8290","#545B70","#3F4250","#FFD86D","#FFBC2C","#C08A16","#936A12",];__exports.getColors=getColors;function getColors(colorScheme,paletteName){switch(paletteName){case"odoo":return colorScheme==="dark"?COLORS_ENT_DARK:COLORS_ENT_BRIGHT;case"sm":return COLORS_SM;case"md":return COLORS_MD;case"lg":return COLORS_LG;default:return COLORS_XL;}}
__exports.getColor=getColor;function getColor(index,colorScheme,paletteSizeOrName){let paletteName;if(paletteSizeOrName==="odoo"){paletteName="odoo";}else if(paletteSizeOrName<=6||paletteSizeOrName==="sm"){paletteName="sm";}else if(paletteSizeOrName<=12||paletteSizeOrName==="md"){paletteName="md";}else if(paletteSizeOrName<=24||paletteSizeOrName==="lg"){paletteName="lg";}else{paletteName="xl";}
const colors=getColors(colorScheme,paletteName);return colors[index%colors.length];}
const DEFAULT_BG=__exports.DEFAULT_BG="#d3d3d3";__exports.getBorderWhite=getBorderWhite;function getBorderWhite(colorScheme){return colorScheme==="dark"?"rgba(38, 42, 54, .2)":"rgba(249,250,251, .2)";}
const RGB_REGEX=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i;__exports.hexToRGBA=hexToRGBA;function hexToRGBA(hex,opacity){const rgb=RGB_REGEX.exec(hex).slice(1,4).map((n)=>parseInt(n,16)).join(",");return`rgba(${rgb},${opacity})`;}
__exports.getCustomColor=getCustomColor;function getCustomColor(colorScheme,brightModeColor,darkModeColor){if(darkModeColor===undefined){return brightModeColor;}else{return colorScheme==="dark"?darkModeColor:brightModeColor;}}
__exports.lightenColor=lightenColor;function lightenColor(color,factor){factor=clamp(factor,0,1);let r=parseInt(color.substring(1,3),16);let g=parseInt(color.substring(3,5),16);let b=parseInt(color.substring(5,7),16);r=Math.round(r+(255-r)*factor);g=Math.round(g+(255-g)*factor);b=Math.round(b+(255-b)*factor);r=r.toString(16).padStart(2,"0");g=g.toString(16).padStart(2,"0");b=b.toString(16).padStart(2,"0");return`#${r}${g}${b}`;}
__exports.darkenColor=darkenColor;function darkenColor(color,factor){factor=clamp(factor,0,1);let r=parseInt(color.substring(1,3),16);let g=parseInt(color.substring(3,5),16);let b=parseInt(color.substring(5,7),16);r=Math.round(r*(1-factor));g=Math.round(g*(1-factor));b=Math.round(b*(1-factor));r=r.toString(16).padStart(2,"0");g=g.toString(16).padStart(2,"0");b=b.toString(16).padStart(2,"0");return`#${r}${g}${b}`;}
return __exports;});;

/* /web/static/src/core/commands/command_category.js */
odoo.define('@web/core/commands/command_category',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const commandCategoryRegistry=registry.category("command_categories");commandCategoryRegistry.add("app",{},{sequence:10}).add("smart_action",{},{sequence:15}).add("actions",{},{sequence:30}).add("default",{},{sequence:50}).add("view_switcher",{},{sequence:100}).add("debug",{},{sequence:110}).add("disabled",{});return __exports;});;

/* /web/static/src/core/commands/command_hook.js */
odoo.define('@web/core/commands/command_hook',['@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{useEffect}=require("@odoo/owl");__exports.useCommand=useCommand;function useCommand(name,action,options={}){const commandService=useService("command");useEffect(()=>commandService.add(name,action,options),()=>[]);}
return __exports;});;

/* /web/static/src/core/commands/command_palette.js */
odoo.define('@web/core/commands/command_palette',['@web/core/dialog/dialog','@web/core/hotkeys/hotkey_hook','@web/core/l10n/translation','@web/core/utils/concurrency','@web/core/utils/hooks','@web/core/utils/scrolling','@web/core/utils/search','@web/core/utils/timing','@web/core/browser/feature_detection','@web/core/utils/strings','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{_t}=require("@web/core/l10n/translation");const{KeepLast,Race}=require("@web/core/utils/concurrency");const{useAutofocus,useService}=require("@web/core/utils/hooks");const{scrollTo}=require("@web/core/utils/scrolling");const{fuzzyLookup}=require("@web/core/utils/search");const{debounce}=require("@web/core/utils/timing");const{isMacOS,isMobileOS}=require("@web/core/browser/feature_detection");const{escapeRegExp}=require("@web/core/utils/strings");const{Component,onWillStart,onWillDestroy,EventBus,useRef,useState,markRaw,useExternalListener,}=require("@odoo/owl");const DEFAULT_PLACEHOLDER=_t("Search...");const DEFAULT_EMPTY_MESSAGE=_t("No result found");const FUZZY_NAMESPACES=["default"];function commandsWithinCategory(categoryName,categories){return(cmd)=>{const inCurrentCategory=categoryName===cmd.category;const fallbackCategory=categoryName==="default"&&!categories.includes(cmd.category);return inCurrentCategory||fallbackCategory;};}
__exports.splitCommandName=splitCommandName;function splitCommandName(name,searchValue){if(name){const splitName=name.split(new RegExp(`(${escapeRegExp(searchValue)})`,"ig"));return searchValue.length&&splitName.length>1?splitName:[name];}
return[];}
const DefaultCommandItem=__exports.DefaultCommandItem=class DefaultCommandItem extends Component{static template="web.DefaultCommandItem";static props={slots:{type:Object,optional:true},hotkey:{type:String,optional:true},hotkeyOptions:{type:String,optional:true},name:{type:String,optional:true},searchValue:{type:String,optional:true},executeCommand:{type:Function,optional:true},};}
const CommandPalette=__exports.CommandPalette=class CommandPalette extends Component{static template="web.CommandPalette";static components={Dialog};static lastSessionId=0;static props={bus:{type:EventBus,optional:true},close:Function,config:Object,closeMe:{type:Function,optional:true},};setup(){if(this.props.bus){const setConfig=({detail})=>this.setCommandPaletteConfig(detail);this.props.bus.addEventListener(`SET-CONFIG`,setConfig);onWillDestroy(()=>this.props.bus.removeEventListener(`SET-CONFIG`,setConfig));}
this.keyId=1;this.race=new Race();this.keepLast=new KeepLast();this._sessionId=CommandPalette.lastSessionId++;this.DefaultCommandItem=DefaultCommandItem;this.activeElement=useService("ui").activeElement;this.inputRef=useAutofocus();useHotkey("Enter",()=>this.executeSelectedCommand(),{bypassEditableProtection:true});useHotkey("Control+Enter",()=>this.executeSelectedCommand(true),{bypassEditableProtection:true,});useHotkey("ArrowUp",()=>this.selectCommandAndScrollTo("PREV"),{bypassEditableProtection:true,allowRepeat:true,});useHotkey("ArrowDown",()=>this.selectCommandAndScrollTo("NEXT"),{bypassEditableProtection:true,allowRepeat:true,});useExternalListener(window,"mousedown",this.onWindowMouseDown);this.state=useState({});this.root=useRef("root");this.listboxRef=useRef("listbox");onWillStart(()=>this.setCommandPaletteConfig(this.props.config));}
get commandsByCategory(){const categories=[];for(const category of this.categoryKeys){const commands=this.state.commands.filter(commandsWithinCategory(category,this.categoryKeys));if(commands.length){categories.push({commands,name:this.categoryNames[category],keyId:category,});}}
return categories;}
async setCommandPaletteConfig(config){this.configByNamespace=config.configByNamespace||{};this.state.FooterComponent=config.FooterComponent;this.providersByNamespace={default:[]};for(const provider of config.providers){const namespace=provider.namespace||"default";if(namespace in this.providersByNamespace){this.providersByNamespace[namespace].push(provider);}else{this.providersByNamespace[namespace]=[provider];}}
const{namespace,searchValue}=this.processSearchValue(config.searchValue||"");this.switchNamespace(namespace);this.state.searchValue=searchValue;await this.race.add(this.search(searchValue));}
async setCommands(namespace,options={}){this.categoryKeys=["default"];this.categoryNames={};const proms=this.providersByNamespace[namespace].map((provider)=>{const{provide}=provider;const result=provide(this.env,options);return result;});let commands=(await this.keepLast.add(Promise.all(proms))).flat();const namespaceConfig=this.configByNamespace[namespace]||{};if(options.searchValue&&FUZZY_NAMESPACES.includes(namespace)){commands=fuzzyLookup(options.searchValue,commands,(c)=>c.name);}else{if(namespaceConfig.categories){let commandsSorted=[];this.categoryKeys=namespaceConfig.categories;this.categoryNames=namespaceConfig.categoryNames||{};if(!this.categoryKeys.includes("default")){this.categoryKeys.push("default");}
for(const category of this.categoryKeys){commandsSorted=commandsSorted.concat(commands.filter(commandsWithinCategory(category,this.categoryKeys)));}
commands=commandsSorted;}}
this.state.commands=markRaw(commands.slice(0,100).map((command)=>({...command,keyId:this.keyId++,splitName:splitCommandName(command.name,options.searchValue),})));this.selectCommand(this.state.commands.length?0:-1);this.mouseSelectionActive=false;this.state.emptyMessage=(namespaceConfig.emptyMessage||DEFAULT_EMPTY_MESSAGE).toString();}
selectCommand(index){if(index===-1||index>=this.state.commands.length){this.state.selectedCommand=null;return;}
this.state.selectedCommand=markRaw(this.state.commands[index]);}
selectCommandAndScrollTo(type){this.mouseSelectionActive=false;const index=this.state.commands.indexOf(this.state.selectedCommand);if(index===-1){return;}
let nextIndex;if(type==="NEXT"){nextIndex=index<this.state.commands.length-1?index+1:0;}else if(type==="PREV"){nextIndex=index>0?index-1:this.state.commands.length-1;}
this.selectCommand(nextIndex);const command=this.listboxRef.el.querySelector(`#o_command_${nextIndex}`);scrollTo(command,{scrollable:this.listboxRef.el});}
onCommandClicked(event,index){event.preventDefault();this.selectCommand(index);const ctrlKey=isMacOS()?event.metaKey:event.ctrlKey;this.executeSelectedCommand(ctrlKey);}
async executeCommand(command){const config=await command.action();if(config){this.setCommandPaletteConfig(config);}else{this.props.close();}}
async executeSelectedCommand(ctrlKey){await this.searchValuePromise;const selectedCommand=this.state.selectedCommand;if(selectedCommand){if(!ctrlKey){this.executeCommand(selectedCommand);}else if(selectedCommand.href){window.open(selectedCommand.href,"_blank");}}}
onCommandMouseEnter(index){if(this.mouseSelectionActive){this.selectCommand(index);}else{this.mouseSelectionActive=true;}}
async search(searchValue){this.state.isLoading=true;try{await this.setCommands(this.state.namespace,{searchValue,activeElement:this.activeElement,sessionId:this._sessionId,});}finally{this.state.isLoading=false;}
if(this.inputRef.el){this.inputRef.el.focus();}}
debounceSearch(value){const{namespace,searchValue}=this.processSearchValue(value);if(namespace!=="default"&&this.state.namespace!==namespace){this.switchNamespace(namespace);}
this.state.searchValue=searchValue;this.searchValuePromise=this.lastDebounceSearch(searchValue).catch(()=>{this.searchValuePromise=null;});}
onSearchInput(ev){this.debounceSearch(ev.target.value);}
onKeyDown(ev){if(ev.key.toLowerCase()==="backspace"&&!ev.target.value.length&&!ev.repeat){this.switchNamespace("default");this.state.searchValue="";this.searchValuePromise=this.lastDebounceSearch("").catch(()=>{this.searchValuePromise=null;});}}
onWindowMouseDown(ev){if(!this.root.el.contains(ev.target)){this.props.close();}}
switchNamespace(namespace){if(this.lastDebounceSearch){this.lastDebounceSearch.cancel();}
const namespaceConfig=this.configByNamespace[namespace]||{};this.lastDebounceSearch=debounce((value)=>this.search(value),namespaceConfig.debounceDelay||0);this.state.namespace=namespace;this.state.placeholder=namespaceConfig.placeholder||DEFAULT_PLACEHOLDER.toString();}
processSearchValue(searchValue){let namespace="default";if(searchValue.length&&this.providersByNamespace[searchValue[0]]){namespace=searchValue[0];searchValue=searchValue.slice(1);}
return{namespace,searchValue};}
get isMacOS(){return isMacOS();}
get isMobileOS(){return isMobileOS();}}
return __exports;});;

/* /web/static/src/core/commands/command_service.js */
odoo.define('@web/core/commands/command_service',['@web/core/registry','@web/core/commands/command_palette','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{CommandPalette}=require("@web/core/commands/command_palette");const{Component,EventBus}=require("@odoo/owl");const commandCategoryRegistry=registry.category("command_categories");const commandProviderRegistry=registry.category("command_provider");const commandSetupRegistry=registry.category("command_setup");class DefaultFooter extends Component{static template="web.DefaultFooter";static props={switchNamespace:{type:Function},};setup(){this.elements=commandSetupRegistry.getEntries().map((el)=>({namespace:el[0],name:el[1].name})).filter((el)=>el.name);}
onClick(namespace){this.props.switchNamespace(namespace);}}
const commandService=__exports.commandService={dependencies:["dialog","hotkey","ui"],start(env,{dialog,hotkey:hotkeyService,ui}){const registeredCommands=new Map();let nextToken=0;let isPaletteOpened=false;const bus=new EventBus();hotkeyService.add("control+k",openMainPalette,{bypassEditableProtection:true,global:true,});function openMainPalette(config={},onClose){const configByNamespace={};for(const provider of commandProviderRegistry.getAll()){const namespace=provider.namespace||"default";if(!configByNamespace[namespace]){configByNamespace[namespace]={categories:[],categoryNames:{},};}}
for(const[category,el]of commandCategoryRegistry.getEntries()){const namespace=el.namespace||"default";const name=el.name;if(namespace in configByNamespace){configByNamespace[namespace].categories.push(category);configByNamespace[namespace].categoryNames[category]=name;}}
for(const[namespace,{emptyMessage,debounceDelay,placeholder},]of commandSetupRegistry.getEntries()){if(namespace in configByNamespace){if(emptyMessage){configByNamespace[namespace].emptyMessage=emptyMessage;}
if(debounceDelay!==undefined){configByNamespace[namespace].debounceDelay=debounceDelay;}
if(placeholder){configByNamespace[namespace].placeholder=placeholder;}}}
config=Object.assign({configByNamespace,FooterComponent:DefaultFooter,providers:commandProviderRegistry.getAll(),},config);return openPalette(config,onClose);}
function openPalette(config,onClose){if(isPaletteOpened){bus.trigger("SET-CONFIG",config);return;}
isPaletteOpened=true;dialog.add(CommandPalette,{config,bus,},{onClose:()=>{isPaletteOpened=false;if(onClose){onClose();}},});}
function registerCommand(command,options){if(!command.name||!command.action||typeof command.action!=="function"){throw new Error("A Command must have a name and an action function.");}
const registration=Object.assign({},command,options);if(registration.identifier){const commandsArray=Array.from(registeredCommands.values());const sameName=commandsArray.find((com)=>com.name===registration.name);if(sameName){if(registration.identifier!==sameName.identifier){registration.name+=` (${registration.identifier})`;sameName.name+=` (${sameName.identifier})`;}}else{const sameFullName=commandsArray.find((com)=>com.name===registration.name+`(${registration.identifier})`);if(sameFullName){registration.name+=` (${registration.identifier})`;}}}
if(registration.hotkey){const action=async()=>{const commandService=env.services.command;const config=await command.action();if(!isPaletteOpened&&config){commandService.openPalette(config);}};registration.removeHotkey=hotkeyService.add(registration.hotkey,action,{...options.hotkeyOptions,global:registration.global,isAvailable:(...args)=>{let available=true;if(registration.isAvailable){available=registration.isAvailable(...args);}
if(available&&options.hotkeyOptions?.isAvailable){available=options.hotkeyOptions?.isAvailable(...args);}
return available;},});}
const token=nextToken++;registeredCommands.set(token,registration);if(!options.activeElement){Promise.resolve().then(()=>{registration.activeElement=ui.activeElement;});}
return token;}
function unregisterCommand(token){const cmd=registeredCommands.get(token);if(cmd&&cmd.removeHotkey){cmd.removeHotkey();}
registeredCommands.delete(token);}
return{add(name,action,options={}){const token=registerCommand({name,action},options);return()=>{unregisterCommand(token);};},getCommands(activeElement){return[...registeredCommands.values()].filter((command)=>command.activeElement===activeElement||command.global);},openMainPalette,openPalette,};},};registry.category("services").add("command",commandService);return __exports;});;

/* /web/static/src/core/commands/default_providers.js */
odoo.define('@web/core/commands/default_providers',['@web/core/browser/feature_detection','@web/core/hotkeys/hotkey_hook','@web/core/l10n/translation','@web/core/registry','@web/core/utils/strings','@web/core/utils/ui','@web/core/commands/command_palette','@odoo/owl'],function(require){'use strict';let __exports={};const{isMacOS}=require("@web/core/browser/feature_detection");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{capitalize}=require("@web/core/utils/strings");const{getVisibleElements}=require("@web/core/utils/ui");const{DefaultCommandItem}=require("@web/core/commands/command_palette");const{Component}=require("@odoo/owl");const commandSetupRegistry=registry.category("command_setup");commandSetupRegistry.add("default",{emptyMessage:_t("No command found"),placeholder:_t("Search for a command..."),});const HotkeyCommandItem=__exports.HotkeyCommandItem=class HotkeyCommandItem extends Component{static template="web.HotkeyCommandItem";static props=["hotkey","hotkeyOptions?","name?","searchValue?","executeCommand","slots"];setup(){useHotkey(this.props.hotkey,this.props.executeCommand);}
getKeysToPress(command){const{hotkey}=command;let result=hotkey.split("+");if(isMacOS()){result=result.map((x)=>x.replace("control","command")).map((x)=>x.replace("alt","control"));}
return result.map((key)=>key.toUpperCase());}}
const commandCategoryRegistry=registry.category("command_categories");const commandProviderRegistry=registry.category("command_provider");commandProviderRegistry.add("command",{provide:(env,options={})=>{const commands=env.services.command.getCommands(options.activeElement).map((cmd)=>{cmd.category=commandCategoryRegistry.contains(cmd.category)?cmd.category:"default";return cmd;}).filter((command)=>command.isAvailable===undefined||command.isAvailable());const uniqueCommands=commands.filter((obj,index)=>{return(index===commands.findIndex((o)=>obj.name===o.name&&obj.category===o.category));});return uniqueCommands.map((command)=>({Component:command.hotkey?HotkeyCommandItem:DefaultCommandItem,action:command.action,category:command.category,name:command.name,props:{hotkey:command.hotkey,hotkeyOptions:command.hotkeyOptions,},}));},});commandProviderRegistry.add("data-hotkeys",{provide:(env,options={})=>{const commands=[];const overlayModifier=registry.category("services").get("hotkey").overlayModifier;for(const el of getVisibleElements(options.activeElement,"[data-hotkey]:not(:disabled)")){const closest=el.closest("[data-command-category]");const category=closest?closest.dataset.commandCategory:"default";if(category==="disabled"){continue;}
const description=el.title||el.dataset.bsOriginalTitle||el.dataset.tooltip||el.placeholder||(el.innerText&&`${el.innerText.slice(0, 50)}${el.innerText.length > 50 ? "..." : ""}`)||_t("no description provided");commands.push({Component:HotkeyCommandItem,action:()=>{el.focus();el.click();},category,name:capitalize(description.trim().toLowerCase()),props:{hotkey:`${overlayModifier}+${el.dataset.hotkey}`,},});}
return commands;},});return __exports;});;

/* /web/static/src/core/confirmation_dialog/confirmation_dialog.js */
odoo.define('@web/core/confirmation_dialog/confirmation_dialog',['@web/core/dialog/dialog','@web/core/l10n/translation','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{_t}=require("@web/core/l10n/translation");const{useChildRef}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const deleteConfirmationMessage=__exports.deleteConfirmationMessage=_t(`Ready to make your record disappear into thin air? Are you sure?
It will be gone forever!

Think twice before you click that 'Delete' button!`);const ConfirmationDialog=__exports.ConfirmationDialog=class ConfirmationDialog extends Component{static template="web.ConfirmationDialog";static components={Dialog};static props={close:Function,title:{validate:(m)=>{return(typeof m==="string"||(typeof m==="object"&&typeof m.toString==="function"));},optional:true,},body:{type:String,optional:true},confirm:{type:Function,optional:true},confirmLabel:{type:String,optional:true},confirmClass:{type:String,optional:true},cancel:{type:Function,optional:true},cancelLabel:{type:String,optional:true},dismiss:{type:Function,optional:true},};static defaultProps={confirmLabel:_t("Ok"),cancelLabel:_t("Cancel"),confirmClass:"btn-primary",title:_t("Confirmation"),};setup(){this.env.dialogData.dismiss=()=>this._dismiss();this.modalRef=useChildRef();this.isProcess=false;}
async _cancel(){return this.execButton(this.props.cancel);}
async _confirm(){return this.execButton(this.props.confirm);}
async _dismiss(){return this.execButton(this.props.dismiss||this.props.cancel);}
setButtonsDisabled(disabled){this.isProcess=disabled;if(!this.modalRef.el){return;}
for(const button of[...this.modalRef.el.querySelectorAll(".modal-footer button")]){button.disabled=disabled;}}
async execButton(callback){if(this.isProcess){return;}
this.setButtonsDisabled(true);if(callback){let shouldClose;try{shouldClose=await callback();}catch(e){this.props.close();throw e;}
if(shouldClose===false){this.setButtonsDisabled(false);return;}}
this.props.close();}}
const AlertDialog=__exports.AlertDialog=class AlertDialog extends ConfirmationDialog{static template="web.AlertDialog";static props={...ConfirmationDialog.props,contentClass:{type:String,optional:true},};static defaultProps={...ConfirmationDialog.defaultProps,title:_t("Alert"),};}
return __exports;});;

/* /web/static/src/core/context.js */
odoo.define('@web/core/context',['@web/core/py_js/py','@web/core/py_js/py_builtin','@web/core/py_js/py_interpreter'],function(require){'use strict';let __exports={};const{evaluateExpr,parseExpr}=require("@web/core/py_js/py");const{BUILTINS}=require("@web/core/py_js/py_builtin");const{evaluate}=require("@web/core/py_js/py_interpreter");__exports.makeContext=makeContext;function makeContext(contexts,initialEvaluationContext){const evaluationContext=Object.assign({},initialEvaluationContext);const context={};for(let ctx of contexts){if(ctx!==""){ctx=typeof ctx==="string"?evaluateExpr(ctx,evaluationContext):ctx;Object.assign(context,ctx);Object.assign(evaluationContext,context);}}
return context;}
function getPartialNames(ast){if(ast.type===5){return[ast.value];}
if(ast.type===6){return getPartialNames(ast.right);}
if(ast.type===14||ast.type===7){return getPartialNames(ast.left).concat(getPartialNames(ast.right));}
if(ast.type===15){return getPartialNames(ast.obj);}
return[];}
__exports.evalPartialContext=evalPartialContext;function evalPartialContext(_context,evaluationContext={}){const ast=parseExpr(_context);const context={};for(const key in ast.value){const value=ast.value[key];if(getPartialNames(value).some((name)=>!(name in evaluationContext||name in BUILTINS))){continue;}
try{context[key]=evaluate(value,evaluationContext);}catch{}}
return context;}
return __exports;});;

/* /web/static/src/core/copy_button/copy_button.js */
odoo.define('@web/core/copy_button/copy_button',['@web/core/browser/browser','@web/core/tooltip/tooltip','@web/core/popover/popover_hook','@odoo/owl'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{Tooltip}=require("@web/core/tooltip/tooltip");const{usePopover}=require("@web/core/popover/popover_hook");const{Component,useRef}=require("@odoo/owl");const CopyButton=__exports.CopyButton=class CopyButton extends Component{static template="web.CopyButton";static props={className:{type:String,optional:true},copyText:{type:String,optional:true},disabled:{type:Boolean,optional:true},successText:{type:String,optional:true},icon:{type:String,optional:true},content:{type:[String,Object],optional:true},};setup(){this.button=useRef("button");this.popover=usePopover(Tooltip);}
showTooltip(){this.popover.open(this.button.el,{tooltip:this.props.successText});browser.setTimeout(this.popover.close,800);}
async onClick(){let write;if(typeof this.props.content==="string"||this.props.content instanceof String){write=(value)=>browser.navigator.clipboard.writeText(value);}else{write=(value)=>browser.navigator.clipboard.write(value);}
try{await write(this.props.content);}catch(error){return browser.console.warn(error);}
this.showTooltip();}}
return __exports;});;

/* /web/static/src/core/currency.js */
odoo.define('@web/core/currency',['@web/core/utils/numbers','@web/session','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{formatFloat,humanNumber}=require("@web/core/utils/numbers");const{session}=require("@web/session");const{nbsp}=require("@web/core/utils/strings");const currencies=__exports.currencies=session.currencies||{};delete session.currencies;__exports.getCurrency=getCurrency;function getCurrency(id){return currencies[id];}
__exports.formatCurrency=formatCurrency;function formatCurrency(amount,currencyId,options={}){const currency=getCurrency(currencyId);const digits=options.digits||(currency&&currency.digits);let formattedAmount;if(options.humanReadable){formattedAmount=humanNumber(amount,{decimals:digits?digits[1]:2});}else{formattedAmount=formatFloat(amount,{digits});}
if(!currency||options.noSymbol){return formattedAmount;}
const formatted=[currency.symbol,formattedAmount];if(currency.position==="after"){formatted.reverse();}
return formatted.join(nbsp);}
return __exports;});;

/* /web/static/src/core/datetime/datetime_hook.js */
odoo.define('@web/core/datetime/datetime_hook',['@odoo/owl','@web/core/popover/popover_hook','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{onPatched,onWillRender,useEffect,useRef}=require("@odoo/owl");const{usePopover}=require("@web/core/popover/popover_hook");const{useService}=require("@web/core/utils/hooks");__exports.useDateTimePicker=useDateTimePicker;function useDateTimePicker(hookParams){const datetimePicker=useService("datetime_picker");if(typeof hookParams.target==="string"){const target=useRef(hookParams.target);Object.defineProperty(hookParams,"target",{get(){return target.el;},});}
const inputRefs=[useRef("start-date"),useRef("end-date")];const createPopover=hookParams.createPopover??usePopover;const getInputs=()=>inputRefs.map((ref)=>ref?.el);const{computeBasePickerProps,state,open,focusIfNeeded,enable}=datetimePicker.create(hookParams,getInputs,createPopover);onWillRender(computeBasePickerProps);useEffect(enable,getInputs);onPatched(focusIfNeeded);return{state,open};}
return __exports;});;

/* /web/static/src/core/datetime/datetime_input.js */
odoo.define('@web/core/datetime/datetime_input',['@odoo/owl','@web/core/utils/objects','@web/core/datetime/datetime_hook','@web/core/datetime/datetime_picker'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{omit}=require("@web/core/utils/objects");const{useDateTimePicker}=require("@web/core/datetime/datetime_hook");const{DateTimePicker}=require("@web/core/datetime/datetime_picker");const dateTimeInputOwnProps={format:{type:String,optional:true},id:{type:String,optional:true},onChange:{type:Function,optional:true},onApply:{type:Function,optional:true},placeholder:{type:String,optional:true},};const DateTimeInput=__exports.DateTimeInput=class DateTimeInput extends Component{static props={...DateTimePicker.props,...dateTimeInputOwnProps,};static template="web.DateTimeInput";setup(){const getPickerProps=()=>omit(this.props,...Object.keys(dateTimeInputOwnProps));useDateTimePicker({format:this.props.format,get pickerProps(){return getPickerProps();},onApply:(...args)=>this.props.onApply?.(...args),onChange:(...args)=>this.props.onChange?.(...args),});}}
return __exports;});;

/* /web/static/src/core/datetime/datetime_picker.js */
odoo.define('@web/core/datetime/datetime_picker',['@odoo/owl','@web/core/l10n/translation','@web/core/l10n/dates','@web/core/l10n/localization','@web/core/utils/arrays'],function(require){'use strict';let __exports={};const{Component,onWillRender,onWillUpdateProps,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{MAX_VALID_DATE,MIN_VALID_DATE,clampDate,is24HourFormat,isInRange,isMeridiemFormat,today,}=require("@web/core/l10n/dates");const{localization}=require("@web/core/l10n/localization");const{ensureArray}=require("@web/core/utils/arrays");const{DateTime,Info}=luxon;const getStartOfDecade=(date)=>Math.floor(date.year/10)*10;const getStartOfCentury=(date)=>Math.floor(date.year/100)*100;const getStartOfWeek=(date)=>{const{weekStart}=localization;return date.set({weekday:date.weekday<weekStart?weekStart-7:weekStart});};const numberRange=(min,max)=>[...Array(max-min)].map((_,i)=>i+min);const parseLimitDate=(value,defaultValue)=>clampDate(value==="today"?today():value||defaultValue,MIN_VALID_DATE,MAX_VALID_DATE);const toDateItem=({isOutOfRange=false,isValid=true,label,range,extraClass})=>({id:range[0].toISODate(),includesToday:isInRange(today(),range),isOutOfRange,isValid,label:String(range[0][label]),range,extraClass,});const toWeekItem=(weekDayItems)=>({number:weekDayItems[3].range[0].weekNumber,days:weekDayItems,});const HOURS=numberRange(0,24).map((hour)=>[hour,String(hour)]);const MINUTES=numberRange(0,60).map((minute)=>[minute,String(minute||0).padStart(2,"0")]);const SECONDS=[...MINUTES];const MERIDIEMS=["AM","PM"];const PRECISION_LEVELS=new Map().set("days",{mainTitle:_t("Select month"),nextTitle:_t("Next month"),prevTitle:_t("Previous month"),step:{month:1},getTitle:(date,{additionalMonth})=>{const titles=[`${date.monthLong} ${date.year}`];if(additionalMonth){const next=date.plus({month:1});titles.push(`${next.monthLong} ${next.year}`);}
return titles;},getItems:(date,{additionalMonth,maxDate,minDate,showWeekNumbers,isDateValid,dayCellClass})=>{const startDates=[date];if(additionalMonth){startDates.push(date.plus({month:1}));}
const lastWeeks=[];let shouldAddLastWeek=false;const dayItems=startDates.map((date,i)=>{const monthRange=[date.startOf("month"),date.endOf("month")];const weeks=[];let startOfNextWeek=getStartOfWeek(monthRange[0]);for(let w=0;w<WEEKS_PER_MONTH;w++){const weekDayItems=[];for(let d=0;d<DAYS_PER_WEEK;d++){const day=startOfNextWeek.plus({day:d});const range=[day,day.endOf("day")];const dayItem=toDateItem({isOutOfRange:!isInRange(day,monthRange),isValid:isInRange(range,[minDate,maxDate])&&isDateValid?.(day),label:"day",range,extraClass:dayCellClass?.(day)||"",});weekDayItems.push(dayItem);if(d===DAYS_PER_WEEK-1){startOfNextWeek=day.plus({day:1});}
if(w===WEEKS_PER_MONTH-1){shouldAddLastWeek||=!dayItem.isOutOfRange;}}
const weekItem=toWeekItem(weekDayItems);if(w===WEEKS_PER_MONTH-1){lastWeeks.push(weekItem);}else{weeks.push(weekItem);}}
const daysOfWeek=weeks[0].days.map((d)=>[d.range[0].weekdayShort,d.range[0].weekdayLong,Info.weekdays("narrow",{locale:d.range[0].locale})[d.range[0].weekday-1],]);if(showWeekNumbers){daysOfWeek.unshift(["#",_t("Week numbers"),"#"]);}
return{id:`__month__${i}`,number:monthRange[0].month,daysOfWeek,weeks,};});if(shouldAddLastWeek){for(let i=0;i<dayItems.length;i++){dayItems[i].weeks.push(lastWeeks[i]);}}
return dayItems;},}).set("months",{mainTitle:_t("Select year"),nextTitle:_t("Next year"),prevTitle:_t("Previous year"),step:{year:1},getTitle:(date)=>String(date.year),getItems:(date,{maxDate,minDate})=>{const startOfYear=date.startOf("year");return numberRange(0,12).map((i)=>{const startOfMonth=startOfYear.plus({month:i});const range=[startOfMonth,startOfMonth.endOf("month")];return toDateItem({isValid:isInRange(range,[minDate,maxDate]),label:"monthShort",range,});});},}).set("years",{mainTitle:_t("Select decade"),nextTitle:_t("Next decade"),prevTitle:_t("Previous decade"),step:{year:10},getTitle:(date)=>`${getStartOfDecade(date) - 1} - ${getStartOfDecade(date) + 10}`,getItems:(date,{maxDate,minDate})=>{const startOfDecade=date.startOf("year").set({year:getStartOfDecade(date)});return numberRange(-GRID_MARGIN,GRID_COUNT+GRID_MARGIN).map((i)=>{const startOfYear=startOfDecade.plus({year:i});const range=[startOfYear,startOfYear.endOf("year")];return toDateItem({isOutOfRange:i<0||i>=GRID_COUNT,isValid:isInRange(range,[minDate,maxDate]),label:"year",range,});});},}).set("decades",{mainTitle:_t("Select century"),nextTitle:_t("Next century"),prevTitle:_t("Previous century"),step:{year:100},getTitle:(date)=>`${getStartOfCentury(date) - 10} - ${getStartOfCentury(date) + 100}`,getItems:(date,{maxDate,minDate})=>{const startOfCentury=date.startOf("year").set({year:getStartOfCentury(date)});return numberRange(-GRID_MARGIN,GRID_COUNT+GRID_MARGIN).map((i)=>{const startOfDecade=startOfCentury.plus({year:i*10});const range=[startOfDecade,startOfDecade.plus({year:10,millisecond:-1})];return toDateItem({label:"year",isOutOfRange:i<0||i>=GRID_COUNT,isValid:isInRange(range,[minDate,maxDate]),range,});});},});const GRID_COUNT=10;const GRID_MARGIN=1;const NULLABLE_DATETIME_PROPERTY=[DateTime,{value:false},{value:null}];const DAYS_PER_WEEK=7;const WEEKS_PER_MONTH=6;const DateTimePicker=__exports.DateTimePicker=class DateTimePicker extends Component{static props={focusedDateIndex:{type:Number,optional:true},showWeekNumbers:{type:Boolean,optional:true},daysOfWeekFormat:{type:String,optional:true},maxDate:{type:[NULLABLE_DATETIME_PROPERTY,{value:"today"}],optional:true},maxPrecision:{type:[...PRECISION_LEVELS.keys()].map((value)=>({value})),optional:true,},minDate:{type:[NULLABLE_DATETIME_PROPERTY,{value:"today"}],optional:true},minPrecision:{type:[...PRECISION_LEVELS.keys()].map((value)=>({value})),optional:true,},onSelect:{type:Function,optional:true},range:{type:Boolean,optional:true},rounding:{type:Number,optional:true},slots:{type:Object,shape:{bottom_left:{type:Object,optional:true},buttons:{type:Object,optional:true},},optional:true,},type:{type:[{value:"date"},{value:"datetime"}],optional:true},value:{type:[NULLABLE_DATETIME_PROPERTY,{type:Array,element:NULLABLE_DATETIME_PROPERTY},],optional:true,},isDateValid:{type:Function,optional:true},dayCellClass:{type:Function,optional:true},tz:{type:String,optional:true},};static defaultProps={focusedDateIndex:0,daysOfWeekFormat:"short",maxPrecision:"decades",minPrecision:"days",rounding:5,type:"datetime",};static template="web.DateTimePicker";get activePrecisionLevel(){return PRECISION_LEVELS.get(this.state.precision);}
get isLastPrecisionLevel(){return(this.allowedPrecisionLevels.indexOf(this.state.precision)===this.allowedPrecisionLevels.length-1);}
get titles(){return ensureArray(this.title);}
setup(){this.availableHours=HOURS;this.availableMinutes=MINUTES;this.allowedPrecisionLevels=[];this.items=[];this.title="";this.shouldAdjustFocusDate=false;this.state=useState({focusDate:null,hoveredDate:null,timeValues:[],precision:this.props.minPrecision,});this.onPropsUpdated(this.props);onWillUpdateProps((nextProps)=>this.onPropsUpdated(nextProps));onWillRender(()=>this.onWillRender());}
onPropsUpdated(props){this.values=ensureArray(props.value).map((value)=>value&&!value.isValid?null:value);this.availableHours=HOURS;this.availableMinutes=MINUTES.filter((minute)=>!(minute[0]%props.rounding));this.availableSeconds=props.rounding?[]:SECONDS;this.allowedPrecisionLevels=this.filterPrecisionLevels(props.minPrecision,props.maxPrecision);this.additionalMonth=props.range&&!this.env.isSmall;this.maxDate=parseLimitDate(props.maxDate,MAX_VALID_DATE);this.minDate=parseLimitDate(props.minDate,MIN_VALID_DATE);if(this.props.type==="date"){this.maxDate=this.maxDate.endOf("day");this.minDate=this.minDate.startOf("day");}
if(this.maxDate<this.minDate){throw new Error(`DateTimePicker error: given "maxDate" comes before "minDate".`);}
const timeValues=this.values.map((val,index)=>[index===1&&!this.values[1]?(val||DateTime.local()).hour+1:(val||DateTime.local()).hour,val?.minute||0,val?.second||0,]);if(props.range){this.state.timeValues=timeValues;}else{this.state.timeValues=[];this.state.timeValues[props.focusedDateIndex]=timeValues[props.focusedDateIndex];}
this.shouldAdjustFocusDate=!props.range;this.adjustFocus(this.values,props.focusedDateIndex);this.handle12HourSystem();this.state.timeValues=this.state.timeValues.map((timeValue)=>timeValue.map(String));}
onWillRender(){const{dayCellClass,focusedDateIndex,isDateValid,range,showWeekNumbers}=this.props;const{focusDate,hoveredDate}=this.state;const precision=this.activePrecisionLevel;const getterParams={additionalMonth:this.additionalMonth,maxDate:this.maxDate,minDate:this.minDate,showWeekNumbers:showWeekNumbers??!range,isDateValid,dayCellClass,};this.title=precision.getTitle(focusDate,getterParams);this.items=precision.getItems(focusDate,getterParams);this.selectedRange=[...this.values];if(range&&focusedDateIndex>0&&(!this.values[1]||hoveredDate>this.values[0])){this.selectedRange[1]=hoveredDate;}}
adjustFocus(values,focusedDateIndex){if(!this.shouldAdjustFocusDate&&this.state.focusDate){return;}
let dateToFocus=values[focusedDateIndex]||values[focusedDateIndex===1?0:1]||today();if(this.additionalMonth&&focusedDateIndex===1&&values[0]&&values[1]&&values[0].month!==values[1].month){dateToFocus=dateToFocus.minus({month:1});}
this.shouldAdjustFocusDate=false;this.state.focusDate=this.clamp(dateToFocus.startOf("month"));}
clamp(value){return clampDate(value,this.minDate,this.maxDate);}
filterPrecisionLevels(minPrecision,maxPrecision){const levels=[...PRECISION_LEVELS.keys()];return levels.slice(levels.indexOf(minPrecision),levels.indexOf(maxPrecision)+1);}
getActiveRangeInfo({isOutOfRange,range}){const result={isSelected:!isOutOfRange&&isInRange(this.selectedRange,range),isSelectStart:false,isSelectEnd:false,isHighlighted:isInRange(this.state.hoveredDate,range),isCurrent:false,};if(this.props.range){if(result.isSelected){const[selectStart,selectEnd]=this.selectedRange;result.isSelectStart=!selectStart||isInRange(selectStart,range);result.isSelectEnd=!selectEnd||isInRange(selectEnd,range);}
result.isCurrent=!isOutOfRange&&(isInRange(this.values[0],range)||isInRange(this.values[1],range));}else{result.isSelectStart=result.isSelectEnd=result.isSelected;}
return result;}
getTimeValues(valueIndex){let[hour,minute,second]=this.state.timeValues[valueIndex].map(Number);if(this.is12HourFormat&&this.meridiems&&this.state.timeValues[valueIndex][3]==="PM"){hour+=12;}
return[hour,minute,second];}
handle12HourSystem(){if(isMeridiemFormat()){this.meridiems=MERIDIEMS.map((m)=>[m,m]);for(const timeValues of this.state.timeValues){if(timeValues){timeValues.push(MERIDIEMS[Math.floor(timeValues[0]/12)||0]);}}}
this.is12HourFormat=!is24HourFormat();if(this.is12HourFormat){this.availableHours=[[0,HOURS[12][1]],...HOURS.slice(1,12)];for(const timeValues of this.state.timeValues){if(timeValues){timeValues[0]%=12;}}}}
isSelectedDate({range}){return this.values.some((value)=>isInRange(value,range));}
next(ev){ev.preventDefault();const{step}=this.activePrecisionLevel;this.state.focusDate=this.clamp(this.state.focusDate.plus(step));}
previous(ev){ev.preventDefault();const{step}=this.activePrecisionLevel;this.state.focusDate=this.clamp(this.state.focusDate.minus(step));}
selectTime(valueIndex){const value=this.values[valueIndex]||today();this.validateAndSelect(value,valueIndex,"time");}
validateAndSelect(value,valueIndex,unit){if(!this.props.onSelect){return false;}
const result=[...this.values];result[valueIndex]=value;if(this.props.type==="datetime"){const[hour,minute,second]=this.getTimeValues(valueIndex);result[valueIndex]=result[valueIndex].set({hour,minute,second});}
if(!isInRange(result[valueIndex],[this.minDate,this.maxDate])){return false;}
this.props.onSelect(result.length===2?result:result[0],unit);return true;}
zoomIn(date){const index=this.allowedPrecisionLevels.indexOf(this.state.precision)-1;if(index in this.allowedPrecisionLevels){this.state.focusDate=this.clamp(date);this.state.precision=this.allowedPrecisionLevels[index];return true;}
return false;}
zoomOut(){const index=this.allowedPrecisionLevels.indexOf(this.state.precision)+1;if(index in this.allowedPrecisionLevels){this.state.precision=this.allowedPrecisionLevels[index];return true;}
return false;}
zoomOrSelect(dateItem){if(!dateItem.isValid){return;}
if(this.zoomIn(dateItem.range[0])){return;}
const[value]=dateItem.range;const valueIndex=this.props.focusedDateIndex;const isValid=this.validateAndSelect(value,valueIndex,"date");this.shouldAdjustFocusDate=isValid&&!this.props.range;}}
return __exports;});;

/* /web/static/src/core/datetime/datetime_picker_popover.js */
odoo.define('@web/core/datetime/datetime_picker_popover',['@odoo/owl','@web/core/hotkeys/hotkey_hook','@web/core/datetime/datetime_picker'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{DateTimePicker}=require("@web/core/datetime/datetime_picker");const DateTimePickerPopover=__exports.DateTimePickerPopover=class DateTimePickerPopover extends Component{static components={DateTimePicker};static props={close:Function,pickerProps:{type:Object,shape:DateTimePicker.props},};static template="web.DateTimePickerPopover";get isDateTimeRange(){return(this.props.pickerProps.type==="datetime"||Array.isArray(this.props.pickerProps.value));}
setup(){useHotkey("enter",()=>this.props.close());}}
return __exports;});;

/* /web/static/src/core/datetime/datetimepicker_service.js */
odoo.define('@web/core/datetime/datetimepicker_service',['@odoo/owl','@web/core/l10n/dates','@web/core/popover/popover_hook','@web/core/registry','@web/core/utils/arrays','@web/core/utils/objects','@web/core/datetime/datetime_picker','@web/core/datetime/datetime_picker_popover'],function(require){'use strict';let __exports={};const{markRaw,reactive}=require("@odoo/owl");const{areDatesEqual,formatDate,formatDateTime,parseDate,parseDateTime}=require("@web/core/l10n/dates");const{makePopover}=require("@web/core/popover/popover_hook");const{registry}=require("@web/core/registry");const{ensureArray,zip,zipWith}=require("@web/core/utils/arrays");const{deepCopy,shallowEqual}=require("@web/core/utils/objects");const{DateTimePicker}=require("@web/core/datetime/datetime_picker");const{DateTimePickerPopover}=require("@web/core/datetime/datetime_picker_popover");const arePropsEqual=(obj1,obj2)=>shallowEqual(obj1,obj2,(a,b)=>areDatesEqual(a,b)||shallowEqual(a,b));const FOCUS_CLASSNAME="text-primary";const formatters={date:formatDate,datetime:formatDateTime,};const listenedElements=new WeakSet();const parsers={date:parseDate,datetime:parseDateTime,};const datetimePickerService=__exports.datetimePickerService={dependencies:["popover"],start(env,{popover:popoverService}){return{create:(hookParams,getInputs=()=>[hookParams.target,null])=>{const createPopover=hookParams.createPopover??((...args)=>makePopover(popoverService.add,...args));const ensureVisibility=hookParams.ensureVisibility??(()=>env.isSmall);const popover=createPopover(DateTimePickerPopover,{onClose:()=>{if(!allowOnClose){return;}
updateValueFromInputs();apply();setFocusClass(null);if(restoreTargetMargin){restoreTargetMargin();restoreTargetMargin=null;}},});const apply=()=>{const valueCopy=deepCopy(pickerProps.value);if(areDatesEqual(lastAppliedValue,valueCopy)){return;}
inputsChanged=ensureArray(pickerProps.value).map(()=>false);hookParams.onApply?.(pickerProps.value);lastAppliedValue=valueCopy;};const computeBasePickerProps=()=>{const nextInitialProps=markValuesRaw(hookParams.pickerProps);const propsCopy=deepCopy(nextInitialProps);if(lastInitialProps&&arePropsEqual(lastInitialProps,propsCopy)){return;}
lastInitialProps=propsCopy;lastAppliedValue=propsCopy.value;inputsChanged=ensureArray(lastInitialProps.value).map(()=>false);for(const[key,value]of Object.entries(nextInitialProps)){if(pickerProps[key]!==value&&!areDatesEqual(pickerProps[key],value)){pickerProps[key]=value;}}};const focusActiveInput=()=>{const inputEl=getInput(pickerProps.focusedDateIndex);if(!inputEl){shouldFocus=true;return;}
const{activeElement}=inputEl.ownerDocument;if(activeElement!==inputEl){inputEl.focus();}
setInputFocus(inputEl);};const getInput=(valueIndex)=>{const el=getInputs()[valueIndex];if(el&&document.body.contains(el)){return el;}
return null;};const getPopoverTarget=()=>{if(hookParams.target){return hookParams.target;}
if(pickerProps.range){let parentElement=getInput(0).parentElement;const inputEls=getInputs();while(parentElement&&!inputEls.every((inputEl)=>parentElement.contains(inputEl))){parentElement=parentElement.parentElement;}
return parentElement||getInput(0);}else{return getInput(0);}};const markValuesRaw=(obj)=>{const copy={};for(const[key,value]of Object.entries(obj)){if(value&&typeof value==="object"){copy[key]=markRaw(value);}else{copy[key]=value;}}
return copy;};const onInputChange=(ev)=>{updateValueFromInputs();inputsChanged[ev.target===getInput(1)?1:0]=true;if(!popover.isOpen||inputsChanged.every(Boolean)){saveAndClose();}};const onInputClick=({target})=>{openPicker(target===getInput(1)?1:0);};const onInputFocus=({target})=>{pickerProps.focusedDateIndex=target===getInput(1)?1:0;setInputFocus(target);};const onInputKeydown=(ev)=>{if(ev.key=="Enter"&&ev.ctrlKey){ev.preventDefault();updateValueFromInputs();return openPicker(ev.target===getInput(1)?1:0);}
switch(ev.key){case"Enter":case"Escape":{return saveAndClose();}
case"Tab":{if(!getInput(0)||!getInput(1)||ev.target!==getInput(ev.shiftKey?1:0)){return saveAndClose();}}}};const openPicker=(inputIndex)=>{pickerProps.focusedDateIndex=inputIndex;if(!popover.isOpen){const popoverTarget=getPopoverTarget();if(ensureVisibility()){const{marginBottom}=popoverTarget.style;popoverTarget.style.marginBottom=`100vh`;popoverTarget.scrollIntoView(true);restoreTargetMargin=async()=>{popoverTarget.style.marginBottom=marginBottom;};}
popover.open(popoverTarget,{pickerProps});}
focusActiveInput();};const safeConvert=(operation,value)=>{const{type}=pickerProps;const convertFn=(operation==="format"?formatters:parsers)[type];const options={tz:pickerProps.tz,format:hookParams.format};if(operation==="format"){options.showSeconds=hookParams.showSeconds??true;options.condensed=hookParams.condensed||false;}
try{return[convertFn(value,options),null];}catch(error){if(error?.name==="ConversionError"){return[null,error];}else{throw error;}}};const saveAndClose=()=>{if(popover.isOpen){popover.close();}else{apply();}};const setFocusClass=(input)=>{for(const el of getInputs()){if(el){el.classList.toggle(FOCUS_CLASSNAME,popover.isOpen&&el===input);}}};const setInputFocus=(inputEl)=>{inputEl.selectionStart=0;inputEl.selectionEnd=inputEl.value.length;setFocusClass(inputEl);shouldFocus=false;};const updateInput=(el,value)=>{if(!el){return;}
const[formattedValue]=safeConvert("format",value);el.value=formattedValue||"";};const updateValue=(value,unit,source)=>{const previousValue=pickerProps.value;pickerProps.value=value;if(areDatesEqual(previousValue,pickerProps.value)){return;}
if(unit!=="time"){if(pickerProps.range&&source==="picker"){if(pickerProps.focusedDateIndex===0||(value[0]&&value[1]&&value[1]<value[0])){const{year,month,day}=value[pickerProps.focusedDateIndex];for(let i=0;i<value.length;i++){value[i]=value[i]&&value[i].set({year,month,day});}
pickerProps.focusedDateIndex=1;}else{pickerProps.focusedDateIndex=pickerProps.focusedDateIndex===1?0:1;}}}
hookParams.onChange?.(value);};const updateValueFromInputs=()=>{const values=zipWith(getInputs(),ensureArray(pickerProps.value),(el,currentValue)=>{if(!el){return currentValue;}
const[parsedValue,error]=safeConvert("parse",el.value);if(error){updateInput(el,currentValue);return currentValue;}else{return parsedValue;}});updateValue(values.length===2?values:values[0],"date","input");};const rawPickerProps={...DateTimePicker.defaultProps,onSelect:(value,unit)=>{value&&=markRaw(value);updateValue(value,unit,"picker");if(!pickerProps.range&&pickerProps.type==="date"){saveAndClose();}},...markValuesRaw(hookParams.pickerProps),};const pickerProps=reactive(rawPickerProps,()=>{const currentIsRange=pickerProps.range;if(popover.isOpen&&lastIsRange!==currentIsRange){allowOnClose=false;popover.open(getPopoverTarget(),{pickerProps});allowOnClose=true;}
lastIsRange=currentIsRange;for(const[el,value]of zip(getInputs(),ensureArray(pickerProps.value),true)){if(el){updateInput(el,value);}}
shouldFocus=true;});let allowOnClose=true;let inputsChanged=[];let lastInitialProps=null;let lastAppliedValue=null;let lastIsRange=pickerProps.range;let restoreTargetMargin=null;let shouldFocus=false;return{state:pickerProps,open:openPicker,computeBasePickerProps,focusIfNeeded(){if(popover.isOpen&&shouldFocus){focusActiveInput();}},enable(){let editableInputs=0;for(const[el,value]of zip(getInputs(),ensureArray(pickerProps.value),true)){updateInput(el,value);if(el&&!el.disabled&&!el.readOnly&&!listenedElements.has(el)){listenedElements.add(el);el.addEventListener("change",onInputChange);el.addEventListener("click",onInputClick);el.addEventListener("focus",onInputFocus);el.addEventListener("keydown",onInputKeydown);editableInputs++;}}
const calendarIconGroupEl=getInput(0)?.parentElement.querySelector(".o_input_group_date_icon");if(calendarIconGroupEl){calendarIconGroupEl.classList.add("cursor-pointer");calendarIconGroupEl.addEventListener("click",()=>openPicker(0));}
if(!editableInputs&&popover.isOpen){saveAndClose();}
return()=>{};},get isOpen(){return popover.isOpen;},};},};},};registry.category("services").add("datetime_picker",datetimePickerService);return __exports;});;

/* /web/static/src/core/debug/debug_context.js */
odoo.define('@web/core/debug/debug_context',['@web/core/user','@web/core/registry','@odoo/owl'],function(require){'use strict';let __exports={};const{user}=require("@web/core/user");const{registry}=require("@web/core/registry");const{useEffect,useEnv,useSubEnv}=require("@odoo/owl");const debugRegistry=registry.category("debug");const getAccessRights=async()=>{const rightsToCheck={"ir.ui.view":"write","ir.rule":"read","ir.model.access":"read",};const proms=Object.entries(rightsToCheck).map(([model,operation])=>{return user.checkAccessRight(model,operation);});const[canEditView,canSeeRecordRules,canSeeModelAccess]=await Promise.all(proms);const accessRights={canEditView,canSeeRecordRules,canSeeModelAccess};return accessRights;};class DebugContext{constructor(defaultCategories){this.categories=new Map(defaultCategories.map((cat)=>[cat,[{}]]));}
activateCategory(category,context){const contexts=this.categories.get(category)||new Set();contexts.add(context);this.categories.set(category,contexts);return()=>{contexts.delete(context);if(contexts.size===0){this.categories.delete(category);}};}
async getItems(env){const accessRights=await getAccessRights();return[...this.categories.entries()].flatMap(([category,contexts])=>{return debugRegistry.category(category).getAll().map((factory)=>factory(Object.assign({env,accessRights},...contexts)));}).filter(Boolean).sort((x,y)=>{const xSeq=x.sequence||1000;const ySeq=y.sequence||1000;return xSeq-ySeq;});}}
const debugContextSymbol=Symbol("debugContext");__exports.createDebugContext=createDebugContext;function createDebugContext({categories=[]}={}){return{[debugContextSymbol]:new DebugContext(categories)};}
__exports.useOwnDebugContext=useOwnDebugContext;function useOwnDebugContext({categories=[]}={}){useSubEnv(createDebugContext({categories}));}
__exports.useEnvDebugContext=useEnvDebugContext;function useEnvDebugContext(){const debugContext=useEnv()[debugContextSymbol];if(!debugContext){throw new Error("There is no debug context available in the current environment.");}
return debugContext;}
__exports.useDebugCategory=useDebugCategory;function useDebugCategory(category,context={}){const env=useEnv();if(env.debug){const debugContext=useEnvDebugContext();useEffect(()=>debugContext.activateCategory(category,context),()=>[]);}}
return __exports;});;

/* /web/static/src/core/debug/debug_menu.js */
odoo.define('@web/core/debug/debug_menu',['@web/core/l10n/translation','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/debug/debug_menu_basic','@web/core/commands/command_hook','@web/core/utils/hooks','@web/core/debug/debug_context'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{DebugMenuBasic}=require("@web/core/debug/debug_menu_basic");const{useCommand}=require("@web/core/commands/command_hook");const{useService}=require("@web/core/utils/hooks");const{useEnvDebugContext}=require("@web/core/debug/debug_context");const DebugMenu=__exports.DebugMenu=class DebugMenu extends DebugMenuBasic{static components={Dropdown,DropdownItem};static props={};setup(){super.setup();const debugContext=useEnvDebugContext();this.command=useService("command");useCommand(_t("Debug tools..."),async()=>{const items=await debugContext.getItems(this.env);let index=0;const defaultCategories=items.filter((item)=>item.type==="separator").map(()=>(index+=1));const provider={async provide(){const categories=[...defaultCategories];let category=categories.shift();const result=[];items.forEach((item)=>{if(item.type==="item"){result.push({name:item.description.toString(),action:item.callback,category,});}else if(item.type==="separator"){category=categories.shift();}});return result;},};const configByNamespace={default:{categories:defaultCategories,emptyMessage:_t("No debug command found"),placeholder:_t("Choose a debug command..."),},};const commandPaletteConfig={configByNamespace,providers:[provider],};return commandPaletteConfig;},{category:"debug",});}}
return __exports;});;

/* /web/static/src/core/debug/debug_menu_basic.js */
odoo.define('@web/core/debug/debug_menu_basic',['@web/core/debug/debug_context','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/l10n/translation','@web/core/utils/arrays','@odoo/owl','@web/core/registry'],function(require){'use strict';let __exports={};const{useEnvDebugContext}=require("@web/core/debug/debug_context");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{_t}=require("@web/core/l10n/translation");const{groupBy,sortBy}=require("@web/core/utils/arrays");const{Component}=require("@odoo/owl");const{registry}=require("@web/core/registry");const debugSectionRegistry=registry.category("debug_section");debugSectionRegistry.add("record",{label:_t("Record"),sequence:10}).add("records",{label:_t("Records"),sequence:10}).add("ui",{label:_t("User Interface"),sequence:20}).add("security",{label:_t("Security"),sequence:30}).add("testing",{label:_t("Testing"),sequence:40}).add("tools",{label:_t("Tools"),sequence:50});const DebugMenuBasic=__exports.DebugMenuBasic=class DebugMenuBasic extends Component{static template="web.DebugMenu";static components={Dropdown,DropdownItem,};static props={};setup(){this.debugContext=useEnvDebugContext();}
async loadGroupedItems(){const items=await this.debugContext.getItems(this.env);const sections=groupBy(items,(item)=>item.section||"");this.sectionEntries=sortBy(Object.entries(sections),([section])=>debugSectionRegistry.get(section,{sequence:50}).sequence);}
getSectionLabel(section){return debugSectionRegistry.get(section,{label:section}).label;}}
return __exports;});;

/* /web/static/src/core/debug/debug_menu_items.js */
odoo.define('@web/core/debug/debug_menu_items',['@web/core/l10n/translation','@web/core/browser/browser','@web/core/browser/router','@web/core/registry','@web/core/user'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{router}=require("@web/core/browser/router");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");function activateTestsAssetsDebugging({env}){if(String(router.current.debug).includes("tests")){return;}
return{type:"item",description:_t("Activate Test Mode"),callback:()=>{router.pushState({debug:"assets,tests"},{reload:true});},sequence:580,section:"tools",};}
__exports.regenerateAssets=regenerateAssets;function regenerateAssets({env}){return{type:"item",description:_t("Regenerate Assets"),callback:async()=>{await env.services.orm.call("ir.attachment","regenerate_assets_bundles");browser.location.reload();},sequence:550,section:"tools",};}
__exports.becomeSuperuser=becomeSuperuser;function becomeSuperuser({env}){const becomeSuperuserURL=browser.location.origin+"/web/become";if(!user.isAdmin){return false;}
return{type:"item",description:_t("Become Superuser"),href:becomeSuperuserURL,callback:()=>{browser.open(becomeSuperuserURL,"_self");},sequence:560,section:"tools",};}
function leaveDebugMode(){return{type:"item",description:_t("Leave Debug Mode"),callback:()=>{router.pushState({debug:0},{reload:true});},sequence:650,};}
registry.category("debug").category("default").add("regenerateAssets",regenerateAssets).add("becomeSuperuser",becomeSuperuser).add("activateTestsAssetsDebugging",activateTestsAssetsDebugging).add("leaveDebugMode",leaveDebugMode);return __exports;});;

/* /web/static/src/core/debug/debug_providers.js */
odoo.define('@web/core/debug/debug_providers',['@web/core/l10n/translation','@web/core/registry','@web/core/browser/browser','@web/core/browser/router'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{browser}=require("@web/core/browser/browser");const{router}=require("@web/core/browser/router");const commandProviderRegistry=registry.category("command_provider");commandProviderRegistry.add("debug",{provide:(env,options)=>{const result=[];if(env.debug){if(!env.debug.includes("assets")){result.push({action(){router.pushState({debug:"assets"},{reload:true});},category:"debug",name:_t("Activate debug mode (with assets)"),});}
result.push({action(){router.pushState({debug:0},{reload:true});},category:"debug",name:_t("Deactivate debug mode"),});result.push({action(){browser.open("/web/tests?debug=assets");},category:"debug",name:_t("Run Unit Tests"),});}else{const debugKey="debug";if(options.searchValue.toLowerCase()===debugKey){result.push({action(){router.pushState({debug:"1"},{reload:true});},category:"debug",name:`${_t("Activate debug mode")} (${debugKey})`,});result.push({action(){router.pushState({debug:"assets"},{reload:true});},category:"debug",name:`${_t("Activate debug mode (with assets)")} (${debugKey})`,});}}
return result;},});return __exports;});;

/* /web/static/src/core/debug/debug_utils.js */
odoo.define('@web/core/debug/debug_utils',[],function(require){'use strict';let __exports={};__exports.editModelDebug=editModelDebug;function editModelDebug(env,title,model,id){return env.services.action.doAction({res_model:model,res_id:id,name:title,type:"ir.actions.act_window",views:[[false,"form"]],view_mode:"form",target:"current",});}
return __exports;});;

/* /web/static/src/core/dialog/dialog.js */
odoo.define('@web/core/dialog/dialog',['@web/core/hotkeys/hotkey_hook','@web/core/ui/ui_service','@web/core/utils/hooks','@odoo/owl','@web/core/utils/timing','@web/core/utils/draggable_hook_builder_owl'],function(require){'use strict';let __exports={};const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{useActiveElement}=require("@web/core/ui/ui_service");const{useForwardRefToParent}=require("@web/core/utils/hooks");const{Component,onWillDestroy,useChildSubEnv,useExternalListener,useState}=require("@odoo/owl");const{throttleForAnimation}=require("@web/core/utils/timing");const{makeDraggableHook}=require("@web/core/utils/draggable_hook_builder_owl");const useDialogDraggable=makeDraggableHook({name:"useDialogDraggable",onWillStartDrag({ctx,addCleanup,addStyle,getRect}){const{height,width}=getRect(ctx.current.element);ctx.current.container=document.createElement("div");addStyle(ctx.current.container,{position:"fixed",top:"0",bottom:`${70 - height}px`,left:`${70 - width}px`,right:`${70 - width}px`,});ctx.current.element.after(ctx.current.container);addCleanup(()=>ctx.current.container.remove());},onDrop({ctx,getRect}){const{top,left}=getRect(ctx.current.element);return{left:left-ctx.current.elementRect.left,top:top-ctx.current.elementRect.top,};},});const Dialog=__exports.Dialog=class Dialog extends Component{static template="web.Dialog";static props={contentClass:{type:String,optional:true},bodyClass:{type:String,optional:true},fullscreen:{type:Boolean,optional:true},footer:{type:Boolean,optional:true},header:{type:Boolean,optional:true},size:{type:String,optional:true,validate:(s)=>["sm","md","lg","xl","fs","fullscreen"].includes(s),},technical:{type:Boolean,optional:true},title:{type:String,optional:true},modalRef:{type:Function,optional:true},slots:{type:Object,shape:{default:Object,header:{type:Object,optional:true},footer:{type:Object,optional:true},},},withBodyPadding:{type:Boolean,optional:true},onExpand:{type:Function,optional:true},};static defaultProps={contentClass:"",bodyClass:"",fullscreen:false,footer:true,header:true,size:"lg",technical:true,title:"Odoo",withBodyPadding:true,};setup(){this.modalRef=useForwardRefToParent("modalRef");useActiveElement("modalRef");this.data=useState(this.env.dialogData);useHotkey("escape",()=>this.onEscape());useHotkey("control+enter",()=>{const btns=document.querySelectorAll(".o_dialog:not(.o_inactive_modal) .modal-footer button");const firstVisibleBtn=Array.from(btns).find((btn)=>{const styles=getComputedStyle(btn);return styles.display!=="none";});if(firstVisibleBtn){firstVisibleBtn.click();}},{bypassEditableProtection:true});this.id=`dialog_${this.data.id}`;useChildSubEnv({inDialog:true,dialogId:this.id});this.isMovable=this.props.header;if(this.isMovable){this.position=useState({left:0,top:0});useDialogDraggable({enable:()=>!this.env.isSmall,ref:this.modalRef,elements:".modal-content",handle:".modal-header",ignore:"button, input",edgeScrolling:{enabled:false},onDrop:({top,left})=>{this.position.left+=left;this.position.top+=top;},});const throttledResize=throttleForAnimation(this.onResize.bind(this));useExternalListener(window,"resize",throttledResize);}
onWillDestroy(()=>{if(this.env.isSmall){this.data.scrollToOrigin();}});}
get isFullscreen(){return this.props.fullscreen||this.env.isSmall;}
get contentStyle(){if(this.isMovable){return`top: ${this.position.top}px; left: ${this.position.left}px;`;}
return"";}
onResize(){this.position.left=0;this.position.top=0;}
onEscape(){return this.dismiss();}
async dismiss(){if(this.data.dismiss){await this.data.dismiss();}
return this.data.close();}}
return __exports;});;

/* /web/static/src/core/dialog/dialog_service.js */
odoo.define('@web/core/dialog/dialog_service',['@odoo/owl','@web/core/registry'],function(require){'use strict';let __exports={};const{Component,markRaw,reactive,useChildSubEnv,xml}=require("@odoo/owl");const{registry}=require("@web/core/registry");class DialogWrapper extends Component{static template=xml`<t t-component="props.subComponent" t-props="props.subProps" />`;static props=["*"];setup(){useChildSubEnv({dialogData:this.props.subEnv});}}
const dialogService=__exports.dialogService={dependencies:["overlay"],start(env,{overlay}){const stack=[];let nextId=0;const deactivate=()=>{for(const subEnv of stack){subEnv.isActive=false;}};const add=(dialogClass,props,options={})=>{const id=nextId++;const close=()=>remove();const subEnv=reactive({id,close,isActive:true,});deactivate();stack.push(subEnv);document.body.classList.add("modal-open");const scrollOrigin={top:window.scrollY,left:window.scrollX};subEnv.scrollToOrigin=()=>{if(!stack.length){window.scrollTo(scrollOrigin);}};const remove=overlay.add(DialogWrapper,{subComponent:dialogClass,subProps:markRaw({...props,close}),subEnv,},{onRemove:()=>{stack.pop();deactivate();if(stack.length){stack.at(-1).isActive=true;}else{document.body.classList.remove("modal-open");}
options.onClose?.();},rootId:options.context?.root?.el.getRootNode()?.host?.id,});return remove;};function closeAll(){for(const dialog of[...stack].reverse()){dialog.close();}}
return{add,closeAll};},};registry.category("services").add("dialog",dialogService);return __exports;});;

/* /web/static/src/core/domain.js */
odoo.define('@web/core/domain',['@web/core/utils/arrays','@web/core/py_js/py','@web/core/py_js/py_utils','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{shallowEqual}=require("@web/core/utils/arrays");const{evaluate,formatAST,parseExpr}=require("@web/core/py_js/py");const{toPyValue}=require("@web/core/py_js/py_utils");const{escapeRegExp}=require("@web/core/utils/strings");const InvalidDomainError=__exports.InvalidDomainError=class InvalidDomainError extends Error{}
const Domain=__exports.Domain=class Domain{static combine(domains,operator){if(domains.length===0){return new Domain([]);}
const domain1=domains[0]instanceof Domain?domains[0]:new Domain(domains[0]);if(domains.length===1){return domain1;}
const domain2=Domain.combine(domains.slice(1),operator);const result=new Domain([]);const astValues1=domain1.ast.value;const astValues2=domain2.ast.value;const op=operator==="AND"?"&":"|";const combinedAST={type:4,value:astValues1.concat(astValues2)};result.ast=normalizeDomainAST(combinedAST,op);return result;}
static and(domains){return Domain.combine(domains,"AND");}
static or(domains){return Domain.combine(domains,"OR");}
static not(domain){const result=new Domain(domain);result.ast.value.unshift({type:1,value:"!"});return result;}
static removeDomainLeaves(domain,keysToRemove){function processLeaf(elements,idx,operatorCtx,newDomain){const leaf=elements[idx];if(leaf.type===10){if(keysToRemove.includes(leaf.value[0].value)){if(operatorCtx==="&"){newDomain.ast.value.push(...Domain.TRUE.ast.value);}else if(operatorCtx==="|"){newDomain.ast.value.push(...Domain.FALSE.ast.value);}}else{newDomain.ast.value.push(leaf);}
return 1;}else if(leaf.type===1){if(leaf.value==="|"&&elements[idx+1].type===10&&elements[idx+2].type===10&&keysToRemove.includes(elements[idx+1].value[0].value)&&keysToRemove.includes(elements[idx+2].value[0].value)){newDomain.ast.value.push(...Domain.TRUE.ast.value);return 3;}
newDomain.ast.value.push(leaf);if(leaf.value==="!"){return 1+processLeaf(elements,idx+1,"&",newDomain);}
const firstLeafSkip=processLeaf(elements,idx+1,leaf.value,newDomain);const secondLeafSkip=processLeaf(elements,idx+1+firstLeafSkip,leaf.value,newDomain);return 1+firstLeafSkip+secondLeafSkip;}
return 0;}
domain=new Domain(domain);if(domain.ast.value.length===0){return domain;}
const newDomain=new Domain([]);processLeaf(domain.ast.value,0,"&",newDomain);return newDomain;}
constructor(descr=[]){if(descr instanceof Domain){return new Domain(descr.toString());}else{let rawAST;try{rawAST=typeof descr==="string"?parseExpr(descr):toAST(descr);}catch(error){throw new InvalidDomainError(`Invalid domain representation: ${descr.toString()}`,{cause:error,});}
this.ast=normalizeDomainAST(rawAST);}}
contains(record){const expr=evaluate(this.ast,record);return matchDomain(record,expr);}
toString(){return formatAST(this.ast);}
toList(context){return evaluate(this.ast,context);}
toJson(){try{const evaluatedAsList=this.toList({});const evaluatedDomain=new Domain(evaluatedAsList);if(evaluatedDomain.toString()===this.toString()){return evaluatedAsList;}
return this.toString();}catch{return this.toString();}}}
__exports.evalDomain=evalDomain;function evalDomain(modifier,evalContext){if(modifier&&typeof modifier!=="boolean"){modifier=new Domain(modifier).contains(evalContext);}
return Boolean(modifier);}
const TRUE_LEAF=[1,"=",1];const FALSE_LEAF=[0,"=",1];const TRUE_DOMAIN=new Domain([TRUE_LEAF]);const FALSE_DOMAIN=new Domain([FALSE_LEAF]);Domain.TRUE=TRUE_DOMAIN;Domain.FALSE=FALSE_DOMAIN;function toAST(domain){const elems=domain.map((elem)=>{switch(elem){case"!":case"&":case"|":return{type:1,value:elem};default:return{type:10,value:elem.map(toPyValue),};}});return{type:4,value:elems};}
function normalizeDomainAST(domain,op="&"){if(domain.type!==4){if(domain.type===10){const value=domain.value;if(value.findIndex((e)=>e.type===10)===-1||!value.every((e)=>e.type===10||e.type===1)){throw new InvalidDomainError("Invalid domain AST");}}else{throw new InvalidDomainError("Invalid domain AST");}}
if(domain.value.length===0){return domain;}
let expected=1;for(const child of domain.value){switch(child.type){case 1:if(child.value==="&"||child.value==="|"){expected++;}else if(child.value!=="!"){throw new InvalidDomainError("Invalid domain AST");}
break;case 4:case 10:if(child.value.length===3){expected--;break;}
throw new InvalidDomainError("Invalid domain AST");default:throw new InvalidDomainError("Invalid domain AST");}}
const values=domain.value.slice();while(expected<0){expected++;values.unshift({type:1,value:op});}
if(expected>0){throw new InvalidDomainError(`invalid domain ${formatAST(domain)} (missing ${expected} segment(s))`);}
return{type:4,value:values};}
function matchCondition(record,condition){if(typeof condition==="boolean"){return condition;}
const[field,operator,value]=condition;if(typeof field==="string"){const names=field.split(".");if(names.length>=2){return matchCondition(record[names[0]],[names.slice(1).join("."),operator,value]);}}
let likeRegexp,ilikeRegexp;if(["like","not like","ilike","not ilike"].includes(operator)){likeRegexp=new RegExp(`(.*)${escapeRegExp(value).replaceAll("%", "(.*)")}(.*)`,"g");ilikeRegexp=new RegExp(`(.*)${escapeRegExp(value).replaceAll("%", "(.*)")}(.*)`,"gi");}
const fieldValue=typeof field==="number"?field:record[field];switch(operator){case"=?":if([false,null].includes(value)){return true;}
case"=":case"==":if(Array.isArray(fieldValue)&&Array.isArray(value)){return shallowEqual(fieldValue,value);}
return fieldValue===value;case"!=":case"<>":return!matchCondition(record,[field,"==",value]);case"<":return fieldValue<value;case"<=":return fieldValue<=value;case">":return fieldValue>value;case">=":return fieldValue>=value;case"in":{const val=Array.isArray(value)?value:[value];const fieldVal=Array.isArray(fieldValue)?fieldValue:[fieldValue];return fieldVal.some((fv)=>val.includes(fv));}
case"not in":{const val=Array.isArray(value)?value:[value];const fieldVal=Array.isArray(fieldValue)?fieldValue:[fieldValue];return!fieldVal.some((fv)=>val.includes(fv));}
case"like":if(fieldValue===false){return false;}
return Boolean(fieldValue.match(likeRegexp));case"not like":if(fieldValue===false){return false;}
return Boolean(!fieldValue.match(likeRegexp));case"=like":if(fieldValue===false){return false;}
return new RegExp(escapeRegExp(value).replace(/%/g,".*")).test(fieldValue);case"ilike":if(fieldValue===false){return false;}
return Boolean(fieldValue.match(ilikeRegexp));case"not ilike":if(fieldValue===false){return false;}
return Boolean(!fieldValue.match(ilikeRegexp));case"=ilike":if(fieldValue===false){return false;}
return new RegExp(escapeRegExp(value).replace(/%/g,".*"),"i").test(fieldValue);case"any":case"not_any":return true;}
throw new InvalidDomainError("could not match domain");}
function makeOperators(record){const match=matchCondition.bind(null,record);return{"!":(x)=>!match(x),"&":(a,b)=>match(a)&&match(b),"|":(a,b)=>match(a)||match(b),};}
function matchDomain(record,domain){if(domain.length===0){return true;}
const operators=makeOperators(record);const reversedDomain=Array.from(domain).reverse();const condStack=[];for(const item of reversedDomain){const operator=typeof item==="string"&&operators[item];if(operator){const operands=condStack.splice(-operator.length);condStack.push(operator(...operands));}else{condStack.push(item);}}
return matchCondition(record,condStack.pop());}
return __exports;});;

/* /web/static/src/core/domain_selector/domain_selector.js */
odoo.define('@web/core/domain_selector/domain_selector',['@odoo/owl','@web/core/domain','@web/core/tree_editor/tree_editor','@web/core/tree_editor/condition_tree','@web/core/model_field_selector/utils','@web/core/checkbox/checkbox','@web/core/utils/objects','@web/core/domain_selector/domain_selector_operator_editor','@web/core/tree_editor/tree_editor_operator_editor','@web/core/l10n/translation','@web/core/model_field_selector/model_field_selector','@web/core/utils/hooks','@web/core/tree_editor/utils','@web/core/domain_selector/utils'],function(require){'use strict';let __exports={};const{Component,onWillStart,onWillUpdateProps}=require("@odoo/owl");const{Domain}=require("@web/core/domain");const{TreeEditor}=require("@web/core/tree_editor/tree_editor");const{domainFromTree,treeFromDomain,formatValue,condition,}=require("@web/core/tree_editor/condition_tree");const{useLoadFieldInfo}=require("@web/core/model_field_selector/utils");const{CheckBox}=require("@web/core/checkbox/checkbox");const{deepEqual}=require("@web/core/utils/objects");const{getDomainDisplayedOperators}=require("@web/core/domain_selector/domain_selector_operator_editor");const{getOperatorEditorInfo}=require("@web/core/tree_editor/tree_editor_operator_editor");const{_t}=require("@web/core/l10n/translation");const{ModelFieldSelector}=require("@web/core/model_field_selector/model_field_selector");const{useService}=require("@web/core/utils/hooks");const{useMakeGetFieldDef}=require("@web/core/tree_editor/utils");const{getDefaultCondition}=require("@web/core/domain_selector/utils");const ARCHIVED_CONDITION=condition("active","in",[true,false]);const ARCHIVED_DOMAIN=`[("active", "in", [True, False])]`;const DomainSelector=__exports.DomainSelector=class DomainSelector extends Component{static template="web.DomainSelector";static components={TreeEditor,CheckBox};static props={domain:String,resModel:String,className:{type:String,optional:true},defaultConnector:{type:[{value:"&"},{value:"|"}],optional:true},isDebugMode:{type:Boolean,optional:true},readonly:{type:Boolean,optional:true},update:{type:Function,optional:true},debugUpdate:{type:Function,optional:true},};static defaultProps={isDebugMode:false,readonly:true,update:()=>{},};setup(){this.fieldService=useService("field");this.loadFieldInfo=useLoadFieldInfo(this.fieldService);this.makeGetFieldDef=useMakeGetFieldDef(this.fieldService);this.tree=null;this.showArchivedCheckbox=false;this.includeArchived=false;onWillStart(()=>this.onPropsUpdated(this.props));onWillUpdateProps((np)=>this.onPropsUpdated(np));}
async onPropsUpdated(p){let domain;let isSupported=true;try{domain=new Domain(p.domain);}catch{isSupported=false;}
if(!isSupported){this.tree=null;this.showArchivedCheckbox=false;this.includeArchived=false;return;}
const tree=treeFromDomain(domain);const getFieldDef=await this.makeGetFieldDef(p.resModel,tree,["active"]);this.tree=treeFromDomain(domain,{getFieldDef,distributeNot:!p.isDebugMode,});this.showArchivedCheckbox=this.getShowArchivedCheckBox(Boolean(getFieldDef("active")),p);this.includeArchived=false;if(this.showArchivedCheckbox){if(this.tree.value==="&"){this.tree.children=this.tree.children.filter((child)=>{if(deepEqual(child,ARCHIVED_CONDITION)){this.includeArchived=true;return false;}
return true;});if(this.tree.children.length===1){this.tree=this.tree.children[0];}}else if(deepEqual(this.tree,ARCHIVED_CONDITION)){this.includeArchived=true;this.tree=treeFromDomain(`[]`);}}}
getShowArchivedCheckBox(hasActiveField,props){return hasActiveField;}
getDefaultCondition(fieldDefs){return getDefaultCondition(fieldDefs);}
getDefaultOperator(fieldDef){return getDomainDisplayedOperators(fieldDef)[0];}
getOperatorEditorInfo(fieldDef){const operators=getDomainDisplayedOperators(fieldDef);return getOperatorEditorInfo(operators,fieldDef);}
getPathEditorInfo(resModel,defaultCondition){const{isDebugMode}=this.props;return{component:ModelFieldSelector,extractProps:({update,value:path})=>{return{path,update,resModel,isDebugMode,readonly:false,};},isSupported:(path)=>[0,1].includes(path)||typeof path==="string",defaultValue:()=>defaultCondition.path,stringify:(path)=>formatValue(path),message:_t("Invalid field chain"),};}
toggleIncludeArchived(){this.includeArchived=!this.includeArchived;this.update(this.tree);}
resetDomain(){this.props.update("[]");}
onDomainInput(domain){if(this.props.debugUpdate){this.props.debugUpdate(domain);}}
onDomainChange(domain){this.props.update(domain,true);}
update(tree){const archiveDomain=this.includeArchived?ARCHIVED_DOMAIN:`[]`;const domain=tree?Domain.and([domainFromTree(tree),archiveDomain]).toString():archiveDomain;this.props.update(domain);}}
return __exports;});;

/* /web/static/src/core/domain_selector/domain_selector_operator_editor.js */
odoo.define('@web/core/domain_selector/domain_selector_operator_editor',[],function(require){'use strict';let __exports={};__exports.getDomainDisplayedOperators=getDomainDisplayedOperators;function getDomainDisplayedOperators(fieldDef){if(!fieldDef){fieldDef={};}
const{type,is_property}=fieldDef;if(is_property){switch(type){case"many2many":case"tags":return["in","not in","set","not_set"];case"many2one":case"selection":return["=","!=","set","not_set"];}}
const hierarchyOperators=fieldDef.allow_hierachy_operators?["child_of","parent_of"]:[];switch(type){case"boolean":return["is","is_not"];case"selection":return["=","!=","in","not in","set","not_set"];case"char":case"text":case"html":return["=","!=","ilike","not ilike","in","not in","set","not_set","starts_with","ends_with",];case"date":case"datetime":return["=","!=",">",">=","<","<=","between","within","set","not_set"];case"integer":case"float":case"monetary":return["=","!=",">",">=","<","<=","between","ilike","not ilike","set","not_set",];case"many2one":case"many2many":case"one2many":return["in","not in","=","!=","ilike","not ilike",...hierarchyOperators,"set","not_set","starts_with","ends_with","any","not any",];case"json":return["=","!=","ilike","not ilike","set","not_set"];case"properties":return["set","not_set"];case undefined:return["="];default:return["=","!=",">",">=","<","<=","ilike","not ilike","like","not like","=like","=ilike","in","not in","set","not_set",];}}
return __exports;});;

/* /web/static/src/core/domain_selector/utils.js */
odoo.define('@web/core/domain_selector/utils',['@web/core/tree_editor/tree_editor_value_editors','@web/core/domain_selector/domain_selector_operator_editor','@web/core/utils/hooks','@web/core/tree_editor/condition_tree','@web/core/tree_editor/utils'],function(require){'use strict';let __exports={};const{getDefaultValue}=require("@web/core/tree_editor/tree_editor_value_editors");const{getDomainDisplayedOperators}=require("@web/core/domain_selector/domain_selector_operator_editor");const{useService}=require("@web/core/utils/hooks");const{domainFromTree,condition}=require("@web/core/tree_editor/condition_tree");const{getDefaultPath}=require("@web/core/tree_editor/utils");__exports.getDefaultCondition=getDefaultCondition;function getDefaultCondition(fieldDefs){const defaultPath=getDefaultPath(fieldDefs);const fieldDef=fieldDefs[defaultPath];const operator=getDomainDisplayedOperators(fieldDef)[0];const value=getDefaultValue(fieldDef,operator);return condition(fieldDef.name,operator,value);}
__exports.getDefaultDomain=getDefaultDomain;function getDefaultDomain(fieldDefs){return domainFromTree(getDefaultCondition(fieldDefs));}
__exports.useGetDefaultLeafDomain=useGetDefaultLeafDomain;function useGetDefaultLeafDomain(){const fieldService=useService("field");return async(resModel)=>{const fieldDefs=await fieldService.loadFields(resModel);return getDefaultDomain(fieldDefs);};}
return __exports;});;

/* /web/static/src/core/domain_selector_dialog/domain_selector_dialog.js */
odoo.define('@web/core/domain_selector_dialog/domain_selector_dialog',['@web/core/l10n/translation','@odoo/owl','@web/core/dialog/dialog','@web/core/domain','@web/core/domain_selector/domain_selector','@web/core/network/rpc','@web/core/utils/hooks','@web/core/user'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component,useRef,useState}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{Domain}=require("@web/core/domain");const{DomainSelector}=require("@web/core/domain_selector/domain_selector");const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{user}=require("@web/core/user");const DomainSelectorDialog=__exports.DomainSelectorDialog=class DomainSelectorDialog extends Component{static template="web.DomainSelectorDialog";static components={Dialog,DomainSelector,};static props={close:Function,onConfirm:Function,resModel:String,className:{type:String,optional:true},defaultConnector:{type:[{value:"&"},{value:"|"}],optional:true},domain:String,isDebugMode:{type:Boolean,optional:true},readonly:{type:Boolean,optional:true},text:{type:String,optional:true},confirmButtonText:{type:String,optional:true},disableConfirmButton:{type:Function,optional:true},discardButtonText:{type:String,optional:true},title:{type:String,optional:true},context:{type:Object,optional:true},};static defaultProps={isDebugMode:false,readonly:false,context:{},};setup(){this.notification=useService("notification");this.orm=useService("orm");this.state=useState({domain:this.props.domain});this.confirmButtonRef=useRef("confirm");}
get confirmButtonText(){return this.props.confirmButtonText||_t("Confirm");}
get dialogTitle(){return this.props.title||_t("Domain");}
get disabled(){if(this.props.disableConfirmButton){return this.props.disableConfirmButton(this.state.domain);}
return false;}
get discardButtonText(){return this.props.discardButtonText||_t("Discard");}
get domainSelectorProps(){return{className:this.props.className,resModel:this.props.resModel,readonly:this.props.readonly,isDebugMode:this.props.isDebugMode,defaultConnector:this.props.defaultConnector,domain:this.state.domain,update:(domain)=>{this.state.domain=domain;},};}
async onConfirm(){this.confirmButtonRef.el.disabled=true;let domain;let isValid;try{const evalContext={...user.context,...this.props.context};domain=new Domain(this.state.domain).toList(evalContext);}catch{isValid=false;}
if(isValid===undefined){isValid=await rpc("/web/domain/validate",{model:this.props.resModel,domain,});}
if(!isValid){if(this.confirmButtonRef.el){this.confirmButtonRef.el.disabled=false;}
this.notification.add(_t("Domain is invalid. Please correct it"),{type:"danger",});return;}
this.props.onConfirm(this.state.domain);this.props.close();}
onDiscard(){this.props.close();}}
return __exports;});;

/* /web/static/src/core/dropdown/_behaviours/dropdown_group_hook.js */
odoo.define('@web/core/dropdown/_behaviours/dropdown_group_hook',['@odoo/owl','@web/core/dropdown/dropdown_group'],function(require){'use strict';let __exports={};const{useComponent,useEffect,useEnv}=require("@odoo/owl");const{DROPDOWN_GROUP}=require("@web/core/dropdown/dropdown_group");__exports.useDropdownGroup=useDropdownGroup;function useDropdownGroup(){const env=useEnv();const group={isInGroup:DROPDOWN_GROUP in env,get isOpen(){return this.isInGroup&&[...env[DROPDOWN_GROUP]].some((dropdown)=>dropdown.isOpen);},};if(group.isInGroup){const dropdown=useComponent();useEffect(()=>{env[DROPDOWN_GROUP].add(dropdown.state);return()=>env[DROPDOWN_GROUP].delete(dropdown.state);});}
return group;}
return __exports;});;

/* /web/static/src/core/dropdown/_behaviours/dropdown_nesting.js */
odoo.define('@web/core/dropdown/_behaviours/dropdown_nesting',['@odoo/owl','@web/core/l10n/localization','@web/core/utils/hooks','@web/core/utils/reactive'],function(require){'use strict';let __exports={};const{EventBus,onWillDestroy,useChildSubEnv,useEffect,useEnv}=require("@odoo/owl");const{localization}=require("@web/core/l10n/localization");const{useBus,useService}=require("@web/core/utils/hooks");const{effect}=require("@web/core/utils/reactive");const DROPDOWN_NESTING=__exports.DROPDOWN_NESTING=Symbol("dropdownNesting");const BUS=new EventBus();class DropdownNestingState{constructor({parent,close}){this._isOpen=false;this.parent=parent;this.children=new Set();this.close=close;parent?.children.add(this);}
set isOpen(value){this._isOpen=value;if(this._isOpen){BUS.trigger("dropdown-opened",this);}}
get isOpen(){return this._isOpen;}
remove(){this.parent?.children.delete(this);}
closeAllParents(){this.close();if(this.parent){this.parent.closeAllParents();}}
closeChildren(){this.children.forEach((child)=>child.close());}
shouldIgnoreChanges(other){return(other===this||other.activeEl!==this.activeEl||[...this.children].some((child)=>child.shouldIgnoreChanges(other)));}
handleChange(other){if(this.shouldIgnoreChanges(other)){return;}
if(other.isOpen&&this.isOpen){this.close();}}}
__exports.useDropdownNesting=useDropdownNesting;function useDropdownNesting(state){const env=useEnv();const current=new DropdownNestingState({parent:env[DROPDOWN_NESTING],close:()=>state.close(),});const uiService=useService("ui");useEffect(()=>{Promise.resolve().then(()=>{current.activeEl=uiService.activeElement;});},()=>[]);useChildSubEnv({[DROPDOWN_NESTING]:current});useBus(BUS,"dropdown-opened",({detail:other})=>current.handleChange(other));effect((state)=>{current.isOpen=state.isOpen;},[state]);onWillDestroy(()=>{current.remove();});return{get hasParent(){return Boolean(current.parent);},navigationOptions:{onEnabled:(items)=>{if(current.parent){items[0]?.focus();}},onMouseEnter:(item)=>{if(item.target.classList.contains("o-dropdown")){item.select();}},hotkeys:{escape:()=>current.close(),arrowleft:(index,items)=>{if(localization.direction==="rtl"&&items[index]?.target.classList.contains("o-dropdown")){items[index]?.select();}else if(current.parent){current.close();}},arrowright:(index,items)=>{if(localization.direction==="rtl"&&current.parent){current.close();}else if(items[index]?.target.classList.contains("o-dropdown")){items[index]?.select();}},},},};}
return __exports;});;

/* /web/static/src/core/dropdown/_behaviours/dropdown_popover.js */
odoo.define('@web/core/dropdown/_behaviours/dropdown_popover',['@odoo/owl','@web/core/dropdown/dropdown_item'],function(require){'use strict';let __exports={};const{Component,onMounted,onRendered,onWillDestroy,onWillStart,xml}=require("@odoo/owl");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const DropdownPopover=__exports.DropdownPopover=class DropdownPopover extends Component{static components={DropdownItem};static template=xml`
        <t t-if="this.props.items">
            <t t-foreach="this.props.items" t-as="item" t-key="this.getKey(item, item_index)">
                <DropdownItem class="item.class" onSelected="() => item.onSelected()" t-out="item.label"/>
            </t>
        </t>
        <t t-slot="content" />
    `;static props={close:{type:Function,optional:true},beforeOpen:{type:Function,optional:true},onOpened:{type:Function,optional:true},onClosed:{type:Function,optional:true},refresher:Object,slots:Object,items:{type:Array,optional:true},};setup(){onRendered(()=>{this.props.refresher.token;});onWillStart(async()=>{await this.props.beforeOpen?.();});onMounted(()=>{this.props.onOpened?.();});onWillDestroy(()=>{this.props.onClosed?.();});}
getKey(item,index){return"id"in item?item.id:index;}}
return __exports;});;

/* /web/static/src/core/dropdown/accordion_item.js */
odoo.define('@web/core/dropdown/accordion_item',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,onPatched,useState}=require("@odoo/owl");const ACCORDION=__exports.ACCORDION=Symbol("Accordion");const AccordionItem=__exports.AccordionItem=class AccordionItem extends Component{static template="web.AccordionItem";static components={};static props={slots:{type:Object,shape:{default:{},},},description:String,selected:{type:Boolean,optional:true,},class:{type:String,optional:true,},};static defaultProps={class:"",selected:false,};setup(){this.state=useState({open:false,});this.parentComponent=this.env[ACCORDION];onPatched(()=>{this.parentComponent?.accordionStateChanged?.();});}}
return __exports;});;

/* /web/static/src/core/dropdown/checkbox_item.js */
odoo.define('@web/core/dropdown/checkbox_item',['@web/core/dropdown/dropdown_item'],function(require){'use strict';let __exports={};const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const CheckboxItem=__exports.CheckboxItem=class CheckboxItem extends DropdownItem{static template="web.CheckboxItem";static props={...DropdownItem.props,checked:{type:Boolean,optional:false,},};}
return __exports;});;

/* /web/static/src/core/dropdown/dropdown.js */
odoo.define('@web/core/dropdown/dropdown',['@odoo/owl','@web/core/dropdown/_behaviours/dropdown_group_hook','@web/core/dropdown/_behaviours/dropdown_nesting','@web/core/dropdown/_behaviours/dropdown_popover','@web/core/dropdown/dropdown_hooks','@web/core/navigation/navigation','@web/core/popover/popover_hook','@web/core/utils/classname','@web/core/utils/hooks','@web/core/utils/objects','@web/core/utils/reactive'],function(require){'use strict';let __exports={};const{Component,onMounted,onRendered,onWillUpdateProps,reactive,status,useEffect,xml,}=require("@odoo/owl");const{useDropdownGroup}=require("@web/core/dropdown/_behaviours/dropdown_group_hook");const{useDropdownNesting}=require("@web/core/dropdown/_behaviours/dropdown_nesting");const{DropdownPopover}=require("@web/core/dropdown/_behaviours/dropdown_popover");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const{useNavigation}=require("@web/core/navigation/navigation");const{usePopover}=require("@web/core/popover/popover_hook");const{mergeClasses}=require("@web/core/utils/classname");const{useChildRef,useService}=require("@web/core/utils/hooks");const{deepMerge}=require("@web/core/utils/objects");const{effect}=require("@web/core/utils/reactive");function getFirstElementOfNode(node){if(!node){return null;}
if(node.el){return node.el.nodeType===Node.ELEMENT_NODE?node.el:null;}
if(node.bdom||node.child){return getFirstElementOfNode(node.bdom||node.child);}
if(node.children){for(const child of node.children){const el=getFirstElementOfNode(child);if(el){return el;}}}
return null;}
const Dropdown=__exports.Dropdown=class Dropdown extends Component{static template=xml`<t t-slot="default"/>`;static components={};static props={arrow:{optional:true},menuClass:{optional:true},position:{type:String,optional:true},slots:{type:Object,shape:{default:{optional:true},content:{optional:true},},},items:{optional:true,type:Array,elements:{type:Object,shape:{label:String,onSelected:Function,class:{optional:true},"*":true,},},},menuRef:{type:Function,optional:true},disabled:{type:Boolean,optional:true},holdOnHover:{type:Boolean,optional:true},beforeOpen:{type:Function,optional:true},onOpened:{type:Function,optional:true},onStateChanged:{type:Function,optional:true},state:{type:Object,shape:{isOpen:Boolean,close:Function,open:Function,"*":true,},optional:true,},manual:{type:Boolean,optional:true},navigationOptions:{type:Object,optional:true},};static defaultProps={arrow:false,disabled:false,holdOnHover:false,menuClass:"",state:undefined,navigationOptions:{},};setup(){this.menuRef=this.props.menuRef||useChildRef();this.state=this.props.state||useDropdownState();this.nesting=useDropdownNesting(this.state);this.group=useDropdownGroup();this.navigation=useNavigation(this.menuRef,{focusInitialElementOnDisabled:()=>!this.group.isInGroup,itemsSelector:":scope .o-navigable, :scope .o-dropdown",...deepMerge(this.nesting.navigationOptions,this.props.navigationOptions),});let activeEl;this.uiService=useService("ui");useEffect(()=>{Promise.resolve().then(()=>{activeEl=this.uiService.activeElement;});},()=>[]);this.popover=usePopover(DropdownPopover,{animation:false,arrow:this.props.arrow,closeOnClickAway:(target)=>{return this.popoverCloseOnClickAway(target,activeEl);},closeOnEscape:false,env:this.__owl__.childEnv,holdOnHover:this.props.holdOnHover,onClose:()=>this.state.close(),onPositioned:(el,{direction})=>this.setTargetDirectionClass(direction),popoverClass:mergeClasses("o-dropdown--menu dropdown-menu mx-0",{"o-dropdown--menu-submenu":this.hasParent},this.props.menuClass),popoverRole:"menu",position:this.position,ref:this.menuRef,setActiveElement:false,});onRendered(()=>(this.popoverRefresher?this.popoverRefresher.token++:null));onMounted(()=>this.onStateChanged(this.state));effect((state)=>this.onStateChanged(state),[this.state]);useEffect((target)=>this.setTargetElement(target),()=>[this.target]);onWillUpdateProps(({disabled})=>{if(disabled){this.closePopover();}});}
get position(){return this.props.position||(this.hasParent?"right-start":"bottom-start");}
get hasParent(){return this.nesting.hasParent;}
get target(){const target=getFirstElementOfNode(this.__owl__.bdom);if(!target){throw new Error("Could not find a valid dropdown toggler, prefer a single html element and put any dynamic content inside of it.");}
return target;}
handleClick(event){if(this.props.disabled){return;}
event.stopPropagation();if(this.state.isOpen&&!this.hasParent){this.state.close();}else{this.state.open();}}
handleMouseEnter(){if(this.props.disabled){return;}
if(this.hasParent||this.group.isOpen){this.target.focus();this.state.open();}}
onStateChanged(state){if(state.isOpen){this.openPopover();}else{this.closePopover();}}
popoverCloseOnClickAway(target,activeEl){const rootNode=target.getRootNode();if(rootNode instanceof ShadowRoot){target=rootNode.host;}
return this.uiService.getActiveElementOf(target)===activeEl;}
setTargetElement(target){if(!target){return;}
target.ariaExpanded=false;target.classList.add("o-dropdown");if(this.hasParent){target.classList.add("o-dropdown--has-parent");}
const tagName=target.tagName.toLowerCase();if(!["input","textarea","table","thead","tbody","tr","th","td"].includes(tagName)){target.classList.add("dropdown-toggle");if(this.hasParent){target.classList.add("o-dropdown-item","o-navigable","dropdown-item");if(!target.classList.contains("o-dropdown--no-caret")){target.classList.add("o-dropdown-caret");}}}
this.defaultDirection=this.position.split("-")[0];this.setTargetDirectionClass(this.defaultDirection);if(!this.props.manual){target.addEventListener("click",this.handleClick.bind(this));target.addEventListener("mouseenter",this.handleMouseEnter.bind(this));return()=>{target.removeEventListener("click",this.handleClick.bind(this));target.removeEventListener("mouseenter",this.handleMouseEnter.bind(this));};}}
setTargetDirectionClass(direction){if(!this.target){return;}
const directionClasses={bottom:"dropdown",top:"dropup",left:"dropstart",right:"dropend",};this.target.classList.remove(...Object.values(directionClasses));this.target.classList.add(directionClasses[direction]);}
openPopover(){if(this.popover.isOpen||status(this)!=="mounted"){return;}
if(!this.target||!this.target.isConnected){this.state.close();return;}
this.popoverRefresher=reactive({token:0});const props={beforeOpen:()=>this.props.beforeOpen?.(),onOpened:()=>this.onOpened(),onClosed:()=>this.onClosed(),refresher:this.popoverRefresher,items:this.props.items,slots:this.props.slots,};this.popover.open(this.target,props);}
closePopover(){this.popover.close();this.navigation.disable();}
onOpened(){this.navigation.enable();this.props.onOpened?.();this.props.onStateChanged?.(true);if(this.target){this.target.ariaExpanded=true;this.target.classList.add("show");}}
onClosed(){this.props.onStateChanged?.(false);if(this.target){this.target.ariaExpanded=false;this.target.classList.remove("show");this.setTargetDirectionClass(this.defaultDirection);}}}
return __exports;});;

/* /web/static/src/core/dropdown/dropdown_group.js */
odoo.define('@web/core/dropdown/dropdown_group',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,onWillDestroy,useChildSubEnv,xml}=require("@odoo/owl");const GROUPS=new Map();function getGroup(id){if(!GROUPS.has(id)){GROUPS.set(id,{group:new Set(),count:0,});}
GROUPS.get(id).count++;return GROUPS.get(id).group;}
function removeGroup(id){const groupData=GROUPS.get(id);groupData.count--;if(groupData.count<=0){GROUPS.delete(id);}}
const DROPDOWN_GROUP=__exports.DROPDOWN_GROUP=Symbol("dropdownGroup");const DropdownGroup=__exports.DropdownGroup=class DropdownGroup extends Component{static template=xml`<t t-slot="default"/>`;static props={group:{type:String,optional:true},slots:Object,};setup(){if(this.props.group){const group=getGroup(this.props.group);onWillDestroy(()=>removeGroup(this.props.group));useChildSubEnv({[DROPDOWN_GROUP]:group});}else{useChildSubEnv({[DROPDOWN_GROUP]:new Set()});}}}
return __exports;});;

/* /web/static/src/core/dropdown/dropdown_hooks.js */
odoo.define('@web/core/dropdown/dropdown_hooks',['@odoo/owl','@web/core/dropdown/_behaviours/dropdown_nesting'],function(require){'use strict';let __exports={};const{useEnv,useState}=require("@odoo/owl");const{DROPDOWN_NESTING}=require("@web/core/dropdown/_behaviours/dropdown_nesting");__exports.useDropdownState=useDropdownState;function useDropdownState({onOpen,onClose}={}){const state=useState({isOpen:false,open:()=>{state.isOpen=true;onOpen?.();},close:()=>{state.isOpen=false;onClose?.();},});return state;}
__exports.useDropdownCloser=useDropdownCloser;function useDropdownCloser(){const env=useEnv();const dropdown=env[DROPDOWN_NESTING];return{close:()=>dropdown?.close(),closeChildren:()=>dropdown?.closeChildren(),closeAll:()=>dropdown?.closeAllParents(),};}
return __exports;});;

/* /web/static/src/core/dropdown/dropdown_item.js */
odoo.define('@web/core/dropdown/dropdown_item',['@odoo/owl','@web/core/dropdown/dropdown_hooks'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{useDropdownCloser}=require("@web/core/dropdown/dropdown_hooks");const ClosingMode={None:"none",ClosestParent:"closest",AllParents:"all",};const DropdownItem=__exports.DropdownItem=class DropdownItem extends Component{static template="web.DropdownItem";static props={class:{type:[String,Object],optional:true,},onSelected:{type:Function,optional:true,},closingMode:{type:ClosingMode,optional:true,},attrs:{type:Object,optional:true,},slots:{Object,optional:true},};static defaultProps={closingMode:ClosingMode.AllParents,attrs:{},};setup(){this.dropdownControl=useDropdownCloser();}
onClick(ev){if(this.props.attrs&&this.props.attrs.href){ev.preventDefault();}
this.props.onSelected?.();switch(this.props.closingMode){case ClosingMode.ClosestParent:this.dropdownControl.close();break;case ClosingMode.AllParents:this.dropdownControl.closeAll();break;}}}
return __exports;});;

/* /web/static/src/core/dropzone/dropzone.js */
odoo.define('@web/core/dropzone/dropzone',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,useEffect,useRef,useState}=require("@odoo/owl");const Dropzone=__exports.Dropzone=class Dropzone extends Component{static props={extraClass:{type:String,optional:true},onDrop:{type:Function,optional:true},ref:Object,slots:{type:Object,optional:true},};static template="web.Dropzone";setup(){super.setup();this.root=useRef("root");this.state=useState({isDraggingInside:false,});useEffect(()=>{const{top,left,width,height}=this.props.ref.el.getBoundingClientRect();this.root.el.style=`top:${top}px;left:${left}px;width:${width}px;height:${height}px;`;});}}
return __exports;});;

/* /web/static/src/core/dropzone/dropzone_hook.js */
odoo.define('@web/core/dropzone/dropzone_hook',['@web/core/dropzone/dropzone','@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Dropzone}=require("@web/core/dropzone/dropzone");const{useEffect,useExternalListener}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");__exports.useCustomDropzone=useCustomDropzone;function useCustomDropzone(targetRef,dropzoneComponent,dropzoneComponentProps,isDropzoneEnabled=()=>true){const overlayService=useService("overlay");const uiService=useService("ui");let dragCount=0;let hasTarget=false;let removeDropzone=false;useExternalListener(document,"dragenter",onDragEnter,{capture:true});useExternalListener(document,"dragleave",onDragLeave,{capture:true});useExternalListener(window,"dragover",(ev)=>{if(ev.dataTransfer&&ev.dataTransfer.types.includes("Files")){ev.preventDefault();}});useExternalListener(window,"drop",(ev)=>{if(ev.dataTransfer&&ev.dataTransfer.types.includes("Files")){ev.preventDefault();}
dragCount=0;updateDropzone();},{capture:true});function updateDropzone(){const hasDropzone=!!removeDropzone;const isTargetInActiveElement=uiService.activeElement.contains(targetRef.el);const shouldDisplayDropzone=dragCount&&hasTarget&&isTargetInActiveElement&&isDropzoneEnabled();if(shouldDisplayDropzone&&!hasDropzone){removeDropzone=overlayService.add(dropzoneComponent,{ref:targetRef,...dropzoneComponentProps});}
if(!shouldDisplayDropzone&&hasDropzone){removeDropzone();removeDropzone=false;}}
function onDragEnter(ev){if(dragCount||(ev.dataTransfer&&ev.dataTransfer.types.includes("Files"))){dragCount++;updateDropzone();}}
function onDragLeave(){if(dragCount){dragCount--;updateDropzone();}}
useEffect((el)=>{hasTarget=!!el;updateDropzone();},()=>[targetRef.el]);}
__exports.useDropzone=useDropzone;function useDropzone(targetRef,onDrop,extraClass,isDropzoneEnabled=()=>true){const dropzoneComponent=Dropzone;const dropzoneComponentProps={extraClass,onDrop};useCustomDropzone(targetRef,dropzoneComponent,dropzoneComponentProps,isDropzoneEnabled);}
return __exports;});;

/* /web/static/src/core/effects/effect_service.js */
odoo.define('@web/core/effects/effect_service',['@web/core/l10n/translation','@web/core/registry','@web/core/user','@web/core/effects/rainbow_man'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{RainbowMan}=require("@web/core/effects/rainbow_man");const effectRegistry=registry.category("effects");function rainbowMan(env,params={}){let message=params.message;if(message instanceof Element){console.log("Providing an HTML element to an effect is deprecated. Note that all event handlers will be lost.");message=message.outerHTML;}else if(!message){message=_t("Well Done!");}
if(user.showEffect){const props={imgUrl:params.img_url||"/web/static/img/smile.svg",fadeout:params.fadeout||"medium",message,Component:params.Component,props:params.props,};return{Component:RainbowMan,props};}
env.services.notification.add(message);}
effectRegistry.add("rainbow_man",rainbowMan);const effectService=__exports.effectService={dependencies:["overlay"],start(env,{overlay}){const add=(params={})=>{const type=params.type||"rainbow_man";const effect=effectRegistry.get(type);const{Component,props}=effect(env,params)||{};if(Component){const remove=overlay.add(Component,{...props,close:()=>remove(),});}};return{add};},};registry.category("services").add("effect",effectService);return __exports;});;

/* /web/static/src/core/effects/rainbow_man.js */
odoo.define('@web/core/effects/rainbow_man',['@web/core/browser/browser','@odoo/owl'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{Component,useEffect,useExternalListener,useState}=require("@odoo/owl");const RainbowMan=__exports.RainbowMan=class RainbowMan extends Component{static template="web.RainbowMan";static rainbowFadeouts={slow:4500,medium:3500,fast:2000,no:false};static props={fadeout:String,close:Function,message:String,imgUrl:String,Component:{type:Function,optional:true},props:{type:Object,optional:true},};setup(){useExternalListener(document.body,"click",this.closeRainbowMan);this.state=useState({isFading:false});this.delay=RainbowMan.rainbowFadeouts[this.props.fadeout];if(this.delay){useEffect(()=>{const timeout=browser.setTimeout(()=>{this.state.isFading=true;},this.delay);return()=>browser.clearTimeout(timeout);},()=>[]);}}
onAnimationEnd(ev){if(this.delay&&ev.animationName==="reward-fading-reverse"){ev.stopPropagation();this.closeRainbowMan();}}
closeRainbowMan(){this.props.close();}}
return __exports;});;

/* /web/static/src/core/emoji_picker/emoji_picker.js */
odoo.define('@web/core/emoji_picker/emoji_picker',['@web/core/utils/misc','@odoo/owl','@web/core/assets','@web/core/browser/browser','@web/core/l10n/translation','@web/core/popover/popover_hook','@web/core/utils/search','@web/core/utils/hooks','@web/core/browser/feature_detection'],function(require){'use strict';let __exports={};const{markEventHandled}=require("@web/core/utils/misc");const{Component,onMounted,onPatched,onWillDestroy,onWillPatch,onWillStart,onWillUnmount,useEffect,useRef,useState,}=require("@odoo/owl");const{loadBundle}=require("@web/core/assets");const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const{usePopover}=require("@web/core/popover/popover_hook");const{fuzzyLookup}=require("@web/core/utils/search");const{useAutofocus,useService}=require("@web/core/utils/hooks");const{isMobileOS}=require("@web/core/browser/feature_detection");__exports.useEmojiPicker=useEmojiPicker;function useEmojiPicker(ref,props,options={}){const targets=[];const state=useState({isOpen:false});const newOptions={...options,onClose:()=>{state.isOpen=false;options.onClose?.();},};const popover=usePopover(EmojiPicker,{...newOptions,animation:false,popoverClass:"border-secondary",});props.storeScroll={scrollValue:0,set:(value)=>{props.storeScroll.scrollValue=value;},get:()=>{return props.storeScroll.scrollValue;},};function add(ref,onSelect,{show=false}={}){const toggler=()=>toggle(ref,onSelect);targets.push([ref,toggler]);if(!ref.el){return;}
ref.el.addEventListener("click",toggler);ref.el.addEventListener("mouseenter",loadEmoji);if(show){ref.el.click();}}
function toggle(ref,onSelect=props.onSelect){if(popover.isOpen){popover.close();}else{state.isOpen=true;popover.open(ref.el,{...props,onSelect});}}
if(ref){add(ref);}
onMounted(()=>{for(const[ref,toggle]of targets){if(!ref.el){continue;}
ref.el.addEventListener("click",toggle);ref.el.addEventListener("mouseenter",loadEmoji);}});onWillPatch(()=>{for(const[ref,toggle]of targets){if(!ref.el){continue;}
ref.el.removeEventListener("click",toggle);ref.el.removeEventListener("mouseenter",loadEmoji);}});onPatched(()=>{for(const[ref,toggle]of targets){if(!ref.el){continue;}
ref.el.addEventListener("click",toggle);ref.el.addEventListener("mouseenter",loadEmoji);}});Object.assign(state,{add});return state;}
const loadingListeners=[];const loader=__exports.loader={loadEmoji:()=>loadBundle("web.assets_emoji"),loaded:undefined,onEmojiLoaded(cb){loadingListeners.push(cb);},};__exports.loadEmoji=loadEmoji;async function loadEmoji(){const res={categories:[],emojis:[]};try{await loader.loadEmoji();const{getCategories,getEmojis}=odoo.loader.modules.get("@web/core/emoji_picker/emoji_data");res.categories=getCategories();res.emojis=getEmojis();return res;}catch{return res;}finally{if(!loader.loaded){loader.loaded={emojiValueToShortcode:{}};for(const emoji of res.emojis){const value=emoji.codepoints;const shortcode=emoji.shortcodes[0];loader.loaded.emojiValueToShortcode[value]=shortcode;for(const listener of loadingListeners){listener();}
loadingListeners.length=0;}}}}
const EMOJI_PICKER_PROPS=__exports.EMOJI_PICKER_PROPS=["close?","onClose?","onSelect","state?","storeScroll?"];const EmojiPicker=__exports.EmojiPicker=class EmojiPicker extends Component{static props=EMOJI_PICKER_PROPS;static template="web.EmojiPicker";categories=null;emojis=null;shouldScrollElem=null;lastSearchTerm;keyboardNavigated=false;setup(){this.gridRef=useRef("emoji-grid");this.navbarRef=useRef("navbar");this.ui=useState(useService("ui"));this.isMobileOS=isMobileOS();this.state=useState({activeEmojiIndex:0,categoryId:null,recent:JSON.parse(browser.localStorage.getItem("web.emoji.frequent")||"{}"),searchTerm:"",});const onStorage=(ev)=>{if(ev.key==="web.emoji.frequent"){this.state.recent=ev.newValue?JSON.parse(ev.newValue):{};}else if(ev.key===null){this.state.recent={};}};browser.addEventListener("storage",onStorage);onWillDestroy(()=>{browser.removeEventListener("storage",onStorage);});useAutofocus();onWillStart(async()=>{const{categories,emojis}=await loadEmoji();this.categories=categories;this.emojis=emojis;this.emojiByCodepoints=Object.fromEntries(this.emojis.map((emoji)=>[emoji.codepoints,emoji]));this.recentCategory={name:"Frequently used",displayName:_t("Frequently used"),title:"🕓",sortId:0,};this.state.categoryId=this.recentEmojis.length?this.recentCategory.sortId:this.categories[0].sortId;});onMounted(()=>{this.navbarResizeObserver=new ResizeObserver(()=>this.adaptNavbar());this.navbarResizeObserver.observe(this.navbarRef.el);this.adaptNavbar();if(this.emojis.length===0){return;}
this.highlightActiveCategory();if(this.props.storeScroll){this.gridRef.el.scrollTop=this.props.storeScroll.get();}});onPatched(()=>{if(this.emojis.length===0){return;}
if(this.shouldScrollElem){this.shouldScrollElem=false;const getElement=()=>this.gridRef.el.querySelector(`.o-EmojiPicker-category[data-category="${this.state.categoryId}"`);const elem=getElement();if(elem){elem.scrollIntoView();}else{this.shouldScrollElem=getElement;}}});useEffect(()=>this.updateEmojiPickerRepr(),()=>[this.state.categoryId,this.state.searchTerm]);useEffect((el)=>{const gridEl=this.gridRef?.el;const activeEl=gridEl?.querySelector(".o-Emoji.o-active");if(gridEl&&activeEl&&this.keyboardNavigated&&!isElementVisible(activeEl,gridEl)){activeEl.scrollIntoView({block:"center",behavior:"instant"});this.keyboardNavigated=false;}},()=>[this.state.activeEmojiIndex,this.gridRef?.el]);useEffect(()=>{if(this.searchTerm){this.gridRef.el.scrollTop=0;this.state.categoryId=null;}else{if(this.lastSearchTerm){this.gridRef.el.scrollTop=0;}
this.highlightActiveCategory();}
this.lastSearchTerm=this.searchTerm;},()=>[this.searchTerm]);onWillUnmount(()=>{this.navbarResizeObserver.disconnect();if(!this.gridRef.el){return;}
if(this.props.storeScroll){this.props.storeScroll.set(this.gridRef.el.scrollTop);}});}
adaptNavbar(){const computedStyle=getComputedStyle(this.navbarRef.el);const availableWidth=this.navbarRef.el.getBoundingClientRect().width-
parseInt(computedStyle.paddingLeft)-
parseInt(computedStyle.marginLeft)-
parseInt(computedStyle.paddingLeft)-
parseInt(computedStyle.marginLeft);const itemWidth=this.navbarRef.el.querySelector(".o-Emoji").getBoundingClientRect().width;const gapWidth=parseInt(computedStyle.gap);const maxAvailableNavbarItemAmountAtOnce=Math.floor(availableWidth/(itemWidth+gapWidth));const repr=[];let panel=[];const allCategories=this.getAllCategories();for(const category of allCategories){if(panel.length===maxAvailableNavbarItemAmountAtOnce-1&&category!==allCategories.at(-1)){panel.push("next");repr.push(panel);panel=[];panel.push("previous");}
panel.push(category.sortId);}
if(panel.length>0){if(repr.length>0){panel.push(...[...Array(maxAvailableNavbarItemAmountAtOnce-panel.length)].map((_,idx)=>"empty_"+idx));}
repr.push(panel);}
this.state.emojiNavbarRepr=repr;}
get currentNavbarPanel(){if(!this.state.emojiNavbarRepr){return this.getAllCategories().map((c)=>c.sortId);}
if(this.state.categoryId===null||Number.isNaN(this.state.categoryId)){return this.state.emojiNavbarRepr[0];}
return this.state.emojiNavbarRepr.find((panel)=>panel.includes(this.state.categoryId));}
get searchTerm(){return this.props.state?this.props.state.searchTerm:this.state.searchTerm;}
set searchTerm(value){if(this.props.state){this.props.state.searchTerm=value;}else{this.state.searchTerm=value;}}
get itemsNumber(){return this.recentEmojis.length+this.getEmojis().length;}
get recentEmojis(){const recent=Object.entries(this.state.recent).sort(([,usage_1],[,usage_2])=>usage_2-usage_1).map(([codepoints])=>this.emojiByCodepoints[codepoints]);if(this.searchTerm&&recent.length>0){return fuzzyLookup(this.searchTerm,recent,(emoji)=>[emoji.name,...emoji.keywords,...emoji.emoticons,...emoji.shortcodes,]);}
return recent.slice(0,42);}
onClick(ev){markEventHandled(ev,"emoji.selectEmoji");}
onClickToNextCategories(){const panelIndex=this.state.emojiNavbarRepr.findIndex((p)=>p.includes(this.state.categoryId));this.selectCategory(this.state.emojiNavbarRepr[panelIndex+1][1]);}
onClickToPreviousCategories(){const panelIndex=this.state.emojiNavbarRepr.findIndex((p)=>p.includes(this.state.categoryId));this.selectCategory(this.state.emojiNavbarRepr[panelIndex-1].at(-2));}
updateEmojiPickerRepr(){const emojiEls=Array.from(this.gridRef.el.querySelectorAll(".o-Emoji"));const emojiRects=emojiEls.map((el)=>el.getBoundingClientRect());this.emojiMatrix=[];for(const[index,pos]of emojiRects.entries()){const emojiIndex=emojiEls[index].dataset.index;if(this.emojiMatrix.length===0||pos.top>emojiRects[index-1].top){this.emojiMatrix.push([]);}
this.emojiMatrix.at(-1).push(parseInt(emojiIndex));}}
handleNavigation(key){const currentIdx=this.state.activeEmojiIndex;let currentRow=-1;let currentCol=-1;const rowIdx=this.emojiMatrix.findIndex((row)=>row.includes(currentIdx));if(rowIdx!==-1){currentRow=rowIdx;currentCol=this.emojiMatrix[currentRow].indexOf(currentIdx);}
let newIdx;switch(key){case"ArrowDown":{const rowBelow=this.emojiMatrix[currentRow+1];const rowBelowBelow=this.emojiMatrix[currentRow+2];if(rowBelow?.length<=currentCol&&rowBelowBelow?.length>=currentCol){newIdx=rowBelowBelow?.[currentCol];}else{newIdx=rowBelow?.[Math.min(currentCol,rowBelow.length-1)];}
break;}
case"ArrowUp":{const rowAbove=this.emojiMatrix[currentRow-1];const rowAboveAbove=this.emojiMatrix[currentRow-2];if(rowAbove?.length<=currentCol&&rowAboveAbove?.length>=currentCol){newIdx=rowAboveAbove?.[currentCol];}else{newIdx=rowAbove?.[Math.min(currentCol,rowAbove.length-1)];}
break;}
case"ArrowRight":{const colRight=currentCol+1;if(colRight===this.emojiMatrix[currentRow].length){const rowBelowRight=this.emojiMatrix[currentRow+1];newIdx=rowBelowRight?.[0];}else{newIdx=this.emojiMatrix[currentRow][colRight];}
break;}
case"ArrowLeft":{const colLeft=currentCol-1;if(colLeft<0){const rowAboveLeft=this.emojiMatrix[currentRow-1];newIdx=rowAboveLeft?.[rowAboveLeft.length-1]??this.state.activeEmojiIndex;}else{newIdx=this.emojiMatrix[currentRow][colLeft];}
break;}}
this.state.activeEmojiIndex=newIdx??this.state.activeEmojiIndex;}
onKeydown(ev){switch(ev.key){case"ArrowDown":case"ArrowUp":case"ArrowRight":case"ArrowLeft":this.handleNavigation(ev.key);this.keyboardNavigated=true;break;case"Enter":ev.preventDefault();this.gridRef.el.querySelector(`.o-EmojiPicker-content .o-Emoji[data-index="${this.state.activeEmojiIndex}"]`)?.click();break;case"Escape":this.props.close?.();this.props.onClose?.();ev.stopPropagation();}}
getAllCategories(){const res=[...this.categories];if(this.recentEmojis.length>0){res.unshift(this.recentCategory);}
return res;}
getEmojis(){let emojisToDisplay=[...this.emojis];const recentEmojis=this.recentEmojis;if(recentEmojis.length>0&&this.searchTerm){emojisToDisplay=emojisToDisplay.filter((emoji)=>!recentEmojis.includes(emoji));}
if(this.searchTerm.length>0){return fuzzyLookup(this.searchTerm,emojisToDisplay,(emoji)=>[emoji.name,...emoji.keywords,...emoji.emoticons,...emoji.shortcodes,]);}
return emojisToDisplay;}
getEmojisFromSearch(){return[...this.recentEmojis,...this.getEmojis()];}
selectCategory(categoryId){this.searchTerm="";this.state.categoryId=categoryId;this.shouldScrollElem=true;}
selectEmoji(ev){const codepoints=ev.currentTarget.dataset.codepoints;const resetOnSelect=!ev.shiftKey&&!this.ui.isSmall;this.props.onSelect(codepoints,resetOnSelect);this.state.recent[codepoints]??=0;this.state.recent[codepoints]++;browser.localStorage.setItem("web.emoji.frequent",JSON.stringify(this.state.recent));if(resetOnSelect){this.gridRef.el.scrollTop=0;this.props.close?.();this.props.onClose?.();}}
highlightActiveCategory(){if(!this.gridRef||!this.gridRef.el){return;}
const coords=this.gridRef.el.getBoundingClientRect();const res=document.elementFromPoint(coords.x+10,coords.y+10);if(!res){return;}
this.state.categoryId=parseInt(res.dataset.category);}}
function isElementVisible(el,holder){const offset=20;holder=holder||document.body;const{top,bottom,height}=el.getBoundingClientRect();let{top:holderTop,bottom:holderBottom}=holder.getBoundingClientRect();holderTop+=offset*2;holderBottom-=offset;return top-offset<=holderTop?holderTop-top<=height:bottom-holderBottom<=height;}
return __exports;});;

/* /web/static/src/core/ensure_jquery.js */
odoo.define('@web/core/ensure_jquery',['@web/core/assets'],function(require){'use strict';let __exports={};const{loadBundle,loadJS}=require("@web/core/assets");__exports.ensureJQuery=ensureJQuery;async function ensureJQuery(){if(!window.jQuery){await loadBundle("web._assets_jquery");const BTS_CLASSES=["Carousel","Dropdown","Modal","Popover","Tooltip","Collapse"];const $=window.jQuery;for(const CLS of BTS_CLASSES){const plugin=window[CLS];if(plugin){const name=plugin.NAME;const JQUERY_NO_CONFLICT=$.fn[name];$.fn[name]=plugin.jQueryInterface;$.fn[name].Constructor=plugin;$.fn[name].noConflict=()=>{$.fn[name]=JQUERY_NO_CONFLICT;return plugin.jQueryInterface;};}}}else if(!window.jQuery.fn.getScrollingElement){await loadJS("/web/static/src/legacy/js/libs/jquery.js");}}
return __exports;});;

/* /web/static/src/core/errors/error_dialogs.js */
odoo.define('@web/core/errors/error_dialogs',['@web/core/browser/browser','@web/core/dialog/dialog','@web/core/l10n/translation','@web/core/registry','@web/core/tooltip/tooltip','@web/core/popover/popover_hook','@web/core/utils/hooks','@web/core/utils/strings','@odoo/owl'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{Dialog}=require("@web/core/dialog/dialog");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{Tooltip}=require("@web/core/tooltip/tooltip");const{usePopover}=require("@web/core/popover/popover_hook");const{useService}=require("@web/core/utils/hooks");const{capitalize}=require("@web/core/utils/strings");const{Component,useRef,useState,markup}=require("@odoo/owl");const{DateTime}=luxon;const standardErrorDialogProps=__exports.standardErrorDialogProps={traceback:{type:[String,{value:null}],optional:true},message:{type:String,optional:true},name:{type:String,optional:true},exceptionName:{type:[String,{value:null}],optional:true},data:{type:[Object,{value:null}],optional:true},subType:{type:[String,{value:null}],optional:true},code:{type:[Number,String,{value:null}],optional:true},type:{type:[String,{value:null}],optional:true},serverHost:{type:[String,{value:null}],optional:true},id:{type:[Number,{value:null}],optional:true},model:{type:[String,{value:null}],optional:true},close:Function,};const odooExceptionTitleMap=__exports.odooExceptionTitleMap=new Map(Object.entries({"odoo.addons.base.models.ir_mail_server.MailDeliveryException":_t("MailDeliveryException"),"odoo.exceptions.AccessDenied":_t("Access Denied"),"odoo.exceptions.MissingError":_t("Missing Record"),"odoo.addons.web.controllers.action.MissingActionError":_t("Missing Action"),"odoo.exceptions.UserError":_t("Invalid Operation"),"odoo.exceptions.ValidationError":_t("Validation Error"),"odoo.exceptions.AccessError":_t("Access Error"),"odoo.exceptions.Warning":_t("Warning"),}));const ErrorDialog=__exports.ErrorDialog=class ErrorDialog extends Component{static template="web.ErrorDialog";static components={Dialog};static title=_t("Odoo Error");static showTracebackButtonText=_t("See technical details");static hideTracebackButtonText=_t("Hide technical details");static props={...standardErrorDialogProps};setup(){this.state=useState({showTraceback:false,});this.copyButtonRef=useRef("copyButton");this.popover=usePopover(Tooltip);this.contextDetails="Occured ";if(this.props.serverHost){this.contextDetails+=`on ${this.props.serverHost} `;}
if(this.props.model&&this.props.id){this.contextDetails+=`on model ${this.props.model} and id ${this.props.id} `;}
this.contextDetails+=`on ${DateTime.now()
            .setZone("UTC")
            .toFormat("yyyy-MM-dd HH:mm:ss")} GMT`;}
showTooltip(){this.popover.open(this.copyButtonRef.el,{tooltip:_t("Copied")});browser.setTimeout(this.popover.close,800);}
onClickClipboard(){browser.navigator.clipboard.writeText(`${this.props.name}\n\n${this.props.message}\n\n${this.contextDetails}\n\n${this.props.traceback}`);this.showTooltip();}}
const ClientErrorDialog=__exports.ClientErrorDialog=class ClientErrorDialog extends ErrorDialog{}
ClientErrorDialog.title=_t("Odoo Client Error");const NetworkErrorDialog=__exports.NetworkErrorDialog=class NetworkErrorDialog extends ErrorDialog{}
NetworkErrorDialog.title=_t("Odoo Network Error");const RPCErrorDialog=__exports.RPCErrorDialog=class RPCErrorDialog extends ErrorDialog{setup(){super.setup();this.inferTitle();this.traceback=this.props.traceback;if(this.props.data&&this.props.data.debug){this.traceback=`${this.props.data.debug}\nThe above server error caused the following client error:\n${this.traceback}`;}}
inferTitle(){if(this.props.exceptionName&&odooExceptionTitleMap.has(this.props.exceptionName)){this.title=odooExceptionTitleMap.get(this.props.exceptionName).toString();return;}
if(!this.props.type){return;}
switch(this.props.type){case"server":this.title=_t("Odoo Server Error");break;case"script":this.title=_t("Odoo Client Error");break;case"network":this.title=_t("Odoo Network Error");break;}}
onClickClipboard(){browser.navigator.clipboard.writeText(`${this.props.name}\n\n${this.props.message}\n\n${this.contextDetails}\n\n${this.traceback}`);this.showTooltip();}}
const WarningDialog=__exports.WarningDialog=class WarningDialog extends Component{static template="web.WarningDialog";static components={Dialog};static props={...standardErrorDialogProps,title:{type:String,optional:true},};setup(){this.title=this.inferTitle();const{data,message}=this.props;if(data&&data.arguments&&data.arguments.length>0){this.message=data.arguments[0];}else{this.message=message;}}
inferTitle(){if(this.props.exceptionName&&odooExceptionTitleMap.has(this.props.exceptionName)){return odooExceptionTitleMap.get(this.props.exceptionName).toString();}
return this.props.title||_t("Odoo Warning");}}
const RedirectWarningDialog=__exports.RedirectWarningDialog=class RedirectWarningDialog extends Component{static template="web.RedirectWarningDialog";static components={Dialog};static props={...standardErrorDialogProps};setup(){this.actionService=useService("action");const{data,subType}=this.props;const[message,actionId,buttonText,additionalContext]=data.arguments;this.title=capitalize(subType)||_t("Odoo Warning");this.message=message;this.actionId=actionId;this.buttonText=buttonText;this.additionalContext=additionalContext;}
async onClick(){const options={};if(this.additionalContext){options.additionalContext=this.additionalContext;}
if(this.actionId.help){this.actionId.help=markup(this.actionId.help);}
await this.actionService.doAction(this.actionId,options);this.props.close();}}
const Error504Dialog=__exports.Error504Dialog=class Error504Dialog extends Component{static template="web.Error504Dialog";static components={Dialog};static props={...standardErrorDialogProps};}
const SessionExpiredDialog=__exports.SessionExpiredDialog=class SessionExpiredDialog extends Component{static template="web.SessionExpiredDialog";static components={Dialog};static props={...standardErrorDialogProps};onClick(){browser.location.reload();}}
registry.category("error_dialogs").add("odoo.exceptions.AccessDenied",WarningDialog).add("odoo.exceptions.AccessError",WarningDialog).add("odoo.exceptions.MissingError",WarningDialog).add("odoo.addons.web.controllers.action.MissingActionError",WarningDialog).add("odoo.exceptions.UserError",WarningDialog).add("odoo.exceptions.ValidationError",WarningDialog).add("odoo.exceptions.RedirectWarning",RedirectWarningDialog).add("odoo.http.SessionExpiredException",SessionExpiredDialog).add("werkzeug.exceptions.Forbidden",SessionExpiredDialog).add("504",Error504Dialog);return __exports;});;

/* /web/static/src/core/errors/error_handlers.js */
odoo.define('@web/core/errors/error_handlers',['@web/core/l10n/translation','@web/core/browser/browser','@web/core/network/rpc','@web/core/registry','@web/session','@web/core/user','@web/core/errors/error_dialogs','@web/core/errors/error_service'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{ConnectionLostError,RPCError,rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{session}=require("@web/session");const{user}=require("@web/core/user");const{ClientErrorDialog,ErrorDialog,NetworkErrorDialog,RPCErrorDialog,}=require("@web/core/errors/error_dialogs");const{UncaughtClientError,ThirdPartyScriptError,UncaughtPromiseError}=require("@web/core/errors/error_service");const errorHandlerRegistry=registry.category("error_handlers");const errorDialogRegistry=registry.category("error_dialogs");const errorNotificationRegistry=registry.category("error_notifications");__exports.rpcErrorHandler=rpcErrorHandler;function rpcErrorHandler(env,error,originalError){if(!(error instanceof UncaughtPromiseError)){return false;}
if(originalError instanceof RPCError){error.unhandledRejectionEvent.preventDefault();const exceptionName=originalError.exceptionName;let ErrorComponent=originalError.Component;if(!ErrorComponent&&exceptionName){if(errorNotificationRegistry.contains(exceptionName)){const notif=errorNotificationRegistry.get(exceptionName);env.services.notification.add(notif.message||originalError.data.message,notif);return true;}
if(errorDialogRegistry.contains(exceptionName)){ErrorComponent=errorDialogRegistry.get(exceptionName);}}
if(!ErrorComponent&&originalError.data.context){const exceptionClass=originalError.data.context.exception_class;if(errorDialogRegistry.contains(exceptionClass)){ErrorComponent=errorDialogRegistry.get(exceptionClass);}}
env.services.dialog.add(ErrorComponent||RPCErrorDialog,{traceback:error.traceback,message:originalError.message,name:originalError.name,exceptionName:originalError.exceptionName,data:originalError.data,subType:originalError.subType,code:originalError.code,type:originalError.type,serverHost:error.event?.target?.location.host,id:originalError.id,model:originalError.model,});return true;}}
errorHandlerRegistry.add("rpcErrorHandler",rpcErrorHandler,{sequence:97});let connectionLostNotifRemove=null;__exports.lostConnectionHandler=lostConnectionHandler;function lostConnectionHandler(env,error,originalError){if(!(error instanceof UncaughtPromiseError)){return false;}
if(originalError instanceof ConnectionLostError){if(connectionLostNotifRemove){return true;}
connectionLostNotifRemove=env.services.notification.add(_t("Connection lost. Trying to reconnect..."),{sticky:true});let delay=2000;browser.setTimeout(function checkConnection(){rpc("/web/webclient/version_info",{}).then(function(){if(connectionLostNotifRemove){connectionLostNotifRemove();connectionLostNotifRemove=null;}
env.services.notification.add(_t("Connection restored. You are back online."),{type:"info",});}).catch(()=>{delay=delay*1.5+500*Math.random();browser.setTimeout(checkConnection,delay);});},delay);return true;}}
errorHandlerRegistry.add("lostConnectionHandler",lostConnectionHandler,{sequence:98});const defaultDialogs=new Map([[UncaughtClientError,ClientErrorDialog],[UncaughtPromiseError,ClientErrorDialog],[ThirdPartyScriptError,NetworkErrorDialog],]);__exports.defaultHandler=defaultHandler;function defaultHandler(env,error){const DialogComponent=defaultDialogs.get(error.constructor)||ErrorDialog;env.services.dialog.add(DialogComponent,{traceback:error.traceback,message:error.message,name:error.name,serverHost:error.event?.target?.location.host,});return true;}
errorHandlerRegistry.add("defaultHandler",defaultHandler,{sequence:100});__exports.swallowAllVisitorErrors=swallowAllVisitorErrors;function swallowAllVisitorErrors(env,error,originalError){if(!user.isInternalUser&&!odoo.debug&&!session.test_mode){return true;}}
if(user.isInternalUser===undefined){if(session.is_frontend){console.warn("isInternalUser information is required for this handler to work. It must be available in the page.");}}else{registry.category("error_handlers").add("swallowAllVisitorErrors",swallowAllVisitorErrors,{sequence:0});}
return __exports;});;

/* /web/static/src/core/errors/error_service.js */
odoo.define('@web/core/errors/error_service',['@web/core/browser/browser','@web/core/registry','@web/core/errors/error_utils','@web/core/browser/feature_detection'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{completeUncaughtError,getErrorTechnicalName}=require("@web/core/errors/error_utils");const{isBrowserFirefox,isBrowserChrome}=require("@web/core/browser/feature_detection");const UncaughtError=__exports.UncaughtError=class UncaughtError extends Error{constructor(message){super(message);this.name=getErrorTechnicalName(this);this.traceback=null;}}
const UncaughtClientError=__exports.UncaughtClientError=class UncaughtClientError extends UncaughtError{constructor(message="Uncaught Javascript Error"){super(message);}}
const UncaughtPromiseError=__exports.UncaughtPromiseError=class UncaughtPromiseError extends UncaughtError{constructor(message="Uncaught Promise"){super(message);this.unhandledRejectionEvent=null;}}
const ThirdPartyScriptError=__exports.ThirdPartyScriptError=class ThirdPartyScriptError extends UncaughtError{constructor(message="Third-Party Script Error"){super(message);}}
const errorService=__exports.errorService={start(env){function handleError(uncaughtError,retry=true){function shouldLogError(){return(uncaughtError.event&&!uncaughtError.event.defaultPrevented&&uncaughtError.traceback);}
let originalError=uncaughtError;while(originalError instanceof Error&&"cause"in originalError){originalError=originalError.cause;}
for(const[name,handler]of registry.category("error_handlers").getEntries()){try{if(handler(env,uncaughtError,originalError)){break;}}catch(e){if(shouldLogError()){uncaughtError.event.preventDefault();console.error(`@web/core/error_service: handler "${name}" failed with "${
                                e.cause || e
                            }" while trying to handle:\n`+uncaughtError.traceback);}
return;}}
if(shouldLogError()){uncaughtError.event.preventDefault();console.error(uncaughtError.traceback);}}
browser.addEventListener("error",async(ev)=>{const{colno,error,filename,lineno,message}=ev;const errorsToIgnore=["ResizeObserver loop completed with undelivered notifications.","ResizeObserver loop limit exceeded",];if(!(error instanceof Error)&&errorsToIgnore.includes(message)){ev.preventDefault();return;}
const isRedactedError=!filename&&!lineno&&!colno;const isThirdPartyScriptError=isRedactedError||(isBrowserFirefox()&&new URL(filename).origin!==window.location.origin);if(isThirdPartyScriptError&&!odoo.debug){return;}
let uncaughtError;if(isRedactedError){uncaughtError=new ThirdPartyScriptError();uncaughtError.traceback=`An error whose details cannot be accessed by the Odoo framework has occurred.\n`+`The error probably originates from a JavaScript file served from a different origin.\n`+`The full error is available in the browser console.`;}else{uncaughtError=new UncaughtClientError();uncaughtError.event=ev;if(error instanceof Error){error.errorEvent=ev;const annotated=env.debug&&env.debug.includes("assets");await completeUncaughtError(uncaughtError,error,annotated);}}
uncaughtError.cause=error;handleError(uncaughtError);});browser.addEventListener("unhandledrejection",async(ev)=>{const error=ev.reason;let traceback;if(isBrowserChrome()&&ev instanceof CustomEvent&&error===undefined){if(!odoo.debug){return;}
traceback=`Uncaught unknown Error\n`+`An unknown error occured. This may be due to a Chrome extension meddling with Odoo.\n`+`(Opening your browser console might give you a hint on the error.)`;}
const uncaughtError=new UncaughtPromiseError();uncaughtError.unhandledRejectionEvent=ev;uncaughtError.event=ev;uncaughtError.traceback=traceback;if(error instanceof Error){error.errorEvent=ev;const annotated=env.debug&&env.debug.includes("assets");await completeUncaughtError(uncaughtError,error,annotated);}
uncaughtError.cause=error;handleError(uncaughtError);});},};registry.category("services").add("error",errorService,{sequence:1});return __exports;});;

/* /web/static/src/core/errors/error_utils.js */
odoo.define('@web/core/errors/error_utils',['@web/core/assets'],function(require){'use strict';let __exports={};const{loadJS}=require("@web/core/assets");function combineErrorNames(uncaughtError,originalError){const originalErrorName=getErrorTechnicalName(originalError);const uncaughtErrorName=getErrorTechnicalName(uncaughtError);if(originalErrorName===Error.name){return uncaughtErrorName;}else{return`${uncaughtErrorName} > ${originalErrorName}`;}}
__exports.fullTraceback=fullTraceback;function fullTraceback(error){let traceback=formatTraceback(error);let current=error.cause;while(current){traceback+=`\n\nCaused by: ${
            current instanceof Error ? formatTraceback(current) : current
        }`;current=current.cause;}
return traceback;}
__exports.fullAnnotatedTraceback=fullAnnotatedTraceback;async function fullAnnotatedTraceback(error){if(error.annotatedTraceback){return error.annotatedTraceback;}
if(error.errorEvent){error.errorEvent.preventDefault();}
let traceback;try{traceback=await annotateTraceback(error);let current=error.cause;while(current){traceback+=`\n\nCaused by: ${
                current instanceof Error ? await annotateTraceback(current) : current
            }`;current=current.cause;}}catch(e){console.warn("Failed to annotate traceback for error:",error,"failure reason:",e);traceback=fullTraceback(error);}
error.annotatedTraceback=traceback;if(error.errorEvent){throw error;}
return traceback;}
__exports.completeUncaughtError=completeUncaughtError;async function completeUncaughtError(uncaughtError,originalError,annotated=false){uncaughtError.name=combineErrorNames(uncaughtError,originalError);if(annotated){uncaughtError.traceback=await fullAnnotatedTraceback(originalError);}else{uncaughtError.traceback=fullTraceback(originalError);}
if(originalError.message){uncaughtError.message=`${uncaughtError.message} > ${originalError.message}`;}
uncaughtError.cause=originalError;}
__exports.getErrorTechnicalName=getErrorTechnicalName;function getErrorTechnicalName(error){return error.name!==Error.name?error.name:error.constructor.name;}
__exports.formatTraceback=formatTraceback;function formatTraceback(error){let traceback=error.stack;const errorName=getErrorTechnicalName(error);const descriptionLine=`${errorName}: ${error.message}`;if(error.stack.split("\n")[0].trim()!==descriptionLine){traceback=`${descriptionLine}\n${error.stack}`.replace(/\n/g,"\n    ");}
return traceback;}
__exports.annotateTraceback=annotateTraceback;async function annotateTraceback(error){const traceback=formatTraceback(error);try{await loadJS("/web/static/lib/stacktracejs/stacktrace.js");}catch{return traceback;}
if(error.stack){const regex=/ line (\d*) > (Function):(\d*)/gm;const subst=`:$1`;error.stack=error.stack.replace(regex,subst);}
let frames;try{frames=await StackTrace.fromError(error);}catch(e){console.warn("The following error could not be annotated:",error,e);return traceback;}
const lines=traceback.split("\n");if(lines[lines.length-1].trim()===""){lines.splice(-1);}
let lineIndex=0;let frameIndex=0;while(frameIndex<frames.length){const line=lines[lineIndex];if(!line.match(/:\d+:\d+\)?$/)){lineIndex++;continue;}
const frame=frames[frameIndex];const info=` (${frame.fileName}:${frame.lineNumber})`;lines[lineIndex]=line+info;lineIndex++;frameIndex++;}
return lines.join("\n");}
return __exports;});;

/* /web/static/src/core/errors/scss_error_dialog.js */
odoo.define('@web/core/errors/scss_error_dialog',['@web/core/browser/browser','@web/core/registry','@web/core/l10n/translation','@web/core/utils/urls'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{_t,translationIsReady}=require("@web/core/l10n/translation");const{getOrigin}=require("@web/core/utils/urls");const scssErrorNotificationService={dependencies:["notification"],start(env,{notification}){const origin=getOrigin();const assets=[...document.styleSheets].filter((sheet)=>{return(sheet.href?.includes("/web")&&sheet.href?.includes("/assets/")&&new URL(sheet.href,browser.location.origin).origin===origin);});translationIsReady.then(()=>{for(const asset of assets){let cssRules;try{cssRules=asset.cssRules;}catch{continue;}
const lastRule=cssRules?.[cssRules?.length-1];if(lastRule?.selectorText==="css_error_message"){const message=_t("The style compilation failed. This is an administrator or developer error that must be fixed for the entire database before continuing working. See browser console or server logs for details.");notification.add(message,{title:_t("Style error"),sticky:true,type:"danger",});console.log(lastRule.style.content.replaceAll("\\a","\n").replaceAll("\\*","*").replaceAll(`\\"`,`"`));}}});},};registry.category("services").add("scss_error_display",scssErrorNotificationService);return __exports;});;

/* /web/static/src/core/expression_editor/expression_editor.js */
odoo.define('@web/core/expression_editor/expression_editor',['@odoo/owl','@web/core/expression_editor/expression_editor_operator_editor','@web/core/tree_editor/condition_tree','@web/core/tree_editor/tree_editor','@web/core/tree_editor/tree_editor_operator_editor','@web/core/tree_editor/tree_editor_value_editors','@web/core/tree_editor/utils','@web/core/model_field_selector/model_field_selector','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Component,onWillStart,onWillUpdateProps}=require("@odoo/owl");const{getExpressionDisplayedOperators}=require("@web/core/expression_editor/expression_editor_operator_editor");const{condition,expressionFromTree,treeFromExpression,}=require("@web/core/tree_editor/condition_tree");const{TreeEditor}=require("@web/core/tree_editor/tree_editor");const{getOperatorEditorInfo}=require("@web/core/tree_editor/tree_editor_operator_editor");const{getDefaultValue}=require("@web/core/tree_editor/tree_editor_value_editors");const{getDefaultPath}=require("@web/core/tree_editor/utils");const{ModelFieldSelector}=require("@web/core/model_field_selector/model_field_selector");const{_t}=require("@web/core/l10n/translation");const ExpressionEditor=__exports.ExpressionEditor=class ExpressionEditor extends Component{static template="web.ExpressionEditor";static components={TreeEditor};static props={resModel:String,fields:Object,expression:String,update:Function,};setup(){onWillStart(()=>this.onPropsUpdated(this.props));onWillUpdateProps((nextProps)=>this.onPropsUpdated(nextProps));}
async onPropsUpdated(props){this.filteredFields=Object.fromEntries(Object.entries(props.fields).filter(([_,fieldDef])=>fieldDef.type!=="properties"));try{this.tree=treeFromExpression(props.expression,{getFieldDef:(name)=>this.getFieldDef(name,props),distributeNot:!this.isDebugMode,});}catch{this.tree=null;}}
getFieldDef(name,props=this.props){if(typeof name==="string"){return props.fields[name]||null;}
return null;}
getDefaultCondition(){const defaultPath=getDefaultPath(this.filteredFields);const fieldDef=this.filteredFields[defaultPath];const operator=getExpressionDisplayedOperators(fieldDef)[0];const value=getDefaultValue(fieldDef,operator);return condition(fieldDef.name,operator,value);}
getDefaultOperator(fieldDef){return getExpressionDisplayedOperators(fieldDef)[0];}
getOperatorEditorInfo(fieldDef){const operators=getExpressionDisplayedOperators(fieldDef);return getOperatorEditorInfo(operators,fieldDef);}
getPathEditorInfo(resModel,defaultCondition){if(resModel!==this.props.resModel){throw new Error(`Expression editor doesn't support tree as value so resModel has to be props.resModel`);}
return{component:ModelFieldSelector,extractProps:({value,update})=>({path:value,update,resModel:this.props.resModel,readonly:false,filter:(fieldDef)=>fieldDef.name in this.filteredFields,showDebugInput:false,followRelations:false,isDebugMode:this.isDebugMode,}),isSupported:(value)=>[0,1].includes(value)||value in this.filteredFields,stringify:(value)=>this.props.fields[value].string,defaultValue:()=>defaultCondition.path,message:_t("Field properties not supported"),};}
get isDebugMode(){return!!this.env.debug;}
onExpressionChange(expression){this.props.update(expression);}
resetExpression(){this.props.update("True");}
update(tree){const expression=expressionFromTree(tree,{getFieldDef:(name)=>this.getFieldDef(name),});this.props.update(expression);}}
return __exports;});;

/* /web/static/src/core/expression_editor/expression_editor_operator_editor.js */
odoo.define('@web/core/expression_editor/expression_editor_operator_editor',['@web/core/domain_selector/domain_selector_operator_editor'],function(require){'use strict';let __exports={};const{getDomainDisplayedOperators}=require("@web/core/domain_selector/domain_selector_operator_editor");const EXPRESSION_VALID_OPERATORS=["<","<=",">",">=","between","within","in","not in","=","!=","set","not_set","is","is_not",];__exports.getExpressionDisplayedOperators=getExpressionDisplayedOperators;function getExpressionDisplayedOperators(fieldDef){const operators=getDomainDisplayedOperators(fieldDef);return operators.filter((operator)=>EXPRESSION_VALID_OPERATORS.includes(operator));}
return __exports;});;

/* /web/static/src/core/expression_editor_dialog/expression_editor_dialog.js */
odoo.define('@web/core/expression_editor_dialog/expression_editor_dialog',['@odoo/owl','@web/core/dialog/dialog','@web/core/expression_editor/expression_editor','@web/core/py_js/py','@web/core/utils/hooks','@web/core/l10n/translation','@web/core/user'],function(require){'use strict';let __exports={};const{Component,useRef,useState}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{ExpressionEditor}=require("@web/core/expression_editor/expression_editor");const{evaluateExpr}=require("@web/core/py_js/py");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const ExpressionEditorDialog=__exports.ExpressionEditorDialog=class ExpressionEditorDialog extends Component{static components={Dialog,ExpressionEditor};static template="web.ExpressionEditorDialog";static props={close:Function,resModel:String,fields:Object,expression:String,onConfirm:Function,};setup(){this.notification=useService("notification");this.state=useState({expression:this.props.expression,});this.confirmButtonRef=useRef("confirm");}
get expressionEditorProps(){return{resModel:this.props.resModel,fields:this.props.fields,expression:this.state.expression,update:(expression)=>{this.state.expression=expression;},};}
makeDefaultRecord(){const record={};for(const[name,{type}]of Object.entries(this.props.fields)){switch(type){case"integer":case"float":case"monetary":record[name]=name==="id"?false:0;break;case"one2many":case"many2many":record[name]=[];break;default:record[name]=false;}}
return record;}
async onConfirm(){this.confirmButtonRef.el.disabled=true;const record=this.makeDefaultRecord();const evalContext={...user.context,...record};try{evaluateExpr(this.state.expression,evalContext);}catch{if(this.confirmButtonRef.el){this.confirmButtonRef.el.disabled=false;}
this.notification.add(_t("Expression is invalid. Please correct it"),{type:"danger",});return;}
this.props.onConfirm(this.state.expression);this.props.close();}
onDiscard(){this.props.close();}}
return __exports;});;

/* /web/static/src/core/field_service.js */
odoo.define('@web/core/field_service',['@web/core/utils/cache','@web/core/domain','@web/core/registry'],function(require){'use strict';let __exports={};const{Cache}=require("@web/core/utils/cache");const{Domain}=require("@web/core/domain");const{registry}=require("@web/core/registry");const fieldService=__exports.fieldService={dependencies:["orm"],async:["loadFields","loadPath","loadPropertyDefinitions"],start(env,{orm}){const cache=new Cache((resModel,options)=>{return orm.call(resModel,"fields_get",[options.fieldNames,options.attributes]).catch((error)=>{cache.clear(resModel,options);return Promise.reject(error);});},(resModel,options)=>JSON.stringify([resModel,options.fieldNames,options.attributes]));env.bus.addEventListener("CLEAR-CACHES",()=>cache.invalidate());async function loadFields(resModel,options={}){if(typeof resModel!=="string"||!resModel){throw new Error(`Invalid model name: ${resModel}`);}
return cache.read(resModel,options);}
async function _loadPropertyDefinitions(fieldDefs,name,domain=[]){const{definition_record:definitionRecord,definition_record_field:definitionRecordField,}=fieldDefs[name];const definitionRecordModel=fieldDefs[definitionRecord].relation;domain=Domain.and([[[definitionRecordField,"!=",false]],domain]).toList();const result=await orm.webSearchRead(definitionRecordModel,domain,{specification:{display_name:{},[definitionRecordField]:{},},});const definitions={};for(const record of result.records){for(const definition of record[definitionRecordField]){definitions[definition.name]={is_property:true,searchable:true,record_id:record.id,record_name:record.display_name,...definition,};}}
return definitions;}
async function loadPropertyDefinitions(resModel,fieldName,domain){const fieldDefs=await loadFields(resModel);return _loadPropertyDefinitions(fieldDefs,fieldName,domain);}
async function _loadPath(resModel,fieldDefs,names){if(!fieldDefs){return{isInvalid:"path",names,modelsInfo:[]};}
const[name,...remainingNames]=names;const modelsInfo=[{resModel,fieldDefs}];if(resModel==="*"&&remainingNames.length){return{isInvalid:"path",names,modelsInfo};}
const fieldDef=fieldDefs[name];if((name!=="*"&&!fieldDef)||(name==="*"&&remainingNames.length)){return{isInvalid:"path",names,modelsInfo};}
if(!remainingNames.length){return{names,modelsInfo};}
let subResult;if(fieldDef.relation){subResult=await _loadPath(fieldDef.relation,await loadFields(fieldDef.relation),remainingNames);}else if(fieldDef.type==="properties"){subResult=await _loadPath("*",await _loadPropertyDefinitions(fieldDefs,name),remainingNames);}
if(subResult){const result={names,modelsInfo:[...modelsInfo,...subResult.modelsInfo],};if(subResult.isInvalid){result.isInvalid="path";}
return result;}
return{isInvalid:"path",names,modelsInfo};}
async function loadPath(resModel,path="*"){const fieldDefs=await loadFields(resModel);if(typeof path!=="string"||!path){throw new Error(`Invalid path: ${path}`);}
return _loadPath(resModel,fieldDefs,path.split("."));}
return{loadFields,loadPath,loadPropertyDefinitions};},};registry.category("services").add("field",fieldService);return __exports;});;

/* /web/static/src/core/file_input/file_input.js */
odoo.define('@web/core/file_input/file_input',['@odoo/owl','@web/core/utils/files'],function(require){'use strict';let __exports={};const{Component,onMounted,useRef,useState}=require("@odoo/owl");const{useFileUploader}=require("@web/core/utils/files");const FileInput=__exports.FileInput=class FileInput extends Component{static template="web.FileInput";static defaultProps={acceptedFileExtensions:"*",hidden:false,multiUpload:false,onUpload:()=>{},route:"/web/binary/upload_attachment",beforeOpen:async()=>true,};static props={acceptedFileExtensions:{type:String,optional:true},autoOpen:{type:Boolean,optional:true},hidden:{type:Boolean,optional:true},multiUpload:{type:Boolean,optional:true},onUpload:{type:Function,optional:true},beforeOpen:{type:Function,optional:true},resId:{type:Number,optional:true},resModel:{type:String,optional:true},route:{type:String,optional:true},"*":true,};setup(){this.uploadFiles=useFileUploader();this.fileInputRef=useRef("file-input");this.state=useState({isDisable:false,});onMounted(()=>{if(this.props.autoOpen){this.onTriggerClicked();}});}
get httpParams(){const{resId,resModel}=this.props;const params={csrf_token:odoo.csrf_token,ufile:[...this.fileInputRef.el.files],};if(resModel){params.model=resModel;}
if(resId!==undefined){params.id=resId;}
return params;}
async onFileInputChange(){this.state.isDisable=true;const parsedFileData=await this.uploadFiles(this.props.route,this.httpParams);if(parsedFileData){this.props.onUpload(parsedFileData,this.fileInputRef.el?this.fileInputRef.el.files:[]);this.fileInputRef.el.value=null;}
this.state.isDisable=false;}
async onTriggerClicked(){if(await this.props.beforeOpen()){this.fileInputRef.el.click();}}}
return __exports;});;

/* /web/static/src/core/file_upload/file_upload_progress_bar.js */
odoo.define('@web/core/file_upload/file_upload_progress_bar',['@web/core/l10n/translation','@web/core/utils/hooks','@web/core/confirmation_dialog/confirmation_dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{Component}=require("@odoo/owl");const FileUploadProgressBar=__exports.FileUploadProgressBar=class FileUploadProgressBar extends Component{static template="web.FileUploadProgressBar";static props={fileUpload:{type:Object},};setup(){this.dialogService=useService("dialog");}
onCancel(){if(!this.props.fileUpload.xhr){return;}
this.dialogService.add(ConfirmationDialog,{body:_t("Do you really want to cancel the upload of %s?",this.props.fileUpload.title),confirm:()=>{this.props.fileUpload.xhr.abort();},});}}
return __exports;});;

/* /web/static/src/core/file_upload/file_upload_progress_container.js */
odoo.define('@web/core/file_upload/file_upload_progress_container',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const FileUploadProgressContainer=__exports.FileUploadProgressContainer=class FileUploadProgressContainer extends Component{static template="web.FileUploadProgressContainer";static props={Component:{optional:false},shouldDisplay:{type:Function,optional:true},fileUploads:{type:Object},};}
return __exports;});;

/* /web/static/src/core/file_upload/file_upload_progress_record.js */
odoo.define('@web/core/file_upload/file_upload_progress_record',['@web/core/l10n/translation','@web/core/file_upload/file_upload_progress_bar','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{FileUploadProgressBar}=require("@web/core/file_upload/file_upload_progress_bar");const{Component}=require("@odoo/owl");const FileUploadProgressRecord=__exports.FileUploadProgressRecord=class FileUploadProgressRecord extends Component{static template="";static components={FileUploadProgressBar,};static props={fileUpload:Object,selector:{type:String,optional:true},};getProgressTexts(){const fileUpload=this.props.fileUpload;const percent=Math.round(fileUpload.progress*100);if(percent===100){return{left:_t("Processing..."),right:"",};}else{const mbLoaded=Math.round(fileUpload.loaded/1000000);const mbTotal=Math.round(fileUpload.total/1000000);return{left:_t("Uploading... (%s%)",percent),right:_t("(%(mbLoaded)s/%(mbTotal)sMB)",{mbLoaded,mbTotal}),};}}}
const FileUploadProgressKanbanRecord=__exports.FileUploadProgressKanbanRecord=class FileUploadProgressKanbanRecord extends FileUploadProgressRecord{static template="web.FileUploadProgressKanbanRecord";}
const FileUploadProgressDataRow=__exports.FileUploadProgressDataRow=class FileUploadProgressDataRow extends FileUploadProgressRecord{static template="web.FileUploadProgressDataRow";}
return __exports;});;

/* /web/static/src/core/file_upload/file_upload_service.js */
odoo.define('@web/core/file_upload/file_upload_service',['@web/core/l10n/translation','@web/core/registry','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{EventBus,reactive}=require("@odoo/owl");const fileUploadService=__exports.fileUploadService={dependencies:["notification"],createXhr(){return new window.XMLHttpRequest();},start(env,{notificationService}){const uploads=reactive({});let nextId=1;const bus=new EventBus();const upload=async(route,files,params={})=>{const xhr=this.createXhr();xhr.open("POST",route);const formData=new FormData();formData.append("csrf_token",odoo.csrf_token);for(const file of files){formData.append("ufile",file);}
if(params.buildFormData){params.buildFormData(formData);}
const upload=reactive({id:nextId++,xhr,data:formData,progress:0,loaded:0,total:0,state:"pending",title:files.length===1?files[0].name:_t("%s Files",files.length),type:files.length===1?files[0].type:undefined,});uploads[upload.id]=upload;xhr.upload.addEventListener("progress",async(ev)=>{upload.progress=ev.loaded/ev.total;upload.loaded=ev.loaded;upload.total=ev.total;upload.state="loading";});xhr.addEventListener("load",()=>{delete uploads[upload.id];upload.state="loaded";bus.trigger("FILE_UPLOAD_LOADED",{upload});});xhr.addEventListener("error",async()=>{delete uploads[upload.id];upload.state="error";if(params.displayErrorNotification!==undefined&&params.displayErrorNotification){notificationService.add(_t("An error occured while uploading."),{title:_t("Error"),sticky:true,});}
bus.trigger("FILE_UPLOAD_ERROR",{upload});});xhr.addEventListener("abort",async()=>{delete uploads[upload.id];upload.state="abort";bus.trigger("FILE_UPLOAD_ERROR",{upload});});xhr.send(formData);bus.trigger("FILE_UPLOAD_ADDED",{upload});return upload;};return{bus,upload,uploads};},};registry.category("services").add("file_upload",fileUploadService);return __exports;});;

/* /web/static/src/core/file_viewer/file_model.js */
odoo.define('@web/core/file_viewer/file_model',['@web/core/utils/urls'],function(require){'use strict';let __exports={};const{url}=require("@web/core/utils/urls");const FileModelMixin=__exports.FileModelMixin=(T)=>class extends T{access_token;checksum;extension;filename;id;mimetype;name;type;tmpUrl;url;uploading;get defaultSource(){const route=url(this.urlRoute,this.urlQueryParams);const encodedRoute=encodeURIComponent(route);if(this.isPdf){return`/web/static/lib/pdfjs/web/viewer.html?file=${encodedRoute}#pagemode=none`;}
if(this.isUrlYoutube){const urlArr=this.url.split("/");let token=urlArr[urlArr.length-1];if(token.includes("watch")){token=token.split("v=")[1];const amp=token.indexOf("&");if(amp!==-1){token=token.substring(0,amp);}}
return`https://www.youtube.com/embed/${token}`;}
return route;}
get displayName(){return this.name||this.filename;}
get downloadUrl(){return url(this.urlRoute,{...this.urlQueryParams,download:true});}
get isImage(){const imageMimetypes=["image/bmp","image/gif","image/jpeg","image/png","image/svg+xml","image/tiff","image/x-icon","image/webp",];return imageMimetypes.includes(this.mimetype);}
get isPdf(){return this.mimetype&&this.mimetype.startsWith("application/pdf");}
get isText(){const textMimeType=["application/javascript","application/json","text/css","text/html","text/plain",];return textMimeType.includes(this.mimetype);}
get isUrl(){return this.type==="url"&&this.url;}
get isUrlYoutube(){return!!this.url&&this.url.includes("youtu");}
get isVideo(){const videoMimeTypes=["audio/mpeg","video/x-matroska","video/mp4","video/webm"];return videoMimeTypes.includes(this.mimetype);}
get isViewable(){return((this.isText||this.isImage||this.isVideo||this.isPdf||this.isUrlYoutube)&&!this.uploading);}
get urlQueryParams(){if(this.uploading&&this.tmpUrl){return{};}
const params={access_token:this.access_token,filename:this.name,unique:this.checksum,};for(const prop in params){if(!params[prop]){delete params[prop];}}
return params;}
get urlRoute(){if(this.uploading&&this.tmpUrl){return this.tmpUrl;}
return this.isImage?`/web/image/${this.id}`:`/web/content/${this.id}`;}};const FileModel=__exports.FileModel=class FileModel extends FileModelMixin(Object){}
return __exports;});;

/* /web/static/src/core/file_viewer/file_viewer.js */
odoo.define('@web/core/file_viewer/file_viewer',['@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,useRef,useState}=require("@odoo/owl");const{useAutofocus,useService}=require("@web/core/utils/hooks");const FileViewer=__exports.FileViewer=class FileViewer extends Component{static template="web.FileViewer";static components={};static props=["files","startIndex","close?","modal?"];static defaultProps={modal:true,};setup(){useAutofocus();this.imageRef=useRef("image");this.zoomerRef=useRef("zoomer");this.isDragging=false;this.dragStartX=0;this.dragStartY=0;this.scrollZoomStep=0.1;this.zoomStep=0.5;this.minScale=0.5;this.translate={dx:0,dy:0,x:0,y:0,};this.state=useState({index:this.props.startIndex,file:this.props.files[this.props.startIndex],imageLoaded:false,scale:1,angle:0,});this.ui=useState(useService("ui"));}
onImageLoaded(){this.state.imageLoaded=true;}
close(){this.props.close&&this.props.close();}
next(){const last=this.props.files.length-1;this.activateFile(this.state.index===last?0:this.state.index+1);}
previous(){const last=this.props.files.length-1;this.activateFile(this.state.index===0?last:this.state.index-1);}
activateFile(index){this.state.index=index;this.state.file=this.props.files[index];}
onKeydown(ev){switch(ev.key){case"ArrowRight":this.next();break;case"ArrowLeft":this.previous();break;case"Escape":this.close();break;case"q":this.close();break;}
if(this.state.file.isImage){switch(ev.key){case"r":this.rotate();break;case"+":this.zoomIn();break;case"-":this.zoomOut();break;case"0":this.resetZoom();break;}}}
onWheelImage(ev){if(ev.deltaY>0){this.zoomOut({scroll:true});}else{this.zoomIn({scroll:true});}}
onMousedownImage(ev){if(this.isDragging){return;}
if(ev.button!==0){return;}
this.isDragging=true;this.dragStartX=ev.clientX;this.dragStartY=ev.clientY;}
onMouseupImage(){if(!this.isDragging){return;}
this.isDragging=false;this.translate.x+=this.translate.dx;this.translate.y+=this.translate.dy;this.translate.dx=0;this.translate.dy=0;this.updateZoomerStyle();}
onMousemoveView(ev){if(!this.isDragging){return;}
this.translate.dx=ev.clientX-this.dragStartX;this.translate.dy=ev.clientY-this.dragStartY;this.updateZoomerStyle();}
resetZoom(){this.state.scale=1;this.updateZoomerStyle();}
rotate(){this.state.angle+=90;}
zoomIn({scroll=false}={}){this.state.scale=this.state.scale+(scroll?this.scrollZoomStep:this.zoomStep);this.updateZoomerStyle();}
zoomOut({scroll=false}={}){if(this.state.scale===this.minScale){return;}
const unflooredAdaptedScale=this.state.scale-(scroll?this.scrollZoomStep:this.zoomStep);this.state.scale=Math.max(this.minScale,unflooredAdaptedScale);this.updateZoomerStyle();}
updateZoomerStyle(){const tx=this.imageRef.el.offsetWidth*this.state.scale>this.zoomerRef.el.offsetWidth?this.translate.x+this.translate.dx:0;const ty=this.imageRef.el.offsetHeight*this.state.scale>this.zoomerRef.el.offsetHeight?this.translate.y+this.translate.dy:0;if(tx===0){this.translate.x=0;}
if(ty===0){this.translate.y=0;}
this.zoomerRef.el.style="transform: "+`translate(${tx}px, ${ty}px)`;}
get imageStyle(){let style="transform: "+`scale3d(${this.state.scale}, ${this.state.scale}, 1) `+`rotate(${this.state.angle}deg);`;if(this.state.angle%180!==0){style+=`max-height: ${window.innerWidth}px; max-width: ${window.innerHeight}px;`;}else{style+="max-height: 100%; max-width: 100%;";}
return style;}
onClickPrint(){const printWindow=window.open("about:blank","_new");printWindow.document.open();printWindow.document.write(`
                <html>
                    <head>
                        <script>
                            function onloadImage() {
                                setTimeout('printImage()', 10);
                            }
                            function printImage() {
                                window.print();
                                window.close();
                            }
                        </script>
                    </head>
                    <body onload='onloadImage()'>
                        <img src="${this.state.file.defaultSource}" alt=""/>
                    </body>
                </html>`);printWindow.document.close();}}
return __exports;});;

/* /web/static/src/core/file_viewer/file_viewer_hook.js */
odoo.define('@web/core/file_viewer/file_viewer_hook',['@odoo/owl','@web/core/registry','@web/core/file_viewer/file_viewer'],function(require){'use strict';let __exports={};const{onWillDestroy}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{FileViewer}=require("@web/core/file_viewer/file_viewer");let id=1;__exports.createFileViewer=createFileViewer;function createFileViewer(){const fileViewerId=`web.file_viewer${id++}`;function open(file,files=[file]){if(!file.isViewable){return;}
if(files.length>0){const viewableFiles=files.filter((file)=>file.isViewable);const index=viewableFiles.indexOf(file);registry.category("main_components").add(fileViewerId,{Component:FileViewer,props:{files:viewableFiles,startIndex:index,close},});}}
function close(){registry.category("main_components").remove(fileViewerId);}
return{open,close};}
__exports.useFileViewer=useFileViewer;function useFileViewer(){const{open,close}=createFileViewer();onWillDestroy(close);return{open,close};}
return __exports;});;

/* /web/static/src/core/hotkeys/hotkey_hook.js */
odoo.define('@web/core/hotkeys/hotkey_hook',['@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{useEffect}=require("@odoo/owl");__exports.useHotkey=useHotkey;function useHotkey(hotkey,callback,options={}){const hotkeyService=useService("hotkey");useEffect(()=>hotkeyService.add(hotkey,callback,options),()=>[]);}
return __exports;});;

/* /web/static/src/core/hotkeys/hotkey_service.js */
odoo.define('@web/core/hotkeys/hotkey_service',['@web/core/browser/feature_detection','@web/core/registry','@web/core/browser/browser','@web/core/utils/ui'],function(require){'use strict';let __exports={};const{isMacOS}=require("@web/core/browser/feature_detection");const{registry}=require("@web/core/registry");const{browser}=require("@web/core/browser/browser");const{getVisibleElements}=require("@web/core/utils/ui");const ALPHANUM_KEYS="abcdefghijklmnopqrstuvwxyz0123456789".split("");const NAV_KEYS=["arrowleft","arrowright","arrowup","arrowdown","pageup","pagedown","home","end","backspace","enter","tab","delete","space",];const MODIFIERS=["alt","control","shift"];const AUTHORIZED_KEYS=[...ALPHANUM_KEYS,...NAV_KEYS,"escape"];__exports.getActiveHotkey=getActiveHotkey;function getActiveHotkey(ev){if(!ev.key){return"";}
if(ev.isComposing){return"";}
const hotkey=[];if(isMacOS()?ev.ctrlKey:ev.altKey){hotkey.push("alt");}
if(isMacOS()?ev.metaKey:ev.ctrlKey){hotkey.push("control");}
if(ev.shiftKey){hotkey.push("shift");}
let key=ev.key.toLowerCase();if(key===" "){key="space";}
if(ev.code&&ev.code.indexOf("Digit")===0){key=ev.code.slice(-1);}
if(!AUTHORIZED_KEYS.includes(key)&&ev.code&&ev.code.indexOf("Key")===0){key=ev.code.slice(-1).toLowerCase();}
if(!MODIFIERS.includes(key)){hotkey.push(key);}
return hotkey.join("+");}
const hotkeyService=__exports.hotkeyService={dependencies:["ui"],overlayModifier:"alt",start(env,{ui}){const registrations=new Map();let nextToken=0;let overlaysVisible=false;addListeners(browser);function addListeners(target){target.addEventListener("keydown",onKeydown);target.addEventListener("keyup",removeHotkeyOverlays);target.addEventListener("blur",removeHotkeyOverlays);target.addEventListener("click",removeHotkeyOverlays);}
function onKeydown(event){if(event.code&&event.code.indexOf("Numpad")===0&&/^\d$/.test(event.key)){return;}
const hotkey=getActiveHotkey(event);if(!hotkey){return;}
const{activeElement,isBlocked}=ui;if(isBlocked){return;}
const elementsWithAccessKey=document.querySelectorAll("[accesskey]");for(const el of elementsWithAccessKey){if(el instanceof HTMLElement){el.dataset.hotkey=el.accessKey;el.removeAttribute("accesskey");}}
if(!overlaysVisible&&hotkey===hotkeyService.overlayModifier){addHotkeyOverlays(activeElement);event.preventDefault();return;}
const singleKey=hotkey.split("+").pop();if(!AUTHORIZED_KEYS.includes(singleKey)){return;}
const targetIsEditable=event.target instanceof HTMLElement&&(/input|textarea/i.test(event.target.tagName)||event.target.isContentEditable)&&!event.target.matches("input[type=checkbox], input[type=radio]");const shouldProtectEditable=targetIsEditable&&!event.target.dataset.allowHotkeys&&singleKey!=="escape";const infos={activeElement,hotkey,isRepeated:event.repeat,target:event.target,shouldProtectEditable,};const dispatched=dispatch(infos);if(dispatched){event.preventDefault();event.stopImmediatePropagation();}
if(overlaysVisible){removeHotkeyOverlays();event.preventDefault();}}
function dispatch(infos){const{activeElement,hotkey,isRepeated,target,shouldProtectEditable}=infos;const reversedRegistrations=Array.from(registrations.values()).reverse();const domRegistrations=getDomRegistrations(hotkey,activeElement);const allRegistrations=reversedRegistrations.concat(domRegistrations);const candidates=allRegistrations.filter((reg)=>reg.hotkey===hotkey&&(reg.allowRepeat||!isRepeated)&&(reg.bypassEditableProtection||!shouldProtectEditable)&&(reg.global||reg.activeElement===activeElement)&&(!reg.isAvailable||reg.isAvailable())&&(!reg.area||(target&&reg.area()&&reg.area().contains(target))));let winner=candidates.shift();if(winner&&winner.area){for(const candidate of candidates.filter((c)=>Boolean(c.area))){if(candidate.area()&&winner.area().contains(candidate.area())){winner=candidate;}}}
if(winner){winner.callback({area:winner.area&&winner.area(),target,});return true;}
return false;}
function getDomRegistrations(hotkey,activeElement){const overlayModParts=hotkeyService.overlayModifier.split("+");if(!overlayModParts.every((el)=>hotkey.includes(el))){return[];}
const cleanHotkey=hotkey.split("+").filter((key)=>!overlayModParts.includes(key)).join("+");const elems=getVisibleElements(activeElement,`[data-hotkey='${cleanHotkey}' i]`);return elems.map((el)=>({hotkey,activeElement,bypassEditableProtection:true,callback:()=>{if(document.activeElement){document.activeElement.blur();}
el.focus();setTimeout(()=>el.click());},}));}
function addHotkeyOverlays(activeElement){const hotkeysFromHookToHighlight=[];for(const[,registration]of registrations){const overlayElement=registration.withOverlay?.();if(overlayElement){hotkeysFromHookToHighlight.push({hotkey:registration.hotkey.replace(`${hotkeyService.overlayModifier}+`,""),el:overlayElement,});}}
const hotkeysFromDomToHighlight=getVisibleElements(activeElement,"[data-hotkey]:not(:disabled)").map((el)=>({hotkey:el.dataset.hotkey,el}));const items=[...hotkeysFromDomToHighlight,...hotkeysFromHookToHighlight];for(const item of items){const hotkey=item.hotkey;const overlay=document.createElement("div");overlay.classList.add("o_web_hotkey_overlay","position-absolute","top-0","bottom-0","start-0","end-0","d-flex","justify-content-center","align-items-center","m-0","bg-black-50","h6");overlay.style.zIndex=1;const overlayKbd=document.createElement("kbd");overlayKbd.className="small";overlayKbd.appendChild(document.createTextNode(hotkey.toUpperCase()));overlay.appendChild(overlayKbd);let overlayParent;if(item.el.tagName.toUpperCase()==="INPUT"){overlayParent=item.el.parentElement;}else{overlayParent=item.el;}
if(overlayParent.style.position!=="absolute"){overlayParent.style.position="relative";}
overlayParent.appendChild(overlay);}
overlaysVisible=true;}
function removeHotkeyOverlays(){for(const overlay of document.querySelectorAll(".o_web_hotkey_overlay")){overlay.remove();}
overlaysVisible=false;}
function registerHotkey(hotkey,callback,options={}){if(!hotkey||hotkey.length===0){throw new Error("You must specify an hotkey when registering a registration.");}
if(!callback||typeof callback!=="function"){throw new Error("You must specify a callback function when registering a registration.");}
const keys=hotkey.toLowerCase().split("+").filter((k)=>!MODIFIERS.includes(k));if(keys.some((k)=>!AUTHORIZED_KEYS.includes(k))){throw new Error(`You are trying to subscribe for an hotkey ('${hotkey}')
            that contains parts not whitelisted: ${keys.join(", ")}`);}else if(keys.length>1){throw new Error(`You are trying to subscribe for an hotkey ('${hotkey}')
            that contains more than one single key part: ${keys.join("+")}`);}
const token=nextToken++;const registration={hotkey:hotkey.toLowerCase(),callback,activeElement:null,allowRepeat:options&&options.allowRepeat,bypassEditableProtection:options&&options.bypassEditableProtection,global:options&&options.global,area:options&&options.area,isAvailable:options&&options.isAvailable,withOverlay:options&&options.withOverlay,};Promise.resolve().then(()=>{registration.activeElement=ui.activeElement;});registrations.set(token,registration);return token;}
function unregisterHotkey(token){registrations.delete(token);}
return{add(hotkey,callback,options={}){const token=registerHotkey(hotkey,callback,options);return()=>{unregisterHotkey(token);};},registerIframe(iframe){addListeners(iframe.contentWindow);},};},};registry.category("services").add("hotkey",hotkeyService);return __exports;});;

/* /web/static/src/core/install_scoped_app/install_scoped_app.js */
odoo.define('@web/core/install_scoped_app/install_scoped_app',['@web/core/browser/browser','@web/core/registry','@odoo/owl','@web/core/browser/feature_detection','@web/core/utils/hooks','@web/core/dropdown/dropdown'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{Component,onMounted,useState}=require("@odoo/owl");const{isDisplayStandalone}=require("@web/core/browser/feature_detection");const{useService}=require("@web/core/utils/hooks");const{Dropdown}=require("@web/core/dropdown/dropdown");const InstallScopedApp=__exports.InstallScopedApp=class InstallScopedApp extends Component{static props={};static template="web.InstallScopedApp";static components={Dropdown};setup(){this.pwa=useState(useService("pwa"));this.state=useState({manifest:{},showInstallUI:false});this.isDisplayStandalone=isDisplayStandalone();this.isInstallationPossible=browser.BeforeInstallPromptEvent!==undefined;onMounted(async()=>{this.state.manifest=await this.pwa.getManifest();this.state.showInstallUI=true;});}
onChangeName(ev){const value=ev.target.value;if(value!==this.state.manifest.name){const url=new URL(document.location.href);url.searchParams.set("app_name",encodeURIComponent(value));browser.location.replace(url);}}
onInstall(){this.state.showInstallUI=false;this.pwa.show({onDone:(res)=>{if(res.outcome==="accepted"){browser.location.replace(this.state.manifest.start_url);}else{this.state.showInstallUI=true;}},});}}
registry.category("public_components").add("web.install_scoped_app",InstallScopedApp);return __exports;});;

/* /web/static/src/core/l10n/dates.js */
odoo.define('@web/core/l10n/dates',['@web/core/l10n/localization','@web/core/l10n/translation','@web/core/utils/functions','@web/core/utils/arrays'],function(require){'use strict';let __exports={};const{localization}=require("@web/core/l10n/localization");const{_t}=require("@web/core/l10n/translation");const{memoize}=require("@web/core/utils/functions");const{ensureArray}=require("@web/core/utils/arrays");const{DateTime,Settings}=luxon;const MIN_VALID_DATE=__exports.MIN_VALID_DATE=DateTime.fromObject({year:1000});const MAX_VALID_DATE=__exports.MAX_VALID_DATE=DateTime.fromObject({year:9999}).endOf("year");const SERVER_DATE_FORMAT="yyyy-MM-dd";const SERVER_TIME_FORMAT="HH:mm:ss";const SERVER_DATETIME_FORMAT=`${SERVER_DATE_FORMAT} ${SERVER_TIME_FORMAT}`;const nonAlphaRegex=/[^a-z]/gi;const nonDigitRegex=/[^\d]/g;const normalizeFormatTable={a:"ccc",A:"cccc",b:"MMM",B:"MMMM",d:"dd",H:"HH",I:"hh",j:"o",m:"MM",M:"mm",p:"a",S:"ss",W:"WW",w:"c",y:"yy",Y:"yyyy",c:"ccc MMM d HH:mm:ss yyyy",x:"MM/dd/yy",X:"HH:mm:ss",};const smartDateUnits={d:"days",m:"months",w:"weeks",y:"years",};const smartDateRegex=new RegExp(["^","([+-])","(\\d+)",`([${Object.keys(smartDateUnits).join("")}]?)`,"$"].join("\\s*"),"i");const dateCache=new WeakMap();const dateTimeCache=new WeakMap();const ConversionError=__exports.ConversionError=class ConversionError extends Error{name="ConversionError";}
__exports.areDatesEqual=areDatesEqual;function areDatesEqual(d1,d2){if(Array.isArray(d1)||Array.isArray(d2)){d1=ensureArray(d1);d2=ensureArray(d2);return d1.length===d2.length&&d1.every((d1Val,i)=>areDatesEqual(d1Val,d2[i]));}
if(d1 instanceof DateTime&&d2 instanceof DateTime&&d1!==d2){return d1.equals(d2);}else{return d1===d2;}}
__exports.clampDate=clampDate;function clampDate(desired,minDate,maxDate){if(maxDate<desired){return maxDate;}
if(minDate>desired){return minDate;}
return desired;}
__exports.getLocalWeekNumber=getLocalWeekNumber;function getLocalWeekNumber(date){return getLocalYearAndWeek(date).week;}
__exports.getLocalYearAndWeek=getLocalYearAndWeek;function getLocalYearAndWeek(date){if(!date.isLuxonDateTime){date=DateTime.fromJSDate(date);}
const{weekStart}=localization;date=date.minus({days:(date.weekday+7-weekStart)%7});date=weekStart>1&&weekStart<5?date.minus({days:(date.weekday+6)%7}):date.plus({days:(8-date.weekday)%7});date=date.plus({days:6});const jan4=DateTime.local(date.year,1,4);const diffDays=date<jan4?date.diff(jan4.minus({years:1}),"day").days:date.diff(jan4,"day").days;return{year:date.year,week:Math.trunc(diffDays/7)+1};}
__exports.getStartOfLocalWeek=getStartOfLocalWeek;function getStartOfLocalWeek(date){const{weekStart}=localization;const weekday=date.weekday<weekStart?weekStart-7:weekStart;return date.set({weekday}).startOf("day");}
__exports.getEndOfLocalWeek=getEndOfLocalWeek;function getEndOfLocalWeek(date){return getStartOfLocalWeek(date).plus({days:6}).endOf("day");}
__exports.is24HourFormat=is24HourFormat;function is24HourFormat(format){return/H/.test(format||localization.timeFormat);}
__exports.isInRange=isInRange;function isInRange(value,range){if(!value||!range){return false;}
if(Array.isArray(value)){const actualValues=value.filter(Boolean);if(actualValues.length<2){return isInRange(actualValues[0],range);}
return((value[0]<=range[0]&&range[0]<=value[1])||(range[0]<=value[0]&&value[0]<=range[1]));}else{return range[0]<=value&&value<=range[1];}}
__exports.isMeridiemFormat=isMeridiemFormat;function isMeridiemFormat(format){return/a/.test(format||localization.timeFormat);}
function isValidDate(date){return date&&date.isValid&&isInRange(date,[MIN_VALID_DATE,MAX_VALID_DATE]);}
function parseSmartDateInput(value){const match=value.match(smartDateRegex);if(match){let date=DateTime.local();const offset=parseInt(match[2],10);const unit=smartDateUnits[(match[3]||"d").toLowerCase()];if(match[1]==="+"){date=date.plus({[unit]:offset});}else{date=date.minus({[unit]:offset});}
return date;}
return false;}
const stripAlphaDupes=memoize(function stripAlphaDupes(str){return str.replace(/[a-z]/gi,(letter,index,str)=>letter===str[index-1]?"":letter);});const strftimeToLuxonFormat=__exports.strftimeToLuxonFormat=memoize(function strftimeToLuxonFormat(format){const output=[];let inToken=false;for(let index=0;index<format.length;++index){let character=format[index];if(character==="%"&&!inToken){inToken=true;continue;}
if(/[a-z]/gi.test(character)){if(inToken&&normalizeFormatTable[character]!==undefined){character=normalizeFormatTable[character];}else{character=`'${character}'`;}}
output.push(character);inToken=false;}
return output.join("");});__exports.today=today;function today(){return DateTime.local().startOf("day");}
const condensedFormats={};function getCondensedFormat(format){const originalFormat=format;if(!condensedFormats[originalFormat]){format=format.replace(/(^|[^M])M{2}([^M]|$)/,"$1M$2");format=format.replace(/(^|[^d])d{2}([^d]|$)/,"$1d$2");format=format.replace(/(^|[^H])H{2}([^H]|$)/,"$1H$2");condensedFormats[originalFormat]=format;}
return condensedFormats[originalFormat];}
__exports.formatDate=formatDate;function formatDate(value,options={}){if(!value){return"";}
let format=options.format;if(!format){format=localization.dateFormat;if(options.condensed){format=getCondensedFormat(format);}}
return value.toFormat(format);}
__exports.formatDateTime=formatDateTime;function formatDateTime(value,options={}){if(!value){return"";}
let format=options.format;if(!format){if(options.showSeconds===false){format=`${localization.dateFormat} ${localization.shortTimeFormat}`;}else{format=localization.dateTimeFormat;}
if(options.condensed){format=getCondensedFormat(format);}}
return value.setZone(options.tz||"default").toFormat(format);}
__exports.formatDuration=formatDuration;function formatDuration(seconds,showFullDuration){const displayStyle=showFullDuration?"long":"narrow";const numberOfValuesToDisplay=showFullDuration?2:1;const durationKeys=["years","months","days","hours","minutes"];if(seconds<60){seconds=60;}
seconds-=seconds%60;let duration=luxon.Duration.fromObject({seconds:seconds}).shiftTo(...durationKeys);duration=duration.shiftTo(...durationKeys.filter((key)=>duration.get(key)));const durationSplit=duration.toHuman({unitDisplay:displayStyle}).split(",");if(!showFullDuration&&duration.loc.locale.includes("en")&&duration.months>0){durationSplit[0]=durationSplit[0].replace("m","M");}
return durationSplit.slice(0,numberOfValuesToDisplay).join(",");}
__exports.serializeDate=serializeDate;function serializeDate(value){if(!dateCache.has(value)){dateCache.set(value,value.toFormat(SERVER_DATE_FORMAT,{numberingSystem:"latn"}));}
return dateCache.get(value);}
__exports.serializeDateTime=serializeDateTime;function serializeDateTime(value){if(!dateTimeCache.has(value)){dateTimeCache.set(value,value.setZone("utc").toFormat(SERVER_DATETIME_FORMAT,{numberingSystem:"latn"}));}
return dateTimeCache.get(value);}
__exports.parseDate=parseDate;function parseDate(value,options={}){const parsed=parseDateTime(value,{...options,format:options.format||localization.dateFormat,});return parsed&&parsed.startOf("day");}
__exports.parseDateTime=parseDateTime;function parseDateTime(value,options={}){if(!value){return false;}
const fmt=options.format||localization.dateTimeFormat;const parseOpts={setZone:true,zone:options.tz||"default",};const switchToLatin=Settings.defaultNumberingSystem!=="latn"&&/[0-9]/.test(value);if(switchToLatin){parseOpts.numberingSystem="latn";}
let result=DateTime.fromFormat(value,fmt,parseOpts);if(!isValidDate(result)){result=parseSmartDateInput(value);}
if(!isValidDate(result)){const fmtWoZero=stripAlphaDupes(fmt);result=DateTime.fromFormat(value,fmtWoZero,parseOpts);}
if(!isValidDate(result)){const digitList=value.split(nonDigitRegex).filter(Boolean);const fmtList=fmt.split(nonAlphaRegex).filter(Boolean);const valWoSeps=digitList.join("");let carry=0;const fmtWoSeps=fmtList.map((part,i)=>{const digitLength=(digitList[i]||"").length;const actualPart=part.slice(0,digitLength+carry);carry+=digitLength-actualPart.length;return actualPart;}).join("");result=DateTime.fromFormat(valWoSeps,fmtWoSeps,parseOpts);}
if(!isValidDate(result)){const valueDigits=value.replace(nonDigitRegex,"");if(valueDigits.length>4){result=DateTime.fromISO(value,parseOpts);if(!isValidDate(result)){result=DateTime.fromSQL(value,parseOpts);}}}
if(!isValidDate(result)){throw new ConversionError(_t("'%s' is not a correct date or datetime",value));}
if(switchToLatin){result=result.reconfigure({numberingSystem:Settings.defaultNumberingSystem,});}
return result.setZone(options.tz||"default");}
__exports.deserializeDate=deserializeDate;function deserializeDate(value,options={}){options={numberingSystem:"latn",zone:"default",...options};return DateTime.fromSQL(value,options).reconfigure({numberingSystem:Settings.defaultNumberingSystem,});}
__exports.deserializeDateTime=deserializeDateTime;function deserializeDateTime(value,options={}){return DateTime.fromSQL(value,{numberingSystem:"latn",zone:"utc"}).setZone(options?.tz||"default").reconfigure({numberingSystem:Settings.defaultNumberingSystem,});}
return __exports;});;

/* /web/static/src/core/l10n/localization.js */
odoo.define('@web/core/l10n/localization',[],function(require){'use strict';let __exports={};const localization=__exports.localization=new Proxy({},{get:(target,p)=>{if(p in target||p==="then"){return Reflect.get(target,p);}
throw new Error(`could not access localization parameter "${p}": parameters are not ready yet. Maybe add 'localization' to your dependencies?`);},});return __exports;});;

/* /web/static/src/core/l10n/localization_service.js */
odoo.define('@web/core/l10n/localization_service',['@web/session','@web/core/l10n/utils','@web/core/user','@web/core/browser/browser','@web/core/registry','@web/core/l10n/dates','@web/core/l10n/localization','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{session}=require("@web/session");const{jsToPyLocale}=require("@web/core/l10n/utils");const{user}=require("@web/core/user");const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{strftimeToLuxonFormat}=require("@web/core/l10n/dates");const{localization}=require("@web/core/l10n/localization");const{translatedTerms,translationLoaded,translationIsReady}=require("@web/core/l10n/translation");const{Settings}=luxon;const NUMBERING_SYSTEMS=[[/^ar-(sa|sy|001)$/i,"arab"],[/^bn/i,"beng"],[/^bo/i,"tibt"],[/^pa-in/i,"guru"],[/^ta/i,"tamldec"],[/.*/i,"latn"],];const localizationService=__exports.localizationService={start:async()=>{const cacheHashes=session.cache_hashes||{};const translationsHash=cacheHashes.translations||new Date().getTime().toString();const lang=jsToPyLocale(user.lang||document.documentElement.getAttribute("lang"));const translationURL=session.translationURL||"/web/webclient/translations";let url=`${translationURL}/${translationsHash}`;if(lang){url+=`?lang=${lang}`;}
const response=await browser.fetch(url);if(!response.ok){throw new Error("Error while fetching translations");}
const{lang_parameters:userLocalization,modules:modules,multi_lang:multiLang,}=await response.json();const terms={};for(const addon of Object.keys(modules)){for(const message of modules[addon].messages){terms[message.id]=message.string;}}
Object.assign(translatedTerms,terms);translatedTerms[translationLoaded]=true;translationIsReady.resolve(true);const locale=user.lang||browser.navigator.language;Settings.defaultLocale=locale;for(const[re,numberingSystem]of NUMBERING_SYSTEMS){if(re.test(locale)){Settings.defaultNumberingSystem=numberingSystem;break;}}
const dateFormat=strftimeToLuxonFormat(userLocalization.date_format);const timeFormat=strftimeToLuxonFormat(userLocalization.time_format);const shortTimeFormat=strftimeToLuxonFormat(userLocalization.short_time_format);const dateTimeFormat=`${dateFormat} ${timeFormat}`;const grouping=JSON.parse(userLocalization.grouping);Object.assign(localization,{dateFormat,timeFormat,shortTimeFormat,dateTimeFormat,decimalPoint:userLocalization.decimal_point,direction:userLocalization.direction,grouping,multiLang,thousandsSep:userLocalization.thousands_sep,weekStart:userLocalization.week_start,code:jsToPyLocale(locale),});return localization;},};registry.category("services").add("localization",localizationService);return __exports;});;

/* /web/static/src/core/l10n/translation.js */
odoo.define('@web/core/l10n/translation',['@odoo/owl','@web/core/utils/concurrency','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{markup}=require("@odoo/owl");const{Deferred}=require("@web/core/utils/concurrency");const{escape,sprintf}=require("@web/core/utils/strings");const translationLoaded=__exports.translationLoaded=Symbol("translationLoaded");const translatedTerms=__exports.translatedTerms={[translationLoaded]:false,};const translationIsReady=__exports.translationIsReady=new Deferred();const Markup=markup().constructor;__exports._t=_t;function _t(term,...values){if(translatedTerms[translationLoaded]){const translation=translatedTerms[term]??term;if(values.length===0){return translation;}
return _safeSprintf(translation,...values);}else{return new LazyTranslatedString(term,values);}}
class LazyTranslatedString extends String{constructor(term,values){super(term);this.values=values;}
valueOf(){const term=super.valueOf();if(translatedTerms[translationLoaded]){const translation=translatedTerms[term]??term;if(this.values.length===0){return translation;}
return _safeSprintf(translation,...this.values);}else{throw new Error(`translation error`);}}
toString(){return this.valueOf();}}
_t("less than a minute ago");_t("about a minute ago");_t("%d minutes ago");_t("about an hour ago");_t("%d hours ago");_t("a day ago");_t("%d days ago");_t("about a month ago");_t("%d months ago");_t("about a year ago");_t("%d years ago");__exports.loadLanguages=loadLanguages;async function loadLanguages(orm){if(!loadLanguages.installedLanguages){loadLanguages.installedLanguages=await orm.call("res.lang","get_installed");}
return loadLanguages.installedLanguages;}
function _safeSprintf(str,...values){let hasMarkup;if(values.length===1&&Object.prototype.toString.call(values[0])==="[object Object]"){hasMarkup=Object.values(values[0]).some((v)=>v instanceof Markup);}else{hasMarkup=values.some((v)=>v instanceof Markup);}
if(hasMarkup){return markup(sprintf(escape(str),..._escapeNonMarkup(values)));}
return sprintf(str,...values);}
function _escapeNonMarkup(values){if(Object.prototype.toString.call(values[0])==="[object Object]"){const sanitized={};for(const[key,value]of Object.entries(values[0])){sanitized[key]=value instanceof Markup?value:escape(value);}
return[sanitized];}
return values.map((x)=>(x instanceof Markup?x:escape(x)));}
return __exports;});;

/* /web/static/src/core/l10n/utils.js */
odoo.define('@web/core/l10n/utils',['@web/core/l10n/utils/format_list','@web/core/l10n/utils/locales'],function(require){'use strict';let __exports={};Object.assign(__exports,require("@web/core/l10n/utils/format_list"));Object.assign(__exports,require("@web/core/l10n/utils/locales"));return __exports;});;

/* /web/static/src/core/l10n/utils/format_list.js */
odoo.define('@web/core/l10n/utils/format_list',['@web/core/user'],function(require){'use strict';let __exports={};const{user}=require("@web/core/user");const LIST_STYLES={standard:{type:"conjunction",style:"long",},"standard-short":{type:"conjunction",style:"short",},or:{type:"disjunction",style:"long",},"or-short":{type:"disjunction",style:"short",},unit:{type:"unit",style:"long",},"unit-short":{type:"unit",style:"short",},"unit-narrow":{type:"unit",style:"narrow",},};__exports.formatList=formatList;function formatList(list,{localeCode="",style="standard"}={}){const locale=localeCode||user.lang||"en-US";const formatter=new Intl.ListFormat(locale,LIST_STYLES[style]);return formatter.format(list);}
return __exports;});;

/* /web/static/src/core/l10n/utils/locales.js */
odoo.define('@web/core/l10n/utils/locales',[],function(require){'use strict';let __exports={};__exports.jsToPyLocale=jsToPyLocale;function jsToPyLocale(locale){if(!locale){return"";}
try{var{language,script,region}=new Intl.Locale(locale);if(language==="fil"){language="tl";}}catch{return locale;}
let xpgLocale=language;if(region){xpgLocale+=`_${region}`;}
switch(script){case"Cyrl":xpgLocale+="@Cyrl";break;case"Latn":xpgLocale+="@latin";break;}
return xpgLocale;}
__exports.pyToJsLocale=pyToJsLocale;function pyToJsLocale(locale){if(!locale){return"";}
const regex=/^([a-z]+)(_[A-Z\d]+)?(@.+)?$/;const match=locale.match(regex);if(!match){return locale;}
const[,language,territory,modifier]=match;const subtags=[language];switch(modifier){case"@Cyrl":subtags.push("Cyrl");break;case"@latin":subtags.push("Latn");break;}
if(territory){subtags.push(territory.slice(1));}
return subtags.join("-");}
return __exports;});;

/* /web/static/src/core/macro.js */
odoo.define('@web/core/macro',['@web/core/utils/ui','@web/core/utils/concurrency','@odoo/owl'],function(require){'use strict';let __exports={};const{isVisible}=require("@web/core/utils/ui");const{delay}=require("@web/core/utils/concurrency");const{validate}=require("@odoo/owl");const macroSchema={name:{type:String,optional:true},timeout:{type:Number,optional:true},steps:{type:Array,element:{type:Object,shape:{action:{type:[Function,String],optional:true},timeout:{type:Number,optional:true},trigger:{type:[Function,String],optional:true},},validate:(step)=>step.action||step.trigger,},},onComplete:{type:Function,optional:true},onStep:{type:Function,optional:true},onError:{type:Function,optional:true},};class MacroError extends Error{constructor(type,message,options){super(message,options);this.type=type;}}
async function performAction(trigger,action){if(!action){return;}
try{return await action(trigger);}catch(error){throw new MacroError("Action",`ERROR during perform action:\n${error.message}`,{cause:error,});}}
__exports.waitForStable=waitForStable;async function waitForStable(target=document,timeout=1000/16){return new Promise((resolve)=>{let observer;let timer;const mutationList=[];function onMutation(mutations){mutationList.push(...(mutations||[]));clearTimeout(timer);timer=setTimeout(()=>{observer.disconnect();resolve(mutationList);},timeout);}
observer=new MacroMutationObserver(onMutation);observer.observe(target);onMutation([]);});}
async function waitForTrigger(trigger){if(!trigger){return;}
try{await delay(50);return await waitUntil(()=>{if(typeof trigger==="function"){return trigger();}else if(typeof trigger==="string"){const triggerEl=document.querySelector(trigger);return isVisible(triggerEl)&&triggerEl;}});}catch(error){throw new MacroError("Trigger",`ERROR during find trigger:\n${error.message}`,{cause:error,});}}
async function waitUntil(predicate){const result=predicate();if(result){return Promise.resolve(result);}
let handle;return new Promise((resolve)=>{const runCheck=()=>{const result=predicate();if(result){resolve(result);}
handle=requestAnimationFrame(runCheck);};handle=requestAnimationFrame(runCheck);}).finally(()=>{cancelAnimationFrame(handle);});}
const Macro=__exports.Macro=class Macro{currentIndex=0;isComplete=false;constructor(descr){try{validate(descr,macroSchema);}catch(error){throw new Error(`Error in schema for Macro ${JSON.stringify(descr, null, 4)}\n${error.message}`);}
Object.assign(this,descr);this.onComplete=this.onComplete||(()=>{});this.onStep=this.onStep||(()=>{});this.onError=this.onError||((error,step,index)=>{console.error(error.message,step,index);});}
async start(){await this.advance();}
async advance(){if(this.isComplete||this.currentIndex>=this.steps.length){this.stop();return;}
try{const currentStep=this.steps[this.currentIndex];const executeStep=async()=>{const trigger=await waitForTrigger(currentStep.trigger);await this.onStep(currentStep,trigger,this.currentIndex);return await performAction(trigger,currentStep.action);};const launchTimer=async()=>{const timeout_delay=currentStep.timeout||this.timeout||10000;await delay(timeout_delay);throw new MacroError("Timeout",`TIMEOUT step failed to complete within ${timeout_delay} ms.`);};const actionResult=await Promise.race([executeStep(),launchTimer()]);if(actionResult){this.stop();return;}}catch(error){this.stop(error);return;}
this.currentIndex++;await this.advance();}
stop(error){if(this.isComplete){return;}
this.isComplete=true;if(error){this.onError(error,this.steps[this.currentIndex],this.currentIndex);}else if(this.currentIndex===this.steps.length){this.onComplete();}}}
const MacroMutationObserver=__exports.MacroMutationObserver=class MacroMutationObserver{observerOptions={attributes:true,childList:true,subtree:true,characterData:true,};constructor(callback){this.callback=callback;this.observer=new MutationObserver((mutationList,observer)=>{callback(mutationList);mutationList.forEach((mutationRecord)=>Array.from(mutationRecord.addedNodes).forEach((node)=>{let iframes=[];if(String(node.tagName).toLowerCase()==="iframe"){iframes=[node];}else if(node instanceof HTMLElement){iframes=Array.from(node.querySelectorAll("iframe"));}
iframes.forEach((iframeEl)=>this.observeIframe(iframeEl,observer,()=>callback()));this.findAllShadowRoots(node).forEach((shadowRoot)=>observer.observe(shadowRoot,this.observerOptions));}));});}
disconnect(){this.observer.disconnect();}
findAllShadowRoots(node,shadowRoots=[]){if(node.shadowRoot){shadowRoots.push(node.shadowRoot);this.findAllShadowRoots(node.shadowRoot,shadowRoots);}
node.childNodes.forEach((child)=>{this.findAllShadowRoots(child,shadowRoots);});return shadowRoots;}
observe(target){this.observer.observe(target,this.observerOptions);target.querySelectorAll("iframe").forEach((el)=>this.observeIframe(el,this.observer,()=>this.callback()));this.findAllShadowRoots(target).forEach((shadowRoot)=>{this.observer.observe(shadowRoot,this.observerOptions);});}
observeIframe(iframeEl,observer,callback){const observerOptions={attributes:true,childList:true,subtree:true,characterData:true,};const observeIframeContent=()=>{if(iframeEl.contentDocument){iframeEl.contentDocument.addEventListener("load",(event)=>{callback();observer.observe(event.target,observerOptions);});if(!iframeEl.src||iframeEl.contentDocument.readyState==="complete"){callback();observer.observe(iframeEl.contentDocument,observerOptions);}}};observeIframeContent();iframeEl.addEventListener("load",observeIframeContent);}}
return __exports;});;

/* /web/static/src/core/main_components_container.js */
odoo.define('@web/core/main_components_container',['@odoo/owl','@web/core/registry','@web/core/registry_hook','@web/core/utils/components'],function(require){'use strict';let __exports={};const{Component,xml}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{useRegistry}=require("@web/core/registry_hook");const{ErrorHandler}=require("@web/core/utils/components");const mainComponents=registry.category("main_components");mainComponents.addValidation({Component:{validate:(c)=>c.prototype instanceof Component},props:{type:Object,optional:true}});const MainComponentsContainer=__exports.MainComponentsContainer=class MainComponentsContainer extends Component{static components={ErrorHandler};static props={};static template=xml`
    <div class="o-main-components-container">
        <t t-foreach="Components.entries" t-as="C" t-key="C[0]">
            <ErrorHandler onError="error => this.handleComponentError(error, C)">
                <t t-component="C[1].Component" t-props="C[1].props"/>
            </ErrorHandler>
        </t>
    </div>
    `;setup(){this.Components=useRegistry(mainComponents);}
handleComponentError(error,C){this.Components.entries.splice(this.Components.entries.indexOf(C),1);this.render();Promise.resolve().then(()=>{throw error;});}}
return __exports;});;

/* /web/static/src/core/model_field_selector/model_field_selector.js */
odoo.define('@web/core/model_field_selector/model_field_selector',['@odoo/owl','@web/core/utils/concurrency','@web/core/model_field_selector/model_field_selector_popover','@web/core/model_field_selector/utils','@web/core/popover/popover_hook'],function(require){'use strict';let __exports={};const{Component,onWillStart,onWillUpdateProps,useState}=require("@odoo/owl");const{KeepLast}=require("@web/core/utils/concurrency");const{ModelFieldSelectorPopover}=require("@web/core/model_field_selector/model_field_selector_popover");const{useLoadFieldInfo,useLoadPathDescription}=require("@web/core/model_field_selector/utils");const{usePopover}=require("@web/core/popover/popover_hook");const ModelFieldSelector=__exports.ModelFieldSelector=class ModelFieldSelector extends Component{static template="web._ModelFieldSelector";static components={Popover:ModelFieldSelectorPopover,};static props={resModel:String,path:{optional:true},allowEmpty:{type:Boolean,optional:true},readonly:{type:Boolean,optional:true},showSearchInput:{type:Boolean,optional:true},isDebugMode:{type:Boolean,optional:true},update:{type:Function,optional:true},filter:{type:Function,optional:true},followRelations:{type:Boolean,optional:true},showDebugInput:{type:Boolean,optional:true},};static defaultProps={readonly:true,allowEmpty:false,isDebugMode:false,showSearchInput:true,update:()=>{},followRelations:true,};setup(){this.loadPathDescription=useLoadPathDescription();const loadFieldInfo=useLoadFieldInfo();this.popover=usePopover(this.constructor.components.Popover,{popoverClass:"o_popover_field_selector",onClose:async()=>{if(this.newPath!==null){const fieldInfo=await loadFieldInfo(this.props.resModel,this.newPath);this.props.update(this.newPath,fieldInfo);}},});this.keepLast=new KeepLast();this.state=useState({isInvalid:false,displayNames:[]});onWillStart(()=>this.updateState(this.props));onWillUpdateProps((nextProps)=>this.updateState(nextProps));}
openPopover(currentTarget){if(this.props.readonly){return;}
this.newPath=null;this.popover.open(currentTarget,{resModel:this.props.resModel,path:this.props.path,update:(path,_fieldInfo,debug=false)=>{this.newPath=path;if(!debug){this.updateState({...this.props,path},true);}},showSearchInput:this.props.showSearchInput,isDebugMode:this.props.isDebugMode,filter:this.props.filter,followRelations:this.props.followRelations,showDebugInput:this.props.showDebugInput,});}
async updateState(params,isConcurrent){const{resModel,path,allowEmpty}=params;let prom=this.loadPathDescription(resModel,path,allowEmpty);if(isConcurrent){prom=this.keepLast.add(prom);}
const state=await prom;Object.assign(this.state,state);}
clear(){if(this.popover.isOpen){this.newPath="";this.popover.close();return;}
this.props.update("",{resModel:this.props.resModel,fieldDef:null});}}
return __exports;});;

/* /web/static/src/core/model_field_selector/model_field_selector_popover.js */
odoo.define('@web/core/model_field_selector/model_field_selector_popover',['@odoo/owl','@web/core/utils/timing','@web/core/l10n/translation','@web/core/utils/search','@web/core/utils/concurrency','@web/core/utils/arrays','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,onWillStart,useEffect,useRef,useState}=require("@odoo/owl");const{debounce}=require("@web/core/utils/timing");const{_t}=require("@web/core/l10n/translation");const{fuzzyLookup}=require("@web/core/utils/search");const{KeepLast}=require("@web/core/utils/concurrency");const{sortBy}=require("@web/core/utils/arrays");const{useService}=require("@web/core/utils/hooks");class Page{constructor(resModel,fieldDefs,options={}){this.resModel=resModel;this.fieldDefs=fieldDefs;const{previousPage=null,selectedName=null,isDebugMode}=options;this.previousPage=previousPage;this.selectedName=selectedName;this.isDebugMode=isDebugMode;this.sortedFieldNames=sortBy(Object.keys(fieldDefs),(key)=>fieldDefs[key].string);this.fieldNames=this.sortedFieldNames;this.query="";this.focusedFieldName=null;this.resetFocusedFieldName();}
get path(){const previousPath=this.previousPage?.path||"";if(this.selectedName){if(previousPath){return`${previousPath}.${this.selectedName}`;}else{return this.selectedName;}}
return previousPath;}
get selectedField(){return this.fieldDefs[this.selectedName];}
get title(){const prefix=this.previousPage?.previousPage?"... > ":"";const title=this.previousPage?.selectedField?.string||"";if(prefix.length||title.length){return`${prefix}${title}`;}
return _t("Select a field");}
focus(direction){if(!this.fieldNames.length){return;}
const index=this.fieldNames.indexOf(this.focusedFieldName);if(direction==="previous"){if(index===0){this.focusedFieldName=this.fieldNames[this.fieldNames.length-1];}else{this.focusedFieldName=this.fieldNames[index-1];}}else{if(index===this.fieldNames.length-1){this.focusedFieldName=this.fieldNames[0];}else{this.focusedFieldName=this.fieldNames[index+1];}}}
resetFocusedFieldName(){if(this.selectedName&&this.fieldNames.includes(this.selectedName)){this.focusedFieldName=this.selectedName;}else{this.focusedFieldName=this.fieldNames.length?this.fieldNames[0]:null;}}
searchFields(query=""){this.query=query;this.fieldNames=this.sortedFieldNames;if(query){this.fieldNames=fuzzyLookup(query,this.fieldNames,(key)=>{const vals=[this.fieldDefs[key].string];if(this.isDebugMode){vals.push(key);}
return vals;});}
this.resetFocusedFieldName();}}
const ModelFieldSelectorPopover=__exports.ModelFieldSelectorPopover=class ModelFieldSelectorPopover extends Component{static template="web.ModelFieldSelectorPopover";static props={close:Function,filter:{type:Function,optional:true},followRelations:{type:Boolean,optional:true},showDebugInput:{type:Boolean,optional:true},isDebugMode:{type:Boolean,optional:true},path:{optional:true},resModel:String,showSearchInput:{type:Boolean,optional:true},update:Function,};static defaultProps={filter:(value)=>value.searchable&&value.type!="json",isDebugMode:false,followRelations:true,};setup(){this.fieldService=useService("field");this.state=useState({page:null});this.keepLast=new KeepLast();this.debouncedSearchFields=debounce(this.searchFields.bind(this),250);onWillStart(async()=>{this.state.page=await this.loadPages(this.props.resModel,this.props.path);});const rootRef=useRef("root");useEffect(()=>{const focusedElement=rootRef.el.querySelector(".o_model_field_selector_popover_item.active");if(focusedElement){focusedElement.scrollIntoView({block:"center"});}});useEffect(()=>{if(this.props.showSearchInput){const searchInput=rootRef.el.querySelector(".o_model_field_selector_popover_search .o_input");searchInput.focus();}},()=>[this.state.page]);}
get showDebugInput(){return this.props.showDebugInput??this.props.isDebugMode;}
filter(fieldDefs,path){const filteredKeys=Object.keys(fieldDefs).filter((k)=>this.props.filter(fieldDefs[k],path));return Object.fromEntries(filteredKeys.map((k)=>[k,fieldDefs[k]]));}
async followRelation(fieldDef){const{modelsInfo}=await this.keepLast.add(this.fieldService.loadPath(this.state.page.resModel,`${fieldDef.name}.*`));this.state.page.selectedName=fieldDef.name;const{resModel,fieldDefs}=modelsInfo.at(-1);this.openPage(new Page(resModel,this.filter(fieldDefs,this.state.page.path),{previousPage:this.state.page,isDebugMode:this.props.isDebugMode,}));}
goToPreviousPage(){this.keepLast.add(Promise.resolve());this.openPage(this.state.page.previousPage);}
async loadNewPath(path){const newPage=await this.keepLast.add(this.loadPages(this.props.resModel,path));this.openPage(newPage);}
async loadPages(resModel,path){if(typeof path!=="string"||!path.length){const fieldDefs=await this.fieldService.loadFields(resModel);return new Page(resModel,this.filter(fieldDefs,path),{isDebugMode:this.props.isDebugMode,});}
const{isInvalid,modelsInfo,names}=await this.fieldService.loadPath(resModel,path);switch(isInvalid){case"model":throw new Error(`Invalid model name: ${resModel}`);case"path":{const{resModel,fieldDefs}=modelsInfo[0];return new Page(resModel,this.filter(fieldDefs,path),{selectedName:path,isDebugMode:this.props.isDebugMode,});}
default:{let page=null;for(let index=0;index<names.length;index++){const name=names[index];const{resModel,fieldDefs}=modelsInfo[index];page=new Page(resModel,this.filter(fieldDefs,path),{previousPage:page,selectedName:name,isDebugMode:this.props.isDebugMode,});}
return page;}}}
openPage(page){this.state.page=page;this.state.page.searchFields();this.props.update(page.path);}
searchFields(query){this.state.page.searchFields(query);}
selectField(field){if(field.type==="properties"){return this.followRelation(field);}
this.keepLast.add(Promise.resolve());this.state.page.selectedName=field.name;this.props.update(this.state.page.path,field);this.props.close(true);}
onDebugInputKeydown(ev){switch(ev.key){case"Enter":{ev.preventDefault();ev.stopPropagation();this.loadNewPath(ev.currentTarget.value);break;}}}
async onInputKeydown(ev){const{page}=this.state;switch(ev.key){case"ArrowUp":{if(ev.target.selectionStart===0){page.focus("previous");}
break;}
case"ArrowDown":{if(ev.target.selectionStart===page.query.length){page.focus("next");}
break;}
case"ArrowLeft":{if(ev.target.selectionStart===0&&page.previousPage){this.goToPreviousPage();}
break;}
case"ArrowRight":{if(ev.target.selectionStart===page.query.length){const focusedFieldName=this.state.page.focusedFieldName;if(focusedFieldName){const fieldDef=this.state.page.fieldDefs[focusedFieldName];if(fieldDef.relation||fieldDef.type==="properties"){this.followRelation(fieldDef);}}}
break;}
case"Enter":{const focusedFieldName=this.state.page.focusedFieldName;if(focusedFieldName){const fieldDef=this.state.page.fieldDefs[focusedFieldName];this.selectField(fieldDef);}else{ev.preventDefault();ev.stopPropagation();}
break;}
case"Escape":{ev.preventDefault();ev.stopPropagation();this.props.close();break;}}}}
return __exports;});;

/* /web/static/src/core/model_field_selector/utils.js */
odoo.define('@web/core/model_field_selector/utils',['@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");function makeString(value){return String(value??"-");}
__exports.useLoadFieldInfo=useLoadFieldInfo;function useLoadFieldInfo(fieldService){fieldService||=useService("field");return async(resModel,path)=>{if(typeof path!=="string"||!path){return{resModel,fieldDef:null};}
const{isInvalid,names,modelsInfo}=await fieldService.loadPath(resModel,path);if(isInvalid){return{resModel,fieldDef:null};}
const name=names.at(-1);const modelInfo=modelsInfo.at(-1);return{resModel:modelInfo.resModel,fieldDef:modelInfo.fieldDefs[name]};};}
__exports.useLoadPathDescription=useLoadPathDescription;function useLoadPathDescription(fieldService){fieldService||=useService("field");return async(resModel,path,allowEmpty)=>{if([0,1].includes(path)){return{isInvalid:false,displayNames:[makeString(path)]};}
if(allowEmpty&&!path){return{isInvalid:false,displayNames:[]};}
if(typeof path!=="string"||!path){return{isInvalid:true,displayNames:[makeString()]};}
const{isInvalid,modelsInfo,names}=await fieldService.loadPath(resModel,path);const result={isInvalid:!!isInvalid,displayNames:[]};if(!isInvalid){const lastName=names.at(-1);const lastFieldDef=modelsInfo.at(-1).fieldDefs[lastName];if(["properties","properties_definition"].includes(lastFieldDef.type)){result.isInvalid=true;}}
for(let index=0;index<names.length;index++){const name=names[index];const fieldDef=modelsInfo[index]?.fieldDefs[name];result.displayNames.push(fieldDef?.string||makeString(name));}
return result;};}
return __exports;});;

/* /web/static/src/core/model_selector/model_selector.js */
odoo.define('@web/core/model_selector/model_selector',['@web/core/autocomplete/autocomplete','@web/core/utils/hooks','@web/core/utils/search','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{AutoComplete}=require("@web/core/autocomplete/autocomplete");const{useService}=require("@web/core/utils/hooks");const{fuzzyLookup}=require("@web/core/utils/search");const{_t}=require("@web/core/l10n/translation");const{Component,onWillStart}=require("@odoo/owl");const ModelSelector=__exports.ModelSelector=class ModelSelector extends Component{static template="web.ModelSelector";static components={AutoComplete};static props={onModelSelected:Function,id:{type:String,optional:true},value:{type:String,optional:true},models:{type:Array,optional:true},};setup(){this.orm=useService("orm");onWillStart(async()=>{if(!this.props.models){this.models=await this._fetchAvailableModels();}else{this.models=await this.orm.call("ir.model","display_name_for",[this.props.models,]);}
this.models=this.models.map((record)=>({label:record.display_name,technical:record.model,classList:{[`o_model_selector_${record.model}`]:1,},}));});}
get sources(){return[this.optionsSource];}
get optionsSource(){return{placeholder:_t("Loading..."),options:this.loadOptionsSource.bind(this),};}
onSelect(option){this.props.onModelSelected({label:option.label,technical:option.technical,});}
filterModels(name){if(!name){const visibleModels=this.models.slice(0,8);if(this.models.length-visibleModels.length>0){visibleModels.push({label:_t("Start typing..."),unselectable:true,classList:"o_m2o_start_typing",});}
return visibleModels;}
return fuzzyLookup(name,this.models,(model)=>model.technical+model.label);}
loadOptionsSource(request){const options=this.filterModels(request);if(!options.length){options.push({label:_t("No records"),classList:"o_m2o_no_result",unselectable:true,});}
return options;}
async _fetchAvailableModels(){const result=await this.orm.call("ir.model","get_available_models");return result||[];}}
return __exports;});;

/* /web/static/src/core/name_service.js */
odoo.define('@web/core/name_service',['@web/core/registry','@web/core/utils/arrays','@web/core/utils/concurrency'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{unique,zip}=require("@web/core/utils/arrays");const{Deferred}=require("@web/core/utils/concurrency");const ERROR_INACCESSIBLE_OR_MISSING=__exports.ERROR_INACCESSIBLE_OR_MISSING=Symbol("INACCESSIBLE OR MISSING RECORD ID");function isId(val){return Number.isInteger(val)&&val>=1;}
const nameService=__exports.nameService={dependencies:["orm"],async:["loadDisplayNames"],start(env,{orm}){let cache={};const batches={};function clearCache(){cache={};}
env.bus.addEventListener("ACTION_MANAGER:UPDATE",clearCache);function getMapping(resModel){if(!cache[resModel]){cache[resModel]={};}
return cache[resModel];}
function addDisplayNames(resModel,displayNames){const mapping=getMapping(resModel);for(const resId in displayNames){mapping[resId]=new Deferred();mapping[resId].resolve(displayNames[resId]);}}
async function loadDisplayNames(resModel,resIds){const mapping=getMapping(resModel);const proms=[];const resIdsToFetch=[];for(const resId of unique(resIds)){if(!isId(resId)){throw new Error(`Invalid ID: ${resId}`);}
if(!(resId in mapping)){mapping[resId]=new Deferred();resIdsToFetch.push(resId);}
proms.push(mapping[resId]);}
if(resIdsToFetch.length){if(batches[resModel]){batches[resModel].push(...resIdsToFetch);}else{batches[resModel]=resIdsToFetch;await Promise.resolve();const idsInBatch=unique(batches[resModel]);delete batches[resModel];const specification={display_name:{}};orm.silent.webSearchRead(resModel,[["id","in",idsInBatch]],{specification}).then(({records})=>{const displayNames=Object.fromEntries(records.map((rec)=>[rec.id,rec.display_name]));for(const resId of idsInBatch){mapping[resId].resolve(resId in displayNames?displayNames[resId]:ERROR_INACCESSIBLE_OR_MISSING);}});}}
const names=await Promise.all(proms);return Object.fromEntries(zip(resIds,names));}
return{addDisplayNames,clearCache,loadDisplayNames};},};registry.category("services").add("name",nameService);return __exports;});;

/* /web/static/src/core/navigation/navigation.js */
odoo.define('@web/core/navigation/navigation',['@odoo/owl','@web/core/utils/hooks','@web/core/utils/scrolling','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{useEffect,useRef}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{scrollTo}=require("@web/core/utils/scrolling");const{debounce,throttleForAnimation}=require("@web/core/utils/timing");const ACTIVE_ELEMENT_CLASS="focus";const throttledElementFocus=throttleForAnimation((el)=>el?.focus());function focusElement(el){throttledElementFocus.cancel();throttledElementFocus(el);}
class NavigationItem{constructor({index,el,setActiveItem,options}){this.index=index;this.options=options;this.setActiveItem=setActiveItem;this.el=el;if(options.shouldFocusChildInput){const subInput=el.querySelector(":scope input, :scope button, :scope textarea");this.target=subInput||el;}else{this.target=el;}
const focus=()=>this.focus(true);const onMouseEnter=(ev)=>this.onMouseEnter(ev);this.target.addEventListener("focus",focus);this.target.addEventListener("mouseenter",onMouseEnter);this.removeListeners=()=>{this.target.removeEventListener("focus",focus);this.target.removeEventListener("mouseenter",onMouseEnter);};}
select(){this.focus();this.target.click();}
focus(skipRealFocus=false){scrollTo(this.target);this.setActiveItem(this.index,this);this.target.classList.add(ACTIVE_ELEMENT_CLASS);if(!skipRealFocus&&!this.options.virtualFocus){focusElement(this.target);}}
defocus(){this.target.classList.remove(ACTIVE_ELEMENT_CLASS);}
onMouseEnter(){this.focus(true);this.options.onMouseEnter?.(this);}}
class Navigator{constructor(containerRef,options,hotkeyService){this.enabled=false;this.containerRef=containerRef;const focusAt=(increment)=>{const isFocused=this.activeItem?.el.isConnected;const index=this.currentActiveIndex+increment;if(isFocused&&index>=0){return this.items[index%this.items.length]?.focus();}else if(!isFocused&&increment>=0){return this.items[0]?.focus();}else{return this.items.at(-1)?.focus();}};this.options={shouldFocusChildInput:true,virtualFocus:false,itemsSelector:":scope .o-navigable",focusInitialElementOnDisabled:()=>true,...options,hotkeys:{home:(index,items)=>items[0]?.focus(),end:(index,items)=>items.at(-1)?.focus(),tab:()=>focusAt(+1),"shift+tab":()=>focusAt(-1),arrowdown:()=>focusAt(+1),arrowup:()=>focusAt(-1),enter:(index,items)=>{const item=items[index]||items[0];item?.select();},...(options?.hotkeys||{}),},};this.items=[];this.activeItem=undefined;this.currentActiveIndex=-1;this.initialFocusElement=undefined;this.debouncedUpdate=debounce(()=>this.update(),100);this.hotkeyRemoves=[];this.hotkeyService=hotkeyService;this.allowedInEditableHotkeys=["arrowup","arrowdown","enter","tab","shift+tab"];}
enable(){if(!this.containerRef.el||this.targetObserver){return;}
for(const[hotkey,callback]of Object.entries(this.options.hotkeys)){if(!callback){continue;}
this.hotkeyRemoves.push(this.hotkeyService.add(hotkey,()=>callback(this.currentActiveIndex,this.items),{allowRepeat:true,bypassEditableProtection:this.allowedInEditableHotkeys.includes(hotkey),}));}
this.targetObserver=new MutationObserver(()=>this.debouncedUpdate());this.targetObserver.observe(this.containerRef.el,{childList:true,subtree:true,});this.initialFocusElement=document.activeElement;this.currentActiveIndex=-1;this.update();if(this.options.onEnabled){this.options.onEnabled(this.items);}else if(this.items.length>0){this.items[0]?.focus();}
this.enabled=true;}
disable(){if(!this.enabled){return;}
if(this.targetObserver){this.targetObserver.disconnect();this.targetObserver=undefined;}
this.clearItems();for(const removeHotkey of this.hotkeyRemoves){removeHotkey();}
this.hotkeyRemoves=[];if(this.options.focusInitialElementOnDisabled()){focusElement(this.initialFocusElement);}
this.enabled=false;}
update(){if(!this.containerRef.el){return;}
const oldItemsLength=this.items.length;this.clearItems();const elements=[...this.containerRef.el.querySelectorAll(this.options.itemsSelector)];this.items=elements.map((el,index)=>{return new NavigationItem({index,el,options:this.options,setActiveItem:(index,el)=>this.setActiveItem(index,el),});});if(oldItemsLength!=this.items.length&&this.currentActiveIndex>=this.items.length){this.items.at(-1)?.focus();}}
setActiveItem(index,item){if(this.activeItem){this.activeItem.el.classList.remove(ACTIVE_ELEMENT_CLASS);}
this.activeItem=item;this.currentActiveIndex=index;}
clearItems(){for(const item of this.items){item.removeListeners();}
this.items=[];}}
__exports.useNavigation=useNavigation;function useNavigation(containerRef,options={}){const hotkeyService=useService("hotkey");containerRef=typeof containerRef==="string"?useRef(containerRef):containerRef;const navigator=new Navigator(containerRef,options,hotkeyService);useEffect((container)=>{if(container){navigator.enable();}else if(navigator){navigator.disable();}},()=>[containerRef.el]);return{enable:()=>navigator.enable(),disable:()=>navigator.disable(),};}
return __exports;});;

/* /web/static/src/core/network/download.js */
odoo.define('@web/core/network/download',['@web/core/l10n/translation','@web/core/network/rpc','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{makeErrorFromResponse,ConnectionLostError}=require("@web/core/network/rpc");const{browser}=require("@web/core/browser/browser");const HEX_ESCAPE_REPLACE_REGEXP=/%([0-9A-Fa-f]{2})/g;const NON_LATIN1_REGEXP=/[^\x20-\x7e\xa0-\xff]/g;const QESC_REGEXP=/\\([\u0000-\u007f])/g;const PARAM_REGEXP=/;[\x09\x20]*([!#$%&'*+.0-9A-Z^_`a-z|~-]+)[\x09\x20]*=[\x09\x20]*("(?:[\x20!\x23-\x5b\x5d-\x7e\x80-\xff]|\\[\x20-\x7e])*"|[!#$%&'*+.0-9A-Z^_`a-z|~-]+)[\x09\x20]*/g;const EXT_VALUE_REGEXP=/^([A-Za-z0-9!#$%&+\-^_`{}~]+)'(?:[A-Za-z]{2,3}(?:-[A-Za-z]{3}){0,3}|[A-Za-z]{4,8}|)'((?:%[0-9A-Fa-f]{2}|[A-Za-z0-9!#$&+.^_`|~-])+)$/;const DISPOSITION_TYPE_REGEXP=/^([!#$%&'*+.0-9A-Z^_`a-z|~-]+)[\x09\x20]*(?:$|;)/;function decodefield(str){const match=EXT_VALUE_REGEXP.exec(str);if(!match){throw new TypeError("invalid extended field value");}
const charset=match[1].toLowerCase();const encoded=match[2];switch(charset){case"iso-8859-1":return encoded.replace(HEX_ESCAPE_REPLACE_REGEXP,pdecode).replace(NON_LATIN1_REGEXP,"?");case"utf-8":return decodeURIComponent(encoded);default:throw new TypeError("unsupported charset in extended field");}}
function parse(string){if(!string||typeof string!=="string"){throw new TypeError("argument string is required");}
let match=DISPOSITION_TYPE_REGEXP.exec(string);if(!match){throw new TypeError("invalid type format");}
let index=match[0].length;const type=match[1].toLowerCase();let key;const names=[];const params={};let value;index=PARAM_REGEXP.lastIndex=match[0].substr(-1)===";"?index-1:index;while((match=PARAM_REGEXP.exec(string))){if(match.index!==index){throw new TypeError("invalid parameter format");}
index+=match[0].length;key=match[1].toLowerCase();value=match[2];if(names.indexOf(key)!==-1){throw new TypeError("invalid duplicate parameter");}
names.push(key);if(key.indexOf("*")+1===key.length){key=key.slice(0,-1);value=decodefield(value);params[key]=value;continue;}
if(typeof params[key]==="string"){continue;}
if(value[0]==='"'){value=value.substr(1,value.length-2).replace(QESC_REGEXP,"$1");}
params[key]=value;}
if(index!==-1&&index!==string.length){throw new TypeError("invalid parameter format");}
return new ContentDisposition(type,params);}
function pdecode(str,hex){return String.fromCharCode(parseInt(hex,16));}
function ContentDisposition(type,parameters){this.type=type;this.parameters=parameters;}
function _download(data,filename,mimetype){let self=window,defaultMime="application/octet-stream",mimeType=mimetype||defaultMime,payload=data,url=!filename&&!mimetype&&payload,anchor=document.createElement("a"),toString=function(a){return String(a);},myBlob=self.Blob||self.MozBlob||self.WebKitBlob||toString,fileName=filename||"download",blob,reader;myBlob=myBlob.call?myBlob.bind(self):Blob;if(String(this)==="true"){payload=[payload,mimeType];mimeType=payload[0];payload=payload[1];}
if(url&&url.length<2048){fileName=url.split("/").pop().split("?")[0];anchor.href=url;if(anchor.href.indexOf(url)!==-1){return new Promise((resolve,reject)=>{let xhr=new browser.XMLHttpRequest();xhr.open("GET",url,true);configureBlobDownloadXHR(xhr,{onSuccess:resolve,onFailure:reject,url});xhr.send();});}}
if(/^data:[\w+\-]+\/[\w+\-]+[,;]/.test(payload)){if(payload.length>1024*1024*1.999&&myBlob!==toString){payload=dataUrlToBlob(payload);mimeType=payload.type||defaultMime;}else{return navigator.msSaveBlob?navigator.msSaveBlob(dataUrlToBlob(payload),fileName):saver(payload);}}
blob=payload instanceof myBlob?payload:new myBlob([payload],{type:mimeType});function dataUrlToBlob(strUrl){let parts=strUrl.split(/[:;,]/),type=parts[1],decoder=parts[2]==="base64"?atob:decodeURIComponent,binData=decoder(parts.pop()),mx=binData.length,i=0,uiArr=new Uint8Array(mx);for(i;i<mx;++i){uiArr[i]=binData.charCodeAt(i);}
return new myBlob([uiArr],{type});}
function saver(url,winMode){if("download"in anchor){anchor.href=url;anchor.setAttribute("download",fileName);anchor.className="download-js-link";anchor.innerText=_t("downloading...");anchor.style.display="none";anchor.target="_blank";document.body.appendChild(anchor);setTimeout(()=>{anchor.click();document.body.removeChild(anchor);if(winMode===true){setTimeout(()=>{self.URL.revokeObjectURL(anchor.href);},250);}},66);return true;}
if(/(Version)\/(\d+)\.(\d+)(?:\.(\d+))?.*Safari\//.test(navigator.userAgent)){url=url.replace(/^data:([\w\/\-+]+)/,defaultMime);if(!window.open(url)){if(confirm("Displaying New Document\n\nUse Save As... to download, then click back to return to this page.")){location.href=url;}}
return true;}
let f=document.createElement("iframe");document.body.appendChild(f);if(!winMode){url=`data:${url.replace(/^data:([\w\/\-+]+)/, defaultMime)}`;}
f.src=url;setTimeout(()=>{document.body.removeChild(f);},333);}
if(navigator.msSaveBlob){return navigator.msSaveBlob(blob,fileName);}
if(self.URL){saver(self.URL.createObjectURL(blob),true);}else{if(typeof blob==="string"||blob.constructor===toString){try{return saver(`data:${mimeType};base64,${self.btoa(blob)}`);}catch{return saver(`data:${mimeType},${encodeURIComponent(blob)}`);}}
reader=new FileReader();reader.onload=function(){saver(this.result);};reader.readAsDataURL(blob);}
return true;}
__exports.downloadFile=downloadFile;function downloadFile(data,filename,mimetype){return downloadFile._download(data,filename,mimetype);}
downloadFile._download=_download;__exports.download=download;function download(options){return download._download(options);}
download._download=(options)=>{return new Promise((resolve,reject)=>{const xhr=new browser.XMLHttpRequest();let data;if(Object.prototype.hasOwnProperty.call(options,"form")){xhr.open(options.form.method,options.form.action);data=new FormData(options.form);}else{xhr.open("POST",options.url);data=new FormData();Object.entries(options.data).forEach((entry)=>{const[key,value]=entry;data.append(key,value);});}
data.append("token","dummy-because-api-expects-one");if(odoo.csrf_token){data.append("csrf_token",odoo.csrf_token);}
configureBlobDownloadXHR(xhr,{onSuccess:resolve,onFailure:reject,url:options.url,});xhr.send(data);});};__exports.configureBlobDownloadXHR=configureBlobDownloadXHR;function configureBlobDownloadXHR(xhr,{onSuccess=()=>{},onFailure=()=>{},url}={}){xhr.responseType="blob";xhr.onload=()=>{const mimetype=xhr.response.type;const header=(xhr.getResponseHeader("Content-Disposition")||"").replace(/;$/,"");const filename=header?parse(header).parameters.filename:null;if(xhr.status===200&&(mimetype!=="text/html"||filename)){_download(xhr.response,filename,mimetype);onSuccess(filename);}else if(xhr.status===502){onFailure(new ConnectionLostError(url));}else{const decoder=new FileReader();decoder.onload=()=>{const contents=decoder.result;const doc=new DOMParser().parseFromString(contents,"text/html");const nodes=doc.body.children.length===0?[doc.body]:doc.body.children;let error;try{const node=nodes[1]||nodes[0];error=JSON.parse(node.textContent);}catch{error={message:"Arbitrary Uncaught Python Exception",data:{debug:`${xhr.status}`+`\n`+`${nodes.length > 0 ? nodes[0].textContent : ""}
                                ${nodes.length > 1 ? nodes[1].textContent : ""}`,},};}
error=makeErrorFromResponse(error);onFailure(error);};decoder.readAsText(xhr.response);}};xhr.onerror=()=>{onFailure(new ConnectionLostError(url));};}
return __exports;});;

/* /web/static/src/core/network/http_service.js */
odoo.define('@web/core/network/http_service',['@web/core/browser/browser','@web/core/registry'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");function checkResponseStatus(response){if(response.status===502){throw new Error("Failed to fetch");}}
__exports.get=get;async function get(route,readMethod="json"){const response=await browser.fetch(route,{method:"GET"});checkResponseStatus(response);return response[readMethod]();}
__exports.post=post;async function post(route,params={},readMethod="json"){let formData=params;if(!(formData instanceof FormData)){formData=new FormData();for(const key in params){const value=params[key];if(Array.isArray(value)&&value.length){for(const val of value){formData.append(key,val);}}else{formData.append(key,value);}}}
const response=await browser.fetch(route,{body:formData,method:"POST",});checkResponseStatus(response);return response[readMethod]();}
const httpService=__exports.httpService={start(){return{get,post};},};registry.category("services").add("http",httpService);return __exports;});;

/* /web/static/src/core/network/rpc.js */
odoo.define('@web/core/network/rpc',['@odoo/owl','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{EventBus}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const rpcBus=__exports.rpcBus=new EventBus();const RPCError=__exports.RPCError=class RPCError extends Error{constructor(){super(...arguments);this.name="RPC_ERROR";this.type="server";this.code=null;this.data=null;this.exceptionName=null;this.subType=null;}}
const ConnectionLostError=__exports.ConnectionLostError=class ConnectionLostError extends Error{constructor(url,...args){super(`Connection to "${url}" couldn't be established or was interrupted`,...args);this.url=url;}}
const ConnectionAbortedError=__exports.ConnectionAbortedError=class ConnectionAbortedError extends Error{}
__exports.makeErrorFromResponse=makeErrorFromResponse;function makeErrorFromResponse(reponse){const{code,data:errorData,message,type:subType}=reponse;const error=new RPCError();error.exceptionName=errorData.name;error.subType=subType;error.data=errorData;error.message=message;error.code=code;return error;}
let rpcId=0;__exports.rpc=rpc;function rpc(url,params={},settings={}){return rpc._rpc(url,params,settings);}
rpc._rpc=function(url,params,settings){const XHR=browser.XMLHttpRequest;const data={id:rpcId++,jsonrpc:"2.0",method:"call",params:params,};const request=settings.xhr||new XHR();let rejectFn;const promise=new Promise((resolve,reject)=>{rejectFn=reject;rpcBus.trigger("RPC:REQUEST",{data,url,settings});request.addEventListener("load",()=>{if(request.status===502){const error=new ConnectionLostError(url);rpcBus.trigger("RPC:RESPONSE",{data,settings,error});reject(error);return;}
let params;try{params=JSON.parse(request.response);}catch{const error=new ConnectionLostError(url);rpcBus.trigger("RPC:RESPONSE",{data,settings,error});return reject(error);}
const{error:responseError,result:responseResult}=params;if(!params.error){rpcBus.trigger("RPC:RESPONSE",{data,settings,result:params.result});return resolve(responseResult);}
const error=makeErrorFromResponse(responseError);error.id=data.id;error.model=data.params.model;rpcBus.trigger("RPC:RESPONSE",{data,settings,error});reject(error);});request.addEventListener("error",()=>{const error=new ConnectionLostError(url);rpcBus.trigger("RPC:RESPONSE",{data,settings,error});reject(error);});request.open("POST",url);const headers=settings.headers||{};headers["Content-Type"]="application/json";for(let[header,value]of Object.entries(headers)){request.setRequestHeader(header,value);}
request.send(JSON.stringify(data));});promise.abort=function(rejectError=true){if(request.abort){request.abort();}
const error=new ConnectionAbortedError("XmlHttpRequestError abort");rpcBus.trigger("RPC:RESPONSE",{data,settings,error});if(rejectError){rejectFn(error);}};return promise;};return __exports;});;

/* /web/static/src/core/notebook/notebook.js */
odoo.define('@web/core/notebook/notebook',['@web/core/utils/scrolling','@odoo/owl','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{scrollTo}=require("@web/core/utils/scrolling");const{Component,onWillUpdateProps,useEffect,useExternalListener,useRef,useState,}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const Notebook=__exports.Notebook=class Notebook extends Component{static template="web.Notebook";static defaultProps={className:"",orientation:"horizontal",onPageUpdate:()=>{},};static props={slots:{type:Object,optional:true},pages:{type:Object,optional:true},class:{optional:true},className:{type:String,optional:true},anchors:{type:Object,optional:true},defaultPage:{type:String,optional:true},orientation:{type:String,optional:true},icons:{type:Object,optional:true},onPageUpdate:{type:Function,optional:true},};setup(){this.activePane=useRef("activePane");this.anchorTarget=null;this.pages=this.computePages(this.props);this.state=useState({currentPage:null});this.state.currentPage=this.computeActivePage(this.props.defaultPage,true);useExternalListener(browser,"click",this.onAnchorClicked);useEffect(()=>{this.props.onPageUpdate(this.state.currentPage);if(this.anchorTarget){const matchingEl=this.activePane.el.querySelector(`#${this.anchorTarget}`);scrollTo(matchingEl,{isAnchor:true});this.anchorTarget=null;}
this.activePane.el?.classList.add("show");},()=>[this.state.currentPage]);onWillUpdateProps((nextProps)=>{const activateDefault=this.props.defaultPage!==nextProps.defaultPage||!this.defaultVisible;this.pages=this.computePages(nextProps);this.state.currentPage=this.computeActivePage(nextProps.defaultPage,activateDefault);});}
get navItems(){return this.pages.filter((e)=>e[1].isVisible);}
get page(){const page=this.pages.find((e)=>e[0]===this.state.currentPage)[1];return page.Component&&page;}
onAnchorClicked(ev){if(!this.props.anchors){return;}
const href=ev.target.closest("a")?.getAttribute("href");if(!href){return;}
const id=href.substring(1);if(this.props.anchors[id]){if(this.state.currentPage!==this.props.anchors[id].target){ev.preventDefault();this.anchorTarget=id;this.state.currentPage=this.props.anchors[id].target;}}}
activatePage(pageIndex){if(!this.disabledPages.includes(pageIndex)&&this.state.currentPage!==pageIndex){this.activePane.el?.classList.remove("show");this.state.currentPage=pageIndex;}}
computePages(props){if(!props.slots&&!props.pages){return[];}
if(props.pages){for(const page of props.pages){page.isVisible=true;}}
this.disabledPages=[];const pages=[];const pagesWithIndex=[];for(const[k,v]of Object.entries({...props.slots,...props.pages})){const id=v.id||k;if(v.index){pagesWithIndex.push([id,v]);}else{pages.push([id,v]);}
if(v.isDisabled){this.disabledPages.push(k);}}
for(const page of pagesWithIndex){pages.splice(page[1].index,0,page);}
return pages;}
computeActivePage(defaultPage,activateDefault){if(!this.pages.length){return null;}
const pages=this.pages.filter((e)=>e[1].isVisible).map((e)=>e[0]);if(defaultPage){if(!pages.includes(defaultPage)){this.defaultVisible=false;}else{this.defaultVisible=true;if(activateDefault){return defaultPage;}}}
const current=this.state.currentPage;if(!current||(current&&!pages.includes(current))){return pages[0];}
return current;}}
return __exports;});;

/* /web/static/src/core/notifications/notification.js */
odoo.define('@web/core/notifications/notification',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const Notification=__exports.Notification=class Notification extends Component{static template="web.NotificationWowl";static props={message:{validate:(m)=>{return(typeof m==="string"||(typeof m==="object"&&typeof m.toString==="function"));},},title:{type:[String,Boolean,{toString:Function}],optional:true},type:{type:String,optional:true,validate:(t)=>["warning","danger","success","info"].includes(t),},className:{type:String,optional:true},buttons:{type:Array,element:{type:Object,shape:{name:{type:String},icon:{type:String,optional:true},primary:{type:Boolean,optional:true},onClick:Function,},},optional:true,},close:{type:Function},refresh:{type:Function},freeze:{type:Function},};static defaultProps={buttons:[],className:"",type:"warning",};}
return __exports;});;

/* /web/static/src/core/notifications/notification_container.js */
odoo.define('@web/core/notifications/notification_container',['@web/core/notifications/notification','@web/core/transition','@odoo/owl'],function(require){'use strict';let __exports={};const{Notification}=require("@web/core/notifications/notification");const{Transition}=require("@web/core/transition");const{Component,xml,useState}=require("@odoo/owl");const NotificationContainer=__exports.NotificationContainer=class NotificationContainer extends Component{static props={notifications:Object,};static template=xml`
        <div class="o_notification_manager">
            <t t-foreach="notifications" t-as="notification" t-key="notification">
                <Transition leaveDuration="0" immediate="true" name="'o_notification_fade'" t-slot-scope="transition">
                    <Notification t-props="notification_value.props" className="(notification_value.props.className || '') + ' ' + transition.className"/>
                </Transition>
            </t>
        </div>`;static components={Notification,Transition};setup(){this.notifications=useState(this.props.notifications);}}
return __exports;});;

/* /web/static/src/core/notifications/notification_service.js */
odoo.define('@web/core/notifications/notification_service',['@web/core/browser/browser','@web/core/registry','@web/core/notifications/notification_container','@odoo/owl'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{NotificationContainer}=require("@web/core/notifications/notification_container");const{reactive}=require("@odoo/owl");const AUTOCLOSE_DELAY=4000;const notificationService=__exports.notificationService={notificationContainer:NotificationContainer,start(){let notifId=0;const notifications=reactive({});registry.category("main_components").add(this.notificationContainer.name,{Component:this.notificationContainer,props:{notifications},},{sequence:100});function add(message,options={}){const id=++notifId;const closeFn=()=>close(id);const props=Object.assign({},options,{message,close:closeFn});const autocloseDelay=options.autocloseDelay??AUTOCLOSE_DELAY;const sticky=props.sticky;delete props.sticky;delete props.onClose;delete props.autocloseDelay;let closeTimeout;const refresh=sticky?()=>{}:()=>{closeTimeout=browser.setTimeout(closeFn,autocloseDelay);};const freeze=sticky?()=>{}:()=>{browser.clearTimeout(closeTimeout);};props.refresh=refreshAll;props.freeze=freezeAll;const notification={id,props,onClose:options.onClose,refresh,freeze,};notifications[id]=notification;if(!sticky){closeTimeout=browser.setTimeout(closeFn,autocloseDelay);}
return closeFn;}
function refreshAll(){for(const id in notifications){notifications[id].refresh();}}
function freezeAll(){for(const id in notifications){notifications[id].freeze();}}
function close(id){if(notifications[id]){const notification=notifications[id];if(notification.onClose){notification.onClose();}
delete notifications[id];}}
return{add};},};registry.category("services").add("notification",notificationService);return __exports;});;

/* /web/static/src/core/orm_service.js */
odoo.define('@web/core/orm_service',['@web/core/registry','@web/core/network/rpc','@web/core/user'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{rpc}=require("@web/core/network/rpc");const{user}=require("@web/core/user");const x2ManyCommands=__exports.x2ManyCommands={CREATE:0,create(virtualID,values){delete values.id;return[x2ManyCommands.CREATE,virtualID||false,values];},UPDATE:1,update(id,values){delete values.id;return[x2ManyCommands.UPDATE,id,values];},DELETE:2,delete(id){return[x2ManyCommands.DELETE,id,false];},UNLINK:3,unlink(id){return[x2ManyCommands.UNLINK,id,false];},LINK:4,link(id){return[x2ManyCommands.LINK,id,false];},CLEAR:5,clear(){return[x2ManyCommands.CLEAR,false,false];},SET:6,set(ids){return[x2ManyCommands.SET,false,ids];},};function validateModel(value){if(typeof value!=="string"||value.length===0){throw new Error(`Invalid model name: ${value}`);}}
function validatePrimitiveList(name,type,value){if(!Array.isArray(value)||value.some((val)=>typeof val!==type)){throw new Error(`Invalid ${name} list: ${value}`);}}
function validateObject(name,obj){if(typeof obj!=="object"||obj===null||Array.isArray(obj)){throw new Error(`${name} should be an object`);}}
function validateArray(name,array){if(!Array.isArray(array)){throw new Error(`${name} should be an array`);}}
const UPDATE_METHODS=__exports.UPDATE_METHODS=["unlink","create","write","web_save","action_archive","action_unarchive",];const ORM=__exports.ORM=class ORM{constructor(){this.rpc=rpc;this._silent=false;}
get silent(){return Object.assign(Object.create(this),{_silent:true});}
call(model,method,args=[],kwargs={}){validateModel(model);const url=`/web/dataset/call_kw/${model}/${method}`;const fullContext=Object.assign({},user.context,kwargs.context||{});const fullKwargs=Object.assign({},kwargs,{context:fullContext});const params={model,method,args,kwargs:fullKwargs,};return this.rpc(url,params,{silent:this._silent});}
create(model,records,kwargs={}){validateArray("records",records);for(const record of records){validateObject("record",record);}
return this.call(model,"create",[records],kwargs);}
read(model,ids,fields,kwargs={}){validatePrimitiveList("ids","number",ids);if(fields){validatePrimitiveList("fields","string",fields);}
if(!ids.length){return Promise.resolve([]);}
return this.call(model,"read",[ids,fields],kwargs);}
readGroup(model,domain,fields,groupby,kwargs={}){validateArray("domain",domain);validatePrimitiveList("fields","string",fields);validatePrimitiveList("groupby","string",groupby);groupby=[...new Set(groupby)];return this.call(model,"read_group",[],{...kwargs,domain,fields,groupby});}
search(model,domain,kwargs={}){validateArray("domain",domain);return this.call(model,"search",[domain],kwargs);}
searchRead(model,domain,fields,kwargs={}){validateArray("domain",domain);if(fields){validatePrimitiveList("fields","string",fields);}
return this.call(model,"search_read",[],{...kwargs,domain,fields});}
searchCount(model,domain,kwargs={}){validateArray("domain",domain);return this.call(model,"search_count",[domain],kwargs);}
unlink(model,ids,kwargs={}){validatePrimitiveList("ids","number",ids);if(!ids.length){return Promise.resolve(true);}
return this.call(model,"unlink",[ids],kwargs);}
webReadGroup(model,domain,fields,groupby,kwargs={}){validateArray("domain",domain);validatePrimitiveList("fields","string",fields);validatePrimitiveList("groupby","string",groupby);return this.call(model,"web_read_group",[],{...kwargs,groupby,domain,fields,});}
webRead(model,ids,kwargs={}){validatePrimitiveList("ids","number",ids);return this.call(model,"web_read",[ids],kwargs);}
webSearchRead(model,domain,kwargs={}){validateArray("domain",domain);return this.call(model,"web_search_read",[],{...kwargs,domain});}
write(model,ids,data,kwargs={}){validatePrimitiveList("ids","number",ids);validateObject("data",data);return this.call(model,"write",[ids,data],kwargs);}
webSave(model,ids,data,kwargs={}){validatePrimitiveList("ids","number",ids);validateObject("data",data);return this.call(model,"web_save",[ids,data],kwargs);}}
const ormService=__exports.ormService={async:["call","create","nameGet","read","readGroup","search","searchRead","unlink","webSearchRead","write",],start(){return new ORM();},};registry.category("services").add("orm",ormService);return __exports;});;

/* /web/static/src/core/overlay/overlay_container.js */
odoo.define('@web/core/overlay/overlay_container',['@odoo/owl','@web/core/utils/arrays','@web/core/utils/components'],function(require){'use strict';let __exports={};const{Component,onWillDestroy,useChildSubEnv,useEffect,useRef,useState}=require("@odoo/owl");const{sortBy}=require("@web/core/utils/arrays");const{ErrorHandler}=require("@web/core/utils/components");const OVERLAY_ITEMS=[];const OVERLAY_SYMBOL=__exports.OVERLAY_SYMBOL=Symbol("Overlay");class OverlayItem extends Component{static template="web.OverlayContainer.Item";static components={};static props={component:{type:Function},props:{type:Object},env:{type:Object,optional:true},};setup(){this.rootRef=useRef("rootRef");OVERLAY_ITEMS.push(this);onWillDestroy(()=>{const index=OVERLAY_ITEMS.indexOf(this);OVERLAY_ITEMS.splice(index,1);});if(this.props.env){this.__owl__.childEnv=this.props.env;}
useChildSubEnv({[OVERLAY_SYMBOL]:{contains:(target)=>this.contains(target),},});}
get subOverlays(){return OVERLAY_ITEMS.slice(OVERLAY_ITEMS.indexOf(this));}
contains(target){return(this.rootRef.el?.contains(target)||this.subOverlays.some((oi)=>oi.rootRef.el?.contains(target)));}}
const OverlayContainer=__exports.OverlayContainer=class OverlayContainer extends Component{static template="web.OverlayContainer";static components={ErrorHandler,OverlayItem};static props={overlays:Object};setup(){this.root=useRef("root");this.state=useState({rootEl:null});useEffect(()=>{this.state.rootEl=this.root.el;},()=>[this.root.el]);}
get sortedOverlays(){return sortBy(Object.values(this.props.overlays),(overlay)=>overlay.sequence);}
isVisible(overlay){return overlay.rootId===this.state.rootEl?.getRootNode()?.host?.id;}
handleError(overlay,error){overlay.remove();Promise.resolve().then(()=>{throw error;});}}
return __exports;});;

/* /web/static/src/core/overlay/overlay_service.js */
odoo.define('@web/core/overlay/overlay_service',['@odoo/owl','@web/core/registry','@web/core/overlay/overlay_container'],function(require){'use strict';let __exports={};const{markRaw,reactive}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{OverlayContainer}=require("@web/core/overlay/overlay_container");const mainComponents=registry.category("main_components");const services=registry.category("services");const overlayService=__exports.overlayService={start(){let nextId=0;const overlays=reactive({});mainComponents.add("OverlayContainer",{Component:OverlayContainer,props:{overlays},});const remove=(id,onRemove=()=>{})=>{if(id in overlays){onRemove();delete overlays[id];}};const add=(component,props,options={})=>{const id=++nextId;const removeCurrentOverlay=()=>remove(id,options.onRemove);overlays[id]={id,component,env:options.env&&markRaw(options.env),props,remove:removeCurrentOverlay,sequence:options.sequence??50,rootId:options.rootId,};return removeCurrentOverlay;};return{add,overlays};},};services.add("overlay",overlayService);return __exports;});;

/* /web/static/src/core/pager/pager.js */
odoo.define('@web/core/pager/pager',['@web/core/utils/hooks','@web/core/utils/numbers','@odoo/owl'],function(require){'use strict';let __exports={};const{useAutofocus}=require("@web/core/utils/hooks");const{clamp}=require("@web/core/utils/numbers");const{Component,EventBus,useEffect,useExternalListener,useState}=require("@odoo/owl");const PAGER_UPDATED_EVENT=__exports.PAGER_UPDATED_EVENT="PAGER:UPDATED";const pagerBus=__exports.pagerBus=new EventBus();const Pager=__exports.Pager=class Pager extends Component{static template="web.Pager";static defaultProps={isEditable:true,withAccessKey:true,};static props={offset:Number,limit:Number,total:Number,onUpdate:Function,isEditable:{type:Boolean,optional:true},withAccessKey:{type:Boolean,optional:true},updateTotal:{type:Function,optional:true},};setup(){this.state=useState({isEditing:false,isDisabled:false,});this.inputRef=useAutofocus();useExternalListener(document,"mousedown",this.onClickAway,{capture:true});let firstMount=true;useEffect(()=>{if(!firstMount&&this.env.isSmall){pagerBus.trigger(PAGER_UPDATED_EVENT,{value:this.value,total:this.props.total,});}
firstMount=false;},()=>[this.props.offset,this.props.limit,this.props.total]);}
get minimum(){return this.props.offset+1;}
get maximum(){return Math.min(this.props.offset+this.props.limit,this.props.total);}
get value(){const parts=[this.minimum];if(this.props.limit>1){parts.push(this.maximum);}
return parts.join("-");}
get isSinglePage(){return!this.props.updateTotal&&this.minimum===1&&this.maximum===this.props.total;}
async navigate(direction){let minimum=this.props.offset+this.props.limit*direction;let total=this.props.total;if(this.props.updateTotal&&minimum<0){total=await this.props.updateTotal();}
if(minimum>=total){if(!this.props.updateTotal){minimum=0;}}else if(minimum<0&&this.props.limit===1){minimum=total-1;}else if(minimum<0&&this.props.limit>1){minimum=total-(total%this.props.limit||this.props.limit);}
this.update(minimum,this.props.limit,true);}
async parse(value){let[minimum,maximum]=value.trim().split(/\s*[-\s,;]\s*/);minimum=parseInt(minimum,10);maximum=maximum?parseInt(maximum,10):minimum;if(this.props.updateTotal){return{minimum:minimum-1,maximum};}
return{minimum:clamp(minimum,1,this.props.total)-1,maximum:clamp(maximum,1,this.props.total),};}
async setValue(value){const{minimum,maximum}=await this.parse(value);if(!isNaN(minimum)&&!isNaN(maximum)&&minimum<maximum){this.update(minimum,maximum-minimum);}}
async update(offset,limit,hasNavigated){this.state.isDisabled=true;try{await this.props.onUpdate({offset,limit},hasNavigated);}finally{this.state.isDisabled=false;this.state.isEditing=false;}}
async updateTotal(){if(!this.state.isDisabled){this.state.isDisabled=true;await this.props.updateTotal();this.state.isDisabled=false;}}
onClickAway(ev){if(ev.target!==this.inputRef.el){this.state.isEditing=false;}}
onInputBlur(){this.state.isEditing=false;}
onInputChange(ev){this.setValue(ev.target.value);if(!this.state.isDisabled){ev.preventDefault();}}
onInputKeydown(ev){switch(ev.key){case"Enter":ev.preventDefault();ev.stopPropagation();this.setValue(ev.currentTarget.value);break;case"Escape":ev.preventDefault();ev.stopPropagation();this.state.isEditing=false;break;}}
onValueClick(){if(this.props.isEditable&&!this.state.isEditing&&!this.state.isDisabled){if(this.inputRef.el){this.inputRef.el.focus();}
this.state.isEditing=true;}}}
return __exports;});;

/* /web/static/src/core/pager/pager_indicator.js */
odoo.define('@web/core/pager/pager_indicator',['@web/core/browser/browser','@web/core/registry','@web/core/transition','@web/core/utils/hooks','@odoo/owl','@web/core/pager/pager'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{Transition}=require("@web/core/transition");const{useBus}=require("@web/core/utils/hooks");const{Component,useState}=require("@odoo/owl");const{PAGER_UPDATED_EVENT,pagerBus}=require("@web/core/pager/pager");const PagerIndicator=__exports.PagerIndicator=class PagerIndicator extends Component{static template="web.PagerIndicator";static components={Transition};static props={};setup(){this.state=useState({show:false,value:"-",total:0,});this.startShowTimer=null;useBus(pagerBus,PAGER_UPDATED_EVENT,this.pagerUpdate);}
pagerUpdate({detail}){this.state.value=detail.value;this.state.total=detail.total;browser.clearTimeout(this.startShowTimer);this.state.show=true;this.startShowTimer=browser.setTimeout(()=>{this.state.show=false;},1400);}}
registry.category("main_components").add("PagerIndicator",{Component:PagerIndicator,});return __exports;});;

/* /web/static/src/core/popover/popover.js */
odoo.define('@web/core/popover/popover',['@odoo/owl','@web/core/hotkeys/hotkey_hook','@web/core/overlay/overlay_container','@web/core/position/position_hook','@web/core/ui/ui_service','@web/core/utils/classname','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,onMounted,onWillDestroy,useComponent,useRef}=require("@odoo/owl");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{OVERLAY_SYMBOL}=require("@web/core/overlay/overlay_container");const{usePosition}=require("@web/core/position/position_hook");const{useActiveElement}=require("@web/core/ui/ui_service");const{addClassesToElement,mergeClasses}=require("@web/core/utils/classname");const{useForwardRefToParent}=require("@web/core/utils/hooks");function useEarlyExternalListener(target,eventName,handler,eventParams){const component=useComponent();const boundHandler=handler.bind(component);target.addEventListener(eventName,boundHandler,eventParams);onWillDestroy(()=>target.removeEventListener(eventName,boundHandler,eventParams));}
function useClickAway(callback){const pointerDownHandler=(event)=>{callback(event.composedPath()[0]);};const blurHandler=(ev)=>{const target=ev.relatedTarget||document.activeElement;if(target?.tagName==="IFRAME"){callback(target);}};useEarlyExternalListener(window,"pointerdown",pointerDownHandler,{capture:true});useEarlyExternalListener(window,"blur",blurHandler,{capture:true});}
const POPOVERS=new WeakMap();__exports.getPopoverForTarget=getPopoverForTarget;function getPopoverForTarget(target){return POPOVERS.get(target);}
const Popover=__exports.Popover=class Popover extends Component{static template="web.Popover";static defaultProps={animation:true,arrow:true,class:"",closeOnClickAway:()=>true,closeOnEscape:true,componentProps:{},fixedPosition:false,position:"bottom",setActiveElement:false,};static props={component:{type:Function},componentProps:{optional:true,type:Object},target:{validate:(target)=>{const Element=target?.ownerDocument?.defaultView?.Element;return((Boolean(Element)&&(target instanceof Element||target instanceof window.Element))||(typeof target==="object"&&target?.constructor?.name?.endsWith("Element")));},},animation:{optional:true,type:Boolean},arrow:{optional:true,type:Boolean},class:{optional:true},role:{optional:true,type:String},fixedPosition:{optional:true,type:Boolean},holdOnHover:{optional:true,type:Boolean},onPositioned:{optional:true,type:Function},position:{optional:true,type:String,validate:(p)=>{const[d,v="middle"]=p.split("-");return(["top","bottom","left","right"].includes(d)&&["start","middle","end","fit"].includes(v));},},close:{optional:true,type:Function},closeOnClickAway:{optional:true,type:Function},closeOnEscape:{optional:true,type:Boolean},setActiveElement:{optional:true,type:Boolean},ref:{optional:true,type:Function},slots:{optional:true,type:Object},};static animationTime=200;setup(){if(this.props.setActiveElement){useActiveElement("ref");}
useForwardRefToParent("ref");this.popoverRef=useRef("ref");let shouldAnimate=this.props.animation;this.position=usePosition("ref",()=>this.props.target,{onPositioned:(el,solution)=>{(this.props.onPositioned||this.onPositioned.bind(this))(el,solution);if(this.props.arrow&&this.props.onPositioned){this.onPositioned.bind(this)(el,solution);}
if(shouldAnimate){shouldAnimate=false;const transform={top:["translateY(-5%)","translateY(0)"],right:["translateX(5%)","translateX(0)"],bottom:["translateY(5%)","translateY(0)"],left:["translateX(-5%)","translateX(0)"],}[solution.direction];this.position.lock();const animation=el.animate({opacity:[0,1],transform},this.constructor.animationTime);animation.finished.then(this.position.unlock);}
if(this.props.fixedPosition){this.position.lock();}},position:this.props.position,});onMounted(()=>POPOVERS.set(this.props.target,this.popoverRef.el));onWillDestroy(()=>POPOVERS.delete(this.props.target));if(!this.props.close){return;}
if(this.props.target.isConnected){useClickAway((target)=>this.onClickAway(target));if(this.props.closeOnEscape){useHotkey("escape",()=>this.props.close());}
const targetObserver=new MutationObserver(this.onTargetMutate.bind(this));targetObserver.observe(this.props.target.parentElement,{childList:true});onWillDestroy(()=>targetObserver.disconnect());}else{this.props.close();}}
get defaultClassObj(){return mergeClasses("o_popover popover mw-100",{"o-popover--with-arrow":this.props.arrow},this.props.class);}
isInside(target){return(this.props.target?.contains(target)||this.popoverRef?.el?.contains(target)||this.env[OVERLAY_SYMBOL]?.contains(target));}
onClickAway(target){if(this.props.closeOnClickAway(target)&&!this.isInside(target)){this.props.close();}}
onTargetMutate(){if(!this.props.target.isConnected){this.props.close();}}
onPositioned(el,{direction,variant}){const position=`${direction[0]}${variant[0]}`;el.classList=[];const directionMap={top:"top",bottom:"bottom",left:"start",right:"end",};addClassesToElement(el,this.defaultClassObj,`bs-popover-${directionMap[direction]}`,`o-popover-${direction}`,`o-popover--${position}`);if(this.props.arrow){const arrowEl=el.querySelector(":scope > .popover-arrow");arrowEl.className="popover-arrow";switch(position){case"tm":case"bm":case"tf":case"bf":arrowEl.classList.add("start-0","end-0","mx-auto");break;case"lm":case"rm":case"lf":case"rf":arrowEl.classList.add("top-0","bottom-0","my-auto");break;case"ts":case"bs":arrowEl.classList.add("end-auto");break;case"te":case"be":arrowEl.classList.add("start-auto");break;case"ls":case"rs":arrowEl.classList.add("bottom-auto");break;case"le":case"re":arrowEl.classList.add("top-auto");break;}}}}
return __exports;});;

/* /web/static/src/core/popover/popover_hook.js */
odoo.define('@web/core/popover/popover_hook',['@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{onWillUnmount,status,useComponent}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");__exports.makePopover=makePopover;function makePopover(addFn,component,options){let removeFn=null;function close(){removeFn?.();}
return{open(target,props){close();const newOptions=Object.create(options);newOptions.onClose=()=>{removeFn=null;options.onClose?.();};removeFn=addFn(target,component,props,newOptions);},close,get isOpen(){return Boolean(removeFn);},};}
__exports.usePopover=usePopover;function usePopover(component,options={}){const popoverService=useService("popover");const owner=useComponent();const newOptions=Object.create(options);newOptions.onClose=()=>{if(status(owner)!=="destroyed"){options.onClose?.();}};const popover=makePopover(popoverService.add,component,newOptions);onWillUnmount(popover.close);return popover;}
return __exports;});;

/* /web/static/src/core/popover/popover_service.js */
odoo.define('@web/core/popover/popover_service',['@odoo/owl','@web/core/popover/popover','@web/core/registry'],function(require){'use strict';let __exports={};const{markRaw}=require("@odoo/owl");const{Popover}=require("@web/core/popover/popover");const{registry}=require("@web/core/registry");const popoverService=__exports.popoverService={dependencies:["overlay"],start(_,{overlay}){const add=(target,component,props={},options={})=>{const closeOnClickAway=typeof options.closeOnClickAway==="function"?options.closeOnClickAway:()=>options.closeOnClickAway??true;const remove=overlay.add(Popover,{target,close:()=>remove(),closeOnClickAway,closeOnEscape:options.closeOnEscape,component,componentProps:markRaw(props),ref:options.ref,class:options.popoverClass,animation:options.animation,arrow:options.arrow,role:options.popoverRole,position:options.position,onPositioned:options.onPositioned,fixedPosition:options.fixedPosition,holdOnHover:options.holdOnHover,setActiveElement:options.setActiveElement??true,},{env:options.env,onRemove:options.onClose,rootId:target.getRootNode()?.host?.id,});return remove;};return{add};},};registry.category("services").add("popover",popoverService);return __exports;});;

/* /web/static/src/core/position/position_hook.js */
odoo.define('@web/core/position/position_hook',['@web/core/position/utils','@web/core/utils/objects','@web/core/utils/timing','@odoo/owl'],function(require){'use strict';let __exports={};const{reposition}=require("@web/core/position/utils");const{omit}=require("@web/core/utils/objects");const{useThrottleForAnimation}=require("@web/core/utils/timing");const{EventBus,onWillDestroy,useChildSubEnv,useComponent,useEffect,useRef,}=require("@odoo/owl");const DEFAULTS={margin:0,position:"bottom",};const POSITION_BUS=Symbol("position-bus");__exports.usePosition=usePosition;function usePosition(refName,getTarget,options={}){const ref=useRef(refName);let lock=false;const update=()=>{const targetEl=getTarget();if(!ref.el||!targetEl?.isConnected||lock){return;}
const repositionOptions={...DEFAULTS,...omit(options,"onPositioned")};const solution=reposition(ref.el,targetEl,repositionOptions);options.onPositioned?.(ref.el,solution);};const component=useComponent();const bus=component.env[POSITION_BUS]||new EventBus();let executingUpdate=false;const batchedUpdate=async()=>{if(!executingUpdate){executingUpdate=true;update();await Promise.resolve();executingUpdate=false;}};bus.addEventListener("update",batchedUpdate);onWillDestroy(()=>bus.removeEventListener("update",batchedUpdate));const isTopmost=!(POSITION_BUS in component.env);if(isTopmost){useChildSubEnv({[POSITION_BUS]:bus});}
const throttledUpdate=useThrottleForAnimation(()=>bus.trigger("update"));useEffect(()=>{bus.trigger("update");if(isTopmost){const scrollListener=(e)=>{if(ref.el?.contains(e.target)){return;}
throttledUpdate();};const targetDocument=getTarget()?.ownerDocument;targetDocument?.addEventListener("scroll",scrollListener,{capture:true});targetDocument?.addEventListener("load",throttledUpdate,{capture:true});window.addEventListener("resize",throttledUpdate);return()=>{targetDocument?.removeEventListener("scroll",scrollListener,{capture:true});targetDocument?.removeEventListener("load",throttledUpdate,{capture:true});window.removeEventListener("resize",throttledUpdate);};}});return{lock:()=>{lock=true;},unlock:()=>{lock=false;bus.trigger("update");},};}
return __exports;});;

/* /web/static/src/core/position/utils.js */
odoo.define('@web/core/position/utils',['@web/core/l10n/localization'],function(require){'use strict';let __exports={};const{localization}=require("@web/core/l10n/localization");const DIRECTIONS={t:"top",r:"right",b:"bottom",l:"left"};const VARIANTS={s:"start",m:"middle",e:"end",f:"fit"};const DIRECTION_FLIP_ORDER={top:"tbrl",right:"rltb",bottom:"btrl",left:"lrbt"};const VARIANT_FLIP_ORDER={start:"sme",middle:"mse",end:"ems",fit:"f"};const FIT_FLIP_ORDER={top:"tb",right:"rl",bottom:"bt",left:"lr"};function getIFrame(popperEl,targetEl){return[...popperEl.ownerDocument.getElementsByTagName("iframe")].find((iframe)=>iframe.contentDocument?.contains(targetEl));}
function computePosition(popper,target,{container,margin,position}){let[direction,variant="middle"]=position.split("-");if(localization.direction==="rtl"){if(["left","right"].includes(direction)){direction=direction==="left"?"right":"left";}else if(["start","end"].includes(variant)){variant=variant==="start"?"end":"start";}}
const directions=variant==="fit"?FIT_FLIP_ORDER[direction]:DIRECTION_FLIP_ORDER[direction];const variants=VARIANT_FLIP_ORDER[variant];if(!container){container=popper.ownerDocument.documentElement;}else if(typeof container==="function"){container=container();}
const popperStyle=getComputedStyle(popper);const{marginTop,marginLeft,marginRight,marginBottom}=popperStyle;const popMargins={top:parseFloat(marginTop),left:parseFloat(marginLeft),right:parseFloat(marginRight),bottom:parseFloat(marginBottom),};const shouldAccountForIFrame=popper.ownerDocument!==target.ownerDocument;const iframe=shouldAccountForIFrame?getIFrame(popper,target):null;const popBox=popper.getBoundingClientRect();const targetBox=target.getBoundingClientRect();const contBox=container.getBoundingClientRect();const iframeBox=iframe?.getBoundingClientRect()??{top:0,left:0};const containerIsHTMLNode=container===container.ownerDocument.firstElementChild;const directionsData={t:iframeBox.top+targetBox.top-popMargins.bottom-margin-popBox.height,b:iframeBox.top+targetBox.bottom+popMargins.top+margin,r:iframeBox.left+targetBox.right+popMargins.left+margin,l:iframeBox.left+targetBox.left-popMargins.right-margin-popBox.width,};const variantsData={vf:iframeBox.left+targetBox.left,vs:iframeBox.left+targetBox.left+popMargins.left,vm:iframeBox.left+targetBox.left+targetBox.width/2-popBox.width/2,ve:iframeBox.left+targetBox.right-popMargins.right-popBox.width,hf:iframeBox.top+targetBox.top,hs:iframeBox.top+targetBox.top+popMargins.top,hm:iframeBox.top+targetBox.top+targetBox.height/2-popBox.height/2,he:iframeBox.top+targetBox.bottom-popMargins.bottom-popBox.height,};function getPositioningData(d=directions[0],v=variants[0],containerRestricted=false){const vertical=["t","b"].includes(d);const variantPrefix=vertical?"v":"h";const directionValue=directionsData[d];const variantValue=variantsData[variantPrefix+v];if(containerRestricted){const[directionSize,variantSize]=vertical?[popBox.height,popBox.width]:[popBox.width,popBox.height];let[directionMin,directionMax]=vertical?[contBox.top,contBox.bottom]:[contBox.left,contBox.right];let[variantMin,variantMax]=vertical?[contBox.left,contBox.right]:[contBox.top,contBox.bottom];if(containerIsHTMLNode){if(vertical){directionMin+=container.scrollTop;directionMax+=container.scrollTop;}else{variantMin+=container.scrollTop;variantMax+=container.scrollTop;}}
const directionOverflow=Math.ceil(directionValue)<Math.floor(directionMin)||Math.floor(directionValue+directionSize)>Math.ceil(directionMax);const variantOverflow=Math.ceil(variantValue)<Math.floor(variantMin)||Math.floor(variantValue+variantSize)>Math.ceil(variantMax);if(directionOverflow||variantOverflow){return null;}}
const positioning=vertical?{top:directionValue,left:variantValue}:{top:variantValue,left:directionValue};return{top:positioning.top-popBox.top,left:positioning.left-popBox.left,direction:DIRECTIONS[d],variant:VARIANTS[v],};}
for(const d of directions){for(const v of variants){const match=getPositioningData(d,v,true);if(match){return match;}}}
return getPositioningData();}
__exports.reposition=reposition;function reposition(popper,target,options){popper.style.position="fixed";popper.style.top="0px";popper.style.left="0px";const solution=computePosition(popper,target,options);const{top,left,direction,variant}=solution;popper.style.top=`${top}px`;popper.style.left=`${left}px`;if(variant==="fit"){const styleProperty=["top","bottom"].includes(direction)?"width":"height";popper.style[styleProperty]=target.getBoundingClientRect()[styleProperty]+"px";}
return solution;}
return __exports;});;

/* /web/static/src/core/pwa/install_prompt.js */
odoo.define('@web/core/pwa/install_prompt',['@odoo/owl','@web/core/dialog/dialog','@web/core/browser/feature_detection'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{isIOS}=require("@web/core/browser/feature_detection");const InstallPrompt=__exports.InstallPrompt=class InstallPrompt extends Component{static props={close:true,onClose:{type:Function},};static components={Dialog,};static template="web.InstallPrompt";get isMobileSafari(){return isIOS();}
onClose(){this.props.close();this.props.onClose();}}
return __exports;});;

/* /web/static/src/core/pwa/pwa_service.js */
odoo.define('@web/core/pwa/pwa_service',['@odoo/owl','@web/core/browser/browser','@web/core/browser/feature_detection','@web/core/network/http_service','@web/core/registry','@web/core/pwa/install_prompt'],function(require){'use strict';let __exports={};const{reactive}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{isDisplayStandalone,isIOS,isMacOS,isBrowserSafari,}=require("@web/core/browser/feature_detection");const{get}=require("@web/core/network/http_service");const{registry}=require("@web/core/registry");const{InstallPrompt}=require("@web/core/pwa/install_prompt");const serviceRegistry=registry.category("services");let BEFOREINSTALLPROMPT_EVENT;let REGISTER_BEFOREINSTALLPROMPT_EVENT;browser.addEventListener("beforeinstallprompt",(ev)=>{if(REGISTER_BEFOREINSTALLPROMPT_EVENT){return REGISTER_BEFOREINSTALLPROMPT_EVENT(ev);}else{BEFOREINSTALLPROMPT_EVENT=ev;}});const pwaService={dependencies:["dialog"],start(env,{dialog}){let _manifest;let nativePrompt;const state=reactive({canPromptToInstall:false,isAvailable:false,isScopedApp:browser.location.href.includes("/scoped_app"),isSupportedOnBrowser:false,startUrl:"/odoo",decline,getManifest,hasScopeBeenInstalled,show,});function _getInstallationState(scope=state.startUrl){const installationState=browser.localStorage.getItem("pwaService.installationState");return installationState?JSON.parse(installationState)[scope]:"";}
function _setInstallationState(value){const ls=JSON.parse(browser.localStorage.getItem("pwaService.installationState")||"{}");ls[state.startUrl]=value;browser.localStorage.setItem("pwaService.installationState",JSON.stringify(ls));}
function _removeInstallationState(){const ls=JSON.parse(browser.localStorage.getItem("pwaService.installationState"));delete ls[state.startUrl];browser.localStorage.setItem("pwaService.installationState",JSON.stringify(ls));}
if(state.isScopedApp){if(browser.location.pathname==="/scoped_app"){state.startUrl="/"+new URL(browser.location.href).searchParams.get("path");}else{state.startUrl=browser.location.pathname;}}
state.isSupportedOnBrowser=browser.BeforeInstallPromptEvent!==undefined||(isBrowserSafari()&&!isDisplayStandalone()&&(isIOS()||(isMacOS()&&browser.navigator.userAgent.match(/Version\/(\d+)/)[1]>=17)));const installationState=_getInstallationState();if(state.isSupportedOnBrowser){if(BEFOREINSTALLPROMPT_EVENT){_handleBeforeInstallPrompt(BEFOREINSTALLPROMPT_EVENT,installationState);BEFOREINSTALLPROMPT_EVENT=null;}
REGISTER_BEFOREINSTALLPROMPT_EVENT=(ev)=>{_handleBeforeInstallPrompt(ev,installationState);};if(isBrowserSafari()){state.canPromptToInstall=installationState!=="dismissed";state.isAvailable=true;}}
function _handleBeforeInstallPrompt(ev,installationState){nativePrompt=ev;if(installationState==="accepted"){if(!isDisplayStandalone()){_removeInstallationState();}}
state.canPromptToInstall=installationState!=="dismissed";state.isAvailable=true;}
async function getManifest(){if(!_manifest){const manifest=await get(document.querySelector("link[rel=manifest")?.getAttribute("href"),"text");_manifest=JSON.parse(manifest);}
return _manifest;}
function hasScopeBeenInstalled(scope){return _getInstallationState(scope)==="accepted";}
async function show({onDone}={}){if(!state.isAvailable){return;}
if(nativePrompt){const res=await nativePrompt.prompt();_setInstallationState(res.outcome);state.canPromptToInstall=false;if(onDone){onDone(res);}}else if(isBrowserSafari()){dialog.add(InstallPrompt,{onClose:()=>{if(onDone){onDone({});}
this.decline();},});}}
function decline(){_setInstallationState("dismissed");state.canPromptToInstall=false;}
return state;},};serviceRegistry.add("pwa",pwaService);return __exports;});;

/* /web/static/src/core/py_js/py.js */
odoo.define('@web/core/py_js/py',['@web/core/py_js/py_interpreter','@web/core/py_js/py_parser','@web/core/py_js/py_tokenizer','@web/core/py_js/py_utils'],function(require){'use strict';let __exports={};const{evaluate}=require("@web/core/py_js/py_interpreter");const{parse}=require("@web/core/py_js/py_parser");const{tokenize}=require("@web/core/py_js/py_tokenizer");{const{evaluate}=require("@web/core/py_js/py_interpreter");Object.assign(__exports,{evaluate})};{const{parse}=require("@web/core/py_js/py_parser");Object.assign(__exports,{parse})};{const{tokenize}=require("@web/core/py_js/py_tokenizer");Object.assign(__exports,{tokenize})};{const{formatAST}=require("@web/core/py_js/py_utils");Object.assign(__exports,{formatAST})};__exports.parseExpr=parseExpr;function parseExpr(expr){const tokens=tokenize(expr);return parse(tokens);}
__exports.evaluateExpr=evaluateExpr;function evaluateExpr(expr,context={}){let ast;try{ast=parseExpr(expr);}catch(error){throw new EvalError(`Can not parse python expression: (${expr})\nError: ${error.message}`);}
try{return evaluate(ast,context);}catch(error){throw new EvalError(`Can not evaluate python expression: (${expr})\nError: ${error.message}`);}}
__exports.evaluateBooleanExpr=evaluateBooleanExpr;function evaluateBooleanExpr(expr,context={}){if(!expr||expr==='False'||expr==='0'){return false;}
if(expr==='True'||expr==='1'){return true;}
return evaluateExpr(`bool(${expr})`,context);}
return __exports;});;

/* /web/static/src/core/py_js/py_builtin.js */
odoo.define('@web/core/py_js/py_builtin',['@web/core/py_js/py_date'],function(require){'use strict';let __exports={};const{PyDate,PyDateTime,PyRelativeDelta,PyTime,PyTimeDelta}=require("@web/core/py_js/py_date");const EvaluationError=__exports.EvaluationError=class EvaluationError extends Error{}
__exports.execOnIterable=execOnIterable;function execOnIterable(iterable,func){if(iterable===null){throw new EvaluationError(`value not iterable`);}
if(typeof iterable==="object"&&!Array.isArray(iterable)&&!(iterable instanceof Set)){iterable=Object.keys(iterable);}
if(typeof iterable?.[Symbol.iterator]!=="function"){throw new EvaluationError(`value not iterable`);}
return func(iterable);}
const BUILTINS=__exports.BUILTINS={bool(value){switch(typeof value){case"number":return value!==0;case"string":return value!=="";case"boolean":return value;case"object":if(value===null||value===undefined){return false;}
if(value.isTrue){return value.isTrue();}
if(value instanceof Array){return!!value.length;}
if(value instanceof Set){return!!value.size;}
return Object.keys(value).length!==0;}
return true;},set(iterable){if(arguments.length>2){throw new EvaluationError(`set expected at most 1 argument, got (${arguments.length - 1}`);}
return execOnIterable(iterable,(iterable)=>{return new Set(iterable);});},max(...args){return Math.max(...args.slice(0,-1));},min(...args){return Math.min(...args.slice(0,-1));},time:{strftime(format){return PyDateTime.now().strftime(format);},},context_today(){return PyDate.today();},get current_date(){return this.today;},get today(){return PyDate.today().strftime("%Y-%m-%d");},get now(){return PyDateTime.now().strftime("%Y-%m-%d %H:%M:%S");},datetime:{time:PyTime,timedelta:PyTimeDelta,datetime:PyDateTime,date:PyDate,},relativedelta:PyRelativeDelta,true:true,false:false,};return __exports;});;

/* /web/static/src/core/py_js/py_date.js */
odoo.define('@web/core/py_js/py_date',['@web/core/py_js/py_parser'],function(require){'use strict';let __exports={};const{parseArgs}=require("@web/core/py_js/py_parser");const AssertionError=__exports.AssertionError=class AssertionError extends Error{}
const ValueError=__exports.ValueError=class ValueError extends Error{}
const NotSupportedError=__exports.NotSupportedError=class NotSupportedError extends Error{}
function fmt2(n){return String(n).padStart(2,"0");}
function fmt4(n){return String(n).padStart(4,"0");}
function divmod(a,b,fn){let mod=a%b;if((mod>0&&b<0)||(mod<0&&b>0)){mod+=b;}
return fn(Math.floor(a/b),mod);}
function assert(bool,message="AssertionError"){if(!bool){throw new AssertionError(message);}}
const DAYS_IN_MONTH=[null,31,28,31,30,31,30,31,31,30,31,30,31];const DAYS_BEFORE_MONTH=[null];for(let dbm=0,i=1;i<DAYS_IN_MONTH.length;++i){DAYS_BEFORE_MONTH.push(dbm);dbm+=DAYS_IN_MONTH[i];}
function daysInMonth(year,month){if(month===2&&isLeap(year)){return 29;}
return DAYS_IN_MONTH[month];}
function isLeap(year){return year%4===0&&(year%100!==0||year%400===0);}
function daysBeforeYear(year){const y=year-1;return y*365+Math.floor(y/4)-Math.floor(y/100)+Math.floor(y/400);}
function daysBeforeMonth(year,month){const postLeapFeb=month>2&&isLeap(year);return DAYS_BEFORE_MONTH[month]+(postLeapFeb?1:0);}
function ymd2ord(year,month,day){const dim=daysInMonth(year,month);if(!(1<=day&&day<=dim)){throw new ValueError(`day must be in 1..${dim}`);}
return daysBeforeYear(year)+daysBeforeMonth(year,month)+day;}
const DI400Y=daysBeforeYear(401);const DI100Y=daysBeforeYear(101);const DI4Y=daysBeforeYear(5);function ord2ymd(n){--n;let n400,n100,n4,n1,n0;divmod(n,DI400Y,function(_n400,n){n400=_n400;divmod(n,DI100Y,function(_n100,n){n100=_n100;divmod(n,DI4Y,function(_n4,n){n4=_n4;divmod(n,365,function(_n1,n){n1=_n1;n0=n;});});});});n=n0;const year=n400*400+1+n100*100+n4*4+n1;if(n1==4||n100==100){assert(n0===0);return{year:year-1,month:12,day:31,};}
const leapyear=n1===3&&(n4!==24||n100==3);assert(leapyear==isLeap(year));let month=(n+50)>>5;let preceding=DAYS_BEFORE_MONTH[month]+(month>2&&leapyear?1:0);if(preceding>n){--month;preceding-=DAYS_IN_MONTH[month]+(month===2&&leapyear?1:0);}
n-=preceding;return{year:year,month:month,day:n+1,};}
function tmxxx(year,month,day,hour,minute,second,microsecond){hour=hour||0;minute=minute||0;second=second||0;microsecond=microsecond||0;if(microsecond<0||microsecond>999999){divmod(microsecond,1000000,function(carry,ms){microsecond=ms;second+=carry;});}
if(second<0||second>59){divmod(second,60,function(carry,s){second=s;minute+=carry;});}
if(minute<0||minute>59){divmod(minute,60,function(carry,m){minute=m;hour+=carry;});}
if(hour<0||hour>23){divmod(hour,24,function(carry,h){hour=h;day+=carry;});}
if(month<1||month>12){divmod(month-1,12,function(carry,m){month=m+1;year+=carry;});}
const dim=daysInMonth(year,month);if(day<1||day>dim){if(day===0){--month;if(month>0){day=daysInMonth(year,month);}else{--year;month=12;day=31;}}else if(day==dim+1){++month;day=1;if(month>12){month=1;++year;}}else{const r=ord2ymd(ymd2ord(year,month,1)+(day-1));year=r.year;month=r.month;day=r.day;}}
return{year:year,month:month,day:day,hour:hour,minute:minute,second:second,microsecond:microsecond,};}
const PyDate=__exports.PyDate=class PyDate{static today(){return this.convertDate(new Date());}
static convertDate(date){const year=date.getFullYear();const month=date.getMonth()+1;const day=date.getDate();return new PyDate(year,month,day);}
constructor(year,month,day){this.year=year;this.month=month;this.day=day;}
static create(...args){const{year,month,day}=parseArgs(args,["year","month","day"]);return new PyDate(year,month,day);}
add(timedelta){const s=tmxxx(this.year,this.month,this.day+timedelta.days);return new PyDate(s.year,s.month,s.day);}
isEqual(other){if(!(other instanceof PyDate)){return false;}
return this.year===other.year&&this.month===other.month&&this.day===other.day;}
strftime(format){return format.replace(/%([A-Za-z])/g,(m,c)=>{switch(c){case"Y":return fmt4(this.year);case"m":return fmt2(this.month);case"d":return fmt2(this.day);}
throw new ValueError(`No known conversion for ${m}`);});}
substract(other){if(other instanceof PyTimeDelta){return this.add(other.negate());}
if(other instanceof PyDate){return PyTimeDelta.create(this.toordinal()-other.toordinal());}
throw new NotSupportedError();}
toJSON(){return this.strftime("%Y-%m-%d");}
toordinal(){return ymd2ord(this.year,this.month,this.day);}}
const PyDateTime=__exports.PyDateTime=class PyDateTime{static now(){return this.convertDate(new Date());}
static convertDate(date){const year=date.getFullYear();const month=date.getMonth()+1;const day=date.getDate();const hour=date.getHours();const minute=date.getMinutes();const second=date.getSeconds();return new PyDateTime(year,month,day,hour,minute,second,0);}
static create(...args){const namedArgs=parseArgs(args,["year","month","day","hour","minute","second","microsecond",]);const year=namedArgs.year;const month=namedArgs.month;const day=namedArgs.day;const hour=namedArgs.hour||0;const minute=namedArgs.minute||0;const second=namedArgs.second||0;const ms=namedArgs.micro/1000||0;return new PyDateTime(year,month,day,hour,minute,second,ms);}
static combine(...args){const{date,time}=parseArgs(args,["date","time"]);return PyDateTime.create(date.year,date.month,date.day,time.hour,time.minute,time.second);}
constructor(year,month,day,hour,minute,second,microsecond){this.year=year;this.month=month;this.day=day;this.hour=hour;this.minute=minute;this.second=second;this.microsecond=microsecond;}
add(timedelta){const s=tmxxx(this.year,this.month,this.day+timedelta.days,this.hour,this.minute,this.second+timedelta.seconds,this.microsecond+timedelta.microseconds);return new PyDateTime(s.year,s.month,s.day,s.hour,s.minute,s.second,s.microsecond);}
isEqual(other){if(!(other instanceof PyDateTime)){return false;}
return(this.year===other.year&&this.month===other.month&&this.day===other.day&&this.hour===other.hour&&this.minute===other.minute&&this.second===other.second&&this.microsecond===other.microsecond);}
strftime(format){return format.replace(/%([A-Za-z])/g,(m,c)=>{switch(c){case"Y":return fmt4(this.year);case"m":return fmt2(this.month);case"d":return fmt2(this.day);case"H":return fmt2(this.hour);case"M":return fmt2(this.minute);case"S":return fmt2(this.second);}
throw new ValueError(`No known conversion for ${m}`);});}
substract(timedelta){return this.add(timedelta.negate());}
toJSON(){return this.strftime("%Y-%m-%d %H:%M:%S");}
to_utc(){const d=new Date(this.year,this.month-1,this.day,this.hour,this.minute,this.second);const timedelta=PyTimeDelta.create({minutes:d.getTimezoneOffset()});return this.add(timedelta);}}
const PyTime=__exports.PyTime=class PyTime extends PyDate{static create(...args){const namedArgs=parseArgs(args,["hour","minute","second"]);const hour=namedArgs.hour||0;const minute=namedArgs.minute||0;const second=namedArgs.second||0;return new PyTime(hour,minute,second);}
constructor(hour,minute,second){const now=new Date();const year=now.getFullYear();const month=now.getMonth();const day=now.getDate();super(year,month,day);this.hour=hour;this.minute=minute;this.second=second;}
strftime(format){return format.replace(/%([A-Za-z])/g,(m,c)=>{switch(c){case"Y":return fmt4(this.year);case"m":return fmt2(this.month+1);case"d":return fmt2(this.day);case"H":return fmt2(this.hour);case"M":return fmt2(this.minute);case"S":return fmt2(this.second);}
throw new ValueError(`No known conversion for ${m}`);});}
toJSON(){return this.strftime("%H:%M:%S");}}
const DAYS_IN_YEAR=[31,59,90,120,151,181,212,243,273,304,334,366];const TIME_PERIODS=["hour","minute","second"];const PERIODS=["year","month","day",...TIME_PERIODS];const RELATIVE_KEYS="years months weeks days hours minutes seconds microseconds leapdays".split(" ");const ABSOLUTE_KEYS="year month day hour minute second microsecond weekday nlyearday yearday".split(" ");const argsSpec=["dt1","dt2"];const PyRelativeDelta=__exports.PyRelativeDelta=class PyRelativeDelta{static create(...args){const params=parseArgs(args,argsSpec);if("dt1"in params){throw new Error("relativedelta(dt1, dt2) is not supported for now");}
for(const period of PERIODS){if(period in params){const val=params[period];assert(val>=0,`${period} ${val} is out of range`);}}
for(const key of RELATIVE_KEYS){params[key]=params[key]||0;}
for(const key of ABSOLUTE_KEYS){params[key]=key in params?params[key]:null;}
params.days+=7*params.weeks;let yearDay=0;if(params.nlyearday){yearDay=params.nlyearday;}else if(params.yearday){yearDay=params.yearday;if(yearDay>59){params.leapDays=-1;}}
if(yearDay){for(let monthIndex=0;monthIndex<DAYS_IN_YEAR.length;monthIndex++){if(yearDay<=DAYS_IN_YEAR[monthIndex]){params.month=monthIndex+1;if(monthIndex===0){params.day=yearDay;}else{params.day=yearDay-DAYS_IN_YEAR[monthIndex-1];}
break;}}}
return new PyRelativeDelta(params);}
static add(date,delta){if(!(date instanceof PyDate||date instanceof PyDateTime)){throw new NotSupportedError();}
const s=tmxxx((delta.year||date.year)+delta.years,(delta.month||date.month)+delta.months,delta.day||date.day,delta.hour||date.hour||0,delta.minute||date.minute||0,delta.second||date.seconds||0,delta.microseconds||date.microseconds||0);const newDateTime=new PyDateTime(s.year,s.month,s.day,s.hour,s.minute,s.second,s.microsecond);let leapDays=0;if(delta.leapDays&&newDateTime.month>2&&isLeap(newDateTime.year)){leapDays=delta.leapDays;}
const temp=newDateTime.add(PyTimeDelta.create({days:delta.days+leapDays,hours:delta.hours,minutes:delta.minutes,seconds:delta.seconds,microseconds:delta.microseconds,}));const hasTime=Boolean(temp.hour||temp.minute||temp.second||temp.microsecond);const returnDate=!hasTime&&date instanceof PyDate?new PyDate(temp.year,temp.month,temp.day):temp;if(delta.weekday!==null){const wantedDow=delta.weekday+1;const _date=new Date(returnDate.year,returnDate.month-1,returnDate.day);const days=(7-_date.getDay()+wantedDow)%7;return returnDate.add(new PyTimeDelta(days,0,0));}
return returnDate;}
static substract(date,delta){return PyRelativeDelta.add(date,delta.negate());}
constructor(params={},sign=+1){this.years=sign*params.years;this.months=sign*params.months;this.days=sign*params.days;this.hours=sign*params.hours;this.minutes=sign*params.minutes;this.seconds=sign*params.seconds;this.microseconds=sign*params.microseconds;this.leapDays=params.leapDays;this.year=params.year;this.month=params.month;this.day=params.day;this.hour=params.hour;this.minute=params.minute;this.second=params.second;this.microsecond=params.microsecond;this.weekday=params.weekday;}
negate(){return new PyRelativeDelta(this,-1);}
isEqual(other){throw new NotSupportedError();}}
const TIME_DELTA_KEYS="weeks days hours minutes seconds milliseconds microseconds".split(" ");function modf(x){const mod=x%1;return[mod<0?mod+1:mod,Math.floor(x)];}
const PyTimeDelta=__exports.PyTimeDelta=class PyTimeDelta{static create(...args){const namedArgs=parseArgs(args,["days","seconds","microseconds"]);for(const key of TIME_DELTA_KEYS){namedArgs[key]=namedArgs[key]||0;}
let d=0;let s=0;let us=0;const days=namedArgs.days+namedArgs.weeks*7;let seconds=namedArgs.seconds+60*namedArgs.minutes+3600*namedArgs.hours;let microseconds=namedArgs.microseconds+1000*namedArgs.milliseconds;const[dFrac,dInt]=modf(days);d=dInt;let daysecondsfrac=0;if(dFrac){const[dsFrac,dsInt]=modf(dFrac*24*3600);s=dsInt;daysecondsfrac=dsFrac;}
const[sFrac,sInt]=modf(seconds);seconds=sInt;const secondsfrac=sFrac+daysecondsfrac;divmod(seconds,24*3600,(days,seconds)=>{d+=days;s+=seconds;});microseconds+=secondsfrac*1e6;divmod(microseconds,1000000,(seconds,microseconds)=>{divmod(seconds,24*3600,(days,seconds)=>{d+=days;s+=seconds;us+=Math.round(microseconds);});});return new PyTimeDelta(d,s,us);}
constructor(days,seconds,microseconds){this.days=days;this.seconds=seconds;this.microseconds=microseconds;}
add(other){return PyTimeDelta.create({days:this.days+other.days,seconds:this.seconds+other.seconds,microseconds:this.microseconds+other.microseconds,});}
divide(n){const us=(this.days*24*3600+this.seconds)*1e6+this.microseconds;return PyTimeDelta.create({microseconds:Math.floor(us/n)});}
isEqual(other){if(!(other instanceof PyTimeDelta)){return false;}
return(this.days===other.days&&this.seconds===other.seconds&&this.microseconds===other.microseconds);}
isTrue(){return this.days!==0||this.seconds!==0||this.microseconds!==0;}
multiply(n){return PyTimeDelta.create({days:n*this.days,seconds:n*this.seconds,microseconds:n*this.microseconds,});}
negate(){return PyTimeDelta.create({days:-this.days,seconds:-this.seconds,microseconds:-this.microseconds,});}
substract(other){return PyTimeDelta.create({days:this.days-other.days,seconds:this.seconds-other.seconds,microseconds:this.microseconds-other.microseconds,});}
total_seconds(){return this.days*86400+this.seconds+this.microseconds/1000000;}}
return __exports;});;

/* /web/static/src/core/py_js/py_interpreter.js */
odoo.define('@web/core/py_js/py_interpreter',['@web/core/py_js/py_builtin','@web/core/py_js/py_date','@web/core/py_js/py_utils','@web/core/py_js/py_parser'],function(require){'use strict';let __exports={};const{BUILTINS,EvaluationError,execOnIterable}=require("@web/core/py_js/py_builtin");const{NotSupportedError,PyDate,PyDateTime,PyRelativeDelta,PyTime,PyTimeDelta,}=require("@web/core/py_js/py_date");const{PY_DICT,toPyDict}=require("@web/core/py_js/py_utils");const{parseArgs}=require("@web/core/py_js/py_parser");const isTrue=BUILTINS.bool;function applyUnaryOp(ast,context){const value=evaluate(ast.right,context);switch(ast.op){case"-":if(value instanceof Object&&value.negate){return value.negate();}
return-value;case"+":return value;case"not":return!isTrue(value);}
throw new EvaluationError(`Unknown unary operator: ${ast.op}`);}
function pytypeIndex(val){switch(typeof val){case"object":return val===null?1:Array.isArray(val)?5:3;case"number":return 2;case"string":return 4;}
throw new EvaluationError(`Unknown type: ${typeof val}`);}
function isConstructor(obj){return!!obj.prototype&&!!obj.prototype.constructor.name;}
function isLess(left,right){if(typeof left==="number"&&typeof right==="number"){return left<right;}
if(typeof left==="boolean"){left=left?1:0;}
if(typeof right==="boolean"){right=right?1:0;}
const leftIndex=pytypeIndex(left);const rightIndex=pytypeIndex(right);if(leftIndex===rightIndex){return left<right;}
return leftIndex<rightIndex;}
function isEqual(left,right){if(typeof left!==typeof right){if(typeof left==="boolean"&&typeof right==="number"){return right===(left?1:0);}
if(typeof left==="number"&&typeof right==="boolean"){return left===(right?1:0);}
return false;}
if(left instanceof Object&&left.isEqual){return left.isEqual(right);}
return left===right;}
function isIn(left,right){if(Array.isArray(right)){return right.includes(left);}
if(typeof right==="string"&&typeof left==="string"){return right.includes(left);}
if(typeof right==="object"){return left in right;}
return false;}
function applyBinaryOp(ast,context){const left=evaluate(ast.left,context);const right=evaluate(ast.right,context);switch(ast.op){case"+":{const relativeDeltaOnLeft=left instanceof PyRelativeDelta;const relativeDeltaOnRight=right instanceof PyRelativeDelta;if(relativeDeltaOnLeft||relativeDeltaOnRight){const date=relativeDeltaOnLeft?right:left;const delta=relativeDeltaOnLeft?left:right;return PyRelativeDelta.add(date,delta);}
const timeDeltaOnLeft=left instanceof PyTimeDelta;const timeDeltaOnRight=right instanceof PyTimeDelta;if(timeDeltaOnLeft&&timeDeltaOnRight){return left.add(right);}
if(timeDeltaOnLeft){if(right instanceof PyDate||right instanceof PyDateTime){return right.add(left);}else{throw new NotSupportedError();}}
if(timeDeltaOnRight){if(left instanceof PyDate||left instanceof PyDateTime){return left.add(right);}else{throw new NotSupportedError();}}
if(left instanceof Array&&right instanceof Array){return[...left,...right];}
return left+right;}
case"-":{const isRightDelta=right instanceof PyRelativeDelta;if(isRightDelta){return PyRelativeDelta.substract(left,right);}
const timeDeltaOnRight=right instanceof PyTimeDelta;if(timeDeltaOnRight){if(left instanceof PyTimeDelta){return left.substract(right);}else if(left instanceof PyDate||left instanceof PyDateTime){return left.substract(right);}else{throw new NotSupportedError();}}
if(left instanceof PyDate){return left.substract(right);}
return left-right;}
case"*":{const timeDeltaOnLeft=left instanceof PyTimeDelta;const timeDeltaOnRight=right instanceof PyTimeDelta;if(timeDeltaOnLeft||timeDeltaOnRight){const number=timeDeltaOnLeft?right:left;const delta=timeDeltaOnLeft?left:right;return delta.multiply(number);}
return left*right;}
case"/":return left/right;case"%":return left%right;case"//":if(left instanceof PyTimeDelta){return left.divide(right);}
return Math.floor(left/right);case"**":return left**right;case"==":return isEqual(left,right);case"<>":case"!=":return!isEqual(left,right);case"<":return isLess(left,right);case">":return isLess(right,left);case">=":return isEqual(left,right)||isLess(right,left);case"<=":return isEqual(left,right)||isLess(left,right);case"in":return isIn(left,right);case"not in":return!isIn(left,right);}
throw new EvaluationError(`Unknown binary operator: ${ast.op}`);}
const DICT={get(...args){const{key,defValue}=parseArgs(args,["key","defValue"]);if(key in this){return this[key];}else if(defValue){return defValue;}
return null;},};const STRING={lower(){return this.toLowerCase();},upper(){return this.toUpperCase();},};function applyFunc(key,func,set,...args){if(args.length===1){return new Set(set);}
if(args.length>2){throw new EvaluationError(`${key}: py_js supports at most 1 argument, got (${args.length - 1})`);}
return execOnIterable(args[0],func);}
const SET={intersection(...args){return applyFunc("intersection",(iterable)=>{const intersection=new Set();for(const i of iterable){if(this.has(i)){intersection.add(i);}}
return intersection;},this,...args);},difference(...args){return applyFunc("difference",(iterable)=>{iterable=new Set(iterable);const difference=new Set();for(const e of this){if(!iterable.has(e)){difference.add(e);}}
return difference;},this,...args);},union(...args){return applyFunc("union",(iterable)=>{return new Set([...this,...iterable]);},this,...args);},};function methods(_class){return Object.getOwnPropertyNames(_class.prototype).map((prop)=>_class.prototype[prop]);}
const allowedFns=new Set([BUILTINS.time.strftime,BUILTINS.set,BUILTINS.bool,BUILTINS.min,BUILTINS.max,BUILTINS.context_today,BUILTINS.datetime.datetime.now,BUILTINS.datetime.datetime.combine,BUILTINS.datetime.date.today,...methods(BUILTINS.relativedelta),...Object.values(BUILTINS.datetime).flatMap((obj)=>methods(obj)),...Object.values(SET),...Object.values(DICT),...Object.values(STRING),]);const unboundFn=Symbol("unbound function");__exports.evaluate=evaluate;function evaluate(ast,context={}){const dicts=new Set();let pyContext;const evalContext=Object.create(context);if(!evalContext.context){Object.defineProperty(evalContext,"context",{get(){if(!pyContext){pyContext=toPyDict(context);}
return pyContext;},});}
function _innerEvaluate(ast){switch(ast.type){case 0:case 1:return ast.value;case 5:if(ast.value in evalContext){return evalContext[ast.value];}else if(ast.value in BUILTINS){return BUILTINS[ast.value];}else{throw new EvaluationError(`Name '${ast.value}' is not defined`);}
case 3:return null;case 2:return ast.value;case 6:return applyUnaryOp(ast,evalContext);case 7:return applyBinaryOp(ast,evalContext);case 14:{const left=_evaluate(ast.left);if(ast.op==="and"){return isTrue(left)?_evaluate(ast.right):left;}else{return isTrue(left)?left:_evaluate(ast.right);}}
case 4:case 10:return ast.value.map(_evaluate);case 11:{const dict={};for(const key in ast.value){dict[key]=_evaluate(ast.value[key]);}
dicts.add(dict);return dict;}
case 8:{const fnValue=_evaluate(ast.fn);const args=ast.args.map(_evaluate);const kwargs={};for(const kwarg in ast.kwargs){kwargs[kwarg]=_evaluate(ast.kwargs[kwarg]);}
if(fnValue===PyDate||fnValue===PyDateTime||fnValue===PyTime||fnValue===PyRelativeDelta||fnValue===PyTimeDelta){return fnValue.create(...args,kwargs);}
return fnValue(...args,kwargs);}
case 12:{const dict=_evaluate(ast.target);const key=_evaluate(ast.key);return dict[key];}
case 13:{if(isTrue(_evaluate(ast.condition))){return _evaluate(ast.ifTrue);}else{return _evaluate(ast.ifFalse);}}
case 15:{let left=_evaluate(ast.obj);let result;if(dicts.has(left)||Object.isPrototypeOf.call(PY_DICT,left)){result=DICT[ast.key];}else if(typeof left==="string"){result=STRING[ast.key];}else if(left instanceof Set){result=SET[ast.key];}else if(ast.key=="get"&&typeof left==="object"){result=DICT[ast.key];left=toPyDict(left);}else{result=left[ast.key];}
if(typeof result==="function"){if(!isConstructor(result)){const bound=result.bind(left);bound[unboundFn]=result;return bound;}}
return result;}}
throw new EvaluationError(`AST of type ${ast.type} cannot be evaluated`);}
function _evaluate(ast){const val=_innerEvaluate(ast);if(typeof val==="function"&&!allowedFns.has(val)&&!allowedFns.has(val[unboundFn])){throw new Error("Invalid Function Call");}
return val;}
return _evaluate(ast);}
return __exports;});;

/* /web/static/src/core/py_js/py_parser.js */
odoo.define('@web/core/py_js/py_parser',['@web/core/py_js/py_tokenizer'],function(require){'use strict';let __exports={};const{binaryOperators,comparators}=require("@web/core/py_js/py_tokenizer");const ParserError=__exports.ParserError=class ParserError extends Error{}
const chainedOperators=new Set(comparators);const infixOperators=new Set(binaryOperators.concat(comparators));__exports.bp=bp;function bp(symbol){switch(symbol){case"=":return 10;case"if":return 20;case"in":case"not in":case"is":case"is not":case"<":case"<=":case">":case">=":case"<>":case"==":case"!=":return 60;case"or":return 30;case"and":return 40;case"not":return 50;case"|":return 70;case"^":return 80;case"&":return 90;case"<<":case">>":return 100;case"+":case"-":return 110;case"*":case"/":case"//":case"%":return 120;case"**":return 140;case".":case"(":case"[":return 150;}
return 0;}
function bindingPower(token){return token.type===2?bp(token.value):0;}
function isSymbol(token,value){return token.type===2&&token.value===value;}
function parsePrefix(current,tokens){switch(current.type){case 0:return{type:0,value:current.value};case 1:return{type:1,value:current.value};case 4:if(current.value==="None"){return{type:3};}else{return{type:2,value:current.value==="True"};}
case 3:return{type:5,value:current.value};case 2:switch(current.value){case"-":case"+":case"~":return{type:6,op:current.value,right:_parse(tokens,130),};case"not":return{type:6,op:current.value,right:_parse(tokens,50),};case"(":{const content=[];let isTuple=false;while(tokens[0]&&!isSymbol(tokens[0],")")){content.push(_parse(tokens,0));if(tokens[0]){if(tokens[0]&&isSymbol(tokens[0],",")){isTuple=true;tokens.shift();}else if(!isSymbol(tokens[0],")")){throw new ParserError("parsing error");}}else{throw new ParserError("parsing error");}}
if(!tokens[0]||!isSymbol(tokens[0],")")){throw new ParserError("parsing error");}
tokens.shift();isTuple=isTuple||content.length===0;return isTuple?{type:10,value:content}:content[0];}
case"[":{const value=[];while(tokens[0]&&!isSymbol(tokens[0],"]")){value.push(_parse(tokens,0));if(tokens[0]){if(isSymbol(tokens[0],",")){tokens.shift();}else if(!isSymbol(tokens[0],"]")){throw new ParserError("parsing error");}}}
if(!tokens[0]||!isSymbol(tokens[0],"]")){throw new ParserError("parsing error");}
tokens.shift();return{type:4,value};}
case"{":{const dict={};while(tokens[0]&&!isSymbol(tokens[0],"}")){const key=_parse(tokens,0);if((key.type!==1&&key.type!==0)||!tokens[0]||!isSymbol(tokens[0],":")){throw new ParserError("parsing error");}
tokens.shift();const value=_parse(tokens,0);dict[key.value]=value;if(isSymbol(tokens[0],",")){tokens.shift();}}
if(!tokens.shift()){throw new ParserError("parsing error");}
return{type:11,value:dict};}}}
throw new ParserError("Token cannot be parsed");}
function parseInfix(left,current,tokens){switch(current.type){case 2:if(infixOperators.has(current.value)){let right=_parse(tokens,bindingPower(current));if(current.value==="and"||current.value==="or"){return{type:14,op:current.value,left,right,};}else if(current.value==="."){if(right.type===5){return{type:15,obj:left,key:right.value,};}else{throw new ParserError("invalid obj lookup");}}
let op={type:7,op:current.value,left,right,};while(chainedOperators.has(current.value)&&tokens[0]&&tokens[0].type===2&&chainedOperators.has(tokens[0].value)){const nextToken=tokens.shift();op={type:14,op:"and",left:op,right:{type:7,op:nextToken.value,left:right,right:_parse(tokens,bindingPower(nextToken)),},};right=op.right.right;}
return op;}
switch(current.value){case"(":{const args=[];const kwargs={};while(tokens[0]&&!isSymbol(tokens[0],")")){const arg=_parse(tokens,0);if(arg.type===9){kwargs[arg.name.value]=arg.value;}else{args.push(arg);}
if(tokens[0]&&isSymbol(tokens[0],",")){tokens.shift();}}
if(!tokens[0]||!isSymbol(tokens[0],")")){throw new ParserError("parsing error");}
tokens.shift();return{type:8,fn:left,args,kwargs};}
case"=":if(left.type===5){return{type:9,name:left,value:_parse(tokens,10),};}
break;case"[":{const key=_parse(tokens);if(!tokens[0]||!isSymbol(tokens[0],"]")){throw new ParserError("parsing error");}
tokens.shift();return{type:12,target:left,key:key,};}
case"if":{const condition=_parse(tokens);if(!tokens[0]||!isSymbol(tokens[0],"else")){throw new ParserError("parsing error");}
tokens.shift();const ifFalse=_parse(tokens);return{type:13,condition,ifTrue:left,ifFalse,};}}}
throw new ParserError("Token cannot be parsed");}
function _parse(tokens,bp=0){const token=tokens.shift();let expr=parsePrefix(token,tokens);while(tokens[0]&&bindingPower(tokens[0])>bp){expr=parseInfix(expr,tokens.shift(),tokens);}
return expr;}
__exports.parse=parse;function parse(tokens){if(tokens.length){const ast=_parse(tokens,0);if(tokens.length){throw new ParserError("Token(s) unused");}
return ast;}
throw new ParserError("Missing token");}
__exports.parseArgs=parseArgs;function parseArgs(args,spec){const last=args[args.length-1];const unnamedArgs=typeof last==="object"?args.slice(0,-1):args;const kwargs=typeof last==="object"?last:{};for(const[index,val]of unnamedArgs.entries()){kwargs[spec[index]]=val;}
return kwargs;}
return __exports;});;

/* /web/static/src/core/py_js/py_tokenizer.js */
odoo.define('@web/core/py_js/py_tokenizer',[],function(require){'use strict';let __exports={};const TokenizerError=__exports.TokenizerError=class TokenizerError extends Error{}
const directMap={"\\":"\\",'"':'"',"'":"'",a:"\x07",b:"\x08",f:"\x0c",n:"\n",r:"\r",t:"\t",v:"\v",};function decodeStringLiteral(str,unicode){const out=[];let code;for(var i=0;i<str.length;++i){if(str[i]!=="\\"){out.push(str[i]);continue;}
var escape=str[i+1];if(escape in directMap){out.push(directMap[escape]);++i;continue;}
switch(escape){case"\n":++i;continue;case"N":if(!unicode){break;}
throw new TokenizerError("SyntaxError: \\N{} escape not implemented");case"u":if(!unicode){break;}
var uni=str.slice(i+2,i+6);if(!/[0-9a-f]{4}/i.test(uni)){throw new TokenizerError(["SyntaxError: (unicode error) 'unicodeescape' codec"," can't decode bytes in position ",i,"-",i+4,": truncated \\uXXXX escape",].join(""));}
code=parseInt(uni,16);out.push(String.fromCharCode(code));i+=5;continue;case"U":if(!unicode){break;}
throw new TokenizerError("SyntaxError: \\U escape not implemented");case"x":var hex=str.slice(i+2,i+4);if(!/[0-9a-f]{2}/i.test(hex)){if(!unicode){throw new TokenizerError("ValueError: invalid \\x escape");}
throw new TokenizerError(["SyntaxError: (unicode error) 'unicodeescape'"," codec can't decode bytes in position ",i,"-",i+2,": truncated \\xXX escape",].join(""));}
code=parseInt(hex,16);out.push(String.fromCharCode(code));i+=3;continue;default:if(!/[0-8]/.test(escape)){break;}
var r=/[0-8]{1,3}/g;r.lastIndex=i+1;var m=r.exec(str);var oct=m[0];code=parseInt(oct,8);out.push(String.fromCharCode(code));i+=oct.length;continue;}
out.push("\\");}
return out.join("");}
const constants=new Set(["None","False","True"]);const comparators=__exports.comparators=["in","not","not in","is","is not","<","<=",">",">=","<>","!=","==",];const binaryOperators=__exports.binaryOperators=["or","and","|","^","&","<<",">>","+","-","*","/","//","%","~","**",".",];const unaryOperators=__exports.unaryOperators=["-"];const symbols=new Set([...["(",")","[","]","{","}",":",","],...["if","else","lambda","="],...comparators,...binaryOperators,...unaryOperators,]);function group(...args){return"("+args.join("|")+")";}
const Name="[a-zA-Z_]\\w*";const Whitespace="[ \\f\\t]*";const DecNumber="\\d+(L|l)?";const IntNumber=DecNumber;const Exponent="[eE][+-]?\\d+";const PointFloat=group(`\\d+\\.\\d*(${Exponent})?`,`\\.\\d+(${Exponent})?`);const FloatNumber=group(PointFloat,`\\d+${Exponent}`);const Number=group(FloatNumber,IntNumber);const Operator=group("\\*\\*=?",">>=?","<<=?","<>","!=","//=?","[+\\-*/%&|^=<>]=?","~");const Bracket="[\\[\\]\\(\\)\\{\\}]";const Special="[:;.,`@]";const Funny=group(Operator,Bracket,Special);const ContStr=group("([uU])?'([^\n'\\\\]*(?:\\\\.[^\n'\\\\]*)*)'",'([uU])?"([^\n"\\\\]*(?:\\\\.[^\n"\\\\]*)*)"');const PseudoToken=Whitespace+group(Number,Funny,ContStr,Name);const NumberPattern=new RegExp("^"+Number+"$");const StringPattern=new RegExp("^"+ContStr+"$");const NamePattern=new RegExp("^"+Name+"$");const strip=new RegExp("^"+Whitespace);__exports.tokenize=tokenize;function tokenize(str){const tokens=[];const max=str.length;let start=0;let end=0;const pseudoprog=new RegExp(PseudoToken,"g");while(pseudoprog.lastIndex<max){const pseudomatch=pseudoprog.exec(str);if(!pseudomatch){if(/^\s+$/.test(str.slice(end))){break;}
throw new TokenizerError("Failed to tokenize <<"+
str+">> at index "+
(end||0)+"; parsed so far: "+
tokens);}
if(pseudomatch.index>end){if(str.slice(end,pseudomatch.index).trim()){throw new TokenizerError("Invalid expression");}}
start=pseudomatch.index;end=pseudoprog.lastIndex;let token=str.slice(start,end).replace(strip,"");if(NumberPattern.test(token)){tokens.push({type:0,value:parseFloat(token),});}else if(StringPattern.test(token)){var m=StringPattern.exec(token);tokens.push({type:1,value:decodeStringLiteral(m[3]!==undefined?m[3]:m[5],!!(m[2]||m[4])),});}else if(symbols.has(token)){if(token==="in"&&tokens.length>0&&tokens[tokens.length-1].value==="not"){token="not in";tokens.pop();}else if(token==="not"&&tokens.length>0&&tokens[tokens.length-1].value==="is"){token="is not";tokens.pop();}
tokens.push({type:2,value:token,});}else if(constants.has(token)){tokens.push({type:4,value:token,});}else if(NamePattern.test(token)){tokens.push({type:3,value:token,});}else{throw new TokenizerError("Invalid expression");}}
return tokens;}
return __exports;});;

/* /web/static/src/core/py_js/py_utils.js */
odoo.define('@web/core/py_js/py_utils',['@web/core/py_js/py_parser','@web/core/py_js/py_date'],function(require){'use strict';let __exports={};const{bp}=require("@web/core/py_js/py_parser");const{PyDate,PyDateTime}=require("@web/core/py_js/py_date");__exports.toPyValue=toPyValue;function toPyValue(value){switch(typeof value){case"string":return{type:1,value};case"number":return{type:0,value};case"boolean":return{type:2,value};case"object":if(Array.isArray(value)){return{type:4,value:value.map(toPyValue)};}else if(value===null){return{type:3};}else if(value instanceof Date){return{type:1,value:PyDateTime.convertDate(value)};}else if(value instanceof PyDate||value instanceof PyDateTime){return{type:1,value};}else{const content={};for(const key in value){content[key]=toPyValue(value[key]);}
return{type:11,value:content};}
default:throw new Error("Invalid type");}}
__exports.formatAST=formatAST;function formatAST(ast,lbp=0){switch(ast.type){case 3:return"None";case 1:return JSON.stringify(ast.value);case 0:return String(ast.value);case 2:return ast.value?"True":"False";case 4:return`[${ast.value.map(formatAST).join(", ")}]`;case 6:if(ast.op==="not"){return`not `+formatAST(ast.right,50);}
return ast.op+formatAST(ast.right,130);case 7:{const abp=bp(ast.op);const str=`${formatAST(ast.left, abp)} ${ast.op} ${formatAST(ast.right, abp)}`;return abp<lbp?`(${str})`:str;}
case 11:{const pairs=[];for(const k in ast.value){pairs.push(`"${k}": ${formatAST(ast.value[k])}`);}
return`{`+pairs.join(", ")+`}`;}
case 10:return`(${ast.value.map(formatAST).join(", ")})`;case 5:return ast.value;case 12:{return`${formatAST(ast.target)}[${formatAST(ast.key)}]`;}
case 13:{const{ifTrue,condition,ifFalse}=ast;return`${formatAST(ifTrue)} if ${formatAST(condition)} else ${formatAST(ifFalse)}`;}
case 14:{const abp=bp(ast.op);const str=`${formatAST(ast.left, abp)} ${ast.op} ${formatAST(ast.right, abp)}`;return abp<lbp?`(${str})`:str;}
case 15:return`${formatAST(ast.obj, 150)}.${ast.key}`;case 8:{const args=ast.args.map(formatAST);const kwargs=[];for(const kwarg in ast.kwargs){kwargs.push(`${kwarg} = ${formatAST(ast.kwargs[kwarg])}`);}
const argStr=args.concat(kwargs).join(", ");return`${formatAST(ast.fn)}(${argStr})`;}}
throw new Error("invalid expression: "+ast);}
const PY_DICT=__exports.PY_DICT=Object.create(null);__exports.toPyDict=toPyDict;function toPyDict(obj){return new Proxy(obj,{getPrototypeOf(){return PY_DICT;},});}
return __exports;});;

/* /web/static/src/core/record_selectors/multi_record_selector.js */
odoo.define('@web/core/record_selectors/multi_record_selector',['@odoo/owl','@web/core/tags_list/tags_list','@web/core/utils/hooks','@web/core/record_selectors/record_autocomplete','@web/core/l10n/translation','@web/core/record_selectors/tag_navigation_hook'],function(require){'use strict';let __exports={};const{Component,onWillStart,onWillUpdateProps}=require("@odoo/owl");const{TagsList}=require("@web/core/tags_list/tags_list");const{useService}=require("@web/core/utils/hooks");const{RecordAutocomplete}=require("@web/core/record_selectors/record_autocomplete");const{_t}=require("@web/core/l10n/translation");const{useTagNavigation}=require("@web/core/record_selectors/tag_navigation_hook");const MultiRecordSelector=__exports.MultiRecordSelector=class MultiRecordSelector extends Component{static props={resIds:{type:Array,element:Number},resModel:String,update:Function,domain:{type:Array,optional:true},context:{type:Object,optional:true},fieldString:{type:String,optional:true},placeholder:{type:String,optional:true},};static components={RecordAutocomplete,TagsList};static template="web.MultiRecordSelector";setup(){this.nameService=useService("name");this.onTagKeydown=useTagNavigation("multiRecordSelector",this.deleteTag.bind(this));onWillStart(()=>this.computeDerivedParams());onWillUpdateProps((nextProps)=>this.computeDerivedParams(nextProps));}
async computeDerivedParams(props=this.props){const displayNames=await this.getDisplayNames(props);this.tags=this.getTags(props,displayNames);}
async getDisplayNames(props){const ids=this.getIds(props);return this.nameService.loadDisplayNames(props.resModel,ids);}
get placeholder(){return this.getIds().length?"":this.props.placeholder;}
getIds(props=this.props){return props.resIds;}
getTags(props,displayNames){return props.resIds.map((id,index)=>{const text=typeof displayNames[id]==="string"?displayNames[id]:_t("Inaccessible/missing record ID: %s",id);return{text,onDelete:()=>{this.deleteTag(index);},onKeydown:this.onTagKeydown,};});}
deleteTag(index){this.props.update([...this.props.resIds.slice(0,index),...this.props.resIds.slice(index+1),]);}
update(resIds){this.props.update([...this.props.resIds,...resIds]);}}
return __exports;});;

/* /web/static/src/core/record_selectors/record_autocomplete.js */
odoo.define('@web/core/record_selectors/record_autocomplete',['@odoo/owl','@web/core/autocomplete/autocomplete','@web/core/l10n/translation','@web/core/domain','@web/core/registry','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{AutoComplete}=require("@web/core/autocomplete/autocomplete");const{_t}=require("@web/core/l10n/translation");const{Domain}=require("@web/core/domain");const{registry}=require("@web/core/registry");const{useOwnedDialogs,useService}=require("@web/core/utils/hooks");const SEARCH_LIMIT=7;const SEARCH_MORE_LIMIT=320;const RecordAutocomplete=__exports.RecordAutocomplete=class RecordAutocomplete extends Component{static props={resModel:String,update:Function,multiSelect:Boolean,getIds:Function,value:String,domain:{type:Array,optional:true},context:{type:Object,optional:true},className:{type:String,optional:true},fieldString:{type:String,optional:true},placeholder:{type:String,optional:true},};static components={AutoComplete};static template="web.RecordAutocomplete";setup(){this.orm=useService("orm");this.nameService=useService("name");this.addDialog=useOwnedDialogs();this.sources=[{placeholder:_t("Loading..."),options:this.loadOptionsSource.bind(this),},];}
addNames(options){const displayNames=Object.fromEntries(options);this.nameService.addDisplayNames(this.props.resModel,displayNames);}
getIds(){return this.props.getIds();}
async loadOptionsSource(name){if(this.lastProm){this.lastProm.abort(false);}
this.lastProm=this.search(name,SEARCH_LIMIT+1);const nameGets=(await this.lastProm).map(([id,label])=>([id,label?label.split("\n")[0]:_t("Unnamed")]));this.addNames(nameGets);const options=nameGets.map(([value,label])=>({value,label}));if(SEARCH_LIMIT<nameGets.length){options.push({label:_t("Search More..."),action:this.onSearchMore.bind(this,name),classList:"o_m2o_dropdown_option",});}
if(options.length===0){options.push({label:_t("(no result)"),unselectable:true});}
return options;}
async onSearchMore(name){const{fieldString,multiSelect,resModel}=this.props;let operator;const ids=[];if(name){const nameGets=await this.search(name,SEARCH_MORE_LIMIT);this.addNames(nameGets);operator="in";ids.push(...nameGets.map((nameGet)=>nameGet[0]));}else{operator="not in";ids.push(...this.getIds());}
const dynamicFilters=ids.length?[{description:_t("Quick search: %s",name),domain:[["id",operator,ids]],},]:undefined;const SelectCreateDialog=registry.category("dialogs").get("select_create");this.addDialog(SelectCreateDialog,{title:_t("Search: %s",fieldString),dynamicFilters,domain:this.getDomain(),resModel,noCreate:true,multiSelect,context:this.props.context||{},onSelected:(resId)=>{const resIds=Array.isArray(resId)?resId:[resId];this.props.update([...resIds]);},});}
getDomain(){const domainIds=Domain.not([["id","in",this.getIds()]]);if(this.props.domain){return Domain.and([this.props.domain,domainIds]).toList();}
return domainIds.toList();}
onSelect({value:resId,action},params){if(action){return action(params);}
this.props.update([resId]);}
search(name,limit){const domain=this.getDomain();return this.orm.call(this.props.resModel,"name_search",[],{name,args:domain,limit,context:this.props.context||{},});}
onChange({inputValue}){if(!inputValue.length){this.props.update([]);}}}
return __exports;});;

/* /web/static/src/core/record_selectors/record_selector.js */
odoo.define('@web/core/record_selectors/record_selector',['@odoo/owl','@web/core/utils/hooks','@web/core/record_selectors/record_autocomplete','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Component,onWillStart,onWillUpdateProps}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{RecordAutocomplete}=require("@web/core/record_selectors/record_autocomplete");const{_t}=require("@web/core/l10n/translation");const RecordSelector=__exports.RecordSelector=class RecordSelector extends Component{static props={resId:[Number,{value:false}],resModel:String,update:Function,domain:{type:Array,optional:true},context:{type:Object,optional:true},fieldString:{type:String,optional:true},placeholder:{type:String,optional:true},};static components={RecordAutocomplete};static template="web.RecordSelector";setup(){this.nameService=useService("name");onWillStart(()=>this.computeDerivedParams());onWillUpdateProps((nextProps)=>this.computeDerivedParams(nextProps));}
async computeDerivedParams(props=this.props){const displayNames=await this.getDisplayNames(props);this.displayName=this.getDisplayName(props,displayNames);}
async getDisplayNames(props){const ids=this.getIds(props);return this.nameService.loadDisplayNames(props.resModel,ids);}
getDisplayName(props=this.props,displayNames){const{resId}=props;if(resId===false){return"";}
return typeof displayNames[resId]==="string"?displayNames[resId]:_t("Inaccessible/missing record ID: %s",resId);}
getIds(props=this.props){if(props.resId){return[props.resId];}
return[];}
update(resIds){this.props.update(resIds[0]||false);this.render(true);}}
return __exports;});;

/* /web/static/src/core/record_selectors/tag_navigation_hook.js */
odoo.define('@web/core/record_selectors/tag_navigation_hook',['@web/core/hotkeys/hotkey_service','@odoo/owl'],function(require){'use strict';let __exports={};const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const{useEffect,useRef}=require("@odoo/owl");__exports.useTagNavigation=useTagNavigation;function useTagNavigation(refName,deleteTag){const ref=useRef(refName);useEffect((autocomplete)=>{if(!autocomplete){return;}
autocomplete.addEventListener("keydown",onAutoCompleteKeydown);return()=>{autocomplete.removeEventListener("keydown",onAutoCompleteKeydown);};},()=>[ref.el?.querySelector(".o-autocomplete")]);function focusTag(index){const tags=ref.el.getElementsByClassName("o_tag");if(tags.length){if(index===undefined){tags[tags.length-1].focus();}else{tags[index].focus();}}}
function onAutoCompleteKeydown(ev){if(ev.isComposing){return;}
const hotkey=getActiveHotkey(ev);const input=ev.target.closest(".o-autocomplete--input");const autoCompleteMenuOpened=!!ref.el.querySelector(".o-autocomplete--dropdown-menu");switch(hotkey){case"arrowleft":{if(input.selectionStart||autoCompleteMenuOpened){return;}
focusTag();break;}
case"arrowright":{if(input.selectionStart!==input.value.length||autoCompleteMenuOpened){return;}
focusTag(0);break;}
case"backspace":{if(input.value){return;}
const tags=ref.el.getElementsByClassName("o_tag");if(tags.length){deleteTag(tags.length-1);}
break;}
default:return;}
ev.preventDefault();ev.stopPropagation();}
function onTagKeydown(ev){const hotkey=getActiveHotkey(ev);const tags=[...ref.el.getElementsByClassName("o_tag")];const closestTag=ev.target.closest(".o_tag");const tagIndex=tags.indexOf(closestTag);const input=ref.el.querySelector(".o-autocomplete--input");switch(hotkey){case"arrowleft":{if(tagIndex===0){input.focus();}else{focusTag(tagIndex-1);}
break;}
case"arrowright":{if(tagIndex===tags.length-1){input.focus();}else{focusTag(tagIndex+1);}
break;}
case"backspace":{input.focus();deleteTag(tagIndex);break;}
default:return;}
ev.preventDefault();ev.stopPropagation();}
return onTagKeydown;}
return __exports;});;

/* /web/static/src/core/registry.js */
odoo.define('@web/core/registry',['@odoo/owl'],function(require){'use strict';let __exports={};const{EventBus,validate}=require("@odoo/owl");const KeyNotFoundError=__exports.KeyNotFoundError=class KeyNotFoundError extends Error{}
const DuplicatedKeyError=__exports.DuplicatedKeyError=class DuplicatedKeyError extends Error{}
const validateSchema=(value,schema)=>{if(!odoo.debug){return;}
validate(value,schema);}
const Registry=__exports.Registry=class Registry extends EventBus{constructor(name){super();this.content={};this.subRegistries={};this.elements=null;this.entries=null;this.name=name;this.validationSchema=null;this.addEventListener("UPDATE",()=>{this.elements=null;this.entries=null;});}
add(key,value,{force,sequence}={}){if(this.validationSchema){validateSchema(value,this.validationSchema);}
if(!force&&key in this.content){throw new DuplicatedKeyError(`Cannot add key "${key}" in the "${this.name}" registry: it already exists`);}
let previousSequence;if(force){const elem=this.content[key];previousSequence=elem&&elem[0];}
sequence=sequence===undefined?previousSequence||50:sequence;this.content[key]=[sequence,value];const payload={operation:"add",key,value};this.trigger("UPDATE",payload);return this;}
get(key,defaultValue){if(arguments.length<2&&!(key in this.content)){throw new KeyNotFoundError(`Cannot find key "${key}" in the "${this.name}" registry`);}
const info=this.content[key];return info?info[1]:defaultValue;}
contains(key){return key in this.content;}
getAll(){if(!this.elements){const content=Object.values(this.content).sort((el1,el2)=>el1[0]-el2[0]);this.elements=content.map((elem)=>elem[1]);}
return this.elements.slice();}
getEntries(){if(!this.entries){const entries=Object.entries(this.content).sort((el1,el2)=>el1[1][0]-el2[1][0]);this.entries=entries.map(([str,elem])=>[str,elem[1]]);}
return this.entries.slice();}
remove(key){const value=this.content[key];delete this.content[key];const payload={operation:"delete",key,value};this.trigger("UPDATE",payload);}
category(subcategory){if(!(subcategory in this.subRegistries)){this.subRegistries[subcategory]=new Registry(subcategory);}
return this.subRegistries[subcategory];}
addValidation(schema){if(this.validationSchema){throw new Error("Validation schema already set on this registry");}
this.validationSchema=schema;for(const value of this.getAll()){validateSchema(value,schema);}}}
const registry=__exports.registry=new Registry();return __exports;});;

/* /web/static/src/core/registry_hook.js */
odoo.define('@web/core/registry_hook',['@odoo/owl'],function(require){'use strict';let __exports={};const{useState,onWillStart,onWillDestroy}=require("@odoo/owl");__exports.useRegistry=useRegistry;function useRegistry(registry){const state=useState({entries:registry.getEntries()});const listener=({detail})=>{const index=state.entries.findIndex(([k])=>k===detail.key);if(detail.operation==="add"&&index===-1){const newEntries=registry.getEntries();const newEntry=newEntries.find(([k])=>k===detail.key);const newIndex=newEntries.indexOf(newEntry);if(newIndex===newEntries.length-1){state.entries.push(newEntry);}else{state.entries.splice(newIndex,0,newEntry);}}else if(detail.operation==="delete"&&index>=0){state.entries.splice(index,1);}};onWillStart(()=>registry.addEventListener("UPDATE",listener));onWillDestroy(()=>registry.removeEventListener("UPDATE",listener));return state;}
return __exports;});;

/* /web/static/src/core/resizable_panel/resizable_panel.js */
odoo.define('@web/core/resizable_panel/resizable_panel',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,onMounted,onWillUpdateProps,onWillUnmount,useEffect,useExternalListener,useRef,useComponent,}=require("@odoo/owl");function useResizable({containerRef,handleRef,initialWidth=400,getMinWidth=()=>400,onResize=()=>{},getResizeSide=()=>"end",}){containerRef=typeof containerRef=="string"?useRef(containerRef):containerRef;handleRef=typeof handleRef=="string"?useRef(handleRef):handleRef;const props=useComponent().props;let minWidth=getMinWidth(props);let resizeSide=getResizeSide(props);let isChangingSize=false;useExternalListener(document,"mouseup",()=>onMouseUp());useExternalListener(document,"mousemove",(ev)=>onMouseMove(ev));useExternalListener(window,"resize",()=>{const limit=getLimitWidth();if(getContainerRect().width>=limit){resize(computeFinalWidth(limit));}});let docDirection;useEffect((container)=>{if(container){docDirection=getComputedStyle(container).direction;}},()=>[containerRef.el]);onMounted(()=>{if(handleRef.el){resize(initialWidth);handleRef.el.addEventListener("mousedown",onMouseDown);}});onWillUpdateProps((nextProps)=>{minWidth=getMinWidth(nextProps);resizeSide=getResizeSide(nextProps);});onWillUnmount(()=>{if(handleRef.el){handleRef.el.removeEventListener("mousedown",onMouseDown);}});function onMouseDown(){isChangingSize=true;document.body.classList.add("pe-none","user-select-none");}
function onMouseUp(){isChangingSize=false;document.body.classList.remove("pe-none","user-select-none");}
function onMouseMove(ev){if(!isChangingSize||!containerRef.el){return;}
const direction=(docDirection==="ltr"&&resizeSide==="end")||(docDirection==="rtl"&&resizeSide==="start")?1:-1;const fixedSide=direction===1?"left":"right";const containerRect=getContainerRect();const newWidth=(ev.clientX-containerRect[fixedSide])*direction;resize(computeFinalWidth(newWidth));}
function computeFinalWidth(targetContainerWidth){const handlerSpacing=handleRef.el?handleRef.el.offsetWidth/2:10;const w=Math.max(minWidth,targetContainerWidth+handlerSpacing);const limit=getLimitWidth();return Math.min(w,limit-handlerSpacing);}
function getContainerRect(){const container=containerRef.el;const offsetParent=container.offsetParent;let containerRect={};if(!offsetParent){containerRect=container.getBoundingClientRect();}else{containerRect.left=container.offsetLeft;containerRect.right=container.offsetLeft+container.offsetWidth;containerRect.width=container.offsetWidth;}
return containerRect;}
function getLimitWidth(){const offsetParent=containerRef.el.offsetParent;return offsetParent?offsetParent.offsetWidth:window.innerWidth;}
function resize(width){containerRef.el.style.setProperty("width",`${width}px`);onResize(width);}}
const ResizablePanel=__exports.ResizablePanel=class ResizablePanel extends Component{static template="web_studio.ResizablePanel";static components={};static props={onResize:{type:Function,optional:true},initialWidth:{type:Number,optional:true},minWidth:{type:Number,optional:true},class:{type:String,optional:true},slots:{type:Object},handleSide:{validate:(val)=>["start","end"].includes(val),optional:true,},};static defaultProps={onResize:()=>{},width:400,minWidth:400,class:"",handleSide:"end",};setup(){useResizable({containerRef:"containerRef",handleRef:"handleRef",onResize:this.props.onResize,initialWidth:this.props.initialWidth,getMinWidth:(props)=>props.minWidth,getResizeSide:(props)=>props.handleSide,});}
get class(){const classes=this.props.class.split(" ");if(!classes.some((cls)=>cls.startsWith("position-"))){classes.push("position-relative");}
return classes.join(" ");}}
return __exports;});;

/* /web/static/src/core/select_menu/select_menu.js */
odoo.define('@web/core/select_menu/select_menu',['@odoo/owl','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/l10n/translation','@web/core/tags_list/tags_list','@web/core/utils/classname','@web/core/utils/hooks','@web/core/utils/scrolling','@web/core/utils/search','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{Component,onWillUpdateProps,useEffect,useRef,useState}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{_t}=require("@web/core/l10n/translation");const{TagsList}=require("@web/core/tags_list/tags_list");const{mergeClasses}=require("@web/core/utils/classname");const{useAutofocus,useChildRef}=require("@web/core/utils/hooks");const{scrollTo}=require("@web/core/utils/scrolling");const{fuzzyLookup}=require("@web/core/utils/search");const{useDebounced}=require("@web/core/utils/timing");const SelectMenu=__exports.SelectMenu=class SelectMenu extends Component{static template="web.SelectMenu";static choiceItemTemplate="web.SelectMenu.ChoiceItem";static components={Dropdown,DropdownItem,TagsList};static defaultProps={value:undefined,class:"",togglerClass:"",multiSelect:false,onSelect:()=>{},required:false,searchable:true,autoSort:true,searchPlaceholder:_t("Search..."),choices:[],groups:[],disabled:false,fuzzyLookupFn:(choice)=>choice.label,};static props={choices:{optional:true,type:Array,element:{type:Object,shape:{value:true,label:{type:String},"*":true,},},},groups:{type:Array,optional:true,element:{type:Object,shape:{label:{type:String,optional:true},choices:{type:Array,element:{type:Object,shape:{value:true,label:{type:String},"*":true,},},},},},},class:{type:String,optional:true},menuClass:{type:String,optional:true},togglerClass:{type:String,optional:true},required:{type:Boolean,optional:true},searchable:{type:Boolean,optional:true},autoSort:{type:Boolean,optional:true},placeholder:{type:String,optional:true},searchPlaceholder:{type:String,optional:true},value:{optional:true},multiSelect:{type:Boolean,optional:true},onInput:{type:Function,optional:true},onSelect:{type:Function,optional:true},slots:{type:Object,optional:true},disabled:{type:Boolean,optional:true},fuzzyLookupFn:{type:Function,optional:true},};static SCROLL_SETTINGS={defaultCount:500,increaseAmount:300,distanceBeforeReload:500,};setup(){this.state=useState({choices:[],displayedOptions:[],searchValue:"",});this.inputRef=useRef("inputRef");this.menuRef=useChildRef();this.debouncedOnInput=useDebounced(()=>this.onInput(this.inputRef.el?this.inputRef.el.value.trim():""),250);this.isOpen=false;this.selectedChoice=this.getSelectedChoice(this.props);onWillUpdateProps((nextProps)=>{if(this.state.choices!==nextProps.choices){this.state.choices=nextProps.choices;}
if(this.props.value!==nextProps.value){this.selectedChoice=this.getSelectedChoice(nextProps);}});useEffect(()=>{if(this.isOpen){const groups=[{choices:this.props.choices},...this.props.groups];this.filterOptions(this.state.searchValue,groups);}},()=>[this.props.choices,this.props.groups]);useAutofocus({refName:"inputRef"});}
get displayValue(){return this.selectedChoice?this.selectedChoice.label:"";}
get canDeselect(){return!this.props.required&&this.selectedChoice!==undefined;}
get multiSelectChoices(){return this.selectedChoice.map((c)=>{return{id:c.value,text:c.label,onDelete:()=>{const values=[...this.props.value];values.splice(values.indexOf(c.value),1);this.props.onSelect(values);},};});}
get menuClass(){return mergeClasses({"o_select_menu_menu border bg-light":true,"py-0":this.props.searchable,o_select_menu_multi_select:this.props.multiSelect,},this.props.menuClass);}
async onBeforeOpen(){if(this.state.searchValue.length){this.state.searchValue="";if(this.props.onInput){await this.executeOnInput("");}}
this.filterOptions();}
onStateChanged(open){this.isOpen=open;if(open){this.menuRef.el?.addEventListener("scroll",(ev)=>this.onScroll(ev));const selectedElement=this.menuRef.el?.querySelectorAll(".o_select_active")[0];if(selectedElement){scrollTo(selectedElement);}}}
isOptionSelected(choice){if(this.props.multiSelect){return this.props.value.includes(choice.value);}
return this.props.value===choice.value;}
getItemClass(choice){if(this.isOptionSelected(choice)){return"o_select_menu_item p-2 o_select_active bg-primary fw-bolder fst-italic";}else{return"o_select_menu_item p-2";}}
async executeOnInput(searchString){await this.props.onInput(searchString);}
onInput(searchString){this.filterOptions(searchString);this.state.searchValue=searchString;const inputEl=this.inputRef.el;if(inputEl&&inputEl.parentNode){inputEl.parentNode.scrollTo(0,0);}
if(this.props.onInput){this.executeOnInput(searchString);}}
getSelectedChoice(props){const choices=[...props.choices,...props.groups.flatMap((g)=>g.choices)];if(!this.props.multiSelect){return choices.find((c)=>c.value===props.value);}
const valueSet=new Set(props.value);return[...(this.selectedChoice||[]),...choices].filter((c,index,self)=>valueSet.has(c.value)&&self.findIndex((t)=>t.value===c.value)===index);}
onItemSelected(value){if(this.props.multiSelect){const values=[...this.props.value];const valueIndex=values.indexOf(value);if(valueIndex!==-1){values.splice(valueIndex,1);this.props.onSelect(values);}else{this.props.onSelect([...this.props.value,value]);}}else if(!this.selectedChoice||this.selectedChoice.value!==value){this.props.onSelect(value);}
if(this.inputRef.el){this.inputRef.el.value="";this.state.searchValue="";}}
filterOptions(searchString="",groups){const groupsList=groups||[{choices:this.props.choices},...this.props.groups];this.state.choices=[];for(const group of groupsList){let filteredOptions=[];if(searchString){filteredOptions=fuzzyLookup(searchString,group.choices,this.props.fuzzyLookupFn);}else{filteredOptions=group.choices;if(this.props.autoSort){filteredOptions.sort((optionA,optionB)=>optionA.label.localeCompare(optionB.label));}}
if(filteredOptions.length===0){continue;}
if(group.label){this.state.choices.push({...group,isGroup:true});}
this.state.choices.push(...filteredOptions);}
this.sliceDisplayedOptions();}
onScroll(event){const el=event.target;const hasReachMax=this.state.displayedOptions.length>=this.state.choices.length;const remainingDistance=el.scrollHeight-el.scrollTop;const distanceToReload=el.clientHeight+this.constructor.SCROLL_SETTINGS.distanceBeforeReload;if(!hasReachMax&&remainingDistance<distanceToReload){const displayCount=this.state.displayedOptions.length+
this.constructor.SCROLL_SETTINGS.increaseAmount;this.state.displayedOptions=this.state.choices.slice(0,displayCount);}}
sliceDisplayedOptions(){const selectedIndex=this.getSelectedOptionIndex();const defaultCount=this.constructor.SCROLL_SETTINGS.defaultCount;if(selectedIndex===-1){this.state.displayedOptions=this.state.choices.slice(0,defaultCount);}else{const endIndex=Math.max(selectedIndex+this.constructor.SCROLL_SETTINGS.increaseAmount,defaultCount);this.state.displayedOptions=this.state.choices.slice(0,endIndex);}}
getSelectedOptionIndex(){let selectedIndex=-1;for(let i=0;i<this.state.choices.length;i++){if(this.isOptionSelected(this.state.choices[i])){selectedIndex=i;}}
return selectedIndex;}}
return __exports;});;

/* /web/static/src/core/signature/name_and_signature.js */
odoo.define('@web/core/signature/name_and_signature',['@web/core/assets','@web/core/browser/feature_detection','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/network/rpc','@web/core/utils/hooks','@web/core/utils/render','@web/core/utils/urls','@odoo/owl'],function(require){'use strict';let __exports={};const{loadJS}=require("@web/core/assets");const{isMobileOS}=require("@web/core/browser/feature_detection");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{rpc}=require("@web/core/network/rpc");const{useAutofocus}=require("@web/core/utils/hooks");const{renderToString}=require("@web/core/utils/render");const{getDataURLFromFile}=require("@web/core/utils/urls");const{Component,useState,onWillStart,useRef,useEffect}=require("@odoo/owl");let htmlId=0;const NameAndSignature=__exports.NameAndSignature=class NameAndSignature extends Component{static template="web.NameAndSignature";static components={Dropdown,DropdownItem};static props={signature:{type:Object},defaultFont:{type:String,optional:true},displaySignatureRatio:{type:Number,optional:true},fontColor:{type:String,optional:true},signatureType:{type:String,optional:true},noInputName:{type:Boolean,optional:true},mode:{type:String,optional:true},onSignatureChange:{type:Function,optional:true},};static defaultProps={defaultFont:"",displaySignatureRatio:3.0,fontColor:"DarkBlue",signatureType:"signature",noInputName:false,onSignatureChange:()=>{},};setup(){this.htmlId=htmlId++;this.defaultName=this.props.signature.name||"";this.currentFont=0;this.drawTimeout=null;this.state=useState({signMode:this.props.mode||(this.props.noInputName&&!this.defaultName?"draw":"auto"),showSignatureArea:!!(this.props.noInputName||this.defaultName),showFontList:false,});this.signNameInputRef=useRef("signNameInput");this.signInputLoad=useRef("signInputLoad");useAutofocus({refName:"signNameInput"});useEffect((el)=>{if(el){el.click();}},()=>[this.signInputLoad.el]);onWillStart(async()=>{this.fonts=await rpc(`/web/sign/get_fonts/${this.props.defaultFont}`);});onWillStart(async()=>{await loadJS("/web/static/lib/signature_pad/signature_pad.umd.js");});this.signatureRef=useRef("signature");useEffect((el)=>{if(el){this.signaturePad=new SignaturePad(el,{penColor:this.props.fontColor,backgroundColor:"rgba(255,255,255,0)",minWidth:2,maxWidth:2,});this.signaturePad.addEventListener("endStroke",()=>{this.props.signature.isSignatureEmpty=this.isSignatureEmpty;this.props.onSignatureChange(this.state.signMode);});this.resetSignature();this.props.signature.getSignatureImage=()=>this.signaturePad.toDataURL();this.props.signature.resetSignature=()=>this.resetSignature();if(this.state.signMode==="auto"){this.drawCurrentName();}
if(this.props.signature.signatureImage){this.clear();this.fromDataURL(this.props.signature.signatureImage);}}},()=>[this.signatureRef.el]);}
async drawCurrentName(){const font=this.fonts[this.currentFont];const text=this.getCleanedName();const canvas=this.signatureRef.el;const img=this.getSVGText(font,text,canvas.width,canvas.height);await this.printImage(img);}
focusName(){if(!isMobileOS()&&this.signNameInputRef.el){this.signNameInputRef.el.focus();}}
clear(){this.signaturePad.clear();this.props.signature.isSignatureEmpty=this.isSignatureEmpty;}
async fromDataURL(){await this.signaturePad.fromDataURL(...arguments);this.props.signature.isSignatureEmpty=this.isSignatureEmpty;this.props.onSignatureChange(this.state.signMode);}
getCleanedName(){const text=this.props.signature.name;if(this.props.signatureType==="initial"&&text){return(text.split(" ").map(function(w){return w[0];}).join(".")+".");}
return text;}
getSVGText(font,text,width,height){const svg=renderToString("web.sign_svg_text",{width:width,height:height,font:font,text:text,type:this.props.signatureType,color:this.props.fontColor,});return"data:image/svg+xml,"+encodeURI(svg);}
getSVGTextFont(font){const height=100;const width=parseInt(height*this.props.displaySignatureRatio);return this.getSVGText(font,this.getCleanedName(),width,height);}
uploadFile(){this.signInputLoad.el?.click();}
async onChangeSignLoadInput(ev){var file=ev.target.files[0];if(file===undefined){return false;}
if(file.type.substr(0,5)!=="image"){this.clear();this.state.loadIsInvalid=true;return false;}
this.state.loadIsInvalid=false;const result=await getDataURLFromFile(file);await this.printImage(result);}
onClickSignAutoSelectStyle(){this.state.showFontList=true;}
onClickSignDrawClear(){this.clear();this.props.onSignatureChange(this.state.signMode);}
onClickSignLoad(){this.setMode("load");}
onClickSignAuto(){this.setMode("auto");}
onInputSignName(ev){this.props.signature.name=ev.target.value;if(!this.state.showSignatureArea&&this.getCleanedName()){this.state.showSignatureArea=true;return;}
if(this.state.signMode==="auto"){this.drawCurrentName();}}
onSelectFont(index){this.currentFont=index;this.drawCurrentName();}
async printImage(imgSrc){this.clear();const c=this.signaturePad.canvas;const img=new Image();img.onload=()=>{const ctx=c.getContext("2d");var ratio=((img.width/img.height)>(c.width/c.height))?c.width/img.width:c.height/img.height;ctx.drawImage(img,(c.width/2)-(img.width*ratio/2),(c.height/2)-(img.height*ratio/2),img.width*ratio,img.height*ratio);this.props.signature.isSignatureEmpty=this.isSignatureEmpty;this.props.onSignatureChange(this.state.signMode);};img.src=imgSrc;this.signaturePad._isEmpty=false;}
resetSignature(){this.resizeSignature();this.clear();this.setMode(this.state.signMode,true);this.focusName();}
resizeSignature(){const width=this.signatureRef.el.clientWidth;const height=parseInt(width/this.props.displaySignatureRatio);Object.assign(this.signatureRef.el,{width,height});}
setMode(mode,reset){if(reset!==true&&mode===this.signMode){return;}
this.state.signMode=mode;this.signaturePad[this.state.signMode==="draw"?"on":"off"]();this.clear();if(this.state.signMode==="auto"){this.drawCurrentName();}
this.props.onSignatureChange(this.state.signMode);}
get isSignatureEmpty(){return this.signaturePad.isEmpty();}
get loadIsInvalid(){return this.state.signMode==="load"&&this.state.loadIsInvalid;}}
return __exports;});;

/* /web/static/src/core/signature/signature_dialog.js */
odoo.define('@web/core/signature/signature_dialog',['@web/core/dialog/dialog','@web/core/signature/name_and_signature','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{NameAndSignature}=require("@web/core/signature/name_and_signature");const{Component,useState}=require("@odoo/owl");const SignatureDialog=__exports.SignatureDialog=class SignatureDialog extends Component{static template="web.SignatureDialog";static components={Dialog,NameAndSignature};static props={defaultName:{type:String,optional:true},nameAndSignatureProps:Object,uploadSignature:Function,close:Function,};static defaultProps={defaultName:"",};setup(){this.signature=useState({name:this.props.defaultName,isSignatureEmpty:true,});}
onClickConfirm(){this.props.uploadSignature({name:this.signature.name,signatureImage:this.signature.getSignatureImage(),});this.props.close();}
get nameAndSignatureProps(){return{...this.props.nameAndSignatureProps,signature:this.signature,};}}
return __exports;});;

/* /web/static/src/core/tags_list/tags_list.js */
odoo.define('@web/core/tags_list/tags_list',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const TagsList=__exports.TagsList=class TagsList extends Component{static template="web.TagsList";static defaultProps={displayText:true,};static props={displayText:{type:Boolean,optional:true},visibleItemsLimit:{type:Number,optional:true},tags:{type:Object},};get visibleTagsCount(){return this.props.visibleItemsLimit-1;}
get visibleTags(){if(this.props.visibleItemsLimit&&this.props.tags.length>this.props.visibleItemsLimit){return this.props.tags.slice(0,this.visibleTagsCount);}
return this.props.tags;}
get otherTags(){if(!this.props.visibleItemsLimit||this.props.tags.length<=this.props.visibleItemsLimit){return[];}
return this.props.tags.slice(this.visibleTagsCount);}
get tooltipInfo(){return JSON.stringify({tags:this.otherTags.map((tag)=>({text:tag.text,id:tag.id,})),});}}
return __exports;});;

/* /web/static/src/core/template_inheritance.js */
odoo.define('@web/core/template_inheritance',[],function(require){'use strict';let __exports={};const RSTRIP_REGEXP=/(?=\n[ \t]*$)/;function addBefore(target,operation){const nodes=getNodes(target,operation);if(nodes.length===0){return;}
const{previousSibling}=target;target.before(...nodes);if(previousSibling?.nodeType===Node.TEXT_NODE){const[text1,text2]=previousSibling.data.split(RSTRIP_REGEXP);previousSibling.data=text1.trimEnd();if(nodes[0].nodeType===Node.TEXT_NODE){mergeTextNodes(previousSibling,nodes[0]);}
if(text2&&nodes.some((n)=>n.nodeType!==Node.TEXT_NODE)){const textNode=document.createTextNode(text2);target.before(textNode);if(textNode.previousSibling.nodeType===Node.TEXT_NODE){mergeTextNodes(textNode.previousSibling,textNode);}}}}
function getRoot(element){while(element.parentElement){element=element.parentElement;}
return element;}
const HASCLASS_REGEXP=/hasclass\(([^)]*)\)/g;function getXpath(operation){const xpath=operation.getAttribute("expr");return xpath.replaceAll(HASCLASS_REGEXP,(_,capturedGroup)=>{return capturedGroup.split(",").map((c)=>`contains(concat(' ', @class, ' '), ' ${c.trim().slice(1, -1)} ')`).join(" and ");});}
function getNode(element,operation){const root=getRoot(element);const doc=new Document();doc.appendChild(root);if(operation.tagName==="xpath"){const xpath=getXpath(operation);const result=doc.evaluate(xpath,root,null,XPathResult.FIRST_ORDERED_NODE_TYPE);return result.singleNodeValue;}
for(const elem of root.querySelectorAll(operation.tagName)){if([...operation.attributes].every(({name,value})=>name==="position"||elem.getAttribute(name)===value)){return elem;}}
return null;}
function getElement(element,operation){const node=getNode(element,operation);if(!node){throw new Error(`Element '${operation.outerHTML}' cannot be located in element tree`);}
if(!(node instanceof Element)){throw new Error(`Found node ${node} instead of an element`);}
return node;}
function getNodes(element,operation){const nodes=[];for(const childNode of operation.childNodes){if(childNode.tagName==="xpath"&&childNode.getAttribute?.("position")==="move"){const node=getElement(element,childNode);removeNode(node);nodes.push(node);}else{nodes.push(childNode);}}
return nodes;}
function mergeTextNodes(first,second,trimEnd=true){first.data=(trimEnd?first.data.trimEnd():first.data)+second.data;second.remove();}
function splitAndTrim(str,separator){return str.split(separator).map((s)=>s.trim());}
function modifyAttributes(target,operation){for(const child of operation.children){if(child.tagName!=="attribute"){continue;}
const attributeName=child.getAttribute("name");const firstNode=child.childNodes[0];let value=firstNode?.nodeType===Node.TEXT_NODE?firstNode.data:"";const add=child.getAttribute("add")||"";const remove=child.getAttribute("remove")||"";if(add||remove){if(firstNode?.nodeType===Node.TEXT_NODE){throw new Error(`Useless element content ${firstNode.outerHTML}`);}
const separator=child.getAttribute("separator")||",";const toRemove=new Set(splitAndTrim(remove,separator));const values=splitAndTrim(target.getAttribute(attributeName)||"",separator).filter((s)=>!toRemove.has(s));values.push(...splitAndTrim(add,separator).filter((s)=>s));value=values.join(separator);}
if(value){target.setAttribute(attributeName,value);}else{target.removeAttribute(attributeName);}}}
function removeNode(node){const{nextSibling,previousSibling}=node;node.remove();if(nextSibling?.nodeType===Node.TEXT_NODE&&previousSibling?.nodeType===Node.TEXT_NODE){mergeTextNodes(previousSibling,nextSibling,previousSibling.parentElement.firstChild===previousSibling);}}
function replace(root,target,operation){const mode=operation.getAttribute("mode")||"outer";switch(mode){case"outer":{const result=operation.ownerDocument.evaluate(".//*[text()='$0']",operation,null,XPathResult.ORDERED_NODE_SNAPSHOT_TYPE);for(let i=0;i<result.snapshotLength;i++){const loc=result.snapshotItem(i);loc.firstChild.replaceWith(target.cloneNode(true));}
if(target.parentElement){const nodes=getNodes(target,operation);target.replaceWith(...nodes);}else{let operationContent=null;let comment=null;for(const child of operation.childNodes){if(child.nodeType===Node.ELEMENT_NODE){operationContent=child;break;}
if(child.nodeType===Node.COMMENT_NODE){comment=child;}}
root=operationContent.cloneNode(true);if(target.hasAttribute("t-name")){root.setAttribute("t-name",target.getAttribute("t-name"));}
if(comment){root.prepend(comment);}}
break;}
case"inner":while(target.firstChild){target.removeChild(target.lastChild);}
target.append(...operation.childNodes);break;default:throw new Error(`Invalid mode attribute: '${mode}'`);}
return root;}
__exports.applyInheritance=applyInheritance;function applyInheritance(root,operations,url=""){for(const operation of operations.children){const target=getElement(root,operation);const position=operation.getAttribute("position")||"inside";if(odoo.debug&&url){const attributes=[...operation.attributes].map(({name,value})=>`${name}=${JSON.stringify(name === "position" ? position : value)}`);const comment=document.createComment(` From file: ${url} ; ${attributes.join(" ; ")} `);if(position==="attributes"){target.before(comment);}else{operation.prepend(comment);}}
switch(position){case"replace":{root=replace(root,target,operation);break;}
case"attributes":{modifyAttributes(target,operation);break;}
case"inside":{const sentinel=document.createElement("sentinel");target.append(sentinel);addBefore(sentinel,operation);removeNode(sentinel);break;}
case"after":{const sentinel=document.createElement("sentinel");target.after(sentinel);addBefore(sentinel,operation);removeNode(sentinel);break;}
case"before":{addBefore(target,operation);break;}
default:throw new Error(`Invalid position attribute: '${position}'`);}}
return root;}
return __exports;});;

/* /web/static/src/core/templates.js */
odoo.define('@web/core/templates',['@web/core/template_inheritance'],function(require){'use strict';let __exports={};const{applyInheritance}=require("@web/core/template_inheritance");function getClone(template){const c=template.cloneNode(true);new Document().append(c);return c;}
function getParsedTemplate(templateString){const doc=parser.parseFromString(templateString,"text/xml");for(const processor of templateProcessors){processor(doc);}
return doc.firstChild;}
function _getTemplate(name,blockId=null){if(!(name in parsedTemplates)){if(!(name in templates)){return null;}
const templateString=templates[name];parsedTemplates[name]=getParsedTemplate(templateString);}
let processedTemplate=parsedTemplates[name];const inheritFrom=processedTemplate.getAttribute("t-inherit");if(inheritFrom){const parentTemplate=_getTemplate(inheritFrom,blockId||info[name].blockId);if(!parentTemplate){throw new Error(`Constructing template ${name}: template parent ${inheritFrom} not found`);}
const element=getClone(processedTemplate);processedTemplate=applyInheritance(getClone(parentTemplate),element,info[name].url);if(processedTemplate.tagName!==element.tagName){const temp=processedTemplate;processedTemplate=new Document().createElement(element.tagName);processedTemplate.append(...temp.childNodes);}
for(const{name,value}of element.attributes){if(!["t-inherit","t-inherit-mode"].includes(name)){processedTemplate.setAttribute(name,value);}}}
for(const otherBlockId in templateExtensions[name]||{}){if(blockId&&otherBlockId>blockId){break;}
if(!(name in parsedTemplateExtensions)){parsedTemplateExtensions[name]={};}
if(!(otherBlockId in parsedTemplateExtensions[name])){parsedTemplateExtensions[name][otherBlockId]=[];for(const{templateString,url}of templateExtensions[name][otherBlockId]){parsedTemplateExtensions[name][otherBlockId].push({template:getParsedTemplate(templateString),url,});}}
for(const{template,url}of parsedTemplateExtensions[name][otherBlockId]){if(!urlFilters.every((filter)=>filter(url))){continue;}
processedTemplate=applyInheritance(inheritFrom?processedTemplate:getClone(processedTemplate),getClone(template),url);}}
return processedTemplate;}
function isRegistered(...args){const key=JSON.stringify([...args]);if(registered.has(key)){return true;}
registered.add(key);return false;}
const info=Object.create(null);const parsedTemplateExtensions=Object.create(null);const parsedTemplates=Object.create(null);const parser=new DOMParser();const processedTemplates=new Map();const registered=new Set();const templateExtensions=Object.create(null);const templateProcessors=[];const templates=Object.create(null);let blockType=null;let blockId=0;let urlFilters=[];__exports.checkPrimaryTemplateParents=checkPrimaryTemplateParents;function checkPrimaryTemplateParents(namesToCheck){const missing=new Set(namesToCheck.filter((name)=>!(name in templates)));if(missing.size){console.error(`Missing (primary) parent templates: ${[...missing].join(", ")}`);}}
__exports.clearProcessedTemplates=clearProcessedTemplates;function clearProcessedTemplates(){processedTemplates.clear();}
__exports.getTemplate=getTemplate;function getTemplate(name){if(!processedTemplates.has(name)){processedTemplates.set(name,_getTemplate(name));}
return processedTemplates.get(name);}
__exports.registerTemplate=registerTemplate;function registerTemplate(name,url,templateString){if(isRegistered(...arguments)){return;}
if(blockType!=="templates"){blockType="templates";blockId++;}
if(name in templates&&(info[name].url!==url||templates[name]!==templateString)){throw new Error(`Template ${name} already exists`);}
templates[name]=templateString;info[name]={blockId,url};}
__exports.registerTemplateExtension=registerTemplateExtension;function registerTemplateExtension(inheritFrom,url,templateString){if(isRegistered(...arguments)){return;}
if(blockType!=="extensions"){blockType="extensions";blockId++;}
if(!templateExtensions[inheritFrom]){templateExtensions[inheritFrom]=[];}
if(!templateExtensions[inheritFrom][blockId]){templateExtensions[inheritFrom][blockId]=[];}
templateExtensions[inheritFrom][blockId].push({templateString,url,});}
__exports.registerTemplateProcessor=registerTemplateProcessor;function registerTemplateProcessor(processor){templateProcessors.push(processor);}
__exports.setUrlFilters=setUrlFilters;function setUrlFilters(filters){urlFilters=filters;}
return __exports;});;

/* /web/static/src/core/tooltip/tooltip.js */
odoo.define('@web/core/tooltip/tooltip',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const Tooltip=__exports.Tooltip=class Tooltip extends Component{static template="web.Tooltip";static props={close:Function,tooltip:{type:String,optional:true},template:{type:String,optional:true},info:{optional:true},};}
return __exports;});;

/* /web/static/src/core/tooltip/tooltip_hook.js */
odoo.define('@web/core/tooltip/tooltip_hook',['@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{useEffect,useRef}=require("@odoo/owl");__exports.useTooltip=useTooltip;function useTooltip(refName,params){const tooltip=useService("tooltip");const ref=useRef(refName);useEffect((el)=>tooltip.add(el,params),()=>[ref.el]);}
return __exports;});;

/* /web/static/src/core/tooltip/tooltip_service.js */
odoo.define('@web/core/tooltip/tooltip_service',['@web/core/browser/browser','@web/core/registry','@web/core/tooltip/tooltip','@web/core/browser/feature_detection','@odoo/owl'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{Tooltip}=require("@web/core/tooltip/tooltip");const{hasTouch}=require("@web/core/browser/feature_detection");const{whenReady}=require("@odoo/owl");const OPEN_DELAY=__exports.OPEN_DELAY=400;const CLOSE_DELAY=__exports.CLOSE_DELAY=200;const SHOW_AFTER_DELAY=__exports.SHOW_AFTER_DELAY=250;const tooltipService=__exports.tooltipService={dependencies:["popover"],start(env,{popover}){let openTooltipTimeout;let closeTooltip;let showTimer;let target=null;const elementsWithTooltips=new WeakMap();function cleanup(){target=null;browser.clearTimeout(openTooltipTimeout);openTooltipTimeout=null;if(closeTooltip){closeTooltip();closeTooltip=null;}}
function shouldCleanup(){if(!target){return false;}
if(!document.body.contains(target)){return true;}
return false;}
function openTooltip(el,{tooltip="",template,info,position,delay=OPEN_DELAY}){cleanup();if(!tooltip&&!template){return;}
target=el;openTooltipTimeout=browser.setTimeout(()=>{if(target.isConnected){closeTooltip=popover.add(target,Tooltip,{tooltip,template,info},{position});target.title="";}},delay);}
function openElementsTooltip(el){if(el.nodeType===Node.TEXT_NODE){return;}
const element=el.closest("[data-tooltip], [data-tooltip-template]");if(elementsWithTooltips.has(el)){openTooltip(el,elementsWithTooltips.get(el));}else if(element){const dataset=element.dataset;const params={tooltip:dataset.tooltip,template:dataset.tooltipTemplate,position:dataset.tooltipPosition,};if(dataset.tooltipInfo){params.info=JSON.parse(dataset.tooltipInfo);}
if(dataset.tooltipDelay){params.delay=parseInt(dataset.tooltipDelay,10);}
openTooltip(element,params);}}
function onMouseenter(ev){openElementsTooltip(ev.target);}
function cleanupTooltip(ev){if(target===ev.target.closest("[data-tooltip], [data-tooltip-template]")){cleanup();}}
function onTouchStart(ev){cleanup();showTimer=browser.setTimeout(()=>{openElementsTooltip(ev.target);},SHOW_AFTER_DELAY);}
whenReady(()=>{browser.setInterval(()=>{if(shouldCleanup()){cleanup();}},CLOSE_DELAY);if(hasTouch()){document.body.addEventListener("touchstart",onTouchStart);document.body.addEventListener("touchend",(ev)=>{if(ev.target.closest("[data-tooltip], [data-tooltip-template]")){if(!ev.target.dataset.tooltipTouchTapToShow){browser.clearTimeout(showTimer);browser.clearTimeout(openTooltipTimeout);}}});document.body.addEventListener("touchcancel",(ev)=>{if(ev.target.closest("[data-tooltip], [data-tooltip-template]")){if(!ev.target.dataset.tooltipTouchTapToShow){browser.clearTimeout(showTimer);browser.clearTimeout(openTooltipTimeout);}}});}
document.body.addEventListener("mouseenter",onMouseenter,{capture:true});document.body.addEventListener("mouseleave",cleanupTooltip,{capture:true});document.body.addEventListener("click",cleanupTooltip,{capture:true});});return{add(el,params){elementsWithTooltips.set(el,params);return()=>{elementsWithTooltips.delete(el);if(target===el){cleanup();}};},};},};registry.category("services").add("tooltip",tooltipService);return __exports;});;

/* /web/static/src/core/transition.js */
odoo.define('@web/core/transition',['@web/core/browser/browser','@odoo/owl'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{Component,onWillUpdateProps,status,useComponent,useEffect,useState,xml,}=require("@odoo/owl");const config=__exports.config={disabled:false,};__exports.useTransition=useTransition;function useTransition({name,initialVisibility=true,immediate=false,leaveDuration=500,onLeave=()=>{},}){const component=useComponent();const state=useState({shouldMount:initialVisibility,stage:initialVisibility?"enter":"leave",});if(config.disabled){return{get shouldMount(){return state.shouldMount;},set shouldMount(val){state.shouldMount=val;},get className(){return`${name} ${name}-enter-active`;},get stage(){return"enter-active";},};}
let onNextPatch=null;useEffect(()=>{if(onNextPatch){onNextPatch();onNextPatch=null;}});let prevState,timer;const transition={get shouldMount(){return state.shouldMount;},set shouldMount(newState){if(newState===prevState){return;}
browser.clearTimeout(timer);prevState=newState;if(newState){if(status(component)==="mounted"||immediate){state.stage="enter";component.render();onNextPatch=()=>{state.stage="enter-active";};}else{state.stage="enter-active";}
state.shouldMount=true;}else{state.stage="leave";timer=browser.setTimeout(()=>{state.shouldMount=false;onLeave();},leaveDuration);}},get className(){return`${name} ${name}-${state.stage}`;},get stage(){return state.stage;},};transition.shouldMount=initialVisibility;return transition;}
const Transition=__exports.Transition=class Transition extends Component{static template=xml`<t t-slot="default" t-if="transition.shouldMount" className="transition.className"/>`;static props={name:String,visible:{type:Boolean,optional:true},immediate:{type:Boolean,optional:true},leaveDuration:{type:Number,optional:true},onLeave:{type:Function,optional:true},slots:Object,};setup(){const{immediate,visible,leaveDuration,name,onLeave}=this.props;this.transition=useTransition({initialVisibility:visible,immediate,leaveDuration,name,onLeave,});onWillUpdateProps(({visible=true})=>{this.transition.shouldMount=visible;});}}
return __exports;});;

/* /web/static/src/core/tree_editor/condition_tree.js */
odoo.define('@web/core/tree_editor/condition_tree',['@web/core/domain','@web/core/py_js/py','@web/core/py_js/py_utils','@web/core/utils/objects'],function(require){'use strict';let __exports={};const{Domain}=require("@web/core/domain");const{formatAST,parseExpr}=require("@web/core/py_js/py");const{toPyValue}=require("@web/core/py_js/py_utils");const{deepCopy,deepEqual}=require("@web/core/utils/objects");const TERM_OPERATORS_NEGATION=__exports.TERM_OPERATORS_NEGATION={"<":">=",">":"<=","<=":">",">=":"<","=":"!=","!=":"=",in:"not in",like:"not like",ilike:"not ilike","not in":"in","not like":"like","not ilike":"ilike",};const TERM_OPERATORS_NEGATION_EXTENDED={...TERM_OPERATORS_NEGATION,is:"is not","is not":"is","==":"!=","!=":"==",};const EXCHANGE={"<":">","<=":">=",">":"<",">=":"<=","=":"=","!=":"!=",};const COMPARATORS=["<","<=",">",">=","in","not in","==","is","!=","is not"];const DATETIME_TODAY_STRING_EXPRESSION=`datetime.datetime.combine(context_today(), datetime.time(0, 0, 0)).to_utc().strftime("%Y-%m-%d %H:%M:%S")`;const DATE_TODAY_STRING_EXPRESSION=`context_today().strftime("%Y-%m-%d")`;const DELTA_DATE_AST=parseExpr(`(context_today() + relativedelta(period=amount)).strftime('%Y-%m-%d')`);const DELTA_DATETIME_AST=parseExpr(`datetime.datetime.combine(context_today() + relativedelta(period=amount), datetime.time(0, 0, 0)).to_utc().strftime("%Y-%m-%d %H:%M:%S")`);function replaceKwargs(ast,fieldType,kwargs={}){const astCopy=deepCopy(ast);if(fieldType==="date"){astCopy.fn.obj.right.kwargs=kwargs;}else{astCopy.fn.obj.fn.obj.args[0].right.kwargs=kwargs;}
return astCopy;}
function getDelta(ast,fieldType){const kwargs=(fieldType==="date"?ast.fn?.obj?.right?.kwargs:ast.fn?.obj?.fn?.obj?.args?.[0]?.right?.kwargs)||{};if(Object.keys(kwargs).length!==1){return null;}
if(!deepEqual(replaceKwargs(ast,fieldType),replaceKwargs(fieldType==="date"?DELTA_DATE_AST:DELTA_DATETIME_AST,fieldType))){return null;}
const[option,amountAST]=Object.entries(kwargs)[0];return[toValue(amountAST),option];}
function getDeltaExpression(value,fieldType){const ast=replaceKwargs(fieldType==="date"?DELTA_DATE_AST:DELTA_DATETIME_AST,fieldType,{[value[1]]:toAST(value[0])});return expression(formatAST(ast));}
function isTodayExpr(val,type){return(val._expr===(type==="date"?DATE_TODAY_STRING_EXPRESSION:DATETIME_TODAY_STRING_EXPRESSION));}
const Couple=__exports.Couple=class Couple{constructor(x,y){this.fst=x;this.snd=y;}}
const Expression=__exports.Expression=class Expression{constructor(ast){if(typeof ast==="string"){ast=parseExpr(ast);}
this._ast=ast;this._expr=formatAST(ast);}
toAST(){return this._ast;}
toString(){return this._expr;}}
__exports.expression=expression;function expression(expr){return new Expression(expr);}
__exports.connector=connector;function connector(value,children=[],negate=false){return{type:"connector",value,children,negate};}
__exports.condition=condition;function condition(path,operator,value,negate=false){return{type:"condition",path,operator,value,negate};}
__exports.complexCondition=complexCondition;function complexCondition(value){parseExpr(value);return{type:"complex_condition",value};}
function cloneValue(value){if(value instanceof Expression){return new Expression(value.toAST());}
if(Array.isArray(value)){return value.map(cloneValue);}
return value;}
__exports.cloneTree=cloneTree;function cloneTree(tree){const clone={};for(const key in tree){clone[key]=cloneValue(tree[key]);}
return clone;}
__exports.formatValue=formatValue;function formatValue(value){return formatAST(toAST(value));}
__exports.normalizeValue=normalizeValue;function normalizeValue(value){return toValue(toAST(value));}
__exports.toValue=toValue;function toValue(ast,isWithinArray=false){if([4,10].includes(ast.type)&&!isWithinArray){return ast.value.map((v)=>toValue(v,true));}else if([0,1,2].includes(ast.type)){return ast.value;}else if(ast.type===6&&ast.op==="-"&&ast.right.type===0){return-ast.right.value;}else if(ast.type===5&&["false","true"].includes(ast.value)){return JSON.parse(ast.value);}else{return new Expression(ast);}}
__exports.isTree=isTree;function isTree(value){return(typeof value==="object"&&!(value instanceof Domain)&&!(value instanceof Expression)&&!Array.isArray(value)&&value!==null);}
function toAST(value){if(isTree(value)){const domain=new Domain(domainFromTree(value));return domain.ast;}
if(value instanceof Expression){return value.toAST();}
if(Array.isArray(value)){return{type:4,value:value.map(toAST)};}
return toPyValue(value);}
function addChild(parent,child){if(child.type==="connector"&&!child.negate&&child.value===parent.value){parent.children.push(...child.children);}else{parent.children.push(child);}}
function getNormalizedCondition(condition){let{operator,negate}=condition;if(negate&&typeof operator==="string"&&TERM_OPERATORS_NEGATION[operator]){operator=TERM_OPERATORS_NEGATION[operator];negate=false;}
return{...condition,operator,negate};}
function normalizeCondition(condition){Object.assign(condition,getNormalizedCondition(condition));}
function _construcTree(ASTs,options={},negate=false){const[firstAST,...tailASTs]=ASTs;if(firstAST.type===1&&firstAST.value==="!"){return _construcTree(tailASTs,options,!negate);}
const tree={type:firstAST.type===1?"connector":"condition"};if(tree.type==="connector"){tree.value=firstAST.value;if(options.distributeNot&&negate){tree.value=tree.value==="&"?"|":"&";tree.negate=false;}else{tree.negate=negate;}
tree.children=[];}else{const[pathAST,operatorAST,valueAST]=firstAST.value;tree.path=toValue(pathAST);tree.negate=negate;tree.operator=toValue(operatorAST);tree.value=toValue(valueAST);if(["any","not any"].includes(tree.operator)){try{tree.value=treeFromDomain(formatAST(valueAST),{...options,getFieldDef:(p)=>options.getFieldDef?.(new Couple(tree.path,p))||null,});}catch{tree.value=Array.isArray(tree.value)?tree.value:[tree.value];}}
normalizeCondition(tree);}
let remaimingASTs=tailASTs;if(tree.type==="connector"){for(let i=0;i<2;i++){const{tree:child,remaimingASTs:otherASTs}=_construcTree(remaimingASTs,options,options.distributeNot&&negate);remaimingASTs=otherASTs;addChild(tree,child);}}
return{tree,remaimingASTs};}
function construcTree(initialASTs,options={}){if(!initialASTs.length){return connector("&");}
const{tree}=_construcTree(initialASTs,options);return tree;}
function getASTs(tree){const ASTs=[];if(tree.type==="condition"){if(tree.negate){ASTs.push(toAST("!"));}
ASTs.push({type:10,value:[tree.path,tree.operator,tree.value].map(toAST),});return ASTs;}
const length=tree.children.length;if(length&&tree.negate){ASTs.push(toAST("!"));}
for(let i=0;i<length-1;i++){ASTs.push(toAST(tree.value));}
for(const child of tree.children){ASTs.push(...getASTs(child));}
return ASTs;}
function not(ast){if(isNot(ast)){return ast.right;}
if(ast.type===2){return{...ast,value:!ast.value};}
if(ast.type===7&&COMPARATORS.includes(ast.op)){return{...ast,op:TERM_OPERATORS_NEGATION_EXTENDED[ast.op]};}
return{type:6,op:"not",right:isBool(ast)?ast.args[0]:ast};}
function bool(ast){if(isBool(ast)||isNot(ast)||ast.type===2){return ast;}
return{type:8,fn:{type:5,value:"bool"},args:[ast],kwargs:{}};}
function name(value){return{type:5,value};}
function or(left,right){return{type:14,op:"or",left,right};}
function and(left,right){return{type:14,op:"and",left,right};}
function isNot(ast){return ast.type===6&&ast.op==="not";}
function is(oneParamFunc,ast){return(ast.type===8&&ast.fn.type===5&&ast.fn.value===oneParamFunc&&ast.args.length===1);}
function isSet(ast){return ast.type===8&&ast.fn.type===5&&ast.fn.value==="set"&&ast.args.length<=1;}
function isBool(ast){return is("bool",ast);}
function isValidPath(ast,options){const getFieldDef=options.getFieldDef||(()=>null);if(ast.type===5){return getFieldDef(ast.value)!==null;}
return false;}
function isX2Many(ast,options){if(isValidPath(ast,options)){const fieldDef=options.getFieldDef(ast.value);return["many2many","one2many"].includes(fieldDef.type);}
return false;}
function _getConditionFromComparator(ast,options){if(["is","is not"].includes(ast.op)){return null;}
let operator=ast.op;if(operator==="=="){operator="=";}
let left=ast.left;let right=ast.right;if(isValidPath(left,options)==isValidPath(right,options)){return null;}
if(!isValidPath(left,options)){if(operator in EXCHANGE){const temp=left;left=right;right=temp;operator=EXCHANGE[operator];}else{return null;}}
return condition(left.value,operator,toValue(right));}
function isValidPath2(ast,options){if(!ast){return null;}
if([4,10].includes(ast.type)&&ast.value.length===1){return isValidPath(ast.value[0],options);}
return isValidPath(ast,options);}
function _getConditionFromIntersection(ast,options,negate=false){let left=ast.fn.obj.args[0];let right=ast.args[0];if(!left){return condition(negate?1:0,"=",1);}
if(isValidPath2(left,options)==isValidPath2(right,options)){return null;}
if(!isValidPath2(left,options)){const temp=left;left=right;right=temp;}
if([4,10].includes(left.type)&&left.value.length===1){left=left.value[0];}
if(!right){return condition(left.value,negate?"=":"!=",false);}
if(isSet(right)){if(!right.args[0]){right={type:4,value:[]};}
if([4,10].includes(right.args[0].type)){right=right.args[0];}}
if(![4,10].includes(right.type)){return null;}
return condition(left.value,negate?"not in":"in",toValue(right));}
function _leafFromAST(ast,options,negate=false){if(isNot(ast)){return _treeFromAST(ast.right,options,!negate);}
if(ast.type===5&&isValidPath(ast,options)){return condition(ast.value,negate?"=":"!=",false);}
const astValue=toValue(ast);if(["boolean","number","string"].includes(typeof astValue)){return condition(astValue?1:0,"=",1);}
if(ast.type===8&&ast.fn.type===15&&isSet(ast.fn.obj)&&ast.fn.key==="intersection"){const tree=_getConditionFromIntersection(ast,options,negate);if(tree){return tree;}}
if(ast.type===7&&COMPARATORS.includes(ast.op)){if(negate){return _leafFromAST(not(ast),options);}
const tree=_getConditionFromComparator(ast,options);if(tree){return tree;}}
return complexCondition(formatAST(negate?not(ast):ast));}
function _treeFromAST(ast,options,negate=false){if(isNot(ast)){return _treeFromAST(ast.right,options,!negate);}
if(ast.type===14){const tree=connector(ast.op==="and"?"&":"|");if(options.distributeNot&&negate){tree.value=tree.value==="&"?"|":"&";}else{tree.negate=negate;}
const subASTs=[ast.left,ast.right];for(const subAST of subASTs){const child=_treeFromAST(subAST,options,options.distributeNot&&negate);addChild(tree,child);}
return tree;}
if(ast.type===13){const newAST=or(and(ast.condition,ast.ifTrue),and(not(ast.condition),ast.ifFalse));return _treeFromAST(newAST,options,negate);}
return _leafFromAST(ast,options,negate);}
function _expressionFromTree(tree,options,isRoot=false){if(tree.type==="connector"&&tree.value==="|"&&tree.children.length===2){const isSimpleAnd=(tree)=>tree.type==="connector"&&tree.value==="&"&&tree.children.length===2;if(tree.children.every((c)=>isSimpleAnd(c))){const[c1,c2]=tree.children;for(let i=0;i<2;i++){const c1Child=c1.children[i];const str1=_expressionFromTree({...c1Child},options);for(let j=0;j<2;j++){const c2Child=c2.children[j];const str2=_expressionFromTree(c2Child,options);if(str1===`not ${str2}`||`not ${str1}`===str2){const others=[c1.children[1-i],c2.children[1-j]];const str=_expressionFromTree(c1Child,options);const strs=others.map((c)=>_expressionFromTree(c,options));return`${strs[0]} if ${str} else ${strs[1]}`;}}}}}
if(tree.type==="connector"){const connector=tree.value==="&"?"and":"or";const subExpressions=tree.children.map((c)=>_expressionFromTree(c,options));if(!subExpressions.length){return connector==="and"?"1":"0";}
let expression=subExpressions.join(` ${connector} `);if(!isRoot||tree.negate){expression=`( ${expression} )`;}
if(tree.negate){expression=`not ${expression}`;}
return expression;}
if(tree.type==="complex_condition"){return tree.value;}
tree=getNormalizedCondition(tree);const{path,operator,value}=tree;const op=operator==="="?"==":operator;if(typeof op!=="string"||!COMPARATORS.includes(op)){throw new Error("Invalid operator");}
if([0,1].includes(path)){if(operator!=="="||value!==1){return new Error("Invalid condition");}
return formatAST({type:2,value:Boolean(path)});}
const pathAST=toAST(path);if(typeof path=="string"&&isValidPath(name(path),options)){pathAST.type=5;}
if(value===false&&["=","!="].includes(operator)){return formatAST(operator==="="?not(pathAST):pathAST);}
let valueAST=toAST(value);if(["in","not in"].includes(operator)&&!(value instanceof Expression)&&![4,10].includes(valueAST.type)){valueAST={type:4,value:[valueAST]};}
if(pathAST.type===5&&isX2Many(pathAST,options)&&["in","not in"].includes(operator)){const ast={type:8,fn:{type:15,obj:{args:[pathAST],type:8,fn:{type:5,value:"set",},},key:"intersection",},args:[valueAST],};return formatAST(operator==="not in"?not(ast):ast);}
return formatAST({type:7,op,left:pathAST,right:valueAST,});}
function createBetweenOperators(tree){if(["condition","complex_condition"].includes(tree.type)){return tree;}
const processedChildren=tree.children.map(createBetweenOperators);if(tree.value==="|"){return{...tree,children:processedChildren};}
const children=[];for(let i=0;i<processedChildren.length;i++){const child1=processedChildren[i];const child2=processedChildren[i+1];if(child1.type==="condition"&&child2&&child2.type==="condition"&&formatValue(child1.path)===formatValue(child2.path)&&child1.operator===">="&&child2.operator==="<="){children.push(condition(child1.path,"between",normalizeValue([child1.value,child2.value])));i+=1;}else{children.push(child1);}}
if(children.length===1){return{...children[0]};}
return{...tree,children};}
function createWithinOperators(tree,options={}){if(tree.children){return{...tree,children:tree.children.map((child)=>createWithinOperators(child,options)),};}
const fieldType=options.getFieldDef?.(tree.path)?.type;if(tree.operator!=="between"||!["date","datetime"].includes(fieldType)){return tree;}
function getProcessedDelta(val,periodShouldBePositive=true){const delta=getDelta(toAST(val),fieldType);if(delta){const[amount]=delta;if(Number.isInteger(amount)&&((amount<0&&periodShouldBePositive)||(amount>0&&!periodShouldBePositive))){return null;}}
return delta;}
const newTree={...tree};if(isTodayExpr(newTree.value[0],fieldType)){const delta=getProcessedDelta(newTree.value[1]);if(delta){newTree.operator="within";newTree.value=[...delta,fieldType];}}else if(isTodayExpr(newTree.value[1],fieldType)){const delta=getProcessedDelta(newTree.value[0],false);if(delta){newTree.operator="within";newTree.value=[...delta,fieldType];}}
return newTree;}
__exports.removeBetweenOperators=removeBetweenOperators;function removeBetweenOperators(tree){if(tree.type==="complex_condition"){return tree;}
if(tree.type==="condition"){if(tree.operator!=="between"){return tree;}
const{negate,path,value}=tree;return connector("&",[condition(path,">=",value[0]),condition(path,"<=",value[1])],negate);}
const processedChildren=tree.children.map(removeBetweenOperators);if(tree.value==="|"){return{...tree,children:processedChildren};}
const newTree={...tree,children:[]};for(let i=0;i<processedChildren.length;i++){addChild(newTree,processedChildren[i]);}
return newTree;}
__exports.removeWithinOperators=removeWithinOperators;function removeWithinOperators(tree){if(tree.type==="complex_condition"){return tree;}
if(tree.type==="condition"){if(tree.operator!=="within"){return tree;}
const{negate,path,value}=tree;const fieldType=value[2];const expressions=[expression(fieldType==="date"?DATE_TODAY_STRING_EXPRESSION:DATETIME_TODAY_STRING_EXPRESSION),getDeltaExpression(value,fieldType),];const reverse=Number.isInteger(value[0])&&value[0]>0;return condition(path,"between",reverse?Object.values(expressions):Object.values(expressions).reverse(),negate);}
const processedChildren=tree.children.map(removeWithinOperators);return{...tree,children:processedChildren};}
__exports.createVirtualOperators=createVirtualOperators;function createVirtualOperators(tree,options={}){if(tree.type==="condition"){const{path,operator,value}=tree;if(["=","!="].includes(operator)){const fieldDef=options.getFieldDef?.(path)||null;if(fieldDef){if(fieldDef.type==="boolean"){return{...tree,operator:operator==="="?"is":"is_not"};}else if(!["many2one","date","datetime"].includes(fieldDef?.type)&&value===false){return{...tree,operator:operator==="="?"not_set":"set"};}}}
if(operator==="=ilike"){if(value.endsWith?.("%")){return{...tree,operator:"starts_with",value:value.slice(0,-1)};}
if(value.startsWith?.("%")){return{...tree,operator:"ends_with",value:value.slice(1)};}}
return tree;}
if(tree.type==="complex_condition"){return tree;}
const processedChildren=tree.children.map((c)=>createVirtualOperators(c,options));return{...tree,children:processedChildren};}
__exports.removeVirtualOperators=removeVirtualOperators;function removeVirtualOperators(tree){if(tree.type==="condition"){const{operator,value}=tree;if(["is","is_not"].includes(operator)){return{...tree,operator:operator==="is"?"=":"!="};}
if(["set","not_set"].includes(operator)){return{...tree,operator:operator==="set"?"!=":"="};}
if(["starts_with","ends_with"].includes(operator)){return{...tree,value:operator==="starts_with"?`${value}%`:`%${value}`,operator:"=ilike",};}
return tree;}
if(tree.type==="complex_condition"){return tree;}
const processedChildren=tree.children.map((c)=>removeVirtualOperators(c));return{...tree,children:processedChildren};}
function createComplexConditions(tree){if(tree.type==="condition"){if(tree.path instanceof Expression&&tree.operator==="="&&tree.value===1){return complexCondition(String(tree.path));}
return cloneTree(tree);}
if(tree.type==="complex_condition"){return cloneTree(tree);}
return{...tree,children:tree.children.map((child)=>createComplexConditions(child)),};}
function removeComplexConditions(tree){if(tree.type==="condition"){return cloneTree(tree);}
if(tree.type==="complex_condition"){const ast=parseExpr(tree.value);return condition(new Expression(bool(ast)),"=",1);}
return{...tree,children:tree.children.map((child)=>removeComplexConditions(child)),};}
__exports.treeFromExpression=treeFromExpression;function treeFromExpression(expression,options={}){const ast=parseExpr(expression);const tree=_treeFromAST(ast,options);return createVirtualOperators(createWithinOperators(createBetweenOperators(tree),options),options);}
__exports.expressionFromTree=expressionFromTree;function expressionFromTree(tree,options={}){const simplifiedTree=createComplexConditions(removeBetweenOperators(removeWithinOperators(removeVirtualOperators(tree))));return _expressionFromTree(simplifiedTree,options,true);}
__exports.domainFromTree=domainFromTree;function domainFromTree(tree){const simplifiedTree=removeBetweenOperators(removeWithinOperators(removeVirtualOperators(removeComplexConditions(tree))));const domainAST={type:4,value:getASTs(simplifiedTree),};return formatAST(domainAST);}
__exports.treeFromDomain=treeFromDomain;function treeFromDomain(domain,options={}){domain=new Domain(domain);const domainAST=domain.ast;const tree=construcTree(domainAST.value,options);return createVirtualOperators(createWithinOperators(createBetweenOperators(tree),options),options);}
__exports.expressionFromDomain=expressionFromDomain;function expressionFromDomain(domain,options={}){const tree=treeFromDomain(domain,options);return expressionFromTree(tree,options);}
__exports.domainFromExpression=domainFromExpression;function domainFromExpression(expression,options={}){const tree=treeFromExpression(expression,options);return domainFromTree(tree);}
return __exports;});;

/* /web/static/src/core/tree_editor/tree_editor.js */
odoo.define('@web/core/tree_editor/tree_editor',['@web/core/tree_editor/utils','@odoo/owl','@web/core/utils/hooks','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/tree_editor/condition_tree','@web/core/tree_editor/tree_editor_value_editors','@web/core/model_field_selector/model_field_selector','@web/core/model_field_selector/utils','@web/core/utils/objects'],function(require){'use strict';let __exports={};const{getResModel,useMakeGetFieldDef,useMakeGetConditionDescription,}=require("@web/core/tree_editor/utils");const{Component,onWillStart,onWillUpdateProps}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{condition,cloneTree,formatValue,removeVirtualOperators,connector,isTree,}=require("@web/core/tree_editor/condition_tree");const{getDefaultValue,getValueEditorInfo,}=require("@web/core/tree_editor/tree_editor_value_editors");const{ModelFieldSelector}=require("@web/core/model_field_selector/model_field_selector");const{useLoadFieldInfo}=require("@web/core/model_field_selector/utils");const{deepEqual,shallowEqual}=require("@web/core/utils/objects");const TRUE_TREE=condition(1,"=",1);function collectDifferences(tree,otherTree){if(tree.type!==otherTree.type){return[{type:"other"}];}
if(tree.negate!==otherTree.negate){return[{type:"other"}];}
if(tree.type==="condition"){if(formatValue(tree.path)!==formatValue(otherTree.path)){return[{type:"other"}];}
if(formatValue(tree.value)!==formatValue(otherTree.value)){return[{type:"other"}];}
if(formatValue(tree.operator)!==formatValue(otherTree.operator)){if(tree.operator==="!="&&otherTree.operator==="set"){return[{type:"replacement",tree,operator:"set"}];}else if(tree.operator==="="&&otherTree.operator==="not_set"){return[{type:"replacement",tree,operator:"not_set"}];}else{return[{type:"other"}];}}
return[];}
if(tree.value!==otherTree.value){return[{type:"other"}];}
if(tree.type==="complex_condition"){return[];}
if(tree.children.length!==otherTree.children.length){return[{type:"other"}];}
const diffs=[];for(let i=0;i<tree.children.length;i++){const child=tree.children[i];const otherChild=otherTree.children[i];const childDiffs=collectDifferences(child,otherChild);if(childDiffs.some((d)=>d.type!=="replacement")){return[{type:"other"}];}
diffs.push(...childDiffs);}
return diffs;}
function restoreVirtualOperators(tree,otherTree){const diffs=collectDifferences(tree,otherTree);if(diffs.some((d)=>d.type!=="replacement")){return;}
for(const{tree,operator}of diffs){tree.operator=operator;}}
const TreeEditor=__exports.TreeEditor=class TreeEditor extends Component{static template="web.TreeEditor";static components={Dropdown,DropdownItem,ModelFieldSelector,TreeEditor,};static props={tree:Object,resModel:String,update:Function,getDefaultCondition:Function,getPathEditorInfo:Function,getOperatorEditorInfo:Function,getDefaultOperator:Function,readonly:{type:Boolean,optional:true},slots:{type:Object,optional:true},isDebugMode:{type:Boolean,optional:true},defaultConnector:{type:[{value:"&"},{value:"|"}],optional:true},isSubTree:{type:Boolean,optional:true},};static defaultProps={defaultConnector:"&",readonly:false,isSubTree:false,};setup(){this.isTree=isTree;this.fieldService=useService("field");this.nameService=useService("name");this.loadFieldInfo=useLoadFieldInfo(this.fieldService);this.makeGetFieldDef=useMakeGetFieldDef(this.fieldService);this.makeGetConditionDescription=useMakeGetConditionDescription(this.fieldService,this.nameService);onWillStart(()=>this.onPropsUpdated(this.props));onWillUpdateProps((nextProps)=>this.onPropsUpdated(nextProps));}
async onPropsUpdated(props){this.tree=cloneTree(props.tree);if(shallowEqual(this.tree,TRUE_TREE)){this.tree=connector(props.defaultConnector);}else if(this.tree.type!=="connector"){this.tree=connector(props.defaultConnector,[this.tree]);}
if(this.previousTree){restoreVirtualOperators(this.tree,this.previousTree);this.previousTree=null;}
const[fieldDefs,getFieldDef]=await Promise.all([this.fieldService.loadFields(props.resModel),this.makeGetFieldDef(props.resModel,this.tree),]);this.getFieldDef=getFieldDef;this.defaultCondition=props.getDefaultCondition(fieldDefs);if(props.readonly){this.getConditionDescription=await this.makeGetConditionDescription(props.resModel,this.tree,this.getFieldDef);}}
get className(){return`${this.props.readonly ? "o_read_mode" : "o_edit_mode"}`;}
get isDebugMode(){return this.props.isDebugMode!==undefined?this.props.isDebugMode:!!this.env.debug;}
notifyChanges(){this.previousTree=cloneTree(this.tree);this.props.update(this.tree);}
updateConnector(node,value){node.value=value;node.negate=false;this.notifyChanges();}
updateComplexCondition(node,value){node.value=value;this.notifyChanges();}
createNewLeaf(){return cloneTree(this.defaultCondition);}
createNewBranch(value){return connector(value,[this.createNewLeaf(),this.createNewLeaf()]);}
insertRootLeaf(parent){parent.children.push(this.createNewLeaf());this.notifyChanges();}
insertLeaf(parent,node){const newNode=node.type!=="connector"?cloneTree(node):this.createNewLeaf();const index=parent.children.indexOf(node);parent.children.splice(index+1,0,newNode);this.notifyChanges();}
insertBranch(parent,node){const nextConnector=parent.value==="&"?"|":"&";const newNode=this.createNewBranch(nextConnector);const index=parent.children.indexOf(node);parent.children.splice(index+1,0,newNode);this.notifyChanges();}
delete(parent,node){const index=parent.children.indexOf(node);parent.children.splice(index,1);this.notifyChanges();}
getResModel(node){const fieldDef=this.getFieldDef(node.path);const resModel=getResModel(fieldDef);return resModel;}
getPathEditorInfo(){return this.props.getPathEditorInfo(this.props.resModel,this.defaultCondition);}
getOperatorEditorInfo(node){const fieldDef=this.getFieldDef(node.path);return this.props.getOperatorEditorInfo(fieldDef);}
getValueEditorInfo(node){const fieldDef=this.getFieldDef(node.path);return getValueEditorInfo(fieldDef,node.operator);}
async updatePath(node,path){const{fieldDef}=await this.loadFieldInfo(this.props.resModel,path);node.path=path;node.negate=false;node.operator=this.props.getDefaultOperator(fieldDef);node.value=getDefaultValue(fieldDef,node.operator);this.notifyChanges();}
updateLeafOperator(node,operator,negate){const previousNode=cloneTree(node);const fieldDef=this.getFieldDef(node.path);node.negate=negate;node.operator=operator;node.value=getDefaultValue(fieldDef,operator,node.value);if(deepEqual(removeVirtualOperators(node),removeVirtualOperators(previousNode))){this.render();}
this.notifyChanges();}
updateLeafValue(node,value){node.value=value;this.notifyChanges();}
highlightNode(target){const nodeEl=target.closest(".o_tree_editor_node");nodeEl.classList.toggle("o_hovered_button");}}
return __exports;});;

/* /web/static/src/core/tree_editor/tree_editor_autocomplete.js */
odoo.define('@web/core/tree_editor/tree_editor_autocomplete',['@web/core/record_selectors/multi_record_selector','@web/core/l10n/translation','@web/core/py_js/py_utils','@web/core/tree_editor/condition_tree','@web/core/record_selectors/record_selector'],function(require){'use strict';let __exports={};const{MultiRecordSelector}=require("@web/core/record_selectors/multi_record_selector");const{_t}=require("@web/core/l10n/translation");const{formatAST,toPyValue}=require("@web/core/py_js/py_utils");const{Expression}=require("@web/core/tree_editor/condition_tree");const{RecordSelector}=require("@web/core/record_selectors/record_selector");const isId=__exports.isId=(val)=>Number.isInteger(val)&&val>=1;const getFormat=__exports.getFormat=(val,displayNames)=>{let text;let colorIndex;if(isId(val)){text=typeof displayNames[val]==="string"?displayNames[val]:_t("Inaccessible/missing record ID: %s",val);colorIndex=typeof displayNames[val]==="string"?0:2;}else{text=val instanceof Expression?String(val):_t("Invalid record ID: %s",formatAST(toPyValue(val)));colorIndex=val instanceof Expression?2:1;}
return{text,colorIndex};};const DomainSelectorAutocomplete=__exports.DomainSelectorAutocomplete=class DomainSelectorAutocomplete extends MultiRecordSelector{static props={...MultiRecordSelector.props,resIds:true,};getIds(props=this.props){return props.resIds.filter((val)=>isId(val));}
getTags(props,displayNames){return props.resIds.map((val,index)=>{const{text,colorIndex}=getFormat(val,displayNames);return{text,colorIndex,onDelete:()=>{this.props.update([...this.props.resIds.slice(0,index),...this.props.resIds.slice(index+1),]);},};});}}
const DomainSelectorSingleAutocomplete=__exports.DomainSelectorSingleAutocomplete=class DomainSelectorSingleAutocomplete extends RecordSelector{static props={...RecordSelector.props,resId:true,};getDisplayName(props=this.props,displayNames){const{resId}=props;if(resId===false){return"";}
const{text}=getFormat(resId,displayNames);return text;}
getIds(props=this.props){if(isId(props.resId)){return[props.resId];}
return[];}}
return __exports;});;

/* /web/static/src/core/tree_editor/tree_editor_components.js */
odoo.define('@web/core/tree_editor/tree_editor_components',['@odoo/owl','@web/core/tags_list/tags_list','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{TagsList}=require("@web/core/tags_list/tags_list");const{_t}=require("@web/core/l10n/translation");const Input=__exports.Input=class Input extends Component{static props=["value","update","startEmpty?"];static template="web.TreeEditor.Input";}
const Select=__exports.Select=class Select extends Component{static props=["value","update","options","addBlankOption?"];static template="web.TreeEditor.Select";deserialize(value){return JSON.parse(value);}
serialize(value){return JSON.stringify(value);}}
const Range=__exports.Range=class Range extends Component{static props=["value","update","editorInfo"];static template="web.TreeEditor.Range";update(index,newValue){const result=[...this.props.value];result[index]=newValue;return this.props.update(result);}}
const Within=__exports.Within=class Within extends Component{static props=["value","update","amountEditorInfo","optionEditorInfo"];static template="web.TreeEditor.Within";static components={Input,Select};static options=[["days",_t("days")],["weeks",_t("weeks")],["months",_t("months")],["years",_t("years")],];update(index,newValue){const result=[...this.props.value];result[index]=newValue;return this.props.update(result);}}
const List=__exports.List=class List extends Component{static components={TagsList};static props=["value","update","editorInfo"];static template="web.TreeEditor.List";get tags(){const{isSupported,stringify}=this.props.editorInfo;return this.props.value.map((val,index)=>({text:stringify(val),colorIndex:isSupported(val)?0:2,onDelete:()=>{this.props.update([...this.props.value.slice(0,index),...this.props.value.slice(index+1),]);},}));}
update(newValue){return this.props.update([...this.props.value,newValue]);}}
return __exports;});;

/* /web/static/src/core/tree_editor/tree_editor_operator_editor.js */
odoo.define('@web/core/tree_editor/tree_editor_operator_editor',['@web/core/l10n/translation','@web/core/tree_editor/condition_tree','@web/core/utils/strings','@web/core/py_js/py','@web/core/tree_editor/tree_editor_components'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{formatValue,TERM_OPERATORS_NEGATION,toValue,}=require("@web/core/tree_editor/condition_tree");const{sprintf}=require("@web/core/utils/strings");const{parseExpr}=require("@web/core/py_js/py");const{Select}=require("@web/core/tree_editor/tree_editor_components");const OPERATOR_DESCRIPTIONS={"=":"=","!=":"!=","<=":"<=","<":"<",">":">",">=":">=","=?":"=?","=like":_t("=like"),"=ilike":_t("=ilike"),like:_t("like"),"not like":_t("not like"),ilike:_t("contains"),"not ilike":_t("does not contain"),in:_t("is in"),"not in":_t("is not in"),child_of:_t("child of"),parent_of:_t("parent of"),is:_t("is"),is_not:_t("is not"),set:_t("is set"),not_set:_t("is not set"),starts_with:_t("starts with"),ends_with:_t("ends with"),between:_t("is between"),within:_t("is within"),any:(fieldDefType)=>{switch(fieldDefType){case"many2one":return _t("matches");default:return _t("match");}},"not any":(fieldDefType)=>{switch(fieldDefType){case"many2one":return _t("matches none of");default:return _t("match none of");}},};function toKey(operator,negate=false){if(!negate&&typeof operator==="string"&&operator in OPERATOR_DESCRIPTIONS){return operator;}
return JSON.stringify([formatValue(operator),negate]);}
function toOperator(key){if(!key.includes("[")){return[key,false];}
const[expr,negate]=JSON.parse(key);return[toValue(parseExpr(expr)),negate];}
function getOperatorDescription(operator,fieldDefType){const description=OPERATOR_DESCRIPTIONS[operator];if(typeof description==="function"&&description.constructor?.name!=="LazyTranslatedString"){return description(fieldDefType);}
return description;}
__exports.getOperatorLabel=getOperatorLabel;function getOperatorLabel(operator,fieldDefType,negate=false){let label;if(typeof operator==="string"&&operator in OPERATOR_DESCRIPTIONS){if(negate&&operator in TERM_OPERATORS_NEGATION){return getOperatorDescription(TERM_OPERATORS_NEGATION[operator],fieldDefType);}
label=getOperatorDescription(operator,fieldDefType);}else{label=formatValue(operator);}
if(negate){return sprintf(`not %s`,label);}
return label;}
function getOperatorInfo(operator,fieldDefType,negate=false){const key=toKey(operator,negate);const label=getOperatorLabel(operator,fieldDefType,negate);return[key,label];}
__exports.getOperatorEditorInfo=getOperatorEditorInfo;function getOperatorEditorInfo(operators,fieldDef){const defaultOperator=operators[0];const operatorsInfo=operators.map((operator)=>getOperatorInfo(operator,fieldDef?.type));return{component:Select,extractProps:({update,value:[operator,negate]})=>{const[operatorKey,operatorLabel]=getOperatorInfo(operator,fieldDef?.type,negate);const options=[...operatorsInfo];if(!options.some(([key])=>key===operatorKey)){options.push([operatorKey,operatorLabel]);}
return{value:operatorKey,update:(operatorKey)=>update(...toOperator(operatorKey)),options,};},defaultValue:()=>defaultOperator,isSupported:([operator])=>typeof operator==="string"&&operator in OPERATOR_DESCRIPTIONS,message:_t("Operator not supported"),stringify:([operator,negate])=>getOperatorLabel(operator,negate),};}
return __exports;});;

/* /web/static/src/core/tree_editor/tree_editor_value_editors.js */
odoo.define('@web/core/tree_editor/tree_editor_value_editors',['@web/core/l10n/dates','@web/core/l10n/translation','@web/core/registry','@web/core/datetime/datetime_input','@web/core/tree_editor/tree_editor_autocomplete','@web/core/utils/arrays','@web/core/tree_editor/tree_editor_components','@web/core/tree_editor/condition_tree','@web/core/tree_editor/utils','@web/core/domain'],function(require){'use strict';let __exports={};const{deserializeDate,deserializeDateTime,serializeDate,serializeDateTime,}=require("@web/core/l10n/dates");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{DateTimeInput}=require("@web/core/datetime/datetime_input");const{DomainSelectorAutocomplete,DomainSelectorSingleAutocomplete,}=require("@web/core/tree_editor/tree_editor_autocomplete");const{unique}=require("@web/core/utils/arrays");const{Input,Select,List,Range,Within}=require("@web/core/tree_editor/tree_editor_components");const{connector,formatValue,isTree}=require("@web/core/tree_editor/condition_tree");const{getResModel,disambiguate,isId}=require("@web/core/tree_editor/utils");const{Domain}=require("@web/core/domain");const{DateTime}=luxon;const formatters=registry.category("formatters");const parsers=registry.category("parsers");function parseValue(fieldType,value){const parser=parsers.get(fieldType,(value)=>value);try{return parser(value);}catch{return value;}}
function isParsable(fieldType,value){const parser=parsers.get(fieldType,(value)=>value);try{parser(value);}catch{return false;}
return true;}
function genericSerializeDate(type,value){return type==="date"?serializeDate(value):serializeDateTime(value);}
function genericDeserializeDate(type,value){return type==="date"?deserializeDate(value):deserializeDateTime(value);}
const STRING_EDITOR={component:Input,extractProps:({value,update})=>({value,update}),isSupported:(value)=>typeof value==="string",defaultValue:()=>"",};function makeSelectEditor(options,params={}){const getOption=(value)=>options.find(([v])=>v===value)||null;return{component:Select,extractProps:({value,update})=>({value,update,options,addBlankOption:params.addBlankOption,}),isSupported:(value)=>Boolean(getOption(value)),defaultValue:()=>options[0]?.[0]??false,stringify:(value,disambiguate)=>{const option=getOption(value);return option?option[1]:disambiguate?formatValue(value):String(value);},message:_t("Value not in selection"),};}
function getDomain(fieldDef){if(fieldDef.type==="many2one"){return[];}
try{return new Domain(fieldDef.domain||[]).toList();}catch{return[];}}
function makeAutoCompleteEditor(fieldDef){return{component:DomainSelectorAutocomplete,extractProps:({value,update})=>{return{resModel:getResModel(fieldDef),fieldString:fieldDef.string,domain:getDomain(fieldDef),update:(value)=>update(unique(value)),resIds:unique(value),};},isSupported:(value)=>Array.isArray(value),defaultValue:()=>[],};}
function getPartialValueEditorInfo(fieldDef,operator,params={}){switch(operator){case"set":case"not_set":return{component:null,extractProps:null,isSupported:(value)=>value===false,defaultValue:()=>false,};case"=like":case"=ilike":case"like":case"not like":case"ilike":case"not ilike":return STRING_EDITOR;case"between":{const editorInfo=getValueEditorInfo(fieldDef,"=");return{component:Range,extractProps:({value,update})=>({value,update,editorInfo,}),isSupported:(value)=>Array.isArray(value)&&value.length===2,defaultValue:()=>{const{defaultValue}=editorInfo;return[defaultValue(),defaultValue()];},};}
case"within":{return{component:Within,extractProps:({value,update})=>({value,update,amountEditorInfo:getValueEditorInfo({type:"integer"},"="),optionEditorInfo:makeSelectEditor(Within.options),}),isSupported:(value)=>Array.isArray(value)&&value.length===3&&typeof value[1]==="string"&&value[2]===fieldDef.type,defaultValue:()=>{return[-1,"months",fieldDef.type];},};}
case"in":case"not in":{switch(fieldDef.type){case"tags":return STRING_EDITOR;case"many2one":case"many2many":case"one2many":return makeAutoCompleteEditor(fieldDef);default:{const editorInfo=getValueEditorInfo(fieldDef,"=",{addBlankOption:true,startEmpty:true,});return{component:List,extractProps:({value,update})=>{if(!disambiguate(value)){const{stringify}=editorInfo;editorInfo.stringify=(val)=>stringify(val,false);}
return{value,update,editorInfo,};},isSupported:(value)=>Array.isArray(value),defaultValue:()=>[],};}}}
case"any":case"not any":{switch(fieldDef.type){case"many2one":case"many2many":case"one2many":{return{component:null,extractProps:null,isSupported:isTree,defaultValue:()=>connector("&"),};}}}}
const{type}=fieldDef;switch(type){case"integer":case"float":case"monetary":{const formatType=type==="integer"?"integer":"float";return{component:Input,extractProps:({value,update})=>({value:String(value),update:(value)=>update(parseValue(formatType,value)),startEmpty:params.startEmpty,}),isSupported:()=>true,defaultValue:()=>1,shouldResetValue:(value)=>parseValue(formatType,value)===value,};}
case"date":case"datetime":return{component:DateTimeInput,extractProps:({value,update})=>({value:params.startEmpty||value===false?false:genericDeserializeDate(type,value),type,onApply:(value)=>{if(!params.startEmpty||value){update(genericSerializeDate(type,value||DateTime.local()));}},}),isSupported:(value)=>value===false||(typeof value==="string"&&isParsable(type,value)),defaultValue:()=>genericSerializeDate(type,DateTime.local()),stringify:(value)=>{if(value===false){return _t("False");}
if(typeof value==="string"&&isParsable(type,value)){const formatter=formatters.get(type,formatValue);return formatter(genericDeserializeDate(type,value));}
return formatValue(value);},message:_t("Not a valid %s",type),};case"char":case"html":case"text":return STRING_EDITOR;case"boolean":{if(["is","is_not"].includes(operator)){const options=[[true,_t("set")],[false,_t("not set")],];return makeSelectEditor(options,params);}
const options=[[true,_t("True")],[false,_t("False")],];return makeSelectEditor(options,params);}
case"many2one":{if(["=","!="].includes(operator)){return{component:DomainSelectorSingleAutocomplete,extractProps:({value,update})=>({resModel:getResModel(fieldDef),fieldString:fieldDef.string,update,resId:value,}),isSupported:()=>true,defaultValue:()=>false,shouldResetValue:(value)=>value!==false&&!isId(value),};}else if(["parent_of","child_of"].includes(operator)){return makeAutoCompleteEditor(fieldDef);}
break;}
case"many2many":case"one2many":if(["=","!="].includes(operator)){return makeAutoCompleteEditor(fieldDef);}
break;case"selection":{const options=fieldDef.selection||[];return makeSelectEditor(options,params);}
case undefined:{const options=[[1,"1"]];return makeSelectEditor(options,params);}}
return{component:Input,extractProps:({value,update})=>({value:String(value),update,}),isSupported:()=>true,defaultValue:()=>"",};}
__exports.getValueEditorInfo=getValueEditorInfo;function getValueEditorInfo(fieldDef,operator,options={}){const info=getPartialValueEditorInfo(fieldDef||{},operator,options);return{extractProps:({value,update})=>({value,update}),message:_t("Value not supported"),stringify:(val,disambiguate=true)=>{if(disambiguate){return formatValue(val);}
return String(val);},...info,};}
__exports.getDefaultValue=getDefaultValue;function getDefaultValue(fieldDef,operator,value=null){const{isSupported,shouldResetValue,defaultValue}=getValueEditorInfo(fieldDef,operator);if(value===null||!isSupported(value)||shouldResetValue?.(value)){return defaultValue();}
return value;}
return __exports;});;

/* /web/static/src/core/tree_editor/utils.js */
odoo.define('@web/core/tree_editor/utils',['@web/core/utils/arrays','@web/core/tree_editor/tree_editor_operator_editor','@web/core/tree_editor/condition_tree','@web/core/utils/hooks','@web/core/l10n/translation','@web/core/l10n/dates','@web/core/model_field_selector/utils','@web/core/tree_editor/tree_editor_components'],function(require){'use strict';let __exports={};const{unique,zip}=require("@web/core/utils/arrays");const{getOperatorLabel}=require("@web/core/tree_editor/tree_editor_operator_editor");const{Expression,condition,createVirtualOperators,normalizeValue,isTree,Couple,}=require("@web/core/tree_editor/condition_tree");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const{deserializeDate,deserializeDateTime,formatDate,formatDateTime,}=require("@web/core/l10n/dates");const{useLoadFieldInfo,useLoadPathDescription}=require("@web/core/model_field_selector/utils");const{Within}=require("@web/core/tree_editor/tree_editor_components");function formatValue(val,disambiguate,fieldDef,displayNames){if(val instanceof Expression){return val.toString();}
if(displayNames&&isId(val)){if(typeof displayNames[val]==="string"){val=displayNames[val];}else{return _t("Inaccessible/missing record ID: %s",val);}}
if(fieldDef?.type==="selection"){const[,label]=(fieldDef.selection||[]).find(([v])=>v===val)||[];if(label!==undefined){val=label;}}
if(typeof val==="string"){if(fieldDef?.type==="datetime"){return formatDateTime(deserializeDateTime(val));}
if(fieldDef?.type==="date"){return formatDate(deserializeDate(val));}}
if(disambiguate&&typeof val==="string"){return JSON.stringify(val);}
return val;}
__exports.isId=isId;function isId(value){return Number.isInteger(value)&&value>=1;}
__exports.disambiguate=disambiguate;function disambiguate(value,displayNames){if(!Array.isArray(value)){return value==="";}
let hasSomeString=false;let hasSomethingElse=false;for(const val of value){if(val===""){return true;}
if(typeof val==="string"||(displayNames&&isId(val))){hasSomeString=true;}else{hasSomethingElse=true;}}
return hasSomeString&&hasSomethingElse;}
__exports.useMakeGetFieldDef=useMakeGetFieldDef;function useMakeGetFieldDef(fieldService){fieldService||=useService("field");const loadFieldInfo=useLoadFieldInfo(fieldService);return async(resModel,tree,additionalsPath=[])=>{const pathsInTree=getPathsInTree(tree,true);const paths=new Set([...pathsInTree,...additionalsPath]);const promises=[];const fieldDefs={};const loadFieldInfoFromMultiplePaths=async(resModel,fieldDefs,path)=>{if(typeof path==="string"&&!(path in fieldDefs)){const prom=loadFieldInfo(resModel,path).then(({fieldDef})=>{fieldDefs[path].fieldDef=fieldDef;return fieldDef?.relation||null;});fieldDefs[path]={prom,pathFieldDefs:{},fieldDef:null};return prom;}
if(path instanceof Couple&&typeof path.fst==="string"&&path.fst in fieldDefs){const resModel=await fieldDefs[path.fst].prom;if(resModel){return loadFieldInfoFromMultiplePaths(resModel,fieldDefs[path.fst].pathFieldDefs,path.snd);}}
return null;};for(const path of paths){promises.push(loadFieldInfoFromMultiplePaths(resModel,fieldDefs,path));}
await Promise.all(promises);const _getFieldDef=(path,fieldDefs)=>{if(typeof path==="string"){return fieldDefs[path].fieldDef;}
if(path instanceof Couple&&typeof path.fst==="string"&&path.fst in fieldDefs){return _getFieldDef(path.snd,fieldDefs[path.fst].pathFieldDefs);}
return null;};return(path)=>_getFieldDef(path,fieldDefs);};}
function useGetTreePathDescription(fieldService){fieldService||=useService("field");const loadPathDescription=useLoadPathDescription(fieldService);return async(resModel,tree)=>{const paths=getPathsInTree(tree);const promises=[];const pathDescriptions=new Map();for(const path of paths){promises.push(loadPathDescription(resModel,path).then(({displayNames})=>{pathDescriptions.set(path,displayNames.join(" \u2794 "));}));}
await Promise.all(promises);return(path)=>pathDescriptions.get(path);};}
async function getDisplayNames(tree,getFieldDef,nameService){const resIdsByModel=extractIdsFromTree(tree,getFieldDef);const proms=[];const resModels=[];for(const[resModel,resIds]of Object.entries(resIdsByModel)){resModels.push(resModel);proms.push(nameService.loadDisplayNames(resModel,resIds));}
return Object.fromEntries(zip(resModels,await Promise.all(proms)));}
__exports.useMakeGetConditionDescription=useMakeGetConditionDescription;function useMakeGetConditionDescription(fieldService,nameService){const makeGetPathDescriptions=useGetTreePathDescription(fieldService);return async(resModel,tree,getFieldDef)=>{tree=simplifyTree(tree);const[displayNames,getPathDescription]=await Promise.all([getDisplayNames(tree,getFieldDef,nameService),makeGetPathDescriptions(resModel,tree),]);return(node)=>_getConditionDescription(node,getFieldDef,getPathDescription,displayNames);};}
function _getConditionDescription(node,getFieldDef,getPathDescription,displayNames){const nodeWithVirtualOperators=createVirtualOperators(node,{getFieldDef});const{operator,negate,value,path}=nodeWithVirtualOperators;const fieldDef=getFieldDef(path);const operatorLabel=getOperatorLabel(operator,fieldDef?.type,negate);const pathDescription=getPathDescription(path);const description={pathDescription,operatorDescription:operatorLabel,valueDescription:null,};if(isTree(node.value)){return description;}
if(["set","not_set"].includes(operator)){return description;}
if(["is","is_not"].includes(operator)){description.valueDescription={values:[value?_t("set"):_t("not set")],join:"",addParenthesis:false,};return description;}
const coModeldisplayNames=displayNames[getResModel(fieldDef)];const dis=disambiguate(value,coModeldisplayNames);const values=operator=="within"?[value[0],Within.options.find((option)=>option[0]===value[1])[1]]:(Array.isArray(value)?value:[value]).slice(0,21).map((val,index)=>index<20?formatValue(val,dis,fieldDef,coModeldisplayNames):"...");let join;let addParenthesis=Array.isArray(value);switch(operator){case"between":join=_t("and");addParenthesis=false;break;case"within":join=" ";addParenthesis=false;break;case"in":case"not in":join=",";break;default:join=_t("or");}
description.valueDescription={values,join,addParenthesis};return description;}
__exports.useGetTreeDescription=useGetTreeDescription;function useGetTreeDescription(fieldService,nameService){fieldService||=useService("field");nameService||=useService("name");const makeGetFieldDef=useMakeGetFieldDef(fieldService);const makeGetConditionDescription=useMakeGetConditionDescription(fieldService,nameService);return async(resModel,tree)=>{async function getTreeDescription(resModel,tree,isSubExpression=false){tree=simplifyTree(tree);if(tree.type==="connector"){const childDescriptions=tree.children.map((node)=>getTreeDescription(resModel,node,true));const separator=tree.value==="&"?_t("and"):_t("or");let description=await Promise.all(childDescriptions);description=description.join(` ${separator} `);if(isSubExpression||tree.negate){description=`( ${description} )`;}
if(tree.negate){description=`! ${description}`;}
return description;}
const getFieldDef=await makeGetFieldDef(resModel,tree);const getConditionDescription=await makeGetConditionDescription(resModel,tree,getFieldDef);const{pathDescription,operatorDescription,valueDescription}=getConditionDescription(tree);const stringDescription=[pathDescription,operatorDescription];if(valueDescription){const{values,join,addParenthesis}=valueDescription;const jointedValues=values.join(` ${join} `);stringDescription.push(addParenthesis?`( ${jointedValues} )`:jointedValues);}else if(isTree(tree.value)){const _fieldDef=getFieldDef(tree.path);const _resModel=getResModel(_fieldDef);const _tree=tree.value;const description=await getTreeDescription(_resModel,_tree);stringDescription.push(`( ${description} )`);}
return stringDescription.join(" ");}
return getTreeDescription(resModel,tree);};}
__exports.getResModel=getResModel;function getResModel(fieldDef){if(fieldDef){return fieldDef.is_property?fieldDef.comodel:fieldDef.relation;}
return null;}
function extractIdsFromTree(tree,getFieldDef){const idsByModel=_extractIdsRecursive(tree,getFieldDef,{});for(const resModel in idsByModel){idsByModel[resModel]=unique(idsByModel[resModel]);}
return idsByModel;}
function _extractIdsRecursive(tree,getFieldDef,idsByModel){if(tree.type==="condition"){const fieldDef=getFieldDef(tree.path);if(["many2one","many2many","one2many"].includes(fieldDef?.type)){const value=tree.value;const values=Array.isArray(value)?value:[value];const ids=values.filter((val)=>isId(val));const resModel=getResModel(fieldDef);if(ids.length){if(!idsByModel[resModel]){idsByModel[resModel]=[];}
idsByModel[resModel].push(...ids);}}}
if(tree.type==="connector"){for(const child of tree.children){_extractIdsRecursive(child,getFieldDef,idsByModel);}}
return idsByModel;}
__exports.getPathsInTree=getPathsInTree;function getPathsInTree(tree,lookInSubTrees=false){const paths=[];if(tree.type==="condition"){paths.push(tree.path);if(lookInSubTrees&&isTree(tree.value)){const subTreePaths=getPathsInTree(tree.value,lookInSubTrees);for(const p of subTreePaths){paths.push(new Couple(tree.path,p));}}}
if(tree.type==="connector"&&tree.children){for(const child of tree.children){paths.push(...getPathsInTree(child,lookInSubTrees));}}
return unique(paths);}
const SPECIAL_FIELDS=["country_id","user_id","partner_id","stage_id","id"];__exports.getDefaultPath=getDefaultPath;function getDefaultPath(fieldDefs){for(const name of SPECIAL_FIELDS){const fieldDef=fieldDefs[name];if(fieldDef){return fieldDef.name;}}
const name=Object.keys(fieldDefs)[0];if(name){return name;}
throw new Error(`No field found`);}
function simplifyTree(tree){if(tree.type==="condition"){return tree;}
const processedChildren=tree.children.map(simplifyTree);if(tree.value==="&"){return{...tree,children:processedChildren};}
const children=[];const childrenByPath={};for(const child of processedChildren){if(child.type==="connector"||typeof child.path!=="string"||!["=","in"].includes(child.operator)){children.push(child);}else{if(!childrenByPath[child.path]){childrenByPath[child.path]=[];}
childrenByPath[child.path].push(child);}}
for(const path in childrenByPath){if(childrenByPath[path].length===1){children.push(childrenByPath[path][0]);continue;}
const value=[];for(const child of childrenByPath[path]){if(child.operator==="="){value.push(child.value);}else{value.push(...child.value);}}
children.push(condition(path,"in",normalizeValue(value)));}
if(children.length===1){return{...children[0]};}
return{...tree,children};}
return __exports;});;

/* /web/static/src/core/ui/block_ui.js */
odoo.define('@web/core/ui/block_ui',['@web/core/l10n/translation','@web/core/browser/browser','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{EventBus,Component,useState,xml}=require("@odoo/owl");const BlockUI=__exports.BlockUI=class BlockUI extends Component{static props={bus:EventBus,};static template=xml`
        <t t-if="state.blockState === BLOCK_STATES.UNBLOCKED">
            <div/>
        </t>
        <t t-else="">
            <t t-set="visiblyBlocked" t-value="state.blockState === BLOCK_STATES.VISIBLY_BLOCKED"/>
            <div class="o_blockUI fixed-top d-flex justify-content-center align-items-center flex-column vh-100"
                 t-att-class="visiblyBlocked ? '' : 'o_blockUI_invisible'">
                <t t-if="visiblyBlocked">
                    <div class="o_spinner mb-4">
                        <img src="/web/static/img/spin.svg" alt="Loading..."/>
                    </div>
                    <div class="o_message text-center px-4">
                        <t t-esc="state.line1"/><br/>
                        <t t-esc="state.line2"/>
                    </div>
                </t>
            </div>
        </t>
    `;setup(){this.messagesByDuration=[{time:20,l1:_t("Loading...")},{time:40,l1:_t("Still loading...")},{time:60,l1:_t("Still loading..."),l2:_t("Please be patient."),},{time:180,l1:_t("Don't leave yet,"),l2:_t("it's still loading..."),},{time:120,l1:_t("You may not believe it,"),l2:_t("but the application is actually loading..."),},{time:3180,l1:_t("Take a minute to get a coffee,"),l2:_t("because it's loading..."),},{time:null,l1:_t("Maybe you should consider reloading the application by pressing F5..."),},];this.BLOCK_STATES={UNBLOCKED:0,BLOCKED:1,VISIBLY_BLOCKED:2};this.state=useState({blockState:this.BLOCK_STATES.UNBLOCKED,line1:"",line2:"",});this.props.bus.addEventListener("BLOCK",this.block.bind(this));this.props.bus.addEventListener("UNBLOCK",this.unblock.bind(this));}
replaceMessage(index){const message=this.messagesByDuration[index];this.state.line1=message.l1;this.state.line2=message.l2||"";if(message.time!==null){this.msgTimer=browser.setTimeout(()=>{this.replaceMessage(index+1);},message.time*1000);}}
block(ev){const showBlockedUI=()=>(this.state.blockState=this.BLOCK_STATES.VISIBLY_BLOCKED);const delay=ev.detail?.delay;if(delay){this.state.blockState=this.BLOCK_STATES.BLOCKED;this.showBlockedUITimer=setTimeout(showBlockedUI,delay);}else{showBlockedUI();}
if(ev.detail?.message){this.state.line1=ev.detail.message;}else{this.replaceMessage(0);}}
unblock(){this.state.blockState=this.BLOCK_STATES.UNBLOCKED;clearTimeout(this.showBlockedUITimer);clearTimeout(this.msgTimer);this.state.line1="";this.state.line2="";}}
return __exports;});;

/* /web/static/src/core/ui/ui_service.js */
odoo.define('@web/core/ui/ui_service',['@web/core/utils/hooks','@web/core/registry','@web/core/utils/timing','@web/core/ui/block_ui','@web/core/browser/browser','@web/core/utils/ui','@web/core/hotkeys/hotkey_service','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const{throttleForAnimation}=require("@web/core/utils/timing");const{BlockUI}=require("@web/core/ui/block_ui");const{browser}=require("@web/core/browser/browser");const{getTabableElements}=require("@web/core/utils/ui");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const{EventBus,reactive,useEffect,useRef}=require("@odoo/owl");const SIZES=__exports.SIZES={XS:0,VSM:1,SM:2,MD:3,LG:4,XL:5,XXL:6};function getFirstAndLastTabableElements(el){const tabableEls=getTabableElements(el);return[tabableEls[0],tabableEls[tabableEls.length-1]];}
__exports.useActiveElement=useActiveElement;function useActiveElement(refName){if(!refName){throw new Error("refName not given to useActiveElement");}
const uiService=useService("ui");const ref=useRef(refName);function trapFocus(e){const hotkey=getActiveHotkey(e);if(!["tab","shift+tab"].includes(hotkey)){return;}
const el=e.currentTarget;const[firstTabableEl,lastTabableEl]=getFirstAndLastTabableElements(el);switch(hotkey){case"tab":if(document.activeElement===lastTabableEl){firstTabableEl.focus();e.preventDefault();e.stopPropagation();}
break;case"shift+tab":if(document.activeElement===firstTabableEl){lastTabableEl.focus();e.preventDefault();e.stopPropagation();}
break;}}
useEffect((el)=>{if(el){const[firstTabableEl]=getFirstAndLastTabableElements(el);if(!firstTabableEl){return;}
const oldActiveElement=document.activeElement;uiService.activateElement(el);el.addEventListener("keydown",trapFocus);if(!el.contains(document.activeElement)){firstTabableEl.focus();}
return async()=>{await Promise.resolve();uiService.deactivateElement(el);el.removeEventListener("keydown",trapFocus);if(el.contains(document.activeElement)||document.activeElement===document.body){oldActiveElement.focus();}};}},()=>[ref.el]);}
const MEDIAS_BREAKPOINTS=__exports.MEDIAS_BREAKPOINTS=[{maxWidth:474},{minWidth:475,maxWidth:575},{minWidth:576,maxWidth:767},{minWidth:768,maxWidth:991},{minWidth:992,maxWidth:1199},{minWidth:1200,maxWidth:1533},{minWidth:1534},];__exports.getMediaQueryLists=getMediaQueryLists;function getMediaQueryLists(){return MEDIAS_BREAKPOINTS.map(({minWidth,maxWidth})=>{if(!maxWidth){return window.matchMedia(`(min-width: ${minWidth}px)`);}
if(!minWidth){return window.matchMedia(`(max-width: ${maxWidth}px)`);}
return window.matchMedia(`(min-width: ${minWidth}px) and (max-width: ${maxWidth}px)`);});}
const MEDIAS=getMediaQueryLists();const utils=__exports.utils={getSize(){return MEDIAS.findIndex((media)=>media.matches);},isSmall(ui={}){return(ui.size||utils.getSize())<=SIZES.SM;},};const bus=new EventBus();__exports.listenSizeChange=listenSizeChange;function listenSizeChange(callback){bus.addEventListener("resize",callback);return()=>bus.removeEventListener("resize",callback);}
const uiService=__exports.uiService={start(env){registry.category("main_components").add("BlockUI",{Component:BlockUI,props:{bus}});let blockCount=0;function block(data){blockCount++;if(blockCount===1){bus.trigger("BLOCK",{message:data?.message,delay:data?.delay,});}}
function unblock(){blockCount--;if(blockCount<0){console.warn("Unblock ui was called more times than block, you should only unblock the UI if you have previously blocked it.");blockCount=0;}
if(blockCount===0){bus.trigger("UNBLOCK");}}
let activeElems=[document];function activateElement(el){activeElems.push(el);bus.trigger("active-element-changed",el);}
function deactivateElement(el){activeElems=activeElems.filter((x)=>x!==el);bus.trigger("active-element-changed",ui.activeElement);}
function getActiveElementOf(el){for(const activeElement of[...activeElems].reverse()){if(activeElement.contains(el)){return activeElement;}}}
const ui=reactive({bus,size:utils.getSize(),get activeElement(){return activeElems[activeElems.length-1];},get isBlocked(){return blockCount>0;},isSmall:utils.isSmall(),block,unblock,activateElement,deactivateElement,getActiveElementOf,});const updateSize=()=>{const prevSize=ui.size;ui.size=utils.getSize();if(ui.size!==prevSize){ui.isSmall=utils.isSmall(ui);bus.trigger("resize");}};browser.addEventListener("resize",throttleForAnimation(updateSize));Object.defineProperty(env,"isSmall",{get(){return ui.isSmall;},});return ui;},};registry.category("services").add("ui",uiService);return __exports;});;

/* /web/static/src/core/user.js */
odoo.define('@web/core/user',['@web/core/browser/browser','@web/core/l10n/utils/locales','@web/core/network/rpc','@web/core/utils/cache','@web/session','@web/core/utils/arrays'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{pyToJsLocale}=require("@web/core/l10n/utils/locales");const{rpc}=require("@web/core/network/rpc");const{Cache}=require("@web/core/utils/cache");const{session}=require("@web/session");const{ensureArray}=require("@web/core/utils/arrays");__exports._makeUser=_makeUser;function _makeUser(session){const{home_action_id:homeActionId,is_admin:isAdmin,is_internal_user:isInternalUser,is_system:isSystem,name,partner_id:partnerId,show_effect:showEffect,uid:userId,username:login,user_context:context,user_settings,partner_write_date:writeDate,}=session;const settings=user_settings||{};delete session.home_action_id;delete session.is_admin;delete session.is_internal_user;delete session.is_system;delete session.name;delete session.partner_id;delete session.show_effect;delete session.uid;delete session.username;delete session.user_context;delete session.user_settings;delete session.partner_write_date;const getGroupCacheValue=(group,context)=>{if(!userId){return Promise.resolve(false);}
return rpc("/web/dataset/call_kw/res.users/has_group",{model:"res.users",method:"has_group",args:[userId,group],kwargs:{context},});};const getGroupCacheKey=(group)=>group;const groupCache=new Cache(getGroupCacheValue,getGroupCacheKey);if(isInternalUser!==undefined){groupCache.cache["base.group_user"]=Promise.resolve(isInternalUser);}
if(isSystem!==undefined){groupCache.cache["base.group_system"]=Promise.resolve(isSystem);}
const getAccessRightCacheValue=(model,operation,ids,context)=>{const url=`/web/dataset/call_kw/${model}/has_access`;return rpc(url,{model,method:"has_access",args:[ids,operation],kwargs:{context},});};const getAccessRightCacheKey=(model,operation,ids)=>JSON.stringify([model,operation,ids]);const accessRightCache=new Cache(getAccessRightCacheValue,getAccessRightCacheKey);const lang=pyToJsLocale(context?.lang);const user={name,login,isAdmin,isSystem,isInternalUser,partnerId,homeActionId,showEffect,userId,writeDate,get context(){return Object.assign({},context,{uid:this.userId});},get lang(){return lang;},get tz(){return this.context.tz;},get settings(){return Object.assign({},settings);},updateContext(update){Object.assign(context,update);},hasGroup(group){return groupCache.read(group,this.context);},checkAccessRight(model,operation,ids=[]){return accessRightCache.read(model,operation,ensureArray(ids),this.context);},async setUserSettings(key,value){const model="res.users.settings";const method="set_res_users_settings";const changedSettings=await rpc(`/web/dataset/call_kw/${model}/${method}`,{model,method,args:[[this.settings.id]],kwargs:{new_settings:{[key]:value,},context:this.context,},});Object.assign(settings,changedSettings);},};return user;}
const user=__exports.user=_makeUser(session);const LAST_CONNECTED_USER_KEY="web.lastConnectedUser";const getLastConnectedUsers=__exports.getLastConnectedUsers=()=>{const lastConnectedUsers=browser.localStorage.getItem(LAST_CONNECTED_USER_KEY);return lastConnectedUsers?JSON.parse(lastConnectedUsers):[];};const setLastConnectedUsers=__exports.setLastConnectedUsers=(users)=>{browser.localStorage.setItem(LAST_CONNECTED_USER_KEY,JSON.stringify(users.slice(0,5)));};if(user.login&&user.login!=="__system__"){const users=getLastConnectedUsers();const lastConnectedUsers=[{login:user.login,name:user.name,partnerId:user.partnerId,partnerWriteDate:user.writeDate,userId:user.userId,},...users.filter((u)=>u.userId!==user.userId),];setLastConnectedUsers(lastConnectedUsers);}
return __exports;});;

/* /web/static/src/core/user_switch/user_switch.js */
odoo.define('@web/core/user_switch/user_switch',['@odoo/owl','@web/core/registry','@web/core/user','@web/core/utils/urls'],function(require){'use strict';let __exports={};const{Component,useRef,useState,useEffect}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{getLastConnectedUsers,setLastConnectedUsers}=require("@web/core/user");const{imageUrl}=require("@web/core/utils/urls");const UserSwitch=__exports.UserSwitch=class UserSwitch extends Component{static template="web.login_user_switch";static props={};setup(){const users=getLastConnectedUsers();this.root=useRef("root");this.state=useState({users,displayUserChoice:users.length>1,});this.form=document.querySelector("form.oe_login_form");this.form.classList.toggle("d-none",users.length>1);this.form.querySelector(":placeholder-shown")?.focus();useEffect((el)=>el?.querySelector("button.list-group-item-action")?.focus(),()=>[this.root.el]);}
toggleFormDisplay(){this.state.displayUserChoice=!this.state.displayUserChoice&&this.state.users.length;this.form.classList.toggle("d-none",this.state.displayUserChoice);this.form.querySelector(":placeholder-shown")?.focus();}
getAvatarUrl({partnerId,partnerWriteDate:unique}){return imageUrl("res.partner",partnerId,"avatar_128",{unique});}
remove(deletedUser){this.state.users=this.state.users.filter((user)=>user!==deletedUser);setLastConnectedUsers(this.state.users);if(!this.state.users.length){this.fillForm();}}
fillForm(login=""){this.form.querySelector("input#login").value=login;this.form.querySelector("input#password").value="";this.toggleFormDisplay();}}
registry.category("public_components").add("web.user_switch",UserSwitch);return __exports;});;

/* /web/static/src/core/utils/arrays.js */
odoo.define('@web/core/utils/arrays',['@web/core/utils/objects'],function(require){'use strict';let __exports={};const{shallowEqual:_shallowEqual}=require("@web/core/utils/objects");function _cartesian(...args){if(args.length===0){return[undefined];}
const firstArray=args.shift().map((elem)=>[elem]);if(args.length===0){return firstArray;}
const result=[];const productOfOtherArrays=_cartesian(...args);for(const array of firstArray){for(const tuple of productOfOtherArrays){result.push([...array,...tuple]);}}
return result;}
function _getExtractorFrom(criterion){if(criterion){switch(typeof criterion){case"string":return(element)=>element[criterion];case"function":return criterion;default:throw new Error(`Expected criterion of type 'string' or 'function' and got '${typeof criterion}'`);}}else{return(element)=>element;}}
__exports.ensureArray=ensureArray;function ensureArray(value){return isIterable(value)?[...value]:[value];}
__exports.intersection=intersection;function intersection(iter1,iter2){const set2=new Set(iter2);return unique(iter1).filter((v)=>set2.has(v));}
__exports.isIterable=isIterable;function isIterable(value){return Boolean(value&&typeof value==="object"&&value[Symbol.iterator]);}
__exports.groupBy=groupBy;function groupBy(iterable,criterion){const extract=_getExtractorFrom(criterion);const groups={};for(const element of iterable){const group=String(extract(element));if(!(group in groups)){groups[group]=[];}
groups[group].push(element);}
return groups;}
__exports.sortBy=sortBy;function sortBy(iterable,criterion,order="asc"){const extract=_getExtractorFrom(criterion);return[...iterable].sort((elA,elB)=>{const a=extract(elA);const b=extract(elB);let result;if(isNaN(a)&&isNaN(b)){result=a>b?1:a<b?-1:0;}else{result=a-b;}
return order==="asc"?result:-result;});}
__exports.symmetricalDifference=symmetricalDifference;function symmetricalDifference(iter1,iter2){const array1=[...iter1];const array2=[...iter2];return[...array1.filter((value)=>!array2.includes(value)),...array2.filter((value)=>!array1.includes(value)),];}
__exports.cartesian=cartesian;function cartesian(...args){if(args.length===0){return[undefined];}else if(args.length===1){return args[0];}else{return _cartesian(...args);}}
const shallowEqual=__exports.shallowEqual=_shallowEqual;__exports.sections=sections;function sections(iterable){const array=[...iterable];const sections=[];for(let i=0;i<array.length+1;i++){sections.push(array.slice(0,i));}
return sections;}
__exports.unique=unique;function unique(iterable){return[...new Set(iterable)];}
__exports.zip=zip;function zip(iter1,iter2,fill=false){const array1=[...iter1];const array2=[...iter2];const result=[];const getLength=fill?Math.max:Math.min;for(let i=0;i<getLength(array1.length,array2.length);i++){result.push([array1[i],array2[i]]);}
return result;}
__exports.zipWith=zipWith;function zipWith(iter1,iter2,mapFn){return zip(iter1,iter2).map(([e1,e2])=>mapFn(e1,e2));}
__exports.slidingWindow=slidingWindow;function slidingWindow(arr,width){const res=[];for(let i=0;i<=arr.length-width;i++){res.push(arr.slice(i,i+width));}
return res;}
__exports.rotate=rotate;function rotate(i,arr,inc=1){return(arr.length+i+inc)%arr.length;}
return __exports;});;

/* /web/static/src/core/utils/autoresize.js */
odoo.define('@web/core/utils/autoresize',['@odoo/owl','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{useEffect}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");__exports.useAutoresize=useAutoresize;function useAutoresize(ref,options={}){let wasProgrammaticallyResized=false;let resize=null;useEffect((el)=>{if(el){resize=(programmaticResize=false)=>{wasProgrammaticallyResized=programmaticResize;if(el instanceof HTMLInputElement){resizeInput(el,options);}else{resizeTextArea(el,options);}
options.onResize?.(el,options);};el.addEventListener("input",()=>resize(true));const resizeObserver=new ResizeObserver(()=>{if(wasProgrammaticallyResized){wasProgrammaticallyResized=false;return;}
resize();});resizeObserver.observe(el);return()=>{el.removeEventListener("input",resize);resizeObserver.unobserve(el);resizeObserver.disconnect();resize=null;};}},()=>[ref.el]);useEffect(()=>{if(resize){resize(true);}});}
function resizeInput(input){input.style.width="100%";const maxWidth=input.clientWidth;const isSafari16=/Version\/16.+Safari/i.test(browser.navigator.userAgent);input.style.width="10px";if(input.value===""&&input.placeholder!==""){input.style.width="auto";return;}
if(input.scrollWidth+5+(isSafari16?8:0)>maxWidth){input.style.width="100%";return;}
input.style.width=input.scrollWidth+5+(isSafari16?8:0)+"px";}
__exports.resizeTextArea=resizeTextArea;function resizeTextArea(textarea,options={}){const minimumHeight=options.minimumHeight||0;let heightOffset=0;const style=window.getComputedStyle(textarea);if(style.boxSizing==="border-box"){const paddingHeight=parseFloat(style.paddingTop)+parseFloat(style.paddingBottom);const borderHeight=parseFloat(style.borderTopWidth)+parseFloat(style.borderBottomWidth);heightOffset=borderHeight+paddingHeight;}
const previousStyle={borderTopWidth:style.borderTopWidth,borderBottomWidth:style.borderBottomWidth,padding:style.padding,};Object.assign(textarea.style,{height:"auto",borderTopWidth:0,borderBottomWidth:0,paddingTop:0,paddingRight:style.paddingRight,paddingBottom:0,paddingLeft:style.paddingLeft,});textarea.style.height="auto";const height=Math.max(minimumHeight,textarea.scrollHeight+heightOffset);Object.assign(textarea.style,previousStyle,{height:`${height}px`});textarea.parentElement.style.height=`${height}px`;}
return __exports;});;

/* /web/static/src/core/utils/binary.js */
odoo.define('@web/core/utils/binary',['@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");__exports.isBinarySize=isBinarySize;function isBinarySize(value){return/^\d+(\.\d*)? [^0-9]+$/.test(value);}
__exports.toBase64Length=toBase64Length;function toBase64Length(maxBytes){return Math.ceil(maxBytes*4/3);}
__exports.humanSize=humanSize;function humanSize(size){const units=_t("Bytes|Kb|Mb|Gb|Tb|Pb|Eb|Zb|Yb").split("|");let i=0;while(size>=1024){size/=1024;++i;}
return`${size.toFixed(2)} ${units[i].trim()}`;}
return __exports;});;

/* /web/static/src/core/utils/cache.js */
odoo.define('@web/core/utils/cache',[],function(require){'use strict';let __exports={};const Cache=__exports.Cache=class Cache{constructor(getValue,getKey){this.cache={};this.getKey=getKey;this.getValue=getValue;}
_getCacheAndKey(...path){let cache=this.cache;let key;if(this.getKey){key=this.getKey(...path);}else{for(let i=0;i<path.length-1;i++){cache=cache[path[i]]=cache[path[i]]||{};}
key=path[path.length-1];}
return{cache,key};}
clear(...path){const{cache,key}=this._getCacheAndKey(...path);delete cache[key];}
invalidate(){this.cache={};}
read(...path){const{cache,key}=this._getCacheAndKey(...path);if(!(key in cache)){cache[key]=this.getValue(...path);}
return cache[key];}}
return __exports;});;

/* /web/static/src/core/utils/classname.js */
odoo.define('@web/core/utils/classname',[],function(require){'use strict';let __exports={};__exports.addClassesToElement=addClassesToElement;function addClassesToElement(el,...classes){for(const classDefinition of classes){const classObj=toClassObj(classDefinition);for(const className in classObj){if(classObj[className]){el.classList.add(className.trim());}}}}
__exports.mergeClasses=mergeClasses;function mergeClasses(...classes){const classObj={};for(const classDefinition of classes){Object.assign(classObj,toClassObj(classDefinition));}
return classObj;}
function toClassObj(classDefinition){if(!classDefinition){return{};}else if(typeof classDefinition==="object"){return classDefinition;}else if(typeof classDefinition==="string"){const classObj={};classDefinition.trim().split(/\s+/).forEach((s)=>{classObj[s]=true;});return classObj;}else{console.warn(`toClassObj only supports strings, objects and undefined className (got ${typeof classProp})`);return{};}}
return __exports;});;

/* /web/static/src/core/utils/colors.js */
odoo.define('@web/core/utils/colors',[],function(require){'use strict';let __exports={};__exports.convertRgbToHsl=convertRgbToHsl;function convertRgbToHsl(r,g,b){if(typeof(r)!=='number'||isNaN(r)||r<0||r>255||typeof(g)!=='number'||isNaN(g)||g<0||g>255||typeof(b)!=='number'||isNaN(b)||b<0||b>255){return false;}
var red=r/255;var green=g/255;var blue=b/255;var maxColor=Math.max(red,green,blue);var minColor=Math.min(red,green,blue);var delta=maxColor-minColor;var hue=0;var saturation=0;var lightness=(maxColor+minColor)/2;if(delta){if(maxColor===red){hue=(green-blue)/delta;}
if(maxColor===green){hue=2+(blue-red)/delta;}
if(maxColor===blue){hue=4+(red-green)/delta;}
if(maxColor){saturation=delta/(1-Math.abs(2*lightness-1));}}
hue=60*hue;return{hue:hue<0?hue+360:hue,saturation:saturation*100,lightness:lightness*100,};};__exports.convertHslToRgb=convertHslToRgb;function convertHslToRgb(h,s,l){if(typeof(h)!=='number'||isNaN(h)||h<0||h>360||typeof(s)!=='number'||isNaN(s)||s<0||s>100||typeof(l)!=='number'||isNaN(l)||l<0||l>100){return false;}
var huePrime=h/60;var saturation=s/100;var lightness=l/100;var chroma=saturation*(1-Math.abs(2*lightness-1));var secondComponent=chroma*(1-Math.abs(huePrime%2-1));var lightnessAdjustment=lightness-chroma/2;var precision=255;chroma=Math.round((chroma+lightnessAdjustment)*precision);secondComponent=Math.round((secondComponent+lightnessAdjustment)*precision);lightnessAdjustment=Math.round((lightnessAdjustment)*precision);if(huePrime>=0&&huePrime<1){return{red:chroma,green:secondComponent,blue:lightnessAdjustment,};}
if(huePrime>=1&&huePrime<2){return{red:secondComponent,green:chroma,blue:lightnessAdjustment,};}
if(huePrime>=2&&huePrime<3){return{red:lightnessAdjustment,green:chroma,blue:secondComponent,};}
if(huePrime>=3&&huePrime<4){return{red:lightnessAdjustment,green:secondComponent,blue:chroma,};}
if(huePrime>=4&&huePrime<5){return{red:secondComponent,green:lightnessAdjustment,blue:chroma,};}
if(huePrime>=5&&huePrime<=6){return{red:chroma,green:lightnessAdjustment,blue:secondComponent,};}
return false;};__exports.convertRgbaToCSSColor=convertRgbaToCSSColor;function convertRgbaToCSSColor(r,g,b,a){if(typeof(r)!=='number'||isNaN(r)||r<0||r>255||typeof(g)!=='number'||isNaN(g)||g<0||g>255||typeof(b)!=='number'||isNaN(b)||b<0||b>255){return false;}
if(typeof(a)!=='number'||isNaN(a)||a<0||Math.abs(a-100)<Number.EPSILON){const rr=r<16?'0'+r.toString(16):r.toString(16);const gg=g<16?'0'+g.toString(16):g.toString(16);const bb=b<16?'0'+b.toString(16):b.toString(16);return(`#${rr}${gg}${bb}`).toUpperCase();}
return`rgba(${r}, ${g}, ${b}, ${parseFloat((a / 100.0).toFixed(3))})`;};__exports.convertCSSColorToRgba=convertCSSColorToRgba;function convertCSSColorToRgba(cssColor){const rgba=cssColor.match(/^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/);if(rgba){if(rgba[4]===undefined){rgba[4]=1;}
return{red:parseInt(rgba[1]),green:parseInt(rgba[2]),blue:parseInt(rgba[3]),opacity:Math.round(parseFloat(rgba[4])*100),};}
if(/^#([0-9A-F]{6}|[0-9A-F]{8})$/i.test(cssColor)){return{red:parseInt(cssColor.substr(1,2),16),green:parseInt(cssColor.substr(3,2),16),blue:parseInt(cssColor.substr(5,2),16),opacity:(cssColor.length===9?(parseInt(cssColor.substr(7,2),16)/255):1)*100,};}
if(/color\(.+\)/.test(cssColor)){const canvasEl=document.createElement("canvas");canvasEl.height=1;canvasEl.width=1;const ctx=canvasEl.getContext("2d");ctx.fillStyle=cssColor;ctx.fillRect(0,0,1,1);const data=ctx.getImageData(0,0,1,1).data;return{red:data[0],green:data[1],blue:data[2],opacity:data[3]/2.55,};}
return false;};__exports.normalizeCSSColor=normalizeCSSColor;function normalizeCSSColor(cssColor){const rgba=convertCSSColorToRgba(cssColor);if(!rgba){return cssColor;}
return convertRgbaToCSSColor(rgba.red,rgba.green,rgba.blue,rgba.opacity);};__exports.isCSSColor=isCSSColor;function isCSSColor(cssColor){return convertCSSColorToRgba(cssColor)!==false;};__exports.mixCssColors=mixCssColors;function mixCssColors(cssColor1,cssColor2,weight){const rgba1=convertCSSColorToRgba(cssColor1);const rgba2=convertCSSColorToRgba(cssColor2);const rgb1=[rgba1.red,rgba1.green,rgba1.blue];const rgb2=[rgba2.red,rgba2.green,rgba2.blue];const[r,g,b]=rgb1.map((_,idx)=>Math.round(rgb2[idx]+(rgb1[idx]-rgb2[idx])*weight));return convertRgbaToCSSColor(r,g,b);};return __exports;});;

/* /web/static/src/core/utils/components.js */
odoo.define('@web/core/utils/components',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,onError,xml}=require("@odoo/owl");const ErrorHandler=__exports.ErrorHandler=class ErrorHandler extends Component{static template=xml`<t t-slot="default" />`;static props=["onError","slots"];setup(){onError((error)=>{this.props.onError(error);});}}
return __exports;});;

/* /web/static/src/core/utils/concurrency.js */
odoo.define('@web/core/utils/concurrency',[],function(require){'use strict';let __exports={};__exports.delay=delay;function delay(wait){return new Promise(function(resolve){setTimeout(resolve,wait);});}
const KeepLast=__exports.KeepLast=class KeepLast{constructor(){this._id=0;}
add(promise){this._id++;const currentId=this._id;return new Promise((resolve,reject)=>{promise.then((value)=>{if(this._id===currentId){resolve(value);}}).catch((reason)=>{if(this._id===currentId){reject(reason);}});});}}
const Mutex=__exports.Mutex=class Mutex{constructor(){this._lock=Promise.resolve();this._queueSize=0;this._unlockedProm=undefined;this._unlock=undefined;}
async exec(action){this._queueSize++;if(!this._unlockedProm){this._unlockedProm=new Promise((resolve)=>{this._unlock=()=>{resolve();this._unlockedProm=undefined;};});}
const always=()=>{return Promise.resolve(action()).finally(()=>{if(--this._queueSize===0){this._unlock();}});};this._lock=this._lock.then(always,always);return this._lock;}
getUnlockedDef(){return this._unlockedProm||Promise.resolve();}}
const Race=__exports.Race=class Race{constructor(){this.currentProm=null;this.currentPromResolver=null;this.currentPromRejecter=null;}
add(promise){if(!this.currentProm){this.currentProm=new Promise((resolve,reject)=>{this.currentPromResolver=(value)=>{this.currentProm=null;this.currentPromResolver=null;this.currentPromRejecter=null;resolve(value);};this.currentPromRejecter=(error)=>{this.currentProm=null;this.currentPromResolver=null;this.currentPromRejecter=null;reject(error);};});}
promise.then(this.currentPromResolver).catch(this.currentPromRejecter);return this.currentProm;}
getCurrentProm(){return this.currentProm;}}
const Deferred=__exports.Deferred=class Deferred extends Promise{constructor(){let resolve;let reject;const prom=new Promise((res,rej)=>{resolve=res;reject=rej;});return Object.assign(prom,{resolve,reject});}}
return __exports;});;

/* /web/static/src/core/utils/draggable.js */
odoo.define('@web/core/utils/draggable',['@web/core/utils/draggable_hook_builder_owl','@web/core/utils/objects'],function(require){'use strict';let __exports={};const{makeDraggableHook}=require("@web/core/utils/draggable_hook_builder_owl");const{pick}=require("@web/core/utils/objects");const useDraggable=__exports.useDraggable=makeDraggableHook({name:"useDraggable",onWillStartDrag:({ctx})=>pick(ctx.current,"element"),onDragStart:({ctx})=>pick(ctx.current,"element"),onDrag:({ctx})=>pick(ctx.current,"element"),onDragEnd:({ctx})=>pick(ctx.current,"element"),onDrop:({ctx})=>pick(ctx.current,"element"),});return __exports;});;

/* /web/static/src/core/utils/draggable_hook_builder.js */
odoo.define('@web/core/utils/draggable_hook_builder',['@web/core/utils/numbers','@web/core/utils/objects','@web/core/utils/scrolling','@web/core/utils/timing','@web/core/browser/browser','@web/core/browser/feature_detection'],function(require){'use strict';let __exports={};const{clamp}=require("@web/core/utils/numbers");const{omit}=require("@web/core/utils/objects");const{closestScrollableX,closestScrollableY}=require("@web/core/utils/scrolling");const{setRecurringAnimationFrame}=require("@web/core/utils/timing");const{browser}=require("@web/core/browser/browser");const{hasTouch,isBrowserFirefox,isIOS}=require("@web/core/browser/feature_detection");const DRAGGABLE_CLASS="o_draggable";const DRAGGED_CLASS=__exports.DRAGGED_CLASS="o_dragged";const DEFAULT_ACCEPTED_PARAMS={enable:[Boolean,Function],preventDrag:[Function],ref:[Object],elements:[String],handle:[String,Function],ignore:[String,Function],cursor:[String],edgeScrolling:[Object,Function],delay:[Number],tolerance:[Number],touchDelay:[Number],iframeWindow:[Object,Function],};const DEFAULT_DEFAULT_PARAMS={elements:`.${DRAGGABLE_CLASS}`,enable:true,preventDrag:()=>false,edgeScrolling:{speed:10,threshold:30,},delay:0,tolerance:10,touchDelay:300,};const LEFT_CLICK=0;const MANDATORY_PARAMS=["ref"];const WHITE_LISTED_KEYS=["Alt","Control","Meta","Shift"];const elCache={};function camelToKebab(str){return str.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase();}
function getReturnValue(valueOrFn){if(typeof valueOrFn==="function"){return valueOrFn();}
return valueOrFn;}
function getScrollParents(el){return[closestScrollableX(el),closestScrollableY(el)];}
function makeCleanupManager(defaultCleanupFn){const add=(cleanupFn)=>typeof cleanupFn==="function"&&cleanups.push(cleanupFn);const cleanup=()=>{while(cleanups.length){cleanups.pop()();}
add(defaultCleanupFn);};const cleanups=[];add(defaultCleanupFn);return{add,cleanup};}
function makeDOMHelpers(cleanup){const addClass=(el,...classNames)=>{if(!el||!classNames.length){return;}
cleanup.add(()=>el.classList.remove(...classNames));el.classList.add(...classNames);};const addListener=(el,event,callback,options={})=>{if(!el||!event||!callback){return;}
const{noAddedStyle}=options;delete options.noAddedStyle;el.addEventListener(event,callback,options);if(!noAddedStyle&&/mouse|pointer|touch/.test(event)){addStyle(el,{pointerEvents:"auto"});}
cleanup.add(()=>el.removeEventListener(event,callback,options));};const addStyle=(el,style)=>{if(!el||!style||!Object.keys(style).length){return;}
cleanup.add(saveAttribute(el,"style"));for(const key in style){const[value,priority]=String(style[key]).split(/\s*!\s*/);el.style.setProperty(camelToKebab(key),value,priority);}};const getRect=(el,options={})=>{if(!el){return{};}
const rect=el.getBoundingClientRect();if(options.adjust){const style=getComputedStyle(el);const[pl,pr,pt,pb]=["padding-left","padding-right","padding-top","padding-bottom",].map((prop)=>pixelValueToNumber(style.getPropertyValue(prop)));rect.x+=pl;rect.y+=pt;rect.width-=pl+pr;rect.height-=pt+pb;}
return rect;};const removeAttribute=(el,attribute)=>{if(!el||!attribute){return;}
cleanup.add(saveAttribute(el,attribute));el.removeAttribute(attribute);};const removeClass=(el,...classNames)=>{if(!el||!classNames.length){return;}
cleanup.add(saveAttribute(el,"class"));el.classList.remove(...classNames);};const removeStyle=(el,...properties)=>{if(!el||!properties.length){return;}
cleanup.add(saveAttribute(el,"style"));for(const key of properties){el.style.removeProperty(camelToKebab(key));}};const setAttribute=(el,attribute,value)=>{if(!el||!attribute){return;}
cleanup.add(saveAttribute(el,attribute));el.setAttribute(attribute,String(value));};return{addClass,addListener,addStyle,getRect,removeAttribute,removeClass,removeStyle,setAttribute,};}
function pixelValueToNumber(val){return Number(val.endsWith("px")?val.slice(0,-2):val);}
function safePrevent(ev,{stop}={}){if(ev.cancelable){ev.preventDefault();if(stop){ev.stopPropagation();}}}
function saveAttribute(el,attribute){const restoreAttribute=()=>{cache.delete(el);if(hasAttribute){el.setAttribute(attribute,originalValue);}else{el.removeAttribute(attribute);}};if(!(attribute in elCache)){elCache[attribute]=new Set();}
const cache=elCache[attribute];if(cache.has(el)){return;}
cache.add(el);const hasAttribute=el.hasAttribute(attribute);const originalValue=el.getAttribute(attribute);return restoreAttribute;}
function toFunction(value){return typeof value==="function"?value:()=>value;}
__exports.makeDraggableHook=makeDraggableHook;function makeDraggableHook(hookParams){hookParams=getReturnValue(hookParams);const hookName=hookParams.name||"useAnonymousDraggable";const{setupHooks}=hookParams;const allAcceptedParams={...DEFAULT_ACCEPTED_PARAMS,...hookParams.acceptedParams};const defaultParams={...DEFAULT_DEFAULT_PARAMS,...hookParams.defaultParams};const computeParams=(params)=>{const computedParams={enable:()=>true};for(const prop in allAcceptedParams){if(prop in params){if(prop==="enable"){computedParams[prop]=toFunction(params[prop]);}else if(allAcceptedParams[prop].length===1&&allAcceptedParams[prop][0]===Function){computedParams[prop]=params[prop];}else{computedParams[prop]=getReturnValue(params[prop]);}}}
return Object.entries(computedParams);};const makeError=(reason)=>new Error(`Error in hook ${hookName}: ${reason}.`);let preventClick=false;return{[hookName](params){const callBuildHandler=(hookHandlerName,arg)=>{if(typeof hookParams[hookHandlerName]!=="function"){return;}
const returnValue=hookParams[hookHandlerName]({ctx,...helpers,...arg});if(returnValue){callHandler(hookHandlerName,returnValue);}};const callHandler=(handlerName,arg)=>{if(typeof params[handlerName]!=="function"){return;}
try{params[handlerName]({...dom,...ctx.pointer,...arg});}catch(err){dragEnd(null,true);throw err;}};const canStartDrag=()=>{const{pointer,current:{initialPosition},}=ctx;return(!ctx.tolerance||Math.hypot(pointer.x-initialPosition.x,pointer.y-initialPosition.y)>=ctx.tolerance);};const dragStart=()=>{state.dragging=true;state.willDrag=false;const isDocumentScrollingElement=ctx.current.container===ctx.current.container.ownerDocument.scrollingElement;[ctx.current.scrollParentX,ctx.current.scrollParentY]=isDocumentScrollingElement?[ctx.current.container,ctx.current.container]:getScrollParents(ctx.current.container);updateRects();const{x,y,width,height}=ctx.current.elementRect;ctx.current.offset={x:ctx.current.initialPosition.x-x,y:ctx.current.initialPosition.y-y,};if(ctx.followCursor){dom.addStyle(ctx.current.element,{width:`${width}px`,height:`${height}px`,position:"fixed !important",});updateElementPosition();}
dom.addClass(document.body,"pe-none","user-select-none");if(params.iframeWindow){for(const iframe of document.getElementsByTagName("iframe")){if(iframe.contentWindow===params.iframeWindow){dom.addClass(iframe,"pe-none","user-select-none");}}}
if(ctx.cursor){dom.addStyle(document.body,{cursor:ctx.cursor});}
if((ctx.current.scrollParentX||ctx.current.scrollParentY)&&ctx.edgeScrolling.enabled){const cleanupFn=setRecurringAnimationFrame(handleEdgeScrolling);cleanup.add(cleanupFn);}
dom.addClass(ctx.current.element,DRAGGED_CLASS);callBuildHandler("onDragStart");};const dragEnd=(target,inErrorState)=>{if(state.dragging){preventClick=true;if(!inErrorState){if(target){callBuildHandler("onDrop",{target});}
callBuildHandler("onDragEnd");}}
cleanup.cleanup();};const handleEdgeScrolling=(deltaTime)=>{updateRects();const{x:pointerX,y:pointerY}=ctx.pointer;const xRect=ctx.current.scrollParentXRect;const yRect=ctx.current.scrollParentYRect;const scrollParentYEl=ctx.current.scrollParentY;if(scrollParentYEl===ctx.current.container.ownerDocument.scrollingElement){yRect.y+=scrollParentYEl.scrollTop;}
const{direction,speed,threshold}=ctx.edgeScrolling;const correctedSpeed=(speed/16)*deltaTime;const diff={};ctx.current.scrollingEdge=null;if(xRect){const maxWidth=xRect.x+xRect.width;if(pointerX-xRect.x<threshold){diff.x=[pointerX-xRect.x,-1];ctx.current.scrollingEdge="left";}else if(maxWidth-pointerX<threshold){diff.x=[maxWidth-pointerX,1];ctx.current.scrollingEdge="right";}}
if(yRect){const maxHeight=yRect.y+yRect.height;if(pointerY-yRect.y<threshold){diff.y=[pointerY-yRect.y,-1];ctx.current.scrollingEdge="top";}else if(maxHeight-pointerY<threshold){diff.y=[maxHeight-pointerY,1];ctx.current.scrollingEdge="bottom";}}
const diffToScroll=([delta,sign])=>(1-Math.max(delta,0)/threshold)*correctedSpeed*sign;if((!direction||direction==="vertical")&&diff.y){ctx.current.scrollParentY.scrollBy({top:diffToScroll(diff.y)});}
if((!direction||direction==="horizontal")&&diff.x){ctx.current.scrollParentX.scrollBy({left:diffToScroll(diff.x)});}
callBuildHandler("onDrag");};const onClick=(ev)=>{if(preventClick){safePrevent(ev,{stop:true});}};const onKeyDown=(ev)=>{if(!state.dragging||!ctx.enable()){return;}
if(!WHITE_LISTED_KEYS.includes(ev.key)){safePrevent(ev,{stop:true});dragEnd(null);}};const onPointerCancel=()=>{dragEnd(null);};const onPointerDown=(ev)=>{preventClick=false;updatePointerPosition(ev);const initiationDelay=ev.pointerType==="touch"?ctx.touchDelay:ctx.delay;dragEnd(null);const fullSelectorEl=ev.target.closest(ctx.fullSelector);if(ev.button!==LEFT_CLICK||!ctx.enable()||!fullSelectorEl||(ctx.ignoreSelector&&ev.target.closest(ctx.ignoreSelector))||ctx.preventDrag(fullSelectorEl)){return;}
safePrevent(ev);let activeElement=document.activeElement;while(activeElement?.nodeName==="IFRAME"){activeElement=activeElement.contentDocument?.activeElement;}
if(activeElement&&!activeElement.contains(ev.target)){activeElement.blur();}
const{currentTarget,pointerId,target}=ev;ctx.current.initialPosition={...ctx.pointer};if(target.hasPointerCapture(pointerId)){target.releasePointerCapture(pointerId);}
if(initiationDelay){if(hasTouch()){if(ev.pointerType==="touch"){dom.addClass(target.closest(ctx.elementSelector),"o_touch_bounce");}
if(isBrowserFirefox()){const links=[...currentTarget.querySelectorAll("[href]")];if(currentTarget.hasAttribute("href")){links.unshift(currentTarget);}
for(const link of links){dom.removeAttribute(link,"href");}}
if(isIOS()){for(const image of currentTarget.getElementsByTagName("img")){dom.setAttribute(image,"draggable",false);}}}
ctx.current.timeout=browser.setTimeout(()=>{ctx.current.initialPosition={...ctx.pointer};willStartDrag(target);const{x:px,y:py}=ctx.pointer;const{x,y,width,height}=dom.getRect(ctx.current.element);if(px<x||x+width<px||py<y||y+height<py){dragEnd(null);}},initiationDelay);cleanup.add(()=>browser.clearTimeout(ctx.current.timeout));}else{willStartDrag(target);}};const onPointerMove=(ev)=>{updatePointerPosition(ev);if(!ctx.current.element||!ctx.enable()){return;}
safePrevent(ev);if(!state.dragging){if(!canStartDrag()){return;}
dragStart();}
if(ctx.followCursor){updateElementPosition();}
callBuildHandler("onDrag");};const onPointerUp=(ev)=>{updatePointerPosition(ev);dragEnd(ev.target);};const updateElementPosition=()=>{const{containerRect,element,elementRect,offset}=ctx.current;const{width:ew,height:eh}=elementRect;const{x:cx,y:cy,width:cw,height:ch}=containerRect;dom.addStyle(element,{left:`${clamp(ctx.pointer.x - offset.x, cx, cx + cw - ew)}px`,top:`${clamp(ctx.pointer.y - offset.y, cy, cy + ch - eh)}px`,});};const updatePointerPosition=(ev)=>{ctx.pointer.x=ev.clientX;ctx.pointer.y=ev.clientY;};const updateRects=()=>{const{current}=ctx;const{container,element,scrollParentX,scrollParentY}=current;current.containerRect=dom.getRect(container,{adjust:true});let iframeOffsetX=0;let iframeOffsetY=0;const iframeEl=container.ownerDocument.defaultView.frameElement;if(iframeEl&&!iframeEl.contentDocument?.contains(element)){const{x,y}=dom.getRect(iframeEl);iframeOffsetX=x;iframeOffsetY=y;current.containerRect.x+=iframeOffsetX;current.containerRect.y+=iframeOffsetY;}
current.containerRect.width=container.scrollWidth;current.containerRect.height=container.scrollHeight;current.scrollParentXRect=null;current.scrollParentYRect=null;if(ctx.edgeScrolling.enabled){if(scrollParentX){current.scrollParentXRect=dom.getRect(scrollParentX,{adjust:true});current.scrollParentXRect.x+=iframeOffsetX;current.scrollParentXRect.y+=iframeOffsetY;const right=Math.min(current.containerRect.left+container.scrollWidth,current.scrollParentXRect.right);current.containerRect.x=Math.max(current.containerRect.x,current.scrollParentXRect.x);current.containerRect.width=right-current.containerRect.x;}
if(scrollParentY){current.scrollParentYRect=dom.getRect(scrollParentY,{adjust:true});current.scrollParentYRect.x+=iframeOffsetX;current.scrollParentYRect.y+=iframeOffsetY;const bottom=Math.min(current.containerRect.top+container.scrollHeight,current.scrollParentYRect.bottom);current.containerRect.y=Math.max(current.containerRect.y,current.scrollParentYRect.y);current.containerRect.height=bottom-current.containerRect.y;}}
ctx.current.elementRect=dom.getRect(element);};const willStartDrag=(target)=>{ctx.current.element=target.closest(ctx.elementSelector);ctx.current.container=ctx.ref.el;cleanup.add(()=>(ctx.current={}));state.willDrag=true;callBuildHandler("onWillStartDrag");if(hasTouch()){dom.addListener(window,"touchmove",safePrevent,{passive:false,noAddedStyle:true,});if(params.iframeWindow){dom.addListener(params.iframeWindow,"touchmove",safePrevent,{passive:false,noAddedStyle:true,});}}};const cleanup=makeCleanupManager(()=>(state.dragging=false));const effectCleanup=makeCleanupManager();const dom=makeDOMHelpers(cleanup);const helpers={...dom,addCleanup:cleanup.add,addEffectCleanup:effectCleanup.add,callHandler,};const state=setupHooks.wrapState({dragging:false});for(const prop in allAcceptedParams){const type=typeof params[prop];const acceptedTypes=allAcceptedParams[prop].map((t)=>t.name.toLowerCase());if(params[prop]){if(!acceptedTypes.includes(type)){throw makeError(`invalid type for property "${prop}" in parameters: expected { ${acceptedTypes.join(
                                ", "
                            )} } and got ${type}`);}}else if(MANDATORY_PARAMS.includes(prop)&&!defaultParams[prop]){throw makeError(`missing required property "${prop}" in parameters`);}}
const ctx={enable:()=>false,preventDrag:()=>false,ref:params.ref,ignoreSelector:null,fullSelector:null,followCursor:true,cursor:null,pointer:{x:0,y:0},edgeScrolling:{enabled:true},get dragging(){return state.dragging;},get willDrag(){return state.willDrag;},current:{},};setupHooks.setup((...deps)=>{const params=Object.fromEntries(deps);const actualParams={...defaultParams,...omit(params,"edgeScrolling")};if(params.edgeScrolling){actualParams.edgeScrolling={...actualParams.edgeScrolling,...params.edgeScrolling,};}
if(!ctx.ref.el){return;}
ctx.enable=actualParams.enable;if(actualParams.preventDrag){ctx.preventDrag=actualParams.preventDrag;}
ctx.elementSelector=actualParams.elements;if(!ctx.elementSelector){throw makeError(`no value found by "elements" selector: ${ctx.elementSelector}`);}
const allSelectors=[ctx.elementSelector];ctx.cursor=actualParams.cursor||null;if(actualParams.handle){allSelectors.push(actualParams.handle);}
if(actualParams.ignore){ctx.ignoreSelector=actualParams.ignore;}
ctx.fullSelector=allSelectors.join(" ");Object.assign(ctx.edgeScrolling,actualParams.edgeScrolling);ctx.delay=actualParams.delay;ctx.touchDelay=actualParams.delay||actualParams.touchDelay;ctx.tolerance=actualParams.tolerance;callBuildHandler("onComputeParams",{params:actualParams});return effectCleanup.cleanup;},()=>computeParams(params));const useMouseEvents=isBrowserFirefox()&&!hasTouch()&&params.iframeWindow;setupHooks.setup((el)=>{if(el){const{add,cleanup}=makeCleanupManager();const{addListener}=makeDOMHelpers({add});const event=useMouseEvents?"mousedown":"pointerdown";addListener(el,event,onPointerDown,{noAddedStyle:true});addListener(el,"click",onClick);if(hasTouch()){addListener(el,"contextmenu",safePrevent);addListener(el,"touchstart",()=>{},{passive:false,noAddedStyle:true,});}
return cleanup;}},()=>[ctx.ref.el]);const addWindowListener=(type,listener,options)=>{if(params.iframeWindow){setupHooks.addListener(params.iframeWindow,type,listener,options);}
setupHooks.addListener(window,type,listener,options);};const throttledOnPointerMove=setupHooks.throttle(onPointerMove);addWindowListener(useMouseEvents?"mousemove":"pointermove",throttledOnPointerMove,{passive:false});addWindowListener(useMouseEvents?"mouseup":"pointerup",onPointerUp);addWindowListener("pointercancel",onPointerCancel);addWindowListener("keydown",onKeyDown,{capture:true});setupHooks.teardown(()=>dragEnd(null));return state;},}[hookName];}
return __exports;});;

/* /web/static/src/core/utils/draggable_hook_builder_owl.js */
odoo.define('@web/core/utils/draggable_hook_builder_owl',['@odoo/owl','@web/core/utils/timing','@web/core/utils/draggable_hook_builder'],function(require){'use strict';let __exports={};const{onWillUnmount,reactive,useEffect,useExternalListener}=require("@odoo/owl");const{useThrottleForAnimation}=require("@web/core/utils/timing");const{makeDraggableHook:nativeMakeDraggableHook}=require("@web/core/utils/draggable_hook_builder");__exports.makeDraggableHook=makeDraggableHook;function makeDraggableHook(params){return nativeMakeDraggableHook({...params,setupHooks:{addListener:useExternalListener,setup:useEffect,teardown:onWillUnmount,throttle:useThrottleForAnimation,wrapState:reactive,},});}
return __exports;});;

/* /web/static/src/core/utils/files.js */
odoo.define('@web/core/utils/files',['@web/core/utils/numbers','@web/core/utils/hooks','@web/session','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{humanNumber}=require("@web/core/utils/numbers");const{useService}=require("@web/core/utils/hooks");const{session}=require("@web/session");const{_t}=require("@web/core/l10n/translation");const DEFAULT_MAX_FILE_SIZE=__exports.DEFAULT_MAX_FILE_SIZE=128*1024*1024;__exports.checkFileSize=checkFileSize;function checkFileSize(fileSize,notificationService){const maxUploadSize=session.max_file_upload_size||DEFAULT_MAX_FILE_SIZE;if(fileSize>maxUploadSize){notificationService.add(_t("The selected file (%(size)sB) is larger than the maximum allowed file size (%(maxSize)sB).",{size:humanNumber(fileSize),maxSize:humanNumber(maxUploadSize)}),{type:"danger",});return false;}
return true;}
__exports.useFileUploader=useFileUploader;function useFileUploader(){const http=useService("http");const notification=useService("notification");return async(route,params)=>{if((params.ufile&&params.ufile.length)||params.file){const fileSize=(params.ufile&&params.ufile[0].size)||params.file.size;if(!checkFileSize(fileSize,notification)){return null;}}
const fileData=await http.post(route,params,"text");const parsedFileData=JSON.parse(fileData);if(parsedFileData.error){throw new Error(parsedFileData.error);}
return parsedFileData;};}
return __exports;});;

/* /web/static/src/core/utils/functions.js */
odoo.define('@web/core/utils/functions',[],function(require){'use strict';let __exports={};__exports.memoize=memoize;function memoize(func){const cache=new Map();const funcName=func.name?func.name+" (memoized)":"memoized";return{[funcName](...args){if(!cache.has(args[0])){cache.set(args[0],func(...args));}
return cache.get(...args);},}[funcName];}
__exports.uniqueId=uniqueId;function uniqueId(prefix=""){return`${prefix}${++uniqueId.nextId}`;}
uniqueId.nextId=0;return __exports;});;

/* /web/static/src/core/utils/hooks.js */
odoo.define('@web/core/utils/hooks',['@web/core/browser/feature_detection','@odoo/owl'],function(require){'use strict';let __exports={};const{hasTouch,isMobileOS}=require("@web/core/browser/feature_detection");const{status,useComponent,useEffect,useRef,onWillUnmount}=require("@odoo/owl");__exports.useAutofocus=useAutofocus;function useAutofocus({refName,selectAll,mobile}={}){const ref=useRef(refName||"autofocus");const uiService=useService("ui");if(!mobile&&hasTouch()){return ref;}
if(!mobile&&isMobileOS()){return ref;}
useEffect((el)=>{if(el&&(!uiService.activeElement||uiService.activeElement.contains(el))){el.focus();if(["INPUT","TEXTAREA"].includes(el.tagName)&&el.type!=="number"){el.selectionEnd=el.value.length;el.selectionStart=selectAll?0:el.value.length;}}},()=>[ref.el]);return ref;}
__exports.useBus=useBus;function useBus(bus,eventName,callback){const component=useComponent();useEffect(()=>{const listener=callback.bind(component);bus.addEventListener(eventName,listener);return()=>bus.removeEventListener(eventName,listener);},()=>[]);}
const useServiceProtectMethodHandling=__exports.useServiceProtectMethodHandling={fn(){return this.original();},mocked(){return new Promise(()=>{});},original(){return Promise.reject(new Error("Component is destroyed"));},};function _protectMethod(component,fn){return function(...args){if(status(component)==="destroyed"){return useServiceProtectMethodHandling.fn();}
const prom=Promise.resolve(fn.call(this,...args));const protectedProm=prom.then((result)=>status(component)==="destroyed"?new Promise(()=>{}):result);return Object.assign(protectedProm,{abort:prom.abort,cancel:prom.cancel,});};}
const SERVICES_METADATA=__exports.SERVICES_METADATA={};__exports.useService=useService;function useService(serviceName){const component=useComponent();const{services}=component.env;if(!(serviceName in services)){throw new Error(`Service ${serviceName} is not available`);}
const service=services[serviceName];if(serviceName in SERVICES_METADATA){if(service instanceof Function){return _protectMethod(component,service);}else{const methods=SERVICES_METADATA[serviceName];const result=Object.create(service);for(const method of methods){result[method]=_protectMethod(component,service[method]);}
return result;}}
return service;}
__exports.useSpellCheck=useSpellCheck;function useSpellCheck({refName}={}){const elements=[];const ref=useRef(refName||"spellcheck");function toggleSpellcheck(ev){ev.target.spellcheck=document.activeElement===ev.target;}
useEffect((el)=>{if(el){const inputs=["INPUT","TEXTAREA"].includes(el.nodeName)||el.isContentEditable?[el]:el.querySelectorAll("input, textarea, [contenteditable=true]");inputs.forEach((input)=>{if(input.spellcheck!==false){elements.push(input);input.addEventListener("focus",toggleSpellcheck);input.addEventListener("blur",toggleSpellcheck);}});}
return()=>{elements.forEach((input)=>{input.removeEventListener("focus",toggleSpellcheck);input.removeEventListener("blur",toggleSpellcheck);});};},()=>[ref.el]);}
__exports.useChildRef=useChildRef;function useChildRef(){let defined=false;let value;return function ref(v){value=v;if(defined){return;}
Object.defineProperty(ref,"el",{get(){return value.el;},});defined=true;};}
__exports.useForwardRefToParent=useForwardRefToParent;function useForwardRefToParent(refName){const component=useComponent();const ref=useRef(refName);if(component.props[refName]){component.props[refName](ref);}
return ref;}
__exports.useOwnedDialogs=useOwnedDialogs;function useOwnedDialogs(){const dialogService=useService("dialog");const cbs=[];onWillUnmount(()=>{cbs.forEach((cb)=>cb());});const addDialog=(...args)=>{const close=dialogService.add(...args);cbs.push(close);return close;};return addDialog;}
__exports.useRefListener=useRefListener;function useRefListener(ref,...listener){useEffect((el)=>{el?.addEventListener(...listener);return()=>el?.removeEventListener(...listener);},()=>[ref.el]);}
return __exports;});;

/* /web/static/src/core/utils/html.js */
odoo.define('@web/core/utils/html',['@odoo/owl','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{markup}=require("@odoo/owl");const{escape}=require("@web/core/utils/strings");const Markup=markup().constructor;__exports.htmlEscape=htmlEscape;function htmlEscape(content){return content instanceof Markup?content:markup(escape(content));}
__exports.isHtmlEmpty=isHtmlEmpty;function isHtmlEmpty(content=""){const div=document.createElement("div");setElementContent(div,content);return div.textContent.trim()==="";}
__exports.setElementContent=setElementContent;function setElementContent(element,content){if(content instanceof Markup){element.innerHTML=content;}else{element.textContent=content;}}
return __exports;});;

/* /web/static/src/core/utils/misc.js */
odoo.define('@web/core/utils/misc',[],function(require){'use strict';let __exports={};const eventHandledWeakMap=new WeakMap();__exports.isEventHandled=isEventHandled;function isEventHandled(ev,markName){if(!eventHandledWeakMap.get(ev)){return false;}
return eventHandledWeakMap.get(ev).includes(markName);}
__exports.markEventHandled=markEventHandled;function markEventHandled(ev,markName){if(!eventHandledWeakMap.get(ev)){eventHandledWeakMap.set(ev,[]);}
eventHandledWeakMap.get(ev).push(markName);}
return __exports;});;

/* /web/static/src/core/utils/nested_sortable.js */
odoo.define('@web/core/utils/nested_sortable',['@web/core/l10n/localization','@web/core/utils/draggable_hook_builder_owl'],function(require){'use strict';let __exports={};const{localization}=require("@web/core/l10n/localization");const{makeDraggableHook}=require("@web/core/utils/draggable_hook_builder_owl");const useNestedSortable=__exports.useNestedSortable=makeDraggableHook({name:"useNestedSortable",acceptedParams:{groups:[String,Function],connectGroups:[Boolean,Function],nest:[Boolean],listTagName:[String],nestInterval:[Number],maxLevels:[Number],isAllowed:[Function],useElementSize:[Boolean],},defaultParams:{connectGroups:false,currentGroup:null,cursor:"grabbing",edgeScrolling:{speed:20,threshold:60},elements:"li",groupSelector:null,nest:false,listTagName:"ul",nestInterval:15,maxLevels:0,isAllowed:(ctx)=>true,useElementSize:false,},onComputeParams({ctx,params}){ctx.groupSelector=params.groups||null;if(ctx.groupSelector){ctx.fullSelector=[ctx.groupSelector,ctx.fullSelector].join(" ");}
ctx.connectGroups=params.connectGroups;ctx.nest=params.nest;ctx.listTagName=params.listTagName;ctx.nestInterval=params.nestInterval;ctx.isRTL=localization.direction==="rtl";ctx.maxLevels=params.maxLevels||0;ctx.isAllowed=params.isAllowed??(()=>true);ctx.useElementSize=params.useElementSize;},onWillStartDrag({ctx,addCleanup}){if(ctx.groupSelector){ctx.currentGroup=ctx.current.element.closest(ctx.groupSelector);if(!ctx.connectGroups){ctx.current.container=ctx.currentGroup;}}
if(ctx.nest){ctx.prevNestX=ctx.pointer.x;}
ctx.current.placeHolder=ctx.current.element.cloneNode(false);ctx.current.placeHolder.removeAttribute("id");ctx.current.placeHolder.classList.add("w-100","d-block");if(ctx.useElementSize){ctx.current.placeHolder.style.height=getComputedStyle(ctx.current.element).height;ctx.current.placeHolder.classList.add("o_nested_sortable_placeholder_realsize");}else{ctx.current.placeHolder.classList.add("o_nested_sortable_placeholder");}
addCleanup(()=>ctx.current.placeHolder.remove());},onDragStart({ctx,addStyle}){ctx.selectorX=ctx.isRTL?ctx.current.elementRect.left+1:ctx.current.elementRect.right-1;ctx.current.element.after(ctx.current.placeHolder);addStyle(ctx.current.element,{opacity:0.5});addStyle(document.body,{"pointer-events":"auto"});addStyle(document.querySelector(".o_navbar"),{"pointer-events":"none"});addStyle(document.querySelector(".o_action_manager"),{"pointer-events":"none"});addStyle(ctx.current.container,{"pointer-events":"auto"});return{element:ctx.current.element,group:ctx.currentGroup,};},_getDeepestChildLevel(ctx,node,depth=0){let result=0;const childSelector=`${ctx.listTagName} ${ctx.elementSelector}`;for(const childNode of node.querySelectorAll(childSelector)){result=Math.max(this._getDeepestChildLevel(ctx,childNode,depth+1),result);}
return depth?result+1:result;},_hasReachMaxAllowedLevel(ctx){if(!ctx.nest||ctx.maxLevels<1){return false;}
let level=this._getDeepestChildLevel(ctx,ctx.current.element);let list=ctx.current.placeHolder.closest(ctx.listTagName);while(list){level++;list=list.parentNode.closest(ctx.listTagName);}
return level>ctx.maxLevels;},_isAllowedNodeMove(ctx){return(!this._hasReachMaxAllowedLevel(ctx)&&ctx.isAllowed(ctx.current,ctx.elementSelector));},onDrag({ctx,callHandler}){const onMove=(prevPos)=>{if(!ctx.isAllowed(ctx.current,ctx.elementSelector)){ctx.current.placeHolder.classList.add("d-none");return;}else if(this._hasReachMaxAllowedLevel(ctx)){const previousSiblingEl=ctx.current.placeHolder.closest(ctx.listTagName).closest(ctx.elementSelector);previousSiblingEl.after(ctx.current.placeHolder);return;}
ctx.current.placeHolder.classList.remove("d-none");callHandler("onMove",{element:ctx.current.element,previous:ctx.current.placeHolder.previousElementSibling,next:ctx.current.placeHolder.nextElementSibling,parent:ctx.nest?ctx.current.placeHolder.parentElement.closest(ctx.elementSelector):false,group:ctx.currentGroup,newGroup:ctx.connectGroups?ctx.current.placeHolder.closest(ctx.groupSelector):ctx.currentGroup,prevPos,placeholder:ctx.current.placeHolder,});};const getChildList=(el)=>{let list=el.querySelector(ctx.listTagName);if(!list){list=document.createElement(ctx.listTagName);el.appendChild(list);}
return list;};const getPosition=(el)=>{return{previous:el.previousElementSibling,next:el.nextElementSibling,parent:el.parentElement?.closest(ctx.elementSelector)||null,group:ctx.groupSelector?el.closest(ctx.groupSelector):false,};};const position=getPosition(ctx.current.placeHolder);if(ctx.nest){const xInterval=ctx.prevNestX-ctx.pointer.x;if(ctx.nestInterval-(-1)**ctx.isRTL*xInterval<1){let nextElement=position.next;if(nextElement===ctx.current.element){nextElement=nextElement.nextElementSibling;}
if(!nextElement){const newSibling=position.parent;if(newSibling){newSibling.after(ctx.current.placeHolder);onMove(position);}}
ctx.prevNestX=ctx.pointer.x;return;}else if(ctx.nestInterval+(-1)**ctx.isRTL*xInterval<1){let parent=position.previous;if(parent===ctx.current.element){parent=parent.previousElementSibling;}
if(parent&&parent.matches(ctx.elementSelector)){getChildList(parent).appendChild(ctx.current.placeHolder);onMove(position);}
ctx.prevNestX=ctx.pointer.x;return;}}
const currentTop=ctx.pointer.y-ctx.current.offset.y;const closestEl=document.elementFromPoint(ctx.selectorX,currentTop);if(!closestEl){return;}
const element=closestEl.closest(ctx.elementSelector);if(element&&element!==ctx.current.placeHolder){const elementPosition=getPosition(element);const eRect=element.getBoundingClientRect();const pos=ctx.current.placeHolder.compareDocumentPosition(element);if(currentTop-eRect.y<10){if(pos&Node.DOCUMENT_POSITION_PRECEDING&&(ctx.nest||elementPosition.parent===position.parent)){element.before(ctx.current.placeHolder);onMove(position);ctx.prevNestX=ctx.pointer.x;}}else if(currentTop-eRect.y>15&&pos===Node.DOCUMENT_POSITION_FOLLOWING){if(ctx.nest){const elementChildList=getChildList(element);if(elementChildList.querySelector(ctx.elementSelector)){elementChildList.prepend(ctx.current.placeHolder);onMove(position);}else{element.after(ctx.current.placeHolder);onMove(position);}
ctx.prevNestX=ctx.pointer.x;}else if(elementPosition.parent===position.parent){element.after(ctx.current.placeHolder);onMove(position);}}}else{const group=closestEl.closest(ctx.groupSelector);if(group&&group!==position.group&&(ctx.nest||!position.parent)){if(group.compareDocumentPosition(position.group)===Node.DOCUMENT_POSITION_PRECEDING){getChildList(group).prepend(ctx.current.placeHolder);onMove(position);}else{getChildList(group).appendChild(ctx.current.placeHolder);onMove(position);}
ctx.prevNestX=ctx.pointer.x;callHandler("onGroupEnter",{group,placeholder:ctx.current.placeHolder});callHandler("onGroupLeave",{group:position.group,placeholder:ctx.current.placeHolder,});}}},onDrop({ctx}){if(!this._isAllowedNodeMove(ctx)){return;}
const previous=ctx.current.placeHolder.previousElementSibling;const next=ctx.current.placeHolder.nextElementSibling;if(previous!==ctx.current.element&&next!==ctx.current.element){return{element:ctx.current.element,group:ctx.currentGroup,previous,next,newGroup:ctx.groupSelector&&ctx.current.placeHolder.closest(ctx.groupSelector),parent:ctx.current.placeHolder.parentElement.closest(ctx.elementSelector),placeholder:ctx.current.placeHolder,};}},onDragEnd({ctx}){return{element:ctx.current.element,group:ctx.currentGroup,};},});return __exports;});;

/* /web/static/src/core/utils/numbers.js */
odoo.define('@web/core/utils/numbers',['@web/core/l10n/localization','@web/core/l10n/translation','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{localization:l10n}=require("@web/core/l10n/localization");const{_t}=require("@web/core/l10n/translation");const{intersperse}=require("@web/core/utils/strings");__exports.clamp=clamp;function clamp(num,min,max){return Math.max(Math.min(num,max),min);}
__exports.range=range;function range(start,stop,step=1){const array=[];const nsteps=Math.floor((stop-start)/step);for(let i=0;i<nsteps;i++){array.push(start+step*i);}
return array;}
__exports.roundPrecision=roundPrecision;function roundPrecision(value,precision,method="HALF-UP"){if(!value){return 0;}else if(!precision||precision<0){precision=1;}
let roundingFactor=precision;let normalize=(val)=>val/roundingFactor;let denormalize=(val)=>val*roundingFactor;if(roundingFactor<1){roundingFactor=invertFloat(roundingFactor);[normalize,denormalize]=[denormalize,normalize];}
const normalizedValue=normalize(value);const sign=Math.sign(normalizedValue);const epsilonMagnitude=Math.log2(Math.abs(normalizedValue));const epsilon=Math.pow(2,epsilonMagnitude-50);let roundedValue;switch(method){case"DOWN":{roundedValue=Math.trunc(normalizedValue+sign*epsilon);break;}
case"HALF-DOWN":{roundedValue=Math.round(normalizedValue-sign*epsilon);break;}
case"HALF-UP":{roundedValue=Math.round(normalizedValue+sign*epsilon);break;}
case"HALF-EVEN":{const integral=Math.floor(normalizedValue);const remainder=Math.abs(normalizedValue-integral);const isHalf=Math.abs(0.5-remainder)<epsilon;roundedValue=isHalf?integral+(integral&1):Math.round(normalizedValue);break;}
case"UP":{roundedValue=Math.trunc(normalizedValue+sign*(1-epsilon));break;}
default:{throw new Error(`Unknown rounding method: ${method}`);}}
return denormalize(roundedValue);}
__exports.roundDecimals=roundDecimals;function roundDecimals(value,decimals){return roundPrecision(value,parseFloat("1e"+-decimals));}
__exports.floatIsZero=floatIsZero;function floatIsZero(value,decimals){return value===0||roundDecimals(value,decimals)===0;}
__exports.insertThousandsSep=insertThousandsSep;function insertThousandsSep(number,thousandsSep=",",grouping=[]){const negative=number[0]==="-";number=negative?number.slice(1):number;return(negative?"-":"")+intersperse(number,grouping,thousandsSep);}
__exports.humanNumber=humanNumber;function humanNumber(number,options={decimals:0,minDigits:1}){const decimals=options.decimals||0;const minDigits=options.minDigits||1;const d2=Math.pow(10,decimals);const numberMagnitude=+number.toExponential().split("e+")[1];number=Math.round(number*d2)/d2;if(numberMagnitude>=21){number=Math.round(number*Math.pow(10,decimals-numberMagnitude))/d2;return`${number}e+${numberMagnitude}`;}
const unitSymbols=_t("kMGTPE").toString();const sign=Math.sign(number);number=Math.abs(number);let symbol="";for(let i=unitSymbols.length;i>0;i--){const s=Math.pow(10,i*3);if(s<=number/Math.pow(10,minDigits-1)){number=Math.round((number*d2)/s)/d2;symbol=unitSymbols[i-1];break;}}
const{decimalPoint,grouping,thousandsSep}=l10n;const decimalsToKeep=number>=1000?0:decimals;number=sign*number;const[integerPart,decimalPart]=number.toFixed(decimalsToKeep).split(".");const int=insertThousandsSep(integerPart,thousandsSep,grouping);if(!decimalPart){return int+symbol;}
return int+decimalPoint+decimalPart+symbol;}
__exports.formatFloat=formatFloat;function formatFloat(value,options={}){if(options.humanReadable){return humanNumber(value,options);}
const grouping=options.grouping||l10n.grouping;const thousandsSep="thousandsSep"in options?options.thousandsSep:l10n.thousandsSep;const decimalPoint="decimalPoint"in options?options.decimalPoint:l10n.decimalPoint;let precision;if(options.digits&&options.digits[1]!==undefined){precision=options.digits[1];}else{precision=2;}
const formatted=value.toFixed(precision).split(".");formatted[0]=insertThousandsSep(formatted[0],thousandsSep,grouping);if(options.trailingZeros===false&&formatted[1]){formatted[1]=formatted[1].replace(/0+$/,"");}
return formatted[1]?formatted.join(decimalPoint):formatted[0];}
const _INVERTDICT=Object.freeze({1e-1:1e+1,1e-2:1e+2,1e-3:1e+3,1e-4:1e+4,1e-5:1e+5,1e-6:1e+6,1e-7:1e+7,1e-8:1e+8,1e-9:1e+9,1e-10:1e+10,2e-1:5e+0,2e-2:5e+1,2e-3:5e+2,2e-4:5e+3,2e-5:5e+4,2e-6:5e+5,2e-7:5e+6,2e-8:5e+7,2e-9:5e+8,2e-10:5e+9,5e-1:2e+0,5e-2:2e+1,5e-3:2e+2,5e-4:2e+3,5e-5:2e+4,5e-6:2e+5,5e-7:2e+6,5e-8:2e+7,5e-9:2e+8,5e-10:2e+9,});__exports.invertFloat=invertFloat;function invertFloat(value){let res=_INVERTDICT[value];if(res===undefined){const[coeff,expt]=value.toExponential().split("e").map(Number.parseFloat);res=Number.parseFloat(`${coeff}e${-expt}`)/Math.pow(coeff,2);}
return res;}
return __exports;});;

/* /web/static/src/core/utils/objects.js */
odoo.define('@web/core/utils/objects',[],function(require){'use strict';let __exports={};__exports.shallowEqual=shallowEqual;function shallowEqual(obj1,obj2,comparisonFn=(a,b)=>a===b){if(!isObject(obj1)||!isObject(obj2)){return obj1===obj2;}
const obj1Keys=Reflect.ownKeys(obj1);return(obj1Keys.length===Reflect.ownKeys(obj2).length&&obj1Keys.every((key)=>comparisonFn(obj1[key],obj2[key])));}
const deepEqual=__exports.deepEqual=(obj1,obj2)=>shallowEqual(obj1,obj2,deepEqual);__exports.deepCopy=deepCopy;function deepCopy(object){return object&&JSON.parse(JSON.stringify(object));}
__exports.isObject=isObject;function isObject(object){return!!object&&(typeof object==="object"||typeof object==="function");}
__exports.omit=omit;function omit(object,...properties){const result={};const propertiesSet=new Set(properties);for(const key in object){if(!propertiesSet.has(key)){result[key]=object[key];}}
return result;}
__exports.pick=pick;function pick(object,...properties){return Object.fromEntries(properties.filter((prop)=>prop in object).map((prop)=>[prop,object[prop]]));}
__exports.deepMerge=deepMerge;function deepMerge(target,extension){if(!isObject(target)&&!isObject(extension)){return;}
target=target||{};const output=Object.assign({},target);if(isObject(extension)){for(const key of Reflect.ownKeys(extension)){if(key in target&&isObject(extension[key])&&!Array.isArray(extension[key])&&typeof extension[key]!=="function"){output[key]=deepMerge(target[key],extension[key]);}else{Object.assign(output,{[key]:extension[key]});}}}
return output;}
return __exports;});;

/* /web/static/src/core/utils/patch.js */
odoo.define('@web/core/utils/patch',[],function(require){'use strict';let __exports={};const patchDescriptions=new WeakMap();function getPatchDescription(objToPatch){if(!patchDescriptions.has(objToPatch)){patchDescriptions.set(objToPatch,{originalProperties:new Map(),skeleton:Object.create(Object.getPrototypeOf(objToPatch)),extensions:new Set(),});}
return patchDescriptions.get(objToPatch);}
function isClassPrototype(objToPatch){return(Object.hasOwn(objToPatch,"constructor")&&objToPatch.constructor?.prototype===objToPatch);}
function findAncestorPropertyDescriptor(objToPatch,key){let descriptor=null;let prototype=objToPatch;do{descriptor=Object.getOwnPropertyDescriptor(prototype,key);prototype=Object.getPrototypeOf(prototype);}while(!descriptor&&prototype);return descriptor;}
__exports.patch=patch;function patch(objToPatch,extension){if(typeof extension==="string"){throw new Error(`Patch "${extension}": Second argument is not the patch name anymore, it should be the object containing the patched properties`);}
const description=getPatchDescription(objToPatch);description.extensions.add(extension);const properties=Object.getOwnPropertyDescriptors(extension);for(const[key,newProperty]of Object.entries(properties)){const oldProperty=Object.getOwnPropertyDescriptor(objToPatch,key);if(oldProperty){Object.defineProperty(description.skeleton,key,oldProperty);}
if(!description.originalProperties.has(key)){description.originalProperties.set(key,oldProperty);}
if(isClassPrototype(objToPatch)){newProperty.enumerable=false;}
if((newProperty.get&&1)^(newProperty.set&&1)){const ancestorProperty=findAncestorPropertyDescriptor(objToPatch,key);newProperty.get=newProperty.get??ancestorProperty?.get;newProperty.set=newProperty.set??ancestorProperty?.set;}
Object.defineProperty(objToPatch,key,newProperty);}
description.skeleton=Object.setPrototypeOf(extension,description.skeleton);return()=>{patchDescriptions.delete(objToPatch);for(const[key,property]of description.originalProperties){if(property){Object.defineProperty(objToPatch,key,property);}else{delete objToPatch[key];}}
description.extensions.delete(extension);for(const extension of description.extensions){patch(objToPatch,extension);}};}
return __exports;});;

/* /web/static/src/core/utils/reactive.js */
odoo.define('@web/core/utils/reactive',['@odoo/owl'],function(require){'use strict';let __exports={};const{reactive}=require("@odoo/owl");const Reactive=__exports.Reactive=class Reactive{constructor(){return reactive(this);}}
__exports.effect=effect;function effect(cb,deps){const reactiveDeps=reactive(deps,()=>{cb(...reactiveDeps);});cb(...reactiveDeps);}
__exports.withComputedProperties=withComputedProperties;function withComputedProperties(obj,sources,descriptor){for(const[key,compute]of Object.entries(descriptor)){effect((obj,sources)=>{obj[key]=compute.call(obj,...sources);},[obj,sources]);}
return obj;}
return __exports;});;

/* /web/static/src/core/utils/render.js */
odoo.define('@web/core/utils/render',['@odoo/owl','@web/core/templates','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{App,blockDom,Component,markup}=require("@odoo/owl");const{getTemplate}=require("@web/core/templates");const{_t}=require("@web/core/l10n/translation");__exports.renderToElement=renderToElement;function renderToElement(template,context={}){const el=render(template,context).firstElementChild;if(el?.nextElementSibling){throw new Error(`The rendered template '${template}' contains multiple root `+`nodes that will be ignored using renderToElement, you should `+`consider using renderToFragment or refactoring the template.`);}
el?.remove();return el;}
__exports.renderToFragment=renderToFragment;function renderToFragment(template,context={}){const frag=document.createDocumentFragment();for(const el of[...render(template,context).children]){frag.appendChild(el);}
return frag;}
__exports.renderToString=renderToString;function renderToString(template,context={}){return render(template,context).innerHTML;}
let app;Object.defineProperty(renderToString,"app",{get:()=>{if(!app){app=new App(Component,{name:"renderToString",getTemplate,translatableAttributes:["data-tooltip"],translateFn:_t,});}
return app;},});function render(template,context={}){const app=renderToString.app;const templateFn=app.getTemplate(template);const bdom=templateFn(context,{});const div=document.createElement("div");blockDom.mount(bdom,div);return div;}
__exports.renderToMarkup=renderToMarkup;function renderToMarkup(template,context={}){return markup(renderToString(template,context));}
return __exports;});;

/* /web/static/src/core/utils/scrolling.js */
odoo.define('@web/core/utils/scrolling',[],function(require){'use strict';let __exports={};__exports.isScrollableX=isScrollableX;function isScrollableX(el){if(el.scrollWidth>el.clientWidth&&el.clientWidth>0){return couldBeScrollableX(el);}
return false;}
__exports.couldBeScrollableX=couldBeScrollableX;function couldBeScrollableX(el){if(el){const overflow=getComputedStyle(el).getPropertyValue("overflow-x");if(/\bauto\b|\bscroll\b/.test(overflow)){return true;}}
return false;}
__exports.closestScrollableX=closestScrollableX;function closestScrollableX(el){if(!el){return null;}
if(isScrollableX(el)){return el;}
return closestScrollableX(el.parentElement);}
__exports.isScrollableY=isScrollableY;function isScrollableY(el){if(el&&el.scrollHeight>el.clientHeight&&el.clientHeight>0){return couldBeScrollableY(el);}
return false;}
__exports.couldBeScrollableY=couldBeScrollableY;function couldBeScrollableY(el){if(el){const overflow=getComputedStyle(el).getPropertyValue("overflow-y");if(/\bauto\b|\bscroll\b/.test(overflow)){return true;}}
return false;}
__exports.closestScrollableY=closestScrollableY;function closestScrollableY(el){if(!el){return null;}
if(isScrollableY(el)){return el;}
return closestScrollableY(el.parentElement);}
__exports.scrollTo=scrollTo;function scrollTo(element,options={}){const{behavior="auto",isAnchor=false,offset=0}=options;const scrollable=closestScrollableY(options.scrollable||element.parentElement);if(!scrollable){return;}
const scrollBottom=scrollable.getBoundingClientRect().bottom;const scrollTop=scrollable.getBoundingClientRect().top;const elementBottom=element.getBoundingClientRect().bottom;const elementTop=element.getBoundingClientRect().top;const scrollPromises=[];if(elementBottom>scrollBottom&&!isAnchor){scrollPromises.push(new Promise((resolve)=>{scrollable.addEventListener("scrollend",()=>resolve(),{once:true});}));scrollable.scrollTo({top:scrollable.scrollTop+
elementTop-
scrollBottom+
Math.ceil(element.getBoundingClientRect().height)+
offset,behavior,});}else if(elementTop<scrollTop||isAnchor){scrollPromises.push(new Promise((resolve)=>{scrollable.addEventListener("scrollend",()=>resolve(),{once:true});}));scrollable.scrollTo({top:scrollable.scrollTop-scrollTop+elementTop+offset,behavior,});if(options.isAnchor){const parentScrollable=closestScrollableY(scrollable.parentElement);if(parentScrollable){scrollPromises.push(scrollTo(scrollable,{behavior,isAnchor:true,scrollable:parentScrollable,}));}}}
return Promise.all(scrollPromises);}
__exports.compensateScrollbar=compensateScrollbar;function compensateScrollbar(el,add=true,isScrollElement=true,cssProperty="padding-right"){if(!el){return;}
const scrollableEl=isScrollElement?el:closestScrollableY(el.parentElement);if(!scrollableEl){return;}
const isRTL=scrollableEl.classList.contains(".o_rtl");if(isRTL){cssProperty=cssProperty.replace("right","left");}
el.style.removeProperty(cssProperty);if(!add){return;}
const style=window.getComputedStyle(el);const borderLeftWidth=Math.ceil(parseFloat(style.borderLeftWidth.replace("px","")));const borderRightWidth=Math.ceil(parseFloat(style.borderRightWidth.replace("px","")));const bordersWidth=borderLeftWidth+borderRightWidth;const newValue=parseInt(style[cssProperty])+
scrollableEl.offsetWidth-
scrollableEl.clientWidth-
bordersWidth;el.style.setProperty(cssProperty,`${newValue}px`,"important");}
__exports.getScrollingElement=getScrollingElement;function getScrollingElement(document=window.document){const baseScrollingElement=document.scrollingElement;if(isScrollableY(baseScrollingElement)){return baseScrollingElement;}
const bodyHeight=window.getComputedStyle(document.body).height;for(const el of document.body.children){if(bodyHeight-el.scrollHeight>1.5){continue;}
if(isScrollableY(el)){return el;}}
return baseScrollingElement;}
return __exports;});;

/* /web/static/src/core/utils/search.js */
odoo.define('@web/core/utils/search',['@web/core/utils/strings'],function(require){'use strict';let __exports={};const{unaccent}=require("@web/core/utils/strings");function match(pattern,strs){if(!Array.isArray(strs)){strs=[strs];}
let globalScore=0;for(const str of strs){globalScore=Math.max(globalScore,_match(pattern,str));}
return globalScore;}
function _match(pattern,str){let totalScore=0;let currentScore=0;const len=str.length;let patternIndex=0;pattern=unaccent(pattern,false);str=unaccent(str,false);for(let i=0;i<len;i++){if(str[i]===pattern[patternIndex]){patternIndex++;currentScore+=100+currentScore-i/200;}else{currentScore=0;}
totalScore=totalScore+currentScore;}
return patternIndex===pattern.length?totalScore:0;}
__exports.fuzzyLookup=fuzzyLookup;function fuzzyLookup(pattern,list,fn){const results=[];list.forEach((data)=>{const score=match(pattern,fn(data));if(score>0){results.push({score,elem:data});}});results.sort((a,b)=>b.score-a.score);return results.map((r)=>r.elem);}
__exports.fuzzyTest=fuzzyTest;function fuzzyTest(pattern,string){return _match(pattern,string)!==0;}
return __exports;});;

/* /web/static/src/core/utils/sortable.js */
odoo.define('@web/core/utils/sortable',['@web/core/utils/draggable_hook_builder','@web/core/utils/objects'],function(require){'use strict';let __exports={};const{DRAGGED_CLASS,makeDraggableHook:nativeMakeDraggableHook,}=require("@web/core/utils/draggable_hook_builder");const{pick}=require("@web/core/utils/objects");const hookParams={name:"useSortable",acceptedParams:{groups:[String,Function],connectGroups:[Boolean,Function],clone:[Boolean],placeholderClasses:[Object],applyChangeOnDrop:[Boolean],followingElementClasses:[Object],},defaultParams:{connectGroups:false,edgeScrolling:{speed:20,threshold:60},groupSelector:null,clone:true,placeholderClasses:[],applyChangeOnDrop:false,followingElementClasses:[],},onComputeParams({ctx,params}){ctx.groupSelector=params.groups||null;if(ctx.groupSelector){ctx.fullSelector=[ctx.groupSelector,ctx.fullSelector].join(" ");}
ctx.connectGroups=params.connectGroups;ctx.placeholderClone=params.clone;ctx.placeholderClasses=params.placeholderClasses;ctx.applyChangeOnDrop=params.applyChangeOnDrop;ctx.followingElementClasses=params.followingElementClasses;},onDragStart({ctx,addListener,addStyle,callHandler}){const onElementPointerEnter=(ev)=>{const element=ev.currentTarget;if(connectGroups||!groupSelector||current.group===element.closest(groupSelector)){const pos=current.placeHolder.compareDocumentPosition(element);if(pos===Node.DOCUMENT_POSITION_PRECEDING){element.before(current.placeHolder);}else if(pos===Node.DOCUMENT_POSITION_FOLLOWING){element.after(current.placeHolder);}}
callHandler("onElementEnter",{element});};const onElementPointerLeave=(ev)=>{const element=ev.currentTarget;callHandler("onElementLeave",{element});};const onElementComplexPointerEnter=(ev)=>{if(ctx.haveAlreadyChanged){return;}
const element=ev.currentTarget;const siblingArray=[...element.parentElement.children].filter((el)=>el===current.placeHolder||(el.matches(elementSelector)&&!el.classList.contains(DRAGGED_CLASS)));const elementIndex=siblingArray.indexOf(element);const placeholderIndex=siblingArray.indexOf(current.placeHolder);const isDirectSibling=Math.abs(elementIndex-placeholderIndex)===1;if(connectGroups||!groupSelector||current.group===element.closest(groupSelector)){const pos=current.placeHolder.compareDocumentPosition(element);if(isDirectSibling){if(pos===Node.DOCUMENT_POSITION_PRECEDING){element.before(current.placeHolder);ctx.haveAlreadyChanged=true;}else if(pos===Node.DOCUMENT_POSITION_FOLLOWING){element.after(current.placeHolder);ctx.haveAlreadyChanged=true;}}else{if(pos===Node.DOCUMENT_POSITION_FOLLOWING){element.before(current.placeHolder);ctx.haveAlreadyChanged=true;}else if(pos===Node.DOCUMENT_POSITION_PRECEDING){element.after(current.placeHolder);ctx.haveAlreadyChanged=true;}}}
callHandler("onElementEnter",{element});};const onElementComplexPointerLeave=(ev)=>{if(ctx.haveAlreadyChanged){return;}
const element=ev.currentTarget;const elementRect=element.getBoundingClientRect();const relatedElement=ev.relatedTarget;const relatedElementRect=element.getBoundingClientRect();const siblingArray=[...element.parentElement.children].filter((el)=>el===current.placeHolder||(el.matches(elementSelector)&&!el.classList.contains(DRAGGED_CLASS)));const pointerOnSiblings=siblingArray.indexOf(relatedElement)>-1;const elementIndex=siblingArray.indexOf(element);const isFirst=elementIndex===0;const isAbove=relatedElementRect.top<=elementRect.top;const isLast=elementIndex===siblingArray.length-1;const isBelow=relatedElementRect.bottom>=elementRect.bottom;const pos=current.placeHolder.compareDocumentPosition(element);if(!pointerOnSiblings){if(isFirst&&isAbove&&pos===Node.DOCUMENT_POSITION_PRECEDING){element.before(current.placeHolder);ctx.haveAlreadyChanged=true;}else if(isLast&&isBelow&&pos===Node.DOCUMENT_POSITION_FOLLOWING){element.after(current.placeHolder);ctx.haveAlreadyChanged=true;}}
callHandler("onElementLeave",{element});};const onGroupPointerEnter=(ev)=>{const group=ev.currentTarget;group.appendChild(current.placeHolder);callHandler("onGroupEnter",{group});};const onGroupPointerLeave=(ev)=>{const group=ev.currentTarget;callHandler("onGroupLeave",{group});};const{connectGroups,current,elementSelector,groupSelector,ref}=ctx;if(ctx.placeholderClone){const{width,height}=current.elementRect;addStyle(current.placeHolder,{visibility:"hidden",display:"block",width:`${width}px`,height:`${height}px`,});}
if(connectGroups&&groupSelector){for(const siblingGroup of ref.el.querySelectorAll(groupSelector)){addListener(siblingGroup,"pointerenter",onGroupPointerEnter);addListener(siblingGroup,"pointerleave",onGroupPointerLeave);}}
for(const siblingEl of ref.el.querySelectorAll(elementSelector)){if(siblingEl!==current.element&&siblingEl!==current.placeHolder){if(ctx.placeholderClone){addListener(siblingEl,"pointerenter",onElementPointerEnter);addListener(siblingEl,"pointerleave",onElementPointerLeave);}else{addListener(siblingEl,"pointerenter",onElementComplexPointerEnter);addListener(siblingEl,"pointerleave",onElementComplexPointerLeave);}}}
current.element.after(current.placeHolder);return pick(current,"element","group");},onDrag({ctx}){ctx.haveAlreadyChanged=false;},onDragEnd({ctx}){return pick(ctx.current,"element","group");},onDrop({ctx}){const{current,groupSelector}=ctx;const previous=current.placeHolder.previousElementSibling;const next=current.placeHolder.nextElementSibling;if(previous!==current.element&&next!==current.element){const element=current.element;if(ctx.applyChangeOnDrop){if(previous){previous.after(element);}else if(next){next.before(element);}}
return{element,group:current.group,previous,next,parent:groupSelector&&current.placeHolder.closest(groupSelector),};}},onWillStartDrag({ctx,addCleanup}){const{connectGroups,current,groupSelector}=ctx;if(groupSelector){current.group=current.element.closest(groupSelector);if(!connectGroups){current.container=current.group;}}
if(ctx.placeholderClone){current.placeHolder=current.element.cloneNode(false);}else{current.placeHolder=document.createElement("div");}
current.placeHolder.classList.add(...ctx.placeholderClasses);current.element.classList.add(...ctx.followingElementClasses);addCleanup(()=>current.element.classList.remove(...ctx.followingElementClasses));addCleanup(()=>current.placeHolder.remove());return pick(current,"element","group");},};const useSortable=__exports.useSortable=(sortableParams)=>{const{setupHooks}=sortableParams;delete sortableParams.setupHooks;return nativeMakeDraggableHook({...hookParams,setupHooks})(sortableParams);};return __exports;});;

/* /web/static/src/core/utils/sortable_owl.js */
odoo.define('@web/core/utils/sortable_owl',['@odoo/owl','@web/core/utils/timing','@web/core/utils/sortable'],function(require){'use strict';let __exports={};const{onWillUnmount,reactive,useEffect,useExternalListener}=require("@odoo/owl");const{useThrottleForAnimation}=require("@web/core/utils/timing");const{useSortable:nativeUseSortable}=require("@web/core/utils/sortable");__exports.useSortable=useSortable;function useSortable(params){return nativeUseSortable({...params,setupHooks:{addListener:useExternalListener,setup:useEffect,teardown:onWillUnmount,throttle:useThrottleForAnimation,wrapState:reactive,},});}
return __exports;});;

/* /web/static/src/core/utils/sortable_service.js */
odoo.define('@web/core/utils/sortable_service',['@web/core/registry','@web/core/utils/sortable','@web/core/utils/timing','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useSortable}=require("@web/core/utils/sortable");const{throttleForAnimation}=require("@web/core/utils/timing");const{reactive}=require("@odoo/owl");const DEFAULT_SORTABLE_ID=Symbol.for("defaultSortable");const sortableService=__exports.sortableService={start(){const boundElements=new Map();return{create:(hookParams)=>{const element=hookParams.ref.el;const sortableId=hookParams.sortableId??DEFAULT_SORTABLE_ID;if(boundElements.has(element)){const boundElement=boundElements.get(element);if(sortableId in boundElement){return{enable(){return{cleanup:boundElement[sortableId],};},};}}
const setupFunctions=new Map();const cleanupFunctions=[];const cleanup=()=>{const boundElement=boundElements.get(element);if(sortableId in boundElement){delete boundElement[sortableId];if(boundElement.length===0){boundElements.delete(element);}}
cleanupFunctions.forEach((fn)=>fn());};const setupHooks={wrapState:reactive,throttle:throttleForAnimation,addListener:(el,type,listener)=>{el.addEventListener(type,listener);cleanupFunctions.push(()=>el.removeEventListener(type,listener));},setup:(setupFn,dependenciesFn)=>setupFunctions.set(setupFn,dependenciesFn),teardown:(fn)=>cleanupFunctions.push(fn),};useSortable({setupHooks,...hookParams});const boundElement=boundElements.get(element);if(boundElement){boundElement[sortableId]=cleanup;}else{boundElements.set(element,{[sortableId]:cleanup});}
return{enable(){setupFunctions.forEach((dependenciesFn,setupFn)=>setupFn(...dependenciesFn()));return{cleanup,};},};},};},};registry.category("services").add("sortable",sortableService);return __exports;});;

/* /web/static/src/core/utils/strings.js */
odoo.define('@web/core/utils/strings',[],function(require){'use strict';let __exports={};const nbsp=__exports.nbsp="\u00a0";__exports.escape=escape;function escape(str){if(str===undefined){return"";}
if(typeof str==="number"){return String(str);}
[["&","&amp;"],["<","&lt;"],[">","&gt;"],["'","&#x27;"],['"',"&quot;"],["`","&#x60;"],].forEach((pairs)=>{str=String(str).replaceAll(pairs[0],pairs[1]);});return str;}
__exports.escapeRegExp=escapeRegExp;function escapeRegExp(str){return str.replace(/[.*+?^${}()|[\]\\]/g,"\\$&");}
__exports.intersperse=intersperse;function intersperse(str,indices,separator=""){separator=separator||"";const result=[];let last=str.length;for(let i=0;i<indices.length;++i){let section=indices[i];if(section===-1||last<=0){break;}else if(section===0&&i===0){break;}else if(section===0){section=indices[--i];}
result.push(str.substring(last-section,last));last-=section;}
const s=str.substring(0,last);if(s){result.push(s);}
return result.reverse().join(separator);}
__exports.sprintf=sprintf;function sprintf(s,...values){if(values.length===1&&Object.prototype.toString.call(values[0])==="[object Object]"){const valuesDict=values[0];s=s.replace(/%\(([^)]+)\)s/g,(match,value)=>valuesDict[value]);}else if(values.length>0){s=s.replace(/%s/g,()=>values.shift());}
return s;}
__exports.capitalize=capitalize;function capitalize(s){return s?s[0].toUpperCase()+s.slice(1):"";}
const diacriticsMap={'\u0041':'A','\u24B6':'A','\uFF21':'A','\u00C0':'A','\u00C1':'A','\u00C2':'A','\u1EA6':'A','\u1EA4':'A','\u1EAA':'A','\u1EA8':'A','\u00C3':'A','\u0100':'A','\u0102':'A','\u1EB0':'A','\u1EAE':'A','\u1EB4':'A','\u1EB2':'A','\u0226':'A','\u01E0':'A','\u00C4':'A','\u01DE':'A','\u1EA2':'A','\u00C5':'A','\u01FA':'A','\u01CD':'A','\u0200':'A','\u0202':'A','\u1EA0':'A','\u1EAC':'A','\u1EB6':'A','\u1E00':'A','\u0104':'A','\u023A':'A','\u2C6F':'A','\uA732':'AA','\u00C6':'AE','\u01FC':'AE','\u01E2':'AE','\uA734':'AO','\uA736':'AU','\uA738':'AV','\uA73A':'AV','\uA73C':'AY','\u0042':'B','\u24B7':'B','\uFF22':'B','\u1E02':'B','\u1E04':'B','\u1E06':'B','\u0243':'B','\u0182':'B','\u0181':'B','\u0043':'C','\u24B8':'C','\uFF23':'C','\u0106':'C','\u0108':'C','\u010A':'C','\u010C':'C','\u00C7':'C','\u1E08':'C','\u0187':'C','\u023B':'C','\uA73E':'C','\u0044':'D','\u24B9':'D','\uFF24':'D','\u1E0A':'D','\u010E':'D','\u1E0C':'D','\u1E10':'D','\u1E12':'D','\u1E0E':'D','\u0110':'D','\u018B':'D','\u018A':'D','\u0189':'D','\uA779':'D','\u01F1':'DZ','\u01C4':'DZ','\u01F2':'Dz','\u01C5':'Dz','\u0045':'E','\u24BA':'E','\uFF25':'E','\u00C8':'E','\u00C9':'E','\u00CA':'E','\u1EC0':'E','\u1EBE':'E','\u1EC4':'E','\u1EC2':'E','\u1EBC':'E','\u0112':'E','\u1E14':'E','\u1E16':'E','\u0114':'E','\u0116':'E','\u00CB':'E','\u1EBA':'E','\u011A':'E','\u0204':'E','\u0206':'E','\u1EB8':'E','\u1EC6':'E','\u0228':'E','\u1E1C':'E','\u0118':'E','\u1E18':'E','\u1E1A':'E','\u0190':'E','\u018E':'E','\u0046':'F','\u24BB':'F','\uFF26':'F','\u1E1E':'F','\u0191':'F','\uA77B':'F','\u0047':'G','\u24BC':'G','\uFF27':'G','\u01F4':'G','\u011C':'G','\u1E20':'G','\u011E':'G','\u0120':'G','\u01E6':'G','\u0122':'G','\u01E4':'G','\u0193':'G','\uA7A0':'G','\uA77D':'G','\uA77E':'G','\u0048':'H','\u24BD':'H','\uFF28':'H','\u0124':'H','\u1E22':'H','\u1E26':'H','\u021E':'H','\u1E24':'H','\u1E28':'H','\u1E2A':'H','\u0126':'H','\u2C67':'H','\u2C75':'H','\uA78D':'H','\u0049':'I','\u24BE':'I','\uFF29':'I','\u00CC':'I','\u00CD':'I','\u00CE':'I','\u0128':'I','\u012A':'I','\u012C':'I','\u0130':'I','\u00CF':'I','\u1E2E':'I','\u1EC8':'I','\u01CF':'I','\u0208':'I','\u020A':'I','\u1ECA':'I','\u012E':'I','\u1E2C':'I','\u0197':'I','\u004A':'J','\u24BF':'J','\uFF2A':'J','\u0134':'J','\u0248':'J','\u004B':'K','\u24C0':'K','\uFF2B':'K','\u1E30':'K','\u01E8':'K','\u1E32':'K','\u0136':'K','\u1E34':'K','\u0198':'K','\u2C69':'K','\uA740':'K','\uA742':'K','\uA744':'K','\uA7A2':'K','\u004C':'L','\u24C1':'L','\uFF2C':'L','\u013F':'L','\u0139':'L','\u013D':'L','\u1E36':'L','\u1E38':'L','\u013B':'L','\u1E3C':'L','\u1E3A':'L','\u0141':'L','\u023D':'L','\u2C62':'L','\u2C60':'L','\uA748':'L','\uA746':'L','\uA780':'L','\u01C7':'LJ','\u01C8':'Lj','\u004D':'M','\u24C2':'M','\uFF2D':'M','\u1E3E':'M','\u1E40':'M','\u1E42':'M','\u2C6E':'M','\u019C':'M','\u004E':'N','\u24C3':'N','\uFF2E':'N','\u01F8':'N','\u0143':'N','\u00D1':'N','\u1E44':'N','\u0147':'N','\u1E46':'N','\u0145':'N','\u1E4A':'N','\u1E48':'N','\u0220':'N','\u019D':'N','\uA790':'N','\uA7A4':'N','\u01CA':'NJ','\u01CB':'Nj','\u004F':'O','\u24C4':'O','\uFF2F':'O','\u00D2':'O','\u00D3':'O','\u00D4':'O','\u1ED2':'O','\u1ED0':'O','\u1ED6':'O','\u1ED4':'O','\u00D5':'O','\u1E4C':'O','\u022C':'O','\u1E4E':'O','\u014C':'O','\u1E50':'O','\u1E52':'O','\u014E':'O','\u022E':'O','\u0230':'O','\u00D6':'O','\u022A':'O','\u1ECE':'O','\u0150':'O','\u01D1':'O','\u020C':'O','\u020E':'O','\u01A0':'O','\u1EDC':'O','\u1EDA':'O','\u1EE0':'O','\u1EDE':'O','\u1EE2':'O','\u1ECC':'O','\u1ED8':'O','\u01EA':'O','\u01EC':'O','\u00D8':'O','\u01FE':'O','\u0186':'O','\u019F':'O','\uA74A':'O','\uA74C':'O','\u01A2':'OI','\uA74E':'OO','\u0222':'OU','\u0050':'P','\u24C5':'P','\uFF30':'P','\u1E54':'P','\u1E56':'P','\u01A4':'P','\u2C63':'P','\uA750':'P','\uA752':'P','\uA754':'P','\u0051':'Q','\u24C6':'Q','\uFF31':'Q','\uA756':'Q','\uA758':'Q','\u024A':'Q','\u0052':'R','\u24C7':'R','\uFF32':'R','\u0154':'R','\u1E58':'R','\u0158':'R','\u0210':'R','\u0212':'R','\u1E5A':'R','\u1E5C':'R','\u0156':'R','\u1E5E':'R','\u024C':'R','\u2C64':'R','\uA75A':'R','\uA7A6':'R','\uA782':'R','\u0053':'S','\u24C8':'S','\uFF33':'S','\u1E9E':'S','\u015A':'S','\u1E64':'S','\u015C':'S','\u1E60':'S','\u0160':'S','\u1E66':'S','\u1E62':'S','\u1E68':'S','\u0218':'S','\u015E':'S','\u2C7E':'S','\uA7A8':'S','\uA784':'S','\u0054':'T','\u24C9':'T','\uFF34':'T','\u1E6A':'T','\u0164':'T','\u1E6C':'T','\u021A':'T','\u0162':'T','\u1E70':'T','\u1E6E':'T','\u0166':'T','\u01AC':'T','\u01AE':'T','\u023E':'T','\uA786':'T','\uA728':'TZ','\u0055':'U','\u24CA':'U','\uFF35':'U','\u00D9':'U','\u00DA':'U','\u00DB':'U','\u0168':'U','\u1E78':'U','\u016A':'U','\u1E7A':'U','\u016C':'U','\u00DC':'U','\u01DB':'U','\u01D7':'U','\u01D5':'U','\u01D9':'U','\u1EE6':'U','\u016E':'U','\u0170':'U','\u01D3':'U','\u0214':'U','\u0216':'U','\u01AF':'U','\u1EEA':'U','\u1EE8':'U','\u1EEE':'U','\u1EEC':'U','\u1EF0':'U','\u1EE4':'U','\u1E72':'U','\u0172':'U','\u1E76':'U','\u1E74':'U','\u0244':'U','\u0056':'V','\u24CB':'V','\uFF36':'V','\u1E7C':'V','\u1E7E':'V','\u01B2':'V','\uA75E':'V','\u0245':'V','\uA760':'VY','\u0057':'W','\u24CC':'W','\uFF37':'W','\u1E80':'W','\u1E82':'W','\u0174':'W','\u1E86':'W','\u1E84':'W','\u1E88':'W','\u2C72':'W','\u0058':'X','\u24CD':'X','\uFF38':'X','\u1E8A':'X','\u1E8C':'X','\u0059':'Y','\u24CE':'Y','\uFF39':'Y','\u1EF2':'Y','\u00DD':'Y','\u0176':'Y','\u1EF8':'Y','\u0232':'Y','\u1E8E':'Y','\u0178':'Y','\u1EF6':'Y','\u1EF4':'Y','\u01B3':'Y','\u024E':'Y','\u1EFE':'Y','\u005A':'Z','\u24CF':'Z','\uFF3A':'Z','\u0179':'Z','\u1E90':'Z','\u017B':'Z','\u017D':'Z','\u1E92':'Z','\u1E94':'Z','\u01B5':'Z','\u0224':'Z','\u2C7F':'Z','\u2C6B':'Z','\uA762':'Z','\u0061':'a','\u24D0':'a','\uFF41':'a','\u1E9A':'a','\u00E0':'a','\u00E1':'a','\u00E2':'a','\u1EA7':'a','\u1EA5':'a','\u1EAB':'a','\u1EA9':'a','\u00E3':'a','\u0101':'a','\u0103':'a','\u1EB1':'a','\u1EAF':'a','\u1EB5':'a','\u1EB3':'a','\u0227':'a','\u01E1':'a','\u00E4':'a','\u01DF':'a','\u1EA3':'a','\u00E5':'a','\u01FB':'a','\u01CE':'a','\u0201':'a','\u0203':'a','\u1EA1':'a','\u1EAD':'a','\u1EB7':'a','\u1E01':'a','\u0105':'a','\u2C65':'a','\u0250':'a','\uA733':'aa','\u00E6':'ae','\u01FD':'ae','\u01E3':'ae','\uA735':'ao','\uA737':'au','\uA739':'av','\uA73B':'av','\uA73D':'ay','\u0062':'b','\u24D1':'b','\uFF42':'b','\u1E03':'b','\u1E05':'b','\u1E07':'b','\u0180':'b','\u0183':'b','\u0253':'b','\u0063':'c','\u24D2':'c','\uFF43':'c','\u0107':'c','\u0109':'c','\u010B':'c','\u010D':'c','\u00E7':'c','\u1E09':'c','\u0188':'c','\u023C':'c','\uA73F':'c','\u2184':'c','\u0064':'d','\u24D3':'d','\uFF44':'d','\u1E0B':'d','\u010F':'d','\u1E0D':'d','\u1E11':'d','\u1E13':'d','\u1E0F':'d','\u0111':'d','\u018C':'d','\u0256':'d','\u0257':'d','\uA77A':'d','\u01F3':'dz','\u01C6':'dz','\u0065':'e','\u24D4':'e','\uFF45':'e','\u00E8':'e','\u00E9':'e','\u00EA':'e','\u1EC1':'e','\u1EBF':'e','\u1EC5':'e','\u1EC3':'e','\u1EBD':'e','\u0113':'e','\u1E15':'e','\u1E17':'e','\u0115':'e','\u0117':'e','\u00EB':'e','\u1EBB':'e','\u011B':'e','\u0205':'e','\u0207':'e','\u1EB9':'e','\u1EC7':'e','\u0229':'e','\u1E1D':'e','\u0119':'e','\u1E19':'e','\u1E1B':'e','\u0247':'e','\u025B':'e','\u01DD':'e','\u0066':'f','\u24D5':'f','\uFF46':'f','\u1E1F':'f','\u0192':'f','\uA77C':'f','\u0067':'g','\u24D6':'g','\uFF47':'g','\u01F5':'g','\u011D':'g','\u1E21':'g','\u011F':'g','\u0121':'g','\u01E7':'g','\u0123':'g','\u01E5':'g','\u0260':'g','\uA7A1':'g','\u1D79':'g','\uA77F':'g','\u0068':'h','\u24D7':'h','\uFF48':'h','\u0125':'h','\u1E23':'h','\u1E27':'h','\u021F':'h','\u1E25':'h','\u1E29':'h','\u1E2B':'h','\u1E96':'h','\u0127':'h','\u2C68':'h','\u2C76':'h','\u0265':'h','\u0195':'hv','\u0069':'i','\u24D8':'i','\uFF49':'i','\u00EC':'i','\u00ED':'i','\u00EE':'i','\u0129':'i','\u012B':'i','\u012D':'i','\u00EF':'i','\u1E2F':'i','\u1EC9':'i','\u01D0':'i','\u0209':'i','\u020B':'i','\u1ECB':'i','\u012F':'i','\u1E2D':'i','\u0268':'i','\u0131':'i','\u006A':'j','\u24D9':'j','\uFF4A':'j','\u0135':'j','\u01F0':'j','\u0249':'j','\u006B':'k','\u24DA':'k','\uFF4B':'k','\u1E31':'k','\u01E9':'k','\u1E33':'k','\u0137':'k','\u1E35':'k','\u0199':'k','\u2C6A':'k','\uA741':'k','\uA743':'k','\uA745':'k','\uA7A3':'k','\u006C':'l','\u24DB':'l','\uFF4C':'l','\u0140':'l','\u013A':'l','\u013E':'l','\u1E37':'l','\u1E39':'l','\u013C':'l','\u1E3D':'l','\u1E3B':'l','\u017F':'l','\u0142':'l','\u019A':'l','\u026B':'l','\u2C61':'l','\uA749':'l','\uA781':'l','\uA747':'l','\u01C9':'lj','\u006D':'m','\u24DC':'m','\uFF4D':'m','\u1E3F':'m','\u1E41':'m','\u1E43':'m','\u0271':'m','\u026F':'m','\u006E':'n','\u24DD':'n','\uFF4E':'n','\u01F9':'n','\u0144':'n','\u00F1':'n','\u1E45':'n','\u0148':'n','\u1E47':'n','\u0146':'n','\u1E4B':'n','\u1E49':'n','\u019E':'n','\u0272':'n','\u0149':'n','\uA791':'n','\uA7A5':'n','\u01CC':'nj','\u006F':'o','\u24DE':'o','\uFF4F':'o','\u00F2':'o','\u00F3':'o','\u00F4':'o','\u1ED3':'o','\u1ED1':'o','\u1ED7':'o','\u1ED5':'o','\u00F5':'o','\u1E4D':'o','\u022D':'o','\u1E4F':'o','\u014D':'o','\u1E51':'o','\u1E53':'o','\u014F':'o','\u022F':'o','\u0231':'o','\u00F6':'o','\u022B':'o','\u1ECF':'o','\u0151':'o','\u01D2':'o','\u020D':'o','\u020F':'o','\u01A1':'o','\u1EDD':'o','\u1EDB':'o','\u1EE1':'o','\u1EDF':'o','\u1EE3':'o','\u1ECD':'o','\u1ED9':'o','\u01EB':'o','\u01ED':'o','\u00F8':'o','\u01FF':'o','\u0254':'o','\uA74B':'o','\uA74D':'o','\u0275':'o','\u01A3':'oi','\u0223':'ou','\uA74F':'oo','\u0070':'p','\u24DF':'p','\uFF50':'p','\u1E55':'p','\u1E57':'p','\u01A5':'p','\u1D7D':'p','\uA751':'p','\uA753':'p','\uA755':'p','\u0071':'q','\u24E0':'q','\uFF51':'q','\u024B':'q','\uA757':'q','\uA759':'q','\u0072':'r','\u24E1':'r','\uFF52':'r','\u0155':'r','\u1E59':'r','\u0159':'r','\u0211':'r','\u0213':'r','\u1E5B':'r','\u1E5D':'r','\u0157':'r','\u1E5F':'r','\u024D':'r','\u027D':'r','\uA75B':'r','\uA7A7':'r','\uA783':'r','\u0073':'s','\u24E2':'s','\uFF53':'s','\u00DF':'s','\u015B':'s','\u1E65':'s','\u015D':'s','\u1E61':'s','\u0161':'s','\u1E67':'s','\u1E63':'s','\u1E69':'s','\u0219':'s','\u015F':'s','\u023F':'s','\uA7A9':'s','\uA785':'s','\u1E9B':'s','\u0074':'t','\u24E3':'t','\uFF54':'t','\u1E6B':'t','\u1E97':'t','\u0165':'t','\u1E6D':'t','\u021B':'t','\u0163':'t','\u1E71':'t','\u1E6F':'t','\u0167':'t','\u01AD':'t','\u0288':'t','\u2C66':'t','\uA787':'t','\uA729':'tz','\u0075':'u','\u24E4':'u','\uFF55':'u','\u00F9':'u','\u00FA':'u','\u00FB':'u','\u0169':'u','\u1E79':'u','\u016B':'u','\u1E7B':'u','\u016D':'u','\u00FC':'u','\u01DC':'u','\u01D8':'u','\u01D6':'u','\u01DA':'u','\u1EE7':'u','\u016F':'u','\u0171':'u','\u01D4':'u','\u0215':'u','\u0217':'u','\u01B0':'u','\u1EEB':'u','\u1EE9':'u','\u1EEF':'u','\u1EED':'u','\u1EF1':'u','\u1EE5':'u','\u1E73':'u','\u0173':'u','\u1E77':'u','\u1E75':'u','\u0289':'u','\u0076':'v','\u24E5':'v','\uFF56':'v','\u1E7D':'v','\u1E7F':'v','\u028B':'v','\uA75F':'v','\u028C':'v','\uA761':'vy','\u0077':'w','\u24E6':'w','\uFF57':'w','\u1E81':'w','\u1E83':'w','\u0175':'w','\u1E87':'w','\u1E85':'w','\u1E98':'w','\u1E89':'w','\u2C73':'w','\u0078':'x','\u24E7':'x','\uFF58':'x','\u1E8B':'x','\u1E8D':'x','\u0079':'y','\u24E8':'y','\uFF59':'y','\u1EF3':'y','\u00FD':'y','\u0177':'y','\u1EF9':'y','\u0233':'y','\u1E8F':'y','\u00FF':'y','\u1EF7':'y','\u1E99':'y','\u1EF5':'y','\u01B4':'y','\u024F':'y','\u1EFF':'y','\u007A':'z','\u24E9':'z','\uFF5A':'z','\u017A':'z','\u1E91':'z','\u017C':'z','\u017E':'z','\u1E93':'z','\u1E95':'z','\u01B6':'z','\u0225':'z','\u0240':'z','\u2C6C':'z','\uA763':'z',};__exports.unaccent=unaccent;function unaccent(str,caseSensitive){str=str.replace(/[^\u0000-\u007E]/g,function(accented){return diacriticsMap[accented]||accented;});return caseSensitive?str:str.toLowerCase();}
__exports.isEmail=isEmail;function isEmail(value){const re=/^(([^<>()\[\]\.,;:\s@\"]+(\.[^<>()\[\]\.,;:\s@\"]+)*)|(\".+\"))@(([^<>()[\]\.,;:\s@\"]+\.)+[^<>()[\]\.,;:\s@\"]{2,})$/i;return re.test(value);}
__exports.isNumeric=isNumeric;function isNumeric(value){return Boolean(value?.match(/^\d+$/));}
__exports.exprToBoolean=exprToBoolean;function exprToBoolean(str,trueIfEmpty=false){return str?!/^false|0$/i.test(str):trueIfEmpty;}
return __exports;});;

/* /web/static/src/core/utils/timing.js */
odoo.define('@web/core/utils/timing',['@web/core/browser/browser','@odoo/owl'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{onWillUnmount,useComponent}=require("@odoo/owl");__exports.batched=batched;function batched(callback,synchronize=()=>Promise.resolve()){let scheduled=false;return async(...args)=>{if(!scheduled){scheduled=true;await synchronize();scheduled=false;callback(...args);}};}
__exports.debounce=debounce;function debounce(func,delay,options){let handle;const funcName=func.name?func.name+" (debounce)":"debounce";const useAnimationFrame=delay==="animationFrame";const setFnName=useAnimationFrame?"requestAnimationFrame":"setTimeout";const clearFnName=useAnimationFrame?"cancelAnimationFrame":"clearTimeout";let lastArgs;let leading=false;let trailing=true;if(typeof options==="boolean"){leading=options;trailing=!options;}else if(options){leading=options.leading??leading;trailing=options.trailing??trailing;}
return Object.assign({[funcName](...args){return new Promise((resolve)=>{if(leading&&!handle){Promise.resolve(func.apply(this,args)).then(resolve);}else{lastArgs=args;}
browser[clearFnName](handle);handle=browser[setFnName](()=>{handle=null;if(trailing&&lastArgs){Promise.resolve(func.apply(this,lastArgs)).then(resolve);lastArgs=null;}},delay);});},}[funcName],{cancel(execNow=false){browser[clearFnName](handle);if(execNow&&lastArgs){func.apply(this,lastArgs);}},});}
__exports.setRecurringAnimationFrame=setRecurringAnimationFrame;function setRecurringAnimationFrame(callback){const handler=(timestamp)=>{callback(timestamp-lastTimestamp);lastTimestamp=timestamp;handle=browser.requestAnimationFrame(handler);};const stop=()=>{browser.cancelAnimationFrame(handle);};let lastTimestamp=browser.performance.now();let handle=browser.requestAnimationFrame(handler);return stop;}
__exports.throttleForAnimation=throttleForAnimation;function throttleForAnimation(func){let handle=null;const calls=new Set();const funcName=func.name?`${func.name} (throttleForAnimation)`:"throttleForAnimation";const pending=()=>{if(calls.size){handle=browser.requestAnimationFrame(pending);const{args,resolve}=[...calls].pop();calls.clear();Promise.resolve(func.apply(this,args)).then(resolve);}else{handle=null;}};return Object.assign({[funcName](...args){return new Promise((resolve)=>{const isNew=handle===null;if(isNew){handle=browser.requestAnimationFrame(pending);Promise.resolve(func.apply(this,args)).then(resolve);}else{calls.add({args,resolve});}});},}[funcName],{cancel(){browser.cancelAnimationFrame(handle);calls.clear();handle=null;},});}
__exports.useDebounced=useDebounced;function useDebounced(callback,delay,{execBeforeUnmount=false,immediate=false}={}){const component=useComponent();const debounced=debounce(callback.bind(component),delay,immediate);onWillUnmount(()=>debounced.cancel(execBeforeUnmount));return debounced;}
__exports.useThrottleForAnimation=useThrottleForAnimation;function useThrottleForAnimation(func){const component=useComponent();const throttledForAnimation=throttleForAnimation(func.bind(component));onWillUnmount(()=>throttledForAnimation.cancel());return throttledForAnimation;}
return __exports;});;

/* /web/static/src/core/utils/ui.js */
odoo.define('@web/core/utils/ui',[],function(require){'use strict';let __exports={};__exports.closest=closest;function closest(elements,targetPos){let closestEl=null;let closestDistance=Infinity;for(const el of elements){const rect=el.getBoundingClientRect();const distance=getQuadrance(rect,targetPos);if(!closestEl||distance<closestDistance){closestEl=el;closestDistance=distance;}}
return closestEl;}
__exports.isVisible=isVisible;function isVisible(el){if(el===document||el===window){return true;}
if(!el){return false;}
let _isVisible=false;if("offsetWidth"in el&&"offsetHeight"in el){_isVisible=el.offsetWidth>0&&el.offsetHeight>0;}else if("getBoundingClientRect"in el){const rect=el.getBoundingClientRect();_isVisible=rect.width>0&&rect.height>0;}
if(!_isVisible&&getComputedStyle(el).display==="contents"){for(const child of el.children){if(isVisible(child)){return true;}}}
return _isVisible;}
__exports.getQuadrance=getQuadrance;function getQuadrance(rect,pos){let q=0;if(pos.x<rect.x){q+=(rect.x-pos.x)**2;}else if(rect.x+rect.width<pos.x){q+=(pos.x-(rect.x+rect.width))**2;}
if(pos.y<rect.y){q+=(rect.y-pos.y)**2;}else if(rect.y+rect.height<pos.y){q+=(pos.y-(rect.y+rect.height))**2;}
return q;}
__exports.getVisibleElements=getVisibleElements;function getVisibleElements(activeElement,selector){const visibleElements=[];const elements=activeElement.querySelectorAll(selector);for(const el of elements){if(isVisible(el)){visibleElements.push(el);}}
return visibleElements;}
__exports.touching=touching;function touching(elements,targetRect){const r1={x:0,y:0,width:0,height:0,...targetRect};return[...elements].filter((el)=>{const r2=el.getBoundingClientRect();return(r2.x+r2.width>=r1.x&&r2.x<=r1.x+r1.width&&r2.y+r2.height>=r1.y&&r2.y<=r1.y+r1.height);});}
const TABABLE_SELECTOR=["[tabindex]","a","area","button","frame","iframe","input","object","select","textarea","details > summary:nth-child(1)",].map((sel)=>`${sel}:not([tabindex="-1"]):not(:disabled)`).join(",");__exports.getTabableElements=getTabableElements;function getTabableElements(container=document.body){const elements=[...container.querySelectorAll(TABABLE_SELECTOR)].filter(isVisible);const byTabIndex={};for(const el of[...elements]){if(!byTabIndex[el.tabIndex]){byTabIndex[el.tabIndex]=[];}
byTabIndex[el.tabIndex].push(el);}
const withTabIndexZero=byTabIndex[0]||[];delete byTabIndex[0];return[...Object.values(byTabIndex).flat(),...withTabIndexZero];}
__exports.getNextTabableElement=getNextTabableElement;function getNextTabableElement(container=document.body){const tabableElements=getTabableElements(container);const index=tabableElements.indexOf(document.activeElement);return index===-1?tabableElements[0]:tabableElements[index+1]||null;}
__exports.getPreviousTabableElement=getPreviousTabableElement;function getPreviousTabableElement(container=document.body){const tabableElements=getTabableElements(container);const index=tabableElements.indexOf(document.activeElement);return index===-1?tabableElements[tabableElements.length-1]:tabableElements[index-1]||null;}
__exports.addLoadingEffect=addLoadingEffect;function addLoadingEffect(btnEl){btnEl.classList.add("o_btn_loading","disabled","pe-none");btnEl.disabled=true;const loaderEl=document.createElement("span");loaderEl.classList.add("fa","fa-refresh","fa-spin","me-2");btnEl.prepend(loaderEl);return()=>{btnEl.classList.remove("o_btn_loading","disabled","pe-none");btnEl.disabled=false;loaderEl.remove();};}
return __exports;});;

/* /web/static/src/core/utils/urls.js */
odoo.define('@web/core/utils/urls',['@web/session','@web/core/browser/browser','@web/core/utils/objects'],function(require){'use strict';let __exports={};const{session}=require("@web/session");const{browser}=require("@web/core/browser/browser");const{shallowEqual}=require("@web/core/utils/objects");const{DateTime}=luxon;const RedirectionError=__exports.RedirectionError=class RedirectionError extends Error{}
__exports.objectToUrlEncodedString=objectToUrlEncodedString;function objectToUrlEncodedString(obj){return Object.entries(obj).map(([k,v])=>`${encodeURIComponent(k)}=${encodeURIComponent(v || "")}`).join("&");}
__exports.getOrigin=getOrigin;function getOrigin(origin){if(origin){origin=origin.replace(/\/+$/,"");}else{const{host,protocol}=browser.location;origin=`${protocol}//${host}`;}
return origin;}
__exports.url=url;function url(route,queryParams,options={}){const origin=getOrigin(options.origin??session.origin);if(!route){return origin;}
let queryString=objectToUrlEncodedString(queryParams||{});queryString=queryString.length>0?`?${queryString}`:queryString;let prefix=["http://","https://","//"].some((el)=>route.length>=el.length&&route.slice(0,el.length)===el);prefix=prefix?"":origin;return`${prefix}${route}${queryString}`;}
__exports.imageUrl=imageUrl;function imageUrl(model,id,field,{access_token,filename,height,unique,width}={}){let route=`/web/image/${model}/${id}/${field}`;if(width&&height){route=`${route}/${width}x${height}`;}
if(filename){route=`${route}/${filename}`;}
const urlParams={};if(access_token){Object.assign(urlParams,{access_token});}
if(unique){if(unique instanceof DateTime){urlParams.unique=unique.ts;}else{const dateTimeFromUnique=DateTime.fromSQL(unique);if(dateTimeFromUnique.isValid){urlParams.unique=dateTimeFromUnique.ts;}else if(typeof unique==="string"&&unique.length>0){urlParams.unique=unique;}}}
return url(route,urlParams);}
__exports.getDataURLFromFile=getDataURLFromFile;function getDataURLFromFile(file){if(!file){return Promise.reject();}
return new Promise((resolve,reject)=>{const reader=new FileReader();reader.addEventListener("load",()=>{if(reader.result==="data:"){resolve(`data:${file.type};base64,`);}else{resolve(reader.result);}});reader.addEventListener("abort",reject);reader.addEventListener("error",reject);reader.readAsDataURL(file);});}
__exports.redirect=redirect;function redirect(url){const{origin,pathname}=browser.location;const _url=new URL(url,`${origin}${pathname}`);if(_url.origin!==origin){throw new RedirectionError("Can't redirect to another origin");}
browser.location.assign(_url.href);}
__exports.compareUrls=compareUrls;function compareUrls(_url1,_url2){const url1=new URL(_url1);const url2=new URL(_url2);return(url1.origin===url2.origin&&url1.pathname===url2.pathname&&shallowEqual(Object.fromEntries(url1.searchParams),Object.fromEntries(url2.searchParams))&&url1.hash===url2.hash);}
return __exports;});;

/* /web/static/src/core/utils/xml.js */
odoo.define('@web/core/utils/xml',['@web/core/utils/arrays'],function(require){'use strict';let __exports={};const{isIterable}=require("@web/core/utils/arrays");const serializer=new XMLSerializer();const parser=new DOMParser();const xmlDocument=parser.parseFromString("<templates/>","text/xml");function hasParsingError(parsedDocument){return parsedDocument.getElementsByTagName("parsererror").length>0;}
__exports.parseXML=parseXML;function parseXML(str){const xml=parser.parseFromString(str,"text/xml");if(hasParsingError(xml)){throw new Error(`An error occured while parsing ${str}: ${xml.getElementsByTagName("parsererror")}`);}
return xml.documentElement;}
__exports.serializeXML=serializeXML;function serializeXML(xml){return serializer.serializeToString(xml);}
__exports.visitXML=visitXML;function visitXML(xml,callback){const visit=(el)=>{if(el){let didVisitChildren=false;const visitChildren=()=>{for(const child of el.children){visit(child);}
didVisitChildren=true;};const shouldVisitChildren=callback(el,visitChildren);if(shouldVisitChildren!==false&&!didVisitChildren){visitChildren();}}};const xmlDoc=typeof xml==="string"?parseXML(xml):xml;visit(xmlDoc);}
__exports.append=append;function append(parent,node){const nodes=Array.isArray(node)?node:[node];parent.append(...nodes.filter(Boolean));return parent;}
__exports.combineAttributes=combineAttributes;function combineAttributes(el,attr,parts,glue=" "){const allValues=[];if(el.hasAttribute(attr)){allValues.push(el.getAttribute(attr));}
parts=Array.isArray(parts)?parts:[parts];parts=parts.filter((part)=>!!part);allValues.push(...parts);el.setAttribute(attr,allValues.join(glue));}
__exports.createElement=createElement;function createElement(tagName,...args){const el=xmlDocument.createElement(tagName);for(const arg of args){if(!arg){continue;}
if(isIterable(arg)){el.append(...arg);}else if(typeof arg==="object"){for(const name in arg){el.setAttribute(name,arg[name]);}}}
return el;}
__exports.createTextNode=createTextNode;function createTextNode(data){return xmlDocument.createTextNode(data);}
__exports.extractAttributes=extractAttributes;function extractAttributes(el,attributes){const attrs=Object.create(null);for(const attr of attributes){attrs[attr]=el.getAttribute(attr)||"";el.removeAttribute(attr);}
return attrs;}
__exports.getTag=getTag;function getTag(node,lower=false){const tag=(node&&node.nodeName)||"";return lower?tag.toLowerCase():tag;}
__exports.setAttributes=setAttributes;function setAttributes(node,attributes){for(const[name,value]of Object.entries(attributes)){node.setAttribute(name,value);}}
return __exports;});;

/* /web/static/src/core/virtual_grid_hook.js */
odoo.define('@web/core/virtual_grid_hook',['@odoo/owl','@web/core/utils/objects','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{useComponent,useEffect,useExternalListener}=require("@odoo/owl");const{pick,shallowEqual}=require("@web/core/utils/objects");const{useThrottleForAnimation}=require("@web/core/utils/timing");const BUFFER_COEFFICIENT=1;function getIndexes({sizes,start,span,prevStartIndex,bufferCoef=BUFFER_COEFFICIENT}){if(!sizes||!sizes.length){return[];}
if(sizes.at(-1)<span){return[0,sizes.length-1];}
const bufferSize=Math.round(span*bufferCoef);const bufferStart=start-bufferSize;const bufferEnd=start+span+bufferSize;let startIndex=prevStartIndex??0;while(startIndex>0&&sizes[startIndex]>bufferStart){startIndex--;}
while(startIndex<sizes.length-1&&sizes[startIndex]<=bufferStart){startIndex++;}
let endIndex=startIndex;while(endIndex<sizes.length-1&&(sizes[endIndex-1]??0)<bufferEnd){endIndex++;}
while(endIndex>startIndex&&(sizes[endIndex-1]??0)>=bufferEnd){endIndex--;}
return[startIndex,endIndex];}
__exports.useVirtualGrid=useVirtualGrid;function useVirtualGrid({scrollableRef,initialScroll,onChange,bufferCoef}){const comp=useComponent();onChange||=()=>comp.render();const current={scroll:{left:0,top:0,...initialScroll}};const computeColumnsIndexes=()=>{return getIndexes({sizes:current.summedColumnsWidths,start:Math.abs(current.scroll.left),span:window.innerWidth,prevStartIndex:current.columnsIndexes?.[0],bufferCoef,});};const computeRowsIndexes=()=>{return getIndexes({sizes:current.summedRowsHeights,start:current.scroll.top,span:window.innerHeight,prevStartIndex:current.rowsIndexes?.[0],bufferCoef,});};const throttledCompute=useThrottleForAnimation(()=>{const changed=[];const columnsVisibleIndexes=computeColumnsIndexes();if(!shallowEqual(columnsVisibleIndexes,current.columnsIndexes)){current.columnsIndexes=columnsVisibleIndexes;changed.push("columnsIndexes");}
const rowsVisibleIndexes=computeRowsIndexes();if(!shallowEqual(rowsVisibleIndexes,current.rowsIndexes)){current.rowsIndexes=rowsVisibleIndexes;changed.push("rowsIndexes");}
if(changed.length){onChange(pick(current,...changed));}});const scrollListener=(ev)=>{current.scroll.left=ev.target.scrollLeft;current.scroll.top=ev.target.scrollTop;throttledCompute();};useEffect((el)=>{el?.addEventListener("scroll",scrollListener);return()=>el?.removeEventListener("scroll",scrollListener);},()=>[scrollableRef.el]);useExternalListener(window,"resize",()=>throttledCompute());return{get columnsIndexes(){return current.columnsIndexes;},get rowsIndexes(){return current.rowsIndexes;},setColumnsWidths(widths){let acc=0;current.summedColumnsWidths=widths.map((w)=>(acc+=w));delete current.columnsIndexes;current.columnsIndexes=computeColumnsIndexes();},setRowsHeights(heights){let acc=0;current.summedRowsHeights=heights.map((h)=>(acc+=h));delete current.rowsIndexes;current.rowsIndexes=computeRowsIndexes();},};}
return __exports;});;

/* /web/static/src/polyfills/clipboard.js */
odoo.define('@web/polyfills/clipboard',[],function(require){'use strict';let __exports={};class ClipboardItemImpl{constructor(items,options={}){this.items=items;this.options=options;}
get presentationStyle(){return this.options.presentationStyle;}
get types(){return Object.keys(this.items);}
getType(type){return this.items[type];}}
function blobToStr(blob){return new Promise((resolve,reject)=>{const reader=new FileReader();reader.addEventListener("load",()=>{const{result}=reader;if(typeof result==="string"){resolve(result);}else{reject("Cannot read Blob as String");}});reader.addEventListener("error",()=>{reject("Cannot read Blob");});reader.readAsText(blob);});}
async function stringify(item){const strItem={};for(const type of item.types){strItem[type]=await blobToStr(item.getType(type));}
return strItem;}
async function write(items){if(!items[0].getType("text/plain")){throw new Error(`Calling clipboard.write() without a "text/plain" type may result in an empty clipboard on some platforms.`);}
const strItem=await stringify(items[0]);const stubContainer=document.createElement("div");const shadowContainer=stubContainer.attachShadow({mode:"open"});const stub=document.createElement("span");stub.innerText=strItem["text/plain"];shadowContainer.appendChild(stub);document.body.appendChild(stubContainer);const selection=document.getSelection();const range=document.createRange();range.selectNodeContents(stub);selection.removeAllRanges();selection.addRange(range);const onCopy=(ev)=>{for(const type in strItem){ev.clipboardData.setData(type,strItem[type]);}
ev.preventDefault();};document.addEventListener("copy",onCopy);let result;try{result=document.execCommand("copy");}finally{document.removeEventListener("copy",onCopy);}
selection.removeAllRanges();document.body.removeChild(stubContainer);return result;}
if(window.navigator.clipboard){if(!window.navigator.clipboard.write){window.navigator.clipboard.write=write.bind(window);}
if(!window.ClipboardItem){window.ClipboardItem=ClipboardItemImpl;}}
return __exports;});;

/* /web/static/lib/popper/popper.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?factory(exports):typeof define==='function'&&define.amd?define(['exports'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,factory(global.Popper={}));}(this,(function(exports){'use strict';function getWindow(node){if(node==null){return window;}
if(node.toString()!=='[object Window]'){var ownerDocument=node.ownerDocument;return ownerDocument?ownerDocument.defaultView||window:window;}
return node;}
function isElement(node){var OwnElement=getWindow(node).Element;return node instanceof OwnElement||node instanceof Element;}
function isHTMLElement(node){var OwnElement=getWindow(node).HTMLElement;return node instanceof OwnElement||node instanceof HTMLElement;}
function isShadowRoot(node){if(typeof ShadowRoot==='undefined'){return false;}
var OwnElement=getWindow(node).ShadowRoot;return node instanceof OwnElement||node instanceof ShadowRoot;}
var max=Math.max;var min=Math.min;var round=Math.round;function getUAString(){var uaData=navigator.userAgentData;if(uaData!=null&&uaData.brands&&Array.isArray(uaData.brands)){return uaData.brands.map(function(item){return item.brand+"/"+item.version;}).join(' ');}
return navigator.userAgent;}
function isLayoutViewport(){return!/^((?!chrome|android).)*safari/i.test(getUAString());}
function getBoundingClientRect(element,includeScale,isFixedStrategy){if(includeScale===void 0){includeScale=false;}
if(isFixedStrategy===void 0){isFixedStrategy=false;}
var clientRect=element.getBoundingClientRect();var scaleX=1;var scaleY=1;if(includeScale&&isHTMLElement(element)){scaleX=element.offsetWidth>0?round(clientRect.width)/element.offsetWidth||1:1;scaleY=element.offsetHeight>0?round(clientRect.height)/element.offsetHeight||1:1;}
var _ref=isElement(element)?getWindow(element):window,visualViewport=_ref.visualViewport;var addVisualOffsets=!isLayoutViewport()&&isFixedStrategy;var x=(clientRect.left+(addVisualOffsets&&visualViewport?visualViewport.offsetLeft:0))/scaleX;var y=(clientRect.top+(addVisualOffsets&&visualViewport?visualViewport.offsetTop:0))/scaleY;var width=clientRect.width/scaleX;var height=clientRect.height/scaleY;return{width:width,height:height,top:y,right:x+width,bottom:y+height,left:x,x:x,y:y};}
function getWindowScroll(node){var win=getWindow(node);var scrollLeft=win.pageXOffset;var scrollTop=win.pageYOffset;return{scrollLeft:scrollLeft,scrollTop:scrollTop};}
function getHTMLElementScroll(element){return{scrollLeft:element.scrollLeft,scrollTop:element.scrollTop};}
function getNodeScroll(node){if(node===getWindow(node)||!isHTMLElement(node)){return getWindowScroll(node);}else{return getHTMLElementScroll(node);}}
function getNodeName(element){return element?(element.nodeName||'').toLowerCase():null;}
function getDocumentElement(element){return((isElement(element)?element.ownerDocument:element.document)||window.document).documentElement;}
function getWindowScrollBarX(element){return getBoundingClientRect(getDocumentElement(element)).left+getWindowScroll(element).scrollLeft;}
function getComputedStyle(element){return getWindow(element).getComputedStyle(element);}
function isScrollParent(element){var _getComputedStyle=getComputedStyle(element),overflow=_getComputedStyle.overflow,overflowX=_getComputedStyle.overflowX,overflowY=_getComputedStyle.overflowY;return/auto|scroll|overlay|hidden/.test(overflow+overflowY+overflowX);}
function isElementScaled(element){var rect=element.getBoundingClientRect();var scaleX=round(rect.width)/element.offsetWidth||1;var scaleY=round(rect.height)/element.offsetHeight||1;return scaleX!==1||scaleY!==1;}
function getCompositeRect(elementOrVirtualElement,offsetParent,isFixed){if(isFixed===void 0){isFixed=false;}
var isOffsetParentAnElement=isHTMLElement(offsetParent);var offsetParentIsScaled=isHTMLElement(offsetParent)&&isElementScaled(offsetParent);var documentElement=getDocumentElement(offsetParent);var rect=getBoundingClientRect(elementOrVirtualElement,offsetParentIsScaled,isFixed);var scroll={scrollLeft:0,scrollTop:0};var offsets={x:0,y:0};if(isOffsetParentAnElement||!isOffsetParentAnElement&&!isFixed){if(getNodeName(offsetParent)!=='body'||isScrollParent(documentElement)){scroll=getNodeScroll(offsetParent);}
if(isHTMLElement(offsetParent)){offsets=getBoundingClientRect(offsetParent,true);offsets.x+=offsetParent.clientLeft;offsets.y+=offsetParent.clientTop;}else if(documentElement){offsets.x=getWindowScrollBarX(documentElement);}}
return{x:rect.left+scroll.scrollLeft-offsets.x,y:rect.top+scroll.scrollTop-offsets.y,width:rect.width,height:rect.height};}
function getLayoutRect(element){var clientRect=getBoundingClientRect(element);var width=element.offsetWidth;var height=element.offsetHeight;if(Math.abs(clientRect.width-width)<=1){width=clientRect.width;}
if(Math.abs(clientRect.height-height)<=1){height=clientRect.height;}
return{x:element.offsetLeft,y:element.offsetTop,width:width,height:height};}
function getParentNode(element){if(getNodeName(element)==='html'){return element;}
return(element.assignedSlot||element.parentNode||(isShadowRoot(element)?element.host:null)||getDocumentElement(element));}
function getScrollParent(node){if(['html','body','#document'].indexOf(getNodeName(node))>=0){return node.ownerDocument.body;}
if(isHTMLElement(node)&&isScrollParent(node)){return node;}
return getScrollParent(getParentNode(node));}
function listScrollParents(element,list){var _element$ownerDocumen;if(list===void 0){list=[];}
var scrollParent=getScrollParent(element);var isBody=scrollParent===((_element$ownerDocumen=element.ownerDocument)==null?void 0:_element$ownerDocumen.body);var win=getWindow(scrollParent);var target=isBody?[win].concat(win.visualViewport||[],isScrollParent(scrollParent)?scrollParent:[]):scrollParent;var updatedList=list.concat(target);return isBody?updatedList:updatedList.concat(listScrollParents(getParentNode(target)));}
function isTableElement(element){return['table','td','th'].indexOf(getNodeName(element))>=0;}
function getTrueOffsetParent(element){if(!isHTMLElement(element)||getComputedStyle(element).position==='fixed'){return null;}
return element.offsetParent;}
function getContainingBlock(element){var isFirefox=/firefox/i.test(getUAString());var isIE=/Trident/i.test(getUAString());if(isIE&&isHTMLElement(element)){var elementCss=getComputedStyle(element);if(elementCss.position==='fixed'){return null;}}
var currentNode=getParentNode(element);if(isShadowRoot(currentNode)){currentNode=currentNode.host;}
while(isHTMLElement(currentNode)&&['html','body'].indexOf(getNodeName(currentNode))<0){var css=getComputedStyle(currentNode);if(css.transform!=='none'||css.perspective!=='none'||css.contain==='paint'||['transform','perspective'].indexOf(css.willChange)!==-1||isFirefox&&css.willChange==='filter'||isFirefox&&css.filter&&css.filter!=='none'){return currentNode;}else{currentNode=currentNode.parentNode;}}
return null;}
function getOffsetParent(element){var window=getWindow(element);var offsetParent=getTrueOffsetParent(element);while(offsetParent&&isTableElement(offsetParent)&&getComputedStyle(offsetParent).position==='static'){offsetParent=getTrueOffsetParent(offsetParent);}
if(offsetParent&&(getNodeName(offsetParent)==='html'||getNodeName(offsetParent)==='body'&&getComputedStyle(offsetParent).position==='static')){return window;}
return offsetParent||getContainingBlock(element)||window;}
var top='top';var bottom='bottom';var right='right';var left='left';var auto='auto';var basePlacements=[top,bottom,right,left];var start='start';var end='end';var clippingParents='clippingParents';var viewport='viewport';var popper='popper';var reference='reference';var variationPlacements=basePlacements.reduce(function(acc,placement){return acc.concat([placement+"-"+start,placement+"-"+end]);},[]);var placements=[].concat(basePlacements,[auto]).reduce(function(acc,placement){return acc.concat([placement,placement+"-"+start,placement+"-"+end]);},[]);var beforeRead='beforeRead';var read='read';var afterRead='afterRead';var beforeMain='beforeMain';var main='main';var afterMain='afterMain';var beforeWrite='beforeWrite';var write='write';var afterWrite='afterWrite';var modifierPhases=[beforeRead,read,afterRead,beforeMain,main,afterMain,beforeWrite,write,afterWrite];function order(modifiers){var map=new Map();var visited=new Set();var result=[];modifiers.forEach(function(modifier){map.set(modifier.name,modifier);});function sort(modifier){visited.add(modifier.name);var requires=[].concat(modifier.requires||[],modifier.requiresIfExists||[]);requires.forEach(function(dep){if(!visited.has(dep)){var depModifier=map.get(dep);if(depModifier){sort(depModifier);}}});result.push(modifier);}
modifiers.forEach(function(modifier){if(!visited.has(modifier.name)){sort(modifier);}});return result;}
function orderModifiers(modifiers){var orderedModifiers=order(modifiers);return modifierPhases.reduce(function(acc,phase){return acc.concat(orderedModifiers.filter(function(modifier){return modifier.phase===phase;}));},[]);}
function debounce(fn){var pending;return function(){if(!pending){pending=new Promise(function(resolve){Promise.resolve().then(function(){pending=undefined;resolve(fn());});});}
return pending;};}
function mergeByName(modifiers){var merged=modifiers.reduce(function(merged,current){var existing=merged[current.name];merged[current.name]=existing?Object.assign({},existing,current,{options:Object.assign({},existing.options,current.options),data:Object.assign({},existing.data,current.data)}):current;return merged;},{});return Object.keys(merged).map(function(key){return merged[key];});}
function getViewportRect(element,strategy){var win=getWindow(element);var html=getDocumentElement(element);var visualViewport=win.visualViewport;var width=html.clientWidth;var height=html.clientHeight;var x=0;var y=0;if(visualViewport){width=visualViewport.width;height=visualViewport.height;var layoutViewport=isLayoutViewport();if(layoutViewport||!layoutViewport&&strategy==='fixed'){x=visualViewport.offsetLeft;y=visualViewport.offsetTop;}}
return{width:width,height:height,x:x+getWindowScrollBarX(element),y:y};}
function getDocumentRect(element){var _element$ownerDocumen;var html=getDocumentElement(element);var winScroll=getWindowScroll(element);var body=(_element$ownerDocumen=element.ownerDocument)==null?void 0:_element$ownerDocumen.body;var width=max(html.scrollWidth,html.clientWidth,body?body.scrollWidth:0,body?body.clientWidth:0);var height=max(html.scrollHeight,html.clientHeight,body?body.scrollHeight:0,body?body.clientHeight:0);var x=-winScroll.scrollLeft+getWindowScrollBarX(element);var y=-winScroll.scrollTop;if(getComputedStyle(body||html).direction==='rtl'){x+=max(html.clientWidth,body?body.clientWidth:0)-width;}
return{width:width,height:height,x:x,y:y};}
function contains(parent,child){var rootNode=child.getRootNode&&child.getRootNode();if(parent.contains(child)){return true;}
else if(rootNode&&isShadowRoot(rootNode)){var next=child;do{if(next&&parent.isSameNode(next)){return true;}
next=next.parentNode||next.host;}while(next);}
return false;}
function rectToClientRect(rect){return Object.assign({},rect,{left:rect.x,top:rect.y,right:rect.x+rect.width,bottom:rect.y+rect.height});}
function getInnerBoundingClientRect(element,strategy){var rect=getBoundingClientRect(element,false,strategy==='fixed');rect.top=rect.top+element.clientTop;rect.left=rect.left+element.clientLeft;rect.bottom=rect.top+element.clientHeight;rect.right=rect.left+element.clientWidth;rect.width=element.clientWidth;rect.height=element.clientHeight;rect.x=rect.left;rect.y=rect.top;return rect;}
function getClientRectFromMixedType(element,clippingParent,strategy){return clippingParent===viewport?rectToClientRect(getViewportRect(element,strategy)):isElement(clippingParent)?getInnerBoundingClientRect(clippingParent,strategy):rectToClientRect(getDocumentRect(getDocumentElement(element)));}
function getClippingParents(element){var clippingParents=listScrollParents(getParentNode(element));var canEscapeClipping=['absolute','fixed'].indexOf(getComputedStyle(element).position)>=0;var clipperElement=canEscapeClipping&&isHTMLElement(element)?getOffsetParent(element):element;if(!isElement(clipperElement)){return[];}
return clippingParents.filter(function(clippingParent){return isElement(clippingParent)&&contains(clippingParent,clipperElement)&&getNodeName(clippingParent)!=='body';});}
function getClippingRect(element,boundary,rootBoundary,strategy){var mainClippingParents=boundary==='clippingParents'?getClippingParents(element):[].concat(boundary);var clippingParents=[].concat(mainClippingParents,[rootBoundary]);var firstClippingParent=clippingParents[0];var clippingRect=clippingParents.reduce(function(accRect,clippingParent){var rect=getClientRectFromMixedType(element,clippingParent,strategy);accRect.top=max(rect.top,accRect.top);accRect.right=min(rect.right,accRect.right);accRect.bottom=min(rect.bottom,accRect.bottom);accRect.left=max(rect.left,accRect.left);return accRect;},getClientRectFromMixedType(element,firstClippingParent,strategy));clippingRect.width=clippingRect.right-clippingRect.left;clippingRect.height=clippingRect.bottom-clippingRect.top;clippingRect.x=clippingRect.left;clippingRect.y=clippingRect.top;return clippingRect;}
function getBasePlacement(placement){return placement.split('-')[0];}
function getVariation(placement){return placement.split('-')[1];}
function getMainAxisFromPlacement(placement){return['top','bottom'].indexOf(placement)>=0?'x':'y';}
function computeOffsets(_ref){var reference=_ref.reference,element=_ref.element,placement=_ref.placement;var basePlacement=placement?getBasePlacement(placement):null;var variation=placement?getVariation(placement):null;var commonX=reference.x+reference.width/2-element.width/2;var commonY=reference.y+reference.height/2-element.height/2;var offsets;switch(basePlacement){case top:offsets={x:commonX,y:reference.y-element.height};break;case bottom:offsets={x:commonX,y:reference.y+reference.height};break;case right:offsets={x:reference.x+reference.width,y:commonY};break;case left:offsets={x:reference.x-element.width,y:commonY};break;default:offsets={x:reference.x,y:reference.y};}
var mainAxis=basePlacement?getMainAxisFromPlacement(basePlacement):null;if(mainAxis!=null){var len=mainAxis==='y'?'height':'width';switch(variation){case start:offsets[mainAxis]=offsets[mainAxis]-(reference[len]/2-element[len]/2);break;case end:offsets[mainAxis]=offsets[mainAxis]+(reference[len]/2-element[len]/2);break;}}
return offsets;}
function getFreshSideObject(){return{top:0,right:0,bottom:0,left:0};}
function mergePaddingObject(paddingObject){return Object.assign({},getFreshSideObject(),paddingObject);}
function expandToHashMap(value,keys){return keys.reduce(function(hashMap,key){hashMap[key]=value;return hashMap;},{});}
function detectOverflow(state,options){if(options===void 0){options={};}
var _options=options,_options$placement=_options.placement,placement=_options$placement===void 0?state.placement:_options$placement,_options$strategy=_options.strategy,strategy=_options$strategy===void 0?state.strategy:_options$strategy,_options$boundary=_options.boundary,boundary=_options$boundary===void 0?clippingParents:_options$boundary,_options$rootBoundary=_options.rootBoundary,rootBoundary=_options$rootBoundary===void 0?viewport:_options$rootBoundary,_options$elementConte=_options.elementContext,elementContext=_options$elementConte===void 0?popper:_options$elementConte,_options$altBoundary=_options.altBoundary,altBoundary=_options$altBoundary===void 0?false:_options$altBoundary,_options$padding=_options.padding,padding=_options$padding===void 0?0:_options$padding;var paddingObject=mergePaddingObject(typeof padding!=='number'?padding:expandToHashMap(padding,basePlacements));var altContext=elementContext===popper?reference:popper;var popperRect=state.rects.popper;var element=state.elements[altBoundary?altContext:elementContext];var clippingClientRect=getClippingRect(isElement(element)?element:element.contextElement||getDocumentElement(state.elements.popper),boundary,rootBoundary,strategy);var referenceClientRect=getBoundingClientRect(state.elements.reference);var popperOffsets=computeOffsets({reference:referenceClientRect,element:popperRect,strategy:'absolute',placement:placement});var popperClientRect=rectToClientRect(Object.assign({},popperRect,popperOffsets));var elementClientRect=elementContext===popper?popperClientRect:referenceClientRect;var overflowOffsets={top:clippingClientRect.top-elementClientRect.top+paddingObject.top,bottom:elementClientRect.bottom-clippingClientRect.bottom+paddingObject.bottom,left:clippingClientRect.left-elementClientRect.left+paddingObject.left,right:elementClientRect.right-clippingClientRect.right+paddingObject.right};var offsetData=state.modifiersData.offset;if(elementContext===popper&&offsetData){var offset=offsetData[placement];Object.keys(overflowOffsets).forEach(function(key){var multiply=[right,bottom].indexOf(key)>=0?1:-1;var axis=[top,bottom].indexOf(key)>=0?'y':'x';overflowOffsets[key]+=offset[axis]*multiply;});}
return overflowOffsets;}
var DEFAULT_OPTIONS={placement:'bottom',modifiers:[],strategy:'absolute'};function areValidElements(){for(var _len=arguments.length,args=new Array(_len),_key=0;_key<_len;_key++){args[_key]=arguments[_key];}
return!args.some(function(element){return!(element&&typeof element.getBoundingClientRect==='function');});}
function popperGenerator(generatorOptions){if(generatorOptions===void 0){generatorOptions={};}
var _generatorOptions=generatorOptions,_generatorOptions$def=_generatorOptions.defaultModifiers,defaultModifiers=_generatorOptions$def===void 0?[]:_generatorOptions$def,_generatorOptions$def2=_generatorOptions.defaultOptions,defaultOptions=_generatorOptions$def2===void 0?DEFAULT_OPTIONS:_generatorOptions$def2;return function createPopper(reference,popper,options){if(options===void 0){options=defaultOptions;}
var state={placement:'bottom',orderedModifiers:[],options:Object.assign({},DEFAULT_OPTIONS,defaultOptions),modifiersData:{},elements:{reference:reference,popper:popper},attributes:{},styles:{}};var effectCleanupFns=[];var isDestroyed=false;var instance={state:state,setOptions:function setOptions(setOptionsAction){var options=typeof setOptionsAction==='function'?setOptionsAction(state.options):setOptionsAction;cleanupModifierEffects();state.options=Object.assign({},defaultOptions,state.options,options);state.scrollParents={reference:isElement(reference)?listScrollParents(reference):reference.contextElement?listScrollParents(reference.contextElement):[],popper:listScrollParents(popper)};var orderedModifiers=orderModifiers(mergeByName([].concat(defaultModifiers,state.options.modifiers)));state.orderedModifiers=orderedModifiers.filter(function(m){return m.enabled;});runModifierEffects();return instance.update();},forceUpdate:function forceUpdate(){if(isDestroyed){return;}
var _state$elements=state.elements,reference=_state$elements.reference,popper=_state$elements.popper;if(!areValidElements(reference,popper)){return;}
state.rects={reference:getCompositeRect(reference,getOffsetParent(popper),state.options.strategy==='fixed'),popper:getLayoutRect(popper)};state.reset=false;state.placement=state.options.placement;state.orderedModifiers.forEach(function(modifier){return state.modifiersData[modifier.name]=Object.assign({},modifier.data);});for(var index=0;index<state.orderedModifiers.length;index++){if(state.reset===true){state.reset=false;index=-1;continue;}
var _state$orderedModifie=state.orderedModifiers[index],fn=_state$orderedModifie.fn,_state$orderedModifie2=_state$orderedModifie.options,_options=_state$orderedModifie2===void 0?{}:_state$orderedModifie2,name=_state$orderedModifie.name;if(typeof fn==='function'){state=fn({state:state,options:_options,name:name,instance:instance})||state;}}},update:debounce(function(){return new Promise(function(resolve){instance.forceUpdate();resolve(state);});}),destroy:function destroy(){cleanupModifierEffects();isDestroyed=true;}};if(!areValidElements(reference,popper)){return instance;}
instance.setOptions(options).then(function(state){if(!isDestroyed&&options.onFirstUpdate){options.onFirstUpdate(state);}});function runModifierEffects(){state.orderedModifiers.forEach(function(_ref){var name=_ref.name,_ref$options=_ref.options,options=_ref$options===void 0?{}:_ref$options,effect=_ref.effect;if(typeof effect==='function'){var cleanupFn=effect({state:state,name:name,instance:instance,options:options});var noopFn=function noopFn(){};effectCleanupFns.push(cleanupFn||noopFn);}});}
function cleanupModifierEffects(){effectCleanupFns.forEach(function(fn){return fn();});effectCleanupFns=[];}
return instance;};}
var passive={passive:true};function effect$2(_ref){var state=_ref.state,instance=_ref.instance,options=_ref.options;var _options$scroll=options.scroll,scroll=_options$scroll===void 0?true:_options$scroll,_options$resize=options.resize,resize=_options$resize===void 0?true:_options$resize;var window=getWindow(state.elements.popper);var scrollParents=[].concat(state.scrollParents.reference,state.scrollParents.popper);if(scroll){scrollParents.forEach(function(scrollParent){scrollParent.addEventListener('scroll',instance.update,passive);});}
if(resize){window.addEventListener('resize',instance.update,passive);}
return function(){if(scroll){scrollParents.forEach(function(scrollParent){scrollParent.removeEventListener('scroll',instance.update,passive);});}
if(resize){window.removeEventListener('resize',instance.update,passive);}};}
var eventListeners={name:'eventListeners',enabled:true,phase:'write',fn:function fn(){},effect:effect$2,data:{}};function popperOffsets(_ref){var state=_ref.state,name=_ref.name;state.modifiersData[name]=computeOffsets({reference:state.rects.reference,element:state.rects.popper,strategy:'absolute',placement:state.placement});}
var popperOffsets$1={name:'popperOffsets',enabled:true,phase:'read',fn:popperOffsets,data:{}};var unsetSides={top:'auto',right:'auto',bottom:'auto',left:'auto'};function roundOffsetsByDPR(_ref,win){var x=_ref.x,y=_ref.y;var dpr=win.devicePixelRatio||1;return{x:round(x*dpr)/dpr||0,y:round(y*dpr)/dpr||0};}
function mapToStyles(_ref2){var _Object$assign2;var popper=_ref2.popper,popperRect=_ref2.popperRect,placement=_ref2.placement,variation=_ref2.variation,offsets=_ref2.offsets,position=_ref2.position,gpuAcceleration=_ref2.gpuAcceleration,adaptive=_ref2.adaptive,roundOffsets=_ref2.roundOffsets,isFixed=_ref2.isFixed;var _offsets$x=offsets.x,x=_offsets$x===void 0?0:_offsets$x,_offsets$y=offsets.y,y=_offsets$y===void 0?0:_offsets$y;var _ref3=typeof roundOffsets==='function'?roundOffsets({x:x,y:y}):{x:x,y:y};x=_ref3.x;y=_ref3.y;var hasX=offsets.hasOwnProperty('x');var hasY=offsets.hasOwnProperty('y');var sideX=left;var sideY=top;var win=window;if(adaptive){var offsetParent=getOffsetParent(popper);var heightProp='clientHeight';var widthProp='clientWidth';if(offsetParent===getWindow(popper)){offsetParent=getDocumentElement(popper);if(getComputedStyle(offsetParent).position!=='static'&&position==='absolute'){heightProp='scrollHeight';widthProp='scrollWidth';}}
offsetParent=offsetParent;if(placement===top||(placement===left||placement===right)&&variation===end){sideY=bottom;var offsetY=isFixed&&offsetParent===win&&win.visualViewport?win.visualViewport.height:offsetParent[heightProp];y-=offsetY-popperRect.height;y*=gpuAcceleration?1:-1;}
if(placement===left||(placement===top||placement===bottom)&&variation===end){sideX=right;var offsetX=isFixed&&offsetParent===win&&win.visualViewport?win.visualViewport.width:offsetParent[widthProp];x-=offsetX-popperRect.width;x*=gpuAcceleration?1:-1;}}
var commonStyles=Object.assign({position:position},adaptive&&unsetSides);var _ref4=roundOffsets===true?roundOffsetsByDPR({x:x,y:y},getWindow(popper)):{x:x,y:y};x=_ref4.x;y=_ref4.y;if(gpuAcceleration){var _Object$assign;return Object.assign({},commonStyles,(_Object$assign={},_Object$assign[sideY]=hasY?'0':'',_Object$assign[sideX]=hasX?'0':'',_Object$assign.transform=(win.devicePixelRatio||1)<=1?"translate("+x+"px, "+y+"px)":"translate3d("+x+"px, "+y+"px, 0)",_Object$assign));}
return Object.assign({},commonStyles,(_Object$assign2={},_Object$assign2[sideY]=hasY?y+"px":'',_Object$assign2[sideX]=hasX?x+"px":'',_Object$assign2.transform='',_Object$assign2));}
function computeStyles(_ref5){var state=_ref5.state,options=_ref5.options;var _options$gpuAccelerat=options.gpuAcceleration,gpuAcceleration=_options$gpuAccelerat===void 0?true:_options$gpuAccelerat,_options$adaptive=options.adaptive,adaptive=_options$adaptive===void 0?true:_options$adaptive,_options$roundOffsets=options.roundOffsets,roundOffsets=_options$roundOffsets===void 0?true:_options$roundOffsets;var commonStyles={placement:getBasePlacement(state.placement),variation:getVariation(state.placement),popper:state.elements.popper,popperRect:state.rects.popper,gpuAcceleration:gpuAcceleration,isFixed:state.options.strategy==='fixed'};if(state.modifiersData.popperOffsets!=null){state.styles.popper=Object.assign({},state.styles.popper,mapToStyles(Object.assign({},commonStyles,{offsets:state.modifiersData.popperOffsets,position:state.options.strategy,adaptive:adaptive,roundOffsets:roundOffsets})));}
if(state.modifiersData.arrow!=null){state.styles.arrow=Object.assign({},state.styles.arrow,mapToStyles(Object.assign({},commonStyles,{offsets:state.modifiersData.arrow,position:'absolute',adaptive:false,roundOffsets:roundOffsets})));}
state.attributes.popper=Object.assign({},state.attributes.popper,{'data-popper-placement':state.placement});}
var computeStyles$1={name:'computeStyles',enabled:true,phase:'beforeWrite',fn:computeStyles,data:{}};function applyStyles(_ref){var state=_ref.state;Object.keys(state.elements).forEach(function(name){var style=state.styles[name]||{};var attributes=state.attributes[name]||{};var element=state.elements[name];if(!isHTMLElement(element)||!getNodeName(element)){return;}
Object.assign(element.style,style);Object.keys(attributes).forEach(function(name){var value=attributes[name];if(value===false){element.removeAttribute(name);}else{element.setAttribute(name,value===true?'':value);}});});}
function effect$1(_ref2){var state=_ref2.state;var initialStyles={popper:{position:state.options.strategy,left:'0',top:'0',margin:'0'},arrow:{position:'absolute'},reference:{}};Object.assign(state.elements.popper.style,initialStyles.popper);state.styles=initialStyles;if(state.elements.arrow){Object.assign(state.elements.arrow.style,initialStyles.arrow);}
return function(){Object.keys(state.elements).forEach(function(name){var element=state.elements[name];var attributes=state.attributes[name]||{};var styleProperties=Object.keys(state.styles.hasOwnProperty(name)?state.styles[name]:initialStyles[name]);var style=styleProperties.reduce(function(style,property){style[property]='';return style;},{});if(!isHTMLElement(element)||!getNodeName(element)){return;}
Object.assign(element.style,style);Object.keys(attributes).forEach(function(attribute){element.removeAttribute(attribute);});});};}
var applyStyles$1={name:'applyStyles',enabled:true,phase:'write',fn:applyStyles,effect:effect$1,requires:['computeStyles']};function distanceAndSkiddingToXY(placement,rects,offset){var basePlacement=getBasePlacement(placement);var invertDistance=[left,top].indexOf(basePlacement)>=0?-1:1;var _ref=typeof offset==='function'?offset(Object.assign({},rects,{placement:placement})):offset,skidding=_ref[0],distance=_ref[1];skidding=skidding||0;distance=(distance||0)*invertDistance;return[left,right].indexOf(basePlacement)>=0?{x:distance,y:skidding}:{x:skidding,y:distance};}
function offset(_ref2){var state=_ref2.state,options=_ref2.options,name=_ref2.name;var _options$offset=options.offset,offset=_options$offset===void 0?[0,0]:_options$offset;var data=placements.reduce(function(acc,placement){acc[placement]=distanceAndSkiddingToXY(placement,state.rects,offset);return acc;},{});var _data$state$placement=data[state.placement],x=_data$state$placement.x,y=_data$state$placement.y;if(state.modifiersData.popperOffsets!=null){state.modifiersData.popperOffsets.x+=x;state.modifiersData.popperOffsets.y+=y;}
state.modifiersData[name]=data;}
var offset$1={name:'offset',enabled:true,phase:'main',requires:['popperOffsets'],fn:offset};var hash$1={left:'right',right:'left',bottom:'top',top:'bottom'};function getOppositePlacement(placement){return placement.replace(/left|right|bottom|top/g,function(matched){return hash$1[matched];});}
var hash={start:'end',end:'start'};function getOppositeVariationPlacement(placement){return placement.replace(/start|end/g,function(matched){return hash[matched];});}
function computeAutoPlacement(state,options){if(options===void 0){options={};}
var _options=options,placement=_options.placement,boundary=_options.boundary,rootBoundary=_options.rootBoundary,padding=_options.padding,flipVariations=_options.flipVariations,_options$allowedAutoP=_options.allowedAutoPlacements,allowedAutoPlacements=_options$allowedAutoP===void 0?placements:_options$allowedAutoP;var variation=getVariation(placement);var placements$1=variation?flipVariations?variationPlacements:variationPlacements.filter(function(placement){return getVariation(placement)===variation;}):basePlacements;var allowedPlacements=placements$1.filter(function(placement){return allowedAutoPlacements.indexOf(placement)>=0;});if(allowedPlacements.length===0){allowedPlacements=placements$1;}
var overflows=allowedPlacements.reduce(function(acc,placement){acc[placement]=detectOverflow(state,{placement:placement,boundary:boundary,rootBoundary:rootBoundary,padding:padding})[getBasePlacement(placement)];return acc;},{});return Object.keys(overflows).sort(function(a,b){return overflows[a]-overflows[b];});}
function getExpandedFallbackPlacements(placement){if(getBasePlacement(placement)===auto){return[];}
var oppositePlacement=getOppositePlacement(placement);return[getOppositeVariationPlacement(placement),oppositePlacement,getOppositeVariationPlacement(oppositePlacement)];}
function flip(_ref){var state=_ref.state,options=_ref.options,name=_ref.name;if(state.modifiersData[name]._skip){return;}
var _options$mainAxis=options.mainAxis,checkMainAxis=_options$mainAxis===void 0?true:_options$mainAxis,_options$altAxis=options.altAxis,checkAltAxis=_options$altAxis===void 0?true:_options$altAxis,specifiedFallbackPlacements=options.fallbackPlacements,padding=options.padding,boundary=options.boundary,rootBoundary=options.rootBoundary,altBoundary=options.altBoundary,_options$flipVariatio=options.flipVariations,flipVariations=_options$flipVariatio===void 0?true:_options$flipVariatio,allowedAutoPlacements=options.allowedAutoPlacements;var preferredPlacement=state.options.placement;var basePlacement=getBasePlacement(preferredPlacement);var isBasePlacement=basePlacement===preferredPlacement;var fallbackPlacements=specifiedFallbackPlacements||(isBasePlacement||!flipVariations?[getOppositePlacement(preferredPlacement)]:getExpandedFallbackPlacements(preferredPlacement));var placements=[preferredPlacement].concat(fallbackPlacements).reduce(function(acc,placement){return acc.concat(getBasePlacement(placement)===auto?computeAutoPlacement(state,{placement:placement,boundary:boundary,rootBoundary:rootBoundary,padding:padding,flipVariations:flipVariations,allowedAutoPlacements:allowedAutoPlacements}):placement);},[]);var referenceRect=state.rects.reference;var popperRect=state.rects.popper;var checksMap=new Map();var makeFallbackChecks=true;var firstFittingPlacement=placements[0];for(var i=0;i<placements.length;i++){var placement=placements[i];var _basePlacement=getBasePlacement(placement);var isStartVariation=getVariation(placement)===start;var isVertical=[top,bottom].indexOf(_basePlacement)>=0;var len=isVertical?'width':'height';var overflow=detectOverflow(state,{placement:placement,boundary:boundary,rootBoundary:rootBoundary,altBoundary:altBoundary,padding:padding});var mainVariationSide=isVertical?isStartVariation?right:left:isStartVariation?bottom:top;if(referenceRect[len]>popperRect[len]){mainVariationSide=getOppositePlacement(mainVariationSide);}
var altVariationSide=getOppositePlacement(mainVariationSide);var checks=[];if(checkMainAxis){checks.push(overflow[_basePlacement]<=0);}
if(checkAltAxis){checks.push(overflow[mainVariationSide]<=0,overflow[altVariationSide]<=0);}
if(checks.every(function(check){return check;})){firstFittingPlacement=placement;makeFallbackChecks=false;break;}
checksMap.set(placement,checks);}
if(makeFallbackChecks){var numberOfChecks=flipVariations?3:1;var _loop=function _loop(_i){var fittingPlacement=placements.find(function(placement){var checks=checksMap.get(placement);if(checks){return checks.slice(0,_i).every(function(check){return check;});}});if(fittingPlacement){firstFittingPlacement=fittingPlacement;return"break";}};for(var _i=numberOfChecks;_i>0;_i--){var _ret=_loop(_i);if(_ret==="break")break;}}
if(state.placement!==firstFittingPlacement){state.modifiersData[name]._skip=true;state.placement=firstFittingPlacement;state.reset=true;}}
var flip$1={name:'flip',enabled:true,phase:'main',fn:flip,requiresIfExists:['offset'],data:{_skip:false}};function getAltAxis(axis){return axis==='x'?'y':'x';}
function within(min$1,value,max$1){return max(min$1,min(value,max$1));}
function withinMaxClamp(min,value,max){var v=within(min,value,max);return v>max?max:v;}
function preventOverflow(_ref){var state=_ref.state,options=_ref.options,name=_ref.name;var _options$mainAxis=options.mainAxis,checkMainAxis=_options$mainAxis===void 0?true:_options$mainAxis,_options$altAxis=options.altAxis,checkAltAxis=_options$altAxis===void 0?false:_options$altAxis,boundary=options.boundary,rootBoundary=options.rootBoundary,altBoundary=options.altBoundary,padding=options.padding,_options$tether=options.tether,tether=_options$tether===void 0?true:_options$tether,_options$tetherOffset=options.tetherOffset,tetherOffset=_options$tetherOffset===void 0?0:_options$tetherOffset;var overflow=detectOverflow(state,{boundary:boundary,rootBoundary:rootBoundary,padding:padding,altBoundary:altBoundary});var basePlacement=getBasePlacement(state.placement);var variation=getVariation(state.placement);var isBasePlacement=!variation;var mainAxis=getMainAxisFromPlacement(basePlacement);var altAxis=getAltAxis(mainAxis);var popperOffsets=state.modifiersData.popperOffsets;var referenceRect=state.rects.reference;var popperRect=state.rects.popper;var tetherOffsetValue=typeof tetherOffset==='function'?tetherOffset(Object.assign({},state.rects,{placement:state.placement})):tetherOffset;var normalizedTetherOffsetValue=typeof tetherOffsetValue==='number'?{mainAxis:tetherOffsetValue,altAxis:tetherOffsetValue}:Object.assign({mainAxis:0,altAxis:0},tetherOffsetValue);var offsetModifierState=state.modifiersData.offset?state.modifiersData.offset[state.placement]:null;var data={x:0,y:0};if(!popperOffsets){return;}
if(checkMainAxis){var _offsetModifierState$;var mainSide=mainAxis==='y'?top:left;var altSide=mainAxis==='y'?bottom:right;var len=mainAxis==='y'?'height':'width';var offset=popperOffsets[mainAxis];var min$1=offset+overflow[mainSide];var max$1=offset-overflow[altSide];var additive=tether?-popperRect[len]/2:0;var minLen=variation===start?referenceRect[len]:popperRect[len];var maxLen=variation===start?-popperRect[len]:-referenceRect[len];var arrowElement=state.elements.arrow;var arrowRect=tether&&arrowElement?getLayoutRect(arrowElement):{width:0,height:0};var arrowPaddingObject=state.modifiersData['arrow#persistent']?state.modifiersData['arrow#persistent'].padding:getFreshSideObject();var arrowPaddingMin=arrowPaddingObject[mainSide];var arrowPaddingMax=arrowPaddingObject[altSide];var arrowLen=within(0,referenceRect[len],arrowRect[len]);var minOffset=isBasePlacement?referenceRect[len]/2-additive-arrowLen-arrowPaddingMin-normalizedTetherOffsetValue.mainAxis:minLen-arrowLen-arrowPaddingMin-normalizedTetherOffsetValue.mainAxis;var maxOffset=isBasePlacement?-referenceRect[len]/2+additive+arrowLen+arrowPaddingMax+normalizedTetherOffsetValue.mainAxis:maxLen+arrowLen+arrowPaddingMax+normalizedTetherOffsetValue.mainAxis;var arrowOffsetParent=state.elements.arrow&&getOffsetParent(state.elements.arrow);var clientOffset=arrowOffsetParent?mainAxis==='y'?arrowOffsetParent.clientTop||0:arrowOffsetParent.clientLeft||0:0;var offsetModifierValue=(_offsetModifierState$=offsetModifierState==null?void 0:offsetModifierState[mainAxis])!=null?_offsetModifierState$:0;var tetherMin=offset+minOffset-offsetModifierValue-clientOffset;var tetherMax=offset+maxOffset-offsetModifierValue;var preventedOffset=within(tether?min(min$1,tetherMin):min$1,offset,tether?max(max$1,tetherMax):max$1);popperOffsets[mainAxis]=preventedOffset;data[mainAxis]=preventedOffset-offset;}
if(checkAltAxis){var _offsetModifierState$2;var _mainSide=mainAxis==='x'?top:left;var _altSide=mainAxis==='x'?bottom:right;var _offset=popperOffsets[altAxis];var _len=altAxis==='y'?'height':'width';var _min=_offset+overflow[_mainSide];var _max=_offset-overflow[_altSide];var isOriginSide=[top,left].indexOf(basePlacement)!==-1;var _offsetModifierValue=(_offsetModifierState$2=offsetModifierState==null?void 0:offsetModifierState[altAxis])!=null?_offsetModifierState$2:0;var _tetherMin=isOriginSide?_min:_offset-referenceRect[_len]-popperRect[_len]-_offsetModifierValue+normalizedTetherOffsetValue.altAxis;var _tetherMax=isOriginSide?_offset+referenceRect[_len]+popperRect[_len]-_offsetModifierValue-normalizedTetherOffsetValue.altAxis:_max;var _preventedOffset=tether&&isOriginSide?withinMaxClamp(_tetherMin,_offset,_tetherMax):within(tether?_tetherMin:_min,_offset,tether?_tetherMax:_max);popperOffsets[altAxis]=_preventedOffset;data[altAxis]=_preventedOffset-_offset;}
state.modifiersData[name]=data;}
var preventOverflow$1={name:'preventOverflow',enabled:true,phase:'main',fn:preventOverflow,requiresIfExists:['offset']};var toPaddingObject=function toPaddingObject(padding,state){padding=typeof padding==='function'?padding(Object.assign({},state.rects,{placement:state.placement})):padding;return mergePaddingObject(typeof padding!=='number'?padding:expandToHashMap(padding,basePlacements));};function arrow(_ref){var _state$modifiersData$;var state=_ref.state,name=_ref.name,options=_ref.options;var arrowElement=state.elements.arrow;var popperOffsets=state.modifiersData.popperOffsets;var basePlacement=getBasePlacement(state.placement);var axis=getMainAxisFromPlacement(basePlacement);var isVertical=[left,right].indexOf(basePlacement)>=0;var len=isVertical?'height':'width';if(!arrowElement||!popperOffsets){return;}
var paddingObject=toPaddingObject(options.padding,state);var arrowRect=getLayoutRect(arrowElement);var minProp=axis==='y'?top:left;var maxProp=axis==='y'?bottom:right;var endDiff=state.rects.reference[len]+state.rects.reference[axis]-popperOffsets[axis]-state.rects.popper[len];var startDiff=popperOffsets[axis]-state.rects.reference[axis];var arrowOffsetParent=getOffsetParent(arrowElement);var clientSize=arrowOffsetParent?axis==='y'?arrowOffsetParent.clientHeight||0:arrowOffsetParent.clientWidth||0:0;var centerToReference=endDiff/2-startDiff/2;var min=paddingObject[minProp];var max=clientSize-arrowRect[len]-paddingObject[maxProp];var center=clientSize/2-arrowRect[len]/2+centerToReference;var offset=within(min,center,max);var axisProp=axis;state.modifiersData[name]=(_state$modifiersData$={},_state$modifiersData$[axisProp]=offset,_state$modifiersData$.centerOffset=offset-center,_state$modifiersData$);}
function effect(_ref2){var state=_ref2.state,options=_ref2.options;var _options$element=options.element,arrowElement=_options$element===void 0?'[data-popper-arrow]':_options$element;if(arrowElement==null){return;}
if(typeof arrowElement==='string'){arrowElement=state.elements.popper.querySelector(arrowElement);if(!arrowElement){return;}}
if(!contains(state.elements.popper,arrowElement)){return;}
state.elements.arrow=arrowElement;}
var arrow$1={name:'arrow',enabled:true,phase:'main',fn:arrow,effect:effect,requires:['popperOffsets'],requiresIfExists:['preventOverflow']};function getSideOffsets(overflow,rect,preventedOffsets){if(preventedOffsets===void 0){preventedOffsets={x:0,y:0};}
return{top:overflow.top-rect.height-preventedOffsets.y,right:overflow.right-rect.width+preventedOffsets.x,bottom:overflow.bottom-rect.height+preventedOffsets.y,left:overflow.left-rect.width-preventedOffsets.x};}
function isAnySideFullyClipped(overflow){return[top,right,bottom,left].some(function(side){return overflow[side]>=0;});}
function hide(_ref){var state=_ref.state,name=_ref.name;var referenceRect=state.rects.reference;var popperRect=state.rects.popper;var preventedOffsets=state.modifiersData.preventOverflow;var referenceOverflow=detectOverflow(state,{elementContext:'reference'});var popperAltOverflow=detectOverflow(state,{altBoundary:true});var referenceClippingOffsets=getSideOffsets(referenceOverflow,referenceRect);var popperEscapeOffsets=getSideOffsets(popperAltOverflow,popperRect,preventedOffsets);var isReferenceHidden=isAnySideFullyClipped(referenceClippingOffsets);var hasPopperEscaped=isAnySideFullyClipped(popperEscapeOffsets);state.modifiersData[name]={referenceClippingOffsets:referenceClippingOffsets,popperEscapeOffsets:popperEscapeOffsets,isReferenceHidden:isReferenceHidden,hasPopperEscaped:hasPopperEscaped};state.attributes.popper=Object.assign({},state.attributes.popper,{'data-popper-reference-hidden':isReferenceHidden,'data-popper-escaped':hasPopperEscaped});}
var hide$1={name:'hide',enabled:true,phase:'main',requiresIfExists:['preventOverflow'],fn:hide};var defaultModifiers$1=[eventListeners,popperOffsets$1,computeStyles$1,applyStyles$1];var createPopper$1=popperGenerator({defaultModifiers:defaultModifiers$1});var defaultModifiers=[eventListeners,popperOffsets$1,computeStyles$1,applyStyles$1,offset$1,flip$1,preventOverflow$1,arrow$1,hide$1];var createPopper=popperGenerator({defaultModifiers:defaultModifiers});exports.applyStyles=applyStyles$1;exports.arrow=arrow$1;exports.computeStyles=computeStyles$1;exports.createPopper=createPopper;exports.createPopperLite=createPopper$1;exports.defaultModifiers=defaultModifiers;exports.detectOverflow=detectOverflow;exports.eventListeners=eventListeners;exports.flip=flip$1;exports.hide=hide$1;exports.offset=offset$1;exports.popperGenerator=popperGenerator;exports.popperOffsets=popperOffsets$1;exports.preventOverflow=preventOverflow$1;Object.defineProperty(exports,'__esModule',{value:true});})));;

/* /web/static/lib/bootstrap/js/dist/util/index.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?factory(exports):typeof define==='function'&&define.amd?define(['exports'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,factory(global.Index={}));})(this,(function(exports){'use strict';const MAX_UID=1000000;const MILLISECONDS_MULTIPLIER=1000;const TRANSITION_END='transitionend';const parseSelector=selector=>{if(selector&&window.CSS&&window.CSS.escape){selector=selector.replace(/#([^\s"#']+)/g,(match,id)=>`#${CSS.escape(id)}`);}
return selector;};const toType=object=>{if(object===null||object===undefined){return`${object}`;}
return Object.prototype.toString.call(object).match(/\s([a-z]+)/i)[1].toLowerCase();};const getUID=prefix=>{do{prefix+=Math.floor(Math.random()*MAX_UID);}while(document.getElementById(prefix));return prefix;};const getTransitionDurationFromElement=element=>{if(!element){return 0;}
let{transitionDuration,transitionDelay}=window.getComputedStyle(element);const floatTransitionDuration=Number.parseFloat(transitionDuration);const floatTransitionDelay=Number.parseFloat(transitionDelay);if(!floatTransitionDuration&&!floatTransitionDelay){return 0;}
transitionDuration=transitionDuration.split(',')[0];transitionDelay=transitionDelay.split(',')[0];return(Number.parseFloat(transitionDuration)+Number.parseFloat(transitionDelay))*MILLISECONDS_MULTIPLIER;};const triggerTransitionEnd=element=>{element.dispatchEvent(new Event(TRANSITION_END));};const isElement=object=>{if(!object||typeof object!=='object'){return false;}
if(typeof object.jquery!=='undefined'){object=object[0];}
return typeof object.nodeType!=='undefined';};const getElement=object=>{if(isElement(object)){return object.jquery?object[0]:object;}
if(typeof object==='string'&&object.length>0){return document.querySelector(parseSelector(object));}
return null;};const isVisible=element=>{if(!isElement(element)||element.getClientRects().length===0){return false;}
const elementIsVisible=getComputedStyle(element).getPropertyValue('visibility')==='visible';const closedDetails=element.closest('details:not([open])');if(!closedDetails){return elementIsVisible;}
if(closedDetails!==element){const summary=element.closest('summary');if(summary&&summary.parentNode!==closedDetails){return false;}
if(summary===null){return false;}}
return elementIsVisible;};const isDisabled=element=>{if(!element||element.nodeType!==Node.ELEMENT_NODE){return true;}
if(element.classList.contains('disabled')){return true;}
if(typeof element.disabled!=='undefined'){return element.disabled;}
return element.hasAttribute('disabled')&&element.getAttribute('disabled')!=='false';};const findShadowRoot=element=>{if(!document.documentElement.attachShadow){return null;}
if(typeof element.getRootNode==='function'){const root=element.getRootNode();return root instanceof ShadowRoot?root:null;}
if(element instanceof ShadowRoot){return element;}
if(!element.parentNode){return null;}
return findShadowRoot(element.parentNode);};const noop=()=>{};const reflow=element=>{element.offsetHeight;};const getjQuery=()=>{if(window.jQuery&&!document.body.hasAttribute('data-bs-no-jquery')){return window.jQuery;}
return null;};const DOMContentLoadedCallbacks=[];const onDOMContentLoaded=callback=>{if(document.readyState==='loading'){if(!DOMContentLoadedCallbacks.length){document.addEventListener('DOMContentLoaded',()=>{for(const callback of DOMContentLoadedCallbacks){callback();}});}
DOMContentLoadedCallbacks.push(callback);}else{callback();}};const isRTL=()=>document.documentElement.dir==='rtl';const defineJQueryPlugin=plugin=>{onDOMContentLoaded(()=>{const $=getjQuery();if($){const name=plugin.NAME;const JQUERY_NO_CONFLICT=$.fn[name];$.fn[name]=plugin.jQueryInterface;$.fn[name].Constructor=plugin;$.fn[name].noConflict=()=>{$.fn[name]=JQUERY_NO_CONFLICT;return plugin.jQueryInterface;};}});};const execute=(possibleCallback,args=[],defaultValue=possibleCallback)=>{return typeof possibleCallback==='function'?possibleCallback(...args):defaultValue;};const executeAfterTransition=(callback,transitionElement,waitForTransition=true)=>{if(!waitForTransition){execute(callback);return;}
const durationPadding=5;const emulatedDuration=getTransitionDurationFromElement(transitionElement)+durationPadding;let called=false;const handler=({target})=>{if(target!==transitionElement){return;}
called=true;transitionElement.removeEventListener(TRANSITION_END,handler);execute(callback);};transitionElement.addEventListener(TRANSITION_END,handler);setTimeout(()=>{if(!called){triggerTransitionEnd(transitionElement);}},emulatedDuration);};const getNextActiveElement=(list,activeElement,shouldGetNext,isCycleAllowed)=>{const listLength=list.length;let index=list.indexOf(activeElement);if(index===-1){return!shouldGetNext&&isCycleAllowed?list[listLength-1]:list[0];}
index+=shouldGetNext?1:-1;if(isCycleAllowed){index=(index+listLength)%listLength;}
return list[Math.max(0,Math.min(index,listLength-1))];};exports.defineJQueryPlugin=defineJQueryPlugin;exports.execute=execute;exports.executeAfterTransition=executeAfterTransition;exports.findShadowRoot=findShadowRoot;exports.getElement=getElement;exports.getNextActiveElement=getNextActiveElement;exports.getTransitionDurationFromElement=getTransitionDurationFromElement;exports.getUID=getUID;exports.getjQuery=getjQuery;exports.isDisabled=isDisabled;exports.isElement=isElement;exports.isRTL=isRTL;exports.isVisible=isVisible;exports.noop=noop;exports.onDOMContentLoaded=onDOMContentLoaded;exports.parseSelector=parseSelector;exports.reflow=reflow;exports.toType=toType;exports.triggerTransitionEnd=triggerTransitionEnd;Object.defineProperty(exports,Symbol.toStringTag,{value:'Module'});}));;

/* /web/static/lib/bootstrap/js/dist/dom/data.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory():typeof define==='function'&&define.amd?define(factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Data=factory());})(this,(function(){'use strict';const elementMap=new Map();const data={set(element,key,instance){if(!elementMap.has(element)){elementMap.set(element,new Map());}
const instanceMap=elementMap.get(element);if(!instanceMap.has(key)&&instanceMap.size!==0){console.error(`Bootstrap doesn't allow more than one instance per element. Bound instance: ${Array.from(instanceMap.keys())[0]}.`);return;}
instanceMap.set(key,instance);},get(element,key){if(elementMap.has(element)){return elementMap.get(element).get(key)||null;}
return null;},remove(element,key){if(!elementMap.has(element)){return;}
const instanceMap=elementMap.get(element);instanceMap.delete(key);if(instanceMap.size===0){elementMap.delete(element);}}};return data;}));;

/* /web/static/lib/bootstrap/js/dist/dom/event-handler.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('../util/index.js')):typeof define==='function'&&define.amd?define(['../util/index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.EventHandler=factory(global.Index));})(this,(function(index_js){'use strict';const namespaceRegex=/[^.]*(?=\..*)\.|.*/;const stripNameRegex=/\..*/;const stripUidRegex=/::\d+$/;const eventRegistry={};let uidEvent=1;const customEvents={mouseenter:'mouseover',mouseleave:'mouseout'};const nativeEvents=new Set(['click','dblclick','mouseup','mousedown','contextmenu','mousewheel','DOMMouseScroll','mouseover','mouseout','mousemove','selectstart','selectend','keydown','keypress','keyup','orientationchange','touchstart','touchmove','touchend','touchcancel','pointerdown','pointermove','pointerup','pointerleave','pointercancel','gesturestart','gesturechange','gestureend','focus','blur','change','reset','select','submit','focusin','focusout','load','unload','beforeunload','resize','move','DOMContentLoaded','readystatechange','error','abort','scroll']);function makeEventUid(element,uid){return uid&&`${uid}::${uidEvent++}`||element.uidEvent||uidEvent++;}
function getElementEvents(element){const uid=makeEventUid(element);element.uidEvent=uid;eventRegistry[uid]=eventRegistry[uid]||{};return eventRegistry[uid];}
function bootstrapHandler(element,fn){return function handler(event){hydrateObj(event,{delegateTarget:element});if(handler.oneOff){EventHandler.off(element,event.type,fn);}
return fn.apply(element,[event]);};}
function bootstrapDelegationHandler(element,selector,fn){return function handler(event){const domElements=element.querySelectorAll(selector);for(let{target}=event;target&&target!==this;target=target.parentNode){for(const domElement of domElements){if(domElement!==target){continue;}
hydrateObj(event,{delegateTarget:target});if(handler.oneOff){EventHandler.off(element,event.type,selector,fn);}
return fn.apply(target,[event]);}}};}
function findHandler(events,callable,delegationSelector=null){return Object.values(events).find(event=>event.callable===callable&&event.delegationSelector===delegationSelector);}
function normalizeParameters(originalTypeEvent,handler,delegationFunction){const isDelegated=typeof handler==='string';const callable=isDelegated?delegationFunction:handler||delegationFunction;let typeEvent=getTypeEvent(originalTypeEvent);if(!nativeEvents.has(typeEvent)){typeEvent=originalTypeEvent;}
return[isDelegated,callable,typeEvent];}
function addHandler(element,originalTypeEvent,handler,delegationFunction,oneOff){if(typeof originalTypeEvent!=='string'||!element){return;}
let[isDelegated,callable,typeEvent]=normalizeParameters(originalTypeEvent,handler,delegationFunction);if(originalTypeEvent in customEvents){const wrapFunction=fn=>{return function(event){if(!event.relatedTarget||event.relatedTarget!==event.delegateTarget&&!event.delegateTarget.contains(event.relatedTarget)){return fn.call(this,event);}};};callable=wrapFunction(callable);}
const events=getElementEvents(element);const handlers=events[typeEvent]||(events[typeEvent]={});const previousFunction=findHandler(handlers,callable,isDelegated?handler:null);if(previousFunction){previousFunction.oneOff=previousFunction.oneOff&&oneOff;return;}
const uid=makeEventUid(callable,originalTypeEvent.replace(namespaceRegex,''));const fn=isDelegated?bootstrapDelegationHandler(element,handler,callable):bootstrapHandler(element,callable);fn.delegationSelector=isDelegated?handler:null;fn.callable=callable;fn.oneOff=oneOff;fn.uidEvent=uid;handlers[uid]=fn;element.addEventListener(typeEvent,fn,isDelegated);}
function removeHandler(element,events,typeEvent,handler,delegationSelector){const fn=findHandler(events[typeEvent],handler,delegationSelector);if(!fn){return;}
element.removeEventListener(typeEvent,fn,Boolean(delegationSelector));delete events[typeEvent][fn.uidEvent];}
function removeNamespacedHandlers(element,events,typeEvent,namespace){const storeElementEvent=events[typeEvent]||{};for(const[handlerKey,event]of Object.entries(storeElementEvent)){if(handlerKey.includes(namespace)){removeHandler(element,events,typeEvent,event.callable,event.delegationSelector);}}}
function getTypeEvent(event){event=event.replace(stripNameRegex,'');return customEvents[event]||event;}
const EventHandler={on(element,event,handler,delegationFunction){addHandler(element,event,handler,delegationFunction,false);},one(element,event,handler,delegationFunction){addHandler(element,event,handler,delegationFunction,true);},off(element,originalTypeEvent,handler,delegationFunction){if(typeof originalTypeEvent!=='string'||!element){return;}
const[isDelegated,callable,typeEvent]=normalizeParameters(originalTypeEvent,handler,delegationFunction);const inNamespace=typeEvent!==originalTypeEvent;const events=getElementEvents(element);const storeElementEvent=events[typeEvent]||{};const isNamespace=originalTypeEvent.startsWith('.');if(typeof callable!=='undefined'){if(!Object.keys(storeElementEvent).length){return;}
removeHandler(element,events,typeEvent,callable,isDelegated?handler:null);return;}
if(isNamespace){for(const elementEvent of Object.keys(events)){removeNamespacedHandlers(element,events,elementEvent,originalTypeEvent.slice(1));}}
for(const[keyHandlers,event]of Object.entries(storeElementEvent)){const handlerKey=keyHandlers.replace(stripUidRegex,'');if(!inNamespace||originalTypeEvent.includes(handlerKey)){removeHandler(element,events,typeEvent,event.callable,event.delegationSelector);}}},trigger(element,event,args){if(typeof event!=='string'||!element){return null;}
const $=index_js.getjQuery();const typeEvent=getTypeEvent(event);const inNamespace=event!==typeEvent;let jQueryEvent=null;let bubbles=true;let nativeDispatch=true;let defaultPrevented=false;if(inNamespace&&$){jQueryEvent=$.Event(event,args);$(element).trigger(jQueryEvent);bubbles=!jQueryEvent.isPropagationStopped();nativeDispatch=!jQueryEvent.isImmediatePropagationStopped();defaultPrevented=jQueryEvent.isDefaultPrevented();}
const evt=hydrateObj(new Event(event,{bubbles,cancelable:true}),args);if(defaultPrevented){evt.preventDefault();}
if(nativeDispatch){element.dispatchEvent(evt);}
if(evt.defaultPrevented&&jQueryEvent){jQueryEvent.preventDefault();}
return evt;}};function hydrateObj(obj,meta={}){for(const[key,value]of Object.entries(meta)){try{obj[key]=value;}catch(_unused){Object.defineProperty(obj,key,{configurable:true,get(){return value;}});}}
return obj;}
return EventHandler;}));;

/* /web/static/lib/bootstrap/js/dist/dom/manipulator.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory():typeof define==='function'&&define.amd?define(factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Manipulator=factory());})(this,(function(){'use strict';function normalizeData(value){if(value==='true'){return true;}
if(value==='false'){return false;}
if(value===Number(value).toString()){return Number(value);}
if(value===''||value==='null'){return null;}
if(typeof value!=='string'){return value;}
try{return JSON.parse(decodeURIComponent(value));}catch(_unused){return value;}}
function normalizeDataKey(key){return key.replace(/[A-Z]/g,chr=>`-${chr.toLowerCase()}`);}
const Manipulator={setDataAttribute(element,key,value){element.setAttribute(`data-bs-${normalizeDataKey(key)}`,value);},removeDataAttribute(element,key){element.removeAttribute(`data-bs-${normalizeDataKey(key)}`);},getDataAttributes(element){if(!element){return{};}
const attributes={};const bsKeys=Object.keys(element.dataset).filter(key=>key.startsWith('bs')&&!key.startsWith('bsConfig'));for(const key of bsKeys){let pureKey=key.replace(/^bs/,'');pureKey=pureKey.charAt(0).toLowerCase()+pureKey.slice(1,pureKey.length);attributes[pureKey]=normalizeData(element.dataset[key]);}
return attributes;},getDataAttribute(element,key){return normalizeData(element.getAttribute(`data-bs-${normalizeDataKey(key)}`));}};return Manipulator;}));;

/* /web/static/lib/bootstrap/js/dist/dom/selector-engine.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('../util/index.js')):typeof define==='function'&&define.amd?define(['../util/index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.SelectorEngine=factory(global.Index));})(this,(function(index_js){'use strict';const getSelector=element=>{let selector=element.getAttribute('data-bs-target');if(!selector||selector==='#'){let hrefAttribute=element.getAttribute('href');if(!hrefAttribute||!hrefAttribute.includes('#')&&!hrefAttribute.startsWith('.')){return null;}
if(hrefAttribute.includes('#')&&!hrefAttribute.startsWith('#')){hrefAttribute=`#${hrefAttribute.split('#')[1]}`;}
selector=hrefAttribute&&hrefAttribute!=='#'?hrefAttribute.trim():null;}
return selector?selector.split(',').map(sel=>index_js.parseSelector(sel)).join(','):null;};const SelectorEngine={find(selector,element=document.documentElement){return[].concat(...Element.prototype.querySelectorAll.call(element,selector));},findOne(selector,element=document.documentElement){return Element.prototype.querySelector.call(element,selector);},children(element,selector){return[].concat(...element.children).filter(child=>child.matches(selector));},parents(element,selector){const parents=[];let ancestor=element.parentNode.closest(selector);while(ancestor){parents.push(ancestor);ancestor=ancestor.parentNode.closest(selector);}
return parents;},prev(element,selector){let previous=element.previousElementSibling;while(previous){if(previous.matches(selector)){return[previous];}
previous=previous.previousElementSibling;}
return[];},next(element,selector){let next=element.nextElementSibling;while(next){if(next.matches(selector)){return[next];}
next=next.nextElementSibling;}
return[];},focusableChildren(element){const focusables=['a','button','input','textarea','select','details','[tabindex]','[contenteditable="true"]'].map(selector=>`${selector}:not([tabindex^="-"])`).join(',');return this.find(focusables,element).filter(el=>!index_js.isDisabled(el)&&index_js.isVisible(el));},getSelectorFromElement(element){const selector=getSelector(element);if(selector){return SelectorEngine.findOne(selector)?selector:null;}
return null;},getElementFromSelector(element){const selector=getSelector(element);return selector?SelectorEngine.findOne(selector):null;},getMultipleElementsFromSelector(element){const selector=getSelector(element);return selector?SelectorEngine.find(selector):[];}};return SelectorEngine;}));;

/* /web/static/lib/bootstrap/js/dist/util/config.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('../dom/manipulator.js'),require('./index.js')):typeof define==='function'&&define.amd?define(['../dom/manipulator','./index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Config=factory(global.Manipulator,global.Index));})(this,(function(Manipulator,index_js){'use strict';class Config{static get Default(){return{};}
static get DefaultType(){return{};}
static get NAME(){throw new Error('You have to implement the static method "NAME", for each component!');}
_getConfig(config){config=this._mergeConfigObj(config);config=this._configAfterMerge(config);this._typeCheckConfig(config);return config;}
_configAfterMerge(config){return config;}
_mergeConfigObj(config,element){const jsonConfig=index_js.isElement(element)?Manipulator.getDataAttribute(element,'config'):{};return{...this.constructor.Default,...(typeof jsonConfig==='object'?jsonConfig:{}),...(index_js.isElement(element)?Manipulator.getDataAttributes(element):{}),...(typeof config==='object'?config:{})};}
_typeCheckConfig(config,configTypes=this.constructor.DefaultType){for(const[property,expectedTypes]of Object.entries(configTypes)){const value=config[property];const valueType=index_js.isElement(value)?'element':index_js.toType(value);if(!new RegExp(expectedTypes).test(valueType)){throw new TypeError(`${this.constructor.NAME.toUpperCase()}: Option "${property}" provided type "${valueType}" but expected type "${expectedTypes}".`);}}}}
return Config;}));;

/* /web/static/lib/bootstrap/js/dist/util/component-functions.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?factory(exports,require('../dom/event-handler.js'),require('../dom/selector-engine.js'),require('./index.js')):typeof define==='function'&&define.amd?define(['exports','../dom/event-handler','../dom/selector-engine','./index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,factory(global.ComponentFunctions={},global.EventHandler,global.SelectorEngine,global.Index));})(this,(function(exports,EventHandler,SelectorEngine,index_js){'use strict';const enableDismissTrigger=(component,method='hide')=>{const clickEvent=`click.dismiss${component.EVENT_KEY}`;const name=component.NAME;EventHandler.on(document,clickEvent,`[data-bs-dismiss="${name}"]`,function(event){if(['A','AREA'].includes(this.tagName)){event.preventDefault();}
if(index_js.isDisabled(this)){return;}
const target=SelectorEngine.getElementFromSelector(this)||this.closest(`.${name}`);const instance=component.getOrCreateInstance(target);instance[method]();});};exports.enableDismissTrigger=enableDismissTrigger;Object.defineProperty(exports,Symbol.toStringTag,{value:'Module'});}));;

/* /web/static/lib/bootstrap/js/dist/util/backdrop.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('../dom/event-handler.js'),require('./config.js'),require('./index.js')):typeof define==='function'&&define.amd?define(['../dom/event-handler','./config','./index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Backdrop=factory(global.EventHandler,global.Config,global.Index));})(this,(function(EventHandler,Config,index_js){'use strict';const NAME='backdrop';const CLASS_NAME_FADE='fade';const CLASS_NAME_SHOW='show';const EVENT_MOUSEDOWN=`mousedown.bs.${NAME}`;const Default={className:'modal-backdrop',clickCallback:null,isAnimated:false,isVisible:true,rootElement:'body'};const DefaultType={className:'string',clickCallback:'(function|null)',isAnimated:'boolean',isVisible:'boolean',rootElement:'(element|string)'};class Backdrop extends Config{constructor(config){super();this._config=this._getConfig(config);this._isAppended=false;this._element=null;}
static get Default(){return Default;}
static get DefaultType(){return DefaultType;}
static get NAME(){return NAME;}
show(callback){if(!this._config.isVisible){index_js.execute(callback);return;}
this._append();const element=this._getElement();if(this._config.isAnimated){index_js.reflow(element);}
element.classList.add(CLASS_NAME_SHOW);this._emulateAnimation(()=>{index_js.execute(callback);});}
hide(callback){if(!this._config.isVisible){index_js.execute(callback);return;}
this._getElement().classList.remove(CLASS_NAME_SHOW);this._emulateAnimation(()=>{this.dispose();index_js.execute(callback);});}
dispose(){if(!this._isAppended){return;}
EventHandler.off(this._element,EVENT_MOUSEDOWN);this._element.remove();this._isAppended=false;}
_getElement(){if(!this._element){const backdrop=document.createElement('div');backdrop.className=this._config.className;if(this._config.isAnimated){backdrop.classList.add(CLASS_NAME_FADE);}
this._element=backdrop;}
return this._element;}
_configAfterMerge(config){config.rootElement=index_js.getElement(config.rootElement);return config;}
_append(){if(this._isAppended){return;}
const element=this._getElement();this._config.rootElement.append(element);EventHandler.on(element,EVENT_MOUSEDOWN,()=>{index_js.execute(this._config.clickCallback);});this._isAppended=true;}
_emulateAnimation(callback){index_js.executeAfterTransition(callback,this._getElement(),this._config.isAnimated);}}
return Backdrop;}));;

/* /web/static/lib/bootstrap/js/dist/util/focustrap.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('../dom/event-handler.js'),require('../dom/selector-engine.js'),require('./config.js')):typeof define==='function'&&define.amd?define(['../dom/event-handler','../dom/selector-engine','./config'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Focustrap=factory(global.EventHandler,global.SelectorEngine,global.Config));})(this,(function(EventHandler,SelectorEngine,Config){'use strict';const NAME='focustrap';const DATA_KEY='bs.focustrap';const EVENT_KEY=`.${DATA_KEY}`;const EVENT_FOCUSIN=`focusin${EVENT_KEY}`;const EVENT_KEYDOWN_TAB=`keydown.tab${EVENT_KEY}`;const TAB_KEY='Tab';const TAB_NAV_FORWARD='forward';const TAB_NAV_BACKWARD='backward';const Default={autofocus:true,trapElement:null};const DefaultType={autofocus:'boolean',trapElement:'element'};class FocusTrap extends Config{constructor(config){super();this._config=this._getConfig(config);this._isActive=false;this._lastTabNavDirection=null;}
static get Default(){return Default;}
static get DefaultType(){return DefaultType;}
static get NAME(){return NAME;}
activate(){if(this._isActive){return;}
if(this._config.autofocus){this._config.trapElement.focus();}
EventHandler.off(document,EVENT_KEY);EventHandler.on(document,EVENT_FOCUSIN,event=>this._handleFocusin(event));EventHandler.on(document,EVENT_KEYDOWN_TAB,event=>this._handleKeydown(event));this._isActive=true;}
deactivate(){if(!this._isActive){return;}
this._isActive=false;EventHandler.off(document,EVENT_KEY);}
_handleFocusin(event){const{trapElement}=this._config;if(event.target===document||event.target===trapElement||trapElement.contains(event.target)){return;}
const elements=SelectorEngine.focusableChildren(trapElement);if(elements.length===0){trapElement.focus();}else if(this._lastTabNavDirection===TAB_NAV_BACKWARD){elements[elements.length-1].focus();}else{elements[0].focus();}}
_handleKeydown(event){if(event.key!==TAB_KEY){return;}
this._lastTabNavDirection=event.shiftKey?TAB_NAV_BACKWARD:TAB_NAV_FORWARD;}}
return FocusTrap;}));;

/* /web/static/lib/bootstrap/js/dist/util/sanitizer.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?factory(exports):typeof define==='function'&&define.amd?define(['exports'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,factory(global.Sanitizer={}));})(this,(function(exports){'use strict';const ARIA_ATTRIBUTE_PATTERN=/^aria-[\w-]*$/i;const DefaultAllowlist={'*':['class','dir','id','lang','role',ARIA_ATTRIBUTE_PATTERN],a:['target','href','title','rel'],area:[],b:[],br:[],col:[],code:[],dd:[],div:[],dl:[],dt:[],em:[],hr:[],h1:[],h2:[],h3:[],h4:[],h5:[],h6:[],i:[],img:['src','srcset','alt','title','width','height'],li:[],ol:[],p:[],pre:[],s:[],small:[],span:[],sub:[],sup:[],strong:[],u:[],ul:[]};const uriAttributes=new Set(['background','cite','href','itemtype','longdesc','poster','src','xlink:href']);const SAFE_URL_PATTERN=/^(?!javascript:)(?:[a-z0-9+.-]+:|[^&:/?#]*(?:[/?#]|$))/i;const allowedAttribute=(attribute,allowedAttributeList)=>{const attributeName=attribute.nodeName.toLowerCase();if(allowedAttributeList.includes(attributeName)){if(uriAttributes.has(attributeName)){return Boolean(SAFE_URL_PATTERN.test(attribute.nodeValue));}
return true;}
return allowedAttributeList.filter(attributeRegex=>attributeRegex instanceof RegExp).some(regex=>regex.test(attributeName));};function sanitizeHtml(unsafeHtml,allowList,sanitizeFunction){if(!unsafeHtml.length){return unsafeHtml;}
if(sanitizeFunction&&typeof sanitizeFunction==='function'){return sanitizeFunction(unsafeHtml);}
const domParser=new window.DOMParser();const createdDocument=domParser.parseFromString(unsafeHtml,'text/html');const elements=[].concat(...createdDocument.body.querySelectorAll('*'));for(const element of elements){const elementName=element.nodeName.toLowerCase();if(!Object.keys(allowList).includes(elementName)){element.remove();continue;}
const attributeList=[].concat(...element.attributes);const allowedAttributes=[].concat(allowList['*']||[],allowList[elementName]||[]);for(const attribute of attributeList){if(!allowedAttribute(attribute,allowedAttributes)){element.removeAttribute(attribute.nodeName);}}}
return createdDocument.body.innerHTML;}
exports.DefaultAllowlist=DefaultAllowlist;exports.sanitizeHtml=sanitizeHtml;Object.defineProperty(exports,Symbol.toStringTag,{value:'Module'});}));;

/* /web/static/lib/bootstrap/js/dist/util/scrollbar.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('../dom/manipulator.js'),require('../dom/selector-engine.js'),require('./index.js')):typeof define==='function'&&define.amd?define(['../dom/manipulator','../dom/selector-engine','./index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Scrollbar=factory(global.Manipulator,global.SelectorEngine,global.Index));})(this,(function(Manipulator,SelectorEngine,index_js){'use strict';const SELECTOR_FIXED_CONTENT='.fixed-top, .fixed-bottom, .is-fixed, .sticky-top';const SELECTOR_STICKY_CONTENT='.sticky-top';const PROPERTY_PADDING='padding-right';const PROPERTY_MARGIN='margin-right';class ScrollBarHelper{constructor(){this._element=document.body;}
getWidth(){const documentWidth=document.documentElement.clientWidth;return Math.abs(window.innerWidth-documentWidth);}
hide(){const width=this.getWidth();this._disableOverFlow();this._setElementAttributes(this._element,PROPERTY_PADDING,calculatedValue=>calculatedValue+width);this._setElementAttributes(SELECTOR_FIXED_CONTENT,PROPERTY_PADDING,calculatedValue=>calculatedValue+width);this._setElementAttributes(SELECTOR_STICKY_CONTENT,PROPERTY_MARGIN,calculatedValue=>calculatedValue-width);}
reset(){this._resetElementAttributes(this._element,'overflow');this._resetElementAttributes(this._element,PROPERTY_PADDING);this._resetElementAttributes(SELECTOR_FIXED_CONTENT,PROPERTY_PADDING);this._resetElementAttributes(SELECTOR_STICKY_CONTENT,PROPERTY_MARGIN);}
isOverflowing(){return this.getWidth()>0;}
_disableOverFlow(){this._saveInitialAttribute(this._element,'overflow');this._element.style.overflow='hidden';}
_setElementAttributes(selector,styleProperty,callback){const scrollbarWidth=this.getWidth();const manipulationCallBack=element=>{if(element!==this._element&&window.innerWidth>element.clientWidth+scrollbarWidth){return;}
this._saveInitialAttribute(element,styleProperty);const calculatedValue=window.getComputedStyle(element).getPropertyValue(styleProperty);element.style.setProperty(styleProperty,`${callback(Number.parseFloat(calculatedValue))}px`);};this._applyManipulationCallback(selector,manipulationCallBack);}
_saveInitialAttribute(element,styleProperty){const actualValue=element.style.getPropertyValue(styleProperty);if(actualValue){Manipulator.setDataAttribute(element,styleProperty,actualValue);}}
_resetElementAttributes(selector,styleProperty){const manipulationCallBack=element=>{const value=Manipulator.getDataAttribute(element,styleProperty);if(value===null){element.style.removeProperty(styleProperty);return;}
Manipulator.removeDataAttribute(element,styleProperty);element.style.setProperty(styleProperty,value);};this._applyManipulationCallback(selector,manipulationCallBack);}
_applyManipulationCallback(selector,callBack){if(index_js.isElement(selector)){callBack(selector);return;}
for(const sel of SelectorEngine.find(selector,this._element)){callBack(sel);}}}
return ScrollBarHelper;}));;

/* /web/static/lib/bootstrap/js/dist/util/swipe.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('../dom/event-handler.js'),require('./config.js'),require('./index.js')):typeof define==='function'&&define.amd?define(['../dom/event-handler','./config','./index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Swipe=factory(global.EventHandler,global.Config,global.Index));})(this,(function(EventHandler,Config,index_js){'use strict';const NAME='swipe';const EVENT_KEY='.bs.swipe';const EVENT_TOUCHSTART=`touchstart${EVENT_KEY}`;const EVENT_TOUCHMOVE=`touchmove${EVENT_KEY}`;const EVENT_TOUCHEND=`touchend${EVENT_KEY}`;const EVENT_POINTERDOWN=`pointerdown${EVENT_KEY}`;const EVENT_POINTERUP=`pointerup${EVENT_KEY}`;const POINTER_TYPE_TOUCH='touch';const POINTER_TYPE_PEN='pen';const CLASS_NAME_POINTER_EVENT='pointer-event';const SWIPE_THRESHOLD=40;const Default={endCallback:null,leftCallback:null,rightCallback:null};const DefaultType={endCallback:'(function|null)',leftCallback:'(function|null)',rightCallback:'(function|null)'};class Swipe extends Config{constructor(element,config){super();this._element=element;if(!element||!Swipe.isSupported()){return;}
this._config=this._getConfig(config);this._deltaX=0;this._supportPointerEvents=Boolean(window.PointerEvent);this._initEvents();}
static get Default(){return Default;}
static get DefaultType(){return DefaultType;}
static get NAME(){return NAME;}
dispose(){EventHandler.off(this._element,EVENT_KEY);}
_start(event){if(!this._supportPointerEvents){this._deltaX=event.touches[0].clientX;return;}
if(this._eventIsPointerPenTouch(event)){this._deltaX=event.clientX;}}
_end(event){if(this._eventIsPointerPenTouch(event)){this._deltaX=event.clientX-this._deltaX;}
this._handleSwipe();index_js.execute(this._config.endCallback);}
_move(event){this._deltaX=event.touches&&event.touches.length>1?0:event.touches[0].clientX-this._deltaX;}
_handleSwipe(){const absDeltaX=Math.abs(this._deltaX);if(absDeltaX<=SWIPE_THRESHOLD){return;}
const direction=absDeltaX/this._deltaX;this._deltaX=0;if(!direction){return;}
index_js.execute(direction>0?this._config.rightCallback:this._config.leftCallback);}
_initEvents(){if(this._supportPointerEvents){EventHandler.on(this._element,EVENT_POINTERDOWN,event=>this._start(event));EventHandler.on(this._element,EVENT_POINTERUP,event=>this._end(event));this._element.classList.add(CLASS_NAME_POINTER_EVENT);}else{EventHandler.on(this._element,EVENT_TOUCHSTART,event=>this._start(event));EventHandler.on(this._element,EVENT_TOUCHMOVE,event=>this._move(event));EventHandler.on(this._element,EVENT_TOUCHEND,event=>this._end(event));}}
_eventIsPointerPenTouch(event){return this._supportPointerEvents&&(event.pointerType===POINTER_TYPE_PEN||event.pointerType===POINTER_TYPE_TOUCH);}
static isSupported(){return'ontouchstart'in document.documentElement||navigator.maxTouchPoints>0;}}
return Swipe;}));;

/* /web/static/lib/bootstrap/js/dist/util/template-factory.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('../dom/selector-engine.js'),require('./config.js'),require('./sanitizer.js'),require('./index.js')):typeof define==='function'&&define.amd?define(['../dom/selector-engine','./config','./sanitizer','./index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.TemplateFactory=factory(global.SelectorEngine,global.Config,global.Sanitizer,global.Index));})(this,(function(SelectorEngine,Config,sanitizer_js,index_js){'use strict';const NAME='TemplateFactory';const Default={allowList:sanitizer_js.DefaultAllowlist,content:{},extraClass:'',html:false,sanitize:true,sanitizeFn:null,template:'<div></div>'};const DefaultType={allowList:'object',content:'object',extraClass:'(string|function)',html:'boolean',sanitize:'boolean',sanitizeFn:'(null|function)',template:'string'};const DefaultContentType={entry:'(string|element|function|null)',selector:'(string|element)'};class TemplateFactory extends Config{constructor(config){super();this._config=this._getConfig(config);}
static get Default(){return Default;}
static get DefaultType(){return DefaultType;}
static get NAME(){return NAME;}
getContent(){return Object.values(this._config.content).map(config=>this._resolvePossibleFunction(config)).filter(Boolean);}
hasContent(){return this.getContent().length>0;}
changeContent(content){this._checkContent(content);this._config.content={...this._config.content,...content};return this;}
toHtml(){const templateWrapper=document.createElement('div');templateWrapper.innerHTML=this._maybeSanitize(this._config.template);for(const[selector,text]of Object.entries(this._config.content)){this._setContent(templateWrapper,text,selector);}
const template=templateWrapper.children[0];const extraClass=this._resolvePossibleFunction(this._config.extraClass);if(extraClass){template.classList.add(...extraClass.split(' '));}
return template;}
_typeCheckConfig(config){super._typeCheckConfig(config);this._checkContent(config.content);}
_checkContent(arg){for(const[selector,content]of Object.entries(arg)){super._typeCheckConfig({selector,entry:content},DefaultContentType);}}
_setContent(template,content,selector){const templateElement=SelectorEngine.findOne(selector,template);if(!templateElement){return;}
content=this._resolvePossibleFunction(content);if(!content){templateElement.remove();return;}
if(index_js.isElement(content)){this._putElementInTemplate(index_js.getElement(content),templateElement);return;}
if(this._config.html){templateElement.innerHTML=this._maybeSanitize(content);return;}
templateElement.textContent=content;}
_maybeSanitize(arg){return this._config.sanitize?sanitizer_js.sanitizeHtml(arg,this._config.allowList,this._config.sanitizeFn):arg;}
_resolvePossibleFunction(arg){return index_js.execute(arg,[this]);}
_putElementInTemplate(element,templateElement){if(this._config.html){templateElement.innerHTML='';templateElement.append(element);return;}
templateElement.textContent=element.textContent;}}
return TemplateFactory;}));;

/* /web/static/lib/bootstrap/js/dist/base-component.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('./dom/data.js'),require('./dom/event-handler.js'),require('./util/config.js'),require('./util/index.js')):typeof define==='function'&&define.amd?define(['./dom/data','./dom/event-handler','./util/config','./util/index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.BaseComponent=factory(global.Data,global.EventHandler,global.Config,global.Index));})(this,(function(Data,EventHandler,Config,index_js){'use strict';const VERSION='5.3.3';class BaseComponent extends Config{constructor(element,config){super();element=index_js.getElement(element);if(!element){return;}
this._element=element;this._config=this._getConfig(config);Data.set(this._element,this.constructor.DATA_KEY,this);}
dispose(){Data.remove(this._element,this.constructor.DATA_KEY);EventHandler.off(this._element,this.constructor.EVENT_KEY);for(const propertyName of Object.getOwnPropertyNames(this)){this[propertyName]=null;}}
_queueCallback(callback,element,isAnimated=true){index_js.executeAfterTransition(callback,element,isAnimated);}
_getConfig(config){config=this._mergeConfigObj(config,this._element);config=this._configAfterMerge(config);this._typeCheckConfig(config);return config;}
static getInstance(element){return Data.get(index_js.getElement(element),this.DATA_KEY);}
static getOrCreateInstance(element,config={}){return this.getInstance(element)||new this(element,typeof config==='object'?config:null);}
static get VERSION(){return VERSION;}
static get DATA_KEY(){return`bs.${this.NAME}`;}
static get EVENT_KEY(){return`.${this.DATA_KEY}`;}
static eventName(name){return`${name}${this.EVENT_KEY}`;}}
return BaseComponent;}));;

/* /web/static/lib/bootstrap/js/dist/alert.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('./base-component.js'),require('./dom/event-handler.js'),require('./util/component-functions.js'),require('./util/index.js')):typeof define==='function'&&define.amd?define(['./base-component','./dom/event-handler','./util/component-functions','./util/index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Alert=factory(global.BaseComponent,global.EventHandler,global.ComponentFunctions,global.Index));})(this,(function(BaseComponent,EventHandler,componentFunctions_js,index_js){'use strict';const NAME='alert';const DATA_KEY='bs.alert';const EVENT_KEY=`.${DATA_KEY}`;const EVENT_CLOSE=`close${EVENT_KEY}`;const EVENT_CLOSED=`closed${EVENT_KEY}`;const CLASS_NAME_FADE='fade';const CLASS_NAME_SHOW='show';class Alert extends BaseComponent{static get NAME(){return NAME;}
close(){const closeEvent=EventHandler.trigger(this._element,EVENT_CLOSE);if(closeEvent.defaultPrevented){return;}
this._element.classList.remove(CLASS_NAME_SHOW);const isAnimated=this._element.classList.contains(CLASS_NAME_FADE);this._queueCallback(()=>this._destroyElement(),this._element,isAnimated);}
_destroyElement(){this._element.remove();EventHandler.trigger(this._element,EVENT_CLOSED);this.dispose();}
static jQueryInterface(config){return this.each(function(){const data=Alert.getOrCreateInstance(this);if(typeof config!=='string'){return;}
if(data[config]===undefined||config.startsWith('_')||config==='constructor'){throw new TypeError(`No method named "${config}"`);}
data[config](this);});}}
componentFunctions_js.enableDismissTrigger(Alert,'close');index_js.defineJQueryPlugin(Alert);return Alert;}));;

/* /web/static/lib/bootstrap/js/dist/button.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('./base-component.js'),require('./dom/event-handler.js'),require('./util/index.js')):typeof define==='function'&&define.amd?define(['./base-component','./dom/event-handler','./util/index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Button=factory(global.BaseComponent,global.EventHandler,global.Index));})(this,(function(BaseComponent,EventHandler,index_js){'use strict';const NAME='button';const DATA_KEY='bs.button';const EVENT_KEY=`.${DATA_KEY}`;const DATA_API_KEY='.data-api';const CLASS_NAME_ACTIVE='active';const SELECTOR_DATA_TOGGLE='[data-bs-toggle="button"]';const EVENT_CLICK_DATA_API=`click${EVENT_KEY}${DATA_API_KEY}`;class Button extends BaseComponent{static get NAME(){return NAME;}
toggle(){this._element.setAttribute('aria-pressed',this._element.classList.toggle(CLASS_NAME_ACTIVE));}
static jQueryInterface(config){return this.each(function(){const data=Button.getOrCreateInstance(this);if(config==='toggle'){data[config]();}});}}
EventHandler.on(document,EVENT_CLICK_DATA_API,SELECTOR_DATA_TOGGLE,event=>{event.preventDefault();const button=event.target.closest(SELECTOR_DATA_TOGGLE);const data=Button.getOrCreateInstance(button);data.toggle();});index_js.defineJQueryPlugin(Button);return Button;}));;

/* /web/static/lib/bootstrap/js/dist/carousel.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('./base-component.js'),require('./dom/event-handler.js'),require('./dom/manipulator.js'),require('./dom/selector-engine.js'),require('./util/index.js'),require('./util/swipe.js')):typeof define==='function'&&define.amd?define(['./base-component','./dom/event-handler','./dom/manipulator','./dom/selector-engine','./util/index','./util/swipe'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Carousel=factory(global.BaseComponent,global.EventHandler,global.Manipulator,global.SelectorEngine,global.Index,global.Swipe));})(this,(function(BaseComponent,EventHandler,Manipulator,SelectorEngine,index_js,Swipe){'use strict';const NAME='carousel';const DATA_KEY='bs.carousel';const EVENT_KEY=`.${DATA_KEY}`;const DATA_API_KEY='.data-api';const ARROW_LEFT_KEY='ArrowLeft';const ARROW_RIGHT_KEY='ArrowRight';const TOUCHEVENT_COMPAT_WAIT=500;const ORDER_NEXT='next';const ORDER_PREV='prev';const DIRECTION_LEFT='left';const DIRECTION_RIGHT='right';const EVENT_SLIDE=`slide${EVENT_KEY}`;const EVENT_SLID=`slid${EVENT_KEY}`;const EVENT_KEYDOWN=`keydown${EVENT_KEY}`;const EVENT_MOUSEENTER=`mouseenter${EVENT_KEY}`;const EVENT_MOUSELEAVE=`mouseleave${EVENT_KEY}`;const EVENT_DRAG_START=`dragstart${EVENT_KEY}`;const EVENT_LOAD_DATA_API=`load${EVENT_KEY}${DATA_API_KEY}`;const EVENT_CLICK_DATA_API=`click${EVENT_KEY}${DATA_API_KEY}`;const CLASS_NAME_CAROUSEL='carousel';const CLASS_NAME_ACTIVE='active';const CLASS_NAME_SLIDE='slide';const CLASS_NAME_END='carousel-item-end';const CLASS_NAME_START='carousel-item-start';const CLASS_NAME_NEXT='carousel-item-next';const CLASS_NAME_PREV='carousel-item-prev';const SELECTOR_ACTIVE='.active';const SELECTOR_ITEM='.carousel-item';const SELECTOR_ACTIVE_ITEM=SELECTOR_ACTIVE+SELECTOR_ITEM;const SELECTOR_ITEM_IMG='.carousel-item img';const SELECTOR_INDICATORS='.carousel-indicators';const SELECTOR_DATA_SLIDE='[data-bs-slide], [data-bs-slide-to]';const SELECTOR_DATA_RIDE='[data-bs-ride="carousel"]';const KEY_TO_DIRECTION={[ARROW_LEFT_KEY]:DIRECTION_RIGHT,[ARROW_RIGHT_KEY]:DIRECTION_LEFT};const Default={interval:5000,keyboard:true,pause:'hover',ride:false,touch:true,wrap:true};const DefaultType={interval:'(number|boolean)',keyboard:'boolean',pause:'(string|boolean)',ride:'(boolean|string)',touch:'boolean',wrap:'boolean'};class Carousel extends BaseComponent{constructor(element,config){super(element,config);this._interval=null;this._activeElement=null;this._isSliding=false;this.touchTimeout=null;this._swipeHelper=null;this._indicatorsElement=SelectorEngine.findOne(SELECTOR_INDICATORS,this._element);this._addEventListeners();if(this._config.ride===CLASS_NAME_CAROUSEL){this.cycle();}}
static get Default(){return Default;}
static get DefaultType(){return DefaultType;}
static get NAME(){return NAME;}
next(){this._slide(ORDER_NEXT);}
nextWhenVisible(){if(!document.hidden&&index_js.isVisible(this._element)){this.next();}}
prev(){this._slide(ORDER_PREV);}
pause(){if(this._isSliding){index_js.triggerTransitionEnd(this._element);}
this._clearInterval();}
cycle(){this._clearInterval();this._updateInterval();this._interval=setInterval(()=>this.nextWhenVisible(),this._config.interval);}
_maybeEnableCycle(){if(!this._config.ride){return;}
if(this._isSliding){EventHandler.one(this._element,EVENT_SLID,()=>this.cycle());return;}
this.cycle();}
to(index){const items=this._getItems();if(index>items.length-1||index<0){return;}
if(this._isSliding){EventHandler.one(this._element,EVENT_SLID,()=>this.to(index));return;}
const activeIndex=this._getItemIndex(this._getActive());if(activeIndex===index){return;}
const order=index>activeIndex?ORDER_NEXT:ORDER_PREV;this._slide(order,items[index]);}
dispose(){if(this._swipeHelper){this._swipeHelper.dispose();}
super.dispose();}
_configAfterMerge(config){config.defaultInterval=config.interval;return config;}
_addEventListeners(){if(this._config.keyboard){EventHandler.on(this._element,EVENT_KEYDOWN,event=>this._keydown(event));}
if(this._config.pause==='hover'){EventHandler.on(this._element,EVENT_MOUSEENTER,()=>this.pause());EventHandler.on(this._element,EVENT_MOUSELEAVE,()=>this._maybeEnableCycle());}
if(this._config.touch&&Swipe.isSupported()){this._addTouchEventListeners();}}
_addTouchEventListeners(){for(const img of SelectorEngine.find(SELECTOR_ITEM_IMG,this._element)){EventHandler.on(img,EVENT_DRAG_START,event=>event.preventDefault());}
const endCallBack=()=>{if(this._config.pause!=='hover'){return;}
this.pause();if(this.touchTimeout){clearTimeout(this.touchTimeout);}
this.touchTimeout=setTimeout(()=>this._maybeEnableCycle(),TOUCHEVENT_COMPAT_WAIT+this._config.interval);};const swipeConfig={leftCallback:()=>this._slide(this._directionToOrder(DIRECTION_LEFT)),rightCallback:()=>this._slide(this._directionToOrder(DIRECTION_RIGHT)),endCallback:endCallBack};this._swipeHelper=new Swipe(this._element,swipeConfig);}
_keydown(event){if(/input|textarea/i.test(event.target.tagName)){return;}
const direction=KEY_TO_DIRECTION[event.key];if(direction){event.preventDefault();this._slide(this._directionToOrder(direction));}}
_getItemIndex(element){return this._getItems().indexOf(element);}
_setActiveIndicatorElement(index){if(!this._indicatorsElement){return;}
const activeIndicator=SelectorEngine.findOne(SELECTOR_ACTIVE,this._indicatorsElement);activeIndicator.classList.remove(CLASS_NAME_ACTIVE);activeIndicator.removeAttribute('aria-current');const newActiveIndicator=SelectorEngine.findOne(`[data-bs-slide-to="${index}"]`,this._indicatorsElement);if(newActiveIndicator){newActiveIndicator.classList.add(CLASS_NAME_ACTIVE);newActiveIndicator.setAttribute('aria-current','true');}}
_updateInterval(){const element=this._activeElement||this._getActive();if(!element){return;}
const elementInterval=Number.parseInt(element.getAttribute('data-bs-interval'),10);this._config.interval=elementInterval||this._config.defaultInterval;}
_slide(order,element=null){if(this._isSliding){return;}
const activeElement=this._getActive();const isNext=order===ORDER_NEXT;const nextElement=element||index_js.getNextActiveElement(this._getItems(),activeElement,isNext,this._config.wrap);if(nextElement===activeElement){return;}
const nextElementIndex=this._getItemIndex(nextElement);const triggerEvent=eventName=>{return EventHandler.trigger(this._element,eventName,{relatedTarget:nextElement,direction:this._orderToDirection(order),from:this._getItemIndex(activeElement),to:nextElementIndex});};const slideEvent=triggerEvent(EVENT_SLIDE);if(slideEvent.defaultPrevented){return;}
if(!activeElement||!nextElement){return;}
const isCycling=Boolean(this._interval);this.pause();this._isSliding=true;this._setActiveIndicatorElement(nextElementIndex);this._activeElement=nextElement;const directionalClassName=isNext?CLASS_NAME_START:CLASS_NAME_END;const orderClassName=isNext?CLASS_NAME_NEXT:CLASS_NAME_PREV;nextElement.classList.add(orderClassName);index_js.reflow(nextElement);activeElement.classList.add(directionalClassName);nextElement.classList.add(directionalClassName);const completeCallBack=()=>{nextElement.classList.remove(directionalClassName,orderClassName);nextElement.classList.add(CLASS_NAME_ACTIVE);activeElement.classList.remove(CLASS_NAME_ACTIVE,orderClassName,directionalClassName);this._isSliding=false;triggerEvent(EVENT_SLID);};this._queueCallback(completeCallBack,activeElement,this._isAnimated());if(isCycling){this.cycle();}}
_isAnimated(){return this._element.classList.contains(CLASS_NAME_SLIDE);}
_getActive(){return SelectorEngine.findOne(SELECTOR_ACTIVE_ITEM,this._element);}
_getItems(){return SelectorEngine.find(SELECTOR_ITEM,this._element);}
_clearInterval(){if(this._interval){clearInterval(this._interval);this._interval=null;}}
_directionToOrder(direction){if(index_js.isRTL()){return direction===DIRECTION_LEFT?ORDER_PREV:ORDER_NEXT;}
return direction===DIRECTION_LEFT?ORDER_NEXT:ORDER_PREV;}
_orderToDirection(order){if(index_js.isRTL()){return order===ORDER_PREV?DIRECTION_LEFT:DIRECTION_RIGHT;}
return order===ORDER_PREV?DIRECTION_RIGHT:DIRECTION_LEFT;}
static jQueryInterface(config){return this.each(function(){const data=Carousel.getOrCreateInstance(this,config);if(typeof config==='number'){data.to(config);return;}
if(typeof config==='string'){if(data[config]===undefined||config.startsWith('_')||config==='constructor'){throw new TypeError(`No method named "${config}"`);}
data[config]();}});}}
EventHandler.on(document,EVENT_CLICK_DATA_API,SELECTOR_DATA_SLIDE,function(event){const target=SelectorEngine.getElementFromSelector(this);if(!target||!target.classList.contains(CLASS_NAME_CAROUSEL)){return;}
event.preventDefault();const carousel=Carousel.getOrCreateInstance(target);const slideIndex=this.getAttribute('data-bs-slide-to');if(slideIndex){carousel.to(slideIndex);carousel._maybeEnableCycle();return;}
if(Manipulator.getDataAttribute(this,'slide')==='next'){carousel.next();carousel._maybeEnableCycle();return;}
carousel.prev();carousel._maybeEnableCycle();});EventHandler.on(window,EVENT_LOAD_DATA_API,()=>{const carousels=SelectorEngine.find(SELECTOR_DATA_RIDE);for(const carousel of carousels){Carousel.getOrCreateInstance(carousel);}});index_js.defineJQueryPlugin(Carousel);return Carousel;}));;

/* /web/static/lib/bootstrap/js/dist/collapse.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('./base-component.js'),require('./dom/event-handler.js'),require('./dom/selector-engine.js'),require('./util/index.js')):typeof define==='function'&&define.amd?define(['./base-component','./dom/event-handler','./dom/selector-engine','./util/index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Collapse=factory(global.BaseComponent,global.EventHandler,global.SelectorEngine,global.Index));})(this,(function(BaseComponent,EventHandler,SelectorEngine,index_js){'use strict';const NAME='collapse';const DATA_KEY='bs.collapse';const EVENT_KEY=`.${DATA_KEY}`;const DATA_API_KEY='.data-api';const EVENT_SHOW=`show${EVENT_KEY}`;const EVENT_SHOWN=`shown${EVENT_KEY}`;const EVENT_HIDE=`hide${EVENT_KEY}`;const EVENT_HIDDEN=`hidden${EVENT_KEY}`;const EVENT_CLICK_DATA_API=`click${EVENT_KEY}${DATA_API_KEY}`;const CLASS_NAME_SHOW='show';const CLASS_NAME_COLLAPSE='collapse';const CLASS_NAME_COLLAPSING='collapsing';const CLASS_NAME_COLLAPSED='collapsed';const CLASS_NAME_DEEPER_CHILDREN=`:scope .${CLASS_NAME_COLLAPSE} .${CLASS_NAME_COLLAPSE}`;const CLASS_NAME_HORIZONTAL='collapse-horizontal';const WIDTH='width';const HEIGHT='height';const SELECTOR_ACTIVES='.collapse.show, .collapse.collapsing';const SELECTOR_DATA_TOGGLE='[data-bs-toggle="collapse"]';const Default={parent:null,toggle:true};const DefaultType={parent:'(null|element)',toggle:'boolean'};class Collapse extends BaseComponent{constructor(element,config){super(element,config);this._isTransitioning=false;this._triggerArray=[];const toggleList=SelectorEngine.find(SELECTOR_DATA_TOGGLE);for(const elem of toggleList){const selector=SelectorEngine.getSelectorFromElement(elem);const filterElement=SelectorEngine.find(selector).filter(foundElement=>foundElement===this._element);if(selector!==null&&filterElement.length){this._triggerArray.push(elem);}}
this._initializeChildren();if(!this._config.parent){this._addAriaAndCollapsedClass(this._triggerArray,this._isShown());}
if(this._config.toggle){this.toggle();}}
static get Default(){return Default;}
static get DefaultType(){return DefaultType;}
static get NAME(){return NAME;}
toggle(){if(this._isShown()){this.hide();}else{this.show();}}
show(){if(this._isTransitioning||this._isShown()){return;}
let activeChildren=[];if(this._config.parent){activeChildren=this._getFirstLevelChildren(SELECTOR_ACTIVES).filter(element=>element!==this._element).map(element=>Collapse.getOrCreateInstance(element,{toggle:false}));}
if(activeChildren.length&&activeChildren[0]._isTransitioning){return;}
const startEvent=EventHandler.trigger(this._element,EVENT_SHOW);if(startEvent.defaultPrevented){return;}
for(const activeInstance of activeChildren){activeInstance.hide();}
const dimension=this._getDimension();this._element.classList.remove(CLASS_NAME_COLLAPSE);this._element.classList.add(CLASS_NAME_COLLAPSING);this._element.style[dimension]=0;this._addAriaAndCollapsedClass(this._triggerArray,true);this._isTransitioning=true;const complete=()=>{this._isTransitioning=false;this._element.classList.remove(CLASS_NAME_COLLAPSING);this._element.classList.add(CLASS_NAME_COLLAPSE,CLASS_NAME_SHOW);this._element.style[dimension]='';EventHandler.trigger(this._element,EVENT_SHOWN);};const capitalizedDimension=dimension[0].toUpperCase()+dimension.slice(1);const scrollSize=`scroll${capitalizedDimension}`;this._queueCallback(complete,this._element,true);this._element.style[dimension]=`${this._element[scrollSize]}px`;}
hide(){if(this._isTransitioning||!this._isShown()){return;}
const startEvent=EventHandler.trigger(this._element,EVENT_HIDE);if(startEvent.defaultPrevented){return;}
const dimension=this._getDimension();this._element.style[dimension]=`${this._element.getBoundingClientRect()[dimension]}px`;index_js.reflow(this._element);this._element.classList.add(CLASS_NAME_COLLAPSING);this._element.classList.remove(CLASS_NAME_COLLAPSE,CLASS_NAME_SHOW);for(const trigger of this._triggerArray){const element=SelectorEngine.getElementFromSelector(trigger);if(element&&!this._isShown(element)){this._addAriaAndCollapsedClass([trigger],false);}}
this._isTransitioning=true;const complete=()=>{this._isTransitioning=false;this._element.classList.remove(CLASS_NAME_COLLAPSING);this._element.classList.add(CLASS_NAME_COLLAPSE);EventHandler.trigger(this._element,EVENT_HIDDEN);};this._element.style[dimension]='';this._queueCallback(complete,this._element,true);}
_isShown(element=this._element){return element.classList.contains(CLASS_NAME_SHOW);}
_configAfterMerge(config){config.toggle=Boolean(config.toggle);config.parent=index_js.getElement(config.parent);return config;}
_getDimension(){return this._element.classList.contains(CLASS_NAME_HORIZONTAL)?WIDTH:HEIGHT;}
_initializeChildren(){if(!this._config.parent){return;}
const children=this._getFirstLevelChildren(SELECTOR_DATA_TOGGLE);for(const element of children){const selected=SelectorEngine.getElementFromSelector(element);if(selected){this._addAriaAndCollapsedClass([element],this._isShown(selected));}}}
_getFirstLevelChildren(selector){const children=SelectorEngine.find(CLASS_NAME_DEEPER_CHILDREN,this._config.parent);return SelectorEngine.find(selector,this._config.parent).filter(element=>!children.includes(element));}
_addAriaAndCollapsedClass(triggerArray,isOpen){if(!triggerArray.length){return;}
for(const element of triggerArray){element.classList.toggle(CLASS_NAME_COLLAPSED,!isOpen);element.setAttribute('aria-expanded',isOpen);}}
static jQueryInterface(config){const _config={};if(typeof config==='string'&&/show|hide/.test(config)){_config.toggle=false;}
return this.each(function(){const data=Collapse.getOrCreateInstance(this,_config);if(typeof config==='string'){if(typeof data[config]==='undefined'){throw new TypeError(`No method named "${config}"`);}
data[config]();}});}}
EventHandler.on(document,EVENT_CLICK_DATA_API,SELECTOR_DATA_TOGGLE,function(event){if(event.target.tagName==='A'||event.delegateTarget&&event.delegateTarget.tagName==='A'){event.preventDefault();}
for(const element of SelectorEngine.getMultipleElementsFromSelector(this)){Collapse.getOrCreateInstance(element,{toggle:false}).toggle();}});index_js.defineJQueryPlugin(Collapse);return Collapse;}));;

/* /web/static/lib/bootstrap/js/dist/dropdown.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('@popperjs/core'),require('./base-component.js'),require('./dom/event-handler.js'),require('./dom/manipulator.js'),require('./dom/selector-engine.js'),require('./util/index.js')):typeof define==='function'&&define.amd?define(['@popperjs/core','./base-component','./dom/event-handler','./dom/manipulator','./dom/selector-engine','./util/index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Dropdown=factory(global.Popper,global.BaseComponent,global.EventHandler,global.Manipulator,global.SelectorEngine,global.Index));})(this,(function(Popper,BaseComponent,EventHandler,Manipulator,SelectorEngine,index_js){'use strict';function _interopNamespaceDefault(e){const n=Object.create(null,{[Symbol.toStringTag]:{value:'Module'}});if(e){for(const k in e){if(k!=='default'){const d=Object.getOwnPropertyDescriptor(e,k);Object.defineProperty(n,k,d.get?d:{enumerable:true,get:()=>e[k]});}}}
n.default=e;return Object.freeze(n);}
const Popper__namespace=_interopNamespaceDefault(Popper);const NAME='dropdown';const DATA_KEY='bs.dropdown';const EVENT_KEY=`.${DATA_KEY}`;const DATA_API_KEY='.data-api';const ESCAPE_KEY='Escape';const TAB_KEY='Tab';const ARROW_UP_KEY='ArrowUp';const ARROW_DOWN_KEY='ArrowDown';const RIGHT_MOUSE_BUTTON=2;const EVENT_HIDE=`hide${EVENT_KEY}`;const EVENT_HIDDEN=`hidden${EVENT_KEY}`;const EVENT_SHOW=`show${EVENT_KEY}`;const EVENT_SHOWN=`shown${EVENT_KEY}`;const EVENT_CLICK_DATA_API=`click${EVENT_KEY}${DATA_API_KEY}`;const EVENT_KEYDOWN_DATA_API=`keydown${EVENT_KEY}${DATA_API_KEY}`;const EVENT_KEYUP_DATA_API=`keyup${EVENT_KEY}${DATA_API_KEY}`;const CLASS_NAME_SHOW='show';const CLASS_NAME_DROPUP='dropup';const CLASS_NAME_DROPEND='dropend';const CLASS_NAME_DROPSTART='dropstart';const CLASS_NAME_DROPUP_CENTER='dropup-center';const CLASS_NAME_DROPDOWN_CENTER='dropdown-center';const SELECTOR_DATA_TOGGLE='[data-bs-toggle="dropdown"]:not(.disabled):not(:disabled)';const SELECTOR_DATA_TOGGLE_SHOWN=`${SELECTOR_DATA_TOGGLE}.${CLASS_NAME_SHOW}`;const SELECTOR_MENU='.dropdown-menu:not(.o-dropdown--menu)';const SELECTOR_NAVBAR='.navbar';const SELECTOR_MENU_NOT_SUB='.dropdown-menu:not(.o-dropdown--menu):not(.o_wysiwyg_submenu)';const SELECTOR_NAVBAR_NAV='.navbar-nav';const SELECTOR_VISIBLE_ITEMS='.dropdown-menu .dropdown-item:not(.disabled):not(:disabled)';const PLACEMENT_TOP=index_js.isRTL()?'top-end':'top-start';const PLACEMENT_TOPEND=index_js.isRTL()?'top-start':'top-end';const PLACEMENT_BOTTOM=index_js.isRTL()?'bottom-end':'bottom-start';const PLACEMENT_BOTTOMEND=index_js.isRTL()?'bottom-start':'bottom-end';const PLACEMENT_RIGHT=index_js.isRTL()?'left-start':'right-start';const PLACEMENT_LEFT=index_js.isRTL()?'right-start':'left-start';const PLACEMENT_TOPCENTER='top';const PLACEMENT_BOTTOMCENTER='bottom';const Default={autoClose:true,boundary:'clippingParents',display:'dynamic',offset:[0,2],popperConfig:null,reference:'toggle'};const DefaultType={autoClose:'(boolean|string)',boundary:'(string|element)',display:'string',offset:'(array|string|function)',popperConfig:'(null|object|function)',reference:'(string|element|object)'};class Dropdown extends BaseComponent{constructor(element,config){super(element,config);this._popper=null;this._parent=this._element.parentNode;this._menu=SelectorEngine.next(this._element,SELECTOR_MENU)[0]||SelectorEngine.prev(this._element,SELECTOR_MENU)[0]||SelectorEngine.findOne(SELECTOR_MENU,this._parent);this._inNavbar=this._detectNavbar();}
static get Default(){return Default;}
static get DefaultType(){return DefaultType;}
static get NAME(){return NAME;}
toggle(){return this._isShown()?this.hide():this.show();}
show(){if(index_js.isDisabled(this._element)||this._isShown()){return;}
const relatedTarget={relatedTarget:this._element};const showEvent=EventHandler.trigger(this._element,EVENT_SHOW,relatedTarget);if(showEvent.defaultPrevented){return;}
this._createPopper();if('ontouchstart'in document.documentElement&&!this._parent.closest(SELECTOR_NAVBAR_NAV)){for(const element of[].concat(...document.body.children)){EventHandler.on(element,'mouseover',index_js.noop);}}
this._element.focus();this._element.setAttribute('aria-expanded',true);this._menu.classList.add(CLASS_NAME_SHOW);this._element.classList.add(CLASS_NAME_SHOW);EventHandler.trigger(this._element,EVENT_SHOWN,relatedTarget);}
hide(){if(index_js.isDisabled(this._element)||!this._isShown()){return;}
const relatedTarget={relatedTarget:this._element};this._completeHide(relatedTarget);}
dispose(){if(this._popper){this._popper.destroy();}
super.dispose();}
update(){this._inNavbar=this._detectNavbar();if(this._popper){this._popper.update();}}
_completeHide(relatedTarget){const hideEvent=EventHandler.trigger(this._element,EVENT_HIDE,relatedTarget);if(hideEvent.defaultPrevented){return;}
if('ontouchstart'in document.documentElement){for(const element of[].concat(...document.body.children)){EventHandler.off(element,'mouseover',index_js.noop);}}
if(this._popper){this._popper.destroy();}
this._menu.classList.remove(CLASS_NAME_SHOW);this._element.classList.remove(CLASS_NAME_SHOW);this._element.setAttribute('aria-expanded','false');Manipulator.removeDataAttribute(this._menu,'popper');EventHandler.trigger(this._element,EVENT_HIDDEN,relatedTarget);}
_getConfig(config){config=super._getConfig(config);if(typeof config.reference==='object'&&!index_js.isElement(config.reference)&&typeof config.reference.getBoundingClientRect!=='function'){throw new TypeError(`${NAME.toUpperCase()}: Option "reference" provided type "object" without a required "getBoundingClientRect" method.`);}
return config;}
_createPopper(){if(typeof Popper__namespace==='undefined'){throw new TypeError('Bootstrap\'s dropdowns require Popper (https://popper.js.org)');}
let referenceElement=this._element;if(this._config.reference==='parent'){referenceElement=this._parent;}else if(index_js.isElement(this._config.reference)){referenceElement=index_js.getElement(this._config.reference);}else if(typeof this._config.reference==='object'){referenceElement=this._config.reference;}
const popperConfig=this._getPopperConfig();this._popper=Popper__namespace.createPopper(referenceElement,this._menu,popperConfig);}
_isShown(){return this._menu.classList.contains(CLASS_NAME_SHOW);}
_getPlacement(){const parentDropdown=this._parent;if(parentDropdown.classList.contains(CLASS_NAME_DROPEND)){return PLACEMENT_RIGHT;}
if(parentDropdown.classList.contains(CLASS_NAME_DROPSTART)){return PLACEMENT_LEFT;}
if(parentDropdown.classList.contains(CLASS_NAME_DROPUP_CENTER)){return PLACEMENT_TOPCENTER;}
if(parentDropdown.classList.contains(CLASS_NAME_DROPDOWN_CENTER)){return PLACEMENT_BOTTOMCENTER;}
const isEnd=getComputedStyle(this._menu).getPropertyValue('--bs-position').trim()==='end';if(parentDropdown.classList.contains(CLASS_NAME_DROPUP)){return isEnd?PLACEMENT_TOPEND:PLACEMENT_TOP;}
return isEnd?PLACEMENT_BOTTOMEND:PLACEMENT_BOTTOM;}
_detectNavbar(){return this._element.closest(SELECTOR_NAVBAR)!==null;}
_getOffset(){const{offset}=this._config;if(typeof offset==='string'){return offset.split(',').map(value=>Number.parseInt(value,10));}
if(typeof offset==='function'){return popperData=>offset(popperData,this._element);}
return offset;}
_getPopperConfig(){const defaultBsPopperConfig={placement:this._getPlacement(),modifiers:[{name:'preventOverflow',options:{boundary:this._config.boundary}},{name:'offset',options:{offset:this._getOffset()}}]};if(this._inNavbar||this._config.display==='static'){Manipulator.setDataAttribute(this._menu,'popper','static');defaultBsPopperConfig.modifiers=[{name:'applyStyles',enabled:false}];}
return{...defaultBsPopperConfig,...index_js.execute(this._config.popperConfig,[defaultBsPopperConfig])};}
_selectMenuItem({key,target}){const items=SelectorEngine.find(SELECTOR_VISIBLE_ITEMS,this._menu).filter(element=>index_js.isVisible(element));if(!items.length){return;}
index_js.getNextActiveElement(items,target,key===ARROW_DOWN_KEY,!items.includes(target)).focus();}
static jQueryInterface(config){return this.each(function(){const data=Dropdown.getOrCreateInstance(this,config);if(typeof config!=='string'){return;}
if(typeof data[config]==='undefined'){throw new TypeError(`No method named "${config}"`);}
data[config]();});}
static clearMenus(event){if(event.button===RIGHT_MOUSE_BUTTON||event.type==='keyup'&&event.key!==TAB_KEY){return;}
const openToggles=SelectorEngine.find(SELECTOR_DATA_TOGGLE_SHOWN);for(const toggle of openToggles){const context=Dropdown.getInstance(toggle);if(!context||context._config.autoClose===false){continue;}
const composedPath=event.composedPath();const isMenuTarget=composedPath.includes(context._menu);if(composedPath.includes(context._element)||context._config.autoClose==='inside'&&!isMenuTarget||context._config.autoClose==='outside'&&isMenuTarget){continue;}
if(context._menu.contains(event.target)&&(event.type==='keyup'&&event.key===TAB_KEY||/input|select|option|textarea|form/i.test(event.target.tagName))){continue;}
const relatedTarget={relatedTarget:context._element};if(event.type==='click'){relatedTarget.clickEvent=event;}
context._completeHide(relatedTarget);}}
static dataApiKeydownHandler(event){const isInput=/input|textarea/i.test(event.target.tagName);const isEscapeEvent=event.key===ESCAPE_KEY;const isUpOrDownEvent=[ARROW_UP_KEY,ARROW_DOWN_KEY].includes(event.key);if(!isUpOrDownEvent&&!isEscapeEvent){return;}
if(isInput&&!isEscapeEvent){return;}
event.preventDefault();const getToggleButton=this.matches(SELECTOR_DATA_TOGGLE)?this:SelectorEngine.prev(this,SELECTOR_DATA_TOGGLE)[0]||SelectorEngine.next(this,SELECTOR_DATA_TOGGLE)[0]||SelectorEngine.findOne(SELECTOR_DATA_TOGGLE,event.delegateTarget.parentNode);const instance=Dropdown.getOrCreateInstance(getToggleButton);if(isUpOrDownEvent){event.stopPropagation();instance.show();instance._selectMenuItem(event);return;}
if(instance._isShown()){event.stopPropagation();instance.hide();getToggleButton.focus();}}}
EventHandler.on(document,EVENT_KEYDOWN_DATA_API,SELECTOR_DATA_TOGGLE,Dropdown.dataApiKeydownHandler);EventHandler.on(document,EVENT_KEYDOWN_DATA_API,SELECTOR_MENU_NOT_SUB,Dropdown.dataApiKeydownHandler);EventHandler.on(document,EVENT_CLICK_DATA_API,Dropdown.clearMenus);EventHandler.on(document,EVENT_KEYUP_DATA_API,Dropdown.clearMenus);EventHandler.on(document,EVENT_CLICK_DATA_API,SELECTOR_DATA_TOGGLE,function(event){event.preventDefault();Dropdown.getOrCreateInstance(this).toggle();});index_js.defineJQueryPlugin(Dropdown);return Dropdown;}));;

/* /web/static/lib/bootstrap/js/dist/modal.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('./base-component.js'),require('./dom/event-handler.js'),require('./dom/selector-engine.js'),require('./util/backdrop.js'),require('./util/component-functions.js'),require('./util/focustrap.js'),require('./util/index.js'),require('./util/scrollbar.js')):typeof define==='function'&&define.amd?define(['./base-component','./dom/event-handler','./dom/selector-engine','./util/backdrop','./util/component-functions','./util/focustrap','./util/index','./util/scrollbar'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Modal=factory(global.BaseComponent,global.EventHandler,global.SelectorEngine,global.Backdrop,global.ComponentFunctions,global.Focustrap,global.Index,global.Scrollbar));})(this,(function(BaseComponent,EventHandler,SelectorEngine,Backdrop,componentFunctions_js,FocusTrap,index_js,ScrollBarHelper){'use strict';const NAME='modal';const DATA_KEY='bs.modal';const EVENT_KEY=`.${DATA_KEY}`;const DATA_API_KEY='.data-api';const ESCAPE_KEY='Escape';const EVENT_HIDE=`hide${EVENT_KEY}`;const EVENT_HIDE_PREVENTED=`hidePrevented${EVENT_KEY}`;const EVENT_HIDDEN=`hidden${EVENT_KEY}`;const EVENT_SHOW=`show${EVENT_KEY}`;const EVENT_SHOWN=`shown${EVENT_KEY}`;const EVENT_RESIZE=`resize${EVENT_KEY}`;const EVENT_CLICK_DISMISS=`click.dismiss${EVENT_KEY}`;const EVENT_MOUSEDOWN_DISMISS=`mousedown.dismiss${EVENT_KEY}`;const EVENT_KEYDOWN_DISMISS=`keydown.dismiss${EVENT_KEY}`;const EVENT_CLICK_DATA_API=`click${EVENT_KEY}${DATA_API_KEY}`;const CLASS_NAME_OPEN='modal-open';const CLASS_NAME_FADE='fade';const CLASS_NAME_SHOW='show';const CLASS_NAME_STATIC='modal-static';const OPEN_SELECTOR='.modal.show';const SELECTOR_DIALOG='.modal-dialog';const SELECTOR_MODAL_BODY='.modal-body';const SELECTOR_DATA_TOGGLE='[data-bs-toggle="modal"]';const Default={backdrop:true,focus:true,keyboard:true};const DefaultType={backdrop:'(boolean|string)',focus:'boolean',keyboard:'boolean'};class Modal extends BaseComponent{constructor(element,config){super(element,config);this._dialog=SelectorEngine.findOne(SELECTOR_DIALOG,this._element);this._backdrop=this._initializeBackDrop();this._focustrap=this._initializeFocusTrap();this._isShown=false;this._isTransitioning=false;this._scrollBar=new ScrollBarHelper();this._addEventListeners();}
static get Default(){return Default;}
static get DefaultType(){return DefaultType;}
static get NAME(){return NAME;}
toggle(relatedTarget){return this._isShown?this.hide():this.show(relatedTarget);}
show(relatedTarget){if(this._isShown||this._isTransitioning){return;}
const showEvent=EventHandler.trigger(this._element,EVENT_SHOW,{relatedTarget});if(showEvent.defaultPrevented){return;}
this._isShown=true;this._isTransitioning=true;this._scrollBar.hide();document.body.classList.add(CLASS_NAME_OPEN);this._adjustDialog();this._backdrop.show(()=>this._showElement(relatedTarget));}
hide(){if(!this._isShown||this._isTransitioning){return;}
const hideEvent=EventHandler.trigger(this._element,EVENT_HIDE);if(hideEvent.defaultPrevented){return;}
this._isShown=false;this._isTransitioning=true;this._focustrap.deactivate();this._element.classList.remove(CLASS_NAME_SHOW);this._queueCallback(()=>this._hideModal(),this._element,this._isAnimated());}
dispose(){EventHandler.off(window,EVENT_KEY);EventHandler.off(this._dialog,EVENT_KEY);this._backdrop.dispose();this._focustrap.deactivate();super.dispose();}
handleUpdate(){this._adjustDialog();}
_initializeBackDrop(){return new Backdrop({isVisible:Boolean(this._config.backdrop),isAnimated:this._isAnimated()});}
_initializeFocusTrap(){return new FocusTrap({trapElement:this._element});}
_showElement(relatedTarget){if(!document.body.contains(this._element)){document.body.append(this._element);}
this._element.style.display='block';this._element.removeAttribute('aria-hidden');this._element.setAttribute('aria-modal',true);this._element.setAttribute('role','dialog');this._element.scrollTop=0;const modalBody=SelectorEngine.findOne(SELECTOR_MODAL_BODY,this._dialog);if(modalBody){modalBody.scrollTop=0;}
index_js.reflow(this._element);this._element.classList.add(CLASS_NAME_SHOW);const transitionComplete=()=>{if(this._config.focus){this._focustrap.activate();}
this._isTransitioning=false;EventHandler.trigger(this._element,EVENT_SHOWN,{relatedTarget});};this._queueCallback(transitionComplete,this._dialog,this._isAnimated());}
_addEventListeners(){EventHandler.on(this._element,EVENT_KEYDOWN_DISMISS,event=>{if(event.key!==ESCAPE_KEY){return;}
if(this._config.keyboard){this.hide();return;}
this._triggerBackdropTransition();});EventHandler.on(window,EVENT_RESIZE,()=>{if(this._isShown&&!this._isTransitioning){this._adjustDialog();}});EventHandler.on(this._element,EVENT_MOUSEDOWN_DISMISS,event=>{EventHandler.one(this._element,EVENT_CLICK_DISMISS,event2=>{if(this._element!==event.target||this._element!==event2.target){return;}
if(this._config.backdrop==='static'){this._triggerBackdropTransition();return;}
if(this._config.backdrop){this.hide();}});});}
_hideModal(){this._element.style.display='none';this._element.setAttribute('aria-hidden',true);this._element.removeAttribute('aria-modal');this._element.removeAttribute('role');this._isTransitioning=false;this._backdrop.hide(()=>{document.body.classList.remove(CLASS_NAME_OPEN);this._resetAdjustments();this._scrollBar.reset();EventHandler.trigger(this._element,EVENT_HIDDEN);});}
_isAnimated(){return this._element.classList.contains(CLASS_NAME_FADE);}
_triggerBackdropTransition(){const hideEvent=EventHandler.trigger(this._element,EVENT_HIDE_PREVENTED);if(hideEvent.defaultPrevented){return;}
const isModalOverflowing=this._element.scrollHeight>document.documentElement.clientHeight;const initialOverflowY=this._element.style.overflowY;if(initialOverflowY==='hidden'||this._element.classList.contains(CLASS_NAME_STATIC)){return;}
if(!isModalOverflowing){this._element.style.overflowY='hidden';}
this._element.classList.add(CLASS_NAME_STATIC);this._queueCallback(()=>{this._element.classList.remove(CLASS_NAME_STATIC);this._queueCallback(()=>{this._element.style.overflowY=initialOverflowY;},this._dialog);},this._dialog);this._element.focus();}
_adjustDialog(){const isModalOverflowing=this._element.scrollHeight>document.documentElement.clientHeight;const scrollbarWidth=this._scrollBar.getWidth();const isBodyOverflowing=scrollbarWidth>0;if(isBodyOverflowing&&!isModalOverflowing){const property=index_js.isRTL()?'paddingLeft':'paddingRight';this._element.style[property]=`${scrollbarWidth}px`;}
if(!isBodyOverflowing&&isModalOverflowing){const property=index_js.isRTL()?'paddingRight':'paddingLeft';this._element.style[property]=`${scrollbarWidth}px`;}}
_resetAdjustments(){this._element.style.paddingLeft='';this._element.style.paddingRight='';}
static jQueryInterface(config,relatedTarget){return this.each(function(){const data=Modal.getOrCreateInstance(this,config);if(typeof config!=='string'){return;}
if(typeof data[config]==='undefined'){throw new TypeError(`No method named "${config}"`);}
data[config](relatedTarget);});}}
EventHandler.on(document,EVENT_CLICK_DATA_API,SELECTOR_DATA_TOGGLE,function(event){const target=SelectorEngine.getElementFromSelector(this);if(['A','AREA'].includes(this.tagName)){event.preventDefault();}
EventHandler.one(target,EVENT_SHOW,showEvent=>{if(showEvent.defaultPrevented){return;}
EventHandler.one(target,EVENT_HIDDEN,()=>{if(index_js.isVisible(this)){this.focus();}});});const alreadyOpen=SelectorEngine.findOne(OPEN_SELECTOR);if(alreadyOpen){Modal.getInstance(alreadyOpen).hide();}
const data=Modal.getOrCreateInstance(target);data.toggle(this);});componentFunctions_js.enableDismissTrigger(Modal);index_js.defineJQueryPlugin(Modal);return Modal;}));;

/* /web/static/lib/bootstrap/js/dist/offcanvas.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('./base-component.js'),require('./dom/event-handler.js'),require('./dom/selector-engine.js'),require('./util/backdrop.js'),require('./util/component-functions.js'),require('./util/focustrap.js'),require('./util/index.js'),require('./util/scrollbar.js')):typeof define==='function'&&define.amd?define(['./base-component','./dom/event-handler','./dom/selector-engine','./util/backdrop','./util/component-functions','./util/focustrap','./util/index','./util/scrollbar'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Offcanvas=factory(global.BaseComponent,global.EventHandler,global.SelectorEngine,global.Backdrop,global.ComponentFunctions,global.Focustrap,global.Index,global.Scrollbar));})(this,(function(BaseComponent,EventHandler,SelectorEngine,Backdrop,componentFunctions_js,FocusTrap,index_js,ScrollBarHelper){'use strict';const NAME='offcanvas';const DATA_KEY='bs.offcanvas';const EVENT_KEY=`.${DATA_KEY}`;const DATA_API_KEY='.data-api';const EVENT_LOAD_DATA_API=`load${EVENT_KEY}${DATA_API_KEY}`;const ESCAPE_KEY='Escape';const CLASS_NAME_SHOW='show';const CLASS_NAME_SHOWING='showing';const CLASS_NAME_HIDING='hiding';const CLASS_NAME_BACKDROP='offcanvas-backdrop';const OPEN_SELECTOR='.offcanvas.show';const EVENT_SHOW=`show${EVENT_KEY}`;const EVENT_SHOWN=`shown${EVENT_KEY}`;const EVENT_HIDE=`hide${EVENT_KEY}`;const EVENT_HIDE_PREVENTED=`hidePrevented${EVENT_KEY}`;const EVENT_HIDDEN=`hidden${EVENT_KEY}`;const EVENT_RESIZE=`resize${EVENT_KEY}`;const EVENT_CLICK_DATA_API=`click${EVENT_KEY}${DATA_API_KEY}`;const EVENT_KEYDOWN_DISMISS=`keydown.dismiss${EVENT_KEY}`;const SELECTOR_DATA_TOGGLE='[data-bs-toggle="offcanvas"]';const Default={backdrop:true,keyboard:true,scroll:false};const DefaultType={backdrop:'(boolean|string)',keyboard:'boolean',scroll:'boolean'};class Offcanvas extends BaseComponent{constructor(element,config){super(element,config);this._isShown=false;this._backdrop=this._initializeBackDrop();this._focustrap=this._initializeFocusTrap();this._addEventListeners();}
static get Default(){return Default;}
static get DefaultType(){return DefaultType;}
static get NAME(){return NAME;}
toggle(relatedTarget){return this._isShown?this.hide():this.show(relatedTarget);}
show(relatedTarget){if(this._isShown){return;}
const showEvent=EventHandler.trigger(this._element,EVENT_SHOW,{relatedTarget});if(showEvent.defaultPrevented){return;}
this._isShown=true;this._backdrop.show();if(!this._config.scroll){new ScrollBarHelper().hide();}
this._element.setAttribute('aria-modal',true);this._element.setAttribute('role','dialog');this._element.classList.add(CLASS_NAME_SHOWING);const completeCallBack=()=>{if(!this._config.scroll||this._config.backdrop){this._focustrap.activate();}
this._element.classList.add(CLASS_NAME_SHOW);this._element.classList.remove(CLASS_NAME_SHOWING);EventHandler.trigger(this._element,EVENT_SHOWN,{relatedTarget});};this._queueCallback(completeCallBack,this._element,true);}
hide(){if(!this._isShown){return;}
const hideEvent=EventHandler.trigger(this._element,EVENT_HIDE);if(hideEvent.defaultPrevented){return;}
this._focustrap.deactivate();this._element.blur();this._isShown=false;this._element.classList.add(CLASS_NAME_HIDING);this._backdrop.hide();const completeCallback=()=>{this._element.classList.remove(CLASS_NAME_SHOW,CLASS_NAME_HIDING);this._element.removeAttribute('aria-modal');this._element.removeAttribute('role');if(!this._config.scroll){new ScrollBarHelper().reset();}
EventHandler.trigger(this._element,EVENT_HIDDEN);};this._queueCallback(completeCallback,this._element,true);}
dispose(){this._backdrop.dispose();this._focustrap.deactivate();super.dispose();}
_initializeBackDrop(){const clickCallback=()=>{if(this._config.backdrop==='static'){EventHandler.trigger(this._element,EVENT_HIDE_PREVENTED);return;}
this.hide();};const isVisible=Boolean(this._config.backdrop);return new Backdrop({className:CLASS_NAME_BACKDROP,isVisible,isAnimated:true,rootElement:this._element.parentNode,clickCallback:isVisible?clickCallback:null});}
_initializeFocusTrap(){return new FocusTrap({trapElement:this._element});}
_addEventListeners(){EventHandler.on(this._element,EVENT_KEYDOWN_DISMISS,event=>{if(event.key!==ESCAPE_KEY){return;}
if(this._config.keyboard){this.hide();return;}
EventHandler.trigger(this._element,EVENT_HIDE_PREVENTED);});}
static jQueryInterface(config){return this.each(function(){const data=Offcanvas.getOrCreateInstance(this,config);if(typeof config!=='string'){return;}
if(data[config]===undefined||config.startsWith('_')||config==='constructor'){throw new TypeError(`No method named "${config}"`);}
data[config](this);});}}
EventHandler.on(document,EVENT_CLICK_DATA_API,SELECTOR_DATA_TOGGLE,function(event){const target=SelectorEngine.getElementFromSelector(this);if(['A','AREA'].includes(this.tagName)){event.preventDefault();}
if(index_js.isDisabled(this)){return;}
EventHandler.one(target,EVENT_HIDDEN,()=>{if(index_js.isVisible(this)){this.focus();}});const alreadyOpen=SelectorEngine.findOne(OPEN_SELECTOR);if(alreadyOpen&&alreadyOpen!==target){Offcanvas.getInstance(alreadyOpen).hide();}
const data=Offcanvas.getOrCreateInstance(target);data.toggle(this);});EventHandler.on(window,EVENT_LOAD_DATA_API,()=>{for(const selector of SelectorEngine.find(OPEN_SELECTOR)){Offcanvas.getOrCreateInstance(selector).show();}});EventHandler.on(window,EVENT_RESIZE,()=>{for(const element of SelectorEngine.find('[aria-modal][class*=show][class*=offcanvas-]')){if(getComputedStyle(element).position!=='fixed'){Offcanvas.getOrCreateInstance(element).hide();}}});componentFunctions_js.enableDismissTrigger(Offcanvas);index_js.defineJQueryPlugin(Offcanvas);return Offcanvas;}));;

/* /web/static/lib/bootstrap/js/dist/tooltip.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('@popperjs/core'),require('./base-component.js'),require('./dom/event-handler.js'),require('./dom/manipulator.js'),require('./util/index.js'),require('./util/sanitizer.js'),require('./util/template-factory.js')):typeof define==='function'&&define.amd?define(['@popperjs/core','./base-component','./dom/event-handler','./dom/manipulator','./util/index','./util/sanitizer','./util/template-factory'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Tooltip=factory(global.Popper,global.BaseComponent,global.EventHandler,global.Manipulator,global.Index,global.Sanitizer,global.TemplateFactory));})(this,(function(Popper,BaseComponent,EventHandler,Manipulator,index_js,sanitizer_js,TemplateFactory){'use strict';function _interopNamespaceDefault(e){const n=Object.create(null,{[Symbol.toStringTag]:{value:'Module'}});if(e){for(const k in e){if(k!=='default'){const d=Object.getOwnPropertyDescriptor(e,k);Object.defineProperty(n,k,d.get?d:{enumerable:true,get:()=>e[k]});}}}
n.default=e;return Object.freeze(n);}
const Popper__namespace=_interopNamespaceDefault(Popper);const NAME='tooltip';const DISALLOWED_ATTRIBUTES=new Set(['sanitize','allowList','sanitizeFn']);const CLASS_NAME_FADE='fade';const CLASS_NAME_MODAL='modal';const CLASS_NAME_SHOW='show';const SELECTOR_TOOLTIP_INNER='.tooltip-inner';const SELECTOR_MODAL=`.${CLASS_NAME_MODAL}`;const EVENT_MODAL_HIDE='hide.bs.modal';const TRIGGER_HOVER='hover';const TRIGGER_FOCUS='focus';const TRIGGER_CLICK='click';const TRIGGER_MANUAL='manual';const EVENT_HIDE='hide';const EVENT_HIDDEN='hidden';const EVENT_SHOW='show';const EVENT_SHOWN='shown';const EVENT_INSERTED='inserted';const EVENT_CLICK='click';const EVENT_FOCUSIN='focusin';const EVENT_FOCUSOUT='focusout';const EVENT_MOUSEENTER='mouseenter';const EVENT_MOUSELEAVE='mouseleave';const AttachmentMap={AUTO:'auto',TOP:'top',RIGHT:index_js.isRTL()?'left':'right',BOTTOM:'bottom',LEFT:index_js.isRTL()?'right':'left'};const Default={allowList:sanitizer_js.DefaultAllowlist,animation:true,boundary:'clippingParents',container:false,customClass:'',delay:0,fallbackPlacements:['top','right','bottom','left'],html:false,offset:[0,6],placement:'top',popperConfig:null,sanitize:true,sanitizeFn:null,selector:false,template:'<div class="tooltip" role="tooltip">'+'<div class="tooltip-arrow"></div>'+'<div class="tooltip-inner"></div>'+'</div>',title:'',trigger:'hover focus'};const DefaultType={allowList:'object',animation:'boolean',boundary:'(string|element)',container:'(string|element|boolean)',customClass:'(string|function)',delay:'(number|object)',fallbackPlacements:'array',html:'boolean',offset:'(array|string|function)',placement:'(string|function)',popperConfig:'(null|object|function)',sanitize:'boolean',sanitizeFn:'(null|function)',selector:'(string|boolean)',template:'string',title:'(string|element|function)',trigger:'string'};class Tooltip extends BaseComponent{constructor(element,config){if(typeof Popper__namespace==='undefined'){throw new TypeError('Bootstrap\'s tooltips require Popper (https://popper.js.org)');}
super(element,config);this._isEnabled=true;this._timeout=0;this._isHovered=null;this._activeTrigger={};this._popper=null;this._templateFactory=null;this._newContent=null;this.tip=null;this._setListeners();if(!this._config.selector){this._fixTitle();}}
static get Default(){return Default;}
static get DefaultType(){return DefaultType;}
static get NAME(){return NAME;}
enable(){this._isEnabled=true;}
disable(){this._isEnabled=false;}
toggleEnabled(){this._isEnabled=!this._isEnabled;}
toggle(){if(!this._isEnabled){return;}
this._activeTrigger.click=!this._activeTrigger.click;if(this._isShown()){this._leave();return;}
this._enter();}
dispose(){clearTimeout(this._timeout);EventHandler.off(this._element.closest(SELECTOR_MODAL),EVENT_MODAL_HIDE,this._hideModalHandler);if(this._element.getAttribute('data-bs-original-title')){this._element.setAttribute('title',this._element.getAttribute('data-bs-original-title'));}
this._disposePopper();super.dispose();}
show(){if(this._element.style.display==='none'){throw new Error('Please use show on visible elements');}
if(!(this._isWithContent()&&this._isEnabled)){return;}
const showEvent=EventHandler.trigger(this._element,this.constructor.eventName(EVENT_SHOW));const shadowRoot=index_js.findShadowRoot(this._element);const isInTheDom=(shadowRoot||this._element.ownerDocument.documentElement).contains(this._element);if(showEvent.defaultPrevented||!isInTheDom){return;}
this._disposePopper();const tip=this._getTipElement();this._element.setAttribute('aria-describedby',tip.getAttribute('id'));const{container}=this._config;if(!this._element.ownerDocument.documentElement.contains(this.tip)){container.append(tip);EventHandler.trigger(this._element,this.constructor.eventName(EVENT_INSERTED));}
this._popper=this._createPopper(tip);tip.classList.add(CLASS_NAME_SHOW);if('ontouchstart'in document.documentElement){for(const element of[].concat(...document.body.children)){EventHandler.on(element,'mouseover',index_js.noop);}}
const complete=()=>{EventHandler.trigger(this._element,this.constructor.eventName(EVENT_SHOWN));if(this._isHovered===false){this._leave();}
this._isHovered=false;};this._queueCallback(complete,this.tip,this._isAnimated());}
hide(){if(!this._isShown()){return;}
const hideEvent=EventHandler.trigger(this._element,this.constructor.eventName(EVENT_HIDE));if(hideEvent.defaultPrevented){return;}
const tip=this._getTipElement();tip.classList.remove(CLASS_NAME_SHOW);if('ontouchstart'in document.documentElement){for(const element of[].concat(...document.body.children)){EventHandler.off(element,'mouseover',index_js.noop);}}
this._activeTrigger[TRIGGER_CLICK]=false;this._activeTrigger[TRIGGER_FOCUS]=false;this._activeTrigger[TRIGGER_HOVER]=false;this._isHovered=null;const complete=()=>{if(this._isWithActiveTrigger()){return;}
if(!this._isHovered){this._disposePopper();}
this._element.removeAttribute('aria-describedby');EventHandler.trigger(this._element,this.constructor.eventName(EVENT_HIDDEN));};this._queueCallback(complete,this.tip,this._isAnimated());}
update(){if(this._popper){this._popper.update();}}
_isWithContent(){return Boolean(this._getTitle());}
_getTipElement(){if(!this.tip){this.tip=this._createTipElement(this._newContent||this._getContentForTemplate());}
return this.tip;}
_createTipElement(content){const tip=this._getTemplateFactory(content).toHtml();if(!tip){return null;}
tip.classList.remove(CLASS_NAME_FADE,CLASS_NAME_SHOW);tip.classList.add(`bs-${this.constructor.NAME}-auto`);const tipId=index_js.getUID(this.constructor.NAME).toString();tip.setAttribute('id',tipId);if(this._isAnimated()){tip.classList.add(CLASS_NAME_FADE);}
return tip;}
setContent(content){this._newContent=content;if(this._isShown()){this._disposePopper();this.show();}}
_getTemplateFactory(content){if(this._templateFactory){this._templateFactory.changeContent(content);}else{this._templateFactory=new TemplateFactory({...this._config,content,extraClass:this._resolvePossibleFunction(this._config.customClass)});}
return this._templateFactory;}
_getContentForTemplate(){return{[SELECTOR_TOOLTIP_INNER]:this._getTitle()};}
_getTitle(){return this._resolvePossibleFunction(this._config.title)||this._element.getAttribute('data-bs-original-title');}
_initializeOnDelegatedTarget(event){return this.constructor.getOrCreateInstance(event.delegateTarget,this._getDelegateConfig());}
_isAnimated(){return this._config.animation||this.tip&&this.tip.classList.contains(CLASS_NAME_FADE);}
_isShown(){return this.tip&&this.tip.classList.contains(CLASS_NAME_SHOW);}
_createPopper(tip){const placement=index_js.execute(this._config.placement,[this,tip,this._element]);const attachment=AttachmentMap[placement.toUpperCase()];return Popper__namespace.createPopper(this._element,tip,this._getPopperConfig(attachment));}
_getOffset(){const{offset}=this._config;if(typeof offset==='string'){return offset.split(',').map(value=>Number.parseInt(value,10));}
if(typeof offset==='function'){return popperData=>offset(popperData,this._element);}
return offset;}
_resolvePossibleFunction(arg){return index_js.execute(arg,[this._element]);}
_getPopperConfig(attachment){const defaultBsPopperConfig={placement:attachment,modifiers:[{name:'flip',options:{fallbackPlacements:this._config.fallbackPlacements}},{name:'offset',options:{offset:this._getOffset()}},{name:'preventOverflow',options:{boundary:this._config.boundary}},{name:'arrow',options:{element:`.${this.constructor.NAME}-arrow`}},{name:'preSetPlacement',enabled:true,phase:'beforeMain',fn:data=>{this._getTipElement().setAttribute('data-popper-placement',data.state.placement);}}]};return{...defaultBsPopperConfig,...index_js.execute(this._config.popperConfig,[defaultBsPopperConfig])};}
_setListeners(){const triggers=this._config.trigger.split(' ');for(const trigger of triggers){if(trigger==='click'){EventHandler.on(this._element,this.constructor.eventName(EVENT_CLICK),this._config.selector,event=>{const context=this._initializeOnDelegatedTarget(event);context.toggle();});}else if(trigger!==TRIGGER_MANUAL){const eventIn=trigger===TRIGGER_HOVER?this.constructor.eventName(EVENT_MOUSEENTER):this.constructor.eventName(EVENT_FOCUSIN);const eventOut=trigger===TRIGGER_HOVER?this.constructor.eventName(EVENT_MOUSELEAVE):this.constructor.eventName(EVENT_FOCUSOUT);EventHandler.on(this._element,eventIn,this._config.selector,event=>{const context=this._initializeOnDelegatedTarget(event);context._activeTrigger[event.type==='focusin'?TRIGGER_FOCUS:TRIGGER_HOVER]=true;context._enter();});EventHandler.on(this._element,eventOut,this._config.selector,event=>{const context=this._initializeOnDelegatedTarget(event);context._activeTrigger[event.type==='focusout'?TRIGGER_FOCUS:TRIGGER_HOVER]=context._element.contains(event.relatedTarget);context._leave();});}}
this._hideModalHandler=()=>{if(this._element){this.hide();}};EventHandler.on(this._element.closest(SELECTOR_MODAL),EVENT_MODAL_HIDE,this._hideModalHandler);}
_fixTitle(){const title=this._element.getAttribute('title');if(!title){return;}
if(!this._element.getAttribute('aria-label')&&!this._element.textContent.trim()){this._element.setAttribute('aria-label',title);}
this._element.setAttribute('data-bs-original-title',title);this._element.removeAttribute('title');}
_enter(){if(this._isShown()||this._isHovered){this._isHovered=true;return;}
this._isHovered=true;this._setTimeout(()=>{if(this._isHovered){this.show();}},this._config.delay.show);}
_leave(){if(this._isWithActiveTrigger()){return;}
this._isHovered=false;this._setTimeout(()=>{if(!this._isHovered){this.hide();}},this._config.delay.hide);}
_setTimeout(handler,timeout){clearTimeout(this._timeout);this._timeout=setTimeout(handler,timeout);}
_isWithActiveTrigger(){return Object.values(this._activeTrigger).includes(true);}
_getConfig(config){const dataAttributes=Manipulator.getDataAttributes(this._element);for(const dataAttribute of Object.keys(dataAttributes)){if(DISALLOWED_ATTRIBUTES.has(dataAttribute)){delete dataAttributes[dataAttribute];}}
config={...dataAttributes,...(typeof config==='object'&&config?config:{})};config=this._mergeConfigObj(config);config=this._configAfterMerge(config);this._typeCheckConfig(config);return config;}
_configAfterMerge(config){config.container=config.container===false?document.body:index_js.getElement(config.container);if(typeof config.delay==='number'){config.delay={show:config.delay,hide:config.delay};}
if(typeof config.title==='number'){config.title=config.title.toString();}
if(typeof config.content==='number'){config.content=config.content.toString();}
return config;}
_getDelegateConfig(){const config={};for(const[key,value]of Object.entries(this._config)){if(this.constructor.Default[key]!==value){config[key]=value;}}
config.selector=false;config.trigger='manual';return config;}
_disposePopper(){if(this._popper){this._popper.destroy();this._popper=null;}
if(this.tip){this.tip.remove();this.tip=null;}}
static jQueryInterface(config){return this.each(function(){const data=Tooltip.getOrCreateInstance(this,config);if(typeof config!=='string'){return;}
if(typeof data[config]==='undefined'){throw new TypeError(`No method named "${config}"`);}
data[config]();});}}
index_js.defineJQueryPlugin(Tooltip);return Tooltip;}));;

/* /web/static/lib/bootstrap/js/dist/popover.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('./tooltip.js'),require('./util/index.js')):typeof define==='function'&&define.amd?define(['./tooltip','./util/index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Popover=factory(global.Tooltip,global.Index));})(this,(function(Tooltip,index_js){'use strict';const NAME='popover';const SELECTOR_TITLE='.popover-header';const SELECTOR_CONTENT='.popover-body';const Default={...Tooltip.Default,content:'',offset:[0,8],placement:'right',template:'<div class="popover" role="tooltip">'+'<div class="popover-arrow"></div>'+'<h3 class="popover-header"></h3>'+'<div class="popover-body"></div>'+'</div>',trigger:'click'};const DefaultType={...Tooltip.DefaultType,content:'(null|string|element|function)'};class Popover extends Tooltip{static get Default(){return Default;}
static get DefaultType(){return DefaultType;}
static get NAME(){return NAME;}
_isWithContent(){return this._getTitle()||this._getContent();}
_getContentForTemplate(){return{[SELECTOR_TITLE]:this._getTitle(),[SELECTOR_CONTENT]:this._getContent()};}
_getContent(){return this._resolvePossibleFunction(this._config.content);}
static jQueryInterface(config){return this.each(function(){const data=Popover.getOrCreateInstance(this,config);if(typeof config!=='string'){return;}
if(typeof data[config]==='undefined'){throw new TypeError(`No method named "${config}"`);}
data[config]();});}}
index_js.defineJQueryPlugin(Popover);return Popover;}));;

/* /web/static/lib/bootstrap/js/dist/scrollspy.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('./base-component.js'),require('./dom/event-handler.js'),require('./dom/selector-engine.js'),require('./util/index.js')):typeof define==='function'&&define.amd?define(['./base-component','./dom/event-handler','./dom/selector-engine','./util/index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.ScrollSpy=factory(global.BaseComponent,global.EventHandler,global.SelectorEngine,global.Index));})(this,(function(BaseComponent,EventHandler,SelectorEngine,index_js){'use strict';const NAME='scrollspy';const DATA_KEY='bs.scrollspy';const EVENT_KEY=`.${DATA_KEY}`;const DATA_API_KEY='.data-api';const EVENT_ACTIVATE=`activate${EVENT_KEY}`;const EVENT_CLICK=`click${EVENT_KEY}`;const EVENT_LOAD_DATA_API=`load${EVENT_KEY}${DATA_API_KEY}`;const CLASS_NAME_DROPDOWN_ITEM='dropdown-item';const CLASS_NAME_ACTIVE='active';const SELECTOR_DATA_SPY='[data-bs-spy="scroll"]';const SELECTOR_TARGET_LINKS='[href]';const SELECTOR_NAV_LIST_GROUP='.nav, .list-group';const SELECTOR_NAV_LINKS='.nav-link';const SELECTOR_NAV_ITEMS='.nav-item';const SELECTOR_LIST_ITEMS='.list-group-item';const SELECTOR_LINK_ITEMS=`${SELECTOR_NAV_LINKS}, ${SELECTOR_NAV_ITEMS} > ${SELECTOR_NAV_LINKS}, ${SELECTOR_LIST_ITEMS}`;const SELECTOR_DROPDOWN='.dropdown';const SELECTOR_DROPDOWN_TOGGLE='.dropdown-toggle';const Default={offset:null,rootMargin:'0px 0px -25%',smoothScroll:false,target:null,threshold:[0.1,0.5,1]};const DefaultType={offset:'(number|null)',rootMargin:'string',smoothScroll:'boolean',target:'element',threshold:'array'};class ScrollSpy extends BaseComponent{constructor(element,config){super(element,config);this._targetLinks=new Map();this._observableSections=new Map();this._rootElement=getComputedStyle(this._element).overflowY==='visible'?null:this._element;this._activeTarget=null;this._observer=null;this._previousScrollData={visibleEntryTop:0,parentScrollTop:0};this.refresh();}
static get Default(){return Default;}
static get DefaultType(){return DefaultType;}
static get NAME(){return NAME;}
refresh(){this._initializeTargetsAndObservables();this._maybeEnableSmoothScroll();if(this._observer){this._observer.disconnect();}else{this._observer=this._getNewObserver();}
for(const section of this._observableSections.values()){this._observer.observe(section);}}
dispose(){this._observer.disconnect();super.dispose();}
_configAfterMerge(config){config.target=index_js.getElement(config.target)||document.body;config.rootMargin=config.offset?`${config.offset}px 0px -30%`:config.rootMargin;if(typeof config.threshold==='string'){config.threshold=config.threshold.split(',').map(value=>Number.parseFloat(value));}
return config;}
_maybeEnableSmoothScroll(){if(!this._config.smoothScroll){return;}
EventHandler.off(this._config.target,EVENT_CLICK);EventHandler.on(this._config.target,EVENT_CLICK,SELECTOR_TARGET_LINKS,event=>{const observableSection=this._observableSections.get(event.target.hash);if(observableSection){event.preventDefault();const root=this._rootElement||window;const height=observableSection.offsetTop-this._element.offsetTop;if(root.scrollTo){root.scrollTo({top:height,behavior:'smooth'});return;}
root.scrollTop=height;}});}
_getNewObserver(){const options={root:this._rootElement,threshold:this._config.threshold,rootMargin:this._config.rootMargin};return new IntersectionObserver(entries=>this._observerCallback(entries),options);}
_observerCallback(entries){const targetElement=entry=>this._targetLinks.get(`#${entry.target.id}`);const activate=entry=>{this._previousScrollData.visibleEntryTop=entry.target.offsetTop;this._process(targetElement(entry));};const parentScrollTop=(this._rootElement||document.documentElement).scrollTop;const userScrollsDown=parentScrollTop>=this._previousScrollData.parentScrollTop;this._previousScrollData.parentScrollTop=parentScrollTop;for(const entry of entries){if(!entry.isIntersecting){this._activeTarget=null;this._clearActiveClass(targetElement(entry));continue;}
const entryIsLowerThanPrevious=entry.target.offsetTop>=this._previousScrollData.visibleEntryTop;if(userScrollsDown&&entryIsLowerThanPrevious){activate(entry);if(!parentScrollTop){return;}
continue;}
if(!userScrollsDown&&!entryIsLowerThanPrevious){activate(entry);}}}
_initializeTargetsAndObservables(){this._targetLinks=new Map();this._observableSections=new Map();const targetLinks=SelectorEngine.find(SELECTOR_TARGET_LINKS,this._config.target);for(const anchor of targetLinks){if(!anchor.hash||index_js.isDisabled(anchor)){continue;}
const observableSection=SelectorEngine.findOne(decodeURI(anchor.hash),this._element);if(index_js.isVisible(observableSection)){this._targetLinks.set(decodeURI(anchor.hash),anchor);this._observableSections.set(anchor.hash,observableSection);}}}
_process(target){if(this._activeTarget===target){return;}
this._clearActiveClass(this._config.target);this._activeTarget=target;target.classList.add(CLASS_NAME_ACTIVE);this._activateParents(target);EventHandler.trigger(this._element,EVENT_ACTIVATE,{relatedTarget:target});}
_activateParents(target){if(target.classList.contains(CLASS_NAME_DROPDOWN_ITEM)){SelectorEngine.findOne(SELECTOR_DROPDOWN_TOGGLE,target.closest(SELECTOR_DROPDOWN)).classList.add(CLASS_NAME_ACTIVE);return;}
for(const listGroup of SelectorEngine.parents(target,SELECTOR_NAV_LIST_GROUP)){for(const item of SelectorEngine.prev(listGroup,SELECTOR_LINK_ITEMS)){item.classList.add(CLASS_NAME_ACTIVE);}}}
_clearActiveClass(parent){parent.classList.remove(CLASS_NAME_ACTIVE);const activeNodes=SelectorEngine.find(`${SELECTOR_TARGET_LINKS}.${CLASS_NAME_ACTIVE}`,parent);for(const node of activeNodes){node.classList.remove(CLASS_NAME_ACTIVE);}}
static jQueryInterface(config){return this.each(function(){const data=ScrollSpy.getOrCreateInstance(this,config);if(typeof config!=='string'){return;}
if(data[config]===undefined||config.startsWith('_')||config==='constructor'){throw new TypeError(`No method named "${config}"`);}
data[config]();});}}
EventHandler.on(window,EVENT_LOAD_DATA_API,()=>{for(const spy of SelectorEngine.find(SELECTOR_DATA_SPY)){ScrollSpy.getOrCreateInstance(spy);}});index_js.defineJQueryPlugin(ScrollSpy);return ScrollSpy;}));;

/* /web/static/lib/bootstrap/js/dist/tab.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('./base-component.js'),require('./dom/event-handler.js'),require('./dom/selector-engine.js'),require('./util/index.js')):typeof define==='function'&&define.amd?define(['./base-component','./dom/event-handler','./dom/selector-engine','./util/index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Tab=factory(global.BaseComponent,global.EventHandler,global.SelectorEngine,global.Index));})(this,(function(BaseComponent,EventHandler,SelectorEngine,index_js){'use strict';const NAME='tab';const DATA_KEY='bs.tab';const EVENT_KEY=`.${DATA_KEY}`;const EVENT_HIDE=`hide${EVENT_KEY}`;const EVENT_HIDDEN=`hidden${EVENT_KEY}`;const EVENT_SHOW=`show${EVENT_KEY}`;const EVENT_SHOWN=`shown${EVENT_KEY}`;const EVENT_CLICK_DATA_API=`click${EVENT_KEY}`;const EVENT_KEYDOWN=`keydown${EVENT_KEY}`;const EVENT_LOAD_DATA_API=`load${EVENT_KEY}`;const ARROW_LEFT_KEY='ArrowLeft';const ARROW_RIGHT_KEY='ArrowRight';const ARROW_UP_KEY='ArrowUp';const ARROW_DOWN_KEY='ArrowDown';const HOME_KEY='Home';const END_KEY='End';const CLASS_NAME_ACTIVE='active';const CLASS_NAME_FADE='fade';const CLASS_NAME_SHOW='show';const CLASS_DROPDOWN='dropdown';const SELECTOR_DROPDOWN_TOGGLE='.dropdown-toggle';const SELECTOR_DROPDOWN_MENU='.dropdown-menu';const NOT_SELECTOR_DROPDOWN_TOGGLE=`:not(${SELECTOR_DROPDOWN_TOGGLE})`;const SELECTOR_TAB_PANEL='.list-group, .nav, [role="tablist"]';const SELECTOR_OUTER='.nav-item, .list-group-item';const SELECTOR_INNER=`.nav-link${NOT_SELECTOR_DROPDOWN_TOGGLE}, .list-group-item${NOT_SELECTOR_DROPDOWN_TOGGLE}, [role="tab"]${NOT_SELECTOR_DROPDOWN_TOGGLE}`;const SELECTOR_DATA_TOGGLE='[data-bs-toggle="tab"], [data-bs-toggle="pill"], [data-bs-toggle="list"]';const SELECTOR_INNER_ELEM=`${SELECTOR_INNER}, ${SELECTOR_DATA_TOGGLE}`;const SELECTOR_DATA_TOGGLE_ACTIVE=`.${CLASS_NAME_ACTIVE}[data-bs-toggle="tab"], .${CLASS_NAME_ACTIVE}[data-bs-toggle="pill"], .${CLASS_NAME_ACTIVE}[data-bs-toggle="list"]`;class Tab extends BaseComponent{constructor(element){super(element);this._parent=this._element.closest(SELECTOR_TAB_PANEL);if(!this._parent){return;}
this._setInitialAttributes(this._parent,this._getChildren());EventHandler.on(this._element,EVENT_KEYDOWN,event=>this._keydown(event));}
static get NAME(){return NAME;}
show(){const innerElem=this._element;if(this._elemIsActive(innerElem)){return;}
const active=this._getActiveElem();const hideEvent=active?EventHandler.trigger(active,EVENT_HIDE,{relatedTarget:innerElem}):null;const showEvent=EventHandler.trigger(innerElem,EVENT_SHOW,{relatedTarget:active});if(showEvent.defaultPrevented||hideEvent&&hideEvent.defaultPrevented){return;}
this._deactivate(active,innerElem);this._activate(innerElem,active);}
_activate(element,relatedElem){if(!element){return;}
element.classList.add(CLASS_NAME_ACTIVE);this._activate(SelectorEngine.getElementFromSelector(element));const complete=()=>{if(element.getAttribute('role')!=='tab'){element.classList.add(CLASS_NAME_SHOW);return;}
element.removeAttribute('tabindex');element.setAttribute('aria-selected',true);this._toggleDropDown(element,true);EventHandler.trigger(element,EVENT_SHOWN,{relatedTarget:relatedElem});};this._queueCallback(complete,element,element.classList.contains(CLASS_NAME_FADE));}
_deactivate(element,relatedElem){if(!element){return;}
element.classList.remove(CLASS_NAME_ACTIVE);element.blur();this._deactivate(SelectorEngine.getElementFromSelector(element));const complete=()=>{if(element.getAttribute('role')!=='tab'){element.classList.remove(CLASS_NAME_SHOW);return;}
element.setAttribute('aria-selected',false);element.setAttribute('tabindex','-1');this._toggleDropDown(element,false);EventHandler.trigger(element,EVENT_HIDDEN,{relatedTarget:relatedElem});};this._queueCallback(complete,element,element.classList.contains(CLASS_NAME_FADE));}
_keydown(event){if(![ARROW_LEFT_KEY,ARROW_RIGHT_KEY,ARROW_UP_KEY,ARROW_DOWN_KEY,HOME_KEY,END_KEY].includes(event.key)){return;}
event.stopPropagation();event.preventDefault();const children=this._getChildren().filter(element=>!index_js.isDisabled(element));let nextActiveElement;if([HOME_KEY,END_KEY].includes(event.key)){nextActiveElement=children[event.key===HOME_KEY?0:children.length-1];}else{const isNext=[ARROW_RIGHT_KEY,ARROW_DOWN_KEY].includes(event.key);nextActiveElement=index_js.getNextActiveElement(children,event.target,isNext,true);}
if(nextActiveElement){nextActiveElement.focus({preventScroll:true});Tab.getOrCreateInstance(nextActiveElement).show();}}
_getChildren(){return SelectorEngine.find(SELECTOR_INNER_ELEM,this._parent);}
_getActiveElem(){return this._getChildren().find(child=>this._elemIsActive(child))||null;}
_setInitialAttributes(parent,children){this._setAttributeIfNotExists(parent,'role','tablist');for(const child of children){this._setInitialAttributesOnChild(child);}}
_setInitialAttributesOnChild(child){child=this._getInnerElement(child);const isActive=this._elemIsActive(child);const outerElem=this._getOuterElement(child);child.setAttribute('aria-selected',isActive);if(outerElem!==child){this._setAttributeIfNotExists(outerElem,'role','presentation');}
if(!isActive){child.setAttribute('tabindex','-1');}
this._setAttributeIfNotExists(child,'role','tab');this._setInitialAttributesOnTargetPanel(child);}
_setInitialAttributesOnTargetPanel(child){const target=SelectorEngine.getElementFromSelector(child);if(!target){return;}
this._setAttributeIfNotExists(target,'role','tabpanel');if(child.id){this._setAttributeIfNotExists(target,'aria-labelledby',`${child.id}`);}}
_toggleDropDown(element,open){const outerElem=this._getOuterElement(element);if(!outerElem.classList.contains(CLASS_DROPDOWN)){return;}
const toggle=(selector,className)=>{const element=SelectorEngine.findOne(selector,outerElem);if(element){element.classList.toggle(className,open);}};toggle(SELECTOR_DROPDOWN_TOGGLE,CLASS_NAME_ACTIVE);toggle(SELECTOR_DROPDOWN_MENU,CLASS_NAME_SHOW);outerElem.setAttribute('aria-expanded',open);}
_setAttributeIfNotExists(element,attribute,value){if(!element.hasAttribute(attribute)){element.setAttribute(attribute,value);}}
_elemIsActive(elem){return elem.classList.contains(CLASS_NAME_ACTIVE);}
_getInnerElement(elem){return elem.matches(SELECTOR_INNER_ELEM)?elem:SelectorEngine.findOne(SELECTOR_INNER_ELEM,elem);}
_getOuterElement(elem){return elem.closest(SELECTOR_OUTER)||elem;}
static jQueryInterface(config){return this.each(function(){const data=Tab.getOrCreateInstance(this);if(typeof config!=='string'){return;}
if(data[config]===undefined||config.startsWith('_')||config==='constructor'){throw new TypeError(`No method named "${config}"`);}
data[config]();});}}
EventHandler.on(document,EVENT_CLICK_DATA_API,SELECTOR_DATA_TOGGLE,function(event){if(['A','AREA'].includes(this.tagName)){event.preventDefault();}
if(index_js.isDisabled(this)){return;}
Tab.getOrCreateInstance(this).show();});EventHandler.on(window,EVENT_LOAD_DATA_API,()=>{for(const element of SelectorEngine.find(SELECTOR_DATA_TOGGLE_ACTIVE)){Tab.getOrCreateInstance(element);}});index_js.defineJQueryPlugin(Tab);return Tab;}));;

/* /web/static/lib/bootstrap/js/dist/toast.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory(require('./base-component.js'),require('./dom/event-handler.js'),require('./util/component-functions.js'),require('./util/index.js')):typeof define==='function'&&define.amd?define(['./base-component','./dom/event-handler','./util/component-functions','./util/index'],factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.Toast=factory(global.BaseComponent,global.EventHandler,global.ComponentFunctions,global.Index));})(this,(function(BaseComponent,EventHandler,componentFunctions_js,index_js){'use strict';const NAME='toast';const DATA_KEY='bs.toast';const EVENT_KEY=`.${DATA_KEY}`;const EVENT_MOUSEOVER=`mouseover${EVENT_KEY}`;const EVENT_MOUSEOUT=`mouseout${EVENT_KEY}`;const EVENT_FOCUSIN=`focusin${EVENT_KEY}`;const EVENT_FOCUSOUT=`focusout${EVENT_KEY}`;const EVENT_HIDE=`hide${EVENT_KEY}`;const EVENT_HIDDEN=`hidden${EVENT_KEY}`;const EVENT_SHOW=`show${EVENT_KEY}`;const EVENT_SHOWN=`shown${EVENT_KEY}`;const CLASS_NAME_FADE='fade';const CLASS_NAME_HIDE='hide';const CLASS_NAME_SHOW='show';const CLASS_NAME_SHOWING='showing';const DefaultType={animation:'boolean',autohide:'boolean',delay:'number'};const Default={animation:true,autohide:true,delay:5000};class Toast extends BaseComponent{constructor(element,config){super(element,config);this._timeout=null;this._hasMouseInteraction=false;this._hasKeyboardInteraction=false;this._setListeners();}
static get Default(){return Default;}
static get DefaultType(){return DefaultType;}
static get NAME(){return NAME;}
show(){const showEvent=EventHandler.trigger(this._element,EVENT_SHOW);if(showEvent.defaultPrevented){return;}
this._clearTimeout();if(this._config.animation){this._element.classList.add(CLASS_NAME_FADE);}
const complete=()=>{this._element.classList.remove(CLASS_NAME_SHOWING);EventHandler.trigger(this._element,EVENT_SHOWN);this._maybeScheduleHide();};this._element.classList.remove(CLASS_NAME_HIDE);index_js.reflow(this._element);this._element.classList.add(CLASS_NAME_SHOW,CLASS_NAME_SHOWING);this._queueCallback(complete,this._element,this._config.animation);}
hide(){if(!this.isShown()){return;}
const hideEvent=EventHandler.trigger(this._element,EVENT_HIDE);if(hideEvent.defaultPrevented){return;}
const complete=()=>{this._element.classList.add(CLASS_NAME_HIDE);this._element.classList.remove(CLASS_NAME_SHOWING,CLASS_NAME_SHOW);EventHandler.trigger(this._element,EVENT_HIDDEN);};this._element.classList.add(CLASS_NAME_SHOWING);this._queueCallback(complete,this._element,this._config.animation);}
dispose(){this._clearTimeout();if(this.isShown()){this._element.classList.remove(CLASS_NAME_SHOW);}
super.dispose();}
isShown(){return this._element.classList.contains(CLASS_NAME_SHOW);}
_maybeScheduleHide(){if(!this._config.autohide){return;}
if(this._hasMouseInteraction||this._hasKeyboardInteraction){return;}
this._timeout=setTimeout(()=>{this.hide();},this._config.delay);}
_onInteraction(event,isInteracting){switch(event.type){case'mouseover':case'mouseout':{this._hasMouseInteraction=isInteracting;break;}
case'focusin':case'focusout':{this._hasKeyboardInteraction=isInteracting;break;}}
if(isInteracting){this._clearTimeout();return;}
const nextElement=event.relatedTarget;if(this._element===nextElement||this._element.contains(nextElement)){return;}
this._maybeScheduleHide();}
_setListeners(){EventHandler.on(this._element,EVENT_MOUSEOVER,event=>this._onInteraction(event,true));EventHandler.on(this._element,EVENT_MOUSEOUT,event=>this._onInteraction(event,false));EventHandler.on(this._element,EVENT_FOCUSIN,event=>this._onInteraction(event,true));EventHandler.on(this._element,EVENT_FOCUSOUT,event=>this._onInteraction(event,false));}
_clearTimeout(){clearTimeout(this._timeout);this._timeout=null;}
static jQueryInterface(config){return this.each(function(){const data=Toast.getOrCreateInstance(this,config);if(typeof config==='string'){if(typeof data[config]==='undefined'){throw new TypeError(`No method named "${config}"`);}
data[config](this);}});}}
componentFunctions_js.enableDismissTrigger(Toast);index_js.defineJQueryPlugin(Toast);return Toast;}));;

/* /web/static/src/libs/bootstrap.js */
odoo.define('@web/libs/bootstrap',['@web/core/utils/scrolling'],function(require){'use strict';let __exports={};const{compensateScrollbar,getScrollingElement}=require("@web/core/utils/scrolling");const bsSanitizeAllowList=Tooltip.Default.allowList;bsSanitizeAllowList["*"].push("title","style",/^data-[\w-]+/);bsSanitizeAllowList.header=[];bsSanitizeAllowList.main=[];bsSanitizeAllowList.footer=[];bsSanitizeAllowList.caption=[];bsSanitizeAllowList.col=["span"];bsSanitizeAllowList.colgroup=["span"];bsSanitizeAllowList.table=[];bsSanitizeAllowList.thead=[];bsSanitizeAllowList.tbody=[];bsSanitizeAllowList.tfooter=[];bsSanitizeAllowList.tr=[];bsSanitizeAllowList.th=["colspan","rowspan"];bsSanitizeAllowList.td=["colspan","rowspan"];bsSanitizeAllowList.address=[];bsSanitizeAllowList.article=[];bsSanitizeAllowList.aside=[];bsSanitizeAllowList.blockquote=[];bsSanitizeAllowList.section=[];bsSanitizeAllowList.button=["type"];bsSanitizeAllowList.del=[];Tooltip.Default.placement="auto";Tooltip.Default.fallbackPlacement=["bottom","right","left","top"];Tooltip.Default.html=true;Tooltip.Default.trigger="hover";Tooltip.Default.container="body";Tooltip.Default.boundary="window";Tooltip.Default.delay={show:1000,hide:0};const bootstrapShowFunction=Tooltip.prototype.show;Tooltip.prototype.show=function(){document.querySelectorAll(".tooltip").forEach((el)=>el.remove());const errorsToIgnore=["Please use show on visible elements"];try{return bootstrapShowFunction.call(this);}catch(error){if(errorsToIgnore.includes(error.message)){return 0;}
throw error;}};Dropdown.prototype._detectNavbar=function(){return false;};const bsAdjustDialogFunction=Modal.prototype._adjustDialog;Modal.prototype._adjustDialog=function(){const document=this._element.ownerDocument;this._scrollBar.reset();document.body.classList.remove("modal-open");const scrollable=getScrollingElement(document);if(document.body.contains(scrollable)){compensateScrollbar(scrollable,true);}
this._scrollBar.hide();document.body.classList.add("modal-open");return bsAdjustDialogFunction.apply(this,arguments);};const bsResetAdjustmentsFunction=Modal.prototype._resetAdjustments;Modal.prototype._resetAdjustments=function(){const document=this._element.ownerDocument;this._scrollBar.reset();document.body.classList.remove("modal-open");const scrollable=getScrollingElement(document);if(document.body.contains(scrollable)){compensateScrollbar(scrollable,false);}
return bsResetAdjustmentsFunction.apply(this,arguments);};return __exports;});;

/* /web/static/lib/dompurify/DOMpurify.js */
(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?module.exports=factory():typeof define==='function'&&define.amd?define(factory):(global=typeof globalThis!=='undefined'?globalThis:global||self,global.DOMPurify=factory());})(this,(function(){'use strict';const{entries,setPrototypeOf,isFrozen,getPrototypeOf,getOwnPropertyDescriptor}=Object;let{freeze,seal,create}=Object;let{apply,construct}=typeof Reflect!=='undefined'&&Reflect;if(!freeze){freeze=function freeze(x){return x;};}
if(!seal){seal=function seal(x){return x;};}
if(!apply){apply=function apply(fun,thisValue,args){return fun.apply(thisValue,args);};}
if(!construct){construct=function construct(Func,args){return new Func(...args);};}
const arrayForEach=unapply(Array.prototype.forEach);const arrayPop=unapply(Array.prototype.pop);const arrayPush=unapply(Array.prototype.push);const stringToLowerCase=unapply(String.prototype.toLowerCase);const stringToString=unapply(String.prototype.toString);const stringMatch=unapply(String.prototype.match);const stringReplace=unapply(String.prototype.replace);const stringIndexOf=unapply(String.prototype.indexOf);const stringTrim=unapply(String.prototype.trim);const objectHasOwnProperty=unapply(Object.prototype.hasOwnProperty);const regExpTest=unapply(RegExp.prototype.test);const typeErrorCreate=unconstruct(TypeError);function unapply(func){return function(thisArg){for(var _len=arguments.length,args=new Array(_len>1?_len-1:0),_key=1;_key<_len;_key++){args[_key-1]=arguments[_key];}
return apply(func,thisArg,args);};}
function unconstruct(func){return function(){for(var _len2=arguments.length,args=new Array(_len2),_key2=0;_key2<_len2;_key2++){args[_key2]=arguments[_key2];}
return construct(func,args);};}
function addToSet(set,array){let transformCaseFunc=arguments.length>2&&arguments[2]!==undefined?arguments[2]:stringToLowerCase;if(setPrototypeOf){setPrototypeOf(set,null);}
let l=array.length;while(l--){let element=array[l];if(typeof element==='string'){const lcElement=transformCaseFunc(element);if(lcElement!==element){if(!isFrozen(array)){array[l]=lcElement;}
element=lcElement;}}
set[element]=true;}
return set;}
function cleanArray(array){for(let index=0;index<array.length;index++){const isPropertyExist=objectHasOwnProperty(array,index);if(!isPropertyExist){array[index]=null;}}
return array;}
function clone(object){const newObject=create(null);for(const[property,value]of entries(object)){const isPropertyExist=objectHasOwnProperty(object,property);if(isPropertyExist){if(Array.isArray(value)){newObject[property]=cleanArray(value);}else if(value&&typeof value==='object'&&value.constructor===Object){newObject[property]=clone(value);}else{newObject[property]=value;}}}
return newObject;}
function lookupGetter(object,prop){while(object!==null){const desc=getOwnPropertyDescriptor(object,prop);if(desc){if(desc.get){return unapply(desc.get);}
if(typeof desc.value==='function'){return unapply(desc.value);}}
object=getPrototypeOf(object);}
function fallbackValue(){return null;}
return fallbackValue;}
const html$1=freeze(['a','abbr','acronym','address','area','article','aside','audio','b','bdi','bdo','big','blink','blockquote','body','br','button','canvas','caption','center','cite','code','col','colgroup','content','data','datalist','dd','decorator','del','details','dfn','dialog','dir','div','dl','dt','element','em','fieldset','figcaption','figure','font','footer','form','h1','h2','h3','h4','h5','h6','head','header','hgroup','hr','html','i','img','input','ins','kbd','label','legend','li','main','map','mark','marquee','menu','menuitem','meter','nav','nobr','ol','optgroup','option','output','p','picture','pre','progress','q','rp','rt','ruby','s','samp','section','select','shadow','small','source','spacer','span','strike','strong','style','sub','summary','sup','table','tbody','td','template','textarea','tfoot','th','thead','time','tr','track','tt','u','ul','var','video','wbr']);const svg$1=freeze(['svg','a','altglyph','altglyphdef','altglyphitem','animatecolor','animatemotion','animatetransform','circle','clippath','defs','desc','ellipse','filter','font','g','glyph','glyphref','hkern','image','line','lineargradient','marker','mask','metadata','mpath','path','pattern','polygon','polyline','radialgradient','rect','stop','style','switch','symbol','text','textpath','title','tref','tspan','view','vkern']);const svgFilters=freeze(['feBlend','feColorMatrix','feComponentTransfer','feComposite','feConvolveMatrix','feDiffuseLighting','feDisplacementMap','feDistantLight','feDropShadow','feFlood','feFuncA','feFuncB','feFuncG','feFuncR','feGaussianBlur','feImage','feMerge','feMergeNode','feMorphology','feOffset','fePointLight','feSpecularLighting','feSpotLight','feTile','feTurbulence']);const svgDisallowed=freeze(['animate','color-profile','cursor','discard','font-face','font-face-format','font-face-name','font-face-src','font-face-uri','foreignobject','hatch','hatchpath','mesh','meshgradient','meshpatch','meshrow','missing-glyph','script','set','solidcolor','unknown','use']);const mathMl$1=freeze(['math','menclose','merror','mfenced','mfrac','mglyph','mi','mlabeledtr','mmultiscripts','mn','mo','mover','mpadded','mphantom','mroot','mrow','ms','mspace','msqrt','mstyle','msub','msup','msubsup','mtable','mtd','mtext','mtr','munder','munderover','mprescripts']);const mathMlDisallowed=freeze(['maction','maligngroup','malignmark','mlongdiv','mscarries','mscarry','msgroup','mstack','msline','msrow','semantics','annotation','annotation-xml','mprescripts','none']);const text=freeze(['#text']);const html=freeze(['accept','action','align','alt','autocapitalize','autocomplete','autopictureinpicture','autoplay','background','bgcolor','border','capture','cellpadding','cellspacing','checked','cite','class','clear','color','cols','colspan','controls','controlslist','coords','crossorigin','datetime','decoding','default','dir','disabled','disablepictureinpicture','disableremoteplayback','download','draggable','enctype','enterkeyhint','face','for','headers','height','hidden','high','href','hreflang','id','inputmode','integrity','ismap','kind','label','lang','list','loading','loop','low','max','maxlength','media','method','min','minlength','multiple','muted','name','nonce','noshade','novalidate','nowrap','open','optimum','pattern','placeholder','playsinline','popover','popovertarget','popovertargetaction','poster','preload','pubdate','radiogroup','readonly','rel','required','rev','reversed','role','rows','rowspan','spellcheck','scope','selected','shape','size','sizes','span','srclang','start','src','srcset','step','style','summary','tabindex','title','translate','type','usemap','valign','value','width','wrap','xmlns','slot']);const svg=freeze(['accent-height','accumulate','additive','alignment-baseline','ascent','attributename','attributetype','azimuth','basefrequency','baseline-shift','begin','bias','by','class','clip','clippathunits','clip-path','clip-rule','color','color-interpolation','color-interpolation-filters','color-profile','color-rendering','cx','cy','d','dx','dy','diffuseconstant','direction','display','divisor','dur','edgemode','elevation','end','fill','fill-opacity','fill-rule','filter','filterunits','flood-color','flood-opacity','font-family','font-size','font-size-adjust','font-stretch','font-style','font-variant','font-weight','fx','fy','g1','g2','glyph-name','glyphref','gradientunits','gradienttransform','height','href','id','image-rendering','in','in2','k','k1','k2','k3','k4','kerning','keypoints','keysplines','keytimes','lang','lengthadjust','letter-spacing','kernelmatrix','kernelunitlength','lighting-color','local','marker-end','marker-mid','marker-start','markerheight','markerunits','markerwidth','maskcontentunits','maskunits','max','mask','media','method','mode','min','name','numoctaves','offset','operator','opacity','order','orient','orientation','origin','overflow','paint-order','path','pathlength','patterncontentunits','patterntransform','patternunits','points','preservealpha','preserveaspectratio','primitiveunits','r','rx','ry','radius','refx','refy','repeatcount','repeatdur','restart','result','rotate','scale','seed','shape-rendering','specularconstant','specularexponent','spreadmethod','startoffset','stddeviation','stitchtiles','stop-color','stop-opacity','stroke-dasharray','stroke-dashoffset','stroke-linecap','stroke-linejoin','stroke-miterlimit','stroke-opacity','stroke','stroke-width','style','surfacescale','systemlanguage','tabindex','targetx','targety','transform','transform-origin','text-anchor','text-decoration','text-rendering','textlength','type','u1','u2','unicode','values','viewbox','visibility','version','vert-adv-y','vert-origin-x','vert-origin-y','width','word-spacing','wrap','writing-mode','xchannelselector','ychannelselector','x','x1','x2','xmlns','y','y1','y2','z','zoomandpan']);const mathMl=freeze(['accent','accentunder','align','bevelled','close','columnsalign','columnlines','columnspan','denomalign','depth','dir','display','displaystyle','encoding','fence','frame','height','href','id','largeop','length','linethickness','lspace','lquote','mathbackground','mathcolor','mathsize','mathvariant','maxsize','minsize','movablelimits','notation','numalign','open','rowalign','rowlines','rowspacing','rowspan','rspace','rquote','scriptlevel','scriptminsize','scriptsizemultiplier','selection','separator','separators','stretchy','subscriptshift','supscriptshift','symmetric','voffset','width','xmlns']);const xml=freeze(['xlink:href','xml:id','xlink:title','xml:space','xmlns:xlink']);const MUSTACHE_EXPR=seal(/\{\{[\w\W]*|[\w\W]*\}\}/gm);const ERB_EXPR=seal(/<%[\w\W]*|[\w\W]*%>/gm);const TMPLIT_EXPR=seal(/\${[\w\W]*}/gm);const DATA_ATTR=seal(/^data-[\-\w.\u00B7-\uFFFF]/);const ARIA_ATTR=seal(/^aria-[\-\w]+$/);const IS_ALLOWED_URI=seal(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i);const IS_SCRIPT_OR_DATA=seal(/^(?:\w+script|data):/i);const ATTR_WHITESPACE=seal(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g);const DOCTYPE_NAME=seal(/^html$/i);const CUSTOM_ELEMENT=seal(/^[a-z][.\w]*(-[.\w]+)+$/i);var EXPRESSIONS=Object.freeze({__proto__:null,MUSTACHE_EXPR:MUSTACHE_EXPR,ERB_EXPR:ERB_EXPR,TMPLIT_EXPR:TMPLIT_EXPR,DATA_ATTR:DATA_ATTR,ARIA_ATTR:ARIA_ATTR,IS_ALLOWED_URI:IS_ALLOWED_URI,IS_SCRIPT_OR_DATA:IS_SCRIPT_OR_DATA,ATTR_WHITESPACE:ATTR_WHITESPACE,DOCTYPE_NAME:DOCTYPE_NAME,CUSTOM_ELEMENT:CUSTOM_ELEMENT});const NODE_TYPE={element:1,attribute:2,text:3,cdataSection:4,entityReference:5,entityNode:6,progressingInstruction:7,comment:8,document:9,documentType:10,documentFragment:11,notation:12};const getGlobal=function getGlobal(){return typeof window==='undefined'?null:window;};const _createTrustedTypesPolicy=function _createTrustedTypesPolicy(trustedTypes,purifyHostElement){if(typeof trustedTypes!=='object'||typeof trustedTypes.createPolicy!=='function'){return null;}
let suffix=null;const ATTR_NAME='data-tt-policy-suffix';if(purifyHostElement&&purifyHostElement.hasAttribute(ATTR_NAME)){suffix=purifyHostElement.getAttribute(ATTR_NAME);}
const policyName='dompurify'+(suffix?'#'+suffix:'');try{return trustedTypes.createPolicy(policyName,{createHTML(html){return html;},createScriptURL(scriptUrl){return scriptUrl;}});}catch(_){console.warn('TrustedTypes policy '+policyName+' could not be created.');return null;}};function createDOMPurify(){let window=arguments.length>0&&arguments[0]!==undefined?arguments[0]:getGlobal();const DOMPurify=root=>createDOMPurify(root);DOMPurify.version='3.1.5';DOMPurify.removed=[];if(!window||!window.document||window.document.nodeType!==NODE_TYPE.document){DOMPurify.isSupported=false;return DOMPurify;}
let{document}=window;const originalDocument=document;const currentScript=originalDocument.currentScript;const{DocumentFragment,HTMLTemplateElement,Node,Element,NodeFilter,NamedNodeMap=window.NamedNodeMap||window.MozNamedAttrMap,HTMLFormElement,DOMParser,trustedTypes}=window;const ElementPrototype=Element.prototype;const cloneNode=lookupGetter(ElementPrototype,'cloneNode');const getNextSibling=lookupGetter(ElementPrototype,'nextSibling');const getChildNodes=lookupGetter(ElementPrototype,'childNodes');const getParentNode=lookupGetter(ElementPrototype,'parentNode');if(typeof HTMLTemplateElement==='function'){const template=document.createElement('template');if(template.content&&template.content.ownerDocument){document=template.content.ownerDocument;}}
let trustedTypesPolicy;let emptyHTML='';const{implementation,createNodeIterator,createDocumentFragment,getElementsByTagName}=document;const{importNode}=originalDocument;let hooks={};DOMPurify.isSupported=typeof entries==='function'&&typeof getParentNode==='function'&&implementation&&implementation.createHTMLDocument!==undefined;const{MUSTACHE_EXPR,ERB_EXPR,TMPLIT_EXPR,DATA_ATTR,ARIA_ATTR,IS_SCRIPT_OR_DATA,ATTR_WHITESPACE,CUSTOM_ELEMENT}=EXPRESSIONS;let{IS_ALLOWED_URI:IS_ALLOWED_URI$1}=EXPRESSIONS;let ALLOWED_TAGS=null;const DEFAULT_ALLOWED_TAGS=addToSet({},[...html$1,...svg$1,...svgFilters,...mathMl$1,...text]);let ALLOWED_ATTR=null;const DEFAULT_ALLOWED_ATTR=addToSet({},[...html,...svg,...mathMl,...xml]);let CUSTOM_ELEMENT_HANDLING=Object.seal(create(null,{tagNameCheck:{writable:true,configurable:false,enumerable:true,value:null},attributeNameCheck:{writable:true,configurable:false,enumerable:true,value:null},allowCustomizedBuiltInElements:{writable:true,configurable:false,enumerable:true,value:false}}));let FORBID_TAGS=null;let FORBID_ATTR=null;let ALLOW_ARIA_ATTR=true;let ALLOW_DATA_ATTR=true;let ALLOW_UNKNOWN_PROTOCOLS=false;let ALLOW_SELF_CLOSE_IN_ATTR=true;let SAFE_FOR_TEMPLATES=false;let SAFE_FOR_XML=true;let WHOLE_DOCUMENT=false;let SET_CONFIG=false;let FORCE_BODY=false;let RETURN_DOM=false;let RETURN_DOM_FRAGMENT=false;let RETURN_TRUSTED_TYPE=false;let SANITIZE_DOM=true;let SANITIZE_NAMED_PROPS=false;const SANITIZE_NAMED_PROPS_PREFIX='user-content-';let KEEP_CONTENT=true;let IN_PLACE=false;let USE_PROFILES={};let FORBID_CONTENTS=null;const DEFAULT_FORBID_CONTENTS=addToSet({},['annotation-xml','audio','colgroup','desc','foreignobject','head','iframe','math','mi','mn','mo','ms','mtext','noembed','noframes','noscript','plaintext','script','style','svg','template','thead','title','video','xmp']);let DATA_URI_TAGS=null;const DEFAULT_DATA_URI_TAGS=addToSet({},['audio','video','img','source','image','track']);let URI_SAFE_ATTRIBUTES=null;const DEFAULT_URI_SAFE_ATTRIBUTES=addToSet({},['alt','class','for','id','label','name','pattern','placeholder','role','summary','title','value','style','xmlns']);const MATHML_NAMESPACE='http://www.w3.org/1998/Math/MathML';const SVG_NAMESPACE='http://www.w3.org/2000/svg';const HTML_NAMESPACE='http://www.w3.org/1999/xhtml';let NAMESPACE=HTML_NAMESPACE;let IS_EMPTY_INPUT=false;let ALLOWED_NAMESPACES=null;const DEFAULT_ALLOWED_NAMESPACES=addToSet({},[MATHML_NAMESPACE,SVG_NAMESPACE,HTML_NAMESPACE],stringToString);let PARSER_MEDIA_TYPE=null;const SUPPORTED_PARSER_MEDIA_TYPES=['application/xhtml+xml','text/html'];const DEFAULT_PARSER_MEDIA_TYPE='text/html';let transformCaseFunc=null;let CONFIG=null;const formElement=document.createElement('form');const isRegexOrFunction=function isRegexOrFunction(testValue){return testValue instanceof RegExp||testValue instanceof Function;};const _parseConfig=function _parseConfig(){let cfg=arguments.length>0&&arguments[0]!==undefined?arguments[0]:{};if(CONFIG&&CONFIG===cfg){return;}
if(!cfg||typeof cfg!=='object'){cfg={};}
cfg=clone(cfg);PARSER_MEDIA_TYPE=SUPPORTED_PARSER_MEDIA_TYPES.indexOf(cfg.PARSER_MEDIA_TYPE)===-1?DEFAULT_PARSER_MEDIA_TYPE:cfg.PARSER_MEDIA_TYPE;transformCaseFunc=PARSER_MEDIA_TYPE==='application/xhtml+xml'?stringToString:stringToLowerCase;ALLOWED_TAGS=objectHasOwnProperty(cfg,'ALLOWED_TAGS')?addToSet({},cfg.ALLOWED_TAGS,transformCaseFunc):DEFAULT_ALLOWED_TAGS;ALLOWED_ATTR=objectHasOwnProperty(cfg,'ALLOWED_ATTR')?addToSet({},cfg.ALLOWED_ATTR,transformCaseFunc):DEFAULT_ALLOWED_ATTR;ALLOWED_NAMESPACES=objectHasOwnProperty(cfg,'ALLOWED_NAMESPACES')?addToSet({},cfg.ALLOWED_NAMESPACES,stringToString):DEFAULT_ALLOWED_NAMESPACES;URI_SAFE_ATTRIBUTES=objectHasOwnProperty(cfg,'ADD_URI_SAFE_ATTR')?addToSet(clone(DEFAULT_URI_SAFE_ATTRIBUTES),cfg.ADD_URI_SAFE_ATTR,transformCaseFunc):DEFAULT_URI_SAFE_ATTRIBUTES;DATA_URI_TAGS=objectHasOwnProperty(cfg,'ADD_DATA_URI_TAGS')?addToSet(clone(DEFAULT_DATA_URI_TAGS),cfg.ADD_DATA_URI_TAGS,transformCaseFunc):DEFAULT_DATA_URI_TAGS;FORBID_CONTENTS=objectHasOwnProperty(cfg,'FORBID_CONTENTS')?addToSet({},cfg.FORBID_CONTENTS,transformCaseFunc):DEFAULT_FORBID_CONTENTS;FORBID_TAGS=objectHasOwnProperty(cfg,'FORBID_TAGS')?addToSet({},cfg.FORBID_TAGS,transformCaseFunc):{};FORBID_ATTR=objectHasOwnProperty(cfg,'FORBID_ATTR')?addToSet({},cfg.FORBID_ATTR,transformCaseFunc):{};USE_PROFILES=objectHasOwnProperty(cfg,'USE_PROFILES')?cfg.USE_PROFILES:false;ALLOW_ARIA_ATTR=cfg.ALLOW_ARIA_ATTR!==false;ALLOW_DATA_ATTR=cfg.ALLOW_DATA_ATTR!==false;ALLOW_UNKNOWN_PROTOCOLS=cfg.ALLOW_UNKNOWN_PROTOCOLS||false;ALLOW_SELF_CLOSE_IN_ATTR=cfg.ALLOW_SELF_CLOSE_IN_ATTR!==false;SAFE_FOR_TEMPLATES=cfg.SAFE_FOR_TEMPLATES||false;SAFE_FOR_XML=cfg.SAFE_FOR_XML!==false;WHOLE_DOCUMENT=cfg.WHOLE_DOCUMENT||false;RETURN_DOM=cfg.RETURN_DOM||false;RETURN_DOM_FRAGMENT=cfg.RETURN_DOM_FRAGMENT||false;RETURN_TRUSTED_TYPE=cfg.RETURN_TRUSTED_TYPE||false;FORCE_BODY=cfg.FORCE_BODY||false;SANITIZE_DOM=cfg.SANITIZE_DOM!==false;SANITIZE_NAMED_PROPS=cfg.SANITIZE_NAMED_PROPS||false;KEEP_CONTENT=cfg.KEEP_CONTENT!==false;IN_PLACE=cfg.IN_PLACE||false;IS_ALLOWED_URI$1=cfg.ALLOWED_URI_REGEXP||IS_ALLOWED_URI;NAMESPACE=cfg.NAMESPACE||HTML_NAMESPACE;CUSTOM_ELEMENT_HANDLING=cfg.CUSTOM_ELEMENT_HANDLING||{};if(cfg.CUSTOM_ELEMENT_HANDLING&&isRegexOrFunction(cfg.CUSTOM_ELEMENT_HANDLING.tagNameCheck)){CUSTOM_ELEMENT_HANDLING.tagNameCheck=cfg.CUSTOM_ELEMENT_HANDLING.tagNameCheck;}
if(cfg.CUSTOM_ELEMENT_HANDLING&&isRegexOrFunction(cfg.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)){CUSTOM_ELEMENT_HANDLING.attributeNameCheck=cfg.CUSTOM_ELEMENT_HANDLING.attributeNameCheck;}
if(cfg.CUSTOM_ELEMENT_HANDLING&&typeof cfg.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements==='boolean'){CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=cfg.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements;}
if(SAFE_FOR_TEMPLATES){ALLOW_DATA_ATTR=false;}
if(RETURN_DOM_FRAGMENT){RETURN_DOM=true;}
if(USE_PROFILES){ALLOWED_TAGS=addToSet({},text);ALLOWED_ATTR=[];if(USE_PROFILES.html===true){addToSet(ALLOWED_TAGS,html$1);addToSet(ALLOWED_ATTR,html);}
if(USE_PROFILES.svg===true){addToSet(ALLOWED_TAGS,svg$1);addToSet(ALLOWED_ATTR,svg);addToSet(ALLOWED_ATTR,xml);}
if(USE_PROFILES.svgFilters===true){addToSet(ALLOWED_TAGS,svgFilters);addToSet(ALLOWED_ATTR,svg);addToSet(ALLOWED_ATTR,xml);}
if(USE_PROFILES.mathMl===true){addToSet(ALLOWED_TAGS,mathMl$1);addToSet(ALLOWED_ATTR,mathMl);addToSet(ALLOWED_ATTR,xml);}}
if(cfg.ADD_TAGS){if(ALLOWED_TAGS===DEFAULT_ALLOWED_TAGS){ALLOWED_TAGS=clone(ALLOWED_TAGS);}
addToSet(ALLOWED_TAGS,cfg.ADD_TAGS,transformCaseFunc);}
if(cfg.ADD_ATTR){if(ALLOWED_ATTR===DEFAULT_ALLOWED_ATTR){ALLOWED_ATTR=clone(ALLOWED_ATTR);}
addToSet(ALLOWED_ATTR,cfg.ADD_ATTR,transformCaseFunc);}
if(cfg.ADD_URI_SAFE_ATTR){addToSet(URI_SAFE_ATTRIBUTES,cfg.ADD_URI_SAFE_ATTR,transformCaseFunc);}
if(cfg.FORBID_CONTENTS){if(FORBID_CONTENTS===DEFAULT_FORBID_CONTENTS){FORBID_CONTENTS=clone(FORBID_CONTENTS);}
addToSet(FORBID_CONTENTS,cfg.FORBID_CONTENTS,transformCaseFunc);}
if(KEEP_CONTENT){ALLOWED_TAGS['#text']=true;}
if(WHOLE_DOCUMENT){addToSet(ALLOWED_TAGS,['html','head','body']);}
if(ALLOWED_TAGS.table){addToSet(ALLOWED_TAGS,['tbody']);delete FORBID_TAGS.tbody;}
if(cfg.TRUSTED_TYPES_POLICY){if(typeof cfg.TRUSTED_TYPES_POLICY.createHTML!=='function'){throw typeErrorCreate('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');}
if(typeof cfg.TRUSTED_TYPES_POLICY.createScriptURL!=='function'){throw typeErrorCreate('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');}
trustedTypesPolicy=cfg.TRUSTED_TYPES_POLICY;emptyHTML=trustedTypesPolicy.createHTML('');}else{if(trustedTypesPolicy===undefined){trustedTypesPolicy=_createTrustedTypesPolicy(trustedTypes,currentScript);}
if(trustedTypesPolicy!==null&&typeof emptyHTML==='string'){emptyHTML=trustedTypesPolicy.createHTML('');}}
if(freeze){freeze(cfg);}
CONFIG=cfg;};const MATHML_TEXT_INTEGRATION_POINTS=addToSet({},['mi','mo','mn','ms','mtext']);const HTML_INTEGRATION_POINTS=addToSet({},['foreignobject','annotation-xml']);const COMMON_SVG_AND_HTML_ELEMENTS=addToSet({},['title','style','font','a','script']);const ALL_SVG_TAGS=addToSet({},[...svg$1,...svgFilters,...svgDisallowed]);const ALL_MATHML_TAGS=addToSet({},[...mathMl$1,...mathMlDisallowed]);const _checkValidNamespace=function _checkValidNamespace(element){let parent=getParentNode(element);if(!parent||!parent.tagName){parent={namespaceURI:NAMESPACE,tagName:'template'};}
const tagName=stringToLowerCase(element.tagName);const parentTagName=stringToLowerCase(parent.tagName);if(!ALLOWED_NAMESPACES[element.namespaceURI]){return false;}
if(element.namespaceURI===SVG_NAMESPACE){if(parent.namespaceURI===HTML_NAMESPACE){return tagName==='svg';}
if(parent.namespaceURI===MATHML_NAMESPACE){return tagName==='svg'&&(parentTagName==='annotation-xml'||MATHML_TEXT_INTEGRATION_POINTS[parentTagName]);}
return Boolean(ALL_SVG_TAGS[tagName]);}
if(element.namespaceURI===MATHML_NAMESPACE){if(parent.namespaceURI===HTML_NAMESPACE){return tagName==='math';}
if(parent.namespaceURI===SVG_NAMESPACE){return tagName==='math'&&HTML_INTEGRATION_POINTS[parentTagName];}
return Boolean(ALL_MATHML_TAGS[tagName]);}
if(element.namespaceURI===HTML_NAMESPACE){if(parent.namespaceURI===SVG_NAMESPACE&&!HTML_INTEGRATION_POINTS[parentTagName]){return false;}
if(parent.namespaceURI===MATHML_NAMESPACE&&!MATHML_TEXT_INTEGRATION_POINTS[parentTagName]){return false;}
return!ALL_MATHML_TAGS[tagName]&&(COMMON_SVG_AND_HTML_ELEMENTS[tagName]||!ALL_SVG_TAGS[tagName]);}
if(PARSER_MEDIA_TYPE==='application/xhtml+xml'&&ALLOWED_NAMESPACES[element.namespaceURI]){return true;}
return false;};const _forceRemove=function _forceRemove(node){arrayPush(DOMPurify.removed,{element:node});try{node.parentNode.removeChild(node);}catch(_){node.remove();}};const _removeAttribute=function _removeAttribute(name,node){try{arrayPush(DOMPurify.removed,{attribute:node.getAttributeNode(name),from:node});}catch(_){arrayPush(DOMPurify.removed,{attribute:null,from:node});}
node.removeAttribute(name);if(name==='is'&&!ALLOWED_ATTR[name]){if(RETURN_DOM||RETURN_DOM_FRAGMENT){try{_forceRemove(node);}catch(_){}}else{try{node.setAttribute(name,'');}catch(_){}}}};const _initDocument=function _initDocument(dirty){let doc=null;let leadingWhitespace=null;if(FORCE_BODY){dirty='<remove></remove>'+dirty;}else{const matches=stringMatch(dirty,/^[\r\n\t ]+/);leadingWhitespace=matches&&matches[0];}
if(PARSER_MEDIA_TYPE==='application/xhtml+xml'&&NAMESPACE===HTML_NAMESPACE){dirty='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+dirty+'</body></html>';}
const dirtyPayload=trustedTypesPolicy?trustedTypesPolicy.createHTML(dirty):dirty;if(NAMESPACE===HTML_NAMESPACE){try{doc=new DOMParser().parseFromString(dirtyPayload,PARSER_MEDIA_TYPE);}catch(_){}}
if(!doc||!doc.documentElement){doc=implementation.createDocument(NAMESPACE,'template',null);try{doc.documentElement.innerHTML=IS_EMPTY_INPUT?emptyHTML:dirtyPayload;}catch(_){}}
const body=doc.body||doc.documentElement;if(dirty&&leadingWhitespace){body.insertBefore(document.createTextNode(leadingWhitespace),body.childNodes[0]||null);}
if(NAMESPACE===HTML_NAMESPACE){return getElementsByTagName.call(doc,WHOLE_DOCUMENT?'html':'body')[0];}
return WHOLE_DOCUMENT?doc.documentElement:body;};const _createNodeIterator=function _createNodeIterator(root){return createNodeIterator.call(root.ownerDocument||root,root,NodeFilter.SHOW_ELEMENT|NodeFilter.SHOW_COMMENT|NodeFilter.SHOW_TEXT|NodeFilter.SHOW_PROCESSING_INSTRUCTION|NodeFilter.SHOW_CDATA_SECTION,null);};const _isClobbered=function _isClobbered(elm){return elm instanceof HTMLFormElement&&(typeof elm.nodeName!=='string'||typeof elm.textContent!=='string'||typeof elm.removeChild!=='function'||!(elm.attributes instanceof NamedNodeMap)||typeof elm.removeAttribute!=='function'||typeof elm.setAttribute!=='function'||typeof elm.namespaceURI!=='string'||typeof elm.insertBefore!=='function'||typeof elm.hasChildNodes!=='function');};const _isNode=function _isNode(object){return typeof Node==='function'&&object instanceof Node;};const _executeHook=function _executeHook(entryPoint,currentNode,data){if(!hooks[entryPoint]){return;}
arrayForEach(hooks[entryPoint],hook=>{hook.call(DOMPurify,currentNode,data,CONFIG);});};const _sanitizeElements=function _sanitizeElements(currentNode){let content=null;_executeHook('beforeSanitizeElements',currentNode,null);if(_isClobbered(currentNode)){_forceRemove(currentNode);return true;}
const tagName=transformCaseFunc(currentNode.nodeName);_executeHook('uponSanitizeElement',currentNode,{tagName,allowedTags:ALLOWED_TAGS});if(currentNode.hasChildNodes()&&!_isNode(currentNode.firstElementChild)&&regExpTest(/<[/\w]/g,currentNode.innerHTML)&&regExpTest(/<[/\w]/g,currentNode.textContent)){_forceRemove(currentNode);return true;}
if(currentNode.nodeType===NODE_TYPE.progressingInstruction){_forceRemove(currentNode);return true;}
if(SAFE_FOR_XML&&currentNode.nodeType===NODE_TYPE.comment&&regExpTest(/<[/\w]/g,currentNode.data)){_forceRemove(currentNode);return true;}
if(!ALLOWED_TAGS[tagName]||FORBID_TAGS[tagName]){if(!FORBID_TAGS[tagName]&&_isBasicCustomElement(tagName)){if(CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof RegExp&&regExpTest(CUSTOM_ELEMENT_HANDLING.tagNameCheck,tagName)){return false;}
if(CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof Function&&CUSTOM_ELEMENT_HANDLING.tagNameCheck(tagName)){return false;}}
if(KEEP_CONTENT&&!FORBID_CONTENTS[tagName]){const parentNode=getParentNode(currentNode)||currentNode.parentNode;const childNodes=getChildNodes(currentNode)||currentNode.childNodes;if(childNodes&&parentNode){const childCount=childNodes.length;for(let i=childCount-1;i>=0;--i){const childClone=cloneNode(childNodes[i],true);childClone.__removalCount=(currentNode.__removalCount||0)+1;parentNode.insertBefore(childClone,getNextSibling(currentNode));}}}
_forceRemove(currentNode);return true;}
if(currentNode instanceof Element&&!_checkValidNamespace(currentNode)){_forceRemove(currentNode);return true;}
if((tagName==='noscript'||tagName==='noembed'||tagName==='noframes')&&regExpTest(/<\/no(script|embed|frames)/i,currentNode.innerHTML)){_forceRemove(currentNode);return true;}
if(SAFE_FOR_TEMPLATES&&currentNode.nodeType===NODE_TYPE.text){content=currentNode.textContent;arrayForEach([MUSTACHE_EXPR,ERB_EXPR,TMPLIT_EXPR],expr=>{content=stringReplace(content,expr,' ');});if(currentNode.textContent!==content){arrayPush(DOMPurify.removed,{element:currentNode.cloneNode()});currentNode.textContent=content;}}
_executeHook('afterSanitizeElements',currentNode,null);return false;};const _isValidAttribute=function _isValidAttribute(lcTag,lcName,value){if(SANITIZE_DOM&&(lcName==='id'||lcName==='name')&&(value in document||value in formElement)){return false;}
if(ALLOW_DATA_ATTR&&!FORBID_ATTR[lcName]&&regExpTest(DATA_ATTR,lcName));else if(ALLOW_ARIA_ATTR&&regExpTest(ARIA_ATTR,lcName));else if(!ALLOWED_ATTR[lcName]||FORBID_ATTR[lcName]){if(_isBasicCustomElement(lcTag)&&(CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof RegExp&&regExpTest(CUSTOM_ELEMENT_HANDLING.tagNameCheck,lcTag)||CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof Function&&CUSTOM_ELEMENT_HANDLING.tagNameCheck(lcTag))&&(CUSTOM_ELEMENT_HANDLING.attributeNameCheck instanceof RegExp&&regExpTest(CUSTOM_ELEMENT_HANDLING.attributeNameCheck,lcName)||CUSTOM_ELEMENT_HANDLING.attributeNameCheck instanceof Function&&CUSTOM_ELEMENT_HANDLING.attributeNameCheck(lcName))||lcName==='is'&&CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements&&(CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof RegExp&&regExpTest(CUSTOM_ELEMENT_HANDLING.tagNameCheck,value)||CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof Function&&CUSTOM_ELEMENT_HANDLING.tagNameCheck(value)));else{return false;}}else if(URI_SAFE_ATTRIBUTES[lcName]);else if(regExpTest(IS_ALLOWED_URI$1,stringReplace(value,ATTR_WHITESPACE,'')));else if((lcName==='src'||lcName==='xlink:href'||lcName==='href')&&lcTag!=='script'&&stringIndexOf(value,'data:')===0&&DATA_URI_TAGS[lcTag]);else if(ALLOW_UNKNOWN_PROTOCOLS&&!regExpTest(IS_SCRIPT_OR_DATA,stringReplace(value,ATTR_WHITESPACE,'')));else if(value){return false;}else;return true;};const _isBasicCustomElement=function _isBasicCustomElement(tagName){return tagName!=='annotation-xml'&&stringMatch(tagName,CUSTOM_ELEMENT);};const _sanitizeAttributes=function _sanitizeAttributes(currentNode){_executeHook('beforeSanitizeAttributes',currentNode,null);const{attributes}=currentNode;if(!attributes){return;}
const hookEvent={attrName:'',attrValue:'',keepAttr:true,allowedAttributes:ALLOWED_ATTR};let l=attributes.length;while(l--){const attr=attributes[l];const{name,namespaceURI,value:attrValue}=attr;const lcName=transformCaseFunc(name);let value=name==='value'?attrValue:stringTrim(attrValue);hookEvent.attrName=lcName;hookEvent.attrValue=value;hookEvent.keepAttr=true;hookEvent.forceKeepAttr=undefined;_executeHook('uponSanitizeAttribute',currentNode,hookEvent);value=hookEvent.attrValue;if(hookEvent.forceKeepAttr){continue;}
_removeAttribute(name,currentNode);if(!hookEvent.keepAttr){continue;}
if(!ALLOW_SELF_CLOSE_IN_ATTR&&regExpTest(/\/>/i,value)){_removeAttribute(name,currentNode);continue;}
if(SAFE_FOR_XML&&regExpTest(/((--!?|])>)|<\/(style|title)/i,value)){_removeAttribute(name,currentNode);continue;}
if(SAFE_FOR_TEMPLATES){arrayForEach([MUSTACHE_EXPR,ERB_EXPR,TMPLIT_EXPR],expr=>{value=stringReplace(value,expr,' ');});}
const lcTag=transformCaseFunc(currentNode.nodeName);if(!_isValidAttribute(lcTag,lcName,value)){continue;}
if(SANITIZE_NAMED_PROPS&&(lcName==='id'||lcName==='name')){_removeAttribute(name,currentNode);value=SANITIZE_NAMED_PROPS_PREFIX+value;}
if(trustedTypesPolicy&&typeof trustedTypes==='object'&&typeof trustedTypes.getAttributeType==='function'){if(namespaceURI);else{switch(trustedTypes.getAttributeType(lcTag,lcName)){case'TrustedHTML':{value=trustedTypesPolicy.createHTML(value);break;}
case'TrustedScriptURL':{value=trustedTypesPolicy.createScriptURL(value);break;}}}}
try{if(namespaceURI){currentNode.setAttributeNS(namespaceURI,name,value);}else{currentNode.setAttribute(name,value);}
if(_isClobbered(currentNode)){_forceRemove(currentNode);}else{arrayPop(DOMPurify.removed);}}catch(_){}}
_executeHook('afterSanitizeAttributes',currentNode,null);};const _sanitizeShadowDOM=function _sanitizeShadowDOM(fragment){let shadowNode=null;const shadowIterator=_createNodeIterator(fragment);_executeHook('beforeSanitizeShadowDOM',fragment,null);while(shadowNode=shadowIterator.nextNode()){_executeHook('uponSanitizeShadowNode',shadowNode,null);if(_sanitizeElements(shadowNode)){continue;}
if(shadowNode.content instanceof DocumentFragment){_sanitizeShadowDOM(shadowNode.content);}
_sanitizeAttributes(shadowNode);}
_executeHook('afterSanitizeShadowDOM',fragment,null);};DOMPurify.sanitize=function(dirty){let cfg=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{};let body=null;let importedNode=null;let currentNode=null;let returnNode=null;IS_EMPTY_INPUT=!dirty;if(IS_EMPTY_INPUT){dirty='<!-->';}
if(typeof dirty!=='string'&&!_isNode(dirty)){if(typeof dirty.toString==='function'){dirty=dirty.toString();if(typeof dirty!=='string'){throw typeErrorCreate('dirty is not a string, aborting');}}else{throw typeErrorCreate('toString is not a function');}}
if(!DOMPurify.isSupported){return dirty;}
if(!SET_CONFIG){_parseConfig(cfg);}
DOMPurify.removed=[];if(typeof dirty==='string'){IN_PLACE=false;}
if(IN_PLACE){if(dirty.nodeName){const tagName=transformCaseFunc(dirty.nodeName);if(!ALLOWED_TAGS[tagName]||FORBID_TAGS[tagName]){throw typeErrorCreate('root node is forbidden and cannot be sanitized in-place');}}}else if(dirty instanceof Node){body=_initDocument('<!---->');importedNode=body.ownerDocument.importNode(dirty,true);if(importedNode.nodeType===NODE_TYPE.element&&importedNode.nodeName==='BODY'){body=importedNode;}else if(importedNode.nodeName==='HTML'){body=importedNode;}else{body.appendChild(importedNode);}}else{if(!RETURN_DOM&&!SAFE_FOR_TEMPLATES&&!WHOLE_DOCUMENT&&dirty.indexOf('<')===-1){return trustedTypesPolicy&&RETURN_TRUSTED_TYPE?trustedTypesPolicy.createHTML(dirty):dirty;}
body=_initDocument(dirty);if(!body){return RETURN_DOM?null:RETURN_TRUSTED_TYPE?emptyHTML:'';}}
if(body&&FORCE_BODY){_forceRemove(body.firstChild);}
const nodeIterator=_createNodeIterator(IN_PLACE?dirty:body);while(currentNode=nodeIterator.nextNode()){if(_sanitizeElements(currentNode)){continue;}
if(currentNode.content instanceof DocumentFragment){_sanitizeShadowDOM(currentNode.content);}
_sanitizeAttributes(currentNode);}
if(IN_PLACE){return dirty;}
if(RETURN_DOM){if(RETURN_DOM_FRAGMENT){returnNode=createDocumentFragment.call(body.ownerDocument);while(body.firstChild){returnNode.appendChild(body.firstChild);}}else{returnNode=body;}
if(ALLOWED_ATTR.shadowroot||ALLOWED_ATTR.shadowrootmode){returnNode=importNode.call(originalDocument,returnNode,true);}
return returnNode;}
let serializedHTML=WHOLE_DOCUMENT?body.outerHTML:body.innerHTML;if(WHOLE_DOCUMENT&&ALLOWED_TAGS['!doctype']&&body.ownerDocument&&body.ownerDocument.doctype&&body.ownerDocument.doctype.name&&regExpTest(DOCTYPE_NAME,body.ownerDocument.doctype.name)){serializedHTML='<!DOCTYPE '+body.ownerDocument.doctype.name+'>\n'+serializedHTML;}
if(SAFE_FOR_TEMPLATES){arrayForEach([MUSTACHE_EXPR,ERB_EXPR,TMPLIT_EXPR],expr=>{serializedHTML=stringReplace(serializedHTML,expr,' ');});}
return trustedTypesPolicy&&RETURN_TRUSTED_TYPE?trustedTypesPolicy.createHTML(serializedHTML):serializedHTML;};DOMPurify.setConfig=function(){let cfg=arguments.length>0&&arguments[0]!==undefined?arguments[0]:{};_parseConfig(cfg);SET_CONFIG=true;};DOMPurify.clearConfig=function(){CONFIG=null;SET_CONFIG=false;};DOMPurify.isValidAttribute=function(tag,attr,value){if(!CONFIG){_parseConfig({});}
const lcTag=transformCaseFunc(tag);const lcName=transformCaseFunc(attr);return _isValidAttribute(lcTag,lcName,value);};DOMPurify.addHook=function(entryPoint,hookFunction){if(typeof hookFunction!=='function'){return;}
hooks[entryPoint]=hooks[entryPoint]||[];arrayPush(hooks[entryPoint],hookFunction);};DOMPurify.removeHook=function(entryPoint){if(hooks[entryPoint]){return arrayPop(hooks[entryPoint]);}};DOMPurify.removeHooks=function(entryPoint){if(hooks[entryPoint]){hooks[entryPoint]=[];}};DOMPurify.removeAllHooks=function(){hooks={};};return DOMPurify;}
var purify=createDOMPurify();return purify;}));;

/* /web/static/src/model/model.js */
odoo.define('@web/model/model',['@web/core/user','@web/core/utils/hooks','@web/search/action_hook','@web/search/with_search/with_search','@web/model/sample_server','@odoo/owl'],function(require){'use strict';let __exports={};const{user}=require("@web/core/user");const{useBus,useService}=require("@web/core/utils/hooks");const{useSetupAction}=require("@web/search/action_hook");const{SEARCH_KEYS}=require("@web/search/with_search/with_search");const{buildSampleORM}=require("@web/model/sample_server");const{EventBus,onWillStart,onWillUpdateProps,status,useComponent}=require("@odoo/owl");const Model=__exports.Model=class Model{constructor(env,params,services){this.env=env;this.orm=services.orm;this.bus=new EventBus();this.setup(params,services);}
setup(){}
async load(){}
hasData(){return true;}
getGroups(){return null;}
notify(){this.bus.trigger("update");}}
Model.services=[];function getSearchParams(props){const params={};for(const key of SEARCH_KEYS){params[key]=props[key];}
return params;}
__exports.useModel=useModel;function useModel(ModelClass,params,options={}){const component=useComponent();const services={};for(const key of ModelClass.services){services[key]=useService(key);}
services.orm=services.orm||useService("orm");const model=new ModelClass(component.env,params,services);onWillStart(async()=>{await options.beforeFirstLoad?.();return model.load(component.props);});onWillUpdateProps((nextProps)=>model.load(nextProps));return model;}
__exports.useModelWithSampleData=useModelWithSampleData;function useModelWithSampleData(ModelClass,params,options={}){const component=useComponent();if(!(ModelClass.prototype instanceof Model)){throw new Error(`the model class should extend Model`);}
const services={};for(const key of ModelClass.services){services[key]=useService(key);}
services.orm=services.orm||useService("orm");if(!("isAlive"in params)){params.isAlive=()=>status(component)!=="destroyed";}
const model=new ModelClass(component.env,params,services);useBus(model.bus,"update",options.onUpdate||(()=>{component.render(true);}));const globalState=component.props.globalState||{};const localState=component.props.state||{};let useSampleModel=component.props.useSampleModel&&(!("useSampleModel"in globalState)||globalState.useSampleModel);model.useSampleModel=useSampleModel;const orm=model.orm;let sampleORM=localState.sampleORM;let started=false;async function load(props){const searchParams=getSearchParams(props);await model.load(searchParams);if(useSampleModel&&!model.hasData()){sampleORM=sampleORM||buildSampleORM(component.props.resModel,component.props.fields,user);model.orm=sampleORM;await model.load(searchParams);model.orm=orm;}else{useSampleModel=false;model.useSampleModel=useSampleModel;}
if(started){model.notify();}}
onWillStart(async()=>{if(options.onWillStart){await options.onWillStart();}
await load(component.props);if(options.onWillStartAfterLoad){await options.onWillStartAfterLoad();}
started=true;});onWillUpdateProps((nextProps)=>{useSampleModel=false;load(nextProps);});useSetupAction({getGlobalState(){if(component.props.useSampleModel){return{useSampleModel};}},getLocalState:()=>{return{sampleORM};},});return model;}
__exports._makeFieldFromPropertyDefinition=_makeFieldFromPropertyDefinition;function _makeFieldFromPropertyDefinition(name,definition,relatedPropertyField){return{...definition,name,propertyName:definition.name,relation:definition.comodel,relatedPropertyField,};}
__exports.addPropertyFieldDefs=addPropertyFieldDefs;async function addPropertyFieldDefs(orm,resModel,context,fields,groupBy){const proms=[];for(const gb of groupBy){if(gb in fields){continue;}
const[fieldName]=gb.split(".");const field=fields[fieldName];if(field?.type==="properties"){proms.push(orm.call(resModel,"get_property_definition",[gb],{context,}).then((definition)=>{fields[gb]=_makeFieldFromPropertyDefinition(gb,definition,field);}).catch(()=>{fields[gb]=_makeFieldFromPropertyDefinition(gb,{},field);}));}}
return Promise.all(proms);}
return __exports;});;

/* /web/static/src/model/record.js */
odoo.define('@web/model/record',['@web/core/utils/hooks','@web/core/utils/objects','@web/model/relational_model/relational_model','@web/model/relational_model/utils','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{pick}=require("@web/core/utils/objects");const{RelationalModel}=require("@web/model/relational_model/relational_model");const{getFieldsSpec}=require("@web/model/relational_model/utils");const{Component,xml,onWillStart,onWillUpdateProps,useState}=require("@odoo/owl");const defaultActiveField={attrs:{},options:{},domain:"[]",string:""};class StandaloneRelationalModel extends RelationalModel{load(params={}){if(params.values){const data=params.values;const config=this._getNextConfig(this.config,params);this.root=this._createRoot(config,data);this.config=config;return;}
return super.load(params);}}
class _Record extends Component{static template=xml`<t t-slot="default" record="model.root"/>`;static props=["slots","info","fields","values?"];setup(){this.orm=useService("orm");const resModel=this.props.info.resModel;const activeFields=this.getActiveFields();const modelParams={config:{resModel,fields:this.props.fields,isMonoRecord:true,activeFields,resId:this.props.info.resId,mode:this.props.info.mode,},hooks:{onRecordSaved:this.props.info.onRecordSaved||(()=>{}),onWillSaveRecord:this.props.info.onWillSaveRecord||(()=>{}),onRecordChanged:this.props.info.onRecordChanged||(()=>{}),},};const modelServices=Object.fromEntries(StandaloneRelationalModel.services.map((servName)=>{return[servName,useService(servName)];}));modelServices.orm=this.orm;this.model=useState(new StandaloneRelationalModel(this.env,modelParams,modelServices));const prepareLoadWithValues=async(values)=>{values=pick(values,...Object.keys(modelParams.config.activeFields));const proms=[];for(const fieldName in values){if(["one2many","many2many"].includes(this.props.fields[fieldName].type)){if(values[fieldName].length&&typeof values[fieldName][0]==="number"){const resModel=this.props.fields[fieldName].relation;const resIds=values[fieldName];const activeField=modelParams.config.activeFields[fieldName];if(activeField.related){const{activeFields,fields}=activeField.related;const fieldSpec=getFieldsSpec(activeFields,fields,{});const kwargs={context:activeField.context||{},specification:fieldSpec,};proms.push(this.orm.webRead(resModel,resIds,kwargs).then((records)=>{values[fieldName]=records;}));}}}
if(this.props.fields[fieldName].type==="many2one"){const loadDisplayName=async(resId)=>{const resModel=this.props.fields[fieldName].relation;const activeField=modelParams.config.activeFields[fieldName];const kwargs={context:activeField.context||{},specification:{display_name:{}},};const records=await this.orm.webRead(resModel,[resId],kwargs);return records[0].display_name;};if(typeof values[fieldName]==="number"){const prom=loadDisplayName(values[fieldName]);prom.then((displayName)=>{values[fieldName]={id:values[fieldName],display_name:displayName,};});proms.push(prom);}else if(Array.isArray(values[fieldName])){if(values[fieldName][1]===undefined){const prom=loadDisplayName(values[fieldName][0]);prom.then((displayName)=>{values[fieldName]={id:values[fieldName][0],display_name:displayName,};});proms.push(prom);}
values[fieldName]={id:values[fieldName][0],display_name:values[fieldName][1],};}}
await Promise.all(proms);}
return values;};onWillStart(async()=>{if(this.props.values){const values=await prepareLoadWithValues(this.props.values);return this.model.load({values});}else{return this.model.load();}});onWillUpdateProps(async(nextProps)=>{const params={};if(nextProps.info.resId!==this.model.root.resId){params.resId=nextProps.info.resId;}
if(nextProps.values){params.values=await prepareLoadWithValues(nextProps.values);}
if(Object.keys(params).length){return this.model.load(params);}});}
getActiveFields(){if(this.props.info.activeFields){const activeFields={};for(const[fName,fInfo]of Object.entries(this.props.info.activeFields)){activeFields[fName]={...defaultActiveField,...fInfo};}
return activeFields;}
return Object.fromEntries(this.props.info.fieldNames.map((f)=>[f,{...defaultActiveField}]));}}
const Record=__exports.Record=class Record extends Component{static template=xml`<_Record fields="fields" slots="props.slots" values="props.values" info="props" />`;static components={_Record};static props=["slots","resModel?","fieldNames?","activeFields?","fields?","resId?","mode?","values?","onRecordChanged?","onRecordSaved?","onWillSaveRecord?",];setup(){if(this.props.fields){this.fields=this.props.fields;}else{const orm=useService("orm");onWillStart(async()=>{this.fields=await orm.call(this.props.resModel,"fields_get",[this.props.fieldNames],{});});}}}
return __exports;});;

/* /web/static/src/model/relational_model/datapoint.js */
odoo.define('@web/model/relational_model/datapoint',['@odoo/owl','@web/core/domain','@web/core/utils/reactive','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{markRaw}=require("@odoo/owl");const{evalDomain}=require("@web/core/domain");const{Reactive}=require("@web/core/utils/reactive");const{getId}=require("@web/model/relational_model/utils");const DataPoint=__exports.DataPoint=class DataPoint extends Reactive{constructor(model,config,data,options){super(...arguments);this.id=getId("datapoint");this.model=model;markRaw(config.activeFields);markRaw(config.fields);this._config=config;this.setup(config,data,options);}
setup(){}
get activeFields(){return this.config.activeFields;}
get fields(){return this.config.fields;}
get fieldNames(){return Object.keys(this.activeFields).filter((fieldName)=>!this.fields[fieldName].relatedPropertyField);}
get resModel(){return this.config.resModel;}
get config(){return this._config;}
get context(){return this.config.context;}
get currentCompanyId(){return this.config.currentCompanyId;}
isFieldReadonly(fieldName){const activeField=this.activeFields[fieldName];const{readonly}=activeField||this.fields[fieldName];return readonly&&evalDomain(readonly,this.evalContext);}}
return __exports;});;

/* /web/static/src/model/relational_model/dynamic_group_list.js */
odoo.define('@web/model/relational_model/dynamic_group_list',['@web/core/domain','@web/model/relational_model/dynamic_list','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{Domain}=require("@web/core/domain");const{DynamicList}=require("@web/model/relational_model/dynamic_list");const{getGroupServerValue}=require("@web/model/relational_model/utils");const DynamicGroupList=__exports.DynamicGroupList=class DynamicGroupList extends DynamicList{static type="DynamicGroupList";setup(config,data){super.setup(...arguments);this.isGrouped=true;this._nbRecordsMatchingDomain=null;this._setData(data);}
_setData(data){this.groups=data.groups.map((g)=>this._createGroupDatapoint(g));this.count=data.length;this._selectDomain(this.isDomainSelected);}
get groupBy(){return this.config.groupBy;}
get groupByField(){return this.fields[this.groupBy[0].split(":")[0]];}
get hasData(){return this.groups.some((group)=>group.hasData);}
get isRecordCountTrustable(){return this.count<=this.limit||this._nbRecordsMatchingDomain!==null;}
get records(){return this.groups.filter((group)=>!group.isFolded).map((group)=>group.records).flat();}
get recordCount(){if(this._nbRecordsMatchingDomain!==null){return this._nbRecordsMatchingDomain;}
return this.groups.reduce((acc,group)=>acc+group.count,0);}
async createGroup(groupName,foldField){if(!this.groupByField||this.groupByField.type!=="many2one"){throw new Error("Cannot create a group on a non many2one group field");}
await this.model.mutex.exec(()=>this._createGroup(groupName,foldField));}
async deleteGroups(groups){await this.model.mutex.exec(()=>this._deleteGroups(groups));}
async moveRecord(dataRecordId,dataGroupId,refId,targetGroupId){const targetGroup=this.groups.find((g)=>g.id===targetGroupId);if(dataGroupId===targetGroupId){await targetGroup.list._resequence(targetGroup.list.records,this.resModel,dataRecordId,refId);return;}
const sourceGroup=this.groups.find((g)=>g.id===dataGroupId);const recordIndex=sourceGroup.list.records.findIndex((r)=>r.id===dataRecordId);const record=sourceGroup.list.records[recordIndex];const refIndex=targetGroup.list.records.findIndex((r)=>r.id===refId);const oldIndex=sourceGroup.list.records.findIndex((r)=>r.id===dataRecordId);const sourceList=sourceGroup.list;const mustReloadSourceList=sourceList.count>sourceList.offset+sourceList.limit;sourceGroup._removeRecords([record.id]);targetGroup._addRecord(record,refIndex+1);const value=targetGroup.groupByField.type==="many2one"?[targetGroup.value,targetGroup.displayName]:targetGroup.value;const revert=()=>{targetGroup._removeRecords([record.id]);sourceGroup._addRecord(record,oldIndex);};try{const changes={[targetGroup.groupByField.name]:value};const res=await record.update(changes,{save:true});if(!res){return revert();}}catch(e){revert();throw e;}
const proms=[];if(mustReloadSourceList){const{offset,limit,orderBy,domain}=sourceGroup.list;proms.push(sourceGroup.list._load(offset,limit,orderBy,domain));}
if(!targetGroup.isFolded){const targetList=targetGroup.list;const records=targetList.records;proms.push(targetList._resequence(records,this.resModel,dataRecordId,refId));}
return Promise.all(proms);}
async resequence(movedGroupId,targetGroupId){if(!this.groupByField||this.groupByField.type!=="many2one"){throw new Error("Cannot resequence a group on a non many2one group field");}
return this.model.mutex.exec(async()=>{await this._resequence(this.groups,this.groupByField.relation,movedGroupId,targetGroupId);});}
async selectDomain(value){return this.model.mutex.exec(async()=>{await this._ensureCorrectRecordCount();this._selectDomain(value);});}
async sortBy(fieldName){if(!this.groups.length){return;}
if(this.groups.every((group)=>group.isFolded)){if(this.groupByField.name!==fieldName){if(!(fieldName in this.groups[0].aggregates)){return;}}}
return super.sortBy(fieldName);}
async _createGroup(groupName,foldField=false){const[id]=await this.model.orm.call(this.groupByField.relation,"name_create",[groupName],{context:this.context});if(foldField){await this.model.orm.write(this.groupByField.relation,[id],{[foldField]:true},{context:this.context});}
const lastGroup=this.groups.at(-1);const commonConfig={resModel:this.config.resModel,fields:this.config.fields,activeFields:this.config.activeFields,};const context={...this.context,[`default_${this.groupByField.name}`]:id,};const nextConfigGroups={...this.config.groups};const domain=Domain.and([this.domain,[[this.groupByField.name,"=",id]]]).toList();nextConfigGroups[id]={...commonConfig,context,groupByFieldName:this.groupByField.name,isFolded:Boolean(foldField),initialDomain:domain,list:{...commonConfig,context,domain:domain,groupBy:[],orderBy:this.orderBy,},};this.model._updateConfig(this.config,{groups:nextConfigGroups},{reload:false});const data={count:0,length:0,records:[],__domain:domain,[this.groupByField.name]:[id,groupName],value:id,serverValue:getGroupServerValue(this.groupByField,id),displayName:groupName,rawValue:[id,groupName],};const group=this._createGroupDatapoint(data);if(lastGroup){const groups=[...this.groups,group];await this._resequence(groups,this.groupByField.relation,group.id,lastGroup.id);this.groups=groups;}else{this.groups.push(group);}}
_createGroupDatapoint(data){return new this.model.constructor.Group(this.model,this.config.groups[data.value],data);}
async _deleteGroups(groups){const shouldReload=groups.some((g)=>g.count>0);await this._unlinkGroups(groups);const configGroups={...this.config.groups};for(const group of groups){delete configGroups[group.value];}
if(shouldReload){await this.model._updateConfig(this.config,{groups:configGroups},{commit:this._setData.bind(this)});}else{for(const group of groups){this._removeGroup(group);}
this.model._updateConfig(this.config,{groups:configGroups},{reload:false});}}
async _ensureCorrectRecordCount(){if(!this.isRecordCountTrustable){this._nbRecordsMatchingDomain=await this.model.orm.searchCount(this.resModel,this.domain,{limit:this.model.initialCountLimit});}}
_getDPresId(group){return group.value;}
_getDPFieldValue(group,handleField){return group[handleField];}
async _load(offset,limit,orderBy,domain){await this.model._updateConfig(this.config,{offset,limit,orderBy,domain},{commit:this._setData.bind(this)});if(this.isDomainSelected){await this._ensureCorrectRecordCount();}}
_removeGroup(group){const index=this.groups.findIndex((g)=>g.id===group.id);this.groups.splice(index,1);this.count--;}
_removeRecords(recordIds){const proms=[];for(const group of this.groups){proms.push(group._removeRecords(recordIds));}
return Promise.all(proms);}
_selectDomain(value){for(const group of this.groups){group.list._selectDomain(value);}
super._selectDomain(value);}
async _toggleSelection(){if(!this.records.length){if(!this.isDomainSelected){await this._ensureCorrectRecordCount();this._selectDomain(true);}else{this._selectDomain(false);}}else{super._toggleSelection();}}
_unlinkGroups(groups){const groupResIds=groups.map((g)=>g.value);return this.model.orm.unlink(this.groupByField.relation,groupResIds,{context:this.context,});}}
return __exports;});;

/* /web/static/src/model/relational_model/dynamic_list.js */
odoo.define('@web/model/relational_model/dynamic_list',['@web/core/confirmation_dialog/confirmation_dialog','@web/core/l10n/translation','@web/core/utils/arrays','@web/model/relational_model/datapoint','@web/model/relational_model/record','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{AlertDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{_t}=require("@web/core/l10n/translation");const{unique}=require("@web/core/utils/arrays");const{DataPoint}=require("@web/model/relational_model/datapoint");const{Record}=require("@web/model/relational_model/record");const{resequence}=require("@web/model/relational_model/utils");const DEFAULT_HANDLE_FIELD="sequence";const DynamicList=__exports.DynamicList=class DynamicList extends DataPoint{setup(config){super.setup(...arguments);this.handleField=Object.keys(this.activeFields).find((fieldName)=>this.activeFields[fieldName].isHandle);if(!this.handleField&&DEFAULT_HANDLE_FIELD in this.fields){this.handleField=DEFAULT_HANDLE_FIELD;}
this.isDomainSelected=false;this.evalContext=this.context;}
get groupBy(){return[];}
get orderBy(){return this.config.orderBy;}
get domain(){return this.config.domain;}
get editedRecord(){return this.records.find((record)=>record.isInEdition);}
get isRecordCountTrustable(){return true;}
get limit(){return this.config.limit;}
get offset(){return this.config.offset;}
get selection(){return this.records.filter((record)=>record.selected);}
archive(isSelected){return this.model.mutex.exec(()=>this._toggleArchive(isSelected,true));}
canResequence(){return!!this.handleField;}
deleteRecords(records=[]){return this.model.mutex.exec(()=>this._deleteRecords(records));}
duplicateRecords(records=[]){return this.model.mutex.exec(()=>this._duplicateRecords(records));}
async enterEditMode(record){if(this.editedRecord===record){return true;}
const canProceed=await this.leaveEditMode();if(canProceed){this.model._updateConfig(record.config,{mode:"edit"},{reload:false});}
return canProceed;}
async getResIds(isSelected){let resIds;if(isSelected){if(this.isDomainSelected){resIds=await this.model.orm.search(this.resModel,this.domain,{limit:this.model.activeIdsLimit,context:this.context,});}else{resIds=this.selection.map((r)=>r.resId);}}else{resIds=this.records.map((r)=>r.resId);}
return unique(resIds);}
async leaveEditMode({discard}={}){let editedRecord=this.editedRecord;if(editedRecord){let canProceed=true;if(discard){this._recordToDiscard=editedRecord;await editedRecord.discard();this._recordToDiscard=null;editedRecord=this.editedRecord;if(editedRecord&&editedRecord.isNew){this._removeRecords([editedRecord.id]);}}else{if(!this.model._urgentSave){await editedRecord.checkValidity();editedRecord=this.editedRecord;if(!editedRecord){return true;}}
if(editedRecord.isNew&&!editedRecord.dirty){this._removeRecords([editedRecord.id]);}else{canProceed=await editedRecord.save();}}
editedRecord=this.editedRecord;if(canProceed&&editedRecord){this.model._updateConfig(editedRecord.config,{mode:"readonly"},{reload:false});}else{return canProceed;}}
return true;}
load(params={}){const limit=params.limit===undefined?this.limit:params.limit;const offset=params.offset===undefined?this.offset:params.offset;const orderBy=params.orderBy===undefined?this.orderBy:params.orderBy;const domain=params.domain===undefined?this.domain:params.domain;return this.model.mutex.exec(()=>this._load(offset,limit,orderBy,domain));}
async multiSave(record){return this.model.mutex.exec(()=>this._multiSave(record));}
selectDomain(value){return this.model.mutex.exec(()=>this._selectDomain(value));}
sortBy(fieldName){return this.model.mutex.exec(()=>{let orderBy=[...this.orderBy];if(orderBy.length&&orderBy[0].name===fieldName){orderBy[0]={name:orderBy[0].name,asc:!orderBy[0].asc};}else{orderBy=orderBy.filter((o)=>o.name!==fieldName);orderBy.unshift({name:fieldName,asc:true,});}
return this._load(this.offset,this.limit,orderBy,this.domain);});}
toggleSelection(){return this.model.mutex.exec(()=>this._toggleSelection());}
unarchive(isSelected){return this.model.mutex.exec(()=>this._toggleArchive(isSelected,false));}
async _duplicateRecords(records){let resIds;if(records.length){resIds=unique(records.map((r)=>r.resId));}else{resIds=await this.getResIds(true);}
const duplicated=await this.model.orm.call(this.resModel,"copy",[resIds],{context:this.context,});if(resIds.length>duplicated.length){this.model.notification.add(_t("Some records could not be duplicated"),{title:_t("Warning"),});}
return this.model.load();}
async _deleteRecords(records){let resIds;if(records.length){resIds=unique(records.map((r)=>r.resId));}else{resIds=await this.getResIds(true);records=this.records.filter((r)=>resIds.includes(r.resId));}
const unlinked=await this.model.orm.unlink(this.resModel,resIds,{context:this.context,});if(!unlinked){return false;}
if(this.isDomainSelected&&resIds.length===this.model.activeIdsLimit&&resIds.length<this.count){const msg=_t("Only the first %(count)s records have been deleted (out of %(total)s selected)",{count:resIds.length,total:this.count});this.model.notification.add(msg,{title:_t("Warning")});}
await this.model.load();return unlinked;}
async _leaveSampleMode(){if(this.model.useSampleModel){await this._load(this.offset,this.limit,this.orderBy,this.domain);this.model.useSampleModel=false;}}
async _multiSave(record){const changes=record._getChanges();if(!Object.keys(changes).length||record===this._recordToDiscard){return;}
const validSelection=this.selection.filter((record)=>{return Object.keys(changes).every((fieldName)=>{if(record._isReadonly(fieldName)){return false;}else if(record._isRequired(fieldName)&&!changes[fieldName]){return false;}
return true;});});const canProceed=await this.model.hooks.onWillSaveMulti(record,changes,validSelection);if(canProceed===false){return false;}
if(validSelection.length===0){this.model.dialog.add(AlertDialog,{body:_t("No valid record to save"),confirm:()=>this.leaveEditMode({discard:true}),dismiss:()=>this.leaveEditMode({discard:true}),});return false;}else{const resIds=unique(validSelection.map((r)=>r.resId));const context=this.context;try{await this.model.orm.write(this.resModel,resIds,changes,{context});}catch(e){record._discard();this.model._updateConfig(record.config,{mode:"readonly"},{reload:false});throw e;}
const records=await this.model._loadRecords({...this.config,resIds});for(const record of validSelection){const serverValues=records.find((r)=>r.id===record.resId);record._applyValues(serverValues);this.model._updateSimilarRecords(record,serverValues);}
record._discard();this.model._updateConfig(record.config,{mode:"readonly"},{reload:false});}
this.model.hooks.onSavedMulti(validSelection);return true;}
async _resequence(originalList,resModel,movedId,targetId){if(this.resModel===resModel&&!this.canResequence()){return;}
const handleField=this.resModel===resModel?this.handleField:DEFAULT_HANDLE_FIELD;const order=this.orderBy.find((o)=>o.name===handleField);const getSequence=(dp)=>dp&&this._getDPFieldValue(dp,handleField);const getResId=(dp)=>this._getDPresId(dp);const resequencedRecords=await resequence({records:originalList,resModel,movedId,targetId,fieldName:handleField,asc:order?.asc,context:this.context,orm:this.model.orm,getSequence,getResId,});if(resequencedRecords){for(const dpData of resequencedRecords){const dp=originalList.find((d)=>getResId(d)===dpData.id);if(dp instanceof Record){dp._applyValues(dpData);}else{dp[handleField]=dpData[handleField];}}}}
_selectDomain(value){this.isDomainSelected=value;}
async _toggleArchive(isSelected,state){const method=state?"action_archive":"action_unarchive";const context=this.context;const resIds=await this.getResIds(isSelected);const action=await this.model.orm.call(this.resModel,method,[resIds],{context});if(this.isDomainSelected&&resIds.length===this.model.activeIdsLimit&&resIds.length<this.count){const msg=_t("Of the %(selectedRecord)s selected records, only the first %(firstRecords)s have been archived/unarchived.",{selectedRecords:resIds.length,firstRecords:this.count,});this.model.notification.add(msg,{title:_t("Warning")});}
const reload=()=>this.model.load();if(action&&Object.keys(action).length){this.model.action.doAction(action,{onClose:reload,});}else{return reload();}}
async _toggleSelection(){if(this.selection.length===this.records.length){this.records.forEach((record)=>{record._toggleSelection(false);});this._selectDomain(false);}else{this.records.forEach((record)=>{record._toggleSelection(true);});}}}
return __exports;});;

/* /web/static/src/model/relational_model/dynamic_record_list.js */
odoo.define('@web/model/relational_model/dynamic_record_list',['@web/model/relational_model/dynamic_list'],function(require){'use strict';let __exports={};const{DynamicList}=require("@web/model/relational_model/dynamic_list");const DynamicRecordList=__exports.DynamicRecordList=class DynamicRecordList extends DynamicList{static type="DynamicRecordList";setup(config,data){super.setup(config);this._setData(data);}
_setData(data){this.records=data.records.map((r)=>this._createRecordDatapoint(r));this._updateCount(data);this._selectDomain(this.isDomainSelected);}
get hasData(){return this.count>0;}
addExistingRecord(resId,atFirstPosition){return this.model.mutex.exec(async()=>{const record=this._createRecordDatapoint({});await record._load({resId});this._addRecord(record,atFirstPosition?0:this.records.length);return record;});}
addNewRecord(atFirstPosition=false){return this.model.mutex.exec(async()=>{await this._leaveSampleMode();return this._addNewRecord(atFirstPosition);});}
async fetchCount(){this.count=await this.model._updateCount(this.config);this.hasLimitedCount=false;return this.count;}
moveRecord(dataRecordId,_dataGroupId,refId,_targetGroupId){return this.resequence(dataRecordId,refId);}
removeRecord(record){if(!record.isNew){throw new Error("removeRecord can't be called on an existing record");}
const index=this.records.findIndex((r)=>r===record);if(index<0){return;}
this.records.splice(index,1);this.count--;return record;}
async resequence(movedRecordId,targetRecordId){return this.model.mutex.exec(async()=>await this._resequence(this.records,this.resModel,movedRecordId,targetRecordId));}
async _addNewRecord(atFirstPosition){const values=await this.model._loadNewRecord({resModel:this.resModel,activeFields:this.activeFields,fields:this.fields,context:this.context,});const record=this._createRecordDatapoint(values,"edit");this._addRecord(record,atFirstPosition?0:this.records.length);return record;}
_addRecord(record,index){this.records.splice(Number.isInteger(index)?index:this.records.length,0,record);this.count++;}
_createRecordDatapoint(data,mode="readonly"){return new this.model.constructor.Record(this.model,{context:this.context,activeFields:this.activeFields,resModel:this.resModel,fields:this.fields,resId:data.id||false,resIds:data.id?[data.id]:[],isMonoRecord:true,currentCompanyId:this.currentCompanyId,mode,},data,{manuallyAdded:!data.id});}
_getDPresId(record){return record.resId;}
_getDPFieldValue(record,handleField){return record.data[handleField];}
async _load(offset,limit,orderBy,domain){await this.model._updateConfig(this.config,{offset,limit,orderBy,domain},{commit:this._setData.bind(this)});}
_removeRecords(recordIds){const keptRecords=this.records.filter((r)=>!recordIds.includes(r.id));this.count-=this.records.length-keptRecords.length;this.records=keptRecords;if(this.offset&&!this.records.length){const offset=Math.max(this.offset-this.limit,0);this.model._updateConfig(this.config,{offset},{reload:false});}}
_selectDomain(value){if(value){this.records.forEach((r)=>(r.selected=true));}
super._selectDomain(value);}
_updateCount(data){const length=data.length;if(length>=this.config.countLimit+1){this.hasLimitedCount=true;this.count=this.config.countLimit;}else{this.hasLimitedCount=false;this.count=length;}}}
return __exports;});;

/* /web/static/src/model/relational_model/errors.js */
odoo.define('@web/model/relational_model/errors',['@web/core/registry','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const FetchRecordError=__exports.FetchRecordError=class FetchRecordError extends Error{constructor(resIds){super(_t("It seems the records with IDs %s cannot be found. They might have been deleted.",resIds));this.resIds=resIds;}}
function fetchRecordErrorHandler(env,error,originalError){if(originalError instanceof FetchRecordError){env.services.notification.add(originalError.message,{sticky:true,type:"danger"});return true;}}
const errorHandlerRegistry=registry.category("error_handlers");errorHandlerRegistry.add("fetchRecordErrorHandler",fetchRecordErrorHandler);return __exports;});;

/* /web/static/src/model/relational_model/group.js */
odoo.define('@web/model/relational_model/group',['@web/core/domain','@web/model/relational_model/datapoint'],function(require){'use strict';let __exports={};const{Domain}=require("@web/core/domain");const{DataPoint}=require("@web/model/relational_model/datapoint");const Group=__exports.Group=class Group extends DataPoint{static type="Group";setup(config,data){super.setup(...arguments);this.groupByField=this.fields[config.groupByFieldName];this.range=data.range;this._rawValue=data.rawValue;this.count=data.count;this.value=data.value;this.serverValue=data.serverValue;this.displayName=data.displayName;this.aggregates=data.aggregates;let List;if(config.list.groupBy.length){List=this.model.constructor.DynamicGroupList;}else{List=this.model.constructor.DynamicRecordList;}
this.list=new List(this.model,config.list,data);this._useGroupCountForList();if(config.record){config.record.context={...config.record.context,...config.context};this.record=new this.model.constructor.Record(this.model,config.record,data.values);}}
get groupDomain(){return this.config.initialDomain;}
get hasData(){return this.count>0;}
get isFolded(){return this.config.isFolded;}
get records(){return this.list.records;}
async addExistingRecord(resId,atFirstPosition=false){const record=await this.list.addExistingRecord(resId,atFirstPosition);this.count++;return record;}
async addNewRecord(_unused,atFirstPosition=false){const canProceed=await this.model.root.leaveEditMode();if(canProceed){const record=await this.list.addNewRecord(atFirstPosition);if(record){this.count++;}}}
async applyFilter(filter){if(filter){await this.list.load({domain:Domain.and([this.groupDomain,filter]).toList(),});}else{await this.list.load({domain:this.groupDomain});this.count=this.list.isGrouped?this.list.recordCount:this.list.count;}
this.model._updateConfig(this.config,{extraDomain:filter},{reload:false});}
deleteRecords(records){return this.model.mutex.exec(()=>this._deleteRecords(records));}
async toggle(){if(this.config.isFolded){await this.list.load();}
this._useGroupCountForList();this.model._updateConfig(this.config,{isFolded:!this.config.isFolded},{reload:false});}
_addRecord(record,index){this.list._addRecord(record,index);this.count++;}
async _deleteRecords(records){await this.list._deleteRecords(records);this.count-=records.length;}
_useGroupCountForList(){if(!this.list.isGrouped&&this.list.count===this.list.config.countLimit){this.list.count=this.count;}}
async _removeRecords(recordIds){const idsToRemove=recordIds.filter((id)=>this.list.records.some((r)=>r.id===id));this.list._removeRecords(idsToRemove);this.count-=idsToRemove.length;}}
return __exports;});;

/* /web/static/src/model/relational_model/record.js */
odoo.define('@web/model/relational_model/record',['@odoo/owl','@web/core/confirmation_dialog/confirmation_dialog','@web/core/l10n/dates','@web/core/l10n/translation','@web/core/orm_service','@web/core/py_js/py','@web/core/utils/strings','@web/model/relational_model/datapoint','@web/model/relational_model/utils','@web/model/relational_model/errors'],function(require){'use strict';let __exports={};const{markRaw,markup,toRaw}=require("@odoo/owl");const{AlertDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{serializeDate,serializeDateTime}=require("@web/core/l10n/dates");const{_t}=require("@web/core/l10n/translation");const{x2ManyCommands}=require("@web/core/orm_service");const{evaluateBooleanExpr}=require("@web/core/py_js/py");const{escape}=require("@web/core/utils/strings");const{DataPoint}=require("@web/model/relational_model/datapoint");const{createPropertyActiveField,getBasicEvalContext,getFieldContext,getFieldsSpec,parseServerValue,}=require("@web/model/relational_model/utils");const{FetchRecordError}=require("@web/model/relational_model/errors");const Record=__exports.Record=class Record extends DataPoint{static type="Record";setup(config,data,options={}){this._manuallyAdded=options.manuallyAdded===true;this._onUpdate=options.onUpdate||(()=>{});this._parentRecord=options.parentRecord;this.canSaveOnUpdate=!options.parentRecord;this._virtualId=options.virtualId||false;this._isEvalContextReady=false;this.dirty=false;this.selected=false;this._invalidFields=new Set();this._unsetRequiredFields=markRaw(new Set());this._closeInvalidFieldsNotification=()=>{};const parentRecord=this._parentRecord;if(parentRecord){this.evalContext={get parent(){return parentRecord.evalContext;},};this.evalContextWithVirtualIds={get parent(){return parentRecord.evalContextWithVirtualIds;},};}else{this.evalContext={};this.evalContextWithVirtualIds={};}
const missingFields=this.fieldNames.filter((fieldName)=>!(fieldName in data));data={...this._getDefaultValues(missingFields),...data};this._textValues=markRaw({});this._setData(data);}
_setData(data){this._isEvalContextReady=false;if(this.resId){this._values=this._parseServerValues(data);this._changes=markRaw({});Object.assign(this._textValues,this._getTextValues(data));}else{this._values=markRaw({});const allVals={...this._getDefaultValues(),...data};this._initialChanges=markRaw(this._parseServerValues(allVals));this._changes=markRaw({...this._initialChanges});Object.assign(this._textValues,this._getTextValues(allVals));}
this.dirty=false;this.data={...this._values,...this._changes};this._setEvalContext();this._initialTextValues={...this._textValues};this._invalidFields.clear();this._savePoint=undefined;}
get canBeAbandoned(){return this.isNew&&!this.dirty&&this._manuallyAdded;}
get hasData(){return true;}
get isActive(){if("active"in this.activeFields){return this.data.active;}else if("x_active"in this.activeFields){return this.data.x_active;}
return true;}
get isInEdition(){if(this.config.mode==="readonly"){return false;}else{return this.config.mode==="edit"||!this.resId;}}
get isNew(){return!this.resId;}
get isValid(){return!this._invalidFields.size;}
get resId(){return this.config.resId;}
get resIds(){return this.config.resIds;}
archive(){return this.model.mutex.exec(()=>this._toggleArchive(true));}
async checkValidity({displayNotification}={}){if(!this._urgentSave){await this.model._askChanges();}
return this._checkValidity({displayNotification});}
delete(){return this.model.mutex.exec(async()=>{const unlinked=await this.model.orm.unlink(this.resModel,[this.resId],{context:this.context,});if(!unlinked){return false;}
const resIds=this.resIds.slice();const index=resIds.indexOf(this.resId);resIds.splice(index,1);const resId=resIds[Math.min(index,resIds.length-1)]||false;if(resId){await this.model.load({resId,resIds});}else{this.model._updateConfig(this.config,{resId:false},{reload:false});this.dirty=false;this._changes=markRaw(this._parseServerValues(this._getDefaultValues()));this._values=markRaw({});this._textValues=markRaw({});this.data={...this._changes};this._setEvalContext();}});}
async discard(){if(this.model._closeUrgentSaveNotification){this.model._closeUrgentSaveNotification();}
await this.model._askChanges();return this.model.mutex.exec(()=>this._discard());}
duplicate(){return this.model.mutex.exec(async()=>{const kwargs={context:this.context};const index=this.resIds.indexOf(this.resId);const[resId]=await this.model.orm.call(this.resModel,"copy",[[this.resId]],kwargs);const resIds=this.resIds.slice();resIds.splice(index+1,0,resId);await this.model.load({resId,resIds,mode:"edit"});});}
async isDirty(){await this.model._askChanges();return this.dirty;}
isFieldInvalid(fieldName){return this._invalidFields.has(fieldName);}
load(){if(arguments.length>0){throw new Error("Record.load() does not accept arguments");}
return this.model.mutex.exec(()=>this._load());}
async save(options){await this.model._askChanges();return this.model.mutex.exec(()=>this._save(options));}
async setInvalidField(fieldName){this.dirty=true;return this._setInvalidField(fieldName);}
async resetFieldValidity(fieldName){this.dirty=true;return this._resetFieldValidity(fieldName);}
switchMode(mode){return this.model.mutex.exec(()=>this._switchMode(mode));}
toggleSelection(selected){return this.model.mutex.exec(()=>{this._toggleSelection(selected);});}
unarchive(){return this.model.mutex.exec(()=>this._toggleArchive(false));}
update(changes,{save}={}){if(this.model._urgentSave){return this._update(changes);}
return this.model.mutex.exec(async()=>{await this._update(changes,{withoutOnchange:save});if(save&&this.canSaveOnUpdate){return this._save();}});}
async urgentSave(){this.model._urgentSave=true;this.model.bus.trigger("WILL_SAVE_URGENTLY");const succeeded=await this._save({reload:false});this.model._urgentSave=false;return succeeded;}
_addSavePoint(){this._savePoint=markRaw({dirty:this.dirty,textValues:{...this._textValues},changes:{...this._changes},});for(const fieldName in this._changes){if(["one2many","many2many"].includes(this.fields[fieldName].type)){this._changes[fieldName]._addSavePoint();}}}
_applyChanges(changes,serverChanges={}){const initialTextValues={...this._textValues};const initialChanges={...this._changes};const initialData={...toRaw(this.data)};const invalidFields=[...toRaw(this._invalidFields)];const undoChanges=()=>{for(const fieldName of invalidFields){this.setInvalidField(fieldName);}
Object.assign(this.data,initialData);this._changes=markRaw(initialChanges);Object.assign(this._textValues,initialTextValues);this._setEvalContext();};for(const fieldName in changes){const change=changes[fieldName];this._changes[fieldName]=change;this.data[fieldName]=change;if(this.fields[fieldName].type==="html"){this._textValues[fieldName]=change===false?false:change.toString();}else if(["char","text"].includes(this.fields[fieldName].type)){this._textValues[fieldName]=change;}}
const parsedChanges=this._parseServerValues(serverChanges,this.data);for(const fieldName in parsedChanges){this._changes[fieldName]=parsedChanges[fieldName];this.data[fieldName]=parsedChanges[fieldName];}
Object.assign(this._textValues,this._getTextValues(serverChanges));this._setEvalContext();this._removeInvalidFields(Object.keys({...changes,...serverChanges}));this._checkValidity({removeInvalidOnly:true});return undoChanges;}
_applyDefaultValues(){const fieldNames=this.fieldNames.filter((fieldName)=>{return!(fieldName in this.data);});const defaultValues=this._getDefaultValues(fieldNames);if(this.isNew){this._applyChanges({},defaultValues);}else{this._applyValues(defaultValues);}}
_applyValues(values){const newValues=this._parseServerValues(values);Object.assign(this._values,newValues);for(const fieldName in newValues){if(fieldName in this._changes){if(["one2many","many2many"].includes(this.fields[fieldName].type)){this._changes[fieldName]=newValues[fieldName];}}}
Object.assign(this.data,this._values,this._changes);const textValues=this._getTextValues(values);Object.assign(this._initialTextValues,textValues);Object.assign(this._textValues,textValues,this._getTextValues(this._changes));this._setEvalContext();}
_checkValidity({silent,displayNotification,removeInvalidOnly}={}){const unsetRequiredFields=new Set();for(const fieldName in this.activeFields){const fieldType=this.fields[fieldName].type;if(this._isInvisible(fieldName)||this.fields[fieldName].relatedPropertyField){continue;}
switch(fieldType){case"boolean":case"float":case"integer":case"monetary":continue;case"html":if(this._isRequired(fieldName)&&this.data[fieldName].length===0){unsetRequiredFields.add(fieldName);}
break;case"one2many":case"many2many":{const list=this.data[fieldName];if((this._isRequired(fieldName)&&!list.count)||!list.records.every((r)=>!r.dirty||r._checkValidity({silent,removeInvalidOnly}))){unsetRequiredFields.add(fieldName);}
break;}
case"properties":{const value=this.data[fieldName];if(value){const ok=value.every((propertyDefinition)=>propertyDefinition.name&&propertyDefinition.name.length&&propertyDefinition.string&&propertyDefinition.string.length);if(!ok){unsetRequiredFields.add(fieldName);}}
break;}
case"json":{if(this._isRequired(fieldName)&&(!this.data[fieldName]||!Object.keys(this.data[fieldName]).length)){unsetRequiredFields.add(fieldName);}
break;}
default:if(!this.data[fieldName]&&this._isRequired(fieldName)){unsetRequiredFields.add(fieldName);}}}
if(silent){return!unsetRequiredFields.size;}
if(removeInvalidOnly){for(const fieldName of Array.from(this._unsetRequiredFields)){if(!unsetRequiredFields.has(fieldName)){this._unsetRequiredFields.delete(fieldName);this._invalidFields.delete(fieldName);}}}else{for(const fieldName of Array.from(this._unsetRequiredFields)){this._invalidFields.delete(fieldName);}
this._unsetRequiredFields.clear();for(const fieldName of unsetRequiredFields){this._unsetRequiredFields.add(fieldName);this._setInvalidField(fieldName);}}
const isValid=!this._invalidFields.size;if(!isValid&&displayNotification){const items=[...this._invalidFields].map((fieldName)=>{return`<li>${escape(this.fields[fieldName].string || fieldName)}</li>`;},this);this._closeInvalidFieldsNotification=this.model.notification.add(markup(`<ul>${items.join("")}</ul>`),{title:_t("Invalid fields: "),type:"danger",});}
return isValid;}
async _completeMany2OneValue(value,fieldName,resModel){const resId=value[0];const displayName=value[1];if(!resId&&!displayName){return false;}
const context=getFieldContext(this,fieldName);if(!resId&&displayName!==undefined){return this.model.orm.call(resModel,"name_create",[displayName],{context});}
if(resId&&displayName===undefined){const kwargs={context,specification:{display_name:{}},};const records=await this.model.orm.webRead(resModel,[resId],kwargs);return[resId,records[0].display_name];}
return value;}
_computeDataContext(){const dataContext={};const x2manyDataContext={withVirtualIds:{},withoutVirtualIds:{},};const data=toRaw(this.data);for(const fieldName in data){const value=data[fieldName];const field=this.fields[fieldName];if(field.relatedPropertyField){continue;}
if(["char","text","html"].includes(field.type)){dataContext[fieldName]=this._textValues[fieldName];}else if(field.type==="one2many"||field.type==="many2many"){x2manyDataContext.withVirtualIds[fieldName]=value.currentIds;x2manyDataContext.withoutVirtualIds[fieldName]=value.currentIds.filter((id)=>typeof id==="number");}else if(value&&field.type==="date"){dataContext[fieldName]=serializeDate(value);}else if(value&&field.type==="datetime"){dataContext[fieldName]=serializeDateTime(value);}else if(value&&field.type==="many2one"){dataContext[fieldName]=value[0];}else if(value&&field.type==="reference"){dataContext[fieldName]=`${value.resModel},${value.resId}`;}else if(field.type==="properties"){dataContext[fieldName]=value.filter((property)=>!property.definition_deleted!==false);}else{dataContext[fieldName]=value;}}
dataContext.id=this.resId||false;return{withVirtualIds:{...dataContext,...x2manyDataContext.withVirtualIds},withoutVirtualIds:{...dataContext,...x2manyDataContext.withoutVirtualIds},};}
_createStaticListDatapoint(data,fieldName){const{related,limit,defaultOrderBy}=this.activeFields[fieldName];const config={resModel:this.fields[fieldName].relation,activeFields:(related&&related.activeFields)||{},fields:(related&&related.fields)||{},relationField:this.fields[fieldName].relation_field||false,offset:0,resIds:data.map((r)=>r.id),orderBy:defaultOrderBy||[],limit:limit||Number.MAX_SAFE_INTEGER,currentCompanyId:this.currentCompanyId,context:{},};const options={onUpdate:({withoutOnchange}={})=>this._update({[fieldName]:[]},{withoutOnchange}),parent:this,};return new this.model.constructor.StaticList(this.model,config,data,options);}
_discard(){for(const fieldName in this._changes){if(["one2many","many2many"].includes(this.fields[fieldName].type)){this._changes[fieldName]._discard();}}
if(this._savePoint){this.dirty=this._savePoint.dirty;this._changes=markRaw({...this._savePoint.changes});this._textValues=markRaw({...this._savePoint.textValues});}else{this.dirty=false;this._changes=markRaw(this.isNew?{...this._initialChanges}:{});this._textValues=markRaw({...this._initialTextValues});}
this.data={...this._values,...this._changes};this._savePoint=undefined;this._setEvalContext();this._invalidFields.clear();this._closeInvalidFieldsNotification();this._closeInvalidFieldsNotification=()=>{};this._restoreActiveFields();}
_formatServerValue(fieldType,value){if(fieldType==="date"){return value?serializeDate(value):false;}else if(fieldType==="datetime"){return value?serializeDateTime(value):false;}else if(fieldType==="char"||fieldType==="text"){return value!==""?value:false;}else if(fieldType==="html"){return value&&value.length?value:false;}else if(fieldType==="many2one"){return value?value[0]:false;}else if(fieldType==="many2one_reference"){return value?value.resId:0;}else if(fieldType==="reference"){return value&&value.resModel&&value.resId?`${value.resModel},${value.resId}`:false;}else if(fieldType==="properties"){return value.map((property)=>{let value;if(property.type==="many2one"){value=property.value;}else if((property.type==="date"||property.type==="datetime")&&typeof property.value==="string"){value=property.value;}else{value=this._formatServerValue(property.type,property.value);}
return{...property,value,};});}
return value;}
_getChanges(changes=this._changes,{withReadonly}={}){const result={};for(const[fieldName,value]of Object.entries(changes)){const field=this.fields[fieldName];if(fieldName==="id"){continue;}
if(!withReadonly&&fieldName in this.activeFields&&this._isReadonly(fieldName)&&!this.activeFields[fieldName].forceSave){continue;}
if(field.relatedPropertyField){continue;}
if(field.type==="one2many"||field.type==="many2many"){const commands=value._getCommands({withReadonly});if(!this.isNew&&!commands.length&&!withReadonly){continue;}
result[fieldName]=commands;}else{result[fieldName]=this._formatServerValue(field.type,value);}}
return result;}
_getDefaultValues(fieldNames=this.fieldNames){const defaultValues={};for(const fieldName of fieldNames){switch(this.fields[fieldName].type){case"integer":case"float":case"monetary":defaultValues[fieldName]=fieldName==="id"?false:0;break;case"one2many":case"many2many":defaultValues[fieldName]=[];break;default:defaultValues[fieldName]=false;}}
return defaultValues;}
_getTextValues(values){const textValues={};for(const fieldName in values){if(!this.activeFields[fieldName]){continue;}
if(["char","text","html"].includes(this.fields[fieldName].type)){textValues[fieldName]=values[fieldName];}}
return textValues;}
_isInvisible(fieldName){const invisible=this.activeFields[fieldName].invisible;return invisible?evaluateBooleanExpr(invisible,this.evalContextWithVirtualIds):false;}
_isReadonly(fieldName){const readonly=this.activeFields[fieldName].readonly;return readonly?evaluateBooleanExpr(readonly,this.evalContextWithVirtualIds):false;}
_isRequired(fieldName){const required=this.activeFields[fieldName].required;return required?evaluateBooleanExpr(required,this.evalContextWithVirtualIds):false;}
async _load(nextConfig={}){if("resId"in nextConfig&&this.resId){throw new Error("Cannot change resId of a record");}
await this.model._updateConfig(this.config,nextConfig,{commit:(values)=>{if(this.resId){this.model._updateSimilarRecords(this,values);}
this._setData(values);},});}
_processProperties(properties,fieldName,parent,currentValues={}){const data={};const hasCurrentValues=Object.keys(currentValues).length>0;for(const property of properties){const propertyFieldName=`${fieldName}.${property.name}`;if(hasCurrentValues||!this.fields[propertyFieldName]){this.fields[propertyFieldName]={...property,name:propertyFieldName,relatedPropertyField:{name:fieldName,},propertyName:property.name,relation:property.comodel,};}
if(hasCurrentValues||!this.activeFields[propertyFieldName]){this.activeFields[propertyFieldName]=createPropertyActiveField(property);}
if(!this.activeFields[propertyFieldName].relatedPropertyField){this.activeFields[propertyFieldName].relatedPropertyField={name:fieldName,id:parent?.id,displayName:parent?.display_name,};}
if(property.type==="many2many"){let staticList=currentValues[propertyFieldName];if(!staticList){staticList=this._createStaticListDatapoint((property.value||[]).map((record)=>({id:record[0],display_name:record[1],})),propertyFieldName);}
data[propertyFieldName]=staticList;}else if(property.type==="many2one"){data[propertyFieldName]=property.value.length&&property.value[1]===null?[property.value[0],_t("No Access")]:property.value;}else{data[propertyFieldName]=property.value??false;}}
return data;}
_parseServerValues(serverValues,currentValues={}){const parsedValues={};if(!serverValues){return parsedValues;}
for(const fieldName in serverValues){const value=serverValues[fieldName];if(!this.activeFields[fieldName]){continue;}
const field=this.fields[fieldName];if(field.type==="one2many"||field.type==="many2many"){let staticList=currentValues[fieldName];let valueIsCommandList=true;valueIsCommandList=value.length>0&&Array.isArray(value[0]);if(!staticList){let data=valueIsCommandList?[]:value;if(data.length>0&&typeof data[0]==="number"){data=data.map((resId)=>{return{id:resId};});}
staticList=this._createStaticListDatapoint(data,fieldName);if(valueIsCommandList){staticList._applyInitialCommands(value);}}else if(valueIsCommandList){staticList._applyCommands(value);}
parsedValues[fieldName]=staticList;}else{parsedValues[fieldName]=parseServerValue(field,value);if(field.type==="properties"){const parent=serverValues[field.definition_record];Object.assign(parsedValues,this._processProperties(parsedValues[fieldName],fieldName,parent,currentValues));}}}
return parsedValues;}
async _preprocessMany2oneChanges(changes){const proms=Object.entries(changes).filter(([fieldName])=>this.fields[fieldName].type==="many2one").map(async([fieldName,value])=>{if(!value){changes[fieldName]=false;}else if(!this.activeFields[fieldName]){changes[fieldName]=value;}else{const relation=this.fields[fieldName].relation;return this._completeMany2OneValue(value,fieldName,relation).then((v)=>{changes[fieldName]=v;});}});return Promise.all(proms);}
async _preprocessMany2OneReferenceChanges(changes){const proms=Object.entries(changes).filter(([fieldName])=>this.fields[fieldName].type==="many2one_reference").map(async([fieldName,value])=>{if(!value){changes[fieldName]=false;}else if(typeof value==="number"){changes[fieldName]={resId:value};}else{const relation=this.data[this.fields[fieldName].model_field];return this._completeMany2OneValue([value.resId,value.displayName],fieldName,relation).then((v)=>{changes[fieldName]={resId:v[0],displayName:v[1]};});}});return Promise.all(proms);}
async _preprocessReferenceChanges(changes){const proms=Object.entries(changes).filter(([fieldName])=>this.fields[fieldName].type==="reference").map(async([fieldName,value])=>{if(!value){changes[fieldName]=false;}else{return this._completeMany2OneValue([value.resId,value.displayName],fieldName,value.resModel).then((v)=>{changes[fieldName]={resId:v[0],resModel:value.resModel,displayName:v[1],};});}});return Promise.all(proms);}
async _preprocessX2manyChanges(changes){for(const[fieldName,value]of Object.entries(changes)){if(this.fields[fieldName].type!=="one2many"&&this.fields[fieldName].type!=="many2many"){continue;}
const list=this.data[fieldName];for(const command of value){switch(command[0]){case x2ManyCommands.SET:await list._replaceWith(command[2]);break;default:await list._applyCommands([command]);}}
changes[fieldName]=list;}}
_preprocessPropertiesChanges(changes){for(const[fieldName,value]of Object.entries(changes)){const field=this.fields[fieldName];if(field.type==="properties"){const parent=changes[field.definition_record]||this.data[field.definition_record];Object.assign(changes,this._processProperties(value,fieldName,parent,this.data));}else if(field&&field.relatedPropertyField){const[propertyFieldName,propertyName]=field.name.split(".");const propertiesData=this.data[propertyFieldName]||[];if(!propertiesData.find((property)=>property.name===propertyName)){this.model.notification.add(_t("This record belongs to a different parent so you can not change this property."),{type:"warning"});return;}
changes[propertyFieldName]=propertiesData.map((property)=>property.name===propertyName?{...property,value}:property);}}}
_preprocessHtmlChanges(changes){for(const[fieldName,value]of Object.entries(changes)){if(this.fields[fieldName].type==="html"){changes[fieldName]=value===false?false:markup(value);}}}
_removeInvalidFields(fieldNames){for(const fieldName of fieldNames){this._invalidFields.delete(fieldName);}}
_restoreActiveFields(){if(!this._activeFieldsToRestore){return;}
this.model._updateConfig(this.config,{activeFields:{...this._activeFieldsToRestore},},{reload:false});this._activeFieldsToRestore=undefined;}
async _save({reload=true,onError,nextId}={}){if(this.model._closeUrgentSaveNotification){this.model._closeUrgentSaveNotification();}
const creation=!this.resId;if(nextId){if(creation){throw new Error("Cannot set nextId on a new record");}
reload=true;}
for(const fieldName in this.activeFields){const field=this.fields[fieldName];if(["one2many","many2many"].includes(field.type)&&!field.relatedPropertyField){this.data[fieldName]._abandonRecords();}}
if(!this._checkValidity({displayNotification:true})){return false;}
const changes=this._getChanges();delete changes.id;if(!creation&&!Object.keys(changes).length){if(nextId){return this.model.load({resId:nextId});}
this._changes=markRaw({});this.data={...this._values};this.dirty=false;return true;}
if(this.model._urgentSave&&this.model.useSendBeaconToSaveUrgently&&!this.model.env.inDialog){const route=`/web/dataset/call_kw/${this.resModel}/web_save`;const params={model:this.resModel,method:"web_save",args:[this.resId?[this.resId]:[],changes],kwargs:{context:this.context,specification:{}},};const data={jsonrpc:"2.0",method:"call",params};const blob=new Blob([JSON.stringify(data)],{type:"application/json"});const succeeded=navigator.sendBeacon(route,blob);if(succeeded){this._changes=markRaw({});this.dirty=false;}else{this.model._closeUrgentSaveNotification=this.model.notification.add(markup(_t(`Heads up! Your recent changes are too large to save automatically. Please click the <i class="fa fa-cloud-upload fa-fw"></i> button now to ensure your work is saved before you exit this tab.`)),{sticky:true});}
return succeeded;}
const canProceed=await this.model.hooks.onWillSaveRecord(this,changes);if(canProceed===false){return false;}
let fieldSpec={};if(reload){fieldSpec=getFieldsSpec(this.activeFields,this.fields,getBasicEvalContext(this.config));}
const kwargs={context:this.context,specification:fieldSpec,next_id:nextId,};let records=[];try{records=await this.model.orm.webSave(this.resModel,this.resId?[this.resId]:[],changes,kwargs);}catch(e){if(onError){return onError(e,{discard:()=>this._discard()});}
if(!this.isInEdition){await this._load({});}
throw e;}
if(reload&&!records.length){throw new FetchRecordError([nextId||this.resId]);}
if(creation){const resId=records[0].id;const resIds=this.resIds.concat([resId]);this.model._updateConfig(this.config,{resId,resIds},{reload:false});}
await this.model.hooks.onRecordSaved(this,changes);if(reload){if(this.resId){this.model._updateSimilarRecords(this,records[0]);}
if(nextId){this.model._updateConfig(this.config,{resId:nextId},{reload:false});}
if(this.config.isRoot){this.model.hooks.onWillLoadRoot(this.config);}
this._setData(records[0]);}else{this._values=markRaw({...this._values,...this._changes});if("id"in this.activeFields){this._values.id=records[0].id;}
for(const fieldName in this.activeFields){const field=this.fields[fieldName];if(["one2many","many2many"].includes(field.type)&&!field.relatedPropertyField){this._changes[fieldName]?._clearCommands();}}
this._changes=markRaw({});this.data={...this._values};this.dirty=false;}
return true;}
_setEvalContext(){const evalContext=getBasicEvalContext(this.config);const dataContext=this._computeDataContext();Object.assign(this.evalContext,evalContext,dataContext.withoutVirtualIds);Object.assign(this.evalContextWithVirtualIds,evalContext,dataContext.withVirtualIds);this._isEvalContextReady=true;if(!this._parentRecord||this._parentRecord._isEvalContextReady){for(const[fieldName,value]of Object.entries(toRaw(this.data))){if(["one2many","many2many"].includes(this.fields[fieldName].type)){value._updateContext(getFieldContext(this,fieldName));}}}}
async _setInvalidField(fieldName){const canProceed=this.model.hooks.onWillSetInvalidField(this,fieldName);if(canProceed===false){return;}
if(this.selected&&this.model.multiEdit&&this.model.root._recordToDiscard!==this&&!this._invalidFields.has(fieldName)){await this.model.dialog.add(AlertDialog,{body:_t("No valid record to save"),confirm:async()=>{await this.discard();this.switchMode("readonly");},});}
this._invalidFields.add(fieldName);}
_resetFieldValidity(fieldName){this._invalidFields.delete(fieldName);}
_switchMode(mode){this.model._updateConfig(this.config,{mode},{reload:false});if(mode==="readonly"){this._noUpdateParent=false;this._invalidFields.clear();}}
async _toggleArchive(state){const method=state?"action_archive":"action_unarchive";const action=await this.model.orm.call(this.resModel,method,[[this.resId]],{context:this.context,});if(action&&Object.keys(action).length){this.model.action.doAction(action,{onClose:()=>this._load()});}else{return this._load();}}
_toggleSelection(selected){if(typeof selected==="boolean"){this.selected=selected;}else{this.selected=!this.selected;}
if(!this.selected&&this.model.root.isDomainSelected){this.model.root._selectDomain(false);}}
async _getOnchangeValues(changes){const onChangeFields=Object.keys(changes).filter((fieldName)=>this.activeFields[fieldName]&&this.activeFields[fieldName].onChange);if(!onChangeFields.length){return{};}
const localChanges=this._getChanges({...this._changes,...changes},{withReadonly:true});if(this.config.relationField){const parentRecord=this._parentRecord;localChanges[this.config.relationField]=parentRecord._getChanges(parentRecord._changes,{withReadonly:true});if(!this._parentRecord.isNew){localChanges[this.config.relationField].id=this._parentRecord.resId;}}
return this.model._onchange(this.config,{changes:localChanges,fieldNames:onChangeFields,evalContext:toRaw(this.evalContext),onError:(e)=>{const undoChanges=this._applyChanges(changes);undoChanges();throw e;},});}
async _update(changes,{withoutOnchange,withoutParentUpdate}={}){this.dirty=true;const prom=Promise.all([this._preprocessMany2oneChanges(changes),this._preprocessMany2OneReferenceChanges(changes),this._preprocessReferenceChanges(changes),this._preprocessX2manyChanges(changes),this._preprocessPropertiesChanges(changes),this._preprocessHtmlChanges(changes),]);if(!this.model._urgentSave){await prom;}
if(this.selected&&this.model.multiEdit){this._applyChanges(changes);return this.model.root._multiSave(this);}
let onchangeServerValues={};if(!this.model._urgentSave&&!withoutOnchange){onchangeServerValues=await this._getOnchangeValues(changes);}
for(const fieldName in changes){if(this.fields[fieldName].type==="many2one"){const curVal=toRaw(this.data[fieldName]);const nextVal=changes[fieldName];if(curVal&&nextVal&&curVal[0]===nextVal[0]&&curVal[1]===nextVal[1]){delete changes[fieldName];}}}
const undoChanges=this._applyChanges(changes,onchangeServerValues);if(Object.keys(changes).length>0||Object.keys(onchangeServerValues).length>0){try{await this._onUpdate({withoutParentUpdate});}catch(e){undoChanges();throw e;}
await this.model.hooks.onRecordChanged(this,this._getChanges());}}}
return __exports;});;

/* /web/static/src/model/relational_model/relational_model.js */
odoo.define('@web/model/relational_model/relational_model',['@odoo/owl','@web/core/context','@web/core/domain','@web/core/errors/error_dialogs','@web/core/utils/arrays','@web/core/utils/concurrency','@web/search/utils/order_by','@web/model/model','@web/model/relational_model/dynamic_group_list','@web/model/relational_model/dynamic_record_list','@web/model/relational_model/group','@web/model/relational_model/record','@web/model/relational_model/static_list','@web/model/relational_model/utils','@web/model/relational_model/errors'],function(require){'use strict';let __exports={};const{EventBus,markRaw,toRaw}=require("@odoo/owl");const{makeContext}=require("@web/core/context");const{Domain}=require("@web/core/domain");const{WarningDialog}=require("@web/core/errors/error_dialogs");const{shallowEqual}=require("@web/core/utils/arrays");const{KeepLast,Mutex}=require("@web/core/utils/concurrency");const{orderByToString}=require("@web/search/utils/order_by");const{Model}=require("@web/model/model");const{DynamicGroupList}=require("@web/model/relational_model/dynamic_group_list");const{DynamicRecordList}=require("@web/model/relational_model/dynamic_record_list");const{Group}=require("@web/model/relational_model/group");const{Record}=require("@web/model/relational_model/record");const{StaticList}=require("@web/model/relational_model/static_list");const{extractInfoFromGroupData,getBasicEvalContext,getFieldsSpec,isRelational,makeActiveField,}=require("@web/model/relational_model/utils");const{FetchRecordError}=require("@web/model/relational_model/errors");const DEFAULT_HOOKS={onWillLoadRoot:()=>{},onRootLoaded:()=>{},onWillSaveRecord:()=>{},onRecordSaved:()=>{},onWillSaveMulti:()=>{},onSavedMulti:()=>{},onWillSetInvalidField:()=>{},onRecordChanged:()=>{},};const RelationalModel=__exports.RelationalModel=class RelationalModel extends Model{static services=["action","company","dialog","notification","orm"];static Record=Record;static Group=Group;static DynamicRecordList=DynamicRecordList;static DynamicGroupList=DynamicGroupList;static StaticList=StaticList;static DEFAULT_LIMIT=80;static DEFAULT_COUNT_LIMIT=10000;static DEFAULT_GROUP_LIMIT=80;static DEFAULT_OPEN_GROUP_LIMIT=10;static MAX_NUMBER_OPENED_GROUPS=10;setup(params,{action,company,dialog,notification}){this.action=action;this.dialog=dialog;this.notification=notification;this.bus=new EventBus();this.keepLast=markRaw(new KeepLast());this.mutex=markRaw(new Mutex());this.config={isMonoRecord:false,currentCompanyId:company.currentCompany.id,context:{},...params.config,isRoot:true,};this.hooks=Object.assign({},DEFAULT_HOOKS,params.hooks);this.initialLimit=params.limit||this.constructor.DEFAULT_LIMIT;this.initialGroupsLimit=params.groupsLimit;this.initialCountLimit=params.countLimit||this.constructor.DEFAULT_COUNT_LIMIT;this.defaultOrderBy=params.defaultOrderBy;this.defaultGroupBy=params.defaultGroupBy;this.maxGroupByDepth=params.maxGroupByDepth;this.groupByInfo=params.groupByInfo||{};this.multiEdit=params.multiEdit;this.activeIdsLimit=params.activeIdsLimit||Number.MAX_SAFE_INTEGER;this.specialDataCaches=markRaw(params.state?.specialDataCaches||{});this.useSendBeaconToSaveUrgently=params.useSendBeaconToSaveUrgently||false;this._urgentSave=false;}
exportState(){return{config:toRaw(this.config),specialDataCaches:this.specialDataCaches,};}
hasData(){return this.root.hasData;}
async load(params={}){const config=this._getNextConfig(this.config,params);this.hooks.onWillLoadRoot(config);const data=await this.keepLast.add(this._loadData(config));this.root=this._createRoot(config,data);this.config=config;return this.hooks.onRootLoaded();}
async _getPropertyDefinition(config,propertyFullName){const result=await this.orm.call(config.resModel,"get_property_definition",[propertyFullName],{context:config.context});if(!result){config.groupBy=null;}else{result.propertyName=result.name;result.name=propertyFullName;result.relatedPropertyField={fieldName:propertyFullName.split(".")[0]};result.relation=result.comodel;config.fields[propertyFullName]=result;}}
_askChanges(){const proms=[];this.bus.trigger("NEED_LOCAL_CHANGES",{proms});return Promise.all([...proms,this.mutex.getUnlockedDef()]);}
_createRoot(config,data){if(config.isMonoRecord){return new this.constructor.Record(this,config,data);}
if(config.groupBy.length){return new this.constructor.DynamicGroupList(this,config,data);}
return new this.constructor.DynamicRecordList(this,config,data);}
_getNextConfig(currentConfig,params){const currentGroupBy=currentConfig.groupBy;const config=Object.assign({},currentConfig);config.context="context"in params?params.context:config.context;if(currentConfig.isMonoRecord){config.resId="resId"in params?params.resId:config.resId;config.resIds="resIds"in params?params.resIds:config.resIds;if(!config.resIds){config.resIds=config.resId?[config.resId]:[];}
if(!config.resId&&config.mode!=="edit"){config.mode="edit";}}else{config.domain="domain"in params?params.domain:config.domain;config.comparison="comparison"in params?params.comparison:config.comparison;config.groupBy="groupBy"in params?params.groupBy:config.groupBy;if(this.defaultGroupBy&&!config.groupBy.length){config.groupBy=[this.defaultGroupBy];}
if(this.maxGroupByDepth){config.groupBy=config.groupBy.slice(0,this.maxGroupByDepth);}
config.orderBy="orderBy"in params?params.orderBy:config.orderBy;if(!config.orderBy.length){config.orderBy=currentConfig.orderBy||[];}
if(this.defaultOrderBy&&!config.orderBy.length){config.orderBy=this.defaultOrderBy;}
if(!shallowEqual(config.groupBy||[],currentGroupBy||[])){delete config.groups;}
if(!config.groupBy.length){config.orderBy=config.orderBy.filter((order)=>order.name!=="__count");}}
if(!config.isMonoRecord&&this.root&&params.domain){const resetOffset=(config)=>{config.offset=0;for(const group of Object.values(config.groups||{})){resetOffset(group.list);}};resetOffset(config);if(!!config.groupBy.length!==!!currentGroupBy.length){delete config.limit;}}
return config;}
async _loadData(config){if(config.isMonoRecord){const evalContext=getBasicEvalContext(config);if(!config.resId){return this._loadNewRecord(config,{evalContext});}
const records=await this._loadRecords({...config,resIds:[config.resId],},evalContext);return records[0];}
if(config.resIds){const resIds=config.resIds.slice(config.offset,config.offset+config.limit);return this._loadRecords({...config,resIds});}
if(config.groupBy.length){return this._loadGroupedList(config);}
Object.assign(config,{limit:config.limit||this.initialLimit,countLimit:"countLimit"in config?config.countLimit:this.initialCountLimit,offset:config.offset||0,});if(config.countLimit!==Number.MAX_SAFE_INTEGER){config.countLimit=Math.max(config.countLimit,config.offset+config.limit);}
const{records,length}=await this._loadUngroupedList({...config,context:{...config.context,current_company_id:config.currentCompanyId,},});if(config.offset&&!records.length){config.offset=0;return this._loadData(config);}
return{records,length};}
async _loadGroupedList(config){config.offset=config.offset||0;config.limit=config.limit||this.initialGroupsLimit;if(!config.limit){config.limit=config.openGroupsByDefault?this.constructor.DEFAULT_OPEN_GROUP_LIMIT:this.constructor.DEFAULT_GROUP_LIMIT;}
config.groups=config.groups||{};const firstGroupByName=config.groupBy[0].split(":")[0];if(firstGroupByName.includes(".")){if(!config.fields[firstGroupByName]){await this._getPropertyDefinition(config,firstGroupByName);}
const propertiesFieldName=firstGroupByName.split(".")[0];if(!config.activeFields[propertiesFieldName]){config.activeFields[propertiesFieldName]=makeActiveField();}}
const orderBy=config.orderBy.filter((o)=>o.name===firstGroupByName||o.name==="__count"||(o.name in config.activeFields&&config.fields[o.name].aggregator!==undefined));const response=await this._webReadGroup(config,orderBy);const{groups:groupsData,length}=response;const groupBy=config.groupBy.slice(1);const groupByField=config.fields[config.groupBy[0].split(":")[0]];const commonConfig={resModel:config.resModel,fields:config.fields,activeFields:config.activeFields,};let groupRecordConfig;const groupRecordResIds=[];if(this.groupByInfo[firstGroupByName]){groupRecordConfig={...this.groupByInfo[firstGroupByName],resModel:config.fields[firstGroupByName].relation,context:{},};}
const proms=[];let nbOpenGroups=0;const groups=[];for(const groupData of groupsData){const group=extractInfoFromGroupData(groupData,config.groupBy,config.fields);if(!config.groups[group.value]){config.groups[group.value]={...commonConfig,groupByFieldName:groupByField.name,isFolded:"__fold"in groupData?groupData.__fold:!config.openGroupsByDefault,extraDomain:false,value:group.value,list:{...commonConfig,groupBy,},};if(isRelational(config.fields[firstGroupByName])&&!group.value){config.groups[group.value].isFolded=true;}
if(groupRecordConfig){config.groups[group.value].record={...groupRecordConfig,resId:group.value??false,};}}
if(groupRecordConfig){const resId=config.groups[group.value].record.resId;if(resId){groupRecordResIds.push(resId);}}
const groupConfig=config.groups[group.value];groupConfig.list.orderBy=config.orderBy;groupConfig.initialDomain=group.domain;if(groupConfig.extraDomain){groupConfig.list.domain=Domain.and([group.domain,groupConfig.extraDomain,]).toList();}else{groupConfig.list.domain=group.domain;}
const context={...config.context,[`default_${firstGroupByName}`]:group.serverValue,};groupConfig.list.context=context;groupConfig.context=context;if(groupBy.length){group.groups=[];}else{group.records=[];}
if(!groupConfig.isFolded){nbOpenGroups++;if(nbOpenGroups>this.constructor.MAX_NUMBER_OPENED_GROUPS){groupConfig.isFolded=true;}}
if(!groupConfig.isFolded&&group.count>0){const prom=this._loadData(groupConfig.list).then((response)=>{if(groupBy.length){group.groups=response?response.groups:[];group.length=response?response.length:0;}else{group.records=response?response.records:[];}});proms.push(prom);}
groups.push(group);}
if(groupRecordConfig&&Object.keys(groupRecordConfig.activeFields).length){const prom=this._loadRecords({...groupRecordConfig,resIds:groupRecordResIds,}).then((records)=>{for(const group of groups){if(!group.value){group.values={id:false};continue;}
group.values=records.find((r)=>group.value&&r.id===group.value);}});proms.push(prom);}
await Promise.all(proms);const params=JSON.stringify([config.domain,config.groupBy,config.offset,config.limit,config.orderBy,]);if(config.currentGroups&&config.currentGroups.params===params){const currentGroups=config.currentGroups.groups;currentGroups.forEach((group,index)=>{if(config.groups[group.value]&&!groups.some((g)=>JSON.stringify(g.value)===JSON.stringify(group.value))){const aggregates=Object.assign({},group.aggregates);for(const key in aggregates){aggregates[key]=0;}
groups.splice(index,0,Object.assign({},group,{count:0,length:0,records:[],aggregates}));}});}
config.currentGroups={params,groups};return{groups,length};}
async _loadNewRecord(config,params={}){return this._onchange(config,params);}
async _loadRecords(config,evalContext=config.context){const{resModel,resIds,activeFields,fields,context}=config;if(!resIds.length){return[];}
const fieldSpec=getFieldsSpec(activeFields,fields,evalContext);if(Object.keys(fieldSpec).length>0){const kwargs={context:{bin_size:true,...context},specification:fieldSpec,};const records=await this.orm.webRead(resModel,resIds,kwargs);if(!records.length){throw new FetchRecordError(resIds);}
return records;}else{return resIds.map((resId)=>{return{id:resId};});}}
async _loadUngroupedList(config){const orderBy=config.orderBy.filter((o)=>o.name!=="__count");const kwargs={specification:getFieldsSpec(config.activeFields,config.fields,config.context),offset:config.offset,order:orderByToString(orderBy),limit:config.limit,context:{bin_size:true,...config.context},count_limit:config.countLimit!==Number.MAX_SAFE_INTEGER?config.countLimit+1:undefined,};return this.orm.webSearchRead(config.resModel,config.domain,kwargs);}
async _onchange(config,{changes={},fieldNames=[],evalContext=config.context,onError}){const{fields,activeFields,resModel,resId}=config;let context=config.context;if(fieldNames.length===1){const fieldContext=config.activeFields[fieldNames[0]].context;context=makeContext([context,fieldContext],evalContext);}
const spec=getFieldsSpec(activeFields,fields,evalContext,{withInvisible:true});const args=[resId?[resId]:[],changes,fieldNames,spec];let response;try{response=await this.orm.call(resModel,"onchange",args,{context});}catch(e){if(onError){return onError(e);}
throw e;}
if(response.warning){const{type,title,message,className,sticky}=response.warning;if(type==="dialog"){this.dialog.add(WarningDialog,{title,message});}else{this.notification.add(message,{className,sticky,title,type:"warning",});}}
return response.value;}
async _updateConfig(config,patch,{reload=true,commit}={}){const tmpConfig={...config,...patch};markRaw(tmpConfig.activeFields);markRaw(tmpConfig.fields);let data;if(reload){if(tmpConfig.isRoot){this.hooks.onWillLoadRoot(tmpConfig);}
data=await this._loadData(tmpConfig);}
Object.assign(config,tmpConfig);if(data&&commit){commit(data);}
if(reload&&config.isRoot){return this.hooks.onRootLoaded();}}
async _updateCount(config){const count=await this.keepLast.add(this.orm.searchCount(config.resModel,config.domain,{context:config.context}));config.countLimit=Number.MAX_SAFE_INTEGER;return count;}
_updateSimilarRecords(reloadedRecord,serverValues){if(this.config.isMonoRecord||!this.config.groupBy.length){return;}
for(const record of this.root.records){if(record===reloadedRecord){continue;}
if(record.resId===reloadedRecord.resId){record._applyValues(serverValues);}}}
async _webReadGroup(config,orderBy){const aggregates=Object.values(config.fields).filter((field)=>field.aggregator&&field.name in config.activeFields&&field.name!==config.groupBy[0]).map((field)=>`${field.name}:${field.aggregator}`);return this.orm.webReadGroup(config.resModel,config.domain,aggregates,[config.groupBy[0]],{orderby:orderByToString(orderBy),lazy:true,offset:config.offset,limit:config.limit,context:config.context,});}}
return __exports;});;

/* /web/static/src/model/relational_model/static_list.js */
odoo.define('@web/model/relational_model/static_list',['@web/core/orm_service','@web/core/utils/arrays','@web/core/utils/objects','@web/model/relational_model/utils','@web/model/relational_model/datapoint','@odoo/owl'],function(require){'use strict';let __exports={};const{x2ManyCommands}=require("@web/core/orm_service");const{intersection}=require("@web/core/utils/arrays");const{pick}=require("@web/core/utils/objects");const{completeActiveFields}=require("@web/model/relational_model/utils");const{DataPoint}=require("@web/model/relational_model/datapoint");const{fromUnityToServerValues,getBasicEvalContext,getId,patchActiveFields}=require("@web/model/relational_model/utils");const{markRaw}=require("@odoo/owl");function compareFieldValues(v1,v2,fieldType){if(fieldType==="many2one"){v1=v1?v1[1]:"";v2=v2?v2[1]:"";}
return v1<v2;}
function compareRecords(r1,r2,orderBy,fields){const{name,asc}=orderBy[0];function getValue(record,fieldName){return fieldName==="id"?record.resId:record.data[fieldName];}
const v1=asc?getValue(r1,name):getValue(r2,name);const v2=asc?getValue(r2,name):getValue(r1,name);if(compareFieldValues(v1,v2,fields[name].type)){return-1;}
if(compareFieldValues(v2,v1,fields[name].type)){return 1;}
if(orderBy.length>1){return compareRecords(r1,r2,orderBy.slice(1),fields);}
return 0;}
const StaticList=__exports.StaticList=class StaticList extends DataPoint{static type="StaticList";setup(config,data,options={}){this._parent=options.parent;this._onUpdate=options.onUpdate;this._cache=markRaw({});this._commands=[];this._initialCommands=[];this._savePoint=undefined;this._unknownRecordCommands={};this._currentIds=[...this.resIds];this._initialCurrentIds=[...this.currentIds];this._needsReordering=false;this._tmpIncreaseLimit=0;this._extendedRecords=new Set();this.records=data.slice(this.offset,this.limit).map((r)=>this._createRecordDatapoint(r));this.count=this.resIds.length;this.handleField=Object.keys(this.activeFields).find((fieldName)=>this.activeFields[fieldName].isHandle);}
get currentIds(){return this._currentIds;}
get editedRecord(){return this.records.find((record)=>record.isInEdition);}
get evalContext(){const evalContext=getBasicEvalContext(this.config);evalContext.parent=this._parent.evalContext;return evalContext;}
get limit(){return this.config.limit;}
get offset(){return this.config.offset;}
get orderBy(){return this.config.orderBy;}
get resIds(){return this.config.resIds;}
addNewRecord(params){return this.model.mutex.exec(async()=>{const{activeFields,context,mode,position,withoutParent}=params;const record=await this._createNewRecordDatapoint({activeFields,context,position,withoutParent,manuallyAdded:true,mode,});await this._addRecord(record,{position});await this._onUpdate({withoutOnchange:!record._checkValidity({silent:true})});return record;});}
canResequence(){return this.handleField&&this.orderBy.length&&this.orderBy[0].name===this.handleField;}
delete(record){return this.model.mutex.exec(async()=>{await this._applyCommands([[x2ManyCommands.DELETE,record.resId||record._virtualId]]);await this._onUpdate();});}
async enterEditMode(record){const canProceed=await this.leaveEditMode();if(canProceed){await record.switchMode("edit");}
return canProceed;}
extendRecord(params,record){return this.model.mutex.exec(async()=>{completeActiveFields(this.config.activeFields,params.activeFields);Object.assign(this.fields,params.fields);const activeFields={...params.activeFields};for(const fieldName in this.activeFields){if(fieldName in activeFields){patchActiveFields(activeFields[fieldName],this.activeFields[fieldName]);}else{activeFields[fieldName]=this.activeFields[fieldName];}}
if(record){record._noUpdateParent=true;record._activeFieldsToRestore={...this.config.activeFields};const config={...record.config,...params,activeFields,};if(this._extendedRecords.has(record.id)){this.model._updateConfig(record.config,config,{reload:false});record._addSavePoint();return record;}
let data={};if(!record.isNew){const evalContext=Object.assign({},record.evalContext,config.context);const resIds=[record.resId];[data]=await this.model._loadRecords({...config,resIds},evalContext);}
this.model._updateConfig(record.config,config,{reload:false});record._applyDefaultValues();for(const fieldName in record.activeFields){if(["one2many","many2many"].includes(record.fields[fieldName].type)){const list=record.data[fieldName];const patch={activeFields:activeFields[fieldName].related.activeFields,fields:activeFields[fieldName].related.fields,};for(const subRecord of Object.values(list._cache)){this.model._updateConfig(subRecord.config,patch,{reload:false,});}
this.model._updateConfig(list.config,patch,{reload:false});}}
record._applyValues(data);const commands=this._unknownRecordCommands[record.resId];delete this._unknownRecordCommands[record.resId];if(commands){this._applyCommands(commands);}
record._addSavePoint();}else{record=await this._createNewRecordDatapoint({activeFields,context:params.context,withoutParent:params.withoutParent,manuallyAdded:true,});record._activeFieldsToRestore={...this.config.activeFields};record._noUpdateParent=true;}
this._extendedRecords.add(record.id);return record;});}
forget(record){return this.model.mutex.exec(async()=>{await this._applyCommands([[x2ManyCommands.UNLINK,record.resId]]);await this._onUpdate();});}
async leaveEditMode({discard,canAbandon,validate}={}){if(this.editedRecord){await this.model._askChanges(false);}
return this.model.mutex.exec(async()=>{let editedRecord=this.editedRecord;if(editedRecord){const isValid=editedRecord._checkValidity();if(!isValid&&validate){return false;}
if(canAbandon!==false&&!validate){this._abandonRecords([editedRecord],{force:true});}
editedRecord=this.editedRecord;if(editedRecord){if(isValid&&!editedRecord.dirty&&discard){return false;}
if(isValid||(!editedRecord.dirty&&!editedRecord._manuallyAdded)){editedRecord._switchMode("readonly");}}}
return!this.editedRecord;});}
linkTo(resId,serverData){return this.model.mutex.exec(async()=>{await this._applyCommands([[x2ManyCommands.LINK,resId,serverData]]);await this._onUpdate();});}
unlinkFrom(resId,serverData){return this.model.mutex.exec(async()=>{await this._applyCommands([[x2ManyCommands.UNLINK,resId,serverData]]);await this._onUpdate();});}
load({limit,offset,orderBy}={}){return this.model.mutex.exec(async()=>{const editedRecord=this.editedRecord;if(editedRecord&&!(await editedRecord.checkValidity())){return;}
limit=limit!==undefined?limit:this.limit;offset=offset!==undefined?offset:this.offset;orderBy=orderBy!==undefined?orderBy:this.orderBy;return this._load({limit,offset,orderBy});});}
moveRecord(dataRecordId,_dataGroupId,refId,_targetGroupId){return this.resequence(dataRecordId,refId);}
sortBy(fieldName){return this.model.mutex.exec(()=>this._sortBy(fieldName));}
async addAndRemove({add,remove,reload}={}){return this.model.mutex.exec(async()=>{const commands=[...(add||[]).map((id)=>[x2ManyCommands.LINK,id]),...(remove||[]).map((id)=>[x2ManyCommands.UNLINK,id]),];await this._applyCommands(commands,{canAddOverLimit:true,reload});await this._onUpdate();});}
async resequence(movedId,targetId){return this.model.mutex.exec(()=>this._resequence(movedId,targetId));}
validateExtendedRecord(record){return this.model.mutex.exec(async()=>{if(!this._currentIds.includes(record.isNew?record._virtualId:record.resId)){await this._addRecord(record);}else if(!record.dirty){return;}
await this._onUpdate();record._restoreActiveFields();record._savePoint=undefined;});}
_abandonRecords(records=this.records,{force}={}){for(const record of records){if(record.canBeAbandoned&&(force||!record._checkValidity())){const virtualId=record._virtualId;const index=this._currentIds.findIndex((id)=>id===virtualId);this._currentIds.splice(index,1);this.records.splice(this.records.findIndex((r)=>r===record),1);this._commands=this._commands.filter((c)=>c[1]!==virtualId);this.count--;if(this._tmpIncreaseLimit>0){this.model._updateConfig(this.config,{limit:this.limit-1},{reload:false});this._tmpIncreaseLimit--;}}}}
async _addRecord(record,{position}={}){const command=[x2ManyCommands.CREATE,record._virtualId];if(position==="top"){this.records.unshift(record);if(this.records.length>this.limit){this.records.pop();}
this._currentIds.splice(this.offset,0,record._virtualId);this._commands.unshift(command);}else if(position==="bottom"){this.records.push(record);this._currentIds.splice(this.offset+this.limit,0,record._virtualId);if(this.records.length>this.limit){this._tmpIncreaseLimit++;const nextLimit=this.limit+1;this.model._updateConfig(this.config,{limit:nextLimit},{reload:false});}
this._commands.push(command);}else{const currentIds=[...this._currentIds,record._virtualId];if(this.orderBy.length){await this._sort(currentIds);}else{if(this.records.length<this.limit){this.records.push(record);}}
this._currentIds=currentIds;this._commands.push(command);}
this.count++;this._needsReordering=true;}
_addSavePoint(){for(const id in this._cache){this._cache[id]._addSavePoint();}
this._savePoint=markRaw({_commands:[...this._commands],_currentIds:[...this._currentIds],count:this.count,});}
_applyCommands(commands,{canAddOverLimit,reload}={}){const{CREATE,UPDATE,DELETE,UNLINK,LINK,SET}=x2ManyCommands;let lastCommandIndex=-1;const commandsByIds={};function addOwnCommand(command){commandsByIds[command[1]]=commandsByIds[command[1]]||[];commandsByIds[command[1]].push({command,index:++lastCommandIndex});}
function getOwnCommands(id){commandsByIds[id]=commandsByIds[id]||[];return commandsByIds[id];}
for(const command of this._commands){addOwnCommand(command);}
const removedIds={};const recordsToLoad=[];for(const command of commands){switch(command[0]){case CREATE:{const virtualId=getId("virtual");const record=this._createRecordDatapoint(command[2],{virtualId});this.records.push(record);addOwnCommand([CREATE,virtualId]);const index=this.offset+this.limit+this._tmpIncreaseLimit;this._currentIds.splice(index,0,virtualId);this._tmpIncreaseLimit=Math.max(this.records.length-this.limit,0);const nextLimit=this.limit+this._tmpIncreaseLimit;this.model._updateConfig(this.config,{limit:nextLimit},{reload:false});this.count++;break;}
case UPDATE:{const existingCommand=getOwnCommands(command[1]).some((x)=>x.command[0]===CREATE||x.command[0]===UPDATE);if(!existingCommand){addOwnCommand([UPDATE,command[1]]);}
const record=this._cache[command[1]];if(!record){if(!(command[1]in this._unknownRecordCommands)){this._unknownRecordCommands[command[1]]=[];}
this._unknownRecordCommands[command[1]].push(command);}else if(command[1]in this._unknownRecordCommands){this._unknownRecordCommands[command[1]].push(command);}else{const changes={};for(const fieldName in command[2]){if(["one2many","many2many"].includes(this.fields[fieldName].type)){const invisible=record.activeFields[fieldName]?.invisible;if(invisible==="True"||invisible==="1"||!(fieldName in record.activeFields)){if(!(command[1]in this._unknownRecordCommands)){this._unknownRecordCommands[command[1]]=[];}
this._unknownRecordCommands[command[1]].push(command);continue;}}
changes[fieldName]=command[2][fieldName];}
record._applyChanges(record._parseServerValues(changes,record.data));}
break;}
case DELETE:case UNLINK:{if(command[0]===UNLINK){const firstCommand=this._commands[0];const hasReplaceWithCommand=firstCommand&&firstCommand[0]===SET;if(hasReplaceWithCommand&&firstCommand[2].includes(command[1])){firstCommand[2]=firstCommand[2].filter((id)=>id!==command[1]);break;}}
const ownCommands=getOwnCommands(command[1]);if(command[0]===DELETE){const hasCreateCommand=ownCommands.some((x)=>x.command[0]===CREATE);ownCommands.splice(0);if(!hasCreateCommand){addOwnCommand([DELETE,command[1]]);}}else{const linkToIndex=ownCommands.findIndex((x)=>x.command[0]===LINK);if(linkToIndex>=0){ownCommands.splice(linkToIndex,1);}else{addOwnCommand([UNLINK,command[1]]);}}
removedIds[command[1]]=true;break;}
case LINK:{let record;if(command[1]in this._cache){record=this._cache[command[1]];}else{record=this._createRecordDatapoint({...command[2],id:command[1]});}
if(!this.limit||this.records.length<this.limit||canAddOverLimit){if(!command[2]){recordsToLoad.push(record);}
this.records.push(record);if(this.records.length>this.limit){this._tmpIncreaseLimit=this.records.length-this.limit;const nextLimit=this.limit+this._tmpIncreaseLimit;this.model._updateConfig(this.config,{limit:nextLimit},{reload:false});}}
this._currentIds.push(record.resId);addOwnCommand([command[0],command[1]]);this.count++;break;}}}
this._commands=Object.values(commandsByIds).flat().sort((x,y)=>x.index-y.index).map((x)=>x.command);if(Object.keys(removedIds).length){let removeCommandsByIdsCopy=Object.assign({},removedIds);this.records=this.records.filter((r)=>{const id=r.resId||r._virtualId;if(removeCommandsByIdsCopy[id]){delete removeCommandsByIdsCopy[id];return false;}
return true;});const nextCurrentIds=[];removeCommandsByIdsCopy=Object.assign({},removedIds);for(const id of this._currentIds){if(removeCommandsByIdsCopy[id]){delete removeCommandsByIdsCopy[id];}else{nextCurrentIds.push(id);}}
this._currentIds=nextCurrentIds;this.count=this._currentIds.length;}
const nbMissingRecords=this.limit-this.records.length;if(nbMissingRecords>0){const lastRecordIndex=this.limit+this.offset;const firstRecordIndex=lastRecordIndex-nbMissingRecords;const nextRecordIds=this._currentIds.slice(firstRecordIndex,lastRecordIndex);for(const id of this._getResIdsToLoad(nextRecordIds)){const record=this._createRecordDatapoint({id},{dontApplyCommands:true});recordsToLoad.push(record);}
for(const id of nextRecordIds){this.records.push(this._cache[id]);}}
if(recordsToLoad.length||reload){const resIds=reload?this.records.map((r)=>r.resId):recordsToLoad.map((r)=>r.resId);return this.model._loadRecords({...this.config,resIds}).then((recordValues)=>{if(reload){for(const record of recordValues){this._createRecordDatapoint(record);}
this.records=resIds.map((id)=>this._cache[id]);return;}
for(let i=0;i<recordsToLoad.length;i++){const record=recordsToLoad[i];record._applyValues(recordValues[i]);const commands=this._unknownRecordCommands[record.resId];if(commands){delete this._unknownRecordCommands[record.resId];this._applyCommands(commands);}}});}}
_applyInitialCommands(commands){this._applyCommands(commands);this._initialCommands=[...commands];this._initialCurrentIds=[...this._currentIds];}
async _createNewRecordDatapoint(params={}){const changes={};if(!params.withoutParent&&this.config.relationField){changes[this.config.relationField]=this._parent._getChanges();if(!this._parent.isNew){changes[this.config.relationField].id=this._parent.resId;}}
const values=await this.model._loadNewRecord({resModel:this.resModel,activeFields:params.activeFields||this.activeFields,fields:this.fields,context:Object.assign({},this.context,params.context),},{changes,evalContext:this.evalContext});if(this.canResequence()&&this.records.length){const position=params.position||"bottom";const order=this.orderBy[0];const asc=!order||order.asc;let value;if(position==="top"){const isOnFirstPage=this.offset===0;value=this.records[0].data[this.handleField];if(isOnFirstPage){if(asc){value=value>0?value-1:0;}else{value=value+1;}}}else if(position==="bottom"){value=this.records[this.records.length-1].data[this.handleField];const isOnLastPage=this.limit+this.offset>=this.count;if(isOnLastPage){if(asc){value=value+1;}else{value=value>0?value-1:0;}}}
values[this.handleField]=value;}
return this._createRecordDatapoint(values,{mode:params.mode||"edit",virtualId:getId("virtual"),activeFields:params.activeFields,manuallyAdded:params.manuallyAdded,});}
_createRecordDatapoint(data,params={}){const resId=data.id||false;if(!resId&&!params.virtualId){throw new Error("You must provide a virtualId if the record has no id");}
const id=resId||params.virtualId;const config={context:this.context,activeFields:Object.assign({},params.activeFields||this.activeFields),resModel:this.resModel,fields:params.fields||this.fields,relationField:this.config.relationField,resId,resIds:resId?[resId]:[],mode:params.mode||"readonly",isMonoRecord:true,currentCompanyId:this.currentCompanyId,};const{CREATE,UPDATE}=x2ManyCommands;const options={parentRecord:this._parent,onUpdate:async({withoutParentUpdate})=>{const id=record.isNew?record._virtualId:record.resId;if(!this.currentIds.includes(id)){return;}
const hasCommand=this._commands.some((c)=>(c[0]===CREATE||c[0]===UPDATE)&&c[1]===id);if(!hasCommand){this._commands.push([UPDATE,id]);}
if(record._noUpdateParent){return;}
if(!withoutParentUpdate){await this._onUpdate({withoutOnchange:!record._checkValidity({silent:true}),});}},virtualId:params.virtualId,manuallyAdded:params.manuallyAdded,};const record=new this.model.constructor.Record(this.model,config,data,options);this._cache[id]=record;if(!params.dontApplyCommands){const commands=this._unknownRecordCommands[id];if(commands){delete this._unknownRecordCommands[id];this._applyCommands(commands);}}
return record;}
_clearCommands(){this._commands=[];this._unknownRecordCommands={};}
_discard(){for(const id in this._cache){this._cache[id]._discard();}
if(this._savePoint){this._commands=this._savePoint._commands;this._currentIds=this._savePoint._currentIds;this.count=this._savePoint.count;}else{this._commands=[];this._currentIds=[...this.resIds];this.count=this.resIds.length;}
this._unknownRecordCommands={};const limit=this.limit-this._tmpIncreaseLimit;this._tmpIncreaseLimit=0;this.model._updateConfig(this.config,{limit},{reload:false});this.records=this._currentIds.slice(this.offset,this.limit).map((resId)=>this._cache[resId]);if(!this._savePoint){this._applyCommands(this._initialCommands);}
this._savePoint=undefined;}
_getCommands({withReadonly}={}){const{CREATE,UPDATE,LINK}=x2ManyCommands;const commands=[];for(const command of this._commands){if(command[0]===UPDATE&&command[1]in this._unknownRecordCommands){const uCommands=this._unknownRecordCommands[command[1]];for(const uCommand of uCommands){const values=fromUnityToServerValues(uCommand[2],this.fields,this.activeFields,{withReadonly,context:this.context});commands.push([uCommand[0],uCommand[1],values]);}}else if(command[0]===CREATE||command[0]===UPDATE){const record=this._cache[command[1]];if(command[0]===CREATE&&record.resId){commands.push([LINK,record.resId]);}else{const values=record._getChanges(record._changes,{withReadonly});if(command[0]===CREATE||Object.keys(values).length){commands.push([command[0],command[1],values]);}}}else{commands.push(command);}}
return commands;}
_getResIdsToLoad(resIds,fieldNames=this.fieldNames){return resIds.filter((resId)=>{if(typeof resId==="string"){return false;}
const record=this._cache[resId];if(!record){return true;}
fieldNames=fieldNames.filter((fieldName)=>fieldName!=="id");return intersection(fieldNames,record.fieldNames).length!==fieldNames.length;});}
async _load({limit=this.limit,offset=this.offset,orderBy=this.orderBy,nextCurrentIds=this._currentIds,}={}){const currentIds=nextCurrentIds.slice(offset,offset+limit);const resIds=this._getResIdsToLoad(currentIds);if(resIds.length){const records=await this.model._loadRecords({...this.config,resIds},this.evalContext);for(const record of records){this._createRecordDatapoint(record);}}
this.records=currentIds.map((id)=>this._cache[id]);this._currentIds=nextCurrentIds;await this.model._updateConfig(this.config,{limit,offset,orderBy},{reload:false});}
async _replaceWith(ids,{reload=false}={}){const resIds=reload?ids:ids.filter((id)=>!this._cache[id]);if(resIds.length){const records=await this.model._loadRecords({...this.config,resIds,context:this.context,});for(const record of records){this._createRecordDatapoint(record);}}
this.records=ids.map((id)=>this._cache[id]);const updateCommandsToKeep=this._commands.filter((c)=>c[0]===x2ManyCommands.UPDATE&&ids.includes(c[1]));this._commands=[x2ManyCommands.set(ids)].concat(updateCommandsToKeep);this._currentIds=[...ids];this.count=this._currentIds.length;if(this._currentIds.length>this.limit){this._tmpIncreaseLimit=this._currentIds.length-this.limit;const nextLimit=this.limit+this._tmpIncreaseLimit;this.model._updateConfig(this.config,{limit:nextLimit},{reload:false});}}
async _resequence(movedId,targetId){const records=[...this.records];const order=this.orderBy.find((o)=>o.name===this.handleField);const asc=!order||order.asc;const fromIndex=records.findIndex((r)=>r.id===movedId);let toIndex=0;if(targetId!==null){const targetIndex=records.findIndex((r)=>r.id===targetId);toIndex=fromIndex>targetIndex?targetIndex+1:targetIndex;}
const getSequence=(rec)=>rec&&rec.data[this.handleField];const firstIndex=Math.min(fromIndex,toIndex);const lastIndex=Math.max(fromIndex,toIndex)+1;let reorderAll=false;let lastSequence=(asc?-1:1)*Infinity;for(let index=0;index<records.length;index++){const sequence=getSequence(records[index]);if((asc&&lastSequence>=sequence)||(!asc&&lastSequence<=sequence)){reorderAll=true;break;}
lastSequence=sequence;}
const[record]=records.splice(fromIndex,1);records.splice(toIndex,0,record);let toReorder=records;if(!reorderAll){toReorder=toReorder.slice(firstIndex,lastIndex).filter((r)=>r.id!==movedId);if(fromIndex<toIndex){toReorder.push(record);}else{toReorder.unshift(record);}}
if(!asc){toReorder.reverse();}
const sequences=toReorder.map(getSequence);const offset=sequences.length&&Math.min(...sequences);const proms=[];for(const[i,record]of Object.entries(toReorder)){proms.push(record._update({[this.handleField]:offset+Number(i)},{withoutParentUpdate:true}));}
await Promise.all(proms);await this._sort();await this._onUpdate();}
async _sort(currentIds=this.currentIds,orderBy=this.orderBy){const fieldNames=orderBy.map((o)=>o.name);const resIds=this._getResIdsToLoad(currentIds,fieldNames);if(resIds.length){const activeFields=pick(this.activeFields,...fieldNames);const config={...this.config,resIds,activeFields};const records=await this.model._loadRecords(config);for(const record of records){this._createRecordDatapoint(record,{activeFields});}}
const allRecords=currentIds.map((id)=>this._cache[id]);const sortedRecords=allRecords.sort((r1,r2)=>{return compareRecords(r1,r2,orderBy,this.fields);});await this._load({orderBy,nextCurrentIds:sortedRecords.map((r)=>r.resId||r._virtualId),});this._needsReordering=false;}
async _sortBy(fieldName){let orderBy=[...this.orderBy];if(fieldName){if(orderBy.length&&orderBy[0].name===fieldName){if(!this._needsReordering){orderBy[0]={name:orderBy[0].name,asc:!orderBy[0].asc};}}else{orderBy=orderBy.filter((o)=>o.name!==fieldName);orderBy.unshift({name:fieldName,asc:true,});}}
return this._sort(this._currentIds,orderBy);}
_updateContext(context){Object.assign(this.context,context);for(const record of Object.values(this._cache)){record._setEvalContext();}}}
return __exports;});;

/* /web/static/src/model/relational_model/utils.js */
odoo.define('@web/model/relational_model/utils',['@odoo/owl','@web/core/context','@web/core/domain','@web/core/l10n/dates','@web/core/orm_service','@web/core/py_js/py','@web/core/utils/concurrency','@web/core/utils/objects','@web/core/utils/reactive','@web/core/utils/timing','@web/search/utils/order_by','@web/core/network/rpc'],function(require){'use strict';let __exports={};const{markup,onWillDestroy,onWillStart,onWillUpdateProps,useComponent}=require("@odoo/owl");const{evalPartialContext,makeContext}=require("@web/core/context");const{Domain}=require("@web/core/domain");const{deserializeDate,deserializeDateTime,serializeDate,serializeDateTime,}=require("@web/core/l10n/dates");const{x2ManyCommands}=require("@web/core/orm_service");const{evaluateExpr}=require("@web/core/py_js/py");const{Deferred}=require("@web/core/utils/concurrency");const{omit}=require("@web/core/utils/objects");const{effect}=require("@web/core/utils/reactive");const{batched}=require("@web/core/utils/timing");const{orderByToString}=require("@web/search/utils/order_by");const{rpc}=require("@web/core/network/rpc");function convertBoolToPyExpr(value){if(value===true||value===false){return value?"True":"False";}
return value;}
__exports.makeActiveField=makeActiveField;function makeActiveField({context,invisible,readonly,required,onChange,forceSave,isHandle,}={}){return{context:context||"{}",invisible:convertBoolToPyExpr(invisible||false),readonly:convertBoolToPyExpr(readonly||false),required:convertBoolToPyExpr(required||false),onChange:onChange||false,forceSave:forceSave||false,isHandle:isHandle||false,};}
const AGGREGATABLE_FIELD_TYPES=["float","integer","monetary"];__exports.addFieldDependencies=addFieldDependencies;function addFieldDependencies(activeFields,fields,fieldDependencies=[]){for(const field of fieldDependencies){if(!("readonly"in field)){field.readonly=true;}
if(field.name in activeFields){patchActiveFields(activeFields[field.name],makeActiveField(field));}else{activeFields[field.name]=makeActiveField(field);}
if(!fields[field.name]){const newField=omit(field,["context","invisible","required","readonly","onChange",]);fields[field.name]=newField;if(newField.type==="selection"&&!Array.isArray(newField.selection)){newField.selection=[];}}}}
function completeActiveField(activeField,extra){if(extra.related){for(const fieldName in extra.related.activeFields){if(fieldName in activeField.related.activeFields){completeActiveField(activeField.related.activeFields[fieldName],extra.related.activeFields[fieldName]);}else{activeField.related.activeFields[fieldName]={...extra.related.activeFields[fieldName],};}}
Object.assign(activeField.related.fields,extra.related.fields);}}
__exports.completeActiveFields=completeActiveFields;function completeActiveFields(activeFields,extraActiveFields){for(const fieldName in extraActiveFields){const extraActiveField={...extraActiveFields[fieldName],invisible:"True",};if(fieldName in activeFields){completeActiveField(activeFields[fieldName],extraActiveField);}else{activeFields[fieldName]=extraActiveField;}}}
__exports.createPropertyActiveField=createPropertyActiveField;function createPropertyActiveField(property){const{type}=property;const activeField=makeActiveField();if(type==="one2many"||type==="many2many"){activeField.related={fields:{id:{name:"id",type:"integer"},display_name:{name:"display_name",type:"char"},},activeFields:{id:makeActiveField({readonly:true}),display_name:makeActiveField(),},};}
return activeField;}
__exports.combineModifiers=combineModifiers;function combineModifiers(mod1,mod2,operator){if(operator==="AND"){if(!mod1||mod1==="False"||!mod2||mod2==="False"){return"False";}
if(mod1==="True"){return mod2;}
if(mod2==="True"){return mod1;}
return"("+mod1+") and ("+mod2+")";}else if(operator==="OR"){if(mod1==="True"||mod2==="True"){return"True";}
if(!mod1||mod1==="False"){return mod2;}
if(!mod2||mod2==="False"){return mod1;}
return"("+mod1+") or ("+mod2+")";}
throw new Error(`Operator provided to "combineModifiers" must be "AND" or "OR", received ${operator}`);}
__exports.patchActiveFields=patchActiveFields;function patchActiveFields(activeField,patch){activeField.invisible=combineModifiers(activeField.invisible,patch.invisible,"AND");activeField.readonly=combineModifiers(activeField.readonly,patch.readonly,"AND");activeField.required=combineModifiers(activeField.required,patch.required,"OR");activeField.onChange=activeField.onChange||patch.onChange;activeField.forceSave=activeField.forceSave||patch.forceSave;activeField.isHandle=activeField.isHandle||patch.isHandle;if(patch.related){const related=activeField.related;for(const fieldName in patch.related.activeFields){if(fieldName in related.activeFields){patchActiveFields(related.activeFields[fieldName],patch.related.activeFields[fieldName]);}else{related.activeFields[fieldName]={...patch.related.activeFields[fieldName]};}}
Object.assign(related.fields,patch.related.fields);}
if("limit"in patch){activeField.limit=patch.limit;}
if(patch.defaultOrderBy){activeField.defaultOrderBy=patch.defaultOrderBy;}}
__exports.extractFieldsFromArchInfo=extractFieldsFromArchInfo;function extractFieldsFromArchInfo({fieldNodes,widgetNodes},fields){const activeFields={};for(const fieldNode of Object.values(fieldNodes)){const fieldName=fieldNode.name;const activeField=makeActiveField({context:fieldNode.context,invisible:combineModifiers(fieldNode.invisible,fieldNode.column_invisible,"OR"),readonly:fieldNode.readonly,required:fieldNode.required,onChange:fieldNode.onChange,forceSave:fieldNode.forceSave,isHandle:fieldNode.isHandle,});if(["one2many","many2many"].includes(fields[fieldName].type)){activeField.related={activeFields:{},fields:{},};if(fieldNode.views){const viewDescr=fieldNode.views[fieldNode.viewMode];if(viewDescr){activeField.related=extractFieldsFromArchInfo(viewDescr,viewDescr.fields);activeField.limit=viewDescr.limit;activeField.defaultOrderBy=viewDescr.defaultOrder;if(fieldNode.views.form){const formArchInfo=extractFieldsFromArchInfo(fieldNode.views.form,fieldNode.views.form.fields);completeActiveFields(activeField.related.activeFields,formArchInfo.activeFields);Object.assign(activeField.related.fields,formArchInfo.fields);}
if(fieldNode.viewMode!=="default"&&fieldNode.views.default){const defaultArchInfo=extractFieldsFromArchInfo(fieldNode.views.default,fieldNode.views.default.fields);for(const fieldName in defaultArchInfo.activeFields){if(fieldName in activeField.related.activeFields){patchActiveFields(activeField.related.activeFields[fieldName],defaultArchInfo.activeFields[fieldName]);}else{activeField.related.activeFields[fieldName]={...defaultArchInfo.activeFields[fieldName],};}}
activeField.related.fields=Object.assign({},defaultArchInfo.fields,activeField.related.fields);}}}
if(fieldNode.field?.useSubView){activeField.required="False";}}
if(fields[fieldName].type==="many2one_reference"&&fieldNode.views){const viewDescr=fieldNode.views.default;activeField.related=extractFieldsFromArchInfo(viewDescr,viewDescr.fields);}
if(fieldName in activeFields){patchActiveFields(activeFields[fieldName],activeField);}else{activeFields[fieldName]=activeField;}
if(fieldNode.field){let fieldDependencies=fieldNode.field.fieldDependencies;if(typeof fieldDependencies==="function"){fieldDependencies=fieldDependencies(fieldNode);}
addFieldDependencies(activeFields,fields,fieldDependencies);}}
for(const widgetInfo of Object.values(widgetNodes||{})){let fieldDependencies=widgetInfo.widget.fieldDependencies;if(typeof fieldDependencies==="function"){fieldDependencies=fieldDependencies(widgetInfo);}
addFieldDependencies(activeFields,fields,fieldDependencies);}
return{activeFields,fields};}
__exports.getFieldContext=getFieldContext;function getFieldContext(record,fieldName,rawContext=record.activeFields[fieldName].context){const context={};for(const key in record.context){if(!key.startsWith("default_")&&!key.startsWith("search_default_")&&!key.endsWith("_view_ref")){context[key]=record.context[key];}}
return{...context,...record.fields[fieldName].context,...makeContext([rawContext],record.evalContext),};}
__exports.getFieldDomain=getFieldDomain;function getFieldDomain(record,fieldName,domain){if(typeof domain==="function"){domain=domain();domain=typeof domain==="function"?domain():domain;}
if(domain){return domain;}
domain=record.fields[fieldName].domain;return typeof domain==="string"?new Domain(evaluateExpr(domain,record.evalContext)).toList():domain||[];}
__exports.getBasicEvalContext=getBasicEvalContext;function getBasicEvalContext(config){const{uid,allowed_company_ids}=config.context;return{context:config.context,uid,allowed_company_ids,current_company_id:config.currentCompanyId,};}
function getFieldContextForSpec(activeFields,fields,fieldName,evalContext){let context=activeFields[fieldName].context;if(!context||context==="{}"){context=fields[fieldName].context||{};}else{context=evalPartialContext(context,evalContext);}
if(Object.keys(context).length>0){return context;}}
__exports.getFieldsSpec=getFieldsSpec;function getFieldsSpec(activeFields,fields,evalContext,{withInvisible}={}){const fieldsSpec={};const properties=[];for(const fieldName in activeFields){if(fields[fieldName].relatedPropertyField){continue;}
const{related,limit,defaultOrderBy,invisible}=activeFields[fieldName];const isAlwaysInvisible=invisible==="True"||invisible==="1";fieldsSpec[fieldName]={};switch(fields[fieldName].type){case"one2many":case"many2many":{if(related&&(withInvisible||!isAlwaysInvisible)){fieldsSpec[fieldName].fields=getFieldsSpec(related.activeFields,related.fields,evalContext,{withInvisible});fieldsSpec[fieldName].context=getFieldContextForSpec(activeFields,fields,fieldName,evalContext);fieldsSpec[fieldName].limit=limit;if(defaultOrderBy){fieldsSpec[fieldName].order=orderByToString(defaultOrderBy);}}
break;}
case"many2one":case"reference":{fieldsSpec[fieldName].fields={};if(!isAlwaysInvisible){fieldsSpec[fieldName].fields.display_name={};fieldsSpec[fieldName].context=getFieldContextForSpec(activeFields,fields,fieldName,evalContext);}
break;}
case"many2one_reference":{if(related&&!isAlwaysInvisible){fieldsSpec[fieldName].fields=getFieldsSpec(related.activeFields,related.fields,evalContext);fieldsSpec[fieldName].context=getFieldContextForSpec(activeFields,fields,fieldName,evalContext);}
break;}
case"properties":{properties.push(fieldName);break;}}}
for(const fieldName of properties){const fieldSpec=fieldsSpec[fields[fieldName].definition_record];if(fieldSpec){if(!fieldSpec.fields){fieldSpec.fields={};}
fieldSpec.fields.display_name={};}}
return fieldsSpec;}
let nextId=0;__exports.getId=getId;function getId(prefix=""){return`${prefix}_${++nextId}`;}
__exports.parseServerValue=parseServerValue;function parseServerValue(field,value){switch(field.type){case"char":case"text":{return value||"";}
case"html":{return markup(value||"");}
case"date":{return value?deserializeDate(value):false;}
case"datetime":{return value?deserializeDateTime(value):false;}
case"selection":{if(value===false){const hasKey0=field.selection.find((option)=>option[0]===0);return hasKey0?0:value;}
return value;}
case"reference":{if(value===false){return false;}
return{resId:value.id.id,resModel:value.id.model,displayName:value.display_name,};}
case"many2one_reference":{if(value===0){return false;}
if(typeof value==="number"){return{resId:value};}
return{resId:value.id,displayName:value.display_name,};}
case"many2one":{if(Array.isArray(value)){return value;}
return value?[value.id,value.display_name]:false;}
case"properties":{return value?value.map((property)=>({...property,value:parseServerValue(property,property.value??false),})):[];}}
return value;}
__exports.extractInfoFromGroupData=extractInfoFromGroupData;function extractInfoFromGroupData(groupData,groupBy,fields){const info={};const groupByField=fields[groupBy[0].split(":")[0]];info.count=groupData.__count||groupData[`${groupByField.name}_count`];info.length=info.count;info.range=groupData.__range?groupData.__range[groupBy[0]]:null;info.domain=groupData.__domain;info.rawValue=groupData[groupBy[0]];info.value=getValueFromGroupData(groupByField,info.rawValue,info.range);info.displayName=getDisplayNameFromGroupData(groupByField,info.rawValue);info.serverValue=getGroupServerValue(groupByField,info.value);info.aggregates=getAggregatesFromGroupData(groupData,fields);return info;}
function getAggregatesFromGroupData(groupData,fields){const aggregates={};for(const[key,value]of Object.entries(groupData)){if(key in fields&&AGGREGATABLE_FIELD_TYPES.includes(fields[key].type)){aggregates[key]=value;}}
return aggregates;}
function getDisplayNameFromGroupData(field,rawValue){if(field.type==="selection"){return Object.fromEntries(field.selection)[rawValue];}
if(["many2one","many2many","tags"].includes(field.type)){return rawValue?rawValue[1]:false;}
return rawValue;}
__exports.getGroupServerValue=getGroupServerValue;function getGroupServerValue(field,value){switch(field.type){case"many2many":{return value?[value]:false;}
case"datetime":{return value?serializeDateTime(value):false;}
case"date":{return value?serializeDate(value):false;}
default:{return value||false;}}}
function getValueFromGroupData(field,rawValue,range){if(["date","datetime"].includes(field.type)){if(!range){return false;}
const dateValue=parseServerValue(field,range.to);return dateValue.minus({[field.type==="date"?"day":"second"]:1,});}
const value=parseServerValue(field,rawValue);if(["many2one","many2many"].includes(field.type)){return value?value[0]:false;}
return value;}
__exports.fromUnityToServerValues=fromUnityToServerValues;function fromUnityToServerValues(values,fields,activeFields,{withReadonly,context}={}){const{CREATE,UPDATE}=x2ManyCommands;const serverValues={};for(const fieldName in values){let value=values[fieldName];const field=fields[fieldName];const activeField=activeFields[fieldName];if(!withReadonly){if(field.readonly){continue;}
try{if(evaluateExpr(activeField.readonly,context)){continue;}}catch{}}
switch(fields[fieldName].type){case"one2many":case"many2many":value=value.map((c)=>{if(c[0]===CREATE||c[0]===UPDATE){const _fields=activeField.related.fields;const _activeFields=activeField.related.activeFields;return[c[0],c[1],fromUnityToServerValues(c[2],_fields,_activeFields,{withReadonly}),];}
return[c[0],c[1]];});break;case"many2one":value=value?value.id:false;break;}
serverValues[fieldName]=value;}
return serverValues;}
__exports.isRelational=isRelational;function isRelational(field){return field&&["one2many","many2many","many2one"].includes(field.type);}
__exports.useRecordObserver=useRecordObserver;function useRecordObserver(callback){const component=useComponent();let alive=true;let props=component.props;const fct=()=>{const def=new Deferred();let firstCall=true;effect((record)=>{if(firstCall){firstCall=false;return Promise.resolve(callback(record,props)).then(def.resolve).catch(def.reject);}else{return batched((record)=>{if(!alive){return;}
return Promise.resolve(callback(record,props)).then(def.resolve).catch(def.reject);},()=>new Promise((resolve)=>window.requestAnimationFrame(resolve)))(record);}},[props.record]);return def;};onWillDestroy(()=>{alive=false;});onWillStart(()=>fct());onWillUpdateProps((nextProps)=>{const currentRecordId=props.record.id;props=nextProps;if(props.record.id!==currentRecordId){return fct();}});}
__exports.resequence=resequence;async function resequence({records,resModel,orm,fieldName,movedId,targetId,asc=true,getSequence=(record)=>record[fieldName],getResId=(record)=>record.id,context,}){const fromIndex=records.findIndex((d)=>d.id===movedId);let toIndex=0;if(targetId!==null){const targetIndex=records.findIndex((d)=>d.id===targetId);toIndex=fromIndex>targetIndex?targetIndex+1:targetIndex;}
const firstIndex=Math.min(fromIndex,toIndex);const lastIndex=Math.max(fromIndex,toIndex)+1;let reorderAll=records.some((record)=>getSequence(record)===undefined);if(!reorderAll){let lastSequence=(asc?-1:1)*Infinity;for(let index=0;index<records.length;index++){const sequence=getSequence(records[index]);if((asc&&lastSequence>=sequence)||(!asc&&lastSequence<=sequence)){reorderAll=true;break;}
lastSequence=sequence;}}
const originalOrder=[...records];const record=records[fromIndex];if(fromIndex!==toIndex){records.splice(fromIndex,1);records.splice(toIndex,0,record);}
let toReorder=records;if(!reorderAll){toReorder=toReorder.slice(firstIndex,lastIndex).filter((r)=>r.id!==movedId);if(fromIndex<toIndex){toReorder.push(record);}else{toReorder.unshift(record);}}
if(!asc){toReorder.reverse();}
const resIds=toReorder.map((d)=>getResId(d)).filter((id)=>id&&!isNaN(id));const sequences=toReorder.map(getSequence);const offset=sequences.length&&Math.min(...sequences);const params={model:resModel,ids:resIds,context:context,field:fieldName,};if(offset){params.offset=offset;}
try{const wasResequenced=await rpc("/web/dataset/resequence",params);if(!wasResequenced){return;}}catch(error){records.splice(0,records.length,...originalOrder);throw error;}
const kwargs={context};return orm.read(resModel,resIds,[fieldName],kwargs);}
return __exports;});;

/* /web/static/src/model/sample_server.js */
odoo.define('@web/model/sample_server',['@web/core/l10n/dates','@web/core/orm_service','@web/core/registry','@web/core/utils/arrays','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{deserializeDate,deserializeDateTime,parseDate,serializeDate,serializeDateTime,}=require("@web/core/l10n/dates");const{ORM}=require("@web/core/orm_service");const{registry}=require("@web/core/registry");const{cartesian,sortBy:arraySortBy}=require("@web/core/utils/arrays");const{parseServerValue}=require("@web/model/relational_model/utils");class UnimplementedRouteError extends Error{}
let searchReadNumber=0;function getSampleFromId(id,sampleTexts){return sampleTexts[(id-1)%sampleTexts.length];}
function serializeGroupDateValue(range,field){if(!range){return false;}
let dateValue=parseServerValue(field,range.to);dateValue=dateValue.minus({[field.type==="date"?"day":"second"]:1,});return field.type==="date"?serializeDate(dateValue):serializeDateTime(dateValue);}
function fieldNameRegex(...terms){return new RegExp(`\\b((\\w+)?_)?(${terms.join("|")})(_(\\w+)?)?\\b`);}
const MEASURE_SPEC_REGEX=/(?<measure>\w+):(?<aggregateFunction>\w+)(\((?<fieldName>\w+)\))?/;const DESCRIPTION_REGEX=fieldNameRegex("description","label","title","subject","message");const EMAIL_REGEX=fieldNameRegex("email");const PHONE_REGEX=fieldNameRegex("phone");const URL_REGEX=fieldNameRegex("url");const SampleServer=__exports.SampleServer=class SampleServer{constructor(modelName,fields){this.mainModel=modelName;this.data={};this.data[modelName]={fields,records:[],};for(const fieldName in fields){const field=fields[fieldName];if(["many2one","one2many","many2many"].includes(field.type)){this.data[field.relation]=this.data[field.relation]||{fields:{display_name:{type:"char"},id:{type:"integer"},color:{type:"integer"},},records:[],};}}
this.existingGroups=null;this.populated=false;this.existingGroupsPopulated=false;}
mockRpc(params){if(!(params.model in this.data)){throw new Error(`SampleServer: unknown model ${params.model}`);}
this._populateModels();switch(params.method||params.route){case"web_search_read":return this._mockWebSearchReadUnity(params);case"web_read_group":return this._mockWebReadGroup(params);case"read_group":return this._mockReadGroup(params);case"read_progress_bar":return this._mockReadProgressBar(params);case"read":return this._mockRead(params);}
const method=params.method||params.route;const mockFunction=registry.category("sample_server").get(`${params.model}/${method}`,null)||registry.category("sample_server").get(method,null);if(mockFunction){return mockFunction.call(this,params);}
console.log(`SampleServer: unimplemented route "${params.method || params.route}"`);throw new SampleServer.UnimplementedRouteError();}
setExistingGroups(groups){this.existingGroups=groups;}
_aggregateFields(measures,records){const values={};for(const{fieldName,type,aggregateFunction}of measures){if(["float","integer","monetary"].includes(type)){if(aggregateFunction==="array_agg"){values[fieldName]=(records||[]).map((r)=>r[fieldName]);}else if(records.length){let value=0;for(const record of records){value+=record[fieldName];}
values[fieldName]=this._sanitizeNumber(value);}else{values[fieldName]=null;}}
if(type==="many2one"){const ids=new Set(records.map((r)=>r[fieldName]));values.fieldName=ids.size||null;}}
return values;}
_formatValue(value,options){if(!value){return false;}
const{type,interval,relation}=options;if(["date","datetime"].includes(type)){const fmt=SampleServer.FORMATS[interval];return parseDate(value).toFormat(fmt);}else if(["many2one","many2many"].includes(type)){const rec=this.data[relation].records.find(({id})=>id===value);return[value,rec.display_name];}else{return value;}}
_generateFieldValue(modelName,fieldName,id){const field=this.data[modelName].fields[fieldName];switch(field.type){case"boolean":return fieldName==="active"?true:this._getRandomBool();case"char":case"text":if(["display_name","name"].includes(fieldName)){if(SampleServer.PEOPLE_MODELS.includes(modelName)){return getSampleFromId(id,SampleServer.SAMPLE_PEOPLE);}else if(modelName==="res.country"){return getSampleFromId(id,SampleServer.SAMPLE_COUNTRIES);}}
if(fieldName==="display_name"){return getSampleFromId(id,SampleServer.SAMPLE_TEXTS);}else if(["name","reference"].includes(fieldName)){return`REF${String(id).padStart(4, "0")}`;}else if(DESCRIPTION_REGEX.test(fieldName)){return getSampleFromId(id,SampleServer.SAMPLE_TEXTS);}else if(EMAIL_REGEX.test(fieldName)){const emailName=getSampleFromId(id,SampleServer.SAMPLE_PEOPLE).replace(/ /,".").toLowerCase();return`${emailName}@sample.demo`;}else if(PHONE_REGEX.test(fieldName)){return`+1 555 754 ${String(id).padStart(4, "0")}`;}else if(URL_REGEX.test(fieldName)){return`http://sample${id}.com`;}
return false;case"date":case"datetime":{const datetime=this._getRandomDate();return field.type==="date"?serializeDate(datetime):serializeDateTime(datetime);}
case"float":return this._getRandomFloat(SampleServer.MAX_FLOAT);case"integer":{let max=SampleServer.MAX_INTEGER;if(fieldName.includes("color")){max=this._getRandomBool()?SampleServer.MAX_COLOR_INT:0;}
return this._getRandomInt(max);}
case"monetary":return this._getRandomInt(SampleServer.MAX_MONETARY);case"many2one":if(field.relation==="res.currency"){return 1;}
if(field.relation==="ir.attachment"){return false;}
return this._getRandomSubRecordId();case"one2many":case"many2many":{const ids=[this._getRandomSubRecordId(),this._getRandomSubRecordId()];return[...new Set(ids)];}
case"selection":{return this._getRandomSelectionValue(modelName,field);}
default:return false;}}
_getRandomArrayEl(array){return array[Math.floor(Math.random()*array.length)];}
_getRandomBool(){return Math.random()<0.5;}
_getRandomDate(){const delta=Math.floor((Math.random()-Math.random())*SampleServer.DATE_DELTA);return luxon.DateTime.local().plus({hours:delta});}
_getRandomFloat(max){return this._sanitizeNumber(Math.random()*max);}
_getRandomInt(max){return Math.floor(Math.random()*max);}
_getRandomSelectionValue(modelName,field){if(field.selection.length>0){return this._getRandomArrayEl(field.selection)[0];}
return false;}
_getRandomSubRecordId(){return Math.floor(Math.random()*SampleServer.SUB_RECORDSET_SIZE)+1;}
_mockRead(params){const model=this.data[params.model];const ids=params.args[0];const fieldNames=params.args[1];const records=[];for(const r of model.records){if(!ids.includes(r.id)){continue;}
const record={id:r.id};for(const fieldName of fieldNames){const field=model.fields[fieldName];if(!field){record[fieldName]=false;}else if(field.type==="many2one"){const relModel=this.data[field.relation];const relRecord=relModel.records.find((relR)=>r[fieldName]===relR.id);record[fieldName]=relRecord?[relRecord.id,relRecord.display_name]:false;}else{record[fieldName]=r[fieldName];}}
records.push(record);}
return records;}
_mockReadGroup(params){const lazy="lazy"in params?params.lazy:true;const model=params.model;const fields=this.data[model].fields;const records=this.data[model].records;const normalizedGroupBys=[];let groupBy=[];if(params.groupBy.length){groupBy=lazy?[params.groupBy[0]]:params.groupBy;}
for(const groupBySpec of groupBy){let[fieldName,interval]=groupBySpec.split(":");interval=interval||"month";const{type,relation}=fields[fieldName];if(type){const gb={fieldName,type,interval,relation,alias:groupBySpec};normalizedGroupBys.push(gb);}}
const groupsFromRecord=(record)=>{const values=[];for(const gb of normalizedGroupBys){const{fieldName,type}=gb;let fieldVals;if(["date","datetime"].includes(type)){fieldVals=[this._formatValue(record[fieldName],gb)];}else if(type==="many2many"){fieldVals=record[fieldName].length?record[fieldName]:[false];}else{fieldVals=[record[fieldName]];}
values.push(fieldVals.map((val)=>({[fieldName]:val})));}
const cart=cartesian(...values);return cart.map((tuple)=>{if(!Array.isArray(tuple)){tuple=[tuple];}
return Object.assign({},...tuple);});};const groups={};for(const record of records){const recordGroups=groupsFromRecord(record);for(const group of recordGroups){const groupId=JSON.stringify(group);if(!(groupId in groups)){groups[groupId]=[];}
groups[groupId].push(record);}}
const measures=[];for(const measureSpec of params.fields||Object.keys(fields)){const matches=measureSpec.match(MEASURE_SPEC_REGEX);let{fieldName,aggregateFunction,measure}=(matches&&matches.groups)||{};if(!aggregateFunction&&fieldName in fields&&fields[fieldName].aggregator){aggregateFunction=fields[fieldName].aggregator;measure=fieldName;}
if(!fieldName&&!measure){continue;}
const fName=fieldName||measure;const{type}=fields[fName];if(!params.groupBy.includes(fName)&&type&&(type!=="many2one"||aggregateFunction!=="count_distinct")){measures.push({fieldName:fName,type,aggregateFunction});}}
let result=[];for(const id in groups){const records=groups[id];const group={__domain:[]};let countKey=`__count`;if(normalizedGroupBys.length&&lazy){countKey=`${normalizedGroupBys[0].fieldName}_count`;}
group[countKey]=records.length;const firstElem=records[0];const parsedId=JSON.parse(id);for(const gb of normalizedGroupBys){const{alias,fieldName,type}=gb;if(type==="many2many"){group[alias]=this._formatValue(parsedId[fieldName],gb);}else{group[alias]=this._formatValue(firstElem[fieldName],gb);if(["date","datetime"].includes(type)){group.__range={};const val=firstElem[fieldName];if(val){const deserialize=type==="date"?deserializeDate:deserializeDateTime;const serialize=type==="date"?serializeDate:serializeDateTime;const from=deserialize(val).startOf(gb.interval);const to=SampleServer.INTERVALS[gb.interval](from);group.__range[alias]={from:serialize(from),to:serialize(to)};}else{group.__range[alias]=false;}}}}
Object.assign(group,this._aggregateFields(measures,records));result.push(group);}
if(normalizedGroupBys.length>0){const{alias,interval,type}=normalizedGroupBys[0];result=arraySortBy(result,(group)=>{const val=group[alias];if(["date","datetime"].includes(type)){return parseDate(val,{format:SampleServer.FORMATS[interval]});}
return val;});}
return result;}
_mockReadProgressBar(params){const groupBy=params.group_by.split(":")[0];const progress_bar=params.progress_bar;const groupByField=this.data[params.model].fields[groupBy];const data={};for(const record of this.data[params.model].records){let groupByValue=record[groupBy];if(groupByField.type==="many2one"){const relatedRecords=this.data[groupByField.relation].records;const relatedRecord=relatedRecords.find((r)=>r.id===groupByValue);groupByValue=relatedRecord.display_name;}
if(!(groupByValue in data)){if(groupByValue===true){groupByValue="True";}else if(groupByValue===false){groupByValue="False";}}
if(!(groupByValue in data)){data[groupByValue]={};for(const key in progress_bar.colors){data[groupByValue][key]=0;}}
const fieldValue=record[progress_bar.field];if(fieldValue in data[groupByValue]){data[groupByValue][fieldValue]++;}}
return data;}
_mockWebSearchReadUnity(params){const fields=Object.keys(params.specification);let result;if(this.existingGroups){const groups=this.existingGroups;const group=groups[searchReadNumber++%groups.length];result={records:this._mockRead({model:params.model,args:[group.__recordIds,fields],}),length:group.__recordIds.length,};}else{const model=this.data[params.model];const rawRecords=model.records.slice(0,SampleServer.SEARCH_READ_LIMIT);const records=this._mockRead({model:params.model,args:[rawRecords.map((r)=>r.id),fields],});result={records,length:records.length};}
for(const fieldName in params.specification){const field=this.data[params.model].fields[fieldName];if(field.type==="many2one"){for(const record of result.records){record[fieldName]=record[fieldName]?{id:record[fieldName][0],display_name:record[fieldName][1],}:false;}}
if(field.type==="one2many"||field.type==="many2many"){const relFields=Object.keys(params.specification[fieldName].fields||{});if(relFields.length){const relIds=result.records.map((r)=>r[fieldName]).flat();const relRecords={};const _relRecords=this._mockRead({model:field.relation,args:[relIds,relFields],});for(const relRecord of _relRecords){relRecords[relRecord.id]=relRecord;}
for(const record of result.records){record[fieldName]=record[fieldName].map((resId)=>relRecords[resId]);}}}}
return result;}
_mockWebReadGroup(params){let groups;if(this.existingGroups){this._tweakExistingGroups(params);groups=this.existingGroups;}else{groups=this._mockReadGroup(params);}
return{groups,length:groups.length,};}
_populateExistingGroups(params){const groups=this.existingGroups;const groupBy=params.groupBy[0].split(":")[0];const groupByField=this.data[params.model].fields[groupBy];const groupedByM2O=groupByField.type==="many2one";if(groupedByM2O){this.data[groupByField.relation].records=groups.map((g)=>{return{id:g[groupBy][0],display_name:g[groupBy][1]};});}
for(const r of this.data[params.model].records){const group=getSampleFromId(r.id,groups);if(["date","datetime"].includes(groupByField.type)){r[groupBy]=serializeGroupDateValue(group.__range[params.groupBy[0]],groupByField);}else if(groupByField.type==="many2one"){r[groupBy]=group[params.groupBy[0]]?group[params.groupBy[0]][0]:false;}else{r[groupBy]=group[params.groupBy[0]];}}}
_populateModels(){if(!this.populated){for(const modelName in this.data){const model=this.data[modelName];const fieldNames=Object.keys(model.fields).filter((f)=>f!=="id");const size=modelName===this.mainModel?SampleServer.MAIN_RECORDSET_SIZE:SampleServer.SUB_RECORDSET_SIZE;for(let id=1;id<=size;id++){const record={id};for(const fieldName of fieldNames){record[fieldName]=this._generateFieldValue(modelName,fieldName,id);}
model.records.push(record);}}
this.populated=true;}}
_sanitizeNumber(value){return parseFloat(value.toFixed(SampleServer.FLOAT_PRECISION));}
_tweakExistingGroups(params){const groups=this.existingGroups;this._populateExistingGroups(params);const fullGroupBy=params.groupBy[0];const groupBy=fullGroupBy.split(":")[0];const groupByField=this.data[params.model].fields[groupBy];const records=this.data[params.model].records;const fields=params.fields.map((aggregate_spec)=>aggregate_spec.split(":")[0])
for(const g of groups){const recordsInGroup=records.filter((r)=>{if(["date","datetime"].includes(groupByField.type)){return(r[groupBy]===serializeGroupDateValue(g.__range[fullGroupBy],groupByField));}else if(groupByField.type==="many2one"){return(!r[groupBy]&&!g[fullGroupBy])||r[groupBy]===g[fullGroupBy][0];}
return r[groupBy]===g[fullGroupBy];});for(const field of fields){const fieldType=this.data[params.model].fields[field].type;if(["integer, float","monetary"].includes(fieldType)){g[field]=recordsInGroup.reduce((acc,r)=>acc+r[field],0);}}
g[`${groupBy}_count`]=recordsInGroup.length;g.__recordIds=recordsInGroup.map((r)=>r.id);}}}
SampleServer.FORMATS={day:"yyyy-MM-dd",week:"'W'WW kkkk",month:"MMMM yyyy",quarter:"'Q'q yyyy",year:"y",};SampleServer.INTERVALS={day:(dt)=>dt.plus({days:1}),week:(dt)=>dt.plus({weeks:1}),month:(dt)=>dt.plus({months:1}),quarter:(dt)=>dt.plus({months:3}),year:(dt)=>dt.plus({years:1}),};SampleServer.DISPLAY_FORMATS=Object.assign({},SampleServer.FORMATS,{day:"dd MMM yyyy"});SampleServer.MAIN_RECORDSET_SIZE=16;SampleServer.SUB_RECORDSET_SIZE=5;SampleServer.SEARCH_READ_LIMIT=10;SampleServer.MAX_FLOAT=100;SampleServer.MAX_INTEGER=50;SampleServer.MAX_COLOR_INT=7;SampleServer.MAX_MONETARY=100000;SampleServer.DATE_DELTA=24*60;SampleServer.FLOAT_PRECISION=2;SampleServer.SAMPLE_COUNTRIES=["Belgium","France","Portugal","Singapore","Australia"];SampleServer.SAMPLE_PEOPLE=["John Miller","Henry Campbell","Carrie Helle","Wendi Baltz","Thomas Passot",];SampleServer.SAMPLE_TEXTS=["Laoreet id","Volutpat blandit","Integer vitae","Viverra nam","In massa",];SampleServer.PEOPLE_MODELS=["res.users","res.partner","hr.employee","mail.followers","mailing.contact",];SampleServer.UnimplementedRouteError=UnimplementedRouteError;__exports.buildSampleORM=buildSampleORM;function buildSampleORM(resModel,fields,user){const sampleServer=new SampleServer(resModel,fields);const fakeRPC=async(_,params)=>{const{args,kwargs,method,model}=params;const{groupby:groupBy}=kwargs;return sampleServer.mockRpc({method,model,args,...kwargs,groupBy});};const sampleORM=new ORM(user);sampleORM.rpc=fakeRPC;sampleORM.isSample=true;sampleORM.setGroups=(groups)=>sampleServer.setExistingGroups(groups);return sampleORM;}
return __exports;});;

/* /web/static/src/search/action_hook.js */
odoo.define('@web/search/action_hook',['@odoo/owl'],function(require){'use strict';let __exports={};const{onMounted,useComponent,useEffect,useExternalListener}=require("@odoo/owl");const scrollSymbol=__exports.scrollSymbol=Symbol("scroll");const CallbackRecorder=__exports.CallbackRecorder=class CallbackRecorder{constructor(){this.setup();}
setup(){this._callbacks=[];}
get callbacks(){return this._callbacks.map(({callback})=>callback);}
add(owner,callback){if(!callback){throw new Error("Missing callback");}
this._callbacks.push({owner,callback});}
remove(owner){this._callbacks=this._callbacks.filter((s)=>s.owner!==owner);}}
__exports.useCallbackRecorder=useCallbackRecorder;function useCallbackRecorder(callbackRecorder,callback){const component=useComponent();useEffect(()=>{callbackRecorder.add(component,callback);return()=>callbackRecorder.remove(component);},()=>[]);}
__exports.useSetupAction=useSetupAction;function useSetupAction(params={}){const component=useComponent();const{__beforeLeave__,__getGlobalState__,__getLocalState__,__getContext__,__getOrderBy__,}=component.env;const{beforeVisibilityChange,beforeUnload,beforeLeave,getGlobalState,getLocalState,rootRef,}=params;if(beforeVisibilityChange){useExternalListener(document,"visibilitychange",beforeVisibilityChange);}
if(beforeUnload){useExternalListener(window,"beforeunload",beforeUnload);}
if(__beforeLeave__&&beforeLeave){useCallbackRecorder(__beforeLeave__,beforeLeave);}
if(__getGlobalState__&&(getGlobalState||rootRef)){useCallbackRecorder(__getGlobalState__,()=>{const state={};if(getGlobalState){Object.assign(state,getGlobalState());}
return state;});}
if(__getLocalState__&&(getLocalState||rootRef)){useCallbackRecorder(__getLocalState__,()=>{const state={};if(getLocalState){Object.assign(state,getLocalState());}
if(rootRef){if(component.env.isSmall){state[scrollSymbol]={root:{left:rootRef.el.scrollLeft,top:rootRef.el.scrollTop},};}else{const contentEl=rootRef.el.querySelector(".o_component_with_search_panel > .o_renderer_with_searchpanel,"+".o_component_with_search_panel > .o_renderer")||rootRef.el.querySelector(".o_content");if(contentEl){state[scrollSymbol]={content:{left:contentEl.scrollLeft,top:contentEl.scrollTop},};}}}
return state;});if(rootRef){onMounted(()=>{const{state}=component.props;const scrolling=state&&state[scrollSymbol];if(scrolling){if(component.env.isSmall){rootRef.el.scrollTop=(scrolling.root&&scrolling.root.top)||0;rootRef.el.scrollLeft=(scrolling.root&&scrolling.root.left)||0;}else if(scrolling.content){const contentEl=rootRef.el.querySelector(".o_component_with_search_panel > .o_renderer_with_searchpanel,"+".o_component_with_search_panel > .o_renderer")||rootRef.el.querySelector(".o_content");if(contentEl){contentEl.scrollTop=scrolling.content.top||0;contentEl.scrollLeft=scrolling.content.left||0;}}}});}}
if(__getContext__&&params.getContext){useCallbackRecorder(__getContext__,params.getContext);}
if(__getOrderBy__&&params.getOrderBy){useCallbackRecorder(__getOrderBy__,params.getOrderBy);}}
return __exports;});;

/* /web/static/src/search/action_menus/action_menus.js */
odoo.define('@web/search/action_menus/action_menus',['@web/core/browser/browser','@web/core/context','@web/session','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/l10n/translation','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{makeContext}=require("@web/core/context");const{session}=require("@web/session");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{Component,onWillStart,onWillUpdateProps,useState}=require("@odoo/owl");const STATIC_ACTIONS_GROUP_NUMBER=__exports.STATIC_ACTIONS_GROUP_NUMBER=1;const ACTIONS_GROUP_NUMBER=__exports.ACTIONS_GROUP_NUMBER=100;const ActionMenus=__exports.ActionMenus=class ActionMenus extends Component{static template="web.ActionMenus";static components={Dropdown,DropdownItem,};static props={getActiveIds:Function,context:Object,resModel:String,printDropdownTitle:{type:String,optional:true},domain:{type:Array,optional:true},isDomainSelected:{type:Boolean,optional:true},items:{type:Object,shape:{action:{type:Array,optional:true},print:{type:Array,optional:true},},},onActionExecuted:{type:Function,optional:true},shouldExecuteAction:{type:Function,optional:true},loadExtraPrintItems:{type:Function,optional:true},};static defaultProps={printDropdownTitle:_t("Print"),onActionExecuted:()=>{},shouldExecuteAction:()=>true,loadExtraPrintItems:()=>[],};setup(){this.orm=useService("orm");this.actionService=useService("action");this.state=useState({printItems:[]})
onWillStart(async()=>{this.actionItems=await this.getActionItems(this.props);});onWillUpdateProps(async(nextProps)=>{this.actionItems=await this.getActionItems(nextProps);});}
async getActionItems(props){return(props.items.action||[]).map((action)=>{if(action.callback){return Object.assign({key:`action-${action.description}`,groupNumber:ACTIONS_GROUP_NUMBER},action);}else{return{action,description:action.name,key:action.id,groupNumber:action.groupNumber||ACTIONS_GROUP_NUMBER,};}});}
async executeAction(action){let activeIds=this.props.getActiveIds();if(this.props.isDomainSelected){activeIds=await this.orm.search(this.props.resModel,this.props.domain,{limit:session.active_ids_limit,context:this.props.context,});}
const activeIdsContext={active_id:activeIds[0],active_ids:activeIds,active_model:this.props.resModel,};if(this.props.domain){activeIdsContext.active_domain=this.props.domain;}
const context=makeContext([this.props.context,activeIdsContext]);return this.actionService.doAction(action.id,{additionalContext:context,onClose:this.props.onActionExecuted,});}
async onItemSelected(item){if(!(await this.props.shouldExecuteAction(item))){return;}
if(item.callback){item.callback([item]);}else if(item.action){this.executeAction(item.action);}else if(item.url){browser.location=item.url;}}
async loadAvailablePrintItems(){const printActions=this.props.items.print||[];const actionWithDomainIds=[];const validActionIds=[];for(const action of printActions){"domain"in action?actionWithDomainIds.push(action.id):validActionIds.push(action.id);}
if(actionWithDomainIds.length){const validActionsWithDomainIds=await this.orm.call("ir.actions.report","get_valid_action_reports",[actionWithDomainIds,this.props.resModel,this.props.getActiveIds()]);validActionIds.push(...validActionsWithDomainIds);}
return printActions.filter((action)=>validActionIds.includes(action.id)).map((action)=>({action,class:"o_menu_item",description:action.name,key:action.id,}));}
async loadPrintItems(){if(!this.props.items.print?.length){return;}
const[items,extraItems]=await Promise.all([this.loadAvailablePrintItems(),this.props.loadExtraPrintItems(),]);const allItems=[...extraItems,...items];if(!allItems.length){allItems.push({description:_t("No report available."),class:"o_menu_item disabled",key:"nothing_to_display",});}
this.state.printItems=allItems;}}
return __exports;});;

/* /web/static/src/search/breadcrumbs/breadcrumbs.js */
odoo.define('@web/search/breadcrumbs/breadcrumbs',['@odoo/owl','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{_t}=require("@web/core/l10n/translation");const Breadcrumbs=__exports.Breadcrumbs=class Breadcrumbs extends Component{static template="web.Breadcrumbs";static components={Dropdown,DropdownItem};static props={breadcrumbs:Array,slots:{type:Object,optional:true},};getBreadcrumbTooltip({isFormView,name}){if(isFormView){return _t("Back to “%s” form",name);}
return _t("Back to “%s”",name);}}
return __exports;});;

/* /web/static/src/search/cog_menu/cog_menu.js */
odoo.define('@web/search/cog_menu/cog_menu',['@web/core/registry','@web/core/dropdown/dropdown','@web/search/action_menus/action_menus','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Dropdown}=require("@web/core/dropdown/dropdown");const{ActionMenus}=require("@web/search/action_menus/action_menus");const{onWillStart,onWillUpdateProps}=require("@odoo/owl");const cogMenuRegistry=registry.category("cogMenu");const CogMenu=__exports.CogMenu=class CogMenu extends ActionMenus{static template="web.CogMenu";static components={...ActionMenus.components,Dropdown,};static props={...ActionMenus.props,getActiveIds:{type:ActionMenus.props.getActiveIds,optional:true},context:{type:ActionMenus.props.context,optional:true},resModel:{type:ActionMenus.props.resModel,optional:true},items:{...ActionMenus.props.items,optional:true},};static defaultProps={...ActionMenus.defaultProps,items:{},};setup(){super.setup();onWillStart(async()=>{this.registryItems=await this._registryItems();});onWillUpdateProps(async()=>{this.registryItems=await this._registryItems();});}
get hasItems(){return this.cogItems.length||this.props.items.print?.length;}
async _registryItems(){const items=[];for(const item of cogMenuRegistry.getAll()){if("isDisplayed"in item?await item.isDisplayed(this.env):true){items.push({Component:item.Component,groupNumber:item.groupNumber,key:item.Component.name,});}}
return items;}
get cogItems(){return[...this.actionItems,...this.registryItems].sort((item1,item2)=>{const grp=(item1.groupNumber||0)-(item2.groupNumber||0);if(grp!==0){return grp;}
return(item1.sequence||0)-(item2.sequence||0);});}}
return __exports;});;

/* /web/static/src/search/control_panel/control_panel.js */
odoo.define('@web/search/control_panel/control_panel',['@web/core/l10n/translation','@web/core/browser/browser','@web/core/hotkeys/hotkey_service','@web/core/pager/pager','@web/core/utils/hooks','@web/core/dropdown/dropdown','@web/core/commands/command_hook','@web/core/dropdown/dropdown_item','@web/core/hotkeys/hotkey_hook','@web/core/utils/sortable_owl','@web/core/user','@web/core/dropdown/accordion_item','@web/core/checkbox/checkbox','@web/core/context','@web/core/confirmation_dialog/confirmation_dialog','@web/core/transition','@web/search/breadcrumbs/breadcrumbs','@web/search/search_bar/search_bar','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const{Pager}=require("@web/core/pager/pager");const{useService}=require("@web/core/utils/hooks");const{Dropdown}=require("@web/core/dropdown/dropdown");const{useCommand}=require("@web/core/commands/command_hook");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{useSortable}=require("@web/core/utils/sortable_owl");const{user}=require("@web/core/user");const{AccordionItem}=require("@web/core/dropdown/accordion_item");const{CheckBox}=require("@web/core/checkbox/checkbox");const{makeContext}=require("@web/core/context");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{Transition}=require("@web/core/transition");const{Breadcrumbs}=require("@web/search/breadcrumbs/breadcrumbs");const{SearchBar}=require("@web/search/search_bar/search_bar");const{Component,useState,onMounted,useExternalListener,useRef,useEffect}=require("@odoo/owl");const STICKY_CLASS="o_mobile_sticky";const ControlPanel=__exports.ControlPanel=class ControlPanel extends Component{static template="web.ControlPanel";static components={Pager,SearchBar,Dropdown,DropdownItem,Breadcrumbs,AccordionItem,CheckBox,Transition,};static props={display:{type:Object,optional:true},slots:{type:Object,optional:true},};setup(){this.actionService=useService("action");this.pagerProps=this.env.config.pagerProps?useState(this.env.config.pagerProps):undefined;this.notificationService=useService("notification");this.breadcrumbs=useState(this.env.config.breadcrumbs);this.orm=useService("orm");this.dialogService=useService("dialog");this.root=useRef("root");this.newActionNameRef=useRef("newActionNameRef");this.isEmbeddedActionsOrderModifiable=false;this.defaultEmbeddedActions=this.env.config.embeddedActions;if(this.env.config.embeddedActions?.length>0&&!this.env.config.parentActionId){const{parent_res_model,parent_action_id}=this.env.config.embeddedActions[0];this.defaultEmbeddedActions=[{id:false,name:this.env.config?.actionName,parent_action_id,parent_res_model,action_id:parent_action_id,user_id:false,context:{},},...this.env.config.embeddedActions,];this.env.config.setEmbeddedActions(this.defaultEmbeddedActions);}
const parentActionId=this.env.config.parentActionId||this.env.config.embeddedActions?.[0]?.parent_action_id[0]||this.env.config.embeddedActions?.[0]?.parent_action_id||"";this.embeddedActionsVisibilityKey=`visibleEmbeddedActions${parentActionId}+${
            this.env.searchModel?.globalContext.active_id || ""
        }+${user.userId}`;this.embeddedVisibilityKey=`visibleEmbedded${parentActionId}+${
            this.env.searchModel?.globalContext.active_id || ""
        }+${user.userId}`;this.embeddedOrderKey=`orderEmbedded${parentActionId}+${
            this.env.searchModel?.globalContext.active_id || ""
        }+${user.userId}`;this.state=useState({showSearchBar:false,showMobileSearch:false,showViewSwitcher:false,embeddedInfos:{showEmbedded:this.env.config.embeddedActions?.length>0&&((!!this.env.config.parentActionId&&!!JSON.parse(browser.localStorage.getItem("showEmbeddedActions")))||!!JSON.parse(browser.localStorage.getItem(this.embeddedVisibilityKey))),embeddedActions:this.defaultEmbeddedActions||[],newActionIsShared:false,newActionName:this.newActionNameGetter,visibleEmbeddedActions:(this.env.config.embeddedActions?.length>0&&JSON.parse(browser.localStorage.getItem(this.embeddedActionsVisibilityKey)))||{},currentEmbeddedAction:this.currentEmbeddedAction,},});this.onScrollThrottledBound=this.onScrollThrottled.bind(this);const{viewSwitcherEntries,viewType}=this.env.config;for(const view of viewSwitcherEntries||[]){useCommand(_t("Show %s view",view.name),()=>this.switchView(view.type),{category:"view_switcher",isAvailable:()=>view.type!==viewType,});}
if(viewSwitcherEntries?.length>1){useHotkey("alt+shift+v",()=>{this.cycleThroughViews();},{bypassEditableProtection:true,withOverlay:()=>this.root.el.querySelector("nav.o_cp_switch_buttons"),});}
useExternalListener(window,"click",this.onWindowClick);useEffect(()=>{if(!this.env.isSmall||("adaptToScroll"in this.display&&!this.display.adaptToScroll)){return;}
const scrollingEl=this.getScrollingElement();scrollingEl.addEventListener("scroll",this.onScrollThrottledBound);this.root.el.style.top="0px";return()=>{scrollingEl.removeEventListener("scroll",this.onScrollThrottledBound);};});onMounted(async()=>{if(this.state.embeddedInfos.embeddedActions?.length>0){const embeddedActionKey=this.state.embeddedInfos.currentEmbeddedAction?.id||false;if(!Object.keys(this.state.embeddedInfos.visibleEmbeddedActions).includes(embeddedActionKey.toString())){this._setVisibility(embeddedActionKey);}
const embeddedOrderLocalStorageKey=browser.localStorage.getItem(this.embeddedOrderKey);if(embeddedOrderLocalStorageKey){this._sortEmbeddedActions(JSON.parse(embeddedOrderLocalStorageKey));}}
if(!this.env.isSmall||("adaptToScroll"in this.display&&!this.display.adaptToScroll)){return;}
this.oldScrollTop=0;this.lastScrollTop=0;this.initialScrollTop=this.getScrollingElement().scrollTop;});this.mainButtons=useRef("mainButtons");useEffect(()=>{const dropdownButtons=this.mainButtons.el.querySelectorAll(".o_control_panel_collapsed_create.dropdown-menu button");if(!dropdownButtons.length){this.mainButtons.el.querySelectorAll(".o_control_panel_collapsed_create.dropdown-menu, .o_control_panel_collapsed_create.dropdown-toggle").forEach((el)=>el.classList.add("d-none"));this.mainButtons.el.querySelectorAll(".o_control_panel_collapsed_create.btn-group").forEach((el)=>el.classList.remove("btn-group"));return;}
for(const button of dropdownButtons){for(const cl of Array.from(button.classList)){button.classList.toggle(cl,!cl.startsWith("btn-"));}
button.classList.add("dropdown-item","btn","btn-link");}});useSortable({enable:true,ref:this.root,elements:".o_draggable",cursor:"move",delay:200,tolerance:10,onWillStartDrag:(params)=>this._sortEmbeddedActionStart(params),onDrop:(params)=>this._sortEmbeddedActionDrop(params),});}
getDropdownClass(action){return(!this.env.isSmall&&this._checkValueLocalStorage(action))||(this.env.isSmall&&this.state.embeddedInfos.currentEmbeddedAction?.id===action.id)?"selected":"";}
getScrollingElement(){return this.root.el.parentElement;}
get currentEmbeddedAction(){if(!this.env.config){return{};}
const{currentEmbeddedActionId}=this.env.config;return(this.defaultEmbeddedActions?.find(({id})=>id===currentEmbeddedActionId)||this.defaultEmbeddedActions?.[0]);}
get newActionNameGetter(){if(this.currentEmbeddedAction?.name){return _t("Custom %s",this.currentEmbeddedAction.name);}else{return _t("Custom Embedded Action");}}
resetSearchState(){Object.assign(this.state,{showSearchBar:false,showMobileSearch:false,showViewSwitcher:false,});}
get display(){return{layoutActions:true,...this.props.display,};}
onClickShowEmbedded(){if(this.state.embeddedInfos.showEmbedded){browser.localStorage.removeItem(this.embeddedVisibilityKey);}else{browser.localStorage.setItem(this.embeddedVisibilityKey,true);}
this.state.embeddedInfos.showEmbedded=!this.state.embeddedInfos.showEmbedded;browser.localStorage.setItem("showEmbeddedActions",this.state.embeddedInfos.showEmbedded);}
onScrollThrottled(){if(this.isScrolling){return;}
this.isScrolling=true;browser.requestAnimationFrame(()=>(this.isScrolling=false));const scrollTop=this.getScrollingElement().scrollTop;const delta=Math.round(scrollTop-this.oldScrollTop);if(scrollTop>this.initialScrollTop){this.root.el.classList.add(STICKY_CLASS);if(delta<=0){this.lastScrollTop=Math.min(0,this.lastScrollTop-delta);}else{this.lastScrollTop=Math.max(-this.root.el.offsetHeight,-this.root.el.offsetTop-delta);}
this.root.el.style.top=`${this.lastScrollTop}px`;}else{this.root.el.classList.remove(STICKY_CLASS);this.lastScrollTop=0;}
this.oldScrollTop=scrollTop;}
switchView(viewType){this.resetSearchState();this.actionService.switchView(viewType);}
cycleThroughViews(){const currentViewType=this.env.config.viewType;const viewSwitcherEntries=this.env.config.viewSwitcherEntries;const currentIndex=viewSwitcherEntries.findIndex((entry)=>entry.type===currentViewType);const nextIndex=(currentIndex+1)%viewSwitcherEntries.length;this.switchView(viewSwitcherEntries[nextIndex].type);}
onWindowClick(ev){if(this.state.showViewSwitcher&&!ev.target.closest(".o_cp_switch_buttons")){this.state.showViewSwitcher=false;}}
onMainButtonsKeydown(ev){const hotkey=getActiveHotkey(ev);if(hotkey==="arrowdown"){this.env.searchModel.trigger("focus-view");ev.preventDefault();ev.stopPropagation();}}
_checkValueLocalStorage(action){const actionIdStr=action.id.toString();return this.state.embeddedInfos.visibleEmbeddedActions[actionIdStr];}
_setVisibility(actionId){const actionIdStr=actionId.toString();if(this.state.embeddedInfos.visibleEmbeddedActions[actionIdStr]){delete this.state.embeddedInfos.visibleEmbeddedActions[actionIdStr];}else{this.state.embeddedInfos.visibleEmbeddedActions[actionIdStr]=true;}
browser.localStorage.setItem(this.embeddedActionsVisibilityKey,JSON.stringify(this.state.embeddedInfos.visibleEmbeddedActions));}
_onShareCheckboxChange(){this.state.embeddedInfos.newActionIsShared=!this.state.embeddedInfos.newActionIsShared;}
async _saveNewAction(ev){const{newActionName,newActionIsShared,embeddedActions,currentEmbeddedAction,visibleEmbeddedActions,}=this.state.embeddedInfos;if(!newActionName){this.notificationService.add(_t("A name for your new action is required."),{type:"danger",});ev.stopPropagation();return this.newActionNameRef.el.focus();}
const duplicateName=embeddedActions.some(({name})=>name===newActionName);if(duplicateName){this.notificationService.add(_t("An action with the same name already exists."),{type:"danger",});ev.stopPropagation();return this.newActionNameRef.el.focus();}
const userId=newActionIsShared?false:user.userId;const{parent_action_id,action_id,parent_res_model,python_method,domain,context,groups_ids,}=currentEmbeddedAction;const values={parent_action_id:parent_action_id[0],parent_res_model,parent_res_id:this.env.searchModel.globalContext.active_id,user_id:userId,is_deletable:true,default_view_mode:this.env.config.viewType,domain,context,groups_ids,name:newActionName,};if(python_method){values.python_method=python_method;}else{values.action_id=action_id[0]||this.env.config.actionId;}
const embeddedActionId=await this.orm.create("ir.embedded.actions",[values]);const description=`${newActionName}`;this.env.searchModel.createNewFavorite({description,isDefault:true,isShared:newActionIsShared,embeddedActionId:embeddedActionId[0],});Object.assign(this.state.embeddedInfos,{newActionName:"",newActionIsShared:false,});const enrichedNewEmbeddedAction={...values,parent_action_id,action_id,id:embeddedActionId[0],};this.state.embeddedInfos.embeddedActions.push(enrichedNewEmbeddedAction);const embeddedActionIdStr=embeddedActionId[0].toString();visibleEmbeddedActions[embeddedActionIdStr]=true;const order=this.state.embeddedInfos.embeddedActions.map((el)=>el.id);browser.localStorage.setItem(this.embeddedActionsVisibilityKey,JSON.stringify(visibleEmbeddedActions));browser.localStorage.setItem(this.embeddedOrderKey,JSON.stringify(order));this.env.config.setCurrentEmbeddedAction(embeddedActionId);this.state.embeddedInfos.currentEmbeddedAction=enrichedNewEmbeddedAction;this.state.embeddedInfos.newActionName=`${newActionName} Custom`;}
openConfirmationDialog(action){const dialogProps={title:_t("Warning"),body:action.user_id?_t("Are you sure that you want to remove this embedded action?"):_t("This embedded action is global and will be removed for everyone."),confirmLabel:_t("Delete"),confirm:async()=>await this._deleteEmbeddedAction(action),cancel:()=>{},};this.dialogService.add(ConfirmationDialog,dialogProps);}
async _deleteEmbeddedAction(action){const{visibleEmbeddedActions,embeddedActions,currentEmbeddedAction}=this.state.embeddedInfos;const actionIdStr=action.id.toString();if(visibleEmbeddedActions[actionIdStr]){delete visibleEmbeddedActions[actionIdStr];}
browser.localStorage.setItem(this.embeddedActionsVisibilityKey,JSON.stringify(visibleEmbeddedActions));this.state.embeddedInfos.embeddedActions=embeddedActions.filter(({id})=>id!==action.id);await this.orm.unlink("ir.embedded.actions",[action.id]);if(action.id===currentEmbeddedAction?.id){const{active_id,active_model}=this.env.searchModel.globalContext;const actionContext=action.context?makeContext([action.context]):{};const additionalContext={...actionContext,active_id,active_model,};this.actionService.doAction(action.parent_action_id[0]||action.parent_action_id,{additionalContext,stackPosition:"replaceCurrentAction",});}}
async onEmbeddedActionClick(action){this.env.config.setEmbeddedActions(this.state.embeddedInfos.embeddedActions);const{active_id,active_model}=this.env.searchModel.globalContext;const actionContext=action.context?makeContext([action.context]):{};const context={...actionContext,active_id,active_model,current_embedded_action_id:action.id,parent_action_embedded_actions:this.state.embeddedInfos.embeddedActions,parent_action_id:action.parent_action_id[0]||action.parent_action_id,};this.actionService.doActionButton({type:action.python_method?"object":"action",resId:this.env.searchModel?.globalContext.active_id,name:action.python_method||action.action_id[0]||action.action_id,resModel:action.parent_res_model,context,stackPosition:this.env.config.parentActionId?"replaceCurrentAction":"",viewType:action.default_view_mode,},{isEmbeddedAction:true});}
_sortEmbeddedActions(order){this.state.embeddedInfos.embeddedActions=this.state.embeddedInfos.embeddedActions.sort((a,b)=>{const indexA=order.indexOf(a.id);if(!indexA){return-1;}
const indexB=order.indexOf(b.id);if(!indexB){return 1;}
return indexA-indexB;});}
_sortEmbeddedActionStart({element,addClass}){addClass(element,"o_dragged_embedded_action");}
_sortEmbeddedActionDrop({element,previous}){const order=this.state.embeddedInfos.embeddedActions.map((el)=>el.id);const elementId=Number(element.dataset.id)||false;const elementIndex=order.indexOf(elementId);order.splice(elementIndex,1);if(previous){const prevIndex=order.indexOf(Number(previous.dataset.id)||false);order.splice(prevIndex+1,0,elementId);}else{order.splice(0,0,elementId);}
this._sortEmbeddedActions(order);browser.localStorage.setItem(this.embeddedOrderKey,JSON.stringify(order));}}
return __exports;});;

/* /web/static/src/search/custom_favorite_item/custom_favorite_item.js */
odoo.define('@web/search/custom_favorite_item/custom_favorite_item',['@web/core/l10n/translation','@web/core/dropdown/accordion_item','@web/core/checkbox/checkbox','@web/core/registry','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{AccordionItem}=require("@web/core/dropdown/accordion_item");const{CheckBox}=require("@web/core/checkbox/checkbox");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{Component,useRef,useState}=require("@odoo/owl");const favoriteMenuRegistry=registry.category("favoriteMenu");const CustomFavoriteItem=__exports.CustomFavoriteItem=class CustomFavoriteItem extends Component{static template="web.CustomFavoriteItem";static components={CheckBox,AccordionItem};static props={};setup(){this.notificationService=useService("notification");this.descriptionRef=useRef("description");this.state=useState({description:this.env.config.getDisplayName(),isDefault:false,isShared:false,});}
saveFavorite(ev){if(!this.state.description){this.notificationService.add(_t("A name for your favorite filter is required."),{type:"danger",});ev.stopPropagation();return this.descriptionRef.el.focus();}
const favorites=this.env.searchModel.getSearchItems((s)=>s.type==="favorite"&&s.description===this.state.description);if(favorites.length){this.notificationService.add(_t("A filter with same name already exists."),{type:"danger",});ev.stopPropagation();return this.descriptionRef.el.focus();}
const{description,isDefault,isShared}=this.state;const embeddedActionId=this.env.config.currentEmbeddedActionId||false;this.env.searchModel.createNewFavorite({description,isDefault,isShared,embeddedActionId,});Object.assign(this.state,{description:this.env.config.getDisplayName(),isDefault:false,isShared:false,});}
onDefaultCheckboxChange(checked){this.state.isDefault=checked;if(checked){this.state.isShared=false;}}
onShareCheckboxChange(checked){this.state.isShared=checked;if(checked){this.state.isDefault=false;}}
onInputKeydown(ev){switch(ev.key){case"Enter":ev.preventDefault();this.saveFavorite(ev);break;case"Escape":ev.preventDefault();ev.target.blur();break;}}}
favoriteMenuRegistry.add("custom-favorite-item",{Component:CustomFavoriteItem,groupNumber:3},{sequence:0});return __exports;});;

/* /web/static/src/search/custom_group_by_item/custom_group_by_item.js */
odoo.define('@web/search/custom_group_by_item/custom_group_by_item',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const CustomGroupByItem=__exports.CustomGroupByItem=class CustomGroupByItem extends Component{static template="web.CustomGroupByItem";static props={fields:Array,onAddCustomGroup:Function,};get choices(){return this.props.fields.map((f)=>({label:f.string,value:f.name}));}
onSelected(ev){if(ev.target.value){this.props.onAddCustomGroup(ev.target.value);ev.target.value="";}}}
return __exports;});;

/* /web/static/src/search/layout.js */
odoo.define('@web/search/layout',['@odoo/owl','@web/search/control_panel/control_panel','@web/search/search_panel/search_panel'],function(require){'use strict';let __exports={};const{Component,useRef}=require("@odoo/owl");const{ControlPanel}=require("@web/search/control_panel/control_panel");const{SearchPanel}=require("@web/search/search_panel/search_panel");__exports.extractLayoutComponents=extractLayoutComponents;function extractLayoutComponents(params){const layoutComponents={ControlPanel:params.ControlPanel||ControlPanel,SearchPanel:params.SearchPanel||SearchPanel,};return layoutComponents;}
const Layout=__exports.Layout=class Layout extends Component{static template="web.Layout";static props={className:{type:String,optional:true},display:{type:Object,optional:true},slots:{type:Object,optional:true},};static defaultProps={display:{},};setup(){this.components=extractLayoutComponents(this.env.config);this.contentRef=useRef("content");}
get controlPanelSlots(){const slots={...this.props.slots};if(this.env.inDialog){delete slots["layout-buttons"];}
delete slots.default;return slots;}}
return __exports;});;

/* /web/static/src/search/pager_hook.js */
odoo.define('@web/search/pager_hook',['@odoo/owl'],function(require){'use strict';let __exports={};const{useEnv,useSubEnv,useState,onWillRender}=require("@odoo/owl");__exports.usePager=usePager;function usePager(getProps){const env=useEnv();const pagerState=useState({});useSubEnv({config:{...env.config,pagerProps:pagerState,},});onWillRender(()=>{Object.assign(pagerState,getProps()||{total:0});});}
return __exports;});;

/* /web/static/src/search/properties_group_by_item/properties_group_by_item.js */
odoo.define('@web/search/properties_group_by_item/properties_group_by_item',['@web/core/dropdown/accordion_item','@web/core/dropdown/checkbox_item','@web/core/dropdown/dropdown_item','@odoo/owl'],function(require){'use strict';let __exports={};const{AccordionItem,ACCORDION}=require("@web/core/dropdown/accordion_item");const{CheckboxItem}=require("@web/core/dropdown/checkbox_item");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{Component,useState,useChildSubEnv}=require("@odoo/owl");const PropertiesGroupByItem=__exports.PropertiesGroupByItem=class PropertiesGroupByItem extends Component{static template="web.PropertiesGroupByItem";static components={AccordionItem,CheckboxItem,DropdownItem};static props={item:Object,onGroup:Function,};setup(){this.state=useState({groupByItems:[]});useChildSubEnv({[ACCORDION]:{accordionStateChanged:this.beforeOpen.bind(this),},});}
get isActive(){return this.state.groupByItems.some((item)=>item.isActive);}
get isSingleParent(){const uniqueNames=new Set(this.state.groupByItems.map((item)=>item.definitionRecordId));return uniqueNames.size<2;}
async beforeOpen(){if(this.definitionLoaded){return;}
this.definitionLoaded=true;await this.env.searchModel.fillSearchViewItemsProperty();this._updateGroupByItems();}
onGroup(ids){this.props.onGroup(ids);this._updateGroupByItems();}
_updateGroupByItems(){this.state.groupByItems=this.env.searchModel.getSearchItems((searchItem)=>["groupBy","dateGroupBy"].includes(searchItem.type)&&searchItem.isProperty&&searchItem.propertyFieldName===this.props.item.fieldName);}}
return __exports;});;

/* /web/static/src/search/search_arch_parser.js */
odoo.define('@web/search/search_arch_parser',['@web/core/context','@web/core/l10n/translation','@web/core/py_js/py','@web/core/utils/numbers','@web/core/utils/strings','@web/core/utils/xml','@web/search/utils/dates'],function(require){'use strict';let __exports={};const{makeContext}=require("@web/core/context");const{_t}=require("@web/core/l10n/translation");const{evaluateBooleanExpr,evaluateExpr}=require("@web/core/py_js/py");const{clamp}=require("@web/core/utils/numbers");const{exprToBoolean}=require("@web/core/utils/strings");const{visitXML}=require("@web/core/utils/xml");const{DEFAULT_INTERVAL,toGeneratorId}=require("@web/search/utils/dates");const ALL=_t("All");const DEFAULT_LIMIT=200;const DEFAULT_VIEWS_WITH_SEARCH_PANEL=["kanban","list"];function getContextGroubBy(context){try{return makeContext([context]).group_by?.split(":")||[];}catch{return[];}}
function reduceType(type){if(type==="dateFilter"){return"filter";}
if(type==="dateGroupBy"){return"groupBy";}
return type;}
const SearchArchParser=__exports.SearchArchParser=class SearchArchParser{constructor(searchViewDescription,fields,searchDefaults={},searchPanelDefaults={}){const{irFilters,arch}=searchViewDescription;this.fields=fields||{};this.irFilters=irFilters||[];this.arch=arch||"<search/>";this.labels=[];this.preSearchItems=[];this.searchPanelInfo={className:"",fold:false,viewTypes:DEFAULT_VIEWS_WITH_SEARCH_PANEL,};this.sections=[];this.searchDefaults=searchDefaults;this.searchPanelDefaults=searchPanelDefaults;this.currentGroup=[];this.currentTag=null;this.groupNumber=0;this.pregroupOfGroupBys=[];this.optionsParams=null;}
parse(){visitXML(this.arch,(node,visitChildren)=>{switch(node.tagName){case"search":this.visitSearch(node,visitChildren);break;case"searchpanel":return this.visitSearchPanel(node);case"group":this.visitGroup(node,visitChildren);break;case"separator":this.visitSeparator();break;case"field":this.visitField(node);break;case"filter":if(this.optionsParams){this.visitDateOption(node);}else{this.visitFilter(node,visitChildren);}
break;}});return{labels:this.labels,preSearchItems:this.preSearchItems,searchPanelInfo:this.searchPanelInfo,sections:this.sections,};}
pushGroup(tag=null){if(this.currentGroup.length){if(this.currentTag==="groupBy"){this.pregroupOfGroupBys.push(...this.currentGroup);}else{this.preSearchItems.push(this.currentGroup);}}
this.currentTag=tag;this.currentGroup=[];this.groupNumber++;}
visitField(node){this.pushGroup("field");const preField={type:"field"};if(node.hasAttribute("invisible")){preField.invisible=node.getAttribute("invisible");}
if(node.hasAttribute("domain")){preField.domain=node.getAttribute("domain");}
if(node.hasAttribute("filter_domain")){preField.filterDomain=node.getAttribute("filter_domain");}else if(node.hasAttribute("operator")){preField.operator=node.getAttribute("operator");}
if(node.hasAttribute("context")){preField.context=node.getAttribute("context");}
if(node.hasAttribute("name")){const name=node.getAttribute("name");if(!this.fields[name]){throw Error(`Unknown field ${name}`);}
const fieldType=this.fields[name].type;preField.fieldName=name;preField.fieldType=fieldType;if(fieldType!=="properties"&&name in this.searchDefaults){preField.isDefault=true;let value=this.searchDefaults[name];value=Array.isArray(value)?value[0]:value;let operator=preField.operator;if(!operator){let type=fieldType;if(node.hasAttribute("widget")){type=node.getAttribute("widget");}
if(["char","html","many2many","one2many","text"].includes(type)){operator="ilike";}else{operator="=";}}
preField.defaultRank=-10;const{selection,context,relation}=this.fields[name];preField.defaultAutocompleteValue={label:`${value}`,operator,value};if(fieldType==="selection"){const option=selection.find((sel)=>sel[0]===value);if(!option){throw Error();}
preField.defaultAutocompleteValue.label=option[1];}else if(fieldType==="many2one"){this.labels.push((orm)=>{return orm.call(relation,"read",[value,["display_name"]],{context}).then((results)=>{preField.defaultAutocompleteValue.label=results[0]["display_name"];});});}}}else{throw Error();}
if(node.hasAttribute("string")){preField.description=node.getAttribute("string");}else if(preField.fieldName){preField.description=this.fields[preField.fieldName].string;}else{preField.description="Ω";}
this.currentGroup.push(preField);}
visitFilter(node,visitChildren){const preSearchItem={type:"filter"};if(node.hasAttribute("context")){const context=node.getAttribute("context");const[fieldName,defaultInterval]=getContextGroubBy(context);const groupByField=this.fields[fieldName];if(groupByField){preSearchItem.type="groupBy";preSearchItem.fieldName=fieldName;preSearchItem.fieldType=groupByField.type;if(["date","datetime"].includes(groupByField.type)){preSearchItem.type="dateGroupBy";preSearchItem.defaultIntervalId=defaultInterval||DEFAULT_INTERVAL;}}else{preSearchItem.context=context;}}
if(reduceType(preSearchItem.type)!==this.currentTag){this.pushGroup(reduceType(preSearchItem.type));}
if(preSearchItem.type==="filter"){if(node.hasAttribute("date")){const fieldName=node.getAttribute("date");preSearchItem.type="dateFilter";preSearchItem.fieldName=fieldName;preSearchItem.fieldType=this.fields[fieldName].type;const optionsParams={startYear:Number(node.getAttribute("start_year")||-2),endYear:Number(node.getAttribute("end_year")||0),startMonth:Number(node.getAttribute("start_month")||-2),endMonth:Number(node.getAttribute("end_month")||0),customOptions:[],};const defaultOffset=clamp(optionsParams.startMonth,optionsParams.endMonth,0);preSearchItem.defaultGeneratorIds=[toGeneratorId("month",defaultOffset)];if(node.hasAttribute("default_period")){preSearchItem.defaultGeneratorIds=node.getAttribute("default_period").split(",");}
this.optionsParams=optionsParams;visitChildren();preSearchItem.optionsParams=optionsParams;this.optionsParams=null;}
preSearchItem.domain=node.getAttribute("domain")||"[]";}
if(node.hasAttribute("invisible")){preSearchItem.invisible=node.getAttribute("invisible");const fieldName=preSearchItem.fieldName;if(fieldName&&!this.fields[fieldName]){return;}}
preSearchItem.groupNumber=this.groupNumber;if(node.hasAttribute("name")){const name=node.getAttribute("name");preSearchItem.name=name;if(name in this.searchDefaults){preSearchItem.isDefault=true;const value=this.searchDefaults[name];if(["groupBy","dateGroupBy"].includes(preSearchItem.type)){preSearchItem.defaultRank=typeof value==="number"?value:100;}else{preSearchItem.defaultRank=-5;}
if(preSearchItem.type==="dateFilter"&&typeof value==="string"&&!/^(true|1)$/i.test(value)){preSearchItem.defaultGeneratorIds=value.split(",");}}}
if(node.hasAttribute("string")){preSearchItem.description=node.getAttribute("string");}else if(preSearchItem.fieldName){preSearchItem.description=this.fields[preSearchItem.fieldName].string;}else if(node.hasAttribute("help")){preSearchItem.description=node.getAttribute("help");}else if(node.hasAttribute("name")){preSearchItem.description=node.getAttribute("name");}else{preSearchItem.description="Ω";}
this.currentGroup.push(preSearchItem);}
visitDateOption(node){const preDateOption={type:"dateOption"};for(const attribute of["name","string","domain"]){if(!node.getAttribute(attribute)){throw new Error(`Attribute "${attribute}" is missing.`);}}
preDateOption.id=`custom_${node.getAttribute("name")}`;preDateOption.description=node.getAttribute("string");preDateOption.domain=node.getAttribute("domain");this.optionsParams.customOptions.push(preDateOption);}
visitGroup(node,visitChildren){this.pushGroup();visitChildren();this.pushGroup();}
visitSearch(node,visitChildren){visitChildren();this.pushGroup();if(this.pregroupOfGroupBys.length){this.preSearchItems.push(this.pregroupOfGroupBys);}}
visitSearchPanel(searchPanelNode){let hasCategoryWithCounters=false;let hasFilterWithDomain=false;let nextSectionId=1;if(searchPanelNode.hasAttribute("class")){this.searchPanelInfo.className=searchPanelNode.getAttribute("class");}
if(searchPanelNode.hasAttribute("fold")){this.searchPanelInfo.fold=exprToBoolean(searchPanelNode.getAttribute("fold"));}
if(searchPanelNode.hasAttribute("view_types")){this.searchPanelInfo.viewTypes=searchPanelNode.getAttribute("view_types").split(",");}
for(const node of searchPanelNode.children){if(node.nodeType!==1||node.tagName!=="field"){continue;}
if(node.getAttribute("invisible")==="True"||node.getAttribute("invisible")==="1"){continue;}
const attrs={};for(const attrName of node.getAttributeNames()){attrs[attrName]=node.getAttribute(attrName);}
const type=attrs.select==="multi"?"filter":"category";const section={color:attrs.color||null,description:attrs.string||this.fields[attrs.name].string,enableCounters:evaluateBooleanExpr(attrs.enable_counters),expand:evaluateBooleanExpr(attrs.expand),fieldName:attrs.name,icon:attrs.icon||null,id:nextSectionId++,limit:evaluateExpr(attrs.limit||String(DEFAULT_LIMIT)),type,values:new Map(),};if(type==="category"){section.activeValueId=this.searchPanelDefaults[attrs.name];section.icon=section.icon||"fa-folder";section.hierarchize=evaluateBooleanExpr(attrs.hierarchize||"1");section.values.set(false,{childrenIds:[],display_name:ALL.toString(),id:false,bold:true,parentId:false,});hasCategoryWithCounters=hasCategoryWithCounters||section.enableCounters;}else{section.domain=attrs.domain||"[]";section.groupBy=attrs.groupby||null;section.icon=section.icon||"fa-filter";hasFilterWithDomain=hasFilterWithDomain||section.domain!=="[]";}
this.sections.push([section.id,section]);}
if(hasCategoryWithCounters&&hasFilterWithDomain){for(const section of this.sections){if(section.type==="category"){section.enableCounters=false;}}
console.warn("Warning: categories with counters are incompatible with filters having a domain attribute.","All category counters have been disabled to avoid inconsistencies.");}
return false;}
visitSeparator(){this.pushGroup();}}
return __exports;});;

/* /web/static/src/search/search_bar/search_bar.js */
odoo.define('@web/search/search_bar/search_bar',['@web/core/domain','@web/core/l10n/dates','@web/core/registry','@web/core/utils/concurrency','@web/core/utils/hooks','@web/core/domain_selector_dialog/domain_selector_dialog','@web/core/utils/search','@web/core/l10n/translation','@web/search/search_bar_menu/search_bar_menu','@odoo/owl','@web/core/dropdown/dropdown_hooks','@web/core/browser/feature_detection'],function(require){'use strict';let __exports={};const{Domain}=require("@web/core/domain");const{serializeDate,serializeDateTime}=require("@web/core/l10n/dates");const{registry}=require("@web/core/registry");const{KeepLast}=require("@web/core/utils/concurrency");const{useAutofocus,useBus,useService}=require("@web/core/utils/hooks");const{DomainSelectorDialog}=require("@web/core/domain_selector_dialog/domain_selector_dialog");const{fuzzyTest}=require("@web/core/utils/search");const{_t}=require("@web/core/l10n/translation");const{SearchBarMenu}=require("@web/search/search_bar_menu/search_bar_menu");const{Component,useExternalListener,useRef,useState}=require("@odoo/owl");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const{hasTouch}=require("@web/core/browser/feature_detection");const parsers=registry.category("parsers");const CHAR_FIELDS=["char","html","many2many","many2one","one2many","text","properties"];const FOLDABLE_TYPES=["properties","many2one","many2many"];let nextItemId=1;const SUB_ITEMS_DEFAULT_LIMIT=8;const SearchBar=__exports.SearchBar=class SearchBar extends Component{static template="web.SearchBar";static components={SearchBarMenu,};static props={autofocus:{type:Boolean,optional:true},slots:{type:Object,optional:true,shape:{default:{optional:true},"search-bar-additional-menu":{optional:true},},},toggler:{type:Object,optional:true,},};static defaultProps={autofocus:true,};setup(){this.dialogService=useService("dialog");this.fields=this.env.searchModel.searchViewFields;this.searchItemsFields=this.env.searchModel.getSearchItems((f)=>f.type==="field");this.root=useRef("root");this.ui=useService("ui");this.visibilityState=useState(this.props.toggler?.state||{showSearchBar:true});this.state=useState({expanded:[],focusedIndex:0,query:"",subItemsLimits:{},});this.items=useState([]);this.subItems={};this.searchBarDropdownState=useDropdownState();this.orm=useService("orm");this.keepLast=new KeepLast();this.inputRef=this.env.config.disableSearchBarAutofocus||!this.props.autofocus?useRef("autofocus"):useAutofocus({mobile:this.props.toggler!==undefined});useBus(this.env.searchModel,"focus-search",()=>{this.inputRef.el.focus();});useBus(this.env.searchModel,"update",this.render);useExternalListener(window,"click",this.onWindowClick);useExternalListener(window,"keydown",this.onWindowKeydown);}
getSearchItem(id){return this.env.searchModel.searchItems[id];}
async computeState(options={}){const query="query"in options?options.query:this.state.query;const expanded="expanded"in options?options.expanded:this.state.expanded;const focusedIndex="focusedIndex"in options?options.focusedIndex:this.state.focusedIndex;const subItems="subItems"in options?options.subItems:this.subItems;const tasks=[];for(const id of expanded){const searchItem=this.getSearchItem(id);if(searchItem.type==="field"&&searchItem.fieldType==="properties"){tasks.push({id,prom:this.getSearchItemsProperties(searchItem)});}else if(!subItems[id]){if(!this.state.subItemsLimits[id]){this.state.subItemsLimits[id]=SUB_ITEMS_DEFAULT_LIMIT;}
tasks.push({id,prom:this.computeSubItems(searchItem,query)});}}
const prom=this.keepLast.add(Promise.all(tasks.map((task)=>task.prom)));if(tasks.length){const taskResults=await prom;tasks.forEach((task,index)=>{subItems[task.id]=taskResults[index];});}
this.state.expanded=expanded;this.state.query=query;this.state.focusedIndex=focusedIndex;this.subItems=subItems;this.inputRef.el.value=query;const trimmedQuery=this.state.query.trim();this.items.length=0;if(!trimmedQuery){return;}
for(const searchItem of this.searchItemsFields){this.items.push(...this.getItems(searchItem,trimmedQuery));}
this.items.push({title:_t("Add a custom filter"),isAddCustomFilterButton:true,});}
getItems(searchItem,trimmedQuery){const items=[];const isFieldProperty=searchItem.type==="field_property";const fieldType=this.getFieldType(searchItem);let preposition=this.getPreposition(searchItem);if((isFieldProperty&&FOLDABLE_TYPES.includes(fieldType))||fieldType==="properties"){preposition=null;}
if(["selection","boolean","tags"].includes(fieldType)){const booleanOptions=[[true,_t("Yes")],[false,_t("No")],];let options;if(isFieldProperty){const{selection,tags}=searchItem.propertyFieldDefinition||{};options=selection||tags||booleanOptions;}else{options=this.fields[searchItem.fieldName].selection||booleanOptions;}
for(const[value,label]of options){if(fuzzyTest(trimmedQuery.toLowerCase(),label.toLowerCase())){items.push({id:nextItemId++,searchItemDescription:searchItem.description,preposition,searchItemId:searchItem.id,label,operator:searchItem.operator||"=",value,isFieldProperty,});}}
return items;}
const parser=parsers.contains(fieldType)?parsers.get(fieldType):(str)=>str;let value;try{switch(fieldType){case"date":{value=serializeDate(parser(trimmedQuery));break;}
case"datetime":{value=serializeDateTime(parser(trimmedQuery));break;}
case"many2one":{value=trimmedQuery;break;}
default:{value=parser(trimmedQuery);}}}catch{return[];}
const item={id:nextItemId++,searchItemDescription:searchItem.description,preposition,searchItemId:searchItem.id,label:this.state.query,operator:searchItem.operator||(CHAR_FIELDS.includes(fieldType)?"ilike":"="),value,isFieldProperty,};if(isFieldProperty){item.isParent=FOLDABLE_TYPES.includes(fieldType);item.unselectable=FOLDABLE_TYPES.includes(fieldType);item.propertyItemId=searchItem.propertyItemId;}else if(fieldType==="properties"){item.isParent=true;item.unselectable=true;}else if(fieldType==="many2one"){item.isParent=true;}
if(item.isParent){item.isExpanded=this.state.expanded.includes(item.searchItemId);}
items.push(item);if(item.isExpanded){if(searchItem.type==="field"&&searchItem.fieldType==="properties"){for(const subItem of this.subItems[searchItem.id]){items.push(...this.getItems(subItem,trimmedQuery));}}else{items.push(...this.subItems[searchItem.id]);}}
return items;}
getPreposition(searchItem){const fieldType=this.getFieldType(searchItem);return["date","datetime"].includes(fieldType)?_t("at"):_t("for");}
getFieldType(searchItem){const{type}=searchItem.type==="field_property"?searchItem.propertyFieldDefinition:this.fields[searchItem.fieldName];const fieldType=type==="reference"?"char":type;return fieldType;}
getSearchItemsProperties(searchItem){return this.env.searchModel.getSearchItemsProperties(searchItem);}
async computeSubItems(searchItem,query){const field=this.fields[searchItem.fieldName];const context={...this.env.searchModel.domainEvalContext,...field.context};let domain=[];if(searchItem.domain){try{domain=new Domain(searchItem.domain).toList(context);}catch{}}
const relation=searchItem.type==="field_property"?searchItem.propertyFieldDefinition.comodel:field.relation;let nameSearchOperator="ilike";if(query&&query[0]==='"'&&query[query.length-1]==='"'){query=query.slice(1,-1);nameSearchOperator="=";}
const limitToFetch=this.state.subItemsLimits[searchItem.id]+1;const options=await this.orm.call(relation,"name_search",[],{args:domain,operator:nameSearchOperator,context,limit:limitToFetch,name:query.trim(),});let showLoadMore=false;if(options.length===limitToFetch){options.pop();showLoadMore=true;}
const subItems=[];if(options.length){const operator=searchItem.operator||"=";for(const[value,label]of options){subItems.push({id:nextItemId++,isChild:true,searchItemId:searchItem.id,value,label,operator,});}
if(showLoadMore){subItems.push({id:nextItemId++,isChild:true,searchItemId:searchItem.id,label:_t("Load more"),unselectable:true,loadMore:()=>{this.state.subItemsLimits[searchItem.id]+=SUB_ITEMS_DEFAULT_LIMIT;const newSubItems=[...this.subItems];newSubItems[searchItem.id]=undefined;this.computeState({subItems:newSubItems});},});}}else{subItems.push({id:nextItemId++,isChild:true,searchItemId:searchItem.id,label:_t("(no result)"),unselectable:true,});}
return subItems;}
focusFacet(index){const facets=this.root.el.getElementsByClassName("o_searchview_facet");if(facets.length){if(index===undefined){facets[facets.length-1].focus();}else{facets[index].focus();}}}
removeFacet(facet){this.env.searchModel.deactivateGroup(facet.groupId);this.inputRef.el.focus();}
resetState(options={focus:true}){this.state.subItemsLimits={};this.computeState({expanded:[],focusedIndex:0,query:"",subItems:[]});if(options.focus){this.inputRef.el.focus();}}
selectItem(item){if(item.isAddCustomFilterButton){return this.env.searchModel.spawnCustomFilterDialog();}
const searchItem=this.getSearchItem(item.searchItemId);if((searchItem.type==="field"&&searchItem.fieldType==="properties")||(searchItem.type==="field_property"&&item.unselectable)){this.toggleItem(item,!item.isExpanded);return;}
if(!item.unselectable){const{searchItemId,label,operator,value}=item;const autoCompleteValues={label,operator,value};if(value&&value[0]==='"'&&value[value.length-1]==='"'){autoCompleteValues.value=value.slice(1,-1);autoCompleteValues.label=label.slice(1,-1);autoCompleteValues.operator="=";autoCompleteValues.enforceEqual=true;}
this.env.searchModel.addAutoCompletionValues(searchItemId,autoCompleteValues);}
if(item.loadMore){item.loadMore();}else{this.resetState();}}
toggleItem(item,shouldExpand){const id=item.searchItemId;const expanded=[...this.state.expanded];const index=expanded.findIndex((id0)=>id0===id);if(shouldExpand===true){if(index<0){expanded.push(id);}}else{if(index>=0){expanded.splice(index,1);}}
this.computeState({expanded});}
onFacetLabelClick(target,facet){const{domain,groupId}=facet;if(this.env.searchModel.canOrderByCount&&facet.type==="groupBy"){this.env.searchModel.switchGroupBySort();return;}else if(!domain){return;}
const{resModel}=this.env.searchModel;this.dialogService.add(DomainSelectorDialog,{resModel,domain,context:this.env.searchModel.domainEvalContext,onConfirm:(domain)=>this.env.searchModel.splitAndAddDomain(domain,groupId),disableConfirmButton:(domain)=>domain===`[]`,title:_t("Modify Condition"),isDebugMode:this.env.searchModel.isDebugMode,});}
onFacetKeydown(facet,facetIndex,ev){switch(ev.key){case"ArrowLeft":{if(facetIndex===0){this.inputRef.el.focus();}else{this.focusFacet(facetIndex-1);}
break;}
case"ArrowRight":{const facets=this.root.el.getElementsByClassName("o_searchview_facet");if(facetIndex===facets.length-1){this.inputRef.el.focus();}else{this.focusFacet(facetIndex+1);}
break;}
case"Backspace":{this.removeFacet(facet);break;}}}
onFacetRemove(facet){this.removeFacet(facet);}
onItemMousemove(focusedIndex){this.state.focusedIndex=focusedIndex;this.inputRef.el.focus();}
onSearchKeydown(ev){if(ev.isComposing){return;}
const focusedItem=this.items[this.state.focusedIndex];let focusedIndex;switch(ev.key){case"ArrowDown":ev.preventDefault();if(this.items.length){if(this.state.focusedIndex>=this.items.length-1){focusedIndex=0;}else{focusedIndex=this.state.focusedIndex+1;}}else{this.env.searchModel.trigger("focus-view");}
break;case"ArrowUp":ev.preventDefault();if(this.items.length){if(this.state.focusedIndex===0||this.state.focusedIndex>this.items.length-1){focusedIndex=this.items.length-1;}else{focusedIndex=this.state.focusedIndex-1;}}
break;case"ArrowLeft":if(focusedItem&&focusedItem.isParent&&focusedItem.isExpanded){ev.preventDefault();this.toggleItem(focusedItem,false);}else if(focusedItem&&focusedItem.isChild){ev.preventDefault();focusedIndex=this.items.findIndex((item)=>item.isParent&&item.searchItemId===focusedItem.searchItemId);}else if(focusedItem&&focusedItem.isFieldProperty){ev.preventDefault();focusedIndex=this.items.findIndex((item)=>item.isParent&&item.searchItemId===focusedItem.propertyItemId);}else if(ev.target.selectionStart===0){this.focusFacet();}else{}
break;case"ArrowRight":if(ev.target.selectionStart===this.state.query.length){if(focusedItem&&focusedItem.isParent){ev.preventDefault();if(focusedItem.isExpanded){focusedIndex=this.state.focusedIndex+1;}else if(!ev.repeat){this.toggleItem(focusedItem,true);}}else if(ev.target.selectionStart===this.state.query.length){this.focusFacet(0);}}
break;case"Backspace":if(!this.state.query.length){const facets=this.env.searchModel.facets;if(facets.length){this.removeFacet(facets[facets.length-1]);}}
break;case"Enter":if(!this.state.query.length){this.env.searchModel.search();break;}else if(focusedItem){ev.preventDefault();this.selectItem(focusedItem);}
break;case"Tab":if(this.state.query.length&&focusedItem){ev.preventDefault();this.selectItem(focusedItem);}
break;case"Escape":this.resetState();break;}
if(focusedIndex!==undefined){this.state.focusedIndex=focusedIndex;}}
onSearchClick(){if(!hasTouch()&&!this.inputRef.el.value.length){this.searchBarDropdownState.open();}}
onSearchInput(ev){if(!hasTouch()){this.searchBarDropdownState.close();}
const query=ev.target.value;if(query.trim()){this.computeState({query,expanded:[],focusedIndex:0,subItems:[]});}else if(this.items.length){this.resetState();}}
onClickSearchIcon(){const focusedItem=this.items[this.state.focusedIndex];if(!this.state.query.length){this.env.searchModel.search();}else if(focusedItem){this.selectItem(focusedItem);}}
onToggleSearchBar(){this.state.showSearchBar=!this.state.showSearchBar;}
onWindowClick(ev){if(this.items.length&&!this.root.el.contains(ev.target)){this.resetState({focus:false});}}
onWindowKeydown(ev){if(this.items.length&&ev.key==="Escape"){this.resetState();}}}
return __exports;});;

/* /web/static/src/search/search_bar/search_bar_toggler.js */
odoo.define('@web/search/search_bar/search_bar_toggler',['@odoo/owl','@web/core/browser/browser','@web/core/utils/hooks','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{Component,useEffect,useState}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{useService}=require("@web/core/utils/hooks");const{useDebounced}=require("@web/core/utils/timing");const SearchBarToggler=__exports.SearchBarToggler=class SearchBarToggler extends Component{static template="web.SearchBar.Toggler";static props={isSmall:Boolean,showSearchBar:Boolean,toggleSearchBar:Function,};}
__exports.useSearchBarToggler=useSearchBarToggler;function useSearchBarToggler(){const ui=useService("ui");let isToggled=false;const state=useState({isSmall:ui.isSmall,showSearchBar:false,});const updateState=()=>{state.isSmall=ui.isSmall;state.showSearchBar=!ui.isSmall||isToggled;};updateState();function toggleSearchBar(){isToggled=!isToggled;updateState();}
const onResize=useDebounced(updateState,200);useEffect(()=>{browser.addEventListener("resize",onResize);return()=>browser.removeEventListener("resize",onResize);},()=>[]);return{state,component:SearchBarToggler,get props(){return{isSmall:state.isSmall,showSearchBar:state.showSearchBar,toggleSearchBar,};},};}
return __exports;});;

/* /web/static/src/search/search_bar_menu/search_bar_menu.js */
odoo.define('@web/search/search_bar_menu/search_bar_menu',['@odoo/owl','@web/core/confirmation_dialog/confirmation_dialog','@web/core/dropdown/dropdown','@web/search/properties_group_by_item/properties_group_by_item','@web/core/dropdown/dropdown_item','@web/core/registry','@web/core/utils/arrays','@web/core/utils/hooks','@web/core/dropdown/accordion_item','@web/search/custom_group_by_item/custom_group_by_item','@web/core/dropdown/checkbox_item','@web/search/utils/misc','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{Dropdown}=require("@web/core/dropdown/dropdown");const{PropertiesGroupByItem}=require("@web/search/properties_group_by_item/properties_group_by_item");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{registry}=require("@web/core/registry");const{sortBy}=require("@web/core/utils/arrays");const{useBus,useService}=require("@web/core/utils/hooks");const{AccordionItem}=require("@web/core/dropdown/accordion_item");const{CustomGroupByItem}=require("@web/search/custom_group_by_item/custom_group_by_item");const{CheckboxItem}=require("@web/core/dropdown/checkbox_item");const{FACET_ICONS,GROUPABLE_TYPES}=require("@web/search/utils/misc");const{_t}=require("@web/core/l10n/translation");const favoriteMenuRegistry=registry.category("favoriteMenu");const SearchBarMenu=__exports.SearchBarMenu=class SearchBarMenu extends Component{static template="web.SearchBarMenu";static components={Dropdown,DropdownItem,CheckboxItem,CustomGroupByItem,AccordionItem,PropertiesGroupByItem,};static props={slots:{type:Object,optional:true,shape:{default:{optional:true},},},dropdownState:{type:Object,optional:true,shape:{isOpen:Boolean,open:Function,close:Function,},},};setup(){this.facet_icons=FACET_ICONS;this.dialogService=useService("dialog");const fields=[];for(const[fieldName,field]of Object.entries(this.env.searchModel.searchViewFields)){if(this.validateField(fieldName,field)){fields.push(Object.assign({name:fieldName},field));}}
this.fields=sortBy(fields,"string");useBus(this.env.searchModel,"update",this.render);}
get filterItems(){return this.env.searchModel.getSearchItems((searchItem)=>["filter","dateFilter"].includes(searchItem.type));}
async onAddCustomFilterClick(){this.env.searchModel.spawnCustomFilterDialog();}
onFilterSelected({itemId,optionId}){if(optionId){this.env.searchModel.toggleDateFilter(itemId,optionId);}else{this.env.searchModel.toggleSearchItem(itemId);}}
get hideCustomGroupBy(){return this.env.searchModel.hideCustomGroupBy||false;}
get groupByItems(){return this.env.searchModel.getSearchItems((searchItem)=>["groupBy","dateGroupBy"].includes(searchItem.type)&&!searchItem.isProperty);}
validateField(fieldName,field){const{groupable,type}=field;return groupable&&fieldName!=="id"&&GROUPABLE_TYPES.includes(type);}
onGroupBySelected({itemId,optionId}){if(optionId){this.env.searchModel.toggleDateGroupBy(itemId,optionId);}else{this.env.searchModel.toggleSearchItem(itemId);}}
onAddCustomGroup(fieldName){this.env.searchModel.createNewGroupBy(fieldName);}
get showComparisonMenu(){return(this.env.searchModel.searchMenuTypes.has("comparison")&&this.env.searchModel.getSearchItems((i)=>i.type==="comparison").length>0);}
get comparisonItems(){return this.env.searchModel.getSearchItems((searchItem)=>searchItem.type==="comparison");}
onComparisonSelected(itemId){this.env.searchModel.toggleSearchItem(itemId);}
get favorites(){return this.env.searchModel.getSearchItems((searchItem)=>searchItem.type==="favorite"&&searchItem.userId!==false);}
get sharedFavorites(){return this.env.searchModel.getSearchItems((searchItem)=>searchItem.type==="favorite"&&searchItem.userId===false);}
get otherItems(){const registryMenus=[];for(const item of favoriteMenuRegistry.getAll()){if("isDisplayed"in item?item.isDisplayed(this.env):true){registryMenus.push({Component:item.Component,groupNumber:item.groupNumber,key:item.Component.name,});}}
return registryMenus;}
onFavoriteSelected(itemId){this.env.searchModel.toggleSearchItem(itemId);}
openConfirmationDialog(itemId,userId){const dialogProps={title:_t("Warning"),body:userId?_t("Are you sure that you want to remove this filter?"):_t("This filter is global and will be removed for everyone."),confirmLabel:_t("Delete Filter"),confirm:()=>this.env.searchModel.deleteFavorite(itemId),cancel:()=>{},};this.dialogService.add(ConfirmationDialog,dialogProps);}}
return __exports;});;

/* /web/static/src/search/search_model.js */
odoo.define('@web/search/search_model',['@web/core/context','@web/core/domain','@web/core/py_js/py','@web/core/user','@web/core/utils/arrays','@web/core/utils/objects','@web/search/search_arch_parser','@web/search/utils/dates','@web/search/utils/misc','@odoo/owl','@web/core/tree_editor/condition_tree','@web/core/l10n/translation','@web/core/tree_editor/utils','@web/core/domain_selector_dialog/domain_selector_dialog','@web/core/domain_selector/utils'],function(require){'use strict';let __exports={};const{makeContext}=require("@web/core/context");const{Domain}=require("@web/core/domain");const{evaluateExpr}=require("@web/core/py_js/py");const{user}=require("@web/core/user");const{sortBy,groupBy}=require("@web/core/utils/arrays");const{deepCopy}=require("@web/core/utils/objects");const{SearchArchParser}=require("@web/search/search_arch_parser");const{constructDateDomain,DEFAULT_INTERVAL,getComparisonOptions,getIntervalOptions,getPeriodOptions,rankInterval,yearSelected,}=require("@web/search/utils/dates");const{FACET_ICONS,FACET_COLORS}=require("@web/search/utils/misc");const{EventBus,toRaw}=require("@odoo/owl");const{domainFromTree,treeFromDomain}=require("@web/core/tree_editor/condition_tree");const{_t}=require("@web/core/l10n/translation");const{useGetTreeDescription,useMakeGetFieldDef}=require("@web/core/tree_editor/utils");const{DomainSelectorDialog}=require("@web/core/domain_selector_dialog/domain_selector_dialog");const{getDefaultDomain}=require("@web/core/domain_selector/utils");const{DateTime}=luxon;function hasValues(section){const{errorMsg,type,values}=section;if(errorMsg){return true;}
switch(type){case"category":{return values&&values.size>1;}
case"filter":{return values&&values.size>0;}}}
function mapToArray(map){const result=[];for(const[key,val]of map){const valCopy=Object.assign({},val);result.push([key,valCopy]);}
return result;}
function arraytoMap(array){return new Map(array);}
function execute(op,source,target){const{query,nextId,nextGroupId,nextGroupNumber,searchItems,searchPanelInfo,sections}=source;target.nextGroupId=nextGroupId;target.nextGroupNumber=nextGroupNumber;target.nextId=nextId;target.query=query;target.searchItems=searchItems;target.searchPanelInfo=searchPanelInfo;target.sections=op(sections);for(const[,section]of target.sections){section.values=op(section.values);if(section.groups){section.groups=op(section.groups);for(const[,group]of section.groups){group.values=op(group.values);}}}}
const FAVORITE_PRIVATE_GROUP=1;const FAVORITE_SHARED_GROUP=2;const SearchModel=__exports.SearchModel=class SearchModel extends EventBus{constructor(env,services,args){super();this.env=env;this.setup(services,args);}
setup(services){const{field:fieldService,name:nameService,orm,view,dialog}=services;this.orm=orm;this.fieldService=fieldService;this.viewService=view;this.dialog=dialog;this.orderByCount=false;this.getDomainTreeDescription=useGetTreeDescription(fieldService,nameService);this.makeGetFieldDef=useMakeGetFieldDef(fieldService);this.referenceMoment=DateTime.local();this.comparisonOptions=getComparisonOptions();this.intervalOptions=getIntervalOptions();}
async load(config){const{resModel}=config;if(!resModel){throw Error(`SearchPanel config should have a "resModel" key`);}
this.resModel=resModel;this._reset();const{comparison,context,domain,groupBy,hideCustomGroupBy,orderBy}=config;this.globalComparison=comparison;this.globalContext=toRaw(Object.assign({},context));this.globalDomain=domain||[];this.globalGroupBy=groupBy||[];this.globalOrderBy=orderBy||[];this.hideCustomGroupBy=hideCustomGroupBy;this.searchMenuTypes=new Set(config.searchMenuTypes||["filter","groupBy","favorite"]);this.canOrderByCount=config.canOrderByCount;let{irFilters,loadIrFilters,searchViewArch,searchViewFields,searchViewId}=config;const loadSearchView=searchViewId!==undefined&&(!searchViewArch||!searchViewFields||(!irFilters&&loadIrFilters));const searchViewDescription={};if(loadSearchView){const result=await this.viewService.loadViews({context:this.globalContext,resModel,views:[[searchViewId,"search"]],},{actionId:this.env.config.actionId,embeddedActionId:this.env.config.currentEmbeddedActionId,loadIrFilters:loadIrFilters||false,});Object.assign(searchViewDescription,result.views.search);searchViewFields=searchViewFields||result.fields;}
if(searchViewArch){searchViewDescription.arch=searchViewArch;}
if(irFilters){searchViewDescription.irFilters=irFilters;}
if(searchViewId!==undefined){searchViewDescription.viewId=searchViewId;}
this.searchViewArch=searchViewDescription.arch||"<search/>";this.searchViewFields=searchViewFields||{};if(searchViewDescription.irFilters){this.irFilters=searchViewDescription.irFilters;}
if(searchViewDescription.viewId!==undefined){this.searchViewId=searchViewDescription.viewId;}
const{searchDefaults,searchPanelDefaults}=this._extractSearchDefaultsFromGlobalContext();if(config.state){this._importState(config.state);this.__legacyParseSearchPanelArchAnyway(searchViewDescription,searchViewFields);this.display=this._getDisplay(config.display);if(!this.searchPanelInfo.loaded){return this._reloadSections();}
return;}
this.blockNotification=true;this.searchItems={};this.query=[];this.nextId=1;this.nextGroupId=1;this.nextGroupNumber=1;const parser=new SearchArchParser(searchViewDescription,searchViewFields,searchDefaults,searchPanelDefaults);const{labels,preSearchItems,searchPanelInfo,sections}=parser.parse();this.searchPanelInfo={...searchPanelInfo,loaded:false,shouldReload:false};await Promise.all(labels.map((cb)=>cb(this.orm)));for(const preGroup of preSearchItems||[]){this._createGroupOfSearchItems(preGroup);}
this.nextGroupNumber=1+Math.max(...Object.values(this.searchItems).map((i)=>i.groupNumber||0),0);const dateFilters=Object.values(this.searchItems).filter((searchElement)=>searchElement.type==="dateFilter");if(dateFilters.length){this._createGroupOfComparisons(dateFilters);}
const{dynamicFilters}=config;if(dynamicFilters){this._createGroupOfDynamicFilters(dynamicFilters);}
const defaultFavoriteId=this._createGroupOfFavorites(this.irFilters||[]);const activateFavorite="activateFavorite"in config?config.activateFavorite:true;this._activateDefaultSearchItems(activateFavorite?defaultFavoriteId:null);this.sections=new Map(sections||[]);this.display=this._getDisplay(config.display);if(this.display.searchPanel){this.searchDomain=this._getDomain({withSearchPanel:false});this.sectionsPromise=this._fetchSections(this.categories,this.filters).then(()=>{for(const{fieldName,values}of this.filters){const filterDefaults=searchPanelDefaults[fieldName]||[];for(const valueId of filterDefaults){const value=values.get(valueId);if(value){value.checked=true;}}}});if(Object.keys(searchPanelDefaults).length||this._shouldWaitForData(false)){await this.sectionsPromise;}}
this.blockNotification=false;}
async reload(config={}){this._reset();const{comparison,context,domain,groupBy,orderBy}=config;this.globalContext=Object.assign({},context);this.globalDomain=domain||[];this.globalComparison=comparison;this.globalGroupBy=groupBy||[];this.globalOrderBy=orderBy||[];this._extractSearchDefaultsFromGlobalContext();await this._reloadSections();}
get categories(){return[...this.sections.values()].filter((s)=>s.type==="category");}
get context(){if(!this._context){this._context=makeContext([this.globalContext,this._getContext()]);}
return deepCopy(this._context);}
get domain(){if(!this._domain){this._domain=this._getDomain();}
return deepCopy(this._domain);}
get domainString(){return this._getDomain({raw:true}).toString();}
get domainEvalContext(){return Object.assign({},this.globalContext,user.context);}
get comparison(){if(!this.searchMenuTypes.has("comparison")){return null;}
if(this._comparison===undefined){if(this.globalComparison){this._comparison=this.globalComparison;}else{const comparison=this.getFullComparison();if(comparison){const{fieldName,range,rangeDescription,comparisonRange,comparisonRangeDescription,}=comparison;const domains=[{arrayRepr:Domain.and([this.domain,range]).toList(),description:rangeDescription,},{arrayRepr:Domain.and([this.domain,comparisonRange]).toList(),description:comparisonRangeDescription,},];this._comparison={domains,fieldName};}else{this._comparison=null;}}}
return deepCopy(this._comparison);}
get facets(){const isValidType=(type)=>!["groupBy","comparison"].includes(type)||this.searchMenuTypes.has(type);const facets=[];for(const facet of this._getFacets()){if(!isValidType(facet.type)){continue;}
facets.push(facet);}
return facets;}
get filters(){return[...this.sections.values()].filter((s)=>s.type==="filter");}
get groupBy(){if(!this.searchMenuTypes.has("groupBy")){return[];}
if(!this._groupBy){this._groupBy=this._getGroupBy();}
return deepCopy(this._groupBy);}
get orderBy(){if(!this._orderBy){this._orderBy=this._getOrderBy();}
return deepCopy(this._orderBy);}
get isDebugMode(){return!!this.env.debug;}
addAutoCompletionValues(searchItemId,autocompleteValue){const searchItem=this.searchItems[searchItemId];if(!["field","field_property"].includes(searchItem.type)){return;}
const{label,value,operator}=autocompleteValue;const queryElem=this.query.find((queryElem)=>queryElem.searchItemId===searchItemId&&"autocompleteValue"in queryElem&&queryElem.autocompleteValue.value===value&&queryElem.autocompleteValue.operator===operator);if(!queryElem){this.query.push({searchItemId,autocompleteValue});}else{queryElem.autocompleteValue.label=label;}
this._notify();}
clearQuery(){this.query=[];this.orderByCount=false;this._notify();}
async createNewFavorite(params){const{preFavorite,irFilter}=this._getIrFilterDescription(params);const serverSideId=await this._createIrFilters(irFilter);this.blockNotification=true;this.clearQuery();const favorite={...preFavorite,type:"favorite",id:this.nextId,groupId:this.nextGroupId,groupNumber:preFavorite.userId?FAVORITE_PRIVATE_GROUP:FAVORITE_SHARED_GROUP,removable:true,serverSideId,};this.searchItems[this.nextId]=favorite;this.query.push({searchItemId:this.nextId});this.nextGroupId++;this.nextId++;this.blockNotification=false;this._notify();}
async _createIrFilters(irFilter){const serverSideId=await this.orm.call("ir.filters","create_or_replace",[irFilter]);this.env.bus.trigger("CLEAR-CACHES");return serverSideId;}
createNewFilters(prefilters){if(!prefilters.length){return[];}
prefilters.forEach((preFilter)=>{const filter=Object.assign(preFilter,{groupId:this.nextGroupId,groupNumber:this.nextGroupNumber,id:this.nextId,type:"filter",});this.searchItems[this.nextId]=filter;this.query.push({searchItemId:this.nextId});this.nextId++;});this.nextGroupId++;this.nextGroupNumber++;this._notify();}
createNewGroupBy(fieldName,{interval,invisible}={}){const field=this.searchViewFields[fieldName];const{string,type:fieldType}=field;const firstGroupBy=Object.values(this.searchItems).find((f)=>f.type==="groupBy");const preSearchItem={description:string||fieldName,fieldName,fieldType,groupId:firstGroupBy?firstGroupBy.groupId:this.nextGroupId++,groupNumber:this.nextGroupNumber,id:this.nextId,custom:true,};if(invisible){preSearchItem.invisible="True";}
if(["date","datetime"].includes(fieldType)){this.searchItems[this.nextId]=Object.assign({type:"dateGroupBy",defaultIntervalId:interval||DEFAULT_INTERVAL},preSearchItem);this.toggleDateGroupBy(this.nextId);}else{this.searchItems[this.nextId]=Object.assign({type:"groupBy"},preSearchItem);this.toggleSearchItem(this.nextId);}
this.nextGroupNumber++;this.nextId++;this._notify();}
deactivateGroup(groupId){this.query=this.query.filter((queryElem)=>{const searchItem=this.searchItems[queryElem.searchItemId];return searchItem.groupId!==groupId;});this._checkComparisonStatus();this._checkOrderByCountStatus();this._notify();}
async deleteFavorite(favoriteId){const searchItem=this.searchItems[favoriteId];if(searchItem.type!=="favorite"){return;}
await this._deleteIrFilters(searchItem);const index=this.query.findIndex((queryElem)=>queryElem.searchItemId===favoriteId);delete this.searchItems[favoriteId];if(index>=0){this.query.splice(index,1);}
this._notify();}
async _deleteIrFilters(searchItem){const{serverSideId}=searchItem;await this.orm.unlink("ir.filters",[serverSideId]);this.env.bus.trigger("CLEAR-CACHES");}
exportState(){const state={};execute(mapToArray,this,state);return state;}
getFullComparison(){let searchItem=null;for(const queryElem of this.query.slice().reverse()){const item=this.searchItems[queryElem.searchItemId];if(item.type==="comparison"){searchItem=item;break;}else if(item.type==="favorite"&&item.comparison){searchItem=item;break;}}
if(!searchItem){return null;}else if(searchItem.type==="favorite"){return searchItem.comparison;}
const{dateFilterId,comparisonOptionId}=searchItem;const dateFilter=this.searchItems[dateFilterId];const{fieldName,description:dateFilterDescription}=dateFilter;const selectedGeneratorIds=this._getSelectedGeneratorIds(dateFilterId);const{domain:range,description:rangeDescription}=constructDateDomain(this.referenceMoment,dateFilter,selectedGeneratorIds);const{domain:comparisonRange,description:comparisonRangeDescription}=constructDateDomain(this.referenceMoment,dateFilter,selectedGeneratorIds,comparisonOptionId);return{comparisonId:comparisonOptionId,fieldName,fieldDescription:dateFilterDescription,range:range.toList(),rangeDescription,comparisonRange:comparisonRange.toList(),comparisonRangeDescription,};}
getIrFilterValues(params){const{irFilter}=this._getIrFilterDescription(params);return irFilter;}
getPreFavoriteValues(params){const{preFavorite}=this._getIrFilterDescription(params);return preFavorite;}
getSearchItems(predicate){const searchItems=[];for(const searchItem of Object.values(this.searchItems)){const enrichedSearchitem=this._enrichItem(searchItem);if(enrichedSearchitem){const isInvisible="invisible"in searchItem&&evaluateExpr(searchItem.invisible,this.globalContext);if(!isInvisible&&(!predicate||predicate(enrichedSearchitem))){searchItems.push(enrichedSearchitem);}}}
if(searchItems.some((f)=>f.type==="favorite")){searchItems.sort((f1,f2)=>f1.groupNumber-f2.groupNumber);}
return searchItems;}
getSections(predicate){let sections=[...this.sections.values()].map((section)=>Object.assign({},section,{empty:!hasValues(section)}));if(predicate){sections=sections.filter(predicate);}
return sections.sort((s1,s2)=>s1.index-s2.index);}
search(){this.trigger("update");}
async splitAndAddDomain(domain,groupId){const group=groupId?this._getGroups().find((g)=>g.id===groupId):null;let context;if(group){const contexts=[];for(const activeItem of group.activeItems){const context=this._getSearchItemContext(activeItem);if(context){contexts.push(context);}}
context=makeContext(contexts);}
const getFieldDef=await this.makeGetFieldDef(this.resModel,treeFromDomain(domain));const tree=treeFromDomain(domain,{distributeNot:!this.isDebugMode,getFieldDef});const trees=!tree.negate&&tree.value==="&"?tree.children:[tree];const promises=trees.map(async(tree)=>{const description=await this.getDomainTreeDescription(this.resModel,tree);const preFilter={description,domain:domainFromTree(tree),invisible:"True",type:"filter",};if(context){preFilter.context=context;}
return preFilter;});const preFilters=await Promise.all(promises);this.blockNotification=true;if(group){const firstActiveItem=group.activeItems[0];const firstSearchItem=this.searchItems[firstActiveItem.searchItemId];const{type}=firstSearchItem;if(type==="favorite"){const activeItemGroupBys=this._getSearchItemGroupBys(firstActiveItem);for(const activeItemGroupBy of activeItemGroupBys){const[fieldName,interval]=activeItemGroupBy.split(":");this.createNewGroupBy(fieldName,{interval,invisible:true});}
const index=this.query.length-activeItemGroupBys.length;this.query=[...this.query.slice(index),...this.query.slice(0,index)];}
this.deactivateGroup(groupId);}
for(const preFilter of preFilters){this.createNewFilters([preFilter]);}
this.blockNotification=false;this._notify();}
toggleCategoryValue(sectionId,valueId){const category=this.sections.get(sectionId);category.activeValueId=valueId;this._notify();}
toggleFilterValues(sectionId,valueIds,forceTo=null){const filter=this.sections.get(sectionId);for(const valueId of valueIds){const value=filter.values.get(valueId);value.checked=forceTo===null?!value.checked:forceTo;}
this._notify();}
clearSections(sectionIds){for(const sectionId of sectionIds){const section=this.sections.get(sectionId);if(section.type==="category"){section.activeValueId=false;}else{for(const[,value]of section.values){value.checked=false;}}}
this._notify();}
toggleSearchItem(searchItemId){const searchItem=this.searchItems[searchItemId];switch(searchItem.type){case"dateFilter":case"dateGroupBy":case"field_property":case"field":{return;}}
const index=this.query.findIndex((queryElem)=>queryElem.searchItemId===searchItemId);if(index>=0){this.query.splice(index,1);this._checkOrderByCountStatus();}else{if(searchItem.type==="favorite"){this.query=[];}else if(searchItem.type==="comparison"){this.query=this.query.filter((queryElem)=>{const{type}=this.searchItems[queryElem.searchItemId];return type!=="comparison";});}
this.query.push({searchItemId});}
this._notify();}
toggleDateFilter(searchItemId,generatorId){const searchItem=this.searchItems[searchItemId];if(searchItem.type!=="dateFilter"){return;}
const generatorIds=generatorId?[generatorId]:searchItem.defaultGeneratorIds;for(const generatorId of generatorIds){const index=this.query.findIndex((queryElem)=>queryElem.searchItemId===searchItemId&&"generatorId"in queryElem&&queryElem.generatorId===generatorId);if(index>=0){this.query.splice(index,1);if(!yearSelected(this._getSelectedGeneratorIds(searchItemId))){this.query=this.query.filter((queryElem)=>queryElem.searchItemId!==searchItemId);}}else{if(generatorId.startsWith("custom")){const comparisonId=this._getActiveComparison()?.id;this.query=this.query.filter((queryElem)=>![searchItemId,comparisonId].includes(queryElem.searchItemId));this.query.push({searchItemId,generatorId});continue;}
this.query=this.query.filter((queryElem)=>queryElem.searchItemId!==searchItemId||!queryElem.generatorId.startsWith("custom"));this.query.push({searchItemId,generatorId});if(!yearSelected(this._getSelectedGeneratorIds(searchItemId))){const{defaultYearId}=getPeriodOptions(this.referenceMoment,searchItem.optionsParams).find((o)=>o.id===generatorId);this.query.push({searchItemId,generatorId:defaultYearId});}}}
this._checkComparisonStatus();this._notify();}
toggleDateGroupBy(searchItemId,intervalId){const searchItem=this.searchItems[searchItemId];if(searchItem.type!=="dateGroupBy"){return;}
intervalId=intervalId||searchItem.defaultIntervalId;const index=this.query.findIndex((queryElem)=>queryElem.searchItemId===searchItemId&&"intervalId"in queryElem&&queryElem.intervalId===intervalId);if(index>=0){this.query.splice(index,1);this._checkOrderByCountStatus();}else{this.query.push({searchItemId,intervalId});}
this._notify();}
async spawnCustomFilterDialog(){const domain=getDefaultDomain(this.searchViewFields);this.dialog.add(DomainSelectorDialog,{resModel:this.resModel,defaultConnector:"|",domain,context:this.domainEvalContext,onConfirm:(domain)=>this.splitAndAddDomain(domain),disableConfirmButton:(domain)=>domain===`[]`,title:_t("Add Custom Filter"),confirmButtonText:_t("Add"),discardButtonText:_t("Cancel"),isDebugMode:this.isDebugMode,});}
switchGroupBySort(){if(this.orderByCount==="Desc"){this.orderByCount="Asc";}else{this.orderByCount="Desc";}
this._notify();}
async getSearchItemsProperties(searchItem){if(searchItem.type!=="field"||searchItem.fieldType!=="properties"){return[];}
const field=this.searchViewFields[searchItem.fieldName];const definitionRecord=field.definition_record;const result=await this._fetchPropertiesDefinition(this.resModel,searchItem.fieldName);const searchItemIds=new Set();const existingFieldProperties={};for(const item of Object.values(this.searchItems)){if(item.type==="field_property"&&item.propertyItemId===searchItem.id){existingFieldProperties[item.propertyFieldDefinition.name]=item;}}
for(const{definitionRecordId,definitionRecordName,definitions}of result){for(const definition of definitions){if(definition.type==="separator"){continue;}
const existingSearchItem=existingFieldProperties[definition.name];if(existingSearchItem){existingSearchItem.description=`${definition.string} (${definitionRecordName})`;searchItemIds.add(existingSearchItem.id);continue;}
const id=this.nextId++;const newSearchItem={id,type:"field_property",fieldName:searchItem.fieldName,propertyDomain:[definitionRecord,"=",definitionRecordId],propertyFieldDefinition:definition,propertyItemId:searchItem.id,description:`${definition.string} (${definitionRecordName})`,groupId:this.nextGroupId++,};if(["many2many","tags"].includes(definition.type)){newSearchItem.operator="in";}
this.searchItems[id]=newSearchItem;searchItemIds.add(id);}}
return this.getSearchItems((searchItem)=>searchItemIds.has(searchItem.id));}
async fillSearchViewItemsProperty(){if(!this.searchViewFields){return;}
const fields=Object.values(this.searchViewFields);for(const field of fields){if(field.type!=="properties"){continue;}
const result=await this._fetchPropertiesDefinition(this.resModel,field.name);const searchItemsNames=Object.values(this.searchItems).filter((item)=>item.isProperty&&["groupBy","dateGroupBy"].includes(item.type)).map((item)=>item.fieldName);for(const{definitionRecordId,definitionRecordName,definitions}of result){const groupNames=definitions.map((definition)=>`group_by_${field.name}.${definition.name}`);Object.values(this.searchItems).forEach((searchItem)=>{if(searchItem.isProperty&&searchItem.definitionRecordId===definitionRecordId&&["groupBy","dateGroupBy"].includes(searchItem.type)&&!groupNames.includes(searchItem.name)){searchItem.type="group_by_property_deleted";}});for(const definition of definitions){const fullName=`${field.name}.${definition.name}`;this.searchViewFields[fullName]={name:fullName,readonly:false,relation:definition.comodel,required:false,searchable:false,selection:definition.selection,sortable:true,store:true,string:`${definition.string} (${definitionRecordName})`,type:definition.type,relatedPropertyField:field,};if(!searchItemsNames.includes(fullName)){const groupByItem={description:definition.string,definitionRecordId,definitionRecordName,fieldName:fullName,fieldType:definition.type,isProperty:true,name:`group_by_${field.name}.${definition.name}`,propertyFieldName:field.name,type:["datetime","date"].includes(definition.type)?"dateGroupBy":"groupBy",};this._createGroupOfSearchItems([groupByItem]);}}}}}
async _fetchPropertiesDefinition(resModel,fieldName){const domain=[];if(this.context.active_id){domain.push(["id","=",this.context.active_id]);}
const definitions=await this.fieldService.loadPropertyDefinitions(resModel,fieldName,domain);const result=groupBy(Object.values(definitions),(definition)=>definition.record_id);return Object.entries(result).map(([recordId,definitions])=>{return{definitionRecordId:parseInt(recordId),definitionRecordName:definitions[0]?.record_name,definitions,};});}
_activateDefaultSearchItems(defaultFavoriteId){if(defaultFavoriteId){this.toggleSearchItem(defaultFavoriteId);}else{Object.values(this.searchItems).filter((f)=>f.isDefault&&f.type!=="favorite").sort((f1,f2)=>(f1.defaultRank||100)-(f2.defaultRank||100)).forEach((f)=>{if(f.type==="dateFilter"){this.toggleDateFilter(f.id);}else if(f.type==="dateGroupBy"){this.toggleDateGroupBy(f.id);}else if(f.type==="field"){this.addAutoCompletionValues(f.id,f.defaultAutocompleteValue);}else{this.toggleSearchItem(f.id);}});}}
_checkComparisonStatus(){const activeComparison=this._getActiveComparison();if(!activeComparison){return;}
const{dateFilterId,id}=activeComparison;const dateFilterIsActive=this.query.some((queryElem)=>queryElem.searchItemId===dateFilterId);if(!dateFilterIsActive){this.query=this.query.filter((queryElem)=>queryElem.searchItemId!==id);}}
_checkOrderByCountStatus(){if(this.orderByCount&&!this.query.some((item)=>["dateGroupBy","groupBy"].includes(this.searchItems[item.searchItemId].type))){this.orderByCount=false;}}
_createCategoryTree(sectionId,result){const category=this.sections.get(sectionId);let{error_msg,parent_field:parentField,values}=result;if(error_msg){category.errorMsg=error_msg;values=[];}
if(category.hierarchize){category.parentField=parentField;}
for(const value of values){category.values.set(value.id,Object.assign({},value,{childrenIds:[],parentId:value[parentField]||false,}));}
for(const value of values){const{parentId}=category.values.get(value.id);if(parentId&&category.values.has(parentId)){category.values.get(parentId).childrenIds.push(value.id);}}
category.rootIds=[false];for(const value of values){const{parentId}=category.values.get(value.id);if(!parentId){category.rootIds.push(value.id);}}
const valueIds=[false,...values.map((val)=>val.id)];this._ensureCategoryValue(category,valueIds);}
_createFilterTree(sectionId,result){const filter=this.sections.get(sectionId);let{error_msg,values}=result;if(error_msg){filter.errorMsg=error_msg;values=[];}
values.forEach((value)=>{const oldValue=filter.values.get(value.id);value.checked=oldValue?oldValue.checked:false;});filter.values=new Map();const groupIds=[];if(filter.groupBy){const groups=new Map();for(const value of values){const groupId=value.group_id;if(!groups.has(groupId)){if(groupId){groupIds.push(groupId);}
groups.set(groupId,{id:groupId,name:value.group_name,values:new Map(),tooltip:value.group_tooltip,sequence:value.group_sequence,color_index:value.color_index,});const oldGroup=filter.groups&&filter.groups.get(groupId);groups.get(groupId).state=(oldGroup&&oldGroup.state)||false;}
groups.get(groupId).values.set(value.id,value);}
filter.groups=groups;filter.sortedGroupIds=sortBy(groupIds,(id)=>groups.get(id).sequence||groups.get(id).name);for(const group of filter.groups.values()){for(const[valueId,value]of group.values){filter.values.set(valueId,value);}}}else{for(const value of values){filter.values.set(value.id,value);}}}
_createGroupOfComparisons(dateFilters){const preSearchItem=[];for(const dateFilter of dateFilters){for(const comparisonOption of this.comparisonOptions){const{id:dateFilterId,description}=dateFilter;const preFilter={type:"comparison",comparisonOptionId:comparisonOption.id,description:`${description}: ${comparisonOption.description}`,dateFilterId,};preSearchItem.push(preFilter);}}
this._createGroupOfSearchItems(preSearchItem);}
_createGroupOfDynamicFilters(dynamicFilters){const pregroup=dynamicFilters.map((filter)=>{return{groupNumber:this.nextGroupNumber,description:filter.description,domain:filter.domain,isDefault:"is_default"in filter?filter.is_default:true,type:"filter",};});this.nextGroupNumber++;this._createGroupOfSearchItems(pregroup);}
_createGroupOfFavorites(irFilters){let defaultFavoriteId=null;irFilters.forEach((irFilter)=>{const favorite=this._irFilterToFavorite(irFilter);this._createGroupOfSearchItems([favorite]);if(favorite.isDefault){defaultFavoriteId=favorite.id;}});return defaultFavoriteId;}
_createGroupOfSearchItems(pregroup){pregroup.forEach((preSearchItem)=>{const searchItem=Object.assign(preSearchItem,{groupId:this.nextGroupId,id:this.nextId,});this.searchItems[this.nextId]=searchItem;this.nextId++;});this.nextGroupId++;}
_enrichItem(searchItem){if(searchItem.type==="field"&&searchItem.fieldType==="properties"){return{...searchItem};}
const queryElements=this.query.filter((queryElem)=>queryElem.searchItemId===searchItem.id);const isActive=Boolean(queryElements.length);const enrichSearchItem=Object.assign({isActive},searchItem);function _enrichOptions(options,selectedIds){return options.map((o)=>{const{description,id,groupNumber}=o;const isActive=selectedIds.some((optionId)=>optionId===id);return{description,id,groupNumber,isActive};});}
switch(searchItem.type){case"comparison":{const{dateFilterId}=searchItem;const dateFilterIsActive=this.query.some((queryElem)=>queryElem.searchItemId===dateFilterId&&!queryElem.generatorId.startsWith("custom"));if(!dateFilterIsActive){return null;}
break;}
case"dateFilter":enrichSearchItem.options=_enrichOptions(getPeriodOptions(this.referenceMoment,searchItem.optionsParams),queryElements.map((queryElem)=>queryElem.generatorId));break;case"dateGroupBy":enrichSearchItem.options=_enrichOptions(this.intervalOptions,queryElements.map((queryElem)=>queryElem.intervalId));break;case"field":case"field_property":enrichSearchItem.autocompleteValues=queryElements.map((queryElem)=>queryElem.autocompleteValue);break;}
return enrichSearchItem;}
_ensureCategoryValue(category,valueIds){if(!valueIds.includes(category.activeValueId)){category.activeValueId=valueIds[0];}}
_extractSearchDefaultsFromGlobalContext(){const searchDefaults={};const searchPanelDefaults={};for(const key in this.globalContext){const defaultValue=this.globalContext[key];const searchDefaultMatch=/^search_default_(.*)$/.exec(key);if(searchDefaultMatch){if(defaultValue){searchDefaults[searchDefaultMatch[1]]=defaultValue;}
delete this.globalContext[key];continue;}
const searchPanelDefaultMatch=/^searchpanel_default_(.*)$/.exec(key);if(searchPanelDefaultMatch){searchPanelDefaults[searchPanelDefaultMatch[1]]=defaultValue;delete this.globalContext[key];}}
return{searchDefaults,searchPanelDefaults};}
async _fetchCategories(categories){const filterDomain=this._getFilterDomain();const searchDomain=this.searchDomain;await Promise.all(categories.map(async(category)=>{const result=await this.orm.call(this.resModel,"search_panel_select_range",[category.fieldName],{category_domain:this._getCategoryDomain(category.id),context:this.globalContext,enable_counters:category.enableCounters,expand:category.expand,filter_domain:filterDomain,hierarchize:category.hierarchize,limit:category.limit,search_domain:searchDomain,});this._createCategoryTree(category.id,result);}));}
async _fetchFilters(filters){const evalContext={};for(const category of this.categories){evalContext[category.fieldName]=category.activeValueId;}
const categoryDomain=this._getCategoryDomain();const searchDomain=this.searchDomain;await Promise.all(filters.map(async(filter)=>{const result=await this.orm.call(this.resModel,"search_panel_select_multi_range",[filter.fieldName],{category_domain:categoryDomain,comodel_domain:new Domain(filter.domain).toList(evalContext),context:this.globalContext,enable_counters:filter.enableCounters,filter_domain:this._getFilterDomain(filter.id),expand:filter.expand,group_by:filter.groupBy||false,group_domain:this._getGroupDomain(filter),limit:filter.limit,search_domain:searchDomain,});this._createFilterTree(filter.id,result);}));}
async _fetchSections(categoriesToLoad,filtersToLoad){await this._fetchCategories(categoriesToLoad);await this._fetchFilters(filtersToLoad);this.searchPanelInfo.loaded=true;}
_getActiveComparison(){for(const queryElem of this.query){const searchItem=this.searchItems[queryElem.searchItemId];if(searchItem.type==="comparison"){return searchItem;}}
return null;}
_getCategoryDomain(excludedCategoryId){const domain=[];for(const category of this.categories){if(category.id===excludedCategoryId||!category.activeValueId){continue;}
const field=this.searchViewFields[category.fieldName];const operator=field.type==="many2one"&&category.parentField?"child_of":"=";domain.push([category.fieldName,operator,category.activeValueId]);}
return domain;}
_getContext(){const groups=this._getGroups();const contexts=[user.context];for(const group of groups){for(const activeItem of group.activeItems){const context=this._getSearchItemContext(activeItem);if(context){contexts.push(context);}}}
let context;try{context=makeContext(contexts);return context;}catch(error){throw new Error(_t("Failed to evaluate the context: %(context)s.\n%(error)s",{context,error:error.message,}));}}
_getDateFilterDomain(dateFilter,generatorIds,key="domain"){const dateFilterRange=constructDateDomain(this.referenceMoment,dateFilter,generatorIds);return dateFilterRange[key];}
_getDisplay(display={}){const{viewTypes}=this.searchPanelInfo;const{bannerRoute,viewType}=this.env.config;return{controlPanel:"controlPanel"in display?display.controlPanel:{},searchPanel:this.sections.size&&(!viewType||viewTypes.includes(viewType))&&("searchPanel"in display?display.searchPanel:true),banner:Boolean(bannerRoute),};}
_getDomain(params={}){const withSearchPanel="withSearchPanel"in params?params.withSearchPanel:true;const withGlobal="withGlobal"in params?params.withGlobal:true;const groups=this._getGroups();const domains=[];if(withGlobal){domains.push(this.globalDomain);}
for(const group of groups){const groupActiveItemDomains=[];for(const activeItem of group.activeItems){const domain=this._getSearchItemDomain(activeItem);if(domain){groupActiveItemDomains.push(domain);}}
const groupDomain=Domain.or(groupActiveItemDomains);domains.push(groupDomain);}
if(this.display.searchPanel&&withSearchPanel){domains.push(this._getSearchPanelDomain());}
let domain;try{domain=Domain.and(domains);return params.raw?domain:domain.toList(this.domainEvalContext);}catch(error){throw new Error(_t("Failed to evaluate the domain: %(domain)s.\n%(error)s",{domain:domain.toString(),error:error.message,}));}}
_getFacets(){const facets=[];const groups=this._getGroups();for(const group of groups){const groupActiveItemDomains=[];const values=[];let title;let type;for(const activeItem of group.activeItems){const domain=this._getSearchItemDomain(activeItem,{withDateFilterDomain:true,});if(domain){groupActiveItemDomains.push(domain);}
const searchItem=this.searchItems[activeItem.searchItemId];switch(searchItem.type){case"field_property":case"field":{type="field";title=searchItem.description;for(const autocompleteValue of activeItem.autocompletValues){values.push(autocompleteValue.label);}
break;}
case"groupBy":{type="groupBy";values.push(searchItem.description);break;}
case"dateGroupBy":{type="groupBy";for(const intervalId of activeItem.intervalIds){const option=this.intervalOptions.find((o)=>o.id===intervalId);values.push(`${searchItem.description}: ${option.description}`);}
break;}
case"dateFilter":{type="filter";const periodDescription=this._getDateFilterDomain(searchItem,activeItem.generatorIds,"description");values.push(`${searchItem.description}: ${periodDescription}`);break;}
default:{type=searchItem.type;values.push(searchItem.description);}}}
const facet={groupId:group.id,type,values,separator:type==="groupBy"?">":_t("or"),};if(type==="field"){facet.title=title;}else{if(type==="groupBy"&&this.orderByCount){facet.icon=FACET_ICONS[this.orderByCount==="Asc"?"groupByAsc":"groupByDesc"];}else{facet.icon=FACET_ICONS[type];}
facet.color=FACET_COLORS[type];}
if(groupActiveItemDomains.length){facet.domain=Domain.or(groupActiveItemDomains).toString();}
facets.push(facet);}
return facets;}
_getFieldDomain(field,autocompleteValues){const domains=autocompleteValues.map(({label,value,operator,enforceEqual})=>{let domain;if(field.filterDomain){let filterDomain=field.filterDomain;if(enforceEqual){filterDomain=field.filterDomain.replaceAll("'ilike'","'='").replaceAll('"ilike"','"="');}
domain=new Domain(filterDomain).toList({self:label.trim(),raw_value:value,});}else if(field.type==="field"){domain=[[field.fieldName,operator,value]];}else if(field.type==="field_property"){domain=[field.propertyDomain,[`${field.fieldName}.${field.propertyFieldDefinition.name}`,operator,value],];}
return new Domain(domain);});return Domain.or(domains);}
_getFilterDomain(excludedFilterId){const domain=[];function addCondition(fieldName,valueMap){const ids=[];for(const[valueId,value]of valueMap){if(value.checked){ids.push(valueId);}}
if(ids.length){domain.push([fieldName,"in",ids]);}}
for(const filter of this.filters){if(filter.id===excludedFilterId){continue;}
const{fieldName,groups,values}=filter;if(groups){for(const group of groups.values()){addCondition(fieldName,group.values);}}else{addCondition(fieldName,values);}}
return domain;}
_getGroupBy(){const groups=this._getGroups();const groupBys=[];for(const group of groups){for(const activeItem of group.activeItems){const activeItemGroupBys=this._getSearchItemGroupBys(activeItem);if(activeItemGroupBys){groupBys.push(...activeItemGroupBys);}}}
const groupBy=groupBys.length?groupBys:this.globalGroupBy.slice();return typeof groupBy==="string"?[groupBy]:groupBy;}
_getGroupDomain(filter){const{fieldName,groups,enableCounters}=filter;const{type:fieldType}=this.searchViewFields[fieldName];if(!enableCounters||!groups){return{many2one:[],many2many:{},}[fieldType];}
let groupDomain=null;if(fieldType==="many2one"){for(const group of groups.values()){const valueIds=[];let active=false;for(const[valueId,value]of group.values){const{checked}=value;valueIds.push(valueId);if(checked){active=true;}}
if(active){if(groupDomain){groupDomain=[[0,"=",1]];break;}else{groupDomain=[[fieldName,"in",valueIds]];}}}}else if(fieldType==="many2many"){const checkedValueIds=new Map();groups.forEach(({values},groupId)=>{values.forEach(({checked},valueId)=>{if(checked){if(!checkedValueIds.has(groupId)){checkedValueIds.set(groupId,[]);}
checkedValueIds.get(groupId).push(valueId);}});});groupDomain={};for(const[gId,ids]of checkedValueIds.entries()){for(const groupId of groups.keys()){if(gId!==groupId){const key=JSON.stringify(groupId);if(!groupDomain[key]){groupDomain[key]=[];}
groupDomain[key].push([fieldName,"in",ids]);}}}}
return groupDomain;}
_getGroups(){const preGroups=[];for(const queryElem of this.query){const{searchItemId}=queryElem;const{groupId}=this.searchItems[searchItemId];let preGroup=preGroups.find((group)=>group.id===groupId);if(!preGroup){preGroup={id:groupId,queryElements:[]};preGroups.push(preGroup);}
preGroup.queryElements.push(queryElem);}
const groups=[];for(const preGroup of preGroups){const{queryElements,id}=preGroup;const activeItems=[];for(const queryElem of queryElements){const{searchItemId}=queryElem;let activeItem=activeItems.find(({searchItemId:id})=>id===searchItemId);if("generatorId"in queryElem){if(!activeItem){activeItem={searchItemId,generatorIds:[]};activeItems.push(activeItem);}
activeItem.generatorIds.push(queryElem.generatorId);}else if("intervalId"in queryElem){if(!activeItem){activeItem={searchItemId,intervalIds:[]};activeItems.push(activeItem);}
activeItem.intervalIds.push(queryElem.intervalId);}else if("autocompleteValue"in queryElem){if(!activeItem){activeItem={searchItemId,autocompletValues:[]};activeItems.push(activeItem);}
activeItem.autocompletValues.push(queryElem.autocompleteValue);}else{if(!activeItem){activeItem={searchItemId};activeItems.push(activeItem);}}}
for(const activeItem of activeItems){if("intervalIds"in activeItem){activeItem.intervalIds.sort((g1,g2)=>rankInterval(g1)-rankInterval(g2));}}
groups.push({id,activeItems});}
return groups;}
_getIrFilterDescription(params={}){const{description,isDefault,isShared,embeddedActionId}=params;const fns=this.env.__getContext__.callbacks;const localContext=Object.assign({},...fns.map((fn)=>fn()));const gs=this.env.__getOrderBy__.callbacks;let localOrderBy;if(gs.length){localOrderBy=gs.flatMap((g)=>g());}
const context=makeContext([this._getContext(),localContext]);const userContext=user.context;for(const key in context){if(key in userContext||/^search(panel)?_default_/.test(key)){delete context[key];}}
const domain=this._getDomain({raw:true,withGlobal:false}).toString();const groupBys=this._getGroupBy();const comparison=this.getFullComparison();const orderBy=localOrderBy||this._getOrderBy();const userId=isShared?false:user.userId;const preFavorite={description,isDefault,domain,context,groupBys,orderBy,userId,};const irFilter={name:description,action_id:this.env.config.actionId,model_id:this.resModel,domain,embedded_action_id:embeddedActionId,embedded_parent_res_id:this.globalContext.active_id||false,is_default:isDefault,sort:JSON.stringify(orderBy.map((o)=>`${o.name}${o.asc === false ? " desc" : ""}`)),user_id:userId,context:{group_by:groupBys,...context},};if(comparison){preFavorite.comparison=comparison;irFilter.context.comparison=comparison;}
return{preFavorite,irFilter};}
_getOrderBy(){const groups=this._getGroups();const orderBy=[];if(this.groupBy.length&&this.orderByCount){orderBy.push({name:"__count",asc:this.orderByCount==="Asc"});}
for(const group of groups){for(const activeItem of group.activeItems){const{searchItemId}=activeItem;const searchItem=this.searchItems[searchItemId];if(searchItem.type==="favorite"){orderBy.push(...searchItem.orderBy);}}}
return orderBy.length?orderBy:this.globalOrderBy;}
_getSearchItemContext(activeItem){const{searchItemId}=activeItem;const searchItem=this.searchItems[searchItemId];switch(searchItem.type){case"field":{let context={};if(searchItem.context){try{const self=activeItem.autocompletValues.map((autocompleValue)=>autocompleValue.value);context=evaluateExpr(searchItem.context,{self});if(typeof context!=="object"){throw Error();}}catch(error){throw new Error(_t("Failed to evaluate the context: %(context)s.\n%(error)s",{context:searchItem.context,error:error.message,}));}}
if(searchItem.isDefault&&searchItem.fieldType==="many2one"){context[`default_${searchItem.fieldName}`]=searchItem.defaultAutocompleteValue.value;}
return context;}
case"favorite":case"filter":{return makeContext([searchItem.context&&deepCopy(searchItem.context)]);}
default:{return null;}}}
_getSearchItemDomain(activeItem,options={}){const{searchItemId}=activeItem;const searchItem=this.searchItems[searchItemId];switch(searchItem.type){case"field_property":case"field":{return this._getFieldDomain(searchItem,activeItem.autocompletValues);}
case"dateFilter":{const{dateFilterId}=this._getActiveComparison()||{};if(options.withDateFilterDomain||!(this.searchMenuTypes.has("comparison")&&dateFilterId===searchItemId)){return this._getDateFilterDomain(searchItem,activeItem.generatorIds);}
return new Domain([]);}
case"filter":case"favorite":{return searchItem.domain;}
default:{return null;}}}
_getSearchItemGroupBys(activeItem){const{searchItemId}=activeItem;const searchItem=this.searchItems[searchItemId];switch(searchItem.type){case"dateGroupBy":{const{fieldName}=searchItem;return activeItem.intervalIds.map((intervalId)=>`${fieldName}:${intervalId}`);}
case"groupBy":{return[searchItem.fieldName];}
case"favorite":{return searchItem.groupBys;}
default:{return null;}}}
_getSelectedGeneratorIds(dateFilterId){const selectedOptionIds=[];for(const queryElem of this.query){if(queryElem.searchItemId===dateFilterId&&"generatorId"in queryElem){selectedOptionIds.push(queryElem.generatorId);}}
return selectedOptionIds;}
_getSearchPanelDomain(){return Domain.and([this._getCategoryDomain(),this._getFilterDomain()]);}
_importState(state){execute(arraytoMap,state,this);}
_irFilterToFavorite(irFilter){let userId=false;if(Array.isArray(irFilter.user_id)){userId=irFilter.user_id[0];}
const groupNumber=userId?FAVORITE_PRIVATE_GROUP:FAVORITE_SHARED_GROUP;const context=evaluateExpr(irFilter.context,user.context);let groupBys=[];if(context.group_by){groupBys=context.group_by;delete context.group_by;}
let comparison;if(context.comparison){comparison=context.comparison;if(typeof comparison.range==="string"){comparison.range=new Domain(comparison.range).toList();}
if(typeof comparison.comparisonRange==="string"){comparison.comparisonRange=new Domain(comparison.comparisonRange).toList();}
delete context.comparison;}
let sort;try{sort=JSON.parse(irFilter.sort);}catch(err){if(err instanceof SyntaxError){sort=[];}else{throw err;}}
const orderBy=sort.map((order)=>{let fieldName;let asc;const sqlNotation=order.split(" ");if(sqlNotation.length>1){fieldName=sqlNotation[0];asc=sqlNotation[1]==="asc";}else{fieldName=order[0]==="-"?order.slice(1):order;asc=order[0]==="-"?false:true;}
return{asc:asc,name:fieldName,};});const favorite={context,description:irFilter.name,domain:irFilter.domain,groupBys,groupNumber,orderBy,removable:true,serverSideId:irFilter.id,type:"favorite",userId,};if(irFilter.is_default){favorite.isDefault=irFilter.is_default;}
if(comparison){favorite.comparison=comparison;}
return favorite;}
async _notify(){if(this.blockNotification){return;}
this._reset();await this._reloadSections();this.trigger("update");}
async _reloadSections(){this.blockNotification=true;const searchDomain=this._getDomain({withSearchPanel:false});const searchDomainChanged=this.searchPanelInfo.shouldReload||JSON.stringify(this.searchDomain)!==JSON.stringify(searchDomain);this.searchDomain=searchDomain;const toFetch=(section)=>section.enableCounters||(searchDomainChanged&&!section.expand);const categoriesToFetch=this.categories.filter(toFetch);const filtersToFetch=this.filters.filter(toFetch);if(searchDomainChanged||Boolean(categoriesToFetch.length+filtersToFetch.length)){if(this.display.searchPanel){this.sectionsPromise=this._fetchSections(categoriesToFetch,filtersToFetch);if(this._shouldWaitForData(searchDomainChanged)){await this.sectionsPromise;}}
this.searchPanelInfo.shouldReload=!this.display.searchPanel;}
this.blockNotification=false;}
_reset(){delete this._comparison;this._context=null;this._domain=null;this._groupBy=null;this._orderBy=null;}
_shouldWaitForData(searchDomainChanged){if(this.categories.length&&this.filters.some((filter)=>filter.domain!=="[]")){return true;}
if(!this.searchDomain.length){return false;}
return[...this.sections.values()].some((section)=>!section.expand&&searchDomainChanged);}
__legacyParseSearchPanelArchAnyway(searchViewDescription,searchViewFields){if(this.searchPanelInfo){return;}
const parser=new SearchArchParser(searchViewDescription,searchViewFields);const{searchPanelInfo}=parser.parse();this.searchPanelInfo={...searchPanelInfo,loaded:false,shouldReload:false};}}
return __exports;});;

/* /web/static/src/search/search_panel/search_panel.js */
odoo.define('@web/search/search_panel/search_panel',['@web/core/dropdown/dropdown','@web/core/utils/hooks','@odoo/owl','@web/search/action_hook'],function(require){'use strict';let __exports={};const{Dropdown}=require("@web/core/dropdown/dropdown");const{useBus}=require("@web/core/utils/hooks");const{Component,onMounted,onWillStart,onWillUpdateProps,reactive,useEffect,useRef,useState,}=require("@odoo/owl");const{useSetupAction}=require("@web/search/action_hook");const isFilter=(s)=>s.type==="filter";const isActiveCategory=(s)=>s.type==="category"&&s.activeValueId;const nameOfCheckedValues=(values)=>{const names=[];for(const[,value]of values){if(value.checked){names.push(value.display_name);}}
return names;};const SearchPanel=__exports.SearchPanel=class SearchPanel extends Component{static template="web.SearchPanel";static props={};static components={Dropdown,};static subTemplates={section:"web.SearchPanel.Section",category:"web.SearchPanel.Category",filtersGroup:"web.SearchPanel.FiltersGroup",};setup(){this.state=useState({active:{},expanded:{},showMobileSearch:false,sidebarExpanded:!this.env.searchModel.searchPanelInfo.fold,});this.hasImportedState=false;this.root=useRef("root");this.scrollTop=0;this.dropdownStates={};this.width="10px";this.importState(this.env.searchPanelState);useBus(this.env.searchModel,"update",async()=>{await this.env.searchModel.sectionsPromise;this.updateActiveValues();this.render();});useEffect((el)=>{if(el&&this.hasImportedState){el.style["min-width"]=this.width;el.scroll({top:this.scrollTop});}},()=>[this.root.el]);useSetupAction({getGlobalState:()=>{return{searchPanel:this.exportState(),};},});onWillStart(async()=>{await this.env.searchModel.sectionsPromise;this.expandDefaultValue();this.updateActiveValues();});onWillUpdateProps(async()=>{await this.env.searchModel.sectionsPromise;this.updateActiveValues();});onMounted(()=>{this.updateGroupHeadersChecked();});}
get sections(){return this.env.searchModel.getSections((s)=>!s.empty);}
exportState(){const exported={expanded:this.state.expanded,scrollTop:this.root.el?.scrollTop||0,sidebarExpanded:this.state.sidebarExpanded,width:this.width,};return JSON.stringify(exported);}
importState(state){this.hasImportedState=Boolean(state);if(this.hasImportedState){this.state.expanded=state.expanded;this.scrollTop=state.scrollTop;this.state.sidebarExpanded=state.sidebarExpanded;this.width=state.width;}}
getDropdownState(sectionId){if(!this.dropdownStates[sectionId]){const state=reactive({isOpen:false,open:()=>(state.isOpen=true),close:()=>(state.isOpen=false),});this.dropdownStates[sectionId]=reactive(state);}
return this.dropdownStates[sectionId];}
expandDefaultValue(){if(this.hasImportedState){return;}
const categories=this.env.searchModel.getSections((s)=>s.type==="category");for(const category of categories){this.state.expanded[category.id]={};if(category.activeValueId){const ancestorIds=this.getAncestorValueIds(category,category.activeValueId);for(const ancestorId of ancestorIds){this.state.expanded[category.id][ancestorId]=true;}}}}
getAncestorValueIds(category,categoryValueId){const{parentId}=category.values.get(categoryValueId);return parentId?[...this.getAncestorValueIds(category,parentId),parentId]:[];}
getCategorySelection(){const activeCategories=this.env.searchModel.getSections(isActiveCategory);const selection=[];for(const category of activeCategories){const parentIds=this.getAncestorValueIds(category,category.activeValueId);const orderedCategoryNames=[...parentIds,category.activeValueId].map((valueId)=>category.values.get(valueId).display_name);selection.push({values:orderedCategoryNames,icon:category.icon,color:category.color,});}
return selection;}
getFilterSelection(){const filters=this.env.searchModel.getSections(isFilter);const selection=[];for(const{groups,values,icon,color}of filters){let filterValues;if(groups){filterValues=Object.keys(groups).map((groupId)=>nameOfCheckedValues(groups[groupId].values)).flat();}else if(values){filterValues=nameOfCheckedValues(values);}
if(filterValues.length){selection.push({values:filterValues,icon,color});}}
return selection;}
hasSelection(sectionId=0){if(sectionId){const sectionState=this.state.active[sectionId];if(sectionState instanceof Object){return Object.values(sectionState).some((val)=>val);}
return Boolean(sectionState);}
return Object.keys(this.state.active).some((key)=>this.hasSelection(key));}
clearSelection(sectionId=0){const sectionIds=sectionId?[sectionId]:Object.keys(this.state.active).map(Number);this.env.searchModel.clearSections(sectionIds);}
async toggleCategory(category,value){if(value.childrenIds.length){const categoryState=this.state.expanded[category.id];if(categoryState[value.id]&&category.activeValueId===value.id){delete categoryState[value.id];}else{categoryState[value.id]=true;}}else{this.getDropdownState(category.id).close();}
if(category.activeValueId!==value.id){this.env.searchModel.toggleCategoryValue(category.id,value.id);}}
toggleSidebar(){this.state.sidebarExpanded=!this.state.sidebarExpanded;}
toggleFilterGroup(filterId,{values}){const valueIds=[];const checked=[...values.values()].every((value)=>this.state.active[filterId][value.id]);values.forEach(({id})=>{valueIds.push(id);this.state.active[filterId][id]=!checked;});this.env.searchModel.toggleFilterValues(filterId,valueIds,!checked);}
toggleFilterValue(filterId,valueId,{currentTarget}){this.state.active[filterId][valueId]=currentTarget.checked;this.updateGroupHeadersChecked();this.env.searchModel.toggleFilterValues(filterId,[valueId]);}
updateActiveValues(){for(const section of this.sections){if(section.type==="category"){this.state.active[section.id]=section.activeValueId;}else{this.state.active[section.id]={};if(section.groups){for(const group of section.groups.values()){for(const value of group.values.values()){this.state.active[section.id][value.id]=value.checked;}}}
if(section&&section.values){for(const value of section.values.values()){this.state.active[section.id][value.id]=value.checked;}}}}}
updateGroupHeadersChecked(){const groups=document.querySelectorAll(".o_search_panel_filter_group");for(const group of groups){const header=group.querySelector(":scope .o_search_panel_group_header input");const vals=[...group.querySelectorAll(":scope .o_search_panel_filter_value input")];header.checked=false;header.indeterminate=false;if(vals.every((v)=>v.checked)){header.checked=true;}else if(vals.some((v)=>v.checked)){header.indeterminate=true;}}}
_onStartResize(ev){if(ev.button!==0){return;}
const initialX=ev.pageX;const initialWidth=this.root.el.offsetWidth;const resizeStoppingEvents=["keydown","pointerdown","pointerup"];const resizePanel=(ev)=>{ev.preventDefault();ev.stopPropagation();const maxWidth=Math.max(0.5*window.innerWidth,initialWidth);const delta=ev.pageX-initialX;const newWidth=Math.min(maxWidth,Math.max(10,initialWidth+delta));this.width=`${newWidth}px`;this.root.el.style["min-width"]=this.width;};document.addEventListener("pointermove",resizePanel,true);const stopResize=(ev)=>{if(ev.type==="pointerdown"&&ev.button===0){return;}
ev.preventDefault();ev.stopPropagation();document.removeEventListener("pointermove",resizePanel,true);resizeStoppingEvents.forEach((stoppingEvent)=>{document.removeEventListener(stoppingEvent,stopResize,true);});document.activeElement.blur();};resizeStoppingEvents.forEach((stoppingEvent)=>{document.addEventListener(stoppingEvent,stopResize,true);});}}
return __exports;});;

/* /web/static/src/search/utils/dates.js */
odoo.define('@web/search/utils/dates',['@web/core/l10n/translation','@web/core/domain','@web/core/l10n/dates','@web/core/l10n/localization','@web/core/utils/numbers','@web/core/utils/objects'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Domain}=require("@web/core/domain");const{serializeDate,serializeDateTime}=require("@web/core/l10n/dates");const{localization}=require("@web/core/l10n/localization");const{clamp}=require("@web/core/utils/numbers");const{pick}=require("@web/core/utils/objects");const QUARTERS=__exports.QUARTERS={1:{description:_t("Q1"),coveredMonths:[1,2,3]},2:{description:_t("Q2"),coveredMonths:[4,5,6]},3:{description:_t("Q3"),coveredMonths:[7,8,9]},4:{description:_t("Q4"),coveredMonths:[10,11,12]},};const QUARTER_OPTIONS=__exports.QUARTER_OPTIONS={fourth_quarter:{id:"fourth_quarter",groupNumber:1,description:QUARTERS[4].description,setParam:{quarter:4},granularity:"quarter",},third_quarter:{id:"third_quarter",groupNumber:1,description:QUARTERS[3].description,setParam:{quarter:3},granularity:"quarter",},second_quarter:{id:"second_quarter",groupNumber:1,description:QUARTERS[2].description,setParam:{quarter:2},granularity:"quarter",},first_quarter:{id:"first_quarter",groupNumber:1,description:QUARTERS[1].description,setParam:{quarter:1},granularity:"quarter",},};const DEFAULT_INTERVAL=__exports.DEFAULT_INTERVAL="month";const INTERVAL_OPTIONS=__exports.INTERVAL_OPTIONS={year:{description:_t("Year"),id:"year",groupNumber:1},quarter:{description:_t("Quarter"),id:"quarter",groupNumber:1},month:{description:_t("Month"),id:"month",groupNumber:1},week:{description:_t("Week"),id:"week",groupNumber:1},day:{description:_t("Day"),id:"day",groupNumber:1},};const COMPARISON_OPTIONS=__exports.COMPARISON_OPTIONS={previous_period:{description:_t("Previous Period"),id:"previous_period",},previous_year:{description:_t("Previous Year"),id:"previous_year",plusParam:{years:-1},},};const PER_YEAR=__exports.PER_YEAR={year:1,quarter:4,month:12,};__exports.constructDateDomain=constructDateDomain;function constructDateDomain(referenceMoment,searchItem,selectedOptionIds,comparisonOptionId){let plusParam;let selectedOptions;if(comparisonOptionId){[plusParam,selectedOptions]=getComparisonParams(referenceMoment,searchItem,selectedOptionIds,comparisonOptionId);}else{selectedOptions=getSelectedOptions(referenceMoment,searchItem,selectedOptionIds);}
if("withDomain"in selectedOptions){return{description:selectedOptions.withDomain[0].description,domain:Domain.and([selectedOptions.withDomain[0].domain,searchItem.domain]),};}
const yearOptions=selectedOptions.year;const otherOptions=[...(selectedOptions.quarter||[]),...(selectedOptions.month||[])];sortPeriodOptions(yearOptions);sortPeriodOptions(otherOptions);const ranges=[];const{fieldName,fieldType}=searchItem;for(const yearOption of yearOptions){const constructRangeParams={referenceMoment,fieldName,fieldType,plusParam,};if(otherOptions.length){for(const option of otherOptions){const setParam=Object.assign({},yearOption.setParam,option?option.setParam:{});const{granularity}=option;const range=constructDateRange(Object.assign({granularity,setParam},constructRangeParams));ranges.push(range);}}else{const{granularity,setParam}=yearOption;const range=constructDateRange(Object.assign({granularity,setParam},constructRangeParams));ranges.push(range);}}
let domain=Domain.combine(ranges.map((range)=>range.domain),"OR");domain=Domain.and([domain,searchItem.domain]);const description=ranges.map((range)=>range.description).join("/");return{domain,description};}
__exports.constructDateRange=constructDateRange;function constructDateRange(params){const{referenceMoment,fieldName,fieldType,granularity,setParam,plusParam}=params;if("quarter"in setParam){setParam.month=QUARTERS[setParam.quarter].coveredMonths[0];delete setParam.quarter;}
const date=referenceMoment.set(setParam).plus(plusParam||{});const leftDate=date.startOf(granularity);const rightDate=date.endOf(granularity);let leftBound;let rightBound;if(fieldType==="date"){leftBound=serializeDate(leftDate);rightBound=serializeDate(rightDate);}else{leftBound=serializeDateTime(leftDate);rightBound=serializeDateTime(rightDate);}
const domain=new Domain(["&",[fieldName,">=",leftBound],[fieldName,"<=",rightBound]]);const descriptions=[date.toFormat("yyyy")];const method=localization.direction==="rtl"?"push":"unshift";if(granularity==="month"){descriptions[method](date.toFormat("MMMM"));}else if(granularity==="quarter"){const quarter=date.quarter;descriptions[method](QUARTERS[quarter].description.toString());}
const description=descriptions.join(" ");return{domain,description};}
__exports.getComparisonOptions=getComparisonOptions;function getComparisonOptions(){return getOptionsWithDescriptions(COMPARISON_OPTIONS);}
__exports.getComparisonParams=getComparisonParams;function getComparisonParams(referenceMoment,searchItem,selectedOptionIds,comparisonOptionId){const comparisonOption=COMPARISON_OPTIONS[comparisonOptionId];const selectedOptions=getSelectedOptions(referenceMoment,searchItem,selectedOptionIds);if(comparisonOption.plusParam){return[comparisonOption.plusParam,selectedOptions];}
const plusParam={};let globalGranularity="year";if(selectedOptions.month){globalGranularity="month";}else if(selectedOptions.quarter){globalGranularity="quarter";}
const granularityFactor=PER_YEAR[globalGranularity];const years=selectedOptions.year.map((o)=>o.setParam.year);const yearMin=Math.min(...years);const yearMax=Math.max(...years);let optionMin=0;let optionMax=0;if(selectedOptions.quarter){const quarters=selectedOptions.quarter.map((o)=>o.setParam.quarter);if(globalGranularity==="month"){delete selectedOptions.quarter;for(const quarter of quarters){for(const month of QUARTERS[quarter].coveredMonths){const monthOption=selectedOptions.month.find((o)=>o.setParam.month===month);if(!monthOption){selectedOptions.month.push({setParam:{month},granularity:"month",});}}}}else{optionMin=Math.min(...quarters);optionMax=Math.max(...quarters);}}
if(selectedOptions.month){const months=selectedOptions.month.map((o)=>o.setParam.month);optionMin=Math.min(...months);optionMax=Math.max(...months);}
const num=-1+granularityFactor*(yearMin-yearMax)+optionMin-optionMax;const key=globalGranularity==="year"?"years":globalGranularity==="month"?"months":"quarters";plusParam[key]=num;return[plusParam,selectedOptions];}
__exports.getIntervalOptions=getIntervalOptions;function getIntervalOptions(){return getOptionsWithDescriptions(INTERVAL_OPTIONS);}
__exports.getOptionsWithDescriptions=getOptionsWithDescriptions;function getOptionsWithDescriptions(OPTIONS){const options=[];for(const option of Object.values(OPTIONS)){options.push(Object.assign({},option,{description:option.description.toString()}));}
return options;}
__exports.getPeriodOptions=getPeriodOptions;function getPeriodOptions(referenceMoment,optionsParams){return[...getMonthPeriodOptions(referenceMoment,optionsParams),...getQuarterPeriodOptions(optionsParams),...getYearPeriodOptions(referenceMoment,optionsParams),...getCustomPeriodOptions(optionsParams),];}
__exports.toGeneratorId=toGeneratorId;function toGeneratorId(unit,offset){if(!offset){return unit;}
const sep=offset>0?"+":"-";const val=Math.abs(offset);return`${unit}${sep}${val}`;}
function getMonthPeriodOptions(referenceMoment,optionsParams){const{startYear,endYear,startMonth,endMonth}=optionsParams;return[...Array(endMonth-startMonth+1).keys()].map((i)=>{const monthOffset=startMonth+i;const date=referenceMoment.plus({months:monthOffset,years:clamp(0,startYear,endYear),});const yearOffset=date.year-referenceMoment.year;return{id:toGeneratorId("month",monthOffset),defaultYearId:toGeneratorId("year",clamp(yearOffset,startYear,endYear)),description:date.toFormat("MMMM"),granularity:"month",groupNumber:1,plusParam:{months:monthOffset},};}).reverse();}
function getQuarterPeriodOptions(optionsParams){const{startYear,endYear}=optionsParams;const defaultYearId=toGeneratorId("year",clamp(0,startYear,endYear));return Object.values(QUARTER_OPTIONS).map((quarter)=>({...quarter,defaultYearId,}));}
function getYearPeriodOptions(referenceMoment,optionsParams){const{startYear,endYear}=optionsParams;return[...Array(endYear-startYear+1).keys()].map((i)=>{const offset=startYear+i;const date=referenceMoment.plus({years:offset});return{id:toGeneratorId("year",offset),description:date.toFormat("yyyy"),granularity:"year",groupNumber:2,plusParam:{years:offset},};}).reverse();}
function getCustomPeriodOptions(optionsParams){const{customOptions}=optionsParams;return customOptions.map((option)=>({id:option.id,description:option.description,granularity:"withDomain",groupNumber:3,domain:option.domain,}));}
__exports.getSelectedOptions=getSelectedOptions;function getSelectedOptions(referenceMoment,searchItem,selectedOptionIds){const selectedOptions={year:[]};const periodOptions=getPeriodOptions(referenceMoment,searchItem.optionsParams);for(const optionId of selectedOptionIds){const option=periodOptions.find((option)=>option.id===optionId);const granularity=option.granularity;if(!selectedOptions[granularity]){selectedOptions[granularity]=[];}
if(option.domain){selectedOptions[granularity].push(pick(option,"domain","description"));}else{const setParam=getSetParam(option,referenceMoment);selectedOptions[granularity].push({granularity,setParam});}}
return selectedOptions;}
__exports.getSetParam=getSetParam;function getSetParam(periodOption,referenceMoment){if(periodOption.granularity==="quarter"){return periodOption.setParam;}
const date=referenceMoment.plus(periodOption.plusParam);const granularity=periodOption.granularity;const setParam={[granularity]:date[granularity]};return setParam;}
__exports.rankInterval=rankInterval;function rankInterval(intervalOptionId){return Object.keys(INTERVAL_OPTIONS).indexOf(intervalOptionId);}
__exports.sortPeriodOptions=sortPeriodOptions;function sortPeriodOptions(options){options.sort((o1,o2)=>{var _a,_b;const granularity1=o1.granularity;const granularity2=o2.granularity;if(granularity1===granularity2){return(((_a=o1.setParam[granularity1])!==null&&_a!==void 0?_a:0)-
((_b=o2.setParam[granularity1])!==null&&_b!==void 0?_b:0));}
return granularity1<granularity2?-1:1;});}
__exports.yearSelected=yearSelected;function yearSelected(selectedOptionIds){return selectedOptionIds.some((optionId)=>optionId.startsWith("year"));}
return __exports;});;

/* /web/static/src/search/utils/group_by.js */
odoo.define('@web/search/utils/group_by',['@web/search/utils/dates'],function(require){'use strict';let __exports={};const{DEFAULT_INTERVAL,INTERVAL_OPTIONS}=require("@web/search/utils/dates");function errorMsg(descr){return`Invalid groupBy description: ${descr}`;}
__exports.getGroupBy=getGroupBy;function getGroupBy(descr,fields){let fieldName;let interval;let spec;[fieldName,interval]=descr.split(":");if(!fieldName){throw Error();}
if(fields){if(!fields[fieldName]&&!fieldName.includes(".")){throw Error(errorMsg(descr));}
const fieldType=fields[fieldName]?.type;if(["date","datetime"].includes(fieldType)){if(!interval){interval=DEFAULT_INTERVAL;}else if(!Object.keys(INTERVAL_OPTIONS).includes(interval)){throw Error(errorMsg(descr));}
spec=`${fieldName}:${interval}`;}else if(interval){throw Error(errorMsg(descr));}else{spec=fieldName;interval=null;}}else{if(interval){if(!Object.keys(INTERVAL_OPTIONS).includes(interval)){throw Error(errorMsg(descr));}
spec=`${fieldName}:${interval}`;}else{spec=fieldName;interval=null;}}
return{fieldName,interval,spec,toJSON(){return spec;},};}
return __exports;});;

/* /web/static/src/search/utils/misc.js */
odoo.define('@web/search/utils/misc',[],function(require){'use strict';let __exports={};const FACET_ICONS=__exports.FACET_ICONS={filter:"fa fa-filter",groupBy:"oi oi-group",groupByAsc:"fa fa-sort-numeric-asc",groupByDesc:"fa fa-sort-numeric-desc",favorite:"fa fa-star",comparison:"fa fa-adjust",};const FACET_COLORS=__exports.FACET_COLORS={filter:"primary",groupBy:"action",favorite:"warning",comparison:"danger",};const GROUPABLE_TYPES=__exports.GROUPABLE_TYPES=["boolean","char","date","datetime","integer","many2one","many2many","selection","tags",];return __exports;});;

/* /web/static/src/search/utils/order_by.js */
odoo.define('@web/search/utils/order_by',[],function(require){'use strict';let __exports={};__exports.orderByToString=orderByToString;function orderByToString(orderBy){return orderBy.map((o)=>`${o.name} ${o.asc ? "ASC" : "DESC"}`).join(", ");}
__exports.stringToOrderBy=stringToOrderBy;function stringToOrderBy(string){if(!string){return[];}
return string.split(",").map((order)=>{const splitOrder=order.trim().split(" ");if(splitOrder.length===2){return{name:splitOrder[0],asc:splitOrder[1].toLowerCase()==="asc",};}else{return{name:splitOrder[0],asc:true,};}});}
return __exports;});;

/* /web/static/src/search/with_search/with_search.js */
odoo.define('@web/search/with_search/with_search',['@odoo/owl','@web/search/action_hook','@web/search/search_model','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,onWillStart,onWillUpdateProps,toRaw,useSubEnv}=require("@odoo/owl");const{CallbackRecorder,useSetupAction}=require("@web/search/action_hook");const{SearchModel}=require("@web/search/search_model");const{useBus,useService}=require("@web/core/utils/hooks");const SEARCH_KEYS=__exports.SEARCH_KEYS=["comparison","context","domain","groupBy","orderBy"];const WithSearch=__exports.WithSearch=class WithSearch extends Component{static template="web.WithSearch";static props={slots:Object,SearchModel:{type:Function,optional:true},resModel:String,globalState:{type:Object,optional:true},searchModelArgs:{type:Object,optional:true},display:{type:Object,optional:true},comparison:{type:[Object,{value:null}],optional:true},context:{type:Object,optional:true},domain:{type:Array,element:[String,Array],optional:true},groupBy:{type:Array,element:String,optional:true},orderBy:{type:Array,element:Object,optional:true},searchViewArch:{type:String,optional:true},searchViewFields:{type:Object,optional:true},searchViewId:{type:[Number,Boolean],optional:true},irFilters:{type:Array,element:Object,optional:true},loadIrFilters:{type:Boolean,optional:true},activateFavorite:{type:Boolean,optional:true},dynamicFilters:{type:Array,element:Object,optional:true},hideCustomGroupBy:{type:Boolean,optional:true},searchMenuTypes:{type:Array,element:String,optional:true},canOrderByCount:{type:Boolean,optional:true},};setup(){if(!this.env.__getContext__){useSubEnv({__getContext__:new CallbackRecorder()});}
if(!this.env.__getOrderBy__){useSubEnv({__getOrderBy__:new CallbackRecorder()});}
const SearchModelClass=this.props.SearchModel||SearchModel;this.searchModel=new SearchModelClass(this.env,{orm:useService("orm"),view:useService("view"),field:useService("field"),name:useService("name"),dialog:useService("dialog"),},this.props.searchModelArgs);const searchPanelState=this.props.globalState?.searchPanel?JSON.parse(this.props.globalState?.searchPanel):null;useSubEnv({searchModel:this.searchModel,searchPanelState});useBus(this.searchModel,"update",this.render);useSetupAction({getGlobalState:()=>{return{searchModel:JSON.stringify(this.searchModel.exportState()),};},});onWillStart(async()=>{const config={...toRaw(this.props)};if(config.globalState&&config.globalState.searchModel){config.state=JSON.parse(config.globalState.searchModel);delete config.globalState;}
await this.searchModel.load(config);});onWillUpdateProps(async(nextProps)=>{const config={};for(const key of SEARCH_KEYS){if(nextProps[key]!==undefined){config[key]=nextProps[key];}}
await this.searchModel.reload(config);});}}
return __exports;});;

/* /web/static/src/views/calendar/calendar_arch_parser.js */
odoo.define('@web/views/calendar/calendar_arch_parser',['@web/core/browser/browser','@web/core/py_js/py','@web/core/utils/strings','@web/core/utils/xml','@web/views/fields/field'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{evaluateExpr}=require("@web/core/py_js/py");const{exprToBoolean}=require("@web/core/utils/strings");const{visitXML}=require("@web/core/utils/xml");const{Field}=require("@web/views/fields/field");const FIELD_ATTRIBUTE_NAMES=["date_start","date_delay","date_stop","all_day","recurrence_update","create_name_field","color",];const SCALES=["day","week","month","year"];const CalendarParseArchError=__exports.CalendarParseArchError=class CalendarParseArchError extends Error{}
const CalendarArchParser=__exports.CalendarArchParser=class CalendarArchParser{parse(arch,models,modelName){const fields=models[modelName].fields;const fieldNames=new Set(fields.display_name?["display_name"]:[]);const fieldMapping={date_start:"date_start"};let jsClass=null;let eventLimit=5;let scales=[...SCALES];const sessionScale=browser.sessionStorage.getItem("calendar-scale");let scale=sessionScale||"week";let canCreate=true;let canDelete=true;let canEdit=true;let quickCreate=true;let quickCreateViewId=null;let hasEditDialog=false;let showUnusualDays=false;let isDateHidden=false;let isTimeHidden=false;let formViewId=false;const popoverFieldNodes={};const filtersInfo={};visitXML(arch,(node)=>{switch(node.tagName){case"calendar":{if(!node.hasAttribute("date_start")){throw new CalendarParseArchError(`Calendar view has not defined "date_start" attribute.`);}
jsClass=node.getAttribute("js_class");for(const fieldAttrName of FIELD_ATTRIBUTE_NAMES){if(node.hasAttribute(fieldAttrName)){const fieldName=node.getAttribute(fieldAttrName);fieldNames.add(fieldName);fieldMapping[fieldAttrName]=fieldName;}}
if(node.hasAttribute("event_limit")){eventLimit=evaluateExpr(node.getAttribute("event_limit"));if(!Number.isInteger(eventLimit)){throw new CalendarParseArchError(`Calendar view's event limit should be a number`);}}
if(node.hasAttribute("scales")){const scalesAttr=node.getAttribute("scales");scales=scalesAttr.split(",").filter((scale)=>SCALES.includes(scale));}
if(node.hasAttribute("mode")){scale=node.getAttribute("mode");if(!scales.includes(scale)){throw new CalendarParseArchError(`Calendar view cannot display mode: ${scale}`);}}
if(node.hasAttribute("create")){canCreate=exprToBoolean(node.getAttribute("create"),true);}
if(node.hasAttribute("delete")){canDelete=exprToBoolean(node.getAttribute("delete"),true);}
if(node.hasAttribute("edit")){canEdit=exprToBoolean(node.getAttribute("edit"),true);}
if(node.hasAttribute("quick_create")){quickCreate=exprToBoolean(node.getAttribute("quick_create"),true);if(quickCreate&&node.hasAttribute("quick_create_view_id")){quickCreateViewId=parseInt(node.getAttribute("quick_create_view_id"),10);}}
if(node.hasAttribute("event_open_popup")){hasEditDialog=exprToBoolean(node.getAttribute("event_open_popup"));}
if(node.hasAttribute("show_unusual_days")){showUnusualDays=exprToBoolean(node.getAttribute("show_unusual_days"));}
if(node.hasAttribute("hide_date")){isDateHidden=exprToBoolean(node.getAttribute("hide_date"));}
if(node.hasAttribute("hide_time")){isTimeHidden=exprToBoolean(node.getAttribute("hide_time"));}
if(node.hasAttribute("form_view_id")){formViewId=parseInt(node.getAttribute("form_view_id"),10);}
break;}
case"field":{const fieldName=node.getAttribute("name");fieldNames.add(fieldName);const fieldInfo=Field.parseFieldNode(node,models,modelName,"calendar",jsClass);popoverFieldNodes[fieldName]=fieldInfo;const field=fields[fieldName];if(!node.hasAttribute("invisible")||node.hasAttribute("filters")){let filterInfo=null;if(node.hasAttribute("avatar_field")||node.hasAttribute("write_model")||node.hasAttribute("write_field")||node.hasAttribute("color")||node.hasAttribute("filters")){filtersInfo[fieldName]=filtersInfo[fieldName]||{avatarFieldName:null,colorFieldName:null,fieldName,filterFieldName:null,label:field.string,resModel:field.relation,writeFieldName:null,writeResModel:null,};filterInfo=filtersInfo[fieldName];}
if(node.hasAttribute("filter_field")){filterInfo.filterFieldName=node.getAttribute("filter_field");}
if(node.hasAttribute("avatar_field")){filterInfo.avatarFieldName=node.getAttribute("avatar_field");}
if(node.hasAttribute("write_model")){filterInfo.writeResModel=node.getAttribute("write_model");}
if(node.hasAttribute("write_field")){filterInfo.writeFieldName=node.getAttribute("write_field");}
if(node.hasAttribute("filters")){if(node.hasAttribute("color")){filterInfo.colorFieldName=node.getAttribute("color");}
if(node.hasAttribute("avatar_field")&&field.relation){if(field.relation.includes(["res.users","res.partners","hr.employee",])){filterInfo.avatarFieldName="image_128";}}}}
break;}}});return{canCreate,canDelete,canEdit,eventLimit,fieldMapping,fieldNames:[...fieldNames],filtersInfo,formViewId,hasEditDialog,quickCreate,quickCreateViewId,isDateHidden,isTimeHidden,popoverFieldNodes,scale,scales,showUnusualDays,};}}
return __exports;});;

/* /web/static/src/views/calendar/calendar_common/calendar_common_popover.js */
odoo.define('@web/views/calendar/calendar_common/calendar_common_popover',['@web/core/l10n/translation','@web/core/dialog/dialog','@web/core/py_js/py','@web/core/l10n/dates','@web/core/registry','@web/views/fields/field','@web/model/record','@web/views/calendar/utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Dialog}=require("@web/core/dialog/dialog");const{evaluateBooleanExpr}=require("@web/core/py_js/py");const{is24HourFormat}=require("@web/core/l10n/dates");const{registry}=require("@web/core/registry");const{Field}=require("@web/views/fields/field");const{Record}=require("@web/model/record");const{getFormattedDateSpan}=require("@web/views/calendar/utils");const{Component,useExternalListener}=require("@odoo/owl");const CalendarCommonPopover=__exports.CalendarCommonPopover=class CalendarCommonPopover extends Component{static template="web.CalendarCommonPopover";static subTemplates={popover:"web.CalendarCommonPopover.popover",body:"web.CalendarCommonPopover.body",footer:"web.CalendarCommonPopover.footer",};static components={Dialog,Field,Record,};static props={close:Function,record:Object,model:Object,createRecord:Function,deleteRecord:Function,editRecord:Function,};setup(){this.time=null;this.timeDuration=null;this.date=null;this.dateDuration=null;useExternalListener(window,"pointerdown",(e)=>e.preventDefault(),{capture:true});this.computeDateTimeAndDuration();}
get activeFields(){return this.props.model.activeFields;}
get isEventEditable(){return true;}
get isEventDeletable(){return this.props.model.canDelete;}
get hasFooter(){return this.isEventEditable||this.isEventDeletable;}
isInvisible(fieldNode,record){return evaluateBooleanExpr(fieldNode.invisible,record.evalContextWithVirtualIds);}
getFormattedValue(fieldName,record){const fieldInfo=this.props.model.popoverFieldNodes[fieldName];const field=this.props.model.fields[fieldName];let format;const formattersRegistry=registry.category("formatters");if(fieldInfo.widget&&formattersRegistry.contains(fieldInfo.widget)){format=formattersRegistry.get(fieldInfo.widget);}else{format=formattersRegistry.get(field.type);}
return format(record.data[fieldName]);}
computeDateTimeAndDuration(){const record=this.props.record;const{start,end}=record;const isSameDay=start.hasSame(end,"day");if(!record.isTimeHidden&&!record.isAllDay&&isSameDay){const timeFormat=is24HourFormat()?"HH:mm":"hh:mm a";this.time=`${start.toFormat(timeFormat)} - ${end.toFormat(timeFormat)}`;const duration=end.diff(start,["hours","minutes"]);const formatParts=[];if(duration.hours>0){const hourString=duration.hours===1?_t("hour"):_t("hours");formatParts.push(`h '${hourString}'`);}
if(duration.minutes>0){const minuteStr=duration.minutes===1?_t("minute"):_t("minutes");formatParts.push(`m '${minuteStr}'`);}
this.timeDuration=duration.toFormat(formatParts.join(", "));}
if(!this.props.model.isDateHidden){this.date=getFormattedDateSpan(start,end);if(record.isAllDay){if(isSameDay){this.dateDuration=_t("All day");}else{const duration=end.plus({day:1}).diff(start,"days");this.dateDuration=duration.toFormat(`d '${_t("days")}'`);}}}}
onEditEvent(){this.props.editRecord(this.props.record);this.props.close();}
onDeleteEvent(){this.props.deleteRecord(this.props.record);this.props.close();}}
return __exports;});;

/* /web/static/src/views/calendar/calendar_common/calendar_common_renderer.js */
odoo.define('@web/views/calendar/calendar_common/calendar_common_renderer',['@web/core/l10n/dates','@web/core/l10n/localization','@web/core/utils/render','@web/views/calendar/colors','@web/views/calendar/hooks','@web/views/calendar/calendar_common/calendar_common_popover','@web/views/calendar/calendar_common/calendar_common_week_column','@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{getLocalWeekNumber,is24HourFormat}=require("@web/core/l10n/dates");const{localization}=require("@web/core/l10n/localization");const{renderToString}=require("@web/core/utils/render");const{getColor}=require("@web/views/calendar/colors");const{useCalendarPopover,useClickHandler,useFullCalendar}=require("@web/views/calendar/hooks");const{CalendarCommonPopover}=require("@web/views/calendar/calendar_common/calendar_common_popover");const{makeWeekColumn}=require("@web/views/calendar/calendar_common/calendar_common_week_column");const{Component}=require("@odoo/owl");const{useBus}=require("@web/core/utils/hooks");const SCALE_TO_FC_VIEW={day:"timeGridDay",week:"timeGridWeek",month:"dayGridMonth",};const SCALE_TO_HEADER_FORMAT={day:"DDD",week:"EEE d",month:"EEEE",};const SHORT_SCALE_TO_HEADER_FORMAT={...SCALE_TO_HEADER_FORMAT,day:"D",month:"EEE",};const HOUR_FORMATS={12:{hour:"numeric",minute:"2-digit",omitZeroMinute:true,meridiem:"short",},24:{hour:"numeric",minute:"2-digit",hour12:false,},};const{DateTime}=luxon;const CalendarCommonRenderer=__exports.CalendarCommonRenderer=class CalendarCommonRenderer extends Component{static components={Popover:CalendarCommonPopover,};static template="web.CalendarCommonRenderer";static eventTemplate="web.CalendarCommonRenderer.event";static headerTemplate="web.CalendarCommonRendererHeader";static props={model:Object,displayName:{type:String,optional:true},isWeekendVisible:{type:Boolean,optional:true},createRecord:Function,editRecord:Function,deleteRecord:Function,setDate:{type:Function,optional:true},};setup(){this.fc=useFullCalendar("fullCalendar",this.options);this.click=useClickHandler(this.onClick,this.onDblClick);this.popover=useCalendarPopover(this.constructor.components.Popover);useBus(this.props.model.bus,"SCROLL_TO_CURRENT_HOUR",()=>this.fc.api.scrollToTime(`${luxon.DateTime.local().hour - 2}:00:00`));}
get options(){return{allDaySlot:true,allDayContent:"",dayHeaderFormat:this.env.isSmall?SHORT_SCALE_TO_HEADER_FORMAT[this.props.model.scale]:SCALE_TO_HEADER_FORMAT[this.props.model.scale],dateClick:this.onDateClick,dayCellClassNames:this.getDayCellClassNames,initialDate:this.props.model.date.toISO(),initialView:SCALE_TO_FC_VIEW[this.props.model.scale],direction:localization.direction,droppable:true,editable:this.props.model.canEdit,eventClick:this.onEventClick,eventDragStart:this.onEventDragStart,eventDrop:this.onEventDrop,dayMaxEventRows:this.props.model.eventLimit,moreLinkClick:this.onEventLimitClick,eventMouseEnter:this.onEventMouseEnter,eventMouseLeave:this.onEventMouseLeave,eventClassNames:this.eventClassNames,eventDidMount:this.onEventDidMount,eventContent:this.onEventContent,eventResizableFromStart:true,eventResize:this.onEventResize,eventResizeStart:this.onEventResizeStart,events:(_,successCb)=>successCb(this.mapRecordsToEvents()),firstDay:this.props.model.firstDayOfWeek,headerToolbar:false,height:"100%",locale:luxon.Settings.defaultLocale,longPressDelay:500,navLinks:false,nowIndicator:true,select:this.onSelect,selectAllow:this.isSelectionAllowed,selectMinDistance:5,selectMirror:true,selectable:this.props.model.canCreate,slotLabelFormat:is24HourFormat()?HOUR_FORMATS[24]:HOUR_FORMATS[12],snapDuration:{minutes:15},timeZone:luxon.Settings.defaultZone.name,unselectAuto:false,weekNumberFormat:{week:this.props.model.scale==="month"||this.env.isSmall?"numeric":"long",},weekends:this.props.isWeekendVisible,weekNumberCalculation:(date)=>getLocalWeekNumber(date),weekNumbers:true,dayHeaderContent:this.getHeaderHtml,eventDisplay:"block",viewDidMount:this.viewDidMount,moreLinkDidMount:this.wrapMoreLink,};}
get customOptions(){return{weekNumbersWithinDays:!this.env.isSmall,};}
viewDidMount({el,view}){const showWeek=view.calendar.currentData.options.weekNumbers;const weekText=view.calendar.currentData.options.weekText;const weekColumn=!this.customOptions.weekNumbersWithinDays;if(showWeek&&weekColumn){makeWeekColumn({el,weekText});}}
getStartTime(record){const timeFormat=is24HourFormat()?"HH:mm":"hh:mm a";return record.start.toFormat(timeFormat);}
getEndTime(record){const timeFormat=is24HourFormat()?"HH:mm":"hh:mm a";return record.end.toFormat(timeFormat);}
computeEventSelector(event){return`[data-event-id="${event.id}"]`;}
highlightEvent(event,className){for(const el of this.fc.el.querySelectorAll(this.computeEventSelector(event))){el.classList.add(className);}}
unhighlightEvent(event,className){for(const el of this.fc.el.querySelectorAll(this.computeEventSelector(event))){el.classList.remove(className);}}
mapRecordsToEvents(){return Object.values(this.props.model.records).map((r)=>this.convertRecordToEvent(r));}
convertRecordToEvent(record){const allDay=record.isAllDay||record.end.diff(record.start,"hours").hours>=24;return{id:record.id,title:record.title,start:record.start.toISO(),end:["week","month"].includes(this.props.model.scale)&&allDay||(record.isAllDay||(allDay&&record.end.toMillis()!==record.end.startOf("day").toMillis()))?record.end.plus({days:1}).toISO():record.end.toISO(),allDay:allDay,};}
getPopoverProps(record){return{record,model:this.props.model,createRecord:this.props.createRecord,deleteRecord:this.props.deleteRecord,editRecord:this.props.editRecord,};}
openPopover(target,record){const color=getColor(record.colorIndex);this.popover.open(target,this.getPopoverProps(record),`o_cw_popover card o_calendar_color_${typeof color === "number" ? color : 0}`);}
onClick(info){this.openPopover(info.el,this.props.model.records[info.event.id]);this.highlightEvent(info.event,"o_cw_custom_highlight");}
onDateClick(info){if(info.jsEvent.defaultPrevented){return;}
this.props.createRecord(this.fcEventToRecord(info));}
getDayCellClassNames(info){const date=luxon.DateTime.fromJSDate(info.date).toISODate();if(this.props.model.unusualDays.includes(date)){return["o_calendar_disabled"];}
return[];}
onDblClick(info){this.props.editRecord(this.props.model.records[info.event.id]);}
onEventClick(info){this.click(info);}
onEventContent({event}){const record=this.props.model.records[event.id];if(record){const injectedContentStr=renderToString(this.constructor.eventTemplate,{...record,startTime:this.getStartTime(record),endTime:this.getEndTime(record),});const domParser=new DOMParser();const{children}=domParser.parseFromString(injectedContentStr,"text/html").body;return{domNodes:children};}
return true;}
eventClassNames({el,event}){const classesToAdd=[];classesToAdd.push("o_event");const record=this.props.model.records[event.id];if(record){const color=getColor(record.colorIndex);if(typeof color==="number"){classesToAdd.push(`o_calendar_color_${color}`);}else if(typeof color!=="string"){classesToAdd.push("o_calendar_color_0");}
if(record.isHatched){classesToAdd.push("o_event_hatched");}
if(record.isStriked){classesToAdd.push("o_event_striked");}
if(record.duration<=0.25){classesToAdd.push("o_event_oneliner");}
if(DateTime.now()>=record.end){classesToAdd.push("o_past_event");}
if(!record.isAllDay&&!record.isTimeHidden&&record.isMonth){classesToAdd.push("o_event_dot");}else if(record.isAllDay){classesToAdd.push("o_event_allday");}}
return classesToAdd;}
onEventDidMount({el,event}){el.dataset.eventId=event.id;const record=this.props.model.records[event.id];if(record){if(record.isMonth){el.querySelector(".fc-event-main").classList.add("d-flex","gap-1","text-truncate");}
const color=getColor(record.colorIndex);if(typeof color==="string"){el.style.backgroundColor=color;}
if(!el.classList.contains("fc-bg")){const bg=document.createElement("div");bg.classList.add("fc-bg");el.appendChild(bg);}}}
async onSelect(info){info.jsEvent.preventDefault();this.popover.close();await this.props.createRecord(this.fcEventToRecord(info));this.fc.api.unselect();}
isSelectionAllowed(event){return event.end.getDate()===event.start.getDate()||event.allDay;}
onEventDrop(info){this.fc.api.unselect();this.props.model.updateRecord(this.fcEventToRecord(info.event),{moved:true});}
onEventResize(info){this.fc.api.unselect();this.props.model.updateRecord(this.fcEventToRecord(info.event));}
fcEventToRecord(event){const{id,allDay,date,start,end}=event;const res={start:luxon.DateTime.fromJSDate(date||start),isAllDay:allDay,};if(end){res.end=luxon.DateTime.fromJSDate(end);if(["week","month"].includes(this.props.model.scale)&&allDay){res.end=res.end.minus({days:1});}}
if(id){const existingRecord=this.props.model.records[id];if(this.props.model.scale==="month"){res.start=res.start?.set({hour:existingRecord.start.hour,minute:existingRecord.start.minute,});if(existingRecord.end){res.end=res.end?.set({hour:existingRecord.end.hour,minute:existingRecord.end.minute,});}}
res.id=existingRecord.id;}
return res;}
onEventMouseEnter(info){this.highlightEvent(info.event,"o_cw_custom_highlight");}
onEventMouseLeave(info){if(!info.event.id){return;}
this.unhighlightEvent(info.event,"o_cw_custom_highlight");}
onEventDragStart(info){info.el.classList.add(info.view.type);this.fc.api.unselect();this.highlightEvent(info.event,"o_cw_custom_highlight");}
onEventResizeStart(info){this.fc.api.unselect();this.highlightEvent(info.event,"o_cw_custom_highlight");}
onEventLimitClick(){this.fc.api.unselect();return"popover";}
onWindowResize(){this.updateSize();}
getHeaderHtml({date}){return{html:renderToString(this.constructor.headerTemplate,this.headerTemplateProps(date)),};}
headerTemplateProps(date){const scale=this.props.model.scale;const options=scale==="month"?{zone:"UTC"}:{};const{weekdayShort,weekdayLong,day}=DateTime.fromJSDate(date,options);return{weekdayShort,weekdayLong,day,scale,};}
wrapMoreLink({el}){const wrapper=document.createElement("div");wrapper.classList.add("fc-more-cell");el.classList.remove("fc-daygrid-more-link");el.parentNode.insertBefore(wrapper,el);wrapper.appendChild(el);}}
return __exports;});;

/* /web/static/src/views/calendar/calendar_common/calendar_common_week_column.js */
odoo.define('@web/views/calendar/calendar_common/calendar_common_week_column',[],function(require){'use strict';let __exports={};__exports.makeWeekColumn=makeWeekColumn;function makeWeekColumn({el,showWeek,weekColumn,weekText}){const firstRows=el.querySelectorAll(".fc-col-header-cell:nth-child(1), .fc-day:nth-child(1)");for(const element of firstRows){const newElement=document.createElement("th");if(element.classList.contains("fc-col-header-cell")){newElement.classList.add("o-fc-week-header");newElement.innerText=weekText;}else{newElement.classList.add("o-fc-week");const weekElement=element.querySelector(".fc-daygrid-week-number");weekElement.classList.remove("fc-daygrid-week-number");newElement.append(weekElement);}
element.parentElement.insertBefore(newElement,element);}}
return __exports;});;

/* /web/static/src/views/calendar/calendar_controller.js */
odoo.define('@web/views/calendar/calendar_controller',['@web/core/confirmation_dialog/confirmation_dialog','@web/core/l10n/translation','@web/core/utils/hooks','@web/search/layout','@web/model/model','@web/views/view_dialogs/form_view_dialog','@web/search/action_hook','@web/core/datetime/datetime_picker','@web/views/calendar/filter_panel/calendar_filter_panel','@web/views/calendar/mobile_filter_panel/calendar_mobile_filter_panel','@web/views/calendar/quick_create/calendar_quick_create','@web/search/search_bar/search_bar','@web/search/search_bar/search_bar_toggler','@web/views/view_components/view_scale_selector','@web/search/cog_menu/cog_menu','@web/core/browser/browser','@web/views/standard_view_props','@web/core/l10n/dates','@odoo/owl'],function(require){'use strict';let __exports={};const{deleteConfirmationMessage,ConfirmationDialog,}=require("@web/core/confirmation_dialog/confirmation_dialog");const{_t}=require("@web/core/l10n/translation");const{useOwnedDialogs,useService}=require("@web/core/utils/hooks");const{Layout}=require("@web/search/layout");const{useModelWithSampleData}=require("@web/model/model");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");const{useSetupAction}=require("@web/search/action_hook");const{DateTimePicker}=require("@web/core/datetime/datetime_picker");const{CalendarFilterPanel}=require("@web/views/calendar/filter_panel/calendar_filter_panel");const{CalendarMobileFilterPanel}=require("@web/views/calendar/mobile_filter_panel/calendar_mobile_filter_panel");const{CalendarQuickCreate}=require("@web/views/calendar/quick_create/calendar_quick_create");const{SearchBar}=require("@web/search/search_bar/search_bar");const{useSearchBarToggler}=require("@web/search/search_bar/search_bar_toggler");const{ViewScaleSelector}=require("@web/views/view_components/view_scale_selector");const{CogMenu}=require("@web/search/cog_menu/cog_menu");const{browser}=require("@web/core/browser/browser");const{standardViewProps}=require("@web/views/standard_view_props");const{getLocalWeekNumber}=require("@web/core/l10n/dates");const{Component,useState}=require("@odoo/owl");const{DateTime}=luxon;const SCALE_LABELS=__exports.SCALE_LABELS={day:_t("Day"),week:_t("Week"),month:_t("Month"),year:_t("Year"),};function useUniqueDialog(){const displayDialog=useOwnedDialogs();let close=null;return(...args)=>{if(close){close();}
close=displayDialog(...args);};}
const CalendarController=__exports.CalendarController=class CalendarController extends Component{static components={DatePicker:DateTimePicker,FilterPanel:CalendarFilterPanel,MobileFilterPanel:CalendarMobileFilterPanel,QuickCreate:CalendarQuickCreate,QuickCreateFormView:FormViewDialog,Layout,SearchBar,ViewScaleSelector,CogMenu,};static template="web.CalendarController";static props={...standardViewProps,Model:Function,Renderer:Function,archInfo:Object,buttonTemplate:String,session:{type:Object,optional:true},itemCalendarProps:{type:Object,optional:true},};setup(){this.action=useService("action");this.orm=useService("orm");this.displayDialog=useUniqueDialog();this.model=useModelWithSampleData(this.props.Model,{...this.props.archInfo,resModel:this.props.resModel,domain:this.props.domain,fields:this.props.fields,allFilter:this.props.state?.allFilter??{},date:this.props.state?.date,},{onWillStart:this.onWillStartModel.bind(this),});useSetupAction({getLocalState:()=>this.model.exportedState,});const sessionShowSidebar=browser.sessionStorage.getItem("calendar.showSideBar");this.state=useState({isWeekendVisible:browser.localStorage.getItem("calendar.isWeekendVisible")!=null?JSON.parse(browser.localStorage.getItem("calendar.isWeekendVisible")):true,showSideBar:!this.env.isSmall&&Boolean(sessionShowSidebar!=null?JSON.parse(sessionShowSidebar):true),});this.searchBarToggler=useSearchBarToggler();}
get currentDate(){const meta=this.model.meta;const scale=meta.scale;if(this.env.isSmall&&["week","month"].includes(scale)){const date=meta.date||DateTime.now();let text="";if(scale==="week"){const startMonth=date.startOf("week");const endMonth=date.endOf("week");if(startMonth.toFormat("LLL")!==endMonth.toFormat("LLL")){text=`${startMonth.toFormat("LLL")}-${endMonth.toFormat("LLL")}`;}else{text=startMonth.toFormat("LLLL");}}else if(scale==="month"){text=date.toFormat("LLLL");}
return` - ${text} ${date.year}`;}else{return"";}}
get date(){return this.model.meta.date||DateTime.now();}
get today(){return DateTime.now().toFormat("d");}
get currentYear(){return this.date.toFormat("y");}
get dayHeader(){return`${this.date.toFormat("d")} ${this.date.toFormat("MMMM")} ${this.date.year}`;}
get weekHeader(){const{rangeStart,rangeEnd}=this.model;if(rangeStart.year!=rangeEnd.year){return`${rangeStart.toFormat("MMMM")} ${rangeStart.year} - ${rangeEnd.toFormat(
                "MMMM"
            )} ${rangeEnd.year}`;}else if(rangeStart.month!=rangeEnd.month){return`${rangeStart.toFormat("MMMM")} - ${rangeEnd.toFormat("MMMM")} ${
                rangeStart.year
            }`;}
return`${rangeStart.toFormat("MMMM")} ${rangeStart.year}`;}
get currentMonth(){return`${this.date.toFormat("MMMM")} ${this.date.year}`;}
get currentWeek(){return getLocalWeekNumber(this.model.rangeStart);}
get rendererProps(){return{model:this.model,isWeekendVisible:this.model.scale==="day"||this.state.isWeekendVisible,createRecord:this.createRecord.bind(this),deleteRecord:this.deleteRecord.bind(this),editRecord:this.editRecord.bind(this),setDate:this.setDate.bind(this),};}
get containerProps(){return{model:this.model,};}
get datePickerProps(){return{type:"date",showWeekNumbers:false,maxPrecision:"days",daysOfWeekFormat:"narrow",onSelect:(date)=>{let scale="week";if(this.model.date.hasSame(date,"day")){const scales=["month","week","day"];scale=scales[(scales.indexOf(this.model.scale)+1)%scales.length];}else{const currentDate=this.model.date.weekday===7?this.model.date.plus({day:1}):this.model.date;const pickedDate=date.weekday===7?date.plus({day:1}):date;if(currentDate.hasSame(pickedDate,"week")){scale="day";}}
this.model.load({scale,date});},value:this.model.date,};}
get filterPanelProps(){return{model:this.model,};}
get mobileFilterPanelProps(){return{model:this.model,sideBarShown:this.state.showSideBar,toggleSideBar:()=>{this.state.showSideBar=!this.state.showSideBar;},};}
toggleSideBar(){this.state.showSideBar=!this.state.showSideBar;browser.sessionStorage.setItem("calendar.showSideBar",this.state.showSideBar);}
get showCalendar(){return!this.env.isSmall||!this.state.showSideBar;}
get showSideBar(){return this.state.showSideBar;}
get className(){return this.props.className;}
get editRecordDefaultDisplayText(){return _t("New Event");}
getQuickCreateProps(record){return{record,model:this.model,editRecord:this.editRecordInCreation.bind(this),title:this.props.context.default_name,};}
getQuickCreateFormViewProps(record){const rawRecord=this.model.buildRawRecord(record);const context=this.model.makeContextDefaults(rawRecord);return{resModel:this.model.resModel,viewId:this.model.quickCreateFormViewId,title:_t("New Event"),context,};}
createRecord(record){if(!this.model.canCreate){return;}
if(this.model.hasQuickCreate){if(this.model.quickCreateFormViewId){return new Promise((resolve)=>{this.displayDialog(this.constructor.components.QuickCreateFormView,this.getQuickCreateFormViewProps(record),{onClose:()=>resolve(),});});}
return new Promise((resolve)=>{this.displayDialog(this.constructor.components.QuickCreate,this.getQuickCreateProps(record),{onClose:()=>resolve(),});});}else{return this.editRecordInCreation(record);}}
async editRecord(record,context={},shouldFetchFormViewId=true){if(this.model.hasEditDialog){return new Promise((resolve)=>{this.displayDialog(FormViewDialog,{resModel:this.model.resModel,resId:record.id||false,context,title:record.id?_t("Open: %s",record.title):this.editRecordDefaultDisplayText,viewId:this.model.formViewId,onRecordSaved:()=>this.model.load(),},{onClose:()=>resolve()});});}else{let formViewId=this.model.formViewId;if(shouldFetchFormViewId){formViewId=await this.orm.call(this.model.resModel,"get_formview_id",[[record.id]],context);}
const action={type:"ir.actions.act_window",res_model:this.model.resModel,views:[[formViewId||false,"form"]],target:"current",context,};if(record.id){action.res_id=record.id;}
this.action.doAction(action);}}
editRecordInCreation(record){const rawRecord=this.model.buildRawRecord(record);const context=this.model.makeContextDefaults(rawRecord);return this.editRecord(record,context,false);}
deleteConfirmationDialogProps(record){return{title:_t("Bye-bye, record!"),body:deleteConfirmationMessage,confirm:()=>{this.model.unlinkRecord(record.id);},confirmLabel:_t("Delete"),cancel:()=>{},cancelLabel:_t("No, keep it"),};}
deleteRecord(record){this.displayDialog(ConfirmationDialog,this.deleteConfirmationDialogProps(record));}
onWillStartModel(){}
async setDate(move){let date=null;switch(move){case"next":date=this.model.date.plus({[`${this.model.scale}s`]:1});break;case"previous":date=this.model.date.minus({[`${this.model.scale}s`]:1});break;case"today":date=luxon.DateTime.local().startOf("day");if(date.ts===this.date.startOf("day").ts){this.model.bus.trigger("SCROLL_TO_CURRENT_HOUR",false);}
break;}
await this.model.load({date});}
get scales(){return Object.fromEntries(this.model.scales.map((s)=>[s,{description:SCALE_LABELS[s]}]));}
async setScale(scale){await this.model.load({scale});browser.sessionStorage.setItem("calendar-scale",this.model.scale);}
toggleWeekendVisibility(){this.state.isWeekendVisible=!this.state.isWeekendVisible;browser.localStorage.setItem("calendar.isWeekendVisible",this.state.isWeekendVisible);}}
return __exports;});;

/* /web/static/src/views/calendar/calendar_model.js */
odoo.define('@web/views/calendar/calendar_model',['@web/core/l10n/dates','@web/core/l10n/localization','@web/core/l10n/translation','@web/core/registry','@web/core/user','@web/core/utils/concurrency','@web/model/model','@web/model/relational_model/utils','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{serializeDate,serializeDateTime,deserializeDate,deserializeDateTime,}=require("@web/core/l10n/dates");const{localization}=require("@web/core/l10n/localization");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{KeepLast}=require("@web/core/utils/concurrency");const{Model}=require("@web/model/model");const{extractFieldsFromArchInfo}=require("@web/model/relational_model/utils");const{browser}=require("@web/core/browser/browser");const CalendarModel=__exports.CalendarModel=class CalendarModel extends Model{setup(params,services){this.keepLast=new KeepLast();const formViewFromConfig=(this.env.config.views||[]).find((view)=>view[1]==="form");const formViewIdFromConfig=formViewFromConfig?formViewFromConfig[0]:false;const fieldNodes=params.popoverFieldNodes;const{activeFields,fields}=extractFieldsFromArchInfo({fieldNodes},params.fields);this.meta={...params,activeFields,fields,firstDayOfWeek:(localization.weekStart||0)%7,formViewId:params.formViewId||formViewIdFromConfig,};this.meta.scale=this.getLocalStorageScale();this.data={filters:{},filterSections:{},hasCreateRight:null,range:null,records:{},unusualDays:[],};}
async load(params={}){Object.assign(this.meta,params);if(!this.meta.date){this.meta.date=params.context&&params.context.initial_date?deserializeDateTime(params.context.initial_date).startOf("day"):luxon.DateTime.local().startOf("day");}
if(!this.meta.scales.includes(this.meta.scale)){this.meta.scale=this.meta.scales[0];}
browser.localStorage.setItem(this.storageKey,this.meta.scale);const data={...this.data};await this.keepLast.add(this.updateData(data));this.data=data;this.notify();}
get date(){return this.meta.date;}
get canCreate(){return this.meta.canCreate&&this.data.hasCreateRight;}
get canDelete(){return this.meta.canDelete;}
get canEdit(){return this.meta.canEdit&&!this.meta.fields[this.meta.fieldMapping.date_start].readonly;}
get eventLimit(){return this.meta.eventLimit;}
get exportedState(){return this.meta;}
get fieldMapping(){return this.meta.fieldMapping;}
get fields(){return this.meta.fields;}
get filterSections(){return Object.values(this.data.filterSections);}
get firstDayOfWeek(){return this.meta.firstDayOfWeek;}
get formViewId(){return this.meta.formViewId;}
get hasAllDaySlot(){return(this.meta.fieldMapping.all_day||this.meta.fields[this.meta.fieldMapping.date_start].type==="date");}
get hasEditDialog(){return this.meta.hasEditDialog;}
get hasQuickCreate(){return this.meta.quickCreate;}
get isDateHidden(){return this.meta.isDateHidden;}
get isTimeHidden(){return this.meta.isTimeHidden;}
get popoverFieldNodes(){return this.meta.popoverFieldNodes;}
get activeFields(){return this.meta.activeFields;}
get rangeEnd(){return this.data.range.end;}
get rangeStart(){return this.data.range.start;}
get records(){return this.data.records;}
get resModel(){return this.meta.resModel;}
get scale(){return this.meta.scale;}
get scales(){return this.meta.scales;}
get storageKey(){return`scaleOf-viewId-${this.env.config.viewId}`;}
get unusualDays(){return this.data.unusualDays;}
get quickCreateFormViewId(){return this.meta.quickCreateViewId;}
get defaultFilterLabel(){return _t("Undefined");}
async createFilter(fieldName,filterValue){const info=this.meta.filtersInfo[fieldName];if(!info||!info.writeFieldName||!info.writeResModel){return;}
const normalizedFilterValue=Array.isArray(filterValue)?filterValue:[filterValue];const dataArray=normalizedFilterValue.map((value)=>{const data={user_id:user.userId,[info.writeFieldName]:value,};if(info.filterFieldName){data[info.filterFieldName]=true;}
return data;});await this.orm.create(info.writeResModel,dataArray);await this.load();}
async createRecord(record){const rawRecord=this.buildRawRecord(record);const context=this.makeContextDefaults(rawRecord);await this.orm.create(this.meta.resModel,[rawRecord],{context});await this.load();}
async unlinkFilter(fieldName,recordId){const info=this.meta.filtersInfo[fieldName];if(info&&info.writeResModel){await this.orm.unlink(info.writeResModel,[recordId]);await this.load();}}
async unlinkRecord(recordId){await this.orm.unlink(this.meta.resModel,[recordId]);await this.load();}
async updateFilters(fieldName,filters){const section=this.data.filterSections[fieldName];if(section){for(const value in filters){const active=filters[value];const filter=section.filters.find((filter)=>`${filter.value}`===value);if(filter){filter.active=active;const info=this.meta.filtersInfo[fieldName];if(filter.recordId&&info&&info.writeFieldName&&info.writeResModel&&info.filterFieldName){const data={[info.filterFieldName]:active,};await this.orm.write(info.writeResModel,[filter.recordId],data);}else if(filter.type==="all"){this.meta.allFilter[section.label]=active;}}}}
await this.load();}
async updateRecord(record,options={}){const rawRecord=this.buildRawRecord(record,options);delete rawRecord.name;await this.orm.write(this.meta.resModel,[record.id],rawRecord,{context:{from_ui:true},});await this.load();}
getAllDayDates(start,end){return[start.set({hours:7}),end.set({hours:19})];}
buildRawRecord(partialRecord,options={}){const data={};data[this.meta.fieldMapping.create_name_field||"name"]=partialRecord.title;let start=partialRecord.start;let end=partialRecord.end;if(!end||!end.isValid){if(partialRecord.isAllDay){end=start;}else{end=start.plus({hours:options.duration_hour||1});}}
const isDateEvent=this.fields[this.meta.fieldMapping.date_start].type==="date";if(partialRecord.isAllDay){if(!this.hasAllDaySlot&&!isDateEvent&&!partialRecord.id){[start,end]=this.getAllDayDates(start,end);}}
if(this.meta.fieldMapping.all_day){data[this.meta.fieldMapping.all_day]=partialRecord.isAllDay;}
data[this.meta.fieldMapping.date_start]=(partialRecord.isAllDay&&this.hasAllDaySlot?"date":this.fields[this.meta.fieldMapping.date_start].type)==="date"?serializeDate(start):serializeDateTime(start);if(this.meta.fieldMapping.date_stop){data[this.meta.fieldMapping.date_stop]=(partialRecord.isAllDay&&this.hasAllDaySlot?"date":this.fields[this.meta.fieldMapping.date_start].type)==="date"?serializeDate(end):serializeDateTime(end);}
if(this.meta.fieldMapping.date_delay){if(this.meta.scale!=="month"||!options.moved){data[this.meta.fieldMapping.date_delay]=end.diff(start,"hours").hours;}}
return data;}
makeContextDefaults(rawRecord){const{fieldMapping,scale}=this.meta;const context={...this.meta.context};const fieldNames=[fieldMapping.create_name_field||"name",fieldMapping.date_start,fieldMapping.date_stop,fieldMapping.date_delay,fieldMapping.all_day||"allday",];for(const fieldName of fieldNames){if(rawRecord[fieldName]!==undefined){context[`default_${fieldName}`]=rawRecord[fieldName];}}
if(["month","year"].includes(scale)){context[`default_${fieldMapping.all_day || "allday"}`]=true;}
return context;}
async updateData(data){if(data.hasCreateRight===null){data.hasCreateRight=await user.checkAccessRight(this.meta.resModel,"create");}
data.range=this.computeRange();if(this.meta.showUnusualDays){data.unusualDays=await this.loadUnusualDays(data);}
const{sections,dynamicFiltersInfo}=await this.loadFilters(data);data.filterSections=sections;data.records=await this.loadRecords(data);const dynamicSections=await this.loadDynamicFilters(data,dynamicFiltersInfo);Object.assign(data.filterSections,dynamicSections);for(const[recordId,record]of Object.entries(data.records)){for(const[fieldName,filterInfo]of Object.entries(dynamicSections)){for(const filter of filterInfo.filters){const rawValue=record.rawRecord[fieldName];const value=Array.isArray(rawValue)?rawValue[0]:rawValue;if(filter.value===value&&!filter.active){delete data.records[recordId];}}}}}
computeRange(){const{scale,date,firstDayOfWeek}=this.meta;let start=date;let end=date;if(scale!=="week"){start=start.startOf(scale);end=end.endOf(scale);}
if(["week","month"].includes(scale)){const currentWeekOffset=(start.weekday-firstDayOfWeek+7)%7;start=start.minus({days:currentWeekOffset});end=start.plus({weeks:scale==="week"?1:6,days:-1});}
start=start.startOf("day");end=end.endOf("day");return{start,end};}
computeDomain(data){return[...this.meta.domain,...this.computeRangeDomain(data),...this.computeFiltersDomain(data),];}
computeFiltersDomain(data){const authorizedValues={};const avoidValues={};for(const[fieldName,filterSection]of Object.entries(data.filterSections)){const filterAll=filterSection.filters.find((f)=>f.type==="all");if(!(filterAll&&filterAll.active)){const filterSectionInfo=this.meta.filtersInfo[fieldName];for(const filter of filterSection.filters){if(filterSectionInfo.writeResModel){if(!authorizedValues[fieldName]){authorizedValues[fieldName]=[];}
if(filter.active){authorizedValues[fieldName].push(filter.value);}}else{if(!filter.active){if(!avoidValues[fieldName]){avoidValues[fieldName]=[];}
avoidValues[fieldName].push(filter.value);}}}}}
const domain=[];for(const field in authorizedValues){domain.push([field,"in",authorizedValues[field]]);}
for(const field in avoidValues){if(avoidValues[field].length>0){domain.push([field,"not in",avoidValues[field]]);}}
return domain;}
computeRangeDomain(data){const{fieldMapping}=this.meta;const formattedEnd=serializeDateTime(data.range.end);const formattedStart=serializeDateTime(data.range.start);const domain=[[fieldMapping.date_start,"<=",formattedEnd]];if(fieldMapping.date_stop){domain.push([fieldMapping.date_stop,">=",formattedStart]);}else if(!fieldMapping.date_delay){domain.push([fieldMapping.date_start,">=",formattedStart]);}
return domain;}
fetchUnusualDays(data){return this.orm.call(this.meta.resModel,"get_unusual_days",[serializeDateTime(data.range.start),serializeDateTime(data.range.end),]);}
async loadUnusualDays(data){const unusualDays=await this.fetchUnusualDays(data);return Object.entries(unusualDays).filter((entry)=>entry[1]).map((entry)=>entry[0]);}
fetchRecords(data){const{fieldNames,resModel}=this.meta;return this.orm.searchRead(resModel,this.computeDomain(data),[...new Set([...fieldNames,...Object.keys(this.meta.activeFields)]),]);}
async loadRecords(data){const rawRecords=await this.fetchRecords(data);const records={};for(const rawRecord of rawRecords){records[rawRecord.id]=this.normalizeRecord(rawRecord);}
return records;}
normalizeRecord(rawRecord){const{fields,fieldMapping,isTimeHidden}=this.meta;const startType=fields[fieldMapping.date_start].type;const isAllDay=startType==="date"||(fieldMapping.all_day&&rawRecord[fieldMapping.all_day])||false;let start=isAllDay?deserializeDate(rawRecord[fieldMapping.date_start]):deserializeDateTime(rawRecord[fieldMapping.date_start]);let end=start;let endType=startType;if(fieldMapping.date_stop){endType=fields[fieldMapping.date_stop].type;end=isAllDay?deserializeDate(rawRecord[fieldMapping.date_stop]):deserializeDateTime(rawRecord[fieldMapping.date_stop]);}
const duration=rawRecord[fieldMapping.date_delay]||1;if(isAllDay){start=start.startOf("day");end=end.startOf("day");}
if(!fieldMapping.date_stop&&duration){end=start.plus({hours:duration});}
const showTime=!(fieldMapping.all_day&&rawRecord[fieldMapping.all_day])&&startType!=="date"&&start.day===end.day;const colorValue=rawRecord[fieldMapping.color];const colorIndex=Array.isArray(colorValue)?colorValue[0]:colorValue;const title=rawRecord[fieldMapping.create_name_field||"display_name"];return{id:rawRecord.id,title,isAllDay,start,startType,end,endType,duration,colorIndex,isHatched:rawRecord["is_hatched"]||false,isStriked:rawRecord["is_striked"]||false,isTimeHidden:isTimeHidden||!showTime,isMonth:this.meta.scale==="month",isSmall:this.env.isSmall,rawRecord,};}
addFilterFields(record,filterInfo){return{colorIndex:record.colorIndex,};}
fetchFilters(resModel,fieldNames){return this.orm.searchRead(resModel,[["user_id","=",user.userId]],fieldNames);}
getLocalStorageScale(){const localScaleId=browser.localStorage.getItem(this.storageKey);return this.meta.scales.includes(localScaleId)?localScaleId:this.meta.scale;}
async loadFilters(data){const previousSections=data.filterSections;const sections={};const dynamicFiltersInfo={};for(const[fieldName,filterInfo]of Object.entries(this.meta.filtersInfo)){const previousSection=previousSections[fieldName];if(filterInfo.writeResModel){sections[fieldName]=await this.loadFilterSection(fieldName,filterInfo,previousSection);}else{dynamicFiltersInfo[fieldName]={filterInfo,previousSection};}}
return{sections,dynamicFiltersInfo};}
async loadFilterSection(fieldName,filterInfo,previousSection){const{filterFieldName,writeFieldName,writeResModel}=filterInfo;const fields=[writeFieldName,filterFieldName].filter(Boolean);const rawFilters=await this.fetchFilters(writeResModel,fields);const previousFilters=previousSection?previousSection.filters:[];const filters=rawFilters.map((rawFilter)=>{const previousRecordFilter=previousFilters.find((f)=>f.type==="record"&&f.recordId===rawFilter.id);return this.makeFilterRecord(filterInfo,previousRecordFilter,rawFilter);});const field=this.meta.fields[fieldName];const isUserOrPartner=["res.users","res.partner"].includes(field.relation);if(isUserOrPartner){const previousUserFilter=previousFilters.find((f)=>f.type==="user");filters.push(this.makeFilterUser(filterInfo,previousUserFilter,fieldName,rawFilters));}
const previousAllFilter=previousFilters.find((f)=>f.type==="all");filters.push(this.makeFilterAll(previousAllFilter,isUserOrPartner,filterInfo.label));return{label:filterInfo.label,fieldName,filters,avatar:{field:filterInfo.avatarFieldName,model:filterInfo.resModel,},hasAvatar:!!filterInfo.avatarFieldName,write:{field:writeFieldName,model:writeResModel,},canCollapse:filters.length>2,canAddFilter:!!filterInfo.writeResModel,};}
async loadDynamicFilters(data,filtersInfo){const sections={};for(const[fieldName,{filterInfo,previousSection}]of Object.entries(filtersInfo)){sections[fieldName]=await this.loadDynamicFilterSection(data,fieldName,filterInfo,previousSection);}
return sections;}
async loadDynamicFilterSection(data,fieldName,filterInfo,previousSection){const{fields,fieldMapping}=this.meta;const field=fields[fieldName];const previousFilters=previousSection?previousSection.filters:[];const rawFilters=Object.values(data.records).reduce((filters,record)=>{const rawValues=["many2many","one2many"].includes(field.type)?record.rawRecord[fieldName]:[record.rawRecord[fieldName]];for(const rawValue of rawValues){const value=Array.isArray(rawValue)?rawValue[0]:rawValue;if(!filters.find((f)=>f.id===value)){filters.push({id:value,[fieldName]:rawValue,...this.addFilterFields(record,filterInfo),});}}
return filters;},[]);const{colorFieldName}=filterInfo;const shouldFetchColor=colorFieldName&&(!fieldMapping.color||`${fieldName}.${colorFieldName}`!==fields[fieldMapping.color].related);let rawColors=[];if(shouldFetchColor){const relatedIds=rawFilters.map(({id})=>id);if(relatedIds.length){rawColors=await this.orm.searchRead(field.relation,[["id","in",relatedIds]],[colorFieldName]);}}
const filters=rawFilters.map((rawFilter)=>{const previousDynamicFilter=previousFilters.find((f)=>f.type==="dynamic"&&f.value===rawFilter.id);return this.makeFilterDynamic(filterInfo,previousDynamicFilter,fieldName,rawFilter,rawColors);});return{label:filterInfo.label,fieldName,filters,avatar:{field:filterInfo.avatarFieldName,model:filterInfo.resModel,},hasAvatar:!!filterInfo.avatarFieldName,write:{field:filterInfo.writeFieldName,model:filterInfo.writeResModel,},canCollapse:filters.length>2,canAddFilter:!!filterInfo.writeResModel,};}
makeFilterDynamic(filterInfo,previousFilter,fieldName,rawFilter,rawColors){const{fieldMapping,fields}=this.meta;const rawValue=rawFilter[fieldName];const value=Array.isArray(rawValue)?rawValue[0]:rawValue;const field=fields[fieldName];const formatter=registry.category("formatters").get(field.type);const{colorFieldName}=filterInfo;const colorField=fields[fieldMapping.color];const hasFilterColorAttr=!!colorFieldName;const sameRelatedModel=colorField&&(colorField.relation===field.relation||(colorField.related&&colorField.related.startsWith(`${fieldName}.`)));let colorIndex=null;if(hasFilterColorAttr||sameRelatedModel){colorIndex=rawFilter.colorIndex;}
if(rawColors.length){const rawColor=rawColors.find(({id})=>id===value);colorIndex=rawColor?rawColor[colorFieldName]:0;}
return{type:"dynamic",recordId:null,value,label:formatter(rawValue,{field})||this.defaultFilterLabel,active:previousFilter?previousFilter.active:true,canRemove:false,colorIndex,hasAvatar:!!value,};}
makeFilterRecord(filterInfo,previousFilter,rawRecord){const{colorFieldName,filterFieldName,writeFieldName}=filterInfo;const{fields,fieldMapping}=this.meta;const raw=rawRecord[writeFieldName];const value=Array.isArray(raw)?raw[0]:raw;const field=fields[writeFieldName];const isX2Many=["many2many","one2many"].includes(field.type);const formatter=registry.category("formatters").get(isX2Many?"many2one":field.type);const colorField=fields[fieldMapping.color];const colorValue=colorField&&(()=>{const sameRelatedModel=colorField.relation===field.relation;const sameRelatedField=colorField.related===`${writeFieldName}.${colorFieldName}`;const shouldHaveColor=sameRelatedModel||sameRelatedField;const colorToUse=raw?value:rawRecord[fieldMapping.color];return shouldHaveColor?colorToUse:null;})();const colorIndex=Array.isArray(colorValue)?colorValue[0]:colorValue;let active=false;if(previousFilter){active=previousFilter.active;}else if(filterFieldName){active=rawRecord[filterFieldName];}
return{type:"record",recordId:rawRecord.id,value,label:formatter(raw),active,canRemove:true,colorIndex,hasAvatar:!!value,};}
makeFilterUser(filterInfo,previousFilter,fieldName,rawRecords){const field=this.meta.fields[fieldName];const userFieldName=field.relation==="res.partner"?"partnerId":"userId";const value=user[userFieldName];let colorIndex=value;const rawRecord=rawRecords.find((r)=>r[filterInfo.writeFieldName][0]===value);if(filterInfo.colorFieldName&&rawRecord){const colorValue=rawRecord[filterInfo.colorFieldName];colorIndex=Array.isArray(colorValue)?colorValue[0]:colorValue;}
return{type:"user",recordId:null,value,label:user.name,active:previousFilter?previousFilter.active:true,canRemove:false,colorIndex,hasAvatar:!!value,};}
makeFilterAll(previousAllFilter,isUserOrPartner,sectionLabel){return{type:"all",recordId:null,value:"all",label:isUserOrPartner?_t("Everybody's calendars"):_t("Everything"),active:previousAllFilter?previousAllFilter.active:this.meta.allFilter[sectionLabel]||false,canRemove:false,colorIndex:null,hasAvatar:false,};}}
return __exports;});;

/* /web/static/src/views/calendar/calendar_renderer.js */
odoo.define('@web/views/calendar/calendar_renderer',['@web/core/action_swiper/action_swiper','@web/views/calendar/calendar_common/calendar_common_renderer','@web/views/calendar/calendar_year/calendar_year_renderer','@odoo/owl'],function(require){'use strict';let __exports={};const{ActionSwiper}=require("@web/core/action_swiper/action_swiper");const{CalendarCommonRenderer}=require("@web/views/calendar/calendar_common/calendar_common_renderer");const{CalendarYearRenderer}=require("@web/views/calendar/calendar_year/calendar_year_renderer");const{Component}=require("@odoo/owl");const CalendarRenderer=__exports.CalendarRenderer=class CalendarRenderer extends Component{static template="web.CalendarRenderer";static components={day:CalendarCommonRenderer,week:CalendarCommonRenderer,month:CalendarCommonRenderer,year:CalendarYearRenderer,ActionSwiper,};static props={model:Object,isWeekendVisible:Boolean,createRecord:Function,editRecord:Function,deleteRecord:Function,setDate:Function,};get calendarComponent(){return this.constructor.components[this.props.model.scale];}
get calendarKey(){return`${this.props.model.scale}_${this.props.model.date.valueOf()}`;}
get actionSwiperProps(){return{onLeftSwipe:this.env.isSmall?{action:()=>this.props.setDate("next")}:undefined,onRightSwipe:this.env.isSmall?{action:()=>this.props.setDate("previous")}:undefined,animationOnMove:false,animationType:"forwards",swipeDistanceRatio:6,swipeInvalid:()=>Boolean(document.querySelector(".o_event.fc-mirror")),};}}
return __exports;});;

/* /web/static/src/views/calendar/calendar_view.js */
odoo.define('@web/views/calendar/calendar_view',['@web/core/registry','@web/views/calendar/calendar_renderer','@web/views/calendar/calendar_arch_parser','@web/views/calendar/calendar_model','@web/views/calendar/calendar_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{CalendarRenderer}=require("@web/views/calendar/calendar_renderer");const{CalendarArchParser}=require("@web/views/calendar/calendar_arch_parser");const{CalendarModel}=require("@web/views/calendar/calendar_model");const{CalendarController}=require("@web/views/calendar/calendar_controller");const calendarView=__exports.calendarView={type:"calendar",searchMenuTypes:["filter","favorite"],ArchParser:CalendarArchParser,Controller:CalendarController,Model:CalendarModel,Renderer:CalendarRenderer,buttonTemplate:"web.CalendarController.controlButtons",props:(props,view)=>{const{ArchParser}=view;const{arch,relatedModels,resModel}=props;const archInfo=new ArchParser().parse(arch,relatedModels,resModel);return{...props,Model:view.Model,Renderer:view.Renderer,buttonTemplate:view.buttonTemplate,archInfo,};},};registry.category("views").add("calendar",calendarView);return __exports;});;

/* /web/static/src/views/calendar/calendar_year/calendar_year_popover.js */
odoo.define('@web/views/calendar/calendar_year/calendar_year_popover',['@web/core/dialog/dialog','@web/core/l10n/dates','@web/views/calendar/colors','@web/views/calendar/utils','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{formatDate}=require("@web/core/l10n/dates");const{getColor}=require("@web/views/calendar/colors");const{getFormattedDateSpan}=require("@web/views/calendar/utils");const{Component}=require("@odoo/owl");const CalendarYearPopover=__exports.CalendarYearPopover=class CalendarYearPopover extends Component{static components={Dialog};static template="web.CalendarYearPopover";static subTemplates={popover:"web.CalendarYearPopover.popover",body:"web.CalendarYearPopover.body",footer:"web.CalendarYearPopover.footer",record:"web.CalendarYearPopover.record",};static props={close:Function,date:true,model:Object,records:Array,createRecord:Function,deleteRecord:Function,editRecord:Function,};get recordGroups(){return this.computeRecordGroups();}
get dialogTitle(){return formatDate(this.props.date,{format:"DDD"});}
computeRecordGroups(){const recordGroups=this.groupRecords();return this.getSortedRecordGroups(recordGroups);}
groupRecords(){const recordGroups={};for(const record of this.props.records){const start=record.start;const end=record.end;const duration=end.diff(start,"days").days;const modifiedRecord=Object.create(record);modifiedRecord.startHour=!record.isAllDay&&duration<1?start.toFormat("HH:mm"):"";const formattedDate=getFormattedDateSpan(start,end);if(!(formattedDate in recordGroups)){recordGroups[formattedDate]={title:formattedDate,start,end,records:[],};}
recordGroups[formattedDate].records.push(modifiedRecord);}
return Object.values(recordGroups);}
getRecordClass(record){const{colorIndex}=record;const color=getColor(colorIndex);if(color&&typeof color==="number"){return`o_calendar_color_${color}`;}
return"";}
getRecordStyle(record){const{colorIndex}=record;const color=getColor(colorIndex);if(color&&typeof color==="string"){return`background-color: ${color};`;}
return"";}
getSortedRecordGroups(recordGroups){return recordGroups.sort((a,b)=>{if(a.start.hasSame(a.end,"days")){return Number.MIN_SAFE_INTEGER;}else if(b.start.hasSame(b.end,"days")){return Number.MAX_SAFE_INTEGER;}else if(a.start.toMillis()-b.start.toMillis()===0){return a.end.toMillis()-b.end.toMillis();}
return a.start.toMillis()-b.start.toMillis();});}
onCreateButtonClick(){this.props.createRecord({start:this.props.date,isAllDay:true,});this.props.close();}
onRecordClick(record){this.props.editRecord(record);this.props.close();}}
return __exports;});;

/* /web/static/src/views/calendar/calendar_year/calendar_year_renderer.js */
odoo.define('@web/views/calendar/calendar_year/calendar_year_renderer',['@web/core/l10n/localization','@web/core/utils/timing','@web/views/calendar/colors','@web/views/calendar/hooks','@web/views/calendar/calendar_year/calendar_year_popover','@web/views/calendar/calendar_common/calendar_common_week_column','@web/core/l10n/dates','@odoo/owl'],function(require){'use strict';let __exports={};const{localization}=require("@web/core/l10n/localization");const{useDebounced}=require("@web/core/utils/timing");const{getColor}=require("@web/views/calendar/colors");const{useCalendarPopover,useFullCalendar}=require("@web/views/calendar/hooks");const{CalendarYearPopover}=require("@web/views/calendar/calendar_year/calendar_year_popover");const{makeWeekColumn}=require("@web/views/calendar/calendar_common/calendar_common_week_column");const{getLocalWeekNumber}=require("@web/core/l10n/dates");const{Component,useEffect,useRef}=require("@odoo/owl");const CalendarYearRenderer=__exports.CalendarYearRenderer=class CalendarYearRenderer extends Component{static components={Popover:CalendarYearPopover,};static template="web.CalendarYearRenderer";static props={model:Object,displayName:{type:String,optional:true},isWeekendVisible:{type:Boolean,optional:true},createRecord:Function,editRecord:Function,deleteRecord:Function,setDate:{type:Function,optional:true},};setup(){this.months=luxon.Info.months();this.fcs={};for(const month of this.months){this.fcs[month]=useFullCalendar(`fullCalendar-${month}`,this.getOptionsForMonth(month));}
this.popover=useCalendarPopover(this.constructor.components.Popover);this.rootRef=useRef("root");this.onWindowResizeDebounced=useDebounced(this.onWindowResize,200);useEffect(()=>{this.updateSize();});}
get options(){return{dayHeaderFormat:"EEEEE",dateClick:this.onDateClick,dayCellClassNames:this.getDayCellClassNames,initialDate:this.props.model.date.toISO(),initialView:"dayGridMonth",direction:localization.direction,droppable:true,editable:this.props.model.canEdit,dayMaxEventRows:this.props.model.eventLimit,eventClassNames:this.eventClassNames,eventDidMount:this.onEventDidMount,eventResizableFromStart:true,events:(_,successCb)=>successCb(this.mapRecordsToEvents()),firstDay:this.props.model.firstDayOfWeek,headerToolbar:{start:false,center:"title",end:false},height:"auto",locale:luxon.Settings.defaultLocale,longPressDelay:500,navLinks:false,nowIndicator:true,select:this.onSelect,selectMinDistance:5,selectMirror:true,selectable:this.props.model.canCreate,showNonCurrentDates:false,timeZone:luxon.Settings.defaultZone.name,titleFormat:{month:"long",year:"numeric"},unselectAuto:false,weekNumberCalculation:(date)=>getLocalWeekNumber(date),weekNumbers:false,weekNumberFormat:{week:"numeric"},windowResize:this.onWindowResizeDebounced,eventContent:this.onEventContent,viewDidMount:this.viewDidMount,weekends:this.props.isWeekendVisible,};}
get customOptions(){return{weekNumbersWithinDays:true,};}
viewDidMount({el,view}){const showWeek=view.calendar.currentData.options.weekNumbers;const weekText=view.calendar.currentData.options.weekText;const weekColumn=!this.customOptions.weekNumbersWithinDays;if(showWeek&&weekColumn){makeWeekColumn({el,weekText});}}
mapRecordsToEvents(){return Object.values(this.props.model.records).map((r)=>this.convertRecordToEvent(r));}
convertRecordToEvent(record){return{id:record.id,title:record.title,start:record.start.toISO(),end:record.end.plus({day:1}).toISO(),allDay:true,display:"background",};}
getDateWithMonth(month){return this.props.model.date.set({month:this.months.indexOf(month)+1}).toISO();}
getOptionsForMonth(month){return{...this.options,initialDate:this.getDateWithMonth(month),};}
getPopoverProps(date,records){return{date,records,model:this.props.model,createRecord:this.props.createRecord,deleteRecord:this.props.deleteRecord,editRecord:this.props.editRecord,};}
openPopover(target,date,records){this.popover.open(target,this.getPopoverProps(date,records),"o_cw_popover");}
unselect(){for(const fc of Object.values(this.fcs)){fc.api.unselect();}}
updateSize(){const height=window.innerHeight-this.rootRef.el.getBoundingClientRect().top;this.rootRef.el.style.height=`${height}px`;}
onDateClick(info){if(this.env.isSmall){this.props.model.load({date:luxon.DateTime.fromISO(info.dateStr),scale:"day",});return;}
const date=luxon.DateTime.fromISO(info.dateStr);const records=Object.values(this.props.model.records).filter((r)=>luxon.Interval.fromDateTimes(r.start.startOf("day"),r.end.endOf("day")).contains(date));this.popover.close();if(records.length){const target=info.dayEl;this.openPopover(target,date,records);}else if(this.props.model.canCreate){this.props.createRecord({start:luxon.DateTime.fromISO(info.dateStr),isAllDay:true,});}}
getDayCellClassNames(info){const date=luxon.DateTime.fromJSDate(info.date).toISODate();if(this.props.model.unusualDays.includes(date)){return["o_calendar_disabled"];}
return[];}
eventClassNames({event}){const classesToAdd=[];classesToAdd.push("o_event");const record=this.props.model.records[event.id];if(record){const color=getColor(record.colorIndex);if(typeof color==="number"){classesToAdd.push(`o_calendar_color_${color}`);}else if(typeof color!=="string"){classesToAdd.push("o_calendar_color_0");}
if(record.isHatched){classesToAdd.push("o_event_hatched");}
if(record.isStriked){classesToAdd.push("o_event_striked");}}
return classesToAdd;}
onEventDidMount(info){const{el,event}=info;el.dataset.eventId=event.id;const record=this.props.model.records[event.id];if(record){const color=getColor(record.colorIndex);if(typeof color==="string"){el.style.backgroundColor=color;}}}
async onSelect(info){this.popover.close();await this.props.createRecord({start:luxon.DateTime.fromISO(info.startStr),end:luxon.DateTime.fromISO(info.endStr).minus({days:1}),isAllDay:true,});this.unselect();}
onWindowResize(){this.updateSize();}
onEventContent(info){if(info.event.display?.includes("background")){return null;}}}
return __exports;});;

/* /web/static/src/views/calendar/colors.js */
odoo.define('@web/views/calendar/colors',[],function(require){'use strict';let __exports={};const CSS_COLOR_REGEX=/^((#[A-F0-9]{3})|(#[A-F0-9]{6})|((hsl|rgb)a?\(\s*(?:(\s*\d{1,3}%?\s*),?){3}(\s*,[0-9.]{1,4})?\))|)$/i;const colorMap=new Map();__exports.getColor=getColor;function getColor(key){if(!key){return false;}
if(colorMap.has(key)){return colorMap.get(key);}
if(typeof key==="string"&&key.match(CSS_COLOR_REGEX)){colorMap.set(key,key);}else if(typeof key==="number"){colorMap.set(key,((key-1)%55)+1);}else{colorMap.set(key,(((colorMap.size+1)*5)%24)+1);}
return colorMap.get(key);}
return __exports;});;

/* /web/static/src/views/calendar/filter_panel/calendar_filter_panel.js */
odoo.define('@web/views/calendar/filter_panel/calendar_filter_panel',['@web/core/l10n/translation','@web/core/autocomplete/autocomplete','@web/core/transition','@web/core/utils/hooks','@web/views/view_dialogs/select_create_dialog','@web/views/calendar/colors','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{AutoComplete}=require("@web/core/autocomplete/autocomplete");const{Transition}=require("@web/core/transition");const{useOwnedDialogs,useService}=require("@web/core/utils/hooks");const{SelectCreateDialog}=require("@web/views/view_dialogs/select_create_dialog");const{getColor}=require("@web/views/calendar/colors");const{Component,useState}=require("@odoo/owl");let nextId=1;const CalendarFilterPanel=__exports.CalendarFilterPanel=class CalendarFilterPanel extends Component{static components={AutoComplete,Transition,};static template="web.CalendarFilterPanel";static subTemplates={filter:"web.CalendarFilterPanel.filter",};static props={model:Object,};setup(){this.state=useState({collapsed:{},fieldRev:1,});this.addDialog=useOwnedDialogs();this.orm=useService("orm");}
getFilterColor(filter){return filter.colorIndex!==null?"o_cw_filter_color_"+getColor(filter.colorIndex):"";}
getAutoCompleteProps(section){return{autoSelect:true,resetOnSelect:true,placeholder:_t("+ Add %s",section.label),sources:[{placeholder:_t("Loading..."),options:(request)=>this.loadSource(section,request),optionTemplate:"web.CalendarFilterPanel.autocomplete.options",},],onSelect:(option,params={})=>{if(option.action){option.action(params);return;}
this.props.model.createFilter(section.fieldName,option.value);},value:"",};}
async loadSource(section,request){const resModel=this.props.model.fields[section.fieldName].relation;const domain=[["id","not in",section.filters.filter((f)=>f.type!=="all").map((f)=>f.value)],];const records=await this.orm.call(resModel,"name_search",[],{name:request,operator:"ilike",args:domain,limit:8,context:{},});const options=records.map((result)=>({value:result[0],label:result[1],model:resModel,}));if(records.length>7){options.push({label:_t("Search More..."),action:()=>this.onSearchMore(section,resModel,domain,request),classList:"o_calendar_dropdown_option",});}
if(records.length===0){options.push({label:_t("No records"),classList:"o_m2o_no_result",unselectable:true,});}
return options;}
async onSearchMore(section,resModel,domain,request){const dynamicFilters=[];if(request.length){const nameGets=await this.orm.call(resModel,"name_search",[],{name:request,args:domain,operator:"ilike",context:{},});dynamicFilters.push({description:_t("Quick search: %s",request),domain:[["id","in",nameGets.map((nameGet)=>nameGet[0])]],});}
const title=_t("Search: %s",section.label);const dialogProps={title,noCreate:true,multiSelect:true,resModel,context:{},domain,onSelected:(resId)=>this.props.model.createFilter(section.fieldName,resId),dynamicFilters,};const updatedProps=this.updateSelectCreateDialogProps(dialogProps);this.addDialog(SelectCreateDialog,updatedProps);}
updateSelectCreateDialogProps(props){return props;}
get nextFilterId(){nextId+=1;return nextId;}
isAllActive(section){let active=true;for(const filter of section.filters){if(filter.type!=="all"&&!filter.active){active=false;break;}}
return active;}
getFilterTypePriority(type){return["user","record","dynamic","all"].indexOf(type);}
getSortedFilters(section){return section.filters.slice().sort((a,b)=>{if(a.type===b.type){const va=a.value?-1:0;const vb=b.value?-1:0;if(a.type==="dynamic"&&va!==vb){return va-vb;}
return a.label.localeCompare(b.label,undefined,{numeric:true,sensitivity:"base",ignorePunctuation:true,});}else{return this.getFilterTypePriority(a.type)-this.getFilterTypePriority(b.type);}});}
toggleSection(section){if(section.canCollapse){this.state.collapsed[section.fieldName]=!this.state.collapsed[section.fieldName];}}
isSectionCollapsed(section){return this.state.collapsed[section.fieldName]||false;}
onFilterInputChange(section,filter,ev){this.props.model.updateFilters(section.fieldName,{[filter.value]:ev.target.checked,});}
onAllFilterInputChange(section,ev){const filters={};for(const filter of section.filters){if(filter.type!=="all"){filters[filter.value]=ev.target.checked;}}
this.props.model.updateFilters(section.fieldName,filters);}
onFilterRemoveBtnClick(section,filter){this.props.model.unlinkFilter(section.fieldName,filter.recordId);}
onFieldChanged(fieldName,filterValue){this.state.fieldRev+=1;this.props.model.createFilter(fieldName,filterValue);}}
return __exports;});;

/* /web/static/src/views/calendar/hooks.js */
odoo.define('@web/views/calendar/hooks',['@web/core/assets','@web/core/browser/browser','@web/core/popover/popover_hook','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{loadBundle}=require("@web/core/assets");const{browser}=require("@web/core/browser/browser");const{usePopover}=require("@web/core/popover/popover_hook");const{useService}=require("@web/core/utils/hooks");const{onMounted,onPatched,onWillStart,onWillUnmount,useComponent,useExternalListener,useRef,}=require("@odoo/owl");__exports.useCalendarPopover=useCalendarPopover;function useCalendarPopover(component){const owner=useComponent();let popoverClass="";const popoverOptions={position:"right",onClose:cleanup};Object.defineProperty(popoverOptions,"popoverClass",{get:()=>popoverClass});const popover=usePopover(component,popoverOptions);const dialog=useService("dialog");let removeDialog=null;let fcPopover;useExternalListener(window,"mousedown",(ev)=>{if(fcPopover){ev.stopPropagation();}},{capture:true});function cleanup(){fcPopover=null;removeDialog=null;}
function close(){removeDialog?.();popover.close();cleanup();}
return{close,open(target,props,popoverClassToUse){fcPopover=target.closest(".fc-popover");if(owner.env.isSmall){close();removeDialog=dialog.add(component,props,{onClose:cleanup});}else{popoverClass=popoverClassToUse;popover.open(target,props);}},};}
__exports.useClickHandler=useClickHandler;function useClickHandler(singleClickCb,doubleClickCb){const component=useComponent();let clickTimeoutId=null;return function handle(...args){if(clickTimeoutId){doubleClickCb.call(component,...args);browser.clearTimeout(clickTimeoutId);clickTimeoutId=null;}else{clickTimeoutId=browser.setTimeout(()=>{singleClickCb.call(component,...args);clickTimeoutId=null;},250);}};}
__exports.useFullCalendar=useFullCalendar;function useFullCalendar(refName,params){const component=useComponent();const ref=useRef(refName);let instance=null;function boundParams(){const newParams={};for(const key in params){const value=params[key];newParams[key]=typeof value==="function"?value.bind(component):value;}
return newParams;}
onWillStart(async()=>await loadBundle("web.fullcalendar_lib"));onMounted(()=>{try{instance=new FullCalendar.Calendar(ref.el,boundParams());instance.render();}catch(e){throw new Error(`Cannot instantiate FullCalendar\n${e.message}`);}});onPatched(()=>{instance.refetchEvents();instance.setOption("weekends",component.props.isWeekendVisible);if(params.weekNumbers&&component.props.model.scale==="year"){instance.destroy();instance.render();}});onWillUnmount(()=>{instance.destroy();});return{get api(){return instance;},get el(){return ref.el;},};}
return __exports;});;

/* /web/static/src/views/calendar/mobile_filter_panel/calendar_mobile_filter_panel.js */
odoo.define('@web/views/calendar/mobile_filter_panel/calendar_mobile_filter_panel',['@odoo/owl','@web/views/calendar/colors'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{getColor}=require("@web/views/calendar/colors");const CalendarMobileFilterPanel=__exports.CalendarMobileFilterPanel=class CalendarMobileFilterPanel extends Component{static components={};static template="web.CalendarMobileFilterPanel";static props={model:Object,sideBarShown:Boolean,toggleSideBar:Function,};get caretDirection(){return this.props.sideBarShown?"down":"left";}
getFilterColor(filter){return`o_color_${getColor(filter.colorIndex)}`;}
getFilterTypePriority(type){return["user","record","dynamic","all"].indexOf(type);}
getSortedFilters(section){return section.filters.slice().sort((a,b)=>{if(a.type===b.type){const va=a.value?-1:0;const vb=b.value?-1:0;if(a.type==="dynamic"&&va!==vb){return va-vb;}
return a.label.localeCompare(b.label,undefined,{numeric:true,sensitivity:"base",ignorePunctuation:true,});}else{return this.getFilterTypePriority(a.type)-this.getFilterTypePriority(b.type);}});}}
return __exports;});;

/* /web/static/src/views/calendar/quick_create/calendar_quick_create.js */
odoo.define('@web/views/calendar/quick_create/calendar_quick_create',['@web/core/utils/hooks','@web/core/dialog/dialog','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{useAutofocus,useService}=require("@web/core/utils/hooks");const{Dialog}=require("@web/core/dialog/dialog");const{_t}=require("@web/core/l10n/translation");const{Component}=require("@odoo/owl");const CalendarQuickCreate=__exports.CalendarQuickCreate=class CalendarQuickCreate extends Component{static template="web.CalendarQuickCreate";static components={Dialog,};static props={title:{type:String,optional:true},close:Function,record:Object,model:Object,editRecord:Function,};setup(){this.titleRef=useAutofocus({refName:"title"});this.notification=useService("notification");this.creatingRecord=false;}
get dialogTitle(){return _t("New Event");}
get recordTitle(){return this.titleRef.el.value.trim();}
get record(){return{...this.props.record,title:this.recordTitle,};}
editRecord(){this.props.editRecord(this.record);this.props.close();}
async createRecord(){if(this.creatingRecord){return;}
if(this.recordTitle){try{this.creatingRecord=true;await this.props.model.createRecord(this.record);this.props.close();}catch{this.editRecord();}}else{this.titleRef.el.classList.add("o_field_invalid");this.notification.add(_t("Meeting Subject"),{title:_t("Invalid fields"),type:"danger",});}}
onInputKeyup(ev){switch(ev.key){case"Enter":this.createRecord();break;case"Escape":this.props.close();break;}}
onCreateBtnClick(){this.createRecord();}
onEditBtnClick(){this.editRecord();}
onCancelBtnClick(){this.props.close();}}
return __exports;});;

/* /web/static/src/views/calendar/utils.js */
odoo.define('@web/views/calendar/utils',[],function(require){'use strict';let __exports={};__exports.getFormattedDateSpan=getFormattedDateSpan;function getFormattedDateSpan(start,end){const isSameDay=start.hasSame(end,"days");if(!isSameDay&&start.hasSame(end,"month")){return start.toFormat("LLLL d")+"-"+end.toFormat("d, y");}else{return isSameDay?start.toFormat("DDD"):start.toFormat("DDD")+" - "+end.toFormat("DDD");}}
return __exports;});;

/* /web/static/src/views/debug_items.js */
odoo.define('@web/views/debug_items',['@web/core/l10n/translation','@web/core/dialog/dialog','@web/core/py_js/py','@web/core/debug/debug_utils','@web/core/l10n/dates','@web/core/registry','@web/core/utils/hooks','@web/views/fields/formatters','@web/views/view_dialogs/form_view_dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Dialog}=require("@web/core/dialog/dialog");const{evaluateBooleanExpr}=require("@web/core/py_js/py");const{editModelDebug}=require("@web/core/debug/debug_utils");const{formatDateTime,deserializeDateTime}=require("@web/core/l10n/dates");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{formatMany2one}=require("@web/views/fields/formatters");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");const{Component,onWillStart,useState,xml}=require("@odoo/owl");const{serializeDate,serializeDateTime}=require("@web/core/l10n/dates");const debugRegistry=registry.category("debug");class GetViewDialog extends Component{static template="web.DebugMenu.GetViewDialog";static components={Dialog};static props={arch:{type:String},close:{type:Function},};}
__exports.getView=getView;function getView({component,env}){return{type:"item",description:_t("Computed Arch"),callback:()=>{env.services.dialog.add(GetViewDialog,{arch:component.env.config.rawArch});},sequence:270,section:"ui",};}
debugRegistry.category("view").add("getView",getView);__exports.editView=editView;function editView({accessRights,component,env}){if(!accessRights.canEditView){return null;}
const{viewId,viewType:type}=component.env.config;if(!type){return;}
const displayName=type[0].toUpperCase()+type.slice(1);const description=_t("View: %(displayName)s",{displayName});return{type:"item",description,callback:()=>{editModelDebug(env,description,"ir.ui.view",viewId);},sequence:240,section:"ui",};}
debugRegistry.category("view").add("editView",editView);__exports.editSearchView=editSearchView;function editSearchView({accessRights,component,env}){if(!accessRights.canEditView){return null;}
const{searchViewId}=component.componentProps.info;if(searchViewId===undefined){return null;}
const description=_t("SearchView");return{type:"item",description,callback:()=>{editModelDebug(env,description,"ir.ui.view",searchViewId);},sequence:230,section:"ui",};}
debugRegistry.category("view").add("editSearchView",editSearchView);class GetMetadataDialog extends Component{static template="web.DebugMenu.GetMetadataDialog";static components={Dialog};static props={resModel:String,resId:Number,close:Function,};setup(){this.orm=useService("orm");this.dialogService=useService("dialog");this.title=_t("View Metadata");this.state=useState({});onWillStart(()=>this.loadMetadata());}
onClickCreateXmlid(){const context=Object.assign({},this.context,{default_module:"__custom__",default_res_id:this.state.id,default_model:this.props.resModel,});this.dialogService.add(FormViewDialog,{context,onRecordSaved:()=>this.loadMetadata(),resModel:"ir.model.data",});}
async toggleNoupdate(){await this.env.services.orm.call("ir.model.data","toggle_noupdate",[this.props.resModel,this.state.id,]);await this.loadMetadata();}
async loadMetadata(){const args=[[this.props.resId]];const result=await this.orm.call(this.props.resModel,"get_metadata",args);const metadata=result[0];this.state.id=metadata.id;this.state.xmlid=metadata.xmlid;this.state.xmlids=metadata.xmlids;this.state.noupdate=metadata.noupdate;this.state.creator=formatMany2one(metadata.create_uid);this.state.lastModifiedBy=formatMany2one(metadata.write_uid);this.state.createDate=formatDateTime(deserializeDateTime(metadata.create_date));this.state.writeDate=formatDateTime(deserializeDateTime(metadata.write_date));}}
__exports.viewMetadata=viewMetadata;function viewMetadata({component,env}){const resId=component.model.root.resId;if(!resId){return null;}
return{type:"item",description:_t("Metadata"),callback:()=>{env.services.dialog.add(GetMetadataDialog,{resModel:component.props.resModel,resId,});},sequence:110,section:"record",};}
debugRegistry.category("form").add("viewMetadata",viewMetadata);class RawRecordDialog extends Component{static template=xml`
        <Dialog title="props.title">
            <pre t-esc="content"/>
        </Dialog>
    `;static components={Dialog};static props={record:{type:Object},title:{type:String},close:{type:Function},};get content(){const record=this.props.record;return JSON.stringify(record,Object.keys(record).sort(),2);}}
__exports.viewRawRecord=viewRawRecord;function viewRawRecord({component,env}){const{resId,resModel}=component.model.config;if(!resId){return null;}
const description=_t("Data");return{type:"item",description,callback:async()=>{const records=await component.model.orm.read(resModel,[resId]);env.services.dialog.add(RawRecordDialog,{title:_t("Data: %(model)s(%(id)s)",{model:resModel,id:resId}),record:records[0],});},sequence:120,section:"record",};}
debugRegistry.category("form").add("viewRawRecord",viewRawRecord);class SetDefaultDialog extends Component{static template="web.DebugMenu.SetDefaultDialog";static components={Dialog};static props={record:{type:Object},fieldNodes:{type:Object},close:{type:Function},};setup(){this.orm=useService("orm");this.state={fieldToSet:"",condition:"",scope:"self",};this.fields=this.props.record.fields;this.activeFields=this.props.record.activeFields;this.fieldNamesInView=this.props.record.fieldNames;this.fieldNamesBlackList=["message_attachment_count"];this.fieldsValues=this.props.record.data;this.modifierDatas={};this.defaultFields=this.getDefaultFields();this.conditions=this.getConditions();}
getDefaultFields(){return this.fieldNamesInView.filter((fieldName)=>!this.fieldNamesBlackList.includes(fieldName)).map((fieldName)=>{const fieldInfo=this.fields[fieldName];const valueDisplayed=this.display(fieldInfo,this.fieldsValues[fieldName]);const value=valueDisplayed[0];const displayed=valueDisplayed[1];const evalContext=this.props.record.evalContextWithVirtualIds;if(!value||evaluateBooleanExpr(this.activeFields[fieldName].invisible,evalContext)||evaluateBooleanExpr(this.activeFields[fieldName].readonly,evalContext)||fieldInfo.type==="one2many"||fieldInfo.type==="many2many"||fieldInfo.type==="binary"||Object.entries(this.props.fieldNodes).filter(([key,value])=>value.name===fieldName).some(([key,value])=>value.options.isPassword)){return false;}
return{name:fieldName,string:fieldInfo.string,value,displayed,};}).filter((val)=>val).sort((field)=>field.string);}
getConditions(){return this.fieldNamesInView.filter((fieldName)=>{const fieldInfo=this.fields[fieldName];return fieldInfo.change_default;}).map((fieldName)=>{const fieldInfo=this.fields[fieldName];const valueDisplayed=this.display(fieldInfo,this.fieldsValues[fieldName]);const value=valueDisplayed[0];const displayed=valueDisplayed[1];return{name:fieldName,string:fieldInfo.string,value:value,displayed:displayed,};});}
display(fieldInfo,value){let displayed=value;if(value&&fieldInfo.type==="many2one"){displayed=value[1];value=value[0];}else if(value&&fieldInfo.type==="selection"){displayed=fieldInfo.selection.find((option)=>{return option[0]===value;})[1];}
if((typeof displayed==="string"||displayed instanceof String)&&displayed.length>60){displayed=displayed.slice(0,57)+"...";}
return[value,displayed];}
async saveDefault(){if(!this.state.fieldToSet){return;}
let fieldToSet=this.defaultFields.find((field)=>{return field.name===this.state.fieldToSet;}).value;if(fieldToSet.constructor.name.toLowerCase()==="date"){fieldToSet=serializeDate(fieldToSet);}else if(fieldToSet.constructor.name.toLowerCase()==="datetime"){fieldToSet=serializeDateTime(fieldToSet);}
await this.orm.call("ir.default","set",[this.props.record.resModel,this.state.fieldToSet,fieldToSet,this.state.scope==="self",true,this.state.condition||false,]);this.props.close();}}
__exports.setDefaults=setDefaults;function setDefaults({component,env}){return{type:"item",description:_t("Set Default Values"),callback:()=>{env.services.dialog.add(SetDefaultDialog,{record:component.model.root,fieldNodes:component.props.archInfo.fieldNodes,});},sequence:150,section:"record",};}
debugRegistry.category("form").add("setDefaults",setDefaults);__exports.manageAttachments=manageAttachments;function manageAttachments({component,env}){const resId=component.model.root.resId;if(!resId){return null;}
const description=_t("Attachments");return{type:"item",description,callback:()=>{env.services.action.doAction({res_model:"ir.attachment",name:description,views:[[false,"list"],[false,"form"],],type:"ir.actions.act_window",domain:[["res_model","=",component.props.resModel],["res_id","=",resId],],context:{default_res_model:component.props.resModel,default_res_id:resId,skip_res_field_check:true,},});},sequence:140,section:"record",};}
debugRegistry.category("form").add("manageAttachments",manageAttachments);return __exports;});;

/* /web/static/src/views/fields/ace/ace_field.js */
odoo.define('@web/views/fields/ace/ace_field',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/views/fields/standard_field_props','@web/core/code_editor/code_editor','@odoo/owl','@web/model/relational_model/utils','@web/views/fields/formatters','@web/core/browser/cookie'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useBus}=require("@web/core/utils/hooks");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{CodeEditor}=require("@web/core/code_editor/code_editor");const{Component,useState}=require("@odoo/owl");const{useRecordObserver}=require("@web/model/relational_model/utils");const{formatText}=require("@web/views/fields/formatters");const{cookie}=require("@web/core/browser/cookie");const AceField=__exports.AceField=class AceField extends Component{static template="web.AceField";static props={...standardFieldProps,mode:{type:String,optional:true},};static defaultProps={mode:"qweb",};static components={CodeEditor};setup(){this.state=useState({});useRecordObserver((record)=>{this.state.initialValue=formatText(record.data[this.props.name]);});this.isDirty=false;const{model}=this.props.record;useBus(model.bus,"WILL_SAVE_URGENTLY",()=>this.commitChanges());useBus(model.bus,"NEED_LOCAL_CHANGES",({detail})=>detail.proms.push(this.commitChanges()));}
get mode(){return this.props.mode==="xml"?"qweb":this.props.mode;}
get theme(){return cookie.get("color_scheme")==="dark"?"monokai":"";}
handleChange(editedValue){if(this.state.initialValue!==editedValue){this.isDirty=true;}else{this.isDirty=false;}
this.props.record.model.bus.trigger("FIELD_IS_DIRTY",this.isDirty);this.editedValue=editedValue;}
async commitChanges(){if(!this.props.readonly&&this.isDirty){if(this.state.initialValue!==this.editedValue){await this.props.record.update({[this.props.name]:this.editedValue});}
this.isDirty=false;this.props.record.model.bus.trigger("FIELD_IS_DIRTY",false);}}}
const aceField=__exports.aceField={component:AceField,displayName:_t("Ace Editor"),supportedOptions:[{label:_t("Mode"),name:"mode",type:"string",},],supportedTypes:["text","html"],extractProps:({options})=>({mode:options.mode,}),};registry.category("fields").add("ace",aceField);registry.category("fields").add("code",aceField);return __exports;});;

/* /web/static/src/views/fields/attachment_image/attachment_image_field.js */
odoo.define('@web/views/fields/attachment_image/attachment_image_field',['@web/core/l10n/translation','@web/core/registry','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{Component}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const AttachmentImageField=__exports.AttachmentImageField=class AttachmentImageField extends Component{static template="web.AttachmentImageField";static props={...standardFieldProps};}
const attachmentImageField=__exports.attachmentImageField={component:AttachmentImageField,displayName:_t("Attachment Image"),supportedTypes:["many2one"],};registry.category("fields").add("attachment_image",attachmentImageField);return __exports;});;

/* /web/static/src/views/fields/badge/badge_field.js */
odoo.define('@web/views/fields/badge/badge_field',['@web/core/l10n/translation','@web/core/py_js/py','@web/core/registry','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{evaluateBooleanExpr}=require("@web/core/py_js/py");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const formatters=registry.category("formatters");const BadgeField=__exports.BadgeField=class BadgeField extends Component{static template="web.BadgeField";static props={...standardFieldProps,decorations:{type:Object,optional:true},};static defaultProps={decorations:{},};get formattedValue(){const formatter=formatters.get(this.props.record.fields[this.props.name].type);return formatter(this.props.record.data[this.props.name],{selection:this.props.record.fields[this.props.name].selection,});}
get classFromDecoration(){const evalContext=this.props.record.evalContextWithVirtualIds;for(const decorationName in this.props.decorations){if(evaluateBooleanExpr(this.props.decorations[decorationName],evalContext)){if(decorationName==="muted"){return"text-bg-300";}
return`text-bg-${decorationName}`;}}
return"text-bg-300";}}
const badgeField=__exports.badgeField={component:BadgeField,displayName:_t("Badge"),supportedTypes:["selection","many2one","char"],extractProps:({decorations})=>{return{decorations};},};registry.category("fields").add("badge",badgeField);return __exports;});;

/* /web/static/src/views/fields/badge_selection/badge_selection_field.js */
odoo.define('@web/views/fields/badge_selection/badge_selection_field',['@odoo/owl','@web/core/l10n/translation','@web/core/registry','@web/model/relational_model/utils','@web/views/fields/relational_utils','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{getFieldDomain}=require("@web/model/relational_model/utils");const{useSpecialData}=require("@web/views/fields/relational_utils");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const BadgeSelectionField=__exports.BadgeSelectionField=class BadgeSelectionField extends Component{static template="web.BadgeSelectionField";static props={...standardFieldProps,domain:{type:[Array,Function],optional:true},size:{type:String,optional:true,validate:(s)=>["sm","md","lg"].includes(s),default:"md",},};setup(){this.type=this.props.record.fields[this.props.name].type;if(this.type==="many2one"){this.specialData=useSpecialData((orm,props)=>{const domain=getFieldDomain(props.record,props.name,props.domain);const{relation}=props.record.fields[props.name];return orm.call(relation,"name_search",["",domain]);});}}
get options(){switch(this.type){case"many2one":return this.specialData.data;case"selection":return this.props.record.fields[this.props.name].selection;default:return[];}}
get string(){switch(this.type){case"many2one":return this.props.record.data[this.props.name]?this.props.record.data[this.props.name][1]:"";case"selection":return this.props.record.data[this.props.name]!==false?this.options.find((o)=>o[0]===this.props.record.data[this.props.name])[1]:"";default:return"";}}
get value(){const rawValue=this.props.record.data[this.props.name];return this.type==="many2one"&&rawValue?rawValue[0]:rawValue;}
stringify(value){return JSON.stringify(value);}
onChange(value){switch(this.type){case"many2one":if(value===false){this.props.record.update({[this.props.name]:false});}else{this.props.record.update({[this.props.name]:this.options.find((option)=>option[0]===value),});}
break;case"selection":if(value===this.value){const{required}=this.props.record.fields[this.props.name];if(!required){this.props.record.update({[this.props.name]:false});}}else{this.props.record.update({[this.props.name]:value});}
break;}}}
const badgeSelectionField=__exports.badgeSelectionField={component:BadgeSelectionField,displayName:_t("Badges"),supportedTypes:["many2one","selection"],supportedOptions:[{label:"Size",name:"size",type:"selection",choices:[{label:"Small",value:"sm"},{label:"Medium",value:"md"},{label:"Large",value:"lg"},],default:"md",},],isEmpty:(record,fieldName)=>record.data[fieldName]===false,extractProps:(fieldInfo,dynamicInfo)=>({domain:dynamicInfo.domain,size:fieldInfo.options.size,}),};registry.category("fields").add("selection_badge",badgeSelectionField);return __exports;});;

/* /web/static/src/views/fields/binary/binary_field.js */
odoo.define('@web/views/fields/binary/binary_field',['@web/core/registry','@web/core/utils/hooks','@web/core/utils/binary','@web/core/network/download','@web/views/fields/standard_field_props','@web/views/fields/file_handler','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{isBinarySize,toBase64Length}=require("@web/core/utils/binary");const{download}=require("@web/core/network/download");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{FileUploader}=require("@web/views/fields/file_handler");const{_t}=require("@web/core/l10n/translation");const{Component}=require("@odoo/owl");const MAX_FILENAME_SIZE_BYTES=__exports.MAX_FILENAME_SIZE_BYTES=0xFF;const BinaryField=__exports.BinaryField=class BinaryField extends Component{static template="web.BinaryField";static components={FileUploader,};static props={...standardFieldProps,acceptedFileExtensions:{type:String,optional:true},fileNameField:{type:String,optional:true},};static defaultProps={acceptedFileExtensions:"*",};setup(){this.notification=useService("notification");}
get fileName(){return(this.props.record.data[this.props.fileNameField]||this.props.record.data[this.props.name]||"").slice(0,toBase64Length(MAX_FILENAME_SIZE_BYTES));}
update({data,name}){const{fileNameField,record}=this.props;const changes={[this.props.name]:data||false};if(fileNameField in record.fields&&record.data[fileNameField]!==name){changes[fileNameField]=name||'';}
return this.props.record.update(changes);}
getDownloadData(){return{model:this.props.record.resModel,id:this.props.record.resId,field:this.props.name,filename_field:this.fileName,filename:this.fileName||"",download:true,data:isBinarySize(this.props.record.data[this.props.name])?null:this.props.record.data[this.props.name],};}
async onFileDownload(){await download({data:this.getDownloadData(),url:"/web/content",});}}
const ListBinaryField=__exports.ListBinaryField=class ListBinaryField extends BinaryField{static template="web.ListBinaryField";}
const binaryField=__exports.binaryField={component:BinaryField,displayName:_t("File"),supportedOptions:[{label:_t("Accepted file extensions"),name:"accepted_file_extensions",type:"string",},],supportedTypes:["binary"],extractProps:({attrs,options})=>({acceptedFileExtensions:options.accepted_file_extensions,fileNameField:attrs.filename,}),};const listBinaryField=__exports.listBinaryField={...binaryField,component:ListBinaryField,};registry.category("fields").add("binary",binaryField);registry.category("fields").add("list.binary",listBinaryField);return __exports;});;

/* /web/static/src/views/fields/boolean/boolean_field.js */
odoo.define('@web/views/fields/boolean/boolean_field',['@odoo/owl','@web/core/checkbox/checkbox','@web/core/l10n/translation','@web/core/registry','@web/model/relational_model/utils','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{CheckBox}=require("@web/core/checkbox/checkbox");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useRecordObserver}=require("@web/model/relational_model/utils");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const BooleanField=__exports.BooleanField=class BooleanField extends Component{static template="web.BooleanField";static components={CheckBox};static props={...standardFieldProps,};setup(){this.state=useState({});useRecordObserver((record)=>{this.state.value=record.data[this.props.name];});}
onChange(newValue){this.state.value=newValue;this.props.record.update({[this.props.name]:newValue});}}
const booleanField=__exports.booleanField={component:BooleanField,displayName:_t("Checkbox"),supportedTypes:["boolean"],isEmpty:()=>false,};registry.category("fields").add("boolean",booleanField);return __exports;});;

/* /web/static/src/views/fields/boolean_favorite/boolean_favorite_field.js */
odoo.define('@web/views/fields/boolean_favorite/boolean_favorite_field',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/strings','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{exprToBoolean}=require("@web/core/utils/strings");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const BooleanFavoriteField=__exports.BooleanFavoriteField=class BooleanFavoriteField extends Component{static template="web.BooleanFavoriteField";static props={...standardFieldProps,noLabel:{type:Boolean,optional:true},autosave:{type:Boolean,optional:true},};static defaultProps={noLabel:false,};get iconClass(){return this.props.record.data[this.props.name]?"fa fa-star me-1":"fa fa-star-o me-1";}
get label(){return this.props.record.data[this.props.name]?_t("Remove from Favorites"):_t("Add to Favorites");}
async update(){if(this.props.readonly){return;}
const changes={[this.props.name]:!this.props.record.data[this.props.name]};await this.props.record.update(changes,{save:this.props.autosave});}}
const booleanFavoriteField=__exports.booleanFavoriteField={component:BooleanFavoriteField,displayName:_t("Favorite"),supportedTypes:["boolean"],isEmpty:()=>false,listViewWidth:({hasLabel})=>(!hasLabel?20:false),supportedOptions:[{label:_t("Autosave"),name:"autosave",type:"boolean",default:true,help:_t("If checked, the record will be saved immediately when the field is modified."),},],extractProps:({attrs,options},dynamicInfo)=>({noLabel:exprToBoolean(attrs.nolabel),autosave:"autosave"in options?Boolean(options.autosave):true,readonly:dynamicInfo.readonly,}),};registry.category("fields").add("boolean_favorite",booleanFavoriteField);return __exports;});;

/* /web/static/src/views/fields/boolean_icon/boolean_icon_field.js */
odoo.define('@web/views/fields/boolean_icon/boolean_icon_field',['@odoo/owl','@web/core/registry','@web/core/l10n/translation','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const BooleanIconField=__exports.BooleanIconField=class BooleanIconField extends Component{static template="web.BooleanIconField";static props={...standardFieldProps,icon:{type:String,optional:true},label:{type:String,optional:true},};static defaultProps={icon:"fa-check-square-o",};update(){this.props.record.update({[this.props.name]:!this.props.record.data[this.props.name]});}}
const booleanIconField=__exports.booleanIconField={component:BooleanIconField,displayName:_t("Boolean Icon"),supportedOptions:[{label:_t("Icon"),name:"icon",type:"string",},],supportedTypes:["boolean"],extractProps:({options,string})=>({icon:options.icon,label:string,}),};registry.category("fields").add("boolean_icon",booleanIconField);return __exports;});;

/* /web/static/src/views/fields/boolean_toggle/boolean_toggle_field.js */
odoo.define('@web/views/fields/boolean_toggle/boolean_toggle_field',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/boolean/boolean_field'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{booleanField,BooleanField}=require("@web/views/fields/boolean/boolean_field");const BooleanToggleField=__exports.BooleanToggleField=class BooleanToggleField extends BooleanField{static template="web.BooleanToggleField";static props={...BooleanField.props,autosave:{type:Boolean,optional:true},};async onChange(newValue){this.state.value=newValue;const changes={[this.props.name]:newValue};await this.props.record.update(changes,{save:this.props.autosave});}}
const booleanToggleField=__exports.booleanToggleField={...booleanField,component:BooleanToggleField,displayName:_t("Toggle"),supportedOptions:[{label:_t("Autosave"),name:"autosave",type:"boolean",default:true,help:_t("If checked, the record will be saved immediately when the field is modified."),},],extractProps({options},dynamicInfo){return{autosave:"autosave"in options?Boolean(options.autosave):true,readonly:dynamicInfo.readonly,};},};registry.category("fields").add("boolean_toggle",booleanToggleField);return __exports;});;

/* /web/static/src/views/fields/boolean_toggle/list_boolean_toggle_field.js */
odoo.define('@web/views/fields/boolean_toggle/list_boolean_toggle_field',['@web/core/registry','@web/views/fields/boolean_toggle/boolean_toggle_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{booleanToggleField,BooleanToggleField}=require("@web/views/fields/boolean_toggle/boolean_toggle_field");const ListBooleanToggleField=__exports.ListBooleanToggleField=class ListBooleanToggleField extends BooleanToggleField{static template="web.ListBooleanToggleField";async onClick(){if(!this.props.readonly&&this.props.record.isInEdition){const changes={[this.props.name]:!this.props.record.data[this.props.name]};await this.props.record.update(changes,{save:this.props.autosave});}}}
const listBooleanToggleField=__exports.listBooleanToggleField={...booleanToggleField,component:ListBooleanToggleField,};registry.category("fields").add("list.boolean_toggle",listBooleanToggleField);return __exports;});;

/* /web/static/src/views/fields/char/char_field.js */
odoo.define('@web/views/fields/char/char_field',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/strings','@web/views/fields/dynamic_placeholder_hook','@web/views/fields/formatters','@web/views/fields/input_field_hook','@web/views/fields/standard_field_props','@web/views/fields/translation_button','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{exprToBoolean}=require("@web/core/utils/strings");const{useDynamicPlaceholder}=require("@web/views/fields/dynamic_placeholder_hook");const{formatChar}=require("@web/views/fields/formatters");const{useInputField}=require("@web/views/fields/input_field_hook");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{TranslationButton}=require("@web/views/fields/translation_button");const{Component,useEffect,useExternalListener,useRef}=require("@odoo/owl");const CharField=__exports.CharField=class CharField extends Component{static template="web.CharField";static components={TranslationButton,};static props={...standardFieldProps,autocomplete:{type:String,optional:true},isPassword:{type:Boolean,optional:true},placeholder:{type:String,optional:true},dynamicPlaceholder:{type:Boolean,optional:true},dynamicPlaceholderModelReferenceField:{type:String,optional:true},placeholderField:{type:String,optional:true},};static defaultProps={dynamicPlaceholder:false};setup(){this.input=useRef("input");if(this.props.dynamicPlaceholder){this.dynamicPlaceholder=useDynamicPlaceholder(this.input);useExternalListener(document,"keydown",this.dynamicPlaceholder.onKeydown);useEffect(()=>this.dynamicPlaceholder.updateModel(this.props.dynamicPlaceholderModelReferenceField));}
useInputField({getValue:()=>this.props.record.data[this.props.name]||"",parse:(v)=>this.parse(v),});this.selectionStart=this.props.record.data[this.props.name]?.length||0;}
get shouldTrim(){return this.props.record.fields[this.props.name].trim&&!this.props.isPassword;}
get maxLength(){return this.props.record.fields[this.props.name].size;}
get isTranslatable(){return this.props.record.fields[this.props.name].translate;}
get formattedValue(){return formatChar(this.props.record.data[this.props.name],{isPassword:this.props.isPassword,});}
get hasDynamicPlaceholder(){return this.props.dynamicPlaceholder&&!this.props.readonly;}
get placeholder(){return this.props.record.data[this.props.placeholderField]||this.props.placeholder;}
parse(value){if(this.shouldTrim){return value.trim();}
return value;}
onBlur(){this.selectionStart=this.input.el.selectionStart;}
async onDynamicPlaceholderOpen(){await this.dynamicPlaceholder.open({validateCallback:this.onDynamicPlaceholderValidate.bind(this),});}
async onDynamicPlaceholderValidate(chain,defaultValue){if(chain){this.input.el.focus();const dynamicPlaceholder=` {{object.${chain}${
                defaultValue?.length ? `|||${defaultValue}` : ""
            }}}`;this.input.el.setRangeText(dynamicPlaceholder,this.selectionStart,this.selectionStart,"end");this.input.el.dispatchEvent(new InputEvent("input"));this.input.el.dispatchEvent(new KeyboardEvent("keydown"));this.input.el.focus();}}}
const charField=__exports.charField={component:CharField,displayName:_t("Text"),supportedTypes:["char"],supportedOptions:[{label:_t("Dynamic Placeholder"),name:"placeholder_field",type:"field",availableTypes:["char"],help:_t("Displays the value of the selected field as a textual hint. If the selected field is empty, the static placeholder attribute is displayed instead."),},],extractProps:({attrs,options})=>({isPassword:exprToBoolean(attrs.password),dynamicPlaceholder:options.dynamic_placeholder||false,dynamicPlaceholderModelReferenceField:options.dynamic_placeholder_model_reference_field||"",autocomplete:attrs.autocomplete,placeholder:attrs.placeholder,placeholderField:options.placeholder_field,}),};registry.category("fields").add("char",charField);return __exports;});;

/* /web/static/src/views/fields/color/color_field.js */
odoo.define('@web/views/fields/color/color_field',['@odoo/owl','@web/core/registry','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const ColorField=__exports.ColorField=class ColorField extends Component{static template="web.ColorField";static props={...standardFieldProps,};get color(){return this.props.record.data[this.props.name]||"";}}
const colorField=__exports.colorField={component:ColorField,supportedTypes:["char"],extractProps(fieldInfo,dynamicInfo){return{readonly:dynamicInfo.readonly,};},};registry.category("fields").add("color",colorField);return __exports;});;

/* /web/static/src/views/fields/color_picker/color_picker_field.js */
odoo.define('@web/views/fields/color_picker/color_picker_field',['@web/core/colorlist/colorlist','@web/core/registry','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{ColorList}=require("@web/core/colorlist/colorlist");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const ColorPickerField=__exports.ColorPickerField=class ColorPickerField extends Component{static template="web.ColorPickerField";static components={ColorList,};static props={...standardFieldProps,canToggle:{type:Boolean},};static RECORD_COLORS=[0,1,2,3,4,5,6,7,8,9,10,11];get isExpanded(){return!this.props.canToggle&&!this.props.readonly;}
switchColor(colorIndex){this.props.record.update({[this.props.name]:colorIndex});}}
const colorPickerField=__exports.colorPickerField={component:ColorPickerField,supportedTypes:["integer"],extractProps:({viewType})=>({canToggle:viewType!=="list",}),};registry.category("fields").add("color_picker",colorPickerField);return __exports;});;

/* /web/static/src/views/fields/copy_clipboard/copy_clipboard_field.js */
odoo.define('@web/views/fields/copy_clipboard/copy_clipboard_field',['@web/core/l10n/translation','@web/core/py_js/py','@web/core/registry','@web/core/utils/objects','@web/core/copy_button/copy_button','@web/views/fields/char/char_field','@web/views/fields/standard_field_props','@web/views/fields/url/url_field','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{evaluateBooleanExpr}=require("@web/core/py_js/py");const{registry}=require("@web/core/registry");const{omit}=require("@web/core/utils/objects");const{CopyButton}=require("@web/core/copy_button/copy_button");const{CharField}=require("@web/views/fields/char/char_field");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{UrlField}=require("@web/views/fields/url/url_field");const{Component}=require("@odoo/owl");class CopyClipboardField extends Component{static template="web.CopyClipboardField";static props={...standardFieldProps,string:{type:String,optional:true},disabledExpr:{type:String,optional:true},};setup(){this.copyText=this.props.string||_t("Copy");this.successText=_t("Copied");}
get copyButtonClassName(){return`o_btn_${this.type}_copy btn-sm`;}
get fieldProps(){return omit(this.props,"string","disabledExpr");}
get type(){return this.props.record.fields[this.props.name].type;}
get disabled(){return this.props.disabledExpr?evaluateBooleanExpr(this.props.disabledExpr,this.props.record.evalContextWithVirtualIds):false;}}
const CopyClipboardButtonField=__exports.CopyClipboardButtonField=class CopyClipboardButtonField extends CopyClipboardField{static template="web.CopyClipboardButtonField";static components={CopyButton};get copyButtonClassName(){return`o_btn_${this.type}_copy btn-primary rounded-2`;}}
const CopyClipboardCharField=__exports.CopyClipboardCharField=class CopyClipboardCharField extends CopyClipboardField{static components={Field:CharField,CopyButton};get copyButtonIcon(){return"fa-clone";}}
const CopyClipboardURLField=__exports.CopyClipboardURLField=class CopyClipboardURLField extends CopyClipboardField{static components={Field:UrlField,CopyButton};get copyButtonIcon(){return"fa-link";}}
function extractProps({attrs}){return{string:attrs.string,disabledExpr:attrs.disabled,};}
const copyClipboardButtonField=__exports.copyClipboardButtonField={component:CopyClipboardButtonField,displayName:_t("Copy to Clipboard"),extractProps,};registry.category("fields").add("CopyClipboardButton",copyClipboardButtonField);const copyClipboardCharField=__exports.copyClipboardCharField={component:CopyClipboardCharField,displayName:_t("Copy Text to Clipboard"),supportedTypes:["char"],extractProps,};registry.category("fields").add("CopyClipboardChar",copyClipboardCharField);const copyClipboardURLField=__exports.copyClipboardURLField={component:CopyClipboardURLField,displayName:_t("Copy URL to Clipboard"),supportedTypes:["char"],extractProps,};registry.category("fields").add("CopyClipboardURL",copyClipboardURLField);return __exports;});;

/* /web/static/src/views/fields/datetime/datetime_field.js */
odoo.define('@web/views/fields/datetime/datetime_field',['@odoo/owl','@web/core/datetime/datetime_hook','@web/core/l10n/dates','@web/core/py_js/py','@web/core/l10n/translation','@web/core/registry','@web/core/utils/arrays','@web/core/utils/strings','@web/views/fields/formatters','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{Component,onWillRender,useState}=require("@odoo/owl");const{useDateTimePicker}=require("@web/core/datetime/datetime_hook");const{areDatesEqual,deserializeDate,deserializeDateTime,today}=require("@web/core/l10n/dates");const{evaluateBooleanExpr}=require("@web/core/py_js/py");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{ensureArray}=require("@web/core/utils/arrays");const{exprToBoolean}=require("@web/core/utils/strings");const{formatDate,formatDateTime}=require("@web/views/fields/formatters");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const DateTimeField=__exports.DateTimeField=class DateTimeField extends Component{static props={...standardFieldProps,endDateField:{type:String,optional:true},maxDate:{type:String,optional:true},minDate:{type:String,optional:true},alwaysRange:{type:Boolean,optional:true},placeholder:{type:String,optional:true},required:{type:Boolean,optional:true},rounding:{type:Number,optional:true},startDateField:{type:String,optional:true},warnFuture:{type:Boolean,optional:true},showSeconds:{type:Boolean,optional:true},showTime:{type:Boolean,optional:true},minPrecision:{type:String,optional:true,validate:(props)=>["days","months","years","decades"].includes(props),},maxPrecision:{type:String,optional:true,validate:(props)=>["days","months","years","decades"].includes(props),},condensed:{type:Boolean,optional:true},};static defaultProps={showSeconds:true,showTime:true,};static template="web.DateTimeField";get endDateField(){return this.relatedField?this.props.endDateField||this.props.name:null;}
get field(){return this.props.record.fields[this.props.name];}
get relatedField(){return this.props.startDateField||this.props.endDateField;}
get startDateField(){return this.props.startDateField||this.props.name;}
get values(){return ensureArray(this.state.value);}
setup(){const getPickerProps=()=>{const value=this.getRecordValue();const pickerProps={value,type:this.field.type,range:this.isRange(value),};if(this.props.maxDate){pickerProps.maxDate=this.parseLimitDate(this.props.maxDate);}
if(this.props.minDate){pickerProps.minDate=this.parseLimitDate(this.props.minDate);}
if(!isNaN(this.props.rounding)){pickerProps.rounding=this.props.rounding;}else if(!this.props.showSeconds){pickerProps.rounding=0;}
if(this.props.maxPrecision){pickerProps.maxPrecision=this.props.maxPrecision;}
if(this.props.minPrecision){pickerProps.minPrecision=this.props.minPrecision;}
return pickerProps;};const dateTimePicker=useDateTimePicker({target:"root",showSeconds:this.props.showSeconds,condensed:this.props.condensed,get pickerProps(){return getPickerProps();},onChange:()=>{this.state.range=this.isRange(this.state.value);},onApply:()=>{const toUpdate={};if(Array.isArray(this.state.value)){[toUpdate[this.startDateField],toUpdate[this.endDateField]]=this.state.value;}else{toUpdate[this.props.name]=this.state.value;}
for(const fieldName in toUpdate){if(areDatesEqual(toUpdate[fieldName],this.props.record.data[fieldName])){delete toUpdate[fieldName];}}
if(Object.keys(toUpdate).length){this.props.record.update(toUpdate);}},});this.state=useState(dateTimePicker.state);this.openPicker=dateTimePicker.open;onWillRender(()=>this.triggerIsDirty());}
async addDate(valueIndex){const values=this.values;values[valueIndex]=valueIndex?values[0].plus({hours:1}):values[1].minus({hours:1});this.state.focusedDateIndex=valueIndex;this.state.value=values;this.state.range=true;this.openPicker(valueIndex);}
getFormattedValue(valueIndex){const value=this.values[valueIndex];const{condensed,showSeconds,showTime}=this.props;return value?this.field.type==="date"?formatDate(value,{condensed}):formatDateTime(value,{condensed,showSeconds,showTime}):"";}
getRecordValue(){if(this.relatedField){return[this.props.record.data[this.startDateField],this.props.record.data[this.endDateField],];}else{return this.props.record.data[this.props.name];}}
isDateInTheFuture(index){return this.values[index]>today();}
isEmpty(fieldName){return fieldName===this.startDateField?!this.values[0]:!this.values[1];}
isRange(value){if(!this.relatedField){return false;}
return(this.props.alwaysRange||this.props.required||ensureArray(value).filter(Boolean).length===2);}
parseLimitDate(value){if(value==="today"){return value;}
return this.field.type==="date"?deserializeDate(value):deserializeDateTime(value);}
shouldShowSeparator(){return((this.props.alwaysRange&&(this.props.readonly?!this.isEmpty(this.startDateField)||!this.isEmpty(this.endDateField):true))||(this.state.range&&(this.props.required||(!this.isEmpty(this.startDateField)&&!this.isEmpty(this.endDateField)))));}
triggerIsDirty(isDirty){this.props.record.model.bus.trigger("FIELD_IS_DIRTY",isDirty??!areDatesEqual(this.getRecordValue(),this.state.value));}
onInput(){this.triggerIsDirty(true);}}
const START_DATE_FIELD_OPTION="start_date_field";const END_DATE_FIELD_OPTION="end_date_field";const dateField=__exports.dateField={component:DateTimeField,displayName:_t("Date"),supportedOptions:[{label:_t("Earliest accepted date"),name:"min_date",type:"string",help:_t(`ISO-formatted date (e.g. "2018-12-31") or "%s".`,"today"),},{label:_t("Latest accepted date"),name:"max_date",type:"string",help:_t(`ISO-formatted date (e.g. "2018-12-31") or "%s".`,"today"),},{label:_t("Warning for future dates"),name:"warn_future",type:"boolean",help:_t(`Displays a warning icon if the input dates are in the future.`),},{label:_t("Minimal precision"),name:"min_precision",type:"selection",help:_t(`Choose which minimal precision (days, months, ...) you want in the datetime picker.`),choices:[{label:_t("Days"),value:"days"},{label:_t("Months"),value:"months"},{label:_t("Years"),value:"years"},{label:_t("Decades"),value:"decades"},],},{label:_t("Maximal precision"),name:"max_precision",type:"selection",help:_t(`Choose which maximal precision (days, months, ...) you want in the datetime picker.`),choices:[{label:_t("Days"),value:"days"},{label:_t("Months"),value:"months"},{label:_t("Years"),value:"years"},{label:_t("Decades"),value:"decades"},],},{label:_t("Condensed display"),name:"condensed",type:"boolean",help:_t(`Set to true to display days, months (and hours) with unpadded numbers`),},],supportedTypes:["date"],extractProps:({attrs,options},dynamicInfo)=>({endDateField:options[END_DATE_FIELD_OPTION],maxDate:options.max_date,minDate:options.min_date,alwaysRange:exprToBoolean(options.always_range),placeholder:attrs.placeholder,required:dynamicInfo.required,rounding:options.rounding&&parseInt(options.rounding,10),startDateField:options[START_DATE_FIELD_OPTION],warnFuture:exprToBoolean(options.warn_future),minPrecision:options.min_precision,maxPrecision:options.max_precision,condensed:options.condensed,}),fieldDependencies:({type,attrs,options})=>{const deps=[];if(options[START_DATE_FIELD_OPTION]){deps.push({name:options[START_DATE_FIELD_OPTION],type,readonly:false,...attrs,});if(options[END_DATE_FIELD_OPTION]){console.warn(`A field cannot have both ${START_DATE_FIELD_OPTION} and ${END_DATE_FIELD_OPTION} options at the same time`);}}else if(options[END_DATE_FIELD_OPTION]){deps.push({name:options[END_DATE_FIELD_OPTION],type,readonly:false,...attrs,});}
return deps;},};const dateTimeField=__exports.dateTimeField={...dateField,displayName:_t("Date & Time"),supportedOptions:[...dateField.supportedOptions,{label:_t("Time interval"),name:"rounding",type:"number",default:5,help:_t(`Control the number of minutes in the time selection. E.g. set it to 15 to work in quarters.`),},{label:_t("Show seconds"),name:"show_seconds",type:"boolean",default:true,help:_t(`Displays or hides the seconds in the datetime value.`),},{label:_t("Show time"),name:"show_time",type:"boolean",default:true,help:_t(`Displays or hides the time in the datetime value.`),},],extractProps:({attrs,options},dynamicInfo)=>({...dateField.extractProps({attrs,options},dynamicInfo),showSeconds:exprToBoolean(options.show_seconds??true),showTime:exprToBoolean(options.show_time??true),}),supportedTypes:["datetime"],};const dateRangeField=__exports.dateRangeField={...dateTimeField,displayName:_t("Date Range"),supportedOptions:[...dateTimeField.supportedOptions,{label:_t("Start date field"),name:START_DATE_FIELD_OPTION,type:"field",availableTypes:["date","datetime"],},{label:_t("End date field"),name:END_DATE_FIELD_OPTION,type:"field",availableTypes:["date","datetime"],},{label:_t("Always range"),name:"always_range",type:"boolean",default:false,help:_t(`Set to true the full range input has to be display by default, even if empty.`),},],supportedTypes:["date","datetime"],listViewWidth:({type})=>(type==="datetime"?294:180),isValid:(record,fieldname,fieldInfo)=>{if(fieldInfo.widget==="daterange"){if(!record.data[fieldInfo.options[END_DATE_FIELD_OPTION]]!==!record.data[fieldname]&&evaluateBooleanExpr(record.activeFields[fieldInfo.options[END_DATE_FIELD_OPTION]]?.required,record.evalContextWithVirtualIds)){return false;}
if(!record.data[fieldInfo.options[START_DATE_FIELD_OPTION]]!==!record.data[fieldname]&&evaluateBooleanExpr(record.activeFields[fieldInfo.options[START_DATE_FIELD_OPTION]]?.required,record.evalContextWithVirtualIds)){return false;}}
return!record.isFieldInvalid(fieldname);},};registry.category("fields").add("date",dateField).add("daterange",dateRangeField).add("datetime",dateTimeField);return __exports;});;

/* /web/static/src/views/fields/datetime/list_datetime_field.js */
odoo.define('@web/views/fields/datetime/list_datetime_field',['@web/core/registry','@web/views/fields/datetime/datetime_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{DateTimeField,dateField,dateRangeField,dateTimeField}=require("@web/views/fields/datetime/datetime_field");const ListDateTimeField=__exports.ListDateTimeField=class ListDateTimeField extends DateTimeField{shouldShowSeparator(){return this.props.readonly?this.relatedField&&this.values.some(Boolean):super.shouldShowSeparator();}}
const listDateField=__exports.listDateField={...dateField,component:ListDateTimeField};const listDateRangeField=__exports.listDateRangeField={...dateRangeField,component:ListDateTimeField};const listDateTimeField=__exports.listDateTimeField={...dateTimeField,component:ListDateTimeField};registry.category("fields").add("list.date",listDateField).add("list.daterange",listDateRangeField).add("list.datetime",listDateTimeField);return __exports;});;

/* /web/static/src/views/fields/domain/domain_field.js */
odoo.define('@web/views/fields/domain/domain_field',['@web/core/l10n/translation','@odoo/owl','@web/core/domain','@web/core/domain_selector/domain_selector','@web/core/domain_selector_dialog/domain_selector_dialog','@web/core/py_js/py_builtin','@web/core/network/rpc','@web/core/registry','@web/views/view_dialogs/select_create_dialog','@web/views/fields/standard_field_props','@web/core/utils/hooks','@web/core/tree_editor/utils','@web/core/domain_selector/utils','@web/core/tree_editor/condition_tree','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component,useState}=require("@odoo/owl");const{Domain,InvalidDomainError}=require("@web/core/domain");const{DomainSelector}=require("@web/core/domain_selector/domain_selector");const{DomainSelectorDialog}=require("@web/core/domain_selector_dialog/domain_selector_dialog");const{EvaluationError}=require("@web/core/py_js/py_builtin");const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{SelectCreateDialog}=require("@web/views/view_dialogs/select_create_dialog");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{useBus,useService,useOwnedDialogs}=require("@web/core/utils/hooks");const{useGetTreeDescription,useMakeGetFieldDef}=require("@web/core/tree_editor/utils");const{useGetDefaultLeafDomain}=require("@web/core/domain_selector/utils");const{treeFromDomain}=require("@web/core/tree_editor/condition_tree");const{useRecordObserver}=require("@web/model/relational_model/utils");const DomainField=__exports.DomainField=class DomainField extends Component{static template="web.DomainField";static components={DomainSelector,};static props={...standardFieldProps,context:{type:Object,optional:true},editInDialog:{type:Boolean,optional:true},resModel:{type:String,optional:true},isFoldable:{type:Boolean,optional:true},};static defaultProps={editInDialog:false,isFoldable:false,};setup(){this.orm=useService("orm");this.getDomainTreeDescription=useGetTreeDescription();this.makeGetFieldDef=useMakeGetFieldDef();this.getDefaultLeafDomain=useGetDefaultLeafDomain();this.addDialog=useOwnedDialogs();this.state=useState({isValid:null,recordCount:null,folded:this.props.isFoldable,facets:[],});this.debugDomain=null;useRecordObserver(async(record,nextProps)=>{nextProps={...nextProps,record};if(this.debugDomain&&this.props.readonly!==nextProps.readonly){this.debugDomain=null;}
if(this.debugDomain){this.state.isValid=await this.quickValidityCheck(nextProps);if(!this.state.isValid){this.state.recordCount=0;nextProps.record.setInvalidField(nextProps.name);}}else{this.checkProps(nextProps);}
if(nextProps.isFoldable){this.loadFacets(nextProps);}});useBus(this.props.record.model.bus,"NEED_LOCAL_CHANGES",async(ev)=>{if(this.debugDomain){const props=this.props;const handleChanges=async()=>{await props.record.update({[props.name]:this.debugDomain});const isValid=await this.quickValidityCheck(props);if(isValid){this.debugDomain=null;}else{this.state.isValid=false;this.state.recordCount=0;props.record.setInvalidField(props.name);}};ev.detail.proms.push(handleChanges());}});}
getContext(props=this.props){return props.context;}
getDomain(props=this.props){return props.record.data[props.name]||"[]";}
getEvaluatedDomain(props=this.props){const domainStringRepr=this.getDomain(props);const evalContext=this.getContext(props);try{const domain=new Domain(domainStringRepr).toList(evalContext);return domain;}catch(error){if(error instanceof InvalidDomainError||error instanceof EvaluationError){return{isInvalid:true};}
throw error;}}
getResModel(props=this.props){let resModel=props.resModel;if(props.record.fieldNames.includes(resModel)){resModel=props.record.data[resModel];}
return resModel;}
async addCondition(){const defaultDomain=await this.getDefaultLeafDomain(this.getResModel());this.update(defaultDomain);this.state.folded=false;}
async loadFacets(props=this.props){const resModel=this.getResModel(props);if(!resModel){this.state.facets=[];this.state.folded=false;return;}
if(typeof resModel!=="string"){throw new Error(`Invalid model: ${resModel}`);}
let promises=[];const domain=this.getDomain(props);try{const getFieldDef=await this.makeGetFieldDef(resModel,treeFromDomain(domain));const tree=treeFromDomain(domain,{distributeNot:!this.env.debug,getFieldDef});const trees=!tree.negate&&tree.value==="&"?tree.children:[tree];promises=trees.map((tree)=>this.getDomainTreeDescription(resModel,tree));}catch(error){if(error.data?.name==="builtins.KeyError"&&error.data.message===resModel){throw new Error(`Invalid model: ${resModel}`);}
this.state.facets=[];this.state.folded=false;}
this.state.facets=await Promise.all(promises);}
async checkProps(props=this.props){const resModel=this.getResModel(props);if(!resModel){this.updateState({});return;}
if(typeof resModel!=="string"){throw new Error(`Invalid model: ${resModel}`);}
const domain=this.getEvaluatedDomain(props);if(domain.isInvalid){this.updateState({isValid:false,recordCount:0});return;}
let recordCount;const context=this.getContext(props);try{recordCount=await this.orm.silent.searchCount(resModel,domain,{context});}catch(error){if(error.data?.name==="builtins.KeyError"&&error.data.message===resModel){throw new Error(`Invalid model: ${resModel}`);}
this.updateState({isValid:false,recordCount:0});return;}
this.updateState({isValid:true,recordCount});}
onButtonClick(){this.addDialog(SelectCreateDialog,{title:_t("Selected records"),noCreate:true,multiSelect:false,resModel:this.getResModel(),domain:this.getEvaluatedDomain(),context:this.getContext(),},{onClose:()=>this.checkProps(),});}
onEditDialogBtnClick(){this.addDialog(DomainSelectorDialog,{resModel:this.getResModel(),domain:this.getDomain(),isDebugMode:!!this.env.debug,onConfirm:this.update.bind(this),});}
async quickValidityCheck(props){const resModel=this.getResModel(props);if(!resModel){return false;}
const domain=this.getEvaluatedDomain(props);if(domain.isInvalid){return false;}
return rpc("/web/domain/validate",{model:resModel,domain});}
update(domain,isDebugEdited=false){if(!isDebugEdited){this.debugDomain=null;}
this.props.record.update({[this.props.name]:domain});this.props.record.model.bus.trigger("FIELD_IS_DIRTY",false);}
debugUpdate(domain){const isDirty=domain!==this.getDomain();this.debugDomain=isDirty?domain:null;this.props.record.model.bus.trigger("FIELD_IS_DIRTY",isDirty);if(!this.props.record.isValid){this.props.record.resetFieldValidity(this.props.name);}}
fold(){this.state.folded=true;}
updateState(params={}){Object.assign(this.state,{isValid:"isValid"in params?params.isValid:null,recordCount:"recordCount"in params?params.recordCount:null,});}}
const domainField=__exports.domainField={component:DomainField,displayName:_t("Domain"),supportedOptions:[{label:_t("Edit in dialog"),name:"in_dialog",type:"boolean",},{label:_t("Foldable"),name:"foldable",type:"boolean",help:_t("Display the domain using facets"),},{label:_t("Model"),name:"model",type:"string",},],supportedTypes:["char"],isEmpty:()=>false,extractProps({options},dynamicInfo){return{editInDialog:options.in_dialog,isFoldable:options.foldable,resModel:options.model,context:dynamicInfo.context,};},};registry.category("fields").add("domain",domainField);return __exports;});;

/* /web/static/src/views/fields/dynamic_placeholder_hook.js */
odoo.define('@web/views/fields/dynamic_placeholder_hook',['@web/core/popover/popover_hook','@web/core/utils/hooks','@odoo/owl','@web/core/l10n/translation','@web/views/fields/dynamic_placeholder_popover'],function(require){'use strict';let __exports={};const{usePopover}=require("@web/core/popover/popover_hook");const{useService}=require("@web/core/utils/hooks");const{useComponent}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{DynamicPlaceholderPopover}=require("@web/views/fields/dynamic_placeholder_popover");__exports.useDynamicPlaceholder=useDynamicPlaceholder;function useDynamicPlaceholder(elementRef){const TRIGGER_KEY="#";const ownerField=useComponent();const triggerKeyReplaceRegex=new RegExp(`${TRIGGER_KEY}$`);let closeCallback;let positionCallback;const popover=usePopover(DynamicPlaceholderPopover,{onClose:()=>closeCallback?.(),onPositioned:(popper,position)=>positionCallback?.(popper,position),});const notification=useService("notification");let model=null;const onDynamicPlaceholderValidate=function(path,defaultValue){const element=elementRef?.el;if(!element){return;}
let rangeIndex=parseInt(element.getAttribute("data-oe-dynamic-placeholder-range-index"));if(path){defaultValue=defaultValue.replace("|||","");const dynamicPlaceholder=` {{object.${path}${
                defaultValue?.length ? `|||${defaultValue}` : ""
            }}}`;const baseValue=element.value;const splitedValue=[baseValue.slice(0,rangeIndex),baseValue.slice(rangeIndex)];const newValue=splitedValue[0].replace(triggerKeyReplaceRegex,"")+
dynamicPlaceholder+
splitedValue[1];const changes={[ownerField.props.name]:newValue};ownerField.props.record.update(changes);element.value=newValue;rangeIndex+=dynamicPlaceholder.length-1;element.setSelectionRange(rangeIndex,rangeIndex);element.removeAttribute("data-oe-dynamic-placeholder-range-index");}};const onDynamicPlaceholderClose=function(){elementRef?.el.focus();};async function open(opts){if(!model){return notification.add(_t("You need to select a model before opening the dynamic placeholder selector."),{type:"danger"});}
closeCallback=opts.closeCallback;positionCallback=opts.positionCallback;popover.open(elementRef?.el,{resModel:model,validate:opts.validateCallback,});}
async function onKeydown(ev){const element=elementRef?.el;if(ev.target===element&&ev.key===TRIGGER_KEY){const currentRangeIndex=element.selectionStart;element.setAttribute("data-oe-dynamic-placeholder-range-index",currentRangeIndex+1);await open({validateCallback:onDynamicPlaceholderValidate,closeCallback:onDynamicPlaceholderClose,});}}
function updateModel(model_name_location){const recordData=ownerField.props.record.data;model=recordData[model_name_location]||recordData.model;}
return{updateModel:updateModel,onKeydown:onKeydown,setElementRef:(er)=>(elementRef=er),open:open,};}
return __exports;});;

/* /web/static/src/views/fields/dynamic_placeholder_popover.js */
odoo.define('@web/views/fields/dynamic_placeholder_popover',['@web/core/utils/functions','@web/core/utils/hooks','@web/core/model_field_selector/model_field_selector_popover','@odoo/owl','@web/core/user'],function(require){'use strict';let __exports={};const{memoize}=require("@web/core/utils/functions");const{useAutofocus,useService}=require("@web/core/utils/hooks");const{ModelFieldSelectorPopover}=require("@web/core/model_field_selector/model_field_selector_popover");const{Component,onWillStart,useState}=require("@odoo/owl");const{user}=require("@web/core/user");const allowedQwebExpressions=memoize(async(model,orm)=>{return await orm.call(model,"mail_allowed_qweb_expressions");});const DynamicPlaceholderPopover=__exports.DynamicPlaceholderPopover=class DynamicPlaceholderPopover extends Component{static template="web.DynamicPlaceholderPopover";static components={ModelFieldSelectorPopover,};static props=["resModel","validate","close"];setup(){useAutofocus();this.state=useState({path:"",isPathSelected:false,defaultValue:"",});this.orm=useService("orm");onWillStart(async()=>{[this.isTemplateEditor,this.allowedQwebExpressions]=await Promise.all([user.hasGroup("mail.group_mail_template_editor"),allowedQwebExpressions(this.props.resModel,this.orm),]);});}
filter(fieldDef,path){const fullPath=`object${path ? `.${path}` : ""}.${fieldDef.name}`;if(!this.isTemplateEditor&&!this.allowedQwebExpressions.includes(fullPath)){return false;}
return!["one2many","boolean","many2many"].includes(fieldDef.type)&&fieldDef.searchable;}
closeFieldSelector(isPathSelected=false){if(isPathSelected){this.state.isPathSelected=true;return;}
this.props.close();}
setPath(path,fieldInfo){this.state.path=path;this.state.fieldName=fieldInfo?.string;}
setDefaultValue(value){this.state.defaultValue=value;}
validate(){this.props.validate(this.state.path,this.state.defaultValue);this.props.close();}
onBack(){this.state.defaultValue="";this.state.isPathSelected=false;this.state.path="";}
async onInputKeydown(ev){switch(ev.key){case"Enter":{this.validate();ev.stopPropagation();ev.preventDefault();break;}
case"Escape":{this.props.close();break;}}}}
return __exports;});;

/* /web/static/src/views/fields/dynamic_widget/dynamic_model_field_selector.js */
odoo.define('@web/views/fields/dynamic_widget/dynamic_model_field_selector',['@web/core/model_field_selector/model_field_selector'],function(require){'use strict';let __exports={};const{ModelFieldSelector}=require("@web/core/model_field_selector/model_field_selector");const DynamicModelFieldSelector=__exports.DynamicModelFieldSelector=class DynamicModelFieldSelector extends ModelFieldSelector{static props={...ModelFieldSelector.props,record:{type:Object,optional:true},recordProps:{type:Object,optional:true},};}
return __exports;});;

/* /web/static/src/views/fields/dynamic_widget/dynamic_model_field_selector_char.js */
odoo.define('@web/views/fields/dynamic_widget/dynamic_model_field_selector_char',['@web/core/registry','@web/core/utils/strings','@web/views/fields/char/char_field','@web/core/l10n/translation','@web/views/fields/dynamic_widget/dynamic_model_field_selector'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{exprToBoolean}=require("@web/core/utils/strings");const{CharField,charField}=require("@web/views/fields/char/char_field");const{_t}=require("@web/core/l10n/translation");const{DynamicModelFieldSelector}=require("@web/views/fields/dynamic_widget/dynamic_model_field_selector");const DynamicModelFieldSelectorChar=__exports.DynamicModelFieldSelectorChar=class DynamicModelFieldSelectorChar extends CharField{static template="web.DynamicModelFieldSelectorChar";static components={...CharField.components,DynamicModelFieldSelector,};static props={...CharField.props,resModel:{type:String,optional:true},onlySearchable:{type:Boolean,optional:true},followRelations:{type:Boolean,optional:true},};async _onRecordUpdate(value){await this.props.record.update({[this.props.name]:value});}
get getSelectorProps(){return{path:this.props.record.data[this.props.name],resModel:this.getResModel(),readonly:this.props.readonly,record:this.props.record,recordProps:this.props,update:this._onRecordUpdate.bind(this),isDebugMode:!!this.env.debug,filter:this.filter.bind(this),followRelations:this.props.followRelations,};}
filter(fieldDef){return!this.props.onlySearchable||fieldDef.searchable;}
getResModel(props=this.props){const resModel=props.record.data[props.resModel];if(!resModel){return props.record.resModel;}
return resModel;}}
const dynamicModelFieldSelectorChar=__exports.dynamicModelFieldSelectorChar={...charField,component:DynamicModelFieldSelectorChar,supportedOptions:[{label:_t("Follow relations"),name:"follow_relations",type:"boolean",default:true,},{label:_t("Model"),name:"model",type:"string",},{label:_t("Only searchable"),name:"only_searchable",type:"string",},],extractProps({options},dynamicInfo){return{followRelations:options.follow_relations??true,onlySearchable:exprToBoolean(options.only_searchable),resModel:options.model,};},};registry.category("fields").add("DynamicModelFieldSelectorChar",dynamicModelFieldSelectorChar);return __exports;});;

/* /web/static/src/views/fields/email/email_field.js */
odoo.define('@web/views/fields/email/email_field',['@web/core/registry','@web/core/l10n/translation','@web/views/fields/input_field_hook','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{useInputField}=require("@web/views/fields/input_field_hook");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const EmailField=__exports.EmailField=class EmailField extends Component{static template="web.EmailField";static props={...standardFieldProps,placeholder:{type:String,optional:true},};setup(){useInputField({getValue:()=>this.props.record.data[this.props.name]||""});}}
const emailField=__exports.emailField={component:EmailField,displayName:_t("Email"),supportedTypes:["char"],extractProps:({attrs})=>({placeholder:attrs.placeholder,}),};registry.category("fields").add("email",emailField);class FormEmailField extends EmailField{static template="web.FormEmailField";}
const formEmailField=__exports.formEmailField={...emailField,component:FormEmailField,};registry.category("fields").add("form.email",formEmailField);return __exports;});;

/* /web/static/src/views/fields/field.js */
odoo.define('@web/views/fields/field',['@web/core/domain','@web/core/py_js/py','@web/core/registry','@web/core/ui/ui_service','@web/core/utils/strings','@web/model/relational_model/utils','@web/views/utils','@web/views/fields/field_tooltip','@odoo/owl'],function(require){'use strict';let __exports={};const{Domain}=require("@web/core/domain");const{evaluateBooleanExpr,evaluateExpr}=require("@web/core/py_js/py");const{registry}=require("@web/core/registry");const{utils}=require("@web/core/ui/ui_service");const{exprToBoolean}=require("@web/core/utils/strings");const{getFieldContext}=require("@web/model/relational_model/utils");const{X2M_TYPES,getClassNameFromDecoration}=require("@web/views/utils");const{getTooltipInfo}=require("@web/views/fields/field_tooltip");const{Component,xml}=require("@odoo/owl");const isSmall=utils.isSmall;const viewRegistry=registry.category("views");const fieldRegistry=registry.category("fields");const supportedInfoValidation={type:Array,element:Object,shape:{label:String,name:String,type:String,availableTypes:{type:Array,element:String,optional:true},default:{type:String,optional:true},help:{type:String,optional:true},choices:{type:Array,element:Object,shape:{label:String,value:String},optional:true,},},optional:true,};fieldRegistry.addValidation({component:{validate:(c)=>c.prototype instanceof Component},displayName:{type:String,optional:true},supportedAttributes:supportedInfoValidation,supportedOptions:supportedInfoValidation,supportedTypes:{type:Array,element:String,optional:true},extractProps:{type:Function,optional:true},isEmpty:{type:Function,optional:true},isValid:{type:Function,optional:true},additionalClasses:{type:Array,element:String,optional:true},fieldDependencies:{type:[Function,{type:Array,element:Object,shape:{name:String,type:String}}],optional:true,},relatedFields:{type:[Function,{type:Array,element:Object,shape:{name:String,type:String,readonly:{type:Boolean,optional:true},selection:{type:Array,element:{type:Array,element:String}},optional:true,},},],optional:true,},useSubView:{type:Boolean,optional:true},label:{type:[String,{value:false}],optional:true},listViewWidth:{type:[Number,{type:Array,element:Number,validate:(array)=>array.length===1||array.length===2,},Function,],optional:true,},});class DefaultField extends Component{static template=xml``;static props=["*"];}
__exports.getFieldFromRegistry=getFieldFromRegistry;function getFieldFromRegistry(fieldType,widget,viewType,jsClass){const prefixes=jsClass?[jsClass,viewType,""]:[viewType,""];const findInRegistry=(key)=>{for(const prefix of prefixes){const _key=prefix?`${prefix}.${key}`:key;if(fieldRegistry.contains(_key)){return fieldRegistry.get(_key);}}};if(widget){const field=findInRegistry(widget);if(field){return field;}
console.warn(`Missing widget: ${widget} for field of type ${fieldType}`);}
return findInRegistry(fieldType)||{component:DefaultField};}
__exports.fieldVisualFeedback=fieldVisualFeedback;function fieldVisualFeedback(field,record,fieldName,fieldInfo){const readonly=evaluateBooleanExpr(fieldInfo.readonly,record.evalContextWithVirtualIds);const required=evaluateBooleanExpr(fieldInfo.required,record.evalContextWithVirtualIds);const inEdit=record.isInEdition;let empty=!record.isNew;if("isEmpty"in field){empty=empty&&field.isEmpty(record,fieldName);}else{empty=empty&&!record.data[fieldName];}
empty=inEdit?empty&&readonly:empty;return{readonly,required,invalid:field.isValid?!field.isValid(record,fieldName,fieldInfo):record.isFieldInvalid(fieldName),empty,};}
__exports.getPropertyFieldInfo=getPropertyFieldInfo;function getPropertyFieldInfo(propertyField){const{name,relatedPropertyField,string,type}=propertyField;const fieldInfo={name,string,type,widget:type,options:{},column_invisible:"False",invisible:"False",readonly:"False",required:"False",attrs:{},relatedPropertyField,context:"{}",help:undefined,onChange:false,forceSave:false,decorations:{},};if(type==="many2one"||type==="many2many"){const{domain,relation}=propertyField;fieldInfo.relation=relation;fieldInfo.domain=domain;if(relation==="res.users"||relation==="res.partner"){fieldInfo.widget=propertyField.type==="many2one"?"many2one_avatar":"many2many_tags_avatar";}else{fieldInfo.widget=propertyField.type==="many2one"?type:"many2many_tags";}}else if(type==="tags"){fieldInfo.tags=propertyField.tags;fieldInfo.widget=`property_tags`;}else if(type==="selection"){fieldInfo.selection=propertyField.selection;}
fieldInfo.field=getFieldFromRegistry(propertyField.type,fieldInfo.widget);let{relatedFields}=fieldInfo.field;if(relatedFields){if(relatedFields instanceof Function){relatedFields=relatedFields({options:{},attrs:{}});}
fieldInfo.relatedFields=Object.fromEntries(relatedFields.map((f)=>[f.name,f]));}
return fieldInfo;}
const Field=__exports.Field=class Field extends Component{static template="web.Field";static props=["fieldInfo?","*"];static parseFieldNode=function(node,models,modelName,viewType,jsClass){const name=node.getAttribute("name");const widget=node.getAttribute("widget");const fields=models[modelName].fields;if(!fields[name]){throw new Error(`"${modelName}"."${name}" field is undefined.`);}
const field=getFieldFromRegistry(fields[name].type,widget,viewType,jsClass);const fieldInfo={name,type:fields[name].type,viewType,widget,field,context:"{}",string:fields[name].string,help:undefined,onChange:false,forceSave:false,options:{},decorations:{},attrs:{},domain:undefined,};for(const attr of["invisible","column_invisible","readonly","required"]){fieldInfo[attr]=node.getAttribute(attr);if(fieldInfo[attr]==="True"){if(attr==="column_invisible"){fieldInfo.invisible="True";}}else if(fieldInfo[attr]===null&&fields[name][attr]){fieldInfo[attr]="True";}}
for(const{name,value}of node.attributes){if(["name","widget"].includes(name)){continue;}
if(["context","string","help","domain"].includes(name)){fieldInfo[name]=value;}else if(name==="on_change"){fieldInfo.onChange=exprToBoolean(value);}else if(name==="options"){fieldInfo.options=evaluateExpr(value);}else if(name==="force_save"){fieldInfo.forceSave=exprToBoolean(value);}else if(name.startsWith("decoration-")){fieldInfo.decorations[name.replace("decoration-","")]=value;}else if(!name.startsWith("t-att")){fieldInfo.attrs[name]=value;}}
if(name==="id"){fieldInfo.readonly="True";}
if(widget==="handle"){fieldInfo.isHandle=true;}
if(X2M_TYPES.includes(fields[name].type)){const views={};let relatedFields=fieldInfo.field.relatedFields;if(relatedFields){if(relatedFields instanceof Function){relatedFields=relatedFields(fieldInfo);}
for(const relatedField of relatedFields){if(!("readonly"in relatedField)){relatedField.readonly=true;}}
relatedFields=Object.fromEntries(relatedFields.map((f)=>[f.name,f]));views.default={fieldNodes:relatedFields,fields:relatedFields};if(!fieldInfo.field.useSubView){fieldInfo.viewMode="default";}}
for(const child of node.children){const viewType=child.tagName;const{ArchParser}=viewRegistry.get(viewType);const childCopy=child.cloneNode(true);const archInfo=new ArchParser().parse(childCopy,models,fields[name].relation);views[viewType]={...archInfo,limit:archInfo.limit||40,fields:models[fields[name].relation].fields,};}
let viewMode=node.getAttribute("mode");if(viewMode){if(viewMode.split(",").length!==1){viewMode=isSmall()?"kanban":"list";}}else{if(views.list&&!views.kanban){viewMode="list";}else if(!views.list&&views.kanban){viewMode="kanban";}else if(views.list&&views.kanban){viewMode=isSmall()?"kanban":"list";}}
if(viewMode){fieldInfo.viewMode=viewMode;}
if(Object.keys(views).length){fieldInfo.relatedFields=models[fields[name].relation]?.fields;fieldInfo.views=views;}}
if(fields[name].type==="many2one_reference"){let relatedFields=fieldInfo.field.relatedFields;if(relatedFields){relatedFields=Object.fromEntries(relatedFields.map((f)=>[f.name,f]));fieldInfo.viewMode="default";fieldInfo.views={default:{fieldNodes:relatedFields,fields:relatedFields},};}}
return fieldInfo;};setup(){if(this.props.fieldInfo){this.field=this.props.fieldInfo.field;}else{const fieldType=this.props.record.fields[this.props.name].type;this.field=getFieldFromRegistry(fieldType,this.props.type);}}
get classNames(){const{class:_class,fieldInfo,name,record}=this.props;const{readonly,required,invalid,empty}=fieldVisualFeedback(this.field,record,name,fieldInfo||{});const classNames={o_field_widget:true,o_readonly_modifier:readonly,o_required_modifier:required,o_field_invalid:invalid,o_field_empty:empty,[`o_field_${this.type}`]:true,[_class]:Boolean(_class),};if(this.field.additionalClasses){for(const cls of this.field.additionalClasses){classNames[cls]=true;}}
if(fieldInfo&&fieldInfo.decorations){const{decorations}=fieldInfo;for(const decoName in decorations){const value=evaluateBooleanExpr(decorations[decoName],record.evalContextWithVirtualIds);classNames[getClassNameFromDecoration(decoName)]=value;}}
return classNames;}
get type(){return this.props.type||this.props.record.fields[this.props.name].type;}
get fieldComponentProps(){const record=this.props.record;let readonly=this.props.readonly||false;let propsFromNode={};if(this.props.fieldInfo){let fieldInfo=this.props.fieldInfo;readonly=readonly||evaluateBooleanExpr(fieldInfo.readonly,record.evalContextWithVirtualIds);if(this.field.extractProps){if(this.props.attrs){fieldInfo={...fieldInfo,attrs:{...fieldInfo.attrs,...this.props.attrs},};}
const dynamicInfo={get context(){return getFieldContext(record,fieldInfo.name,fieldInfo.context);},domain(){const evalContext=record.evalContext;if(fieldInfo.domain){return new Domain(evaluateExpr(fieldInfo.domain,evalContext)).toList();}},required:evaluateBooleanExpr(fieldInfo.required,record.evalContextWithVirtualIds),readonly:readonly,};propsFromNode=this.field.extractProps(fieldInfo,dynamicInfo);}}
const props={...this.props};delete props.style;delete props.class;delete props.showTooltip;delete props.fieldInfo;delete props.attrs;delete props.type;delete props.readonly;return{readonly:readonly||!record.isInEdition||false,...propsFromNode,...props,};}
get tooltip(){if(this.props.showTooltip){const tooltip=getTooltipInfo({field:this.props.record.fields[this.props.name],fieldInfo:this.props.fieldInfo||{},});if(Boolean(odoo.debug)||(tooltip&&JSON.parse(tooltip).field.help)){return tooltip;}}
return false;}}
return __exports;});;

/* /web/static/src/views/fields/field_tooltip.js */
odoo.define('@web/views/fields/field_tooltip',[],function(require){'use strict';let __exports={};__exports.getTooltipInfo=getTooltipInfo;function getTooltipInfo(params){let widgetDescription=undefined;if(params.fieldInfo.widget){widgetDescription=params.fieldInfo.field.displayName;}
const info={viewMode:params.viewMode,resModel:params.resModel,debug:Boolean(odoo.debug),field:{name:params.field.name,label:params.field.string,help:params.fieldInfo.help??params.field.help,type:params.field.type,widget:params.fieldInfo.widget,widgetDescription,context:params.fieldInfo.context,domain:params.fieldInfo.domain||params.field.domain,invisible:params.fieldInfo.invisible,column_invisible:params.fieldInfo.column_invisible,readonly:params.fieldInfo.readonly,required:params.fieldInfo.required,changeDefault:params.field.change_default,relation:params.field.relation,model_field:params.field.model_field,selection:params.field.selection,default:params.field.default,},};return JSON.stringify(info);}
return __exports;});;

/* /web/static/src/views/fields/file_handler.js */
odoo.define('@web/views/fields/file_handler',['@web/core/l10n/translation','@web/core/utils/hooks','@web/core/utils/urls','@web/core/utils/files','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{getDataURLFromFile}=require("@web/core/utils/urls");const{checkFileSize}=require("@web/core/utils/files");const{Component,useRef,useState}=require("@odoo/owl");const FileUploader=__exports.FileUploader=class FileUploader extends Component{static template="web.FileUploader";static props={onClick:{type:Function,optional:true},onUploaded:Function,onUploadComplete:{type:Function,optional:true},multiUpload:{type:Boolean,optional:true},checkSize:{type:Boolean,optional:true},inputName:{type:String,optional:true},fileUploadClass:{type:String,optional:true},acceptedFileExtensions:{type:String,optional:true},slots:{type:Object,optional:true},showUploadingText:{type:Boolean,optional:true},};static defaultProps={checkSize:true,showUploadingText:true,};setup(){this.notification=useService("notification");this.fileInputRef=useRef("fileInput");this.state=useState({isUploading:false,});}
async onFileChange(ev){if(!ev.target.files.length){return;}
const{target}=ev;for(const file of ev.target.files){if(this.props.checkSize&&!checkFileSize(file.size,this.notification)){return null;}
this.state.isUploading=true;const data=await getDataURLFromFile(file);if(!file.size){console.warn(`Error while uploading file : ${file.name}`);this.notification.add(_t("There was a problem while uploading your file."),{type:"danger",});}
try{await this.props.onUploaded({name:file.name,size:file.size,type:file.type,data:data.split(",")[1],objectUrl:file.type==="application/pdf"?URL.createObjectURL(file):null,});}finally{this.state.isUploading=false;}}
target.value=null;if(this.props.multiUpload&&this.props.onUploadComplete){this.props.onUploadComplete({});}}
async onSelectFileButtonClick(ev){if(this.props.onClick){const ok=await this.props.onClick(ev);if(ok!==undefined&&!ok){return;}}
this.fileInputRef.el.click();}}
return __exports;});;

/* /web/static/src/views/fields/float/float_field.js */
odoo.define('@web/views/fields/float/float_field',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/input_field_hook','@web/views/fields/numpad_decimal_hook','@web/views/fields/formatters','@web/views/fields/parsers','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useInputField}=require("@web/views/fields/input_field_hook");const{useNumpadDecimal}=require("@web/views/fields/numpad_decimal_hook");const{formatFloat}=require("@web/views/fields/formatters");const{parseFloat}=require("@web/views/fields/parsers");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component,useState}=require("@odoo/owl");const FloatField=__exports.FloatField=class FloatField extends Component{static template="web.FloatField";static props={...standardFieldProps,formatNumber:{type:Boolean,optional:true},inputType:{type:String,optional:true},step:{type:Number,optional:true},digits:{type:Array,optional:true},placeholder:{type:String,optional:true},humanReadable:{type:Boolean,optional:true},decimals:{type:Number,optional:true},};static defaultProps={formatNumber:true,inputType:"text",humanReadable:false,decimals:0,};setup(){this.state=useState({hasFocus:false,});this.inputRef=useInputField({getValue:()=>this.formattedValue,refName:"numpadDecimal",parse:(v)=>this.parse(v),});useNumpadDecimal();}
onFocusIn(){this.state.hasFocus=true;}
onFocusOut(){this.state.hasFocus=false;}
parse(value){return this.props.inputType==="number"?Number(value):parseFloat(value);}
get formattedValue(){if(!this.props.formatNumber||(this.props.inputType==="number"&&!this.props.readonly&&this.value)){return this.value;}
const options={digits:this.props.digits,field:this.props.record.fields[this.props.name],};if(this.props.humanReadable&&!this.state.hasFocus){return formatFloat(this.value,{...options,humanReadable:true,decimals:this.props.decimals,});}else{return formatFloat(this.value,{...options,humanReadable:false});}}
get value(){return this.props.record.data[this.props.name];}}
const floatField=__exports.floatField={component:FloatField,displayName:_t("Float"),supportedOptions:[{label:_t("Format number"),name:"enable_formatting",type:"boolean",help:_t("Format the value according to your language setup - e.g. thousand separators, rounding, etc."),default:true,},{label:_t("Digits"),name:"digits",type:"digits",},{label:_t("Type"),name:"type",type:"string",},{label:_t("Step"),name:"step",type:"number",},{label:_t("User-friendly format"),name:"human_readable",type:"boolean",help:_t("Use a human readable format (e.g.: 500G instead of 500,000,000,000)."),},{label:_t("Decimals"),name:"decimals",type:"number",default:0,help:_t("Use it with the 'User-friendly format' option to customize the formatting."),},],supportedTypes:["float"],isEmpty:()=>false,extractProps:({attrs,options})=>{let digits;if(attrs.digits){digits=JSON.parse(attrs.digits);}else if(options.digits){digits=options.digits;}
return{formatNumber:options?.enable_formatting!==undefined?Boolean(options.enable_formatting):true,inputType:options.type,humanReadable:!!options.human_readable,step:options.step,digits,placeholder:attrs.placeholder,decimals:options.decimals||0,};},};registry.category("fields").add("float",floatField);return __exports;});;

/* /web/static/src/views/fields/float_factor/float_factor_field.js */
odoo.define('@web/views/fields/float_factor/float_factor_field',['@web/core/registry','@web/views/fields/float/float_field','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{floatField,FloatField}=require("@web/views/fields/float/float_field");const{_t}=require("@web/core/l10n/translation");const FloatFactorField=__exports.FloatFactorField=class FloatFactorField extends FloatField{static props={...FloatField.props,factor:{type:Number,optional:true},};static defaultProps={...FloatField.defaultProps,factor:1,};parse(value){return super.parse(value)/this.props.factor;}
get value(){return this.props.record.data[this.props.name]*this.props.factor;}}
const floatFactorField=__exports.floatFactorField={...floatField,component:FloatFactorField,supportedOptions:[...floatField.supportedOptions,{label:_t("Factor"),name:"factor",type:"number",},],extractProps({options}){const props=floatField.extractProps(...arguments);props.factor=options.factor;return props;},};registry.category("fields").add("float_factor",floatFactorField);return __exports;});;

/* /web/static/src/views/fields/float_time/float_time_field.js */
odoo.define('@web/views/fields/float_time/float_time_field',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/formatters','@web/views/fields/parsers','@web/views/fields/input_field_hook','@web/views/fields/standard_field_props','@web/views/fields/numpad_decimal_hook','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{formatFloatTime}=require("@web/views/fields/formatters");const{parseFloatTime}=require("@web/views/fields/parsers");const{useInputField}=require("@web/views/fields/input_field_hook");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{useNumpadDecimal}=require("@web/views/fields/numpad_decimal_hook");const{Component}=require("@odoo/owl");const FloatTimeField=__exports.FloatTimeField=class FloatTimeField extends Component{static template="web.FloatTimeField";static props={...standardFieldProps,inputType:{type:String,optional:true},placeholder:{type:String,optional:true},displaySeconds:{type:Boolean,optional:true},};static defaultProps={inputType:"text",};setup(){this.inputFloatTimeRef=useInputField({getValue:()=>this.formattedValue,refName:"numpadDecimal",parse:(v)=>parseFloatTime(v),});useNumpadDecimal();}
get formattedValue(){return formatFloatTime(this.props.record.data[this.props.name],{displaySeconds:this.props.displaySeconds,});}}
const floatTimeField=__exports.floatTimeField={component:FloatTimeField,displayName:_t("Time"),supportedOptions:[{label:_t("Display seconds"),name:"display_seconds",type:"boolean",},{label:_t("Type"),name:"type",type:"string",default:"text",},],supportedTypes:["float"],isEmpty:()=>false,extractProps:({attrs,options})=>({displaySeconds:options.displaySeconds,inputType:options.type,placeholder:attrs.placeholder,}),};registry.category("fields").add("float_time",floatTimeField);return __exports;});;

/* /web/static/src/views/fields/float_toggle/float_toggle_field.js */
odoo.define('@web/views/fields/float_toggle/float_toggle_field',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/formatters','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{formatFloatFactor}=require("@web/views/fields/formatters");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const FloatToggleField=__exports.FloatToggleField=class FloatToggleField extends Component{static template="web.FloatToggleField";static props={...standardFieldProps,digits:{type:Array,optional:true},range:{type:Array,optional:true},factor:{type:Number,optional:true},disableReadOnly:{type:Boolean,optional:true},};static defaultProps={range:[0.0,0.5,1.0],factor:1,disableReadOnly:false,};onChange(){let currentIndex=this.props.range.indexOf(this.props.record.data[this.props.name]*this.factor);currentIndex++;if(currentIndex>this.props.range.length-1){currentIndex=0;}
this.props.record.update({[this.props.name]:this.props.range[currentIndex]/this.factor,});}
get factor(){return this.props.factor;}
get formattedValue(){return formatFloatFactor(this.props.record.data[this.props.name],{digits:this.props.digits,factor:this.factor,field:this.props.record.fields[this.props.name],});}}
const floatToggleField=__exports.floatToggleField={component:FloatToggleField,supportedOptions:[{label:_t("Digits"),name:"digits",type:"digits",},{label:_t("Type"),name:"type",type:"string",},{label:_t("Range"),name:"range",type:"string",},{label:_t("Factor"),name:"factor",type:"number",},{label:_t("Disable readonly"),name:"force_button",type:"boolean",},],supportedTypes:["float"],isEmpty:()=>false,extractProps:({attrs,options})=>{let digits;if(attrs.digits){digits=JSON.parse(attrs.digits);}else if(options.digits){digits=options.digits;}
return{digits,range:options.range,factor:options.factor,disableReadOnly:options.force_button||false,};},};registry.category("fields").add("float_toggle",floatToggleField);return __exports;});;

/* /web/static/src/views/fields/formatters.js */
odoo.define('@web/views/fields/formatters',['@web/core/l10n/dates','@web/core/l10n/localization','@web/core/l10n/translation','@web/core/registry','@web/core/utils/binary','@web/core/utils/numbers','@web/core/utils/strings','@odoo/owl','@web/core/currency'],function(require){'use strict';let __exports={};const{formatDate:_formatDate,formatDateTime:_formatDateTime}=require("@web/core/l10n/dates");const{localization:l10n}=require("@web/core/l10n/localization");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{isBinarySize}=require("@web/core/utils/binary");const{formatFloat:formatFloatNumber,humanNumber,insertThousandsSep,}=require("@web/core/utils/numbers");const{escape,exprToBoolean}=require("@web/core/utils/strings");const{markup}=require("@odoo/owl");const{formatCurrency}=require("@web/core/currency");function humanSize(value){if(!value){return"";}
const suffix=value<1024?" "+_t("Bytes"):"b";return(humanNumber(value,{decimals:2,})+suffix);}
__exports.formatBinary=formatBinary;function formatBinary(value){if(!isBinarySize(value)){return humanSize(value.length/1.37);}
return value;}
__exports.formatBoolean=formatBoolean;function formatBoolean(value){return markup(`
        <div class="o-checkbox d-inline-block me-2">
            <input id="boolean_checkbox" type="checkbox" class="form-check-input" disabled ${
                value ? "checked" : ""
            }/>
            <label for="boolean_checkbox" class="form-check-label"/>
        </div>`);}
__exports.formatChar=formatChar;function formatChar(value,options){if(options&&options.isPassword){return"*".repeat(value?value.length:0);}
if(options&&options.escape){value=escape(value);}
return value;}
formatChar.extractOptions=({attrs})=>{return{isPassword:exprToBoolean(attrs.password),};};__exports.formatDate=formatDate;function formatDate(value,options){return _formatDate(value,options);}
formatDate.extractOptions=({options})=>{return{condensed:options.condensed};};__exports.formatDateTime=formatDateTime;function formatDateTime(value,options={}){if(options.showTime===false){return _formatDate(value,options);}
return _formatDateTime(value,options);}
formatDateTime.extractOptions=({attrs,options})=>{return{...formatDate.extractOptions({attrs,options}),showSeconds:exprToBoolean(options.show_seconds??true),showTime:exprToBoolean(options.show_time??true),};};__exports.formatFloat=formatFloat;function formatFloat(value,options={}){if(value===false){return"";}
if(!options.digits&&options.field){options.digits=options.field.digits;}
return formatFloatNumber(value,options);}
formatFloat.extractOptions=({attrs,options})=>{let digits;if(attrs.digits){digits=JSON.parse(attrs.digits);}else if(options.digits){digits=options.digits;}
const humanReadable=!!options.human_readable;const decimals=options.decimals||0;return{decimals,digits,humanReadable};};__exports.formatFloatFactor=formatFloatFactor;function formatFloatFactor(value,options={}){if(value===false){return"";}
const factor=options.factor||1;if(!options.digits&&options.field){options.digits=options.field.digits;}
return formatFloatNumber(value*factor,options);}
formatFloatFactor.extractOptions=({attrs,options})=>{return{...formatFloat.extractOptions({attrs,options}),factor:options.factor,};};__exports.formatFloatTime=formatFloatTime;function formatFloatTime(value,options={}){if(value===false){return"";}
const isNegative=value<0;value=Math.abs(value);let hour=Math.floor(value);const milliSecLeft=Math.round(value*3600000)-hour*3600000;let min=milliSecLeft/60000;if(options.displaySeconds){min=Math.floor(min);}else{min=Math.round(min);}
if(min===60){min=0;hour=hour+1;}
min=String(min).padStart(2,"0");if(!options.noLeadingZeroHour){hour=String(hour).padStart(2,"0");}
let sec="";if(options.displaySeconds){sec=":"+String(Math.floor((milliSecLeft%60000)/1000)).padStart(2,"0");}
return`${isNegative ? "-" : ""}${hour}:${min}${sec}`;}
formatFloatTime.extractOptions=({options})=>{return{displaySeconds:options.displaySeconds,};};__exports.formatInteger=formatInteger;function formatInteger(value,options={}){if(value===false||value===null){return"";}
if(options.isPassword){return"*".repeat(value.length);}
if(options.humanReadable){return humanNumber(value,options);}
const grouping=options.grouping||l10n.grouping;const thousandsSep="thousandsSep"in options?options.thousandsSep:l10n.thousandsSep;return insertThousandsSep(value.toFixed(0),thousandsSep,grouping);}
formatInteger.extractOptions=({attrs,options})=>{return{decimals:options.decimals||0,humanReadable:!!options.human_readable,isPassword:exprToBoolean(attrs.password),};};__exports.formatMany2one=formatMany2one;function formatMany2one(value,options){if(!value){value="";}else if(value[1]){value=value[1];}else{value=_t("Unnamed");}
if(options&&options.escape){value=encodeURIComponent(value);}
return value;}
__exports.formatX2many=formatX2many;function formatX2many(value){const count=value.currentIds.length;if(count===0){return _t("No records");}else if(count===1){return _t("1 record");}else{return _t("%s records",count);}}
__exports.formatMonetary=formatMonetary;function formatMonetary(value,options={}){if(value===false){return"";}
let currencyId=options.currencyId;if(!currencyId&&options.data){const currencyField=options.currencyField||(options.field&&options.field.currency_field)||"currency_id";const dataValue=options.data[currencyField];currencyId=Array.isArray(dataValue)?dataValue[0]:dataValue;}
return formatCurrency(value,currencyId,options);}
formatMonetary.extractOptions=({options})=>{return{noSymbol:options.no_symbol,currencyField:options.currency_field,};};__exports.formatPercentage=formatPercentage;function formatPercentage(value,options={}){value=value||0;options=Object.assign({trailingZeros:false,thousandsSep:""},options);if(!options.digits&&options.field){options.digits=options.field.digits;}
const formatted=formatFloatNumber(value*100,options);return`${formatted}${options.noSymbol ? "" : "%"}`;}
formatPercentage.extractOptions=formatFloat.extractOptions;function formatProperties(value,field){if(!value||!value.length){return"";}
return value.map((property)=>property["string"]).join(", ");}
__exports.formatReference=formatReference;function formatReference(value,options){return formatMany2one(value?[value.resId,value.displayName]:false,options);}
__exports.formatMany2oneReference=formatMany2oneReference;function formatMany2oneReference(value){return value?formatMany2one([value.resId,value.displayName]):"";}
__exports.formatSelection=formatSelection;function formatSelection(value,options={}){const selection=options.selection||(options.field&&options.field.selection)||[];const option=selection.find((option)=>option[0]===value);return option?option[1]:"";}
__exports.formatText=formatText;function formatText(value){return value?value.toString():"";}
__exports.formatHtml=formatHtml;function formatHtml(value){return value;}
__exports.formatJson=formatJson;function formatJson(value){return(value&&JSON.stringify(value))||"";}
registry.category("formatters").add("binary",formatBinary).add("boolean",formatBoolean).add("char",formatChar).add("date",formatDate).add("datetime",formatDateTime).add("float",formatFloat).add("float_factor",formatFloatFactor).add("float_time",formatFloatTime).add("html",formatHtml).add("integer",formatInteger).add("json",formatJson).add("many2one",formatMany2one).add("many2one_reference",formatMany2oneReference).add("one2many",formatX2many).add("many2many",formatX2many).add("monetary",formatMonetary).add("percentage",formatPercentage).add("properties",formatProperties).add("properties_definition",formatProperties).add("reference",formatReference).add("selection",formatSelection).add("text",formatText);return __exports;});;

/* /web/static/src/views/fields/gauge/gauge_field.js */
odoo.define('@web/views/fields/gauge/gauge_field',['@web/core/l10n/translation','@web/core/assets','@web/core/registry','@web/views/fields/formatters','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{loadBundle}=require("@web/core/assets");const{registry}=require("@web/core/registry");const{formatFloat}=require("@web/views/fields/formatters");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component,onWillStart,useEffect,useRef}=require("@odoo/owl");const GaugeField=__exports.GaugeField=class GaugeField extends Component{static template="web.GaugeField";static props={...standardFieldProps,maxValueField:{type:String,optional:true},maxValue:{type:Number,optional:true},title:{type:String,optional:true},};static defaultProps={maxValue:100,};setup(){this.chart=null;this.canvasRef=useRef("canvas");onWillStart(async()=>await loadBundle("web.chartjs_lib"));useEffect(()=>{this.renderChart();return()=>{if(this.chart){this.chart.destroy();}};});}
get title(){return this.props.title||this.props.record.fields[this.props.name].string||"";}
get formattedValue(){return formatFloat(this.props.record.data[this.props.name],{humanReadable:true,decimals:1,});}
renderChart(){const gaugeValue=this.props.record.data[this.props.name];let maxValue=this.props.maxValueField?this.props.record.data[this.props.maxValueField]:this.props.maxValue;maxValue=Math.max(gaugeValue,maxValue);let maxLabel=maxValue;if(gaugeValue===0&&maxValue===0){maxValue=1;maxLabel=0;}
const config={type:"doughnut",data:{datasets:[{data:[gaugeValue,maxValue-gaugeValue],backgroundColor:["#1f77b4","#dddddd"],label:this.title,},],},options:{circumference:180,rotation:270,responsive:true,maintainAspectRatio:false,cutout:"70%",layout:{padding:5,},plugins:{title:{display:true,text:this.title,padding:4,},tooltip:{displayColors:false,callbacks:{label:function(tooltipItem){if(tooltipItem.dataIndex===0){return _t("Value: %(value)s",{value:gaugeValue});}
return _t("Max: %(max)s",{max:maxLabel});},},},},aspectRatio:2,},};this.chart=new Chart(this.canvasRef.el,config);}}
const gaugeField=__exports.gaugeField={component:GaugeField,supportedOptions:[{label:_t("Title"),name:"title",type:"string",},{label:_t("Max value field"),name:"max_value_field",type:"field",availableTypes:["integer","float"],},{label:_t("Max value"),name:"max_value",type:"string",},],extractProps:({options})=>({maxValueField:options.max_field,maxValue:options.max_value,title:options.title,}),};registry.category("fields").add("gauge",gaugeField);return __exports;});;

/* /web/static/src/views/fields/google_slide_viewer/google_slide_viewer.js */
odoo.define('@web/views/fields/google_slide_viewer/google_slide_viewer',['@odoo/owl','@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/views/fields/char/char_field'],function(require){'use strict';let __exports={};const{useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{CharField,charField}=require("@web/views/fields/char/char_field");__exports.getGoogleSlideUrl=getGoogleSlideUrl;function getGoogleSlideUrl(value,page){let url=false;const googleRegExp=/(^https:\/\/docs.google.com).*(\/d\/e\/|\/d\/)([A-Za-z0-9-_]+)/;const google=value.match(googleRegExp);if(google&&google[3]){url=`https://docs.google.com/presentation${google[2]}${google[3]}/preview?slide=${page}`;}
return url;}
const GoogleSlideViewer=__exports.GoogleSlideViewer=class GoogleSlideViewer extends CharField{static template="web.GoogleSlideViewer";setup(){super.setup();this.notification=useService("notification");this.page=1;this.state=useState({isValid:true,});}
get fileName(){return this.state.fileName||this.props.record.data[this.props.name]||"";}
_get_slide_page(){return this.props.record.data[this.props.name+"_page"]?this.props.record.data[this.props.name+"_page"]:this.page;}
get url(){let url=this.props.value;if(this.props.record.data[this.props.name]){url=getGoogleSlideUrl(this.props.record.data[this.props.name],this._get_slide_page());}
return url;}
onLoadFailed(){this.state.isValid=false;this.notification.add(_t("Could not display the selected spreadsheet"),{type:"danger"});}}
const googleSlideViewer=__exports.googleSlideViewer={...charField,component:GoogleSlideViewer,displayName:_t("Google Slide Viewer"),};registry.category("fields").add("embed_viewer",googleSlideViewer);return __exports;});;

/* /web/static/src/views/fields/handle/handle_field.js */
odoo.define('@web/views/fields/handle/handle_field',['@web/core/registry','@web/core/l10n/translation','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const HandleField=__exports.HandleField=class HandleField extends Component{static template="web.HandleField";static props={...standardFieldProps,};}
const handleField=__exports.handleField={component:HandleField,displayName:_t("Handle"),supportedTypes:["integer"],isEmpty:()=>false,listViewWidth:20,};registry.category("fields").add("handle",handleField);return __exports;});;

/* /web/static/src/views/fields/html/html_field.js */
odoo.define('@web/views/fields/html/html_field',['@web/core/registry','@web/views/fields/text/text_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{TextField,textField}=require("@web/views/fields/text/text_field");const HtmlField=__exports.HtmlField=class HtmlField extends TextField{static template="web.HtmlField";}
const htmlField=__exports.htmlField={...textField,component:HtmlField,};registry.category("fields").add("html",htmlField);return __exports;});;

/* /web/static/src/views/fields/iframe_wrapper/iframe_wrapper_field.js */
odoo.define('@web/views/fields/iframe_wrapper/iframe_wrapper_field',['@web/core/registry','@web/core/l10n/translation','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component,useEffect,useRef}=require("@odoo/owl");const IframeWrapperField=__exports.IframeWrapperField=class IframeWrapperField extends Component{static template="web.IframeWrapperField";static props={...standardFieldProps,};setup(){this.iframeRef=useRef("iframe");useEffect((value)=>{const iframeDoc=this.iframeRef.el.contentDocument;iframeDoc.open();iframeDoc.write(value);iframeDoc.close();},()=>[this.props.record.data[this.props.name]]);}}
const iframeWrapperField=__exports.iframeWrapperField={component:IframeWrapperField,displayName:_t("Wrap raw html within an iframe"),supportedTypes:["text","html"],};registry.category("fields").add("iframe_wrapper",iframeWrapperField);return __exports;});;

/* /web/static/src/views/fields/image/image_field.js */
odoo.define('@web/views/fields/image/image_field',['@web/core/browser/feature_detection','@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/core/utils/urls','@web/core/utils/binary','@web/views/fields/file_handler','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{isMobileOS}=require("@web/core/browser/feature_detection");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{imageUrl}=require("@web/core/utils/urls");const{isBinarySize}=require("@web/core/utils/binary");const{FileUploader}=require("@web/views/fields/file_handler");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component,useState,onWillRender}=require("@odoo/owl");const{DateTime}=luxon;const fileTypeMagicWordMap=__exports.fileTypeMagicWordMap={"/":"jpg",R:"gif",i:"png",P:"svg+xml",U:"webp",};const placeholder="/web/static/img/placeholder.png";const ImageField=__exports.ImageField=class ImageField extends Component{static template="web.ImageField";static components={FileUploader,};static props={...standardFieldProps,alt:{type:String,optional:true},enableZoom:{type:Boolean,optional:true},imgClass:{type:String,optional:true},zoomDelay:{type:Number,optional:true},previewImage:{type:String,optional:true},acceptedFileExtensions:{type:String,optional:true},width:{type:Number,optional:true},height:{type:Number,optional:true},reload:{type:Boolean,optional:true},convertToWebp:{type:Boolean,optional:true},};static defaultProps={acceptedFileExtensions:"image/*",alt:_t("Binary file"),imgClass:"",reload:true,};setup(){this.notification=useService("notification");this.orm=useService("orm");this.isMobile=isMobileOS();this.state=useState({isValid:true,});this.lastURL=undefined;if(this.fieldType==="many2one"&&!this.props.previewImage){throw new Error("ImageField: previewImage must be provided when set on a many2one field");}
const field=this.props.record.fields[this.props.name];if(field.related?.includes(".")){this.lastUpdate=DateTime.now();let key=this.props.value;onWillRender(()=>{const nextKey=this.props.value;if(key!==nextKey){this.lastUpdate=DateTime.now();}
key=nextKey;});}}
get imgAlt(){if(this.fieldType==="many2one"&&this.props.record.data[this.props.name]){return this.props.record.data[this.props.name][1];}
return this.props.alt;}
get imgClass(){return["img","img-fluid"].concat(this.props.imgClass.split(" ")).join(" ");}
get fieldType(){return this.props.record.fields[this.props.name].type;}
get rawCacheKey(){return this.lastUpdate||this.props.record.data.write_date;}
get sizeStyle(){let style="";if(this.props.width){style+=`max-width: ${this.props.width}px;`;if(!this.props.height){style+=`height: auto; max-height: 100%;`;}}
if(this.props.height){style+=`max-height: ${this.props.height}px;`;if(!this.props.width){style+=`width: auto; max-width: 100%;`;}}
return style;}
get hasTooltip(){return this.props.enableZoom&&this.props.record.data[this.props.name];}
get tooltipAttributes(){const fieldName=this.fieldType==="many2one"?this.props.previewImage:this.props.name;return{template:"web.ImageZoomTooltip",info:JSON.stringify({url:this.getUrl(fieldName)}),};}
getUrl(imageFieldName){if(!this.props.reload&&this.lastURL){return this.lastURL;}
if(!this.props.record.data[this.props.name]||!this.state.isValid){return placeholder;}
if(this.fieldType==="many2one"){this.lastURL=imageUrl(this.props.record.fields[this.props.name].relation,this.props.record.data[this.props.name][0],imageFieldName,{unique:this.rawCacheKey});}else if(isBinarySize(this.props.record.data[this.props.name])){this.lastURL=imageUrl(this.props.record.resModel,this.props.record.resId,imageFieldName,{unique:this.rawCacheKey});}else{const magic=fileTypeMagicWordMap[this.props.record.data[this.props.name][0]]||"png";this.lastURL=`data:image/${magic};base64,${this.props.record.data[this.props.name]}`;}
return this.lastURL;}
onFileRemove(){this.state.isValid=true;this.props.record.update({[this.props.name]:false});}
async onFileUploaded(info){this.state.isValid=true;if(this.props.convertToWebp&&!["image/gif","image/svg+xml","image/webp"].includes(info.type)){const image=document.createElement("img");image.src=`data:${info.type};base64,${info.data}`;await new Promise((resolve)=>image.addEventListener("load",resolve));const canvas=document.createElement("canvas");canvas.width=image.width;canvas.height=image.height;const ctx=canvas.getContext("2d");ctx.drawImage(image,0,0);info.data=canvas.toDataURL("image/webp",0.75).split(",")[1];info.type="image/webp";info.name=info.name.replace(/\.[^/.]+$/,".webp");}
if(info.type==="image/webp"){const image=document.createElement("img");image.src=`data:image/webp;base64,${info.data}`;await new Promise((resolve)=>image.addEventListener("load",resolve));const originalSize=Math.max(image.width,image.height);const smallerSizes=[1024,512,256,128].filter((size)=>size<originalSize);let referenceId=undefined;for(const size of[originalSize,...smallerSizes]){const ratio=size/originalSize;const canvas=document.createElement("canvas");canvas.width=image.width*ratio;canvas.height=image.height*ratio;const ctx=canvas.getContext("2d");ctx.fillStyle="transparent";ctx.fillRect(0,0,canvas.width,canvas.height);ctx.imageSmoothingEnabled=true;ctx.imageSmoothingQuality="high";ctx.drawImage(image,0,0,image.width,image.height,0,0,canvas.width,canvas.height);const[resizedId]=await this.orm.call("ir.attachment","create_unique",[[{name:info.name,description:size===originalSize?"":`resize: ${size}`,datas:size===originalSize?info.data:canvas.toDataURL("image/webp",0.75).split(",")[1],res_id:referenceId,res_model:"ir.attachment",mimetype:"image/webp",},],]);referenceId=referenceId||resizedId;await this.orm.call("ir.attachment","create_unique",[[{name:info.name.replace(/\.webp$/,".jpg"),description:"format: jpeg",datas:canvas.toDataURL("image/jpeg",0.75).split(",")[1],res_id:resizedId,res_model:"ir.attachment",mimetype:"image/jpeg",},],]);}}
this.props.record.update({[this.props.name]:info.data});}
onLoadFailed(){this.state.isValid=false;}}
const imageField=__exports.imageField={component:ImageField,displayName:_t("Image"),supportedAttributes:[{label:_t("Alternative text"),name:"alt",type:"string",},],supportedOptions:[{label:_t("Reload"),name:"reload",type:"boolean",default:true,},{label:_t("Enable zoom"),name:"zoom",type:"boolean",},{label:_t("Convert to webp"),name:"convert_to_webp",type:"boolean",},{label:_t("Zoom delay"),name:"zoom_delay",type:"number",help:_t("Delay the apparition of the zoomed image with a value in milliseconds"),},{label:_t("Accepted file extensions"),name:"accepted_file_extensions",type:"string",},{label:_t("Size"),name:"size",type:"selection",choices:[{label:_t("Small"),value:"[0,90]"},{label:_t("Medium"),value:"[0,180]"},{label:_t("Large"),value:"[0,270]"},],},{label:_t("Preview image"),name:"preview_image",type:"field",availableTypes:["binary"],},],supportedTypes:["binary","many2one"],fieldDependencies:[{name:"write_date",type:"datetime"}],isEmpty:()=>false,extractProps:({attrs,options})=>({alt:attrs.alt,enableZoom:options.zoom,convertToWebp:options.convert_to_webp,imgClass:options.img_class,zoomDelay:options.zoom_delay,previewImage:options.preview_image,acceptedFileExtensions:options.accepted_file_extensions,width:options.size&&Boolean(options.size[0])?options.size[0]:attrs.width,height:options.size&&Boolean(options.size[1])?options.size[1]:attrs.height,reload:"reload"in options?Boolean(options.reload):true,}),};registry.category("fields").add("image",imageField);return __exports;});;

/* /web/static/src/views/fields/image_url/image_url_field.js */
odoo.define('@web/views/fields/image_url/image_url_field',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/views/fields/standard_field_props','@odoo/owl','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component,useState}=require("@odoo/owl");const{useRecordObserver}=require("@web/model/relational_model/utils");const ImageUrlField=__exports.ImageUrlField=class ImageUrlField extends Component{static template="web.ImageUrlField";static props={...standardFieldProps,width:{type:Number,optional:true},height:{type:Number,optional:true},};static fallbackSrc="/web/static/img/placeholder.png";setup(){this.notification=useService("notification");this.state=useState({src:this.props.record.data[this.props.name],});useRecordObserver((record)=>{this.state.src=record.data[this.props.name];});}
get sizeStyle(){let style="";if(this.props.width){style+=`max-width: ${this.props.width}px;`;}
if(this.props.height){style+=`max-height: ${this.props.height}px;`;}
return style;}
onLoadFailed(){this.state.src=this.constructor.fallbackSrc;}}
const imageUrlField=__exports.imageUrlField={component:ImageUrlField,displayName:_t("Image"),supportedOptions:[{label:_t("Size"),name:"size",type:"selection",choices:[{label:_t("Small"),value:"[0,90]"},{label:_t("Medium"),value:"[0,180]"},{label:_t("Large"),value:"[0,270]"},],},],supportedTypes:["char"],extractProps:({attrs,options})=>({width:options.size?options.size[0]:attrs.width,height:options.size?options.size[1]:attrs.height,}),};registry.category("fields").add("image_url",imageUrlField);return __exports;});;

/* /web/static/src/views/fields/input_field_hook.js */
odoo.define('@web/views/fields/input_field_hook',['@web/core/hotkeys/hotkey_service','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const{useBus}=require("@web/core/utils/hooks");const{useComponent,useEffect,useRef}=require("@odoo/owl");__exports.useInputField=useInputField;function useInputField(params){const inputRef=params.ref||useRef(params.refName||"input");const component=useComponent();let isDirty=false;let lastSetValue=null;let pendingUpdate=false;function onInput(ev){isDirty=ev.target.value!==lastSetValue;if(params.preventLineBreaks&&ev.inputType==="insertFromPaste"){ev.target.value=ev.target.value.replace(/[\r\n]+/g," ");}
component.props.record.model.bus.trigger("FIELD_IS_DIRTY",isDirty);if(!component.props.record.isValid){component.props.record.resetFieldValidity(component.props.name);}}
async function onChange(ev){if(isDirty){isDirty=false;let isInvalid=false;let val=ev.target.value;if(params.parse){try{val=params.parse(val);}catch{component.props.record.setInvalidField(component.props.name);isInvalid=true;}}
if(!isInvalid){if(val!==component.props.record.data[component.props.name]){lastSetValue=inputRef.el.value;pendingUpdate=true;await component.props.record.update({[component.props.name]:val});pendingUpdate=false;component.props.record.model.bus.trigger("FIELD_IS_DIRTY",isDirty);}else{inputRef.el.value=params.getValue();}}}}
function onKeydown(ev){const hotkey=getActiveHotkey(ev);if(["enter","tab","shift+tab"].includes(hotkey)){commitChanges(false);}
if(params.preventLineBreaks&&["enter","shift+enter"].includes(hotkey)){ev.preventDefault();}}
useEffect((inputEl)=>{if(inputEl){inputEl.addEventListener("input",onInput);inputEl.addEventListener("change",onChange);inputEl.addEventListener("keydown",onKeydown);return()=>{inputEl.removeEventListener("input",onInput);inputEl.removeEventListener("change",onChange);inputEl.removeEventListener("keydown",onKeydown);};}},()=>[inputRef.el]);useEffect(()=>{const value=params.getValue();if(inputRef.el&&!isDirty&&!component.props.record.isFieldInvalid(component.props.name)){inputRef.el.value=value;lastSetValue=inputRef.el.value;}});const{model}=component.props.record;useBus(model.bus,"WILL_SAVE_URGENTLY",()=>commitChanges(true));useBus(model.bus,"NEED_LOCAL_CHANGES",(ev)=>ev.detail.proms.push(commitChanges()));async function commitChanges(urgent){if(!inputRef.el){return;}
isDirty=inputRef.el.value!==lastSetValue;if(isDirty||(urgent&&pendingUpdate)){let isInvalid=false;isDirty=false;let val=inputRef.el.value;if(params.parse){try{val=params.parse(val);}catch{isInvalid=true;if(urgent){return;}else{component.props.record.setInvalidField(component.props.name);}}}
if(isInvalid){return;}
if((val||false)!==(component.props.record.data[component.props.name]||false)){lastSetValue=inputRef.el.value;await component.props.record.update({[component.props.name]:val});component.props.record.model.bus.trigger("FIELD_IS_DIRTY",false);}else{inputRef.el.value=params.getValue();}}}
return inputRef;}
return __exports;});;

/* /web/static/src/views/fields/integer/integer_field.js */
odoo.define('@web/views/fields/integer/integer_field',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/formatters','@web/views/fields/parsers','@web/views/fields/input_field_hook','@web/views/fields/standard_field_props','@web/views/fields/numpad_decimal_hook','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{formatInteger}=require("@web/views/fields/formatters");const{parseInteger}=require("@web/views/fields/parsers");const{useInputField}=require("@web/views/fields/input_field_hook");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{useNumpadDecimal}=require("@web/views/fields/numpad_decimal_hook");const{Component,useState}=require("@odoo/owl");const IntegerField=__exports.IntegerField=class IntegerField extends Component{static template="web.IntegerField";static props={...standardFieldProps,formatNumber:{type:Boolean,optional:true},humanReadable:{type:Boolean,optional:true},decimals:{type:Number,optional:true},inputType:{type:String,optional:true},step:{type:Number,optional:true},placeholder:{type:String,optional:true},};static defaultProps={formatNumber:true,humanReadable:false,inputType:"text",decimals:0,};setup(){this.state=useState({hasFocus:false,});useInputField({getValue:()=>this.formattedValue,refName:"numpadDecimal",parse:(v)=>parseInteger(v),});useNumpadDecimal();}
onFocusIn(){this.state.hasFocus=true;}
onFocusOut(){this.state.hasFocus=false;}
get formattedValue(){if(!this.props.formatNumber||(!this.props.readonly&&this.props.inputType==="number")){return this.value;}
if(this.props.humanReadable&&!this.state.hasFocus){return formatInteger(this.value,{humanReadable:true,decimals:this.props.decimals,});}else{return formatInteger(this.value,{humanReadable:false});}}
get value(){return this.props.record.data[this.props.name];}}
const integerField=__exports.integerField={component:IntegerField,displayName:_t("Integer"),supportedOptions:[{label:_t("Format number"),name:"enable_formatting",type:"boolean",help:_t("Format the value according to your language setup - e.g. thousand separators, rounding, etc."),default:true,},{label:_t("Type"),name:"type",type:"string",},{label:_t("Step"),name:"step",type:"number",},{label:_t("User-friendly format"),name:"human_readable",type:"boolean",help:_t("Use a human readable format (e.g.: 500G instead of 500,000,000,000)."),},{label:_t("Decimals"),name:"decimals",type:"number",default:0,help:_t("Use it with the 'User-friendly format' option to customize the formatting."),},],supportedTypes:["integer"],isEmpty:(record,fieldName)=>record.data[fieldName]===false,extractProps:({attrs,options})=>({formatNumber:options?.enable_formatting!==undefined?Boolean(options.enable_formatting):true,humanReadable:!!options.human_readable,inputType:options.type,step:options.step,placeholder:attrs.placeholder,decimals:options.decimals||0,}),};registry.category("fields").add("integer",integerField);return __exports;});;

/* /web/static/src/views/fields/journal_dashboard_graph/journal_dashboard_graph_field.js */
odoo.define('@web/views/fields/journal_dashboard_graph/journal_dashboard_graph_field',['@web/core/assets','@web/core/registry','@web/core/colors/colors','@web/views/fields/standard_field_props','@odoo/owl','@web/core/browser/cookie'],function(require){'use strict';let __exports={};const{loadBundle}=require("@web/core/assets");const{registry}=require("@web/core/registry");const{getColor,hexToRGBA,getCustomColor}=require("@web/core/colors/colors");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component,onWillStart,useEffect,useRef}=require("@odoo/owl");const{cookie}=require("@web/core/browser/cookie");const colorScheme=cookie.get("color_scheme");const GRAPH_GRID_COLOR=getCustomColor(colorScheme,"#d8dadd","#3C3E4B");const GRAPH_LABEL_COLOR=getCustomColor(colorScheme,"#111827","#E4E4E4");const JournalDashboardGraphField=__exports.JournalDashboardGraphField=class JournalDashboardGraphField extends Component{static template="web.JournalDashboardGraphField";static props={...standardFieldProps,graphType:String,};setup(){this.chart=null;this.canvasRef=useRef("canvas");this.data=JSON.parse(this.props.record.data[this.props.name]);onWillStart(async()=>await loadBundle("web.chartjs_lib"));useEffect(()=>{this.renderChart();return()=>{if(this.chart){this.chart.destroy();}};});}
renderChart(){if(this.chart){this.chart.destroy();}
let config;if(this.props.graphType==="line"){config=this.getLineChartConfig();}else if(this.props.graphType==="bar"){config=this.getBarChartConfig();}
this.chart=new Chart(this.canvasRef.el,config);}
getLineChartConfig(){const labels=this.data[0].values.map(function(pt){return pt.x;});const color10=getColor(3,cookie.get("color_scheme"),"odoo");const borderColor=this.data[0].is_sample_data?hexToRGBA(color10,0.1):color10;const backgroundColor=this.data[0].is_sample_data?hexToRGBA(color10,0.05):hexToRGBA(color10,0.2);return{type:"line",data:{labels,datasets:[{backgroundColor,borderColor,data:this.data[0].values,fill:"start",label:this.data[0].key,borderWidth:2,},],},options:{plugins:{legend:{display:false},tooltip:{enabled:!this.data[0].is_sample_data,intersect:false,position:"nearest",caretSize:0,},},scales:{y:{display:false,},x:{display:false,},},maintainAspectRatio:false,elements:{line:{tension:0.000001,},},},};}
getBarChartConfig(){const data=[];const labels=[];const backgroundColor=[];const color13=getColor(2,cookie.get("color_scheme"),"odoo");const color19=getColor(1,cookie.get("color_scheme"),"odoo");this.data[0].values.forEach((pt)=>{data.push(pt.value);labels.push(pt.label);if(pt.type==="past"){backgroundColor.push(color13);}else if(pt.type==="future"){backgroundColor.push(color19);}else{backgroundColor.push(getCustomColor(colorScheme,"#ebebeb","#3C3E4B"));}});return{type:"bar",data:{labels,datasets:[{backgroundColor,data,fill:"start",label:this.data[0].key,},],},options:{plugins:{legend:{display:false},tooltip:{enabled:!this.data[0].is_sample_data,intersect:false,position:"nearest",caretSize:0,},},scales:{y:{display:false,},x:{grid:{color:GRAPH_GRID_COLOR,},ticks:{color:GRAPH_LABEL_COLOR,},border:{color:GRAPH_GRID_COLOR,},},},maintainAspectRatio:false,elements:{line:{tension:0.000001,},},},};}}
const journalDashboardGraphField=__exports.journalDashboardGraphField={component:JournalDashboardGraphField,supportedTypes:["text"],extractProps:({attrs})=>({graphType:attrs.graph_type,}),};registry.category("fields").add("dashboard_graph",journalDashboardGraphField);return __exports;});;

/* /web/static/src/views/fields/jsonb/jsonb.js */
odoo.define('@web/views/fields/jsonb/jsonb',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const JsonField=__exports.JsonField=class JsonField extends Component{static template="web.JsonbField";static props={...standardFieldProps,};get formattedValue(){const value=this.props.record.data[this.props.name];return value?JSON.stringify(value):"";}}
const jsonField=__exports.jsonField={component:JsonField,displayName:_t("Json"),supportedTypes:["jsonb"],};registry.category("fields").add("jsonb",jsonField);return __exports;});;

/* /web/static/src/views/fields/kanban_color_picker/kanban_color_picker_field.js */
odoo.define('@web/views/fields/kanban_color_picker/kanban_color_picker_field',['@web/core/l10n/translation','@web/core/colorlist/colorlist','@web/core/registry','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ColorList}=require("@web/core/colorlist/colorlist");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");class KanbanColorPickerField extends Component{static template="web.KanbanColorPickerField";static props=standardFieldProps;get colors(){return ColorList.COLORS;}
selectColor(colorIndex){return this.props.record.update({[this.props.name]:colorIndex},{save:true});}}
const kanbanColorPickerField=__exports.kanbanColorPickerField={component:KanbanColorPickerField,displayName:_t("Color Picker"),extractProps(fieldInfo,dynamicInfo){return{readonly:dynamicInfo.readonly,};},};registry.category("fields").add("kanban_color_picker",kanbanColorPickerField);return __exports;});;

/* /web/static/src/views/fields/label_selection/label_selection_field.js */
odoo.define('@web/views/fields/label_selection/label_selection_field',['@web/core/registry','@web/core/l10n/translation','@web/views/fields/standard_field_props','@web/views/fields/formatters','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{formatSelection}=require("@web/views/fields/formatters");const{Component}=require("@odoo/owl");const LabelSelectionField=__exports.LabelSelectionField=class LabelSelectionField extends Component{static template="web.LabelSelectionField";static props={...standardFieldProps,classesObj:{type:Object,optional:true},};static defaultProps={classesObj:{},};get className(){return this.props.classesObj[this.props.record.data[this.props.name]]||"primary";}
get string(){return formatSelection(this.props.record.data[this.props.name],{selection:Array.from(this.props.record.fields[this.props.name].selection),});}}
const labelSelectionField=__exports.labelSelectionField={component:LabelSelectionField,displayName:_t("Label Selection"),supportedOptions:[{label:_t("Classes"),name:"classes",type:"string",},],supportedTypes:["selection"],extractProps:({options})=>({classesObj:options.classes,}),};registry.category("fields").add("label_selection",labelSelectionField);return __exports;});;

/* /web/static/src/views/fields/many2many_binary/many2many_binary_field.js */
odoo.define('@web/views/fields/many2many_binary/many2many_binary_field',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/views/fields/standard_field_props','@web/core/file_input/file_input','@web/views/fields/relational_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{FileInput}=require("@web/core/file_input/file_input");const{useX2ManyCrud}=require("@web/views/fields/relational_utils");const{Component}=require("@odoo/owl");const Many2ManyBinaryField=__exports.Many2ManyBinaryField=class Many2ManyBinaryField extends Component{static template="web.Many2ManyBinaryField";static components={FileInput,};static props={...standardFieldProps,acceptedFileExtensions:{type:String,optional:true},className:{type:String,optional:true},numberOfFiles:{type:Number,optional:true},};setup(){this.orm=useService("orm");this.notification=useService("notification");this.operations=useX2ManyCrud(()=>this.props.record.data[this.props.name],true);}
get uploadText(){return this.props.record.fields[this.props.name].string;}
get files(){return this.props.record.data[this.props.name].records.map((record)=>{return{...record.data,id:record.resId,};});}
getUrl(id){return"/web/content/"+id+"?download=true";}
getExtension(file){return file.name.replace(/^.*\./,"");}
async onFileUploaded(files){for(const file of files){if(file.error){return this.notification.add(file.error,{title:_t("Uploading error"),type:"danger",});}
await this.operations.saveRecord([file.id]);}}
async onFileRemove(deleteId){const record=this.props.record.data[this.props.name].records.find((record)=>record.resId===deleteId);this.operations.removeRecord(record);}}
const many2ManyBinaryField=__exports.many2ManyBinaryField={component:Many2ManyBinaryField,supportedOptions:[{label:_t("Accepted file extensions"),name:"accepted_file_extensions",type:"string",},{label:_t("Number of files"),name:"number_of_files",type:"integer",},],supportedTypes:["many2many"],isEmpty:()=>false,relatedFields:[{name:"name",type:"char"},{name:"mimetype",type:"char"},],extractProps:({attrs,options})=>({acceptedFileExtensions:options.accepted_file_extensions,className:attrs.class,numberOfFiles:options.number_of_files,}),};registry.category("fields").add("many2many_binary",many2ManyBinaryField);return __exports;});;

/* /web/static/src/views/fields/many2many_checkboxes/many2many_checkboxes_field.js */
odoo.define('@web/views/fields/many2many_checkboxes/many2many_checkboxes_field',['@odoo/owl','@web/core/checkbox/checkbox','@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/core/utils/timing','@web/model/relational_model/utils','@web/views/fields/relational_utils','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{Component,onWillUnmount}=require("@odoo/owl");const{CheckBox}=require("@web/core/checkbox/checkbox");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useBus}=require("@web/core/utils/hooks");const{debounce}=require("@web/core/utils/timing");const{getFieldDomain}=require("@web/model/relational_model/utils");const{useSpecialData}=require("@web/views/fields/relational_utils");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const Many2ManyCheckboxesField=__exports.Many2ManyCheckboxesField=class Many2ManyCheckboxesField extends Component{static template="web.Many2ManyCheckboxesField";static components={CheckBox};static props={...standardFieldProps,domain:{type:[Array,Function],optional:true},};setup(){this.specialData=useSpecialData((orm,props)=>{const{relation}=props.record.fields[props.name];const domain=getFieldDomain(props.record,props.name,props.domain);return orm.call(relation,"name_search",["",domain]);});this.idsToAdd=new Set();this.idsToRemove=new Set();this.debouncedCommitChanges=debounce(this.commitChanges.bind(this),500);useBus(this.props.record.model.bus,"NEED_LOCAL_CHANGES",this.commitChanges.bind(this));onWillUnmount(this.commitChanges.bind(this));}
get items(){return this.specialData.data;}
isSelected(item){return this.props.record.data[this.props.name].currentIds.includes(item[0]);}
commitChanges(){if(this.idsToAdd.size===0&&this.idsToRemove.size===0){return;}
const result=this.props.record.data[this.props.name].addAndRemove({add:[...this.idsToAdd],remove:[...this.idsToRemove],});this.idsToAdd.clear();this.idsToRemove.clear();return result;}
onChange(resId,checked){if(checked){if(this.idsToRemove.has(resId)){this.idsToRemove.delete(resId);}else{this.idsToAdd.add(resId);}}else{if(this.idsToAdd.has(resId)){this.idsToAdd.delete(resId);}else{this.idsToRemove.add(resId);}}
this.debouncedCommitChanges();}}
const many2ManyCheckboxesField=__exports.many2ManyCheckboxesField={component:Many2ManyCheckboxesField,displayName:_t("Checkboxes"),supportedTypes:["many2many"],isEmpty:()=>false,extractProps(fieldInfo,dynamicInfo){return{domain:dynamicInfo.domain,};},};registry.category("fields").add("many2many_checkboxes",many2ManyCheckboxesField);return __exports;});;

/* /web/static/src/views/fields/many2many_tags/kanban_many2many_tags_field.js */
odoo.define('@web/views/fields/many2many_tags/kanban_many2many_tags_field',['@web/core/registry','@web/views/fields/many2many_tags/many2many_tags_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Many2ManyTagsField,many2ManyTagsField}=require("@web/views/fields/many2many_tags/many2many_tags_field");const KanbanMany2ManyTagsField=__exports.KanbanMany2ManyTagsField=class KanbanMany2ManyTagsField extends Many2ManyTagsField{static template="web.KanbanMany2ManyTagsField";get tags(){return super.tags.reduce((kanbanTags,tag)=>{if(tag.colorIndex!==0){delete tag.onClick;kanbanTags.push(tag);}
return kanbanTags;},[]);}}
const kanbanMany2ManyTagsField=__exports.kanbanMany2ManyTagsField={...many2ManyTagsField,component:KanbanMany2ManyTagsField,};registry.category("fields").add("kanban.many2many_tags",kanbanMany2ManyTagsField);return __exports;});;

/* /web/static/src/views/fields/many2many_tags/many2many_tags_field.js */
odoo.define('@web/views/fields/many2many_tags/many2many_tags_field',['@web/core/l10n/translation','@web/core/checkbox/checkbox','@web/core/colorlist/colorlist','@web/core/domain','@web/core/py_js/py','@web/views/fields/relational_utils','@web/core/registry','@web/core/utils/concurrency','@web/views/fields/standard_field_props','@web/core/tags_list/tags_list','@web/core/popover/popover_hook','@web/core/utils/hooks','@web/core/record_selectors/tag_navigation_hook','@odoo/owl','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{CheckBox}=require("@web/core/checkbox/checkbox");const{ColorList}=require("@web/core/colorlist/colorlist");const{Domain}=require("@web/core/domain");const{evaluateBooleanExpr}=require("@web/core/py_js/py");const{Many2XAutocomplete,useActiveActions,useX2ManyCrud,useOpenMany2XRecord,}=require("@web/views/fields/relational_utils");const{registry}=require("@web/core/registry");const{Mutex}=require("@web/core/utils/concurrency");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{TagsList}=require("@web/core/tags_list/tags_list");const{usePopover}=require("@web/core/popover/popover_hook");const{useService}=require("@web/core/utils/hooks");const{useTagNavigation}=require("@web/core/record_selectors/tag_navigation_hook");const{Component,useRef}=require("@odoo/owl");const{getFieldDomain}=require("@web/model/relational_model/utils");class Many2ManyTagsFieldColorListPopover extends Component{static template="web.Many2ManyTagsFieldColorListPopover";static components={CheckBox,ColorList,};static props={colors:Array,tag:Object,switchTagColor:Function,onTagVisibilityChange:Function,close:Function,};}
const Many2ManyTagsField=__exports.Many2ManyTagsField=class Many2ManyTagsField extends Component{static template="web.Many2ManyTagsField";static components={TagsList,Many2XAutocomplete,};static props={...standardFieldProps,canCreate:{type:Boolean,optional:true},canQuickCreate:{type:Boolean,optional:true},canCreateEdit:{type:Boolean,optional:true},colorField:{type:String,optional:true},createDomain:{type:[Array,Boolean],optional:true},domain:{type:[Array,Function],optional:true},context:{type:Object,optional:true},placeholder:{type:String,optional:true},nameCreateField:{type:String,optional:true},string:{type:String,optional:true},noSearchMore:{type:Boolean,optional:true},};static defaultProps={canCreate:true,canQuickCreate:true,canCreateEdit:true,nameCreateField:"name",context:{},};static RECORD_COLORS=[1,2,3,4,5,6,7,8,9,10,11];static SEARCH_MORE_LIMIT=320;setup(){this.orm=useService("orm");this.previousColorsMap={};this.popover=usePopover(this.constructor.components.Popover);this.dialog=useService("dialog");this.dialogClose=[];this.onTagKeydown=useTagNavigation("many2ManyTagsField",this.deleteTagByIndex.bind(this));this.autoCompleteRef=useRef("autoComplete");this.mutex=new Mutex();const{saveRecord,removeRecord}=useX2ManyCrud(()=>this.props.record.data[this.props.name],true);this.activeActions=useActiveActions({fieldType:"many2many",crudOptions:{create:this.props.canCreate&&this.props.createDomain,createEdit:this.props.canCreateEdit,onDelete:removeRecord,edit:this.props.record.isInEdition,},getEvalParams:(props)=>{return{evalContext:this.evalContext,readonly:props.readonly,};},});this.openMany2xRecord=useOpenMany2XRecord({resModel:this.relation,activeActions:{create:false,write:true,},onRecordSaved:async(record)=>{await this.props.record.data[this.props.name].forget(record);return saveRecord([record.resId]);},});this.update=(recordlist)=>{recordlist=recordlist?recordlist.filter((element)=>{return!this.tags.some((record)=>record.resId===element.id);}):[];if(!recordlist.length){return;}
const resIds=recordlist.map((rec)=>rec.id);return saveRecord(resIds);};if(this.props.canQuickCreate){this.quickCreate=async(name)=>{const created=await this.orm.call(this.relation,"name_create",[name],{context:this.props.context,});return saveRecord([created[0]]);};}}
get relation(){return this.props.record.fields[this.props.name].relation;}
get evalContext(){return this.props.record.evalContext;}
get string(){return this.props.string||this.props.record.fields[this.props.name].string||"";}
getTagProps(record){return{id:record.id,resId:record.resId,text:record.data.display_name,colorIndex:record.data[this.props.colorField],canEdit:this.props.canEditTags,onDelete:!this.props.readonly?()=>this.deleteTag(record.id):undefined,onKeydown:(ev)=>{if(this.props.readonly){return;}
this.onTagKeydown(ev);},};}
get tags(){return this.props.record.data[this.props.name].records.map((record)=>this.getTagProps(record));}
get showM2OSelectionField(){return!this.props.readonly;}
async deleteTagByIndex(index){this.mutex.exec(()=>{if(this.tags[index]){return this.deleteTag(this.tags[index].id);}});}
async deleteTag(id){const tagRecord=this.props.record.data[this.props.name].records.find((record)=>record.id===id);await this.props.record.data[this.props.name].forget(tagRecord);}
getDomain(){return Domain.and([getFieldDomain(this.props.record,this.props.name,this.props.domain),]).toList(this.props.context);}
getOptionClassnames(record){const records=this.props.record.data[this.props.name].records;const isSelected=records.some((r)=>r.resId===record.id);return isSelected?"dropdown-item-selected":"";}}
const many2ManyTagsField=__exports.many2ManyTagsField={component:Many2ManyTagsField,displayName:_t("Tags"),supportedOptions:[{label:_t("Disable creation"),name:"no_create",type:"boolean",help:_t("If checked, users won't be able to create records through the autocomplete dropdown at all."),},{label:_t("Disable 'Create' option"),name:"no_quick_create",type:"boolean",help:_t("If checked, users will not be able to create records based on the text input; they will still be able to create records via a popup form."),},{label:_t("Disable 'Create and Edit' option"),name:"no_create_edit",type:"boolean",help:_t("If checked, users will not be able to create records based through a popup form; they will still be able to create records based on the text input."),},{label:_t("Can create"),name:"create",type:"string",help:_t("Write a domain to allow the creation of records conditionnally."),},{label:_t("Color field"),name:"color_field",type:"field",availableTypes:["integer"],help:_t("Set an integer field to use colors with the tags."),},],supportedTypes:["many2many"],relatedFields:({options})=>{const relatedFields=[{name:"display_name",type:"char"}];if(options.color_field){relatedFields.push({name:options.color_field,type:"integer",readonly:false});}
return relatedFields;},extractProps({attrs,options,string},dynamicInfo){const hasCreatePermission=attrs.can_create?evaluateBooleanExpr(attrs.can_create):true;const noCreate=Boolean(options.no_create);const canCreate=noCreate?false:hasCreatePermission;const noQuickCreate=Boolean(options.no_quick_create);const noCreateEdit=Boolean(options.no_create_edit);return{colorField:options.color_field,nameCreateField:options.create_name_field,canCreate,canQuickCreate:canCreate&&!noQuickCreate,canCreateEdit:canCreate&&!noCreateEdit,createDomain:options.create,context:dynamicInfo.context,domain:dynamicInfo.domain,placeholder:attrs.placeholder,string,};},};registry.category("fields").add("many2many_tags",many2ManyTagsField);registry.category("fields").add("calendar.one2many",many2ManyTagsField);registry.category("fields").add("calendar.many2many",many2ManyTagsField);const Many2ManyTagsFieldColorEditable=__exports.Many2ManyTagsFieldColorEditable=class Many2ManyTagsFieldColorEditable extends Many2ManyTagsField{static components={...super.components,Popover:Many2ManyTagsFieldColorListPopover,};static props={...super.props,canEditColor:{type:Boolean,optional:true},canEditTags:{type:Boolean,optional:true},};static defaultProps={...super.defaultProps,canEditColor:true,canEditTags:false,};getTagProps(record){const props=super.getTagProps(record);props.onClick=(ev)=>this.onTagClick(ev,record);return props;}
onTagClick(ev,record){if(this.props.canEditTags){return this.openMany2xRecord({resId:record.resId,context:this.props.context,title:_t("Edit: %s",record.data.display_name),});}
if(!this.props.canEditColor){return;}
if(this.popover.isOpen){this.popover.close();}else{this.popover.open(ev.currentTarget,{colors:this.constructor.RECORD_COLORS,tag:{id:record.id,colorIndex:record.data[this.props.colorField],},switchTagColor:this.switchTagColor.bind(this),onTagVisibilityChange:this.onTagVisibilityChange.bind(this),});}}
async onTagVisibilityChange(isHidden,tag){const tagRecord=this.props.record.data[this.props.name].records.find((record)=>record.id===tag.id);if(tagRecord.data[this.props.colorField]!=0){this.previousColorsMap[tagRecord.resId]=tagRecord.data[this.props.colorField];}
const changes={[this.props.colorField]:isHidden?0:this.previousColorsMap[tagRecord.resId]||1,};await tagRecord.update(changes);await tagRecord.save();this.popover.close();}
async switchTagColor(colorIndex,tag){const tagRecord=this.props.record.data[this.props.name].records.find((record)=>record.id===tag.id);await tagRecord.update({[this.props.colorField]:colorIndex});await tagRecord.save();this.popover.close();}}
const many2ManyTagsFieldColorEditable=__exports.many2ManyTagsFieldColorEditable={...many2ManyTagsField,component:Many2ManyTagsFieldColorEditable,supportedOptions:[...many2ManyTagsField.supportedOptions,{label:_t("Prevent color edition"),name:"no_edit_color",type:"boolean",},{label:_t("Edit Tags"),name:"edit_tags",type:"boolean",help:_t("If checked, clicking on the tag will open the form that allows to directly edit it. Note that if a color field is also set, the tag edition will prevail. So, the color picker will not be displayed on click on the tag."),},],extractProps({options,attrs}){const props=many2ManyTagsField.extractProps(...arguments);const hasEditPermission=attrs.can_write?evaluateBooleanExpr(attrs.can_write):true;props.canEditTags=options.edit_tags?hasEditPermission:false;props.canEditColor=!props.canEditTags&&!options.no_edit_color&&!!options.color_field;return props;},};registry.category("fields").add("form.many2many_tags",many2ManyTagsFieldColorEditable);return __exports;});;

/* /web/static/src/views/fields/many2many_tags_avatar/many2many_tags_avatar_field.js */
odoo.define('@web/views/fields/many2many_tags_avatar/many2many_tags_avatar_field',['@web/core/l10n/translation','@web/core/popover/popover_hook','@web/core/registry','@web/views/fields/many2many_tags/many2many_tags_field','@web/core/tags_list/tags_list','@web/views/fields/relational_utils','@web/core/utils/urls'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{usePopover}=require("@web/core/popover/popover_hook");const{registry}=require("@web/core/registry");const{many2ManyTagsField,Many2ManyTagsField,}=require("@web/views/fields/many2many_tags/many2many_tags_field");const{TagsList}=require("@web/core/tags_list/tags_list");const{AvatarMany2XAutocomplete}=require("@web/views/fields/relational_utils");const{imageUrl}=require("@web/core/utils/urls");const Many2ManyTagsAvatarField=__exports.Many2ManyTagsAvatarField=class Many2ManyTagsAvatarField extends Many2ManyTagsField{static template="web.Many2ManyTagsAvatarField";static components={Many2XAutocomplete:AvatarMany2XAutocomplete,TagsList,};static props={...Many2ManyTagsField.props,withCommand:{type:Boolean,optional:true},};getTagProps(record){return{...super.getTagProps(record),img:imageUrl(this.relation,record.resId,"avatar_128"),};}}
const many2ManyTagsAvatarField=__exports.many2ManyTagsAvatarField={...many2ManyTagsField,component:Many2ManyTagsAvatarField,extractProps({viewType},dynamicInfo){const props=many2ManyTagsField.extractProps(...arguments);props.withCommand=viewType==="form"||viewType==="list";props.domain=dynamicInfo.domain;return props;},};registry.category("fields").add("many2many_tags_avatar",many2ManyTagsAvatarField);const ListMany2ManyTagsAvatarField=__exports.ListMany2ManyTagsAvatarField=class ListMany2ManyTagsAvatarField extends Many2ManyTagsAvatarField{visibleItemsLimit=5;}
const listMany2ManyTagsAvatarField=__exports.listMany2ManyTagsAvatarField={...many2ManyTagsAvatarField,component:ListMany2ManyTagsAvatarField,};registry.category("fields").add("list.many2many_tags_avatar",listMany2ManyTagsAvatarField);const Many2ManyTagsAvatarFieldPopover=__exports.Many2ManyTagsAvatarFieldPopover=class Many2ManyTagsAvatarFieldPopover extends Many2ManyTagsAvatarField{static template="web.Many2ManyTagsAvatarFieldPopover";static props={...Many2ManyTagsAvatarField.props,close:{type:Function},};setup(){super.setup();const originalUpdate=this.update;this.update=async(recordList)=>{await originalUpdate(recordList);await this._saveUpdate();};}
async deleteTag(id){await super.deleteTag(id);await this._saveUpdate();}
async _saveUpdate(){await this.props.record.save({reload:false});this.render();this.autoCompleteRef.el?.querySelector("input")?.click();}
get tags(){return super.tags.reverse();}}
const many2ManyTagsAvatarFieldPopover=__exports.many2ManyTagsAvatarFieldPopover={...many2ManyTagsAvatarField,component:Many2ManyTagsAvatarFieldPopover,};registry.category("fields").add("many2many_tags_avatar_popover",many2ManyTagsAvatarFieldPopover);const KanbanMany2ManyTagsAvatarFieldTagsList=__exports.KanbanMany2ManyTagsAvatarFieldTagsList=class KanbanMany2ManyTagsAvatarFieldTagsList extends TagsList{static template="web.KanbanMany2ManyTagsAvatarFieldTagsList";static props={...TagsList.props,popoverProps:{type:Object},readonly:{type:Boolean,optional:true},};setup(){super.setup();this.popover=usePopover(Many2ManyTagsAvatarFieldPopover,{popoverClass:"o_m2m_tags_avatar_field_popover",closeOnClickAway:(target)=>!target.closest(".modal"),});}
openPopover(ev){if(this.props.readonly){return;}
this.popover.open(ev.currentTarget.parentElement,{...this.props.popoverProps,readonly:false,canCreate:false,canCreateEdit:false,canQuickCreate:false,placeholder:_t("Search users..."),});}
get canDisplayQuickAssignAvatar(){return!this.props.readonly&&!(this.props.tags&&this.otherTags.length);}}
const KanbanMany2ManyTagsAvatarField=__exports.KanbanMany2ManyTagsAvatarField=class KanbanMany2ManyTagsAvatarField extends Many2ManyTagsAvatarField{static template="web.KanbanMany2ManyTagsAvatarField";static components={...Many2ManyTagsAvatarField.components,TagsList:KanbanMany2ManyTagsAvatarFieldTagsList,};static props={...Many2ManyTagsAvatarField.props,isEditable:{type:Boolean,optional:true},};visibleItemsLimit=3;get popoverProps(){const props={...this.props,readonly:false,};delete props.isEditable;return props;}
get tags(){return super.tags.reverse();}}
const kanbanMany2ManyTagsAvatarField=__exports.kanbanMany2ManyTagsAvatarField={...many2ManyTagsAvatarField,component:KanbanMany2ManyTagsAvatarField,extractProps(fieldInfo,dynamicInfo){const props=many2ManyTagsAvatarField.extractProps(...arguments);props.isEditable=!dynamicInfo.readonly;return props;},};registry.category("fields").add("kanban.many2many_tags_avatar",kanbanMany2ManyTagsAvatarField);return __exports;});;

/* /web/static/src/views/fields/many2one/many2one_field.js */
odoo.define('@web/views/fields/many2one/many2one_field',['@web/core/browser/browser','@web/core/browser/feature_detection','@web/core/context','@web/core/dialog/dialog','@web/core/l10n/translation','@web/core/py_js/py','@web/core/registry','@web/core/utils/hooks','@web/core/utils/strings','@web/views/fields/relational_utils','@web/core/barcode/barcode_dialog','@web/core/barcode/barcode_video_scanner','@web/views/fields/standard_field_props','@odoo/owl','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{isMobileOS}=require("@web/core/browser/feature_detection");const{makeContext}=require("@web/core/context");const{Dialog}=require("@web/core/dialog/dialog");const{_t}=require("@web/core/l10n/translation");const{evaluateBooleanExpr}=require("@web/core/py_js/py");const{registry}=require("@web/core/registry");const{useChildRef,useOwnedDialogs,useService}=require("@web/core/utils/hooks");const{escape,sprintf}=require("@web/core/utils/strings");const{Many2XAutocomplete,useOpenMany2XRecord}=require("@web/views/fields/relational_utils");const BarcodeScanner=require("@web/core/barcode/barcode_dialog");const{isBarcodeScannerSupported}=require("@web/core/barcode/barcode_video_scanner");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component,markup,onWillUpdateProps,useState}=require("@odoo/owl");const{getFieldDomain}=require("@web/model/relational_model/utils");class CreateConfirmationDialog extends Component{static template="web.Many2OneField.CreateConfirmationDialog";static components={Dialog};static props={name:String,value:String,create:Function,close:Function,};get title(){return _t("New: %s",this.props.name);}
get dialogContent(){return markup(sprintf(escape(_t("Create %(value)s as a new %(field)s?")),{value:`<strong>${escape(this.props.value)}</strong>`,field:escape(this.props.name),}));}
async onCreate(){await this.props.create();this.props.close();}}
__exports.m2oTupleFromData=m2oTupleFromData;function m2oTupleFromData(data){const id=data.id;let name;if("display_name"in data){name=data.display_name;}else{const _name=data.name;name=Array.isArray(_name)?_name[1]:_name;}
return[id,name];}
const Many2OneField=__exports.Many2OneField=class Many2OneField extends Component{static template="web.Many2OneField";static components={Many2XAutocomplete,};static props={...standardFieldProps,placeholder:{type:String,optional:true},canOpen:{type:Boolean,optional:true},canCreate:{type:Boolean,optional:true},canWrite:{type:Boolean,optional:true},canQuickCreate:{type:Boolean,optional:true},canCreateEdit:{type:Boolean,optional:true},context:{type:Object,optional:true},openActionContext:{type:String,optional:true},domain:{type:[Array,Function],optional:true},nameCreateField:{type:String,optional:true},searchLimit:{type:Number,optional:true},relation:{type:String,optional:true},string:{type:String,optional:true},canScanBarcode:{type:Boolean,optional:true},update:{type:Function,optional:true},value:{optional:true},decorations:{type:Object,optional:true},};static defaultProps={canOpen:true,canCreate:true,canWrite:true,canQuickCreate:true,canCreateEdit:true,nameCreateField:"name",searchLimit:7,string:"",canScanBarcode:false,context:{},decorations:{},};static SEARCH_MORE_LIMIT=320;setup(){this.orm=useService("orm");this.action=useService("action");this.dialog=useService("dialog");this.notification=useService("notification");this.autocompleteContainerRef=useChildRef();this.addDialog=useOwnedDialogs();this.focusInput=()=>{this.autocompleteContainerRef.el.querySelector("input").focus();};this.state=useState({isFloating:false,});this.computeActiveActions(this.props);this.openMany2X=useOpenMany2XRecord({resModel:this.relation,activeActions:this.state.activeActions,isToMany:false,onRecordSaved:async(record)=>{const resId=this.value[0];const fields=["display_name"];const records=await this.orm.read(this.relation,[resId],fields,{context:this.context,});await this.updateRecord(m2oTupleFromData(records[0]));},onClose:()=>this.focusInput(),fieldString:this.string,});this.update=(value,params={})=>{if(value){value=m2oTupleFromData(value[0]);}
this.state.isFloating=false;return this.updateRecord(value);};if(this.props.canQuickCreate){this.quickCreate=(name)=>{this.state.isFloating=false;return this.updateRecord([false,name]);};}
this.setFloating=(bool)=>{this.state.isFloating=bool;};onWillUpdateProps(async(nextProps)=>{this.computeActiveActions(nextProps);});}
updateRecord(value){const changes={[this.props.name]:value};if(this.props.update){return this.props.update(changes);}
return this.props.record.update(changes);}
get relation(){return this.props.relation||this.props.record.fields[this.props.name].relation;}
get urlRelation(){if(!this.relation.includes(".")){return"m-"+this.relation;}
return this.relation;}
get string(){return this.props.string||this.props.record.fields[this.props.name].string||"";}
get hasExternalButton(){return this.props.canOpen&&!!this.value&&!this.state.isFloating;}
get context(){return this.props.context;}
get classFromDecoration(){const evalContext=this.props.record.evalContextWithVirtualIds;for(const decorationName in this.props.decorations){if(evaluateBooleanExpr(this.props.decorations[decorationName],evalContext)){return`text-${decorationName}`;}}
return"";}
get displayName(){if(this.value&&this.value[1]){return this.value[1].split("\n")[0];}else if(this.value){return _t("Unnamed");}else{return"";}}
get extraLines(){return this.value&&this.value[1]?this.value[1].split("\n").map((line)=>line.trim()).slice(1):[];}
get resId(){return this.value&&this.value[0];}
get value(){return"value"in this.props?this.props.value:this.props.record.data[this.props.name];}
get Many2XAutocompleteProps(){return{value:this.displayName,id:this.props.id,placeholder:this.props.placeholder,resModel:this.relation,autoSelect:true,fieldString:this.string,activeActions:this.state.activeActions,update:this.update,quickCreate:this.quickCreate,context:this.context,getDomain:this.getDomain.bind(this),nameCreateField:this.props.nameCreateField,setInputFloats:this.setFloating,autocomplete_container:this.autocompleteContainerRef,};}
computeActiveActions(props){this.state.activeActions={create:props.canCreate,createEdit:props.canCreateEdit,write:props.canWrite,};}
getDomain(){return getFieldDomain(this.props.record,this.props.name,this.props.domain);}
async openAction(){const{name,openActionContext,record}=this.props;const context=makeContext([openActionContext||this.context,record.fields[name].context],record.evalContext);const action=await this.orm.call(this.relation,"get_formview_action",[[this.resId]],{context,});await this.action.doAction(action);}
async openDialog(resId){return this.openMany2X({resId,context:this.context});}
async openConfirmationDialog(request){return new Promise((resolve,reject)=>{this.addDialog(CreateConfirmationDialog,{value:request,name:this.string,create:async()=>{try{await this.quickCreate(request);resolve();}catch(e){reject(e);}},});});}
onClick(ev){if(this.props.canOpen&&this.props.readonly){ev.stopPropagation();this.openAction();}}
onExternalBtnClick(){if(this.env.inDialog){this.openDialog(this.resId);}else{this.openAction();}}
async onBarcodeBtnClick(){const barcode=await BarcodeScanner.scanBarcode(this.env);if(barcode){await this.onBarcodeScanned(barcode);if("vibrate"in browser.navigator){browser.navigator.vibrate(100);}}else{this.notification.add(_t("Please, scan again!"),{type:"warning",});}}
async search(barcode){const results=await this.orm.call(this.relation,"name_search",[],{name:barcode,args:this.getDomain(),operator:"ilike",limit:2,context:this.context,});return results.map((result)=>{const[id,displayName]=result;return{id,name:displayName,};});}
async onBarcodeScanned(barcode){const results=await this.search(barcode);const records=results.filter((r)=>!!r.id);if(records.length===1){this.update([{id:records[0].id,name:records[0].name}]);}else{const searchInput=this.autocompleteContainerRef.el.querySelector("input");searchInput.value=barcode;searchInput.dispatchEvent(new Event("input"));if(this.env.isSmall){searchInput.dispatchEvent(new Event("barcode-search"));}}}
get hasBarcodeButton(){const canScanBarcode=this.props.canScanBarcode;const supported=isBarcodeScannerSupported();return canScanBarcode&&isMobileOS()&&supported&&!this.hasExternalButton;}}
const many2OneField=__exports.many2OneField={component:Many2OneField,displayName:_t("Many2one"),supportedOptions:[{label:_t("Disable opening"),name:"no_open",type:"boolean",},{label:_t("Disable creation"),name:"no_create",type:"boolean",help:_t("If checked, users won't be able to create records through the autocomplete dropdown at all."),},{label:_t("Disable 'Create' option"),name:"no_quick_create",type:"boolean",help:_t("If checked, users will not be able to create records based on the text input; they will still be able to create records via a popup form."),},{label:_t("Disable 'Create and Edit' option"),name:"no_create_edit",type:"boolean",help:_t("If checked, users will not be able to create records based through a popup form; they will still be able to create records based on the text input."),},],supportedTypes:["many2one"],extractProps({attrs,context,decorations,options,string},dynamicInfo){const hasCreatePermission=attrs.can_create?evaluateBooleanExpr(attrs.can_create):true;const hasWritePermission=attrs.can_write?evaluateBooleanExpr(attrs.can_write):true;const canCreate=options.no_create?false:hasCreatePermission;return{placeholder:attrs.placeholder,canOpen:!options.no_open,canCreate,canWrite:hasWritePermission,canQuickCreate:canCreate&&!options.no_quick_create,canCreateEdit:canCreate&&!options.no_create_edit,context:dynamicInfo.context,openActionContext:context||"{}",decorations,domain:dynamicInfo.domain,nameCreateField:options.create_name_field,canScanBarcode:!!options.can_scan_barcode,string,};},};registry.category("fields").add("many2one",many2OneField);registry.category("fields").add("list.many2one",many2OneField);registry.category("fields").add("kanban.many2one",many2OneField);return __exports;});;

/* /web/static/src/views/fields/many2one_avatar/many2one_avatar_field.js */
odoo.define('@web/views/fields/many2one_avatar/many2one_avatar_field',['@web/core/l10n/translation','@web/core/registry','@web/core/popover/popover_hook','@web/views/fields/many2one/many2one_field','@web/views/fields/relational_utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{usePopover}=require("@web/core/popover/popover_hook");const{many2OneField,Many2OneField}=require("@web/views/fields/many2one/many2one_field");const{AvatarMany2XAutocomplete}=require("@web/views/fields/relational_utils");const Many2OneAvatarField=__exports.Many2OneAvatarField=class Many2OneAvatarField extends Many2OneField{static template="web.Many2OneAvatarField";static components={...Many2OneField.components,Many2XAutocomplete:AvatarMany2XAutocomplete,};}
const many2OneAvatarField=__exports.many2OneAvatarField={...many2OneField,component:Many2OneAvatarField,extractProps(fieldInfo){const props=many2OneField.extractProps(...arguments);props.canOpen=fieldInfo.viewType==="form";return props;},};const Many2OneFieldPopover=__exports.Many2OneFieldPopover=class Many2OneFieldPopover extends Many2OneField{static props={...Many2OneField.props,close:{type:Function},};static components={Many2XAutocomplete:AvatarMany2XAutocomplete,};get Many2XAutocompleteProps(){return{...super.Many2XAutocompleteProps,dropdown:false,autofocus:true,};}
async updateRecord(value){const updatedValue=await super.updateRecord(...arguments);await this.props.record.save();return updatedValue;}}
const KanbanMany2OneAvatarField=__exports.KanbanMany2OneAvatarField=class KanbanMany2OneAvatarField extends Many2OneAvatarField{static template="web.KanbanMany2OneAvatarField";static props={...Many2OneAvatarField.props,isEditable:{type:Boolean,optional:true},};setup(){super.setup();this.popover=usePopover(Many2OneFieldPopover,{popoverClass:"o_m2o_tags_avatar_field_popover",closeOnClickAway:(target)=>!target.closest(".modal"),});}
get popoverProps(){const props={...this.props,readonly:false,};delete props.isEditable;return props;}
openPopover(ev){if(!this.props.isEditable){return;}
this.popover.open(ev.currentTarget,{...this.popoverProps,canCreate:false,canCreateEdit:false,canQuickCreate:false,placeholder:_t("Search user..."),});}}
const kanbanMany2OneAvatarField=__exports.kanbanMany2OneAvatarField={...many2OneField,component:KanbanMany2OneAvatarField,additionalClasses:["o_field_many2one_avatar_kanban"],extractProps(fieldInfo,dynamicInfo){const props=many2OneAvatarField.extractProps(...arguments);props.isEditable=!dynamicInfo.readonly;return props;},};registry.category("fields").add("many2one_avatar",many2OneAvatarField);registry.category("fields").add("kanban.many2one_avatar",kanbanMany2OneAvatarField);return __exports;});;

/* /web/static/src/views/fields/many2one_barcode/many2one_barcode_field.js */
odoo.define('@web/views/fields/many2one_barcode/many2one_barcode_field',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/many2one/many2one_field'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{many2OneField,Many2OneField}=require("@web/views/fields/many2one/many2one_field");const Many2OneBarcodeField=__exports.Many2OneBarcodeField=class Many2OneBarcodeField extends Many2OneField{static defaultProps={...super.defaultProps,canScanBarcode:true,};}
const many2OneBarcodeField=__exports.many2OneBarcodeField={...many2OneField,component:Many2OneBarcodeField,displayName:_t("Many2OneBarcode"),extractProps(){const props=many2OneField.extractProps(...arguments);props.canScanBarcode=true;return props;},};registry.category("fields").add("many2one_barcode",many2OneBarcodeField);return __exports;});;

/* /web/static/src/views/fields/many2one_reference/many2one_reference_field.js */
odoo.define('@web/views/fields/many2one_reference/many2one_reference_field',['@web/core/registry','@web/core/l10n/translation','@web/views/fields/many2one/many2one_field','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{many2OneField,Many2OneField}=require("@web/views/fields/many2one/many2one_field");const{Component}=require("@odoo/owl");const Many2OneReferenceField=__exports.Many2OneReferenceField=class Many2OneReferenceField extends Component{static template="web.Many2OneReferenceField";static components={Many2OneField};static props=Many2OneField.props;get relation(){const modelField=this.props.record.fields[this.props.name].model_field;if(!(modelField in this.props.record.data)){throw new Error(`Many2OneReferenceField: model_field must be in view (${modelField})`);}
return this.props.record.data[modelField];}
get m2oProps(){const relation=this.relation;const value=this.props.record.data[this.props.name];return{...this.props,relation,value:value?[value.resId,value.displayName]:false,readonly:this.props.readonly||!relation,update:(changes)=>{let nextVal;if(changes[this.props.name]){nextVal={resId:changes[this.props.name][0],displayName:changes[this.props.name][1],};}else{nextVal=false;}
return this.props.record.update({[this.props.name]:nextVal});},};}}
const many2oneReferenceField={component:Many2OneReferenceField,displayName:_t("Many2OneReference"),relatedFields:[{name:"display_name",type:"char"}],supportedTypes:["many2one_reference"],extractProps:many2OneField.extractProps,};registry.category("fields").add("many2one_reference",many2oneReferenceField);return __exports;});;

/* /web/static/src/views/fields/many2one_reference_integer/many2one_reference_integer_field.js */
odoo.define('@web/views/fields/many2one_reference_integer/many2one_reference_integer_field',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/integer/integer_field'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{IntegerField}=require("@web/views/fields/integer/integer_field");const Many2OneReferenceIntegerField=__exports.Many2OneReferenceIntegerField=class Many2OneReferenceIntegerField extends IntegerField{get value(){const value=this.props.record.data[this.props.name];return value?value.resId:false;}}
const many2oneReferenceIntegerField={component:Many2OneReferenceIntegerField,displayName:_t("Many2OneReferenceInteger"),supportedTypes:["many2one_reference"],};registry.category("fields").add("many2one_reference_integer",many2oneReferenceIntegerField);return __exports;});;

/* /web/static/src/views/fields/monetary/monetary_field.js */
odoo.define('@web/views/fields/monetary/monetary_field',['@web/core/registry','@web/core/l10n/translation','@web/views/fields/formatters','@web/views/fields/parsers','@web/views/fields/input_field_hook','@web/views/fields/numpad_decimal_hook','@web/views/fields/standard_field_props','@web/core/utils/strings','@odoo/owl','@web/core/currency'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{formatMonetary}=require("@web/views/fields/formatters");const{parseMonetary}=require("@web/views/fields/parsers");const{useInputField}=require("@web/views/fields/input_field_hook");const{useNumpadDecimal}=require("@web/views/fields/numpad_decimal_hook");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{nbsp}=require("@web/core/utils/strings");const{Component,useState,useEffect}=require("@odoo/owl");const{getCurrency}=require("@web/core/currency");const MonetaryField=__exports.MonetaryField=class MonetaryField extends Component{static template="web.MonetaryField";static props={...standardFieldProps,currencyField:{type:String,optional:true},inputType:{type:String,optional:true},useFieldDigits:{type:Boolean,optional:true},hideSymbol:{type:Boolean,optional:true},placeholder:{type:String,optional:true},};static defaultProps={hideSymbol:false,inputType:"text",};setup(){this.inputRef=useInputField(this.inputOptions);this.state=useState({value:undefined});this.nbsp=nbsp;useNumpadDecimal();useEffect(()=>{if(this.inputRef?.el){this.state.value=this.inputRef.el.value;}});}
get inputOptions(){return{getValue:()=>this.formattedValue,refName:"numpadDecimal",parse:parseMonetary,};}
get currencyId(){const currencyField=this.props.currencyField||this.props.record.fields[this.props.name].currency_field||"currency_id";const currency=this.props.record.data[currencyField];return currency&&currency[0];}
get currency(){if(!isNaN(this.currencyId)){return getCurrency(this.currencyId)||null;}
return null;}
get currencySymbol(){return this.currency?this.currency.symbol:"";}
get currencyDigits(){if(this.props.useFieldDigits){return this.props.record.fields[this.props.name].digits;}
if(!this.currency){return null;}
return getCurrency(this.currencyId).digits;}
get value(){return this.props.record.data[this.props.name];}
get formattedValue(){if(this.props.inputType==="number"&&!this.props.readonly&&this.value){return this.value;}
return formatMonetary(this.value,{digits:this.currencyDigits,currencyId:this.currencyId,noSymbol:!this.props.readonly||this.props.hideSymbol,});}
onInput(ev){this.state.value=ev.target.value;}}
const monetaryField=__exports.monetaryField={component:MonetaryField,supportedOptions:[{label:_t("Hide symbol"),name:"no_symbol",type:"boolean",},{label:_t("Currency"),name:"currency_field",type:"field",availableTypes:["many2one"],},],supportedTypes:["monetary","float"],displayName:_t("Monetary"),extractProps:({attrs,options})=>({currencyField:options.currency_field,inputType:attrs.type,useFieldDigits:options.field_digits,hideSymbol:options.no_symbol,placeholder:attrs.placeholder,}),};registry.category("fields").add("monetary",monetaryField);return __exports;});;

/* /web/static/src/views/fields/numpad_decimal_hook.js */
odoo.define('@web/views/fields/numpad_decimal_hook',['@web/core/l10n/localization','@web/core/browser/feature_detection','@odoo/owl'],function(require){'use strict';let __exports={};const{localization}=require("@web/core/l10n/localization");const{isIOS}=require("@web/core/browser/feature_detection");const{useRef,useEffect}=require("@odoo/owl");function onKeydown(ev){const decimalPoint=localization.decimalPoint;if(!([".",","].includes(ev.key)&&ev.code==="NumpadDecimal")||ev.key===decimalPoint||ev.target.type==="number"){return;}
ev.preventDefault();ev.target.setRangeText(decimalPoint,ev.target.selectionStart,ev.target.selectionEnd,"end");}
function onFocus(ev){ev.target.select();}
__exports.useNumpadDecimal=useNumpadDecimal;function useNumpadDecimal(){const ref=useRef("numpadDecimal");const isIOSDevice=isIOS();useEffect(()=>{let inputs=[];const el=ref.el;if(el){inputs=el.nodeName==="INPUT"?[el]:el.querySelectorAll("input");inputs.forEach((input)=>input.addEventListener("keydown",onKeydown));inputs.forEach((input)=>input.addEventListener("focus",onFocus));if(isIOSDevice){inputs.forEach((input)=>input.removeAttribute("inputmode"));}}
return()=>{inputs.forEach((input)=>input.removeEventListener("keydown",onKeydown));inputs.forEach((input)=>input.removeEventListener("focus",onFocus));};});}
return __exports;});;

/* /web/static/src/views/fields/parsers.js */
odoo.define('@web/views/fields/parsers',['@web/core/l10n/dates','@web/core/l10n/localization','@web/core/py_js/py','@web/core/registry','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{parseDate,parseDateTime}=require("@web/core/l10n/dates");const{localization}=require("@web/core/l10n/localization");const{evaluateExpr}=require("@web/core/py_js/py");const{registry}=require("@web/core/registry");const{escapeRegExp}=require("@web/core/utils/strings");function evaluateMathematicalExpression(expr,context={}){var val=expr.replace(new RegExp(/( )/g),"");var safeEvalString="";for(let v of val.split(new RegExp(/([-+*/()^])/g))){if(!["+","-","*","/","(",")","^"].includes(v)&&v.length){v=parseFloat(v);}
if(v==="^"){v="**";}
safeEvalString+=v;}
return evaluateExpr(safeEvalString,context);}
function parseNumber(value,options={}){if(value.startsWith("=")){value=evaluateMathematicalExpression(value.substring(1));if(options.truncate){value=Math.trunc(value);}}else{const thousandsSepRegex=options.thousandsSep.match(/\s+/)?/\s+/g:new RegExp(escapeRegExp(options.thousandsSep),"g")||",";value=value.replaceAll(thousandsSepRegex,"");value=value.replace(new RegExp(escapeRegExp(options.decimalPoint),"g")||".",".");}
return Number(value);}
const InvalidNumberError=__exports.InvalidNumberError=class InvalidNumberError extends Error{}
__exports.parseFloat=parseFloat;function parseFloat(value){const thousandsSepRegex=localization.thousandsSep||"";const decimalPointRegex=localization.decimalPoint;let parsed=parseNumber(value,{thousandsSep:thousandsSepRegex,decimalPoint:decimalPointRegex,});if(isNaN(parsed)){parsed=parseNumber(value,{thousandsSep:",",decimalPoint:".",});if(isNaN(parsed)){throw new InvalidNumberError(`"${value}" is not a correct number`);}}
return parsed;}
__exports.parseFloatTime=parseFloatTime;function parseFloatTime(value){let sign=1;if(value[0]==="-"){value=value.slice(1);sign=-1;}
const values=value.split(":");if(values.length>2){throw new InvalidNumberError(`"${value}" is not a correct number`);}
if(values.length===1){return sign*parseFloat(value);}
const hours=parseInteger(values[0]);const minutes=parseInteger(values[1]);return sign*(hours+minutes/60);}
__exports.parseInteger=parseInteger;function parseInteger(value){const thousandsSepRegex=localization.thousandsSep||"";const decimalPointRegex=localization.decimalPoint;let parsed=parseNumber(value,{thousandsSep:thousandsSepRegex,decimalPoint:decimalPointRegex,truncate:true,});if(!Number.isInteger(parsed)){parsed=parseNumber(value,{thousandsSep:",",decimalPoint:".",truncate:true,});if(!Number.isInteger(parsed)){throw new InvalidNumberError(`"${value}" is not a correct number`);}}
if(parsed<-2147483648||parsed>2147483647){throw new InvalidNumberError(`"${value}" is out of bounds (integers should be between -2,147,483,648 and 2,147,483,647)`);}
return parsed;}
__exports.parsePercentage=parsePercentage;function parsePercentage(value){if(value[value.length-1]==="%"){value=value.slice(0,value.length-1);}
return parseFloat(value)/100;}
__exports.parseMonetary=parseMonetary;function parseMonetary(value){value=value.trim();const startMatch=value.match(new RegExp(`[\\d\\-+=]|${escapeRegExp(localization.decimalPoint)}`));if(startMatch){value=value.substring(startMatch.index);}
value=value.replace(/\D*$/,"");return parseFloat(value);}
registry.category("parsers").add("date",parseDate).add("datetime",parseDateTime).add("float",parseFloat).add("float_time",parseFloatTime).add("integer",parseInteger).add("many2one_reference",parseInteger).add("monetary",parseMonetary).add("percentage",parsePercentage);return __exports;});;

/* /web/static/src/views/fields/pdf_viewer/pdf_viewer_field.js */
odoo.define('@web/views/fields/pdf_viewer/pdf_viewer_field',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/core/utils/urls','@web/views/fields/standard_field_props','@web/views/fields/file_handler','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{url}=require("@web/core/utils/urls");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{FileUploader}=require("@web/views/fields/file_handler");const{Component,onWillUpdateProps,useState}=require("@odoo/owl");const PdfViewerField=__exports.PdfViewerField=class PdfViewerField extends Component{static template="web.PdfViewerField";static components={FileUploader,};static props={...standardFieldProps,};setup(){this.notification=useService("notification");this.state=useState({isValid:true,objectUrl:"",});onWillUpdateProps((nextProps)=>{if(nextProps.readonly){this.state.objectUrl="";}});}
get url(){if(!this.state.isValid||!this.props.record.data[this.props.name]){return null;}
const page=this.props.record.data[`${this.props.name}_page`]||1;const file=encodeURIComponent(this.state.objectUrl||url("/web/content",{model:this.props.record.resModel,field:this.props.name,id:this.props.record.resId,}));return`/web/static/lib/pdfjs/web/viewer.html?file=${file}#page=${page}`;}
update({data}){const changes={[this.props.name]:data||false};return this.props.record.update(changes);}
onFileRemove(){this.state.isValid=true;this.update({});}
onFileUploaded({data,objectUrl}){this.state.isValid=true;this.state.objectUrl=objectUrl;this.update({data});}
onLoadFailed(){this.state.isValid=false;this.notification.add(_t("Could not display the selected pdf"),{type:"danger",});}}
const pdfViewerField=__exports.pdfViewerField={component:PdfViewerField,displayName:_t("PDF Viewer"),supportedOptions:[{label:_t("Preview image"),name:"preview_image",type:"field",availableTypes:["binary"],},],supportedTypes:["binary"],};registry.category("fields").add("pdf_viewer",pdfViewerField);return __exports;});;

/* /web/static/src/views/fields/percent_pie/percent_pie_field.js */
odoo.define('@web/views/fields/percent_pie/percent_pie_field',['@web/core/registry','@web/core/l10n/translation','@web/views/fields/formatters','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{formatFloat}=require("@web/views/fields/formatters");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const PercentPieField=__exports.PercentPieField=class PercentPieField extends Component{static template="web.PercentPieField";static props={...standardFieldProps,string:{type:String,optional:true},};get formattedValue(){return formatFloat(this.props.record.data[this.props.name],{trailingZeros:false,});}}
const percentPieField=__exports.percentPieField={component:PercentPieField,displayName:_t("PercentPie"),supportedTypes:["float","integer"],additionalClasses:["o_field_percent_pie"],extractProps:({string})=>({string}),};registry.category("fields").add("percentpie",percentPieField);return __exports;});;

/* /web/static/src/views/fields/percentage/percentage_field.js */
odoo.define('@web/views/fields/percentage/percentage_field',['@web/core/registry','@web/core/l10n/translation','@web/views/fields/formatters','@web/views/fields/parsers','@web/views/fields/input_field_hook','@web/views/fields/numpad_decimal_hook','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{formatPercentage}=require("@web/views/fields/formatters");const{parsePercentage}=require("@web/views/fields/parsers");const{useInputField}=require("@web/views/fields/input_field_hook");const{useNumpadDecimal}=require("@web/views/fields/numpad_decimal_hook");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const PercentageField=__exports.PercentageField=class PercentageField extends Component{static template="web.PercentageField";static props={...standardFieldProps,digits:{type:Array,optional:true},placeholder:{type:String,optional:true},};setup(){useInputField({getValue:()=>formatPercentage(this.props.record.data[this.props.name],{digits:this.props.digits,noSymbol:true,field:this.props.record.fields[this.props.name],}),refName:"numpadDecimal",parse:(v)=>parsePercentage(v),});useNumpadDecimal();}
get formattedValue(){return formatPercentage(this.props.record.data[this.props.name],{digits:this.props.digits,field:this.props.record.fields[this.props.name],});}}
const percentageField=__exports.percentageField={component:PercentageField,displayName:_t("Percentage"),supportedTypes:["integer","float"],extractProps:({attrs,options})=>{let digits;if(attrs.digits){digits=JSON.parse(attrs.digits);}else if(options.digits){digits=options.digits;}
return{digits,placeholder:attrs.placeholder,};},};registry.category("fields").add("percentage",percentageField);return __exports;});;

/* /web/static/src/views/fields/phone/phone_field.js */
odoo.define('@web/views/fields/phone/phone_field',['@web/core/registry','@web/core/l10n/translation','@web/views/fields/input_field_hook','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{useInputField}=require("@web/views/fields/input_field_hook");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const PhoneField=__exports.PhoneField=class PhoneField extends Component{static template="web.PhoneField";static props={...standardFieldProps,placeholder:{type:String,optional:true},};setup(){useInputField({getValue:()=>this.props.record.data[this.props.name]||""});}
get phoneHref(){return"tel:"+this.props.record.data[this.props.name].replace(/\s+/g,"");}}
const phoneField=__exports.phoneField={component:PhoneField,displayName:_t("Phone"),supportedTypes:["char"],extractProps:({attrs})=>({placeholder:attrs.placeholder,}),};registry.category("fields").add("phone",phoneField);class FormPhoneField extends PhoneField{static template="web.FormPhoneField";}
const formPhoneField=__exports.formPhoneField={...phoneField,component:FormPhoneField,};registry.category("fields").add("form.phone",formPhoneField);return __exports;});;

/* /web/static/src/views/fields/priority/priority_field.js */
odoo.define('@web/views/fields/priority/priority_field',['@web/core/commands/command_hook','@web/core/registry','@web/core/l10n/translation','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{useCommand}=require("@web/core/commands/command_hook");const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component,useState}=require("@odoo/owl");const PriorityField=__exports.PriorityField=class PriorityField extends Component{static template="web.PriorityField";static props={...standardFieldProps,withCommand:{type:Boolean,optional:true},autosave:{type:Boolean,optional:true},};setup(){this.state=useState({index:-1,});if(this.props.withCommand){for(const command of this.commands){useCommand(...command);}}}
get commands(){const commandName=_t("Set priority...");return[[commandName,()=>{return{placeholder:commandName,providers:[{provide:()=>this.options.map((value)=>({name:value[1],action:()=>{this.updateRecord(value[0]);},})),},],};},{category:"smart_action",hotkey:"alt+r"},],];}
get tooltipLabel(){return this.props.record.fields[this.props.name].string;}
get options(){return Array.from(this.props.record.fields[this.props.name].selection);}
get index(){return this.state.index>-1?this.state.index:this.options.findIndex((o)=>o[0]===this.props.record.data[this.props.name]);}
getTooltip(value){return this.tooltipLabel&&this.tooltipLabel!==value?`${this.tooltipLabel}: ${value}`:value;}
onStarClicked(value){if(this.props.record.data[this.props.name]===value){this.state.index=-1;this.updateRecord(this.options[0][0]);}else{this.updateRecord(value);}}
async updateRecord(value){await this.props.record.update({[this.props.name]:value},{save:this.props.autosave});}}
const priorityField=__exports.priorityField={component:PriorityField,displayName:_t("Priority"),supportedOptions:[{label:_t("Autosave"),name:"autosave",type:"boolean",default:true,help:_t("If checked, the record will be saved immediately when the field is modified."),},],supportedTypes:["selection"],extractProps({options,viewType},dynamicInfo){return{withCommand:viewType==="form",readonly:dynamicInfo.readonly,autosave:"autosave"in options?!!options.autosave:true,};},};registry.category("fields").add("priority",priorityField);return __exports;});;

/* /web/static/src/views/fields/progress_bar/kanban_progress_bar_field.js */
odoo.define('@web/views/fields/progress_bar/kanban_progress_bar_field',['@web/core/registry','@web/views/fields/progress_bar/progress_bar_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{progressBarField,ProgressBarField}=require("@web/views/fields/progress_bar/progress_bar_field");const KanbanProgressBarField=__exports.KanbanProgressBarField=class KanbanProgressBarField extends ProgressBarField{get isEditable(){return this.props.isEditable;}}
const kanbanProgressBarField=__exports.kanbanProgressBarField={...progressBarField,component:KanbanProgressBarField,};registry.category("fields").add("kanban.progressbar",kanbanProgressBarField);return __exports;});;

/* /web/static/src/views/fields/progress_bar/progress_bar_field.js */
odoo.define('@web/views/fields/progress_bar/progress_bar_field',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/numpad_decimal_hook','@web/views/fields/parsers','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useNumpadDecimal}=require("@web/views/fields/numpad_decimal_hook");const{parseFloat}=require("@web/views/fields/parsers");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component,useRef,useState}=require("@odoo/owl");const formatters=registry.category("formatters");const ProgressBarField=__exports.ProgressBarField=class ProgressBarField extends Component{static template="web.ProgressBarField";static props={...standardFieldProps,maxValueField:{type:[String,Number],optional:true},currentValueField:{type:String,optional:true},isEditable:{type:Boolean,optional:true},isCurrentValueEditable:{type:Boolean,optional:true},isMaxValueEditable:{type:Boolean,optional:true},title:{type:String,optional:true},overflowClass:{type:String,optional:true},};setup(){useNumpadDecimal();this.root=useRef("numpadDecimal");this.maxValueRef=useRef("maxValue");this.currentValueRef=useRef("currentValue");const{currentValueField,maxValueField,name}=this.props;this.currentValueField=currentValueField?currentValueField:name;if(maxValueField){this.maxValueField=maxValueField;}
this.state=useState({isEditing:false,});}
get isEditable(){return this.props.isEditable&&!this.props.readonly;}
get isPercentage(){return!this.props.maxValueField||!isNaN(this.props.maxValueField);}
get currentValue(){return this.props.record.data[this.currentValueField]||0;}
get maxValue(){return this.props.record.data[this.maxValueField]||100;}
get progressBarColorClass(){return this.currentValue>this.maxValue?this.props.overflowClass:"bg-primary";}
formatCurrentValue(humanReadable=!this.state.isEditing){const formatter=formatters.get(Number.isInteger(this.currentValue)?"integer":"float");return formatter(this.currentValue,{humanReadable});}
formatMaxValue(humanReadable=!this.state.isEditing){const formatter=formatters.get(Number.isInteger(this.maxValue)?"integer":"float");return formatter(this.maxValue,{humanReadable});}
onValueChange(value,fieldName){let parsedValue;try{parsedValue=parseFloat(value);}catch{this.props.record.setInvalidField(this.props.name);return;}
if(this.props.record.fields[fieldName].type==="integer"){parsedValue=Math.floor(parsedValue);}
this.props.record.update({[fieldName]:parsedValue},{save:this.props.readonly});}
onCurrentValueChange(ev){this.onValueChange(ev.target.value,this.currentValueField);}
onMaxValueChange(ev){this.onValueChange(ev.target.value,this.maxValueField);}
onInputBlur(){if(document.activeElement!==this.maxValueRef.el&&document.activeElement!==this.currentValueRef.el){this.state.isEditing=false;}}
onInputFocus(){this.state.isEditing=true;}}
const progressBarField=__exports.progressBarField={component:ProgressBarField,displayName:_t("Progress Bar"),supportedOptions:[{label:_t("Can edit value"),name:"editable",type:"boolean",},{label:_t("Can edit max value"),name:"edit_max_value",type:"boolean",},{label:_t("Current value field"),name:"current_value",type:"field",availableTypes:["integer","float"],help:_t("Use to override the display value (e.g. if your progress bar is a computed percentage but you want to display the actual field value instead)."),},{label:_t("Max value field"),name:"max_value",type:"field",availableTypes:["integer","float"],help:_t("Field that holds the maximum value of the progress bar. If set, will be displayed next to the progress bar (e.g. 10 / 200)."),},{label:_t("Overflow style"),name:"overflow_class",type:"string",availableTypes:["integer","float"],help:_t("Bootstrap classname to customize the style of the progress bar when the maximum value is exceeded"),default:"bg-secondary",},],supportedTypes:["integer","float"],extractProps:({attrs,options})=>({maxValueField:options.max_value,currentValueField:options.current_value,isEditable:!options.readonly&&options.editable,isCurrentValueEditable:options.editable&&!options.edit_max_value,isMaxValueEditable:options.editable&&options.edit_max_value,title:attrs.title,overflowClass:options.overflow_class||"bg-secondary",}),};registry.category("fields").add("progressbar",progressBarField);return __exports;});;

/* /web/static/src/views/fields/properties/card_properties_field.js */
odoo.define('@web/views/fields/properties/card_properties_field',['@web/core/registry','@web/views/fields/properties/properties_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{propertiesField,PropertiesField}=require("@web/views/fields/properties/properties_field");const CardPropertiesField=__exports.CardPropertiesField=class CardPropertiesField extends PropertiesField{static template="web.CardPropertiesField";async _checkDefinitionAccess(){this.state.canChangeDefinition=false;}}
const cardPropertiesField=__exports.cardPropertiesField={...propertiesField,component:CardPropertiesField,};registry.category("fields").add("calendar.properties",cardPropertiesField);registry.category("fields").add("kanban.properties",cardPropertiesField);registry.category("fields").add("hierarchy.properties",cardPropertiesField);return __exports;});;

/* /web/static/src/views/fields/properties/properties_field.js */
odoo.define('@web/views/fields/properties/properties_field',['@web/core/confirmation_dialog/confirmation_dialog','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/l10n/translation','@web/core/popover/popover_hook','@web/core/position/utils','@web/core/registry','@web/core/user','@web/core/utils/hooks','@web/core/utils/sortable_owl','@web/core/utils/strings','@web/model/relational_model/utils','@web/views/utils','@web/views/fields/standard_field_props','@web/views/fields/properties/property_definition','@web/views/fields/properties/property_value','@odoo/owl'],function(require){'use strict';let __exports={};const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{_t}=require("@web/core/l10n/translation");const{usePopover}=require("@web/core/popover/popover_hook");const{reposition}=require("@web/core/position/utils");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{useBus,useService}=require("@web/core/utils/hooks");const{useSortable}=require("@web/core/utils/sortable_owl");const{exprToBoolean}=require("@web/core/utils/strings");const{useRecordObserver}=require("@web/model/relational_model/utils");const{uuid}=require("@web/views/utils");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{PropertyDefinition}=require("@web/views/fields/properties/property_definition");const{PropertyValue}=require("@web/views/fields/properties/property_value");const{Component,onWillStart,useEffect,useRef,useState}=require("@odoo/owl");const PropertiesField=__exports.PropertiesField=class PropertiesField extends Component{static template="web.PropertiesField";static components={Dropdown,DropdownItem,PropertyDefinition,PropertyValue,};static props={...standardFieldProps,context:{type:Object,optional:true},columns:{type:Number,optional:true,validate:(columns)=>[1,2].includes(columns),},showAddButton:{type:Boolean,optional:true},};setup(){this.notification=useService("notification");this.orm=useService("orm");this.dialogService=useService("dialog");this.popover=usePopover(PropertyDefinition,{closeOnClickAway:this.checkPopoverClose,popoverClass:"o_property_field_popover",position:"top",onClose:()=>this.onCloseCurrentPopover?.(),fixedPosition:true,arrow:false,});this.propertiesRef=useRef("properties");let currentResId;useRecordObserver((record)=>{if(currentResId!==record.resId){currentResId=record.resId;this._saveInitialPropertiesValues();}});const field=this.props.record.fields[this.props.name];this.definitionRecordField=field.definition_record;this.state=useState({canChangeDefinition:true,movedPropertyName:null,showAddButton:this.props.showAddButton,unfoldedSeparators:this._getUnfoldedSeparators(),});if(this.env.config?.viewType==="form"){useBus(this.env.model.bus,"PROPERTY_FIELD:ADD_PROPERTY_VALUE",()=>{this.onPropertyCreate();});}
onWillStart(async()=>{await this._checkDefinitionAccess();});useEffect(()=>{if(this.openPropertyDefinition){const propertyName=this.openPropertyDefinition;const labels=this.propertiesRef.el.querySelectorAll(`.o_property_field[property-name="${propertyName}"] .o_field_property_open_popover`);this.openPropertyDefinition=null;const lastLabel=labels[labels.length-1];this._openPropertyDefinition(lastLabel,propertyName,true);}},()=>[this.openPropertyDefinition]);useEffect(()=>this._movePopoverIfNeeded());useSortable({enable:()=>!this.props.readonly&&this.state.canChangeDefinition,ref:this.propertiesRef,handle:".o_field_property_label .oi-draggable",elements:this.renderedColumnsCount===1?"*:is(.o_property_field, .o_field_property_group_label)":".o_property_field",groups:".o_property_group",connectGroups:true,cursor:"grabbing",onDragStart:({element,group})=>{this.propertiesRef.el.classList.add("o_property_dragging");element.classList.add("o_property_drag_item");group.classList.add("o_property_drag_group");document.activeElement.blur();},onDrop:async({parent,element,next,previous})=>{const from=element.getAttribute("property-name");let to=previous&&previous.getAttribute("property-name");let moveBefore=false;if(!to&&next){if(next.classList.contains("o_field_property_group_label")){next=next.closest(".o_property_group");}
to=next.getAttribute("property-name");moveBefore=!!to;}
if(!to){const groupName=parent.getAttribute("property-name");const group=this.groupedPropertiesList.find((group)=>group.name===groupName);if(!group){to=null;moveBefore=false;}else{to=group.elements.length?group.elements.at(-1).name:groupName;}}
await this.onPropertyMoveTo(from,to,moveBefore);},onDragEnd:({element})=>{this.propertiesRef.el.classList.remove("o_property_dragging");element.classList.remove("o_property_drag_item");const targetGroup=this.propertiesRef.el.querySelector(".o_property_drag_group");if(targetGroup){targetGroup.classList.remove("o_property_drag_group");}},onGroupEnter:({group})=>{group.classList.add("o_property_drag_group");this._unfoldSeparators([group.getAttribute("property-name")],true);},onGroupLeave:({group})=>{group.classList.remove("o_property_drag_group");},});useSortable({enable:()=>!this.props.readonly&&this.state.canChangeDefinition,ref:this.propertiesRef,handle:".o_field_property_group_label .oi-draggable",elements:".o_property_group:not([property-name=''])",cursor:"grabbing",onDragStart:({element})=>{this.propertiesRef.el.classList.add("o_property_dragging");element.classList.add("o_property_drag_item");document.activeElement.blur();},onDrop:async({element,previous})=>{const from=element.getAttribute("property-name");const to=previous&&previous.getAttribute("property-name");await this.onGroupMoveTo(from,to);},onDragEnd:({element})=>{this.propertiesRef.el.classList.remove("o_property_dragging");element.classList.remove("o_property_drag_item");},});}
get renderedColumnsCount(){return this.env.isSmall?1:this.props.columns;}
get propertiesList(){return(this.props.record.data[this.props.name]||[]).filter((definition)=>!definition.definition_deleted).map((definition)=>({...definition}));}
get groupedPropertiesList(){const propertiesList=this.propertiesList;const groupedProperties=propertiesList[0]?.type!=="separator"?[{title:null,name:null,elements:[],invisibleLabel:true}]:[];propertiesList.forEach((property)=>{if(property.type==="separator"){groupedProperties.push({title:property.string,name:property.name,elements:[],});}else{groupedProperties.at(-1).elements.push(property);}});if(groupedProperties.length===1){const invisibleLabel=propertiesList[0]?.type!=="separator";groupedProperties[0].elements=[];groupedProperties[0].invisibleLabel=invisibleLabel;for(let col=1;col<this.renderedColumnsCount;++col){groupedProperties.push({title:null,name:groupedProperties[0].name,columnSeparator:true,elements:[],invisibleLabel,});}
const properties=propertiesList.filter((property)=>property.type!=="separator");properties.forEach((property,index)=>{const columnIndex=Math.floor((index*this.renderedColumnsCount)/properties.length);groupedProperties[columnIndex].elements.push(property);});}
return groupedProperties;}
get definitionRecordId(){return this.props.record.data[this.definitionRecordField][0];}
get definitionRecordModel(){return this.props.record.fields[this.definitionRecordField].relation;}
checkPopoverClose(target){if(target.closest(".o_datetime_picker")){return false;}
if(target.closest(".modal")){return false;}
if(target.closest(".o_tag_popover")){return false;}
if(target.closest(".o_model_field_selector_popover")){return false;}
return true;}
generateUniqueDomID(){return`property_${uuid()}`;}
generatePropertyName(){return uuid();}
async onPropertyMove(propertyName,direction){const propertiesValues=this.propertiesList||[];const propertyIndex=propertiesValues.findIndex((property)=>property.name===propertyName);const targetIndex=propertyIndex+(direction==="down"?1:-1);if(targetIndex<0||targetIndex>=propertiesValues.length){this.notification.add(direction==="down"?_t("This field is already last"):_t("This field is already first"),{type:"warning"});return;}
this.state.movedPropertyName=propertyName;const prop=propertiesValues[targetIndex];propertiesValues[targetIndex]=propertiesValues[propertyIndex];propertiesValues[propertyIndex]=prop;propertiesValues[propertyIndex].definition_changed=true;this._unfoldPropertyGroup(targetIndex,propertiesValues);await this.props.record.update({[this.props.name]:propertiesValues});this.movePopoverToProperty=propertyName;}
onPropertyMoveTo(propertyName,toPropertyName,moveBefore){const propertiesValues=this.propertiesList||[];let fromIndex=propertiesValues.findIndex((property)=>property.name===propertyName);let toIndex=propertiesValues.findIndex((property)=>property.name===toPropertyName);const columnSize=Math.ceil(propertiesValues.length/this.renderedColumnsCount);if(this.renderedColumnsCount>1&&!propertiesValues.some((p,index)=>index!==0&&p.type==="separator")&&Math.floor(fromIndex/columnSize)!==Math.floor(toIndex/columnSize)){const newSeparators=[];for(let col=0;col<this.renderedColumnsCount;++col){const separatorIndex=columnSize*col+newSeparators.length;if(propertiesValues[separatorIndex]?.type==="separator"){newSeparators.push(propertiesValues[separatorIndex].name);continue;}
const newSeparator={type:"separator",string:_t("Group %s",col+1),name:this.generatePropertyName(),};newSeparators.push(newSeparator.name);propertiesValues.splice(separatorIndex,0,newSeparator);}
this._unfoldSeparators(newSeparators,true);toPropertyName=toPropertyName||propertiesValues.at(-1).name;fromIndex=propertiesValues.findIndex((property)=>property.name===propertyName);toIndex=propertiesValues.findIndex((property)=>property.name===toPropertyName);}
if(moveBefore){toIndex--;}
if(toIndex<fromIndex){toIndex++;}
propertiesValues.splice(toIndex,0,propertiesValues.splice(fromIndex,1)[0]);propertiesValues[0].definition_changed=true;this.props.record.update({[this.props.name]:propertiesValues});}
onGroupMoveTo(propertyName,toPropertyName){const propertiesValues=this.propertiesList||[];const fromIndex=propertiesValues.findIndex((property)=>property.name===propertyName);const toIndex=propertiesValues.findIndex((property)=>property.name===toPropertyName);if(propertiesValues[fromIndex].type!=="separator"||(toIndex>=0&&propertiesValues[toIndex].type!=="separator")){throw new Error("Something went wrong");}
const getNextSeparatorIndex=(startIndex)=>{const nextSeparatorIndex=propertiesValues.findIndex((property,index)=>property.type==="separator"&&index>startIndex);return nextSeparatorIndex<0?propertiesValues.length:nextSeparatorIndex;};const groupSize=getNextSeparatorIndex(fromIndex)-fromIndex;let targetIndex=getNextSeparatorIndex(toIndex);if(targetIndex>fromIndex){targetIndex-=groupSize;}
propertiesValues.splice(targetIndex,0,...propertiesValues.splice(fromIndex,groupSize));propertiesValues[0].definition_changed=true;this.props.record.update({[this.props.name]:propertiesValues});}
onPropertyValueChange(propertyName,propertyValue){const propertiesValues=this.propertiesList;propertiesValues.find((property)=>property.name===propertyName).value=propertyValue;this.props.record.update({[this.props.name]:propertiesValues});}
async onPropertyEdit(event,propertyName){event.stopPropagation();event.preventDefault();if(!(await this.checkDefinitionWriteAccess())){this.notification.add(_t("You need edit access on the parent document to update these property fields"),{type:"warning"});return;}
if(event.target.classList.contains("disabled")){return;}
event.target.classList.add("disabled");this._openPropertyDefinition(event.target,propertyName,false);}
async onPropertyDefinitionChange(propertyDefinition){propertyDefinition["definition_changed"]=true;if(propertyDefinition.type==="separator"){const separatorKeys=new Set(["name","string","definition_changed","type"]);for(const key in propertyDefinition){if(!separatorKeys.has(key)){delete propertyDefinition[key];}}}
const propertiesValues=this.propertiesList;const propertyIndex=this._getPropertyIndex(propertyDefinition.name);const oldType=propertiesValues[propertyIndex].type;const newType=propertyDefinition.type;this._regeneratePropertyName(propertyDefinition);propertiesValues[propertyIndex]=propertyDefinition;await this.props.record.update({[this.props.name]:propertiesValues});if(newType==="separator"&&oldType!=="separator"){this._unfoldSeparators([propertyDefinition.name],true);this.movePopoverToProperty=propertyDefinition.name;}else if(oldType==="separator"&&newType!=="separator"){const previousSeperator=propertiesValues.findLast((property,index)=>index<propertyIndex&&property.type==="separator");if(previousSeperator){this._unfoldSeparators([previousSeperator.name],true);}
this.movePopoverToProperty=propertyDefinition.name;}}
onPropertyDelete(propertyName){this.popover.close();const dialogProps={title:_t("Delete Property Field"),body:_t('Are you sure you want to delete this property field? It will be removed for everyone using the "%(parentName)s" %(parentFieldLabel)s.',{parentName:this.parentName,parentFieldLabel:this.parentString}),confirmLabel:_t("Delete"),confirm:()=>{const propertiesDefinitions=this.propertiesList;propertiesDefinitions.find((property)=>property.name===propertyName).definition_deleted=true;this.props.record.update({[this.props.name]:propertiesDefinitions});},cancel:()=>{},};this.dialogService.add(ConfirmationDialog,dialogProps);}
async onPropertyCreate(){if(!this.state.canChangeDefinition||!(await this.checkDefinitionWriteAccess())){this.notification.add(_t("You need edit access on the parent document to update these property fields"),{type:"warning"});return;}
const propertiesDefinitions=this.propertiesList||[];if(propertiesDefinitions.length&&propertiesDefinitions.some((prop)=>prop.type!=="separator"&&(!prop.string||!prop.string.length))){this.propertiesRef.el.closest(".o_field_properties").classList.add("o_field_invalid");this.notification.add(_t("Please complete your properties before adding a new one"),{type:"warning",});return;}
this._unfoldPropertyGroup(propertiesDefinitions.length-1,propertiesDefinitions);this.propertiesRef.el.closest(".o_field_properties").classList.remove("o_field_invalid");const newName=this.generatePropertyName();propertiesDefinitions.push({name:newName,string:_t("Property %s",propertiesDefinitions.length+1),type:"char",definition_changed:true,});this.openPropertyDefinition=newName;this.state.showAddButton=true;this.props.record.update({[this.props.name]:propertiesDefinitions});}
onSeparatorClick(propertyName){if(propertyName){this._unfoldSeparators([propertyName]);}}
async checkDefinitionWriteAccess(){if(!this.definitionRecordId||!this.definitionRecordModel){return false;}
return await user.checkAccessRight(this.definitionRecordModel,"write",this.definitionRecordId);}
onTagsChange(propertyName,newTags,newValue=null){const propertyDefinition=this.propertiesList.find((property)=>property.name===propertyName);propertyDefinition.tags=newTags;if(newValue!==null){propertyDefinition.value=newValue;}
propertyDefinition.definition_changed=true;this.onPropertyDefinitionChange(propertyDefinition);}
_getSeparatorFoldKey(){const definitionRecordId=this.props.record.data[this.definitionRecordField][0];const definitionRecordModel=this.props.record.fields[this.definitionRecordField].relation;return`properties.fold,${definitionRecordModel},${definitionRecordId}`;}
_getUnfoldedSeparators(){const key=this._getSeparatorFoldKey();const unfoldedSeparators=JSON.parse(window.localStorage.getItem(key))||[];const allPropertiesNames=this.propertiesList.map((property)=>property.name);return unfoldedSeparators.filter((name)=>allPropertiesNames.includes(name));}
_unfoldSeparators(separatorNames,forceUnfold){let unfoldedSeparators=this._getUnfoldedSeparators();for(const separatorName of separatorNames){if(unfoldedSeparators.includes(separatorName)){if(!forceUnfold){unfoldedSeparators=unfoldedSeparators.filter((name)=>name!==separatorName);}}else{unfoldedSeparators.push(separatorName);}}
const key=this._getSeparatorFoldKey();window.localStorage.setItem(key,JSON.stringify(unfoldedSeparators));this.state.unfoldedSeparators=unfoldedSeparators;}
_movePopoverIfNeeded(){if(!this.movePopoverToProperty){return;}
const propertyName=this.movePopoverToProperty;this.movePopoverToProperty=null;const popover=document.querySelector(".o_field_property_definition").closest(".o_popover");const target=document.querySelector(`*[property-name="${propertyName}"] .o_field_property_open_popover`);reposition(popover,target,{position:"top",margin:10});}
async _checkDefinitionAccess(){this.parentName=this.props.record.data[this.definitionRecordField][1];this.parentString=this.props.record.fields[this.definitionRecordField].string;if(!this.definitionRecordModel){this.state.canChangeDefinition=false;return;}
this.state.canChangeDefinition=await user.checkAccessRight(this.definitionRecordModel,"write");}
_regeneratePropertyName(propertyDefinition){const initialValues=this.initialValues[propertyDefinition.name];if(initialValues&&propertyDefinition.type===initialValues.type&&propertyDefinition.comodel===initialValues.comodel){propertyDefinition.name=initialValues.name;}else if(initialValues&&initialValues.name===propertyDefinition.name){const newName=this.generatePropertyName();this.initialValues[newName]=initialValues;propertyDefinition.name=newName;}}
_getPropertyIndex(propertyName){const initialName=this.initialValues[propertyName]?.name||propertyName;return this.propertiesList.findIndex((property)=>[propertyName,initialName].includes(property.name));}
_saveInitialPropertiesValues(){this.initialValues={};for(const propertiesValues of this.props.record.data[this.props.name]||[]){this.initialValues[propertiesValues.name]={name:propertiesValues.name,type:propertiesValues.type,comodel:propertiesValues.comodel,};}}
_openPropertyDefinition(target,propertyName,isNewlyCreated=false){const propertiesList=this.propertiesList;const propertyIndex=propertiesList.findIndex((property)=>property.name===propertyName);const currentName=(propertyName)=>{const propertiesList=this.propertiesList;for(const[newName,initialValue]of Object.entries(this.initialValues)){if(initialValue.name===propertyName){const prop=propertiesList.find((prop)=>prop.name===newName);if(prop){return newName;}}}
return propertyName;};this.onCloseCurrentPopover=()=>{this.onCloseCurrentPopover=null;this.state.movedPropertyName=null;target.classList.remove("disabled");if(isNewlyCreated){this._setDefaultPropertyValue(currentName(propertyName));}};this.popover.open(target,{readonly:this.props.readonly||!this.state.canChangeDefinition,canChangeDefinition:this.state.canChangeDefinition,checkDefinitionWriteAccess:()=>this.checkDefinitionWriteAccess(),propertyDefinition:this.propertiesList.find((property)=>property.name===currentName(propertyName)),context:this.props.context,onChange:this.onPropertyDefinitionChange.bind(this),onDelete:()=>this.onPropertyDelete(currentName(propertyName)),onPropertyMove:(direction)=>this.onPropertyMove(currentName(propertyName),direction),isNewlyCreated:isNewlyCreated,propertyIndex:propertyIndex,propertiesSize:propertiesList.length,});}
_setDefaultPropertyValue(propertyName){const propertiesValues=this.propertiesList;const newProperty=propertiesValues.find((property)=>property.name===propertyName);newProperty.value=newProperty.default;this.props.value=propertiesValues;this.props.record.update({[this.props.name]:propertiesValues});}
_unfoldPropertyGroup(targetIndex,propertiesValues){const separator=propertiesValues.findLast((property,index)=>property.type==="separator"&&index<=targetIndex);if(separator){this._unfoldSeparators([separator.name],true);}}}
const propertiesField=__exports.propertiesField={component:PropertiesField,displayName:_t("Properties"),supportedTypes:["properties"],extractProps({attrs},dynamicInfo){return{context:dynamicInfo.context,columns:parseInt(attrs.columns||"1"),showAddButton:exprToBoolean(attrs.showAddButton),};},};registry.category("fields").add("properties",propertiesField);return __exports;});;

/* /web/static/src/views/fields/properties/property_definition.js */
odoo.define('@web/views/fields/properties/property_definition',['@web/core/l10n/translation','@web/views/fields/properties/property_value','@web/core/checkbox/checkbox','@web/core/domain_selector/domain_selector','@web/core/domain','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/model_selector/model_selector','@web/views/fields/relational_utils','@web/core/utils/hooks','@web/views/fields/properties/property_definition_selection','@web/views/fields/properties/property_tags','@web/views/view_dialogs/select_create_dialog','@web/views/utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{PropertyValue}=require("@web/views/fields/properties/property_value");const{CheckBox}=require("@web/core/checkbox/checkbox");const{DomainSelector}=require("@web/core/domain_selector/domain_selector");const{Domain}=require("@web/core/domain");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{ModelSelector}=require("@web/core/model_selector/model_selector");const{Many2XAutocomplete}=require("@web/views/fields/relational_utils");const{useService,useOwnedDialogs}=require("@web/core/utils/hooks");const{PropertyDefinitionSelection}=require("@web/views/fields/properties/property_definition_selection");const{PropertyTags}=require("@web/views/fields/properties/property_tags");const{SelectCreateDialog}=require("@web/views/view_dialogs/select_create_dialog");const{uuid}=require("@web/views/utils");const{Component,useState,onWillUpdateProps,useEffect,useRef}=require("@odoo/owl");const PropertyDefinition=__exports.PropertyDefinition=class PropertyDefinition extends Component{static template="web.PropertyDefinition";static components={CheckBox,DomainSelector,Dropdown,DropdownItem,PropertyValue,Many2XAutocomplete,ModelSelector,PropertyDefinitionSelection,PropertyTags,};static props={readonly:{type:Boolean,optional:true},canChangeDefinition:{type:Boolean,optional:true},checkDefinitionWriteAccess:{type:Function,optional:true},propertyDefinition:{optional:true},context:{type:Object},isNewlyCreated:{type:Boolean,optional:true},propertyIndex:{type:Number},propertiesSize:{type:Number},onChange:{type:Function,optional:true},onDelete:{type:Function,optional:true},onPropertyMove:{type:Function,optional:true},close:{type:Function,optional:true},};setup(){this.orm=useService("orm");this.propertyDefinitionRef=useRef("propertyDefinition");this.addDialog=useOwnedDialogs();const defaultDefinition={name:false,string:"",type:"char",default:"",};const propertyDefinition={...defaultDefinition,...this.props.propertyDefinition,};this.state=useState({propertyDefinition:propertyDefinition,typeLabel:this._typeLabel(propertyDefinition.type),resModel:"",resModelDescription:"",matchingRecordsCount:undefined,propertyIndex:this.props.propertyIndex,});this._syncStateWithProps(propertyDefinition);this._domInputIdPrefix=uuid();onWillUpdateProps((newProps)=>this._syncStateWithProps(newProps.value));useEffect((event)=>{if(this.labelFocused){return;}
this.labelFocused=true;const labelInput=this.propertyDefinitionRef.el.querySelectorAll("input")[0];if(labelInput){if(this.props.isNewlyCreated){labelInput.select();}else{labelInput.focus();}}});}
get availablePropertyTypes(){return[["char",_t("Text")],["boolean",_t("Checkbox")],["integer",_t("Integer")],["float",_t("Decimal")],["date",_t("Date")],["datetime",_t("Date & Time")],["selection",_t("Selection")],["tags",_t("Tags")],["many2one",_t("Many2one")],["many2many",_t("Many2many")],["separator",_t("Separator")],];}
get isFirst(){return this.state.propertyIndex===0;}
get isLast(){return this.state.propertyIndex===this.props.propertiesSize-1;}
get propertyTagValues(){return(this.state.propertyDefinition.tags||[]).map((tag)=>tag[0]);}
getUniqueDomID(suffix){return`property_definition_${this._domInputIdPrefix}_${suffix}`;}
onPropertyLabelChange(event){const newString=event.target.value;const propertyDefinition={...this.state.propertyDefinition,string:newString,};this.props.onChange(propertyDefinition);this.state.propertyDefinition=propertyDefinition;}
onPropertyLabelKeypress(event){if(event.key!=="Enter"){return;}
this.props.close();}
onDefaultChange(newDefault){const propertyDefinition={...this.state.propertyDefinition,default:newDefault,};this.props.onChange(propertyDefinition);this.state.propertyDefinition=propertyDefinition;}
onPropertyTypeChange(newType){const propertyDefinition={...this.state.propertyDefinition,type:newType,};if(["integer","float"].includes(newType)){propertyDefinition.value=0;propertyDefinition.default=0;}else{propertyDefinition.value=false;propertyDefinition.default=false;}
delete propertyDefinition.comodel;this.props.onChange(propertyDefinition);this.state.propertyDefinition=propertyDefinition;this.state.resModel="";this.state.resModelDescription="";this.state.typeLabel=this._typeLabel(newType);}
async onModelChange(newModel){const{label,technical}=newModel;const modelChanged=technical!==this.state.resModel;this.state.resModel=technical;this.state.resModelDescription=label;const propertyDefinition={...this.state.propertyDefinition,comodel:technical,default:modelChanged?false:this.state.propertyDefinition.default,value:modelChanged?false:this.state.propertyDefinition.value,domain:modelChanged?false:this.state.propertyDefinition.domain,};this.props.onChange(propertyDefinition);this.state.propertyDefinition=propertyDefinition;await this._updateMatchingRecordsCount();}
async onDomainChange(newDomain){const propertyDefinition={...this.state.propertyDefinition,domain:newDomain,default:false,};this.props.onChange(propertyDefinition);this.state.propertyDefinition=propertyDefinition;await this._updateMatchingRecordsCount();}
onButtonDomainClick(){this.addDialog(SelectCreateDialog,{title:_t("Selected records"),noCreate:true,multiSelect:false,resModel:this.state.propertyDefinition.comodel,domain:new Domain(this.state.propertyDefinition.domain||"[]").toList(),context:this.props.context||{},});}
onPropertyMove(direction){if(direction==="up"){this.state.propertyIndex--;}else{this.state.propertyIndex++;}
this.props.onPropertyMove(direction);}
onSelectionOptionChange(newOptions){const propertyDefinition={...this.state.propertyDefinition,selection:newOptions,};this.props.onChange(propertyDefinition);this.state.propertyDefinition=propertyDefinition;}
onTagsChange(newTags){const propertyDefinition={...this.state.propertyDefinition,tags:newTags,};this.props.onChange(propertyDefinition);this.state.propertyDefinition=propertyDefinition;}
onViewInKanbanChange(newValue){const propertyDefinition={...this.state.propertyDefinition,view_in_cards:newValue,};this.props.onChange(propertyDefinition);this.state.propertyDefinition=propertyDefinition;}
async _syncStateWithProps(propertyDefinition){const newModel=propertyDefinition.comodel;const currentModel=this.state.resModel;this.state.propertyDefinition=propertyDefinition;this.state.resModel=propertyDefinition.comodel;this.state.typeLabel=this._typeLabel(propertyDefinition.type);this.state.resModel=newModel;if(newModel&&newModel!==currentModel){try{const result=await this.orm.call("ir.model","display_name_for",[[newModel]]);if(!result||!result.length){return;}
this.state.resModelDescription=result[0].display_name;}catch{this.state.resModelDescription=_t('You do not have access to the model "%s".',newModel);}
await this._updateMatchingRecordsCount();}else if(!newModel){this.state.resModelDescription="";}}
async _updateMatchingRecordsCount(){if(this.state.resModel&&this.state.resModel.length){const domainList=new Domain(this.state.propertyDefinition.domain||"[]").toList();const result=await this.orm.call(this.state.propertyDefinition.comodel,"search_count",[domainList]);this.state.matchingRecordsCount=result;}else{this.state.matchingRecordsCount=undefined;}}
_typeLabel(propertyType){const allTypes=this.availablePropertyTypes;return allTypes.find((type)=>type[0]===propertyType)[1];}}
return __exports;});;

/* /web/static/src/views/fields/properties/property_definition_selection.js */
odoo.define('@web/views/fields/properties/property_definition_selection',['@web/core/utils/hooks','@web/views/utils','@odoo/owl','@web/core/utils/sortable_owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{uuid}=require("@web/views/utils");const{Component,useState,useRef,useEffect}=require("@odoo/owl");const{useSortable}=require("@web/core/utils/sortable_owl");const PropertyDefinitionSelection=__exports.PropertyDefinitionSelection=class PropertyDefinitionSelection extends Component{static template="web.PropertyDefinitionSelection";static props={default:{type:String,optional:true},options:{},readonly:{type:Boolean,optional:true},canChangeDefinition:{type:Boolean,optional:true},onOptionsChange:{type:Function,optional:true},onDefaultOptionChange:{type:Function,optional:true},};setup(){this.notification=useService("notification");this.state=useState({newOption:null,});this.propertyDefinitionSelectionRef=useRef("propertyDefinitionSelection");this.addButtonRef=useRef("addButton");useEffect(()=>{if(!this.state.newOption){return;}
const inputs=this.propertyDefinitionSelectionRef.el.querySelectorAll(".o_field_property_selection_option input");if(inputs&&inputs.length&&!inputs[this.state.newOption.index].value){inputs[this.state.newOption.index].focus();}});useSortable({enable:()=>this.props.canChangeDefinition&&!this.props.readonly,ref:this.propertyDefinitionSelectionRef,handle:".o_field_property_selection_drag",elements:".o_field_property_selection_option",cursor:"grabbing",onDrop:async({element,previous})=>{const movedOption=element.getAttribute("option-name");const destinationOption=previous&&previous.getAttribute("option-name");await this.onOptionMoveTo(movedOption,destinationOption);},});}
get options(){return JSON.parse(JSON.stringify(this.props.options||[]));}
get optionsVisible(){const options=this.options||[];const newOption=this.state.newOption;if(newOption){options.splice(newOption.index,0,[newOption.name,""]);}
return options;}
onOptionCreate(index){this.state.newOption={index:index,name:uuid(),};}
onOptionChange(event,optionIndex){const target=event.target;const newLabel=target.value;if(this.options[optionIndex]&&this.options[optionIndex][1]===newLabel){return;}
const options=this.optionsVisible;if(!newLabel||!newLabel.length){options.splice(optionIndex,1);}else{options[optionIndex][1]=newLabel;}
const nonEmptyOptions=options.filter((option)=>option[1]&&option[1].length);this.props.onOptionsChange(nonEmptyOptions);if(this.state.newOption){this.state.newOption=null;}}
onOptionBlur(event,optionIndex){if(event.target.value&&event.target.value.length){return;}else if(this._ignoreBlur){this._ignoreBlur=false;return;}
if(event.relatedTarget===this.addButtonRef.el){event.stopPropagation();event.preventDefault();}else if(optionIndex===this.state.newOption?.index){this.state.newOption=null;}}
onOptionKeyDown(event,optionIndex){if(event.key==="Enter"){const newLabel=event.target.value;if(!newLabel||!newLabel.length){event.stopPropagation();event.preventDefault();return;}
this.onOptionChange(event,optionIndex);this.onOptionCreate(optionIndex+1);}else if(["ArrowUp","ArrowDown"].includes(event.key)){event.stopPropagation();event.preventDefault();if(event.key==="ArrowUp"&&optionIndex>0){const previousInput=event.target.closest(".o_field_property_selection_option").previousElementSibling.querySelector("input");previousInput.focus();}else if(event.key==="ArrowDown"&&optionIndex<this.optionsVisible.length-1){const nextInput=event.target.closest(".o_field_property_selection_option").nextElementSibling.querySelector("input");nextInput.focus();}}}
onOptionSetDefault(optionIndex){if(!this.props.canChangeDefinition){return;}
const newValue=this.optionsVisible[optionIndex][0];this.props.onDefaultOptionChange(newValue!==this.props.default?newValue:false);}
onOptionDelete(optionIndex){const options=this.optionsVisible;options.splice(optionIndex,1);this.props.onOptionsChange(options);}
onOptionMoveTo(movedOption,destinationOption){this._ignoreBlur=true;let options=this.optionsVisible;let destinationOptionIndex=options.findIndex((option)=>option[0]==destinationOption);const movedOptionIndex=options.findIndex((option)=>option[0]==movedOption);if(destinationOptionIndex<movedOptionIndex){destinationOptionIndex++;}
const activeEl=document.activeElement;if(activeEl&&this.propertyDefinitionSelectionRef.el.contains(activeEl)&&activeEl.tagName==="INPUT"){const optionName=activeEl.closest(".o_field_property_selection_option").getAttribute("option-name");const editedOptionIndex=options.findIndex((option)=>option[0]===optionName);options[editedOptionIndex][1]=activeEl.value;}
options.splice(destinationOptionIndex,0,options.splice(movedOptionIndex,1)[0]);if(this.state.newOption){const newOptionIndex=options.findIndex((option)=>option[0]===this.state.newOption.name);if(!options[newOptionIndex][1]?.length){this.state.newOption={...this.state.newOption,index:newOptionIndex,};options=options.filter((option)=>option[0]!==this.state.newOption.name);}else{this.state.newOption=null;}}
this.props.onOptionsChange(options);}}
return __exports;});;

/* /web/static/src/views/fields/properties/property_tags.js */
odoo.define('@web/views/fields/properties/property_tags',['@web/core/autocomplete/autocomplete','@web/core/colorlist/colorlist','@web/core/l10n/translation','@web/core/popover/popover_hook','@web/core/registry','@web/core/utils/hooks','@web/core/tags_list/tags_list','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{AutoComplete}=require("@web/core/autocomplete/autocomplete");const{ColorList}=require("@web/core/colorlist/colorlist");const{_t}=require("@web/core/l10n/translation");const{usePopover}=require("@web/core/popover/popover_hook");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{TagsList}=require("@web/core/tags_list/tags_list");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");class PropertyTagsColorListPopover extends Component{static template="web.PropertyTagsColorListPopover";static components={ColorList,};static props={colors:Array,tag:Object,switchTagColor:Function,close:Function,};}
const PropertyTagAutoComplete=__exports.PropertyTagAutoComplete=class PropertyTagAutoComplete extends AutoComplete{}
Object.assign(PropertyTagAutoComplete,{timeout:0});const PropertyTags=__exports.PropertyTags=class PropertyTags extends Component{static template="web.PropertyTags";static components={AutoComplete:PropertyTagAutoComplete,TagsList,ColorList,Popover:PropertyTagsColorListPopover,};static props={id:{type:String,optional:true},selectedTags:{},tags:{},deleteAction:{type:String},readonly:{type:Boolean,optional:true},canChangeTags:{type:Boolean,optional:true},checkDefinitionWriteAccess:{type:Function,optional:true},onValueChange:{type:Function,optional:true},onTagsChange:{type:Function,optional:true},};setup(){this.notification=useService("notification");this.popover=usePopover(this.constructor.components.Popover);}
get displayBadge(){return!this.env.config||this.env.config.viewType!=="kanban";}
get tagListItems(){if(!this.props.selectedTags||!this.props.selectedTags.length){return[];}
let value=this.props.tags.filter((tag)=>this.props.selectedTags.indexOf(tag[0])>=0);if(!this.displayBadge){value=value.filter((tag)=>tag[2]);}
const canDeleteTag=!this.props.readonly&&(this.props.canChangeTags||this.props.deleteAction==="value");return value.map((tag)=>{const[tagId,tagLabel,tagColorIndex]=tag;return{id:tagId,text:tagLabel,className:this.props.canChangeTags?"":"pe-none",colorIndex:tagColorIndex||0,onClick:(event)=>this.onTagClick(event,tagId,tagColorIndex),onDelete:canDeleteTag&&(()=>this.onTagDelete(tagId)),};});}
get selectedTags(){return JSON.parse(JSON.stringify(this.props.selectedTags||[]));}
get availableTags(){return JSON.parse(JSON.stringify(this.props.tags||[]));}
get autocompleteSources(){return[{options:(request)=>{const tagsFiltered=this.props.tags.filter((tag)=>(!this.props.selectedTags||this.props.selectedTags.indexOf(tag[0])<0)&&(!request||!request.length||tag[1].toLocaleLowerCase().indexOf(request.toLocaleLowerCase())>=0));if(!tagsFiltered||!tagsFiltered.length){if(!request||!request.length){return[{value:null,label:_t("Start typing..."),classList:"fst-italic",},];}else if(!this.props.canChangeTags){return[{value:null,label:_t("No result"),classList:"fst-italic",},];}
return[{value:{toCreate:true,value:request},label:_t('Create "%s"',request),classList:"o_field_property_dropdown_add",},];}
return tagsFiltered.map((tag)=>{return{value:tag[0],label:tag[1],};});},},];}
onOptionSelected(tagValue){if(!tagValue){return;}
if(tagValue.toCreate){this.onTagCreate(tagValue.value);}else{const selectedTags=this.selectedTags;const newValue=[...selectedTags,tagValue];this.props.onValueChange(newValue);}}
async onTagCreate(newLabel){if(!newLabel||!newLabel.length){return;}
if(!(await this.props.checkDefinitionWriteAccess())){this.notification.add(_t("You need to be able to edit parent first to add property tags"),{type:"warning"});return;}
const newValue=newLabel?newLabel.toLowerCase().replace(" ","_"):"";const existingTag=this.props.tags.find((tag)=>tag[0]===newValue);if(existingTag){this.notification.add(_t("This tag is already available"),{type:"warning",});return;}
let tagColor=this.props.tags&&this.props.tags.length?(this.props.tags[this.props.tags.length-1][2]+1)%ColorList.COLORS.length:parseInt(Math.random()*ColorList.COLORS.length);tagColor=tagColor||1;const newTag=[newValue,newLabel,tagColor];const updatedTags=[...this.availableTags,newTag];const newValues=[...this.props.selectedTags,newTag[0]];this.props.onTagsChange(updatedTags,newValues);}
onTagDelete(deleteTag){if(this.props.deleteAction==="value"){const selectedTags=this.selectedTags;const newValue=selectedTags.filter((tag)=>tag!==deleteTag);this.props.onValueChange(newValue);}else{const availableTags=this.availableTags;this.props.onTagsChange(availableTags.filter((tag)=>tag[0]!==deleteTag));}}
onTagClick(event,tagId,tagColor){if(!this.props.canChangeTags){event.currentTarget.blur();return;}
this.popover.open(event.currentTarget,{colors:[...Array(ColorList.COLORS.length).keys()],tag:{id:tagId,colorIndex:tagColor},switchTagColor:this.onTagColorSwitch.bind(this),});}
onTagColorSwitch(colorIndex,currentTag){const availableTags=this.availableTags;availableTags.find((tag)=>tag[0]===currentTag.id)[2]=colorIndex;this.props.onTagsChange(availableTags);this.popover.close();}}
const PropertyTagsField=__exports.PropertyTagsField=class PropertyTagsField extends Component{static template="web.PropertyTagsField";static components={PropertyTags};static props={...standardFieldProps};get propertyTagsProps(){return{selectedTags:this.props.record.data[this.props.name]||[],tags:this.props.record.fields[this.props.name].tags||[],deleteAction:"value",readonly:this.props.readonly,canChangeTags:false,onValueChange:(value)=>{this.props.record.update({[this.props.name]:value});},};}}
const propertyTagsField=__exports.propertyTagsField={component:PropertyTagsField,};registry.category("fields").add("property_tags",propertyTagsField);return __exports;});;

/* /web/static/src/views/fields/properties/property_value.js */
odoo.define('@web/views/fields/properties/property_value',['@odoo/owl','@web/core/autocomplete/autocomplete','@web/core/checkbox/checkbox','@web/core/datetime/datetime_input','@web/core/domain','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/l10n/dates','@web/core/l10n/translation','@web/core/tags_list/tags_list','@web/core/utils/hooks','@web/views/fields/formatters','@web/core/utils/numbers','@web/views/fields/many2one/many2one_field','@web/views/fields/parsers','@web/views/fields/relational_utils','@web/views/fields/properties/property_tags','@web/core/utils/urls'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{AutoComplete}=require("@web/core/autocomplete/autocomplete");const{CheckBox}=require("@web/core/checkbox/checkbox");const{DateTimeInput}=require("@web/core/datetime/datetime_input");const{Domain}=require("@web/core/domain");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{deserializeDate,deserializeDateTime,formatDate,formatDateTime,serializeDate,serializeDateTime,}=require("@web/core/l10n/dates");const{_t}=require("@web/core/l10n/translation");const{TagsList}=require("@web/core/tags_list/tags_list");const{useService}=require("@web/core/utils/hooks");const{formatInteger,formatMany2one}=require("@web/views/fields/formatters");const{formatFloat}=require("@web/core/utils/numbers");const{m2oTupleFromData}=require("@web/views/fields/many2one/many2one_field");const{parseFloat,parseInteger}=require("@web/views/fields/parsers");const{Many2XAutocomplete,useOpenMany2XRecord}=require("@web/views/fields/relational_utils");const{PropertyTags}=require("@web/views/fields/properties/property_tags");const{imageUrl}=require("@web/core/utils/urls");const PropertyValue=__exports.PropertyValue=class PropertyValue extends Component{static template="web.PropertyValue";static components={Dropdown,DropdownItem,CheckBox,DateTimeInput,Many2XAutocomplete,TagsList,AutoComplete,PropertyTags,};static props={id:{type:String,optional:true},type:{type:String,optional:true},comodel:{type:String,optional:true},domain:{type:String,optional:true},string:{type:String,optional:true},value:{optional:true},context:{type:Object},readonly:{type:Boolean,optional:true},canChangeDefinition:{type:Boolean,optional:true},checkDefinitionWriteAccess:{type:Function,optional:true},selection:{type:Array,optional:true},tags:{type:Array,optional:true},onChange:{type:Function,optional:true},onTagsChange:{type:Function,optional:true},};setup(){this.orm=useService("orm");this.action=useService("action");this.openMany2X=useOpenMany2XRecord({resModel:this.props.model,activeActions:{create:false,createEdit:false,write:true,},isToMany:false,onRecordSaved:async(record)=>{if(!record){return;}
await record.load();const recordData=m2oTupleFromData(record.data);await this.onValueChange([{id:recordData[0],name:recordData[1]}]);},fieldString:this.props.string,});}
get propertyValue(){const value=this.props.value;if(this.props.type==="float"){return value;}else if(this.props.type==="datetime"){const datetimeValue=typeof value==="string"?deserializeDateTime(value):value;return datetimeValue&&!datetimeValue.invalid?datetimeValue:false;}else if(this.props.type==="date"){const dateValue=typeof value==="string"?deserializeDate(value):value;return dateValue&&!dateValue.invalid?dateValue:false;}else if(this.props.type==="boolean"){return!!value;}else if(this.props.type==="selection"){const options=this.props.selection||[];const option=options.find((option)=>option[0]===value);return option&&option.length===2&&option[0]?option[0]:"";}else if(this.props.type==="many2one"){return!value||value.length!==2||!value[0]?false:value;}else if(this.props.type==="many2many"){if(!value||!value.length){return[];}
return value.map((many2manyValue)=>{const hasAccess=many2manyValue[1]!==null;return{id:many2manyValue[0],comodel:this.props.comodel,text:hasAccess?many2manyValue[1]:_t("No Access"),onClick:hasAccess&&this.clickableRelational&&(async()=>await this._openRecord(this.props.comodel,many2manyValue[0])),onDelete:!this.props.readonly&&hasAccess&&(()=>this.onMany2manyDelete(many2manyValue[0])),colorIndex:0,img:this.showAvatar&&hasAccess?imageUrl(this.props.comodel,many2manyValue[0],"avatar_128"):null,};});}else if(this.props.type==="tags"){return value||[];}
return value;}
get propertyDomain(){if(!this.props.domain||!this.props.domain.length){return[];}
let domain=new Domain(this.props.domain);if(this.props.type==="many2many"&&this.props.value){domain=Domain.and([domain,[["id","not in",this.props.value.map((rec)=>rec[0])]],]);}
return domain.toList();}
get displayValue(){const value=this.propertyValue;if(this.props.type==="many2one"&&value&&value.length===2){return formatMany2one(value);}else if(this.props.type==="integer"){return formatInteger(value||0);}else if(this.props.type==="float"){return formatFloat(value||0);}else if(!value){return false;}else if(this.props.type==="datetime"&&value){return formatDateTime(value);}else if(this.props.type==="date"&&value){return formatDate(value);}else if(this.props.type==="selection"){return this.props.selection.find((option)=>option[0]===value)[1];}
return value.toString();}
get clickableRelational(){return!this.env.config||this.env.config.viewType!=="kanban";}
get showAvatar(){return(["many2one","many2many"].includes(this.props.type)&&["res.users","res.partner"].includes(this.props.comodel));}
async onValueChange(newValue){if(this.props.type==="datetime"){newValue=newValue&&serializeDateTime(newValue);}else if(this.props.type==="date"){newValue=newValue&&serializeDate(newValue);}else if(this.props.type==="integer"){try{newValue=parseInteger(newValue)||0;}catch{newValue=0;}}else if(this.props.type==="float"){try{newValue=parseFloat(newValue)||0;}catch{newValue=0;}}else if(["many2one","many2many"].includes(this.props.type)){newValue=newValue&&newValue.length&&newValue[0].id?[newValue[0].id,newValue[0].name]:false;if(newValue&&newValue[0]&&newValue[1]===undefined){newValue=await this._nameGet(newValue[0]);}
if(this.props.type==="many2many"&&newValue){const currentValue=this.props.value||[];const recordId=newValue[0];const exists=currentValue.find((rec)=>rec[0]===recordId);if(exists){return;}
newValue=[...currentValue,newValue];}}
this.props.onChange(newValue);}
async onMany2oneClick(event){if(this.props.readonly){event.stopPropagation();await this._openRecord(this.props.comodel,this.propertyValue[0]);}}
onExternalLinkClick(){return this.openMany2X({resId:this.propertyValue[0],forceModel:this.props.comodel,context:this.context,});}
onMany2manyDelete(many2manyId){const currentValue=JSON.parse(JSON.stringify(this.props.value||[]));const newValue=currentValue.filter((value)=>value[0]!==many2manyId);this.props.onChange(newValue);}
async onQuickCreate(name,params={}){const result=await this.orm.call(this.props.comodel,"name_create",[name],{context:this.props.context,});this.onValueChange([{id:result[0],name:result[1]}]);}
async _openRecord(recordModel,recordId){const action=await this.orm.call(recordModel,"get_formview_action",[[recordId]],{context:this.props.context,});this.action.doAction(action);}
async _nameGet(recordId){const result=await this.orm.read(this.props.comodel,[recordId],["display_name"],{context:this.props.context,});return[result[0].id,result[0].display_name];}}
return __exports;});;

/* /web/static/src/views/fields/radio/radio_field.js */
odoo.define('@web/views/fields/radio/radio_field',['@odoo/owl','@web/core/l10n/translation','@web/core/registry','@web/model/relational_model/utils','@web/views/fields/relational_utils','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{getFieldDomain}=require("@web/model/relational_model/utils");const{useSpecialData}=require("@web/views/fields/relational_utils");const{standardFieldProps}=require("@web/views/fields/standard_field_props");let nextId=0;const RadioField=__exports.RadioField=class RadioField extends Component{static template="web.RadioField";static props={...standardFieldProps,orientation:{type:String,optional:true},label:{type:String,optional:true},domain:{type:[Array,Function],optional:true},};static defaultProps={orientation:"vertical",};setup(){this.id=`radio_field_${nextId++}`;this.type=this.props.record.fields[this.props.name].type;if(this.type==="many2one"){this.specialData=useSpecialData(async(orm,props)=>{const{relation}=props.record.fields[props.name];const domain=getFieldDomain(props.record,props.name,props.domain);const kwargs={specification:{display_name:1},domain,};const{records}=await orm.call(relation,"web_search_read",[],kwargs);return records.map((record)=>[record.id,record.display_name]);});}}
get items(){switch(this.type){case"selection":return this.props.record.fields[this.props.name].selection;case"many2one":{return this.specialData.data;}
default:return[];}}
get value(){switch(this.type){case"selection":return this.props.record.data[this.props.name];case"many2one":return Array.isArray(this.props.record.data[this.props.name])?this.props.record.data[this.props.name][0]:this.props.record.data[this.props.name];default:return null;}}
onChange(value){switch(this.type){case"selection":this.props.record.update({[this.props.name]:value[0]});break;case"many2one":this.props.record.update({[this.props.name]:value});break;}}}
const radioField=__exports.radioField={component:RadioField,displayName:_t("Radio"),supportedOptions:[{label:_t("Display horizontally"),name:"horizontal",type:"boolean",},],supportedTypes:["many2one","selection"],isEmpty:(record,fieldName)=>record.data[fieldName]===false,extractProps:({options,string},dynamicInfo)=>({orientation:options.horizontal?"horizontal":"vertical",label:string,domain:dynamicInfo.domain,}),};registry.category("fields").add("radio",radioField);return __exports;});;

/* /web/static/src/views/fields/reference/reference_field.js */
odoo.define('@web/views/fields/reference/reference_field',['@web/core/l10n/translation','@web/core/registry','@web/model/relational_model/utils','@web/views/fields/many2one/many2one_field','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useRecordObserver}=require("@web/model/relational_model/utils");const{many2OneField,Many2OneField}=require("@web/views/fields/many2one/many2one_field");const{Component,useState}=require("@odoo/owl");const ReferenceField=__exports.ReferenceField=class ReferenceField extends Component{static template="web.ReferenceField";static components={Many2OneField,};static props={...Many2OneField.props,hideModel:{type:Boolean,optional:true},modelField:{type:String,optional:true},};static defaultProps={...Many2OneField.defaultProps,};setup(){this.state=useState({formattedCharValue:undefined,modelName:undefined,currentRelation:undefined,});if(this._isCharField(this.props)){let currentValue=undefined;useRecordObserver(async(record,props)=>{if(currentValue!==record.data[props.name]){this.state.formattedCharValue=await this._fetchReferenceCharData(props);currentValue=record.data[props.name];}});}else if(this.props.modelField){useRecordObserver(async(record,props)=>{if(this.currentModelId!==record.data[props.modelField]?.[0]){this.state.modelName=await this._fetchModelTechnicalName(props);if(this.currentModelId!==undefined){record.update({[props.name]:false});}
this.currentModelId=record.data[props.modelField]?.[0];}});}}
get m2oProps(){const value=this.getValue();const p={...this.props,relation:this.getRelation(),value:value&&[value.resId,value.displayName],update:this.updateM2O.bind(this),};delete p.hideModel;delete p.modelField;return p;}
get selection(){if(!this._isCharField(this.props)&&!this.hideModelSelector){return this.props.record.fields[this.props.name].selection;}
return[];}
get relation(){return this.getRelation();}
get hideModelSelector(){return this.props.hideModel||this.props.modelField;}
getRelation(){const modelName=this.getModelName();if(modelName){return modelName;}
const value=this.getValue();if(value&&value.resModel){return value.resModel;}else{return this.state.currentRelation;}}
getValue(){if(this._isCharField(this.props)){return this.state.formattedCharValue;}else{return this.props.record.data[this.props.name];}}
getModelName(){return this.hideModelSelector&&this.state.modelName;}
updateModel(value){this.state.currentRelation=value;this.props.record.update({[this.props.name]:false});}
updateM2O(data){const value=data[this.props.name];const resModel=this.state.currentRelation||this.getRelation();this.props.record.update({[this.props.name]:value&&{resModel,resId:value[0],displayName:value[1],},});}
_isCharField(props){return props.record.fields[props.name].type==="char";}
async _fetchReferenceCharData(props){const recordData=props.record.data[props.name];if(!recordData){return false;}
const[resModel,_resId]=recordData.split(",");const resId=parseInt(_resId,10);if(resModel&&resId){const{specialDataCaches,orm}=props.record.model;const key=`__reference__name_get-${recordData}`;if(!specialDataCaches[key]){specialDataCaches[key]=orm.read(resModel,[resId],["display_name"]);}
const result=await specialDataCaches[key];return{resId,resModel,displayName:result[0].display_name,};}
return false;}
_assertMany2OneToIrModel(props){const field=props.modelField&&props.record.fields[props.modelField];if(field&&(field.type!=="many2one"||field.relation!=="ir.model")){throw new Error(`The model_field (${props.modelField}) of the reference field ${props.name} must be a many2one('ir.model').`);}}
async _fetchModelTechnicalName(props){this._assertMany2OneToIrModel(props);const record=props.record;const modelId=record.data[props.modelField]?.[0];if(!modelId){return false;}
const{specialDataCaches,orm}=props.record.model;const key=`__reference__ir_model-${modelId}`;if(!specialDataCaches[key]){specialDataCaches[key]=orm.read("ir.model",[modelId],["model"]);}
const result=await specialDataCaches[key];return result[0].model;}}
const referenceField=__exports.referenceField={component:ReferenceField,displayName:_t("Reference"),supportedOptions:[{label:_t("Hide model"),name:"hide_model",type:"boolean",},{label:_t("Model field"),name:"model_field",type:"field",availableTypes:["many2one"],},],supportedTypes:["reference","char"],extractProps({options}){const props=many2OneField.extractProps(...arguments);props.hideModel=!!options.hide_model;props.modelField=options.model_field;return props;},};registry.category("fields").add("reference",referenceField);return __exports;});;

/* /web/static/src/views/fields/relational_utils.js */
odoo.define('@web/views/fields/relational_utils',['@web/core/l10n/translation','@web/core/autocomplete/autocomplete','@web/core/context','@web/core/dialog/dialog','@web/core/domain','@web/core/network/rpc','@web/core/utils/cache','@web/core/utils/hooks','@web/core/utils/xml','@web/views/form/form_arch_parser','@web/views/form/form_controller','@web/views/form/form_renderer','@web/model/relational_model/utils','@web/views/utils','@web/views/view_button/view_button','@web/views/view_button/view_button_hook','@web/views/view_dialogs/form_view_dialog','@web/views/view_dialogs/select_create_dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{AutoComplete}=require("@web/core/autocomplete/autocomplete");const{makeContext}=require("@web/core/context");const{Dialog}=require("@web/core/dialog/dialog");const{Domain}=require("@web/core/domain");const{RPCError}=require("@web/core/network/rpc");const{Cache}=require("@web/core/utils/cache");const{useBus,useChildRef,useForwardRefToParent,useOwnedDialogs,useService,}=require("@web/core/utils/hooks");const{createElement,parseXML}=require("@web/core/utils/xml");const{FormArchParser}=require("@web/views/form/form_arch_parser");const{loadSubViews,useFormViewInDialog}=require("@web/views/form/form_controller");const{FormRenderer}=require("@web/views/form/form_renderer");const{extractFieldsFromArchInfo,useRecordObserver}=require("@web/model/relational_model/utils");const{computeViewClassName,isNull}=require("@web/views/utils");const{ViewButton}=require("@web/views/view_button/view_button");const{executeButtonCallback,useViewButtons}=require("@web/views/view_button/view_button_hook");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");const{SelectCreateDialog}=require("@web/views/view_dialogs/select_create_dialog");const{Component,onWillUpdateProps,useComponent,useEffect,useEnv,useState,useSubEnv,}=require("@odoo/owl");__exports.useSelectCreate=useSelectCreate;function useSelectCreate({resModel,activeActions,onSelected,onCreateEdit,onUnselect}){const addDialog=useOwnedDialogs();function selectCreate({domain,context,filters,title}){addDialog(SelectCreateDialog,{title:title||_t("Select records"),noCreate:!activeActions.create,multiSelect:"link"in activeActions?activeActions.link:false,resModel,context,domain,onSelected,onCreateEdit:()=>onCreateEdit({context}),dynamicFilters:filters,onUnselect,});}
return selectCreate;}
const STANDARD_ACTIVE_ACTIONS=["create","createEdit","delete","link","unlink","write"];__exports.useActiveActions=useActiveActions;function useActiveActions({fieldType,subViewActiveActions={},crudOptions={},getEvalParams=()=>({}),}){const compute=({evalContext={},readonly=true})=>{const result={type:fieldType,onDelete:null};const evalAction=(actionName)=>evals[actionName](evalContext);result.create=!readonly&&evalAction("create");result.createEdit=!readonly&&result.create&&crudOptions.createEdit;result.edit=crudOptions.edit;result.delete=!readonly&&evalAction("delete");if(isMany2Many){result.link=!readonly&&evalAction("link");result.unlink=!readonly&&evalAction("unlink");result.write=evalAction("write");}
if(result.unlink||(!isMany2Many&&result.delete)){result.onDelete=crudOptions.onDelete;}
return result;};const props=useComponent().props;const isMany2Many=fieldType==="many2many";const evals={};for(const actionName of STANDARD_ACTIVE_ACTIONS){let evalFn=()=>actionName!=="write";if(!isNull(crudOptions[actionName])){const action=crudOptions[actionName];evalFn=(evalContext)=>Boolean(action&&new Domain(action).contains(evalContext));}
if(actionName in subViewActiveActions){const viewActiveAction=subViewActiveActions[actionName];evals[actionName]=(evalContext)=>viewActiveAction&&evalFn(evalContext);}else{evals[actionName]=evalFn;}}
const activeActions=compute(getEvalParams(props));onWillUpdateProps((nextProps)=>{Object.assign(activeActions,compute(getEvalParams(nextProps)));});return activeActions;}
__exports.useSpecialData=useSpecialData;function useSpecialData(loadFn){const component=useComponent();const record=component.props.record;const key=`${record.resModel}-${component.props.name}`;const{specialDataCaches}=record.model;const orm=component.env.services.orm;const ormWithCache=Object.create(orm);if(!specialDataCaches[key]){specialDataCaches[key]=new Cache((...args)=>orm.call(...args),(...path)=>JSON.stringify(path));}
ormWithCache.call=(...args)=>specialDataCaches[key].read(...args);const result=useState({data:{}});useRecordObserver(async(record,props)=>{result.data=await loadFn(ormWithCache,{...props,record});});onWillUpdateProps(async(props)=>{if(props.record.id===component.props.record.id){result.data=await loadFn(ormWithCache,props);}});return result;}
const Many2XAutocomplete=__exports.Many2XAutocomplete=class Many2XAutocomplete extends Component{static template="web.Many2XAutocomplete";static components={AutoComplete};static props={value:{type:String,optional:true},activeActions:Object,context:{type:Object,optional:true},nameCreateField:{type:String,optional:true},setInputFloats:{type:Function,optional:true},update:Function,resModel:String,getDomain:Function,searchLimit:{type:Number,optional:true},quickCreate:{type:[Function,{value:null}],optional:true},noSearchMore:{type:Boolean,optional:true},searchMoreLimit:{type:Number,optional:true},fieldString:String,id:{type:String,optional:true},placeholder:{type:String,optional:true},autoSelect:{type:Boolean,optional:true},isToMany:{type:Boolean,optional:true},autocomplete_container:{type:Function,optional:true},dropdown:{type:Boolean,optional:true},autofocus:{type:Boolean,optional:true},getOptionClassnames:{type:Function,optional:true},};static defaultProps={searchLimit:7,searchMoreLimit:320,nameCreateField:"name",value:"",setInputFloats:()=>{},quickCreate:null,context:{},dropdown:true,getOptionClassnames:()=>"",};setup(){this.orm=useService("orm");this.autoCompleteContainer=useForwardRefToParent("autocomplete_container");const{activeActions,resModel,update,isToMany,fieldString}=this.props;this.openMany2X=useOpenMany2XRecord({resModel,activeActions,isToMany,onRecordSaved:(record)=>{return update([{...record.data,id:record.resId}]);},onRecordDiscarded:()=>{if(!isToMany){this.props.update(false);}},fieldString,onClose:()=>{const autoCompleteInput=this.autoCompleteContainer.el.querySelector("input");if(this.props.value!==autoCompleteInput.value){autoCompleteInput.value="";}
autoCompleteInput.focus();},});this.selectCreate=useSelectCreate({resModel,activeActions,onSelected:(resId)=>{const resIds=Array.isArray(resId)?resId:[resId];const values=resIds.map((id)=>({id}));return update(values);},onCreateEdit:({context})=>this.openMany2X({context}),onUnselect:isToMany?undefined:()=>update(),});}
get sources(){return[this.optionsSource];}
get optionsSource(){return{placeholder:_t("Loading..."),options:this.loadOptionsSource.bind(this),};}
get activeActions(){return this.props.activeActions||{};}
getCreationContext(value){return makeContext([this.props.context,{[`default_${this.props.nameCreateField}`]:value},]);}
onInput({inputValue}){if(!this.props.value||this.props.value!==inputValue){this.props.setInputFloats(true);}}
onCancel(){this.props.setInputFloats(false);}
onSelect(option,params={}){if(option.action){return option.action(params);}
const record={id:option.value,display_name:option.displayName,};this.props.update([record],params);}
abortableSearch(name){const originalPromise=this.search(name);return{promise:originalPromise,abort:originalPromise.abort?originalPromise.abort.bind(originalPromise):()=>{},};}
search(name){return this.orm.call(this.props.resModel,"name_search",[],{name:name,operator:"ilike",args:this.props.getDomain(),limit:this.props.searchLimit+1,context:this.props.context,});}
mapRecordToOption(result){return{value:result[0],label:result[1]?result[1].split("\n")[0]:_t("Unnamed"),displayName:result[1],classList:this.props.getOptionClassnames({id:result[0],display_name:result[1]}),};}
async loadOptionsSource(request){if(this.lastProm){this.lastProm.abort(false);}
this.lastProm=this.abortableSearch(request);const records=await this.lastProm.promise;const options=records.map((result)=>this.mapRecordToOption(result));if(this.props.quickCreate&&request.length){options.push({label:_t('Create "%s"',request),classList:"o_m2o_dropdown_option o_m2o_dropdown_option_create",action:async(params)=>{try{await this.props.quickCreate(request,params);}catch(e){if(e instanceof RPCError&&e.exceptionName==="odoo.exceptions.ValidationError"){return this.openMany2X({context:this.getCreationContext(request),nextRecordsContext:this.props.context,});}
throw e;}},});}
if(!this.props.noSearchMore&&records.length>0){options.push({label:this.SearchMoreButtonLabel,action:this.onSearchMore.bind(this,request),classList:"o_m2o_dropdown_option o_m2o_dropdown_option_search_more",});}
const canCreateEdit="createEdit"in this.activeActions?this.activeActions.createEdit:this.activeActions.create;if(!request.length&&!this.props.value&&(this.props.quickCreate||canCreateEdit)){options.push({label:_t("Start typing..."),classList:"o_m2o_start_typing",unselectable:true,});}
if(request.length&&canCreateEdit){options.push({label:_t("Create and edit..."),classList:"o_m2o_dropdown_option o_m2o_dropdown_option_create_edit",action:()=>this.openMany2X({context:this.getCreationContext(request),nextRecordsContext:this.props.context,}),});}
if(!records.length&&!this.activeActions.createEdit&&!this.props.quickCreate){options.push({label:_t("No records"),classList:"o_m2o_no_result",unselectable:true,});}
return options;}
get SearchMoreButtonLabel(){return _t("Search More...");}
async onBarcodeSearch(){const autoCompleteInput=this.autoCompleteContainer.el.querySelector("input");return this.onSearchMore(autoCompleteInput.value);}
async onSearchMore(request){const{resModel,getDomain,context,fieldString}=this.props;const domain=getDomain();let dynamicFilters=[];if(request.length){const nameGets=await this.orm.call(resModel,"name_search",[],{name:request,args:domain,operator:"ilike",limit:this.props.searchMoreLimit,context,});dynamicFilters=[{description:_t("Quick search: %s",request),domain:[["id","in",nameGets.map((nameGet)=>nameGet[0])]],},];}
const title=_t("Search: %s",fieldString);this.selectCreate({domain,context,filters:dynamicFilters,title,});}
onChange({inputValue}){if(!inputValue.length){this.props.update(false);}}}
const AvatarMany2XAutocomplete=__exports.AvatarMany2XAutocomplete=class AvatarMany2XAutocomplete extends Many2XAutocomplete{mapRecordToOption(result){return{...super.mapRecordToOption(result),resModel:this.props.resModel,};}
get optionsSource(){return{...super.optionsSource,optionTemplate:"web.AvatarMany2XAutocomplete",};}}
__exports.useOpenMany2XRecord=useOpenMany2XRecord;function useOpenMany2XRecord({resModel,onRecordSaved,onRecordDiscarded,fieldString,activeActions,isToMany,onClose=(isNew)=>{},}){const addDialog=useOwnedDialogs();const orm=useService("orm");return async function openDialog({resId=false,forceModel=null,title,context,nextRecordsContext},immediate=false){const model=forceModel||resModel;let viewId;if(resId!==false){viewId=await orm.call(model,"get_formview_id",[[resId]],{context,});}
let resolve=()=>{};if(!title){title=resId?_t("Open: %s",fieldString):_t("Create %s",fieldString);}
const{create:canCreate,write:canWrite}=activeActions;const mode=(resId?canWrite:canCreate)?"edit":"readonly";addDialog(FormViewDialog,{preventCreate:!canCreate,preventEdit:!canWrite,title,context,nextRecordsContext,mode,resId,resModel:model,viewId,onRecordSaved,onRecordDiscarded,isToMany,},{onClose:()=>{resolve();const isNew=!resId;onClose(isNew);},});if(!immediate){return new Promise((_resolve)=>{resolve=_resolve;});}};}
const X2ManyFieldDialog=__exports.X2ManyFieldDialog=class X2ManyFieldDialog extends Component{static template="web.X2ManyFieldDialog";static components={Dialog,FormRenderer,ViewButton};static props={archInfo:Object,close:Function,record:Object,addNew:Function,save:Function,title:String,delete:{optional:true},deleteButtonLabel:{optional:true},config:Object,};setup(){this.actionService=useService("action");this.archInfo=this.props.archInfo;this.record=this.props.record;this.title=this.props.title;this.contentClass=computeViewClassName("form",this.archInfo.xmlDoc);useSubEnv({config:this.props.config});this.env.dialogData.dismiss=()=>this.discard();useBus(this.record.model.bus,"update",()=>this.render(true));this.modalRef=useChildRef();const reload=()=>this.record.load();useViewButtons(this.modalRef,{reload,beforeExecuteAction:this.beforeExecuteActionButton.bind(this),});this.canCreate=!this.record.resId;if(this.archInfo.xmlDoc.querySelector("footer:not(field footer)")){this.archInfo={...this.archInfo,xmlDoc:this.archInfo.xmlDoc.cloneNode(true)};this.footerArchInfo=Object.assign({},this.archInfo);this.footerArchInfo.xmlDoc=createElement("t");this.footerArchInfo.xmlDoc.append(...this.archInfo.xmlDoc.querySelectorAll("footer:not(field footer)"));this.footerArchInfo.arch=this.footerArchInfo.xmlDoc.outerHTML;this.archInfo.arch=this.archInfo.xmlDoc.outerHTML;}
const{autofocusFieldId,disableAutofocus}=this.archInfo;if(!disableAutofocus){useEffect((isInEdition)=>{let elementToFocus;if(isInEdition){elementToFocus=(autofocusFieldId&&this.modalRef.el.querySelector(`#${autofocusFieldId}`))||this.modalRef.el.querySelector(".o_field_widget input");}else{elementToFocus=this.modalRef.el.querySelector("button.btn-primary");}
if(elementToFocus){elementToFocus.focus();}else{this.modalRef.el.focus();}},()=>[this.record.isInEdition]);}
useFormViewInDialog();}
get dialogProps(){const props={title:this.title,withBodyPadding:false,modalRef:this.modalRef,contentClass:this.contentClass,};if(!this.record.isNew){props.onExpand=async()=>{await this.save({saveAndNew:false});this.actionService.doAction({type:"ir.actions.act_window",res_model:this.props.record.resModel,res_id:this.props.record.resId,views:[[false,"form"]],});};}
return props;}
async beforeExecuteActionButton(clickParams){if(clickParams.special!=="cancel"){return this.record.save();}}
async discard(){if(this.record.isInEdition){await this.record.discard();}
this.props.close();}
save({saveAndNew}){return executeButtonCallback(this.modalRef.el,async()=>{if(await this.record.checkValidity({displayNotification:true})){await this.props.save(this.record);if(saveAndNew){await this.record.switchMode("readonly");this.record=await this.props.addNew();}}else{return false;}
if(!saveAndNew){this.props.close();}
return true;});}
async remove(){await this.props.delete();this.props.close();}
async saveAndNew(){const saved=await this.save({saveAndNew:true});if(saved){if(this.title){this.title=this.title.replace(_t("Open:"),_t("New:"));}
this.render(true);}}}
async function getFormViewInfo({list,context,activeField,viewService,env}){let formArchInfo=activeField.views.form;let fields=activeField.fields;const comodel=list.resModel;if(!formArchInfo){const{fields:formFields,relatedModels,views,}=await viewService.loadViews({context:makeContext([list.context,context]),resModel:comodel,views:[[false,"form"]],});const xmlDoc=parseXML(views.form.arch);formArchInfo=new FormArchParser().parse(xmlDoc,relatedModels,comodel);fields={...list.fields,...formFields};}
await loadSubViews(formArchInfo.fieldNodes,fields,{},comodel,viewService,env.isSmall);return{archInfo:formArchInfo,fields};}
__exports.useAddInlineRecord=useAddInlineRecord;function useAddInlineRecord({addNew}){let creatingRecord=false;async function addInlineRecord({context,editable}){if(!creatingRecord){creatingRecord=true;try{await addNew({context,mode:"edit",position:editable});}finally{creatingRecord=false;}}}
return addInlineRecord;}
__exports.useOpenX2ManyRecord=useOpenX2ManyRecord;function useOpenX2ManyRecord({activeField,activeActions,getList,updateRecord,saveRecord,isMany2Many,}){const viewService=useService("view");const env=useEnv();const component=useComponent();const addDialog=useOwnedDialogs();const viewMode=activeField.viewMode;async function openRecord({record,mode,context,title,onClose}){if(!title){title=record?_t("Open: %s",activeField.string):_t("Create %s",activeField.string);}
const list=getList();const{archInfo,fields:_fields}=await getFormViewInfo({list,context,activeField,viewService,env,});if(!component.props.record.isInEdition){archInfo.activeActions.edit=false;}
const{activeFields,fields}=extractFieldsFromArchInfo(archInfo,_fields);let deleteRecord;let deleteButtonLabel=undefined;const isDuplicate=!!record;const params={activeFields,fields,mode};if(record){const{delete:canDelete,onDelete}=activeActions;deleteRecord=viewMode==="kanban"&&canDelete?()=>onDelete(record):null;deleteButtonLabel=activeActions.type==="one2many"?_t("Delete"):_t("Remove");}else{params.context=makeContext([list.context,context]);params.withoutParent=isMany2Many;}
record=await list.extendRecord(params,record);const _onClose=()=>{list.editedRecord?.switchMode("readonly");onClose?.();};addDialog(X2ManyFieldDialog,{config:env.config,archInfo,record,addNew:()=>{return getList().extendRecord(params);},save:(rec)=>{if(isDuplicate&&rec.id===record.id){return updateRecord(rec);}else{return saveRecord(rec);}},title,delete:deleteRecord,deleteButtonLabel:deleteButtonLabel,},{onClose:_onClose});}
let recordIsOpen=false;return(params)=>{if(recordIsOpen){return;}
recordIsOpen=true;const onClose=params.onClose;params={...params,onClose:(...args)=>{recordIsOpen=false;if(onClose){return onClose(...args);}},};try{return openRecord(params);}catch(e){recordIsOpen=false;throw e;}};}
__exports.useX2ManyCrud=useX2ManyCrud;function useX2ManyCrud(getList,isMany2Many){let saveRecord;if(isMany2Many){saveRecord=async(object)=>{const list=getList();if(Array.isArray(object)){return list.addAndRemove({add:object});}else{await object.save({reload:false});return list.linkTo(object.resId);}};}else{saveRecord=async(record)=>{return getList().validateExtendedRecord(record);};}
const updateRecord=async(record)=>{if(isMany2Many){await record.save();}
return getList().validateExtendedRecord(record);};const removeRecord=(record)=>{const list=getList();if(isMany2Many){return list.forget(record);}
return list.delete(record);};return{saveRecord,updateRecord,removeRecord,};}
return __exports;});;

/* /web/static/src/views/fields/remaining_days/remaining_days_field.js */
odoo.define('@web/views/fields/remaining_days/remaining_days_field',['@odoo/owl','@web/core/py_js/py','@web/core/l10n/dates','@web/views/utils','@web/core/l10n/localization','@web/core/l10n/translation','@web/core/registry','@web/views/fields/datetime/datetime_field','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{evaluateExpr}=require("@web/core/py_js/py");const{formatDate,formatDateTime}=require("@web/core/l10n/dates");const{getClassNameFromDecoration}=require("@web/views/utils");const{localization}=require("@web/core/l10n/localization");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{DateTimeField}=require("@web/views/fields/datetime/datetime_field");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{DateTime}=luxon;const RemainingDaysField=__exports.RemainingDaysField=class RemainingDaysField extends Component{static components={DateTimeField};static props={...standardFieldProps,classes:{type:Object,optional:true},};static defaultProps={classes:{'bf':'days <= 0','danger':'days < 0','warning':'days == 0',},};static template="web.RemainingDaysField";get diffDays(){const{record,name}=this.props;const value=record.data[name];if(!value){return null;}
const today=DateTime.local().startOf("day");const diff=value.startOf("day").diff(today,"days");return Math.floor(diff.days);}
get diffString(){if(this.diffDays===null){return"";}
switch(this.diffDays){case-1:return _t("Yesterday");case 0:return _t("Today");case 1:return _t("Tomorrow");}
if(Math.abs(this.diffDays)>99){return this.formattedValue;}
if(this.diffDays<0){return _t("%s days ago",-this.diffDays);}
return _t("In %s days",this.diffDays);}
get formattedValue(){const{record,name}=this.props;return record.fields[name].type==="datetime"?formatDateTime(record.data[name],{format:localization.dateFormat}):formatDate(record.data[name]);}
get classNames(){if(this.diffDays===null){return null;}
if(!this.props.record.isActive){return null;}
const classNames={};const evalContext={days:this.diffDays,record:this.props.record.evalContext};for(const decoration in this.props.classes){const value=evaluateExpr(this.props.classes[decoration],evalContext);classNames[getClassNameFromDecoration(decoration)]=value;}
return classNames;}
get dateTimeFieldProps(){return Object.fromEntries(Object.entries(this.props).filter(([key])=>standardFieldProps[key]));}}
const remainingDaysField=__exports.remainingDaysField={component:RemainingDaysField,displayName:_t("Remaining Days"),supportedTypes:["date","datetime"],extractProps:({options})=>{return{classes:options.classes,};},};registry.category("fields").add("remaining_days",remainingDaysField);return __exports;});;

/* /web/static/src/views/fields/selection/filterable_selection_field.js */
odoo.define('@web/views/fields/selection/filterable_selection_field',['@web/core/registry','@web/views/fields/selection/selection_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{SelectionField,selectionField}=require("@web/views/fields/selection/selection_field");const FilterableSelectionField=__exports.FilterableSelectionField=class FilterableSelectionField extends SelectionField{static props={...SelectionField.props,whitelist_fname:{type:String,optional:true},whitelisted_values:{type:Array,optional:true},blacklisted_values:{type:Array,optional:true},};get options(){let options=super.options;if(this.props.whitelist_fname){options=options.filter((option)=>{return(option[0]===this.props.record.data[this.props.name]||this.props.record.data[this.props.whitelist_fname].includes(option[0]));});}else if(this.props.whitelisted_values){options=options.filter((option)=>{return(option[0]===this.props.record.data[this.props.name]||this.props.whitelisted_values.includes(option[0]));});}else if(this.props.blacklisted_values){options=options.filter((option)=>{return(option[0]===this.props.record.data[this.props.name]||!this.props.blacklisted_values.includes(option[0]));});}
return options;}}
const filterableSelectionField=__exports.filterableSelectionField={...selectionField,component:FilterableSelectionField,supportedOptions:[{label:"Whitelisted Values",name:"whitelisted_values",type:"string",},{label:"Blacklisted Values",name:"blacklisted_values",type:"string",},{label:"Whitelisted field name",name:"whitelist_fname",type:"string",},],extractProps({options}){const props=selectionField.extractProps(...arguments);props.whitelist_fname=options.whitelist_fname;props.whitelisted_values=options.whitelisted_values;props.blacklisted_values=options.blacklisted_values;return props;},};registry.category("fields").add("filterable_selection",filterableSelectionField);return __exports;});;

/* /web/static/src/views/fields/selection/selection_field.js */
odoo.define('@web/views/fields/selection/selection_field',['@odoo/owl','@web/core/l10n/translation','@web/core/registry','@web/model/relational_model/utils','@web/views/fields/relational_utils','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{getFieldDomain}=require("@web/model/relational_model/utils");const{useSpecialData}=require("@web/views/fields/relational_utils");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const SelectionField=__exports.SelectionField=class SelectionField extends Component{static template="web.SelectionField";static props={...standardFieldProps,placeholder:{type:String,optional:true},required:{type:Boolean,optional:true},domain:{type:[Array,Function],optional:true},autosave:{type:Boolean,optional:true},};static defaultProps={autosave:false,};setup(){this.type=this.props.record.fields[this.props.name].type;if(this.type==="many2one"){this.specialData=useSpecialData((orm,props)=>{const{relation}=props.record.fields[props.name];const domain=getFieldDomain(props.record,props.name,props.domain);return orm.call(relation,"name_search",["",domain]);});}}
get options(){switch(this.type){case"many2one":return[...this.specialData.data];case"selection":return this.props.record.fields[this.props.name].selection.filter((option)=>option[0]!==false&&option[1]!=="");default:return[];}}
get string(){switch(this.type){case"many2one":return this.props.record.data[this.props.name]?this.props.record.data[this.props.name][1]:"";case"selection":return this.props.record.data[this.props.name]!==false?this.options.find((o)=>o[0]===this.props.record.data[this.props.name])[1]:"";default:return"";}}
get value(){const rawValue=this.props.record.data[this.props.name];return this.type==="many2one"&&rawValue?rawValue[0]:rawValue;}
stringify(value){return JSON.stringify(value);}
onChange(ev){const value=JSON.parse(ev.target.value);switch(this.type){case"many2one":if(value===false){this.props.record.update({[this.props.name]:false},{save:this.props.autosave});}else{this.props.record.update({[this.props.name]:this.options.find((option)=>option[0]===value),},{save:this.props.autosave});}
break;case"selection":this.props.record.update({[this.props.name]:value},{save:this.props.autosave});break;}}}
const selectionField=__exports.selectionField={component:SelectionField,displayName:_t("Selection"),supportedTypes:["many2one","selection"],isEmpty:(record,fieldName)=>record.data[fieldName]===false,extractProps({attrs,viewType},dynamicInfo){const props={autosave:viewType==="kanban",placeholder:attrs.placeholder,required:dynamicInfo.required,domain:dynamicInfo.domain,};if(viewType==="kanban"){props.readonly=dynamicInfo.readonly;}
return props;},};registry.category("fields").add("selection",selectionField);registry.category("fields").add("kanban.selection",selectionField);return __exports;});;

/* /web/static/src/views/fields/signature/signature_field.js */
odoo.define('@web/views/fields/signature/signature_field',['@web/core/l10n/translation','@web/core/registry','@web/core/signature/signature_dialog','@web/core/utils/hooks','@web/core/utils/urls','@web/core/utils/binary','@web/views/fields/image/image_field','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{SignatureDialog}=require("@web/core/signature/signature_dialog");const{useService}=require("@web/core/utils/hooks");const{imageUrl}=require("@web/core/utils/urls");const{isBinarySize}=require("@web/core/utils/binary");const{fileTypeMagicWordMap}=require("@web/views/fields/image/image_field");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component,useState}=require("@odoo/owl");const placeholder="/web/static/img/placeholder.png";const SignatureField=__exports.SignatureField=class SignatureField extends Component{static template="web.SignatureField";static props={...standardFieldProps,defaultFont:{type:String},fullName:{type:String,optional:true},height:{type:Number,optional:true},previewImage:{type:String,optional:true},width:{type:Number,optional:true},type:{validate:(t)=>["initial","signature"].includes(t),optional:true},};static defaultProps={type:"signature",};setup(){this.displaySignatureRatio=3;this.dialogService=useService("dialog");this.state=useState({isValid:true,});}
get rawCacheKey(){return this.props.record.data.write_date;}
get getUrl(){const{name,previewImage,record}=this.props;if(this.state.isValid&&this.value){if(isBinarySize(this.value)){return imageUrl(record.resModel,record.resId,previewImage||name,{unique:this.rawCacheKey,});}else{const magic=fileTypeMagicWordMap[this.value[0]]||"png";return`data:image/${magic};base64,${this.props.record.data[this.props.name]}`;}}
return placeholder;}
get sizeStyle(){let{width,height}=this.props;if(!this.value){if(width&&height){width=Math.min(width,this.displaySignatureRatio*height);height=width/this.displaySignatureRatio;}else if(width){height=width/this.displaySignatureRatio;}else if(height){width=height*this.displaySignatureRatio;}}
let style="";if(width){style+=`width:${width}px; max-width:${width}px;`;}
if(height){style+=`height:${height}px; max-height:${height}px;`;}
return style;}
get value(){return this.props.record.data[this.props.name];}
onClickSignature(){if(!this.props.readonly){const nameAndSignatureProps={displaySignatureRatio:3,signatureType:this.props.type,noInputName:true,};const{fullName,record}=this.props;let defaultName="";if(fullName){let signName;const fullNameData=record.data[fullName];if(record.fields[fullName].type==="many2one"){signName=fullNameData&&fullNameData[1];}else{signName=fullNameData;}
defaultName=signName===""?undefined:signName;}
nameAndSignatureProps.defaultFont=this.props.defaultFont;const dialogProps={defaultName,nameAndSignatureProps,uploadSignature:(signature)=>this.uploadSignature(signature),};this.dialogService.add(SignatureDialog,dialogProps);}}
onLoadFailed(){this.state.isValid=false;this.notification.add(_t("Could not display the selected image"),{type:"danger",});}
uploadSignature({signatureImage}){return this.props.record.update({[this.props.name]:signatureImage.split(",")[1]||false,});}}
const signatureField=__exports.signatureField={component:SignatureField,fieldDependencies:[{name:"write_date",type:"datetime"}],supportedOptions:[{label:_t("Prefill with"),name:"full_name",type:"field",availableTypes:["char","many2one"],help:_t("The selected field will be used to pre-fill the signature"),},{label:_t("Default font"),name:"default_font",type:"string",},{label:_t("Size"),name:"size",type:"selection",choices:[{label:_t("Small"),value:"[0,90]"},{label:_t("Medium"),value:"[0,180]"},{label:_t("Large"),value:"[0,270]"},],},{label:_t("Preview image field"),name:"preview_image",type:"field",availableTypes:["binary"],},],extractProps:({attrs,options})=>({defaultFont:options.default_font||"",fullName:options.full_name,height:options.size?options.size[1]||undefined:attrs.height,previewImage:options.preview_image,type:options.type,width:options.size?options.size[0]||undefined:attrs.width,}),};registry.category("fields").add("signature",signatureField);return __exports;});;

/* /web/static/src/views/fields/standard_field_props.js */
odoo.define('@web/views/fields/standard_field_props',[],function(require){'use strict';let __exports={};const standardFieldProps=__exports.standardFieldProps={id:{type:String,optional:true},name:{type:String},readonly:{type:Boolean,optional:true},record:{type:Object},};return __exports;});;

/* /web/static/src/views/fields/stat_info/stat_info_field.js */
odoo.define('@web/views/fields/stat_info/stat_info_field',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/strings','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{exprToBoolean}=require("@web/core/utils/strings");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const formatters=registry.category("formatters");const StatInfoField=__exports.StatInfoField=class StatInfoField extends Component{static template="web.StatInfoField";static props={...standardFieldProps,labelField:{type:String,optional:true},noLabel:{type:Boolean,optional:true},digits:{type:Array,optional:true},string:{type:String,optional:true},};get formattedValue(){const field=this.props.record.fields[this.props.name];const formatter=formatters.get(field.type);return formatter(this.props.record.data[this.props.name]||0,{digits:this.props.digits,field,});}
get label(){return this.props.labelField?this.props.record.data[this.props.labelField]:this.props.string;}}
const statInfoField=__exports.statInfoField={component:StatInfoField,displayName:_t("Stat Info"),supportedOptions:[{label:_t("Label field"),name:"label_field",type:"field",availableTypes:["char"],},],supportedTypes:["float","integer","monetary"],isEmpty:()=>false,extractProps:({attrs,options,string})=>{let digits;if(attrs.digits){digits=JSON.parse(attrs.digits);}else if(options.digits){digits=options.digits;}
return{digits,labelField:options.label_field,noLabel:exprToBoolean(attrs.nolabel),string,};},};registry.category("fields").add("statinfo",statInfoField);return __exports;});;

/* /web/static/src/views/fields/state_selection/state_selection_field.js */
odoo.define('@web/views/fields/state_selection/state_selection_field',['@odoo/owl','@web/core/commands/command_hook','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/l10n/translation','@web/core/registry','@web/views/fields/formatters','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{useCommand}=require("@web/core/commands/command_hook");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{formatSelection}=require("@web/views/fields/formatters");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const StateSelectionField=__exports.StateSelectionField=class StateSelectionField extends Component{static template="web.StateSelectionField";static components={Dropdown,DropdownItem,};static props={...standardFieldProps,showLabel:{type:Boolean,optional:true},withCommand:{type:Boolean,optional:true},autosave:{type:Boolean,optional:true},};static defaultProps={showLabel:true,};setup(){this.colorPrefix="o_status_";this.colors={blocked:"red",done:"green",};if(this.props.withCommand){const hotkeys=["D","F","G"];for(const[index,[value,label]]of this.options.entries()){useCommand(_t("Set kanban state as %s",label),()=>{this.updateRecord(value);},{category:"smart_action",hotkey:hotkeys[index]&&"alt+"+hotkeys[index],isAvailable:()=>this.props.record.data[this.props.name]!==value,});}}}
get options(){return this.props.record.fields[this.props.name].selection.map(([state,label])=>{return[state,this.props.record.data[`legend_${state}`]||label];});}
get currentValue(){return this.props.record.data[this.props.name]||this.options[0][0];}
get label(){if(this.props.record.data[this.props.name]&&this.props.record.data[`legend_${this.props.record.data[this.props.name][0]}`]){return this.props.record.data[`legend_${this.props.record.data[this.props.name][0]}`];}
return formatSelection(this.currentValue,{selection:this.options});}
statusColor(value){return this.colors[value]?this.colorPrefix+this.colors[value]:"";}
async updateRecord(value){await this.props.record.update({[this.props.name]:value},{save:this.props.autosave});}}
const stateSelectionField=__exports.stateSelectionField={component:StateSelectionField,displayName:_t("Label Selection"),supportedOptions:[{label:_t("Autosave"),name:"autosave",type:"boolean",default:true,help:_t("If checked, the record will be saved immediately when the field is modified."),},{label:_t("Hide label"),name:"hide_label",type:"boolean",},],supportedTypes:["selection"],extractProps({options,viewType},dynamicInfo){return{showLabel:'hide_label'in options?!options.hide_label:false,withCommand:viewType==="form",readonly:dynamicInfo.readonly,autosave:"autosave"in options?!!options.autosave:true,};},};registry.category("fields").add("state_selection",stateSelectionField);return __exports;});;

/* /web/static/src/views/fields/statusbar/statusbar_field.js */
odoo.define('@web/views/fields/statusbar/statusbar_field',['@odoo/owl','@web/core/browser/browser','@web/core/commands/command_hook','@web/core/domain','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/l10n/translation','@web/core/registry','@web/core/utils/arrays','@web/core/utils/strings','@web/core/utils/timing','@web/model/relational_model/utils','@web/views/fields/relational_utils','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{Component,onWillRender,useEffect,useExternalListener,useRef}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{useCommand}=require("@web/core/commands/command_hook");const{Domain}=require("@web/core/domain");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{groupBy}=require("@web/core/utils/arrays");const{escape}=require("@web/core/utils/strings");const{throttleForAnimation}=require("@web/core/utils/timing");const{getFieldDomain}=require("@web/model/relational_model/utils");const{useSpecialData}=require("@web/views/fields/relational_utils");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const hide=(...els)=>els.forEach((el)=>el.classList.add("d-none"));const show=(...els)=>els.forEach((el)=>el.classList.remove("d-none"));const StatusBarField=__exports.StatusBarField=class StatusBarField extends Component{static template="web.StatusBarField";static components={Dropdown,DropdownItem,};static props={...standardFieldProps,domain:{type:[Array,Function],optional:true},foldField:{type:String,optional:true},isDisabled:{type:Boolean,optional:true},visibleSelection:{type:Array,element:String,optional:true},withCommand:{type:Boolean,optional:true},};setup(){this.items={};this.beforeRef=useRef("before");this.rootRef=useRef("root");this.afterRef=useRef("after");this.dropdownRef=useRef("dropdown");let status="idle";const adjust=()=>{status="adjusting";this.adjustVisibleItems();this.render();browser.requestAnimationFrame(()=>(status="idle"));};useEffect(()=>status==="shouldAdjust"&&adjust(),()=>[status]);onWillRender(()=>{if(status!=="adjusting"){Object.assign(this.items,this.getSortedItems());status="shouldAdjust";}});useExternalListener(window,"resize",throttleForAnimation(adjust));if(this.field.type==="many2one"){this.specialData=useSpecialData((orm,props)=>{const{foldField,name:fieldName,record}=props;const{relation}=record.fields[fieldName];const fieldNames=["display_name"];if(foldField){fieldNames.push(foldField);}
const value=record.data[fieldName];let domain=getFieldDomain(record,fieldName,props.domain);if(domain.length&&value){domain=Domain.or([[["id","=",value[0]]],domain]).toList(record.evalContext);}
return orm.searchRead(relation,domain,fieldNames);});}
if(this.props.withCommand){const moveToCommandName=_t("Move to %s...",escape(this.field.string));useCommand(moveToCommandName,()=>({placeholder:moveToCommandName,providers:[{provide:()=>this.getAllItems().map((item)=>({name:item.label,action:()=>this.selectItem(item),})),},],}),{category:"smart_action",hotkey:"alt+shift+x",isAvailable:()=>!this.props.isDisabled,});useCommand(_t("Move to next %s",this.field.string),()=>{const items=this.getAllItems();const nextIndex=items.findIndex((item)=>item.isSelected)+1;this.selectItem(items[nextIndex]);},{category:"smart_action",hotkey:"alt+x",isAvailable:()=>!this.props.isDisabled&&!this.getAllItems().at(-1).isSelected,});}}
get field(){return this.props.record.fields[this.props.name];}
adjustVisibleItems(){const itemEls=[...this.rootRef.el.querySelectorAll(".o_arrow_button:not(.dropdown-toggle)"),];const selectedIndex=itemEls.findIndex((el)=>el.classList.contains("o_arrow_button_current"));const itemsBefore=itemEls.slice(selectedIndex+2).reverse();const itemsAfter=itemEls.slice(0,Math.max(selectedIndex-1,0)).reverse();show(...itemEls);hide(this.dropdownRef.el,this.beforeRef.el);if(this.items.folded.length){show(this.afterRef.el);itemEls.forEach((el)=>el.classList.remove("o_first"));}else{hide(this.afterRef.el);itemEls[0]?.classList.add("o_first");}
this.items.before=[];this.items.after=[...this.items.folded];const itemsToAssign=this.getAllItems().filter((item)=>!item.isFolded);while(this.areItemsWrapping()){if(itemsBefore.length){show(this.beforeRef.el);hide(itemsBefore.shift());this.items.before.push(itemsToAssign.shift());}else if(itemsAfter.length){show(this.afterRef.el);hide(itemsAfter.pop());this.items.after.unshift(itemsToAssign.pop());}else{show(this.dropdownRef.el);hide(this.beforeRef.el,this.afterRef.el,...itemEls);break;}}}
areItemsWrapping(){const root=this.rootRef.el;const firstItem=root.querySelector(":scope > :not(.d-none)");if(!firstItem){return false;}
const{height:currentHeight}=root.getBoundingClientRect();const{height:targetHeight}=firstItem.getBoundingClientRect();return currentHeight>targetHeight;}
getAllItems(){const{foldField,name,record}=this.props;const currentValue=record.data[name];if(this.field.type==="many2one"){return this.specialData.data.map((option)=>({value:option.id,label:option.display_name,isFolded:option[foldField],isSelected:Boolean(currentValue&&option.id===currentValue[0]),}));}else{let{selection}=this.field;const{visibleSelection}=this.props;if(visibleSelection?.length){selection=selection.filter(([value])=>value===currentValue||visibleSelection.includes(value));}
return selection.map(([value,label])=>({value,label,isFolded:false,isSelected:value===currentValue,}));}}
getCurrentLabel(){return this.getAllItems().find((item)=>item.isSelected)?.label||_t("More");}
getDropdownItemClassNames(item){const classNames=[];if(item.isSelected){classNames.push("active");}
if(item.isSelected||this.props.isDisabled){classNames.push("disabled");}
return classNames.join(" ");}
getItemTooltip(item){if(item.isSelected){return _t("Current state");}
if(this.props.isDisabled){return _t("Not active state");}
return _t("Not active state, click to change it");}
getSortedItems(){const before=[];const after=[];const{true:inline=[],false:folded=[]}=groupBy(this.getAllItems(),(item)=>item.isSelected||!item.isFolded);inline.reverse();after.push(...folded);return{inline,before,after,folded};}
async selectItem(item){const{name,record}=this.props;const value=this.field.type==="many2one"?[item.value,item.label]:item.value;await record.update({[name]:value});await record.save();}
onDropdownItemSelected(ev){this.selectItem(ev.detail.payload);}}
const statusBarField=__exports.statusBarField={component:StatusBarField,displayName:_t("Status"),supportedOptions:[{label:_t("Clickable"),name:"clickable",type:"boolean",default:true,},{label:_t("Fold field"),name:"fold_field",type:"field",availableTypes:["boolean"],help:_t("Boolean field from the model used in the relation, which indicates whether the state is folded or not."),},],supportedTypes:["many2one","selection"],isEmpty:(record,fieldName)=>!record.data[fieldName],extractProps:({attrs,options,viewType},dynamicInfo)=>({isDisabled:!options.clickable||dynamicInfo.readonly,visibleSelection:attrs.statusbar_visible?.trim().split(/\s*,\s*/g),withCommand:viewType==="form",foldField:options.fold_field,domain:dynamicInfo.domain,}),};registry.category("fields").add("statusbar",statusBarField);return __exports;});;

/* /web/static/src/views/fields/text/text_field.js */
odoo.define('@web/views/fields/text/text_field',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/autoresize','@web/core/utils/hooks','@web/views/fields/dynamic_placeholder_hook','@web/views/fields/input_field_hook','@web/views/fields/parsers','@web/views/fields/standard_field_props','@web/views/fields/translation_button','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useAutoresize}=require("@web/core/utils/autoresize");const{useSpellCheck}=require("@web/core/utils/hooks");const{useDynamicPlaceholder}=require("@web/views/fields/dynamic_placeholder_hook");const{useInputField}=require("@web/views/fields/input_field_hook");const{parseInteger}=require("@web/views/fields/parsers");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{TranslationButton}=require("@web/views/fields/translation_button");const{Component,useExternalListener,useEffect,useRef}=require("@odoo/owl");const TextField=__exports.TextField=class TextField extends Component{static template="web.TextField";static components={TranslationButton,};static props={...standardFieldProps,lineBreaks:{type:Boolean,optional:true},placeholder:{type:String,optional:true},dynamicPlaceholder:{type:Boolean,optional:true},dynamicPlaceholderModelReferenceField:{type:String,optional:true},rowCount:{type:Number,optional:true},};static defaultProps={lineBreaks:true,dynamicPlaceholder:false,rowCount:2,};setup(){this.divRef=useRef("div");this.textareaRef=useRef("textarea");if(this.props.dynamicPlaceholder){this.dynamicPlaceholder=useDynamicPlaceholder(this.textareaRef);useExternalListener(document,"keydown",this.dynamicPlaceholder.onKeydown);useEffect(()=>this.dynamicPlaceholder.updateModel(this.props.dynamicPlaceholderModelReferenceField));}
useInputField({getValue:()=>this.props.record.data[this.props.name]||"",refName:"textarea",preventLineBreaks:!this.props.lineBreaks,});useSpellCheck({refName:"textarea"});useAutoresize(this.textareaRef,{minimumHeight:this.minimumHeight});this.selectionStart=this.props.record.data[this.props.name]?.length||0;}
async onBlur(){this.selectionStart=this.textareaRef.el.selectionStart;}
async onDynamicPlaceholderOpen(){await this.dynamicPlaceholder.open({validateCallback:this.onDynamicPlaceholderValidate.bind(this),});}
get isTranslatable(){return this.props.record.fields[this.props.name].translate;}
get minimumHeight(){return this.props.lineBreaks?50:0;}
get rowCount(){return this.props.lineBreaks?this.props.rowCount:1;}
async onDynamicPlaceholderValidate(chain,defaultValue){if(chain){this.textareaRef.el.focus();const dynamicPlaceholder=` {{object.${chain}${
                defaultValue?.length ? `|||${defaultValue}` : ""
            }}}`;this.textareaRef.el.setRangeText(dynamicPlaceholder,this.selectionStart,this.selectionStart,"end");this.textareaRef.el.dispatchEvent(new InputEvent("input"));this.textareaRef.el.dispatchEvent(new KeyboardEvent("keydown"));this.textareaRef.el.focus();}}}
const textField=__exports.textField={component:TextField,displayName:_t("Multiline Text"),supportedOptions:[{label:_t("Enable line breaks"),name:"line_breaks",type:"boolean",default:true,},],supportedTypes:["html","text"],extractProps:({attrs,options})=>({placeholder:attrs.placeholder,dynamicPlaceholder:options?.dynamic_placeholder||false,dynamicPlaceholderModelReferenceField:options?.dynamic_placeholder_model_reference_field||"",rowCount:attrs.rows&&parseInteger(attrs.rows),lineBreaks:options?.line_breaks!==undefined?Boolean(options.line_breaks):true,}),};registry.category("fields").add("text",textField);const ListTextField=__exports.ListTextField=class ListTextField extends TextField{static defaultProps={...super.defaultProps,rowCount:1,};get minimumHeight(){return 0;}
get rowCount(){return this.props.rowCount;}}
const listTextField=__exports.listTextField={...textField,component:ListTextField,};registry.category("fields").add("list.text",listTextField);return __exports;});;

/* /web/static/src/views/fields/timezone_mismatch/timezone_mismatch_field.js */
odoo.define('@web/views/fields/timezone_mismatch/timezone_mismatch_field',['@web/core/l10n/dates','@web/core/l10n/translation','@web/core/registry','@web/views/fields/selection/selection_field'],function(require){'use strict';let __exports={};const{formatDateTime}=require("@web/core/l10n/dates");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{selectionField,SelectionField}=require("@web/views/fields/selection/selection_field");const{DateTime}=luxon;const TimezoneMismatchField=__exports.TimezoneMismatchField=class TimezoneMismatchField extends SelectionField{static template="web.TimezoneMismatchField";static props={...super.props,tzOffsetField:{type:String,optional:true},mismatchTitle:{type:String,optional:true},};static defaultProps={...super.defaultProps,tzOffsetField:"tz_offset",mismatchTitle:_t("Timezone Mismatch : This timezone is different from that of your browser.\nPlease, set the same timezone as your browser's to avoid time discrepancies in your system."),};get mismatch(){const userOffset=this.props.record.data[this.props.tzOffsetField];if(userOffset&&this.props.record.data[this.props.name]){const offset=-new Date().getTimezoneOffset();let browserOffset=offset<0?"-":"+";browserOffset+=Math.abs(offset/60).toFixed(0).padStart(2,"0");browserOffset+=Math.abs(offset%60).toFixed(0).padStart(2,"0");return browserOffset!==userOffset;}else if(!this.props.record.data[this.props.name]){return true;}
return false;}
get mismatchTitle(){if(!this.props.record.data[this.props.name]){return _t("Set a timezone on your user");}
return this.props.mismatchTitle;}
get options(){if(!this.mismatch){return super.options;}
return super.options.map((option)=>{const[value,label]=option;if(value===this.props.record.data[this.props.name]){const offset=this.props.record.data[this.props.tzOffsetField].match(/([+-])([0-9]{2})([0-9]{2})/);const sign=offset[1]==="-"?-1:1;const userOffset=sign*(parseInt(offset[2])*60+parseInt(offset[3]));const browserOffset=-new Date().getTimezoneOffset();const userUTCDatetime=DateTime.utc().plus({minutes:userOffset-browserOffset,});return[value,`${label} (${formatDateTime(userUTCDatetime)})`];}
return[value,label];});}}
const timezoneMismatchField=__exports.timezoneMismatchField={...selectionField,component:TimezoneMismatchField,additionalClasses:["d-flex"],supportedOptions:[...(selectionField.supportedOptions||[]),{label:_t("Mismatch title"),name:"mismatch_title",type:"string",},{label:_t("Timezone offset field"),name:"tz_offset_field",type:"field",availableTypes:["char"],},],extractProps({options}){const props=selectionField.extractProps(...arguments);props.tzOffsetField=options.tz_offset_field;props.mismatchTitle=options.mismatch_title;return props;},};registry.category("fields").add("timezone_mismatch",timezoneMismatchField);return __exports;});;

/* /web/static/src/views/fields/translation_button.js */
odoo.define('@web/views/fields/translation_button',['@web/core/l10n/localization','@web/core/utils/hooks','@web/core/user','@web/views/fields/translation_dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{localization}=require("@web/core/l10n/localization");const{useOwnedDialogs}=require("@web/core/utils/hooks");const{user}=require("@web/core/user");const{TranslationDialog}=require("@web/views/fields/translation_dialog");const{Component}=require("@odoo/owl");__exports.useTranslationDialog=useTranslationDialog;function useTranslationDialog(){const addDialog=useOwnedDialogs();async function openTranslationDialog({record,fieldName}){const saved=await record.save();if(!saved){return;}
const{resModel,resId}=record;addDialog(TranslationDialog,{fieldName:fieldName,resId:resId,resModel:resModel,userLanguageValue:record.data[fieldName]||"",isComingFromTranslationAlert:false,onSave:async()=>{await record.load();},});}
return openTranslationDialog;}
const TranslationButton=__exports.TranslationButton=class TranslationButton extends Component{static template="web.TranslationButton";static props={fieldName:{type:String},record:{type:Object},};setup(){this.translationDialog=useTranslationDialog();}
get isMultiLang(){return localization.multiLang;}
get lang(){return new Intl.Locale(user.lang).language.toUpperCase();}
onClick(){const{fieldName,record}=this.props;this.translationDialog({fieldName,record});}}
return __exports;});;

/* /web/static/src/views/fields/translation_dialog.js */
odoo.define('@web/views/fields/translation_dialog',['@web/core/dialog/dialog','@web/core/user','@web/core/utils/hooks','@web/core/l10n/translation','@web/core/l10n/utils','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{loadLanguages,_t}=require("@web/core/l10n/translation");const{jsToPyLocale}=require("@web/core/l10n/utils");const{Component,onWillStart}=require("@odoo/owl");const TranslationDialog=__exports.TranslationDialog=class TranslationDialog extends Component{static template="web.TranslationDialog";static components={Dialog};static props={fieldName:String,resId:Number,resModel:String,userLanguageValue:{type:String,optional:true},isComingFromTranslationAlert:{type:Boolean,optional:true},onSave:Function,close:Function,isText:{type:Boolean,optional:true},showSource:{type:Boolean,optional:true},};setup(){super.setup();this.title=_t("Translate: %s",this.props.fieldName);this.user=user;this.orm=useService("orm");this.terms=[];this.updatedTerms={};onWillStart(async()=>{const languages=await loadLanguages(this.orm);const[translations,context]=await this.loadTranslations(languages);let id=1;translations.forEach((t)=>(t.id=id++));this.props.isText=context.translation_type==="text";this.props.showSource=context.translation_show_source;this.terms=translations.map((term)=>{const relatedLanguage=languages.find((l)=>l[0]===term.lang);const termInfo={...term,langName:relatedLanguage[1],value:term.value||"",};if(term.lang===jsToPyLocale(user.lang)&&!this.props.showSource&&!this.props.isComingFromTranslationAlert){this.updatedTerms[term.id]=this.props.userLanguageValue;termInfo.value=this.props.userLanguageValue;}
return termInfo;});this.terms.sort((a,b)=>a.langName.localeCompare(b.langName));});}
get domain(){const domain=this.props.domain;if(this.props.searchName){domain.push(["name","=",`${this.props.searchName}`]);}
return domain;}
async loadTranslations(languages){return this.orm.call(this.props.resModel,"get_field_translations",[[this.props.resId],this.props.fieldName,]);}
async onSave(){const translations={};this.terms.map((term)=>{const updatedTermValue=this.updatedTerms[term.id];if(term.id in this.updatedTerms&&term.value!==updatedTermValue){if(this.props.showSource){if(!translations[term.lang]){translations[term.lang]={};}
translations[term.lang][term.source]=updatedTermValue||term.source;}else{translations[term.lang]=updatedTermValue||false;}}});await this.orm.call(this.props.resModel,"update_field_translations",[[this.props.resId],this.props.fieldName,translations,]);await this.props.onSave();this.props.close();}}
return __exports;});;

/* /web/static/src/views/fields/url/url_field.js */
odoo.define('@web/views/fields/url/url_field',['@web/core/registry','@web/core/l10n/translation','@web/views/fields/input_field_hook','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{useInputField}=require("@web/views/fields/input_field_hook");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const UrlField=__exports.UrlField=class UrlField extends Component{static template="web.UrlField";static props={...standardFieldProps,placeholder:{type:String,optional:true},text:{type:String,optional:true},websitePath:{type:Boolean,optional:true},};setup(){useInputField({getValue:()=>this.value});}
get value(){return this.props.record.data[this.props.name]||"";}
get formattedHref(){let value=this.props.record.data[this.props.name];if(value&&!this.props.websitePath){const regex=/^((ftp|http)s?:\/)?\//i;value=!regex.test(value)?`http://${value}`:value;}
return value;}}
const urlField=__exports.urlField={component:UrlField,displayName:_t("URL"),supportedOptions:[{label:_t("Is a website path"),name:"website_path",type:"boolean",help:_t("If True, the url will be used as it is, without any prefix added to it."),},],supportedTypes:["char"],extractProps:({attrs,options})=>({text:attrs.text,websitePath:options.website_path,placeholder:attrs.placeholder,}),};registry.category("fields").add("url",urlField);class FormUrlField extends UrlField{static template="web.FormUrlField";}
const formUrlField=__exports.formUrlField={...urlField,component:FormUrlField,};registry.category("fields").add("form.url",formUrlField);return __exports;});;

/* /web/static/src/views/fields/x2many/list_x2many_field.js */
odoo.define('@web/views/fields/x2many/list_x2many_field',['@web/core/registry','@web/views/fields/formatters','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formatX2many}=require("@web/views/fields/formatters");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const ListX2ManyField=__exports.ListX2ManyField=class ListX2ManyField extends Component{static template="web.ListX2ManyField";static props={...standardFieldProps};get formattedValue(){return formatX2many(this.props.record.data[this.props.name]);}}
const listX2ManyField=__exports.listX2ManyField={component:ListX2ManyField,useSubView:false,};registry.category("fields").add("list.one2many",listX2ManyField);registry.category("fields").add("list.many2many",listX2ManyField);return __exports;});;

/* /web/static/src/views/fields/x2many/x2many_field.js */
odoo.define('@web/views/fields/x2many/x2many_field',['@web/core/context','@web/core/l10n/translation','@web/core/pager/pager','@web/core/registry','@web/core/utils/hooks','@web/model/relational_model/utils','@web/views/fields/relational_utils','@web/views/fields/standard_field_props','@web/views/kanban/kanban_renderer','@web/views/list/list_renderer','@web/views/utils','@web/views/view_button/view_button','@odoo/owl'],function(require){'use strict';let __exports={};const{makeContext}=require("@web/core/context");const{_t}=require("@web/core/l10n/translation");const{Pager}=require("@web/core/pager/pager");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{getFieldDomain}=require("@web/model/relational_model/utils");const{useActiveActions,useAddInlineRecord,useOpenX2ManyRecord,useSelectCreate,useX2ManyCrud,}=require("@web/views/fields/relational_utils");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{ListRenderer}=require("@web/views/list/list_renderer");const{computeViewClassName}=require("@web/views/utils");const{ViewButton}=require("@web/views/view_button/view_button");const{Component}=require("@odoo/owl");const X2ManyField=__exports.X2ManyField=class X2ManyField extends Component{static template="web.X2ManyField";static components={Pager,KanbanRenderer,ListRenderer,ViewButton};static props={...standardFieldProps,addLabel:{type:String,optional:true},editable:{type:String,optional:true},viewMode:{type:String,optional:true},widget:{type:String,optional:true},crudOptions:{type:Object,optional:true},string:{type:String,optional:true},relatedFields:{type:Object,optional:true},views:{type:Object,optional:true},domain:{type:[Array,Function],optional:true},context:{type:Object},};setup(){this.field=this.props.record.fields[this.props.name];const{saveRecord,updateRecord,removeRecord}=useX2ManyCrud(()=>this.list,this.isMany2Many);this.archInfo=this.props.views?.[this.props.viewMode]||{};const classes=this.props.viewMode?["o_field_x2many",`o_field_x2many_${this.props.viewMode}`]:["o_field_x2many"];this.className=computeViewClassName(this.props.viewMode,this.archInfo.xmlDoc,classes);const{activeActions,creates}=this.archInfo;if(this.props.viewMode==="kanban"){this.creates=creates.length?creates:[{type:"create",string:this.props.addLabel||_t("Add"),class:"o-kanban-button-new",},];}
const subViewActiveActions=activeActions;this.activeActions=useActiveActions({crudOptions:Object.assign({},this.props.crudOptions,{onDelete:removeRecord,edit:this.props.record.isInEdition,}),fieldType:this.isMany2Many?"many2many":"one2many",subViewActiveActions,getEvalParams:(props)=>{return{evalContext:props.record.evalContext,readonly:props.readonly,};},});this.addInLine=useAddInlineRecord({addNew:(...args)=>this.list.addNewRecord(...args),});const openRecord=useOpenX2ManyRecord({resModel:this.list.resModel,activeField:this.activeField,activeActions:this.activeActions,getList:()=>this.list,saveRecord,updateRecord,isMany2Many:this.isMany2Many,});this._openRecord=(params)=>{const activeElement=document.activeElement;openRecord({...params,onClose:()=>{if(activeElement){activeElement.focus();}},});};this.canOpenRecord=this.props.viewMode==="list"?!(this.archInfo.editable||this.props.editable):true;const selectCreate=useSelectCreate({resModel:this.props.record.data[this.props.name].resModel,activeActions:this.activeActions,onSelected:(resIds)=>saveRecord(resIds),onCreateEdit:({context})=>this._openRecord({context}),onUnselect:this.isMany2Many?undefined:()=>saveRecord(),});this.selectCreate=(params)=>{const p=Object.assign({},params);const currentIds=this.props.record.data[this.props.name].currentIds.filter((id)=>typeof id==="number");p.domain=[...(p.domain||[]),"!",["id","in",currentIds]];return selectCreate(p);};this.action=useService("action");}
get activeField(){return{fields:this.props.relatedFields,views:this.props.views,viewMode:this.props.viewMode,string:this.props.string,};}
get displayControlPanelButtons(){return(this.props.viewMode==="kanban"&&("link"in this.activeActions?this.activeActions.link:this.activeActions.create)&&!this.props.readonly);}
get isMany2Many(){return this.field.type==="many2many"||this.props.widget==="many2many";}
get list(){return this.props.record.data[this.props.name];}
get nestedKeyOptionalFieldsData(){return{field:this.props.name,model:this.props.record.resModel,viewMode:"form",};}
get pagerProps(){const list=this.list;return{offset:list.offset,limit:list.limit,total:list.count,onUpdate:async({offset,limit})=>{const initialLimit=this.list.limit;const leaved=await list.leaveEditMode();if(leaved){if(initialLimit===limit&&initialLimit===this.list.limit+1){offset-=1;limit-=1;}
await list.load({limit,offset});this.render();}},withAccessKey:false,};}
get rendererProps(){const{archInfo}=this;const props={archInfo,list:this.list,openRecord:this.openRecord.bind(this),};if(this.props.viewMode==="kanban"){const recordsDraggable=!this.props.readonly&&archInfo.recordsDraggable;props.archInfo={...archInfo,recordsDraggable};props.readonly=this.props.readonly;props.deleteRecord=(record)=>{if(this.isMany2Many){return this.list.forget(record);}
return this.list.delete(record);};return props;}
const editable=(this.archInfo.activeActions.edit&&archInfo.editable)||this.props.editable;props.activeActions=this.activeActions;props.cycleOnTab=false;props.editable=!this.props.readonly&&editable;props.nestedKeyOptionalFieldsData=this.nestedKeyOptionalFieldsData;props.onAdd=(params)=>{params.editable=!this.props.readonly&&("editable"in params?params.editable:editable);this.onAdd(params);};props.onOpenFormView=this.switchToForm.bind(this);props.hasOpenFormViewButton=archInfo.editable?archInfo.openFormView:false;return props;}
async switchToForm(record){await this.props.record.save();this.action.doAction({type:"ir.actions.act_window",views:[[false,"form"]],res_id:record.resId,res_model:this.list.resModel,},{props:{resIds:this.list.resIds},});}
async onAdd({context,editable}={}){context=makeContext([this.props.context,context]);if(this.isMany2Many){const domain=getFieldDomain(this.props.record,this.props.name,this.props.domain);const{string}=this.props;const title=_t("Add: %s",string);return this.selectCreate({domain,context,title});}
if(editable){const editedRecord=this.list.editedRecord;if(editedRecord){const proms=[];this.list.model.bus.trigger("NEED_LOCAL_CHANGES",{proms});await Promise.all([...proms,editedRecord._updatePromise]);await this.list.leaveEditMode({canAbandon:false});}
if(!this.list.editedRecord){return this.addInLine({context,editable});}
return;}
return this._openRecord({context});}
async openRecord(record){if(this.canOpenRecord){return this._openRecord({record,context:this.props.context,mode:this.props.readonly?"readonly":"edit",});}}}
const x2ManyField=__exports.x2ManyField={component:X2ManyField,displayName:_t("Relational table"),supportedTypes:["one2many","many2many"],useSubView:true,extractProps:({attrs,relatedFields,viewMode,views,widget,options,string},dynamicInfo)=>{const props={addLabel:attrs["add-label"],context:dynamicInfo.context,domain:dynamicInfo.domain,crudOptions:options,string,};if(viewMode){props.views=views;props.viewMode=viewMode;props.relatedFields=relatedFields;}
if(widget){props.widget=widget;}
return props;},};registry.category("fields").add("one2many",x2ManyField);registry.category("fields").add("many2many",x2ManyField);return __exports;});;

/* /web/static/src/views/form/button_box/button_box.js */
odoo.define('@web/views/form/button_box/button_box',['@web/core/utils/hooks','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{Component,onWillRender}=require("@odoo/owl");const ButtonBox=__exports.ButtonBox=class ButtonBox extends Component{static template="web.Form.ButtonBox";static components={Dropdown,DropdownItem};static props={slots:Object,class:{type:String,optional:true},};static defaultProps={class:"",};setup(){const ui=useService("ui");onWillRender(()=>{const maxVisibleButtons=[0,0,0,7,4,5,8][ui.size]??8;const allVisibleButtons=Object.entries(this.props.slots).filter(([_,slot])=>this.isSlotVisible(slot)).map(([slotName])=>slotName);if(allVisibleButtons.length<=maxVisibleButtons){this.visibleButtons=allVisibleButtons;this.additionalButtons=[];this.isFull=allVisibleButtons.length===maxVisibleButtons;}else{const splitIndex=Math.max(maxVisibleButtons-1,0);this.visibleButtons=allVisibleButtons.slice(0,splitIndex);this.additionalButtons=allVisibleButtons.slice(splitIndex);this.isFull=true;}});}
isSlotVisible(slot){return!("isVisible"in slot)||slot.isVisible;}}
return __exports;});;

/* /web/static/src/views/form/form_arch_parser.js */
odoo.define('@web/views/form/form_arch_parser',['@web/core/utils/strings','@web/core/utils/xml','@web/views/fields/field','@web/views/utils','@web/views/widgets/widget'],function(require){'use strict';let __exports={};const{exprToBoolean}=require("@web/core/utils/strings");const{visitXML}=require("@web/core/utils/xml");const{Field}=require("@web/views/fields/field");const{getActiveActions}=require("@web/views/utils");const{Widget}=require("@web/views/widgets/widget");const FormArchParser=__exports.FormArchParser=class FormArchParser{parse(xmlDoc,models,modelName){const jsClass=xmlDoc.getAttribute("js_class");const disableAutofocus=exprToBoolean(xmlDoc.getAttribute("disable_autofocus")||"");const activeActions=getActiveActions(xmlDoc);const fieldNodes={};const widgetNodes={};let widgetNextId=0;const fieldNextIds={};let autofocusFieldId=null;visitXML(xmlDoc,(node)=>{if(node.tagName==="field"){const fieldInfo=Field.parseFieldNode(node,models,modelName,"form",jsClass);if(!(fieldInfo.name in fieldNextIds)){fieldNextIds[fieldInfo.name]=0;}
const fieldId=`${fieldInfo.name}_${fieldNextIds[fieldInfo.name]++}`;fieldNodes[fieldId]=fieldInfo;node.setAttribute("field_id",fieldId);if(exprToBoolean(node.getAttribute("default_focus")||"")){autofocusFieldId=fieldId;}
if(fieldInfo.type==="properties"){activeActions.addPropertyFieldValue=true;}
return false;}else if(node.tagName==="widget"){const widgetInfo=Widget.parseWidgetNode(node);const widgetId=`widget_${++widgetNextId}`;widgetNodes[widgetId]=widgetInfo;node.setAttribute("widget_id",widgetId);}});return{activeActions,autofocusFieldId,disableAutofocus,fieldNodes,widgetNodes,xmlDoc,};}}
return __exports;});;

/* /web/static/src/views/form/form_cog_menu/form_cog_menu.js */
odoo.define('@web/views/form/form_cog_menu/form_cog_menu',['@web/search/cog_menu/cog_menu','@web/views/form/status_bar_dropdown_items/status_bar_dropdown_items'],function(require){'use strict';let __exports={};const{CogMenu}=require("@web/search/cog_menu/cog_menu");const{StatusBarDropdownItems}=require("@web/views/form/status_bar_dropdown_items/status_bar_dropdown_items");const FormCogMenu=__exports.FormCogMenu=class FormCogMenu extends CogMenu{static template="web.FormCogMenu";static components={...CogMenu.components,StatusBarDropdownItems,};static props={...CogMenu.props,slots:{type:Object,optional:true},};}
return __exports;});;

/* /web/static/src/views/form/form_compiler.js */
odoo.define('@web/views/form/form_compiler',['@web/core/registry','@web/core/ui/ui_service','@web/core/utils/xml','@web/views/utils','@web/views/view_compiler','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{SIZES}=require("@web/core/ui/ui_service");const{append,combineAttributes,createElement,createTextNode,getTag,}=require("@web/core/utils/xml");const{toStringExpression}=require("@web/views/utils");const{copyAttributes,getModifier,isComponentNode,isTextNode,makeSeparator,}=require("@web/views/view_compiler");const{ViewCompiler}=require("@web/views/view_compiler");const{exprToBoolean}=require("@web/core/utils/strings");const compilersRegistry=registry.category("form_compilers");function appendAttf(el,attr,string){const attrKey=`t-attf-${attr}`;const attrVal=el.getAttribute(attrKey);el.setAttribute(attrKey,appendToExpr(attrVal,string));}
function appendToExpr(expr,string){const re=/{{.*}}/;const oldString=re.exec(expr);return oldString?`${oldString} {{${string} }}`:`{{${string} }}`;}
__exports.objectToString=objectToString;function objectToString(obj){return`{${Object.entries(obj)
        .map((t) => t.join(":"))
        .join(",")}}`;}
const FormCompiler=__exports.FormCompiler=class FormCompiler extends ViewCompiler{setup(){this.encounteredFields={};this.labels={};this.noteBookId=0;this.compilers.push(...compilersRegistry.getAll(),{selector:"div[name='button_box']",fn:this.compileButtonBox},{selector:"footer",fn:this.compileFooter},{selector:"form",fn:this.compileForm,doNotCopyAttributes:true},{selector:"group",fn:this.compileGroup},{selector:"header",fn:this.compileHeader},{selector:"label",fn:this.compileLabel,doNotCopyAttributes:true},{selector:"notebook",fn:this.compileNotebook},{selector:"setting",fn:this.compileSetting},{selector:"separator",fn:this.compileSeparator},{selector:"sheet",fn:this.compileSheet});}
compile(key,params={}){const compiled=super.compile(...arguments);if(!params.isSubView){compiled.children[0].setAttribute("t-ref","compiled_view_root");}
return compiled;}
createLabelFromField(fieldId,fieldName,fieldString,label,params){let labelText=label.textContent||fieldString;if(label.hasAttribute("data-no-label")){labelText=toStringExpression("");}else{labelText=labelText?toStringExpression(labelText):`__comp__.props.record.fields['${fieldName}'].string`;}
const formLabel=createElement("FormLabel",{id:`'${fieldId}'`,fieldName:`'${fieldName}'`,record:`__comp__.props.record`,fieldInfo:`__comp__.props.archInfo.fieldNodes['${fieldId}']`,className:`"${label.className}"`,string:labelText,});const condition=label.getAttribute("t-if");if(condition){formLabel.setAttribute("t-if",condition);}
return formLabel;}
getLabels(fieldName){const labels=this.labels[fieldName]||[];this.labels[fieldName]=null;return labels;}
pushLabel(fieldName,label){this.labels[fieldName]=this.labels[fieldName]||[];this.labels[fieldName].push(label);}
compileButtonBox(el,params){if(!el.children.length){return this.compileGenericNode(el,params);}
el.classList.remove("oe_button_box");const buttonBox=createElement("ButtonBox");buttonBox.setAttribute("t-if","!__comp__.env.inDialog");let slotId=0;let hasContent=false;for(const child of el.children){const invisible=getModifier(child,"invisible");if(!params.compileInvisibleNodes&&(invisible==="True"||invisible==="1")){continue;}
hasContent=true;let isVisibleExpr;if(!invisible||invisible==="False"||invisible==="0"){isVisibleExpr="true";}else if(invisible==="True"||invisible==="1"){isVisibleExpr="false";}else{isVisibleExpr=`!__comp__.evaluateBooleanExpr(${JSON.stringify(
                    invisible
                )},__comp__.props.record.evalContextWithVirtualIds)`;}
const mainSlot=createElement("t",{"t-set-slot":`slot_${slotId++}`,isVisible:isVisibleExpr,});if(child.tagName==="button"||child.children.tagName==="button"){child.classList.add("oe_stat_button","btn","btn-outline-secondary","flex-grow-1","flex-lg-grow-0");}
if(child.tagName==="field"){child.classList.add("d-inline-block","mb-0","z-0");}
append(mainSlot,this.compileNode(child,params,false));append(buttonBox,mainSlot);}
return hasContent?buttonBox:"";}
compileButton(el,params){return super.compileButton(el,params);}
compileField(el,params){const field=super.compileField(el,params);const fieldName=el.getAttribute("name");const fieldString=el.getAttribute("string");const fieldId=el.getAttribute("field_id");const labelsForAttr=el.getAttribute("id")||fieldName;const labels=this.getLabels(labelsForAttr);const dynamicLabel=(label)=>{const formLabel=this.createLabelFromField(fieldId,fieldName,fieldString,label,{...params,currentFieldArchNode:el,});if(formLabel){label.replaceWith(formLabel);}else{label.remove();}
return formLabel;};for(const label of labels){dynamicLabel(label);}
this.encounteredFields[fieldName]=dynamicLabel;return field;}
compileForm(el,params){let sheetNode=null;for(const sheet of el.querySelectorAll("sheet")){if(sheet.closest("form")===el){sheetNode=sheet;break;}}
const displayClasses=sheetNode?`d-flex d-print-block {{ __comp__.uiService.size < ${SIZES.XXL} ? "flex-column" : "flex-nowrap h-100" }}`:"d-block";const stateClasses="{{ __comp__.props.record.dirty ? 'o_form_dirty' : !__comp__.props.record.isNew ? 'o_form_saved' : '' }}";const form=createElement("div",{class:"o_form_renderer","t-att-class":"__comp__.props.class","t-attf-class":`{{__comp__.props.record.isInEdition ? 'o_form_editable' : 'o_form_readonly'}} ${displayClasses} ${stateClasses}`,});if(!sheetNode){for(const child of el.childNodes){if(child.attributes?.name?.value!=="button_box"){append(form,this.compileNode(child,params));}}
form.classList.add("o_form_nosheet");}else{let compiledList=[];for(const child of el.childNodes){const compiled=this.compileNode(child,params);if(getTag(child,true)==="sheet"){append(form,compiled);compiled.prepend(...compiledList);compiledList=[];}else if(compiled){compiledList.push(compiled);}}
append(form,compiledList);}
return form;}
compileFooter(el,params){const footer=createElement("t");const replace=el.getAttribute("replace");if(replace&&!exprToBoolean(replace)){footer.append(createElement("t",{"t-call":"web.DefaultButtonsSlot","t-call-context":"{ props: __comp__.props }",}));}
copyAttributes(el,footer);for(const child of el.childNodes){const compiled=this.compileNode(child,params);if(compiled){footer.append(compiled);}}
return footer;}
compileGroup(el,params){const isOuterGroup=[...el.children].some((c)=>getTag(c,true)==="group");const formGroup=createElement(isOuterGroup?"OuterGroup":"InnerGroup");let slotId=0;let sequence=0;if(el.hasAttribute("col")){formGroup.setAttribute("maxCols",el.getAttribute("col"));}
if(el.hasAttribute("string")){const titleSlot=createElement("t",{"t-set-slot":"title"},[makeSeparator(el.getAttribute("string")),]);append(formGroup,titleSlot);}
let forceNewline=false;for(const child of el.children){if(getTag(child,true)==="newline"){forceNewline=true;continue;}
const invisible=getModifier(child,"invisible");if(!params.compileInvisibleNodes&&(invisible==="True"||invisible==="1")){continue;}
const mainSlot=createElement("t",{"t-set-slot":`item_${slotId++}`,type:"'item'",sequence:sequence++,"t-slot-scope":"scope",});let itemSpan=parseInt(child.getAttribute("colspan")||"1",10);if(forceNewline){mainSlot.setAttribute("newline",true);forceNewline=false;}
if(getTag(child,true)==="separator"){itemSpan=parseInt(formGroup.getAttribute("maxCols")||2,10);}
if(child.matches("div[class='clearfix']:empty")){itemSpan=parseInt(formGroup.getAttribute("maxCols")||2,10);}
let slotContent;if(getTag(child,true)==="field"){const addLabel=child.hasAttribute("nolabel")?child.getAttribute("nolabel")!=="1":true;slotContent=this.compileNode(child,{...params,currentSlot:mainSlot},false);if(slotContent&&addLabel&&!isOuterGroup&&!isTextNode(slotContent)){itemSpan=itemSpan===1?itemSpan+1:itemSpan;const fieldName=child.getAttribute("name");const fieldId=slotContent.getAttribute("id")||fieldName;const props={id:`${fieldId}`,fieldName:`'${fieldName}'`,record:`__comp__.props.record`,string:child.hasAttribute("string")?toStringExpression(child.getAttribute("string")):`__comp__.props.record.fields.${fieldName}.string`,fieldInfo:`__comp__.props.archInfo.fieldNodes[${fieldId}]`,};mainSlot.setAttribute("props",objectToString(props));mainSlot.setAttribute("Component","__comp__.constructor.components.FormLabel");mainSlot.setAttribute("subType","'item_component'");}}else{if(child.classList.contains("o_wrap_label")||child.classList.contains("o_td_label")||getTag(child,true)==="label"){mainSlot.setAttribute("subType","'label'");child.classList.remove("o_wrap_label");}
slotContent=this.compileNode(child,{...params,currentSlot:mainSlot},false);}
if(slotContent&&!isTextNode(slotContent)){let isVisibleExpr;if(!invisible||invisible==="False"||invisible==="0"){isVisibleExpr="true";}else if(invisible==="True"||invisible==="1"){isVisibleExpr="false";}else{isVisibleExpr=`!__comp__.evaluateBooleanExpr(${JSON.stringify(
                        invisible
                    )},__comp__.props.record.evalContextWithVirtualIds)`;}
mainSlot.setAttribute("isVisible",isVisibleExpr);if(itemSpan>0){mainSlot.setAttribute("itemSpan",`${itemSpan}`);}
const groupClassExpr=`scope && scope.className`;if(isComponentNode(slotContent)){if(getTag(slotContent)==="FormLabel"){mainSlot.prepend(createElement("t",{"t-set":"addClass","t-value":groupClassExpr,}));combineAttributes(slotContent,"className",`(addClass ? " " + addClass : "")`,`+`);}else if(getTag(child,true)!=="button"){if(slotContent.hasAttribute("class")){mainSlot.prepend(createElement("t",{"t-set":"addClass","t-value":groupClassExpr,}));combineAttributes(slotContent,"class",`(addClass ? " " + addClass : "")`,`+`);}else{slotContent.setAttribute("class",groupClassExpr);}}}else{appendAttf(slotContent,"class",`${groupClassExpr} || ""`);}
append(mainSlot,slotContent);append(formGroup,mainSlot);}}
return formGroup;}
compileHeader(el,params){const statusBar=createElement("div");statusBar.className="o_form_statusbar position-relative d-flex justify-content-between mb-0 mb-md-2 pb-2 pb-md-0";const buttons=[];const others=[];for(const child of el.childNodes){const compiled=this.compileNode(child,params);if(!compiled||isTextNode(compiled)){continue;}
if(getTag(child,true)==="field"&&!child.classList.contains("btn")){compiled.setAttribute("showTooltip",true);others.push(compiled);}else{if(compiled.tagName==="ViewButton"){compiled.setAttribute("defaultRank","'btn-secondary'");}
buttons.push(compiled);}}
let slotId=0;let statusBarButtons;if(params.asDropdownItems){statusBarButtons=createElement("StatusBarDropdownItems");}else{statusBarButtons=createElement("StatusBarButtons",{"t-if":"!__comp__.env.isSmall or __comp__.env.inDialog",});}
for(const button of buttons){const slot=createElement("t",{"t-set-slot":`button_${slotId++}`,isVisible:button.getAttribute("t-if")||true,});append(slot,button);append(statusBarButtons,slot);}
if(params.asDropdownItems){return statusBarButtons;}
append(statusBar,statusBarButtons);append(statusBar,others);return statusBar;}
compileLabel(el,params){const forAttr=el.getAttribute("for");if(forAttr){let label=createElement("label");copyAttributes(el,label);const string=el.getAttribute("string");if(string){append(label,createTextNode(string));}else if(string===""){label.setAttribute("data-no-label","true");}
if(this.encounteredFields[forAttr]){label=this.encounteredFields[forAttr](label);}else{this.pushLabel(forAttr,label);}
return label;}
const res=this.compileGenericNode(el,params);copyAttributes(el,res);return res;}
compileNotebook(el,params){const noteBookId=this.noteBookId++;const noteBook=createElement("Notebook");const pageAnchors=[];const noteBookAnchors={};if(el.hasAttribute("class")){noteBook.setAttribute("className",toStringExpression(el.getAttribute("class")));el.removeAttribute("class");}
noteBook.setAttribute("defaultPage",`__comp__.props.record.isNew ? undefined : __comp__.props.activeNotebookPages[${noteBookId}]`);noteBook.setAttribute("onPageUpdate",`(page) => __comp__.props.onNotebookPageChange(${noteBookId}, page)`);for(const child of el.children){if(getTag(child,true)!=="page"){continue;}
const invisible=getModifier(child,"invisible");if(!params.compileInvisibleNodes&&(invisible==="True"||invisible==="1")){continue;}
const pageSlot=createElement("t");append(noteBook,pageSlot);const pageId=`page_${this.id++}`;const pageTitle=toStringExpression(child.getAttribute("string")||child.getAttribute("name")||"");const pageNodeName=toStringExpression(child.getAttribute("name")||"");pageSlot.setAttribute("t-set-slot",pageId);pageSlot.setAttribute("title",pageTitle);pageSlot.setAttribute("name",pageNodeName);if(child.className){pageSlot.setAttribute("className",`"${child.className}"`);}
if(child.getAttribute("autofocus")==="autofocus"){noteBook.setAttribute("defaultPage",`__comp__.props.record.isNew ? "${pageId}" : (__comp__.props.activeNotebookPages[${noteBookId}] || "${pageId}")`);}
for(const anchor of child.querySelectorAll("[href^=\\#]")){const anchorValue=CSS.escape(anchor.getAttribute("href").substring(1));if(!anchorValue.length){continue;}
pageAnchors.push(anchorValue);noteBookAnchors[anchorValue]={origin:`'${pageId}'`,};}
let isVisibleExpr;if(!invisible||invisible==="False"||invisible==="0"){isVisibleExpr="true";}else if(invisible==="True"||invisible==="1"){isVisibleExpr="false";}else{isVisibleExpr=`!__comp__.evaluateBooleanExpr(${JSON.stringify(
                    invisible
                )},__comp__.props.record.evalContextWithVirtualIds)`;}
pageSlot.setAttribute("isVisible",isVisibleExpr);for(const contents of child.children){append(pageSlot,this.compileNode(contents,{...params,currentSlot:pageSlot}));}}
if(pageAnchors.length){for(const anchor of pageAnchors){let pageId=1;for(const child of el.children){if(child.querySelector(`#${anchor}`)){noteBookAnchors[anchor].target=`'page_${pageId}'`;noteBookAnchors[anchor]=objectToString(noteBookAnchors[anchor]);break;}
pageId++;}}
noteBook.setAttribute("anchors",objectToString(noteBookAnchors));}
return noteBook;}
compileSetting(el,params){const setting=createElement(params.componentName||"Setting",{title:toStringExpression(el.getAttribute("title")||""),help:toStringExpression(el.getAttribute("help")||""),companyDependent:el.getAttribute("company_dependent")==="1"||"false",documentation:toStringExpression(el.getAttribute("documentation")||""),record:`__comp__.props.record`,});if(el.getAttribute("id")){setting.setAttribute("id",toStringExpression(el.getAttribute("id")));}
let string=toStringExpression(el.getAttribute("string")||"");let addLabel=true;Array.from(el.children).forEach((child,index)=>{if(getTag(child,true)==="field"&&index===0){const fieldSlot=createElement("t",{"t-set-slot":"fieldSlot"});const field=this.compileNode(child,params);if(field){append(fieldSlot,field);setting.setAttribute("fieldInfo",field.getAttribute("fieldInfo"));addLabel=child.hasAttribute("nolabel")?child.getAttribute("nolabel")!=="1":true;const fieldName=child.getAttribute("name");string=child.hasAttribute("string")?toStringExpression(child.getAttribute("string")):string;setting.setAttribute("fieldName",toStringExpression(fieldName));setting.setAttribute("fieldId",toStringExpression(child.getAttribute("field_id")));}
append(setting,fieldSlot);}else{append(setting,this.compileNode(child,params));}});setting.setAttribute("string",string);setting.setAttribute("addLabel",addLabel);return setting;}
compileSeparator(el,params={}){const separator=makeSeparator(el.getAttribute("string"));copyAttributes(el,separator);return this.applyInvisible(getModifier(el,"invisible"),separator,params);}
compileSheet(el,params){const sheetBG=createElement("div");sheetBG.className="o_form_sheet_bg";const sheetFG=createElement("div");sheetFG.className="o_form_sheet position-relative";append(sheetBG,sheetFG);for(const child of el.childNodes){const compiled=this.compileNode(child,params);if(!compiled){continue;}
if(compiled.nodeName==="ButtonBox"){continue;}
if(getTag(child,true)==="field"){compiled.setAttribute("showTooltip",true);}
append(sheetFG,compiled);}
return sheetBG;}}
return __exports;});;

/* /web/static/src/views/form/form_controller.js */
odoo.define('@web/views/form/form_controller',['@web/core/l10n/translation','@web/core/browser/feature_detection','@web/core/confirmation_dialog/confirmation_dialog','@web/core/context','@web/core/debug/debug_context','@web/core/registry','@web/core/ui/ui_service','@web/core/user','@web/core/utils/hooks','@web/core/utils/objects','@web/core/utils/xml','@web/core/py_js/py','@web/search/action_hook','@web/search/layout','@web/search/pager_hook','@web/views/standard_view_props','@web/views/utils','@web/views/view_button/view_button_hook','@web/views/view_button/view_button','@web/views/fields/field','@web/model/model','@web/model/relational_model/utils','@web/views/view_compiler','@web/views/widgets/widget','@web/search/action_menus/action_menus','@web/views/form/button_box/button_box','@web/views/form/form_compiler','@web/views/form/form_error_dialog/form_error_dialog','@web/views/form/form_status_indicator/form_status_indicator','@web/views/form/status_bar_dropdown_items/status_bar_dropdown_items','@web/views/form/form_cog_menu/form_cog_menu','@odoo/owl','@web/model/relational_model/errors','@web/core/utils/reactive'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{hasTouch}=require("@web/core/browser/feature_detection");const{deleteConfirmationMessage,ConfirmationDialog,}=require("@web/core/confirmation_dialog/confirmation_dialog");const{makeContext}=require("@web/core/context");const{useDebugCategory}=require("@web/core/debug/debug_context");const{registry}=require("@web/core/registry");const{SIZES}=require("@web/core/ui/ui_service");const{user}=require("@web/core/user");const{useBus,useService}=require("@web/core/utils/hooks");const{omit}=require("@web/core/utils/objects");const{createElement,parseXML}=require("@web/core/utils/xml");const{evaluateBooleanExpr}=require("@web/core/py_js/py");const{useSetupAction}=require("@web/search/action_hook");const{Layout}=require("@web/search/layout");const{usePager}=require("@web/search/pager_hook");const{standardViewProps}=require("@web/views/standard_view_props");const{isX2Many}=require("@web/views/utils");const{executeButtonCallback,useViewButtons}=require("@web/views/view_button/view_button_hook");const{ViewButton}=require("@web/views/view_button/view_button");const{Field}=require("@web/views/fields/field");const{useModel}=require("@web/model/model");const{addFieldDependencies,extractFieldsFromArchInfo}=require("@web/model/relational_model/utils");const{useViewCompiler}=require("@web/views/view_compiler");const{Widget}=require("@web/views/widgets/widget");const{STATIC_ACTIONS_GROUP_NUMBER}=require("@web/search/action_menus/action_menus");const{ButtonBox}=require("@web/views/form/button_box/button_box");const{FormCompiler}=require("@web/views/form/form_compiler");const{FormErrorDialog}=require("@web/views/form/form_error_dialog/form_error_dialog");const{FormStatusIndicator}=require("@web/views/form/form_status_indicator/form_status_indicator");const{StatusBarDropdownItems}=require("@web/views/form/status_bar_dropdown_items/status_bar_dropdown_items");const{FormCogMenu}=require("@web/views/form/form_cog_menu/form_cog_menu");const{Component,onError,onMounted,onRendered,onWillUnmount,status,useComponent,useEffect,useRef,useState,}=require("@odoo/owl");const{FetchRecordError}=require("@web/model/relational_model/errors");const{effect}=require("@web/core/utils/reactive");const viewRegistry=registry.category("views");__exports.loadSubViews=loadSubViews;async function loadSubViews(fieldNodes,fields,context,resModel,viewService,isSmall){for(const fieldInfo of Object.values(fieldNodes)){const fieldName=fieldInfo.name;const field=fields[fieldName];if(!isX2Many(field)){continue;}
if(fieldInfo.invisible==="True"||fieldInfo.invisible==="1"){continue;}
if(!fieldInfo.field.useSubView){continue;}
fieldInfo.views=fieldInfo.views||{};let viewType=fieldInfo.viewMode||"list,kanban";if(viewType.includes(",")){viewType=isSmall?"kanban":"list";}
fieldInfo.viewMode=viewType;if(fieldInfo.views[viewType]){continue;}
const fieldContext={};const regex=/'([a-z]*_view_ref)' *: *'(.*?)'/g;let matches;while((matches=regex.exec(fieldInfo.context))!==null){fieldContext[matches[1]]=matches[2];}
const refinedContext={};for(const key in context){if(key.indexOf("_view_ref")===-1){refinedContext[key]=context[key];}}
const comodel=field.relation;const{fields:comodelFields,relatedModels,views,}=await viewService.loadViews({resModel:comodel,views:[[false,viewType]],context:makeContext([fieldContext,user.context,refinedContext]),});const{ArchParser}=viewRegistry.get(viewType);const xmlDoc=parseXML(views[viewType].arch);const archInfo=new ArchParser().parse(xmlDoc,relatedModels,comodel);fieldInfo.views[viewType]={...archInfo,limit:archInfo.limit||40,fields:comodelFields,};fieldInfo.relatedFields=comodelFields;}}
__exports.useFormViewInDialog=useFormViewInDialog;function useFormViewInDialog(){const component=useComponent();onMounted(()=>{component.env.bus.trigger("FORM-CONTROLLER:FORM-IN-DIALOG:ADD");});onWillUnmount(()=>{component.env.bus.trigger("FORM-CONTROLLER:FORM-IN-DIALOG:REMOVE");});}
const FormController=__exports.FormController=class FormController extends Component{static template=`web.FormView`;static components={FormStatusIndicator,Layout,ButtonBox,ViewButton,Field,CogMenu:FormCogMenu,StatusBarDropdownItems,Widget,};static props={...standardViewProps,discardRecord:{type:Function,optional:true},mode:{optional:true,validate:(m)=>["edit","readonly"].includes(m),},saveRecord:{type:Function,optional:true},removeRecord:{type:Function,optional:true},Model:Function,Renderer:Function,Compiler:Function,archInfo:Object,buttonTemplate:String,preventCreate:{type:Boolean,optional:true},preventEdit:{type:Boolean,optional:true},onDiscard:{type:Function,optional:true},onSave:{type:Function,optional:true},};static defaultProps={preventCreate:false,preventEdit:false,updateActionState:()=>{},};setup(){this.evaluateBooleanExpr=evaluateBooleanExpr;this.dialogService=useService("dialog");this.orm=useService("orm");this.viewService=useService("view");this.ui=useService("ui");this.companyService=useService("company");useBus(this.ui.bus,"resize",this.render);this.archInfo=this.props.archInfo;const{create,edit}=this.archInfo.activeActions;this.canCreate=create&&!this.props.preventCreate;this.canEdit=edit&&!this.props.preventEdit;this.duplicateId=false;this.display={...this.props.display};if(this.env.inDialog){this.display.controlPanel=false;}
this.formInDialog=0;useBus(this.env.bus,"FORM-CONTROLLER:FORM-IN-DIALOG:ADD",()=>this.formInDialog++);useBus(this.env.bus,"FORM-CONTROLLER:FORM-IN-DIALOG:REMOVE",()=>this.formInDialog--);const beforeFirstLoad=async()=>{await loadSubViews(this.archInfo.fieldNodes,this.props.fields,this.props.context,this.props.resModel,this.viewService,this.env.isSmall);const{activeFields,fields}=extractFieldsFromArchInfo(this.archInfo,this.props.fields);if(this.display.controlPanel){addFieldDependencies(activeFields,fields,[{name:"display_name",type:"char",readonly:true},]);}
this.model.config.activeFields=activeFields;this.model.config.fields=fields;};this.model=useState(useModel(this.props.Model,this.modelParams,{beforeFirstLoad}));onMounted(()=>{effect((model)=>{if(status(this)==="mounted"){this.props.updateActionState({resId:model.root.resId});}},[this.model]);});onError((error)=>{const suggestedCompany=error.cause?.data?.context?.suggested_company;if(error.cause?.data?.name==="odoo.exceptions.AccessError"&&suggestedCompany&&!this.env.inDialog){this.env.pushStateBeforeReload();const activeCompanyIds=this.companyService.activeCompanyIds;activeCompanyIds.push(suggestedCompany.id);this.companyService.setCompanies(activeCompanyIds,true);}else{throw error;}});const footers=[...this.archInfo.xmlDoc.querySelectorAll("footer:not(field footer)")];if(footers.length){this.footerArchInfo=Object.assign({},this.archInfo);this.footerArchInfo.xmlDoc=createElement("t");this.footerArchInfo.xmlDoc.append(...footers);this.footerArchInfo.arch=this.footerArchInfo.xmlDoc.outerHTML;this.archInfo.arch=this.archInfo.xmlDoc.outerHTML;}
const xmlDocButtonBox=this.archInfo.xmlDoc.querySelector("div[name='button_box']:not(field div)");if(xmlDocButtonBox){const buttonBoxTemplates=useViewCompiler(this.props.Compiler||FormCompiler,{ButtonBox:xmlDocButtonBox},{isSubView:true});this.buttonBoxTemplate=buttonBoxTemplates.ButtonBox;}
const xmlDocHeader=this.archInfo.xmlDoc.querySelector("header");if(xmlDocHeader){const{StatusBarDropdownItems}=useViewCompiler(this.props.Compiler||FormCompiler,{StatusBarDropdownItems:xmlDocHeader},{isSubView:true,asDropdownItems:true});this.statusBarDropdownItemsTemplate=StatusBarDropdownItems;}
this.rootRef=useRef("root");useViewButtons(this.rootRef,{beforeExecuteAction:this.beforeExecuteActionButton.bind(this),afterExecuteAction:this.afterExecuteActionButton.bind(this),reload:()=>this.model.load(),});const state=this.props.state||{};const activeNotebookPages={...state.activeNotebookPages};this.onNotebookPageChange=(notebookId,page)=>{if(page){activeNotebookPages[notebookId]=page;}};useSetupAction({rootRef:this.rootRef,beforeVisibilityChange:()=>this.beforeVisibilityChange(),beforeLeave:()=>this.beforeLeave(),beforeUnload:(ev)=>this.beforeUnload(ev),getLocalState:()=>{return{activeNotebookPages:!this.model.root.isNew?activeNotebookPages:{},modelState:this.model.exportState(),resId:this.model.root.resId,};},});useDebugCategory("form",{component:this});usePager(()=>{if(!this.model.root.isNew){const resIds=this.model.root.resIds;return{offset:resIds.indexOf(this.model.root.resId),limit:1,total:resIds.length,onUpdate:({offset})=>this.onPagerUpdate({offset,resIds}),};}});onRendered(()=>{this.env.config.setDisplayName(this.displayName());});const{disableAutofocus}=this.archInfo;if(!disableAutofocus){useEffect((isInEdition)=>{if(!isInEdition&&!this.rootRef.el.querySelector(".o_content").contains(document.activeElement)){const elementToFocus=this.rootRef.el.querySelector(".o_content button.btn-primary");if(elementToFocus){elementToFocus.focus();}}},()=>[this.model.root.isInEdition]);}
if(this.env.inDialog){useFormViewInDialog();}}
get cogMenuProps(){return{getActiveIds:()=>(this.model.root.isNew?[]:[this.model.root.resId]),context:this.props.context,items:this.props.info.actionMenus?this.actionMenuItems:{},isDomainSelected:this.model.root.isDomainSelected,resModel:this.model.root.resModel,domain:this.props.domain,onActionExecuted:()=>this.model.load({resId:this.model.root.resId,resIds:this.model.root.resIds}),shouldExecuteAction:this.shouldExecuteAction.bind(this),};}
get modelParams(){let mode=this.props.mode||"edit";if(!this.canEdit&&this.props.resId){mode="readonly";}
return{config:{resModel:this.props.resModel,resId:this.props.resId||false,resIds:this.props.resIds||(this.props.resId?[this.props.resId]:[]),fields:this.props.fields,activeFields:{},isMonoRecord:true,mode,context:this.props.context,},state:this.props.state?.modelState,hooks:{onWillLoadRoot:this.onWillLoadRoot.bind(this),onWillSaveRecord:this.onWillSaveRecord.bind(this),onRecordSaved:this.onRecordSaved.bind(this),},useSendBeaconToSaveUrgently:true,};}
onWillLoadRoot(){this.duplicateId=undefined;}
async onRecordSaved(record,changes){if(this.duplicateId===record.id){const translationChanges={};for(const fieldName in changes){if(record.fields[fieldName].translate){translationChanges[fieldName]=changes[fieldName];}}
if(Object.keys(translationChanges).length){await this.orm.call(this.model.root.resModel,"web_override_translations",[[this.model.root.resId],translationChanges,]);}}}
async onWillSaveRecord(){}
async onSaveError(error,{discard}){const proceed=await new Promise((resolve)=>{this.model.dialog.add(FormErrorDialog,{message:error.data.message,data:error.data,onDiscard:()=>{discard();resolve(true);},onStayHere:()=>resolve(false),});});return proceed;}
displayName(){return this.model.root.data.display_name||(this.model.root.isNew&&_t("New"))||"";}
async onPagerUpdate({offset,resIds}){const dirty=await this.model.root.isDirty();try{if(dirty){await this.model.root.save({onError:this.onSaveError.bind(this),nextId:resIds[offset],});}else{await this.model.load({resId:resIds[offset]});}}catch(e){if(e instanceof FetchRecordError){this.model.load({resIds:this.model.config.resIds.filter((id)=>!e.resIds.includes(id)),});}
throw e;}}
beforeVisibilityChange(){if(document.visibilityState==="hidden"&&this.formInDialog===0){return this.model.root.save();}}
async beforeLeave(){if(this.model.root.dirty){return this.save({reload:false,onError:this.onSaveError.bind(this),});}}
async beforeUnload(ev){const succeeded=await this.model.root.urgentSave();if(!succeeded){ev.preventDefault();ev.returnValue="Unsaved changes";}}
getStaticActionMenuItems(){const{activeActions}=this.archInfo;return{archive:{isAvailable:()=>this.archiveEnabled&&this.model.root.isActive,sequence:10,description:_t("Archive"),icon:"oi oi-archive",callback:()=>{this.dialogService.add(ConfirmationDialog,this.archiveDialogProps);},},unarchive:{isAvailable:()=>this.archiveEnabled&&!this.model.root.isActive,sequence:20,icon:"oi oi-unarchive",description:_t("Unarchive"),callback:()=>this.model.root.unarchive(),},duplicate:{isAvailable:()=>activeActions.create&&activeActions.duplicate,sequence:30,icon:"fa fa-clone",description:_t("Duplicate"),callback:()=>this.duplicateRecord(),},delete:{isAvailable:()=>activeActions.delete&&!this.model.root.isNew,sequence:40,icon:"fa fa-trash-o",description:_t("Delete"),callback:()=>this.deleteRecord(),skipSave:true,},addPropertyFieldValue:{isAvailable:()=>activeActions.addPropertyFieldValue,sequence:50,icon:"fa fa-cogs",description:_t("Add Properties"),callback:()=>this.model.bus.trigger("PROPERTY_FIELD:ADD_PROPERTY_VALUE"),},};}
get archiveDialogProps(){return{body:_t("Are you sure that you want to archive this record?"),confirmLabel:_t("Archive"),confirm:()=>this.model.root.archive(),cancel:()=>{},};}
get actionMenuItems(){const{actionMenus}=this.props.info;const staticActionItems=Object.entries(this.getStaticActionMenuItems()).filter(([key,item])=>item.isAvailable===undefined||item.isAvailable()).sort(([k1,item1],[k2,item2])=>(item1.sequence||0)-(item2.sequence||0)).map(([key,item])=>Object.assign({key},omit(item,"isAvailable","sequence"),{groupNumber:STATIC_ACTIONS_GROUP_NUMBER,}));return{action:[...staticActionItems,...(actionMenus.action||[])],print:actionMenus.print,};}
get archiveEnabled(){return"active"in this.model.root.activeFields?!this.props.fields.active.readonly:"x_active"in this.model.root.activeFields?!this.props.fields.x_active.readonly:false;}
async shouldExecuteAction(item){const dirty=await this.model.root.isDirty();if((dirty||this.model.root.isNew)&&!item.skipSave){let hasError=false;const isSaved=await this.model.root.save({onError:(...args)=>{hasError=true;return this.onSaveError(...args);},});return isSaved&&!hasError;}
return true;}
async duplicateRecord(){await this.model.root.duplicate();this.duplicateId=this.model.root.id;}
get deleteConfirmationDialogProps(){return{title:_t("Bye-bye, record!"),body:deleteConfirmationMessage,confirm:async()=>{await this.model.root.delete();if(!this.model.root.resId){this.env.config.historyBack();}},confirmLabel:_t("Delete"),cancel:()=>{},cancelLabel:_t("No, keep it"),};}
async deleteRecord(){this.dialogService.add(ConfirmationDialog,this.deleteConfirmationDialogProps);}
async beforeExecuteActionButton(clickParams){const record=this.model.root;if(clickParams.special!=="cancel"){let saved=false;if(clickParams.special==="save"&&this.props.saveRecord){saved=await this.props.saveRecord(record,clickParams);}else{const params={reload:!(this.env.inDialog&&clickParams.close)};saved=await record.save(params);}
if(saved!==false&&this.props.onSave){this.props.onSave(record,clickParams);}
return saved;}else if(this.props.onDiscard){this.props.onDiscard(record);}}
async afterExecuteActionButton(clickParams){}
async create(){const dirty=await this.model.root.isDirty();const onError=this.onSaveError.bind(this);const canProceed=!dirty||(await this.model.root.save({onError}));if(canProceed){await executeButtonCallback(this.ui.activeElement,()=>this.model.load({resId:false}));}}
async save(params){const record=this.model.root;let saved=false;if(this.props.saveRecord){saved=await this.props.saveRecord(record,params);}else{saved=await record.save(params);}
if(saved&&this.props.onSave){this.props.onSave(record,params);}
return saved;}
saveButtonClicked(params={}){return executeButtonCallback(this.ui.activeElement,()=>this.save(params));}
async discard(){if(this.props.discardRecord){this.props.discardRecord(this.model.root);return;}
await this.model.root.discard();if(this.props.onDiscard){this.props.onDiscard(this.model.root);}
if(this.model.root.isNew||this.env.inDialog){this.env.config.historyBack();}}
get className(){const result={};const{size}=this.ui;if(size<=SIZES.XS){result.o_xxs_form_view=true;}else if(!this.env.inDialog&&size===SIZES.XXL){result["o_xxl_form_view h-100"]=true;}
if(this.props.className){result[this.props.className]=true;}
result["o_field_highlight"]=size<SIZES.SM||hasTouch();return result;}}
return __exports;});;

/* /knowledge/static/src/web/form_controller_patch.js */
odoo.define('@knowledge/web/form_controller_patch',['@web/views/form/form_controller','@web/core/utils/patch','@web/core/utils/hooks','@web/core/py_js/py','@web/search/action_hook','@odoo/owl'],function(require){'use strict';let __exports={};const{FormController}=require("@web/views/form/form_controller");const{patch}=require("@web/core/utils/patch");const{useService}=require("@web/core/utils/hooks");const{evaluateBooleanExpr}=require("@web/core/py_js/py");const{CallbackRecorder}=require("@web/search/action_hook");const{useEffect,useSubEnv}=require("@odoo/owl");const KNOWLEDGE_RECORDED_FIELD_NAMES=['note','memo','description','comment','narration','additional_note','internal_notes','notes',];const KNOWLEDGE_EXCLUDED_MODELS=new Set(['knowledge.article','res.config.settings',]);const FormControllerPatch={setup(){super.setup(...arguments);this.command=useService("command");if(!this.env.inDialog){this.knowledgeCommandsService=useService('knowledgeCommandsService');useSubEnv({__knowledgeUpdateCommandsRecordInfo__:new CallbackRecorder(),});useEffect(()=>this._evaluateRecordCandidate(),()=>[this.model.root.resId],);}},_evaluateRecordCandidate(){if(KNOWLEDGE_EXCLUDED_MODELS.has(this.props.resModel)||!this.env.config.breadcrumbs||!this.env.config.breadcrumbs.length){return;}
const record=this.model.root;const fields=this.props.fields;const xmlDoc=this.props.archInfo.xmlDoc;const commandsRecordInfo={resId:this.model.root.resId,resModel:this.props.resModel,breadcrumbs:this.knowledgeCommandsService.getBreadcrumbsIdentifier(this.env.config.breadcrumbs||[]),canPostMessages:false,canAttachFiles:false,withHtmlField:false,fieldInfo:{},xmlDoc:this.props.archInfo.xmlDoc,};if(this.props.archInfo.xmlDoc.querySelector("chatter")){for(const callback of this.env.__knowledgeUpdateCommandsRecordInfo__.callbacks){callback(commandsRecordInfo);}}
if(this.props.mode==="readonly"||!this.canEdit){return;}
const defaultFieldNamesSet=new Set(KNOWLEDGE_RECORDED_FIELD_NAMES);const fieldNames=KNOWLEDGE_RECORDED_FIELD_NAMES.filter((name)=>{return(name in record.activeFields&&fields[name].type==="html"&&!fields[name].readonly);}).concat(Object.getOwnPropertyNames(record.activeFields).filter((name)=>{return(!defaultFieldNamesSet.has(name)&&fields[name].type==="html"&&!fields[name].readonly);}));loopFieldNames:for(const fieldName of fieldNames){if(evaluateBooleanExpr(record.activeFields[fieldName].readonly,record.evalContextWithVirtualIds)||evaluateBooleanExpr(record.activeFields[fieldName].invisible,record.evalContextWithVirtualIds)){continue loopFieldNames;}
const xmlFields=Array.from(xmlDoc.querySelectorAll(`field[name="${fieldName}"]:is([widget="html"], :not([widget])`));const xmlFieldsCandidates=xmlFields.filter((xmlField)=>{return(!(xmlField.parentElement.closest('field'))&&!evaluateBooleanExpr(xmlField.getAttribute('readonly'),record.evalContextWithVirtualIds)&&!evaluateBooleanExpr(xmlField.getAttribute('invisible'),record.evalContextWithVirtualIds));});loopXmlFieldsCandidates:for(const xmlField of xmlFieldsCandidates){const xmlFieldParent=xmlField.parentElement;let xmlInvisibleParent=xmlFieldParent.closest('[invisible]');while(xmlInvisibleParent){const invisibleParentModifier=xmlInvisibleParent.getAttribute('invisible');if(evaluateBooleanExpr(invisibleParentModifier,record.evalContextWithVirtualIds)){continue loopXmlFieldsCandidates;}
xmlInvisibleParent=xmlInvisibleParent.parentElement&&xmlInvisibleParent.parentElement.closest('[invisible]');}
const page=xmlField.closest('page');const pageName=page?page.getAttribute('name'):undefined;if(!page||pageName){commandsRecordInfo.fieldInfo={name:fieldName,string:fields[fieldName].string,pageName:pageName,};break loopFieldNames;}}}
if(commandsRecordInfo.fieldInfo.name){commandsRecordInfo.withHtmlField=true;}
if(this.knowledgeCommandsService.isRecordCompatibleWithMacro(commandsRecordInfo)){this.knowledgeCommandsService.setCommandsRecordInfo(commandsRecordInfo);}},async onClickSearchKnowledgeArticle(){if(await this.model.root.isDirty()||this.model.root.isNew){const saved=await this.model.root.save();if(!saved){return;}}
this.command.openMainPalette({searchValue:"?"});},};patch(FormController.prototype,FormControllerPatch);return __exports;});;

/* /web/static/src/views/form/form_error_dialog/form_error_dialog.js */
odoo.define('@web/views/form/form_error_dialog/form_error_dialog',['@web/core/dialog/dialog','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const FormErrorDialog=__exports.FormErrorDialog=class FormErrorDialog extends Component{static template="web.FormErrorDialog";static components={Dialog};static props={message:{type:String,optional:true},data:{type:Object},onDiscard:Function,onStayHere:Function,close:Function,};setup(){this.action=useService("action");this.message=this.props.message;if(this.props?.data.name==="odoo.exceptions.RedirectWarning"){this.message=this.props.data.arguments[0];this.redirectAction=this.props.data.arguments[1];this.redirectBtnLabel=this.props.data.arguments[2];}}
onRedirectBtnClicked(){this.action.doAction(this.redirectAction);this.stay();}
async discard(){await this.props.onDiscard();this.props.close();}
async stay(){await this.props.onStayHere();this.props.close();}}
return __exports;});;

/* /web/static/src/views/form/form_group/form_group.js */
odoo.define('@web/views/form/form_group/form_group',['@odoo/owl','@web/core/utils/arrays'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{sortBy}=require("@web/core/utils/arrays");class Group extends Component{static template="";static props=["class?","slots?","maxCols?","style?"];static defaultProps={maxCols:2,};_getItems(){const items=Object.entries(this.props.slots||{}).filter(([k,v])=>v.type==="item");return sortBy(items,(i)=>i[1].sequence);}
getItems(){return this._getItems();}
get allClasses(){return this.props.class;}}
const OuterGroup=__exports.OuterGroup=class OuterGroup extends Group{static template="web.Form.OuterGroup";static defaultProps={...Group.defaultProps,slots:[],hasOuterTemplate:true,};getItems(){const nbCols=this.props.maxCols;const colSize=Math.max(1,Math.round(12/nbCols));const items=super.getItems().filter(([k,v])=>!("isVisible"in v)||v.isVisible);return items.map((item)=>{const[slotName,slot]=item;const itemSpan=slot.itemSpan||1;return{name:slotName,size:itemSpan*colSize,newline:slot.newline,colspan:itemSpan,};});}}
const InnerGroup=__exports.InnerGroup=class InnerGroup extends Group{static template="web.Form.InnerGroup";getTemplate(subType){return this.constructor.templates[subType]||this.constructor.templates.default;}
getRows(){const maxCols=this.props.maxCols;const rows=[];let currentRow=[];let reservedSpace=0;const items=this.getItems();while(items.length){const[slotName,slot]=items.shift();if(!slot.isVisible){continue;}
const{newline,itemSpan}=slot;if(newline){rows.push(currentRow);currentRow=[];reservedSpace=0;}
const fullItemSpan=itemSpan||1;if(fullItemSpan+reservedSpace>maxCols){rows.push(currentRow);currentRow=[];reservedSpace=0;}
const isVisible=!("isVisible"in slot)||slot.isVisible;currentRow.push({...slot,name:slotName,itemSpan,isVisible});reservedSpace+=itemSpan||1;currentRow.isVisible=currentRow.isVisible||isVisible;}
rows.push(currentRow);return rows;}}
return __exports;});;

/* /web/static/src/views/form/form_label.js */
odoo.define('@web/views/form/form_label',['@web/views/fields/field','@web/session','@web/views/fields/field_tooltip','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{fieldVisualFeedback}=require("@web/views/fields/field");const{session}=require("@web/session");const{getTooltipInfo}=require("@web/views/fields/field_tooltip");const{_t}=require("@web/core/l10n/translation");const{Component}=require("@odoo/owl");const FormLabel=__exports.FormLabel=class FormLabel extends Component{static template="web.FormLabel";static props={fieldInfo:{type:Object},record:{type:Object},fieldName:{type:String},className:{type:String,optional:true},string:{type:String},id:{type:String},notMuttedLabel:{type:Boolean,optional:true},};get className(){const{invalid,empty,readonly}=fieldVisualFeedback(this.props.fieldInfo.field,this.props.record,this.props.fieldName,this.props.fieldInfo);const classes=this.props.className?[this.props.className]:[];if(invalid){classes.push("o_field_invalid");}
if(empty){classes.push("o_form_label_empty");}
if(readonly&&!this.props.notMuttedLabel){classes.push("o_form_label_readonly");}
return classes.join(" ");}
get hasTooltip(){return Boolean(odoo.debug)||this.tooltipHelp;}
get tooltipHelp(){const field=this.props.record.fields[this.props.fieldName];let help=this.props.fieldInfo.help||field.help||"";if(field.company_dependent&&session.display_switch_company_menu){help+=(help?"\n\n":"")+_t("Values set here are company-specific.");}
return help;}
get tooltipInfo(){if(!odoo.debug){return JSON.stringify({field:{help:this.tooltipHelp,},});}
return getTooltipInfo({viewMode:"form",resModel:this.props.record.resModel,field:this.props.record.fields[this.props.fieldName],fieldInfo:this.props.fieldInfo,help:this.tooltipHelp,});}}
return __exports;});;

/* /web/static/src/views/form/form_renderer.js */
odoo.define('@web/views/form/form_renderer',['@web/core/py_js/py','@web/core/notebook/notebook','@web/views/form/setting/setting','@web/views/fields/field','@web/core/browser/browser','@web/core/browser/feature_detection','@web/core/utils/hooks','@web/core/utils/timing','@web/views/form/button_box/button_box','@web/views/form/form_group/form_group','@web/views/view_button/view_button','@web/views/view_compiler','@web/views/view_hook','@web/views/widgets/widget','@web/views/form/form_compiler','@web/views/form/form_label','@web/views/form/status_bar_buttons/status_bar_buttons','@odoo/owl'],function(require){'use strict';let __exports={};const{evaluateBooleanExpr}=require("@web/core/py_js/py");const{Notebook}=require("@web/core/notebook/notebook");const{Setting}=require("@web/views/form/setting/setting");const{Field}=require("@web/views/fields/field");const{browser}=require("@web/core/browser/browser");const{hasTouch}=require("@web/core/browser/feature_detection");const{useService}=require("@web/core/utils/hooks");const{useDebounced}=require("@web/core/utils/timing");const{ButtonBox}=require("@web/views/form/button_box/button_box");const{InnerGroup,OuterGroup}=require("@web/views/form/form_group/form_group");const{ViewButton}=require("@web/views/view_button/view_button");const{useViewCompiler}=require("@web/views/view_compiler");const{useBounceButton}=require("@web/views/view_hook");const{Widget}=require("@web/views/widgets/widget");const{FormCompiler}=require("@web/views/form/form_compiler");const{FormLabel}=require("@web/views/form/form_label");const{StatusBarButtons}=require("@web/views/form/status_bar_buttons/status_bar_buttons");const{Component,onMounted,onWillUnmount,useEffect,useSubEnv,useRef,useState,xml,}=require("@odoo/owl");const FormRenderer=__exports.FormRenderer=class FormRenderer extends Component{static template=xml`<t t-call="{{ templates.FormRenderer }}" t-call-context="{ __comp__: Object.assign(Object.create(this), { this: this }) }" />`;static components={Field,FormLabel,ButtonBox,ViewButton,Widget,Notebook,Setting,OuterGroup,InnerGroup,StatusBarButtons,};static props={archInfo:Object,Compiler:{type:Function,optional:true},record:Object,class:{type:String,optional:1},translateAlert:{type:[Object,{value:null}],optional:true},onNotebookPageChange:{type:Function,optional:true},activeNotebookPages:{type:Object,optional:true},saveRecord:{type:Function,optional:true},setFieldAsDirty:{type:Function,optional:true},slots:{type:Object,optional:true},};static defaultProps={activeNotebookPages:{},onNotebookPageChange:()=>{},};setup(){this.evaluateBooleanExpr=evaluateBooleanExpr;const{archInfo,Compiler,record}=this.props;const templates={FormRenderer:archInfo.xmlDoc};this.state=useState({});this.templates=useViewCompiler(Compiler||FormCompiler,templates);useSubEnv({model:record.model});useBounceButton(useRef("compiled_view_root"),(target)=>{return!record.isInEdition&&!!target.closest(".oe_title, .o_inner_group");});this.uiService=useService("ui");this.onResize=useDebounced(this.render,200);onMounted(()=>browser.addEventListener("resize",this.onResize));onWillUnmount(()=>browser.removeEventListener("resize",this.onResize));const{autofocusFieldId}=archInfo;const rootRef=useRef("compiled_view_root");if(this.shouldAutoFocus){useEffect((isNew,rootEl)=>{if(!rootEl){return;}
let elementToFocus;if(isNew){const focusableSelectors=['input[type="text"]',"textarea","[contenteditable]",];elementToFocus=(autofocusFieldId&&rootEl.querySelector(`#${autofocusFieldId}`))||rootEl.querySelector(focusableSelectors.map((sel)=>`.o_content .o_field_widget ${sel}`).join(", "));}
if(elementToFocus){elementToFocus.focus();}},()=>[this.props.record.isNew,rootRef.el]);}
if(this.env.inDialog){const fieldNodeIds=Object.keys(this.props.archInfo.fieldNodes);const elementsByNodeIds={};onMounted(()=>{if(!rootRef.el){return;}
for(const id of fieldNodeIds){const els=[...document.querySelectorAll(`[id=${id}]`)].filter((el)=>!rootRef.el.contains(el));if(els.length){els[0].removeAttribute("id");elementsByNodeIds[id]=els[0];}}});onWillUnmount(()=>{for(const[id,el]of Object.entries(elementsByNodeIds)){el.setAttribute("id",id);}});}}
get shouldAutoFocus(){return!hasTouch()&&!this.props.archInfo.disableAutofocus;}}
return __exports;});;

/* /web/static/src/views/form/form_status_indicator/form_status_indicator.js */
odoo.define('@web/views/form/form_status_indicator/form_status_indicator',['@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,useEffect,useRef,useState}=require("@odoo/owl");const{useBus}=require("@web/core/utils/hooks");const FormStatusIndicator=__exports.FormStatusIndicator=class FormStatusIndicator extends Component{static template="web.FormStatusIndicator";static props={model:Object,save:Function,discard:Function,};setup(){this.state=useState({fieldIsDirty:false,});useBus(this.props.model.bus,"FIELD_IS_DIRTY",(ev)=>(this.state.fieldIsDirty=ev.detail));useEffect(()=>{if(!this.props.model.root.isNew&&this.indicatorMode==="invalid"){this.saveButton.el.setAttribute("disabled","1");}else{this.saveButton.el.removeAttribute("disabled");}},()=>[this.props.model.root.isValid]);this.saveButton=useRef("save");}
get displayButtons(){return this.indicatorMode!=="saved";}
get indicatorMode(){if(this.props.model.root.isNew){return this.props.model.root.isValid?"dirty":"invalid";}else if(!this.props.model.root.isValid){return"invalid";}else if(this.props.model.root.dirty||this.state.fieldIsDirty){return"dirty";}else{return"saved";}}
async discard(){await this.props.discard();}
async save(){await this.props.save();}}
return __exports;});;

/* /web/static/src/views/form/form_view.js */
odoo.define('@web/views/form/form_view',['@web/core/registry','@web/model/relational_model/relational_model','@web/views/form/form_renderer','@web/views/form/form_arch_parser','@web/views/form/form_controller','@web/views/form/form_compiler'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{RelationalModel}=require("@web/model/relational_model/relational_model");const{FormRenderer}=require("@web/views/form/form_renderer");const{FormArchParser}=require("@web/views/form/form_arch_parser");const{FormController}=require("@web/views/form/form_controller");const{FormCompiler}=require("@web/views/form/form_compiler");const formView=__exports.formView={type:"form",searchMenuTypes:[],Controller:FormController,Renderer:FormRenderer,ArchParser:FormArchParser,Model:RelationalModel,Compiler:FormCompiler,buttonTemplate:"web.FormView.Buttons",props:(genericProps,view)=>{const{ArchParser}=view;const{arch,relatedModels,resModel}=genericProps;const archInfo=new ArchParser().parse(arch,relatedModels,resModel);return{...genericProps,Model:view.Model,Renderer:view.Renderer,buttonTemplate:genericProps.buttonTemplate||view.buttonTemplate,Compiler:view.Compiler,archInfo,};},};registry.category("views").add("form",formView);return __exports;});;

/* /web/static/src/views/form/setting/setting.js */
odoo.define('@web/views/form/setting/setting',['@web/session','@odoo/owl','@web/views/form/form_label','@web/views/widgets/documentation_link/documentation_link'],function(require){'use strict';let __exports={};const{session}=require("@web/session");const{Component}=require("@odoo/owl");const{FormLabel}=require("@web/views/form/form_label");const{DocumentationLink}=require("@web/views/widgets/documentation_link/documentation_link");const Setting=__exports.Setting=class Setting extends Component{static template="web.Setting";static components={FormLabel,DocumentationLink,};static props={id:{type:String,optional:1},title:{type:String,optional:1},fieldId:{type:String,optional:1},help:{type:String,optional:1},fieldName:{type:String,optional:1},fieldInfo:{type:Object,optional:1},class:{type:String,optional:1},record:{type:Object,optional:1},documentation:{type:String,optional:1},string:{type:String,optional:1},addLabel:{type:Boolean},companyDependent:{type:Boolean,optional:1},slots:{type:Object,optional:1},};setup(){if(this.props.fieldName){this.fieldType=this.props.record.fields[this.props.fieldName].type;if(this.props.fieldInfo.readonly==="True"){this.notMuttedLabel=true;}}}
get classNames(){const{class:_class}=this.props;const classNames={o_setting_box:true,"col-12":true,"col-lg-6":true,[_class]:Boolean(_class),};return classNames;}
get displayCompanyDependentIcon(){return(this.labelString&&this.props.companyDependent&&session.display_switch_company_menu);}
get labelString(){if(this.props.string){return this.props.string;}
const label=this.props.record&&this.props.record.fields[this.props.fieldName]&&this.props.record.fields[this.props.fieldName].string;return label||"";}}
return __exports;});;

/* /web/static/src/views/form/status_bar_buttons/status_bar_buttons.js */
odoo.define('@web/views/form/status_bar_buttons/status_bar_buttons',['@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@odoo/owl'],function(require){'use strict';let __exports={};const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{Component}=require("@odoo/owl");const StatusBarButtons=__exports.StatusBarButtons=class StatusBarButtons extends Component{static template="web.StatusBarButtons";static components={Dropdown,DropdownItem,};static props={slots:{type:Object,optional:1},};get visibleSlotNames(){if(!this.props.slots){return[];}
return Object.entries(this.props.slots).filter((entry)=>entry[1].isVisible).map((entry)=>entry[0]);}}
return __exports;});;

/* /web/static/src/views/form/status_bar_dropdown_items/status_bar_dropdown_items.js */
odoo.define('@web/views/form/status_bar_dropdown_items/status_bar_dropdown_items',['@web/core/dropdown/dropdown_item','@web/views/form/status_bar_buttons/status_bar_buttons'],function(require){'use strict';let __exports={};const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{StatusBarButtons}=require("@web/views/form/status_bar_buttons/status_bar_buttons");const StatusBarDropdownItems=__exports.StatusBarDropdownItems=class StatusBarDropdownItems extends StatusBarButtons{static template="web.StatusBarDropdownItems";static components={DropdownItem,};}
return __exports;});;

/* /web/static/src/views/kanban/kanban_arch_parser.js */
odoo.define('@web/views/kanban/kanban_arch_parser',['@web/core/utils/strings','@web/core/utils/xml','@web/search/utils/order_by','@web/views/fields/field','@web/views/utils','@web/views/widgets/widget'],function(require){'use strict';let __exports={};const{exprToBoolean}=require("@web/core/utils/strings");const{extractAttributes,visitXML}=require("@web/core/utils/xml");const{stringToOrderBy}=require("@web/search/utils/order_by");const{Field}=require("@web/views/fields/field");const{getActiveActions,processButton}=require("@web/views/utils");const{Widget}=require("@web/views/widgets/widget");const LEGACY_KANBAN_BOX_ATTRIBUTE=__exports.LEGACY_KANBAN_BOX_ATTRIBUTE="kanban-box";const LEGACY_KANBAN_MENU_ATTRIBUTE=__exports.LEGACY_KANBAN_MENU_ATTRIBUTE="kanban-menu";const KANBAN_CARD_ATTRIBUTE=__exports.KANBAN_CARD_ATTRIBUTE="card";const KANBAN_MENU_ATTRIBUTE=__exports.KANBAN_MENU_ATTRIBUTE="menu";const KanbanArchParser=__exports.KanbanArchParser=class KanbanArchParser{parse(xmlDoc,models,modelName){const fields=models[modelName].fields;const className=xmlDoc.getAttribute("class")||null;const canOpenRecords=exprToBoolean(xmlDoc.getAttribute("can_open"),true);let defaultOrder=stringToOrderBy(xmlDoc.getAttribute("default_order")||null);const defaultGroupBy=xmlDoc.getAttribute("default_group_by");const limit=xmlDoc.getAttribute("limit");const countLimit=xmlDoc.getAttribute("count_limit");const recordsDraggable=exprToBoolean(xmlDoc.getAttribute("records_draggable"),true);const groupsDraggable=exprToBoolean(xmlDoc.getAttribute("groups_draggable"),true);const activeActions=getActiveActions(xmlDoc);activeActions.archiveGroup=exprToBoolean(xmlDoc.getAttribute("archivable"),true);activeActions.createGroup=exprToBoolean(xmlDoc.getAttribute("group_create"),true);activeActions.deleteGroup=exprToBoolean(xmlDoc.getAttribute("group_delete"),true);activeActions.editGroup=exprToBoolean(xmlDoc.getAttribute("group_edit"),true);activeActions.quickCreate=activeActions.create&&exprToBoolean(xmlDoc.getAttribute("quick_create"),true);const onCreate=xmlDoc.getAttribute("on_create");const quickCreateView=xmlDoc.getAttribute("quick_create_view");const tooltipInfo={};let handleField=null;const fieldNodes={};const fieldNextIds={};const widgetNodes={};let widgetNextId=0;const jsClass=xmlDoc.getAttribute("js_class");const action=xmlDoc.getAttribute("action");const type=xmlDoc.getAttribute("type");const openAction=action&&type?{action,type}:null;const templateDocs={};let headerButtons=[];const creates=[];let button_id=0;visitXML(xmlDoc,(node)=>{if(node.hasAttribute("t-name")){templateDocs[node.getAttribute("t-name")]=node;return;}
if(node.tagName==="header"){headerButtons=[...node.children].filter((node)=>node.tagName==="button").map((node)=>({...processButton(node),type:"button",id:button_id++,})).filter((button)=>button.invisible!=="True"&&button.invisible!=="1");return false;}else if(node.tagName==="control"){for(const childNode of node.children){if(childNode.tagName==="button"){creates.push({type:"button",...processButton(childNode),});}else if(childNode.tagName==="create"){creates.push({type:"create",context:childNode.getAttribute("context"),string:childNode.getAttribute("string"),});}}
return false;}
if(node.tagName==="field"){const widget=node.getAttribute("widget");if(!widget&&models[modelName].fields[node.getAttribute("name")].type==="many2many"){node.setAttribute("widget","many2many_tags");}
const fieldInfo=Field.parseFieldNode(node,models,modelName,"kanban",jsClass);const name=fieldInfo.name;if(!(fieldInfo.name in fieldNextIds)){fieldNextIds[fieldInfo.name]=0;}
const fieldId=`${fieldInfo.name}_${fieldNextIds[fieldInfo.name]++}`;fieldNodes[fieldId]=fieldInfo;node.setAttribute("field_id",fieldId);if(fieldInfo.options.group_by_tooltip){tooltipInfo[name]=fieldInfo.options.group_by_tooltip;}
if(fieldInfo.isHandle){handleField=name;}}
if(node.tagName==="widget"){const widgetInfo=Widget.parseWidgetNode(node);const widgetId=`widget_${++widgetNextId}`;widgetNodes[widgetId]=widgetInfo;node.setAttribute("widget_id",widgetId);}
if(node.tagName==="img"){const attSrc=node.getAttribute("t-att-src");if(attSrc&&/\bkanban_image\b/.test(attSrc)&&!Object.values(fieldNodes).some((f)=>f.name==="write_date")){fieldNodes.write_date_0={name:"write_date",type:"datetime"};}}});let progressAttributes=false;const progressBar=xmlDoc.querySelector("progressbar");if(progressBar){progressAttributes=this.parseProgressBar(progressBar,fields);}
let cardDoc=templateDocs[KANBAN_CARD_ATTRIBUTE];const isLegacyArch=!cardDoc;if(isLegacyArch){console.warn("'kanban-box' is deprecated, define a 'card' template instead");}
if(!cardDoc){cardDoc=templateDocs[LEGACY_KANBAN_BOX_ATTRIBUTE];if(!cardDoc){throw new Error(`Missing '${KANBAN_CARD_ATTRIBUTE}' template.`);}}
const cardClassName=(!isLegacyArch&&cardDoc.getAttribute("class"))||"";if(!defaultOrder.length&&handleField){const handleFieldSort=`${handleField}, id`;defaultOrder=stringToOrderBy(handleFieldSort);}
return{activeActions,canOpenRecords,cardClassName,cardColorField:xmlDoc.getAttribute("highlight_color"),className,creates,defaultGroupBy,fieldNodes,widgetNodes,handleField,headerButtons,defaultOrder,onCreate,openAction,quickCreateView,recordsDraggable,groupsDraggable,limit:limit&&parseInt(limit,10),countLimit:countLimit&&parseInt(countLimit,10),progressAttributes,templateDocs,tooltipInfo,examples:xmlDoc.getAttribute("examples"),xmlDoc,isLegacyArch,};}
parseProgressBar(progressBar,fields){const attrs=extractAttributes(progressBar,["field","colors","sum_field","help"]);return{fieldName:attrs.field,colors:JSON.parse(attrs.colors),sumField:fields[attrs.sum_field]||false,help:attrs.help,};}}
return __exports;});;

/* /web/static/src/views/kanban/kanban_color_picker_legacy.js */
odoo.define('@web/views/kanban/kanban_color_picker_legacy',['@web/core/colorlist/colorlist','@web/core/utils/patch','@web/core/utils/xml','@web/views/kanban/kanban_arch_parser','@web/views/kanban/kanban_compiler','@web/views/kanban/kanban_record'],function(require){'use strict';let __exports={};const{ColorList}=require("@web/core/colorlist/colorlist");const{patch}=require("@web/core/utils/patch");const{createElement}=require("@web/core/utils/xml");const{LEGACY_KANBAN_BOX_ATTRIBUTE,KanbanArchParser}=require("@web/views/kanban/kanban_arch_parser");const{KanbanCompiler}=require("@web/views/kanban/kanban_compiler");const{KanbanRecord,getColorIndex}=require("@web/views/kanban/kanban_record");patch(KanbanArchParser.prototype,{parse(xmlDoc,models,modelName){const archInfo=super.parse(xmlDoc,models,modelName);const legacyCardDoc=archInfo.templateDocs[LEGACY_KANBAN_BOX_ATTRIBUTE];if(legacyCardDoc){const cardColorEl=legacyCardDoc.querySelector("[color]");const cardColorField=cardColorEl&&cardColorEl.getAttribute("color");const colorEl=xmlDoc.querySelector("templates .oe_kanban_colorpicker[data-field]");const colorField=(colorEl&&colorEl.getAttribute("data-field"))||"color";archInfo.cardColorField=archInfo.cardColorField||cardColorField;archInfo.colorField=colorField;}
return archInfo;},});patch(KanbanCompiler.prototype,{setup(){super.setup();this.compilers.push({selector:".oe_kanban_colorpicker",fn:this.compileColorPicker});},compileColorPicker(){return createElement("t",{"t-call":"web.KanbanColorPicker","t-call-context":"__comp__",});},});function getColorClass(value){return`oe_kanban_color_${getColorIndex(value)}`;}
function getColorName(value){return ColorList.COLORS[getColorIndex(value)];}
patch(KanbanRecord.prototype,{selectColor(colorIndex){const{archInfo,record}=this.props;return record.update({[archInfo.colorField]:colorIndex},{save:true});},get renderingContext(){return Object.assign(super.renderingContext,{kanban_color:getColorClass,kanban_getcolor:getColorIndex,kanban_getcolorname:getColorName,});},});return __exports;});;

/* /web/static/src/views/kanban/kanban_column_examples_dialog.js */
odoo.define('@web/views/kanban/kanban_column_examples_dialog',['@web/core/dialog/dialog','@web/core/notebook/notebook','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{Notebook}=require("@web/core/notebook/notebook");const{Component,useRef}=require("@odoo/owl");const random=(min,max)=>Math.floor(Math.random()*(max-min)+min);class KanbanExamplesNotebookTemplate extends Component{static template="web.KanbanExamplesNotebookTemplate";static props=["*"];static defaultProps={columns:[],foldedColumns:[],};setup(){this.columns=[];const hasBullet=this.props.bullets&&this.props.bullets.length;const allColumns=[...this.props.columns,...this.props.foldedColumns];for(const title of allColumns){const col={title,records:[]};this.columns.push(col);for(let i=0;i<random(1,5);i++){const rec={id:i};if(hasBullet&&Math.random()>0.3){const sampleId=Math.floor(Math.random()*this.props.bullets.length);rec.bullet=this.props.bullets[sampleId];}
col.records.push(rec);}}}}
const KanbanColumnExamplesDialog=__exports.KanbanColumnExamplesDialog=class KanbanColumnExamplesDialog extends Component{static template="web.KanbanColumnExamplesDialog";static components={Dialog,Notebook};static props=["*"];setup(){this.navList=useRef("navList");this.pages=[];this.activePage=null;this.props.examples.forEach((eg)=>{this.pages.push({Component:KanbanExamplesNotebookTemplate,title:eg.name,props:eg,id:eg.name,});});}
onPageUpdate(page){this.activePage=page;}
applyExamples(){const index=this.props.examples.findIndex((e)=>e.name===this.activePage);this.props.applyExamples(index);this.props.close();}}
return __exports;});;

/* /web/static/src/views/kanban/kanban_column_quick_create.js */
odoo.define('@web/views/kanban/kanban_column_quick_create',['@web/core/l10n/translation','@web/core/hotkeys/hotkey_hook','@web/core/utils/hooks','@web/views/kanban/kanban_column_examples_dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{useAutofocus,useService}=require("@web/core/utils/hooks");const{KanbanColumnExamplesDialog}=require("@web/views/kanban/kanban_column_examples_dialog");const{Component,useExternalListener,useState,useRef}=require("@odoo/owl");const KanbanColumnQuickCreate=__exports.KanbanColumnQuickCreate=class KanbanColumnQuickCreate extends Component{static template="web.KanbanColumnQuickCreate";static props={exampleData:[Object,{value:null}],onFoldChange:Function,onValidate:Function,folded:Boolean,groupByField:Object,};setup(){this.dialog=useService("dialog");this.root=useRef("root");this.state=useState({hasInputFocused:false,});useAutofocus();this.inputRef=useRef("autofocus");useExternalListener(window,"mousedown",(ev)=>{this.mousedownTarget=ev.target;});useExternalListener(window,"click",(ev)=>{const target=this.mousedownTarget||ev.target;const gotClickedInside=this.root.el.contains(target);if(!gotClickedInside){this.fold();}
this.mousedownTarget=null;},{capture:true});useHotkey("escape",()=>this.fold());}
get canShowExamples(){const{allowedGroupBys=[],examples=[]}=this.props.exampleData||{};const hasExamples=Boolean(examples.length);return hasExamples&&allowedGroupBys.includes(this.props.groupByField.name);}
get relatedFieldName(){return this.props.groupByField.string;}
fold(){this.props.onFoldChange(true);}
unfold(){this.props.onFoldChange(false);}
validate(){const title=this.inputRef.el.value.trim();if(title.length){this.props.onValidate(title);this.inputRef.el.value="";}}
showExamples(){this.dialog.add(KanbanColumnExamplesDialog,{examples:this.props.exampleData.examples,applyExamplesText:this.props.exampleData.applyExamplesText||_t("Use This For My Kanban"),applyExamples:(index)=>{const{examples,foldField}=this.props.exampleData;const{columns,foldedColumns=[]}=examples[index];for(const groupName of columns){this.props.onValidate(groupName);}
for(const groupName of foldedColumns){this.props.onValidate(groupName,foldField);}},});}
onInputKeydown(ev){if(ev.key==="Enter"){this.validate();}}}
return __exports;});;

/* /web/static/src/views/kanban/kanban_compiler.js */
odoo.define('@web/views/kanban/kanban_compiler',['@web/core/utils/xml','@web/views/utils','@web/views/view_compiler'],function(require){'use strict';let __exports={};const{append,combineAttributes,createElement,extractAttributes,getTag,}=require("@web/core/utils/xml");const{toStringExpression}=require("@web/views/utils");const{toInterpolatedStringExpression,ViewCompiler}=require("@web/views/view_compiler");const ACTION_TYPES=["action","object"];const SPECIAL_TYPES=[...ACTION_TYPES,"edit","open","delete","url","set_cover","archive","unarchive",];const KanbanCompiler=__exports.KanbanCompiler=class KanbanCompiler extends ViewCompiler{setup(){this.ctx.readonly="read_only_mode";this.compilers.push({selector:"t[t-call]",fn:this.compileTCall},{selector:"img",fn:this.compileImage});}
compileButton(el,params){const type=el.getAttribute("type");if(!SPECIAL_TYPES.includes(type)){return super.compileButton(el,params);}
combineAttributes(el,"class",["oe_kanban_action"]);if(ACTION_TYPES.includes(type)){if(!el.hasAttribute("debounce")){el.setAttribute("debounce",300);}
return super.compileButton(el,params);}
const nodeParams=extractAttributes(el,["type"]);if(type==="set_cover"){const{"auto-open":autoOpen,"data-field":fieldName}=extractAttributes(el,["auto-open","data-field",]);Object.assign(nodeParams,{autoOpen,fieldName});}
const strParams=Object.entries(nodeParams).map(([k,v])=>[k,toStringExpression(v)].join(":")).join(",");el.setAttribute("t-on-click",`()=>__comp__.triggerAction({${strParams}})`);const compiled=createElement(el.nodeName);for(const{name,value}of el.attributes){compiled.setAttribute(name,value);}
if(getTag(el,true)==="a"&&!compiled.hasAttribute("href")){compiled.setAttribute("href","#");}
for(const child of el.childNodes){append(compiled,this.compileNode(child,params));}
return compiled;}
compileImage(el){const element=el.cloneNode(true);element.setAttribute("loading","lazy");return element;}
compileField(el,params){let compiled;let isSpan=false;const recordExpr=params.recordExpr||"__comp__.props.record";const dataPointIdExpr=params.dataPointIdExpr||`${recordExpr}.id`;if(!el.hasAttribute("widget")){isSpan=true;const fieldId=el.getAttribute("field_id");compiled=createElement("span",{"t-out":params.formattedValueExpr||`__comp__.getFormattedValue("${fieldId}")`,});}else{compiled=super.compileField(el,params);const fieldId=el.getAttribute("field_id");compiled.setAttribute("id",`'${fieldId}_' + ${dataPointIdExpr}`);const readonlyAttr=compiled.getAttribute("readonly");if(readonlyAttr){compiled.setAttribute("readonly",`${recordExpr}.isInEdition || (${readonlyAttr})`);}else{compiled.setAttribute("readonly",`${recordExpr}.isInEdition`);}}
if(params.isLegacy){const{bold,display}=extractAttributes(el,["bold","display"]);const classNames=[];if(display==="right"){classNames.push("float-end");}else if(display==="full"){classNames.push("o_text_block");}
if(bold){classNames.push("o_text_bold");}
if(classNames.length>0){const clsFormatted=isSpan?classNames.join(" "):toStringExpression(classNames.join(" "));compiled.setAttribute("class",clsFormatted);}}
const attrs={};for(const attr of el.attributes){attrs[attr.name]=attr.value;}
if(el.hasAttribute("widget")){const attrsParts=Object.entries(attrs).map(([key,value])=>{if(key.startsWith("t-attf-")){key=key.slice(7);value=toInterpolatedStringExpression(value);}else if(key.startsWith("t-att-")){key=key.slice(6);value=`"" + (${value})`;}else if(key.startsWith("t-att")){throw new Error("t-att on <field> nodes is not supported");}else if(!key.startsWith("t-")){value=toStringExpression(value);}
return`'${key}':${value}`;});compiled.setAttribute("attrs",`{${attrsParts.join(",")}}`);}
for(const attr in attrs){if(attr.startsWith("t-")&&!attr.startsWith("t-att")){compiled.setAttribute(attr,attrs[attr]);}}
return compiled;}
compileTCall(el,params){const compiled=this.compileGenericNode(el,params);const tname=el.getAttribute("t-call");if(tname in this.templates){compiled.setAttribute("t-call",`{{__comp__.templates[${toStringExpression(tname)}]}}`);}
return compiled;}}
KanbanCompiler.OWL_DIRECTIVE_WHITELIST=[...ViewCompiler.OWL_DIRECTIVE_WHITELIST,"t-name","t-esc","t-out","t-set","t-value","t-if","t-else","t-elif","t-foreach","t-as","t-key","t-att.*","t-call",];return __exports;});;

/* /web/static/src/views/kanban/kanban_controller.js */
odoo.define('@web/views/kanban/kanban_controller',['@web/core/confirmation_dialog/confirmation_dialog','@web/core/l10n/translation','@web/core/utils/hooks','@web/search/cog_menu/cog_menu','@web/core/py_js/py','@web/search/action_hook','@web/search/layout','@web/search/pager_hook','@web/search/search_bar/search_bar','@web/search/search_bar/search_bar_toggler','@web/session','@web/model/model','@web/views/standard_view_props','@web/views/view_button/multi_record_view_button','@web/views/view_button/view_button_hook','@web/model/relational_model/utils','@web/views/kanban/kanban_renderer','@web/views/kanban/progress_bar_hook','@odoo/owl'],function(require){'use strict';let __exports={};const{deleteConfirmationMessage,ConfirmationDialog,}=require("@web/core/confirmation_dialog/confirmation_dialog");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{CogMenu}=require("@web/search/cog_menu/cog_menu");const{evaluateBooleanExpr}=require("@web/core/py_js/py");const{useSetupAction}=require("@web/search/action_hook");const{Layout}=require("@web/search/layout");const{usePager}=require("@web/search/pager_hook");const{SearchBar}=require("@web/search/search_bar/search_bar");const{useSearchBarToggler}=require("@web/search/search_bar/search_bar_toggler");const{session}=require("@web/session");const{useModelWithSampleData}=require("@web/model/model");const{standardViewProps}=require("@web/views/standard_view_props");const{MultiRecordViewButton}=require("@web/views/view_button/multi_record_view_button");const{useViewButtons}=require("@web/views/view_button/view_button_hook");const{addFieldDependencies,extractFieldsFromArchInfo}=require("@web/model/relational_model/utils");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{useProgressBar}=require("@web/views/kanban/progress_bar_hook");const{Component,reactive,useRef,useState}=require("@odoo/owl");const QUICK_CREATE_FIELD_TYPES=["char","boolean","many2one","selection","many2many"];const KanbanController=__exports.KanbanController=class KanbanController extends Component{static template=`web.KanbanView`;static components={Layout,KanbanRenderer,MultiRecordViewButton,SearchBar,CogMenu};static props={...standardViewProps,defaultGroupBy:{validate:(dgb)=>!dgb||typeof dgb==="string",optional:true,},editable:{type:Boolean,optional:true},forceGlobalClick:{type:Boolean,optional:true},onSelectionChanged:{type:Function,optional:true},showButtons:{type:Boolean,optional:true},Compiler:{type:Function,optional:true},Model:Function,Renderer:Function,buttonTemplate:String,archInfo:Object,};static defaultProps={createRecord:()=>{},forceGlobalClick:false,selectRecord:()=>{},showButtons:true,};setup(){this.actionService=useService("action");this.dialog=useService("dialog");const{Model,archInfo}=this.props;class KanbanSampleModel extends Model{setup(){super.setup(...arguments);this.initialSampleGroups=undefined;}
hasData(){if(this.root.groups){if(!this.root.groups.length){return true;}
return this.root.groups.some((group)=>group.hasData);}
return super.hasData();}
async load(){if(this.orm.isSample&&this.initialSampleGroups){this.orm.setGroups(this.initialSampleGroups);}
return super.load(...arguments);}
async _webReadGroup(){const result=await super._webReadGroup(...arguments);if(!this.initialSampleGroups){this.initialSampleGroups=JSON.parse(JSON.stringify(result.groups));}
return result;}
removeSampleDataInGroups(){if(this.useSampleModel){for(const group of this.root.groups){const list=group.list;group.count=0;list.count=0;if(list.records){list.records=[];}else{list.groups=[];}}}}}
this.model=useState(useModelWithSampleData(KanbanSampleModel,this.modelParams,this.modelOptions));if(archInfo.progressAttributes){const{activeBars}=this.props.state||{};this.progressBarState=useProgressBar(archInfo.progressAttributes,this.model,this.progressBarAggregateFields,activeBars);}
this.headerButtons=archInfo.headerButtons;const self=this;this.quickCreateState=reactive({get groupId(){return this._groupId||false;},set groupId(groupId){if(self.model.useSampleModel){self.model.removeSampleDataInGroups();self.model.useSampleModel=false;}
this._groupId=groupId;},view:archInfo.quickCreateView,});this.rootRef=useRef("root");useViewButtons(this.rootRef,{beforeExecuteAction:this.beforeExecuteActionButton.bind(this),afterExecuteAction:this.afterExecuteActionButton.bind(this),reload:()=>this.model.load(),});useSetupAction({rootRef:this.rootRef,beforeLeave:()=>this.model.mutex.getUnlockedDef(),getLocalState:()=>({activeBars:this.progressBarState?.activeBars,modelState:this.model.exportState(),}),});usePager(()=>{const root=this.model.root;const{count,hasLimitedCount,isGrouped,limit,offset}=root;if(!isGrouped&&!this.model.useSampleModel){return{offset:offset,limit:limit,total:count,onUpdate:async({offset,limit},hasNavigated)=>{await this.model.root.load({offset,limit});await this.onUpdatedPager();if(hasNavigated){this.onPageChangeScroll();}},updateTotal:hasLimitedCount?()=>root.fetchCount():undefined,};}});this.searchBarToggler=useSearchBarToggler();}
get modelParams(){const{resModel,archInfo,limit,defaultGroupBy}=this.props;const{activeFields,fields}=extractFieldsFromArchInfo(archInfo,this.props.fields);const cardColorField=archInfo.cardColorField;if(cardColorField){addFieldDependencies(activeFields,fields,[{name:cardColorField,type:"integer"}]);}
const aggregateFieldNames=this.progressBarAggregateFields.map((field)=>field.name);for(const[key,value]of Object.entries(activeFields)){if(!aggregateFieldNames.includes(key)){value.aggregator=null;}}
addFieldDependencies(activeFields,fields,this.progressBarAggregateFields);const modelConfig=this.props.state?.modelState?.config||{resModel,activeFields,fields,openGroupsByDefault:true,};return{config:modelConfig,state:this.props.state?.modelState,limit:archInfo.limit||limit||40,groupsLimit:Number.MAX_SAFE_INTEGER,countLimit:archInfo.countLimit,defaultGroupBy,defaultOrderBy:archInfo.defaultOrder,maxGroupByDepth:1,activeIdsLimit:session.active_ids_limit,hooks:{onRecordSaved:this.onRecordSaved.bind(this),},};}
get modelOptions(){return{};}
get progressBarAggregateFields(){const res=[];const{progressAttributes}=this.props.archInfo;if(progressAttributes&&progressAttributes.sumField){res.push(progressAttributes.sumField);}
return res;}
get className(){if(this.env.isSmall&&this.model.root.isGrouped){const classList=(this.props.className||"").split(" ");classList.push("o_action_delegate_scroll");return classList.join(" ");}
return this.props.className;}
async deleteRecord(record){this.dialog.add(ConfirmationDialog,{title:_t("Bye-bye, record!"),body:deleteConfirmationMessage,confirm:()=>this.model.root.deleteRecords([record]),confirmLabel:_t("Delete"),cancel:()=>{},cancelLabel:_t("No, keep it"),});}
evalViewModifier(modifier){return evaluateBooleanExpr(modifier,{context:this.props.context});}
async openRecord(record,mode){const activeIds=this.model.root.records.map((datapoint)=>datapoint.resId);this.props.selectRecord(record.resId,{activeIds,mode});}
async createRecord(){const{onCreate}=this.props.archInfo;const{root}=this.model;if(this.canQuickCreate&&onCreate==="quick_create"){const firstGroup=root.groups[0];if(firstGroup.isFolded){await firstGroup.toggle();}
this.quickCreateState.groupId=firstGroup.id;}else if(onCreate&&onCreate!=="quick_create"){const options={additionalContext:root.context,onClose:async()=>{await root.load();this.model.useSampleModel=false;this.render(true);},};await this.actionService.doAction(onCreate,options);}else{await this.props.createRecord();}}
get canCreate(){const{create,createGroup}=this.props.archInfo.activeActions;const list=this.model.root;if(!create){return false;}
if(list.isGrouped){if(list.groupByField.type!=="many2one"){return true;}
return list.groups.length||!createGroup;}
return true;}
get canQuickCreate(){const{activeActions}=this.props.archInfo;if(!activeActions.quickCreate){return false;}
const list=this.model.root;if(list.groups&&!list.groups.length){return false;}
return this.isQuickCreateField(list.groupByField);}
onRecordSaved(record){if(this.model.root.isGrouped){const group=this.model.root.groups.find((l)=>l.records.find((r)=>r.id===record.id));this.progressBarState?.updateCounts(group);}}
onPageChangeScroll(){if(this.rootRef&&this.rootRef.el){if(this.env.isSmall){this.rootRef.el.scrollTop=0;}else{this.rootRef.el.querySelector(".o_content").scrollTop=0;}}}
async beforeExecuteActionButton(clickParams){}
async afterExecuteActionButton(clickParams){}
async onUpdatedPager(){}
scrollTop(){this.rootRef.el.querySelector(".o_content").scrollTo({top:0});}
isQuickCreateField(field){return field&&QUICK_CREATE_FIELD_TYPES.includes(field.type);}}
return __exports;});;

/* /web/static/src/views/kanban/kanban_cover_image_dialog.js */
odoo.define('@web/views/kanban/kanban_cover_image_dialog',['@web/core/dialog/dialog','@web/core/file_input/file_input','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{FileInput}=require("@web/core/file_input/file_input");const{useService}=require("@web/core/utils/hooks");const{Component,useState,onWillStart}=require("@odoo/owl");let nextDialogId=1;const KanbanCoverImageDialog=__exports.KanbanCoverImageDialog=class KanbanCoverImageDialog extends Component{static template="web.KanbanCoverImageDialog";static components={Dialog,FileInput};static props=["*"];setup(){this.id=`o_cover_image_upload_${nextDialogId++}`;this.orm=useService("orm");this.http=useService("http");const{record,fieldName}=this.props;const attachment=(record&&record.data[fieldName])||[];this.state=useState({selectFile:false,selectedAttachmentId:attachment[0],});onWillStart(async()=>{this.attachments=await this.orm.searchRead("ir.attachment",[["res_model","=",record.resModel],["res_id","=",record.resId],["mimetype","ilike","image"],],["id"]);this.state.selectFile=this.props.autoOpen&&this.attachments.length;});}
get hasCoverImage(){return Boolean(this.props.record.data[this.props.fieldName]);}
onUpload([attachment]){if(!attachment){return;}
this.state.selectFile=false;this.selectAttachment(attachment,true);}
selectAttachment(attachment,setSelected){if(this.state.selectedAttachmentId!==attachment.id){this.state.selectedAttachmentId=attachment.id;}else{this.state.selectedAttachmentId=null;}
if(setSelected){this.setCover();}}
removeCover(){this.state.selectedAttachmentId=null;this.setCover();}
async setCover(){const id=this.state.selectedAttachmentId?[this.state.selectedAttachmentId]:false;await this.props.record.update({[this.props.fieldName]:id},{save:true});this.props.close();}
uploadImage(){this.state.selectFile=true;}}
return __exports;});;

/* /web/static/src/views/kanban/kanban_dropdown_menu_wrapper.js */
odoo.define('@web/views/kanban/kanban_dropdown_menu_wrapper',['@odoo/owl','@web/core/dropdown/dropdown_hooks'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{useDropdownCloser}=require("@web/core/dropdown/dropdown_hooks");const KanbanDropdownMenuWrapper=__exports.KanbanDropdownMenuWrapper=class KanbanDropdownMenuWrapper extends Component{static template="web.KanbanDropdownMenuWrapper";static props={slots:Object,};setup(){this.dropdownControl=useDropdownCloser();}
onClick(ev){this.dropdownControl.closeAll();}}
return __exports;});;

/* /web/static/src/views/kanban/kanban_header.js */
odoo.define('@web/views/kanban/kanban_header',['@web/core/l10n/translation','@odoo/owl','@web/core/confirmation_dialog/confirmation_dialog','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/popover/popover_hook','@web/core/utils/functions','@web/core/utils/hooks','@web/core/utils/timing','@web/model/relational_model/utils','@web/views/utils','@web/views/view_components/column_progress','@web/views/view_dialogs/form_view_dialog','@web/core/registry','@web/core/ui/ui_service'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component,useRef}=require("@odoo/owl");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{usePopover}=require("@web/core/popover/popover_hook");const{memoize}=require("@web/core/utils/functions");const{useService}=require("@web/core/utils/hooks");const{useDebounced}=require("@web/core/utils/timing");const{isRelational}=require("@web/model/relational_model/utils");const{isNull}=require("@web/views/utils");const{ColumnProgress}=require("@web/views/view_components/column_progress");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");const{registry}=require("@web/core/registry");const{utils}=require("@web/core/ui/ui_service");class KanbanHeaderTooltip extends Component{static template="web.KanbanGroupTooltip";static props={tooltip:Array,close:Function,};}
const KanbanHeader=__exports.KanbanHeader=class KanbanHeader extends Component{static template="web.KanbanHeader";static components={ColumnProgress,Dropdown,DropdownItem};static props={activeActions:{type:Object},canQuickCreate:{type:Boolean},deleteGroup:{type:Function},dialogClose:{type:Array},group:{type:Object},list:{type:Object},quickCreateState:{type:Object},scrollTop:{type:Function},tooltipInfo:{type:Object},progressBarState:{type:true,optional:true},};setup(){this.dialog=useService("dialog");this.orm=useService("orm");this.rootRef=useRef("root");this.popover=usePopover(KanbanHeaderTooltip);this.onTitleMouseEnter=useDebounced(this.onTitleMouseEnter,400);}
async onTitleMouseEnter(ev){if(!this.hasTooltip){return;}
const tooltip=await this.loadTooltip();if(tooltip.length){this.popover.open(ev.target,{tooltip});}}
onTitleMouseLeave(){this.onTitleMouseEnter.cancel();this.popover.close();}
get _configDropdownContainer(){return this.rootRef.el.closest(`.o_kanban_group[data-id="${this.props.group.id}"]`);}
get configItems(){const args={permissions:this.permissions,props:this.props};return registry.category("kanban_header_config_items").getEntries().map(([key,desc])=>({key,method:desc.method,label:desc.label,isVisible:typeof desc.isVisible==="function"?desc.isVisible(args):desc.isVisible,class:typeof desc.class==="function"?desc.class(args):desc.class,}));}
get progressBar(){return this.props.progressBarState?.getGroupInfo(this.group);}
get group(){return this.props.group;}
_getEmptyGroupLabel(fieldName){return _t("None");}
get groupName(){const{groupByField,displayName}=this.group;let name=displayName;if(groupByField.type==="boolean"){name=name?_t("Yes"):_t("No");}else if(!name){if(isRelational(groupByField)||groupByField.type==="date"||groupByField.type==="datetime"||isNull(name)){name=this._getEmptyGroupLabel(groupByField.name);}}
return name;}
get groupAggregate(){const{group,progressBarState}=this.props;const{sumField}=progressBarState.progressAttributes;return progressBarState.getAggregateValue(group,sumField);}
get hasTooltip(){const{name,type}=this.group.groupByField;return type==="many2one"&&this.group.value&&name in this.props.tooltipInfo;}
loadTooltip=memoize(async()=>{const{name,relation:resModel}=this.group.groupByField;const tooltipInfo=this.props.tooltipInfo[name];const fieldNames=Object.keys(tooltipInfo);const[values]=await this.orm.silent.read(resModel,[this.group.value],["display_name",...fieldNames]);return fieldNames.filter((fieldName)=>values[fieldName]).map((fieldName)=>({title:tooltipInfo[fieldName],value:values[fieldName]}));});archiveGroup(){this.dialog.add(ConfirmationDialog,{body:_t("Are you sure that you want to archive all the records from this column?"),confirmLabel:_t("Archive All"),confirm:()=>this.group.list.archive(),cancel:()=>{},});}
unarchiveGroup(){this.group.list.unarchive();}
deleteGroup(){this.dialog.add(ConfirmationDialog,{body:_t("Are you sure you want to delete this column?"),confirm:async()=>{this.props.deleteGroup(this.group);},confirmLabel:_t("Delete"),cancel:()=>{},});}
editGroup(){const{context,displayName,groupByField,value}=this.group;this.props.dialogClose.push(this.dialog.add(FormViewDialog,{context,resId:value,resModel:groupByField.relation,title:_t("Edit: %s",displayName),onRecordSaved:async()=>{await this.props.list.load();this.props.list.model.notify();},}));}
quickCreate(group){this.props.quickCreateState.groupId=this.group.id;}
toggleGroup(){return this.group.toggle();}
get permissions(){return["canArchiveGroup","canDeleteGroup","canEditGroup","canQuickCreate"].reduce((o,key)=>{Object.defineProperty(o,key,{get:()=>this[key]()});return o;},{});}
canArchiveGroup(){const{archiveGroup}=this.props.activeActions;const hasActiveField="active"in this.group.fields;return archiveGroup&&hasActiveField&&this.group.groupByField.type!=="many2many";}
canDeleteGroup(){const{deleteGroup}=this.props.activeActions;const{groupByField,value}=this.group;return deleteGroup&&isRelational(groupByField)&&value;}
canEditGroup(){const{editGroup}=this.props.activeActions;const{groupByField,value}=this.group;return editGroup&&isRelational(groupByField)&&value;}
canQuickCreate(){return this.props.canQuickCreate;}
async onBarClicked(value){await this.props.progressBarState.selectBar(this.props.group.id,value);this.props.scrollTop();}}
const kanbanHeaderConfigItems=registry.category("kanban_header_config_items");kanbanHeaderConfigItems.add("toggle_group",{label:_t("Fold"),method:"toggleGroup",isVisible:()=>!utils.isSmall(),class:({props})=>({o_kanban_toggle_fold:true,disabled:props.list.model.useSampleModel,}),},{sequence:10});kanbanHeaderConfigItems.add("edit_group",{label:_t("Edit"),method:"editGroup",isVisible:({permissions})=>permissions.canEditGroup,class:"o_column_edit",},{sequence:20});kanbanHeaderConfigItems.add("delete_group",{label:_t("Delete"),method:"deleteGroup",isVisible:({permissions})=>permissions.canDeleteGroup,class:"o_column_delete",},{sequence:30});kanbanHeaderConfigItems.add("archive_group",{label:_t("Archive All"),method:"archiveGroup",isVisible:({permissions})=>permissions.canArchiveGroup,class:({props})=>({o_column_archive_records:true,disabled:props.list.model.useSampleModel,}),},{sequence:40});kanbanHeaderConfigItems.add("unarchive_group",{label:_t("Unarchive All"),method:"unarchiveGroup",isVisible:({permissions})=>permissions.canArchiveGroup,class:({props})=>({o_column_unarchive_records:true,disabled:props.list.model.useSampleModel,}),},{sequence:50});return __exports;});;

/* /web/static/src/views/kanban/kanban_record.js */
odoo.define('@web/views/kanban/kanban_record',['@web/core/l10n/translation','@web/core/colorlist/colorlist','@web/core/py_js/py','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/registry','@web/core/user','@web/core/utils/hooks','@web/core/utils/html','@web/core/utils/urls','@web/model/relational_model/utils','@web/views/fields/field','@web/views/fields/image/image_field','@web/views/view_button/view_button','@web/views/view_compiler','@web/views/widgets/widget','@web/views/utils','@web/views/kanban/kanban_arch_parser','@web/views/kanban/kanban_compiler','@web/views/kanban/kanban_cover_image_dialog','@web/views/kanban/kanban_dropdown_menu_wrapper','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ColorList}=require("@web/core/colorlist/colorlist");const{evaluateBooleanExpr}=require("@web/core/py_js/py");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{isHtmlEmpty:_isHtmlEmpty}=require("@web/core/utils/html");const{imageUrl}=require("@web/core/utils/urls");const{useRecordObserver}=require("@web/model/relational_model/utils");const{Field}=require("@web/views/fields/field");const{fileTypeMagicWordMap}=require("@web/views/fields/image/image_field");const{ViewButton}=require("@web/views/view_button/view_button");const{useViewCompiler}=require("@web/views/view_compiler");const{Widget}=require("@web/views/widgets/widget");const{getFormattedValue}=require("@web/views/utils");const{LEGACY_KANBAN_BOX_ATTRIBUTE,LEGACY_KANBAN_MENU_ATTRIBUTE,KANBAN_CARD_ATTRIBUTE,KANBAN_MENU_ATTRIBUTE,}=require("@web/views/kanban/kanban_arch_parser");const{KanbanCompiler}=require("@web/views/kanban/kanban_compiler");const{KanbanCoverImageDialog}=require("@web/views/kanban/kanban_cover_image_dialog");const{KanbanDropdownMenuWrapper}=require("@web/views/kanban/kanban_dropdown_menu_wrapper");const{Component,onWillUpdateProps,useRef,useState}=require("@odoo/owl");const{COLORS}=ColorList;const formatters=registry.category("formatters");const CANCEL_GLOBAL_CLICK=__exports.CANCEL_GLOBAL_CLICK=["a",".dropdown",".oe_kanban_action","[data-bs-toggle]"].join(",");__exports.getColorIndex=getColorIndex;function getColorIndex(value){if(typeof value==="number"){return Math.round(value)%COLORS.length;}else if(typeof value==="string"){const charCodeSum=[...value].reduce((acc,_,i)=>acc+value.charCodeAt(i),0);return charCodeSum%COLORS.length;}else{return 0;}}
__exports.getRawValue=getRawValue;function getRawValue(record,fieldName){const field=record.fields[fieldName];const value=record.data[fieldName];switch(field.type){case"one2many":case"many2many":{return value.count?value.currentIds:[];}
case"many2one":{return(value&&value[0])||false;}
case"date":case"datetime":{return value&&value.toISO();}
default:{return value;}}}
function getValue(record,fieldName){const field=record.fields[fieldName];const value=record.data[fieldName];const formatter=formatters.get(field.type,String);return formatter(value,{field,data:record.data});}
__exports.getFormattedRecord=getFormattedRecord;function getFormattedRecord(record){const formattedRecord={id:{value:record.resId,raw_value:record.resId,},};for(const fieldName of record.fieldNames){formattedRecord[fieldName]={value:getValue(record,fieldName),raw_value:getRawValue(record,fieldName),};}
return formattedRecord;}
__exports.getImageSrcFromRecordInfo=getImageSrcFromRecordInfo;function getImageSrcFromRecordInfo(record,model,field,idOrIds,placeholder){const id=(Array.isArray(idOrIds)?idOrIds[0]:idOrIds)||null;const isCurrentRecord=record.resModel===model&&(record.resId===id||(!record.resId&&!id));const fieldVal=record.data[field];if(isCurrentRecord&&fieldVal&&!isBinSize(fieldVal)){const type=fileTypeMagicWordMap[fieldVal[0]];return`data:image/${type};base64,${fieldVal}`;}else if(placeholder&&(!model||!field||!id||!fieldVal)){return placeholder;}else{const unique=isCurrentRecord&&record.data.write_date;return imageUrl(model,id,field,{unique});}}
function isBinSize(value){return/^\d+(\.\d*)? [^0-9]+$/.test(value);}
__exports.isHtmlEmpty=isHtmlEmpty;function isHtmlEmpty(innerHTML=""){return _isHtmlEmpty(innerHTML);}
const KanbanRecord=__exports.KanbanRecord=class KanbanRecord extends Component{static components={Dropdown,DropdownItem,KanbanDropdownMenuWrapper,Field,KanbanCoverImageDialog,ViewButton,Widget,};static defaultProps={colors:COLORS,deleteRecord:()=>{},archiveRecord:()=>{},openRecord:()=>{},};static props=["archInfo","canResequence?","colors?","Compiler?","forceGlobalClick?","group?","list","deleteRecord?","archiveRecord?","openRecord?","readonly?","record","templates","progressBarState?",];static Compiler=KanbanCompiler;static LEGACY_KANBAN_BOX_ATTRIBUTE=LEGACY_KANBAN_BOX_ATTRIBUTE;static LEGACY_KANBAN_MENU_ATTRIBUTE=LEGACY_KANBAN_MENU_ATTRIBUTE;static KANBAN_CARD_ATTRIBUTE=KANBAN_CARD_ATTRIBUTE;static KANBAN_MENU_ATTRIBUTE=KANBAN_MENU_ATTRIBUTE;static menuTemplate="web.KanbanRecordMenu";static template="web.KanbanRecord";setup(){this.evaluateBooleanExpr=evaluateBooleanExpr;this.action=useService("action");this.dialog=useService("dialog");this.notification=useService("notification");const{archInfo,Compiler,templates}=this.props;const ViewCompiler=Compiler||this.constructor.Compiler;const isLegacy=archInfo.isLegacyArch;this.templates=useViewCompiler(ViewCompiler,templates,{isLegacy});this.menuTemplateName=this.props.archInfo.isLegacyArch?this.constructor.LEGACY_KANBAN_MENU_ATTRIBUTE:this.constructor.KANBAN_MENU_ATTRIBUTE;this.showMenu=this.menuTemplateName in templates;this.dataState=useState({record:{},widget:{}});this.createWidget(this.props);onWillUpdateProps(this.createWidget);useRecordObserver((record)=>Object.assign(this.dataState.record,getFormattedRecord(record)));this.rootRef=useRef("root");}
get record(){return this.dataState.record;}
getFormattedValue(fieldId){const{archInfo,record}=this.props;const{name}=archInfo.fieldNodes[fieldId];return getFormattedValue(record,name,archInfo.fieldNodes[fieldId]);}
createWidget(props){const{archInfo,list}=props;const{activeActions}=archInfo;const deletable=activeActions.delete&&(!list.groupByField||list.groupByField.type!=="many2many");const editable=activeActions.edit;this.dataState.widget={deletable,editable,};if(archInfo.isLegacyArch){this.dataState.widget.isHtmlEmpty=isHtmlEmpty;}}
getRecordClasses(){const{archInfo,canResequence,forceGlobalClick,record,progressBarState}=this.props;const classes=["o_kanban_record d-flex"];if(canResequence){classes.push("o_draggable");}
if(forceGlobalClick||archInfo.openAction||archInfo.canOpenRecords){classes.push("cursor-pointer");}
if(progressBarState){const{fieldName,colors}=progressBarState.progressAttributes;const value=record.data[fieldName];const color=colors[value];classes.push(`oe_kanban_card_${color}`);}
if(archInfo.cardColorField){const value=record.data[archInfo.cardColorField];classes.push(`o_kanban_color_${getColorIndex(value)}`);}
if(!this.props.list.isGrouped){classes.push("flex-grow-1 flex-md-shrink-1 flex-shrink-0");}
classes.push(archInfo.cardClassName);if(archInfo.isLegacyArch){classes.push("o_legacy_kanban_record");}
return classes.join(" ");}
getMenuClasses(){if(this.props.archInfo.isLegacyArch){return"o-dropdown--legacy-kanban-record-menu";}else{return"o-dropdown--kanban-record-menu";}}
onGlobalClick(ev){if(ev.target.closest(CANCEL_GLOBAL_CLICK)){return;}
const{archInfo,forceGlobalClick,openRecord,record}=this.props;if(!forceGlobalClick&&archInfo.openAction){this.action.doActionButton({name:archInfo.openAction.action,type:archInfo.openAction.type,resModel:record.resModel,resId:record.resId,resIds:record.resIds,context:record.context,onClose:async()=>{await record.model.root.load();},});}else if(forceGlobalClick||this.props.archInfo.canOpenRecords){openRecord(record);}}
triggerAction(params){const{archInfo,openRecord,deleteRecord,record,archiveRecord}=this.props;const{type}=params;switch(type){case"edit":{return openRecord(record,"edit");}
case"open":{return openRecord(record);}
case"archive":{return archiveRecord(record,true);}
case"unarchive":{return archiveRecord(record,false);}
case"delete":{return deleteRecord(record);}
case"set_cover":{const{autoOpen,fieldName}=params;const widgets=Object.values(archInfo.fieldNodes).filter((x)=>x.name===fieldName).map((x)=>x.widget);const field=record.fields[fieldName];if(field.type==="many2one"&&field.relation==="ir.attachment"&&widgets.includes("attachment_image")){this.dialog.add(KanbanCoverImageDialog,{autoOpen,fieldName,record});}else{const warning=_t(`Could not set the cover image: incorrect field ("%s") is provided in the view.`,fieldName);this.notification.add({title:warning,type:"danger"});}
break;}
default:{return this.notification.add(_t("Kanban: no action for type: %(type)s",{type}),{type:"danger",});}}}
get mainTemplate(){return this.props.archInfo.isLegacyArch?this.templates[this.constructor.LEGACY_KANBAN_BOX_ATTRIBUTE]:this.templates[this.constructor.KANBAN_CARD_ATTRIBUTE];}
get renderingContext(){const renderingContext={context:this.props.record.context,JSON,luxon,read_only_mode:this.props.readonly,record:this.dataState.record,selection_mode:this.props.forceGlobalClick,widget:this.dataState.widget,__comp__:Object.assign(Object.create(this),{this:this}),};if(this.props.archInfo.isLegacyArch){renderingContext.kanban_image=(...args)=>getImageSrcFromRecordInfo(this.props.record,...args);renderingContext.user_context=user.context;}
return renderingContext;}}
return __exports;});;

/* /web/static/src/views/kanban/kanban_record_quick_create.js */
odoo.define('@web/views/kanban/kanban_record_quick_create',['@web/core/l10n/translation','@web/core/utils/xml','@web/core/hotkeys/hotkey_hook','@web/core/utils/hooks','@odoo/owl','@web/core/network/rpc','@web/model/relational_model/utils','@web/views/form/form_view','@web/views/view','@web/views/view_dialogs/form_view_dialog'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{parseXML}=require("@web/core/utils/xml");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{useOwnedDialogs,useService}=require("@web/core/utils/hooks");const{Component,onMounted,onWillStart,useExternalListener,useRef,useState,useSubEnv,}=require("@odoo/owl");const{RPCError}=require("@web/core/network/rpc");const{extractFieldsFromArchInfo}=require("@web/model/relational_model/utils");const{formView}=require("@web/views/form/form_view");const{getDefaultConfig}=require("@web/views/view");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");const DEFAULT_QUICK_CREATE_VIEW={arch:`
        <form>
            <field name="display_name" placeholder="Title" required="True" />
        </form>`,};const DEFAULT_QUICK_CREATE_FIELDS={display_name:{string:"Display name",type:"char"},};const ACTION_SELECTORS=[".o_kanban_quick_add",".o_kanban_load_more button",".o-kanban-button-new",];const KanbanQuickCreateController=__exports.KanbanQuickCreateController=class KanbanQuickCreateController extends Component{static props={Model:Function,Renderer:Function,Compiler:Function,resModel:String,onValidate:Function,onCancel:Function,fields:{type:Object},context:{type:Object},archInfo:{type:Object},};static template="web.KanbanQuickCreateController";setup(){super.setup();this.uiService=useService("ui");this.rootRef=useRef("root");this.state=useState({disabled:false});this.addDialog=useOwnedDialogs();const{activeFields,fields}=extractFieldsFromArchInfo(this.props.archInfo,this.props.fields);const modelServices=Object.fromEntries(this.props.Model.services.map((servName)=>{return[servName,useService(servName)];}));modelServices.orm=useService("orm");const config={resModel:this.props.resModel,resId:false,resIds:[],fields,activeFields,isMonoRecord:true,mode:"edit",context:this.props.context,};this.model=useState(new this.props.Model(this.env,{config},modelServices));onWillStart(()=>this.model.load());onMounted(()=>{this.uiActiveElement=this.uiService.activeElement;});useExternalListener(window,"mousedown",(ev)=>{this.mousedownTarget=ev.target;});useExternalListener(window,"click",(ev)=>{if(this.uiActiveElement!==this.uiService.activeElement){return;}
const target=this.mousedownTarget||ev.target;const gotClickedInside=target.closest(".o_datetime_picker")||target.closest(".ui-autocomplete")||this.rootRef.el.contains(target);if(!gotClickedInside){let force=false;for(const selector of ACTION_SELECTORS){const closestEl=target.closest(selector);if(closestEl){force=true;break;}}
this.cancel(force);}
this.mousedownTarget=null;},{capture:true});useHotkey("enter",()=>this.validate("add"),{bypassEditableProtection:true});useHotkey("escape",()=>this.cancel(true));}
async validate(mode){let resId=undefined;if(this.state.disabled){return;}
this.state.disabled=true;const keys=Object.keys(this.model.root.activeFields);if(keys.length===1&&keys[0]==="display_name"){const isValid=await this.model.root.checkValidity();if(isValid){try{[resId]=await this.model.orm.call(this.props.resModel,"name_create",[this.model.root.data.display_name],{context:this.props.context,});}catch(e){this.showFormDialogInError(e);}}else{this.model.notification.add(_t("Display Name"),{title:_t("Invalid fields: "),type:"danger",});}}else{await this.model.root.save({reload:false,onError:(e)=>this.showFormDialogInError(e),});resId=this.model.root.resId;}
if(resId){await this.props.onValidate(resId,mode);if(mode==="add"){await this.model.load({resId:false});}}
this.state.disabled=false;}
async cancel(force){if(this.state.disabled){return;}
if(force||!(await this.model.root.isDirty())){this.props.onCancel();}}
showFormDialogInError(e){if(!(e instanceof RPCError)){throw e;}
const context=this.props.context;const values=this.model.root.data;context.default_name=values.name||values.display_name;this.addDialog(FormViewDialog,{resModel:this.props.resModel,context,title:_t("Create"),onRecordSaved:async(record)=>{await this.props.onValidate(record.resId,"add");await this.model.load();},});}
get className(){return"o_kanban_quick_create o_field_highlight shadow";}}
const KanbanRecordQuickCreate=__exports.KanbanRecordQuickCreate=class KanbanRecordQuickCreate extends Component{static components={KanbanQuickCreateController};static template="web.KanbanRecordQuickCreate";static props={quickCreateView:{type:[String,{value:null}],optional:1},onValidate:Function,onCancel:Function,group:Object,};setup(){this.state=useState({isLoaded:false,});this.viewService=useService("view");onMounted(()=>{this.getQuickCreateProps(this.props).then(()=>{this.state.isLoaded=true;});});useSubEnv({config:getDefaultConfig(),});}
async getQuickCreateProps(props){let quickCreateFields={fields:DEFAULT_QUICK_CREATE_FIELDS};let quickCreateForm=DEFAULT_QUICK_CREATE_VIEW;let quickCreateRelatedModels={};if(props.quickCreateView){const{fields,relatedModels,views}=await this.viewService.loadViews({context:{...props.context,form_view_ref:props.quickCreateView},resModel:props.group.resModel,views:[[false,"form"]],});quickCreateFields={fields:fields};quickCreateForm=views.form;quickCreateRelatedModels=relatedModels;}
const models={...quickCreateRelatedModels,[props.group.resModel]:quickCreateFields,};const archInfo=new formView.ArchParser().parse(parseXML(quickCreateForm.arch),models,props.group.resModel);this.quickCreateProps={Model:formView.Model,Renderer:formView.Renderer,Compiler:formView.Compiler,resModel:props.group.resModel,onValidate:props.onValidate,onCancel:props.onCancel,fields:quickCreateFields.fields,context:props.group.context,archInfo,};}}
return __exports;});;

/* /web/static/src/views/kanban/kanban_renderer.js */
odoo.define('@web/views/kanban/kanban_renderer',['@web/core/l10n/translation','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/hotkeys/hotkey_hook','@web/core/registry','@web/core/utils/hooks','@web/core/utils/sortable_owl','@web/views/utils','@web/views/view_components/column_progress','@web/views/view_hook','@web/views/kanban/kanban_column_quick_create','@web/views/kanban/kanban_header','@web/views/kanban/kanban_record','@web/views/kanban/kanban_record_quick_create','@web/core/confirmation_dialog/confirmation_dialog','@odoo/owl','@web/core/py_js/py'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{registry}=require("@web/core/registry");const{useBus,useService}=require("@web/core/utils/hooks");const{useSortable}=require("@web/core/utils/sortable_owl");const{isNull}=require("@web/views/utils");const{ColumnProgress}=require("@web/views/view_components/column_progress");const{useBounceButton}=require("@web/views/view_hook");const{KanbanColumnQuickCreate}=require("@web/views/kanban/kanban_column_quick_create");const{KanbanHeader}=require("@web/views/kanban/kanban_header");const{KanbanRecord}=require("@web/views/kanban/kanban_record");const{KanbanRecordQuickCreate}=require("@web/views/kanban/kanban_record_quick_create");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{Component,onWillDestroy,useRef,useState}=require("@odoo/owl");const{evaluateExpr}=require("@web/core/py_js/py");const DRAGGABLE_GROUP_TYPES=["many2one"];const MOVABLE_RECORD_TYPES=["char","boolean","integer","selection","many2one"];function validateColumnQuickCreateExamples(data){const{allowedGroupBys=[],examples=[],foldField=""}=data;if(!allowedGroupBys.length){throw new Error("The example data must contain an array of allowed groupbys");}
if(!examples.length){throw new Error("The example data must contain an array of examples");}
const someHasFoldedColumns=examples.some(({foldedColumns=[]})=>foldedColumns.length);if(!foldField&&someHasFoldedColumns){throw new Error("The example data must contain a fold field if there are folded columns");}}
const KanbanRenderer=__exports.KanbanRenderer=class KanbanRenderer extends Component{static template="web.KanbanRenderer";static components={Dropdown,DropdownItem,ColumnProgress,KanbanColumnQuickCreate,KanbanHeader,KanbanRecord,KanbanRecordQuickCreate,};static props=["archInfo","Compiler?","list","deleteRecord","openRecord","readonly","forceGlobalClick?","noContentHelp?","scrollTop?","canQuickCreate?","quickCreateState?","progressBarState?",];static defaultProps={scrollTop:()=>{},quickCreateState:{groupId:false},tooltipInfo:{},};setup(){this.dialogClose=[];this.state=useState({processedIds:[],columnQuickCreateIsFolded:!this.props.list.isGrouped||this.props.list.groups.length>0,});this.dialog=useService("dialog");this.exampleData=registry.category("kanban_examples").get(this.props.archInfo.examples,null);if(this.exampleData){validateColumnQuickCreateExamples(this.exampleData);}
this.ghostColumns=this.generateGhostColumns();let dataRecordId;let dataGroupId;this.rootRef=useRef("root");if(this.canUseSortable){useSortable({enable:()=>this.canResequenceRecords,ref:this.rootRef,elements:".o_draggable",ignore:".dropdown,select",groups:()=>this.props.list.isGrouped&&".o_kanban_group",connectGroups:()=>this.canMoveRecords,cursor:"move",onDragStart:(params)=>{const{element,group}=params;dataRecordId=element.dataset.id;dataGroupId=group&&group.dataset.id;return this.sortStart(params);},onDragEnd:(params)=>this.sortStop(params),onGroupEnter:(params)=>this.sortRecordGroupEnter(params),onGroupLeave:(params)=>this.sortRecordGroupLeave(params),onDrop:(params)=>this.sortRecordDrop(dataRecordId,dataGroupId,params),});useSortable({enable:()=>this.canResequenceGroups,ref:this.rootRef,elements:".o_group_draggable",handle:".o_column_title",cursor:"move",onDragStart:(params)=>{const{element}=params;dataGroupId=element.dataset.id;return this.sortStart(params);},onDragEnd:(params)=>this.sortStop(params),onDrop:(params)=>this.sortGroupDrop(dataGroupId,params),});}
useBounceButton(this.rootRef,(clickedEl)=>{if(this.props.list.isGrouped?!this.props.list.recordCount:!this.props.list.count||this.props.list.model.useSampleModel){return clickedEl.matches([".o_kanban_renderer",".o_kanban_group",".o_kanban_header",".o_column_quick_create",".o_view_nocontent_smiling_face",].join(", "));}
return false;});onWillDestroy(()=>{this.dialogClose.forEach((close)=>close());});if(this.env.searchModel){useBus(this.env.searchModel,"focus-view",()=>{const{model}=this.props.list;if(model.useSampleModel||!model.hasData()){return;}
const firstCard=this.rootRef.el.querySelector(".o_kanban_record");if(firstCard){firstCard.focus();}});}
useHotkey("Enter",({target})=>{if(!target.classList.contains("o_kanban_record")){return;}
if(this.props.archInfo.canOpenRecords){target.click();return;}
const firstLink=target.querySelector("a, button");if(firstLink){firstLink.click();}},{area:()=>this.rootRef.el});const arrowsOptions={area:()=>this.rootRef.el,allowRepeat:true};if(this.env.searchModel){useHotkey("ArrowUp",({area})=>{if(!this.focusNextCard(area,"up")){this.env.searchModel.trigger("focus-search");}},arrowsOptions);}
useHotkey("ArrowDown",({area})=>this.focusNextCard(area,"down"),arrowsOptions);useHotkey("ArrowLeft",({area})=>this.focusNextCard(area,"left"),arrowsOptions);useHotkey("ArrowRight",({area})=>this.focusNextCard(area,"right"),arrowsOptions);}
get canUseSortable(){return!this.env.isSmall;}
get canMoveRecords(){if(!this.canResequenceRecords){return false;}
const groupByField=this.props.list.groupByField;if(!groupByField){return true;}
const fieldNodes=Object.values(this.props.archInfo.fieldNodes).filter((fieldNode)=>fieldNode.name===groupByField.name);let isReadonly=this.props.list.fields[groupByField.name].readonly;if(!isReadonly&&fieldNodes.length){isReadonly=fieldNodes.every((fieldNode)=>{if(!fieldNode.readonly){return false;}
try{return evaluateExpr(fieldNode.readonly,this.props.list.evalContext);}catch{return false;}});}
return!isReadonly&&this.isMovableField(groupByField);}
get canResequenceGroups(){if(!this.props.list.isGrouped){return false;}
const{type}=this.props.list.groupByField;const{groupsDraggable}=this.props.archInfo;return groupsDraggable&&DRAGGABLE_GROUP_TYPES.includes(type);}
get canResequenceRecords(){const{isGrouped,orderBy}=this.props.list;const{handleField,recordsDraggable}=this.props.archInfo;return Boolean(recordsDraggable&&(isGrouped||(handleField&&(!orderBy[0]||orderBy[0].name===handleField))));}
get showNoContentHelper(){const{model,isGrouped,groupByField,groups}=this.props.list;if(model.useSampleModel){return true;}
if(isGrouped){if(this.props.quickCreateState.groupId){return false;}
if(this.canCreateGroup()&&!this.state.columnQuickCreateIsFolded){return false;}
if(groups.length===0){return groupByField.type!=="many2one";}}
return!model.hasData();}
getGroupsOrRecords(){const{list}=this.props;if(list.isGrouped){return[...list.groups].sort((a,b)=>(a.value&&!b.value?1:!a.value&&b.value?-1:0)).map((group,i)=>({group,key:isNull(group.value)?`group_key_${i}`:String(group.value),}));}else{return list.records.map((record)=>({record,key:record.id}));}}
getGroupClasses(group,isGroupProcessing){const classes=[];if(!isGroupProcessing&&this.canResequenceGroups&&group.value){classes.push("o_group_draggable");}
if(!group.count){classes.push("o_kanban_no_records");}
if(!this.env.isSmall&&group.isFolded){classes.push("o_column_folded","flex-basis-0");}
if(this.props.progressBarState&&!group.isFolded){const progressBarInfo=this.props.progressBarState.getGroupInfo(group);if(progressBarInfo.activeBar){const progressBar=progressBarInfo.bars.find((b)=>b.value===progressBarInfo.activeBar);classes.push("o_kanban_group_show",`o_kanban_group_show_${progressBar.color}`);}}
return classes.join(" ");}
getGroupUnloadedCount(group){const records=group.list.records.filter((r)=>!r.isInQuickCreation);const count=this.props.progressBarState?.getGroupCount(group)||group.count;return count-records.length;}
generateGhostColumns(){let colNames;if(this.exampleData&&this.exampleData.ghostColumns){colNames=this.exampleData.ghostColumns;}else{colNames=[1,2,3,4].map((num)=>_t("Column %s",num));}
return colNames.map((colName)=>({name:colName,cards:new Array(Math.floor(Math.random()*4)+2),}));}
isProcessing(id){return this.state.processedIds.includes(id);}
isMovableField(field){return MOVABLE_RECORD_TYPES.includes(field.type);}
canCreateGroup(){const{activeActions}=this.props.archInfo;return activeActions.createGroup&&this.props.list.groupByField.type==="many2one";}
canQuickCreate(){return this.props.canQuickCreate;}
async archiveRecord(record,active){if(active){this.dialog.add(ConfirmationDialog,{body:_t("Are you sure that you want to archive this record?"),confirmLabel:_t("Archive"),confirm:()=>record.archive(),cancel:()=>{},});}else{return record.unarchive();}}
async validateQuickCreate(recordId,mode,group){this.props.quickCreateState.groupId=false;if(mode==="add"){this.props.quickCreateState.groupId=group.id;}
const record=await group.addExistingRecord(recordId,true);group.model.bus.trigger("group-updated",{group:group,withProgressBars:true,});if(mode==="edit"){await this.props.openRecord(record,"edit");}else{this.props.progressBarState?.updateCounts(group);}}
cancelQuickCreate(){this.props.quickCreateState.groupId=false;}
async deleteGroup(group){await this.props.list.deleteGroups([group]);if(this.props.list.groups.length===0){this.state.columnQuickCreateIsFolded=false;}}
toggleGroup(group){return group.toggle();}
loadMore(group){return group.list.load({limit:group.list.records.length+group.model.initialLimit});}
toggleProcessing(id,isProcessing){if(isProcessing){this.state.processedIds=[...this.state.processedIds,id];}else{this.state.processedIds=this.state.processedIds.filter((processedId)=>processedId!==id);}}
async onGroupClick(group,ev){if(!this.env.isSmall&&group.isFolded){await group.toggle();this.props.scrollTop();}}
async sortGroupDrop(dataGroupId,{previous}){this.toggleProcessing(dataGroupId,true);const refId=previous?previous.dataset.id:null;try{await this.props.list.resequence(dataGroupId,refId);}finally{this.toggleProcessing(dataGroupId,false);}}
async sortRecordDrop(dataRecordId,dataGroupId,{element,parent,previous}){if(!this.props.list.isGrouped||parent.classList.contains("o_kanban_hover")||parent.dataset.id===element.parentElement.dataset.id){this.toggleProcessing(dataRecordId,true);parent?.classList.remove("o_kanban_hover");while(previous&&!previous.dataset.id){previous=previous.previousElementSibling;}
const refId=previous?previous.dataset.id:null;const targetGroupId=parent?.dataset.id;try{await this.props.list.moveRecord(dataRecordId,dataGroupId,refId,targetGroupId);}finally{this.toggleProcessing(dataRecordId,false);}}}
sortRecordGroupEnter({group}){group.classList.add("o_kanban_hover");}
sortRecordGroupLeave({group}){group.classList.remove("o_kanban_hover");}
sortStart({element}){element.classList.add("shadow");}
sortStop({element,group}){element.classList.remove("shadow");if(group){group.classList.remove("o_kanban_hover");}}
focusNextCard(area,direction){const{isGrouped}=this.props.list;const closestCard=document.activeElement.closest(".o_kanban_record");if(!closestCard){return;}
const groups=isGrouped?[...area.querySelectorAll(".o_kanban_group")]:[area];const cards=[...groups].map((group)=>[...group.querySelectorAll(".o_kanban_record")]).filter((group)=>group.length);let iGroup;let iCard;for(iGroup=0;iGroup<cards.length;iGroup++){const i=cards[iGroup].indexOf(closestCard);if(i!==-1){iCard=i;break;}}
let nextCard;switch(direction){case"down":nextCard=iCard<cards[iGroup].length-1&&cards[iGroup][iCard+1];break;case"up":nextCard=iCard>0&&cards[iGroup][iCard-1];break;case"right":if(isGrouped){nextCard=iGroup<cards.length-1&&cards[iGroup+1][0];}else{nextCard=iCard<cards[0].length-1&&cards[0][iCard+1];}
break;case"left":if(isGrouped){nextCard=iGroup>0&&cards[iGroup-1][0];}else{nextCard=iCard>0&&cards[0][iCard-1];}
break;}
if(nextCard&&nextCard instanceof HTMLElement){nextCard.focus();return true;}}}
return __exports;});;

/* /web/static/src/views/kanban/kanban_view.js */
odoo.define('@web/views/kanban/kanban_view',['@web/core/registry','@web/model/relational_model/relational_model','@web/views/kanban/kanban_arch_parser','@web/views/kanban/kanban_compiler','@web/views/kanban/kanban_controller','@web/views/kanban/kanban_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{RelationalModel}=require("@web/model/relational_model/relational_model");const{KanbanArchParser}=require("@web/views/kanban/kanban_arch_parser");const{KanbanCompiler}=require("@web/views/kanban/kanban_compiler");const{KanbanController}=require("@web/views/kanban/kanban_controller");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const kanbanView=__exports.kanbanView={type:"kanban",ArchParser:KanbanArchParser,Controller:KanbanController,Model:RelationalModel,Renderer:KanbanRenderer,Compiler:KanbanCompiler,buttonTemplate:"web.KanbanView.Buttons",props:(genericProps,view)=>{const{arch,relatedModels,resModel}=genericProps;const{ArchParser}=view;const archInfo=new ArchParser().parse(arch,relatedModels,resModel);const defaultGroupBy=genericProps.searchMenuTypes.includes("groupBy")&&archInfo.defaultGroupBy;return{...genericProps,Model:view.Model,Renderer:view.Renderer,buttonTemplate:view.buttonTemplate,archInfo,defaultGroupBy,};},};registry.category("views").add("kanban",kanbanView);return __exports;});;

/* /web/static/src/views/kanban/progress_bar_hook.js */
odoo.define('@web/views/kanban/progress_bar_hook',['@odoo/owl','@web/core/domain','@web/core/l10n/translation','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{reactive}=require("@odoo/owl");const{Domain}=require("@web/core/domain");const{_t}=require("@web/core/l10n/translation");const{extractInfoFromGroupData}=require("@web/model/relational_model/utils");const FALSE=Symbol("False");function _findGroup(groups,groupByField,value){return groups.find((g)=>g[groupByField.name]===value)||{};}
function _createFilterDomain(fieldName,bars,value){let filterDomain=undefined;if(value===FALSE){const keys=bars.filter((x)=>x.value!==FALSE).map((x)=>x.value);filterDomain=["!",[fieldName,"in",keys]];}else{filterDomain=[[fieldName,"=",value]];}
return filterDomain;}
function _groupsToAggregateValues(groups,groupBy,fields){const groupByFieldName=groupBy[0].split(":")[0];return groups.map((g)=>{const groupInfo=extractInfoFromGroupData(g,groupBy,fields);return Object.assign(groupInfo.aggregates,{[groupByFieldName]:groupInfo.serverValue});});}
class ProgressBarState{constructor(progressAttributes,model,aggregateFields,activeBars={}){this.progressAttributes=progressAttributes;this.model=model;this._groupsInfo={};this._aggregateFields=aggregateFields;this.activeBars=activeBars;this._aggregateValues=[];this._pbCounts=null;}
getGroupInfo(group){if(!this._groupsInfo[group.id]){const aggValues=_findGroup(this._aggregateValues,group.groupByField,group.serverValue);const index=this._aggregateValues.indexOf(aggValues);if(index>-1){this._aggregateValues.splice(index,1);}
this._aggregateValues.push({...group.aggregates,[group.groupByField.name]:group.serverValue,});const groupValue=this._getGroupValue(group);const pbCount=this._pbCounts[groupValue];const{fieldName,colors}=this.progressAttributes;const{selection:fieldSelection}=this.model.root.fields[fieldName];const selection=fieldSelection&&Object.fromEntries(fieldSelection);const bars=Object.entries(colors).map(([value,color])=>{let string;if(selection){string=selection[value];}else{string=String(value);}
return{count:(pbCount&&pbCount[value])||0,value,string,color,};});bars.push({count:group.count-bars.map((r)=>r.count).reduce((a,b)=>a+b,0),value:FALSE,string:_t("Other"),color:"200",});if(this.activeBars[group.serverValue]){this.activeBars[group.serverValue].count=bars.find((x)=>x.value===this.activeBars[group.serverValue].value).count;if(this.activeBars[group.serverValue].count===0){group.applyFilter(undefined).then(()=>{delete this.activeBars[group.serverValue];group.model.notify();});}
if(this._aggregateFields.length){this.activeBars[group.serverValue].aggregates=_findGroup(this._aggregateValues,group.groupByField,group.serverValue);}}
const self=this;const progressBar={get activeBar(){return self.activeBars[group.serverValue]?.value||null;},bars,};this._groupsInfo[group.id]=progressBar;}
return this._groupsInfo[group.id];}
getAggregateValue(group,aggregateField){const title=aggregateField?aggregateField.string:_t("Count");let value=0;if(!this.activeBars[group.serverValue]){value=group.count;if(aggregateField){value=_findGroup(this._aggregateValues,group.groupByField,group.serverValue)[aggregateField.name]||0;}}else{value=this.activeBars[group.serverValue].count;if(aggregateField){value=(this.activeBars[group.serverValue]?.aggregates&&this.activeBars[group.serverValue]?.aggregates[aggregateField.name])||0;}}
return{title,value};}
async selectBar(groupId,bar){const group=this.model.root.groups.find((group)=>group.id===groupId);const progressBar=this.getGroupInfo(group);const nextActiveBar={};if(bar.value&&this.activeBars[group.serverValue]?.value!==bar.value){nextActiveBar.value=bar.value;}else{group.applyFilter(undefined).then(()=>{delete this.activeBars[group.serverValue];group.model.notify();});return;}
const{bars}=progressBar;const filterDomain=_createFilterDomain(this.progressAttributes.fieldName,bars,nextActiveBar.value);const proms=[];proms.push(group.applyFilter(filterDomain).then((res)=>{const groupInfo=this.getGroupInfo(group);nextActiveBar.count=groupInfo.bars.find((x)=>x.value===nextActiveBar.value).count;}));if(this._aggregateFields.length){proms.push(this._updateAggregateGroup(group,bars,nextActiveBar));}
await Promise.all(proms);this.activeBars[group.serverValue]=nextActiveBar;this.updateCounts(group);}
_updateAggregateGroup(group,bars,activeBar){const filterDomain=_createFilterDomain(this.progressAttributes.fieldName,bars,activeBar.value);const{context,fields,groupBy,resModel}=this.model.root;const kwargs={context};const fieldNames=[...this._aggregateFields.map((f)=>f.name),group.groupByField.name];const domain=filterDomain?Domain.and([group.groupDomain,filterDomain]).toList():group.groupDomain;return this.model.orm.webReadGroup(resModel,domain,fieldNames,groupBy,kwargs).then((res)=>{if(res.length){const groupByField=group.groupByField;const aggrValues=_groupsToAggregateValues(res.groups,groupBy,fields);activeBar.aggregates=_findGroup(aggrValues,groupByField,group.serverValue);}});}
updateCounts(group){this._updateProgressBar();if(this._aggregateFields.length){this._updateAggregates();this.updateAggreagteGroup(group);}
for(const group of this.model.root.groups){if(this.activeBars[group.serverValue]&&group.list.count===0){this.selectBar(group.id,{value:null});}}}
updateAggreagteGroup(group){if(group&&this.activeBars[group.serverValue]){const{bars}=this.getGroupInfo(group);this._updateAggregateGroup(group,bars,this.activeBars[group.serverValue]);}}
async _updateAggregates(){const{context,fields,groupBy,domain,resModel}=this.model.root;const fieldsName=this._aggregateFields.map((f)=>f.name);const firstGroupByName=groupBy[0].split(":")[0];const kwargs={context};const res=await this.model.orm.webReadGroup(resModel,domain,[...fieldsName,firstGroupByName],groupBy,kwargs);this._aggregateValues=_groupsToAggregateValues(res.groups,groupBy,fields);}
async _updateProgressBar(){const groupBy=this.model.root.groupBy;const defaultGroupBy=this.model.root.defaultGroupBy;if(groupBy.length||defaultGroupBy){const resModel=this.model.root.resModel;const domain=this.model.root.domain;const context=this.model.root.context;const{colors,fieldName:field,help}=this.progressAttributes;const groupsId=this.model.root.groups.map((g)=>g.id).join();const res=await this.model.orm.call(resModel,"read_progress_bar",[],{domain,group_by:groupBy.length?groupBy[0]:defaultGroupBy,progress_bar:{colors,field,help},context,});if(groupsId!==this.model.root.groups.map((g)=>g.id).join()){return;}
this._pbCounts=res;for(const group of this.model.root.groups){if(!group.isFolded){const groupInfo=this.getGroupInfo(group);const groupValue=this._getGroupValue(group);const counts=res[groupValue];for(const bar of groupInfo.bars){bar.count=(counts&&counts[bar.value])||0;}
groupInfo.bars.find((b)=>b.value===FALSE).count=counts?group.count-Object.values(counts).reduce((a,b)=>a+b,0):group.count;if(this.activeBars[group.serverValue]){this.activeBars[group.serverValue].count=groupInfo.bars.find((x)=>x.value===this.activeBars[group.serverValue].value).count;}}}}}
async loadProgressBar({context,domain,groupBy,resModel}){if(groupBy.length){const{colors,fieldName:field,help}=this.progressAttributes;const res=await this.model.orm.call(resModel,"read_progress_bar",[],{domain,group_by:groupBy[0],progress_bar:{colors,field,help},context,});this._pbCounts=res;}}
getGroupCount(group){const progressBarInfo=this.getGroupInfo(group);if(progressBarInfo.activeBar){const progressBar=progressBarInfo.bars.find((b)=>b.value===progressBarInfo.activeBar);return progressBar.count;}}
_getGroupValue(group){if(group.groupByField.type==="date"||group.groupByField.type==="datetime"){return group.displayName||"False";}
if(group.value===true){return"True";}else if(group.value===false){return"False";}
return group.value;}}
__exports.useProgressBar=useProgressBar;function useProgressBar(progressAttributes,model,aggregateFields,activeBars){const progressBarState=reactive(new ProgressBarState(progressAttributes,model,aggregateFields,activeBars));let prom;const onWillLoadRoot=model.hooks.onWillLoadRoot;model.hooks.onWillLoadRoot=(config)=>{onWillLoadRoot();prom=progressBarState.loadProgressBar({context:config.context,domain:config.domain,groupBy:config.groupBy,resModel:config.resModel,});};const onRootLoaded=model.hooks.onRootLoaded;model.hooks.onRootLoaded=async()=>{await onRootLoaded();return prom;};return progressBarState;}
return __exports;});;

/* /web/static/src/views/list/column_width_hook.js */
odoo.define('@web/views/list/column_width_hook',['@web/core/utils/timing','@odoo/owl'],function(require){'use strict';let __exports={};const{useDebounced}=require("@web/core/utils/timing");const{useComponent,useEffect,useExternalListener}=require("@odoo/owl");const DEFAULT_MIN_WIDTH=80;const SELECTOR_WIDTH=20;const OPEN_FORM_VIEW_BUTTON_WIDTH=54;const DELETE_BUTTON_WIDTH=12;const FIELD_WIDTHS={boolean:[20,100],char:[80],date:80,datetime:145,float:93,integer:71,many2many:[80],many2one_reference:[80],many2one:[80],monetary:105,one2many:[80],reference:[80],selection:[80],text:[80,1200],};function computeWidths(table,state,allowedWidth,startingWidths){let _columnWidths;const headers=[...table.querySelectorAll("thead th")];const columns=state.columns;if(startingWidths){_columnWidths=startingWidths.slice();}else if(state.isEmpty){_columnWidths=headers.map(()=>allowedWidth/headers.length);}else{table.style.tableLayout="auto";headers.forEach((th)=>{th.style.width=null;});table.classList.add("o_list_computing_widths");_columnWidths=headers.map((th)=>th.getBoundingClientRect().width);table.classList.remove("o_list_computing_widths");}
if(state.hasSelectors){_columnWidths[0]=SELECTOR_WIDTH;}
if(state.hasOpenFormViewColumn){const index=_columnWidths.length-(state.hasActionsColumn?2:1);_columnWidths[index]=OPEN_FORM_VIEW_BUTTON_WIDTH;}
if(state.hasActionsColumn){_columnWidths[_columnWidths.length-1]=DELETE_BUTTON_WIDTH;}
const columnWidthSpecs=getWidthSpecs(columns);const columnOffset=state.hasSelectors?1:0;for(let columnIndex=0;columnIndex<columns.length;columnIndex++){const thIndex=columnIndex+columnOffset;const{minWidth,maxWidth}=columnWidthSpecs[columnIndex];if(_columnWidths[thIndex]<minWidth){_columnWidths[thIndex]=minWidth;}else if(maxWidth&&_columnWidths[thIndex]>maxWidth){_columnWidths[thIndex]=maxWidth;}}
const totalWidth=_columnWidths.reduce((tot,width)=>tot+width,0);let diff=totalWidth-allowedWidth;if(diff>=1){const shrinkableColumns=[];let totalAvailableSpace=0;for(let columnIndex=0;columnIndex<columns.length;columnIndex++){const thIndex=columnIndex+columnOffset;const{minWidth,canShrink}=columnWidthSpecs[columnIndex];if(_columnWidths[thIndex]>minWidth&&canShrink){shrinkableColumns.push({thIndex,minWidth});totalAvailableSpace+=_columnWidths[thIndex]-minWidth;}}
if(diff>totalAvailableSpace){for(const{thIndex,minWidth}of shrinkableColumns){_columnWidths[thIndex]=minWidth;}}else{let remainingColumnsToShrink=shrinkableColumns.length;while(diff>=1){const colDiff=diff/remainingColumnsToShrink;for(const{thIndex,minWidth}of shrinkableColumns){const currentWidth=_columnWidths[thIndex];if(currentWidth===minWidth){continue;}
const newWidth=Math.max(currentWidth-colDiff,minWidth);diff-=currentWidth-newWidth;_columnWidths[thIndex]=newWidth;if(newWidth===minWidth){remainingColumnsToShrink--;}}}}}else if(diff<=-1){diff=-diff;const expandableColumns=[];for(let columnIndex=0;columnIndex<columns.length;columnIndex++){const thIndex=columnIndex+columnOffset;const maxWidth=columnWidthSpecs[columnIndex].maxWidth;if(!maxWidth||_columnWidths[thIndex]<maxWidth){expandableColumns.push({thIndex,maxWidth});}}
let remainingExpandableColumns=expandableColumns.length;while(diff>=1&&remainingExpandableColumns>0){const colDiff=diff/remainingExpandableColumns;for(const{thIndex,maxWidth}of expandableColumns){const currentWidth=_columnWidths[thIndex];const newWidth=Math.min(currentWidth+colDiff,maxWidth||Number.MAX_VALUE);diff-=newWidth-currentWidth;_columnWidths[thIndex]=newWidth;if(newWidth===maxWidth){remainingExpandableColumns--;}}}
if(diff>=1){for(let columnIndex=0;columnIndex<columns.length;columnIndex++){const thIndex=columnIndex+columnOffset;_columnWidths[thIndex]+=diff/columns.length;}}}
return _columnWidths;}
function getWidthSpecs(columns){return columns.map((column)=>{let minWidth;let maxWidth;if(column.attrs&&column.attrs.width){minWidth=maxWidth=parseInt(column.attrs.width.split("px")[0]);}else{let width;if(column.type==="field"){if(column.field.listViewWidth){width=column.field.listViewWidth;if(typeof width==="function"){width=width({type:column.fieldType,hasLabel:column.hasLabel});}}else{width=FIELD_WIDTHS[column.widget||column.fieldType];}}else if(column.type==="widget"){width=column.widget.listViewWidth;}
if(width){minWidth=Array.isArray(width)?width[0]:width;maxWidth=Array.isArray(width)?width[1]:width;}else{minWidth=DEFAULT_MIN_WIDTH;}}
return{minWidth,maxWidth,canShrink:column.type==="field"};});}
function getHorizontalPadding(el){const{paddingLeft,paddingRight}=getComputedStyle(el);return parseFloat(paddingLeft)+parseFloat(paddingRight);}
__exports.useMagicColumnWidths=useMagicColumnWidths;function useMagicColumnWidths(tableRef,getState){const renderer=useComponent();let columnWidths=null;let allowedWidth=0;let hasAlwaysBeenEmpty=true;let parentWidthFixed=false;let hash;let _resizing=false;function forceColumnWidths(){const table=tableRef.el;const headers=[...table.querySelectorAll("thead th")];const state=getState();const columns=state.columns;const nextHash=`${columns.map((column) => column.id).join("/")}/${headers.length}`;if(nextHash!==hash){hash=nextHash;resetWidths();}
if(hasAlwaysBeenEmpty&&!state.isEmpty){hasAlwaysBeenEmpty=false;const rows=table.querySelectorAll(".o_data_row");if(rows.length!==1||!rows[0].classList.contains("o_selected_row")){resetWidths();}}
const parentPadding=getHorizontalPadding(table.parentNode);const cellPaddings=headers.map((th)=>getHorizontalPadding(th));const totalCellPadding=cellPaddings.reduce((total,padding)=>padding+total,0);const nextAllowedWidth=table.parentNode.clientWidth-parentPadding-totalCellPadding;const allowedWidthDiff=Math.abs(allowedWidth-nextAllowedWidth);allowedWidth=nextAllowedWidth;if(!columnWidths||allowedWidthDiff>0){columnWidths=computeWidths(table,state,allowedWidth,columnWidths);}
table.style.tableLayout="fixed";headers.forEach((th,index)=>{th.style.width=`${Math.floor(columnWidths[index] + cellPaddings[index])}px`;});}
function resetWidths(){columnWidths=null;tableRef.el.style.width=null;if(parentWidthFixed){tableRef.el.parentElement.style.width=null;}}
function onStartResize(ev){_resizing=true;const table=tableRef.el;const th=ev.target.closest("th");const handler=th.querySelector(".o_resize");table.style.width=`${Math.floor(table.getBoundingClientRect().width)}px`;const thPosition=[...th.parentNode.children].indexOf(th);const resizingColumnElements=[...table.getElementsByTagName("tr")].filter((tr)=>tr.children.length===th.parentNode.children.length).map((tr)=>tr.children[thPosition]);const initialX=ev.clientX;const initialWidth=th.getBoundingClientRect().width;const initialTableWidth=table.getBoundingClientRect().width;const resizeStoppingEvents=["keydown","pointerdown","pointerup"];if(!table.parentElement.style.width){parentWidthFixed=true;table.parentElement.style.width=`${Math.floor(
                table.parentElement.getBoundingClientRect().width
            )}px`;}
table.classList.add("o_resizing");for(const el of resizingColumnElements){el.classList.add("o_column_resizing");handler.classList.add("bg-primary","opacity-100");handler.classList.remove("bg-black-25","opacity-50-hover");}
const resizeHeader=(ev)=>{ev.preventDefault();ev.stopPropagation();const delta=ev.clientX-initialX;const newWidth=Math.max(10,initialWidth+delta);const tableDelta=newWidth-initialWidth;th.style.width=`${Math.floor(newWidth)}px`;table.style.width=`${Math.floor(initialTableWidth + tableDelta)}px`;};window.addEventListener("pointermove",resizeHeader);const stopResize=(ev)=>{_resizing=false;const headers=[...table.querySelectorAll("thead th")];columnWidths=headers.map((th)=>{return th.getBoundingClientRect().width-getHorizontalPadding(th);});if(ev.type==="pointerdown"&&ev.button===0){return;}
ev.preventDefault();ev.stopPropagation();table.classList.remove("o_resizing");for(const el of resizingColumnElements){el.classList.remove("o_column_resizing");handler.classList.remove("bg-primary","opacity-100");handler.classList.add("bg-black-25","opacity-50-hover");}
window.removeEventListener("pointermove",resizeHeader);for(const eventType of resizeStoppingEvents){window.removeEventListener(eventType,stopResize);}
document.activeElement.blur();};for(const eventType of resizeStoppingEvents){window.addEventListener(eventType,stopResize);}}
if(renderer.constructor.useMagicColumnWidths){useEffect(forceColumnWidths);const debouncedResizeCallback=useDebounced(()=>{resetWidths();forceColumnWidths();},200);useExternalListener(window,"resize",debouncedResizeCallback);}
return{get resizing(){return _resizing;},onStartResize,};}
return __exports;});;

/* /web/static/src/views/list/export_all/export_all.js */
odoo.define('@web/views/list/export_all/export_all',['@web/core/dropdown/dropdown_item','@web/core/registry','@web/core/user','@web/core/utils/strings','@web/search/action_menus/action_menus','@odoo/owl'],function(require){'use strict';let __exports={};const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{exprToBoolean}=require("@web/core/utils/strings");const{STATIC_ACTIONS_GROUP_NUMBER}=require("@web/search/action_menus/action_menus");const{Component}=require("@odoo/owl");const cogMenuRegistry=registry.category("cogMenu");const ExportAll=__exports.ExportAll=class ExportAll extends Component{static template="web.ExportAll";static components={DropdownItem};static props={};async onDirectExportData(){this.env.searchModel.trigger("direct-export-data");}}
const exportAllItem=__exports.exportAllItem={Component:ExportAll,groupNumber:STATIC_ACTIONS_GROUP_NUMBER,isDisplayed:async(env)=>env.config.viewType==="list"&&!env.model.root.selection.length&&(await user.hasGroup("base.group_allow_export"))&&exprToBoolean(env.config.viewArch.getAttribute("export_xlsx"),true),};cogMenuRegistry.add("export-all-menu",exportAllItem,{sequence:10});return __exports;});;

/* /web/static/src/views/list/list_arch_parser.js */
odoo.define('@web/views/list/list_arch_parser',['@web/core/utils/strings','@web/core/utils/xml','@web/model/relational_model/utils','@web/search/utils/order_by','@web/views/fields/field','@web/views/utils','@web/views/view_compiler','@web/views/widgets/widget'],function(require){'use strict';let __exports={};const{exprToBoolean}=require("@web/core/utils/strings");const{visitXML}=require("@web/core/utils/xml");const{combineModifiers}=require("@web/model/relational_model/utils");const{stringToOrderBy}=require("@web/search/utils/order_by");const{Field}=require("@web/views/fields/field");const{getActiveActions,getDecoration,processButton}=require("@web/views/utils");const{encodeObjectForTemplate}=require("@web/views/view_compiler");const{Widget}=require("@web/views/widgets/widget");const GroupListArchParser=__exports.GroupListArchParser=class GroupListArchParser{parse(arch,models,modelName,jsClass){const fieldNodes={};const fieldNextIds={};const buttons=[];let buttonId=0;visitXML(arch,(node)=>{if(node.tagName==="button"){buttons.push({...processButton(node),id:buttonId++,});return false;}else if(node.tagName==="field"){const fieldInfo=Field.parseFieldNode(node,models,modelName,"list",jsClass);if(!(fieldInfo.name in fieldNextIds)){fieldNextIds[fieldInfo.name]=0;}
const fieldId=`${fieldInfo.name}_${fieldNextIds[fieldInfo.name]++}`;fieldNodes[fieldId]=fieldInfo;node.setAttribute("field_id",fieldId);return false;}});return{fieldNodes,buttons};}}
const ListArchParser=__exports.ListArchParser=class ListArchParser{parseFieldNode(node,models,modelName){return Field.parseFieldNode(node,models,modelName,"list");}
parseWidgetNode(node,models,modelName){return Widget.parseWidgetNode(node);}
processButton(node){return processButton(node);}
parse(xmlDoc,models,modelName){const fieldNodes={};const widgetNodes={};let widgetNextId=0;const columns=[];const fields=models[modelName].fields;let buttonId=0;const groupBy={buttons:{},fields:{},};let headerButtons=[];const creates=[];const groupListArchParser=new GroupListArchParser();let buttonGroup;let handleField=null;const treeAttr={};let nextId=0;const fieldNextIds={};visitXML(xmlDoc,(node)=>{if(node.tagName!=="button"){buttonGroup=undefined;}
if(node.tagName==="button"){const button={...this.processButton(node),defaultRank:"btn-link",type:"button",id:buttonId++,};const width=button.attrs.width;if(buttonGroup&&!width){buttonGroup.buttons.push(button);buttonGroup.column_invisible=combineModifiers(buttonGroup.column_invisible,node.getAttribute("column_invisible"),"AND");}else{buttonGroup={id:`column_${nextId++}`,type:"button_group",buttons:[button],hasLabel:false,column_invisible:node.getAttribute("column_invisible"),};columns.push(buttonGroup);if(width){buttonGroup.attrs={width};buttonGroup=undefined;}}}else if(node.tagName==="field"){const fieldInfo=this.parseFieldNode(node,models,modelName);if(!(fieldInfo.name in fieldNextIds)){fieldNextIds[fieldInfo.name]=0;}
const fieldId=`${fieldInfo.name}_${fieldNextIds[fieldInfo.name]++}`;fieldNodes[fieldId]=fieldInfo;node.setAttribute("field_id",fieldId);if(fieldInfo.isHandle){handleField=fieldInfo.name;}
const label=fieldInfo.field.label;columns.push({...fieldInfo,id:`column_${nextId++}`,className:node.getAttribute("class"),optional:node.getAttribute("optional")||false,type:"field",fieldType:fieldInfo.type,hasLabel:!(fieldInfo.field.label===false||exprToBoolean(fieldInfo.attrs.nolabel)===true),label:(fieldInfo.widget&&label&&label.toString())||fieldInfo.string,});return false;}else if(node.tagName==="widget"){const widgetInfo=this.parseWidgetNode(node);const widgetId=`widget_${++widgetNextId}`;widgetNodes[widgetId]=widgetInfo;node.setAttribute("widget_id",widgetId);const widgetProps={name:widgetInfo.name,node:encodeObjectForTemplate({attrs:widgetInfo.attrs}).slice(1,-1),className:node.getAttribute("class")||"",widgetInfo,};columns.push({...widgetInfo,props:widgetProps,id:`column_${nextId++}`,type:"widget",});}else if(node.tagName==="groupby"&&node.getAttribute("name")){const fieldName=node.getAttribute("name");const coModelName=fields[fieldName].relation;const groupByArchInfo=groupListArchParser.parse(node,models,coModelName);groupBy.buttons[fieldName]=groupByArchInfo.buttons;groupBy.fields[fieldName]={fieldNodes:groupByArchInfo.fieldNodes,fields:models[coModelName].fields,};return false;}else if(node.tagName==="header"){headerButtons=[...node.children].map((node)=>({...this.processButton(node),type:"button",id:buttonId++,}));return false;}else if(node.tagName==="control"){for(const childNode of node.children){if(childNode.tagName==="button"){creates.push({type:"button",...processButton(childNode),});}else if(childNode.tagName==="create"){creates.push({type:"create",context:childNode.getAttribute("context"),string:childNode.getAttribute("string"),});}}
return false;}else if("list"===node.tagName){const activeActions={...getActiveActions(xmlDoc),exportXlsx:exprToBoolean(xmlDoc.getAttribute("export_xlsx"),true),};treeAttr.activeActions=activeActions;treeAttr.className=xmlDoc.getAttribute("class")||null;treeAttr.editable=xmlDoc.getAttribute("editable");treeAttr.multiEdit=activeActions.edit?exprToBoolean(node.getAttribute("multi_edit")||""):false;treeAttr.openFormView=treeAttr.editable?exprToBoolean(xmlDoc.getAttribute("open_form_view")||""):false;const limitAttr=node.getAttribute("limit");treeAttr.limit=limitAttr&&parseInt(limitAttr,10);const countLimitAttr=node.getAttribute("count_limit");treeAttr.countLimit=countLimitAttr&&parseInt(countLimitAttr,10);const groupsLimitAttr=node.getAttribute("groups_limit");treeAttr.groupsLimit=groupsLimitAttr&&parseInt(groupsLimitAttr,10);treeAttr.noOpen=exprToBoolean(node.getAttribute("no_open")||"");treeAttr.rawExpand=xmlDoc.getAttribute("expand");treeAttr.decorations=getDecoration(xmlDoc);treeAttr.defaultGroupBy=xmlDoc.getAttribute("default_group_by");treeAttr.defaultOrder=stringToOrderBy(xmlDoc.getAttribute("default_order")||null);const action=xmlDoc.getAttribute("action");const type=xmlDoc.getAttribute("type");treeAttr.openAction=action&&type?{action,type}:null;}});if(!treeAttr.defaultOrder.length&&handleField){const handleFieldSort=`${handleField}, id`;treeAttr.defaultOrder=stringToOrderBy(handleFieldSort);}
return{creates,headerButtons,fieldNodes,widgetNodes,columns,groupBy,xmlDoc,...treeAttr,};}}
return __exports;});;

/* /web/static/src/views/list/list_cog_menu.js */
odoo.define('@web/views/list/list_cog_menu',['@web/search/cog_menu/cog_menu'],function(require){'use strict';let __exports={};const{CogMenu}=require("@web/search/cog_menu/cog_menu");const ListCogMenu=__exports.ListCogMenu=class ListCogMenu extends CogMenu{static template="web.ListCogMenu";static props={...CogMenu.props,hasSelectedRecords:{type:Number,optional:true},slots:{type:Object,optional:true},};_registryItems(){return this.props.hasSelectedRecords?[]:super._registryItems();}}
return __exports;});;

/* /web/static/src/views/list/list_confirmation_dialog.js */
odoo.define('@web/views/list/list_confirmation_dialog',['@web/core/dialog/dialog','@web/core/l10n/translation','@web/views/fields/field','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{_t}=require("@web/core/l10n/translation");const{Field}=require("@web/views/fields/field");const{useAutofocus}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const ListConfirmationDialog=__exports.ListConfirmationDialog=class ListConfirmationDialog extends Component{static template="web.ListView.ConfirmationModal";static components={Dialog,Field};static props={close:Function,title:{validate:(m)=>{return(typeof m==="string"||(typeof m==="object"&&typeof m.toString==="function"));},optional:true,},confirm:{type:Function,optional:true},cancel:{type:Function,optional:true},isDomainSelected:Boolean,fields:Object,nbRecords:Number,nbValidRecords:Number,record:Object,};static defaultProps={title:_t("Confirmation"),};setup(){useAutofocus();}
_cancel(){if(this.props.cancel){this.props.cancel();}
this.props.close();}
async _confirm(){if(this.props.confirm){await this.props.confirm();}
this.props.close();}}
return __exports;});;

/* /web/static/src/views/list/list_controller.js */
odoo.define('@web/views/list/list_controller',['@web/core/l10n/translation','@web/core/confirmation_dialog/confirmation_dialog','@web/core/network/download','@web/core/network/rpc','@web/core/py_js/py','@web/core/user','@web/core/utils/arrays','@web/core/utils/hooks','@web/core/utils/objects','@web/search/action_hook','@web/search/action_menus/action_menus','@web/search/layout','@web/search/pager_hook','@web/model/model','@web/model/relational_model/dynamic_record_list','@web/model/relational_model/utils','@web/views/standard_view_props','@web/views/view_button/multi_record_view_button','@web/views/view_button/view_button','@web/views/view_button/view_button_hook','@web/views/view_dialogs/export_data_dialog','@web/views/list/list_confirmation_dialog','@web/search/search_bar/search_bar','@web/search/search_bar/search_bar_toggler','@web/session','@web/views/list/list_cog_menu','@web/core/dropdown/dropdown_item','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{deleteConfirmationMessage,ConfirmationDialog,}=require("@web/core/confirmation_dialog/confirmation_dialog");const{download}=require("@web/core/network/download");const{rpc}=require("@web/core/network/rpc");const{evaluateExpr,evaluateBooleanExpr}=require("@web/core/py_js/py");const{user}=require("@web/core/user");const{unique}=require("@web/core/utils/arrays");const{useService,useBus}=require("@web/core/utils/hooks");const{omit}=require("@web/core/utils/objects");const{useSetupAction}=require("@web/search/action_hook");const{ActionMenus,STATIC_ACTIONS_GROUP_NUMBER}=require("@web/search/action_menus/action_menus");const{Layout}=require("@web/search/layout");const{usePager}=require("@web/search/pager_hook");const{useModelWithSampleData}=require("@web/model/model");const{DynamicRecordList}=require("@web/model/relational_model/dynamic_record_list");const{extractFieldsFromArchInfo}=require("@web/model/relational_model/utils");const{standardViewProps}=require("@web/views/standard_view_props");const{MultiRecordViewButton}=require("@web/views/view_button/multi_record_view_button");const{ViewButton}=require("@web/views/view_button/view_button");const{executeButtonCallback,useViewButtons}=require("@web/views/view_button/view_button_hook");const{ExportDataDialog}=require("@web/views/view_dialogs/export_data_dialog");const{ListConfirmationDialog}=require("@web/views/list/list_confirmation_dialog");const{SearchBar}=require("@web/search/search_bar/search_bar");const{useSearchBarToggler}=require("@web/search/search_bar/search_bar_toggler");const{session}=require("@web/session");const{ListCogMenu}=require("@web/views/list/list_cog_menu");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{Component,onMounted,onWillPatch,onWillRender,onWillStart,useEffect,useRef,useState,useSubEnv,}=require("@odoo/owl");const ListController=__exports.ListController=class ListController extends Component{static template=`web.ListView`;static components={ActionMenus,Layout,ViewButton,MultiRecordViewButton,SearchBar,CogMenu:ListCogMenu,DropdownItem,};static props={...standardViewProps,allowSelectors:{type:Boolean,optional:true},editable:{type:Boolean,optional:true},onSelectionChanged:{type:Function,optional:true},showButtons:{type:Boolean,optional:true},Model:Function,Renderer:Function,buttonTemplate:String,archInfo:Object,};static defaultProps={allowSelectors:true,createRecord:()=>{},editable:true,selectRecord:()=>{},showButtons:true,};setup(){this.actionService=useService("action");this.dialogService=useService("dialog");this.rootRef=useRef("root");this.archInfo=this.props.archInfo;this.activeActions=this.archInfo.activeActions;this.editable=this.activeActions.edit&&this.props.editable?this.archInfo.editable:false;this.onOpenFormView=this.openRecord.bind(this);this.hasOpenFormViewButton=this.editable?this.archInfo.openFormView:false;this.model=useState(useModelWithSampleData(this.props.Model,this.modelParams));this.hasMousedownDiscard=false;this.nextActionAfterMouseup=null;this.optionalActiveFields={};this.editedRecord=null;onWillRender(()=>{this.editedRecord=this.model.root.editedRecord;});onWillStart(async()=>{this.isExportEnable=await user.hasGroup("base.group_allow_export");});onMounted(()=>{const{rendererScrollPositions}=this.props.state||{};if(rendererScrollPositions){const renderer=this.rootRef.el.querySelector(".o_list_renderer");renderer.scrollLeft=rendererScrollPositions.left;renderer.scrollTop=rendererScrollPositions.top;}});this.archiveEnabled="active"in this.props.fields?!this.props.fields.active.readonly:"x_active"in this.props.fields?!this.props.fields.x_active.readonly:false;useSubEnv({model:this.model});useViewButtons(this.rootRef,{beforeExecuteAction:this.beforeExecuteActionButton.bind(this),afterExecuteAction:this.afterExecuteActionButton.bind(this),reload:()=>this.model.load(),});useSetupAction({rootRef:this.rootRef,beforeLeave:async()=>{return this.model.root.leaveEditMode();},beforeUnload:async(ev)=>{if(this.editedRecord){const isValid=await this.editedRecord.urgentSave();if(!isValid){ev.preventDefault();ev.returnValue="Unsaved changes";}}},getLocalState:()=>{const renderer=this.rootRef.el.querySelector(".o_list_renderer");return{modelState:this.model.exportState(),rendererScrollPositions:{left:renderer.scrollLeft,top:renderer.scrollTop,},};},getOrderBy:()=>{return this.model.root.orderBy;},});usePager(()=>{if(this.model.useSampleModel){return;}
const{count,hasLimitedCount,isGrouped,limit,offset}=this.model.root;return{offset:offset,limit:limit,total:count,onUpdate:async({offset,limit},hasNavigated)=>{if(this.editedRecord){if(!(await this.editedRecord.save())){return;}}
await this.model.root.load({limit,offset});if(hasNavigated){this.onPageChangeScroll();}},updateTotal:!isGrouped&&hasLimitedCount?()=>this.model.root.fetchCount():undefined,};});useEffect(()=>{if(this.props.onSelectionChanged){const resIds=this.model.root.selection.map((record)=>record.resId);this.props.onSelectionChanged(resIds);}},()=>[this.model.root.selection.length]);this.searchBarToggler=useSearchBarToggler();this.firstLoad=true;onWillPatch(()=>{this.firstLoad=false;});useBus(this.env.searchModel,"direct-export-data",this.onDirectExportData.bind(this));}
get modelParams(){const{defaultGroupBy,rawExpand}=this.archInfo;const{activeFields,fields}=extractFieldsFromArchInfo(this.archInfo,this.props.fields);const groupByInfo={};for(const fieldName in this.archInfo.groupBy.fields){const fieldNodes=this.archInfo.groupBy.fields[fieldName].fieldNodes;const fields=this.archInfo.groupBy.fields[fieldName].fields;groupByInfo[fieldName]=extractFieldsFromArchInfo({fieldNodes},fields);}
const modelConfig=this.props.state?.modelState?.config||{resModel:this.props.resModel,fields,activeFields,openGroupsByDefault:rawExpand?evaluateExpr(rawExpand,this.props.context):false,};return{config:modelConfig,state:this.props.state?.modelState,groupByInfo,limit:this.archInfo.limit||this.props.limit,countLimit:this.archInfo.countLimit,defaultOrderBy:this.archInfo.defaultOrder,defaultGroupBy:this.props.searchMenuTypes.includes("groupBy")?defaultGroupBy:false,groupsLimit:this.archInfo.groupsLimit,multiEdit:this.archInfo.multiEdit,activeIdsLimit:session.active_ids_limit,hooks:{onRecordSaved:this.onRecordSaved.bind(this),onWillSaveRecord:this.onWillSaveRecord.bind(this),onWillSaveMulti:this.onWillSaveMulti.bind(this),onWillSetInvalidField:this.onWillSetInvalidField.bind(this),},};}
get actionMenuProps(){return{getActiveIds:()=>this.model.root.selection.map((r)=>r.resId),context:this.props.context,domain:this.props.domain,items:this.actionMenuItems,isDomainSelected:this.model.root.isDomainSelected,resModel:this.model.root.resModel,onActionExecuted:()=>this.model.load(),};}
async onRecordSaved(record){}
async onWillSaveRecord(record){}
async createRecord({group}={}){const list=(group&&group.list)||this.model.root;if(this.editable&&!list.isGrouped){if(!(list instanceof DynamicRecordList)){throw new Error("List should be a DynamicRecordList");}
await list.leaveEditMode();if(!list.editedRecord){await(group||list).addNewRecord(this.editable==="top");}
this.render();}else{await this.props.createRecord();}}
async openRecord(record,force=false){const dirty=await record.isDirty();if(dirty){await record.save();}
if(this.archInfo.openAction){this.actionService.doActionButton({name:this.archInfo.openAction.action,type:this.archInfo.openAction.type,resModel:record.resModel,resId:record.resId,resIds:record.resIds,context:record.context,onClose:async()=>{await record.model.root.load();},});}else{const activeIds=this.model.root.records.map((datapoint)=>datapoint.resId);this.props.selectRecord(record.resId,{activeIds,force});}}
async onClickCreate(){return executeButtonCallback(this.rootRef.el,()=>this.createRecord());}
async onClickDiscard(){return executeButtonCallback(this.rootRef.el,()=>this.model.root.leaveEditMode({discard:true}));}
async onClickSave(){return executeButtonCallback(this.rootRef.el,async()=>{const saved=await this.editedRecord.save();if(saved){await this.model.root.leaveEditMode();}});}
onMouseDownDiscard(mouseDownEvent){this.hasMousedownDiscard=true;document.addEventListener("mouseup",(mouseUpEvent)=>{this.hasMousedownDiscard=false;if(mouseUpEvent.target!==mouseDownEvent.target){if(this.nextActionAfterMouseup){this.nextActionAfterMouseup();}}
this.nextActionAfterMouseup=null;},{capture:true,once:true});}
onPageChangeScroll(){if(this.rootRef&&this.rootRef.el){if(this.env.isSmall){this.rootRef.el.scrollTop=0;}else{this.rootRef.el.querySelector(".o_content .o_list_renderer").scrollTop=0;}}}
getSelectedResIds(){return this.model.root.getResIds(true);}
getStaticActionMenuItems(){return{export:{isAvailable:()=>this.isExportEnable,sequence:10,icon:"fa fa-upload",description:_t("Export"),callback:()=>this.onExportData(),},archive:{isAvailable:()=>this.archiveEnabled,sequence:20,icon:"oi oi-archive",description:_t("Archive"),callback:()=>{this.dialogService.add(ConfirmationDialog,this.archiveDialogProps);},},unarchive:{isAvailable:()=>this.archiveEnabled,sequence:30,icon:"oi oi-unarchive",description:_t("Unarchive"),callback:()=>this.toggleArchiveState(false),},duplicate:{isAvailable:()=>this.activeActions.duplicate,sequence:35,icon:"fa fa-clone",description:_t("Duplicate"),callback:()=>this.duplicateRecords(),},delete:{isAvailable:()=>this.activeActions.delete,sequence:40,icon:"fa fa-trash-o",description:_t("Delete"),callback:()=>this.onDeleteSelectedRecords(),},};}
get archiveDialogProps(){return{body:_t("Are you sure that you want to archive all the selected records?"),confirmLabel:_t("Archive"),confirm:()=>{this.toggleArchiveState(true);},cancel:()=>{},};}
get actionMenuItems(){const{actionMenus}=this.props.info;const staticActionItems=Object.entries(this.getStaticActionMenuItems()).filter(([key,item])=>item.isAvailable===undefined||item.isAvailable()).sort(([k1,item1],[k2,item2])=>(item1.sequence||0)-(item2.sequence||0)).map(([key,item])=>Object.assign({key,groupNumber:STATIC_ACTIONS_GROUP_NUMBER},omit(item,"isAvailable")));return{action:[...staticActionItems,...(actionMenus?.action||[])],print:actionMenus?.print,};}
async onSelectDomain(){await this.model.root.selectDomain(true);if(this.props.onSelectionChanged){const resIds=await this.model.root.getResIds(true);this.props.onSelectionChanged(resIds);}}
onUnselectAll(){this.model.root.selection.forEach((record)=>{record.toggleSelection(false);});this.model.root.selectDomain(false);}
evalViewModifier(modifier){return evaluateBooleanExpr(modifier,this.model.root.evalContext);}
get className(){return this.props.className;}
get hasSelectedRecords(){return this.nbSelected||this.isDomainSelected;}
get nbSelected(){return this.model.root.selection.length;}
get isPageSelected(){const root=this.model.root;return root.selection.length===root.records.length;}
get isDomainSelected(){return this.model.root.isDomainSelected;}
get nbTotal(){const list=this.model.root;return list.isGrouped?list.recordCount:list.count;}
get defaultExportList(){return unique(this.props.archInfo.columns.filter((col)=>col.type==="field").filter((col)=>!col.optional||this.optionalActiveFields[col.name]).filter((col)=>!evaluateBooleanExpr(col.column_invisible,this.props.context)).map((col)=>this.props.fields[col.name]).filter((field)=>field.exportable!==false));}
get display(){const{controlPanel}=this.props.display;if(!controlPanel){return this.props.display;}
return{...this.props.display,controlPanel:{...controlPanel,layoutActions:!this.hasSelectedRecords,},};}
async downloadExport(fields,import_compat,format){let ids=false;if(!this.isDomainSelected){const resIds=await this.getSelectedResIds();ids=resIds.length>0&&resIds;}
const exportedFields=fields.map((field)=>({name:field.name||field.id,label:field.label||field.string,store:field.store,type:field.field_type||field.type,}));if(import_compat){exportedFields.unshift({name:"id",label:_t("External ID"),});}
await download({data:{data:JSON.stringify({import_compat,context:this.props.context,domain:this.model.root.domain,fields:exportedFields,groupby:this.model.root.groupBy,ids,model:this.model.root.resModel,}),},url:`/web/export/${format}`,});}
async getExportedFields(model,import_compat,parentParams){let domain=parentParams?[]:this.model.root.domain;if(!this.isDomainSelected){const resIds=await this.getSelectedResIds();const ids=resIds.length>0&&resIds;domain=[["id","in",ids]];}
return await rpc("/web/export/get_fields",{...parentParams,model,domain,import_compat,});}
async onExportData(){const dialogProps={context:this.props.context,defaultExportList:this.defaultExportList,download:this.downloadExport.bind(this),getExportedFields:this.getExportedFields.bind(this),root:this.model.root,};this.dialogService.add(ExportDataDialog,dialogProps);}
async onDirectExportData(){await this.downloadExport(this.defaultExportList,false,"xlsx");}
async toggleArchiveState(archive){if(archive){return this.model.root.archive(true);}
return this.model.root.unarchive(true);}
async duplicateRecords(){return this.model.root.duplicateRecords();}
get deleteConfirmationDialogProps(){const root=this.model.root;let body=deleteConfirmationMessage;if(root.isDomainSelected||root.selection.length>1){body=_t("Are you sure you want to delete these records?");}
return{title:_t("Bye-bye, record!"),body,confirmLabel:_t("Delete"),confirm:()=>this.model.root.deleteRecords(),cancel:()=>{},cancelLabel:_t("No, keep it"),};}
async onDeleteSelectedRecords(){this.dialogService.add(ConfirmationDialog,this.deleteConfirmationDialogProps);}
discardSelection(){this.model.root.records.forEach((record)=>{record.toggleSelection(false);});}
async beforeExecuteActionButton(clickParams){if(clickParams.special!=="cancel"&&this.editedRecord){return this.editedRecord.save();}}
async afterExecuteActionButton(clickParams){}
onWillSaveMulti(editedRecord,changes,validSelectedRecords){if(this.hasMousedownDiscard){this.nextActionAfterMouseup=()=>this.model.root.multiSave(editedRecord);return false;}
if(validSelectedRecords.length>1){const{isDomainSelected,selection}=this.model.root;return new Promise((resolve)=>{const dialogProps={confirm:()=>resolve(true),cancel:()=>{if(this.editedRecord){this.model.root.leaveEditMode({discard:true});}else{editedRecord.discard();}
resolve(false);},isDomainSelected,fields:Object.keys(changes).map((fieldName)=>{const fieldNode=Object.values(this.archInfo.fieldNodes).find((fieldNode)=>fieldNode.name===fieldName);const label=fieldNode&&fieldNode.string;return{name:fieldName,label:label||editedRecord.fields[fieldName].string,fieldNode,widget:fieldNode&&fieldNode.widget,};}),nbRecords:selection.length,nbValidRecords:validSelectedRecords.length,record:editedRecord,};const focusedCellBeforeDialog=document.activeElement.closest(".o_data_cell");this.dialogService.add(ListConfirmationDialog,dialogProps,{onClose:()=>{if(focusedCellBeforeDialog){focusedCellBeforeDialog.focus();}
this.model.root.leaveEditMode({discard:true});resolve(false);},});});}
return true;}
onWillSetInvalidField(record,fieldName){if(this.hasMousedownDiscard){this.nextActionAfterMouseup=()=>record.setInvalidField(fieldName);return false;}
return true;}}
return __exports;});;

/* /web/static/src/views/list/list_renderer.js */
odoo.define('@web/views/list/list_renderer',['@web/core/browser/browser','@web/core/checkbox/checkbox','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/hotkeys/hotkey_service','@web/core/pager/pager','@web/core/py_js/py','@web/core/registry','@web/core/utils/hooks','@web/core/utils/sortable_owl','@web/core/utils/ui','@web/views/fields/field','@web/views/fields/field_tooltip','@web/views/utils','@web/model/relational_model/utils','@web/views/view_button/view_button','@web/views/view_hook','@web/views/widgets/widget','@web/core/l10n/localization','@web/views/list/column_width_hook','@odoo/owl','@web/core/l10n/translation','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{CheckBox}=require("@web/core/checkbox/checkbox");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const{Pager}=require("@web/core/pager/pager");const{evaluateBooleanExpr}=require("@web/core/py_js/py");const{registry}=require("@web/core/registry");const{useBus,useService}=require("@web/core/utils/hooks");const{useSortable}=require("@web/core/utils/sortable_owl");const{getTabableElements}=require("@web/core/utils/ui");const{Field,getPropertyFieldInfo}=require("@web/views/fields/field");const{getTooltipInfo}=require("@web/views/fields/field_tooltip");const{getClassNameFromDecoration}=require("@web/views/utils");const{combineModifiers}=require("@web/model/relational_model/utils");const{ViewButton}=require("@web/views/view_button/view_button");const{useBounceButton}=require("@web/views/view_hook");const{Widget}=require("@web/views/widgets/widget");const{getFormattedValue}=require("@web/views/utils");const{localization}=require("@web/core/l10n/localization");const{useMagicColumnWidths}=require("@web/views/list/column_width_hook");const{Component,onMounted,onPatched,onWillPatch,onWillRender,useExternalListener,useRef,}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{exprToBoolean}=require("@web/core/utils/strings");const formatters=registry.category("formatters");const DEFAULT_GROUP_PAGER_COLSPAN=1;const FIELD_CLASSES={char:"o_list_char",float:"o_list_number",integer:"o_list_number",monetary:"o_list_number",text:"o_list_text",many2one:"o_list_many2one",};function containsActiveElement(parent){const{activeElement}=document;return parent!==activeElement&&parent.contains(activeElement);}
function getElementToFocus(cell,index){return getTabableElements(cell).at(index)||cell;}
const ListRenderer=__exports.ListRenderer=class ListRenderer extends Component{static template="web.ListRenderer";static rowsTemplate="web.ListRenderer.Rows";static recordRowTemplate="web.ListRenderer.RecordRow";static groupRowTemplate="web.ListRenderer.GroupRow";static useMagicColumnWidths=true;static LONG_TOUCH_THRESHOLD=400;static components={DropdownItem,Field,ViewButton,CheckBox,Dropdown,Pager,Widget};static defaultProps={hasSelectors:false,cycleOnTab:true};static props=["activeActions?","list","archInfo","openRecord","onAdd?","cycleOnTab?","allowSelectors?","editable?","onOpenFormView?","hasOpenFormViewButton?","noContentHelp?","nestedKeyOptionalFieldsData?","optionalActiveFields?",];setup(){this.uiService=useService("ui");this.notificationService=useService("notification");const key=this.createViewKey();this.keyOptionalFields=`optional_fields,${key}`;this.keyDebugOpenView=`debug_open_view,${key}`;this.cellClassByColumn={};this.groupByButtons=this.props.archInfo.groupBy.buttons;useExternalListener(document,"click",this.onGlobalClick.bind(this));this.tableRef=useRef("table");this.longTouchTimer=null;this.touchStartMs=0;this.preventReorder=false;this.creates=this.props.archInfo.creates.length?this.props.archInfo.creates:[{type:"create",string:_t("Add a line")}];this.cellToFocus=null;this.activeRowId=null;onMounted(async()=>{await Promise.resolve();this.activeElement=this.uiService.activeElement;});onWillPatch(()=>{const activeRow=document.activeElement.closest(".o_data_row.o_selected_row");this.activeRowId=activeRow?activeRow.dataset.id:null;});this.optionalActiveFields=this.props.optionalActiveFields||{};this.allColumns=[];this.columns=[];this.editedRecord=null;onWillRender(()=>{this.editedRecord=this.props.list.editedRecord;this.allColumns=this.processAllColumn(this.props.archInfo.columns,this.props.list);Object.assign(this.optionalActiveFields,this.computeOptionalActiveFields());this.debugOpenView=exprToBoolean(browser.localStorage.getItem(this.keyDebugOpenView));this.columns=this.getActiveColumns(this.props.list);this.withHandleColumn=this.columns.some((col)=>col.widget==="handle");});let dataRowId;this.rootRef=useRef("root");this.resequencePromise=Promise.resolve();useSortable({enable:()=>this.canResequenceRows,ref:this.rootRef,elements:".o_row_draggable",handle:".o_handle_cell",cursor:"grabbing",placeholderClasses:["d-table-row"],onDragStart:(params)=>{const{element}=params;dataRowId=element.dataset.id;return this.sortStart(params);},onDragEnd:(params)=>this.sortStop(params),onDrop:(params)=>this.sortDrop(dataRowId,params),});if(this.env.searchModel){useBus(this.env.searchModel,"focus-view",()=>{if(this.props.list.model.useSampleModel){return;}
const nextTh=this.tableRef.el.querySelector("thead th");const toFocus=getElementToFocus(nextTh);this.focus(toFocus);this.tableRef.el.querySelector("tbody").classList.add("o_keyboard_navigation");});}
useBus(this.props.list.model.bus,"FIELD_IS_DIRTY",(ev)=>(this.lastIsDirty=ev.detail));useBounceButton(this.rootRef,()=>{return this.showNoContentHelper;});let isSmall=this.uiService.isSmall;useBus(this.uiService.bus,"resize",()=>{if(isSmall!==this.uiService.isSmall){isSmall=this.uiService.isSmall;this.render();}});this.columnWidths=useMagicColumnWidths(this.tableRef,()=>{return{columns:this.columns,isEmpty:!this.props.list.records.length||this.props.list.model.useSampleModel,hasSelectors:this.hasSelectors,hasOpenFormViewColumn:this.hasOpenFormViewColumn,hasActionsColumn:this.hasActionsColumn,};});useExternalListener(window,"keydown",(ev)=>{this.shiftKeyMode=ev.shiftKey;});useExternalListener(window,"keyup",(ev)=>{this.shiftKeyMode=ev.shiftKey;const hotkey=getActiveHotkey(ev);if(hotkey==="shift"){this.shiftKeyedRecord=undefined;}});useExternalListener(window,"blur",(ev)=>{this.shiftKeyMode=false;});onPatched(async()=>{await Promise.resolve();if(this.activeElement!==this.uiService.activeElement){return;}
if(this.editedRecord&&this.activeRowId!==this.editedRecord.id){if(this.cellToFocus&&this.cellToFocus.record===this.editedRecord){const column=this.cellToFocus.column;const forward=this.cellToFocus.forward;this.focusCell(column,forward);}else if(this.lastEditedCell){this.focusCell(this.lastEditedCell.column,true);}else{this.focusCell(this.columns[0]);}}
this.cellToFocus=null;this.lastEditedCell=null;});this.isRTL=localization.direction==="rtl";}
displaySaveNotification(){this.notificationService.add(_t("Please save your changes first"),{type:"danger",});}
getActiveColumns(list){return this.allColumns.filter((col)=>{if(list.isGrouped&&col.widget==="handle"){return false;}
if(col.optional&&!this.optionalActiveFields[col.name]){return false;}
if(this.evalColumnInvisible(col.column_invisible)){return false;}
return true;});}
get hasSelectors(){return this.props.allowSelectors&&!this.env.isSmall;}
get hasOpenFormViewColumn(){return this.props.hasOpenFormViewButton||this.debugOpenView;}
get hasOptionalOpenFormViewColumn(){return this.props.editable&&this.env.debug&&!this.props.hasOpenFormViewButton;}
get hasActionsColumn(){return!!(this.displayOptionalFields||this.activeActions.onDelete||this.hasOptionalOpenFormViewColumn);}
add(params){if(this.canCreate){this.props.onAdd(params);}}
async addInGroup(group){const left=await this.props.list.leaveEditMode({canAbandon:false});if(left){group.addNewRecord({},this.props.editable==="top");}}
processAllColumn(allColumns,list){return allColumns.flatMap((column)=>{if(column.type==="field"&&list.fields[column.name].type==="properties"){return this.getPropertyFieldColumns(column,list);}else{return[column];}});}
getPropertyFieldColumns(column,list){return Object.values(list.fields).filter((field)=>list.activeFields[field.name]&&field.relatedPropertyField&&field.relatedPropertyField.name===column.name&&field.type!=="separator").map((propertyField)=>{const activeField=list.activeFields[propertyField.name];return{...getPropertyFieldInfo(propertyField),relatedPropertyField:activeField.relatedPropertyField,id:`${column.id}_${propertyField.name}`,column_invisible:combineModifiers(propertyField.column_invisible,column.column_invisible,"OR"),classNames:column.classNames,optional:"hide",type:"field",hasLabel:true,label:propertyField.string,sortable:false,attrs:["integer","float"].includes(propertyField.type)?{sum:propertyField.string}:{},};});}
getFieldProps(record,column){return{readonly:this.isCellReadonly(column,record)||this.isRecordReadonly(record),};}
get activeActions(){return this.props.activeActions||{};}
get canResequenceRows(){if(!this.props.list.canResequence()){return false;}
const{handleField,orderBy}=this.props.list;return!orderBy.length||(orderBy.length&&orderBy[0].name===handleField);}
get fields(){return this.props.list.fields;}
get nbCols(){let nbCols=this.columns.length;if(this.hasSelectors){nbCols++;}
if(this.hasActionsColumn){nbCols++;}
if(this.hasOpenFormViewColumn){nbCols++;}
return nbCols;}
canUseFormatter(column,record){if(column.widget){return false;}
if(record.isInEdition&&(record.model.multiEdit||this.isInlineEditable(record))){return false;}
return true;}
isRecordReadonly(record){if(record.isNew){return false;}
if(this.props.activeActions?.edit===false){return true;}
if(record.isInEdition&&!this.isInlineEditable(record)&&!record.model.multiEdit){return true;}
return false;}
focusCell(column,forward=true){const index=column?this.columns.findIndex((col)=>col.id===column.id&&col.name===column.name):-1;let columns;if(index===-1&&!forward){columns=this.columns.slice(0).reverse();}else{columns=[...this.columns.slice(index,this.columns.length),...this.columns.slice(0,index),];}
for(const column of columns){if(column.type!=="field"){continue;}
if(!this.isCellReadonly(column,this.editedRecord)){const cell=this.tableRef.el.querySelector(`.o_selected_row td[name='${column.name}']`);if(cell){const toFocus=getElementToFocus(cell);if(cell!==toFocus){this.focus(toFocus);this.lastEditedCell={column,record:this.editedRecord};break;}}}}}
focus(el){if(!el){return;}
el.focus();if(["text","search","url","tel","password","textarea"].includes(el.type)&&el.selectionStart===el.selectionEnd){el.selectionStart=0;el.selectionEnd=el.value.length;}}
editGroupRecord(group){const{resId,resModel}=group.record;this.env.services.action.doAction({context:{create:false,},res_model:resModel,res_id:resId,type:"ir.actions.act_window",views:[[false,"form"]],flags:{mode:"edit"},});}
createViewKey(){let keyParts={fields:this.props.list.fieldNames,model:this.props.list.resModel,viewMode:"list",viewId:this.env.config.viewId,};if(this.props.nestedKeyOptionalFieldsData){keyParts=Object.assign(keyParts,{model:this.props.nestedKeyOptionalFieldsData.model,viewMode:this.props.nestedKeyOptionalFieldsData.viewMode,relationalField:this.props.nestedKeyOptionalFieldsData.field,subViewType:"list",});}
const parts=["model","viewMode","viewId","relationalField","subViewType"];const viewIdentifier=[];parts.forEach((partName)=>{if(partName in keyParts){viewIdentifier.push(keyParts[partName]);}});keyParts.fields.sort((left,right)=>(left<right?-1:1)).forEach((fieldName)=>{return viewIdentifier.push(fieldName);});return viewIdentifier.join(",");}
get optionalFieldGroups(){const propertyGroups={};const optionalFields=[];const optionalColumns=this.allColumns.filter((col)=>col.optional&&!this.evalColumnInvisible(col.column_invisible));for(const col of optionalColumns){const optionalField={label:col.label,name:col.name,value:this.optionalActiveFields[col.name],};if(!col.relatedPropertyField){optionalFields.push(optionalField);}else{const{displayName,id}=col.relatedPropertyField;if(propertyGroups[id]){propertyGroups[id].optionalFields.push(optionalField);}else{propertyGroups[id]={id,displayName,optionalFields:[optionalField]};}}}
if(optionalFields.length){return[{optionalFields},...Object.values(propertyGroups)];}
return Object.values(propertyGroups);}
get hasOptionalFields(){return this.allColumns.some((col)=>col.optional&&!this.evalColumnInvisible(col.column_invisible));}
get displayOptionalFields(){return this.hasOptionalFields;}
nbRecordsInGroup(group){if(group.isFolded){return 0;}else if(group.list.isGrouped){let count=0;for(const gr of group.list.groups){count+=this.nbRecordsInGroup(gr);}
return count;}else{return group.list.records.length;}}
get selectAll(){const list=this.props.list;const nbDisplayedRecords=list.records.length;if(list.isDomainSelected){return true;}else{return nbDisplayedRecords>0&&list.selection.length===nbDisplayedRecords;}}
get aggregates(){let values;if(this.props.list.selection&&this.props.list.selection.length){values=this.props.list.selection.map((r)=>r.data);}else if(this.props.list.isGrouped){values=this.props.list.groups.map((g)=>g.aggregates);}else{values=this.props.list.records.map((r)=>r.data);}
const aggregates={};for(const column of this.allColumns){if(column.type!=="field"){continue;}
const fieldName=column.name;if(fieldName in this.optionalActiveFields&&!this.optionalActiveFields[fieldName]){continue;}
const field=this.fields[fieldName];const fieldValues=values.map((v)=>v[fieldName]).filter((v)=>v||v===0);if(!fieldValues.length){continue;}
const type=field.type;if(type!=="integer"&&type!=="float"&&type!=="monetary"){continue;}
const{attrs,widget}=column;const func=(attrs.sum&&"sum")||(attrs.avg&&"avg")||(attrs.max&&"max")||(attrs.min&&"min");let currencyId;if(type==="monetary"||widget==="monetary"){const currencyField=column.options.currency_field||this.fields[fieldName].currency_field||"currency_id";if(!(currencyField in this.props.list.activeFields)){aggregates[fieldName]={help:_t("No currency provided"),value:"—",};continue;}
currencyId=values[0][currencyField]&&values[0][currencyField][0];if(currencyId&&func){const sameCurrency=values.every((value)=>currencyId===value[currencyField][0]);if(!sameCurrency){aggregates[fieldName]={help:_t("Different currencies cannot be aggregated"),value:"—",};continue;}}}
if(func){let aggregateValue=0;if(func==="max"){aggregateValue=Math.max(-Infinity,...fieldValues);}else if(func==="min"){aggregateValue=Math.min(Infinity,...fieldValues);}else if(func==="avg"){aggregateValue=fieldValues.reduce((acc,val)=>acc+val)/fieldValues.length;}else if(func==="sum"){aggregateValue=fieldValues.reduce((acc,val)=>acc+val);}
const formatter=formatters.get(widget,false)||formatters.get(type,false);const formatOptions={digits:attrs.digits?JSON.parse(attrs.digits):undefined,escape:true,};if(currencyId){formatOptions.currencyId=currencyId;}
aggregates[fieldName]={help:attrs[func],value:formatter?formatter(aggregateValue,formatOptions):aggregateValue,};}}
return aggregates;}
formatAggregateValue(group,column){const{widget,attrs}=column;const field=this.props.list.fields[column.name];const aggregateValue=group.aggregates[column.name];if(!(column.name in group.aggregates)){return"";}
const formatter=formatters.get(widget,false)||formatters.get(field.type,false);const formatOptions={digits:attrs.digits?JSON.parse(attrs.digits):field.digits,escape:true,};return formatter?formatter(aggregateValue,formatOptions):aggregateValue;}
getGroupLevel(group){return this.props.list.groupBy.length-group.list.groupBy.length-1;}
getColumnClass(column){const classNames=["align-middle"];if(this.isSortable(column)){classNames.push("o_column_sortable","position-relative","cursor-pointer");}else{classNames.push("cursor-default");}
const orderBy=this.props.list.orderBy;if(orderBy.length&&column.widget!=="handle"&&orderBy[0].name===column.name&&column.hasLabel){classNames.push("table-active");}
if(this.isNumericColumn(column)){classNames.push("o_list_number_th");}
if(column.type==="button_group"){classNames.push("o_list_button");}
if(column.widget){classNames.push(`o_${column.widget}_cell`);}
return classNames.join(" ");}
getColumns(record){return this.columns;}
isNumericColumn(column){const{type}=this.fields[column.name];return["float","integer","monetary"].includes(type);}
isSortable(column){const{hasLabel,name,options}=column;const{sortable}=this.fields[name];return(sortable||options.allow_order)&&hasLabel;}
getSortableIconClass(column){const{orderBy}=this.props.list;const classNames=this.isSortable(column)?["fa","fa-lg"]:["d-none"];if(orderBy.length&&orderBy[0].name===column.name){classNames.push(orderBy[0].asc?"fa-angle-up":"fa-angle-down");}else{classNames.push("fa-angle-down","opacity-0","opacity-100-hover");}
return classNames.join(" ");}
getRowClass(record){const classNames=this.props.archInfo.decorations.filter((decoration)=>evaluateBooleanExpr(decoration.condition,record.evalContextWithVirtualIds)).map((decoration)=>decoration.class);if(record.selected){classNames.push("table-info");}
if(record.isInEdition){classNames.push("o_selected_row");}
if(record.selected){classNames.push("o_data_row_selected");}
if(this.canResequenceRows){classNames.push("o_row_draggable");}
return classNames.join(" ");}
getCellClass(column,record){if(column.relatedPropertyField&&!(column.name in record.data)){return"";}
if(!this.cellClassByColumn[column.id]){const classNames=["o_data_cell"];if(column.type==="button_group"){classNames.push("o_list_button");}else if(column.type==="field"){classNames.push("o_field_cell");if(column.attrs&&column.attrs.class&&this.canUseFormatter(column,record)){classNames.push(column.attrs.class);}
const typeClass=FIELD_CLASSES[this.fields[column.name].type];if(typeClass){classNames.push(typeClass);}
if(column.widget){classNames.push(`o_${column.widget}_cell`);}}
this.cellClassByColumn[column.id]=classNames;}
const classNames=[...this.cellClassByColumn[column.id]];if(column.type==="field"){if(evaluateBooleanExpr(column.required,record.evalContextWithVirtualIds)){classNames.push("o_required_modifier");}
if(record.isFieldInvalid(column.name)){classNames.push("o_invalid_cell");}
if(this.isCellReadonly(column,record)){classNames.push("o_readonly_modifier");}
if(this.canUseFormatter(column,record)){const{decorations}=column;for(const decoName in decorations){if(evaluateBooleanExpr(decorations[decoName],record.evalContextWithVirtualIds)){classNames.push(getClassNameFromDecoration(decoName));}}}
if(record.isInEdition&&this.editedRecord&&this.isCellReadonly(column,this.editedRecord)){classNames.push("text-muted");}else{classNames.push("cursor-pointer");}}
return classNames.join(" ");}
isCellReadonly(column,record){return!!(this.isRecordReadonly(record)||(column.relatedPropertyField&&record.selected&&record.model.multiEdit)||evaluateBooleanExpr(column.readonly,record.evalContextWithVirtualIds));}
getCellTitle(column,record){if(["many2one","reference","char"].includes(this.fields[column.name].type)){return this.getFormattedValue(column,record);}}
getFieldClass(column){return column.attrs&&column.attrs.class;}
getFormattedValue(column,record){const fieldName=column.name;if(column.options.enable_formatting===false){return record.data[fieldName];}
return getFormattedValue(record,fieldName,column);}
evalInvisible(invisible,record){return evaluateBooleanExpr(invisible,record.evalContextWithVirtualIds);}
evalColumnInvisible(columnInvisible){return evaluateBooleanExpr(columnInvisible,this.props.list.evalContext);}
getGroupDisplayName(group){if(group.groupByField.type==="boolean"){return group.value===undefined?_t("None"):group.value?_t("Yes"):_t("No");}else{return group.value===undefined||group.value===false?_t("None"):group.displayName;}}
get canCreate(){return"link"in this.activeActions?this.activeActions.link:this.activeActions.create;}
get isX2Many(){return this.activeActions.type!=="view";}
get getEmptyRowIds(){let nbEmptyRow=Math.max(0,4-this.props.list.records.length);if(nbEmptyRow>0&&this.displayRowCreates){nbEmptyRow-=1;}
return Array.from(Array(nbEmptyRow).keys());}
get displayRowCreates(){return this.isX2Many&&this.canCreate;}
getFirstAggregateIndex(group){return this.columns.findIndex((col)=>col.name in group.aggregates);}
getLastAggregateIndex(group){const reversedColumns=[...this.columns].reverse();const index=reversedColumns.findIndex((col)=>col.name in group.aggregates);return index>-1?this.columns.length-index-1:-1;}
getAggregateColumns(group){const firstIndex=this.getFirstAggregateIndex(group);const lastIndex=this.getLastAggregateIndex(group);return this.columns.slice(firstIndex,lastIndex+1);}
getGroupNameCellColSpan(group){const firstAggregateIndex=this.getFirstAggregateIndex(group);let colspan;if(firstAggregateIndex>-1){colspan=firstAggregateIndex;}else{colspan=Math.max(1,this.columns.length-DEFAULT_GROUP_PAGER_COLSPAN);if(this.displayOptionalFields){colspan++;}}
if(this.hasSelectors){colspan++;}
return colspan;}
getGroupPagerCellColspan(group){const lastAggregateIndex=this.getLastAggregateIndex(group);let colspan;if(lastAggregateIndex>-1){colspan=this.columns.length-lastAggregateIndex-1;if(this.displayOptionalFields){colspan++;}}else{colspan=this.columns.length>1?DEFAULT_GROUP_PAGER_COLSPAN:0;}
if(this.hasOpenFormViewColumn){colspan++;}
return colspan;}
getGroupPagerProps(group){const list=group.list;return{offset:list.offset,limit:list.limit,total:list.count,onUpdate:async({offset,limit})=>{await list.load({limit,offset});this.render(true);},withAccessKey:false,};}
computeOptionalActiveFields(){const localStorageValue=browser.localStorage.getItem(this.keyOptionalFields);const optionalColumn=this.allColumns.filter((col)=>col.type==="field"&&col.optional);const optionalActiveFields={};if(localStorageValue!==null){const localStorageOptionalActiveFields=localStorageValue.split(",");for(const col of optionalColumn){optionalActiveFields[col.name]=localStorageOptionalActiveFields.includes(col.name);}}else{for(const col of optionalColumn){optionalActiveFields[col.name]=col.optional==="show";}}
return optionalActiveFields;}
onClickSortColumn(column){if(this.preventReorder){this.preventReorder=false;return;}
if(this.editedRecord||this.props.list.model.useSampleModel){return;}
const fieldName=column.name;const list=this.props.list;if(this.isSortable(column)){list.sortBy(fieldName);}}
onButtonCellClicked(record,column,ev){if(!ev.target.closest("button")){this.onCellClicked(record,column,ev);}}
async onCellClicked(record,column,ev){if(ev.target.special_click){return;}
const recordAfterResequence=async()=>{const recordIndex=this.props.list.records.indexOf(record);await this.resequencePromise;record=this.props.list.records[recordIndex]||record;};if((this.props.list.model.multiEdit&&record.selected)||this.isInlineEditable(record)){if(record.isInEdition&&this.editedRecord===record){const cell=this.tableRef.el.querySelector(`.o_selected_row td[name='${column.name}']`);if(cell&&containsActiveElement(cell)){this.lastEditedCell={column,record};return;}
this.focusCell(column);this.cellToFocus=null;}else{await recordAfterResequence();await this.props.list.enterEditMode(record);this.cellToFocus={column,record};if(column.type==="field"&&record.fields[column.name].type==="boolean"&&(!column.widget||column.widget==="boolean")){if(!this.isCellReadonly(column,record)&&!this.evalInvisible(column.invisible,record)){await record.update({[column.name]:!record.data[column.name]});}}}}else if(this.editedRecord&&this.editedRecord!==record){this.props.list.leaveEditMode();}else if(!this.props.archInfo.noOpen){this.props.openRecord(record);}}
onRemoveCellClicked(record,ev){const element=ev.target.closest(".o_list_record_remove");if(element.dataset.clicked){return;}
element.dataset.clicked=true;this.onDeleteRecord(record,ev);}
async onDeleteRecord(record){this.keepColumnWidths=true;if(this.editedRecord&&this.editedRecord!==record){const left=await this.props.list.leaveEditMode();if(!left){return;}}
if(this.activeActions.onDelete){this.activeActions.onDelete(record);}}
findFocusFutureCell(cell,cellIsInGroupRow,direction){const row=cell.parentElement;const children=[...row.children];const index=children.indexOf(cell);let futureCell;switch(direction){case"up":{let futureRow=row.previousElementSibling;futureRow=futureRow||row.parentElement.previousElementSibling?.lastElementChild;if(futureRow){const addCell=[...futureRow.children].find((c)=>c.classList.contains("o_group_field_row_add"));const nextIsGroup=futureRow.classList.contains("o_group_header");const rowTypeSwitched=cellIsInGroupRow!==nextIsGroup;let defaultIndex=0;if(cellIsInGroupRow){defaultIndex=this.hasSelectors?1:0;}
futureCell=addCell||(futureRow&&futureRow.children[rowTypeSwitched?defaultIndex:index]);}
break;}
case"down":{let futureRow=row.nextElementSibling;futureRow=futureRow||row.parentElement.nextElementSibling?.firstElementChild;if(futureRow){const addCell=[...futureRow.children].find((c)=>c.classList.contains("o_group_field_row_add"));const nextIsGroup=futureRow.classList.contains("o_group_header");const rowTypeSwitched=cellIsInGroupRow!==nextIsGroup;let defaultIndex=0;if(cellIsInGroupRow){defaultIndex=this.hasSelectors?1:0;}
futureCell=addCell||(futureRow&&futureRow.children[rowTypeSwitched?defaultIndex:index]);}
break;}
case"left":{futureCell=children[index-1];break;}
case"right":{futureCell=children[index+1];break;}}
return futureCell&&getElementToFocus(futureCell);}
isInlineEditable(record){return!!this.props.editable;}
onCellKeydown(ev,group=null,record=null){if(this.props.list.model.useSampleModel){return;}
const hotkey=getActiveHotkey(ev);if(ev.target.tagName==="TEXTAREA"&&hotkey==="enter"){return;}
const closestCell=ev.target.closest("td, th");if(this.toggleFocusInsideCell(hotkey,closestCell)){return;}
const handled=this.editedRecord?this.onCellKeydownEditMode(hotkey,closestCell,group,record):this.onCellKeydownReadOnlyMode(hotkey,closestCell,group,record);if(handled){this.lastCreatingAction=false;this.tableRef.el.querySelector("tbody").classList.add("o_keyboard_navigation");ev.preventDefault();ev.stopPropagation();}}
findNextFocusableOnRow(row,cell){const children=[...row.children];const index=children.indexOf(cell);const nextCells=children.slice(index+1);for(const c of nextCells){if(!c.classList.contains("o_data_cell")){continue;}
if(c.firstElementChild&&c.firstElementChild.classList.contains("o_readonly_modifier")){continue;}
const toFocus=getElementToFocus(c,0);if(toFocus!==c){return toFocus;}}
return null;}
findPreviousFocusableOnRow(row,cell){const children=[...row.children];const index=children.indexOf(cell);const previousCells=children.slice(0,index);for(const c of previousCells.reverse()){if(!c.classList.contains("o_data_cell")){continue;}
if(c.firstElementChild&&c.firstElementChild.classList.contains("o_readonly_modifier")){continue;}
const toFocus=getElementToFocus(c,-1);if(toFocus!==c){return toFocus;}}
return null;}
expandCheckboxes(record,direction){const{records}=this.props.list;if(!record&&direction==="down"){const defaultRecord=records[0];this.shiftKeyedRecord=defaultRecord;defaultRecord.toggleSelection(true);return true;}
const recordIndex=records.indexOf(record);const shiftKeyedRecordIndex=records.indexOf(this.shiftKeyedRecord);let nextRecord;let isExpanding;switch(direction){case"up":if(recordIndex<=0){return false;}
nextRecord=records[recordIndex-1];isExpanding=shiftKeyedRecordIndex>recordIndex-1;break;case"down":if(recordIndex===records.length-1){return false;}
nextRecord=records[recordIndex+1];isExpanding=shiftKeyedRecordIndex<recordIndex+1;break;}
if(isExpanding){record.toggleSelection(true);nextRecord.toggleSelection(true);}else{record.toggleSelection(false);}
return true;}
applyCellKeydownMultiEditMode(hotkey,cell,group,record){const{list}=this.props;const row=cell.parentElement;let toFocus,futureRecord;const index=list.selection.indexOf(record);if(this.lastIsDirty&&["tab","shift+tab","enter"].includes(hotkey)){list.leaveEditMode();return true;}
if(this.applyCellKeydownEditModeStayOnRow(hotkey,cell,group,record)){return true;}
switch(hotkey){case"tab":futureRecord=list.selection[index+1]||list.selection[0];if(record===futureRecord){toFocus=this.findNextFocusableOnRow(row,cell);this.focus(toFocus);return true;}
break;case"shift+tab":futureRecord=list.selection[index-1]||list.selection[list.selection.length-1];if(record===futureRecord){toFocus=this.findPreviousFocusableOnRow(row,cell);this.focus(toFocus);return true;}
this.cellToFocus={forward:false,record:futureRecord};break;case"enter":if(list.selection.length===1){list.leaveEditMode();return true;}
futureRecord=list.selection[index+1]||list.selection[0];break;}
if(futureRecord){list.enterEditMode(futureRecord);return true;}
return false;}
applyCellKeydownEditModeGroup(hotkey,_cell,group,record){const{editable}=this.props;const groupIndex=group.list.records.indexOf(record);const isLastOfGroup=groupIndex===group.list.records.length-1;const isDirty=record.dirty||this.lastIsDirty;const isEnterBehavior=hotkey==="enter"&&(!record.canBeAbandoned||isDirty);const isTabBehavior=hotkey==="tab"&&!record.canBeAbandoned&&isDirty;if(isLastOfGroup&&this.canCreate&&editable==="bottom"&&(isEnterBehavior||isTabBehavior)){this.add({group});return true;}
return false;}
applyCellKeydownEditModeStayOnRow(hotkey,cell,group,record){let toFocus;const row=cell.parentElement;switch(hotkey){case"tab":toFocus=this.findNextFocusableOnRow(row,cell);break;case"shift+tab":toFocus=this.findPreviousFocusableOnRow(row,cell);break;}
if(toFocus){this.focus(toFocus);return true;}
return false;}
onCellKeydownEditMode(hotkey,cell,group,record){const{cycleOnTab,list}=this.props;const row=cell.parentElement;const applyMultiEditBehavior=record&&record.selected&&list.model.multiEdit;const topReCreate=this.props.editable==="top"&&record.isNew;if(applyMultiEditBehavior&&this.applyCellKeydownMultiEditMode(hotkey,cell,group,record)){return true;}
if(this.applyCellKeydownEditModeStayOnRow(hotkey,cell,group,record)){return true;}
if(group&&this.applyCellKeydownEditModeGroup(hotkey,cell,group,record)){return true;}
switch(hotkey){case"tab":{const index=list.records.indexOf(record);const lastIndex=topReCreate?0:list.records.length-1;if(index===lastIndex||index===list.records.length-1){if(this.displayRowCreates){if(record.isNew&&!record.dirty){list.leaveEditMode();return false;}
const{context}=this.creates[0];this.add({context});}else if(this.canCreate&&!record.canBeAbandoned&&(record.dirty||this.lastIsDirty)){this.add({group});}else if(cycleOnTab){if(record.canBeAbandoned){list.leaveEditMode();}
const futureRecord=list.records[0];if(record===futureRecord){const toFocus=this.findNextFocusableOnRow(row);this.focus(toFocus);}else{list.enterEditMode(futureRecord);}}else{return false;}}else{const futureRecord=list.records[index+1];list.enterEditMode(futureRecord);}
break;}
case"shift+tab":{const index=list.records.indexOf(record);if(index===0){if(cycleOnTab){if(record.canBeAbandoned){list.leaveEditMode();}
const futureRecord=list.records[list.records.length-1];if(record===futureRecord){const toFocus=this.findPreviousFocusableOnRow(row);this.focus(toFocus);}else{this.cellToFocus={forward:false,record:futureRecord};list.enterEditMode(futureRecord);}}else{list.leaveEditMode();return false;}}else{const futureRecord=list.records[index-1];this.cellToFocus={forward:false,record:futureRecord};list.enterEditMode(futureRecord);}
break;}
case"enter":{const index=list.records.indexOf(record);let futureRecord=list.records[index+1];if(topReCreate&&index===0){futureRecord=null;}
if(!futureRecord&&!this.canCreate){futureRecord=list.records[0];}
if(futureRecord){list.leaveEditMode({validate:true}).then((canProceed)=>{if(canProceed){list.enterEditMode(futureRecord);}});}else if(this.lastIsDirty||!record.canBeAbandoned||this.displayRowCreates){this.add({group});}else{futureRecord=list.records.at(0);list.enterEditMode(futureRecord);}
break;}
case"escape":{list.leaveEditMode({discard:true});const firstAddButton=this.tableRef.el.querySelector(".o_field_x2many_list_row_add a");if(firstAddButton){this.focus(firstAddButton);}else if(group&&record.isNew){const children=[...row.parentElement.children];const index=children.indexOf(row);for(let i=index+1;i<children.length;i++){const row=children[i];if(row.classList.contains("o_group_header")){break;}
const addCell=[...row.children].find((c)=>c.classList.contains("o_group_field_row_add"));if(addCell){const toFocus=addCell.querySelector("a");this.focus(toFocus);return true;}}
this.focus(cell);}else{this.focus(cell);}
break;}
default:return false;}
return true;}
onCellKeydownReadOnlyMode(hotkey,cell,group,record){const cellIsInGroupRow=Boolean(group&&!record);const applyMultiEditBehavior=record&&record.selected&&this.props.list.model.multiEdit;let toFocus;switch(hotkey){case"arrowup":toFocus=this.findFocusFutureCell(cell,cellIsInGroupRow,"up");if(!toFocus&&this.env.searchModel){this.env.searchModel.trigger("focus-search");return true;}
break;case"arrowdown":toFocus=this.findFocusFutureCell(cell,cellIsInGroupRow,"down");break;case"arrowleft":if(cellIsInGroupRow&&!group.isFolded){this.toggleGroup(group);return true;}
if(cell.classList.contains("o_field_x2many_list_row_add")){const a=document.activeElement;toFocus=a.previousElementSibling;}else{toFocus=this.findFocusFutureCell(cell,cellIsInGroupRow,"left");}
break;case"arrowright":if(cellIsInGroupRow&&group.isFolded){this.toggleGroup(group);return true;}
if(cell.classList.contains("o_field_x2many_list_row_add")){const a=document.activeElement;toFocus=a.nextElementSibling;}else{toFocus=this.findFocusFutureCell(cell,cellIsInGroupRow,"right");}
break;case"tab":if(cellIsInGroupRow){const buttons=Array.from(cell.querySelectorAll(".o_group_buttons button"));const currentButton=document.activeElement.closest("button");const index=buttons.indexOf(currentButton);toFocus=buttons[index+1]||currentButton;}
break;case"shift+tab":if(cellIsInGroupRow){const buttons=Array.from(cell.querySelectorAll(".o_group_buttons button"));const currentButton=document.activeElement.closest("button");const index=buttons.indexOf(currentButton);toFocus=buttons[index-1]||currentButton;}
break;case"shift+arrowdown":{if(this.expandCheckboxes(record,"down")){toFocus=this.findFocusFutureCell(cell,cellIsInGroupRow,"down");}
break;}
case"shift+arrowup":{if(this.expandCheckboxes(record,"up")){toFocus=this.findFocusFutureCell(cell,cellIsInGroupRow,"up");}
break;}
case"shift+space":this.toggleRecordSelection(record);toFocus=getElementToFocus(cell);break;case"shift":this.shiftKeyedRecord=record;break;case"enter":if(!group&&!record){return false;}
if(cell.classList.contains("o_list_record_remove")){this.onDeleteRecord(record);return true;}
if(cellIsInGroupRow){const button=document.activeElement.closest("button");if(button){button.click();}else{this.toggleGroup(group);}
return true;}
if(this.isInlineEditable(record)||applyMultiEditBehavior){const column=this.columns.find((c)=>c.name===cell.getAttribute("name"));this.cellToFocus={column,record};this.props.list.enterEditMode(record);return true;}
if(!this.props.archInfo.noOpen){this.props.openRecord(record);return true;}
break;default:return false;}
if(toFocus){this.focus(toFocus);return true;}
return false;}
saveOptionalActiveFields(){browser.localStorage.setItem(this.keyOptionalFields,Object.keys(this.optionalActiveFields).filter((fieldName)=>this.optionalActiveFields[fieldName]));}
get showNoContentHelper(){const{model}=this.props.list;return this.props.noContentHelp&&(model.useSampleModel||!model.hasData());}
showGroupPager(group){return!group.isFolded&&group.list.limit<group.list.count;}
toggleFocusInsideCell(hotkey,cell){if(!["tab","shift+tab"].includes(hotkey)||!containsActiveElement(cell)){return false;}
const focusableEls=getTabableElements(cell).filter((el)=>el===document.activeElement||["INPUT","TEXTAREA"].includes(el.tagName));const index=focusableEls.indexOf(document.activeElement);return((hotkey==="tab"&&index<focusableEls.length-1)||(hotkey==="shift+tab"&&index>0));}
async onGroupHeaderClicked(ev,group){const left=await this.props.list.leaveEditMode();if(left){this.toggleGroup(group);}}
toggleGroup(group){group.toggle();}
get canSelectRecord(){return!this.editedRecord&&!this.props.list.model.useSampleModel;}
toggleSelection(){const list=this.props.list;if(!this.canSelectRecord){return;}
return list.toggleSelection();}
toggleRecordSelection(record,ev){if(!this.canSelectRecord){return;}
const isRecordPresent=this.props.list.records.includes(this.lastCheckedRecord);if(this.shiftKeyMode&&isRecordPresent){this.toggleRecordShiftSelection(record);}else{record.toggleSelection();}
this.lastCheckedRecord=record;}
toggleRecordShiftSelection(record){const{records}=this.props.list;const recordIndex=records.indexOf(record);const lastCheckedRecordIndex=records.indexOf(this.lastCheckedRecord);const start=Math.min(recordIndex,lastCheckedRecordIndex);const end=Math.max(recordIndex,lastCheckedRecordIndex);const{selected}=record;for(let i=start;i<=end;i++){records[i].toggleSelection(!selected);}}
async toggleOptionalField(fieldName){this.optionalActiveFields[fieldName]=!this.optionalActiveFields[fieldName];this.saveOptionalActiveFields(this.allColumns.filter((col)=>this.optionalActiveFields[col.name]&&col.optional));this.render();}
toggleOptionalFieldGroup(groupId){const fieldNames=this.allColumns.filter((col)=>col.type==="field"&&col.relatedPropertyField&&col.relatedPropertyField.id===groupId).map((col)=>col.name);const active=!fieldNames.every((fieldName)=>this.optionalActiveFields[fieldName]);for(const fieldName of fieldNames){this.optionalActiveFields[fieldName]=active;}
this.saveOptionalActiveFields(this.allColumns.filter((col)=>this.optionalActiveFields[col.name]&&col.optional));this.render();}
toggleDebugOpenView(){this.debugOpenView=!this.debugOpenView;browser.localStorage.setItem(this.keyDebugOpenView,this.debugOpenView);this.render();}
onGlobalClick(ev){if(!this.editedRecord){return;}
this.tableRef.el.querySelector("tbody").classList.remove("o_keyboard_navigation");const target=ev.target;if(this.tableRef.el.contains(target)&&target.closest(".o_data_row")){return;}
if(this.activeElement!==this.uiService.activeElement){return;}
if(target.closest(".o_datetime_picker")){return;}
if(ev.target.closest(".ui-autocomplete")){return;}
this.props.list.leaveEditMode();}
get isDebugMode(){return Boolean(odoo.debug);}
makeTooltip(column){return getTooltipInfo({viewMode:"list",resModel:this.props.list.resModel,field:this.fields[column.name],fieldInfo:column,});}
onColumnTitleMouseUp(){if(this.columnWidths.resizing){this.preventReorder=true;}}
resetLongTouchTimer(){if(this.longTouchTimer){browser.clearTimeout(this.longTouchTimer);this.longTouchTimer=null;}}
onRowTouchStart(record,ev){if(!this.props.allowSelectors){return;}
if(this.props.list.selection.length){ev.stopPropagation();}
this.touchStartMs=Date.now();if(this.longTouchTimer===null){this.longTouchTimer=browser.setTimeout(()=>{this.toggleRecordSelection(record);this.resetLongTouchTimer();},this.constructor.LONG_TOUCH_THRESHOLD);}}
onRowTouchEnd(record){const elapsedTime=Date.now()-this.touchStartMs;if(elapsedTime<this.constructor.LONG_TOUCH_THRESHOLD){this.resetLongTouchTimer();}}
onRowTouchMove(record){this.resetLongTouchTimer();}
async sortDrop(dataRowId,{element,previous}){await this.props.list.leaveEditMode();element.classList.remove("o_row_draggable");const refId=previous?previous.dataset.id:null;try{this.resequencePromise=this.props.list.resequence(dataRowId,refId,{handleField:this.props.list.handleField,});await this.resequencePromise;}finally{element.classList.add("o_row_draggable");}}
sortStart({element}){const table=this.tableRef.el;const headers=[...table.querySelectorAll("thead th")];const cells=[...element.querySelectorAll("td")];let headerIndex=0;for(const cell of cells){let width=0;for(let i=0;i<cell.colSpan;i++){const header=headers[headerIndex+i];const style=getComputedStyle(header);width+=parseFloat(style.width);}
cell.style.width=`${width}px`;headerIndex+=cell.colSpan;}}
sortStop({element}){for(const cell of element.querySelectorAll("td")){cell.style.width=null;}}
ignoreEventInSelectionMode(ev){const{list}=this.props;if(this.env.isSmall&&list.selection&&list.selection.length){ev.stopPropagation();ev.preventDefault();}}
onClickCapture(record,ev){const{list}=this.props;if(this.env.isSmall&&list.selection&&list.selection.length){ev.stopPropagation();ev.preventDefault();this.toggleRecordSelection(record);}}}
return __exports;});;

/* /web/static/src/views/list/list_view.js */
odoo.define('@web/views/list/list_view',['@web/core/registry','@web/model/relational_model/relational_model','@web/views/list/list_arch_parser','@web/views/list/list_controller','@web/views/list/list_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{RelationalModel}=require("@web/model/relational_model/relational_model");const{ListArchParser}=require("@web/views/list/list_arch_parser");const{ListController}=require("@web/views/list/list_controller");const{ListRenderer}=require("@web/views/list/list_renderer");const listView=__exports.listView={type:"list",Controller:ListController,Renderer:ListRenderer,ArchParser:ListArchParser,Model:RelationalModel,buttonTemplate:"web.ListView.Buttons",canOrderByCount:true,limit:80,props:(genericProps,view)=>{const{ArchParser}=view;const{arch,relatedModels,resModel}=genericProps;const archInfo=new ArchParser().parse(arch,relatedModels,resModel);return{...genericProps,Model:view.Model,Renderer:view.Renderer,buttonTemplate:view.buttonTemplate,archInfo,};},};registry.category("views").add("list",listView);return __exports;});;

/* /web/static/src/views/standard_view_props.js */
odoo.define('@web/views/standard_view_props',[],function(require){'use strict';let __exports={};const standardViewProps=__exports.standardViewProps={info:{type:Object,},resModel:String,arch:{type:Element},bannerRoute:{type:String,optional:true},className:{type:String,optional:true},comparison:{type:[Object,{value:null}],optional:true},context:{type:Object},createRecord:{type:Function,optional:true},display:{type:Object,optional:true},domain:{type:Array},fields:{type:Object},globalState:{type:Object,optional:true},groupBy:{type:Array,element:String},limit:{type:Number,optional:true},noBreadcrumbs:{type:Boolean,optional:true},orderBy:{type:Array,element:Object},relatedModels:{type:Object,optional:true},resId:{type:[Number,Boolean],optional:true},resIds:{type:Array,optional:true},searchMenuTypes:{type:Array,element:String},selectRecord:{type:Function,optional:true},state:{type:Object,optional:true},useSampleModel:{type:Boolean},updateActionState:{type:Function,optional:true},};return __exports;});;

/* /web/static/src/views/utils.js */
odoo.define('@web/views/utils',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/strings','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{exprToBoolean}=require("@web/core/utils/strings");const{combineModifiers}=require("@web/model/relational_model/utils");const X2M_TYPES=__exports.X2M_TYPES=["one2many","many2many"];const NUMERIC_TYPES=["integer","float","monetary"];const BUTTON_CLICK_PARAMS=__exports.BUTTON_CLICK_PARAMS=["name","type","args","block-ui","context","close","cancel-label","confirm","confirm-title","confirm-label","special","effect","help","debounce","noSaveDialog",];function getViewClass(type){const isValidType=Boolean(type)&&registry.category("views").contains(type);return isValidType&&`o_${type}_view`;}
__exports.computeViewClassName=computeViewClassName;function computeViewClassName(viewType,rootNode,additionalClassList=[]){const subType=rootNode?.getAttribute("js_class");const classList=rootNode?.getAttribute("class")?.split(" ")||[];const uniqueClasses=new Set([getViewClass(viewType),getViewClass(subType),...classList,...additionalClassList,]);return Array.from(uniqueClasses).filter((c)=>c).join(" ");}
const computeReportMeasures=__exports.computeReportMeasures=(fields,fieldAttrs,activeMeasures,{sumAggregatorOnly=false}={})=>{const measures={__count:{name:"__count",string:_t("Count"),type:"integer"},};for(const[fieldName,field]of Object.entries(fields)){if(fieldName==="id"){continue;}
const{isInvisible}=fieldAttrs[fieldName]||{};if(isInvisible){continue;}
if(["integer","float","monetary"].includes(field.type)&&((sumAggregatorOnly&&field.aggregator==="sum")||(!sumAggregatorOnly&&field.aggregator))){measures[fieldName]=field;}}
for(const measure of activeMeasures){if(!measures[measure]){measures[measure]=fields[measure];}}
for(const fieldName in fieldAttrs){if(fieldAttrs[fieldName].string&&fieldName in measures){measures[fieldName].string=fieldAttrs[fieldName].string;}}
const sortedMeasures=Object.entries(measures).sort(([m1,f1],[m2,f2])=>{if(m1==="__count"||m2==="__count"){return m1==="__count"?1:-1;}
return f1.string.toLowerCase().localeCompare(f2.string.toLowerCase());});return Object.fromEntries(sortedMeasures);};__exports.getFormattedValue=getFormattedValue;function getFormattedValue(record,fieldName,fieldInfo=null){const field=record.fields[fieldName];const formatter=registry.category("formatters").get(field.type,(val)=>val);const formatOptions={};if(fieldInfo&&formatter.extractOptions){Object.assign(formatOptions,formatter.extractOptions(fieldInfo));}
formatOptions.data=record.data;formatOptions.field=field;return record.data[fieldName]!==undefined?formatter(record.data[fieldName],formatOptions):"";}
__exports.getActiveActions=getActiveActions;function getActiveActions(rootNode){const activeActions={type:"view",edit:exprToBoolean(rootNode.getAttribute("edit"),true),create:exprToBoolean(rootNode.getAttribute("create"),true),delete:exprToBoolean(rootNode.getAttribute("delete"),true),};activeActions.duplicate=activeActions.create&&exprToBoolean(rootNode.getAttribute("duplicate"),true);return activeActions;}
__exports.getClassNameFromDecoration=getClassNameFromDecoration;function getClassNameFromDecoration(decoration){if(decoration==="bf"){return"fw-bold";}else if(decoration==="it"){return"fst-italic";}
return`text-${decoration}`;}
__exports.getDecoration=getDecoration;function getDecoration(rootNode){const decorations=[];for(const name of rootNode.getAttributeNames()){if(name.startsWith("decoration-")){decorations.push({class:getClassNameFromDecoration(name.replace("decoration-","")),condition:rootNode.getAttribute(name),});}}
return decorations;}
__exports.isX2Many=isX2Many;function isX2Many(field){return field&&X2M_TYPES.includes(field.type);}
__exports.isNumeric=isNumeric;function isNumeric(field){return NUMERIC_TYPES.includes(field.type);}
__exports.isNull=isNull;function isNull(value){return[null,undefined].includes(value);}
__exports.processButton=processButton;function processButton(node){const withDefault={close:(val)=>exprToBoolean(val,false),context:(val)=>val||"{}",};const clickParams={};const attrs={};for(const{name,value}of node.attributes){if(BUTTON_CLICK_PARAMS.includes(name)){clickParams[name]=withDefault[name]?withDefault[name](value):value;}else{attrs[name]=value;}}
return{className:node.getAttribute("class")||"",disabled:!!node.getAttribute("disabled")||false,icon:node.getAttribute("icon")||false,title:node.getAttribute("title")||undefined,string:node.getAttribute("string")||undefined,options:JSON.parse(node.getAttribute("options")||"{}"),display:node.getAttribute("display")||"selection",clickParams,column_invisible:node.getAttribute("column_invisible"),invisible:combineModifiers(node.getAttribute("column_invisible"),node.getAttribute("invisible"),"OR"),readonly:node.getAttribute("readonly"),required:node.getAttribute("required"),attrs,};}
__exports.processMeasure=processMeasure;function processMeasure(measure){if(Array.isArray(measure)){return measure.map(processMeasure);}
return measure==="__count__"?"__count":measure;}
__exports.toStringExpression=toStringExpression;function toStringExpression(str){return`\`${str.replaceAll("`", "\\`")}\``;}
__exports.uuid=uuid;function uuid(){const array=new Uint8Array(8);window.crypto.getRandomValues(array);return[...array].map((b)=>b.toString(16).padStart(2,"0")).join("");}
return __exports;});;

/* /web/static/src/views/view.js */
odoo.define('@web/views/view',['@web/core/debug/debug_context','@web/core/py_js/py','@web/core/registry','@web/core/utils/concurrency','@web/core/utils/hooks','@web/core/utils/objects','@web/core/utils/strings','@web/core/utils/xml','@web/search/layout','@web/search/with_search/with_search','@web/views/view_hook','@web/views/utils','@web/core/assets','@web/core/browser/cookie','@odoo/owl','@web/session'],function(require){'use strict';let __exports={};const{useDebugCategory}=require("@web/core/debug/debug_context");const{evaluateBooleanExpr}=require("@web/core/py_js/py");const{registry}=require("@web/core/registry");const{KeepLast}=require("@web/core/utils/concurrency");const{useService}=require("@web/core/utils/hooks");const{deepCopy,pick}=require("@web/core/utils/objects");const{nbsp}=require("@web/core/utils/strings");const{parseXML}=require("@web/core/utils/xml");const{extractLayoutComponents}=require("@web/search/layout");const{WithSearch}=require("@web/search/with_search/with_search");const{useActionLinks}=require("@web/views/view_hook");const{computeViewClassName}=require("@web/views/utils");const{loadBundle}=require("@web/core/assets");const{cookie}=require("@web/core/browser/cookie");const{Component,markRaw,onWillUpdateProps,onWillStart,toRaw,useSubEnv,reactive,}=require("@odoo/owl");const{session}=require("@web/session");const viewRegistry=registry.category("views");viewRegistry.addValidation({type:{validate:(t)=>t in session.view_info},Controller:{validate:(c)=>c.prototype instanceof Component},"*":true,});__exports.getDefaultConfig=getDefaultConfig;function getDefaultConfig(){let displayName;const config={actionId:false,actionType:false,embeddedActions:[],currentEmbeddedActionId:false,parentActionId:false,actionFlags:{},breadcrumbs:reactive([{get name(){return displayName;},},]),disableSearchBarAutofocus:false,getDisplayName:()=>displayName,historyBack:()=>{},pagerProps:{},setDisplayName:(newDisplayName)=>{displayName=newDisplayName;config.breadcrumbs.push(undefined);config.breadcrumbs.pop();},viewSwitcherEntries:[],views:[],};return config;}
const ViewNotFoundError=__exports.ViewNotFoundError=class ViewNotFoundError extends Error{}
const CALLBACK_RECORDER_NAMES=["__beforeLeave__","__getGlobalState__","__getLocalState__","__getContext__","__getOrderBy__",];const STANDARD_PROPS=["resModel","type","jsClass","arch","fields","relatedModels","viewId","views","actionMenus","loadActionMenus","searchViewArch","searchViewFields","searchViewId","irFilters","loadIrFilters","comparison","context","domain","groupBy","orderBy","useSampleModel","noContentHelp","className","display","globalState","activateFavorite","dynamicFilters","hideCustomGroupBy","searchMenuTypes",...CALLBACK_RECORDER_NAMES,"searchPanel","searchModel",];const ACTIONS=["create","delete","edit","group_create","group_delete","group_edit"];const View=__exports.View=class View extends Component{static _download=async function(){};static template="web.View";static components={WithSearch};static searchMenuTypes=["filter","groupBy","favorite"];static canOrderByCount=false;static defaultProps={display:{},context:{},loadActionMenus:false,loadIrFilters:false,className:"",};static props={"*":true,};setup(){const{arch,fields,resModel,searchViewArch,searchViewFields,type}=this.props;if(!resModel){throw Error(`View props should have a "resModel" key`);}
if(!type){throw Error(`View props should have a "type" key`);}
if((arch&&!fields)||(!arch&&fields)){throw new Error(`"arch" and "fields" props must be given together`);}
if((searchViewArch&&!searchViewFields)||(!searchViewArch&&searchViewFields)){throw new Error(`"searchViewArch" and "searchViewFields" props must be given together`);}
this.viewService=useService("view");this.withSearchProps=null;useSubEnv({keepLast:new KeepLast(),config:{...getDefaultConfig(),...this.env.config,},...Object.fromEntries(CALLBACK_RECORDER_NAMES.map((name)=>[name,this.props[name]||null])),});this.handleActionLinks=useActionLinks({resModel});onWillStart(()=>this.loadView(this.props));onWillUpdateProps((nextProps)=>this.onWillUpdateProps(nextProps));useDebugCategory("view",{component:this});}
async loadView(props){const type=props.type;if(!session.view_info[type]){throw new Error(`Invalid view type: ${type}`);}
let{viewId,searchViewId}=props;const views=deepCopy(props.views||this.env.config.views);const view=views.find((v)=>v[1]===type)||[];if(view.length){view[0]=viewId!==undefined?viewId:view[0];viewId=view[0];}else{view.push(viewId||false,type);views.push(view);}
const searchView=views.find((v)=>v[1]==="search");if(searchView){searchView[0]=searchViewId!==undefined?searchViewId:searchView[0];searchViewId=searchView[0];}else if(searchViewId!==undefined){views.push([searchViewId,"search"]);}
const{context,resModel,loadActionMenus,loadIrFilters}=props;let{arch,fields,relatedModels,searchViewArch,searchViewFields,irFilters,actionMenus,}=props;const loadView=!arch||(!actionMenus&&loadActionMenus);const loadSearchView=(searchViewId!==undefined&&!searchViewArch)||(!irFilters&&loadIrFilters);let viewDescription={viewId,resModel,type};let searchViewDescription;if(loadView||loadSearchView){const options={actionId:this.env.config.actionId,loadActionMenus,loadIrFilters,};if(this.env.config.currentEmbeddedActionId){options.embeddedActionId=this.env.config.currentEmbeddedActionId;options.embeddedParentResId=context.active_id;}
const result=await this.viewService.loadViews({context,resModel,views},options);viewDescription=result.views[type];searchViewDescription=result.views.search;if(loadSearchView){searchViewId=searchViewId||searchViewDescription.id;if(!searchViewArch){searchViewArch=searchViewDescription.arch;searchViewFields=result.fields;}
if(!irFilters){irFilters=searchViewDescription.irFilters;}}
this.env.config.views=views;fields=fields||markRaw(result.fields);relatedModels=relatedModels||markRaw(result.relatedModels);}
if(!arch){arch=viewDescription.arch;}
if(!actionMenus){actionMenus=viewDescription.actionMenus;}
const archXmlDoc=parseXML(arch.replace(/&amp;nbsp;/g,nbsp));for(const action of ACTIONS){if(action in this.props.context&&!this.props.context[action]){archXmlDoc.setAttribute(action,"0");}}
const jsClass=archXmlDoc.hasAttribute("js_class")?archXmlDoc.getAttribute("js_class"):props.jsClass||type;if(!viewRegistry.contains(jsClass)){await loadBundle(cookie.get("color_scheme")==="dark"?"web.assets_backend_lazy_dark":"web.assets_backend_lazy");}
const descr=viewRegistry.get(jsClass);const sample=archXmlDoc.getAttribute("sample");const className=computeViewClassName(type,archXmlDoc,["o_view_controller",...(props.className||"").split(" "),]);Object.assign(this.env.config,{rawArch:arch,viewArch:archXmlDoc,viewId:viewDescription.id,viewType:type,viewSubType:jsClass,noBreadcrumbs:props.noBreadcrumbs,...extractLayoutComponents(descr),});const info={actionMenus,mode:props.display.mode,irFilters,searchViewArch,searchViewFields,searchViewId,};const viewProps={info,arch:archXmlDoc,fields,relatedModels,resModel,useSampleModel:false,className,};if(viewDescription.custom_view_id){viewProps.info.customViewId=viewDescription.custom_view_id;}
if(props.globalState){viewProps.globalState=props.globalState;}
if("useSampleModel"in props){viewProps.useSampleModel=props.useSampleModel;}else if(sample){viewProps.useSampleModel=evaluateBooleanExpr(sample);}
for(const key in props){if(!STANDARD_PROPS.includes(key)){viewProps[key]=props[key];}}
const{noContentHelp}=props;if(noContentHelp){viewProps.info.noContentHelp=noContentHelp;}
const searchMenuTypes=props.searchMenuTypes||descr.searchMenuTypes||this.constructor.searchMenuTypes;viewProps.searchMenuTypes=searchMenuTypes;const canOrderByCount=descr.canOrderByCount||this.constructor.canOrderByCount;const finalProps=descr.props?descr.props(viewProps,descr,this.env.config):viewProps;this.Controller=descr.Controller;this.componentProps=finalProps;this.withSearchProps={...toRaw(props),hideCustomGroupBy:props.hideCustomGroupBy||descr.hideCustomGroupBy,searchMenuTypes,canOrderByCount,SearchModel:descr.SearchModel,};if(searchViewId!==undefined){this.withSearchProps.searchViewId=searchViewId;}
if(searchViewArch){this.withSearchProps.searchViewArch=searchViewArch;this.withSearchProps.searchViewFields=searchViewFields;}
if(irFilters){this.withSearchProps.irFilters=irFilters;}
if(descr.display){const viewDisplay=deepCopy(descr.display);const display={...this.withSearchProps.display};for(const key in viewDisplay){if(typeof display[key]==="object"){Object.assign(display[key],viewDisplay[key]);}else if(!(key in display)||display[key]){display[key]=viewDisplay[key];}}
this.withSearchProps.display=display;}
for(const key in this.withSearchProps){if(!(key in WithSearch.props)){delete this.withSearchProps[key];}}}
onWillUpdateProps(nextProps){const oldProps=pick(this.props,"arch","type","resModel");const newProps=pick(nextProps,"arch","type","resModel");if(JSON.stringify(oldProps)!==JSON.stringify(newProps)){return this.loadView(nextProps);}
const{comparison,context,domain,groupBy,orderBy}=nextProps;Object.assign(this.withSearchProps,{comparison,context,domain,groupBy,orderBy});}}
return __exports;});;

/* /web/static/src/views/view_button/multi_record_view_button.js */
odoo.define('@web/views/view_button/multi_record_view_button',['@web/views/view_button/view_button'],function(require){'use strict';let __exports={};const{ViewButton}=require("@web/views/view_button/view_button");const MultiRecordViewButton=__exports.MultiRecordViewButton=class MultiRecordViewButton extends ViewButton{static props=[...ViewButton.props,"list","domain"];async onClick(){const{clickParams,list}=this.props;const resIds=await list.getResIds(true);clickParams.buttonContext={active_domain:this.props.domain,active_ids:resIds,active_model:list.resModel,};this.env.onClickViewButton({clickParams,getResParams:()=>({context:list.context,evalContext:list.evalContext,resModel:list.resModel,resIds,}),});}}
return __exports;});;

/* /web/static/src/views/view_button/view_button.js */
odoo.define('@web/views/view_button/view_button',['@odoo/owl','@web/core/dropdown/dropdown_hooks','@web/core/utils/objects','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{useDropdownCloser}=require("@web/core/dropdown/dropdown_hooks");const{pick}=require("@web/core/utils/objects");const{debounce:debounceFn}=require("@web/core/utils/timing");const explicitRankClasses=["btn-primary","btn-secondary","btn-link","btn-success","btn-info","btn-warning","btn-danger",];const odooToBootstrapClasses={oe_highlight:"btn-primary",oe_link:"btn-link",};function iconFromString(iconString){const icon={};if(iconString.startsWith("fa-")){icon.tag="i";icon.class=`o_button_icon fa fa-fw ${iconString}`;}else if(iconString.startsWith("oi-")){icon.tag="i";icon.class=`o_button_icon oi oi-fw ${iconString}`;}else{icon.tag="img";icon.src=iconString;}
return icon;}
const ViewButton=__exports.ViewButton=class ViewButton extends Component{static template="web.views.ViewButton";static props=["id?","tag?","record?","attrs?","className?","context?","clickParams?","icon?","defaultRank?","disabled?","size?","tabindex?","title?","style?","string?","slots?","onClick?",];static defaultProps={tag:"button",className:"",clickParams:{},attrs:{},};setup(){if(this.props.icon){this.icon=iconFromString(this.props.icon);}
const{debounce}=this.clickParams;if(debounce){this.onClick=debounceFn(this.onClick.bind(this),debounce,true);}
this.tooltip=JSON.stringify({debug:Boolean(odoo.debug),button:{string:this.props.string,help:this.clickParams.help,context:this.clickParams.context,invisible:this.props.attrs.invisible,column_invisible:this.props.attrs.column_invisible,readonly:this.props.attrs.readonly,required:this.props.attrs.required,special:this.clickParams.special,type:this.clickParams.type,name:this.clickParams.name,title:this.props.title,},context:this.props.record&&this.props.record.context,model:this.props.record&&this.props.record.resModel,});this.dropdownControl=useDropdownCloser();}
get clickParams(){return{context:this.props.context,...this.props.clickParams};}
get hasBigTooltip(){return Boolean(odoo.debug)||this.clickParams.help;}
get hasSmallToolTip(){return!this.hasBigTooltip&&this.props.title;}
get disabled(){const{name,type,special}=this.clickParams;return(!name&&!type&&!special)||this.props.disabled;}
onClick(ev){if(this.props.tag==="a"){ev.preventDefault();}
if(this.props.onClick){return this.props.onClick();}
this.env.onClickViewButton({clickParams:this.clickParams,getResParams:()=>pick(this.props.record||{},"context","evalContext","resModel","resId","resIds"),beforeExecute:()=>this.dropdownControl.close(),});}
getClassName(){const classNames=[];let hasExplicitRank=false;if(this.props.className){for(let cls of this.props.className.split(" ")){if(cls in odooToBootstrapClasses){cls=odooToBootstrapClasses[cls];}
classNames.push(cls);if(!hasExplicitRank&&explicitRankClasses.includes(cls)){hasExplicitRank=true;}}}
if(this.props.tag==="button"){const hasOtherClasses=classNames.length;classNames.unshift("btn");if((!hasExplicitRank&&this.props.defaultRank)||!hasOtherClasses){classNames.push(this.props.defaultRank||"btn-secondary");}
if(this.props.size){classNames.push(`btn-${this.props.size}`);}}
return classNames.join(" ");}}
return __exports;});;

/* /web/static/src/views/view_button/view_button_hook.js */
odoo.define('@web/views/view_button/view_button_hook',['@web/core/utils/hooks','@web/core/py_js/py','@web/core/confirmation_dialog/confirmation_dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{evaluateExpr}=require("@web/core/py_js/py");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{status,useComponent,useEnv,useSubEnv}=require("@odoo/owl");__exports.executeButtonCallback=executeButtonCallback;async function executeButtonCallback(el,fct){let btns=[];function disableButtons(){btns=[...btns,...el.querySelectorAll("button:not([disabled])"),...document.querySelectorAll(".o-overlay-container button:not([disabled])"),];for(const btn of btns){btn.setAttribute("disabled","1");}}
function enableButtons(){for(const btn of btns){btn.removeAttribute("disabled");}}
disableButtons();let res;try{res=await fct();}finally{enableButtons();}
return res;}
function undefinedAsTrue(val){return typeof val==="undefined"||val;}
__exports.useViewButtons=useViewButtons;function useViewButtons(ref,options={}){const action=useService("action");const dialog=useService("dialog");const comp=useComponent();const env=useEnv();useSubEnv({async onClickViewButton({clickParams,getResParams,beforeExecute}){async function execute(){let _continue=true;if(beforeExecute){_continue=undefinedAsTrue(await beforeExecute());}
_continue=_continue&&undefinedAsTrue(await options.beforeExecuteAction?.(clickParams));if(!_continue){return;}
const closeDialog=(clickParams.close||clickParams.special)&&env.dialogData?.close;const params=getResParams();let buttonContext={};if(clickParams.context){if(typeof clickParams.context==="string"){buttonContext=evaluateExpr(clickParams.context,params.evalContext);}else{buttonContext=clickParams.context;}}
if(clickParams.buttonContext){Object.assign(buttonContext,clickParams.buttonContext);}
const doActionParams=Object.assign({},clickParams,{resModel:params.resModel,resId:params.resId,resIds:params.resIds,context:params.context||{},buttonContext,onClose:async(onCloseInfo)=>{if(!closeDialog&&status(comp)!=="destroyed"&&!onCloseInfo?.noReload){await options.reload?.();}},});let error;try{await action.doActionButton(doActionParams);}catch(_e){error=_e;}
await options.afterExecuteAction?.(clickParams);if(closeDialog){closeDialog();}
if(error){return Promise.reject(error);}}
if(clickParams.confirm){executeButtonCallback(getEl(),async()=>{await new Promise((resolve)=>{const dialogProps={...(clickParams["confirm-title"]&&{title:clickParams["confirm-title"],}),...(clickParams["confirm-label"]&&{confirmLabel:clickParams["confirm-label"],}),...(clickParams["cancel-label"]&&{cancelLabel:clickParams["cancel-label"],}),body:clickParams.confirm,confirm:()=>execute(),cancel:()=>{},};dialog.add(ConfirmationDialog,dialogProps,{onClose:resolve});});});}else{return executeButtonCallback(getEl(),execute);}},});function getEl(){if(env.inDialog){const el=ref.el;return el?el.closest(".modal"):null;}else{return ref.el;}}}
return __exports;});;

/* /web/static/src/views/view_compiler.js */
odoo.define('@web/views/view_compiler',['@web/core/utils/xml','@web/views/utils','@odoo/owl'],function(require){'use strict';let __exports={};const{append,combineAttributes,createElement,createTextNode,getTag,}=require("@web/core/utils/xml");const{toStringExpression,BUTTON_CLICK_PARAMS}=require("@web/views/utils");const{xml}=require("@odoo/owl");const BUTTON_STRING_PROPS=["string","size","title","icon","id","disabled"];const INTERP_REGEXP=/(\{\{|#\{)(.*?)(\}{1,2})/g;__exports.toInterpolatedStringExpression=toInterpolatedStringExpression;function toInterpolatedStringExpression(str){const matches=str.matchAll(INTERP_REGEXP);const parts=[];let searchString=str;for(const[match,head,expr]of matches){const index=searchString.indexOf(head);const left=searchString.slice(0,index);if(left){parts.push(toStringExpression(left));}
parts.push(`(${expr})`);searchString=searchString.slice(index+match.length);}
parts.push(toStringExpression(searchString));return parts.join("+");}
__exports.appendAttr=appendAttr;function appendAttr(el,attr,string){const attrKey=`t-att-${attr}`;const attrVal=el.getAttribute(attrKey);el.setAttribute(attrKey,appendToStringifiedObject(attrVal,string));}
function appendToStringifiedObject(originalTattr,string){const re=/{(.*)}/;const oldString=re.exec(originalTattr);if(oldString){string=`${oldString[1]},${string}`;}
return`{${string}}`;}
__exports.assignOwlDirectives=assignOwlDirectives;function assignOwlDirectives(target,...sources){for(const source of sources){for(const{name,value}of source.attributes){if(name.startsWith("t-attf-")){const propName=name.slice(7);const interpolatedExpression=toInterpolatedStringExpression(value);target.setAttribute(propName,interpolatedExpression);}else if(name.startsWith("t-att-")){const propName=name.slice(6);target.setAttribute(propName,value);}else if(name.startsWith("t-")){target.setAttribute(name,value);}}}
return target;}
__exports.copyAttributes=copyAttributes;function copyAttributes(el,compiled){const isComponent=isComponentNode(compiled);const classes=el.className;if(classes){if(isComponent){const cls=compiled.className;compiled.setAttribute("class",cls?`'${classes} ' + ${cls}`:`'${classes}'`);}else{compiled.classList.add(...classes.split(/\s+/).filter(Boolean));}}
let att=el.getAttribute("style");if(att){if(isComponent){att=toStringExpression(att);}
compiled.setAttribute("style",att);}}
__exports.decodeObjectForTemplate=decodeObjectForTemplate;function decodeObjectForTemplate(str){return JSON.parse(decodeURI(str));}
__exports.encodeObjectForTemplate=encodeObjectForTemplate;function encodeObjectForTemplate(obj){return`"${encodeURI(JSON.stringify(obj))}"`;}
__exports.getModifier=getModifier;function getModifier(el,modifierName){return el.getAttribute(modifierName);}
function getTitleTag(node){return getTag(node)[0].toUpperCase()+getTag(node).slice(1);}
function isComment(node){return node.nodeType===8;}
__exports.isComponentNode=isComponentNode;function isComponentNode(el){return(getTag(el)===getTitleTag(el)||(getTag(el,true)==="t"&&"t-component"in el.attributes));}
__exports.isTextNode=isTextNode;function isTextNode(node){return node.nodeType===3;}
__exports.makeSeparator=makeSeparator;function makeSeparator(title){const separator=createElement("div");separator.className="o_horizontal_separator mt-4 mb-3 text-uppercase fw-bolder small";separator.textContent=title;return separator;}
const ViewCompiler=__exports.ViewCompiler=class ViewCompiler{constructor(templates){this.id=1;this.compilers=[{selector:"a[type]:not([data-bs-toggle]),a[data-type]:not([data-bs-toggle])",fn:this.compileButton,},{selector:"button:not([data-bs-toggle])",fn:this.compileButton,doNotCopyAttributes:true,},{selector:"field",fn:this.compileField},{selector:"widget",fn:this.compileWidget},];this.templates=templates;this.ctx={readonly:"__comp__.props.readonly"};this.owlDirectiveRegexesWhitelist=this.constructor.OWL_DIRECTIVE_WHITELIST.map((d)=>new RegExp(d));this.setup();}
setup(){}
applyInvisible(invisible,compiled,params){if(!invisible||invisible==="False"){return compiled;}
if(invisible==="True"||invisible==="1"){return;}
const recordExpr=params.recordExpr||"__comp__.props.record";let isVisileExpr=`!__comp__.evaluateBooleanExpr(${JSON.stringify(
            invisible
        )},${recordExpr}.evalContextWithVirtualIds)`;if(compiled.hasAttribute("t-if")){const formerTif=compiled.getAttribute("t-if");isVisileExpr=`( ${formerTif} ) and ${isVisileExpr}`;}
compiled.setAttribute("t-if",isVisileExpr);return compiled;}
compile(key,params={}){const root=this.templates[key].cloneNode(true);const child=this.compileNode(root,params);const newRoot=createElement("t",[child]);newRoot.setAttribute("t-translation","off");return newRoot;}
compileNode(node,params={},evalInvisible=true){if(isComment(node)){return;}
if(isTextNode(node)){return createTextNode(node.nodeValue);}
if(node.hasAttribute("t-translation")){node.removeAttribute("t-translation");}
this.validateNode(node);let invisible;if(evalInvisible){invisible=getModifier(node,"invisible");if(!params.compileInvisibleNodes&&(invisible==="True"||invisible==="1")){return;}}
const compiler=this.compilers.find((cp)=>node.matches(cp.selector));let compiledNode;if(compiler){compiledNode=compiler.fn.call(this,node,params);if(!compiler.doNotCopyAttributes&&compiledNode){copyAttributes(node,compiledNode);}}else{compiledNode=this.compileGenericNode(node,params);}
if(evalInvisible&&compiledNode){compiledNode=this.applyInvisible(invisible,compiledNode,params);}
return compiledNode;}
compileButton(el,params){let tag=getTag(el,true);const type=el.getAttribute("type");if(tag==="a"&&type==="url"){tag="button";}
const recordExpr=params.recordExpr||"__comp__.props.record";const button=createElement("ViewButton",{tag:toStringExpression(tag),record:recordExpr,});assignOwlDirectives(button,el);combineAttributes(button,"className",[toStringExpression(el.className),button.className],"+` `+");el.removeAttribute("class");button.removeAttribute("class");const clickParams={};const attrs={};for(const{name,value}of el.attributes){if(BUTTON_CLICK_PARAMS.includes(name)){clickParams[name]=value;}else if(BUTTON_STRING_PROPS.includes(name)){button.setAttribute(name,toStringExpression(value));}else if(!name.startsWith("t-")){attrs[name]=value;}}
button.setAttribute("clickParams",JSON.stringify(clickParams));button.setAttribute("attrs",JSON.stringify(attrs));const buttonContent=[];for(const child of el.childNodes){const compiled=this.compileNode(child,params);if(compiled){buttonContent.push(compiled);}}
if(buttonContent.length){const contentSlot=createElement("t");contentSlot.setAttribute("t-set-slot","contents");append(button,contentSlot);for(const buttonChild of buttonContent){append(contentSlot,buttonChild);}}
return button;}
compileField(el,params){const fieldName=el.getAttribute("name");const fieldId=el.getAttribute("field_id");const field=createElement("Field");const recordExpr=params.recordExpr||"__comp__.props.record";field.setAttribute("id",`'${fieldId}'`);field.setAttribute("name",`'${fieldName}'`);field.setAttribute("record",recordExpr);field.setAttribute("fieldInfo",`__comp__.props.archInfo.fieldNodes['${fieldId}']`);field.setAttribute("readonly",`__comp__.props.archInfo.activeActions?.edit === false and !${recordExpr}.isNew`);if(el.hasAttribute("widget")){field.setAttribute("type",`'${el.getAttribute("widget")}'`);}
return field;}
compileGenericNode(el,params){const compiled=createElement(el.nodeName.toLowerCase());const metaAttrs=["column_invisible","invisible","readonly","required"];for(const attr of el.attributes){if(metaAttrs.includes(attr.name)){continue;}
compiled.setAttribute(attr.name,attr.value);}
for(const child of el.childNodes){append(compiled,this.compileNode(child,params));}
if(el.hasAttribute("t-foreach")&&!el.hasAttribute("t-key")){compiled.setAttribute("t-key",`${el.getAttribute("t-as")}_index`);console.warn(`Missing attribute "t-key" in "t-foreach" statement.`);}
return compiled;}
compileWidget(el){const widgetId=el.getAttribute("widget_id");const props={record:"__comp__.props.record"};if(el.hasAttribute("name")){props.name=`'${el.getAttribute("name")}'`;}
if(el.hasAttribute("class")){props.className=`'${el.getAttribute("class")}'`;}
props.widgetInfo=`__comp__.props.archInfo.widgetNodes['${widgetId}']`;const widget=createElement("Widget",props);return assignOwlDirectives(widget,el);}
validateNode(node){const attributes=Object.values(node.attributes).map((attr)=>attr.name);const regexes=this.owlDirectiveRegexesWhitelist;for(const attr of attributes){if(attr.startsWith("t-")&&!regexes.some((regex)=>regex.test(attr))){console.warn(`Forbidden directive ${attr} used in arch`);}}}}
ViewCompiler.OWL_DIRECTIVE_WHITELIST=[];let templateCache=Object.create(null);__exports.useViewCompiler=useViewCompiler;function useViewCompiler(ViewCompiler,templates,params){const compiledTemplates={};let compiler;for(const tname in templates){const key=`${ViewCompiler.name}/${templates[tname].outerHTML}`;if(!templateCache[key]){compiler=compiler||new ViewCompiler(templates);templateCache[key]=xml`${compiler.compile(tname, params).outerHTML}`;}
compiledTemplates[tname]=templateCache[key];}
return compiledTemplates;}
__exports.resetViewCompilerCache=resetViewCompilerCache;function resetViewCompilerCache(){templateCache=Object.create(null);}
return __exports;});;

/* /web/static/src/views/view_components/animated_number.js */
odoo.define('@web/views/view_components/animated_number',['@web/core/browser/browser','@web/views/fields/formatters','@odoo/owl'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{formatInteger}=require("@web/views/fields/formatters");const{Component,onWillUpdateProps,onWillUnmount,useState}=require("@odoo/owl");const AnimatedNumber=__exports.AnimatedNumber=class AnimatedNumber extends Component{static template="web.AnimatedNumber";static props={value:Number,duration:Number,animationClass:{type:String,optional:true},currency:{type:[Object,Boolean],optional:true},title:{type:String,optional:true},slots:{type:Object,shape:{prefix:{type:Object,optional:true},},optional:true,},};static enableAnimations=true;setup(){this.formatInteger=formatInteger;this.state=useState({value:this.props.value});this.handle=null;onWillUpdateProps((nextProps)=>{const{value:from}=this.props;const{value:to,duration}=nextProps;if(!this.constructor.enableAnimations||!duration||to<=from){browser.cancelAnimationFrame(this.handle);this.state.value=to;return;}
const startTime=Date.now();const animate=()=>{const progress=(Date.now()-startTime)/duration;if(progress>=1){this.state.value=to;}else{this.state.value=from+(to-from)*progress;this.handle=browser.requestAnimationFrame(animate);}};browser.cancelAnimationFrame(this.handle);animate();});onWillUnmount(()=>browser.cancelAnimationFrame(this.handle));}
format(value){return this.formatInteger(value,{humanReadable:true,decimals:0,minDigits:3});}}
return __exports;});;

/* /web/static/src/views/view_components/column_progress.js */
odoo.define('@web/views/view_components/column_progress',['@odoo/owl','@web/views/view_components/animated_number'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{AnimatedNumber}=require("@web/views/view_components/animated_number");const ColumnProgress=__exports.ColumnProgress=class ColumnProgress extends Component{static components={AnimatedNumber,};static template="web.ColumnProgress";static props={aggregate:{type:Object},group:{type:Object},onBarClicked:{type:Function,optional:true},progressBar:{type:Object},};static defaultProps={onBarClicked:()=>{},};async onBarClick(bar){await this.props.onBarClicked(bar);}}
return __exports;});;

/* /web/static/src/views/view_components/report_view_measures.js */
odoo.define('@web/views/view_components/report_view_measures',['@odoo/owl','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const ReportViewMeasures=__exports.ReportViewMeasures=class ReportViewMeasures extends Component{static template="web.ReportViewMeasures";static components={Dropdown,DropdownItem,};static props={measures:true,activeMeasures:{type:Array,optional:true},onMeasureSelected:{type:Function,optional:true},};}
return __exports;});;

/* /web/static/src/views/view_components/view_scale_selector.js */
odoo.define('@web/views/view_components/view_scale_selector',['@odoo/owl','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const ViewScaleSelector=__exports.ViewScaleSelector=class ViewScaleSelector extends Component{static components={Dropdown,DropdownItem,};static template="web.ViewScaleSelector";static props={scales:{type:Object},currentScale:{type:String},isWeekendVisible:{type:Boolean,optional:true},setScale:{type:Function},toggleWeekendVisibility:{type:Function,optional:true},dropdownClass:{type:String,optional:true},};get scales(){return Object.entries(this.props.scales).map(([key,value])=>({key,...value}));}}
return __exports;});;

/* /web/static/src/views/view_dialogs/export_data_dialog.js */
odoo.define('@web/views/view_dialogs/export_data_dialog',['@web/core/l10n/translation','@web/core/browser/browser','@web/core/checkbox/checkbox','@web/core/dialog/dialog','@web/core/network/rpc','@web/core/utils/arrays','@web/core/utils/hooks','@web/core/utils/search','@web/core/utils/sortable_owl','@web/core/utils/timing','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{CheckBox}=require("@web/core/checkbox/checkbox");const{Dialog}=require("@web/core/dialog/dialog");const{rpc}=require("@web/core/network/rpc");const{unique}=require("@web/core/utils/arrays");const{useService}=require("@web/core/utils/hooks");const{fuzzyLookup}=require("@web/core/utils/search");const{useSortable}=require("@web/core/utils/sortable_owl");const{useDebounced}=require("@web/core/utils/timing");const{Component,useRef,useState,onMounted,onWillStart,onWillUnmount}=require("@odoo/owl");class DeleteExportListDialog extends Component{static components={Dialog};static template="web.DeleteExportListDialog";static props={text:String,close:Function,delete:Function,};async onDelete(){await this.props.delete();this.props.close();}}
class ExportDataItem extends Component{static template="web.ExportDataItem";static components={ExportDataItem};static props={exportList:{type:Object,optional:true},field:{type:Object,optional:true},filterSubfields:Function,isDebug:Boolean,isExpanded:Boolean,isFieldExpandable:Function,onAdd:Function,loadFields:Function,};setup(){this.state=useState({subfields:[],});onWillStart(()=>{if(this.props.isExpanded){return this.toggleItem(this.props.field.id,false);}});}
async toggleItem(id,isUserToggle){if(this.props.isFieldExpandable(id)){if(this.state.subfields.length){this.state.subfields=[];}else{const subfields=await this.props.loadFields(id,!isUserToggle);if(subfields){this.state.subfields=isUserToggle?subfields:this.props.filterSubfields(subfields);}else{this.state.subfields=[];}}}}
onDoubleClick(id){if(!this.props.isFieldExpandable(id)&&!this.isFieldSelected(id)){this.props.onAdd(id);}}
isFieldSelected(current){return this.props.exportList.find(({id})=>id===current);}}
const ExportDataDialog=__exports.ExportDataDialog=class ExportDataDialog extends Component{static template="web.ExportDataDialog";static components={CheckBox,Dialog,ExportDataItem};static props={close:{type:Function},context:{type:Object,optional:true},defaultExportList:{type:Array},download:{type:Function},getExportedFields:{type:Function},root:{type:Object},};setup(){this.dialog=useService("dialog");this.notification=useService("notification");this.orm=useService("orm");this.draggableRef=useRef("draggable");this.exportListRef=useRef("exportList");this.searchRef=useRef("search");this.knownFields={};this.expandedFields={};this.availableFormats=[];this.templates=[];this.state=useState({exportList:[],isCompatible:false,isEditingTemplate:false,search:[],selectedFormat:0,templateId:null,isSmall:this.env.isSmall,disabled:false,});this.newTemplateText=_t("New template");this.removeFieldText=_t("Remove field");this.debouncedOnResize=useDebounced(this.updateSize,300);useSortable({ref:this.draggableRef,elements:".o_export_field",enable:!this.state.isSmall,cursor:"grabbing",onDrop:async({element,previous,next})=>{const indexes=[element,previous,next].map((e)=>e&&Object.values(this.state.exportList).findIndex(({id})=>id===e.dataset.field_id));let target;if(indexes[0]<indexes[1]){target=previous?indexes[1]:0;}else{target=next?indexes[2]:this.state.exportList.length-1;}
this.onDraggingEnd(indexes[0],target);},});onWillStart(async()=>{this.availableFormats=await rpc("/web/export/formats");this.templates=await this.orm.searchRead("ir.exports",[["resource","=",this.props.root.resModel]],[],{context:this.props.context,});await this.fetchFields();});onMounted(()=>{browser.addEventListener("resize",this.debouncedOnResize);this.updateSize();});onWillUnmount(()=>browser.removeEventListener("resize",this.debouncedOnResize));}
get fieldsAvailable(){if(this.searchRef.el&&this.searchRef.el.value){return this.state.search.length&&Object.values(this.state.search);}
return Object.values(this.knownFields);}
get isDebug(){return Boolean(odoo.debug);}
get rootFields(){if(this.searchRef.el&&this.searchRef.el.value){const rootFromSearchResults=this.fieldsAvailable.map((f)=>{if(f.parent){const parentEl=this.knownFields[f.parent.id];return this.knownFields[parentEl.parent?parentEl.parent.id:parentEl.id];}
return this.knownFields[f.id];});return unique(rootFromSearchResults);}
return this.fieldsAvailable.filter(({parent})=>!parent);}
filterSubfields(subfields){let subfieldsFromSearchResults=[];let searchResults;if(this.searchRef.el&&this.searchRef.el.value){searchResults=this.lookup(this.searchRef.el.value);}
const fieldsAvailable=Object.values(searchResults||this.knownFields);if(this.searchRef.el&&this.searchRef.el.value){subfieldsFromSearchResults=fieldsAvailable.filter((f)=>f.parent&&this.knownFields[f.parent.id].parent).map((f)=>f.parent);}
const availableSubFields=unique([...fieldsAvailable,...subfieldsFromSearchResults]);return subfields.filter((a)=>availableSubFields.some((b)=>a.id===b.id));}
updateSize(){this.state.isSmall=this.env.isSmall;}
async fetchFields(){this.state.search=[];this.knownFields={};this.expandedFields={};await this.loadFields();await this.setDefaultExportList();if(this.searchRef.el){this.searchRef.el.value="";}
if(this.state.templateId){this.loadExportList(this.state.templateId);}}
enterTemplateEdition(){if(this.state.templateId&&!this.state.isEditingTemplate){this.state.isEditingTemplate=true;}}
isFieldExpandable(id){return this.knownFields[id].children&&id.split("/").length<3;}
async loadExportList(value){this.state.templateId=value==="new_template"?value:Number(value);this.state.isEditingTemplate=value==="new_template";if(!value||value==="new_template"){return;}
const fields=await rpc("/web/export/namelist",{model:this.props.root.resModel,export_id:Number(value),});this.state.exportList=fields;}
async loadFields(id,preventLoad=false){let model=this.props.root.resModel;let parentField,parentParams;if(id){if(this.expandedFields[id]){return this.expandedFields[id].fields;}
parentField=this.knownFields[id];model=parentField.params&&parentField.params.model;parentParams={...parentField.params,parent_field_type:parentField.field_type,parent_field:parentField,parent_name:parentField.string,exclude:[parentField.relation_field],};}
if(preventLoad){return;}
const fields=await this.props.getExportedFields(model,this.state.isCompatible,parentParams);for(const field of fields){field.parent=parentField;if(!this.knownFields[field.id]){this.knownFields[field.id]=field;}}
if(id){this.expandedFields[id]={fields};}
return fields;}
onDraggingEnd(item,target){this.state.exportList.splice(target,0,this.state.exportList.splice(item,1)[0]);}
onAddItemExportList(fieldId){this.state.exportList.push(this.knownFields[fieldId]);this.enterTemplateEdition();}
onRemoveItemExportList(fieldId){const item=this.state.exportList.findIndex(({id})=>id===fieldId);this.state.exportList.splice(item,1);this.enterTemplateEdition();}
async onChangeExportList(ev){this.loadExportList(ev.target.value);}
async onSaveExportTemplate(){const name=this.exportListRef.el.value;if(!name){return this.notification.add(_t("Please enter save field list name"),{type:"danger",});}
const[id]=await this.orm.create("ir.exports",[{name,export_fields:this.state.exportList.map((field)=>[0,0,{name:field.id,},]),resource:this.props.root.resModel,},],{context:this.props.context});this.state.isEditingTemplate=false;this.state.templateId=id;this.templates.push({id,name});}
onCancelExportTemplate(){this.state.isEditingTemplate=false;if(this.state.templateId==="new_template"){this.state.templateId=null;return;}
this.loadExportList(this.state.templateId);}
async onClickExportButton(){if(!this.state.exportList.length){return this.notification.add(_t("Please select fields to save export list..."),{type:"danger",});}
this.state.disabled=true;await this.props.download(this.state.exportList,this.state.isCompatible,this.availableFormats[this.state.selectedFormat].tag);this.state.disabled=false;}
async onDeleteExportTemplate(){this.dialog.add(DeleteExportListDialog,{text:_t("Do you really want to delete this export template?"),delete:async()=>{const id=Number(this.state.templateId);await this.orm.unlink("ir.exports",[id],{context:this.props.context});this.templates.splice(this.templates.findIndex((i)=>i.id===id),1);this.state.templateId=null;this.setDefaultExportList();},});}
onSearch(ev){this.state.search=this.lookup(ev.target.value);}
lookup(value){let lookupResult=fuzzyLookup(value,Object.values(this.knownFields),(field)=>field.string.split("/").reverse().join("/"));if(this.isDebug){lookupResult=unique([...lookupResult,...Object.values(this.knownFields).filter((f)=>{return f.id.includes(value);}),]);}
return lookupResult;}
onToggleCompatibleExport(value){this.state.isCompatible=value;this.fetchFields();}
async setDefaultExportList(){this.state.exportList=Object.values(this.knownFields).filter((e)=>e.default_export||this.props.defaultExportList.find((i)=>i.name===e.id));}
setFormat(ev){if(ev.target.checked){this.state.selectedFormat=this.availableFormats.findIndex(({tag})=>tag===ev.target.value);}}}
return __exports;});;

/* /web/static/src/views/view_dialogs/form_view_dialog.js */
odoo.define('@web/views/view_dialogs/form_view_dialog',['@web/core/dialog/dialog','@web/core/utils/hooks','@web/search/action_hook','@web/views/view','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{useChildRef,useService}=require("@web/core/utils/hooks");const{CallbackRecorder}=require("@web/search/action_hook");const{View}=require("@web/views/view");const{Component,onMounted}=require("@odoo/owl");const FormViewDialog=__exports.FormViewDialog=class FormViewDialog extends Component{static template="web.FormViewDialog";static components={Dialog,View};static props={close:Function,resModel:String,context:{type:Object,optional:true},nextRecordsContext:{type:Object,optional:true},mode:{optional:true,validate:(m)=>["edit","readonly"].includes(m),},onRecordSaved:{type:Function,optional:true},onRecordDiscarded:{type:Function,optional:true},removeRecord:{type:Function,optional:true},resId:{type:[Number,Boolean],optional:true},title:{type:String,optional:true},viewId:{type:[Number,Boolean],optional:true},preventCreate:{type:Boolean,optional:true},preventEdit:{type:Boolean,optional:true},isToMany:{type:Boolean,optional:true},size:Dialog.props.size,};static defaultProps={onRecordSaved:()=>{},preventCreate:false,preventEdit:false,isToMany:false,};setup(){super.setup();this.actionService=useService("action");this.modalRef=useChildRef();this.env.dialogData.dismiss=()=>this.discardRecord();const buttonTemplate=this.props.isToMany?"web.FormViewDialog.ToMany.buttons":"web.FormViewDialog.ToOne.buttons";this.currentResId=this.props.resId;this.viewProps={type:"form",buttonTemplate,context:this.props.context||{},display:{controlPanel:false},mode:this.props.mode||"edit",resId:this.props.resId||false,resModel:this.props.resModel,viewId:this.props.viewId||false,preventCreate:this.props.preventCreate,preventEdit:this.props.preventEdit,discardRecord:this.discardRecord.bind(this),saveRecord:async(record,{saveAndNew})=>{const saved=await record.save({reload:false});if(saved){this.currentResId=record.resId;await this.props.onRecordSaved(record);if(saveAndNew){this.currentResId=false;const context=this.props.nextRecordsContext||this.props.context||{};await record.model.load({resId:false,context});}else{this.props.close();}}
return saved;},__beforeLeave__:new CallbackRecorder(),};if(this.props.removeRecord){this.viewProps.removeRecord=async()=>{await this.props.removeRecord();this.props.close();};}
onMounted(()=>{if(this.modalRef.el.querySelector(".modal-footer").childElementCount>1){const defaultButton=this.modalRef.el.querySelector(".modal-footer button.o-default-button");if(defaultButton){defaultButton.classList.add("d-none");}}});}
async discardRecord(){if(this.props.onRecordDiscarded){await this.props.onRecordDiscarded();}
this.props.close();}
async onExpand(){const beforeLeaveCallbacks=this.viewProps.__beforeLeave__.callbacks;const res=await Promise.all(beforeLeaveCallbacks.map((callback)=>callback()));if(!res.includes(false)){this.actionService.doAction({type:"ir.actions.act_window",res_model:this.props.resModel,res_id:this.currentResId,views:[[false,"form"]],});}}}
return __exports;});;

/* /web/static/src/views/view_dialogs/select_create_dialog.js */
odoo.define('@web/views/view_dialogs/select_create_dialog',['@web/core/dialog/dialog','@web/core/utils/hooks','@web/core/utils/render','@web/views/view','@web/views/view_dialogs/form_view_dialog','@odoo/owl','@web/core/registry'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{useService}=require("@web/core/utils/hooks");const{renderToMarkup}=require("@web/core/utils/render");const{View}=require("@web/views/view");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");const{Component,useState}=require("@odoo/owl");const{registry}=require("@web/core/registry");let _defaultNoContentHelp;function getDefaultNoContentHelp(){if(!_defaultNoContentHelp){_defaultNoContentHelp=renderToMarkup("web.SelectCreateDialog.DefaultNoContentHelp");}
return _defaultNoContentHelp;}
const SelectCreateDialog=__exports.SelectCreateDialog=class SelectCreateDialog extends Component{static components={Dialog,View};static template="web.SelectCreateDialog";static props={context:{type:Object,optional:true},domain:{type:Array,optional:true},dynamicFilters:{type:Array,optional:true},resModel:String,searchViewId:{type:[Number,{value:false}],optional:true},multiSelect:{type:Boolean,optional:true},onSelected:{type:Function,optional:true},close:{type:Function,optional:true},onCreateEdit:{type:Function,optional:true},title:{type:String,optional:true},noCreate:{type:Boolean,optional:true},onUnselect:{type:Function,optional:true},noContentHelp:{type:String,optional:true},};static defaultProps={dynamicFilters:[],multiSelect:true,searchViewId:false,domain:[],context:{},};setup(){this.viewService=useService("view");this.dialogService=useService("dialog");this.state=useState({resIds:[]});const noContentHelp=this.props.noContentHelp||getDefaultNoContentHelp();this.busy=false;this.baseViewProps={display:{searchPanel:false},editable:false,noBreadcrumbs:true,noContentHelp,showButtons:false,selectRecord:(resId)=>this.select([resId]),onSelectionChanged:(resIds)=>{this.state.resIds=resIds;},};}
get viewProps(){const type=this.env.isSmall?"kanban":"list";const props={loadIrFilters:true,...this.baseViewProps,context:this.props.context,domain:this.props.domain,dynamicFilters:this.props.dynamicFilters,resModel:this.props.resModel,searchViewId:this.props.searchViewId,type,};if(type==="list"){props.allowSelectors=this.props.multiSelect;}else if(type==="kanban"){props.forceGlobalClick=true;}
return props;}
async executeOnceAndClose(callback){if(!this.busy){this.busy=true;try{await callback();}catch(e){this.busy=false;throw e;}
this.props.close();}}
async select(resIds){if(this.props.onSelected){this.executeOnceAndClose(()=>this.props.onSelected(resIds));}}
async unselect(){if(this.props.onUnselect){this.executeOnceAndClose(()=>this.props.onUnselect());}}
get canUnselect(){return this.env.isSmall&&!!this.props.onUnselect;}
async createEditRecord(){if(this.props.onCreateEdit){await this.props.onCreateEdit();this.props.close();}else{this.dialogService.add(FormViewDialog,{context:this.props.context,resModel:this.props.resModel,onRecordSaved:(record)=>{this.props.onSelected([record.resId]);this.props.close();},});}}}
registry.category("dialogs").add("select_create",SelectCreateDialog);return __exports;});;

/* /web/static/src/views/view_hook.js */
odoo.define('@web/views/view_hook',['@web/core/registry','@web/core/utils/hooks','@web/core/browser/browser','@web/core/py_js/py','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{browser}=require("@web/core/browser/browser");const{evaluateExpr}=require("@web/core/py_js/py");const{useComponent,useEffect,xml}=require("@odoo/owl");__exports.useViewArch=useViewArch;function useViewArch(arch,params={}){const CATEGORY="__processed_archs__";arch=arch.trim();const processedRegistry=registry.category(CATEGORY);let processedArch;if(!processedRegistry.contains(arch)){processedArch={};processedRegistry.add(arch,processedArch);}else{processedArch=processedRegistry.get(arch);}
const{compile,extract}=params;if(!("template"in processedArch)&&compile){processedArch.template=xml`${compile(arch)}`;}
if(!("extracted"in processedArch)&&extract){processedArch.extracted=extract(arch);}
return processedArch;}
__exports.useActionLinks=useActionLinks;function useActionLinks({resModel,reload}){const component=useComponent();const keepLast=component.env.keepLast;const orm=useService("orm");const{doAction}=useService("action");async function handler(ev){ev.preventDefault();ev.stopPropagation();let target=ev.target;if(target.tagName!=="A"){target=target.closest("a");}
const data=target.dataset;if(data.method!==undefined&&data.model!==undefined){const options={};if(data.reloadOnClose){options.onClose=reload||(()=>component.render());}
const action=await keepLast.add(orm.call(data.model,data.method));if(action!==undefined){keepLast.add(Promise.resolve(doAction(action,options)));}}else if(target.getAttribute("name")){const options={};if(data.context){options.additionalContext=evaluateExpr(data.context);}
keepLast.add(doAction(target.getAttribute("name"),options));}else{let views;const resId=data.resid?parseInt(data.resid,10):null;if(data.views){views=evaluateExpr(data.views);}else{views=resId?[[false,"form"]]:[[false,"list"],[false,"form"],];}
const action={name:target.getAttribute("title")||target.textContent.trim(),type:"ir.actions.act_window",res_model:data.model||resModel,target:"current",views,domain:data.domain?evaluateExpr(data.domain):[],};if(resId){action.res_id=resId;}
const options={};if(data.context){options.additionalContext=evaluateExpr(data.context);}
keepLast.add(doAction(action,options));}}
return(ev)=>{const a=ev.target.closest(`a[type="action"]`);if(a&&ev.currentTarget.contains(a)){handler(ev);}};}
__exports.useBounceButton=useBounceButton;function useBounceButton(containerRef,shouldBounce){let timeout;const ui=useService("ui");useEffect((containerEl)=>{if(!containerEl){return;}
const handler=(ev)=>{const button=ui.activeElement.querySelector("[data-bounce-button]");if(button&&shouldBounce(ev.target)){button.classList.add("o_catch_attention");browser.clearTimeout(timeout);timeout=browser.setTimeout(()=>{button.classList.remove("o_catch_attention");},400);}};containerEl.addEventListener("click",handler);return()=>containerEl.removeEventListener("click",handler);},()=>[containerRef.el]);}
return __exports;});;

/* /web/static/src/views/view_service.js */
odoo.define('@web/views/view_service',['@web/core/network/rpc','@web/core/registry','@web/core/orm_service'],function(require){'use strict';let __exports={};const{rpcBus}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{UPDATE_METHODS}=require("@web/core/orm_service");const viewService=__exports.viewService={dependencies:["orm"],async:["loadViews"],start(env,{orm}){let cache={};function clearCache(){cache={};const processedArchs=registry.category("__processed_archs__");processedArchs.content={};processedArchs.trigger("UPDATE");}
env.bus.addEventListener("CLEAR-CACHES",clearCache);rpcBus.addEventListener("RPC:RESPONSE",(ev)=>{const{model,method}=ev.detail.data.params;if(["ir.ui.view","ir.filters"].includes(model)){if(UPDATE_METHODS.includes(method)){clearCache();}}});async function loadViews(params,options={}){const{context,resModel,views}=params;const loadViewsOptions={action_id:options.actionId||false,embedded_action_id:options.embeddedActionId||false,embedded_parent_res_id:options.embeddedParentResId||false,load_filters:options.loadIrFilters||false,toolbar:(!context?.disable_toolbar&&options.loadActionMenus)||false,};for(const key in options){if(!["actionId","embeddedActionId","embeddedParentResId","loadIrFilters","loadActionMenus",].includes(key)){loadViewsOptions[key]=options[key];}}
if(env.isSmall){loadViewsOptions.mobile=true;}
const filteredContext=Object.fromEntries(Object.entries(context||{}).filter(([k,v])=>k=="lang"||k.endsWith("_view_ref")));const key=JSON.stringify([resModel,views,filteredContext,loadViewsOptions]);if(!cache[key]){cache[key]=orm.call(resModel,"get_views",[],{context:filteredContext,views,options:loadViewsOptions,}).then((result)=>{const{models,views}=result;const viewDescriptions={fields:models[resModel].fields,relatedModels:models,views:{},};for(const viewType in views){const{arch,toolbar,id,filters,custom_view_id}=views[viewType];const viewDescription={arch,id,custom_view_id};if(toolbar){viewDescription.actionMenus=toolbar;}
if(filters){viewDescription.irFilters=filters;}
viewDescriptions.views[viewType]=viewDescription;}
return viewDescriptions;}).catch((error)=>{delete cache[key];return Promise.reject(error);});}
return cache[key];}
return{loadViews};},};registry.category("services").add("view",viewService);return __exports;});;

/* /web/static/src/views/widgets/attach_document/attach_document.js */
odoo.define('@web/views/widgets/attach_document/attach_document',['@web/core/file_input/file_input','@web/core/registry','@web/core/utils/hooks','@web/core/utils/files','@web/views/widgets/standard_widget_props','@odoo/owl'],function(require){'use strict';let __exports={};const{FileInput}=require("@web/core/file_input/file_input");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{checkFileSize}=require("@web/core/utils/files");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{Component}=require("@odoo/owl");const AttachDocumentWidget=__exports.AttachDocumentWidget=class AttachDocumentWidget extends Component{static template="web.AttachDocument";static components={FileInput,};static props={...standardWidgetProps,string:{type:String},action:{type:String,optional:true},highlight:{type:Boolean},};setup(){this.http=useService("http");this.notification=useService("notification");this.fileInput=document.createElement("input");this.fileInput.type="file";this.fileInput.accept="*";this.fileInput.multiple=true;this.fileInput.onchange=this.onInputChange.bind(this);}
async onInputChange(){const ufile=[...this.fileInput.files];for(const file of ufile){if(!checkFileSize(file.size,this.notification)){return null;}}
const fileData=await this.http.post("/web/binary/upload_attachment",{csrf_token:odoo.csrf_token,ufile:ufile,model:this.props.record.resModel,id:this.props.record.resId,},"text");const parsedFileData=JSON.parse(fileData);if(parsedFileData.error){throw new Error(parsedFileData.error);}
await this.onFileUploaded(parsedFileData);}
async triggerUpload(){if(await this.beforeOpen()){this.fileInput.click();}}
async onFileUploaded(files){const{action,record}=this.props;if(action){const{resId,resModel}=record;await this.env.services.orm.call(resModel,action,[resId],{attachment_ids:files.map((file)=>file.id),});await record.load();}}
beforeOpen(){return this.props.record.save();}}
const attachDocumentWidget=__exports.attachDocumentWidget={component:AttachDocumentWidget,extractProps:({attrs})=>{const{action,highlight,string}=attrs;return{action,highlight:!!highlight,string,};},};registry.category("view_widgets").add("attach_document",attachDocumentWidget);return __exports;});;

/* /web/static/src/views/widgets/documentation_link/documentation_link.js */
odoo.define('@web/views/widgets/documentation_link/documentation_link',['@web/session','@web/views/widgets/standard_widget_props','@odoo/owl','@web/core/registry'],function(require){'use strict';let __exports={};const{session}=require("@web/session");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{Component}=require("@odoo/owl");const{registry}=require("@web/core/registry");const LINK_REGEX=new RegExp("^https?://");const DocumentationLink=__exports.DocumentationLink=class DocumentationLink extends Component{static template="web.DocumentationLink";static props={...standardWidgetProps,record:{type:Object,optional:1},path:{type:String},label:{type:String,optional:1},icon:{type:String,optional:1},alertLink:{type:Boolean,optional:1},};get url(){if(LINK_REGEX.test(this.props.path)){return this.props.path;}else{const serverVersion=session.server_version_info.includes("final")?`${session.server_version_info[0]}.${session.server_version_info[1]}`.replace("~","-"):"master";return"https://www.odoo.com/documentation/"+serverVersion+this.props.path;}}
get classes(){let classes="o_doc_link me-2";if(this.props.alertLink){classes+=" alert-link";}
return classes;}}
const documentationLink=__exports.documentationLink={component:DocumentationLink,extractProps:({attrs})=>{const{path,label,icon,alert_link}=attrs;return{path,label,icon,alertLink:Boolean(alert_link),};},additionalClasses:["d-inline"],};registry.category("view_widgets").add("documentation_link",documentationLink);return __exports;});;

/* /web/static/src/views/widgets/notification_alert/notification_alert.js */
odoo.define('@web/views/widgets/notification_alert/notification_alert',['@web/core/browser/browser','@web/core/registry','@web/views/widgets/standard_widget_props','@odoo/owl'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{Component}=require("@odoo/owl");const NotificationAlert=__exports.NotificationAlert=class NotificationAlert extends Component{static props=standardWidgetProps;static template="web.NotificationAlert";get isNotificationBlocked(){return browser.Notification&&browser.Notification.permission==="denied";}}
const notificationAlert=__exports.notificationAlert={component:NotificationAlert,};registry.category("view_widgets").add("notification_alert",notificationAlert);return __exports;});;

/* /web/static/src/views/widgets/ribbon/ribbon.js */
odoo.define('@web/views/widgets/ribbon/ribbon',['@web/core/l10n/translation','@web/core/registry','@web/views/widgets/standard_widget_props','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{Component}=require("@odoo/owl");class RibbonWidget extends Component{static template="web.Ribbon";static props={...standardWidgetProps,text:{type:String},title:{type:String,optional:true},bgClass:{type:String,optional:true},};static defaultProps={title:"",bgClass:"text-bg-success",};get classes(){let classes=this.props.bgClass;if(this.props.text.length>15){classes+=" o_small";}else if(this.props.text.length>10){classes+=" o_medium";}
return classes;}}
const ribbonWidget=__exports.ribbonWidget={component:RibbonWidget,extractProps:({attrs})=>{return{text:attrs.title||attrs.text,title:attrs.tooltip,bgClass:attrs.bg_color,};},supportedAttributes:[{label:_t("Title"),name:"title",type:"string",},{label:_t("Background color"),name:"bg_color",type:"string",},{label:_t("Tooltip"),name:"tooltip",type:"string",},],};registry.category("view_widgets").add("web_ribbon",ribbonWidget);return __exports;});;

/* /web/static/src/views/widgets/signature/signature.js */
odoo.define('@web/views/widgets/signature/signature',['@web/core/registry','@web/core/signature/signature_dialog','@web/core/utils/hooks','@web/views/widgets/standard_widget_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{SignatureDialog}=require("@web/core/signature/signature_dialog");const{useService}=require("@web/core/utils/hooks");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{Component}=require("@odoo/owl");const SignatureWidget=__exports.SignatureWidget=class SignatureWidget extends Component{static template="web.SignatureWidget";static props={...standardWidgetProps,fullName:{type:String,optional:true},highlight:{type:Boolean,optional:true},string:{type:String},signatureField:{type:String,optional:true},};setup(){this.dialogService=useService("dialog");this.orm=useService("orm");}
onClickSignature(){const nameAndSignatureProps={mode:"draw",displaySignatureRatio:3,signatureType:"signature",noInputName:true,};const{fullName,record}=this.props;let defaultName="";if(fullName){let signName;const fullNameData=record.data[fullName];if(record.fields[fullName].type==="many2one"){signName=fullNameData&&fullNameData[1];}else{signName=fullNameData;}
defaultName=signName===""?undefined:signName;}
nameAndSignatureProps.defaultFont=this.props.defaultFont;const dialogProps={defaultName,nameAndSignatureProps,uploadSignature:(data)=>this.uploadSignature(data),};this.dialogService.add(SignatureDialog,dialogProps);}
async uploadSignature({signatureImage}){const file=signatureImage.split(",")[1];const{model,resModel,resId}=this.props.record;await this.env.services.orm.write(resModel,[resId],{[this.props.signatureField]:file,});await this.props.record.load();model.notify();}}
const signatureWidget=__exports.signatureWidget={component:SignatureWidget,extractProps:({attrs})=>{const{full_name:fullName,highlight,signature_field,string}=attrs;return{fullName,highlight:!!highlight,string,signatureField:signature_field||"signature",};},};registry.category("view_widgets").add("signature",signatureWidget);return __exports;});;

/* /web/static/src/views/widgets/standard_widget_props.js */
odoo.define('@web/views/widgets/standard_widget_props',[],function(require){'use strict';let __exports={};const standardWidgetProps=__exports.standardWidgetProps={readonly:{type:Boolean,optional:true},record:{type:Object},};return __exports;});;

/* /web/static/src/views/widgets/week_days/week_days.js */
odoo.define('@web/views/widgets/week_days/week_days',['@web/core/registry','@web/core/checkbox/checkbox','@web/core/l10n/localization','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{CheckBox}=require("@web/core/checkbox/checkbox");const{localization}=require("@web/core/l10n/localization");const{_t}=require("@web/core/l10n/translation");const{Component}=require("@odoo/owl");const WEEKDAYS=["sun","mon","tue","wed","thu","fri","sat"];const WeekDays=__exports.WeekDays=class WeekDays extends Component{static template="web.WeekDays";static components={CheckBox};static props={record:Object,readonly:Boolean,};get weekdays(){return[...WEEKDAYS.slice(localization.weekStart%WEEKDAYS.length,WEEKDAYS.length),...WEEKDAYS.slice(0,localization.weekStart%WEEKDAYS.length),];}
get data(){return Object.fromEntries(this.weekdays.map((day)=>[day,this.props.record.data[day]]));}
onChange(day,checked){this.props.record.update({[day]:checked});}}
const weekDays=__exports.weekDays={component:WeekDays,fieldDependencies:[{name:"sun",type:"boolean",string:_t("Sun"),readonly:false},{name:"mon",type:"boolean",string:_t("Mon"),readonly:false},{name:"tue",type:"boolean",string:_t("Tue"),readonly:false},{name:"wed",type:"boolean",string:_t("Wed"),readonly:false},{name:"thu",type:"boolean",string:_t("Thu"),readonly:false},{name:"fri",type:"boolean",string:_t("Fri"),readonly:false},{name:"sat",type:"boolean",string:_t("Sat"),readonly:false},],};registry.category("view_widgets").add("week_days",weekDays);return __exports;});;

/* /web/static/src/views/widgets/widget.js */
odoo.define('@web/views/widgets/widget',['@web/core/py_js/py','@web/core/registry','@odoo/owl'],function(require){'use strict';let __exports={};const{evaluateExpr,evaluateBooleanExpr}=require("@web/core/py_js/py");const{registry}=require("@web/core/registry");const{Component,xml}=require("@odoo/owl");const viewWidgetRegistry=registry.category("view_widgets");const supportedInfoValidation={type:Array,element:Object,shape:{label:String,name:String,type:String,availableTypes:{type:Array,element:String,optional:true},default:{type:String,optional:true},help:{type:String,optional:true},choices:{type:Array,element:Object,shape:{label:String,value:String},optional:true,},},optional:true,};viewWidgetRegistry.addValidation({component:{validate:(c)=>c.prototype instanceof Component},extractProps:{type:Function,optional:true},additionalClasses:{type:Array,element:String,optional:true},fieldDependencies:{type:[Function,{type:Array,element:Object,shape:{name:String,type:String}}],optional:true,},listViewWidth:{type:[Number,{type:Array,element:Number,validate:(array)=>array.length===1||array.length===2,},Function,],optional:true,},supportedAttributes:supportedInfoValidation,supportedOptions:supportedInfoValidation,});const Widget=__exports.Widget=class Widget extends Component{static template=xml`
        <div t-att-class="classNames" t-att-style="props.style">
            <t t-component="widget.component" t-props="widgetProps" />
        </div>`;static parseWidgetNode=function(node){const name=node.getAttribute("name");const widget=viewWidgetRegistry.get(name);const widgetInfo={name,widget,options:{},attrs:{},};for(const{name,value}of node.attributes){if(["name","widget"].includes(name)){continue;}
if(name==="options"){widgetInfo.options=evaluateExpr(value);}else if(!name.startsWith("t-att")){widgetInfo.attrs[name]=value;}}
return widgetInfo;};static props={"*":true,};setup(){if(this.props.widgetInfo){this.widget=this.props.widgetInfo.widget;}else{this.widget=viewWidgetRegistry.get(this.props.name);}}
get classNames(){const classNames={o_widget:true,[`o_widget_${this.props.name}`]:true,[this.props.className]:Boolean(this.props.className),};if(this.widget.additionalClasses){for(const cls of this.widget.additionalClasses){classNames[cls]=true;}}
return classNames;}
get widgetProps(){const record=this.props.record;let readonlyFromModifiers=false;let propsFromNode={};if(this.props.widgetInfo){const widgetInfo=this.props.widgetInfo;readonlyFromModifiers=evaluateBooleanExpr(widgetInfo.attrs.readonly,record.evalContextWithVirtualIds);const dynamicInfo={readonly:readonlyFromModifiers,};propsFromNode=this.widget.extractProps?this.widget.extractProps(widgetInfo,dynamicInfo):{};}
return{record,readonly:!record.isInEdition||readonlyFromModifiers||false,...propsFromNode,};}}
return __exports;});;

/* /web/static/src/webclient/actions/action_container.js */
odoo.define('@web/webclient/actions/action_container',['@web/webclient/actions/action_dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{ActionDialog}=require("@web/webclient/actions/action_dialog");const{Component,xml,onWillDestroy}=require("@odoo/owl");const ActionContainer=__exports.ActionContainer=class ActionContainer extends Component{static components={ActionDialog};static props={};static template=xml`
        <t t-name="web.ActionContainer">
          <div class="o_action_manager">
            <t t-if="info.Component" t-component="info.Component" className="'o_action'" t-props="info.componentProps" t-key="info.id"/>
          </div>
        </t>`;setup(){this.info={};this.onActionManagerUpdate=({detail:info})=>{this.info=info;this.render();};this.env.bus.addEventListener("ACTION_MANAGER:UPDATE",this.onActionManagerUpdate);onWillDestroy(()=>{this.env.bus.removeEventListener("ACTION_MANAGER:UPDATE",this.onActionManagerUpdate);});}}
return __exports;});;

/* /web/static/src/webclient/actions/action_dialog.js */
odoo.define('@web/webclient/actions/action_dialog',['@web/core/dialog/dialog','@web/core/debug/debug_menu','@web/core/debug/debug_context','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{DebugMenu}=require("@web/core/debug/debug_menu");const{useOwnDebugContext}=require("@web/core/debug/debug_context");const{useEffect}=require("@odoo/owl");const ActionDialog=__exports.ActionDialog=class ActionDialog extends Dialog{static components={...Dialog.components,DebugMenu};static template="web.ActionDialog";static props={...Dialog.props,close:Function,slots:{optional:true},ActionComponent:{optional:true},actionProps:{optional:true},actionType:{optional:true},title:{optional:true},};static defaultProps={...Dialog.defaultProps,withBodyPadding:false,};setup(){super.setup();useOwnDebugContext();useEffect(()=>{if(this.modalRef.el.querySelector(".modal-footer")?.childElementCount>1){const defaultButton=this.modalRef.el.querySelector(".modal-footer button.o-default-button");defaultButton.classList.add("d-none");}},()=>[]);}}
return __exports;});;

/* /web/static/src/webclient/actions/action_install_kiosk_pwa.js */
odoo.define('@web/webclient/actions/action_install_kiosk_pwa',['@web/core/registry','@web/core/utils/hooks','@web/webclient/actions/action_service','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");const{Component,onWillStart}=require("@odoo/owl");const InstallKiosk=__exports.InstallKiosk=class InstallKiosk extends Component{static template="web.ActionInstallKioskPWA";static props={...standardActionServiceProps};setup(){this.resModel=this.props.action.res_model;this.orm=useService("orm");this.dialog=useService("dialog");onWillStart(async()=>{this.url=await this.orm.call(this.resModel,"get_kiosk_url",[this.props.action.context.active_id,]);});}
get appId(){return this.props.action.context.app_id||this.resModel;}
get installURL(){return`/scoped_app?app_id=${this.appId}&path=${encodeURIComponent(
            this.url.replace(document.location.origin + "/", "")
        )}`;}}
registry.category("actions").add("install_kiosk_pwa",InstallKiosk);return __exports;});;

/* /web/static/src/webclient/actions/action_service.js */
odoo.define('@web/webclient/actions/action_service',['@web/core/l10n/translation','@web/core/browser/browser','@web/core/context','@web/core/debug/debug_context','@web/core/py_js/py','@web/core/network/rpc','@web/core/registry','@web/core/user','@web/core/utils/concurrency','@web/core/utils/hooks','@web/views/view','@web/webclient/actions/action_dialog','@web/webclient/actions/reports/report_action','@web/core/orm_service','@web/search/action_hook','@web/search/control_panel/control_panel','@web/core/browser/router','@odoo/owl','@web/webclient/actions/reports/utils','@web/core/utils/arrays','@web/core/utils/html','@web/core/utils/objects','@web/session','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{makeContext}=require("@web/core/context");const{useDebugCategory}=require("@web/core/debug/debug_context");const{evaluateExpr}=require("@web/core/py_js/py");const{rpc,rpcBus}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{Deferred,KeepLast}=require("@web/core/utils/concurrency");const{useBus,useService}=require("@web/core/utils/hooks");const{View,ViewNotFoundError}=require("@web/views/view");const{ActionDialog}=require("@web/webclient/actions/action_dialog");const{ReportAction}=require("@web/webclient/actions/reports/report_action");const{UPDATE_METHODS}=require("@web/core/orm_service");const{CallbackRecorder}=require("@web/search/action_hook");const{ControlPanel}=require("@web/search/control_panel/control_panel");const{PATH_KEYS,router:_router,stateToUrl}=require("@web/core/browser/router");const{Component,markup,onMounted,onWillUnmount,onError,useChildSubEnv,xml,reactive,status,}=require("@odoo/owl");const{downloadReport,getReportUrl}=require("@web/webclient/actions/reports/utils");const{zip}=require("@web/core/utils/arrays");const{isHtmlEmpty}=require("@web/core/utils/html");const{omit,pick,shallowEqual}=require("@web/core/utils/objects");const{session}=require("@web/session");const{exprToBoolean}=require("@web/core/utils/strings");class BlankComponent extends Component{static props=["onMounted","withControlPanel","*"];static template=xml`
        <ControlPanel display="{disableDropdown: true}" t-if="props.withControlPanel and !env.isSmall">
            <t t-set-slot="layout-buttons">
                <button class="btn btn-primary invisible"> empty </button>
            </t>
        </ControlPanel>`;static components={ControlPanel};setup(){useChildSubEnv({config:{breadcrumbs:[],noBreadcrumbs:true}});onMounted(()=>this.props.onMounted());}}
const actionHandlersRegistry=registry.category("action_handlers");const actionRegistry=registry.category("actions");__exports.clearUncommittedChanges=clearUncommittedChanges;async function clearUncommittedChanges(env){const callbacks=[];env.bus.trigger("CLEAR-UNCOMMITTED-CHANGES",callbacks);const res=await Promise.all(callbacks.map((fn)=>fn()));return!res.includes(false);}
const standardActionServiceProps=__exports.standardActionServiceProps={action:Object,actionId:{type:Number,optional:true},className:{type:String,optional:true},globalState:{type:Object,optional:true},state:{type:Object,optional:true},resId:{type:[Number,Boolean],optional:true},updateActionState:{type:Function,optional:true},};function parseActiveIds(ids){const activeIds=[];if(typeof ids==="string"){activeIds.push(...ids.split(",").map(Number));}else if(typeof ids==="number"){activeIds.push(ids);}
return activeIds;}
const DIALOG_SIZES={"extra-large":"xl",large:"lg",medium:"md",small:"sm",};const ControllerNotFoundError=__exports.ControllerNotFoundError=class ControllerNotFoundError extends Error{}
const InvalidButtonParamsError=__exports.InvalidButtonParamsError=class InvalidButtonParamsError extends Error{}
const CTX_KEY_REGEX=/^(?:(?:default_|search_default_|show_).+|.+_view_ref|group_by|active_id|active_ids|orderedBy)$/;const EMBEDDED_ACTIONS_CTX_KEYS=["current_embedded_action_id","parent_action_embedded_actions","parent_action_id","from_embedded_action",];const ControllerComponentTemplate=xml`<t t-component="Component" t-props="componentProps"/>`;__exports.makeActionManager=makeActionManager;function makeActionManager(env,router=_router){const breadcrumbCache={};const keepLast=new KeepLast();let id=0;let controllerStack=[];let dialogCloseProm;let actionCache={};let dialog=null;let nextDialog=null;router.hideKeyFromUrl("globalState");env.bus.addEventListener("CLEAR-CACHES",()=>{actionCache={};});rpcBus.addEventListener("RPC:RESPONSE",(ev)=>{const{model,method}=ev.detail.data.params;if(model==="ir.actions.act_window"&&UPDATE_METHODS.includes(method)){actionCache={};}});async function _controllersFromState(){const state=router.current;if(!state?.actionStack?.length){return[];}
const controllers=state.actionStack.slice(0,-1).map((actionState,index)=>{const controller=_makeController({displayName:actionState.displayName,virtual:true,action:{},props:{},state:{...actionState,actionStack:state.actionStack.slice(0,index+1)},currentState:{},});if(actionState.action){controller.action.id=actionState.action;const[actionRequestKey,clientAction]=actionRegistry.contains(actionState.action)?[actionState.action,actionRegistry.get(actionState.action)]:actionRegistry.getEntries().find((a)=>a[1].path===actionState.action)??[];if(actionRequestKey&&clientAction){if(state.actionStack[index+1]?.action===actionState.action){return;}
controller.action.tag=actionRequestKey;controller.action.type="ir.actions.client";controller.displayName=clientAction.displayName?.toString();}
if(actionState.active_id){controller.action.context={active_id:actionState.active_id};controller.currentState.active_id=actionState.active_id;}}
if(actionState.model){controller.action.type="ir.actions.act_window";controller.props.resModel=actionState.model;}
if(actionState.resId){controller.action.type||="ir.actions.act_window";controller.props.resId=actionState.resId;controller.currentState.resId=actionState.resId;controller.props.type="form";}
return controller;}).filter(Boolean);if(state.action&&state.resId&&controllers.at(-1)?.action?.id===state.action){const bcControllers=await _loadBreadcrumbs(controllers.slice(0,-1));controllers.at(-1).lazy=true;return[...bcControllers,controllers.at(-1)];}
return _loadBreadcrumbs(controllers);}
async function _loadBreadcrumbs(controllers){const toFetch=[];const keys=[];for(const{action,state,displayName}of controllers){if(action.id==="menu"||(action.type==="ir.actions.client"&&!displayName)){continue;}
const actionInfo=pick(state,"action","model","resId");const key=JSON.stringify(actionInfo);keys.push(key);if(displayName){breadcrumbCache[key]={display_name:displayName};}
if(key in breadcrumbCache){continue;}
toFetch.push(actionInfo);}
if(toFetch.length){const req=rpc("/web/action/load_breadcrumbs",{actions:toFetch});for(const[i,info]of toFetch.entries()){const key=JSON.stringify(info);breadcrumbCache[key]=req.then((res)=>{breadcrumbCache[key]=res[i];return res[i];});}}
const results=await Promise.all(keys.map((k)=>breadcrumbCache[k]));const controllersToRemove=[];for(const[controller,res]of zip(controllers,results)){if("display_name"in res){controller.displayName=res.display_name;}else{controllersToRemove.push(controller);if("error"in res){console.warn("The following element was removed from the breadcrumb and from the url.\n",controller.state,"\nThis could be because the action wasn't found or because the user doesn't have the right to access to the record, the original error is :\n",res.error);}}}
return controllers.filter((c)=>!controllersToRemove.includes(c));}
function _removeDialog(){if(dialog){const{onClose,remove}=dialog;dialog=null;remove();return onClose;}}
function _getCurrentController(){const stack=controllerStack;return stack.length?stack[stack.length-1]:null;}
async function _loadAction(actionRequest,context={}){if(typeof actionRequest==="string"&&actionRegistry.contains(actionRequest)){return{target:"current",tag:actionRequest,type:"ir.actions.client",};}
if(typeof actionRequest==="string"||typeof actionRequest==="number"){const ctx=makeContext([user.context,context]);delete ctx.params;const key=`${JSON.stringify(actionRequest)},${JSON.stringify(ctx)}`;let action=await actionCache[key];if(!action){actionCache[key]=rpc("/web/action/load",{action_id:actionRequest,context:ctx,});action=await actionCache[key];if(action.help){action.help=markup(action.help);}}
return Object.assign({},action);}
return actionRequest;}
function _makeController(params){return{...params,jsId:`controller_${++id}`,isMounted:false,};}
function _preprocessAction(action,context={}){try{action._originalAction=JSON.stringify(action);}catch{}
action.context=makeContext([context,action.context],user.context);const domain=action.domain||[];action.domain=typeof domain==="string"?evaluateExpr(domain,Object.assign({},user.context,action.context)):domain;if(action.help){if(isHtmlEmpty(action.help)){delete action.help;}}
action={...action};action.jsId=`action_${++id}`;if(action.type==="ir.actions.act_window"||action.type==="ir.actions.client"){action.target=action.target||"current";}
if(action.type==="ir.actions.act_window"){action.views=[...action.views.map((v)=>[v[0],v[1]])];action.controllers={};const target=action.target;if(target!=="inline"&&!(target==="new"&&action.views[0][1]==="form")){const searchViewId=action.search_view_id?action.search_view_id[0]:false;action.views.push([searchViewId,"search"]);}
if("no_breadcrumbs"in action.context){action._noBreadcrumbs=action.context.no_breadcrumbs;delete action.context.no_breadcrumbs;}}
return action;}
function _getView(viewType){const currentController=controllerStack[controllerStack.length-1];if(currentController.action.type!=="ir.actions.act_window"){throw new Error(`switchView called but the current controller isn't a view`);}
const view=currentController.views.find((view)=>view.type===viewType);return view||null;}
function _getBreadcrumbs(stack){return stack.filter((controller)=>controller.action.tag!=="menu").map((controller)=>{return{jsId:controller.jsId,get name(){return controller.displayName;},get isFormView(){return controller.props?.type==="form";},get url(){return stateToUrl(controller.state);},onSelected(){restore(controller.jsId);},};});}
function _getActionParams(state=router.current){const options={};let actionRequest=null;if(state.action){const context={};if(state.active_id){context.active_id=state.active_id;}
if(state.active_ids){context.active_ids=parseActiveIds(state.active_ids);}else if(state.active_id){context.active_ids=[state.active_id];}
const[actionRequestKey,clientAction]=actionRegistry.contains(state.action)?[state.action,actionRegistry.get(state.action)]:actionRegistry.getEntries().find((a)=>a[1].path===state.action)??[];if(actionRequestKey&&clientAction){actionRequest={context,params:state,tag:actionRequestKey,type:"ir.actions.client",};if(clientAction.path){actionRequest.path=clientAction.path;}}else{actionRequest=state.action;context.params=state;Object.assign(options,{additionalContext:context,viewType:state.resId?"form":state.view_type,});}
if((state.resId&&state.resId!=="new")||state.globalState){options.props={};if(state.resId&&state.resId!=="new"){options.props.resId=state.resId;}
if(state.globalState){options.props.globalState=state.globalState;}}}else if(state.model){if(state.resId||state.view_type==="form"){actionRequest={res_model:state.model,res_id:state.resId==="new"?undefined:state.resId,type:"ir.actions.act_window",views:[[state.view_id?state.view_id:false,"form"]],};}else{const storedAction=browser.sessionStorage.getItem("current_action");const lastAction=JSON.parse(storedAction||"{}");if(lastAction.help){lastAction.help=markup(lastAction.help);}
if(lastAction.res_model===state.model){if(lastAction.context){delete lastAction.context.allowed_company_ids;}
actionRequest=lastAction;options.viewType=state.view_type;}}}
if(!actionRequest){const{actionStack}=state;if(actionStack?.length>1){const nextState={actionStack:actionStack.slice(0,-1)};Object.assign(nextState,nextState.actionStack.at(-1));const params=_getActionParams(nextState);if(params.options&&params.options.index===undefined){params.options.index=nextState.actionStack.length-1;}
return params;}
actionRequest=user.homeActionId;}
return actionRequest?{actionRequest,options}:null;}
function _getActionInfo(action,props){const actionProps=Object.assign({},props,{action,actionId:action.id});const currentState={resId:actionProps.resId||false,active_id:action.context.active_id||false,};actionProps.updateActionState=(controller,patchState)=>{const oldState={...currentState};Object.assign(currentState,patchState);const changed=!shallowEqual(currentState,oldState);if(changed&&action.target!=="new"&&controller.isMounted){pushState();}};return{props:actionProps,currentState,config:{actionId:action.id,actionType:"ir.actions.client",actionFlags:action.flags,},displayName:action.display_name||action.name||"",};}
function _getActionMode(action){if(action.target==="new"){return"new";}
if(action.type==="ir.actions.client"){const clientAction=actionRegistry.get(action.tag);if(clientAction.target){return clientAction.target;}}
if(action.target==="fullscreen"){return"fullscreen";}
return"current";}
function _getViewInfo(view,action,views,props={}){const target=action.target;const viewSwitcherEntries=views.filter((v)=>v.multiRecord===view.multiRecord).map((v)=>{const viewSwitcherEntry={icon:v.icon,name:v.display_name,type:v.type,multiRecord:v.multiRecord,};if(view.type===v.type){viewSwitcherEntry.active=true;}
return viewSwitcherEntry;});const context=action.context||{};let groupBy=context.group_by||[];if(typeof groupBy==="string"){groupBy=[groupBy];}
const openFormView=(resId,{activeIds,mode,force}={})=>{if(target!=="new"){if(_getView("form")){return switchView("form",{mode,resId,resIds:activeIds});}else if(force||!resId){return doAction({type:"ir.actions.act_window",res_model:action.res_model,views:[[false,"form"]],},{props:{mode,resId,resIds:activeIds}});}}};const viewProps=Object.assign({},props,{context,display:{mode:target==="new"?"inDialog":target},domain:action.domain||[],groupBy,loadActionMenus:target!=="new"&&target!=="inline",loadIrFilters:action.views.some((v)=>v[1]==="search"),resModel:action.res_model,type:view.type,selectRecord:openFormView,createRecord:()=>openFormView(false),});if(view.type==="form"){if(target==="new"){viewProps.mode="edit";if(!viewProps.onSave){viewProps.onSave=(record,params)=>{if(params&&params.closable){doAction({type:"ir.actions.act_window_close"});}};}}
if(action.flags&&"mode"in action.flags){viewProps.mode=action.flags.mode;}}
if(target==="inline"){viewProps.searchMenuTypes=[];}
const specialKeys=["help","useSampleModel","limit","count"];for(const key of specialKeys){if(key in action){if(key==="help"){viewProps.noContentHelp=action.help;}else{viewProps[key]=action[key];}}}
if(context.search_disable_custom_filters){viewProps.activateFavorite=false;}
if(!viewProps.resId){viewProps.resId=action.res_id||false;}
const currentState={resId:viewProps.resId,active_id:action.context.active_id||false,};viewProps.updateActionState=(controller,patchState)=>{const oldState={...currentState};Object.assign(currentState,patchState);const changed=!shallowEqual(currentState,oldState);if(changed&&target!=="new"&&controller.isMounted){pushState();}};viewProps.noBreadcrumbs="_noBreadcrumbs"in action?action._noBreadcrumbs:target==="new";const embeddedActions=view.type==="form"?[]:context.parent_action_embedded_actions||action.embedded_action_ids;const parentActionId=(view.type!=="form"&&context.parent_action_id)||false;const currentEmbeddedActionId=context.current_embedded_action_id||false;return{props:viewProps,currentState,config:{actionId:action.id,actionName:action.name,actionType:"ir.actions.act_window",embeddedActions,parentActionId,currentEmbeddedActionId,actionFlags:action.flags,views:action.views,viewSwitcherEntries,},displayName:action.display_name||action.name||"",};}
function _computeStackIndex(options){if(options.clearBreadcrumbs){return 0;}else if(options.stackPosition==="replaceCurrentAction"){const currentController=controllerStack[controllerStack.length-1];if(currentController){return controllerStack.findIndex((ct)=>ct.action.jsId===currentController.action.jsId);}}else if(options.stackPosition==="replacePreviousAction"){let last;for(let i=controllerStack.length-1;i>=0;i--){const action=controllerStack[i].action.jsId;if(!last){last=action;}
if(action!==last){last=action;break;}}
if(last){return controllerStack.findIndex((ct)=>ct.action.jsId===last);}}else if(options.index!==undefined){return options.index;}
return controllerStack.length;}
async function _updateUI(controller,options={}){let resolve;let reject;let dialogCloseResolve;let removeDialogFn;const currentActionProm=new Promise((_res,_rej)=>{resolve=_res;reject=_rej;});const action=controller.action;if(action.target!=="new"&&"newStack"in options){controllerStack=options.newStack;}
const index=_computeStackIndex(options);const nextStack=[...controllerStack.slice(0,index),controller];controller.config.breadcrumbs=reactive(action.target==="new"?[]:_getBreadcrumbs(nextStack));controller.config.getDisplayName=()=>controller.displayName;controller.config.setDisplayName=(displayName)=>{controller.displayName=displayName;if(controller===_getCurrentController()){env.services.title.setParts({action:controller.displayName});}
if(action.target!=="new"){controller.config.breadcrumbs.push(undefined);controller.config.breadcrumbs.pop();}};controller.config.setCurrentEmbeddedAction=(embeddedActionId)=>{controller.currentEmbeddedActionId=embeddedActionId;};controller.config.setEmbeddedActions=(embeddedActions)=>{controller.embeddedActions=embeddedActions;};controller.config.historyBack=()=>{if(dialog){_executeCloseAction();}else{const previousController=controllerStack[controllerStack.length-2];if(previousController){restore(previousController.jsId);}else{env.bus.trigger("WEBCLIENT:LOAD_DEFAULT_APP");}}};class ControllerComponent extends Component{static template=ControllerComponentTemplate;static Component=controller.Component;static props={"*":true,};setup(){this.Component=controller.Component;this.titleService=useService("title");useDebugCategory("action",{action});useChildSubEnv({config:controller.config,pushStateBeforeReload:()=>{if(controller.isMounted){return;}
pushState(nextStack);},});if(action.target!=="new"){this.__beforeLeave__=new CallbackRecorder();this.__getGlobalState__=new CallbackRecorder();this.__getLocalState__=new CallbackRecorder();useBus(env.bus,"CLEAR-UNCOMMITTED-CHANGES",(ev)=>{const callbacks=ev.detail;const beforeLeaveFns=this.__beforeLeave__.callbacks;callbacks.push(...beforeLeaveFns);});if(this.constructor.Component!==View){useChildSubEnv({__beforeLeave__:this.__beforeLeave__,__getGlobalState__:this.__getGlobalState__,__getLocalState__:this.__getLocalState__,});}}
onMounted(this.onMounted);onWillUnmount(this.onWillUnmount);onError(this.onError);}
onError(error){if(controller.isMounted){Promise.reject(error);return;}
if(!controller.isMounted&&status(this)==="mounted"){env.bus.trigger("ACTION_MANAGER:UPDATE",{id:++id,Component:BlankComponent,componentProps:{onMounted:()=>{},withControlPanel:action.type==="ir.actions.act_window",},});Promise.reject(error);return;}
reject(error);if(action.target==="new"){removeDialogFn?.();return;}
const index=controllerStack.findIndex((ct)=>ct.jsId===controller.jsId);if(index>0){return restore(controllerStack[index-1].jsId);}
if(index===0){return;}
const lastController=controllerStack.at(-1);if(lastController){if(lastController.jsId!==controller.jsId){return restore(lastController.jsId);}}else{env.bus.trigger("ACTION_MANAGER:UPDATE",{});}}
onMounted(){if(action.target==="new"){dialogCloseProm=new Promise((_r)=>{dialogCloseResolve=_r;}).then(()=>{dialogCloseProm=undefined;});dialog=nextDialog;}else{controller.getGlobalState=()=>{const exportFns=this.__getGlobalState__.callbacks;if(exportFns.length){return Object.assign({},...exportFns.map((fn)=>fn()));}};controller.getLocalState=()=>{const exportFns=this.__getLocalState__.callbacks;if(exportFns.length){return Object.assign({},...exportFns.map((fn)=>fn()));}};controllerStack=nextStack;pushState();this.titleService.setParts({action:controller.displayName});browser.sessionStorage.setItem("current_action",action._originalAction||"{}");}
resolve();env.bus.trigger("ACTION_MANAGER:UI-UPDATED",_getActionMode(action));controller.isMounted=true;}
onWillUnmount(){controller.isMounted=false;if(action.target==="new"&&dialogCloseResolve){dialogCloseResolve();}}
get componentProps(){const componentProps={...this.props};const updateActionState=componentProps.updateActionState;componentProps.updateActionState=(newState)=>updateActionState(controller,newState);if(this.constructor.Component===View){componentProps.__beforeLeave__=this.__beforeLeave__;componentProps.__getGlobalState__=this.__getGlobalState__;componentProps.__getLocalState__=this.__getLocalState__;}
return componentProps;}}
if(action.target==="new"){const actionDialogProps={ActionComponent:ControllerComponent,actionProps:controller.props,actionType:action.type,};if(action.name){actionDialogProps.title=action.name;}
const size=DIALOG_SIZES[action.context.dialog_size];if(size){actionDialogProps.size=size;}
actionDialogProps.footer=action.context.footer??actionDialogProps.footer;const onClose=_removeDialog();removeDialogFn=env.services.dialog.add(ActionDialog,actionDialogProps,{onClose:()=>{const onClose=_removeDialog();if(onClose){onClose();}},});if(nextDialog){nextDialog.remove();}
nextDialog={remove:removeDialogFn,onClose:onClose||options.onClose,};return currentActionProm;}
const currentController=_getCurrentController();if(currentController&&currentController.getLocalState){currentController.exportedState=currentController.getLocalState();}
if(controller.exportedState){controller.props.state=controller.exportedState;}
if(currentController&&currentController.getGlobalState){const globalState=Object.assign({},currentController.action.globalState,currentController.getGlobalState());currentController.action.globalState=globalState;if(currentController.state.action===router.current.action&&currentController.state.active_id===router.current.active_id&&currentController.state.resId===router.current.resId){router.pushState({globalState},{sync:true});}}
if(controller.action.globalState){controller.props.globalState=controller.action.globalState;}
const closingProm=_executeCloseAction({onCloseInfo:{noReload:true}});if(options.clearBreadcrumbs&&!options.noEmptyTransition){const def=new Deferred();env.bus.trigger("ACTION_MANAGER:UPDATE",{id:++id,Component:BlankComponent,componentProps:{onMounted:()=>def.resolve(),withControlPanel:action.type==="ir.actions.act_window",},});await def;}
if(options.onActionReady){options.onActionReady(action);}
controller.__info__={id:++id,Component:ControllerComponent,componentProps:controller.props,};env.services.dialog.closeAll();env.bus.trigger("ACTION_MANAGER:UPDATE",controller.__info__);return Promise.all([currentActionProm,closingProm]).then((r)=>r[0]);}
function _executeActURLAction(action,options){let url=action.url;if(url&&!(url.startsWith("http")||url.startsWith("/"))){url="/"+url;}
if(action.target==="download"||action.target==="self"){browser.location.assign(url);}else{const w=browser.open(url,"_blank");if(!w||w.closed||typeof w.closed==="undefined"){const msg=_t("A popup window has been blocked. You may need to change your "+"browser settings to allow popup windows for this page.");env.services.notification.add(msg,{sticky:true,type:"warning",});}
if(action.close){return doAction({type:"ir.actions.act_window_close"},{onClose:options.onClose});}else if(options.onClose){options.onClose();}}}
async function _executeActWindowAction(action,options){const views=[];const unknown=[];for(const[,type]of action.views){if(type==="search"){continue;}
if(session.view_info[type]){const{icon,display_name,multi_record:multiRecord}=session.view_info[type];views.push({icon,display_name,multiRecord,type});}else{unknown.push(type);}}
if(unknown.length){throw new Error(`View types not defined ${unknown.join(", ")} found in act_window action ${
                    action.id
                }`);}
if(!views.length){throw new Error(`No view found for act_window action ${action.id}`);}
let view=(options.viewType&&views.find((v)=>v.type===options.viewType))||views[0];if(env.isSmall){view=_findView(views,view.multiRecord,action.mobile_view_mode)||view;}
const controller=_makeController({Component:View,action,view,views,..._getViewInfo(view,action,views,options.props),});action.controllers[view.type]=controller;const newStackLastController=options.newStack?.at(-1);if(newStackLastController?.lazy){const multiView=action.views.find((view)=>view[1]!=="form"&&view[1]!=="search");if(multiView){delete newStackLastController.lazy;newStackLastController.displayName=action.display_name||action.name||"";newStackLastController.action=action;newStackLastController.props.type=multiView[1];}else{options.newStack.splice(-1);}}
return _updateUI(controller,options);}
function _findView(views,multiRecord,viewType){return views.find((v)=>v.type===viewType&&v.multiRecord==multiRecord);}
async function _executeClientAction(action,options){const clientAction=actionRegistry.get(action.tag);action.path||=clientAction.path;if(clientAction.prototype instanceof Component){if(action.target!=="new"){const canProceed=await clearUncommittedChanges(env);if(!canProceed){return;}
if(clientAction.target){action.target=clientAction.target;}}
const controller=_makeController({Component:clientAction,action,..._getActionInfo(action,options.props),});controller.displayName||=clientAction.displayName?.toString()||"";return _updateUI(controller,options);}else{const next=await clientAction(env,action);if(next){return doAction(next,options);}}}
function _executeReportClientAction(action,options){const props=Object.assign({},options.props,{data:action.data,display_name:action.display_name,name:action.name,report_file:action.report_file,report_name:action.report_name,report_url:getReportUrl(action,"html",user.context),context:Object.assign({},action.context),});const controller=_makeController({Component:ReportAction,action,..._getActionInfo(action,props),});return _updateUI(controller,options);}
async function _executeReportAction(action,options){const handlers=registry.category("ir.actions.report handlers").getAll();for(const handler of handlers){const result=await handler(action,options,env);if(result){return result;}}
if(action.report_type==="qweb-html"){return _executeReportClientAction(action,options);}else if(action.report_type==="qweb-pdf"||action.report_type==="qweb-text"){const type=action.report_type.slice(5);let success,message;env.services.ui.block();try{const downloadContext={...user.context};if(action.context){Object.assign(downloadContext,action.context);}
({success,message}=await downloadReport(rpc,action,type,downloadContext));}finally{env.services.ui.unblock();}
if(message){env.services.notification.add(message,{sticky:true,title:_t("Report"),});}
if(!success){return _executeReportClientAction(action,options);}
const{onClose}=options;if(action.close_on_report_download){return doAction({type:"ir.actions.act_window_close"},{onClose});}else if(onClose){onClose();}}else{console.error(`The ActionManager can't handle reports of type ${action.report_type}`,action);}}
async function _executeServerAction(action,options){const runProm=rpc("/web/action/run",{action_id:action.id,context:makeContext([user.context,action.context]),});let nextAction=await keepLast.add(runProm);if(nextAction.help){nextAction.help=markup(nextAction.help);}
nextAction=nextAction||{type:"ir.actions.act_window_close"};if(typeof nextAction==="object"){nextAction.path||=action.path;}
return doAction(nextAction,options);}
async function _executeCloseAction(params={}){let onClose;if(dialog){onClose=_removeDialog();}else{onClose=params.onClose;}
if(onClose){await onClose(params.onCloseInfo);}
return dialogCloseProm;}
async function doAction(actionRequest,options={}){const actionProm=_loadAction(actionRequest,options.additionalContext);let action=await keepLast.add(actionProm);action=_preprocessAction(action,options.additionalContext);options.clearBreadcrumbs=action.target==="main"||options.clearBreadcrumbs;switch(action.type){case"ir.actions.act_url":return _executeActURLAction(action,options);case"ir.actions.act_window":if(action.target!=="new"){const canProceed=await clearUncommittedChanges(env);if(!canProceed){return new Promise(()=>{});}}
return _executeActWindowAction(action,options);case"ir.actions.act_window_close":return _executeCloseAction({onClose:options.onClose,onCloseInfo:action.infos});case"ir.actions.client":return _executeClientAction(action,options);case"ir.actions.server":return _executeServerAction(action,options);case"ir.actions.report":return _executeReportAction(action,options);default:{const handler=actionHandlersRegistry.get(action.type,null);if(handler!==null){return handler({env,action,options});}
throw new Error(`The ActionManager service can't handle actions of type ${action.type}`);}}}
async function doActionButton(params,{isEmbeddedAction}={}){let action;if(!isEmbeddedAction){for(const key of EMBEDDED_ACTIONS_CTX_KEYS){delete params.context?.[key];}}
const context=makeContext([params.context,params.buttonContext]);const blockUi=exprToBoolean(params["block-ui"]);if(blockUi){env.services.ui.block();}
if(params.special){action={type:"ir.actions.act_window_close",infos:{special:true}};}else if(params.type==="object"){let args=params.resId?[[params.resId]]:[params.resIds];if(params.args){let additionalArgs;try{additionalArgs=JSON.parse(params.args.replace(/'/g,'"'));}catch{browser.console.error("Could not JSON.parse arguments",params.args);}
args=args.concat(additionalArgs);}
const callProm=rpc(`/web/dataset/call_button/${params.resModel}/${params.name}`,{args,kwargs:{context},method:params.name,model:params.resModel,});action=await keepLast.add(callProm);action=action&&typeof action==="object"?action:{type:"ir.actions.act_window_close"};if(action.help){action.help=markup(action.help);}}else if(params.type==="action"){context.active_id=params.resId||null;context.active_ids=params.resIds;context.active_model=params.resModel;action=await keepLast.add(_loadAction(params.name,context));}else{if(blockUi){env.services.ui.unblock();}
throw new InvalidButtonParamsError("Missing type for doActionButton request");}
if(!isEmbeddedAction&&action.embedded_action_ids?.length){const embeddedActionsOrder=JSON.parse(browser.localStorage.getItem(`orderEmbedded${action.id}+${params.resId || ""}+${user.userId}`));const embeddedActionId=embeddedActionsOrder?.[0];const embeddedAction=action.embedded_action_ids?.find((embeddedAction)=>embeddedAction.id===embeddedActionId);if(embeddedAction){const embeddedActions=[...action.embedded_action_ids,{id:false,name:action.name,parent_action_id:action.id,parent_res_model:action.res_model,action_id:action.id,user_id:false,context:{},},];const context={...action.context,...(embeddedAction.context?makeContext([embeddedAction.context]):{}),active_id:params.resId,active_model:params.resModel,current_embedded_action_id:embeddedActionId,parent_action_embedded_actions:embeddedActions,parent_action_id:action.id,};await this.doActionButton({name:embeddedAction.python_method||embeddedAction.action_id[0]||embeddedAction.action_id,resId:params.resId,context,type:embeddedAction.python_method?"object":"action",resModel:embeddedAction.parent_res_model,viewType:embeddedAction.default_view_mode,},{isEmbeddedAction:true});return;}}
const currentCtx={};for(const key in params.context){if(key.match(CTX_KEY_REGEX)===null){currentCtx[key]=params.context[key];}}
const activeCtx={active_model:params.resModel};if(params.resId){activeCtx.active_id=params.resId;activeCtx.active_ids=[params.resId];}
action.context=makeContext([currentCtx,params.buttonContext,activeCtx,action.context]);const effect=params.effect?evaluateExpr(params.effect):action.effect;const{onClose,stackPosition,viewType}=params;const options={onClose,stackPosition,viewType};await doAction(action,options);if(params.close){await _executeCloseAction();}
if(blockUi){env.services.ui.unblock();}
if(effect){env.services.effect.add(effect);}}
async function switchView(viewType,props={}){await keepLast.add(Promise.resolve());if(dialog){return;}
const controller=controllerStack[controllerStack.length-1];const view=_getView(viewType);if(!view){throw new ViewNotFoundError(_t("No view of type '%s' could be found in the current action.",viewType));}
const newController=controller.action.controllers[viewType]||_makeController({Component:View,action:controller.action,views:controller.views,view,});const canProceed=await clearUncommittedChanges(env);if(!canProceed){return;}
Object.assign(newController,_getViewInfo(view,controller.action,controller.views,props));controller.action.controllers[viewType]=newController;let index;if(view.multiRecord){index=controllerStack.findIndex((ct)=>ct.action.jsId===controller.action.jsId);index=index>-1?index:controllerStack.length-1;}else{index=controllerStack.findIndex((ct)=>ct.action.jsId===controller.action.jsId&&!ct.view.multiRecord);index=index>-1?index:controllerStack.length;}
return _updateUI(newController,{index});}
async function restore(jsId){await keepLast.add(Promise.resolve());let index;if(!jsId){index=controllerStack.length-2;}else{index=controllerStack.findIndex((controller)=>controller.jsId===jsId);}
if(index<0){const msg=jsId?"Invalid controller to restore":"No controller to restore";throw new ControllerNotFoundError(msg);}
const canProceed=await clearUncommittedChanges(env);if(!canProceed){return;}
const controller=controllerStack[index];if(controller.virtual){const actionParams=_getActionParams(controller.state);if(!actionParams){throw new Error("Attempted to restore a virtual controller whose state is invalid");}
const{actionRequest,options}=actionParams;controllerStack=controllerStack.slice(0,index);return doAction(actionRequest,options);}
if(controller.action.type==="ir.actions.act_window"){if(controller.isMounted){controller.exportedState=controller.getLocalState();}
const{action,exportedState,view,views}=controller;const props={...controller.props};if(exportedState&&"resId"in exportedState){props.resId=exportedState.resId;}
Object.assign(controller,_getViewInfo(view,action,views,props));}
return _updateUI(controller,{index});}
async function loadState(){const newStack=await _controllersFromState();const actionParams=_getActionParams();if(actionParams){const{actionRequest,options}=actionParams;if(options.index){options.newStack=newStack.slice(0,options.index);delete options.index;}else{options.newStack=newStack;}
await doAction(actionRequest,options);return true;}}
function pushState(cStack=controllerStack){if(!cStack.length){return;}
const actions=cStack.map((controller)=>{const{action,props,displayName}=controller;const actionState={displayName};if(action.path||action.id){actionState.action=action.path||action.id;}else if(action.type==="ir.actions.client"){actionState.action=action.tag;}else if(action.type==="ir.actions.act_window"){actionState.model=props.resModel;}
if(action.type==="ir.actions.act_window"){actionState.view_type=props.type;if(props.type==="form"&&action.res_model!=="res.config.settings"){actionState.resId=controller.currentState.resId||"new";}}
if(action.type==="ir.actions.client"&&controller.currentState?.resId){actionState.resId=controller.currentState.resId;}
if(controller.currentState?.active_id){const activeId=controller.currentState.active_id;if(activeId){actionState.active_id=activeId;}}
Object.assign(actionState,omit(controller.currentState||{},...PATH_KEYS));return actionState;});const newState={actionStack:actions,};const stateKeys=[...PATH_KEYS];const{action,props,currentState}=cStack.at(-1);if(props.type!=="form"&&props.type!==action.views?.[0][1]){stateKeys.push("view_type");}
if(currentState){stateKeys.push(...Object.keys(omit(currentState,...PATH_KEYS)));}
Object.assign(newState,pick(newState.actionStack.at(-1),...stateKeys));cStack.at(-1).state=newState;router.pushState(newState,{replace:true});}
return{doAction,doActionButton,switchView,restore,loadState,async loadAction(actionRequest,context){const action=await _loadAction(actionRequest,context);return _preprocessAction(action,context);},get currentController(){return _getCurrentController();},};}
const actionService=__exports.actionService={dependencies:["dialog","effect","localization","notification","title","ui"],start(env){return makeActionManager(env);},};registry.category("services").add("action",actionService);return __exports;});;

/* /web/static/src/webclient/actions/client_actions.js */
odoo.define('@web/webclient/actions/client_actions',['@web/core/browser/browser','@web/core/browser/router','@web/core/network/rpc','@web/core/registry','@web/core/utils/strings','@odoo/owl'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{router}=require("@web/core/browser/router");const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{escape,sprintf}=require("@web/core/utils/strings");const{markup}=require("@odoo/owl");__exports.displayNotificationAction=displayNotificationAction;function displayNotificationAction(env,action){const params=action.params||{};const options={className:params.className||"",sticky:params.sticky||false,title:params.title,type:params.type||"info",};const links=(params.links||[]).map((link)=>{return`<a href="${escape(link.url)}" target="_blank">${escape(link.label)}</a>`;});const message=markup(sprintf(escape(params.message),...links));env.services.notification.add(message,options);return params.next;}
registry.category("actions").add("display_notification",displayNotificationAction);function reload(env,action){const{menu_id,action_id}=action.params||{};let route={...router.current};if(menu_id||action_id){route={};if(menu_id){route.menu_id=menu_id;}
if(action_id){route.action=action_id;}}
env.bus.trigger("CLEAR-CACHES");router.pushState(route,{replace:true,reload:true});}
registry.category("actions").add("reload",reload);async function home(){await new Promise((resolve)=>{const waitForServer=(delay)=>{browser.setTimeout(async()=>{rpc("/web/webclient/version_info",{}).then(resolve).catch(()=>waitForServer(250));},delay);};waitForServer(1000);});const url="/"+(browser.location.search||"");browser.location.assign(url);}
registry.category("actions").add("home",home);async function reloadContext(env,action){await rpc("/web/session/get_session_info");reload(env,action);}
registry.category("actions").add("reload_context",reloadContext);async function softReload(env,action){const controller=env.services.action.currentController;if(controller){await env.services.action.restore(controller.jsId);}}
registry.category("actions").add("soft_reload",softReload);return __exports;});;

/* /web/static/src/webclient/actions/debug_items.js */
odoo.define('@web/webclient/actions/debug_items',['@web/core/l10n/translation','@web/core/debug/debug_utils','@web/core/registry'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{editModelDebug}=require("@web/core/debug/debug_utils");const{registry}=require("@web/core/registry");const debugRegistry=registry.category("debug");function editAction({action,env}){if(!action.id){return null;}
const description=_t("Action");return{type:"item",description,callback:()=>{editModelDebug(env,description,action.type,action.id);},sequence:220,section:"ui",};}
function viewFields({action,env}){if(!action.res_model){return null;}
const description=_t("Fields");return{type:"item",description,callback:async()=>{const modelId=(await env.services.orm.search("ir.model",[["model","=",action.res_model]],{limit:1,}))[0];env.services.action.doAction({res_model:"ir.model.fields",name:description,views:[[false,"list"],[false,"form"],],domain:[["model_id","=",modelId]],type:"ir.actions.act_window",context:{default_model_id:modelId,},});},sequence:250,section:"ui",};}
function ViewModel({action,env}){if(!action.res_model){return null;}
const modelName=action.res_model;return{type:"item",description:_t("Model: %s",modelName),callback:async()=>{const modelId=(await env.services.orm.search("ir.model",[["model","=",modelName]],{limit:1,}))[0];editModelDebug(env,modelName,"ir.model",modelId);},sequence:210,section:"ui",};}
function manageFilters({action,env}){if(!action.res_model){return null;}
const description=_t("Filters");return{type:"item",description,callback:()=>{env.services.action.doAction({res_model:"ir.filters",name:description,views:[[false,"list"],[false,"form"],],type:"ir.actions.act_window",context:{search_default_my_filters:true,search_default_model_id:action.res_model,},});},sequence:260,section:"ui",};}
function viewAccessRights({accessRights,action,env}){if(!action.res_model||!accessRights.canSeeModelAccess){return null;}
const description=_t("Access Rights");return{type:"item",description,callback:async()=>{const modelId=(await env.services.orm.search("ir.model",[["model","=",action.res_model]],{limit:1,}))[0];env.services.action.doAction({res_model:"ir.model.access",name:description,views:[[false,"list"],[false,"form"],],domain:[["model_id","=",modelId]],type:"ir.actions.act_window",context:{default_model_id:modelId,},});},sequence:350,section:"security",};}
function viewRecordRules({accessRights,action,env}){if(!action.res_model||!accessRights.canSeeRecordRules){return null;}
const description=_t("Model Record Rules");return{type:"item",description:_t("Record Rules"),callback:async()=>{const modelId=(await env.services.orm.search("ir.model",[["model","=",action.res_model]],{limit:1,}))[0];env.services.action.doAction({res_model:"ir.rule",name:description,views:[[false,"list"],[false,"form"],],domain:[["model_id","=",modelId]],type:"ir.actions.act_window",context:{default_model_id:modelId,},});},sequence:360,section:"security",};}
debugRegistry.category("action").add("editAction",editAction).add("viewFields",viewFields).add("ViewModel",ViewModel).add("manageFilters",manageFilters).add("viewAccessRights",viewAccessRights).add("viewRecordRules",viewRecordRules);return __exports;});;

/* /web/static/src/webclient/burger_menu/burger_menu.js */
odoo.define('@web/webclient/burger_menu/burger_menu',['@web/core/registry','@web/core/transition','@web/core/user','@web/core/utils/hooks','@web/webclient/burger_menu/burger_user_menu/burger_user_menu','@web/webclient/burger_menu/mobile_switch_company_menu/mobile_switch_company_menu','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Transition}=require("@web/core/transition");const{user}=require("@web/core/user");const{useBus,useService}=require("@web/core/utils/hooks");const{BurgerUserMenu}=require("@web/webclient/burger_menu/burger_user_menu/burger_user_menu");const{MobileSwitchCompanyMenu}=require("@web/webclient/burger_menu/mobile_switch_company_menu/mobile_switch_company_menu");const{Component,useState}=require("@odoo/owl");const SWIPE_ACTIVATION_THRESHOLD=100;const BurgerMenu=__exports.BurgerMenu=class BurgerMenu extends Component{static template="web.BurgerMenu";static props={};static components={BurgerUserMenu,MobileSwitchCompanyMenu,Transition,};setup(){this.company=useService("company");this.user=user;this.state=useState({isBurgerOpened:false,});this.swipeStartX=null;useBus(this.env.bus,"HOME-MENU:TOGGLED",()=>{this._closeBurger();});useBus(this.env.bus,"ACTION_MANAGER:UPDATE",({detail:req})=>{if(req.id){this._closeBurger();}});}
_closeBurger(){this.state.isBurgerOpened=false;}
_openBurger(){this.state.isBurgerOpened=true;}
_onSwipeStart(ev){this.swipeStartX=ev.changedTouches[0].clientX;}
_onSwipeEnd(ev){if(!this.swipeStartX){return;}
const deltaX=ev.changedTouches[0].clientX-this.swipeStartX;if(deltaX<SWIPE_ACTIVATION_THRESHOLD){return;}
this._closeBurger();this.swipeStartX=null;}}
const systrayItem={Component:BurgerMenu,};registry.category("systray").add("burger_menu",systrayItem,{sequence:0});return __exports;});;

/* /web/static/src/webclient/burger_menu/burger_user_menu/burger_user_menu.js */
odoo.define('@web/webclient/burger_menu/burger_user_menu/burger_user_menu',['@web/webclient/user_menu/user_menu'],function(require){'use strict';let __exports={};const{UserMenu}=require("@web/webclient/user_menu/user_menu");const BurgerUserMenu=__exports.BurgerUserMenu=class BurgerUserMenu extends UserMenu{static template="web.BurgerUserMenu";_onItemClicked(callback){callback();}}
return __exports;});;

/* /web/static/src/webclient/burger_menu/mobile_switch_company_menu/mobile_switch_company_menu.js */
odoo.define('@web/webclient/burger_menu/mobile_switch_company_menu/mobile_switch_company_menu',['@web/webclient/switch_company_menu/switch_company_menu'],function(require){'use strict';let __exports={};const{SwitchCompanyMenu}=require("@web/webclient/switch_company_menu/switch_company_menu");const MobileSwitchCompanyMenu=__exports.MobileSwitchCompanyMenu=class MobileSwitchCompanyMenu extends SwitchCompanyMenu{static template="web.MobileSwitchCompanyMenu";setup(){super.setup();this.state.isOpen=false;}
get show(){return!this.hasLotsOfCompanies||this.state.isOpen===true;}
toggleCollapsible(){if(this.hasLotsOfCompanies){this.state.isOpen=!this.state.isOpen;}}}
return __exports;});;

/* /web/static/src/webclient/clickbot/clickbot_loader.js */
odoo.define('@web/webclient/clickbot/clickbot_loader',['@web/core/l10n/translation','@web/core/assets','@web/core/registry','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{loadBundle}=require("@web/core/assets");const{registry}=require("@web/core/registry");const{browser}=require("@web/core/browser/browser");__exports.startClickEverywhere=startClickEverywhere;async function startClickEverywhere(xmlId,light,currentState){await loadBundle("web.assets_clickbot");window.clickEverywhere(xmlId,light,currentState);}
__exports.runClickTestItem=runClickTestItem;function runClickTestItem({env}){return{type:"item",description:_t("Run Click Everywhere"),callback:()=>{startClickEverywhere();},sequence:460,section:"testing",};}
const currentState=JSON.parse(browser.localStorage.getItem("running.clickbot"));if(currentState){startClickEverywhere(currentState.xmlId,currentState.light,currentState);}
__exports[Symbol.for("default")]={startClickEverywhere,runClickTestItem,};registry.category("debug").category("default").add("runClickTestItem",runClickTestItem);return __exports;});;

/* /web/static/src/webclient/company_service.js */
odoo.define('@web/webclient/company_service',['@web/core/browser/browser','@web/core/network/rpc','@web/core/registry','@web/session','@web/core/orm_service','@web/core/browser/cookie','@web/core/user','@web/core/browser/router'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{rpcBus}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{session}=require("@web/session");const{UPDATE_METHODS}=require("@web/core/orm_service");const{cookie}=require("@web/core/browser/cookie");const{user}=require("@web/core/user");const{router}=require("@web/core/browser/router");const CIDS_SEPARATOR="-";function parseCompanyIds(cids,separator=CIDS_SEPARATOR){if(typeof cids==="string"){return cids.split(separator).map(Number);}else if(typeof cids==="number"){return[cids];}
return[];}
function computeActiveCompanyIds(cids){const{user_companies}=session;let activeCompanyIds=cids||[];const availableCompaniesFromSession=user_companies.allowed_companies;const notAllowedCompanies=activeCompanyIds.filter((id)=>!(id in availableCompaniesFromSession));if(!activeCompanyIds.length||notAllowedCompanies.length){activeCompanyIds=[user_companies.current_company];}
return activeCompanyIds;}
function getCompanyIds(){let cids;const state=router.current;if("cids"in state){if(typeof state.cids==="string"&&!state.cids.includes(CIDS_SEPARATOR)){cids=parseCompanyIds(state.cids,",");}else{cids=parseCompanyIds(state.cids);}}else if(cookie.get("cids")){cids=parseCompanyIds(cookie.get("cids"));}
return cids||[];}
const companyService=__exports.companyService={dependencies:["action","orm"],start(env,{action,orm}){const allowedCompanies=session.user_companies.allowed_companies;const disallowedAncestorCompanies=session.user_companies.disallowed_ancestor_companies;const allowedCompaniesWithAncestors={...allowedCompanies,...disallowedAncestorCompanies,};const activeCompanyIds=computeActiveCompanyIds(getCompanyIds());cookie.set("cids",activeCompanyIds.join(CIDS_SEPARATOR));user.updateContext({allowed_company_ids:activeCompanyIds});rpcBus.addEventListener("RPC:RESPONSE",(ev)=>{const{data,error}=ev.detail;const{model,method}=data.params;if(!error&&model==="res.company"&&UPDATE_METHODS.includes(method)){if(!browser.localStorage.getItem("running_tour")){action.doAction("reload_context");}}});return{allowedCompanies,allowedCompaniesWithAncestors,disallowedAncestorCompanies,get activeCompanyIds(){return activeCompanyIds.slice();},get currentCompany(){return allowedCompanies[activeCompanyIds[0]];},getCompany(companyId){return allowedCompaniesWithAncestors[companyId];},async setCompanies(companyIds,includeChildCompanies=true){const newCompanyIds=companyIds.length?companyIds:[activeCompanyIds[0]];function addCompanies(companyIds){for(const companyId of companyIds){if(!newCompanyIds.includes(companyId)){newCompanyIds.push(companyId);addCompanies(allowedCompanies[companyId].child_ids);}}}
if(includeChildCompanies){addCompanies(companyIds.flatMap((companyId)=>allowedCompanies[companyId].child_ids));}
cookie.set("cids",newCompanyIds.join(CIDS_SEPARATOR));user.updateContext({allowed_company_ids:newCompanyIds});const controller=action.currentController;const state={};const options={reload:true};if(controller?.props.resId&&controller?.props.resModel){const hasReadRights=await user.checkAccessRight(controller.props.resModel,"read",controller.props.resId);if(!hasReadRights){options.replace=true;state.actionStack=router.current.actionStack.slice(0,-1);}}
router.pushState(state,options);},};},};registry.category("services").add("company",companyService);return __exports;});;

/* /web/static/src/webclient/currency_service.js */
odoo.define('@web/webclient/currency_service',['@web/core/network/rpc','@web/core/registry','@web/core/currency','@web/core/orm_service'],function(require){'use strict';let __exports={};const{rpc,rpcBus}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{currencies}=require("@web/core/currency");const{UPDATE_METHODS}=require("@web/core/orm_service");const currencyService=__exports.currencyService={start(){async function reloadCurrencies(){const result=await rpc("/web/session/get_session_info");for(const k in currencies){delete currencies[k];}
Object.assign(currencies,result?.currencies);}
rpcBus.addEventListener("RPC:RESPONSE",(ev)=>{const{data,error}=ev.detail;const{model,method}=data.params;if(!error&&model==="res.currency"&&UPDATE_METHODS.includes(method)){reloadCurrencies();}});},};registry.category("services").add("currency",currencyService);return __exports;});;

/* /web/static/src/webclient/debug/debug_items.js */
odoo.define('@web/webclient/debug/debug_items',['@web/core/browser/browser','@web/core/l10n/translation','@web/core/registry','@web/views/view_dialogs/select_create_dialog'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{SelectCreateDialog}=require("@web/views/view_dialogs/select_create_dialog");function runUnitTestsItem(){const href="/web/tests?debug=assets";return{type:"item",description:_t("Run Unit Tests"),href,callback:()=>browser.open(href),sequence:450,section:"testing",};}
__exports.openViewItem=openViewItem;function openViewItem({env}){async function onSelected(records){const views=await env.services.orm.searchRead("ir.ui.view",[["id","=",records[0]]],["name","model","type"],{limit:1});const view=views[0];env.services.action.doAction({type:"ir.actions.act_window",name:view.name,res_model:view.model,views:[[view.id,view.type]],});}
return{type:"item",description:_t("Open View"),callback:()=>{env.services.dialog.add(SelectCreateDialog,{resModel:"ir.ui.view",title:_t("Select a view"),multiSelect:false,domain:[["type","!=","qweb"],["type","!=","search"],],onSelected,});},sequence:540,section:"tools",};}
registry.category("debug").category("default").add("runUnitTestsItem",runUnitTestsItem).add("openViewItem",openViewItem);return __exports;});;

/* /web/static/src/webclient/debug/profiling/profiling_item.js */
odoo.define('@web/webclient/debug/profiling/profiling_item',['@web/core/dropdown/dropdown_item','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{useBus,useService}=require("@web/core/utils/hooks");const{Component,EventBus}=require("@odoo/owl");const ProfilingItem=__exports.ProfilingItem=class ProfilingItem extends Component{static components={DropdownItem};static template="web.DebugMenu.ProfilingItem";static props={bus:{type:EventBus},};setup(){this.profiling=useService("profiling");useBus(this.props.bus,"UPDATE",this.render);}
changeParam(param,ev){this.profiling.setParam(param,ev.target.value);}
toggleParam(param){const value=this.profiling.state.params.execution_context_qweb;this.profiling.setParam(param,!value);}
openProfiles(){if(this.env.services.action){this.env.services.action.doAction("base.action_menu_ir_profile");}else{window.location="/web/#action=base.action_menu_ir_profile";}}}
return __exports;});;

/* /web/static/src/webclient/debug/profiling/profiling_qweb.js */
odoo.define('@web/webclient/debug/profiling/profiling_qweb',['@web/core/registry','@web/core/utils/hooks','@web/core/assets','@web/core/utils/render','@web/core/utils/timing','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{loadBundle}=require("@web/core/assets");const{renderToString}=require("@web/core/utils/render");const{useDebounced}=require("@web/core/utils/timing");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component,useState,useRef,onWillStart,onMounted,onWillUnmount}=require("@odoo/owl");class MenuItem extends Component{static template="web.ProfilingQwebView.menuitem";static props={view:Object,};}
function processValue(value){const data=JSON.parse(value);for(const line of data[0].results.data){line.xpath=line.xpath.replace(/([^\]])\//g,"$1[1]/").replace(/([^\]])$/g,"$1[1]");}
return data;}
const ProfilingQwebView=__exports.ProfilingQwebView=class ProfilingQwebView extends Component{static template="web.ProfilingQwebView";static components={MenuItem};static props={...standardFieldProps};setup(){super.setup();this.orm=useService("orm");this.ace=useRef("ace");this.selector=useRef("selector");this.value=processValue(this.props.record.data[this.props.name]);this.state=useState({viewID:this.profile.data.length?this.profile.data[0].view_id:0,view:null,});this.renderProfilingInformation=useDebounced(this.renderProfilingInformation,100);onWillStart(async()=>{await loadBundle("web.ace_lib");await this._fetchViewData();this.state.view=this.viewObjects.find((view)=>view.id===this.state.viewID);});onMounted(()=>{this._startAce(this.ace.el);this._renderView();});onWillUnmount(()=>{if(this.aceEditor){this.aceEditor.destroy();}
this._unmoutInfo();});}
get profile(){return this.value?this.value[0].results:{archs:{},data:[]};}
async _fetchViewData(){const viewIDs=Array.from(new Set(this.profile.data.map((line)=>line.view_id)));const viewObjects=await this.orm.call("ir.ui.view","search_read",[],{fields:["id","display_name","key"],domain:[["id","in",viewIDs]],});for(const view of viewObjects){view.delay=0;view.query=0;const lines=this.profile.data.filter((l)=>l.view_id===view.id);const root=lines.find((l)=>l.xpath==="");if(root){view.delay+=root.delay;view.query+=root.query;}else{view.delay=lines.map((l)=>l.delay).reduce((a,b)=>a+b);view.query=lines.map((l)=>l.query).reduce((a,b)=>a+b);}
view.delay=Math.ceil(view.delay*10)/10;}
this.viewObjects=viewObjects;}
_formatDelay(delay){return delay?(Math.ceil(delay*10)/10).toFixed(1):".";}
_startAce(node){this.aceEditor=window.ace.edit(node);this.aceEditor.setOptions({maxLines:Infinity,showPrintMargin:false,highlightActiveLine:false,highlightGutterLine:true,readOnly:true,});this.aceEditor.renderer.setOptions({displayIndentGuides:true,showGutter:true,});this.aceEditor.renderer.$cursorLayer.element.style.display="none";this.aceEditor.$blockScrolling=true;this.aceSession=this.aceEditor.getSession();this.aceSession.setOptions({useWorker:false,mode:"ace/mode/qweb",tabSize:2,useSoftTabs:true,});this.aceEditor.renderer.on("afterRender",this.renderProfilingInformation.bind(this));}
renderProfilingInformation(){this._unmoutInfo();const flat={};const arch=[{xpath:"",children:[]}];const rows=this.ace.el.querySelectorAll(".ace_gutter .ace_gutter-cell");const elems=this.ace.el.querySelectorAll(".ace_tag-open, .ace_end-tag-close, .ace_end-tag-open, .ace_qweb");elems.forEach((node)=>{const parent=arch[arch.length-1];let xpath=parent.xpath;if(node.classList.contains("ace_end-tag-close")){let previous=node;while((previous=previous.previousElementSibling)){if(previous&&previous.classList.contains("ace_tag-name")){break;}}
const tag=previous&&previous.textContent;if(parent.tag===tag){arch.pop();}}else if(node.classList.contains("ace_end-tag-open")){const tag=node.nextElementSibling&&node.nextElementSibling.textContent;if(parent.tag===tag){arch.pop();}}else if(node.classList.contains("ace_qweb")){const directive=node.textContent;parent.directive.push({el:node,directive:directive,});let delay=0;let query=0;for(const line of this.profile.data){if(line.view_id===this.state.viewID&&line.xpath===xpath&&line.directive.includes(directive)){delay+=line.delay;query+=line.query;}}
if((delay||query)&&!node.querySelector(".o_info")){this._renderHover(delay,query,node);}}else if(node.classList.contains("ace_tag-open")){const nodeTagName=node.nextElementSibling;const aceLine=nodeTagName.parentNode;const index=[].indexOf.call(aceLine.parentNode.children,aceLine);const row=rows[index];xpath+="/"+nodeTagName.textContent;let i=1;while(flat[xpath+"["+i+"]"]){i++;}
xpath+="["+i+"]";flat[xpath]={xpath:xpath,tag:nodeTagName.textContent,children:[],directive:[],};arch.push(flat[xpath]);parent.children.push(flat[xpath]);const closed=!!row.querySelector(".ace_closed");const delays=[];const querys=[];const groups={};let displayDetail=false;for(const line of this.profile.data){if(line.view_id===this.state.viewID&&(closed?line.xpath.startsWith(xpath):line.xpath===xpath)){delays.push(line.delay);querys.push(line.query);const directive=line.directive.split("=")[0];if(!groups[directive]){groups[directive]={delays:[],querys:[],};}else{displayDetail=true;}
groups[directive].delays.push(this._formatDelay(line.delay));groups[directive].querys.push(line.query);}}
if(delays.length&&!row.querySelector(".o_info")){this._renderInfo(delays,querys,displayDetail,groups,row);}}
node.setAttribute("data-xpath",xpath);});}
_renderView(){const view=this.viewObjects.find((view)=>view.id===this.state.viewID);if(view){const arch=this.profile.archs[view.id]||"";if(this.aceSession.getValue()!==arch){this.aceSession.setValue(arch);}}else{this.aceSession.setValue("");}
this.state.view=view;}
_unmoutInfo(){if(this.hover){if(this.ace.el.querySelector(".o_ace_hover")){this.ace.el.querySelector(".o_ace_hover").remove();}}
if(this.info){if(this.ace.el.querySelector(".o_ace_info")){this.ace.el.querySelector(".o_ace_info").remove();}}}
_renderHover(delay,query,node){const xml=renderToString("web.ProfilingQwebView.hover",{delay:this._formatDelay(delay),query:query,});const div=new DOMParser().parseFromString(xml,"text/html").querySelector("div");node.appendChild(div);}
_renderInfo(delays,querys,displayDetail,groups,node){const xml=renderToString("web.ProfilingQwebView.info",{delay:this._formatDelay(delays.reduce((a,b)=>a+b,0)),query:querys.reduce((a,b)=>a+b,0)||".",displayDetail:displayDetail,groups:groups,});const div=new DOMParser().parseFromString(xml,"text/html").querySelector("div");node.appendChild(div);}
_onSelectView(ev){this.state.viewID=+ev.currentTarget.dataset.id;this._renderView();}}
const profilingQwebView=__exports.profilingQwebView={component:ProfilingQwebView,};registry.category("fields").add("profiling_qweb_view",profilingQwebView);return __exports;});;

/* /web/static/src/webclient/debug/profiling/profiling_service.js */
odoo.define('@web/webclient/debug/profiling/profiling_service',['@web/core/registry','@web/webclient/debug/profiling/profiling_item','@web/session','@web/webclient/debug/profiling/profiling_systray_item','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{ProfilingItem}=require("@web/webclient/debug/profiling/profiling_item");const{session}=require("@web/session");const{profilingSystrayItem}=require("@web/webclient/debug/profiling/profiling_systray_item");const{EventBus,reactive}=require("@odoo/owl");const systrayRegistry=registry.category("systray");const profilingService=__exports.profilingService={dependencies:["orm"],start(env,{orm}){if(!env.debug){return;}
function notify(){if(systrayRegistry.contains("web.profiling")&&state.isEnabled===false){systrayRegistry.remove("web.profiling");}
if(!systrayRegistry.contains("web.profiling")&&state.isEnabled===true){systrayRegistry.add("web.profiling",profilingSystrayItem,{sequence:99});}
bus.trigger("UPDATE");}
const state=reactive({session:session.profile_session||false,collectors:session.profile_collectors||["sql","traces_async"],params:session.profile_params||{},get isEnabled(){return Boolean(state.session);},},notify);const bus=new EventBus();notify();async function setProfiling(params){const kwargs=Object.assign({collectors:state.collectors,params:state.params,profile:state.isEnabled,},params);const resp=await orm.call("ir.profile","set_profiling",[],kwargs);if(resp.type){env.services.action.doAction(resp);}else{state.session=resp.session;state.collectors=resp.collectors;state.params=resp.params;}}
function profilingItem(){return{type:"component",Component:ProfilingItem,props:{bus},sequence:570,section:"tools",};}
registry.category("debug").category("default").add("profilingItem",profilingItem);return{state,async toggleProfiling(){await setProfiling({profile:!state.isEnabled});},async toggleCollector(collector){const nextCollectors=state.collectors.slice();const index=nextCollectors.indexOf(collector);if(index>=0){nextCollectors.splice(index,1);}else{nextCollectors.push(collector);}
await setProfiling({collectors:nextCollectors});},async setParam(key,value){const nextParams=Object.assign({},state.params);nextParams[key]=value;await setProfiling({params:nextParams});},isCollectorEnabled(collector){return state.collectors.includes(collector);},};},};registry.category("services").add("profiling",profilingService);return __exports;});;

/* /web/static/src/webclient/debug/profiling/profiling_systray_item.js */
odoo.define('@web/webclient/debug/profiling/profiling_systray_item',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");class ProfilingSystrayItem extends Component{static template="web.ProfilingSystrayItem";static props={};}
const profilingSystrayItem=__exports.profilingSystrayItem={Component:ProfilingSystrayItem,};return __exports;});;

/* /web/static/src/webclient/loading_indicator/loading_indicator.js */
odoo.define('@web/webclient/loading_indicator/loading_indicator',['@web/core/browser/browser','@web/core/network/rpc','@web/core/registry','@web/core/utils/hooks','@web/core/transition','@odoo/owl'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{rpcBus}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{useBus}=require("@web/core/utils/hooks");const{Transition}=require("@web/core/transition");const{Component,useState}=require("@odoo/owl");const LoadingIndicator=__exports.LoadingIndicator=class LoadingIndicator extends Component{static template="web.LoadingIndicator";static components={Transition};static props={};setup(){this.state=useState({count:0,show:false,});this.rpcIds=new Set();this.startShowTimer=null;useBus(rpcBus,"RPC:REQUEST",this.requestCall);useBus(rpcBus,"RPC:RESPONSE",this.responseCall);}
requestCall({detail}){if(detail.settings.silent){return;}
if(this.state.count===0){browser.clearTimeout(this.startShowTimer);this.startShowTimer=browser.setTimeout(()=>{if(this.state.count){this.state.show=true;}},250);}
this.rpcIds.add(detail.data.id);this.state.count++;}
responseCall({detail}){if(detail.settings.silent){return;}
this.rpcIds.delete(detail.data.id);this.state.count=this.rpcIds.size;if(this.state.count===0){browser.clearTimeout(this.startShowTimer);this.state.show=false;}}}
registry.category("main_components").add("LoadingIndicator",{Component:LoadingIndicator,});return __exports;});;

/* /web/static/src/webclient/menus/menu_helpers.js */
odoo.define('@web/webclient/menus/menu_helpers',[],function(require){'use strict';let __exports={};function traverseMenuTree(tree,cb,parents=[]){cb(tree,parents);tree.childrenTree.forEach((c)=>traverseMenuTree(c,cb,parents.concat([tree])));}
__exports.computeAppsAndMenuItems=computeAppsAndMenuItems;function computeAppsAndMenuItems(menuTree){const apps=[];const menuItems=[];traverseMenuTree(menuTree,(menuItem,parents)=>{if(!menuItem.id||!menuItem.actionID){return;}
const isApp=menuItem.id===menuItem.appID;const item={parents:parents.slice(1).map((p)=>p.name).join(" / "),label:menuItem.name,id:menuItem.id,xmlid:menuItem.xmlid,actionID:menuItem.actionID,href:`/odoo/${menuItem.actionPath || "action-" + menuItem.actionID}`,appID:menuItem.appID,};if(isApp){if(menuItem.webIconData){item.webIconData=menuItem.webIconData;}else{const[iconClass,color,backgroundColor]=(menuItem.webIcon||"").split(",");if(backgroundColor!==undefined){item.webIcon={iconClass,color,backgroundColor};}else{item.webIconData="/web/static/img/default_icon_app.png";}}}else{item.menuID=parents[1].id;}
if(isApp){apps.push(item);}else{menuItems.push(item);}});return{apps,menuItems};}
__exports.reorderApps=reorderApps;function reorderApps(apps,order){apps.sort((a,b)=>{const aIndex=order.indexOf(a.xmlid);const bIndex=order.indexOf(b.xmlid);if(aIndex===-1&&bIndex===-1){return apps.indexOf(a)-apps.indexOf(b);}
if(aIndex===-1){return-1;}
if(bIndex===-1){return 1;}
return aIndex-bIndex;});}
return __exports;});;

/* /web/static/src/webclient/menus/menu_providers.js */
odoo.define('@web/webclient/menus/menu_providers',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/search','@web/webclient/menus/menu_helpers','@web/core/commands/command_palette','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{fuzzyLookup}=require("@web/core/utils/search");const{computeAppsAndMenuItems}=require("@web/webclient/menus/menu_helpers");const{DefaultCommandItem}=require("@web/core/commands/command_palette");const{Component}=require("@odoo/owl");class AppIconCommand extends Component{static template="web.AppIconCommand";static props={webIconData:{type:String,optional:true},webIcon:{type:Object,optional:true},...DefaultCommandItem.props,};}
const commandCategoryRegistry=registry.category("command_categories");commandCategoryRegistry.add("apps",{namespace:"/"},{sequence:10});commandCategoryRegistry.add("menu_items",{namespace:"/"},{sequence:20});const commandSetupRegistry=registry.category("command_setup");commandSetupRegistry.add("/",{emptyMessage:_t("No menu found"),name:_t("menus"),placeholder:_t("Search for a menu..."),});const commandProviderRegistry=registry.category("command_provider");commandProviderRegistry.add("menu",{namespace:"/",async provide(env,options){const result=[];const menuService=env.services.menu;let{apps,menuItems}=computeAppsAndMenuItems(menuService.getMenuAsTree("root"));if(options.searchValue!==""){apps=fuzzyLookup(options.searchValue,apps,(menu)=>menu.label);fuzzyLookup(options.searchValue,menuItems,(menu)=>(menu.parents+" / "+menu.label).split("/").reverse().join("/")).forEach((menu)=>{result.push({action(){menuService.selectMenu(menu);},category:"menu_items",name:menu.parents+" / "+menu.label,href:menu.href||`#menu_id=${menu.id}&amp;action_id=${menu.actionID}`,});});}
apps.forEach((menu)=>{const props={};if(menu.webIconData){const prefix=menu.webIconData.startsWith("P")?"data:image/svg+xml;base64,":"data:image/png;base64,";props.webIconData=menu.webIconData.startsWith("data:image")?menu.webIconData:prefix+menu.webIconData.replace(/\s/g,"");}else{props.webIcon=menu.webIcon;}
result.push({Component:AppIconCommand,action(){menuService.selectMenu(menu);},category:"apps",name:menu.label,href:menu.href||`#menu_id=${menu.id}&amp;action_id=${menu.actionID}`,props,});});return result;},});return __exports;});;

/* /web/static/src/webclient/menus/menu_service.js */
odoo.define('@web/webclient/menus/menu_service',['@web/core/browser/browser','@web/core/registry','@web/session'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{session}=require("@web/session");const loadMenusUrl=`/web/webclient/load_menus`;function makeFetchLoadMenus(){const cacheHashes=session.cache_hashes;let loadMenusHash=cacheHashes.load_menus||new Date().getTime().toString();return async function fetchLoadMenus(reload){if(reload){loadMenusHash=new Date().getTime().toString();}else if(odoo.loadMenusPromise){return odoo.loadMenusPromise;}
const res=await browser.fetch(`${loadMenusUrl}/${loadMenusHash}`);if(!res.ok){throw new Error("Error while fetching menus");}
return res.json();};}
function makeMenus(env,menusData,fetchLoadMenus){let currentAppId;function _getMenu(menuId){return menusData[menuId];}
function setCurrentMenu(menu){menu=typeof menu==="number"?_getMenu(menu):menu;if(menu&&menu.appID!==currentAppId){currentAppId=menu.appID;browser.sessionStorage.setItem("menu_id",currentAppId);env.bus.trigger("MENUS:APP-CHANGED");}}
return{getAll(){return Object.values(menusData);},getApps(){return this.getMenu("root").children.map((mid)=>this.getMenu(mid));},getMenu:_getMenu,getCurrentApp(){if(!currentAppId){return;}
return this.getMenu(currentAppId);},getMenuAsTree(menuID){const menu=this.getMenu(menuID);if(!menu.childrenTree){menu.childrenTree=menu.children.map((mid)=>this.getMenuAsTree(mid));}
return menu;},async selectMenu(menu){menu=typeof menu==="number"?this.getMenu(menu):menu;if(!menu.actionID){return;}
await env.services.action.doAction(menu.actionID,{clearBreadcrumbs:true,onActionReady:()=>{setCurrentMenu(menu);},});},setCurrentMenu,async reload(){if(fetchLoadMenus){menusData=await fetchLoadMenus(true);env.bus.trigger("MENUS:APP-CHANGED");}},};}
const menuService=__exports.menuService={dependencies:["action"],async start(env){const fetchLoadMenus=makeFetchLoadMenus();const menusData=await fetchLoadMenus();return makeMenus(env,menusData,fetchLoadMenus);},};registry.category("services").add("menu",menuService);return __exports;});;

/* /web/static/src/webclient/navbar/navbar.js */
odoo.define('@web/webclient/navbar/navbar',['@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/dropdown/dropdown_group','@web/core/transition','@web/core/utils/hooks','@web/core/registry','@web/core/utils/timing','@web/core/utils/components','@odoo/owl'],function(require){'use strict';let __exports={};const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{DropdownGroup}=require("@web/core/dropdown/dropdown_group");const{Transition}=require("@web/core/transition");const{useService}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const{debounce}=require("@web/core/utils/timing");const{ErrorHandler}=require("@web/core/utils/components");const{Component,onWillDestroy,useExternalListener,useEffect,useRef,useState,onWillUnmount,}=require("@odoo/owl");const systrayRegistry=registry.category("systray");const getBoundingClientRect=Element.prototype.getBoundingClientRect;const SWIPE_ACTIVATION_THRESHOLD=100;const MenuDropdown=__exports.MenuDropdown=class MenuDropdown extends Dropdown{}
const NavBar=__exports.NavBar=class NavBar extends Component{static template="web.NavBar";static components={Dropdown,DropdownItem,DropdownGroup,MenuDropdown,ErrorHandler,Transition};static props={};setup(){this.currentAppSectionsExtra=[];this.actionService=useService("action");this.menuService=useService("menu");this.pwa=useService("pwa");this.root=useRef("root");this.appSubMenus=useRef("appSubMenus");const debouncedAdapt=debounce(this.adapt.bind(this),250);onWillDestroy(()=>debouncedAdapt.cancel());useExternalListener(window,"resize",debouncedAdapt);let adaptCounter=0;const renderAndAdapt=()=>{adaptCounter++;this.render();};systrayRegistry.addEventListener("UPDATE",renderAndAdapt);this.env.bus.addEventListener("MENUS:APP-CHANGED",renderAndAdapt);onWillUnmount(()=>{systrayRegistry.removeEventListener("UPDATE",renderAndAdapt);this.env.bus.removeEventListener("MENUS:APP-CHANGED",renderAndAdapt);});useEffect(()=>{this.adapt();},()=>[adaptCounter]);this.state=useState({isAllAppsMenuOpened:false,isAppMenuSidebarOpened:false,});}
handleItemError(error,item){item.isDisplayed=()=>false;Promise.resolve().then(()=>{throw error;});}
get currentApp(){return this.menuService.getCurrentApp();}
get currentAppSections(){return((this.currentApp&&this.menuService.getMenuAsTree(this.currentApp.id).childrenTree)||[]);}
set currentAppSections(_){}
get isScopedApp(){return this.pwa.isScopedApp;}
get systrayItems(){return systrayRegistry.getEntries().map(([key,value])=>({key,...value})).filter((item)=>("isDisplayed"in item?item.isDisplayed(this.env):true)).reverse();}
set systrayItems(_){}
async adapt(){if(!this.root.el){return;}
const sectionsMenu=this.appSubMenus.el;if(!sectionsMenu){return;}
const initialAppSectionsExtra=this.currentAppSectionsExtra;const firstInitialAppSectionExtra=[...initialAppSectionsExtra].shift();const initialAppId=firstInitialAppSectionExtra&&firstInitialAppSectionExtra.appID;const sections=[...sectionsMenu.querySelectorAll(":scope > *:not(.o_menu_sections_more)"),];for(const section of sections){section.classList.remove("d-none");}
this.currentAppSectionsExtra=[];const sectionsAvailableWidth=getBoundingClientRect.call(sectionsMenu).width;const sectionsTotalWidth=sections.reduce((sum,s)=>sum+getBoundingClientRect.call(s).width,0);if(sectionsAvailableWidth<sectionsTotalWidth){let width=46;for(const section of sections){if(sectionsAvailableWidth<width+section.offsetWidth){const overflowingSections=sections.slice(sections.indexOf(section));overflowingSections.forEach((s)=>{s.classList.add("d-none");const sectionId=s.dataset.section||s.querySelector("[data-section]").getAttribute("data-section");const currentAppSection=this.currentAppSections.find((appSection)=>appSection.id.toString()===sectionId);this.currentAppSectionsExtra.push(currentAppSection);});break;}
width+=section.offsetWidth;}}
const firstCurrentAppSectionExtra=[...this.currentAppSectionsExtra].shift();const currentAppId=firstCurrentAppSectionExtra&&firstCurrentAppSectionExtra.appID;if(initialAppSectionsExtra.length===this.currentAppSectionsExtra.length&&initialAppId===currentAppId){return;}
return this.render();}
onNavBarDropdownItemSelection(menu){if(menu){this.menuService.selectMenu(menu);}}
getMenuItemHref(payload){return`/odoo/${payload.actionPath || "action-" + payload.actionID}`;}
_closeAppMenuSidebar(){this.state.isAllAppsMenuOpened=false;this.state.isAppMenuSidebarOpened=false;}
_openAppMenuSidebar(){this.state.isAppMenuSidebarOpened=!this.state.isAppMenuSidebarOpened;}
onAllAppsBtnClick(){this.state.isAllAppsMenuOpened=!this.state.isAllAppsMenuOpened;}
async _onMenuClicked(menu){await this.menuService.selectMenu(menu);this._closeAppMenuSidebar();}
_onSwipeStart(ev){this.swipeStartX=ev.changedTouches[0].clientX;}
_onSwipeEnd(ev){if(!this.swipeStartX){return;}
const deltaX=this.swipeStartX-ev.changedTouches[0].clientX;if(deltaX<SWIPE_ACTIVATION_THRESHOLD){return;}
this._closeAppMenuSidebar();this.swipeStartX=null;}}
return __exports;});;

/* /web/static/src/webclient/settings_form_view/fields/settings_binary_field/settings_binary_field.js */
odoo.define('@web/webclient/settings_form_view/fields/settings_binary_field/settings_binary_field',['@web/core/registry','@web/views/fields/binary/binary_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{BinaryField,binaryField}=require("@web/views/fields/binary/binary_field");const SettingsBinaryField=__exports.SettingsBinaryField=class SettingsBinaryField extends BinaryField{static template="web.SettingsBinaryField";getDownloadData(){const related=this.props.record.fields[this.props.name].related;return{...super.getDownloadData(),model:this.props.record.fields[related.split(".")[0]].relation,field:related.split(".")[1]??related.split(".")[0],id:this.props.record.data[related.split(".")[0]][0],}}}
const settingsBinaryField={...binaryField,component:SettingsBinaryField,};registry.category("fields").add("base_settings.binary",settingsBinaryField);return __exports;});;

/* /web/static/src/webclient/settings_form_view/fields/upgrade_boolean_field.js */
odoo.define('@web/webclient/settings_form_view/fields/upgrade_boolean_field',['@web/core/registry','@web/views/fields/boolean/boolean_field','@web/core/utils/hooks','@web/webclient/settings_form_view/fields/upgrade_dialog'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{booleanField,BooleanField}=require("@web/views/fields/boolean/boolean_field");const{useService}=require("@web/core/utils/hooks");const{UpgradeDialog}=require("@web/webclient/settings_form_view/fields/upgrade_dialog");const UpgradeBooleanField=__exports.UpgradeBooleanField=class UpgradeBooleanField extends BooleanField{setup(){super.setup();this.dialogService=useService("dialog");this.isEnterprise=odoo.info&&odoo.info.isEnterprise;}
async onChange(newValue){if(!this.isEnterprise){this.dialogService.add(UpgradeDialog,{},{onClose:()=>{this.props.record.update({[this.props.name]:false});},});}else{super.onChange(...arguments);}}}
const upgradeBooleanField=__exports.upgradeBooleanField={...booleanField,component:UpgradeBooleanField,additionalClasses:[...(booleanField.additionalClasses||[]),"o_field_boolean"],};registry.category("fields").add("upgrade_boolean",upgradeBooleanField);return __exports;});;

/* /web/static/src/webclient/settings_form_view/fields/upgrade_dialog.js */
odoo.define('@web/webclient/settings_form_view/fields/upgrade_dialog',['@web/core/dialog/dialog','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const UpgradeDialog=__exports.UpgradeDialog=class UpgradeDialog extends Component{static template="web.UpgradeDialog";static components={Dialog};static props={close:Function,};setup(){this.orm=useService("orm");}
async _confirmUpgrade(){const usersCount=await this.orm.call("res.users","search_count",[[["share","=",false]],]);window.open("https://www.odoo.com/odoo-enterprise/upgrade?num_users="+usersCount,"_blank");this.props.close();}}
return __exports;});;

/* /web/static/src/webclient/settings_form_view/highlight_text/form_label_highlight_text.js */
odoo.define('@web/webclient/settings_form_view/highlight_text/form_label_highlight_text',['@web/views/form/form_label','@web/webclient/settings_form_view/highlight_text/highlight_text','@web/webclient/settings_form_view/fields/upgrade_boolean_field'],function(require){'use strict';let __exports={};const{FormLabel}=require("@web/views/form/form_label");const{HighlightText}=require("@web/webclient/settings_form_view/highlight_text/highlight_text");const{upgradeBooleanField}=require("@web/webclient/settings_form_view/fields/upgrade_boolean_field");const FormLabelHighlightText=__exports.FormLabelHighlightText=class FormLabelHighlightText extends FormLabel{static template="web.FormLabelHighlightText";static components={HighlightText};setup(){super.setup();const isEnterprise=odoo.info&&odoo.info.isEnterprise;if(this.props.fieldInfo?.field===upgradeBooleanField&&!isEnterprise){this.upgradeEnterprise=true;}}}
return __exports;});;

/* /web/static/src/webclient/settings_form_view/highlight_text/highlight_text.js */
odoo.define('@web/webclient/settings_form_view/highlight_text/highlight_text',['@web/core/utils/strings','@odoo/owl'],function(require){'use strict';let __exports={};const{escapeRegExp}=require("@web/core/utils/strings");const{Component,useState,onWillRender}=require("@odoo/owl");const HighlightText=__exports.HighlightText=class HighlightText extends Component{static template="web.HighlightText";static highlightClass="highlighter";static props={originalText:String,};setup(){this.searchState=useState(this.env.searchState);onWillRender(()=>{const splitText=this.props.originalText.split(new RegExp(`(${escapeRegExp(this.searchState.value)})`,"ig"));this.splitText=this.searchState.value.length&&splitText.length>1?splitText:[this.props.originalText];});}}
return __exports;});;

/* /web/static/src/webclient/settings_form_view/highlight_text/settings_radio_field.js */
odoo.define('@web/webclient/settings_form_view/highlight_text/settings_radio_field',['@web/core/registry','@web/views/fields/radio/radio_field','@web/webclient/settings_form_view/highlight_text/highlight_text'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{radioField,RadioField}=require("@web/views/fields/radio/radio_field");const{HighlightText}=require("@web/webclient/settings_form_view/highlight_text/highlight_text");const SettingsRadioField=__exports.SettingsRadioField=class SettingsRadioField extends RadioField{static template="web.SettingsRadioField";static components={...super.components,HighlightText};}
const settingsRadioField=__exports.settingsRadioField={...radioField,component:SettingsRadioField,};registry.category("fields").add("base_settings.radio",settingsRadioField);return __exports;});;

/* /web/static/src/webclient/settings_form_view/settings/searchable_setting.js */
odoo.define('@web/webclient/settings_form_view/settings/searchable_setting',['@web/core/utils/strings','@web/views/form/setting/setting','@odoo/owl','@web/webclient/settings_form_view/highlight_text/form_label_highlight_text','@web/webclient/settings_form_view/highlight_text/highlight_text','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{escapeRegExp}=require("@web/core/utils/strings");const{Setting}=require("@web/views/form/setting/setting");const{onMounted,useRef,useState}=require("@odoo/owl");const{FormLabelHighlightText}=require("@web/webclient/settings_form_view/highlight_text/form_label_highlight_text");const{HighlightText}=require("@web/webclient/settings_form_view/highlight_text/highlight_text");const{browser}=require("@web/core/browser/browser");const SearchableSetting=__exports.SearchableSetting=class SearchableSetting extends Setting{static template="web.SearchableSetting";static components={...Setting.components,FormLabel:FormLabelHighlightText,HighlightText,};setup(){this.settingRef=useRef("setting");this.state=useState({search:this.env.searchState,showAllContainer:this.env.showAllContainer,highlightClass:{},});this.labels=[];this.labels.push(this.labelString,this.props.help);super.setup();onMounted(()=>{if(this.settingRef.el){const searchableTexts=this.settingRef.el.querySelectorAll("span[searchableText]");searchableTexts.forEach((st)=>{this.labels.push(st.getAttribute("searchableText"));});}
if(browser.location.hash.substring(1)===this.props.id){this.state.highlightClass={o_setting_highlight:true};setTimeout(()=>(this.state.highlightClass={}),5000);}});}
get classNames(){const classNames=super.classNames;classNames.o_searchable_setting=Boolean(this.labels.length);return{...classNames,...this.state.highlightClass};}
visible(){if(!this.state.search.value){return true;}
if(this.state.showAllContainer.showAllContainer){return true;}
const regexp=new RegExp(escapeRegExp(this.state.search.value),"i");if(regexp.test(this.labels.join())){return true;}
return false;}}
return __exports;});;

/* /web/static/src/webclient/settings_form_view/settings/setting_header.js */
odoo.define('@web/webclient/settings_form_view/settings/setting_header',['@web/views/form/setting/setting'],function(require){'use strict';let __exports={};const{Setting}=require("@web/views/form/setting/setting");const SettingHeader=__exports.SettingHeader=class SettingHeader extends Setting{static template="web.HeaderSetting";get labelString(){return this.props.string||this.props.record.fields[this.props.name].string;}}
return __exports;});;

/* /web/static/src/webclient/settings_form_view/settings/settings_app.js */
odoo.define('@web/webclient/settings_form_view/settings/settings_app',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,useState,useEffect,useRef}=require("@odoo/owl");const SettingsApp=__exports.SettingsApp=class SettingsApp extends Component{static template="web.SettingsApp";static props={string:String,imgurl:String,key:String,selectedTab:{type:String,optional:1},slots:Object,};setup(){this.state=useState({search:this.env.searchState,});this.settingsAppRef=useRef("settingsApp");useEffect(()=>{if(this.settingsAppRef.el){const force=this.state.search.value&&!this.settingsAppRef.el.querySelector(".o_settings_container:not(.d-none)")&&!this.settingsAppRef.el.querySelector(".o_setting_box.o_searchable_setting");this.settingsAppRef.el.classList.toggle("d-none",force);}},()=>[this.state.search.value]);}}
return __exports;});;

/* /web/static/src/webclient/settings_form_view/settings/settings_block.js */
odoo.define('@web/webclient/settings_form_view/settings/settings_block',['@web/webclient/settings_form_view/highlight_text/highlight_text','@web/core/utils/strings','@odoo/owl'],function(require){'use strict';let __exports={};const{HighlightText}=require("@web/webclient/settings_form_view/highlight_text/highlight_text");const{escapeRegExp}=require("@web/core/utils/strings");const{Component,useState,useRef,useEffect,onWillRender,useChildSubEnv}=require("@odoo/owl");const SettingsBlock=__exports.SettingsBlock=class SettingsBlock extends Component{static template="web.SettingsBlock";static components={HighlightText,};static props={title:{type:String,optional:true},tip:{type:String,optional:true},slots:{type:Object,optional:true},class:{type:String,optional:true},};setup(){this.state=useState({search:this.env.searchState,});this.showAllContainerState=useState({showAllContainer:false,});useChildSubEnv({showAllContainer:this.showAllContainerState,});this.settingsContainerRef=useRef("settingsContainer");this.settingsContainerTitleRef=useRef("settingsContainerTitle");this.settingsContainerTipRef=useRef("settingsContainerTip");useEffect(()=>{const regexp=new RegExp(escapeRegExp(this.state.search.value),"i");const force=this.state.search.value&&!regexp.test([this.props.title,this.props.tip].join())&&!this.settingsContainerRef.el.querySelector(".o_setting_box.o_searchable_setting");this.toggleContainer(force);},()=>[this.state.search.value]);onWillRender(()=>{const regexp=new RegExp(escapeRegExp(this.state.search.value),"i");if(regexp.test([this.props.title,this.props.tip].join())){this.showAllContainerState.showAllContainer=true;}else{this.showAllContainerState.showAllContainer=false;}});}
toggleContainer(force){if(this.settingsContainerTitleRef.el){this.settingsContainerTitleRef.el.classList.toggle("d-none",force);}
if(this.settingsContainerTipRef.el){this.settingsContainerTipRef.el.classList.toggle("d-none",force);}
this.settingsContainerRef.el.classList.toggle("d-none",force);}}
return __exports;});;

/* /web/static/src/webclient/settings_form_view/settings/settings_page.js */
odoo.define('@web/webclient/settings_form_view/settings/settings_page',['@web/core/action_swiper/action_swiper','@odoo/owl','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{ActionSwiper}=require("@web/core/action_swiper/action_swiper");const{Component,useState,useRef,useEffect}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const SettingsPage=__exports.SettingsPage=class SettingsPage extends Component{static template="web.SettingsPage";static components={ActionSwiper};static props={modules:Array,anchors:Array,initialTab:{type:String,optional:1},slots:Object,};setup(){this.state=useState({selectedTab:"",search:this.env.searchState,});if(this.props.modules){let selectedTab=this.props.initialTab||this.props.modules[0].key;if(browser.location.hash){const hash=browser.location.hash.substring(1);if(this.props.modules.map((m)=>m.key).includes(hash)){selectedTab=hash;}else{const plop=this.props.anchors.find((a)=>a.settingId===hash);if(plop){selectedTab=plop.app;}}}
this.state.selectedTab=selectedTab;}
this.settingsRef=useRef("settings");this.settingsTabRef=useRef("settings_tab");this.scrollMap=Object.create(null);useEffect((settingsEl,currentTab)=>{if(!settingsEl){return;}
const{scrollTop}=this.scrollMap[currentTab]||0;settingsEl.scrollTop=scrollTop;},()=>[this.settingsRef.el,this.state.selectedTab]);}
getCurrentIndex(){return this.props.modules.findIndex((object)=>{return object.key===this.state.selectedTab;});}
hasRightSwipe(){return(this.env.isSmall&&this.state.search.value.length===0&&this.getCurrentIndex()!==0);}
hasLeftSwipe(){return(this.env.isSmall&&this.state.search.value.length===0&&this.getCurrentIndex()!==this.props.modules.length-1);}
async onRightSwipe(prom){this.state.selectedTab=this.props.modules[this.getCurrentIndex()-1].key;await prom;this.scrollToSelectedTab();}
async onLeftSwipe(prom){this.state.selectedTab=this.props.modules[this.getCurrentIndex()+1].key;await prom;this.scrollToSelectedTab();}
scrollToSelectedTab(){const key=this.state.selectedTab;this.settingsTabRef.el.querySelector(`[data-key='${key}']`).scrollIntoView({behavior:"smooth",inline:"center",block:"nearest"});}
onSettingTabClick(key){if(this.settingsRef.el){const{scrollTop}=this.settingsRef.el;this.scrollMap[this.state.selectedTab]={scrollTop};}
this.state.selectedTab=key;this.env.searchState.value="";}}
return __exports;});;

/* /web/static/src/webclient/settings_form_view/settings_confirmation_dialog.js */
odoo.define('@web/webclient/settings_form_view/settings_confirmation_dialog',['@web/core/confirmation_dialog/confirmation_dialog','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{_t}=require("@web/core/l10n/translation");const SettingsConfirmationDialog=__exports.SettingsConfirmationDialog=class SettingsConfirmationDialog extends ConfirmationDialog{static template="web.SettingsConfirmationDialog";static defaultProps={title:_t("Unsaved changes"),};static props={...ConfirmationDialog.props,stayHere:{type:Function,optional:true},};_stayHere(){if(this.props.stayHere){this.props.stayHere();}
this.props.close();}}
return __exports;});;

/* /web/static/src/webclient/settings_form_view/settings_form_compiler.js */
odoo.define('@web/webclient/settings_form_view/settings_form_compiler',['@web/core/utils/xml','@web/views/form/form_compiler','@web/views/utils','@web/views/view_compiler'],function(require){'use strict';let __exports={};const{append,createElement}=require("@web/core/utils/xml");const{FormCompiler}=require("@web/views/form/form_compiler");const{toStringExpression}=require("@web/views/utils");const{isTextNode}=require("@web/views/view_compiler");const SettingsFormCompiler=__exports.SettingsFormCompiler=class SettingsFormCompiler extends FormCompiler{setup(){super.setup();this.compilers.push({selector:"app",fn:this.compileApp},{selector:"block",fn:this.compileBlock});}
compileForm(el,params){const settingsPage=createElement("SettingsPage");settingsPage.setAttribute("slots","{NoContentHelper:__comp__.props.slots.NoContentHelper}");settingsPage.setAttribute("initialTab","__comp__.props.initialApp");settingsPage.setAttribute("t-slot-scope","settings");params.modules=[];params.anchors=[];const res=super.compileForm(...arguments);res.classList.remove("o_form_nosheet");settingsPage.setAttribute("modules",JSON.stringify(params.modules));while(res.firstChild){append(settingsPage,res.firstChild);}
settingsPage.setAttribute("anchors",JSON.stringify(params.anchors));append(res,settingsPage);return res;}
compileApp(el,params){if(el.getAttribute("notApp")==="1"){return;}
const module={key:el.getAttribute("name"),string:el.getAttribute("string"),imgurl:el.getAttribute("logo")||"/"+el.getAttribute("name")+"/static/description/icon.png",};params.modules.push(module);const settingsApp=createElement("SettingsApp",{key:toStringExpression(module.key),string:toStringExpression(module.string||""),imgurl:toStringExpression(module.imgurl),selectedTab:"settings.selectedTab",});for(const child of el.children){append(settingsApp,this.compileNode(child,params));}
params.anchors.push(...[...settingsApp.querySelectorAll("SearchableSetting")].filter((s)=>s.id).map((s)=>({app:module.key,settingId:s.id.replaceAll("`","")})));return settingsApp;}
compileBlock(el,params){const settingsContainer=createElement("SettingsBlock",{title:toStringExpression(el.getAttribute("title")||""),tip:toStringExpression(el.getAttribute("help")||""),});for(const child of el.children){append(settingsContainer,this.compileNode(child,params));}
return settingsContainer;}
compileSetting(el,params){params.componentName=el.getAttribute("type")==="header"?"SettingHeader":"SearchableSetting";const res=super.compileSetting(el,params);return res;}
compileNode(node,params,evalInvisible){if(isTextNode(node)){if(node.textContent.trim()){return createElement("HighlightText",{originalText:toStringExpression(node.textContent),});}}
return super.compileNode(node,params,evalInvisible);}
compileButton(el,params){const res=super.compileButton(el,params);if(res.hasAttribute("string")&&res.children.length===0){const contentSlot=createElement("t");contentSlot.setAttribute("t-set-slot","contents");const content=createElement("HighlightText",{originalText:res.getAttribute("string"),});append(contentSlot,content);append(res,contentSlot);}
return res;}}
return __exports;});;

/* /web/static/src/webclient/settings_form_view/settings_form_controller.js */
odoo.define('@web/webclient/settings_form_view/settings_form_controller',['@web/core/l10n/translation','@web/core/utils/hooks','@web/core/utils/objects','@web/views/form/form_view','@web/webclient/settings_form_view/settings_confirmation_dialog','@web/webclient/settings_form_view/settings_form_renderer','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useAutofocus}=require("@web/core/utils/hooks");const{pick}=require("@web/core/utils/objects");const{formView}=require("@web/views/form/form_view");const{SettingsConfirmationDialog}=require("@web/webclient/settings_form_view/settings_confirmation_dialog");const{SettingsFormRenderer}=require("@web/webclient/settings_form_view/settings_form_renderer");const{useSubEnv,useState,useRef,useEffect}=require("@odoo/owl");const SettingsFormController=__exports.SettingsFormController=class SettingsFormController extends formView.Controller{static template="web.SettingsFormView";static components={...formView.Controller.components,Renderer:SettingsFormRenderer,};setup(){super.setup();useAutofocus();this.state=useState({displayNoContent:false});this.searchState=useState({value:""});this.rootRef=useRef("root");this.canCreate=false;useSubEnv({searchState:this.searchState});useEffect(()=>{if(this.searchState.value){if(this.rootRef.el.querySelector(".o_settings_container:not(.d-none)")||this.rootRef.el.querySelector(".settings .o_settings_container:not(.d-none) .o_setting_box.o_searchable_setting")){this.state.displayNoContent=false;}else{this.state.displayNoContent=true;}}else{this.state.displayNoContent=false;}},()=>[this.searchState.value]);useEffect(()=>{if(this.env.__getLocalState__){this.env.__getLocalState__.remove(this);}});this.initialApp="module"in this.props.context?this.props.context.module:"";}
get modelParams(){const headerFields=Object.values(this.archInfo.fieldNodes).filter((fieldNode)=>fieldNode.options.isHeaderField).map((fieldNode)=>fieldNode.name);return{...super.modelParams,headerFields,onChangeHeaderFields:()=>this._confirmSave(),};}
async beforeExecuteActionButton(clickParams){if(clickParams.name==="cancel"){return true;}
if((await this.model.root.isDirty())&&!["execute"].includes(clickParams.name)&&!clickParams.noSaveDialog){return this._confirmSave();}else{return this.model.root.save();}}
displayName(){return _t("Settings");}
async beforeLeave(){const dirty=await this.model.root.isDirty();if(dirty){return this._confirmSave();}}
beforeUnload(){}
beforeVisibilityChange(){}
async save(){await this.env.onClickViewButton({clickParams:{name:"execute",type:"object",},getResParams:()=>pick(this.model.root,"context","evalContext","resModel","resId","resIds"),});}
discard(){this.env.onClickViewButton({clickParams:{name:"cancel",type:"object",special:"cancel",},getResParams:()=>pick(this.model.root,"context","evalContext","resModel","resId","resIds"),});}
async _confirmSave(){let _continue=true;await new Promise((resolve)=>{this.dialogService.add(SettingsConfirmationDialog,{body:_t("Would you like to save your changes?"),confirm:async()=>{await this.save();_continue=false;resolve();},cancel:async()=>{await this.model.root.discard();await this.model.root.save();_continue=true;resolve();},stayHere:()=>{_continue=false;resolve();},});});return _continue;}}
return __exports;});;

/* /web/static/src/webclient/settings_form_view/settings_form_renderer.js */
odoo.define('@web/webclient/settings_form_view/settings_form_renderer',['@web/views/form/form_renderer','@web/webclient/settings_form_view/highlight_text/form_label_highlight_text','@web/webclient/settings_form_view/highlight_text/highlight_text','@web/webclient/settings_form_view/settings/searchable_setting','@web/webclient/settings_form_view/settings/setting_header','@web/webclient/settings_form_view/settings/settings_block','@web/webclient/settings_form_view/settings/settings_app','@web/webclient/settings_form_view/settings/settings_page','@odoo/owl'],function(require){'use strict';let __exports={};const{FormRenderer}=require("@web/views/form/form_renderer");const{FormLabelHighlightText}=require("@web/webclient/settings_form_view/highlight_text/form_label_highlight_text");const{HighlightText}=require("@web/webclient/settings_form_view/highlight_text/highlight_text");const{SearchableSetting}=require("@web/webclient/settings_form_view/settings/searchable_setting");const{SettingHeader}=require("@web/webclient/settings_form_view/settings/setting_header");const{SettingsBlock}=require("@web/webclient/settings_form_view/settings/settings_block");const{SettingsApp}=require("@web/webclient/settings_form_view/settings/settings_app");const{SettingsPage}=require("@web/webclient/settings_form_view/settings/settings_page");const{useState}=require("@odoo/owl");const SettingsFormRenderer=__exports.SettingsFormRenderer=class SettingsFormRenderer extends FormRenderer{static components={...FormRenderer.components,SearchableSetting,SettingHeader,SettingsBlock,SettingsPage,SettingsApp,HighlightText,FormLabel:FormLabelHighlightText,};static props={...FormRenderer.props,initialApp:String,slots:Object,};setup(){super.setup();this.searchState=useState(this.env.searchState);}
get shouldAutoFocus(){return false;}}
return __exports;});;

/* /web/static/src/webclient/settings_form_view/settings_form_view.js */
odoo.define('@web/webclient/settings_form_view/settings_form_view',['@web/core/registry','@web/core/py_js/py','@web/core/utils/arrays','@web/search/control_panel/control_panel','@web/views/form/form_view','@web/webclient/settings_form_view/settings_form_controller','@web/webclient/settings_form_view/settings_form_renderer','@web/webclient/settings_form_view/settings_form_compiler'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{evaluateExpr}=require("@web/core/py_js/py");const{intersection}=require("@web/core/utils/arrays");const{ControlPanel}=require("@web/search/control_panel/control_panel");const{formView}=require("@web/views/form/form_view");const{SettingsFormController}=require("@web/webclient/settings_form_view/settings_form_controller");const{SettingsFormRenderer}=require("@web/webclient/settings_form_view/settings_form_renderer");const{SettingsFormCompiler}=require("@web/webclient/settings_form_view/settings_form_compiler");class SettingRecord extends formView.Model.Record{_update(changes){const changedFields=Object.keys(changes);let dirty=true;if(intersection(changedFields,this.model._headerFields).length===changedFields.length){dirty=this.dirty;if(this.dirty){this.model._onChangeHeaderFields().then(async(isDiscard)=>{if(isDiscard){await super._update(...arguments);this.dirty=false;}else{const undoChanges=this._applyChanges(changes);undoChanges();}});return;}}
const prom=super._update(...arguments);this.dirty=dirty;return prom;}}
class SettingModel extends formView.Model{setup(params){super.setup(...arguments);this._headerFields=params.headerFields;this._onChangeHeaderFields=params.onChangeHeaderFields;}
_getNextConfig(){const nextConfig=super._getNextConfig(...arguments);nextConfig.resId=false;return nextConfig;}}
SettingModel.Record=SettingRecord;const settingsFormView=__exports.settingsFormView={...formView,display:{},buttonTemplate:"web.SettingsFormView.Buttons",Model:SettingModel,ControlPanel:ControlPanel,Controller:SettingsFormController,Compiler:SettingsFormCompiler,Renderer:SettingsFormRenderer,props:(genericProps,view)=>{[...genericProps.arch.querySelectorAll("setting[type='header'] field")].forEach((el)=>{const options=evaluateExpr(el.getAttribute("options")||"{}");options.isHeaderField=true;el.setAttribute("options",JSON.stringify(options));});return formView.props(genericProps,view);},};registry.category("views").add("base_settings",settingsFormView);return __exports;});;

/* /web/static/src/webclient/settings_form_view/widgets/demo_data_service.js */
odoo.define('@web/webclient/settings_form_view/widgets/demo_data_service',['@web/core/network/rpc','@web/core/registry'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const demoDataService=__exports.demoDataService={async start(){let isDemoDataActiveProm;return{isDemoDataActive(){if(!isDemoDataActiveProm){isDemoDataActiveProm=rpc("/base_setup/demo_active");}
return isDemoDataActiveProm;},};},};registry.category("services").add("demo_data",demoDataService);return __exports;});;

/* /web/static/src/webclient/settings_form_view/widgets/mobile_apps_funnel.js */
odoo.define('@web/webclient/settings_form_view/widgets/mobile_apps_funnel',['@web/core/registry','@odoo/owl','@web/core/browser/feature_detection','@web/views/form/setting/setting','@web/views/widgets/standard_widget_props'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Component}=require("@odoo/owl");const{isMobileOS}=require("@web/core/browser/feature_detection");const{Setting}=require("@web/views/form/setting/setting");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");class MobileAppsFunnel extends Component{static template="web.MobileAppsFunnel";static components={Setting,};static props={...standardWidgetProps};setup(){this.iosAppstoreImagePath=isMobileOS()?"/web/static/img/app_store.png":"/web/static/img/mobile_app_qrcode_ios.svg";this.androidAppstoreImagePath=isMobileOS()?"/web/static/img/google_play.png":"/web/static/img/mobile_app_qrcode_android.svg";}}
const mobileAppsFunnel=__exports.mobileAppsFunnel={component:MobileAppsFunnel,};registry.category("view_widgets").add("mobile_apps_funnel",mobileAppsFunnel);return __exports;});;

/* /web/static/src/webclient/settings_form_view/widgets/res_config_dev_tool.js */
odoo.define('@web/webclient/settings_form_view/widgets/res_config_dev_tool',['@web/core/registry','@web/core/utils/hooks','@web/webclient/settings_form_view/settings/settings_block','@web/views/form/setting/setting','@odoo/owl','@web/views/widgets/standard_widget_props','@web/core/browser/router'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{SettingsBlock}=require("@web/webclient/settings_form_view/settings/settings_block");const{Setting}=require("@web/views/form/setting/setting");const{Component,onWillStart}=require("@odoo/owl");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{router}=require("@web/core/browser/router");const ResConfigDevTool=__exports.ResConfigDevTool=class ResConfigDevTool extends Component{static template="res_config_dev_tool";static components={SettingsBlock,Setting,};static props={...standardWidgetProps,};setup(){this.isDebug=Boolean(odoo.debug);this.isAssets=odoo.debug.includes("assets");this.isTests=odoo.debug.includes("tests");this.action=useService("action");this.demo=useService("demo_data");onWillStart(async()=>{this.isDemoDataActive=await this.demo.isDemoDataActive();});}
activateDebug(value){router.pushState({debug:value},{reload:true});}
onClickForceDemo(){this.action.doAction("base.demo_force_install_action");}}
const resConfigDevTool=__exports.resConfigDevTool={component:ResConfigDevTool,};registry.category("view_widgets").add("res_config_dev_tool",resConfigDevTool);return __exports;});;

/* /web/static/src/webclient/settings_form_view/widgets/res_config_edition.js */
odoo.define('@web/webclient/settings_form_view/widgets/res_config_edition',['@web/core/registry','@web/session','@web/views/form/setting/setting','@odoo/owl','@web/views/widgets/standard_widget_props'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{session}=require("@web/session");const{Setting}=require("@web/views/form/setting/setting");const{Component}=require("@odoo/owl");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{DateTime}=luxon;class ResConfigEdition extends Component{static template="res_config_edition";static components={Setting};static props={...standardWidgetProps,};setup(){this.serverVersion=session.server_version;this.expirationDate=session.expiration_date?DateTime.fromSQL(session.expiration_date).toLocaleString(DateTime.DATE_FULL):DateTime.now().plus({days:30}).toLocaleString(DateTime.DATE_FULL);}}
const resConfigEdition=__exports.resConfigEdition={component:ResConfigEdition,};registry.category("view_widgets").add("res_config_edition",resConfigEdition);return __exports;});;

/* /web/static/src/webclient/settings_form_view/widgets/res_config_invite_users.js */
odoo.define('@web/webclient/settings_form_view/widgets/res_config_invite_users',['@web/core/registry','@web/core/l10n/translation','@web/core/l10n/utils','@web/core/utils/arrays','@web/core/utils/hooks','@odoo/owl','@web/views/widgets/standard_widget_props'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{formatList}=require("@web/core/l10n/utils");const{unique}=require("@web/core/utils/arrays");const{useService}=require("@web/core/utils/hooks");const{Component,useState,onWillStart}=require("@odoo/owl");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");class ResConfigInviteUsers extends Component{static template="res_config_invite_users";static props={...standardWidgetProps,};setup(){this.orm=useService("orm");this.invite=useService("user_invite");this.action=useService("action");this.notification=useService("notification");this.state=useState({status:"idle",emails:"",invite:null,});onWillStart(async()=>{this.state.invite=await this.invite.fetchData();});}
validateEmail(email){const re=/^([a-z0-9][-a-z0-9_+.]*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,63}(?:\.[a-z]{2})?)$/i;return re.test(email);}
get emails(){return unique(this.state.emails.split(/[ ,;\n]+/).map((email)=>email.trim()).filter((email)=>email.length));}
validate(){if(!this.emails.length){throw new Error(_t("Empty email address"));}
const invalidEmails=[];for(const email of this.emails){if(!this.validateEmail(email)){invalidEmails.push(email);}}
if(invalidEmails.length){const errorMessage=(()=>{switch(invalidEmails.length){case 1:return _t("Invalid email address: %(address)s",{address:invalidEmails[0],});case 2:return _t("Invalid email addresses: %(2 addresses)s",{"2 addresses":formatList(invalidEmails),});default:return _t("Invalid email addresses: %(addresses)s",{addresses:formatList(invalidEmails),});}})();throw new Error(errorMessage);}}
get inviteButtonText(){if(this.state.status==="inviting"){return _t("Inviting...");}
return _t("Invite");}
onClickMore(ev){this.action.doAction(this.state.invite.action_pending_users);}
onClickUser(ev,user){const action=Object.assign({},this.state.invite.action_pending_users,{res_id:user[0],});this.action.doAction(action);}
onKeydownUserEmails(ev){const keys=["Enter","Tab",","];if(keys.includes(ev.key)){if(ev.key==="Tab"&&!this.emails.length){return;}
ev.preventDefault();this.sendInvite();}}
async sendInvite(){try{this.validate();}catch(e){this.notification.add(e.message,{type:"danger"});return;}
this.state.status="inviting";const pendingUserEmails=this.state.invite.pending_users.map((user)=>user[1]);const emailsLeftToProcess=this.emails.filter((email)=>!pendingUserEmails.includes(email));try{if(emailsLeftToProcess){await this.orm.call("res.users","web_create_users",[emailsLeftToProcess]);this.state.invite=await this.invite.fetchData(true);}}finally{this.state.emails="";this.state.status="idle";}}}
const resConfigInviteUsers=__exports.resConfigInviteUsers={component:ResConfigInviteUsers,};registry.category("view_widgets").add("res_config_invite_users",resConfigInviteUsers);return __exports;});;

/* /web/static/src/webclient/settings_form_view/widgets/user_invite_service.js */
odoo.define('@web/webclient/settings_form_view/widgets/user_invite_service',['@web/core/network/rpc','@web/core/registry'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const userInviteService=__exports.userInviteService={async start(){let dataProm;return{fetchData(reload=false){if(!dataProm||reload){dataProm=rpc("/base_setup/data");}
return dataProm;},};},};registry.category("services").add("user_invite",userInviteService);return __exports;});;

/* /web/static/src/webclient/share_target/share_target_service.js */
odoo.define('@web/webclient/share_target/share_target_service',['@web/core/registry','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{browser}=require("@web/core/browser/browser");const getShareTargetDataFromServiceWorker=()=>{return new Promise((resolve)=>{const onmessage=(event)=>{if(event.data.action==="odoo_share_target_ack"){resolve(event.data.shared_files);browser.navigator.serviceWorker.removeEventListener("message",onmessage);}};browser.navigator.serviceWorker.addEventListener("message",onmessage);browser.navigator.serviceWorker.controller.postMessage("odoo_share_target");});};const shareTargetService=__exports.shareTargetService={dependencies:["menu"],start(env,{menu}){let sharedFiles=null;if(browser.navigator.serviceWorker&&new URL(browser.location).searchParams.get("share_target")==="trigger"){const app=menu.getApps().find((app)=>"expenses"===app.actionPath);if(app){const clientReadyListener=async()=>{sharedFiles=await getShareTargetDataFromServiceWorker();if(sharedFiles?.length){await menu.selectMenu(app);}
env.bus.removeEventListener("WEB_CLIENT_READY",clientReadyListener);};env.bus.addEventListener("WEB_CLIENT_READY",clientReadyListener);}}
return{hasSharedFiles:()=>!!sharedFiles?.length,getSharedFilesToUpload:()=>{const files=sharedFiles;sharedFiles=null;return files;},};},};registry.category("services").add("shareTarget",shareTargetService);return __exports;});;

/* /web/static/src/webclient/switch_company_menu/switch_company_item.js */
odoo.define('@web/webclient/switch_company_menu/switch_company_item',['@web/core/dropdown/dropdown_item','@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{Component,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const SwitchCompanyItem=__exports.SwitchCompanyItem=class SwitchCompanyItem extends Component{static template="web.SwitchCompanyItem";static components={DropdownItem,SwitchCompanyItem};static props={company:{},level:{type:Number},};setup(){this.companyService=useService("company");this.companySelector=useState(this.env.companySelector);}
get isCompanySelected(){return this.companySelector.isCompanySelected(this.props.company.id);}
get isCompanyAllowed(){return this.props.company.id in this.companyService.allowedCompanies;}
get isCurrent(){return this.props.company.id===this.companyService.currentCompany.id;}
logIntoCompany(){if(this.isCompanyAllowed){this.companySelector.switchCompany("loginto",this.props.company.id);}}
toggleCompany(){if(this.isCompanyAllowed){this.companySelector.switchCompany("toggle",this.props.company.id);}}}
return __exports;});;

/* /web/static/src/webclient/switch_company_menu/switch_company_menu.js */
odoo.define('@web/webclient/switch_company_menu/switch_company_menu',['@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_group','@web/core/dropdown/dropdown_item','@web/core/registry','@odoo/owl','@web/core/commands/command_hook','@web/core/l10n/translation','@web/core/utils/arrays','@web/core/utils/hooks','@web/webclient/switch_company_menu/switch_company_item','@web/core/hotkeys/hotkey_hook','@web/core/dropdown/dropdown_hooks'],function(require){'use strict';let __exports={};const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownGroup}=require("@web/core/dropdown/dropdown_group");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{registry}=require("@web/core/registry");const{Component,useChildSubEnv,useRef,useState}=require("@odoo/owl");const{useCommand}=require("@web/core/commands/command_hook");const{_t}=require("@web/core/l10n/translation");const{symmetricalDifference}=require("@web/core/utils/arrays");const{useChildRef,useService}=require("@web/core/utils/hooks");const{SwitchCompanyItem}=require("@web/webclient/switch_company_menu/switch_company_item");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const CompanySelector=__exports.CompanySelector=class CompanySelector{constructor(companyService,dropdownState){this.companyService=companyService;this.dropdownState=dropdownState;this.selectedCompaniesIds=companyService.activeCompanyIds.slice();}
get hasSelectionChanged(){return(symmetricalDifference(this.selectedCompaniesIds,this.companyService.activeCompanyIds).length>0);}
isCompanySelected(companyId){return this.selectedCompaniesIds.includes(companyId);}
switchCompany(mode,companyId){if(mode==="toggle"){if(this.selectedCompaniesIds.includes(companyId)){this._deselectCompany(companyId);}else{this._selectCompany(companyId);}}else if(mode==="loginto"){if(this._isSingleCompanyMode()){this.selectedCompaniesIds.splice(0,this.selectedCompaniesIds.length);}
this._selectCompany(companyId,true);this.apply();this.dropdownState.close?.();}}
apply(){this.companyService.setCompanies(this.selectedCompaniesIds,false);}
reset(){this.selectedCompaniesIds=this.companyService.activeCompanyIds.slice();}
selectAll(){if(this.selectedCompaniesIds.length>0){this.selectedCompaniesIds.splice(0,this.selectedCompaniesIds.length);}else{const newIds=Object.values(this.companyService.allowedCompanies).map((c)=>c.id);this.selectedCompaniesIds.splice(0,this.selectedCompaniesIds.length,...newIds);}}
_selectCompany(companyId,unshift=false){if(!this.selectedCompaniesIds.includes(companyId)){if(unshift){this.selectedCompaniesIds.unshift(companyId);}else{this.selectedCompaniesIds.push(companyId);}}else if(unshift){const index=this.selectedCompaniesIds.findIndex((c)=>c===companyId);this.selectedCompaniesIds.splice(index,1);this.selectedCompaniesIds.unshift(companyId);}
this._getBranches(companyId).forEach((companyId)=>this._selectCompany(companyId));}
_deselectCompany(companyId){if(this.selectedCompaniesIds.includes(companyId)){this.selectedCompaniesIds.splice(this.selectedCompaniesIds.indexOf(companyId),1);this._getBranches(companyId).forEach((companyId)=>this._deselectCompany(companyId));}}
_getBranches(companyId){return this.companyService.getCompany(companyId).child_ids||[];}
_isSingleCompanyMode(){if(this.selectedCompaniesIds.length===1){return true;}
const getActiveCompany=(companyId)=>{const isActive=this.selectedCompaniesIds.includes(companyId);return isActive?this.companyService.getCompany(companyId):null;};let rootCompany=undefined;for(const companyId of this.selectedCompaniesIds){let company=getActiveCompany(companyId);while(getActiveCompany(company.parent_id)){company=getActiveCompany(company.parent_id);}
if(rootCompany===undefined){rootCompany=company;}else if(rootCompany!==company){return false;}}
if(rootCompany&&rootCompany.child_ids){const queue=[...rootCompany.child_ids];while(queue.length>0){const company=getActiveCompany(queue.pop());if(company&&company.child_ids){queue.push(...company.child_ids);}else if(!company){return false;}}}
return true;}}
const SwitchCompanyMenu=__exports.SwitchCompanyMenu=class SwitchCompanyMenu extends Component{static template="web.SwitchCompanyMenu";static components={Dropdown,DropdownItem,DropdownGroup,SwitchCompanyItem};static props={};static CompanySelector=CompanySelector;setup(){this.dropdown=useDropdownState();this.companyService=useService("company");this.companySelector=useState(new this.constructor.CompanySelector(this.companyService,this.dropdown));useChildSubEnv({companySelector:this.companySelector});this.searchInputRef=useRef("inputRef");this.state=useState({});this.resetState();useHotkey("control+enter",()=>this.confirm(),{bypassEditableProtection:true,isAvailable:()=>this.companySelector.hasSelectionChanged,});useCommand(_t("Switch Company"),()=>this.dropdown.open(),{hotkey:"alt+shift+u"});this.containerRef=useChildRef();this.navigationOptions={hotkeys:{space:(index,items)=>{if(!items[index]){return;}
if(items[index].el.classList.contains("o_switch_company_item")){const companyId=parseInt(items[index].el.dataset.companyId);this.companySelector.switchCompany("toggle",companyId);}},enter:(index,items)=>{if(!items[index]){return;}
if(items[index].el.classList.contains("o_switch_company_item")){const companyId=parseInt(items[index].el.dataset.companyId);this.companySelector.switchCompany("loginto",companyId);this.dropdown.close();}else{items[index].select();}},},};}
get hasLotsOfCompanies(){return Object.values(this.companyService.allowedCompaniesWithAncestors).length>9;}
get companiesEntries(){const companies=[];const addCompany=(company,level=0)=>{if(this.matchSearch(company.name)){companies.push({company,level});}
if(company.child_ids){for(const companyId of company.child_ids){addCompany(this.companyService.getCompany(companyId),level+1);}}};Object.values(this.companyService.allowedCompaniesWithAncestors).filter((c)=>!c.parent_id).sort((c1,c2)=>c1.sequence-c2.sequence).forEach((c)=>addCompany(c));return companies;}
get selectAllClass(){if(this.companySelector.selectedCompaniesIds.length>=Object.values(this.companyService.allowedCompanies).length){return"btn-link text-primary";}else{return"btn-link text-secondary";}}
get selectAllIcon(){if(this.companySelector.selectedCompaniesIds.length>=Object.values(this.companyService.allowedCompanies).length){return"fa-check-square text-primary";}else if(this.companySelector.selectedCompaniesIds.length>0){return"fa-minus-square-o";}else{return"fa-square-o";}}
resetState(){this.state.searchFilter="";this.state.showFilter=this.hasLotsOfCompanies;}
onSearch(ev){this.state.searchFilter=ev.target.value;this.state.showFilter=true;}
matchSearch(companyName){if(!this.state.searchFilter){return true;}
const name=companyName.toLocaleLowerCase().replace(/\s/g,"");const filter=this.state.searchFilter.toLocaleLowerCase().replace(/\s/g,"");return name.includes(filter);}
handleDropdownChange(isOpen){if(isOpen){if(this.searchInputRef.el){this.searchInputRef.el.focus();}
if(this.containerRef.el){const currentWidth=this.containerRef.el.getBoundingClientRect().width;this.containerRef.el.style.width=currentWidth+"px";}}else{this.resetState();}}
confirm(){this.dropdown.close();this.companySelector.apply();}
get isSingleCompany(){return Object.values(this.companyService.allowedCompaniesWithAncestors??{}).length===1;}}
const systrayItem=__exports.systrayItem={Component:SwitchCompanyMenu,};registry.category("systray").add("SwitchCompanyMenu",systrayItem,{sequence:1});return __exports;});;

/* /web/static/src/webclient/user_menu/user_menu.js */
odoo.define('@web/webclient/user_menu/user_menu',['@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_group','@web/core/dropdown/dropdown_item','@web/core/checkbox/checkbox','@web/core/registry','@web/core/user','@web/session','@odoo/owl','@web/core/utils/urls'],function(require){'use strict';let __exports={};const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownGroup}=require("@web/core/dropdown/dropdown_group");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{CheckBox}=require("@web/core/checkbox/checkbox");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{session}=require("@web/session");const{Component}=require("@odoo/owl");const{imageUrl}=require("@web/core/utils/urls");const userMenuRegistry=registry.category("user_menuitems");const UserMenu=__exports.UserMenu=class UserMenu extends Component{static template="web.UserMenu";static components={DropdownGroup,Dropdown,DropdownItem,CheckBox};static props={};setup(){this.userName=user.name;this.dbName=session.db;const{partnerId,writeDate}=user;this.source=imageUrl("res.partner",partnerId,"avatar_128",{unique:writeDate});}
getElements(){const sortedItems=userMenuRegistry.getAll().map((element)=>element(this.env)).filter((element)=>(element.show?element.show():true)).sort((x,y)=>{const xSeq=x.sequence?x.sequence:100;const ySeq=y.sequence?y.sequence:100;return xSeq-ySeq;});return sortedItems;}}
const systrayItem=__exports.systrayItem={Component:UserMenu,};registry.category("systray").add("web.user_menu",systrayItem,{sequence:0});return __exports;});;

/* /web/static/src/webclient/user_menu/user_menu_items.js */
odoo.define('@web/webclient/user_menu/user_menu_items',['@odoo/owl','@web/core/browser/feature_detection','@web/core/l10n/translation','@web/core/network/rpc','@web/core/user','@web/core/utils/strings','@web/session','@web/core/browser/browser','@web/core/registry'],function(require){'use strict';let __exports={};const{Component,markup}=require("@odoo/owl");const{isMacOS}=require("@web/core/browser/feature_detection");const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{user}=require("@web/core/user");const{escape}=require("@web/core/utils/strings");const{session}=require("@web/session");const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");function documentationItem(env){const documentationURL="https://www.odoo.com/documentation/18.0";return{type:"item",id:"documentation",description:_t("Documentation"),href:documentationURL,callback:()=>{browser.open(documentationURL,"_blank");},sequence:10,};}
function supportItem(env){const url=session.support_url;return{type:"item",id:"support",description:_t("Support"),href:url,callback:()=>{browser.open(url,"_blank");},sequence:20,};}
class ShortcutsFooterComponent extends Component{static template="web.UserMenu.ShortcutsFooterComponent";static props={switchNamespace:{type:Function,optional:true},};setup(){this.runShortcutKey=isMacOS()?"CONTROL":"ALT";}}
function shortCutsItem(env){const translatedText=_t("Shortcuts");return{type:"item",id:"shortcuts",hide:env.isSmall,description:markup(`<div class="d-flex align-items-center justify-content-between">
                <span>${escape(translatedText)}</span>
                <span class="fw-bold">${isMacOS() ? "CMD" : "CTRL"}+K</span>
            </div>`),callback:()=>{env.services.command.openMainPalette({FooterComponent:ShortcutsFooterComponent});},sequence:30,};}
function separator(){return{type:"separator",sequence:40,};}
__exports.preferencesItem=preferencesItem;function preferencesItem(env){return{type:"item",id:"settings",description:_t("Preferences"),callback:async function(){const actionDescription=await env.services.orm.call("res.users","action_get");actionDescription.res_id=user.userId;env.services.action.doAction(actionDescription);},sequence:50,};}
__exports.odooAccountItem=odooAccountItem;function odooAccountItem(env){return{type:"item",id:"account",description:_t("My Odoo.com account"),callback:()=>{rpc("/web/session/account").then((url)=>{browser.open(url,"_blank");}).catch(()=>{browser.open("https://accounts.odoo.com/account","_blank");});},sequence:60,};}
function installPWAItem(env){let description=_t("Install App");let callback=()=>env.services.pwa.show();let show=()=>env.services.pwa.isAvailable;const currentApp=env.services.menu.getCurrentApp();if(currentApp&&["barcode","field-service","shop-floor"].includes(currentApp.actionPath)){description=_t("Install %s",currentApp.name);callback=()=>{window.open(`/scoped_app?app_id=${currentApp.webIcon.split(",")[0]}&path=${encodeURIComponent(
                    "scoped_app/" + currentApp.actionPath
                )}`);};show=()=>!env.services.pwa.isScopedApp;}
return{type:"item",id:"install_pwa",description,callback,show,sequence:65,};}
function logOutItem(env){let route="/web/session/logout";if(env.services.pwa.isScopedApp){route+=`?redirect=${encodeURIComponent(env.services.pwa.startUrl)}`;}
return{type:"item",id:"logout",description:_t("Log out"),href:`${browser.location.origin}${route}`,callback:()=>{browser.location.href=route;},sequence:70,};}
registry.category("user_menuitems").add("documentation",documentationItem).add("support",supportItem).add("shortcuts",shortCutsItem).add("separator",separator).add("profile",preferencesItem).add("odoo_account",odooAccountItem).add("install_pwa",installPWAItem).add("log_out",logOutItem);return __exports;});;

/* /web/static/src/webclient/webclient.js */
odoo.define('@web/webclient/webclient',['@web/core/debug/debug_context','@web/core/debug/debug_menu','@web/core/l10n/localization','@web/core/main_components_container','@web/core/registry','@web/core/utils/hooks','@web/webclient/actions/action_container','@web/webclient/navbar/navbar','@odoo/owl','@web/core/browser/router','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{useOwnDebugContext}=require("@web/core/debug/debug_context");const{DebugMenu}=require("@web/core/debug/debug_menu");const{localization}=require("@web/core/l10n/localization");const{MainComponentsContainer}=require("@web/core/main_components_container");const{registry}=require("@web/core/registry");const{useBus,useService}=require("@web/core/utils/hooks");const{ActionContainer}=require("@web/webclient/actions/action_container");const{NavBar}=require("@web/webclient/navbar/navbar");const{Component,onMounted,onWillStart,useExternalListener,useState}=require("@odoo/owl");const{router,routerBus}=require("@web/core/browser/router");const{browser}=require("@web/core/browser/browser");const WebClient=__exports.WebClient=class WebClient extends Component{static template="web.WebClient";static props={};static components={ActionContainer,NavBar,MainComponentsContainer,};setup(){this.menuService=useService("menu");this.actionService=useService("action");this.title=useService("title");useOwnDebugContext({categories:["default"]});if(this.env.debug){registry.category("systray").add("web.debug_mode_menu",{Component:DebugMenu,},{sequence:100});}
this.localization=localization;this.state=useState({fullscreen:false,});useBus(routerBus,"ROUTE_CHANGE",async()=>{document.body.style.pointerEvents="none";try{await this.loadRouterState();}finally{document.body.style.pointerEvents="auto";}});useBus(this.env.bus,"ACTION_MANAGER:UI-UPDATED",({detail:mode})=>{if(mode!=="new"){this.state.fullscreen=mode==="fullscreen";}});useBus(this.env.bus,"WEBCLIENT:LOAD_DEFAULT_APP",this._loadDefaultApp);onMounted(()=>{this.loadRouterState();this.env.bus.trigger("WEB_CLIENT_READY");});useExternalListener(window,"click",this.onGlobalClick,{capture:true});onWillStart(this.registerServiceWorker);}
async loadRouterState(){let menuId=Number(router.current.menu_id||0);const firstAction=router.current.actionStack?.[0]?.action;if(!menuId&&firstAction){menuId=this.menuService.getAll().find((m)=>m.actionID===firstAction||m.actionPath===firstAction)?.appID;}
if(menuId){this.menuService.setCurrentMenu(menuId);}
let stateLoaded=await this.actionService.loadState();if(!stateLoaded&&menuId){const menu=this.menuService.getAll().find((m)=>menuId===m.id);const actionId=menu&&menu.actionID;if(actionId){await this.actionService.doAction(actionId,{clearBreadcrumbs:true});stateLoaded=true;}}
if(stateLoaded&&!menuId){const currentController=this.actionService.currentController;const actionId=currentController&&currentController.action.id;menuId=this.menuService.getAll().find((m)=>m.actionID===actionId)?.appID;if(!menuId){menuId=Number(browser.sessionStorage.getItem("menu_id"));}
if(menuId){this.menuService.setCurrentMenu(menuId);}}
if(stateLoaded){if(browser.location.hash!==""){try{const el=document.querySelector(browser.location.hash);if(el!==null){el.scrollIntoView(true);}}catch{}}}
if(!stateLoaded){await this._loadDefaultApp();}}
_loadDefaultApp(){const root=this.menuService.getMenu("root");const firstApp=root.children[0];if(firstApp){return this.menuService.selectMenu(firstApp);}}
onGlobalClick(ev){if((ev.ctrlKey||ev.metaKey)&&!ev.target.isContentEditable&&((ev.target instanceof HTMLAnchorElement&&ev.target.href)||(ev.target instanceof HTMLElement&&ev.target.closest("a[href]:not([href=''])")))){ev.stopImmediatePropagation();return;}}
registerServiceWorker(){if(navigator.serviceWorker){navigator.serviceWorker.register("/web/service-worker.js",{scope:"/odoo"}).catch((error)=>{console.error("Service worker registration failed, error:",error);});}}}
return __exports;});;

/* /web/static/src/webclient/actions/reports/report_action.js */
odoo.define('@web/webclient/actions/reports/report_action',['@web/core/utils/hooks','@web/search/action_hook','@web/search/layout','@web/views/view','@web/webclient/actions/reports/report_hook','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{useSetupAction}=require("@web/search/action_hook");const{Layout}=require("@web/search/layout");const{getDefaultConfig}=require("@web/views/view");const{useEnrichWithActionLinks}=require("@web/webclient/actions/reports/report_hook");const{Component,useRef,useSubEnv}=require("@odoo/owl");const ReportAction=__exports.ReportAction=class ReportAction extends Component{static components={Layout};static template="web.ReportAction";static props=["*"];setup(){useSubEnv({config:{...getDefaultConfig(),...this.env.config,},});useSetupAction();this.action=useService("action");this.title=this.props.display_name||this.props.name;this.reportUrl=this.props.report_url;this.iframe=useRef("iframe");useEnrichWithActionLinks(this.iframe);}
onIframeLoaded(ev){const iframeDocument=ev.target.contentWindow.document;iframeDocument.body.classList.add("o_in_iframe","container-fluid");iframeDocument.body.classList.remove("container");}
print(){this.action.doAction({type:"ir.actions.report",report_type:"qweb-pdf",report_name:this.props.report_name,report_file:this.props.report_file,data:this.props.data||{},context:this.props.context||{},display_name:this.title,});}}
return __exports;});;

/* /web/static/src/webclient/actions/reports/report_hook.js */
odoo.define('@web/webclient/actions/reports/report_hook',['@odoo/owl'],function(require){'use strict';let __exports={};const{useComponent,useEffect}=require("@odoo/owl");__exports.useEnrichWithActionLinks=useEnrichWithActionLinks;function useEnrichWithActionLinks(ref,selector=null){const comp=useComponent();useEffect((element)=>{if(element.matches("iframe")){element.onload=()=>enrich(comp,element,selector,true);}else{enrich(comp,element,selector);}},()=>[ref.el]);}
function enrich(component,targetElement,selector,isIFrame=false){let doc=window.document;if(isIFrame){targetElement=targetElement.contentDocument;doc=targetElement;}
const targets=[];if(selector){targets.push(...targetElement.querySelectorAll(selector));}else{targets.push(targetElement);}
for(const currentTarget of targets){const elementsToWrap=currentTarget.querySelectorAll("[res-id][res-model][view-type]");for(const element of elementsToWrap.values()){const wrapper=doc.createElement("a");wrapper.setAttribute("href","#");wrapper.addEventListener("click",(ev)=>{ev.preventDefault();component.env.services.action.doAction({type:"ir.actions.act_window",view_mode:element.getAttribute("view-type"),res_id:Number(element.getAttribute("res-id")),res_model:element.getAttribute("res-model"),views:[[element.getAttribute("view-id"),element.getAttribute("view-type")]],});});element.parentNode.insertBefore(wrapper,element);wrapper.appendChild(element);}}}
return __exports;});;

/* /web/static/src/webclient/actions/reports/utils.js */
odoo.define('@web/webclient/actions/reports/utils',['@web/core/l10n/translation','@web/core/network/download'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{download}=require("@web/core/network/download");__exports.getReportUrl=getReportUrl;function getReportUrl(action,type,userContext){let url=`/report/${type}/${action.report_name}`;const actionContext=action.context||{};if(action.data&&JSON.stringify(action.data)!=="{}"){const options=encodeURIComponent(JSON.stringify(action.data));const context=encodeURIComponent(JSON.stringify(actionContext));url+=`?options=${options}&context=${context}`;}else{if(actionContext.active_ids){url+=`/${actionContext.active_ids.join(",")}`;}
if(type==="html"){const context=encodeURIComponent(JSON.stringify(userContext));url+=`?context=${context}`;}}
return url;}
function getWKHTMLTOPDF_MESSAGES(status){const link='<br><br><a href="http://wkhtmltopdf.org/" target="_blank">wkhtmltopdf.org</a>';const _status={broken:_t("Your installation of Wkhtmltopdf seems to be broken. The report will be shown in html.%(link)s",{link}),install:_t("Unable to find Wkhtmltopdf on this system. The report will be shown in html.%(link)s",{link}),upgrade:_t("You should upgrade your version of Wkhtmltopdf to at least 0.12.0 in order to get a correct display of headers and footers as well as support for table-breaking between pages.%(link)s",{link}),workers:_t("You need to start Odoo with at least two workers to print a pdf version of the reports."),};return _status[status];}
__exports.downloadReport=downloadReport;async function downloadReport(rpc,action,type,userContext){let message;if(type==="pdf"){downloadReport.wkhtmltopdfStatusProm||=rpc("/report/check_wkhtmltopdf");const status=await downloadReport.wkhtmltopdfStatusProm;message=getWKHTMLTOPDF_MESSAGES(status);if(!["upgrade","ok"].includes(status)){return{success:false,message};}}
const url=getReportUrl(action,type);await download({url:"/report/download",data:{data:JSON.stringify([url,action.report_type]),context:JSON.stringify(userContext),},});return{success:true,message};}
return __exports;});;

/* /web/static/src/libs/pdfjs.js */
odoo.define('@web/libs/pdfjs',['@web/core/browser/feature_detection','@web/core/assets'],function(require){'use strict';let __exports={};const{isMobileOS}=require("@web/core/browser/feature_detection");const{loadJS}=require("@web/core/assets");__exports.hidePDFJSButtons=hidePDFJSButtons;function hidePDFJSButtons(rootElement){const cssStyle=document.createElement("style");cssStyle.rel="stylesheet";cssStyle.textContent=`button#secondaryOpenFile.secondaryToolbarButton, button#openFile.toolbarButton,
    button#editorFreeText.toolbarButton, button#editorInk.toolbarButton, button#editorStamp.toolbarButton,
    button#secondaryOpenFile.secondaryToolbarButton,
a#secondaryViewBookmark.secondaryToolbarButton, a#viewBookmark.toolbarButton {
display: none !important;
}`;if(isMobileOS()){cssStyle.textContent=`${cssStyle.innerHTML}
button#secondaryDownload.secondaryToolbarButton, button#download.toolbarButton,
button#editorFreeText.toolbarButton, button#editorInk.toolbarButton, button#editorStamp.toolbarButton,
button#secondaryPrint.secondaryToolbarButton, button#print.toolbarButton{
display: none !important;
}`;}
const iframe=rootElement.tagName==="IFRAME"?rootElement:rootElement.querySelector("iframe");if(iframe){if(!iframe.dataset.hideButtons){iframe.dataset.hideButtons="true";iframe.addEventListener("load",(event)=>{if(iframe.contentDocument&&iframe.contentDocument.head){iframe.contentDocument.head.appendChild(cssStyle);}});}}else{console.warn("No IFRAME found");}}
__exports.loadPDFJSAssets=loadPDFJSAssets;async function loadPDFJSAssets(){return Promise.all([loadJS("/web/static/lib/pdfjs/build/pdf.js"),loadJS("/web/static/lib/pdfjs/build/pdf.worker.js"),]);}
return __exports;});;

/* /bus/static/src/bus_parameters_service.js */
odoo.define('@bus/bus_parameters_service',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const busParametersService=__exports.busParametersService={start(){return{serverURL:window.origin,};},};registry.category("services").add("bus.parameters",busParametersService);return __exports;});;

/* /bus/static/src/im_status_service.js */
odoo.define('@bus/im_status_service',['@web/core/browser/browser','@web/core/registry','@web/core/user','@web/session'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{session}=require("@web/session");const AWAY_DELAY=__exports.AWAY_DELAY=30*60*1000;const FIRST_UPDATE_DELAY=__exports.FIRST_UPDATE_DELAY=500;const UPDATE_BUS_PRESENCE_DELAY=__exports.UPDATE_BUS_PRESENCE_DELAY=60000;const imStatusService=__exports.imStatusService={dependencies:["bus_service","presence"],start(env,{bus_service,presence}){let lastSentInactivity;let becomeAwayTimeout;const updateBusPresence=()=>{lastSentInactivity=presence.getInactivityPeriod();startAwayTimeout();bus_service.send("update_presence",{inactivity_period:lastSentInactivity,im_status_ids_by_model:{},});};this.updateBusPresence=updateBusPresence;const startAwayTimeout=()=>{clearTimeout(becomeAwayTimeout);const awayTime=AWAY_DELAY-presence.getInactivityPeriod();if(awayTime>0){becomeAwayTimeout=browser.setTimeout(()=>updateBusPresence(),awayTime);}};bus_service.addEventListener("connect",()=>updateBusPresence(),{once:true});bus_service.subscribe("bus.bus/im_status_updated",async({partner_id,presence_status})=>{if(session.is_public||!partner_id||partner_id!==user.partnerId){return;}
const isOnline=presence.getInactivityPeriod()<AWAY_DELAY;if(presence_status==="offline"||(presence_status==="away"&&isOnline)){this.updateBusPresence();}});presence.bus.addEventListener("presence",()=>{if(lastSentInactivity>=AWAY_DELAY){this.updateBusPresence();}
startAwayTimeout();});return{updateBusPresence};},};registry.category("services").add("im_status",imStatusService);return __exports;});;

/* /bus/static/src/misc.js */
odoo.define('@bus/misc',['@web/core/browser/browser'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");function throttle(func,wait,options){let timeout,context,args,result;let previous=0;if(!options){options={};}
const later=function(){previous=options.leading===false?0:luxon.DateTime.now().ts;timeout=null;result=func.apply(context,args);if(!timeout){context=args=null;}};const throttled=function(){const _now=luxon.DateTime.now().ts;if(!previous&&options.leading===false){previous=_now;}
const remaining=wait-(_now-previous);context=this;args=arguments;if(remaining<=0||remaining>wait){if(timeout){browser.clearTimeout(timeout);timeout=null;}
previous=_now;result=func.apply(context,args);if(!timeout){context=args=null;}}else if(!timeout&&options.trailing!==false){timeout=browser.setTimeout(later,remaining);}
return result;};throttled.cancel=function(){browser.clearTimeout(timeout);previous=0;timeout=context=args=null;};return throttled;}
const timings=__exports.timings={throttle,};return __exports;});;

/* /bus/static/src/multi_tab_service.js */
odoo.define('@bus/multi_tab_service',['@web/core/registry','@web/core/browser/browser','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{browser}=require("@web/core/browser/browser");const{EventBus}=require("@odoo/owl");let multiTabId=0;const multiTabService=__exports.multiTabService={start(){const bus=new EventBus();const TAB_HEARTBEAT_PERIOD=10000;const MAIN_TAB_HEARTBEAT_PERIOD=1500;const HEARTBEAT_OUT_OF_DATE_PERIOD=5000;const HEARTBEAT_KILL_OLD_PERIOD=15000;const PRIVATE_LOCAL_STORAGE_KEYS=["main","heartbeat"];let _isOnMainTab=false;let lastHeartbeat=0;let heartbeatTimeout;const sanitizedOrigin=location.origin.replace(/:\/{0,2}/g,"_");const localStoragePrefix=`${this.name}.${sanitizedOrigin}.`;const now=new Date().getTime();const tabId=`${this.name}${multiTabId++}:${now}`;function generateLocalStorageKey(baseKey){return localStoragePrefix+baseKey;}
function getItemFromStorage(key,defaultValue){const item=browser.localStorage.getItem(generateLocalStorageKey(key));try{return item?JSON.parse(item):defaultValue;}catch{return item;}}
function setItemInStorage(key,value){browser.localStorage.setItem(generateLocalStorageKey(key),JSON.stringify(value));}
function startElection(){if(_isOnMainTab){return;}
const now=new Date().getTime();const lastPresenceByTab=getItemFromStorage("lastPresenceByTab",{});const heartbeatKillOld=now-HEARTBEAT_KILL_OLD_PERIOD;let newMain;for(const[tab,lastPresence]of Object.entries(lastPresenceByTab)){if(lastPresence<heartbeatKillOld){continue;}
newMain=tab;break;}
if(newMain===tabId){lastHeartbeat=now;setItemInStorage("heartbeat",lastHeartbeat);setItemInStorage("main",true);_isOnMainTab=true;bus.trigger("become_main_tab");delete lastPresenceByTab[newMain];setItemInStorage("lastPresenceByTab",lastPresenceByTab);}}
function heartbeat(){const now=new Date().getTime();let heartbeatValue=getItemFromStorage("heartbeat",0);const lastPresenceByTab=getItemFromStorage("lastPresenceByTab",{});if(heartbeatValue+HEARTBEAT_OUT_OF_DATE_PERIOD<now){startElection();heartbeatValue=getItemFromStorage("heartbeat",0);}
if(_isOnMainTab){const cleanedTabs={};for(const[tabId,lastPresence]of Object.entries(lastPresenceByTab)){if(lastPresence+HEARTBEAT_KILL_OLD_PERIOD>now){cleanedTabs[tabId]=lastPresence;}}
if(heartbeatValue!==lastHeartbeat){_isOnMainTab=false;lastHeartbeat=0;lastPresenceByTab[tabId]=now;setItemInStorage("lastPresenceByTab",lastPresenceByTab);bus.trigger("no_longer_main_tab");}else{lastHeartbeat=now;setItemInStorage("heartbeat",now);setItemInStorage("lastPresenceByTab",cleanedTabs);}}else{lastPresenceByTab[tabId]=now;setItemInStorage("lastPresenceByTab",lastPresenceByTab);}
const hbPeriod=_isOnMainTab?MAIN_TAB_HEARTBEAT_PERIOD:TAB_HEARTBEAT_PERIOD;heartbeatTimeout=browser.setTimeout(heartbeat,hbPeriod);}
function onStorage({key,newValue}){if(key===generateLocalStorageKey("main")&&!newValue){startElection();}
if(PRIVATE_LOCAL_STORAGE_KEYS.includes(key)){return;}
if(key&&key.includes(localStoragePrefix)){const baseKey=key.replace(localStoragePrefix,"");bus.trigger("shared_value_updated",{key:baseKey,newValue});}}
function unregister(){clearTimeout(heartbeatTimeout);const lastPresenceByTab=getItemFromStorage("lastPresenceByTab",{});delete lastPresenceByTab[tabId];setItemInStorage("lastPresenceByTab",lastPresenceByTab);if(_isOnMainTab){_isOnMainTab=false;bus.trigger("no_longer_main_tab");browser.localStorage.removeItem(generateLocalStorageKey("main"));}}
browser.addEventListener("pagehide",unregister);browser.addEventListener("storage",onStorage);const lastPresenceByTab=getItemFromStorage("lastPresenceByTab",{});lastPresenceByTab[tabId]=now;setItemInStorage("lastPresenceByTab",lastPresenceByTab);if(!getItemFromStorage("main")){startElection();}
heartbeat();return{bus,get currentTabId(){return tabId;},isOnMainTab(){return _isOnMainTab;},getSharedValue(key,defaultValue){return getItemFromStorage(key,defaultValue);},setSharedValue(key,value){if(value===undefined){return this.removeSharedValue(key);}
setItemInStorage(key,value);},removeSharedValue(key){browser.localStorage.removeItem(generateLocalStorageKey(key));},unregister:unregister,};},};registry.category("services").add("multi_tab",multiTabService);return __exports;});;

/* /bus/static/src/outdated_page_watcher_service.js */
odoo.define('@bus/outdated_page_watcher_service',['@web/core/browser/browser','@web/core/l10n/translation','@web/core/network/rpc','@web/core/registry'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{DateTime}=luxon;const OutdatedPageWatcherService=__exports.OutdatedPageWatcherService=class OutdatedPageWatcherService{constructor(env,services){this.setup(env,services);}
setup(env,{bus_service,multi_tab,notification}){this.notification=notification;this.multi_tab=multi_tab;this.lastNotificationId=null;this.lastDisconnectDt=null;this.closeNotificationFn;let wasBusAlreadyConnected;bus_service.addEventListener("worker_state_updated",({detail:state})=>{wasBusAlreadyConnected=state!=="IDLE";},{once:true});bus_service.addEventListener("disconnect",()=>{this.lastNotificationId=bus_service.lastNotificationId;this.lastDisconnectDt=DateTime.now();});bus_service.addEventListener("connect",async()=>{if(wasBusAlreadyConnected){this.checkHasMissedNotifications();}
wasBusAlreadyConnected=true;});bus_service.addEventListener("reconnect",()=>this.checkHasMissedNotifications());multi_tab.bus.addEventListener("shared_value_updated",({detail:{key}})=>{if(key==="bus.has_missed_notifications"){this.showOutdatedPageNotification();}});}
async checkHasMissedNotifications(){if(!this.multi_tab.isOnMainTab()){return;}
const hasMissedNotifications=await rpc("/bus/has_missed_notifications",{last_notification_id:this.lastNotificationId},{silent:true});if(hasMissedNotifications){this.showOutdatedPageNotification();this.multi_tab.setSharedValue("bus.has_missed_notifications",Date.now());}}
showOutdatedPageNotification(){this.closeNotificationFn?.();this.closeNotificationFn=this.notification.add(_t("Save your work and refresh to get the latest updates and avoid potential issues."),{title:_t("The page is out of date"),type:"warning",sticky:true,buttons:[{name:_t("Refresh"),primary:true,onClick:()=>browser.location.reload(),},],});}}
const outdatedPageWatcherService=__exports.outdatedPageWatcherService={dependencies:["bus_service","multi_tab","notification"],start(env,services){return new OutdatedPageWatcherService(env,services);},};registry.category("services").add("bus.outdated_page_watcher",outdatedPageWatcherService);return __exports;});;

/* /bus/static/src/simple_notification_service.js */
odoo.define('@bus/simple_notification_service',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const simpleNotificationService=__exports.simpleNotificationService={dependencies:["bus_service","notification"],start(env,{bus_service,notification:notificationService}){bus_service.subscribe("simple_notification",({message,sticky,title,type})=>{notificationService.add(message,{sticky,title,type});});bus_service.start();},};registry.category("services").add("simple_notification",simpleNotificationService);return __exports;});;

/* /bus/static/src/services/assets_watchdog_service.js */
odoo.define('@bus/services/assets_watchdog_service',['@web/core/l10n/translation','@web/core/browser/browser','@web/core/registry','@web/session'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{session}=require("@web/session");const assetsWatchdogService=__exports.assetsWatchdogService={dependencies:["bus_service","notification"],start(env,{bus_service,notification}){let isNotificationDisplayed=false;let bundleNotifTimerID=null;bus_service.subscribe("bundle_changed",({server_version})=>{if(server_version!==session.server_version){displayBundleChangedNotification();}});bus_service.start();function displayBundleChangedNotification(){if(!isNotificationDisplayed){browser.clearTimeout(bundleNotifTimerID);bundleNotifTimerID=browser.setTimeout(()=>{notification.add(_t("The page appears to be out of date."),{title:_t("Refresh"),type:"warning",sticky:true,buttons:[{name:_t("Refresh"),primary:true,onClick:()=>{browser.location.reload();},},],onClose:()=>{isNotificationDisplayed=false;},});isNotificationDisplayed=true;},getBundleNotificationDelay());}}
function getBundleNotificationDelay(){return 10000+Math.floor(Math.random()*50)*1000;}},};registry.category("services").add("assetsWatchdog",assetsWatchdogService);return __exports;});;

/* /bus/static/src/services/bus_monitoring_service.js */
odoo.define('@bus/services/bus_monitoring_service',['@bus/workers/websocket_worker','@odoo/owl','@web/core/browser/browser','@web/core/registry'],function(require){'use strict';let __exports={};const{WORKER_STATE}=require("@bus/workers/websocket_worker");const{reactive}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const BusMonitoringService=__exports.BusMonitoringService=class BusMonitoringService{isConnectionLost=false;constructor(env,services){const reactiveThis=reactive(this);reactiveThis.setup(env,services);return reactiveThis;}
setup(env,{bus_service}){bus_service.addEventListener("worker_state_updated",({detail})=>this.workerStateOnChange(detail));browser.addEventListener("offline",()=>(this.isReconnecting=false));}
workerStateOnChange(state){if(!navigator.onLine){return;}
switch(state){case WORKER_STATE.CONNECTING:{this.isReconnecting=true;break;}
case WORKER_STATE.CONNECTED:{this.isReconnecting=false;this.isConnectionLost=false;break;}
case WORKER_STATE.DISCONNECTED:{if(this.isReconnecting){this.isConnectionLost=true;this.isReconnecting=false;}
break;}}}}
const busMonitoringservice=__exports.busMonitoringservice={dependencies:["bus_service"],start(env,services){return new BusMonitoringService(env,services);},};registry.category("services").add("bus.monitoring_service",busMonitoringservice);return __exports;});;

/* /bus/static/src/services/bus_service.js */
odoo.define('@bus/services/bus_service',['@web/core/browser/browser','@web/core/l10n/translation','@web/core/utils/concurrency','@web/core/registry','@web/session','@web/core/browser/feature_detection','@odoo/owl','@web/core/user'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const{Deferred}=require("@web/core/utils/concurrency");const{registry}=require("@web/core/registry");const{session}=require("@web/session");const{isIosApp}=require("@web/core/browser/feature_detection");const{EventBus}=require("@odoo/owl");const{user}=require("@web/core/user");const INTERNAL_EVENTS=new Set(["initialized","outdated","log_debug","notification"]);const BACK_ONLINE_RECONNECT_DELAY=__exports.BACK_ONLINE_RECONNECT_DELAY=5000;const busService=__exports.busService={dependencies:["bus.parameters","localization","multi_tab","notification"],start(env,{multi_tab:multiTab,notification,"bus.parameters":params}){const bus=new EventBus();const notificationBus=new EventBus();const subscribeFnToWrapper=new Map();let worker;let workerState;let isActive=false;let isInitialized=false;let lastNotificationId=null;let isUsingSharedWorker=browser.SharedWorker&&!isIosApp();let backOnlineTimeout;const startedAt=luxon.DateTime.now().set({milliseconds:0});const connectionInitializedDeferred=new Deferred();function send(action,data){if(!worker){return;}
const message={action,data};if(isUsingSharedWorker){worker.port.postMessage(message);}else{worker.postMessage(message);}}
function handleMessage(messageEv){const{type,data}=messageEv.data;switch(type){case"notification":{const notifications=data.map(({id,message})=>({id,...message}));lastNotificationId=notifications.at(-1).id;multiTab.setSharedValue("last_notification_id",lastNotificationId);for(const{id,type,payload}of notifications){notificationBus.trigger(type,{id,payload});busService._onMessage(id,type,payload);}
break;}
case"initialized":{isInitialized=true;connectionInitializedDeferred.resolve();break;}
case"worker_state_updated":workerState=data;break;case"log_debug":console.debug(...data);break;case"outdated":{multiTab.unregister();notification.add(_t("Save your work and refresh to get the latest updates and avoid potential issues."),{title:_t("The page is out of date"),type:"warning",sticky:true,buttons:[{name:_t("Refresh"),primary:true,onClick:()=>{browser.location.reload();},},],});break;}}
if(!INTERNAL_EVENTS.has(type)){bus.trigger(type,data);}}
function initializeWorkerConnection(){let uid=Array.isArray(session.user_id)?session.user_id[0]:user.userId;if(!uid&&uid!==undefined){uid=false;}
send("initialize_connection",{websocketURL:`${params.serverURL.replace("http", "ws")}/websocket?version=${
                    session.websocket_worker_version
                }`,db:session.db,debug:odoo.debug,lastNotificationId:multiTab.getSharedValue("last_notification_id",0),uid,startTs:startedAt.valueOf(),});}
function startWorker(){let workerURL=`${params.serverURL}/bus/websocket_worker_bundle?v=${session.websocket_worker_version}`;if(params.serverURL!==window.origin){const source=`importScripts("${workerURL}");`;workerURL="data:application/javascript;base64,"+window.btoa(source);}
const workerClass=isUsingSharedWorker?browser.SharedWorker:browser.Worker;worker=new workerClass(workerURL,{name:isUsingSharedWorker?"odoo:websocket_shared_worker":"odoo:websocket_worker",});worker.addEventListener("error",(e)=>{if(!isInitialized&&workerClass===browser.SharedWorker){console.warn('Error while loading "bus_service" SharedWorker, fallback on Worker.');isUsingSharedWorker=false;startWorker();}else if(!isInitialized){isInitialized=true;connectionInitializedDeferred.resolve();console.warn("Bus service failed to initialized.");}});if(isUsingSharedWorker){worker.port.start();worker.port.addEventListener("message",handleMessage);}else{worker.addEventListener("message",handleMessage);}
initializeWorkerConnection();}
browser.addEventListener("pagehide",({persisted})=>{if(!persisted){send("leave");}});browser.addEventListener("online",()=>{backOnlineTimeout=browser.setTimeout(()=>{if(isActive){send("start");}},BACK_ONLINE_RECONNECT_DELAY);},{capture:true});browser.addEventListener("offline",()=>{clearTimeout(backOnlineTimeout);send("stop");},{capture:true,});return{addEventListener:bus.addEventListener.bind(bus),addChannel:async(channel)=>{if(!worker){startWorker();}
await connectionInitializedDeferred;send("add_channel",channel);send("start");isActive=true;},deleteChannel:(channel)=>send("delete_channel",channel),forceUpdateChannels:()=>send("force_update_channels"),trigger:bus.trigger.bind(bus),removeEventListener:bus.removeEventListener.bind(bus),send:(eventName,data)=>send("send",{event_name:eventName,data}),start:async()=>{if(!worker){startWorker();}
await connectionInitializedDeferred;send("start");isActive=true;},stop:()=>{send("leave");isActive=false;},get isActive(){return isActive;},subscribe(notificationType,callback){const wrapper=({detail})=>{const{id,payload}=detail;callback(payload,{id});};subscribeFnToWrapper.set(callback,wrapper);notificationBus.addEventListener(notificationType,wrapper);},unsubscribe(notificationType,callback){notificationBus.removeEventListener(notificationType,subscribeFnToWrapper.get(callback));subscribeFnToWrapper.delete(callback);},startedAt,get workerState(){return workerState;},get lastNotificationId(){return lastNotificationId;},};},_onMessage(id,type,payload){},};registry.category("services").add("bus_service",busService);return __exports;});;

/* /bus/static/src/services/presence_service.js */
odoo.define('@bus/services/presence_service',['@odoo/owl','@web/core/browser/browser','@web/core/registry'],function(require){'use strict';let __exports={};const{EventBus}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const presenceService=__exports.presenceService={start(env){const LOCAL_STORAGE_PREFIX="presence";const bus=new EventBus();let isOdooFocused=true;let lastPresenceTime=browser.localStorage.getItem(`${LOCAL_STORAGE_PREFIX}.lastPresence`)||luxon.DateTime.now().ts;function onPresence(){lastPresenceTime=luxon.DateTime.now().ts;browser.localStorage.setItem(`${LOCAL_STORAGE_PREFIX}.lastPresence`,lastPresenceTime);bus.trigger("presence");}
function onFocusChange(isFocused){try{isFocused=parent.document.hasFocus();}catch{}
isOdooFocused=isFocused;browser.localStorage.setItem(`${LOCAL_STORAGE_PREFIX}.focus`,isOdooFocused);if(isOdooFocused){lastPresenceTime=luxon.DateTime.now().ts;env.bus.trigger("window_focus",isOdooFocused);}}
function onStorage({key,newValue}){if(key===`${LOCAL_STORAGE_PREFIX}.focus`){isOdooFocused=JSON.parse(newValue);env.bus.trigger("window_focus",newValue);}
if(key===`${LOCAL_STORAGE_PREFIX}.lastPresence`){lastPresenceTime=JSON.parse(newValue);bus.trigger("presence");}}
browser.addEventListener("storage",onStorage);browser.addEventListener("focus",()=>onFocusChange(true));browser.addEventListener("blur",()=>onFocusChange(false));browser.addEventListener("pagehide",()=>onFocusChange(false));browser.addEventListener("click",onPresence);browser.addEventListener("keydown",onPresence);return{bus,getLastPresence(){return lastPresenceTime;},isOdooFocused(){return isOdooFocused;},getInactivityPeriod(){return luxon.DateTime.now().ts-this.getLastPresence();},};},};registry.category("services").add("presence",presenceService);return __exports;});;

/* /bus/static/src/workers/websocket_worker.js */
odoo.define('@bus/workers/websocket_worker',['@bus/workers/websocket_worker_utils'],function(require){'use strict';let __exports={};const{debounce,Deferred}=require("@bus/workers/websocket_worker_utils");const WEBSOCKET_CLOSE_CODES=__exports.WEBSOCKET_CLOSE_CODES=Object.freeze({CLEAN:1000,GOING_AWAY:1001,PROTOCOL_ERROR:1002,INCORRECT_DATA:1003,ABNORMAL_CLOSURE:1006,INCONSISTENT_DATA:1007,MESSAGE_VIOLATING_POLICY:1008,MESSAGE_TOO_BIG:1009,EXTENSION_NEGOTIATION_FAILED:1010,SERVER_ERROR:1011,RESTART:1012,TRY_LATER:1013,BAD_GATEWAY:1014,SESSION_EXPIRED:4001,KEEP_ALIVE_TIMEOUT:4002,RECONNECTING:4003,});const WORKER_STATE=__exports.WORKER_STATE=Object.freeze({CONNECTED:"CONNECTED",DISCONNECTED:"DISCONNECTED",IDLE:"IDLE",CONNECTING:"CONNECTING",});const MAXIMUM_RECONNECT_DELAY=60000;const WebsocketWorker=__exports.WebsocketWorker=class WebsocketWorker{INITIAL_RECONNECT_DELAY=1000;RECONNECT_JITTER=1000;constructor(){this.newestStartTs=undefined;this.websocketURL="";this.currentUID=null;this.currentDB=null;this.isWaitingForNewUID=true;this.channelsByClient=new Map();this.connectRetryDelay=this.INITIAL_RECONNECT_DELAY;this.connectTimeout=null;this.debugModeByClient=new Map();this.isDebug=false;this.active=true;this.state=WORKER_STATE.IDLE;this.isReconnecting=false;this.lastChannelSubscription=null;this.firstSubscribeDeferred=new Deferred();this.lastNotificationId=0;this.messageWaitQueue=[];this._forceUpdateChannels=debounce(this._forceUpdateChannels,300);this._debouncedUpdateChannels=debounce(this._updateChannels,300);this._debouncedSendToServer=debounce(this._sendToServer,300);this._onWebsocketClose=this._onWebsocketClose.bind(this);this._onWebsocketError=this._onWebsocketError.bind(this);this._onWebsocketMessage=this._onWebsocketMessage.bind(this);this._onWebsocketOpen=this._onWebsocketOpen.bind(this);}
broadcast(type,data){this._logDebug("broadcast",type,data);for(const client of this.channelsByClient.keys()){client.postMessage({type,data:data?JSON.parse(JSON.stringify(data)):undefined});}}
registerClient(messagePort){messagePort.onmessage=(ev)=>{this._onClientMessage(messagePort,ev.data);};this.channelsByClient.set(messagePort,[]);}
sendToClient(client,type,data){this._logDebug("sendToClient",type,data);client.postMessage({type,data:data?JSON.parse(JSON.stringify(data)):undefined});}
_onClientMessage(client,{action,data}){this._logDebug("_onClientMessage",action,data);switch(action){case"send":{if(data["event_name"]==="update_presence"){this._debouncedSendToServer(data);}else{this._sendToServer(data);}
return;}
case"start":return this._start();case"stop":return this._stop();case"leave":return this._unregisterClient(client);case"add_channel":return this._addChannel(client,data);case"delete_channel":return this._deleteChannel(client,data);case"force_update_channels":return this._forceUpdateChannels();case"initialize_connection":return this._initializeConnection(client,data);}}
_addChannel(client,channel){const clientChannels=this.channelsByClient.get(client);if(!clientChannels.includes(channel)){clientChannels.push(channel);this.channelsByClient.set(client,clientChannels);this._debouncedUpdateChannels();}}
_deleteChannel(client,channel){const clientChannels=this.channelsByClient.get(client);if(!clientChannels){return;}
const channelIndex=clientChannels.indexOf(channel);if(channelIndex!==-1){clientChannels.splice(channelIndex,1);this._debouncedUpdateChannels();}}
_forceUpdateChannels(){this._updateChannels({force:true});}
_unregisterClient(client){this.channelsByClient.delete(client);this.debugModeByClient.delete(client);this.isDebug=[...this.debugModeByClient.values()].some(Boolean);this._debouncedUpdateChannels();}
_initializeConnection(client,{db,debug,lastNotificationId,uid,websocketURL,startTs}){if(this.newestStartTs&&this.newestStartTs>startTs){this.debugModeByClient.set(client,debug);this.isDebug=[...this.debugModeByClient.values()].some(Boolean);this.sendToClient(client,"worker_state_updated",this.state);this.sendToClient(client,"initialized");return;}
this.newestStartTs=startTs;this.websocketURL=websocketURL;this.lastNotificationId=lastNotificationId;this.debugModeByClient.set(client,debug);this.isDebug=[...this.debugModeByClient.values()].some(Boolean);const isCurrentUserKnown=uid!==undefined;if(this.isWaitingForNewUID&&isCurrentUserKnown){this.isWaitingForNewUID=false;this.currentUID=uid;}
if((this.currentUID!==uid&&isCurrentUserKnown)||this.currentDB!==db){this.currentUID=uid;this.currentDB=db;if(this.websocket){this.websocket.close(WEBSOCKET_CLOSE_CODES.CLEAN);}
this.channelsByClient.forEach((_,key)=>this.channelsByClient.set(key,[]));}
this.sendToClient(client,"worker_state_updated",this.state);this.sendToClient(client,"initialized");if(!this.active){this.sendToClient(client,"outdated");}}
_isWebsocketConnected(){return this.websocket&&this.websocket.readyState===1;}
_isWebsocketConnecting(){return this.websocket&&this.websocket.readyState===0;}
_isWebsocketClosing(){return this.websocket&&this.websocket.readyState===2;}
_onWebsocketClose({code,reason}){this._logDebug("_onWebsocketClose",code,reason);this._updateState(WORKER_STATE.DISCONNECTED);this.lastChannelSubscription=null;this.firstSubscribeDeferred=new Deferred();if(this.isReconnecting){return;}
this.broadcast("disconnect",{code,reason});if(code===WEBSOCKET_CLOSE_CODES.CLEAN){if(reason==="OUTDATED_VERSION"){console.warn("Worker deactivated due to an outdated version.");this.active=false;this.broadcast("outdated");}
return;}
this.broadcast("reconnecting",{closeCode:code});this.isReconnecting=true;if(code===WEBSOCKET_CLOSE_CODES.KEEP_ALIVE_TIMEOUT){this.connectRetryDelay=0;}
if(code===WEBSOCKET_CLOSE_CODES.SESSION_EXPIRED){this.isWaitingForNewUID=true;}
this._retryConnectionWithDelay();}
_onWebsocketError(){this._logDebug("_onWebsocketError");this._retryConnectionWithDelay();}
_onWebsocketMessage(messageEv){const notifications=JSON.parse(messageEv.data);this._logDebug("_onWebsocketMessage",notifications);this.lastNotificationId=notifications[notifications.length-1].id;this.broadcast("notification",notifications);}
_logDebug(title,...args){const clientsInDebug=[...this.debugModeByClient.keys()].filter((client)=>this.debugModeByClient.get(client));for(const client of clientsInDebug){client.postMessage({type:"log_debug",data:[`%c${new Date().toLocaleString()} - [${title}]`,"color: #c6e; font-weight: bold;",...args,],});}}
_onWebsocketOpen(){this._logDebug("_onWebsocketOpen");this._updateState(WORKER_STATE.CONNECTED);this.broadcast(this.isReconnecting?"reconnect":"connect");this._debouncedUpdateChannels();this.connectRetryDelay=this.INITIAL_RECONNECT_DELAY;this.connectTimeout=null;this.isReconnecting=false;this.firstSubscribeDeferred.then(()=>{this.messageWaitQueue.forEach((msg)=>this.websocket.send(msg));this.messageWaitQueue=[];});}
_retryConnectionWithDelay(){this.connectRetryDelay=Math.min(this.connectRetryDelay*1.5,MAXIMUM_RECONNECT_DELAY)+
this.RECONNECT_JITTER*Math.random();this._logDebug("_retryConnectionWithDelay",this.connectRetryDelay);this.connectTimeout=setTimeout(this._start.bind(this),this.connectRetryDelay);}
_sendToServer(message){this._logDebug("_sendToServer",message);const payload=JSON.stringify(message);if(!this._isWebsocketConnected()){if(message["event_name"]==="subscribe"){this.messageWaitQueue=this.messageWaitQueue.filter((msg)=>JSON.parse(msg).event_name!=="subscribe");this.messageWaitQueue.unshift(payload);}else{this.messageWaitQueue.push(payload);}}else{if(message["event_name"]==="subscribe"){this.websocket.send(payload);}else{this.firstSubscribeDeferred.then(()=>this.websocket.send(payload));}}}
_removeWebsocketListeners(){this.websocket?.removeEventListener("open",this._onWebsocketOpen);this.websocket?.removeEventListener("message",this._onWebsocketMessage);this.websocket?.removeEventListener("error",this._onWebsocketError);this.websocket?.removeEventListener("close",this._onWebsocketClose);}
_start(){this._logDebug("_start");if(!this.active||this._isWebsocketConnected()||this._isWebsocketConnecting()){return;}
this._removeWebsocketListeners();if(this._isWebsocketClosing()){this.lastChannelSubscription=null;this.broadcast("disconnect",{code:WEBSOCKET_CLOSE_CODES.ABNORMAL_CLOSURE});}
this._updateState(WORKER_STATE.CONNECTING);this.websocket=new WebSocket(this.websocketURL);this.websocket.addEventListener("open",this._onWebsocketOpen);this.websocket.addEventListener("error",this._onWebsocketError);this.websocket.addEventListener("message",this._onWebsocketMessage);this.websocket.addEventListener("close",this._onWebsocketClose);}
_stop(){this._logDebug("_stop");clearTimeout(this.connectTimeout);this.connectRetryDelay=this.INITIAL_RECONNECT_DELAY;this.isReconnecting=false;this.lastChannelSubscription=null;this.websocket?.close();this._removeWebsocketListeners();}
_updateChannels({force=false}={}){const allTabsChannels=[...new Set([].concat.apply([],[...this.channelsByClient.values()])),].sort();const allTabsChannelsString=JSON.stringify(allTabsChannels);const shouldUpdateChannelSubscription=allTabsChannelsString!==this.lastChannelSubscription;if(force||shouldUpdateChannelSubscription){this.lastChannelSubscription=allTabsChannelsString;this._sendToServer({event_name:"subscribe",data:{channels:allTabsChannels,last:this.lastNotificationId},});this.firstSubscribeDeferred.resolve();}}
_updateState(newState){this.state=newState;this.broadcast("worker_state_updated",newState);}}
return __exports;});;

/* /bus/static/src/workers/websocket_worker_utils.js */
odoo.define('@bus/workers/websocket_worker_utils',[],function(require){'use strict';let __exports={};__exports.debounce=debounce;function debounce(func,wait,immediate){let timeout;return function(){const context=this;const args=arguments;function later(){timeout=null;if(!immediate){func.apply(context,args);}}
const callNow=immediate&&!timeout;clearTimeout(timeout);timeout=setTimeout(later,wait);if(callNow){func.apply(context,args);}};}
const Deferred=__exports.Deferred=class Deferred extends Promise{constructor(){let resolve;let reject;const prom=new Promise((res,rej)=>{resolve=res;reject=rej;});return Object.assign(prom,{resolve,reject});}}
return __exports;});;

/* /web_tour/static/src/tour_pointer/tour_pointer.js */
odoo.define('@web_tour/tour_pointer/tour_pointer',['@odoo/owl','@web/core/position/position_hook'],function(require){'use strict';let __exports={};const{Component,useEffect,useRef}=require("@odoo/owl");const{usePosition}=require("@web/core/position/position_hook");const TourPointer=__exports.TourPointer=class TourPointer extends Component{static props={pointerState:{type:Object,shape:{anchor:{type:HTMLElement,optional:true},content:{type:String,optional:true},isOpen:{type:Boolean,optional:true},isVisible:{type:Boolean,optional:true},isZone:{type:Boolean,optional:true},onClick:{type:[Function,{value:null}],optional:true},onMouseEnter:{type:[Function,{value:null}],optional:true},onMouseLeave:{type:[Function,{value:null}],optional:true},position:{type:[{value:"left"},{value:"right"},{value:"top"},{value:"bottom"},],optional:true,},rev:{type:Number,optional:true},},},bounce:{type:Boolean,optional:true},};static defaultProps={bounce:true,};static template="web_tour.TourPointer";static width=28;static height=28;setup(){const positionOptions={margin:6,onPositioned:(pointer,position)=>{const popperRect=pointer.getBoundingClientRect();const{top,left,direction}=position;if(direction==="top"){pointer.style.bottom=`${window.innerHeight - top - popperRect.height}px`;pointer.style.removeProperty("top");}else if(direction==="left"){pointer.style.right=`${window.innerWidth - left - popperRect.width}px`;pointer.style.removeProperty("left");}},};Object.defineProperty(positionOptions,"position",{get:()=>this.position,enumerable:true,});const position=usePosition("pointer",()=>this.props.pointerState.anchor,positionOptions);const rootRef=useRef("pointer");const zoneRef=useRef("zone");let dimensions=null;let lastMeasuredContent=null;let lastOpenState=this.isOpen;let lastAnchor;let[anchorX,anchorY]=[0,0];useEffect(()=>{const{el:pointer}=rootRef;const{el:zone}=zoneRef;if(pointer){const hasContentChanged=lastMeasuredContent!==this.content;const hasOpenStateChanged=lastOpenState!==this.isOpen;lastOpenState=this.isOpen;if(this.props.pointerState.isZone){const{anchor}=this.props.pointerState;let offsetLeft=0;let offsetTop=0;if(document!==anchor.ownerDocument){const iframe=[...document.querySelectorAll("iframe")].filter((e)=>e.contentDocument===anchor.ownerDocument)[0];offsetLeft=iframe.getBoundingClientRect().left;offsetTop=iframe.getBoundingClientRect().top;}
const{left,top,width,height}=anchor.getBoundingClientRect();zone.style.minWidth=width+"px";zone.style.minHeight=height+"px";zone.style.left=left+offsetLeft+"px";zone.style.top=top+offsetTop+"px";}
if(hasContentChanged){lastMeasuredContent=this.content;pointer.style.removeProperty("width");pointer.style.removeProperty("height");dimensions=pointer.getBoundingClientRect();}
if(hasContentChanged||hasOpenStateChanged){const[width,height]=this.isOpen?[dimensions.width,dimensions.height]:[this.constructor.width,this.constructor.height];if(this.isOpen){pointer.style.removeProperty("transition");}else{pointer.style.setProperty("transition","none");}
pointer.style.setProperty("width",`${width}px`);pointer.style.setProperty("height",`${height}px`);}
if(!this.isOpen){const{anchor}=this.props.pointerState;if(anchor===lastAnchor){const{x,y,width}=anchor.getBoundingClientRect();const[lastAnchorX,lastAnchorY]=[anchorX,anchorY];[anchorX,anchorY]=[x,y];const delta=Math.sqrt(Math.pow(x-lastAnchorX,2)+Math.pow(y-lastAnchorY,2));if(delta<1){position.lock();return;}
const wouldOverflow=window.innerWidth-x-width/2<dimensions?.width;pointer.classList.toggle("o_expand_left",wouldOverflow);}
lastAnchor=anchor;pointer.style.bottom="";pointer.style.right="";position.unlock();}}else{lastMeasuredContent=null;lastOpenState=false;lastAnchor=null;dimensions=null;}});}
get content(){return this.props.pointerState.content||"";}
get isOpen(){return this.props.pointerState.isOpen&&this.content;}
get position(){return this.props.pointerState.position||"top";}}
return __exports;});;

/* /web_tour/static/src/tour_service/tour_automatic.js */
odoo.define('@web_tour/tour_service/tour_automatic',['@web_tour/tour_service/tour_state','@web/core/transition','@web_tour/tour_service/tour_step_automatic','@web/core/macro','@web/core/browser/browser','@web/../lib/hoot-dom/helpers/events','@odoo/hoot-dom'],function(require){'use strict';let __exports={};const{tourState}=require("@web_tour/tour_service/tour_state");const{config:transitionConfig}=require("@web/core/transition");const{TourStepAutomatic}=require("@web_tour/tour_service/tour_step_automatic");const{Macro}=require("@web/core/macro");const{browser}=require("@web/core/browser/browser");const{setupEventActions}=require("@web/../lib/hoot-dom/helpers/events");const hoot=require("@odoo/hoot-dom");const TourAutomatic=__exports.TourAutomatic=class TourAutomatic{mode="auto";constructor(data){Object.assign(this,data);this.steps=this.steps.map((step,index)=>new TourStepAutomatic(step,this,index));this.config=tourState.getCurrentConfig()||{};}
get currentIndex(){return tourState.getCurrentIndex();}
get currentStep(){return this.steps[this.currentIndex];}
get debugMode(){return this.config.debug!==false;}
start(){setupEventActions(document.createElement("div"),{allowSubmit:true});const{delayToCheckUndeterminisms,stepDelay}=this.config;const macroSteps=this.steps.filter((step)=>step.index>=this.currentIndex).flatMap((step)=>[{action:async()=>{if(this.debugMode){console.groupCollapsed(step.describeMe);console.log(step.stringify);if(step.break){debugger;}}else{console.log(step.describeMe);}
await new Promise((resolve)=>requestAnimationFrame(resolve));if(stepDelay>0){await hoot.delay(stepDelay);}},},{trigger:step.trigger?()=>step.findTrigger():null,timeout:step.pause&&this.debugMode?9999999:step.timeout||this.timeout||10000,action:async(trigger)=>{if(delayToCheckUndeterminisms>0){await step.checkForUndeterminisms(trigger,delayToCheckUndeterminisms);}
const result=await step.doAction();if(this.debugMode){console.log(trigger);if(step.skipped){console.log("This step has been skipped");}else{console.log("This step has run successfully");}
console.groupEnd();if(step.pause){await this.pause();}}
tourState.setCurrentIndex(step.index+1);return result;},},]);const end=()=>{delete window.hoot;transitionConfig.disabled=false;tourState.clear();window.addEventListener("error",(ev)=>{ev.preventDefault();ev.stopImmediatePropagation();},true);window.addEventListener("unhandledrejection",(ev)=>{ev.preventDefault();ev.stopImmediatePropagation();},true);};this.macro=new Macro({name:this.name,steps:macroSteps,onError:(error)=>{if(error.type==="Timeout"){this.throwError(...this.currentStep.describeWhyIFailed,error.message);}else{this.throwError(error.message);}
end();},onComplete:()=>{browser.console.log("tour succeeded");const succeeded=`║ TOUR ${this.name} SUCCEEDED ║`;const msg=[succeeded];msg.unshift("╔"+"═".repeat(succeeded.length-2)+"╗");msg.push("╚"+"═".repeat(succeeded.length-2)+"╝");browser.console.log(`\n\n${msg.join("\n")}\n`);end();},});if(this.debugMode&&this.currentIndex===0){debugger;}
transitionConfig.disabled=true;window.hoot=hoot;this.macro.start();}
get describeWhereIFailed(){const offset=3;const start=Math.max(this.currentIndex-offset,0);const end=Math.min(this.currentIndex+offset,this.steps.length-1);const result=[];for(let i=start;i<=end;i++){const step=this.steps[i];const stepString=step.stringify;const text=[stepString];if(i===this.currentIndex){const line="-".repeat(10);const failing_step=`${line} FAILED: ${step.describeMe} ${line}`;text.unshift(failing_step);text.push("-".repeat(failing_step.length));}
result.push(...text);}
return result.join("\n");}
throwError(...args){console.groupEnd();tourState.setCurrentTourOnError();browser.console.error([`FAILED: ${this.currentStep.describeMe}.`,...args].join("\n"));browser.console.dir(this.describeWhereIFailed);if(this.debugMode){debugger;}}
async pause(){const styles=["background: black; color: white; font-size: 14px","background: black; color: orange; font-size: 14px",];console.log(`%cTour is paused. Use %cplay()%c to continue.`,styles[0],styles[1],styles[0]);await new Promise((resolve)=>{window.play=()=>{resolve();delete window.play;};});}}
return __exports;});;

/* /web_tour/static/src/tour_service/tour_helpers.js */
odoo.define('@web_tour/tour_service/tour_helpers',['@odoo/hoot-dom','@web/core/macro'],function(require){'use strict';let __exports={};const hoot=require("@odoo/hoot-dom");const{waitForStable}=require("@web/core/macro");const TourHelpers=__exports.TourHelpers=class TourHelpers{constructor(anchor){this.anchor=anchor;this.delay=20;}
async check(selector){const element=this._get_action_element(selector);await hoot.check(element);}
async clear(selector){const element=this._get_action_element(selector);await hoot.click(element);await hoot.clear();}
async click(selector){const element=this._get_action_element(selector);await hoot.click(element);}
async dblclick(selector){const element=this._get_action_element(selector);await hoot.dblclick(element);}
async drag_and_drop(selector,options){if(typeof options!=="object"){options={position:"top",relative:true};}
const dragEffectDelay=async()=>{await new Promise((resolve)=>requestAnimationFrame(resolve));await new Promise((resolve)=>setTimeout(resolve,this.delay));};const element=this.anchor;const{drop,moveTo}=await hoot.drag(element);await dragEffectDelay();await hoot.hover(element,{position:{top:20,left:20,},relative:true,});await dragEffectDelay();const target=await hoot.waitFor(selector,{visible:true,timeout:1000,});await moveTo(target,options);await dragEffectDelay();await drop();await dragEffectDelay();}
async edit(text,selector){const element=this._get_action_element(selector);await hoot.click(element);await hoot.edit(text);}
async editor(text,selector){const element=this._get_action_element(selector);const InEditor=Boolean(element.closest(".odoo-editor-editable"));if(!InEditor){throw new Error("run 'editor' always on an element in an editor");}
await hoot.click(element);this._set_range(element,"start");await hoot.keyDown("_");element.textContent=text;await hoot.manuallyDispatchProgrammaticEvent(element,"input");this._set_range(element,"stop");await hoot.keyUp("_");await hoot.manuallyDispatchProgrammaticEvent(element,"change");}
async fill(value,selector){const element=this._get_action_element(selector);await hoot.click(element);await hoot.fill(value);}
async hover(selector){const element=this._get_action_element(selector);await hoot.hover(element);}
async range(value,selector){const element=this._get_action_element(selector);await hoot.click(element);await hoot.setInputRange(element,value);}
async press(...args){await hoot.press(args.flatMap((arg)=>typeof arg==="string"&&arg.split("+")));}
async select(value,selector){const element=this._get_action_element(selector);await hoot.click(element);await hoot.select(value,{target:element});}
async selectByIndex(index,selector){const element=this._get_action_element(selector);await hoot.click(element);const value=hoot.queryValue(`option:eq(${index})`,{root:element});if(value){await hoot.select(value,{target:element});await hoot.manuallyDispatchProgrammaticEvent(element,"input");}}
async selectByLabel(contains,selector){const element=this._get_action_element(selector);await hoot.click(element);const values=hoot.queryAllValues(`option:contains(${contains})`,{root:element});await hoot.select(values,{target:element});}
async uncheck(selector){const element=this._get_action_element(selector);await hoot.uncheck(element);}
async goToUrl(url){const linkEl=document.createElement("a");linkEl.href=url;await waitForStable();await hoot.click(linkEl);}
_get_action_element(selector){if(typeof selector==="string"&&selector.length){const nodes=hoot.queryAll(selector);return nodes.find(hoot.isVisible)||nodes.at(0);}else if(typeof selector==="object"&&Boolean(selector?.nodeType)){return selector;}
return this.anchor;}
_set_range(element,start_or_stop){function _node_length(node){if(node.nodeType===Node.TEXT_NODE){return node.nodeValue.length;}else{return node.childNodes.length;}}
const selection=element.ownerDocument.getSelection();selection.removeAllRanges();const range=new Range();let node=element;let length=0;if(start_or_stop==="start"){while(node.firstChild){node=node.firstChild;}}else{while(node.lastChild){node=node.lastChild;}
length=_node_length(node);}
range.setStart(node,length);range.setEnd(node,length);selection.addRange(range);}}
return __exports;});;

/* /web_tour/static/src/tour_service/tour_interactive.js */
odoo.define('@web_tour/tour_service/tour_interactive',['@web_tour/tour_service/tour_state','@web/core/utils/timing','@web_tour/tour_service/tour_utils','@odoo/hoot-dom','@web/core/ui/ui_service','@web_tour/tour_service/tour_step','@web/core/macro'],function(require){'use strict';let __exports={};const{tourState}=require("@web_tour/tour_service/tour_state");const{debounce}=require("@web/core/utils/timing");const{getScrollParent}=require("@web_tour/tour_service/tour_utils");const hoot=require("@odoo/hoot-dom");const{utils}=require("@web/core/ui/ui_service");const{TourStep}=require("@web_tour/tour_service/tour_step");const{MacroMutationObserver}=require("@web/core/macro");const TourInteractive=__exports.TourInteractive=class TourInteractive{mode="manual";currentAction;currentActionIndex;anchorEls=[];removeListeners=()=>{};constructor(data){Object.assign(this,data);this.steps=this.steps.map((step)=>new TourStep(step,this));this.actions=this.steps.flatMap((s)=>this.getSubActions(s));}
start(pointer,onTourEnd){this.pointer=pointer;this.debouncedToggleOpen=debounce(this.pointer.showContent,50,true);this.onTourEnd=onTourEnd;this.observer=new MacroMutationObserver(()=>this._onMutation());this.observer.observe(document.body);this.currentActionIndex=tourState.getCurrentIndex();this.play();}
backward(){let tempIndex=this.currentActionIndex;let tempAction,tempAnchors=[];while(!tempAnchors.length&&tempIndex>=0){tempIndex--;tempAction=this.actions.at(tempIndex);if(!tempAction.step.active){continue;}
tempAnchors=tempAction&&this.findTriggers(tempAction.anchor);}
if(tempIndex>=0){this.currentActionIndex=tempIndex;this.play();}}
findTriggers(anchor){if(!anchor){anchor=this.currentAction.anchor;}
return anchor.split(/,\s*(?![^(]*\))/).map((part)=>hoot.queryFirst(part,{visible:true})).filter((el)=>!!el).map((el)=>this.getAnchorEl(el,this.currentAction.event)).filter((el)=>!!el);}
play(){this.removeListeners();if(this.currentActionIndex===this.actions.length){this.observer.disconnect();this.onTourEnd();return;}
this.currentAction=this.actions.at(this.currentActionIndex);if(!this.currentAction.step.active||this.currentAction.event==="warn"){if(this.currentAction.event==="warn"){console.warn(`Step '${this.currentAction.anchor}' ignored.`);}
this.currentActionIndex++;this.play();return;}
console.log(this.currentAction.event,this.currentAction.anchor);tourState.setCurrentIndex(this.currentActionIndex);this.anchorEls=this.findTriggers();this.setActionListeners();this.updatePointer();}
updatePointer(){if(this.anchorEls.length){this.pointer.pointTo(this.anchorEls[0],this.currentAction.pointerInfo,this.currentAction.event==="drop");this.pointer.setState({onMouseEnter:()=>this.debouncedToggleOpen(true),onMouseLeave:()=>this.debouncedToggleOpen(false),});}}
setActionListeners(){const cleanups=this.anchorEls.flatMap((anchorEl,index)=>{const toListen={anchorEl,consumeEvents:this.getConsumeEventType(anchorEl,this.currentAction.event),onConsume:()=>{this.pointer.hide();this.currentActionIndex++;this.play();},onError:()=>{if(this.currentAction.event==="drop"){this.pointer.hide();this.currentActionIndex--;this.play();}},};if(index===0){return this.setupListeners({...toListen,onMouseEnter:()=>this.pointer.showContent(true),onMouseLeave:()=>this.pointer.showContent(false),onScroll:()=>this.updatePointer(),});}else{return this.setupListeners({...toListen,onScroll:()=>{},});}});this.removeListeners=()=>{this.anchorEls=[];while(cleanups.length){cleanups.pop()();}};}
setupListeners({anchorEl,consumeEvents,onMouseEnter,onMouseLeave,onScroll,onConsume,onError=()=>{},}){consumeEvents=consumeEvents.map((c)=>({target:c.target,type:c.name,listener:function(ev){if(!c.conditional||c.conditional(ev)){onConsume();}else{onError();}},}));for(const consume of consumeEvents){consume.target.addEventListener(consume.type,consume.listener,true);}
anchorEl.addEventListener("mouseenter",onMouseEnter);anchorEl.addEventListener("mouseleave",onMouseLeave);const cleanups=[()=>{for(const consume of consumeEvents){consume.target.removeEventListener(consume.type,consume.listener,true);}
anchorEl.removeEventListener("mouseenter",onMouseEnter);anchorEl.removeEventListener("mouseleave",onMouseLeave);},];const scrollEl=getScrollParent(anchorEl);if(scrollEl){const debouncedOnScroll=debounce(onScroll,50);scrollEl.addEventListener("scroll",debouncedOnScroll);cleanups.push(()=>scrollEl.removeEventListener("scroll",debouncedOnScroll));}
return cleanups;}
getSubActions(step){const actions=[];if(!step.run||typeof step.run==="function"){actions.push({step,event:"warn",anchor:step.trigger,});return actions;}
for(const todo of step.run.split("&&")){const m=String(todo).trim().match(/^(?<action>\w*) *\(? *(?<arguments>.*?)\)?$/);let action=m.groups?.action;const anchor=m.groups?.arguments||step.trigger;const pointerInfo={content:step.content,tooltipPosition:step.tooltipPosition,};if(action==="drag_and_drop"){actions.push({step,event:"drag",anchor:step.trigger,pointerInfo,});action="drop";}
actions.push({step,event:action,anchor:action==="edit"?step.trigger:anchor,pointerInfo,});}
return actions;}
getConsumeEventType(element,runCommand){const consumeEvents=[];if(runCommand==="click"){consumeEvents.push({name:"click",target:element,});if(element.querySelector(".o-autocomplete--input")){consumeEvents.push({name:"keydown",target:element.querySelector(".o-autocomplete--input"),conditional:(ev)=>["Tab","Enter"].includes(ev.key)&&ev.target.parentElement.querySelector(".o-autocomplete--dropdown-item .ui-state-active"),});}
if(element.closest(".o-autocomplete--dropdown-menu")){consumeEvents.push({name:"keydown",target:element.closest(".o-autocomplete").querySelector("input"),conditional:(ev)=>["Tab","Enter"].includes(ev.key),});}
if(element.tagName==="BUTTON"){consumeEvents.push({name:"keydown",target:element,conditional:(ev)=>ev.key==="Enter",});if(element.closest(".input-group")){for(const inputEl of element.parentElement.querySelectorAll("input")){consumeEvents.push({name:"keydown",target:inputEl,conditional:(ev)=>ev.key==="Enter",});}}}}
if(["fill","edit"].includes(runCommand)){if(utils.isSmall()&&element.closest(".o_field_widget")?.matches(".o_field_many2one, .o_field_many2many")){consumeEvents.push({name:"click",target:element,});}else{consumeEvents.push({name:"input",target:element,});if(element.classList.contains("o-autocomplete--input")){consumeEvents.push({name:"keydown",target:element,conditional:(ev)=>{if(["Tab","Enter"].includes(ev.key)&&ev.target.parentElement.querySelector(".o-autocomplete--dropdown-item .ui-state-active")){const nextStep=this.actions.at(this.currentActionIndex+1);if(this.findTriggers(nextStep.anchor).at(0)?.closest(".o-autocomplete--dropdown-item")){this.currentActionIndex++;}
return true;}},});consumeEvents.push({name:"click",target:element.ownerDocument,conditional:(ev)=>{if(ev.target.closest(".o-autocomplete--dropdown-item")){const nextStep=this.actions.at(this.currentActionIndex+1);if(this.findTriggers(nextStep.anchor).at(0)?.closest(".o-autocomplete--dropdown-item")){this.currentActionIndex++;}
return true;}},});}}}
if(runCommand==="drag"){consumeEvents.push({name:"pointerdown",target:element,});}
if(runCommand==="drop"){consumeEvents.push({name:"pointerup",target:element.ownerDocument,conditional:(ev)=>element.ownerDocument.elementsFromPoint(ev.clientX,ev.clientY).includes(element),});consumeEvents.push({name:"drop",target:element.ownerDocument,conditional:(ev)=>element.ownerDocument.elementsFromPoint(ev.clientX,ev.clientY).includes(element),});}
return consumeEvents;}
getAnchorEl(el,consumeEvent){if(consumeEvent==="drag"){return el.closest(".ui-draggable, .o_draggable, .o_we_draggable, .o-draggable, [draggable='true']");}
if(consumeEvent==="input"&&!["textarea","input"].includes(el.tagName.toLowerCase())){return el.closest("[contenteditable='true']");}
if(consumeEvent==="sort"){return el.closest(".ui-sortable, .o_sortable");}
return el;}
_onMutation(){if(this.currentAction){const tempAnchors=this.findTriggers();if(tempAnchors.length&&(tempAnchors.some((a)=>!this.anchorEls.includes(a))||this.anchorEls.some((a)=>!tempAnchors.includes(a)))){this.removeListeners();this.anchorEls=tempAnchors;this.setActionListeners();}else if(!tempAnchors.length&&this.anchorEls.length){this.pointer.hide();if(!hoot.queryFirst(".o_home_menu",{visible:true})&&!hoot.queryFirst(".dropdown-item.o_loading",{visible:true})){this.backward();}
return;}
this.updatePointer();}}}
return __exports;});;

/* /web_tour/static/src/tour_service/tour_pointer_state.js */
odoo.define('@web_tour/tour_service/tour_pointer_state',['@odoo/owl','@web/core/l10n/translation','@web_tour/tour_pointer/tour_pointer','@web_tour/tour_service/tour_utils'],function(require){'use strict';let __exports={};const{reactive}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{TourPointer}=require("@web_tour/tour_pointer/tour_pointer");const{getScrollParent}=require("@web_tour/tour_service/tour_utils");class Intersection{constructor(){this.currentTarget=null;this.rootBounds=null;this._targetPosition="unknown";this._observer=new IntersectionObserver((observations)=>this._handleObservations(observations));}
_handleObservations(observations){if(observations.length<1){return;}
const observation=observations[observations.length-1];this.rootBounds=observation.rootBounds;if(this.rootBounds&&this.currentTarget){if(observation.isIntersecting){this._targetPosition="in";}else{const scrollParentElement=getScrollParent(this.currentTarget)||document.documentElement;const targetBounds=this.currentTarget.getBoundingClientRect();if(targetBounds.bottom>scrollParentElement.clientHeight){this._targetPosition="out-below";}else if(targetBounds.top<0){this._targetPosition="out-above";}else if(targetBounds.left<0){this._targetPosition="out-left";}else if(targetBounds.right>scrollParentElement.clientWidth){this._targetPosition="out-right";}}}else{this._targetPosition="unknown";}}
get targetPosition(){if(!this.rootBounds){return this.currentTarget?"in":"unknown";}else{return this._targetPosition;}}
setTarget(newTarget){if(this.currentTarget!==newTarget){if(this.currentTarget){this._observer.unobserve(this.currentTarget);}
if(newTarget){this._observer.observe(newTarget);}
this.currentTarget=newTarget;}}
stop(){this._observer.disconnect();}}
__exports.createPointerState=createPointerState;function createPointerState(){const setState=(newState)=>{Object.assign(state,newState);};const pointTo=(anchor,step,isZone)=>{intersection.setTarget(anchor);if(anchor){let{tooltipPosition,content}=step;switch(intersection.targetPosition){case"unknown":{break;}
case"in":{if(document.body.contains(floatingAnchor)){floatingAnchor.remove();}
setState({anchor,content,isZone,onClick:null,position:tooltipPosition,isVisible:true,});break;}
default:{const onClick=()=>{anchor.scrollIntoView({behavior:"smooth",block:"nearest"});hide();};const scrollParent=getScrollParent(anchor);if(!scrollParent){setState({anchor,content,isZone,onClick:null,position:tooltipPosition,isVisible:true,});return;}
let{x,y,width,height}=scrollParent.getBoundingClientRect();const iframeEl=scrollParent.ownerDocument.defaultView.frameElement;if(iframeEl){const iframeOffset=iframeEl.getBoundingClientRect();x+=iframeOffset.x;y+=iframeOffset.y;}
if(intersection.targetPosition==="out-below"){tooltipPosition="top";content=_t("Scroll down to reach the next step.");floatingAnchor.style.top=`${y + height - TourPointer.height}px`;floatingAnchor.style.left=`${x + width / 2}px`;}else if(intersection.targetPosition==="out-above"){tooltipPosition="bottom";content=_t("Scroll up to reach the next step.");floatingAnchor.style.top=`${y + TourPointer.height}px`;floatingAnchor.style.left=`${x + width / 2}px`;}
if(intersection.targetPosition==="out-left"){tooltipPosition="right";content=_t("Scroll left to reach the next step.");floatingAnchor.style.top=`${y + height / 2}px`;floatingAnchor.style.left=`${x + TourPointer.width}px`;}else if(intersection.targetPosition==="out-right"){tooltipPosition="left";content=_t("Scroll right to reach the next step.");floatingAnchor.style.top=`${y + height / 2}px`;floatingAnchor.style.left=`${x + width - TourPointer.width}px`;}
if(!document.contains(floatingAnchor)){document.body.appendChild(floatingAnchor);}
setState({anchor:floatingAnchor,content,onClick,position:tooltipPosition,isZone,isVisible:true,});}}}else{hide();}};function hide(){setState({content:"",isVisible:false,isOpen:false});}
function showContent(isOpen){setState({isOpen});}
function destroy(){intersection.stop();if(document.body.contains(floatingAnchor)){floatingAnchor.remove();}}
const state=reactive({});const intersection=new Intersection();const floatingAnchor=document.createElement("div");floatingAnchor.className="position-fixed";return{state,setState,showContent,pointTo,hide,destroy};}
return __exports;});;

/* /web_tour/static/src/tour_service/tour_recorder/tour_recorder.js */
odoo.define('@web_tour/tour_service/tour_recorder/tour_recorder',['@web/core/utils/hooks','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/browser/browser','@odoo/hoot-dom','@odoo/owl','@web/core/l10n/translation','@web/core/orm_service','@web_tour/tour_service/tour_recorder/tour_recorder_state'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{browser}=require("@web/core/browser/browser");const{queryAll,queryFirst,queryOne}=require("@odoo/hoot-dom");const{Component,useState,useExternalListener}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{x2ManyCommands}=require("@web/core/orm_service");const{tourRecorderState}=require("@web_tour/tour_service/tour_recorder/tour_recorder_state");const TOUR_RECORDER_ACTIVE_LOCAL_STORAGE_KEY=__exports.TOUR_RECORDER_ACTIVE_LOCAL_STORAGE_KEY="tour_recorder_active";const PRECISE_IDENTIFIERS=["data-menu-xmlid","name","contenteditable"];const ODOO_CLASS_REGEX=/^oe?(-|_)[\w-]+$/;const VALIDATING_KEYS=["Enter","Tab"];const getShortestSelector=(paths)=>{paths.reverse();let filteredPath=[];let hasOdooClass=false;for(let currentElem=paths.pop();(currentElem&&queryAll(filteredPath.join(" > ")).length!==1)||!hasOdooClass;currentElem=paths.pop()){if(currentElem.parentElement.contentEditable==="true"){continue;}
let currentPredicate=currentElem.tagName.toLowerCase();const odooClass=[...currentElem.classList].find((c)=>c.match(ODOO_CLASS_REGEX));if(odooClass){currentPredicate=`.${odooClass}`;hasOdooClass=true;}
if(["BUTTON","A"].includes(currentElem.tagName)){filteredPath=[];}
for(const identifier of PRECISE_IDENTIFIERS){const identifierValue=currentElem.getAttribute(identifier);if(identifierValue){currentPredicate+=`[${identifier}='${CSS.escape(identifierValue)}']`;}}
const siblingNodes=queryAll(":scope > "+currentPredicate,{root:currentElem.parentElement,});if(siblingNodes.length>1){currentPredicate+=`:nth-child(${
                [...currentElem.parentElement.children].indexOf(currentElem) + 1
            })`;}
filteredPath.unshift(currentPredicate);}
if(filteredPath.length>2){return reducePath(filteredPath);}
return filteredPath.join(" > ");};const reducePath=(paths)=>{const numberOfElement=paths.length-2;let currentElement="";let hasReduced=false;let path=paths.shift();for(let i=0;i<numberOfElement;i++){currentElement=paths.shift();if(queryAll(`${path} ${paths.join(" > ")}`).length===1){hasReduced=true;}else{path+=`${hasReduced ? " " : " > "}${currentElement}`;hasReduced=false;}}
path+=`${hasReduced ? " " : " > "}${paths.shift()}`;return path;};const TourRecorder=__exports.TourRecorder=class TourRecorder extends Component{static template="web_tour.TourRecorder";static components={Dropdown,DropdownItem};static props={onClose:{type:Function},};static defaultState={recording:false,url:"",editedElement:undefined,tourName:"",};setup(){this.originClickEvent=false;this.notification=useService("notification");this.orm=useService("orm");this.state=useState({...TourRecorder.defaultState,steps:[],});this.state.steps=tourRecorderState.getCurrentTourRecorder();this.state.recording=tourRecorderState.isRecording()==="1";useExternalListener(document,"pointerdown",this.setStartingEvent,{capture:true});useExternalListener(document,"pointerup",this.recordClickEvent,{capture:true});useExternalListener(document,"keydown",this.recordConfirmationKeyboardEvent,{capture:true,});useExternalListener(document,"keyup",this.recordKeyboardEvent,{capture:true});}
setStartingEvent(ev){if(!this.state.recording||ev.target.closest(".o_tour_recorder")){return;}
this.originClickEvent=ev.composedPath().filter((p)=>p instanceof Element);}
recordClickEvent(ev){if(!this.state.recording||ev.target.closest(".o_tour_recorder")){return;}
const pathElements=ev.composedPath().filter((p)=>p instanceof Element);this.addTourStep([...pathElements]);const lastStepInput=this.state.steps.at(-1);if(JSON.stringify(pathElements.map((e)=>e.tagName))!==JSON.stringify(this.originClickEvent.map((e)=>e.tagName))){lastStepInput.run=`drag_and_drop ${lastStepInput.trigger}`;lastStepInput.trigger=getShortestSelector(this.originClickEvent);}else{const lastStepInput=this.state.steps.at(-1);lastStepInput.run="click";}
tourRecorderState.setCurrentTourRecorder(this.state.steps);}
recordConfirmationKeyboardEvent(ev){if(!this.state.recording||!this.state.editedElement||ev.target.closest(".o_tour_recorder")){return;}
if([...this.state.editedElement.classList].includes("o-autocomplete--input")&&VALIDATING_KEYS.includes(ev.key)){const selectedRow=queryFirst(".ui-state-active",{root:this.state.editedElement.parentElement,});this.state.steps.push({trigger:`.o-autocomplete--dropdown-item > a:contains('${selectedRow.textContent}'), .fa-circle-o-notch`,run:"click",});this.state.editedElement=undefined;}
tourRecorderState.setCurrentTourRecorder(this.state.steps);}
recordKeyboardEvent(ev){if(!this.state.recording||VALIDATING_KEYS.includes(ev.key)||ev.target.closest(".o_tour_recorder")){return;}
if(!this.state.editedElement){if(ev.target.matches("input:not(:disabled), textarea:not(:disabled), [contenteditable=true]")){this.state.editedElement=ev.target;this.state.steps.push({trigger:getShortestSelector(ev.composedPath()),});}else{return;}}
if(!this.state.editedElement){return;}
const lastStep=this.state.steps.at(-1);if(this.state.editedElement.contentEditable==="true"){lastStep.run=`editor ${this.state.editedElement.textContent}`;}else{lastStep.run=`edit ${this.state.editedElement.value}`;}
tourRecorderState.setCurrentTourRecorder(this.state.steps);}
toggleRecording(){this.state.recording=!this.state.recording;tourRecorderState.setIsRecording(this.state.recording);this.state.editedElement=undefined;if(this.state.recording&&!this.state.url){this.state.url=browser.location.pathname+browser.location.search;}}
async saveTour(){const newTour={name:this.state.tourName.replaceAll(" ","_"),url:this.state.url,step_ids:this.state.steps.map((s)=>x2ManyCommands.create(undefined,s)),custom:true,};const result=await this.orm.create("web_tour.tour",[newTour]);if(result){this.notification.add(_t("Custom tour '%s' has been added.",newTour.name),{type:"success",});this.resetTourRecorderState();}else{this.notification.add(_t("Custom tour '%s' couldn't be saved!",newTour.name),{type:"danger",});}}
resetTourRecorderState(){Object.assign(this.state,{...TourRecorder.defaultState,steps:[]});tourRecorderState.clear();}
addTourStep(path){const shortestPath=getShortestSelector(path);const target=queryOne(shortestPath);this.state.editedElement=target.matches("input:not(:disabled), textarea:not(:disabled), [contenteditable=true]")&&target;this.state.steps.push({trigger:shortestPath,});}}
return __exports;});;

/* /web_tour/static/src/tour_service/tour_recorder/tour_recorder_state.js */
odoo.define('@web_tour/tour_service/tour_recorder/tour_recorder_state',['@web/core/browser/browser'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const CURRENT_TOUR_RECORDER_LOCAL_STORAGE="current_tour_recorder";const CURRENT_TOUR_RECORDER_RECORD_LOCAL_STORAGE="current_tour_recorder.record";const tourRecorderState=__exports.tourRecorderState={isRecording(){return browser.localStorage.getItem(CURRENT_TOUR_RECORDER_RECORD_LOCAL_STORAGE)||"0";},setIsRecording(isRecording){browser.localStorage.setItem(CURRENT_TOUR_RECORDER_RECORD_LOCAL_STORAGE,isRecording?"1":"0");},setCurrentTourRecorder(tour){tour=JSON.stringify(tour);browser.localStorage.setItem(CURRENT_TOUR_RECORDER_LOCAL_STORAGE,tour);},getCurrentTourRecorder(){const tour=browser.localStorage.getItem(CURRENT_TOUR_RECORDER_LOCAL_STORAGE)||"[]";return JSON.parse(tour);},clear(){browser.localStorage.removeItem(CURRENT_TOUR_RECORDER_LOCAL_STORAGE);browser.localStorage.removeItem(CURRENT_TOUR_RECORDER_RECORD_LOCAL_STORAGE);},};return __exports;});;

/* /web_tour/static/src/tour_service/tour_service.js */
odoo.define('@web_tour/tour_service/tour_service',['@odoo/owl','@web/core/browser/browser','@web/core/l10n/translation','@web/core/registry','@web/session','@web_tour/tour_pointer/tour_pointer','@web_tour/tour_service/tour_pointer_state','@web_tour/tour_service/tour_state','@web_tour/tour_service/tour_interactive','@web_tour/tour_service/tour_automatic','@web_tour/tour_service/tour_utils','@web_tour/tour_service/tour_recorder/tour_recorder','@web/core/utils/urls','@web_tour/tour_service/tour_recorder/tour_recorder_state'],function(require){'use strict';let __exports={};const{markup,whenReady,validate}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{session}=require("@web/session");const{TourPointer}=require("@web_tour/tour_pointer/tour_pointer");const{createPointerState}=require("@web_tour/tour_service/tour_pointer_state");const{tourState}=require("@web_tour/tour_service/tour_state");const{TourInteractive}=require("@web_tour/tour_service/tour_interactive");const{TourAutomatic}=require("@web_tour/tour_service/tour_automatic");const{callWithUnloadCheck}=require("@web_tour/tour_service/tour_utils");const{TOUR_RECORDER_ACTIVE_LOCAL_STORAGE_KEY,TourRecorder,}=require("@web_tour/tour_service/tour_recorder/tour_recorder");const{redirect}=require("@web/core/utils/urls");const{tourRecorderState}=require("@web_tour/tour_service/tour_recorder/tour_recorder_state");const StepSchema={id:{type:[String],optional:true},content:{type:[String,Object],optional:true},debugHelp:{type:String,optional:true},isActive:{type:Array,element:String,optional:true},run:{type:[String,Function,Boolean],optional:true},timeout:{optional:true,validate(value){return value>=0&&value<=60000;},},tooltipPosition:{optional:true,validate(value){return["top","bottom","left","right"].includes(value);},},trigger:{type:String},pause:{type:Boolean,optional:true},break:{type:Boolean,optional:true},};const TourSchema={name:{type:String,optional:true},steps:Function,url:{type:String,optional:true},wait_for:{type:[Function,Object],optional:true},};registry.category("web_tour.tours").addValidation(TourSchema);const userMenuRegistry=registry.category("user_menuitems");const tourService=__exports.tourService={dependencies:["orm","effect","overlay","localization"],start:async(_env,{orm,effect,overlay})=>{await whenReady();let toursEnabled=session?.tour_enabled;const tourRegistry=registry.category("web_tour.tours");const pointer=createPointerState();pointer.stop=()=>{};userMenuRegistry.add("web_tour.tour_enabled",()=>({type:"switch",id:"web_tour.tour_enabled",description:_t("Onboarding"),callback:async()=>{tourState.clear();toursEnabled=await orm.call("res.users","switch_tour_enabled",[!toursEnabled]);browser.location.reload();},isChecked:toursEnabled,sequence:30,}));function getTourFromRegistry(tourName){if(!tourRegistry.contains(tourName)){return;}
const tour=tourRegistry.get(tourName);return{...tour,steps:tour.steps(),name:tourName,wait_for:tour.wait_for||Promise.resolve(),};}
async function getTourFromDB(tourName){const tour=await orm.call("web_tour.tour","get_tour_json_by_name",[tourName]);if(!tour){throw new Error(`Tour '${tourName}' is not found in the database.`);}
if(!tour.steps.length&&tourRegistry.contains(tour.name)){tour.steps=tourRegistry.get(tour.name).steps();}
return tour;}
function validateStep(step){try{validate(step,StepSchema);}catch(error){console.error(`Error in schema for TourStep ${JSON.stringify(step, null, 4)}\n${
                        error.message
                    }`);}}
async function startTour(tourName,options={}){pointer.stop();const tourFromRegistry=getTourFromRegistry(tourName);if(!tourFromRegistry&&!options.fromDB){return;}
const tour=options.fromDB?{name:tourName,url:options.url}:tourFromRegistry;if(!session.is_public&&!toursEnabled&&options.mode==="manual"){toursEnabled=await orm.call("res.users","switch_tour_enabled",[!toursEnabled]);}
let tourConfig={delayToCheckUndeterminisms:0,stepDelay:0,keepWatchBrowser:false,mode:"auto",showPointerDuration:0,debug:false,redirect:true,};tourConfig=Object.assign(tourConfig,options);tourState.setCurrentConfig(tourConfig);tourState.setCurrentTour(tour.name);tourState.setCurrentIndex(0);const willUnload=callWithUnloadCheck(()=>{if(tour.url&&tourConfig.startUrl!=tour.url&&tourConfig.redirect){redirect(tour.url);}});if(!willUnload){resumeTour();}}
async function resumeTour(){const tourName=tourState.getCurrentTour();const tourConfig=tourState.getCurrentConfig();let tour=getTourFromRegistry(tourName);if(tourConfig.fromDB){tour=await getTourFromDB(tourName);}
if(!tour){return;}
tour.steps.forEach((step)=>validateStep(step));pointer.stop=overlay.add(TourPointer,{pointerState:pointer.state,bounce:!(tourConfig.mode==="auto"&&tourConfig.keepWatchBrowser),},{sequence:1100,});if(tourConfig.mode==="auto"){new TourAutomatic(tour).start();}else{new TourInteractive(tour).start(pointer,async()=>{pointer.stop();tourState.clear();browser.console.log("tour succeeded");let message=tourConfig.rainbowManMessage||tour.rainbowManMessage;if(message){message=window.DOMPurify.sanitize(tourConfig.rainbowManMessage);effect.add({type:"rainbow_man",message:markup(message),});}
const nextTour=await orm.call("web_tour.tour","consume",[tour.name]);if(nextTour){startTour(nextTour.name,{mode:"manual",redirect:false,rainbowManMessage:nextTour.rainbowManMessage,});}});}}
function startTourRecorder(){if(!browser.localStorage.getItem(TOUR_RECORDER_ACTIVE_LOCAL_STORAGE_KEY)){const remove=overlay.add(TourRecorder,{onClose:()=>{remove();browser.localStorage.removeItem(TOUR_RECORDER_ACTIVE_LOCAL_STORAGE_KEY);tourRecorderState.clear();},},{sequence:99999});}
browser.localStorage.setItem(TOUR_RECORDER_ACTIVE_LOCAL_STORAGE_KEY,"1");}
if(!window.frameElement){const paramsTourName=new URLSearchParams(browser.location.search).get("tour");if(paramsTourName){startTour(paramsTourName,{mode:"manual",fromDB:true});}
if(tourState.getCurrentTour()){if(tourState.getCurrentConfig().mode==="auto"||toursEnabled){resumeTour();}else{tourState.clear();}}else if(session.current_tour){startTour(session.current_tour.name,{mode:"manual",redirect:false,rainbowManMessage:session.current_tour.rainbowManMessage,});}
if(browser.localStorage.getItem(TOUR_RECORDER_ACTIVE_LOCAL_STORAGE_KEY)&&!session.is_public){const remove=overlay.add(TourRecorder,{onClose:()=>{remove();browser.localStorage.removeItem(TOUR_RECORDER_ACTIVE_LOCAL_STORAGE_KEY);tourRecorderState.clear();},},{sequence:99999});}}
odoo.startTour=startTour;odoo.isTourReady=(tourName)=>getTourFromRegistry(tourName).wait_for.then(()=>true);return{startTour,startTourRecorder,};},};registry.category("services").add("tour_service",tourService);return __exports;});;

/* /web_tour/static/src/tour_service/tour_state.js */
odoo.define('@web_tour/tour_service/tour_state',['@web/core/browser/browser'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const CURRENT_TOUR_LOCAL_STORAGE="current_tour";const CURRENT_TOUR_CONFIG_LOCAL_STORAGE="current_tour.config";const CURRENT_TOUR_INDEX_LOCAL_STORAGE="current_tour.index";const CURRENT_TOUR_ON_ERROR_LOCAL_STORAGE="current_tour.on_error";const tourState=__exports.tourState={getCurrentTour(){return browser.localStorage.getItem(CURRENT_TOUR_LOCAL_STORAGE);},setCurrentTour(tourName){browser.localStorage.setItem(CURRENT_TOUR_LOCAL_STORAGE,tourName);},getCurrentIndex(){const index=browser.localStorage.getItem(CURRENT_TOUR_INDEX_LOCAL_STORAGE,"0");return parseInt(index,10);},setCurrentIndex(index){browser.localStorage.setItem(CURRENT_TOUR_INDEX_LOCAL_STORAGE,index.toString());},getCurrentConfig(){const config=browser.localStorage.getItem(CURRENT_TOUR_CONFIG_LOCAL_STORAGE,"{}");return JSON.parse(config);},setCurrentConfig(config){config=JSON.stringify(config);browser.localStorage.setItem(CURRENT_TOUR_CONFIG_LOCAL_STORAGE,config);},getCurrentTourOnError(){return browser.localStorage.getItem(CURRENT_TOUR_ON_ERROR_LOCAL_STORAGE);},setCurrentTourOnError(){browser.localStorage.setItem(CURRENT_TOUR_ON_ERROR_LOCAL_STORAGE,"1");},clear(){browser.localStorage.removeItem(CURRENT_TOUR_ON_ERROR_LOCAL_STORAGE);browser.localStorage.removeItem(CURRENT_TOUR_CONFIG_LOCAL_STORAGE);browser.localStorage.removeItem(CURRENT_TOUR_INDEX_LOCAL_STORAGE);browser.localStorage.removeItem(CURRENT_TOUR_LOCAL_STORAGE);},};return __exports;});;

/* /web_tour/static/src/tour_service/tour_step.js */
odoo.define('@web_tour/tour_service/tour_step',['@web/session','@web/core/ui/ui_service','@odoo/hoot-dom','@web/core/utils/objects'],function(require){'use strict';let __exports={};const{session}=require("@web/session");const{utils}=require("@web/core/ui/ui_service");const hoot=require("@odoo/hoot-dom");const{pick}=require("@web/core/utils/objects");const TourStep=__exports.TourStep=class TourStep{constructor(data,tour){Object.assign(this,data);this.tour=tour;}
get active(){this.checkHasTour();const mode=this.tour.mode;const isSmall=utils.isSmall();const standardKeyWords=["enterprise","community","mobile","desktop","auto","manual"];const isActiveArray=Array.isArray(this.isActive)?this.isActive:[];if(isActiveArray.length===0){return true;}
const selectors=isActiveArray.filter((key)=>!standardKeyWords.includes(key));if(selectors.length){for(const selector of selectors){const el=hoot.queryFirst(selector);if(!el){return false;}}}
const checkMode=isActiveArray.includes(mode)||(!isActiveArray.includes("manual")&&!isActiveArray.includes("auto"));const edition=(session.server_version_info||"").at(-1)==="e"?"enterprise":"community";const checkEdition=isActiveArray.includes(edition)||(!isActiveArray.includes("enterprise")&&!isActiveArray.includes("community"));const onlyForMobile=isActiveArray.includes("mobile")&&isSmall;const onlyForDesktop=isActiveArray.includes("desktop")&&!isSmall;const checkDevice=onlyForMobile||onlyForDesktop||(!isActiveArray.includes("mobile")&&!isActiveArray.includes("desktop"));return checkEdition&&checkDevice&&checkMode;}
checkHasTour(){if(!this.tour){throw new Error(`TourStep instance must have a tour`);}}
get describeMe(){this.checkHasTour();return(`[${this.index + 1}/${this.tour.steps.length}] Tour ${this.tour.name} → Step `+
(this.content?`${this.content} (trigger: ${this.trigger})`:this.trigger));}
get stringify(){return(JSON.stringify(pick(this,"isActive","content","trigger","run","tooltipPosition","timeout"),(_key,value)=>{if(typeof value==="function"){return"[function]";}else{return value;}},2)+",");}}
return __exports;});;

/* /web_tour/static/src/tour_service/tour_step_automatic.js */
odoo.define('@web_tour/tour_service/tour_step_automatic',['@web_tour/tour_service/tour_state','@odoo/hoot-dom','@web_tour/tour_service/tour_utils','@web_tour/tour_service/tour_helpers','@web_tour/tour_service/tour_step','@web/core/utils/xml','@web/core/macro'],function(require){'use strict';let __exports={};const{tourState}=require("@web_tour/tour_service/tour_state");const hoot=require("@odoo/hoot-dom");const{callWithUnloadCheck,serializeChanges,serializeMutation}=require("@web_tour/tour_service/tour_utils");const{TourHelpers}=require("@web_tour/tour_service/tour_helpers");const{TourStep}=require("@web_tour/tour_service/tour_step");const{getTag}=require("@web/core/utils/xml");const{waitForStable}=require("@web/core/macro");const TourStepAutomatic=__exports.TourStepAutomatic=class TourStepAutomatic extends TourStep{skipped=false;error="";constructor(data,tour,index){super(data,tour);this.index=index;this.tourConfig=tourState.getCurrentConfig();}
async checkForUndeterminisms(initialElement,delay){if(delay<=0||!initialElement){return;}
const tagName=initialElement.tagName?.toLowerCase();if(["body","html"].includes(tagName)||!tagName){return;}
const snapshot=initialElement.cloneNode(true);const mutations=await waitForStable(initialElement,delay);let reason;if(!hoot.isVisible(initialElement)){reason=`Initial element is no longer visible`;}else if(!initialElement.isEqualNode(snapshot)){reason=`Initial element has changed:\n`+
JSON.stringify(serializeChanges(snapshot,initialElement),null,2);}else if(mutations.length){const changes=[...new Set(mutations.map(serializeMutation))];reason=`Initial element has mutated ${mutations.length} times:\n`+
JSON.stringify(changes,null,2);}
if(reason){throw new Error(`Potential non deterministic behavior found in ${delay}ms for trigger ${this.trigger}.\n${reason}`);}}
get describeWhyIFailed(){const errors=[];if(this.element){errors.push(`Element has been found.`);if(this.isUIBlocked){errors.push("BUT: DOM is blocked by UI.");}
if(!this.elementIsInModal){errors.push(`BUT: It is not allowed to do action on an element that's below a modal.`);}
if(!this.elementIsEnabled){errors.push(`BUT: Element is not enabled. TIP: You can use :enable to wait the element is enabled before doing action on it.`);}
if(!this.parentFrameIsReady){errors.push(`BUT: parent frame is not ready ([is-ready='false']).`);}}else{const checkElement=hoot.queryFirst(this.trigger);if(checkElement){errors.push(`Element has been found.`);errors.push(`BUT: Element is not visible. TIP: You can use :not(:visible) to force the search for an invisible element.`);}else{errors.push(`Element (${this.trigger}) has not been found.`);}}
return errors;}
async doAction(){if(this.skipped){return;}
return await callWithUnloadCheck(async()=>{const actionHelper=new TourHelpers(this.element);if(typeof this.run==="function"){await this.run.call({anchor:this.element},actionHelper);}else if(typeof this.run==="string"){for(const todo of this.run.split("&&")){const m=String(todo).trim().match(/^(?<action>\w*) *\(? *(?<arguments>.*?)\)?$/);await actionHelper[m.groups?.action](m.groups?.arguments);}}});}
findTrigger(){if(!this.active){this.skipped=true;return true;}
const visible=!/:(hidden|visible)\b/.test(this.trigger);this.element=hoot.queryFirst(this.trigger,{visible});if(this.element){return!this.isUIBlocked&&this.elementIsEnabled&&this.elementIsInModal&&this.parentFrameIsReady?this.element:false;}
return false;}
get isUIBlocked(){return(document.body.classList.contains("o_lazy_js_waiting")||document.body.classList.contains("o_ui_blocked")||document.querySelector(".o_blockUI")||document.querySelector(".o_is_blocked"));}
get parentFrameIsReady(){if(this.trigger.match(/\[is-ready=(true|false)\]/)){return true;}
const parentFrame=hoot.getParentFrame(this.element);return parentFrame&&parentFrame.hasAttribute("is-ready")?parentFrame.getAttribute("is-ready")==="true":true;}
get elementIsInModal(){if(this.hasAction){const overlays=hoot.queryFirst(".popover, .o-we-command, .o_notification");const modal=hoot.queryFirst(".modal:visible:not(.o_inactive_modal):last");if(modal&&!overlays&&!this.trigger.startsWith("body")){return(modal.contains(hoot.getParentFrame(this.element))||modal.contains(this.element));}}
return true;}
get elementIsEnabled(){const isTag=(array)=>array.includes(getTag(this.element,true));if(this.hasAction){if(isTag(["input","textarea"])){return hoot.isEditable(this.element);}else if(isTag(["button","select"])){return!this.element.disabled;}}
return true;}
get hasAction(){return["string","function"].includes(typeof this.run)&&!this.skipped;}}
return __exports;});;

/* /web_tour/static/src/tour_service/tour_utils.js */
odoo.define('@web_tour/tour_service/tour_utils',['@odoo/hoot-dom','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const hoot=require("@odoo/hoot-dom");const{_t}=require("@web/core/l10n/translation");__exports.callWithUnloadCheck=callWithUnloadCheck;function callWithUnloadCheck(func,...args){let willUnload=false;const beforeunload=()=>(willUnload=true);window.addEventListener("beforeunload",beforeunload);const result=func(...args);if(result instanceof Promise){return result.then(()=>{window.removeEventListener("beforeunload",beforeunload);return willUnload;});}else{window.removeEventListener("beforeunload",beforeunload);return willUnload;}}
function formatValue(key,value,maxLength=200){if(!value){return"(empty)";}
return value.length>maxLength?value.slice(0,maxLength)+"...":value;}
function serializeNode(node){if(node.nodeType===Node.TEXT_NODE){return`"${node.nodeValue.trim()}"`;}
return node.outerHTML?formatValue("node",node.outerHTML,500):"[Unknown Node]";}
__exports.serializeChanges=serializeChanges;function serializeChanges(snapshot,current){const changes={node:serializeNode(current),};function pushChanges(key,obj){changes[key]=changes[key]||[];changes[key].push(obj);}
if(snapshot.textContent!==current.textContent){pushChanges("modifiedText",{before:snapshot.textContent,after:current.textContent});}
const oldChildren=[...snapshot.childNodes].filter((node)=>node.nodeType!==Node.TEXT_NODE);const newChildren=[...current.childNodes].filter((node)=>node.nodeType!==Node.TEXT_NODE);oldChildren.forEach((oldNode,index)=>{if(!newChildren[index]||!oldNode.isEqualNode(newChildren[index])){pushChanges("removedNodes",{oldNode:serializeNode(oldNode)});}});newChildren.forEach((newNode,index)=>{if(!oldChildren[index]||!newNode.isEqualNode(oldChildren[index])){pushChanges("addedNodes",{newNode:serializeNode(newNode)});}});const oldAttrNames=new Set([...snapshot.attributes].map((attr)=>attr.name));const newAttrNames=new Set([...current.attributes].map((attr)=>attr.name));new Set([...oldAttrNames,...newAttrNames]).forEach((attributeName)=>{const oldValue=snapshot.getAttribute(attributeName);const newValue=current.getAttribute(attributeName);const before=oldValue!==newValue||!newAttrNames.has(attributeName)?oldValue:null;const after=oldValue!==newValue||!oldAttrNames.has(attributeName)?newValue:null;if(before||after){pushChanges("modifiedAttributes",{attributeName,before,after});}});return changes;}
__exports.serializeMutation=serializeMutation;function serializeMutation(mutation){const{type,attributeName}=mutation;if(type==="attributes"&&attributeName){return`attribute: ${attributeName}`;}else{return type;}}
__exports.getScrollParent=getScrollParent;function getScrollParent(element){if(!element){return null;}
const overflowY=window.getComputedStyle(element).overflowY;const isScrollable=overflowY==="auto"||overflowY==="scroll"||(overflowY==="visible"&&element===element.ownerDocument.scrollingElement);if(isScrollable){return element;}else{return getScrollParent(element.parentNode);}}
const stepUtils=__exports.stepUtils={_getHelpMessage(functionName,...args){return`Generated by function tour utils ${functionName}(${args.join(", ")})`;},addDebugHelp(helpMessage,step){if(typeof step.debugHelp==="string"){step.debugHelp=step.debugHelp+"\n"+helpMessage;}else{step.debugHelp=helpMessage;}
return step;},showAppsMenuItem(){return{isActive:["auto","community","desktop"],trigger:".o_navbar_apps_menu button:enabled",tooltipPosition:"bottom",run:"click",};},toggleHomeMenu(){return[{isActive:[".o_main_navbar .o_menu_toggle"],trigger:".o_main_navbar .o_menu_toggle",content:_t("Click the top left corner to navigate across apps."),tooltipPosition:"bottom",run:"click",},{isActive:["mobile"],trigger:".o_sidebar_topbar a.btn-primary",tooltipPosition:"right",run:"click",},];},autoExpandMoreButtons(isActiveMobile=false){const isActive=["auto"];if(isActiveMobile){isActive.push("mobile");}
return{isActive,content:`autoExpandMoreButtons`,trigger:".o-form-buttonbox",run(){const more=hoot.queryFirst(".o-form-buttonbox .o_button_more");if(more){hoot.click(more);}},};},goToAppSteps(dataMenuXmlid,description){return[this.showAppsMenuItem(),{isActive:["community"],trigger:`.o_app[data-menu-xmlid="${dataMenuXmlid}"]`,content:description,tooltipPosition:"right",run:"click",},{isActive:["enterprise"],trigger:`.o_app[data-menu-xmlid="${dataMenuXmlid}"]`,content:description,tooltipPosition:"bottom",run:"click",},].map((step)=>this.addDebugHelp(this._getHelpMessage("goToApp",dataMenuXmlid,description),step));},statusbarButtonsSteps(innerTextButton,description,trigger){const steps=[];if(trigger){steps.push({isActive:["auto","mobile"],trigger,});}
steps.push({isActive:["auto","mobile"],trigger:".o_cp_action_menus",run:(actions)=>{const node=hoot.queryFirst(".o_cp_action_menus .fa-cog");if(node){hoot.click(node);}},},{trigger:`.o_statusbar_buttons button:enabled:contains('${innerTextButton}'), .dropdown-item button:enabled:contains('${innerTextButton}')`,content:description,tooltipPosition:"bottom",run:"click",});return steps.map((step)=>this.addDebugHelp(this._getHelpMessage("statusbarButtonsSteps",innerTextButton,description),step));},mobileKanbanSearchMany2X(modalTitle,valueSearched){return[{isActive:["mobile"],trigger:`.modal:not(.o_inactive_modal) .o_control_panel_navigation .btn .fa-search`,tooltipPosition:"bottom",run:"click",},{isActive:["mobile"],trigger:".o_searchview_input",tooltipPosition:"bottom",run:`edit ${valueSearched}`,},{isActive:["mobile"],trigger:".dropdown-menu.o_searchview_autocomplete",},{isActive:["mobile"],trigger:".o_searchview_input",tooltipPosition:"bottom",run:"press Enter",},{isActive:["mobile"],trigger:`.o_kanban_record:contains('${valueSearched}')`,tooltipPosition:"bottom",run:"click",},].map((step)=>this.addDebugHelp(this._getHelpMessage("mobileKanbanSearchMany2X",modalTitle,valueSearched),step));},saveForm(){return[{isActive:["auto"],content:"save form",trigger:".o_form_button_save:enabled",run:"click",},{content:"wait for save completion",trigger:".o_form_readonly, .o_form_saved",},];},discardForm(){return[{isActive:["auto"],content:"discard the form",trigger:".o_form_button_cancel",run:"click",},{content:"wait for cancellation to complete",trigger:".o_view_controller.o_list_view, .o_form_view > div > div > .o_form_readonly, .o_form_view > div > div > .o_form_saved",},];},waitIframeIsReady(){return{content:"Wait until the iframe is ready",trigger:`iframe[is-ready=true]:iframe html`,};},goToUrl(url){return{isActive:["auto"],content:`Navigate to ${url}`,trigger:"body",run:`goToUrl ${url}`,};},};return __exports;});;

/* /web_tour/static/src/views/tour_list.js */
odoo.define('@web_tour/views/tour_list',['@web/core/registry','@web/views/list/list_view'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");registry.category("views").add("tour_list",{...listView,buttonTemplate:"web_tour.TourListController.Buttons",});return __exports;});;

/* /web_tour/static/src/widgets/tour_start.js */
odoo.define('@web_tour/widgets/tour_start',['@web/views/fields/char/char_field','@web/core/utils/hooks','@web/core/registry'],function(require){'use strict';let __exports={};const{charField,CharField}=require("@web/views/fields/char/char_field");const{useService}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const TourStartWidget=__exports.TourStartWidget=class TourStartWidget extends CharField{static template="web_tour.TourStartWidget";static props={...CharField.props,link:{type:Boolean,optional:true},};setup(){this.tour=useService("tour_service");}
get tourData(){return this.props.record.data;}
_onStartTour(){this.tour.startTour(this.tourData.name,{mode:"manual",url:this.tourData.url,fromDB:this.tourData.custom,rainbowManMessage:this.tourData.rainbow_man_message,});}
_onTestTour(){this.tour.startTour(this.tourData.name,{mode:"auto",url:this.tourData.url,fromDB:this.tourData.custom,stepDelay:500,showPointerDuration:250,rainbowManMessage:this.tourData.rainbow_man_message,});}}
const tourStartWidgetField=__exports.tourStartWidgetField={...charField,component:TourStartWidget,extractProps:({options})=>({link:options.link,}),};registry.category("fields").add("tour_start_widget",tourStartWidgetField);return __exports;});;

/* /web/static/lib/hoot-dom/helpers/dom.js */
odoo.define('@web/../lib/hoot-dom/helpers/dom',['@web/../lib/hoot-dom/hoot_dom_utils','@web/../lib/hoot-dom/helpers/time'],function(require){'use strict';let __exports={};const{HootDomError,getTag,isFirefox,isIterable,parseRegExp}=require("@web/../lib/hoot-dom/hoot_dom_utils");const{waitUntil}=require("@web/../lib/hoot-dom/helpers/time");const{Boolean,document,DOMParser,innerWidth,innerHeight,Map,MutationObserver,Number:{isInteger:$isInteger,isNaN:$isNaN,parseInt:$parseInt,parseFloat:$parseFloat},Object:{keys:$keys,values:$values},RegExp,Set,}=globalThis;const and=(values)=>{const last=values.pop();if(values.length){return[values.join(", "),last].join(" and ");}else{return last;}};const compilePseudoClassRegex=()=>{const customKeys=[...customPseudoClasses.keys()].filter((k)=>k!=="has"&&k!=="not");return new RegExp(`:(${customKeys.join("|")})`);};const elementsMatch=(elements,selector)=>{if(!elements.length){return false;}
return parseSelector(selector).some((selectorParts)=>{const[baseSelector,...filters]=selectorParts.at(-1);for(let i=0;i<elements.length;i++){if(baseSelector&&!elements[i].matches(baseSelector)){return false;}
if(!filters.every((filter)=>matchFilter(filter,elements,i))){return false;}}
return true;});};const ensureElement=(node)=>{if(node){if(isDocument(node)){return node.documentElement;}
if(isWindow(node)){return node.document.documentElement;}
if(isElement(node)){return node;}}
return null;};const extractLayers=(nodes,level,keepInlineTextNodes)=>{const layers=[];for(const node of nodes){if(node.nodeType===Node.COMMENT_NODE){continue;}
if(node.nodeType===Node.TEXT_NODE){const textContent=node.nodeValue.replaceAll(/\n/g,"");const trimmedTextContent=textContent.trim();if(trimmedTextContent){const inline=textContent===trimmedTextContent;layers.push({inline,level,value:{textContent:trimmedTextContent}});}
continue;}
const[open,close]=node.outerHTML.replace(`>${node.innerHTML}<`,">\n<").split("\n");const layer={inline:false,level,value:{open,close}};layers.push(layer);const childLayers=extractLayers(node.childNodes,level+1,false);if(keepInlineTextNodes&&childLayers.length===1&&childLayers[0].inline){layer.value.textContent=childLayers[0].value.textContent;}else{layers.push(...childLayers);}}
return layers;};const filterUniqueNodes=(nodesToFilter)=>{const nodes=[];for(const node of nodesToFilter){if(isQueryableNode(node)&&!nodes.includes(node)){nodes.push(node);}}
return nodes;};const generateStringFromLayers=(layers,tabSize)=>{const result=[];let layerIndex=0;while(layers.length>0){const layer=layers[layerIndex];const{level,value}=layer;const pad=" ".repeat(tabSize*level);let nextLayerIndex=layerIndex+1;if(value.open){if(value.textContent){result.push(`${pad}${value.open}${value.textContent}${value.close}`);layers.splice(layerIndex,1);nextLayerIndex--;}else{result.push(`${pad}${value.open}`);delete value.open;}}else{if(value.close){result.push(`${pad}${value.close}`);}else if(value.textContent){result.push(`${pad}${value.textContent}`);}
layers.splice(layerIndex,1);nextLayerIndex--;}
if(nextLayerIndex>=layers.length){layerIndex=nextLayerIndex-1;continue;}
const nextLayer=layers[nextLayerIndex];if(nextLayerIndex===0||nextLayer.level>layers[nextLayerIndex-1].level){layerIndex=nextLayerIndex;}else{layerIndex=nextLayerIndex-1;}}
return result.join("\n");};const getNodeContent=(node)=>{switch(getTag(node)){case"input":case"option":case"textarea":return getNodeValue(node);case"select":return[...node.selectedOptions].map(getNodeValue).join(",");}
return getNodeText(node);};const getStringContent=(string)=>string.match(R_QUOTE_CONTENT)?.[2]||string;const isChar=(char)=>Boolean(char)&&R_CHAR.test(char);const isDocument=(object)=>object?.nodeType===Node.DOCUMENT_NODE;const isElement=(object)=>object?.nodeType===Node.ELEMENT_NODE;const isQueryableNode=(node)=>QUERYABLE_NODE_TYPES.includes(node.nodeType);const isRootElement=(el)=>el&&R_ROOT_ELEMENT.test(el.nodeName||"");const isShadowRoot=(el)=>el.nodeType===Node.DOCUMENT_FRAGMENT_NODE&&Boolean(el.host);const isWindow=(object)=>object?.window===object&&object.constructor.name==="Window";const isWhiteSpace=(char)=>Boolean(char)&&R_HORIZONTAL_WHITESPACE.test(char);const makePatternBasedPseudoClass=(pseudoClass,getContent)=>{return(content)=>{let regex;try{regex=parseRegExp(content);}catch(err){throw selectorError(pseudoClass,err.message);}
if(regex instanceof RegExp){return function containsRegExp(node){return regex.test(String(getContent(node)));};}else{const lowerContent=content.toLowerCase();return function containsString(node){return getStringContent(String(getContent(node))).toLowerCase().includes(lowerContent);};}};};const matchFilter=(filter,nodes,index)=>{const node=nodes[index];if(typeof filter==="function"){return filter(node,index,nodes);}else{return node.matches?.(String(filter));}};const parseNumberTuple=(value,propsA,propsB)=>{let result=[];if(value&&typeof value==="object"){if(isIterable(value)){[result[0],result[1]]=[...value];}else{for(const prop of propsA){result[0]??=value[prop];}
for(const prop of propsB){result[1]??=value[prop];}}}else{result=[value,value];}
return result.map($parseFloat);};const parseSelector=(selector)=>{const addToSelector=(selector)=>{registerChar=false;const index=currentPart.length-1;if(typeof currentPart[index]==="string"){currentPart[index]+=selector;}else{currentPart.push(selector);}};const firstPart=[""];const firstGroup=[firstPart];const groups=[firstGroup];const parens=[0,0];let currentGroup=groups.at(-1);let currentPart=currentGroup.at(-1);let currentPseudo=null;let currentQuote=null;let registerChar=true;for(let i=0;i<selector.length;i++){const char=selector[i];registerChar=true;switch(char){case",":{if(!currentQuote&&!currentPseudo){groups.push([[""]]);currentGroup=groups.at(-1);currentPart=currentGroup.at(-1);registerChar=false;}
break;}
case" ":case"\t":case"\n":case"\r":case"\f":case"\v":{if(!currentQuote&&!currentPseudo){if(currentPart[0]||currentPart.length>1){currentGroup.push([""]);currentPart=currentGroup.at(-1);}
registerChar=false;}
break;}
case`'`:case`"`:{if(char===currentQuote){currentQuote=null;}else if(!currentQuote){currentQuote=char;}
break;}
case">":case"+":case"~":{if(!currentQuote&&!currentPseudo){while(isWhiteSpace(selector[i+1])){i++;}
addToSelector(char);}
break;}
case":":{if(!currentQuote&&!currentPseudo){let pseudo="";while(isChar(selector[i+1])){pseudo+=selector[++i];}
if(customPseudoClasses.has(pseudo)){if(selector[i+1]==="("){parens[0]++;i++;registerChar=false;}
currentPseudo=[pseudo,""];}else{addToSelector(char+pseudo);}}
break;}
case"(":{if(!currentQuote){parens[0]++;}
break;}
case")":{if(!currentQuote){parens[1]++;}
break;}}
if(currentPseudo){if(parens[0]===parens[1]){const[pseudo,content]=currentPseudo;const makeFilter=customPseudoClasses.get(pseudo);if(pseudo==="iframe"&&!currentPart[0].startsWith("iframe")){currentPart[0]=`iframe${currentPart[0]}`;}
currentPart.push(makeFilter(getStringContent(content)));currentPseudo=null;}else if(registerChar){currentPseudo[1]+=selector[i];}}else if(registerChar){addToSelector(selector[i]);}}
return groups;};const parseXml=(xmlString,type)=>{const wrapperTag=type==="html"?"body":"templates";const document=parser.parseFromString(`<${wrapperTag}>${xmlString}</${wrapperTag}>`,`text/${type}`);if(document.getElementsByTagName("parsererror").length){const trimmed=xmlString.length>80?xmlString.slice(0,80)+"…":xmlString;throw new HootDomError(`error while parsing ${trimmed}: ${getNodeText(
                document.getElementsByTagName("parsererror")[0]
            )}`);}
return document.getElementsByTagName(wrapperTag)[0].childNodes;};const pixelValueToNumber=(val)=>$parseFloat(val.endsWith("px")?val.slice(0,-2):val);const queryWithCustomSelector=(nodes,selector)=>{const selectorGroups=parseSelector(selector);const foundNodes=[];for(const selectorParts of selectorGroups){let groupNodes=nodes;for(const[partSelector,...filters]of selectorParts){let baseSelector=partSelector;let nodeGetter;switch(baseSelector[0]){case"+":{nodeGetter=NEXT_SIBLING;break;}
case">":{nodeGetter=DIRECT_CHILDREN;break;}
case"~":{nodeGetter=NEXT_SIBLINGS;break;}}
if(nodeGetter){baseSelector=baseSelector.slice(1);}
const getNodes=nodeGetter||DESCENDANTS;let currentGroupNodes=groupNodes.flatMap((node)=>getNodes(node,baseSelector));const pseudosReturningNode=new Set();for(const filter of filters){const filteredGroupNodes=[];for(let i=0;i<currentGroupNodes.length;i++){const result=matchFilter(filter,currentGroupNodes,i);if(result===true){filteredGroupNodes.push(currentGroupNodes[i]);}else if(result){filteredGroupNodes.push(result);pseudosReturningNode.add(filter.name);}}
if(pseudosReturningNode.size>1){const pseudoList=[...pseudosReturningNode];throw selectorError(pseudoList[0],`cannot use multiple pseudo-classes returning nodes (${and(pseudoList)})`);}
currentGroupNodes=filteredGroupNodes;}
groupNodes=currentGroupNodes;}
foundNodes.push(...groupNodes);}
return filterUniqueNodes(foundNodes);};const selectorError=(pseudoClass,message)=>new HootDomError(`invalid selector \`:${pseudoClass}\`: ${message}`);const R_CHAR=/[\w-]/;const R_QUOTE_CONTENT=/^\s*(['"])?([^]*?)\1\s*$/;const R_ROOT_ELEMENT=/^(HTML|HEAD|BODY)$/;const R_LINEBREAK=/\s*\n+\s*/g;const R_HORIZONTAL_WHITESPACE=/[\r\t\f \u00a0\u1680\u2000-\u200a\u2028\u2029\u202f\u205f\u3000\ufeff]+/g;const QUERYABLE_NODE_TYPES=[Node.ELEMENT_NODE,Node.DOCUMENT_NODE,Node.DOCUMENT_FRAGMENT_NODE];const parser=new DOMParser();const DIRECT_CHILDREN=(node,selector)=>{const children=[];for(const childNode of node.childNodes){if(childNode.matches?.(selector)){children.push(childNode);}}
return children;};const DESCENDANTS=(node,selector)=>[...(node.querySelectorAll?.(selector||"*")||[])];const NEXT_SIBLING=(node,selector)=>{const sibling=node.nextElementSibling;return sibling?.matches?.(selector)?[sibling]:[];};const NEXT_SIBLINGS=(node,selector)=>{const siblings=[];while((node=node.nextElementSibling)){if(node.matches?.(selector)){siblings.push(node);}}
return siblings;};const observers=new Map();const currentDimensions={width:innerWidth,height:innerHeight,};let getDefaultRoot=()=>document;const customPseudoClasses=new Map();customPseudoClasses.set("contains",makePatternBasedPseudoClass("contains",getNodeText)).set("displayed",()=>{return function displayed(node){return isNodeDisplayed(node);};}).set("empty",()=>{return function empty(node){return isEmpty(node);};}).set("eq",(content)=>{const index=$parseInt(content);if(!$isInteger(index)){throw selectorError("eq",`expected index to be an integer (got ${content})`);}
return function eq(node,i,nodes){return index<0?i===nodes.length+index:i===index;};}).set("first",()=>{return function first(node,i){return i===0;};}).set("focusable",()=>{return function focusable(node){return isNodeFocusable(node);};}).set("has",(content)=>{return function has(node){return Boolean(queryAll(content,{root:node}).length);};}).set("hidden",()=>{return function hidden(node){return!isNodeVisible(node);};}).set("iframe",()=>{return function iframe(node){const doc=node.contentDocument;return doc&&doc.readyState!=="loading"?doc:false;};}).set("last",()=>{return function last(node,i,nodes){return i===nodes.length-1;};}).set("not",(content)=>{return function not(node){return!matches(node,content);};}).set("only",()=>{return function only(node,i,nodes){return nodes.length===1;};}).set("scrollable",()=>{return function scrollable(node){return isNodeScrollable(node);};}).set("selected",()=>{return function selected(node){return Boolean(node.selected);};}).set("shadow",()=>{return function shadow(node){return node.shadowRoot||false;};}).set("value",makePatternBasedPseudoClass("value",getNodeValue)).set("visible",()=>{return function visible(node){return isNodeVisible(node);};});const rCustomPseudoClass=compilePseudoClassRegex();__exports.cleanupDOM=cleanupDOM;function cleanupDOM(){currentDimensions.width=innerWidth;currentDimensions.height=innerHeight;const remainingObservers=observers.size;if(remainingObservers){for(const{observer}of observers.values()){observer.disconnect();}
observers.clear();}}
__exports.defineRootNode=defineRootNode;function defineRootNode(node){if(typeof node==="function"){getDefaultRoot=node;}else if(node){getDefaultRoot=()=>node;}else{getDefaultRoot=()=>document;}}
__exports.getCurrentDimensions=getCurrentDimensions;function getCurrentDimensions(){return currentDimensions;}
__exports.getDocument=getDocument;function getDocument(node){node||=getDefaultRoot();return isDocument(node)?node:node.ownerDocument||document;}
__exports.getNodeAttribute=getNodeAttribute;function getNodeAttribute(node,attribute){return node.getAttribute?.(attribute)??null;}
__exports.getNodeValue=getNodeValue;function getNodeValue(node){switch(node.type){case"checkbox":case"radio":return node.checked;case"file":return[...node.files];case"number":case"range":return node.valueAsNumber;case"date":case"datetime-local":case"month":case"time":case"week":return node.valueAsDate.toISOString();}
return node.value;}
__exports.getNodeRect=getNodeRect;function getNodeRect(node,options){if(!isElement(node)){return new DOMRect();}
const rect=node.getBoundingClientRect();const parentFrame=getParentFrame(node);if(parentFrame){const parentRect=getNodeRect(parentFrame);rect.x-=parentRect.x;rect.y-=parentRect.y;}
if(!options?.trimPadding){return rect;}
const style=getStyle(node);const{x,y,width,height}=rect;const[pl,pr,pt,pb]=["left","right","top","bottom"].map((side)=>pixelValueToNumber(style.getPropertyValue(`padding-${side}`)));return new DOMRect(x+pl,y+pt,width-(pl+pr),height-(pt+pb));}
__exports.getNodeText=getNodeText;function getNodeText(node,options){let content;if(typeof node.innerText==="string"){content=node.innerText;}else{content=node.textContent;}
if(!options?.raw){content=content.replace(R_HORIZONTAL_WHITESPACE," ").trim();}
if(options?.inline){content=content.replace(R_LINEBREAK," ");}
return content;}
__exports.getStyle=getStyle;function getStyle(node){return isElement(node)?getComputedStyle(node):null;}
__exports.getWindow=getWindow;function getWindow(node){return getDocument(node).defaultView;}
__exports.isCheckable=isCheckable;function isCheckable(node){switch(getTag(node)){case"input":return node.type==="checkbox"||node.type==="radio";case"label":return isCheckable(node.control);default:return false;}}
__exports.isEmpty=isEmpty;function isEmpty(value){if(!value){return true;}
if(typeof value==="object"){if(isNode(value)){return isEmpty(getNodeContent(value));}
if(!isIterable(value)){value=$keys(value);}
return[...value].length===0;}
return false;}
__exports.isEventTarget=isEventTarget;function isEventTarget(object){return object&&typeof object.addEventListener==="function";}
__exports.isNode=isNode;function isNode(object){return object&&typeof object.nodeType==="number"&&typeof object.nodeName==="string";}
__exports.isNodeCssVisible=isNodeCssVisible;function isNodeCssVisible(node){const element=ensureElement(node);if(element===getDefaultRoot()||isRootElement(element)){return true;}
const style=getStyle(element);if(style?.visibility==="hidden"||style?.opacity==="0"){return false;}
const parent=element.parentNode;return!parent||isNodeCssVisible(isShadowRoot(parent)?parent.host:parent);}
__exports.isNodeDisplayed=isNodeDisplayed;function isNodeDisplayed(node){const element=ensureElement(node);if(!isInDOM(element)){return false;}
if(isRootElement(element)||element.offsetParent||element.closest("svg")){return true;}
return!isFirefox()&&getStyle(element)?.position==="fixed";}
__exports.isNodeFocusable=isNodeFocusable;function isNodeFocusable(node,options){return(isNodeDisplayed(node)&&node.matches?.(FOCUSABLE_SELECTOR)&&(!options?.tabbable||node.tabIndex>=0));}
__exports.isNodeInViewPort=isNodeInViewPort;function isNodeInViewPort(node){const element=ensureElement(node);const{x,y}=getNodeRect(element);return y>0&&y<currentDimensions.height&&x>0&&x<currentDimensions.width;}
__exports.isNodeScrollable=isNodeScrollable;function isNodeScrollable(node,axis){if(!isElement(node)){return false;}
const[scrollProp,sizeProp]=axis==="x"?["scrollWidth","clientWidth"]:["scrollHeight","clientHeight"];if(node[scrollProp]>node[sizeProp]){const overflow=getStyle(node).getPropertyValue("overflow");if(/\bauto\b|\bscroll\b/.test(overflow)){return true;}}
return false;}
__exports.isNodeVisible=isNodeVisible;function isNodeVisible(node){const element=ensureElement(node);if(!isNodeDisplayed(element)||!isNodeCssVisible(element)){return false;}
let visible=false;const{width,height}=getNodeRect(element);visible=width>0&&height>0;if(!visible&&getStyle(element)?.display==="contents"){for(const child of element.childNodes){if(isNodeVisible(child)){return true;}}}
return visible;}
__exports.parseDimensions=parseDimensions;function parseDimensions(dimensions){return parseNumberTuple(dimensions,["width","w"],["height","h"]);}
__exports.parsePosition=parsePosition;function parsePosition(position){return parseNumberTuple(position,["x","left","clientX","pageX","screenX"],["y","top","clientY","pageY","screenY"]);}
__exports.setDimensions=setDimensions;function setDimensions(width,height){const defaultRoot=getDefaultRoot();if(!$isNaN(width)){currentDimensions.width=width;defaultRoot.style?.setProperty("width",`${width}px`,"important");}
if(!$isNaN(height)){currentDimensions.height=height;defaultRoot.style?.setProperty("height",`${height}px`,"important");}}
__exports.toSelector=toSelector;function toSelector(node,options){const parts={tag:node.nodeName.toLowerCase(),};if(node.id){parts.id=`#${node.id}`;}
if(node.classList?.length){parts.class=`.${[...node.classList].join(".")}`;}
return options?.object?parts:$values(parts).join("");}
const FOCUSABLE_SELECTOR=__exports.FOCUSABLE_SELECTOR=["a[href]","area[href]","button:enabled","details > summary:first-of-type","iframe","input:enabled","select:enabled","textarea:enabled","[tabindex]","[contenteditable=true]",].join(",");__exports.formatXml=formatXml;function formatXml(value,options){const nodes=parseXml(value,options?.type||"xml");const layers=extractLayers(nodes,0,options?.keepInlineTextNodes??false);return generateStringFromLayers(layers,options?.tabSize??4);}
__exports.getActiveElement=getActiveElement;function getActiveElement(node){const document=getDocument(node);const window=getWindow(node);const{activeElement}=document;const{contentDocument,shadowRoot}=activeElement;if(contentDocument&&contentDocument.activeElement!==contentDocument.body){if(contentDocument.activeElement===contentDocument.body){return contentDocument.activeElement;}else{return getActiveElement(contentDocument);}}
if(shadowRoot){return shadowRoot.activeElement;}
if(activeElement===document.body&&window!==window.parent){return getActiveElement(window.parent.document);}
return activeElement;}
__exports.getFocusableElements=getFocusableElements;function getFocusableElements(options){const parent=queryOne(options?.root||getDefaultRoot());if(typeof parent.querySelectorAll!=="function"){return[];}
const byTabIndex={};for(const element of parent.querySelectorAll(FOCUSABLE_SELECTOR)){const{tabIndex}=element;if((options?.tabbable&&tabIndex<0)||!isNodeDisplayed(element)){continue;}
if(!byTabIndex[tabIndex]){byTabIndex[tabIndex]=[];}
byTabIndex[tabIndex].push(element);}
const withTabIndexZero=byTabIndex[0]||[];delete byTabIndex[0];return[...$values(byTabIndex).flat(),...withTabIndexZero];}
__exports.getNextFocusableElement=getNextFocusableElement;function getNextFocusableElement(options){const parent=queryOne(options?.root||getDefaultRoot());const focusableEls=getFocusableElements({...options,parent});const index=focusableEls.indexOf(getActiveElement(parent));return focusableEls[index+1]||null;}
__exports.getParentFrame=getParentFrame;function getParentFrame(node){const document=getDocument(node);if(!document){return null;}
const view=document.defaultView;if(view!==view.parent){for(const iframe of view.parent.document.getElementsByTagName("iframe")){if(iframe.contentWindow===view){return iframe;}}}
return null;}
__exports.getPreviousFocusableElement=getPreviousFocusableElement;function getPreviousFocusableElement(options){const parent=queryOne(options?.root||getDefaultRoot());const focusableEls=getFocusableElements({...options,parent});const index=focusableEls.indexOf(getActiveElement(parent));return index<0?focusableEls.at(-1):focusableEls[index-1]||null;}
__exports.isDisplayed=isDisplayed;function isDisplayed(target){return queryAll(target,{displayed:true}).length>0;}
__exports.isEditable=isEditable;function isEditable(node){return(isElement(node)&&!node.matches?.(":disabled")&&["input","textarea"].includes(getTag(node)));}
__exports.isFocusable=isFocusable;function isFocusable(target,options){const nodes=queryAll(...arguments);return nodes.length&&nodes.every((node)=>isNodeFocusable(node,options));}
__exports.isInDOM=isInDOM;function isInDOM(target){return ensureElement(target)?.isConnected;}
__exports.isInViewPort=isInViewPort;function isInViewPort(target){return queryAll(target,{viewPort:true}).length>0;}
__exports.isScrollable=isScrollable;function isScrollable(target,axis){const nodes=queryAll(target);return nodes.length&&nodes.every((node)=>isNodeScrollable(node,axis));}
__exports.isVisible=isVisible;function isVisible(target){return queryAll(target,{visible:true}).length>0;}
__exports.matches=matches;function matches(target,selector){return elementsMatch(queryAll(target),selector);}
__exports.observe=observe;function observe(target,callback){if(observers.has(target)){observers.get(target).callbacks.add(callback);}else{const callbacks=new Set([callback]);const observer=new MutationObserver((mutations,observer)=>{for(const callback of callbacks){callback(mutations,observer);}});observer.observe(target,{attributes:true,characterData:true,childList:true,subtree:true,});observers.set(target,{callbacks,observer});}
return function disconnect(){if(!observers.has(target)){return;}
const{callbacks,observer}=observers.get(target);callbacks.delete(callback);if(!callbacks.size){observer.disconnect();observers.delete(target);}};}
__exports.queryAll=queryAll;function queryAll(target,options){if(!target){return[];}
if(target.raw){return queryAll(String.raw(...arguments));}
const{exact,displayed,root,viewPort,visible}=options||{};let nodes=[];let selector;if(typeof target==="string"){nodes=root?queryAll(root):[getDefaultRoot()];selector=target.trim();}else if(isIterable(target)&&!isNode(target)){nodes=filterUniqueNodes(target);}else{nodes=filterUniqueNodes([target]);}
if(selector&&nodes.length){if(rCustomPseudoClass.test(selector)){nodes=queryWithCustomSelector(nodes,selector);}else{nodes=filterUniqueNodes(nodes.flatMap((node)=>DESCENDANTS(node,selector)));}}
let prefix,suffix;if(visible+displayed>1){throw new HootDomError(`cannot use more than one visibility modifier ('visible' implies 'displayed')`);}
if(viewPort){nodes=nodes.filter(isNodeInViewPort);suffix="in viewport";}else if(visible){nodes=nodes.filter(isNodeVisible);prefix="visible";}else if(displayed){nodes=nodes.filter(isNodeDisplayed);prefix="displayed";}
const count=nodes.length;if($isInteger(exact)&&count!==exact){const s=count===1?"":"s";const strPrefix=prefix?`${prefix} `:"";const strSuffix=suffix?` ${suffix}`:"";const strSelector=typeof target==="string"?`(selector: "${target}")`:"";throw new HootDomError(`found ${count} ${strPrefix}node${s}${strSuffix} instead of ${exact} ${strSelector}`);}
return nodes;}
__exports.queryAttribute=queryAttribute;function queryAttribute(target,attribute,options){return getNodeAttribute(queryOne(target,options),attribute);}
__exports.queryAllAttributes=queryAllAttributes;function queryAllAttributes(target,attribute,options){return queryAll(target,options).map((node)=>getNodeAttribute(node,attribute));}
__exports.queryAllProperties=queryAllProperties;function queryAllProperties(target,property,options){return queryAll(target,options).map((node)=>node[property]);}
__exports.queryAllRects=queryAllRects;function queryAllRects(target,options){return queryAll(...arguments).map(getNodeRect);}
__exports.queryAllTexts=queryAllTexts;function queryAllTexts(target,options){return queryAll(...arguments).map((node)=>getNodeText(node,options));}
__exports.queryAllValues=queryAllValues;function queryAllValues(target,options){return queryAll(...arguments).map(getNodeValue);}
__exports.queryFirst=queryFirst;function queryFirst(target,options){return queryAll(...arguments)[0]||null;}
__exports.queryOne=queryOne;function queryOne(target,options){if(target.raw){return queryOne(String.raw(...arguments));}
if($isInteger(options?.exact)){throw new HootDomError(`cannot call \`queryOne\` with 'exact'=${options.exact}: did you mean to use \`queryAll\`?`);}
return queryAll(target,{...options,exact:1})[0];}
__exports.queryRect=queryRect;function queryRect(target,options){return getNodeRect(queryOne(...arguments),options);}
__exports.queryText=queryText;function queryText(target,options){return getNodeText(queryOne(...arguments),options);}
__exports.queryValue=queryValue;function queryValue(target,options){return getNodeValue(queryOne(...arguments));}
__exports.waitFor=waitFor;function waitFor(target,options){return waitUntil(()=>queryFirst(...arguments),{message:`Could not find elements matching "${target}" within %timeout% milliseconds`,...options,});}
__exports.waitForNone=waitForNone;function waitForNone(target,options){let count=0;return waitUntil(()=>{count=queryAll(...arguments).length;return!count;},{message:()=>`Could still find ${count} elements matching "${target}" after %timeout% milliseconds`,...options,});}
return __exports;});;

/* /web/static/lib/hoot-dom/helpers/events.js */
odoo.define('@web/../lib/hoot-dom/helpers/events',['@web/../lib/hoot-dom/hoot_dom_utils','@web/../lib/hoot-dom/helpers/dom','@web/../lib/hoot-dom/helpers/time'],function(require){'use strict';let __exports={};const{HootDomError,getTag,isFirefox,isIterable}=require("@web/../lib/hoot-dom/hoot_dom_utils");const{getActiveElement,getDocument,getNextFocusableElement,getNodeRect,getNodeValue,getParentFrame,getPreviousFocusableElement,getStyle,getWindow,isCheckable,isEditable,isEventTarget,isNode,isNodeFocusable,parseDimensions,parsePosition,queryAll,queryFirst,setDimensions,toSelector,}=require("@web/../lib/hoot-dom/helpers/dom");const{microTick}=require("@web/../lib/hoot-dom/helpers/time");const{AnimationEvent,ClipboardEvent,CompositionEvent,console:{dir:$dir,groupCollapsed:$groupCollapsed,groupEnd:$groupEnd,log:$log},DataTransfer,document,DragEvent,ErrorEvent,Event,File,FocusEvent,KeyboardEvent,Math:{ceil:$ceil,max:$max,min:$min},MouseEvent,Number:{isInteger:$isInteger,isNaN:$isNaN,parseFloat:$parseFloat},Object:{assign:$assign,create:$create,defineProperties:$defineProperties,values:$values,},PointerEvent,PromiseRejectionEvent,String,SubmitEvent,Touch,TouchEvent,TypeError,WheelEvent,}=globalThis;const $createRange=document.createRange.bind(document);const $toString=Object.prototype.toString;const cancelTrustedEvent=(ev)=>{if(ev.isTrusted&&runTime.eventsToIgnore.includes(ev.type)){runTime.eventsToIgnore.splice(runTime.eventsToIgnore.indexOf(ev.type),1);ev.stopPropagation();ev.stopImmediatePropagation();ev.preventDefault();}};const changeSelection=async(target,start,end)=>{if(!isNil(start)&&!isNil(target.selectionStart)){target.selectionStart=start;}
if(!isNil(end)&&!isNil(target.selectionEnd)){target.selectionEnd=end;}};const constrainScrollX=(target,x)=>{let{offsetWidth,scrollWidth}=target;const document=getDocument(target);if(target===document||target===document.documentElement){const iframe=getParentFrame(target);if(iframe){({offsetWidth}=iframe);}}
const maxScrollLeft=scrollWidth-offsetWidth;const{direction}=getStyle(target);const[min,max]=direction==="rtl"?[-maxScrollLeft,0]:[0,maxScrollLeft];return $min($max(x,min),max);};const constrainScrollY=(target,y)=>{let{offsetHeight,scrollHeight}=target;const document=getDocument(target);if(target===document||target===document.documentElement){const iframe=getParentFrame(target);if(iframe){({offsetHeight}=iframe);}}
return $min($max(y,0),scrollHeight-offsetHeight);};const createDataTransfer=(options)=>{const dataTransfer=options?.dataTransfer instanceof DataTransfer?options.dataTransfer:new DataTransfer();const types=new Set();for(const file of options?.files||[]){if(!(file instanceof File)){throw new TypeError(`'DataTransfer.files' list only accepts 'File' objects`);}
dataTransfer.items.add(file);types.add("Files");}
for(const[data,type]of options?.items||[]){dataTransfer.items.add(data,type);types.add(type);}
$defineProperties(dataTransfer,{dropEffect:{value:options?.dropEffect||"none",writable:true},effectAllowed:{value:options?.effectAllowed||"all",writable:true},types:{value:[...types],writable:true},});return dataTransfer;};const deleteSelection=(target)=>{const{selectionStart,selectionEnd,value}=target;return value.slice(0,selectionStart)+value.slice(selectionEnd);};const dispatchAndIgnore=async({target,events,additionalEvents=[],callback,options})=>{for(const eventType of[...events,...additionalEvents]){runTime.eventsToIgnore.push(eventType);}
if(callback){callback(target);}
for(const eventType of events){await dispatch(target,eventType,options);}};const dispatchPointerEvent=async(target,eventType,eventInit,{mouse,touch})=>{const pointerEvent=await dispatch(target,eventType,eventInit);let prevented=isPrevented(pointerEvent);if(hasTouch()){if(touch&&runTime.pointerDownTarget){const[touchEventType,touchEventInit]=touch;await dispatch(runTime.pointerDownTarget,touchEventType,touchEventInit||eventInit);}}else{if(mouse&&!prevented){const[mouseEventType,mouseEventInit]=mouse;const mouseEvent=await dispatch(target,mouseEventType,mouseEventInit||eventInit);prevented=isPrevented(mouseEvent);}}
return prevented;};const dispatchRelatedEvents=async(events,eventType,eventInit)=>{for(const event of events){if(!event.target||isPrevented(event)){break;}
await dispatch(event.target,eventType,eventInit);}};const ensureArray=(value)=>(isIterable(value)?[...value]:[value]);const getCurrentEvents=()=>{const eventType=currentEventTypes.at(-1);if(!eventType){return[];}
currentEvents[eventType]||=[];return currentEvents[eventType];};const getDefaultRunTimeValue=()=>({isComposing:false,clipboardData:null,dataTransfer:null,canStartDrag:false,isDragging:false,lastDragOverCancelled:false,clickCount:0,key:null,pointerDownTarget:null,pointerDownTimeout:0,pointerTarget:null,position:{},previousPointerDownTarget:null,previousPointerTarget:null,touchStartPosition:{},fileInput:null,buttons:0,modifierKeys:{},eventsToIgnore:[],});const getDifferentParents=(el1,el2)=>{if(!el1&&!el2){return[];}else if(!el1&&el2){[el1,el2]=[el2,el1];}
const parents=[el2||el1];while(parents[0].parentElement){const parent=parents[0].parentElement;if(el2&&parent.contains(el1)){break;}
parents.unshift(parent);}
return parents;};const getEventConstructor=(eventType)=>{switch(eventType){case"dblclick":case"mousedown":case"mouseup":case"mousemove":case"mouseover":case"mouseout":return[MouseEvent,mapMouseEvent,BUBBLES|CANCELABLE|VIEW];case"mouseenter":case"mouseleave":return[MouseEvent,mapMouseEvent,VIEW];case"auxclick":case"click":case"contextmenu":case"pointerdown":case"pointerup":case"pointermove":case"pointerover":case"pointerout":return[PointerEvent,mapPointerEvent,BUBBLES|CANCELABLE|VIEW];case"pointerenter":case"pointerleave":case"pointercancel":return[PointerEvent,mapPointerEvent,VIEW];case"blur":case"focus":return[FocusEvent,mapEvent];case"focusin":case"focusout":return[FocusEvent,mapEvent,BUBBLES];case"cut":case"copy":case"paste":return[ClipboardEvent,mapEvent,BUBBLES];case"keydown":case"keyup":return[KeyboardEvent,mapKeyboardEvent,BUBBLES|CANCELABLE|VIEW];case"drag":case"dragend":case"dragenter":case"dragstart":case"dragleave":case"dragover":case"drop":return[DragEvent,mapEvent,BUBBLES|CANCELABLE];case"beforeinput":return[InputEvent,mapInputEvent,BUBBLES|CANCELABLE|VIEW];case"input":return[InputEvent,mapInputEvent,BUBBLES|VIEW];case"compositionstart":case"compositionend":return[CompositionEvent,mapEvent,BUBBLES];case"select":case"selectionchange":return[Event,mapEvent,BUBBLES];case"touchstart":case"touchend":case"touchmove":return[TouchEvent,mapTouchEvent,BUBBLES|CANCELABLE|VIEW];case"touchcancel":return[TouchEvent,mapTouchEvent,BUBBLES|VIEW];case"resize":return[Event,mapEvent];case"submit":return[SubmitEvent,mapEvent,BUBBLES|CANCELABLE];case"wheel":return[WheelEvent,mapWheelEvent,BUBBLES|VIEW];case"animationcancel":case"animationend":case"animationiteration":case"animationstart":{return[AnimationEvent,mapEvent,BUBBLES|CANCELABLE];}
case"error":return[ErrorEvent,mapEvent];case"unhandledrejection":return[PromiseRejectionEvent,mapEvent,CANCELABLE];case"beforeunload":return[Event,mapEvent,CANCELABLE];case"unload":return[Event,mapEvent];default:return[Event,mapEvent,BUBBLES];}};const getFirstCommonParent=(a,b)=>{if(!a||!b||a.ownerDocument!==b.ownerDocument){return null;}
const range=document.createRange();range.setStart(a,0);range.setEnd(b,0);if(range.collapsed){range.setStart(b,0);range.setEnd(a,0);}
return range.commonAncestorContainer;};const getPosition=(element,options)=>{const{position,relative}=options||{};const isString=typeof position==="string";const[posX,posY]=parsePosition(position);if(!isString&&!relative&&!$isNaN(posX)&&!$isNaN(posY)){return toEventPosition(posX,posY,position);}
const{x,y,width,height}=getNodeRect(element);let clientX=x;let clientY=y;if(isString){const positions=position.split("-");if(positions.includes("left")){clientX-=1;}else if(positions.includes("right")){clientX+=$ceil(width)+1;}else{clientX+=width/2;}
if(positions.includes("top")){clientY-=1;}else if(positions.includes("bottom")){clientY+=$ceil(height)+1;}else{clientY+=height/2;}}else{if($isNaN(posX)){clientX+=width/2;}else{if(relative){clientX+=posX||0;}else{clientX=posX||0;}}
if($isNaN(posY)){clientY+=height/2;}else{if(relative){clientY+=posY||0;}else{clientY=posY||0;}}}
return toEventPosition(clientX,clientY,position);};const getStringSelection=(target)=>$isInteger(target.selectionStart)&&$isInteger(target.selectionEnd)&&[target.selectionStart,target.selectionEnd].join(",");const hasTagName=(node,...tagNames)=>tagNames.includes(getTag(node));const hasTouch=()=>globalThis.ontouchstart!==undefined||globalThis.matchMedia("(pointer:coarse)").matches;const isDifferentPosition=(target,options)=>{const previous=runTime.position;const next=isNode(target)?getPosition(target,options):target;for(const key in next){if(previous[key]!==next[key]){return true;}}
return false;};const isDictionary=(object)=>$toString.call(object)==="[object Object]";const isNil=(value)=>value===null||value===undefined;const isPrevented=(event)=>event&&event.defaultPrevented;const parseKeyStrokes=(keyStrokes,options)=>(isIterable(keyStrokes)?[...keyStrokes]:[keyStrokes]).map((key)=>{const lower=key.toLowerCase();return{...options,key:lower.length===1?key:KEY_ALIASES[lower]||key,};});const redirectSubmit=(ev)=>{if(isPrevented(ev)){return;}
ev.preventDefault();const form=ev.target;globalThis.fetch(form.action,{method:form.method,body:new FormData(form,ev.submitter),});};const registerButton=(eventInit,toggle)=>{let value=0;switch(eventInit.button){case btn.LEFT:{value=1;break;}
case btn.MIDDLE:{value=4;break;}
case btn.RIGHT:{value=2;break;}
case btn.BACK:{value=8;break;}
case btn.FORWARD:{value=16;break;}}
runTime.buttons=$max(runTime.buttons+(toggle?value:-value),0);};const registerFileInput=({target})=>{if(getTag(target)==="input"&&target.type==="file"){runTime.fileInput=target;}else{runTime.fileInput=null;}};const registerForChange=async(target,initialValue,confirmAction)=>{const dispatchChange=()=>target.value!==initialValue&&dispatch(target,"change");confirmAction&&=confirmAction.toLowerCase();if(confirmAction==="auto"){confirmAction=getTag(target)==="input"?"enter":"blur";}
if(getTag(target)==="input"){changeTargetListeners.push(on(target,"keydown",(ev)=>{if(isPrevented(ev)||ev.key!=="Enter"){return;}
removeChangeTargetListeners();afterNextDispatch=dispatchChange;}));}else if(confirmAction==="enter"){throw new HootDomError(`"enter" confirm action is only supported on <input/> elements`);}
changeTargetListeners.push(on(target,"blur",()=>{removeChangeTargetListeners();dispatchChange();}),on(target,"change",removeChangeTargetListeners));switch(confirmAction){case"blur":{await _click(getDocument(target).body,{position:{x:0,y:0},});break;}
case"enter":{await _press(target,{key:"Enter"});break;}
case"tab":{await _press(target,{key:"Tab"});break;}}};const registerSpecialKey=(eventInit,toggle)=>{switch(eventInit.key){case"Alt":{runTime.modifierKeys.altKey=toggle;break;}
case"Control":{runTime.modifierKeys.ctrlKey=toggle;break;}
case"Meta":{runTime.modifierKeys.metaKey=toggle;break;}
case"Shift":{runTime.modifierKeys.shiftKey=toggle;break;}}};const removeChangeTargetListeners=()=>{while(changeTargetListeners.length){changeTargetListeners.pop()();}};const setPointerDownTarget=(target)=>{if(runTime.pointerDownTarget){runTime.previousPointerDownTarget=runTime.pointerDownTarget;}
runTime.pointerDownTarget=target;runTime.canStartDrag=false;};const setPointerTarget=async(target,options)=>{runTime.previousPointerTarget=runTime.pointerTarget;runTime.pointerTarget=target;if(runTime.canStartDrag){const dragStartEvent=await dispatch(runTime.previousPointerTarget,"dragstart",{dataTransfer:runTime.dataTransfer,});runTime.isDragging=!isPrevented(dragStartEvent);runTime.canStartDrag=false;}
runTime.position=target&&getPosition(target,options);};const setupEvents=(type,options)=>{currentEventTypes.push(type);$assign(currentEventInit,options?.eventInit);return()=>{for(const eventType in currentEventInit){delete currentEventInit[eventType];}
const events=new EventList(getCurrentEvents());const currentType=currentEventTypes.pop();delete currentEvents[currentType];if(!allowLogs){return events;}
const groupName=[`${type}: dispatched`,events.length,`events`];$groupCollapsed(...groupName);for(const event of events){const colors=["blue"];const typeList=[event.type];if(event.key){typeList.push(event.key);}else if(event.button){typeList.push(event.button);}
[...Array(typeList.length)].forEach(()=>colors.push("orange"));const typeString=typeList.map((t)=>`%c"${t}"%c`).join(", ");let message=`%c${event.constructor.name}%c<${typeString}>`;if(event.__bubbleCount){message+=` (${event.__bubbleCount})`;}
const target=event.__originalTarget||event.target;if(isNode(target)){const targetParts=toSelector(target,{object:true});colors.push("blue");if(targetParts.id){colors.push("orange");}
if(targetParts.class){colors.push("lightBlue");}
const targetString=$values(targetParts).map((part)=>`%c${part}%c`).join("");message+=` @${targetString}`;}
const messageColors=colors.flatMap((color)=>[`color: ${LOG_COLORS[color]}; font-weight: normal`,`color: ${LOG_COLORS.reset}`,]);$groupCollapsed(message,...messageColors);$dir(event);$log(target);$groupEnd();}
$groupEnd();return events;};};const toEventPosition=(clientX,clientY,position)=>{clientX||=0;clientY||=0;return{clientX,clientY,pageX:position?.pageX??clientX,pageY:position?.pageY??clientY,screenX:position?.screenX??clientX,screenY:position?.screenY??clientY,};};const triggerClick=async(target,pointerInit)=>{if(target.disabled){return;}
const eventType=(pointerInit.button??0)===btn.LEFT?"click":"auxclick";const clickEvent=await dispatch(target,eventType,pointerInit);if(isPrevented(clickEvent)){return;}
if(isFirefox()){switch(getTag(target)){case"label":{target=target.control;if(target){await triggerClick(target,pointerInit);}
break;}
case"option":{const parent=target.parentElement;if(parent&&getTag(parent)==="select"){await dispatch(parent,"change");}
break;}}}};const triggerDrag=async(target,eventInit)=>{await dispatch(target,"drag",eventInit);const dragOverEvent=await dispatch(target,"dragover",eventInit);return isPrevented(dragOverEvent);};const triggerFocus=async(target)=>{const previous=getActiveElement(target);if(previous===target){return;}
if(previous!==target.ownerDocument.body){await dispatchAndIgnore({target:previous,events:["blur","focusout"],callback:(el)=>el.blur(),options:{relatedTarget:target},});}
if(isNodeFocusable(target)){const previousSelection=getStringSelection(target);await dispatchAndIgnore({target,events:["focus","focusin"],additionalEvents:["select"],callback:(el)=>el.focus(),options:{relatedTarget:previous},});if(previousSelection&&previousSelection===getStringSelection(target)){changeSelection(target,target.value.length,target.value.length);}}};const _clear=async(target,options)=>{const initialValue=target.value;fullClear=true;await _press(target,{ctrlKey:true,key:"a"});await _press(target,{key:"Backspace"});fullClear=false;await registerForChange(target,initialValue,options?.confirm);};const _click=async(target,options)=>{await _pointerDown(target,options);await _pointerUp(target,options);};const _fill=async(target,value,options)=>{const initialValue=target.value;if(getTag(target)==="input"){switch(target.type){case"color":{target.value=String(value);await dispatch(target,"input");await dispatch(target,"change");return;}
case"file":{const files=ensureArray(value);if(files.length>1&&!target.multiple){throw new HootDomError(`input[type="file"] does not support multiple files`);}
target.files=createDataTransfer({files}).files;await dispatch(target,"change");return;}
case"range":{const numberValue=$parseFloat(value);if($isNaN(numberValue)){throw new TypeError(`input[type="range"] only accept 'number' values`);}
target.value=String(numberValue);await dispatch(target,"input");await dispatch(target,"change");return;}}}
if(options?.instantly){globalThis.navigator.clipboard.writeText(value).catch();await _press(target,{ctrlKey:true,key:"v"});}else{if(options?.composition){runTime.isComposing=true;await dispatch(target,"compositionstart");}
for(const char of String(value)){const key=char.toLowerCase();await _press(target,{key,shiftKey:key!==char});}
if(options?.composition){runTime.isComposing=false;await dispatch(target,"compositionend");}}
await registerForChange(target,initialValue,options?.confirm);};const _hover=async(target,options)=>{const isDifferentTarget=target!==runTime.pointerTarget;const previousPosition=runTime.position;await setPointerTarget(target,options);const{previousPointerTarget:previous,pointerTarget:current}=runTime;if(isDifferentTarget&&previous&&(!current||!previous.contains(current))){const leaveEventInit={...previousPosition,relatedTarget:current,};if(runTime.isDragging){const leaveEventInitWithDT={...leaveEventInit,dataTransfer:runTime.dataTransfer};runTime.lastDragOverCancelled=await triggerDrag(previous,leaveEventInitWithDT);await dispatch(previous,"dragleave",leaveEventInitWithDT);}else{await dispatchPointerEvent(previous,"pointermove",leaveEventInit,{mouse:["mousemove"],touch:["touchmove"],});await dispatchPointerEvent(previous,"pointerout",leaveEventInit,{mouse:["mouseout"],});const leaveEvents=await Promise.all(getDifferentParents(current,previous).map((element)=>dispatch(element,"pointerleave",leaveEventInit)));if(!hasTouch()){await dispatchRelatedEvents(leaveEvents,"mouseleave",leaveEventInit);}}}
if(current){const enterEventInit={...runTime.position,relatedTarget:previous,};if(runTime.isDragging){const enterEventInitWithDT={...enterEventInit,dataTransfer:runTime.dataTransfer};runTime.lastDragOverCancelled=false;if(isDifferentTarget){const dragEnterEvent=await dispatch(target,"dragenter",enterEventInitWithDT);runTime.lastDragOverCancelled=isPrevented(dragEnterEvent);}
runTime.lastDragOverCancelled||=await triggerDrag(target,enterEventInitWithDT);}else{if(isDifferentTarget){await dispatchPointerEvent(target,"pointerover",enterEventInit,{mouse:["mouseover"],});const enterEvents=await Promise.all(getDifferentParents(previous,current).map((element)=>dispatch(element,"pointerenter",enterEventInit)));if(!hasTouch()){await dispatchRelatedEvents(enterEvents,"mouseenter",enterEventInit);}}
await dispatchPointerEvent(target,"pointermove",enterEventInit,{mouse:["mousemove"],touch:["touchmove"],});}}};const _implicitHover=async(target,options)=>{if(runTime.pointerTarget!==target||isDifferentPosition(target,options)){await _hover(target,options);}};const _keyDown=async(target,eventInit)=>{eventInit={...eventInit,...currentEventInit.keydown};registerSpecialKey(eventInit,true);const repeat=typeof eventInit.repeat==="boolean"?eventInit.repeat:runTime.key===eventInit.key;runTime.key=eventInit.key;const keyDownEvent=await dispatch(target,"keydown",{...eventInit,repeat});if(isPrevented(keyDownEvent)){return;}
const insertValue=(toInsert,type)=>{const{selectionStart,selectionEnd,value}=target;inputData=toInsert;inputType=type;if(isNil(selectionStart)&&isNil(selectionEnd)){nextValue+=toInsert;}else{nextValue=value.slice(0,selectionStart)+toInsert+value.slice(selectionEnd);if(selectionStart===selectionEnd){nextSelectionStart=nextSelectionEnd=selectionStart+1;}}};const{ctrlKey,key,shiftKey}=keyDownEvent;const initialValue=target.value;let inputData=null;let inputType=null;let nextSelectionEnd=null;let nextSelectionStart=null;let nextValue=initialValue;let triggerSelect=false;if(isEditable(target)){switch(key){case"ArrowDown":case"ArrowLeft":case"ArrowUp":case"ArrowRight":{const{selectionStart,selectionEnd,value}=target;if(isNil(selectionStart)||isNil(selectionEnd)){break;}
const start=key==="ArrowLeft"||key==="ArrowUp";let selectionTarget;if(ctrlKey){selectionTarget=start?0:value.length;}else{selectionTarget=start?selectionStart-1:selectionEnd+1;}
nextSelectionStart=nextSelectionEnd=$max($min(selectionTarget,value.length),0);triggerSelect=shiftKey;break;}
case"Backspace":{const{selectionStart,selectionEnd,value}=target;if(fullClear){nextValue="";}else if(isNil(selectionStart)||isNil(selectionEnd)){nextValue=value.slice(0,-1);}else if(selectionStart===selectionEnd){nextValue=value.slice(0,selectionStart-1)+value.slice(selectionEnd);}else{nextValue=deleteSelection(target);}
inputType="deleteContentBackward";break;}
case"Delete":{const{selectionStart,selectionEnd,value}=target;if(fullClear){nextValue="";}else if(isNil(selectionStart)||isNil(selectionEnd)){nextValue=value.slice(1);}else if(selectionStart===selectionEnd){nextValue=value.slice(0,selectionStart)+value.slice(selectionEnd+1);}else{nextValue=deleteSelection(target);}
inputType="deleteContentForward";break;}
case"Enter":{if(target.tagName==="TEXTAREA"){insertValue("\n","insertLineBreak");}
break;}
default:{if(key.length===1&&!ctrlKey){insertValue(shiftKey?key.toUpperCase():key.toLowerCase(),runTime.isComposing?"insertCompositionText":"insertText");}}}}
switch(key){case"a":{if(ctrlKey){if(isEditable(target)){nextSelectionStart=0;nextSelectionEnd=target.value.length;triggerSelect=true;}else{const selection=globalThis.getSelection();const range=$createRange();range.selectNodeContents(target);selection.removeAllRanges();selection.addRange(range);}}
break;}
case"c":{if(ctrlKey){const text=globalThis.getSelection().toString();globalThis.navigator.clipboard.writeText(text).catch();runTime.clipboardData=createDataTransfer(eventInit);await dispatch(target,"copy",{clipboardData:runTime.clipboardData});}
break;}
case"Enter":{const tag=getTag(target);const parentForm=target.closest("form");if(parentForm&&target.type!=="button"){await dispatch(parentForm,"submit");}else if(!keyDownEvent.repeat&&(tag==="a"||tag==="button"||(tag==="input"&&target.type==="button"))){await dispatch(target,"click",{button:btn.LEFT});}
break;}
case"Escape":{runTime.dataTransfer=null;runTime.isDragging=false;break;}
case"Tab":{const next=shiftKey?getPreviousFocusableElement({tabbable:true}):getNextFocusableElement({tabbable:true});if(next){await triggerFocus(next);}
break;}
case"v":{if(ctrlKey&&isEditable(target)){try{nextValue=await globalThis.navigator.clipboard.readText();}catch(err){}
inputType="insertFromPaste";await dispatch(target,"paste",{clipboardData:runTime.clipboardData||createDataTransfer(eventInit),});runTime.clipboardData=null;}
break;}
case"x":{if(ctrlKey&&isEditable(target)){const text=globalThis.getSelection().toString();globalThis.navigator.clipboard.writeText(text).catch();nextValue=deleteSelection(target);inputType="deleteByCut";runTime.clipboardData=createDataTransfer(eventInit);await dispatch(target,"cut",{clipboardData:runTime.clipboardData});}
break;}}
if(initialValue!==nextValue){target.value=nextValue;const inputEventInit={data:inputData,inputType,};const beforeInputEvent=await dispatch(target,"beforeinput",inputEventInit);if(!isPrevented(beforeInputEvent)){await dispatch(target,"input",inputEventInit);}}
changeSelection(target,nextSelectionStart,nextSelectionEnd);if(triggerSelect){await dispatchAndIgnore({target,events:["select"],});}};const _keyUp=async(target,eventInit)=>{eventInit={...eventInit,...currentEventInit.keyup};await dispatch(target,"keyup",eventInit);runTime.key=null;registerSpecialKey(eventInit,false);if(eventInit.key===" "&&getTag(target)==="input"&&target.type==="checkbox"){await triggerClick(target,{button:btn.LEFT});}};const _pointerDown=async(target,options)=>{setPointerDownTarget(target);if(options?.dataTransfer||options?.files||options?.items){runTime.dataTransfer=createDataTransfer(options);}
const pointerDownTarget=runTime.pointerDownTarget;const eventInit={...runTime.position,...currentEventInit.pointerdown,button:options?.button||btn.LEFT,};registerButton(eventInit,true);if(pointerDownTarget!==runTime.previousPointerDownTarget){runTime.clickCount=0;}
runTime.touchStartPosition={...runTime.position};runTime.touchStartTimeOffset=globalThis.Date.now();const prevented=await dispatchPointerEvent(pointerDownTarget,"pointerdown",eventInit,{mouse:!pointerDownTarget.disabled&&["mousedown",{...eventInit,detail:runTime.clickCount+1},],touch:["touchstart"],});if(prevented){return;}
await triggerFocus(target);if(eventInit.button===btn.LEFT&&!hasTouch()&&(pointerDownTarget.draggable||runTime.dataTransfer)){runTime.canStartDrag=true;}else if(eventInit.button===btn.RIGHT){await dispatch(target,"contextmenu",eventInit);}};const _pointerUp=async(target,options)=>{const isLongTap=globalThis.Date.now()-runTime.touchStartTimeOffset>LONG_TAP_DELAY;const pointerDownTarget=runTime.pointerDownTarget;const eventInit={...runTime.position,...currentEventInit.pointerup,button:options?.button||btn.LEFT,};registerButton(eventInit,false);if(runTime.isDragging){const eventInitWithDT={...eventInit,dataTransfer:runTime.dataTransfer};runTime.dataTransfer=null;runTime.isDragging=false;if(runTime.lastDragOverCancelled){await dispatch(target,"drop",eventInitWithDT);}
await dispatch(target,"dragend",eventInitWithDT);return;}
const mouseEventInit={...eventInit,detail:runTime.clickCount+1,};await dispatchPointerEvent(target,"pointerup",eventInit,{mouse:!target.disabled&&["mouseup",mouseEventInit],touch:["touchend"],});const touchStartPosition=runTime.touchStartPosition;runTime.touchStartPosition={};if(hasTouch()&&(isDifferentPosition(touchStartPosition)||isLongTap)){return;}
let actualTarget;if(hasTouch()){actualTarget=pointerDownTarget===target&&target;}else{actualTarget=getFirstCommonParent(target,pointerDownTarget);}
if(actualTarget){await triggerClick(actualTarget,mouseEventInit);if(mouseEventInit.button===btn.LEFT){runTime.clickCount++;if(!hasTouch()&&runTime.clickCount%2===0){await dispatch(actualTarget,"dblclick",mouseEventInit);}}}
setPointerDownTarget(null);if(runTime.pointerDownTimeout){globalThis.clearTimeout(runTime.pointerDownTimeout);}
runTime.pointerDownTimeout=globalThis.setTimeout(()=>{runTime.clickCount=0;runTime.pointerDownTimeout=0;},DOUBLE_CLICK_DELAY);};const _press=async(target,eventInit)=>{await _keyDown(target,eventInit);await _keyUp(target,eventInit);};const _select=async(target,value)=>{const values=ensureArray(value).map(String);let found=false;for(const option of target.options){option.selected=values.includes(option.value);found||=option.selected;}
if(!value){target.selectedIndex=-1;}else if(!found){throw new HootDomError(`error when calling \`select()\`: no option found with value "${values.join(", ")}"`);}
await dispatch(target,"change");};const btn={LEFT:0,MIDDLE:1,RIGHT:2,BACK:3,FORWARD:4,};const CAPTURE={capture:true};const DEPRECATED_EVENT_PROPERTIES={keyCode:"key",which:"key",};const DEPRECATED_EVENTS={keypress:"keydown",mousewheel:"wheel",};const DOUBLE_CLICK_DELAY=500;const GLOBAL_TRUSTED_EVENTS_CANCELERS=[["blur",cancelTrustedEvent,CAPTURE],["focus",cancelTrustedEvent,CAPTURE],["focusin",cancelTrustedEvent,CAPTURE],["focusout",cancelTrustedEvent,CAPTURE],["scroll",cancelTrustedEvent,CAPTURE],["scrollend",cancelTrustedEvent,CAPTURE],["select",cancelTrustedEvent,CAPTURE],];const GLOBAL_FILE_INPUT_REGISTERERS=[["click",registerFileInput,CAPTURE],["focus",registerFileInput,CAPTURE],];const GLOBAL_SUBMIT_FORWARDERS=[["submit",redirectSubmit]];const KEY_ALIASES={alt:"Alt",arrowdown:"ArrowDown",arrowleft:"ArrowLeft",arrowright:"ArrowRight",arrowup:"ArrowUp",backspace:"Backspace",control:"Control",delete:"Delete",enter:"Enter",escape:"Escape",meta:"Meta",shift:"Shift",tab:"Tab",caps:"Shift",cmd:"Meta",command:"Meta",ctrl:"Control",del:"Delete",down:"ArrowDown",esc:"Escape",left:"ArrowLeft",right:"ArrowRight",space:" ",up:"ArrowUp",win:"Meta",};const LOG_COLORS={blue:"#5db0d7",orange:"#f29364",lightBlue:"#9bbbdc",reset:"inherit",};const LONG_TAP_DELAY=500;const currentEvents=$create(null);const currentEventInit=$create(null);const currentEventTypes=[];let afterNextDispatch=null;let allowLogs=false;let fullClear=false;const changeTargetListeners=[];const runTime=getDefaultRunTimeValue();const BUBBLES=0b1;const CANCELABLE=0b10;const VIEW=0b100;const mapEvent=(eventInit)=>eventInit;const mapMouseEvent=(eventInit)=>({button:-1,buttons:runTime.buttons,clientX:eventInit.clientX??eventInit.pageX??eventInit.screenX??0,clientY:eventInit.clientY??eventInit.pageY??eventInit.screenY??0,...runTime.modifierKeys,...eventInit,});const mapPointerEvent=(eventInit)=>({...mapMouseEvent(eventInit),button:btn.LEFT,pointerId:1,pointerType:hasTouch()?"touch":"mouse",...eventInit,});const mapWheelEvent=(eventInit)=>({...mapMouseEvent(eventInit),button:btn.LEFT,...eventInit,});const mapTouchEvent=(eventInit)=>{const touches=eventInit.targetTouches||eventInit.touches||[new Touch({identifier:0,...eventInit})];return{...eventInit,changedTouches:eventInit.changedTouches||touches,target:eventInit.target,targetTouches:eventInit.targetTouches||touches,touches:eventInit.touches||(eventInit.type==="touchend"?[]:touches),};};const mapInputEvent=(eventInit)=>({data:null,isComposing:Boolean(runTime.isComposing),...eventInit,});const mapKeyboardEvent=(eventInit)=>({isComposing:Boolean(runTime.isComposing),...runTime.modifierKeys,...eventInit,});__exports.check=check;async function check(target,options){const finalizeEvents=setupEvents("check",options);const element=queryFirst(await target,options);if(!isCheckable(element)){throw new HootDomError(`cannot call \`check()\`: target should be a checkbox or radio input`);}
const checkTarget=getTag(element)==="label"?element.control:element;if(!checkTarget.checked){await _implicitHover(element,options);await _click(element,options);if(!checkTarget.checked){throw new HootDomError(`error when calling \`check()\`: target is not checked after interaction`);}}
return finalizeEvents();}
__exports.clear=clear;async function clear(options){const finalizeEvents=setupEvents("clear",options);const element=getActiveElement();if(!hasTagName(element,"select")&&!isEditable(element)){throw new HootDomError(`cannot call \`clear()\`: target should be editable or a <select> element`);}
if(isEditable(element)){await _clear(element,options);}else{await _select(element,"");}
return finalizeEvents();}
__exports.click=click;async function click(target,options){const finalizeEvents=setupEvents("click",options);const element=queryFirst(await target,options);await _implicitHover(element,options);await _click(element,options);return finalizeEvents();}
__exports.dblclick=dblclick;async function dblclick(target,options){const finalizeEvents=setupEvents("dblclick",options);const element=queryFirst(await target,options);options={...options,button:btn.LEFT};await _implicitHover(element,options);await _click(element,options);await _click(element,options);return finalizeEvents();}
__exports.dispatch=dispatch;async function dispatch(target,type,eventInit){if(type in DEPRECATED_EVENTS){throw new HootDomError(`cannot dispatch "${type}" event: this event type is deprecated, use "${DEPRECATED_EVENTS[type]}" instead`);}
if(type!==type.toLowerCase()){throw new HootDomError(`cannot dispatch "${type}" event: this event type is either non-standard or deprecated`);}
eventInit={...eventInit,...currentEventInit[type]};for(const key in eventInit){if(key in DEPRECATED_EVENT_PROPERTIES){throw new HootDomError(`cannot dispatch "${type}" event: property "${key}" is deprecated, use "${DEPRECATED_EVENT_PROPERTIES[key]}" instead`);}}
const[Constructor,processParams,flags]=getEventConstructor(type);const params=processParams({composed:true,...eventInit,target,type,});if(flags&BUBBLES){params.bubbles=true;}
if(flags&CANCELABLE){params.cancelable=true;}
if(flags&VIEW){params.view||=getWindow(target);}
const event=new Constructor(type,params);target.dispatchEvent(event);await Promise.resolve();getCurrentEvents().push(event);if(afterNextDispatch){const callback=afterNextDispatch;afterNextDispatch=null;await microTick().then(callback);}
return event;}
__exports.drag=drag;async function drag(target,options){const expectIsDragging=(fn,endDrag)=>{return{async[fn.name](...args){if(dragEndReason){throw new HootDomError(`cannot execute drag helper \`${fn.name}\`: drag sequence has been ended by \`${dragEndReason}\``);}
const result=await fn(...args);if(endDrag){dragEndReason=fn.name;}
return result;},}[fn.name];};const cancel=expectIsDragging(async function cancel(options){const finalizeEvents=setupEvents("drag & drop: cancel",options);const bodyElement=getDocument(initialElement).body;runTime.buttons=0;await _press(bodyElement,{key:"Escape"});dragEvents.push(...finalizeEvents());return dragEvents;},true);const drop=expectIsDragging(async function drop(to,options){if(to){await moveTo(to,options);if(isDictionary(to)){options=to;}}
const finalizeEvents=setupEvents("drag & drop: drop",options);await _pointerUp(runTime.pointerTarget,options);dragEvents.push(...finalizeEvents());return dragEvents;},true);const moveTo=expectIsDragging(async function moveTo(to,options){if(isDictionary(to)){[to,options]=[null,to];}
const finalizeEvents=setupEvents("drag & drop: move",options);const nextElement=to?queryFirst(await to):initialElement;await _hover(nextElement,options);dragEvents.push(...finalizeEvents());return dragHelpers;},false);const finalizeEvents=setupEvents("drag & drop: start",options);const dragHelpers={cancel,drop,moveTo};const initialElement=queryFirst(await target);let dragEndReason=null;await _implicitHover(initialElement,options);await _pointerDown(initialElement,options);const dragEvents=finalizeEvents();return dragHelpers;}
__exports.edit=edit;async function edit(value,options){const finalizeEvents=setupEvents("edit",options);const element=getActiveElement();if(!isEditable(element)){throw new HootDomError(`cannot call \`edit()\`: target should be editable`);}
if(getNodeValue(element)){await _clear(element);}
await _fill(element,value,options);return finalizeEvents();}
__exports.enableEventLogs=enableEventLogs;function enableEventLogs(toggle){allowLogs=toggle??true;}
__exports.fill=fill;async function fill(value,options){const finalizeEvents=setupEvents("fill",options);const element=getActiveElement();if(!isEditable(element)){throw new HootDomError(`cannot call \`fill()\`: target should be editable`);}
await _fill(element,value,options);return finalizeEvents();}
__exports.hover=hover;async function hover(target,options){const finalizeEvents=setupEvents("hover",options);const element=queryFirst(await target,options);await _hover(element,options);return finalizeEvents();}
__exports.keyDown=keyDown;async function keyDown(keyStrokes,options){const finalizeEvents=setupEvents("keyDown",options);const eventInits=parseKeyStrokes(keyStrokes,options);for(const eventInit of eventInits){await _keyDown(getActiveElement(),eventInit);}
return finalizeEvents();}
__exports.keyUp=keyUp;async function keyUp(keyStrokes,options){const finalizeEvents=setupEvents("keyUp",options);const eventInits=parseKeyStrokes(keyStrokes,options);for(const eventInit of eventInits){await _keyUp(getActiveElement(),eventInit);}
return finalizeEvents();}
__exports.leave=leave;async function leave(options){const finalizeEvents=setupEvents("leave",options);await _hover(null,options);return finalizeEvents();}
__exports.middleClick=middleClick;async function middleClick(target,options){const finalizeEvents=setupEvents("middleClick",options);const element=queryFirst(await target,options);options={...options,button:btn.MIDDLE};await _implicitHover(element,options);await _click(element,options);return finalizeEvents();}
__exports.on=on;function on(target,type,listener,options){const targets=isEventTarget(target)?[target]:queryAll(target);if(!targets.length){throw new HootDomError(`expected at least 1 event target, got none`);}
for(const eventTarget of targets){eventTarget.addEventListener(type,listener,options);}
return function off(){for(const eventTarget of targets){eventTarget.removeEventListener(type,listener,options);}};}
__exports.pointerDown=pointerDown;async function pointerDown(target,options){const finalizeEvents=setupEvents("pointerDown",options);const element=queryFirst(await target,options);await _implicitHover(element,options);await _pointerDown(element,options);return finalizeEvents();}
__exports.pointerUp=pointerUp;async function pointerUp(target,options){const finalizeEvents=setupEvents("pointerUp",options);const element=queryFirst(await target,options);await _implicitHover(element,options);await _pointerUp(element,options);return finalizeEvents();}
__exports.press=press;async function press(keyStrokes,options){const finalizeEvents=setupEvents("press",options);const eventInits=parseKeyStrokes(keyStrokes,options);const activeElement=getActiveElement();for(const eventInit of eventInits){await _keyDown(activeElement,eventInit);}
for(const eventInit of eventInits.reverse()){await _keyUp(activeElement,eventInit);}
return finalizeEvents();}
__exports.resize=resize;async function resize(dimensions,options){const finalizeEvents=setupEvents("resize",options);const[width,height]=parseDimensions(dimensions);setDimensions(width,height);await dispatch(getWindow(),"resize");return finalizeEvents();}
__exports.rightClick=rightClick;async function rightClick(target,options){const finalizeEvents=setupEvents("rightClick",options);const element=queryFirst(await target,options);options={...options,button:btn.RIGHT};await _implicitHover(element,options);await _click(element,options);return finalizeEvents();}
__exports.scroll=scroll;async function scroll(target,position,options){const finalizeEvents=setupEvents("scroll",options);const{force,initiator="wheel",relative}=options||{};const scrollTopOptions={};const element=queryFirst(await target,{scrollable:true,...options});let[x,y]=parsePosition(position);if(relative){x+=element.scrollLeft;y+=element.scrollTop;}
if(!$isNaN(x)){const targetX=force?x:constrainScrollX(element,x);if(targetX!==element.scrollLeft){scrollTopOptions.left=targetX;}}
if(!$isNaN(y)){const targetY=force?y:constrainScrollY(element,y);if(targetY!==element.scrollTop){scrollTopOptions.top=targetY;}}
const keys=[];if(initiator==="keyboard"){if(x<element.scrollLeft){keys.push("ArrowRight");}else if(x>element.scrollLeft){keys.push("ArrowLeft");}
if(y<element.scrollTop){keys.push("ArrowDown");}else if(y>element.scrollTop){keys.push("ArrowUp");}
await Promise.all(keys.map((key)=>_keyDown(key)));}else if(!hasTouch()&&initiator==="wheel"){const wheelEventInit={};if(!$isNaN(x)){wheelEventInit.deltaX=x-element.scrollLeft;}
if(!$isNaN(y)){wheelEventInit.deltaY=y-element.scrollTop;}
await dispatch(element,"wheel",wheelEventInit);}
if(force||$values(scrollTopOptions).length){await dispatchAndIgnore({target:element,events:["scroll","scrollend"],callback:(el)=>el.scrollTo(scrollTopOptions),});}
if(initiator==="keyboard"){await Promise.all(keys.map((key)=>_keyUp(key)));}
return finalizeEvents();}
__exports.select=select;async function select(value,options){const finalizeEvents=setupEvents("select",options);const element=options?.target?queryFirst(await options.target):getActiveElement();if(!hasTagName(element,"select")){throw new HootDomError(`cannot call \`select()\`: target should be a <select> element`);}
if(options?.target){await _implicitHover(element);await _pointerDown(element);}
await _select(element,value);if(options?.target){await _pointerUp(element);}
return finalizeEvents();}
__exports.setInputFiles=setInputFiles;async function setInputFiles(files,options){if(!runTime.fileInput){throw new HootDomError(`cannot call \`setInputFiles()\`: no file input has been interacted with`);}
const finalizeEvents=setupEvents("setInputFiles",options);await _fill(runTime.fileInput,files,options);runTime.fileInput=null;return finalizeEvents();}
__exports.setInputRange=setInputRange;async function setInputRange(target,value,options){const finalizeEvents=setupEvents("setInputRange",options);const element=queryFirst(await target,options);await _implicitHover(element,options);await _pointerDown(element,options);await _fill(element,value,options);await _pointerUp(element,options);return finalizeEvents();}
__exports.setupEventActions=setupEventActions;function setupEventActions(target,options){const eventHandlers=[];if(!options?.allowTrustedEvents){eventHandlers.push(...GLOBAL_TRUSTED_EVENTS_CANCELERS);}
if(!options?.noFileInputRegistration){eventHandlers.push(...GLOBAL_FILE_INPUT_REGISTERERS);}
if(!options?.allowSubmit){eventHandlers.push(...GLOBAL_SUBMIT_FORWARDERS);}
for(const[eventType,handler,options]of eventHandlers){window.addEventListener(eventType,handler,options);}
const processedIframes=new WeakSet();const observer=new MutationObserver((mutations)=>{for(const mutation of mutations){if(!mutation.addedNodes){continue;}
for(const iframe of target.getElementsByTagName("iframe")){if(processedIframes.has(iframe)){continue;}
processedIframes.add(iframe);for(const[eventType,handler,options]of eventHandlers){iframe.contentWindow.addEventListener(eventType,handler,options);}}}});observer.observe(target,{childList:true,subtree:true});return function cleanupEventActions(){observer.disconnect();if(runTime.pointerDownTimeout){globalThis.clearTimeout(runTime.pointerDownTimeout);}
removeChangeTargetListeners();for(const[eventType,handler,options]of eventHandlers){window.removeEventListener(eventType,handler,options);}
$assign(runTime,getDefaultRunTimeValue());};}
__exports.uncheck=uncheck;async function uncheck(target,options){const finalizeEvents=setupEvents("uncheck",options);const element=queryFirst(await target,options);if(!isCheckable(element)){throw new HootDomError(`cannot call \`uncheck()\`: target should be a checkbox or radio input`);}
const checkTarget=getTag(element)==="label"?element.control:element;if(checkTarget.checked){await _implicitHover(element,options);await _click(element,options);if(checkTarget.checked){throw new HootDomError(`error when calling \`uncheck()\`: target is still checked after interaction`);}}
return finalizeEvents();}
__exports.unload=unload;async function unload(options){const finalizeEvents=setupEvents("unload",options);await dispatch(getWindow(),"beforeunload");return finalizeEvents();}
const EventList=__exports.EventList=class EventList extends Array{constructor(...args){super(...args.flat());}
get(predicate){return this.getAll(predicate)[0]||null;}
getAll(predicate){if(typeof predicate!=="function"){const type=predicate;predicate=(ev)=>ev.type===type;}
return this.filter(predicate);}}
return __exports;});;

/* /web/static/lib/hoot-dom/helpers/time.js */
odoo.define('@web/../lib/hoot-dom/helpers/time',['@web/../lib/hoot-dom/hoot_dom_utils'],function(require){'use strict';let __exports={};const{HootDomError}=require("@web/../lib/hoot-dom/hoot_dom_utils");const{cancelAnimationFrame,clearInterval,clearTimeout,Error,Math:{ceil:$ceil,floor:$floor,max:$max,min:$min},Number,performance,Promise,requestAnimationFrame,setInterval,setTimeout,}=globalThis;const $performanceNow=performance.now.bind(performance);const animationToId=(id)=>ID_PREFIX.animation+String(id);const getNextTimerValues=()=>{let timerValues=null;for(const[internalId,[callback,init,delay]]of timers.entries()){const timeout=init+delay;if(!timerValues||timeout<timerValues[0]){timerValues=[timeout,callback,internalId];}}
return timerValues;};const idToAnimation=(id)=>Number(id.slice(ID_PREFIX.animation.length));const idToInterval=(id)=>Number(id.slice(ID_PREFIX.interval.length));const idToTimeout=(id)=>Number(id.slice(ID_PREFIX.timeout.length));const intervalToId=(id)=>ID_PREFIX.interval+String(id);const parseNat=(value)=>$max($floor(Number(value)),0)||0;const now=()=>(frozen?0:$performanceNow())+timeOffset;const timeoutToId=(id)=>ID_PREFIX.timeout+String(id);const ID_PREFIX={animation:"a_",interval:"i_",timeout:"t_",};const timers=new Map();let allowTimers=false;let frozen=false;let frameDelay=1000/60;let nextDummyId=1;let timeOffset=0;__exports.advanceFrame=advanceFrame;function advanceFrame(frameCount,options){return advanceTime(frameDelay*parseNat(frameCount),options);}
__exports.advanceTime=advanceTime;async function advanceTime(ms,options){ms=parseNat(ms);if(options?.blockTimers){allowTimers=false;}
const targetTime=now()+ms;let remaining=ms;let timerValues;while((timerValues=getNextTimerValues())&&timerValues[0]<=targetTime){const[timeout,handler,id]=timerValues;const diff=timeout-now();if(diff>0){timeOffset+=$min(remaining,diff);remaining=$max(remaining-diff,0);}
if(timers.has(id)){handler(timeout);}}
if(remaining>0){timeOffset+=remaining;}
if(options?.animationFrame??true){await animationFrame();}
allowTimers=true;return ms;}
__exports.animationFrame=animationFrame;function animationFrame(){return new Promise((resolve)=>requestAnimationFrame(()=>delay().then(resolve)));}
__exports.cancelAllTimers=cancelAllTimers;function cancelAllTimers(){for(const id of timers.keys()){if(id.startsWith(ID_PREFIX.animation)){globalThis.cancelAnimationFrame(idToAnimation(id));}else if(id.startsWith(ID_PREFIX.interval)){globalThis.clearInterval(idToInterval(id));}else if(id.startsWith(ID_PREFIX.timeout)){globalThis.clearTimeout(idToTimeout(id));}}}
__exports.cleanupTime=cleanupTime;function cleanupTime(){allowTimers=false;frozen=false;cancelAllTimers();return delay();}
__exports.delay=delay;function delay(duration){return new Promise((resolve)=>setTimeout(resolve,duration));}
__exports.freezeTime=freezeTime;function freezeTime(setFreeze){frozen=setFreeze??!frozen;}
__exports.getTimeOffset=getTimeOffset;function getTimeOffset(){return timeOffset;}
__exports.isTimeFrozen=isTimeFrozen;function isTimeFrozen(){return frozen;}
__exports.microTick=microTick;function microTick(){return new Promise(queueMicrotask);}
__exports.mockedCancelAnimationFrame=mockedCancelAnimationFrame;function mockedCancelAnimationFrame(handle){if(!frozen){cancelAnimationFrame(handle);}
timers.delete(animationToId(handle));}
__exports.mockedClearInterval=mockedClearInterval;function mockedClearInterval(intervalId){if(!frozen){clearInterval(intervalId);}
timers.delete(intervalToId(intervalId));}
__exports.mockedClearTimeout=mockedClearTimeout;function mockedClearTimeout(timeoutId){if(!frozen){clearTimeout(timeoutId);}
timers.delete(timeoutToId(timeoutId));}
__exports.mockedRequestAnimationFrame=mockedRequestAnimationFrame;function mockedRequestAnimationFrame(callback){if(!allowTimers){return 0;}
const handler=()=>{mockedCancelAnimationFrame(handle);return callback(now());};const animationValues=[handler,now(),frameDelay];const handle=frozen?nextDummyId++:requestAnimationFrame(handler);const internalId=animationToId(handle);timers.set(internalId,animationValues);return handle;}
__exports.mockedSetInterval=mockedSetInterval;function mockedSetInterval(callback,ms,...args){if(!allowTimers){return 0;}
ms=parseNat(ms);const handler=()=>{if(allowTimers){intervalValues[1]=$max(now(),intervalValues[1]+ms);}else{mockedClearInterval(intervalId);}
return callback(...args);};const intervalValues=[handler,now(),ms];const intervalId=frozen?nextDummyId++:setInterval(handler,ms);const internalId=intervalToId(intervalId);timers.set(internalId,intervalValues);return intervalId;}
__exports.mockedSetTimeout=mockedSetTimeout;function mockedSetTimeout(callback,ms,...args){if(!allowTimers){return 0;}
ms=parseNat(ms);const handler=()=>{mockedClearTimeout(timeoutId);return callback(...args);};const timeoutValues=[handler,now(),ms];const timeoutId=frozen?nextDummyId++:setTimeout(handler,ms);const internalId=timeoutToId(timeoutId);timers.set(internalId,timeoutValues);return timeoutId;}
__exports.resetTimeOffset=resetTimeOffset;function resetTimeOffset(){timeOffset=0;}
__exports.runAllTimers=runAllTimers;function runAllTimers(options){if(!timers.size){return 0;}
const endts=$max(...[...timers.values()].map(([,init,delay])=>init+delay));return advanceTime($ceil(endts-now()),options);}
__exports.setFrameRate=setFrameRate;function setFrameRate(frameRate){frameRate=parseNat(frameRate);if(frameRate<1||frameRate>1000){throw new Error("frame rate must be an number between 1 and 1000");}
frameDelay=1000/frameRate;}
__exports.setupTime=setupTime;function setupTime(){allowTimers=true;}
__exports.tick=tick;function tick(){return delay();}
__exports.waitUntil=waitUntil;function waitUntil(predicate,options){const result=predicate();if(result){return Promise.resolve().then(()=>result);}
const timeout=$floor(options?.timeout??200);let handle;let timeoutId;let running=true;return new Promise((resolve,reject)=>{const runCheck=()=>{const result=predicate();if(result){resolve(result);}else if(running){handle=requestAnimationFrame(runCheck);}else{let message=options?.message||`'waitUntil' timed out after %timeout% milliseconds`;if(typeof message==="function"){message=message();}
reject(new HootDomError(message.replace("%timeout%",String(timeout))));}};handle=requestAnimationFrame(runCheck);timeoutId=setTimeout(()=>(running=false),timeout);}).finally(()=>{cancelAnimationFrame(handle);clearTimeout(timeoutId);});}
const Deferred=__exports.Deferred=class Deferred extends Promise{_resolve;_reject;constructor(executor){let _resolve,_reject;super((resolve,reject)=>{_resolve=resolve;_reject=reject;executor?.(_resolve,_reject);});this._resolve=_resolve;this._reject=_reject;}
async reject(reason){return this._reject(reason);}
async resolve(value){return this._resolve(value);}}
return __exports;});;

/* /web/static/lib/hoot-dom/hoot-dom.js */
odoo.define('@web/../lib/hoot-dom/hoot-dom',['@web/../lib/hoot-dom/helpers/dom','@web/../lib/hoot-dom/helpers/events','@web/../lib/hoot-dom/hoot_dom_utils','@web/../lib/hoot-dom/helpers/time'],function(require){'use strict';let __exports={};const dom=require("@web/../lib/hoot-dom/helpers/dom");const events=require("@web/../lib/hoot-dom/helpers/events");const{interactor}=require("@web/../lib/hoot-dom/hoot_dom_utils");{const{formatXml,getActiveElement,getFocusableElements,getNextFocusableElement,getParentFrame,getPreviousFocusableElement,isDisplayed,isEditable,isFocusable,isInDOM,isInViewPort,isScrollable,isVisible,matches,queryAll,queryAllAttributes,queryAllProperties,queryAllRects,queryAllTexts,queryAllValues,queryAttribute,queryFirst,queryOne,queryRect,queryText,queryValue,}=require("@web/../lib/hoot-dom/helpers/dom");Object.assign(__exports,{formatXml,getActiveElement,getFocusableElements,getNextFocusableElement,getParentFrame,getPreviousFocusableElement,isDisplayed,isEditable,isFocusable,isInDOM,isInViewPort,isScrollable,isVisible,matches,queryAll,queryAllAttributes,queryAllProperties,queryAllRects,queryAllTexts,queryAllValues,queryAttribute,queryFirst,queryOne,queryRect,queryText,queryValue,})};{const{on}=require("@web/../lib/hoot-dom/helpers/events");Object.assign(__exports,{on})};{const{advanceFrame,advanceTime,animationFrame,cancelAllTimers,Deferred,delay,freezeTime,microTick,runAllTimers,setFrameRate,tick,waitUntil,}=require("@web/../lib/hoot-dom/helpers/time");Object.assign(__exports,{advanceFrame,advanceTime,animationFrame,cancelAllTimers,Deferred,delay,freezeTime,microTick,runAllTimers,setFrameRate,tick,waitUntil,})};const observe=__exports.observe=interactor("query",dom.observe);const waitFor=__exports.waitFor=interactor("query",dom.waitFor);const waitForNone=__exports.waitForNone=interactor("query",dom.waitForNone);const check=__exports.check=interactor("interaction",events.check);const clear=__exports.clear=interactor("interaction",events.clear);const click=__exports.click=interactor("interaction",events.click);const dblclick=__exports.dblclick=interactor("interaction",events.dblclick);const drag=__exports.drag=interactor("interaction",events.drag);const edit=__exports.edit=interactor("interaction",events.edit);const fill=__exports.fill=interactor("interaction",events.fill);const hover=__exports.hover=interactor("interaction",events.hover);const keyDown=__exports.keyDown=interactor("interaction",events.keyDown);const keyUp=__exports.keyUp=interactor("interaction",events.keyUp);const leave=__exports.leave=interactor("interaction",events.leave);const manuallyDispatchProgrammaticEvent=__exports.manuallyDispatchProgrammaticEvent=interactor("interaction",events.dispatch);const middleClick=__exports.middleClick=interactor("interaction",events.middleClick);const pointerDown=__exports.pointerDown=interactor("interaction",events.pointerDown);const pointerUp=__exports.pointerUp=interactor("interaction",events.pointerUp);const press=__exports.press=interactor("interaction",events.press);const resize=__exports.resize=interactor("interaction",events.resize);const rightClick=__exports.rightClick=interactor("interaction",events.rightClick);const scroll=__exports.scroll=interactor("interaction",events.scroll);const select=__exports.select=interactor("interaction",events.select);const setInputFiles=__exports.setInputFiles=interactor("interaction",events.setInputFiles);const setInputRange=__exports.setInputRange=interactor("interaction",events.setInputRange);const uncheck=__exports.uncheck=interactor("interaction",events.uncheck);const unload=__exports.unload=interactor("interaction",events.unload);return __exports;});odoo.define(`@odoo/hoot-dom`,['@web/../lib/hoot-dom/hoot-dom'],function(require){return require('@web/../lib/hoot-dom/hoot-dom');});;

/* /web/static/lib/hoot-dom/hoot_dom_utils.js */
odoo.define('@web/../lib/hoot-dom/hoot_dom_utils',[],function(require){'use strict';let __exports={};const{Boolean,navigator:{userAgent:$userAgent},Object:{assign:$assign},RegExp,SyntaxError,}=globalThis;const R_REGEX_PATTERN=/^\/(.*)\/([dgimsuvy]+)?$/;const interactionBus=new EventTarget();__exports.addInteractionListener=addInteractionListener;function addInteractionListener(types,callback){for(const type of types){interactionBus.addEventListener(type,callback);}
return function removeInteractionListener(){for(const type of types){interactionBus.removeEventListener(type,callback);}};}
__exports.dispatchInteraction=dispatchInteraction;function dispatchInteraction(type,name,args,returnValue){interactionBus.dispatchEvent(new CustomEvent(type,{detail:[name,args,returnValue],}));return returnValue;}
const makeInteractorFn=(type,fn,name)=>({[name](...args){const result=fn(...args);if(result instanceof Promise){for(let i=0;i<args.length;i++){if(args[i]instanceof Promise){args[i].then((result)=>(args[i]=result));}}
return result.then((promiseResult)=>dispatchInteraction(type,name,args,promiseResult));}else{return dispatchInteraction(type,name,args,result);}},}[name]);__exports.interactor=interactor;function interactor(type,fn){return $assign(makeInteractorFn(type,fn,fn.name),{as(alias){return makeInteractorFn(type,fn,alias);},get silent(){return fn;},});}
__exports.getTag=getTag;function getTag(node){return node?.nodeName?.toLowerCase()||"";}
__exports.isFirefox=isFirefox;function isFirefox(){return/firefox/i.test($userAgent);}
__exports.isIterable=isIterable;function isIterable(object){return Boolean(object&&typeof object==="object"&&object[Symbol.iterator]);}
__exports.isRegExpFilter=isRegExpFilter;function isRegExpFilter(filter){return R_REGEX_PATTERN.test(filter);}
__exports.parseRegExp=parseRegExp;function parseRegExp(value,options){const regexParams=value.match(R_REGEX_PATTERN);if(regexParams){const unified=regexParams[1].replace(/\s+/g,"\\s+");const flag=regexParams[2]||"i";try{return new RegExp(unified,flag);}catch(error){if(error instanceof SyntaxError&&options?.safe){return value;}else{throw error;}}}
return value;}
__exports.toSelector=toSelector;function toSelector(node,options){const tagName=getTag(node);const id=node.id?`#${node.id}`:"";const classNames=node.classList?[...node.classList].map((className)=>`.${className}`):[];if(options?.raw){return{tagName,id,classNames};}else{return[tagName,id,...classNames].join("");}}
const HootDomError=__exports.HootDomError=class HootDomError extends Error{name="HootDomError";}
return __exports;});;

/* /html_editor/static/src/components/history_dialog/history_dialog.js */
odoo.define('@html_editor/components/history_dialog/history_dialog',['@web/core/dialog/dialog','@web/core/notebook/notebook','@web/core/l10n/dates','@web/core/utils/hooks','@web/core/utils/functions','@odoo/owl','@web/core/l10n/translation','@web/core/user','@html_editor/fields/html_viewer','@html_editor/others/embedded_components/embedding_sets'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{Notebook}=require("@web/core/notebook/notebook");const{formatDateTime}=require("@web/core/l10n/dates");const{useService}=require("@web/core/utils/hooks");const{memoize}=require("@web/core/utils/functions");const{Component,onMounted,useState,markup}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{HtmlViewer}=require("@html_editor/fields/html_viewer");const{READONLY_MAIN_EMBEDDINGS}=require("@html_editor/others/embedded_components/embedding_sets");const{DateTime}=luxon;const HistoryDialog=__exports.HistoryDialog=class HistoryDialog extends Component{static template="html_editor.HistoryDialog";static components={Dialog,HtmlViewer,Notebook};static props={recordId:Number,recordModel:String,close:Function,restoreRequested:Function,historyMetadata:Array,versionedFieldName:String,title:{String,optional:true},noContentHelper:{String,optional:true},embeddedComponents:{Array,optional:true},};static defaultProps={title:_t("History"),noContentHelper:markup(""),embeddedComponents:[...READONLY_MAIN_EMBEDDINGS],};state=useState({revisionsData:[],revisionContent:null,revisionComparison:null,revisionId:null,});setup(){this.size="xl";this.title=this.props.title;this.orm=useService("orm");this.notebookTabs=[_t("Content"),_t("Comparison")];onMounted(()=>this.init());}
getConfig(value){return{value:this.state[value],embeddedComponents:this.props.embeddedComponents,};}
async init(){this.state.revisionsData=this.props.historyMetadata;await this.updateCurrentRevision(this.props.historyMetadata[0]["revision_id"]);}
async updateCurrentRevision(revisionId){if(this.state.revisionId===revisionId){return;}
this.env.services.ui.block();this.state.revisionId=revisionId;this.state.revisionContent=await this.getRevisionContent(revisionId);this.state.revisionComparison=await this.getRevisionComparison(revisionId);this.env.services.ui.unblock();}
getRevisionComparison=memoize(async function getRevisionComparison(revisionId){const comparison=await this.orm.call(this.props.recordModel,"html_field_history_get_comparison_at_revision",[this.props.recordId,this.props.versionedFieldName,revisionId]);return markup(comparison);}.bind(this));getRevisionContent=memoize(async function getRevisionContent(revisionId){const content=await this.orm.call(this.props.recordModel,"html_field_history_get_content_at_revision",[this.props.recordId,this.props.versionedFieldName,revisionId]);return markup(content);}.bind(this));async _onRestoreRevisionClick(){this.env.services.ui.block();const restoredContent=await this.getRevisionContent(this.state.revisionId);this.props.restoreRequested(restoredContent,this.props.close);this.env.services.ui.unblock();}
getRevisionDate(revision){return formatDateTime(DateTime.fromISO(revision["create_date"],{zone:"utc"}).setZone(user.tz));}}
return __exports;});;

/* /html_editor/static/src/core/base_container_plugin.js */
odoo.define('@html_editor/core/base_container_plugin',['@html_editor/utils/dom_info','@html_editor/plugin','@html_editor/utils/dom','@html_editor/utils/base_container','@html_editor/utils/resource','@html_editor/utils/dom_traversal'],function(require){'use strict';let __exports={};const{containsAnyNonPhrasingContent,isMediaElement,isProtected,isProtecting,}=require("@html_editor/utils/dom_info");const{Plugin}=require("@html_editor/plugin");const{fillEmpty}=require("@html_editor/utils/dom");const{BASE_CONTAINER_CLASS,SUPPORTED_BASE_CONTAINER_NAMES,baseContainerGlobalSelector,createBaseContainer,}=require("@html_editor/utils/base_container");const{withSequence}=require("@html_editor/utils/resource");const{selectElements}=require("@html_editor/utils/dom_traversal");const BaseContainerPlugin=__exports.BaseContainerPlugin=class BaseContainerPlugin extends Plugin{static id="baseContainer";static shared=["createBaseContainer","getDefaultNodeName","isCandidateForBaseContainer"];hasNonPhrasingContentPredicate=(element)=>{return element?.nodeType===Node.ELEMENT_NODE&&containsAnyNonPhrasingContent(element);};isUnsplittablePredicate=(element)=>{return this.getResource("unsplittable_node_predicates").some((fn)=>fn(element));};resources={clean_for_save_handlers:this.cleanForSave.bind(this),normalize_handlers:withSequence(Infinity,this.normalizeDivBaseContainers.bind(this)),unsplittable_node_predicates:(node)=>{if(node.nodeName!=="DIV"){return false;}
return!this.isCandidateForBaseContainerAllowUnsplittable(node);},invalid_for_base_container_predicates:[(node)=>!node||node.nodeType!==Node.ELEMENT_NODE||!SUPPORTED_BASE_CONTAINER_NAMES.includes(node.tagName)||isProtected(node)||isProtecting(node)||isMediaElement(node),this.isUnsplittablePredicate,this.hasNonPhrasingContentPredicate,],system_classes:[BASE_CONTAINER_CLASS],};createBaseContainer(nodeName=this.getDefaultNodeName()){return createBaseContainer(nodeName,this.document);}
getDefaultNodeName(){return this.config.baseContainer||"P";}
isCandidateForBaseContainer(element){return!this.getResource("invalid_for_base_container_predicates").some((fn)=>fn(element));}
isCandidateForBaseContainerAllowUnsplittable(element){const predicates=new Set(this.getResource("invalid_for_base_container_predicates"));predicates.delete(this.isUnsplittablePredicate);for(const predicate of predicates){if(predicate(element)){return false;}}
return true;}
shallowIsCandidateForBaseContainer(element){const predicates=new Set(this.getResource("invalid_for_base_container_predicates"));predicates.delete(this.hasNonPhrasingContentPredicate);for(const predicate of predicates){if(predicate(element)){return false;}}
return true;}
cleanForSave({root}){for(const baseContainer of selectElements(root,`.${BASE_CONTAINER_CLASS}`)){baseContainer.classList.remove(BASE_CONTAINER_CLASS);if(baseContainer.classList.length===0){baseContainer.removeAttribute("class");}}}
normalizeDivBaseContainers(element=this.editable){const newBaseContainers=[];const divSelector=`div:not(.${BASE_CONTAINER_CLASS})`;const targets=[...element.querySelectorAll(divSelector)];if(element.matches(divSelector)){targets.unshift(element);}
for(const div of targets){if(!div.parentElement?.matches(baseContainerGlobalSelector)&&this.shallowIsCandidateForBaseContainer(div)&&!containsAnyNonPhrasingContent(div)){div.classList.add(BASE_CONTAINER_CLASS);newBaseContainers.push(div);fillEmpty(div);}}}}
return __exports;});;

/* /html_editor/static/src/core/clipboard_plugin.js */
odoo.define('@html_editor/core/clipboard_plugin',['@html_editor/utils/dom_info','@html_editor/plugin','@html_editor/utils/blocks','@html_editor/utils/dom','@html_editor/utils/dom_traversal','@html_editor/utils/html','@html_editor/utils/base_container','@html_editor/utils/position'],function(require){'use strict';let __exports={};const{isTextNode,isParagraphRelatedElement}=require("@html_editor/utils/dom_info");const{Plugin}=require("@html_editor/plugin");const{closestBlock,isBlock}=require("@html_editor/utils/blocks");const{unwrapContents,wrapInlinesInBlocks,splitTextNode}=require("@html_editor/utils/dom");const{ancestors,childNodes,closestElement}=require("@html_editor/utils/dom_traversal");const{parseHTML}=require("@html_editor/utils/html");const{baseContainerGlobalSelector,getBaseContainerSelector,}=require("@html_editor/utils/base_container");const{DIRECTIONS}=require("@html_editor/utils/position");const CLIPBOARD_BLACKLISTS={unwrap:[".Apple-interchange-newline","DIV",],remove:["META","STYLE","SCRIPT"],};const CLIPBOARD_WHITELISTS=__exports.CLIPBOARD_WHITELISTS={nodes:["P","H1","H2","H3","H4","H5","H6","BLOCKQUOTE","PRE","UL","OL","LI","I","B","U","S","EM","FONT","STRONG","TABLE","THEAD","TH","TBODY","TR","TD","IMG","BR","A",".fa",],classes:[/^float-/,"d-block","mx-auto","img-fluid","img-thumbnail","rounded","rounded-circle","table","table-bordered",/^padding-/,/^shadow/,/^text-o-/,/^bg-o-/,"o_checked","o_checklist","oe-nested",/^btn/,/^fa/,],attributes:["class","href","src","target"],styledTags:["SPAN","B","STRONG","I","S","U","FONT","TD"],};const ONLY_LINK_REGEX=/^(https?:\/\/)?([\w-]+\.)+[\w-]+(\/[\w-./?%&=]*)?$/i;const ClipboardPlugin=__exports.ClipboardPlugin=class ClipboardPlugin extends Plugin{static id="clipboard";static dependencies=["baseContainer","dom","selection","sanitize","history","split","delete","lineBreak",];static shared=["pasteText"];setup(){this.addDomListener(this.editable,"copy",this.onCopy);this.addDomListener(this.editable,"cut",this.onCut);this.addDomListener(this.editable,"paste",this.onPaste);this.addDomListener(this.editable,"dragstart",this.onDragStart);this.addDomListener(this.editable,"drop",this.onDrop);}
onCut(ev){this.onCopy(ev);this.dependencies.history.stageSelection();this.dependencies.delete.deleteSelection();this.dependencies.history.addStep();}
onCopy(ev){ev.preventDefault();const selection=this.dependencies.selection.getEditableSelection();const commonAncestor=selection.commonAncestorContainer;if(commonAncestor&&commonAncestor.nodeType===Node.ELEMENT_NODE){this.dispatchTo("clean_handlers",commonAncestor);}
let clonedContents=selection.cloneContents();if(!clonedContents.hasChildNodes()){if(commonAncestor&&commonAncestor.nodeType===Node.ELEMENT_NODE){this.dispatchTo("normalize_handlers",commonAncestor);}
return;}
if(clonedContents.firstChild.nodeName==="LI"){const list=selection.commonAncestorContainer.cloneNode();list.replaceChildren(...childNodes(clonedContents));clonedContents=list;}
if(clonedContents.firstChild.nodeName==="TR"||clonedContents.firstChild.nodeName==="TD"){const table=closestElement(selection.commonAncestorContainer,"table");const tableClone=table.cloneNode(true);const isTableFullySelected=(table.parentElement&&!!closestElement(table.parentElement,"td.o_selected_td"))||[...table.querySelectorAll("td")].filter((td)=>closestElement(td,"table")===table).every((td)=>td.classList.contains("o_selected_td"));if(!isTableFullySelected){for(const td of tableClone.querySelectorAll("td:not(.o_selected_td)")){if(closestElement(td,"table")===tableClone){td.remove();}}
const trsWithoutTd=Array.from(tableClone.querySelectorAll("tr")).filter((row)=>!row.querySelector("td"));for(const tr of trsWithoutTd){if(closestElement(tr,"table")===tableClone){tr.remove();}}}
clonedContents=tableClone;}
const startTable=closestElement(selection.startContainer,"table");if(clonedContents.firstChild.nodeName==="TABLE"&&startTable){clonedContents.firstChild.after(startTable.cloneNode(true));clonedContents.firstChild.remove();}
const endTable=closestElement(selection.endContainer,"table");if(clonedContents.lastChild.nodeName==="TABLE"&&endTable){clonedContents.lastChild.before(endTable.cloneNode(true));clonedContents.lastChild.remove();}
const commonAncestorElement=closestElement(selection.commonAncestorContainer);if(commonAncestorElement&&!isBlock(clonedContents.firstChild)){const blockEl=closestBlock(commonAncestorElement);const ancestorsList=[commonAncestorElement,...ancestors(commonAncestorElement,blockEl),];for(const ancestor of ancestorsList){if(!isBlock(ancestor)||isParagraphRelatedElement(ancestor)){const clone=ancestor.cloneNode();clone.append(...childNodes(clonedContents));clonedContents.appendChild(clone);}}}
const dataHtmlElement=this.document.createElement("data");dataHtmlElement.append(clonedContents);prependOriginToImages(dataHtmlElement,window.location.origin);const odooHtml=dataHtmlElement.innerHTML;const odooText=selection.textContent();ev.clipboardData.setData("text/plain",odooText);ev.clipboardData.setData("text/html",odooHtml);ev.clipboardData.setData("application/vnd.odoo.odoo-editor",odooHtml);if(commonAncestor&&commonAncestor.nodeType===Node.ELEMENT_NODE){this.dispatchTo("normalize_handlers",commonAncestor);}}
onPaste(ev){let selection=this.dependencies.selection.getEditableSelection();if(!selection.anchorNode.isConnected){return;}
ev.preventDefault();this.dependencies.history.stageSelection();this.dispatchTo("before_paste_handlers",selection);selection=this.dependencies.selection.getEditableSelection();this.handlePasteUnsupportedHtml(selection,ev.clipboardData)||this.handlePasteOdooEditorHtml(ev.clipboardData)||this.handlePasteHtml(selection,ev.clipboardData)||this.handlePasteText(selection,ev.clipboardData);this.dispatchTo("after_paste_handlers",selection);this.dependencies.history.addStep();}
handlePasteUnsupportedHtml(selection,clipboardData){const targetSupportsHtmlContent=isHtmlContentSupported(selection.anchorNode);if(!targetSupportsHtmlContent){const text=clipboardData.getData("text/plain");this.dependencies.dom.insert(text);return true;}}
handlePasteOdooEditorHtml(clipboardData){const odooEditorHtml=clipboardData.getData("application/vnd.odoo.odoo-editor");const textContent=clipboardData.getData("text/plain");if(ONLY_LINK_REGEX.test(textContent)){return false;}
if(odooEditorHtml){const fragment=parseHTML(this.document,odooEditorHtml);this.dependencies.sanitize.sanitize(fragment);if(fragment.hasChildNodes()){this.dependencies.dom.insert(fragment);}
return true;}}
handlePasteHtml(selection,clipboardData){const files=getImageFiles(clipboardData);const clipboardHtml=clipboardData.getData("text/html");const textContent=clipboardData.getData("text/plain");if(ONLY_LINK_REGEX.test(textContent)){return false;}
if(files.length||clipboardHtml){const clipboardElem=this.prepareClipboardData(clipboardHtml);if(files.length&&!clipboardElem.querySelector("table")){return this.addImagesFiles(files).then((html)=>{this.dependencies.dom.insert(html);this.dependencies.history.addStep();});}else{if(closestElement(selection.anchorNode,"a")){this.dependencies.dom.insert(clipboardElem.textContent);}else{this.dependencies.dom.insert(clipboardElem);}}
return true;}}
handlePasteText(selection,clipboardData){const text=clipboardData.getData("text/plain");if(this.delegateTo("paste_text_overrides",selection,text)){return;}else{this.pasteText(selection,text);}}
pasteText(selection,text){const textFragments=text.split(/\r?\n/);let textIndex=1;for(const textFragment of textFragments){const modifiedTextFragment=textFragment.replace(/( {2,})/g,(match)=>{let alertnateValue=false;return match.replace(/ /g,()=>{alertnateValue=!alertnateValue;const replaceContent=alertnateValue?"\u00A0":" ";return replaceContent;});});this.dependencies.dom.insert(modifiedTextFragment);selection=this.dependencies.selection.getEditableSelection();if(textIndex<textFragments.length){const block=closestBlock(selection.anchorNode);if(this.dependencies.split.isUnsplittable(block)||closestElement(selection.anchorNode).tagName==="PRE"){this.dependencies.lineBreak.insertLineBreak();}else{const[blockBefore]=this.dependencies.split.splitBlock();if(block&&block.matches(baseContainerGlobalSelector)&&blockBefore&&!blockBefore.matches(getBaseContainerSelector("DIV"))){const div=this.dependencies.baseContainer.createBaseContainer("DIV");const cursors=this.dependencies.selection.preserveSelection();blockBefore.before(div);div.replaceChildren(...childNodes(blockBefore));blockBefore.remove();cursors.remapNode(blockBefore,div).restore();}
selection=this.dependencies.selection.getEditableSelection();}}
textIndex++;}}
prepareClipboardData(clipboardData){const fragment=parseHTML(this.document,clipboardData);this.dependencies.sanitize.sanitize(fragment);const container=this.document.createElement("fake-container");container.append(fragment);for(const tableElement of container.querySelectorAll("table")){tableElement.classList.add("table","table-bordered","o_table");}
const progId=container.querySelector('meta[name="ProgId"]');if(progId&&progId.content==="Excel.Sheet"){const xlStylesheet=container.querySelector("style");const xlNodes=container.querySelectorAll("[class*=xl],[class*=font]");for(const xlNode of xlNodes){for(const xlClass of xlNode.classList){const xlStyle=xlStylesheet.textContent.match(`.${xlClass}[^{]*{(?<xlStyle>[^}]*)}`).groups.xlStyle.replace("background:","background-color:");xlNode.setAttribute("style",xlNode.style.cssText+";"+xlStyle);}}}
const childContent=childNodes(container);for(const child of childContent){this.cleanForPaste(child);}
const selection=this.dependencies.selection.getEditableSelection();const closestBaseContainer=selection.anchorNode&&closestElement(selection.anchorNode,baseContainerGlobalSelector);wrapInlinesInBlocks(container,{baseContainerNodeName:closestBaseContainer?.nodeName||this.dependencies.baseContainer.getDefaultNodeName(),});const result=this.document.createDocumentFragment();result.replaceChildren(...childNodes(container));const brs=result.querySelectorAll("br");for(const br of brs){const block=closestBlock(br);if((isParagraphRelatedElement(block)||this.dependencies.baseContainer.isCandidateForBaseContainer(block))&&block.nodeName!=="PRE"&&!block.closest("li")){const isEmptyLine=block.firstChild.nodeName==="BR";const remainingBrContainer=this.dependencies.split.splitAroundUntil(br,block);if(!isEmptyLine){remainingBrContainer.remove();}}}
return result;}
cleanForPaste(node){if(!this.isWhitelisted(node)||this.isBlacklisted(node)||(node.id&&node.id.startsWith("docs-internal-guid"))){if(!node.matches||node.matches(CLIPBOARD_BLACKLISTS.remove.join(","))){node.remove();}else{let childrenNodes;if(node.nodeName==="DIV"){if(this.dependencies.baseContainer.isCandidateForBaseContainer(node)){childrenNodes=childNodes(node);}else{childrenNodes=unwrapContents(node);}}else{childrenNodes=unwrapContents(node);}
for(const child of childrenNodes){this.cleanForPaste(child);}}}else if(node.nodeType!==Node.TEXT_NODE){if(node.nodeName==="TD"){if(node.hasAttribute("bgcolor")&&!node.style["background-color"]){node.style["background-color"]=node.getAttribute("bgcolor");}}else if(node.nodeName==="FONT"){if(node.hasAttribute("color")&&!node.style["color"]){node.style["color"]=node.getAttribute("color");}
if(node.hasAttribute("size")&&!node.style["font-size"]){node.style["font-size"]=+node.getAttribute("size")+10+"pt";}}else if(["S","U"].includes(node.nodeName)&&childNodes(node).length===1&&node.firstChild.nodeName==="FONT"){const fontNode=node.firstChild;node.before(fontNode);node.replaceChildren(...childNodes(fontNode));fontNode.appendChild(node);}else if(node.nodeName==="IMG"&&node.getAttribute("aria-roledescription")==="checkbox"){const checklist=node.closest("ul");const closestLi=node.closest("li");if(checklist){checklist.classList.add("o_checklist");if(node.getAttribute("alt")==="checked"){closestLi.classList.add("o_checked");}
node.remove();node=checklist;}}
for(const attribute of[...node.attributes]){if(CLIPBOARD_WHITELISTS.styledTags.includes(node.nodeName)&&attribute.name==="style"){node.removeAttribute(attribute.name);if(["SPAN","FONT"].includes(node.tagName)){for(const unwrappedNode of unwrapContents(node)){this.cleanForPaste(unwrappedNode);}}}else if(!this.isWhitelisted(attribute)){node.removeAttribute(attribute.name);}}
for(const klass of[...node.classList]){if(!this.isWhitelisted(klass)){node.classList.remove(klass);}}
for(const child of childNodes(node)){this.cleanForPaste(child);}}}
isWhitelisted(item){if(item instanceof Attr){return CLIPBOARD_WHITELISTS.attributes.includes(item.name);}else if(typeof item==="string"){return CLIPBOARD_WHITELISTS.classes.some((okClass)=>okClass instanceof RegExp?okClass.test(item):okClass===item);}else{return isTextNode(item)||item.matches?.(CLIPBOARD_WHITELISTS.nodes.join(","));}}
isBlacklisted(node){return(!isTextNode(node)&&node.matches([].concat(...Object.values(CLIPBOARD_BLACKLISTS)).join(",")));}
onDragStart(ev){if(ev.target.nodeName==="IMG"){this.dragImage=ev.target instanceof HTMLElement&&ev.target;ev.dataTransfer.setData("application/vnd.odoo.odoo-editor-node",this.dragImage.outerHTML);}}
async onDrop(ev){ev.preventDefault();if(!isHtmlContentSupported(ev.target)){return;}
const selection=this.dependencies.selection.getEditableSelection();const nodeToSplit=selection.direction===DIRECTIONS.RIGHT?selection.focusNode:selection.anchorNode;const offsetToSplit=selection.direction===DIRECTIONS.RIGHT?selection.focusOffset:selection.anchorOffset;if(nodeToSplit.nodeType===Node.TEXT_NODE&&!selection.isCollapsed){const selectionToRestore=this.dependencies.selection.preserveSelection();splitTextNode(nodeToSplit,offsetToSplit,DIRECTIONS.LEFT);selectionToRestore.restore();}
const dataTransfer=(ev.originalEvent||ev).dataTransfer;const imageNodeHTML=ev.dataTransfer.getData("application/vnd.odoo.odoo-editor-node");const image=imageNodeHTML&&this.dragImage&&imageNodeHTML===this.dragImage.outerHTML&&this.dragImage;const fileTransferItems=getImageFiles(dataTransfer);const htmlTransferItem=[...dataTransfer.items].find((item)=>item.type==="text/html");if(image||fileTransferItems.length||htmlTransferItem){if(this.document.caretPositionFromPoint){const range=this.document.caretPositionFromPoint(ev.clientX,ev.clientY);this.dependencies.delete.deleteSelection();this.dependencies.selection.setSelection({anchorNode:range.offsetNode,anchorOffset:range.offset,});}else if(this.document.caretRangeFromPoint){const range=this.document.caretRangeFromPoint(ev.clientX,ev.clientY);this.dependencies.delete.deleteSelection();this.dependencies.selection.setSelection({anchorNode:range.startContainer,anchorOffset:range.startOffset,});}}
if(image){const fragment=this.document.createDocumentFragment();fragment.append(image);this.dependencies.dom.insert(fragment);this.dependencies.history.addStep();}else if(fileTransferItems.length){const html=await this.addImagesFiles(fileTransferItems);this.dependencies.dom.insert(html);this.dependencies.history.addStep();}else if(htmlTransferItem){htmlTransferItem.getAsString((pastedText)=>{this.dependencies.dom.insert(this.prepareClipboardData(pastedText));this.dependencies.history.addStep();});}}
async addImagesFiles(imageFiles){const promises=[];for(const imageFile of imageFiles){const imageNode=this.document.createElement("img");imageNode.classList.add("img-fluid");if(this.config.dropImageAsAttachment){imageNode.classList.add("o_b64_image_to_save");}
imageNode.dataset.fileName=imageFile.name;promises.push(getImageUrl(imageFile).then((url)=>{imageNode.src=url;return imageNode;}));}
const nodes=await Promise.all(promises);const fragment=this.document.createDocumentFragment();fragment.append(...nodes);return fragment;}}
function getImageFiles(dataTransfer){return[...dataTransfer.items].filter((item)=>item.kind==="file"&&item.type.includes("image/")).map((item)=>item.getAsFile());}
function getImageUrl(file){return new Promise((resolve,reject)=>{const reader=new FileReader();reader.readAsDataURL(file);reader.onloadend=(e)=>{if(reader.error){return reject(reader.error);}
resolve(e.target.result);};});}
__exports.isHtmlContentSupported=isHtmlContentSupported;function isHtmlContentSupported(node){return!closestElement(node,'[data-oe-model]:not([data-oe-field="arch"]):not([data-oe-type="html"]),[data-oe-translation-id]');}
function prependOriginToImages(doc,origin){doc.querySelectorAll("img").forEach((img)=>{const src=img.getAttribute("src");if(src&&!src.startsWith("http")&&!src.startsWith("//")){img.src=origin+(src.startsWith("/")?src:"/"+src);}});}
return __exports;});;

/* /html_editor/static/src/core/comment_plugin.js */
odoo.define('@html_editor/core/comment_plugin',['@html_editor/utils/dom_info','@html_editor/plugin','@html_editor/utils/dom_traversal'],function(require){'use strict';let __exports={};const{isProtected}=require("@html_editor/utils/dom_info");const{Plugin}=require("@html_editor/plugin");const{descendants}=require("@html_editor/utils/dom_traversal");const CommentPlugin=__exports.CommentPlugin=class CommentPlugin extends Plugin{static id="comment";resources={normalize_handlers:this.removeComment.bind(this),};removeComment(node){for(const el of[node,...descendants(node)]){if(el.nodeType===Node.COMMENT_NODE&&!isProtected(el)){el.remove();return;}}}}
return __exports;});;

/* /html_editor/static/src/core/delete_plugin.js */
odoo.define('@html_editor/core/delete_plugin',['@html_editor/plugin','@html_editor/utils/blocks','@html_editor/utils/dom_info','@html_editor/utils/dom_state','@html_editor/utils/dom_traversal','@html_editor/utils/position','@html_editor/utils/content_types','@html_editor/utils/resource','@html_editor/main/list/utils','@web/core/browser/feature_detection'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{closestBlock,isBlock}=require("@html_editor/utils/blocks");const{isAllowedContent,isButton,isContentEditable,isEditorTab,isEmpty,isInPre,isMediaElement,isProtected,isSelfClosingElement,isShrunkBlock,isTangible,isTextNode,isVisibleTextNode,isWhitespace,isZwnbsp,isZWS,nextLeaf,previousLeaf,}=require("@html_editor/utils/dom_info");const{getState,isFakeLineBreak,observeMutations,prepareUpdate}=require("@html_editor/utils/dom_state");const{childNodes,closestElement,findUpTo,descendants,firstLeaf,getCommonAncestor,lastLeaf,findFurthest,}=require("@html_editor/utils/dom_traversal");const{DIRECTIONS,childNodeIndex,endPos,leftPos,nodeSize,rightPos,startPos,}=require("@html_editor/utils/position");const{CTYPES}=require("@html_editor/utils/content_types");const{withSequence}=require("@html_editor/utils/resource");const{compareListTypes}=require("@html_editor/main/list/utils");const{hasTouch,isBrowserChrome}=require("@web/core/browser/feature_detection");const DeletePlugin=__exports.DeletePlugin=class DeletePlugin extends Plugin{static dependencies=["baseContainer","selection","history","input"];static id="delete";static shared=["deleteRange","deleteSelection","delete"];resources={user_commands:[{id:"deleteBackward",run:()=>this.delete("backward","character")},{id:"deleteForward",run:()=>this.delete("forward","character")},{id:"deleteBackwardWord",run:()=>this.delete("backward","word")},{id:"deleteForwardWord",run:()=>this.delete("forward","word")},{id:"deleteBackwardLine",run:()=>this.delete("backward","line")},{id:"deleteForwardLine",run:()=>this.delete("forward","line")},],shortcuts:[{hotkey:"backspace",commandId:"deleteBackward"},{hotkey:"delete",commandId:"deleteForward"},{hotkey:"control+backspace",commandId:"deleteBackwardWord"},{hotkey:"control+delete",commandId:"deleteForwardWord"},{hotkey:"control+shift+backspace",commandId:"deleteBackwardLine"},{hotkey:"control+shift+delete",commandId:"deleteForwardLine"},],beforeinput_handlers:[withSequence(5,this.onBeforeInputInsertText.bind(this)),this.onBeforeInputDelete.bind(this),],input_handlers:(ev)=>this.onAndroidChromeInput?.(ev),selectionchange_handlers:withSequence(5,()=>this.onAndroidChromeSelectionChange?.()),delete_backward_overrides:withSequence(30,this.deleteBackwardUnmergeable.bind(this)),delete_backward_word_overrides:withSequence(20,this.deleteBackwardUnmergeable.bind(this)),delete_backward_line_overrides:this.deleteBackwardUnmergeable.bind(this),delete_forward_overrides:withSequence(20,this.deleteForwardUnmergeable.bind(this)),delete_forward_word_overrides:this.deleteForwardUnmergeable.bind(this),delete_forward_line_overrides:this.deleteForwardUnmergeable.bind(this),unremovable_node_predicates:[(node)=>node.classList?.contains("oe_unremovable"),(node)=>node.matches?.("[data-oe-type='monetary'] > span"),],invalid_for_base_container_predicates:(node)=>this.isUnremovable(node,this.editable),};setup(){this.findPreviousPosition=this.makeFindPositionFn("backward");this.findNextPosition=this.makeFindPositionFn("forward");}
deleteSelection(selection=this.dependencies.selection.getEditableSelection()){selection=this.dependencies.selection.setSelection(selection);if(selection.isCollapsed){return;}
let range=this.adjustRange(selection,[this.expandRangeToIncludeNonEditables,this.includeEndOrStartBlock,this.fullyIncludeLinks,]);if(this.delegateTo("delete_range_overrides",range)){return;}
range=this.deleteRange(range);this.setCursorFromRange(range);}
delete(direction,granularity){const selection=this.dependencies.selection.getEditableSelection();this.dispatchTo("before_delete_handlers");if(!selection.isCollapsed){this.deleteSelection(selection);}else if(direction==="backward"){this.deleteBackward(selection,granularity);}else if(direction==="forward"){this.deleteForward(selection,granularity);}else{throw new Error("Invalid direction");}
this.dispatchTo("delete_handlers");this.dependencies.history.addStep();}
deleteBackward(selection,granularity){const{endContainer,endOffset}=this.dependencies.selection.setSelection(selection);let range=this.getRangeForDelete(endContainer,endOffset,"backward",granularity);const resourceIds={character:"delete_backward_overrides",word:"delete_backward_word_overrides",line:"delete_backward_line_overrides",};if(this.delegateTo(resourceIds[granularity],range)){return;}
range=this.adjustRange(range,[this.includeEmptyInlineEnd,this.includePreviousZWS,this.includeEndOrStartBlock,]);range=this.deleteRange(range);this.document.getSelection()?.removeAllRanges();this.setCursorFromRange(range,{collapseToEnd:true});}
deleteForward(selection,granularity){const{startContainer,startOffset}=this.dependencies.selection.setSelection(selection);let range=this.getRangeForDelete(startContainer,startOffset,"forward",granularity);const resourceIds={character:"delete_forward_overrides",word:"delete_forward_word_overrides",line:"delete_forward_line_overrides",};if(this.delegateTo(resourceIds[granularity],range)){return;}
range=this.adjustRange(range,[this.includeEmptyInlineStart,this.includeNextZWS,this.includeEndOrStartBlock,]);range=this.deleteRange(range);this.setCursorFromRange(range);}
getRangeForDelete(node,offset,direction,granularity){let destContainer,destOffset;switch(granularity){case"character":[destContainer,destOffset]=this.findAdjacentPosition(node,offset,direction);break;case"word":({focusNode:destContainer,focusOffset:destOffset}=this.dependencies.selection.modifySelection("extend",direction,"word"));break;case"line":[destContainer,destOffset]=this.findLineBoundary(node,offset,direction);break;default:throw new Error("Invalid granularity");}
if(!destContainer){[destContainer,destOffset]=[node,offset];}
const[startContainer,startOffset,endContainer,endOffset]=direction==="forward"?[node,offset,destContainer,destOffset]:[destContainer,destOffset,node,offset];return{startContainer,startOffset,endContainer,endOffset};}
deleteRange(range){if(range.startContainer===range.endContainer&&range.startOffset===range.endOffset){return range;}
range=this.splitTextNodes(range);const{startContainer,startOffset,endContainer,endOffset}=range;const restoreSpaces=prepareUpdate(startContainer,startOffset,endContainer,endOffset);let restoreFakeBRs;({restoreFakeBRs,range}=this.removeFakeBRs(range));let allNodesRemoved;({allNodesRemoved,range}=this.removeNodes(range));this.fillEmptyInlines(range);const originalCommonAncestor=range.commonAncestorContainer;if(allNodesRemoved){range=this.joinFragments(range);}
restoreFakeBRs();this.fillShrunkBlocks(originalCommonAncestor);restoreSpaces();return range;}
splitTextNodes({startContainer,startOffset,endContainer,endOffset}){const split=(textNode,offset)=>{let didSplit=false;if(offset===0){offset=childNodeIndex(textNode);}else if(offset===nodeSize(textNode)){offset=childNodeIndex(textNode)+1;}else{textNode.splitText(offset);didSplit=true;offset=childNodeIndex(textNode)+1;}
return[textNode.parentElement,offset,didSplit];};if(endContainer.nodeType===Node.TEXT_NODE){[endContainer,endOffset]=split(endContainer,endOffset);}
if(startContainer.nodeType===Node.TEXT_NODE){let didSplit;[startContainer,startOffset,didSplit]=split(startContainer,startOffset);if(startContainer===endContainer&&didSplit){endOffset+=1;}}
return{startContainer,startOffset,endContainer,endOffset,commonAncestorContainer:getCommonAncestor([startContainer,endContainer],this.editable),};}
removeFakeBRs(range){let{startContainer,startOffset,endContainer,endOffset,commonAncestorContainer}=range;const visitedNodes=new Set();const removeBRs=(container,offset)=>{let node=container;while(node!==commonAncestorContainer){const lastBR=childNodes(node).findLast((child)=>child.nodeName==="BR");if(lastBR&&isFakeLineBreak(lastBR)){if(lastBR===container){[container,offset]=leftPos(lastBR);}else if(node===container&&offset>childNodeIndex(lastBR)){offset-=1;}
lastBR.remove();}
visitedNodes.add(node);node=node.parentNode;}
return[container,offset];};[startContainer,startOffset]=removeBRs(startContainer,startOffset);[endContainer,endOffset]=removeBRs(endContainer,endOffset);range={startContainer,startOffset,endContainer,endOffset,commonAncestorContainer};const restoreFakeBRs=()=>{for(const node of visitedNodes){if(!node.isConnected){continue;}
const lastBR=childNodes(node).findLast((child)=>child.nodeName==="BR");if(lastBR&&isFakeLineBreak(lastBR)){lastBR.after(this.document.createElement("br"));}}};return{restoreFakeBRs,range};}
fillEmptyInlines(range){const nodes=[range.startContainer];if(range.endContainer!==range.startContainer){nodes.push(range.endContainer);}
for(const node of nodes){if(!isBlock(node)&&!isTangible(node)){node.appendChild(this.document.createTextNode("\u200B"));node.setAttribute("data-oe-zws-empty-inline","");}}}
fillShrunkBlocks(commonAncestor){const fillBlock=(block)=>{if(block.matches("div[contenteditable='true']")&&!block.parentElement.isContentEditable){const baseContainer=this.dependencies.baseContainer.createBaseContainer();baseContainer.appendChild(this.document.createElement("br"));block.appendChild(baseContainer);}else{block.appendChild(this.document.createElement("br"));}};for(const node of descendants(commonAncestor).reverse()){if(isBlock(node)&&isShrunkBlock(node)){fillBlock(node);}}
const containingBlock=closestBlock(commonAncestor);if(isShrunkBlock(containingBlock)){fillBlock(containingBlock);}}
removeNodes(range){const{startContainer,startOffset,endContainer,commonAncestorContainer}=range;let{endOffset}=range;const nodesToRemove=[];let node=startContainer;let startRemoveIndex=startOffset;while(node!==commonAncestorContainer){for(let i=startRemoveIndex;i<node.childNodes.length;i++){nodesToRemove.push(node.childNodes[i]);}
startRemoveIndex=childNodeIndex(node)+1;node=node.parentElement;}
node=endContainer;let endRemoveIndex=endOffset;while(node!==commonAncestorContainer){for(let i=0;i<endRemoveIndex;i++){nodesToRemove.push(node.childNodes[i]);}
endRemoveIndex=childNodeIndex(node);node=node.parentElement;}
for(let i=startRemoveIndex;i<endRemoveIndex;i++){nodesToRemove.push(commonAncestorContainer.childNodes[i]);}
let allNodesRemoved=true;for(const node of nodesToRemove){const parent=node.parentNode;const didRemove=this.removeNode(node);allNodesRemoved&&=didRemove;if(didRemove&&endContainer===parent){endOffset-=1;}}
const endContainerList=closestElement(endContainer,"UL, OL");if(["OL","UL"].includes(startContainer.nodeName)&&endContainerList&&!compareListTypes(startContainer,endContainerList)){const newRange=this.document.createRange();newRange.setStart(range.endContainer,endOffset);return{allNodesRemoved,range:newRange};}
return{allNodesRemoved,range:{...range,endOffset}};}
isUnremovable(node,root=undefined){return this.getResource("unremovable_node_predicates").some((p)=>p(node,root));}
removeNode(node){const root=node;const remove=(node)=>{let customHandling=false;let customIsUnremovable;for(const cb of this.getResource("removable_descendants_providers")){const descendantsToRemove=cb(node);if(descendantsToRemove){for(const descendant of descendantsToRemove){remove(descendant);}
customHandling=true;customIsUnremovable=this.isUnremovable(node,root);if(!customIsUnremovable){node.remove();}}}
if(customHandling){return!customIsUnremovable;}
for(const child of[...node.childNodes]){remove(child);}
if(this.isUnremovable(node,root)){return false;}
if(node.hasChildNodes()){node.before(...node.childNodes);node.remove();return false;}
node.remove();return true;};return remove(node);}
joinFragments(range){const joinableLeft=this.getJoinableFragment(range,"start");const joinableRight=this.getJoinableFragment(range,"end");const join=this.getJoinOperation(joinableLeft.type,joinableRight.type);const didJoin=join(joinableLeft.node,joinableRight.node,range.commonAncestorContainer);return didJoin?this.collapseRange(range):range;}
getJoinableFragment(range,side){const commonAncestor=range.commonAncestorContainer;const container=side==="start"?range.startContainer:range.endContainer;const offset=side==="start"?range.startOffset:range.endOffset;if(container===range.commonAncestorContainer){const sibling=childNodes(commonAncestor)[side==="start"?offset-1:offset];if(sibling&&!isBlock(sibling)&&!(sibling.nodeType===Node.TEXT_NODE&&!isVisibleTextNode(sibling))){return{node:sibling,type:"inline"};}
return{node:null,type:"null"};}
let last;let element=container;while(element!==commonAncestor){if(isBlock(element)){return{node:element,type:"block"};}
last=element;element=element.parentElement;}
return{node:last,type:"inline"};}
getJoinOperation(leftType,rightType){return({"block + block":this.joinBlocks,"block + inline":this.joinInlineIntoBlock,"inline + block":this.joinBlockIntoInline,}[leftType+" + "+rightType]||(()=>true)).bind(this);}
isUnmergeable(node){return this.getResource("unsplittable_node_predicates").some((p)=>p(node));}
joinBlocks(left,right,commonAncestor){const canMerge=(n)=>!findUpTo(n,commonAncestor,this.isUnmergeable.bind(this));if(!canMerge(left)||!canMerge(right)){return false;}
const rightChildNodes=childNodes(right);if(!isAllowedContent(left,rightChildNodes)){return false;}
left.append(...rightChildNodes);let toRemove=right;let parent=right.parentElement;while(parent!==commonAncestor&&parent.childNodes.length===1){toRemove=parent;parent=parent.parentElement;}
toRemove.remove();return true;}
joinInlineIntoBlock(leftBlock,rightInline,commonAncestor){if(findUpTo(leftBlock,commonAncestor,(node)=>this.isUnmergeable(node))){return false;}
while(rightInline&&!isBlock(rightInline)){const toAppend=rightInline;rightInline=rightInline.nextSibling;leftBlock.append(toAppend);}
return true;}
joinBlockIntoInline(leftInline,rightBlock,commonAncestor){if(findUpTo(rightBlock,commonAncestor,(node)=>this.isUnmergeable(node))){return false;}
leftInline.after(...childNodes(rightBlock));let toRemove=rightBlock;let parent=rightBlock.parentElement;while(parent!==commonAncestor&&parent.childNodes.length===1){toRemove=parent;parent=parent.parentElement;}
if(parent===commonAncestor){const rightSibling=toRemove.nextSibling;if(rightSibling&&!isBlock(rightSibling)){rightSibling.before(this.document.createElement("br"));}}
toRemove.remove();return true;}
adjustRange({startContainer,startOffset,endContainer,endOffset},callbacks){let range=this.document.createRange();range.setStart(startContainer,startOffset);range.setEnd(endContainer,endOffset);for(const callback of callbacks){range=callback.call(this,range);}
({startContainer,startOffset,endOffset,endContainer}=range);return{startContainer,startOffset,endOffset,endContainer};}
includeBlockStart(block,range){const{startContainer,startOffset,commonAncestorContainer}=range;if(block===commonAncestorContainer||!this.isCursorAtStartOfElement(block,startContainer,startOffset)){return range;}
range.setStartBefore(block);return this.includeBlockStart(block.parentNode,range);}
includeBlockEnd(block,range){const{startContainer,endContainer,endOffset,commonAncestorContainer}=range;const startList=closestElement(startContainer,"UL, OL");const endList=closestElement(endContainer,"UL, OL");if(block===commonAncestorContainer||!this.isCursorAtEndOfElement(block,endContainer,endOffset)||(startList&&endList&&!compareListTypes(startList,endList))){return range;}
range.setEndAfter(block);return this.includeBlockEnd(block.parentNode,range);}
includeEndOrStartBlock(range){const{startContainer,endContainer,commonAncestorContainer}=range;const startBlock=findUpTo(startContainer,commonAncestorContainer,isBlock);const endBlock=findUpTo(endContainer,commonAncestorContainer,isBlock);if(!startBlock||!endBlock){return range;}
range=this.includeBlockEnd(endBlock,range);if(range.endContainer===endContainer){range=this.includeBlockStart(startBlock,range);}
return range;}
fullyIncludeLinks(range){const{startContainer,startOffset,endContainer,endOffset,commonAncestorContainer}=range;const[startLink,endLink]=[startContainer,endContainer].map((container)=>findUpTo(container,commonAncestorContainer,(node)=>node.nodeName==="A"));if(startLink&&this.isCursorAtStartOfElement(startLink,startContainer,startOffset)){range.setStartBefore(startLink);}
if(endLink&&this.isCursorAtEndOfElement(endLink,endContainer,endOffset)){range.setEndAfter(endLink);}
return range;}
includeEmptyInlineStart(range){const element=closestElement(range.startContainer);if(this.isEmptyInline(element)){range.setStartBefore(element);}
return range;}
includeEmptyInlineEnd(range){const element=closestElement(range.endContainer);if(this.isEmptyInline(element)){range.setEndAfter(element);}
return range;}
includeNextZWS(range){const{endContainer,endOffset}=range;if(isTextNode(endContainer)&&endContainer.textContent[endOffset]==="\u200B"){range.setEnd(endContainer,endOffset+1);}
return range;}
includePreviousZWS(range){const{startContainer,startOffset}=range;if(isTextNode(startContainer)&&startContainer.textContent[startOffset-1]==="\u200B"){range.setStart(startContainer,startOffset-1);}
return range;}
expandRangeToIncludeNonEditables(range){const{startContainer,endContainer,commonAncestorContainer:commonAncestor}=range;const isNonEditable=(node)=>!isContentEditable(node);const startUneditable=findFurthest(startContainer,commonAncestor,isNonEditable);if(startUneditable){const leaf=previousLeaf(startUneditable);if(leaf){range.setStart(leaf,nodeSize(leaf));}else{range.setStart(commonAncestor,0);}}
const endUneditable=findFurthest(endContainer,commonAncestor,isNonEditable);if(endUneditable){range.setEndAfter(endUneditable);}
return range;}
findAdjacentPosition(node,offset,direction){return direction==="forward"?this.findNextPosition(node,offset):this.findPreviousPosition(node,offset);}
makeFindPositionFn(direction){const isDirectionForward=direction==="forward";const findVisibleChar=(isDirectionForward?this.findNextVisibleChar:this.findPreviousVisibleChar).bind(this);const charLeftPos=(index,char)=>index;const charRightPos=(index,char)=>index+char.length;const indexBeforeChar=isDirectionForward?charLeftPos:charRightPos;const indexAfterChar=isDirectionForward?charRightPos:charLeftPos;const textEdgePos=isDirectionForward?startPos:endPos;const adjacentLeaf=(isDirectionForward?this.nextLeaf:this.previousLeaf).bind(this);const adjacentLeafFromPos=(isDirectionForward?this.nextLeafFromPos:this.previousLeafFromPos).bind(this);const beforePos=isDirectionForward?leftPos:rightPos;const afterPos=isDirectionForward?rightPos:leftPos;return function findPosition(node,offset){if(node.nodeType===Node.TEXT_NODE){const[char,index]=findVisibleChar(node,offset);if(char){return[node,indexAfterChar(index,char)];}}
const isEditableRoot=(n)=>n.isContentEditable&&!n.parentNode.isContentEditable;const editableRoot=findUpTo(node,this.editable.parentNode,isEditableRoot);let blockSwitch;const nodeClosestBlock=closestBlock(node);let leaf=adjacentLeafFromPos(node,offset,editableRoot);while(leaf){blockSwitch||=closestBlock(leaf)!==nodeClosestBlock;if(this.shouldSkip(leaf,blockSwitch)){leaf=adjacentLeaf(leaf,editableRoot);continue;}
if(leaf.nodeType===Node.TEXT_NODE){const[char,index]=findVisibleChar(...textEdgePos(leaf));if(char){const idx=(blockSwitch?indexBeforeChar:indexAfterChar)(index,char);return[leaf,idx];}}else if(!leaf.isContentEditable&&isBlock(leaf)){return afterPos(leaf);}else{return blockSwitch?beforePos(leaf):afterPos(leaf);}
leaf=adjacentLeaf(leaf,editableRoot);}
return[null,null];};}
findLineBoundary(container,offset,direction){const adjacentLeaf=direction==="forward"?nextLeaf:previousLeaf;const edgeIndex=(node)=>(direction==="forward"?nodeSize(node):0);const block=closestBlock(container);let last=container;let node=adjacentLeaf(container,this.editable);while(node&&node.nodeName!=="BR"&&closestBlock(node)===block){last=node;node=adjacentLeaf(node,this.editable);}
if(last===container&&offset===edgeIndex(container)){return this.findAdjacentPosition(container,offset,direction);}
return direction==="forward"?rightPos(last):leftPos(last);}
isVisibleChar(char,textNode,offset){if(isProtected(textNode)){return true;}
const isZwnbspLinkPad=(node)=>isButton(node.previousSibling)||isButton(node.nextSibling);if(isZwnbsp(textNode)&&isZwnbspLinkPad(textNode)){return true;}
if(["\u200B","\uFEFF"].includes(char)){return false;}
if(!isWhitespace(char)||isInPre(textNode)){return true;}
if(offset){return!isWhitespace(textNode.textContent[offset-char.length]);}else if(!(getState(...leftPos(textNode),DIRECTIONS.LEFT).cType&CTYPES.CONTENT)){return false;}
const charsToTheRight=textNode.textContent.slice(offset+char.length);for(char of charsToTheRight){if(!isWhitespace(char)){return true;}}
if(getState(...rightPos(textNode),DIRECTIONS.RIGHT).cType&CTYPES.CONTENT){return true;}
return false;}
shouldSkip(leaf,blockSwitch){if(leaf.nodeType===Node.TEXT_NODE){return false;}
if(blockSwitch){return false;}
if(leaf.nodeName==="BR"&&isFakeLineBreak(leaf)){return true;}
if([isSelfClosingElement,isMediaElement,isEditorTab].some((predicate)=>predicate(leaf))){return false;}
if(isEmpty(leaf)||isZWS(leaf)){return true;}
return false;}
findPreviousVisibleChar(textNode,index){const chars=[...textNode.textContent.slice(0,index)];let char=chars.pop();while(char){index-=char.length;if(this.isVisibleChar(char,textNode,index)){return[char,index];}
char=chars.pop();}
return[null,null];}
findNextVisibleChar(textNode,index){for(const char of textNode.textContent.slice(index)){if(this.isVisibleChar(char,textNode,index)){return[char,index];}
index+=char.length;}
return[null,null];}
adjustedLeaf(leaf,refEditableRoot){const isNonEditable=(node)=>!isContentEditable(node);const nonEditableRoot=leaf&&findFurthest(leaf,refEditableRoot,isNonEditable);return nonEditableRoot||leaf;}
previousLeaf(node,editableRoot){return this.adjustedLeaf(previousLeaf(node,editableRoot),editableRoot);}
nextLeaf(node,editableRoot){return this.adjustedLeaf(nextLeaf(node,editableRoot),editableRoot);}
previousLeafFromPos(node,offset,editableRoot){const leaf=node.hasChildNodes()&&offset>0?lastLeaf(node.childNodes[offset-1]):previousLeaf(node,editableRoot);return this.adjustedLeaf(leaf,editableRoot);}
nextLeafFromPos(node,offset,editableRoot){const leaf=node.hasChildNodes()&&offset<nodeSize(node)?firstLeaf(node.childNodes[offset]):nextLeaf(node,editableRoot);return this.adjustedLeaf(leaf,editableRoot);}
onBeforeInputDelete(ev){const handledInputTypes={deleteContentBackward:["backward","character"],deleteContentForward:["forward","character"],deleteWordBackward:["backward","word"],deleteWordForward:["forward","word"],deleteHardLineBackward:["backward","line"],deleteHardLineForward:["forward","line"],};const argsForDelete=handledInputTypes[ev.inputType];if(argsForDelete){this.delete(...argsForDelete);ev.preventDefault();if(isBrowserChrome()&&hasTouch()){this.preventDefaultDeleteAndroidChrome(ev);}}}
onBeforeInputInsertText(ev){if(ev.inputType==="insertText"){const selection=this.dependencies.selection.getSelectionData().deepEditableSelection;if(!selection.isCollapsed){this.dispatchTo("before_delete_handlers");this.deleteSelection(selection);this.dispatchTo("delete_handlers");}}}
preventDefaultDeleteAndroidChrome(beforeInputEvent){const restoreDOM=this.dependencies.history.makeSavePoint();this.onAndroidChromeInput=(ev)=>{if(ev.inputType!==beforeInputEvent.inputType){return;}
restoreDOM();const{restore:restoreSelection}=this.dependencies.selection.preserveSelection();const observerOptions={childList:true,subtree:true,characterData:true};const getMutationRecords=observeMutations(this.editable,observerOptions);this.onAndroidChromeSelectionChange=()=>{const shouldRevertSelectionChanges=!getMutationRecords().length;if(shouldRevertSelectionChanges){restoreSelection();}};setTimeout(()=>delete this.onAndroidChromeSelectionChange);};}
deleteBackwardUnmergeable(range){const{startContainer,startOffset,endContainer,endOffset}=range;return this.deleteCharUnmergeable(endContainer,endOffset,startContainer,startOffset);}
deleteForwardUnmergeable(range){const{startContainer,startOffset,endContainer,endOffset}=range;return this.deleteCharUnmergeable(startContainer,startOffset,endContainer,endOffset);}
deleteCharUnmergeable(sourceContainer,sourceOffset,destContainer,destOffset){if(!destContainer){return;}
const commonAncestor=getCommonAncestor([sourceContainer,destContainer],this.editable);const closestUnmergeable=findUpTo(sourceContainer,commonAncestor,(node)=>this.isUnmergeable(node));if(!closestUnmergeable){return;}
if((isEmpty(closestUnmergeable)||this.delegateTo("is_empty_predicates",closestUnmergeable))&&!this.isUnremovable(closestUnmergeable)){closestUnmergeable.remove();this.dependencies.selection.setSelection({anchorNode:destContainer,anchorOffset:destOffset,});}else{this.dependencies.selection.setSelection({anchorNode:sourceContainer,anchorOffset:sourceOffset,});}
return true;}
isEmptyInline(element){if(isBlock(element)){return false;}
if(isZWS(element)){return true;}
return element.innerHTML.trim()==="";}
isCursorAtStartOfElement(element,cursorNode,cursorOffset){const[node]=this.findPreviousPosition(cursorNode,cursorOffset);return!element.contains(node);}
isCursorAtEndOfElement(element,cursorNode,cursorOffset){const[node]=this.findNextPosition(cursorNode,cursorOffset);return!element.contains(node);}
setCursorFromRange(range,{collapseToEnd=false}={}){range=this.collapseRange(range,{toEnd:collapseToEnd});const[anchorNode,anchorOffset]=this.normalizeEnterBlock(range.startContainer,range.startOffset);this.dependencies.selection.setSelection({anchorNode,anchorOffset});}
normalizeEnterBlock(node,offset){while(isBlock(node.childNodes[offset])){[node,offset]=[node.childNodes[offset],0];}
return[node,offset];}
collapseRange(range,{toEnd=false}={}){let{startContainer,startOffset,endContainer,endOffset}=range;if(toEnd){[startContainer,startOffset]=[endContainer,endOffset];}else{[endContainer,endOffset]=[startContainer,startOffset];}
const commonAncestorContainer=startContainer;return{startContainer,startOffset,endContainer,endOffset,commonAncestorContainer};}}
return __exports;});;

/* /html_editor/static/src/core/dialog_plugin.js */
odoo.define('@html_editor/core/dialog_plugin',['@html_editor/plugin'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const DialogPlugin=__exports.DialogPlugin=class DialogPlugin extends Plugin{static id="dialog";static dependencies=["selection"];static shared=["addDialog"];addDialog(DialogClass,props,options={}){return new Promise((resolve)=>{this.services.dialog.add(DialogClass,props,{onClose:()=>{this.dependencies.selection.focusEditable();resolve();},...options,});});}}
return __exports;});;

/* /html_editor/static/src/core/dom_plugin.js */
odoo.define('@html_editor/core/dom_plugin',['@web/core/l10n/translation','@html_editor/plugin','@html_editor/utils/blocks','@html_editor/utils/dom','@html_editor/utils/dom_info','@html_editor/utils/dom_traversal','@html_editor/utils/formatting','@html_editor/utils/position','@html_editor/utils/selection','@html_editor/utils/base_container'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Plugin}=require("@html_editor/plugin");const{closestBlock,isBlock}=require("@html_editor/utils/blocks");const{cleanTrailingBR,fillEmpty,fillShrunkPhrasingParent,makeContentsInline,removeClass,splitTextNode,unwrapContents,wrapInlinesInBlocks,}=require("@html_editor/utils/dom");const{allowsParagraphRelatedElements,getDeepestPosition,isContentEditable,isContentEditableAncestor,isEmptyBlock,isListElement,isListItemElement,isParagraphRelatedElement,isProtecting,isProtected,isSelfClosingElement,isShrunkBlock,isTangible,isUnprotecting,listElementSelector,paragraphRelatedElementsSelector,}=require("@html_editor/utils/dom_info");const{childNodes,children,closestElement,descendants,firstLeaf,lastLeaf,}=require("@html_editor/utils/dom_traversal");const{FONT_SIZE_CLASSES,TEXT_STYLE_CLASSES}=require("@html_editor/utils/formatting");const{DIRECTIONS,childNodeIndex,nodeSize,rightPos}=require("@html_editor/utils/position");const{normalizeCursorPosition}=require("@html_editor/utils/selection");const{baseContainerGlobalSelector}=require("@html_editor/utils/base_container");function getConnectedParents(nodes){const parents=new Set();for(const node of nodes){if(node.isConnected&&node.parentElement){parents.add(node.parentElement);}}
return parents;}
const DomPlugin=__exports.DomPlugin=class DomPlugin extends Plugin{static id="dom";static dependencies=["baseContainer","selection","history","split","delete","lineBreak"];static shared=["insert","copyAttributes","setTag","setTagName"];resources={user_commands:[{id:"insertFontAwesome",run:this.insertFontAwesome.bind(this)},{id:"setTag",run:this.setTag.bind(this)},{id:"insertSeparator",title:_t("Separator"),description:_t("Insert a horizontal rule separator"),icon:"fa-minus",run:this.insertSeparator.bind(this),},],powerbox_items:{categoryId:"structure",commandId:"insertSeparator",},clean_handlers:this.removeEmptyClassAndStyleAttributes.bind(this),clean_for_save_handlers:({root})=>{this.removeEmptyClassAndStyleAttributes(root);for(const el of root.querySelectorAll("hr[contenteditable]")){el.removeAttribute("contenteditable");}},normalize_handlers:this.normalize.bind(this),};contentEditableToRemove=new Set();insert(content){if(!content){return;}
let selection=this.dependencies.selection.getEditableSelection();let startNode;let insertBefore=false;if(!selection.isCollapsed){this.dependencies.delete.deleteSelection();selection=this.dependencies.selection.getEditableSelection();}
if(selection.startContainer.nodeType===Node.TEXT_NODE){insertBefore=!selection.startOffset;splitTextNode(selection.startContainer,selection.startOffset,DIRECTIONS.LEFT);startNode=selection.startContainer;}
const container=this.document.createElement("fake-element");const containerFirstChild=this.document.createElement("fake-element-fc");const containerLastChild=this.document.createElement("fake-element-lc");if(typeof content==="string"){container.textContent=content;}else{if(content.nodeType===Node.ELEMENT_NODE){this.dispatchTo("normalize_handlers",content);}else{for(const child of children(content)){this.dispatchTo("normalize_handlers",child);}}
container.replaceChildren(content);}
const allInsertedNodes=[];const hasSingleChild=nodeSize(container)===1;if(closestElement(selection.anchorNode,listElementSelector)&&isListElement(container.firstChild)){unwrapContents(container.firstChild);}
if(closestElement(selection.focusNode,listElementSelector)&&isListElement(container.lastChild)&&!hasSingleChild){unwrapContents(container.lastChild);}
startNode=startNode||this.dependencies.selection.getEditableSelection().anchorNode;const block=closestBlock(selection.anchorNode);const shouldUnwrap=(node)=>(isParagraphRelatedElement(node)||isListItemElement(node)||node.nodeName==="PRE")&&!isEmptyBlock(block)&&!isEmptyBlock(node)&&(isContentEditable(node)||(!node.isConnected&&!closestElement(node,"[contenteditable]")))&&!this.dependencies.split.isUnsplittable(node)&&(node.nodeName===block.nodeName||(this.dependencies.baseContainer.isCandidateForBaseContainer(node)&&this.dependencies.baseContainer.isCandidateForBaseContainer(block))||(block.nodeName==="DIV"&&this.dependencies.split.isUnsplittable(block)))&&!this.isEditionBoundary(selection.anchorNode);if(container.lastElementChild&&isBlock(container.lastElementChild)&&!container.lastElementChild.hasChildNodes()){fillEmpty(container.lastElementChild);}
if(container.childElementCount===1&&(this.dependencies.baseContainer.isCandidateForBaseContainer(container.firstChild)||shouldUnwrap(container.firstChild))){const nodeToUnwrap=container.firstElementChild;container.replaceChildren(...childNodes(nodeToUnwrap));}else if(container.childElementCount>1){const isSelectionAtStart=firstLeaf(block)===selection.anchorNode&&selection.anchorOffset===0;const isSelectionAtEnd=lastLeaf(block)===selection.focusNode&&selection.focusOffset===nodeSize(selection.focusNode);if(shouldUnwrap(container.firstChild)&&!isSelectionAtStart){if(isListItemElement(container.firstChild)){const deepestBlock=closestBlock(firstLeaf(container.firstChild));this.dependencies.split.splitAroundUntil(deepestBlock,container.firstChild);container.firstElementChild.replaceChildren(...childNodes(deepestBlock));}
containerFirstChild.replaceChildren(...childNodes(container.firstElementChild));container.firstElementChild.remove();}
if(shouldUnwrap(container.lastChild)&&!isSelectionAtEnd){if(isListItemElement(container.lastChild)){const deepestBlock=closestBlock(lastLeaf(container.lastChild));this.dependencies.split.splitAroundUntil(deepestBlock,container.lastChild);container.lastElementChild.replaceChildren(...childNodes(deepestBlock));}
containerLastChild.replaceChildren(...childNodes(container.lastElementChild));container.lastElementChild.remove();}}
if(startNode.nodeType===Node.ELEMENT_NODE){if(selection.anchorOffset===0){const textNode=this.document.createTextNode("");if(isSelfClosingElement(startNode)){startNode.parentNode.insertBefore(textNode,startNode);}else{startNode.prepend(textNode);}
startNode=textNode;allInsertedNodes.push(textNode);}else{startNode=childNodes(startNode).at(selection.anchorOffset-1);}}
let currentNode=startNode;const _insertAt=(reference,nodes,insertBefore)=>{for(const child of insertBefore?nodes.reverse():nodes){reference[insertBefore?"before":"after"](child);reference=child;}};const lastInsertedNodes=childNodes(containerLastChild);if(containerLastChild.hasChildNodes()){const toInsert=childNodes(containerLastChild);_insertAt(currentNode,[...toInsert],insertBefore);currentNode=insertBefore?toInsert[0]:currentNode;toInsert[toInsert.length-1];}
const firstInsertedNodes=childNodes(containerFirstChild);if(containerFirstChild.hasChildNodes()){const toInsert=childNodes(containerFirstChild);_insertAt(currentNode,[...toInsert],insertBefore);currentNode=toInsert[toInsert.length-1];insertBefore=false;}
allInsertedNodes.push(...firstInsertedNodes);if(!container.hasChildNodes()){if(this.dependencies.split.isUnsplittable(closestBlock(currentNode.nextSibling))){this.dependencies.lineBreak.insertLineBreakNode({targetNode:currentNode.nextSibling,targetOffset:0,});}else{const parent=currentNode.nextSibling.parentElement;const index=childNodes(parent).indexOf(currentNode.nextSibling);this.dependencies.split.splitBlockNode({targetNode:parent,targetOffset:index,});}}
let nodeToInsert;let doesCurrentNodeAllowsP=allowsParagraphRelatedElements(currentNode);const candidatesForRemoval=[];const insertedNodes=childNodes(container);while((nodeToInsert=container.firstChild)){if(isBlock(nodeToInsert)&&!doesCurrentNodeAllowsP){while(!this.isEditionBoundary(currentNode.parentElement)&&(!allowsParagraphRelatedElements(currentNode.parentElement)||(isListItemElement(currentNode.parentElement)&&!this.dependencies.split.isUnsplittable(nodeToInsert)))){if(this.dependencies.split.isUnsplittable(currentNode.parentElement)){if(this.dependencies.split.isUnsplittable(nodeToInsert)){currentNode=currentNode.parentElement;doesCurrentNodeAllowsP=allowsParagraphRelatedElements(currentNode);continue;}else{makeContentsInline(container);nodeToInsert=container.firstChild;break;}}
let offset=childNodeIndex(currentNode);if(!insertBefore){offset+=1;}
if(offset){const[left,right]=this.dependencies.split.splitElement(currentNode.parentElement,offset);currentNode=insertBefore?right:left;const otherNode=insertBefore?left:right;if(isBlock(otherNode)){fillShrunkPhrasingParent(otherNode);}
candidatesForRemoval.push(right);}else{if(isBlock(currentNode)){fillShrunkPhrasingParent(currentNode);}
currentNode=currentNode.parentElement;}
doesCurrentNodeAllowsP=allowsParagraphRelatedElements(currentNode);}
if(isListItemElement(currentNode.parentElement)&&isBlock(nodeToInsert)&&this.dependencies.split.isUnsplittable(nodeToInsert)){const br=document.createElement("br");currentNode[isEmptyBlock(currentNode)||!isTangible(currentNode)?"before":"after"](br);}}
const container=closestBlock(currentNode);for(const processor of this.getResource("node_to_insert_processors")){nodeToInsert=processor({nodeToInsert,container});}
if(insertBefore){currentNode.before(nodeToInsert);insertBefore=false;}else{currentNode.after(nodeToInsert);}
allInsertedNodes.push(nodeToInsert);if(currentNode.tagName!=="BR"&&isShrunkBlock(currentNode)){currentNode.remove();}
currentNode=nodeToInsert;}
allInsertedNodes.push(...lastInsertedNodes);let insertedNodesParents=getConnectedParents(allInsertedNodes);for(const parent of insertedNodesParents){if(!this.config.allowInlineAtRoot&&this.isEditionBoundary(parent)&&allowsParagraphRelatedElements(parent)){wrapInlinesInBlocks(parent,{baseContainerNodeName:this.dependencies.baseContainer.getDefaultNodeName(),});}}
insertedNodesParents=getConnectedParents(allInsertedNodes);for(const parent of insertedNodesParents){if(!isProtecting(parent)&&!(isProtected(parent)&&!isUnprotecting(parent))&&parent.isContentEditable){cleanTrailingBR(parent,[(node)=>{const previousSibling=node.previousSibling;return(previousSibling&&isBlock(previousSibling)&&this.dependencies.split.isUnsplittable(previousSibling));},]);}}
for(const candidateForRemoval of candidatesForRemoval){if(candidateForRemoval.isConnected&&(isParagraphRelatedElement(candidateForRemoval)||isListItemElement(candidateForRemoval))&&candidateForRemoval.parentElement.isContentEditable&&isEmptyBlock(candidateForRemoval)&&((candidateForRemoval.previousElementSibling&&!this.dependencies.split.isUnsplittable(candidateForRemoval.previousElementSibling))||(candidateForRemoval.nextElementSibling&&!this.dependencies.split.isUnsplittable(candidateForRemoval.nextElementSibling)))){candidateForRemoval.remove();}}
for(const insertedNode of allInsertedNodes.reverse()){if(insertedNode.isConnected){currentNode=insertedNode;break;}}
let lastPosition=isParagraphRelatedElement(currentNode)||isListItemElement(currentNode)||isListElement(currentNode)?rightPos(lastLeaf(currentNode)):rightPos(currentNode);lastPosition=normalizeCursorPosition(lastPosition[0],lastPosition[1],"right");if(!this.config.allowInlineAtRoot&&this.isEditionBoundary(lastPosition[0])){lastPosition=getDeepestPosition(...lastPosition);}
this.dependencies.selection.setSelection({anchorNode:lastPosition[0],anchorOffset:lastPosition[1]},{normalize:false});return firstInsertedNodes.concat(insertedNodes).concat(lastInsertedNodes);}
isEditionBoundary(node){if(!node){return false;}
if(node===this.editable){return true;}
return isContentEditableAncestor(node);}
copyAttributes(source,target){this.dispatchTo("clean_handlers",source);if(source?.nodeType!==Node.ELEMENT_NODE||target?.nodeType!==Node.ELEMENT_NODE){return;}
const ignoredAttrs=new Set();const ignoredClasses=new Set(this.getResource("system_classes"));for(const attr of source.attributes){if(ignoredAttrs.has(attr)){continue;}
if(attr.name!=="class"||ignoredClasses.size===0){target.setAttribute(attr.name,attr.value);}else{const classes=[...source.classList];for(const className of classes){if(!ignoredClasses.has(className)){target.classList.add(className);}}}}}
setTagName(el,newTagName){const document=el.ownerDocument;if(el.tagName===newTagName){return el;}
const newEl=document.createElement(newTagName);const content=childNodes(el);if(isListItemElement(el)){el.append(newEl);newEl.replaceChildren(...content);}else{if(el.parentElement){el.before(newEl);}
this.copyAttributes(el,newEl);newEl.replaceChildren(...content);el.remove();}
return newEl;}
insertFontAwesome({faClass="fa fa-star"}={}){const fontAwesomeNode=document.createElement("i");fontAwesomeNode.className=faClass;this.insert(fontAwesomeNode);this.dependencies.history.addStep();const[anchorNode,anchorOffset]=rightPos(fontAwesomeNode);this.dependencies.selection.setSelection({anchorNode,anchorOffset});}
setTag({tagName,extraClass=""}){let newCandidate=this.document.createElement(tagName.toUpperCase());if(extraClass){newCandidate.classList.add(extraClass);}
if(this.dependencies.baseContainer.isCandidateForBaseContainer(newCandidate)){const baseContainer=this.dependencies.baseContainer.createBaseContainer(newCandidate.nodeName);this.copyAttributes(newCandidate,baseContainer);newCandidate=baseContainer;}
const cursors=this.dependencies.selection.preserveSelection();const selectedBlocks=[...this.dependencies.selection.getTraversedBlocks()];const deepestSelectedBlocks=selectedBlocks.filter((block)=>!descendants(block).some((descendant)=>selectedBlocks.includes(descendant))&&block.isContentEditable);for(const block of deepestSelectedBlocks){if(isParagraphRelatedElement(block)||block.nodeName==="PRE"||isListItemElement(block)){if(newCandidate.matches(baseContainerGlobalSelector)&&isListItemElement(block)){continue;}
const newEl=this.setTagName(block,tagName);cursors.remapNode(block,newEl);const headingClasses=["h1","h2","h3","h4","h5","h6"];removeClass(newEl,...FONT_SIZE_CLASSES,...TEXT_STYLE_CLASSES,...headingClasses);delete newEl.style.fontSize;if(extraClass){newEl.classList.add(extraClass);}}else{newCandidate.append(...childNodes(block));block.append(newCandidate);cursors.remapNode(block,newCandidate);}}
cursors.restore();this.dependencies.history.addStep();}
insertSeparator(){const selection=this.dependencies.selection.getEditableSelection();const sep=this.document.createElement("hr");const block=closestBlock(selection.startContainer);const element=closestElement(selection.startContainer,paragraphRelatedElementsSelector)||(block&&!isListItemElement(block)?block:null);if(element&&element!==this.editable){element.before(sep);}
this.dependencies.history.addStep();}
removeEmptyClassAndStyleAttributes(root){for(const node of[root,...descendants(root)]){if(node.classList&&!node.classList.length){node.removeAttribute("class");}
if(node.style&&!node.style.length){node.removeAttribute("style");}}}
normalize(el){if(el.tagName==="HR"){el.setAttribute("contenteditable",el.hasAttribute("contenteditable")?el.getAttribute("contenteditable"):"false");}else{for(const separator of el.querySelectorAll("hr")){separator.setAttribute("contenteditable",separator.hasAttribute("contenteditable")?separator.getAttribute("contenteditable"):"false");}}}}
return __exports;});;

/* /html_editor/static/src/core/editor_version_plugin.js */
odoo.define('@html_editor/core/editor_version_plugin',['@html_editor/html_migrations/html_migrations_utils','@html_editor/plugin'],function(require){'use strict';let __exports={};const{htmlEditorVersions,stripVersion,VERSION_SELECTOR,}=require("@html_editor/html_migrations/html_migrations_utils");const{Plugin}=require("@html_editor/plugin");const EditorVersionPlugin=__exports.EditorVersionPlugin=class EditorVersionPlugin extends Plugin{static id="editorVersion";resources={clean_for_save_handlers:this.cleanForSave.bind(this),normalize_handlers:this.normalize.bind(this),};normalize(element){if(element.matches(VERSION_SELECTOR)&&element!==this.editable){delete element.dataset.oeVersion;}
stripVersion(element);}
cleanForSave({root}){const VERSIONS=htmlEditorVersions();const firstChild=root.firstElementChild;const version=VERSIONS.at(-1);if(firstChild&&version){firstChild.dataset.oeVersion=version;}}}
return __exports;});;

/* /html_editor/static/src/core/format_plugin.js */
odoo.define('@html_editor/core/format_plugin',['@html_editor/plugin','@html_editor/utils/blocks','@html_editor/utils/color','@html_editor/utils/dom','@html_editor/utils/dom_info','@html_editor/utils/dom_traversal','@html_editor/utils/formatting','@html_editor/utils/position','@html_editor/utils/dom_state','@web/core/l10n/translation','@html_editor/utils/selection','@html_editor/utils/resource'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{closestBlock,isBlock}=require("@html_editor/utils/blocks");const{hasAnyNodesColor}=require("@html_editor/utils/color");const{cleanTextNode,splitTextNode,unwrapContents}=require("@html_editor/utils/dom");const{areSimilarElements,isContentEditable,isEmptyTextNode,isEmptyBlock,isSelfClosingElement,isTextNode,isVisibleTextNode,isZwnbsp,isZWS,previousLeaf,}=require("@html_editor/utils/dom_info");const{childNodes,closestElement,descendants,selectElements,findFurthest,}=require("@html_editor/utils/dom_traversal");const{FONT_SIZE_CLASSES,formatsSpecs}=require("@html_editor/utils/formatting");const{boundariesIn,boundariesOut,DIRECTIONS,leftPos,rightPos}=require("@html_editor/utils/position");const{prepareUpdate}=require("@html_editor/utils/dom_state");const{_t}=require("@web/core/l10n/translation");const{callbacksForCursorUpdate}=require("@html_editor/utils/selection");const{withSequence}=require("@html_editor/utils/resource");const{isFakeLineBreak}=require("@html_editor/utils/dom_state");const allWhitespaceRegex=/^[\s\u200b]*$/;function isFormatted(formatPlugin,format){return(sel,nodes)=>formatPlugin.isSelectionFormat(format,nodes);}
const FormatPlugin=__exports.FormatPlugin=class FormatPlugin extends Plugin{static id="format";static dependencies=["selection","history","input","split"];static shared=["isSelectionFormat","insertAndSelectZws","mergeAdjacentInlines","formatSelection",];resources={user_commands:[{id:"formatBold",title:_t("Toggle bold"),icon:"fa-bold",run:this.formatSelection.bind(this,"bold"),},{id:"formatItalic",title:_t("Toggle italic"),icon:"fa-italic",run:this.formatSelection.bind(this,"italic"),},{id:"formatUnderline",title:_t("Toggle underline"),icon:"fa-underline",run:this.formatSelection.bind(this,"underline"),},{id:"formatStrikethrough",title:_t("Toggle strikethrough"),icon:"fa-strikethrough",run:this.formatSelection.bind(this,"strikeThrough"),},{id:"formatFontSize",run:({size})=>{return this.formatSelection("fontSize",{applyStyle:true,formatProps:{size},});},},{id:"formatFontSizeClassName",run:({className})=>{return this.formatSelection("setFontSizeClassName",{applyStyle:true,formatProps:{className},});},},{id:"removeFormat",title:_t("Remove Format"),icon:"fa-eraser",run:this.removeFormat.bind(this),},],shortcuts:[{hotkey:"control+b",commandId:"formatBold"},{hotkey:"control+i",commandId:"formatItalic"},{hotkey:"control+u",commandId:"formatUnderline"},{hotkey:"control+5",commandId:"formatStrikethrough"},],toolbar_groups:withSequence(20,{id:"decoration"}),toolbar_items:[{id:"bold",groupId:"decoration",commandId:"formatBold",isActive:isFormatted(this,"bold"),},{id:"italic",groupId:"decoration",commandId:"formatItalic",isActive:isFormatted(this,"italic"),},{id:"underline",groupId:"decoration",commandId:"formatUnderline",isActive:isFormatted(this,"underline"),},{id:"strikethrough",groupId:"decoration",commandId:"formatStrikethrough",isActive:isFormatted(this,"strikeThrough"),},{id:"remove_format",groupId:"decoration",commandId:"removeFormat",isDisabled:(sel,nodes)=>!this.hasAnyFormat(nodes),},],beforeinput_handlers:withSequence(20,this.onBeforeInput.bind(this)),clean_for_save_handlers:this.cleanForSave.bind(this),normalize_handlers:this.normalize.bind(this),selectionchange_handlers:this.removeEmptyInlineElement.bind(this),intangible_char_for_keyboard_navigation_predicates:(_,char)=>char==="\u200b",};removeFormat(){const traversedNodes=this.dependencies.selection.getTraversedNodes();for(const format of Object.keys(formatsSpecs)){if(!formatsSpecs[format].removeStyle||!this.hasSelectionFormat(format,traversedNodes)){continue;}
this._formatSelection(format,{applyStyle:false});}
this.dispatchTo("remove_format_handlers");this.dependencies.history.addStep();}
hasSelectionFormat(format,traversedNodes=this.dependencies.selection.getTraversedNodes()){const selectedNodes=traversedNodes.filter(isTextNode);const isFormatted=formatsSpecs[format].isFormatted;return selectedNodes.some((n)=>isFormatted(n,this.editable));}
isSelectionFormat(format,traversedNodes=this.dependencies.selection.getTraversedNodes()){const selectedNodes=traversedNodes.filter(isTextNode);const isFormatted=formatsSpecs[format].isFormatted;return(selectedNodes.length&&selectedNodes.every((node)=>isZwnbsp(node)||isEmptyTextNode(node)||isFormatted(node,this.editable)));}
hasAnyFormat(traversedNodes){for(const format of Object.keys(formatsSpecs)){if(formatsSpecs[format].removeStyle&&this.hasSelectionFormat(format,traversedNodes)){return true;}}
return(hasAnyNodesColor(traversedNodes,"color")||hasAnyNodesColor(traversedNodes,"backgroundColor"));}
formatSelection(...args){if(this._formatSelection(...args)){this.dependencies.history.addStep();}}
_formatSelection(formatName,{applyStyle,formatProps}={}){const selection=this.dependencies.split.splitSelection();if(typeof applyStyle==="undefined"){applyStyle=!this.isSelectionFormat(formatName);}
let zws;if(selection.isCollapsed){if(isTextNode(selection.anchorNode)&&selection.anchorNode.textContent==="\u200b"){zws=selection.anchorNode;this.dependencies.selection.setSelection({anchorNode:zws,anchorOffset:0,focusNode:zws,focusOffset:1,});}else{zws=this.insertAndSelectZws();}}
const selectedNodes=(this.dependencies.selection.getSelectedNodes().filter((n)=>((isTextNode(n)&&(isVisibleTextNode(n)||isZWS(n)))||(n.nodeName==="BR"&&(isFakeLineBreak(n)||previousLeaf(n,closestBlock(n))?.nodeName==="BR")))&&isContentEditable(n)));const selectedFieldNodes=new Set(this.dependencies.selection.getSelectedNodes().map((n)=>closestElement(n,"*[t-field],*[t-out],*[t-esc]")).filter(Boolean));const formatSpec=formatsSpecs[formatName];for(const node of selectedNodes){const inlineAncestors=[];let currentNode=node;let parentNode=node.parentElement;while(parentNode&&!isBlock(parentNode)&&!this.dependencies.split.isUnsplittable(parentNode)&&(parentNode.classList.length===0||[...parentNode.classList].every((cls)=>FONT_SIZE_CLASSES.includes(cls)))){const isUselessZws=parentNode.tagName==="SPAN"&&parentNode.hasAttribute("data-oe-zws-empty-inline")&&parentNode.getAttributeNames().length===1;if(isUselessZws){unwrapContents(parentNode);}else{const newLastAncestorInlineFormat=this.dependencies.split.splitAroundUntil(currentNode,parentNode);removeFormat(newLastAncestorInlineFormat,formatSpec);if(newLastAncestorInlineFormat.isConnected){inlineAncestors.push(newLastAncestorInlineFormat);currentNode=newLastAncestorInlineFormat;}}
parentNode=currentNode.parentElement;}
const firstBlockOrClassHasFormat=formatSpec.isFormatted(parentNode,formatProps);if(firstBlockOrClassHasFormat&&!applyStyle){formatSpec.addNeutralStyle&&formatSpec.addNeutralStyle(getOrCreateSpan(node,inlineAncestors));}else if(!firstBlockOrClassHasFormat&&applyStyle){const tag=formatSpec.tagName&&this.document.createElement(formatSpec.tagName);if(tag){node.after(tag);tag.append(node);if(!formatSpec.isFormatted(tag,formatProps)){tag.after(node);tag.remove();formatSpec.addStyle(getOrCreateSpan(node,inlineAncestors),formatProps);}}else if(formatName!=="fontSize"||formatProps.size!==undefined){formatSpec.addStyle(getOrCreateSpan(node,inlineAncestors),formatProps);}}}
for(const selectedFieldNode of selectedFieldNodes){if(applyStyle){formatSpec.addStyle(selectedFieldNode,formatProps);}else{formatSpec.removeStyle(selectedFieldNode);}}
if(zws){const siblings=[...zws.parentElement.childNodes];if(!isBlock(zws.parentElement)&&selectedNodes.includes(siblings[0])&&selectedNodes.includes(siblings[siblings.length-1])){zws.parentElement.setAttribute("data-oe-zws-empty-inline","");}else{const span=this.document.createElement("span");span.setAttribute("data-oe-zws-empty-inline","");zws.before(span);span.append(zws);}}
if(selectedNodes.length===1&&selectedNodes[0]&&selectedNodes[0].textContent==="\u200B"){this.dependencies.selection.setCursorStart(selectedNodes[0]);}else if(selectedNodes.length){const firstNode=selectedNodes[0];const lastNode=selectedNodes[selectedNodes.length-1];let newSelection;if(selection.direction===DIRECTIONS.RIGHT){newSelection={anchorNode:firstNode,anchorOffset:0,focusNode:lastNode,focusOffset:lastNode.length,};}else{newSelection={anchorNode:lastNode,anchorOffset:lastNode.length,focusNode:firstNode,focusOffset:0,};}
this.dependencies.selection.setSelection(newSelection,{normalize:false});return true;}
if(selectedFieldNodes.size>0){return true;}}
normalize(root){for(const el of selectElements(root,"[data-oe-zws-empty-inline]")){if(!allWhitespaceRegex.test(el.textContent)){delete el.dataset.oeZwsEmptyInline;this.cleanZWS(el);if(el.tagName==="SPAN"&&el.getAttributeNames().length===0&&el.classList.length===0){unwrapContents(el);}}}
this.mergeAdjacentInlines(root);}
cleanForSave({root,preserveSelection=false}={}){for(const element of root.querySelectorAll("[data-oe-zws-empty-inline]")){this.cleanElement(element,{preserveSelection});}
this.mergeAdjacentInlines(root,{preserveSelection});}
removeEmptyInlineElement(selectionData){const{anchorNode}=selectionData.editableSelection;const blockEl=closestBlock(anchorNode);const inlineElement=findFurthest(closestElement(anchorNode),blockEl,(e)=>!isBlock(e)&&e.textContent==="\u200b");if(this.lastEmptyInlineElement?.isConnected&&this.lastEmptyInlineElement!==inlineElement){this.cleanElement(this.lastEmptyInlineElement,{preserveSelection:true});}
if(inlineElement&&!isEmptyBlock(blockEl)){this.lastEmptyInlineElement=inlineElement;}else{this.lastEmptyInlineElement=null;}}
cleanElement(element,{preserveSelection}){delete element.dataset.oeZwsEmptyInline;if(!allWhitespaceRegex.test(element.textContent)){this.cleanZWS(element,{preserveSelection});return;}
if(this.getResource("unremovable_node_predicates").some((p)=>p(element))){return;}
if(element.classList.length){return;}
const restore=prepareUpdate(...leftPos(element),...rightPos(element));element.remove();restore();}
cleanZWS(element,{preserveSelection=true}={}){const textNodes=descendants(element).filter(isTextNode);const cursors=preserveSelection?this.dependencies.selection.preserveSelection():null;for(const node of textNodes){cleanTextNode(node,"\u200B",cursors);}
cursors?.restore();}
insertText(selection,content){if(selection.anchorNode.nodeType===Node.TEXT_NODE){selection=this.dependencies.selection.setSelection({anchorNode:selection.anchorNode.parentElement,anchorOffset:splitTextNode(selection.anchorNode,selection.anchorOffset),},{normalize:false});}
const txt=this.document.createTextNode(content||"#");const restore=prepareUpdate(selection.anchorNode,selection.anchorOffset);selection.anchorNode.insertBefore(txt,selection.anchorNode.childNodes[selection.anchorOffset]);restore();const[anchorNode,anchorOffset,focusNode,focusOffset]=boundariesOut(txt);this.dependencies.selection.setSelection({anchorNode,anchorOffset,focusNode,focusOffset},{normalize:false});return txt;}
insertAndSelectZws(){const selection=this.dependencies.selection.getEditableSelection();const zws=this.insertText(selection,"\u200B");splitTextNode(zws,selection.anchorOffset);return zws;}
onBeforeInput(ev){if(ev.inputType==="insertText"){const selection=this.dependencies.selection.getEditableSelection();if(!selection.isCollapsed){return;}
const element=closestElement(selection.anchorNode);if(element.hasAttribute("data-oe-zws-empty-inline")){const[anchorNode,anchorOffset,focusNode,focusOffset]=boundariesIn(element);this.dependencies.selection.setSelection({anchorNode,anchorOffset,focusNode,focusOffset,});}}}
mergeAdjacentInlines(root,{preserveSelection=true}={}){let selectionToRestore=null;for(const node of descendants(root)){if(this.shouldBeMergedWithPreviousSibling(node)){if(preserveSelection){selectionToRestore??=this.dependencies.selection.preserveSelection();selectionToRestore.update(callbacksForCursorUpdate.merge(node));}
node.previousSibling.append(...childNodes(node));node.remove();}}
selectionToRestore?.restore();}
shouldBeMergedWithPreviousSibling(node){const isMergeable=(node)=>!this.getResource("unsplittable_node_predicates").some((predicate)=>predicate(node));return(!isSelfClosingElement(node)&&areSimilarElements(node,node.previousSibling)&&isMergeable(node));}}
function getOrCreateSpan(node,ancestors){const document=node.ownerDocument;const span=ancestors.find((element)=>element.tagName==="SPAN"&&element.isConnected);const lastInlineAncestor=ancestors.findLast((element)=>!isBlock(element)&&element.isConnected);if(span){return span;}else{const span=document.createElement("span");if(lastInlineAncestor){lastInlineAncestor.after(span);span.append(lastInlineAncestor);}else{node.after(span);span.append(node);}
return span;}}
function removeFormat(node,formatSpec){const document=node.ownerDocument;node=closestElement(node);if(formatSpec.hasStyle(node)){formatSpec.removeStyle(node);if(["SPAN","FONT"].includes(node.tagName)&&!node.getAttributeNames().length){return unwrapContents(node);}}
if(formatSpec.isTag&&formatSpec.isTag(node)){const attributesNames=node.getAttributeNames().filter((name)=>{return name!=="data-oe-zws-empty-inline";});if(attributesNames.length){const newNode=document.createElement("span");while(node.firstChild){newNode.appendChild(node.firstChild);}
for(let index=node.attributes.length-1;index>=0;--index){newNode.attributes.setNamedItem(node.attributes[index].cloneNode());}
node.parentNode.replaceChild(newNode,node);}else{unwrapContents(node);}}}
return __exports;});;

/* /html_editor/static/src/core/history_plugin.js */
odoo.define('@html_editor/core/history_plugin',['@html_editor/plugin','@html_editor/utils/dom_traversal'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{childNodes,descendants,getCommonAncestor}=require("@html_editor/utils/dom_traversal");const HistoryPlugin=__exports.HistoryPlugin=class HistoryPlugin extends Plugin{static id="history";static dependencies=["selection","sanitize"];static shared=["addExternalStep","addStep","canRedo","canUndo","disableObserver","enableObserver","getHistorySteps","getNodeById","makePreviewableOperation","makeSavePoint","makeSnapshotStep","redo","reset","resetFromSteps","serializeSelection","stageSelection","undo",];resources={user_commands:[{id:"historyUndo",run:this.undo.bind(this)},{id:"historyRedo",run:this.redo.bind(this)},],shortcuts:[{hotkey:"control+z",commandId:"historyUndo"},{hotkey:"control+y",commandId:"historyRedo"},{hotkey:"control+shift+z",commandId:"historyRedo"},],start_edition_handlers:()=>{this.enableObserver();this.reset(this.config.content);},};setup(){this.mutationFilteredClasses=new Set(this.getResource("system_classes"));this._onKeyupResetContenteditableNodes=[];this.addDomListener(this.document,"beforeinput",this._onDocumentBeforeInput.bind(this));this.addDomListener(this.document,"input",this._onDocumentInput.bind(this));this.addDomListener(this.editable,"pointerup",()=>{this.stageSelection();});this.observer=new MutationObserver(this.handleNewRecords.bind(this));this._cleanups.push(()=>this.observer.disconnect());this.clean();}
clean(){this.handleObserverRecords();this.steps=[];this.currentStep=this.processHistoryStep({selection:{},mutations:[],id:this.generateId(),previousStepId:undefined,});this.stepsStates=new Map();this.nodeToIdMap=new WeakMap();this.idToNodeMap=new Map();this.setNodeId(this.editable);this.dispatchTo("history_cleaned_handlers");}
getNodeById(id){return this.idToNodeMap.get(id);}
reset(content){this.clean();this.stageSelection();this.steps.push(this.makeSnapshotStep());this.dispatchTo("history_reset_handlers",content);}
resetFromSteps(steps){this.disableObserver();this.editable.replaceChildren();this.clean();this.stageSelection();for(const step of steps){this.applyMutations(step.mutations);}
this.steps=steps;this.dispatchTo("history_reset_from_steps_handlers");this.enableObserver();this.dispatchTo("history_reset_from_steps_handlers");}
makeSnapshotStep(){return{selection:{anchorNode:undefined,anchorOffset:undefined,focusNode:undefined,focusOffset:undefined,},mutations:childNodes(this.editable).map((node)=>({type:"add",append:"root",id:this.nodeToIdMap.get(node),node:this.serializeNode(node),})),id:this.steps[this.steps.length-1]?.id||this.generateId(),previousStepId:undefined,};}
getHistorySteps(){return this.steps;}
processHistoryStep(step){for(const fn of this.getResource("history_step_processors")){step=fn(step);}
return step;}
enableObserver(){this.observer.observe(this.editable,{childList:true,subtree:true,attributes:true,attributeOldValue:true,characterData:true,characterDataOldValue:true,});}
disableObserver(){this.handleObserverRecords();this.observer.disconnect();}
handleObserverRecords(){this.handleNewRecords(this.observer.takeRecords());}
processNewRecords(records){this.setIdOnRecords(records);records=this.filterMutationRecords(records);if(!records.length){return[];}
this.getResource("handleNewRecords").forEach((cb)=>cb(records));this.stageRecords(records);return records;}
dispatchContentUpdated(){if(!this.currentStep?.mutations?.length){return;}
const root=this.getMutationsRoot(this.currentStep.mutations);if(!root){return;}
this.dispatchTo("content_updated_handlers",root);}
handleNewRecords(records){if(this.processNewRecords(records).length){this.dispatchContentUpdated();}}
setIdOnRecords(records){for(const record of records){if(record.type==="childList"&&record.addedNodes.length){const{addedNodes,removedNodes}=record;if(this.isSameTextContentMutation(record)){const oldId=this.nodeToIdMap.get(removedNodes[0]);if(oldId){this.nodeToIdMap.delete(removedNodes[0]);this.idToNodeMap.delete(oldId);this.nodeToIdMap.set(addedNodes[0],oldId);this.idToNodeMap.set(oldId,addedNodes[0]);}}else{for(const node of addedNodes){this.setNodeId(node);}}}}}
filterMutationRecords(records){this.dispatchTo("before_filter_mutation_record_handlers",records);for(const callback of this.getResource("savable_mutation_record_predicates")){records=records.filter(callback);}
const attributeCache=new Map();const filteredRecords=[];for(const record of records){if(record.type==="attributes"){if(record.target===this.editable){continue;}
if(record.attributeName==="contenteditable"){continue;}
attributeCache.set(record.target,attributeCache.get(record.target)||{});if(record.attributeName==="class"){const classBefore=(record.oldValue&&record.oldValue.split(" "))||[];const classAfter=(record.target.className&&record.target.className.split&&record.target.className.split(" "))||[];const excludedClasses=[];for(const klass of classBefore){if(!classAfter.includes(klass)){excludedClasses.push(klass);}}
for(const klass of classAfter){if(!classBefore.includes(klass)){excludedClasses.push(klass);}}
if(excludedClasses.length&&excludedClasses.every((c)=>this.mutationFilteredClasses.has(c))){continue;}}
if(typeof attributeCache.get(record.target)[record.attributeName]==="undefined"){const oldValue=record.oldValue===undefined?null:record.oldValue;attributeCache.get(record.target)[record.attributeName]=oldValue!==record.target.getAttribute(record.attributeName);}
if(!attributeCache.get(record.target)[record.attributeName]){continue;}}else if(record.type==="childList"&&this.isSameTextContentMutation(record)){continue;}
filteredRecords.push(record);}
return filteredRecords;}
isSameTextContentMutation(record){const{addedNodes,removedNodes}=record;return(record.type==="childList"&&addedNodes.length===1&&removedNodes.length===1&&addedNodes[0].nodeType===Node.TEXT_NODE&&removedNodes[0].nodeType===Node.TEXT_NODE&&addedNodes[0].textContent===removedNodes[0].textContent);}
stageSelection(){const selection=this.dependencies.selection.getEditableSelection();if(this.currentStep.mutations.find((m)=>["characterData","remove","add"].includes(m.type))){console.warn(`should not have any "characterData", "remove" or "add" mutations in current step when you update the selection`);return;}
this.currentStep.selection=this.serializeSelection(selection);}
stageRecords(records){const mutatedNodes=new Set();for(const record of records){if(record.type==="childList"){for(const node of record.addedNodes){const id=this.setNodeId(node);mutatedNodes.add(id);}
for(const node of record.removedNodes){const id=this.setNodeId(node);mutatedNodes.delete(id);}}}
for(const record of records){switch(record.type){case"characterData":{this.currentStep.mutations.push({type:"characterData",id:this.nodeToIdMap.get(record.target),text:record.target.textContent,oldValue:record.oldValue,});break;}
case"attributes":{this.currentStep.mutations.push({type:"attributes",id:this.nodeToIdMap.get(record.target),attributeName:record.attributeName,value:record.target.getAttribute(record.attributeName),oldValue:record.oldValue,});this.dispatchTo("attribute_change_handlers",{target:record.target,attributeName:record.attributeName,oldValue:record.oldValue,value:record.target.getAttribute(record.attributeName),});break;}
case"childList":{record.addedNodes.forEach((added)=>{const mutation={type:"add",};if(!record.nextSibling&&this.nodeToIdMap.get(record.target)){mutation.append=this.nodeToIdMap.get(record.target);}else if(record.nextSibling&&this.nodeToIdMap.get(record.nextSibling)){mutation.before=this.nodeToIdMap.get(record.nextSibling);}else if(!record.previousSibling&&this.nodeToIdMap.get(record.target)){mutation.prepend=this.nodeToIdMap.get(record.target);}else if(record.previousSibling&&this.nodeToIdMap.get(record.previousSibling)){mutation.after=this.nodeToIdMap.get(record.previousSibling);}else{return false;}
mutation.id=this.nodeToIdMap.get(added);mutation.node=this.serializeNode(added,mutatedNodes);this.currentStep.mutations.push(mutation);});record.removedNodes.forEach((removed)=>{this.currentStep.mutations.push({type:"remove",id:this.nodeToIdMap.get(removed),parentId:this.nodeToIdMap.get(record.target),node:this.serializeNode(removed),nextId:record.nextSibling?this.nodeToIdMap.get(record.nextSibling):undefined,previousId:record.previousSibling?this.nodeToIdMap.get(record.previousSibling):undefined,});});break;}}}}
setNodeId(node){let id=this.nodeToIdMap.get(node);if(!id){id=node===this.editable?"root":this.generateId();this.nodeToIdMap.set(node,id);this.idToNodeMap.set(id,node);node=node.firstChild;while(node){this.setNodeId(node);node=node.nextSibling;}}
return id;}
generateId(){return Math.floor(Math.random()*Math.pow(2,52)).toString();}
addStep({stepState}={}){this.handleObserverRecords();const currentStep=this.currentStep;const currentMutationsCount=currentStep.mutations.length;if(currentMutationsCount===0){return false;}
const stepCommonAncestor=this.getMutationsRoot(currentStep.mutations)||this.editable;this.dispatchTo("normalize_handlers",stepCommonAncestor);this.handleObserverRecords();if(currentMutationsCount===currentStep.mutations.length){this.dispatchContentUpdated();}
currentStep.previousStepId=this.steps.at(-1)?.id;this.steps.push(currentStep);this.currentStep=this.processHistoryStep({id:this.generateId(),selection:{},mutations:[],previousStepId:undefined,});if(stepState){this.stepsStates.set(currentStep.id,stepState);}
this.stageSelection();this.dispatchTo("step_added_handlers",{step:currentStep,stepCommonAncestor});this.config.onChange?.();return currentStep;}
canUndo(){return this.getNextUndoIndex()>0;}
canRedo(){return this.getNextRedoIndex()>0;}
undo(){if(this.steps.length===1){return;}
this.handleObserverRecords();const lastStep=this.currentStep;this.revertMutations(lastStep.mutations);this.observer.takeRecords();lastStep.mutations=[];const pos=this.getNextUndoIndex();if(pos>0){this.stepsStates.set(this.steps[pos].id,"consumed");this.revertMutations(this.steps[pos].mutations,{forNewStep:true});this.setSerializedSelection(this.steps[pos].selection);this.addStep({stepState:"undo"});}
this.dispatchTo("post_undo_handlers");}
redo(){this.handleObserverRecords();this.revertMutations(this.currentStep.mutations);this.observer.takeRecords();this.currentStep.mutations=[];const pos=this.getNextRedoIndex();if(pos>0){this.stepsStates.set(this.steps[pos].id,"consumed");this.revertMutations(this.steps[pos].mutations,{forNewStep:true});this.setSerializedSelection(this.steps[pos].selection);this.addStep({stepState:"redo"});}
this.dispatchTo("post_redo_handlers");}
setSerializedSelection(selection){if(!selection.anchorNodeId){return;}
const anchorNode=this.idToNodeMap.get(selection.anchorNodeId);if(!anchorNode){return;}
const newSelection={anchorNode,anchorOffset:selection.anchorOffset,};const focusNode=this.idToNodeMap.get(selection.focusNodeId);if(focusNode){newSelection.focusNode=focusNode;newSelection.focusOffset=selection.focusOffset;}
this.dependencies.selection.setSelection(newSelection,{normalize:false});}
getNextUndoIndex(){for(let index=this.steps.length-1;index>=0;index--){if(this.isReversibleStep(index)){const state=this.stepsStates.get(this.steps[index].id);if(state==="redo"||!state){return index;}}}
return-1;}
isReversibleStep(index){const step=this.steps[index];if(!step){return false;}
return!this.getResource("unreversible_step_predicates").some((predicate)=>predicate(step));}
getNextRedoIndex(){let totalConsumed=0;for(let index=this.steps.length-1;index>=0;index--){if(this.isReversibleStep(index)){const state=this.stepsStates.get(this.steps[index].id);switch(state){case"undo":return totalConsumed<=0?index:-1;case"redo":totalConsumed-=1;break;case"consumed":totalConsumed+=1;break;default:return-1;}}}
return-1;}
addExternalStep(newStep,index){this.revertMutations(this.currentStep.mutations);const stepsAfterNewStep=this.steps.slice(index);for(const stepToRevert of stepsAfterNewStep.slice().reverse()){this.revertMutations(stepToRevert.mutations);}
this.applyMutations(newStep.mutations);this.dispatchTo("normalize_handlers",this.getMutationsRoot(newStep.mutations)||this.editable);this.steps.splice(index,0,newStep);for(const stepToApply of stepsAfterNewStep){this.applyMutations(stepToApply.mutations);}
this.applyMutations(this.currentStep.mutations);this.dispatchTo("external_step_added_handlers");}
applyMutations(mutations,{forNewStep=false}={}){for(const mutation of mutations){switch(mutation.type){case"characterData":{const node=this.idToNodeMap.get(mutation.id);if(node){node.textContent=mutation.text;}
break;}
case"attributes":{const node=this.idToNodeMap.get(mutation.id);if(node){let value=this.getAttributeValue(mutation.attributeName,mutation.value);for(const cb of this.getResource("attribute_change_processors")){value=cb({target:node,attributeName:mutation.attributeName,oldValue:mutation.oldValue,value,},{forNewStep});}
this.setAttribute(node,mutation.attributeName,value);}
break;}
case"remove":{const toremove=this.idToNodeMap.get(mutation.id);if(toremove){toremove.remove();}
break;}
case"add":{const node=this.idToNodeMap.get(mutation.id)||this.unserializeNode(mutation.node);if(!node){continue;}
this.setNodeId(node);if(mutation.append&&this.idToNodeMap.get(mutation.append)){this.idToNodeMap.get(mutation.append).append(node);}else if(mutation.before&&this.idToNodeMap.get(mutation.before)){this.idToNodeMap.get(mutation.before).before(node);}else if(mutation.after&&this.idToNodeMap.get(mutation.after)){this.idToNodeMap.get(mutation.after).after(node);}else{continue;}
break;}}}}
revertMutations(mutations,{forNewStep=false}={}){for(const mutation of mutations.toReversed()){switch(mutation.type){case"characterData":{const node=this.idToNodeMap.get(mutation.id);if(node){node.textContent=mutation.oldValue;}
break;}
case"attributes":{const node=this.idToNodeMap.get(mutation.id);if(node){let value=this.getAttributeValue(mutation.attributeName,mutation.oldValue);for(const cb of this.getResource("attribute_change_processors")){value=cb({target:node,attributeName:mutation.attributeName,oldValue:mutation.value,value,reverse:true,},{forNewStep});}
this.setAttribute(node,mutation.attributeName,value);}
break;}
case"remove":{let nodeToRemove=this.idToNodeMap.get(mutation.id);if(!nodeToRemove){nodeToRemove=this.unserializeNode(mutation.node);if(!nodeToRemove){continue;}}
if(mutation.nextId&&this.idToNodeMap.get(mutation.nextId)?.isConnected){const node=this.idToNodeMap.get(mutation.nextId);node&&node.before(nodeToRemove);}else if(mutation.previousId&&this.idToNodeMap.get(mutation.previousId)?.isConnected){const node=this.idToNodeMap.get(mutation.previousId);node&&node.after(nodeToRemove);}else{const node=this.idToNodeMap.get(mutation.parentId);node&&node.append(nodeToRemove);}
break;}
case"add":{const node=this.idToNodeMap.get(mutation.id);if(node){node.remove();}}}}}
serializeSelection(selection){return{anchorNodeId:this.nodeToIdMap.get(selection.anchorNode),anchorOffset:selection.anchorOffset,focusNodeId:this.nodeToIdMap.get(selection.focusNode),focusOffset:selection.focusOffset,};}
getMutationsRoot(mutations){const nodes=mutations.map((m)=>this.idToNodeMap.get(m.parentId||m.id)).filter((node)=>this.editable.contains(node));let commonAncestor=getCommonAncestor(nodes,this.editable);if(commonAncestor?.nodeType===Node.TEXT_NODE){commonAncestor=commonAncestor.parentElement;}
return commonAncestor;}
makeSavePoint(){this.handleObserverRecords();const draftMutations=this.currentStep.mutations.slice();const step=this.steps.at(-1);let applied=false;const selectionToRestore=this.dependencies.selection.preserveSelection();return()=>{if(applied){return;}
applied=true;const stepIndex=this.steps.findLastIndex((item)=>item===step);this.revertStepsUntil(stepIndex);this.applyMutations(draftMutations,{forNewStep:true});this.handleObserverRecords();selectionToRestore.restore();this.dispatchTo("restore_savepoint_handlers");};}
makePreviewableOperation(operation){let revertOperation=()=>{};return{preview:(...args)=>{revertOperation();revertOperation=this.makeSavePoint();operation(...args);},commit:(...args)=>{revertOperation();operation(...args);this.addStep();},revert:()=>{revertOperation();},};}
revertStepsUntil(stepIndex){this.handleObserverRecords();this.revertMutations(this.currentStep.mutations);this.observer.takeRecords();this.currentStep.mutations=[];let lastRevertedStep=this.currentStep;if(stepIndex===this.steps.length-1){return;}
for(let i=this.steps.length-1;i>stepIndex;i--){const currentStep=this.steps[i];this.revertMutations(currentStep.mutations,{forNewStep:true});this.processNewRecords(this.observer.takeRecords());if(this.isReversibleStep(i)){this.stepsStates.set(currentStep.id,"consumed");lastRevertedStep=currentStep;}}
for(let i=stepIndex+1;i<this.steps.length;i++){const currentStep=this.steps[i];if(!this.isReversibleStep(i)){this.applyMutations(currentStep.mutations,{forNewStep:true});this.processNewRecords(this.observer.takeRecords());}}
this.setSerializedSelection(lastRevertedStep.selection);this.dispatchContentUpdated();this.addStep({stepState:"consumed"});}
getAttributeValue(attributeName,value){if(typeof value==="string"&&attributeName==="class"){value=value.split(" ").filter((c)=>!this.mutationFilteredClasses.has(c)).join(" ");}
return value;}
setAttribute(node,attributeName,attributeValue){if(this.delegateTo("set_attribute_overrides",node,attributeName,attributeValue)){return;}
if(attributeValue!==null){node.setAttribute(attributeName,attributeValue);}else{node.removeAttribute(attributeName);}}
serializeNode(node,mutatedNodes){return this._serializeNode(node,mutatedNodes,this.nodeToIdMap);}
unserializeNode(node){let[unserializedNode,nodeMap]=this._unserializeNode(node,this.idToNodeMap);const fakeNode=this.document.createElement("fake-el");fakeNode.appendChild(unserializedNode);this.dependencies.sanitize.sanitize(fakeNode,{IN_PLACE:true});unserializedNode=fakeNode.firstChild;if(unserializedNode){for(const node of[unserializedNode,...descendants(unserializedNode)]){const id=nodeMap.get(node);if(id){this.nodeToIdMap.set(node,id);this.idToNodeMap.set(id,node);}}
this.setNodeId(unserializedNode);return unserializedNode;}}
_serializeNode(node,nodesToStripFromChildren=new Set()){const nodeId=this.nodeToIdMap.get(node);if(!nodeId){return;}
const result={nodeType:node.nodeType,nodeId:nodeId,};if(node.nodeType===Node.TEXT_NODE){result.textValue=node.nodeValue;}else if(node.nodeType===Node.ELEMENT_NODE){let childrenToSerialize=childNodes(node);for(const cb of this.getResource("serializable_descendants_processors")){childrenToSerialize=cb(node,childrenToSerialize);}
result.tagName=node.tagName;result.children=[];result.attributes={};for(let i=0;i<node.attributes.length;i++){result.attributes[node.attributes[i].name]=node.attributes[i].value;}
for(const child of childrenToSerialize){if(!nodesToStripFromChildren.has(child.nodeId)){const serializedChild=this._serializeNode(child,nodesToStripFromChildren);if(serializedChild){result.children.push(serializedChild);}}}}
return result;}
_unserializeNode(serializedNode,idToNodeMap=new Map(),_map=new Map()){let node=undefined;if(serializedNode.nodeType===Node.TEXT_NODE){node=this.document.createTextNode(serializedNode.textValue);}else if(serializedNode.nodeType===Node.ELEMENT_NODE){node=idToNodeMap.get(serializedNode.nodeId);if(node){return[node,_map];}
node=this.document.createElement(serializedNode.tagName);for(const key in serializedNode.attributes){node.setAttribute(key,serializedNode.attributes[key]);}
serializedNode.children.forEach((child)=>node.append(this._unserializeNode(child,idToNodeMap,_map)[0]));}else{console.warn("unknown node type");}
_map.set(node,serializedNode.nodeId);return[node,_map];}
_onDocumentBeforeInput(ev){if(this.editable.contains(ev.targget)){return;}
if(["historyUndo","historyRedo"].includes(ev.inputType)){this._onKeyupResetContenteditableNodes.push(...this.editable.querySelectorAll("[contenteditable=true]"));if(this.editable.getAttribute("contenteditable")==="true"){this._onKeyupResetContenteditableNodes.push(this.editable);}
for(const node of this._onKeyupResetContenteditableNodes){node.setAttribute("contenteditable",false);}}}
_onDocumentInput(ev){if(["historyUndo","historyRedo"].includes(ev.inputType)&&this._onKeyupResetContenteditableNodes.length){for(const node of this._onKeyupResetContenteditableNodes){node.setAttribute("contenteditable",true);}
this._onKeyupResetContenteditableNodes=[];}}}
return __exports;});;

/* /html_editor/static/src/core/input_plugin.js */
odoo.define('@html_editor/core/input_plugin',['@html_editor/plugin'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const InputPlugin=__exports.InputPlugin=class InputPlugin extends Plugin{static id="input";static dependencies=["history"];setup(){this.addDomListener(this.editable,"beforeinput",this.onBeforeInput);this.addDomListener(this.editable,"input",this.onInput);}
onBeforeInput(ev){this.dependencies.history.stageSelection();this.dispatchTo("beforeinput_handlers",ev);}
onInput(ev){this.dependencies.history.addStep();this.dispatchTo("input_handlers",ev);}}
return __exports;});;

/* /html_editor/static/src/core/line_break_plugin.js */
odoo.define('@html_editor/core/line_break_plugin',['@html_editor/utils/dom','@html_editor/plugin','@html_editor/utils/content_types','@html_editor/utils/dom_state','@html_editor/utils/position','@html_editor/utils/dom_traversal'],function(require){'use strict';let __exports={};const{splitTextNode}=require("@html_editor/utils/dom");const{Plugin}=require("@html_editor/plugin");const{CTGROUPS,CTYPES}=require("@html_editor/utils/content_types");const{getState,isFakeLineBreak,prepareUpdate}=require("@html_editor/utils/dom_state");const{DIRECTIONS,leftPos,rightPos}=require("@html_editor/utils/position");const{closestElement}=require("@html_editor/utils/dom_traversal");const LineBreakPlugin=__exports.LineBreakPlugin=class LineBreakPlugin extends Plugin{static dependencies=["selection","history","input","delete"];static id="lineBreak";static shared=["insertLineBreak","insertLineBreakNode","insertLineBreakElement"];resources={beforeinput_handlers:this.onBeforeInput.bind(this),};insertLineBreak(){this.dispatchTo("before_line_break_handlers");let selection=this.dependencies.selection.getEditableSelection();if(!selection.isCollapsed){this.dependencies.delete.deleteSelection();selection=this.dependencies.selection.getEditableSelection();}
const targetNode=selection.anchorNode;const targetOffset=selection.anchorOffset;this.insertLineBreakNode({targetNode,targetOffset});this.dependencies.history.addStep();}
insertLineBreakNode({targetNode,targetOffset}){const closestEl=closestElement(targetNode);if(closestEl&&!closestEl.isContentEditable){return;}
if(targetNode.nodeType===Node.TEXT_NODE){targetOffset=splitTextNode(targetNode,targetOffset);targetNode=targetNode.parentElement;}
if(this.delegateTo("insert_line_break_element_overrides",{targetNode,targetOffset})){return;}
this.insertLineBreakElement({targetNode,targetOffset});}
insertLineBreakElement({targetNode,targetOffset}){const closestEl=closestElement(targetNode);if(closestEl&&!closestEl.isContentEditable){return;}
const restore=prepareUpdate(targetNode,targetOffset);const brEl=this.document.createElement("br");const brEls=[brEl];if(targetOffset>=targetNode.childNodes.length){targetNode.appendChild(brEl);}else{targetNode.insertBefore(brEl,targetNode.childNodes[targetOffset]);}
if(isFakeLineBreak(brEl)&&!(getState(...leftPos(brEl),DIRECTIONS.LEFT).cType&(CTGROUPS.BLOCK|CTYPES.BR))){const brEl2=this.document.createElement("br");brEl.before(brEl2);brEls.unshift(brEl2);}
restore();for(const el of brEls){if(el.parentNode){const pos=rightPos(el);this.dependencies.selection.setSelection({anchorNode:pos[0],anchorOffset:pos[1],});break;}}}
onBeforeInput(e){if(e.inputType==="insertLineBreak"){e.preventDefault();this.insertLineBreak();}}}
return __exports;});;

/* /html_editor/static/src/core/no_inline_root_plugin.js */
odoo.define('@html_editor/core/no_inline_root_plugin',['@html_editor/utils/dom_info','@html_editor/plugin','@html_editor/core/selection_plugin','@html_editor/utils/position'],function(require){'use strict';let __exports={};const{getDeepestPosition,isParagraphRelatedElement}=require("@html_editor/utils/dom_info");const{Plugin}=require("@html_editor/plugin");const{isNotAllowedContent}=require("@html_editor/core/selection_plugin");const{nodeSize}=require("@html_editor/utils/position");const NoInlineRootPlugin=__exports.NoInlineRootPlugin=class NoInlineRootPlugin extends Plugin{static id="noInlineRoot";static dependencies=["baseContainer","selection","history"];resources={...(!this.config.allowInlineAtRoot&&{fix_selection_on_editable_root_handlers:this.fixSelectionOnEditableRoot.bind(this),}),};setup(){this.addDomListener(this.editable,"keydown",(ev)=>{this.currentKeyDown=ev.key;});this.addDomListener(this.editable,"pointerdown",()=>{this.isPointerDown=true;});this.addDomListener(this.editable,"pointerup",()=>{this.isPointerDown=false;this.preventNextPointerdownFix=false;});}
fixSelectionOnEditableRoot(selection){if(!selection.isCollapsed||selection.anchorNode!==this.editable||this.config.allowInlineAtRoot){return false;}
const nodeAfterCursor=this.editable.childNodes[selection.anchorOffset];const nodeBeforeCursor=nodeAfterCursor&&nodeAfterCursor.previousElementSibling;return(this.fixSelectionOnEditableRootArrowKeys(nodeAfterCursor,nodeBeforeCursor)||this.fixSelectionOnEditableRootGeneric(nodeAfterCursor,nodeBeforeCursor)||this.fixSelectionOnEditableRootCreateP(nodeAfterCursor,nodeBeforeCursor));}
fixSelectionOnEditableRootArrowKeys(nodeAfterCursor,nodeBeforeCursor){const currentKeyDown=this.currentKeyDown;delete this.currentKeyDown;if(currentKeyDown==="ArrowRight"||currentKeyDown==="ArrowDown"){while(nodeAfterCursor&&isNotAllowedContent(nodeAfterCursor)){nodeAfterCursor=nodeAfterCursor.nextElementSibling;}
const[anchorNode]=getDeepestPosition(nodeAfterCursor,0);if(nodeAfterCursor){this.dependencies.selection.setSelection({anchorNode:anchorNode,anchorOffset:0,});return true;}else{this.dependencies.selection.resetActiveSelection();}}else if(currentKeyDown==="ArrowLeft"||currentKeyDown==="ArrowUp"){while(nodeBeforeCursor&&isNotAllowedContent(nodeBeforeCursor)){nodeBeforeCursor=nodeBeforeCursor.previousElementSibling;}
if(nodeBeforeCursor){const[anchorNode,anchorOffset]=getDeepestPosition(nodeBeforeCursor,nodeSize(nodeBeforeCursor));this.dependencies.selection.setSelection({anchorNode:anchorNode,anchorOffset:anchorOffset,});return true;}else{this.dependencies.selection.resetActiveSelection();}}}
fixSelectionOnEditableRootGeneric(nodeAfterCursor,nodeBeforeCursor){if(nodeAfterCursor&&isParagraphRelatedElement(nodeAfterCursor)){this.dependencies.selection.setCursorStart(nodeAfterCursor);return true;}else if(nodeBeforeCursor&&isParagraphRelatedElement(nodeBeforeCursor)){this.dependencies.selection.setCursorEnd(nodeBeforeCursor);return true;}}
fixSelectionOnEditableRootCreateP(nodeAfterCursor,nodeBeforeCursor){if(this.isPointerDown&&!this.preventNextPointerdownFix){this.preventNextPointerdownFix=true;const baseContainer=this.dependencies.baseContainer.createBaseContainer();baseContainer.append(this.document.createElement("br"));if(!nodeAfterCursor){this.editable.append(baseContainer);}else if(!nodeBeforeCursor){this.editable.prepend(baseContainer);}else{nodeAfterCursor.before(baseContainer);}
this.dependencies.selection.setCursorStart(baseContainer);this.dependencies.history.addStep();return true;}
return false;}}
return __exports;});;

/* /html_editor/static/src/core/overlay.js */
odoo.define('@html_editor/core/overlay',['@odoo/owl','@web/core/position/position_hook','@web/core/ui/ui_service'],function(require){'use strict';let __exports={};const{Component,onWillDestroy,useEffect,useExternalListener,useRef,xml}=require("@odoo/owl");const{usePosition}=require("@web/core/position/position_hook");const{useActiveElement}=require("@web/core/ui/ui_service");const EditorOverlay=__exports.EditorOverlay=class EditorOverlay extends Component{static template=xml`
        <div t-ref="root" class="overlay" t-att-class="props.className" t-on-pointerdown.stop="() => {}">
            <t t-component="props.Component" t-props="props.props"/>
        </div>`;static props={target:{validate:(el)=>el.nodeType===Node.ELEMENT_NODE,optional:true},initialSelection:{type:Object,optional:true},Component:Function,props:{type:Object,optional:true},editable:{validate:(el)=>el.nodeType===Node.ELEMENT_NODE},bus:Object,getContainer:Function,history:Object,close:Function,isOverlayOpen:Function,positionOptions:{type:Object,optional:true},className:{type:String,optional:true},closeOnPointerdown:{type:Boolean,optional:true},hasAutofocus:{type:Boolean,optional:true},};static defaultProps={className:"",closeOnPointerdown:true,hasAutofocus:false,};setup(){this.lastSelection=this.props.initialSelection;let getTarget,position;if(this.props.target){getTarget=()=>this.props.target;}else{useExternalListener(this.props.bus,"updatePosition",()=>{position.unlock();});const editable=this.props.editable;this.rangeElement=editable.ownerDocument.createElement("range-el");editable.after(this.rangeElement);onWillDestroy(()=>{this.rangeElement.remove();});getTarget=this.getSelectionTarget.bind(this);}
const rootRef=useRef("root");if(this.props.positionOptions?.updatePositionOnResize??true){const resizeObserver=new ResizeObserver(()=>{position.unlock();});useEffect((root)=>{resizeObserver.observe(root);return()=>{resizeObserver.unobserve(root);};},()=>[rootRef.el]);}
if(this.props.closeOnPointerdown){const editableDocument=this.props.editable.ownerDocument;useExternalListener(editableDocument,"pointerdown",this.props.close);if(editableDocument!==document){useExternalListener(document,"pointerdown",this.props.close);}}
if(this.props.hasAutofocus){useActiveElement("root");}
const positionOptions={position:"bottom-start",container:this.props.getContainer,...this.props.positionOptions,onPositioned:(el,solution)=>{this.props.positionOptions?.onPositioned?.(el,solution);this.updateVisibility(el,solution);},};position=usePosition("root",getTarget,positionOptions);}
getSelectionTarget(){const doc=this.props.editable.ownerDocument;const selection=doc.getSelection();if(!selection||!selection.rangeCount||!this.props.isOverlayOpen()){return null;}
const inEditable=this.props.editable.contains(selection.anchorNode);let range;if(inEditable){range=selection.getRangeAt(0);this.lastSelection={range};}else{if(!this.lastSelection){return null;}
range=this.lastSelection.range;}
let rect=range.getBoundingClientRect();if(rect.x===0&&rect.width===0&&rect.height===0){this.props.history.disableObserver();const clonedRange=range.cloneRange();const shadowCaret=doc.createTextNode("|");clonedRange.insertNode(shadowCaret);clonedRange.selectNode(shadowCaret);rect=clonedRange.getBoundingClientRect();shadowCaret.remove();clonedRange.detach();this.props.history.enableObserver();}
this.rangeElement.getBoundingClientRect=()=>rect;return this.rangeElement;}
updateVisibility(overlayElement,solution){if(this.env.isSmall){return;}
const containerRect=this.props.getContainer().getBoundingClientRect();overlayElement.style.visibility=solution.top>containerRect.top?"visible":"hidden";}}
return __exports;});;

/* /html_editor/static/src/core/overlay_plugin.js */
odoo.define('@html_editor/core/overlay_plugin',['@odoo/owl','@html_editor/plugin','@html_editor/core/overlay','@web/core/utils/timing','@html_editor/utils/dom_traversal'],function(require){'use strict';let __exports={};const{markRaw,EventBus}=require("@odoo/owl");const{Plugin}=require("@html_editor/plugin");const{EditorOverlay}=require("@html_editor/core/overlay");const{throttleForAnimation}=require("@web/core/utils/timing");const{findUpTo}=require("@html_editor/utils/dom_traversal");const OverlayPlugin=__exports.OverlayPlugin=class OverlayPlugin extends Plugin{static id="overlay";static dependencies=["history"];static shared=["createOverlay"];resources={step_added_handlers:this.getScrollContainer.bind(this),};overlays=[];setup(){this.iframe=this.document.defaultView.frameElement;this.topDocument=this.iframe?.ownerDocument||this.document;this.container=this.getScrollContainer();this.throttledUpdateContainer=throttleForAnimation(()=>{this.container=this.getScrollContainer();});this.addDomListener(this.topDocument.defaultView,"resize",this.throttledUpdateContainer);}
destroy(){this.throttledUpdateContainer.cancel();super.destroy();for(const overlay of this.overlays){overlay.close();}}
createOverlay(Component,props={},options){const overlay=new Overlay(this,Component,()=>this.container,props,options);this.overlays.push(overlay);return overlay;}
getScrollContainer(){const isScrollable=(element)=>element.scrollHeight>element.clientHeight&&["auto","scroll"].includes(getComputedStyle(element).overflowY);return(findUpTo(this.iframe||this.editable,null,isScrollable)||this.topDocument.documentElement);}}
const Overlay=__exports.Overlay=class Overlay{constructor(plugin,C,getContainer,props,options){this.plugin=plugin;this.C=C;this.editorOverlayProps=props;this.options=options;this.isOpen=false;this._remove=null;this.component=null;this.bus=new EventBus();this.getContainer=getContainer;}
open({target,props}){if(this.isOpen){this.updatePosition();}else{this.isOpen=true;const selection=this.plugin.editable.ownerDocument.getSelection();let initialSelection;if(selection&&selection.type!=="None"){initialSelection={range:selection.getRangeAt(0),};}
this._remove=this.plugin.services.overlay.add(EditorOverlay,markRaw({...this.editorOverlayProps,Component:this.C,editable:this.plugin.editable,props,target,initialSelection,bus:this.bus,getContainer:this.getContainer,close:this.close.bind(this),isOverlayOpen:this.isOverlayOpen.bind(this),history:{enableObserver:this.plugin.dependencies.history.enableObserver,disableObserver:this.plugin.dependencies.history.disableObserver,},}),{...this.options,});}}
close(){this.isOpen=false;if(this._remove){this._remove();}}
isOverlayOpen(){return this.isOpen;}
updatePosition(){this.bus.trigger("updatePosition");}}
return __exports;});;

/* /html_editor/static/src/core/protected_node_plugin.js */
odoo.define('@html_editor/core/protected_node_plugin',['@html_editor/plugin','@html_editor/utils/dom_info','@html_editor/utils/dom_traversal'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{isProtecting,isUnprotecting}=require("@html_editor/utils/dom_info");const{childNodes}=require("@html_editor/utils/dom_traversal");const PROTECTED_SELECTOR=`[data-oe-protected="true"],[data-oe-protected=""]`;const UNPROTECTED_SELECTOR=`[data-oe-protected="false"]`;const ProtectedNodePlugin=__exports.ProtectedNodePlugin=class ProtectedNodePlugin extends Plugin{static id="protectedNode";static shared=["setProtectingNode"];resources={clean_for_save_handlers:({root})=>this.cleanForSave(root),normalize_handlers:this.normalize.bind(this),before_filter_mutation_record_handlers:this.beforeFilteringMutationRecords.bind(this),unsplittable_node_predicates:[isProtecting,isUnprotecting,],savable_mutation_record_predicates:this.isMutationRecordSavable.bind(this),removable_descendants_providers:this.filterDescendantsToRemove.bind(this),};setup(){this.protectedNodes=new WeakSet();}
filterDescendantsToRemove(elem){if(isProtecting(elem)){const descendantsToRemove=[];for(const candidate of elem.querySelectorAll(UNPROTECTED_SELECTOR)){if(candidate.closest(PROTECTED_SELECTOR)===elem){descendantsToRemove.push(...childNodes(candidate));}}
return descendantsToRemove;}}
protectNode(node){if(node.nodeType===Node.ELEMENT_NODE){if(node.matches(UNPROTECTED_SELECTOR)){this.unProtectDescendants(node);}else if(!this.protectedNodes.has(node)){this.protectDescendants(node);}}
this.protectedNodes.add(node);}
unProtectNode(node){if(node.nodeType===Node.ELEMENT_NODE){if(node.matches(PROTECTED_SELECTOR)){this.protectDescendants(node);}else if(this.protectedNodes.has(node)){this.unProtectDescendants(node);}}
this.protectedNodes.delete(node);}
protectDescendants(node){let child=node.firstChild;while(child){this.protectNode(child);child=child.nextSibling;}}
unProtectDescendants(node){let child=node.firstChild;while(child){this.unProtectNode(child);child=child.nextSibling;}}
beforeFilteringMutationRecords(records){for(const record of records){if(record.type==="childList"){if(record.target.nodeType!==Node.ELEMENT_NODE){return;}
if((this.protectedNodes.has(record.target)&&!record.target.matches(UNPROTECTED_SELECTOR))||record.target.matches(PROTECTED_SELECTOR)){for(const addedNode of record.addedNodes){this.protectNode(addedNode);}}else if(!this.protectedNodes.has(record.target)||record.target.matches(UNPROTECTED_SELECTOR)){for(const addedNode of record.addedNodes){this.unProtectNode(addedNode);}}}}}
isMutationRecordSavable(record){if(record.type==="attributes"){if(record.attributeName==="contenteditable"){return(!this.protectedNodes.has(record.target)||record.target.matches(UNPROTECTED_SELECTOR));}}else if(record.target.nodeType===Node.ELEMENT_NODE){return!((this.protectedNodes.has(record.target)&&!record.target.matches(UNPROTECTED_SELECTOR))||record.target.matches(PROTECTED_SELECTOR));}
return!this.protectedNodes.has(record.target);}
forEachProtectingElem(elem,callback){const selector=`[data-oe-protected]`;const protectingNodes=[...elem.querySelectorAll(selector)].reverse();if(elem.matches(selector)){protectingNodes.push(elem);}
for(const protectingNode of protectingNodes){if(protectingNode.dataset.oeProtected==="false"){callback(protectingNode,false);}else{callback(protectingNode,true);}}}
normalize(elem){this.forEachProtectingElem(elem,this.setProtectingNode.bind(this));}
setProtectingNode(elem,protecting){elem.dataset.oeProtected=protecting;if(protecting){elem.setAttribute("contenteditable","false");this.protectDescendants(elem);}else{elem.setAttribute("contenteditable","true");this.unProtectDescendants(elem);}}
cleanForSave(clone){this.forEachProtectingElem(clone,(protectingNode)=>{protectingNode.removeAttribute("contenteditable");});}}
return __exports;});;

/* /html_editor/static/src/core/sanitize_plugin.js */
odoo.define('@html_editor/core/sanitize_plugin',['@html_editor/utils/dom_traversal','@html_editor/plugin'],function(require){'use strict';let __exports={};const{selectElements}=require("@html_editor/utils/dom_traversal");const{Plugin}=require("@html_editor/plugin");const SanitizePlugin=__exports.SanitizePlugin=class SanitizePlugin extends Plugin{static id="sanitize";static shared=["sanitize"];resources={clean_for_save_handlers:this.cleanForSave.bind(this),normalize_handlers:this.normalize.bind(this),};setup(){if(!window.DOMPurify){throw new Error("DOMPurify is not available");}
this.DOMPurify=DOMPurify(this.document.defaultView);}
sanitize(elem){return this.DOMPurify.sanitize(elem,{IN_PLACE:true,ADD_TAGS:["#document-fragment","fake-el"],ADD_ATTR:["contenteditable"],});}
normalize(element){for(const el of selectElements(element,".o-contenteditable-false, .o-contenteditable-true")){el.contentEditable=el.matches(".o-contenteditable-true");}
for(const el of selectElements(element,"[data-oe-role]")){el.setAttribute("role",el.dataset.oeRole);}
for(const el of selectElements(element,"[data-oe-aria-label]")){el.setAttribute("aria-label",el.dataset.oeAriaLabel);}}
cleanForSave({root}){for(const el of selectElements(root,".o-contenteditable-false, .o-contenteditable-true")){el.removeAttribute("contenteditable");}
for(const el of selectElements(root,"[data-oe-role]")){el.removeAttribute("role");}
for(const el of selectElements(root,"[data-oe-aria-label]")){el.removeAttribute("aria-label");}}}
return __exports;});;

/* /html_editor/static/src/core/selection_plugin.js */
odoo.define('@html_editor/core/selection_plugin',['@html_editor/utils/blocks','@html_editor/utils/dom_info','@html_editor/utils/dom_traversal','@web/core/hotkeys/hotkey_service','@html_editor/plugin','@html_editor/utils/position','@html_editor/utils/selection','@web/core/utils/scrolling'],function(require){'use strict';let __exports={};const{closestBlock}=require("@html_editor/utils/blocks");const{getDeepestPosition,isMediaElement,isProtected,isProtecting,isUnprotecting,previousLeaf,}=require("@html_editor/utils/dom_info");const{childNodes,closestElement,descendants,firstLeaf,lastLeaf,}=require("@html_editor/utils/dom_traversal");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const{Plugin}=require("@html_editor/plugin");const{DIRECTIONS,endPos,leftPos,nodeSize,rightPos}=require("@html_editor/utils/position");const{getAdjacentCharacter,normalizeCursorPosition,normalizeDeepCursorPosition,normalizeFakeBR,}=require("@html_editor/utils/selection");const{isElement}=require("@html_editor/utils/dom_info");const{closestScrollableY}=require("@web/core/utils/scrolling");const VOID_ELEMENT_NAMES=["AREA","BASE","BR","COL","EMBED","HR","IMG","INPUT","KEYGEN","LINK","META","PARAM","SOURCE","TRACK","WBR",];__exports.isArtificialVoidElement=isArtificialVoidElement;function isArtificialVoidElement(node){return isMediaElement(node)||node.nodeName==="HR";}
__exports.isNotAllowedContent=isNotAllowedContent;function isNotAllowedContent(node){return isArtificialVoidElement(node)||VOID_ELEMENT_NAMES.includes(node.nodeName);}
function getUnselectedEdgeNodes(selection){const startEdgeNodes=(node,offset)=>node===selection.commonAncestorContainer||offset<nodeSize(node)?[]:[node,...startEdgeNodes(...rightPos(node))];const endEdgeNodes=(node,offset)=>node===selection.commonAncestorContainer||offset>0?[]:[node,...endEdgeNodes(...leftPos(node))];return new Set([...startEdgeNodes(selection.startContainer,selection.startOffset),...endEdgeNodes(selection.endContainer,selection.endOffset),]);}
function scrollToSelection(selection){const range=selection.getRangeAt(0);const container=closestScrollableY(range.startContainer.parentElement);if(!container){return;}
let rect=range.getBoundingClientRect();if(rect.width===0&&rect.height===0&&selection.isCollapsed&&selection.anchorNode.hasChildNodes()){const target=selection.anchorNode.childNodes[selection.anchorOffset]||selection.anchorNode.childNodes[selection.anchorOffset-1];if(isElement(target)){rect=target.getBoundingClientRect();}}
const containerRect=container.getBoundingClientRect();const offsetTop=rect.top-containerRect.top+container.scrollTop;const offsetBottom=rect.bottom-containerRect.top+container.scrollTop;if(rect.height>=containerRect.height){return;}
if(rect.top<containerRect.top){container.scrollTo({top:offsetTop,behavior:"instant"});}else if(rect.bottom>containerRect.bottom){container.scrollTo({top:offsetBottom-container.clientHeight,behavior:"instant"});}}
const SelectionPlugin=__exports.SelectionPlugin=class SelectionPlugin extends Plugin{static id="selection";static shared=["getSelectionData","getEditableSelection","setSelection","setCursorStart","setCursorEnd","extractContent","preserveSelection","resetSelection","getSelectedNodes","getTraversedNodes","getTraversedBlocks","modifySelection","rectifySelection","resetActiveSelection","focusEditable","isSelectionInEditable",];resources={user_commands:{id:"selectAll",run:this.selectAll.bind(this)},shortcuts:[{hotkey:"control+a",commandId:"selectAll"}],};setup(){this.resetSelection();this.addDomListener(this.document,"selectionchange",()=>{this.updateActiveSelection();const selection=this.document.getSelection();if(this.isSelectionInEditable(selection)){scrollToSelection(selection);}});this.addDomListener(this.editable,"mousedown",(ev)=>{if(ev.detail>=3){this.correctTripleClick=true;}
this.handleEmptySelection();});this.addDomListener(this.editable,"keydown",(ev)=>{const handled=["arrowright","shift+arrowright","arrowleft","shift+arrowleft","shift+arrowup","shift+arrowdown",];if(handled.includes(getActiveHotkey(ev))){this.onKeyDownArrows(ev);}});}
selectAll(){const selection=this.getEditableSelection();const containerSelector="#wrap > *, .oe_structure > *, [contenteditable]";const container=selection&&closestElement(selection.anchorNode,containerSelector);const[anchorNode,anchorOffset]=getDeepestPosition(container,0);const[focusNode,focusOffset]=getDeepestPosition(container,nodeSize(container));this.setSelection({anchorNode,anchorOffset,focusNode,focusOffset});}
resetSelection(){this.activeSelection=this.makeActiveSelection();}
handleEmptySelection(){const selection=this.getEditableSelection();if(selection.anchorNode&&!selection.isCollapsed){const[deepAnchorNode,deepAnchorOffset]=getDeepestPosition(selection.anchorNode,selection.anchorOffset);const[deepFocusNode,deepFocusOffset]=getDeepestPosition(selection.focusNode,selection.focusOffset);const range=new Range();range.setStart(deepAnchorNode,deepAnchorOffset);range.setEnd(deepFocusNode,deepFocusOffset);const rangeContentChildNodes=range.cloneContents().childNodes;if(rangeContentChildNodes.length===1&&rangeContentChildNodes[0].nodeName==="BR"){this.setSelection({anchorNode:deepAnchorNode,anchorOffset:0,focusNode:deepAnchorNode,focusOffset:0,});}}}
updateActiveSelection(){this.previousActiveSelection=this.activeSelection;const selectionData=this.getSelectionData();if(selectionData.documentSelectionIsInEditable){if(this.correctTripleClick){this.correctTripleClick=false;let{anchorNode,anchorOffset,focusNode,focusOffset}=this.activeSelection;if(focusOffset===0&&anchorNode!==focusNode){[focusNode,focusOffset]=endPos(previousLeaf(focusNode));return this.setSelection({anchorNode,anchorOffset,focusNode,focusOffset});}}
if(this.fixSelectionOnEditableRoot(this.activeSelection)){return;}}
this.dispatchTo("selectionchange_handlers",selectionData);}
makeActiveSelection(selection){let range;let activeSelection;if(!selection||!selection.rangeCount){activeSelection={anchorNode:this.editable,anchorOffset:0,focusNode:this.editable,focusOffset:0,startContainer:this.editable,startOffset:0,endContainer:this.editable,endOffset:0,commonAncestorContainer:this.editable,isCollapsed:true,direction:DIRECTIONS.RIGHT,textContent:()=>"",intersectsNode:()=>false,};}else{range=selection.getRangeAt(0);let{anchorNode,anchorOffset,focusNode,focusOffset}=selection;let direction=anchorNode===range.startContainer?DIRECTIONS.RIGHT:DIRECTIONS.LEFT;if(anchorNode===focusNode&&focusOffset<anchorOffset){direction=!direction;}
if(this.activeSelection&&(isProtecting(anchorNode)||(isProtected(anchorNode)&&!isUnprotecting(anchorNode)))){return this.activeSelection;}
[anchorNode,anchorOffset]=normalizeCursorPosition(anchorNode,anchorOffset,direction?"left":"right");[focusNode,focusOffset]=normalizeCursorPosition(focusNode,focusOffset,direction?"right":"left");const[startContainer,startOffset,endContainer,endOffset]=direction===DIRECTIONS.RIGHT?[anchorNode,anchorOffset,focusNode,focusOffset]:[focusNode,focusOffset,anchorNode,anchorOffset];range=this.document.createRange();range.setStart(startContainer,startOffset);range.setEnd(endContainer,endOffset);activeSelection={anchorNode,anchorOffset,focusNode,focusOffset,startContainer,startOffset,endContainer,endOffset,commonAncestorContainer:range.commonAncestorContainer,isCollapsed:range.collapsed,direction,textContent:()=>(range.collapsed?"":selection.toString()),intersectsNode:(node)=>range.intersectsNode(node),};}
Object.freeze(activeSelection);return activeSelection;}
extractContent(selection){const range=new Range();range.setStart(selection.startContainer,selection.startOffset);range.setEnd(selection.endContainer,selection.endOffset);this.setSelection({anchorNode:selection.startContainer,anchorOffset:selection.startOffset,});return range.extractContents();}
createEditorSelection(anchorNode,anchorOffset,focusNode,focusOffset,direction){let startContainer,startOffset,endContainer,endOffset;const range=new Range();if(direction){[startContainer,startOffset]=[anchorNode,anchorOffset];[endContainer,endOffset]=[focusNode,focusOffset];}else{[startContainer,startOffset]=[focusNode,focusOffset];[endContainer,endOffset]=[anchorNode,anchorOffset];}
range.setStart(startContainer,startOffset);range.setEnd(endContainer,endOffset);return Object.freeze({...this.activeSelection,anchorNode,anchorOffset,focusNode,focusOffset,startContainer,startOffset,endContainer,endOffset,commonAncestorContainer:range.commonAncestorContainer,cloneContents:()=>range.cloneContents(),});}
getEditableSelection(){return this.getSelectionData().editableSelection;}
getSelectionData(){const selection=this.document.getSelection();const documentSelectionIsInEditable=selection&&this.isSelectionInEditable(selection);const documentSelection=selection?.anchorNode&&selection?.focusNode?Object.freeze({anchorNode:selection.anchorNode,anchorOffset:selection.anchorOffset,focusNode:selection.focusNode,focusOffset:selection.focusOffset,commonAncestorContainer:selection.rangeCount?selection.getRangeAt(0).commonAncestorContainer:null,}):null;if(documentSelectionIsInEditable){this.activeSelection=this.makeActiveSelection(selection);}else if(!this.activeSelection.anchorNode.isConnected){this.activeSelection=this.makeActiveSelection();}
let{anchorNode,anchorOffset,focusNode,focusOffset,isCollapsed,direction}=this.activeSelection;const editableSelection=this.createEditorSelection(anchorNode,anchorOffset,focusNode,focusOffset,direction);const selectionData={documentSelection:documentSelection,editableSelection:editableSelection,documentSelectionIsInEditable:documentSelectionIsInEditable,};Object.defineProperty(selectionData,"deepEditableSelection",{get:function(){[anchorNode,anchorOffset]=getDeepestPosition(anchorNode,anchorOffset);[focusNode,focusOffset]=isCollapsed?[anchorNode,anchorOffset]:getDeepestPosition(focusNode,focusOffset);return this.createEditorSelection(anchorNode,anchorOffset,focusNode,focusOffset,direction);}.bind(this),});Object.defineProperty(selectionData,"documentSelectionIsProtecting",{get:function(){return documentSelection?.anchorNode?isProtecting(documentSelection.anchorNode):false;}.bind(this),});Object.defineProperty(selectionData,"documentSelectionIsProtected",{get:function(){return documentSelection?.anchorNode?isProtected(documentSelection.anchorNode):false;}.bind(this),});return Object.freeze(selectionData);}
setSelection({anchorNode,anchorOffset,focusNode=anchorNode,focusOffset=anchorOffset},{normalize=true}={}){if(!this.isSelectionInEditable({anchorNode,focusNode})){throw new Error("Selection is not in editor");}
const isCollapsed=anchorNode===focusNode&&anchorOffset===focusOffset;[focusNode,focusOffset]=normalizeCursorPosition(focusNode,focusOffset,"right");[anchorNode,anchorOffset]=isCollapsed?[focusNode,focusOffset]:normalizeCursorPosition(anchorNode,anchorOffset,"left");if(normalize){[anchorNode,anchorOffset]=normalizeDeepCursorPosition(anchorNode,anchorOffset);[focusNode,focusOffset]=isCollapsed?[anchorNode,anchorOffset]:normalizeDeepCursorPosition(focusNode,focusOffset);}
[anchorNode,anchorOffset]=normalizeFakeBR(anchorNode,anchorOffset);[focusNode,focusOffset]=normalizeFakeBR(focusNode,focusOffset);const selection=this.document.getSelection();const documentSelectionIsInEditable=selection&&this.isSelectionInEditable(selection);if(selection){if(documentSelectionIsInEditable||selection.anchorNode===null){selection.setBaseAndExtent(anchorNode,anchorOffset,focusNode,focusOffset);this.activeSelection=this.makeActiveSelection(selection,true);}else{let range=new Range();range.setStart(anchorNode,anchorOffset);range.setEnd(focusNode,focusOffset);if(anchorNode!==focusNode||anchorOffset!==focusOffset){if(range.collapsed){range=new Range();range.setEnd(anchorNode,anchorOffset);range.setStart(focusNode,focusOffset);}}
this.activeSelection=this.makeActiveSelection({anchorNode,anchorOffset,focusNode,focusOffset,getRangeAt:()=>range,rangeCount:1,});}}
return this.activeSelection;}
setCursorStart(node){return this.setSelection({anchorNode:node,anchorOffset:0});}
setCursorEnd(node){return this.setSelection({anchorNode:node,anchorOffset:nodeSize(node)});}
preserveSelection(){const hadSelection=this.document.getSelection()&&this.document.getSelection().anchorNode!==null;const selectionData=this.getSelectionData();const selection=selectionData.editableSelection;const anchor={node:selection.anchorNode,offset:selection.anchorOffset};const focus={node:selection.focusNode,offset:selection.focusOffset};return{restore:()=>{if(!hadSelection){return;}
this.setSelection({anchorNode:anchor.node,anchorOffset:anchor.offset,focusNode:focus.node,focusOffset:focus.offset,},{normalize:false});},update(callback){callback(anchor);callback(focus);return this;},remapNode(node,newNode){return this.update((cursor)=>{if(cursor.node===node){cursor.node=newNode;}});},setOffset(node,newOffset){return this.update((cursor)=>{if(cursor.node===node){cursor.offset=newOffset;}});},shiftOffset(node,shiftOffset){return this.update((cursor)=>{if(cursor.node===node){cursor.offset+=shiftOffset;}});},};}
getSelectedNodes(){const selection=this.getSelectionData().editableSelection;const range=new Range();range.setStart(selection.startContainer,selection.startOffset);range.setEnd(selection.endContainer,selection.endOffset);const isNodeFullySelected=(node)=>this.getResource("fully_selected_node_predicates").some((cb)=>cb(node,selection))||(range.isPointInRange(node,0)&&range.isPointInRange(node,nodeSize(node)));return this.getTraversedNodes().filter(isNodeFullySelected);}
getTraversedNodes(){const selection=this.getSelectionData().deepEditableSelection;const{commonAncestorContainer:root}=selection;let traversedNodes=[root,...descendants(root).filter((node)=>selection.intersectsNode(node)),];const modifiers=[(nodes)=>(nodes[0]===this.editable?nodes.slice(1):nodes),(nodes)=>{const edgeNodes=getUnselectedEdgeNodes(selection);return nodes.filter((node)=>!edgeNodes.has(node));},...this.getResource("traversed_nodes_processors"),];for(const modifier of modifiers){traversedNodes=modifier(traversedNodes);}
return traversedNodes;}
getTraversedBlocks(){return new Set(this.getTraversedNodes().map(closestBlock).filter(Boolean));}
resetActiveSelection(){const selection=this.document.getSelection();selection.setBaseAndExtent(this.previousActiveSelection.anchorNode,this.previousActiveSelection.anchorOffset,this.previousActiveSelection.focusNode,this.previousActiveSelection.focusOffset);}
fixSelectionOnEditableRoot(selection){if(!selection.isCollapsed||selection.anchorNode!==this.editable){return false;}
this.dispatchTo("fix_selection_on_editable_root_handlers",selection);}
rectifySelection(selection){if(!this.isSelectionInEditable(selection)){return null;}
const anchorNode=selection.anchorNode;let anchorOffset=selection.anchorOffset;const focusNode=selection.focusNode;let focusOffset=selection.focusOffset;const anchorSize=nodeSize(anchorNode);const focusSize=nodeSize(focusNode);if(anchorSize<anchorOffset){anchorOffset=anchorSize;}
if(focusSize<focusOffset){focusOffset=focusSize;}
const anchorTarget=childNodes(anchorNode).at(anchorOffset);const focusTarget=childNodes(focusNode).at(focusOffset);const protectionCheck=(node)=>isProtecting(node)||(isProtected(node)&&!isUnprotecting(node));if(focusTarget!==anchorTarget&&focusTarget.previousSibling===anchorTarget&&protectionCheck(anchorTarget)){return;}
if(protectionCheck(anchorNode)||protectionCheck(focusNode)){return;}
return this.setSelection({anchorNode,anchorOffset,focusNode,focusOffset,});}
modifySelection(alter,direction,granularity){const selectionData=this.getSelectionData();if(!selectionData.documentSelectionIsInEditable){return selectionData.editableSelection;}
const selection=this.document.getSelection();if(!selection){return selectionData.editableSelection;}
selection.modify(alter,direction,granularity);if(!this.isSelectionInEditable(selection)){return this.setSelection(selectionData.editableSelection);}
this.activeSelection=this.makeActiveSelection(selection);return this.activeSelection;}
onKeyDownArrows(ev){const selection=this.document.getSelection();if(!selection||!this.isSelectionInEditable(selection)){return;}
const mode=ev.shiftKey?"extend":"move";if(["ArrowLeft","ArrowRight"].includes(ev.key)){const screenDirection=ev.key==="ArrowLeft"?"left":"right";const isRtl=closestElement(selection.focusNode,"[dir]")?.dir==="rtl";const domDirection=(screenDirection==="left")^isRtl?"previous":"next";const shouldSkipCallbacks=this.getResource("intangible_char_for_keyboard_navigation_predicates");let adjacentCharacter=getAdjacentCharacter(selection,domDirection,this.editable);let shouldSkip=shouldSkipCallbacks.some((cb)=>cb(ev,adjacentCharacter));while(shouldSkip){const{focusNode:nodeBefore,focusOffset:offsetBefore}=selection;selection.modify(mode,screenDirection,"character");const hasSelectionChanged=nodeBefore!==selection.focusNode||offsetBefore!==selection.focusOffset;const lastSkippedChar=adjacentCharacter;adjacentCharacter=getAdjacentCharacter(selection,domDirection,this.editable);shouldSkip=hasSelectionChanged&&shouldSkipCallbacks.some((cb)=>cb(ev,adjacentCharacter,lastSkippedChar));}}
const{focusNode,focusOffset}=selection;if(mode==="extend"){const selectingBackward=["ArrowLeft","ArrowUp"].includes(ev.key);const currentBlock=closestBlock(focusNode);const isAtBoundary=selectingBackward?firstLeaf(currentBlock)===focusNode&&focusOffset===0:lastLeaf(currentBlock)===focusNode&&focusOffset===nodeSize(focusNode);const adjacentBlock=selectingBackward?currentBlock.previousElementSibling:currentBlock.nextElementSibling;const targetBlock=selectingBackward?adjacentBlock?.previousElementSibling:adjacentBlock?.nextElementSibling;if(!adjacentBlock?.isContentEditable&&targetBlock&&isAtBoundary){const leafNode=selectingBackward?lastLeaf(targetBlock):firstLeaf(targetBlock);const offset=selectingBackward?nodeSize(leafNode):0;selection.extend(leafNode,offset);ev.preventDefault();}}}
isSelectionInEditable({anchorNode,focusNode}={}){return(!!anchorNode&&!!focusNode&&this.editable.contains(anchorNode)&&(focusNode===anchorNode||this.editable.contains(focusNode)));}
focusEditable(){const{editableSelection,documentSelectionIsInEditable}=this.getSelectionData();if(documentSelectionIsInEditable){return;}
this.editable.focus({preventScroll:true});const{anchorNode,anchorOffset,focusNode,focusOffset}=editableSelection;const selection=this.document.getSelection();if(selection){selection.setBaseAndExtent(anchorNode,anchorOffset,focusNode,focusOffset);}}}
return __exports;});;

/* /html_editor/static/src/core/shortcut_plugin.js */
odoo.define('@html_editor/core/shortcut_plugin',['@html_editor/plugin'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const ShortCutPlugin=__exports.ShortCutPlugin=class ShortCutPlugin extends Plugin{static id="shortcut";static dependencies=["userCommand"];setup(){const hotkeyService=this.services.hotkey;if(!hotkeyService){throw new Error("ShorcutPlugin needs hotkey service to properly work");}
if(document!==this.document){hotkeyService.registerIframe({contentWindow:this.document.defaultView});}
for(const shortcut of this.getResource("shortcuts")){const command=this.dependencies.userCommand.getCommand(shortcut.commandId);this.addShortcut(shortcut.hotkey,()=>{command.run(shortcut.commandParams);});}}
addShortcut(hotkey,action){this.services.hotkey.add(hotkey,action,{area:()=>this.editable,bypassEditableProtection:true,allowRepeat:true,});}}
return __exports;});;

/* /html_editor/static/src/core/split_plugin.js */
odoo.define('@html_editor/core/split_plugin',['@html_editor/plugin','@html_editor/utils/blocks','@html_editor/utils/dom','@html_editor/utils/dom_info','@html_editor/utils/dom_state','@html_editor/utils/dom_traversal','@html_editor/utils/position'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{isBlock}=require("@html_editor/utils/blocks");const{fillEmpty,splitTextNode}=require("@html_editor/utils/dom");const{isContentEditable,isContentEditableAncestor,isTextNode,isVisible,}=require("@html_editor/utils/dom_info");const{prepareUpdate}=require("@html_editor/utils/dom_state");const{childNodes,closestElement,firstLeaf,lastLeaf}=require("@html_editor/utils/dom_traversal");const{DIRECTIONS,childNodeIndex,nodeSize}=require("@html_editor/utils/position");const{isProtected,isProtecting}=require("@html_editor/utils/dom_info");const SplitPlugin=__exports.SplitPlugin=class SplitPlugin extends Plugin{static dependencies=["baseContainer","selection","history","input","delete","lineBreak"];static id="split";static shared=["splitBlock","splitBlockNode","splitElementBlock","splitElement","splitAroundUntil","splitSelection","isUnsplittable",];resources={beforeinput_handlers:this.onBeforeInput.bind(this),unsplittable_node_predicates:[(node)=>this.getResource("unremovable_node_predicates").some((predicate)=>predicate(node)),(node)=>node.classList?.contains("oe_unbreakable"),(node)=>{const isExplicitlyNotContentEditable=(node)=>{return(!isContentEditable(node)&&(node.isConnected||closestElement(node,"[contenteditable]")));};return(isExplicitlyNotContentEditable(node)||(node.parentElement&&isContentEditableAncestor(node)&&isExplicitlyNotContentEditable(node.parentElement)));},(node)=>node.nodeName==="SECTION",],};splitBlock(){this.dispatchTo("before_split_block_handlers");let selection=this.dependencies.selection.getEditableSelection();if(!selection.isCollapsed){this.dependencies.delete.deleteSelection();selection=this.dependencies.selection.getEditableSelection();}
return this.splitBlockNode({targetNode:selection.anchorNode,targetOffset:selection.anchorOffset,});}
splitBlockNode({targetNode,targetOffset}){if(targetNode.nodeType===Node.TEXT_NODE){targetOffset=splitTextNode(targetNode,targetOffset);targetNode=targetNode.parentElement;}
const blockToSplit=closestElement(targetNode,isBlock);const params={targetNode,targetOffset,blockToSplit};if(this.delegateTo("split_element_block_overrides",params)){return[undefined,undefined];}
return this.splitElementBlock(params);}
splitElementBlock({targetNode,targetOffset,blockToSplit}){if(this.isUnsplittable(blockToSplit)){this.dependencies.lineBreak.insertLineBreakElement({targetNode,targetOffset});return[undefined,undefined];}
const restore=prepareUpdate(targetNode,targetOffset);const[beforeElement,afterElement]=this.splitElementUntil(targetNode,targetOffset,blockToSplit.parentElement);restore();const removeEmptyAndFill=(node)=>{if(isProtecting(node)||isProtected(node)){return;}else if(!isBlock(node)&&!isVisible(node)){const parent=node.parentElement;node.remove();removeEmptyAndFill(parent);}else{fillEmpty(node);}};removeEmptyAndFill(lastLeaf(beforeElement));removeEmptyAndFill(firstLeaf(afterElement));this.dependencies.selection.setCursorStart(afterElement);return[beforeElement,afterElement];}
isUnsplittable(node){return this.getResource("unsplittable_node_predicates").some((p)=>p(node));}
splitElement(element,offset){this.dispatchTo("clean_handlers",element);const before=element.cloneNode();const after=(element.cloneNode());element.before(before);element.after(after);let index=0;for(const child of childNodes(element)){index<offset?before.appendChild(child):after.appendChild(child);index++;}
element.remove();return[before,after];}
splitElementUntil(element,offset,limitAncestor){if(element===limitAncestor){return[element,element];}
let[before,after]=this.splitElement(element,offset);if(after.parentElement!==limitAncestor){const afterIndex=childNodeIndex(after);[before,after]=this.splitElementUntil(after.parentElement,afterIndex,limitAncestor);}
return[before,after];}
splitAroundUntil(elements,limitAncestor){elements=Array.isArray(elements)?elements:[elements];const firstNode=elements[0];const lastNode=elements[elements.length-1];if([firstNode,lastNode].includes(limitAncestor)){return limitAncestor;}
let before=firstNode.previousSibling;let after=lastNode.nextSibling;let beforeSplit,afterSplit;if(!before&&!after&&elements[0]!==limitAncestor){return this.splitAroundUntil(elements[0].parentElement,limitAncestor);}
while(after&&after.parentElement!==limitAncestor){afterSplit=this.splitElement(after.parentElement,childNodeIndex(after))[0];after=afterSplit.nextSibling;}
if(after){afterSplit=this.splitElement(limitAncestor,childNodeIndex(after))[0];limitAncestor=afterSplit;}
while(before&&before.parentElement!==limitAncestor){beforeSplit=this.splitElement(before.parentElement,childNodeIndex(before)+1)[1];before=beforeSplit.previousSibling;}
if(before){beforeSplit=this.splitElement(limitAncestor,childNodeIndex(before)+1)[1];}
return beforeSplit||afterSplit||limitAncestor;}
splitSelection(){let{startContainer,startOffset,endContainer,endOffset,direction}=this.dependencies.selection.getEditableSelection();const isInSingleContainer=startContainer===endContainer;if(isTextNode(endContainer)&&endOffset>0&&endOffset<nodeSize(endContainer)){const endParent=endContainer.parentNode;const splitOffset=splitTextNode(endContainer,endOffset);endContainer=endParent.childNodes[splitOffset-1]||endParent.firstChild;if(isInSingleContainer){startContainer=endContainer;}
endOffset=endContainer.textContent.length;}
if(isTextNode(startContainer)&&startOffset>0&&startOffset<nodeSize(startContainer)){splitTextNode(startContainer,startOffset);startOffset=0;if(isInSingleContainer){endOffset=startContainer.textContent.length;}}
const selection=direction===DIRECTIONS.RIGHT?{anchorNode:startContainer,anchorOffset:startOffset,focusNode:endContainer,focusOffset:endOffset,}:{anchorNode:endContainer,anchorOffset:endOffset,focusNode:startContainer,focusOffset:startOffset,};return this.dependencies.selection.setSelection(selection,{normalize:false});}
onBeforeInput(e){if(e.inputType==="insertParagraph"){e.preventDefault();this.splitBlock();this.dependencies.history.addStep();}}}
return __exports;});;

/* /html_editor/static/src/core/user_command_plugin.js */
odoo.define('@html_editor/core/user_command_plugin',['@html_editor/plugin'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const UserCommandPlugin=__exports.UserCommandPlugin=class UserCommandPlugin extends Plugin{static id="userCommand";static shared=["getCommand"];setup(){this.commands={};for(const command of this.getResource("user_commands")){if(command.id in this.commands){throw new Error(`Duplicate user command id: ${command.id}`);}
this.commands[command.id]=command;}
Object.freeze(this.commands);}
getCommand(commandId){const command=this.commands[commandId];if(!command){throw new Error(`Unknown user command id: ${commandId}`);}
return command;}}
return __exports;});;

/* /html_editor/static/src/editor.js */
odoo.define('@html_editor/editor',['@html_editor/plugin_sets','@html_editor/utils/base_container','@html_editor/utils/dom','@html_editor/utils/dom_info','@html_editor/utils/resource','@html_editor/utils/sanitize'],function(require){'use strict';let __exports={};const{MAIN_PLUGINS}=require("@html_editor/plugin_sets");const{createBaseContainer}=require("@html_editor/utils/base_container");const{fillShrunkPhrasingParent,removeClass}=require("@html_editor/utils/dom");const{isEmpty}=require("@html_editor/utils/dom_info");const{resourceSequenceSymbol,withSequence}=require("@html_editor/utils/resource");const{fixInvalidHTML,initElementForEdition}=require("@html_editor/utils/sanitize");function sortPlugins(plugins){const initialPlugins=new Set(plugins);const inResult=new Set();const result=[];let P;function findPlugin(){for(const P of initialPlugins){if(P.dependencies.every((dep)=>inResult.has(dep))){initialPlugins.delete(P);return P;}}}
while((P=findPlugin())){inResult.add(P.id);result.push(P);}
if(initialPlugins.size){const messages=[];for(const P of initialPlugins){messages.push(`"${P.id}" is missing (${P.dependencies
                    .filter((d) => !inResult.has(d))
                    .join(", ")})`);}
throw new Error(`Missing dependencies:  ${messages.join(", ")}`);}
return result;}
const Editor=__exports.Editor=class Editor{constructor(config,services){this.isDestroyed=false;this.config=config;this.services=services;this.resources=null;this.plugins=[];this.editable=null;this.document=null;this.shared={};}
attachTo(editable){if(this.isDestroyed||this.editable){throw new Error("Cannot re-attach an editor");}
this.editable=editable;this.document=editable.ownerDocument;if(this.config.content){editable.innerHTML=fixInvalidHTML(this.config.content);if(isEmpty(editable)){const baseContainer=createBaseContainer(this.config.baseContainer,this.document);fillShrunkPhrasingParent(baseContainer);editable.replaceChildren(baseContainer);}}
this.preparePlugins();editable.setAttribute("contenteditable",true);initElementForEdition(editable,{allowInlineAtRoot:!!this.config.allowInlineAtRoot});editable.classList.add("odoo-editor-editable");if(this.config.classList){editable.classList.add(...this.config.classList);}
if(this.config.height){editable.style.height=this.config.height;}
this.startPlugins();this.config.onEditorReady?.();}
preparePlugins(){const Plugins=sortPlugins(this.config.Plugins||MAIN_PLUGINS);const plugins=new Map();for(const P of Plugins){if(P.id===""){throw new Error(`Missing plugin id (class ${P.name})`);}
if(plugins.has(P.id)){throw new Error(`Duplicate plugin id: ${P.id}`);}
const imports={};for(const dep of P.dependencies){if(plugins.has(dep)){imports[dep]={};for(const h of plugins.get(dep).shared){imports[dep][h]=this.shared[dep][h];}}else{throw new Error(`Missing dependency for plugin ${P.id}: ${dep}`);}}
plugins.set(P.id,P);const plugin=new P(this.document,this.editable,imports,this.config,this.services);this.plugins.push(plugin);const exports={};for(const h of P.shared){if(!(h in plugin)){throw new Error(`Missing helper implementation: ${h} in plugin ${P.id}`);}
exports[h]=plugin[h].bind(plugin);}
this.shared[P.id]=exports;}
const resources=this.createResources();for(const plugin of this.plugins){plugin._resources=resources;}
this.resources=resources;}
startPlugins(){for(const plugin of this.plugins){plugin.setup();}
this.resources["normalize_handlers"].forEach((cb)=>cb(this.editable));this.resources["start_edition_handlers"].forEach((cb)=>cb());}
createResources(){const resources={};function registerResources(obj){for(const key in obj){if(!(key in resources)){resources[key]=[];}
resources[key].push(obj[key]);}}
if(this.config.resources){registerResources(this.config.resources);}
for(const plugin of this.plugins){if(plugin.resources){registerResources(plugin.resources);}}
for(const key in resources){const resource=resources[key].flat().map((r)=>{const isObjectWithSequence=typeof r==="object"&&r!==null&&resourceSequenceSymbol in r;return isObjectWithSequence?r:withSequence(10,r);}).sort((a,b)=>a[resourceSequenceSymbol]-b[resourceSequenceSymbol]).map((r)=>r.object);resources[key]=resource;Object.freeze(resources[key]);}
return Object.freeze(resources);}
getContent(){return this.getElContent().innerHTML;}
getElContent(){const el=this.editable.cloneNode(true);this.resources["clean_for_save_handlers"].forEach((cb)=>cb({root:el}));return el;}
destroy(willBeRemoved){if(this.editable){let plugin;while((plugin=this.plugins.pop())){plugin.destroy();}
this.shared={};if(!willBeRemoved){this.editable.removeAttribute("contenteditable");removeClass(this.editable,"odoo-editor-editable");}
this.editable=null;}
this.isDestroyed=true;}}
return __exports;});;

/* /html_editor/static/src/fields/html_field.js */
odoo.define('@html_editor/fields/html_field',['@html_editor/html_migrations/html_upgrade_manager','@html_editor/html_migrations/html_migrations_utils','@html_editor/others/collaboration/collaboration_odoo_plugin','@html_editor/plugin_sets','@html_editor/others/embedded_components/embedding_sets','@html_editor/utils/html','@html_editor/wysiwyg','@odoo/owl','@web/core/l10n/localization','@web/core/l10n/translation','@web/core/registry','@web/core/utils/concurrency','@web/core/utils/hooks','@web/model/relational_model/utils','@web/views/fields/standard_field_props','@web/views/fields/translation_button','@html_editor/fields/html_viewer','@html_editor/utils/resource','@html_editor/utils/sanitize'],function(require){'use strict';let __exports={};const{HtmlUpgradeManager}=require("@html_editor/html_migrations/html_upgrade_manager");const{stripVersion}=require("@html_editor/html_migrations/html_migrations_utils");const{stripHistoryIds}=require("@html_editor/others/collaboration/collaboration_odoo_plugin");const{COLLABORATION_PLUGINS,DYNAMIC_PLACEHOLDER_PLUGINS,EMBEDDED_COMPONENT_PLUGINS,MAIN_PLUGINS,}=require("@html_editor/plugin_sets");const{MAIN_EMBEDDINGS,READONLY_MAIN_EMBEDDINGS,}=require("@html_editor/others/embedded_components/embedding_sets");const{normalizeHTML}=require("@html_editor/utils/html");const{Wysiwyg}=require("@html_editor/wysiwyg");const{Component,markup,status,useRef,useState}=require("@odoo/owl");const{localization}=require("@web/core/l10n/localization");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{Mutex}=require("@web/core/utils/concurrency");const{useBus,useService}=require("@web/core/utils/hooks");const{useRecordObserver}=require("@web/model/relational_model/utils");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{TranslationButton}=require("@web/views/fields/translation_button");const{HtmlViewer}=require("@html_editor/fields/html_viewer");const{withSequence}=require("@html_editor/utils/resource");const{fixInvalidHTML,instanceofMarkup}=require("@html_editor/utils/sanitize");function computeContainsComplexHTML(value){const domParser=new DOMParser();if(!value){return false;}
const parsedOriginal=domParser.parseFromString(value,"text/html");return!!parsedOriginal.head.innerHTML.trim();}
const HtmlField=__exports.HtmlField=class HtmlField extends Component{static template="html_editor.HtmlField";static props={...standardFieldProps,isCollaborative:{type:Boolean,optional:true},collaborativeTrigger:{type:String,optional:true},dynamicPlaceholder:{type:Boolean,optional:true,default:false},dynamicPlaceholderModelReferenceField:{type:String,optional:true},cssReadonlyAssetId:{type:String,optional:true},sandboxedPreview:{type:Boolean,optional:true},codeview:{type:Boolean,optional:true},editorConfig:{type:Object,optional:true},embeddedComponents:{type:Boolean,optional:true},};static defaultProps={dynamicPlaceholder:false,};static components={Wysiwyg,HtmlViewer,TranslationButton,};setup(){this.htmlUpgradeManager=new HtmlUpgradeManager();this.mutex=new Mutex();this.codeViewRef=useRef("codeView");const{model}=this.props.record;useBus(model.bus,"WILL_SAVE_URGENTLY",()=>this.commitChanges({urgent:true}));useBus(model.bus,"NEED_LOCAL_CHANGES",({detail})=>detail.proms.push(this.commitChanges()));this.busService=this.env.services.bus_service;this.ormService=useService("orm");this.isDirty=false;this.state=useState({key:0,showCodeView:false,containsComplexHTML:computeContainsComplexHTML(this.props.record.data[this.props.name]),});useRecordObserver((record)=>{const newValue=fixInvalidHTML(record.data[this.props.name]);if(!this.isDirty){const value=normalizeHTML(newValue,this.clearElementToCompare.bind(this));if(this.lastValue!==value){this.state.key++;this.state.containsComplexHTML=computeContainsComplexHTML(newValue);this.lastValue=value;}}});useRecordObserver((record)=>{const value=record.data[this.props.dynamicPlaceholderModelReferenceField||"model"];if(this.props.dynamicPlaceholder&&this.editor){this.editor.shared.dynamicPlaceholder?.updateDphDefaultModel(value);}});}
get value(){const value=this.props.record.data[this.props.name];const newVal=this.htmlUpgradeManager.processForUpgrade(fixInvalidHTML(value),{containsComplexHTML:this.state.containsComplexHTML,env:this.env,});if(instanceofMarkup(value)){return markup(newVal);}
return newVal;}
get displayReadonly(){return this.props.readonly||(this.sandboxedPreview&&!this.state.showCodeView);}
get wysiwygKey(){return`${this.props.record.resId}_${this.state.key}`;}
get sandboxedPreview(){return this.props.sandboxedPreview||this.state.containsComplexHTML;}
get isTranslatable(){return this.props.record.fields[this.props.name].translate;}
clearElementToCompare(element){if(this.props.isCollaborative){stripHistoryIds(element);}
stripVersion(element);}
async updateValue(value){this.lastValue=normalizeHTML(value,this.clearElementToCompare.bind(this));this.isDirty=false;await this.props.record.update({[this.props.name]:value}).catch(()=>{this.isDirty=true;});this.props.record.model.bus.trigger("FIELD_IS_DIRTY",this.isDirty);}
async getEditorContent(){await this.editor.shared.media?.savePendingImages();return this.editor.getElContent();}
async _commitChanges({urgent}){if(status(this)==="destroyed"){return;}
if(this.isDirty){if(this.state.showCodeView){await this.updateValue(this.codeViewRef.el.value);return;}
if(urgent){await this.updateValue(this.editor.getContent());}
const el=await this.getEditorContent();const content=el.innerHTML;this.clearElementToCompare(el);const comparisonValue=el.innerHTML;if(!urgent||(urgent&&this.lastValue!==comparisonValue)){await this.updateValue(content);}}}
async commitChanges({urgent}={}){if(urgent){this._commitChanges({urgent});}else{return this.mutex.exec(()=>this._commitChanges({urgent}));}}
onEditorLoad(editor){this.editor=editor;}
onChange(){this.isDirty=true;this.props.record.model.bus.trigger("FIELD_IS_DIRTY",true);}
onBlur(){return this.commitChanges();}
async toggleCodeView(){await this.commitChanges();this.state.showCodeView=!this.state.showCodeView;if(!this.state.showCodeView&&this.editor){this.editor.editable.innerHTML=this.value;this.editor.shared.history.addStep();}}
getConfig(){const config={content:this.value,Plugins:[...MAIN_PLUGINS,...(this.props.isCollaborative?COLLABORATION_PLUGINS:[]),...(this.props.dynamicPlaceholder?DYNAMIC_PLACEHOLDER_PLUGINS:[]),...(this.props.embeddedComponents?EMBEDDED_COMPONENT_PLUGINS:[]),],classList:this.classList,onChange:this.onChange.bind(this),collaboration:this.props.isCollaborative&&{busService:this.busService,ormService:this.ormService,collaborativeTrigger:this.props.collaborativeTrigger,collaborationChannel:{collaborationModelName:this.props.record.resModel,collaborationFieldName:this.props.name,collaborationResId:parseInt(this.props.record.resId),},peerId:this.generateId(),},dropImageAsAttachment:true,dynamicPlaceholder:this.dynamicPlaceholder,dynamicPlaceholderResModel:this.props.record.data[this.props.dynamicPlaceholderModelReferenceField||"model"],direction:localization.direction||"ltr",getRecordInfo:()=>{const{resModel,resId}=this.props.record;return{resModel,resId};},resources:{},...this.props.editorConfig,};if(!("baseContainer"in config)){config.baseContainer="DIV";}
if(this.props.embeddedComponents){config.resources.embedded_components=[...MAIN_EMBEDDINGS];}
const{sanitize_tags,sanitize}=this.props.record.fields[this.props.name];if(!("disableVideo"in config)&&(sanitize_tags||(sanitize_tags===undefined&&sanitize))){config.disableVideo=true;}
if(this.props.codeview){config.resources={user_commands:[{id:"codeview",title:_t("Code view"),icon:"fa-code",run:this.toggleCodeView.bind(this),},],toolbar_groups:withSequence(100,{id:"codeview",}),toolbar_items:{id:"codeview",groupId:"codeview",commandId:"codeview",},};}
return config;}
getReadonlyConfig(){const config={value:this.value,cssAssetId:this.props.cssReadonlyAssetId,hasFullHtml:this.sandboxedPreview,isFixedValue:true,};if(this.props.embeddedComponents){config.embeddedComponents=[...READONLY_MAIN_EMBEDDINGS];}
return config;}
generateId(){return Math.floor(Math.random()*Math.pow(2,52)).toString();}}
const htmlField=__exports.htmlField={component:HtmlField,displayName:_t("Html"),supportedTypes:["html"],extractProps({attrs,options},dynamicInfo){const editorConfig={mediaModalParams:{useMediaLibrary:true,},};if(attrs.placeholder){editorConfig.placeholder=attrs.placeholder;}
if(options.height){editorConfig.height=`${options.height}px`;editorConfig.classList=["overflow-auto"];}
if("disableImage"in options){editorConfig.disableImage=Boolean(options.disableImage);}
if("disableVideo"in options){editorConfig.disableVideo=Boolean(options.disableVideo);}
if("disableFile"in options){editorConfig.disableFile=Boolean(options.disableFile);}
if("baseContainer"in options){editorConfig.baseContainer=options.baseContainer;}
return{editorConfig,isCollaborative:options.collaborative,collaborativeTrigger:options.collaborative_trigger,dynamicPlaceholder:options.dynamic_placeholder,dynamicPlaceholderModelReferenceField:options.dynamic_placeholder_model_reference_field,embeddedComponents:"embedded_components"in options?options.embedded_components:true,sandboxedPreview:Boolean(options.sandboxedPreview),cssReadonlyAssetId:options.cssReadonly,codeview:Boolean(odoo.debug&&options.codeview),};},};registry.category("fields").add("html",htmlField,{force:true});return __exports;});;

/* /html_editor/static/src/fields/html_viewer.js */
odoo.define('@html_editor/fields/html_viewer',['@odoo/owl','@web/core/assets','@web/core/utils/functions','@html_editor/utils/sanitize','@html_editor/html_migrations/html_upgrade_manager','@html_editor/others/embedded_components/core/table_of_content/table_of_content_manager'],function(require){'use strict';let __exports={};const{Component,markup,onMounted,onWillStart,onWillUnmount,onWillUpdateProps,useEffect,useRef,useState,}=require("@odoo/owl");const{getBundle}=require("@web/core/assets");const{memoize}=require("@web/core/utils/functions");const{fixInvalidHTML,instanceofMarkup}=require("@html_editor/utils/sanitize");const{HtmlUpgradeManager}=require("@html_editor/html_migrations/html_upgrade_manager");const{TableOfContentManager}=require("@html_editor/others/embedded_components/core/table_of_content/table_of_content_manager");const HtmlViewer=__exports.HtmlViewer=class HtmlViewer extends Component{static template="html_editor.HtmlViewer";static props={config:{type:Object},};static defaultProps={hasFullHtml:false,};setup(){this.htmlUpgradeManager=new HtmlUpgradeManager();this.iframeRef=useRef("iframe");this.state=useState({iframeVisible:false,value:this.formatValue(this.props.config.value),});this.components=new Set();onWillUpdateProps((newProps)=>{const newValue=this.formatValue(newProps.config.value);if(newValue.toString()!==this.state.value.toString()){this.state.value=this.formatValue(newProps.config.value);if(this.props.config.embeddedComponents){this.destroyComponents();}
if(this.showIframe){this.updateIframeContent(this.state.value);}}});onWillUnmount(()=>{this.destroyComponents();});if(this.showIframe){onMounted(()=>{const onLoadIframe=()=>this.onLoadIframe(this.state.value);this.iframeRef.el.addEventListener("load",onLoadIframe,{once:true});this.iframeRef.el.after(this.iframeRef.el);});}else{this.readonlyElementRef=useRef("readonlyContent");useEffect(()=>{this.processReadonlyContent(this.readonlyElementRef.el);},()=>[this.props.config.value.toString(),this.readonlyElementRef?.el]);}
if(this.props.config.cssAssetId){onWillStart(async()=>{this.cssAsset=await getBundle(this.props.config.cssAssetId);});}
if(this.props.config.embeddedComponents){this.embeddedComponents=memoize((embeddedComponents=[])=>{const result={};for(const embedding of embeddedComponents){result[embedding.name]=embedding;}
return result;});useEffect(()=>{if(this.readonlyElementRef?.el){this.mountComponents();}},()=>[this.props.config.value.toString(),this.readonlyElementRef?.el]);this.tocManager=new TableOfContentManager(this.readonlyElementRef);}}
get showIframe(){return this.props.config.hasFullHtml||this.props.config.cssAssetId;}
formatValue(value){if(this.props.config.isFixedValue){return value;}
const newVal=this.htmlUpgradeManager.processForUpgrade(fixInvalidHTML(value),{env:this.env,});if(instanceofMarkup(value)){return markup(newVal);}
return newVal;}
processReadonlyContent(container){this.retargetLinks(container);this.applyAccessibilityAttributes(container);}
applyAccessibilityAttributes(container){for(const el of container.querySelectorAll("[data-oe-role]")){el.setAttribute("role",el.dataset.oeRole);}
for(const el of container.querySelectorAll("[data-oe-aria-label]")){el.setAttribute("aria-label",el.dataset.oeAriaLabel);}}
retargetLinks(container){for(const link of container.querySelectorAll("a")){this.retargetLink(link);}}
retargetLink(link){link.setAttribute("target","_blank");link.setAttribute("rel","noreferrer");}
updateIframeContent(content){const contentWindow=this.iframeRef.el.contentWindow;const iframeTarget=this.props.config.hasFullHtml?contentWindow.document.documentElement:contentWindow.document.querySelector("#iframe_target");iframeTarget.innerHTML=content;this.processReadonlyContent(iframeTarget);}
onLoadIframe(value){const contentWindow=this.iframeRef.el.contentWindow;if(!this.props.config.hasFullHtml){contentWindow.document.open("text/html","replace").write(`<!DOCTYPE html><html>
                        <head>
                            <meta charset="utf-8"/>
                            <meta http-equiv="X-UA-Compatible" content="IE=edge"/>
                            <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no"/>
                        </head>
                        <body class="o_in_iframe o_readonly" style="overflow: hidden;">
                            <div id="iframe_target"></div>
                        </body>
                    </html>`);}
if(this.cssAsset){for(const cssLib of this.cssAsset.cssLibs){const link=contentWindow.document.createElement("link");link.setAttribute("type","text/css");link.setAttribute("rel","stylesheet");link.setAttribute("href",cssLib);contentWindow.document.head.append(link);}}
this.updateIframeContent(this.state.value);this.state.iframeVisible=true;}
destroyComponent({root,host}){const{getEditableDescendants}=this.getEmbedding(host);const editableDescendants=getEditableDescendants?.(host)||{};root.destroy();this.components.delete(arguments[0]);host.append(...Object.values(editableDescendants));}
destroyComponents(){for(const info of[...this.components]){this.destroyComponent(info);}}
forEachEmbeddedComponentHost(elem,callback){const selector=`[data-embedded]`;const targets=[...elem.querySelectorAll(selector)];if(elem.matches(selector)){targets.unshift(elem);}
for(const host of targets){const embedding=this.getEmbedding(host);if(!embedding){continue;}
callback(host,embedding);}}
getEmbedding(host){return this.embeddedComponents(this.props.config.embeddedComponents)[host.dataset.embedded];}
setupNewComponent({name,env,props}){if(name==="tableOfContent"){Object.assign(props,{manager:this.tocManager,});}}
mountComponent(host,{Component,getEditableDescendants,getProps,name}){const props=getProps?.(host)||{};const env=Object.create(this.env);if(getEditableDescendants){env.getEditableDescendants=getEditableDescendants;}
this.setupNewComponent({name,env,props,});const root=this.__owl__.app.createRoot(Component,{props,env,});const promise=root.mount(host);promise.catch();const fiber=root.node.fiber;const fiberComplete=fiber.complete;fiber.complete=function(){host.replaceChildren();fiberComplete.call(this);};const info={root,host,};this.components.add(info);}
mountComponents(){this.forEachEmbeddedComponentHost(this.readonlyElementRef.el,(host,embedding)=>{this.mountComponent(host,embedding);});}}
return __exports;});;

/* /html_editor/static/src/html_migrations/html_migrations_utils.js */
odoo.define('@html_editor/html_migrations/html_migrations_utils',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");__exports.htmlEditorVersions=htmlEditorVersions;function htmlEditorVersions(){return Object.keys(registry.category("html_editor_upgrade").subRegistries).sort(compareVersions);}
const VERSION_SELECTOR=__exports.VERSION_SELECTOR="[data-oe-version]";__exports.stripVersion=stripVersion;function stripVersion(element){element.querySelectorAll(VERSION_SELECTOR).forEach((el)=>{delete el.dataset.oeVersion;});}
__exports.compareVersions=compareVersions;function compareVersions(version1,version2){version1=version1.split(".").map((v)=>parseInt(v));version2=version2.split(".").map((v)=>parseInt(v));if(version1[0]<version2[0]||(version1[0]===version2[0]&&version1[1]<version2[1])){return-1;}else if(version1[0]===version2[0]&&version1[1]===version2[1]){return 0;}else{return 1;}}
return __exports;});;

/* /html_editor/static/src/html_migrations/html_upgrade_manager.js */
odoo.define('@html_editor/html_migrations/html_upgrade_manager',['@html_editor/html_migrations/html_migrations_utils','@web/core/registry','@html_editor/utils/sanitize'],function(require){'use strict';let __exports={};const{compareVersions,VERSION_SELECTOR,htmlEditorVersions,}=require("@html_editor/html_migrations/html_migrations_utils");const{registry}=require("@web/core/registry");const{fixInvalidHTML}=require("@html_editor/utils/sanitize");const HtmlUpgradeManager=__exports.HtmlUpgradeManager=class HtmlUpgradeManager{constructor(){this.upgradeRegistry=registry.category("html_editor_upgrade");this.parser=new DOMParser();this.originalValue=undefined;this.upgradedValue=undefined;this.element=undefined;this.env={};}
get value(){return this.upgradedValue;}
processForUpgrade(value,{containsComplexHTML,env}={}){this.env=env||{};this.containsComplexHTML=containsComplexHTML;const strValue=value.toString();if(strValue===this.originalValue?.toString()||strValue===this.upgradedValue?.toString()){return this.value;}
this.originalValue=value;this.upgradedValue=value;this.element=this.parser.parseFromString(fixInvalidHTML(value.toString()),"text/html")[this.containsComplexHTML?"documentElement":"body"];const versionNode=this.element.querySelector(VERSION_SELECTOR);const version=versionNode?.dataset.oeVersion||"0.0";const VERSIONS=htmlEditorVersions();const currentVersion=VERSIONS.at(-1);if(!currentVersion||version===currentVersion){return this.value;}
try{const upgradeSequence=VERSIONS.filter((subVersion)=>{return compareVersions(subVersion,version)>0;});this.upgradedValue=this.upgrade(upgradeSequence);}catch{}
return this.value;}
upgrade(upgradeSequence){for(const version of upgradeSequence){const modules=this.upgradeRegistry.category(version);for(const[key,module]of modules.getEntries()){const upgrade=odoo.loader.modules.get(module).upgrade;if(!upgrade){console.error(`An "${key}" upgrade function could not be found at "${module}" or it did not load.`);}
upgrade(this.element,this.env);}}
return this.element[this.containsComplexHTML?"outerHTML":"innerHTML"];}}
return __exports;});;

/* /html_editor/static/src/html_migrations/manifest.js */
odoo.define('@html_editor/html_migrations/manifest',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const html_upgrade=registry.category("html_editor_upgrade");html_upgrade.category("1.1").add("html_editor","@html_editor/html_migrations/migration-1.1");html_upgrade.category("1.2").add("html_editor","@html_editor/html_migrations/migration-1.2");return __exports;});;

/* /html_editor/static/src/html_migrations/migration-1.1.js */
odoo.define('@html_editor/html_migrations/migration-1.1',[],function(require){'use strict';let __exports={};__exports.upgrade=upgrade;function upgrade(container){const excalidrawContainers=container.querySelectorAll("[data-embedded='draw']");for(const excalidrawContainer of excalidrawContainers){const source=JSON.parse(excalidrawContainer.dataset.embeddedProps).source;const newParagraph=document.createElement("P");const anchor=document.createElement("A");newParagraph.append(anchor);anchor.append(document.createTextNode(source));anchor.href=source;excalidrawContainer.replaceWith(newParagraph);}}
return __exports;});;

/* /html_editor/static/src/html_migrations/migration-1.2.js */
odoo.define('@html_editor/html_migrations/migration-1.2',['@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const ARIA_LABELS={".o_editor_banner.alert-danger":_t("Banner Danger"),".o_editor_banner.alert-info":_t("Banner Info"),".o_editor_banner.alert-success":_t("Banner Success"),".o_editor_banner.alert-warning":_t("Banner Warning"),};function getAriaLabel(element){for(const[selector,ariaLabel]of Object.entries(ARIA_LABELS)){if(element.matches(selector)){return ariaLabel;}}}
__exports.upgrade=upgrade;function upgrade(container){const bannerContainers=container.querySelectorAll(".o_editor_banner");for(const bannerContainer of bannerContainers){bannerContainer.classList.remove("o_not_editable");bannerContainer.classList.add("o-contenteditable-false");bannerContainer.dataset.oeRole="status";const icon=bannerContainer.querySelector(".o_editor_banner_icon");if(icon){const ariaLabel=getAriaLabel(bannerContainer);if(ariaLabel){icon.dataset.oeAriaLabel=ariaLabel;}}
const bannerContent=bannerContainer.querySelector(".o_editor_banner_icon ~ div");if(bannerContent){bannerContent.classList.remove("o_editable");bannerContent.classList.add("o_editor_banner_content");bannerContent.classList.add("o-contenteditable-true");}}}
return __exports;});;

/* /html_editor/static/src/local_overlay_container.js */
odoo.define('@html_editor/local_overlay_container',['@odoo/owl','@web/core/main_components_container','@web/core/utils/hooks','@web/core/registry','@web/core/registry_hook'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{MainComponentsContainer}=require("@web/core/main_components_container");const{useForwardRefToParent}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const{useRegistry}=require("@web/core/registry_hook");const LocalOverlayContainer=__exports.LocalOverlayContainer=class LocalOverlayContainer extends MainComponentsContainer{static template="html_editor.LocalOverlayContainer";static props={localOverlay:{type:Function,optional:true},identifier:{type:String,optional:true},};static defaultProps={identifier:"overlay_components",};setup(){const overlayComponents=registry.category(this.props.identifier);overlayComponents.addValidation({Component:{validate:(c)=>c.prototype instanceof Component},props:{type:Object,optional:true},});this.Components=useRegistry(overlayComponents);useForwardRefToParent("localOverlay");}}
return __exports;});;

/* /html_editor/static/src/main/align_plugin.js */
odoo.define('@html_editor/main/align_plugin',['@html_editor/plugin','@html_editor/utils/blocks','@html_editor/utils/dom_info'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{closestBlock}=require("@html_editor/utils/blocks");const{isVisibleTextNode}=require("@html_editor/utils/dom_info");const AlignPlugin=__exports.AlignPlugin=class AlignPlugin extends Plugin{static id="align";static dependencies=["selection"];resources={user_commands:[{id:"alignLeft",run:()=>this.align("left")},{id:"alignRight",run:()=>this.align("right")},{id:"alignCenter",run:()=>this.align("center")},{id:"justify",run:()=>this.align("justify")},],};align(mode){const visitedBlocks=new Set();const traversedNode=this.dependencies.selection.getTraversedNodes();for(const node of traversedNode){if(isVisibleTextNode(node)){const block=closestBlock(node);if(!visitedBlocks.has(block)){let textAlign=getComputedStyle(block).textAlign;textAlign=textAlign==="start"?"left":textAlign;if(textAlign!==mode&&block.isContentEditable){block.style.textAlign=mode;}
visitedBlocks.add(block);}}}}}
return __exports;});;

/* /html_editor/static/src/main/banner_plugin.js */
odoo.define('@html_editor/main/banner_plugin',['@html_editor/plugin','@html_editor/utils/dom','@html_editor/utils/dom_traversal','@html_editor/utils/html','@html_editor/utils/resource','@odoo/owl','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{fillShrunkPhrasingParent}=require("@html_editor/utils/dom");const{closestElement}=require("@html_editor/utils/dom_traversal");const{parseHTML}=require("@html_editor/utils/html");const{withSequence}=require("@html_editor/utils/resource");const{htmlEscape}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");function isAvailable(selection){return!closestElement(selection.anchorNode,".o_editor_banner");}
const BannerPlugin=__exports.BannerPlugin=class BannerPlugin extends Plugin{static id="banner";static dependencies=["baseContainer","history","dom","emoji","selection","sanitize"];resources={user_commands:[{id:"banner_info",title:_t("Banner Info"),description:_t("Insert an info banner"),icon:"fa-info-circle",isAvailable,run:()=>{this.insertBanner(_t("Banner Info"),"💡","info");},},{id:"banner_success",title:_t("Banner Success"),description:_t("Insert a success banner"),icon:"fa-check-circle",isAvailable,run:()=>{this.insertBanner(_t("Banner Success"),"✅","success");},},{id:"banner_warning",title:_t("Banner Warning"),description:_t("Insert a warning banner"),icon:"fa-exclamation-triangle",isAvailable,run:()=>{this.insertBanner(_t("Banner Warning"),"⚠️","warning");},},{id:"banner_danger",title:_t("Banner Danger"),description:_t("Insert a danger banner"),icon:"fa-exclamation-circle",isAvailable,run:()=>{this.insertBanner(_t("Banner Danger"),"❌","danger");},},],powerbox_categories:withSequence(20,{id:"banner",name:_t("Banner")}),powerbox_items:[{commandId:"banner_info",categoryId:"banner",},{commandId:"banner_success",categoryId:"banner",},{commandId:"banner_warning",categoryId:"banner",},{commandId:"banner_danger",categoryId:"banner",},],power_buttons_visibility_predicates:({anchorNode})=>!closestElement(anchorNode,".o_editor_banner"),};setup(){this.addDomListener(this.editable,"click",(e)=>{if(e.target.classList.contains("o_editor_banner_icon")){this.onBannerEmojiChange(e.target);}});}
insertBanner(title,emoji,alertClass){const baseContainer=this.dependencies.baseContainer.createBaseContainer();fillShrunkPhrasingParent(baseContainer);const baseContainerHtml=baseContainer.outerHTML;const bannerElement=parseHTML(this.document,`<div class="o_editor_banner user-select-none o-contenteditable-false lh-1 d-flex align-items-center alert alert-${alertClass} pb-0 pt-3" data-oe-role="status">
                <i class="o_editor_banner_icon mb-3 fst-normal" data-oe-aria-label="${htmlEscape(
                    title
                )}">${emoji}</i>
                <div class="o_editor_banner_content o-contenteditable-true w-100 px-3">
                    ${baseContainerHtml}
                </div>
            </div`).childNodes[0];this.dependencies.dom.insert(bannerElement);if(this.editable.firstChild===bannerElement){const baseContainer=this.dependencies.baseContainer.createBaseContainer();baseContainer.append(this.document.createElement("br"));bannerElement.before(baseContainer);}
const baseContainerName=this.dependencies.baseContainer.getDefaultNodeName();this.dependencies.selection.setCursorStart(bannerElement.querySelector(`.o_editor_banner_content > ${baseContainerName}`));this.dependencies.history.addStep();}
onBannerEmojiChange(iconElement){this.dependencies.emoji.showEmojiPicker({target:iconElement,onSelect:(emoji)=>{iconElement.textContent=emoji;this.dependencies.history.addStep();},});}}
return __exports;});;

/* /html_editor/static/src/main/chatgpt/chatgpt_alternatives_dialog.js */
odoo.define('@html_editor/main/chatgpt/chatgpt_alternatives_dialog',['@web/core/l10n/translation','@odoo/owl','@html_editor/main/chatgpt/chatgpt_dialog'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useState}=require("@odoo/owl");const{ChatGPTDialog}=require("@html_editor/main/chatgpt/chatgpt_dialog");const DEFAULT_ALTERNATIVES_MODES=__exports.DEFAULT_ALTERNATIVES_MODES={correct:_t("Correct"),short:_t("Shorten"),long:_t("Lengthen"),friendly:_t("Friendly"),professional:_t("Professional"),persuasive:_t("Persuasive"),};let messageId=0;let nextBatchId=0;const ChatGPTAlternativesDialog=__exports.ChatGPTAlternativesDialog=class ChatGPTAlternativesDialog extends ChatGPTDialog{static template="html_editor.ChatGPTAlternativesDialog";static props={...super.props,originalText:String,alternativesModes:{type:Object,optional:true},numberOfAlternatives:{type:Number,optional:true},};static defaultProps={...super.defaultProps,alternativesModes:DEFAULT_ALTERNATIVES_MODES,numberOfAlternatives:3,};setup(){super.setup();this.state=useState({...this.state,conversationHistory:[{role:"system",content:"The user wrote the following text:\n"+"<generated_text>"+
this.props.originalText+"</generated_text>\n"+"Your goal is to help the user write alternatives to that text.\n"+"Conditions:\n"+"- You must respect the format (wrapping the alternative between <generated_text> and </generated_text>)\n"+"- You must detect the language of the text given to you and respond in that language\n"+"- Do not write HTML\n"+"- You must suggest one and only one alternative per answer\n"+"- Your answer must be different every time, never repeat yourself\n"+"- You must respect whatever extra conditions the user gives you\n",},],messages:[],alternativesMode:"",messagesInProgress:0,currentBatchId:null,});this._generationIndex=0;this.generateAlternatives();}
switchAlternativesMode(ev){this.state.alternativesMode=ev.currentTarget.getAttribute("data-mode");this.generateAlternatives(1);}
async generateAlternatives(numberOfAlternatives=this.props.numberOfAlternatives){this.state.messagesInProgress=numberOfAlternatives;const batchId=nextBatchId++;this.state.currentBatchId=batchId;let wasError=false;let messageIndex=0;while(!wasError&&messageIndex<numberOfAlternatives&&this.state.currentBatchId===batchId){this._generationIndex+=1;let query=messageIndex?"Write one alternative version of the original text.":"Try again another single version of the original text.";if(this.state.alternativesMode&&!messageIndex){query+=` Make it more ${this.state.alternativesMode} than your last answer.`;}
if(this.state.alternativesMode==="correct"){query="Simply correct the text, without altering its meaning in any way. Preserve whatever language the user wrote their text in.";}
await this.generate(query,(content,isError)=>{if(this.state.currentBatchId===batchId){const alternative=content.replace(/^[\s\S]*<generated_text>/,"").replace(/<\/generated_text>[\s\S]*$/,"");if(isError){wasError=true;}else{this.state.conversationHistory.push({role:"user",content:query,},{role:"assistant",content,});}
this.state.messages.push({author:"assistant",text:alternative,isError,batchId,mode:this.state.alternativesMode,id:messageId++,});}}).catch(()=>{if(this.state.currentBatchId===batchId){wasError=true;this.state.messages=[];}});messageIndex+=1;this.state.messagesInProgress-=1;if(wasError){break;}}
this.state.messagesInProgress=0;}
preventDialogMousedown(ev){ev.preventDefault();}}
return __exports;});;

/* /html_editor/static/src/main/chatgpt/chatgpt_dialog.js */
odoo.define('@html_editor/main/chatgpt/chatgpt_dialog',['@web/core/l10n/translation','@web/core/dialog/dialog','@web/core/network/rpc','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Dialog}=require("@web/core/dialog/dialog");const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{Component,useState,onWillDestroy,status,markup}=require("@odoo/owl");const POSTPROCESS_GENERATED_CONTENT=(content,baseContainer)=>{let lines=content.split("\n");if(baseContainer.toUpperCase()==="P"){lines=lines.filter((line)=>line.trim().length);}
const fragment=document.createDocumentFragment();let parentUl,parentOl;let lineIndex=0;for(const line of lines){if(line.trim().startsWith("- ")){parentUl=parentUl||document.createElement("ul");const li=document.createElement("li");li.innerText=line.trim().slice(2);parentUl.appendChild(li);}else if((parentOl&&line.startsWith(`${parentOl.children.length + 1}. `))||(!parentOl&&line.startsWith("1. ")&&lines[lineIndex+1]?.startsWith("2. "))){parentOl=parentOl||document.createElement("ol");const li=document.createElement("li");li.innerText=line.slice(line.indexOf(".")+2);parentOl.appendChild(li);}else if(line.trim().length===0){const emptyLine=document.createElement("DIV");emptyLine.append(document.createElement("BR"));fragment.appendChild(emptyLine);}else{[parentUl,parentOl].forEach((list)=>list&&fragment.appendChild(list));parentUl=parentOl=undefined;const block=document.createElement(line.startsWith("Title: ")?"h2":baseContainer);block.innerText=line;fragment.appendChild(block);}
lineIndex+=1;}
[parentUl,parentOl].forEach((list)=>list&&fragment.appendChild(list));return fragment;};const ChatGPTDialog=__exports.ChatGPTDialog=class ChatGPTDialog extends Component{static template="";static components={Dialog};static props={insert:{type:Function},close:{type:Function},sanitize:{type:Function},baseContainer:{type:String,optional:true},};static defaultProps={baseContainer:"DIV",};setup(){this.notificationService=useService("notification");this.state=useState({selectedMessageId:null});onWillDestroy(()=>this.pendingRpcPromise?.abort());}
selectMessage(ev){this.state.selectedMessageId=+ev.currentTarget.getAttribute("data-message-id");}
insertMessage(ev){this.selectMessage(ev);this._confirm();}
formatContent(content){const fragment=POSTPROCESS_GENERATED_CONTENT(content,this.props.baseContainer);let result="";for(const child of fragment.children){this.props.sanitize(child,{IN_PLACE:true});result+=child.outerHTML;}
return markup(result);}
generate(prompt,callback){const protectedCallback=(...args)=>{if(status(this)!=="destroyed"){delete this.pendingRpcPromise;return callback(...args);}};this.pendingRpcPromise=rpc("/html_editor/generate_text",{prompt,conversation_history:this.state.conversationHistory,},{shadow:true});return this.pendingRpcPromise.then((content)=>protectedCallback(content)).catch((error)=>protectedCallback(_t(error.data?.message||error.message),true));}
_cancel(){this.props.close();}
_confirm(){try{this.props.close();const text=this.state.messages.find((message)=>message.id===this.state.selectedMessageId)?.text;this.notificationService.add(_t("Your content was successfully generated."),{title:_t("Content generated"),type:"success",});const fragment=POSTPROCESS_GENERATED_CONTENT(text||"",this.props.baseContainer);this.props.sanitize(fragment,{IN_PLACE:true});this.props.insert(fragment);}catch(e){this.props.close();throw e;}}}
return __exports;});;

/* /html_editor/static/src/main/chatgpt/chatgpt_plugin.js */
odoo.define('@html_editor/main/chatgpt/chatgpt_plugin',['@web/core/l10n/translation','@html_editor/plugin','@html_editor/utils/dom_traversal','@html_editor/main/chatgpt/chatgpt_prompt_dialog','@html_editor/main/chatgpt/chatgpt_alternatives_dialog','@html_editor/main/chatgpt/chatgpt_translate_dialog','@html_editor/main/chatgpt/language_selector','@html_editor/utils/resource','@web/core/user','@html_editor/utils/dom_info'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Plugin}=require("@html_editor/plugin");const{closestElement}=require("@html_editor/utils/dom_traversal");const{ChatGPTPromptDialog}=require("@html_editor/main/chatgpt/chatgpt_prompt_dialog");const{ChatGPTAlternativesDialog}=require("@html_editor/main/chatgpt/chatgpt_alternatives_dialog");const{ChatGPTTranslateDialog}=require("@html_editor/main/chatgpt/chatgpt_translate_dialog");const{LanguageSelector}=require("@html_editor/main/chatgpt/language_selector");const{withSequence}=require("@html_editor/utils/resource");const{user}=require("@web/core/user");const{isContentEditable}=require("@html_editor/utils/dom_info");const ChatGPTPlugin=__exports.ChatGPTPlugin=class ChatGPTPlugin extends Plugin{static id="chatgpt";static dependencies=["baseContainer","selection","history","dom","sanitize","dialog","split",];resources={user_commands:[{id:"openChatGPTDialog",title:_t("ChatGPT"),description:_t("Generate or transform content with AI."),icon:"fa-magic",run:this.openDialog.bind(this),},],toolbar_groups:withSequence(50,{id:"ai",}),toolbar_items:[{id:"translate",groupId:"ai",title:_t("Translate with AI"),isAvailable:(selection)=>{return!selection.isCollapsed&&user.userId;},isDisabled:this.isNotReplaceableByAI.bind(this),Component:LanguageSelector,props:{onSelected:(language)=>this.openDialog({language}),isDisabled:(selection)=>{return this.isNotReplaceableByAI(selection);},},},{id:"chatgpt",groupId:"ai",commandId:"openChatGPTDialog",text:"AI",isDisabled:this.isNotReplaceableByAI.bind(this),},],powerbox_categories:withSequence(70,{id:"ai",name:_t("AI Tools")}),powerbox_items:{keywords:[_t("AI")],categoryId:"ai",commandId:"openChatGPTDialog",},};isNotReplaceableByAI(selection=this.dependencies.selection.getEditableSelection()){const isEmpty=!selection.textContent().replace(/\s+/g,"");const cannotReplace=this.dependencies.selection.getTraversedNodes().find((el)=>this.dependencies.split.isUnsplittable(el)||!isContentEditable(el));return cannotReplace||isEmpty;}
openDialog(params={}){const selection=this.dependencies.selection.getEditableSelection();const dialogParams={insert:(content)=>{const insertedNodes=this.dependencies.dom.insert(content);this.dependencies.history.addStep();const start=insertedNodes?.length&&closestElement(insertedNodes[0]);const end=insertedNodes?.length&&closestElement(insertedNodes[insertedNodes.length-1]);if(start&&end){const divContainer=this.editable.parentElement;let[parent,left,top]=[start.offsetParent,start.offsetLeft,start.offsetTop-start.scrollTop,];while(parent&&!parent.contains(divContainer)){left+=parent.offsetLeft;top+=parent.offsetTop-parent.scrollTop;parent=parent.offsetParent;}
let[endParent,endTop]=[end.offsetParent,end.offsetTop-end.scrollTop];while(endParent&&!endParent.contains(divContainer)){endTop+=endParent.offsetTop-endParent.scrollTop;endParent=endParent.offsetParent;}
const div=document.createElement("div");div.classList.add("o-chatgpt-content");const FRAME_PADDING=3;div.style.left=`${left - FRAME_PADDING}px`;div.style.top=`${top - FRAME_PADDING}px`;div.style.width=`${
                        Math.max(start.offsetWidth, end.offsetWidth) + FRAME_PADDING * 2
                    }px`;div.style.height=`${endTop + end.offsetHeight - top + FRAME_PADDING * 2}px`;divContainer.prepend(div);setTimeout(()=>div.remove(),2000);}},...params,};dialogParams.baseContainer=this.dependencies.baseContainer.getDefaultNodeName();const sanitize=this.dependencies.sanitize.sanitize;if(selection.isCollapsed){this.dependencies.dialog.addDialog(ChatGPTPromptDialog,{...dialogParams,sanitize});}else{const originalText=selection.textContent()||"";this.dependencies.dialog.addDialog(params.language?ChatGPTTranslateDialog:ChatGPTAlternativesDialog,{...dialogParams,originalText,sanitize});}
if(this.services.ui.isSmall){Promise.resolve().then(()=>{this.document.getSelection()?.removeAllRanges();});}}}
return __exports;});;

/* /html_editor/static/src/main/chatgpt/chatgpt_prompt_dialog.js */
odoo.define('@html_editor/main/chatgpt/chatgpt_prompt_dialog',['@web/core/browser/browser','@web/core/user','@web/core/utils/hooks','@odoo/owl','@html_editor/main/chatgpt/chatgpt_dialog','@web/core/utils/scrolling'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{user}=require("@web/core/user");const{useAutofocus,useChildRef}=require("@web/core/utils/hooks");const{useState,useEffect,useRef}=require("@odoo/owl");const{ChatGPTDialog}=require("@html_editor/main/chatgpt/chatgpt_dialog");const{scrollTo}=require("@web/core/utils/scrolling");const ChatGPTPromptDialog=__exports.ChatGPTPromptDialog=class ChatGPTPromptDialog extends ChatGPTDialog{static template="html_editor.ChatGPTPromptDialog";static props={...super.props,initialPrompt:{type:String,optional:true},};static defaultProps={...super.defaultProps,initialPrompt:"",};setup(){super.setup();this.assistantAvatarUrl=`${browser.location.origin}/web_editor/static/src/img/odoobot_transparent.png`;this.userAvatarUrl=`${
            browser.location.origin
        }/web/image?model=res.users&field=avatar_128&id=${encodeURIComponent(user.userId)}`;this.state=useState({...this.state,prompt:this.props.initialPrompt,conversationHistory:[{role:"system",content:"You are a helpful assistant, your goal is to help the user write their document.",},{role:"assistant",content:"What do you need ?",},],messages:[],});this.promptInputRef=useRef("promptInput");this.modalRef=useChildRef();useAutofocus({refName:"promptInput",mobile:true});useEffect(()=>{this.promptInputRef.el.style.height=0;this.promptInputRef.el.style.height=this.promptInputRef.el.scrollHeight+"px";},()=>[this.state.prompt]);useEffect(()=>{const modalEl=this.modalRef.el.querySelector("main.modal-body");const lastMessageEl=modalEl.lastElementChild;scrollTo(lastMessageEl,{behavior:"smooth",isAnchor:true,});},()=>[this.state.conversationHistory.length]);}
onTextareaKeydown(ev){if(ev.key==="Enter"&&!ev.shiftKey){ev.stopImmediatePropagation();if(this.state.prompt.trim().length){this.submitPrompt(ev);}}}
submitPrompt(ev){this.freezeInput();ev.preventDefault();const prompt=this.state.prompt;this.state.messages.push({author:"user",text:prompt});const messageId=new Date().getTime();const conversation={role:"user",content:prompt};this.state.conversationHistory.push(conversation);this.state.messages.push({author:"assistant",id:messageId});this.state.prompt="";this.generate(prompt,(content,isError)=>{if(isError){this.state.conversationHistory=this.state.conversationHistory.filter((c)=>c!==conversation);}else{this.state.conversationHistory.push({role:"assistant",content});}
const messageIndex=this.state.messages.findIndex((m)=>m.id===messageId);this.state.messages[messageIndex]={author:"assistant",text:content,isError,id:messageId,};this.unfreezeInput();});}
freezeInput(){this.promptInputRef.el.setAttribute("disabled","");}
unfreezeInput(){this.promptInputRef.el.removeAttribute("disabled");this.promptInputRef.el.focus();}
_cancel(){this.freezeInput();super._cancel();}
_confirm(){this.freezeInput();super._confirm();}}
return __exports;});;

/* /html_editor/static/src/main/chatgpt/chatgpt_translate_dialog.js */
odoo.define('@html_editor/main/chatgpt/chatgpt_translate_dialog',['@odoo/owl','@html_editor/main/chatgpt/chatgpt_dialog'],function(require){'use strict';let __exports={};const{useState}=require("@odoo/owl");const{ChatGPTDialog}=require("@html_editor/main/chatgpt/chatgpt_dialog");const ChatGPTTranslateDialog=__exports.ChatGPTTranslateDialog=class ChatGPTTranslateDialog extends ChatGPTDialog{static template="html_editor.ChatGPTTranslateDialog";static props={...super.props,originalText:String,language:String,};setup(){super.setup();this.state=useState({...this.state,conversationHistory:[{role:"system",content:"You are a translation assistant. You goal is to translate text while maintaining the original format and"+"respecting specific instructions. \n"+"Instructions: \n"+"- You must respect the format (wrapping the translated text between <generated_text> and </generated_text>)\n"+"- Do not write HTML.",},],messages:[],translationInProgress:true,});this.translate();}
async translate(){const query=`Translate <generated_text>${this.props.originalText}</generated_text> to ${this.props.language}`;const messageId=new Date().getTime();await this.generate(query,(content,isError)=>{let translatedText=content.replace(/^[\s\S]*<generated_text>/,"").replace(/<\/generated_text>[\s\S]*$/,"");if(!this.formatContent(translatedText).length){isError=true;translatedText="You didn't select any text.";}
this.state.translationInProgress=false;if(!isError){this.state.conversationHistory.push({role:"user",content:query,},{role:"assistant",content,});}
this.state.messages.push({author:"assistant",text:translatedText,id:messageId,isError,});this.state.selectedMessageId=messageId;});}}
return __exports;});;

/* /html_editor/static/src/main/chatgpt/language_selector.js */
odoo.define('@html_editor/main/chatgpt/language_selector',['@odoo/owl','@web/core/utils/hooks','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/l10n/translation','@html_editor/main/toolbar/toolbar','@web/core/user'],function(require){'use strict';let __exports={};const{Component,onWillStart,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{loadLanguages}=require("@web/core/l10n/translation");const{toolbarButtonProps}=require("@html_editor/main/toolbar/toolbar");const{user}=require("@web/core/user");const LanguageSelector=__exports.LanguageSelector=class LanguageSelector extends Component{static template="html_editor.LanguageSelector";static props={...toolbarButtonProps,onSelected:{type:Function},isDisabled:{type:Function,optional:true},};static components={Dropdown,DropdownItem};setup(){this.orm=useService("orm");this.state=useState({languages:[],});onWillStart(()=>{if(user.userId){loadLanguages(this.orm).then((res)=>{this.state.languages=res;});}});}
onSelected(language){this.props.onSelected(language);}}
return __exports;});;

/* /html_editor/static/src/main/column_plugin.js */
odoo.define('@html_editor/main/column_plugin',['@web/core/l10n/translation','@html_editor/plugin','@html_editor/utils/blocks','@html_editor/utils/dom','@html_editor/utils/dom_traversal'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Plugin}=require("@html_editor/plugin");const{closestBlock}=require("@html_editor/utils/blocks");const{unwrapContents}=require("@html_editor/utils/dom");const{closestElement}=require("@html_editor/utils/dom_traversal");const REGEX_BOOTSTRAP_COLUMN=/(?:^| )col(-[a-zA-Z]+)?(-\d+)?(?:$| )/;function isUnremovableColumn(node,root){const isColumnInnerStructure=node.nodeName==="DIV"&&[...node.classList].some((cls)=>/^row$|^col$|^col-/.test(cls));if(!isColumnInnerStructure){return false;}
if(!root){return true;}
const closestColumnContainer=closestElement(node,"div.o_text_columns");return!root.contains(closestColumnContainer);}
function columnIsAvailable(numberOfColumns){return(selection)=>{const row=closestElement(selection.anchorNode,".o_text_columns .row");return!(row&&row.childElementCount===numberOfColumns);};}
const ColumnPlugin=__exports.ColumnPlugin=class ColumnPlugin extends Plugin{static id="column";static dependencies=["baseContainer","selection","history"];resources={user_commands:[{id:"columnize",title:_t("Columnize"),description:_t("Convert into columns"),icon:"fa-columns",run:this.columnize.bind(this),},],powerbox_items:[{title:_t("2 columns"),description:_t("Convert into 2 columns"),categoryId:"structure",isAvailable:columnIsAvailable(2),commandId:"columnize",commandParams:{numberOfColumns:2},},{title:_t("3 columns"),description:_t("Convert into 3 columns"),categoryId:"structure",isAvailable:columnIsAvailable(3),commandId:"columnize",commandParams:{numberOfColumns:3},},{title:_t("4 columns"),description:_t("Convert into 4 columns"),categoryId:"structure",isAvailable:columnIsAvailable(4),commandId:"columnize",commandParams:{numberOfColumns:4},},{title:_t("Remove columns"),description:_t("Back to one column"),categoryId:"structure",isAvailable:(selection)=>!!closestElement(selection.anchorNode,".o_text_columns .row"),commandId:"columnize",commandParams:{numberOfColumns:0},},],hints:[{selector:`.odoo-editor-editable .o_text_columns div[class^='col-'],
                            .odoo-editor-editable .o_text_columns div[class^='col-']>p:first-child`,text:_t("Empty column"),},],unremovable_node_predicates:isUnremovableColumn,power_buttons_visibility_predicates:({anchorNode})=>!closestElement(anchorNode,".o_text_columns"),};columnize({numberOfColumns,addParagraphAfter=true}={}){const selectionToRestore=this.dependencies.selection.getEditableSelection();const anchor=selectionToRestore.anchorNode;const hasColumns=!!closestElement(anchor,".o_text_columns");if(hasColumns){if(numberOfColumns){this.changeColumnsNumber(anchor,numberOfColumns);}else{this.removeColumns(anchor);}}else if(numberOfColumns){this.createColumns(anchor,numberOfColumns,addParagraphAfter);}
this.dependencies.selection.setSelection(selectionToRestore);this.dependencies.history.addStep();}
removeColumns(anchor){const container=closestElement(anchor,".o_text_columns");const rows=unwrapContents(container);for(const row of rows){const columns=unwrapContents(row);for(const column of columns){unwrapContents(column);}}}
createColumns(anchor,numberOfColumns,addParagraphAfter){const container=this.document.createElement("div");if(!closestElement(anchor,".container")){container.classList.add("container");}
container.classList.add("o_text_columns");const row=this.document.createElement("div");row.classList.add("row");container.append(row);const block=closestBlock(anchor);const columnSize=Math.floor(12/numberOfColumns);const columns=[];for(let i=0;i<numberOfColumns;i++){const column=this.document.createElement("div");column.classList.add(`col-${columnSize}`);row.append(column);columns.push(column);}
block.before(container);columns.shift().append(block);for(const column of columns){const baseContainer=this.dependencies.baseContainer.createBaseContainer();baseContainer.append(this.document.createElement("br"));column.append(baseContainer);}
if(addParagraphAfter){const baseContainer=this.dependencies.baseContainer.createBaseContainer();baseContainer.append(this.document.createElement("br"));container.after(baseContainer);}}
changeColumnsNumber(anchor,numberOfColumns){const row=closestElement(anchor,".row");const columns=[...row.children];const columnSize=Math.floor(12/numberOfColumns);const diff=numberOfColumns-columns.length;if(!diff){return;}
for(const column of columns){column.className=column.className.replace(REGEX_BOOTSTRAP_COLUMN,`col$1-${columnSize}`);}
if(diff>0){let lastColumn=columns[columns.length-1];for(let i=0;i<diff;i++){const column=this.document.createElement("div");column.classList.add(`col-${columnSize}`);const baseContainer=this.dependencies.baseContainer.createBaseContainer();baseContainer.append(this.document.createElement("br"));column.append(baseContainer);lastColumn.after(column);lastColumn=column;}}else if(diff<0){const contents=[];for(let i=diff;i<0;i++){const column=columns.pop();const columnContents=unwrapContents(column);contents.unshift(...columnContents);}
columns[columns.length-1].append(...contents);}}}
return __exports;});;

/* /html_editor/static/src/main/emoji_plugin.js */
odoo.define('@html_editor/main/emoji_plugin',['@html_editor/plugin','@web/core/emoji_picker/emoji_picker','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{EmojiPicker}=require("@web/core/emoji_picker/emoji_picker");const{_t}=require("@web/core/l10n/translation");const EmojiPlugin=__exports.EmojiPlugin=class EmojiPlugin extends Plugin{static id="emoji";static dependencies=["history","overlay","dom","selection"];static shared=["showEmojiPicker"];resources={user_commands:[{id:"addEmoji",title:_t("Emoji"),description:_t("Add an emoji"),icon:"fa-smile-o",run:this.showEmojiPicker.bind(this),},],powerbox_items:[{categoryId:"widget",commandId:"addEmoji",},],};setup(){this.overlay=this.dependencies.overlay.createOverlay(EmojiPicker,{hasAutofocus:true,className:"popover",});}
showEmojiPicker({target,onSelect}={}){this.overlay.open({props:{close:()=>{this.overlay.close();this.dependencies.selection.focusEditable();},onSelect:(str)=>{if(onSelect){onSelect(str);return;}
this.dependencies.dom.insert(str);this.dependencies.history.addStep();},},target,});}}
return __exports;});;

/* /html_editor/static/src/main/feff_plugin.js */
odoo.define('@html_editor/main/feff_plugin',['@html_editor/plugin','@html_editor/utils/dom','@html_editor/utils/dom_info','@html_editor/utils/dom_state','@html_editor/utils/dom_traversal','@html_editor/utils/position','@html_editor/utils/selection'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{cleanTextNode}=require("@html_editor/utils/dom");const{isTextNode,isZwnbsp}=require("@html_editor/utils/dom_info");const{prepareUpdate}=require("@html_editor/utils/dom_state");const{descendants,selectElements}=require("@html_editor/utils/dom_traversal");const{leftPos}=require("@html_editor/utils/position");const{callbacksForCursorUpdate}=require("@html_editor/utils/selection");const FeffPlugin=__exports.FeffPlugin=class FeffPlugin extends Plugin{static id="feff";static dependencies=["selection"];static shared=["addFeff","removeFeffs","updateFeffs"];resources={normalize_handlers:this.updateFeffs.bind(this),clean_handlers:(root)=>this.clean({root,preserveSelection:true}),clean_for_save_handlers:this.clean.bind(this),intangible_char_for_keyboard_navigation_predicates:(ev,char,lastSkipped)=>char==="\uFEFF"&&(ev.shiftKey||lastSkipped!=="\uFEFF"),};clean({root,preserveSelection=false}){if(preserveSelection){const cursors=this.getCursors();this.removeFeffs(root,cursors);cursors.restore();}else{this.removeFeffs(root,null);}}
removeFeffs(root,cursors,{exclude=()=>false}={}){const hasFeff=(node)=>isTextNode(node)&&node.textContent.includes("\ufeff")&&node.parentElement.isContentEditable;for(const node of descendants(root).filter((n)=>hasFeff(n)&&!exclude(n))){const restoreSpaces=prepareUpdate(...leftPos(node));cleanTextNode(node,"\ufeff",cursors);restoreSpaces();}}
addFeff(element,position,cursors){const feff=this.document.createTextNode("\ufeff");cursors?.update(callbacksForCursorUpdate[position](element,feff));element[position](feff);return feff;}
padWithFeffs(root,cursors){const combinedSelector=this.getResource("selectors_for_feff_providers").map((provider)=>provider()).join(", ");if(!combinedSelector){return[];}
const elements=[...selectElements(root,combinedSelector)];const feffNodes=elements.flatMap((el)=>{const addFeff=(position)=>this.addFeff(el,position,cursors);return[isZwnbsp(el.previousSibling)?el.previousSibling:addFeff("before"),isZwnbsp(el.nextSibling)?el.nextSibling:addFeff("after"),];}).filter((feff,i,array)=>!(i>0&&areCloseSiblings(array[i-1],feff)));return feffNodes;}
updateFeffs(root){const cursors=this.getCursors();const feffNodesBasedOnSelectors=this.padWithFeffs(root,cursors);const customFeffNodes=this.getResource("feff_providers").flatMap((p)=>p(root,cursors));const feffNodesToKeep=new Set([...feffNodesBasedOnSelectors,...customFeffNodes]);this.removeFeffs(root,cursors,{exclude:(node)=>feffNodesToKeep.has(node)});cursors.restore();}
getCursors(){const cursors=this.dependencies.selection.preserveSelection();const originalUpdate=cursors.update.bind(cursors);const originalRestore=cursors.restore.bind(cursors);let shouldRestore=false;cursors.update=(...args)=>{shouldRestore=true;return originalUpdate(...args);};cursors.restore=()=>{if(shouldRestore){originalRestore();}};return cursors;}}
function areCloseSiblings(a,b){let next=a.nextSibling;while(next&&isTextNode(next)&&!next.textContent){next=next.nextSibling;}
return next===b;}
return __exports;});;

/* /html_editor/static/src/main/font/color_plugin.js */
odoo.define('@html_editor/main/font/color_plugin',['@html_editor/plugin','@html_editor/utils/color','@html_editor/utils/dom','@html_editor/utils/dom_info','@html_editor/utils/dom_traversal','@web/core/utils/colors','@html_editor/main/font/color_selector','@odoo/owl','@web/core/l10n/translation','@html_editor/utils/resource'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{isColorGradient,rgbaToHex,hasColor,hasAnyNodesColor,TEXT_CLASSES_REGEX,BG_CLASSES_REGEX,RGBA_REGEX,}=require("@html_editor/utils/color");const{fillEmpty,unwrapContents}=require("@html_editor/utils/dom");const{isContentEditable,isEmptyBlock,isTextNode,isWhitespace,isZwnbsp,}=require("@html_editor/utils/dom_info");const{closestElement,descendants}=require("@html_editor/utils/dom_traversal");const{isCSSColor}=require("@web/core/utils/colors");const{ColorSelector}=require("@html_editor/main/font/color_selector");const{reactive}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{withSequence}=require("@html_editor/utils/resource");const RGBA_OPACITY=0.6;const HEX_OPACITY="99";const ColorPlugin=__exports.ColorPlugin=class ColorPlugin extends Plugin{static id="color";static dependencies=["selection","split","history","format"];static shared=["colorElement","getPropsForColorSelector"];resources={user_commands:[{id:"applyColor",run:this.applyColor.bind(this),},],toolbar_groups:withSequence(25,{id:"color",}),toolbar_items:[{id:"forecolor",groupId:"color",title:_t("Font Color"),Component:ColorSelector,props:this.getPropsForColorSelector("foreground"),},{id:"backcolor",groupId:"color",title:_t("Background Color"),Component:ColorSelector,props:this.getPropsForColorSelector("background"),},],selectionchange_handlers:this.updateSelectedColor.bind(this),remove_format_handlers:this.removeAllColor.bind(this),};setup(){this.selectedColors=reactive({color:"",backgroundColor:""});this.previewableApplyColor=this.dependencies.history.makePreviewableOperation((color,mode,previewMode)=>this._applyColor(color,mode,previewMode));}
getPropsForColorSelector(type){const mode=type==="foreground"?"color":"backgroundColor";return{type,getUsedCustomColors:()=>this.getUsedCustomColors(mode),getSelectedColors:()=>this.selectedColors,applyColor:this.applyColor.bind(this),applyColorPreview:this.applyColorPreview.bind(this),applyColorResetPreview:this.applyColorResetPreview.bind(this),focusEditable:()=>this.dependencies.selection.focusEditable(),};}
updateSelectedColor(){const nodes=this.dependencies.selection.getTraversedNodes().filter(isTextNode);if(nodes.length===0){return;}
const el=closestElement(nodes[0]);if(!el){return;}
const elStyle=getComputedStyle(el);const backgroundImage=elStyle.backgroundImage;const hasGradient=isColorGradient(backgroundImage);const hasTextGradientClass=el.classList.contains("text-gradient");let backgroundColor=elStyle.backgroundColor;const activeTab=document.querySelector(".o_font_color_selector button.active")?.innerHTML.trim();if(backgroundColor.startsWith("rgba")&&activeTab==="Solid"){const values=backgroundColor.match(RGBA_REGEX)||[];const alpha=parseFloat(values.pop());if(alpha===RGBA_OPACITY){backgroundColor=`rgb(${values.slice(0, 3).join(", ")})`;}}
this.selectedColors.color=hasGradient&&hasTextGradientClass?backgroundImage:rgbaToHex(elStyle.color);this.selectedColors.backgroundColor=hasGradient&&!hasTextGradientClass?backgroundImage:rgbaToHex(backgroundColor);}
applyColor({color,mode}){this.previewableApplyColor.commit(color,mode);this.updateSelectedColor();}
applyColorPreview({color,mode}){this.previewableApplyColor.preview(color,mode,true);this.updateSelectedColor();}
applyColorResetPreview(){this.previewableApplyColor.revert();this.updateSelectedColor();}
removeAllColor(){const colorModes=["color","backgroundColor"];let someColorWasRemoved=true;while(someColorWasRemoved){someColorWasRemoved=false;for(const mode of colorModes){let max=40;const hasAnySelectedNodeColor=(mode)=>{const nodes=this.dependencies.selection.getTraversedNodes().filter((n)=>isTextNode(n)||n.classList.contains("o_selected_td"));return hasAnyNodesColor(nodes,mode);};while(hasAnySelectedNodeColor(mode)&&max>0){this._applyColor("",mode);someColorWasRemoved=true;max--;}
if(max===0){someColorWasRemoved=false;throw new Error("Infinite Loop in removeAllColor().");}}}}
_applyColor(color,mode,previewMode=false){if(this.delegateTo("color_apply_overrides",color,mode,previewMode)){return;}
const activeTab=document.querySelector(".o_font_color_selector button.active")?.innerHTML.trim();if(mode==="backgroundColor"&&activeTab==="Solid"&&color.startsWith("#")){color+=HEX_OPACITY;}
let selection=this.dependencies.selection.getEditableSelection();let selectionNodes;if(selection.isCollapsed){let zws;if(selection.anchorNode.nodeType!==Node.TEXT_NODE&&selection.anchorNode.textContent!=="\u200b"){zws=selection.anchorNode;}else{zws=this.dependencies.format.insertAndSelectZws();}
selection=this.dependencies.selection.setSelection({anchorNode:zws,anchorOffset:0,},{normalize:false});selectionNodes=[zws];}else{selection=this.dependencies.split.splitSelection();selectionNodes=this.dependencies.selection.getSelectedNodes().filter((node)=>isContentEditable(node)&&node.nodeName!=="T");if(isEmptyBlock(selection.endContainer)){selectionNodes.push(selection.endContainer,...descendants(selection.endContainer));}}
const selectedNodes=mode==="backgroundColor"&&color?selectionNodes.filter((node)=>!closestElement(node,"table.o_selected_table")):selectionNodes;const selectedFieldNodes=new Set(this.dependencies.selection.getSelectedNodes().map((n)=>closestElement(n,"*[t-field],*[t-out],*[t-esc]")).filter(Boolean));const getFonts=(selectedNodes)=>{return selectedNodes.flatMap((node)=>{let font=closestElement(node,"font")||closestElement(node,"span");const children=font&&descendants(font);const hasInlineGradient=font&&isColorGradient(font.style["background-image"]);if(font&&(font.nodeName==="FONT"||(font.nodeName==="SPAN"&&font.style[mode]))&&(isColorGradient(color)||color===""||!hasInlineGradient)){const selectedChildren=children.filter((child)=>selectedNodes.includes(child));if(selectedChildren.length){const closestGradientEl=closestElement(node,'font[style*="background-image"], span[style*="background-image"]');const isGradientBeingUpdated=closestGradientEl&&isColorGradient(color);const splitnode=isGradientBeingUpdated?closestGradientEl:font;font=this.dependencies.split.splitAroundUntil(selectedChildren,splitnode);if(isGradientBeingUpdated){const classRegex=mode==="color"?TEXT_CLASSES_REGEX:BG_CLASSES_REGEX;for(const node of descendants(font)){if(node.nodeType===Node.ELEMENT_NODE&&(node.style[mode]||classRegex.test(node.className))){this.colorElement(node,"",mode);node.style.webkitTextFillColor="";if(!node.getAttribute("style")){unwrapContents(node);}}}}else if(mode==="color"&&(font.style.webkitTextFillColor||(closestGradientEl&&closestGradientEl.classList.contains("text-gradient")))){font.style.webkitTextFillColor=color;}}else{font=[];}}else if((node.nodeType===Node.TEXT_NODE&&!isWhitespace(node)&&!isZwnbsp(node))||(node.nodeName==="BR"&&isEmptyBlock(node.parentNode))||(node.nodeType===Node.ELEMENT_NODE&&["inline","inline-block"].includes(getComputedStyle(node).display)&&!isWhitespace(node.textContent)&&!node.classList.contains("btn")&&!node.querySelector("font")&&node.nodeName!=="A"&&!(node.nodeName==="SPAN"&&node.style["fontSize"]))){const previous=node.previousSibling;const classRegex=mode==="color"?BG_CLASSES_REGEX:TEXT_CLASSES_REGEX;if(previous&&previous.nodeName==="FONT"&&!previous.style[mode==="color"?"backgroundColor":"color"]&&!classRegex.test(previous.className)&&selectedNodes.includes(previous.firstChild)&&selectedNodes.includes(previous.lastChild)){font=previous;}else{const isTextGradient=hasInlineGradient&&font.classList.contains("text-gradient");font=this.document.createElement("font");node.after(font);if(isTextGradient&&mode==="color"){font.style.webkitTextFillColor=color;}}
if(node.textContent){font.appendChild(node);}else{fillEmpty(font);}}else{font=[];}
return font;});};for(const fieldNode of selectedFieldNodes){this.colorElement(fieldNode,color,mode);}
let fonts=getFonts(selectedNodes);if(!fonts.every((font)=>font.isConnected)){fonts=getFonts(selectedNodes);}
const fontsSet=new Set(fonts);for(const font of fontsSet){this.colorElement(font,color,mode);if(!hasColor(font,"color")&&!hasColor(font,"backgroundColor")&&(!font.hasAttribute("style")||!color)){for(const child of[...font.childNodes]){font.parentNode.insertBefore(child,font);}
font.parentNode.removeChild(font);fontsSet.delete(font);}}
this.dependencies.selection.setSelection(selection,{normalize:false});}
getUsedCustomColors(mode){const allFont=this.editable.querySelectorAll("font");const usedCustomColors=new Set();for(const font of allFont){if(isCSSColor(font.style[mode])){usedCustomColors.add(rgbaToHex(font.style[mode]));}}
return usedCustomColors;}
colorElement(element,color,mode){const newClassName=element.className.replace(mode==="color"?TEXT_CLASSES_REGEX:BG_CLASSES_REGEX,"").replace(/\btext-gradient\b/g,"").replace(/\s+/," ");element.className!==newClassName&&(element.className=newClassName);element.style["background-image"]="";if(mode==="backgroundColor"){element.style["background"]="";}
if(color.startsWith("text")||color.startsWith("bg-")){element.style[mode]="";element.classList.add(color);}else if(isColorGradient(color)){element.style[mode]="";if(mode==="color"){element.style["background"]="";element.style["background-image"]=color;element.classList.add("text-gradient");}else{element.style["background-image"]=color;}}else{element.style[mode]=color;}}}
return __exports;});;

/* /html_editor/static/src/main/font/color_selector.js */
odoo.define('@html_editor/main/font/color_selector',['@odoo/owl','@web/core/colorpicker/colorpicker','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_hooks','@web/core/utils/colors','@html_editor/utils/color','@html_editor/main/font/gradient_picker','@html_editor/main/toolbar/toolbar'],function(require){'use strict';let __exports={};const{Component,useRef,useState}=require("@odoo/owl");const{Colorpicker}=require("@web/core/colorpicker/colorpicker");const{Dropdown}=require("@web/core/dropdown/dropdown");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const{isCSSColor}=require("@web/core/utils/colors");const{isColorGradient}=require("@html_editor/utils/color");const{GradientPicker}=require("@html_editor/main/font/gradient_picker");const{toolbarButtonProps}=require("@html_editor/main/toolbar/toolbar");const DEFAULT_COLORS=[["#000000","#424242","#636363","#9C9C94","#CEC6CE","#EFEFEF","#F7F7F7","#FFFFFF"],["#FF0000","#FF9C00","#FFFF00","#00FF00","#00FFFF","#0000FF","#9C00FF","#FF00FF"],["#F7C6CE","#FFE7CE","#FFEFC6","#D6EFD6","#CEDEE7","#CEE7F7","#D6D6E7","#E7D6DE"],["#E79C9C","#FFC69C","#FFE79C","#B5D6A5","#A5C6CE","#9CC6EF","#B5A5D6","#D6A5BD"],["#E76363","#F7AD6B","#FFD663","#94BD7B","#73A5AD","#6BADDE","#8C7BC6","#C67BA5"],["#CE0000","#E79439","#EFC631","#6BA54A","#4A7B8C","#3984C6","#634AA5","#A54A7B"],["#9C0000","#B56308","#BD9400","#397B21","#104A5A","#085294","#311873","#731842"],["#630000","#7B3900","#846300","#295218","#083139","#003163","#21104A","#4A1031"],];const DEFAULT_GRADIENT_COLORS=["linear-gradient(135deg, rgb(255, 204, 51) 0%, rgb(226, 51, 255) 100%)","linear-gradient(135deg, rgb(102, 153, 255) 0%, rgb(255, 51, 102) 100%)","linear-gradient(135deg, rgb(47, 128, 237) 0%, rgb(178, 255, 218) 100%)","linear-gradient(135deg, rgb(203, 94, 238) 0%, rgb(75, 225, 236) 100%)","linear-gradient(135deg, rgb(214, 255, 127) 0%, rgb(0, 179, 204) 100%)","linear-gradient(135deg, rgb(255, 222, 69) 0%, rgb(69, 33, 0) 100%)","linear-gradient(135deg, rgb(222, 222, 222) 0%, rgb(69, 69, 69) 100%)","linear-gradient(135deg, rgb(255, 222, 202) 0%, rgb(202, 115, 69) 100%)",];const ColorSelector=__exports.ColorSelector=class ColorSelector extends Component{static template="html_editor.ColorSelector";static components={Dropdown,Colorpicker,GradientPicker};static props={type:String,getUsedCustomColors:Function,getSelectedColors:Function,applyColor:Function,applyColorPreview:Function,applyColorResetPreview:Function,focusEditable:Function,...toolbarButtonProps,};setup(){this.DEFAULT_COLORS=DEFAULT_COLORS;this.DEFAULT_GRADIENT_COLORS=DEFAULT_GRADIENT_COLORS;this.dropdown=useDropdownState({onClose:()=>this.props.applyColorResetPreview(),});this.mode=this.props.type==="foreground"?"color":"backgroundColor";this.state=useState({activeTab:"solid"});this.colorWrapperEl=useRef("colorsWrapper");this.selectedColors=useState(this.props.getSelectedColors());this.defaultColor=this.selectedColors[this.mode];this.currentCustomColor=useState({color:this.selectedColors[this.mode]});this.usedCustomColors=this.props.getUsedCustomColors();}
setTab(tab){this.state.activeTab=tab;}
processColorFromEvent(ev){let color=ev.target.dataset.color;if(color&&!isCSSColor(color)&&!isColorGradient(color)){color=(this.mode==="color"?"text-":"bg-")+color;}
return color;}
applyColor(color){this.currentCustomColor.color=color;this.props.applyColor({color:color||"",mode:this.mode});this.props.focusEditable();}
onColorApply(ev){if(ev.target.tagName!=="BUTTON"){return;}
const color=this.processColorFromEvent(ev);this.applyColor(color);this.dropdown.close();}
onColorPreview(ev){const color=ev.hex?ev.hex:this.processColorFromEvent(ev);this.props.applyColorPreview({color:color||"",mode:this.mode});}
onColorHover(ev){if(ev.target.tagName!=="BUTTON"){return;}
this.onColorPreview(ev);}
onColorHoverOut(ev){if(ev.target.tagName!=="BUTTON"){return;}
this.props.applyColorResetPreview();}
getCurrentGradientColor(){if(isColorGradient(this.selectedColors[this.mode])){return this.selectedColors[this.mode];}}
getSelectedColorStyle(){if(isColorGradient(this.selectedColors[this.mode])){return`border-bottom: 2px solid transparent; border-image: ${
                this.selectedColors[this.mode]
            }; border-image-slice: 1`;}
return`border-bottom: 2px solid ${this.selectedColors[this.mode]}`;}}
return __exports;});;

/* /html_editor/static/src/main/font/font_plugin.js */
odoo.define('@html_editor/main/font/font_plugin',['@html_editor/plugin','@html_editor/utils/blocks','@html_editor/utils/dom','@html_editor/utils/dom_state','@html_editor/utils/dom_info','@html_editor/utils/dom_traversal','@html_editor/utils/formatting','@html_editor/utils/position','@web/core/l10n/translation','@html_editor/main/font/font_selector','@html_editor/utils/base_container','@html_editor/utils/resource','@odoo/owl','@html_editor/main/font/font_size_selector'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{isBlock,closestBlock}=require("@html_editor/utils/blocks");const{fillEmpty}=require("@html_editor/utils/dom");const{leftLeafOnlyNotBlockPath}=require("@html_editor/utils/dom_state");const{isVisibleTextNode}=require("@html_editor/utils/dom_info");const{closestElement,createDOMPathGenerator,descendants,}=require("@html_editor/utils/dom_traversal");const{convertNumericToUnit,getCSSVariableValue,getHtmlStyle,getFontSizeDisplayValue,}=require("@html_editor/utils/formatting");const{DIRECTIONS}=require("@html_editor/utils/position");const{_t}=require("@web/core/l10n/translation");const{FontSelector}=require("@html_editor/main/font/font_selector");const{getBaseContainerSelector}=require("@html_editor/utils/base_container");const{withSequence}=require("@html_editor/utils/resource");const{reactive}=require("@odoo/owl");const{FontSizeSelector}=require("@html_editor/main/font/font_size_selector");const fontItems=__exports.fontItems=[{name:_t("Header 1 Display 1"),tagName:"h1",extraClass:"display-1",},{name:_t("Header 1"),tagName:"h1"},{name:_t("Header 2"),tagName:"h2"},{name:_t("Header 3"),tagName:"h3"},{name:_t("Header 4"),tagName:"h4"},{name:_t("Header 5"),tagName:"h5"},{name:_t("Header 6"),tagName:"h6"},{name:_t("Normal"),tagName:"div",selector:getBaseContainerSelector("DIV"),},{name:_t("Paragraph"),tagName:"p"},{name:_t("Code"),tagName:"pre"},{name:_t("Quote"),tagName:"blockquote"},];const fontSizeItems=__exports.fontSizeItems=[{variableName:"display-1-font-size",className:"display-1-fs",},{variableName:"display-2-font-size",className:"display-2-fs"},{variableName:"display-3-font-size",className:"display-3-fs"},{variableName:"display-4-font-size",className:"display-4-fs"},{variableName:"h1-font-size",className:"h1-fs"},{variableName:"h2-font-size",className:"h2-fs"},{variableName:"h3-font-size",className:"h3-fs"},{variableName:"h4-font-size",className:"h4-fs"},{variableName:"h5-font-size",className:"h5-fs"},{variableName:"h6-font-size",className:"h6-fs"},{variableName:"font-size-base",className:"base-fs"},{variableName:"small-font-size",className:"o_small-fs"},];const rightLeafOnlyNotBlockPath=createDOMPathGenerator(DIRECTIONS.RIGHT,{leafOnly:true,stopTraverseFunction:isBlock,stopFunction:isBlock,});const headingTags=["H1","H2","H3","H4","H5","H6"];const handledElemSelector=[...headingTags,"PRE","BLOCKQUOTE"].join(", ");const FontPlugin=__exports.FontPlugin=class FontPlugin extends Plugin{static id="font";static dependencies=["baseContainer","input","split","selection","dom","format"];resources={user_commands:[{id:"setTagHeading1",title:_t("Heading 1"),description:_t("Big section heading"),icon:"fa-header",run:()=>this.dependencies.dom.setTag({tagName:"H1"}),},{id:"setTagHeading2",title:_t("Heading 2"),description:_t("Medium section heading"),icon:"fa-header",run:()=>this.dependencies.dom.setTag({tagName:"H2"}),},{id:"setTagHeading3",title:_t("Heading 3"),description:_t("Small section heading"),icon:"fa-header",run:()=>this.dependencies.dom.setTag({tagName:"H3"}),},{id:"setTagParagraph",title:_t("Text"),description:_t("Paragraph block"),icon:"fa-paragraph",run:()=>{this.dependencies.dom.setTag({tagName:this.dependencies.baseContainer.getDefaultNodeName(),});},},{id:"setTagQuote",title:_t("Quote"),description:_t("Add a blockquote section"),icon:"fa-quote-right",run:()=>this.dependencies.dom.setTag({tagName:"blockquote"}),},{id:"setTagPre",title:_t("Code"),description:_t("Add a code section"),icon:"fa-code",run:()=>this.dependencies.dom.setTag({tagName:"pre"}),},],toolbar_groups:[withSequence(10,{id:"font",}),withSequence(29,{id:"font-size",}),],toolbar_items:[{id:"font",groupId:"font",title:_t("Font style"),Component:FontSelector,props:{getItems:()=>fontItems,getDisplay:()=>this.font,onSelected:(item)=>{this.dependencies.dom.setTag({tagName:item.tagName,extraClass:item.extraClass,});this.updateFontSelectorParams();},},},{id:"font-size",groupId:"font-size",title:_t("Font size"),Component:FontSizeSelector,props:{getItems:()=>this.fontSizeItems,getDisplay:()=>this.fontSize,onFontSizeInput:(size)=>{this.dependencies.format.formatSelection("fontSize",{formatProps:{size},applyStyle:true,});this.updateFontSizeSelectorParams();},onSelected:(item)=>{this.dependencies.format.formatSelection("setFontSizeClassName",{formatProps:{className:item.className},applyStyle:true,});this.updateFontSizeSelectorParams();},},},],powerbox_categories:withSequence(30,{id:"format",name:_t("Format")}),powerbox_items:[{categoryId:"format",commandId:"setTagHeading1",},{categoryId:"format",commandId:"setTagHeading2",},{categoryId:"format",commandId:"setTagHeading3",},{categoryId:"format",commandId:"setTagParagraph",},{categoryId:"structure",commandId:"setTagQuote",},{categoryId:"structure",commandId:"setTagPre",},],hints:[{selector:"H1",text:_t("Heading 1")},{selector:"H2",text:_t("Heading 2")},{selector:"H3",text:_t("Heading 3")},{selector:"H4",text:_t("Heading 4")},{selector:"H5",text:_t("Heading 5")},{selector:"H6",text:_t("Heading 6")},{selector:"PRE",text:_t("Code")},{selector:"BLOCKQUOTE",text:_t("Quote")},],input_handlers:this.onInput.bind(this),selectionchange_handlers:[this.updateFontSelectorParams.bind(this),this.updateFontSizeSelectorParams.bind(this),],post_undo_handlers:[this.updateFontSelectorParams.bind(this),this.updateFontSizeSelectorParams.bind(this),],post_redo_handlers:[this.updateFontSelectorParams.bind(this),this.updateFontSizeSelectorParams.bind(this),],split_element_block_overrides:[this.handleSplitBlockHeading.bind(this),this.handleSplitBlockPRE.bind(this),this.handleSplitBlockquote.bind(this),],delete_backward_overrides:withSequence(20,this.handleDeleteBackward.bind(this)),delete_backward_word_overrides:this.handleDeleteBackward.bind(this),};setup(){this.fontSize=reactive({displayName:""});this.font=reactive({displayName:""});}
get fontName(){const sel=this.dependencies.selection.getSelectionData().deepEditableSelection;const anchorNode=sel.anchorNode;const block=closestBlock(anchorNode);const tagName=block.tagName.toLowerCase();const matchingItems=fontItems.filter((item)=>{return item.selector?block.matches(item.selector):item.tagName===tagName;});const matchingItemsWitoutExtraClass=matchingItems.filter((item)=>!item.extraClass);if(!matchingItems.length){return _t("Normal");}
return(matchingItems.find((item)=>block.classList.contains(item.extraClass))||(matchingItemsWitoutExtraClass.length&&matchingItemsWitoutExtraClass[0])).name;}
get fontSizeName(){const sel=this.dependencies.selection.getSelectionData().deepEditableSelection;if(!sel){return fontSizeItems[0].name;}
return Math.round(getFontSizeDisplayValue(sel,this.document));}
get fontSizeItems(){const style=getHtmlStyle(this.document);const nameAlreadyUsed=new Set();return fontSizeItems.flatMap((item)=>{const strValue=getCSSVariableValue(item.variableName,style);if(!strValue){return[];}
const remValue=parseFloat(strValue);const pxValue=convertNumericToUnit(remValue,"rem","px",style);const roundedValue=Math.round(pxValue);if(nameAlreadyUsed.has(roundedValue)){return[];}
nameAlreadyUsed.add(roundedValue);return[{...item,tagName:"span",name:roundedValue}];});}
handleSplitBlockPRE({targetNode,targetOffset}){const closestPre=closestElement(targetNode,"pre");const closestBlockNode=closestBlock(targetNode);if(!closestPre||(closestBlockNode.nodeName!=="PRE"&&(closestBlockNode.textContent||closestBlockNode.nextSibling))){return;}
const nodesAfterTarget=[...rightLeafOnlyNotBlockPath(targetNode,targetOffset)];if(!nodesAfterTarget.length||(nodesAfterTarget.length===1&&nodesAfterTarget[0].nodeName==="BR")){if(closestBlockNode.nodeName!=="PRE"){closestBlockNode.remove();}
const baseContainer=this.dependencies.baseContainer.createBaseContainer();const dir=closestBlockNode.getAttribute("dir")||closestPre.getAttribute("dir");if(dir){baseContainer.setAttribute("dir",dir);}
closestPre.after(baseContainer);fillEmpty(baseContainer);this.dependencies.selection.setCursorStart(baseContainer);}else{const lineBreak=this.document.createElement("br");targetNode.insertBefore(lineBreak,targetNode.childNodes[targetOffset]);this.dependencies.selection.setCursorEnd(lineBreak);}
return true;}
handleSplitBlockquote({targetNode,targetOffset}){const closestQuote=closestElement(targetNode,"blockquote");const closestBlockNode=closestBlock(targetNode);if(!closestQuote||(closestBlockNode.nodeName!=="BLOCKQUOTE"&&(closestBlockNode.textContent||closestBlockNode.nextSibling))){return;}
const nodesAfterTarget=[...rightLeafOnlyNotBlockPath(targetNode,targetOffset)];if(!nodesAfterTarget.length||(nodesAfterTarget.length===1&&nodesAfterTarget[0].nodeName==="BR")){if(closestBlockNode.nodeName!=="BLOCKQUOTE"){closestBlockNode.remove();}
const baseContainer=this.dependencies.baseContainer.createBaseContainer();const dir=closestBlockNode.getAttribute("dir")||closestQuote.getAttribute("dir");if(dir){baseContainer.setAttribute("dir",dir);}
closestQuote.after(baseContainer);fillEmpty(baseContainer);this.dependencies.selection.setCursorStart(baseContainer);return true;}}
handleSplitBlockHeading(params){const closestHeading=closestElement(params.targetNode,(element)=>headingTags.includes(element.tagName));if(closestHeading){const[,newElement]=this.dependencies.split.splitElementBlock(params);if(newElement&&headingTags.includes(newElement.tagName)&&!descendants(newElement).some(isVisibleTextNode)){const baseContainer=this.dependencies.baseContainer.createBaseContainer();const dir=newElement.getAttribute("dir");if(dir){baseContainer.setAttribute("dir",dir);}
newElement.replaceWith(baseContainer);baseContainer.replaceChildren(this.document.createElement("br"));this.dependencies.selection.setCursorStart(baseContainer);}
return true;}}
handleDeleteBackward({startContainer,startOffset,endContainer,endOffset}){const rangeIsCollapsed=startContainer===endContainer&&startOffset===endOffset;if(!rangeIsCollapsed){return;}
const closestHandledElement=closestElement(endContainer,handledElemSelector);if(!closestHandledElement||closestHandledElement.textContent.length){return;}
if(this.getResource("unremovable_node_predicates").some((p)=>p(closestHandledElement))){return;}
const baseContainer=this.dependencies.baseContainer.createBaseContainer();baseContainer.append(...closestHandledElement.childNodes);closestHandledElement.after(baseContainer);closestHandledElement.remove();this.dependencies.selection.setCursorStart(baseContainer);return true;}
onInput(ev){if(ev.data!==" "){return;}
const selection=this.dependencies.selection.getEditableSelection();const blockEl=closestBlock(selection.anchorNode);const leftDOMPath=leftLeafOnlyNotBlockPath(selection.anchorNode);let spaceOffset=selection.anchorOffset;let leftLeaf=leftDOMPath.next().value;while(leftLeaf){spaceOffset+=leftLeaf.length;leftLeaf=leftDOMPath.next().value;}
const precedingText=blockEl.textContent.substring(0,spaceOffset);if(/^(#{1,6})\s$/.test(precedingText)){const numberOfHash=precedingText.length-1;const headingToBe=headingTags[numberOfHash-1];this.dependencies.selection.setSelection({anchorNode:blockEl.firstChild,anchorOffset:0,focusNode:selection.focusNode,focusOffset:selection.focusOffset,});this.dependencies.selection.extractContent(this.dependencies.selection.getEditableSelection());fillEmpty(blockEl);this.dependencies.dom.setTag({tagName:headingToBe});}}
updateFontSelectorParams(){this.font.displayName=this.fontName;}
updateFontSizeSelectorParams(){this.fontSize.displayName=this.fontSizeName;}}
return __exports;});;

/* /html_editor/static/src/main/font/font_selector.js */
odoo.define('@html_editor/main/font/font_selector',['@odoo/owl','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@html_editor/main/toolbar/toolbar'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{toolbarButtonProps}=require("@html_editor/main/toolbar/toolbar");const FontSelector=__exports.FontSelector=class FontSelector extends Component{static template="html_editor.FontSelector";static props={getItems:Function,getDisplay:Function,onSelected:Function,...toolbarButtonProps,};static components={Dropdown,DropdownItem};setup(){this.items=this.props.getItems();this.state=useState(this.props.getDisplay());}
onSelected(item){this.props.onSelected(item);}}
return __exports;});;

/* /html_editor/static/src/main/font/font_size_selector.js */
odoo.define('@html_editor/main/font/font_size_selector',['@odoo/owl','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@html_editor/main/toolbar/toolbar','@web/core/dropdown/dropdown_hooks','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{Component,onMounted,useEffect,useRef,useState}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{toolbarButtonProps}=require("@html_editor/main/toolbar/toolbar");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const{useDebounced}=require("@web/core/utils/timing");const MAX_FONT_SIZE=144;const FontSizeSelector=__exports.FontSizeSelector=class FontSizeSelector extends Component{static template="html_editor.FontSizeSelector";static props={getItems:Function,getDisplay:Function,onFontSizeInput:Function,onSelected:Function,...toolbarButtonProps,};static components={Dropdown,DropdownItem};setup(){this.items=this.props.getItems();this.state=useState(this.props.getDisplay());this.dropdown=useDropdownState();this.iframeContentRef=useRef("iframeContent");this.debouncedCustomFontSizeInput=useDebounced(this.onCustomFontSizeInput,200);onMounted(()=>{const iframeEl=this.iframeContentRef.el;const initFontSizeInput=()=>{const iframeDoc=iframeEl.contentWindow.document;if(this.fontSizeInput||!iframeDoc.body){return;}
this.fontSizeInput=iframeDoc.createElement("input");Object.assign(iframeDoc.body.style,{padding:"0",margin:"0",});Object.assign(this.fontSizeInput.style,{width:"100%",height:"100%",border:"none",outline:"none",textAlign:"center",});this.fontSizeInput.type="text";this.fontSizeInput.name="font-size-input";this.fontSizeInput.autocomplete="off";this.fontSizeInput.value=this.state.displayName;iframeDoc.body.appendChild(this.fontSizeInput);this.fontSizeInput.addEventListener("click",()=>{if(!this.dropdown.isOpen){this.dropdown.open();}});this.fontSizeInput.addEventListener("input",this.debouncedCustomFontSizeInput);this.fontSizeInput.addEventListener("keydown",this.onKeyDownFontSizeInput.bind(this));};if(iframeEl.contentDocument.readyState==="complete"){initFontSizeInput();}else{iframeEl.addEventListener("load",()=>{initFontSizeInput();},{once:true});}});useEffect(()=>{if(this.fontSizeInput){this.fontSizeInput.value=this.state.displayName;}},()=>[this.state.displayName]);useEffect(()=>{if(this.fontSizeInput){this.dropdown.isOpen?this.fontSizeInput.select():this.fontSizeInput.blur();}},()=>[this.dropdown.isOpen]);}
onCustomFontSizeInput(ev){let fontSize=parseInt(ev.target.value,10);if(fontSize>0){fontSize=Math.min(fontSize,MAX_FONT_SIZE);if(this.state.displayName!==fontSize){this.props.onFontSizeInput(`${fontSize}px`);}else{this.fontSizeInput.value=this.state.displayName;}}
this.fontSizeInput.focus();}
onKeyDownFontSizeInput(ev){if(["Enter","Tab"].includes(ev.key)&&this.dropdown.isOpen){this.dropdown.close();}else if(["ArrowUp","ArrowDown"].includes(ev.key)){const fontSizeSelectorMenu=document.querySelector(".o_font_size_selector_menu");if(!fontSizeSelectorMenu){return;}
ev.target.blur();const fontSizeMenuItemToFocus=ev.key==="ArrowUp"?fontSizeSelectorMenu.lastElementChild:fontSizeSelectorMenu.firstElementChild;if(fontSizeMenuItemToFocus){fontSizeMenuItemToFocus.focus();}}}
onSelected(item){this.props.onSelected(item);}}
return __exports;});;

/* /html_editor/static/src/main/font/gradient_picker.js */
odoo.define('@html_editor/main/font/gradient_picker',['@odoo/owl','@web/core/colorpicker/colorpicker','@html_editor/utils/color'],function(require){'use strict';let __exports={};const{Component,onWillUpdateProps,useState}=require("@odoo/owl");const{Colorpicker}=require("@web/core/colorpicker/colorpicker");const{isColorGradient,rgbaToHex}=require("@html_editor/utils/color");const GradientPicker=__exports.GradientPicker=class GradientPicker extends Component{static components={Colorpicker};static template="html_editor.GradientPicker";static props={onGradientChange:{type:Function,optional:true},selectedGradient:{type:String,optional:true},};setup(){this.state=useState({type:"linear",angle:135,currentColorIndex:0,size:"closest-side",});this.positions=useState({x:25,y:25});this.colors=useState([{hex:"#FF00FF",percentage:0},{hex:"#00FFFF",percentage:100},]);this.setGradientFromString(this.props.selectedGradient);onWillUpdateProps((newProps)=>{if(newProps.selectedGradient){this.setGradientFromString(newProps.selectedGradient);}});}
setGradientFromString(gradient){if(!gradient||!isColorGradient(gradient)){return;}
const colors=[...gradient.matchAll(/(#[0-9a-f]{6}|rgba?\(\s*[0-9]+\s*,\s*[0-9]+\s*,\s*[0-9]+\s*[,\s*[0-9.]*]?\s*\)|[a-z]+)\s*([[0-9]+%]?)/g),].filter((color)=>rgbaToHex(color[1])!=="#");if(colors.length!==2){return;}
this.colors[0]={hex:rgbaToHex(colors[0][1]),percentage:colors[0][2].replace("%",""),};this.colors[1]={hex:rgbaToHex(colors[1][1]),percentage:colors[1][2].replace("%",""),};const isLinear=gradient.startsWith("linear-gradient(");if(isLinear){const angle=gradient.match(/([0-9]+)deg/);if(angle){this.state.angle=angle[1];}}else{this.state.type="radial";const sizeMatch=gradient.match(/(closest|farthest)-(side|corner)/);const size=sizeMatch?sizeMatch[0]:"farthest-corner";this.state.size=size;const position=gradient.match(/ at ([0-9]+)% ([0-9]+)%/)||["","50","50"];this.positions.x=position[1];this.positions.y=position[2];}}
selectType(type){this.state.type=type;this.onColorGradientChange();}
onAngleChange(ev){this.state.angle=ev.target.value;this.onColorGradientChange();}
onPositionChange(position,ev){this.positions[position]=ev.target.value;this.onColorGradientChange();}
onColorChange(color){const hex=rgbaToHex(color.cssColor);this.colors[this.state.currentColorIndex].hex=hex;this.onColorGradientChange();}
onSizeChange(size){this.state.size=size;this.onColorGradientChange();}
onColorPercentageChange(colorIndex,ev){this.state.currentColorIndex=colorIndex;this.colors[colorIndex].percentage=ev.target.value;if(this.colors[0].percentage>this.colors[1].percentage){this.colors[1].percentage=this.colors[0].percentage;}
this.onColorGradientChange();}
onColorGradientChange(){if(this.state.type==="linear"){this.props.onGradientChange(`linear-gradient(${this.state.angle}deg, ${this.colors[0].hex} ${this.colors[0].percentage}%, ${this.colors[1].hex} ${this.colors[1].percentage}%)`);}else{this.props.onGradientChange(`radial-gradient(circle ${this.state.size} at ${this.positions.x}% ${this.positions.y}%, ${this.colors[0].hex} ${this.colors[0].percentage}%, ${this.colors[1].hex} ${this.colors[1].percentage}%)`);}}}
return __exports;});;

/* /html_editor/static/src/main/hint_plugin.js */
odoo.define('@html_editor/main/hint_plugin',['@html_editor/plugin','@html_editor/utils/dom_info','@html_editor/utils/dom','@html_editor/utils/dom_traversal','@html_editor/utils/blocks','@html_editor/utils/base_container'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{isEmptyBlock,isProtected}=require("@html_editor/utils/dom_info");const{removeClass}=require("@html_editor/utils/dom");const{childNodes,selectElements}=require("@html_editor/utils/dom_traversal");const{closestBlock}=require("@html_editor/utils/blocks");const{baseContainerGlobalSelector}=require("@html_editor/utils/base_container");function isMutationRecordSavable(record){return!(record.type==="attributes"&&record.attributeName==="placeholder");}
const HintPlugin=__exports.HintPlugin=class HintPlugin extends Plugin{static id="hint";static dependencies=["history","selection"];resources={selectionchange_handlers:this.updateHints.bind(this),external_history_step_handlers:()=>{this.clearHints();this.updateHints();},clean_handlers:this.clearHints.bind(this),clean_for_save_handlers:({root})=>this.clearHints(root),content_updated_handlers:this.updateHints.bind(this),savable_mutation_record_predicates:isMutationRecordSavable,system_classes:["o-we-hint"],...(this.config.placeholder&&{hints:[{text:this.config.placeholder,target:(selectionData,editable)=>{if(selectionData.documentSelectionIsInEditable||childNodes(editable).length!==1){return;}
const el=editable.firstChild;if(isEmptyBlock(el)&&el.matches(baseContainerGlobalSelector)){return el;}},},],}),};setup(){this.hint=null;this.updateHints(this.editable);}
destroy(){super.destroy();this.clearHints();}
updateHints(){const selectionData=this.dependencies.selection.getSelectionData();const editableSelection=selectionData.editableSelection;if(this.hint){const blockEl=closestBlock(editableSelection.anchorNode);this.removeHint(this.hint);this.removeHint(blockEl);}
if(editableSelection.isCollapsed){for(const hint of this.getResource("hints")){if(hint.selector){const el=closestBlock(editableSelection.anchorNode);if(el&&el.matches(hint.selector)&&!isProtected(el)&&isEmptyBlock(el)){this.makeHint(el,hint.text);this.hint=el;}}else{const target=hint.target(selectionData,this.editable);if(target&&!target.classList.contains("o-we-hint")){this.makeHint(target,hint.text);this.hint=target;return;}}}}}
makeHint(el,text){el.setAttribute("placeholder",text);el.classList.add("o-we-hint");}
removeHint(el){el.removeAttribute("placeholder");removeClass(el,"o-we-hint");if(this.hint===el){this.hint=null;}}
clearHints(root=this.editable){for(const elem of selectElements(root,".o-we-hint")){this.removeHint(elem);}}}
return __exports;});;

/* /html_editor/static/src/main/inline_code.js */
odoo.define('@html_editor/main/inline_code',['@html_editor/plugin','@html_editor/utils/dom','@html_editor/utils/dom_traversal','@html_editor/utils/position'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{splitTextNode}=require("@html_editor/utils/dom");const{closestElement}=require("@html_editor/utils/dom_traversal");const{DIRECTIONS}=require("@html_editor/utils/position");const InlineCodePlugin=__exports.InlineCodePlugin=class InlineCodePlugin extends Plugin{static id="inlineCode";static dependencies=["selection","history","input"];resources={input_handlers:this.onInput.bind(this),};onInput(ev){const selection=this.dependencies.selection.getEditableSelection();if(ev.data!=="`"||closestElement(selection.anchorNode,"code")){return;}
let textNode=selection.startContainer;let offset=selection.startOffset;let sibling=textNode.previousSibling;while(sibling&&sibling.nodeType===Node.TEXT_NODE){offset+=sibling.textContent.length;sibling.textContent+=textNode.textContent;textNode.remove();textNode=sibling;sibling=textNode.previousSibling;}
sibling=textNode.nextSibling;while(sibling&&sibling.nodeType===Node.TEXT_NODE){textNode.textContent+=sibling.textContent;sibling.remove();sibling=textNode.nextSibling;}
this.dependencies.selection.setSelection({anchorNode:textNode,anchorOffset:offset});const textHasTwoTicks=/`.*`/.test(textNode.textContent);if(textHasTwoTicks&&textNode.textContent.replace(/`/g,"").length){this.dependencies.history.addStep();const insertedBacktickIndex=offset-1;const textBeforeInsertedBacktick=textNode.textContent.substring(0,insertedBacktickIndex-1);let startOffset,endOffset;const isClosingForward=textBeforeInsertedBacktick.includes("`");if(isClosingForward){startOffset=textBeforeInsertedBacktick.lastIndexOf("`");endOffset=insertedBacktickIndex;}else{const textAfterInsertedBacktick=textNode.textContent.substring(offset);startOffset=insertedBacktickIndex;endOffset=offset+textAfterInsertedBacktick.indexOf("`");}
if(endOffset&&endOffset<textNode.textContent.length){splitTextNode(textNode,endOffset+1,DIRECTIONS.LEFT);}
if(startOffset){splitTextNode(textNode,startOffset);}
textNode.textContent=textNode.textContent.substring(1,textNode.textContent.length-1);const codeElement=this.document.createElement("code");codeElement.classList.add("o_inline_code");textNode.before(codeElement);codeElement.append(textNode);if(!codeElement.previousSibling||codeElement.previousSibling.nodeType!==Node.TEXT_NODE){codeElement.before(document.createTextNode("\u200B"));}
if(isClosingForward){codeElement.after(document.createTextNode("\u200B"));this.dependencies.selection.setSelection({anchorNode:codeElement.nextSibling,anchorOffset:1,});}else{this.dependencies.selection.setSelection({anchorNode:codeElement.firstChild,anchorOffset:0,});}}
this.dependencies.history.addStep();}}
return __exports;});;

/* /html_editor/static/src/main/link/command_category.js */
odoo.define('@html_editor/main/link/command_category',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const commandCategoryRegistry=registry.category("command_categories");commandCategoryRegistry.add("shortcut_conflict",{},{sequence:5});return __exports;});;

/* /html_editor/static/src/main/link/link_paste_plugin.js */
odoo.define('@html_editor/main/link/link_paste_plugin',['@html_editor/utils/dom_traversal','@html_editor/main/link/utils','@html_editor/utils/url','@html_editor/plugin','@html_editor/utils/position'],function(require){'use strict';let __exports={};const{closestElement}=require("@html_editor/utils/dom_traversal");const{URL_REGEX,cleanZWChars}=require("@html_editor/main/link/utils");const{isImageUrl}=require("@html_editor/utils/url");const{Plugin}=require("@html_editor/plugin");const{leftPos}=require("@html_editor/utils/position");const LinkPastePlugin=__exports.LinkPastePlugin=class LinkPastePlugin extends Plugin{static id="linkPaste";static dependencies=["link","clipboard","selection","dom"];resources={before_paste_handlers:this.removeFullySelectedLink.bind(this),paste_text_overrides:this.handlePasteText.bind(this),};handlePasteText(selection,text){let splitAroundUrl;if(!text.match(/\${.*}/gi)){splitAroundUrl=text.split(URL_REGEX);splitAroundUrl=splitAroundUrl.filter((_,index)=>(index+1)%3);}
if(!splitAroundUrl||splitAroundUrl.length<3||closestElement(selection.anchorNode,"pre")){return false;}
if(splitAroundUrl.length===3&&!splitAroundUrl[0]&&!splitAroundUrl[2]){this.handlePasteTextUrl(selection,text);}else{this.handlePasteTextMultiUrl(selection,splitAroundUrl);}
return true;}
handlePasteTextUrl(selection,text){const selectionIsInsideALink=!!closestElement(selection.anchorNode,"a");const url=/^https?:\/\//i.test(text)?text:"http://"+text;if(selectionIsInsideALink){this.handlePasteTextUrlInsideLink(text,url);return;}
if(this.delegateTo("paste_url_overrides",text,url)){return;}
this.dependencies.link.insertLink(url,text);}
handlePasteTextUrlInsideLink(text,url){if(isImageUrl(url)){const img=this.document.createElement("IMG");img.setAttribute("src",url);this.dependencies.dom.insert(img);}else{this.dependencies.dom.insert(text);}}
handlePasteTextMultiUrl(selection,splitAroundUrl){const selectionIsInsideALink=!!closestElement(selection.anchorNode,"a");for(let i=0;i<splitAroundUrl.length;i++){const url=/^https?:\/\//gi.test(splitAroundUrl[i])?splitAroundUrl[i]:"http://"+splitAroundUrl[i];if(i%2&&!selectionIsInsideALink){this.dependencies.dom.insert(this.dependencies.link.createLink(url,splitAroundUrl[i]));}else if(splitAroundUrl[i]!==""){this.dependencies.clipboard.pasteText(selection,splitAroundUrl[i]);}}}
removeFullySelectedLink(selection){const link=closestElement(selection.anchorNode,"a");if(link&&cleanZWChars(selection.textContent())===cleanZWChars(link.innerText)){const start=leftPos(link);link.remove();this.dependencies.selection.setSelection({anchorNode:start[0],anchorOffset:start[1],normalize:false,});}}}
return __exports;});;

/* /html_editor/static/src/main/link/link_plugin.js */
odoo.define('@html_editor/main/link/link_plugin',['@html_editor/plugin','@html_editor/utils/dom','@html_editor/utils/dom_traversal','@html_editor/utils/selection','@web/core/l10n/translation','@html_editor/main/link/link_popover','@html_editor/utils/position','@html_editor/utils/dom_state','@html_editor/main/link/utils','@html_editor/utils/dom_info','@web/core/utils/concurrency','@web/core/network/rpc','@web/core/utils/functions','@html_editor/utils/resource','@html_editor/utils/blocks'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{cleanTrailingBR,unwrapContents}=require("@html_editor/utils/dom");const{childNodes,closestElement,descendants,selectElements,}=require("@html_editor/utils/dom_traversal");const{findInSelection,callbacksForCursorUpdate}=require("@html_editor/utils/selection");const{_t}=require("@web/core/l10n/translation");const{LinkPopover}=require("@html_editor/main/link/link_popover");const{DIRECTIONS,leftPos,nodeSize,rightPos}=require("@html_editor/utils/position");const{prepareUpdate}=require("@html_editor/utils/dom_state");const{EMAIL_REGEX,URL_REGEX,cleanZWChars,deduceURLfromText}=require("@html_editor/main/link/utils");const{isVisible,isZwnbsp}=require("@html_editor/utils/dom_info");const{KeepLast}=require("@web/core/utils/concurrency");const{rpc}=require("@web/core/network/rpc");const{memoize}=require("@web/core/utils/functions");const{withSequence}=require("@html_editor/utils/resource");const{isBlock,closestBlock}=require("@html_editor/utils/blocks");function isLinkActive(selection){const linkElementAnchor=closestElement(selection.anchorNode,"A");const linkElementFocus=closestElement(selection.focusNode,"A");if(linkElementFocus&&linkElementAnchor){return linkElementAnchor===linkElementFocus;}
if(linkElementAnchor||linkElementFocus){return true;}
return false;}
function isLinkDisabled(selection){const blockElements=childNodes(selection.commonAncestorContainer).filter((el)=>isBlock(el)&&el.isContentEditable);return blockElements.length>=1;}
function isSelectionHasLink(selection){return findInSelection(selection,"a")?true:false;}
function isPositionAtEdgeofLink(link,offset){const childNodes=[...link.childNodes];let firstVisibleIndex=childNodes.findIndex(isVisible);firstVisibleIndex=firstVisibleIndex===-1?0:firstVisibleIndex;if(offset<=firstVisibleIndex){return"start";}
let lastVisibleIndex=childNodes.reverse().findIndex(isVisible);lastVisibleIndex=lastVisibleIndex===-1?0:childNodes.length-lastVisibleIndex;if(offset>=lastVisibleIndex){return"end";}
return false;}
async function fetchExternalMetaData(url){try{return await rpc("/html_editor/link_preview_external",{preview_url:url,});}catch{return;}}
async function fetchInternalMetaData(url){const keepLastPromise=new KeepLast();const urlParsed=new URL(url);if(urlParsed.protocol!==window.location.protocol){urlParsed.protocol=window.location.protocol;}
const result=await keepLastPromise.add(fetch(urlParsed)).then((response)=>response.text()).then(async(content)=>{const html_parser=new window.DOMParser();const doc=html_parser.parseFromString(content,"text/html");const internalUrlMetaData=await rpc("/html_editor/link_preview_internal",{preview_url:urlParsed.pathname,});internalUrlMetaData["favicon"]=doc.querySelector("link[rel~='icon']");internalUrlMetaData["ogTitle"]=doc.querySelector("[property='og:title']");internalUrlMetaData["title"]=doc.querySelector("title");return internalUrlMetaData;}).catch((error)=>{if(error instanceof Error){return Promise.reject(error);}});return result;}
async function fetchAttachmentMetaData(url,ormService){try{const urlParsed=new URL(url,window.location.origin);const attachementId=parseInt(urlParsed.pathname.split("/").pop());const[{name,mimetype}]=await ormService.read("ir.attachment",[attachementId],["name","mimetype"]);return{name,mimetype};}catch{return{name:url,mimetype:undefined};}}
const LinkPlugin=__exports.LinkPlugin=class LinkPlugin extends Plugin{static id="link";static dependencies=["dom","history","input","selection","split","lineBreak","overlay","color","feff",];static shared=["createLink","insertLink","getPathAsUrlCommand"];resources={user_commands:[{id:"toggleLinkTools",title:_t("Link"),description:_t("Add a link"),icon:"fa-link",run:this.toggleLinkTools.bind(this),},{id:"toggleLinkToolsButton",title:_t("Button"),description:_t("Add a button"),icon:"fa-link",run:this.toggleLinkTools.bind(this,{type:"primary"}),},{id:"removeLinkFromSelection",title:_t("Remove Link"),icon:"fa-unlink",isAvailable:isSelectionHasLink,run:this.removeLinkFromSelection.bind(this),},],toolbar_groups:[withSequence(40,{id:"link"}),withSequence(30,{id:"image_link",namespace:"image"}),],toolbar_items:[{id:"link",groupId:"link",commandId:"toggleLinkTools",isActive:isLinkActive,isDisabled:isLinkDisabled,},{id:"unlink",groupId:"link",commandId:"removeLinkFromSelection",},{id:"link",groupId:"image_link",commandId:"toggleLinkTools",isActive:isLinkActive,},{id:"unlink",groupId:"image_link",commandId:"removeLinkFromSelection",},],powerbox_categories:withSequence(50,{id:"navigation",name:_t("Navigation")}),powerbox_items:[{categoryId:"navigation",commandId:"toggleLinkTools",},{title:_t("Button"),description:_t("Add a button"),categoryId:"navigation",commandId:"toggleLinkToolsButton",},],power_buttons:{commandId:"toggleLinkTools"},beforeinput_handlers:withSequence(5,this.onBeforeInput.bind(this)),input_handlers:this.onInputDeleteNormalizeLink.bind(this),before_delete_handlers:this.updateCurrentLinkSyncState.bind(this),delete_handlers:this.onInputDeleteNormalizeLink.bind(this),before_paste_handlers:this.updateCurrentLinkSyncState.bind(this),after_paste_handlers:this.onPasteNormalizeLink.bind(this),selectionchange_handlers:this.handleSelectionChange.bind(this),clean_for_save_handlers:({root})=>this.removeEmptyLinks(root),normalize_handlers:this.normalizeLink.bind(this),split_element_block_overrides:this.handleSplitBlock.bind(this),insert_line_break_element_overrides:this.handleInsertLineBreak.bind(this),};setup(){this.overlay=this.dependencies.overlay.createOverlay(LinkPopover,{},{sequence:50});this.addDomListener(this.editable,"click",(ev)=>{const target=closestElement(ev.target,"a");if(target?.isContentEditable){if(ev.ctrlKey||ev.metaKey){window.open(target.href,"_blank");}
ev.preventDefault();this.toggleLinkTools({link:target});}});this.addDomListener(this.editable,"mousedown",()=>{this._isNavigatingByMouse=true;});this.addDomListener(this.editable,"keydown",()=>{delete this._isNavigatingByMouse;});this.removeLinkShortcut=this.services.command.add("Create link",()=>{this.toggleLinkTools();this.dependencies.selection.focusEditable();},{hotkey:"control+k",category:"shortcut_conflict",isAvailable:()=>this.dependencies.selection.getSelectionData().documentSelectionIsInEditable,});this.ignoredClasses=new Set(this.getResource("system_classes"));this.getExternalMetaData=memoize(fetchExternalMetaData);this.getInternalMetaData=memoize(fetchInternalMetaData);this.getAttachmentMetadata=memoize((url)=>fetchAttachmentMetaData(url,this.services.orm));}
destroy(){this.removeLinkShortcut();}
createLink(url,label){const link=this.document.createElement("a");link.setAttribute("href",url);for(const[param,value]of Object.entries(this.config.defaultLinkAttributes||{})){link.setAttribute(param,`${value}`);}
link.innerText=label;return link;}
insertLink(url,label){const selection=this.dependencies.selection.getEditableSelection();let link=closestElement(selection.anchorNode,"a");if(link){link.setAttribute("href",url);link.innerText=label;}else{link=this.createLink(url,label);this.dependencies.dom.insert(link);}
this.dependencies.history.addStep();const linkParent=link.parentElement;const linkOffset=Array.from(linkParent.childNodes).indexOf(link);this.dependencies.selection.setSelection({anchorNode:linkParent,anchorOffset:linkOffset+1},{normalize:false});}
getPathAsUrlCommand(text,url){const pasteAsURLCommand={title:_t("Paste as URL"),description:_t("Create an URL."),icon:"fa-link",run:()=>{this.dependencies.dom.insert(this.createLink(url,text));this.dependencies.history.addStep();},};return pasteAsURLCommand;}
toggleLinkTools({link,type}={}){if(!link){link=this.getOrCreateLink();}
this.linkElement=link;this.type=type;}
normalizeLink(root){for(const anchorEl of selectElements(root,"a")){const{color}=anchorEl.style;const childNodes=[...anchorEl.childNodes];if(color&&childNodes.every((n)=>!isBlock(n))){anchorEl.style.removeProperty("color");const font=selectElements(anchorEl,"font").next().value;if(font&&cleanZWChars(anchorEl.textContent)===font.textContent){continue;}
const newFont=this.document.createElement("font");newFont.append(...childNodes);anchorEl.appendChild(newFont);this.dependencies.color.colorElement(newFont,color,"color");}}}
handleSelectionChange(selectionData){const selection=selectionData.editableSelection;const props={onRemove:()=>{this.removeLink();this.overlay.close();this.dependencies.history.addStep();},onCopy:()=>{this.overlay.close();},onClose:()=>{this.overlay.close();},getInternalMetaData:this.getInternalMetaData,getExternalMetaData:this.getExternalMetaData,getAttachmentMetadata:this.getAttachmentMetadata,recordInfo:this.config.getRecordInfo?.()||{},type:this.type||"",};if(this._isNavigatingByMouse&&selection.isCollapsed&&selectionData.documentSelectionIsInEditable){delete this._isNavigatingByMouse;const{startContainer,startOffset,endContainer,endOffset}=selection;const linkElement=closestElement(startContainer,"a");if(linkElement&&linkElement.textContent.startsWith("\uFEFF")&&linkElement.textContent.endsWith("\uFEFF")){const linkDescendants=descendants(linkElement);const isCursorAtStartOfLink=isZwnbsp(startContainer)?linkDescendants.indexOf(startContainer)===0:startContainer.nodeType===Node.TEXT_NODE&&linkDescendants.indexOf(startContainer)===1&&startOffset===0;const isCursorAtEndOfLink=isZwnbsp(endContainer)?linkDescendants.indexOf(endContainer)===linkDescendants.length-1:endContainer.nodeType===Node.TEXT_NODE&&linkDescendants.indexOf(endContainer)===linkDescendants.length-2&&endOffset===nodeSize(endContainer);if(isCursorAtStartOfLink||isCursorAtEndOfLink){const[targetNode,targetOffset]=isCursorAtStartOfLink?leftPos(linkElement):rightPos(linkElement);this.dependencies.selection.setSelection({anchorNode:targetNode,anchorOffset:isCursorAtStartOfLink?targetOffset-1:targetOffset+1,});return;}}}
if(!selectionData.documentSelectionIsInEditable){const popoverEl=document.querySelector("[data-prevent-closing-overlay=true]");if(popoverEl?.contains(selectionData.documentSelection?.anchorNode)){return;}
this.overlay.close();}else if(!selection.isCollapsed){const selectedNodes=this.dependencies.selection.getSelectedNodes();const imageNode=selectedNodes.find((node)=>node.tagName==="IMG");if(imageNode&&imageNode.parentNode.tagName==="A"){if(this.linkElement!==imageNode.parentElement){this.overlay.close();this.removeCurrentLinkIfEmtpy();}
this.linkElement=imageNode.parentElement;const imageLinkProps={...props,isImage:true,linkEl:this.linkElement,onApply:(url,_)=>{this.linkElement.href=url;this.dependencies.selection.setCursorEnd(this.linkElement);this.dependencies.selection.focusEditable();this.removeCurrentLinkIfEmtpy();this.dependencies.history.addStep();},};if(this.overlay.isOpen){this.overlay.close();}
this.overlay.open({target:imageNode,props:imageLinkProps});}else{this.overlay.close();}}else{const linkEl=closestElement(selection.anchorNode,"A");if(!linkEl){this.overlay.close();this.removeCurrentLinkIfEmtpy();return;}
if(linkEl!==this.linkElement){this.removeCurrentLinkIfEmtpy();this.overlay.close();this.linkElement=linkEl;}
const imageNode=linkEl.querySelector("img");if(imageNode){this.removeCurrentLinkIfEmtpy();this.overlay.close();}
if(linkEl.isConnected){const linkProps={...props,isImage:false,linkEl:this.linkElement,onApply:(url,label,classes)=>{this.linkElement.href=url;if(cleanZWChars(this.linkElement.innerText)===label){this.overlay.close();this.dependencies.selection.setSelection(this.dependencies.selection.getEditableSelection());}else{const restore=prepareUpdate(...leftPos(this.linkElement));this.linkElement.innerText=label;restore();this.overlay.close();this.dependencies.selection.setCursorEnd(this.linkElement);}
if(classes){this.linkElement.className=classes;}else{this.linkElement.removeAttribute("class");}
cleanTrailingBR(closestBlock(this.linkElement));this.dependencies.selection.focusEditable();this.removeCurrentLinkIfEmtpy();this.dependencies.history.addStep();},canEdit:!this.linkElement.classList.contains("o_link_readonly"),canUpload:!this.config.disableFile,onUpload:this.config.onAttachmentChange,};this.overlay.open({target:this.linkElement,props:linkProps});}}}
getOrCreateLink(){const selection=this.dependencies.selection.getEditableSelection();const linkElement=findInSelection(selection,"a");if(linkElement){if(!linkElement.contains(selection.anchorNode)||!linkElement.contains(selection.focusNode)){this.dependencies.split.splitSelection();const selectedNodes=this.dependencies.selection.getSelectedNodes();let before=linkElement.previousSibling;while(before!==null&&selectedNodes.includes(before)){linkElement.insertBefore(before,linkElement.firstChild);before=linkElement.previousSibling;}
let after=linkElement.nextSibling;while(after!==null&&selectedNodes.includes(after)){linkElement.appendChild(after);after=linkElement.nextSibling;}
this.dependencies.selection.setCursorEnd(linkElement);this.dependencies.history.addStep();}
return linkElement;}else{const selectedNodes=this.dependencies.selection.getSelectedNodes();const imageNode=selectedNodes.find((node)=>node.tagName==="IMG");const link=this.document.createElement("a");if(!selection.isCollapsed){const content=this.dependencies.selection.extractContent(selection);link.append(content);link.normalize();}
this.dependencies.dom.insert(link);if(!imageNode){this.dependencies.selection.setCursorEnd(link);}else{this.dependencies.selection.setSelection({anchorNode:link,anchorOffset:0,focusNode:link,focusOffset:nodeSize(link),});}
return link;}}
removeCurrentLinkIfEmtpy(){if(this.linkElement&&cleanZWChars(this.linkElement.innerText)===""&&!this.linkElement.querySelector("img")&&this.linkElement.parentElement?.isContentEditable){this.linkElement.remove();}
if(this.linkElement&&!this.linkElement.href&&!this.linkElement.hasAttribute("t-attf-href")&&!this.linkElement.hasAttribute("t-att-href")){this.removeLink();this.dependencies.history.addStep();}}
removeLink(){const link=this.linkElement;const cursors=this.dependencies.selection.preserveSelection();if(link&&link.isContentEditable){cursors.update(callbacksForCursorUpdate.unwrap(link));unwrapContents(link);}
cursors.restore();this.linkElement=null;}
removeLinkFromSelection(){const selection=this.dependencies.split.splitSelection();let{anchorNode,focusNode,anchorOffset,focusOffset}=selection;const direction=selection.direction;let[startLink,endLink]=[closestElement(anchorNode,"a"),closestElement(focusNode,"a"),];let cursors;if(startLink){cursors=this.dependencies.selection.preserveSelection();this.dependencies.feff.removeFeffs(startLink,cursors);cursors.restore();}
if(endLink&&startLink!==endLink){cursors=this.dependencies.selection.preserveSelection();this.dependencies.feff.removeFeffs(endLink,cursors);cursors.restore();}
({anchorNode,focusNode,anchorOffset,focusOffset}=this.dependencies.selection.getEditableSelection());cursors=this.dependencies.selection.preserveSelection();const selectedNodes=this.dependencies.selection.getSelectedNodes();const selectedImageNodes=selectedNodes.filter((node)=>node.tagName==="IMG");if(selectedImageNodes.length&&startLink&&endLink&&startLink===endLink){for(const imageNode of selectedImageNodes){let imageLink;if(direction===DIRECTIONS.RIGHT){imageLink=this.dependencies.split.splitAroundUntil(imageNode,endLink);}else{imageLink=this.dependencies.split.splitAroundUntil(imageNode,startLink);}
cursors.update(callbacksForCursorUpdate.unwrap(imageLink));unwrapContents(imageLink);[startLink,endLink]=[closestElement(anchorNode,"a"),closestElement(focusNode,"a"),];}
cursors.restore();if(selectedImageNodes.length===1&&selectedImageNodes.length===selectedNodes.length){this.dependencies.history.addStep();return;}}
const startBlock=closestBlock(startLink);const endBlock=closestBlock(endLink);if(startLink&&startLink.isConnected){anchorNode=this.dependencies.split.splitAroundUntil(anchorNode,startLink);anchorOffset=direction===DIRECTIONS.RIGHT?0:nodeSize(anchorNode);this.dependencies.selection.setSelection({anchorNode,anchorOffset,focusNode,focusOffset},{normalize:true});}
if(endLink&&endLink.isConnected){focusNode=this.dependencies.split.splitAroundUntil(focusNode,endLink);focusOffset=direction===DIRECTIONS.RIGHT?nodeSize(focusNode):0;this.dependencies.selection.setSelection({anchorNode,anchorOffset,focusNode,focusOffset},{normalize:true});}
const targetedNodes=this.dependencies.selection.getSelectedNodes();const links=new Set(targetedNodes.map((node)=>closestElement(node,"a")).filter((a)=>a&&a.isContentEditable));if(links.size){for(const link of links){cursors.update(callbacksForCursorUpdate.unwrap(link));unwrapContents(link);}
cursors.restore();}
if(startBlock){this.removeEmptyLinks(startBlock);}
if(endBlock&&endBlock!==startBlock){this.removeEmptyLinks(endBlock);}
this.dependencies.history.addStep();}
removeEmptyLinks(root){const buttonClassRegex=/^(btn|btn-(sm|lg|(?:[a-z0-9_]+-)?(?:primary|secondary))|rounded-circle)$/;for(const link of root.querySelectorAll("a")){if([...link.childNodes].some(isVisible)){continue;}
const classes=[...link.classList].filter((c)=>!this.ignoredClasses.has(c)&&!buttonClassRegex.test(c));const attributes=[...link.attributes].filter((a)=>!["style","href","class"].includes(a.name));if(!classes.length&&!attributes.length&&link.parentElement.isContentEditable){link.remove();}}}
updateCurrentLinkSyncState(){const{anchorNode}=this.dependencies.selection.getEditableSelection();const linkEl=closestElement(anchorNode,"a");if(linkEl&&linkEl.isContentEditable){const label=linkEl.innerText;const url=deduceURLfromText(label,linkEl);const href=linkEl.getAttribute("href");if(url&&(url===href||url+"/"===href||url===deduceURLfromText(href,linkEl))){this.isCurrentLinkInSync=true;}}}
onBeforeInput(ev){if(ev.inputType==="insertParagraph"||ev.inputType==="insertLineBreak"){const nodeForSelectionRestore=this.handleAutomaticLinkInsertion();if(nodeForSelectionRestore){this.dependencies.selection.setCursorStart(nodeForSelectionRestore);this.dependencies.history.addStep();}}
if(ev.inputType==="insertText"&&ev.data===" "){const nodeForSelectionRestore=this.handleAutomaticLinkInsertion();if(nodeForSelectionRestore){this.dependencies.selection.setSelection({anchorNode:nodeForSelectionRestore,anchorOffset:0,});this.dependencies.history.addStep();nodeForSelectionRestore.textContent="\u00A0"+nodeForSelectionRestore.textContent;this.dependencies.selection.setSelection({anchorNode:nodeForSelectionRestore,anchorOffset:1,});this.dependencies.history.addStep();ev.preventDefault();}}
this.updateCurrentLinkSyncState();}
onInputDeleteNormalizeLink(){const{anchorNode}=this.dependencies.selection.getEditableSelection();const linkEl=closestElement(anchorNode,"a");if(linkEl&&linkEl.isContentEditable){const label=linkEl.innerText;const url=deduceURLfromText(label,linkEl);if(url&&this?.isCurrentLinkInSync){linkEl.setAttribute("href",url);this.isCurrentLinkInSync=false;if(this.overlay.isOpen){this.overlay.close();}}}}
onPasteNormalizeLink(){this.updateCurrentLinkSyncState();this.onInputDeleteNormalizeLink();}
handleAutomaticLinkInsertion(){let selection=this.dependencies.selection.getEditableSelection();if(isHtmlContentSupported(selection.anchorNode)&&!closestElement(selection.anchorNode,"a")&&selection.anchorNode.nodeType===Node.TEXT_NODE){selection.anchorNode.parentNode.normalize();selection=this.dependencies.selection.getEditableSelection();const textSliced=selection.anchorNode.textContent.slice(0,selection.anchorOffset);const textNodeSplitted=textSliced.split(/\s/);const potentialUrl=textNodeSplitted.pop();const match=[...potentialUrl.matchAll(new RegExp(URL_REGEX,"g"))].pop();if(match&&!EMAIL_REGEX.test(match[0])){const nodeForSelectionRestore=selection.anchorNode.splitText(selection.anchorOffset);const url=match[2]?match[0]:"http://"+match[0];const startOffset=selection.anchorOffset-potentialUrl.length+match.index;const text=selection.anchorNode.textContent.slice(startOffset,startOffset+match[0].length);const link=this.createLink(url,text);const textNodeToReplace=selection.anchorNode.splitText(startOffset);textNodeToReplace.splitText(match[0].length);selection.anchorNode.parentElement.replaceChild(link,textNodeToReplace);return nodeForSelectionRestore;}}}
handleSplitBlock(params){return this.handleEnterAtEdgeOfLink(params,this.dependencies.split.splitElementBlock);}
handleInsertLineBreak(params){return this.handleEnterAtEdgeOfLink(params,this.dependencies.lineBreak.insertLineBreakElement);}
handleEnterAtEdgeOfLink(params,splitOrLineBreakCallback){let{targetNode,targetOffset,blockToSplit}=params;if(targetNode.tagName!=="A"){return;}
const edge=isPositionAtEdgeofLink(targetNode,targetOffset);if(!edge){return;}
[targetNode,targetOffset]=edge==="start"?leftPos(targetNode):rightPos(targetNode);blockToSplit=targetNode;splitOrLineBreakCallback({...params,targetNode,targetOffset,blockToSplit});return true;}}
__exports.isHtmlContentSupported=isHtmlContentSupported;function isHtmlContentSupported(node){return!closestElement(node,'[data-oe-model]:not([data-oe-field="arch"]):not([data-oe-type="html"]),[data-oe-translation-id]',true);}
return __exports;});;

/* /html_editor/static/src/main/link/link_popover.js */
odoo.define('@html_editor/main/link/link_popover',['@web/core/l10n/translation','@odoo/owl','@web/core/utils/hooks','@web/core/browser/browser','@html_editor/main/link/utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component,useState,onMounted,useRef}=require("@odoo/owl");const{useAutofocus,useService}=require("@web/core/utils/hooks");const{browser}=require("@web/core/browser/browser");const{cleanZWChars,deduceURLfromText}=require("@html_editor/main/link/utils");const LinkPopover=__exports.LinkPopover=class LinkPopover extends Component{static template="html_editor.linkPopover";static props={linkEl:{validate:(el)=>el.nodeType===Node.ELEMENT_NODE},onApply:Function,onRemove:Function,onCopy:Function,onClose:Function,getInternalMetaData:Function,getExternalMetaData:Function,getAttachmentMetadata:Function,isImage:Boolean,type:String,recordInfo:Object,canEdit:{type:Boolean,optional:true},canUpload:{type:Boolean,optional:true},onUpload:{type:Function,optional:true},};static defaultProps={canEdit:true,};colorsData=[{type:"",label:_t("Link"),btnPreview:"link"},{type:"primary",label:_t("Button Primary"),btnPreview:"primary"},{type:"secondary",label:_t("Button Secondary"),btnPreview:"secondary"},{type:"custom",label:_t("Custom"),btnPreview:"custom"},];buttonSizesData=[{size:"sm",label:_t("Small")},{size:"",label:_t("Medium")},{size:"lg",label:_t("Large")},];buttonStylesData=[{style:"fill",label:_t("Fill")},{style:"fill,rounded-circle",label:_t("Fill + Rounded")},{style:"outline",label:_t("Outline")},{style:"outline,rounded-circle",label:_t("Outline + Rounded")},];setup(){this.ui=useService("ui");this.notificationService=useService("notification");this.uploadService=useService("uploadLocalFiles");this.state=useState({editing:this.props.linkEl.href?false:true,url:this.props.linkEl.href||"",label:cleanZWChars(this.props.linkEl.textContent),previewIcon:{type:"fa",value:"fa-globe",},urlTitle:"",urlDescription:"",linkPreviewName:"",imgSrc:"",iconSrc:"",classes:this.props.type==="primary"?"btn btn-primary":this.props.linkEl.className||"",type:this.props.type||this.props.linkEl.className.match(/btn(-[a-z0-9_-]*)(primary|secondary)/)?.pop()||"",buttonSize:this.props.linkEl.className.match(/btn-(sm|lg)/)?.[1]||"",buttonStyle:this.initButtonStyle(this.props.linkEl.className),isImage:this.props.isImage,});this.editingWrapper=useRef("editing-wrapper");useAutofocus({refName:this.state.isImage||this.state.label!==""?"url":"label",mobile:true,});onMounted(()=>{if(!this.state.editing){this.loadAsyncLinkPreview();}});}
initButtonStyle(className){const styleArray=[className.match(/btn-([a-z0-9_]+)-(primary|secondary)/)?.[1],className.match(/rounded-circle/)?.pop(),];return styleArray.every(Boolean)?styleArray.join(","):styleArray.join("")||className.match(/flat/)?.pop()||"";}
onClickApply(){this.state.editing=false;if(this.state.label===""){this.state.label=this.state.url;}
const deducedUrl=this.deduceUrl(this.state.url);this.state.url=deducedUrl?this.correctLink(deducedUrl):this.correctLink(this.state.url);this.loadAsyncLinkPreview();this.props.onApply(this.state.url,this.state.label,this.state.classes);}
onClickEdit(){this.state.editing=true;this.state.url=this.props.linkEl.href;this.state.label=cleanZWChars(this.props.linkEl.textContent);}
async onClickCopy(ev){ev.preventDefault();await browser.navigator.clipboard.writeText(this.props.linkEl.href||"");this.notificationService.add(_t("Link copied to clipboard."),{type:"success",});this.props.onCopy();}
onClickRemove(){this.props.onRemove();}
onKeydownEnter(ev){const isAutoCompleteDropdownOpen=document.querySelector(".o-autocomplete--dropdown-menu");if(ev.key==="Enter"&&!isAutoCompleteDropdownOpen){ev.preventDefault();this.onClickApply();}}
onKeydown(ev){if(ev.key==="Escape"){ev.preventDefault();this.props.onClose();}}
onClickReplaceTitle(){this.state.label=this.state.urlTitle;this.onClickApply();}
correctLink(url){if(url&&!url.startsWith("tel:")&&!url.startsWith("mailto:")&&!url.includes("://")&&!url.startsWith("/")&&!url.startsWith("#")&&!url.startsWith("${")){url="http://"+url;}
return url;}
deduceUrl(text){text=text.trim();if(/^(https?:|mailto:|tel:)/.test(text)){return text;}else{return deduceURLfromText(text,this.props.linkEl)||"";}}
resetPreview(){this.state.previewIcon={type:"fa",value:"fa-globe"};this.state.urlTitle=this.state.url||_t("No URL specified");this.state.urlDescription="";this.state.linkPreviewName="";}
async loadAsyncLinkPreview(){let url;if(this.state.url===""){this.resetPreview();this.state.previewIcon.value="fa-question-circle-o";return;}
if(this.isAttachmentUrl()){const{name,mimetype}=await this.props.getAttachmentMetadata(this.state.url);this.resetPreview();this.state.urlTitle=name;this.state.previewIcon={type:"mimetype",value:mimetype};return;}
try{url=new URL(this.state.url);}catch{this.notificationService.add(_t("This URL is invalid. Preview couldn't be updated."),{type:"danger",});return;}
this.resetPreview();const protocol=url.protocol;if(!protocol.startsWith("http")){const faMap={"mailto:":"fa-envelope-o","tel:":"fa-phone"};const icon=faMap[protocol];if(icon){this.state.previewIcon.value=icon;}}else if(window.location.hostname!==url.hostname){this.state.previewIcon={type:"imgSrc",value:`https://www.google.com/s2/favicons?sz=16&domain=${encodeURIComponent(url)}`,};const externalMetadata=await this.props.getExternalMetaData(this.state.url);this.state.urlTitle=externalMetadata?.og_title||this.state.url;this.state.urlDescription=externalMetadata?.og_description||"";this.state.imgSrc=externalMetadata?.og_image||"";if(externalMetadata?.og_image&&this.state.label&&this.state.urlTitle===this.state.url){this.state.urlTitle=this.state.label;}}else{const internalMetadata=await this.props.getInternalMetaData(this.state.url);if(internalMetadata.favicon){this.state.previewIcon={type:"imgSrc",value:internalMetadata.favicon.href,};}
if(internalMetadata.error_msg){this.notificationService.add(internalMetadata.error_msg,{type:"warning",});}else if(internalMetadata.other_error_msg){console.error("Internal meta data retrieve error for link preview: "+
internalMetadata.other_error_msg);}else{this.state.linkPreviewName=internalMetadata.link_preview_name||internalMetadata.display_name||internalMetadata.name;this.state.urlDescription=internalMetadata?.description||"";this.state.urlTitle=this.state.linkPreviewName?this.state.linkPreviewName:this.state.url;}
if((internalMetadata.ogTitle||internalMetadata.title)&&!this.state.linkPreviewName){this.state.urlTitle=internalMetadata.ogTitle?internalMetadata.ogTitle.getAttribute("content"):internalMetadata.title.text.trim();}}}
onChangeClasses(){const shapes=this.state.buttonStyle?this.state.buttonStyle.split(","):[];const style=["outline","fill"].includes(shapes[0])?`${shapes[0]}-`:"fill-";const shapeClasses=shapes.slice(style?1:0).join(" ");this.state.classes=(this.state.type?`btn btn-${style}${this.state.type}`:"")+
(this.state.type&&shapeClasses?` ${shapeClasses}`:"")+
(this.state.type&&this.state.buttonSize?" btn-"+this.state.buttonSize:"");}
async uploadFile(){const{upload,getURL}=this.uploadService;const{resModel,resId}=this.props.recordInfo;const[attachment]=await upload({resModel,resId,accessToken:true});if(!attachment){return;}
this.props.onUpload?.(attachment);this.state.url=getURL(attachment,{download:true,unique:true,accessToken:true});this.state.label||=attachment.name;}
isAttachmentUrl(){return!!this.state.url.match(/\/web\/content\/\d+/);}}
return __exports;});;

/* /html_editor/static/src/main/link/link_selection_odoo_plugin.js */
odoo.define('@html_editor/main/link/link_selection_odoo_plugin',['@html_editor/plugin','@html_editor/utils/blocks'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{isBlock}=require("@html_editor/utils/blocks");const OdooLinkSelectionPlugin=__exports.OdooLinkSelectionPlugin=class OdooLinkSelectionPlugin extends Plugin{static id="odooLinkSelection";resources={ineligible_link_for_zwnbsp_predicates:[(link)=>[link,...link.querySelectorAll("*")].some((el)=>el.nodeName==="IMG"||isBlock(el)),(link)=>link.matches("nav a, a.nav-link"),],ineligible_link_for_selection_indication_predicates:(link)=>link.matches(".btn"),};}
return __exports;});;

/* /html_editor/static/src/main/link/link_selection_plugin.js */
odoo.define('@html_editor/main/link/link_selection_plugin',['@html_editor/plugin','@html_editor/utils/dom_traversal','@html_editor/utils/dom','@html_editor/utils/dom_info'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{closestElement,selectElements}=require("@html_editor/utils/dom_traversal");const{removeClass}=require("@html_editor/utils/dom");const{isProtected,isProtecting,isZwnbsp}=require("@html_editor/utils/dom_info");const LinkSelectionPlugin=__exports.LinkSelectionPlugin=class LinkSelectionPlugin extends Plugin{static id="linkSelection";static dependencies=["selection","feff"];static shared=["padLinkWithZwnbsp"];resources={selectionchange_handlers:this.resetLinkInSelection.bind(this),clean_for_save_handlers:({root})=>this.clearLinkInSelectionClass(root),normalize_handlers:()=>this.resetLinkInSelection(),feff_providers:this.addFeffsToLinks.bind(this),system_classes:["o_link_in_selection"],};addFeffsToLinks(root,cursors){return[...selectElements(root,"a")].filter(this.isLinkEligibleForZwnbsp.bind(this)).flatMap((link)=>this.addFeffs(link,cursors));}
addFeffs(link,cursors){const addFeff=(position)=>{const c=position==="append"?null:cursors;return this.dependencies.feff.addFeff(link,position,c);};const zwnbspNodes=[];for(const[position,relation]of[["before","previousSibling"],["after","nextSibling"],["prepend","firstChild"],["append","lastChild"],]){const candidate=link[relation];const feff=isZwnbsp(candidate)?candidate:addFeff(position);zwnbspNodes.push(feff);}
return zwnbspNodes;}
padLinkWithZwnbsp(link){const cursors=this.dependencies.selection.preserveSelection();this.addFeffs(link,cursors);cursors.restore();}
isLinkEligibleForZwnbsp(link){return(link.isContentEditable&&link.parentElement.isContentEditable&&this.editable.contains(link)&&!isProtected(link)&&!isProtecting(link)&&!this.getResource("ineligible_link_for_zwnbsp_predicates").some((p)=>p(link)));}
isLinkEligibleForVisualIndication(link){return(this.isLinkEligibleForZwnbsp(link)&&!this.getResource("ineligible_link_for_selection_indication_predicates").some((predicate)=>predicate(link)));}
resetLinkInSelection(selectionData=this.dependencies.selection.getSelectionData()){this.clearLinkInSelectionClass(this.editable);const{anchorNode,focusNode}=selectionData.editableSelection;const[anchorLink,focusLink]=[anchorNode,focusNode].map((node)=>closestElement(node,"a"));const singleLinkInSelection=anchorLink===focusLink&&anchorLink;if(singleLinkInSelection&&this.isLinkEligibleForVisualIndication(singleLinkInSelection)){singleLinkInSelection.classList.add("o_link_in_selection");}}
clearLinkInSelectionClass(root){for(const link of selectElements(root,".o_link_in_selection")){removeClass(link,"o_link_in_selection");}}
normalize(root){this.updateFEFFs(root);this.resetLinkInSelection();}
cleanForSave({root,preserveSelection=false}){this.removeFEFFs(root,{preserveSelection});this.clearLinkInSelectionClass(root);}
updateFEFFs(root){this.dependencies.feff.updateFeffs(root);}
removeFEFFs(root,{exclude=()=>false,preserveSelection=true}={}){const cursors=preserveSelection?this.dependencies.selection.preserveSelection():null;this.dependencies.feff.removeFeffs(root,cursors,{exclude});cursors?.restore();}}
return __exports;});;

/* /html_editor/static/src/main/link/utils.js */
odoo.define('@html_editor/main/link/utils',[],function(require){'use strict';let __exports={};const tldWhitelist=["com","net","org","ac","ad","ae","af","ag","ai","al","am","an","ao","aq","ar","as","at","au","aw","ax","az","ba","bb","bd","be","bf","bg","bh","bi","bj","bl","bm","bn","bo","br","bq","bs","bt","bv","bw","by","bz","ca","cc","cd","cf","cg","ch","ci","ck","cl","cm","cn","co","cr","cs","cu","cv","cw","cx","cy","cz","dd","de","dj","dk","dm","do","dz","ec","ee","eg","eh","er","es","et","eu","fi","fj","fk","fm","fo","fr","ga","gb","gd","ge","gf","gg","gh","gi","gl","gm","gn","gp","gq","gr","gs","gt","gu","gw","gy","hk","hm","hn","hr","ht","hu","id","ie","il","im","in","io","iq","ir","is","it","je","jm","jo","jp","ke","kg","kh","ki","km","kn","kp","kr","kw","ky","kz","la","lb","lc","li","lk","lr","ls","lt","lu","lv","ly","ma","mc","md","me","mf","mg","mh","mk","ml","mm","mn","mo","mp","mq","mr","ms","mt","mu","mv","mw","mx","my","mz","na","nc","ne","nf","ng","ni","nl","no","np","nr","nu","nz","om","pa","pe","pf","pg","ph","pk","pl","pm","pn","pr","ps","pt","pw","py","qa","re","ro","rs","ru","rw","sa","sb","sc","sd","se","sg","sh","si","sj","sk","sl","sm","sn","so","sr","ss","st","su","sv","sx","sy","sz","tc","td","tf","tg","th","tj","tk","tl","tm","tn","to","tp","tr","tt","tv","tw","tz","ua","ug","uk","um","us","uy","uz","va","vc","ve","vg","vi","vn","vu","wf","ws","ye","yt","yu","za","zm","zr","zw","co\\.uk"];const urlRegexBase=`|(?:www.))[-a-zA-Z0-9@:%._\\+~#=]{2,256}\\.[a-zA-Z][a-zA-Z0-9]{1,62}|(?:[-a-zA-Z0-9@:%._\\+~#=]{2,256}\\.(?:${tldWhitelist.join(
    "|"
)})\\b))(?:(?:[/?#])[^\\s]*[^!.,})\\]'"\\s]|(?:[^!(){}.,[\\]'"\\s]+))?`;const httpCapturedRegex=`(https?:\\/\\/)`;const URL_REGEX=__exports.URL_REGEX=new RegExp(`((?:(?:${httpCapturedRegex}${urlRegexBase})`,"i");const EMAIL_REGEX=__exports.EMAIL_REGEX=/^(mailto:)?[\w-.]+@(?:[\w-]+\.)+[\w-]{2,4}$/i;const PHONE_REGEX=__exports.PHONE_REGEX=/^(tel:(?:\/\/)?)?\+?[\d\s.\-()/]{3,25}$/;__exports.cleanZWChars=cleanZWChars;function cleanZWChars(text){return text.replace(/\u200B|\uFEFF/g,"");}
__exports.deduceURLfromText=deduceURLfromText;function deduceURLfromText(text,link){const label=cleanZWChars(text).trim();let match=label.match(EMAIL_REGEX);if(match){return match[1]?match[0]:"mailto:"+match[0];}
match=label.match(URL_REGEX);if(match&&match[0]===label){const currentHttpProtocol=(link?.href.match(/^http(s)?:\/\//gi)||[])[0];if(match[2]){return match[0];}else if(currentHttpProtocol){return currentHttpProtocol+match[0];}else{return"http://"+match[0];}}
match=label.match(PHONE_REGEX);if(match){return(match[1]?match[0]:"tel:"+match[0]).replace(/\s+/g,"");}
return null;}
return __exports;});;

/* /html_editor/static/src/main/list/list_plugin.js */
odoo.define('@html_editor/main/list/list_plugin',['@html_editor/plugin','@html_editor/utils/blocks','@html_editor/utils/dom','@html_editor/utils/dom_info','@html_editor/utils/dom_traversal','@html_editor/utils/position','@html_editor/utils/dom_state','@web/core/l10n/translation','@html_editor/main/list/utils','@html_editor/utils/selection','@html_editor/utils/resource','@html_editor/utils/base_container'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{closestBlock,isBlock}=require("@html_editor/utils/blocks");const{removeClass,toggleClass,wrapInlinesInBlocks}=require("@html_editor/utils/dom");const{getDeepestPosition,isEmptyBlock,isListElement,isListItemElement,isParagraphRelatedElement,isProtected,isProtecting,listElementSelector,}=require("@html_editor/utils/dom_info");const{closestElement,descendants,getAdjacents,selectElements,ancestors,childNodes,}=require("@html_editor/utils/dom_traversal");const{childNodeIndex}=require("@html_editor/utils/position");const{leftLeafOnlyNotBlockPath}=require("@html_editor/utils/dom_state");const{_t}=require("@web/core/l10n/translation");const{compareListTypes,createList,insertListAfter,isListItem}=require("@html_editor/main/list/utils");const{callbacksForCursorUpdate}=require("@html_editor/utils/selection");const{withSequence}=require("@html_editor/utils/resource");const{baseContainerGlobalSelector}=require("@html_editor/utils/base_container");const ListPlugin=__exports.ListPlugin=class ListPlugin extends Plugin{static id="list";static dependencies=["baseContainer","tabulation","history","input","split","selection","delete","dom",];resources={user_commands:[{id:"toggleList",run:this.toggleListCommand.bind(this),},{id:"toggleListUL",title:_t("Bulleted list"),description:_t("Create a simple bulleted list"),icon:"fa-list-ul",run:()=>this.toggleListCommand({mode:"UL"}),},{id:"toggleListOL",title:_t("Numbered list"),description:_t("Create a list with numbering"),icon:"fa-list-ol",run:()=>this.toggleListCommand({mode:"OL"}),},{id:"toggleListCL",title:_t("Checklist"),description:_t("Track tasks with a checklist"),icon:"fa-check-square-o",run:()=>this.toggleListCommand({mode:"CL"}),},],toolbar_groups:withSequence(30,{id:"list"}),toolbar_items:[{id:"bulleted_list",groupId:"list",commandId:"toggleListUL",isActive:this.isListActive("UL"),},{id:"numbered_list",groupId:"list",commandId:"toggleListOL",isActive:this.isListActive("OL"),},{id:"checklist",groupId:"list",commandId:"toggleListCL",isActive:this.isListActive("CL"),},],powerbox_items:[{categoryId:"structure",commandId:"toggleListUL",},{categoryId:"structure",commandId:"toggleListOL",},{categoryId:"structure",commandId:"toggleListCL",},],power_buttons:[{commandId:"toggleListUL"},{commandId:"toggleListOL"},{commandId:"toggleListCL"},],hints:[{selector:"LI",text:_t("List")}],input_handlers:this.onInput.bind(this),normalize_handlers:this.normalize.bind(this),delete_backward_overrides:this.handleDeleteBackward.bind(this),delete_range_overrides:this.handleDeleteRange.bind(this),tab_overrides:this.handleTab.bind(this),shift_tab_overrides:this.handleShiftTab.bind(this),split_element_block_overrides:this.handleSplitBlock.bind(this),node_to_insert_processors:this.processNodeToInsert.bind(this),};setup(){this.addDomListener(this.editable,"touchstart",this.onPointerdown);this.addDomListener(this.editable,"mousedown",this.onPointerdown);}
toggleListCommand({mode}={}){this.toggleList(mode);this.dependencies.history.addStep();}
onInput(ev){if(ev.data!==" "){return;}
const selection=this.dependencies.selection.getEditableSelection();const blockEl=closestBlock(selection.anchorNode);const leftDOMPath=leftLeafOnlyNotBlockPath(selection.anchorNode);let spaceOffset=selection.anchorOffset;let leftLeaf=leftDOMPath.next().value;while(leftLeaf){spaceOffset+=leftLeaf.length;leftLeaf=leftDOMPath.next().value;}
const stringToConvert=blockEl.textContent.substring(0,spaceOffset);const shouldCreateNumberList=/^(?:[1aA])[.)]\s$/.test(stringToConvert);const shouldCreateBulletList=/^[-*]\s$/.test(stringToConvert);const shouldCreateCheckList=/^\[\]\s$/.test(stringToConvert);if((shouldCreateNumberList||shouldCreateBulletList||shouldCreateCheckList)&&!closestElement(selection.anchorNode,"li")){this.dependencies.selection.setSelection({anchorNode:blockEl.firstChild,anchorOffset:0,focusNode:selection.focusNode,focusOffset:selection.focusOffset,});this.dependencies.delete.deleteSelection();if(shouldCreateNumberList){const listStyle={a:"lower-alpha",A:"upper-alpha",1:null}[stringToConvert.substring(0,1)];this.toggleList("OL",listStyle);}else if(shouldCreateBulletList){this.toggleList("UL");}else if(shouldCreateCheckList){this.toggleList("CL");}
this.dependencies.history.addStep();}}
toggleList(mode,listStyle){if(!["UL","OL","CL"].includes(mode)){throw new Error(`Invalid list type: ${mode}`);}
if(mode==="CL"&&!!listStyle){throw new Error(`listStyle is not compatible with "CL" list type`);}
const traversedBlocks=this.dependencies.selection.getTraversedBlocks();for(const block of traversedBlocks){if(descendants(block).some((descendant)=>traversedBlocks.has(descendant))){traversedBlocks.delete(block);}}
const sameModeListItems=new Set();const nonListBlocks=new Set();const listsToSwitch=new Set();for(const block of traversedBlocks){if(["OL","UL"].includes(block.tagName)||!block.isContentEditable){continue;}
const li=closestElement(block,isListItem);if(li){if(this.getListMode(li.parentElement)===mode){sameModeListItems.add(li);}else{listsToSwitch.add(li.parentElement);}}else{nonListBlocks.add(block);}}
if(listsToSwitch.size||nonListBlocks.size){for(const list of listsToSwitch){const cursors=this.dependencies.selection.preserveSelection();const newList=this.switchListMode(list,mode);cursors.remapNode(list,newList).restore();}
for(const block of nonListBlocks){const list=this.blockToList(block,mode,listStyle);if(listStyle){list.style.listStyle=listStyle;}}}else{for(const li of sameModeListItems){this.liToBlocks(li);}}}
normalize(root=this.editable){const closestNestedLI=closestElement(root,"li.oe-nested");if(closestNestedLI){root=closestNestedLI.parentElement;}
for(const element of selectElements(root,"ul, ol, li")){if(isProtected(element)||isProtecting(element)){continue;}
for(const fn of[this.liWithoutParentToP,this.mergeSimilarLists,this.normalizeLI,this.normalizeNestedList,]){fn.call(this,element);}}}
blockToList(element,mode){if(element.matches(baseContainerGlobalSelector)){return this.baseContainerToList(element,mode);}
if(element.matches("td, th, li.nav-item")){return this.blockContentsToList(element,mode);}
let list;const cursors=this.dependencies.selection.preserveSelection();if(element===this.editable){const callingNode=element.firstChild;const group=getAdjacents(callingNode,(n)=>!isBlock(n));list=insertListAfter(this.document,callingNode,mode,[group]);}else{const parent=element.parentNode;const childIndex=childNodeIndex(element);list=insertListAfter(this.document,element,mode,[element]);cursors.update((cursor)=>{if(cursor.node===parent){if(cursor.offset===childIndex){[cursor.node,cursor.offset]=[list.firstChild,0];}else if(cursor.offset===childIndex+1){[cursor.node,cursor.offset]=[list.firstChild,1];}}});if(element.hasAttribute("dir")){list.setAttribute("dir",element.getAttribute("dir"));}}
cursors.restore();return list;}
baseContainerToList(baseContainer,mode){const cursors=this.dependencies.selection.preserveSelection();const list=insertListAfter(this.document,baseContainer,mode,[childNodes(baseContainer),]);this.dependencies.dom.copyAttributes(baseContainer,list);baseContainer.remove();cursors.remapNode(baseContainer,list.firstChild).restore();return list;}
blockContentsToList(block,mode){const cursors=this.dependencies.selection.preserveSelection();const list=insertListAfter(this.document,block.lastChild,mode,[[...block.childNodes]]);cursors.remapNode(block,list.firstChild).restore();return list;}
convertList(node,newMode){if(!["UL","OL","LI"].includes(node.tagName)){return;}
const listMode=this.getListMode(node);if(listMode&&newMode!==listMode){node=this.switchListMode(node,newMode);}
for(const child of node.children){this.convertList(child,newMode);}
return node;}
getListMode(listContainerEl){if(!["UL","OL"].includes(listContainerEl.tagName)){return;}
if(listContainerEl.tagName==="OL"){return"OL";}
return listContainerEl.classList.contains("o_checklist")?"CL":"UL";}
isListActive(listMode){return(selection)=>{const block=closestBlock(selection.anchorNode);return block?.tagName==="LI"&&this.getListMode(block.parentNode)===listMode;};}
switchListMode(list,newMode){if(this.getListMode(list)===newMode){return;}
const newTag=newMode==="CL"?"UL":newMode;const newList=this.dependencies.dom.setTagName(list,newTag);newList.style.removeProperty("list-style");for(const li of newList.children){if(li.style.listStyle!=="none"){li.style.listStyle=null;if(!li.style.all){li.removeAttribute("style");}}}
removeClass(newList,"o_checklist");if(newMode==="CL"){newList.classList.add("o_checklist");}
return newList;}
liToBlocks(li){while(li){li=this.outdentLI(li);}}
liWithoutParentToP(element){const isOrphan=element.nodeName==="LI"&&!element.closest("ul, ol");if(!isOrphan){return;}
const paragraph=this.dependencies.baseContainer.createBaseContainer();element.replaceWith(paragraph);paragraph.replaceChildren(...element.childNodes);}
mergeSimilarLists(element){if(!element.matches("ul, ol, li.oe-nested")){return;}
const previousSibling=element.previousElementSibling;if(previousSibling&&element.isContentEditable&&previousSibling.isContentEditable&&compareListTypes(previousSibling,element)){const cursors=this.dependencies.selection.preserveSelection();cursors.update(callbacksForCursorUpdate.merge(element));previousSibling.append(...element.childNodes);element.remove();cursors.restore();}}
normalizeLI(element){if(!isListItem(element)||element.classList.contains("oe-nested")){return;}
if([...element.children].some((child)=>isBlock(child)&&!this.dependencies.split.isUnsplittable(child))){const cursors=this.dependencies.selection.preserveSelection();wrapInlinesInBlocks(element,{baseContainerNodeName:this.dependencies.baseContainer.getDefaultNodeName(),cursors,});cursors.restore();}}
normalizeNestedList(element){if(element.tagName==="LI"){return;}
if(["UL","OL"].includes(element.parentElement?.tagName)){const cursors=this.dependencies.selection.preserveSelection();const li=this.document.createElement("li");element.parentElement.insertBefore(li,element);li.appendChild(element);li.classList.add("oe-nested");cursors.restore();}}
indentLI(li){const lip=this.document.createElement("li");const parentLi=li.parentElement;const nextSiblingLi=li.nextSibling;lip.classList.add("oe-nested");const destul=li.previousElementSibling?.querySelector("ol, ul")||li.nextElementSibling?.querySelector("ol, ul")||li.closest("ol, ul");const cursors=this.dependencies.selection.preserveSelection();parentLi.removeChild(li);const ul=createList(this.document,this.getListMode(destul));lip.append(ul);li.before(lip);ul.append(li);parentLi.insertBefore(lip,nextSiblingLi);cursors.update((cursor)=>{if(cursor.node===lip.parentNode){const childIndex=childNodeIndex(lip);if(cursor.offset===childIndex){[cursor.node,cursor.offset]=[ul,0];}else if(cursor.offset===childIndex+1){[cursor.node,cursor.offset]=[ul,1];}}});cursors.restore();}
outdentLI(li){if(li.nextElementSibling){this.splitList(li.nextElementSibling);}
if(isListItem(li.parentNode.parentNode)){this.outdentNestedLI(li);return li;}
this.outdentTopLevelLI(li);return null;}
splitList(li){const cursors=this.dependencies.selection.preserveSelection();const currentList=li.parentElement;const newList=currentList.cloneNode(false);if(isListItem(li.parentNode.parentNode)){const lip=this.document.createElement("li");lip.classList.add("oe-nested");lip.append(newList);cursors.update(callbacksForCursorUpdate.after(li.parentNode.parentNode,lip));li.parentNode.parentNode.after(lip);}else{cursors.update(callbacksForCursorUpdate.after(li.parentNode,newList));li.parentNode.after(newList);}
while(li.nextSibling){cursors.update(callbacksForCursorUpdate.append(newList,li.nextSibling));newList.append(li.nextSibling);}
cursors.update(callbacksForCursorUpdate.prepend(newList,li));newList.prepend(li);cursors.restore();return newList;}
outdentNestedLI(li){const cursors=this.dependencies.selection.preserveSelection();const ul=li.parentNode;const lip=ul.parentNode;cursors.update(callbacksForCursorUpdate.after(lip,li));lip.after(li);if(!ul.children.length){cursors.update(callbacksForCursorUpdate.remove(ul));ul.remove();}
if(!lip.children.length&&lip.classList.contains("oe-nested")){cursors.update(callbacksForCursorUpdate.remove(lip));lip.remove();}
cursors.restore();}
outdentTopLevelLI(li){const cursors=this.dependencies.selection.preserveSelection();const ul=li.parentNode;const dir=ul.getAttribute("dir");const textAlign=ul.style.getPropertyValue("text-align");wrapInlinesInBlocks(li,{baseContainerNodeName:this.dependencies.baseContainer.getDefaultNodeName(),cursors,});if(!li.hasChildNodes()){const baseContainer=this.dependencies.baseContainer.createBaseContainer();baseContainer.append(this.document.createElement("br"));li.append(baseContainer);cursors.remapNode(li,baseContainer);}
for(const block of childNodes(li).reverse()){if(dir&&!block.getAttribute("dir")){block.setAttribute("dir",dir);}
if(textAlign&&!block.style.getPropertyValue("text-align")){block.style.setProperty("text-align",textAlign);}
cursors.update(callbacksForCursorUpdate.after(ul,block));ul.after(block);}
cursors.update(callbacksForCursorUpdate.remove(li));li.remove();if(!ul.firstElementChild){cursors.update(callbacksForCursorUpdate.remove(ul));ul.remove();}
cursors.restore();}
indentListNodes(listNodes){for(const li of listNodes){this.indentLI(li);}}
outdentListNodes(listNodes){for(const li of listNodes){this.outdentLI(li);}}
separateListItems(){const listItems=new Set();const navListItems=new Set();const nonListItems=[];for(const block of this.dependencies.selection.getTraversedBlocks()){const closestLI=block.closest("li");if(closestLI){if(closestLI.classList.contains("nav-item")){navListItems.add(closestLI);}else if(!closestLI.querySelector("li")&&closestLI.isContentEditable){listItems.add(closestLI);}}else if(!["UL","OL"].includes(block.tagName)){nonListItems.push(block);}}
return{listItems:[...listItems],navListItems:[...navListItems],nonListItems};}
processNodeToInsert({nodeToInsert,container}){if(isListItemElement(container)&&isParagraphRelatedElement(nodeToInsert)){nodeToInsert=this.dependencies.dom.setTagName(nodeToInsert,"LI");}
const listEl=container&&closestElement(container,listElementSelector);if(!listEl){return nodeToInsert;}
const mode=container&&this.getListMode(listEl);if(isListItemElement(nodeToInsert)&&nodeToInsert.classList.contains("oe-nested")){return this.convertList(nodeToInsert,mode);}
if(isListElement(nodeToInsert)){return this.convertList(nodeToInsert,this.getListMode(nodeToInsert));}
return nodeToInsert;}
handleTab(){const selection=this.dependencies.selection.getEditableSelection();const closestLI=closestElement(selection.anchorNode,"LI");if(closestLI){const block=closestBlock(selection.anchorNode);const isLiContainsUnSpittable=isParagraphRelatedElement(block)&&ancestors(block,closestLI).find((node)=>this.dependencies.split.isUnsplittable(node));if(isLiContainsUnSpittable){return;}}
const{listItems,navListItems,nonListItems}=this.separateListItems();if(listItems.length||navListItems.length){this.indentListNodes(listItems);this.dependencies.tabulation.indentBlocks(nonListItems);this.dependencies.history.addStep();return true;}}
handleShiftTab(){const selection=this.dependencies.selection.getEditableSelection();const closestLI=closestElement(selection.anchorNode,"LI");if(closestLI){const block=closestBlock(selection.anchorNode);const isLiContainsUnSpittable=isParagraphRelatedElement(block)&&ancestors(block,closestLI).find((node)=>this.dependencies.split.isUnsplittable(node));if(isLiContainsUnSpittable){return;}}
const{listItems,navListItems,nonListItems}=this.separateListItems();if(listItems.length||navListItems.length){this.outdentListNodes(listItems);this.dependencies.tabulation.outdentBlocks(nonListItems);this.dependencies.history.addStep();return true;}}
handleSplitBlock(params){const closestLI=closestElement(params.targetNode,"LI");const isBlockUnsplittable=closestLI&&Array.from(closestLI.childNodes).some((node)=>isBlock(node)&&this.dependencies.split.isUnsplittable(node));if(!closestLI||isBlockUnsplittable){return;}
if(isEmptyBlock(closestLI)){this.outdentLI(closestLI);return true;}
const[,newLI]=this.dependencies.split.splitElementBlock({...params,blockToSplit:closestLI,});if(closestLI.classList.contains("o_checked")){removeClass(newLI,"o_checked");}
const[anchorNode,anchorOffset]=getDeepestPosition(newLI,0);this.dependencies.selection.setSelection({anchorNode,anchorOffset});return true;}
handleDeleteBackward(range){const{startContainer,startOffset,endContainer,endOffset}=range;const closestLIendContainer=closestElement(endContainer,"LI");if(!closestLIendContainer){return;}
const isCursorAtStartofLI=(startContainer===endContainer&&startOffset===endOffset)||closestElement(startContainer,"LI")!==closestLIendContainer;if(!isCursorAtStartofLI){return;}
let element=closestLIendContainer;while(["LI","UL","OL"].includes(element.tagName)){if(this.dependencies.split.isUnsplittable(element)){return;}
element=element.parentElement;}
this.liToBlocks(closestLIendContainer);return true;}
handleDeleteRange(range){const{startContainer,endContainer}=range;const startCheckedLi=closestElement(startContainer,"li.o_checked");if(!startCheckedLi){return;}
const endLi=closestElement(endContainer,"li");if(startCheckedLi===endLi){return;}
range=this.dependencies.delete.deleteRange(range);this.dependencies.selection.setSelection({anchorNode:range.startContainer,anchorOffset:range.startOffset,});if(isEmptyBlock(startCheckedLi)){removeClass(startCheckedLi,"o_checked");}
return true;}
onPointerdown(ev){const node=ev.target;const isChecklistItem=node.tagName=="LI"&&this.getListMode(node.parentElement)=="CL";if(!isChecklistItem){return;}
let offsetX=ev.offsetX;let offsetY=ev.offsetY;if(ev.type==="touchstart"){const rect=node.getBoundingClientRect();offsetX=ev.touches[0].clientX-rect.x;offsetY=ev.touches[0].clientY-rect.y;}
if(isChecklistItem&&this.isPointerInsideCheckbox(node,offsetX,offsetY)){toggleClass(node,"o_checked");ev.preventDefault();this.dependencies.history.addStep();}}
isPointerInsideCheckbox(li,pointerOffsetX,pointerOffsetY){const beforeStyle=this.document.defaultView.getComputedStyle(li,":before");const checkboxPosition={left:parseInt(beforeStyle.left),top:parseInt(beforeStyle.top),};checkboxPosition.right=checkboxPosition.left+parseInt(beforeStyle.width);checkboxPosition.bottom=checkboxPosition.top+parseInt(beforeStyle.height);return(pointerOffsetX>=checkboxPosition.left&&pointerOffsetX<=checkboxPosition.right&&pointerOffsetY>=checkboxPosition.top&&pointerOffsetY<=checkboxPosition.bottom);}}
return __exports;});;

/* /html_editor/static/src/main/list/utils.js */
odoo.define('@html_editor/main/list/utils',[],function(require){'use strict';let __exports={};__exports.createList=createList;function createList(document,mode){const node=document.createElement(mode==="OL"?"OL":"UL");if(mode==="CL"){node.classList.add("o_checklist");}
return node;}
__exports.insertListAfter=insertListAfter;function insertListAfter(document,afterNode,mode,content=[]){const list=createList(document,mode);afterNode.after(list);list.append(...content.map((c)=>{const li=document.createElement("LI");li.append(...[].concat(c));return li;}));return list;}
__exports.compareListTypes=compareListTypes;function compareListTypes(a,b){if(!a||!b||a.tagName!==b.tagName){return false;}
if(a.classList.contains("o_checklist")!==b.classList.contains("o_checklist")){return false;}
if(a.tagName==="LI"){if(a.classList.contains("oe-nested")!==b.classList.contains("oe-nested")){return false;}
return compareListTypes(a.firstElementChild,b.firstElementChild);}
return true;}
__exports.isListItem=isListItem;function isListItem(node){return node.nodeName==="LI"&&!node.classList.contains("nav-item");}
return __exports;});;

/* /html_editor/static/src/main/local_overlay_plugin.js */
odoo.define('@html_editor/main/local_overlay_plugin',['@html_editor/plugin'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const LocalOverlayPlugin=__exports.LocalOverlayPlugin=class LocalOverlayPlugin extends Plugin{static id="localOverlay";static shared=["makeLocalOverlay"];setup(){this.localOverlayContainer=this.config.localOverlayContainers?.ref.el;}
makeLocalOverlay(containerId){const container=this.document.createElement("div");container.className=`oe-local-overlay`;container.setAttribute("data-oe-local-overlay-id",containerId);if(this.localOverlayContainer){this.localOverlayContainer.append(container);}
return container;}}
return __exports;});;

/* /html_editor/static/src/main/media/file_plugin.js */
odoo.define('@html_editor/main/media/file_plugin',['@html_editor/main/media/media_dialog/document_selector','@html_editor/plugin','@html_editor/utils/resource','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{DocumentSelector,renderStaticFileBox,}=require("@html_editor/main/media/media_dialog/document_selector");const{Plugin}=require("@html_editor/plugin");const{withSequence}=require("@html_editor/utils/resource");const{_t}=require("@web/core/l10n/translation");const FilePlugin=__exports.FilePlugin=class FilePlugin extends Plugin{static id="file";static dependencies=["dom","history"];resources={user_commands:{id:"uploadFile",title:_t("Upload a file"),description:_t("Add a download box"),icon:"fa-upload",run:this.uploadAndInsertFiles.bind(this),isAvailable:this.isUploadCommandAvailable.bind(this),},powerbox_items:{categoryId:"media",commandId:"uploadFile",keywords:[_t("file"),_t("document")],},power_buttons:withSequence(5,{commandId:"uploadFile"}),unsplittable_node_predicates:(node)=>node.classList?.contains("o_file_box"),...(!this.config.disableFile&&{media_dialog_extra_tabs:{id:"DOCUMENTS",title:_t("Documents"),Component:this.componentForMediaDialog,sequence:15,},}),selectors_for_feff_providers:()=>".o_file_box",};get recordInfo(){return this.config.getRecordInfo?.()||{};}
isUploadCommandAvailable(){return!this.config.disableFile;}
get componentForMediaDialog(){return DocumentSelector;}
async uploadAndInsertFiles(){const attachments=await this.services.uploadLocalFiles.upload(this.recordInfo,{multiple:true,accessToken:true,});if(!attachments.length){this.editable.focus();return;}
if(this.config.onAttachmentChange){attachments.forEach(this.config.onAttachmentChange);}
const fileCards=attachments.map(this.renderDownloadBox.bind(this));fileCards.forEach(this.dependencies.dom.insert);this.dependencies.history.addStep();}
renderDownloadBox(attachment){const url=this.services.uploadLocalFiles.getURL(attachment,{download:true,unique:true,accessToken:true,});const{name:filename,mimetype}=attachment;return renderStaticFileBox(filename,mimetype,url);}}
return __exports;});;

/* /html_editor/static/src/main/media/icon_plugin.js */
odoo.define('@html_editor/main/media/icon_plugin',['@html_editor/utils/resource','@html_editor/plugin','@web/core/l10n/translation','@html_editor/main/font/color_selector'],function(require){'use strict';let __exports={};const{withSequence}=require("@html_editor/utils/resource");const{Plugin}=require("@html_editor/plugin");const{_t}=require("@web/core/l10n/translation");const{ColorSelector}=require("@html_editor/main/font/color_selector");const IconPlugin=__exports.IconPlugin=class IconPlugin extends Plugin{static id="icon";static dependencies=["history","selection","color"];resources={user_commands:[{id:"resizeIcon1",title:_t("Icon size 1x"),run:()=>this.resizeIcon({size:"1"}),},{id:"resizeIcon2",title:_t("Icon size 2x"),run:()=>this.resizeIcon({size:"2"}),},{id:"resizeIcon3",title:_t("Icon size 3x"),run:()=>this.resizeIcon({size:"3"}),},{id:"resizeIcon4",title:_t("Icon size 4x"),run:()=>this.resizeIcon({size:"4"}),},{id:"resizeIcon5",title:_t("Icon size 5x"),run:()=>this.resizeIcon({size:"5"}),},{id:"toggleSpinIcon",title:_t("Toggle icon spin"),icon:"fa-play",run:this.toggleSpinIcon.bind(this),},],toolbar_namespaces:[{id:"icon",isApplied:(traversedNodes)=>traversedNodes.every((node)=>node.classList?.contains("fa")||node.parentElement.classList.contains("fa")||(node.querySelector?.(".fa")&&node.isContentEditable!==false)),},],toolbar_groups:[withSequence(1,{id:"icon_color",namespace:"icon",}),withSequence(1,{id:"icon_size",namespace:"icon",}),withSequence(3,{id:"icon_spin",namespace:"icon"}),],toolbar_items:[{id:"icon_forecolor",groupId:"icon_color",title:_t("Font Color"),Component:ColorSelector,props:this.dependencies.color.getPropsForColorSelector("foreground"),},{id:"icon_backcolor",groupId:"icon_color",title:_t("Background Color"),Component:ColorSelector,props:this.dependencies.color.getPropsForColorSelector("background"),},{id:"icon_size_1",groupId:"icon_size",commandId:"resizeIcon1",text:"1x",isActive:()=>this.hasIconSize("1"),},{id:"icon_size_2",groupId:"icon_size",commandId:"resizeIcon2",text:"2x",isActive:()=>this.hasIconSize("2"),},{id:"icon_size_3",groupId:"icon_size",commandId:"resizeIcon3",text:"3x",isActive:()=>this.hasIconSize("3"),},{id:"icon_size_4",groupId:"icon_size",commandId:"resizeIcon4",text:"4x",isActive:()=>this.hasIconSize("4"),},{id:"icon_size_5",groupId:"icon_size",commandId:"resizeIcon5",text:"5x",isActive:()=>this.hasIconSize("5"),},{id:"icon_spin",groupId:"icon_spin",commandId:"toggleSpinIcon",isActive:()=>this.hasSpinIcon(),},],color_apply_overrides:this.applyIconColor.bind(this),};getSelectedIcon(){const selectedNodes=this.dependencies.selection.getSelectedNodes();return selectedNodes.find((node)=>node.classList?.contains?.("fa"));}
resizeIcon({size}){const selectedIcon=this.getSelectedIcon();if(!selectedIcon){return;}
for(const classString of selectedIcon.classList){if(classString.match(/^fa-[2-5]x$/)){selectedIcon.classList.remove(classString);}}
if(size!=="1"){selectedIcon.classList.add(`fa-${size}x`);}
this.dependencies.history.addStep();}
toggleSpinIcon(){const selectedIcon=this.getSelectedIcon();if(!selectedIcon){return;}
selectedIcon.classList.toggle("fa-spin");}
hasIconSize(size){const selectedIcon=this.getSelectedIcon();if(!selectedIcon){return;}
if(size==="1"){return![...selectedIcon.classList].some((classString)=>classString.match(/^fa-[2-5]x$/));}
return selectedIcon.classList.contains(`fa-${size}x`);}
hasSpinIcon(){const selectedIcon=this.getSelectedIcon();if(!selectedIcon){return;}
return selectedIcon.classList.contains("fa-spin");}
applyIconColor(color,mode){const selectedIcon=this.getSelectedIcon();if(!selectedIcon){return;}
this.dependencies.color.colorElement(selectedIcon,color,mode);return true;}}
return __exports;});;

/* /html_editor/static/src/main/media/image_crop.js */
odoo.define('@html_editor/main/media/image_crop',['@html_editor/utils/image_processing','@web/core/l10n/translation','@odoo/owl','@web/core/utils/hooks','@web/core/utils/scrolling'],function(require){'use strict';let __exports={};const{applyModifications,cropperDataFields,activateCropper,loadImage,loadImageInfo,}=require("@html_editor/utils/image_processing");const{_t}=require("@web/core/l10n/translation");const{Component,useRef,onMounted,onWillDestroy,markup,useExternalListener,status,}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{scrollTo,closestScrollableY}=require("@web/core/utils/scrolling");const ImageCrop=__exports.ImageCrop=class ImageCrop extends Component{static template="html_editor.ImageCrop";static props={document:{validate:(p)=>p.nodeType===Node.DOCUMENT_NODE},media:{optional:true},mimetype:{type:String,optional:true},onClose:{type:Function,optional:true},onSave:{type:Function,optional:true},};setup(){this.aspectRatios={"0/0":{label:_t("Flexible"),value:0},"16/9":{label:"16:9",value:16/9},"4/3":{label:"4:3",value:4/3},"1/1":{label:"1:1",value:1},"2/3":{label:"2:3",value:2/3},};this.notification=useService("notification");this.media=this.props.media;this.document=this.props.document;this.elRef=useRef("el");this.cropperWrapper=useRef("cropperWrapper");this.imageRef=useRef("imageRef");this.cropperOpen=false;useExternalListener(this.document,"mousedown",this.onDocumentMousedown,{capture:true,});useExternalListener(this.document,"keydown",this.onDocumentKeydown,{capture:true,});onMounted(()=>{this.hasModifiedImageClass=this.media.classList.contains("o_modified_image_to_save");if(this.hasModifiedImageClass){this.media.classList.remove("o_modified_image_to_save");}
this.show();});onWillDestroy(this.closeCropper);}
closeCropper(){if(!this.cropperOpen){return;}
this.cropper?.destroy?.();this.media.setAttribute("src",this.initialSrc);if(this.hasModifiedImageClass&&!this.media.classList.contains("o_modified_image_to_save")){this.media.classList.add("o_modified_image_to_save");}
this.props?.onClose?.();this.cropperOpen=false;}
async reset(){if(this.cropper){this.cropper.reset();if(this.aspectRatio!=="0/0"){this.aspectRatio="0/0";this.cropper.setAspectRatio(this.aspectRatios[this.aspectRatio].value);}
await this.save(false);}}
async show(){if(this.cropperOpen){return;}
const src=this.media.getAttribute("src");const data={...this.media.dataset};this.initialSrc=src;this.aspectRatio=data.aspectRatio||"0/0";const mimetype=data.mimetype||src.endsWith(".png")?"image/png":src.endsWith(".webp")?"image/webp":"image/jpeg";this.mimetype=this.props.mimetype||mimetype;await loadImageInfo(this.media);const isIllustration=/^\/(?:html|web)_editor\/shape\/illustration\//.test(this.media.dataset.originalSrc);this.uncroppable=false;if(this.media.dataset.originalSrc&&!isIllustration){this.originalSrc=this.media.dataset.originalSrc;this.originalId=this.media.dataset.originalId;}else{this.uncroppable=true;}
if(this.uncroppable){this.notification.add(markup(_t("This type of image is not supported for cropping.<br/>If you want to crop it, please first download it from the original source and upload it in Odoo.")),{title:_t("This image is an external image"),type:"warning",});return this.closeCropper();}
await this.scrollToInvisibleImage();await loadImage(this.originalSrc,this.media);if(status(this)!=="mounted"){return;}
const cropperImage=this.imageRef.el;[cropperImage.style.width,cropperImage.style.height]=[this.media.width+"px",this.media.height+"px",];const sel=this.document.getSelection();sel&&sel.removeAllRanges();let offset=undefined;if(!this.media.getClientRects().length){offset={top:0,left:0};}else{const rect=this.media.getBoundingClientRect();const win=this.media.ownerDocument.defaultView;offset={top:rect.top+win.pageYOffset,left:rect.left+win.pageXOffset,};}
offset.left+=parseInt(this.media.style.paddingLeft||0);offset.top+=parseInt(this.media.style.paddingRight||0);const frameElement=this.media.ownerDocument.defaultView.frameElement;if(frameElement){const frameRect=frameElement.getBoundingClientRect();offset.left+=frameRect.left;offset.top+=frameRect.top;}
this.cropperWrapper.el.style.left=`${offset.left}px`;this.cropperWrapper.el.style.top=`${offset.top}px`;await loadImage(this.originalSrc,cropperImage);this.cropper=await activateCropper(cropperImage,this.aspectRatios[this.aspectRatio].value,this.media.dataset);this.cropperOpen=true;}
async save(cropped=true){this.media.classList.add("o_modified_image_to_save");[...cropperDataFields,"aspectRatio"].forEach((attr)=>{delete this.media.dataset[attr];const value=this.getAttributeValue(attr);if(value){this.media.dataset[attr]=value;}});delete this.media.dataset.resizeWidth;this.initialSrc=await applyModifications(this.media,this.cropper,{forceModification:true,mimetype:this.mimetype,});this.media.classList.toggle("o_we_image_cropped",cropped);this.closeCropper();this.props.onSave?.();}
getAttributeValue(attr){if(cropperDataFields.includes(attr)){return this.cropper.getData()[attr];}
return this[attr];}
resetCropBox(){this.cropper.clear();this.cropper.crop();}
async scrollToInvisibleImage(){const rect=this.media.getBoundingClientRect();const viewportTop=this.document.documentElement.scrollTop||0;const viewportBottom=viewportTop+window.innerHeight;const scrollable=closestScrollableY(this.media);if(rect.top<viewportTop||viewportBottom-rect.bottom<100){await scrollTo(this.media,{behavior:"smooth",...(scrollable&&{scrollable}),});}}
onZoom(scale){this.cropper.zoom(scale);}
onReset(){this.cropper.reset();}
onRotate(degree){this.cropper.rotate(degree);}
onFlip(scaleDirection){const amount=this.cropper.getData()[scaleDirection]*-1;this.cropper[scaleDirection](amount);}
setAspectRatio(ratio){this.cropper.reset();this.aspectRatio=ratio;this.cropper.setAspectRatio(this.aspectRatios[this.aspectRatio].value);}
onDocumentMousedown(ev){if(this.props.document.body.contains(ev.target)&&(this.elRef.el===ev.target||!this.elRef.el.contains(ev.target))){return this.closeCropper();}}
onDocumentKeydown(ev){if(ev.key==="Enter"){return this.save();}else if(ev.key==="Escape"){ev.stopImmediatePropagation();return this.closeCropper();}}
async onCropZoom(){await new Promise((res)=>setTimeout(res,0));this.resetCropBox();}}
return __exports;});;

/* /html_editor/static/src/main/media/image_crop_plugin.js */
odoo.define('@html_editor/main/media/image_crop_plugin',['@web/core/registry','@html_editor/plugin','@web/core/l10n/translation','@html_editor/main/media/image_crop','@web/core/assets','@html_editor/utils/resource'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Plugin}=require("@html_editor/plugin");const{_t}=require("@web/core/l10n/translation");const{ImageCrop}=require("@html_editor/main/media/image_crop");const{loadBundle}=require("@web/core/assets");const{withSequence}=require("@html_editor/utils/resource");const ImageCropPlugin=__exports.ImageCropPlugin=class ImageCropPlugin extends Plugin{static id="imageCrop";static dependencies=["selection","history"];resources={user_commands:[{id:"cropImage",run:this.openCropImage.bind(this),title:_t("Crop image"),icon:"fa-crop",},],toolbar_groups:withSequence(27,{id:"image_crop",namespace:"image",}),toolbar_items:[{id:"image_crop",commandId:"cropImage",groupId:"image_crop",},],};setup(){this.imageCropProps={media:undefined,mimetype:undefined,};}
getSelectedImage(){const selectedNodes=this.dependencies.selection.getSelectedNodes();return selectedNodes.find((node)=>node.tagName==="IMG");}
async openCropImage(){const selectedImg=this.getSelectedImage();if(!selectedImg){return;}
this.imageCropProps.media=selectedImg;const onClose=()=>{registry.category("main_components").remove("ImageCropping");};const onSave=()=>{this.dependencies.history.addStep();};await loadBundle("html_editor.assets_image_cropper");registry.category("main_components").add("ImageCropping",{Component:ImageCrop,props:{...this.imageCropProps,onClose,onSave,document:this.document},});}}
return __exports;});;

/* /html_editor/static/src/main/media/image_description.js */
odoo.define('@html_editor/main/media/image_description',['@odoo/owl','@web/core/dialog/dialog','@web/core/utils/hooks','@html_editor/main/toolbar/toolbar'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{useService}=require("@web/core/utils/hooks");const{toolbarButtonProps}=require("@html_editor/main/toolbar/toolbar");const ImageDescription=__exports.ImageDescription=class ImageDescription extends Component{static components={Dialog};static props={getDescription:Function,getTooltip:Function,updateImageDescription:Function,...toolbarButtonProps,};static template="html_editor.ImageDescription";setup(){this.dialog=useService("dialog");}
openDescriptionDialog(){this.dialog.add(ImageDescriptionDialog,{description:this.props.getDescription(),onConfirm:(description,tooltip)=>this.props.updateImageDescription({description,tooltip}),tooltip:this.props.getTooltip(),});}}
class ImageDescriptionDialog extends Component{static components={Dialog};static props={close:Function,description:{type:String,optional:true,},onConfirm:Function,tooltip:{type:String,optional:true,},};static template="html_editor.ImageDescriptionDialog";setup(){this.state={description:this.props.description,tooltip:this.props.tooltip,};}
onSave(){this.props.onConfirm(this.state.description,this.state.tooltip);this.props.close();}}
return __exports;});;

/* /html_editor/static/src/main/media/image_padding.js */
odoo.define('@html_editor/main/media/image_padding',['@odoo/owl','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@html_editor/main/toolbar/toolbar'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{toolbarButtonProps}=require("@html_editor/main/toolbar/toolbar");const ImagePadding=__exports.ImagePadding=class ImagePadding extends Component{static components={Dropdown,DropdownItem};static props={...toolbarButtonProps,onSelected:Function,};static template="html_editor.ImagePadding";setup(){this.paddings={None:0,Small:1,Medium:2,Large:3,XL:5};}
onSelected(padding){this.props.onSelected({size:this.paddings[padding]});}}
return __exports;});;

/* /html_editor/static/src/main/media/image_plugin.js */
odoo.define('@html_editor/main/media/image_plugin',['@html_editor/plugin','@web/core/l10n/translation','@html_editor/utils/url','@html_editor/main/media/image_description','@html_editor/main/media/image_padding','@web/core/file_viewer/file_viewer_hook','@html_editor/utils/position','@html_editor/utils/resource','@html_editor/main/media/image_transform_button','@html_editor/utils/dom_info'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{_t}=require("@web/core/l10n/translation");const{isImageUrl}=require("@html_editor/utils/url");const{ImageDescription}=require("@html_editor/main/media/image_description");const{ImagePadding}=require("@html_editor/main/media/image_padding");const{createFileViewer}=require("@web/core/file_viewer/file_viewer_hook");const{boundariesOut,childNodeIndex}=require("@html_editor/utils/position");const{withSequence}=require("@html_editor/utils/resource");const{ImageTransformButton}=require("@html_editor/main/media/image_transform_button");const{isEmpty}=require("@html_editor/utils/dom_info");function hasShape(imagePlugin,shapeName){return()=>imagePlugin.isSelectionShaped(shapeName);}
const ImagePlugin=__exports.ImagePlugin=class ImagePlugin extends Plugin{static id="image";static dependencies=["history","link","powerbox","dom","selection"];resources={user_commands:[{id:"deleteImage",title:_t("Remove (DELETE)"),icon:"fa-trash text-danger",run:this.deleteImage.bind(this),},{id:"previewImage",title:_t("Preview image"),icon:"fa-search-plus",run:this.previewImage.bind(this),},{id:"setImageShapeRounded",title:_t("Shape: Rounded"),icon:"fa-square",run:()=>this.setImageShape("rounded",{excludeClasses:["rounded-circle"]}),},{id:"setImageShapeCircle",title:_t("Shape: Circle"),icon:"fa-circle-o",run:()=>this.setImageShape("rounded-circle",{excludeClasses:["rounded"]}),},{id:"setImageShapeShadow",title:_t("Shape: Shadow"),icon:"fa-sun-o",run:()=>this.setImageShape("shadow"),},{id:"setImageShapeThumbnail",title:_t("Shape: Thumbnail"),icon:"fa-picture-o",run:()=>this.setImageShape("img-thumbnail"),},{id:"resizeImage",run:this.resizeImage.bind(this)},],toolbar_namespaces:[{id:"image",isApplied:(traversedNodes)=>traversedNodes.every((node)=>node.nodeName==="IMG"||node.querySelector?.("img")),},],toolbar_groups:[withSequence(23,{id:"image_preview",namespace:"image"}),withSequence(24,{id:"image_description",namespace:"image"}),withSequence(25,{id:"image_shape",namespace:"image"}),withSequence(26,{id:"image_padding",namespace:"image"}),withSequence(26,{id:"image_size",namespace:"image"}),withSequence(26,{id:"image_transform",namespace:"image"}),withSequence(30,{id:"image_delete",namespace:"image"}),],toolbar_items:[{id:"image_preview",groupId:"image_preview",commandId:"previewImage",},{id:"image_description",title:_t("Edit media description"),groupId:"image_description",Component:ImageDescription,props:{getDescription:()=>this.getImageAttribute("alt"),getTooltip:()=>this.getImageAttribute("title"),updateImageDescription:this.updateImageDescription.bind(this),},},{id:"shape_rounded",groupId:"image_shape",commandId:"setImageShapeRounded",isActive:hasShape(this,"rounded"),},{id:"shape_circle",groupId:"image_shape",commandId:"setImageShapeCircle",isActive:hasShape(this,"rounded-circle"),},{id:"shape_shadow",groupId:"image_shape",commandId:"setImageShapeShadow",isActive:hasShape(this,"shadow"),},{id:"shape_thumbnail",groupId:"image_shape",commandId:"setImageShapeThumbnail",isActive:hasShape(this,"img-thumbnail"),},{id:"image_padding",groupId:"image_padding",title:_t("Image padding"),Component:ImagePadding,props:{onSelected:this.setImagePadding.bind(this),},},{id:"resize_default",groupId:"image_size",commandId:"resizeImage",title:_t("Resize Default"),text:_t("Default"),isActive:()=>this.hasImageSize(""),},{id:"resize_100",groupId:"image_size",commandId:"resizeImage",commandParams:{size:"100%"},title:_t("Resize Full"),text:"100%",isActive:()=>this.hasImageSize("100%"),},{id:"resize_50",groupId:"image_size",commandId:"resizeImage",commandParams:{size:"50%"},title:_t("Resize Half"),text:"50%",isActive:()=>this.hasImageSize("50%"),},{id:"resize_25",groupId:"image_size",commandId:"resizeImage",commandParams:{size:"25%"},title:_t("Resize Quarter"),text:"25%",isActive:()=>this.hasImageSize("25%"),},{id:"image_transform",groupId:"image_transform",title:_t("Transform the picture (click twice to reset transformation)"),Component:ImageTransformButton,props:this.getImageTransformProps(),},{id:"image_delete",groupId:"image_delete",commandId:"deleteImage",},],paste_url_overrides:this.handlePasteUrl.bind(this),};setup(){this.addDomListener(this.editable,"dblclick",(e)=>{if(e.target.tagName==="IMG"){this.previewImage();}});this.addDomListener(this.editable,"pointerup",(e)=>{if(e.target.tagName==="IMG"){const[anchorNode,anchorOffset,focusNode,focusOffset]=boundariesOut(e.target);this.dependencies.selection.setSelection({anchorNode,anchorOffset,focusNode,focusOffset,});this.dependencies.selection.focusEditable();}});this.fileViewer=createFileViewer();}
destroy(){super.destroy();}
setImagePadding({size}={}){const selectedImg=this.getSelectedImage();if(!selectedImg){return;}
for(const classString of selectedImg.classList){if(classString.match(/^p-[0-9]$/)){selectedImg.classList.remove(classString);}}
selectedImg.classList.add(`p-${size}`);this.dependencies.history.addStep();}
resizeImage({size}={}){const selectedImg=this.getSelectedImage();if(!selectedImg){return;}
selectedImg.style.width=size||"";this.dependencies.history.addStep();}
setImageShape(className,{excludeClasses=[]}={}){const selectedImg=this.getSelectedImage();if(!selectedImg){return;}
for(const classString of excludeClasses){if(selectedImg.classList.contains(classString)){selectedImg.classList.remove(classString);}}
selectedImg.classList.toggle(className);this.dependencies.history.addStep();}
previewImage(){const selectedImg=this.getSelectedImage();if(!selectedImg){return;}
const fileModel={isImage:true,isViewable:true,displayName:selectedImg.src,defaultSource:selectedImg.src,downloadUrl:selectedImg.src,};this.document.getSelection().collapseToEnd();this.fileViewer.open(fileModel);}
deleteImage(){const selectedImg=this.getSelectedImage();if(selectedImg){const anchorNode=selectedImg.parentElement;let anchorOffset=childNodeIndex(selectedImg);selectedImg.remove();if(anchorNode.nodeName==="P"&&isEmpty(anchorNode)){const br=this.document.createElement("br");anchorNode.replaceChildren(br);anchorOffset=0;}
this.dependencies.selection.setSelection({anchorNode,anchorOffset});this.dependencies.history.addStep();}}
getSelectedImage(){const selectedNodes=this.dependencies.selection.getSelectedNodes();return selectedNodes.find((node)=>node.tagName==="IMG");}
hasImageSize(size){const selectedImg=this.getSelectedImage();return selectedImg?.style?.width===size;}
isSelectionShaped(shape){const selectedNodes=this.dependencies.selection.getTraversedNodes().filter((n)=>n.tagName==="IMG"&&n.classList.contains(shape));return selectedNodes.length>0;}
getImageAttribute(attributeName){const selectedNodes=this.dependencies.selection.getSelectedNodes();const selectedImg=selectedNodes.find((node)=>node.tagName==="IMG");return selectedImg.getAttribute(attributeName)||undefined;}
handlePasteUrl(text,url){if(isImageUrl(url)){const restoreSavepoint=this.dependencies.history.makeSavePoint();this.dependencies.dom.insert(text);this.dependencies.history.addStep();const embedImageCommand={title:_t("Embed Image"),description:_t("Embed the image in the document."),icon:"fa-image",run:()=>{const img=document.createElement("IMG");img.setAttribute("src",url);this.dependencies.dom.insert(img);this.dependencies.history.addStep();},};const commands=[embedImageCommand,this.dependencies.link.getPathAsUrlCommand(text,url),];this.dependencies.powerbox.openPowerbox({commands,onApplyCommand:restoreSavepoint});return true;}}
updateImageDescription({description,tooltip}={}){const selectedImg=this.getSelectedImage();if(!selectedImg){return;}
selectedImg.setAttribute("alt",description);selectedImg.setAttribute("title",tooltip);this.dependencies.history.addStep();}
resetImageTransformation(image){image.setAttribute("style",(image.getAttribute("style")||"").replace(/[^;]*transform[\w:]*;?/g,""));this.dependencies.history.addStep();}
getImageTransformProps(){return{icon:"fa-object-ungroup",getSelectedImage:this.getSelectedImage.bind(this),resetImageTransformation:this.resetImageTransformation.bind(this),addStep:this.dependencies.history.addStep.bind(this),document:this.document,editable:this.editable,};}}
return __exports;});;

/* /html_editor/static/src/main/media/image_transform_button.js */
odoo.define('@html_editor/main/media/image_transform_button',['@odoo/owl','@html_editor/main/toolbar/toolbar','@web/core/registry','@html_editor/main/media/image_transformation'],function(require){'use strict';let __exports={};const{Component,useExternalListener,useState}=require("@odoo/owl");const{toolbarButtonProps}=require("@html_editor/main/toolbar/toolbar");const{registry}=require("@web/core/registry");const{ImageTransformation}=require("@html_editor/main/media/image_transformation");const ImageTransformButton=__exports.ImageTransformButton=class ImageTransformButton extends Component{static template="html_editor.ImageTransformButton";static props={icon:String,getSelectedImage:Function,resetImageTransformation:Function,addStep:Function,document:{validate:(p)=>p.nodeType===Node.DOCUMENT_NODE},editable:{validate:(p)=>p.nodeType===Node.ELEMENT_NODE},...toolbarButtonProps,};setup(){this.state=useState({active:false});this.mouseDownInsideTransform=false;useExternalListener(this.props.document,"mousedown",(ev)=>{if(this.isNodeInsideTransform(ev.target)){this.mouseDownInsisdeTransform=true;}else{this.closeImageTransformation();this.mouseDownInsideTransform=false;}});useExternalListener(this.props.document,"click",(ev)=>{if(!this.isNodeInsideTransform(ev.target)&&!this.mouseDownInsideTransform){this.closeImageTransformation();}
this.mouseDownInsideTransform=false;});useExternalListener(this.props.document,"selectionchange",(ev)=>{this.closeImageTransformation();});}
isNodeInsideTransform(node){if(!node){return false;}
if(node.nodeType===Node.TEXT_NODE){node=node.parentElement;}
if(node.matches('[name="image_transform"], [name="image_transform"] *')){return true;}
if(this.isImageTransformationOpen()&&node.matches(".transfo-container, .transfo-container div, .transfo-container i, .transfo-container span")){return true;}
return false;}
onButtonClick(){this.handleImageTransformation(this.props.getSelectedImage());}
handleImageTransformation(image){if(this.isImageTransformationOpen()){this.props.resetImageTransformation(image);this.closeImageTransformation();}else{this.openImageTransformation(image);}}
openImageTransformation(image){this.state.active=true;registry.category("main_components").add("ImageTransformation",{Component:ImageTransformation,props:{image,document:this.props.document,editable:this.props.editable,destroy:()=>this.closeImageTransformation(),onChange:()=>this.props.addStep(),},});}
isImageTransformationOpen(){return registry.category("main_components").contains("ImageTransformation");}
closeImageTransformation(){this.state.active=false;if(this.isImageTransformationOpen()){registry.category("main_components").remove("ImageTransformation");}}}
return __exports;});;

/* /html_editor/static/src/main/media/image_transformation.js */
odoo.define('@html_editor/main/media/image_transformation',['@odoo/owl','@web/core/hotkeys/hotkey_hook','@html_editor/position_hook'],function(require){'use strict';let __exports={};const{Component,onMounted,useExternalListener,useRef}=require("@odoo/owl");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{usePositionHook}=require("@html_editor/position_hook");const rad=Math.PI/180;const ImageTransformation=__exports.ImageTransformation=class ImageTransformation extends Component{static template="html_editor.ImageTransformation";static props={document:{validate:(p)=>p.nodeType===Node.DOCUMENT_NODE},editable:{validate:(p)=>p.nodeType===Node.ELEMENT_NODE},image:{validate:(p)=>p.tagName==="IMG"},destroy:{type:Function},onChange:{type:Function},};setup(){this.document=this.props.document;this.image=this.props.image;this.transfoContainer=useRef("transfoContainer");this.transfoControls=useRef("transfoControls");this.transfoCenter=useRef("transfoCenter");this.computeImageTransformations();onMounted(()=>{this.positionTransfoContainer();});useExternalListener(window,"mousemove",this.mouseMove);useExternalListener(window,"mouseup",this.mouseUp);useHotkey("escape",()=>this.props.destroy());usePositionHook({el:this.props.editable},this.document,this.resetHandlers);}
mouseMove(ev){if(!this.transfo.active){return;}
ev.preventDefault();const settings=this.transfo.settings;const center=this.transfo.active.center;const cdx=center.left-ev.pageX;const cdy=center.top-ev.pageY;if(this.transfo.active.type=="rotator"){let ang;const dang=Math.atan((settings.width*settings.scalex)/(settings.height*settings.scaley))/rad;if(cdy){ang=Math.atan(-cdx/cdy)/rad;}else{ang=0;}
if(ev.pageY>=center.top&&ev.pageX>=center.left){ang+=180;}else if(ev.pageY>=center.top&&ev.pageX<center.left){ang+=180;}else if(ev.pageY<center.top&&ev.pageX<center.left){ang+=360;}
ang-=dang;if(settings.scaley<0&&settings.scalex<0){ang+=180;}
if(!ev.ctrlKey){settings.angle=Math.round(ang/this.transfo.settings.rotationStep)*this.transfo.settings.rotationStep;}else{settings.angle=ang;}
this.positionTransfoContainer();const new_center=this.getOffset(this.transfoCenter.el);const x=center.left-new_center.left;const y=center.top-new_center.top;const angle=ang*rad;settings.translatex+=x*Math.cos(angle)-y*Math.sin(-angle);settings.translatey+=-x*Math.sin(angle)+y*Math.cos(-angle);}else if(this.transfo.active.type=="position"){const angle=settings.angle*rad;const x=ev.pageX-this.transfo.active.pageX;const y=ev.pageY-this.transfo.active.pageY;this.transfo.active.pageX=ev.pageX;this.transfo.active.pageY=ev.pageY;const dx=x*Math.cos(angle)-y*Math.sin(-angle);const dy=-x*Math.sin(angle)+y*Math.cos(-angle);settings.translatex+=dx;settings.translatey+=dy;}else if(this.transfo.active.type.length===2){const angle=settings.angle*rad;const dx=cdx*Math.cos(angle)-cdy*Math.sin(-angle);const dy=-cdx*Math.sin(angle)+cdy*Math.cos(-angle);if(this.transfo.active.type.indexOf("t")!=-1){settings.scaley=dy/(settings.height/2);}
if(this.transfo.active.type.indexOf("b")!=-1){settings.scaley=-dy/(settings.height/2);}
if(this.transfo.active.type.indexOf("l")!=-1){settings.scalex=dx/(settings.width/2);}
if(this.transfo.active.type.indexOf("r")!=-1){settings.scalex=-dx/(settings.width/2);}
if(settings.scaley>0&&settings.scaley<0.05){settings.scaley=0.05;}
if(settings.scalex>0&&settings.scalex<0.05){settings.scalex=0.05;}
if(settings.scaley<0&&settings.scaley>-0.05){settings.scaley=-0.05;}
if(settings.scalex<0&&settings.scalex>-0.05){settings.scalex=-0.05;}
if(ev.shiftKey&&(this.transfo.active.type==="tl"||this.transfo.active.type==="bl"||this.transfo.active.type==="tr"||this.transfo.active.type==="br")){settings.scaley=settings.scalex;}}
settings.angle=Math.round(settings.angle);settings.translatex=Math.round(settings.translatex);settings.translatey=Math.round(settings.translatey);settings.scalex=Math.round(settings.scalex*100)/100;settings.scaley=Math.round(settings.scaley*100)/100;this.positionTransfoContainer();this.props.onChange();}
mouseUp(){this.transfo.active=null;}
mouseDown(ev){if(this.transfo.active){return;}
let type="position";const target=ev.target.closest("div");if(target.classList.contains("transfo-rotator")){type="rotator";}else if(target.classList.contains("transfo-scaler-tl")){type="tl";}else if(target.classList.contains("transfo-scaler-tr")){type="tr";}else if(target.classList.contains("transfo-scaler-br")){type="br";}else if(target.classList.contains("transfo-scaler-bl")){type="bl";}else if(target.classList.contains("transfo-scaler-tc")){type="tc";}else if(target.classList.contains("transfo-scaler-bc")){type="bc";}else if(target.classList.contains("transfo-scaler-ml")){type="ml";}else if(target.classList.contains("transfo-scaler-mr")){type="mr";}
this.transfo.active={type:type,scalex:this.transfo.settings.scalex,scaley:this.transfo.settings.scaley,pageX:ev.pageX,pageY:ev.pageY,center:this.getOffset(this.transfoCenter.el),};}
computeImageTransformations(){this.transfo={};const transform=this.image.style.transform||"";this.transfo.settings={};this.transfo.settings.angle=transform.indexOf("rotate")!=-1?parseFloat(transform.match(/rotate\(([^)]+)deg\)/)[1]):0;this.transfo.settings.scalex=transform.indexOf("scaleX")!=-1?parseFloat(transform.match(/scaleX\(([^)]+)\)/)[1]):1;this.transfo.settings.scaley=transform.indexOf("scaleY")!=-1?parseFloat(transform.match(/scaleY\(([^)]+)\)/)[1]):1;this.image.style.transform="";this.transfo.settings.pos=this.getOffset(this.image);this.transfo.settings.height=this.image.clientHeight;this.transfo.settings.width=this.image.clientWidth;const translatex=transform.match(/translateX\(([0-9.-]+)(%|px)\)/);const translatey=transform.match(/translateY\(([0-9.-]+)(%|px)\)/);this.transfo.settings.translate="%";if(translatex&&translatex[2]==="%"){this.transfo.settings.translatexp=parseFloat(translatex[1]);this.transfo.settings.translatex=(this.transfo.settings.translatexp/100)*this.transfo.settings.width;}else{this.transfo.settings.translatex=translatex?parseFloat(translatex[1]):0;}
if(translatey&&translatey[2]==="%"){this.transfo.settings.translateyp=parseFloat(translatey[1]);this.transfo.settings.translatey=(this.transfo.settings.translateyp/100)*this.transfo.settings.height;}else{this.transfo.settings.translatey=translatey?parseFloat(translatey[1]):0;}
this.transfo.settings.css=window.getComputedStyle(this.image,null);this.transfo.settings.rotationStep=5;}
positionTransfoContainer(){const settings=this.transfo.settings;const width=parseFloat(settings.css.width);const height=parseFloat(settings.css.height);settings.translatexp=Math.round((settings.translatex/width)*1000)/10;settings.translateyp=Math.round((settings.translatey/height)*1000)/10;this.setImageTransformation(this.image);this.transfoContainer.el.style.position="absolute";this.transfoContainer.el.style.width=width+"px";this.transfoContainer.el.style.height=height+"px";this.transfoContainer.el.style.top=settings.pos.top+"px";this.transfoContainer.el.style.left=settings.pos.left+"px";const controls=this.transfoControls.el;this.setImageTransformation(controls);controls.style.width=width+"px";controls.style.height=height+"px";controls.style.cursor="move";for(const child of controls.children){child.style.transform="scaleX("+1/settings.scalex+") scaleY("+1/settings.scaley+")";}}
setImageTransformation(element){let transform="";if(this.transfo.settings.angle!==0){transform+=" rotate("+this.transfo.settings.angle+"deg) ";}
if(this.transfo.settings.translatex){transform+=" translateX("+
(this.transfo.settings.translate==="%"?this.transfo.settings.translatexp+"%":this.transfo.settings.translatex+"px")+") ";}
if(this.transfo.settings.translatey){transform+=" translateY("+
(this.transfo.settings.translate==="%"?this.transfo.settings.translateyp+"%":this.transfo.settings.translatey+"px")+") ";}
if(this.transfo.settings.scalex!=1){transform+=" scaleX("+this.transfo.settings.scalex+") ";}
if(this.transfo.settings.scaley!=1){transform+=" scaleY("+this.transfo.settings.scaley+") ";}
element.style.transform=transform;}
getOffset(target){if(!target.getClientRects().length){return{top:0,left:0};}else{const rect=target.getBoundingClientRect();const win=target.ownerDocument.defaultView;const frameElement=target.ownerDocument.defaultView.frameElement;const offset={top:0,left:0};if(frameElement){const frameRect=frameElement.getBoundingClientRect();offset.left+=frameRect.left;offset.top+=frameRect.top;}
return{top:rect.top+win.pageYOffset+offset.top,left:rect.left+win.pageXOffset+offset.left,};}}
resetHandlers(){this.computeImageTransformations();this.positionTransfoContainer();}}
return __exports;});;

/* /html_editor/static/src/main/media/media_dialog/document_selector.js */
odoo.define('@html_editor/main/media/media_dialog/document_selector',['@web/core/l10n/translation','@html_editor/main/media/media_dialog/file_selector','@web/core/utils/render'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Attachment,FileSelector,IMAGE_MIMETYPES}=require("@html_editor/main/media/media_dialog/file_selector");const{renderToElement}=require("@web/core/utils/render");const DocumentAttachment=__exports.DocumentAttachment=class DocumentAttachment extends Attachment{static template="html_editor.DocumentAttachment";}
const DocumentSelector=__exports.DocumentSelector=class DocumentSelector extends FileSelector{static mediaSpecificClasses=["o_image"];static mediaSpecificStyles=[];static mediaExtraClasses=[];static tagNames=["A"];static attachmentsListTemplate="html_editor.DocumentsListTemplate";static components={...FileSelector.components,DocumentAttachment,};setup(){super.setup();this.uploadText=_t("Upload a document");this.urlPlaceholder="https://www.odoo.com/mydocument";this.addText=_t("Add URL");this.searchPlaceholder=_t("Search a document");this.allLoadedText=_t("All documents have been loaded");}
get attachmentsDomain(){const domain=super.attachmentsDomain;domain.push(["mimetype","not in",IMAGE_MIMETYPES]);domain.unshift("&","|",["url","=",null],"!",["url","=like","/web/assets/%"]);return domain;}
async onClickDocument(document){this.selectAttachment(document);await this.props.save();}
async fetchAttachments(...args){const attachments=await super.fetchAttachments(...args);if(this.selectInitialMedia()){for(const attachment of attachments){if(`/web/content/${attachment.id}`===this.props.media.getAttribute("href").replace(/[?].*/,"")){this.selectAttachment(attachment);}}}
return attachments;}
static async createElements(selectedMedia,{orm}){return Promise.all(selectedMedia.map(async(attachment)=>{let url=`/web/content/${encodeURIComponent(
                    attachment.id
                )}?unique=${encodeURIComponent(attachment.checksum)}&download=true`;if(!attachment.public){let accessToken=attachment.access_token;if(!accessToken){[accessToken]=await orm.call("ir.attachment","generate_access_token",[attachment.id,]);}
url+=`&access_token=${encodeURIComponent(accessToken)}`;}
return this.renderFileElement(attachment,url);}));}
static renderFileElement(attachment,downloadUrl){return renderStaticFileBox(attachment.name,attachment.mimetype,downloadUrl);}}
__exports.renderStaticFileBox=renderStaticFileBox;function renderStaticFileBox(filename,mimetype,downloadUrl){const rootSpan=document.createElement("span");rootSpan.classList.add("o_file_box");rootSpan.contentEditable=false;const bannerElement=renderToElement("html_editor.StaticFileBox",{fileModel:{filename,mimetype,downloadUrl},});rootSpan.append(bannerElement);return rootSpan;}
return __exports;});;

/* /html_editor/static/src/main/media/media_dialog/file_documents_selector.js */
odoo.define('@html_editor/main/media/media_dialog/file_documents_selector',['@html_editor/main/media/media_dialog/document_selector'],function(require){'use strict';let __exports={};const{DocumentSelector}=require("@html_editor/main/media/media_dialog/document_selector");const FileDocumentsSelector=__exports.FileDocumentsSelector=class FileDocumentsSelector extends DocumentSelector{get attachmentsDomain(){const domain=super.attachmentsDomain.map((d)=>{if(d[0]==="mimetype"){return["mimetype","!=",false];}
return d;});domain.unshift("&","|",["url","=",null],"&","!",["url","=like","/%/static/%"],"!","|",["url","=ilike","/html_editor/shape/%"],["url","=ilike","/web_editor/shape/%"]);domain.push("!",["name","=like","%.crop"]);return domain;}}
return __exports;});;

/* /html_editor/static/src/main/media/media_dialog/file_media_dialog.js */
odoo.define('@html_editor/main/media/media_dialog/file_media_dialog',['@web/core/utils/render','@html_editor/main/media/media_dialog/media_dialog','@html_editor/main/media/media_dialog/file_documents_selector','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{renderToElement}=require("@web/core/utils/render");const{MediaDialog}=require("@html_editor/main/media/media_dialog/media_dialog");const{FileDocumentsSelector}=require("@html_editor/main/media/media_dialog/file_documents_selector");const{_t}=require("@web/core/l10n/translation");const FileMediaDialog=__exports.FileMediaDialog=class FileMediaDialog extends MediaDialog{addTabs(){super.addTabs(...arguments);this.addTab({id:"MIXED_FILES",title:_t("Documents"),Component:FileDocumentsSelector,});}
async renderMedia([selectedMedia]){let accessToken=selectedMedia.access_token;if(!selectedMedia.public||!accessToken){[accessToken]=await this.orm.call("ir.attachment","generate_access_token",[selectedMedia.id,]);}
const dotSplit=selectedMedia.name.split(".");const extension=dotSplit.length>1?dotSplit.pop():undefined;const fileData={access_token:accessToken,checksum:selectedMedia.checksum,extension,filename:selectedMedia.name,id:selectedMedia.id,mimetype:selectedMedia.mimetype,name:selectedMedia.name,type:selectedMedia.type,url:selectedMedia.url||"",};const fileBlock=renderToElement("html_editor.EmbeddedFileBlueprint",{embeddedProps:JSON.stringify({fileData,}),});return[fileBlock];}}
return __exports;});;

/* /html_editor/static/src/main/media/media_dialog/file_selector.js */
odoo.define('@html_editor/main/media/media_dialog/file_selector',['@web/core/l10n/translation','@web/core/network/rpc','@web/core/utils/hooks','@web/core/confirmation_dialog/confirmation_dialog','@web/core/dialog/dialog','@web/core/utils/concurrency','@web/core/utils/timing','@html_editor/main/media/media_dialog/search_media','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{Dialog}=require("@web/core/dialog/dialog");const{KeepLast}=require("@web/core/utils/concurrency");const{useDebounced}=require("@web/core/utils/timing");const{SearchMedia}=require("@html_editor/main/media/media_dialog/search_media");const{Component,xml,useState,useRef,onWillStart,useEffect}=require("@odoo/owl");const IMAGE_MIMETYPES=__exports.IMAGE_MIMETYPES=["image/jpg","image/jpeg","image/jpe","image/png","image/svg+xml","image/gif","image/webp",];const IMAGE_EXTENSIONS=__exports.IMAGE_EXTENSIONS=[".jpg",".jpeg",".jpe",".png",".svg",".gif",".webp"];class RemoveButton extends Component{static template=xml`<i class="fa fa-trash o_existing_attachment_remove position-absolute top-0 end-0 p-2 bg-white-25 cursor-pointer opacity-0 opacity-100-hover z-index-1 transition-base" t-att-title="removeTitle" role="img" t-att-aria-label="removeTitle" t-on-click="this.remove"/>`;static props=["model?","remove"];setup(){this.removeTitle=_t("This file is attached to the current record.");if(this.props.model==="ir.ui.view"){this.removeTitle=_t("This file is a public view attachment.");}}
remove(ev){ev.stopPropagation();this.props.remove();}}
const AttachmentError=__exports.AttachmentError=class AttachmentError extends Component{static components={Dialog};static template=xml`
        <Dialog title="title">
            <div class="form-text">
                <p>The image could not be deleted because it is used in the
                    following pages or views:</p>
                <ul t-foreach="props.views"  t-as="view" t-key="view.id">
                    <li>
                        <a t-att-href="'/odoo/ir.ui.view/' + window.encodeURIComponent(view.id)">
                            <t t-esc="view.name"/>
                        </a>
                    </li>
                </ul>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="() => this.props.close()">
                    Ok
                </button>
            </t>
        </Dialog>`;static props=["views","close"];setup(){this.title=_t("Alert");}}
const Attachment=__exports.Attachment=class Attachment extends Component{static template="";static components={RemoveButton,};static props=["*"];setup(){this.dialogs=useService("dialog");}
remove(){this.dialogs.add(ConfirmationDialog,{body:_t("Are you sure you want to delete this file?"),confirm:async()=>{const prevented=await rpc("/web_editor/attachment/remove",{ids:[this.props.id],});if(!Object.keys(prevented).length){this.props.onRemoved(this.props.id);}else{this.dialogs.add(AttachmentError,{views:prevented[this.props.id],});}},});}}
const FileSelectorControlPanel=__exports.FileSelectorControlPanel=class FileSelectorControlPanel extends Component{static template="html_editor.FileSelectorControlPanel";static components={SearchMedia,};static props={uploadUrl:Function,validateUrl:Function,uploadFiles:Function,changeSearchService:Function,changeShowOptimized:Function,search:Function,accept:{type:String,optional:true},addText:{type:String,optional:true},multiSelect:{type:true,optional:true},needle:{type:String,optional:true},searchPlaceholder:{type:String,optional:true},searchService:{type:String,optional:true},showOptimized:{type:Boolean,optional:true},showOptimizedOption:{type:String,optional:true},uploadText:{type:String,optional:true},urlPlaceholder:{type:String,optional:true},urlWarningTitle:{type:String,optional:true},useMediaLibrary:{type:Boolean,optional:true},useUnsplash:{type:Boolean,optional:true},};setup(){this.state=useState({showUrlInput:false,urlInput:"",isValidUrl:false,isValidFileFormat:false,isValidatingUrl:false,});this.debouncedValidateUrl=useDebounced(this.props.validateUrl,500);this.fileInput=useRef("file-input");}
get showSearchServiceSelect(){return this.props.searchService&&this.props.needle;}
get enableUrlUploadClick(){return(!this.state.showUrlInput||(this.state.urlInput&&this.state.isValidUrl&&this.state.isValidFileFormat));}
async onUrlUploadClick(){if(!this.state.showUrlInput){this.state.showUrlInput=true;}else{await this.props.uploadUrl(this.state.urlInput);this.state.urlInput="";}}
async onUrlInput(ev){this.state.isValidatingUrl=true;const{isValidUrl,isValidFileFormat}=await this.debouncedValidateUrl(ev.target.value);this.state.isValidFileFormat=isValidFileFormat;this.state.isValidUrl=isValidUrl;this.state.isValidatingUrl=false;}
onClickUpload(){this.fileInput.el.click();}
async onChangeFileInput(){const inputFiles=this.fileInput.el.files;if(!inputFiles.length){return;}
await this.props.uploadFiles(inputFiles);this.fileInput.el.value="";}}
const FileSelector=__exports.FileSelector=class FileSelector extends Component{static template="html_editor.FileSelector";static components={FileSelectorControlPanel,};static props=["*"];setup(){this.notificationService=useService("notification");this.orm=useService("orm");this.uploadService=useService("upload");this.keepLast=new KeepLast();this.loadMoreButtonRef=useRef("load-more-button");this.existingAttachmentsRef=useRef("existing-attachments");this.state=useState({attachments:[],canScrollAttachments:false,canLoadMoreAttachments:false,isFetchingAttachments:false,needle:"",});this.NUMBER_OF_ATTACHMENTS_TO_DISPLAY=30;onWillStart(async()=>{this.state.attachments=await this.fetchAttachments(this.NUMBER_OF_ATTACHMENTS_TO_DISPLAY,0);});this.debouncedOnScroll=useDebounced(this.updateScroll,15);this.debouncedScrollUpdate=useDebounced(this.updateScroll,500);useEffect((modalEl)=>{if(modalEl){modalEl.addEventListener("scroll",this.debouncedOnScroll);return()=>{modalEl.removeEventListener("scroll",this.debouncedOnScroll);};}},()=>[this.props.modalRef.el?.querySelector("main.modal-body")]);useEffect(()=>{this.loadMoreButtonRef.el.classList.add("o_hide_loading");this.state.canScrollAttachments=false;this.debouncedScrollUpdate();},()=>[this.allAttachments.length]);}
get canLoadMore(){return this.state.canLoadMoreAttachments;}
get hasContent(){return this.state.attachments.length;}
get isFetching(){return this.state.isFetchingAttachments;}
get selectedAttachmentIds(){return this.props.selectedMedia[this.props.id].filter((media)=>media.mediaType==="attachment").map(({id})=>id);}
get attachmentsDomain(){const domain=["&",["res_model","=",this.props.resModel],["res_id","=",this.props.resId||0],];domain.unshift("|",["public","=",true]);domain.push(["name","ilike",this.state.needle]);return domain;}
get allAttachments(){return this.state.attachments;}
validateUrl(url){const path=url.split("?")[0];const isValidUrl=/^.+\..+$/.test(path);const isValidFileFormat=true;return{isValidUrl,isValidFileFormat,path};}
async fetchAttachments(limit,offset){this.state.isFetchingAttachments=true;let attachments=[];try{attachments=await this.orm.call("ir.attachment","search_read",[],{domain:this.attachmentsDomain,fields:["name","mimetype","description","checksum","url","type","res_id","res_model","public","access_token","image_src","image_width","image_height","original_id",],order:"id desc",limit,offset,});attachments.forEach((attachment)=>(attachment.mediaType="attachment"));}catch(e){if(e.exceptionName!=="odoo.exceptions.AccessError"){throw e;}}
this.state.canLoadMoreAttachments=attachments.length>=this.NUMBER_OF_ATTACHMENTS_TO_DISPLAY;this.state.isFetchingAttachments=false;return attachments;}
async handleLoadMore(){await this.loadMore();}
async loadMore(){return this.keepLast.add(this.fetchAttachments(this.NUMBER_OF_ATTACHMENTS_TO_DISPLAY,this.state.attachments.length)).then((newAttachments)=>{this.state.attachments.push(...newAttachments);});}
async handleSearch(needle){await this.search(needle);}
async search(needle){this.state.attachments=[];this.state.needle=needle;return this.keepLast.add(this.fetchAttachments(this.NUMBER_OF_ATTACHMENTS_TO_DISPLAY,0)).then((attachments)=>{this.state.attachments=attachments;});}
async uploadFiles(files){await this.uploadService.uploadFiles(files,{resModel:this.props.resModel,resId:this.props.resId},(attachment)=>this.onUploaded(attachment));}
async uploadUrl(url){await fetch(url).then(async(result)=>{const blob=await result.blob();blob.id=new Date().getTime();blob.name=new URL(url).pathname.split("/").findLast((s)=>s);await this.uploadFiles([blob]);}).catch(async()=>{await new Promise((resolve)=>{const imageEl=document.createElement("img");imageEl.onerror=()=>{this.notificationService.add(_t("An error occurred while fetching the entered URL."),{title:_t("Error"),sticky:true,});resolve();};imageEl.onload=()=>{this.uploadService.uploadUrl(url,{resModel:this.props.resModel,resId:this.props.resId,},(attachment)=>this.onUploaded(attachment)).then(resolve);};imageEl.src=url;});});}
async onUploaded(attachment){this.state.attachments=[attachment,...this.state.attachments.filter((attach)=>attach.id!==attachment.id),];this.selectAttachment(attachment);if(!this.props.multiSelect){await this.props.save();}
if(this.props.onAttachmentChange){this.props.onAttachmentChange(attachment);}}
onRemoved(attachmentId){this.state.attachments=this.state.attachments.filter((attachment)=>attachment.id!==attachmentId);}
selectAttachment(attachment){this.props.selectMedia({...attachment,mediaType:"attachment"});}
selectInitialMedia(){return(this.props.media&&this.constructor.tagNames.includes(this.props.media.tagName)&&!this.selectedAttachmentIds.length);}
updateScroll(){const loadMoreTop=this.loadMoreButtonRef.el.getBoundingClientRect().top;const modalEl=this.props.modalRef.el.querySelector("main.modal-body");const modalBottom=modalEl.getBoundingClientRect().bottom;this.state.canScrollAttachments=loadMoreTop>=modalBottom;this.loadMoreButtonRef.el.classList.remove("o_hide_loading");}
isAttachmentHidden(attachmentEl){const attachmentBottom=Math.round(attachmentEl.getBoundingClientRect().bottom);const modalEl=this.props.modalRef.el.querySelector("main.modal-body");const modalBottom=modalEl.getBoundingClientRect().bottom;return attachmentBottom>modalBottom;}
handleScrollAttachments(){let scrollToEl=this.loadMoreButtonRef.el;const attachmentEls=[...this.existingAttachmentsRef.el.querySelectorAll(".o_existing_attachment_cell"),];const firstHiddenAttachmentEl=attachmentEls.find((el)=>this.isAttachmentHidden(el));if(firstHiddenAttachmentEl){const attachmentBottom=firstHiddenAttachmentEl.getBoundingClientRect().bottom;const attachmentIndex=attachmentEls.indexOf(firstHiddenAttachmentEl);const firstNextRowAttachmentEl=attachmentEls.slice(attachmentIndex).find((el)=>{return el.getBoundingClientRect().bottom>attachmentBottom;});scrollToEl=firstNextRowAttachmentEl||scrollToEl;}
scrollToEl.scrollIntoView({block:"end",inline:"nearest",behavior:"smooth"});}}
return __exports;});;

/* /html_editor/static/src/main/media/media_dialog/icon_selector.js */
odoo.define('@html_editor/main/media/media_dialog/icon_selector',['@html_editor/main/media/media_dialog/search_media','@html_editor/utils/fonts','@odoo/owl'],function(require){'use strict';let __exports={};const{SearchMedia}=require("@html_editor/main/media/media_dialog/search_media");const{fonts}=require("@html_editor/utils/fonts");const{Component,useState}=require("@odoo/owl");const IconSelector=__exports.IconSelector=class IconSelector extends Component{static mediaSpecificClasses=["fa"];static mediaSpecificStyles=["color","background-color"];static mediaExtraClasses=["rounded-circle","rounded","img-thumbnail","shadow",/^text-\S+$/,/^bg-\S+$/,/^fa-\S+$/,];static tagNames=["SPAN","I"];static template="html_editor.IconSelector";static components={SearchMedia,};static props=["*"];setup(){this.state=useState({fonts:this.props.fonts,needle:"",});}
get selectedMediaIds(){return this.props.selectedMedia[this.props.id].map(({id})=>id);}
search(needle){this.state.needle=needle;if(!this.state.needle){this.state.fonts=this.props.fonts;}else{this.state.fonts=this.props.fonts.map((font)=>{const icons=font.icons.filter((icon)=>icon.alias.indexOf(this.state.needle.toLowerCase())>=0);return{...font,icons};});}}
async onClickIcon(font,icon){this.props.selectMedia({...icon,fontBase:font.base,initialIconChanged:this.props.media&&!icon.names.some((name)=>this.props.media.classList.contains(name)),});await this.props.save();}
static createElements(selectedMedia){return selectedMedia.map((icon)=>{const iconEl=document.createElement("span");iconEl.classList.add(icon.fontBase,icon.names[0]);return iconEl;});}
static initFonts(){fonts.computeFonts();const allFonts=fonts.fontIcons.map(({cssData,base})=>{const uniqueIcons=Array.from(new Map(cssData.map((icon)=>{const alias=icon.names.join(",");const id=`${base}_${alias}`;return[id,{...icon,alias,id}];})).values());return{base,icons:uniqueIcons};});return allFonts;}}
return __exports;});;

/* /html_editor/static/src/main/media/media_dialog/image_selector.js */
odoo.define('@html_editor/main/media/media_dialog/image_selector',['@odoo/owl','@web/core/l10n/translation','@web/core/network/rpc','@web/core/utils/concurrency','@html_editor/utils/color','@html_editor/utils/formatting','@html_editor/main/media/media_dialog/file_selector'],function(require){'use strict';let __exports={};const{useEffect,useRef,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{KeepLast}=require("@web/core/utils/concurrency");const{DEFAULT_PALETTE}=require("@html_editor/utils/color");const{getCSSVariableValue,getHtmlStyle}=require("@html_editor/utils/formatting");const{Attachment,FileSelector,IMAGE_EXTENSIONS,IMAGE_MIMETYPES}=require("@html_editor/main/media/media_dialog/file_selector");const AutoResizeImage=__exports.AutoResizeImage=class AutoResizeImage extends Attachment{static template="html_editor.AutoResizeImage";setup(){super.setup();this.image=useRef("auto-resize-image");this.container=useRef("auto-resize-image-container");this.state=useState({loaded:false,});useEffect(()=>{this.image.el.addEventListener("load",()=>this.onImageLoaded());return this.image.el.removeEventListener("load",()=>this.onImageLoaded());},()=>[]);}
async onImageLoaded(){if(!this.image.el){return;}
if(this.props.onLoaded){await this.props.onLoaded(this.image.el);if(!this.image.el){return;}}
const aspectRatio=this.image.el.offsetWidth/this.image.el.offsetHeight;const width=aspectRatio*this.props.minRowHeight;this.container.el.style.flexGrow=width;this.container.el.style.flexBasis=`${width}px`;this.state.loaded=true;}}
const newLocal="img-fluid";const ImageSelector=__exports.ImageSelector=class ImageSelector extends FileSelector{static mediaSpecificClasses=["img",newLocal,"o_we_custom_image"];static mediaSpecificStyles=[];static mediaExtraClasses=["rounded-circle","rounded","img-thumbnail","shadow","w-25","w-50","w-75","w-100",];static tagNames=["IMG"];static attachmentsListTemplate="html_editor.ImagesListTemplate";static components={...FileSelector.components,AutoResizeImage,};setup(){super.setup();this.keepLastLibraryMedia=new KeepLast();this.state.libraryMedia=[];this.state.libraryResults=null;this.state.isFetchingLibrary=false;this.state.searchService="all";this.state.showOptimized=false;this.NUMBER_OF_MEDIA_TO_DISPLAY=10;this.uploadText=_t("Upload an image");this.urlPlaceholder="https://www.odoo.com/logo.png";this.addText=_t("Add URL");this.searchPlaceholder=_t("Search an image");this.urlWarningTitle=_t("Uploaded image's format is not supported. Try with: "+IMAGE_EXTENSIONS.join(", "));this.allLoadedText=_t("All images have been loaded");this.showOptimizedOption=this.env.debug;this.MIN_ROW_HEIGHT=128;this.fileMimetypes=IMAGE_MIMETYPES.join(",");}
get canLoadMore(){if(this.state.searchService==="media-library"){return(this.state.libraryResults&&this.state.libraryMedia.length<this.state.libraryResults);}
return super.canLoadMore;}
get hasContent(){if(this.state.searchService==="all"){return super.hasContent||!!this.state.libraryMedia.length;}else if(this.state.searchService==="media-library"){return!!this.state.libraryMedia.length;}
return super.hasContent;}
get isFetching(){return super.isFetching||this.state.isFetchingLibrary;}
get selectedMediaIds(){return this.props.selectedMedia[this.props.id].filter((media)=>media.mediaType==="libraryMedia").map(({id})=>id);}
get allAttachments(){return[...super.allAttachments,...this.state.libraryMedia];}
get attachmentsDomain(){const domain=super.attachmentsDomain;domain.push(["mimetype","in",IMAGE_MIMETYPES]);if(!this.props.useMediaLibrary){domain.push("|",["url","=",false],"!","|",["url","=ilike","/html_editor/shape/%"],["url","=ilike","/web_editor/shape/%"],);}
domain.push("!",["name","=like","%.crop"]);domain.push("|",["type","=","binary"],"!",["url","=like","/%/static/%"]);if(!this.env.debug){const subDomain=[false];const originalId=this.props.media&&this.props.media.dataset.originalId;if(originalId){subDomain.push(originalId);}
domain.push(["original_id","in",subDomain]);}
return domain;}
async uploadFiles(files){await this.uploadService.uploadFiles(files,{resModel:this.props.resModel,resId:this.props.resId,isImage:true},(attachment)=>this.onUploaded(attachment));}
async validateUrl(...args){const{isValidUrl,path}=super.validateUrl(...args);const isValidFileFormat=isValidUrl&&(await new Promise((resolve)=>{const img=new Image();img.src=path;img.onload=()=>resolve(true);img.onerror=()=>resolve(false);}));return{isValidFileFormat,isValidUrl};}
isInitialMedia(attachment){if(this.props.media.dataset.originalSrc){return this.props.media.dataset.originalSrc===attachment.image_src;}
return this.props.media.getAttribute("src")===attachment.image_src;}
async fetchAttachments(limit,offset){const attachments=await super.fetchAttachments(limit,offset);const primaryColors={};const htmlStyle=getHtmlStyle(document);for(let color=1;color<=5;color++){primaryColors[color]=getCSSVariableValue("o-color-"+color,htmlStyle);}
return attachments.map((attachment)=>{if(attachment.image_src.startsWith("/")){const newURL=new URL(attachment.image_src,window.location.origin);if(attachment.image_src.startsWith("/html_editor/shape/")||attachment.image_src.startsWith("/web_editor/shape/")){newURL.searchParams.forEach((value,key)=>{const match=key.match(/^c([1-5])$/);if(match){newURL.searchParams.set(key,primaryColors[match[1]]);}});}else{newURL.searchParams.set("height",2*this.MIN_ROW_HEIGHT);}
attachment.thumbnail_src=newURL.pathname+newURL.search;}
if(this.selectInitialMedia()&&this.isInitialMedia(attachment)){this.selectAttachment(attachment);}
return attachment;});}
async fetchLibraryMedia(offset){if(!this.state.needle){return{media:[],results:null};}
this.state.isFetchingLibrary=true;try{const response=await rpc("/web_editor/media_library_search",{query:this.state.needle,offset:offset,},{silent:true,});this.state.isFetchingLibrary=false;const media=(response.media||[]).slice(0,this.NUMBER_OF_MEDIA_TO_DISPLAY);media.forEach((record)=>(record.mediaType="libraryMedia"));return{media,results:response.results};}catch{console.error(`Couldn't reach API endpoint.`);this.state.isFetchingLibrary=false;return{media:[],results:null};}}
async loadMore(...args){await super.loadMore(...args);if(!this.props.useMediaLibrary||this.state.searchService!=="media-library"){return;}
return this.keepLastLibraryMedia.add(this.fetchLibraryMedia(this.state.libraryMedia.length)).then(({media})=>{this.state.libraryMedia.push(...media);});}
async search(...args){await super.search(...args);if(!this.props.useMediaLibrary){return;}
if(!this.state.needle){this.state.searchService="all";}
this.state.libraryMedia=[];this.state.libraryResults=0;return this.keepLastLibraryMedia.add(this.fetchLibraryMedia(0)).then(({media,results})=>{this.state.libraryMedia=media;this.state.libraryResults=results;});}
async onClickAttachment(attachment){this.selectAttachment(attachment);if(!this.props.multiSelect){await this.props.save();}}
async onClickMedia(media){this.props.selectMedia({...media,mediaType:"libraryMedia"});if(!this.props.multiSelect){await this.props.save();}}
static async createElements(selectedMedia,{orm}){const toSave=Object.fromEntries(selectedMedia.filter((media)=>media.mediaType==="libraryMedia").map((media)=>[media.id,{query:media.query||"",is_dynamic_svg:!!media.isDynamicSVG,dynamic_colors:media.dynamicColors,},]));let savedMedia=[];if(Object.keys(toSave).length!==0){savedMedia=await rpc("/html_editor/save_library_media",{media:toSave});}
const selected=selectedMedia.filter((media)=>media.mediaType==="attachment").concat(savedMedia).map((attachment)=>{if(attachment.image_src&&(attachment.image_src.startsWith("/html_editor/shape/")||attachment.image_src.startsWith("/web_editor/shape/"))){const colorCustomizedURL=new URL(attachment.image_src,window.location.origin);const htmlStyle=getHtmlStyle(document);colorCustomizedURL.searchParams.forEach((value,key)=>{const match=key.match(/^c([1-5])$/);if(match){colorCustomizedURL.searchParams.set(key,getCSSVariableValue(`o-color-${match[1]}`,htmlStyle));}});attachment.image_src=colorCustomizedURL.pathname+colorCustomizedURL.search;}
return attachment;});return Promise.all(selected.map(async(attachment)=>{const imageEl=document.createElement("img");let src=attachment.image_src;if(!attachment.public&&!attachment.url){let accessToken=attachment.access_token;if(!accessToken){[accessToken]=await orm.call("ir.attachment","generate_access_token",[attachment.id,]);}
src+=`?access_token=${encodeURIComponent(accessToken)}`;}
imageEl.src=src;imageEl.alt=attachment.description||"";return imageEl;}));}
async onImageLoaded(imgEl,attachment){this.debouncedScrollUpdate();if(attachment.mediaType==="libraryMedia"&&!imgEl.src.startsWith("blob")){await this.onLibraryImageLoaded(imgEl,attachment);}}
async onLibraryImageLoaded(imgEl,media){const mediaUrl=imgEl.src;try{const response=await fetch(mediaUrl);if(response.headers.get("content-type")==="image/svg+xml"){let svg=await response.text();const dynamicColors={};const combinedColorsRegex=new RegExp(Object.values(DEFAULT_PALETTE).join("|"),"gi");const htmlStyle=getHtmlStyle(document);svg=svg.replace(combinedColorsRegex,(match)=>{const colorId=Object.keys(DEFAULT_PALETTE).find((key)=>DEFAULT_PALETTE[key]===match.toUpperCase());const colorKey="c"+colorId;dynamicColors[colorKey]=getCSSVariableValue("o-color-"+colorId,htmlStyle);return dynamicColors[colorKey];});const fileName=mediaUrl.split("/").pop();const file=new File([svg],fileName,{type:"image/svg+xml",});imgEl.src=URL.createObjectURL(file);if(Object.keys(dynamicColors).length){media.isDynamicSVG=true;media.dynamicColors=dynamicColors;}}}catch{console.error("CORS is misconfigured on the API server, image will be treated as non-dynamic.");}}}
return __exports;});;

/* /html_editor/static/src/main/media/media_dialog/media_dialog.js */
odoo.define('@html_editor/main/media/media_dialog/media_dialog',['@web/core/l10n/translation','@web/core/utils/hooks','@web/core/dialog/dialog','@web/core/notebook/notebook','@html_editor/main/media/media_dialog/image_selector','@html_editor/main/media/media_dialog/icon_selector','@html_editor/main/media/media_dialog/video_selector','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService,useChildRef}=require("@web/core/utils/hooks");const{Dialog}=require("@web/core/dialog/dialog");const{Notebook}=require("@web/core/notebook/notebook");const{ImageSelector}=require("@html_editor/main/media/media_dialog/image_selector");const{IconSelector}=require("@html_editor/main/media/media_dialog/icon_selector");const{VideoSelector}=require("@html_editor/main/media/media_dialog/video_selector");const{Component,useState,useRef,useEffect}=require("@odoo/owl");const TABS=__exports.TABS={IMAGES:{id:"IMAGES",title:_t("Images"),Component:ImageSelector,sequence:10,},ICONS:{id:"ICONS",title:_t("Icons"),Component:IconSelector,sequence:20,},VIDEOS:{id:"VIDEOS",title:_t("Videos"),Component:VideoSelector,sequence:30,},};const DEFAULT_SEQUENCE=50;const sequence=(tab)=>tab.sequence??DEFAULT_SEQUENCE;const MediaDialog=__exports.MediaDialog=class MediaDialog extends Component{static template="html_editor.MediaDialog";static defaultProps={useMediaLibrary:true,};static components={Dialog,Notebook,};static props=["*"];setup(){this.size="xl";this.contentClass="o_select_media_dialog h-100";this.title=_t("Select a media");this.modalRef=useChildRef();this.orm=useService("orm");this.notificationService=useService("notification");this.selectedMedia=useState({});this.addButtonRef=useRef("add-button");this.initialIconClasses=[];this.tabs={...TABS};this.notebookPages=[];this.addDefaultTabs();this.addExtraTabs();this.notebookPages.sort((a,b)=>sequence(a)-sequence(b));this.errorMessages={};this.state=useState({activeTab:this.initialActiveTab,});useEffect((nbSelectedAttachments)=>{this.addButtonRef.el.toggleAttribute("disabled",!nbSelectedAttachments);},()=>[this.selectedMedia[this.state.activeTab].length]);}
get initialActiveTab(){if(this.props.activeTab){return this.props.activeTab;}
if(this.props.media){const correspondingTab=Object.keys(this.tabs).find((id)=>this.tabs[id].Component.tagNames.includes(this.props.media.tagName));if(correspondingTab){return correspondingTab;}}
return this.notebookPages[0].id;}
addTab(tab,additionalProps={}){this.selectedMedia[tab.id]=[];this.notebookPages.push({...tab,props:{...tab.props,...additionalProps,id:tab.id,resModel:this.props.resModel,resId:this.props.resId,media:this.props.media,selectedMedia:this.selectedMedia,selectMedia:(...args)=>this.selectMedia(...args,tab.id,additionalProps.multiSelect),save:this.save.bind(this),onAttachmentChange:this.props.onAttachmentChange,errorMessages:(errorMessage)=>(this.errorMessages[tab.id]=errorMessage),modalRef:this.modalRef,},});}
addTabs(){this.addDefaultTabs();}
addDefaultTabs(){const onlyImages=this.props.onlyImages||(this.props.media&&this.props.media.parentElement&&(this.props.media.parentElement.dataset.oeField==="image"||this.props.media.parentElement.dataset.oeType==="image"));const noIcons=onlyImages||this.props.noIcons;const noVideos=onlyImages||this.props.noVideos;if(!this.props.noImages){this.addTab(TABS.IMAGES,{useMediaLibrary:this.props.useMediaLibrary,multiSelect:this.props.multiImages,});}
if(!noIcons){const fonts=TABS.ICONS.Component.initFonts();this.addTab(TABS.ICONS,{fonts,});if(this.props.media&&TABS.ICONS.Component.tagNames.includes(this.props.media.tagName)){const classes=this.props.media.className.split(/\s+/);const mediaFont=fonts.find((font)=>classes.includes(font.base));if(mediaFont){const selectedIcon=mediaFont.icons.find((icon)=>icon.names.some((name)=>classes.includes(name)));if(selectedIcon){this.initialIconClasses.push(...selectedIcon.names);this.selectMedia(selectedIcon,TABS.ICONS.id);}}}}
if(!noVideos){this.addTab(TABS.VIDEOS,{vimeoPreviewIds:this.props.vimeoPreviewIds,isForBgVideo:this.props.isForBgVideo,});}}
addExtraTabs(){for(const tab of this.props.extraTabs||[]){this.addTab(tab);this.tabs[tab.id]=tab;}}
async renderMedia(selectedMedia){const elements=await this.tabs[this.state.activeTab].Component.createElements(selectedMedia,{orm:this.orm});elements.forEach((element)=>{if(this.props.media){element.classList.add(...this.props.media.classList);const style=this.props.media.getAttribute("style");if(style){element.setAttribute("style",style);}
if(this.state.activeTab===this.tabs.IMAGES.id){if(this.props.media.dataset.shape){element.dataset.shape=this.props.media.dataset.shape;}
if(this.props.media.dataset.shapeColors){element.dataset.shapeColors=this.props.media.dataset.shapeColors;}
if(this.props.media.dataset.shapeFlip){element.dataset.shapeFlip=this.props.media.dataset.shapeFlip;}
if(this.props.media.dataset.shapeRotate){element.dataset.shapeRotate=this.props.media.dataset.shapeRotate;}
if(this.props.media.dataset.hoverEffect){element.dataset.hoverEffect=this.props.media.dataset.hoverEffect;}
if(this.props.media.dataset.hoverEffectColor){element.dataset.hoverEffectColor=this.props.media.dataset.hoverEffectColor;}
if(this.props.media.dataset.hoverEffectStrokeWidth){element.dataset.hoverEffectStrokeWidth=this.props.media.dataset.hoverEffectStrokeWidth;}
if(this.props.media.dataset.hoverEffectIntensity){element.dataset.hoverEffectIntensity=this.props.media.dataset.hoverEffectIntensity;}}}
for(const otherTab of Object.keys(this.tabs).filter((key)=>key!==this.state.activeTab)){for(const property of this.tabs[otherTab].Component.mediaSpecificStyles){element.style.removeProperty(property);}
element.classList.remove(...this.tabs[otherTab].Component.mediaSpecificClasses);const extraClassesToRemove=[];for(const name of this.tabs[otherTab].Component.mediaExtraClasses){if(typeof name==="string"){extraClassesToRemove.push(name);}else{for(const className of element.classList){if(className.match(name)){extraClassesToRemove.push(className);}}}}
element.classList.remove(...extraClassesToRemove.filter((candidateName)=>{for(const name of this.tabs[this.state.activeTab].Component.mediaExtraClasses){if(typeof name==="string"){if(candidateName===name){return false;}}else{for(const className of element.classList){if(className.match(candidateName)){return false;}}}}
return true;}));}
element.classList.remove(...this.initialIconClasses);element.classList.remove("o_modified_image_to_save");element.classList.remove("oe_edited_link");element.classList.add(...this.tabs[this.state.activeTab].Component.mediaSpecificClasses);});return elements;}
selectMedia(media,tabId,multiSelect){if(multiSelect){const isMediaSelected=this.selectedMedia[tabId].map(({id})=>id).includes(media.id);if(!isMediaSelected){this.selectedMedia[tabId].push(media);}else{this.selectedMedia[tabId]=this.selectedMedia[tabId].filter((m)=>m.id!==media.id);}}else{this.selectedMedia[tabId]=[media];}}
async save(){if(this.errorMessages[this.state.activeTab]){this.notificationService.add(this.errorMessages[this.state.activeTab],{type:"danger",});return;}
const selectedMedia=this.selectedMedia[this.state.activeTab];const saveSelectedMedia=selectedMedia.length&&(this.state.activeTab!==this.tabs.ICONS.id||selectedMedia[0].initialIconChanged||!this.props.media);if(saveSelectedMedia){const elements=await this.renderMedia(selectedMedia);if(this.props.multiImages){this.props.save(elements);}else{this.props.save(elements[0]);}}
this.props.close();}
onTabChange(tab){this.state.activeTab=tab;}}
return __exports;});;

/* /html_editor/static/src/main/media/media_dialog/search_media.js */
odoo.define('@html_editor/main/media/media_dialog/search_media',['@web/core/utils/timing','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useDebounced}=require("@web/core/utils/timing");const{useAutofocus}=require("@web/core/utils/hooks");const{Component,xml,useEffect,useState}=require("@odoo/owl");const SearchMedia=__exports.SearchMedia=class SearchMedia extends Component{static template=xml`
        <div class="position-relative mw-lg-25 flex-grow-1 me-auto">
            <input type="text" class="o_we_search o_input form-control" t-att-placeholder="props.searchPlaceholder.trim()" t-model="state.input" t-ref="autofocus"/>
            <i class="oi oi-search input-group-text position-absolute end-0 top-50 me-n3 px-2 py-1 translate-middle bg-transparent border-0" title="Search" role="img" aria-label="Search"/>
        </div>`;static props=["searchPlaceholder","search","needle"];setup(){useAutofocus({mobile:true});this.debouncedSearch=useDebounced(this.props.search,1000);this.state=useState({input:this.props.needle||"",});useEffect((input)=>{if(this.hasRendered){this.debouncedSearch(input);}else{this.hasRendered=true;}},()=>[this.state.input]);}}
return __exports;});;

/* /html_editor/static/src/main/media/media_dialog/upload_progress_toast/upload_progress_toast.js */
odoo.define('@html_editor/main/media/media_dialog/upload_progress_toast/upload_progress_toast',['@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{Component,useState}=require("@odoo/owl");const ProgressBar=__exports.ProgressBar=class ProgressBar extends Component{static template="html_editor.ProgressBar";static props={progress:{type:Number,optional:true},hasError:{type:Boolean,optional:true},uploaded:{type:Boolean,optional:true},name:String,size:{type:String,optional:true},errorMessage:{type:String,optional:true},};static defaultProps={progress:0,hasError:false,uploaded:false,size:"",errorMessage:"",};get progress(){return Math.round(this.props.progress);}}
const UploadProgressToast=__exports.UploadProgressToast=class UploadProgressToast extends Component{static template="html_editor.UploadProgressToast";static components={ProgressBar,};static props={close:Function,};setup(){this.uploadService=useService("upload");this.state=useState(this.uploadService.progressToast);}}
return __exports;});;

/* /html_editor/static/src/main/media/media_dialog/upload_progress_toast/upload_service.js */
odoo.define('@html_editor/main/media/media_dialog/upload_progress_toast/upload_service',['@web/core/network/rpc','@web/core/registry','@html_editor/main/media/media_dialog/upload_progress_toast/upload_progress_toast','@web/core/l10n/translation','@web/core/utils/files','@web/core/utils/numbers','@web/core/utils/urls','@web/core/utils/strings','@odoo/owl'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{UploadProgressToast}=require("@html_editor/main/media/media_dialog/upload_progress_toast/upload_progress_toast");const{_t}=require("@web/core/l10n/translation");const{checkFileSize}=require("@web/core/utils/files");const{humanNumber}=require("@web/core/utils/numbers");const{getDataURLFromFile}=require("@web/core/utils/urls");const{sprintf}=require("@web/core/utils/strings");const{reactive}=require("@odoo/owl");const AUTOCLOSE_DELAY=__exports.AUTOCLOSE_DELAY=3000;const AUTOCLOSE_DELAY_LONG=__exports.AUTOCLOSE_DELAY_LONG=8000;const uploadService=__exports.uploadService={dependencies:["notification"],start(env,{notification}){let fileId=0;const progressToast=reactive({files:{},isVisible:false,});registry.category("main_components").add("UploadProgressToast",{Component:UploadProgressToast,props:{close:()=>(progressToast.isVisible=false),},});const addFile=(file)=>{progressToast.files[file.id]=file;progressToast.isVisible=true;return progressToast.files[file.id];};const deleteFile=(fileId)=>{delete progressToast.files[fileId];if(!Object.keys(progressToast.files).length){progressToast.isVisible=false;}};return{get progressToast(){return progressToast;},get fileId(){return fileId;},addFile,deleteFile,incrementId(){fileId++;},uploadUrl:async(url,{resModel,resId},onUploaded)=>{const attachment=await rpc("/html_editor/attachment/add_url",{url,res_model:resModel,res_id:resId,});await onUploaded(attachment);},uploadFiles:async(files,{resModel,resId,isImage},onUploaded)=>{const sortedFiles=Array.from(files).sort((a,b)=>a.size-b.size);for(const file of sortedFiles){let fileSize=file.size;if(!checkFileSize(fileSize,notification)){return null;}
if(!fileSize){fileSize="";}else{fileSize=humanNumber(fileSize)+"B";}
const id=++fileId;file.progressToastId=id;addFile({id,name:file.name,size:fileSize,});}
for(const sortedFile of sortedFiles){const file=progressToast.files[sortedFile.progressToastId];let dataURL;try{dataURL=await getDataURLFromFile(sortedFile);}catch{deleteFile(file.id);env.services.notification.add(sprintf(_t('Could not load the file "%s".'),sortedFile.name),{type:"danger"});continue;}
try{const xhr=new XMLHttpRequest();xhr.upload.addEventListener("progress",(ev)=>{const rpcComplete=(ev.loaded/ev.total)*100;file.progress=rpcComplete;});xhr.upload.addEventListener("load",function(){file.progress=100;});const attachment=await rpc("/html_editor/attachment/add_data",{name:file.name,data:dataURL.split(",")[1],res_id:resId,res_model:resModel,is_image:!!isImage,width:0,quality:0,},{xhr});if(attachment.error){file.hasError=true;file.errorMessage=attachment.error;}else{if(attachment.mimetype==="image/webp"){const image=document.createElement("img");image.src=`data:image/webp;base64,${dataURL.split(",")[1]}`;await new Promise((resolve)=>image.addEventListener("load",resolve));const canvas=document.createElement("canvas");canvas.width=image.width;canvas.height=image.height;const ctx=canvas.getContext("2d");ctx.fillStyle="rgb(255, 255, 255)";ctx.fillRect(0,0,canvas.width,canvas.height);ctx.drawImage(image,0,0);const altDataURL=canvas.toDataURL("image/jpeg",0.75);await rpc("/html_editor/attachment/add_data",{name:file.name.replace(/\.webp$/,".jpg"),data:altDataURL.split(",")[1],res_id:attachment.id,res_model:"ir.attachment",is_image:true,width:0,quality:0,},{xhr});}
file.uploaded=true;await onUploaded(attachment);}
const message_autoclose_delay=file.hasError?AUTOCLOSE_DELAY_LONG:AUTOCLOSE_DELAY;setTimeout(()=>deleteFile(file.id),message_autoclose_delay);}catch(error){file.hasError=true;setTimeout(()=>deleteFile(file.id),AUTOCLOSE_DELAY_LONG);throw error;}}},};},};registry.category("services").add("upload",uploadService);return __exports;});;

/* /html_editor/static/src/main/media/media_dialog/video_selector.js */
odoo.define('@html_editor/main/media/media_dialog/video_selector',['@web/core/l10n/translation','@web/core/network/rpc','@web/core/utils/hooks','@web/core/utils/timing','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{useAutofocus,useService}=require("@web/core/utils/hooks");const{debounce}=require("@web/core/utils/timing");const{Component,useState,useRef,onMounted,onWillStart}=require("@odoo/owl");class VideoOption extends Component{static template="html_editor.VideoOption";static props={description:{type:String,optional:true},label:{type:String,optional:true},onChangeOption:Function,value:{type:Boolean,optional:true},};}
class VideoIframe extends Component{static template="html_editor.VideoIframe";static props={src:{type:String},};}
const VideoSelector=__exports.VideoSelector=class VideoSelector extends Component{static mediaSpecificClasses=["media_iframe_video"];static mediaSpecificStyles=[];static mediaExtraClasses=[];static tagNames=["IFRAME","DIV"];static template="html_editor.VideoSelector";static components={VideoIframe,VideoOption,};static props={selectMedia:Function,errorMessages:Function,vimeoPreviewIds:{type:Array,optional:true},isForBgVideo:{type:Boolean,optional:true},media:{type:Object,optional:true},"*":true,};static defaultProps={vimeoPreviewIds:[],isForBgVideo:false,};setup(){this.http=useService("http");this.PLATFORMS={youtube:"youtube",dailymotion:"dailymotion",vimeo:"vimeo",youku:"youku",};this.OPTIONS={autoplay:{label:_t("Autoplay"),description:_t("Videos are muted when autoplay is enabled"),platforms:[this.PLATFORMS.youtube,this.PLATFORMS.dailymotion,this.PLATFORMS.vimeo,],urlParameter:"autoplay=1",},loop:{label:_t("Loop"),platforms:[this.PLATFORMS.youtube,this.PLATFORMS.vimeo],urlParameter:"loop=1",},hide_controls:{label:_t("Hide player controls"),platforms:[this.PLATFORMS.youtube,this.PLATFORMS.dailymotion,this.PLATFORMS.vimeo,],urlParameter:"controls=0",},hide_fullscreen:{label:_t("Hide fullscreen button"),platforms:[this.PLATFORMS.youtube],urlParameter:"fs=0",isHidden:()=>this.state.options.filter((option)=>option.id==="hide_controls")[0].value,},hide_dm_logo:{label:_t("Hide Dailymotion logo"),platforms:[this.PLATFORMS.dailymotion],urlParameter:"ui-logo=0",},hide_dm_share:{label:_t("Hide sharing button"),platforms:[this.PLATFORMS.dailymotion],urlParameter:"sharing-enable=0",},};this.state=useState({options:[],src:"",urlInput:"",platform:null,vimeoPreviews:[],errorMessage:"",});this.urlInputRef=useRef("url-input");onWillStart(async()=>{if(this.props.media){const src=this.props.media.dataset.oeExpression||this.props.media.dataset.src||(this.props.media.tagName==="IFRAME"&&this.props.media.getAttribute("src"))||"";if(src){this.state.urlInput=src;await this.updateVideo();this.state.options=this.state.options.map((option)=>{const{urlParameter}=this.OPTIONS[option.id];return{...option,value:src.indexOf(urlParameter)>=0};});}}});onMounted(async()=>{await Promise.all(this.props.vimeoPreviewIds.map(async(videoId)=>{const{thumbnail_url:thumbnailSrc}=await this.http.get(`https://vimeo.com/api/oembed.json?url=http%3A//vimeo.com/${encodeURIComponent(
                            videoId
                        )}`);this.state.vimeoPreviews.push({id:videoId,thumbnailSrc,src:`https://player.vimeo.com/video/${encodeURIComponent(videoId)}`,});}));});useAutofocus();this.onChangeUrl=debounce((ev)=>this.updateVideo(ev.target.value),500);}
get shownOptions(){if(this.props.isForBgVideo){return[];}
return this.state.options.filter((option)=>!this.OPTIONS[option.id].isHidden||!this.OPTIONS[option.id].isHidden());}
async onChangeOption(optionId){this.state.options=this.state.options.map((option)=>{if(option.id===optionId){return{...option,value:!option.value};}
return option;});await this.updateVideo();}
async onClickSuggestion(src){this.state.urlInput=src;await this.updateVideo();}
async updateVideo(){if(!this.state.urlInput){this.state.src="";this.state.urlInput="";this.state.options=[];this.state.platform=null;this.state.errorMessage="";this.props.selectMedia({});return;}
const embedMatch=this.state.urlInput.match(/(src|href)=["']?([^"']+)?/);if(embedMatch&&embedMatch[2].length>0&&embedMatch[2].indexOf("instagram")){embedMatch[1]=embedMatch[2];}
const url=embedMatch?embedMatch[1]:this.state.urlInput;const options={};if(this.props.isForBgVideo){Object.keys(this.OPTIONS).forEach((key)=>{options[key]=true;});}else{for(const option of this.shownOptions){options[option.id]=option.value;}}
const{embed_url:src,video_id:videoId,params,platform,}=await this._getVideoURLData(url,options);if(!src){this.state.errorMessage=_t("The provided url is not valid");}else if(!platform){this.state.errorMessage=_t("The provided url does not reference any supported video");}else{this.state.errorMessage="";}
this.props.errorMessages(this.state.errorMessage);const newOptions=[];if(platform&&platform!==this.state.platform){Object.keys(this.OPTIONS).forEach((key)=>{if(this.OPTIONS[key].platforms.includes(platform)){const{label,description}=this.OPTIONS[key];newOptions.push({id:key,label,description});}});}
this.state.src=src;this.props.selectMedia({id:src,src,platform,videoId,params,});if(platform!==this.state.platform){this.state.platform=platform;this.state.options=newOptions;}}
async _getVideoURLData(url,options){return await rpc("/web_editor/video_url/data",{video_url:url,...options,});}
static createElements(selectedMedia){return selectedMedia.map((video)=>{const div=document.createElement("div");div.dataset.oeExpression=video.src;div.innerHTML='<div class="css_editable_mode_display"></div>'+'<div class="media_iframe_video_size" contenteditable="false"></div>'+'<iframe frameborder="0" contenteditable="false" allowfullscreen="allowfullscreen"></iframe>';div.querySelector("iframe").src=video.src;return div;});}}
return __exports;});;

/* /html_editor/static/src/main/media/media_plugin.js */
odoo.define('@html_editor/main/media/media_plugin',['@html_editor/plugin','@html_editor/utils/dom_info','@html_editor/utils/image','@web/core/l10n/translation','@web/core/network/rpc','@html_editor/main/media/media_dialog/media_dialog','@html_editor/utils/position','@html_editor/utils/resource'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{ICON_SELECTOR,isIconElement,isProtected,isProtecting,}=require("@html_editor/utils/dom_info");const{backgroundImageCssToParts,backgroundImagePartsToCss}=require("@html_editor/utils/image");const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{MediaDialog}=require("@html_editor/main/media/media_dialog/media_dialog");const{rightPos}=require("@html_editor/utils/position");const{withSequence}=require("@html_editor/utils/resource");const MEDIA_SELECTOR=`${ICON_SELECTOR} , .o_image, .media_iframe_video`;const MediaPlugin=__exports.MediaPlugin=class MediaPlugin extends Plugin{static id="media";static dependencies=["selection","history","dom","dialog"];static shared=["savePendingImages"];resources={user_commands:[{id:"replaceImage",title:_t("Replace media"),run:this.replaceImage.bind(this),},{id:"insertMedia",title:_t("Media"),description:_t("Insert image or icon"),keywords:[_t("Image"),_t("Icon")],icon:"fa-file-image-o",run:this.openMediaDialog.bind(this),},],toolbar_groups:withSequence(29,{id:"replace_image",namespace:"image",}),toolbar_items:[{id:"replace_image",groupId:"replace_image",commandId:"replaceImage",text:"Replace",},],powerbox_categories:withSequence(40,{id:"media",name:_t("Media")}),powerbox_items:[...(this.config.disableImage?[]:[{categoryId:"media",commandId:"insertMedia"}]),],power_buttons:withSequence(1,{commandId:"insertMedia"}),clean_handlers:this.clean.bind(this),clean_for_save_handlers:({root})=>this.cleanForSave(root),normalize_handlers:this.normalizeMedia.bind(this),unsplittable_node_predicates:isIconElement,selectors_for_feff_providers:()=>ICON_SELECTOR,};get recordInfo(){return this.config.getRecordInfo?this.config.getRecordInfo():{};}
replaceImage(){const selectedNodes=this.dependencies.selection.getSelectedNodes();const node=selectedNodes.find((node)=>node.tagName==="IMG");if(node){this.openMediaDialog({node});this.dependencies.history.addStep();}}
normalizeMedia(node){const mediaElements=[...node.querySelectorAll(MEDIA_SELECTOR)];if(node.matches(MEDIA_SELECTOR)){mediaElements.push(node);}
for(const el of mediaElements){if(isProtected(el)||isProtecting(el)){continue;}
el.setAttribute("contenteditable",el.hasAttribute("contenteditable")?el.getAttribute("contenteditable"):"false");if(isIconElement(el)){el.textContent="\u200B";}}}
clean(root){for(const el of root.querySelectorAll(MEDIA_SELECTOR)){if(isIconElement(el)){el.textContent="";}}}
cleanForSave(root){for(const el of root.querySelectorAll(MEDIA_SELECTOR)){if(isIconElement(el)){el.textContent="";}
el.removeAttribute("contenteditable");}}
onSaveMediaDialog(element,{node}){if(!element){throw new Error("Element is required: onSaveMediaDialog");}
if(node){const changedIcon=isIconElement(node)&&isIconElement(element);if(changedIcon){for(const attribute of element.attributes){node.setAttribute(attribute.nodeName,attribute.nodeValue);}}else{node.replaceWith(element);}}else{this.dependencies.dom.insert(element);}
const[anchorNode,anchorOffset]=rightPos(element);this.dependencies.selection.setSelection({anchorNode,anchorOffset});this.dependencies.history.addStep();}
openMediaDialog(params={}){const{resModel,resId,field,type}=this.recordInfo;const mediaDialogClosedPromise=this.dependencies.dialog.addDialog(MediaDialog,{resModel,resId,useMediaLibrary:!!(field&&((resModel==="ir.ui.view"&&field==="arch")||type==="html")),media:params.node,save:(element)=>{this.onSaveMediaDialog(element,{node:params.node});},onAttachmentChange:this.config.onAttachmentChange||(()=>{}),noVideos:!!this.config.disableVideo,noImages:!!this.config.disableImage,extraTabs:this.getResource("media_dialog_extra_tabs"),...this.config.mediaModalParams,...params,});return mediaDialogClosedPromise;}
async savePendingImages(){const editableEl=this.editable;const{resModel,resId}=this.recordInfo;const b64Proms=[...editableEl.querySelectorAll(".o_b64_image_to_save")].map(async(el)=>{const dirtyEditable=el.closest(".o_dirty");if(dirtyEditable&&dirtyEditable!==editableEl){return;}
await this.saveB64Image(el,resModel,resId);});const modifiedProms=[...editableEl.querySelectorAll(".o_modified_image_to_save")].map(async(el)=>{const dirtyEditable=el.closest(".o_dirty");if(dirtyEditable&&dirtyEditable!==editableEl){return;}
await this.saveModifiedImage(el,resModel,resId);});const proms=[...b64Proms,...modifiedProms];const hasChange=!!proms.length;if(hasChange){await Promise.all(proms);}
return hasChange;}
createAttachment({el,imageData,resModel,resId}){return rpc("/html_editor/attachment/add_data",{name:el.dataset.fileName||"",data:imageData,is_image:true,res_model:resModel,res_id:resId,});}
async saveB64Image(el,resModel,resId){const imageData=el.getAttribute("src").split("base64,")[1];if(!imageData){el.classList.remove("o_b64_image_to_save");return;}
const attachment=await this.createAttachment({el,imageData,resId,resModel,});if(!attachment){return;}
if(attachment.mimetype==="image/webp"){el.classList.add("o_modified_image_to_save");el.dataset.originalId=attachment.id;el.dataset.mimetype=attachment.mimetype;el.dataset.fileName=attachment.name;return this.saveModifiedImage(el,resModel,resId);}else{let src=attachment.image_src;if(!attachment.public){let accessToken=attachment.access_token;if(!accessToken){[accessToken]=await this.services.orm.call("ir.attachment","generate_access_token",[attachment.id]);}
src+=`?access_token=${encodeURIComponent(accessToken)}`;}
el.setAttribute("src",src);}
el.classList.remove("o_b64_image_to_save");}
async saveModifiedImage(el,resModel,resId){const isBackground=!el.matches("img");let altData=undefined;const isImageField=!!el.closest("[data-oe-type=image]");if(el.dataset.mimetype==="image/webp"&&isImageField){altData={};const image=document.createElement("img");image.src=isBackground?el.dataset.bgSrc:el.getAttribute("src");await new Promise((resolve)=>image.addEventListener("load",resolve));const originalSize=Math.max(image.width,image.height);const smallerSizes=[1024,512,256,128].filter((size)=>size<originalSize);for(const size of[originalSize,...smallerSizes]){const ratio=size/originalSize;const canvas=document.createElement("canvas");canvas.width=image.width*ratio;canvas.height=image.height*ratio;const ctx=canvas.getContext("2d");ctx.fillStyle="rgb(255, 255, 255)";ctx.fillRect(0,0,canvas.width,canvas.height);ctx.drawImage(image,0,0,image.width,image.height,0,0,canvas.width,canvas.height);altData[size]={"image/jpeg":canvas.toDataURL("image/jpeg",0.75).split(",")[1],};if(size!==originalSize){altData[size]["image/webp"]=canvas.toDataURL("image/webp",0.75).split(",")[1];}}}
const newAttachmentSrc=await rpc(`/html_editor/modify_image/${encodeURIComponent(el.dataset.originalId)}`,{res_model:resModel,res_id:parseInt(resId),data:(isBackground?el.dataset.bgSrc:el.getAttribute("src")).split(",")[1],alt_data:altData,mimetype:isBackground?el.dataset.mimetype:el.getAttribute("src").split(":")[1].split(";")[0],name:el.dataset.fileName?el.dataset.fileName:null,});el.classList.remove("o_modified_image_to_save");if(isBackground){const parts=backgroundImageCssToParts(el.style["background-image"]);parts.url=`url('${newAttachmentSrc}')`;const combined=backgroundImagePartsToCss(parts);el.style["background-image"]=combined;delete el.dataset.bgSrc;}else{el.setAttribute("src",newAttachmentSrc);}}}
return __exports;});;

/* /html_editor/static/src/main/movenode_plugin.js */
odoo.define('@html_editor/main/movenode_plugin',['@html_editor/utils/drag_and_drop','@html_editor/utils/position','@html_editor/plugin','@html_editor/utils/dom_traversal','@html_editor/utils/base_container'],function(require){'use strict';let __exports={};const{useNativeDraggable}=require("@html_editor/utils/drag_and_drop");const{endPos}=require("@html_editor/utils/position");const{Plugin}=require("@html_editor/plugin");const{ancestors,closestElement}=require("@html_editor/utils/dom_traversal");const{baseContainerGlobalSelector}=require("@html_editor/utils/base_container");const WIDGET_CONTAINER_WIDTH=25;const WIDGET_MOVE_SIZE=20;const ALLOWED_ELEMENTS="h1, h2, h3, p, hr, pre, blockquote, ul, ol, table, [data-embedded], .o_text_columns, .o_editor_banner, .oe_movable";const MoveNodePlugin=__exports.MoveNodePlugin=class MoveNodePlugin extends Plugin{static id="movenode";static dependencies=["baseContainer","selection","history","position","localOverlay"];resources={layout_geometry_change_handlers:()=>{if(this.currentMovableElement){this.setMovableElement(this.currentMovableElement);}
this.updateHooks();},};setup(){this.intersectionObserver=new IntersectionObserver(this.intersectionObserverCallback.bind(this),{root:document,});this.visibleMovableElements=new Set();this.elementHookMap=new Map();this.addDomListener(this.editable,"mousemove",this.onMousemove,true);this.addDomListener(this.editable,"touchmove",this.onMousemove,true);this.addDomListener(this.document,"keydown",this.onDocumentKeydown,true);this.addDomListener(this.document,"mousemove",this.onDocumentMousemove,true);this.addDomListener(this.document,"touchmove",this.onDocumentMousemove,true);this.widgetHookContainer=this.dependencies.localOverlay.makeLocalOverlay("oe-widget-hooks-container");this.widgetContainer=this.dependencies.localOverlay.makeLocalOverlay("oe-widgets-container");this.dragHelperContainer=this.dependencies.localOverlay.makeLocalOverlay("oe-movenode-helper-container");this.dropzonesContainer=this.dependencies.localOverlay.makeLocalOverlay("oe-dropzones-container");this.dropzoneHintContainer=this.dependencies.localOverlay.makeLocalOverlay("oe-dropzone-hint-container");this.scrollableElement=closestElement(this.editable.parentElement);while(this.scrollableElement&&getComputedStyle(this.scrollableElement).overflowY!=="auto"){this.scrollableElement=this.scrollableElement.parentElement;}
this.scrollableElement=this.scrollableElement||this.editable;this.resetHooksNextMousemove=true;this.mutationObserver=new MutationObserver(()=>{this.resetHooksNextMousemove=true;this.removeMoveWidget();});this.mutationObserver.observe(this.editable,{childList:true,subtree:true,characterData:true,characterDataOldValue:true,});}
destroy(){super.destroy();this.intersectionObserver.disconnect();this.mutationObserver.disconnect();this.smoothScrollOnDrag&&this.smoothScrollOnDrag.destroy();}
intersectionObserverCallback(entries){for(const entry of entries){const element=entry.target;if(entry.isIntersecting){this.visibleMovableElements.add(element);this.resetHooksNextMousemove=true;}else{this.visibleMovableElements.delete(element);const hookElement=this.elementHookMap.get(element);if(hookElement){hookElement.style.display=`none`;}}}}
updateHooks(){const editableStyles=getComputedStyle(this.editable);this.editableRect=this.editable.getBoundingClientRect();const paddingLeft=parseInt(editableStyles.paddingLeft,10)||0;this.editableRect.x=this.editableRect.x+paddingLeft-(WIDGET_CONTAINER_WIDTH+5);this.editableRect.width=this.editableRect.width-paddingLeft+(WIDGET_CONTAINER_WIDTH+5);const containerRect=this.widgetHookContainer.getBoundingClientRect();const elements=this.getMovableElements();const elementsToGarbageCollect=new Set(this.elementHookMap.keys());for(const index in elements){const element=elements[index];elementsToGarbageCollect.delete(element);let hookElement=this.elementHookMap.get(element);if(!hookElement){hookElement=document.createElement("div");this.elementHookMap.set(element,hookElement);hookElement.classList.add("oe-dropzone-hook");hookElement.addEventListener("mouseenter",()=>{if(element!==this.currentMovableElement){this.setMovableElement(element);}});this.widgetHookContainer.append(hookElement);hookElement.style.display=`none`;this.intersectionObserver.observe(element);}
hookElement.style.zIndex=index;}
for(const element of elementsToGarbageCollect){this.visibleMovableElements.delete(element);this.elementHookMap.get(element).remove();this.intersectionObserver.unobserve(element);this.elementHookMap.delete(element);}
const visibleElements=[...this.visibleMovableElements];const elementRects=visibleElements.map((element)=>element.getBoundingClientRect());for(const index in visibleElements){const element=visibleElements[index];const elementRect=elementRects[index];const hookElement=this.elementHookMap.get(element);const style=getComputedStyle(element);const marginTop=parseInt(style.marginTop,10)||0;const marginBottom=parseInt(style.marginBottom,10)||0;let hookBox;if(element.tagName==="HR"){hookBox=new DOMRect(elementRect.x-containerRect.left-WIDGET_CONTAINER_WIDTH,elementRect.y-containerRect.top-marginTop,elementRect.width+WIDGET_CONTAINER_WIDTH,elementRect.height+marginTop+marginBottom);}else{hookBox=new DOMRect(elementRect.x-containerRect.left-WIDGET_CONTAINER_WIDTH,elementRect.y-containerRect.top-marginTop,WIDGET_CONTAINER_WIDTH,elementRect.height+marginTop+marginBottom);}
hookElement.style.left=`${hookBox.x}px`;hookElement.style.top=`${hookBox.y}px`;hookElement.style.width=`${hookBox.width}px`;hookElement.style.height=`${hookBox.height}px`;hookElement.style.display=`block`;}}
_updateAnchorWidgets(newAnchorWidget){let movableElement=newAnchorWidget&&closestElement(newAnchorWidget,(node)=>{return(isNodeMovable(node)&&node.matches([ALLOWED_ELEMENTS,baseContainerGlobalSelector].join(", ")));});const listContainer=movableElement&&ancestors(movableElement,this.editable).reverse().find((n)=>["UL","OL"].includes(n.tagName));movableElement=listContainer||movableElement;if(movableElement&&movableElement!==this.currentMovableElement){this.setMovableElement(movableElement);}}
getMovableElements(){const elems=[];for(const el of this.editable.querySelectorAll([ALLOWED_ELEMENTS,baseContainerGlobalSelector].join(", "))){if(isNodeMovable(el)){elems.push(el);}}
return elems;}
getDroppableElements(draggableNode){return this.getMovableElements().filter((node)=>!closestElement(node.parentElement,(n)=>n===draggableNode));}
setMovableElement(movableElement){this.removeMoveWidget();this.currentMovableElement=movableElement;this.dispatchTo("set_movable_element_handlers",movableElement);const containerRect=this.widgetContainer.getBoundingClientRect();const anchorBlockRect=this.currentMovableElement.getBoundingClientRect();const closestList=closestElement(this.currentMovableElement,"ul, ol");const anchorX=closestList?closestList.getBoundingClientRect().x:anchorBlockRect.x;let anchorY=anchorBlockRect.y;if(this.currentMovableElement.tagName.match(/H[1-6]/)){anchorY+=(anchorBlockRect.height-WIDGET_MOVE_SIZE)/2;}
this.moveWidget=this.document.createElement("div");this.moveWidget.className="oe-sidewidget-move fa fa-sort";this.widgetContainer.append(this.moveWidget);let moveWidgetOffsetTop=0;if(movableElement.tagName==="HR"){const style=getComputedStyle(movableElement);moveWidgetOffsetTop=parseInt(style.marginTop,10)||0;}
this.moveWidget.style.width=`${WIDGET_MOVE_SIZE}px`;this.moveWidget.style.height=`${WIDGET_MOVE_SIZE}px`;this.moveWidget.style.top=`${anchorY - containerRect.y - moveWidgetOffsetTop}px`;this.moveWidget.style.left=`${anchorX - containerRect.x - WIDGET_CONTAINER_WIDTH}px`;if(this.scrollableElement){this.smoothScrollOnDrag&&this.smoothScrollOnDrag.destroy();this.smoothScrollOnDrag=useNativeDraggable(simpleDraggableHook,{ref:{el:this.widgetContainer},elements:".oe-sidewidget-move",onDragStart:()=>this.startDropzones(movableElement,containerRect),onDragEnd:()=>this._stopDropzones(movableElement),helper:()=>{const container=document.createElement("div");container.append(movableElement.cloneNode(true));const style=getComputedStyle(movableElement);container.style.height=style.height;container.style.width=style.width;container.style.paddingLeft="25px";container.style.opacity="0.4";this.dragHelperContainer.append(container);return container;},});}}
removeMoveWidget(){this.dispatchTo("unset_movable_element_handlers");this.moveWidget?.remove();this.moveWidget=undefined;this.currentMovableElement=undefined;}
startDropzones(movableElement,containerRect,directions=["north","south"]){this.removeMoveWidget();const elements=this.getDroppableElements(movableElement);this.dropzonesContainer.replaceChildren();this.editable.classList.add("oe-editor-dragging");for(const element of elements){const originalRect=element.getBoundingClientRect();const style=getComputedStyle(element);const marginTop=parseInt(style.marginTop,10);const marginBottom=parseInt(style.marginBottom,10);const marginLeft=parseInt(style.marginLeft,10);const marginRight=parseInt(style.marginRight,10);const dropzoneRect=new DOMRect(originalRect.left-marginLeft-WIDGET_CONTAINER_WIDTH,originalRect.top-marginTop,originalRect.width+marginLeft+marginRight+WIDGET_CONTAINER_WIDTH,originalRect.height+marginTop+marginBottom);const dropzoneHintRect=new DOMRect(originalRect.left-marginLeft,originalRect.top-marginTop,originalRect.width+marginLeft+marginRight,originalRect.height+marginTop+marginBottom);const dropzoneBox=document.createElement("div");dropzoneBox.className=`oe-dropzone-box`;dropzoneBox.style.top=`${dropzoneRect.top - containerRect.top}px`;dropzoneBox.style.left=`${dropzoneRect.left - containerRect.left}px`;dropzoneBox.style.width=`${dropzoneRect.width}px`;dropzoneBox.style.height=`${dropzoneRect.height}px`;const dropzoneHintBox=document.createElement("div");dropzoneHintBox.className=`oe-dropzone-box`;dropzoneHintBox.style.top=`${dropzoneHintRect.top - containerRect.top}px`;dropzoneHintBox.style.left=`${dropzoneHintRect.left - containerRect.left}px`;dropzoneHintBox.style.width=`${dropzoneHintRect.width}px`;dropzoneHintBox.style.height=`${dropzoneHintRect.height}px`;const sideElements={};for(const direction of directions){const sideElement=document.createElement("div");sideElement.className=`oe-dropzone-box-side oe-dropzone-box-side-${direction}`;sideElements[direction]=sideElement;dropzoneBox.append(sideElement);const onEnter=()=>{this._currentZone=[direction];removeDropHint();this._currentDropHint=document.createElement("div");this._currentDropHint.className=`oe-current-drop-hint`;const currentDropHintSize=4;const currentDropHintSizeHalf=currentDropHintSize/2;if(direction==="north"){this._currentDropHint.style["top"]=`-${currentDropHintSizeHalf}px`;this._currentDropHint.style["width"]=`100%`;this._currentDropHint.style["height"]=`${currentDropHintSize}px`;dropzoneHintBox.append(this._currentDropHint);this._currentDropHintElementPosition=["top",element];}else if(direction==="south"){this._currentDropHint.style["bottom"]=`-${currentDropHintSizeHalf}px`;this._currentDropHint.style["width"]=`100%`;this._currentDropHint.style["height"]=`${currentDropHintSize}px`;dropzoneHintBox.append(this._currentDropHint);this._currentDropHintElementPosition=["bottom",element];}else if(direction==="west"){this._currentDropHint.style["left"]=`-${currentDropHintSizeHalf}px`;this._currentDropHint.style["height"]=`100%`;this._currentDropHint.style["width"]=`${currentDropHintSize}px`;dropzoneHintBox.append(this._currentDropHint);this._currentDropHintElementPosition=["left",element];}else if(direction==="east"){this._currentDropHint.style["right"]=`-${currentDropHintSizeHalf}px`;this._currentDropHint.style["height"]=`100%`;this._currentDropHint.style["width"]=`${currentDropHintSize}px`;dropzoneHintBox.append(this._currentDropHint);this._currentDropHintElementPosition=["right",element];}};sideElement.addEventListener("mouseenter",onEnter);sideElement.addEventListener("pointerenter",onEnter);const removeDropHint=()=>{if(this._currentDropHint){this._currentDropHint.remove();this._currentDropHint=null;}
this._currentDropHintElementPosition=null;};dropzoneBox.addEventListener("mouseleave",removeDropHint);dropzoneBox.addEventListener("pointerleave",removeDropHint);}
this.dropzonesContainer.append(dropzoneBox);this.dropzoneHintContainer.append(dropzoneHintBox);}}
_stopDropzones(movableElement){this.editable.classList.remove("oe-editor-dragging");this.dropzonesContainer.replaceChildren();this.dropzoneHintContainer.replaceChildren();if(this._currentDropHintElementPosition){const[position,focusElelement]=this._currentDropHintElementPosition;this._currentDropHintElementPosition=undefined;const previousParent=movableElement.parentElement;if(position==="top"){focusElelement.before(movableElement);}else if(position==="bottom"){focusElelement.after(movableElement);}
if(previousParent.innerHTML.trim()===""){const baseContainer=this.dependencies.baseContainer.createBaseContainer();const br=document.createElement("br");baseContainer.append(br);previousParent.append(baseContainer);}
const selectionPosition=endPos(movableElement);this.dependencies.selection.setSelection({anchorNode:selectionPosition[0],anchorOffset:selectionPosition[1],});this.dependencies.history.addStep();}}
onMousemove(e){this._updateAnchorWidgets(e.target);}
onDocumentKeydown(){this.removeMoveWidget();}
onDocumentMousemove(e){if(this.resetHooksNextMousemove){this.resetHooksNextMousemove=false;this.removeMoveWidget();this.updateHooks();}
const clientX=e.clientX??e.touches?.[0]?.clientX;const clientY=e.clientY??e.touches?.[0]?.clientY;if(this.editableRect&&!isPointInside(this.editableRect,clientX,clientY)){this.removeMoveWidget();}}}
function isNodeMovable(node){return(node.parentElement?.getAttribute("contentEditable")==="true"&&!node.parentElement.closest(".o_editor_banner"));}
function isPointInside(rect,x,y){return rect.left<=x&&rect.right>=x&&rect.top<=y&&rect.bottom>=y;}
const simpleDraggableHook={acceptedParams:{helper:[Function],},edgeScrolling:{enable:true},onComputeParams({ctx,params}){ctx.helper=params.helper;ctx.followCursor=false;ctx.tolerance=0;},onDragStart({ctx}){ctx.current.element=ctx.helper();ctx.current.element.style.left=`${ctx.pointer.x + 10}px`;ctx.current.element.style.top=`${ctx.pointer.y + 10}px`;ctx.current.element.style.position="fixed";document.body.classList.remove("pe-none");return ctx.current;},onDrag({ctx}){ctx.current.element.style.left=`${ctx.pointer.x}px`;ctx.current.element.style.top=`${ctx.pointer.y}px`;},onDragEnd({ctx}){ctx.current.element.remove();return ctx.current;},};return __exports;});;

/* /html_editor/static/src/main/position_plugin.js */
odoo.define('@html_editor/main/position_plugin',['@html_editor/utils/dom_traversal','@html_editor/plugin','@web/core/utils/timing','@web/core/utils/scrolling'],function(require){'use strict';let __exports={};const{ancestors}=require("@html_editor/utils/dom_traversal");const{Plugin}=require("@html_editor/plugin");const{throttleForAnimation}=require("@web/core/utils/timing");const{couldBeScrollableX,couldBeScrollableY}=require("@web/core/utils/scrolling");const PositionPlugin=__exports.PositionPlugin=class PositionPlugin extends Plugin{static id="position";resources={external_history_step_handlers:this.layoutGeometryChange.bind(this),history_reset_from_steps_handlers:this.layoutGeometryChange.bind(this),step_added_handlers:this.layoutGeometryChange.bind(this),};setup(){this.layoutGeometryChange=throttleForAnimation(this.layoutGeometryChange.bind(this));this.resizeObserver=new ResizeObserver(this.layoutGeometryChange);this.resizeObserver.observe(this.document.body);this.resizeObserver.observe(this.editable);this.addDomListener(window,"resize",this.layoutGeometryChange);if(this.document.defaultView!==window){this.addDomListener(this.document.defaultView,"resize",this.layoutGeometryChange);}
const scrollableElements=[this.editable,...ancestors(this.editable)].filter((node)=>{return couldBeScrollableX(node)||couldBeScrollableY(node);});for(const scrollableElement of scrollableElements){this.addDomListener(scrollableElement,"scroll",()=>{this.layoutGeometryChange();});this.resizeObserver.observe(scrollableElement);}}
destroy(){this.resizeObserver.disconnect();super.destroy();}
layoutGeometryChange(){this.dispatchTo("layout_geometry_change_handlers");}}
return __exports;});;

/* /html_editor/static/src/main/power_buttons_plugin.js */
odoo.define('@html_editor/main/power_buttons_plugin',['@html_editor/plugin','@html_editor/utils/base_container','@html_editor/utils/blocks','@html_editor/utils/dom_info','@html_editor/utils/dom_traversal','@web/core/utils/objects'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{baseContainerGlobalSelector}=require("@html_editor/utils/base_container");const{closestBlock}=require("@html_editor/utils/blocks");const{isEmptyBlock}=require("@html_editor/utils/dom_info");const{closestElement}=require("@html_editor/utils/dom_traversal");const{omit,pick}=require("@web/core/utils/objects");const PowerButtonsPlugin=__exports.PowerButtonsPlugin=class PowerButtonsPlugin extends Plugin{static id="powerButtons";static dependencies=["baseContainer","selection","position","localOverlay","powerbox","userCommand","history",];resources={layout_geometry_change_handlers:this.updatePowerButtons.bind(this),selectionchange_handlers:this.updatePowerButtons.bind(this),};setup(){this.powerButtonsOverlay=this.dependencies.localOverlay.makeLocalOverlay("oe-power-buttons-overlay");this.createPowerButtons();}
createPowerButtons(){const composePowerButton=(item)=>{const command=this.dependencies.userCommand.getCommand(item.commandId);return{...pick(command,"title","icon","isAvailable"),...omit(item,"commandId","commandParams"),run:()=>command.run(item.commandParams),};};const renderButton=({title,icon,run})=>{const btn=this.document.createElement("button");btn.className=`power_button btn px-2 py-1 cursor-pointer fa ${icon}`;btn.title=title;this.addDomListener(btn,"click",()=>this.applyCommand(run));return btn;};const powerButtonsDefinitions=this.getResource("power_buttons");const powerButtons=powerButtonsDefinitions.map(composePowerButton);this.descriptionToElementMap=new Map(powerButtons.map((pb)=>[pb,renderButton(pb)]));this.powerButtonsContainer=this.document.createElement("div");this.powerButtonsContainer.className=`o_we_power_buttons d-flex justify-content-center d-none`;this.powerButtonsContainer.append(...this.descriptionToElementMap.values());this.powerButtonsOverlay.append(this.powerButtonsContainer);}
updatePowerButtons(){this.powerButtonsContainer.classList.add("d-none");const{editableSelection,documentSelectionIsInEditable}=this.dependencies.selection.getSelectionData();if(!documentSelectionIsInEditable){return;}
const block=closestBlock(editableSelection.anchorNode);const element=closestElement(editableSelection.anchorNode);const blockRect=block.getBoundingClientRect();const editableRect=this.editable.getBoundingClientRect();if(editableSelection.isCollapsed&&element?.matches(baseContainerGlobalSelector)&&editableRect.bottom>blockRect.top&&isEmptyBlock(block)&&!this.services.ui.isSmall&&!closestElement(editableSelection.anchorNode,"td")&&!block.style.textAlign&&this.getResource("power_buttons_visibility_predicates").every((predicate)=>predicate(editableSelection))){this.powerButtonsContainer.classList.remove("d-none");const direction=closestElement(element,"[dir]")?.getAttribute("dir");this.powerButtonsContainer.setAttribute("dir",direction);for(const[{isAvailable},buttonElement]of this.descriptionToElementMap.entries()){const shouldHide=Boolean(isAvailable&&!isAvailable(editableSelection));buttonElement.classList.toggle("d-none",shouldHide);}
this.setPowerButtonsPosition(block,blockRect,direction);}}
getPlaceholderWidth(block){this.dependencies.history.disableObserver();const clone=block.cloneNode(true);clone.innerText=clone.getAttribute("placeholder");clone.style.width="fit-content";clone.style.visibility="hidden";this.editable.appendChild(clone);const{width}=clone.getBoundingClientRect();this.editable.removeChild(clone);this.dependencies.history.enableObserver();return width;}
setPowerButtonsPosition(block,blockRect,direction){const overlayStyles=this.powerButtonsOverlay.style;overlayStyles.top="0px";overlayStyles.left="0px";const buttonsRect=this.powerButtonsContainer.getBoundingClientRect();const placeholderWidth=this.getPlaceholderWidth(block)+20;if(direction==="rtl"){overlayStyles.left=blockRect.right-buttonsRect.width-buttonsRect.x-placeholderWidth+"px";}else{overlayStyles.left=blockRect.left-buttonsRect.x+placeholderWidth+"px";}
overlayStyles.top=blockRect.top-buttonsRect.top+"px";overlayStyles.height=blockRect.height+"px";}
async applyCommand(commandFn){const btns=[...this.powerButtonsContainer.querySelectorAll(".btn")];btns.forEach((btn)=>btn.classList.add("disabled"));await commandFn();btns.forEach((btn)=>btn.classList.remove("disabled"));}}
return __exports;});;

/* /html_editor/static/src/main/powerbox/powerbox.js */
odoo.define('@html_editor/main/powerbox/powerbox',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,onPatched,useEffect,useExternalListener,useRef}=require("@odoo/owl");const Powerbox=__exports.Powerbox=class Powerbox extends Component{static template="html_editor.Powerbox";static props={document:{validate:(doc)=>doc.constructor.name==="HTMLDocument"},close:Function,state:Object,activateCommand:Function,applyCommand:Function,};setup(){const ref=useRef("root");onPatched(()=>{const activeCommand=ref.el.querySelector(".o-we-command.active");if(activeCommand){activeCommand.scrollIntoView({block:"nearest",inline:"nearest"});}});this.mouseSelectionActive=false;const onMouseMove=()=>(this.mouseSelectionActive=true);useExternalListener(this.props.document,"mousemove",onMouseMove);useEffect((ownDoc,propsDoc)=>{if(ownDoc&&propsDoc&&ownDoc!==propsDoc){ownDoc.addEventListener("mousemove",onMouseMove);return()=>ownDoc.removeEventListener("mousemove",onMouseMove);}},()=>[ref.el?.ownerDocument,this.props.document]);}
get commands(){return this.props.state.commands;}
get currentIndex(){return this.props.state.currentIndex;}
get showCategories(){return this.props.state.showCategories;}
onScroll(){this.mouseSelectionActive=false;}
onMouseEnter(index){if(this.mouseSelectionActive){this.props.activateCommand(index);}}}
return __exports;});;

/* /html_editor/static/src/main/powerbox/powerbox_plugin.js */
odoo.define('@html_editor/main/powerbox/powerbox_plugin',['@html_editor/plugin','@html_editor/utils/dom_info','@odoo/owl','@web/core/l10n/translation','@web/core/utils/arrays','@html_editor/main/powerbox/powerbox','@html_editor/utils/resource','@web/core/utils/objects','@html_editor/utils/base_container'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{isEmptyBlock}=require("@html_editor/utils/dom_info");const{reactive}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{rotate}=require("@web/core/utils/arrays");const{Powerbox}=require("@html_editor/main/powerbox/powerbox");const{withSequence}=require("@html_editor/utils/resource");const{omit,pick}=require("@web/core/utils/objects");const{baseContainerGlobalSelector}=require("@html_editor/utils/base_container");function target(selectionData){const node=selectionData.editableSelection.anchorNode;const el=node.nodeType===Node.ELEMENT_NODE?node:node.parentElement;if(selectionData.documentSelectionIsInEditable&&el.matches(baseContainerGlobalSelector)&&isEmptyBlock(el)){return el;}}
const PowerboxPlugin=__exports.PowerboxPlugin=class PowerboxPlugin extends Plugin{static id="powerbox";static dependencies=["overlay","selection","history","userCommand"];static shared=["closePowerbox","getAvailablePowerboxCommands","openPowerbox","updatePowerbox",];resources={user_commands:{id:"openPowerbox",run:()=>this.openPowerbox({commands:this.getAvailablePowerboxCommands(),categories:this.getResource("powerbox_categories"),}),},powerbox_categories:[withSequence(10,{id:"structure",name:_t("Structure")}),withSequence(60,{id:"widget",name:_t("Widget")}),],power_buttons:withSequence(100,{commandId:"openPowerbox",title:_t("More options"),icon:"fa-ellipsis-v",}),hints:{text:_t('Type "/" for commands'),target,},};setup(){this.overlay=this.dependencies.overlay.createOverlay(Powerbox);this.state=reactive({});this.overlayProps={document:this.document,close:()=>this.overlay.close(),state:this.state,activateCommand:(currentIndex)=>{this.state.currentIndex=currentIndex;},applyCommand:this.applyCommand.bind(this),};this.powerboxCommands=this.makePowerboxCommands();this.addDomListener(this.editable.ownerDocument,"keydown",this.onKeyDown);}
getAvailablePowerboxCommands(){const selection=this.dependencies.selection.getEditableSelection();return this.powerboxCommands.filter((cmd)=>cmd.isAvailable===undefined||cmd.isAvailable(selection));}
makePowerboxCommands(){const powerboxItems=this.getResource("powerbox_items");const categories=this.getResource("powerbox_categories");const categoryDict=Object.fromEntries(categories.map((category)=>[category.id,category]));return powerboxItems.map((item)=>{const command=this.dependencies.userCommand.getCommand(item.commandId);return{...pick(command,"title","description","icon","isAvailable"),...omit(item,"commandId","commandParams"),categoryName:categoryDict[item.categoryId].name,run:()=>command.run(item.commandParams),};});}
openPowerbox({commands,categories,onApplyCommand=()=>{},onClose=()=>{}}={}){this.closePowerbox();this.onApplyCommand=onApplyCommand;this.onClose=onClose;this.updatePowerbox(commands,categories);}
updatePowerbox(commands,categories){if(categories){const orderCommands=[];for(const category of categories){orderCommands.push(...commands.filter((command)=>command.categoryId===category.id));}
commands=orderCommands;}
Object.assign(this.state,{showCategories:!!categories,commands,currentIndex:0,});this.overlay.open({props:this.overlayProps});}
closePowerbox(){if(!this.overlay.isOpen){return;}
this.onClose();this.overlay.close();}
onKeyDown(ev){if(!this.overlay.isOpen){return;}
const key=ev.key;switch(key){case"Escape":this.closePowerbox();break;case"Enter":case"Tab":ev.preventDefault();ev.stopImmediatePropagation();this.applyCommand(this.state.commands[this.state.currentIndex]);break;case"ArrowUp":{ev.preventDefault();this.state.currentIndex=rotate(this.state.currentIndex,this.state.commands,-1);break;}
case"ArrowDown":{ev.preventDefault();this.state.currentIndex=rotate(this.state.currentIndex,this.state.commands,1);break;}
case"ArrowLeft":case"ArrowRight":{this.closePowerbox();break;}}}
applyCommand(command){this.onApplyCommand(command);command.run();this.closePowerbox();}}
return __exports;});;

/* /html_editor/static/src/main/powerbox/search_powerbox_plugin.js */
odoo.define('@html_editor/main/powerbox/search_powerbox_plugin',['@web/core/utils/search','@html_editor/plugin'],function(require){'use strict';let __exports={};const{fuzzyLookup}=require("@web/core/utils/search");const{Plugin}=require("@html_editor/plugin");const SearchPowerboxPlugin=__exports.SearchPowerboxPlugin=class SearchPowerboxPlugin extends Plugin{static id="searchPowerbox";static dependencies=["powerbox","selection","history","input"];resources={beforeinput_handlers:this.onBeforeInput.bind(this),input_handlers:this.onInput.bind(this),delete_handlers:this.update.bind(this),post_undo_handlers:this.update.bind(this),post_redo_handlers:this.update.bind(this),};setup(){const categoryIds=new Set();for(const category of this.getResource("powerbox_categories")){if(categoryIds.has(category.id)){throw new Error(`Duplicate category id: ${category.id}`);}
categoryIds.add(category.id);}
this.categories=this.getResource("powerbox_categories");this.shouldUpdate=false;}
onBeforeInput(ev){if(ev.data==="/"){this.historySavePointRestore=this.dependencies.history.makeSavePoint();}}
onInput(ev){if(ev.data==="/"){this.openPowerbox();}else{this.update();}}
update(){if(!this.shouldUpdate){return;}
const selection=this.dependencies.selection.getEditableSelection();this.searchNode=selection.startContainer;if(!this.isSearching(selection)){this.dependencies.powerbox.closePowerbox();return;}
const searchTerm=this.searchNode.nodeValue.slice(this.offset+1,selection.endOffset);if(!searchTerm){this.dependencies.powerbox.updatePowerbox(this.enabledCommands,this.categories);return;}
if(searchTerm.includes(" ")){this.dependencies.powerbox.closePowerbox();return;}
const commands=this.filterCommands(searchTerm);if(!commands.length){this.dependencies.powerbox.closePowerbox();this.shouldUpdate=true;return;}
this.dependencies.powerbox.updatePowerbox(commands);}
filterCommands(searchTerm){return fuzzyLookup(searchTerm,this.enabledCommands,(cmd)=>[cmd.title,cmd.categoryName,cmd.description,...(cmd.keywords||[]),]);}
isSearching(selection){return(selection.endContainer===this.searchNode&&this.searchNode.nodeValue&&this.searchNode.nodeValue[this.offset]==="/"&&selection.endOffset>=this.offset);}
openPowerbox(){const selection=this.dependencies.selection.getEditableSelection();this.offset=selection.startOffset-1;this.enabledCommands=this.dependencies.powerbox.getAvailablePowerboxCommands();this.dependencies.powerbox.openPowerbox({commands:this.enabledCommands,categories:this.categories,onApplyCommand:this.historySavePointRestore,onClose:()=>{this.shouldUpdate=false;},});this.shouldUpdate=true;}}
return __exports;});;

/* /html_editor/static/src/main/signature_plugin.js */
odoo.define('@html_editor/main/signature_plugin',['@html_editor/plugin','@web/core/l10n/translation','@html_editor/utils/html','@web/core/user','@html_editor/utils/resource','@web/core/utils/render','@odoo/owl','@html_editor/utils/dom_info'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{_t}=require("@web/core/l10n/translation");const{parseHTML}=require("@html_editor/utils/html");const{user}=require("@web/core/user");const{withSequence}=require("@html_editor/utils/resource");const{renderToString}=require("@web/core/utils/render");const{markup}=require("@odoo/owl");const{isEmptyBlock,paragraphRelatedElementsSelector}=require("@html_editor/utils/dom_info");const SIGNATURE_CLASS=__exports.SIGNATURE_CLASS="o-signature-container";const SignaturePlugin=__exports.SignaturePlugin=class SignaturePlugin extends Plugin{static id="signature";static dependencies=["dom","history","selection"];static shared=["cleanSignatures"];resources={user_commands:[{id:"insertSignature",title:_t("Signature"),description:_t("Insert your signature"),icon:"fa-pencil-square-o",run:this.insertSignature.bind(this),},],powerbox_categories:withSequence(100,{id:"basic_block",name:_t("Basic Bloc")}),powerbox_items:[{categoryId:"basic_block",commandId:"insertSignature",},],is_empty_predicates:this.isEmpty.bind(this),unsplittable_node_predicates:(host)=>host.nodeType===Node.ELEMENT_NODE&&host.matches(`.${SIGNATURE_CLASS}`),};cleanSignatures({rootClone}){for(const el of rootClone.querySelectorAll(`.${SIGNATURE_CLASS}`)){el.remove();}}
async insertSignature(){const[currentUser]=await this.services.orm.read("res.users",[user.userId],["signature"]);if(currentUser&&currentUser.signature){const signatureFragment=parseHTML(this.document,renderToString("html_editor.Signature",{signature:markup(currentUser.signature),signatureClass:SIGNATURE_CLASS,}));const signatureBlock=signatureFragment.firstElementChild;this.dependencies.dom.insert(signatureFragment);if(signatureBlock){const lastPhrasingElement=[...signatureBlock.querySelectorAll(paragraphRelatedElementsSelector),].at(-1);if(lastPhrasingElement){this.dependencies.selection.setCursorEnd(lastPhrasingElement);}else{this.dependencies.selection.setCursorEnd(signatureBlock);}}
this.dependencies.history.addStep();}}
isEmpty(element){if(element.nodeType===Node.ELEMENT_NODE&&element.matches(`.${SIGNATURE_CLASS}`)&&isEmptyBlock(element)){return true;}}}
return __exports;});;

/* /html_editor/static/src/main/star_plugin.js */
odoo.define('@html_editor/main/star_plugin',['@html_editor/plugin','@html_editor/utils/html','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{parseHTML}=require("@html_editor/utils/html");const{_t}=require("@web/core/l10n/translation");const StarPlugin=__exports.StarPlugin=class StarPlugin extends Plugin{static id="star";static dependencies=["dom","history"];resources={user_commands:[{id:"addStars",title:_t("Stars"),description:_t("Insert a rating"),icon:"fa-star",run:this.addStars.bind(this),},],powerbox_items:[{title:_t("3 Stars"),description:_t("Insert a rating over 3 stars"),categoryId:"widget",icon:"fa-star-o",commandId:"addStars",commandParams:{length:3},},{title:_t("5 Stars"),description:_t("Insert a rating over 5 stars"),categoryId:"widget",commandId:"addStars",commandParams:{length:5},},],};setup(){this.addDomListener(this.editable,"pointerdown",this.onMouseDown);}
onMouseDown(ev){const node=ev.target;const isStar=(node)=>node.nodeType===Node.ELEMENT_NODE&&(node.classList.contains("fa-star")||node.classList.contains("fa-star-o"));if(isStar(node)&&node.parentElement&&node.parentElement.className.includes("o_stars")){const allStars=Array.from(node.parentElement.childNodes).filter(isStar);const currentStarIndex=allStars.indexOf(node);const previousStars=allStars.slice(0,currentStarIndex);const nextStars=allStars.slice(currentStarIndex+1);if(nextStars.length||previousStars.length){const shouldToggleOff=node.classList.contains("fa-star")&&(!nextStars[0]||!nextStars[0].classList.contains("fa-star"));for(const star of[...previousStars,node]){star.classList.toggle("fa-star-o",shouldToggleOff);star.classList.toggle("fa-star",!shouldToggleOff);}
for(const star of nextStars){star.classList.toggle("fa-star-o",true);star.classList.toggle("fa-star",false);}
this.dependencies.history.addStep();}
ev.stopPropagation();ev.preventDefault();}}
addStars({length}){const stars=Array.from({length},()=>'<i class="fa fa-star-o"></i>').join("");const html=`\u200B<span contenteditable="false" class="o_stars">${stars}</span>\u200B`;this.dependencies.dom.insert(parseHTML(this.document,html));this.dependencies.history.addStep();}}
return __exports;});;

/* /html_editor/static/src/main/table/table_menu.js */
odoo.define('@html_editor/main/table/table_menu',['@odoo/owl','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{_t}=require("@web/core/l10n/translation");const TableMenu=__exports.TableMenu=class TableMenu extends Component{static template="html_editor.TableMenu";static props={type:String,moveColumn:Function,addColumn:Function,removeColumn:Function,moveRow:Function,addRow:Function,removeRow:Function,resetTableSize:Function,overlay:Object,dropdownState:Object,target:{validate:(el)=>el.nodeType===Node.ELEMENT_NODE},direction:{type:String,optional:true},};static defaultProps={direction:"ltr"};static components={Dropdown,DropdownItem};setup(){if(this.props.type==="column"){this.isFirst=this.props.target.cellIndex===0;this.isLast=!this.props.target.nextElementSibling;}else{const tr=this.props.target.parentElement;this.isFirst=!tr.previousElementSibling;this.isLast=!tr.nextElementSibling;}
this.items=this.props.type==="column"?this.colItems():this.rowItems();}
get hasCustomSize(){return(!!this.props.target.closest("tr").style.height||!!this.props.target.closest("td")?.style?.width||!!this.props.target.closest("th")?.style?.width);}
onSelected(item){item.action(this.props.target);this.props.overlay.close();}
colItems(){const ltr=this.props.direction==="ltr";return[!this.isFirst&&{name:"move_left",icon:"fa-chevron-left disabled",text:ltr?_t("Move left"):_t("Move right"),action:this.props.moveColumn.bind(this,"left"),},!this.isLast&&{name:"move_right",icon:"fa-chevron-right",text:ltr?_t("Move right"):_t("Move left"),action:this.props.moveColumn.bind(this,"right"),},{name:"insert_left",icon:"fa-plus",text:ltr?_t("Insert left"):_t("Insert right"),action:this.props.addColumn.bind(this,"before"),},{name:"insert_right",icon:"fa-plus",text:ltr?_t("Insert right"):_t("Insert left"),action:this.props.addColumn.bind(this,"after"),},{name:"delete",icon:"fa-trash",text:_t("Delete"),action:this.props.removeColumn.bind(this),},this.hasCustomSize&&{name:"reset_size",icon:"fa-table",text:_t("Reset Size"),action:(target)=>this.props.resetTableSize(target.closest("table")),},].filter(Boolean);}
rowItems(){return[!this.isFirst&&{name:"move_up",icon:"fa-chevron-up",text:_t("Move up"),action:(target)=>this.props.moveRow("up",target.parentElement),},!this.isLast&&{name:"move_down",icon:"fa-chevron-down",text:_t("Move down"),action:(target)=>this.props.moveRow("down",target.parentElement),},{name:"insert_above",icon:"fa-plus",text:_t("Insert above"),action:(target)=>this.props.addRow("before",target.parentElement),},{name:"insert_below",icon:"fa-plus",text:_t("Insert below"),action:(target)=>this.props.addRow("after",target.parentElement),},{name:"delete",icon:"fa-trash",text:_t("Delete"),action:(target)=>this.props.removeRow(target.parentElement),},this.hasCustomSize&&{name:"reset_size",icon:"fa-table",text:_t("Reset Size"),action:(target)=>this.props.resetTableSize(target.closest("table")),},].filter(Boolean);}}
return __exports;});;

/* /html_editor/static/src/main/table/table_picker.js */
odoo.define('@html_editor/main/table/table_picker',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,useExternalListener,useState}=require("@odoo/owl");const TablePicker=__exports.TablePicker=class TablePicker extends Component{static template="html_editor.TablePicker";static props={insertTable:Function,editable:{validate:(el)=>el.nodeType===Node.ELEMENT_NODE,},overlay:Object,direction:String,};setup(){this.state=useState({cols:3,rows:3,});useExternalListener(this.props.editable.ownerDocument,"keydown",(ev)=>{const key=ev.key;const isRTL=this.props.direction==="rtl";switch(key){case"Enter":ev.preventDefault();this.insertTable();break;case"ArrowUp":ev.preventDefault();if(this.state.rows>1){this.state.rows-=1;}
break;case"ArrowDown":this.state.rows+=1;ev.preventDefault();break;case"ArrowLeft":ev.preventDefault();if(isRTL){this.state.cols+=1;}else{if(this.state.cols>1){this.state.cols-=1;}}
break;case"ArrowRight":ev.preventDefault();if(isRTL){if(this.state.cols>1){this.state.cols-=1;}}else{this.state.cols+=1;}
break;default:this.props.overlay.close();break;}});}
updateSize(cols,rows){this.state.cols=cols;this.state.rows=rows;}
insertTable(){this.props.insertTable({cols:this.state.cols,rows:this.state.rows});this.props.overlay.close();}}
return __exports;});;

/* /html_editor/static/src/main/table/table_plugin.js */
odoo.define('@html_editor/main/table/table_plugin',['@html_editor/plugin','@html_editor/utils/base_container','@html_editor/utils/blocks','@html_editor/utils/dom','@html_editor/utils/dom_info','@html_editor/utils/dom_traversal','@html_editor/utils/html','@html_editor/utils/position','@html_editor/utils/resource','@html_editor/utils/selection','@html_editor/utils/table','@web/core/browser/feature_detection'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{baseContainerGlobalSelector}=require("@html_editor/utils/base_container");const{isBlock}=require("@html_editor/utils/blocks");const{fillShrunkPhrasingParent,removeClass,splitTextNode}=require("@html_editor/utils/dom");const{getDeepestPosition,isProtected,isProtecting,isEmptyBlock,}=require("@html_editor/utils/dom_info");const{ancestors,closestElement,descendants,lastLeaf}=require("@html_editor/utils/dom_traversal");const{parseHTML}=require("@html_editor/utils/html");const{DIRECTIONS,leftPos,rightPos,nodeSize}=require("@html_editor/utils/position");const{withSequence}=require("@html_editor/utils/resource");const{findInSelection}=require("@html_editor/utils/selection");const{getColumnIndex,getRowIndex}=require("@html_editor/utils/table");const{isBrowserFirefox}=require("@web/core/browser/feature_detection");const BORDER_SENSITIVITY=__exports.BORDER_SENSITIVITY=5;const tableInnerComponents=new Set(["THEAD","TBODY","TFOOT","TR","TH","TD"]);function isUnremovableTableComponent(node,root){if(!tableInnerComponents.has(node.nodeName)){return false;}
if(!root){return true;}
const closestTable=closestElement(node,"table");return!root.contains(closestTable);}
const TablePlugin=__exports.TablePlugin=class TablePlugin extends Plugin{static id="table";static dependencies=["baseContainer","dom","history","selection","delete","split","color",];static shared=["insertTable","addColumn","addRow","removeColumn","removeRow","moveColumn","moveRow","resetTableSize",];resources={user_commands:[{id:"insertTable",run:(params)=>{this.insertTable(params);},},],selectionchange_handlers:this.updateSelectionTable.bind(this),clean_handlers:this.deselectTable.bind(this),clean_for_save_handlers:({root})=>this.deselectTable(root),before_line_break_handlers:this.resetTableSelection.bind(this),before_split_block_handlers:this.resetTableSelection.bind(this),tab_overrides:withSequence(20,this.handleTab.bind(this)),shift_tab_overrides:withSequence(20,this.handleShiftTab.bind(this)),delete_range_overrides:this.handleDeleteRange.bind(this),color_apply_overrides:this.applyTableColor.bind(this),unremovable_node_predicates:isUnremovableTableComponent,unsplittable_node_predicates:(node)=>node.nodeName==="TABLE"||tableInnerComponents.has(node.nodeName),fully_selected_node_predicates:(node)=>!!closestElement(node,".o_selected_td"),traversed_nodes_processors:this.adjustTraversedNodes.bind(this),};setup(){this.addDomListener(this.editable,"mousedown",this.onMousedown);this.addDomListener(this.editable,"mouseup",this.onMouseup);this.addDomListener(this.editable,"keydown",(ev)=>{this._isKeyDown=true;});this.onMousemove=this.onMousemove.bind(this);}
handleTab(){const selection=this.dependencies.selection.getEditableSelection();const inTable=closestElement(selection.anchorNode,"table");if(inTable){const shouldAddNewRow=!this.shiftCursorToTableCell(1);if(shouldAddNewRow){this.addRow("after",findInSelection(selection,"tr"));this.shiftCursorToTableCell(1);this.dependencies.history.addStep();}
return true;}}
handleShiftTab(){const selection=this.dependencies.selection.getEditableSelection();const inTable=closestElement(selection.anchorNode,"table");if(inTable){this.shiftCursorToTableCell(-1);return true;}}
createTable({rows=2,cols=2}={}){const baseContainer=this.dependencies.baseContainer.createBaseContainer();fillShrunkPhrasingParent(baseContainer);const baseContainerHtml=baseContainer.outerHTML;const tdsHtml=new Array(cols).fill(`<td>${baseContainerHtml}</td>`).join("");const trsHtml=new Array(rows).fill(`<tr>${tdsHtml}</tr>`).join("");const tableHtml=`<table class="table table-bordered o_table"><tbody>${trsHtml}</tbody></table>`;return parseHTML(this.document,tableHtml);}
_insertTable({rows=2,cols=2}={}){const newTable=this.createTable({rows,cols});let sel=this.dependencies.selection.getEditableSelection();if(!sel.isCollapsed){this.dependencies.delete.deleteSelection();}
while(!isBlock(sel.anchorNode)){const anchorNode=sel.anchorNode;const isTextNode=anchorNode.nodeType===Node.TEXT_NODE;const newAnchorNode=isTextNode?splitTextNode(anchorNode,sel.anchorOffset,DIRECTIONS.LEFT)+1&&anchorNode:this.dependencies.split.splitElement(anchorNode,sel.anchorOffset).shift();const newPosition=rightPos(newAnchorNode);sel=this.dependencies.selection.setSelection({anchorNode:newPosition[0],anchorOffset:newPosition[1]},{normalize:false});}
const[table]=this.dependencies.dom.insert(newTable);return table;}
insertTable({rows=2,cols=2}={}){const table=this._insertTable({rows,cols});this.dependencies.selection.setCursorStart(table.querySelector(baseContainerGlobalSelector));this.dependencies.history.addStep();}
addColumn(position,reference){const columnIndex=getColumnIndex(reference);const table=closestElement(reference,"table");const tableWidth=table.style.width&&parseFloat(table.style.width);const referenceColumn=table.querySelectorAll(`tr td:nth-of-type(${columnIndex + 1}), tr th:nth-of-type(${columnIndex + 1})`);const referenceCellWidth=reference.style.width?parseFloat(reference.style.width):reference.clientWidth;const firstRow=table.querySelector("tr");const firstRowCells=[...firstRow.children].filter((child)=>child.nodeName==="TD"||child.nodeName==="TH");let totalWidth=0;if(tableWidth){for(const cell of firstRowCells){const width=parseFloat(cell.style.width);cell.style.width=width+"px";const newWidth=Math.max(Math.round((width*tableWidth)/(tableWidth+referenceCellWidth-1)),13);cell.style.width=newWidth+"px";totalWidth+=newWidth;}}
referenceColumn.forEach((cell,rowIndex)=>{const newCell=this.document.createElement(cell.tagName);const baseContainer=this.dependencies.baseContainer.createBaseContainer();baseContainer.append(this.document.createElement("br"));newCell.append(baseContainer);cell[position](newCell);if(rowIndex===0&&tableWidth){newCell.style.width=cell.style.width;totalWidth+=parseFloat(cell.style.width);}});if(tableWidth){if(totalWidth!==tableWidth-1){firstRowCells[firstRowCells.length-1].style.width=parseFloat(firstRowCells[firstRowCells.length-1].style.width)+
(tableWidth-totalWidth-1)+"px";}
table.style.width=tableWidth+"px";}}
addRow(position,reference){const referenceRowHeight=reference.style.height&&parseFloat(reference.style.height);const newRow=this.document.createElement("tr");if(referenceRowHeight){newRow.style.height=referenceRowHeight+"px";}
const cells=reference.querySelectorAll("td, th");const referenceRowWidths=[...cells].map((cell)=>cell.style.width);newRow.append(...Array.from(cells).map((cell)=>{const td=this.document.createElement(cell.tagName);const baseContainer=this.dependencies.baseContainer.createBaseContainer();baseContainer.append(this.document.createElement("br"));td.append(baseContainer);return td;}));reference[position](newRow);if(referenceRowHeight){newRow.style.height=referenceRowHeight+"px";}
if(getRowIndex(newRow)===0){let columnIndex=0;for(const column of newRow.children){column.style.width=referenceRowWidths[columnIndex];cells[columnIndex].style.width="";columnIndex++;}}}
removeColumn(cell){const table=closestElement(cell,"table");const cells=[...closestElement(cell,"tr").querySelectorAll("th, td")];const index=cells.findIndex((td)=>td===cell);const siblingCell=cells[index-1]||cells[index+1];table.querySelectorAll(`tr td:nth-of-type(${index + 1})`).forEach((td)=>td.remove());siblingCell?this.dependencies.selection.setCursorStart(siblingCell):this.deleteTable(table);}
removeRow(row){const table=closestElement(row,"table");const siblingRow=row.previousElementSibling||row.nextElementSibling;row.remove();siblingRow?this.dependencies.selection.setCursorStart(siblingRow.querySelector("td")):this.deleteTable(table);}
moveColumn(position,cell){const columnIndex=getColumnIndex(cell);const nColumns=cell.parentElement.children.length;if(columnIndex<0||(position==="left"&&columnIndex===0)||(position!=="left"&&columnIndex===nColumns-1)){return;}
const trs=cell.parentElement.parentElement.children;const tdsToMove=[...trs].map((tr)=>tr.children[columnIndex]);const selectionToRestore=this.dependencies.selection.getEditableSelection();if(position==="left"){tdsToMove.forEach((td)=>td.previousElementSibling.before(td));}else{tdsToMove.forEach((td)=>td.nextElementSibling.after(td));}
this.dependencies.selection.setSelection(selectionToRestore);}
moveRow(position,row){const selectionToRestore=this.dependencies.selection.getEditableSelection();let adjustedRow;if(position==="up"){row.previousElementSibling?.before(row);adjustedRow=row;}else{row.nextElementSibling?.after(row);adjustedRow=row.previousElementSibling;}
if(!adjustedRow.previousElementSibling){adjustedRow.childNodes.forEach((cell,index)=>{cell.style.width=adjustedRow.nextElementSibling.childNodes[index].style.width;});}
this.dependencies.selection.setSelection(selectionToRestore);}
resetTableSize(table){table.removeAttribute("style");const cells=[...table.querySelectorAll("tr, td")];cells.forEach((cell)=>{const cStyle=cell.style;if(cell.tagName==="TR"){cStyle.height="";}else{cStyle.width="";}});}
deleteTable(table){table=table||findInSelection(this.dependencies.selection.getEditableSelection(),"table");if(!table){return;}
const baseContainer=this.dependencies.baseContainer.createBaseContainer();baseContainer.appendChild(this.document.createElement("br"));table.before(baseContainer);table.remove();this.dependencies.selection.setCursorStart(baseContainer);}
deleteTableCells(selectedTds){const rows=[...closestElement(selectedTds[0],"tr").parentElement.children].filter((child)=>child.nodeName==="TR");const firstRowCells=[...rows[0].children].filter((child)=>child.nodeName==="TD"||child.nodeName==="TH");const firstCellRowIndex=getRowIndex(selectedTds[0]);const firstCellColumnIndex=getColumnIndex(selectedTds[0]);const lastCellRowIndex=getRowIndex(selectedTds[selectedTds.length-1]);const lastCellColumnIndex=getColumnIndex(selectedTds[selectedTds.length-1]);const areFullColumnsSelected=firstCellRowIndex===0&&lastCellRowIndex===rows.length-1;const areFullRowsSelected=firstCellColumnIndex===0&&lastCellColumnIndex===firstRowCells.length-1;if(areFullColumnsSelected){for(let index=firstCellColumnIndex;index<=lastCellColumnIndex;index++){this.removeColumn(firstRowCells[index]);}
return;}
if(areFullRowsSelected){for(let index=firstCellRowIndex;index<=lastCellRowIndex;index++){this.removeRow(rows[index]);}
return;}
for(const td of selectedTds){td.replaceChildren(this.document.createElement("br"));}
this.dependencies.selection.setCursorStart(selectedTds[0]);}
deleteRangeWithFullySelectedTables(range,fullySelectedTables){let{startContainer,startOffset,endContainer,endOffset}=range;const firstTable=fullySelectedTables[0];if(firstTable.contains(startContainer)){[startContainer,startOffset]=leftPos(firstTable);}
const lastTable=fullySelectedTables.at(-1);if(lastTable.contains(endContainer)){[endContainer,endOffset]=rightPos(lastTable);}
range={startContainer,startOffset,endContainer,endOffset};range=this.dependencies.delete.deleteRange(range);const[anchorNode,anchorOffset]=getDeepestPosition(range.startContainer,range.startOffset);this.dependencies.selection.setSelection({anchorNode,anchorOffset});}
handleDeleteRange(range){const fullySelectedTables=[...this.editable.querySelectorAll(".o_selected_table")].filter((table)=>[...table.querySelectorAll("td")].every((td)=>closestElement(td,"table")!==table||td.classList.contains("o_selected_td")));if(fullySelectedTables.length){this.deleteRangeWithFullySelectedTables(range,fullySelectedTables);return true;}
const selectedTds=this.editable.querySelectorAll(".o_selected_td");if(selectedTds.length){this.deleteTableCells(selectedTds);return true;}
return false;}
shiftCursorToTableCell(shiftIndex){const sel=this.dependencies.selection.getEditableSelection();const currentTd=closestElement(sel.anchorNode,"td");const closestTable=closestElement(currentTd,"table");if(!currentTd||!closestTable){return false;}
const tds=[...closestTable.querySelectorAll("td")];const cursorDestination=tds[tds.findIndex((td)=>currentTd===td)+shiftIndex];if(!cursorDestination){return false;}
this.dependencies.selection.setCursorEnd(lastLeaf(cursorDestination));return true;}
hanldeFirefoxSelection(ev=null){const selection=this.document.getSelection();if(isBrowserFirefox()){if(!this.dependencies.selection.isSelectionInEditable(selection)){return false;}
if(selection.rangeCount>1){const[anchorNode,anchorOffset]=getDeepestPosition(selection.getRangeAt(0).startContainer,selection.getRangeAt(0).startOffset);const[focusNode,focusOffset]=getDeepestPosition(selection.getRangeAt(selection.rangeCount-1).startContainer,selection.getRangeAt(selection.rangeCount-1).startOffset);this.dependencies.selection.setSelection({anchorNode,anchorOffset,focusNode,focusOffset,});return true;}else if(ev&&closestElement(ev.target,"table")===closestElement(selection.anchorNode,"table")&&closestElement(ev.target,"td")!==closestElement(selection.focusNode,"td")){this.dependencies.selection.setSelection({anchorNode:selection.anchorNode,anchorOffset:selection.anchorOffset,focusNode:ev.target,focusOffset:0,});return true;}}
return false;}
updateSelectionTable(selectionData){if(this.hanldeFirefoxSelection()){return;}
const selection=selectionData.editableSelection;const startTd=closestElement(selection.startContainer,"td");const endTd=closestElement(selection.endContainer,"td");if(!(startTd&&startTd===endTd)||this._isKeyDown){delete this._isKeyDown;this.deselectTable();}
const startTable=ancestors(selection.startContainer,this.editable).filter((node)=>node.nodeName==="TABLE").pop();const endTable=ancestors(selection.endContainer,this.editable).filter((node)=>node.nodeName==="TABLE").pop();const traversedNodes=this.dependencies.selection.getTraversedNodes({deep:true});if(startTd!==endTd&&startTable===endTable){if(!isProtected(startTable)&&!isProtecting(startTable)){this.selectTableCells(selection);}}else if(!traversedNodes.every((node)=>closestElement(node.parentElement,"table"))){const traversedTables=new Set(traversedNodes.map((node)=>closestElement(node,"table")).filter((node)=>node&&!isProtected(node)&&!isProtecting(node)));for(const table of traversedTables){if(!ancestors(table,this.editable).some((node)=>traversedTables.has(node))){table.classList.toggle("o_selected_table",true);for(const td of[...table.querySelectorAll("td")].filter((td)=>closestElement(td,"table")===table)){td.classList.toggle("o_selected_td",true);}}}}}
onMousedown(ev){this._currentMouseState=ev.type;this._lastMousedownPosition=[ev.x,ev.y];this.deselectTable();if(this.isPointerInsideCell(ev)){this.editable.addEventListener("mousemove",this.onMousemove);const currentSelection=this.dependencies.selection.getEditableSelection();this.dependencies.selection.setCursorStart(currentSelection.anchorNode);}}
onMouseup(ev){this._currentMouseState=ev.type;this.editable.removeEventListener("mousemove",this.onMousemove);}
isPointerInsideCell(ev){const td=closestElement(ev.target,"td");if(td){const targetRect=td.getBoundingClientRect();if(ev.clientX>targetRect.x+BORDER_SENSITIVITY&&ev.clientX<targetRect.x+td.clientWidth-BORDER_SENSITIVITY&&ev.clientY>targetRect.y+BORDER_SENSITIVITY&&ev.clientY<targetRect.y+td.clientHeight-BORDER_SENSITIVITY){return true;}}
return false;}
onMousemove(ev){if(this._currentMouseState!=="mousedown"){return;}
if(this.hanldeFirefoxSelection(ev)){return;}
const selection=this.dependencies.selection.getEditableSelection();const docSelection=this.document.getSelection();const range=docSelection.rangeCount&&docSelection.getRangeAt(0);const startTd=closestElement(selection.startContainer,"td");const endTd=closestElement(selection.endContainer,"td");if(startTd&&startTd===endTd&&!isProtected(startTd)&&!isProtecting(startTd)){const selectedNodes=this.dependencies.selection.getSelectedNodes();const cellContents=descendants(startTd);const areCellContentsFullySelected=cellContents.filter((d)=>!isBlock(d)).every((child)=>selectedNodes.includes(child));if(areCellContentsFullySelected){const SENSITIVITY=5;const rangeRect=range.getBoundingClientRect();const isMovingAwayFromSelection=ev.clientX>rangeRect.x+rangeRect.width+SENSITIVITY||ev.clientX<rangeRect.x-SENSITIVITY;if(isMovingAwayFromSelection){this.selectTableCells(selection);}}else if(cellContents.filter(isBlock).every(isEmptyBlock)&&Math.abs(ev.clientX-
(this._lastMousedownPosition?this._lastMousedownPosition[0]:ev.clientX))>=20){this.selectTableCells(selection);}}}
selectTableCells(selection){const table=closestElement(selection.commonAncestorContainer,"table");table.classList.toggle("o_selected_table",true);const columns=[...table.querySelectorAll("td")].filter((td)=>closestElement(td,"table")===table);const startCol=[selection.startContainer,...ancestors(selection.startContainer,this.editable)].find((node)=>node.nodeName==="TD"&&closestElement(node,"table")===table)||columns[0];const endCol=[selection.endContainer,...ancestors(selection.endContainer,this.editable)].find((node)=>node.nodeName==="TD"&&closestElement(node,"table")===table)||columns[columns.length-1];const[startRow,endRow]=[closestElement(startCol,"tr"),closestElement(endCol,"tr")];const[startColIndex,endColIndex]=[getColumnIndex(startCol),getColumnIndex(endCol)];const[startRowIndex,endRowIndex]=[getRowIndex(startRow),getRowIndex(endRow)];const[minRowIndex,maxRowIndex]=[Math.min(startRowIndex,endRowIndex),Math.max(startRowIndex,endRowIndex),];const[minColIndex,maxColIndex]=[Math.min(startColIndex,endColIndex),Math.max(startColIndex,endColIndex),];const grid=[...table.querySelectorAll("tr")].filter((tr)=>closestElement(tr,"table")===table).map((tr)=>[...tr.children].filter((child)=>child.nodeName==="TD"));for(const tds of grid.filter((_,index)=>index>=minRowIndex&&index<=maxRowIndex)){for(const td of tds.filter((_,index)=>index>=minColIndex&&index<=maxColIndex)){td.classList.toggle("o_selected_td",true);}}}
deselectTable(root=this.editable){let didDeselectTable=false;for(const table of root.querySelectorAll(".o_selected_table")){removeClass(table,"o_selected_table");for(const td of table.querySelectorAll(".o_selected_td")){removeClass(td,"o_selected_td");}
didDeselectTable=true;}
return didDeselectTable;}
applyTableColor(color,mode,previewMode){const selectedTds=[...this.editable.querySelectorAll("td.o_selected_td")].filter((node)=>node.isContentEditable);if(selectedTds.length&&mode==="backgroundColor"){if(previewMode){selectedTds.forEach((td)=>td.classList.remove("o_selected_td"));}
for(const td of selectedTds){this.dependencies.color.colorElement(td,color,mode);if(color){td.style["color"]=getComputedStyle(td).color;}else{td.style["color"]="";}}}}
adjustTraversedNodes(traversedNodes){const modifiedTraversedNodes=[];const visitedTables=new Set();for(const node of traversedNodes){const selectedTable=closestElement(node,".o_selected_table");if(selectedTable){if(visitedTables.has(selectedTable)){continue;}
visitedTables.add(selectedTable);for(const selectedTd of selectedTable.querySelectorAll(".o_selected_td")){modifiedTraversedNodes.push(selectedTd,...descendants(selectedTd));}}else{modifiedTraversedNodes.push(node);}}
return modifiedTraversedNodes;}
resetTableSelection(){const selection=this.dependencies.selection.getEditableSelection({deep:true});const anchorTD=closestElement(selection.anchorNode,".o_selected_td");if(!anchorTD){return;}
this.deselectTable();this.dependencies.selection.setSelection({anchorNode:anchorTD.firstChild,anchorOffset:0,focusNode:anchorTD.lastChild,focusOffset:nodeSize(anchorTD.lastChild),});}}
return __exports;});;

/* /html_editor/static/src/main/table/table_resize_plugin.js */
odoo.define('@html_editor/main/table/table_resize_plugin',['@html_editor/plugin','@html_editor/utils/dom_traversal','@html_editor/utils/table','@html_editor/main/table/table_plugin'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{closestElement,getAdjacentNextSiblings,getAdjacentPreviousSiblings,}=require("@html_editor/utils/dom_traversal");const{getColumnIndex}=require("@html_editor/utils/table");const{BORDER_SENSITIVITY}=require("@html_editor/main/table/table_plugin");const TableResizePlugin=__exports.TableResizePlugin=class TableResizePlugin extends Plugin{static id="tableResize";static dependencies=["table","history"];setup(){this.addDomListener(this.editable,"mousedown",this.onMousedown);this.addDomListener(this.editable,"mousemove",this.onMousemove);}
isHoveringTdBorder(ev){const target=(ev.target);if(ev.target&&target.nodeName==="TD"&&target.isContentEditable){const targetRect=target.getBoundingClientRect();if(ev.clientX<=targetRect.x+BORDER_SENSITIVITY){return"left";}else if(ev.clientY<=targetRect.y+BORDER_SENSITIVITY){return"top";}else if(ev.clientX>=targetRect.x+target.clientWidth-BORDER_SENSITIVITY){return"right";}else if(ev.clientY>=targetRect.y+target.clientHeight-BORDER_SENSITIVITY){return"bottom";}}
return false;}
setTableResizeCursor(direction){const classList=this.editable.classList;if(classList.contains("o_col_resize")){classList.remove("o_col_resize");}
if(classList.contains("o_row_resize")){classList.remove("o_row_resize");}
if(direction==="col"){this.editable.classList.add("o_col_resize");}else if(direction==="row"){this.editable.classList.add("o_row_resize");}}
resizeTable(ev,direction,target1,target2){ev.preventDefault();const position=target1?(target2?"middle":"last"):"first";let[item,neighbor]=[target1||target2,target2];const table=closestElement(item,"table");const[sizeProp,positionProp,clientPositionProp]=direction==="col"?["width","x","clientX"]:["height","y","clientY"];const isRTL=this.config.direction==="rtl";if(sizeProp==="width"){const tableRect=table.getBoundingClientRect();table.style[sizeProp]=tableRect[sizeProp]+"px";}
const unsizedItemsSelector=`${
            direction === "col" ? "td" : "tr"
        }:not([style*=${sizeProp}])`;for(const unsizedItem of table.querySelectorAll(unsizedItemsSelector)){unsizedItem.style[sizeProp]=unsizedItem.getBoundingClientRect()[sizeProp]+"px";}
if(direction==="col"){let hostCell=closestElement(table,"td");const hostCells=[];while(hostCell){hostCells.push(hostCell);hostCell=closestElement(hostCell.parentElement,"td");}
const nthColumn=getColumnIndex(item);const firstRow=[...table.querySelector("tr").children];[item,neighbor]=[firstRow[nthColumn],firstRow[nthColumn+1]];for(const td of hostCells){if(td!==item&&td!==neighbor&&closestElement(td,"table")===table&&getColumnIndex(td)!==0){td.style.removeProperty(sizeProp);}}
if(isRTL&&position=="middle"){[item,neighbor]=[neighbor,item];}}
const MIN_SIZE=33;switch(position){case"first":{const marginProp=direction==="col"?(isRTL?"marginRight":"marginLeft"):"marginTop";const itemRect=item.getBoundingClientRect();const tableStyle=getComputedStyle(table);const currentMargin=parseFloat(tableStyle[marginProp]);let sizeDelta=itemRect[positionProp]-ev[clientPositionProp];if(direction==="col"&&isRTL){sizeDelta=ev[clientPositionProp]-itemRect[positionProp]-itemRect[sizeProp];}
const newMargin=currentMargin-sizeDelta;const currentSize=itemRect[sizeProp];const newSize=currentSize+sizeDelta;if(newMargin>=0&&newSize>MIN_SIZE){const tableRect=table.getBoundingClientRect();const hostCell=closestElement(table.parentElement,"td");const childTable=item.querySelector("table");const endProp=isRTL?"left":"right";if(direction==="col"&&((hostCell&&tableRect[endProp]+sizeDelta>hostCell.getBoundingClientRect()[endProp]-5)||(childTable&&childTable.getBoundingClientRect()[endProp]>itemRect[endProp]+sizeDelta-5))){break;}
table.style[marginProp]=newMargin+"px";item.style[sizeProp]=newSize+"px";if(sizeProp==="width"){table.style[sizeProp]=tableRect[sizeProp]+sizeDelta+"px";}}
break;}
case"middle":{const[itemRect,neighborRect]=[item.getBoundingClientRect(),neighbor.getBoundingClientRect(),];const[currentSize,newSize]=[itemRect[sizeProp],ev[clientPositionProp]-itemRect[positionProp],];const editableStyle=getComputedStyle(this.editable);const sizeDelta=newSize-currentSize;const currentNeighborSize=neighborRect[sizeProp];const newNeighborSize=currentNeighborSize-sizeDelta;const maxWidth=this.editable.clientWidth-
parseFloat(editableStyle.paddingLeft)-
parseFloat(editableStyle.paddingRight);const tableRect=table.getBoundingClientRect();if(newSize>MIN_SIZE&&(direction==="row"||newNeighborSize>MIN_SIZE||tableRect[sizeProp]+sizeDelta<maxWidth)){const childTable=item.querySelector("table");if(direction==="col"&&childTable&&childTable.getBoundingClientRect().right>itemRect.right+sizeDelta-5){break;}
item.style[sizeProp]=newSize+"px";if(direction==="col"){neighbor.style[sizeProp]=(newNeighborSize>MIN_SIZE?newNeighborSize:currentNeighborSize)+"px";}else if(sizeProp==="width"){table.style[sizeProp]=tableRect[sizeProp]+sizeDelta+"px";}}
break;}
case"last":{const itemRect=item.getBoundingClientRect();let sizeDelta=ev[clientPositionProp]-(itemRect[positionProp]+itemRect[sizeProp]);if(direction==="col"&&isRTL){sizeDelta=itemRect[positionProp]-ev[clientPositionProp];}
const currentSize=itemRect[sizeProp];const newSize=currentSize+sizeDelta;if((newSize>=0||direction==="row")&&newSize>MIN_SIZE){const tableRect=table.getBoundingClientRect();const hostCell=closestElement(table.parentElement,"td");const childTable=item.querySelector("table");const endProp=isRTL?"left":"right";if(direction==="col"&&((hostCell&&tableRect[endProp]+sizeDelta>hostCell.getBoundingClientRect()[endProp]-5)||(childTable&&childTable.getBoundingClientRect()[endProp]>itemRect[endProp]+sizeDelta-5))){break;}
if(sizeProp==="width"){table.style[sizeProp]=tableRect[sizeProp]+sizeDelta+"px";}
item.style[sizeProp]=newSize+"px";}
break;}}}
onMousedown(ev){const isHoveringTdBorder=this.isHoveringTdBorder(ev);const isRTL=this.config.direction==="rtl";if(isHoveringTdBorder){ev.preventDefault();const direction={top:"row",right:"col",bottom:"row",left:"col"}[isHoveringTdBorder]||false;let target1,target2;const column=closestElement(ev.target,"tr");if(isHoveringTdBorder==="top"&&column){target1=getAdjacentPreviousSiblings(column).find((node)=>node.nodeName==="TR");target2=closestElement(ev.target,"tr");}else if(isHoveringTdBorder==="right"){if(isRTL){target1=getAdjacentPreviousSiblings(ev.target).find((node)=>node.nodeName==="TD");target2=ev.target;}else{target1=ev.target;target2=getAdjacentNextSiblings(ev.target).find((node)=>node.nodeName==="TD");}}else if(isHoveringTdBorder==="bottom"&&column){target1=closestElement(ev.target,"tr");target2=getAdjacentNextSiblings(column).find((node)=>node.nodeName==="TR");}else if(isHoveringTdBorder==="left"){if(isRTL){target1=ev.target;target2=getAdjacentNextSiblings(ev.target).find((node)=>node.nodeName==="TD");}else{target1=getAdjacentPreviousSiblings(ev.target).find((node)=>node.nodeName==="TD");target2=ev.target;}}
this.isResizingTable=true;this.setTableResizeCursor(direction);const resizeTable=(ev)=>this.resizeTable(ev,direction,target1,target2);const stopResizing=(ev)=>{ev.preventDefault();this.isResizingTable=false;this.setTableResizeCursor(false);this.dependencies.history.addStep();this.document.removeEventListener("mousemove",resizeTable);this.document.removeEventListener("mouseup",stopResizing);this.document.removeEventListener("mouseleave",stopResizing);};this.document.addEventListener("mousemove",resizeTable);this.document.addEventListener("mouseup",stopResizing);this.document.addEventListener("mouseleave",stopResizing);}}
onMousemove(ev){const direction={top:"row",right:"col",bottom:"row",left:"col"}[this.isHoveringTdBorder(ev)]||false;if(direction||!this.isResizingTable){this.setTableResizeCursor(direction);}}}
return __exports;});;

/* /html_editor/static/src/main/table/table_ui_plugin.js */
odoo.define('@html_editor/main/table/table_ui_plugin',['@html_editor/plugin','@html_editor/utils/dom_traversal','@odoo/owl','@web/core/l10n/translation','@html_editor/main/table/table_menu','@html_editor/main/table/table_picker'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{closestElement}=require("@html_editor/utils/dom_traversal");const{reactive}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{TableMenu}=require("@html_editor/main/table/table_menu");const{TablePicker}=require("@html_editor/main/table/table_picker");const TableUIPlugin=__exports.TableUIPlugin=class TableUIPlugin extends Plugin{static id="tableUi";static dependencies=["history","overlay","table"];resources={user_commands:[{id:"openTablePicker",title:_t("Table"),description:_t("Insert a table"),icon:"fa-table",run:this.openPickerOrInsertTable.bind(this),},],powerbox_items:[{categoryId:"structure",commandId:"openTablePicker",},],power_buttons:{commandId:"openTablePicker"},};setup(){this.picker=this.dependencies.overlay.createOverlay(TablePicker,{positionOptions:{updatePositionOnResize:false,onPositioned:(picker,position)=>{const popperRect=picker.getBoundingClientRect();const{left}=position;if(this.config.direction==="rtl"){picker.style.right=`${window.innerWidth - left - popperRect.width}px`;picker.style.removeProperty("left");}},},});this.activeTd=null;this.colMenu=this.dependencies.overlay.createOverlay(TableMenu,{positionOptions:{position:"top-fit",onPositioned:(el,solution)=>{if(solution.direction!=="top"){el.style.display="none";this.colMenu.close();}},},});this.rowMenu=this.dependencies.overlay.createOverlay(TableMenu,{positionOptions:{position:"left-fit",},});this.addDomListener(this.document,"pointermove",this.onMouseMove);const closeMenus=()=>{if(this.isMenuOpened){this.isMenuOpened=false;this.colMenu.close();this.rowMenu.close();}};this.addDomListener(this.document,"scroll",closeMenus,true);}
openPicker(){this.picker.open({props:{editable:this.editable,overlay:this.picker,direction:this.config.direction||"ltr",insertTable:(params)=>this.dependencies.table.insertTable(params),},});}
openPickerOrInsertTable(){if(this.services.ui.isSmall){this.dependencies.table.insertTable({cols:3,rows:3});}else{this.openPicker();}}
onMouseMove(ev){const target=ev.target;if(this.isMenuOpened){return;}
if(["TD","TH"].includes(target.tagName)&&target!==this.activeTd&&this.editable.contains(target)){if(ev.target.isContentEditable){this.setActiveTd(target);}}else if(this.activeTd){const isOverlay=target.closest(".o-overlay-container");if(isOverlay){return;}
const parentTd=closestElement(target,"td, th");if(!parentTd){this.setActiveTd(null);}}}
createDropdownState(menuToClose){const dropdownState=reactive({isOpen:false,open:()=>{dropdownState.isOpen=true;menuToClose.close();this.isMenuOpened=true;},close:()=>{dropdownState.isOpen=false;this.isMenuOpened=false;},});return dropdownState;}
setActiveTd(td){this.activeTd=td;this.colMenu.close();this.rowMenu.close();if(!td){return;}
const withAddStep=(fn)=>{return(...args)=>{fn(...args);this.dependencies.history.addStep();};};const tableMethods={moveColumn:withAddStep(this.dependencies.table.moveColumn),addColumn:withAddStep(this.dependencies.table.addColumn),removeColumn:withAddStep(this.dependencies.table.removeColumn),moveRow:withAddStep(this.dependencies.table.moveRow),addRow:withAddStep(this.dependencies.table.addRow),removeRow:withAddStep(this.dependencies.table.removeRow),resetTableSize:withAddStep(this.dependencies.table.resetTableSize),};if(td.cellIndex===0){this.rowMenu.open({target:td,props:{type:"row",overlay:this.rowMenu,target:td,dropdownState:this.createDropdownState(this.colMenu),...tableMethods,},});}
if(td.parentElement.rowIndex===0){this.colMenu.open({target:td,props:{type:"column",overlay:this.colMenu,target:td,dropdownState:this.createDropdownState(this.rowMenu),direction:this.config.direction||"ltr",...tableMethods,},});}}}
return __exports;});;

/* /html_editor/static/src/main/tabulation_plugin.js */
odoo.define('@html_editor/main/tabulation_plugin',['@html_editor/plugin','@html_editor/utils/blocks','@html_editor/utils/dom','@html_editor/utils/dom_info','@html_editor/utils/dom_traversal','@html_editor/utils/html','@html_editor/utils/position'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{closestBlock,isBlock}=require("@html_editor/utils/blocks");const{splitTextNode}=require("@html_editor/utils/dom");const{isEditorTab,isTextNode,isZWS}=require("@html_editor/utils/dom_info");const{descendants,getAdjacentPreviousSiblings,closestElement,firstLeaf,}=require("@html_editor/utils/dom_traversal");const{parseHTML}=require("@html_editor/utils/html");const{DIRECTIONS,childNodeIndex}=require("@html_editor/utils/position");const tabHtml='<span class="oe-tabs" contenteditable="false">\u0009</span>\u200B';const GRID_COLUMN_WIDTH=40;function isIndentationTab(tab){return!getAdjacentPreviousSiblings(tab).some((sibling)=>isTextNode(sibling)&&!/^[\u200B\s]*$/.test(sibling.textContent));}
const TabulationPlugin=__exports.TabulationPlugin=class TabulationPlugin extends Plugin{static id="tabulation";static dependencies=["dom","selection","history","delete"];static shared=["indentBlocks","outdentBlocks"];resources={user_commands:[{id:"tab",run:this.handleTab.bind(this)},{id:"shiftTab",run:this.handleShiftTab.bind(this)},],shortcuts:[{hotkey:"tab",commandId:"tab"},{hotkey:"shift+tab",commandId:"shiftTab"},],clean_for_save_handlers:({root})=>{for(const tab of root.querySelectorAll("span.oe-tabs")){tab.removeAttribute("contenteditable");}},normalize_handlers:this.normalize.bind(this),delete_forward_overrides:this.handleDeleteForward.bind(this),unsplittable_node_predicates:isEditorTab,};handleTab(){if(this.delegateTo("tab_overrides")){return;}
const selection=this.dependencies.selection.getEditableSelection();if(selection.isCollapsed){this.insertTab();}else{const traversedBlocks=this.dependencies.selection.getTraversedBlocks();this.indentBlocks(traversedBlocks);}
this.dependencies.history.addStep();}
handleShiftTab(){if(this.delegateTo("shift_tab_overrides")){return;}
const traversedBlocks=this.dependencies.selection.getTraversedBlocks();this.outdentBlocks(traversedBlocks);this.dependencies.history.addStep();}
insertTab(){const selection=this.dependencies.selection.getEditableSelection();const element=closestElement(selection.anchorNode);const isSelectionAtStart=firstLeaf(element)===selection.anchorNode&&(selection.anchorOffset===0||element.textContent==="\u200B");const tab=parseHTML(this.document,tabHtml);if(isSelectionAtStart&&!isBlock(element)){element.before(tab);}else{this.dependencies.dom.insert(tab);}}
indentBlocks(blocks){const selectionToRestore=this.dependencies.selection.getEditableSelection();const tab=parseHTML(this.document,tabHtml);for(const block of blocks){block.prepend(tab.cloneNode(true));}
this.dependencies.selection.setSelection(selectionToRestore,{normalize:false});}
outdentBlocks(blocks){for(const block of blocks){const firstTab=descendants(block).find(isEditorTab);if(firstTab&&isIndentationTab(firstTab)){this.removeTrailingZWS(firstTab);firstTab.remove();}}}
removeTrailingZWS(tab){const selection=this.dependencies.selection.getEditableSelection();const{anchorNode,anchorOffset,focusNode,focusOffset}=selection;const updateAnchor=anchorNode===tab.nextSibling;const updateFocus=focusNode===tab.nextSibling;let zwsRemoved=0;while(tab.nextSibling&&tab.nextSibling.nodeType===Node.TEXT_NODE&&tab.nextSibling.textContent.startsWith("\u200B")){splitTextNode(tab.nextSibling,1,DIRECTIONS.LEFT);tab.nextSibling.remove();zwsRemoved++;}
if(updateAnchor||updateFocus){this.dependencies.selection.setSelection({anchorNode:updateAnchor?tab.nextSibling:anchorNode,anchorOffset:updateAnchor?Math.max(0,anchorOffset-zwsRemoved):anchorOffset,focusNode:updateFocus?tab.nextSibling:focusNode,focusOffset:updateFocus?Math.max(0,focusOffset-zwsRemoved):focusOffset,});}}
adjustTabWidth(tabSpan){let tabPreviousSibling=tabSpan.previousSibling;while(isZWS(tabPreviousSibling)){tabPreviousSibling=tabPreviousSibling.previousSibling;}
if(isEditorTab(tabPreviousSibling)){tabSpan.style.width=`${GRID_COLUMN_WIDTH}px`;return;}
const spanRect=tabSpan.getBoundingClientRect();const referenceRect=this.editable.firstElementChild?.getBoundingClientRect();if(!referenceRect?.width||!spanRect.width){return;}
const relativePosition=spanRect.left-referenceRect.left;const distToNextGridLine=GRID_COLUMN_WIDTH-(relativePosition%GRID_COLUMN_WIDTH);const width=distToNextGridLine.toFixed(1);tabSpan.style.width=`${width}px`;}
alignTabs(root=this.editable){const block=closestBlock(root);if(!block){return;}
for(const tab of block.querySelectorAll("span.oe-tabs")){this.adjustTabWidth(tab);}}
expandRangeToIncludeZWS(tabElement){let previous=tabElement;let node=tabElement.nextSibling;while(node?.nodeType===Node.TEXT_NODE){for(let i=0;i<node.textContent.length;i++){if(node.textContent[i]!=="\u200B"){return[node,i];}}
previous=node;node=node.nextSibling;}
return[previous.parentElement,childNodeIndex(previous)+1];}
handleDeleteForward(range){let{endContainer,endOffset}=range;if(!(endContainer?.nodeType===Node.ELEMENT_NODE)||!endOffset){return;}
const nodeToDelete=endContainer.childNodes[endOffset-1];if(isEditorTab(nodeToDelete)){[endContainer,endOffset]=this.expandRangeToIncludeZWS(nodeToDelete);range=this.dependencies.delete.deleteRange({...range,endContainer,endOffset});this.dependencies.selection.setSelection({anchorNode:range.startContainer,anchorOffset:range.startOffset,});return true;}}
normalize(el){for(const tab of el.querySelectorAll(".oe-tabs")){tab.setAttribute("contenteditable","false");}
this.alignTabs(el);}}
return __exports;});;

/* /html_editor/static/src/main/text_direction_plugin.js */
odoo.define('@html_editor/main/text_direction_plugin',['@web/core/l10n/translation','@html_editor/plugin','@html_editor/utils/blocks','@html_editor/utils/dom_traversal','@html_editor/utils/dom_info'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Plugin}=require("@html_editor/plugin");const{closestBlock}=require("@html_editor/utils/blocks");const{closestElement}=require("@html_editor/utils/dom_traversal");const{isContentEditable,isTextNode}=require("@html_editor/utils/dom_info");const TextDirectionPlugin=__exports.TextDirectionPlugin=class TextDirectionPlugin extends Plugin{static id="textDirection";static dependencies=["selection","history","split","format"];resources={user_commands:[{id:"switchDirection",title:_t("Switch direction"),description:_t("Switch the text's direction"),icon:"fa-exchange",run:this.switchDirection.bind(this),},],powerbox_items:[{categoryId:"format",commandId:"switchDirection",},],};setup(){if(this.config.direction){this.editable.setAttribute("dir",this.config.direction);}
this.direction=this.config.direction||"ltr";}
switchDirection(){const selection=this.dependencies.split.splitSelection();const selectedTextNodes=[selection.anchorNode,...this.dependencies.selection.getSelectedNodes(),].filter((n)=>isTextNode(n)&&isContentEditable(n)&&n.nodeValue.trim().length);const blocks=new Set(selectedTextNodes.map((textNode)=>closestElement(textNode,"ul,ol")||closestBlock(textNode)));const shouldApplyStyle=!this.dependencies.format.isSelectionFormat("switchDirection");for(const block of blocks){for(const node of block.querySelectorAll("ul,ol")){blocks.add(node);}}
for(const block of blocks){if(!shouldApplyStyle){block.removeAttribute("dir");}else{block.setAttribute("dir",this.direction==="ltr"?"rtl":"ltr");}}
for(const element of blocks){const style=getComputedStyle(element);if(style.direction==="ltr"&&style.textAlign==="right"){element.style.setProperty("text-align","left");}else if(style.direction==="rtl"&&style.textAlign==="left"){element.style.setProperty("text-align","right");}}
this.dependencies.history.addStep();}}
return __exports;});;

/* /html_editor/static/src/main/toolbar/mobile_toolbar.js */
odoo.define('@html_editor/main/toolbar/mobile_toolbar',['@odoo/owl','@html_editor/main/toolbar/toolbar'],function(require){'use strict';let __exports={};const{Component,onMounted,useExternalListener,useRef}=require("@odoo/owl");const{Toolbar}=require("@html_editor/main/toolbar/toolbar");const ToolbarMobile=__exports.ToolbarMobile=class ToolbarMobile extends Component{static template="html_editor.MobileToolbar";static props=["*"];static components={Toolbar,};setup(){this.toolbar=useRef("toolbarWrapper");useExternalListener(window.visualViewport,"resize",this.fixToolbarPosition);useExternalListener(window.visualViewport,"scroll",this.fixToolbarPosition);onMounted(()=>{this.fixToolbarPosition();});}
fixToolbarPosition(){const keyboardHeight=window.innerHeight-(window.visualViewport.height+window.visualViewport.offsetTop);if(keyboardHeight>0){this.toolbar.el.style.bottom=`${keyboardHeight}px`;}else{this.toolbar.el.style.bottom=`0px`;}}}
return __exports;});;

/* /html_editor/static/src/main/toolbar/toolbar.js */
odoo.define('@html_editor/main/toolbar/toolbar',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,useState,validate}=require("@odoo/owl");const Toolbar=__exports.Toolbar=class Toolbar extends Component{static template="html_editor.Toolbar";static props={class:{type:String,optional:true},toolbar:{type:Object,shape:{getSelection:Function,focusEditable:Function,buttonGroups:{type:Array,element:{type:Object,shape:{id:String,namespace:{type:String,optional:true},buttons:{type:Array,element:{type:Object,validate:(button)=>{const base={id:String,groupId:String,title:String,isAvailable:{type:Function,optional:true},isDisabled:{type:Function,optional:true},};if(button.Component){validate(button,{...base,Component:Function,props:{type:Object,optional:true},});}else{validate(button,{...base,run:Function,icon:{type:String,optional:true},text:{type:String,optional:true},isActive:{type:Function,optional:true},});}
return true;},},},},},},state:{type:Object,shape:{buttonsActiveState:Object,buttonsDisabledState:Object,buttonsAvailableState:Object,namespace:{type:String,optional:true,},},},},},};setup(){this.state=useState(this.props.toolbar.state);}
getFilteredButtonGroups(){if(this.state.namespace){const filteredGroups=this.props.toolbar.buttonGroups.filter((group)=>group.namespace===this.state.namespace);if(filteredGroups.length>0){return filteredGroups;}}
return this.props.toolbar.buttonGroups.filter((group)=>group.namespace===undefined);}
onButtonClick(button){button.run();this.props.toolbar.focusEditable();}}
const toolbarButtonProps=__exports.toolbarButtonProps={title:String,getSelection:Function,};return __exports;});;

/* /html_editor/static/src/main/toolbar/toolbar_plugin.js */
odoo.define('@html_editor/main/toolbar/toolbar_plugin',['@html_editor/plugin','@html_editor/utils/dom_info','@odoo/owl','@web/views/view_compiler','@html_editor/main/toolbar/toolbar','@web/core/browser/feature_detection','@web/core/registry','@html_editor/main/toolbar/mobile_toolbar','@web/core/utils/timing','@web/core/utils/objects','@html_editor/utils/dom_traversal'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{isZWS}=require("@html_editor/utils/dom_info");const{reactive}=require("@odoo/owl");const{isTextNode}=require("@web/views/view_compiler");const{Toolbar}=require("@html_editor/main/toolbar/toolbar");const{hasTouch}=require("@web/core/browser/feature_detection");const{registry}=require("@web/core/registry");const{ToolbarMobile}=require("@html_editor/main/toolbar/mobile_toolbar");const{debounce}=require("@web/core/utils/timing");const{omit,pick}=require("@web/core/utils/objects");const{closestElement}=require("@html_editor/utils/dom_traversal");const DELAY_TOOLBAR_OPEN=300;const ToolbarPlugin=__exports.ToolbarPlugin=class ToolbarPlugin extends Plugin{static id="toolbar";static dependencies=["overlay","selection","userCommand"];static shared=["getToolbarInfo"];resources={selectionchange_handlers:this.handleSelectionChange.bind(this),step_added_handlers:()=>this.updateToolbar(),};setup(){const groupIds=new Set();for(const group of this.getResource("toolbar_groups")){if(groupIds.has(group.id)){throw new Error(`Duplicate toolbar group id: ${group.id}`);}
groupIds.add(group.id);}
this.buttonGroups=this.getButtonGroups();this.isMobileToolbar=hasTouch()&&window.visualViewport;if(this.isMobileToolbar){this.overlay=new MobileToolbarOverlay(this.editable);}else{this.overlay=this.dependencies.overlay.createOverlay(Toolbar,{positionOptions:{position:"top-start",},closeOnPointerdown:false,});}
this.state=reactive({buttonsActiveState:this.buttonGroups.flatMap((g)=>g.buttons.map((b)=>[b.id,false])),buttonsDisabledState:this.buttonGroups.flatMap((g)=>g.buttons.map((b)=>[b.id,false])),buttonsAvailableState:this.buttonGroups.flatMap((g)=>g.buttons.map((b)=>[b.id,true])),namespace:undefined,});this.updateSelection=null;this.onSelectionChangeActive=true;this.debouncedUpdateToolbar=debounce(this.updateToolbar,DELAY_TOOLBAR_OPEN);if(!this.isMobileToolbar){this.addDomListener(this.editable,"mousedown",()=>{this.overlay.close();this.debouncedUpdateToolbar.cancel();this.onSelectionChangeActive=false;});this.addDomListener(this.document,"mouseup",(ev)=>{if(ev.detail>=2){this.onSelectionChangeActive=true;this.debouncedUpdateToolbar();}else{setTimeout(()=>{this.updateToolbar();this.onSelectionChangeActive=true;});}});this.addDomListener(this.editable,"keydown",(ev)=>{if(ev.key.startsWith("Arrow")){this.overlay.close();this.onSelectionChangeActive=false;}});this.addDomListener(this.editable,"keyup",(ev)=>{if(ev.key.startsWith("Arrow")){this.onSelectionChangeActive=true;this.debouncedUpdateToolbar();}});}}
destroy(){this.debouncedUpdateToolbar.cancel();this.overlay.close();super.destroy();}
getButtons(){const toolbarItems=this.getResource("toolbar_items");const commandItemToButton=(item)=>{const command=this.dependencies.userCommand.getCommand(item.commandId);return{...pick(command,"title","icon","isAvailable"),...omit(item,"commandId","commandParams"),run:()=>command.run(item.commandParams),};};return toolbarItems.map((item)=>("Component"in item?item:commandItemToButton(item)));}
getButtonGroups(){const buttons=this.getButtons();const groups=this.getResource("toolbar_groups");return groups.map((group)=>({...group,buttons:buttons.filter((button)=>button.groupId===group.id),}));}
getToolbarInfo(){return{buttonGroups:this.buttonGroups,getSelection:()=>this.dependencies.selection.getSelectionData(),state:this.state,focusEditable:()=>this.dependencies.selection.focusEditable(),};}
handleSelectionChange(selectionData){if(this.onSelectionChangeActive){this.updateToolbar(selectionData);}}
updateToolbar(selectionData=this.dependencies.selection.getSelectionData()){this.updateToolbarVisibility(selectionData);if(this.overlay.isOpen||this.config.disableFloatingToolbar){this.updateNamespace();this.updateButtonsStates(selectionData.editableSelection);}}
getFilterTraverseNodes(){return this.dependencies.selection.getTraversedNodes().filter((node)=>!isTextNode(node)||(node.textContent!=="\n"&&!isZWS(node)));}
updateToolbarVisibility(selectionData){if(this.config.disableFloatingToolbar){return;}
if(this.shouldBeVisible(selectionData)){const props={toolbar:this.getToolbarInfo(),class:"shadow rounded my-2"};this.overlay.open({props});}else if(this.overlay.isOpen&&!this.shouldPreventClosing(selectionData)){this.overlay.close();}}
shouldBeVisible(selectionData){const inEditable=selectionData.documentSelectionIsInEditable&&!selectionData.documentSelectionIsProtected&&!selectionData.documentSelectionIsProtecting;if(!inEditable){return false;}
if(this.isMobileToolbar){return true;}
const isCollapsed=selectionData.editableSelection.isCollapsed;if(isCollapsed){return!!closestElement(selectionData.editableSelection.anchorNode,"td.o_selected_td");}
return this.getFilterTraverseNodes().length;}
shouldPreventClosing(selectionData){const preventClosing=selectionData.documentSelection?.anchorNode?.closest?.("[data-prevent-closing-overlay]");return preventClosing?.dataset?.preventClosingOverlay==="true";}
updateNamespace(){const traversedNodes=this.getFilterTraverseNodes();for(const namespace of this.getResource("toolbar_namespaces")){if(namespace.isApplied(traversedNodes)){this.state.namespace=namespace.id;return;}}
this.state.namespace=undefined;}
updateButtonsStates(selection){if(!this.updateSelection){queueMicrotask(()=>{if(!this.isDestroyed){this._updateButtonsStates();}});}
this.updateSelection=selection;}
_updateButtonsStates(){const selection=this.updateSelection;if(!selection){return;}
const nodes=this.getFilterTraverseNodes();for(const buttonGroup of this.buttonGroups){if(buttonGroup.namespace===this.state.namespace){for(const button of buttonGroup.buttons){this.state.buttonsActiveState[button.id]=button.isActive?.(selection,nodes);this.state.buttonsDisabledState[button.id]=button.isDisabled?.(selection,nodes);this.state.buttonsAvailableState[button.id]=button.isAvailable===undefined||button.isAvailable(selection);}}}
this.updateSelection=null;}}
class MobileToolbarOverlay{constructor(editable){this.isOpen=false;this.overlayId=`mobile_toolbar_${Math.random().toString(16).slice(2)}`;this.editable=editable;}
open({props}){props.class="shadow";if(!this.isOpen){const modal=this.editable.closest(".o_modal_full");if(modal){modal.style.paddingBottom="40px";}
registry.category("main_components").add(this.overlayId,{Component:ToolbarMobile,props,});this.isOpen=true;}}
close(){const modal=this.editable.closest(".o_modal_full");if(modal){modal.style.paddingBottom="";}
registry.category("main_components").remove(this.overlayId,"MobileToolbar");this.isOpen=false;}}
return __exports;});;

/* /html_editor/static/src/main/youtube_plugin.js */
odoo.define('@html_editor/main/youtube_plugin',['@web/core/l10n/translation','@web/core/network/rpc','@html_editor/plugin','@html_editor/main/media/media_dialog/video_selector'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{Plugin}=require("@html_editor/plugin");const{VideoSelector}=require("@html_editor/main/media/media_dialog/video_selector");const YOUTUBE_URL_GET_VIDEO_ID=__exports.YOUTUBE_URL_GET_VIDEO_ID=/^(?:(?:https?:)?\/\/)?(?:(?:www|m)\.)?(?:youtube\.com|youtu\.be)(?:\/(?:[\w-]+\?v=|embed\/|v\/)?)([^\s?&#]+)(?:\S+)?$/i;const YoutubePlugin=__exports.YoutubePlugin=class YoutubePlugin extends Plugin{static id="youtube";static dependencies=["history","powerbox","link","dom"];resources={paste_url_overrides:this.handlePasteUrl.bind(this),};handlePasteUrl(text,url){const youtubeUrl=!this.config.disableVideo&&YOUTUBE_URL_GET_VIDEO_ID.exec(url);if(youtubeUrl){const restoreSavepoint=this.dependencies.history.makeSavePoint();this.dependencies.dom.insert(text);this.dependencies.history.addStep();const embedVideoCommand={title:_t("Embed Youtube Video"),description:_t("Embed the youtube video in the document."),icon:"fa-youtube-play",run:async()=>{const videoElement=await this.getYoutubeVideoElement(youtubeUrl[0]);this.dependencies.dom.insert(videoElement);this.dependencies.history.addStep();},};const commands=[embedVideoCommand,this.dependencies.link.getPathAsUrlCommand(text,url),];this.dependencies.powerbox.openPowerbox({commands,onApplyCommand:restoreSavepoint});return true;}}
async getYoutubeVideoElement(url){const{embed_url:src}=await rpc("/html_editor/video_url/data",{video_url:url,});const[savedVideo]=VideoSelector.createElements([{src}]);savedVideo.classList.add(...VideoSelector.mediaSpecificClasses);return savedVideo;}}
return __exports;});;

/* /html_editor/static/src/others/collaboration/PeerToPeer.js */
odoo.define('@html_editor/others/collaboration/PeerToPeer',[],function(require){'use strict';let __exports={};const urlParams=new URLSearchParams(window.location.search);const collaborationDebug=urlParams.get("collaborationDebug");const COLLABORATION_LOCALSTORAGE_KEY="odoo_editor_collaboration_debug";if(typeof collaborationDebug==="string"){if(collaborationDebug==="false"){localStorage.removeItem(COLLABORATION_LOCALSTORAGE_KEY,urlParams.get("collaborationDebug"));}else{localStorage.setItem(COLLABORATION_LOCALSTORAGE_KEY,urlParams.get("collaborationDebug"));}}
const debugValue=localStorage.getItem(COLLABORATION_LOCALSTORAGE_KEY);const debugShowLog=["","true","all"].includes(debugValue);const debugShowNotifications=debugValue==="all";const baseNotificationMethods={ptp_request:async function(notification){const{requestId,requestName,requestPayload,requestTransport}=notification.notificationPayload;this._onRequest(notification.fromPeerId,requestId,requestName,requestPayload,requestTransport);},ptp_request_result:function(notification){const{requestId,result}=notification.notificationPayload;if(this._pendingRequestResolver[requestId]){clearTimeout(this._pendingRequestResolver[requestId].rejectTimeout);this._pendingRequestResolver[requestId].resolve(result);delete this._pendingRequestResolver[requestId];}},ptp_join:async function(notification){const peerId=notification.fromPeerId;if(this.peersInfos[peerId]&&this.peersInfos[peerId].peerConnection){return this.peersInfos[peerId];}
this._createPeer(peerId);},rtc_signal_icecandidate:async function(notification){if(debugShowLog){console.log(`%creceive candidate`,"background: darkgreen; color: white;");}
const peerInfos=this.peersInfos[notification.fromPeerId];if(!peerInfos||!peerInfos.peerConnection||peerInfos.peerConnection.connectionState==="closed"){console.groupCollapsed("=== ERROR: Handle Ice Candidate from undefined|closed ===");console.trace(peerInfos);console.groupEnd();return;}
if(!peerInfos.peerConnection.remoteDescription){peerInfos.iceCandidateBuffer.push(notification.notificationPayload);}else{this._addIceCandidate(peerInfos,notification.notificationPayload);}},rtc_signal_description:async function(notification){const description=notification.notificationPayload;if(debugShowLog){console.log(`%cdescription received:`,"background: blueviolet; color: white;",description);}
const peerInfos=this.peersInfos[notification.fromPeerId]||this._createPeer(notification.fromPeerId);const pc=peerInfos.peerConnection;if(!pc||pc.connectionState==="closed"){if(debugShowLog){console.groupCollapsed("=== ERROR: handle offer ===");console.log("An offer has been received for a non-existent peer connection - peer: "+
notification.fromPeerId);console.trace(pc&&pc.connectionState);console.groupEnd();}
return;}
if(pc.signalingState==="have-remote-offer"){return;}
const isPolite=(""+notification.fromPeerId).localeCompare(""+this._currentPeerId)===1;if(debugShowLog){console.log(`%cisPolite: %c${isPolite}`,"background: deepskyblue;",`background:${isPolite ? "green" : "red"}`);}
const isOfferRacing=description.type==="offer"&&(peerInfos.makingOffer||pc.signalingState!=="stable");if(isOfferRacing&&!isPolite){if(debugShowLog){console.log(`%creturn because isOfferRacing && !isPolite. pc.signalingState: ${pc.signalingState}`,"background: red;");}
return;}
if(debugShowLog){console.log(`%cisOfferRacing: ${isOfferRacing}`,"background: red;");console.log(`%c SETREMOTEDESCRIPTION`,"background: navy; color:white;");}
try{await pc.setRemoteDescription(description);}catch(e){if(e instanceof DOMException&&e.name==="InvalidStateError"){console.error(e);return;}else{throw e;}}
if(peerInfos.iceCandidateBuffer.length){for(const candidate of peerInfos.iceCandidateBuffer){await this._addIceCandidate(peerInfos,candidate);}
peerInfos.iceCandidateBuffer.splice(0);}
if(description.type==="offer"){const answerDescription=await pc.createAnswer();try{await pc.setLocalDescription(answerDescription);}catch(e){if(e instanceof DOMException&&e.name==="InvalidStateError"){console.error(e);return;}else{throw e;}}
this.notifyPeer(notification.fromPeerId,"rtc_signal_description",pc.localDescription);}},};const PeerToPeer=__exports.PeerToPeer=class PeerToPeer{constructor(options){this.options=options;this._currentPeerId=this.options.currentPeerId;if(debugShowLog){console.log(`%c currentPeerId:${this._currentPeerId}`,"background: blue; color: white;");}
this.peersInfos={};this._lastRequestId=-1;this._pendingRequestResolver={};this._stopped=false;}
stop(){this.closeAllConnections();this._stopped=true;}
getConnectedPeerIds(){return Object.entries(this.peersInfos).filter(([id,infos])=>infos.peerConnection&&infos.peerConnection.iceConnectionState==="connected"&&infos.dataChannel&&infos.dataChannel.readyState==="open").map(([id])=>id);}
removePeer(peerId){if(debugShowLog){console.log(`%c REMOVE PEER ${peerId}`,"background: chocolate;");}
this.notifySelf("ptp_remove",peerId);const peerInfos=this.peersInfos[peerId];if(!peerInfos){return;}
clearTimeout(peerInfos.fallbackTimeout);clearTimeout(peerInfos.zombieTimeout);peerInfos.dataChannel&&peerInfos.dataChannel.close();peerInfos.peerConnection&&peerInfos.peerConnection.close();delete this.peersInfos[peerId];}
closeAllConnections(){for(const peerId of Object.keys(this.peersInfos)){this.notifyAllPeers("ptp_disconnect");this.removePeer(peerId);}}
async notifyAllPeers(notificationName,notificationPayload,{transport="server"}={}){if(this._stopped){return;}
const transportPayload={fromPeerId:this._currentPeerId,notificationName,notificationPayload,};if(transport==="server"){await this.options.broadcastAll(transportPayload);}else if(transport==="rtc"){for(const cliendId of Object.keys(this.peersInfos)){this._channelNotify(cliendId,transportPayload);}}else{throw new Error(`Transport "${transport}" is not supported. Use "server" or "rtc" transport.`);}}
notifyPeer(peerId,notificationName,notificationPayload,{transport="server"}={}){if(this._stopped){return;}
if(debugShowNotifications){if(notificationName==="ptp_request_result"){console.log(`%c${Date.now()} - REQUEST RESULT SEND: %c${transport}:${
                        notificationPayload.requestId
                    }:${this._currentPeerId.slice("-5")}:${peerId.slice("-5")}`,"color: #aaa;font-weight:bold;","color: #aaa;font-weight:normal");}else if(notificationName==="ptp_request"){console.log(`%c${Date.now()} - REQUEST SEND: %c${transport}:${
                        notificationPayload.requestName
                    }|${notificationPayload.requestId}:${this._currentPeerId.slice(
                        "-5"
                    )}:${peerId.slice("-5")}`,"color: #aaa;font-weight:bold;","color: #aaa;font-weight:normal");}else{console.log(`%c${Date.now()} - NOTIFICATION SEND: %c${transport}:${notificationName}:${this._currentPeerId.slice(
                        "-5"
                    )}:${peerId.slice("-5")}`,"color: #aaa;font-weight:bold;","color: #aaa;font-weight:normal");}}
const transportPayload={fromPeerId:this._currentPeerId,toPeerId:peerId,notificationName,notificationPayload,};if(transport==="server"){this.options.broadcastAll(transportPayload);}else if(transport==="rtc"){this._channelNotify(peerId,transportPayload);}else{throw new Error(`Transport "${transport}" is not supported. Use "server" or "rtc" transport.`);}}
notifySelf(notificationName,notificationPayload){if(this._stopped){return;}
return this.handleNotification({notificationName,notificationPayload});}
handleNotification(notification){if(this._stopped){return;}
const isInternalNotification=typeof notification.fromPeerId==="undefined"&&typeof notification.toPeerId==="undefined";if(isInternalNotification||(notification.fromPeerId!==this._currentPeerId&&!notification.toPeerId)||notification.toPeerId===this._currentPeerId){if(debugShowNotifications){if(notification.notificationName==="ptp_request_result"){console.log(`%c${Date.now()} - REQUEST RESULT RECEIVE: %c${
                            notification.notificationPayload.requestId
                        }:${notification.fromPeerId.slice("-5")}:${notification.toPeerId.slice(
                            "-5"
                        )}`,"color: #aaa;font-weight:bold;","color: #aaa;font-weight:normal");}else if(notification.notificationName==="ptp_request"){console.log(`%c${Date.now()} - REQUEST RECEIVE: %c${
                            notification.notificationPayload.requestName
                        }|${
                            notification.notificationPayload.requestId
                        }:${notification.fromPeerId.slice("-5")}:${notification.toPeerId.slice(
                            "-5"
                        )}`,"color: #aaa;font-weight:bold;","color: #aaa;font-weight:normal");}else{console.log(`%c${Date.now()} - NOTIFICATION RECEIVE: %c${
                            notification.notificationName
                        }:${notification.fromPeerId}:${notification.toPeerId}`,"color: #aaa;font-weight:bold;","color: #aaa;font-weight:normal");}}
try{const baseMethod=baseNotificationMethods[notification.notificationName];if(baseMethod){return baseMethod.call(this,notification);}
if(this.options.onNotification){return this.options.onNotification(notification);}}catch(error){console.groupCollapsed("=== ERROR: On notification in collaboration ===");console.error(error);console.groupEnd();}}}
requestPeer(peerId,requestName,requestPayload,{transport="server"}={}){if(this._stopped){return;}
return new Promise((resolve,reject)=>{const requestId=this._getRequestId();const abort=(reason)=>{clearTimeout(rejectTimeout);delete this._pendingRequestResolver[requestId];reject(new RequestError(reason||"Request was aborted."));};const rejectTimeout=setTimeout(()=>abort("Request took too long (more than 10 seconds)."),10000);this._pendingRequestResolver[requestId]={resolve,rejectTimeout,abort,};this.notifyPeer(peerId,"ptp_request",{requestId,requestName,requestPayload,requestTransport:transport,},{transport});});}
abortCurrentRequests(){for(const{abort}of Object.values(this._pendingRequestResolver)){abort();}}
_createPeer(peerId,{makeOffer=true}={}){if(this._stopped){return;}
if(debugShowLog){console.log("CREATE CONNECTION with peer id:",peerId);}
this.peersInfos[peerId]={makingOffer:false,iceCandidateBuffer:[],backoffFactor:0,};if(!navigator.onLine){return this.peersInfos[peerId];}
const pc=new RTCPeerConnection(this.options.peerConnectionConfig);if(makeOffer){pc.onnegotiationneeded=async()=>{if(debugShowLog){console.log(`%c NEGONATION NEEDED: ${pc.connectionState}`,"background: deeppink;");}
try{this.peersInfos[peerId].makingOffer=true;if(debugShowLog){console.log(`%ccreating and sending an offer`,"background: darkmagenta; color: white;");}
const offer=await pc.createOffer();if(pc.signalingState!=="stable"){return;}
await pc.setLocalDescription(offer);this.notifyPeer(peerId,"rtc_signal_description",pc.localDescription);}catch(err){console.error(err);}finally{this.peersInfos[peerId].makingOffer=false;}};}
pc.onicecandidate=async(event)=>{if(event.candidate){this.notifyPeer(peerId,"rtc_signal_icecandidate",event.candidate);}};pc.oniceconnectionstatechange=async()=>{if(debugShowLog){console.log("ICE STATE UPDATE: "+pc.iceConnectionState);}
switch(pc.iceConnectionState){case"failed":case"closed":this.removePeer(peerId);break;case"disconnected":if(navigator.onLine){await this._recoverConnection(peerId,{delay:3000,reason:"ice connection disconnected",});}
break;case"connected":this.peersInfos[peerId].backoffFactor=0;break;}};pc.onconnectionstatechange=async()=>{if(debugShowLog){console.log("CONNECTION STATE UPDATE:"+pc.connectionState);}
switch(pc.connectionState){case"failed":case"closed":this.removePeer(peerId);break;case"disconnected":if(navigator.onLine){await this._recoverConnection(peerId,{delay:3000,reason:"connection disconnected",});}
break;case"connected":case"completed":this.peersInfos[peerId].backoffFactor=0;break;}};pc.onicecandidateerror=async(error)=>{if(debugShowLog){console.groupCollapsed("=== ERROR: onIceCandidate ===");console.log("connectionState: "+
pc.connectionState+" - iceState: "+
pc.iceConnectionState);console.trace(error);console.groupEnd();}
this._recoverConnection(peerId,{delay:3000,reason:"ice candidate error"});};const dataChannel=pc.createDataChannel("notifications",{negotiated:true,id:1});let message=[];dataChannel.onmessage=(event)=>{if(event.data!=="-"){message.push(event.data);}else{this.handleNotification(JSON.parse(message.join("")));message=[];}};dataChannel.onopen=(event)=>{this.notifySelf("rtc_data_channel_open",{connectionPeerId:peerId,});};this.peersInfos[peerId].peerConnection=pc;this.peersInfos[peerId].dataChannel=dataChannel;return this.peersInfos[peerId];}
async _addIceCandidate(peerInfos,candidate){const rtcIceCandidate=new RTCIceCandidate(candidate);try{await peerInfos.peerConnection.addIceCandidate(rtcIceCandidate);}catch(error){console.groupCollapsed("=== ERROR: ADD ICE CANDIDATE ===");console.trace(error);console.groupEnd();}}
_channelNotify(peerId,transportPayload){if(this._stopped){return;}
const peerInfo=this.peersInfos[peerId];const dataChannel=peerInfo&&peerInfo.dataChannel;if(!dataChannel||dataChannel.readyState!=="open"){if(peerInfo&&!peerInfo.zombieTimeout){if(debugShowLog){console.warn(`Impossible to communicate with peer ${peerId}. The connection will be killed in 10 seconds if the datachannel state has not changed.`);}
this._killPotentialZombie(peerId);}}else{const str=JSON.stringify(transportPayload);const size=str.length;const maxStringLength=5000;let from=0;let to=maxStringLength;while(from<size){dataChannel.send(str.slice(from,to));from=to;to=to+=maxStringLength;}
dataChannel.send("-");}}
_getRequestId(){this._lastRequestId++;return this._lastRequestId;}
async _onRequest(fromPeerId,requestId,requestName,requestPayload,requestTransport){if(this._stopped){return;}
const requestFunction=this.options.onRequest&&this.options.onRequest[requestName];const result=await requestFunction({fromPeerId,requestId,requestName,requestPayload,});this.notifyPeer(fromPeerId,"ptp_request_result",{requestId,result},{transport:requestTransport});}
_recoverConnection(peerId,{delay=0,reason=""}={}){if(this._stopped){this.removePeer(peerId);return;}
const peerInfos=this.peersInfos[peerId];if(!peerInfos||peerInfos.fallbackTimeout){return;}
const backoffFactor=this.peersInfos[peerId].backoffFactor;const backoffDelay=delay*Math.pow(2,backoffFactor);if(backoffFactor>10){if(debugShowLog){console.log(`%c STOP RTC RECOVERY: impossible to connect to peer ${peerId}: ${reason}`,"background: darkred; color: white;");}
return;}
peerInfos.fallbackTimeout=setTimeout(async()=>{peerInfos.fallbackTimeout=undefined;const pc=peerInfos.peerConnection;if(!pc||pc.iceConnectionState==="connected"){return;}
if(["connected","closed"].includes(pc.connectionState)){return;}
if(debugShowLog){console.log(`%c RTC RECOVERY: calling back peer ${peerId} to salvage the connection ${pc.iceConnectionState} after ${backoffDelay}ms, reason: ${reason}`,"background: darkorange; color: white;");}
this.removePeer(peerId);const newPeerInfos=this._createPeer(peerId);newPeerInfos.backoffFactor=backoffFactor+1;},backoffDelay);}
_killPotentialZombie(peerId){if(this._stopped){this.removePeer(peerId);return;}
const peerInfos=this.peersInfos[peerId];if(!peerInfos||peerInfos.zombieTimeout){return;}
peerInfos.zombieTimeout=setTimeout(()=>{if(peerInfos&&peerInfos.dataChannel&&peerInfos.dataChannel.readyState!=="open"){if(debugShowLog){console.log(`%c KILL ZOMBIE ${peerId}`,"background: red;");}
this.removePeer(peerId);}else{if(debugShowLog){console.log(`%c NOT A ZOMBIE ${peerId}`,"background: green;");}}},10000);}}
const RequestError=__exports.RequestError=class RequestError extends Error{constructor(message){super(message);this.name="RequestError";}}
return __exports;});;

/* /html_editor/static/src/others/collaboration/collaboration_odoo_plugin.js */
odoo.define('@html_editor/others/collaboration/collaboration_odoo_plugin',['@html_editor/plugin','@web/core/network/rpc','@web/core/user','@web/core/utils/concurrency','@web/core/utils/timing','@html_editor/others/collaboration/PeerToPeer','@html_editor/utils/dom_traversal','@html_editor/utils/position'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{rpc}=require("@web/core/network/rpc");const{user}=require("@web/core/user");const{Mutex}=require("@web/core/utils/concurrency");const{debounce}=require("@web/core/utils/timing");const{PeerToPeer,RequestError}=require("@html_editor/others/collaboration/PeerToPeer");const{ancestors}=require("@html_editor/utils/dom_traversal");const{childNodeIndex}=require("@html_editor/utils/position");const PTP_MAX_RECOVERY_TIME=500;const REQUEST_ERROR=Symbol("REQUEST_ERROR");let ICE_SERVERS=null;const CollaborationOdooPlugin=__exports.CollaborationOdooPlugin=class CollaborationOdooPlugin extends Plugin{static id="collaborationOdoo";static dependencies=["baseContainer","history","collaboration","selection"];static shared=["getPeerMetadata"];resources={selectionchange_handlers:debounce(()=>{this.ptp?.notifyAllPeers("oe_history_set_selection",this.getCurrentCollaborativeSelection(),{transport:"rtc",});},50),clean_for_save_handlers:({root})=>this.attachHistoryIds(root),history_missing_parent_step_handlers:this.onHistoryMissingParentStep.bind(this),history_reset_handlers:this.onReset.bind(this),step_added_handlers:({step})=>this.ptp?.notifyAllPeers("oe_history_step",step,{transport:"rtc"}),};setup(){this.isDocumentStale=false;this.ptpJoined=false;this.lastCollaborationResetId=0;this.serverLastStepId=this.config.content&&this.getLastHistoryStepId(this.config.content);this.setupCollaboration(this.config.collaboration.collaborationChannel);const collaborativeTrigger=this.config.collaboration.collaborativeTrigger;this.joinPeerToPeer=this.joinPeerToPeer.bind(this);if(collaborativeTrigger==="start"){this.joinPeerToPeer();}else if(collaborativeTrigger==="focus"||typeof collaborativeTrigger==="undefined"){this.editable.addEventListener("focus",this.joinPeerToPeer);}
stripHistoryIds(this.editable);}
destroy(){this.collaborationStopBus&&this.collaborationStopBus();if(this.peerToPeerLoading){this.peerToPeerLoading.then(()=>{this.stopPeerToPeer();});}
super.destroy();}
stopPeerToPeer(){this.joiningPtp=false;this.ptpJoined=false;this.resetCollabRequests();this.ptp&&this.ptp.stop();}
getCurrentCollaborativeSelection(){const selection=this.dependencies.selection.getEditableSelection();return{selection:this.dependencies.history.serializeSelection(selection),peerId:this.config.collaboration.peerId,};}
setupCollaboration(collaborationChannel){const modelName=collaborationChannel.collaborationModelName;const fieldName=collaborationChannel.collaborationFieldName;const resId=collaborationChannel.collaborationResId;const channelName=`editor_collaboration:${modelName}:${fieldName}:${resId}`;if(!(modelName&&fieldName&&resId)){return;}
this.collaborationChannelName=channelName;this.historyStepsBuffer=[];const collaborationBusListener=(payload)=>{if(payload.model_name===modelName&&payload.field_name===fieldName&&payload.res_id===resId){if(payload.notificationName==="html_field_write"){this.onServerLastIdUpdate(payload.notificationPayload.last_step_id);}else if(this.ptpJoined){this.peerToPeerLoading.then(()=>this.ptp.handleNotification(payload));}}};const{busService}=this.config.collaboration;busService.subscribe("editor_collaboration",collaborationBusListener);busService.addChannel(this.collaborationChannelName);this.collaborationStopBus=()=>{busService.unsubscribe("editor_collaboration",collaborationBusListener);busService.deleteChannel(this.collaborationChannelName);};this.startCollaborationTime=new Date().getTime();const loadPeerToPeer=async()=>{if(!ICE_SERVERS){ICE_SERVERS=await rpc("/html_editor/get_ice_servers");}
let iceServers=ICE_SERVERS;if(!iceServers.length){iceServers=[{urls:["stun:stun1.l.google.com:19302","stun:stun2.l.google.com:19302"],},];}
this.iceServers=iceServers;this.ptp=this.getNewPtp();};this.peerToPeerLoading=loadPeerToPeer();}
getNewPtp(){const rpcMutex=new Mutex();const{collaborationChannel}=this.config.collaboration;const modelName=collaborationChannel.collaborationModelName;const fieldName=collaborationChannel.collaborationFieldName;const resId=collaborationChannel.collaborationResId;this.historySyncAtLeastOnce=false;return new PeerToPeer({peerConnectionConfig:{iceServers:this.iceServers},currentPeerId:this.config.collaboration.peerId,broadcastAll:(rpcData)=>{return rpcMutex.exec(async()=>{return rpc("/html_editor/bus_broadcast",{model_name:modelName,field_name:fieldName,res_id:resId,bus_data:rpcData,});});},onRequest:{get_peer_metadata:this.getMetadata.bind(this),get_missing_steps:(params)=>this.dependencies.collaboration.historyGetMissingSteps(params.requestPayload),get_history_from_snapshot:()=>this.getHistorySnapshot(),get_collaborative_selection:()=>this.getCurrentCollaborativeSelection(),recover_document:(params)=>{const{serverDocumentId,fromStepId}=params.requestPayload;if(!this.dependencies.collaboration.getBranchIds().includes(serverDocumentId)){return;}
return{missingSteps:this.dependencies.collaboration.historyGetMissingSteps({fromStepId,}),snapshot:this.getHistorySnapshot(),};},},onNotification:async(notification)=>{this.dispatchTo("collaboration_notification_handlers",notification);let{fromPeerId,notificationName,notificationPayload}=notification;switch(notificationName){case"ptp_remove":break;case"ptp_disconnect":this.ptp.removePeer(fromPeerId);break;case"rtc_data_channel_open":{fromPeerId=notificationPayload.connectionPeerId;const metadata=await this.requestPeer(fromPeerId,"get_peer_metadata",undefined,{transport:"rtc"});if(metadata===REQUEST_ERROR){return;}
this.ptp.peersInfos[fromPeerId].metadata=metadata;if(!this.historySyncAtLeastOnce){const localPeer={id:this.config.collaboration.peerId,startTime:this.startCollaborationTime,};const remotePeer={id:fromPeerId,startTime:metadata.startTime,};if(isPeerFirst(localPeer,remotePeer)){this.historySyncAtLeastOnce=true;this.historySyncFinished=true;}else{this.resetCollabRequests();const response=await this.resetFromPeer(fromPeerId,this.lastCollaborationResetId);if(response===REQUEST_ERROR){return;}}}else{this.ptp.notifyAllPeers("oe_history_step",this.dependencies.history.getHistorySteps().at(-1),{transport:"rtc"});this.resetCollaborativeSelection(fromPeerId);}
break;}
case"oe_history_step":if(this.historySyncFinished){this.dependencies.collaboration.onExternalHistorySteps([notificationPayload,]);}else{this.historyStepsBuffer.push(notificationPayload);}
break;case"oe_history_set_selection":{const peer=this.ptp.peersInfos[fromPeerId];if(!peer){return;}
const selection=notificationPayload;this.onExternalMultiselectionUpdate(selection);break;}}},});}
getPeerMetadata(peerId){return this.ptp.peersInfos[peerId]?.metadata;}
onExternalMultiselectionUpdate(selection){this.dispatchTo("collaborative_selection_update_handlers",selection);}
async requestPeer(peerId,requestName,requestPayload,params){return this.ptp.requestPeer(peerId,requestName,requestPayload,params).catch((e)=>{if(e instanceof RequestError){return REQUEST_ERROR;}else{throw e;}});}
getMetadata(){const metadatas={startTime:this.startCollaborationTime,peerName:user.name,};for(const cb of this.getResource("collaboration_peer_metadata_providers")){Object.assign(metadatas,cb());}
return metadatas;}
onServerLastIdUpdate(last_step_id){this.serverLastStepId=last_step_id;this.isDocumentStale=this.isLastDocumentStale();if(this.isDocumentStale&&this.ptpJoined){return this.recoverFromStaleDocument();}else if(this.isDocumentStale&&this.joiningPtp){this.resetCollabRequests();this.joinPeerToPeer();}}
joinPeerToPeer(){this.editable.removeEventListener("focus",this.joinPeerToPeer);if(this.peerToPeerLoading){return this.peerToPeerLoading.then(async()=>{this.joiningPtp=true;if(this.isDocumentStale){const success=await this.resetFromServerAndResyncWithPeers();if(!success){return;}}
this.ptp.notifyAllPeers("ptp_join");this.joiningPtp=false;this.ptpJoined=true;});}}
isLastDocumentStale(){if(!this.serverLastStepId){return false;}
return!this.dependencies.collaboration.getBranchIds().includes(this.serverLastStepId);}
async recoverFromStaleDocument(){return new Promise((resolve)=>{const resetCollabCount=this.lastCollaborationResetId;const allPeers=this.getPtpPeers().map((peer)=>peer.id);if(allPeers.length===0){if(this.isDocumentStale){this.showConflictDialog();resolve();return this.resetFromServerAndResyncWithPeers();}}
let hasRetrievalBudgetTimeout=false;const snapshots=[];let nbPendingResponses=allPeers.length;const success=()=>{resolve();clearTimeout(timeout);};for(const peerId of allPeers){this.requestPeer(peerId,"recover_document",{serverDocumentId:this.serverLastStepId,fromStepId:this.dependencies.collaboration.getBranchIds().at(-1),},{transport:"rtc"}).then((response)=>{nbPendingResponses--;if(response===REQUEST_ERROR||resetCollabCount!==this.lastCollaborationResetId||hasRetrievalBudgetTimeout||!response||!this.isDocumentStale){if(nbPendingResponses<=0){processSnapshots();}
return;}
this.processMissingSteps(response.missingSteps);this.isDocumentStale=this.isLastDocumentStale();snapshots.push(response.snapshot);if(nbPendingResponses<1){processSnapshots();}});}
const processSnapshots=async()=>{this.isDocumentStale=this.isLastDocumentStale();if(!this.isDocumentStale){return success();}
if(snapshots[0]){this.showConflictDialog();}
for(const snapshot of snapshots){this.applySnapshot(snapshot);this.isDocumentStale=this.isLastDocumentStale();if(!this.isDocumentStale){return success();}}
if(this.isDocumentStale){this.showConflictDialog();await this.resetFromServerAndResyncWithPeers();}
success();};const timeout=setTimeout(()=>{if(resetCollabCount!==this.lastCollaborationResetId){return;}
hasRetrievalBudgetTimeout=true;this.onRecoveryPeerTimeout(processSnapshots);},PTP_MAX_RECOVERY_TIME);});}
getPtpPeers(){const peers=Object.entries(this.ptp.peersInfos).map(([peerId,peerInfo])=>({id:peerId,...peerInfo,}));return peers.sort((a,b)=>(isPeerFirst(a,b)?-1:1));}
getLastHistoryStepId(value){const matchId=value.match(/data-last-history-steps="[0-9,]*?([0-9]+)"/);return matchId&&matchId[1];}
resetCollabRequests(){this.lastCollaborationResetId++;this.ptp&&this.ptp.abortCurrentRequests();}
async resetFromServerAndResyncWithPeers(){let collaborationResetId=this.lastCollaborationResetId;const record=await this.getCurrentRecord();if(collaborationResetId!==this.lastCollaborationResetId){return;}
const content=record[this.config.collaboration.collaborationChannel.collaborationFieldName];const lastHistoryId=content&&this.getLastHistoryStepId(content);if(this.serverLastStepId!==lastHistoryId){throw new Error("Concurency detected while recovering from a stale document. The last history id of the server is different from the history id received by the html_field_write event.");}
this.isDocumentStale=false;if(content){this.editable.innerHTML=content;}else{this.editable.replaceChildren(this.dependencies.baseContainer.createBaseContainer());}
stripHistoryIds(this.editable);this.dispatchTo("normalize_handlers",this.editable);this.dependencies.history.reset(content);this.historySyncAtLeastOnce=false;this.resetCollabRequests();collaborationResetId=this.lastCollaborationResetId;this.startCollaborationTime=new Date().getTime();await Promise.all(this.getPtpPeers().map((peer)=>{return this.resetFromPeer(peer.id,collaborationResetId);}));return true;}
onReset(content){this.historyShareId=Math.floor(Math.random()*Math.pow(2,52)).toString();const lastStepId=content&&this.getLastHistoryStepId(content);if(lastStepId){this.dependencies.collaboration.setInitialBranchStepId(lastStepId);}}
async processMissingSteps(missingSteps){if(missingSteps===-1||!missingSteps.length){return false;}
this.dependencies.collaboration.onExternalHistorySteps(missingSteps);return true;}
applySnapshot(snapshot){const{steps,historyIds,historyShareId}=snapshot;const isStaleDocument=this.serverLastStepId&&!historyIds.includes(this.serverLastStepId);if(isStaleDocument){return;}
this.historyShareId=historyShareId;this.historySyncAtLeastOnce=true;this.dependencies.collaboration.resetFromSteps(steps,historyIds);return true;}
async onRecoveryPeerTimeout(processSnapshots){processSnapshots();}
showConflictDialog(){}
getHistorySnapshot(){return Object.assign({},this.dependencies.collaboration.getSnapshotSteps(),{historyShareId:this.historyShareId,});}
async resetFromPeer(fromPeerId,resetCollabCount){this.historySyncFinished=false;this.historyStepsBuffer=[];const snapshot=await this.requestPeer(fromPeerId,"get_history_from_snapshot",undefined,{transport:"rtc"});if(snapshot===REQUEST_ERROR){return REQUEST_ERROR;}
if(resetCollabCount!==this.lastCollaborationResetId){return;}
if(this.historySyncAtLeastOnce){return;}
const selection=this.dependencies.selection.getEditableSelection();let anchorNodeIndexPath=this._getNodeIndexPath(selection.anchorNode);let anchorOffset=selection.anchorOffset;if(selection.anchorNode===this.editable){anchorNodeIndexPath=this._getNodeIndexPath(this.editable.firstChild);anchorOffset=0;}
const applied=this.applySnapshot(snapshot);if(!applied){return;}
const anchorNode=this._getNodeFromIndexPath(anchorNodeIndexPath);if(this.dependencies.selection.isSelectionInEditable({anchorNode,focusNode:anchorNode})){this.dependencies.selection.setSelection({anchorNode,anchorOffset,});}
this.historySyncFinished=true;if(this.historyStepsBuffer.length){this.dependencies.collaboration.onExternalHistorySteps(this.historyStepsBuffer);this.historyStepsBuffer=[];}
this.editable.dispatchEvent(new CustomEvent("onHistoryResetFromPeer"));this.resetCollaborativeSelection(fromPeerId);}
async resetCollaborativeSelection(fromPeerId){const remoteSelection=await this.requestPeer(fromPeerId,"get_collaborative_selection",undefined,{transport:"rtc"});if(remoteSelection===REQUEST_ERROR){return;}
if(remoteSelection){this.onExternalMultiselectionUpdate(remoteSelection);}}
async onHistoryMissingParentStep({step,fromStepId}){if(!this.ptp){return;}
const missingSteps=await this.requestPeer(step.peerId,"get_missing_steps",{fromStepId:fromStepId,toStepId:step.id,},{transport:"rtc"});if(missingSteps===REQUEST_ERROR){return;}
this.processMissingSteps(Array.isArray(missingSteps)?missingSteps.concat(step):missingSteps);}
async getCurrentRecord(){const[record]=await this.config.collaboration.ormService.read(this.config.collaboration.collaborationChannel.collaborationModelName,[this.config.collaboration.collaborationChannel.collaborationResId],[this.config.collaboration.collaborationChannel.collaborationFieldName]);return record;}
attachHistoryIds(editable){const historyIds=this.dependencies.collaboration.getBranchIds().join(",");const firstChild=editable.children[0];if(firstChild){firstChild.setAttribute("data-last-history-steps",historyIds);}}
_getNodeIndexPath(node){return[node,...ancestors(node,this.editable)].map((ancestor)=>childNodeIndex(ancestor));}
_getNodeFromIndexPath(indexPath){return indexPath.reduceRight((node,index)=>node?.childNodes?.[index],this.editable.parentElement);}}
function isPeerFirst(peerA,peerB){if(peerA.startTime===peerB.startTime){return peerA.id.localeCompare(peerB.id)===-1;}
if(peerA.startTime===undefined||peerB.startTime===undefined){return Boolean(peerA.startTime);}else{return peerA.startTime<peerB.startTime;}}
__exports.stripHistoryIds=stripHistoryIds;function stripHistoryIds(element){element.querySelectorAll("[data-last-history-steps]").forEach((el)=>el.removeAttribute("data-last-history-steps"));}
return __exports;});;

/* /html_editor/static/src/others/collaboration/collaboration_plugin.js */
odoo.define('@html_editor/others/collaboration/collaboration_plugin',['@html_editor/plugin'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const HISTORY_SNAPSHOT_INTERVAL=__exports.HISTORY_SNAPSHOT_INTERVAL=1000*60;const HISTORY_SNAPSHOT_BUFFER_TIME=1000*10;const CollaborationPlugin=__exports.CollaborationPlugin=class CollaborationPlugin extends Plugin{static id="collaboration";static dependencies=["history","selection","sanitize"];resources={history_cleaned_handlers:this.onHistoryClean.bind(this),history_reset_handlers:this.onHistoryReset.bind(this),step_added_handlers:({step})=>this.onStepAdded(step),set_attribute_overrides:this.setAttribute.bind(this),history_step_processors:this.processHistoryStep.bind(this),unreversible_step_predicates:this.isUnreversibleStep.bind(this),};static shared=["getBranchIds","getSnapshotSteps","historyGetMissingSteps","onExternalHistorySteps","resetFromSteps","setInitialBranchStepId",];peerId=null;setup(){this.peerId=this.config.collaboration.peerId;if(!this.peerId){throw new Error("The collaboration plugin requires a peerId");}
this._snapshotInterval=setInterval(()=>{this.makeSnapshot();},HISTORY_SNAPSHOT_INTERVAL);}
destroy(){super.destroy();clearInterval(this._snapshotInterval);this._snapshotInterval=false;}
onHistoryClean(){this.branchStepIds=[];}
onHistoryReset(){const firstStep=this.dependencies.history.getHistorySteps()[0];this.snapshots=[{step:firstStep}];}
isUnreversibleStep(step){return step.peerId!==this.peerId;}
setAttribute(node,attributeName,attributeValue){if(attributeValue){this.safeSetAttribute(node,attributeName,attributeValue);return true;}}
getBranchIds(){const steps=this.dependencies.history.getHistorySteps();return[this.initialBranchStepId].concat(this.branchStepIds).concat(steps.map((s)=>s.id));}
safeSetAttribute(node,attributeName,attributeValue){const clone=this.document.createElement(node.tagName);clone.setAttribute(attributeName,attributeValue);this.dependencies.sanitize.sanitize(clone);if(clone.hasAttribute(attributeName)){node.setAttribute(attributeName,clone.getAttribute(attributeName));}else{node.removeAttribute(attributeName);}}
onExternalHistorySteps(newSteps){this.dependencies.history.disableObserver();const selectionData=this.dependencies.selection.getSelectionData();let stepIndex=0;const steps=this.dependencies.history.getHistorySteps();for(const newStep of newSteps){const insertIndex=this.getInsertStepIndex(steps,newStep);if(typeof insertIndex==="undefined"){continue;}
this.dependencies.history.addExternalStep(newStep,insertIndex);stepIndex++;}
this.dependencies.history.enableObserver();if(selectionData.documentSelectionIsInEditable){this.dependencies.selection.rectifySelection(selectionData.editableSelection);}
this.dispatchTo("external_history_step_handlers");if(stepIndex){this.config.onChange?.();}}
getInsertStepIndex(steps,newStep){let index=steps.length-1;while(index>=0&&steps[index].id!==newStep.previousStepId){if(steps[index].id===newStep.id){return;}
index--;}
if(index<0){const historySteps=steps;let index=historySteps.length-1;while(index!==0){if(historySteps[index].peerId===newStep.peerId){break;}
index--;}
const fromStepId=historySteps[index].id;this.dispatchTo("history_missing_parent_step_handlers",{step:newStep,fromStepId:fromStepId,});return;}
let concurentSteps=[];index++;while(index<steps.length){if(steps[index].previousStepId===newStep.previousStepId){if(steps[index].id.localeCompare(newStep.id)===1){break;}else{concurentSteps=[steps[index].id];}}else{if(concurentSteps.includes(steps[index].previousStepId)){concurentSteps.push(steps[index].id);}else{break;}}
index++;}
return index;}
historyGetMissingSteps({fromStepId,toStepId}){const steps=this.dependencies.history.getHistorySteps();const fromIndex=steps.findIndex((x)=>x.id===fromStepId);const toIndex=toStepId?steps.findIndex((x)=>x.id===toStepId):steps.length;if(fromIndex===-1||toIndex===-1){return-1;}
return steps.slice(fromIndex+1,toIndex);}
getSnapshotSteps(){const historySteps=this.dependencies.history.getHistorySteps();if(!this.snapshots[0].time){return{steps:historySteps,historyIds:this.getBranchIds()};}
const snapshotSteps=[];let snapshot;if(this.snapshots[0].time+HISTORY_SNAPSHOT_BUFFER_TIME<Date.now()){snapshot=this.snapshots[0];}else{snapshot=this.snapshots[1];}
let index=historySteps.length-1;while(historySteps[index].id!==snapshot.step.id){snapshotSteps.push(historySteps[index]);index--;}
snapshotSteps.push(snapshot.step);snapshotSteps.reverse();return{steps:snapshotSteps,historyIds:this.getBranchIds()};}
setInitialBranchStepId(stepId){this.initialBranchStepId=stepId;}
resetFromSteps(steps,branchStepIds){this.dependencies.selection.resetSelection();this.dependencies.history.resetFromSteps(steps);this.snapshots=[{step:steps[0]}];this.branchStepIds=branchStepIds;this.dependencies.history.enableObserver();}
makeSnapshot(){const historyLength=this.dependencies.history.getHistorySteps().length;if(!this.lastSnapshotLength||this.lastSnapshotLength<historyLength){this.lastSnapshotLength=historyLength;const step=this.dependencies.history.makeSnapshotStep();const snapshot={time:Date.now(),step:step,};this.snapshots=[snapshot,this.snapshots[0]];}}
onStepAdded(step){step.peerId=this.peerId;this.dispatchTo("collaboration_step_added_handlers",step);}
processHistoryStep(step){step.peerId=this.peerId;return step;}}
return __exports;});;

/* /html_editor/static/src/others/collaboration/collaboration_selection_avatar_plugin.js */
odoo.define('@html_editor/others/collaboration/collaboration_selection_avatar_plugin',['@html_editor/plugin','@html_editor/utils/blocks','@html_editor/utils/dom_traversal','@web/core/browser/browser','@web/core/l10n/translation','@web/core/user'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{closestBlock}=require("@html_editor/utils/blocks");const{closestElement}=require("@html_editor/utils/dom_traversal");const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const AVATAR_SIZE=__exports.AVATAR_SIZE=25;const CollaborationSelectionAvatarPlugin=__exports.CollaborationSelectionAvatarPlugin=class CollaborationSelectionAvatarPlugin extends Plugin{static id="collaborationSelectionAvatar";static dependencies=["history","position","localOverlay","collaborationOdoo"];resources={collaboration_notification_handlers:this.handleCollaborationNotification.bind(this),external_history_step_handlers:this.refreshSelection.bind(this),layout_geometry_change_handlers:this.refreshSelection.bind(this),set_movable_element_handlers:this.disableAvatarForElement.bind(this),unset_movable_element_handlers:this.enableAvatars.bind(this),collaborative_selection_update_handlers:this.updateSelection.bind(this),collaboration_peer_metadata_providers:()=>({avatarUrl:this.avatarUrl}),};selectionInfos=new Map();setup(){this.avatarOverlay=this.dependencies.localOverlay.makeLocalOverlay("oe-avatars-overlay");this.avatarsCountersOverlay=this.dependencies.localOverlay.makeLocalOverlay("oe-avatars-counters-overlay");this.avatarUrl=`${
            browser.location.origin
        }/web/image?model=res.users&field=avatar_128&id=${encodeURIComponent(user.userId)}`;}
handleCollaborationNotification({notificationName,notificationPayload}){switch(notificationName){case"ptp_remove":this.selectionInfos.delete(notificationPayload);this.refreshSelection();}}
updateSelection(selection){const savedSelection=this.selectionInfos.get(selection.peerId)||{};const newSelection=Object.assign(savedSelection,selection);this.selectionInfos.set(selection.peerId,newSelection);this.drawPeerAvatar(newSelection);this.updateAvatarCounters();}
drawPeerAvatar(selectionInfo){const{selection,peerId}=selectionInfo;const peerMetadata=this.dependencies.collaborationOdoo.getPeerMetadata(peerId);if(!peerMetadata){return;}
const{avatarUrl,peerName=_t("Anonymous")}=peerMetadata;const anchorNode=this.dependencies.history.getNodeById(selection.anchorNodeId);const focusNode=this.dependencies.history.getNodeById(selection.focusNodeId);if(!anchorNode||!focusNode||!anchorNode.isConnected||!focusNode.isConnected){return;}
const anchorBlock=closestBlock(anchorNode);if(!anchorBlock){return;}
const containerRect=this.avatarOverlay.getBoundingClientRect();let avatarElement=selectionInfo.avatarElement;if(!avatarElement){avatarElement=this.document.createElement("div");avatarElement.className="oe-collaboration-caret-avatar";avatarElement.style.display="none";const image=this.document.createElement("img");avatarElement.append(image);image.onload=()=>avatarElement.style.removeProperty("display");image.setAttribute("src",avatarUrl);image.classList.add("o_object_fit_cover");}
if(!avatarElement.parentElement){this.avatarOverlay.append(avatarElement);}
selectionInfo.avatarElement=avatarElement;selectionInfo.peerName=peerName;selectionInfo.avatarTargetElement=anchorBlock;this.selectionInfos.set(peerId,selectionInfo);const anchorBlockRect=anchorBlock.getBoundingClientRect();const top=anchorBlockRect.y-containerRect.y;avatarElement.style.top=top+"px";const closestList=closestElement(anchorNode,"ul, ol");const anchorX=closestList?closestList.getBoundingClientRect().x:anchorBlockRect.x;const left=anchorX-containerRect.x-AVATAR_SIZE;avatarElement.style.left=left+"px";selectionInfo.avatarPositionKey=`${left}|${top}`;}
updateAvatarCounters(){const avatarsOverlaps={};for(const info of this.selectionInfos.values()){const key=info.avatarPositionKey;avatarsOverlaps[key]=avatarsOverlaps[key]||new Set();avatarsOverlaps[key].add(info);}
this.avatarsCountersOverlay.replaceChildren();for(const[overlapKey,infos]of Object.entries(avatarsOverlaps)){const size=infos.size;if(size>1){const[left,top]=overlapKey.split("|").map((n)=>parseInt(n,10));const div=document.createElement("div");div.className="oe-overlapping-counter";div.style.left=left+10+"px";div.style.top=top+10+"px";div.innerText=size;this.avatarsCountersOverlay.append(div);}}}
refreshSelection(){if(!this.selectionInfos.size){this.avatarOverlay.replaceChildren();}
this.avatarsCountersOverlay.replaceChildren();for(const selection of this.selectionInfos.values()){this.drawPeerAvatar(selection);}
this.updateAvatarCounters();}
disableAvatarForElement(element){this.enableAvatars();for(const info of this.selectionInfos.values()){if(info.avatarTargetElement===element){if(!info.avatarElement.classList.contains("invisible")){info.avatarElement.classList.add("invisible");}}}}
enableAvatars(){for(const element of this.avatarOverlay.querySelectorAll(".oe-collaboration-caret-avatar.invisible")){element.classList.remove("invisible");}}}
return __exports;});;

/* /html_editor/static/src/others/collaboration/collaboration_selection_plugin.js */
odoo.define('@html_editor/others/collaboration/collaboration_selection_plugin',['@html_editor/plugin','@html_editor/utils/dom_info','@html_editor/utils/dom_traversal','@html_editor/utils/position','@html_editor/utils/selection','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{getDeepestPosition,isProtected,isProtecting,isUnprotecting,}=require("@html_editor/utils/dom_info");const{childNodes}=require("@html_editor/utils/dom_traversal");const{DIRECTIONS}=require("@html_editor/utils/position");const{getCursorDirection}=require("@html_editor/utils/selection");const{_t}=require("@web/core/l10n/translation");const CollaborationSelectionPlugin=__exports.CollaborationSelectionPlugin=class CollaborationSelectionPlugin extends Plugin{static id="collaborationSelection";static dependencies=["history","collaborationOdoo","position","localOverlay"];resources={collaboration_notification_handlers:this.handleCollaborationNotification.bind(this),layout_geometry_change_handlers:this.refreshSelection.bind(this),collaborative_selection_update_handlers:this.updateSelection.bind(this),collaboration_peer_metadata_providers:()=>({selectionColor:this.selectionColor}),};selectionInfos=new Map();setup(){this.selectionOverlay=this.dependencies.localOverlay.makeLocalOverlay("oe-selections-container");this.selectionColor=`hsl(${(Math.random() * 360).toFixed(0)}, 75%, 50%)`;}
handleCollaborationNotification({notificationName,notificationPayload}){switch(notificationName){case"ptp_remove":this.multiselectionRemove(notificationPayload);this.selectionInfos.delete(notificationPayload);break;}}
updateSelection(selection){this.selectionInfos.set(selection.peerId,selection);this.drawPeerSelection(selection);}
drawPeerSelection({selection,peerId}){const peerMetadata=this.dependencies.collaborationOdoo.getPeerMetadata(peerId);if(!peerMetadata){return;}
const{selectionColor,peerName=_t("Anonymous")}=peerMetadata;this.multiselectionRemove(peerId);let clientRects;let anchorNode=this.dependencies.history.getNodeById(selection.anchorNodeId);let focusNode=this.dependencies.history.getNodeById(selection.focusNodeId);let anchorOffset=selection.anchorOffset;let focusOffset=selection.focusOffset;if(!anchorNode||!focusNode){anchorNode=this.editable.children[0];focusNode=this.editable.children[0];anchorOffset=0;focusOffset=0;}
const anchorTarget=childNodes(anchorNode).at(anchorOffset);const focusTarget=childNodes(focusNode).at(focusOffset);const protectionCheck=(node)=>isProtecting(node)||(isProtected(node)&&!isUnprotecting(node));if(protectionCheck(anchorTarget)||protectionCheck(focusTarget)){return;}
if(anchorNode.isConnected&&focusNode.isConnected){[anchorNode,anchorOffset]=getDeepestPosition(anchorNode,anchorOffset);[focusNode,focusOffset]=getDeepestPosition(focusNode,focusOffset);}else{anchorNode=this.editable.children[0];focusNode=this.editable.children[0];anchorOffset=0;focusOffset=0;}
const direction=getCursorDirection(anchorNode,anchorOffset,focusNode,focusOffset);const range=new Range();try{if(direction===DIRECTIONS.RIGHT){range.setStart(anchorNode,anchorOffset);range.setEnd(focusNode,focusOffset);}else{range.setStart(focusNode,focusOffset);range.setEnd(anchorNode,anchorOffset);}
clientRects=Array.from(range.getClientRects());}catch{clientRects=[];}
if(!clientRects.length){return;}
const containerRect=this.selectionOverlay.getBoundingClientRect();const indicators=clientRects.map(({x,y,width,height})=>{const rectElement=this.document.createElement("div");rectElement.style=`
                position: absolute;
                top: ${y - containerRect.y}px;
                left: ${x - containerRect.x}px;
                width: ${width}px;
                height: ${height}px;
                background-color: ${selectionColor};
                opacity: 0.25;
                pointer-events: none;
            `;rectElement.setAttribute("data-selection-peer-id",peerId);return rectElement;});const caretElement=this.document.createElement("div");caretElement.style=`border-left: 2px solid ${selectionColor}; position: absolute;`;caretElement.setAttribute("data-selection-peer-id",peerId);caretElement.className="oe-collaboration-caret";const caretTopSquare=this.document.createElement("div");caretTopSquare.className="oe-collaboration-caret-top-square";caretTopSquare.style["background-color"]=selectionColor;caretTopSquare.setAttribute("data-peer-name",peerName);caretElement.append(caretTopSquare);if(direction===DIRECTIONS.LEFT){const rect=clientRects[0];caretElement.style.height=`${rect.height * 1.2}px`;caretElement.style.top=`${rect.y - containerRect.y}px`;caretElement.style.left=`${rect.x - containerRect.x}px`;}else{const rect=clientRects.at(-1);caretElement.style.height=`${rect.height * 1.2}px`;caretElement.style.top=`${rect.y - containerRect.y}px`;caretElement.style.left=`${rect.right - containerRect.x}px`;}
this.selectionOverlay.append(caretElement,...indicators);}
multiselectionRemove(peerId){const elements=this.selectionOverlay.querySelectorAll(`[data-selection-peer-id="${peerId}"]`);for(const element of elements){element.remove();}}
refreshSelection(){this.selectionOverlay.replaceChildren();for(const selection of this.selectionInfos.values()){this.drawPeerSelection(selection);}}}
return __exports;});;

/* /html_editor/static/src/others/custom_media_dialog.js */
odoo.define('@html_editor/others/custom_media_dialog',['@html_editor/main/media/media_dialog/media_dialog'],function(require){'use strict';let __exports={};const{MediaDialog}=require("@html_editor/main/media/media_dialog/media_dialog");const CustomMediaDialog=__exports.CustomMediaDialog=class CustomMediaDialog extends MediaDialog{async save(){if(this.errorMessages[this.state?.activeTab]){this.notificationService.add(this.errorMessages[this.state.activeTab],{type:"danger",});return;}
if(this.state.activeTab=="IMAGES"){const attachments=this.selectedMedia[this.state.activeTab];const preloadedAttachments=attachments.filter((attachment)=>attachment.res_model);this.selectedMedia[this.state.activeTab]=attachments.filter((attachment)=>!preloadedAttachments.includes(attachment));if(this.selectedMedia[this.state.activeTab].length>0){await super.save();const newAttachments=this.selectedMedia[this.state.activeTab];this.props.imageSave(newAttachments);}
if(preloadedAttachments.length){this.props.imageSave(preloadedAttachments);}}else{this.props.videoSave(this.selectedMedia[this.state.activeTab]);}
this.props.close();}}
return __exports;});;

/* /html_editor/static/src/others/dynamic_placeholder_plugin.js */
odoo.define('@html_editor/others/dynamic_placeholder_plugin',['@html_editor/plugin','@web/core/l10n/translation','@web/views/fields/dynamic_placeholder_popover','@html_editor/utils/resource'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{_t}=require("@web/core/l10n/translation");const{DynamicPlaceholderPopover}=require("@web/views/fields/dynamic_placeholder_popover");const{withSequence}=require("@html_editor/utils/resource");const DynamicPlaceholderPlugin=__exports.DynamicPlaceholderPlugin=class DynamicPlaceholderPlugin extends Plugin{static id="dynamicPlaceholder";static dependencies=["overlay","selection","history","dom"];static shared=["updateDphDefaultModel"];resources={user_commands:[{id:"openDynamicPlaceholder",title:_t("Dynamic Placeholder"),description:_t("Insert a field"),icon:"fa-hashtag",run:(params={})=>{return this.open(params.resModel||this.defaultResModel);},},],powerbox_categories:withSequence(60,{id:"marketing_tools",name:_t("Marketing Tools"),}),powerbox_items:{categoryId:"marketing_tools",commandId:"openDynamicPlaceholder",},power_buttons:{commandId:"openDynamicPlaceholder"},};setup(){this.defaultResModel=this.config.dynamicPlaceholderResModel;this.overlay=this.dependencies.overlay.createOverlay(DynamicPlaceholderPopover,{hasAutofocus:true,className:"popover",});}
updateDphDefaultModel(resModel){this.defaultResModel=resModel;}
open(resModel){if(!resModel){return this.services.notification.add(_t("You need to select a model before opening the dynamic placeholder selector."),{type:"danger"});}
this.overlay.open({props:{close:this.onClose.bind(this),validate:this.onValidate.bind(this),resModel:resModel,},});}
onValidate(chain,defaultValue){if(!chain){return;}
const t=document.createElement("T");t.setAttribute("t-out",`object.${chain}`);if(defaultValue?.length){t.innerText=defaultValue;}
this.dependencies.dom.insert(t);this.dependencies.history.addStep();}
onClose(){this.overlay.close();this.dependencies.selection.focusEditable();}}
return __exports;});;

/* /html_editor/static/src/others/embedded_component_plugin.js */
odoo.define('@html_editor/others/embedded_component_plugin',['@html_editor/plugin','@web/core/utils/functions'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{memoize}=require("@web/core/utils/functions");const EmbeddedComponentPlugin=__exports.EmbeddedComponentPlugin=class EmbeddedComponentPlugin extends Plugin{static id="embeddedComponents";static dependencies=["history","protectedNode"];resources={normalize_handlers:this.normalize.bind(this),clean_for_save_handlers:({root})=>this.cleanForSave(root),attribute_change_handlers:this.onChangeAttribute.bind(this),restore_savepoint_handlers:()=>this.handleComponents(this.editable),history_reset_handlers:()=>this.handleComponents(this.editable),history_reset_from_steps_handlers:()=>this.handleComponents(this.editable),step_added_handlers:({stepCommonAncestor})=>this.handleComponents(stepCommonAncestor),external_step_added_handlers:()=>this.handleComponents(this.editable),serializable_descendants_processors:this.processDescendantsToSerialize.bind(this),attribute_change_processors:this.onChangeAttribute.bind(this),savable_mutation_record_predicates:this.isMutationRecordSavable.bind(this),};setup(){this.components=new Set();this.nodeMap=new WeakMap();this.app=this.config.embeddedComponentInfo.app;this.env=this.config.embeddedComponentInfo.env;this.hostToStateChangeManagerMap=new WeakMap();this.embeddedComponents=memoize((embeddedComponents=[])=>{const result={};for(const embedding of embeddedComponents){result[embedding.name]=embedding;}
return result;});}
isMutationRecordSavable(record){const info=this.nodeMap.get(record.target);if(info&&record.type==="attributes"&&record.attributeName==="data-embedded-props"){return false;}
return true;}
processDescendantsToSerialize(elem,serializableDescendants){const embedding=this.getEmbedding(elem);if(!embedding){return serializableDescendants;}
return Object.values(embedding.getEditableDescendants?.(elem)||{});}
handleComponents(elem){this.destroyRemovedComponents([...this.components]);this.forEachEmbeddedComponentHost(elem,(host,embedding)=>{const info=this.nodeMap.get(host);if(!info){this.mountComponent(host,embedding);}});}
forEachEmbeddedComponentHost(elem,callback){const selector=`[data-embedded]`;const targets=[...elem.querySelectorAll(selector)];if(elem.matches(selector)){targets.unshift(elem);}
for(const host of targets){const embedding=this.getEmbedding(host);if(!embedding){continue;}
callback(host,embedding);}}
getEmbedding(host){return this.embeddedComponents(this.getResource("embedded_components"))[host.dataset.embedded];}
onChangeAttribute(attributeChange,{forNewStep=false}={}){const attributeValue=attributeChange.value;let newAttributeValue;if(attributeChange.attributeName==="data-embedded-state"){const attrState=attributeChange.reverse?attributeChange.oldValue:attributeChange.value;const stateChangeManager=this.getStateChangeManager(attributeChange.target);if(stateChangeManager){newAttributeValue=stateChangeManager.onStateChanged(attrState,{reverse:attributeChange.reverse,forNewStep,});}}
return newAttributeValue||attributeValue;}
getStateChangeManager(host){const embedding=this.getEmbedding(host);if(!("getStateChangeManager"in embedding)){return null;}
if(!this.hostToStateChangeManagerMap.has(host)){const config={host,commitStateChanges:()=>this.dependencies.history.addStep(),};const stateChangeManager=embedding.getStateChangeManager(config);stateChangeManager.setup();this.hostToStateChangeManagerMap.set(host,stateChangeManager);}
return this.hostToStateChangeManagerMap.get(host);}
mountComponent(host,{Component,getEditableDescendants,getProps,name,getStateChangeManager}){const props=getProps?.(host)||{};const env=Object.create(this.env);if(getStateChangeManager){env.getStateChangeManager=this.getStateChangeManager.bind(this);}
if(getEditableDescendants){env.getEditableDescendants=getEditableDescendants;}
this.dispatchTo("mount_component_handlers",{name,env,props});const root=this.app.createRoot(Component,{props,env,});root.mount(host);const fiber=root.node.fiber;const fiberComplete=fiber.complete;fiber.complete=function(){host.replaceChildren();fiberComplete.call(this);};const info={root,host,};this.components.add(info);this.nodeMap.set(host,info);}
destroyRemovedComponents(infos){this.dependencies.history.disableObserver();for(const info of infos){if(!this.editable.contains(info.host)){const host=info.host;const display=host.style.display;const parentNode=host.parentNode;const clone=host.cloneNode(false);if(parentNode){parentNode.replaceChild(clone,host);}
host.style.display="none";this.editable.after(host);this.destroyComponent(info);if(parentNode){parentNode.replaceChild(host,clone);}else{host.remove();}
host.style.display=display;if(!host.getAttribute("style")){host.removeAttribute("style");}}}
this.dependencies.history.enableObserver();}
deepDestroyComponent({host}){const removed=[];this.forEachEmbeddedComponentHost(host,(containedHost)=>{const info=this.nodeMap.get(containedHost);if(info){if(this.editable.contains(containedHost)){this.destroyComponent(info);}else{removed.push(info);}}});this.destroyRemovedComponents(removed);}
destroyComponent({root,host}){const{getEditableDescendants}=this.getEmbedding(host);const editableDescendants=getEditableDescendants?.(host)||{};root.destroy();this.components.delete(arguments[0]);this.nodeMap.delete(host);host.append(...Object.values(editableDescendants));}
destroy(){super.destroy();for(const info of[...this.components]){if(this.components.has(info)){this.deepDestroyComponent(info);}}}
normalize(elem){this.forEachEmbeddedComponentHost(elem,(host,{getEditableDescendants})=>{this.dependencies.protectedNode.setProtectingNode(host,true);const editableDescendants=getEditableDescendants?.(host)||{};for(const editableDescendant of Object.values(editableDescendants)){this.dependencies.protectedNode.setProtectingNode(editableDescendant,false);}});}
cleanForSave(clone){this.forEachEmbeddedComponentHost(clone,(host,{getEditableDescendants})=>{const editableDescendants=getEditableDescendants?.(host)||{};host.replaceChildren();for(const editableDescendant of Object.values(editableDescendants)){delete editableDescendant.dataset.oeProtected;host.append(editableDescendant);}
delete host.dataset.oeProtected;delete host.dataset.embeddedState;});}}
return __exports;});;

/* /html_editor/static/src/others/embedded_component_utils.js */
odoo.define('@html_editor/others/embedded_component_utils',['@odoo/owl'],function(require){'use strict';let __exports={};const{onMounted,onRendered,onPatched,onWillDestroy,reactive,toRaw,useComponent,useRef,useState,}=require("@odoo/owl");__exports.getEditableDescendants=getEditableDescendants;function getEditableDescendants(host){const editableDescendants={};for(const candidate of host.querySelectorAll("[data-embedded-editable]")){if(candidate.closest("[data-embedded]")===host){editableDescendants[candidate.dataset.embeddedEditable]=candidate;}}
return editableDescendants;}
__exports.useEditableDescendants=useEditableDescendants;function useEditableDescendants(host){const component=useComponent();if(!component.env.getEditableDescendants){throw new Error("Missing `getEditableDescendants` function in the `embedding` provided to the `EmbeddedComponentPlugin`.");}
const editableDescendants=Object.freeze(component.env.getEditableDescendants(host));const refs={};const renders={};for(const name of Object.keys(editableDescendants)){refs[name]=useRef(name);renders[name]=()=>refs[name].el.replaceChildren(editableDescendants[name]);}
let _restoreSelection;const restoreSelection=()=>{if(_restoreSelection){_restoreSelection();_restoreSelection=undefined;}};if(component.env.editorShared?.preserveSelection){onRendered(()=>{_restoreSelection=component.env.editorShared.preserveSelection().restore;});}
onMounted(()=>{for(const render of Object.values(renders)){render();}
restoreSelection();});onPatched(()=>{for(const[name,render]of Object.entries(renders)){if(!host.contains(editableDescendants[name])){render();}}
restoreSelection();});return editableDescendants;}
function embeddedStateProxyHandler(state,stateChangeManager){return{set(target,key,value,receiver){if(value!==Reflect.get(target,key,receiver)&&!stateChangeManager.previousEmbeddedState){stateChangeManager.previousEmbeddedState=JSON.parse(JSON.stringify(stateChangeManager.embeddedState));}
return Reflect.set(target,key,value,receiver);},deleteProperty(target,key){if(Reflect.has(target,key)&&!stateChangeManager.previousEmbeddedState){stateChangeManager.previousEmbeddedState=JSON.parse(JSON.stringify(stateChangeManager.embeddedState));}
return Reflect.deleteProperty(target,key);},get(target,key,receiver){Reflect.get(state,key,state);return Reflect.get(target,key,receiver);},ownKeys(target){Reflect.ownKeys(state);return Reflect.ownKeys(target);},has(target,key){Reflect.has(state,key);return Reflect.has(target,key);},};}
function observeAllKeys(reactive){for(const key in reactive){const prop=reactive[key];if(prop instanceof Object){observeAllKeys(prop);}}}
__exports.getEmbeddedProps=getEmbeddedProps;function getEmbeddedProps(host){return host.dataset.embeddedProps?JSON.parse(host.dataset.embeddedProps):{};}
function sortedCopy(obj){const result={};const propNames=Object.keys(obj).sort();for(const propName of propNames){result[propName]=obj[propName];}
return result;}
__exports.applyObjectPropertyDifference=applyObjectPropertyDifference;function applyObjectPropertyDifference(container,key,previous,next){if(!container[key]){container[key]={};}
const obj1={...(previous||{})};const obj2={...(next||{})};const dest=container[key];for(const key in obj2){if(JSON.stringify(obj1[key])!==JSON.stringify(obj2[key])){dest[key]=obj2[key];}
delete obj1[key];}
for(const key in obj1){delete dest[key];}
if(!Object.keys(dest).length&&!next){delete container[key];}}
__exports.replaceProperty=replaceProperty;function replaceProperty(container,key,value){if(value===undefined){delete container[key];}else{container[key]=value;}}
const StateChangeManager=__exports.StateChangeManager=class StateChangeManager{constructor(config){this.config=config;}
setup(){const defaultState=sortedCopy(this.getEmbeddedState());const defaultStateChange={stateChangeId:null,previous:defaultState,next:defaultState,};this.defaultStateChange=defaultStateChange;this.previousStateChange=defaultStateChange;this.batchId=0;this.setupUnmounted();}
setupUnmounted(){this.previousEmbeddedState=null;this.state=null;this.embeddedState=null;this.embeddedStateProxy=null;this.isLiveComponent=false;this.batchId+=1;}
constructEmbeddedState(state){this.state=state;this.embeddedState=reactive(this.assignDeepProxyCopy({},state),this.batchedChangeState());this.embeddedStateProxy=new Proxy(this.embeddedState,embeddedStateProxyHandler(state,this));observeAllKeys(this.embeddedStateProxy);this.isLiveComponent=true;return this.embeddedStateProxy;}
getState(){let state=this.state;if(!this.isLiveComponent){state=this.getEmbeddedState();}
return state;}
onStateChanged(attrState,{reverse=false,forNewStep=false}={}){const stateChange=attrState?JSON.parse(attrState):this.defaultStateChange;const state=this.getState();if(reverse){this.reverseStateChange(stateChange);}
if(!this.areStateChangesEqual(this.previousStateChange,stateChange)){const previous=JSON.stringify(sortedCopy(state));this.commitStateChange(state,stateChange.previous,stateChange.next);const sortedState=sortedCopy(state);this.config.host.dataset.embeddedProps=JSON.stringify(this.stateToEmbeddedProps(this.config.host,sortedState));if(this.isLiveComponent&&!this.previousEmbeddedState){this.assignDeepProxyCopy(toRaw(this.embeddedState),sortedState);}
if(!forNewStep){this.previousStateChange=stateChange;}else{const next=JSON.stringify(sortedState);if(previous!==next){this.previousStateChange={stateChangeId:this.generateId(),previous:JSON.parse(previous),next:JSON.parse(next),};return JSON.stringify(this.previousStateChange);}}}}
batchedChangeState(){let scheduled=false;const batchId=this.batchId;return async()=>{if(this.isLiveComponent&&!scheduled){scheduled=true;await Promise.resolve();scheduled=false;if(batchId===this.batchId){this.changeState();}}};}
changeState(){if(!this.previousEmbeddedState){return;}
const previousEmbeddedState=this.previousEmbeddedState;this.previousEmbeddedState=null;const previous=JSON.stringify(sortedCopy(this.state));this.commitStateChange(this.state,previousEmbeddedState,JSON.parse(JSON.stringify(this.embeddedState)));const sortedState=sortedCopy(this.state);const next=JSON.stringify(sortedState);this.assignDeepProxyCopy(toRaw(this.embeddedState),sortedState);if(previous!==next){this.previousStateChange={stateChangeId:this.generateId(),previous:JSON.parse(previous),next:JSON.parse(next),};this.config.host.dataset.embeddedState=JSON.stringify(this.previousStateChange);this.config.host.dataset.embeddedProps=JSON.stringify(this.stateToEmbeddedProps(this.config.host,sortedState));this.config.commitStateChanges();}
observeAllKeys(this.embeddedStateProxy);}
areStateChangesEqual(sc1,sc2){return(sc1.stateChangeId===sc2.stateChangeId&&JSON.stringify(sc1.previous)===JSON.stringify(sc2.previous)&&JSON.stringify(sc1.next)===JSON.stringify(sc2.next));}
reverseStateChange(stateChange){const previous=stateChange.previous;stateChange.previous=stateChange.next;stateChange.next=previous;}
assignDeepProxyCopy(target,source){for(const key of Object.keys(target)){delete target[key];}
for(const key of Object.keys(source)){target[key]=this.deepProxyCopy(source[key]);}
return target;}
deepProxyCopy(value){if(value instanceof Object){const copy=value instanceof Array?[]:{};for(const prop in value){copy[prop]=this.deepProxyCopy(value[prop]);}
return new Proxy(copy,embeddedStateProxyHandler(value,this));}
return value;}
generateId(){return Math.floor(Math.random()*Math.pow(2,52));}
commitStateChange(state,previous,next){const currentKeys=new Set([...Object.keys(state),...Object.keys(previous),...Object.keys(next),]);for(const key of currentKeys){if(key in(this.config.propertyUpdater||{})){this.config.propertyUpdater[key](state,previous,next);}else if(JSON.stringify(previous[key])!==JSON.stringify(next[key])){replaceProperty(state,key,next[key]);}}}
getEmbeddedState(){const host=this.config.host;return this.config.getEmbeddedState?.(host)||getEmbeddedProps(host);}
stateToEmbeddedProps(host,state){const props=this.config.stateToEmbeddedProps?.(host,state)||state;for(const key of Object.keys(props)){if(props[key]===undefined){delete props[key];}}
return props;}}
__exports.useEmbeddedState=useEmbeddedState;function useEmbeddedState(host){const component=useComponent();if(!component.env.getStateChangeManager){throw new Error("Missing `getStateChangeManager` function in the `embedding` provided to the `EmbeddedComponentPlugin`.");}
const stateChangeManager=component.env.getStateChangeManager(host);onWillDestroy(()=>stateChangeManager.setupUnmounted());const state=useState(stateChangeManager.getEmbeddedState());return stateChangeManager.constructEmbeddedState(state);}
return __exports;});;

/* /html_editor/static/src/others/embedded_components/backend/file/file.js */
odoo.define('@html_editor/others/embedded_components/backend/file/file',['@html_editor/others/embedded_component_utils','@odoo/owl','@html_editor/others/embedded_components/core/file/readonly_file'],function(require){'use strict';let __exports={};const{applyObjectPropertyDifference,getEmbeddedProps,StateChangeManager,useEmbeddedState,}=require("@html_editor/others/embedded_component_utils");const{useEffect,useRef,useState}=require("@odoo/owl");const{ReadonlyEmbeddedFileComponent}=require("@html_editor/others/embedded_components/core/file/readonly_file");const EmbeddedFileComponent=__exports.EmbeddedFileComponent=class EmbeddedFileComponent extends ReadonlyEmbeddedFileComponent{static template="html_editor.EmbeddedFile";setup(){super.setup();this.state=useEmbeddedState(this.props.host);this.fileModel.state=this.state;this.localState=useState({editFileName:false,});this.nameInput=useRef("nameInput");useEffect(()=>{if(this.localState.editFileName){this.nameInput.el.focus();this.nameInput.el.select();}},()=>[this.localState.editFileName]);}
onBlurNameInput(ev){this.localState.editFileName=false;this.renameFile();}
onFocusFileName(ev){this.localState.editFileName=true;}
onKeydownNameInput(ev){if(ev.key!=="Enter"){return;}else{ev.preventDefault();}
if(this.renameFile()){this.localState.editFileName=false;this.env.editorShared?.setSelectionAfter(this.props.host);}}
renameFile(){let newName=this.nameInput.el.value;if(!newName.length){return false;}
if(newName===this.fileModel.filename){return true;}
this.fileModel.filename=newName;if(this.fileModel.extension){const pattern=new RegExp(`\\.${this.fileModel.extension}$`,"i");if(!newName.match(pattern)){newName+=`.${this.fileModel.extension}`;}}
this.fileModel.name=newName;return true;}}
const fileEmbedding=__exports.fileEmbedding={name:"file",Component:EmbeddedFileComponent,getProps:(host)=>{return{host,...getEmbeddedProps(host)};},getStateChangeManager:(config)=>{return new StateChangeManager(Object.assign(config,{propertyUpdater:{fileData:(state,previous,next)=>{applyObjectPropertyDifference(state,"fileData",previous.fileData,next.fileData);},},}));},};return __exports;});;

/* /html_editor/static/src/others/embedded_components/core/embedded_component_toolbar/embedded_component_toolbar.js */
odoo.define('@html_editor/others/embedded_components/core/embedded_component_toolbar/embedded_component_toolbar',['@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{useForwardRefToParent}=require("@web/core/utils/hooks");const EmbeddedComponentToolbar=__exports.EmbeddedComponentToolbar=class EmbeddedComponentToolbar extends Component{static props={buttonsGroupClass:{type:String,optional:true},slots:Object,};static template="html_editor.EmbeddedComponentToolbar";}
const EmbeddedComponentToolbarButton=__exports.EmbeddedComponentToolbarButton=class EmbeddedComponentToolbarButton extends Component{static props={buttonRef:{type:Function,optional:true},hidden:{type:Boolean,optional:true},icon:{type:String,optional:true},label:String,name:{type:String,optional:true},onClick:Function,title:{type:String,optional:true},};static template="html_editor.EmbeddedComponentToolbarButton";setup(){useForwardRefToParent("buttonRef");}}
return __exports;});;

/* /html_editor/static/src/others/embedded_components/core/file/readonly_file.js */
odoo.define('@html_editor/others/embedded_components/core/file/readonly_file',['@web/core/l10n/translation','@web/core/network/download','@web/core/file_viewer/file_viewer_hook','@web/core/utils/hooks','@web/core/confirmation_dialog/confirmation_dialog','@html_editor/others/embedded_components/core/embedded_component_toolbar/embedded_component_toolbar','@html_editor/others/embedded_components/core/file/state_file_model','@html_editor/others/embedded_component_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{downloadFile}=require("@web/core/network/download");const{useFileViewer}=require("@web/core/file_viewer/file_viewer_hook");const{useService}=require("@web/core/utils/hooks");const{AlertDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{EmbeddedComponentToolbar,EmbeddedComponentToolbarButton,}=require("@html_editor/others/embedded_components/core/embedded_component_toolbar/embedded_component_toolbar");const{StateFileModel}=require("@html_editor/others/embedded_components/core/file/state_file_model");const{getEmbeddedProps}=require("@html_editor/others/embedded_component_utils");const{Component,useState}=require("@odoo/owl");const ReadonlyEmbeddedFileComponent=__exports.ReadonlyEmbeddedFileComponent=class ReadonlyEmbeddedFileComponent extends Component{static components={EmbeddedComponentToolbar,EmbeddedComponentToolbarButton,};static props={fileData:{type:Object},host:{type:Object},};static template="html_editor.ReadonlyEmbeddedFile";setup(){this.dialogService=useService("dialog");this.state=useState({fileData:{...this.props.fileData},});this.fileModel=new StateFileModel(this.state);this.attachmentViewer=useFileViewer();}
async onClickDownload(ev){ev.preventDefault();ev.stopPropagation();await this.download();}
async download(){try{await downloadFile(this.fileModel.downloadUrl);}catch{this.dialogService.add(AlertDialog,{body:_t("Oops, the file %s could not be found. Please replace this file box by a new one to re-upload the file.",this.fileModel.name),title:_t("Missing File"),confirm:()=>{},confirmLabel:_t("Close"),});}}
onClickFileImage(){if(this.fileModel.isViewable){this.attachmentViewer.open(this.fileModel);}else{this.download();}}}
const readonlyFileEmbedding=__exports.readonlyFileEmbedding={name:"file",Component:ReadonlyEmbeddedFileComponent,getProps:(host)=>{return{host,...getEmbeddedProps(host)};},};return __exports;});;

/* /html_editor/static/src/others/embedded_components/core/file/state_file_model.js */
odoo.define('@html_editor/others/embedded_components/core/file/state_file_model',['@web/core/file_viewer/file_model'],function(require){'use strict';let __exports={};const{FileModel}=require("@web/core/file_viewer/file_model");const StateFileModel=__exports.StateFileModel=class StateFileModel extends FileModel{constructor(state){super();this.state=state;for(const property of["access_token","checksum","extension","filename","id","mimetype","name","type","tmpUrl","url","uploading",]){Object.defineProperty(this,property,{get(){return this.state.fileData[property];},set(value){this.state.fileData[property]=value;},configurable:true,enumerable:true,});}}}
return __exports;});;

/* /html_editor/static/src/others/embedded_components/core/table_of_content/table_of_content.js */
odoo.define('@html_editor/others/embedded_components/core/table_of_content/table_of_content',['@odoo/owl','@html_editor/others/embedded_components/core/table_of_content/table_of_content_manager'],function(require){'use strict';let __exports={};const{Component,onWillStart,useState}=require("@odoo/owl");const{TableOfContentManager}=require("@html_editor/others/embedded_components/core/table_of_content/table_of_content_manager");const EmbeddedTableOfContentComponent=__exports.EmbeddedTableOfContentComponent=class EmbeddedTableOfContentComponent extends Component{static template="html_editor.EmbeddedTableOfContent";static props={manager:{type:TableOfContentManager},readonly:{type:Boolean,optional:true},};setup(){this.state=useState({toc:this.props.manager.structure});onWillStart(async()=>{await this.props.manager.batchedUpdateStructure();});}
displayTocHint(){return this.state.toc.headings.length<2&&!this.props.readonly;}
onTocLinkClick(heading){this.props.manager.scrollIntoView(heading);}}
const tableOfContentEmbedding=__exports.tableOfContentEmbedding={name:"tableOfContent",Component:EmbeddedTableOfContentComponent,};const readonlyTableOfContentEmbedding=__exports.readonlyTableOfContentEmbedding={name:"tableOfContent",Component:EmbeddedTableOfContentComponent,getProps:(host)=>{return{readonly:true,};},};return __exports;});;

/* /html_editor/static/src/others/embedded_components/core/table_of_content/table_of_content_manager.js */
odoo.define('@html_editor/others/embedded_components/core/table_of_content/table_of_content_manager',['@odoo/owl'],function(require){'use strict';let __exports={};const{batched,reactive}=require("@odoo/owl");const HEADINGS=__exports.HEADINGS=["H1","H2","H3","H4","H5","H6"];const TableOfContentManager=__exports.TableOfContentManager=class TableOfContentManager{constructor(containerRef){this.containerRef=containerRef;this.structure=reactive({headings:[],});this.batchedUpdateStructure=batched(this.updateStructure.bind(this));}
getContainerEl(){return this.containerRef.el;}
fetchValidHeadings(element){const inEmbeddedHeadings=new Set(element.querySelectorAll(HEADINGS.map((heading)=>`[data-embedded] ${heading}`).join(",")));return Array.from(element.querySelectorAll(HEADINGS.join(","))).filter((heading)=>heading.innerText.trim().replaceAll("\u200B","").length>0).filter((heading)=>!inEmbeddedHeadings.has(heading));}
scrollIntoView(heading){if(!heading){return;}
const{target}=heading;target.scrollIntoView({behavior:"smooth"});target.classList.add("o_embedded_toc_header_highlight");window.setTimeout(()=>{target.classList.remove("o_embedded_toc_header_highlight");},2000);}
updateStructure(){let currentDepthByTag={};let previousTag;let previousDepth=-1;const container=this.getContainerEl();if(!container){return;}
this.structure.headings=this.fetchValidHeadings(container).map((heading)=>{let depth=HEADINGS.indexOf(heading.tagName);if(depth!==previousDepth&&heading.tagName===previousTag){depth=previousDepth;}else if(depth>previousDepth){if(heading.tagName!==previousTag&&HEADINGS.indexOf(previousTag)<depth){depth=previousDepth+1;}else{depth=previousDepth;}}else if(depth<previousDepth){if(currentDepthByTag.hasOwnProperty(heading.tagName)){depth=currentDepthByTag[heading.tagName];}}
previousTag=heading.tagName;previousDepth=depth;if(depth===0){currentDepthByTag={};}
currentDepthByTag[heading.tagName]=depth;return{depth:depth,name:heading.innerText,target:heading,};});}}
return __exports;});;

/* /html_editor/static/src/others/embedded_components/core/video/video.js */
odoo.define('@html_editor/others/embedded_components/core/video/video',['@html_editor/others/embedded_component_utils','@html_editor/utils/url','@odoo/owl'],function(require){'use strict';let __exports={};const{getEmbeddedProps}=require("@html_editor/others/embedded_component_utils");const{getVideoUrl}=require("@html_editor/utils/url");const{Component}=require("@odoo/owl");const EmbeddedVideoIframe=__exports.EmbeddedVideoIframe=class EmbeddedVideoIframe extends Component{static template="html_editor.EmbeddedVideoIframe";static props={src:{type:String},};}
const EmbeddedVideoComponent=__exports.EmbeddedVideoComponent=class EmbeddedVideoComponent extends Component{static template="html_editor.EmbeddedVideo";static props={platform:{type:String},videoId:{type:String},params:{type:Object,optional:true},};static components={VideoIframe:EmbeddedVideoIframe};setup(){super.setup();const url=getVideoUrl(this.props.platform,this.props.videoId,this.props.params);this.src=url.toString();}}
const videoEmbedding=__exports.videoEmbedding={name:"video",Component:EmbeddedVideoComponent,getProps:(host)=>{return{...getEmbeddedProps(host)};},};return __exports;});;

/* /html_editor/static/src/others/embedded_components/embedding_sets.js */
odoo.define('@html_editor/others/embedded_components/embedding_sets',['@html_editor/others/embedded_components/backend/file/file','@html_editor/others/embedded_components/core/file/readonly_file','@html_editor/others/embedded_components/core/table_of_content/table_of_content','@html_editor/others/embedded_components/core/video/video'],function(require){'use strict';let __exports={};const{fileEmbedding}=require("@html_editor/others/embedded_components/backend/file/file");const{readonlyFileEmbedding}=require("@html_editor/others/embedded_components/core/file/readonly_file");const{readonlyTableOfContentEmbedding,tableOfContentEmbedding,}=require("@html_editor/others/embedded_components/core/table_of_content/table_of_content");const{videoEmbedding}=require("@html_editor/others/embedded_components/core/video/video");const MAIN_EMBEDDINGS=__exports.MAIN_EMBEDDINGS=[fileEmbedding,tableOfContentEmbedding,videoEmbedding];const READONLY_MAIN_EMBEDDINGS=__exports.READONLY_MAIN_EMBEDDINGS=[readonlyFileEmbedding,readonlyTableOfContentEmbedding,videoEmbedding,];return __exports;});;

/* /html_editor/static/src/others/embedded_components/plugins/embedded_file_plugin/embedded_file_documents_selector.js */
odoo.define('@html_editor/others/embedded_components/plugins/embedded_file_plugin/embedded_file_documents_selector',['@html_editor/main/media/media_dialog/document_selector','@web/core/utils/render'],function(require){'use strict';let __exports={};const{DocumentSelector}=require("@html_editor/main/media/media_dialog/document_selector");const{renderToElement}=require("@web/core/utils/render");const EmbeddedFileDocumentsSelector=__exports.EmbeddedFileDocumentsSelector=class EmbeddedFileDocumentsSelector extends DocumentSelector{static mediaSpecificClasses=[];static async renderFileElement(attachment){return renderEmbeddedFileBox(attachment);}}
__exports.renderEmbeddedFileBox=renderEmbeddedFileBox;function renderEmbeddedFileBox(attachment){const dotSplit=attachment.name.split(".");const extension=dotSplit.length>1?dotSplit.pop():undefined;const fileData={access_token:attachment.access_token,checksum:attachment.checksum,extension,filename:attachment.name,id:attachment.id,mimetype:attachment.mimetype,name:attachment.name,type:attachment.type,url:attachment.url||"",};return renderToElement("html_editor.EmbeddedFileBlueprint",{embeddedProps:JSON.stringify({fileData}),});}
return __exports;});;

/* /html_editor/static/src/others/embedded_components/plugins/embedded_file_plugin/embedded_file_plugin.js */
odoo.define('@html_editor/others/embedded_components/plugins/embedded_file_plugin/embedded_file_plugin',['@html_editor/utils/dom_info','@html_editor/utils/blocks','@html_editor/others/embedded_components/plugins/embedded_file_plugin/embedded_file_documents_selector','@html_editor/main/media/file_plugin','@html_editor/utils/dom_traversal'],function(require){'use strict';let __exports={};const{nextLeaf}=require("@html_editor/utils/dom_info");const{isBlock}=require("@html_editor/utils/blocks");const{EmbeddedFileDocumentsSelector,renderEmbeddedFileBox,}=require("@html_editor/others/embedded_components/plugins/embedded_file_plugin/embedded_file_documents_selector");const{FilePlugin}=require("@html_editor/main/media/file_plugin");const{closestElement}=require("@html_editor/utils/dom_traversal");const EmbeddedFilePlugin=__exports.EmbeddedFilePlugin=class EmbeddedFilePlugin extends FilePlugin{static id="embeddedFile";static dependencies=[...super.dependencies,"embeddedComponents","selection"];resources={...this.resources,mount_component_handlers:this.setupNewFile.bind(this),};renderDownloadBox(attachment){return renderEmbeddedFileBox(attachment);}
isUploadCommandAvailable({anchorNode}){return(super.isUploadCommandAvailable()&&!closestElement(anchorNode,"[data-embedded='clipboard']"));}
get componentForMediaDialog(){return EmbeddedFileDocumentsSelector;}
setupNewFile({name,env}){if(name==="file"){Object.assign(env,{editorShared:{setSelectionAfter:(host)=>{try{const leaf=nextLeaf(host,this.editable);if(!leaf){return;}
const leafEl=isBlock(leaf)?leaf:leaf.parentElement;if(isBlock(leafEl)&&leafEl.isContentEditable){this.dependencies.selection.setSelection({anchorNode:leafEl,anchorOffset:0,});}}catch{return;}},},});}}}
return __exports;});;

/* /html_editor/static/src/others/embedded_components/plugins/file_plugin/file_plugin.js */
odoo.define('@html_editor/others/embedded_components/plugins/file_plugin/file_plugin',['@html_editor/plugin','@web/core/l10n/translation','@html_editor/main/media/media_dialog/file_media_dialog','@html_editor/utils/dom_traversal','@html_editor/utils/dom_info','@html_editor/utils/blocks'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{_t}=require("@web/core/l10n/translation");const{FileMediaDialog}=require("@html_editor/main/media/media_dialog/file_media_dialog");const{closestElement}=require("@html_editor/utils/dom_traversal");const{nextLeaf}=require("@html_editor/utils/dom_info");const{isBlock}=require("@html_editor/utils/blocks");const FilePlugin=__exports.FilePlugin=class FilePlugin extends Plugin{static id="file";static dependencies=["embeddedComponents","dom","selection","history"];resources={user_commands:[{id:"openMediaDialog",title:_t("File"),description:_t("Upload a file"),icon:"fa-file",isAvailable:(selection)=>{return(!this.config.disableFile&&!closestElement(selection.anchorNode,"[data-embedded='clipboard']"));},run:()=>{this.openMediaDialog({noVideos:true,noImages:true,noIcons:true,});},},],powerbox_items:[{categoryId:"media",commandId:"openMediaDialog",},],mount_component_handlers:this.setupNewFile.bind(this),};get recordInfo(){return this.config.getRecordInfo?this.config.getRecordInfo():{};}
openMediaDialog(params={}){const selection=this.dependencies.selection.getEditableSelection();const restoreSelection=()=>{this.dependencies.selection.setSelection(selection);};const{resModel,resId,field,type}=this.recordInfo;this.services.dialog.add(FileMediaDialog,{resModel,resId,useMediaLibrary:!!(field&&((resModel==="ir.ui.view"&&field==="arch")||type==="html")),save:(element)=>{this.onSaveMediaDialog(element,{restoreSelection});},close:restoreSelection,onAttachmentChange:this.config.onAttachmentChange||(()=>{}),noVideos:!!this.config.disableVideo,noImages:!!this.config.disableImage,...this.config.mediaModalParams,...params,});}
onSaveMediaDialog(element,{restoreSelection}){restoreSelection();this.dependencies.dom.insert(element);this.dependencies.history.addStep();}
setupNewFile({name,env}){if(name==="file"){Object.assign(env,{editorShared:{setSelectionAfter:(host)=>{try{const leaf=nextLeaf(host,this.editable);if(!leaf){return;}
const leafEl=isBlock(leaf)?leaf:leaf.parentElement;if(isBlock(leafEl)&&leafEl.isContentEditable){this.dependencies.selection.setSelection({anchorNode:leafEl,anchorOffset:0,});}}catch{return;}},},});}}}
return __exports;});;

/* /html_editor/static/src/others/embedded_components/plugins/table_of_content_plugin/table_of_content_plugin.js */
odoo.define('@html_editor/others/embedded_components/plugins/table_of_content_plugin/table_of_content_plugin',['@html_editor/plugin','@web/core/l10n/translation','@web/core/utils/render','@html_editor/others/embedded_components/core/table_of_content/table_of_content_manager'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{_t}=require("@web/core/l10n/translation");const{renderToElement}=require("@web/core/utils/render");const{HEADINGS,TableOfContentManager,}=require("@html_editor/others/embedded_components/core/table_of_content/table_of_content_manager");const TableOfContentPlugin=__exports.TableOfContentPlugin=class TableOfContentPlugin extends Plugin{static id="tableOfContent";static dependencies=["dom","selection","embeddedComponents","link","history"];resources={user_commands:[{id:"insertTableOfContent",title:_t("Table Of Content"),description:_t("Highlight the structure (headings) of this field"),icon:"fa-bookmark",run:this.insertTableOfContent.bind(this),},],powerbox_items:[{categoryId:"navigation",commandId:"insertTableOfContent",},],restore_savepoint_handlers:()=>this.delayedUpdateTableOfContents(this.editable),history_reset_handlers:()=>this.delayedUpdateTableOfContents(this.editable),history_reset_from_steps_handlers:()=>this.delayedUpdateTableOfContents(this.editable),step_added_handlers:({stepCommonAncestor})=>this.delayedUpdateTableOfContents(stepCommonAncestor),external_step_added_handlers:this.delayedUpdateTableOfContents.bind(this,this.editable),clean_for_save_handlers:this.cleanForSave.bind(this),mount_component_handlers:this.setupNewToc.bind(this),system_classes:["o_embedded_toc_header_highlight"],};setup(){this.manager=new TableOfContentManager({el:this.editable,});this.alive=true;}
insertTableOfContent(){const tableOfContentBlueprint=renderToElement("html_editor.TableOfContentBlueprint");this.dependencies.dom.insert(tableOfContentBlueprint);this.dependencies.history.addStep();}
cleanForSave({root}){for(const el of root.querySelectorAll(".o_embedded_toc_header_highlight")){el.classList.remove("o_embedded_toc_header_highlight");}}
destroy(){super.destroy();this.alive=false;}
delayedUpdateTableOfContents(element){const selector=HEADINGS.join(",");if(!(!element||element.querySelector(selector)||element.closest(selector))){return;}
if(this.updateTimeout){window.clearTimeout(this.updateTimeout);}
this.updateTimeout=window.setTimeout(()=>{if(!this.alive){return;}
this.manager.updateStructure();},500);}
setupNewToc({name,props}){if(name==="tableOfContent"){Object.assign(props,{manager:this.manager,});}}}
return __exports;});;

/* /html_editor/static/src/others/embedded_components/plugins/video_plugin/video_plugin.js */
odoo.define('@html_editor/others/embedded_components/plugins/video_plugin/video_plugin',['@html_editor/plugin','@web/core/l10n/translation','@html_editor/others/embedded_components/plugins/video_plugin/video_selector_dialog/video_selector_dialog','@web/core/utils/render'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{_t}=require("@web/core/l10n/translation");const{VideoSelectorDialog}=require("@html_editor/others/embedded_components/plugins/video_plugin/video_selector_dialog/video_selector_dialog");const{renderToElement}=require("@web/core/utils/render");const VideoPlugin=__exports.VideoPlugin=class VideoPlugin extends Plugin{static id="video";static dependencies=["embeddedComponents","dom","selection","link","history"];resources={user_commands:[{id:"openVideoSelectorDialog",title:_t("Video Link"),description:_t("Insert a Video"),icon:"fa-play",run:()=>{this.openVideoSelectorDialog((media)=>{this.insertVideo(media);});},},],powerbox_items:[{categoryId:"navigation",commandId:"openVideoSelectorDialog",},],};insertVideo(media){const videoBlock=renderToElement("html_editor.EmbeddedVideoBlueprint",{embeddedProps:JSON.stringify({videoId:media.videoId,platform:media.platform,params:media.params||{},}),});this.dependencies.dom.insert(videoBlock);this.dependencies.history.addStep();}
openVideoSelectorDialog(save){const selection=this.dependencies.selection.getEditableSelection();let restoreSelection=()=>{this.dependencies.selection.setSelection(selection);};this.services.dialog.add(VideoSelectorDialog,{save:(media)=>{save(media);restoreSelection=()=>{};},},{onClose:()=>{restoreSelection();},});}}
return __exports;});;

/* /html_editor/static/src/others/embedded_components/plugins/video_plugin/video_selector_dialog/video_selector_dialog.js */
odoo.define('@html_editor/others/embedded_components/plugins/video_plugin/video_selector_dialog/video_selector_dialog',['@html_editor/main/media/media_dialog/video_selector','@web/core/dialog/dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{VideoSelector}=require("@html_editor/main/media/media_dialog/video_selector");const{Dialog}=require("@web/core/dialog/dialog");const{Component,useState}=require("@odoo/owl");const VideoSelectorDialog=__exports.VideoSelectorDialog=class VideoSelectorDialog extends Component{static template="html_editor.VideoSelectorDialog";static components={Dialog,VideoSelector};static props={save:{type:Function},close:{type:Function},};setup(){super.setup();this.media={};this.state=useState({enableInsertVideoButton:false,});}
selectMedia(media){this.media=media;this.state.enableInsertVideoButton=!!this.media.src;}
onInsertVideoBtnClick(event){this.props.save(this.media);this.props.close();}}
return __exports;});;

/* /html_editor/static/src/others/qweb_picker.js */
odoo.define('@html_editor/others/qweb_picker',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const QWebPicker=__exports.QWebPicker=class QWebPicker extends Component{static template="html_editor.QWebPicker";static props=["groups","select"];setup(){this.state=useState({groups:this.props.groups});}
onChange(ev){const[groupIndex,elementIndex]=ev.target.value.split(",");this.props.select(this.state.groups[groupIndex][elementIndex].node);}}
return __exports;});;

/* /html_editor/static/src/others/qweb_plugin.js */
odoo.define('@html_editor/others/qweb_plugin',['@html_editor/plugin','@html_editor/utils/dom_traversal','@html_editor/utils/position','@html_editor/others/qweb_picker','@html_editor/utils/dom_info'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{closestElement,selectElements}=require("@html_editor/utils/dom_traversal");const{leftPos,rightPos}=require("@html_editor/utils/position");const{QWebPicker}=require("@html_editor/others/qweb_picker");const{isElement}=require("@html_editor/utils/dom_info");const isUnsplittableQWebElement=(node)=>isElement(node)&&(node.tagName==="T"||["t-field","t-if","t-elif","t-else","t-foreach","t-value","t-esc","t-out","t-raw",].some((attr)=>node.getAttribute(attr)));const PROTECTED_QWEB_SELECTOR="[t-esc], [t-raw], [t-out], [t-field]";const QWebPlugin=__exports.QWebPlugin=class QWebPlugin extends Plugin{static id="qweb";static dependencies=["overlay","protectedNode","selection"];resources={selectionchange_handlers:this.onSelectionChange.bind(this),clean_handlers:this.clearDataAttributes.bind(this),clean_for_save_handlers:({root})=>{this.clearDataAttributes(root);for(const element of root.querySelectorAll(PROTECTED_QWEB_SELECTOR)){element.removeAttribute("contenteditable");delete element.dataset.oeProtected;}},normalize_handlers:this.normalize.bind(this),savable_mutation_record_predicates:this.isMutationRecordSavable.bind(this),unremovable_node_predicates:(node)=>node.getAttribute?.("t-set")||node.getAttribute?.("t-call"),unsplittable_node_predicates:isUnsplittableQWebElement,};setup(){this.editable.classList.add("odoo-editor-qweb");this.picker=this.dependencies.overlay.createOverlay(QWebPicker,{positionOptions:{position:"top-start"},});this.addDomListener(this.editable,"click",this.onClick);this.groupIndex=0;}
isMutationRecordSavable(mutationRecord){if(mutationRecord.type==="attributes"){if(["data-oe-t-group","data-oe-t-inline","data-oe-t-selectable","data-oe-t-group-active",].includes(mutationRecord.attributeName)){return false;}}
return true;}
isValidTargetForDomListener(ev){if(ev.type==="click"&&ev.target&&closestElement(ev.target,PROTECTED_QWEB_SELECTOR)){return true;}
return super.isValidTargetForDomListener(ev);}
onSelectionChange(){if(this.picker.isOpen){this.picker.close();}}
normalize(root){this.normalizeInline(root);for(const element of selectElements(root,PROTECTED_QWEB_SELECTOR)){this.dependencies.protectedNode.setProtectingNode(element,true);}
this.applyGroupQwebBranching(root);}
checkAllInline(el){return[...el.children].every((child)=>{if(child.tagName==="T"){return this.checkAllInline(child);}else{return(child.nodeType!==Node.ELEMENT_NODE||this.document.defaultView.getComputedStyle(child).display==="inline");}});}
normalizeInline(root){for(const el of selectElements(root,"t")){if(this.checkAllInline(el)){el.setAttribute("data-oe-t-inline","true");}}}
getNodeGroups(node){const branchNode=node.closest("[data-oe-t-group]");if(!branchNode){return[];}
const groupId=branchNode.getAttribute("data-oe-t-group");const group=[];for(const node of branchNode.parentElement.querySelectorAll(`[data-oe-t-group='${groupId}']`)){let label="";if(node.hasAttribute("t-if")){label=`if: ${node.getAttribute("t-if")}`;}else if(node.hasAttribute("t-elif")){label=`elif: ${node.getAttribute("t-elif")}`;}else if(node.hasAttribute("t-else")){label="else";}
group.push({groupId,node,label,isActive:node.getAttribute("data-oe-t-group-active")==="true",});}
return this.getNodeGroups(branchNode.parentElement).concat([group]);}
onClick(ev){if(this.picker.isOpen){this.picker.close();}
if(ev.detail>1){const selectionData=this.dependencies.selection.getSelectionData();const selection=selectionData.documentSelection;const qwebNode=selection&&selection.anchorNode&&closestElement(selection.anchorNode,"[t-field],[t-esc],[t-out]");if(qwebNode&&this.editable.contains(qwebNode)){const[anchorNode,anchorOffset]=leftPos(qwebNode);const[focusNode,focusOffset]=rightPos(qwebNode);this.dependencies.selection.setSelection({anchorNode,anchorOffset,focusNode,focusOffset,});}}
const targetNode=ev.target;if(targetNode.closest("[data-oe-t-group]")){this.selectNode(targetNode);}}
selectNode(node){const editableSelection=this.dependencies.selection.getSelectionData().editableSelection;if(!editableSelection.isCollapsed){return;}
this.selectedNode=node;this.picker.open({target:node,props:{groups:this.getNodeGroups(node),select:this.select.bind(this),},});}
applyGroupQwebBranching(root){const tNodes=selectElements(root,"[t-if], [t-elif], [t-else]");const groupsEncounter=new Set();for(const node of tNodes){const prevNode=node.previousElementSibling;let groupId;if(prevNode&&!node.hasAttribute("t-if")){prevNode.setAttribute("data-oe-t-selectable","true");groupId=parseInt(prevNode.getAttribute("data-oe-t-group"));node.setAttribute("data-oe-t-selectable","true");}else{groupId=this.groupIndex++;}
groupsEncounter.add(groupId);node.setAttribute("data-oe-t-group",groupId);}
for(const groupId of groupsEncounter){const isOneElementActive=root.querySelector(`[data-oe-t-group='${groupId}'][data-oe-t-group-active]`);if(!isOneElementActive){const firstElementToActivate=selectElements(root,`[data-oe-t-group='${groupId}']`).next().value;firstElementToActivate.setAttribute("data-oe-t-group-active","true");}}}
select(node){const groupId=node.getAttribute("data-oe-t-group");const activeElement=node.parentElement.querySelector(`[data-oe-t-group='${groupId}'][data-oe-t-group-active]`);if(activeElement===node){return;}
activeElement.removeAttribute("data-oe-t-group-active");node.setAttribute("data-oe-t-group-active","true");this.selectedNode=node;this.picker.close();this.selectNode(node);}
clearDataAttributes(root){for(const node of root.querySelectorAll("[data-oe-t-group], [data-oe-t-inline], [data-oe-t-selectable], [data-oe-t-group-active]")){node.removeAttribute("data-oe-t-group-active");node.removeAttribute("data-oe-t-group");node.removeAttribute("data-oe-t-inline");node.removeAttribute("data-oe-t-selectable");}}}
return __exports;});;

/* /html_editor/static/src/others/x2many_image_field.js */
odoo.define('@html_editor/others/x2many_image_field',['@web/core/registry','@web/core/utils/hooks','@web/views/fields/image/image_field','@html_editor/others/custom_media_dialog','@html_editor/utils/url'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{ImageField,imageField}=require("@web/views/fields/image/image_field");const{CustomMediaDialog}=require("@html_editor/others/custom_media_dialog");const{getVideoUrl}=require("@html_editor/utils/url");const X2ManyImageField=__exports.X2ManyImageField=class X2ManyImageField extends ImageField{static template="html_editor.ImageField";setup(){super.setup();this.orm=useService("orm");this.dialog=useService("dialog");}
onFileEdit(ev){const isVideo=this.props.record.data.video_url;let mediaEl;if(isVideo){mediaEl=document.createElement("img");mediaEl.dataset.src=this.props.record.data.video_url;}
this.dialog.add(CustomMediaDialog,{noIcons:true,media:mediaEl,activeTab:isVideo?"VIDEOS":"IMAGES",save:(el)=>{},imageSave:this.onImageSave.bind(this),videoSave:this.onVideoSave.bind(this),});}
async onImageSave(attachment){const attachmentRecord=await this.orm.searchRead("ir.attachment",[["id","=",attachment[0].id]],["id","datas","name"],{});if(!attachmentRecord[0].datas){return this.notification.add(`Cannot add URL type attachment "${attachmentRecord[0].name}". Please try to reupload this image.`,{type:"warning",});}
await this.props.record.update({[this.props.name]:attachmentRecord[0].datas,name:attachmentRecord[0].name,});}
async onVideoSave(videoInfo){const url=getVideoUrl(videoInfo[0].platform,videoInfo[0].videoId,videoInfo[0].params);await this.props.record.update({video_url:url.href,name:videoInfo[0].platform+" - [Video]",});}
onFileRemove(){const parentRecord=this.props.record._parentRecord.data;parentRecord[this.env.parentField].delete(this.props.record);}}
const x2ManyImageField=__exports.x2ManyImageField={...imageField,component:X2ManyImageField,};registry.category("fields").add("x2_many_image",x2ManyImageField);return __exports;});;

/* /html_editor/static/src/others/x2many_media_viewer.js */
odoo.define('@html_editor/others/x2many_media_viewer',['@web/core/registry','@web/core/utils/hooks','@web/views/fields/x2many/x2many_field','@html_editor/utils/url','@odoo/owl','@html_editor/others/custom_media_dialog'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const{getVideoUrl}=require("@html_editor/utils/url");const{useChildSubEnv}=require("@odoo/owl");const{CustomMediaDialog}=require("@html_editor/others/custom_media_dialog");const X2ManyMediaViewer=__exports.X2ManyMediaViewer=class X2ManyMediaViewer extends X2ManyField{static template="html_editor.X2ManyMediaViewer";static props={...X2ManyField.props,convertToWebp:{type:Boolean,optional:true},};setup(){super.setup();this.dialogs=useService("dialog");this.orm=useService("orm");this.notification=useService("notification");this.supportedFields=["image_1920","image_1024","image_512","image_256","image_128"];useChildSubEnv({parentField:this.props.name,});}
addMedia(){this.dialogs.add(CustomMediaDialog,{save:(el)=>{},multiImages:true,noIcons:true,imageSave:this.onImageSave.bind(this),videoSave:this.onVideoSave.bind(this),});}
onVideoSave(videoInfo){const url=getVideoUrl(videoInfo[0].platform,videoInfo[0].videoId,videoInfo[0].params);const videoList=this.props.record.data[this.props.name];videoList.addNewRecord({position:"bottom"}).then((record)=>{record.update({name:videoInfo[0].platform+" - [Video]",video_url:url.href});});}
async onImageSave(attachments){const attachmentIds=attachments.map((attachment)=>attachment.id);const attachmentRecords=await this.orm.searchRead("ir.attachment",[["id","in",attachmentIds]],["id","datas","name","mimetype"],{});for(let attachment of attachmentRecords){const imageList=this.props.record.data[this.props.name];if(!attachment.datas){return this.notification.add(`Cannot add URL type attachment "${attachment.name}". Please try to reupload this image.`,{type:"warning",});}
if(this.props.convertToWebp&&!["image/gif","image/svg+xml"].includes(attachment.mimetype)){const image=document.createElement("img");image.src=`data:${attachment.mimetype};base64,${attachment.datas}`;await new Promise((resolve)=>image.addEventListener("load",resolve));const originalSize=Math.max(image.width,image.height);const smallerSizes=[1024,512,256,128].filter((size)=>size<originalSize);let referenceId=undefined;for(const size of[originalSize,...smallerSizes]){const ratio=size/originalSize;const canvas=document.createElement("canvas");canvas.width=image.width*ratio;canvas.height=image.height*ratio;const ctx=canvas.getContext("2d");ctx.drawImage(image,0,0,image.width,image.height,0,0,canvas.width,canvas.height);const webpData=canvas.toDataURL("image/webp",0.75).split(",")[1];const[resizedId]=await this.orm.call("ir.attachment","create_unique",[[{name:attachment.name.replace(/\.[^/.]+$/,".webp"),description:size===originalSize?"":`resize: ${size}`,datas:webpData,res_id:referenceId,res_model:"ir.attachment",mimetype:"image/webp",},],]);referenceId=referenceId||resizedId;const jpegData=canvas.toDataURL("image/jpeg",0.75).split(",")[1];await this.orm.call("ir.attachment","create_unique",[[{name:attachment.name.replace(/\.[^/.]+$/,".jpg"),description:`resize: ${size} - format: jpeg`,datas:jpegData,res_id:resizedId,res_model:"ir.attachment",mimetype:"image/jpeg",}],]);}
const canvas=document.createElement("canvas");canvas.width=image.width;canvas.height=image.height;const ctx=canvas.getContext("2d");ctx.drawImage(image,0,0,image.width,image.height);const webpData=canvas.toDataURL("image/webp",0.75).split(",")[1];attachment.datas=webpData;attachment.mimetype="image/webp";attachment.name=attachment.name.replace(/\.[^/.]+$/,".webp");}
imageList.addNewRecord({position:"bottom"}).then((record)=>{const activeFields=imageList.activeFields;const updateData={};for(const field in activeFields){if(attachment.datas&&this.supportedFields.includes(field)){updateData[field]=attachment.datas;updateData["name"]=attachment.name;}}
record.update(updateData);});}}
async onAdd({context,editable}={}){this.addMedia();}}
const x2ManyMediaViewer=__exports.x2ManyMediaViewer={...x2ManyField,component:X2ManyMediaViewer,extractProps:({attrs,relatedFields,viewMode,views,widget,options,string},dynamicInfo)=>{const x2ManyFieldProps=x2ManyField.extractProps({attrs,relatedFields,viewMode,views,widget,options,string},dynamicInfo);return{...x2ManyFieldProps,convertToWebp:options.convert_to_webp,};},};registry.category("fields").add("x2_many_media_viewer",x2ManyMediaViewer);return __exports;});;

/* /html_editor/static/src/plugin.js */
odoo.define('@html_editor/plugin',['@html_editor/utils/dom_info'],function(require){'use strict';let __exports={};const{isProtected,isProtecting,isUnprotecting}=require("@html_editor/utils/dom_info");const Plugin=__exports.Plugin=class Plugin{static id="";static dependencies=[];static shared=[];constructor(document,editable,dependencies,config,services){this.document=document;this.editable=editable;this.config=config;this.services=services;this.dependencies=dependencies;this._cleanups=[];this._resources=null;this.isDestroyed=false;}
setup(){}
isValidTargetForDomListener(ev){return!isProtecting(ev.target)&&(!isProtected(ev.target)||isUnprotecting(ev.target));}
addDomListener(target,eventName,fn,capture=false){const handler=(ev)=>{if(this.isValidTargetForDomListener(ev)){fn?.call(this,ev);}};target.addEventListener(eventName,handler,capture);this._cleanups.push(()=>target.removeEventListener(eventName,handler,capture));}
getResource(resourceId){return this._resources[resourceId]||[];}
dispatchTo(resourceId,...args){this.getResource(resourceId).forEach((handler)=>handler(...args));}
delegateTo(resourceId,...args){return this.getResource(resourceId).some((fn)=>fn(...args));}
destroy(){for(const cleanup of this._cleanups){cleanup();}
this.isDestroyed=true;}}
return __exports;});;

/* /html_editor/static/src/plugin_sets.js */
odoo.define('@html_editor/plugin_sets',['@html_editor/core/base_container_plugin','@html_editor/core/clipboard_plugin','@html_editor/core/comment_plugin','@html_editor/core/delete_plugin','@html_editor/core/dialog_plugin','@html_editor/core/dom_plugin','@html_editor/core/format_plugin','@html_editor/core/history_plugin','@html_editor/core/input_plugin','@html_editor/core/line_break_plugin','@html_editor/core/no_inline_root_plugin','@html_editor/core/overlay_plugin','@html_editor/core/protected_node_plugin','@html_editor/core/sanitize_plugin','@html_editor/core/selection_plugin','@html_editor/core/shortcut_plugin','@html_editor/core/split_plugin','@html_editor/core/user_command_plugin','@html_editor/main/align_plugin','@html_editor/main/banner_plugin','@html_editor/main/chatgpt/chatgpt_plugin','@html_editor/main/column_plugin','@html_editor/main/emoji_plugin','@html_editor/main/font/color_plugin','@html_editor/main/feff_plugin','@html_editor/main/font/font_plugin','@html_editor/main/hint_plugin','@html_editor/main/inline_code','@html_editor/main/link/link_paste_plugin','@html_editor/main/link/link_plugin','@html_editor/main/link/link_selection_odoo_plugin','@html_editor/main/link/link_selection_plugin','@html_editor/main/list/list_plugin','@html_editor/main/local_overlay_plugin','@html_editor/main/media/file_plugin','@html_editor/main/media/icon_plugin','@html_editor/main/media/image_crop_plugin','@html_editor/main/media/image_plugin','@html_editor/main/media/media_plugin','@html_editor/main/movenode_plugin','@html_editor/main/power_buttons_plugin','@html_editor/main/position_plugin','@html_editor/main/powerbox/powerbox_plugin','@html_editor/main/powerbox/search_powerbox_plugin','@html_editor/main/signature_plugin','@html_editor/main/star_plugin','@html_editor/main/table/table_plugin','@html_editor/main/table/table_resize_plugin','@html_editor/main/table/table_ui_plugin','@html_editor/main/tabulation_plugin','@html_editor/main/text_direction_plugin','@html_editor/main/toolbar/toolbar_plugin','@html_editor/main/youtube_plugin','@html_editor/others/collaboration/collaboration_odoo_plugin','@html_editor/others/collaboration/collaboration_plugin','@html_editor/others/collaboration/collaboration_selection_avatar_plugin','@html_editor/others/collaboration/collaboration_selection_plugin','@html_editor/others/dynamic_placeholder_plugin','@html_editor/others/embedded_component_plugin','@html_editor/others/embedded_components/plugins/table_of_content_plugin/table_of_content_plugin','@html_editor/others/embedded_components/plugins/video_plugin/video_plugin','@html_editor/others/qweb_plugin','@html_editor/core/editor_version_plugin'],function(require){'use strict';let __exports={};const{BaseContainerPlugin}=require("@html_editor/core/base_container_plugin");const{ClipboardPlugin}=require("@html_editor/core/clipboard_plugin");const{CommentPlugin}=require("@html_editor/core/comment_plugin");const{DeletePlugin}=require("@html_editor/core/delete_plugin");const{DialogPlugin}=require("@html_editor/core/dialog_plugin");const{DomPlugin}=require("@html_editor/core/dom_plugin");const{FormatPlugin}=require("@html_editor/core/format_plugin");const{HistoryPlugin}=require("@html_editor/core/history_plugin");const{InputPlugin}=require("@html_editor/core/input_plugin");const{LineBreakPlugin}=require("@html_editor/core/line_break_plugin");const{NoInlineRootPlugin}=require("@html_editor/core/no_inline_root_plugin");const{OverlayPlugin}=require("@html_editor/core/overlay_plugin");const{ProtectedNodePlugin}=require("@html_editor/core/protected_node_plugin");const{SanitizePlugin}=require("@html_editor/core/sanitize_plugin");const{SelectionPlugin}=require("@html_editor/core/selection_plugin");const{ShortCutPlugin}=require("@html_editor/core/shortcut_plugin");const{SplitPlugin}=require("@html_editor/core/split_plugin");const{UserCommandPlugin}=require("@html_editor/core/user_command_plugin");const{AlignPlugin}=require("@html_editor/main/align_plugin");const{BannerPlugin}=require("@html_editor/main/banner_plugin");const{ChatGPTPlugin}=require("@html_editor/main/chatgpt/chatgpt_plugin");const{ColumnPlugin}=require("@html_editor/main/column_plugin");const{EmojiPlugin}=require("@html_editor/main/emoji_plugin");const{ColorPlugin}=require("@html_editor/main/font/color_plugin");const{FeffPlugin}=require("@html_editor/main/feff_plugin");const{FontPlugin}=require("@html_editor/main/font/font_plugin");const{HintPlugin}=require("@html_editor/main/hint_plugin");const{InlineCodePlugin}=require("@html_editor/main/inline_code");const{LinkPastePlugin}=require("@html_editor/main/link/link_paste_plugin");const{LinkPlugin}=require("@html_editor/main/link/link_plugin");const{OdooLinkSelectionPlugin}=require("@html_editor/main/link/link_selection_odoo_plugin");const{LinkSelectionPlugin}=require("@html_editor/main/link/link_selection_plugin");const{ListPlugin}=require("@html_editor/main/list/list_plugin");const{LocalOverlayPlugin}=require("@html_editor/main/local_overlay_plugin");const{FilePlugin}=require("@html_editor/main/media/file_plugin");const{IconPlugin}=require("@html_editor/main/media/icon_plugin");const{ImageCropPlugin}=require("@html_editor/main/media/image_crop_plugin");const{ImagePlugin}=require("@html_editor/main/media/image_plugin");const{MediaPlugin}=require("@html_editor/main/media/media_plugin");const{MoveNodePlugin}=require("@html_editor/main/movenode_plugin");const{PowerButtonsPlugin}=require("@html_editor/main/power_buttons_plugin");const{PositionPlugin}=require("@html_editor/main/position_plugin");const{PowerboxPlugin}=require("@html_editor/main/powerbox/powerbox_plugin");const{SearchPowerboxPlugin}=require("@html_editor/main/powerbox/search_powerbox_plugin");const{SignaturePlugin}=require("@html_editor/main/signature_plugin");const{StarPlugin}=require("@html_editor/main/star_plugin");const{TablePlugin}=require("@html_editor/main/table/table_plugin");const{TableResizePlugin}=require("@html_editor/main/table/table_resize_plugin");const{TableUIPlugin}=require("@html_editor/main/table/table_ui_plugin");const{TabulationPlugin}=require("@html_editor/main/tabulation_plugin");const{TextDirectionPlugin}=require("@html_editor/main/text_direction_plugin");const{ToolbarPlugin}=require("@html_editor/main/toolbar/toolbar_plugin");const{YoutubePlugin}=require("@html_editor/main/youtube_plugin");const{CollaborationOdooPlugin}=require("@html_editor/others/collaboration/collaboration_odoo_plugin");const{CollaborationPlugin}=require("@html_editor/others/collaboration/collaboration_plugin");const{CollaborationSelectionAvatarPlugin}=require("@html_editor/others/collaboration/collaboration_selection_avatar_plugin");const{CollaborationSelectionPlugin}=require("@html_editor/others/collaboration/collaboration_selection_plugin");const{DynamicPlaceholderPlugin}=require("@html_editor/others/dynamic_placeholder_plugin");const{EmbeddedComponentPlugin}=require("@html_editor/others/embedded_component_plugin");const{TableOfContentPlugin}=require("@html_editor/others/embedded_components/plugins/table_of_content_plugin/table_of_content_plugin");const{VideoPlugin}=require("@html_editor/others/embedded_components/plugins/video_plugin/video_plugin");const{QWebPlugin}=require("@html_editor/others/qweb_plugin");const{EditorVersionPlugin}=require("@html_editor/core/editor_version_plugin");const CORE_PLUGINS=__exports.CORE_PLUGINS=[BaseContainerPlugin,ClipboardPlugin,CommentPlugin,DeletePlugin,DialogPlugin,DomPlugin,EditorVersionPlugin,FormatPlugin,HistoryPlugin,InputPlugin,LineBreakPlugin,NoInlineRootPlugin,OverlayPlugin,ProtectedNodePlugin,SanitizePlugin,SelectionPlugin,SplitPlugin,UserCommandPlugin,];const MAIN_PLUGINS=__exports.MAIN_PLUGINS=[...CORE_PLUGINS,BannerPlugin,ChatGPTPlugin,ColorPlugin,ColumnPlugin,EmojiPlugin,HintPlugin,AlignPlugin,ListPlugin,MediaPlugin,ShortCutPlugin,PowerboxPlugin,SearchPowerboxPlugin,SignaturePlugin,StarPlugin,TablePlugin,TableUIPlugin,TabulationPlugin,ToolbarPlugin,FontPlugin,YoutubePlugin,IconPlugin,ImagePlugin,ImageCropPlugin,LinkPlugin,LinkPastePlugin,FeffPlugin,LinkSelectionPlugin,OdooLinkSelectionPlugin,PowerButtonsPlugin,MoveNodePlugin,LocalOverlayPlugin,PositionPlugin,TextDirectionPlugin,InlineCodePlugin,TableResizePlugin,FilePlugin,];const COLLABORATION_PLUGINS=__exports.COLLABORATION_PLUGINS=[CollaborationPlugin,CollaborationOdooPlugin,CollaborationSelectionPlugin,CollaborationSelectionAvatarPlugin,];const EMBEDDED_COMPONENT_PLUGINS=__exports.EMBEDDED_COMPONENT_PLUGINS=[EmbeddedComponentPlugin,TableOfContentPlugin,VideoPlugin,];const DYNAMIC_PLACEHOLDER_PLUGINS=__exports.DYNAMIC_PLACEHOLDER_PLUGINS=[DynamicPlaceholderPlugin,QWebPlugin];const EXTRA_PLUGINS=__exports.EXTRA_PLUGINS=[...COLLABORATION_PLUGINS,...MAIN_PLUGINS,...EMBEDDED_COMPONENT_PLUGINS,QWebPlugin,];return __exports;});;

/* /html_editor/static/src/position_hook.js */
odoo.define('@html_editor/position_hook',['@html_editor/utils/dom_traversal','@web/core/utils/timing','@web/core/utils/scrolling','@odoo/owl'],function(require){'use strict';let __exports={};const{ancestors}=require("@html_editor/utils/dom_traversal");const{throttleForAnimation}=require("@web/core/utils/timing");const{couldBeScrollableX,couldBeScrollableY}=require("@web/core/utils/scrolling");const{useComponent,useEffect}=require("@odoo/owl");__exports.usePositionHook=usePositionHook;function usePositionHook(containerRef,document,callback){const comp=useComponent();const onLayoutGeometryChange=throttleForAnimation(callback.bind(comp));const resizeObserver=new ResizeObserver(onLayoutGeometryChange);const cleanups=[];const addDomListener=(target,eventName,capture)=>{target.addEventListener(eventName,onLayoutGeometryChange,capture);cleanups.push(()=>target.removeEventListener(eventName,onLayoutGeometryChange,capture));};useEffect(()=>{if(containerRef.el){resizeObserver.observe(document.body);resizeObserver.observe(containerRef.el);addDomListener(window,"resize");if(document.defaultView!==window){addDomListener(document.defaultView,"resize");}
const scrollableElements=[containerRef.el,...ancestors(containerRef.el)].filter((node)=>{return couldBeScrollableX(node)||couldBeScrollableY(node);});for(const scrollableElement of scrollableElements){addDomListener(scrollableElement,"scroll");resizeObserver.observe(scrollableElement);}}
return()=>{resizeObserver.disconnect();for(const cleanup of cleanups.toReversed()){cleanup();cleanups.pop();}};},()=>[containerRef.el]);}
return __exports;});;

/* /html_editor/static/src/services/upload_local_files_service.js */
odoo.define('@html_editor/services/upload_local_files_service',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const uploadLocalFileService=__exports.uploadLocalFileService={dependencies:["upload","orm"],start(env,{upload:uploadService,orm}){const input=document.createElement("input");input.type="file";async function selectLocalFiles({multiple,accept}){input.multiple=multiple;input.accept=accept;input.click();await new Promise((resolve)=>{const resolveAndClear=()=>{resolve();input.removeEventListener("change",resolveAndClear);input.removeEventListener("cancel",resolveAndClear);};input.addEventListener("change",resolveAndClear);input.addEventListener("cancel",resolveAndClear);});return input.files;}
async function filesToAttachments(files,{resModel,resId}){const attachments=[];await uploadService.uploadFiles(files,{resModel,resId},(attachment)=>{attachments.push(attachment);});return attachments;}
async function upload({resId,resModel},{accept="*/*",multiple=false,accessToken=false}={}){try{const files=await selectLocalFiles({multiple,accept});const attachments=await filesToAttachments(files,{resModel,resId});if(accessToken&&attachments.length&&!attachments[0].public){await addAccessToken(attachments);}
return attachments;}catch{return[];}}
async function addAccessToken(attachments){const accessTokens=await orm.call("ir.attachment","generate_access_token",[attachments.map((a)=>a.id),]);attachments.forEach((attachment,index)=>{attachment.access_token=accessTokens[index];});return attachments;}
function getURL(attachment,{unique,download,accessToken}={}){let url=`/web/content/${attachment.id}`;const queryParams=[];if(unique){queryParams.push(`unique=${encodeURIComponent(attachment.checksum)}`);}
if(download){queryParams.push("download=true");}
if(accessToken&&attachment.access_token){queryParams.push(`access_token=${attachment.access_token}`);}
if(queryParams.length){url+=`?${queryParams.join("&")}`;}
return url;}
return{upload,addAccessToken,getURL};},};registry.category("services").add("uploadLocalFiles",uploadLocalFileService);return __exports;});;

/* /html_editor/static/src/utils/base_container.js */
odoo.define('@html_editor/utils/base_container',[],function(require){'use strict';let __exports={};const BASE_CONTAINER_CLASS=__exports.BASE_CONTAINER_CLASS="o-paragraph";const SUPPORTED_BASE_CONTAINER_NAMES=__exports.SUPPORTED_BASE_CONTAINER_NAMES=["P","DIV"];__exports.getBaseContainerSelector=getBaseContainerSelector;function getBaseContainerSelector(nodeName){if(!nodeName){return baseContainerGlobalSelector;}
nodeName=SUPPORTED_BASE_CONTAINER_NAMES.includes(nodeName)?nodeName:"P";let suffix="";if(nodeName!=="P"){suffix=`.${BASE_CONTAINER_CLASS}`;}
return`${nodeName}${suffix}`;}
const baseContainerGlobalSelector=__exports.baseContainerGlobalSelector=SUPPORTED_BASE_CONTAINER_NAMES.map((name)=>getBaseContainerSelector(name)).join(",");__exports.createBaseContainer=createBaseContainer;function createBaseContainer(nodeName,document){if(!document&&window){document=window.document;}
nodeName=nodeName&&SUPPORTED_BASE_CONTAINER_NAMES.includes(nodeName)?nodeName:"P";const el=document.createElement(nodeName);if(nodeName!=="P"){el.className=BASE_CONTAINER_CLASS;}
return el;}
return __exports;});;

/* /html_editor/static/src/utils/blocks.js */
odoo.define('@html_editor/utils/blocks',['@html_editor/utils/dom_traversal'],function(require){'use strict';let __exports={};const{closestPath,findNode}=require("@html_editor/utils/dom_traversal");const blockTagNames=["ADDRESS","ARTICLE","ASIDE","BLOCKQUOTE","DETAILS","DIALOG","DD","DIV","DL","DT","FIELDSET","FIGCAPTION","FIGURE","FOOTER","FORM","H1","H2","H3","H4","H5","H6","HEADER","HGROUP","HR","LI","MAIN","NAV","OL","P","PRE","SECTION","TABLE","UL","SELECT","OPTION","TR","TD","TBODY","THEAD","TH",];const computedStyles=new WeakMap();__exports.isBlock=isBlock;function isBlock(node){if(!node||node.nodeType!==Node.ELEMENT_NODE){return false;}
const tagName=node.nodeName.toUpperCase();if(tagName==="BR"){return false;}
if(!node.isConnected){return blockTagNames.includes(tagName);}
let style=computedStyles.get(node);if(!style){style=node.ownerDocument.defaultView.getComputedStyle(node);computedStyles.set(node,style);}
if(style.display){return!style.display.includes("inline")&&style.display!=="contents";}
return blockTagNames.includes(tagName);}
__exports.closestBlock=closestBlock;function closestBlock(node){return findNode(closestPath(node),(node)=>isBlock(node));}
return __exports;});;

/* /html_editor/static/src/utils/color.js */
odoo.define('@html_editor/utils/color',['@html_editor/utils/dom_traversal'],function(require){'use strict';let __exports={};const{closestElement}=require("@html_editor/utils/dom_traversal");const COLOR_PALETTE_COMPATIBILITY_COLOR_NAMES=__exports.COLOR_PALETTE_COMPATIBILITY_COLOR_NAMES=["primary","secondary","alpha","beta","gamma","delta","epsilon","success","info","warning","danger",];const DEFAULT_PALETTE=__exports.DEFAULT_PALETTE={1:"#3AADAA",2:"#7C6576",3:"#F6F6F6",4:"#FFFFFF",5:"#383E45",};const EDITOR_COLOR_CSS_VARIABLES=__exports.EDITOR_COLOR_CSS_VARIABLES=[...COLOR_PALETTE_COMPATIBILITY_COLOR_NAMES];for(let i=1;i<=5;i++){EDITOR_COLOR_CSS_VARIABLES.push(`o-color-${i}`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-bg`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-bg-gradient`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-headings`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-text`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-btn-primary`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-btn-primary-text`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-btn-secondary`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-btn-secondary-text`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-btn-primary-border`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-btn-secondary-border`);}
for(let i=100;i<=900;i+=100){EDITOR_COLOR_CSS_VARIABLES.push(`${i}`);}
const RGBA_REGEX=__exports.RGBA_REGEX=/[\d.]{1,5}/g;__exports.rgbToHex=rgbToHex;function rgbToHex(rgb="",node=null){if(rgb.startsWith("#")){return rgb;}else if(rgb.startsWith("rgba")){const values=rgb.match(RGBA_REGEX)||[];const alpha=parseFloat(values.pop());let bgRgbValues=[];if(node){let bgColor=getComputedStyle(node).backgroundColor;if(bgColor.startsWith("rgba")){bgColor=rgbToHex(bgColor,node.parentElement);}
if(bgColor&&bgColor.startsWith("#")){bgRgbValues=(bgColor.match(/[\da-f]{2}/gi)||[]).map((val)=>parseInt(val,16));}else if(bgColor&&bgColor.startsWith("rgb")){bgRgbValues=(bgColor.match(RGBA_REGEX)||[]).map((val)=>parseInt(val));}}
bgRgbValues=bgRgbValues.length?bgRgbValues:[255,255,255];return("#"+
values.map((value,index)=>{const converted=Math.floor(alpha*parseInt(value)+(1-alpha)*bgRgbValues[index]);const hex=parseInt(converted).toString(16);return hex.length===1?"0"+hex:hex;}).join(""));}else{return("#"+
(rgb.match(/\d{1,3}/g)||[]).map((x)=>{x=parseInt(x).toString(16);return x.length===1?"0"+x:x;}).join(""));}}
__exports.rgbaToHex=rgbaToHex;function rgbaToHex(rgba=""){if(rgba.startsWith("#")){return rgba;}else if(rgba.startsWith("rgba")){const values=rgba.match(/[\d.]{1,5}/g)||[];const alpha=values.length===4?parseFloat(values.pop()):1;const hexRgb=values.map((value)=>{const hex=parseInt(value).toString(16);return hex.length===1?"0"+hex:hex;}).join("");const hexAlpha=Math.round(alpha*255).toString(16);const finalAlpha=hexAlpha.length===1?"0"+hexAlpha:hexAlpha;return"#"+hexRgb+finalAlpha;}else{return("#"+
(rgba.match(/\d{1,3}/g)||[]).map((x)=>{x=parseInt(x).toString(16);return x.length===1?"0"+x:x;}).join(""));}}
__exports.blendColors=blendColors;function blendColors(color,node){if(!color.startsWith("rgba")){return rgbaToHex(color);}
let bgRgbValues=[255,255,255];if(node){let bgColor=getComputedStyle(node).backgroundColor;if(bgColor.startsWith("rgba")){bgColor=blendColors(bgColor,node.parentElement);}
if(bgColor.startsWith("#")){bgRgbValues=(bgColor.match(/[\da-f]{2}/gi)||[]).map((val)=>parseInt(val,16));}else if(bgColor.startsWith("rgb")){bgRgbValues=(bgColor.match(/[\d.]{1,5}/g)||[]).map((val)=>parseInt(val));}}
const values=color.match(/[\d.]{1,5}/g)||[];const alpha=values.length===4?parseFloat(values.pop()):1;return("#"+
values.map((value,index)=>{const converted=Math.round(alpha*parseInt(value)+(1-alpha)*bgRgbValues[index]);const hex=parseInt(converted).toString(16);return hex.length===1?"0"+hex:hex;}).join(""));}
__exports.isColorCombinationName=isColorCombinationName;function isColorCombinationName(name){const number=parseInt(name);return!isNaN(number)&&number%100!==0;}
__exports.isColorGradient=isColorGradient;function isColorGradient(value){return value&&value.includes("-gradient(");}
const TEXT_CLASSES_REGEX=__exports.TEXT_CLASSES_REGEX=/\btext-[^\s]*\b/;const BG_CLASSES_REGEX=__exports.BG_CLASSES_REGEX=/\bbg-[^\s]*\b/;__exports.hasColor=hasColor;function hasColor(element,mode){const style=element.style;const parent=element.parentNode;const classRegex=mode==="color"?TEXT_CLASSES_REGEX:BG_CLASSES_REGEX;if(isColorGradient(style["background-image"])){if(element.classList.contains("text-gradient")){if(mode==="color"){return true;}}else{if(mode!=="color"){return true;}}}
return((style[mode]&&style[mode]!=="inherit"&&(!parent||style[mode]!==parent.style[mode]))||(classRegex.test(element.className)&&(!parent||getComputedStyle(element)[mode]!==getComputedStyle(parent)[mode])));}
__exports.hasAnyNodesColor=hasAnyNodesColor;function hasAnyNodesColor(nodes,mode){for(const node of nodes){if(hasColor(closestElement(node),mode)){return true;}}
return false;}
return __exports;});;

/* /html_editor/static/src/utils/content_types.js */
odoo.define('@html_editor/utils/content_types',[],function(require){'use strict';let __exports={};const CTYPES=__exports.CTYPES={CONTENT:1,SPACE:2,BLOCK_OUTSIDE:4,BLOCK_INSIDE:8,BR:16,};__exports.ctypeToString=ctypeToString;function ctypeToString(ctype){return Object.keys(CTYPES).find((key)=>CTYPES[key]===ctype);}
const CTGROUPS=__exports.CTGROUPS={INLINE:CTYPES.CONTENT|CTYPES.SPACE,BLOCK:CTYPES.BLOCK_OUTSIDE|CTYPES.BLOCK_INSIDE,BR:CTYPES.BR,};return __exports;});;

/* /html_editor/static/src/utils/dom.js */
odoo.define('@html_editor/utils/dom',['@html_editor/utils/blocks','@html_editor/utils/dom_info','@html_editor/utils/selection','@html_editor/utils/dom_traversal','@html_editor/utils/position','@html_editor/utils/base_container'],function(require){'use strict';let __exports={};const{closestBlock,isBlock}=require("@html_editor/utils/blocks");const{isParagraphRelatedElement,isShrunkBlock,isVisible}=require("@html_editor/utils/dom_info");const{callbacksForCursorUpdate}=require("@html_editor/utils/selection");const{isEmptyBlock,isPhrasingContent}=require("@html_editor/utils/dom_info");const{childNodes}=require("@html_editor/utils/dom_traversal");const{childNodeIndex,DIRECTIONS}=require("@html_editor/utils/position");const{baseContainerGlobalSelector,createBaseContainer,}=require("@html_editor/utils/base_container");__exports.makeContentsInline=makeContentsInline;function makeContentsInline(node){const document=node.ownerDocument;let childIndex=0;for(const child of node.childNodes){if(isBlock(child)){if(childIndex&&isParagraphRelatedElement(child)){child.before(document.createElement("br"));}
for(const grandChild of child.childNodes){child.before(grandChild);makeContentsInline(grandChild);}
child.remove();}
childIndex+=1;}}
__exports.wrapInlinesInBlocks=wrapInlinesInBlocks;function wrapInlinesInBlocks(element,{baseContainerNodeName="P",cursors={update:()=>{}}}={}){const wrapInBlock=(node,cursors)=>{const block=isPhrasingContent(node)?createBaseContainer(baseContainerNodeName,node.ownerDocument):node.ownerDocument.createElement("DIV");cursors.update(callbacksForCursorUpdate.append(block,node));cursors.update(callbacksForCursorUpdate.before(node,block));if(node.nextSibling){const sibling=node.nextSibling;node.remove();sibling.before(block);}else{const parent=node.parentElement;node.remove();parent.append(block);}
block.append(node);return block;};const appendToCurrentBlock=(currentBlock,node,cursors)=>{if(currentBlock.matches(baseContainerGlobalSelector)&&!isPhrasingContent(node)){const block=currentBlock.ownerDocument.createElement("DIV");cursors.update(callbacksForCursorUpdate.before(currentBlock,block));currentBlock.before(block);for(const child of childNodes(currentBlock)){cursors.update(callbacksForCursorUpdate.append(block,child));block.append(child);}
cursors.update(callbacksForCursorUpdate.remove(currentBlock));currentBlock.remove();currentBlock=block;}
cursors.update(callbacksForCursorUpdate.append(currentBlock,node));currentBlock.append(node);return currentBlock;};const removeNode=(node,cursors)=>{cursors.update(callbacksForCursorUpdate.remove(node));node.remove();};const children=childNodes(element);const visibleNodes=new Set(children.filter(isVisible));let currentBlock;let shouldBreakLine=true;for(const node of children){if(isBlock(node)){shouldBreakLine=true;}else if(!visibleNodes.has(node)){removeNode(node,cursors);}else if(node.nodeName==="BR"){if(shouldBreakLine){wrapInBlock(node,cursors);}else{removeNode(node,cursors);shouldBreakLine=true;}}else if(shouldBreakLine){currentBlock=wrapInBlock(node,cursors);shouldBreakLine=false;}else{currentBlock=appendToCurrentBlock(currentBlock,node,cursors);}}}
__exports.unwrapContents=unwrapContents;function unwrapContents(node){const contents=childNodes(node);for(const child of contents){node.parentNode.insertBefore(child,node);}
node.parentNode.removeChild(node);return contents;}
__exports.setTagName=setTagName;function setTagName(el,newTagName){const document=el.ownerDocument;if(el.tagName===newTagName){return el;}
const newEl=document.createElement(newTagName);while(el.firstChild){newEl.append(el.firstChild);}
if(el.tagName==="LI"){el.append(newEl);}else{for(const attribute of el.attributes){newEl.setAttribute(attribute.name,attribute.value);}
el.parentNode.replaceChild(newEl,el);}
return newEl;}
__exports.removeClass=removeClass;function removeClass(element,...classNames){const classNamesSet=new Set(classNames);if([...element.classList].every((className)=>classNamesSet.has(className))){element.removeAttribute("class");}else{element.classList.remove(...classNames);}}
__exports.fillEmpty=fillEmpty;function fillEmpty(el){const document=el.ownerDocument;const fillers={...fillShrunkPhrasingParent(el)};if(!isBlock(el)&&!isVisible(el)&&!el.hasAttribute("data-oe-zws-empty-inline")){const zws=document.createTextNode("\u200B");el.appendChild(zws);el.setAttribute("data-oe-zws-empty-inline","");fillers.zws=zws;const previousSibling=el.previousSibling;if(previousSibling&&previousSibling.nodeName==="BR"){previousSibling.remove();}}
return fillers;}
__exports.fillShrunkPhrasingParent=fillShrunkPhrasingParent;function fillShrunkPhrasingParent(el){const document=el.ownerDocument;const fillers={};const blockEl=closestBlock(el);if(isShrunkBlock(blockEl)){const br=document.createElement("br");blockEl.appendChild(br);fillers.br=br;}
return fillers;}
__exports.cleanTrailingBR=cleanTrailingBR;function cleanTrailingBR(el,predicates=[]){const candidate=el?.lastChild;if(candidate?.nodeName==="BR"&&candidate.previousSibling?.nodeName!=="BR"&&!isEmptyBlock(el)&&!predicates.some((predicate)=>predicate(candidate))){candidate.remove();return candidate;}}
__exports.toggleClass=toggleClass;function toggleClass(node,className){node.classList.toggle(className);if(!node.className){node.removeAttribute("class");}}
__exports.cleanTextNode=cleanTextNode;function cleanTextNode(node,char,cursors){const removedIndexes=[];node.textContent=node.textContent.replaceAll(char,(_,offset)=>{removedIndexes.push(offset);return"";});cursors?.update((cursor)=>{if(cursor.node===node){cursor.offset-=removedIndexes.filter((index)=>cursor.offset>index).length;}});}
__exports.splitTextNode=splitTextNode;function splitTextNode(textNode,offset,originalNodeSide=DIRECTIONS.RIGHT){const document=textNode.ownerDocument;let parentOffset=childNodeIndex(textNode);if(offset>0){parentOffset++;if(offset<textNode.length){const left=textNode.nodeValue.substring(0,offset);const right=textNode.nodeValue.substring(offset);if(originalNodeSide===DIRECTIONS.LEFT){const newTextNode=document.createTextNode(right);textNode.after(newTextNode);textNode.nodeValue=left;}else{const newTextNode=document.createTextNode(left);textNode.before(newTextNode);textNode.nodeValue=right;}}}
return parentOffset;}
return __exports;});;

/* /html_editor/static/src/utils/dom_info.js */
odoo.define('@html_editor/utils/dom_info',['@html_editor/utils/base_container','@html_editor/utils/blocks','@html_editor/utils/dom_traversal','@html_editor/utils/position'],function(require){'use strict';let __exports={};const{baseContainerGlobalSelector}=require("@html_editor/utils/base_container");const{closestBlock,isBlock}=require("@html_editor/utils/blocks");const{childNodes,closestElement,firstLeaf,lastLeaf}=require("@html_editor/utils/dom_traversal");const{DIRECTIONS,nodeSize}=require("@html_editor/utils/position");__exports.isEmpty=isEmpty;function isEmpty(el){if(isProtecting(el)||isProtected(el)){return false;}
const content=el.innerHTML.trim();if(content===""||content==="<br>"){return true;}
return false;}
__exports.isEmptyTextNode=isEmptyTextNode;function isEmptyTextNode(node){return node.nodeType===Node.TEXT_NODE&&node.nodeValue.length===0;}
__exports.isBold=isBold;function isBold(node){const fontWeight=+getComputedStyle(closestElement(node)).fontWeight;return fontWeight>500||fontWeight>+getComputedStyle(closestBlock(node)).fontWeight;}
__exports.isItalic=isItalic;function isItalic(node){return getComputedStyle(closestElement(node)).fontStyle==="italic";}
__exports.isUnderline=isUnderline;function isUnderline(node){let parent=closestElement(node);while(parent){if(getComputedStyle(parent).textDecorationLine.includes("underline")){return true;}
parent=parent.parentElement;}
return false;}
__exports.isStrikeThrough=isStrikeThrough;function isStrikeThrough(node){let parent=closestElement(node);while(parent){if(getComputedStyle(parent).textDecorationLine.includes("line-through")){return true;}
parent=parent.parentElement;}
return false;}
__exports.isFontSize=isFontSize;function isFontSize(node,props){const element=closestElement(node);return getComputedStyle(element)["font-size"]===props.size;}
__exports.hasClass=hasClass;function hasClass(node,props){const element=closestElement(node);return element.classList.contains(props.className);}
__exports.isDirectionSwitched=isDirectionSwitched;function isDirectionSwitched(node,editable){const defaultDirection=editable.getAttribute("dir")||"ltr";return getComputedStyle(closestElement(node)).direction!==defaultDirection;}
__exports.isRow=isRow;function isRow(node){return["TH","TD"].includes(node.tagName);}
__exports.isZWS=isZWS;function isZWS(node){return node&&node.textContent==="\u200B";}
__exports.isInPre=isInPre;function isInPre(node){const element=node.nodeType===Node.TEXT_NODE?node.parentElement:node;return(!!element&&(!!element.closest("pre")||getComputedStyle(element).getPropertyValue("white-space")==="pre"));}
const ZERO_WIDTH_CHARS=__exports.ZERO_WIDTH_CHARS=["\u200b","\ufeff"];const whitespace=__exports.whitespace=`[^\\S\\u00A0\\u0009\\ufeff]`;const whitespaceRegex=new RegExp(`^${whitespace}*$`);__exports.isWhitespace=isWhitespace;function isWhitespace(value){const str=typeof value==="string"?value:value.nodeValue;return whitespaceRegex.test(str);}
const visibleCharRegex=/[^\s\u200b]|[\u00A0\u0009]$/;__exports.isVisibleTextNode=isVisibleTextNode;function isVisibleTextNode(testedNode){if(!testedNode||!testedNode.length||testedNode.nodeType!==Node.TEXT_NODE){return false;}
if(isProtected(testedNode)){return true;}
if(visibleCharRegex.test(testedNode.textContent)||(isInPre(testedNode)&&isWhitespace(testedNode))){return true;}
if(ZERO_WIDTH_CHARS.includes(testedNode.textContent)){return false;}
let preceding;let following;let foundTestedNode;const currentNodeParentBlock=closestBlock(testedNode);if(!currentNodeParentBlock){return false;}
const nodeIterator=document.createNodeIterator(currentNodeParentBlock);for(let node=nodeIterator.nextNode();node;node=nodeIterator.nextNode()){if(node.nodeType===Node.TEXT_NODE){if(foundTestedNode){following=node;break;}else if(testedNode===node){foundTestedNode=true;}else{preceding=node;}}else if(isBlock(node)){if(foundTestedNode){break;}else{preceding=null;}}else if(foundTestedNode&&!isWhitespace(node)){following=node;break;}}
while(following&&!visibleCharRegex.test(following.textContent)){following=following.nextSibling;}
if(!(preceding&&following)||currentNodeParentBlock!==closestBlock(preceding)||currentNodeParentBlock!==closestBlock(following)){return false;}
return visibleCharRegex.test(preceding.textContent);}
const selfClosingElementTags=["BR","IMG","INPUT","T","HR"];__exports.isSelfClosingElement=isSelfClosingElement;function isSelfClosingElement(node){return node&&selfClosingElementTags.includes(node.nodeName);}
__exports.isVisible=isVisible;function isVisible(node){return(!!node&&((node.nodeType===Node.TEXT_NODE&&isVisibleTextNode(node))||isSelfClosingElement(node)||isMediaElement(node)||hasVisibleContent(node)||isProtecting(node)));}
__exports.hasVisibleContent=hasVisibleContent;function hasVisibleContent(node){return(node?childNodes(node):[]).some((n)=>isVisible(n));}
__exports.isButton=isButton;function isButton(node){if(!node||node.nodeType!==Node.ELEMENT_NODE){return false;}
return node.nodeName==="BUTTON"||node.classList.contains("btn");}
__exports.isZwnbsp=isZwnbsp;function isZwnbsp(node){return node?.nodeType===Node.TEXT_NODE&&node.textContent==="\ufeff";}
__exports.isTangible=isTangible;function isTangible(node){return isVisible(node)||isZwnbsp(node)||hasTangibleContent(node);}
__exports.hasTangibleContent=hasTangibleContent;function hasTangibleContent(node){return(node?childNodes(node):[]).some((n)=>isTangible(n));}
const isNotEditableNode=__exports.isNotEditableNode=(node)=>node.getAttribute&&node.getAttribute("contenteditable")&&node.getAttribute("contenteditable").toLowerCase()==="false";const iconTags=["I","SPAN"];const iconClasses=["fa","fab","fad","far","oi"];const ICON_SELECTOR=__exports.ICON_SELECTOR=iconTags.map((tag)=>{return iconClasses.map((cls)=>{return`${tag}.${cls}`;}).join(", ");}).join(", ");__exports.isIconElement=isIconElement;function isIconElement(node){return!!(node&&iconTags.includes(node.nodeName)&&iconClasses.some((cls)=>node.classList.contains(cls)));}
__exports.isMediaElement=isMediaElement;function isMediaElement(node){return(isIconElement(node)||(node.classList&&(node.classList.contains("o_image")||node.classList.contains("media_iframe_video"))));}
const phrasingTagNames=new Set(["ABBR","AUDIO","B","BDI","BDO","BR","BUTTON","CANVAS","CITE","CODE","DATA","DATALIST","DFN","EM","EMBED","I","IFRAME","IMG","INPUT","KBD","LABEL","MARK","MATH","METER","NOSCRIPT","OBJECT","OUTPUT","PICTURE","PROGRESS","Q","RUBY","S","SAMP","SCRIPT","SELECT","SLOT","SMALL","SPAN","STRONG","SUB","SUP","SVG","TEMPLATE","TEXTAREA","TIME","U","VAR","VIDEO","WBR","FONT","A","AREA","DEL","INS","LINK","MAP","META",]);__exports.isPhrasingContent=isPhrasingContent;function isPhrasingContent(node){if(node&&(node.nodeType===Node.TEXT_NODE||(node.nodeType===Node.ELEMENT_NODE&&phrasingTagNames.has(node.tagName)))){return true;}
return false;}
__exports.containsAnyInline=containsAnyInline;function containsAnyInline(element){if(!element){return false;}
let child=element.firstChild;while(child){if((!isBlock(child)&&child.nodeType===Node.ELEMENT_NODE)||(child.nodeType===Node.TEXT_NODE&&child.textContent.trim()!=="")){return true;}
child=child.nextSibling;}
return false;}
__exports.containsAnyNonPhrasingContent=containsAnyNonPhrasingContent;function containsAnyNonPhrasingContent(element){if(!element){return false;}
let child=element.firstChild;while(child){if(!isPhrasingContent(child)){return true;}
child=child.nextSibling;}
return false;}
__exports.isProtected=isProtected;function isProtected(node){if(!node){return false;}
const candidate=node.parentElement?closestElement(node.parentElement,"[data-oe-protected]"):null;if(!candidate||candidate.dataset.oeProtected==="false"){return false;}
return true;}
__exports.isProtecting=isProtecting;function isProtecting(node){if(!node){return false;}
return(node.nodeType===Node.ELEMENT_NODE&&node.dataset.oeProtected!=="false"&&node.dataset.oeProtected!==undefined);}
__exports.isUnprotecting=isUnprotecting;function isUnprotecting(node){if(!node){return false;}
return node.nodeType===Node.ELEMENT_NODE&&node.dataset.oeProtected==="false";}
const paragraphRelatedElements=__exports.paragraphRelatedElements=["P","H1","H2","H3","H4","H5","H6"];__exports.allowsParagraphRelatedElements=allowsParagraphRelatedElements;function allowsParagraphRelatedElements(node){return isBlock(node)&&!isParagraphRelatedElement(node);}
const phrasingContent=__exports.phrasingContent=new Set(["#text",...phrasingTagNames]);const flowContent=new Set([...phrasingContent,...paragraphRelatedElements,"DIV","HR"]);const listItem=__exports.listItem=new Set(["LI"]);const listContainers=new Set(["UL","OL"]);const allowedContent={BLOCKQUOTE:flowContent,DIV:flowContent,H1:phrasingContent,H2:phrasingContent,H3:phrasingContent,H4:phrasingContent,H5:phrasingContent,H6:phrasingContent,HR:new Set(),LI:flowContent,OL:listItem,UL:listItem,P:phrasingContent,PRE:flowContent,TD:flowContent,TR:new Set(["TD"]),};__exports.isParagraphRelatedElement=isParagraphRelatedElement;function isParagraphRelatedElement(node){if(!node){return false;}
return(paragraphRelatedElements.includes(node.nodeName)||(node.nodeType===Node.ELEMENT_NODE&&node.matches(baseContainerGlobalSelector)));}
const paragraphRelatedElementsSelector=__exports.paragraphRelatedElementsSelector=[...paragraphRelatedElements,baseContainerGlobalSelector,].join(",");__exports.isListItemElement=isListItemElement;function isListItemElement(node){return[...listItem].includes(node.nodeName);}
const listItemElementSelector=__exports.listItemElementSelector=[...listItem].join(",");__exports.isListElement=isListElement;function isListElement(node){return[...listContainers].includes(node.nodeName);}
const listElementSelector=__exports.listElementSelector=[...listContainers].join(",");__exports.isAllowedContent=isAllowedContent;function isAllowedContent(parentBlock,nodes){let allowedContentSet=allowedContent[parentBlock.nodeName];if(!allowedContentSet){return true;}
if(parentBlock.matches(baseContainerGlobalSelector)){allowedContentSet=phrasingContent;}
return nodes.every((node)=>allowedContentSet.has(node.nodeName));}
__exports.isEmptyBlock=isEmptyBlock;function isEmptyBlock(blockEl){if(!blockEl||blockEl.nodeType!==Node.ELEMENT_NODE){return false;}
if(visibleCharRegex.test(blockEl.textContent)){return false;}
if(blockEl.querySelectorAll("br").length>=2){return false;}
if(isProtecting(blockEl)||isProtected(blockEl)){return false;}
const nodes=blockEl.querySelectorAll("*");for(const node of nodes){if(node.nodeName!="BR"&&(isSelfClosingElement(node)||isMediaElement(node)||isProtecting(node))){return false;}}
return isBlock(blockEl);}
__exports.isShrunkBlock=isShrunkBlock;function isShrunkBlock(blockEl){return isEmptyBlock(blockEl)&&!blockEl.querySelector("br")&&!isSelfClosingElement(blockEl);}
__exports.isEditorTab=isEditorTab;function isEditorTab(node){return node&&node.nodeName==="SPAN"&&node.classList.contains("oe-tabs");}
__exports.getDeepestPosition=getDeepestPosition;function getDeepestPosition(node,offset){let direction=DIRECTIONS.RIGHT;let next=node;while(next){if(isTangible(next)||(isZWS(next)&&isContentEditable(next))){if(next!==node){[node,offset]=[next,direction?0:nodeSize(next)];}
const childrenNodes=childNodes(node);direction=offset<childrenNodes.length;next=childrenNodes[direction?offset:offset-1];}else if(direction&&next.nextSibling&&closestBlock(node).contains(next.nextSibling)){next=next.nextSibling;}else{direction=DIRECTIONS.LEFT;next=closestBlock(node).contains(next.previousSibling)&&next.previousSibling;}
next=!isSelfClosingElement(next)&&next;}
return[node,offset];}
__exports.previousLeaf=previousLeaf;function previousLeaf(node,editable,skipInvisible=false){let ancestor=node;while(ancestor&&!ancestor.previousSibling&&ancestor!==editable){ancestor=ancestor.parentElement;}
if(ancestor&&ancestor!==editable){if(skipInvisible&&!isVisible(ancestor.previousSibling)){return previousLeaf(ancestor.previousSibling,editable,skipInvisible);}else{const last=lastLeaf(ancestor.previousSibling);if(skipInvisible&&!isVisible(last)){return previousLeaf(last,editable,skipInvisible);}else{return last;}}}}
__exports.nextLeaf=nextLeaf;function nextLeaf(node,editable,skipInvisible=false){let ancestor=node;while(ancestor&&!ancestor.nextSibling&&ancestor!==editable){ancestor=ancestor.parentElement;}
if(ancestor&&ancestor!==editable){if(skipInvisible&&ancestor.nextSibling&&!isVisible(ancestor.nextSibling)){return nextLeaf(ancestor.nextSibling,editable,skipInvisible);}else{const first=firstLeaf(ancestor.nextSibling);if(skipInvisible&&!isVisible(first)){return nextLeaf(first,editable,skipInvisible);}else{return first;}}}}
function hasPseudoElementContent(node,pseudoSelector){const content=getComputedStyle(node,pseudoSelector).getPropertyValue("content");return content&&content!=="none";}
const NOT_A_NUMBER=/[^\d]/g;__exports.areSimilarElements=areSimilarElements;function areSimilarElements(node,node2){if(![node,node2].every((n)=>n?.nodeType===Node.ELEMENT_NODE)){return false;}
if(node.nodeName!==node2.nodeName){return false;}
for(const name of new Set([...node.getAttributeNames(),...node2.getAttributeNames()])){if(node.getAttribute(name)!==node2.getAttribute(name)){return false;}}
if([node,node2].some((n)=>hasPseudoElementContent(n,":before")||hasPseudoElementContent(n,":after"))){return false;}
if(isBlock(node)){return false;}
const nodeStyle=getComputedStyle(node);const node2Style=getComputedStyle(node2);return(!+nodeStyle.padding.replace(NOT_A_NUMBER,"")&&!+node2Style.padding.replace(NOT_A_NUMBER,"")&&!+nodeStyle.margin.replace(NOT_A_NUMBER,"")&&!+node2Style.margin.replace(NOT_A_NUMBER,""));}
__exports.isTextNode=isTextNode;function isTextNode(node){return node.nodeType===Node.TEXT_NODE;}
__exports.isElement=isElement;function isElement(node){return node.nodeType===Node.ELEMENT_NODE;}
__exports.isContentEditable=isContentEditable;function isContentEditable(node){const element=isTextNode(node)?node.parentElement:node;return element&&element.isContentEditable;}
__exports.isContentEditableAncestor=isContentEditableAncestor;function isContentEditableAncestor(node){if(node.nodeType!==Node.ELEMENT_NODE){return false;}
return node.isContentEditable&&node.matches("[contenteditable]");}
return __exports;});;

/* /html_editor/static/src/utils/dom_state.js */
odoo.define('@html_editor/utils/dom_state',['@html_editor/utils/blocks','@html_editor/utils/content_types','@html_editor/utils/dom_info','@html_editor/utils/dom_traversal','@html_editor/utils/position'],function(require){'use strict';let __exports={};const{isBlock}=require("@html_editor/utils/blocks");const{CTGROUPS,CTYPES,ctypeToString}=require("@html_editor/utils/content_types");const{isInPre,isVisible,isWhitespace,whitespace}=require("@html_editor/utils/dom_info");const{PATH_END_REASONS,ancestors,closestElement,closestPath,createDOMPathGenerator,}=require("@html_editor/utils/dom_traversal");const{DIRECTIONS,leftPos,rightPos}=require("@html_editor/utils/position");const prepareUpdateLockedEditables=new Set();__exports.prepareUpdate=prepareUpdate;function prepareUpdate(...args){const closestRoot=args.length&&ancestors(args[0]).find((ancestor)=>ancestor.classList.contains("odoo-editor-editable"));const isPrepareUpdateLocked=closestRoot&&prepareUpdateLockedEditables.has(closestRoot);const hash=(Math.random()+1).toString(36).substring(7);const options={allowReenter:true,label:hash,debug:false,...(args.length&&args[args.length-1]instanceof Object?args.pop():{}),};if(options.debug){console.log("%cPreparing%c update: "+
options.label+
(options.label===hash?"":` (${hash})`)+"%c"+
(isPrepareUpdateLocked?" LOCKED":""),"color: cyan;","color: white;","color: red; font-weight: bold;");}
if(isPrepareUpdateLocked){return()=>{if(options.debug){console.log("%cRestoring%c update: "+
options.label+
(options.label===hash?"":` (${hash})`)+"%c LOCKED","color: lightgreen;","color: white;","color: red; font-weight: bold;");}};}
if(!options.allowReenter&&closestRoot){prepareUpdateLockedEditables.add(closestRoot);}
const positions=[...args];const restoreData=[];let el,offset;while(positions.length){offset=positions.pop();el=positions.pop();const left=getState(el,offset,DIRECTIONS.LEFT);const right=getState(el,offset,DIRECTIONS.RIGHT,left.cType);if(options.debug){const editable=el&&closestElement(el,".odoo-editor-editable");const oldEditableHTML=(editable&&editable.innerHTML.replaceAll(" ","_").replaceAll("\u200B","ZWS"))||"";left.oldEditableHTML=oldEditableHTML;right.oldEditableHTML=oldEditableHTML;}
restoreData.push(left,right);}
return function restoreStates(){if(options.debug){console.log("%cRestoring%c update: "+
options.label+
(options.label===hash?"":` (${hash})`),"color: lightgreen;","color: white;");}
for(const data of restoreData){restoreState(data,options.debug);}
if(!options.allowReenter&&closestRoot){prepareUpdateLockedEditables.delete(closestRoot);}};}
const leftLeafOnlyNotBlockPath=__exports.leftLeafOnlyNotBlockPath=createDOMPathGenerator(DIRECTIONS.LEFT,{leafOnly:true,stopTraverseFunction:isBlock,stopFunction:isBlock,});const rightLeafOnlyNotBlockPath=createDOMPathGenerator(DIRECTIONS.RIGHT,{leafOnly:true,stopTraverseFunction:isBlock,stopFunction:isBlock,});__exports.getState=getState;function getState(el,offset,direction,leftCType){const leftDOMPath=leftLeafOnlyNotBlockPath;const rightDOMPath=rightLeafOnlyNotBlockPath;let domPath;let inverseDOMPath;const whitespaceAtStartRegex=new RegExp("^"+whitespace+"+");const whitespaceAtEndRegex=new RegExp(whitespace+"+$");const reasons=[];if(direction===DIRECTIONS.LEFT){domPath=leftDOMPath(el,offset,reasons);inverseDOMPath=rightDOMPath(el,offset);}else{domPath=rightDOMPath(el,offset,reasons);inverseDOMPath=leftDOMPath(el,offset);}
const boundaryNode=inverseDOMPath.next().value;let cType=undefined;let lastSpace=null;for(const node of domPath){if(node.nodeType===Node.TEXT_NODE){const value=node.nodeValue;if(direction===DIRECTIONS.LEFT){if(!isWhitespace(value)){if(lastSpace){cType=CTYPES.SPACE;}else{const rightLeaf=rightLeafOnlyNotBlockPath(node).next().value;const hasContentRight=rightLeaf&&!whitespaceAtStartRegex.test(rightLeaf.textContent);cType=!hasContentRight&&whitespaceAtEndRegex.test(node.textContent)?CTYPES.SPACE:CTYPES.CONTENT;}
break;}
if(value.length){lastSpace=node;}}else{leftCType=leftCType||getState(el,offset,DIRECTIONS.LEFT).cType;if(whitespaceAtStartRegex.test(value)){const leftLeaf=leftLeafOnlyNotBlockPath(node).next().value;const hasContentLeft=leftLeaf&&!whitespaceAtEndRegex.test(leftLeaf.textContent);const rct=!isWhitespace(value)?CTYPES.CONTENT:getState(...rightPos(node),DIRECTIONS.RIGHT).cType;cType=leftCType&CTYPES.CONTENT&&rct&(CTYPES.CONTENT|CTYPES.BR)&&!hasContentLeft?CTYPES.SPACE:rct;break;}
if(!isWhitespace(value)){cType=CTYPES.CONTENT;break;}}}else if(node.nodeName==="BR"){cType=CTYPES.BR;break;}else if(isVisible(node)){cType=CTYPES.CONTENT;break;}}
if(cType===undefined){cType=reasons.includes(PATH_END_REASONS.BLOCK_HIT)?CTYPES.BLOCK_OUTSIDE:CTYPES.BLOCK_INSIDE;}
return{node:boundaryNode,direction:direction,cType:cType,};}
const priorityRestoreStateRules=[[{cType1:CTYPES.CONTENT,cType2:CTYPES.SPACE|CTGROUPS.BLOCK},{spaceVisibility:true},],[{direction:DIRECTIONS.LEFT,cType1:CTGROUPS.INLINE,cType2:CTGROUPS.BR},{spaceVisibility:true},],[{direction:DIRECTIONS.RIGHT,cType1:CTGROUPS.CONTENT,cType2:CTGROUPS.BR},{spaceVisibility:true},],[{direction:DIRECTIONS.RIGHT,cType1:CTGROUPS.BR,cType2:CTYPES.SPACE|CTGROUPS.BLOCK},{spaceVisibility:true},],[{cType1:CTYPES.SPACE},{spaceVisibility:false},],[{direction:DIRECTIONS.LEFT,cType1:CTGROUPS.BR},{spaceVisibility:false},],[{cType1:CTGROUPS.BLOCK,cType2:CTGROUPS.INLINE|CTGROUPS.BR},{spaceVisibility:false},],[{direction:DIRECTIONS.RIGHT,cType1:CTGROUPS.INLINE,cType2:CTGROUPS.BLOCK},{brVisibility:true},],[{direction:DIRECTIONS.RIGHT,cType1:CTGROUPS.BLOCK,cType2:CTGROUPS.INLINE|CTGROUPS.BR,},{brVisibility:false},],[{direction:DIRECTIONS.LEFT,cType1:CTGROUPS.BR|CTGROUPS.BLOCK,cType2:CTGROUPS.INLINE,},{brVisibility:false,extraBRRemovalCondition:(brNode)=>isFakeLineBreak(brNode)},],];function restoreStateRuleHashCode(direction,cType1,cType2){return`${direction}-${cType1}-${cType2}`;}
const allRestoreStateRules=(function(){const map=new Map();const keys=["direction","cType1","cType2"];for(const direction of Object.values(DIRECTIONS)){for(const cType1 of Object.values(CTYPES)){for(const cType2 of Object.values(CTYPES)){const rule={direction:direction,cType1:cType1,cType2:cType2};const matchedRules=[];for(const entry of priorityRestoreStateRules){let priority=0;for(const key of keys){const entryKeyValue=entry[0][key];if(entryKeyValue!==undefined){if(typeof entryKeyValue==="boolean"?rule[key]===entryKeyValue:rule[key]&entryKeyValue){priority++;}else{priority=-1;break;}}}
if(priority>=0){matchedRules.push([priority,entry[1]]);}}
const finalRule={};for(let p=0;p<=keys.length;p++){for(const entry of matchedRules){if(entry[0]===p){Object.assign(finalRule,entry[1]);}}}
const hashCode=restoreStateRuleHashCode(direction,cType1,cType2);map.set(hashCode,finalRule);}}}
return map;})();__exports.restoreState=restoreState;function restoreState(prevStateData,debug=false){const{node,direction,cType:cType1,oldEditableHTML}=prevStateData;if(!node||!node.parentNode){return;}
const[el,offset]=direction===DIRECTIONS.LEFT?leftPos(node):rightPos(node);const{cType:cType2}=getState(el,offset,direction);const ruleHashCode=restoreStateRuleHashCode(direction,cType1,cType2);const rule=allRestoreStateRules.get(ruleHashCode);if(debug){const editable=closestElement(node,".odoo-editor-editable");console.log("%c"+
node.textContent.replaceAll(" ","_").replaceAll("\u200B","ZWS")+"\n"+"%c"+
(direction===DIRECTIONS.LEFT?"left":"right")+"\n"+"%c"+
ctypeToString(cType1)+"\n"+"%c"+
ctypeToString(cType2)+"\n"+"%c"+"BEFORE: "+
(oldEditableHTML||"(unavailable)")+"\n"+"%c"+"AFTER:  "+
(editable?editable.innerHTML.replaceAll(" ","_").replaceAll("\u200B","ZWS"):"(unavailable)")+"\n","color: white; display: block; width: 100%;","color: "+
(direction===DIRECTIONS.LEFT?"magenta":"lightgreen")+"; display: block; width: 100%;","color: pink; display: block; width: 100%;","color: lightblue; display: block; width: 100%;","color: white; display: block; width: 100%;","color: white; display: block; width: 100%;",rule);}
if(Object.values(rule).filter((x)=>x!==undefined).length){const inverseDirection=direction===DIRECTIONS.LEFT?DIRECTIONS.RIGHT:DIRECTIONS.LEFT;enforceWhitespace(el,offset,inverseDirection,rule);}
return rule;}
__exports.isFakeLineBreak=isFakeLineBreak;function isFakeLineBreak(brEl){return!(getState(...rightPos(brEl),DIRECTIONS.RIGHT).cType&(CTYPES.CONTENT|CTGROUPS.BR));}
__exports.enforceWhitespace=enforceWhitespace;function enforceWhitespace(el,offset,direction,rule){const document=el.ownerDocument;let domPath,whitespaceAtEdgeRegex;if(direction===DIRECTIONS.LEFT){domPath=leftLeafOnlyNotBlockPath(el,offset);whitespaceAtEdgeRegex=new RegExp(whitespace+"+$");}else{domPath=rightLeafOnlyNotBlockPath(el,offset);whitespaceAtEdgeRegex=new RegExp("^"+whitespace+"+");}
const invisibleSpaceTextNodes=[];let foundVisibleSpaceTextNode=null;for(const node of domPath){if(node.nodeName==="BR"){if(rule.brVisibility===undefined){break;}
if(rule.brVisibility){node.before(document.createElement("br"));}else{if(!rule.extraBRRemovalCondition||rule.extraBRRemovalCondition(node)){node.remove();}}
break;}else if(node.nodeType===Node.TEXT_NODE&&!isInPre(node)){if(whitespaceAtEdgeRegex.test(node.nodeValue)){if(!isWhitespace(node)){foundVisibleSpaceTextNode=node;break;}else{invisibleSpaceTextNodes.push(node);}}else if(!isWhitespace(node)){break;}}else{break;}}
if(rule.spaceVisibility===undefined){return;}
if(!rule.spaceVisibility){for(const node of invisibleSpaceTextNodes){node.nodeValue="";const ancestorPath=closestPath(node.parentNode);let toRemove=null;for(const pNode of ancestorPath){if(toRemove){toRemove.remove();}
if(pNode.childNodes.length===1&&!isBlock(pNode)){pNode.after(node);toRemove=pNode;}else{break;}}}}
const spaceNode=foundVisibleSpaceTextNode||invisibleSpaceTextNodes[0];if(spaceNode){let spaceVisibility=rule.spaceVisibility;if(spaceVisibility&&!foundVisibleSpaceTextNode&&getState(...rightPos(spaceNode),DIRECTIONS.RIGHT).cType&CTGROUPS.BLOCK&&getState(...leftPos(spaceNode),DIRECTIONS.LEFT).cType!==CTYPES.CONTENT){spaceVisibility=false;}
spaceNode.nodeValue=spaceNode.nodeValue.replace(whitespaceAtEdgeRegex,spaceVisibility?"\u00A0":"");}}
__exports.observeMutations=observeMutations;function observeMutations(target,observerOptions){const records=[];const observerCallback=(mutations)=>records.push(...mutations);const observer=new MutationObserver(observerCallback);observer.observe(target,observerOptions);return()=>{observerCallback(observer.takeRecords());observer.disconnect();return records;};}
return __exports;});;

/* /html_editor/static/src/utils/dom_traversal.js */
odoo.define('@html_editor/utils/dom_traversal',['@html_editor/utils/position'],function(require){'use strict';let __exports={};const{DIRECTIONS}=require("@html_editor/utils/position");const closestPath=__exports.closestPath=function*(node){while(node){yield node;node=node.parentNode;}};__exports.findNode=findNode;function findNode(domPath,findCallback=()=>true,stopCallback=()=>false){for(const node of domPath){if(findCallback(node)){return node;}
if(stopCallback(node)){break;}}
return null;}
__exports.findUpTo=findUpTo;function findUpTo(node,limitAncestor,predicate){while(node!==limitAncestor){if(predicate(node)){return node;}
node=node.parentElement;}
return null;}
__exports.findFurthest=findFurthest;function findFurthest(node,limitAncestor,predicate){const nodes=[];while(node!==limitAncestor){nodes.push(node);node=node.parentNode;}
return nodes.findLast(predicate);}
__exports.closestElement=closestElement;function closestElement(node,predicate="*"){let element=node.nodeType===Node.ELEMENT_NODE?node:node.parentElement;const editable=element?.closest(".odoo-editor-editable");if(typeof predicate==="function"){while(element&&!predicate(element)){element=element.parentElement;}}else{element=element?.closest(predicate);}
if((editable&&editable.contains(element))||!node.isConnected){return element;}
return null;}
__exports.ancestors=ancestors;function ancestors(node,editable){const result=[];while(node&&node.parentElement&&node!==editable){result.push(node.parentElement);node=node.parentElement;}
return result;}
__exports.children=children;function children(elem){const children=[];let child=elem.firstElementChild;while(child){children.push(child);child=child.nextElementSibling;}
return children;}
__exports.childNodes=childNodes;function childNodes(node){const childNodes=[];let child=node.firstChild;while(child){childNodes.push(child);child=child.nextSibling;}
return childNodes;}
__exports.descendants=descendants;function descendants(node,posterity=[]){let child=node.firstChild;while(child){posterity.push(child);descendants(child,posterity);child=child.nextSibling;}
return posterity;}
const PATH_END_REASONS=__exports.PATH_END_REASONS={NO_NODE:0,BLOCK_OUT:1,BLOCK_HIT:2,OUT_OF_SCOPE:3,};__exports.createDOMPathGenerator=createDOMPathGenerator;function createDOMPathGenerator(direction,{leafOnly=false,inScope=false,stopTraverseFunction,stopFunction}={}){const nextDeepest=direction===DIRECTIONS.LEFT?(node)=>lastLeaf(node.previousSibling,stopTraverseFunction):(node)=>firstLeaf(node.nextSibling,stopTraverseFunction);const firstNode=direction===DIRECTIONS.LEFT?(node,offset)=>lastLeaf(node.childNodes[offset-1],stopTraverseFunction):(node,offset)=>firstLeaf(node.childNodes[offset],stopTraverseFunction);return function*(node,offset,reasons=[]){let movedUp=false;let currentNode=firstNode(node,offset);if(!currentNode){movedUp=true;currentNode=node;}
while(currentNode){if(stopFunction&&stopFunction(currentNode)){reasons.push(movedUp?PATH_END_REASONS.BLOCK_OUT:PATH_END_REASONS.BLOCK_HIT);break;}
if(inScope&&currentNode===node){reasons.push(PATH_END_REASONS.OUT_OF_SCOPE);break;}
if(!(leafOnly&&movedUp)){yield currentNode;}
movedUp=false;let nextNode=nextDeepest(currentNode);if(!nextNode){movedUp=true;nextNode=currentNode.parentNode;}
currentNode=nextNode;}
reasons.push(PATH_END_REASONS.NO_NODE);};}
__exports.lastLeaf=lastLeaf;function lastLeaf(node,stopTraverseFunction){while(node&&node.lastChild&&!(stopTraverseFunction&&stopTraverseFunction(node))){node=node.lastChild;}
return node;}
__exports.firstLeaf=firstLeaf;function firstLeaf(node,stopTraverseFunction){while(node&&node.firstChild&&!(stopTraverseFunction&&stopTraverseFunction(node))){node=node.firstChild;}
return node;}
__exports.getAdjacentPreviousSiblings=getAdjacentPreviousSiblings;function getAdjacentPreviousSiblings(node,predicate=(n)=>!!n){let previous=node.previousSibling;const list=[];while(previous&&predicate(previous)){list.push(previous);previous=previous.previousSibling;}
return list;}
__exports.getAdjacentNextSiblings=getAdjacentNextSiblings;function getAdjacentNextSiblings(node,predicate=(n)=>!!n){let next=node.nextSibling;const list=[];while(next&&predicate(next)){list.push(next);next=next.nextSibling;}
return list;}
__exports.getAdjacents=getAdjacents;function getAdjacents(node,predicate=(n)=>!!n){const previous=getAdjacentPreviousSiblings(node,predicate);const next=getAdjacentNextSiblings(node,predicate);return predicate(node)?[...previous.reverse(),node,...next]:[];}
__exports.getCommonAncestor=getCommonAncestor;function getCommonAncestor(nodes,root=undefined){const pathsToRoot=nodes.map((node)=>[node,...ancestors(node,root)]);let candidate=pathsToRoot[0]?.at(-1);if(root&&candidate!==root){return null;}
let commonAncestor=null;while(candidate&&pathsToRoot.every((path)=>path.at(-1)===candidate)){commonAncestor=candidate;pathsToRoot.forEach((path)=>path.pop());candidate=pathsToRoot[0].at(-1);}
return commonAncestor;}
const selectElements=__exports.selectElements=function*(root,selector){if(root.matches(selector)){yield root;}
for(const elem of root.querySelectorAll(selector)){yield elem;}};return __exports;});;

/* /html_editor/static/src/utils/drag_and_drop.js */
odoo.define('@html_editor/utils/drag_and_drop',['@web/core/utils/draggable_hook_builder','@web/core/utils/objects','@odoo/owl','@web/core/utils/timing','@web/core/utils/ui'],function(require){'use strict';let __exports={};const{makeDraggableHook}=require("@web/core/utils/draggable_hook_builder");const{pick}=require("@web/core/utils/objects");const{reactive}=require("@odoo/owl");const{throttleForAnimation}=require("@web/core/utils/timing");const{closest,touching}=require("@web/core/utils/ui");__exports.useNativeDraggable=useNativeDraggable;function useNativeDraggable(hookParams,initialParams){const setupFunctions=new Map();const cleanupFunctions=[];const currentParams={...initialParams};const setupHooks={wrapState:reactive,throttle:throttleForAnimation,addListener:(el,type,callback,options)=>{el.addEventListener(type,callback,options);cleanupFunctions.push(()=>el.removeEventListener(type,callback));},setup:(setupFn,depsFn)=>setupFunctions.set(setupFn,depsFn),teardown:(cleanupFn)=>{cleanupFunctions.push(cleanupFn);},};const el=initialParams.ref.el;el.classList.add("o_draggable");cleanupFunctions.push(()=>el.classList.remove("o_draggable"));const draggableState=makeDraggableHook({setupHooks,...hookParams})(currentParams);draggableState.enable=true;const draggableComponent={state:draggableState,update:(newParams)=>{Object.assign(currentParams,newParams);setupFunctions.forEach((depsFn,setupFn)=>setupFn(...depsFn()));},destroy:()=>{cleanupFunctions.forEach((cleanupFn)=>cleanupFn());},};draggableComponent.update({});return draggableComponent;}
function updateElementPosition(el,{x,y},styleFn,offset={x:0,y:0}){return styleFn(el,{top:`${y - offset.y}px`,left:`${x - offset.x}px`});}
const dragAndDropHookParams={name:"useDragAndDrop",acceptedParams:{dropzones:[Function],scrollingElement:[Object,Function],helper:[Function],extraWindow:[Object,Function],},edgeScrolling:{enabled:true},onComputeParams({ctx,params}){ctx.followCursor=false;ctx.scrollingElement=params.scrollingElement;ctx.getHelper=params.helper;ctx.getDropZones=params.dropzones;},onWillStartDrag:({ctx})=>{ctx.current.container=ctx.scrollingElement;ctx.current.helperOffset={x:0,y:0};},onDragStart:({ctx,addStyle,addCleanup})=>{ctx.current.element=ctx.getHelper({...ctx.current,...ctx.pointer});ctx.current.helper=ctx.current.element;ctx.current.helper.style.position="fixed";ctx.current.helper.classList.remove("o_dragged");ctx.current.helper.style.cursor=ctx.cursor;ctx.current.helper.style.pointerEvents="auto";const frameElement=ctx.current.helper.ownerDocument.defaultView.frameElement;if(frameElement){addStyle(frameElement,{pointerEvents:"auto"});}
addCleanup(()=>ctx.current.helper.remove());updateElementPosition(ctx.current.helper,ctx.pointer,addStyle,ctx.current.helperOffset);return pick(ctx.current,"element","helper");},onDrag:({ctx,addStyle,callHandler})=>{ctx.current.helper.classList.add("o_draggable_dragging");updateElementPosition(ctx.current.helper,ctx.pointer,addStyle,ctx.current.helperOffset);let helperRect=ctx.current.helper.getBoundingClientRect();helperRect={x:helperRect.x,y:helperRect.y,width:helperRect.width,height:helperRect.height,};const dropzoneEl=closest(touching(ctx.getDropZones(),helperRect),helperRect);if(ctx.current.dropzone?.el&&ctx.current.dropzone.el.classList.contains("oe_grid_zone")){ctx.current.dropzone.rect=ctx.current.dropzone.el.getBoundingClientRect();}
if(ctx.current.dropzone&&(ctx.current.dropzone.el===dropzoneEl||(!dropzoneEl&&touching([ctx.current.helper],ctx.current.dropzone.rect).length>0))){return pick(ctx.current,"element","dropzone","helper");}
if(ctx.current.dropzone&&dropzoneEl!==ctx.current.dropzone.el){callHandler("dropzoneOut",{dropzone:ctx.current.dropzone});delete ctx.current.dropzone;}
if(dropzoneEl){const rect=DOMRect.fromRect(dropzoneEl.getBoundingClientRect());ctx.current.dropzone={el:dropzoneEl,rect:{x:rect.x,y:rect.y,width:rect.width,height:rect.height,},};callHandler("dropzoneOver",{dropzone:ctx.current.dropzone});}
return pick(ctx.current,"element","dropzone","helper");},onDragEnd({ctx}){return pick(ctx.current,"element","dropzone","helper");},};__exports.useDragAndDrop=useDragAndDrop;function useDragAndDrop(initialParams){return useNativeDraggable(dragAndDropHookParams,initialParams);}
return __exports;});;

/* /html_editor/static/src/utils/fonts.js */
odoo.define('@html_editor/utils/fonts',[],function(require){'use strict';let __exports={};const fonts=__exports.fonts={cacheCssSelectors:{},getCssSelectors:function(filter){if(this.cacheCssSelectors[filter]){return this.cacheCssSelectors[filter];}
this.cacheCssSelectors[filter]=[];var sheets=document.styleSheets;for(var i=0;i<sheets.length;i++){var rules;try{rules=sheets[i].rules||sheets[i].cssRules;}catch{continue;}
if(!rules){continue;}
for(var r=0;r<rules.length;r++){var selectorText=rules[r].selectorText;if(!selectorText){continue;}
var selectors=selectorText.split(/\s*,\s*/);var data=null;for(var s=0;s<selectors.length;s++){var match=selectors[s].trim().match(filter);if(!match){continue;}
if(!data){data={selector:match[0],css:rules[r].cssText.replace(/(^.*\{\s*)|(\s*\}\s*$)/g,""),names:[match[1]],};}else{data.selector+=", "+match[0];data.names.push(match[1]);}}
if(data){this.cacheCssSelectors[filter].push(data);}}}
return this.cacheCssSelectors[filter];},fontIcons:[{base:"fa",parser:/\.(fa-(?:\w|-)+)::?before/i}],computedFonts:false,computeFonts:function(){if(!this.computedFonts){var self=this;this.fontIcons.forEach((data)=>{data.cssData=self.getCssSelectors(data.parser);data.alias=data.cssData.map((x)=>x.names).flat();});this.computedFonts=true;}},};return __exports;});;

/* /html_editor/static/src/utils/formatting.js */
odoo.define('@html_editor/utils/formatting',['@web/core/utils/colors','@html_editor/utils/dom','@html_editor/utils/dom_info','@html_editor/utils/dom_traversal'],function(require){'use strict';let __exports={};const{normalizeCSSColor}=require("@web/core/utils/colors");const{removeClass}=require("@html_editor/utils/dom");const{isBold,isDirectionSwitched,isItalic,isStrikeThrough,isUnderline}=require("@html_editor/utils/dom_info");const{closestElement}=require("@html_editor/utils/dom_traversal");const FONT_SIZE_CLASSES=__exports.FONT_SIZE_CLASSES=["display-1-fs","display-2-fs","display-3-fs","display-4-fs","h1-fs","h2-fs","h3-fs","h4-fs","h5-fs","h6-fs","base-fs","small","o_small-fs",];const TEXT_STYLE_CLASSES=__exports.TEXT_STYLE_CLASSES=["display-1","display-2","display-3","display-4","lead"];const formatsSpecs=__exports.formatsSpecs={italic:{tagName:"em",isFormatted:isItalic,isTag:(node)=>["EM","I"].includes(node.tagName),hasStyle:(node)=>Boolean(node.style&&node.style["font-style"]),addStyle:(node)=>(node.style["font-style"]="italic"),addNeutralStyle:(node)=>(node.style["font-style"]="normal"),removeStyle:(node)=>removeStyle(node,"font-style"),},bold:{tagName:"strong",isFormatted:isBold,isTag:(node)=>["STRONG","B"].includes(node.tagName),hasStyle:(node)=>Boolean(node.style&&node.style["font-weight"]),addStyle:(node)=>(node.style["font-weight"]="bolder"),addNeutralStyle:(node)=>{node.style["font-weight"]="normal";},removeStyle:(node)=>removeStyle(node,"font-weight"),},underline:{tagName:"u",isFormatted:isUnderline,isTag:(node)=>node.tagName==="U",hasStyle:(node)=>node.style&&(node.style["text-decoration"].includes("underline")||node.style["text-decoration-line"].includes("underline")),addStyle:(node)=>(node.style["text-decoration-line"]+=" underline"),removeStyle:(node)=>removeStyle(node,node.style["text-decoration"].includes("underline")?"text-decoration":"text-decoration-line","underline"),},strikeThrough:{tagName:"s",isFormatted:isStrikeThrough,isTag:(node)=>node.tagName==="S",hasStyle:(node)=>node.style&&(node.style["text-decoration"].includes("line-through")||node.style["text-decoration-line"].includes("line-through")),addStyle:(node)=>(node.style["text-decoration-line"]+=" line-through"),removeStyle:(node)=>removeStyle(node,node.style["text-decoration"].includes("line-through")?"text-decoration":"text-decoration-line","line-through"),},fontSize:{isFormatted:(node)=>closestElement(node)?.style["font-size"],hasStyle:(node)=>node.style&&node.style["font-size"],addStyle:(node,props)=>{node.style["font-size"]=props.size;removeClass(node,...FONT_SIZE_CLASSES);},removeStyle:(node)=>removeStyle(node,"font-size"),},setFontSizeClassName:{isFormatted:(node)=>FONT_SIZE_CLASSES.find((cls)=>closestElement(node)?.classList?.contains(cls)),hasStyle:(node,props)=>FONT_SIZE_CLASSES.find((cls)=>node.classList.contains(cls)),addStyle:(node,props)=>{node.style.removeProperty("font-size");node.classList.add(props.className);},removeStyle:(node)=>removeClass(node,...FONT_SIZE_CLASSES,...TEXT_STYLE_CLASSES),},switchDirection:{isFormatted:isDirectionSwitched,},};function removeStyle(node,styleName,item){if(item){const newStyle=node.style[styleName].split(" ").filter((x)=>x!==item).join(" ");node.style[styleName]=newStyle||null;}else{node.style[styleName]=null;}
if(node.getAttribute("style")===""){node.removeAttribute("style");}}
__exports.getCSSVariableValue=getCSSVariableValue;function getCSSVariableValue(key,htmlStyle){let value=htmlStyle.getPropertyValue(`--${key}`).trim();value=normalizeCSSColor(value);return value.replace(/"/g,"'");}
const CSS_UNITS_CONVERSION={"s-ms":()=>1000,"ms-s":()=>0.001,"rem-px":(htmlStyle)=>parseFloat(htmlStyle["font-size"]),"px-rem":(htmlStyle)=>1/parseFloat(htmlStyle["font-size"]),"%-px":()=>-1,"px-%":()=>-1,};__exports.convertNumericToUnit=convertNumericToUnit;function convertNumericToUnit(value,unitFrom,unitTo,htmlStyle){if(Math.abs(value)<Number.EPSILON||unitFrom===unitTo){return value;}
const converter=CSS_UNITS_CONVERSION[`${unitFrom}-${unitTo}`];if(converter===undefined){throw new Error(`Cannot convert '${unitFrom}' units into '${unitTo}' units !`);}
return value*converter(htmlStyle);}
__exports.getHtmlStyle=getHtmlStyle;function getHtmlStyle(document){return document.defaultView.getComputedStyle(document.documentElement);}
__exports.getFontSizeDisplayValue=getFontSizeDisplayValue;function getFontSizeDisplayValue(sel,document){const tagNameRelatedToFontSize=["h1","h2","h3","h4","h5","h6"];const styleClassesRelatedToFontSize=["display-1","display-2","display-3","display-4","lead",];const closestStartContainerEl=closestElement(sel.startContainer);const closestFontSizedEl=closestStartContainerEl.closest(`
        [style*='font-size'],
        ${FONT_SIZE_CLASSES.map((className) => `.${className}`)},
        ${styleClassesRelatedToFontSize.map((className) => `.${className}`)},
        ${tagNameRelatedToFontSize}
    `);let remValue;const htmlStyle=getHtmlStyle(document);if(closestFontSizedEl){const useFontSizeInput=closestFontSizedEl.style.fontSize;if(useFontSizeInput){return parseFloat(getComputedStyle(closestStartContainerEl).fontSize);}
const fontSizeClass=FONT_SIZE_CLASSES.find((className)=>closestFontSizedEl.classList.contains(className));let fsName;if(fontSizeClass){fsName=fontSizeClass.substring(0,fontSizeClass.length-3);}else{fsName=styleClassesRelatedToFontSize.find((className)=>closestFontSizedEl.classList.contains(className))||closestFontSizedEl.tagName.toLowerCase();}
remValue=parseFloat(getCSSVariableValue(`${fsName}-font-size`,htmlStyle));}
const pxValue=remValue&&convertNumericToUnit(remValue,"rem","px",htmlStyle);return pxValue||parseFloat(getComputedStyle(closestStartContainerEl).fontSize);}
return __exports;});;

/* /html_editor/static/src/utils/html.js */
odoo.define('@html_editor/utils/html',[],function(require){'use strict';let __exports={};__exports.parseHTML=parseHTML;function parseHTML(document,html){const fragment=document.createDocumentFragment();const parser=new document.defaultView.DOMParser();const parsedDocument=parser.parseFromString(html,"text/html");fragment.replaceChildren(...parsedDocument.body.childNodes);return fragment;}
__exports.normalizeHTML=normalizeHTML;function normalizeHTML(content,cleanup=()=>{}){const parser=new document.defaultView.DOMParser();const body=parser.parseFromString(content,"text/html").body;cleanup(body);return body.innerHTML;}
return __exports;});;

/* /html_editor/static/src/utils/image.js */
odoo.define('@html_editor/utils/image',['@html_editor/utils/color'],function(require){'use strict';let __exports={};const{isColorGradient}=require("@html_editor/utils/color");__exports.backgroundImageCssToParts=backgroundImageCssToParts;function backgroundImageCssToParts(css){const parts={};css=css||"";if(css.startsWith("url(")){const urlEnd=css.indexOf(")")+1;parts.url=css.substring(0,urlEnd).trim();const commaPos=css.indexOf(",",urlEnd);css=commaPos>0?css.substring(commaPos+1):"";}
if(isColorGradient(css)){parts.gradient=css.trim();}
return parts;}
__exports.backgroundImagePartsToCss=backgroundImagePartsToCss;function backgroundImagePartsToCss(parts){let css=parts.url||"";if(parts.gradient){css+=(css?", ":"")+parts.gradient;}
return css||"none";}
return __exports;});;

/* /html_editor/static/src/utils/image_processing.js */
odoo.define('@html_editor/utils/image_processing',['@web/core/network/rpc','@web/core/utils/objects','@html_editor/utils/perspective_utils'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{pick}=require("@web/core/utils/objects");const{getAffineApproximation,getProjective}=require("@html_editor/utils/perspective_utils");const cropperDataFields=__exports.cropperDataFields=["x","y","width","height","rotate","scaleX","scaleY"];const isGif=__exports.isGif=(mimetype)=>mimetype==="image/gif";const _applyAll=(result,filter,filters)=>{filters.forEach((f)=>{if(f[0]==="blend"){const cv=f[1];const ctx=result.getContext("2d");ctx.globalCompositeOperation=f[2];ctx.globalAlpha=f[3];ctx.drawImage(cv,0,0);ctx.globalCompositeOperation="source-over";ctx.globalAlpha=1.0;}else{filter.addFilter(...f);}});};let applyAll;const glFilters={blur:(filter)=>filter.addFilter("blur",10),1977:(filter,cv)=>{const ctx=cv.getContext("2d");ctx.fillStyle="rgb(243, 106, 188)";ctx.fillRect(0,0,cv.width,cv.height);applyAll(filter,[["blend",cv,"screen",0.3],["brightness",0.1],["contrast",0.1],["saturation",0.3],]);},aden:(filter,cv)=>{const ctx=cv.getContext("2d");ctx.fillStyle="rgb(66, 10, 14)";ctx.fillRect(0,0,cv.width,cv.height);applyAll(filter,[["blend",cv,"darken",0.2],["brightness",0.2],["contrast",-0.1],["saturation",-0.15],["hue",20],]);},brannan:(filter,cv)=>{const ctx=cv.getContext("2d");ctx.fillStyle="rgb(161, 44, 191)";ctx.fillRect(0,0,cv.width,cv.height);applyAll(filter,[["blend",cv,"lighten",0.31],["sepia",0.5],["contrast",0.4],]);},earlybird:(filter,cv)=>{const ctx=cv.getContext("2d");const gradient=ctx.createRadialGradient(cv.width/2,cv.height/2,0,cv.width/2,cv.height/2,Math.hypot(cv.width,cv.height)/2);gradient.addColorStop(0.2,"#D0BA8E");gradient.addColorStop(1,"#1D0210");ctx.fillStyle=gradient;ctx.fillRect(0,0,cv.width,cv.height);applyAll(filter,[["blend",cv,"overlay",0.2],["sepia",0.2],["contrast",-0.1],]);},inkwell:(filter,cv)=>{applyAll(filter,[["sepia",0.3],["brightness",0.1],["contrast",-0.1],["desaturateLuminance"],]);},maven:(filter,cv)=>{applyAll(filter,[["sepia",0.25],["brightness",-0.05],["contrast",-0.05],["saturation",0.5],]);},toaster:(filter,cv)=>{const ctx=cv.getContext("2d");const gradient=ctx.createRadialGradient(cv.width/2,cv.height/2,0,cv.width/2,cv.height/2,Math.hypot(cv.width,cv.height)/2);gradient.addColorStop(0,"#0F4E80");gradient.addColorStop(1,"#3B003B");ctx.fillStyle=gradient;ctx.fillRect(0,0,cv.width,cv.height);applyAll(filter,[["blend",cv,"screen",0.5],["brightness",-0.1],["contrast",0.5],]);},walden:(filter,cv)=>{const ctx=cv.getContext("2d");ctx.fillStyle="#CC4400";ctx.fillRect(0,0,cv.width,cv.height);applyAll(filter,[["blend",cv,"screen",0.3],["sepia",0.3],["brightness",0.1],["saturation",0.6],["hue",350],]);},valencia:(filter,cv)=>{const ctx=cv.getContext("2d");ctx.fillStyle="#3A0339";ctx.fillRect(0,0,cv.width,cv.height);applyAll(filter,[["blend",cv,"exclusion",0.5],["sepia",0.08],["brightness",0.08],["contrast",0.08],]);},xpro:(filter,cv)=>{const ctx=cv.getContext("2d");const gradient=ctx.createRadialGradient(cv.width/2,cv.height/2,0,cv.width/2,cv.height/2,Math.hypot(cv.width,cv.height)/2);gradient.addColorStop(0.4,"#E0E7E6");gradient.addColorStop(1,"#2B2AA1");ctx.fillStyle=gradient;ctx.fillRect(0,0,cv.width,cv.height);applyAll(filter,[["blend",cv,"color-burn",0.7],["sepia",0.3],]);},custom:(filter,cv,filterOptions)=>{const options=Object.assign({blend:"normal",filterColor:"",blur:"0",desaturateLuminance:"0",saturation:"0",contrast:"0",brightness:"0",sepia:"0",},JSON.parse(filterOptions||"{}"));const filters=[];if(options.filterColor){const ctx=cv.getContext("2d");ctx.fillStyle=options.filterColor;ctx.fillRect(0,0,cv.width,cv.height);filters.push(["blend",cv,options.blend,1]);}
delete options.blend;delete options.filterColor;filters.push(...Object.entries(options).map(([filter,amount])=>[filter,parseInt(amount)/100]));applyAll(filter,filters);},};__exports.applyModifications=applyModifications;async function applyModifications(img,cropper,dataOptions={}){const data=Object.assign({glFilter:"",filter:"#0000",quality:"75",forceModification:false,},img.dataset,dataOptions);let{width,height,resizeWidth,quality,filter,mimetype,originalSrc,glFilter,filterOptions,forceModification,perspective,svgAspectRatio,imgAspectRatio,}=data;[width,height,resizeWidth]=[width,height,resizeWidth].map((s)=>parseFloat(s));quality=parseInt(quality);if(isGif(mimetype)&&!forceModification){return await _loadImageDataURL(originalSrc);}
const container=document.createElement("div");const original=await loadImage(originalSrc);originalSrc=original.getAttribute("src");container.appendChild(original);let croppedImg=cropper.getCroppedCanvas(width,height);if(imgAspectRatio){document.createElement("div").appendChild(croppedImg);imgAspectRatio=imgAspectRatio.split(":");imgAspectRatio=parseFloat(imgAspectRatio[0])/parseFloat(imgAspectRatio[1]);const croppedCropper=await activateCropper(croppedImg,imgAspectRatio,{y:0});croppedImg=croppedCropper.cropper("getCroppedCanvas");croppedCropper.destroy();}
const result=document.createElement("canvas");result.width=resizeWidth||croppedImg.width;result.height=perspective?result.width/svgAspectRatio:(croppedImg.height*result.width)/croppedImg.width;const ctx=result.getContext("2d");ctx.imageSmoothingQuality="high";ctx.mozImageSmoothingEnabled=true;ctx.webkitImageSmoothingEnabled=true;ctx.msImageSmoothingEnabled=true;ctx.imageSmoothingEnabled=true;if(perspective){const points=JSON.parse(perspective);const divisions=10;const w=croppedImg.width,h=croppedImg.height;const project=getProjective(w,h,[[(result.width/100)*points[0][0],(result.height/100)*points[0][1]],[(result.width/100)*points[1][0],(result.height/100)*points[1][1]],[(result.width/100)*points[2][0],(result.height/100)*points[2][1]],[(result.width/100)*points[3][0],(result.height/100)*points[3][1]],]);for(let i=0;i<divisions;i++){for(let j=0;j<divisions;j++){const[dx,dy]=[w/divisions,h/divisions];const upper={origin:[i*dx,j*dy],sides:[dx,dy],flange:0.1,overlap:0,};const lower={origin:[i*dx+dx,j*dy+dy],sides:[-dx,-dy],flange:0,overlap:0.1,};for(let{origin,sides,flange,overlap}of[upper,lower]){const[[a,c,e],[b,d,f]]=getAffineApproximation(project,[origin,[origin[0]+sides[0],origin[1]],[origin[0],origin[1]+sides[1]],]);const ox=(i!==divisions?overlap*sides[0]:0)+flange*sides[0];const oy=(j!==divisions?overlap*sides[1]:0)+flange*sides[1];origin[0]+=flange*sides[0];origin[1]+=flange*sides[1];sides[0]-=flange*sides[0];sides[1]-=flange*sides[1];ctx.save();ctx.setTransform(a,b,c,d,e,f);ctx.beginPath();ctx.moveTo(origin[0]-ox,origin[1]-oy);ctx.lineTo(origin[0]+sides[0],origin[1]-oy);ctx.lineTo(origin[0]+sides[0],origin[1]);ctx.lineTo(origin[0],origin[1]+sides[1]);ctx.lineTo(origin[0]-ox,origin[1]+sides[1]);ctx.closePath();ctx.clip();ctx.drawImage(croppedImg,0,0);ctx.restore();}}}}else{ctx.drawImage(croppedImg,0,0,croppedImg.width,croppedImg.height,0,0,result.width,result.height);}
if(glFilter){const glf=new window.WebGLImageFilter();const cv=document.createElement("canvas");cv.width=result.width;cv.height=result.height;applyAll=_applyAll.bind(null,result);glFilters[glFilter](glf,cv,filterOptions);const filtered=glf.apply(result);ctx.drawImage(filtered,0,0,filtered.width,filtered.height,0,0,result.width,result.height);}
ctx.fillStyle=filter||"#0000";ctx.fillRect(0,0,result.width,result.height);const dataURL=result.toDataURL(mimetype,quality/100);const newSize=getDataURLBinarySize(dataURL);const originalSize=_getImageSizeFromCache(originalSrc);const isChanged=!!perspective||!!glFilter||original.width!==result.width||original.height!==result.height||original.width!==croppedImg.width||original.height!==croppedImg.height;return isChanged||originalSize>=newSize?dataURL:await _loadImageDataURL(originalSrc);}
__exports.loadImage=loadImage;function loadImage(src,img=new Image()){const handleImage=(source,resolve,reject)=>{img.addEventListener("load",()=>resolve(img),{once:true});img.addEventListener("error",reject,{once:true});img.src=source;};const placeholderHref="/web/image/__odoo__unknown__src__/";return new Promise((resolve,reject)=>{fetch(src).then((response)=>{if(!response.ok){src=placeholderHref;}
handleImage(src,resolve,reject);}).catch((error)=>{src=placeholderHref;handleImage(src,resolve,reject);});});}
const imageCache=new Map();function _loadImageObjectURL(src){return _updateImageData(src);}
function _loadImageDataURL(src){return _updateImageData(src,"dataURL");}
async function _updateImageData(src,key="objectURL"){const currentImageData=imageCache.get(src);if(currentImageData&&currentImageData[key]){return currentImageData[key];}
let value="";const blob=await fetch(src).then((res)=>res.blob());if(key==="dataURL"){value=await createDataURL(blob);}else{value=URL.createObjectURL(blob);}
imageCache.set(src,Object.assign(currentImageData||{},{[key]:value,size:blob.size}));return value;}
function _getImageSizeFromCache(src){return imageCache.get(src).size;}
__exports.activateCropper=activateCropper;async function activateCropper(image,aspectRatio,dataset){const oldSrc=image.src;const newSrc=await _loadImageObjectURL(image.getAttribute("src"));image.src=newSrc;const cropper=new Cropper(image,{viewMode:2,dragMode:"move",autoCropArea:1.0,aspectRatio:aspectRatio,data:Object.fromEntries(Object.entries(pick(dataset,...cropperDataFields)).map(([key,value])=>[key,parseFloat(value),])),minContainerWidth:1,minContainerHeight:1,});if(oldSrc===newSrc&&image.complete){return;}
return cropper;}
__exports.loadImageInfo=loadImageInfo;async function loadImageInfo(img,attachmentSrc=""){const src=attachmentSrc||img.getAttribute("src");if((img.dataset.originalSrc&&img.dataset.mimetypeBeforeConversion)||!src){return;}
let docHref=img.ownerDocument.defaultView.location.href;if(docHref.startsWith("about:")){docHref=window.location.href;}
const srcUrl=new URL(src,docHref);const relativeSrc=srcUrl.pathname;const{original}=await rpc("/html_editor/get_image_info",{src:relativeSrc});if(original&&original.image_src&&!/\/web\/image\/\d+-redirect\//.test(original.image_src)){if(!img.dataset.mimetype){img.dataset.mimetype=original.mimetype;}
img.dataset.originalId=original.id;img.dataset.originalSrc=original.image_src;img.dataset.mimetypeBeforeConversion=original.mimetype;}}
__exports.createDataURL=createDataURL;function createDataURL(blob){return new Promise((resolve,reject)=>{const reader=new FileReader();reader.addEventListener("load",()=>resolve(reader.result));reader.addEventListener("abort",reject);reader.addEventListener("error",reject);reader.readAsDataURL(blob);});}
__exports.getDataURLBinarySize=getDataURLBinarySize;function getDataURLBinarySize(dataURL){return(dataURL.split(",")[1].length/4)*3;}
return __exports;});;

/* /html_editor/static/src/utils/list.js */
odoo.define('@html_editor/utils/list',['@html_editor/utils/dom'],function(require){'use strict';let __exports={};const{removeClass,setTagName}=require("@html_editor/utils/dom");__exports.getListMode=getListMode;function getListMode(pnode){if(!["UL","OL"].includes(pnode.tagName)){return;}
if(pnode.tagName==="OL"){return"OL";}
return pnode.classList.contains("o_checklist")?"CL":"UL";}
__exports.switchListMode=switchListMode;function switchListMode(list,newMode){if(getListMode(list)===newMode){return;}
const newTag=newMode==="CL"?"UL":newMode;const newList=setTagName(list,newTag);newList.style.removeProperty("list-style");for(const li of newList.children){if(li.style.listStyle!=="none"){li.style.listStyle=null;if(!li.style.all){li.removeAttribute("style");}}}
removeClass(newList,"o_checklist");if(newMode==="CL"){newList.classList.add("o_checklist");}
return newList;}
__exports.convertList=convertList;function convertList(node,newMode){if(!["UL","OL","LI"].includes(node.tagName)){return;}
const listMode=getListMode(node);if(listMode&&newMode!==listMode){node=switchListMode(node,newMode);}
for(const child of node.children){convertList(child,newMode);}
return node;}
return __exports;});;

/* /html_editor/static/src/utils/perspective_utils.js */
odoo.define('@html_editor/utils/perspective_utils',[],function(require){'use strict';let __exports={};__exports.transform=transform;function transform([[a,b,c],[d,e,f],[g,h,i]],[x,y]){let z=g*x+h*y+i;return[(a*x+b*y+c)/z,(d*x+e*y+f)/z];}
function invert([[a,b,c],[d,e,f],[g,h,i]]){const determinant=a*e*i-a*f*h-b*d*i+b*f*g+c*d*h-c*e*g;return[[(e*i-h*f)/determinant,(h*c-b*i)/determinant,(b*f-e*c)/determinant],[(g*f-d*i)/determinant,(a*i-g*c)/determinant,(d*c-a*f)/determinant],[(d*h-g*e)/determinant,(g*b-a*h)/determinant,(a*e-d*b)/determinant],];}
function multiply(a,b){const[[a0,a1,a2],[a3,a4,a5],[a6,a7,a8]]=a;const[[b0,b1,b2],[b3,b4,b5],[b6,b7,b8]]=b;return[[a0*b0+a1*b3+a2*b6,a0*b1+a1*b4+a2*b7,a0*b2+a1*b5+a2*b8],[a3*b0+a4*b3+a5*b6,a3*b1+a4*b4+a5*b7,a3*b2+a4*b5+a5*b8],[a6*b0+a7*b3+a8*b6,a6*b1+a7*b4+a8*b7,a6*b2+a7*b5+a8*b8],];}
__exports.getProjective=getProjective;function getProjective(width,height,[[x0,y0],[x1,y1],[x2,y2],[x3,y3]]){const denominator=x3*(y1-y2)+x1*(y2-y3)+x2*(y3-y1);const a=(x0*(y2-y3)+x2*(y3-y0)+x3*(y0-y2))/denominator;const b=(x0*(y3-y1)+x3*(y1-y0)+x1*(y0-y3))/denominator;const c=(x0*(y1-y2)+x1*(y2-y0)+x2*(y0-y1))/denominator;const reverse=invert([[width,-width,0],[0,-height,height],[1,-1,1]]);const forward=[[a*x1,b*x2,c*x3],[a*y1,b*y2,c*y3],[a,b,c]];return multiply(forward,reverse);}
__exports.getAffineApproximation=getAffineApproximation;function getAffineApproximation(projective,[[x0,y0],[x1,y1],[x2,y2]]){const a=transform(projective,[x0,y0]);const b=transform(projective,[x1,y1]);const c=transform(projective,[x2,y2]);return multiply([[a[0],b[0],c[0]],[a[1],b[1],c[1]],[1,1,1]],invert([[x0,x1,x2],[y0,y1,y2],[1,1,1]]),);}
return __exports;});;

/* /html_editor/static/src/utils/position.js */
odoo.define('@html_editor/utils/position',[],function(require){'use strict';let __exports={};const DIRECTIONS=__exports.DIRECTIONS={LEFT:false,RIGHT:true,};__exports.leftPos=leftPos;function leftPos(node){return[node.parentElement,childNodeIndex(node)];}
__exports.rightPos=rightPos;function rightPos(node){return[node.parentElement,childNodeIndex(node)+1];}
__exports.boundariesOut=boundariesOut;function boundariesOut(node){const index=childNodeIndex(node);return[node.parentElement,index,node.parentElement,index+1];}
__exports.boundariesIn=boundariesIn;function boundariesIn(node){return[node,0,node,nodeSize(node)];}
__exports.startPos=startPos;function startPos(node){return[node,0];}
__exports.endPos=endPos;function endPos(node){return[node,nodeSize(node)];}
__exports.childNodeIndex=childNodeIndex;function childNodeIndex(node){let i=0;while(node.previousSibling){i++;node=node.previousSibling;}
return i;}
__exports.nodeSize=nodeSize;function nodeSize(node){const isTextNode=node.nodeType===Node.TEXT_NODE;if(isTextNode){return node.length;}else{const child=node.lastChild;return child?childNodeIndex(child)+1:0;}}
return __exports;});;

/* /html_editor/static/src/utils/regex.js */
odoo.define('@html_editor/utils/regex',[],function(require){'use strict';let __exports={};const tldWhitelist=['com','net','org','ac','ad','ae','af','ag','ai','al','am','an','ao','aq','ar','as','at','au','aw','ax','az','ba','bb','bd','be','bf','bg','bh','bi','bj','bl','bm','bn','bo','br','bq','bs','bt','bv','bw','by','bz','ca','cc','cd','cf','cg','ch','ci','ck','cl','cm','cn','co','cr','cs','cu','cv','cw','cx','cy','cz','dd','de','dj','dk','dm','do','dz','ec','ee','eg','eh','er','es','et','eu','fi','fj','fk','fm','fo','fr','ga','gb','gd','ge','gf','gg','gh','gi','gl','gm','gn','gp','gq','gr','gs','gt','gu','gw','gy','hk','hm','hn','hr','ht','hu','id','ie','il','im','in','io','iq','ir','is','it','je','jm','jo','jp','ke','kg','kh','ki','km','kn','kp','kr','kw','ky','kz','la','lb','lc','li','lk','lr','ls','lt','lu','lv','ly','ma','mc','md','me','mf','mg','mh','mk','ml','mm','mn','mo','mp','mq','mr','ms','mt','mu','mv','mw','mx','my','mz','na','nc','ne','nf','ng','ni','nl','no','np','nr','nu','nz','om','pa','pe','pf','pg','ph','pk','pl','pm','pn','pr','ps','pt','pw','py','qa','re','ro','rs','ru','rw','sa','sb','sc','sd','se','sg','sh','si','sj','sk','sl','sm','sn','so','sr','ss','st','su','sv','sx','sy','sz','tc','td','tf','tg','th','tj','tk','tl','tm','tn','to','tp','tr','tt','tv','tw','tz','ua','ug','uk','um','us','uy','uz','va','vc','ve','vg','vi','vn','vu','wf','ws','ye','yt','yu','za','zm','zr','zw','co\\.uk'];const urlRegexBase=`|(?:www.))[-a-zA-Z0-9@:%._\\+~#=]{2,256}\\.[a-zA-Z][a-zA-Z0-9]{1,62}|(?:[-a-zA-Z0-9@:%._\\+~#=]{2,256}\\.(?:${tldWhitelist.join('|')})\\b))(?:(?:[/?#])[^\\s]*[^!.,})\\]'"\\s]|(?:[^!(){}.,[\\]'"\\s]+))?`;const httpCapturedRegex=`(https?:\\/\\/)`;const URL_REGEX=__exports.URL_REGEX=new RegExp(`((?:(?:${httpCapturedRegex}${urlRegexBase})`,'i');return __exports;});;

/* /html_editor/static/src/utils/resource.js */
odoo.define('@html_editor/utils/resource',[],function(require){'use strict';let __exports={};const resourceSequenceSymbol=__exports.resourceSequenceSymbol=Symbol("resourceSequence");__exports.withSequence=withSequence;function withSequence(sequenceNumber,object){return{[resourceSequenceSymbol]:sequenceNumber,object,};}
return __exports;});;

/* /html_editor/static/src/utils/sanitize.js */
odoo.define('@html_editor/utils/sanitize',['@html_editor/utils/dom_info','@html_editor/utils/dom','@odoo/owl'],function(require){'use strict';let __exports={};const{containsAnyInline}=require("@html_editor/utils/dom_info");const{wrapInlinesInBlocks}=require("@html_editor/utils/dom");const{markup}=require("@odoo/owl");__exports.initElementForEdition=initElementForEdition;function initElementForEdition(element,options={}){if(element?.nodeType===Node.ELEMENT_NODE&&containsAnyInline(element)&&!options.allowInlineAtRoot){wrapInlinesInBlocks(element,{baseContainerNodeName:"DIV",});}}
__exports.fixInvalidHTML=fixInvalidHTML;function fixInvalidHTML(content){if(!content){return content;}
const regex=/<\s*(a|strong|t|span)[^<]*?\/\s*>/g;return content.replace(regex,(match,g0)=>match.replace(/\/\s*>/,`></${g0}>`));}
let Markup=null;__exports.instanceofMarkup=instanceofMarkup;function instanceofMarkup(value){if(!Markup){Markup=markup("").constructor;}
return value instanceof Markup;}
return __exports;});;

/* /html_editor/static/src/utils/selection.js */
odoo.define('@html_editor/utils/selection',['@html_editor/utils/blocks','@html_editor/utils/dom_info','@html_editor/utils/dom_state','@html_editor/utils/dom_traversal','@html_editor/utils/position'],function(require){'use strict';let __exports={};const{closestBlock,isBlock}=require("@html_editor/utils/blocks");const{getDeepestPosition,isContentEditable,isNotEditableNode,isSelfClosingElement,nextLeaf,previousLeaf,}=require("@html_editor/utils/dom_info");const{isFakeLineBreak}=require("@html_editor/utils/dom_state");const{closestElement,createDOMPathGenerator}=require("@html_editor/utils/dom_traversal");const{DIRECTIONS,childNodeIndex,endPos,leftPos,nodeSize,rightPos,startPos,}=require("@html_editor/utils/position");__exports.getCursorDirection=getCursorDirection;function getCursorDirection(anchorNode,anchorOffset,focusNode,focusOffset){if(anchorNode===focusNode){if(anchorOffset===focusOffset){return false;}
return anchorOffset<focusOffset?DIRECTIONS.RIGHT:DIRECTIONS.LEFT;}
return anchorNode.compareDocumentPosition(focusNode)&Node.DOCUMENT_POSITION_FOLLOWING?DIRECTIONS.RIGHT:DIRECTIONS.LEFT;}
__exports.findInSelection=findInSelection;function findInSelection(selection,selector){const selectorInStartAncestors=closestElement(selection.startContainer,selector);if(selectorInStartAncestors){return selectorInStartAncestors;}else{const commonElementAncestor=closestElement(selection.commonAncestorContainer);return(commonElementAncestor&&[...commonElementAncestor.querySelectorAll(selector)].find((node)=>selection.intersectsNode(node)));}}
const leftLeafOnlyInScopeNotBlockEditablePath=createDOMPathGenerator(DIRECTIONS.LEFT,{leafOnly:true,inScope:true,stopTraverseFunction:(node)=>isNotEditableNode(node)||isBlock(node),stopFunction:(node)=>isNotEditableNode(node)||isBlock(node),});const rightLeafOnlyInScopeNotBlockEditablePath=createDOMPathGenerator(DIRECTIONS.RIGHT,{leafOnly:true,inScope:true,stopTraverseFunction:(node)=>isNotEditableNode(node)||isBlock(node),stopFunction:(node)=>isNotEditableNode(node)||isBlock(node),});__exports.normalizeSelfClosingElement=normalizeSelfClosingElement;function normalizeSelfClosingElement(node,offset){if(isSelfClosingElement(node)){[node,offset]=rightPos(node);}
return[node,offset];}
__exports.normalizeNotEditableNode=normalizeNotEditableNode;function normalizeNotEditableNode(node,offset,position="right"){const editable=closestElement(node,".odoo-editor-editable");let closest=closestElement(node);while(closest&&closest!==editable&&!closest.isContentEditable){[node,offset]=position==="right"?rightPos(node):leftPos(node);closest=node;}
return[node,offset];}
__exports.normalizeCursorPosition=normalizeCursorPosition;function normalizeCursorPosition(node,offset,position="right"){[node,offset]=normalizeSelfClosingElement(node,offset);[node,offset]=normalizeNotEditableNode(node,offset,position);return[node,offset];}
__exports.normalizeFakeBR=normalizeFakeBR;function normalizeFakeBR(node,offset){const prevNode=node.nodeType===Node.ELEMENT_NODE&&node.childNodes[offset-1];if(prevNode&&prevNode.nodeName==="BR"&&isFakeLineBreak(prevNode)){offset--;}
return[node,offset];}
__exports.normalizeDeepCursorPosition=normalizeDeepCursorPosition;function normalizeDeepCursorPosition(node,offset){let el;let elOffset;if(node.nodeType===Node.ELEMENT_NODE){el=node;elOffset=offset;}else if(node.nodeType===Node.TEXT_NODE){if(offset===0){el=node.parentNode;elOffset=childNodeIndex(node);}else if(offset===node.length){el=node.parentNode;elOffset=childNodeIndex(node)+1;}}
if(el){const leftInlineNode=leftLeafOnlyInScopeNotBlockEditablePath(el,elOffset).next().value;let leftVisibleEmpty=false;if(leftInlineNode){leftVisibleEmpty=isSelfClosingElement(leftInlineNode)||!isContentEditable(leftInlineNode);[node,offset]=leftVisibleEmpty?rightPos(leftInlineNode):endPos(leftInlineNode);}
if(!leftInlineNode||leftVisibleEmpty){const rightInlineNode=rightLeafOnlyInScopeNotBlockEditablePath(el,elOffset).next().value;if(rightInlineNode){const closest=closestElement(rightInlineNode);const rightVisibleEmpty=isSelfClosingElement(rightInlineNode)||!closest||!closest.isContentEditable;if(!(leftVisibleEmpty&&rightVisibleEmpty)){[node,offset]=rightVisibleEmpty?leftPos(rightInlineNode):startPos(rightInlineNode);}}}}
return[node,offset];}
function updateCursorBeforeMove(destParent,destIndex,node,cursor){if(cursor.node===destParent&&cursor.offset>=destIndex){cursor.offset+=1;}else if(cursor.node===node.parentNode){const childIndex=childNodeIndex(node);if(cursor.offset===childIndex){[cursor.node,cursor.offset]=[destParent,destIndex];}else if(cursor.offset>childIndex){cursor.offset-=1;}}}
function updateCursorBeforeRemove(node,cursor){if(node.contains(cursor.node)){[cursor.node,cursor.offset]=[node.parentNode,childNodeIndex(node)];}else if(cursor.node===node.parentNode&&cursor.offset>childNodeIndex(node)){cursor.offset-=1;}}
function updateCursorBeforeUnwrap(node,cursor){if(cursor.node===node){[cursor.node,cursor.offset]=[node.parentNode,cursor.offset+childNodeIndex(node)];}else if(cursor.node===node.parentNode&&cursor.offset>childNodeIndex(node)){cursor.offset+=nodeSize(node)-1;}}
function updateCursorBeforeMergeIntoPreviousSibling(node,cursor){if(cursor.node===node){cursor.node=node.previousSibling;cursor.offset+=node.previousSibling.childNodes.length;}else if(cursor.node===node.parentNode){const childIndex=childNodeIndex(node);if(cursor.offset===childIndex){cursor.node=node.previousSibling;cursor.offset=node.previousSibling.childNodes.length;}else if(cursor.offset>childIndex){cursor.offset--;}}}
const callbacksForCursorUpdate=__exports.callbacksForCursorUpdate={remove:(node)=>(cursor)=>updateCursorBeforeRemove(node,cursor),before:(ref,node)=>(cursor)=>updateCursorBeforeMove(ref.parentNode,childNodeIndex(ref),node,cursor),after:(ref,node)=>(cursor)=>updateCursorBeforeMove(ref.parentNode,childNodeIndex(ref)+1,node,cursor),append:(to,node)=>(cursor)=>updateCursorBeforeMove(to,to.childNodes.length,node,cursor),prepend:(to,node)=>(cursor)=>updateCursorBeforeMove(to,0,node,cursor),unwrap:(node)=>(cursor)=>updateCursorBeforeUnwrap(node,cursor),merge:(node)=>(cursor)=>updateCursorBeforeMergeIntoPreviousSibling(node,cursor),};__exports.getAdjacentCharacter=getAdjacentCharacter;function getAdjacentCharacter(selection,side,editable){let{focusNode,focusOffset}=selection;[focusNode,focusOffset]=getDeepestPosition(focusNode,focusOffset);const originalBlock=closestBlock(focusNode);let adjacentCharacter;while(!adjacentCharacter&&focusNode){if(side==="previous"){adjacentCharacter=focusOffset>0&&focusNode.textContent[focusOffset-1];}else{adjacentCharacter=focusNode.textContent[focusOffset];}
if(!adjacentCharacter){if(side==="previous"){focusNode=previousLeaf(focusNode,editable);focusOffset=focusNode&&nodeSize(focusNode);}else{focusNode=nextLeaf(focusNode,editable);focusOffset=0;}
const characterIndex=side==="previous"?focusOffset-1:focusOffset;adjacentCharacter=focusNode&&focusNode.textContent[characterIndex];}}
if(!focusNode||!isContentEditable(focusNode)||closestBlock(focusNode)!==originalBlock){return undefined;}
return adjacentCharacter;}
return __exports;});;

/* /html_editor/static/src/utils/table.js */
odoo.define('@html_editor/utils/table',['@html_editor/utils/dom_traversal'],function(require){'use strict';let __exports={};const{closestElement}=require("@html_editor/utils/dom_traversal");__exports.getRowIndex=getRowIndex;function getRowIndex(trOrTd){const tr=closestElement(trOrTd,"tr");return tr.rowIndex;}
__exports.getColumnIndex=getColumnIndex;function getColumnIndex(td){return td.cellIndex;}
return __exports;});;

/* /html_editor/static/src/utils/url.js */
odoo.define('@html_editor/utils/url',[],function(require){'use strict';let __exports={};__exports.checkURL=checkURL;function checkURL(url,hostnameList){if(url){let potentialURL;try{potentialURL=new URL(url);}catch{return false;}
if(hostnameList.includes(potentialURL.hostname)){return`https://${potentialURL.hostname}${potentialURL.pathname}`;}}
return false;}
__exports.isImageUrl=isImageUrl;function isImageUrl(url){const urlFileExtention=url.split(".").pop();return["jpg","jpeg","png","gif","svg","webp"].includes(urlFileExtention.toLowerCase());}
__exports.getVideoUrl=getVideoUrl;function getVideoUrl(platform,videoId,params){let url;switch(platform){case"youtube":url=new URL(`https://www.youtube.com/embed/${videoId}`);break;case"vimeo":url=new URL(`https://player.vimeo.com/video/${videoId}`);break;case"dailymotion":url=new URL(`https://www.dailymotion.com/embed/video/${videoId}`);break;case"instagram":url=new URL(`https://www.instagram.com/p/${videoId}/embed`);break;case"youku":url=new URL(`https://player.youku.com/embed/${videoId}`);break;default:throw new Error(`Unsupported platform: ${platform}`);}
url.search=new URLSearchParams(params);return url;}
return __exports;});;

/* /html_editor/static/src/wysiwyg.js */
odoo.define('@html_editor/wysiwyg',['@odoo/owl','@html_editor/editor','@html_editor/main/toolbar/toolbar','@web/core/utils/hooks','@html_editor/local_overlay_container','@web/core/utils/functions'],function(require){'use strict';let __exports={};const{Component,onMounted,onWillDestroy,useRef,useState,useSubEnv}=require("@odoo/owl");const{Editor}=require("@html_editor/editor");const{Toolbar}=require("@html_editor/main/toolbar/toolbar");const{useChildRef,useSpellCheck}=require("@web/core/utils/hooks");const{LocalOverlayContainer}=require("@html_editor/local_overlay_container");const{uniqueId}=require("@web/core/utils/functions");function copyCssRules(sourceDoc,targetDoc){for(const sheet of sourceDoc.styleSheets){const rules=[];for(const r of sheet.cssRules){rules.push(r.cssText);}
const cssRules=rules.join(" ");const styleTag=targetDoc.createElement("style");styleTag.appendChild(targetDoc.createTextNode(cssRules));targetDoc.head.appendChild(styleTag);}}
const Wysiwyg=__exports.Wysiwyg=class Wysiwyg extends Component{static template="html_editor.Wysiwyg";static components={Toolbar,LocalOverlayContainer};static props={config:{type:Object,optional:true},class:{type:String,optional:true},contentClass:{type:String,optional:true},style:{type:String,optional:true},toolbar:{type:Boolean,optional:true},iframe:{type:Boolean,optional:true},copyCss:{type:Boolean,optional:true},onLoad:{type:Function,optional:true},onBlur:{type:Function,optional:true},dynamicPlaceholder:{type:Boolean,optional:true},};static defaultProps={onLoad:()=>{},onBlur:()=>{},};setup(){this.state=useState({showToolbar:false,});this.overlayRef=useChildRef();useSubEnv({localOverlayContainerKey:uniqueId("wysiwyg"),});const contentRef=useRef("content");this.editor=this.props.editor;const config=this.getEditorConfig();this.editor=new Editor(config,this.env.services);this.props.onLoad(this.editor);useSpellCheck({refName:"content",});onMounted(()=>{this.state.showToolbar=true;const el=contentRef.el;if(el.tagName==="IFRAME"){const attachEditor=()=>{if(!this.editor.isDestroyed){if(this.props.copyCss){copyCssRules(document,el.contentDocument);}
const additionalClasses=el.dataset.class?.trim().split(" ");if(additionalClasses){for(const c of additionalClasses){el.contentDocument.body.classList.add(c);}}
this.editor.attachTo(el.contentDocument.body);}};if(el.contentDocument.readyState==="complete"){attachEditor();}else{el.addEventListener("load",()=>{attachEditor();this.render();},{once:true});}}else{this.editor.attachTo(el);}});onWillDestroy(()=>this.editor.destroy(true));}
getEditorConfig(){return{...this.props.config,embeddedComponentInfo:{app:this.__owl__.app,env:this.env},localOverlayContainers:{key:this.env.localOverlayContainerKey,ref:this.overlayRef,},disableFloatingToolbar:this.props.toolbar,};}}
return __exports;});;

/* /web_unsplash/static/src/media_dialog/image_selector_patch.js */
odoo.define('@web_unsplash/media_dialog/image_selector_patch',['@web/core/l10n/translation','@web/core/utils/patch','@web/core/utils/concurrency','@web/core/network/rpc','@web/core/utils/hooks','@html_editor/main/media/media_dialog/image_selector','@web_unsplash/unsplash_error/unsplash_error','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{KeepLast}=require("@web/core/utils/concurrency");const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{ImageSelector}=require("@html_editor/main/media/media_dialog/image_selector");const{UnsplashError}=require("@web_unsplash/unsplash_error/unsplash_error");const{useState}=require("@odoo/owl");patch(ImageSelector.prototype,{setup(){super.setup();this.unsplash=useService("unsplash");this.keepLastUnsplash=new KeepLast();this.unsplashState=useState({unsplashRecords:[],isFetchingUnsplash:false,isMaxed:false,unsplashError:null,useUnsplash:true,});this.NUMBER_OF_RECORDS_TO_DISPLAY=30;this.errorMessages={key_not_found:{title:_t("Setup Unsplash to access royalty free photos."),subtitle:"",},401:{title:_t("Unauthorized Key"),subtitle:_t("Please check your Unsplash access key and application ID."),},403:{title:_t("Search is temporarily unavailable"),subtitle:_t("The max number of searches is exceeded. Please retry in an hour or extend to a better account."),},};},get canLoadMore(){if(this.state.searchService==="all"){return(super.canLoadMore||(this.state.needle&&!this.unsplashState.isMaxed&&!this.unsplashState.unsplashError));}else if(this.state.searchService==="unsplash"){return(this.state.needle&&!this.unsplashState.isMaxed&&!this.unsplashState.unsplashError);}
return super.canLoadMore;},get hasContent(){if(this.state.searchService==="all"){return super.hasContent||!!this.unsplashState.unsplashRecords.length;}else if(this.state.searchService==="unsplash"){return!!this.unsplashState.unsplashRecords.length;}
return super.hasContent;},get errorTitle(){if(this.errorMessages[this.unsplashState.unsplashError]){return this.errorMessages[this.unsplashState.unsplashError].title;}
return _t("Something went wrong");},get errorSubtitle(){if(this.errorMessages[this.unsplashState.unsplashError]){return this.errorMessages[this.unsplashState.unsplashError].subtitle;}
return _t("Please check your internet connection or contact administrator.");},get selectedRecordIds(){return this.props.selectedMedia[this.props.id].filter((media)=>media.mediaType==="unsplashRecord").map(({id})=>id);},get isFetching(){return super.isFetching||this.unsplashState.isFetchingUnsplash;},get combinedRecords(){function alternate(a,b){return[a.map((v,i)=>(i<b.length?[v,b[i]]:v)),b.slice(a.length)].flat(2);}
return alternate(this.unsplashState.unsplashRecords,this.state.libraryMedia);},get allAttachments(){return[...super.allAttachments,...this.unsplashState.unsplashRecords];},async fetchUnsplashRecords(offset){if(!this.state.needle){return{records:[],isMaxed:false};}
this.unsplashState.isFetchingUnsplash=true;try{const{isMaxed,images}=await this.unsplash.getImages(this.state.needle,offset,this.NUMBER_OF_RECORDS_TO_DISPLAY,this.props.orientation);this.unsplashState.isFetchingUnsplash=false;this.unsplashState.unsplashError=false;const existingIds=this.unsplashState.unsplashRecords.map((existing)=>existing.id);const newImages=images.filter((record)=>!existingIds.includes(record.id));const records=newImages.map((record)=>{const url=new URL(record.urls.regular);url.searchParams.set("h",2*this.MIN_ROW_HEIGHT);url.searchParams.delete("w");return Object.assign({},record,{url:url.toString(),mediaType:"unsplashRecord",});});return{isMaxed,records};}catch(e){this.unsplashState.isFetchingUnsplash=false;if(e==="no_access"){this.unsplashState.useUnsplash=false;}else{this.unsplashState.unsplashError=e;}
return{records:[],isMaxed:true};}},async loadMore(...args){await super.loadMore(...args);return this.keepLastUnsplash.add(this.fetchUnsplashRecords(this.unsplashState.unsplashRecords.length)).then(({records,isMaxed})=>{this.unsplashState.unsplashRecords.push(...records);this.unsplashState.isMaxed=isMaxed;});},async search(...args){await super.search(...args);await this.searchUnsplash();},async searchUnsplash(){if(!this.state.needle){this.unsplashState.unsplashError=false;this.unsplashState.unsplashRecords=[];this.unsplashState.isMaxed=false;}
return this.keepLastUnsplash.add(this.fetchUnsplashRecords(0)).then(({records,isMaxed})=>{this.unsplashState.unsplashRecords=records;this.unsplashState.isMaxed=isMaxed;});},async onClickRecord(media){this.props.selectMedia({...media,mediaType:"unsplashRecord",query:this.state.needle});if(!this.props.multiSelect){await this.props.save();}},async submitCredentials(key,appId){this.unsplashState.unsplashError=null;await rpc("/web_unsplash/save_unsplash",{key,appId});await this.searchUnsplash();},});ImageSelector.components={...ImageSelector.components,UnsplashError,};return __exports;});;

/* /web_unsplash/static/src/media_dialog/media_dialog_patch.js */
odoo.define('@web_unsplash/media_dialog/media_dialog_patch',['@html_editor/main/media/media_dialog/media_dialog','@web/core/utils/patch','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{MediaDialog,TABS}=require("@html_editor/main/media/media_dialog/media_dialog");const{patch}=require("@web/core/utils/patch");const{useService}=require("@web/core/utils/hooks");patch(MediaDialog.prototype,{setup(){super.setup();this.unsplashService=useService("unsplash");},async save(){const selectedImages=this.selectedMedia[TABS.IMAGES.id];if(selectedImages){const unsplashRecords=selectedImages.filter((media)=>media.mediaType==="unsplashRecord");if(unsplashRecords.length){await this.unsplashService.uploadUnsplashRecords(unsplashRecords,{resModel:this.props.resModel,resId:this.props.resId},(attachments)=>{this.selectedMedia[TABS.IMAGES.id]=this.selectedMedia[TABS.IMAGES.id].filter((media)=>media.mediaType!=="unsplashRecord");this.selectedMedia[TABS.IMAGES.id]=this.selectedMedia[TABS.IMAGES.id].concat(attachments.map((attachment)=>({...attachment,mediaType:"attachment",})));});}}
return super.save(...arguments);},});return __exports;});;

/* /web_unsplash/static/src/unsplash_credentials/unsplash_credentials.js */
odoo.define('@web_unsplash/unsplash_credentials/unsplash_credentials',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const UnsplashCredentials=__exports.UnsplashCredentials=class UnsplashCredentials extends Component{static template="web_unsplash.UnsplashCredentials";static props={submitCredentials:Function,hasCredentialsError:Boolean,};setup(){this.state=useState({key:"",appId:"",hasKeyError:this.props.hasCredentialsError,hasAppIdError:this.props.hasCredentialsError,});}
submitCredentials(){if(this.state.key===""){this.state.hasKeyError=true;}else if(this.state.appId===""){this.state.hasAppIdError=true;}else{this.props.submitCredentials(this.state.key,this.state.appId);}}}
return __exports;});;

/* /web_unsplash/static/src/unsplash_error/unsplash_error.js */
odoo.define('@web_unsplash/unsplash_error/unsplash_error',['@odoo/owl','@web_unsplash/unsplash_credentials/unsplash_credentials'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{UnsplashCredentials}=require("@web_unsplash/unsplash_credentials/unsplash_credentials");const UnsplashError=__exports.UnsplashError=class UnsplashError extends Component{static template="web_unsplash.UnsplashError";static components={UnsplashCredentials,};static props={title:String,subtitle:String,showCredentials:Boolean,submitCredentials:{type:Function,optional:true},hasCredentialsError:{type:Boolean,optional:true},};}
return __exports;});;

/* /web_unsplash/static/src/unsplash_service.js */
odoo.define('@web_unsplash/unsplash_service',['@web/core/network/rpc','@web/core/registry','@web/core/l10n/translation','@html_editor/main/media/media_dialog/upload_progress_toast/upload_service'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{AUTOCLOSE_DELAY}=require("@html_editor/main/media/media_dialog/upload_progress_toast/upload_service");const unsplashService=__exports.unsplashService={dependencies:["upload"],async start(env,{upload}){const _cache={};return{async uploadUnsplashRecords(records,{resModel,resId},onUploaded){upload.incrementId();const file=upload.addFile({id:upload.fileId,name:records.length>1?_t("Uploading %(count)s '%(query)s' images.",{count:records.length,query:records[0].query,}):_t("Uploading '%s' image.",records[0].query),});try{const urls={};for(const record of records){const _1920Url=new URL(record.urls.regular);_1920Url.searchParams.set("w","1920");urls[record.id]={url:_1920Url.href,download_url:record.links.download_location,description:record.alt_description,};}
const xhr=new XMLHttpRequest();xhr.upload.addEventListener("progress",(ev)=>{const rpcComplete=(ev.loaded/ev.total)*100;file.progress=rpcComplete;});xhr.upload.addEventListener("load",function(){file.progress=100;});const attachments=await rpc("/web_unsplash/attachment/add",{res_id:resId,res_model:resModel,unsplashurls:urls,query:records[0].query,},{xhr});if(attachments.error){file.hasError=true;file.errorMessage=attachments.error;}else{file.uploaded=true;await onUploaded(attachments);}
setTimeout(()=>upload.deleteFile(file.id),AUTOCLOSE_DELAY);}catch(error){file.hasError=true;setTimeout(()=>upload.deleteFile(file.id),AUTOCLOSE_DELAY);throw error;}},async getImages(query,offset=0,pageSize=30,orientation){const from=offset;const to=offset+pageSize;let cachedData=orientation?_cache[query+orientation]:_cache[query];if(cachedData&&(cachedData.images.length>=to||(cachedData.totalImages!==0&&cachedData.totalImages<to))){return{images:cachedData.images.slice(from,to),isMaxed:to>cachedData.totalImages,};}
cachedData=await this._fetchImages(query,orientation);return{images:cachedData.images.slice(from,to),isMaxed:to>cachedData.totalImages,};},async _fetchImages(query,orientation){const key=orientation?query+orientation:query;if(!_cache[key]){_cache[key]={images:[],maxPages:0,totalImages:0,pageCached:0,};}
const cachedData=_cache[key];const payload={query:query,page:cachedData.pageCached+1,per_page:30,};if(orientation){payload.orientation=orientation;}
const result=await rpc("/web_unsplash/fetch_images",payload);if(result.error){return Promise.reject(result.error);}
cachedData.pageCached++;cachedData.images.push(...result.results);cachedData.maxPages=result.total_pages;cachedData.totalImages=result.total;return cachedData;},};},};registry.category("services").add("unsplash",unsplashService);return __exports;});;

/* /mail/static/lib/selfie_segmentation/selfie_segmentation.js */
(function(){'use strict';var D;function aa(a){var b=0;return function(){return b<a.length?{done:!1,value:a[b++]}:{done:!0}}}var ba="function"==typeof Object.defineProperties?Object.defineProperty:function(a,b,c){if(a==Array.prototype||a==Object.prototype)return a;a[b]=c.value;return a};function ca(a){a=["object"==typeof globalThis&&globalThis,a,"object"==typeof window&&window,"object"==typeof self&&self,"object"==typeof global&&global];for(var b=0;b<a.length;++b){var c=a[b];if(c&&c.Math==Math)return c}throw Error("Cannot find global object");}var H=ca(this);function J(a,b){if(b)a:{var c=H;a=a.split(".");for(var d=0;d<a.length-1;d++){var f=a[d];if(!(f in c))break a;c=c[f]}a=a[a.length-1];d=c[a];b=b(d);b!=d&&null!=b&&ba(c,a,{configurable:!0,writable:!0,value:b})}}
J("Symbol",function(a){function b(h){if(this instanceof b)throw new TypeError("Symbol is not a constructor");return new c(d+(h||"")+"_"+f++,h)}function c(h,e){this.g=h;ba(this,"description",{configurable:!0,writable:!0,value:e})}if(a)return a;c.prototype.toString=function(){return this.g};var d="jscomp_symbol_"+(1E9*Math.random()>>>0)+"_",f=0;return b});J("Symbol.iterator",function(a){if(a)return a;a=Symbol("Symbol.iterator");for(var b="Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array".split(" "),c=0;c<b.length;c++){var d=H[b[c]];"function"===typeof d&&"function"!=typeof d.prototype[a]&&ba(d.prototype,a,{configurable:!0,writable:!0,value:function(){return da(aa(this))}})}return a});function da(a){a={next:a};a[Symbol.iterator]=function(){return this};return a}
function M(a){var b="undefined"!=typeof Symbol&&Symbol.iterator&&a[Symbol.iterator];return b?b.call(a):{next:aa(a)}}function ea(a){if(!(a instanceof Array)){a=M(a);for(var b,c=[];!(b=a.next()).done;)c.push(b.value);a=c}return a}var fa="function"==typeof Object.create?Object.create:function(a){function b(){}b.prototype=a;return new b},ha;if("function"==typeof Object.setPrototypeOf)ha=Object.setPrototypeOf;else{var ia;a:{var ja={a:!0},ka={};try{ka.__proto__=ja;ia=ka.a;break a}catch(a){}ia=!1}ha=ia?function(a,b){a.__proto__=b;if(a.__proto__!==b)throw new TypeError(a+" is not extensible");return a}:null}var la=ha;function ma(a,b){a.prototype=fa(b.prototype);a.prototype.constructor=a;if(la)la(a,b);else for(var c in b)if("prototype"!=c)if(Object.defineProperties){var d=Object.getOwnPropertyDescriptor(b,c);d&&Object.defineProperty(a,c,d)}else a[c]=b[c];a.ea=b.prototype}function na(){this.l=!1;this.i=null;this.h=void 0;this.g=1;this.s=this.m=0;this.j=null}function oa(a){if(a.l)throw new TypeError("Generator is already running");a.l=!0}na.prototype.o=function(a){this.h=a};function pa(a,b){a.j={U:b,V:!0};a.g=a.m||a.s}na.prototype.return=function(a){this.j={return:a};this.g=this.s};function N(a,b,c){a.g=c;return{value:b}}function qa(a){this.g=new na;this.h=a}function ra(a,b){oa(a.g);var c=a.g.i;if(c)return sa(a,"return"in c?c["return"]:function(d){return{value:d,done:!0}},b,a.g.return);a.g.return(b);return ta(a)}
function sa(a,b,c,d){try{var f=b.call(a.g.i,c);if(!(f instanceof Object))throw new TypeError("Iterator result "+f+" is not an object");if(!f.done)return a.g.l=!1,f;var h=f.value}catch(e){return a.g.i=null,pa(a.g,e),ta(a)}a.g.i=null;d.call(a.g,h);return ta(a)}function ta(a){for(;a.g.g;)try{var b=a.h(a.g);if(b)return a.g.l=!1,{value:b.value,done:!1}}catch(c){a.g.h=void 0,pa(a.g,c)}a.g.l=!1;if(a.g.j){b=a.g.j;a.g.j=null;if(b.V)throw b.U;return{value:b.return,done:!0}}return{value:void 0,done:!0}}
function ua(a){this.next=function(b){oa(a.g);a.g.i?b=sa(a,a.g.i.next,b,a.g.o):(a.g.o(b),b=ta(a));return b};this.throw=function(b){oa(a.g);a.g.i?b=sa(a,a.g.i["throw"],b,a.g.o):(pa(a.g,b),b=ta(a));return b};this.return=function(b){return ra(a,b)};this[Symbol.iterator]=function(){return this}}function O(a,b){b=new ua(new qa(b));la&&a.prototype&&la(b,a.prototype);return b}
function va(a,b){a instanceof String&&(a+="");var c=0,d=!1,f={next:function(){if(!d&&c<a.length){var h=c++;return{value:b(h,a[h]),done:!1}}d=!0;return{done:!0,value:void 0}}};f[Symbol.iterator]=function(){return f};return f}var wa="function"==typeof Object.assign?Object.assign:function(a,b){for(var c=1;c<arguments.length;c++){var d=arguments[c];if(d)for(var f in d)Object.prototype.hasOwnProperty.call(d,f)&&(a[f]=d[f])}return a};J("Object.assign",function(a){return a||wa});J("Promise",function(a){function b(e){this.h=0;this.i=void 0;this.g=[];this.o=!1;var g=this.j();try{e(g.resolve,g.reject)}catch(k){g.reject(k)}}function c(){this.g=null}function d(e){return e instanceof b?e:new b(function(g){g(e)})}if(a)return a;c.prototype.h=function(e){if(null==this.g){this.g=[];var g=this;this.i(function(){g.l()})}this.g.push(e)};var f=H.setTimeout;c.prototype.i=function(e){f(e,0)};c.prototype.l=function(){for(;this.g&&this.g.length;){var e=this.g;this.g=[];for(var g=0;g<e.length;++g){var k=e[g];e[g]=null;try{k()}catch(l){this.j(l)}}}this.g=null};c.prototype.j=function(e){this.i(function(){throw e;})};b.prototype.j=function(){function e(l){return function(q){k||(k=!0,l.call(g,q))}}var g=this,k=!1;return{resolve:e(this.C),reject:e(this.l)}};b.prototype.C=function(e){if(e===this)this.l(new TypeError("A Promise cannot resolve to itself"));else if(e instanceof b)this.F(e);else{a:switch(typeof e){case"object":var g=null!=e;break a;case"function":g=!0;break a;default:g=!1}g?this.u(e):this.m(e)}};b.prototype.u=function(e){var g=void 0;try{g=e.then}catch(k){this.l(k);return}"function"==typeof g?this.G(g,e):this.m(e)};b.prototype.l=function(e){this.s(2,e)};b.prototype.m=function(e){this.s(1,e)};b.prototype.s=function(e,g){if(0!=this.h)throw Error("Cannot settle("+e+", "+g+"): Promise already settled in state"+this.h);this.h=e;this.i=g;2===this.h&&this.D();this.A()};b.prototype.D=function(){var e=this;f(function(){if(e.B()){var g=H.console;"undefined"!==typeof g&&g.error(e.i)}},1)};b.prototype.B=function(){if(this.o)return!1;var e=H.CustomEvent,g=H.Event,k=H.dispatchEvent;if("undefined"===typeof k)return!0;"function"===typeof e?e=new e("unhandledrejection",{cancelable:!0}):"function"===typeof g?e=new g("unhandledrejection",{cancelable:!0}):(e=H.document.createEvent("CustomEvent"),e.initCustomEvent("unhandledrejection",!1,!0,e));e.promise=this;e.reason=this.i;return k(e)};b.prototype.A=function(){if(null!=this.g){for(var e=0;e<this.g.length;++e)h.h(this.g[e]);this.g=null}};var h=new c;b.prototype.F=function(e){var g=this.j();e.J(g.resolve,g.reject)};b.prototype.G=function(e,g){var k=this.j();try{e.call(g,k.resolve,k.reject)}catch(l){k.reject(l)}};b.prototype.then=function(e,g){function k(w,t){return"function"==typeof w?function(y){try{l(w(y))}catch(m){q(m)}}:t}var l,q,v=new b(function(w,t){l=w;q=t});this.J(k(e,l),k(g,q));return v};b.prototype.catch=function(e){return this.then(void 0,e)};b.prototype.J=function(e,g){function k(){switch(l.h){case 1:e(l.i);break;case 2:g(l.i);break;default:throw Error("Unexpected state: "+
l.h);}}var l=this;null==this.g?h.h(k):this.g.push(k);this.o=!0};b.resolve=d;b.reject=function(e){return new b(function(g,k){k(e)})};b.race=function(e){return new b(function(g,k){for(var l=M(e),q=l.next();!q.done;q=l.next())d(q.value).J(g,k)})};b.all=function(e){var g=M(e),k=g.next();return k.done?d([]):new b(function(l,q){function v(y){return function(m){w[y]=m;t--;0==t&&l(w)}}var w=[],t=0;do w.push(void 0),t++,d(k.value).J(v(w.length-1),q),k=g.next();while(!k.done)})};return b});J("Object.is",function(a){return a?a:function(b,c){return b===c?0!==b||1/b===1/c:b!==b&&c!==c}});J("Array.prototype.includes",function(a){return a?a:function(b,c){var d=this;d instanceof String&&(d=String(d));var f=d.length;c=c||0;for(0>c&&(c=Math.max(c+f,0));c<f;c++){var h=d[c];if(h===b||Object.is(h,b))return!0}return!1}});J("String.prototype.includes",function(a){return a?a:function(b,c){if(null==this)throw new TypeError("The 'this' value for String.prototype.includes must not be null or undefined");if(b instanceof RegExp)throw new TypeError("First argument to String.prototype.includes must not be a regular expression");return-1!==this.indexOf(b,c||0)}});J("Array.prototype.keys",function(a){return a?a:function(){return va(this,function(b){return b})}});var xa=this||self;function ya(a,b){a=a.split(".");var c=xa;a[0]in c||"undefined"==typeof c.execScript||c.execScript("var "+a[0]);for(var d;a.length&&(d=a.shift());)a.length||void 0===b?c[d]&&c[d]!==Object.prototype[d]?c=c[d]:c=c[d]={}:c[d]=b};function za(a,b){b=String.fromCharCode.apply(null,b);return null==a?b:a+b}var Aa,Ba="undefined"!==typeof TextDecoder,Ca,Da="undefined"!==typeof TextEncoder;function Ea(a){if(Da)a=(Ca||(Ca=new TextEncoder)).encode(a);else{var b=void 0;b=void 0===b?!1:b;for(var c=0,d=new Uint8Array(3*a.length),f=0;f<a.length;f++){var h=a.charCodeAt(f);if(128>h)d[c++]=h;else{if(2048>h)d[c++]=h>>6|192;else{if(55296<=h&&57343>=h){if(56319>=h&&f<a.length){var e=a.charCodeAt(++f);if(56320<=e&&57343>=e){h=1024*(h-55296)+e-56320+65536;d[c++]=h>>18|240;d[c++]=h>>12&63|128;d[c++]=h>>6&63|128;d[c++]=h&63|128;continue}else f--}if(b)throw Error("Found an unpaired surrogate");h=65533}d[c++]=h>>12|224;d[c++]=h>>6&63|128}d[c++]=h&63|128}}a=d.subarray(0,c)}return a};var Fa={},Ga=null;function Ha(a,b){void 0===b&&(b=0);Ja();b=Fa[b];for(var c=Array(Math.floor(a.length/3)),d=b[64]||"",f=0,h=0;f<a.length-2;f+=3){var e=a[f],g=a[f+1],k=a[f+2],l=b[e>>2];e=b[(e&3)<<4|g>>4];g=b[(g&15)<<2|k>>6];k=b[k&63];c[h++]=l+e+g+k}l=0;k=d;switch(a.length-f){case 2:l=a[f+1],k=b[(l&15)<<2]||d;case 1:a=a[f],c[h]=b[a>>2]+b[(a&3)<<4|l>>4]+k+d}return c.join("")}
function Ka(a){var b=a.length,c=3*b/4;c%3?c=Math.floor(c):-1!="=.".indexOf(a[b-1])&&(c=-1!="=.".indexOf(a[b-2])?c-2:c-1);var d=new Uint8Array(c),f=0;La(a,function(h){d[f++]=h});return d.subarray(0,f)}
function La(a,b){function c(k){for(;d<a.length;){var l=a.charAt(d++),q=Ga[l];if(null!=q)return q;if(!/^[\s\xa0]*$/.test(l))throw Error("Unknown base64 encoding at char: "+l);}return k}Ja();for(var d=0;;){var f=c(-1),h=c(0),e=c(64),g=c(64);if(64===g&&-1===f)break;b(f<<2|h>>4);64!=e&&(b(h<<4&240|e>>2),64!=g&&b(e<<6&192|g))}}
function Ja(){if(!Ga){Ga={};for(var a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789".split(""),b=["+/=","+/","-_=","-_.","-_"],c=0;5>c;c++){var d=a.concat(b[c].split(""));Fa[c]=d;for(var f=0;f<d.length;f++){var h=d[f];void 0===Ga[h]&&(Ga[h]=f)}}}};var Ma="function"===typeof Uint8Array.prototype.slice,Na;function Oa(a,b,c){return b===c?Na||(Na=new Uint8Array(0)):Ma?a.slice(b,c):new Uint8Array(a.subarray(b,c))}var P=0,Q=0;function Pa(a,b){b=void 0===b?{}:b;b=void 0===b.v?!1:b.v;this.h=null;this.g=this.i=this.j=0;this.l=!1;this.v=b;a&&Qa(this,a)}function Qa(a,b){b=b.constructor===Uint8Array?b:b.constructor===ArrayBuffer?new Uint8Array(b):b.constructor===Array?new Uint8Array(b):b.constructor===String?Ka(b):b instanceof Uint8Array?new Uint8Array(b.buffer,b.byteOffset,b.byteLength):new Uint8Array(0);a.h=b;a.j=0;a.i=a.h.length;a.g=a.j}Pa.prototype.reset=function(){this.g=this.j};function Ra(a){var b=a.h,c=b[a.g],d=c&127;if(128>c)return a.g+=1,d;c=b[a.g+1];d|=(c&127)<<7;if(128>c)return a.g+=2,d;c=b[a.g+2];d|=(c&127)<<14;if(128>c)return a.g+=3,d;c=b[a.g+3];d|=(c&127)<<21;if(128>c)return a.g+=4,d;c=b[a.g+4];d|=(c&15)<<28;if(128>c)return a.g+=5,d>>>0;a.g+=5;128<=b[a.g++]&&128<=b[a.g++]&&128<=b[a.g++]&&128<=b[a.g++]&&a.g++;return d}
function R(a){var b=a.h[a.g];var c=a.h[a.g+1];var d=a.h[a.g+2],f=a.h[a.g+3];a.g+=4;c=(b<<0|c<<8|d<<16|f<<24)>>>0;a=2*(c>>31)+1;b=c>>>23&255;c&=8388607;return 255==b?c?NaN:Infinity*a:0==b?a*Math.pow(2,-149)*c:a*Math.pow(2,b-150)*(c+Math.pow(2,23))}var Sa=[];function Ta(){this.g=new Uint8Array(64);this.h=0}Ta.prototype.push=function(a){if(!(this.h+1<this.g.length)){var b=this.g;this.g=new Uint8Array(Math.ceil(1+2*this.g.length));this.g.set(b)}this.g[this.h++]=a};Ta.prototype.length=function(){return this.h};Ta.prototype.end=function(){var a=this.g,b=this.h;this.h=0;return Oa(a,0,b)};function S(a,b){for(;127<b;)a.push(b&127|128),b>>>=7;a.push(b)};function Ua(a){var b={},c=void 0===b.N?!1:b.N;this.o={v:void 0===b.v?!1:b.v};this.N=c;b=this.o;Sa.length?(c=Sa.pop(),b&&(c.v=b.v),a&&Qa(c,a),a=c):a=new Pa(a,b);this.g=a;this.m=this.g.g;this.h=this.i=this.l=-1;this.j=!1}Ua.prototype.reset=function(){this.g.reset();this.h=this.l=-1};function Va(a){var b=a.g;(b=b.g==b.i)||(b=a.j)||(b=a.g,b=b.l||0>b.g||b.g>b.i);if(b)return!1;a.m=a.g.g;b=Ra(a.g);var c=b&7;if(0!=c&&5!=c&&1!=c&&2!=c&&3!=c&&4!=c)return a.j=!0,!1;a.i=b;a.l=b>>>3;a.h=c;return!0}
function Wa(a){switch(a.h){case 0:if(0!=a.h)Wa(a);else{for(a=a.g;a.h[a.g]&128;)a.g++;a.g++}break;case 1:1!=a.h?Wa(a):(a=a.g,a.g+=8);break;case 2:if(2!=a.h)Wa(a);else{var b=Ra(a.g);a=a.g;a.g+=b}break;case 5:5!=a.h?Wa(a):(a=a.g,a.g+=4);break;case 3:b=a.l;do{if(!Va(a)){a.j=!0;break}if(4==a.h){a.l!=b&&(a.j=!0);break}Wa(a)}while(1);break;default:a.j=!0}}function Xa(a,b,c){var d=a.g.i,f=Ra(a.g);f=a.g.g+f;a.g.i=f;c(b,a);a.g.g=f;a.g.i=d;return b}
function Ya(a){var b=Ra(a.g);a=a.g;var c=a.g;a.g+=b;a=a.h;var d;if(Ba)(d=Aa)||(d=Aa=new TextDecoder("utf-8",{fatal:!1})),d=d.decode(a.subarray(c,c+b));else{b=c+b;for(var f=[],h=null,e,g,k;c<b;)e=a[c++],128>e?f.push(e):224>e?c>=b?f.push(65533):(g=a[c++],194>e||128!==(g&192)?(c--,f.push(65533)):f.push((e&31)<<6|g&63)):240>e?c>=b-1?f.push(65533):(g=a[c++],128!==(g&192)||224===e&&160>g||237===e&&160<=g||128!==((d=a[c++])&192)?(c--,f.push(65533)):f.push((e&15)<<12|(g&63)<<6|d&63)):244>=e?c>=b-2?f.push(65533):(g=a[c++],128!==(g&192)||0!==(e<<28)+(g-144)>>30||128!==((d=a[c++])&192)||128!==((k=a[c++])&192)?(c--,f.push(65533)):(e=(e&7)<<18|(g&63)<<12|(d&63)<<6|k&63,e-=65536,f.push((e>>10&1023)+55296,(e&1023)+56320))):f.push(65533),8192<=f.length&&(h=za(h,f),f.length=0);d=za(h,f)}return d};function Za(){this.h=[];this.i=0;this.g=new Ta}function $a(a,b){0!==b.length&&(a.h.push(b),a.i+=b.length)}function ab(a){var b=a.i+a.g.length();if(0===b)return new Uint8Array(0);b=new Uint8Array(b);for(var c=a.h,d=c.length,f=0,h=0;h<d;h++){var e=c[h];0!==e.length&&(b.set(e,f),f+=e.length)}c=a.g;d=c.h;0!==d&&(b.set(c.g.subarray(0,d),f),c.h=0);a.h=[b];return b}
function T(a,b,c){if(null!=c){S(a.g,8*b+5);a=a.g;var d=c;d=(c=0>d?1:0)?-d:d;0===d?0<1/d?P=Q=0:(Q=0,P=2147483648):isNaN(d)?(Q=0,P=2147483647):3.4028234663852886E38<d?(Q=0,P=(c<<31|2139095040)>>>0):1.1754943508222875E-38>d?(d=Math.round(d/Math.pow(2,-149)),Q=0,P=(c<<31|d)>>>0):(b=Math.floor(Math.log(d)/Math.LN2),d*=Math.pow(2,-b),d=Math.round(8388608*d)&8388607,Q=0,P=(c<<31|b+127<<23|d)>>>0);c=P;a.push(c>>>0&255);a.push(c>>>8&255);a.push(c>>>16&255);a.push(c>>>24&255)}};var bb="function"===typeof Uint8Array;function cb(a,b,c){if(null!=a)return"object"===typeof a?bb&&a instanceof Uint8Array?c(a):db(a,b,c):b(a)}function db(a,b,c){if(Array.isArray(a)){for(var d=Array(a.length),f=0;f<a.length;f++)d[f]=cb(a[f],b,c);Array.isArray(a)&&a.W&&eb(d);return d}d={};for(f in a)d[f]=cb(a[f],b,c);return d}function fb(a){return"number"===typeof a?isFinite(a)?a:String(a):a}var gb={W:{value:!0,configurable:!0}};function eb(a){Array.isArray(a)&&!Object.isFrozen(a)&&Object.defineProperties(a,gb);return a};var hb;function U(a,b,c){var d=hb;hb=null;a||(a=d);d=this.constructor.ca;a||(a=d?[d]:[]);this.j=d?0:-1;this.i=null;this.g=a;a:{d=this.g.length;a=d-1;if(d&&(d=this.g[a],null!==d&&"object"===typeof d&&d.constructor===Object)){this.l=a-this.j;this.h=d;break a}void 0!==b&&-1<b?(this.l=Math.max(b,a+1-this.j),this.h=null):this.l=Number.MAX_VALUE}if(c)for(b=0;b<c.length;b++)a=c[b],a<this.l?(a+=this.j,(d=this.g[a])?eb(d):this.g[a]=ib):(jb(this),(d=this.h[a])?eb(d):this.h[a]=ib)}var ib=Object.freeze(eb([]));function jb(a){var b=a.l+a.j;a.g[b]||(a.h=a.g[b]={})}function V(a,b,c){return-1===b?null:(void 0===c?0:c)||b>=a.l?a.h?a.h[b]:void 0:a.g[b+a.j]}function kb(a){var b=void 0===b?!1:b;var c=V(a,1,b);null==c&&(c=ib);c===ib&&(c=eb([]),W(a,1,c,b));return c}function X(a,b,c){a=V(a,b);a=null==a?a:+a;return null==a?void 0===c?0:c:a}function W(a,b,c,d){(void 0===d?0:d)||b>=a.l?(jb(a),a.h[b]=c):a.g[b+a.j]=c}
function lb(a,b){a.i||(a.i={});var c=a.i[1];if(!c){var d=kb(a);c=[];for(var f=0;f<d.length;f++)c[f]=new b(d[f]);a.i[1]=c}return c}function mb(a,b,c,d){var f=lb(a,c);b=b?b:new c;a=kb(a);void 0!=d?(f.splice(d,0,b),a.splice(d,0,nb(b,!1))):(f.push(b),a.push(nb(b,!1)))}U.prototype.toJSON=function(){var a=nb(this,!1);return db(a,fb,Ha)};function nb(a,b){if(a.i)for(var c in a.i){var d=a.i[c];if(Array.isArray(d))for(var f=0;f<d.length;f++)d[f]&&nb(d[f],b);else d&&nb(d,b)}return a.g}
U.prototype.toString=function(){return nb(this,!1).toString()};function ob(a,b){a=V(a,b);return null==a?0:a}function pb(a,b){a=V(a,b);return null==a?"":a};function qb(a,b){if(a=a.m){$a(b,b.g.end());for(var c=0;c<a.length;c++)$a(b,a[c])}}function rb(a,b){if(4==b.h)return!1;var c=b.m;Wa(b);b.N||(b=Oa(b.g.h,c,b.g.g),(c=a.m)?c.push(b):a.m=[b]);return!0};function Y(a,b){var c=void 0;return new(c||(c=Promise))(function(d,f){function h(k){try{g(b.next(k))}catch(l){f(l)}}function e(k){try{g(b["throw"](k))}catch(l){f(l)}}function g(k){k.done?d(k.value):(new c(function(l){l(k.value)})).then(h,e)}g((b=b.apply(a,void 0)).next())})};function sb(a){U.call(this,a)}ma(sb,U);function tb(a,b){for(;Va(b);)switch(b.i){case 8:var c=Ra(b.g);W(a,1,c);break;case 21:c=R(b.g);W(a,2,c);break;case 26:c=Ya(b);W(a,3,c);break;case 34:c=Ya(b);W(a,4,c);break;default:if(!rb(a,b))return a}return a};function ub(a){U.call(this,a,-1,vb)}ma(ub,U);ub.prototype.addClassification=function(a,b){mb(this,a,sb,b)};var vb=[1];function wb(a){U.call(this,a)}ma(wb,U);function xb(a,b){for(;Va(b);)switch(b.i){case 13:var c=R(b.g);W(a,1,c);break;case 21:c=R(b.g);W(a,2,c);break;case 29:c=R(b.g);W(a,3,c);break;case 37:c=R(b.g);W(a,4,c);break;case 45:c=R(b.g);W(a,5,c);break;default:if(!rb(a,b))return a}return a};function yb(a){U.call(this,a,-1,zb)}ma(yb,U);var zb=[1];function Ab(a){U.call(this,a)}ma(Ab,U);function Bb(a,b,c){c=a.createShader(0===c?a.VERTEX_SHADER:a.FRAGMENT_SHADER);a.shaderSource(c,b);a.compileShader(c);if(!a.getShaderParameter(c,a.COMPILE_STATUS))throw Error("Could not compile WebGL shader.\n\n"+a.getShaderInfoLog(c));return c};function Cb(a){return lb(a,sb).map(function(b){return{index:ob(b,1),Y:X(b,2),label:null!=V(b,3)?pb(b,3):void 0,displayName:null!=V(b,4)?pb(b,4):void 0}})};function Db(a){return{x:X(a,1),y:X(a,2),z:X(a,3),visibility:null!=V(a,4)?X(a,4):void 0}};function Eb(a,b){this.h=a;this.g=b;this.l=0}
function Fb(a,b,c){Gb(a,b);if("function"===typeof a.g.canvas.transferToImageBitmap)return Promise.resolve(a.g.canvas.transferToImageBitmap());if(c)return Promise.resolve(a.g.canvas);if("function"===typeof createImageBitmap)return createImageBitmap(a.g.canvas);void 0===a.i&&(a.i=document.createElement("canvas"));return new Promise(function(d){a.i.height=a.g.canvas.height;a.i.width=a.g.canvas.width;a.i.getContext("2d",{}).drawImage(a.g.canvas,0,0,a.g.canvas.width,a.g.canvas.height);d(a.i)})}
function Gb(a,b){var c=a.g;if(void 0===a.m){var d=Bb(c,"\n  attribute vec2 aVertex;\n  attribute vec2 aTex;\n  varying vec2 vTex;\n  void main(void) {\n    gl_Position = vec4(aVertex, 0.0, 1.0);\n    vTex = aTex;\n  }",0),f=Bb(c,"\n  precision mediump float;\n  varying vec2 vTex;\n  uniform sampler2D sampler0;\n  void main(){\n    gl_FragColor = texture2D(sampler0, vTex);\n  }",1),h=c.createProgram();c.attachShader(h,d);c.attachShader(h,f);c.linkProgram(h);if(!c.getProgramParameter(h,c.LINK_STATUS))throw Error("Could not compile WebGL program.\n\n"+
c.getProgramInfoLog(h));d=a.m=h;c.useProgram(d);f=c.getUniformLocation(d,"sampler0");a.j={I:c.getAttribLocation(d,"aVertex"),H:c.getAttribLocation(d,"aTex"),da:f};a.s=c.createBuffer();c.bindBuffer(c.ARRAY_BUFFER,a.s);c.enableVertexAttribArray(a.j.I);c.vertexAttribPointer(a.j.I,2,c.FLOAT,!1,0,0);c.bufferData(c.ARRAY_BUFFER,new Float32Array([-1,-1,-1,1,1,1,1,-1]),c.STATIC_DRAW);c.bindBuffer(c.ARRAY_BUFFER,null);a.o=c.createBuffer();c.bindBuffer(c.ARRAY_BUFFER,a.o);c.enableVertexAttribArray(a.j.H);c.vertexAttribPointer(a.j.H,2,c.FLOAT,!1,0,0);c.bufferData(c.ARRAY_BUFFER,new Float32Array([0,1,0,0,1,0,1,1]),c.STATIC_DRAW);c.bindBuffer(c.ARRAY_BUFFER,null);c.uniform1i(f,0)}d=a.j;c.useProgram(a.m);c.canvas.width=b.width;c.canvas.height=b.height;c.viewport(0,0,b.width,b.height);c.activeTexture(c.TEXTURE0);a.h.bindTexture2d(b.glName);c.enableVertexAttribArray(d.I);c.bindBuffer(c.ARRAY_BUFFER,a.s);c.vertexAttribPointer(d.I,2,c.FLOAT,!1,0,0);c.enableVertexAttribArray(d.H);c.bindBuffer(c.ARRAY_BUFFER,a.o);c.vertexAttribPointer(d.H,2,c.FLOAT,!1,0,0);c.bindFramebuffer(c.DRAW_FRAMEBUFFER?c.DRAW_FRAMEBUFFER:c.FRAMEBUFFER,null);c.clearColor(0,0,0,0);c.clear(c.COLOR_BUFFER_BIT);c.colorMask(!0,!0,!0,!0);c.drawArrays(c.TRIANGLE_FAN,0,4);c.disableVertexAttribArray(d.I);c.disableVertexAttribArray(d.H);c.bindBuffer(c.ARRAY_BUFFER,null);a.h.bindTexture2d(0)}function Hb(a){this.g=a};var Ib=new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,10,9,1,7,0,65,0,253,15,26,11]);function Jb(a,b){return b+a}function Kb(a,b){window[a]=b}function Lb(a){var b=document.createElement("script");b.setAttribute("src",a);b.setAttribute("crossorigin","anonymous");return new Promise(function(c){b.addEventListener("load",function(){c()},!1);b.addEventListener("error",function(){c()},!1);document.body.appendChild(b)})}
function Mb(){return Y(this,function b(){return O(b,function(c){switch(c.g){case 1:return c.m=2,N(c,WebAssembly.instantiate(Ib),4);case 4:c.g=3;c.m=0;break;case 2:return c.m=0,c.j=null,c.return(!1);case 3:return c.return(!0)}})})}
function Nb(a){this.g=a;this.listeners={};this.j={};this.F={};this.m={};this.s={};this.G=this.o=this.R=!0;this.C=Promise.resolve();this.P="";this.B={};this.locateFile=a&&a.locateFile||Jb;if("object"===typeof window)var b=window.location.pathname.toString().substring(0,window.location.pathname.toString().lastIndexOf("/"))+"/";else if("undefined"!==typeof location)b=location.pathname.toString().substring(0,location.pathname.toString().lastIndexOf("/"))+"/";else throw Error("solutions can only be loaded on a web page or in a web worker");this.S=b;if(a.options){b=M(Object.keys(a.options));for(var c=b.next();!c.done;c=b.next()){c=c.value;var d=a.options[c].default;void 0!==d&&(this.j[c]="function"===typeof d?d():d)}}}D=Nb.prototype;D.close=function(){this.i&&this.i.delete();return Promise.resolve()};function Ob(a,b){return void 0===a.g.files?[]:"function"===typeof a.g.files?a.g.files(b):a.g.files}
function Pb(a){return Y(a,function c(){var d=this,f,h,e,g,k,l,q,v,w,t,y;return O(c,function(m){switch(m.g){case 1:f=d;if(!d.R)return m.return();h=Ob(d,d.j);return N(m,Mb(),2);case 2:e=m.h;if("object"===typeof window)return Kb("createMediapipeSolutionsWasm",{locateFile:d.locateFile}),Kb("createMediapipeSolutionsPackedAssets",{locateFile:d.locateFile}),l=h.filter(function(u){return void 0!==u.data}),q=h.filter(function(u){return void 0===u.data}),v=Promise.all(l.map(function(u){var x=Qb(f,u.url);if(void 0!==u.path){var z=u.path;x=x.then(function(E){f.overrideFile(z,E);return Promise.resolve(E)})}return x})),w=Promise.all(q.map(function(u){return void 0===u.simd||u.simd&&e||!u.simd&&!e?Lb(f.locateFile(u.url,f.S)):Promise.resolve()})).then(function(){return Y(f,function x(){var z,E,F=this;return O(x,function(K){if(1==K.g)return z=window.createMediapipeSolutionsWasm,E=window.createMediapipeSolutionsPackedAssets,N(K,z(E),2);F.h=K.h;K.g=0})})}),t=function(){return Y(f,function x(){var z=this;return O(x,function(E){z.g.graph&&z.g.graph.url?E=N(E,Qb(z,z.g.graph.url),0):(E.g=0,E=void 0);return E})})}(),N(m,Promise.all([w,v,t]),7);if("function"!==typeof importScripts)throw Error("solutions can only be loaded on a web page or in a web worker");g=h.filter(function(u){return void 0===u.simd||u.simd&&e||!u.simd&&!e}).map(function(u){return f.locateFile(u.url,f.S)});importScripts.apply(null,ea(g));return N(m,createMediapipeSolutionsWasm(Module),6);case 6:d.h=m.h;d.l=new OffscreenCanvas(1,1);d.h.canvas=d.l;k=d.h.GL.createContext(d.l,{antialias:!1,alpha:!1,ba:"undefined"!==typeof WebGL2RenderingContext?2:1});d.h.GL.makeContextCurrent(k);m.g=4;break;case 7:d.l=document.createElement("canvas");y=d.l.getContext("webgl2",{});if(!y&&(y=d.l.getContext("webgl",{}),!y))return alert("Failed to create WebGL canvas context when passing video frame."),m.return();d.D=y;d.h.canvas=d.l;d.h.createContext(d.l,!0,!0,{});case 4:d.i=new d.h.SolutionWasm,d.R=!1,m.g=0}})})}
function Rb(a){return Y(a,function c(){var d=this,f,h,e,g,k,l,q,v;return O(c,function(w){if(1==w.g){if(d.g.graph&&d.g.graph.url&&d.P===d.g.graph.url)return w.return();d.o=!0;if(!d.g.graph||!d.g.graph.url){w.g=2;return}d.P=d.g.graph.url;return N(w,Qb(d,d.g.graph.url),3)}2!=w.g&&(f=w.h,d.i.loadGraph(f));h=M(Object.keys(d.B));for(e=h.next();!e.done;e=h.next())g=e.value,d.i.overrideFile(g,d.B[g]);d.B={};if(d.g.listeners)for(k=M(d.g.listeners),l=k.next();!l.done;l=k.next())q=l.value,Sb(d,q);v=d.j;d.j={};d.setOptions(v);w.g=0})})}D.reset=function(){return Y(this,function b(){var c=this;return O(b,function(d){c.i&&(c.i.reset(),c.m={},c.s={});d.g=0})})};D.setOptions=function(a,b){var c=this;if(b=b||this.g.options){for(var d=[],f=[],h={},e=M(Object.keys(a)),g=e.next();!g.done;h={K:h.K,L:h.L},g=e.next()){var k=g.value;k in this.j&&this.j[k]===a[k]||(this.j[k]=a[k],g=b[k],void 0!==g&&(g.onChange&&(h.K=g.onChange,h.L=a[k],d.push(function(l){return function(){return Y(c,function v(){var w,t=this;return O(v,function(y){if(1==y.g)return N(y,l.K(l.L),2);w=y.h;!0===w&&(t.o=!0);y.g=0})})}}(h))),g.graphOptionXref&&(k={valueNumber:1===g.type?a[k]:0,valueBoolean:0===g.type?a[k]:!1,valueString:2===g.type?a[k]:""},g=Object.assign(Object.assign(Object.assign({},{calculatorName:"",calculatorIndex:0}),g.graphOptionXref),k),f.push(g))))}if(0!==d.length||0!==f.length)this.o=!0,this.A=(void 0===this.A?[]:this.A).concat(f),this.u=(void 0===this.u?[]:this.u).concat(d)}};function Tb(a){return Y(a,function c(){var d=this,f,h,e,g,k,l,q;return O(c,function(v){switch(v.g){case 1:if(!d.o)return v.return();if(!d.u){v.g=2;break}f=M(d.u);h=f.next();case 3:if(h.done){v.g=5;break}e=h.value;return N(v,e(),4);case 4:h=f.next();v.g=3;break;case 5:d.u=void 0;case 2:if(d.A){g=new d.h.GraphOptionChangeRequestList;k=M(d.A);for(l=k.next();!l.done;l=k.next())q=l.value,g.push_back(q);d.i.changeOptions(g);g.delete();d.A=void 0}d.o=!1;v.g=0}})})}
D.initialize=function(){return Y(this,function b(){var c=this;return O(b,function(d){return 1==d.g?N(d,Pb(c),2):3!=d.g?N(d,Rb(c),3):N(d,Tb(c),0)})})};function Qb(a,b){return Y(a,function d(){var f=this,h,e;return O(d,function(g){if(b in f.F)return g.return(f.F[b]);h=f.locateFile(b,"");e=fetch(h).then(function(k){return k.arrayBuffer()});f.F[b]=e;return g.return(e)})})}D.overrideFile=function(a,b){this.i?this.i.overrideFile(a,b):this.B[a]=b};D.clearOverriddenFiles=function(){this.B={};this.i&&this.i.clearOverriddenFiles()};D.send=function(a,b){return Y(this,function d(){var f=this,h,e,g,k,l,q,v,w,t;return O(d,function(y){switch(y.g){case 1:if(!f.g.inputs)return y.return();h=1E3*(void 0===b||null===b?performance.now():b);return N(y,f.C,2);case 2:return N(y,f.initialize(),3);case 3:e=new f.h.PacketDataList;g=M(Object.keys(a));for(k=g.next();!k.done;k=g.next())if(l=k.value,q=f.g.inputs[l]){a:{var m=f;var u=a[l];switch(q.type){case"video":var x=m.m[q.stream];x||(x=new Eb(m.h,m.D),m.m[q.stream]=x);m=x;0===m.l&&(m.l=m.h.createTexture());if("undefined"!==typeof HTMLVideoElement&&u instanceof HTMLVideoElement){var z=u.videoWidth;x=u.videoHeight}else"undefined"!==typeof HTMLImageElement&&u instanceof HTMLImageElement?(z=u.naturalWidth,x=u.naturalHeight):(z=u.width,x=u.height);x={glName:m.l,width:z,height:x};z=m.g;z.canvas.width=x.width;z.canvas.height=x.height;z.activeTexture(z.TEXTURE0);m.h.bindTexture2d(m.l);z.texImage2D(z.TEXTURE_2D,0,z.RGBA,z.RGBA,z.UNSIGNED_BYTE,u);m.h.bindTexture2d(0);m=x;break a;case"detections":x=m.m[q.stream];x||(x=new Hb(m.h),m.m[q.stream]=x);m=x;m.data||(m.data=new m.g.DetectionListData);m.data.reset(u.length);for(x=0;x<u.length;++x){z=u[x];var E=m.data,F=E.setBoundingBox,K=x;var I=z.T;var r=new Ab;W(r,1,I.Z);W(r,2,I.$);W(r,3,I.height);W(r,4,I.width);W(r,5,I.rotation);W(r,6,I.X);var A=I=new Za;T(A,1,V(r,1));T(A,2,V(r,2));T(A,3,V(r,3));T(A,4,V(r,4));T(A,5,V(r,5));var C=V(r,6);if(null!=C&&null!=C){S(A.g,48);var p=A.g,B=C;C=0>B;B=Math.abs(B);var n=B>>>0;B=Math.floor((B-n)/4294967296);B>>>=0;C&&(B=~B>>>0,n=(~n>>>0)+1,4294967295<n&&(n=0,B++,4294967295<B&&(B=0)));P=n;Q=B;C=P;for(n=Q;0<n||127<C;)p.push(C&127|128),C=(C>>>7|n<<25)>>>0,n>>>=7;p.push(C)}qb(r,A);I=ab(I);F.call(E,K,I);if(z.O)for(E=0;E<z.O.length;++E)r=z.O[E],A=r.visibility?!0:!1,F=m.data,K=F.addNormalizedLandmark,I=x,r=Object.assign(Object.assign({},r),{visibility:A?r.visibility:0}),A=new wb,W(A,1,r.x),W(A,2,r.y),W(A,3,r.z),r.visibility&&W(A,4,r.visibility),p=r=new Za,T(p,1,V(A,1)),T(p,2,V(A,2)),T(p,3,V(A,3)),T(p,4,V(A,4)),T(p,5,V(A,5)),qb(A,p),r=ab(r),K.call(F,I,r);if(z.M)for(E=0;E<z.M.length;++E){F=m.data;K=F.addClassification;I=x;r=z.M[E];A=new sb;W(A,2,r.Y);r.index&&W(A,1,r.index);r.label&&W(A,3,r.label);r.displayName&&W(A,4,r.displayName);p=r=new Za;n=V(A,1);if(null!=n&&null!=n)if(S(p.g,8),C=p.g,0<=n)S(C,n);else{for(B=0;9>B;B++)C.push(n&127|128),n>>=7;C.push(1)}T(p,2,V(A,2));C=V(A,3);null!=C&&(C=Ea(C),S(p.g,26),S(p.g,C.length),$a(p,p.g.end()),$a(p,C));C=V(A,4);null!=C&&(C=Ea(C),S(p.g,34),S(p.g,C.length),$a(p,p.g.end()),$a(p,C));qb(A,p);r=ab(r);K.call(F,I,r)}}m=m.data;break a;default:m={}}}v=m;w=q.stream;switch(q.type){case"video":e.pushTexture2d(Object.assign(Object.assign({},v),{stream:w,timestamp:h}));break;case"detections":t=v;t.stream=w;t.timestamp=h;e.pushDetectionList(t);break;default:throw Error("Unknown input config type: '"+q.type+"'");}}f.i.send(e);return N(y,f.C,4);case 4:e.delete(),y.g=0}})})};function Ub(a,b,c){return Y(a,function f(){var h,e,g,k,l,q,v=this,w,t,y,m,u,x,z,E;return O(f,function(F){switch(F.g){case 1:if(!c)return F.return(b);h={};e=0;g=M(Object.keys(c));for(k=g.next();!k.done;k=g.next())l=k.value,q=c[l],"string"!==typeof q&&"texture"===q.type&&void 0!==b[q.stream]&&++e;1<e&&(v.G=!1);w=M(Object.keys(c));k=w.next();case 2:if(k.done){F.g=4;break}t=k.value;y=c[t];if("string"===typeof y)return z=h,E=t,N(F,Vb(v,t,b[y]),14);m=b[y.stream];if("detection_list"===y.type){if(m){var K=m.getRectList();for(var I=m.getLandmarksList(),r=m.getClassificationsList(),A=[],C=0;C<K.size();++C){var p=K.get(C);a:{var B=new Ab;for(p=new Ua(p);Va(p);)switch(p.i){case 13:var n=R(p.g);W(B,1,n);break;case 21:n=R(p.g);W(B,2,n);break;case 29:n=R(p.g);W(B,3,n);break;case 37:n=R(p.g);W(B,4,n);break;case 45:n=R(p.g);W(B,5,n);break;case 48:for(var G=p.g,L=128,Ia=0,Z=n=0;4>Z&&128<=L;Z++)L=G.h[G.g++],Ia|=(L&127)<<7*Z;128<=L&&(L=G.h[G.g++],Ia|=(L&127)<<28,n|=(L&127)>>4);if(128<=L)for(Z=0;5>Z&&128<=L;Z++)L=G.h[G.g++],n|=(L&127)<<7*Z+3;if(128>L){G=Ia>>>0;L=n>>>0;if(n=L&2147483648)G=~G+1>>>0,L=~L>>>0,0==G&&(L=L+1>>>0);G=4294967296*L+(G>>>0);n=n?-G:G}else G.l=!0,n=void 0;W(B,6,n);break;default:if(!rb(B,p))break a}}B={Z:X(B,1),$:X(B,2),height:X(B,3),width:X(B,4),rotation:X(B,5,0),X:ob(B,6)};n=I.get(C);a:for(p=new yb,n=new Ua(n);Va(n);)switch(n.i){case 10:G=Xa(n,new wb,xb);mb(p,G,wb,void 0);break;default:if(!rb(p,n))break a}p=lb(p,wb).map(Db);G=r.get(C);a:for(n=new ub,G=new Ua(G);Va(G);)switch(G.i){case 10:n.addClassification(Xa(G,new sb,tb));break;default:if(!rb(n,G))break a}B={T:B,O:p,M:Cb(n)};A.push(B)}K=A}else K=[];h[t]=K;F.g=7;break}if("proto_list"===y.type){if(m){K=Array(m.size());for(I=0;I<m.size();I++)K[I]=m.get(I);m.delete()}else K=[];h[t]=K;F.g=7;break}if(void 0===m){F.g=3;break}if("float_list"===y.type){h[t]=m;F.g=7;break}if("proto"===y.type){h[t]=m;F.g=7;break}if("texture"!==y.type)throw Error("Unknown output config type: '"+y.type+"'");u=v.s[t];u||(u=new Eb(v.h,v.D),v.s[t]=u);return N(F,Fb(u,m,v.G),13);case 13:x=F.h,h[t]=x;case 7:y.transform&&h[t]&&(h[t]=y.transform(h[t]));F.g=3;break;case 14:z[E]=F.h;case 3:k=w.next();F.g=2;break;case 4:return F.return(h)}})})}function Vb(a,b,c){return Y(a,function f(){var h=this,e;return O(f,function(g){return"number"===typeof c||c instanceof Uint8Array||c instanceof h.h.Uint8BlobList?g.return(c):c instanceof h.h.Texture2dDataOut?(e=h.s[b],e||(e=new Eb(h.h,h.D),h.s[b]=e),g.return(Fb(e,c,h.G))):g.return(void 0)})})}
function Sb(a,b){for(var c=b.name||"$",d=[].concat(ea(b.wants)),f=new a.h.StringList,h=M(b.wants),e=h.next();!e.done;e=h.next())f.push_back(e.value);h=a.h.PacketListener.implement({onResults:function(g){for(var k={},l=0;l<b.wants.length;++l)k[d[l]]=g.get(l);var q=a.listeners[c];q&&(a.C=Ub(a,k,b.outs).then(function(v){v=q(v);for(var w=0;w<b.wants.length;++w){var t=k[d[w]];"object"===typeof t&&t.hasOwnProperty&&t.hasOwnProperty("delete")&&t.delete()}v&&(a.C=v)}))}});a.i.attachMultiListener(f,h);f.delete()}
D.onResults=function(a,b){this.listeners[b||"$"]=a};ya("Solution",Nb);ya("OptionType",{BOOL:0,NUMBER:1,aa:2,0:"BOOL",1:"NUMBER",2:"STRING"});function Wb(a){void 0===a&&(a=0);switch(a){case 1:return"selfie_segmentation_landscape.tflite";default:return"selfie_segmentation.tflite"}}
function Xb(a){var b=this;a=a||{};this.g=new Nb({locateFile:a.locateFile,files:function(c){return[{simd:!0,url:"selfie_segmentation_solution_simd_wasm_bin.js"},{simd:!1,url:"selfie_segmentation_solution_wasm_bin.js"},{data:!0,url:Wb(c.modelSelection)}]},graph:{url:"selfie_segmentation.binarypb"},listeners:[{wants:["segmentation_mask","image_transformed"],outs:{image:{type:"texture",stream:"image_transformed"},segmentationMask:{type:"texture",stream:"segmentation_mask"}}}],inputs:{image:{type:"video",stream:"input_frames_gpu"}},options:{useCpuInference:{type:0,graphOptionXref:{calculatorType:"InferenceCalculator",fieldName:"use_cpu_inference"},default:"iPad Simulator;iPhone Simulator;iPod Simulator;iPad;iPhone;iPod".split(";").includes(navigator.platform)||navigator.userAgent.includes("Mac")&&"ontouchend"in document},selfieMode:{type:0,graphOptionXref:{calculatorType:"GlScalerCalculator",calculatorIndex:1,fieldName:"flip_horizontal"}},modelSelection:{type:1,graphOptionXref:{calculatorType:"ConstantSidePacketCalculator",calculatorName:"ConstantSidePacketCalculatorModelSelection",fieldName:"int_value"},onChange:function(c){return Y(b,function f(){var h,e,g=this,k;return O(f,function(l){if(1==l.g)return h=Wb(c),e="third_party/mediapipe/modules/selfie_segmentation/"+h,N(l,Qb(g.g,h),2);k=l.h;g.g.overrideFile(e,k);return l.return(!0)})})}}}})}D=Xb.prototype;D.close=function(){this.g.close();return Promise.resolve()};D.onResults=function(a){this.g.onResults(a)};D.initialize=function(){return Y(this,function b(){var c=this;return O(b,function(d){return N(d,c.g.initialize(),0)})})};D.reset=function(){this.g.reset()};D.send=function(a){return Y(this,function c(){var d=this;return O(c,function(f){return N(f,d.g.send(a),0)})})};D.setOptions=function(a){this.g.setOptions(a)};ya("SelfieSegmentation",Xb);ya("VERSION","0.1.1632777926");}).call(this);;

/* /mail/static/src/js/emojis_mixin.js */
odoo.define('@mail/js/emojis_mixin',['@web/core/utils/strings'],function(require){'use strict';let __exports={};const{escape}=require("@web/core/utils/strings");__exports.formatText=formatText;function formatText(message){message=escape(message);message=message.replaceAll(/(\p{Emoji_Presentation}+)/gu,"<span class='o_mail_emoji'>$1</span>");message=message.replace(/(?:\r\n|\r|\n)/g,"<br>");return message;}
return __exports;});;

/* /mail/static/src/js/onchange_on_keydown.js */
odoo.define('@mail/js/onchange_on_keydown',['@odoo/owl','@web/core/utils/patch','@web/core/utils/strings','@web/core/utils/timing','@web/views/fields/char/char_field','@web/views/fields/text/text_field'],function(require){'use strict';let __exports={};const{useEffect}=require("@odoo/owl");const{patch}=require("@web/core/utils/patch");const{exprToBoolean}=require("@web/core/utils/strings");const{useDebounced}=require("@web/core/utils/timing");const{charField,CharField}=require("@web/views/fields/char/char_field");const{textField,TextField}=require("@web/views/fields/text/text_field");const onchangeOnKeydownMixin=()=>({setup(){super.setup(...arguments);if(this.props.onchangeOnKeydown){const input=this.input||this.textareaRef;const triggerOnChange=useDebounced(this.triggerOnChange,this.props.keydownDebounceDelay);useEffect(()=>{if(input.el){input.el.addEventListener("keydown",triggerOnChange);return()=>{input.el.removeEventListener("keydown",triggerOnChange);};}});}},triggerOnChange(){const input=this.input||this.textareaRef;input.el.dispatchEvent(new Event("change"));},});patch(CharField.prototype,onchangeOnKeydownMixin());patch(TextField.prototype,onchangeOnKeydownMixin());CharField.props={...CharField.props,onchangeOnKeydown:{type:Boolean,optional:true},keydownDebounceDelay:{type:Number,optional:true},};TextField.props={...TextField.props,onchangeOnKeydown:{type:Boolean,optional:true},keydownDebounceDelay:{type:Number,optional:true},};const charExtractProps=charField.extractProps;charField.extractProps=(fieldInfo)=>{return Object.assign(charExtractProps(fieldInfo),{onchangeOnKeydown:exprToBoolean(fieldInfo.attrs.onchange_on_keydown),keydownDebounceDelay:fieldInfo.attrs.keydown_debounce_delay?Number(fieldInfo.attrs.keydown_debounce_delay):2000,});};const textExtractProps=textField.extractProps;textField.extractProps=(fieldInfo)=>{return Object.assign(textExtractProps(fieldInfo),{onchangeOnKeydown:exprToBoolean(fieldInfo.attrs.onchange_on_keydown),keydownDebounceDelay:fieldInfo.attrs.keydown_debounce_delay?Number(fieldInfo.attrs.keydown_debounce_delay):2000,});};return __exports;});;

/* /mail/static/src/js/tools/debug_manager.js */
odoo.define('@mail/js/tools/debug_manager',['@web/core/l10n/translation','@web/core/registry'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");__exports.manageMessages=manageMessages;function manageMessages({component,env}){const resId=component.model.root.resId;if(!resId){return null;}
const description=_t("Messages");return{type:"item",description,callback:()=>{env.services.action.doAction({res_model:"mail.message",name:description,views:[[false,"list"],[false,"form"],],type:"ir.actions.act_window",domain:[["res_id","=",resId],["model","=",component.props.resModel],],context:{default_res_model:component.props.resModel,default_res_id:resId,},});},sequence:130,section:"record",};}
registry.category("debug").category("form").add("mail.manageMessages",manageMessages);return __exports;});;

/* /mail/static/src/js/tours/discuss_channel_tour.js */
odoo.define('@mail/js/tours/discuss_channel_tour',['@web/core/l10n/translation','@web/core/registry','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add("discuss_channel_tour",{url:"/odoo",steps:()=>[{isActive:["enterprise"],trigger:"a[data-menu-xmlid='mail.menu_root_discuss']",content:_t("Open Discuss App"),tooltipPosition:"bottom",run:"click",},{trigger:".o-mail-DiscussSidebarCategory-channel .o-mail-DiscussSidebarCategory-add",content:markup(_t("<p>Channels make it easy to organize information across different topics and groups.</p> <p>Try to <b>create your first channel</b> (e.g. sales, marketing, product XYZ, after work party, etc).</p>")),tooltipPosition:"bottom",run:"click",},{trigger:".o-discuss-ChannelSelector input",content:markup(_t("<p>Create a channel here.</p>")),tooltipPosition:"bottom",run:`edit SomeChannel_${new Date().getTime()}`,},{trigger:".o-discuss-ChannelSelector-suggestion",content:markup(_t("<p>Create a public or private channel.</p>")),run:"click",tooltipPosition:"right",},{trigger:".o-mail-Composer-input",content:markup(_t("<p><b>Write a message</b> to the members of the channel here.</p> <p>You can notify someone with <i>'@'</i> or link another channel with <i>'#'</i>. Start your message with <i>'/'</i> to get the list of possible commands.</p>")),tooltipPosition:"top",run:`edit SomeText_${new Date().getTime()}`,},{trigger:".o-mail-Composer-send:enabled",content:_t("Post your message on the thread"),tooltipPosition:"top",run:"click",},{trigger:".o-mail-Message:contains(today at)",content:_t("Hover on your message and mark as todo"),tooltipPosition:"top",run:"hover && click .o-mail-Message [title='Mark as Todo']",},{trigger:"button:contains(Starred)",content:_t("Once a message has been starred, you can come back and review it at any time here."),tooltipPosition:"bottom",run:"click",},{trigger:".o-mail-DiscussSidebarCategory-chat .o-mail-DiscussSidebarCategory-add",content:markup(_t("<p><b>Chat with coworkers</b> in real-time using direct messages.</p><p><i>You might need to invite users from the Settings app first.</i></p>")),tooltipPosition:"bottom",run:"click",},{trigger:".o-discuss-ChannelSelector",},],});return __exports;});;

/* /mail/static/src/model/export.js */
odoo.define('@mail/model/export',['@mail/model/store','@mail/model/record','@mail/model/make_store','@mail/model/misc'],function(require){'use strict';let __exports={};Object.assign(__exports,require("@mail/model/store"));Object.assign(__exports,require("@mail/model/record"));Object.assign(__exports,require("@mail/model/make_store"));{const{AND,OR}=require("@mail/model/misc");Object.assign(__exports,{AND,OR})};return __exports;});;

/* /mail/static/src/model/make_store.js */
odoo.define('@mail/model/make_store',['@odoo/owl','@mail/model/store','@mail/model/misc','@mail/model/record','@mail/model/store_internal','@mail/model/model_internal','@mail/model/record_internal'],function(require){'use strict';let __exports={};const{markRaw,reactive,toRaw}=require("@odoo/owl");const{Store}=require("@mail/model/store");const{STORE_SYM,isFieldDefinition,isMany,isRelation,modelRegistry}=require("@mail/model/misc");const{Record}=require("@mail/model/record");const{StoreInternal}=require("@mail/model/store_internal");const{ModelInternal}=require("@mail/model/model_internal");const{RecordInternal}=require("@mail/model/record_internal");__exports.makeStore=makeStore;function makeStore(env,{localRegistry}={}){const recordByLocalId=reactive(new Map());Store.env=env;let store=new Store();store.env=env;store.Model=Store;store._=markRaw(new StoreInternal());store._raw=store;store._proxyInternal=store;store._proxy=store;store.recordByLocalId=recordByLocalId;Record.store=store;const Models={};const chosenModelRegistry=localRegistry??modelRegistry;for(const[,_OgClass]of chosenModelRegistry.getEntries()){const OgClass=_OgClass;if(store[OgClass.getName()]){throw new Error(`There must be no duplicated Model Names (duplicate found: ${OgClass.getName()})`);}
const Model=Object.create(OgClass);const Class={[OgClass.getName()]:class extends OgClass{constructor(){super();this.setup();const record=this;record._raw=record;record.Model=Model;record._=markRaw(record[STORE_SYM]?new StoreInternal():new RecordInternal());const recordProxyInternal=new Proxy(record,{get(record,name,recordFullProxy){recordFullProxy=record._.downgradeProxy(record,recordFullProxy);if(record._.gettingField||!Model._.fields.get(name)){let res=Reflect.get(...arguments);if(typeof res==="function"){res=res.bind(recordFullProxy);}
return res;}
if(Model._.fieldsCompute.get(name)&&!Model._.fieldsEager.get(name)){record._.fieldsComputeInNeed.set(name,true);if(record._.fieldsComputeOnNeed.get(name)){record._.compute(record,name);}}
if(Model._.fieldsSort.get(name)&&!Model._.fieldsEager.get(name)){record._.fieldsSortInNeed.set(name,true);if(record._.fieldsSortOnNeed.get(name)){record._.sort(record,name);}}
record._.gettingField=true;const val=recordFullProxy[name];record._.gettingField=false;if(isRelation(Model,name)){const recordListFullProxy=val._proxy;if(isMany(Model,name)){return recordListFullProxy;}
return recordListFullProxy[0];}
return Reflect.get(record,name,recordFullProxy);},deleteProperty(record,name){return store.MAKE_UPDATE(function recordDeleteProperty(){if(isRelation(Model,name)){const recordList=record[name];recordList.clear();return true;}
return Reflect.deleteProperty(record,name);});},set(record,name,val,receiver){if(record._.updatingAttrs.has(name)){record[name]=val;return true;}
return store.MAKE_UPDATE(function recordSet(){const reactiveSet=receiver!==record._proxyInternal;if(reactiveSet){record._.proxyUsed.set(name,true);}
store._.updateFields(record,{[name]:val});if(reactiveSet){record._.proxyUsed.delete(name);}
return true;});},});record._proxyInternal=recordProxyInternal;const recordProxy=reactive(recordProxyInternal);record._proxy=recordProxy;if(record?.[STORE_SYM]){record.recordByLocalId=store.recordByLocalId;record._=markRaw(toRaw(store._));store=record;Record.store=store;}
for(const name of Model._.fields.keys()){record._.prepareField(record,name,recordProxy);}
return recordProxy;}},}[OgClass.getName()];Model._=markRaw(new ModelInternal());Object.assign(Model,{Class,env,records:reactive({}),});Models[Model.getName()]=Model;store[Model.getName()]=Model;const obj=new OgClass();obj.setup();for(const[name,val]of Object.entries(obj)){if(isFieldDefinition(val)){Model._.prepareField(name,val);}}}
for(const Model of Object.values(Models)){for(const name of Model._.fields.keys()){if(!isRelation(Model,name)){continue;}
const targetModel=Model._.fieldsTargetModel.get(name);const inverse=Model._.fieldsInverse.get(name);if(targetModel&&!Models[targetModel]){throw new Error(`No target model ${targetModel} exists`);}
if(inverse){const OtherModel=Models[targetModel];const rel2TargetModel=OtherModel._.fieldsTargetModel.get(inverse);const rel2Inverse=OtherModel._.fieldsInverse.get(inverse);if(rel2TargetModel&&rel2TargetModel!==Model.getName()){throw new Error(`Fields ${Models[
                            targetModel
                        ].getName()}.${inverse} has wrong targetModel. Expected: "${Model.getName()}" Actual: "${rel2TargetModel}"`);}
if(rel2Inverse&&rel2Inverse!==name){throw new Error(`Fields ${Models[
                            targetModel
                        ].getName()}.${inverse} has wrong inverse. Expected: "${name}" Actual: "${rel2Inverse}"`);}
OtherModel._.fieldsTargetModel.set(inverse,Model.getName());OtherModel._.fieldsInverse.set(inverse,name);Model._.fieldsEager.set(name,true);OtherModel._.fieldsEager.set(inverse,true);}}}
Object.assign(store.Store,{store,_rawStore:store});store=toRaw(store.Store.insert())._raw;for(const Model of Object.values(Models)){Model._rawStore=store;Model.store=store._proxy;store._proxy[Model.getName()]=Model;}
Object.assign(store,{Models,storeReady:true});return store._proxy;}
return __exports;});;

/* /mail/static/src/model/misc.js */
odoo.define('@mail/model/misc',['@odoo/owl','@web/core/registry'],function(require){'use strict';let __exports={};const{markup}=require("@odoo/owl");const{registry}=require("@web/core/registry");const modelRegistry=__exports.modelRegistry=registry.category("discuss.model");const Markup=__exports.Markup=markup("").constructor;const FIELD_DEFINITION_SYM=__exports.FIELD_DEFINITION_SYM=Symbol("field_definition");const ATTR_SYM=__exports.ATTR_SYM=Symbol("attr");const MANY_SYM=__exports.MANY_SYM=Symbol("many");const ONE_SYM=__exports.ONE_SYM=Symbol("one");const OR_SYM=__exports.OR_SYM=Symbol("or");const AND_SYM=Symbol("and");const IS_RECORD_SYM=__exports.IS_RECORD_SYM=Symbol("isRecord");const IS_FIELD_SYM=__exports.IS_FIELD_SYM=Symbol("isField");const IS_DELETING_SYM=__exports.IS_DELETING_SYM=Symbol("isDeleting");const IS_DELETED_SYM=__exports.IS_DELETED_SYM=Symbol("isDeleted");const STORE_SYM=__exports.STORE_SYM=Symbol("store");__exports.AND=AND;function AND(...args){return[AND_SYM,...args];}
__exports.OR=OR;function OR(...args){return[OR_SYM,...args];}
__exports.isCommand=isCommand;function isCommand(data){return["ADD","DELETE","ADD.noinv","DELETE.noinv"].includes(data?.[0]?.[0]);}
__exports.isOne=isOne;function isOne(Model,fieldName){return Model._.fieldsOne.get(fieldName);}
__exports.isMany=isMany;function isMany(Model,fieldName){return Model._.fieldsMany.get(fieldName);}
__exports.isRecord=isRecord;function isRecord(record){return Boolean(record?._?.[IS_RECORD_SYM]);}
__exports.isRelation=isRelation;function isRelation(Model,fieldName){return isMany(Model,fieldName)||isOne(Model,fieldName);}
__exports.isFieldDefinition=isFieldDefinition;function isFieldDefinition(val){return val?.[FIELD_DEFINITION_SYM];}
return __exports;});;

/* /mail/static/src/model/model_internal.js */
odoo.define('@mail/model/model_internal',['@mail/model/misc'],function(require){'use strict';let __exports={};const{ATTR_SYM,MANY_SYM,ONE_SYM}=require("@mail/model/misc");const ModelInternal=__exports.ModelInternal=class ModelInternal{fields=new Map();fieldsAttr=new Map();fieldsOne=new Map();fieldsMany=new Map();fieldsHtml=new Map();fieldsTargetModel=new Map();fieldsCompute=new Map();fieldsEager=new Map();fieldsInverse=new Map();fieldsOnAdd=new Map();fieldsOnDelete=new Map();fieldsOnUpdate=new Map();fieldsSort=new Map();fieldsType=new Map();prepareField(fieldName,data){this.fields.set(fieldName,true);if(data[ATTR_SYM]){this.fieldsAttr.set(fieldName,true);}
if(data[ONE_SYM]){this.fieldsOne.set(fieldName,true);}
if(data[MANY_SYM]){this.fieldsMany.set(fieldName,true);}
for(const key in data){const value=data[key];switch(key){case"html":{if(!value){break;}
this.fieldsHtml.set(fieldName,value);break;}
case"targetModel":{this.fieldsTargetModel.set(fieldName,value);break;}
case"compute":{this.fieldsCompute.set(fieldName,value);break;}
case"eager":{if(!value){break;}
this.fieldsEager.set(fieldName,value);break;}
case"sort":{this.fieldsSort.set(fieldName,value);break;}
case"inverse":{this.fieldsInverse.set(fieldName,value);break;}
case"onAdd":{this.fieldsOnAdd.set(fieldName,value);break;}
case"onDelete":{this.fieldsOnDelete.set(fieldName,value);break;}
case"onUpdate":{this.fieldsOnUpdate.set(fieldName,value);break;}
case"type":{this.fieldsType.set(fieldName,value);break;}}}}}
return __exports;});;

/* /mail/static/src/model/record.js */
odoo.define('@mail/model/record',['@odoo/owl','@mail/model/misc','@web/core/l10n/dates'],function(require){'use strict';let __exports={};const{toRaw}=require("@odoo/owl");const{ATTR_SYM,FIELD_DEFINITION_SYM,IS_DELETED_SYM,MANY_SYM,ONE_SYM,OR_SYM,isCommand,isMany,isOne,isRecord,isRelation,modelRegistry,}=require("@mail/model/misc");const{serializeDate,serializeDateTime}=require("@web/core/l10n/dates");const Record=__exports.Record=class Record{static _;_;static id;static env;env;static records;static store;static MAKE_UPDATE(fn){return this.store.MAKE_UPDATE(...arguments);}
static onChange(record,name,cb){return this.store.onChange(...arguments);}
static get(data){const Model=toRaw(this);return this.records[Model.localId(data)];}
static getName(){return this._name||this.name;}
static register(localRegistry){if(localRegistry){localRegistry.add(this.getName(),this);}else{modelRegistry.add(this.getName(),this);}}
static localId(data){const Model=toRaw(this);let idStr;if(typeof data==="object"&&data!==null){idStr=Model._localId(Model.id,data);}else{idStr=data;}
return`${Model.getName()},${idStr}`;}
static _localId(expr,data,{brackets=false}={}){const Model=toRaw(this);if(!Array.isArray(expr)){if(Model._.fields.get(expr)){if(Model._.fieldsMany.get(expr)){throw new Error("Using a Record.Many() as id is not (yet) supported");}
if(!isRelation(Model,expr)){return data[expr];}
if(isCommand(data[expr])){const[cmd,data2]=data[expr].at(-1);if(cmd==="DELETE"){return undefined;}else{return`(${data2?.localId})`;}}
if(isRecord(data[expr])){return`(${data[expr]?.localId})`;}
const TargetModelName=Model._.fieldsTargetModel.get(expr);return`(${Model.store[TargetModelName].get(data[expr])?.localId})`;}
return data[expr];}
const vals=[];for(let i=1;i<expr.length;i++){vals.push(Model._localId(expr[i],data,{brackets:true}));}
let res=vals.join(expr[0]===OR_SYM?" OR ":" AND ");if(brackets){res=`(${res})`;}
return res;}
static _retrieveIdFromData(data){const Model=toRaw(this);const res={};function _deepRetrieve(expr2){if(typeof expr2==="string"){if(isCommand(data[expr2])){const[cmd,data2]=data[expr2].at(-1);return Object.assign(res,{[expr2]:cmd==="DELETE"?undefined:cmd==="DELETE.noinv"?[["DELETE.noinv",data2]]:cmd==="ADD.noinv"?[["ADD.noinv",data2]]:data2,});}
return Object.assign(res,{[expr2]:data[expr2]});}
if(expr2 instanceof Array){for(const expr of this.id){if(typeof expr==="symbol"){continue;}
_deepRetrieve(expr);}}}
if(Model.id===undefined){return res;}
if(typeof Model.id==="string"){if(typeof data!=="object"||data===null){return{[Model.id]:data};}
if(isCommand(data[Model.id])){const[cmd,data2]=data[Model.id].at(-1);return Object.assign(res,{[Model.id]:cmd==="DELETE"?undefined:cmd==="DELETE.noinv"?[["DELETE.noinv",data2]]:cmd==="ADD.noinv"?[["ADD.noinv",data2]]:data2,});}
return{[Model.id]:data[Model.id]};}
for(const expr of Model.id){if(typeof expr==="symbol"){continue;}
_deepRetrieve(expr);}
return res;}
static Class;static new(data,ids){const Model=toRaw(this);const store=Model._rawStore;return store.MAKE_UPDATE(function RecordNew(){const recordProxy=new Model.Class();const record=toRaw(recordProxy)._raw;Object.assign(record._,{localId:Model.localId(ids)});Object.assign(recordProxy,{...ids});Model.records[record.localId]=recordProxy;if(record.Model.getName()==="Store"){Object.assign(record,{env:Model._rawStore.env,recordByLocalId:Model._rawStore.recordByLocalId,});}
Model._rawStore.recordByLocalId.set(record.localId,recordProxy);for(const fieldName of record.Model._.fields.keys()){record._.requestCompute?.(record,fieldName);record._.requestSort?.(record,fieldName);}
return recordProxy;});}
static one(targetModel,param1){return{...param1,targetModel,[FIELD_DEFINITION_SYM]:true,[ONE_SYM]:true};}
static many(targetModel,param1){return{...param1,targetModel,[FIELD_DEFINITION_SYM]:true,[MANY_SYM]:true};}
static attr(def,param1){return{...param1,[FIELD_DEFINITION_SYM]:true,[ATTR_SYM]:true,default:def};}
static insert(data,options={}){const ModelFullProxy=this;const Model=toRaw(ModelFullProxy);const store=Model._rawStore;return store.MAKE_UPDATE(function RecordInsert(){const isMulti=Array.isArray(data);if(!isMulti){data=[data];}
const oldTrusted=store._.trusted;store._.trusted=options.html??store._.trusted;const res=data.map(function RecordInsertMap(d){return Model._insert.call(ModelFullProxy,d,options);});store._.trusted=oldTrusted;if(!isMulti){return res[0];}
return res;});}
static _insert(data){const ModelFullProxy=this;const Model=toRaw(ModelFullProxy);const recordFullProxy=Model.preinsert.call(ModelFullProxy,data);const record=toRaw(recordFullProxy)._raw;record.update.call(record._proxy,data);return recordFullProxy;}
static preinsert(data){const ModelFullProxy=this;const Model=toRaw(ModelFullProxy);const ids=Model._retrieveIdFromData(data);for(const name in ids){if(ids[name]&&!isRecord(ids[name])&&!isCommand(ids[name])&&isRelation(Model,name)){ids[name]=Model._rawStore[Model._.fieldsTargetModel.get(name)].preinsert(ids[name]);}}
return Model.get.call(ModelFullProxy,data)??Model.new(data,ids);}
get store(){return toRaw(this)._raw.Model._rawStore._proxy;}
get _rawStore(){return toRaw(this)._raw.Model._rawStore;}
Model;get localId(){return toRaw(this)._.localId;}
_raw;_proxyInternal;_proxy;setup(){}
update(data){const record=toRaw(this)._raw;const store=record._rawStore;return store.MAKE_UPDATE(function recordUpdate(){if(typeof data==="object"&&data!==null){store._.updateFields(record,data);}else{store._.updateFields(record,{[record.Model.id]:data});}});}
delete(){const record=toRaw(this)._raw;const store=record._rawStore;return store.MAKE_UPDATE(function recordDelete(){store._.ADD_QUEUE("delete",record);});}
exists(){return!this._[IS_DELETED_SYM];}
eq(record){return toRaw(this)._raw===toRaw(record)?._raw;}
notEq(record){return!this.eq(record);}
in(collection){if(!collection){return false;}
return collection.some((record)=>toRaw(record)._raw.eq(this));}
notIn(collection){return!this.in(collection);}
toData(){const recordProxy=this;const record=toRaw(recordProxy)._raw;const Model=record.Model;const data={...recordProxy};for(const name of Model._.fields.keys()){if(isMany(Model,name)){data[name]=record._proxyInternal[name].map((recordProxy)=>{const record=toRaw(recordProxy)._raw;return record.toIdData.call(record._proxyInternal);});}else if(isOne(Model,name)){const otherRecord=toRaw(record._proxyInternal[name])?._raw;data[name]=otherRecord?.toIdData.call(otherRecord._proxyInternal);}else{const value=recordProxy[name];if(Model._.fieldsType.get(name)==="datetime"&&value){data[name]=serializeDateTime(value);}else if(Model._.fieldsType.get(name)==="date"&&value){data[name]=serializeDate(value);}else{data[name]=value;}}}
delete data._;delete data._fieldsValue;delete data._proxy;delete data._proxyInternal;delete data._raw;delete data.Model;return data;}
toIdData(){const data=this.Model._retrieveIdFromData(this);for(const[name,val]of Object.entries(data)){if(isRecord(val)){data[name]=val.toIdData();}}
return data;}}
Record.register();return __exports;});;

/* /mail/static/src/model/record_internal.js */
odoo.define('@mail/model/record_internal',['@mail/utils/common/misc','@mail/model/misc','@mail/model/record_list','@odoo/owl','@mail/model/record_uses'],function(require){'use strict';let __exports={};const{onChange}=require("@mail/utils/common/misc");const{IS_DELETED_SYM,IS_DELETING_SYM,IS_RECORD_SYM,isRelation}=require("@mail/model/misc");const{RecordList}=require("@mail/model/record_list");const{reactive,toRaw}=require("@odoo/owl");const{RecordUses}=require("@mail/model/record_uses");const RecordInternal=__exports.RecordInternal=class RecordInternal{[IS_RECORD_SYM]=true;[IS_DELETED_SYM]=false;fieldsComputing=new Map();fieldsSortOnNeed=new Map();fieldsSortInNeed=new Map();fieldsSorting=new Map();fieldsComputeInNeed=new Map();fieldsComputeOnNeed=new Map();fieldsOnUpdateObserves=new Map();fieldsSortProxy2=new Map();fieldsComputeProxy2=new Map();uses=new RecordUses();updatingAttrs=new Map();proxyUsed=new Map();localId;gettingField=false;prepareField(record,fieldName,recordProxy){const self=this;const Model=toRaw(record).Model;if(isRelation(Model,fieldName)){const recordList=new RecordList();Object.assign(recordList._,{name:fieldName,owner:record,});Object.assign(recordList,{_raw:recordList,_store:record.store,});record[fieldName]=recordList;}else{record[fieldName]=record[fieldName].default;}
if(Model._.fieldsCompute.get(fieldName)){if(!Model._.fieldsEager.get(fieldName)){onChange(recordProxy,fieldName,()=>{if(this.fieldsComputing.get(fieldName)){this.fieldsComputeInNeed.delete(fieldName);}});this.fieldsComputeInNeed.delete(fieldName);this.fieldsSortInNeed.delete(fieldName);}
const cb=function computeObserver(){self.requestCompute(record,fieldName);};const computeProxy2=reactive(recordProxy,cb);this.fieldsComputeProxy2.set(fieldName,computeProxy2);}
if(Model._.fieldsSort.get(fieldName)){if(!Model._.fieldsEager.get(fieldName)){onChange(recordProxy,fieldName,()=>{if(this.fieldsSorting.get(fieldName)){this.fieldsSortInNeed.delete(fieldName);}});this.fieldsComputeInNeed.delete(fieldName);this.fieldsSortInNeed.delete(fieldName);}
const sortProxy2=reactive(recordProxy,function sortObserver(){self.requestSort(record,fieldName);});this.fieldsSortProxy2.set(fieldName,sortProxy2);}
if(Model._.fieldsOnUpdate.get(fieldName)){const store=Model.store;store._onChange(recordProxy,fieldName,(obs)=>{this.fieldsOnUpdateObserves.set(fieldName,obs);if(store._.UPDATE!==0){store._.ADD_QUEUE("onUpdate",record,fieldName);}else{this.onUpdate(record,fieldName);}});}}
requestCompute(record,fieldName,{force=false}={}){if(record._[IS_DELETING_SYM]){return;}
const Model=record.Model;if(!Model._.fieldsCompute.get(fieldName)){return;}
const store=record._rawStore;if(store._.UPDATE!==0&&!force){store._.ADD_QUEUE("compute",record,fieldName);}else{if(Model._.fieldsEager.get(fieldName)||this.fieldsComputeInNeed.get(fieldName)){this.compute(record,fieldName);}else{this.fieldsComputeOnNeed.set(fieldName,true);}}}
requestSort(record,fieldName,{force}={}){if(record._[IS_DELETING_SYM]){return;}
const Model=record.Model;if(!Model._.fieldsSort.get(fieldName)){return;}
const store=record._rawStore;if(store._.UPDATE!==0&&!force){store._.ADD_QUEUE("sort",record,fieldName);}else{if(Model._.fieldsEager.get(fieldName)||this.fieldsSortInNeed.get(fieldName)){this.sort(record,fieldName);}else{this.fieldsSortOnNeed.set(fieldName,true);}}}
compute(record,fieldName){const Model=record.Model;const store=record._rawStore;this.fieldsComputing.set(fieldName,true);this.fieldsComputeOnNeed.delete(fieldName);store._.updateFields(record,{[fieldName]:Model._.fieldsCompute.get(fieldName).call(this.fieldsComputeProxy2.get(fieldName)),});this.fieldsComputing.delete(fieldName);}
sort(record,fieldName){const Model=record.Model;if(!Model._.fieldsSort.get(fieldName)){return;}
const store=record._rawStore;this.fieldsSortOnNeed.delete(fieldName);this.fieldsSorting.set(fieldName,true);const proxy2Sort=this.fieldsSortProxy2.get(fieldName);const func=Model._.fieldsSort.get(fieldName).bind(proxy2Sort);if(isRelation(Model,fieldName)){store._.sortRecordList(proxy2Sort[fieldName]._proxy,func);}else{const copy=[...proxy2Sort[fieldName]];copy.sort(func);const hasChanged=copy.some((item,index)=>item!==record[fieldName][index]);if(hasChanged){proxy2Sort[fieldName]=copy;}}
this.fieldsSorting.delete(fieldName);}
onUpdate(record,fieldName){const Model=record.Model;if(!Model._.fieldsOnUpdate.get(fieldName)){return;}
Model._.fieldsOnUpdate.get(fieldName).call(record._proxyInternal);this.fieldsOnUpdateObserves.get(fieldName)?.();}
downgradeProxy(record,fullProxy){return record._proxy===fullProxy?record._proxyInternal:fullProxy;}}
return __exports;});;

/* /mail/static/src/model/record_list.js */
odoo.define('@mail/model/record_list',['@odoo/owl','@mail/model/misc'],function(require){'use strict';let __exports={};const{markRaw,reactive,toRaw}=require("@odoo/owl");const{isRecord}=require("@mail/model/misc");function getInverse(reclist){return reclist._.owner.Model._.fieldsInverse.get(reclist._.name);}
function getTargetModel(reclist){return reclist._.owner.Model._.fieldsTargetModel.get(reclist._.name);}
function isComputeField(reclist){return reclist._.owner.Model._.fieldsCompute.get(reclist._.name);}
function isSortField(reclist){return reclist._.owner.Model._.fieldsSort.get(reclist._.name);}
function isEager(reclist){return reclist._.owner.Model._.fieldsEager.get(reclist._.name);}
function setComputeInNeed(reclist){reclist._.owner._.fieldsComputeInNeed.set(reclist._.name,true);}
function setSortInNeed(reclist){reclist._.owner._.fieldsSortInNeed.set(reclist._.name,true);}
function isComputeOnNeed(reclist){return reclist._.owner._.fieldsComputeOnNeed.get(reclist._.name);}
function isSortOnNeed(reclist){return reclist._.owner._.fieldsSortOnNeed.get(reclist._.name);}
function computeField(reclist){reclist._.owner._.compute(reclist._.owner,reclist._.name);}
function sortField(reclist){reclist._.owner._.sort(reclist._.owner,reclist._.name);}
function isOne(reclist){return reclist._.owner.Model._.fieldsOne.get(reclist._.name);}
const RecordListInternal=__exports.RecordListInternal=class RecordListInternal{name;owner;addNoinv(recordList,...records){const self=this;const store=recordList._store;if(isOne(recordList)){const last=records.at(-1);if(isRecord(last)&&last.in(recordList)){return;}
const record=self.insert(recordList,last,function recordList_AddNoInvOneInsert(record){if(record.localId!==recordList.data[0]){const old=recordList._proxy.at(-1);recordList._proxy.data.pop();old?._.uses.delete(recordList);recordList._proxy.data.push(record.localId);self.syncLength(recordList);record._.uses.add(recordList);}},{inv:false});store._.ADD_QUEUE("onAdd",self.owner,self.name,record);return;}
for(const val of records){if(isRecord(val)&&val.in(recordList)){continue;}
const record=self.insert(recordList,val,function recordList_AddNoInvManyInsert(record){if(recordList.data.indexOf(record.localId)===-1){recordList._proxy.data.push(record.localId);self.syncLength(recordList);record._.uses.add(recordList);}},{inv:false});store._.ADD_QUEUE("onAdd",self.owner,self.name,record);}}
assign(recordList,data){const self=this;const store=recordList._store;return store.MAKE_UPDATE(function recordListAssign(){const collection=isRecord(data)?[data]:data;const vals=[...collection];const oldRecords=recordList._proxyInternal.slice.call(recordList._proxy).map((recordProxy)=>toRaw(recordProxy)._raw);const newRecords=vals.map((val)=>self.insert(recordList,val,function recordListAssignInsert(record){if(record.notIn(oldRecords)){record._.uses.add(recordList);store._.ADD_QUEUE("onAdd",self.owner,self.name,record);}}));const inverse=getInverse(recordList);for(const oldRecord of oldRecords){if(oldRecord.notIn(newRecords)){oldRecord._.uses.delete(recordList);store._.ADD_QUEUE("onDelete",self.owner,self.name,oldRecord);if(inverse){oldRecord[inverse].delete(self.owner);}}}
recordList._proxy.data=newRecords.map((newRecord)=>newRecord.localId);recordList._.syncLength(recordList);});}
deleteNoinv(recordList,...records){const self=this;const store=recordList._store;for(const val of records){const record=this.insert(recordList,val,function recordList_DeleteNoInv_Insert(record){const index=recordList.data.indexOf(record.localId);if(index!==-1){const old=recordList._proxy.at(-1);recordList.splice.call(recordList._proxy,index,1);self.syncLength(recordList);old._.uses.delete(recordList);}},{inv:false});store._.ADD_QUEUE("onDelete",self.owner,self.name,record);}}
downgradeProxy(recordList,fullProxy){return recordList._proxy===fullProxy?recordList._proxyInternal:fullProxy;}
insert(recordList,val,fn,{inv=true,mode="ADD"}={}){const inverse=getInverse(recordList);const targetModel=getTargetModel(recordList);if(typeof val!=="object"){val={[recordList._store[targetModel].id]:val};}
if(inverse&&inv){const target=isRecord(val)&&val._raw===val?val._proxy:val;target[inverse]=[[mode==="ADD"?"ADD.noinv":"DELETE.noinv",recordList._.owner]];}
let newRecordProxy;if(!isRecord(val)){newRecordProxy=recordList._store[targetModel].preinsert(val);}else{newRecordProxy=val;}
const newRecord=toRaw(newRecordProxy)._raw;fn?.(newRecord);if(!isRecord(val)){recordList._store[targetModel].insert(val);}
return newRecord;}
syncLength(reclist){reclist.length=reclist.data.length;}}
const RecordList=__exports.RecordList=class RecordList extends Array{_store;data=[];_raw;_proxyInternal;_proxy;_=markRaw(new RecordListInternal());constructor(){super();const recordList=this;recordList._raw=recordList;const recordListProxyInternal=new Proxy(recordList,{get(recordList,name,recordListFullProxy){recordListFullProxy=recordList._.downgradeProxy(recordList,recordListFullProxy);if(typeof name==="symbol"||Object.keys(recordList).includes(name)||Object.prototype.hasOwnProperty.call(recordList.constructor.prototype,name)){let res=Reflect.get(...arguments);if(typeof res==="function"){res=res.bind(recordListFullProxy);}
return res;}
if(isComputeField(recordList)&&!isEager(recordList)){setComputeInNeed(recordList);if(isComputeOnNeed(recordList)){computeField(recordList);}}
if(name==="length"){return recordListFullProxy.data.length;}
if(isSortField(recordList)&&!isEager(recordList)){setSortInNeed(recordList);if(isSortOnNeed(recordList)){sortField(recordList);}}
if(typeof name!=="symbol"&&!window.isNaN(parseInt(name))){const index=parseInt(name);return recordListFullProxy._store.recordByLocalId.get(recordListFullProxy.data[index]);}
const array=[...recordList[Symbol.iterator].call(recordListFullProxy)];return array[name]?.bind(array);},set(recordList,name,val,recordListProxy){const store=recordList._store;return store.MAKE_UPDATE(function recordListSet(){if(typeof name!=="symbol"&&!window.isNaN(parseInt(name))){const index=parseInt(name);recordList._.insert(recordList,val,function recordListSet_Insert(newRecord){const oldRecord=toRaw(recordList._store.recordByLocalId).get(recordList.data[index]);if(oldRecord&&oldRecord.notEq(newRecord)){oldRecord._.uses.delete(recordList);}
store._.ADD_QUEUE("onDelete",recordList._.owner,recordList._.name,oldRecord);const inverse=getInverse(recordList);if(inverse){oldRecord[inverse].delete(recordList);}
recordListProxy.data[index]=newRecord?.localId;if(newRecord){newRecord._.uses.add(recordList);store._.ADD_QUEUE("onAdd",recordList._.owner,recordList._.name,newRecord);if(inverse){newRecord[inverse].add(recordList);}}});}else if(name==="length"){const newLength=parseInt(val);if(newLength!==recordList.data.length){if(newLength<recordList.data.length){recordList.splice.call(recordListProxy,newLength,recordList.length-newLength);}
recordListProxy.data.length=newLength;recordList._.syncLength(recordList);}}else{return Reflect.set(recordList,name,val,recordListProxy);}
return true;});},});recordList._proxyInternal=recordListProxyInternal;recordList._proxy=reactive(recordListProxyInternal);return recordList;}
push(...records){const recordList=toRaw(this)._raw;const recordListFullProxy=recordList._.downgradeProxy(recordList,this);const store=recordList._store;return store.MAKE_UPDATE(function recordListPush(){for(const val of records){const record=recordList._.insert(recordList,val,function recordListPushInsert(record){recordList._proxy.data.push(record.localId);recordList._.syncLength(recordList);record._.uses.add(recordList);});store._.ADD_QUEUE("onAdd",recordList._.owner,recordList._.name,record);const inverse=getInverse(recordList);if(inverse){record[inverse].add(recordList._.owner);}}
return recordListFullProxy.data.length;});}
pop(){const recordList=toRaw(this)._raw;const recordListFullProxy=recordList._.downgradeProxy(recordList,this);const store=recordList._store;return store.MAKE_UPDATE(function recordListPop(){const oldRecordProxy=recordListFullProxy.at(-1);if(oldRecordProxy){recordList.splice.call(recordListFullProxy,recordListFullProxy.length-1,1);}
return oldRecordProxy;});}
shift(){const recordList=toRaw(this)._raw;const recordListFullProxy=recordList._.downgradeProxy(recordList,this);const store=recordList._store;return store.MAKE_UPDATE(function recordListShift(){const recordProxy=recordListFullProxy._store.recordByLocalId.get(recordListFullProxy.data.shift());recordList._.syncLength(recordList);if(!recordProxy){return;}
const record=toRaw(recordProxy)._raw;record._.uses.delete(recordList);store._.ADD_QUEUE("onDelete",recordList._.owner,recordList._.name,record);const inverse=getInverse(recordList);if(inverse){record[inverse].delete(recordList._.owner);}
return recordProxy;});}
unshift(...records){const recordList=toRaw(this)._raw;const recordListFullProxy=recordList._.downgradeProxy(recordList,this);const store=recordList._store;return store.MAKE_UPDATE(function recordListUnshift(){for(let i=records.length-1;i>=0;i--){const record=recordList._.insert(recordList,records[i],(record)=>{recordList._proxy.data.unshift(record.localId);recordList._.syncLength(recordList);record._.uses.add(recordList);});store._.ADD_QUEUE("onAdd",recordList._.owner,recordList._.name,record);const inverse=getInverse(recordList);if(inverse){record[inverse].add(recordList._.owner);}}
return recordListFullProxy.data.length;});}
indexOf(recordProxy){const recordList=toRaw(this)._raw;const recordListFullProxy=recordList._.downgradeProxy(recordList,this);return recordListFullProxy.data.indexOf(toRaw(recordProxy)?._raw.localId);}
splice(start,deleteCount,...newRecordsProxy){const recordList=toRaw(this)._raw;const recordListFullProxy=recordList._.downgradeProxy(recordList,this);const store=recordList._store;return store.MAKE_UPDATE(function recordListSplice(){const oldRecordsProxy=recordList._proxyInternal.slice.call(recordListFullProxy,start,start+deleteCount);const list=recordListFullProxy.data.slice();list.splice(start,deleteCount,...newRecordsProxy.map((newRecordProxy)=>toRaw(newRecordProxy)._raw.localId));if(isOne(recordList)&&start===0&&deleteCount===1){if(list.length===0){recordList._proxy.data.pop();}else{recordList._proxy.data[0]=list[0];}}else{recordList._proxy.data=list;}
recordList._.syncLength(recordList);for(const oldRecordProxy of oldRecordsProxy){const oldRecord=toRaw(oldRecordProxy)._raw;oldRecord._.uses.delete(recordList);store._.ADD_QUEUE("onDelete",recordList._.owner,recordList._.name,oldRecord);const inverse=getInverse(recordList);if(inverse){oldRecord[inverse].delete(recordList._.owner);}}
for(const newRecordProxy of newRecordsProxy){const newRecord=toRaw(newRecordProxy)._raw;newRecord._.uses.add(recordList);store._.ADD_QUEUE("onAdd",recordList._.owner,recordList._.name,newRecord);const inverse=getInverse(recordList);if(inverse){newRecord[inverse].add(recordList._.owner);}}});}
sort(func){const recordList=toRaw(this)._raw;const recordListFullProxy=recordList._.downgradeProxy(recordList,this);const store=recordList._store;return store.MAKE_UPDATE(function recordListSort(){recordList._store._.sortRecordList(recordListFullProxy,func);return recordListFullProxy;});}
concat(...collections){const recordList=toRaw(this)._raw;const recordListFullProxy=recordList._.downgradeProxy(recordList,this);return recordListFullProxy.data.map((localId)=>recordListFullProxy._store.recordByLocalId.get(localId)).concat(...collections.map((c)=>[...c]));}
add(...records){const recordList=toRaw(this)._raw;const store=recordList._store;return store.MAKE_UPDATE(function recordListAdd(){if(isOne(recordList)){const last=records.at(-1);if(isRecord(last)&&recordList.data.includes(toRaw(last)._raw.localId)){return last;}
return recordList._.insert(recordList,last,function recordListAddInsertOne(record){if(record.localId!==recordList.data[0]){recordList.splice.call(recordList._proxy,0,1,record);}});}
const res=[];for(const val of records){if(isRecord(val)&&recordList.data.includes(val.localId)){continue;}
const rec=recordList._.insert(recordList,val,function recordListAddInsertMany(record){if(recordList.data.indexOf(record.localId)===-1){recordList.push.call(recordList._proxy,record);}});res.push(rec);}
return res.length===1?res[0]:res;});}
delete(...records){const recordList=toRaw(this)._raw;const store=recordList._store;return store.MAKE_UPDATE(function recordListDelete(){for(const val of records){recordList._.insert(recordList,val,function recordListDelete_Insert(record){const index=recordList.data.indexOf(record.localId);if(index!==-1){recordList.splice.call(recordList._proxy,index,1);}},{mode:"DELETE"});}});}
clear(){const recordList=toRaw(this)._raw;const store=recordList._store;return store.MAKE_UPDATE(function recordListClear(){while(recordList.data.length>0){recordList.pop.call(recordList._proxy);}});}*[Symbol.iterator](){const recordList=toRaw(this)._raw;const recordListFullProxy=recordList._.downgradeProxy(recordList,this);for(const localId of recordListFullProxy.data){yield recordListFullProxy._store.recordByLocalId.get(localId);}}
at(index){const recordList=toRaw(this)._raw;const recordListFullProxy=recordList._.downgradeProxy(recordList,this);return recordListFullProxy._store.recordByLocalId.get(recordListFullProxy.data.at(index));}}
return __exports;});;

/* /mail/static/src/model/record_uses.js */
odoo.define('@mail/model/record_uses',[],function(require){'use strict';let __exports={};const RecordUses=__exports.RecordUses=class RecordUses{data=new Map();add(list){const record=list._.owner;if(!this.data.has(record.localId)){this.data.set(record.localId,new Map());}
const use=this.data.get(record.localId);if(!use.get(list._.name)){use.set(list._.name,0);}
use.set(list._.name,use.get(list._.name)+1);}
delete(list){const record=list._.owner;if(!this.data.has(record.localId)){return;}
const use=this.data.get(record.localId);if(!use.get(list._.name)){return;}
use.set(list._.name,use.get(list._.name)-1);if(use.get(list._.name)===0){use.delete(list._.name);}}}
return __exports;});;

/* /mail/static/src/model/store.js */
odoo.define('@mail/model/store',['@mail/model/record','@mail/model/misc','@odoo/owl'],function(require){'use strict';let __exports={};const{Record}=require("@mail/model/record");const{IS_DELETED_SYM,STORE_SYM}=require("@mail/model/misc");const{reactive,toRaw}=require("@odoo/owl");const Store=__exports.Store=class Store extends Record{_;[STORE_SYM]=true;recordByLocalId;storeReady=false;get(localId){return this.recordByLocalId.get(localId);}
MAKE_UPDATE(fn){this._.UPDATE++;const res=fn();this._.UPDATE--;if(this._.UPDATE===0){this._.UPDATE++;while(this._.FC_QUEUE.size>0||this._.FS_QUEUE.size>0||this._.FA_QUEUE.size>0||this._.FD_QUEUE.size>0||this._.FU_QUEUE.size>0||this._.RO_QUEUE.size>0||this._.RD_QUEUE.size>0||this._.RHD_QUEUE.size>0){const FC_QUEUE=new Map(this._.FC_QUEUE);const FS_QUEUE=new Map(this._.FS_QUEUE);const FA_QUEUE=new Map(this._.FA_QUEUE);const FD_QUEUE=new Map(this._.FD_QUEUE);const FU_QUEUE=new Map(this._.FU_QUEUE);const RO_QUEUE=new Map(this._.RO_QUEUE);const RD_QUEUE=new Map(this._.RD_QUEUE);const RHD_QUEUE=new Map(this._.RHD_QUEUE);this._.FC_QUEUE.clear();this._.FS_QUEUE.clear();this._.FA_QUEUE.clear();this._.FD_QUEUE.clear();this._.FU_QUEUE.clear();this._.RO_QUEUE.clear();this._.RD_QUEUE.clear();this._.RHD_QUEUE.clear();while(FC_QUEUE.size>0){const[record,recMap]=FC_QUEUE.entries().next().value;FC_QUEUE.delete(record);for(const fieldName of recMap.keys()){record._.requestCompute(record,fieldName,{force:true});}}
while(FS_QUEUE.size>0){const[record,recMap]=FS_QUEUE.entries().next().value;FS_QUEUE.delete(record);for(const fieldName of recMap.keys()){record._.requestSort(record,fieldName,{force:true});}}
while(FA_QUEUE.size>0){const[record,recMap]=FA_QUEUE.entries().next().value;FA_QUEUE.delete(record);while(recMap.size>0){const[fieldName,fieldMap]=recMap.entries().next().value;recMap.delete(fieldName);const onAdd=record.Model._.fieldsOnAdd.get(fieldName);for(const addedRec of fieldMap.keys()){onAdd?.call(record._proxy,addedRec._proxy);}}}
while(FD_QUEUE.size>0){const[record,recMap]=FD_QUEUE.entries().next().value;FD_QUEUE.delete(record);while(recMap.size>0){const[fieldName,fieldMap]=recMap.entries().next().value;recMap.delete(fieldName);const onDelete=record.Model._.fieldsOnDelete.get(fieldName);for(const removedRec of fieldMap.keys()){onDelete?.call(record._proxy,removedRec._proxy);}}}
while(FU_QUEUE.size>0){const[record,map]=FU_QUEUE.entries().next().value;FU_QUEUE.delete(record);for(const fieldName of map.keys()){record._.onUpdate(record,fieldName);}}
while(RO_QUEUE.size>0){const cb=RO_QUEUE.keys().next().value;RO_QUEUE.delete(cb);cb();}
while(RD_QUEUE.size>0){const record=RD_QUEUE.keys().next().value;RD_QUEUE.delete(record);for(const[localId,names]of record._.uses.data.entries()){for(const[name2,count]of names.entries()){const usingRecord2=toRaw(this.recordByLocalId).get(localId);if(!usingRecord2){record._.uses.data.delete(localId);continue;}
if(usingRecord2.Model._.fieldsMany.get(name2)){for(let c=0;c<count;c++){usingRecord2[name2].delete(record);}}else{usingRecord2[name2]=undefined;}}}
this._.ADD_QUEUE("hard_delete",toRaw(record));}
while(RHD_QUEUE.size>0){const record=RHD_QUEUE.keys().next().value;RHD_QUEUE.delete(record);record._[IS_DELETED_SYM]=true;delete record.Model.records[record.localId];this.recordByLocalId.delete(record.localId);}}
this._.UPDATE--;}
return res;}
onChange(record,name,cb){return this._onChange(record,name,(observe)=>{const fn=()=>{observe();cb();};if(this._.UPDATE!==0){if(!this._.RO_QUEUE.has(fn)){this._.RO_QUEUE.set(fn,true);}}else{fn();}});}
_onChange(record,key,callback){let proxy;function _observe(){const val=proxy[key];if(typeof val==="object"&&val!==null){void Object.keys(val);}
if(Array.isArray(val)){void val.length;void toRaw(val).forEach.call(val,(i)=>i);}}
if(Array.isArray(key)){for(const k of key){this._onChange(record,k,callback);}
return;}
let ready=true;proxy=reactive(record,()=>{if(ready){callback(_observe);}});_observe();return()=>{ready=false;};}}
return __exports;});;

/* /mail/static/src/model/store_internal.js */
odoo.define('@mail/model/store_internal',['@odoo/owl','@mail/model/record_internal','@web/core/l10n/dates','@mail/model/misc'],function(require){'use strict';let __exports={};const{markup,toRaw}=require("@odoo/owl");const{RecordInternal}=require("@mail/model/record_internal");const{deserializeDate,deserializeDateTime}=require("@web/core/l10n/dates");const{IS_DELETING_SYM,Markup,isCommand,isMany}=require("@mail/model/misc");const StoreInternal=__exports.StoreInternal=class StoreInternal extends RecordInternal{trusted=false;FC_QUEUE=new Map();FS_QUEUE=new Map();FA_QUEUE=new Map();FD_QUEUE=new Map();FU_QUEUE=new Map();RO_QUEUE=new Map();RD_QUEUE=new Map();RHD_QUEUE=new Map();UPDATE=0;ADD_QUEUE(type,...params){switch(type){case"delete":{const[record]=params;if(!this.RD_QUEUE.has(record)){this.RD_QUEUE.set(record,true);}
break;}
case"compute":{const[record,fieldName]=params;let recMap=this.FC_QUEUE.get(record);if(!recMap){recMap=new Map();this.FC_QUEUE.set(record,recMap);}
recMap.set(fieldName,true);break;}
case"sort":{const[record,fieldName]=params;let recMap=this.FS_QUEUE.get(record);if(!recMap){recMap=new Map();this.FS_QUEUE.set(record,recMap);}
recMap.set(fieldName,true);break;}
case"onAdd":{const[record,fieldName,addedRec]=params;const Model=record.Model;if(Model._.fieldsSort.get(fieldName)){this.ADD_QUEUE("sort",record,fieldName);}
if(!Model._.fieldsOnAdd.get(fieldName)){return;}
let recMap=this.FA_QUEUE.get(record);if(!recMap){recMap=new Map();this.FA_QUEUE.set(record,recMap);}
let fieldMap=recMap.get(fieldName);if(!fieldMap){fieldMap=new Map();recMap.set(fieldName,fieldMap);}
fieldMap.set(addedRec,true);break;}
case"onDelete":{const[record,fieldName,removedRec]=params;const Model=record.Model;if(!Model._.fieldsOnDelete.get(fieldName)){return;}
let recMap=this.FD_QUEUE.get(record);if(!recMap){recMap=new Map();this.FD_QUEUE.set(record,recMap);}
let fieldMap=recMap.get(fieldName);if(!fieldMap){fieldMap=new Map();recMap.set(fieldName,fieldMap);}
fieldMap.set(removedRec,true);break;}
case"onUpdate":{const[record,fieldName]=params;let recMap=this.FU_QUEUE.get(record);if(!recMap){recMap=new Map();this.FU_QUEUE.set(record,recMap);}
recMap.set(fieldName,true);break;}
case"hard_delete":{const[record]=params;record._[IS_DELETING_SYM]=true;if(!this.RHD_QUEUE.has(record)){this.RHD_QUEUE.set(record,true);}
break;}}}
sortRecordList(recordListFullProxy,func){const recordList=toRaw(recordListFullProxy)._raw;const recordsFullProxy=recordListFullProxy.data.map((localId)=>recordListFullProxy._store.recordByLocalId.get(localId));recordsFullProxy.sort(func);const data=recordsFullProxy.map((recordFullProxy)=>toRaw(recordFullProxy)._raw.localId);const hasChanged=recordList.data.some((localId,i)=>localId!==data[i]);if(hasChanged){recordListFullProxy.data=data;}}
updateAttr(record,fieldName,value){const Model=record.Model;const fieldType=Model._.fieldsType.get(fieldName);const fieldHtml=Model._.fieldsHtml.get(fieldName);const targetRecord=record._.proxyUsed.has(fieldName)?record:record._proxy;let shouldChange=record[fieldName]!==value;if(fieldType==="datetime"&&value){if(!(value instanceof luxon.DateTime)){value=deserializeDateTime(value);}
shouldChange=!record[fieldName]||!value.equals(record[fieldName]);}
if(fieldType==="date"&&value){if(!(value instanceof luxon.DateTime)){value=deserializeDate(value);}
shouldChange=!record[fieldName]||!value.equals(record[fieldName]);}
let newValue=value;if(fieldHtml&&this.trusted){shouldChange=record[fieldName]?.toString()!==value?.toString()||!(record[fieldName]instanceof Markup);newValue=typeof value==="string"?markup(value):value;}
if(shouldChange){record._.updatingAttrs.set(fieldName,true);targetRecord[fieldName]=newValue;record._.updatingAttrs.delete(fieldName);}}
updateFields(record,vals){for(const[fieldName,value]of Object.entries(vals)){if(!record.Model._.fields.get(fieldName)||record.Model._.fieldsAttr.get(fieldName)){this.updateAttr(record,fieldName,value);}else{this.updateRelation(record,fieldName,value);}}}
updateRelation(record,fieldName,value){const recordList=record[fieldName];if(isMany(record.Model,fieldName)){this.updateRelationMany(recordList,value);}else{this.updateRelationOne(recordList,value);}}
updateRelationMany(recordList,value){if(isCommand(value)){for(const[cmd,cmdData]of value){if(Array.isArray(cmdData)){for(const item of cmdData){if(cmd==="ADD"){recordList.add(item);}else if(cmd==="ADD.noinv"){recordList._.addNoinv(recordList,item);}else if(cmd==="DELETE.noinv"){recordList._.deleteNoinv(recordList,item);}else{recordList.delete(item);}}}else{if(cmd==="ADD"){recordList.add(cmdData);}else if(cmd==="ADD.noinv"){recordList._.addNoinv(recordList,cmdData);}else if(cmd==="DELETE.noinv"){recordList._.deleteNoinv(recordList,cmdData);}else{recordList.delete(cmdData);}}}}else if([null,false,undefined].includes(value)){recordList.clear();}else if(!Array.isArray(value)){recordList._.assign(recordList,[value]);}else{recordList._.assign(recordList,value);}}
updateRelationOne(recordList,value){if(isCommand(value)){const[cmd,cmdData]=value.at(-1);if(cmd==="ADD"){recordList.add(cmdData);}else if(cmd==="ADD.noinv"){recordList._.addNoinv(recordList,cmdData);}else if(cmd==="DELETE.noinv"){recordList._.deleteNoinv(recordList,cmdData);}else{recordList.delete(cmdData);}}else if([null,false,undefined].includes(value)){recordList.clear();}else{recordList.add(value);}}}
return __exports;});;

/* /mail/static/src/core/common/attachment_list.js */
odoo.define('@mail/core/common/attachment_list',['@odoo/owl','@web/core/browser/feature_detection','@web/core/confirmation_dialog/confirmation_dialog','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_hooks','@web/core/dropdown/dropdown_item','@web/core/file_viewer/file_viewer_hook','@web/core/l10n/translation','@web/core/utils/hooks','@web/core/utils/urls'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{isMobileOS}=require("@web/core/browser/feature_detection");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{Dropdown}=require("@web/core/dropdown/dropdown");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{useFileViewer}=require("@web/core/file_viewer/file_viewer_hook");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{url}=require("@web/core/utils/urls");class ImageActions extends Component{static components={Dropdown,DropdownItem};static props=["actions","imagesHeight"];static template="mail.ImageActions";setup(){super.setup();this.actionsMenuState=useDropdownState();this.isMobileOS=isMobileOS();}}
const AttachmentList=__exports.AttachmentList=class AttachmentList extends Component{static components={ImageActions};static props=["attachments","unlinkAttachment","imagesHeight","messageSearch?"];static template="mail.AttachmentList";setup(){super.setup();this.ui=useState(useService("ui"));this.imagesWidth=1920;this.dialog=useService("dialog");this.fileViewer=useFileViewer();this.actionsMenuState=useDropdownState();this.isMobileOS=isMobileOS();}
getImageUrl(attachment){if(attachment.uploading&&attachment.tmpUrl){return attachment.tmpUrl;}
return url(attachment.urlRoute,{...attachment.urlQueryParams,width:this.imagesWidth*2,height:this.props.imagesHeight*2,});}
get images(){return this.props.attachments.filter((a)=>a.isImage);}
get cards(){return this.props.attachments.filter((a)=>!a.isImage);}
canDownload(attachment){return!attachment.uploading&&!this.env.inComposer;}
onClickDownload(attachment){const downloadLink=document.createElement("a");downloadLink.setAttribute("href",attachment.downloadUrl);downloadLink.setAttribute("download","");downloadLink.click();}
onClickUnlink(attachment){if(this.env.inComposer){return this.props.unlinkAttachment(attachment);}
this.dialog.add(ConfirmationDialog,{body:_t('Do you really want to delete "%s"?',attachment.filename),cancel:()=>{},confirm:()=>this.onConfirmUnlink(attachment),});}
onConfirmUnlink(attachment){this.props.unlinkAttachment(attachment);}
onImageLoaded(){this.env.onImageLoaded?.();}
get isInChatWindowAndIsAlignedRight(){return this.env.inChatWindow&&this.env.alignedRight;}
get isInChatWindowAndIsAlignedLeft(){return this.env.inChatWindow&&!this.env.alignedRight;}
getActions(attachment){const res=[];if(this.showDelete){res.push({label:_t("Remove"),icon:"fa fa-trash",onSelect:()=>this.onClickUnlink(attachment),});}
if(this.canDownload(attachment)){res.push({label:_t("Download"),icon:"fa fa-download",onSelect:()=>this.onClickDownload(attachment),});}
return res;}
get showDelete(){if(this.env.inComposer){return true;}
if(!this.attachment.isDeletable){return false;}
return(!this.env.message||this.env.message.hasTextContent||(this.env.message&&this.props.attachments.length>1));}}
return __exports;});;

/* /mail/static/src/core/common/attachment_model.js */
odoo.define('@mail/core/common/attachment_model',['@mail/core/common/record','@mail/utils/common/misc','@web/core/network/rpc','@web/core/file_viewer/file_model'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{assignDefined}=require("@mail/utils/common/misc");const{rpc}=require("@web/core/network/rpc");const{FileModelMixin}=require("@web/core/file_viewer/file_model");const Attachment=__exports.Attachment=class Attachment extends FileModelMixin(Record){static id="id";static records={};static get(data){return super.get(data);}
static insert(data){return super.insert(...arguments);}
static new(){const attachment=super.new(...arguments);Record.onChange(attachment,["extension","filename"],()=>{if(!attachment.extension&&attachment.filename){attachment.extension=attachment.filename.split(".").pop();}});return attachment;}
thread=Record.one("Thread",{inverse:"attachments"});res_name;message=Record.one("Message",{inverse:"attachment_ids"});create_date=Record.attr(undefined,{type:"datetime"});get isDeletable(){if(this.message&&!this.store.self.isInternalUser){return this.message.editable;}
return true;}
get monthYear(){if(!this.create_date){return undefined;}
return`${this.create_date.monthLong}, ${this.create_date.year}`;}
get uploading(){return this.id<0;}
delete(){if(this.tmpUrl){URL.revokeObjectURL(this.tmpUrl);}
super.delete();}
async remove(){if(this.id>0){const rpcParams=assignDefined({attachment_id:this.id},{access_token:this.access_token});const thread=this.thread||this.message?.thread;if(thread){Object.assign(rpcParams,thread.rpcParams);}
await rpc("/mail/attachment/delete",rpcParams);}
this.delete();}}
Attachment.register();return __exports;});;

/* /mail/static/src/core/common/attachment_upload_service.js */
odoo.define('@mail/core/common/attachment_upload_service',['@odoo/owl','@web/core/l10n/translation','@web/core/registry','@web/core/utils/concurrency'],function(require){'use strict';let __exports={};const{EventBus}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{Deferred}=require("@web/core/utils/concurrency");const AttachmentUploadService=__exports.AttachmentUploadService=class AttachmentUploadService{constructor(env,services){this.setup(env,services);}
setup(env,services){this.env=env;this.fileUploadService=services["file_upload"];this.store=services["mail.store"];this.notificationService=services["notification"];this.nextId=-1;this.abortByAttachmentId=new Map();this.deferredByAttachmentId=new Map();this.uploadingAttachmentIds=new Set();this._fileUploadBus=new EventBus();this.targetsByTmpId=new Map();this.fileUploadService.bus.addEventListener("FILE_UPLOAD_ADDED",({detail:{upload}})=>{const tmpId=parseInt(upload.data.get("temporary_id"));if(!this.uploadingAttachmentIds.has(tmpId)){return;}
const{thread,composer}=this.targetsByTmpId.get(tmpId);const tmpUrl=upload.data.get("tmp_url");this.abortByAttachmentId.set(tmpId,upload.xhr.abort.bind(upload.xhr));const attachment=this.store.Attachment.insert(this._makeAttachmentData(upload,tmpId,composer?undefined:thread,tmpUrl));composer?.attachments.push(attachment);});this.fileUploadService.bus.addEventListener("FILE_UPLOAD_LOADED",({detail:{upload}})=>{const tmpId=parseInt(upload.data.get("temporary_id"));if(!this.uploadingAttachmentIds.has(tmpId)){return;}
const def=this.deferredByAttachmentId.get(tmpId);if(upload.xhr.status===413){this.notificationService.add(_t("File too large"),{type:"danger"});def.resolve();this._cleanupUploading(tmpId);return;}
if(upload.xhr.status!==200){this.notificationService.add(_t("Server error"),{type:"danger"});def.resolve();this._cleanupUploading(tmpId);return;}
const response=JSON.parse(upload.xhr.response);if(response.error){this.notificationService.add(response.error,{type:"danger"});def.resolve();this._cleanupUploading(tmpId);return;}
const{thread,composer}=this.targetsByTmpId.get(tmpId);const attachmentData=response?.result??response;this._processLoaded(thread,composer,attachmentData,tmpId,def);});this.fileUploadService.bus.addEventListener("FILE_UPLOAD_ERROR",({detail:{upload}})=>{const tmpId=parseInt(upload.data.get("temporary_id"));if(!this.uploadingAttachmentIds.has(tmpId)){return;}
this.deferredByAttachmentId.get(tmpId).resolve();this._cleanupUploading(tmpId);});}
_processLoaded(thread,composer,{data},tmpId,def){const{Attachment}=this.store.insert(data);const[attachment]=Attachment;if(composer){const index=composer.attachments.findIndex(({id})=>id===tmpId);if(index>=0){composer.attachments[index]=attachment;}else{composer.attachments.push(attachment);}}
def.resolve(attachment);this._fileUploadBus.trigger("UPLOAD",thread);this._cleanupUploading(tmpId);}
_cleanupUploading(tmpId){this.abortByAttachmentId.delete(tmpId);this.deferredByAttachmentId.delete(tmpId);this.uploadingAttachmentIds.delete(tmpId);this.targetsByTmpId.delete(tmpId);this.store.Attachment.get(tmpId)?.remove();}
getUploadURL(thread){return"/mail/attachment/upload";}
async unlink(attachment){if(this.uploadingAttachmentIds.has(attachment.id)){const deferred=this.deferredByAttachmentId.get(attachment.id);const abort=this.abortByAttachmentId.get(attachment.id);this._cleanupUploading(attachment.id);deferred.resolve();abort();return;}
await attachment.remove();}
async upload(thread,composer,file,options){const tmpId=this.nextId--;const tmpURL=URL.createObjectURL(file);return this._upload(thread,composer,file,options,tmpId,tmpURL);}
async _upload(thread,composer,file,options,tmpId,tmpURL){this.targetsByTmpId.set(tmpId,{composer,thread});this.uploadingAttachmentIds.add(tmpId);await this.fileUploadService.upload(this.getUploadURL(thread),[file],{buildFormData:(formData)=>{this._buildFormData(formData,tmpURL,thread,composer,tmpId,options);},}).catch((e)=>{if(e.name!=="AbortError"){throw e;}});const uploadDoneDeferred=new Deferred();this.deferredByAttachmentId.set(tmpId,uploadDoneDeferred);return uploadDoneDeferred;}
onFileUploaded(thread,onFileUploaded){this._fileUploadBus.addEventListener("UPLOAD",({detail})=>{if(thread.eq(detail)){onFileUploaded();}});}
_buildFormData(formData,tmpURL,thread,composer,tmpId,options){formData.append("thread_id",thread.id);formData.append("tmp_url",tmpURL);formData.append("thread_model",thread.model);formData.append("is_pending",Boolean(composer));formData.append("temporary_id",tmpId);if(options?.activity){formData.append("activity_id",options.activity.id);}
return formData;}
_makeAttachmentData(upload,tmpId,thread,tmpUrl){const attachmentData={filename:upload.title,id:tmpId,mimetype:upload.type,name:upload.title,thread,extension:upload.title.split(".").pop(),uploading:true,tmpUrl,};return attachmentData;}}
const attachmentUploadService=__exports.attachmentUploadService={dependencies:["file_upload","mail.store","notification"],start(env,services){return new AttachmentUploadService(env,services);},};registry.category("services").add("mail.attachment_upload",attachmentUploadService);return __exports;});;

/* /mail/static/src/core/common/attachment_uploader_hook.js */
odoo.define('@mail/core/common/attachment_uploader_hook',['@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");__exports.dataUrlToBlob=dataUrlToBlob;function dataUrlToBlob(data,type){const binData=window.atob(data);const uiArr=new Uint8Array(binData.length);uiArr.forEach((_,index)=>(uiArr[index]=binData.charCodeAt(index)));return new Blob([uiArr],{type});}
const AttachmentUploader=__exports.AttachmentUploader=class AttachmentUploader{constructor(thread,{composer}={}){this.attachmentUploadService=useService("mail.attachment_upload");Object.assign(this,{thread,composer});}
uploadData({data,name,type},options){const file=new File([dataUrlToBlob(data,type)],name,{type});return this.uploadFile(file,options);}
async uploadFile(file,options){return this.attachmentUploadService.upload(this.thread,this.composer,file,options);}
async unlink(attachment){await this.attachmentUploadService.unlink(attachment);}}
__exports.useAttachmentUploader=useAttachmentUploader;function useAttachmentUploader(thread,{composer,onFileUploaded}={}){return useState(new AttachmentUploader(...arguments));}
return __exports;});;

/* /mail/static/src/core/common/attachment_view.js */
odoo.define('@mail/core/common/attachment_view',['@odoo/owl','@web/core/utils/hooks','@web/core/utils/objects','@web/libs/pdfjs'],function(require){'use strict';let __exports={};const{Component,onMounted,onWillUnmount,onWillUpdateProps,useComponent,useEffect,useRef,useState,}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{deepEqual}=require("@web/core/utils/objects");const{hidePDFJSButtons}=require("@web/libs/pdfjs");class AbstractAttachmentView extends Component{static template="mail.AttachmentView";static components={};static props=["threadId","threadModel"];setup(){super.setup();this.store=useState(useService("mail.store"));this.uiService=useService("ui");this.iframeViewerPdfRef=useRef("iframeViewerPdf");this.state=useState({thread:undefined,});useEffect(()=>{if(this.iframeViewerPdfRef.el){hidePDFJSButtons(this.iframeViewerPdfRef.el);}});this.updateFromProps(this.props);onWillUpdateProps((props)=>this.updateFromProps(props));}
onClickNext(){const index=this.state.thread.attachmentsInWebClientView.findIndex((attachment)=>attachment.eq(this.state.thread.mainAttachment));this.state.thread.setMainAttachmentFromIndex(index>=this.state.thread.attachmentsInWebClientView.length-1?0:index+1);}
onClickPrevious(){const index=this.state.thread.attachmentsInWebClientView.findIndex((attachment)=>attachment.eq(this.state.thread.mainAttachment));this.state.thread.setMainAttachmentFromIndex(index<=0?this.state.thread.attachmentsInWebClientView.length-1:index-1);}
updateFromProps(props){this.state.thread=this.store.Thread.insert({id:props.threadId,model:props.threadModel,});}
get displayName(){return this.state.thread.mainAttachment.filename;}
onClickPopout(){}}
const PopoutAttachmentView=__exports.PopoutAttachmentView=class PopoutAttachmentView extends AbstractAttachmentView{static template="mail.PopoutAttachmentView";}
__exports.usePopoutAttachment=usePopoutAttachment;function usePopoutAttachment(){const component=useComponent();const uiService=useService("ui");const mailPopoutService=useService("mail.popout");function attachmentViewParentElementClassList(){const attachmentViewEl=document.querySelector(".o-mail-Attachment");let parentElementClassList;if((parentElementClassList=attachmentViewEl?.parentElement?.classList)){return parentElementClassList;}
return null;}
function showAttachmentView(){const parentElementClassList=attachmentViewParentElementClassList();const hiddenClass="d-none";if(parentElementClassList?.contains(hiddenClass)){parentElementClassList.remove(hiddenClass);}}
function hideAttachmentView(){const parentElementClassList=attachmentViewParentElementClassList();const hiddenClass="d-none";if(!parentElementClassList?.contains(hiddenClass)){parentElementClassList?.add(hiddenClass);}}
function extractPopoutProps(props){return{threadId:props.threadId,threadModel:props.threadModel,};}
function popout(){mailPopoutService.addHooks(()=>{hideAttachmentView();uiService.bus.trigger("resize");},()=>{showAttachmentView();uiService.bus.trigger("resize");});mailPopoutService.popout(PopoutAttachmentView,extractPopoutProps(component.props));}
function updatePopout(newProps=component.props){if(mailPopoutService.externalWindow){hideAttachmentView();mailPopoutService.popout(PopoutAttachmentView,extractPopoutProps(newProps));}}
function resetPopout(){mailPopoutService.reset();}
onMounted(updatePopout);onWillUpdateProps((props)=>{const oldProps=extractPopoutProps(component.props);const newProps=extractPopoutProps(props);if(!deepEqual(oldProps,newProps)){updatePopout(newProps);}});onWillUnmount(resetPopout);return{popout,updatePopout,resetPopout,};}
const AttachmentView=__exports.AttachmentView=class AttachmentView extends AbstractAttachmentView{setup(){super.setup();this.attachmentPopout=usePopoutAttachment();}
onClickPopout(){this.attachmentPopout.popout();}}
return __exports;});;

/* /mail/static/src/core/common/autoresize_input.js */
odoo.define('@mail/core/common/autoresize_input',['@odoo/owl','@web/core/utils/autoresize'],function(require){'use strict';let __exports={};const{Component,useRef,useState,onWillUpdateProps,onMounted}=require("@odoo/owl");const{useAutoresize}=require("@web/core/utils/autoresize");const AutoresizeInput=__exports.AutoresizeInput=class AutoresizeInput extends Component{static template="mail.AutoresizeInput";static props={autofocus:{type:Boolean,optional:true},className:{type:String,optional:true},enabled:{optional:true},onValidate:{type:Function,optional:true},placeholder:{type:String,optional:true},value:{type:String,optional:true},};static defaultProps={autofocus:false,className:"",enabled:true,onValidate:()=>{},placeholder:"",};setup(){super.setup();this.state=useState({value:this.props.value,isFocused:false,});this.inputRef=useRef("input");onWillUpdateProps((nextProps)=>{if(this.props.value!==nextProps.value){this.state.value=nextProps.value;}});useAutoresize(this.inputRef);onMounted(()=>{if(this.props.autofocus){this.inputRef.el.focus();this.inputRef.el.setSelectionRange(-1,-1);}});}
onKeydownInput(ev){switch(ev.key){case"Enter":this.inputRef.el.blur();break;case"Escape":ev.stopPropagation();this.state.value=this.props.value;this.inputRef.el.blur();break;}}
onBlurInput(){this.state.isFocused=false;this.props.onValidate(this.state.value);}}
return __exports;});;

/* /mail/static/src/core/common/canned_response_model.js */
odoo.define('@mail/core/common/canned_response_model',['@mail/core/common/record'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const CannedResponse=__exports.CannedResponse=class CannedResponse extends Record{static _name="mail.canned.response";static id="id";static records={};static get(data){return super.get(data);}
static insert(data){return super.insert(...arguments);}
id;source;substitution;}
CannedResponse.register();return __exports;});;

/* /mail/static/src/core/common/channel_member_model.js */
odoo.define('@mail/core/common/channel_member_model',['@mail/core/common/store_service','@mail/core/common/record','@web/core/browser/browser','@web/core/l10n/dates','@web/core/user'],function(require){'use strict';let __exports={};const{Store}=require("@mail/core/common/store_service");const{Record}=require("@mail/core/common/record");const{browser}=require("@web/core/browser/browser");const{deserializeDateTime}=require("@web/core/l10n/dates");const{user}=require("@web/core/user");const{DateTime}=luxon;const ChannelMember=__exports.ChannelMember=class ChannelMember extends Record{static id="id";static records={};static get(data){return super.get(data);}
static insert(data){return super.insert(...arguments);}
create_date;id;last_interest_dt=Record.attr(undefined,{type:"datetime"});last_seen_dt=Record.attr(undefined,{type:"datetime"});persona=Record.one("Persona",{inverse:"channelMembers"});thread=Record.one("Thread",{inverse:"channelMembers"});threadAsSelf=Record.one("Thread",{compute(){if(this.store.self?.eq(this.persona)){return this.thread;}},});fetched_message_id=Record.one("Message");seen_message_id=Record.one("Message");syncUnread=true;_syncUnread=Record.attr(false,{compute(){if(!this.syncUnread||!this.eq(this.thread?.selfMember)){return false;}
return(this.localNewMessageSeparator!==this.new_message_separator||this.localMessageUnreadCounter!==this.message_unread_counter);},onUpdate(){if(this._syncUnread){this.localNewMessageSeparator=this.new_message_separator;this.localMessageUnreadCounter=this.message_unread_counter;}},});unreadSynced=Record.attr(true,{compute(){return this.localNewMessageSeparator===this.new_message_separator;},onUpdate(){if(this.unreadSynced){this.hideUnreadBanner=false;}},});hideUnreadBanner=false;localMessageUnreadCounter=0;localNewMessageSeparator=null;message_unread_counter=0;message_unread_counter_bus_id=0;new_message_separator=null;threadAsTyping=Record.one("Thread",{compute(){return this.isTyping?this.thread:undefined;},eager:true,onAdd(){browser.clearTimeout(this.typingTimeoutId);this.typingTimeoutId=browser.setTimeout(()=>(this.isTyping=false),Store.OTHER_LONG_TYPING);},onDelete(){browser.clearTimeout(this.typingTimeoutId);},});typingTimeoutId;get name(){return this.persona.name;}
getLangName(){return this.persona.lang_name;}
get memberSince(){return this.create_date?deserializeDateTime(this.create_date):undefined;}
hasSeen(message){return this.persona.eq(message.author)||this.seen_message_id?.id>=message.id;}
get lastSeenDt(){return this.last_seen_dt?this.last_seen_dt.toLocaleString(DateTime.TIME_24_SIMPLE,{locale:user.lang,}):undefined;}
get totalUnreadMessageCounter(){let counter=this.message_unread_counter;if(!this.unreadSynced){counter+=this.localMessageUnreadCounter;}
return counter;}}
ChannelMember.register();return __exports;});;

/* /mail/static/src/core/common/chat_bubble.js */
odoo.define('@mail/core/common/chat_bubble',['@mail/core/common/im_status','@odoo/owl','@web/core/utils/hooks','@mail/utils/common/hooks','@web/core/dropdown/dropdown_hooks','@web/core/dropdown/dropdown','@mail/core/common/country_flag'],function(require){'use strict';let __exports={};const{ImStatus}=require("@mail/core/common/im_status");const{Component,useEffect,useRef,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{useHover,useMovable}=require("@mail/utils/common/hooks");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const{Dropdown}=require("@web/core/dropdown/dropdown");const{CountryFlag}=require("@mail/core/common/country_flag");const ChatBubble=__exports.ChatBubble=class ChatBubble extends Component{static components={CountryFlag,ImStatus,Dropdown};static props=["chatWindow"];static template="mail.ChatBubble";setup(){super.setup();this.store=useState(useService("mail.store"));this.wasHover=false;this.hover=useHover(["root","preview*"],{onHover:()=>(this.preview.isOpen=true),onHovering:[100,()=>(this.state.showClose=true)],onAway:()=>{this.state.showClose=false;this.preview.isOpen=false;},});this.preview=useDropdownState();this.rootRef=useRef("root");this.state=useState({bouncing:false,showClose:true});useEffect(()=>{this.state.bouncing=this.thread.importantCounter?true:this.state.bouncing;},()=>[this.thread.importantCounter]);if(this.env.embedLivechat){this.position=useState({left:"auto",top:"auto"});useMovable({cursor:"grabbing",ref:this.rootRef,elements:".o-mail-ChatBubble",onDrop:({top,left})=>Object.assign(this.position,{left:`${left}px`,top:`${top}px`}),});}}
get thread(){return this.props.chatWindow.thread;}
get previewContent(){const lastMessage=this.thread?.newestPersistentNotEmptyOfAllMessage;if(!lastMessage){return false;}
return lastMessage.inlineBody;}}
return __exports;});;

/* /mail/static/src/core/common/chat_hub.js */
odoo.define('@mail/core/common/chat_hub',['@mail/core/common/chat_window','@mail/utils/common/hooks','@odoo/owl','@web/core/browser/browser','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_hooks','@web/core/registry','@web/core/utils/hooks','@mail/core/common/chat_bubble','@web/core/browser/feature_detection'],function(require){'use strict';let __exports={};const{ChatWindow}=require("@mail/core/common/chat_window");const{useHover,useMovable}=require("@mail/utils/common/hooks");const{Component,useEffect,useExternalListener,useRef,useState}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{Dropdown}=require("@web/core/dropdown/dropdown");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{ChatBubble}=require("@mail/core/common/chat_bubble");const{isMobileOS}=require("@web/core/browser/feature_detection");const ChatHub=__exports.ChatHub=class ChatHub extends Component{static components={ChatBubble,ChatWindow,Dropdown};static props=[];static template="mail.ChatHub";get chatHub(){return this.store.chatHub;}
setup(){super.setup();this.store=useState(useService("mail.store"));this.ui=useState(useService("ui"));this.busMonitoring=useState(useService("bus.monitoring_service"));this.bubblesHover=useHover("bubbles");this.moreHover=useHover(["more-button","more-menu*"],{onHover:()=>(this.more.isOpen=true),onAway:()=>(this.more.isOpen=false),});this.options=useDropdownState();this.more=useDropdownState();this.compactRef=useRef("compact");this.compactPosition=useState({left:"auto",top:"auto"});this.onResize();useExternalListener(browser,"resize",this.onResize);useEffect(()=>{if(this.chatHub.folded.length&&this.store.channels?.status==="not_fetched"){this.store.channels.fetch();}});useMovable({cursor:"grabbing",ref:this.compactRef,elements:".o-mail-ChatHub-compact",onDrop:({top,left})=>Object.assign(this.compactPosition,{left:`${left}px`,top:`${top}px`}),});}
get isMobileOS(){return isMobileOS();}
onResize(){this.chatHub.onRecompute();}
get compactCounter(){let counter=0;const cws=this.chatHub.opened.concat(this.chatHub.folded);for(const chatWindow of cws){counter+=chatWindow.thread.importantCounter>0?1:0;}
return counter;}
get hiddenCounter(){let counter=0;for(const chatWindow of this.chatHub.folded.slice(this.chatHub.maxFolded)){counter+=chatWindow.thread.importantCounter>0?1:0;}
return counter;}
get isShown(){return true;}
expand(){this.chatHub.compact=false;Object.assign(this.compactPosition,{left:"auto",top:"auto"});this.more.isOpen=this.chatHub.folded.length>this.chatHub.maxFolded;}}
const chatHubService=__exports.chatHubService={dependencies:["bus.monitoring_service","mail.store","ui"],start(){registry.category("main_components").add("mail.ChatHub",{Component:ChatHub});},};registry.category("services").add("mail.chat_hub",chatHubService);return __exports;});;

/* /mail/static/src/core/common/chat_hub_model.js */
odoo.define('@mail/core/common/chat_hub_model',['@web/core/browser/browser','@mail/core/common/record'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{Record}=require("@mail/core/common/record");const ChatHub=__exports.ChatHub=class ChatHub extends Record{BUBBLE=56;BUBBLE_START=15;BUBBLE_LIMIT=7;BUBBLE_OUTER=10;WINDOW_GAP=10;WINDOW_INBETWEEN=5;WINDOW=380;static get(data){return super.get(data);}
static insert(data){return super.insert(...arguments);}
compact=false;opened=Record.many("ChatWindow",{inverse:"hubAsOpened",onAdd(r){this.onRecompute();},onDelete(){this.onRecompute();},});folded=Record.many("ChatWindow",{inverse:"hubAsFolded",onAdd(r){this.onRecompute();},onDelete(){this.onRecompute();},});closeAll(){[...this.opened,...this.folded].forEach((cw)=>cw.close());}
onRecompute(){while(this.opened.length>this.maxOpened){const cw=this.opened.pop();this.folded.unshift(cw);}}
get maxOpened(){const chatBubblesWidth=this.BUBBLE_START+this.BUBBLE+this.BUBBLE_OUTER*2;const startGap=this.store.env.services.ui.isSmall?0:this.WINDOW_GAP;const endGap=this.store.env.services.ui.isSmall?0:this.WINDOW_GAP;const available=browser.innerWidth-startGap-endGap-chatBubblesWidth;const maxAmountWithoutHidden=Math.max(1,Math.floor(available/(this.WINDOW+this.WINDOW_INBETWEEN)));return maxAmountWithoutHidden;}
get maxFolded(){const chatBubbleSpace=this.BUBBLE_START+this.BUBBLE+this.BUBBLE_OUTER*2;return Math.min(this.BUBBLE_LIMIT,Math.floor(browser.innerHeight/chatBubbleSpace));}}
ChatHub.register();return __exports;});;

/* /mail/static/src/core/common/chat_window.js */
odoo.define('@mail/core/common/chat_window',['@mail/core/common/composer','@mail/core/common/im_status','@mail/core/common/thread','@mail/core/common/autoresize_input','@mail/core/common/country_flag','@mail/core/common/thread_actions','@mail/core/common/thread_icon','@mail/utils/common/hooks','@web/core/utils/misc','@odoo/owl','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/l10n/localization','@web/core/l10n/translation','@web/core/utils/hooks','@mail/discuss/typing/common/typing','@web/core/hotkeys/hotkey_service'],function(require){'use strict';let __exports={};const{Composer}=require("@mail/core/common/composer");const{ImStatus}=require("@mail/core/common/im_status");const{Thread}=require("@mail/core/common/thread");const{AutoresizeInput}=require("@mail/core/common/autoresize_input");const{CountryFlag}=require("@mail/core/common/country_flag");const{useThreadActions}=require("@mail/core/common/thread_actions");const{ThreadIcon}=require("@mail/core/common/thread_icon");const{useHover,useMessageEdition,useMessageHighlight,useMessageToReplyTo,}=require("@mail/utils/common/hooks");const{isEventHandled}=require("@web/core/utils/misc");const{Component,toRaw,useChildSubEnv,useRef,useState}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{localization}=require("@web/core/l10n/localization");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{Typing}=require("@mail/discuss/typing/common/typing");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const ChatWindow=__exports.ChatWindow=class ChatWindow extends Component{static components={CountryFlag,Dropdown,DropdownItem,Thread,Composer,ThreadIcon,ImStatus,AutoresizeInput,Typing,};static props=["chatWindow","right?"];static template="mail.ChatWindow";setup(){super.setup();this.store=useState(useService("mail.store"));this.messageEdition=useMessageEdition();this.messageHighlight=useMessageHighlight();this.messageToReplyTo=useMessageToReplyTo();this.state=useState({actionsDisabled:false,actionsMenuOpened:false,jumpThreadPresent:0,editingGuestName:false,editingName:false,});this.ui=useState(useService("ui"));this.contentRef=useRef("content");this.threadActions=useThreadActions();this.actionsMenuButtonHover=useHover("actionsMenuButton");this.parentChannelHover=useHover("parentChannel");useChildSubEnv({closeActionPanel:()=>this.threadActions.activeAction?.close(),inChatWindow:true,messageHighlight:this.messageHighlight,});}
get composerType(){if(this.thread&&this.thread.model!=="discuss.channel"){return"note";}
return undefined;}
get hasActionsMenu(){return(this.partitionedActions.group.length>0||this.partitionedActions.other.length>0||(this.ui.isSmall&&this.partitionedActions.quick.length>2)||(!this.ui.isSmall&&this.partitionedActions.quick.length>3));}
get thread(){return this.props.chatWindow.thread;}
get style(){const maxHeight=!this.ui.isSmall?"max-height: 95vh;":"";const textDirection=localization.direction;const offsetFrom=textDirection==="rtl"?"left":"right";const visibleOffset=this.ui.isSmall?0:this.props.right;const oppositeFrom=offsetFrom==="right"?"left":"right";return`${offsetFrom}: ${visibleOffset}px; ${oppositeFrom}: auto; ${maxHeight}`;}
onKeydown(ev){const chatWindow=toRaw(this.props.chatWindow);if(ev.key==="Escape"&&this.threadActions.activeAction){this.threadActions.activeAction.close();ev.stopPropagation();return;}
if(ev.target.closest(".o-dropdown")||ev.target.closest(".o-dropdown--menu")){return;}
ev.stopPropagation();switch(getActiveHotkey(ev)){case"escape":if(isEventHandled(ev,"NavigableList.close")||isEventHandled(ev,"Composer.discard")){return;}
if(this.state.editingName){this.state.editingName=false;return;}
this.close({escape:true});break;case"tab":{const index=this.store.chatHub.opened.findIndex((cw)=>cw.eq(chatWindow));if(index===this.store.chatHub.opened.length-1){this.store.chatHub.opened[0].focus();}else{this.store.chatHub.opened[index+1].focus();}
break;}
case"control+k":this.store.env.services.command.openMainPalette();ev.preventDefault();break;}}
onClickHeader(){if(this.ui.isSmall||this.state.editingName||!this.thread||this.state.actionsDisabled){return;}
this.toggleFold();}
toggleFold(){const chatWindow=toRaw(this.props.chatWindow);if(this.state.actionsMenuOpened){return;}
chatWindow.fold();}
async close(options){const chatWindow=toRaw(this.props.chatWindow);await chatWindow.close(options);}
get actionsMenuTitleText(){return _t("Open Actions Menu");}
async renameThread(name){const thread=toRaw(this.thread);await thread.rename(name);this.state.editingName=false;}
async renameGuest(name){const newName=name.trim();if(this.store.self.name!==newName){await this.store.self.updateGuestName(newName);}
this.state.editingGuestName=false;}
async onActionsMenuStateChanged(isOpen){this.state.actionsMenuOpened=isOpen;}}
return __exports;});;

/* /mail/static/src/core/common/chat_window_model.js */
odoo.define('@mail/core/common/chat_window_model',['@mail/core/common/record','@web/core/network/rpc','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{rpc}=require("@web/core/network/rpc");const{_t}=require("@web/core/l10n/translation");const ChatWindow=__exports.ChatWindow=class ChatWindow extends Record{static id="thread";static records={};static get(data){return super.get(data);}
static insert(){return super.insert(...arguments);}
thread=Record.one("Thread");autofocus=0;hidden=false;fromMessagingMenu=false;hubAsOpened=Record.one("ChatHub",{onAdd(){this.hubAsFolded=undefined;},onDelete(){if(!this.thread&&!this.hubAsOpened){this.delete();}},});hubAsFolded=Record.one("ChatHub",{onAdd(){this.hubAsOpened=undefined;},});get displayName(){return this.thread?.displayName??_t("New message");}
get isOpen(){return Boolean(this.hubAsOpened);}
async close(options={}){const{escape=false}=options;const chatHub=this.store.chatHub;const indexAsOpened=chatHub.opened.findIndex((w)=>w.eq(this));const thread=this.thread;if(thread){thread.state="closed";}
await this._onClose(options);this.delete();if(escape&&indexAsOpened!==-1&&chatHub.opened.length>0){chatHub.opened[indexAsOpened===0?0:indexAsOpened-1].focus();}}
focus(){this.autofocus++;}
fold(){if(!this.thread){return this.close();}
this.store.chatHub.folded.delete(this);this.store.chatHub.folded.unshift(this);this.thread.state="folded";this.notifyState();}
open({notifyState=true}={}){this.store.chatHub.opened.delete(this);this.store.chatHub.opened.unshift(this);if(this.thread){this.thread.state="open";if(notifyState){this.notifyState();}}
this.focus();}
notifyState(){if(this.store.env.services.ui.isSmall||this.thread?.isTransient||!this.thread?.hasSelfAsMember){return;}
if(this.thread?.model==="discuss.channel"){this.thread.foldStateCount++;return rpc("/discuss/channel/fold",{channel_id:this.thread.id,state:this.thread.state,state_count:this.thread.foldStateCount,},{shadow:true});}}
async _onClose({notifyState=true}={}){if(notifyState){this.notifyState();}}}
ChatWindow.register();return __exports;});;

/* /mail/static/src/core/common/composer.js */
odoo.define('@mail/core/common/composer',['@mail/core/common/attachment_list','@mail/core/common/attachment_uploader_hook','@web/core/dropzone/dropzone_hook','@mail/core/common/picker','@mail/core/common/mail_attachment_dropzone','@mail/core/common/message_confirm_dialog','@mail/core/common/navigable_list','@mail/core/common/suggestion_hook','@mail/utils/common/format','@mail/utils/common/hooks','@mail/utils/common/misc','@web/core/network/rpc','@web/core/utils/misc','@web/core/browser/browser','@web/core/utils/timing','@odoo/owl','@web/core/l10n/translation','@web/core/utils/hooks','@web/views/fields/file_handler','@web/core/utils/strings','@web/core/browser/feature_detection'],function(require){'use strict';let __exports={};const{AttachmentList}=require("@mail/core/common/attachment_list");const{useAttachmentUploader}=require("@mail/core/common/attachment_uploader_hook");const{useCustomDropzone}=require("@web/core/dropzone/dropzone_hook");const{Picker,usePicker}=require("@mail/core/common/picker");const{MailAttachmentDropzone}=require("@mail/core/common/mail_attachment_dropzone");const{MessageConfirmDialog}=require("@mail/core/common/message_confirm_dialog");const{NavigableList}=require("@mail/core/common/navigable_list");const{useSuggestion}=require("@mail/core/common/suggestion_hook");const{prettifyMessageContent}=require("@mail/utils/common/format");const{useSelection}=require("@mail/utils/common/hooks");const{isDragSourceExternalFile}=require("@mail/utils/common/misc");const{rpc}=require("@web/core/network/rpc");const{isEventHandled,markEventHandled}=require("@web/core/utils/misc");const{browser}=require("@web/core/browser/browser");const{useDebounced}=require("@web/core/utils/timing");const{Component,markup,onMounted,onWillUnmount,useChildSubEnv,useEffect,useRef,useState,useExternalListener,toRaw,EventBus,}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{FileUploader}=require("@web/views/fields/file_handler");const{escape,sprintf}=require("@web/core/utils/strings");const{isDisplayStandalone,isIOS,isMobileOS}=require("@web/core/browser/feature_detection");const EDIT_CLICK_TYPE={CANCEL:"cancel",SAVE:"save",};const Composer=__exports.Composer=class Composer extends Component{static components={AttachmentList,Picker,FileUploader,NavigableList,};static defaultProps={mode:"normal",className:"",sidebar:true,showFullComposer:true,allowUpload:true,};static props=["composer","autofocus?","messageToReplyTo?","onCloseFullComposerCallback?","onDiscardCallback?","onPostCallback?","mode?","placeholder?","dropzoneRef?","messageEdition?","className?","sidebar?","type?","showFullComposer?","allowUpload?",];static template="mail.Composer";setup(){super.setup();this.isMobileOS=isMobileOS();this.isIosPwa=isIOS()&&isDisplayStandalone();this.OR_PRESS_SEND_KEYBIND=markup(_t("or press %(send_keybind)s",{send_keybind:this.sendKeybinds.map((key)=>`<samp>${escape(key)}</samp>`).join(" + "),}));this.store=useState(useService("mail.store"));this.attachmentUploader=useAttachmentUploader(this.thread??this.props.composer.message.thread,{composer:this.props.composer});this.ui=useState(useService("ui"));this.mainActionsRef=useRef("main-actions");this.ref=useRef("textarea");this.fakeTextarea=useRef("fakeTextarea");this.emojiButton=useRef("emoji-button");this.inputContainerRef=useRef("input-container");this.state=useState({active:true,isFullComposerOpen:false,});this.fullComposerBus=new EventBus();this.selection=useSelection({refName:"textarea",model:this.props.composer.selection,preserveOnClickAwayPredicate:async(ev)=>{await new Promise(setTimeout);return(!this.isEventTrusted(ev)||isEventHandled(ev,"sidebar.openThread")||isEventHandled(ev,"emoji.selectEmoji")||isEventHandled(ev,"Composer.onClickAddEmoji")||isEventHandled(ev,"composer.clickOnAddAttachment")||isEventHandled(ev,"composer.selectSuggestion"));},});this.suggestion=useSuggestion();this.markEventHandled=markEventHandled;this.onDropFile=this.onDropFile.bind(this);this.saveContentDebounced=useDebounced(this.saveContent,5000,{execBeforeUnmount:true,});useExternalListener(window,"beforeunload",this.saveContent.bind(this));if(this.props.dropzoneRef){useCustomDropzone(this.props.dropzoneRef,MailAttachmentDropzone,{extraClass:"o-mail-Composer-dropzone",onDrop:this.onDropFile,},()=>this.allowUpload);}
if(this.props.messageEdition){this.props.messageEdition.composerOfThread=this;}
useChildSubEnv({inComposer:true,});this.picker=usePicker(this.pickerSettings);useEffect((focus)=>{if(focus&&this.ref.el){this.selection.restore();this.ref.el.focus();}},()=>[this.props.autofocus+this.props.composer.autofocus,this.props.placeholder]);useEffect((rThread,cThread)=>{if(cThread&&cThread.eq(rThread)){this.props.composer.autofocus++;}},()=>[this.props.messageToReplyTo?.thread,this.props.composer.thread]);useEffect(()=>{if(this.fakeTextarea.el.scrollHeight){this.ref.el.style.height=this.fakeTextarea.el.scrollHeight+"px";}
this.saveContentDebounced();},()=>[this.props.composer.text,this.ref.el]);useEffect(()=>{if(!this.props.composer.forceCursorMove){return;}
this.selection.restore();this.props.composer.forceCursorMove=false;},()=>[this.props.composer.forceCursorMove]);onMounted(()=>{this.ref.el.scrollTo({top:0,behavior:"instant"});if(!this.props.composer.text){this.restoreContent();}});onWillUnmount(()=>{this.props.composer.isFocused=false;});useEffect((composerThread,replyToThread)=>{if(replyToThread&&replyToThread!==composerThread){this.props.messageToReplyTo.cancel();}},()=>[this.props.composer.thread,this.props.messageToReplyTo?.thread]);}
get pickerSettings(){return{anchor:this.props.mode==="extended"?undefined:this.mainActionsRef,buttons:[this.emojiButton],close:()=>{if(!this.ui.isSmall){this.props.composer.autofocus++;}},pickers:{emoji:(emoji)=>this.addEmoji(emoji)},position:this.props.mode==="extended"?"bottom-start":this.props.composer.message?"bottom-start":"top-end",fixed:!this.props.composer.message,};}
get placeholder(){if(this.props.placeholder){return this.props.placeholder;}
if(this.thread){if(this.thread.channel_type==="channel"){const threadName=this.thread.displayName;if(this.thread.parent_channel_id){return _t(`Message "%(subChannelName)s"`,{subChannelName:threadName,});}
return _t("Message #%(threadName)s…",{threadName});}
return _t("Message %(thread name)s…",{"thread name":this.thread.displayName});}
return"";}
onClickCancelOrSaveEditText(ev){const composer=toRaw(this.props.composer);if(composer.message&&ev.target.dataset?.type===EDIT_CLICK_TYPE.CANCEL){this.props.onDiscardCallback(ev);}
if(composer.message&&ev.target.dataset?.type===EDIT_CLICK_TYPE.SAVE){this.editMessage(ev);}}
get CANCEL_OR_SAVE_EDIT_TEXT(){if(this.ui.isSmall){return markup(sprintf(escape(_t("%(open_button)s%(icon)s%(open_em)sDiscard editing%(close_em)s%(close_button)s")),{open_button:`<button class='btn px-1 py-0' data-type="${escape(
                            EDIT_CLICK_TYPE.CANCEL
                        )}">`,close_button:"</button>",icon:`<i class='fa fa-times-circle pe-1' data-type="${escape(
                            EDIT_CLICK_TYPE.CANCEL
                        )}"></i>`,open_em:`<em data-type="${escape(EDIT_CLICK_TYPE.CANCEL)}">`,close_em:"</em>",}));}else{const translation1=_t("%(open_samp)sEscape%(close_samp)s %(open_em)sto %(open_cancel)scancel%(close_cancel)s%(close_em)s, %(open_samp)sCTRL-Enter%(close_samp)s %(open_em)sto %(open_save)ssave%(close_save)s%(close_em)s");const translation2=_t("%(open_samp)sEscape%(close_samp)s %(open_em)sto %(open_cancel)scancel%(close_cancel)s%(close_em)s, %(open_samp)sEnter%(close_samp)s %(open_em)sto %(open_save)ssave%(close_save)s%(close_em)s");return markup(sprintf(escape(this.props.mode==="extended"?translation1:translation2),{open_samp:"<samp>",close_samp:"</samp>",open_em:"<em>",close_em:"</em>",open_cancel:`<a role="button" href="#" data-type="${escape(
                        EDIT_CLICK_TYPE.CANCEL
                    )}">`,close_cancel:"</a>",open_save:`<a role="button" href="#" data-type="${escape(
                        EDIT_CLICK_TYPE.SAVE
                    )}">`,close_save:"</a>",}));}}
get SEND_TEXT(){if(this.props.composer.message){return _t("Save editing");}
return this.props.type==="note"?_t("Log"):_t("Send");}
get sendKeybinds(){return this.props.mode==="extended"?[_t("CTRL"),_t("Enter")]:[_t("Enter")];}
get showComposerAvatar(){return!this.compact&&this.props.sidebar;}
get thread(){return this.props.messageToReplyTo?.message?.thread??this.props.composer.thread??null;}
get allowUpload(){return this.props.allowUpload;}
get message(){return this.props.composer.message??null;}
get extraData(){return this.thread.rpcParams;}
get isSendButtonDisabled(){const attachments=this.props.composer.attachments;return(!this.state.active||(!this.props.composer.text&&attachments.length===0)||attachments.some(({uploading})=>Boolean(uploading)));}
get hasSendButtonNonEditing(){return!this.extended&&!this.props.composer.message;}
get hasSuggestions(){return Boolean(this.suggestion?.state.items);}
get navigableListProps(){const props={anchorRef:this.inputContainerRef.el,position:this.env.inChatter?"bottom-fit":"top-fit",onSelect:(ev,option)=>{this.suggestion.insert(option);markEventHandled(ev,"composer.selectSuggestion");},isLoading:!!this.suggestion.search.term&&this.suggestion.state.isFetching,options:[],};if(!this.hasSuggestions){return props;}
const suggestions=this.suggestion.state.items.suggestions;switch(this.suggestion.state.items.type){case"Partner":return{...props,optionTemplate:"mail.Composer.suggestionPartner",options:suggestions.map((suggestion)=>{if(suggestion.isSpecial){return{...suggestion,group:1,optionTemplate:"mail.Composer.suggestionSpecial",classList:"o-mail-Composer-suggestion",};}else{return{label:suggestion.name,partner:suggestion,classList:"o-mail-Composer-suggestion",};}}),};case"Thread":return{...props,optionTemplate:"mail.Composer.suggestionThread",options:suggestions.map((suggestion)=>{return{label:suggestion.parent_channel_id?`${suggestion.parent_channel_id.displayName} > ${suggestion.displayName}`:suggestion.displayName,thread:suggestion,classList:"o-mail-Composer-suggestion",};}),};case"ChannelCommand":return{...props,optionTemplate:"mail.Composer.suggestionChannelCommand",options:suggestions.map((suggestion)=>{return{label:suggestion.name,help:suggestion.help,classList:"o-mail-Composer-suggestion",};}),};case"mail.canned.response":return{...props,autoSelectFirst:false,hint:_t("Tab to select"),optionTemplate:"mail.Composer.suggestionCannedResponse",options:suggestions.map((suggestion)=>{return{cannedResponse:suggestion,source:suggestion.source,label:suggestion.substitution,classList:"o-mail-Composer-suggestion",};}),};default:return props;}}
onDropFile(ev){if(isDragSourceExternalFile(ev.dataTransfer)){for(const file of ev.dataTransfer.files){this.attachmentUploader.uploadFile(file);}}}
onCloseFullComposerCallback(){if(this.props.onCloseFullComposerCallback){this.props.onCloseFullComposerCallback();}else{this.thread?.fetchNewMessages();}}
onPaste(ev){if(!this.allowUpload){return;}
if(!ev.clipboardData?.items){return;}
if(ev.clipboardData.files.length===0){return;}
ev.preventDefault();for(const file of ev.clipboardData.files){this.attachmentUploader.uploadFile(file);}}
onKeydown(ev){const composer=toRaw(this.props.composer);switch(ev.key){case"ArrowUp":if(this.props.messageEdition&&composer.text===""){const messageToEdit=composer.thread.lastEditableMessageOfSelf;if(messageToEdit){this.props.messageEdition.editingMessage=messageToEdit;}}
break;case"Enter":{if(isEventHandled(ev,"NavigableList.select")||!this.state.active){ev.preventDefault();return;}
if(this.isMobileOS){return;}
const shouldPost=this.props.mode==="extended"?ev.ctrlKey:!ev.shiftKey;if(!shouldPost){return;}
ev.preventDefault();if(composer.message){this.editMessage();}else{this.sendMessage();}
break;}
case"Escape":if(isEventHandled(ev,"NavigableList.close")){return;}
if(this.props.onDiscardCallback){this.props.onDiscardCallback();markEventHandled(ev,"Composer.discard");}
break;}}
onClickAddAttachment(ev){const composer=toRaw(this.props.composer);markEventHandled(ev,"composer.clickOnAddAttachment");composer.autofocus++;}
async onClickFullComposer(ev){if(this.props.type!=="note"){const newPartners=this.thread.suggestedRecipients.filter((recipient)=>recipient.checked&&!recipient.persona);if(newPartners.length!==0){const recipientEmails=[];const recipientAdditionalValues={};newPartners.forEach((recipient)=>{recipientEmails.push(recipient.email);recipientAdditionalValues[recipient.email]=recipient.create_values||{};});const partners=await rpc("/mail/partner/from_email",{emails:recipientEmails,additional_values:recipientAdditionalValues,});for(const index in partners){const partnerData=partners[index];const persona=this.store.Persona.insert({...partnerData,type:"partner"});const email=recipientEmails[index];const recipient=this.thread.suggestedRecipients.find((recipient)=>recipient.email===email);Object.assign(recipient,{persona});}}}
const attachmentIds=this.props.composer.attachments.map((attachment)=>attachment.id);const body=this.props.composer.text;const validMentions=this.store.getMentionsFromText(body,{mentionedChannels:this.props.composer.mentionedChannels,mentionedPartners:this.props.composer.mentionedPartners,});let default_body=await prettifyMessageContent(body,validMentions);if(!default_body){const composer=toRaw(this.props.composer);composer.emailAddSignature=true;}
default_body=this.formatDefaultBodyForFullComposer(default_body,this.props.composer.emailAddSignature?markup(this.store.self.signature):"");const context={default_attachment_ids:attachmentIds,default_body,default_email_add_signature:false,default_model:this.thread.model,default_partner_ids:this.props.type==="note"?[]:this.thread.suggestedRecipients.filter((recipient)=>recipient.checked).map((recipient)=>recipient.persona.id),default_res_ids:[this.thread.id],default_subtype_xmlid:this.props.type==="note"?"mail.mt_note":"mail.mt_comment",mail_post_autofollow:this.thread.hasWriteAccess,};const action={name:this.props.type==="note"?_t("Log note"):_t("Compose Email"),type:"ir.actions.act_window",res_model:"mail.compose.message",view_mode:"form",views:[[false,"form"]],target:"new",context:context,};const options={onClose:(...args)=>{const accidentalDiscard=args.length===0;const isDiscard=accidentalDiscard||args[0]?.special;if(!isDiscard&&this.props.composer.thread.model==="mail.box"){this.notifySendFromMailbox();}
if(accidentalDiscard){this.fullComposerBus.trigger("ACCIDENTAL_DISCARD",{onAccidentalDiscard:(isEmpty)=>{if(!isEmpty){this.saveContent();this.restoreContent();}},});}else{this.clear();}
this.props.messageToReplyTo?.cancel();this.onCloseFullComposerCallback();this.state.isFullComposerOpen=false;this.fullComposerBus=new EventBus();},props:{fullComposerBus:this.fullComposerBus,},};await this.env.services.action.doAction(action,options);this.state.isFullComposerOpen=true;}
formatDefaultBodyForFullComposer(defaultBody,signature=""){if(signature){defaultBody=`${defaultBody}<br>${signature}`;}
return`<div>${defaultBody}</div>`;}
clear(){this.props.composer.clear();browser.localStorage.removeItem(this.props.composer.localId);}
notifySendFromMailbox(){this.env.services.notification.add(_t('Message posted on "%s"',this.thread.displayName),{type:"info",});}
onClickAddEmoji(ev){markEventHandled(ev,"Composer.onClickAddEmoji");}
isEventTrusted(ev){return ev.isTrusted;}
async processMessage(cb){const el=this.ref.el;const attachments=this.props.composer.attachments;if(attachments.some(({uploading})=>uploading)){this.env.services.notification.add(_t("Please wait while the file is uploading."),{type:"warning",});}else if(this.props.composer.text.trim()||attachments.length>0||(this.message&&this.message.attachment_ids.length>0)){if(!this.state.active){return;}
this.state.active=false;await cb(this.props.composer.text);if(this.props.onPostCallback){this.props.onPostCallback();}
this.clear();this.state.active=true;el.focus();}}
async sendMessage(){const composer=toRaw(this.props.composer);if(composer.message){this.editMessage();return;}
await this.processMessage(async(value)=>{await this._sendMessage(value,this.postData,this.extraData);});}
get postData(){const composer=toRaw(this.props.composer);return{attachments:composer.attachments||[],emailAddSignature:composer.emailAddSignature,isNote:this.props.type==="note",mentionedChannels:composer.mentionedChannels||[],mentionedPartners:composer.mentionedPartners||[],cannedResponseIds:composer.cannedResponses.map((c)=>c.id),parentId:this.props.messageToReplyTo?.message?.id,};}
async _sendMessage(value,postData,extraData){const thread=toRaw(this.props.composer.thread);const postThread=toRaw(this.thread);const post=postThread.post.bind(postThread,value,postData,extraData);if(postThread.model==="discuss.channel"){post();}else{await post();}
if(thread.model==="mail.box"){this.notifySendFromMailbox();}
this.suggestion?.clearRawMentions();this.suggestion?.clearCannedResponses();this.props.messageToReplyTo?.cancel();this.props.composer.emailAddSignature=true;}
async editMessage(){const composer=toRaw(this.props.composer);if(composer.text||composer.message.attachment_ids.length>0){await this.processMessage(async(value)=>composer.message.edit(value,composer.attachments,{mentionedChannels:composer.mentionedChannels,mentionedPartners:composer.mentionedPartners,}));}else{this.env.services.dialog.add(MessageConfirmDialog,{message:composer.message,onConfirm:()=>this.message.remove(),prompt:_t("Are you sure you want to delete this message?"),});}
this.suggestion?.clearRawMentions();}
addEmoji(str){const composer=toRaw(this.props.composer);const text=composer.text;const firstPart=text.slice(0,composer.selection.start);const secondPart=text.slice(composer.selection.end,text.length);composer.text=firstPart+str+secondPart;this.selection.moveCursor((firstPart+str).length);if(!this.ui.isSmall){composer.autofocus++;}}
onFocusin(){const composer=toRaw(this.props.composer);composer.isFocused=true;composer.thread?.markAsRead();}
onFocusout(ev){if([EDIT_CLICK_TYPE.CANCEL,EDIT_CLICK_TYPE.SAVE].includes(ev.relatedTarget?.dataset?.type)){return;}
this.props.composer.isFocused=false;}
saveContent(){const composer=toRaw(this.props.composer);const saveContentToLocalStorage=(text,emailAddSignature)=>{const config={emailAddSignature,text,};browser.localStorage.setItem(composer.localId,JSON.stringify(config));};if(this.state.isFullComposerOpen){this.fullComposerBus.trigger("SAVE_CONTENT",{onSaveContent:saveContentToLocalStorage,});}else{saveContentToLocalStorage(composer.text,true);}}
restoreContent(){const composer=toRaw(this.props.composer);try{const config=JSON.parse(browser.localStorage.getItem(composer.localId));if(config.text){composer.emailAddSignature=config.emailAddSignature;composer.text=config.text;}}catch{browser.localStorage.removeItem(composer.localId);}}}
return __exports;});;

/* /mail/static/src/core/common/composer_model.js */
odoo.define('@mail/core/common/composer_model',['@mail/core/common/record'],function(require){'use strict';let __exports={};const{OR,Record}=require("@mail/core/common/record");const Composer=__exports.Composer=class Composer extends Record{static id=OR("thread","message");static get(data){return super.get(data);}
static insert(data){return super.insert(...arguments);}
clear(){this.attachments.length=0;this.text="";Object.assign(this.selection,{start:0,end:0,direction:"none",});}
attachments=Record.many("Attachment");emailAddSignature=true;message=Record.one("Message");mentionedPartners=Record.many("Persona");mentionedChannels=Record.many("Thread");cannedResponses=Record.many("mail.canned.response");text="";thread=Record.one("Thread");selection={start:0,end:0,direction:"none",};forceCursorMove;isFocused=false;autofocus=0;}
Composer.register();return __exports;});;

/* /mail/static/src/core/common/country_flag.js */
odoo.define('@mail/core/common/country_flag',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const CountryFlag=__exports.CountryFlag=class CountryFlag extends Component{static props=["country","class?"];static template="mail.CountryFlag";}
return __exports;});;

/* /mail/static/src/core/common/country_model.js */
odoo.define('@mail/core/common/country_model',['@mail/core/common/record'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const Country=__exports.Country=class Country extends Record{static id="id";static records={};static get(data){return super.get(data);}
static insert(data){return super.insert(...arguments);}
code;id;name;get flagUrl(){return`/base/static/img/country_flags/${encodeURIComponent(this.code.toLowerCase())}.png`;}}
Country.register();return __exports;});;

/* /mail/static/src/core/common/date_section.js */
odoo.define('@mail/core/common/date_section',['@odoo/owl','@web/core/browser/feature_detection'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{isMobileOS}=require("@web/core/browser/feature_detection");const DateSection=__exports.DateSection=class DateSection extends Component{static template="mail.DateSection";static props=["date","className?"];get isMobileOS(){return isMobileOS();}}
return __exports;});;

/* /mail/static/src/core/common/discuss_component_registry.js */
odoo.define('@mail/core/common/discuss_component_registry',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const discussComponentRegistry=__exports.discussComponentRegistry=registry.category("discuss.component");return __exports;});;

/* /mail/static/src/core/common/emoji_picker_mobile.js */
odoo.define('@mail/core/common/emoji_picker_mobile',['@odoo/owl','@web/core/dialog/dialog','@web/core/emoji_picker/emoji_picker'],function(require){'use strict';let __exports={};const{Component,xml}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{EMOJI_PICKER_PROPS,EmojiPicker}=require("@web/core/emoji_picker/emoji_picker");const EmojiPickerMobile=__exports.EmojiPickerMobile=class EmojiPickerMobile extends Component{static components={Dialog,EmojiPicker};static props=EMOJI_PICKER_PROPS;static template=xml`
        <Dialog size="'lg'" header="false" footer="false" contentClass="'o-discuss-mobileContextMenu d-flex position-absolute bottom-0 rounded-0 h-50 bg-100'">
            <EmojiPicker t-props="props"/>
        </Dialog>
    `;}
return __exports;});;

/* /mail/static/src/core/common/failure_model.js */
odoo.define('@mail/core/common/failure_model',['@mail/core/common/record','@odoo/owl','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{markRaw}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const Failure=__exports.Failure=class Failure extends Record{static nextId=markRaw({value:1});static id="id";static records={};static get(data){return super.get(data);}
static insert(data){return super.insert(...arguments);}
notifications=Record.many("Notification",{onUpdate(){if(this.notifications.length===0){this.delete();}else{this.store.failures.add(this);}},});get modelName(){return this.notifications?.[0]?.message?.thread?.modelName;}
get resModel(){return this.notifications?.[0]?.message?.thread?.model;}
get resIds(){return new Set([...this.notifications.map((notif)=>notif.message?.thread?.id).filter((id)=>!!id),]);}
lastMessage=Record.one("Message",{compute(){let lastMsg=this.notifications[0]?.message;for(const notification of this.notifications){if(lastMsg?.id<notification.message?.id){lastMsg=notification.message;}}
return lastMsg;},});get type(){return this.notifications?.[0]?.notification_type;}
get status(){return this.notifications?.[0]?.notification_status;}
get iconSrc(){return"/mail/static/src/img/smiley/mailfailure.svg";}
get body(){if(this.notifications.length===1&&this.lastMessage?.thread){return _t("An error occurred when sending an email on “%(record_name)s”",{record_name:this.lastMessage.thread.name,});}
return _t("An error occurred when sending an email");}
get datetime(){return this.lastMessage?.datetime;}}
Failure.register();return __exports;});;

/* /mail/static/src/core/common/follower_model.js */
odoo.define('@mail/core/common/follower_model',['@mail/core/common/record'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const Follower=__exports.Follower=class Follower extends Record{static id="id";static records={};static get(data){return super.get(data);}
static insert(data){return super.insert(...arguments);}
thread=Record.one("Thread");id;is_active;partner=Record.one("Persona");get isEditable(){const hasWriteAccess=this.thread?this.thread.hasWriteAccess:false;return this.partner.eq(this.store.self)?this.thread.hasReadAccess:hasWriteAccess;}
async remove(){await this.store.env.services.orm.call(this.thread.model,"message_unsubscribe",[[this.thread.id],[this.partner.id],]);this.delete();}
removeRecipient(){this.thread.recipients.delete(this);}}
Follower.register();return __exports;});;

/* /mail/static/src/core/common/im_status.js */
odoo.define('@mail/core/common/im_status',['@odoo/owl','@mail/discuss/typing/common/typing'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{Typing}=require("@mail/discuss/typing/common/typing");const ImStatus=__exports.ImStatus=class ImStatus extends Component{static props=["persona?","className?","style?","member?","size?"];static template="mail.ImStatus";static defaultProps={className:"",style:"",size:"lg"};static components={Typing};get persona(){return this.props.persona??this.props.member?.persona;}}
return __exports;});;

/* /mail/static/src/core/common/im_status_service_patch.js */
odoo.define('@mail/core/common/im_status_service_patch',['@bus/im_status_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{AWAY_DELAY,imStatusService}=require("@bus/im_status_service");const{patch}=require("@web/core/utils/patch");const imStatusServicePatch=__exports.imStatusServicePatch={start(env,services){const{bus_service,presence}=services;const API=super.start(env,services);bus_service.subscribe("bus.bus/im_status_updated",({presence_status,im_status,partner_id,guest_id})=>{const store=env.services["mail.store"];if(!store){return;}
const persona=store.Persona.get({type:partner_id?"partner":"guest",id:partner_id??guest_id,});if(!persona){return;}
persona.debouncedSetImStatus(im_status);if(persona.type!=="guest"||persona.notEq(store.self)){return;}
const isOnline=presence.getInactivityPeriod()<AWAY_DELAY;if((presence_status==="away"&&isOnline)||presence_status==="offline"){this.updateBusPresence();}});return API;},};const unpatchImStatusService=__exports.unpatchImStatusService=patch(imStatusService,imStatusServicePatch);return __exports;});;

/* /mail/static/src/core/common/link_preview.js */
odoo.define('@mail/core/common/link_preview',['@mail/core/common/link_preview_confirm_delete','@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{LinkPreviewConfirmDelete}=require("@mail/core/common/link_preview_confirm_delete");const{Component}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const LinkPreview=__exports.LinkPreview=class LinkPreview extends Component{static template="mail.LinkPreview";static props=["linkPreview","deletable"];static components={};setup(){super.setup();this.dialogService=useService("dialog");}
onClick(){this.dialogService.add(LinkPreviewConfirmDelete,{linkPreview:this.props.linkPreview,LinkPreview,});}
onImageLoaded(){this.env.onImageLoaded?.();}}
return __exports;});;

/* /mail/static/src/core/common/link_preview_confirm_delete.js */
odoo.define('@mail/core/common/link_preview_confirm_delete',['@web/core/network/rpc','@odoo/owl','@web/core/dialog/dialog','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{Component,useState}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{useService}=require("@web/core/utils/hooks");const LinkPreviewConfirmDelete=__exports.LinkPreviewConfirmDelete=class LinkPreviewConfirmDelete extends Component{static components={Dialog};static props=["linkPreview","close","LinkPreview"];static template="mail.LinkPreviewConfirmDelete";setup(){super.setup();this.store=useState(useService("mail.store"));}
get message(){return this.props.linkPreview.message;}
onClickOk(){rpc("/mail/link_preview/hide",{link_preview_ids:[this.props.linkPreview.id]},{silent:true});this.props.close();}
onClickDeleteAll(){rpc("/mail/link_preview/hide",{link_preview_ids:this.message.linkPreviews.map((lp)=>lp.id)},{silent:true});this.props.close();}
onClickCancel(){this.props.close();}}
return __exports;});;

/* /mail/static/src/core/common/link_preview_list.js */
odoo.define('@mail/core/common/link_preview_list',['@mail/core/common/link_preview','@odoo/owl'],function(require){'use strict';let __exports={};const{LinkPreview}=require("@mail/core/common/link_preview");const{Component}=require("@odoo/owl");const LinkPreviewList=__exports.LinkPreviewList=class LinkPreviewList extends Component{static template="mail.LinkPreviewList";static props=["linkPreviews","deletable?"];static defaultProps={deletable:false,};static components={LinkPreview};}
return __exports;});;

/* /mail/static/src/core/common/link_preview_model.js */
odoo.define('@mail/core/common/link_preview_model',['@mail/core/common/record'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const LinkPreview=__exports.LinkPreview=class LinkPreview extends Record{static id="id";static get(data){return super.get(data);}
static insert(data){return super.insert(...arguments);}
id;message=Record.one("Message",{inverse:"linkPreviews"});image_mimetype;og_description;og_image;og_mimetype;og_title;og_type;og_site_name;source_url;get imageUrl(){return this.og_image?this.og_image:this.source_url;}
get isImage(){return Boolean(this.image_mimetype||this.og_mimetype==="image/gif");}
get isVideo(){return Boolean(!this.isImage&&this.og_type&&this.og_type.startsWith("video"));}
get isCard(){return!this.isImage&&!this.isVideo;}}
LinkPreview.register();return __exports;});;

/* /mail/static/src/core/common/mail_attachment_dropzone.js */
odoo.define('@mail/core/common/mail_attachment_dropzone',['@odoo/owl','@web/core/dropzone/dropzone'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{Dropzone}=require("@web/core/dropzone/dropzone");const MailAttachmentDropzone=__exports.MailAttachmentDropzone=class MailAttachmentDropzone extends Component{static template="mail.MailAttachmentDropzone";static components={Dropzone};static props=Dropzone.props;}
return __exports;});;

/* /mail/static/src/core/common/mail_core_common_service.js */
odoo.define('@mail/core/common/mail_core_common_service',['@odoo/owl','@web/core/registry'],function(require){'use strict';let __exports={};const{reactive}=require("@odoo/owl");const{registry}=require("@web/core/registry");const MailCoreCommon=__exports.MailCoreCommon=class MailCoreCommon{constructor(env,services){this.env=env;this.busService=services.bus_service;this.store=services["mail.store"];}
setup(){this.busService.subscribe("ir.attachment/delete",(payload)=>{const{id:attachmentId,message:messageData}=payload;if(messageData){this.store.Message.insert(messageData);}
const attachment=this.store.Attachment.get(attachmentId);attachment?.delete();});this.busService.subscribe("mail.message/delete",(payload,{id:notifId})=>{for(const messageId of payload.message_ids){const message=this.store.Message.get(messageId);if(!message){continue;}
this.env.bus.trigger("mail.message/delete",{message,notifId});message.delete();}});this.busService.subscribe("mail.message/toggle_star",(payload,metadata)=>this._handleNotificationToggleStar(payload,metadata));this.busService.subscribe("res.users.settings",(payload)=>{if(payload){this.store.settings.update(payload);}});this.busService.subscribe("mail.record/insert",(payload)=>{this.store.insert(payload,{html:true});});}
_handleNotificationToggleStar(payload,metadata){const{message_ids:messageIds,starred}=payload;this.store.Message.insert(messageIds.map((id)=>({id,starred})));}}
const mailCoreCommon=__exports.mailCoreCommon={dependencies:["bus_service","mail.store"],start(env,services){const mailCoreCommon=reactive(new MailCoreCommon(env,services));mailCoreCommon.setup();return mailCoreCommon;},};registry.category("services").add("mail.core.common",mailCoreCommon);return __exports;});;

/* /mail/static/src/core/common/mail_popout_service.js */
odoo.define('@mail/core/common/mail_popout_service',['@odoo/owl','@web/core/browser/browser','@web/core/registry','@web/core/templates','@web/core/utils/html'],function(require){'use strict';let __exports={};const{App}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{getTemplate}=require("@web/core/templates");const{setElementContent}=require("@web/core/utils/html");const mailPopoutService=__exports.mailPopoutService={start(env){let externalWindow;let beforeFn=()=>{};let afterFn=()=>{};let app;function reset(){if(externalWindow?.document){setElementContent(externalWindow.document.head,"");externalWindow.document.write(window.document.head.outerHTML);externalWindow.document.body=externalWindow.document.createElement("body");}
if(app){app.destroy();app=null;}}
async function pollClosedWindow(){while(externalWindow){await new Promise((r)=>setTimeout(r,1000));if(externalWindow.closed){externalWindow=null;afterFn();}}}
function addHooks(beforePopout=()=>{},afterPopoutClosed=()=>{}){beforeFn=beforePopout;afterFn=afterPopoutClosed;}
function popout(component,props){if(!externalWindow||externalWindow.closed){beforeFn();externalWindow=browser.open("about:blank","_blank","popup=yes");window.addEventListener("beforeunload",()=>{if(externalWindow&&!externalWindow.closed){externalWindow.close();}});pollClosedWindow();}
reset();app=new App(component,{name:"Popout",env,props,getTemplate,});app.mount(externalWindow.document.body);return externalWindow;}
return{get externalWindow(){return externalWindow&&externalWindow.closed?null:externalWindow;},popout,reset,addHooks,};},};registry.category("services").add("mail.popout",mailPopoutService);return __exports;});;

/* /mail/static/src/core/common/message.js */
odoo.define('@mail/core/common/message',['@mail/core/common/attachment_list','@mail/core/common/composer','@mail/core/common/im_status','@mail/core/common/link_preview_list','@mail/core/common/message_in_reply','@mail/core/common/message_notification_popover','@mail/core/common/message_reaction_menu','@mail/core/common/message_reactions','@mail/core/common/message_seen_indicator','@mail/core/common/relative_time','@mail/utils/common/format','@web/core/utils/misc','@web/core/utils/render','@odoo/owl','@web/core/action_swiper/action_swiper','@web/core/browser/feature_detection','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_hooks','@web/core/dropdown/dropdown_item','@web/core/l10n/translation','@web/core/popover/popover_hook','@web/core/utils/hooks','@web/core/utils/html','@web/core/utils/urls','@mail/core/common/message_actions','@web/core/browser/cookie','@web/core/network/rpc','@web/core/utils/strings','@mail/core/common/message_action_menu_mobile','@mail/core/common/discuss_component_registry'],function(require){'use strict';let __exports={};const{AttachmentList}=require("@mail/core/common/attachment_list");const{Composer}=require("@mail/core/common/composer");const{ImStatus}=require("@mail/core/common/im_status");const{LinkPreviewList}=require("@mail/core/common/link_preview_list");const{MessageInReply}=require("@mail/core/common/message_in_reply");const{MessageNotificationPopover}=require("@mail/core/common/message_notification_popover");const{MessageReactionMenu}=require("@mail/core/common/message_reaction_menu");const{MessageReactions}=require("@mail/core/common/message_reactions");const{MessageSeenIndicator}=require("@mail/core/common/message_seen_indicator");const{RelativeTime}=require("@mail/core/common/relative_time");const{htmlToTextContentInline}=require("@mail/utils/common/format");const{isEventHandled,markEventHandled}=require("@web/core/utils/misc");const{renderToElement}=require("@web/core/utils/render");const{Component,markup,onMounted,onPatched,onWillDestroy,onWillUpdateProps,toRaw,useChildSubEnv,useEffect,useRef,useState,}=require("@odoo/owl");const{ActionSwiper}=require("@web/core/action_swiper/action_swiper");const{hasTouch,isMobileOS}=require("@web/core/browser/feature_detection");const{Dropdown}=require("@web/core/dropdown/dropdown");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{_t}=require("@web/core/l10n/translation");const{usePopover}=require("@web/core/popover/popover_hook");const{useService}=require("@web/core/utils/hooks");const{setElementContent}=require("@web/core/utils/html");const{url}=require("@web/core/utils/urls");const{messageActionsRegistry,useMessageActions}=require("@mail/core/common/message_actions");const{cookie}=require("@web/core/browser/cookie");const{rpc}=require("@web/core/network/rpc");const{escape}=require("@web/core/utils/strings");const{MessageActionMenuMobile}=require("@mail/core/common/message_action_menu_mobile");const{discussComponentRegistry}=require("@mail/core/common/discuss_component_registry");const Message=__exports.Message=class Message extends Component{static SHADOW_LINK_COLOR="#66598f";static SHADOW_HIGHLIGHT_COLOR="#e99d00bf";static SHADOW_LINK_HOVER_COLOR="#564b79";static components={ActionSwiper,AttachmentList,Composer,Dropdown,DropdownItem,LinkPreviewList,MessageInReply,MessageReactions,MessageSeenIndicator,ImStatus,Popover:MessageNotificationPopover,RelativeTime,};static defaultProps={hasActions:true,isInChatWindow:false,showDates:true,};static props=["asCard?","registerMessageRef?","hasActions?","isInChatWindow?","onParentMessageClick?","message","messageEdition?","messageToReplyTo?","previousMessage?","squashed?","thread?","messageSearch?","className?","showDates?","isFirstMessage?",];static template="mail.Message";setup(){super.setup();this.escape=escape;this.popover=usePopover(this.constructor.components.Popover,{position:"top"});this.state=useState({isEditing:false,isHovered:false,isClicked:false,expandOptions:false,emailHeaderOpen:false,showTranslation:false,actionMenuMobileOpen:false,});this.shadowRoot;this.root=useRef("root");onWillUpdateProps((nextProps)=>{this.props.registerMessageRef?.(this.props.message,null);});onMounted(()=>this.props.registerMessageRef?.(this.props.message,this.root));onPatched(()=>this.props.registerMessageRef?.(this.props.message,this.root));onWillDestroy(()=>this.props.registerMessageRef?.(this.props.message,null));this.hasTouch=hasTouch;this.messageBody=useRef("body");this.messageActions=useMessageActions();this.store=useState(useService("mail.store"));this.shadowBody=useRef("shadowBody");this.dialog=useService("dialog");this.ui=useState(useService("ui"));this.openReactionMenu=this.openReactionMenu.bind(this);this.optionsDropdown=useDropdownState();useChildSubEnv({message:this.props.message,alignedRight:this.isAlignedRight,});useEffect((editingMessage)=>{if(this.props.message.eq(editingMessage)){messageActionsRegistry.get("edit").onClick(this);}},()=>[this.props.messageEdition?.editingMessage]);onMounted(()=>{if(this.shadowBody.el){this.shadowRoot=this.shadowBody.el.attachShadow({mode:"open"});const color=cookie.get("color_scheme")==="dark"?"white":"black";const shadowStyle=document.createElement("style");shadowStyle.textContent=`
                    * {
                        background-color: transparent !important;
                        color: ${color} !important;
                    }
                    a, a * {
                        color: ${this.constructor.SHADOW_LINK_COLOR} !important;
                    }
                    a:hover, a *:hover {
                        color: ${this.constructor.SHADOW_LINK_HOVER_COLOR} !important;
                    }
                    .o-mail-Message-searchHighlight {
                        background: ${this.constructor.SHADOW_HIGHLIGHT_COLOR} !important;
                    }
                `;if(cookie.get("color_scheme")==="dark"){this.shadowRoot.appendChild(shadowStyle);}}});useEffect(()=>{if(this.messageBody.el){this.prepareMessageBody(this.messageBody.el);}
if(this.shadowBody.el){const bodyEl=document.createElement("span");setElementContent(bodyEl,this.state.showTranslation?this.message.translationValue:this.props.messageSearch?.highlight(this.message.body)??this.message.body);this.prepareMessageBody(bodyEl);this.shadowRoot.appendChild(bodyEl);return()=>{this.shadowRoot.removeChild(bodyEl);};}},()=>[this.state.showTranslation,this.message.translationValue,this.props.messageSearch?.searchTerm,this.message.body,this.message.composer,]);}
get attClass(){return{[this.props.className]:true,"o-card p-2 mt-2 border border-secondary":this.props.asCard,"pt-1":!this.props.asCard,"o-selfAuthored":this.message.isSelfAuthored&&!this.env.messageCard,"o-selected":this.props.messageToReplyTo?.isSelected(this.props.thread,this.props.message),"o-squashed":this.props.squashed,"mt-1":!this.props.squashed&&this.props.thread&&!this.env.messageCard&&!this.props.asCard,"px-2":this.props.isInChatWindow,"opacity-50":this.props.messageToReplyTo?.isNotSelected(this.props.thread,this.props.message),"o-actionMenuMobileOpen":this.state.actionMenuMobileOpen,"o-editing":this.state.isEditing,};}
get authorAvatarAttClass(){return{o_object_fit_contain:this.props.message.author?.is_company,o_object_fit_cover:!this.props.message.author?.is_company,};}
get authorName(){if(this.message.author){return this.message.author.name;}
return this.message.email_from;}
get authorAvatarUrl(){if(this.message.message_type&&this.message.message_type.includes("email")&&!["partner","guest"].includes(this.message.author?.type)){return url("/mail/static/src/img/email_icon.png");}
if(this.message.author){return this.message.author.avatarUrl;}
return this.store.DEFAULT_AVATAR;}
get expandText(){return _t("Expand");}
get message(){return this.props.message;}
get quickActionCount(){return this.env.inChatter?3:this.env.inChatWindow?2:4;}
get showSeenIndicator(){return this.props.message.isSelfAuthored&&this.props.thread?.hasSeenFeature;}
get showSubtypeDescription(){return(this.message.subtype_description&&this.message.subtype_description.toLowerCase()!==htmlToTextContentInline(this.message.body||"").toLowerCase());}
get messageTypeText(){if(this.props.message.message_type==="notification"){return _t("System notification");}
if(this.props.message.message_type==="auto_comment"){return _t("Automated message");}
if(!this.props.message.is_discussion&&this.props.message.message_type!=="user_notification"){return _t("Note");}
return _t("Message");}
get isActive(){return(this.state.isHovered||this.state.isClicked||this.emojiPicker?.isOpen||this.optionsDropdown.isOpen);}
get isAlignedRight(){return Boolean(this.env.inChatWindow&&this.props.message.isSelfAuthored);}
get isMobileOS(){return isMobileOS();}
get isPersistentMessageFromAnotherThread(){return!this.isOriginThread&&!this.message.is_transient&&this.message.thread;}
get isOriginThread(){if(!this.props.thread){return false;}
return this.props.thread.eq(this.message.thread);}
get translatedFromText(){return _t("(Translated from: %(language)s)",{language:this.message.translationSource});}
get translationFailureText(){return _t("(Translation Failure: %(error)s)",{error:this.message.translationErrors});}
onMouseenter(){this.state.isHovered=true;}
onMouseleave(){this.state.isHovered=false;this.state.isClicked=null;}
get shouldDisplayAuthorName(){if(!this.env.inChatWindow){return true;}
if(this.message.isSelfAuthored){return false;}
if(this.props.thread.channel_type==="chat"){return false;}
return true;}
async onClickAttachmentUnlink(attachment){await toRaw(attachment).remove();}
async onClick(ev){if(this.store.handleClickOnLink(ev,this.props.thread)){return;}
if(!isEventHandled(ev,"Message.ClickAuthor")&&!isEventHandled(ev,"Message.ClickFailure")){if(this.state.isClicked){this.state.isClicked=false;}else{this.state.isClicked=true;document.body.addEventListener("click",()=>{this.state.isClicked=false;},{capture:true,once:true});}}}
async onClickNotificationMessage(ev){this.store.handleClickOnLink(ev,this.props.thread);const{oeType,oeId}=ev.target.dataset;if(oeType==="highlight"){await this.env.messageHighlight?.highlightMessage(this.store.Message.insert({id:Number(oeId),res_id:this.props.thread.id,model:this.props.thread.model,thread:this.props.thread,}),this.props.thread);}}
prepareMessageBody(bodyEl){if(!bodyEl){return;}
const editedEl=bodyEl.querySelector(".o-mail-Message-edited");editedEl?.replaceChildren(renderToElement("mail.Message.edited"));const linkEls=bodyEl.querySelectorAll(".o_channel_redirect");for(const linkEl of linkEls){const text=linkEl.textContent.substring(1);const icon=linkEl.classList.contains("o_channel_redirect_asThread")?"fa fa-comments-o":"fa fa-hashtag";const iconEl=renderToElement("mail.Message.mentionedChannelIcon",{icon});linkEl.replaceChildren(iconEl);linkEl.insertAdjacentText("beforeend",` ${text}`);}}
getAuthorAttClass(){return{"opacity-50":this.message.isPending};}
getAvatarContainerAttClass(){return{"opacity-50":this.message.isPending,"o-inChatWindow":this.env.inChatWindow,};}
exitEditMode(){const message=toRaw(this.props.message);this.props.messageEdition?.exitEditMode();message.composer=undefined;this.state.isEditing=false;}
onClickNotification(ev){const message=toRaw(this.message);if(message.failureNotifications.length>0){this.onClickFailure(ev);}else{this.popover.open(ev.target,{message});}}
onClickFailure(ev){const message=toRaw(this.message);markEventHandled(ev,"Message.ClickFailure");this.env.services.action.doAction("mail.mail_resend_message_action",{additionalContext:{mail_message_to_resend:message.id,},});}
openMobileActions(ev){if(!isMobileOS()){return;}
ev?.stopPropagation();this.state.actionMenuMobileOpen=true;this.dialog.add(MessageActionMenuMobile,{message:this.props.message,thread:this.props.thread,isFirstMessage:this.props.isFirstMessage,messageToReplyTo:this.props.messageToReplyTo,openReactionMenu:()=>this.openReactionMenu(),state:this.state,},{context:this,onClose:()=>(this.state.actionMenuMobileOpen=false)});}
openReactionMenu(reaction){const message=toRaw(this.props.message);this.dialog.add(MessageReactionMenu,{message,initialReaction:reaction},{context:this});}
async onClickToggleTranslation(){const message=toRaw(this.message);if(!message.translationValue){const{error,lang_name,body}=await rpc("/mail/message/translate",{message_id:message.id,});message.translationValue=body&&markup(body);message.translationSource=lang_name;message.translationErrors=error;}
this.state.showTranslation=!this.state.showTranslation&&Boolean(message.translationValue);}}
discussComponentRegistry.add("Message",Message);return __exports;});;

/* /mail/static/src/core/common/message_action_menu_mobile.js */
odoo.define('@mail/core/common/message_action_menu_mobile',['@odoo/owl','@web/core/dialog/dialog','@mail/core/common/message_actions','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,onMounted,onWillUnmount,useState}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{useMessageActions}=require("@mail/core/common/message_actions");const{useChildRef,useService}=require("@web/core/utils/hooks");const MessageActionMenuMobile=__exports.MessageActionMenuMobile=class MessageActionMenuMobile extends Component{static components={Dialog};static props=["message","close?","thread?","isFirstMessage?","messageToReplyTo?","openReactionMenu?","state",];static template="mail.MessageActionMenuMobile";setup(){super.setup();this.store=useState(useService("mail.store"));this.modalRef=useChildRef();this.messageActions=useMessageActions();this.onClickModal=this.onClickModal.bind(this);onMounted(()=>{this.modalRef.el.addEventListener("click",this.onClickModal);});onWillUnmount(()=>{this.modalRef.el.removeEventListener("click",this.onClickModal);});}
onClickModal(){this.props.close?.();}
get message(){return this.props.message;}
get state(){return this.props.state;}
async onClickAction(action){const success=await action.onClick();if(action.mobileCloseAfterClick&&(success||success===undefined)){this.props.close?.();}}
openReactionMenu(){return this.props.openReactionMenu?.();}}
return __exports;});;

/* /mail/static/src/core/common/message_actions.js */
odoo.define('@mail/core/common/message_actions',['@odoo/owl','@web/core/l10n/translation','@web/core/network/download','@web/core/registry','@mail/core/common/message_reaction_button','@web/core/utils/hooks','@mail/core/common/discuss_component_registry','@web/core/utils/concurrency','@web/core/emoji_picker/emoji_picker','@web/core/dialog/dialog','@mail/utils/common/hooks','@mail/utils/common/format'],function(require){'use strict';let __exports={};const{Component,toRaw,useComponent,useState,xml}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{download}=require("@web/core/network/download");const{registry}=require("@web/core/registry");const{MessageReactionButton}=require("@mail/core/common/message_reaction_button");const{useService}=require("@web/core/utils/hooks");const{discussComponentRegistry}=require("@mail/core/common/discuss_component_registry");const{Deferred}=require("@web/core/utils/concurrency");const{EMOJI_PICKER_PROPS,EmojiPicker}=require("@web/core/emoji_picker/emoji_picker");const{Dialog}=require("@web/core/dialog/dialog");const{onExternalClick}=require("@mail/utils/common/hooks");const{convertBrToLineBreak}=require("@mail/utils/common/format");const{DateTime}=luxon;const messageActionsRegistry=__exports.messageActionsRegistry=registry.category("mail.message/actions");class EmojiPickerMobile extends Component{static components={Dialog,EmojiPicker};static props=[...EMOJI_PICKER_PROPS,"onClose?"];static template=xml`
        <Dialog size="'lg'" header="false" footer="false" contentClass="'o-discuss-mobileContextMenu d-flex position-absolute bottom-0 rounded-0 h-50 bg-100'">
            <div t-ref="root">
                <EmojiPicker t-props="emojiPickerProps"/>
            </div>
        </Dialog>
    `;get emojiPickerProps(){return{...this.props,onSelect:(...args)=>{this.props.onSelect(...args);this.props.close?.();},};}
setup(){super.setup();onExternalClick("root",()=>this.props.close?.());}}
messageActionsRegistry.add("reaction",{callComponent:MessageReactionButton,props:(component)=>({message:component.props.message,action:messageActionsRegistry.get("reaction"),}),condition:(component)=>component.props.message.canAddReaction(component.props.thread),icon:"oi oi-smile-add",title:_t("Add a Reaction"),onClick:async(component)=>{const def=new Deferred();component.dialog.add(EmojiPickerMobile,{onSelect:(emoji)=>{const reaction=component.props.message.reactions.find(({content,personas})=>content===emoji&&personas.find((persona)=>persona.eq(component.store.self)));if(!reaction){component.props.message.react(emoji);}
def.resolve(true);},},{context:component,onClose:()=>def.resolve(false)});return def;},sequence:10,}).add("reply-to",{condition:(component)=>component.props.message.canReplyTo(component.props.thread),icon:"fa fa-reply",title:_t("Reply"),onClick:(component)=>{const message=toRaw(component.props.message);const thread=toRaw(component.props.thread);component.props.messageToReplyTo.toggle(thread,message);},sequence:(component)=>(component.props.thread?.eq(component.store.inbox)?55:20),}).add("toggle-star",{condition:(component)=>component.props.message.canToggleStar,icon:(component)=>component.props.message.starred?"fa fa-star o-mail-Message-starred":"fa fa-star-o",title:_t("Mark as Todo"),onClick:(component)=>component.props.message.toggleStar(),sequence:30,mobileCloseAfterClick:false,}).add("mark-as-read",{condition:(component)=>component.props.thread?.eq(component.store.inbox),icon:"fa fa-check",title:_t("Mark as Read"),onClick:(component)=>component.props.message.setDone(),sequence:40,}).add("reactions",{condition:(component)=>component.message.reactions.length,icon:"fa fa-smile-o",title:_t("View Reactions"),onClick:(component)=>component.openReactionMenu(),sequence:50,dropdown:true,}).add("unfollow",{condition:(component)=>component.props.message.canUnfollow(component.props.thread),icon:"fa fa-user-times",title:_t("Unfollow"),onClick:(component)=>component.props.message.unfollow(),sequence:60,}).add("mark-as-unread",{condition:(component)=>component.props.thread?.model==="discuss.channel"&&component.store.self.type==="partner",icon:"fa fa-eye-slash",title:_t("Mark as Unread"),onClick:(component)=>component.props.message.onClickMarkAsUnread(component.props.thread),sequence:70,}).add("edit",{condition:(component)=>component.props.message.editable,icon:"fa fa-pencil",title:_t("Edit"),onClick:(component)=>{const message=toRaw(component.props.message);const text=convertBrToLineBreak(message.body);message.composer={mentionedPartners:message.recipients,text,selection:{start:text.length,end:text.length,direction:"none",},};component.state.isEditing=true;},sequence:80,}).add("delete",{condition:(component)=>component.props.message.editable,btnClass:"text-danger",icon:"fa fa-trash",title:_t("Delete"),onClick:async(component)=>{const message=toRaw(component.message);const def=new Deferred();component.dialog.add(discussComponentRegistry.get("MessageConfirmDialog"),{message,prompt:_t("Are you sure you want to delete this message?"),onConfirm:()=>{def.resolve(true);message.remove();},},{context:component,onClose:()=>def.resolve(false)});return def;},setup:()=>{const component=useComponent();component.dialog=useService("dialog");},sequence:90,}).add("download_files",{condition:(component)=>component.message.attachment_ids.length>1&&component.store.self.isInternalUser,icon:"fa fa-download",title:_t("Download Files"),onClick:(component)=>download({data:{file_ids:component.message.attachment_ids.map((rec)=>rec.id),zip_name:`attachments_${DateTime.local().toFormat("HHmmddMMyyyy")}.zip`,},url:"/mail/attachment/zip",}),sequence:55,}).add("toggle-translation",{condition:(component)=>component.props.message.isTranslatable(component.props.thread),icon:(component)=>`fa fa-language ${component.state.showTranslation ? "o-mail-Message-translated" : ""}`,title:(component)=>(component.state.showTranslation?_t("Revert"):_t("Translate")),onClick:(component)=>component.onClickToggleTranslation(),sequence:100,}).add("copy-link",{condition:(component)=>component.message.message_type&&component.message.message_type!=="user_notification",icon:"fa fa-link",title:_t("Copy Link"),onClick:(component)=>component.message.copyLink(),sequence:110,});function transformAction(component,id,action){return{get btnClass(){return typeof action.btnClass==="function"?action.btnClass(component):action.btnClass;},component:action.component,id,mobileCloseAfterClick:action.mobileCloseAfterClick??true,get condition(){return action.condition(component);},get icon(){return typeof action.icon==="function"?action.icon(component):action.icon;},get title(){return typeof action.title==="function"?action.title(component):action.title;},callComponent:action.callComponent,get props(){return action.props(component);},onClick(){return action.onClick?.(component);},get sequence(){return typeof action.sequence==="function"?action.sequence(component):action.sequence;},setup:action.setup,};}
__exports.useMessageActions=useMessageActions;function useMessageActions(){const component=useComponent();const transformedActions=messageActionsRegistry.getEntries().map(([id,action])=>transformAction(component,id,action));for(const action of transformedActions){if(action.setup){action.setup(action);}}
const state=useState({get actions(){const actions=transformedActions.filter((action)=>action.condition).sort((a1,a2)=>a1.sequence-a2.sequence);if(actions.length>0){actions.at(0).isFirst=true;actions.at(-1).isLast=true;}
return actions;},});return state;}
return __exports;});;

/* /mail/static/src/core/common/message_card_list.js */
odoo.define('@mail/core/common/message_card_list',['@mail/core/common/message','@mail/utils/common/hooks','@odoo/owl','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message");const{useVisible}=require("@mail/utils/common/hooks");const{Component,useState,useSubEnv}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const MessageCardList=__exports.MessageCardList=class MessageCardList extends Component{static components={Message};static props=["emptyText?","messages","messageSearch?","loadMore?","mode","onClickJump?","onLoadMoreVisible?","showEmpty?","thread",];static template="mail.MessageCardList";setup(){super.setup();this.ui=useState(useService("ui"));useSubEnv({messageCard:true});useVisible("load-more",(isVisible)=>{if(isVisible){this.props.onLoadMoreVisible?.();}});}
async onClickJump(message){this.props.onClickJump?.();if(this.ui.isSmall||this.env.inChatWindow){this.env.pinMenu?.close();this.env.searchMenu?.close();}
await new Promise((resolve)=>setTimeout(()=>requestAnimationFrame(resolve)));await this.env.messageHighlight?.highlightMessage(message,this.props.thread);}
get emptyText(){return this.props.emptyText??_t("No messages found");}}
return __exports;});;

/* /mail/static/src/core/common/message_confirm_dialog.js */
odoo.define('@mail/core/common/message_confirm_dialog',['@odoo/owl','@web/core/dialog/dialog','@web/core/l10n/translation','@mail/core/common/discuss_component_registry'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{_t}=require("@web/core/l10n/translation");const{discussComponentRegistry}=require("@mail/core/common/discuss_component_registry");const MessageConfirmDialog=__exports.MessageConfirmDialog=class MessageConfirmDialog extends Component{static components={Dialog};static props=["close","confirmColor?","confirmText?","message","prompt","size?","title?","onConfirm",];static defaultProps={confirmColor:"btn-primary",confirmText:_t("Confirm"),size:"xl",title:_t("Confirmation"),};static template="mail.MessageConfirmDialog";get messageComponent(){return discussComponentRegistry.get("Message");}
onClickConfirm(){this.props.onConfirm();this.props.close();}}
discussComponentRegistry.add("MessageConfirmDialog",MessageConfirmDialog);return __exports;});;

/* /mail/static/src/core/common/message_in_reply.js */
odoo.define('@mail/core/common/message_in_reply',['@odoo/owl','@web/core/utils/hooks','@web/core/utils/urls'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{url}=require("@web/core/utils/urls");const MessageInReply=__exports.MessageInReply=class MessageInReply extends Component{static props=["message","onClick?"];static template="mail.MessageInReply";setup(){super.setup();this.store=useState(useService("mail.store"));}
get authorAvatarUrl(){if(this.props.message.message_type&&this.props.message.message_type.includes("email")&&!["partner","guest"].includes(this.props.message.author?.type)){return url("/mail/static/src/img/email_icon.png");}
if(this.props.message.parentMessage.author){return this.props.message.parentMessage.author.avatarUrl;}
return this.store.DEFAULT_AVATAR;}}
return __exports;});;

/* /mail/static/src/core/common/message_model.js */
odoo.define('@mail/core/common/message_model',['@mail/core/common/record','@mail/utils/common/format','@mail/utils/common/html','@odoo/owl','@web/core/browser/browser','@web/core/browser/router','@web/core/l10n/translation','@web/core/network/rpc','@web/core/user','@web/core/utils/html','@web/core/utils/urls'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{EMOJI_REGEX,convertBrToLineBreak,htmlToTextContentInline,prettifyMessageContent,}=require("@mail/utils/common/format");const{createDocumentFragmentFromContent}=require("@mail/utils/common/html");const{toRaw}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{stateToUrl}=require("@web/core/browser/router");const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{user}=require("@web/core/user");const{setElementContent}=require("@web/core/utils/html");const{url}=require("@web/core/utils/urls");const{DateTime}=luxon;const Message=__exports.Message=class Message extends Record{static id="id";static records={};static get(data){return super.get(data);}
static insert(data){return super.insert(...arguments);}
update(data){super.update(data);if(this.isNotification&&!this.notificationType){const htmlBody=createDocumentFragmentFromContent(this.body);this.notificationType=htmlBody.querySelector(".o_mail_notification")?.dataset.oeType;}}
attachment_ids=Record.many("Attachment",{inverse:"message"});author=Record.one("Persona");body=Record.attr("",{html:true});composer=Record.one("Composer",{inverse:"message",onDelete:(r)=>r.delete()});date=Record.attr(undefined,{type:"datetime"});default_subject;edited=Record.attr(false,{compute(){return Boolean(createDocumentFragmentFromContent(this.body).querySelector(".o-mail-Message-edited"));},});hasEveryoneSeen=Record.attr(false,{compute(){return this.thread?.membersThatCanSeen.every((m)=>m.hasSeen(this));},});isMessagePreviousToLastSelfMessageSeenByEveryone=Record.attr(false,{compute(){if(!this.thread?.lastSelfMessageSeenByEveryone){return false;}
return this.id<this.thread.lastSelfMessageSeenByEveryone.id;},});isReadBySelf=Record.attr(false,{compute(){return(this.thread?.selfMember?.seen_message_id?.id>=this.id&&this.thread?.selfMember?.new_message_separator>this.id);},});hasSomeoneSeen=Record.attr(false,{compute(){return this.thread?.membersThatCanSeen.filter(({persona})=>!persona.eq(this.author)).some((m)=>m.hasSeen(this));},});hasSomeoneFetched=Record.attr(false,{compute(){if(!this.thread){return false;}
const otherFetched=this.thread.channelMembers.filter((m)=>m.persona.notEq(this.author)&&m.fetched_message_id?.id>=this.id);return otherFetched.length>0;},});hasLink=Record.attr(false,{compute(){if(this.isBodyEmpty){return false;}
const div=document.createElement("div");setElementContent(div,this.body);return Boolean(div.querySelector("a:not([data-oe-model])"));},});id;is_discussion;is_note;is_transient;linkPreviews=Record.many("LinkPreview",{inverse:"message",onDelete:(r)=>r.delete()});parentMessage=Record.one("Message");postFailRedo=undefined;reactions=Record.many("MessageReactions",{inverse:"message",sort:(r1,r2)=>r1.sequence-r2.sequence,});notifications=Record.many("Notification",{inverse:"message"});recipients=Record.many("Persona");thread=Record.one("Thread");threadAsNeedaction=Record.one("Thread",{compute(){if(this.needaction){return this.thread;}},});threadAsNewest=Record.one("Thread");scheduledDatetime=Record.attr(undefined,{type:"datetime"});onlyEmojis=Record.attr(false,{compute(){const div=document.createElement("div");setElementContent(div,this.body);const bodyWithoutTags=div.textContent;const withoutEmojis=bodyWithoutTags.replace(EMOJI_REGEX,"");return bodyWithoutTags.length>0&&withoutEmojis.trim().length===0;},});subject;subtype_description;threadAsFirstUnread=Record.one("Thread",{inverse:"firstUnreadMessage"});trackingValues=[];translationValue;translationSource;translationErrors;message_type;notificationType;create_date=Record.attr(undefined,{type:"datetime"});write_date=Record.attr(undefined,{type:"datetime"});needaction;starred=false;get allowsEdition(){return this.store.self.isAdmin||this.isSelfAuthored;}
get bubbleColor(){if(!this.isSelfAuthored&&!this.is_note&&!this.isHighlightedFromMention){return"blue";}
if(this.isSelfAuthored&&!this.is_note&&!this.isHighlightedFromMention){return"green";}
if(this.isHighlightedFromMention){return"orange";}
return undefined;}
get editable(){if(!this.allowsEdition){return false;}
return this.message_type==="comment";}
get dateDay(){let dateDay=this.datetime.toLocaleString(DateTime.DATE_MED);if(dateDay===DateTime.now().toLocaleString(DateTime.DATE_MED)){dateDay=_t("Today");}
return dateDay;}
get dateSimple(){return this.datetime.toLocaleString(DateTime.TIME_SIMPLE,{locale:user.lang,}).replace(" "," ");}
get dateSimpleWithDay(){const userLocale={locale:user.lang};if(this.datetime.hasSame(DateTime.now(),"day")){return _t("Today at %(time)s",{time:this.datetime.toLocaleString(DateTime.TIME_SIMPLE,userLocale),});}
if(this.datetime.hasSame(DateTime.now().minus({day:1}),"day")){return _t("Yesterday at %(time)s",{time:this.datetime.toLocaleString(DateTime.TIME_SIMPLE,userLocale),});}
if(this.datetime?.year===DateTime.now().year){return this.datetime.toLocaleString({...DateTime.DATETIME_MED,year:undefined},userLocale);}
return this.datetime.toLocaleString({...DateTime.DATETIME_MED},userLocale);}
get datetime(){return this.date||DateTime.now();}
get datetimeShort(){return this.datetime.toLocaleString(DateTime.DATETIME_SHORT_WITH_SECONDS);}
get isSelfMentioned(){return this.store.self.in(this.recipients);}
get isHighlightedFromMention(){return this.isSelfMentioned&&this.thread?.model==="discuss.channel";}
isSelfAuthored=Record.attr(false,{compute(){if(!this.author){return false;}
return this.author.eq(this.store.self);},});isPending=false;get hasActions(){return!this.is_transient;}
get isNotification(){return this.message_type==="notification"&&this.thread?.model==="discuss.channel";}
get isSubjectSimilarToThreadName(){if(!this.subject||!this.thread||!this.thread.name){return false;}
const regexPrefix=/^((re|fw|fwd)\s*:\s*)*/i;const cleanedThreadName=this.thread.name.replace(regexPrefix,"");const cleanedSubject=this.subject.replace(regexPrefix,"");return cleanedSubject===cleanedThreadName;}
get isSubjectDefault(){const name=this.thread?.name;const threadName=name?name.trim().toLowerCase():"";const defaultSubject=this.default_subject?this.default_subject.toLowerCase():"";const candidates=new Set([defaultSubject,threadName]);return candidates.has(this.subject?.toLowerCase());}
get resUrl(){return url(stateToUrl({model:this.thread.model,resId:this.thread.id}));}
isTranslatable(thread){return(this.store.hasMessageTranslationFeature&&!["discuss.channel","mail.box"].includes(thread?.model));}
get hasTextContent(){return!this.isBodyEmpty;}
isEmpty=Record.attr(false,{compute(){return(this.isBodyEmpty&&this.attachment_ids.length===0&&this.trackingValues.length===0&&!this.subtype_description);},});isBodyEmpty=Record.attr(undefined,{compute(){return(!this.body||["","<p></p>","<p><br></p>","<p><br/></p>","<div></div>","<div><br></div>","<div><br/></div>",].includes(this.body.replace('<span class="o-mail-Message-edited"></span>',"").replace(/\s/g,"")));},});get linkPreviewSquash(){return(this.store.hasLinkPreviewFeature&&this.body&&this.body.startsWith("<a")&&this.body.endsWith("/a>")&&this.body.match(/<\/a>/im)?.length===1&&this.linkPreviews.length===1&&this.linkPreviews[0].isImage);}
get inlineBody(){if(!this.body){return"";}
return htmlToTextContentInline(this.body);}
get notificationIcon(){switch(this.notificationType){case"pin":return"fa fa-thumb-tack";}
return null;}
get failureNotifications(){return this.notifications.filter((notification)=>notification.isFailure);}
get scheduledDateSimple(){return this.scheduledDatetime.toLocaleString(DateTime.TIME_SIMPLE,{locale:user.lang,});}
get canToggleStar(){return Boolean(!this.is_transient&&this.thread&&this.store.self.type==="partner"&&this.store.self.isInternalUser);}
canAddReaction(thread){return Boolean(!this.is_transient&&this.thread?.can_react);}
canReplyTo(thread){return(["discuss.channel","mail.box"].includes(thread.model)&&this.message_type!=="user_notification");}
canUnfollow(thread){return Boolean(this.thread?.selfFollower&&thread?.model==="mail.box");}
async copyLink(){let notification=_t("Message Link Copied!");let type="info";try{await browser.navigator.clipboard.writeText(url(`/mail/message/${this.id}`));}catch{notification=_t("Message Link Copy Failed (Permission denied?)!");type="danger";}
this.store.env.services.notification.add(notification,{type});}
async edit(body,attachments=[],{mentionedChannels=[],mentionedPartners=[]}={}){if(convertBrToLineBreak(this.body)===body&&attachments.length===0){return;}
const validMentions=this.store.getMentionsFromText(body,{mentionedChannels,mentionedPartners,});const data=await rpc("/mail/message/update_content",{attachment_ids:attachments.concat(this.attachment_ids).map((attachment)=>attachment.id),attachment_tokens:attachments.concat(this.attachment_ids).map((attachment)=>attachment.access_token),body:await prettifyMessageContent(body,validMentions),message_id:this.id,partner_ids:validMentions?.partners?.map((partner)=>partner.id),...this.thread.rpcParams,});this.store.insert(data,{html:true});if(this.hasLink&&this.store.hasLinkPreviewFeature){rpc("/mail/link_preview",{message_id:this.id},{silent:true});}}
async react(content){this.store.insert(await rpc("/mail/message/reaction",{action:"add",content,message_id:this.id,...this.thread.rpcParams,},{silent:true}));}
async remove(){await rpc("/mail/message/update_content",{attachment_ids:[],attachment_tokens:[],body:"",message_id:this.id,...this.thread.rpcParams,});this.body="";this.attachment_ids=[];}
async setDone(){await this.store.env.services.orm.silent.call("mail.message","set_message_done",[[this.id],]);}
async toggleStar(){this.store.insert(await this.store.env.services.orm.silent.call("mail.message","toggle_message_starred",[[this.id]]));}
async unfollow(){if(this.needaction){await this.setDone();}
const thread=this.thread;await thread.selfFollower.remove();this.store.env.services.notification.add(_t('You are no longer following "%(thread_name)s".',{thread_name:thread.name}),{type:"success"});}
get channelMemberHaveSeen(){return this.thread.membersThatCanSeen.filter((m)=>m.hasSeen(this)&&m.persona.notEq(this.author));}
onClickMarkAsUnread(thr){const message=toRaw(this);const thread=toRaw(thr);if(!thread.selfMember||thread.selfMember?.new_message_separator===message.id){return;}
return rpc("/discuss/channel/mark_as_unread",{channel_id:message.thread.id,message_id:message.id,});}}
Message.register();return __exports;});;

/* /mail/static/src/core/common/message_notification_popover.js */
odoo.define('@mail/core/common/message_notification_popover',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const MessageNotificationPopover=__exports.MessageNotificationPopover=class MessageNotificationPopover extends Component{static template="mail.MessageNotificationPopover";static props=["message","close?"];}
return __exports;});;

/* /mail/static/src/core/common/message_reaction_button.js */
odoo.define('@mail/core/common/message_reaction_button',['@odoo/owl','@web/core/emoji_picker/emoji_picker','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,useRef,useState}=require("@odoo/owl");const{useEmojiPicker}=require("@web/core/emoji_picker/emoji_picker");const{useService}=require("@web/core/utils/hooks");const MessageReactionButton=__exports.MessageReactionButton=class MessageReactionButton extends Component{static template="mail.MessageReactionButton";static props=["message","classNames?","action"];setup(){super.setup();this.store=useState(useService("mail.store"));this.emojiPickerRef=useRef("emoji-picker");this.emojiPicker=useEmojiPicker(this.emojiPickerRef,{onSelect:(emoji)=>{const reaction=this.props.message.reactions.find(({content,personas})=>content===emoji&&personas.find((persona)=>persona.eq(this.store.self)));if(!reaction){this.props.message.react(emoji);}},});}}
return __exports;});;

/* /mail/static/src/core/common/message_reaction_list.js */
odoo.define('@mail/core/common/message_reaction_list',['@mail/utils/common/hooks','@odoo/owl','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_hooks','@web/core/emoji_picker/emoji_picker','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{useHover}=require("@mail/utils/common/hooks");const{Component,onMounted,onPatched,useState}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const{loadEmoji,loader}=require("@web/core/emoji_picker/emoji_picker");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const MessageReactionList=__exports.MessageReactionList=class MessageReactionList extends Component{static template="mail.MessageReactionList";static components={Dropdown};static props=["message","openReactionMenu","reaction"];setup(){super.setup();this.loadEmoji=loadEmoji;this.store=useState(useService("mail.store"));this.ui=useService("ui");this.preview=useDropdownState();this.hover=useHover(["reactionButton","reactionList*"],{onHover:()=>(this.preview.isOpen=true),onAway:()=>(this.preview.isOpen=false),stateObserver:()=>[this.preview?.isOpen],});this.state=useState({emojiLoaded:Boolean(loader.loaded)});if(!loader.loaded){loader.onEmojiLoaded(()=>(this.state.emojiLoaded=true));}
onMounted(()=>void this.state.emojiLoaded);onPatched(()=>void this.state.emojiLoaded);}
previewText(reaction){const{count,content:emoji}=reaction;const personNames=reaction.personas.slice(0,3).map((persona)=>persona.name);const shortcode=loader.loaded?.emojiValueToShortcode?.[emoji]??"?";switch(count){case 1:return _t("%(emoji)s reacted by %(person)s",{emoji:shortcode,person:personNames[0],});case 2:return _t("%(emoji)s reacted by %(person1)s and %(person2)s",{emoji:shortcode,person1:personNames[0],person2:personNames[1],});case 3:return _t("%(emoji)s reacted by %(person1)s, %(person2)s, and %(person3)s",{emoji:shortcode,person1:personNames[0],person2:personNames[1],person3:personNames[2],});case 4:return _t("%(emoji)s reacted by %(person1)s, %(person2)s, %(person3)s, and 1 other",{emoji:shortcode,person1:personNames[0],person2:personNames[1],person3:personNames[2],});default:return _t("%(emoji)s reacted by %(person1)s, %(person2)s, %(person3)s, and %(count)s others",{count:count-3,emoji:shortcode,person1:personNames[0],person2:personNames[1],person3:personNames[2],});}}
hasSelfReacted(reaction){return this.store.self.in(reaction.personas);}
onClickReaction(reaction){if(!this.props.message.canAddReaction()){return;}
if(this.hasSelfReacted(reaction)){reaction.remove();}else{this.props.message.react(reaction.content);}}
onContextMenu(ev){if(this.ui.isSmall){ev.preventDefault();this.props.openReactionMenu();}}
onClickReactionList(reaction){this.preview.isOpen=false;this.props.openReactionMenu(reaction);}}
return __exports;});;

/* /mail/static/src/core/common/message_reaction_menu.js */
odoo.define('@mail/core/common/message_reaction_menu',['@web/core/emoji_picker/emoji_picker','@mail/utils/common/hooks','@odoo/owl','@web/core/dialog/dialog','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{loadEmoji,loader}=require("@web/core/emoji_picker/emoji_picker");const{onExternalClick}=require("@mail/utils/common/hooks");const{Component,onMounted,onPatched,useEffect,useExternalListener,useRef,useState,}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{useService}=require("@web/core/utils/hooks");const MessageReactionMenu=__exports.MessageReactionMenu=class MessageReactionMenu extends Component{static props=["close","message","initialReaction?"];static components={Dialog};static template="mail.MessageReactionMenu";setup(){super.setup();this.root=useRef("root");this.store=useState(useService("mail.store"));this.ui=useState(useService("ui"));this.state=useState({emojiLoaded:Boolean(loader.loaded),reaction:this.props.initialReaction?this.props.initialReaction:this.props.message.reactions[0],});useExternalListener(document,"keydown",this.onKeydown);onExternalClick("root",()=>this.props.close());useEffect(()=>{const activeReaction=this.props.message.reactions.find(({content})=>content===this.state.reaction.content);if(this.props.message.reactions.length===0){this.props.close();}else if(!activeReaction){this.state.reaction=this.props.message.reactions[0];}},()=>[this.props.message.reactions.length]);onMounted(async()=>{if(!loader.loaded){loadEmoji();}});if(!loader.loaded){loader.onEmojiLoaded(()=>(this.state.emojiLoaded=true));}
onMounted(()=>void this.state.emojiLoaded);onPatched(()=>void this.state.emojiLoaded);}
onKeydown(ev){switch(ev.key){case"Escape":this.props.close();break;case"q":this.props.close();break;default:return;}}
getEmojiShortcode(reaction){return loader.loaded?.emojiValueToShortcode?.[reaction.content]??"?";}}
return __exports;});;

/* /mail/static/src/core/common/message_reactions.js */
odoo.define('@mail/core/common/message_reactions',['@odoo/owl','@mail/core/common/message_reaction_list','@web/core/utils/hooks','@web/core/emoji_picker/emoji_picker'],function(require){'use strict';let __exports={};const{Component,useRef,useState}=require("@odoo/owl");const{MessageReactionList}=require("@mail/core/common/message_reaction_list");const{useService}=require("@web/core/utils/hooks");const{useEmojiPicker}=require("@web/core/emoji_picker/emoji_picker");const MessageReactions=__exports.MessageReactions=class MessageReactions extends Component{static props=["message","openReactionMenu"];static template="mail.MessageReactions";static components={MessageReactionList};setup(){super.setup();this.store=useState(useService("mail.store"));this.ui=useService("ui");this.addRef=useRef("add");this.emojiPicker=useEmojiPicker(this.addRef,{onSelect:(emoji)=>{const reaction=this.props.message.reactions.find(({content,personas})=>content===emoji&&personas.find((persona)=>persona.eq(this.store.self)));if(!reaction){this.props.message.react(emoji);}},});}}
return __exports;});;

/* /mail/static/src/core/common/message_reactions_model.js */
odoo.define('@mail/core/common/message_reactions_model',['@mail/core/common/record','@web/core/network/rpc'],function(require){'use strict';let __exports={};const{AND,Record}=require("@mail/core/common/record");const{rpc}=require("@web/core/network/rpc");const MessageReactions=__exports.MessageReactions=class MessageReactions extends Record{static id=AND("message","content");static get(data){return super.get(data);}
static insert(data){return super.insert(...arguments);}
content;count;sequence;personas=Record.many("Persona");message=Record.one("Message");async remove(){this.store.insert(await rpc("/mail/message/reaction",{action:"remove",content:this.content,message_id:this.message.id,...this.message.thread.rpcParams,},{silent:true}));}}
MessageReactions.register();return __exports;});;

/* /mail/static/src/core/common/message_search_hook.js */
odoo.define('@mail/core/common/message_search_hook',['@mail/utils/common/hooks','@mail/utils/common/html','@odoo/owl','@web/core/utils/hooks','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{useSequential}=require("@mail/utils/common/hooks");const{createDocumentFragmentFromContent}=require("@mail/utils/common/html");const{useState,onWillUnmount,markup}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{escapeRegExp}=require("@web/core/utils/strings");const HIGHLIGHT_CLASS=__exports.HIGHLIGHT_CLASS="o-mail-Message-searchHighlight";__exports.searchHighlight=searchHighlight;function searchHighlight(searchTerm,target){if(!searchTerm){return target;}
const htmlDoc=createDocumentFragmentFromContent(target);for(const term of searchTerm.split(" ")){const regexp=new RegExp(`(${escapeRegExp(term)})`,"gi");const split=term.toLowerCase().split("'");let lowercase=split.map((s)=>`'${s}'`).join(', "\'", ');let uppercase=lowercase.toUpperCase();if(split.length>1){lowercase=`concat(${lowercase})`;uppercase=`concat(${uppercase})`;}
const matchs=htmlDoc.evaluate(`//*[text()[contains(translate(., ${uppercase}, ${lowercase}), ${lowercase})]]`,htmlDoc,null,XPathResult.ORDERED_NODE_SNAPSHOT_TYPE);for(let i=0;i<matchs.snapshotLength;i++){const element=matchs.snapshotItem(i);const newNode=[];for(const node of element.childNodes){const match=node.textContent.match(regexp);if(node.nodeType===Node.TEXT_NODE&&match?.length>0){let curIndex=0;for(const match of node.textContent.matchAll(regexp)){const start=htmlDoc.createTextNode(node.textContent.slice(curIndex,match.index));newNode.push(start);const span=htmlDoc.createElement("span");span.setAttribute("class",HIGHLIGHT_CLASS);span.textContent=match[0];newNode.push(span);curIndex=match.index+match[0].length;}
const end=htmlDoc.createTextNode(node.textContent.slice(curIndex));newNode.push(end);}else{newNode.push(node);}}
element.replaceChildren(...newNode);}}
return markup(htmlDoc.body.innerHTML);}
__exports.useMessageSearch=useMessageSearch;function useMessageSearch(thread){const store=useService("mail.store");const sequential=useSequential();const state=useState({thread,async search(before=false){if(this.searchTerm){this.searching=true;const data=await sequential(()=>store.search(this.searchTerm,this.thread,before));if(!data){return;}
const{count,loadMore,messages}=data;this.searched=true;this.searching=false;this.count=count;this.loadMore=loadMore;if(before){this.messages.push(...messages);}else{this.messages=messages;}}else{this.clear();}},count:0,clear(){this.messages=[];this.searched=false;this.searching=false;this.searchTerm=undefined;},loadMore:false,messages:[],searchTerm:undefined,searched:false,searching:false,highlight:(target)=>searchHighlight(state.searchTerm,target),});onWillUnmount(()=>{state.clear();});return state;}
return __exports;});;

/* /mail/static/src/core/common/message_seen_indicator.js */
odoo.define('@mail/core/common/message_seen_indicator',['@odoo/owl','@web/core/dialog/dialog','@web/core/l10n/translation','@web/core/utils/hooks','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{Component,useExternalListener,useRef}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{browser}=require("@web/core/browser/browser");class MessageSeenIndicatorDialog extends Component{static components={Dialog};static template="mail.MessageSeenIndicatorDialog";static props=["message","close?"];setup(){super.setup();this.contentRef=useRef("content");useExternalListener(browser,"click",(ev)=>{if(!this.contentRef?.el.contains(ev.target)){this.props.close();}},true);}}
const MessageSeenIndicator=__exports.MessageSeenIndicator=class MessageSeenIndicator extends Component{static template="mail.MessageSeenIndicator";static props=["message","thread","className?"];setup(){super.setup();this.dialog=useService("dialog");}
get summary(){if(this.props.message.hasEveryoneSeen){if(this.props.thread.channelMembers.length===2){return _t("Seen by %(user)s",{user:this.props.thread.correspondent.name});}
return _t("Seen by everyone");}
const seenMembers=this.props.message.channelMemberHaveSeen;const[user1,user2,user3]=seenMembers.map((member)=>member.name);switch(seenMembers.length){case 0:return _t("Sent");case 1:return _t("Seen by %(user)s",{user:user1});case 2:return _t("Seen by %(user1)s and %(user2)s",{user1,user2});case 3:return _t("Seen by %(user1)s, %(user2)s and %(user3)s",{user1,user2,user3});case 4:return _t("Seen by %(user1)s, %(user2)s, %(user3)s and 1 other",{user1,user2,user3,});default:return _t("Seen by %(user1)s, %(user2)s, %(user3)s and %(count)s others",{user1,user2,user3,count:seenMembers.length-3,});}}
openDialog(){if(this.props.message.channelMemberHaveSeen.length===0){return;}
this.dialog.add(MessageSeenIndicatorDialog,{message:this.props.message});}}
return __exports;});;

/* /mail/static/src/core/common/navigable_list.js */
odoo.define('@mail/core/common/navigable_list',['@mail/core/common/im_status','@mail/utils/common/hooks','@web/core/utils/misc','@odoo/owl','@web/core/hotkeys/hotkey_service','@web/core/position/position_hook','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{ImStatus}=require("@mail/core/common/im_status");const{onExternalClick}=require("@mail/utils/common/hooks");const{markEventHandled,isEventHandled}=require("@web/core/utils/misc");const{Component,useEffect,useExternalListener,useRef,useState}=require("@odoo/owl");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const{usePosition}=require("@web/core/position/position_hook");const{useService}=require("@web/core/utils/hooks");const NavigableList=__exports.NavigableList=class NavigableList extends Component{static components={ImStatus};static template="mail.NavigableList";static props={anchorRef:{optional:true},autoSelectFirst:{type:Boolean,optional:true},class:{type:String,optional:true},hint:{type:String,optional:true},onSelect:{type:Function},options:{type:Array},optionTemplate:{type:String,optional:true},position:{type:String,optional:true},isLoading:{type:Boolean,optional:true},};static defaultProps={position:"bottom",isLoading:false,autoSelectFirst:true};setup(){super.setup();this.rootRef=useRef("root");this.state=useState({activeIndex:null,open:false,showLoading:false,});this.hotkey=useService("hotkey");this.hotkeysToRemove=[];useExternalListener(window,"keydown",this.onKeydown,true);onExternalClick("root",async(ev)=>{await new Promise(setTimeout);if(isEventHandled(ev,"composer.onClickTextarea")||isEventHandled(ev,"channelSelector.onClickInput")){return;}
this.close();});usePosition("root",()=>this.props.anchorRef,{position:this.props.position});useEffect(()=>{this.open();},()=>[this.props]);useEffect(()=>{if(!this.props.isLoading){clearTimeout(this.loadingTimeoutId);this.state.showLoading=false;}else if(!this.loadingTimeoutId){this.loadingTimeoutId=setTimeout(()=>(this.state.showLoading=true),2000);}},()=>[this.props.isLoading]);}
get show(){return Boolean(this.state.open&&(this.props.isLoading||this.props.options.length));}
get sortedOptions(){return this.props.options.sort((o1,o2)=>(o1.group??0)-(o2.group??0));}
open(){this.state.open=true;this.state.activeIndex=null;if(this.props.autoSelectFirst){this.navigate("first");}}
close(){this.state.open=false;this.state.activeIndex=null;}
selectOption(ev,index,params={}){const option=this.props.options[index];if(option.unselectable){this.close();return;}
this.props.onSelect(ev,option,{...params,});this.close();}
navigate(direction){if(this.props.options.length===0){return;}
const activeOptionId=this.state.activeIndex!==null?this.state.activeIndex:0;let targetId=undefined;switch(direction){case"first":targetId=0;break;case"last":targetId=this.props.options.length-1;break;case"previous":targetId=activeOptionId-1;if(targetId<0){this.navigate("last");return;}
break;case"next":targetId=activeOptionId+1;if(targetId>this.props.options.length-1){this.navigate("first");return;}
break;default:return;}
this.state.activeIndex=targetId;}
onKeydown(ev){if(!this.show){return;}
const hotkey=getActiveHotkey(ev);switch(hotkey){case"enter":markEventHandled(ev,"NavigableList.select");if(this.state.activeIndex===null){this.close();return;}
this.selectOption(ev,this.state.activeIndex);break;case"escape":markEventHandled(ev,"NavigableList.close");this.close();break;case"tab":this.navigate(this.state.activeIndex===null?"first":"next");break;case"arrowup":this.navigate(this.state.activeIndex===null?"first":"previous");break;case"arrowdown":this.navigate(this.state.activeIndex===null?"first":"next");break;default:return;}
if(this.props.options.length!==0){ev.stopPropagation();}
ev.preventDefault();}
onOptionMouseEnter(index){}}
return __exports;});;

/* /mail/static/src/core/common/notification_model.js */
odoo.define('@mail/core/common/notification_model',['@mail/core/common/record','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{_t}=require("@web/core/l10n/translation");const Notification=__exports.Notification=class Notification extends Record{static id="id";static records={};static get(data){return super.get(data);}
static insert(data){return super.insert(...arguments);}
id;message=Record.one("Message",{onDelete(){this.delete();},});notification_status;notification_type;failure=Record.one("Failure",{inverse:"notifications",compute(){const thread=this.message?.thread;if(!this.message?.isSelfAuthored){return;}
const failure=Object.values(this.store.Failure.records).find((f)=>{return(f.resModel===thread?.model&&f.type===this.notification_type&&(f.resModel!=="discuss.channel"||f.resIds.has(thread?.id)));});return this.isFailure?{id:failure?failure.id:this.store.Failure.nextId.value++,}:false;},eager:true,});failure_type;persona=Record.one("Persona");get isFailure(){return["exception","bounce"].includes(this.notification_status);}
get icon(){if(this.isFailure){return"fa fa-envelope";}
return"fa fa-envelope-o";}
get label(){return"";}
get statusIcon(){switch(this.notification_status){case"process":return"fa fa-hourglass-half";case"pending":return"fa fa-paper-plane-o";case"sent":return"fa fa-check";case"bounce":return"fa fa-exclamation";case"exception":return"fa fa-exclamation";case"ready":return"fa fa-send-o";case"canceled":return"fa fa-trash-o";}
return"";}
get statusTitle(){switch(this.notification_status){case"process":return _t("Processing");case"pending":return _t("Sent");case"sent":return _t("Delivered");case"bounce":return _t("Bounced");case"exception":return _t("Error");case"ready":return _t("Ready");case"canceled":return _t("Cancelled");}
return"";}}
Notification.register();return __exports;});;

/* /mail/static/src/core/common/notification_permission_service.js */
odoo.define('@mail/core/common/notification_permission_service',['@odoo/owl','@web/core/browser/browser','@web/core/browser/feature_detection','@web/core/l10n/translation','@web/core/registry'],function(require){'use strict';let __exports={};const{reactive}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{isAndroidApp,isDisplayStandalone,isIOS,isIosApp,}=require("@web/core/browser/feature_detection");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");async function getIosPwaPermission(){if(browser.location.protocol!=="https:"){return"denied";}
const registration=await browser.navigator.serviceWorker?.getRegistration();return(await registration?.pushManager.permissionState())??"prompt";}
const notificationPermissionService=__exports.notificationPermissionService={dependencies:["notification"],_normalizePermission(permission){switch(permission){case"default":return"prompt";case undefined:return"denied";default:return permission;}},async start(env,services){const notification=services.notification;let permission;try{if(isIOS()&&isDisplayStandalone()){permission={state:await getIosPwaPermission()};}else if(isIOS()){permission={state:"denied"};}else{permission=await browser.navigator?.permissions?.query({name:"notifications",});}}catch{}
const state=reactive({permission:isIosApp()||isAndroidApp()?"denied":this._normalizePermission(permission?.state??browser.Notification?.permission),requestPermission:async()=>{if(browser.Notification&&state.permission==="prompt"){state.permission=this._normalizePermission(await browser.Notification.requestPermission());if(state.permission==="denied"){notification.add(_t("Odoo will not send notifications on this device."),{type:"warning",title:_t("Notifications blocked"),});}else if(state.permission==="granted"){notification.add(_t("Odoo will send notifications on this device!"),{type:"success",title:_t("Notifications allowed"),});}}},});if(permission&&!isIOS()){permission.addEventListener("change",()=>(state.permission=permission.state));}
return state;},};registry.category("services").add("mail.notification.permission",notificationPermissionService);return __exports;});;

/* /mail/static/src/core/common/out_of_focus_service.js */
odoo.define('@mail/core/common/out_of_focus_service',['@mail/utils/common/format','@web/core/browser/browser','@web/core/l10n/translation','@web/core/registry','@web/core/utils/urls'],function(require){'use strict';let __exports={};const{htmlToTextContentInline}=require("@mail/utils/common/format");const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{url}=require("@web/core/utils/urls");const PREVIEW_MSG_MAX_SIZE=350;const OutOfFocusService=__exports.OutOfFocusService=class OutOfFocusService{constructor(env,services){this.setup(env,services);}
setup(env,services){this.env=env;this.audio=undefined;this.multiTab=services.multi_tab;this.notificationService=services.notification;this.closeFuncs=[];}
async notify(message,thread){const modelsHandleByPush=["mail.thread","discuss.channel"];if(modelsHandleByPush.includes(message.thread?.model)&&(await this.hasServiceWorkInstalledAndPushSubscriptionActive())){return;}
const author=message.author;let notificationTitle;let icon="/mail/static/src/img/odoobot_transparent.png";if(!author){notificationTitle=_t("New message");}else{icon=author.avatarUrl;if(message.thread?.channel_type==="channel"){notificationTitle=_t("%(author name)s from %(channel name)s",{"author name":author.name,"channel name":message.thread.displayName,});}else{notificationTitle=author.name;}}
const notificationContent=htmlToTextContentInline(message.body).substring(0,PREVIEW_MSG_MAX_SIZE);this.sendNotification({message:notificationContent,sound:message.thread?.model==="discuss.channel",title:notificationTitle,type:"info",icon,});}
async hasServiceWorkInstalledAndPushSubscriptionActive(){const registration=await browser.navigator.serviceWorker?.getRegistration();if(registration){const pushManager=await registration.pushManager;if(pushManager){const subscription=await pushManager.getSubscription();return!!subscription;}}
return false;}
sendNotification({message,sound=true,title,type,icon}){if(!this.canSendNativeNotification){this.sendOdooNotification(message,{sound,title,type});return;}
if(!this.multiTab.isOnMainTab()){return;}
try{this.sendNativeNotification(title,message,icon,{sound});}catch(error){if(error.message.includes("ServiceWorkerRegistration")){this.sendOdooNotification(message,{sound,title,type});}else{throw error;}}}
async sendOdooNotification(message,options){const{sound}=options;delete options.sound;this.closeFuncs.push(this.notificationService.add(message,options));if(this.closeFuncs.length>3){this.closeFuncs.shift()();}
if(sound){this._playSound();}}
sendNativeNotification(title,message,icon,{sound=true}={}){const notification=new Notification(title,{body:message,icon,});notification.addEventListener("click",({target:notification})=>{window.focus();notification.close();});if(sound){this._playSound();}}
async _playSound(){if(this.canPlayAudio&&this.multiTab.isOnMainTab()){if(!this.audio){this.audio=new Audio();this.audio.src=this.audio.canPlayType("audio/ogg; codecs=vorbis")?url("/mail/static/src/audio/ting.ogg"):url("/mail/static/src/audio/ting.mp3");}
try{await this.audio.play();}catch{}}}
get canPlayAudio(){return typeof Audio!=="undefined";}
get canSendNativeNotification(){return Boolean(browser.Notification&&browser.Notification.permission==="granted");}}
const outOfFocusService=__exports.outOfFocusService={dependencies:["multi_tab","notification"],start(env,services){const service=new OutOfFocusService(env,services);return service;},};registry.category("services").add("mail.out_of_focus",outOfFocusService);return __exports;});;

/* /mail/static/src/core/common/partner_compare.js */
odoo.define('@mail/core/common/partner_compare',['@mail/utils/common/format','@web/core/registry'],function(require){'use strict';let __exports={};const{cleanTerm}=require("@mail/utils/common/format");const{registry}=require("@web/core/registry");const partnerCompareRegistry=__exports.partnerCompareRegistry=registry.category("mail.partner_compare");partnerCompareRegistry.add("mail.archived-last-except-odoobot",(p1,p2)=>{const p1active=p1.active||p1.eq(p1.store.odoobot);const p2active=p2.active||p2.eq(p2.store.odoobot);if(!p1active&&p2active){return 1;}
if(!p2active&&p1active){return-1;}},{sequence:5});partnerCompareRegistry.add("mail.internal-users",(p1,p2)=>{const isAInternalUser=p1.isInternalUser;const isBInternalUser=p2.isInternalUser;if(isAInternalUser&&!isBInternalUser){return-1;}
if(!isAInternalUser&&isBInternalUser){return 1;}},{sequence:35});partnerCompareRegistry.add("mail.followers",(p1,p2,{thread})=>{if(thread){const followerList=[...thread.followers];if(thread.selfFollower){followerList.push(thread.selfFollower);}
const isFollower1=followerList.some((follower)=>p1.eq(follower.partner));const isFollower2=followerList.some((follower)=>p2.eq(follower.partner));if(isFollower1&&!isFollower2){return-1;}
if(!isFollower1&&isFollower2){return 1;}}},{sequence:45});partnerCompareRegistry.add("mail.name",(p1,p2,{searchTerm})=>{const cleanedName1=cleanTerm(p1.name);const cleanedName2=cleanTerm(p2.name);if(cleanedName1.startsWith(searchTerm)&&!cleanedName2.startsWith(searchTerm)){return-1;}
if(!cleanedName1.startsWith(searchTerm)&&cleanedName2.startsWith(searchTerm)){return 1;}
if(cleanedName1<cleanedName2){return-1;}
if(cleanedName1>cleanedName2){return 1;}},{sequence:50});partnerCompareRegistry.add("mail.email",(p1,p2,{searchTerm})=>{const cleanedEmail1=cleanTerm(p1.email);const cleanedEmail2=cleanTerm(p2.email);if(cleanedEmail1.startsWith(searchTerm)&&!cleanedEmail1.startsWith(searchTerm)){return-1;}
if(!cleanedEmail2.startsWith(searchTerm)&&cleanedEmail2.startsWith(searchTerm)){return 1;}
if(cleanedEmail1<cleanedEmail2){return-1;}
if(cleanedEmail1>cleanedEmail2){return 1;}},{sequence:55});partnerCompareRegistry.add("mail.id",(p1,p2)=>{return p1.id-p2.id;},{sequence:75});return __exports;});;

/* /mail/static/src/core/common/persona_model.js */
odoo.define('@mail/core/common/persona_model',['@mail/core/common/record','@web/core/utils/urls','@web/core/network/rpc','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{AND,Record}=require("@mail/core/common/record");const{imageUrl}=require("@web/core/utils/urls");const{rpc}=require("@web/core/network/rpc");const{debounce}=require("@web/core/utils/timing");const Persona=__exports.Persona=class Persona extends Record{static id=AND("type","id");static records={};static get(data){return super.get(data);}
static insert(data){return super.insert(...arguments);}
static new(){const record=super.new(...arguments);record.debouncedSetImStatus=debounce((newStatus)=>record.updateImStatus(newStatus),this.IM_STATUS_DEBOUNCE_DELAY);return record;}
static IM_STATUS_DEBOUNCE_DELAY=1000;avatar_128_access_token;channelMembers=Record.many("ChannelMember");id;is_company;landlineNumber;mobileNumber;debouncedSetImStatus;storeAsTrackedImStatus=Record.one("Store",{compute(){if(this.type==="guest"||(this.type==="partner"&&this.im_status!=="im_partner"&&!this.is_public)){return this.store;}},onAdd(){if(!this.store.env.services.bus_service.isActive){return;}
const model=this.type==="partner"?"res.partner":"mail.guest";this.store.env.services.bus_service.addChannel(`odoo-presence-${model}_${this.id}`);},onDelete(){if(!this.store.env.services.bus_service.isActive){return;}
const model=this.type==="partner"?"res.partner":"mail.guest";this.store.env.services.bus_service.deleteChannel(`odoo-presence-${model}_${this.id}`);},eager:true,inverse:"imStatusTrackedPersonas",});type;name;country=Record.one("Country");email;userId;im_status=Record.attr(null,{onUpdate(){if(this.eq(this.store.self)&&this.im_status==="offline"){this.store.env.services.im_status.updateBusPresence();}},});notification_preference;isAdmin=false;isInternalUser=false;write_date=Record.attr(undefined,{type:"datetime"});groups_id=Record.many("res.groups",{inverse:"personas"});get hasPhoneNumber(){return Boolean(this.mobileNumber||this.landlineNumber);}
get emailWithoutDomain(){return this.email.substring(0,this.email.lastIndexOf("@"));}
get avatarUrl(){const accessTokenParam={};if(!this.store.self.isInternalUser){accessTokenParam.access_token=this.avatar_128_access_token;}
if(this.type==="partner"){return imageUrl("res.partner",this.id,"avatar_128",{...accessTokenParam,unique:this.write_date,});}
if(this.type==="guest"){return imageUrl("mail.guest",this.id,"avatar_128",{...accessTokenParam,unique:this.write_date,});}
if(this.userId){return imageUrl("res.users",this.userId,"avatar_128",{unique:this.write_date,});}
return this.store.DEFAULT_AVATAR;}
searchChat(){return Object.values(this.store.Thread.records).find((thread)=>thread.channel_type==="chat"&&thread.correspondent?.persona.eq(this));}
async updateGuestName(name){await rpc("/mail/guest/update_name",{guest_id:this.id,name,});}
updateImStatus(newStatus){this.im_status=newStatus;}}
Persona.register();return __exports;});;

/* /mail/static/src/core/common/picker.js */
odoo.define('@mail/core/common/picker',['@odoo/owl','@web/core/browser/browser','@web/core/utils/misc','@web/core/popover/popover_hook','@web/core/utils/hooks','@mail/core/common/picker_content','@mail/utils/common/hooks'],function(require){'use strict';let __exports={};const{Component,useExternalListener,useState}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{isEventHandled}=require("@web/core/utils/misc");const{usePopover}=require("@web/core/popover/popover_hook");const{useService}=require("@web/core/utils/hooks");const{PickerContent}=require("@mail/core/common/picker_content");const{useLazyExternalListener}=require("@mail/utils/common/hooks");__exports.usePicker=usePicker;function usePicker(setting){const storeScroll={scrollValue:0,set:(value)=>(storeScroll.scrollValue=value),get:()=>storeScroll.scrollValue,};const PICKERS={NONE:"none",EMOJI:"emoji",GIF:"gif",};return useState({PICKERS,anchor:setting.anchor,buttons:setting.buttons,close:setting.close,pickers:setting.pickers,position:setting.position,state:{picker:PICKERS.NONE,searchTerm:"",},storeScroll,});}
const Picker=__exports.Picker=class Picker extends Component{static components={PickerContent,};static props=["PICKERS","anchor?","buttons","close?","state","pickers","position?","storeScroll","fixed?",];static template="mail.Picker";setup(){this.ui=useState(useService("ui"));this.popover=usePopover(PickerContent,this.popoverSettings);useExternalListener(browser,"click",async(ev)=>{if(this.props.state.picker===this.props.PICKERS.NONE){return;}
await new Promise(setTimeout);if(!this.isEventHandledByPicker(ev)){this.close();}},true);for(const button of this.props.buttons){useLazyExternalListener(()=>button.el,"click",async(ev)=>this.toggle(this.props.anchor?.el??button.el,ev));}}
get popoverSettings(){return{popoverClass:"border-secondary",position:this.props.position,fixedPosition:this.props.fixed,onClose:()=>this.close(),closeOnClickAway:false,animation:false,arrow:false,};}
get contentProps(){const pickers={};for(const[name,fn]of Object.entries(this.props.pickers)){pickers[name]=(str,resetOnSelect)=>{fn(str);if(resetOnSelect){this.close();}};}
return{PICKERS:this.props.PICKERS,close:()=>this.close(),pickers,state:this.props.state,storeScroll:this.props.storeScroll,};}
isEventHandledByPicker(ev){return(isEventHandled(ev,"Composer.onClickAddEmoji")||isEventHandled(ev,"PickerContent.onClick"));}
async toggle(el,ev){await new Promise(setTimeout);if(this.ui.isSmall){if(this.props.state.picker===this.props.PICKERS.NONE){this.props.state.picker=this.props.PICKERS.EMOJI;}else{this.props.state.picker=this.props.PICKERS.NONE;}
return;}
if(isEventHandled(ev,"Composer.onClickAddEmoji")){if(this.popover.isOpen){if(this.props.state.picker===this.props.PICKERS.EMOJI){this.props.state.picker=this.props.PICKERS.NONE;this.popover.close();return;}
this.props.state.picker=this.props.PICKERS.EMOJI;}else{this.props.state.picker=this.props.PICKERS.EMOJI;this.popover.open(el,this.contentProps);}}}
close(){this.props.close?.();this.popover.close();this.props.state.picker=this.props.PICKERS.NONE;this.props.state.searchTerm="";}}
return __exports;});;

/* /mail/static/src/core/common/picker_content.js */
odoo.define('@mail/core/common/picker_content',['@odoo/owl','@web/core/utils/misc','@web/core/emoji_picker/emoji_picker'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{markEventHandled}=require("@web/core/utils/misc");const{EmojiPicker}=require("@web/core/emoji_picker/emoji_picker");const PickerContent=__exports.PickerContent=class PickerContent extends Component{static components={EmojiPicker};static props=["PICKERS","close","pickers","state","storeScroll"];static template="mail.PickerContent";onClick(ev){markEventHandled(ev,"PickerContent.onClick");}}
return __exports;});;

/* /mail/static/src/core/common/record.js */
odoo.define('@mail/core/common/record',['@mail/model/export'],function(require){'use strict';let __exports={};Object.assign(__exports,require("@mail/model/export"));return __exports;});;

/* /mail/static/src/core/common/relative_time.js */
odoo.define('@mail/core/common/relative_time',['@odoo/owl','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Component,onWillDestroy,onWillUpdateProps,xml}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const MINUTE=60*1000;const HOUR=60*MINUTE;const RelativeTime=__exports.RelativeTime=class RelativeTime extends Component{static props=["datetime"];static template=xml`<t t-esc="relativeTime"/>`;setup(){super.setup();this.timeout=null;this.computeRelativeTime(this.props.datetime);onWillDestroy(()=>clearTimeout(this.timeout));onWillUpdateProps((nextProps)=>{clearTimeout(this.timeout);this.computeRelativeTime(nextProps.datetime);});}
computeRelativeTime(datetime){if(!datetime){this.relativeTime="";return;}
const delta=Date.now()-datetime.ts;const absDelta=Math.abs(delta);if(absDelta<45*1000){this.relativeTime=delta<0?_t("in a few seconds"):_t("now");}else{this.relativeTime=datetime.toRelative();}
const updateDelay=absDelta<MINUTE?absDelta:absDelta<HOUR?MINUTE:HOUR;this.timeout=setTimeout(()=>{this.computeRelativeTime(this.props.datetime);this.render();},updateDelay);}}
return __exports;});;

/* /mail/static/src/core/common/res_groups_model.js */
odoo.define('@mail/core/common/res_groups_model',['@mail/core/common/record'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const ResGroups=__exports.ResGroups=class ResGroups extends Record{static _name="res.groups";static id="id";personas=Record.many("Persona");}
ResGroups.register();return __exports;});;

/* /mail/static/src/core/common/search_message_input.js */
odoo.define('@mail/core/common/search_message_input',['@odoo/owl','@web/core/browser/browser','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,useExternalListener,useState}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{useAutofocus}=require("@web/core/utils/hooks");const SearchMessageInput=__exports.SearchMessageInput=class SearchMessageInput extends Component{static template="mail.SearchMessageInput";static props=["closeSearch?","messageSearch","thread"];setup(){super.setup();this.state=useState({searchTerm:"",searchedTerm:""});useAutofocus();useExternalListener(browser,"keydown",(ev)=>{if(ev.key==="Escape"){this.props.closeSearch?.();}},{capture:true});}
search(){this.props.messageSearch.searchTerm=this.state.searchTerm;this.props.messageSearch.search();this.state.searchedTerm=this.state.searchTerm;}
clear(){this.state.searchTerm="";this.state.searchedTerm=this.state.searchTerm;this.props.messageSearch.clear();this.props.closeSearch?.();}
onKeydownSearch(ev){if(ev.key!=="Enter"){return;}
if(!this.state.searchTerm){this.clear();}else{this.search();}}}
return __exports;});;

/* /mail/static/src/core/common/search_message_result.js */
odoo.define('@mail/core/common/search_message_result',['@odoo/owl','@mail/core/common/message_card_list','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{MessageCardList}=require("@mail/core/common/message_card_list");const{_t}=require("@web/core/l10n/translation");const SearchMessageResult=__exports.SearchMessageResult=class SearchMessageResult extends Component{static template="mail.SearchMessageResult";static components={MessageCardList};static props=["thread","messageSearch","onClickJump?"];get MESSAGE_FOUND(){if(this.props.messageSearch.messages.length===0){return false;}
return _t("%s messages found",this.props.messageSearch.count);}
onLoadMoreVisible(){const before=this.props.messageSearch?.messages?Math.min(...this.props.messageSearch.messages.map((message)=>message.id)):false;this.props.messageSearch.search(before);}}
return __exports;});;

/* /mail/static/src/core/common/search_messages_panel.js */
odoo.define('@mail/core/common/search_messages_panel',['@odoo/owl','@mail/discuss/core/common/action_panel','@web/core/l10n/translation','@web/core/utils/hooks','@mail/core/common/search_message_input','@mail/core/common/search_message_result','@mail/core/common/message_search_hook'],function(require){'use strict';let __exports={};const{Component,useState,onWillUpdateProps}=require("@odoo/owl");const{ActionPanel}=require("@mail/discuss/core/common/action_panel");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{SearchMessageInput}=require("@mail/core/common/search_message_input");const{SearchMessageResult}=require("@mail/core/common/search_message_result");const{useMessageSearch}=require("@mail/core/common/message_search_hook");const SearchMessagesPanel=__exports.SearchMessagesPanel=class SearchMessagesPanel extends Component{static template="mail.SearchMessagesPanel";static components={ActionPanel,SearchMessageInput,SearchMessageResult};static props=["thread"];setup(){super.setup();this.store=useState(useService("mail.store"));this.messageSearch=useMessageSearch(this.props.thread);onWillUpdateProps((nextProps)=>{if(this.props.thread.notEq(nextProps.thread)){this.env.searchMenu?.close();}});}
get title(){return _t("Search Message");}}
return __exports;});;

/* /mail/static/src/core/common/settings_model.js */
odoo.define('@mail/core/common/settings_model',['@web/core/l10n/translation','@web/core/utils/strings','@web/core/browser/browser','@mail/core/common/record','@web/core/utils/timing','@web/core/network/rpc'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{sprintf}=require("@web/core/utils/strings");const{browser}=require("@web/core/browser/browser");const{Record}=require("@mail/core/common/record");const{debounce}=require("@web/core/utils/timing");const{rpc}=require("@web/core/network/rpc");const Settings=__exports.Settings=class Settings extends Record{id;setup(){super.setup();this.saveVoiceThresholdDebounce=debounce(()=>{browser.localStorage.setItem("mail_user_setting_voice_threshold",this.voiceActivationThreshold.toString());},2000);this.hasCanvasFilterSupport=typeof document.createElement("canvas").getContext("2d").filter!=="undefined";this._loadLocalSettings();}
channel_notifications=Record.attr("mentions",{compute(){return this.channel_notifications===false?"mentions":this.channel_notifications;},});mute_until_dt=Record.attr(false,{type:"datetime"});audioInputDeviceId="";use_push_to_talk=false;voice_active_duration=200;volumes=Record.many("Volume");volumeSettingsTimeouts=new Map();voiceActivationThreshold=0.05;isRegisteringKey=false;push_to_talk_key;backgroundBlurAmount=10;edgeBlurAmount=10;showOnlyVideo=false;useBlur=false;logRtc=false;get audioConstraints(){const constraints={echoCancellation:true,noiseSuppression:true,};if(this.audioInputDeviceId){constraints.deviceId=this.audioInputDeviceId;}
return constraints;}
get NOTIFICATIONS(){return[{label:"all",name:_t("All Messages"),},{label:"mentions",name:_t("Mentions Only"),},{label:"no_notif",name:_t("Nothing"),},];}
get MUTES(){return[{label:"15_mins",value:15,name:_t("For 15 minutes"),},{label:"1_hour",value:60,name:_t("For 1 hour"),},{label:"3_hours",value:180,name:_t("For 3 hours"),},{label:"8_hours",value:480,name:_t("For 8 hours"),},{label:"24_hours",value:1440,name:_t("For 24 hours"),},{label:"forever",value:-1,name:_t("Until I turn it back on"),},];}
getMuteUntilText(dt){if(dt){return dt.year<=luxon.DateTime.now().year+2?sprintf(_t(`Until %s`),dt.toLocaleString(luxon.DateTime.DATETIME_MED)):_t("Until I turn it back on");}
return undefined;}
async setCustomNotifications(custom_notifications,thread=undefined){return rpc("/discuss/settings/custom_notifications",{custom_notifications:!thread&&custom_notifications==="mentions"?false:custom_notifications,channel_id:thread?.id,});}
async setMuteDuration(minutes,thread=undefined){return rpc("/discuss/settings/mute",{minutes,channel_id:thread?.id,});}
async setAudioInputDevice(audioInputDeviceId){this.audioInputDeviceId=audioInputDeviceId;browser.localStorage.setItem("mail_user_setting_audio_input_device_id",audioInputDeviceId);}
setDelayValue(value){this.voice_active_duration=parseInt(value,10);this._saveSettings();}
async setPushToTalkKey(ev){const nonElligibleKeys=new Set(["Shift","Control","Alt","Meta"]);let pushToTalkKey=`${ev.shiftKey || ""}.${ev.ctrlKey || ev.metaKey || ""}.${
            ev.altKey || ""
        }`;if(!nonElligibleKeys.has(ev.key)){pushToTalkKey+=`.${ev.key === " " ? "Space" : ev.key}`;}
this.push_to_talk_key=pushToTalkKey;this._saveSettings();}
async saveVolumeSetting({partnerId,guestId,volume}){if(this.store.self.type!=="partner"){return;}
const key=`${partnerId}_${guestId}`;if(this.volumeSettingsTimeouts.get(key)){browser.clearTimeout(this.volumeSettingsTimeouts.get(key));}
this.volumeSettingsTimeouts.set(key,browser.setTimeout(this._onSaveVolumeSettingTimeout.bind(this,{key,partnerId,guestId,volume}),5000));}
setThresholdValue(voiceActivationThreshold){this.voiceActivationThreshold=voiceActivationThreshold;this.saveVoiceThresholdDebounce();}
buildKeySet({shiftKey,ctrlKey,altKey,key}){const keys=new Set();if(key){keys.add(key==="Meta"?"Alt":key);}
if(shiftKey){keys.add("Shift");}
if(ctrlKey){keys.add("Control");}
if(altKey){keys.add("Alt");}
return keys;}
isPushToTalkKey(ev){if(!this.use_push_to_talk||!this.push_to_talk_key){return false;}
const[shiftKey,ctrlKey,altKey,key]=this.push_to_talk_key.split(".");const settingsKeySet=this.buildKeySet({shiftKey,ctrlKey,altKey,key});const eventKeySet=this.buildKeySet({shiftKey:ev.shiftKey,ctrlKey:ev.ctrlKey,altKey:ev.altKey,key:ev.key,});if(ev.type==="keydown"){return[...settingsKeySet].every((key)=>eventKeySet.has(key));}
return settingsKeySet.has(ev.key==="Meta"?"Alt":ev.key);}
pushToTalkKeyFormat(){if(!this.push_to_talk_key){return;}
const[shiftKey,ctrlKey,altKey,key]=this.push_to_talk_key.split(".");return{shiftKey:!!shiftKey,ctrlKey:!!ctrlKey,altKey:!!altKey,key:key||false,};}
setPushToTalk(value){this.use_push_to_talk=value;this._saveSettings();}
_loadLocalSettings(){const voiceActivationThresholdString=browser.localStorage.getItem("mail_user_setting_voice_threshold");this.voiceActivationThreshold=voiceActivationThresholdString?parseFloat(voiceActivationThresholdString):this.voiceActivationThreshold;this.audioInputDeviceId=browser.localStorage.getItem("mail_user_setting_audio_input_device_id");this.showOnlyVideo=browser.localStorage.getItem("mail_user_setting_show_only_video")==="true";this.useBlur=browser.localStorage.getItem("mail_user_setting_use_blur")==="true";const backgroundBlurAmount=browser.localStorage.getItem("mail_user_setting_background_blur_amount");this.backgroundBlurAmount=backgroundBlurAmount?parseInt(backgroundBlurAmount):10;const edgeBlurAmount=browser.localStorage.getItem("mail_user_setting_edge_blur_amount");this.edgeBlurAmount=edgeBlurAmount?parseInt(edgeBlurAmount):10;}
async _onSaveGlobalSettingsTimeout(){this.globalSettingsTimeout=undefined;await this.store.env.services.orm.call("res.users.settings","set_res_users_settings",[[this.id]],{new_settings:{push_to_talk_key:this.push_to_talk_key,use_push_to_talk:this.use_push_to_talk,voice_active_duration:this.voice_active_duration,},});}
async _onSaveVolumeSettingTimeout({key,partnerId,guestId,volume}){this.volumeSettingsTimeouts.delete(key);await this.store.env.services.orm.call("res.users.settings","set_volume_setting",[[this.id],partnerId,volume],{guest_id:guestId});}
async _saveSettings(){if(this.store.self.type!=="partner"){return;}
browser.clearTimeout(this.globalSettingsTimeout);this.globalSettingsTimeout=browser.setTimeout(()=>this._onSaveGlobalSettingsTimeout(),2000);}}
Settings.register();return __exports;});;

/* /mail/static/src/core/common/sound_effects_service.js */
odoo.define('@mail/core/common/sound_effects_service',['@web/core/browser/browser','@web/core/registry','@web/core/utils/urls'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{url}=require("@web/core/utils/urls");const SoundEffects=__exports.SoundEffects=class SoundEffects{constructor(env){this.soundEffects={"channel-join":{defaultVolume:0.3,path:"/mail/static/src/audio/channel_01_in"},"channel-leave":{path:"/mail/static/src/audio/channel_04_out"},deafen:{defaultVolume:0.15,path:"/mail/static/src/audio/deafen_new_01"},"incoming-call":{defaultVolume:0.15,path:"/mail/static/src/audio/call_02_in_"},"member-leave":{defaultVolume:0.5,path:"/mail/static/src/audio/channel_01_out"},mute:{defaultVolume:0.2,path:"/mail/static/src/audio/mute_1"},"new-message":{path:"/mail/static/src/audio/dm_02"},"push-to-talk-on":{defaultVolume:0.02,path:"/mail/static/src/audio/ptt_push_1"},"push-to-talk-off":{defaultVolume:0.02,path:"/mail/static/src/audio/ptt_release_1",},"screen-sharing":{defaultVolume:0.5,path:"/mail/static/src/audio/share_02"},undeafen:{defaultVolume:0.15,path:"/mail/static/src/audio/undeafen_new_01"},unmute:{defaultVolume:0.2,path:"/mail/static/src/audio/unmute_1"},};}
play(soundEffectName,{loop=false,volume}={}){if(typeof browser.Audio==="undefined"){return;}
const soundEffect=this.soundEffects[soundEffectName];if(!soundEffect){return;}
if(!soundEffect.audio){const audio=new browser.Audio();const ext=audio.canPlayType("audio/ogg; codecs=vorbis")?".ogg":".mp3";audio.src=url(soundEffect.path+ext);soundEffect.audio=audio;}
if(!soundEffect.audio.paused){soundEffect.audio.pause();}
soundEffect.audio.currentTime=0;soundEffect.audio.loop=loop;soundEffect.audio.volume=volume??soundEffect.defaultVolume??1;Promise.resolve(soundEffect.audio.play()).catch(()=>{});}
stop(soundEffectName){const soundEffect=this.soundEffects[soundEffectName];if(soundEffect){if(soundEffect.audio){soundEffect.audio.pause();soundEffect.audio.currentTime=0;}}else{for(const soundEffect of Object.values(this.soundEffects)){if(soundEffect.audio){soundEffect.audio.pause();soundEffect.audio.currentTime=0;}}}}}
const soundEffects=__exports.soundEffects={start(env){return new SoundEffects(env);},};registry.category("services").add("mail.sound_effects",soundEffects);return __exports;});;

/* /mail/static/src/core/common/store_service.js */
odoo.define('@mail/core/common/store_service',['@mail/utils/common/misc','@web/core/network/rpc','@mail/core/common/record','@odoo/owl','@web/core/registry','@web/core/user','@web/core/utils/concurrency','@web/core/utils/timing','@web/session','@web/core/l10n/translation','@mail/utils/common/format','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{compareDatetime}=require("@mail/utils/common/misc");const{rpc}=require("@web/core/network/rpc");const{Store:BaseStore,makeStore,Record}=require("@mail/core/common/record");const{reactive}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{Deferred,Mutex}=require("@web/core/utils/concurrency");const{debounce}=require("@web/core/utils/timing");const{session}=require("@web/session");const{_t}=require("@web/core/l10n/translation");const{cleanTerm,prettifyMessageContent}=require("@mail/utils/common/format");const{browser}=require("@web/core/browser/browser");let prevLastMessageId=null;let temporaryIdOffset=0.01;const pyToJsModels=__exports.pyToJsModels={"discuss.channel.member":"ChannelMember","discuss.channel.rtc.session":"RtcSession","discuss.channel":"Thread","ir.attachment":"Attachment","mail.activity":"Activity","mail.guest":"Persona","mail.followers":"Follower","mail.link.preview":"LinkPreview","mail.message":"Message","mail.notification":"Notification","mail.scheduled.message":"ScheduledMessage","mail.thread":"Thread","res.partner":"Persona",};const addFieldsByPyModel=__exports.addFieldsByPyModel={"discuss.channel":{model:"discuss.channel"},"mail.guest":{type:"guest"},"res.partner":{type:"partner"},};const Store=__exports.Store=class Store extends BaseStore{static FETCH_DATA_DEBOUNCE_DELAY=1;static OTHER_LONG_TYPING=60000;FETCH_LIMIT=30;DEFAULT_AVATAR="/mail/static/src/img/smiley/avatar.jpg";isReady=new Deferred();static insert(){return super.insert(...arguments);}
Activity;Attachment;["mail.canned.response"];ChannelMember;ChatWindow;Composer;Failure;Follower;LinkPreview;Message;MessageReactions;Notification;Persona;["res.groups"];ScheduledMessage;Settings;Thread;Volume;channel_types_with_seen_infos=[];self=Record.one("Persona");inPublicPage=false;odoobot=Record.one("Persona");users={};internalUserGroupId;mt_comment_id;hasMessageTranslationFeature;imStatusTrackedPersonas=Record.many("Persona",{inverse:"storeAsTrackedImStatus",});hasLinkPreviewFeature=true;menu={counter:0};chatHub=Record.one("ChatHub",{compute:()=>({})});failures=Record.many("Failure",{sort:(f1,f2)=>f2.lastMessage?.id-f1.lastMessage?.id,});settings=Record.one("Settings");openInviteThread=Record.one("Thread");fetchDeferred=new Deferred();fetchParams={};fetchReadonly=true;fetchSilent=true;cannedReponses=this.makeCachedFetchData({canned_responses:true});specialMentions=[{isSpecial:true,label:"everyone",channel_types:["channel","group"],displayName:"Everyone",description:_t("Notify everyone"),},];get initMessagingParams(){return{init_messaging:{},};}
isNotificationPermissionDismissed=Record.attr(false,{compute(){return(browser.localStorage.getItem("mail.user_setting.push_notification_dismissed")==="true");},onUpdate(){if(this.isNotificationPermissionDismissed){browser.localStorage.setItem("mail.user_setting.push_notification_dismissed","true");}else{browser.localStorage.removeItem("mail.user_setting.push_notification_dismissed");}},});messagePostMutex=new Mutex();menuThreads=Record.many("Thread",{compute(){const searchTerm=cleanTerm(this.discuss.searchTerm);let threads=Object.values(this.Thread.records).filter((thread)=>(thread.displayToSelf||(thread.needactionMessages.length>0&&thread.model!=="mail.box"))&&cleanTerm(thread.displayName).includes(searchTerm));const tab=this.discuss.activeTab;if(tab!=="main"){threads=threads.filter(({channel_type})=>this.tabToThreadType(tab).includes(channel_type));}else if(tab==="main"&&this.env.inDiscussApp){threads=threads.filter(({channel_type})=>this.tabToThreadType("mailbox").includes(channel_type));}
return threads;},sort(a,b){const aNeedaction=a.needactionMessages.length;const bNeedaction=b.needactionMessages.length;if(aNeedaction>0&&bNeedaction===0){return-1;}
if(bNeedaction>0&&aNeedaction===0){return 1;}
const aUnread=a.selfMember?.message_unread_counter;const bUnread=b.selfMember?.message_unread_counter;if(aUnread>0&&bUnread===0){return-1;}
if(bUnread>0&&aUnread===0){return 1;}
const aMessageDatetime=a.newestPersistentNotEmptyOfAllMessage?.datetime;const bMessageDateTime=b.newestPersistentNotEmptyOfAllMessage?.datetime;if(!aMessageDatetime&&bMessageDateTime){return 1;}
if(!bMessageDateTime&&aMessageDatetime){return-1;}
if(aMessageDatetime&&bMessageDateTime&&aMessageDatetime!==bMessageDateTime){return bMessageDateTime-aMessageDatetime;}
return b.localId>a.localId?1:-1;},});async doMessagePost(params,tmpMessage){return this.messagePostMutex.exec(async()=>{let res;try{res=await rpc("/mail/message/post",params,{silent:true});}catch(err){if(!tmpMessage){throw err;}
tmpMessage.postFailRedo=()=>{tmpMessage.postFailRedo=undefined;tmpMessage.thread.messages.delete(tmpMessage);tmpMessage.thread.messages.add(tmpMessage);this.doMessagePost(params,tmpMessage);};}
return res;});}
async fetchData(params,{readonly=true,silent=true}={}){Object.assign(this.fetchParams,params);this.fetchReadonly=this.fetchReadonly&&readonly;this.fetchSilent=this.fetchSilent&&silent;const fetchDeferred=this.fetchDeferred;this._fetchDataDebounced();return fetchDeferred;}
async initialize(){await this.fetchData(this.initMessagingParams);this.isReady.resolve();}
makeCachedFetchData(params){let def=null;const r=reactive({status:"not_fetched",fetch:()=>{if(["fetching","fetched"].includes(r.status)){return def;}
r.status="fetching";def=new Deferred();this.fetchData(params).then((result)=>{r.status="fetched";def.resolve(result);},(error)=>{r.status="not_fetched";def.reject(error);});return def;},});return r;}
async _fetchDataDebounced(){const fetchDeferred=this.fetchDeferred;this.fetchParams.context={...user.context,...this.fetchParams.context,};rpc(this.fetchReadonly?"/mail/data":"/mail/action",this.fetchParams,{silent:this.fetchSilent,}).then((data)=>{const recordsByModel=this.insert(data,{html:true});fetchDeferred.resolve(recordsByModel);},(error)=>fetchDeferred.reject(error));this.fetchDeferred=new Deferred();this.fetchParams={};this.fetchReadonly=true;this.fetchSilent=true;}
insert(dataByModelName={},options={}){const store=this;const pyModels=Object.values(pyToJsModels);return Record.MAKE_UPDATE(function storeInsert(){const res={};const recordsDataToDelete=[];for(const[pyOrJsModelName,data]of Object.entries(dataByModelName)){if(pyModels.includes(pyOrJsModelName)){console.warn(`store.insert() should receive the python model name instead of “${pyOrJsModelName}”.`);}
const modelName=pyToJsModels[pyOrJsModelName]||pyOrJsModelName;if(!store[modelName]){console.warn(`store.insert() received data for unknown model “${modelName}”.`);continue;}
const insertData=[];for(const vals of Array.isArray(data)?data:[data]){const extraFields=addFieldsByPyModel[pyOrJsModelName];if(extraFields){Object.assign(vals,extraFields);}
if(vals._DELETE){delete vals._DELETE;recordsDataToDelete.push([modelName,vals]);}else{insertData.push(vals);}}
const records=store[modelName].insert(insertData,options);if(!res[modelName]){res[modelName]=records;}else{const knownRecordIds=new Set(res[modelName].map((r)=>r.localId));res[modelName].push(...records.filter((r)=>!knownRecordIds.has(r.localId)));}}
for(const[modelName,vals]of recordsDataToDelete){store[modelName].get(vals)?.delete();}
return res;});}
async startMeeting(){const thread=await this.env.services["discuss.core.common"].createGroupChat({default_display_mode:"video_full_screen",partners_to:[this.self.id],});this.ChatWindow.get(thread)?.update({autofocus:0});this.env.services["discuss.rtc"].toggleCall(thread,{camera:true});this.openInviteThread=thread;}
tabToThreadType(tab){return tab==="chat"?["chat","group"]:[tab];}
handleClickOnLink(ev,thread){const model=ev.target.dataset.oeModel;const id=Number(ev.target.dataset.oeId);if(ev.target.closest(".o_channel_redirect")&&model&&id){ev.preventDefault();this.Thread.getOrFetch({model,id}).then((thread)=>{if(thread){thread.open();}});return true;}else if(ev.target.closest(".o_mail_redirect")&&id){ev.preventDefault();this.openChat({partnerId:id});return true;}
return false;}
setup(){super.setup();this._fetchDataDebounced=debounce(this._fetchDataDebounced,Store.FETCH_DATA_DEBOUNCE_DELAY);this.updateBusSubscription=debounce(()=>this.env.services.bus_service.forceUpdateChannels(),0);}
onStarted(){}
async getChat({userId,partnerId}){const partner=await this.getPartner({userId,partnerId});let chat=partner?.searchChat();if(!chat||!chat.is_pinned){chat=await this.joinChat(partnerId||partner?.id);}
if(!chat){this.env.services.notification.add(_t("An unexpected error occurred during the creation of the chat."),{type:"warning"});return;}
return chat;}
getLastMessageId(){return Object.values(this.Message.records).reduce((lastMessageId,message)=>Math.max(lastMessageId,message.id),0);}
getMentionsFromText(body,{mentionedChannels=[],mentionedPartners=[],specialMentions=[]}={}){const validMentions={};validMentions.threads=mentionedChannels.filter((thread)=>{if(thread.parent_channel_id){return body.includes(`#${thread.parent_channel_id.displayName} > ${thread.displayName}`);}
return body.includes(`#${thread.displayName}`);});validMentions.partners=mentionedPartners.filter((partner)=>body.includes(`@${partner.name}`));validMentions.specialMentions=this.specialMentions.filter((special)=>body.includes(`@${special.label}`)).map((special)=>special.label);return validMentions;}
async getMessagePostParams({body,postData,thread}){const{attachments,cannedResponseIds,emailAddSignature,isNote,mentionedChannels,mentionedPartners,}=postData;const subtype=isNote?"mail.mt_note":"mail.mt_comment";const validMentions=this.getMentionsFromText(body,{mentionedChannels,mentionedPartners,});const partner_ids=validMentions?.partners.map((partner)=>partner.id)??[];const recipientEmails=[];const recipientAdditionalValues={};if(!isNote){const recipientIds=thread.suggestedRecipients.filter((recipient)=>recipient.persona&&recipient.checked).map((recipient)=>recipient.persona.id);thread.suggestedRecipients.filter((recipient)=>recipient.checked&&!recipient.persona).forEach((recipient)=>{recipientEmails.push(recipient.email);recipientAdditionalValues[recipient.email]=recipient.create_values;});partner_ids.push(...recipientIds);}
postData={body:await prettifyMessageContent(body,validMentions),email_add_signature:emailAddSignature,message_type:"comment",subtype_xmlid:subtype,};if(attachments.length){postData.attachment_ids=attachments.map(({id})=>id);}
if(partner_ids.length){Object.assign(postData,{partner_ids});}
if(thread.model==="discuss.channel"&&validMentions?.specialMentions.length){postData.special_mentions=validMentions.specialMentions;}
const params={context:{mail_post_autofollow:!isNote&&thread.hasWriteAccess,},post_data:postData,thread_id:thread.id,thread_model:thread.model,};if(attachments.length){params.attachment_tokens=attachments.map((attachment)=>attachment.access_token);}
if(cannedResponseIds?.length){params.canned_response_ids=cannedResponseIds;}
if(recipientEmails.length){Object.assign(params,{partner_emails:recipientEmails,partner_additional_values:recipientAdditionalValues,});}
return params;}
getNextTemporaryId(){const lastMessageId=this.getLastMessageId();if(prevLastMessageId===lastMessageId){temporaryIdOffset+=0.01;}else{prevLastMessageId=lastMessageId;temporaryIdOffset=0.01;}
return lastMessageId+temporaryIdOffset;}
async getPartner({userId,partnerId}){if(userId){let user=this.users[userId];if(!user){this.users[userId]={id:userId};user=this.users[userId];}
if(!user.partner_id){const[userData]=await this.env.services.orm.silent.read("res.users",[user.id],["partner_id"],{context:{active_test:false}});if(userData){user.partner_id=userData.partner_id[0];}}
if(!user.partner_id){this.env.services.notification.add(_t("You can only chat with existing users."),{type:"warning",});return;}
partnerId=user.partner_id;}
if(partnerId){const partner=this.Persona.insert({id:partnerId,type:"partner"});if(!partner.userId){const[userId]=await this.env.services.orm.silent.search("res.users",[["partner_id","=",partnerId]],{context:{active_test:false}});if(!userId){this.env.services.notification.add(_t("You can only chat with partners that have a dedicated user."),{type:"info"});return;}
partner.userId=userId;}
return partner;}}
getRecentChatPartnerIds(){return Object.values(this.Thread.records).filter((thread)=>thread.channel_type==="chat"&&thread.correspondent).sort((a,b)=>compareDatetime(b.lastInterestDt,a.lastInterestDt)||b.id-a.id).map((thread)=>thread.correspondent.persona.id);}
async joinChannel(id,name){await this.env.services.orm.call("discuss.channel","add_members",[[id]],{partner_ids:[this.self.id],});const thread=this.Thread.insert({channel_type:"channel",id,model:"discuss.channel",name,});if(!thread.avatarCacheKey){thread.avatarCacheKey="hello";}
thread.open();return thread;}
async joinChat(id,forceOpen=false){const data=await this.env.services.orm.call("discuss.channel","channel_get",[],{partners_to:[id],force_open:forceOpen,});const{Thread}=this.store.insert(data);return Thread[0];}
async openChat(person){const chat=await this.getChat(person);chat?.open();}
openDocument({id,model}){this.env.services.action.doAction({type:"ir.actions.act_window",res_model:model,views:[[false,"form"]],res_id:id,});}
openNewMessage(){let cw=this.ChatWindow.get({thread:undefined});if(cw){cw.focus();return;}
cw=this.ChatWindow.insert({thread:undefined,fromMessagingMenu:true});this.chatHub.opened.unshift(cw);cw.focus();}
async search(searchTerm,thread,before=false){const{count,data,messages}=await rpc(thread.getFetchRoute(),{...thread.getFetchParams(),search_term:await prettifyMessageContent(searchTerm),before,});this.insert(data,{html:true});return{count,loadMore:messages.length===this.FETCH_LIMIT,messages:this.Message.insert(messages),};}
async searchPartners(searchStr="",limit=10){const partners=[];const searchTerm=cleanTerm(searchStr);for(const localId in this.Persona.records){const persona=this.Persona.records[localId];if(persona.type!=="partner"){continue;}
const partner=persona;if(partner.name&&cleanTerm(partner.name).includes(searchTerm)&&((partner.active&&partner.userId)||partner===this.store.odoobot)){partners.push(partner);if(partners.length>=limit){break;}}}
if(!partners.length){const data=await this.env.services.orm.silent.call("res.partner","im_search",[searchTerm,limit,]);const{Persona=[]}=this.store.insert(data);partners.push(...Persona);}
return partners;}}
Store.register();const storeService=__exports.storeService={dependencies:["bus_service","im_status","ui"],start(env,services){const store=makeStore(env);store.insert(session.storeData);store.self??={id:-1,type:"guest"};store.settings??={};store.initialize();store.onStarted();return store;},};registry.category("services").add("mail.store",storeService);return __exports;});;

/* /mail/static/src/core/common/suggestion_hook.js */
odoo.define('@mail/core/common/suggestion_hook',['@odoo/owl','@web/core/network/rpc','@web/core/utils/hooks','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{status,useComponent,useEffect,useState}=require("@odoo/owl");const{ConnectionAbortedError}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{useDebounced}=require("@web/core/utils/timing");class UseSuggestion{constructor(comp){this.comp=comp;this.fetchSuggestions=useDebounced(this.fetchSuggestions.bind(this),250);useEffect(()=>{this.update();if(this.search.position===undefined||!this.search.delimiter){return;}
if(this.composer.store.self.type!=="partner"){return;}
if(this.lastFetchedSearch?.count===0&&(!this.search.delimiter||this.isSearchMoreSpecificThanLastFetch)){return;}
this.fetchSuggestions();},()=>[this.search.delimiter,this.search.position,this.search.term]);useEffect(()=>{this.detect();},()=>[this.composer.selection.start,this.composer.selection.end,this.composer.text]);}
comp;get composer(){return this.comp.props.composer;}
suggestionService=useService("mail.suggestion");state=useState({count:0,items:undefined,isFetching:false,});search={delimiter:undefined,position:undefined,term:"",};lastFetchedSearch;get isSearchMoreSpecificThanLastFetch(){return(this.lastFetchedSearch.delimiter===this.search.delimiter&&this.search.term.startsWith(this.lastFetchedSearch.term)&&this.lastFetchedSearch.position>=this.search.position);}
clearRawMentions(){this.composer.mentionedChannels.length=0;this.composer.mentionedPartners.length=0;}
clearCannedResponses(){this.composer.cannedResponses=[];}
clearSearch(){Object.assign(this.search,{delimiter:undefined,position:undefined,term:"",});this.state.items=undefined;}
detect(){const{start,end}=this.composer.selection;const text=this.composer.text;if(start!==end){this.clearSearch();return;}
const candidatePositions=[];let numberOfSpaces=0;for(let index=start-1;index>=0;--index){if(/\s/.test(text[index])){numberOfSpaces++;if(numberOfSpaces===2){break;}}
candidatePositions.push(index);}
if(this.search.position!==undefined&&this.search.position<start){candidatePositions.push(this.search.position);}
const supportedDelimiters=this.suggestionService.getSupportedDelimiters(this.thread);for(const candidatePosition of candidatePositions){if(candidatePosition<0||candidatePosition>=text.length){continue;}
const candidateChar=text[candidatePosition];if(!supportedDelimiters.find(([delimiter,allowedPosition])=>delimiter===candidateChar&&(allowedPosition===undefined||allowedPosition===candidatePosition))){continue;}
const charBeforeCandidate=text[candidatePosition-1];if(charBeforeCandidate&&!/\s/.test(charBeforeCandidate)){continue;}
Object.assign(this.search,{delimiter:candidateChar,position:candidatePosition,term:text.substring(candidatePosition+1,start),});this.state.count++;return;}
this.clearSearch();}
get thread(){return this.composer.thread||this.composer.message.thread;}
insert(option){const position=this.composer.selection.start;const text=this.composer.text;let before=text.substring(0,this.search.position+1);let after=text.substring(position,text.length);if(this.search.delimiter===":"){before=text.substring(0,this.search.position);after=text.substring(position,text.length);}
if(option.partner){this.composer.mentionedPartners.add({id:option.partner.id,type:"partner",});}
if(option.thread){this.composer.mentionedChannels.add({model:"discuss.channel",id:option.thread.id,});}
if(option.cannedResponse){this.composer.cannedResponses.push(option.cannedResponse);}
this.clearSearch();this.composer.text=before+option.label+" "+after;this.composer.selection.start=before.length+option.label.length+1;this.composer.selection.end=before.length+option.label.length+1;this.composer.forceCursorMove=true;}
update(){if(!this.search.delimiter){return;}
const{type,suggestions}=this.suggestionService.searchSuggestions(this.search,{thread:this.thread,sort:true,});if(!suggestions.length){this.state.items=undefined;return;}
const limit=8;suggestions.length=Math.min(suggestions.length,limit);this.state.items={type,suggestions};}
async fetchSuggestions(){let resetFetchingState=true;try{this.abortController?.abort();this.abortController=new AbortController();this.state.isFetching=true;await this.suggestionService.fetchSuggestions(this.search,{thread:this.thread,abortSignal:this.abortController.signal,});}catch(e){this.lastFetchedSearch=null;if(e instanceof ConnectionAbortedError){resetFetchingState=false;return;}
throw e;}finally{if(resetFetchingState){this.state.isFetching=false;}}
if(status(this.comp)==="destroyed"){return;}
this.update();this.lastFetchedSearch={...this.search,count:this.state.items?.suggestions.length??0,};if(!this.state.items?.suggestions.length){this.clearSearch();}}}
__exports.useSuggestion=useSuggestion;function useSuggestion(){return new UseSuggestion(useComponent());}
return __exports;});;

/* /mail/static/src/core/common/suggestion_service.js */
odoo.define('@mail/core/common/suggestion_service',['@mail/core/common/partner_compare','@mail/utils/common/format','@odoo/owl','@web/core/registry'],function(require){'use strict';let __exports={};const{partnerCompareRegistry}=require("@mail/core/common/partner_compare");const{cleanTerm}=require("@mail/utils/common/format");const{toRaw}=require("@odoo/owl");const{registry}=require("@web/core/registry");const SuggestionService=__exports.SuggestionService=class SuggestionService{constructor(env,services){this.env=env;this.orm=services.orm;this.store=services["mail.store"];}
getSupportedDelimiters(thread){return[["@"],["#"],[":"]];}
async fetchSuggestions({delimiter,term},{thread,abortSignal}={}){const cleanedSearchTerm=cleanTerm(term);switch(delimiter){case"@":{await this.fetchPartners(cleanedSearchTerm,thread,{abortSignal});break;}
case"#":await this.fetchThreads(cleanedSearchTerm,{abortSignal});break;case":":await this.store.cannedReponses.fetch();break;}}
makeOrmCall(model,method,args,kwargs,{abortSignal}={}){return new Promise((res,rej)=>{const req=this.orm.silent.call(model,method,args,kwargs);const onAbort=()=>{try{req.abort();}catch(e){rej(e);}};abortSignal?.addEventListener("abort",onAbort);req.then(res).catch(rej).finally(()=>abortSignal?.removeEventListener("abort",onAbort));});}
async fetchPartners(term,thread,{abortSignal}={}){const kwargs={search:term};if(thread?.model==="discuss.channel"){kwargs.channel_id=thread.id;}
const data=await this.makeOrmCall("res.partner",thread?.model==="discuss.channel"?"get_mention_suggestions_from_channel":"get_mention_suggestions",[],kwargs,{abortSignal});this.store.insert(data);}
async fetchThreads(term,{abortSignal}={}){const suggestedThreads=await this.makeOrmCall("discuss.channel","get_mention_suggestions",[],{search:term},{abortSignal});this.store.Thread.insert(suggestedThreads);}
searchCannedResponseSuggestions(cleanedSearchTerm,sort){const cannedResponses=Object.values(this.store["mail.canned.response"].records).filter((cannedResponse)=>cleanTerm(cannedResponse.source).includes(cleanedSearchTerm));const sortFunc=(c1,c2)=>{const cleanedName1=cleanTerm(c1.source);const cleanedName2=cleanTerm(c2.source);if(cleanedName1.startsWith(cleanedSearchTerm)&&!cleanedName2.startsWith(cleanedSearchTerm)){return-1;}
if(!cleanedName1.startsWith(cleanedSearchTerm)&&cleanedName2.startsWith(cleanedSearchTerm)){return 1;}
if(cleanedName1<cleanedName2){return-1;}
if(cleanedName1>cleanedName2){return 1;}
return c1.id-c2.id;};return{type:"mail.canned.response",suggestions:sort?cannedResponses.sort(sortFunc):cannedResponses,};}
searchSuggestions({delimiter,term},{thread,sort=false}={}){thread=toRaw(thread);const cleanedSearchTerm=cleanTerm(term);switch(delimiter){case"@":{return this.searchPartnerSuggestions(cleanedSearchTerm,thread,sort);}
case"#":return this.searchChannelSuggestions(cleanedSearchTerm,sort);case":":return this.searchCannedResponseSuggestions(cleanedSearchTerm,sort);}
return{type:undefined,suggestions:[],};}
getPartnerSuggestions(thread){let partners;const isNonPublicChannel=thread&&(thread.channel_type==="group"||thread.channel_type==="chat"||(thread.channel_type==="channel"&&(thread.parent_channel_id||thread).group_public_id));if(isNonPublicChannel){partners=thread.channelMembers.map((member)=>member.persona).filter((persona)=>persona.type==="partner");if(thread.channel_type==="channel"){const group=(thread.parent_channel_id||thread).group_public_id;partners=new Set([...partners,...(group?.personas??[])]);}}else{partners=Object.values(this.store.Persona.records).filter((persona)=>{if(thread?.model!=="discuss.channel"&&persona.eq(this.store.odoobot)){return false;}
return persona.type==="partner";});}
return partners;}
searchPartnerSuggestions(cleanedSearchTerm,thread,sort){const partners=this.getPartnerSuggestions(thread);const suggestions=[];for(const partner of partners){if(!partner.name){continue;}
if(cleanTerm(partner.name).includes(cleanedSearchTerm)||(partner.email&&cleanTerm(partner.email).includes(cleanedSearchTerm))){suggestions.push(partner);}}
suggestions.push(...this.store.specialMentions.filter((special)=>thread&&special.channel_types.includes(thread.channel_type)&&cleanedSearchTerm.length>=Math.min(4,special.label.length)&&(special.label.startsWith(cleanedSearchTerm)||cleanTerm(special.description.toString()).includes(cleanedSearchTerm))));return{type:"Partner",suggestions:sort?[...this.sortPartnerSuggestions(suggestions,cleanedSearchTerm,thread)]:suggestions,};}
sortPartnerSuggestions(partners,searchTerm="",thread=undefined){const cleanedSearchTerm=cleanTerm(searchTerm);const compareFunctions=partnerCompareRegistry.getAll();const context={recentChatPartnerIds:this.store.getRecentChatPartnerIds()};const memberPartnerIds=new Set(thread?.channelMembers.filter((member)=>member.persona.type==="partner").map((member)=>member.persona.id));return partners.sort((p1,p2)=>{p1=toRaw(p1);p2=toRaw(p2);if(p1.isSpecial||p2.isSpecial){return 0;}
for(const fn of compareFunctions){const result=fn(p1,p2,{env:this.env,memberPartnerIds,searchTerm:cleanedSearchTerm,thread,context,});if(result!==undefined){return result;}}});}
searchChannelSuggestions(cleanedSearchTerm,sort){const suggestionList=Object.values(this.store.Thread.records).filter((thread)=>thread.channel_type==="channel"&&thread.displayName&&cleanTerm(thread.displayName).includes(cleanedSearchTerm));const sortFunc=(c1,c2)=>{const isPublicChannel1=c1.channel_type==="channel"&&!c2.authorizedGroupFullName;const isPublicChannel2=c2.channel_type==="channel"&&!c2.authorizedGroupFullName;if(isPublicChannel1&&!isPublicChannel2){return-1;}
if(!isPublicChannel1&&isPublicChannel2){return 1;}
if(c1.hasSelfAsMember&&!c2.hasSelfAsMember){return-1;}
if(!c1.hasSelfAsMember&&c2.hasSelfAsMember){return 1;}
const cleanedDisplayName1=cleanTerm(c1.displayName);const cleanedDisplayName2=cleanTerm(c2.displayName);if(cleanedDisplayName1.startsWith(cleanedSearchTerm)&&!cleanedDisplayName2.startsWith(cleanedSearchTerm)){return-1;}
if(!cleanedDisplayName1.startsWith(cleanedSearchTerm)&&cleanedDisplayName2.startsWith(cleanedSearchTerm)){return 1;}
if(cleanedDisplayName1<cleanedDisplayName2){return-1;}
if(cleanedDisplayName1>cleanedDisplayName2){return 1;}
return c1.id-c2.id;};return{type:"Thread",suggestions:sort?suggestionList.sort(sortFunc):suggestionList,};}}
const suggestionService=__exports.suggestionService={dependencies:["orm","mail.store"],start(env,services){return new SuggestionService(env,services);},};registry.category("services").add("mail.suggestion",suggestionService);return __exports;});;

/* /mail/static/src/core/common/thread.js */
odoo.define('@mail/core/common/thread',['@mail/core/common/date_section','@mail/core/common/message','@mail/core/common/record','@mail/utils/common/hooks','@odoo/owl','@web/core/browser/browser','@web/core/l10n/translation','@web/core/transition','@web/core/utils/hooks','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{DateSection}=require("@mail/core/common/date_section");const{Message}=require("@mail/core/common/message");const{Record}=require("@mail/core/common/record");const{useVisible}=require("@mail/utils/common/hooks");const{Component,markRaw,onMounted,onWillDestroy,onWillPatch,onWillUpdateProps,reactive,toRaw,useChildSubEnv,useEffect,useRef,useState,}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const{Transition}=require("@web/core/transition");const{useBus,useRefListener,useService}=require("@web/core/utils/hooks");const{escape}=require("@web/core/utils/strings");const PRESENT_VIEWPORT_THRESHOLD=__exports.PRESENT_VIEWPORT_THRESHOLD=3;const PRESENT_MESSAGE_THRESHOLD=10;const Thread=__exports.Thread=class Thread extends Component{static components={Message,Transition,DateSection};static props=["showDates?","isInChatWindow?","jumpPresent?","thread","messageEdition?","messageToReplyTo?","order?","scrollRef?","showEmptyMessage?","showJumpPresent?","messageActions?",];static defaultProps={isInChatWindow:false,jumpPresent:0,order:"asc",showDates:true,showEmptyMessage:true,showJumpPresent:true,messageActions:true,};static template="mail.Thread";setup(){super.setup();this.escape=escape;this.registerMessageRef=this.registerMessageRef.bind(this);this.store=useState(useService("mail.store"));this.state=useState({isReplyingTo:false,mountedAndLoaded:false,showJumpPresent:false,scrollTop:null,});this.lastJumpPresent=this.props.jumpPresent;this.orm=useService("orm");this.messageHighlight=this.env.messageHighlight?useState(this.env.messageHighlight):null;this.scrollingToHighlight=false;this.refByMessageId=reactive(new Map(),()=>this.scrollToHighlighted());useEffect(()=>this.scrollToHighlighted(),()=>[this.messageHighlight?.highlightedMessageId]);this.present=useRef("load-newer");this.jumpPresentRef=useRef("jump-present");this.root=useRef("messages");this.scrollableRef=this.props.scrollRef??this.root;useRefListener(this.scrollableRef,"scrollend",()=>(this.state.scrollTop=this.scrollableRef.el.scrollTop));useEffect((loadNewer,mountedAndLoaded,unreadSynced)=>{if(loadNewer||unreadSynced||!mountedAndLoaded||!this.props.thread.selfMember||!this.scrollableRef.el){return;}
const el=this.scrollableRef.el;if(Math.abs(el.scrollTop+el.clientHeight-el.scrollHeight)<=1){this.props.thread.selfMember.hideUnreadBanner=true;}},()=>[this.props.thread.loadNewer,this.state.mountedAndLoaded,this.props.thread.selfMember?.unreadSynced,this.state.scrollTop,]);this.loadOlderState=useVisible("load-older",async()=>{await this.messageHighlight?.scrollPromise;if(this.loadOlderState.isVisible){toRaw(this.props.thread).fetchMoreMessages();}},{ready:false});this.loadNewerState=useVisible("load-newer",async()=>{await this.messageHighlight?.scrollPromise;if(this.loadNewerState.isVisible){toRaw(this.props.thread).fetchMoreMessages("newer");}},{ready:false});this.presentThresholdState=useVisible("present-treshold",()=>this.updateShowJumpPresent());this.setupScroll();useEffect(()=>{this.computeJumpPresentPosition();},()=>[this.jumpPresentRef.el,this.viewportEl]);useEffect(()=>this.updateShowJumpPresent(),()=>[this.props.thread.loadNewer]);useEffect(()=>{if(this.props.jumpPresent!==this.lastJumpPresent){this.messageHighlight?.clearHighlight();if(this.props.thread.loadNewer){this.jumpToPresent();}else{if(this.props.order==="desc"){this.scrollableRef.el.scrollTop=0;}else{this.scrollableRef.el.scrollTop=this.scrollableRef.el.scrollHeight-
this.scrollableRef.el.clientHeight;}
this.props.thread.scrollTop="bottom";}
this.lastJumpPresent=this.props.jumpPresent;}},()=>[this.props.jumpPresent]);useEffect(()=>{if(this.props.thread.highlightMessage&&this.state.mountedAndLoaded){this.messageHighlight?.highlightMessage(this.props.thread.highlightMessage,this.props.thread);this.props.thread.highlightMessage=null;}},()=>[this.props.thread.highlightMessage,this.state.mountedAndLoaded]);useEffect(()=>{if(!this.state.mountedAndLoaded){return;}
this.updateShowJumpPresent();},()=>[this.state.mountedAndLoaded]);onMounted(()=>{if(!this.env.chatter||this.env.chatter?.fetchMessages){if(this.env.chatter){this.env.chatter.fetchMessages=false;}
if(this.props.thread.selfMember&&this.props.thread.scrollUnread){toRaw(this.props.thread).loadAround(this.props.thread.selfMember.new_message_separator);}else{toRaw(this.props.thread).fetchNewMessages();}}});useEffect((isLoaded)=>{this.state.mountedAndLoaded=isLoaded;},()=>[this.props.thread.isLoaded,this.state.mountedAndLoaded]);useBus(this.env.bus,"MAIL:RELOAD-THREAD",({detail})=>{const{model,id}=this.props.thread;if(detail.model===model&&detail.id===id){toRaw(this.props.thread).fetchNewMessages();}});onWillUpdateProps((nextProps)=>{if(nextProps.thread.notEq(this.props.thread)){this.lastJumpPresent=nextProps.jumpPresent;}
if(!this.env.chatter||this.env.chatter?.fetchMessages){if(this.env.chatter){this.env.chatter.fetchMessages=false;}
toRaw(nextProps.thread).fetchNewMessages();}});}
computeJumpPresentPosition(){if(!this.viewportEl||!this.jumpPresentRef.el){return;}
const width=this.viewportEl.clientWidth;const height=this.viewportEl.clientHeight;const computedStyle=window.getComputedStyle(this.viewportEl);const ps=parseInt(computedStyle.getPropertyValue("padding-left"));const pe=parseInt(computedStyle.getPropertyValue("padding-right"));const pt=parseInt(computedStyle.getPropertyValue("padding-top"));const pb=parseInt(computedStyle.getPropertyValue("padding-bottom"));this.jumpPresentRef.el.style.transform=`translate(${
            this.env.inChatter ? 22 : width - ps - pe - 22
        }px, ${
            this.env.inChatter && !this.env.inChatter.aside
                ? 0
                : height - pt - pb - (this.env.inChatter?.aside ? 75 : 0)
        }px)`;}
setupScroll(){const ref=this.scrollableRef;let lastSetValue;let loadedAndPatched=false;let snapshot;let newestPersistentMessage;let oldestPersistentMessage;let loadNewer;const reset=()=>{this.state.mountedAndLoaded=false;this.loadOlderState.ready=false;this.loadNewerState.ready=false;lastSetValue=undefined;snapshot=undefined;newestPersistentMessage=undefined;oldestPersistentMessage=undefined;loadedAndPatched=false;loadNewer=false;};let stopOnChange=Record.onChange(this.props.thread,"isLoaded",()=>{if(!this.props.thread.isLoaded||!this.state.mountedAndLoaded){reset();}});onWillUpdateProps((nextProps)=>{if(nextProps.thread.notEq(this.props.thread)){stopOnChange();stopOnChange=Record.onChange(nextProps.thread,"isLoaded",()=>{if(!nextProps.thread.isLoaded||!this.state.mountedAndLoaded){reset();}});}});onWillDestroy(()=>stopOnChange());const saveScroll=()=>{const thread=toRaw(this.props.thread);const isBottom=this.props.order==="asc"?ref.el.scrollHeight-ref.el.scrollTop-ref.el.clientHeight<30:ref.el.scrollTop<30;if(isBottom){thread.scrollTop="bottom";}else{thread.scrollTop=this.props.order==="asc"?ref.el.scrollTop:ref.el.scrollHeight-ref.el.scrollTop-ref.el.clientHeight;}};const setScroll=(value)=>{ref.el.scrollTop=value;lastSetValue=value;saveScroll();};const applyScroll=()=>{if(!this.props.thread.isLoaded||!this.state.mountedAndLoaded){reset();return;}
const thread=toRaw(this.props.thread);const olderMessages=thread.oldestPersistentMessage?.id<oldestPersistentMessage?.id;const newerMessages=thread.newestPersistentMessage?.id>newestPersistentMessage?.id;const messagesAtTop=(this.props.order==="asc"&&olderMessages)||(this.props.order==="desc"&&newerMessages);const messagesAtBottom=(this.props.order==="desc"&&olderMessages)||(this.props.order==="asc"&&newerMessages&&(loadNewer||thread.scrollTop!=="bottom"));if(thread.selfMember&&thread.scrollUnread){if(thread.firstUnreadMessage){const messageEl=this.refByMessageId.get(thread.firstUnreadMessage.id)?.el;if(!messageEl){return;}
const messageCenter=messageEl.offsetTop-
this.scrollableRef.el.offsetHeight/2+
messageEl.offsetHeight/2;setScroll(messageCenter);}else{const scrollTop=this.props.order==="asc"?this.scrollableRef.el.scrollHeight-
this.scrollableRef.el.clientHeight:0;setScroll(scrollTop);}
thread.scrollUnread=false;}else if(snapshot&&messagesAtTop){setScroll(snapshot.scrollTop+ref.el.scrollHeight-snapshot.scrollHeight);}else if(snapshot&&messagesAtBottom){setScroll(snapshot.scrollTop);}else if(!this.scrollingToHighlight&&!this.env.messageHighlight?.highlightedMessageId&&thread.scrollTop!==undefined){let value;if(thread.scrollTop==="bottom"){value=this.props.order==="asc"?ref.el.scrollHeight-ref.el.clientHeight:0;}else{value=this.props.order==="asc"?thread.scrollTop:ref.el.scrollHeight-thread.scrollTop-ref.el.clientHeight;}
if(lastSetValue===undefined||Math.abs(lastSetValue-value)>1){setScroll(value);}}
snapshot=undefined;newestPersistentMessage=thread.newestPersistentMessage;oldestPersistentMessage=thread.oldestPersistentMessage;loadNewer=thread.loadNewer;if(!loadedAndPatched){loadedAndPatched=true;this.loadOlderState.ready=true;this.loadNewerState.ready=true;}};onWillPatch(()=>{if(!loadedAndPatched){return;}
snapshot={scrollHeight:ref.el.scrollHeight,scrollTop:ref.el.scrollTop,};});useEffect(applyScroll);useChildSubEnv({onImageLoaded:applyScroll,});const observer=new ResizeObserver(()=>{this.computeJumpPresentPosition();applyScroll();});useEffect((el,mountedAndLoaded)=>{if(el&&mountedAndLoaded){el.addEventListener("scroll",saveScroll);observer.observe(el);return()=>{observer.unobserve(el);el.removeEventListener("scroll",saveScroll);};}},()=>[ref.el,this.state.mountedAndLoaded]);}
get viewportEl(){let viewportEl=this.scrollableRef.el;if(viewportEl&&viewportEl.clientHeight>browser.innerHeight){while(viewportEl&&viewportEl.clientHeight>browser.innerHeight){viewportEl=viewportEl.parentElement;}}
return viewportEl;}
get PRESENT_THRESHOLD(){const viewportHeight=(this.getViewportEl?.clientHeight??0)*PRESENT_VIEWPORT_THRESHOLD;const messagesHeight=[...this.props.thread.nonEmptyMessages].reverse().slice(0,PRESENT_MESSAGE_THRESHOLD).map((message)=>this.refByMessageId.get(message.id)).reduce((totalHeight,message)=>totalHeight+(message?.el?.clientHeight??0),0);const threshold=Math.max(viewportHeight,messagesHeight);return this.state.showJumpPresent?threshold-200:threshold;}
get newMessageBannerText(){if(this.props.thread.selfMember?.totalUnreadMessageCounter>1){return _t("%s new messages",this.props.thread.selfMember.totalUnreadMessageCounter);}
return _t("1 new message");}
get preferenceButtonText(){const[,before,inside,after]=_t("<button>Change your preferences</button> to receive new notifications in your inbox.").match(/(.*)<button>(.*)<\/button>(.*)/)??[];return{before,inside,after};}
updateShowJumpPresent(){this.state.showJumpPresent=this.props.thread.loadNewer||this.presentThresholdState.isVisible===false;}
onClickLoadOlder(){this.props.thread.fetchMoreMessages();}
async onClickPreferences(){const actionDescription=await this.orm.call("res.users","action_get");actionDescription.res_id=this.store.self.userId;this.env.services.action.doAction(actionDescription);}
getMessageClassName(message){return!message.isNotification&&this.messageHighlight?.highlightedMessageId===message.id?"o-highlighted bg-view shadow-lg pb-1":"";}
async jumpToPresent(){this.messageHighlight?.clearHighlight();await this.props.thread.loadAround();this.props.thread.loadNewer=false;this.props.thread.scrollTop="bottom";this.state.showJumpPresent=false;this.scrollingToHighlight=false;}
async onClickUnreadMessagesBanner(){await this.props.thread.loadAround(this.props.thread.selfMember.localNewMessageSeparator);this.messageHighlight?.highlightMessage(this.props.thread.firstUnreadMessage,this.props.thread);}
registerMessageRef(message,ref){if(!ref){this.refByMessageId.delete(message.id);return;}
this.refByMessageId.set(message.id,markRaw(ref));}
isSquashed(msg,prevMsg){if(this.props.thread.model==="mail.box"){return false;}
if(!prevMsg||prevMsg.message_type==="notification"||prevMsg.isEmpty||this.env.inChatter){return false;}
if(!msg.author?.eq(prevMsg.author)){return false;}
if(!msg.thread?.eq(prevMsg.thread)){return false;}
if(msg.is_note){return false;}
return msg.datetime.ts-prevMsg.datetime.ts<5*60*1000;}
scrollToHighlighted(){if(!this.messageHighlight?.highlightedMessageId||this.scrollingToHighlight){return;}
const el=this.refByMessageId.get(this.messageHighlight.highlightedMessageId)?.el;if(el){this.scrollingToHighlight=true;this.messageHighlight.scrollTo(el).then(()=>(this.scrollingToHighlight=false));}}
get orderedMessages(){return this.props.order==="asc"?[...this.props.thread.nonEmptyMessages]:[...this.props.thread.nonEmptyMessages].reverse();}}
return __exports;});;

/* /mail/static/src/core/common/thread_actions.js */
odoo.define('@mail/core/common/thread_actions',['@odoo/owl','@web/core/l10n/translation','@web/core/registry','@mail/core/common/search_messages_panel'],function(require){'use strict';let __exports={};const{useSubEnv,useComponent,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{SearchMessagesPanel}=require("@mail/core/common/search_messages_panel");const threadActionsRegistry=__exports.threadActionsRegistry=registry.category("mail.thread/actions");threadActionsRegistry.add("fold-chat-window",{condition(component){return(component.props.chatWindow&&component.props.chatWindow.thread&&(component.env.services["im_livechat.livechat"]||!component.env.services.ui.isSmall));},icon:"fa fa-fw fa-minus",name(component){return!component.props.chatWindow?.isOpen?_t("Open"):_t("Fold");},open(component){component.toggleFold();},displayActive(component){return!component.props.chatWindow?.isOpen;},sequence:99,sequenceQuick:20,}).add("rename-thread",{condition(component){return(component.thread&&component.props.chatWindow?.isOpen&&(component.thread.is_editable||component.thread.channel_type==="chat"));},icon:"fa fa-fw fa-pencil",name:_t("Rename Thread"),open(component){component.state.editingName=true;},sequence:30,sequenceGroup:20,}).add("close",{condition(component){return component.props.chatWindow;},icon:"oi fa-fw oi-close",name:_t("Close Chat Window (ESC)"),open(component){component.close();},sequence:100,sequenceQuick:10,}).add("search-messages",{component:SearchMessagesPanel,condition(component){return(["discuss.channel","mail.box"].includes(component.thread?.model)&&(!component.props.chatWindow||component.props.chatWindow.isOpen));},panelOuterClass:"o-mail-SearchMessagesPanel bg-inherit",icon:"oi oi-fw oi-search",iconLarge:"oi oi-fw fa-lg oi-search",name:_t("Search Messages"),nameActive:_t("Close Search"),sequence:20,sequenceGroup:20,setup(action){useSubEnv({searchMenu:{open:()=>action.open(),close:()=>{if(action.isActive){action.close();}},},});},toggle:true,});function transformAction(component,id,action){return{close(){if(this.toggle){component.threadActions.activeAction=component.threadActions.actionStack.pop();}
action.close?.(component,this);},component:action.component,get componentCondition(){return this.isActive&&this.component&&this.condition&&!this.popover;},get componentProps(){return action.componentProps?.(this,component);},get condition(){if(action.condition===undefined){return true;}
return action.condition(component);},get disabledCondition(){return action.disabledCondition?.(component);},get icon(){return typeof action.icon==="function"?action.icon(component):action.icon;},get iconLarge(){return typeof action.iconLarge==="function"?action.iconLarge(component):action.iconLarge??action.icon;},id,get isActive(){return id===component.threadActions.activeAction?.id;},get name(){const res=this.isActive&&action.nameActive?action.nameActive:action.name;return typeof res==="function"?res(component):res;},onSelect({keepPrevious}={}){if(this.toggle&&this.isActive){this.close();}else{this.open({keepPrevious});}},open({keepPrevious}={}){if(this.toggle){if(component.threadActions.activeAction){if(keepPrevious){component.threadActions.actionStack.push(component.threadActions.activeAction);}else{component.threadActions.activeAction.close();}}
component.threadActions.activeAction=this;}
action.open?.(component,this);},get panelOuterClass(){return typeof action.panelOuterClass==="function"?action.panelOuterClass(component):action.panelOuterClass;},popover:null,get sequence(){return typeof action.sequence==="function"?action.sequence(component):action.sequence;},get sequenceGroup(){return typeof action.sequenceGroup==="function"?action.sequenceGroup(component):action.sequenceGroup;},get sequenceQuick(){return typeof action.sequenceQuick==="function"?action.sequenceQuick(component):action.sequenceQuick;},setup:action.setup,text:action.text,toggle:action.toggle,};}
__exports.useThreadActions=useThreadActions;function useThreadActions(){const component=useComponent();const transformedActions=threadActionsRegistry.getEntries().map(([id,action])=>transformAction(component,id,action));for(const action of transformedActions){if(action.setup){action.setup(action);}}
const state=useState({get actions(){return transformedActions.filter((action)=>action.condition).sort((a1,a2)=>a1.sequence-a2.sequence);},get partition(){const actions=transformedActions.filter((action)=>action.condition);const quick=actions.filter((a)=>a.sequenceQuick).sort((a1,a2)=>a1.sequenceQuick-a2.sequenceQuick);const grouped=actions.filter((a)=>a.sequenceGroup);const groups={};for(const a of grouped){if(!(a.sequenceGroup in groups)){groups[a.sequenceGroup]=[];}
groups[a.sequenceGroup].push(a);}
const sortedGroups=Object.entries(groups).sort(([groupId1],[groupId2])=>groupId1-groupId2);for(const[,actions]of sortedGroups){actions.sort((a1,a2)=>a1.sequence-a2.sequence);}
const group=sortedGroups.map(([groupId,actions])=>actions);const other=actions.filter((a)=>!a.sequenceQuick&!a.sequenceGroup).sort((a1,a2)=>a1.sequence-a2.sequence);return{quick,group,other};},actionStack:[],activeAction:null,});return state;}
return __exports;});;

/* /mail/static/src/core/common/thread_icon.js */
odoo.define('@mail/core/common/thread_icon',['@web/core/utils/hooks','@odoo/owl','@mail/core/common/thread_model','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{Component,useState}=require("@odoo/owl");const{Thread}=require("@mail/core/common/thread_model");const{_t}=require("@web/core/l10n/translation");const ThreadIcon=__exports.ThreadIcon=class ThreadIcon extends Component{static template="mail.ThreadIcon";static props={thread:{type:Thread},size:{optional:true,validate:(size)=>["small","medium","large"].includes(size)},className:{type:String,optional:true},};static defaultProps={size:"medium",className:"",};setup(){super.setup();this.store=useState(useService("mail.store"));}
get correspondent(){return this.props.thread.correspondent;}
get defaultChatIcon(){return{class:"fa fa-question-circle opacity-75",title:_t("No IM status available"),};}}
return __exports;});;

/* /mail/static/src/core/common/thread_model.js */
odoo.define('@mail/core/common/thread_model',['@mail/core/common/record','@mail/utils/common/format','@mail/utils/common/misc','@web/core/network/rpc','@web/core/l10n/translation','@web/core/l10n/utils','@web/core/user','@web/core/utils/concurrency','@web/core/browser/feature_detection'],function(require){'use strict';let __exports={};const{AND,Record}=require("@mail/core/common/record");const{prettifyMessageContent}=require("@mail/utils/common/format");const{assignDefined,compareDatetime,nearestGreaterThanOrEqual}=require("@mail/utils/common/misc");const{rpc}=require("@web/core/network/rpc");const{_t}=require("@web/core/l10n/translation");const{formatList}=require("@web/core/l10n/utils");const{user}=require("@web/core/user");const{Deferred}=require("@web/core/utils/concurrency");const{isMobileOS}=require("@web/core/browser/feature_detection");const Thread=__exports.Thread=class Thread extends Record{static id=AND("model","id");static records={};static get(data){return super.get(data);}
static localIdToActiveId(localId){if(!localId){return undefined;}
return localId.split(",").slice(1).join("_").replace(" AND ","_");}
static insert(data){return super.insert(...arguments);}
static new(){const thread=super.new(...arguments);Record.onChange(thread,["state"],()=>{if(thread.state==="folded"||(thread.state==="open"&&this.store.env.services.ui.isSmall&&this.store.env.services["im_livechat.livechat"])){const cw=this.store.ChatWindow?.insert({thread});thread.store.chatHub.folded.delete(cw);thread.store.chatHub.folded.unshift(cw);}
if(thread.state==="open"&&!this.store.env.services.ui.isSmall){const cw=this.store.ChatWindow?.insert({thread});thread.store.chatHub.opened.delete(cw);thread.store.chatHub.opened.unshift(cw);}});return thread;}
static async getOrFetch(data){return this.get(data);}
id;uuid;model;allMessages=Record.many("Message",{inverse:"thread",});areAttachmentsLoaded=false;group_public_id=Record.one("res.groups");attachments=Record.many("Attachment",{sort:(a1,a2)=>(a1.id<a2.id?1:-1),});get canLeave(){return(["channel","group"].includes(this.channel_type)&&!this.message_needaction_counter&&!this.group_based_subscription&&this.store.self?.type==="partner");}
get canUnpin(){return this.channel_type==="chat"&&this.importantCounter===0;}
can_react=true;channelMembers=Record.many("ChannelMember",{inverse:"thread",onDelete:(r)=>r.delete(),sort:(m1,m2)=>m1.id-m2.id,});get membersThatCanSeen(){return this.channelMembers;}
typingMembers=Record.many("ChannelMember",{inverse:"threadAsTyping"});otherTypingMembers=Record.many("ChannelMember",{compute(){return this.typingMembers.filter((member)=>!member.persona?.eq(this.store.self));},});hasOtherMembersTyping=Record.attr(false,{compute(){return this.otherTypingMembers.length>0;},});toggleBusSubscription=Record.attr(false,{compute(){return(this.model==="discuss.channel"&&this.selfMember?.memberSince>=this.store.env.services.bus_service.startedAt);},onUpdate(){this.store.updateBusSubscription();},});invitedMembers=Record.many("ChannelMember");composer=Record.one("Composer",{compute:()=>({}),inverse:"thread",onDelete:(r)=>r.delete(),});correspondent=Record.one("ChannelMember",{compute(){return this.computeCorrespondent();},});correspondentCountry=Record.one("Country",{compute(){return this.correspondent?.persona?.country??this.anonymous_country;},});get showCorrespondentCountry(){return(this.channel_type==="livechat"&&this.operator?.eq(this.store.self)&&Boolean(this.correspondentCountry));}
counter=0;counter_bus_id=0;custom_channel_name;description;displayToSelf=Record.attr(false,{compute(){return(this.is_pinned||(["channel","group"].includes(this.channel_type)&&this.hasSelfAsMember&&!this.parent_channel_id));},onUpdate(){this.onPinStateUpdated();},});followers=Record.many("Follower",{onAdd(r){r.thread=this;},onDelete:(r)=>r.delete(),});selfFollower=Record.one("Follower",{onAdd(r){r.thread=this;},onDelete:(r)=>r.delete(),});followersCount;loadOlder=false;loadNewer=false;get importantCounter(){if(this.model==="mail.box"){return this.counter;}
if(this.isChatChannel&&this.selfMember?.message_unread_counter){return this.selfMember.totalUnreadMessageCounter;}
return this.message_needaction_counter;}
isCorrespondentOdooBot=Record.attr(undefined,{compute(){return this.correspondent?.persona.eq(this.store.odoobot);},});isDisplayed=Record.attr(false,{compute(){return this.computeIsDisplayed();},onUpdate(){if(this.selfMember&&!this.isDisplayed){this.selfMember.syncUnread=true;}},});isLoadingAttachments=false;isLoadedDeferred=new Deferred();isLoaded=Record.attr(false,{onUpdate(){if(this.isLoaded){this.isLoadedDeferred.resolve();}else{const def=this.isLoadedDeferred;this.isLoadedDeferred=new Deferred();this.isLoadedDeferred.then(()=>def.resolve());}},});is_pinned=Record.attr(undefined,{onUpdate(){this.onPinStateUpdated();},});mainAttachment=Record.one("Attachment");memberCount=0;message_needaction_counter=0;message_needaction_counter_bus_id=0;messages=Record.many("Message");modelName;module_icon;pendingNewMessages=Record.many("Message");needactionMessages=Record.many("Message",{inverse:"threadAsNeedaction",sort:(message1,message2)=>message1.id-message2.id,});name;selfMember=Record.one("ChannelMember",{inverse:"threadAsSelf",});state;status="new";scrollTop="bottom";transientMessages=Record.many("Message");defaultDisplayMode;scrollUnread=true;suggestedRecipients=Record.attr([],{onUpdate(){for(const recipient of this.suggestedRecipients){if(recipient.checked===undefined){recipient.checked=true;}
recipient.persona=recipient.partner_id?{type:"partner",id:recipient.partner_id}:false;}},});hasLoadingFailed=false;canPostOnReadonly;last_interest_dt=Record.attr(undefined,{type:"datetime"});lastInterestDt=Record.attr(undefined,{type:"datetime",compute(){const selfMemberLastInterestDt=this.selfMember?.last_interest_dt;const lastInterestDt=this.last_interest_dt;return compareDatetime(selfMemberLastInterestDt,lastInterestDt)>0?selfMemberLastInterestDt:lastInterestDt;},});is_editable;custom_notifications=false;mute_until_dt=Record.attr(undefined,{type:"datetime"});isLocallyPinned=Record.attr(false,{onUpdate(){this.onPinStateUpdated();},});fetchMembersState="not_fetched";highlightMessage=Record.one("Message",{onAdd(msg){msg.thread=this;},});access_token;hash;pid;get accessRestrictedToGroupText(){if(!this.authorizedGroupFullName){return false;}
return _t('Access restricted to group "%(groupFullName)s"',{groupFullName:this.authorizedGroupFullName,});}
get areAllMembersLoaded(){return this.memberCount===this.channelMembers.length;}
get busChannel(){return`${this.model}_${this.id}`;}
get followersFullyLoaded(){return(this.followersCount===(this.selfFollower?this.followers.length+1:this.followers.length));}
get attachmentsInWebClientView(){const attachments=this.attachments.filter((attachment)=>(attachment.isPdf||attachment.isImage)&&!attachment.uploading);attachments.sort((a1,a2)=>{return a2.id-a1.id;});return attachments;}
get isUnread(){return this.selfMember?.message_unread_counter>0||this.needactionMessages.length>0;}
get isMuted(){return this.mute_until_dt||this.store.settings.mute_until_dt;}
get typesAllowingCalls(){return["chat","channel","group"];}
get allowCalls(){return(this.typesAllowingCalls.includes(this.channel_type)&&!this.correspondent?.persona.eq(this.store.odoobot));}
get hasAttachmentPanel(){return this.model==="discuss.channel";}
get isChatChannel(){return["chat","group"].includes(this.channel_type);}
get displayName(){if(this.channel_type==="chat"&&this.correspondent){return this.custom_channel_name||this.correspondent.persona.name;}
if(this.channel_type==="group"&&!this.name){return formatList(this.channelMembers.map((channelMember)=>channelMember.persona.name));}
return this.name;}
get correspondents(){return this.channelMembers.filter(({persona})=>persona.notEq(this.store.self));}
computeCorrespondent(){if(this.channel_type==="channel"){return undefined;}
const correspondents=this.correspondents;if(correspondents.length===1){return correspondents[0];}
if(correspondents.length===0&&this.channelMembers.length===1){return this.channelMembers[0];}
return undefined;}
computeIsDisplayed(){return this.store.ChatWindow.get({thread:this})?.isOpen;}
get avatarUrl(){return this.module_icon??this.store.DEFAULT_AVATAR;}
get allowDescription(){return["channel","group"].includes(this.channel_type);}
get isTransient(){return!this.id||this.id<0;}
get lastEditableMessageOfSelf(){const editableMessagesBySelf=this.nonEmptyMessages.filter((message)=>message.isSelfAuthored&&message.editable);if(editableMessagesBySelf.length>0){return editableMessagesBySelf.at(-1);}
return null;}
get needactionCounter(){return this.isChatChannel?this.selfMember?.message_unread_counter??0:this.message_needaction_counter;}
newestMessage=Record.one("Message",{inverse:"threadAsNewest",compute(){return this.messages.findLast((msg)=>!msg.isEmpty);},});firstUnreadMessage=Record.one("Message",{compute(){if(!this.selfMember){return null;}
const messages=this.nonEmptyMessages;const separator=this.selfMember.localNewMessageSeparator;if(separator===0&&!this.loadOlder){return messages[0];}
if(!separator||messages.length===0||messages.at(-1).id<separator){return null;}
let message=this.store.Message.get({id:separator});if(!message||this.notEq(message.thread)||message.isEmpty){message=nearestGreaterThanOrEqual(messages,separator,(msg)=>msg.id);}
return message;},});get newestPersistentMessage(){return this.messages.findLast((msg)=>Number.isInteger(msg.id));}
newestPersistentAllMessages=Record.many("Message",{compute(){const allPersistentMessages=this.allMessages.filter((message)=>Number.isInteger(message.id));allPersistentMessages.sort((m1,m2)=>m2.id-m1.id);return allPersistentMessages;},});newestPersistentOfAllMessage=Record.one("Message",{compute(){return this.newestPersistentAllMessages[0];},});newestPersistentNotEmptyOfAllMessage=Record.one("Message",{compute(){return this.newestPersistentAllMessages.find((message)=>!message.isEmpty);},});get oldestPersistentMessage(){return this.messages.find((msg)=>Number.isInteger(msg.id));}
onPinStateUpdated(){}
get hasSelfAsMember(){return Boolean(this.selfMember);}
hasSeenFeature=Record.attr(false,{compute(){return this.store.channel_types_with_seen_infos.includes(this.channel_type);},});get invitationLink(){if(!this.uuid||this.channel_type==="chat"){return undefined;}
return`${window.location.origin}/chat/${this.id}/${this.uuid}`;}
get isEmpty(){return!this.messages.some((message)=>!message.isEmpty);}
get nonEmptyMessages(){return this.messages.filter((message)=>!message.isEmpty);}
get persistentMessages(){return this.messages.filter((message)=>!message.is_transient);}
get prefix(){return this.isChatChannel?"@":"#";}
get showUnreadBanner(){return(!this.selfMember?.hideUnreadBanner&&this.selfMember?.localMessageUnreadCounter>0&&this.firstUnreadMessage);}
get rpcParams(){return{};}
lastMessageSeenByAllId=Record.attr(undefined,{compute(){if(!this.hasSeenFeature){return;}
const otherMembers=this.channelMembers.filter((member)=>member.persona.notEq(this.store.self));if(otherMembers.length===0){return;}
const otherLastSeenMessageIds=otherMembers.filter((member)=>member.seen_message_id).map((member)=>member.seen_message_id.id);if(otherLastSeenMessageIds.length===0){return;}
return Math.min(...otherLastSeenMessageIds);},});lastSelfMessageSeenByEveryone=Record.one("Message",{compute(){if(!this.lastMessageSeenByAllId){return false;}
let res;for(let i=this.persistentMessages.length-1;i>=0;i--){const message=this.persistentMessages[i];if(!message.isSelfAuthored){continue;}
if(message.id>this.lastMessageSeenByAllId){continue;}
res=message;break;}
return res;},});get unknownMembersCount(){return this.memberCount-this.channelMembers.length;}
executeCommand(command,body=""){return this.store.env.services.orm.call("discuss.channel",command.methodName,[[this.id]],{body});}
async fetchChannelMembers(){if(this.fetchMembersState==="pending"){return;}
const previousState=this.fetchMembersState;this.fetchMembersState="pending";const known_member_ids=this.channelMembers.map((channelMember)=>channelMember.id);let data;try{data=await rpc("/discuss/channel/members",{channel_id:this.id,known_member_ids:known_member_ids,});}catch(e){this.fetchMembersState=previousState;throw e;}
this.fetchMembersState="fetched";this.store.insert(data);}
async fetchMessages({after,around,before}={}){this.status="loading";if(!["mail.box","discuss.channel"].includes(this.model)&&!this.id){this.isLoaded=true;return[];}
try{const{data,messages}=await this.fetchMessagesData({after,around,before});this.store.insert(data,{html:true});return this.store.Message.insert(messages.reverse());}catch(e){this.hasLoadingFailed=true;throw e;}finally{this.isLoaded=true;this.status="ready";}}
async fetchMessagesData({after,around,before}={}){return await rpc(this.getFetchRoute(),{...this.getFetchParams(),limit:!around&&around!==0?this.store.FETCH_LIMIT:this.store.FETCH_LIMIT*2,after,around,before,});}
async fetchMoreMessages(epoch="older"){if(this.status==="loading"||(epoch==="older"&&!this.loadOlder)||(epoch==="newer"&&!this.loadNewer)){return;}
const before=epoch==="older"?this.oldestPersistentMessage?.id:undefined;const after=epoch==="newer"?this.newestPersistentMessage?.id:undefined;try{const fetched=await this.fetchMessages({after,before});if((after!==undefined&&!this.messages.some((message)=>message.id===after))||(before!==undefined&&!this.messages.some((message)=>message.id===before))){return;}
const alreadyKnownMessages=new Set(this.messages.map(({id})=>id));const messagesToAdd=fetched.filter((message)=>!alreadyKnownMessages.has(message.id));if(epoch==="older"){this.messages.unshift(...messagesToAdd);}else{this.messages.push(...messagesToAdd);}
if(fetched.length<this.store.FETCH_LIMIT){if(epoch==="older"){this.loadOlder=false;}else if(epoch==="newer"){this.loadNewer=false;const missingMessages=this.pendingNewMessages.filter(({id})=>!alreadyKnownMessages.has(id));if(missingMessages.length>0){this.messages.push(...missingMessages);this.messages.sort((m1,m2)=>m1.id-m2.id);}}}
this._enrichMessagesWithTransient();}catch{}
this.pendingNewMessages=[];}
async fetchNewMessages(){if(this.status==="loading"||(this.isLoaded&&["discuss.channel","mail.box"].includes(this.model))){return;}
const after=this.isLoaded?this.newestPersistentMessage?.id:undefined;try{const fetched=await this.fetchMessages({after});let startIndex;if(after===undefined){startIndex=0;}else{const afterIndex=this.messages.findIndex((message)=>message.id===after);if(afterIndex===-1){return;}else{startIndex=afterIndex+1;}}
const alreadyKnownMessages=new Set(this.messages.map((m)=>m.id));const filtered=fetched.filter((message)=>!alreadyKnownMessages.has(message.id)&&(this.persistentMessages.length===0||message.id<this.oldestPersistentMessage.id||message.id>this.newestPersistentMessage.id));this.messages.splice(startIndex,0,...filtered);Object.assign(this,{loadOlder:after===undefined&&fetched.length===this.store.FETCH_LIMIT?true:after===undefined&&fetched.length!==this.store.FETCH_LIMIT?false:this.loadOlder,});}catch{}}
getFetchParams(){if(this.model==="discuss.channel"){return{channel_id:this.id};}
if(this.model==="mail.box"){return{};}
return{thread_id:this.id,thread_model:this.model,...this.rpcParams,};}
getFetchRoute(){if(this.model==="discuss.channel"){return"/discuss/channel/messages";}
if(this.model==="mail.box"&&this.id==="inbox"){return`/mail/inbox/messages`;}
if(this.model==="mail.box"&&this.id==="starred"){return`/mail/starred/messages`;}
if(this.model==="mail.box"&&this.id==="history"){return`/mail/history/messages`;}
return this.fetchRouteChatter;}
get fetchRouteChatter(){return"/mail/thread/messages";}
async leave(){await this.store.env.services.orm.call("discuss.channel","action_unfollow",[this.id]);}
async loadAround(messageId){if(this.status==="loading"||(this.isLoaded&&this.messages.some(({id})=>id===messageId))){return;}
try{this.isLoaded=false;this.scrollTop=undefined;this.messages=await this.fetchMessages({around:messageId});this.isLoaded=true;this.loadNewer=messageId!==undefined?true:false;this.loadOlder=true;const limit=!messageId&&messageId!==0?this.store.FETCH_LIMIT:this.store.FETCH_LIMIT*2;if(this.messages.length<limit){const olderMessagesCount=this.messages.filter(({id})=>id<messageId).length;const newerMessagesCount=this.messages.filter(({id})=>id>messageId).length;if(olderMessagesCount<limit/2-1){this.loadOlder=false;}
if(newerMessagesCount<limit/2){this.loadNewer=false;}}
this._enrichMessagesWithTransient();}catch{}}
async markAllMessagesAsRead(){await this.store.env.services.orm.silent.call("mail.message","mark_all_as_read",[[["model","=",this.model],["res_id","=",this.id],],]);this.message_needaction_counter=0;}
async markAsFetched(){await this.store.env.services.orm.silent.call("discuss.channel","channel_fetched",[[this.id],]);}
markAsRead({sync}={}){const newestPersistentMessage=this.newestPersistentOfAllMessage;if(!newestPersistentMessage&&!this.isLoaded){this.isLoadedDeferred.then(()=>new Promise(setTimeout)).then(()=>this.markAsRead());}
const alreadyReadBySelf=newestPersistentMessage?.isReadBySelf;if(this.selfMember){this.selfMember.syncUnread=sync??this.selfMember.syncUnread;this.selfMember.seen_message_id=newestPersistentMessage;}
if(newestPersistentMessage&&this.selfMember&&!alreadyReadBySelf){rpc("/discuss/channel/mark_as_read",{channel_id:this.id,last_message_id:newestPersistentMessage.id,sync,}).catch((e)=>{if(e.code!==404){throw e;}});}
if(this.message_needaction_counter>0){this.markAllMessagesAsRead();}}
async notifyAvatarToServer(data){await rpc("/discuss/channel/update_avatar",{channel_id:this.id,data,});}
async notifyDescriptionToServer(description){this.description=description;return this.store.env.services.orm.call("discuss.channel","channel_change_description",[[this.id]],{description});}
open(options){}
openChatWindow({fromMessagingMenu}={}){const cw=this.store.ChatWindow.insert(assignDefined({thread:this},{fromMessagingMenu}));this.store.chatHub.opened.delete(cw);this.store.chatHub.opened.unshift(cw);if(!isMobileOS()){cw.focus();}else{this.markAsRead();}
this.state="open";cw.notifyState();return cw;}
pin(){if(this.model!=="discuss.channel"||this.store.self.type!=="partner"){return;}
this.is_pinned=true;return this.store.env.services.orm.silent.call("discuss.channel","channel_pin",[this.id],{pinned:true});}
async rename(name){const newName=name.trim();if(newName!==this.displayName&&((newName&&this.channel_type==="channel")||this.channel_type==="chat"||this.channel_type==="group")){if(this.channel_type==="channel"||this.channel_type==="group"){this.name=newName;await this.store.env.services.orm.call("discuss.channel","channel_rename",[[this.id]],{name:newName});}else if(this.channel_type==="chat"){this.custom_channel_name=newName;await this.store.env.services.orm.call("discuss.channel","channel_set_custom_name",[[this.id]],{name:newName});}}}
addOrReplaceMessage(message,tmpMsg){if(tmpMsg&&tmpMsg.in(this.messages)&&message.author.eq(this.store.self)){this.messages.splice(this.messages.indexOf(tmpMsg),1,message);return;}
this.messages.add(message);}
async post(body,postData={},extraData={}){let tmpMsg;postData.attachments=postData.attachments?[...postData.attachments]:[];const{attachments,parentId,mentionedChannels,mentionedPartners}=postData;const params=await this.store.getMessagePostParams({body,postData,thread:this});Object.assign(params,extraData);const tmpId=this.store.getNextTemporaryId();params.context={...user.context,...params.context,temporary_id:tmpId};if(parentId){params.post_data.parent_id=parentId;}
if(this.model!=="discuss.channel"){params.thread_id=this.id;params.thread_model=this.model;}else{const tmpData={id:tmpId,attachments:attachments,res_id:this.id,model:"discuss.channel",};tmpData.author=this.store.self;if(parentId){tmpData.parentMessage=this.store.Message.get(parentId);}
const prettyContent=await prettifyMessageContent(body,this.store.getMentionsFromText(body,{mentionedChannels,mentionedPartners,}));tmpMsg=this.store.Message.insert({...tmpData,body:prettyContent,isPending:true,thread:this,},{html:true});this.messages.push(tmpMsg);if(this.selfMember){this.selfMember.syncUnread=true;this.selfMember.seen_message_id=tmpMsg;this.selfMember.new_message_separator=tmpMsg.id+1;}}
const data=await this.store.doMessagePost(params,tmpMsg);if(!data){return;}
const{Message:messages=[]}=this.store.insert(data,{html:true});const[message]=messages;this.addOrReplaceMessage(message,tmpMsg);if(this.selfMember?.seen_message_id?.id<message.id){this.selfMember.seen_message_id=message;this.selfMember.new_message_separator=message.id+1;}
tmpMsg?.delete();if(message.hasLink&&this.store.hasLinkPreviewFeature){rpc("/mail/link_preview",{message_id:message.id},{silent:true});}
return message;}
async setMainAttachmentFromIndex(index){this.mainAttachment=this.attachmentsInWebClientView[index];await this.store.env.services.orm.call("ir.attachment","register_as_main_attachment",[this.mainAttachment.id,]);}
_enrichMessagesWithTransient(){for(const message of this.transientMessages){if(message.id<this.oldestPersistentMessage&&!this.loadOlder){this.messages.unshift(message);}else if(message.id>this.newestPersistentMessage&&!this.loadNewer){this.messages.push(message);}else{let afterIndex=this.messages.findIndex((msg)=>msg.id>message.id);if(afterIndex===-1){afterIndex=this.messages.length+1;}
this.messages.splice(afterIndex-1,0,message);}}}}
Thread.register();return __exports;});;

/* /mail/static/src/core/common/volume_model.js */
odoo.define('@mail/core/common/volume_model',['@mail/core/common/record'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const Volume=__exports.Volume=class Volume extends Record{static id="persona";persona=Record.one("Persona");volume=1;}
Volume.register();return __exports;});;

/* /mail/static/src/core/public_web/chat_hub_patch.js */
odoo.define('@mail/core/public_web/chat_hub_patch',['@web/core/utils/patch','@mail/core/common/chat_hub'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{ChatHub}=require("@mail/core/common/chat_hub");patch(ChatHub.prototype,{get isShown(){return super.isShown&&!this.store.discuss.isActive;},});return __exports;});;

/* /mail/static/src/core/public_web/discuss.js */
odoo.define('@mail/core/public_web/discuss',['@mail/core/common/autoresize_input','@mail/core/common/composer','@mail/core/common/country_flag','@mail/core/common/im_status','@mail/core/common/thread','@mail/core/common/thread_actions','@mail/core/common/thread_icon','@mail/core/public_web/discuss_sidebar','@mail/utils/common/hooks','@odoo/owl','@web/core/hotkeys/hotkey_service','@web/core/l10n/translation','@web/core/utils/hooks','@web/views/fields/file_handler','@mail/core/public_web/messaging_menu'],function(require){'use strict';let __exports={};const{AutoresizeInput}=require("@mail/core/common/autoresize_input");const{Composer}=require("@mail/core/common/composer");const{CountryFlag}=require("@mail/core/common/country_flag");const{ImStatus}=require("@mail/core/common/im_status");const{Thread}=require("@mail/core/common/thread");const{useThreadActions}=require("@mail/core/common/thread_actions");const{ThreadIcon}=require("@mail/core/common/thread_icon");const{DiscussSidebar}=require("@mail/core/public_web/discuss_sidebar");const{useMessageEdition,useMessageHighlight,useMessageToReplyTo,}=require("@mail/utils/common/hooks");const{Component,onMounted,onWillUnmount,useRef,useState,useExternalListener,useEffect,useSubEnv,}=require("@odoo/owl");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{FileUploader}=require("@web/views/fields/file_handler");const{MessagingMenu}=require("@mail/core/public_web/messaging_menu");const Discuss=__exports.Discuss=class Discuss extends Component{static components={AutoresizeInput,CountryFlag,DiscussSidebar,Thread,ThreadIcon,Composer,FileUploader,ImStatus,MessagingMenu,};static props={hasSidebar:{type:Boolean,optional:true},};static defaultProps={hasSidebar:true};static template="mail.Discuss";setup(){super.setup();this.store=useState(useService("mail.store"));this.messageHighlight=useMessageHighlight();this.messageEdition=useMessageEdition();this.messageToReplyTo=useMessageToReplyTo();this.contentRef=useRef("content");this.root=useRef("root");this.state=useState({jumpThreadPresent:0});this.orm=useService("orm");this.effect=useService("effect");this.ui=useState(useService("ui"));useSubEnv({inDiscussApp:true,messageHighlight:this.messageHighlight,});this.notification=useService("notification");this.threadActions=useThreadActions();useExternalListener(window,"keydown",(ev)=>{if(getActiveHotkey(ev)==="escape"&&!this.thread?.composer?.isFocused){if(this.thread?.composer){this.thread.composer.autofocus++;}}},{capture:true});if(this.store.inPublicPage){useEffect((thread,isSmall)=>{if(!thread){return;}
if(isSmall){this.chatWindow=this.thread.openChatWindow();}else{this.chatWindow?.close();}},()=>[this.thread,this.ui.isSmall]);}
onMounted(()=>(this.store.discuss.isActive=true));onWillUnmount(()=>(this.store.discuss.isActive=false));useEffect((memberListAction)=>{if(!memberListAction){return;}
if(this.store.discuss.isMemberPanelOpenByDefault){if(!this.threadActions.activeAction){memberListAction.open();}else if(this.threadActions.activeAction===memberListAction){return;}else{this.store.discuss.isMemberPanelOpenByDefault=false;}}},()=>[this.threadActions.actions.find((a)=>a.id==="member-list")]);}
get thread(){return this.store.discuss.thread;}
async onFileUploaded(file){await this.thread.notifyAvatarToServer(file.data);this.notification.add(_t("The avatar has been updated!"),{type:"success"});}
async renameThread(name){await this.thread.rename(name);}
async updateThreadDescription(description){const newDescription=description.trim();if(!newDescription&&!this.thread.description){return;}
if(newDescription!==this.thread.description){await this.thread.notifyDescriptionToServer(newDescription);}}
async renameGuest(name){const newName=name.trim();if(this.store.self.name!==newName){await this.store.self.updateGuestName(newName);}}}
return __exports;});;

/* /mail/static/src/core/public_web/discuss_app_category_model.js */
odoo.define('@mail/core/public_web/discuss_app_category_model',['@mail/utils/common/misc','@mail/core/common/record','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{compareDatetime}=require("@mail/utils/common/misc");const{Record}=require("@mail/core/common/record");const{browser}=require("@web/core/browser/browser");const DiscussAppCategory=__exports.DiscussAppCategory=class DiscussAppCategory extends Record{static id="id";static get(data){return super.get(data);}
static insert(data){return super.insert(...arguments);}
sortThreads(t1,t2){if(this.id==="channels"){return String.prototype.localeCompare.call(t1.name,t2.name);}
if(this.id==="chats"){return compareDatetime(t2.lastInterestDt,t1.lastInterestDt)||t2.id-t1.id;}}
get isVisible(){return(!this.hideWhenEmpty||this.threads.some((thread)=>thread.displayToSelf||thread.isLocallyPinned));}
extraClass;icon;id;name;hideWhenEmpty=false;canView=false;canAdd=false;app=Record.one("DiscussApp",{compute(){return this.store.discuss;},});_openLocally=false;localStateKey=Record.attr(null,{compute(){if(this.saveStateToServer){return null;}
return`discuss_sidebar_category_${this.id}_open`;},onUpdate(){if(this.localStateKey){this._openLocally=JSON.parse(browser.localStorage.getItem(this.localStateKey)??"true");}},});sequence;get open(){return this.saveStateToServer?this.store.settings[this.serverStateKey]:this._openLocally;}
get saveStateToServer(){return this.serverStateKey&&this.store.self?.isInternalUser;}
set open(value){if(this.saveStateToServer){this.store.settings[this.serverStateKey]=value;this.store.env.services.orm.call("res.users.settings","set_res_users_settings",[[this.store.settings.id]],{new_settings:{[this.serverStateKey]:value,},});}else{this._openLocally=value;browser.localStorage.setItem(this.localStateKey,value);}}
serverStateKey;addTitle;addHotkey;threads=Record.many("Thread",{sort(t1,t2){return this.sortThreads(t1,t2);},inverse:"discussAppCategory",});}
DiscussAppCategory.register();return __exports;});;

/* /mail/static/src/core/public_web/discuss_app_model.js */
odoo.define('@mail/core/public_web/discuss_app_model',['@mail/core/common/record','@web/core/browser/browser','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const DiscussApp=__exports.DiscussApp=class DiscussApp extends Record{static new(data){const res=super.new(data);Object.assign(res,{channels:{extraClass:"o-mail-DiscussSidebarCategory-channel",icon:"fa fa-hashtag",id:"channels",name:_t("Channels"),canView:true,canAdd:true,sequence:10,serverStateKey:"is_discuss_sidebar_category_channel_open",addTitle:_t("Add or join a channel"),addHotkey:"c",},chats:{extraClass:"o-mail-DiscussSidebarCategory-chat",icon:"fa fa-users",id:"chats",name:_t("Direct messages"),canView:false,canAdd:true,sequence:30,serverStateKey:"is_discuss_sidebar_category_chat_open",addTitle:_t("Start a conversation"),addHotkey:"d",},});return res;}
static get(data){return super.get(data);}
static insert(data){return super.insert(...arguments);}
INSPECTOR_WIDTH=300;activeTab="main";searchTerm="";isActive=false;isMemberPanelOpenByDefault=Record.attr(true,{compute(){return(browser.localStorage.getItem("mail.user_setting.no_members_default_open")!=="true");},onUpdate(){if(this.isMemberPanelOpenByDefault){browser.localStorage.removeItem("mail.user_setting.no_members_default_open");}else{browser.localStorage.setItem("mail.user_setting.no_members_default_open","true");}},});isSidebarCompact=Record.attr(false,{compute(){return(browser.localStorage.getItem("mail.user_setting.discuss_sidebar_compact")==="true");},onUpdate(){if(this.isSidebarCompact){browser.localStorage.setItem("mail.user_setting.discuss_sidebar_compact",this.isSidebarCompact.toString());}else{browser.localStorage.removeItem("mail.user_setting.discuss_sidebar_compact");}},});allCategories=Record.many("DiscussAppCategory",{inverse:"app",sort:(c1,c2)=>c1.sequence!==c2.sequence?c1.sequence-c2.sequence:c1.name.localeCompare(c2.name),});thread=Record.one("Thread");channels=Record.one("DiscussAppCategory");chats=Record.one("DiscussAppCategory");hasRestoredThread=false;}
DiscussApp.register();return __exports;});;

/* /mail/static/src/core/public_web/discuss_client_action.js */
odoo.define('@mail/core/public_web/discuss_client_action',['@mail/core/public_web/discuss','@odoo/owl','@web/core/registry','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Discuss}=require("@mail/core/public_web/discuss");const{Component,onWillStart,onWillUpdateProps,useState}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const DiscussClientAction=__exports.DiscussClientAction=class DiscussClientAction extends Component{static components={Discuss};static props=["*"];static template="mail.DiscussClientAction";setup(){super.setup();this.store=useState(useService("mail.store"));onWillStart(()=>{this.restoreDiscussThread(this.props);});onWillUpdateProps((nextProps)=>{this.restoreDiscussThread(nextProps);});}
getActiveId(props){return(props.action.context.active_id??props.action.params?.active_id??this.store.Thread.localIdToActiveId(this.store.discuss.thread?.localId)??"mail.box_inbox");}
parseActiveId(rawActiveId){const[model,id]=rawActiveId.split("_");if(model==="mail.box"){return["mail.box",id];}
return[model,parseInt(id)];}
async restoreDiscussThread(props){const rawActiveId=this.getActiveId(props);const[model,id]=this.parseActiveId(rawActiveId);const activeThread=await this.store.Thread.getOrFetch({model,id});if(activeThread&&activeThread.notEq(this.store.discuss.thread)){if(props.action?.params?.highlight_message_id){activeThread.highlightMessage=props.action.params.highlight_message_id;delete props.action.params.highlight_message_id;}
activeThread.setAsDiscussThread(false);}
this.store.discuss.hasRestoredThread=true;}}
registry.category("actions").add("mail.action_discuss",DiscussClientAction);return __exports;});;

/* /mail/static/src/core/public_web/discuss_sidebar.js */
odoo.define('@mail/core/public_web/discuss_sidebar',['@odoo/owl','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/registry','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const discussSidebarItemsRegistry=__exports.discussSidebarItemsRegistry=registry.category("mail.discuss_sidebar_items");const DiscussSidebar=__exports.DiscussSidebar=class DiscussSidebar extends Component{static template="mail.DiscussSidebar";static props={};static components={Dropdown,DropdownItem};setup(){super.setup();this.store=useState(useService("mail.store"));}
get discussSidebarItems(){return discussSidebarItemsRegistry.getAll();}}
return __exports;});;

/* /mail/static/src/core/public_web/messaging_menu.js */
odoo.define('@mail/core/public_web/messaging_menu',['@mail/core/common/country_flag','@mail/core/common/im_status','@mail/core/public_web/notification_item','@mail/utils/common/hooks','@odoo/owl','@web/core/browser/feature_detection','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_hooks','@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/core/hotkeys/hotkey_service'],function(require){'use strict';let __exports={};const{CountryFlag}=require("@mail/core/common/country_flag");const{ImStatus}=require("@mail/core/common/im_status");const{NotificationItem}=require("@mail/core/public_web/notification_item");const{useDiscussSystray}=require("@mail/utils/common/hooks");const{Component,useExternalListener,useRef,useState}=require("@odoo/owl");const{hasTouch}=require("@web/core/browser/feature_detection");const{Dropdown}=require("@web/core/dropdown/dropdown");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const MessagingMenu=__exports.MessagingMenu=class MessagingMenu extends Component{static components={CountryFlag,Dropdown,NotificationItem,ImStatus};static props=[];static template="mail.MessagingMenu";setup(){super.setup();this.discussSystray=useDiscussSystray();this.store=useState(useService("mail.store"));this.hasTouch=hasTouch;this.ui=useState(useService("ui"));this.state=useState({activeIndex:null,adding:false,});this.dropdown=useDropdownState();this.notificationList=useRef("notification-list");useExternalListener(window,"keydown",this.onKeydown,true);}
onClickThread(isMarkAsRead,thread){if(!isMarkAsRead){this.openDiscussion(thread);return;}
this.markAsRead(thread);}
markAsRead(thread){if(thread.needactionMessages.length>0){thread.markAllMessagesAsRead();}
if(thread.model==="discuss.channel"){thread.markAsRead();}}
navigate(direction){if(this.notificationItems.length===0){return;}
const activeOptionId=this.state.activeIndex!==null?this.state.activeIndex:0;let targetId=undefined;switch(direction){case"first":targetId=0;break;case"last":targetId=this.notificationItems.length-1;break;case"previous":targetId=activeOptionId-1;if(targetId<0){this.navigate("last");return;}
break;case"next":targetId=activeOptionId+1;if(targetId>this.notificationItems.length-1){this.navigate("first");return;}
break;default:return;}
this.state.activeIndex=targetId;this.notificationItems[targetId]?.scrollIntoView({block:"nearest"});}
onKeydown(ev){if(!this.dropdown.isOpen){return;}
const hotkey=getActiveHotkey(ev);switch(hotkey){case"enter":if(this.state.activeIndex===null){return;}
this.notificationItems[this.state.activeIndex].click();break;case"tab":this.navigate(this.state.activeIndex===null?"first":"next");break;case"arrowup":this.navigate(this.state.activeIndex===null?"first":"previous");break;case"arrowdown":this.navigate(this.state.activeIndex===null?"first":"next");break;default:return;}
ev.preventDefault();ev.stopPropagation();}
get notificationItems(){return this.notificationList.el?.children??[];}
get threads(){return this.store.menuThreads;}
get tabs(){return[{icon:"fa fa-user",id:"chat",label:_t("Chat"),},{icon:"fa fa-users",id:"channel",label:_t("Channel"),},];}
openDiscussion(thread){thread.open({fromMessagingMenu:true});this.dropdown.close();}
onClickNavTab(tabId){if(this.store.discuss.activeTab===tabId){return;}
this.store.discuss.activeTab=tabId;if(this.store.discuss.activeTab==="main"&&this.env.inDiscussApp&&(!this.store.discuss.thread||this.store.discuss.thread.model!=="mail.box")){this.store.inbox.setAsDiscussThread();}
if(this.store.discuss.activeTab!=="main"){this.store.discuss.thread=undefined;}}}
registry.category("systray").add("mail.messaging_menu",{Component:MessagingMenu},{sequence:25});return __exports;});;

/* /mail/static/src/core/public_web/notification_item.js */
odoo.define('@mail/core/public_web/notification_item',['@mail/core/common/im_status','@mail/utils/common/dates','@mail/utils/common/hooks','@odoo/owl','@web/core/action_swiper/action_swiper','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{ImStatus}=require("@mail/core/common/im_status");const{isToday}=require("@mail/utils/common/dates");const{useHover}=require("@mail/utils/common/hooks");const{Component,useRef,useState}=require("@odoo/owl");const{ActionSwiper}=require("@web/core/action_swiper/action_swiper");const{useService}=require("@web/core/utils/hooks");const{DateTime}=luxon;const NotificationItem=__exports.NotificationItem=class NotificationItem extends Component{static components={ActionSwiper,ImStatus};static props=["body?","counter?","datetime?","first?","hasMarkAsReadButton?","iconSrc?","muted?","onClick","onSwipeLeft?","onSwipeRight?","slots?","isActive?","nameMaxLine?","textMaxLine?",];static defaultProps={counter:0,muted:0,};static template="mail.NotificationItem";setup(){super.setup();this.isToday=isToday;this.DateTime=DateTime;this.ui=useState(useService("ui"));this.markAsReadRef=useRef("markAsRead");this.rootHover=useHover("root");}
get dateText(){if(isToday(this.props.datetime)){return this.props.datetime?.toLocaleString(DateTime.TIME_SIMPLE);}
if(this.props.datetime?.year===DateTime.now().year){return this.props.datetime?.toLocaleString({month:"short",day:"numeric"});}
return this.props.datetime?.toLocaleString(DateTime.DATE_MED);}
onClick(ev){this.props.onClick(ev.target===this.markAsReadRef.el);}
webkitLineClamp(maxLine){return`
            display: -webkit-box;
            overflow: hidden;
            -webkit-box-orient: vertical;
            -webkit-line-clamp: ${maxLine};
        `;}}
return __exports;});;

/* /mail/static/src/core/public_web/out_of_focus_service_patch.js */
odoo.define('@mail/core/public_web/out_of_focus_service_patch',['@mail/core/common/out_of_focus_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{OutOfFocusService,outOfFocusService}=require("@mail/core/common/out_of_focus_service");const{patch}=require("@web/core/utils/patch");patch(OutOfFocusService.prototype,{setup(env,services){super.setup(env,services);this.titleService=services.title;this.counter=0;this.contributingMessageLocalIds=new Set();env.bus.addEventListener("window_focus",()=>this.clearUnreadMessage());},clearUnreadMessage(){this.counter=0;this.contributingMessageLocalIds.clear();this.titleService.setCounters({discuss:undefined});},notify(message){if(this.contributingMessageLocalIds.has(message.localId)){return;}
this.contributingMessageLocalIds.add(message.localId);this.counter++;this.titleService.setCounters({discuss:this.counter});super.notify(...arguments);},});outOfFocusService.dependencies=[...outOfFocusService.dependencies,"title"];return __exports;});;

/* /mail/static/src/core/public_web/store_service_patch.js */
odoo.define('@mail/core/public_web/store_service_patch',['@mail/core/common/store_service','@mail/core/common/record','@web/core/browser/router','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Store,storeService}=require("@mail/core/common/store_service");const{Record}=require("@mail/core/common/record");const{router}=require("@web/core/browser/router");const{patch}=require("@web/core/utils/patch");patch(Store.prototype,{setup(){super.setup(...arguments);this.discuss=Record.one("DiscussApp");this.action_discuss_id;},onStarted(){super.onStarted(...arguments);this.discuss={activeTab:"main"};this.env.bus.addEventListener("discuss.channel/new_message",({detail:{channel,message,silent}})=>{if(this.env.services.ui.isSmall||message.isSelfAuthored||silent){return;}
channel.notifyMessageToUser(message);});},getDiscussSidebarCategoryCounter(categoryId){return this.DiscussAppCategory.get({id:categoryId}).threads.reduce((acc,channel)=>{if(categoryId==="channels"){return channel.message_needaction_counter>0?acc+1:acc;}else{return channel.selfMember?.message_unread_counter>0?acc+1:acc;}},0);},});patch(storeService,{start(env,services){const store=super.start(...arguments);const discussActionIds=["mail.action_discuss","discuss"];if(store.action_discuss_id){discussActionIds.push(store.action_discuss_id);}
store.discuss.isActive||=discussActionIds.includes(router.current.action);services.ui.bus.addEventListener("resize",()=>{store.discuss.activeTab="main";if(services.ui.isSmall&&store.discuss.thread?.channel_type){store.discuss.activeTab=store.discuss.thread.channel_type;}});return store;},});return __exports;});;

/* /mail/static/src/core/public_web/thread_model_patch.js */
odoo.define('@mail/core/public_web/thread_model_patch',['@web/core/utils/patch','@mail/core/common/thread_model','@mail/core/common/record','@web/core/browser/router'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{Thread}=require("@mail/core/common/thread_model");const{Record}=require("@mail/core/common/record");const{router}=require("@web/core/browser/router");patch(Thread.prototype,{setup(){super.setup(...arguments);this.discussAppCategory=Record.one("DiscussAppCategory",{compute(){return this._computeDiscussAppCategory();},});},_computeDiscussAppCategory(){if(["group","chat"].includes(this.channel_type)){return this.store.discuss.chats;}
if(this.channel_type==="channel"&&!this.parent_channel_id){return this.store.discuss.channels;}},notifyMessageToUser(message){const channel_notifications=this.custom_notifications||this.store.settings.channel_notifications;if(!this.mute_until_dt&&!this.store.settings.mute_until_dt&&(this.channel_type!=="channel"||(this.channel_type==="channel"&&(channel_notifications==="all"||(channel_notifications==="mentions"&&message.recipients?.includes(this.store.self)))))){if(this.model==="discuss.channel"){let chatWindow=this.store.ChatWindow.get({thread:this});if(!chatWindow){chatWindow=this.store.ChatWindow.insert({thread:this});if(this.autoOpenChatWindowOnNewMessage&&!this.store.discuss.isActive&&this.store.chatHub.opened.length<this.store.chatHub.maxOpened){chatWindow.open();}else{chatWindow.fold();}}}
this.store.env.services["mail.out_of_focus"].notify(message,this);}},get autoOpenChatWindowOnNewMessage(){return false;},setAsDiscussThread(pushState){if(pushState===undefined){pushState=this.notEq(this.store.discuss.thread);}
this.store.discuss.thread=this;this.store.discuss.activeTab=!this.store.env.services.ui.isSmall||this.model==="mail.box"?"main":["chat","group"].includes(this.channel_type)?"chat":"channel";if(pushState){this.setActiveURL();}
if(this.store.env.services.ui.isSmall&&this.model!=="mail.box"&&!this.store.shouldDisplayWelcomeViewInitially){this.open();}},setActiveURL(){const activeId=typeof this.id==="string"?`mail.box_${this.id}`:`discuss.channel_${this.id}`;router.pushState({active_id:activeId});if(this.store.action_discuss_id&&this.store.env.services.action?.currentController?.action.id===this.store.action_discuss_id){this.store.env.services.action.currentController.action.context.active_id=activeId;}},open(options){if(this.store.env.services.ui.isSmall){this.openChatWindow(options);return;}
this.setAsDiscussThread();},async unpin(){this.isLocallyPinned=false;if(this.eq(this.store.discuss.thread)){router.replaceState({active_id:undefined});}
if(this.model==="discuss.channel"&&this.is_pinned){return this.store.env.services.orm.silent.call("discuss.channel","channel_pin",[this.id],{pinned:false});}},});return __exports;});;

/* /mail/static/src/core/web_portal/message_patch.js */
odoo.define('@mail/core/web_portal/message_patch',['@web/core/utils/patch','@mail/core/common/message','@odoo/owl','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{Message}=require("@mail/core/common/message");const{onWillUnmount}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");patch(Message.prototype,{setup(){super.setup(...arguments);this.state.lastReadMoreIndex=0;this.state.isReadMoreByIndex=new Map();onWillUnmount(()=>{this.messageBody.el?.querySelector(".o-mail-read-more-less")?.remove();});},prepareMessageBody(bodyEl){super.prepareMessageBody(...arguments);Array.from(bodyEl.querySelectorAll(".o-mail-read-more-less")).forEach((el)=>el.remove());this.insertReadMoreLess(bodyEl);},insertReadMoreLess(bodyEl){function prevAll(e,selector){const res=[];while((e=e.previousElementSibling)){if(e.matches(selector)){res.push(e);}}
return res;}
function prev(e,selector){while((e=e.previousElementSibling)){if(e.matches(selector)){return e;}}}
function hide(el){el.dataset.oMailDisplay=el.style.display;el.style.display="none";}
function toggle(el,condition=false){if(condition){let newDisplay=el.dataset.oMailDisplay;if(newDisplay==="none"){newDisplay=null;}
el.style.display=newDisplay;}else{hide(el);}}
const groups=[];let readMoreNodes;const ELEMENT_NODE=1;const TEXT_NODE=3;const childrenEl=Array.from(bodyEl.childNodes).filter(function(childEl){return(childEl.nodeType===ELEMENT_NODE||(childEl.nodeType===TEXT_NODE&&childEl.nodeValue.trim()));});for(const childEl of childrenEl){if(childEl.nodeType===TEXT_NODE&&prevAll(childEl,'[id*="stopSpelling"]').length>0){const newChildEl=document.createElement("span");newChildEl.textContent=childEl.textContent;newChildEl.dataset.oMailQuote="1";childEl.parentNode.replaceChild(newChildEl,childEl);}
if((childEl.nodeType===ELEMENT_NODE&&childEl.getAttribute("data-o-mail-quote"))||(childEl.nodeName==="BR"&&prev(childEl,'[data-o-mail-quote="1"]'))){if(!readMoreNodes){readMoreNodes=[];groups.push(readMoreNodes);}
hide(childEl);readMoreNodes.push(childEl);}else{readMoreNodes=undefined;this.insertReadMoreLess(childEl);}}
for(const group of groups){const index=this.state.lastReadMoreIndex++;const readMoreLessEl=document.createElement("a");readMoreLessEl.style.display="block";readMoreLessEl.className="o-mail-read-more-less";readMoreLessEl.href="#";readMoreLessEl.textContent=_t("Read More");group[0].parentNode.insertBefore(readMoreLessEl,group[0]);if(!this.state.isReadMoreByIndex.has(index)){this.state.isReadMoreByIndex.set(index,true);}
const updateFromState=()=>{const isReadMore=this.state.isReadMoreByIndex.get(index);for(const childEl of group){hide(childEl);toggle(childEl,!isReadMore);}
readMoreLessEl.textContent=isReadMore?_t("Read More").toString():_t("Read Less").toString();};readMoreLessEl.addEventListener("click",(e)=>{e.preventDefault();this.state.isReadMoreByIndex.set(index,!this.state.isReadMoreByIndex.get(index));updateFromState();});updateFromState();}},});return __exports;});;

/* /mail/static/src/core/web/activity.js */
odoo.define('@mail/core/web/activity',['@mail/core/common/attachment_uploader_hook','@mail/core/web/activity_mail_template','@mail/core/web/activity_markasdone_popover','@mail/utils/common/dates','@mail/discuss/web/avatar_card/avatar_card_popover','@odoo/owl','@web/core/browser/browser','@web/core/l10n/translation','@web/core/popover/popover_hook','@web/core/utils/hooks','@web/views/fields/file_handler'],function(require){'use strict';let __exports={};const{useAttachmentUploader}=require("@mail/core/common/attachment_uploader_hook");const{ActivityMailTemplate}=require("@mail/core/web/activity_mail_template");const{ActivityMarkAsDone}=require("@mail/core/web/activity_markasdone_popover");const{computeDelay,getMsToTomorrow}=require("@mail/utils/common/dates");const{AvatarCardPopover}=require("@mail/discuss/web/avatar_card/avatar_card_popover");const{Component,onMounted,onWillUnmount,useState}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const{usePopover}=require("@web/core/popover/popover_hook");const{useService}=require("@web/core/utils/hooks");const{FileUploader}=require("@web/views/fields/file_handler");const Activity=__exports.Activity=class Activity extends Component{static components={ActivityMailTemplate,FileUploader};static props=["activity","onActivityChanged","reloadParentView"];static template="mail.Activity";setup(){super.setup();this.storeService=useService("mail.store");this.state=useState({showDetails:false});this.markDonePopover=usePopover(ActivityMarkAsDone,{position:"right"});this.avatarCard=usePopover(AvatarCardPopover);onMounted(()=>{this.updateDelayAtNight();});onWillUnmount(()=>browser.clearTimeout(this.updateDelayMidnightTimeout));this.attachmentUploader=useAttachmentUploader(this.thread);}
get displayName(){if(this.props.activity.summary){return _t("“%s”",this.props.activity.summary);}
return this.props.activity.display_name;}
updateDelayAtNight(){browser.clearTimeout(this.updateDelayMidnightTimeout);this.updateDelayMidnightTimeout=browser.setTimeout(()=>this.render(),getMsToTomorrow()+100);}
get delay(){return computeDelay(this.props.activity.date_deadline);}
toggleDetails(){this.state.showDetails=!this.state.showDetails;}
async onClickMarkAsDone(ev){if(this.markDonePopover.isOpen){this.markDonePopover.close();return;}
this.markDonePopover.open(ev.currentTarget,{activity:this.props.activity,hasHeader:true,onActivityChanged:this.props.onActivityChanged,});}
async onFileUploaded(data){const thread=this.thread;const{id:attachmentId}=await this.attachmentUploader.uploadData(data,{activity:this.props.activity,});await this.props.activity.markAsDone([attachmentId]);this.props.onActivityChanged(thread);await thread.fetchNewMessages();}
onClickAvatar(ev){const target=ev.currentTarget;if(!this.avatarCard.isOpen){this.avatarCard.open(target,{id:this.props.activity.persona.userId,});}}
async edit(){const thread=this.thread;await this.props.activity.edit();this.props.onActivityChanged(thread);}
async unlink(){const thread=this.thread;this.props.activity.remove();await this.env.services.orm.unlink("mail.activity",[this.props.activity.id]);this.props.onActivityChanged(thread);}
get thread(){return this.env.services["mail.store"].Thread.insert({model:this.props.activity.res_model,id:this.props.activity.res_id,});}
async onClick(ev){this.storeService.handleClickOnLink(ev,this.thread);}}
return __exports;});;

/* /mail/static/src/core/web/activity_button.js */
odoo.define('@mail/core/web/activity_button',['@mail/core/web/activity_list_popover','@odoo/owl','@web/core/l10n/translation','@web/core/popover/popover_hook'],function(require){'use strict';let __exports={};const{ActivityListPopover}=require("@mail/core/web/activity_list_popover");const{Component,useEnv,useRef}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{usePopover}=require("@web/core/popover/popover_hook");const ActivityButton=__exports.ActivityButton=class ActivityButton extends Component{static props={record:{type:Object},};static template="mail.ActivityButton";setup(){super.setup();this.popover=usePopover(ActivityListPopover,{position:"bottom-start"});this.buttonRef=useRef("button");this.env=useEnv();}
get buttonClass(){const classes=[];switch(this.props.record.data.activity_state){case"overdue":classes.push("text-danger");break;case"today":classes.push("text-warning");break;case"planned":classes.push("text-success");break;default:classes.push("text-muted");break;}
switch(this.props.record.data.activity_exception_decoration){case"warning":classes.push("text-warning");classes.push(this.props.record.data.activity_exception_icon);break;case"danger":classes.push("text-danger");classes.push(this.props.record.data.activity_exception_icon);break;default:{const{activity_ids,activity_type_icon}=this.props.record.data;if(activity_ids.records.length){classes.push(activity_type_icon||"fa-tasks");break;}
classes.push("fa-clock-o btn-link text-dark");break;}}
return classes.join(" ");}
get title(){if(this.props.record.data.activity_exception_decoration){return _t("Warning");}
if(this.props.record.data.activity_summary){return this.props.record.data.activity_summary;}
if(this.props.record.data.activity_type_id){return this.props.record.data.activity_type_id[1];}
return _t("Show activities");}
async onClick(){if(this.popover.isOpen){this.popover.close();}else{const resId=this.props.record.resId;const selectedRecords=this.env?.model?.root?.selection??[];const selectedIds=selectedRecords.map((r)=>r.resId);const resIds=selectedIds.includes(resId)&&selectedIds.length>1?selectedIds:undefined;this.popover.open(this.buttonRef.el,{activityIds:this.props.record.data.activity_ids.currentIds,onActivityChanged:(thread)=>{const recordToLoad=resIds?selectedRecords:[this.props.record];recordToLoad.forEach((r)=>r.load());this.popover.close();},resId,resIds,resModel:this.props.record.resModel,});}}}
return __exports;});;

/* /mail/static/src/core/web/activity_list_popover.js */
odoo.define('@mail/core/web/activity_list_popover',['@mail/core/web/activity_list_popover_item','@mail/utils/common/misc','@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{ActivityListPopoverItem}=require("@mail/core/web/activity_list_popover_item");const{compareDatetime}=require("@mail/utils/common/misc");const{Component,onWillUpdateProps,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const ActivityListPopover=__exports.ActivityListPopover=class ActivityListPopover extends Component{static components={ActivityListPopoverItem};static props=["activityIds","close","defaultActivityTypeId?","onActivityChanged","resId","resIds?","resModel",];static template="mail.ActivityListPopover";setup(){super.setup();this.orm=useService("orm");this.store=useState(useService("mail.store"));this.updateFromProps(this.props);onWillUpdateProps((props)=>this.updateFromProps(props));}
get activities(){const allActivities=Object.values(this.store.Activity.records);return allActivities.filter((activity)=>this.props.activityIds.includes(activity.id)).sort((a,b)=>compareDatetime(a.date_deadline,b.date_deadline)||a.id-b.id);}
onClickAddActivityButton(){this.store.scheduleActivity(this.props.resModel,this.props.resIds?this.props.resIds:[this.props.resId],this.props.defaultActivityTypeId).then(()=>this.props.onActivityChanged());this.props.close();}
get doneActivities(){return this.activities.filter((activity)=>activity.state==="done");}
get overdueActivities(){return this.activities.filter((activity)=>activity.state==="overdue");}
get plannedActivities(){return this.activities.filter((activity)=>activity.state==="planned");}
get todayActivities(){return this.activities.filter((activity)=>activity.state==="today");}
async updateFromProps(props){const data=await this.orm.silent.call("mail.activity","activity_format",[props.activityIds,]);this.store.insert(data,{html:true});}}
return __exports;});;

/* /mail/static/src/core/web/activity_list_popover_item.js */
odoo.define('@mail/core/web/activity_list_popover_item',['@mail/core/common/attachment_uploader_hook','@mail/core/web/activity_mail_template','@mail/core/web/activity_markasdone_popover','@mail/utils/common/dates','@odoo/owl','@web/core/l10n/translation','@web/core/utils/urls','@web/views/fields/file_handler'],function(require){'use strict';let __exports={};const{useAttachmentUploader}=require("@mail/core/common/attachment_uploader_hook");const{ActivityMailTemplate}=require("@mail/core/web/activity_mail_template");const{ActivityMarkAsDone}=require("@mail/core/web/activity_markasdone_popover");const{computeDelay}=require("@mail/utils/common/dates");const{Component,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{url}=require("@web/core/utils/urls");const{FileUploader}=require("@web/views/fields/file_handler");const ActivityListPopoverItem=__exports.ActivityListPopoverItem=class ActivityListPopoverItem extends Component{static components={ActivityMailTemplate,ActivityMarkAsDone,FileUploader};static props=["activity","onActivityChanged?","onClickDoneAndScheduleNext?","onClickEditActivityButton?",];static template="mail.ActivityListPopoverItem";setup(){super.setup();this.state=useState({hasMarkDoneView:false});if(this.props.activity.activity_category==="upload_file"){this.attachmentUploader=useAttachmentUploader(this.env.services["mail.store"].Thread.insert({model:this.props.activity.res_model,id:this.props.activity.res_id,}));}
this.closeMarkAsDone=this.closeMarkAsDone.bind(this);}
closeMarkAsDone(){this.state.hasMarkDoneView=false;}
get delayLabel(){const diff=computeDelay(this.props.activity.date_deadline);if(diff===0){return _t("Today");}else if(diff===-1){return _t("Yesterday");}else if(diff<0){return _t("%s days overdue",Math.round(Math.abs(diff)));}else if(diff===1){return _t("Tomorrow");}else{return _t("Due in %s days",Math.round(Math.abs(diff)));}}
get hasCancelButton(){const activity=this.props.activity;return activity.state!=="done"&&activity.can_write;}
get hasEditButton(){const activity=this.props.activity;return activity.state!=="done"&&activity.can_write;}
get hasFileUploader(){const activity=this.props.activity;return activity.state!=="done"&&activity.activity_category==="upload_file";}
get hasMarkDoneButton(){return this.props.activity.state!=="done"&&!this.hasFileUploader;}
onClickEditActivityButton(){this.props.onClickEditActivityButton();this.props.activity.edit().then(()=>this.props.onActivityChanged?.());}
onClickMarkAsDone(){this.state.hasMarkDoneView=!this.state.hasMarkDoneView;}
async onFileUploaded(data){const{id:attachmentId}=await this.attachmentUploader.uploadData(data,{activity:this.props.activity,});await this.props.activity.markAsDone([attachmentId]);this.props.onActivityChanged?.();}
unlink(){this.props.activity.remove();this.env.services.orm.unlink("mail.activity",[this.props.activity.id]).then(()=>this.props.onActivityChanged?.());}
get activityAssigneeAvatar(){return url("/web/image",{field:"avatar_128",id:this.props.activity.user_id[0],model:"res.users",});}}
return __exports;});;

/* /mail/static/src/core/web/activity_mail_template.js */
odoo.define('@mail/core/web/activity_mail_template',['@odoo/owl','@web/core/utils/hooks','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const ActivityMailTemplate=__exports.ActivityMailTemplate=class ActivityMailTemplate extends Component{static defaultProps={onClickButtons:()=>{},};static props=["activity","onClickButtons?","onActivityChanged?"];static template="mail.ActivityMailTemplate";setup(){super.setup();this.store=useState(useService("mail.store"));}
onClickPreview(ev,mailTemplate){ev.stopPropagation();ev.preventDefault();this.props.onClickButtons();const action={name:_t("Compose Email"),type:"ir.actions.act_window",res_model:"mail.compose.message",views:[[false,"form"]],target:"new",context:{default_res_ids:[this.props.activity.res_id],default_model:this.props.activity.res_model,default_subtype_xmlid:"mail.mt_comment",default_template_id:mailTemplate.id,force_email:true,},};const thread=this.store.Thread.insert({model:this.props.activity.res_model,id:this.props.activity.res_id,});this.env.services.action.doAction(action,{onClose:()=>this.props.onActivityChanged?.(thread),});}
async onClickSend(ev,mailTemplate){ev.stopPropagation();ev.preventDefault();this.props.onClickButtons();const thread=this.store.Thread.insert({model:this.props.activity.res_model,id:this.props.activity.res_id,});await this.env.services.orm.call(this.props.activity.res_model,"activity_send_mail",[[this.props.activity.res_id],mailTemplate.id,]);this.props.onActivityChanged?.(thread);}}
return __exports;});;

/* /mail/static/src/core/web/activity_markasdone_popover.js */
odoo.define('@mail/core/web/activity_markasdone_popover',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,onMounted,useExternalListener,useRef}=require("@odoo/owl");const ActivityMarkAsDone=__exports.ActivityMarkAsDone=class ActivityMarkAsDone extends Component{static template="mail.ActivityMarkAsDone";static props=["activity","close?","hasHeader?","onClickDoneAndScheduleNext?","onActivityChanged",];static defaultProps={hasHeader:false,};get isSuggested(){return this.props.activity.chaining_type==="suggest";}
setup(){super.setup();this.textArea=useRef("textarea");onMounted(()=>{this.textArea.el.focus();});useExternalListener(window,"keydown",this.onKeydown);}
onKeydown(ev){if(ev.key==="Escape"&&this.props.close){this.props.close();}}
async onClickDone(){const{res_id,res_model}=this.props.activity;const thread=this.env.services["mail.store"].Thread.insert({model:res_model,id:res_id,});await this.props.activity.markAsDone();this.props.onActivityChanged(thread);await thread.fetchNewMessages();}
async onClickDoneAndScheduleNext(){const{res_id,res_model}=this.props.activity;const thread=this.env.services["mail.store"].Thread.insert({model:res_model,id:res_id,});if(this.props.onClickDoneAndScheduleNext){this.props.onClickDoneAndScheduleNext();}
if(this.props.close){this.props.close();}
const action=await this.props.activity.markAsDoneAndScheduleNext();thread.fetchNewMessages();this.props.onActivityChanged(thread);if(!action){return;}
await new Promise((resolve)=>{this.env.services.action.doAction(action,{onClose:resolve,});});this.props.onActivityChanged(thread);}}
return __exports;});;

/* /mail/static/src/core/web/activity_menu.js */
odoo.define('@mail/core/web/activity_menu',['@odoo/owl','@mail/utils/common/hooks','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_hooks','@web/core/registry','@web/core/utils/hooks','@web/core/domain','@web/core/user'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{useDiscussSystray}=require("@mail/utils/common/hooks");const{Dropdown}=require("@web/core/dropdown/dropdown");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{Domain}=require("@web/core/domain");const{user}=require("@web/core/user");const ActivityMenu=__exports.ActivityMenu=class ActivityMenu extends Component{static components={Dropdown};static props=[];static template="mail.ActivityMenu";setup(){super.setup();this.discussSystray=useDiscussSystray();this.store=useState(useService("mail.store"));this.action=useService("action");this.userId=user.userId;this.ui=useState(useService("ui"));this.dropdown=useDropdownState();}
onBeforeOpen(){this.store.fetchData({systray_get_activities:true});}
availableViews(group){return[[false,"kanban"],[false,"list"],[false,"form"],[false,"activity"],];}
openActivityGroup(group,filter="all"){this.dropdown.close();const context={force_search_count:1,};if(group.model==="mail.activity"){this.action.doAction("mail.mail_activity_without_access_action",{additionalContext:{active_ids:group.activity_ids,active_model:"mail.activity",},});return;}
if(filter==="all"){context["search_default_activities_overdue"]=1;context["search_default_activities_today"]=1;}
else if(filter==="overdue"){context["search_default_activities_overdue"]=1;}
else if(filter==="today"){context["search_default_activities_today"]=1;}
else if(filter==="upcoming_all"){context["search_default_activities_upcoming_all"]=1;}
let domain=[["activity_user_id","=",this.userId]];if(group.domain){domain=Domain.and([domain,group.domain]).toList();}
const views=this.availableViews(group);this.action.doAction({context,domain,name:group.name,res_model:group.model,search_view_id:[false],type:"ir.actions.act_window",views,},{clearBreadcrumbs:true,viewType:group.view_type,});}
openMyActivities(){this.dropdown.close();this.action.doAction("mail.mail_activity_action_my",{clearBreadcrumbs:true});}}
registry.category("systray").add("mail.activity_menu",{Component:ActivityMenu},{sequence:20});return __exports;});;

/* /mail/static/src/core/web/activity_model.js */
odoo.define('@mail/core/web/activity_model',['@mail/core/common/record','@mail/utils/common/misc','@web/core/l10n/translation','@web/core/l10n/dates'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{assignDefined}=require("@mail/utils/common/misc");const{_t}=require("@web/core/l10n/translation");const{formatDate,formatDateTime}=require("@web/core/l10n/dates");const Activity=__exports.Activity=class Activity extends Record{static id="id";static records={};static get(data){return super.get(data);}
static insert(data,{broadcast=true}={}){return super.insert(...arguments);}
static _insert(data,{broadcast=true}={}){const activity=this.preinsert(data);if(data.request_partner_id){data.request_partner_id=data.request_partner_id[0];}
assignDefined(activity,data);if(broadcast){this.store.activityBroadcastChannel?.postMessage({type:"INSERT",payload:activity.serialize(),});}
return activity;}
active;activity_category;activity_type_id;activity_decoration;attachment_ids;can_write;chaining_type;create_date=Record.attr(undefined,{type:"datetime"});create_uid;date_deadline=Record.attr(undefined,{type:"date"});date_done=Record.attr(undefined,{type:"date"});display_name;has_recommended_activities;feedback;icon="fa-tasks";id;mail_template_ids;note=Record.attr("",{html:true});persona=Record.one("Persona");previous_activity_type_id;recommended_activity_type_id;res_model;res_model_id;res_id;res_name;request_partner_id;state;summary;user_id;write_date;write_uid;get dateDeadlineFormatted(){return formatDate(this.date_deadline);}
get dateDoneFormatted(){return formatDate(this.date_done);}
get dateCreateFormatted(){return formatDateTime(this.create_date);}
async edit(){return new Promise((resolve)=>this.store.env.services.action.doAction({type:"ir.actions.act_window",name:_t("Schedule Activity"),res_model:"mail.activity",view_mode:"form",views:[[false,"form"]],target:"new",res_id:this.id,context:{default_res_model:this.res_model,default_res_id:this.res_id,},},{onClose:resolve}));}
async markAsDone(attachmentIds=[]){await this.store.env.services.orm.call("mail.activity","action_feedback",[[this.id]],{attachment_ids:attachmentIds,feedback:this.feedback,});this.store.activityBroadcastChannel?.postMessage({type:"RELOAD_CHATTER",payload:{id:this.res_id,model:this.res_model},});}
async markAsDoneAndScheduleNext(){const action=await this.store.env.services.orm.call("mail.activity","action_feedback_schedule_next",[[this.id]],{feedback:this.feedback});this.activityBroadcastChannel?.postMessage({type:"RELOAD_CHATTER",payload:{id:this.res_id,model:this.res_model},});return action;}
remove({broadcast=true}={}){this.delete();if(broadcast){this.activityBroadcastChannel?.postMessage({type:"DELETE",payload:{id:this.id},});}}
serialize(){return JSON.parse(JSON.stringify(this.toData()));}}
Activity.register();return __exports;});;

/* /mail/static/src/core/web/base_recipients_list.js */
odoo.define('@mail/core/web/base_recipients_list',['@web/core/l10n/translation','@web/core/utils/strings','@web/core/l10n/utils','@odoo/owl','@web/core/popover/popover_hook','@mail/core/web/recipient_list','@mail/core/web/suggested_recipient_list','@mail/core/common/thread_model'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{escape}=require("@web/core/utils/strings");const{formatList}=require("@web/core/l10n/utils");const{markup,Component}=require("@odoo/owl");const{usePopover}=require("@web/core/popover/popover_hook");const{RecipientList}=require("@mail/core/web/recipient_list");const{SuggestedRecipientsList}=require("@mail/core/web/suggested_recipient_list");const{Thread}=require("@mail/core/common/thread_model");const BaseRecipientsList=__exports.BaseRecipientsList=class BaseRecipientsList extends Component{static template="mail.BaseRecipientsList";static components={SuggestedRecipientsList};static props={thread:{type:Thread}};setup(){this.recipientsPopover=usePopover(RecipientList);}
getRecipientListToHTML(){const recipients=this.props.thread.recipients.slice(0,5).map(({partner})=>{const text=partner.email?partner.emailWithoutDomain:partner.name;return`<span class="text-muted" title="${escape(
                    partner.email || _t("no email address")
                )}">${escape(text)}</span>`;});if(this.props.thread.recipients.length>5){recipients.push(escape(_t("%(recipientCount)s more",{recipientCount:this.props.thread.recipients.length-5})));}
return markup(formatList(recipients));}
onClickRecipientList(ev){if(this.recipientsPopover.isOpen){return this.recipientsPopover.close();}
this.recipientsPopover.open(ev.target,{thread:this.props.thread});}};return __exports;});;

/* /mail/static/src/core/web/chat_window_model_patch.js */
odoo.define('@mail/core/web/chat_window_model_patch',['@mail/core/common/chat_window_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ChatWindow}=require("@mail/core/common/chat_window_model");const{patch}=require("@web/core/utils/patch");patch(ChatWindow.prototype,{async _onClose(options){if(this.store.env.services.ui.isSmall&&!this.store.discuss.isActive&&this.fromMessagingMenu){document.querySelector(".o_menu_systray i[aria-label='Messages']")?.click();await Promise.resolve();}
await super._onClose(options);},});return __exports;});;

/* /mail/static/src/core/web/command_category.js */
odoo.define('@mail/core/web/command_category',['@web/core/l10n/translation','@web/core/registry'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const commandCategoryRegistry=registry.category("command_categories");commandCategoryRegistry.add("discuss_mentioned",{namespace:"@",name:_t("Mentions")},{sequence:10}).add("discuss_recent",{namespace:"#",name:_t("Recent")},{sequence:10});return __exports;});;

/* /mail/static/src/core/web/composer_patch.js */
odoo.define('@mail/core/web/composer_patch',['@html_editor/main/signature_plugin','@html_editor/utils/dom','@html_editor/utils/dom_traversal','@html_editor/utils/html','@mail/core/common/composer','@web/core/utils/patch','@web/core/utils/render'],function(require){'use strict';let __exports={};const{SIGNATURE_CLASS}=require("@html_editor/main/signature_plugin");const{wrapInlinesInBlocks}=require("@html_editor/utils/dom");const{childNodes}=require("@html_editor/utils/dom_traversal");const{parseHTML}=require("@html_editor/utils/html");const{Composer}=require("@mail/core/common/composer");const{patch}=require("@web/core/utils/patch");const{renderToElement}=require("@web/core/utils/render");patch(Composer.prototype,{formatDefaultBodyForFullComposer(defaultBody,signature=""){const fragment=parseHTML(document,defaultBody);if(!fragment.firstChild){fragment.append(document.createElement("BR"));}
if(signature){const signatureEl=renderToElement("html_editor.Signature",{signature,signatureClass:SIGNATURE_CLASS,});fragment.append(signatureEl);}
const container=document.createElement("DIV");container.append(...childNodes(fragment));wrapInlinesInBlocks(container,{baseContainerNodeName:"DIV"});return container.innerHTML;},});return __exports;});;

/* /mail/static/src/core/web/dialog_patch.js */
odoo.define('@mail/core/web/dialog_patch',['@web/core/dialog/dialog','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{patch}=require("@web/core/utils/patch");patch(Dialog.prototype,{onEscape(){if(this.data.model==="mail.compose.message"){return;}
super.onEscape();},});return __exports;});;

/* /mail/static/src/core/web/discuss_patch.js */
odoo.define('@mail/core/web/discuss_patch',['@odoo/owl','@mail/core/public_web/discuss','@mail/core/public_web/messaging_menu','@web/search/control_panel/control_panel','@web/core/l10n/translation','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{useEffect}=require("@odoo/owl");const{Discuss}=require("@mail/core/public_web/discuss");const{MessagingMenu}=require("@mail/core/public_web/messaging_menu");const{ControlPanel}=require("@web/search/control_panel/control_panel");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");Object.assign(Discuss.components,{ControlPanel,MessagingMenu});patch(Discuss.prototype,{setup(){super.setup();this.prevInboxCounter=this.store.inbox.counter;useEffect((threadName)=>{if(threadName){this.env.config?.setDisplayName(threadName);}},()=>[this.thread?.displayName]);useEffect(()=>{if(this.thread?.id==="inbox"&&this.prevInboxCounter!==this.store.inbox.counter&&this.store.inbox.counter===0){this.effect.add({message:_t("Congratulations, your inbox is empty!"),type:"rainbow_man",fadeout:"fast",});}
this.prevInboxCounter=this.store.inbox.counter;},()=>[this.store.inbox.counter]);},});return __exports;});;

/* /mail/static/src/core/web/discuss_sidebar_mailboxes.js */
odoo.define('@mail/core/web/discuss_sidebar_mailboxes',['@mail/core/common/thread_icon','@mail/core/public_web/discuss_sidebar','@mail/utils/common/hooks','@odoo/owl','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_hooks','@web/core/utils/hooks','@web/core/utils/misc'],function(require){'use strict';let __exports={};const{ThreadIcon}=require("@mail/core/common/thread_icon");const{discussSidebarItemsRegistry}=require("@mail/core/public_web/discuss_sidebar");const{useHover}=require("@mail/utils/common/hooks");const{Component,useRef,useState}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const{useService}=require("@web/core/utils/hooks");const{markEventHandled}=require("@web/core/utils/misc");const Mailbox=__exports.Mailbox=class Mailbox extends Component{static template="mail.Mailbox";static props=["mailbox"];static components={Dropdown,ThreadIcon};setup(){super.setup();this.store=useState(useService("mail.store"));this.hover=useHover(["root","floating*"],{onHover:()=>(this.floating.isOpen=true),onAway:()=>(this.floating.isOpen=false),});this.floating=useDropdownState();this.rootRef=useRef("root");}
get mailbox(){return this.props.mailbox;}
openThread(ev){markEventHandled(ev,"sidebar.openThread");this.mailbox.setAsDiscussThread();}}
const DiscussSidebarMailboxes=__exports.DiscussSidebarMailboxes=class DiscussSidebarMailboxes extends Component{static template="mail.DiscussSidebarMailboxes";static props={};static components={Mailbox};setup(){super.setup();this.store=useState(useService("mail.store"));}}
discussSidebarItemsRegistry.add("mailbox",DiscussSidebarMailboxes,{sequence:20});return __exports;});;

/* /mail/static/src/core/web/discuss_sidebar_patch.js */
odoo.define('@mail/core/web/discuss_sidebar_patch',['@web/core/utils/patch','@mail/core/public_web/discuss_sidebar','@web/core/l10n/translation','@odoo/owl','@web/core/utils/hooks','@mail/utils/common/hooks','@web/core/dropdown/dropdown_hooks'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{DiscussSidebar}=require("@mail/core/public_web/discuss_sidebar");const{_t}=require("@web/core/l10n/translation");const{useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{useHover}=require("@mail/utils/common/hooks");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");patch(DiscussSidebar.prototype,{setup(){super.setup();this.ui=useState(useService("ui"));this.meetingHover=useHover(["meeting-btn","meeting-floating*"],{onHover:()=>(this.meetingFloating.isOpen=true),onAway:()=>(this.meetingFloating.isOpen=false),});this.meetingFloating=useDropdownState();},get startMeetingText(){return _t("Start a meeting");},});return __exports;});;

/* /mail/static/src/core/web/follower_list.js */
odoo.define('@mail/core/web/follower_list',['@odoo/owl','@web/core/l10n/translation','@web/core/utils/hooks','@mail/core/web/follower_subtype_dialog','@mail/utils/common/hooks','@web/core/dropdown/dropdown_item'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{FollowerSubtypeDialog}=require("@mail/core/web/follower_subtype_dialog");const{useVisible}=require("@mail/utils/common/hooks");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const FollowerList=__exports.FollowerList=class FollowerList extends Component{static template="mail.FollowerList";static components={DropdownItem};static props=["onAddFollowers?","onFollowerChanged?","thread","dropdown"];setup(){super.setup();this.action=useService("action");this.store=useState(useService("mail.store"));useVisible("load-more",(isVisible)=>{if(isVisible){this.props.thread.loadMoreFollowers();}});}
onClickAddFollowers(){const action={type:"ir.actions.act_window",res_model:"mail.wizard.invite",view_mode:"form",views:[[false,"form"]],name:_t("Add followers to this document"),target:"new",context:{default_res_model:this.props.thread.model,default_res_id:this.props.thread.id,dialog_size:"medium",},};this.action.doAction(action,{onClose:()=>{this.props.onAddFollowers?.();},});}
onClickDetails(ev,follower){this.store.openDocument({id:follower.partner.id,model:"res.partner"});this.props.dropdown.close();}
async onClickEdit(ev,follower){this.env.services.dialog.add(FollowerSubtypeDialog,{follower,onFollowerChanged:()=>this.props.onFollowerChanged?.(this.props.thread),});this.props.dropdown.close();}
async onClickRemove(ev,follower){const thread=this.props.thread;await follower.remove();this.props.onFollowerChanged?.(thread);}}
return __exports;});;

/* /mail/static/src/core/web/follower_subtype_dialog.js */
odoo.define('@mail/core/web/follower_subtype_dialog',['@web/core/network/rpc','@odoo/owl','@web/core/dialog/dialog','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{Component,onWillStart,useState}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const FollowerSubtypeDialog=__exports.FollowerSubtypeDialog=class FollowerSubtypeDialog extends Component{static components={Dialog};static props=["close","follower","onFollowerChanged"];static template="mail.FollowerSubtypeDialog";setup(){super.setup();this.store=useState(useService("mail.store"));this.state=useState({subtypes:[],});onWillStart(async()=>{this.state.subtypes=await rpc("/mail/read_subscription_data",{follower_id:this.props.follower.id,});});}
onChangeCheckbox(ev,subtype){subtype.followed=ev.target.checked;}
async onClickApply(){const selectedSubtypes=this.state.subtypes.filter((s)=>s.followed);const thread=this.props.follower.thread;if(selectedSubtypes.length===0){await this.props.follower.remove();}else{await this.env.services.orm.call(this.props.follower.thread.model,"message_subscribe",[[this.props.follower.thread.id]],{partner_ids:[this.props.follower.partner.id],subtype_ids:selectedSubtypes.map((subtype)=>subtype.id),});if(!selectedSubtypes.some((subtype)=>subtype.id===this.store.mt_comment_id)){this.props.follower.removeRecipient();}
this.env.services.notification.add(_t("The subscription preferences were successfully applied."),{type:"success"});}
this.props.onFollowerChanged(thread);this.props.close();}
get title(){return _t("Edit Subscription of %(name)s",{name:this.props.follower.partner.name});}}
return __exports;});;

/* /mail/static/src/core/web/mail_column_progress.js */
odoo.define('@mail/core/web/mail_column_progress',['@web/views/view_components/column_progress'],function(require){'use strict';let __exports={};const{ColumnProgress}=require("@web/views/view_components/column_progress");const MailColumnProgress=__exports.MailColumnProgress=class MailColumnProgress extends ColumnProgress{static props={...ColumnProgress.props,aggregateOn:{type:Object,optional:true},};static template="mail.ColumnProgress";}
return __exports;});;

/* /mail/static/src/core/web/mail_composer_attachment_list.js */
odoo.define('@mail/core/web/mail_composer_attachment_list',['@web/core/registry','@web/core/utils/hooks','@web/views/fields/many2many_binary/many2many_binary_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{many2ManyBinaryField,Many2ManyBinaryField}=require("@web/views/fields/many2many_binary/many2many_binary_field");const MailComposerAttachmentList=__exports.MailComposerAttachmentList=class MailComposerAttachmentList extends Many2ManyBinaryField{static template="mail.MailComposerAttachmentList";setup(){super.setup();this.mailStore=useService("mail.store");this.attachmentUploadService=useService("mail.attachment_upload");}
async onFileRemove(fileId){super.onFileRemove(fileId);const attachment=this.mailStore.Attachment.insert(fileId);if(attachment){await this.attachmentUploadService.unlink(attachment);}}}
const mailComposerAttachmentList=__exports.mailComposerAttachmentList={...many2ManyBinaryField,component:MailComposerAttachmentList,};registry.category("fields").add("mail_composer_attachment_list",mailComposerAttachmentList);return __exports;});;

/* /mail/static/src/core/web/mail_composer_attachment_selector.js */
odoo.define('@mail/core/web/mail_composer_attachment_selector',['@mail/core/common/attachment_uploader_hook','@web/core/registry','@web/views/fields/standard_field_props','@web/core/utils/hooks','@web/views/fields/relational_utils','@odoo/owl','@web/views/fields/file_handler'],function(require){'use strict';let __exports={};const{dataUrlToBlob}=require("@mail/core/common/attachment_uploader_hook");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{useService}=require("@web/core/utils/hooks");const{useX2ManyCrud}=require("@web/views/fields/relational_utils");const{Component}=require("@odoo/owl");const{FileUploader}=require("@web/views/fields/file_handler");const MailComposerAttachmentSelector=__exports.MailComposerAttachmentSelector=class MailComposerAttachmentSelector extends Component{static template="mail.MailComposerAttachmentSelector";static components={FileUploader};static props={...standardFieldProps};setup(){this.mailStore=useService("mail.store");this.attachmentUploadService=useService("mail.attachment_upload");this.operations=useX2ManyCrud(()=>{return this.props.record.data["attachment_ids"];},true);}
async onFileUploaded({data,name,type}){const resIds=JSON.parse(this.props.record.data.res_ids);const thread=await this.mailStore.Thread.insert({model:this.props.record.data.model,id:resIds[0],});const file=new File([dataUrlToBlob(data,type)],name,{type});const attachment=await this.attachmentUploadService.upload(thread,thread.composer,file);await this.operations.saveRecord([attachment.id]);}}
const mailComposerAttachmentSelector=__exports.mailComposerAttachmentSelector={component:MailComposerAttachmentSelector,};registry.category("fields").add("mail_composer_attachment_selector",mailComposerAttachmentSelector);return __exports;});;

/* /mail/static/src/core/web/mail_composer_chatgpt.js */
odoo.define('@mail/core/web/mail_composer_chatgpt',['@html_editor/main/chatgpt/chatgpt_prompt_dialog','@mail/utils/common/html','@odoo/owl','@web/core/l10n/translation','@web/core/registry','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{ChatGPTPromptDialog}=require("@html_editor/main/chatgpt/chatgpt_prompt_dialog");const{htmlJoin}=require("@mail/utils/common/html");const{Component,markup}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const MailComposerChatGPT=__exports.MailComposerChatGPT=class MailComposerChatGPT extends Component{static template="mail.MailComposerChatGPT";static props={...standardFieldProps};setup(){this.btnLabel=_t("AI");}
async onOpenChatGPTPromptDialogBtnClick(){this.env.services.dialog.add(ChatGPTPromptDialog,{insert:(content)=>{const root=document.createElement("div");root.appendChild(content);const{body}=this.props.record.data;this.props.record.update({body:htmlJoin(body,markup(root.innerHTML)),});},sanitize:(fragment)=>{return DOMPurify.sanitize(fragment,{IN_PLACE:true,ADD_TAGS:["#document-fragment"],ADD_ATTR:["contenteditable"],});},});}}
const mailComposerChatGPT=__exports.mailComposerChatGPT={component:MailComposerChatGPT,fieldDependencies:[{name:"body",type:"text"}],};registry.category("fields").add("mail_composer_chatgpt",mailComposerChatGPT);return __exports;});;

/* /mail/static/src/core/web/mail_composer_recipient_list.js */
odoo.define('@mail/core/web/mail_composer_recipient_list',['@web/core/registry','@web/views/widgets/standard_widget_props','@web/core/utils/hooks','@odoo/owl','@mail/core/web/base_recipients_list'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{useService}=require("@web/core/utils/hooks");const{Component,useState,onWillStart}=require("@odoo/owl");const{BaseRecipientsList}=require("@mail/core/web/base_recipients_list");const MailComposerRecipientList=__exports.MailComposerRecipientList=class MailComposerRecipientList extends Component{static template="mail.MailComposerRecipientList";static components={BaseRecipientsList};static props={...standardWidgetProps,thread_model_field:{type:String},thread_id_field:{type:String},};setup(){const{Thread}=useService("mail.store");this.state=useState({});onWillStart(async()=>{const threadIdFieldType=this.props.record.fields[this.props.thread_id_field].type;let threadId;if(threadIdFieldType==="text"){threadId=JSON.parse(this.props.record.data[this.props.thread_id_field])[0];}else if(threadIdFieldType==="many2one_reference"){threadId=this.props.record.data[this.props.thread_id_field].resId;}else{console.error("Thread id field type not supported");return;}
try{const thread=await Thread.getOrFetch({model:this.props.record.data[this.props.thread_model_field],id:threadId,});this.state.thread=thread;}catch(e){console.error(e);}});}}
const mailComposerRecipientList={component:MailComposerRecipientList,extractProps:({attrs})=>({thread_model_field:attrs.thread_model_field,thread_id_field:attrs.thread_id_field,}),};registry.category("view_widgets").add("mail_composer_recipient_list",mailComposerRecipientList);return __exports;});;

/* /mail/static/src/core/web/mail_composer_template_selector.js */
odoo.define('@mail/core/web/mail_composer_template_selector',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/strings','@web/views/fields/standard_field_props','@web/core/user','@web/core/utils/hooks','@odoo/owl','@web/core/confirmation_dialog/confirmation_dialog','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/views/view_dialogs/select_create_dialog'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{sprintf}=require("@web/core/utils/strings");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{Component,useState,onWillStart}=require("@odoo/owl");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{SelectCreateDialog}=require("@web/views/view_dialogs/select_create_dialog");const MailComposerTemplateSelector=__exports.MailComposerTemplateSelector=class MailComposerTemplateSelector extends Component{static template="mail.MailComposerTemplateSelector";static components={Dropdown,DropdownItem};static props={...standardFieldProps};setup(){this.action=useService("action");this.orm=useService("orm");this.state=useState({});this.limit=7;onWillStart(()=>{this.fetchTemplates();});}
async fetchTemplates(){const fields=["display_name"];const templates=await this.orm.searchRead("mail.template",[["model","=",this.props.record.data.render_model],["user_id","=",user.userId]],fields,{limit:this.limit});if(templates.length<this.limit){templates.push(...await this.orm.searchRead("mail.template",[["model","=",this.props.record.data.render_model],["user_id","!=",user.userId]],fields,{limit:this.limit-templates.length}));}
this.state.templates=templates;}
async onLoadTemplate(template){await this.props.record.update({template_id:[template.id]});}
async onDeleteTemplate(template){this.env.services.dialog.add(ConfirmationDialog,{body:sprintf(_t('Are you sure you want to delete "%(template_name)s"?'),{template_name:template.display_name,}),confirmLabel:_t("Delete Template"),confirm:async()=>{await this.orm.unlink("mail.template",[template.id]);this.state.templates=this.state.templates.filter(current=>{return current.id!==template.id;});},cancel:()=>{},});}
async onOverwriteTemplate(template){this.env.services.dialog.add(ConfirmationDialog,{body:sprintf(_t('Are your sure you want to update "%(template_name)s"?'),{template_name:template.display_name,}),confirmLabel:_t("Update Template"),confirm:async()=>{await this.orm.write("mail.template",[template.id],{subject:this.props.record.data.subject,body_html:this.props.record.data.body,});},cancel:()=>{},});}
async onSaveTemplate(){if(!(await this.props.record.save())){return;}
await this.action.doActionButton({type:"object",name:"open_template_creation_wizard",resId:this.props.record.resId,resModel:this.props.record.resModel});}
onSelectTemplateSearchMoreBtnClick(){this.env.services.dialog.add(SelectCreateDialog,{resModel:"mail.template",title:_t("Insert Templates"),multiSelect:false,noCreate:true,domain:[["model","=",this.props.record.data.render_model]],onSelected:async templateIds=>{await this.props.record.update({template_id:templateIds});},});}
onDeleteTemplateSearchMoreBtnClick(){this.env.services.dialog.add(SelectCreateDialog,{resModel:"mail.template",title:_t("Delete Template"),multiSelect:true,noCreate:true,domain:[["model","=",this.props.record.data.render_model]],onSelected:async templateIds=>{await this.orm.unlink("mail.template",templateIds);this.state.templates=this.state.templates.filter(current=>{return!templateIds.includes(current.id);});},});}
onOverwriteTemplateSearchMoreBtnClick(){this.env.services.dialog.add(SelectCreateDialog,{resModel:"mail.template",title:_t("Overwrite Template"),multiSelect:false,noCreate:true,domain:[["model","=",this.props.record.data.render_model]],onSelected:async templateIds=>{await this.orm.write("mail.template",templateIds,{subject:this.props.record.data.subject,body_html:this.props.record.data.body,});},});}}
const mailComposerTemplateSelector=__exports.mailComposerTemplateSelector={component:MailComposerTemplateSelector,fieldDependencies:[{name:"can_edit_body",type:"boolean"},{name:"render_model",type:"string"},],};registry.category("fields").add("mail_composer_template_selector",mailComposerTemplateSelector);return __exports;});;

/* /mail/static/src/core/web/mail_core_common_service_patch.js */
odoo.define('@mail/core/web/mail_core_common_service_patch',['@web/core/utils/patch','@mail/core/common/mail_core_common_service'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{MailCoreCommon}=require("@mail/core/common/mail_core_common_service");patch(MailCoreCommon.prototype,{_handleNotificationToggleStar(payload,metadata){super._handleNotificationToggleStar(payload,metadata);const{id:notifId}=metadata;const{message_ids:messageIds,starred}=payload;for(const id of messageIds){const message=this.store.Message.get({id});const starredBox=this.store.starred;if(starred){if(notifId>starredBox.counter_bus_id){starredBox.counter++;}
starredBox.messages.add(message);}else{if(notifId>starredBox.counter_bus_id){starredBox.counter--;}
starredBox.messages.delete(message);}}},});return __exports;});;

/* /mail/static/src/core/web/mail_core_web_service.js */
odoo.define('@mail/core/web/mail_core_web_service',['@odoo/owl','@web/core/registry'],function(require){'use strict';let __exports={};const{reactive}=require("@odoo/owl");const{registry}=require("@web/core/registry");const MailCoreWeb=__exports.MailCoreWeb=class MailCoreWeb{constructor(env,services){this.env=env;this.busService=services.bus_service;this.store=services["mail.store"];}
setup(){this.busService.subscribe("mail.activity/updated",(payload,{id:notifId})=>{if(payload.activity_created&&notifId>this.store.activity_counter_bus_id){this.store.activityCounter++;}
if(payload.activity_deleted&&notifId>this.store.activity_counter_bus_id){this.store.activityCounter--;}});this.env.bus.addEventListener("mail.message/delete",({detail:{message,notifId}})=>{if(message.needaction&&notifId>this.store.inbox.counter_bus_id){this.store.inbox.counter--;}
if(message.starred&&notifId>this.store.starred.counter_bus_id){this.store.starred.counter--;}});this.busService.subscribe("mail.message/inbox",(payload,{id:notifId})=>{const{Message:messages=[]}=this.store.insert(payload,{html:true});const[message]=messages;const inbox=this.store.inbox;if(notifId>inbox.counter_bus_id){inbox.counter++;}
inbox.messages.add(message);if(message.thread&&notifId>message.thread.message_needaction_counter_bus_id){message.thread.message_needaction_counter++;}
this.store.env.services["mail.out_of_focus"].notify(message);});this.busService.subscribe("mail.message/mark_as_read",(payload,{id:notifId})=>{const{message_ids:messageIds,needaction_inbox_counter}=payload;const inbox=this.store.inbox;for(const messageId of messageIds){const message=this.store.Message.get(messageId);if(!message){continue;}
const thread=message.thread;if(thread&&message.needaction&&notifId>thread.message_needaction_counter_bus_id){thread.message_needaction_counter--;}
message.needaction=false;inbox.messages.delete({id:messageId});const history=this.store.history;history.messages.add(message);}
if(notifId>inbox.counter_bus_id){inbox.counter=needaction_inbox_counter;inbox.counter_bus_id=notifId;}
if(inbox.counter>inbox.messages.length){inbox.fetchMoreMessages();}});this.busService.start();}}
const mailCoreWeb=__exports.mailCoreWeb={dependencies:["bus_service","mail.store"],start(env,services){const mailCoreWeb=reactive(new MailCoreWeb(env,services));mailCoreWeb.setup();return mailCoreWeb;},};registry.category("services").add("mail.core.web",mailCoreWeb);return __exports;});;

/* /mail/static/src/core/web/mention_list.js */
odoo.define('@mail/core/web/mention_list',['@web/core/l10n/translation','@odoo/owl','@web/core/utils/hooks','@mail/core/common/navigable_list','@mail/utils/common/hooks'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component,useEffect,useState}=require("@odoo/owl");const{useService,useAutofocus}=require("@web/core/utils/hooks");const{NavigableList}=require("@mail/core/common/navigable_list");const{useSequential}=require("@mail/utils/common/hooks");const MentionList=__exports.MentionList=class MentionList extends Component{static template="mail.MentionList";static components={NavigableList};static props={onSelect:{type:Function},close:{type:Function,optional:true},type:{type:String},};static defaultProps={close:()=>{},};setup(){super.setup();this.state=useState({searchTerm:"",options:[],isFetching:false,});this.orm=useService("orm");this.store=useState(useService("mail.store"));this.suggestionService=useService("mail.suggestion");this.sequential=useSequential();this.ref=useAutofocus({mobile:true});useEffect(()=>{if(!this.state.searchTerm){this.state.options=[];return;}
this.sequential(async()=>{this.state.isFetching=true;try{await this.suggestionService.fetchSuggestions({delimiter:this.props.type==="partner"?"@":"#",term:this.state.searchTerm,});}finally{this.state.isFetching=false;}
const{suggestions}=this.suggestionService.searchSuggestions({delimiter:this.props.type==="partner"?"@":"#",term:this.state.searchTerm,},{sort:true});this.state.options=suggestions;});},()=>[this.state.searchTerm]);}
get placeholder(){switch(this.props.type){case"channel":return _t("Search for a channel...");case"partner":return _t("Search for a user...");default:return _t("Search...");}}
get navigableListProps(){const props={anchorRef:this.ref.el,position:"bottom-fit",isLoading:!!this.state.searchTerm&&this.state.isFetching,onSelect:(...args)=>{this.props.onSelect(...args);this.props.close();},options:[],};switch(this.props.type){case"partner":this.state.options.forEach((option)=>{props.options.push({label:option.name,partner:option,});});break;case"channel":{this.state.options.forEach((option)=>{props.options.push({label:option.name,channel:option,});});break;}}
return props;}
onKeydown(ev){switch(ev.key){case"Escape":{this.props.close();break;}}}}
return __exports;});;

/* /mail/static/src/core/web/message_patch.js */
odoo.define('@mail/core/web/message_patch',['@mail/core/common/message','@web/core/utils/misc','@web/core/l10n/dates','@web/core/l10n/translation','@web/views/fields/formatters','@web/core/utils/hooks','@web/core/popover/popover_hook','@web/core/utils/patch','@mail/discuss/web/avatar_card/avatar_card_popover'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message");const{markEventHandled}=require("@web/core/utils/misc");const{deserializeDate,deserializeDateTime,formatDate,formatDateTime,}=require("@web/core/l10n/dates");const{_t}=require("@web/core/l10n/translation");const{formatChar,formatFloat,formatInteger,formatMonetary,formatText,}=require("@web/views/fields/formatters");const{useService}=require("@web/core/utils/hooks");const{usePopover}=require("@web/core/popover/popover_hook");const{patch}=require("@web/core/utils/patch");const{AvatarCardPopover}=require("@mail/discuss/web/avatar_card/avatar_card_popover");patch(Message.prototype,{setup(){super.setup(...arguments);this.action=useService("action");this.avatarCard=usePopover(AvatarCardPopover);},get authorAvatarAttClass(){return{...super.authorAvatarAttClass,"o_redirect cursor-pointer":this.hasAuthorClickable(),};},getAuthorAttClass(){return{...super.getAuthorAttClass(),"cursor-pointer o-hover-text-underline":this.hasAuthorClickable(),};},getAuthorText(){return this.hasAuthorClickable()?_t("Open card"):undefined;},getAvatarContainerAttClass(){return{...super.getAvatarContainerAttClass(),"cursor-pointer":this.hasAuthorClickable(),};},hasAuthorClickable(){return this.message.author?.userId;},onClickAuthor(ev){if(this.hasAuthorClickable()){markEventHandled(ev,"Message.ClickAuthor");const target=ev.currentTarget;if(!this.avatarCard.isOpen){this.avatarCard.open(target,{id:this.message.author.userId,});}}},openRecord(){this.message.thread.open();},formatTracking(trackingType,trackingValue){switch(trackingType){case"boolean":return trackingValue.value?_t("Yes"):_t("No");case"char":case"many2one":case"selection":return formatChar(trackingValue.value);case"date":{const value=trackingValue.value?deserializeDate(trackingValue.value):trackingValue.value;return formatDate(value);}
case"datetime":{const value=trackingValue.value?deserializeDateTime(trackingValue.value):trackingValue.value;return formatDateTime(value);}
case"float":return formatFloat(trackingValue.value);case"integer":return formatInteger(trackingValue.value);case"text":return formatText(trackingValue.value);case"monetary":return formatMonetary(trackingValue.value,{currencyId:trackingValue.currencyId,});default:return trackingValue.value;}},formatTrackingOrNone(trackingType,trackingValue){const formattedValue=this.formatTracking(trackingType,trackingValue);return formattedValue||_t("None");},});return __exports;});;

/* /mail/static/src/core/web/messaging_menu_patch.js */
odoo.define('@mail/core/web/messaging_menu_patch',['@mail/core/public_web/messaging_menu','@mail/utils/common/hooks','@odoo/owl','@web/core/l10n/translation','@web/core/utils/hooks','@web/core/utils/patch','@mail/core/web/messaging_menu_quick_search'],function(require){'use strict';let __exports={};const{MessagingMenu}=require("@mail/core/public_web/messaging_menu");const{onExternalClick}=require("@mail/utils/common/hooks");const{useEffect,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");const{MessagingMenuQuickSearch}=require("@mail/core/web/messaging_menu_quick_search");Object.assign(MessagingMenu.components,{MessagingMenuQuickSearch});patch(MessagingMenu.prototype,{setup(){super.setup();this.action=useService("action");this.pwa=useState(useService("pwa"));this.notification=useState(useService("mail.notification.permission"));Object.assign(this.state,{searchOpen:false,});onExternalClick("selector",()=>Object.assign(this.state,{adding:false}));useEffect(()=>{if(this.store.discuss.searchTerm&&this.lastSearchTerm!==this.store.discuss.searchTerm&&this.state.activeIndex){this.state.activeIndex=0;}
if(!this.store.discuss.searchTerm){this.state.activeIndex=null;}
this.lastSearchTerm=this.store.discuss.searchTerm;},()=>[this.store.discuss.searchTerm]);useEffect(()=>{if(!this.dropdown.isOpen){this.state.activeIndex=null;}},()=>[this.dropdown.isOpen]);},beforeOpen(){this.state.searchOpen=false;this.store.discuss.searchTerm="";this.store.isReady.then(()=>{if(!this.store.inbox.isLoaded&&this.store.inbox.status!=="loading"&&this.store.inbox.counter!==this.store.inbox.messages.length){this.store.inbox.fetchNewMessages();}});},get canPromptToInstall(){return this.pwa.canPromptToInstall;},get hasPreviews(){return(this.threads.length>0||(this.store.failures.length>0&&this.store.discuss.activeTab==="main"&&!this.env.inDiscussApp)||(this.shouldAskPushPermission&&this.store.discuss.activeTab==="main"&&!this.env.inDiscussApp)||(this.canPromptToInstall&&this.store.discuss.activeTab==="main"&&!this.env.inDiscussApp));},get installationRequest(){return{body:_t("Come here often? Install the app for quick and easy access!"),displayName:_t("Install Odoo"),onClick:()=>{this.pwa.show();},iconSrc:this.store.odoobot.avatarUrl,partner:this.store.odoobot,isShown:this.store.discuss.activeTab==="main"&&this.canPromptToInstall,};},get notificationRequest(){return{body:_t("Stay tuned! Enable push notifications to never miss a message."),displayName:_t("Turn on notifications"),iconSrc:this.store.odoobot.avatarUrl,partner:this.store.odoobot,isShown:this.store.discuss.activeTab==="main"&&this.shouldAskPushPermission,};},get tabs(){return[{icon:this.env.inDiscussApp?"fa fa-inbox":"fa fa-envelope",id:"main",label:this.env.inDiscussApp?_t("Mailboxes"):_t("All"),},...super.tabs,];},onClickFailure(failure){const threadIds=new Set(failure.notifications.map(({message})=>message.thread.id));if(threadIds.size===1){const message=failure.notifications[0].message;this.openThread(message.thread);}else{this.openFailureView(failure);this.dropdown.close();}},openThread(thread){if(this.store.discuss.isActive){this.action.doAction({type:"ir.actions.act_window",res_model:thread.model,views:[[false,"form"]],res_id:thread.id,});this.store.ChatWindow.get({thread})?.close();}else{thread.open({fromMessagingMenu:true});}
this.dropdown.close();},openFailureView(failure){if(failure.type!=="email"){return;}
this.action.doAction({name:_t("Mail Failures"),type:"ir.actions.act_window",view_mode:"kanban,list,form",views:[[false,"kanban"],[false,"list"],[false,"form"],],target:"current",res_model:failure.resModel,domain:[["message_has_error","=",true]],context:{create:false},});},cancelNotifications(failure){return this.env.services.orm.call(failure.resModel,"notify_cancel_by_type",[],{notification_type:failure.type,});},toggleSearch(){this.store.discuss.searchTerm="";this.state.searchOpen=!this.state.searchOpen;},get counter(){let value=this.store.inbox.counter+
this.store.failures.reduce((acc,f)=>acc+parseInt(f.notifications.length),0);if(this.canPromptToInstall){value++;}
if(this.shouldAskPushPermission){value++;}
return value;},get displayStartConversation(){return this.store.discuss.activeTab!=="channel"&&!this.state.adding;},get shouldAskPushPermission(){return(this.notification.permission==="prompt"&&!this.store.isNotificationPermissionDismissed);},getFailureNotificationName(failure){if(failure.type==="email"){return _t("Email Failure: %(modelName)s",{modelName:failure.modelName});}
return _t("Failure: %(modelName)s",{modelName:failure.modelName});},});return __exports;});;

/* /mail/static/src/core/web/messaging_menu_quick_search.js */
odoo.define('@mail/core/web/messaging_menu_quick_search',['@mail/utils/common/hooks','@odoo/owl','@web/core/hotkeys/hotkey_service','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{onExternalClick}=require("@mail/utils/common/hooks");const{Component,useState}=require("@odoo/owl");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const{useAutofocus,useService}=require("@web/core/utils/hooks");const MessagingMenuQuickSearch=__exports.MessagingMenuQuickSearch=class MessagingMenuQuickSearch extends Component{static components={};static props=["onClose"];static template="mail.MessagingMenuQuickSearch";setup(){super.setup();this.store=useState(useService("mail.store"));useAutofocus();onExternalClick("search",()=>this.props.onClose());}
onKeydownInput(ev){const hotkey=getActiveHotkey(ev);if(hotkey==="escape"){ev.stopPropagation();ev.preventDefault();this.props.onClose();}}}
return __exports;});;

/* /mail/static/src/core/web/open_chat_hook.js */
odoo.define('@mail/core/web/open_chat_hook',['@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const helpers=__exports.helpers={SUPPORTED_M2X_AVATAR_MODELS:["res.users"],buildOpenChatParams:(resModel,id)=>{if(resModel==="res.users"){return{userId:id};}},};__exports.useOpenChat=useOpenChat;function useOpenChat(resModel){const store=useService("mail.store");if(!helpers.SUPPORTED_M2X_AVATAR_MODELS.includes(resModel)){throw new Error(`This widget is only supported on many2one and many2many fields pointing to ${JSON.stringify(
                helpers.SUPPORTED_M2X_AVATAR_MODELS
            )}`);}
return async(id)=>{store.openChat(helpers.buildOpenChatParams(resModel,id));};}
return __exports;});;

/* /mail/static/src/core/web/recipient_list.js */
odoo.define('@mail/core/web/recipient_list',['@mail/utils/common/hooks','@odoo/owl','@web/core/utils/hooks','@web/core/l10n/translation','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{useVisible}=require("@mail/utils/common/hooks");const{Component,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const{sprintf}=require("@web/core/utils/strings");const RecipientList=__exports.RecipientList=class RecipientList extends Component{static template="mail.RecipientList";static props=["thread","close?"];setup(){super.setup();this.store=useState(useService("mail.store"));this.loadMoreState=useVisible("load-more",()=>{if(this.loadMoreState.isVisible){this.props.thread.loadMoreRecipients();}});}
getRecipientText(recipient){return(recipient.partner.email||sprintf(_t("[%(name)s] (no email address)"),{name:recipient.partner.name}));}}
return __exports;});;

/* /mail/static/src/core/web/store_service_patch.js */
odoo.define('@mail/core/web/store_service_patch',['@mail/core/common/record','@mail/core/common/store_service','@mail/utils/common/misc','@web/core/browser/browser','@web/core/l10n/translation','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{Store}=require("@mail/core/common/store_service");const{compareDatetime}=require("@mail/utils/common/misc");const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const StorePatch={setup(){super.setup(...arguments);this.activityCounter=0;this.activity_counter_bus_id=0;this.activityGroups=Record.attr([],{onUpdate(){this.onUpdateActivityGroups();},sort(g1,g2){const getSortId=(activityGroup)=>activityGroup.model==="mail.activity"?Number.MAX_VALUE:activityGroup.id;return getSortId(g1)-getSortId(g2);},});this.inbox=Record.one("Thread");this.starred=Record.one("Thread");this.history=Record.one("Thread");},onStarted(){super.onStarted(...arguments);this.inbox={id:"inbox",model:"mail.box",name:_t("Inbox"),};this.starred={id:"starred",model:"mail.box",name:_t("Starred"),};this.history={id:"history",model:"mail.box",name:_t("History"),};try{this.activityBroadcastChannel=new browser.BroadcastChannel("mail.activity.channel");this.activityBroadcastChannel.onmessage=this._onActivityBroadcastChannelMessage.bind(this);}catch{this.activityBroadcastChannel=null;}},get initMessagingParams(){return{...super.initMessagingParams,failures:true,systray_get_activities:true,};},getNeedactionChannels(){return this.getRecentChannels().filter((channel)=>channel.importantCounter>0);},getRecentChannels(){return Object.values(this.Thread.records).filter((thread)=>thread.model==="discuss.channel").sort((a,b)=>compareDatetime(b.lastInterestDt,a.lastInterestDt)||b.id-a.id);},onUpdateActivityGroups(){},async scheduleActivity(resModel,resIds,defaultActivityTypeId=undefined){const context={active_model:resModel,active_ids:resIds,active_id:resIds[0],...(defaultActivityTypeId!==undefined?{default_activity_type_id:defaultActivityTypeId}:{}),};return new Promise((resolve)=>this.env.services.action.doAction({type:"ir.actions.act_window",name:resIds&&resIds.length>1?_t("Schedule Activity On Selected Records"):_t("Schedule Activity"),res_model:"mail.activity.schedule",view_mode:"form",views:[[false,"form"]],target:"new",context,},{onClose:resolve}));},_onActivityBroadcastChannelMessage({data}){switch(data.type){case"INSERT":this.Activity.insert(data.payload,{broadcast:false,html:true});break;case"DELETE":{const activity=this.Activity.insert(data.payload,{broadcast:false});activity.remove({broadcast:false});break;}
case"RELOAD_CHATTER":{const thread=this.Thread.insert({model:data.payload.model,id:data.payload.id,});thread.fetchNewMessages();break;}}},async unstarAll(){this.store.starred.counter=0;this.store.starred.messages=[];await this.env.services.orm.call("mail.message","unstar_all");},handleClickOnLink(ev,thread){const model=ev.target.dataset.oeModel;const id=Number(ev.target.dataset.oeId);const isLinkHandledBySuper=super.handleClickOnLink(...arguments);if(!isLinkHandledBySuper&&ev.target.tagName==="A"&&id&&model){ev.preventDefault();Promise.resolve(this.env.services.action.doAction({type:"ir.actions.act_window",res_model:model,views:[[false,"form"]],res_id:id,})).then(()=>this.onLinkFollowed(thread));return true;}
return false;},onLinkFollowed(fromThread){if(!this.env.isSmall&&fromThread?.model==="discuss.channel"){fromThread.open(true,{autofocus:false});}},};patch(Store.prototype,StorePatch);return __exports;});;

/* /mail/static/src/core/web/suggested_recipient.js */
odoo.define('@mail/core/web/suggested_recipient',['@odoo/owl','@web/core/l10n/translation','@web/core/utils/hooks','@web/views/view_dialogs/form_view_dialog'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");const SuggestedRecipient=__exports.SuggestedRecipient=class SuggestedRecipient extends Component{static template="mail.SuggestedRecipients";static props=["thread","recipient","onSuggestedRecipientAdded"];setup(){super.setup();this.dialogService=useService("dialog");}
get titleText(){return _t("Add as recipient and follower (reason: %s)",this.props.recipient.reason);}
onChangeCheckbox(ev){this.props.recipient.checked=!this.props.recipient.checked;if(this.props.recipient.checked&&!this.props.recipient.persona){this.props.recipient.checked=false;const thread=this.props.thread;this.dialogService.add(FormViewDialog,{context:{active_id:thread.id,active_model:"mail.compose.message",default_email:this.props.recipient.email,default_name:this.props.recipient.name,default_lang:this.props.recipient.lang,...Object.fromEntries(Object.entries(this.props.recipient.create_values).map(([k,v])=>["default_"+k,v,])),force_email:true,ref:"compound_context",},onRecordSaved:()=>this.props.onSuggestedRecipientAdded(thread),resModel:"res.partner",title:_t("Please complete customer's information"),});}}}
return __exports;});;

/* /mail/static/src/core/web/suggested_recipient_list.js */
odoo.define('@mail/core/web/suggested_recipient_list',['@mail/core/web/suggested_recipient','@odoo/owl'],function(require){'use strict';let __exports={};const{SuggestedRecipient}=require("@mail/core/web/suggested_recipient");const{Component,useState}=require("@odoo/owl");const SuggestedRecipientsList=__exports.SuggestedRecipientsList=class SuggestedRecipientsList extends Component{static template="mail.SuggestedRecipientsList";static components={SuggestedRecipient};static props=["thread","className?","styleString?","onSuggestedRecipientAdded"];setup(){super.setup();this.state=useState({showMore:false});}
get suggestedRecipients(){if(!this.state.showMore){return this.props.thread.suggestedRecipients.slice(0,3);}
return this.props.thread.suggestedRecipients;}}
return __exports;});;

/* /mail/static/src/core/web/thread_actions.js */
odoo.define('@mail/core/web/thread_actions',['@mail/core/common/thread_actions','@odoo/owl','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{threadActionsRegistry}=require("@mail/core/common/thread_actions");const{useComponent,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");threadActionsRegistry.add("mark-all-read",{condition(component){return component.thread?.id==="inbox";},disabledCondition(component){return component.thread.isEmpty&&!component.store.inbox.counter;},open(component){component.orm.silent.call("mail.message","mark_all_as_read");},sequence:1,text:_t("Mark all read"),}).add("unstar-all",{condition(component){return component.thread?.id==="starred";},disabledCondition(component){return component.thread.isEmpty;},open(component){component.store.unstarAll();},sequence:2,setup(){const component=useComponent();component.store=useState(useService("mail.store"));},text:_t("Unstar all"),}).add("expand-form",{condition(component){return(component.thread&&!["mail.box","discuss.channel"].includes(component.thread.model)&&component.props.chatWindow?.isOpen);},setup(){const component=useComponent();component.actionService=useService("action");},icon:"fa fa-fw fa-expand",name:_t("Open Form View"),open(component){component.actionService.doAction({type:"ir.actions.act_window",res_id:component.thread.id,res_model:component.thread.model,views:[[false,"form"]],});component.props.chatWindow.close();},sequence:40,sequenceGroup:20,});return __exports;});;

/* /mail/static/src/core/web/thread_model_patch.js */
odoo.define('@mail/core/web/thread_model_patch',['@mail/core/common/thread_model','@web/core/utils/patch','@mail/core/common/record','@mail/utils/common/misc'],function(require){'use strict';let __exports={};const{Thread}=require("@mail/core/common/thread_model");const{patch}=require("@web/core/utils/patch");const{Record}=require("@mail/core/common/record");const{compareDatetime}=require("@mail/utils/common/misc");patch(Thread.prototype,{recipientsCount:undefined,setup(){super.setup();this.recipients=Record.many("Follower");this.activities=Record.many("Activity",{sort:(a,b)=>compareDatetime(a.date_deadline,b.date_deadline)||a.id-b.id,onDelete(r){r.remove();},});},get recipientsFullyLoaded(){return this.recipientsCount===this.recipients.length;},closeChatWindow(){const chatWindow=this.store.ChatWindow.get({thread:this});chatWindow?.close({notifyState:false});},computeIsDisplayed(){if(this.store.discuss.isActive&&!this.store.env.services.ui.isSmall){return this.eq(this.store.discuss.thread);}
return super.computeIsDisplayed();},async leave(){this.closeChatWindow();super.leave(...arguments);},async loadMoreFollowers(){const data=await this.store.env.services.orm.call(this.model,"message_get_followers",[[this.id],this.followers.at(-1).id,]);this.store.insert(data);},async loadMoreRecipients(){const data=await this.store.env.services.orm.call(this.model,"message_get_followers",[[this.id],this.recipients.at(-1).id],{filter_recipients:true});this.store.insert(data);},open(options){if(this.model==="discuss.channel"&&!this.selfMember){this.store.env.services["bus_service"].addChannel(this.busChannel);}
if(!this.store.discuss.isActive&&!this.store.env.services.ui.isSmall){this.openChatWindow(options);return;}
if(this.store.env.services.ui.isSmall&&this.model==="discuss.channel"){this.openChatWindow(options);return;}
if(this.model!=="discuss.channel"){this.store.env.services.action.doAction({type:"ir.actions.act_window",res_id:this.id,res_model:this.model,views:[[false,"form"]],});return;}
super.open();},async unpin(){const chatWindow=this.store.ChatWindow.get({thread:this});await chatWindow?.close();super.unpin(...arguments);},});return __exports;});;

/* /mail/static/src/utils/common/dates.js */
odoo.define('@mail/utils/common/dates',[],function(require){'use strict';let __exports={};const{DateTime}=luxon;__exports.computeDelay=computeDelay;function computeDelay(datetime){if(!datetime){return 0;}
const today=DateTime.now().startOf("day");return datetime.diff(today,"days").days;}
__exports.getMsToTomorrow=getMsToTomorrow;function getMsToTomorrow(){const now=new Date();const night=new Date(now.getFullYear(),now.getMonth(),now.getDate()+1,0,0,0);return night.getTime()-now.getTime();}
__exports.isToday=isToday;function isToday(datetime){if(!datetime){return false;}
return(datetime.toLocaleString(DateTime.DATE_FULL)===DateTime.now().toLocaleString(DateTime.DATE_FULL));}
return __exports;});;

/* /mail/static/src/utils/common/format.js */
odoo.define('@mail/utils/common/format',['@mail/utils/common/html','@odoo/owl','@web/core/browser/router','@web/core/emoji_picker/emoji_picker','@web/core/utils/html','@web/core/utils/strings','@web/core/utils/xml'],function(require){'use strict';let __exports={};const{createDocumentFragmentFromContent,htmlJoin,htmlReplace,htmlTrim,}=require("@mail/utils/common/html");const{markup}=require("@odoo/owl");const{stateToUrl}=require("@web/core/browser/router");const{loadEmoji}=require("@web/core/emoji_picker/emoji_picker");const{htmlEscape,setElementContent}=require("@web/core/utils/html");const{escapeRegExp,unaccent}=require("@web/core/utils/strings");const{setAttributes}=require("@web/core/utils/xml");const urlRegexp=/\b(?:https?:\/\/\d{1,3}(?:\.\d{1,3}){3}|(?:https?:\/\/|(?:www\.))[-a-z0-9@:%._+~#=\u00C0-\u024F\u1E00-\u1EFF]{1,256}\.[a-z]{2,13})\b(?:[-a-z0-9@:%_+~#?&[\]^|{}`\\'$//=\u00C0-\u024F\u1E00-\u1EFF]|[.]*[-a-z0-9@:%_+~#?&[\]^|{}`\\'$//=\u00C0-\u024F\u1E00-\u1EFF]|,(?!$| )|\.(?!$| |\.)|;(?!$| ))*/gi;const _escapeEntities=(function(){const map={"&":"&amp;","<":"&lt;",">":"&gt;"};const escaper=function(match){return map[match];};const testRegexp=RegExp("(?:&|<|>)");const replaceRegexp=RegExp("(?:&|<|>)","g");return function(string){string=string==null?"":""+string;return testRegexp.test(string)?string.replace(replaceRegexp,escaper):string;};})();__exports.prettifyMessageContent=prettifyMessageContent;async function prettifyMessageContent(rawBody,validRecords=[]){const escapedAndCompactContent=escapeAndCompactTextContent(rawBody);let body=htmlReplace(escapedAndCompactContent,/&nbsp;/g," ");body=htmlTrim(body);body=generateMentionsLinks(body,validRecords);body=await _generateEmojisOnHtml(body);body=parseAndTransform(body,addLink);return body;}
__exports.parseAndTransform=parseAndTransform;function parseAndTransform(htmlString,transformFunction){let children;try{const div=document.createElement("div");setElementContent(div,htmlString);children=Array.from(div.childNodes);}catch{const div=document.createElement("div");const pre=document.createElement("pre");setElementContent(pre,htmlString);div.appendChild(pre);children=Array.from(div.childNodes);}
return _parseAndTransform(children,transformFunction);}
function _parseAndTransform(nodes,transformFunction){if(!nodes){return;}
return htmlJoin(...Object.values(nodes).map((node)=>transformFunction(node,function(){return _parseAndTransform(node.childNodes,transformFunction);})));}
function linkify(text){let curIndex=0;let result="";let match;while((match=urlRegexp.exec(text))!==null){result=htmlJoin(result,text.slice(curIndex,match.index));const url=decodeURI(match[0]);const href=encodeURI(!/^https?:\/\//i.test(url)?"http://"+url:url);result=htmlJoin(result,markup(`<a target="_blank" rel="noreferrer noopener" href="${href}">${_escapeEntities(
                    url
                )}</a>`));curIndex=match.index+match[0].length;}
return htmlJoin(result,text.slice(curIndex));}
__exports.addLink=addLink;function addLink(node,transformChildren){if(node.nodeType===3){const linkified=linkify(node.textContent);if(linkified.toString()!==node.textContent){const div=document.createElement("div");setElementContent(div,linkified);for(const childNode of[...div.childNodes]){node.parentNode.insertBefore(childNode,node);}
node.parentNode.removeChild(node);return linkified;}
return node.textContent;}
if(node.tagName==="A"){return markup(node.outerHTML);}
transformChildren();return markup(node.outerHTML);}
__exports.escapeAndCompactTextContent=escapeAndCompactTextContent;function escapeAndCompactTextContent(content){let value=htmlTrim(content);value=htmlReplace(value,/(\r|\n){2,}/g,markup("<br/><br/>"));value=htmlReplace(value,/(\r|\n)/g,markup("<br/>"));value=htmlReplace(value,/ /g,markup("&nbsp;"));value=htmlReplace(value,/([^>])&nbsp;([^<])/g,markup("$1 $2"));return value;}
function generateMentionsLinks(body,{partners=[],threads=[],specialMentions=[]}){const mentions=[];for(const partner of partners){const placeholder=`@-mention-partner-${partner.id}`;const text=`@${partner.name}`;mentions.push({class:"o_mail_redirect",id:partner.id,model:"res.partner",placeholder,text,});body=htmlReplace(body,text,placeholder);}
for(const thread of threads){const placeholder=`#-mention-channel-${thread.id}`;let className,text;if(thread.parent_channel_id){className="o_channel_redirect o_channel_redirect_asThread";text=`#${thread.parent_channel_id.displayName} > ${thread.displayName}`;}else{className="o_channel_redirect";text=`#${thread.displayName}`;}
mentions.push({class:className,id:thread.id,model:"discuss.channel",placeholder,text,});body=htmlReplace(body,text,placeholder);}
for(const special of specialMentions){body=htmlReplace(body,`@${special}`,markup(`<a href="#" class="o-discuss-mention">@${htmlEscape(special)}</a>`));}
for(const mention of mentions){const link=document.createElement("a");setAttributes(link,{href:stateToUrl({model:mention.model,resId:mention.id}),class:mention.class,"data-oe-id":mention.id,"data-oe-model":mention.model,target:"_blank",contenteditable:"false",});link.textContent=mention.text;body=htmlReplace(body,mention.placeholder,markup(link.outerHTML));}
return htmlEscape(body);}
async function _generateEmojisOnHtml(htmlString){const{emojis}=await loadEmoji();for(const emoji of emojis){for(const source of[...emoji.shortcodes,...emoji.emoticons]){const escapedSource=htmlJoin(String(source));const regexp=new RegExp("(\\s|^)("+escapeRegExp(escapedSource)+")(?=\\s|$)","g");htmlString=htmlReplace(htmlString,regexp,"$1"+emoji.codepoints);}}
return htmlEscape(htmlString);}
__exports.htmlToTextContentInline=htmlToTextContentInline;function htmlToTextContentInline(htmlString){htmlString=htmlReplace(htmlString,/<br\s*\/?>/gi," ");const div=document.createElement("div");try{setElementContent(div,htmlString);}catch{const pre=document.createElement("pre");setElementContent(pre,htmlString);div.appendChild(pre);}
return div.textContent.trim().replace(/[\n\r]/g,"").replace(/\s\s+/g," ");}
__exports.convertBrToLineBreak=convertBrToLineBreak;function convertBrToLineBreak(str){str=htmlReplace(str,/<br\s*\/?>/gi,"\n");return createDocumentFragmentFromContent(str).body.textContent;}
__exports.cleanTerm=cleanTerm;function cleanTerm(term){return unaccent((typeof term==="string"?term:"").toLowerCase());}
__exports.parseEmail=parseEmail;function parseEmail(text){if(!text){return;}
let result=text.match(/"?(.*?)"? <(.*@.*)>/);if(result){const name=(result[1]||"").trim().replace(/(^"|"$)/g,"");return[name,(result[2]||"").trim()];}
result=text.match(/(.*@.*)/);if(result){return[String(result[1]||"").trim(),String(result[1]||"").trim()];}
return[text,false];}
const EMOJI_REGEX=__exports.EMOJI_REGEX=/\p{Emoji_Presentation}|\p{Emoji}\uFE0F|\u200d/gu;return __exports;});;

/* /mail/static/src/utils/common/hooks.js */
odoo.define('@mail/utils/common/hooks',['@odoo/owl','@web/core/browser/browser','@web/core/utils/concurrency','@web/core/utils/draggable_hook_builder_owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{onMounted,onPatched,onWillUnmount,useComponent,useEffect,useRef,useState,}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{Deferred}=require("@web/core/utils/concurrency");const{makeDraggableHook}=require("@web/core/utils/draggable_hook_builder_owl");const{useService}=require("@web/core/utils/hooks");__exports.useLazyExternalListener=useLazyExternalListener;function useLazyExternalListener(target,eventName,handler,eventParams){const boundHandler=handler.bind(useComponent());let t;onMounted(()=>{t=target();if(!t){return;}
t.addEventListener(eventName,boundHandler,eventParams);});onPatched(()=>{const t2=target();if(t!==t2){if(t){t.removeEventListener(eventName,boundHandler,eventParams);}
if(t2){t2.addEventListener(eventName,boundHandler,eventParams);}
t=t2;}});onWillUnmount(()=>{if(!t){return;}
t.removeEventListener(eventName,boundHandler,eventParams);});}
__exports.onExternalClick=onExternalClick;function onExternalClick(refName,cb){let downTarget,upTarget;const ref=useRef(refName);function onClick(ev){if(ref.el&&!ref.el.contains(ev.composedPath()[0])){cb(ev,{downTarget,upTarget});upTarget=downTarget=null;}}
function onMousedown(ev){downTarget=ev.target;}
function onMouseup(ev){upTarget=ev.target;}
onMounted(()=>{document.body.addEventListener("mousedown",onMousedown,true);document.body.addEventListener("mouseup",onMouseup,true);document.body.addEventListener("click",onClick,true);});onWillUnmount(()=>{document.body.removeEventListener("mousedown",onMousedown,true);document.body.removeEventListener("mouseup",onMouseup,true);document.body.removeEventListener("click",onClick,true);});}
__exports.useHover=useHover;function useHover(refNames,{onHover,onAway,stateObserver,onHovering}={}){refNames=Array.isArray(refNames)?refNames:[refNames];const targets=[];let wasHovering=false;let hoveringTimeout;let awayTimeout;let lastHoveredTarget;for(const refName of refNames){targets.push({ref:refName.endsWith("*")?useRef(refName.substring(0,refName.length-1)):useRef(refName),});}
const state=useState({set isHover(newIsHover){if(this._isHover!==newIsHover){this._isHover=newIsHover;this._count++;}},get isHover(){void this._count;return this._isHover;},_count:0,_isHover:false,});function setHover(hovering){if(hovering&&!wasHovering){state.isHover=true;clearTimeout(awayTimeout);clearTimeout(hoveringTimeout);if(typeof onHover==="function"){onHover();}
if(Array.isArray(onHovering)){const[delay,cb]=onHovering;hoveringTimeout=setTimeout(()=>{cb();},delay);}}else if(!hovering){state.isHover=false;clearTimeout(awayTimeout);if(typeof onAway==="function"){awayTimeout=setTimeout(()=>{clearTimeout(hoveringTimeout);onAway();},200);}}
wasHovering=hovering;}
function onmouseenter(ev){if(state.isHover){return;}
for(const target of targets){if(!target.ref.el){continue;}
if(target.ref.el.contains(ev.target)){setHover(true);lastHoveredTarget=target;return;}}}
function onmouseleave(ev){if(!state.isHover){return;}
for(const target of targets){if(!target.ref.el){continue;}
if(target.ref.el.contains(ev.relatedTarget)){return;}}
setHover(false);lastHoveredTarget=null;}
for(const target of targets){useLazyExternalListener(()=>target.ref.el,"mouseenter",(ev)=>onmouseenter(ev),true);useLazyExternalListener(()=>target.ref.el,"mouseleave",(ev)=>onmouseleave(ev),true);}
if(stateObserver){useEffect(()=>{if(lastHoveredTarget&&!lastHoveredTarget.ref.el){setHover(false);lastHoveredTarget=null;}},stateObserver);}
return state;}
__exports.useOnBottomScrolled=useOnBottomScrolled;function useOnBottomScrolled(refName,callback,threshold=1){const ref=useRef(refName);function onScroll(){if(Math.abs(ref.el.scrollTop+ref.el.clientHeight-ref.el.scrollHeight)<threshold){callback();}}
onMounted(()=>{ref.el.addEventListener("scroll",onScroll);});onWillUnmount(()=>{ref.el.removeEventListener("scroll",onScroll);});}
__exports.useVisible=useVisible;function useVisible(refName,cb,{ready=true}={}){const ref=useRef(refName);const state=useState({isVisible:undefined,ready,});function setValue(value){state.isVisible=value;cb(state.isVisible);}
const observer=new IntersectionObserver((entries)=>{setValue(entries.at(-1).isIntersecting);});useEffect((el,ready)=>{if(el&&ready){observer.observe(el);return()=>{setValue(undefined);observer.unobserve(el);};}},()=>[ref.el,state.ready]);return state;}
__exports.useMessageHighlight=useMessageHighlight;function useMessageHighlight(duration=2000){let timeout;const state=useState({clearHighlight(){if(this.highlightedMessageId){browser.clearTimeout(timeout);timeout=null;this.highlightedMessageId=null;}},async highlightMessage(message,thread){if(thread.notEq(message.thread)){return;}
await thread.loadAround(message.id);const lastHighlightedMessageId=state.highlightedMessageId;this.clearHighlight();if(lastHighlightedMessageId===message.id){await new Promise(setTimeout);}
thread.scrollTop=undefined;state.highlightedMessageId=message.id;timeout=browser.setTimeout(()=>this.clearHighlight(),duration);},scrollPromise:null,scrollTo(el){state.scrollPromise?.resolve();const scrollPromise=new Deferred();state.scrollPromise=scrollPromise;if("onscrollend"in window){document.addEventListener("scrollend",scrollPromise.resolve,{capture:true,once:true,});}else{setTimeout(scrollPromise.resolve,250);}
el.scrollIntoView({behavior:"smooth",block:"center"});return scrollPromise;},highlightedMessageId:null,});return state;}
__exports.useSelection=useSelection;function useSelection({refName,model,preserveOnClickAwayPredicate=()=>false}){const ui=useState(useService("ui"));const ref=useRef(refName);function onSelectionChange(){const activeElement=ref.el?.getRootNode().activeElement;if(activeElement&&activeElement===ref.el){Object.assign(model,{start:ref.el.selectionStart,end:ref.el.selectionEnd,direction:ref.el.selectionDirection,});}}
onExternalClick(refName,async(ev)=>{if(await preserveOnClickAwayPredicate(ev)){return;}
if(!ref.el){return;}
Object.assign(model,{start:ref.el.value.length,end:ref.el.value.length,direction:ref.el.selectionDirection,});});onMounted(()=>{document.addEventListener("selectionchange",onSelectionChange);document.addEventListener("input",onSelectionChange);});onWillUnmount(()=>{document.removeEventListener("selectionchange",onSelectionChange);document.removeEventListener("input",onSelectionChange);});return{restore(){ref.el?.setSelectionRange(model.start,model.end,model.direction);},moveCursor(position){model.start=model.end=position;if(!ui.isSmall){ref.el.selectionStart=ref.el.selectionEnd=position;}},};}
__exports.useMessageEdition=useMessageEdition;function useMessageEdition(){const state=useState({composerOfThread:null,editingMessage:null,exitEditMode(){state.editingMessage=null;if(state.composerOfThread){state.composerOfThread.props.composer.autofocus++;}},});return state;}
__exports.useMessageToReplyTo=useMessageToReplyTo;function useMessageToReplyTo(){return useState({cancel(){Object.assign(this,{message:null,thread:null});},isNotSelected(thread,message){return thread.eq(this.thread)&&message.notEq(this.message);},isSelected(thread,message){return thread.eq(this.thread)&&message.eq(this.message);},message:null,thread:null,toggle(thread,message){if(message.eq(this.message)){this.cancel();}else{Object.assign(this,{message,thread});}},});}
__exports.useSequential=useSequential;function useSequential(){let inProgress=false;let nextFunction;let nextResolve;let nextReject;async function call(){const resolve=nextResolve;const reject=nextReject;const func=nextFunction;nextResolve=undefined;nextReject=undefined;nextFunction=undefined;inProgress=true;try{const data=await func();resolve(data);}catch(e){reject(e);}
inProgress=false;if(nextFunction&&nextResolve){call();}}
return(func)=>{nextResolve?.();const prom=new Promise((resolve,reject)=>{nextResolve=resolve;nextReject=reject;});nextFunction=func;if(!inProgress){call();}
return prom;};}
__exports.useDiscussSystray=useDiscussSystray;function useDiscussSystray(){const ui=useState(useService("ui"));return{class:"o-mail-DiscussSystray-class",get contentClass(){return`d-flex flex-column flex-grow-1 ${
                ui.isSmall ? "overflow-auto w-100 mh-100" : ""
            }`;},get menuClass(){return`p-0 o-mail-DiscussSystray ${
                ui.isSmall
                    ? "o-mail-systrayFullscreenDropdownMenu start-0 w-100 mh-100 d-flex flex-column mt-0 border-0 shadow-lg"
                    : ""
            }`;},};}
const useMovable=__exports.useMovable=makeDraggableHook({name:"useMovable",onWillStartDrag({ctx,addCleanup,addStyle,getRect}){const{height}=getRect(ctx.current.element);ctx.current.container=document.createElement("div");addStyle(ctx.current.container,{position:"fixed",top:0,bottom:`${height}px`,left:0,right:0,});ctx.current.element.after(ctx.current.container);addCleanup(()=>ctx.current.container.remove());},onDrop({ctx,getRect}){const{top,left}=getRect(ctx.current.element);return{top,left};},});return __exports;});;

/* /mail/static/src/utils/common/html.js */
odoo.define('@mail/utils/common/html',['@odoo/owl','@web/core/utils/html'],function(require){'use strict';let __exports={};const{markup}=require("@odoo/owl");const{htmlEscape,setElementContent}=require("@web/core/utils/html");__exports.createDocumentFragmentFromContent=createDocumentFragmentFromContent;function createDocumentFragmentFromContent(content){const div=document.createElement("div");setElementContent(div,content);return new DOMParser().parseFromString(div.innerHTML,"text/html");}
__exports.htmlJoin=htmlJoin;function htmlJoin(...args){return markup(args.map((arg)=>htmlEscape(arg)).join(""));}
__exports.htmlReplace=htmlReplace;function htmlReplace(content,search,replacement){content=htmlEscape(content);if(typeof search==="string"||search instanceof String){search=htmlEscape(search);}
replacement=htmlEscape(replacement);return markup(content.replace(search,replacement));}
__exports.htmlTrim=htmlTrim;function htmlTrim(content){content=htmlEscape(content);return markup(content.trim());}
return __exports;});;

/* /mail/static/src/utils/common/misc.js */
odoo.define('@mail/utils/common/misc',['@odoo/owl','@web/core/network/rpc'],function(require){'use strict';let __exports={};const{reactive}=require("@odoo/owl");const{rpc}=require("@web/core/network/rpc");__exports.assignDefined=assignDefined;function assignDefined(obj,data,keys=Object.keys(data)){for(const key of keys){if(data[key]!==undefined){obj[key]=data[key];}}
return obj;}
__exports.assignIn=assignIn;function assignIn(obj,data,keys=Object.keys(data)){for(const key of keys){if(key in data){obj[key]=data[key];}}
return obj;}
__exports.nearestGreaterThanOrEqual=nearestGreaterThanOrEqual;function nearestGreaterThanOrEqual(list,target,itemToCompareVal){const findNext=(left,right,next)=>{if(left>right){return next;}
const index=Math.floor((left+right)/2);const item=list[index];const val=itemToCompareVal?.(item)??item;if(val===target){return item;}else if(val>target){return findNext(left,index-1,item);}else{return findNext(index+1,right,next);}};return findNext(0,list.length-1,null);}
const mailGlobal=__exports.mailGlobal={isInTest:false,};__exports.rpcWithEnv=rpcWithEnv;function rpcWithEnv(){return rpc;}
__exports.isDragSourceExternalFile=isDragSourceExternalFile;function isDragSourceExternalFile(dataTransfer){const dragDataType=dataTransfer.types;if(dragDataType.constructor===window.DOMStringList){return dragDataType.contains("Files");}
if(dragDataType.constructor===Array){return dragDataType.includes("Files");}
return false;}
__exports.onChange=onChange;function onChange(target,key,callback){let proxy;function _observe(){const val=proxy[key];if(typeof val==="object"&&val!==null){void Object.keys(val);}
if(Array.isArray(val)){void val.length;void val.forEach((i)=>i);}}
if(Array.isArray(key)){for(const k of key){onChange(target,k,callback);}
return;}
proxy=reactive(target,()=>{_observe();callback();});_observe();return proxy;}
__exports.closeStream=closeStream;function closeStream(stream){stream?.getTracks?.().forEach((track)=>track.stop());}
__exports.compareDatetime=compareDatetime;function compareDatetime(date1,date2){if(date1?.ts===date2?.ts){return 0;}
if(!date1){return-1;}
if(!date2){return 1;}
return date1.ts-date2.ts;}
function compareVersion(v1,v2){const parts1=v1.split(".");const parts2=v2.split(".");for(let i=0;i<Math.max(parts1.length,parts2.length);i++){const num1=parseInt(parts1[i])||0;const num2=parseInt(parts2[i])||0;if(num1<num2){return-1;}
if(num1>num2){return 1;}}
return 0;}
__exports.parseVersion=parseVersion;function parseVersion(v){return{isLowerThan(other){return compareVersion(v,other)<0;},};}
return __exports;});;

/* /mail/static/src/chatter/web_portal/chatter.js */
odoo.define('@mail/chatter/web_portal/chatter',['@mail/core/common/composer','@mail/core/common/thread','@odoo/owl','@web/core/l10n/translation','@web/core/utils/hooks','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{Composer}=require("@mail/core/common/composer");const{Thread}=require("@mail/core/common/thread");const{Component,onMounted,onWillUpdateProps,useChildSubEnv,useRef,useState,}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{useThrottleForAnimation}=require("@web/core/utils/timing");const Chatter=__exports.Chatter=class Chatter extends Component{static template="mail.Chatter";static components={Thread,Composer};static props=["composer?","threadId?","threadModel","twoColumns?"];static defaultProps={composer:true,threadId:false,twoColumns:false};setup(){this.store=useState(useService("mail.store"));this.state=useState({jumpThreadPresent:0,thread:undefined,aside:false,});this.rootRef=useRef("root");this.onScrollDebounced=useThrottleForAnimation(this.onScroll);useChildSubEnv(this.childSubEnv);onMounted(this._onMounted);onWillUpdateProps((nextProps)=>{if(this.props.threadId!==nextProps.threadId||this.props.threadModel!==nextProps.threadModel){this.changeThread(nextProps.threadModel,nextProps.threadId);}
if(!this.env.chatter||this.env.chatter?.fetchData){if(this.env.chatter){this.env.chatter.fetchData=false;}
this.load(this.state.thread,this.requestList);}});}
get afterPostRequestList(){return["messages"];}
get childSubEnv(){return{inChatter:this.state};}
get onCloseFullComposerRequestList(){return["messages"];}
get requestList(){return[];}
changeThread(threadModel,threadId){this.state.thread=this.store.Thread.insert({model:threadModel,id:threadId});if(threadId===false){if(this.state.thread.messages.length===0){this.state.thread.messages.push({id:this.store.getNextTemporaryId(),author:this.store.self,body:_t("Creating a new record..."),message_type:"notification",thread:this.state.thread,trackingValues:[],res_id:threadId,model:threadModel,});}}}
load(thread,requestList){if(!thread.id||!this.state.thread?.eq(thread)){return;}
thread.fetchData(requestList);}
onCloseFullComposerCallback(){this.load(this.state.thread,this.onCloseFullComposerRequestList);}
_onMounted(){this.changeThread(this.props.threadModel,this.props.threadId);if(!this.env.chatter||this.env.chatter?.fetchData){if(this.env.chatter){this.env.chatter.fetchData=false;}
this.load(this.state.thread,this.requestList);}}
onPostCallback(){this.state.jumpThreadPresent++;this.load(this.state.thread,this.afterPostRequestList);}
onScroll(){this.state.isTopStickyPinned=this.rootRef.el.scrollTop!==0;}}
return __exports;});;

/* /mail/static/src/chatter/web_portal/composer_patch.js */
odoo.define('@mail/chatter/web_portal/composer_patch',['@mail/core/common/composer','@web/core/l10n/translation','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Composer}=require("@mail/core/common/composer");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");patch(Composer.prototype,{get placeholder(){if(this.thread&&this.thread.model!=="discuss.channel"&&!this.props.placeholder){if(this.props.type==="message"){return _t("Send a message to followers…");}else{return _t("Log an internal note…");}}
return super.placeholder;},});return __exports;});;

/* /mail/static/src/chatter/web_portal/thread_model_patch.js */
odoo.define('@mail/chatter/web_portal/thread_model_patch',['@mail/core/common/thread_model','@web/core/network/rpc','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Thread}=require("@mail/core/common/thread_model");const{rpc}=require("@web/core/network/rpc");const{patch}=require("@web/core/utils/patch");patch(Thread.prototype,{async fetchData(requestList){if(requestList.includes("messages")){this.fetchNewMessages();}
const result=await rpc("/mail/thread/data",{request_list:requestList,thread_id:this.id,thread_model:this.model,...this.rpcParams,});this.store.insert(result,{html:true});},});return __exports;});;

/* /mail/static/src/chatter/web/chatter_patch.js */
odoo.define('@mail/chatter/web/chatter_patch',['@mail/chatter/web/scheduled_message','@mail/core/web/activity','@mail/core/common/attachment_list','@mail/core/web/base_recipients_list','@mail/chatter/web_portal/chatter','@mail/core/web/suggested_recipient_list','@mail/core/web/follower_list','@mail/utils/common/misc','@mail/core/common/attachment_uploader_hook','@web/core/dropzone/dropzone_hook','@mail/utils/common/hooks','@mail/core/common/mail_attachment_dropzone','@mail/core/common/search_message_input','@mail/core/common/search_message_result','@odoo/owl','@web/core/l10n/translation','@web/core/browser/browser','@web/core/dropdown/dropdown','@web/views/fields/file_handler','@web/core/utils/patch','@web/core/dropdown/dropdown_hooks','@web/core/utils/hooks','@mail/core/common/message_search_hook','@mail/core/common/attachment_view'],function(require){'use strict';let __exports={};const{ScheduledMessage}=require("@mail/chatter/web/scheduled_message");const{Activity}=require("@mail/core/web/activity");const{AttachmentList}=require("@mail/core/common/attachment_list");const{BaseRecipientsList}=require("@mail/core/web/base_recipients_list");const{Chatter}=require("@mail/chatter/web_portal/chatter");const{SuggestedRecipientsList}=require("@mail/core/web/suggested_recipient_list");const{FollowerList}=require("@mail/core/web/follower_list");const{isDragSourceExternalFile}=require("@mail/utils/common/misc");const{useAttachmentUploader}=require("@mail/core/common/attachment_uploader_hook");const{useCustomDropzone}=require("@web/core/dropzone/dropzone_hook");const{useHover,useMessageHighlight}=require("@mail/utils/common/hooks");const{MailAttachmentDropzone}=require("@mail/core/common/mail_attachment_dropzone");const{SearchMessageInput}=require("@mail/core/common/search_message_input");const{SearchMessageResult}=require("@mail/core/common/search_message_result");const{useEffect}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{Dropdown}=require("@web/core/dropdown/dropdown");const{FileUploader}=require("@web/views/fields/file_handler");const{patch}=require("@web/core/utils/patch");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const{useService}=require("@web/core/utils/hooks");const{useMessageSearch}=require("@mail/core/common/message_search_hook");const{usePopoutAttachment}=require("@mail/core/common/attachment_view");const DELAY_FOR_SPINNER=__exports.DELAY_FOR_SPINNER=1000;Object.assign(Chatter.components,{Activity,AttachmentList,BaseRecipientsList,Dropdown,FileUploader,FollowerList,ScheduledMessage,SearchMessageInput,SearchMessageResult,SuggestedRecipientsList,});Chatter.props.push("close?","compactHeight?","has_activities?","hasAttachmentPreview?","hasParentReloadOnAttachmentsChanged?","hasParentReloadOnFollowersUpdate?","hasParentReloadOnMessagePosted?","highlightMessageId?","isAttachmentBoxVisibleInitially?","isChatterAside?","isInFormSheetBg?","saveRecord?","webRecord?");Object.assign(Chatter.defaultProps,{compactHeight:false,has_activities:true,hasAttachmentPreview:false,hasParentReloadOnAttachmentsChanged:false,hasParentReloadOnFollowersUpdate:false,hasParentReloadOnMessagePosted:false,isAttachmentBoxVisibleInitially:false,isChatterAside:false,isInFormSheetBg:true,});patch(Chatter.prototype,{setup(){this.messageHighlight=useMessageHighlight();super.setup(...arguments);this.orm=useService("orm");this.attachmentPopout=usePopoutAttachment();Object.assign(this.state,{composerType:false,isAttachmentBoxOpened:this.props.isAttachmentBoxVisibleInitially,isSearchOpen:false,showActivities:true,showAttachmentLoading:false,showScheduledMessages:true,});this.messageSearch=useMessageSearch();this.attachmentUploader=useAttachmentUploader(this.store.Thread.insert({model:this.props.threadModel,id:this.props.threadId}));this.unfollowHover=useHover("unfollow");this.followerListDropdown=useDropdownState();this.loadingAttachmentTimeout=null;useCustomDropzone(this.rootRef,MailAttachmentDropzone,{extraClass:"o-mail-Chatter-dropzone",onDrop:async(ev)=>{if(this.state.composerType){return;}
if(isDragSourceExternalFile(ev.dataTransfer)){const files=[...ev.dataTransfer.files];if(!this.state.thread.id){const saved=await this.props.saveRecord?.();if(!saved){return;}}
Promise.all(files.map((file)=>this.attachmentUploader.uploadFile(file))).then(()=>{if(this.props.hasParentReloadOnAttachmentsChanged){this.reloadParentView();}});this.state.isAttachmentBoxOpened=true;}}});useEffect(()=>{if(!this.state.thread){return;}
browser.clearTimeout(this.loadingAttachmentTimeout);if(this.state.thread?.isLoadingAttachments){this.loadingAttachmentTimeout=browser.setTimeout(()=>(this.state.showAttachmentLoading=true),DELAY_FOR_SPINNER);}else{this.state.showAttachmentLoading=false;this.state.isAttachmentBoxOpened=this.state.isAttachmentBoxOpened||(this.props.isAttachmentBoxVisibleInitially&&this.attachments.length>0);}
return()=>browser.clearTimeout(this.loadingAttachmentTimeout);},()=>[this.state.thread,this.state.thread?.isLoadingAttachments]);useEffect(()=>{if(this.state.thread&&!["new","loading"].includes(this.state.thread.status)&&this.attachments.length===0){this.state.isAttachmentBoxOpened=false;}},()=>[this.state.thread?.status,this.attachments]);useEffect(()=>{this.state.aside=this.props.isChatterAside;},()=>[this.props.isChatterAside]);},get activities(){return this.state.thread?.activities??[];},get afterPostRequestList(){return[...super.afterPostRequestList,"followers","scheduledMessages","suggestedRecipients",];},get attachments(){return this.state.thread?.attachments??[];},get childSubEnv(){const res=Object.assign(super.childSubEnv,{messageHighlight:this.messageHighlight});res.inChatter.aside=this.props.isChatterAside;return res;},get followerButtonLabel(){return _t("Show Followers");},get followingText(){return _t("Following");},get isDisabled(){return!this.state.thread.id||!this.state.thread?.hasReadAccess;},get onCloseFullComposerRequestList(){return[...super.onCloseFullComposerRequestList,"scheduledMessages"];},get requestList(){return[...super.requestList,"activities","attachments","followers","scheduledMessages","suggestedRecipients",];},get scheduledMessages(){return this.state.thread?.scheduledMessages??[];},get unfollowText(){return _t("Unfollow");},changeThread(threadModel,threadId){super.changeThread(...arguments);this.attachmentUploader.thread=this.state.thread;if(threadId===false){this.state.composerType=false;}else{this.onThreadCreated?.(this.state.thread);this.onThreadCreated=null;this.messageSearch.thread=this.state.thread;this.closeSearch();}},closeSearch(){this.messageSearch.clear();this.state.isSearchOpen=false;},async _follow(thread){await this.orm.call(thread.model,"message_subscribe",[[thread.id]],{partner_ids:[this.store.self.id],});this.onFollowerChanged(thread);},onActivityChanged(thread){this.load(thread,[...this.requestList,"messages"]);},onAddFollowers(){this.load(this.state.thread,["followers","suggestedRecipients"]);if(this.props.hasParentReloadOnFollowersUpdate){this.reloadParentView();}},onClickAddAttachments(){if(this.attachments.length===0){return;}
this.state.isAttachmentBoxOpened=!this.state.isAttachmentBoxOpened;if(this.state.isAttachmentBoxOpened){this.rootRef.el.scrollTop=0;this.state.thread.scrollTop="bottom";}},async onClickAttachFile(ev){if(this.state.thread.id){return;}
const saved=await this.props.saveRecord?.();if(!saved){return false;}},async onClickFollow(){if(this.state.thread.id){this._follow(this.state.thread);}else{this.onThreadCreated=this._follow;await this.props.saveRecord?.();}},onClickSearch(){this.state.composerType=false;this.state.isSearchOpen=!this.state.isSearchOpen;},async onClickUnfollow(){const thread=this.state.thread;await thread.selfFollower.remove();this.onFollowerChanged(thread);},onCloseFullComposerCallback(){this.toggleComposer();super.onCloseFullComposerCallback();},onFollowerChanged(thread){document.body.click();this.reloadParentView();this.load(thread,["followers","suggestedRecipients"]);},_onMounted(){super._onMounted();if(this.state.thread&&this.props.highlightMessageId){this.state.thread.highlightMessage=this.props.highlightMessageId;}},onPostCallback(){if(this.props.hasParentReloadOnMessagePosted){this.reloadParentView();}
this.toggleComposer();super.onPostCallback();},onScheduledMessageChanged(thread){this.load(thread,["scheduledMessages","messages"]);},onSuggestedRecipientAdded(thread){this.load(thread,["suggestedRecipients"]);},async onUploaded(data){await this.attachmentUploader.uploadData(data);if(this.props.hasParentReloadOnAttachmentsChanged){this.reloadParentView();}
this.state.isAttachmentBoxOpened=true;if(this.rootRef.el){this.rootRef.el.scrollTop=0;}
this.state.thread.scrollTop="bottom";},async reloadParentView(){await this.props.saveRecord?.();if(this.props.webRecord){await this.props.webRecord.load();}},async scheduleActivity(){this.closeSearch();const schedule=async(thread)=>{await this.store.scheduleActivity(thread.model,[thread.id]);this.load(thread,["activities","messages"]);};if(this.state.thread.id){schedule(this.state.thread);}else{this.onThreadCreated=schedule;this.props.saveRecord?.();}},toggleActivities(){this.state.showActivities=!this.state.showActivities;},toggleComposer(mode=false){this.closeSearch();const toggle=()=>{if(this.state.composerType===mode){this.state.composerType=false;}else{this.state.composerType=mode;}};if(this.state.thread.id){toggle();}else{this.onThreadCreated=toggle;this.props.saveRecord?.();}},toggleScheduledMessages(){this.state.showScheduledMessages=!this.state.showScheduledMessages;},async unlinkAttachment(attachment){await this.attachmentUploader.unlink(attachment);if(this.props.hasParentReloadOnAttachmentsChanged){this.reloadParentView();}},popoutAttachment(){this.attachmentPopout.popout();},});return __exports;});;

/* /mail/static/src/chatter/web/form_arch_parser.js */
odoo.define('@mail/chatter/web/form_arch_parser',['@web/core/utils/patch','@web/views/form/form_arch_parser'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{FormArchParser}=require("@web/views/form/form_arch_parser");patch(FormArchParser.prototype,{parse(xmlDoc,models,modelName){const result=super.parse(...arguments);result.has_activities=Boolean(models[modelName].has_activities);return result;},});return __exports;});;

/* /mail/static/src/chatter/web/form_compiler.js */
odoo.define('@mail/chatter/web/form_compiler',['@web/core/registry','@web/core/utils/patch','@web/core/utils/xml','@web/views/form/form_compiler'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{patch}=require("@web/core/utils/patch");const{append,createElement,extractAttributes,setAttributes}=require("@web/core/utils/xml");const{FormCompiler}=require("@web/views/form/form_compiler");function compileChatter(node,params){const chatterContainerXml=createElement("t");setAttributes(chatterContainerXml,{"t-component":"__comp__.mailComponents.Chatter",has_activities:"__comp__.props.archInfo.has_activities",hasAttachmentPreview:Boolean(this.templates.FormRenderer.querySelector(".o_attachment_preview")),hasParentReloadOnAttachmentsChanged:Boolean(node.getAttribute("reload_on_attachment")),hasParentReloadOnFollowersUpdate:Boolean(node.getAttribute("reload_on_follower")),hasParentReloadOnMessagePosted:Boolean(node.getAttribute("reload_on_post")),isAttachmentBoxVisibleInitially:Boolean(node.getAttribute("open_attachments")),threadId:"__comp__.props.record.resId or undefined",threadModel:"__comp__.props.record.resModel",webRecord:"__comp__.props.record",saveRecord:"() => __comp__.save and __comp__.save()",highlightMessageId:"__comp__.highlightMessageId",});const chatterContainerHookXml=createElement("div");chatterContainerHookXml.classList.add("o-mail-ChatterContainer","o-mail-Form-chatter");setAttributes(chatterContainerHookXml,{"t-if":"!__comp__.env.inDialog"});append(chatterContainerHookXml,chatterContainerXml);return chatterContainerHookXml;}
function compileAttachmentPreview(node,params){const webClientViewAttachmentViewContainerHookXml=createElement("div");webClientViewAttachmentViewContainerHookXml.classList.add("o_attachment_preview");const webClientViewAttachmentViewContainerXml=createElement("t");setAttributes(webClientViewAttachmentViewContainerXml,{"t-component":"__comp__.mailComponents.AttachmentView",threadId:"__comp__.props.record.resId or undefined",threadModel:"__comp__.props.record.resModel",});append(webClientViewAttachmentViewContainerHookXml,webClientViewAttachmentViewContainerXml);return webClientViewAttachmentViewContainerHookXml;}
registry.category("form_compilers").add("chatter_compiler",{selector:"chatter",fn:compileChatter,});registry.category("form_compilers").add("attachment_preview_compiler",{selector:"div.o_attachment_preview",fn:compileAttachmentPreview,});patch(FormCompiler.prototype,{compile(node,params){const res=super.compile(node,params);const chatterContainerHookXml=res.querySelector(".o-mail-Form-chatter");if(!chatterContainerHookXml){return res;}
const chatterContainerXml=chatterContainerHookXml.querySelector("t[t-component='__comp__.mailComponents.Chatter']");setAttributes(chatterContainerXml,{isChatterAside:"false",isInFormSheetBg:"false",saveRecord:"__comp__.props.saveRecord",});if(chatterContainerHookXml.parentNode.classList.contains("o_form_sheet")){return res;}
const formSheetBgXml=res.querySelector(".o_form_sheet_bg");const parentXml=formSheetBgXml&&formSheetBgXml.parentNode;if(!parentXml){return res;}
const webClientViewAttachmentViewHookXml=res.querySelector(".o_attachment_preview");const hasPreview=!!webClientViewAttachmentViewHookXml;if(webClientViewAttachmentViewHookXml){setAttributes(webClientViewAttachmentViewHookXml,{"t-if":`__comp__.mailLayout(${hasPreview}).includes("COMBO")`,});const sheetBgChatterContainerHookXml=chatterContainerHookXml.cloneNode(true);sheetBgChatterContainerHookXml.classList.add("o-isInFormSheetBg","w-auto");setAttributes(sheetBgChatterContainerHookXml,{"t-if":`__comp__.mailLayout(${hasPreview}) == "COMBO"`,});append(formSheetBgXml,sheetBgChatterContainerHookXml);const sheetBgChatterContainerXml=sheetBgChatterContainerHookXml.querySelector("t[t-component='__comp__.mailComponents.Chatter']");setAttributes(sheetBgChatterContainerXml,{isInFormSheetBg:"true",isChatterAside:"false",});}
setAttributes(chatterContainerXml,{isInFormSheetBg:`["COMBO", "BOTTOM_CHATTER"].includes(__comp__.mailLayout(${hasPreview}))`,isChatterAside:`["SIDE_CHATTER", "EXTERNAL_COMBO_XXL", "EXTERNAL_COMBO"].includes(__comp__.mailLayout(${hasPreview}))`,});const{["t-if"]:tIf}=extractAttributes(chatterContainerHookXml,["t-if"]);setAttributes(chatterContainerHookXml,{"t-if":`${
                tIf ? tIf : "true"
            } and (!["COMBO", "NONE"].includes(__comp__.mailLayout(${hasPreview})))`,"t-attf-class":`{{ ["SIDE_CHATTER", "EXTERNAL_COMBO_XXL"].includes(__comp__.mailLayout(${hasPreview})) ? "o-aside w-print-100" : "mt-4 mt-md-0" }}`,});append(parentXml,chatterContainerHookXml);return res;},});return __exports;});;

/* /mail/static/src/chatter/web/form_controller.js */
odoo.define('@mail/chatter/web/form_controller',['@mail/utils/common/html','@odoo/owl','@web/core/orm_service','@web/core/utils/hooks','@web/core/utils/patch','@web/views/form/form_controller'],function(require){'use strict';let __exports={};const{createDocumentFragmentFromContent}=require("@mail/utils/common/html");const{useSubEnv}=require("@odoo/owl");const{x2ManyCommands}=require("@web/core/orm_service");const{useService}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");const{FormController}=require("@web/views/form/form_controller");patch(FormController.prototype,{setup(){super.setup(...arguments);if(this.env.services["mail.store"]){this.mailStore=useService("mail.store");}
useSubEnv({chatter:{fetchData:true,fetchMessages:true,},});},onWillLoadRoot(nextConfiguration){super.onWillLoadRoot(...arguments);this.env.chatter.fetchData=true;this.env.chatter.fetchMessages=true;const isSameThread=this.model.root?.resId===nextConfiguration.resId&&this.model.root?.resModel===nextConfiguration.resModel;if(isSameThread){const{resModel,resId}=this.model.root;this.env.bus.trigger("MAIL:RELOAD-THREAD",{model:resModel,id:resId});}},async onWillSaveRecord(record,changes){if(record.resModel==="mail.compose.message"){const doc=createDocumentFragmentFromContent(changes.body);const partnerElements=doc.querySelectorAll('[data-oe-model="res.partner"]');const partnerIds=Array.from(partnerElements).map((element)=>parseInt(element.dataset.oeId));if(partnerIds.length){if(changes.partner_ids[0]&&changes.partner_ids[0][0]===x2ManyCommands.SET){partnerIds.push(...changes.partner_ids[0][2]);}
changes.partner_ids.push(...partnerIds.map((pid)=>x2ManyCommands.link(pid)));}}},});return __exports;});;

/* /mail/static/src/chatter/web/form_renderer.js */
odoo.define('@mail/chatter/web/form_renderer',['@mail/core/common/attachment_view','@mail/chatter/web_portal/chatter','@odoo/owl','@web/core/browser/browser','@web/core/browser/router','@web/core/ui/ui_service','@web/core/utils/hooks','@web/core/utils/patch','@web/core/utils/timing','@web/views/form/form_renderer'],function(require){'use strict';let __exports={};const{AttachmentView}=require("@mail/core/common/attachment_view");const{Chatter}=require("@mail/chatter/web_portal/chatter");const{onMounted,onWillUnmount,useState}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{router}=require("@web/core/browser/router");const{SIZES}=require("@web/core/ui/ui_service");const{useService}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");const{useDebounced}=require("@web/core/utils/timing");const{FormRenderer}=require("@web/views/form/form_renderer");patch(FormRenderer.prototype,{setup(){super.setup();this.mailComponents={AttachmentView,Chatter,};this.highlightMessageId=router.current.highlight_message_id;this.messagingState=useState({thread:undefined,});if(this.env.services["mail.store"]){this.mailStore=useService("mail.store");}
this.uiService=useService("ui");this.mailPopoutService=useService("mail.popout");this.onResize=useDebounced(this.render,200);onMounted(()=>browser.addEventListener("resize",this.onResize));onWillUnmount(()=>browser.removeEventListener("resize",this.onResize));},hasFile(){if(!this.mailStore||!this.props.record.resId){return false;}
this.messagingState.thread=this.mailStore.Thread.insert({id:this.props.record.resId,model:this.props.record.resModel,});return this.messagingState.thread.attachmentsInWebClientView.length>0;},mailLayout(hasAttachmentContainer){const xxl=this.uiService.size>=SIZES.XXL;const hasFile=this.hasFile();const hasChatter=!!this.mailStore;const hasExternalWindow=!!this.mailPopoutService.externalWindow;if(hasExternalWindow&&hasFile&&hasAttachmentContainer){if(xxl){return"EXTERNAL_COMBO_XXL";}
return"EXTERNAL_COMBO";}
if(hasChatter){if(xxl){if(hasAttachmentContainer&&hasFile){return"COMBO";}
return"SIDE_CHATTER";}
return"BOTTOM_CHATTER";}
return"NONE";},});return __exports;});;

/* /mail/static/src/chatter/web/mail_composer_form.js */
odoo.define('@mail/chatter/web/mail_composer_form',['@web/views/form/form_view','@web/core/registry','@odoo/owl','@web/core/dropzone/dropzone_hook','@web/core/utils/hooks','@web/views/fields/relational_utils','@mail/core/common/mail_attachment_dropzone'],function(require){'use strict';let __exports={};const{formView}=require("@web/views/form/form_view");const{registry}=require("@web/core/registry");const{EventBus,toRaw,useEffect,useRef,useSubEnv}=require("@odoo/owl");const{useCustomDropzone}=require("@web/core/dropzone/dropzone_hook");const{useService}=require("@web/core/utils/hooks");const{useX2ManyCrud}=require("@web/views/fields/relational_utils");const{MailAttachmentDropzone}=require("@mail/core/common/mail_attachment_dropzone");const MailComposerFormController=__exports.MailComposerFormController=class MailComposerFormController extends formView.Controller{static props={...formView.Controller.props,fullComposerBus:{type:EventBus,optional:true},};setup(){super.setup();toRaw(this.env.dialogData).model="mail.compose.message";if(this.props.fullComposerBus){useSubEnv({fullComposerBus:this.props.fullComposerBus,});}}}
const MailComposerFormRenderer=__exports.MailComposerFormRenderer=class MailComposerFormRenderer extends formView.Renderer{setup(){super.setup();this.root=useRef("compiled_view_root");useEffect((isInEdition,root)=>{if(root&&root.el&&isInEdition){const element=root.el.querySelector(".note-editable[contenteditable]");if(element){element.focus();document.dispatchEvent(new Event("selectionchange",{}));}}},()=>[this.props.record.isInEdition,this.root,this.props.record.resId]);this.attachmentUploadService=useService("mail.attachment_upload");this.operations=useX2ManyCrud(()=>{return this.props.record.data["attachment_ids"];},true);useCustomDropzone(this.root,MailAttachmentDropzone,{onDrop:async event=>{const resIds=JSON.parse(this.props.record.data.res_ids);const thread=await this.mailStore.Thread.insert({model:this.props.record.data.model,id:resIds[0],});for(const file of event.dataTransfer.files){const attachment=await this.attachmentUploadService.upload(thread,thread.composer,file);await this.operations.saveRecord([attachment.id]);}}});}}
registry.category("views").add("mail_composer_form",{...formView,Controller:MailComposerFormController,Renderer:MailComposerFormRenderer,});return __exports;});;

/* /mail/static/src/chatter/web/mail_composer_schedule_dialog.js */
odoo.define('@mail/chatter/web/mail_composer_schedule_dialog',['@web/core/datetime/datetime_input','@web/core/dialog/dialog','@web/core/l10n/dates','@odoo/owl'],function(require){'use strict';let __exports={};const{DateTimeInput}=require("@web/core/datetime/datetime_input");const{Dialog}=require("@web/core/dialog/dialog");const{serializeDateTime,today}=require("@web/core/l10n/dates");const{Component,useState}=require("@odoo/owl");const MailComposerScheduleDialog=__exports.MailComposerScheduleDialog=class MailComposerScheduleDialog extends Component{static template="mail.MailComposerScheduleDialog";static props={close:Function,isNote:Boolean,schedule:Function,};static components={DateTimeInput,Dialog,};setup(){const now=luxon.DateTime.now();this.state=useState({customDateTime:now.plus({hours:1}).set({minutes:Math.ceil(now.minute/5)*5,seconds:0,milliseconds:0}),selectedOption:"morning",});this.dateTimeFormat={day:"numeric",hour:"numeric",minute:"numeric",month:"short",};}
get dateTimePickerProps(){return{minDate:luxon.DateTime.now(),onSelect:(value)=>(this.state.customDateTime=value),type:"datetime",value:this.state.customDateTime,};}
get mondayMorning(){return today().plus({days:(1-today().weekday+7)%7||7}).set({hour:8});}
get tomorrowAfternoon(){return today().plus({days:1}).set({hour:13});}
get tomorrowMorning(){return today().plus({days:1}).set({hour:8});}
get scheduledDate(){if(this.state.selectedOption==="morning"){return this.tomorrowMorning;}else if(this.state.selectedOption==="afternoon"){return this.tomorrowAfternoon;}else if(this.state.selectedOption==="monday"){return this.mondayMorning;}else{return this.state.customDateTime;}}
async schedule(){await this.props.schedule(serializeDateTime(this.scheduledDate));this.props.close();}}
return __exports;});;

/* /mail/static/src/chatter/web/mail_composer_send_dropdown.js */
odoo.define('@mail/chatter/web/mail_composer_send_dropdown',['@mail/chatter/web/mail_composer_schedule_dialog','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/registry','@web/core/utils/hooks','@web/views/widgets/standard_widget_props','@odoo/owl'],function(require){'use strict';let __exports={};const{MailComposerScheduleDialog}=require("@mail/chatter/web/mail_composer_schedule_dialog");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{Component,useState}=require("@odoo/owl");class MailComposerSendDropdown extends Component{static components={Dropdown,DropdownItem,};static props=standardWidgetProps;static template="mail.MailComposerSendDropdown";setup(){super.setup();this.actionService=useService("action");this.dialogService=useService("dialog");this.orm=useService("orm");this.buttonState=useState({disabled:false});}
async onClickSend(){this.buttonState.disabled=true;if(await this.props.record.save()){const method=this.props.record.data.scheduled_date?"action_schedule_message":"action_send_mail";this.actionService.doAction(await this.orm.call("mail.compose.message",method,[this.props.record.resId],{context:this.props.record.context,}),);}
this.buttonState.disabled=false;}
async onClickSendLater(){if(await this.props.record.save()){this.dialogService.add(MailComposerScheduleDialog,{isNote:this.props.record.data.subtype_is_log,schedule:async(scheduledDate)=>{await this.env.services.action.doAction(await this.env.services.orm.call("mail.compose.message","action_schedule_message",[this.props.record.resId,scheduledDate],{context:this.props.record.context},),);},});}}}
const mailComposerSendDropdown={component:MailComposerSendDropdown};registry.category("view_widgets").add("mail_composer_send_dropdown",mailComposerSendDropdown);return __exports;});;

/* /mail/static/src/chatter/web/scheduled_message.js */
odoo.define('@mail/chatter/web/scheduled_message',['@mail/core/common/attachment_list','@mail/core/common/relative_time','@mail/discuss/web/avatar_card/avatar_card_popover','@web/core/confirmation_dialog/confirmation_dialog','@web/core/l10n/translation','@web/core/popover/popover_hook','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{AttachmentList}=require("@mail/core/common/attachment_list");const{RelativeTime}=require("@mail/core/common/relative_time");const{AvatarCardPopover}=require("@mail/discuss/web/avatar_card/avatar_card_popover");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{_t}=require("@web/core/l10n/translation");const{usePopover}=require("@web/core/popover/popover_hook");const{useService}=require("@web/core/utils/hooks");const{Component,useState}=require("@odoo/owl");const SCHEDULED_MESSAGE_TRUNCATE_THRESHOLD=__exports.SCHEDULED_MESSAGE_TRUNCATE_THRESHOLD=50;const ScheduledMessage=__exports.ScheduledMessage=class ScheduledMessage extends Component{static props={onScheduledMessageChanged:Function,scheduledMessage:Object,};static template="mail.ScheduledMessage";static components={AttachmentList,RelativeTime,};setup(){super.setup();this.state=useState({readMore:false,});this.avatarCard=usePopover(AvatarCardPopover);this.dialogService=useService("dialog");}
get isShort(){return(this.props.scheduledMessage.textContent.length<SCHEDULED_MESSAGE_TRUNCATE_THRESHOLD);}
get scheduledDate(){return this.props.scheduledMessage.scheduled_date.toLocaleString(luxon.DateTime.DATETIME_SHORT,);}
get truncatedMessage(){return(this.props.scheduledMessage.textContent.substring(0,SCHEDULED_MESSAGE_TRUNCATE_THRESHOLD,)+"...");}
async cancel(){const thread=this.props.scheduledMessage.thread;await this.props.scheduledMessage.cancel();this.props.onScheduledMessageChanged(thread);}
onClick(ev){this.props.scheduledMessage.store.handleClickOnLink(ev,this.props.scheduledMessage.thread);}
async onClickAttachmentUnlink(attachment){attachment.remove();}
onClickAuthor(ev){if(!this.avatarCard.isOpen){this.avatarCard.open(ev.currentTarget,{id:this.props.scheduledMessage.author.userId,});}}
onClickCancel(){this.dialogService.add(ConfirmationDialog,{body:_t("Are you sure you want to cancel the scheduled message?"),cancel:()=>{},cancelLabel:_t("Close"),confirm:this.cancel.bind(this),confirmLabel:_t("Cancel Message"),});}
async onClickEdit(){await this.props.scheduledMessage.edit();this.props.onScheduledMessageChanged(this.props.scheduledMessage.thread);}
async onClickSendNow(){await this.props.scheduledMessage.send();this.props.onScheduledMessageChanged(this.props.scheduledMessage.thread);}}
return __exports;});;

/* /mail/static/src/chatter/web/scheduled_message_model.js */
odoo.define('@mail/chatter/web/scheduled_message_model',['@mail/core/common/record','@mail/utils/common/format','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{htmlToTextContentInline}=require("@mail/utils/common/format");const{_t}=require("@web/core/l10n/translation");const ScheduledMessage=__exports.ScheduledMessage=class ScheduledMessage extends Record{static id="id";static records={};static get(data){return super.get(data);}
id;attachment_ids=Record.many("Attachment");author=Record.one("Persona");body=Record.attr("",{html:true});composition_batch;scheduled_date=Record.attr(undefined,{type:"datetime"});is_note;textContent=Record.attr(false,{compute(){if(!this.body){return"";}
return htmlToTextContentInline(this.body);},});thread=Record.one("Thread");get deletable(){return this.store.self.isAdmin||this.thread.hasWriteAccess;}
get editable(){return this.store.self.isAdmin||this.isSelfAuthored;}
get isSelfAuthored(){return this.author.eq(this.store.self);}
get isSubjectThreadName(){return this.thread.name?.trim().toLowerCase()===this.subject?.trim().toLowerCase();}
async cancel(){await this.store.env.services.orm.unlink("mail.scheduled.message",[this.id]);this.delete();}
async edit(){let action;try{action=await this.store.env.services.orm.call("mail.scheduled.message","open_edit_form",[this.id],);}catch{this.notifyAlreadySent();return;}
return new Promise((resolve)=>this.store.env.services.action.doAction(action,{onClose:resolve}),);}
notifyAlreadySent(){this.store.env.services.notification.add(_t("This message has already been sent."),{type:"warning",});}
async send(){try{await this.store.env.services.orm.call("mail.scheduled.message","post_message",[this.id]);}catch{return;}}}
ScheduledMessage.register();return __exports;});;

/* /mail/static/src/chatter/web/thread_model_patch.js */
odoo.define('@mail/chatter/web/thread_model_patch',['@mail/core/common/record','@mail/core/common/thread_model','@mail/chatter/web_portal/thread_model_patch','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{Thread}=require("@mail/core/common/thread_model");require("@mail/chatter/web_portal/thread_model_patch");const{patch}=require("@web/core/utils/patch");patch(Thread.prototype,{setup(){super.setup();this.scheduledMessages=Record.many("ScheduledMessage",{sort:(a,b)=>{if(a.scheduled_date===b.scheduled_date){return a.id-b.id;}
return a.scheduled_date<b.scheduled_date?-1:1;},inverse:"thread",});},async fetchData(requestList){this.isLoadingAttachments=this.isLoadingAttachments||requestList.includes("attachments");await super.fetchData(requestList);if(!this.mainAttachment&&this.attachmentsInWebClientView.length>0){this.setMainAttachmentFromIndex(0);}},});return __exports;});;

/* /mail/static/src/views/web/fields/activity_exception/activity_exception.js */
odoo.define('@mail/views/web/fields/activity_exception/activity_exception',['@odoo/owl','@web/core/registry','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");class ActivityException extends Component{static props=standardFieldProps;static template="mail.ActivityException";static fieldDependencies=[{name:"activity_exception_icon",type:"char"}];get textClass(){if(this.props.record.data[this.props.name]){return("text-"+
this.props.record.data[this.props.name]+" fa "+
this.props.record.data.activity_exception_icon);}
return undefined;}}
Object.assign(ActivityException,{props:standardFieldProps,template:"mail.ActivityException",});registry.category("fields").add("activity_exception",{component:ActivityException,fieldDependencies:ActivityException.fieldDependencies,label:false,});return __exports;});;

/* /mail/static/src/views/web/fields/assign_user_command_hook.js */
odoo.define('@mail/views/web/fields/assign_user_command_hook',['@odoo/owl','@web/core/commands/command_hook','@web/core/domain','@web/core/l10n/translation','@web/core/user','@web/core/utils/hooks','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{useComponent}=require("@odoo/owl");const{useCommand}=require("@web/core/commands/command_hook");const{Domain}=require("@web/core/domain");const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{getFieldDomain}=require("@web/model/relational_model/utils");__exports.useAssignUserCommand=useAssignUserCommand;function useAssignUserCommand(){const component=useComponent();const orm=useService("orm");const type=component.props.record.fields[component.props.name].type;if(component.relation!=="res.users"){return;}
const getCurrentIds=()=>{if(type==="many2one"&&component.props.record.data[component.props.name]){return[component.props.record.data[component.props.name][0]];}else if(type==="many2many"){return component.props.record.data[component.props.name].currentIds;}
return[];};const add=async(record)=>{if(type==="many2one"){component.props.record.update({[component.props.name]:record});}else if(type==="many2many"){component.props.record.data[component.props.name].linkTo(record[0],{display_name:record[1],});}};const remove=async(record)=>{if(type==="many2one"){component.props.record.update({[component.props.name]:false});}else if(type==="many2many"){component.props.record.data[component.props.name].unlinkFrom(record[0]);}};const provide=async(env,options)=>{const value=options.searchValue.trim();let domain=getFieldDomain(component.props.record,component.props.name,component.props.domain);const context=component.props.context;if(type==="many2many"){const selectedUserIds=getCurrentIds();if(selectedUserIds.length){domain=Domain.and([domain,[["id","not in",selectedUserIds]]]).toList();}}
component._pendingRpc?.abort(false);component._pendingRpc=orm.call(component.relation,"name_search",[],{name:value,args:domain,operator:"ilike",limit:80,context,});const searchResult=await component._pendingRpc;component._pendingRpc=null;return searchResult.map((record)=>({name:record[1],action:add.bind(null,record),}));};const options={category:"smart_action",global:true,identifier:component.props.string,};if(component.props.record.id!==component.props.record.model.root.id){options.isAvailable=()=>component.props.record.model.multiEdit&&component.props.record.selected;}else{options.isAvailable=()=>true;}
useCommand(_t("Assign to ..."),()=>({configByNameSpace:{default:{emptyMessage:_t("No users found"),},},placeholder:_t("Select a user..."),providers:[{provide,},],}),{...options,hotkey:"alt+i",});useCommand(_t("Assign to me"),()=>{add([user.userId,user.name]);},{...options,isAvailable:()=>options.isAvailable()&&!getCurrentIds().includes(user.userId),hotkey:"alt+shift+i",});if(component.props.record.id===component.props.record.model.root.id){useCommand(_t("Unassign from me"),()=>{remove([user.userId,user.name]);},{...options,isAvailable:()=>options.isAvailable()&&getCurrentIds().includes(user.userId),hotkey:"alt+shift+i",});}else{if(type==="many2one"){useCommand(_t("Unassign"),()=>{remove([user.userId,user.name]);},{...options,isAvailable:()=>options.isAvailable()&&getCurrentIds().length>0,hotkey:"alt+shift+u",});}else{useCommand(_t("Unassign from me"),()=>{remove([user.userId,user.name]);},{...options,isAvailable:()=>options.isAvailable()&&getCurrentIds().includes(user.userId),hotkey:"alt+shift+u",});}}}
return __exports;});;

/* /mail/static/src/views/web/fields/avatar/avatar.js */
odoo.define('@mail/views/web/fields/avatar/avatar',['@web/core/popover/popover_hook','@mail/discuss/web/avatar_card/avatar_card_popover','@odoo/owl'],function(require){'use strict';let __exports={};const{usePopover}=require("@web/core/popover/popover_hook");const{AvatarCardPopover}=require("@mail/discuss/web/avatar_card/avatar_card_popover");const{Component}=require("@odoo/owl");const Avatar=__exports.Avatar=class Avatar extends Component{static template="mail.Avatar";static props={resModel:{type:String},resId:{type:Number},displayName:{type:String},noSpacing:{type:Boolean,optional:true},};setup(){this.avatarCard=usePopover(AvatarCardPopover);}
onClickAvatar(ev){if(this.env.isSmall||!this.props.resId){return;}
const target=ev.currentTarget;if(!this.avatarCard.isOpen){this.avatarCard.open(target,{id:this.props.resId,});}}}
return __exports;});;

/* /mail/static/src/views/web/fields/emojis_char_field/emojis_char_field.js */
odoo.define('@mail/views/web/fields/emojis_char_field/emojis_char_field',['@mail/views/web/fields/emojis_field_common/emojis_field_common','@odoo/owl','@web/core/registry','@web/views/fields/char/char_field'],function(require){'use strict';let __exports={};const{EmojisFieldCommon}=require("@mail/views/web/fields/emojis_field_common/emojis_field_common");const{useRef}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{CharField,charField}=require("@web/views/fields/char/char_field");const EmojisCharField=__exports.EmojisCharField=class EmojisCharField extends EmojisFieldCommon(CharField){static template="mail.EmojisCharField";static components={...CharField.components};setup(){super.setup();this.targetEditElement=useRef("input");this._setupOverride();}
get shouldTrim(){return false;}}
const emojisCharField=__exports.emojisCharField={...charField,component:EmojisCharField,additionalClasses:[...(charField.additionalClasses||[]),"o_field_text"],};registry.category("fields").add("char_emojis",emojisCharField);return __exports;});;

/* /mail/static/src/views/web/fields/emojis_field_common/emojis_field_common.js */
odoo.define('@mail/views/web/fields/emojis_field_common/emojis_field_common',['@web/core/emoji_picker/emoji_picker','@odoo/owl'],function(require){'use strict';let __exports={};const{useEmojiPicker}=require("@web/core/emoji_picker/emoji_picker");const{useRef}=require("@odoo/owl");const EmojisFieldCommon=__exports.EmojisFieldCommon=(T)=>class EmojisFieldCommon extends T{_setupOverride(){this.emojiPicker=useEmojiPicker(useRef("emojisButton"),{onSelect:(codepoints)=>{const originalContent=this.targetEditElement.el.value;const start=this.targetEditElement.el.selectionStart;const end=this.targetEditElement.el.selectionEnd;const left=originalContent.slice(0,start);const right=originalContent.slice(end,originalContent.length);this.targetEditElement.el.value=left+codepoints+right;this.targetEditElement.el.dispatchEvent(new InputEvent("input"));this.targetEditElement.el.dispatchEvent(new KeyboardEvent("keydown"));this.targetEditElement.el.focus();const newCursorPos=start+codepoints.length;this.targetEditElement.el.setSelectionRange(newCursorPos,newCursorPos);if(this._emojiAdded){this._emojiAdded();}},},{position:"bottom",});}};return __exports;});;

/* /mail/static/src/views/web/fields/emojis_text_field/emojis_text_field.js */
odoo.define('@mail/views/web/fields/emojis_text_field/emojis_text_field',['@mail/views/web/fields/emojis_field_common/emojis_field_common','@web/core/registry','@web/views/fields/text/text_field'],function(require){'use strict';let __exports={};const{EmojisFieldCommon}=require("@mail/views/web/fields/emojis_field_common/emojis_field_common");const{registry}=require("@web/core/registry");const{TextField,textField}=require("@web/views/fields/text/text_field");const EmojisTextField=__exports.EmojisTextField=class EmojisTextField extends EmojisFieldCommon(TextField){static template="mail.EmojisTextField";static components={...TextField.components};setup(){super.setup();this.targetEditElement=this.textareaRef;this._setupOverride();}}
const emojisTextField=__exports.emojisTextField={...textField,component:EmojisTextField,additionalClasses:[...(textField.additionalClasses||[]),"o_field_text"],};registry.category("fields").add("text_emojis",emojisTextField);return __exports;});;

/* /mail/static/src/views/web/fields/html_composer_message_field/html_composer_message_field.js */
odoo.define('@mail/views/web/fields/html_composer_message_field/html_composer_message_field',['@html_editor/plugin_sets','@html_editor/utils/dom_info','@web/core/registry','@web/core/utils/hooks','@mail/views/web/fields/html_mail_field/html_mail_field','@mail/views/web/fields/html_composer_message_field/mention_plugin','@html_editor/main/signature_plugin'],function(require){'use strict';let __exports={};const{DYNAMIC_PLACEHOLDER_PLUGINS}=require("@html_editor/plugin_sets");const{isEmpty}=require("@html_editor/utils/dom_info");const{registry}=require("@web/core/registry");const{useBus}=require("@web/core/utils/hooks");const{HtmlMailField,htmlMailField}=require("@mail/views/web/fields/html_mail_field/html_mail_field");const{MentionPlugin}=require("@mail/views/web/fields/html_composer_message_field/mention_plugin");const{SIGNATURE_CLASS}=require("@html_editor/main/signature_plugin");const HtmlComposerMessageField=__exports.HtmlComposerMessageField=class HtmlComposerMessageField extends HtmlMailField{setup(){super.setup();if(this.env.fullComposerBus){useBus(this.env.fullComposerBus,"ACCIDENTAL_DISCARD",(ev)=>{const elContent=this.getNoSignatureElContent();ev.detail.onAccidentalDiscard(isEmpty(elContent));});useBus(this.env.fullComposerBus,"SAVE_CONTENT",(ev)=>{const emailAddSignature=Boolean(this.editor.editable.querySelector(`.${SIGNATURE_CLASS}`));const elContent=this.getNoSignatureElContent();this.editor.editable.after(elContent);const textValue=elContent.innerText.replace(/(\t|\n)+/g,"\n");elContent.remove();ev.detail.onSaveContent(textValue,emailAddSignature);});}}
getConfig(){const config=super.getConfig(...arguments);config.Plugins=[...config.Plugins,MentionPlugin];if(!this.props.record.data.composition_batch){config.Plugins=config.Plugins.filter((plugin)=>!DYNAMIC_PLACEHOLDER_PLUGINS.includes(plugin));}
config.onAttachmentChange=(attachment)=>{if(!(this.props.record.fieldNames.includes("attachment_ids")&&this.props.record.resModel==="mail.compose.message")){return;}
this.props.record.data.attachment_ids.linkTo(attachment.id,attachment);};return config;}
getNoSignatureElContent(){const elContent=this.editor.getElContent();this.editor.shared.signature.cleanSignatures({rootClone:elContent});return elContent;}}
const htmlComposerMessageField=__exports.htmlComposerMessageField={...htmlMailField,component:HtmlComposerMessageField,};registry.category("fields").add("html_composer_message",htmlComposerMessageField);return __exports;});;

/* /mail/static/src/views/web/fields/html_composer_message_field/mention_plugin.js */
odoo.define('@mail/views/web/fields/html_composer_message_field/mention_plugin',['@html_editor/plugin','@mail/core/web/mention_list','@web/core/browser/router','@web/core/utils/render','@web/core/utils/urls'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{MentionList}=require("@mail/core/web/mention_list");const{stateToUrl}=require("@web/core/browser/router");const{renderToElement}=require("@web/core/utils/render");const{url}=require("@web/core/utils/urls");const MentionPlugin=__exports.MentionPlugin=class MentionPlugin extends Plugin{static id="mention";static dependencies=["overlay","dom","history","input","selection"];resources={beforeinput_handlers:this.onBeforeInput.bind(this),};setup(){this.mentionList=this.dependencies.overlay.createOverlay(MentionList,{hasAutofocus:true,className:"popover",});}
onSelect(ev,option){this.dependencies.selection.focusEditable();const mentionBlock=renderToElement("mail.Wysiwyg.mentionLink",{option,href:url(stateToUrl({model:option.partner?"res.partner":"discuss.channel",resId:option.partner?option.partner.id:option.channel.id,})),});const nameNode=this.document.createTextNode(`${option.partner ? "@" : "#"}${option.label}`);mentionBlock.appendChild(nameNode);this.historySavePointRestore();this.dependencies.dom.insert(mentionBlock);this.dependencies.history.addStep();}
onBeforeInput(ev){if(ev.data==="@"||ev.data==="#"){this.historySavePointRestore=this.dependencies.history.makeSavePoint();this.mentionList.open({props:{onSelect:this.onSelect.bind(this),type:ev.data==="@"?"partner":"channel",close:()=>{this.mentionList.close();},},});}}}
return __exports;});;

/* /mail/static/src/views/web/fields/html_mail_field/convert_inline.js */
odoo.define('@mail/views/web/fields/html_mail_field/convert_inline',['@html_editor/utils/blocks','@html_editor/utils/color','@html_editor/utils/dom_traversal'],function(require){'use strict';let __exports={};const{isBlock}=require("@html_editor/utils/blocks");const{blendColors}=require("@html_editor/utils/color");const{getAdjacentPreviousSiblings}=require("@html_editor/utils/dom_traversal");function parentsGet(node,root=undefined){const parents=[];while(node){parents.unshift(node);if(node===root){break;}
node=node.parentNode;}
return parents;}
function commonParentGet(node1,node2,root=undefined){if(!node1||!node2){return null;}
const n1p=parentsGet(node1,root);const n2p=parentsGet(node2,root);while(n1p.length>1&&n1p[1]===n2p[1]){n1p.shift();n2p.shift();}
return n1p[0]===n2p[0]?n1p[0]:null;}
const RE_COL_MATCH=/(^| )col(-[\w\d]+)*( |$)/;const RE_COMMAS_OUTSIDE_PARENTHESES=/,(?![^(]*?\))/g;const RE_OFFSET_MATCH=/(^| )offset(-[\w\d]+)*( |$)/;const RE_PADDING_MATCH=/[ ]*padding[^;]*;/g;const RE_PADDING=/([\d.]+)/;const RE_WHITESPACE=/[\s\u200b]*/;const SELECTORS_IGNORE=/(^\*$|:hover|:before|:after|:active|:link|::|'|\([^(),]+[,(])|@page/;const FONT_PROPERTIES_TO_INHERIT=["color","font-size","font-family","font-weight","font-style","text-decoration","text-transform","text-align",];const TABLE_ATTRIBUTES=__exports.TABLE_ATTRIBUTES={cellspacing:0,cellpadding:0,border:0,width:"100%",align:"center",role:"presentation",};const TABLE_STYLES=__exports.TABLE_STYLES={"border-collapse":"collapse","text-align":"inherit","font-size":"unset","line-height":"inherit",};const GROUPED_STYLES={border:["border-top-width","border-right-width","border-bottom-width","border-left-width","border-top-style","border-right-style","border-bottom-style","border-left-style",],padding:["padding-top","padding-bottom","padding-left","padding-right"],margin:["margin-top","margin-bottom","margin-left","margin-right"],"border-radius":["border-top-left-radius","border-top-right-radius","border-bottom-right-radius","border-bottom-left-radius",],};__exports.addTables=addTables;function addTables(element){for(const snippet of element.querySelectorAll(".o_mail_snippet_general, .o_layout")){const table=_createTable(snippet.attributes);const row=document.createElement("tr");let col=document.createElement("td");row.appendChild(col);if(snippet.classList.contains("o_basic_theme")){const div=document.createElement("div");div.classList.add("o_apple_wrapper_padding");col.appendChild(div);col=div;const style=document.createElement("style");const padding="34px";style.textContent=`@media{@media{.o_basic_theme div.o_apple_wrapper_padding{padding:${snippet.style.padding};}}}`+`@media(min-width:961px){@media{@media{.o_basic_theme div.o_apple_wrapper_padding{padding-left:${padding};}}}}`;div.before(style);}
table.appendChild(row);for(const child of[...snippet.childNodes]){col.appendChild(child);}
snippet.before(table);snippet.remove();const childTables=[...col.children].filter((child)=>child.nodeName==="TABLE");if(!childTables.length){const tableB=_createTable();const rowB=document.createElement("tr");const colB=document.createElement("td");rowB.appendChild(colB);tableB.appendChild(rowB);for(const child of[...col.childNodes]){colB.appendChild(child);}
col.appendChild(tableB);}}}
function attachmentThumbnailToLinkImg(element){const links=[...element.querySelectorAll(`a[href*="/web/content/"][data-mimetype]:empty`),].filter((link)=>RE_WHITESPACE.test(link.textContent));for(const link of links){const image=document.createElement("img");image.setAttribute("src",_getStylePropertyValue(link,"background-image").replace(/(^url\(['"])|(['"]\)$)/g,""));image.setAttribute("height",Math.max(1,_getHeight(link)));image.setAttribute("width",Math.max(1,_getWidth(link)));link.prepend(image);}}
__exports.bootstrapToTable=bootstrapToTable;function bootstrapToTable(element){for(const rowInColumn of[...element.querySelectorAll(".row")].filter((row)=>RE_COL_MATCH.test(row.parentElement.className))){const parentColumn=rowInColumn.parentElement;const previous=rowInColumn.previousElementSibling;if(previous&&previous.classList.contains("o_fake_table")){previous.append(rowInColumn);}else{_wrap(rowInColumn,"div","o_fake_table");}
const rowStyle=getComputedStyle(rowInColumn);const columnStyle=getComputedStyle(parentColumn);for(const side of["left","right"]){const negativeMargin=+rowStyle[`margin-${side}`].replace("px","");const columnPadding=+columnStyle[`padding-${side}`].replace("px","");if(negativeMargin<0&&columnPadding>=Math.abs(negativeMargin)){parentColumn.style[`padding-${side}`]=`${columnPadding + negativeMargin}px`;rowInColumn.style[`margin-${side}`]=0;}}}
for(const masonryTopInnerContainer of element.querySelectorAll(".s_masonry_block > .container")){masonryTopInnerContainer.style.setProperty("height","100%");}
for(const masonryGrid of element.querySelectorAll(".o_masonry_grid_container")){masonryGrid.style.setProperty("padding",0);for(const fakeTable of[...masonryGrid.children].filter((c)=>c.classList.contains("o_fake_table"))){fakeTable.style.setProperty("height",_getHeight(fakeTable)+"px");}}
for(const masonryRow of element.querySelectorAll(".o_masonry_grid_container > .o_fake_table > .row.h-100")){masonryRow.style.removeProperty("height");masonryRow.parentElement.style.setProperty("height","100%");}
const containers=element.querySelectorAll(".container, .container-fluid, .o_fake_table");for(const container of containers){container.setAttribute("o-temp-width",_getWidth(container));}
for(const container of[...containers].filter((n)=>[...n.children].some((c)=>c.classList.contains("row")))){const containerWidth=parseFloat(container.getAttribute("o-temp-width"));const table=_createTable(container.attributes);for(const child of[...container.childNodes]){table.append(child);}
table.classList.remove("container","container-fluid","o_fake_table");if(!table.className){table.removeAttribute("class");}
container.before(table);container.remove();for(const row of[...table.children].filter((child)=>isBlock(child)&&!child.classList.contains("row"))){const newCol=_wrap(row,"div","col-12");_wrap(newCol,"div","row");}
for(const bootstrapRow of[...table.children].filter((c)=>c.classList.contains("row"))){const tr=document.createElement("tr");for(const attr of bootstrapRow.attributes){tr.setAttribute(attr.name,attr.value);}
tr.classList.remove("row");if(!tr.className){tr.removeAttribute("class");}
for(const child of[...bootstrapRow.childNodes]){tr.append(child);}
bootstrapRow.before(tr);bootstrapRow.remove();const bootstrapColumns=[...tr.children].filter((column)=>column.className&&column.className.match(RE_COL_MATCH));const flexColumns=bootstrapColumns.filter((column)=>!/\d/.test(column.className.match(RE_COL_MATCH)[0]||"0"));const colTotalSize=bootstrapColumns.map((child)=>_getColumnSize(child)+_getColumnOffsetSize(child)).reduce((a,b)=>a+b,0);const colSize=Math.max(1,Math.round((12-colTotalSize)/flexColumns.length));for(const flexColumn of flexColumns){flexColumn.classList.remove(flexColumn.className.match(RE_COL_MATCH)[0].trim());flexColumn.classList.add(`col-${colSize}`);}
let columnIndex=0;for(const bootstrapColumn of[...bootstrapColumns]){const offsetSize=_getColumnOffsetSize(bootstrapColumn);if(offsetSize){const newColumn=document.createElement("div");newColumn.classList.add(`col-${offsetSize}`);bootstrapColumn.classList.remove(bootstrapColumn.className.match(RE_OFFSET_MATCH)[0].trim());bootstrapColumn.before(newColumn);bootstrapColumns.splice(columnIndex,0,newColumn);columnIndex++;}
columnIndex++;}
let grid=_createColumnGrid();let gridIndex=0;let currentRow=tr.cloneNode();tr.after(currentRow);let currentCol;columnIndex=0;for(const bootstrapColumn of bootstrapColumns){const columnSize=_getColumnSize(bootstrapColumn);if(gridIndex+columnSize<12){currentCol=grid[gridIndex];_applyColspan(currentCol,columnSize,containerWidth);gridIndex+=columnSize;if(columnIndex===bootstrapColumns.length-1){_applyColspan(grid[gridIndex],12-gridIndex,containerWidth);currentRow.append(...grid.filter((td)=>td.getAttribute("colspan")));}}else if(gridIndex+columnSize===12){currentCol=grid[gridIndex];_applyColspan(currentCol,columnSize,containerWidth);currentRow.append(...grid.filter((td)=>td.getAttribute("colspan")));if(columnIndex!==bootstrapColumns.length-1){const previousRow=currentRow;currentRow=currentRow.cloneNode();previousRow.after(currentRow);grid=_createColumnGrid();gridIndex=0;}}else{_applyColspan(grid[gridIndex],12-gridIndex,containerWidth);currentRow.append(...grid.filter((td)=>td.getAttribute("colspan")));const previousRow=currentRow;currentRow=currentRow.cloneNode();previousRow.after(currentRow);grid=_createColumnGrid();currentCol=grid[0];_applyColspan(currentCol,columnSize,containerWidth);gridIndex=columnSize;if(columnIndex===bootstrapColumns.length-1&&gridIndex<12){_applyColspan(grid[gridIndex],12-gridIndex,containerWidth);currentRow.append(...grid.filter((td)=>td.getAttribute("colspan")));}}
if(currentCol){for(const attr of bootstrapColumn.attributes){if(attr.name!=="colspan"){currentCol.setAttribute(attr.name,attr.value);}}
const colMatch=bootstrapColumn.className.match(RE_COL_MATCH);currentCol.classList.remove(colMatch[0].trim());if(!currentCol.className){currentCol.removeAttribute("class");}
for(const child of[...bootstrapColumn.childNodes]){currentCol.append(child);}
_applyColspan(currentCol,+currentCol.getAttribute("colspan"),containerWidth);}
columnIndex++;}
tr.remove();}}
for(const table of element.querySelectorAll("table")){table.removeAttribute("o-temp-width");}
const tds=[...element.querySelectorAll("td")].filter((td)=>td.children.length>1&&[...td.children].every((child)=>child.nodeName==="TABLE")).reverse();for(const td of tds){const table=_createTable();const trs=[...td.children].map((child)=>_wrap(child,"td")).map((wrappedChild)=>_wrap(wrappedChild,"tr"));trs[0].before(table);table.append(...trs);}}
__exports.cardToTable=cardToTable;function cardToTable(element){for(const card of element.querySelectorAll(".card")){const table=_createTable(card.attributes);table.style.removeProperty("overflow");const cardImgTopSuperRows=[];for(const child of[...card.childNodes]){const row=document.createElement("tr");const col=document.createElement("td");if(!["IMG","A"].includes(child.nodeName)&&isBlock(child)){for(const attr of child.attributes){col.setAttribute(attr.name,attr.value);}
for(const descendant of[...child.childNodes]){col.append(descendant);}
child.remove();}else if(child.nodeType===Node.TEXT_NODE){if(child.textContent.replace(RE_WHITESPACE,"").length){col.append(child);}else{continue;}}else{col.append(child);}
const subTable=_createTable();const superRow=document.createElement("tr");const superCol=document.createElement("td");row.append(col);subTable.append(row);superCol.append(subTable);superRow.append(superCol);table.append(superRow);if(child.nodeType===Node.ELEMENT_NODE){const hasImgTop=[child,...child.querySelectorAll(".card-img-top")].some((node)=>node.classList&&node.classList.contains("card-img-top")&&node.closest&&node.closest(".card")===table);if(hasImgTop){cardImgTopSuperRows.push(superRow);}}}
const smallestCardImgRow=Math.min(0,...cardImgTopSuperRows.map((row)=>row.clientHeight));for(const row of cardImgTopSuperRows){row.style.height=smallestCardImgRow+"px";}
card.before(table);card.remove();}}
__exports.classToStyle=classToStyle;function classToStyle(element,cssRules){const writes=[];const nodeToRules=new Map();const rulesToProcess=[];for(const rule of cssRules){const nodes=element.querySelectorAll(rule.selector);if(nodes.length){rulesToProcess.push(rule);}
for(const node of nodes){const nodeRules=nodeToRules.get(node);if(!nodeRules){nodeToRules.set(node,[rule]);}else{nodeRules.push(rule);}}}
_computeStyleAndSpecificityOnRules(rulesToProcess);for(const rules of nodeToRules.values()){rules.sort((a,b)=>a.specificity-b.specificity);}
for(const node of nodeToRules.keys()){const nodeRules=nodeToRules.get(node);const css=nodeRules?_getMatchedCSSRules(node,nodeRules):{};for(const styleName of node.style){if(styleName.includes("flex")||`${node.style[styleName]}`.includes("flex")){writes.push(()=>{node.style[styleName]="";});}}
let style=node.getAttribute("style")||"";style=style.replace(/!important/g,"");for(const[key,value]of Object.entries(css)){if(!new RegExp(`(^|;)\\s*${key}[ :]`).test(style)){style=`${key}:${value};${style}`;}}
if(Object.keys(style||{}).length===0){writes.push(()=>{node.removeAttribute("style");});}else{writes.push(()=>{node.setAttribute("style",style);if(node.style.width){node.setAttribute("width",node.style.width.replace("px","").trim());}});}
if(node.nodeName==="IMG"){writes.push(()=>{if(node.classList.contains("s_media_list_img")){node.style.removeProperty("height");}
if(node.style.getPropertyValue("width")==="100%"&&node.style.getPropertyValue("object-fit")===""){node.style.setProperty("object-fit","cover");}});}
if(node.nodeName==="TD"&&!node.childNodes.length){writes.push(()=>{node.appendChild(document.createTextNode("\u00A0"));});}
if(node.nodeName==="A"&&node.classList.contains("btn")&&!node.classList.contains("btn-link")&&!node.children.length){writes.push(()=>{node.before(_createMso(`<table align="center" border="0"
                    role="presentation" cellpadding="0" cellspacing="0"
                    style="border-radius: 6px; border-collapse: separate !important;">
                        <tbody>
                            <tr>
                                <td style="${node.style.cssText
                                    .replace(RE_PADDING_MATCH, "")
                                    .replaceAll('"', "&quot;")}" ${
                        node.parentElement.style.textAlign === "center" ? 'align="center" ' : ""
                    }bgcolor="${blendColors(node.style.backgroundColor)}">
                    `));node.after(_createMso(`</td>
                        </tr>
                    </tbody>
                </table>`));});}else if(node.nodeName==="IMG"&&node.classList.contains("mx-auto")&&node.classList.contains("d-block")){writes.push(()=>{_wrap(node,"p","o_outlook_hack","text-align:center;margin:0");});}
writes.push(()=>{let computedStyle;for(const styleName of node.style){const styleValue=node.style.getPropertyValue(styleName);if(styleValue.includes("var(")||styleValue.includes("calc(")){computedStyle=computedStyle||getComputedStyle(node);const prop=styleValue.includes("var(")?styleValue.replace(/var\((.*)\)/,"$1"):styleName;const value=computedStyle.getPropertyValue(prop)||computedStyle.getPropertyValue(styleName);node.style.setProperty(styleName,value);}}});writes.push(()=>{const propsToConvert=FONT_PROPERTIES_TO_INHERIT.filter((prop)=>node.style[prop]==="inherit");if(propsToConvert.length){const computedStyle=getComputedStyle(node);for(const prop of propsToConvert){node.style.setProperty(prop,computedStyle[prop]);}}});}
writes.forEach((fn)=>fn());}
function enforceTablesResponsivity(element){const trs=[...element.querySelectorAll(".o_mail_wrapper tr")].filter((tr)=>[...tr.children].some((td)=>td.classList.contains("o_converted_col"))).reverse();for(const tr of trs){const commonTable=_createTable();commonTable.style.height="100%";const commonTr=document.createElement("tr");const commonTd=document.createElement("td");commonTr.appendChild(commonTd);commonTable.appendChild(commonTr);const tds=[...tr.children].filter((child)=>child.nodeName==="TD");let index=0;for(const td of tds){const width=td.style.maxWidth;const div=document.createElement("div");div.style.display="inline-block";div.style.verticalAlign="top";div.classList.add("o_stacking_wrapper");commonTd.appendChild(div);const newTable=_createTable();newTable.style.width=width;newTable.classList.add("o_stacking_wrapper");div.appendChild(newTable);const newTr=document.createElement("tr");newTable.appendChild(newTr);newTr.appendChild(td);td.style.width="100%";td.removeAttribute("width");if(index===0){div.before(_createMso(`
                    <table cellpadding="0" cellspacing="0" border="0" role="presentation" style="width: 100%;">
                        <tr>
                            <td valign="top" style="width: ${width};">`));}else{div.before(_createMso(`</td><td valign="top" style="width: ${width};">`));}
if(index===tds.length-1){div.after(_createMso(`</td></tr></table>`));}
index++;}
const topTd=document.createElement("td");topTd.appendChild(commonTable);tr.prepend(topTd);}}
function handleMasonry(element){const masonryTrs=element.querySelectorAll(".s_masonry_block tr");for(const tr of masonryTrs){const height=_getHeight(tr);const tds=[...tr.children].filter((child)=>child.nodeName==="TD");const tdsWithTable=tds.filter((td)=>[...td.children].some((child)=>child.nodeName==="TABLE"));if(tdsWithTable.length){for(const tdWithTable of tdsWithTable){tdWithTable.classList.add("o_desktop_h100");tdWithTable.style.setProperty("height","100%");}
tds.forEach((td)=>td.style.setProperty("height",height+"px"));}
const trSiblings=[...tr.parentElement.children].filter((child)=>child.nodeName==="TR");if(trSiblings.length>1&&(tr.classList.contains("h-100")||tr.style.getPropertyValue("height")==="100%")){tr.style.setProperty("height",`${_getHeight(tr.parentElement) / trSiblings.length}px`);}}
for(const tr of masonryTrs){const height=tr.style.height.includes("px")?parseFloat(tr.style.height.replace("px","").trim()):_getHeight(tr);tr.closest("table").classList.add("o_desktop_h100");tr.classList.add("o_desktop_h100");for(const td of[...tr.children].filter((child)=>child.nodeName==="TD")){td.classList.add("o_desktop_h100");td.style.setProperty("height","100%");const childrenNames=[...td.children].map((child)=>child.nodeName);if(!childrenNames.includes("TABLE")){const wrapper=document.createElement("div");wrapper.style.setProperty("display","inline-block");wrapper.style.setProperty("width","100%");const tdStyle=getComputedStyle(td);wrapper.style.setProperty("color",tdStyle.color);const firstNonCommentChild=[...td.childNodes].find((child)=>child.nodeType!==Node.COMMENT_NODE);let anchor;if(firstNonCommentChild){anchor=getAdjacentPreviousSiblings(firstNonCommentChild).filter((sib)=>sib.nodeType!==Node.TEXT_NODE).shift();}
for(const child of[...td.childNodes].filter((child)=>child.nodeType!==Node.COMMENT_NODE)){wrapper.append(child);}
anchor?anchor.after(wrapper):td.append(wrapper);const centeringSpan=document.createElement("span");centeringSpan.style.setProperty("height","100%");centeringSpan.style.setProperty("display","inline-block");centeringSpan.style.setProperty("vertical-align","middle");td.prepend(centeringSpan);if(td.style.height.includes("%")){const newHeight=(height*parseFloat(td.style.height.replace("%").trim()))/100;td.style.setProperty("height",newHeight+"px");td.style.setProperty("max-height",newHeight+"px");wrapper.style.setProperty("max-height",newHeight+"px");if(wrapper.childElementCount===1&&wrapper.firstElementChild.nodeName==="IMG"&&wrapper.firstElementChild.style.height==="100%"){wrapper.firstElementChild.style.setProperty("max-height",newHeight+"px");}}}}}}
function enforceImagesResponsivity(element){for(const image of element.querySelectorAll("td > img")){const td=image.parentElement;if(td.childElementCount===1&&(image.classList.contains("h-100")||_getStylePropertyValue(image,"height")==="100%")){td.style.setProperty("height",_getHeight(td.parentElement)+"px");image.style.setProperty("height","100%");}}
for(const image of element.querySelectorAll('img[width="100%"][height]')){image.before(_createMso(image.outerHTML));image.classList.add("mso-hide");image.removeAttribute("height");}}
__exports.toInline=toInline;async function toInline(element,cssRules){for(const imgTop of element.querySelectorAll(".card-img-top")){imgTop.style.setProperty("height",_getHeight(imgTop)+"px");}
attachmentThumbnailToLinkImg(element);fontToImg(element);await svgToPng(element);for(const image of element.querySelectorAll("img.img-fluid")){const width=_getWidth(image);const clone=image.cloneNode();clone.setAttribute("width",width);clone.style.setProperty("width",width+"px");clone.style.removeProperty("max-width");image.before(_createMso(clone.outerHTML));_hideForOutlook(image);}
classToStyle(element,cssRules);bootstrapToTable(element);cardToTable(element);listGroupToTable(element);addTables(element);handleMasonry(element);const rootFontSizeProperty=getComputedStyle(element.ownerDocument.documentElement).fontSize;const rootFontSize=parseFloat(rootFontSizeProperty.replace(/[^\d.]/g,""));normalizeRem(element,rootFontSize);enforceImagesResponsivity(element);enforceTablesResponsivity(element);flattenBackgroundImages(element);formatTables(element);normalizeColors(element);responsiveToStaticForOutlook(element);for(const attributeName of["width","height"]){const images=element.querySelectorAll("img");for(const image of images){if(image.style[attributeName]!=="auto"){const value=image.getAttribute(attributeName)||(attributeName==="height"&&image.offsetHeight)||(attributeName==="width"?_getWidth(image):_getHeight(image));if(value){image.setAttribute(attributeName,value);image.style.setProperty(attributeName,value+"px");}}}}
for(const centeredImage of element.querySelectorAll("td > img.mx-auto")){if(centeredImage.parentElement.children.length===1){centeredImage.parentElement.style.setProperty("text-align","center");}}
[element,...element.querySelectorAll("[contenteditable]")].forEach((node)=>node.removeAttribute("contenteditable"));element.querySelectorAll(".mso-hide").forEach(_hideForOutlook);element.querySelectorAll("[style*=font-family]").forEach((n)=>n.nodeName==="IMG"?n.style.removeProperty("font-family"):n.setAttribute("style",n.getAttribute("style").replaceAll('"',"'")));element.querySelectorAll(".o_converted_col").forEach((node)=>node.classList.remove("o_converted_col"));}
function flattenBackgroundImages(element){const backgroundImages=[...element.querySelectorAll("*[style*=background-image]")].filter((el)=>!el.closest(".mso-hide")).reverse();for(const backgroundImage of backgroundImages){const vml=_backgroundImageToVml(backgroundImage);if(vml){backgroundImage.after(_createMso(vml));backgroundImage.classList.add("mso-hide");}
if(backgroundImage.hasAttribute("data-bg-src")){backgroundImage.removeAttribute("data-bg-src");}}}
function fontToImg(element){const{fonts}=odoo.loader.modules.get("@html_editor/utils/fonts");for(const font of element.querySelectorAll(".fa")){let icon,content;fonts.fontIcons.find((fontIcon)=>{return fonts.getCssSelectors(fontIcon.parser).find((data)=>{if(font.matches(data.selector.replace(/::?before/g,""))){icon=data.names[0].split("-").shift();content=data.css.match(/content:\s*['"]?(.)['"]?/)[1];return true;}});});if(content){const color=_getStylePropertyValue(font,"color").replace(/\s/g,"");let backgroundColoredElement=font;let bg,isTransparent;do{bg=_getStylePropertyValue(backgroundColoredElement,"background-color").replace(/\s/g,"");isTransparent=bg==="transparent"||bg==="rgba(0,0,0,0)";backgroundColoredElement=backgroundColoredElement.parentElement;}while(isTransparent&&backgroundColoredElement);if(bg==="rgba(0,0,0,0)"&&isTransparent){bg="rgb(255,255,255)";}
const style=font.getAttribute("style");const width=_getWidth(font);const height=_getHeight(font);const lineHeight=_getStylePropertyValue(font,"line-height");font.style.setProperty("height","fit-content");font.style.setProperty("width","fit-content");font.style.setProperty("line-height","normal");const intrinsicWidth=_getWidth(font);const intrinsicHeight=_getHeight(font);const hPadding=width&&intrinsicWidth&&(width-intrinsicWidth)/2;const vPadding=height&&intrinsicHeight&&(height-intrinsicHeight)/2;let padding="";if(hPadding||vPadding){padding=vPadding?vPadding+"px ":"0 ";padding+=hPadding?hPadding+"px":"0";}
const image=document.createElement("img");image.setAttribute("width",intrinsicWidth);image.setAttribute("height",intrinsicHeight);image.setAttribute("src",`/web_editor/font_to_img/${content.charCodeAt(0)}/${encodeURIComponent(
                    color
                )}/${encodeURIComponent(bg)}/${Math.max(1, Math.round(intrinsicWidth))}x${Math.max(
                    1,
                    Math.round(intrinsicHeight)
                )}`);image.setAttribute("data-class",font.getAttribute("class"));image.setAttribute("data-style",style);image.setAttribute("style",style);image.style.setProperty("box-sizing","border-box");image.style.setProperty("line-height",lineHeight);image.style.setProperty("width",intrinsicWidth+"px");image.style.setProperty("height",intrinsicHeight+"px");image.style.setProperty("vertical-align","unset");if(!padding){image.style.setProperty("margin",_getStylePropertyValue(font,"margin"));}
const wrapper=document.createElement("span");wrapper.style.setProperty("display","inline-block");wrapper.append(image);font.before(wrapper);if(font.classList.contains("mx-auto")){wrapper.parentElement.style.textAlign="center";}
font.remove();wrapper.style.setProperty("padding",padding);const wrapperWidth=width+
["left","right"].reduce((sum,side)=>sum+
(+_getStylePropertyValue(image,`margin-${side}`).replace("px","")||0),0);wrapper.style.setProperty("width",wrapperWidth+"px");wrapper.style.setProperty("height",height+"px");wrapper.style.setProperty("vertical-align","text-bottom");wrapper.style.setProperty("background-color",image.style.backgroundColor);wrapper.setAttribute("class","oe_unbreakable "+
font.getAttribute("class").replace(new RegExp("(^|\\s+)"+icon+"(-[^\\s]+)?","gi"),""));}else{font.remove();}}}
__exports.formatTables=formatTables;function formatTables(element){const writes=[];for(const table of element.querySelectorAll("table.o_mail_snippet_general, .o_mail_snippet_general table")){const tablePaddingTop=parseFloat(_getStylePropertyValue(table,"padding-top").match(RE_PADDING)[1]);const tablePaddingRight=parseFloat(_getStylePropertyValue(table,"padding-right").match(RE_PADDING)[1]);const tablePaddingBottom=parseFloat(_getStylePropertyValue(table,"padding-bottom").match(RE_PADDING)[1]);const tablePaddingLeft=parseFloat(_getStylePropertyValue(table,"padding-left").match(RE_PADDING)[1]);const rows=[...table.querySelectorAll("tr")].filter((tr)=>tr.closest("table")===table);const columns=[...table.querySelectorAll("td")].filter((td)=>td.closest("table")===table);for(const column of columns){const columnsInRow=[...column.closest("tr").querySelectorAll("td")].filter((td)=>td.closest("table")===table);const columnIndex=columnsInRow.findIndex((col)=>col===column);const rowIndex=rows.findIndex((row)=>row===column.closest("tr"));if(!rowIndex){const match=_getStylePropertyValue(column,"padding-top").match(RE_PADDING);const columnPaddingTop=match?parseFloat(match[1]):0;writes.push(()=>{column.style["padding-top"]=`${columnPaddingTop + tablePaddingTop}px`;});}
if(columnIndex===columnsInRow.length-1){const match=_getStylePropertyValue(column,"padding-right").match(RE_PADDING);const columnPaddingRight=match?parseFloat(match[1]):0;writes.push(()=>{column.style["padding-right"]=`${columnPaddingRight + tablePaddingRight}px`;});}
if(rowIndex===rows.length-1){const match=_getStylePropertyValue(column,"padding-bottom").match(RE_PADDING);const columnPaddingBottom=match?parseFloat(match[1]):0;writes.push(()=>{column.style["padding-bottom"]=`${
                        columnPaddingBottom + tablePaddingBottom
                    }px`;});}
if(!columnIndex){const match=_getStylePropertyValue(column,"padding-left").match(RE_PADDING);const columnPaddingLeft=match?parseFloat(match[1]):0;writes.push(()=>{column.style["padding-left"]=`${columnPaddingLeft + tablePaddingLeft}px`;});}}
writes.push(()=>{table.style.removeProperty("padding");});}
writes.forEach((fn)=>fn());for(const table of[...element.querySelectorAll("table")].filter((n)=>![...n.children].some((c)=>c.nodeName==="TBODY"))){const contents=[...table.childNodes];const tbody=document.createElement("tbody");tbody.style.setProperty("vertical-align","top");table.prepend(tbody);tbody.append(...contents);}
for(const node of[...element.querySelectorAll("*")].filter((n)=>n.style&&n.style.getPropertyValue("height")==="100%"&&(!n.parentElement.style.getPropertyValue("height")||n.parentElement.style.getPropertyValue("height").includes("%")))){let parent=node.parentElement;let height=parent.style.getPropertyValue("height");while(parent&&height&&height.includes("%")){parent=parent.parentElement;height=parent.style.getPropertyValue("height");}
if(parent){parent.style.setProperty("height",parent.getBoundingClientRect().height);}}
for(const cell of element.querySelectorAll("td")){const alignSelf=cell.style.alignSelf;const justifyContent=cell.style.justifyContent;if(alignSelf==="start"||justifyContent==="start"||justifyContent==="flex-start"){cell.style.verticalAlign="top";}else if(alignSelf==="center"||justifyContent==="center"){const parentCell=cell.parentElement.closest("td");const parentTable=cell.closest("table");if(parentCell){parentTable.style.height=_getHeight(parentCell)+"px";}
cell.style.verticalAlign="middle";}else if(alignSelf==="end"||justifyContent==="end"||justifyContent==="flex-end"){cell.style.verticalAlign="bottom";}}
for(const row of element.querySelectorAll("tr")){const alignItems=row.style.alignItems;if(alignItems==="flex-start"){row.style.verticalAlign="top";}else if(alignItems==="center"){row.style.verticalAlign="middle";}else if(alignItems==="flex-end"||alignItems==="baseline"){row.style.verticalAlign="bottom";}else if(alignItems==="stretch"){const columns=[...row.querySelectorAll("td.o_converted_col")];if(columns.length>1){const commonAncestor=commonParentGet(columns[0],columns[1]);const biggestHeight=commonAncestor.clientHeight;for(const column of columns){column.style.height=biggestHeight+"px";}}}}
for(const table of element.querySelectorAll("table")){const propsToConvert=FONT_PROPERTIES_TO_INHERIT.filter((prop)=>table.style[prop]==="inherit"||!table.style[prop]);if(propsToConvert.length){for(const prop of propsToConvert){let ancestor=table;while(ancestor&&(!ancestor.style[prop]||ancestor.style[prop]==="inherit")){ancestor=ancestor.parentElement;}
if(ancestor){table.style.setProperty(prop,ancestor.style[prop]);}}}}}
__exports.getCSSRules=getCSSRules;function getCSSRules(doc){const cssRules=[];for(const sheet of doc.styleSheets){let rules;try{rules=sheet.rules||sheet.cssRules;}catch(e){console.log("Can't read the css rules of: "+sheet.href,e);continue;}
for(const rule of rules||[]){const subRules=[rule];const conditionText=rule.conditionText;const minWidthMatch=conditionText&&conditionText.match(/\(min-width *: *(\d+)/);const minWidth=minWidthMatch&&+(minWidthMatch[1]||"0");if(minWidth&&minWidth>=992){let mediaRules;try{mediaRules=rule.rules||rule.cssRules;subRules.push(...mediaRules);}catch(e){console.log(`Can't read the css rules of: ${sheet.href} (${conditionText})`,e);}}
for(const subRule of subRules){const selectorText=subRule.selectorText||"";for(const selector of selectorText.split(RE_COMMAS_OUTSIDE_PARENTHESES)){if(selector&&!SELECTORS_IGNORE.test(selector)){cssRules.push({selector:selector.trim(),rawRule:subRule});if(selector==="body"){cssRules.push({selector:".o_layout",rawRule:subRule,specificity:1,});}}}}}}
return cssRules;}
__exports.listGroupToTable=listGroupToTable;function listGroupToTable(element){for(const listGroup of element.querySelectorAll(".list-group")){let table;if(listGroup.querySelectorAll(".list-group-item").length){table=_createTable(listGroup.attributes);}else{table=listGroup.cloneNode();for(const attr of listGroup.attributes){table.setAttribute(attr.name,attr.value);}}
for(const child of[...listGroup.childNodes]){if(child.classList&&child.classList.contains("list-group-item")){const row=document.createElement("tr");const col=document.createElement("td");for(const attr of child.attributes){col.setAttribute(attr.name,attr.value);}
col.append(...child.childNodes);col.classList.remove("list-group-item");if(!col.className){col.removeAttribute("class");}
row.append(col);table.append(row);child.remove();}else if(child.nodeName==="LI"){table.append(...child.childNodes);}else{table.append(child);}}
table.classList.remove("list-group");if(!table.className){table.removeAttribute("class");}
if(listGroup.nodeName==="TD"){listGroup.append(table);listGroup.classList.remove("list-group");if(!listGroup.className){listGroup.removeAttribute("class");}}else{listGroup.before(table);listGroup.remove();}}}
__exports.normalizeColors=normalizeColors;function normalizeColors(element){for(const node of element.querySelectorAll('[style*="rgb"]')){const rgbaMatch=node.getAttribute("style").match(/rgba?\(([\d.]+\s*,?\s*){3,4}\)/g);for(const rgb of rgbaMatch||[]){node.setAttribute("style",node.getAttribute("style").replace(rgb,blendColors(rgb,node)));}}}
__exports.normalizeRem=normalizeRem;function normalizeRem(element,rootFontSize=16){for(const node of element.querySelectorAll('[style*="rem"]')){const remMatch=node.getAttribute("style").match(/[\d.]+\s*rem/g);for(const rem of remMatch||[]){const remValue=parseFloat(rem.replace(/[^\d.]/g,""));const pxValue=Math.round(remValue*rootFontSize*100)/100;node.setAttribute("style",node.getAttribute("style").replace(rem,pxValue+"px"));}}}
function responsiveToStaticForOutlook(element){for(const td of element.querySelectorAll("td.o_converted_col:not(.mso-hide)")){const tdStyle=td.getAttribute("style")||"";const msoAttributes=[...td.attributes].filter((attr)=>attr.name!=="style"&&attr.name!=="width");const msoWidth=td.style.getPropertyValue("max-width");const msoStyles=tdStyle.replace(/(^| |max-)width:[^;]*;\s*/g,"");const outlookTd=document.createElement("td");for(const attribute of msoAttributes){outlookTd.setAttribute(attribute.name,td.getAttribute(attribute.name));}
if(msoWidth){outlookTd.setAttribute("width",(""+msoWidth).replace("px","").trim());outlookTd.setAttribute("style",`${msoStyles}width: ${msoWidth};`);}else{outlookTd.setAttribute("style",msoStyles);}
if(td.closest(".s_masonry_block")){outlookTd.style.padding=0;}
if(td.children.length===1&&td.firstElementChild.nodeName==="IMG"){const tdComputedStyle=getComputedStyle(td);for(const side of["left","right"]){if(td.firstElementChild.style.width==="100%"){const prop=`padding-${side}`;const imagePadding=+td.firstElementChild.style[prop].replace("px","");if(imagePadding>0){const tdPadding=+tdComputedStyle[prop].replace("px","")||0;outlookTd.style[prop]=tdPadding+imagePadding+"px";}}}}
td.before(_createMso(outlookTd.outerHTML.replace("</td>","")));_hideForOutlook(td,"opening");}}
async function svgToPng(element){for(const svg of element.querySelectorAll('img[src*=".svg"]')){await new Promise((resolve)=>{svg.onload=()=>resolve();if(svg.complete){resolve();}});const image=document.createElement("img");const canvas=document.createElement("CANVAS");const width=_getWidth(svg);const height=_getHeight(svg);canvas.setAttribute("width",width);canvas.setAttribute("height",height);canvas.getContext("2d").drawImage(svg,0,0,width,height);for(const attribute of svg.attributes){image.setAttribute(attribute.name,attribute.value);}
image.setAttribute("src",canvas.toDataURL("png"));image.setAttribute("width",width);image.setAttribute("height",height);svg.before(image);svg.remove();}}
function _applyColspan(element,colspan,tableWidth){element.setAttribute("colspan",colspan);const widthPercentage=+element.getAttribute("colspan")/12;const width=Math.round(tableWidth*widthPercentage*100)/100;element.style.setProperty("max-width",width+"px");element.classList.add("o_converted_col");}
function _backgroundImageToVml(backgroundImage){const matches=backgroundImage.style.backgroundImage.match(/url\("?(.+?)"?\)/);const url=matches&&matches[1];if(url){const clone=backgroundImage.cloneNode(true);const div=document.createElement("div");div.replaceChildren(...clone.childNodes);[["fontSize",0],["height","100%"],["width","100%"],].forEach(([k,v])=>(div.style[k]=v));const vmlContent=document.createElement("div");vmlContent.append(div);const style=getComputedStyle(backgroundImage);for(const prop of FONT_PROPERTIES_TO_INHERIT){div.style[prop]=backgroundImage.style[prop]||style[prop];}
[...div.children].forEach((child)=>child.style.setProperty("font-size",child.style.fontSize||style.fontSize));for(const prop of["background","background-image","background-repeat","background-size",]){clone.style.removeProperty(prop);}
clone.style.padding=0;clone.className=clone.className.replace(/p[bt]\d+/g,"");clone.setAttribute("background",url);clone.setAttribute("valign","middle");const[width,height]=[_getWidth(backgroundImage),_getHeight(backgroundImage)];const vml=`<v:image xmlns:v="urn:schemas-microsoft-com:vml" fill="true" stroke="false" `+`style="border: 0; display: inline-block; width: ${width}px; height: ${height}px;" src="${url}"/>
        <v:rect xmlns:v="urn:schemas-microsoft-com:vml" fill="true" stroke="false" `+`style="border: 0; display: inline-block; position: absolute; width:${width}px; height:${height}px; v-text-anchor:middle;">
            <v:fill opacity="0%" color="#000000"/>
            <v:textbox inset="0,0,0,0">
                <table border="0" cellpadding="0" cellspacing="0">
                    <tr>
                        <td width="${width}" align="center" style="text-align: center;">${vmlContent.outerHTML}</td>
                    </tr>
                </table>
            </v:textbox>
        </v:rect>`;return`${clone.outerHTML.replace(
            /<\/[\w-]+>[\s\n]*$/,
            ""
        )}${vml}</${clone.nodeName.toLowerCase()}>`;}}
function _computeSpecificity(selector){let a=0;selector=selector.replace(/#[a-z0-9_-]+/gi,()=>{a++;return"";});let b=0;selector=selector.replace(/(\.[a-z0-9_-]+)|(\[.*?\])/gi,()=>{b++;return"";});let c=0;selector=selector.replace(/(^|\s+|:+)[a-z0-9_-]+/gi,(a)=>{if(!a.includes(":not(")){c++;}
return"";});return a*100+b*10+c;}
function _computeStyleAndSpecificityOnRules(cssRules){for(const cssRule of cssRules){if(!cssRule.style&&cssRule.rawRule.style){const style=_normalizeStyle(cssRule.rawRule.style);if(Object.keys(style).length){Object.assign(cssRule,{style,specificity:_computeSpecificity(cssRule.selector),});}}}}
function _createColumnGrid(){return new Array(12).fill().map(()=>document.createElement("td"));}
function _createMso(content=""){return document.createComment(`[if mso]>${content}<![endif]`);}
function _createTable(attributes=[]){const table=document.createElement("table");Object.entries(TABLE_ATTRIBUTES).forEach(([att,value])=>table.setAttribute(att,value));for(const attr of attributes){if(!(attr.name==="width"&&attr.value==="100%")){table.setAttribute(attr.name,attr.value);}}
table.style.setProperty("width","100%","important");if(table.classList.contains("o_layout")){const layoutStyles={...TABLE_STYLES};delete layoutStyles["font-size"];delete layoutStyles["line-height"];Object.entries(layoutStyles).forEach(([att,value])=>(table.style[att]=value));}else{for(const styleName in TABLE_STYLES){if(!("style"in attributes&&attributes.style.value.includes(styleName+":"))){table.style[styleName]=TABLE_STYLES[styleName];}}}
return table;}
function _getColumnSize(column){const colMatch=column.className.match(RE_COL_MATCH);const colOptions=colMatch[2]&&colMatch[2].substr(1).split("-");const colSize=(colOptions&&(colOptions.length===2?+colOptions[1]:+colOptions[0]))||0;return colSize;}
function _getColumnOffsetSize(column){const offsetMatch=column.className.match(RE_OFFSET_MATCH);const offsetOptions=offsetMatch&&offsetMatch[2]&&offsetMatch[2].substr(1).split("-");const offsetSize=(offsetOptions&&(offsetOptions.length===2?+offsetOptions[1]:+offsetOptions[0]))||0;return offsetSize;}
function _getMatchedCSSRules(node,cssRules){node.matches=node.matches||node.webkitMatchesSelector||node.mozMatchesSelector||node.msMatchesSelector||node.oMatchesSelector;const styles=cssRules.map((rule)=>rule.style).filter(Boolean);if(node.style.length){const inlineStyles={};for(const styleName of node.style){inlineStyles[styleName]=node.style[styleName];}
styles.push(inlineStyles);}
const processedStyle={};for(const style of styles){for(const[key,value]of Object.entries(style)){if(!processedStyle[key]||!processedStyle[key].includes("important")||value.includes("important")){processedStyle[key]=value;}}}
for(const[key,value]of Object.entries(processedStyle)){if(value&&value.endsWith("important")){processedStyle[key]=value.replace(/\s*!important\s*$/,"");}}
const computedStyle=getComputedStyle(node);for(const groupName in GROUPED_STYLES){const force=!groupName.includes("margin")&&!groupName.includes("padding");const hasSubStyleApplied=GROUPED_STYLES[groupName].some((styleName)=>styleName in processedStyle);if(!force&&hasSubStyleApplied){continue;}
for(const styleName of GROUPED_STYLES[groupName]){const styleValue=computedStyle.getPropertyValue(styleName);if(styleValue&&typeof styleValue==="string"&&styleValue.length){processedStyle[styleName]=styleValue;}}}
if(processedStyle.display==="block"&&!(node.classList&&node.classList.contains("oe-nested"))){delete processedStyle.display;}
if(!processedStyle["box-sizing"]){processedStyle["box-sizing"]="border-box";}
for(const info of[{name:"margin"},{name:"padding"},{name:"border",suffix:"-style",defaultValue:"none"},]){const positions=["top","right","bottom","left"];const positionalKeys=positions.map((position)=>`${info.name}-${position}${info.suffix || ""}`);const styles=positionalKeys.map((key)=>processedStyle[key]).filter((s)=>s);const hasVariableStyle=styles.some((style)=>style.includes("calc(")||style.includes("var("));const inherits=positionalKeys.some((key)=>["inherit","initial"].includes((processedStyle[key]||"").trim()));if(styles.length&&!hasVariableStyle&&!inherits){const propertyName=`${info.name}${info.suffix || ""}`;processedStyle[propertyName]=positionalKeys.every((key)=>processedStyle[positionalKeys[0]]===processedStyle[key])?(processedStyle[propertyName]=processedStyle[positionalKeys[0]]):positionalKeys.map((key)=>processedStyle[key]||info.defaultValue||0).join(" ");for(const prop of positionalKeys){delete processedStyle[prop];}}}
if(processedStyle["border-bottom-left-radius"]){processedStyle["border-radius"]=processedStyle["border-bottom-left-radius"];delete processedStyle["border-bottom-left-radius"];delete processedStyle["border-bottom-right-radius"];delete processedStyle["border-top-left-radius"];delete processedStyle["border-top-right-radius"];}
for(const styleName in processedStyle){if(styleName.includes("border")&&processedStyle[styleName]==="initial"){delete processedStyle[styleName];}}
if(processedStyle["text-decoration-line"]){processedStyle["text-decoration"]=processedStyle["text-decoration-line"];delete processedStyle["text-decoration-line"];delete processedStyle["text-decoration-color"];delete processedStyle["text-decoration-style"];delete processedStyle["text-decoration-thickness"];}
for(const styleName in processedStyle){if(styleName.includes("flex")||`${processedStyle[styleName]}`.includes("flex")){delete processedStyle[styleName];}}
return processedStyle;}
let lastComputedStyleElement;let lastComputedStyle;function _getStylePropertyValue(element,propertyName){const computedStyle=lastComputedStyleElement===element?lastComputedStyle:getComputedStyle(element);lastComputedStyleElement=element;lastComputedStyle=computedStyle;return computedStyle[propertyName]||element.style.getPropertyValue(propertyName);}
function _getWidth(element){return parseFloat(getComputedStyle(element).width.replace("px",""))||0;}
function _getHeight(element){return parseFloat(getComputedStyle(element).height.replace("px",""))||0;}
function _hideForOutlook(node,onlyHideTag=false){if(!onlyHideTag){node.setAttribute("style",`${node.getAttribute("style") || ""} mso-hide: all;`.trim());}
node[onlyHideTag==="closing"?"append":"before"](document.createComment("[if !mso]><!"));node[onlyHideTag==="opening"?"prepend":"after"](document.createComment("<![endif]"));}
function _normalizeStyle(style){const normalizedStyle={};for(const styleName of style){const value=style[styleName];if(value&&!styleName.includes("animation")&&!styleName.includes("-webkit")&&typeof value==="string"){const normalizedStyleName=styleName.replace(/-(.)/g,(a,b)=>b.toUpperCase());normalizedStyle[styleName]=style[normalizedStyleName];if(style.getPropertyPriority(styleName)==="important"){normalizedStyle[styleName]+=" !important";}}}
return normalizedStyle;}
function _wrap(element,wrapperTag,wrapperClass,wrapperStyle){const wrapper=document.createElement(wrapperTag);if(wrapperClass){wrapper.className=wrapperClass;}
if(wrapperStyle){wrapper.style.cssText=wrapperStyle;}
element.parentElement.insertBefore(wrapper,element);wrapper.append(element);return wrapper;}
return __exports;});;

/* /mail/static/src/views/web/fields/html_mail_field/html_mail_field.js */
odoo.define('@mail/views/web/fields/html_mail_field/html_mail_field',['@html_editor/fields/html_field','@web/core/registry','@mail/views/web/fields/html_mail_field/convert_inline','@html_editor/main/column_plugin'],function(require){'use strict';let __exports={};const{HtmlField,htmlField}=require("@html_editor/fields/html_field");const{registry}=require("@web/core/registry");const{getCSSRules,toInline}=require("@mail/views/web/fields/html_mail_field/convert_inline");const{ColumnPlugin}=require("@html_editor/main/column_plugin");const cssRulesByElement=new WeakMap();const HtmlMailField=__exports.HtmlMailField=class HtmlMailField extends HtmlField{static async getInlinedEditorContent(cssRulesByElement,editor,el){if(!cssRulesByElement.has(editor.editable)){cssRulesByElement.set(editor.editable,getCSSRules(editor.document));}
const cssRules=cssRulesByElement.get(editor.editable);editor.editable.after(el);el.classList.remove("odoo-editor-editable");await toInline(el,cssRules);el.remove();}
async getEditorContent(){const el=await super.getEditorContent();await HtmlMailField.getInlinedEditorContent(cssRulesByElement,this.editor,el);return el;}
getConfig(){const config=super.getConfig();config.dropImageAsAttachment=false;config.Plugins=config.Plugins.filter((plugin)=>plugin!==ColumnPlugin);return config;}}
const htmlMailField=__exports.htmlMailField={...htmlField,component:HtmlMailField,additionalClasses:["o_field_html"],extractProps({attrs,options},dynamicInfo){const props=htmlField.extractProps({attrs,options},dynamicInfo);props.embeddedComponents=false;return props;},};registry.category("fields").add("html_mail",htmlMailField);return __exports;});;

/* /mail/static/src/views/web/fields/kanban_activity/kanban_activity.js */
odoo.define('@mail/views/web/fields/kanban_activity/kanban_activity',['@mail/core/web/activity_button','@odoo/owl','@web/core/registry','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{ActivityButton}=require("@mail/core/web/activity_button");const{Component}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const KanbanActivity=__exports.KanbanActivity=class KanbanActivity extends Component{static components={ActivityButton};static fieldDependencies=[{name:"activity_exception_decoration",type:"selection",selection:[("warning","Alert"),("danger","Error")],},{name:"activity_exception_icon",type:"char"},{name:"activity_state",type:"selection"},{name:"activity_summary",type:"char"},{name:"activity_type_icon",type:"char"},{name:"activity_type_id",type:"many2one",relation:"mail.activity.type"},];static props=standardFieldProps;static template="mail.KanbanActivity";}
const kanbanActivity=__exports.kanbanActivity={component:KanbanActivity,fieldDependencies:KanbanActivity.fieldDependencies,};registry.category("fields").add("kanban_activity",kanbanActivity);return __exports;});;

/* /mail/static/src/views/web/fields/list_activity/list_activity.js */
odoo.define('@mail/views/web/fields/list_activity/list_activity',['@mail/core/web/activity_button','@odoo/owl','@web/core/l10n/translation','@web/core/registry','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{ActivityButton}=require("@mail/core/web/activity_button");const{Component}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const ListActivity=__exports.ListActivity=class ListActivity extends Component{static components={ActivityButton};static fieldDependencies=[{name:"activity_exception_decoration",type:"selection",selection:[]},{name:"activity_exception_icon",type:"char"},{name:"activity_state",type:"selection",selection:[]},{name:"activity_summary",type:"char"},{name:"activity_type_icon",type:"char"},{name:"activity_type_id",type:"many2one",relation:"mail.activity.type"},];static props=standardFieldProps;static template="mail.ListActivity";get summaryText(){if(this.props.record.data.activity_exception_decoration){return _t("Warning");}
if(this.props.record.data.activity_summary){return this.props.record.data.activity_summary;}
if(this.props.record.data.activity_type_id){return this.props.record.data.activity_type_id[1];}
return undefined;}}
const listActivity=__exports.listActivity={component:ListActivity,fieldDependencies:ListActivity.fieldDependencies,displayName:_t("List Activity"),supportedTypes:["one2many"],};registry.category("fields").add("list_activity",listActivity);return __exports;});;

/* /mail/static/src/views/web/fields/many2many_avatar_user_field/many2many_avatar_user_field.js */
odoo.define('@mail/views/web/fields/many2many_avatar_user_field/many2many_avatar_user_field',['@mail/views/web/fields/assign_user_command_hook','@web/core/registry','@web/core/tags_list/tags_list','@web/core/popover/popover_hook','@mail/discuss/web/avatar_card/avatar_card_popover','@web/views/fields/many2many_tags_avatar/many2many_tags_avatar_field'],function(require){'use strict';let __exports={};const{useAssignUserCommand}=require("@mail/views/web/fields/assign_user_command_hook");const{registry}=require("@web/core/registry");const{TagsList}=require("@web/core/tags_list/tags_list");const{usePopover}=require("@web/core/popover/popover_hook");const{AvatarCardPopover}=require("@mail/discuss/web/avatar_card/avatar_card_popover");const{Many2ManyTagsAvatarField,many2ManyTagsAvatarField,ListMany2ManyTagsAvatarField,listMany2ManyTagsAvatarField,KanbanMany2ManyTagsAvatarField,kanbanMany2ManyTagsAvatarField,KanbanMany2ManyTagsAvatarFieldTagsList,}=require("@web/views/fields/many2many_tags_avatar/many2many_tags_avatar_field");const Many2ManyAvatarUserTagsList=__exports.Many2ManyAvatarUserTagsList=class Many2ManyAvatarUserTagsList extends TagsList{static template="mail.Many2ManyAvatarUserTagsList";}
const WithUserChatter=(T)=>class UserChatterMixin extends T{setup(){super.setup(...arguments);if(this.props.withCommand){useAssignUserCommand();}
this.avatarCard=usePopover(AvatarCardPopover);}
displayAvatarCard(record){return this.relation==="res.users";}
getAvatarCardProps(record){return{id:record.resId,};}
getTagProps(record){return{...super.getTagProps(...arguments),onImageClicked:(ev)=>{if(!this.displayAvatarCard(record)){return;}
const target=ev.currentTarget;if(!this.avatarCard.isOpen||(this.lastOpenedId&&record.resId!==this.lastOpenedId)){this.avatarCard.open(target,this.getAvatarCardProps(record));this.lastOpenedId=record.resId;}},};}};const Many2ManyTagsAvatarUserField=__exports.Many2ManyTagsAvatarUserField=class Many2ManyTagsAvatarUserField extends WithUserChatter(Many2ManyTagsAvatarField){static components={...Many2ManyTagsAvatarField.components,TagsList:Many2ManyAvatarUserTagsList,};}
const many2ManyTagsAvatarUserField=__exports.many2ManyTagsAvatarUserField={...many2ManyTagsAvatarField,component:Many2ManyTagsAvatarUserField,additionalClasses:["o_field_many2many_tags_avatar"],};registry.category("fields").add("many2many_avatar_user",many2ManyTagsAvatarUserField);const KanbanMany2ManyAvatarUserTagsList=__exports.KanbanMany2ManyAvatarUserTagsList=class KanbanMany2ManyAvatarUserTagsList extends KanbanMany2ManyTagsAvatarFieldTagsList{static template="mail.KanbanMany2ManyAvatarUserTagsList";}
const KanbanMany2ManyTagsAvatarUserField=__exports.KanbanMany2ManyTagsAvatarUserField=class KanbanMany2ManyTagsAvatarUserField extends WithUserChatter(KanbanMany2ManyTagsAvatarField){static template="mail.KanbanMany2ManyTagsAvatarUserField";static components={...KanbanMany2ManyTagsAvatarField.components,TagsList:KanbanMany2ManyAvatarUserTagsList,};get displayText(){return!this.props.readonly;}}
const kanbanMany2ManyTagsAvatarUserField=__exports.kanbanMany2ManyTagsAvatarUserField={...kanbanMany2ManyTagsAvatarField,component:KanbanMany2ManyTagsAvatarUserField,additionalClasses:["o_field_many2many_tags_avatar","o_field_many2many_tags_avatar_kanban"],};registry.category("fields").add("kanban.many2many_avatar_user",kanbanMany2ManyTagsAvatarUserField);const ListMany2ManyTagsAvatarUserField=__exports.ListMany2ManyTagsAvatarUserField=class ListMany2ManyTagsAvatarUserField extends WithUserChatter(ListMany2ManyTagsAvatarField){static template="mail.ListMany2ManyTagsAvatarUserField";static components={...ListMany2ManyTagsAvatarField.components,TagsList:Many2ManyAvatarUserTagsList,};get displayText(){return this.props.record.data[this.props.name].records.length===1||!this.props.readonly;}}
const listMany2ManyTagsAvatarUserField=__exports.listMany2ManyTagsAvatarUserField={...listMany2ManyTagsAvatarField,component:ListMany2ManyTagsAvatarUserField,listViewWidth:[120],additionalClasses:["o_field_many2many_tags_avatar","o_field_many2many_tags_avatar_list"],};registry.category("fields").add("list.many2many_avatar_user",listMany2ManyTagsAvatarUserField);registry.category("fields").add("activity.many2many_avatar_user",kanbanMany2ManyTagsAvatarUserField);return __exports;});;

/* /mail/static/src/views/web/fields/many2many_tags_email/many2many_tags_email.js */
odoo.define('@mail/views/web/fields/many2many_tags_email/many2many_tags_email',['@odoo/owl','@web/core/l10n/translation','@web/core/registry','@web/core/tags_list/tags_list','@web/views/fields/many2many_tags/many2many_tags_field','@web/views/fields/relational_utils'],function(require){'use strict';let __exports={};const{onMounted}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{TagsList}=require("@web/core/tags_list/tags_list");const{Many2ManyTagsField,many2ManyTagsField,}=require("@web/views/fields/many2many_tags/many2many_tags_field");const{useOpenMany2XRecord}=require("@web/views/fields/relational_utils");const FieldMany2ManyTagsEmailTagsList=__exports.FieldMany2ManyTagsEmailTagsList=class FieldMany2ManyTagsEmailTagsList extends TagsList{static template="FieldMany2ManyTagsEmailTagsList";}
const FieldMany2ManyTagsEmail=__exports.FieldMany2ManyTagsEmail=class FieldMany2ManyTagsEmail extends Many2ManyTagsField{static components={...FieldMany2ManyTagsEmail.components,TagsList:FieldMany2ManyTagsEmailTagsList,};static props={...Many2ManyTagsField.props,context:{type:Object,optional:true},};setup(){super.setup();this.openedDialogs=0;this.recordsIdsToAdd=[];this.openMany2xRecord=useOpenMany2XRecord({resModel:this.relation,activeActions:{create:false,createEdit:false,write:true,},isToMany:true,onRecordSaved:async(record)=>{if(record.data.email){this.recordsIdsToAdd.push(record.resId);}},fieldString:this.props.string,});const update=this.update;this.update=async(object)=>{await update(object);await this.checkEmails();};onMounted(()=>{this.checkEmails();});}
async checkEmails(){const list=this.props.record.data[this.props.name];const invalidRecords=list.records.filter((record)=>!record.data.email);if(!invalidRecords.length){return;}
const dialogDefs=[];for(const record of invalidRecords){dialogDefs.push(this.openMany2xRecord({resId:record.resId,context:this.props.context,title:_t("Edit: %s",record.data.display_name),}));}
this.openedDialogs+=invalidRecords.length;await Promise.all(dialogDefs);this.openedDialogs-=invalidRecords.length;if(this.openedDialogs){return;}
const invalidRecordIds=invalidRecords.map((rec)=>rec.resId);await list.addAndRemove({remove:invalidRecordIds.filter((id)=>!this.recordsIdsToAdd.includes(id)),reload:true,});this.recordsIdsToAdd=[];}
get tags(){const tags=super.tags;const emailByResId=this.props.record.data[this.props.name].records.reduce((acc,record)=>{acc[record.resId]=record.data.email;return acc;},{});tags.forEach((tag)=>(tag.email=emailByResId[tag.resId]));return tags;}}
const fieldMany2ManyTagsEmail=__exports.fieldMany2ManyTagsEmail={...many2ManyTagsField,component:FieldMany2ManyTagsEmail,extractProps(fieldInfo,dynamicInfo){const props=many2ManyTagsField.extractProps(...arguments);props.context=dynamicInfo.context;return props;},relatedFields:(fieldInfo)=>{return[...many2ManyTagsField.relatedFields(fieldInfo),{name:"email",type:"char"}];},additionalClasses:["o_field_many2many_tags"],};registry.category("fields").add("many2many_tags_email",fieldMany2ManyTagsEmail);return __exports;});;

/* /mail/static/src/views/web/fields/many2one_avatar_user_field/many2one_avatar_user_field.js */
odoo.define('@mail/views/web/fields/many2one_avatar_user_field/many2one_avatar_user_field',['@mail/views/web/fields/assign_user_command_hook','@web/core/l10n/translation','@web/core/registry','@web/views/fields/many2one_avatar/many2one_avatar_field','@web/core/popover/popover_hook','@mail/discuss/web/avatar_card/avatar_card_popover'],function(require){'use strict';let __exports={};const{useAssignUserCommand}=require("@mail/views/web/fields/assign_user_command_hook");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{Many2OneAvatarField,many2OneAvatarField,KanbanMany2OneAvatarField,kanbanMany2OneAvatarField,}=require("@web/views/fields/many2one_avatar/many2one_avatar_field");const{usePopover}=require("@web/core/popover/popover_hook");const{AvatarCardPopover}=require("@mail/discuss/web/avatar_card/avatar_card_popover");const WithUserChatter=(T)=>class extends T{setup(){super.setup(...arguments);if(this.props.withCommand){useAssignUserCommand();}
this.avatarCard=usePopover(AvatarCardPopover);}
get displayAvatarCard(){return this.relation==="res.users";}
getAvatarCardProps(){return{id:this.props.record.data[this.props.name][0]??false,};}
onClickAvatar(ev){const id=this.props.record.data[this.props.name][0]??false;if(id!==false){if(!this.displayAvatarCard){return;}
const target=ev.currentTarget;if(!this.avatarCard.isOpen){this.avatarCard.open(target,this.getAvatarCardProps());}}}};const Many2OneAvatarUserField=__exports.Many2OneAvatarUserField=class Many2OneAvatarUserField extends WithUserChatter(Many2OneAvatarField){static template="mail.Many2OneAvatarUserField";static props={...Many2OneAvatarField.props,withCommand:{type:Boolean,optional:true},};}
const many2OneAvatarUserField=__exports.many2OneAvatarUserField={...many2OneAvatarField,component:Many2OneAvatarUserField,additionalClasses:["o_field_many2one_avatar"],listViewWidth:[110],extractProps(fieldInfo,dynamicInfo){const props=many2OneAvatarField.extractProps(...arguments);props.withCommand=fieldInfo.viewType==="form"||fieldInfo.viewType==="list";return props;},};registry.category("fields").add("many2one_avatar_user",many2OneAvatarUserField);const KanbanMany2OneAvatarUserField=__exports.KanbanMany2OneAvatarUserField=class KanbanMany2OneAvatarUserField extends WithUserChatter(KanbanMany2OneAvatarField){static template="mail.KanbanMany2OneAvatarUserField";static props={...KanbanMany2OneAvatarField.props,displayAvatarName:{type:Boolean,optional:true},};get popoverProps(){const props=super.popoverProps;delete props.displayAvatarName;return props;}}
const kanbanMany2OneAvatarUserField=__exports.kanbanMany2OneAvatarUserField={...kanbanMany2OneAvatarField,component:KanbanMany2OneAvatarUserField,additionalClasses:[...kanbanMany2OneAvatarField.additionalClasses,"o_field_many2one_avatar"],supportedOptions:[...(kanbanMany2OneAvatarField.supportedOptions||[]),{label:_t("Display avatar name"),name:"display_avatar_name",type:"boolean",},],extractProps({options}){const props=kanbanMany2OneAvatarField.extractProps(...arguments);props.displayAvatarName=options.display_avatar_name||false;return props;},};registry.category("fields").add("kanban.many2one_avatar_user",kanbanMany2OneAvatarUserField);registry.category("fields").add("activity.many2one_avatar_user",kanbanMany2OneAvatarUserField);return __exports;});;

/* /mail/static/src/views/web/fields/properties_field/property_value.js */
odoo.define('@mail/views/web/fields/properties_field/property_value',['@mail/core/web/open_chat_hook','@web/core/tags_list/tags_list','@web/core/utils/patch','@web/views/fields/properties/property_value'],function(require){'use strict';let __exports={};const{useOpenChat}=require("@mail/core/web/open_chat_hook");const{TagsList}=require("@web/core/tags_list/tags_list");const{patch}=require("@web/core/utils/patch");const{PropertyValue}=require("@web/views/fields/properties/property_value");patch(PropertyValue.prototype,{setup(){super.setup();if(this.env.services["mail.store"]){this.openChat=useOpenChat("res.users");}},_onAvatarClicked(){if(this.openChat&&this.showAvatar&&this.props.comodel==="res.users"){this.openChat(this.props.value[0]);}},});const Many2manyPropertiesTagsList=__exports.Many2manyPropertiesTagsList=class Many2manyPropertiesTagsList extends TagsList{static template="mail.Many2manyPropertiesTagsList";setup(){super.setup();if(this.env.services["mail.store"]){this.openChat=useOpenChat("res.users");}}
_onAvatarClicked(tagIndex){const tag=this.props.tags[tagIndex];if(this.openChat&&tag.comodel==="res.users"){this.openChat(tag.id);}}}
PropertyValue.components={...PropertyValue.components,TagsList:Many2manyPropertiesTagsList,};return __exports;});;

/* /mail/static/src/views/web/list/archive_disabled_list_controller.js */
odoo.define('@mail/views/web/list/archive_disabled_list_controller',['@web/views/list/list_controller'],function(require){'use strict';let __exports={};const{ListController}=require("@web/views/list/list_controller");const ArchiveDisabledListController=__exports.ArchiveDisabledListController=class ArchiveDisabledListController extends ListController{setup(){super.setup();this.archiveEnabled=false;}}
return __exports;});;

/* /mail/static/src/views/web/list/archive_disabled_list_view.js */
odoo.define('@mail/views/web/list/archive_disabled_list_view',['@web/core/registry','@web/views/list/list_view','@mail/views/web/list/archive_disabled_list_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{ArchiveDisabledListController}=require("@mail/views/web/list/archive_disabled_list_controller");const archiveDisabledListView=__exports.archiveDisabledListView={...listView,Controller:ArchiveDisabledListController,};registry.category("views").add("archive_disabled_activity_list",archiveDisabledListView);return __exports;});;

/* /mail/static/src/views/web/list_renderer.js */
odoo.define('@mail/views/web/list_renderer',['@web/core/utils/patch','@web/views/list/list_renderer'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{ListRenderer}=require("@web/views/list/list_renderer");patch(ListRenderer.prototype,{getPropertyFieldColumns(_,list){const columns=super.getPropertyFieldColumns(...arguments);for(const column of columns){const{relation,type}=list.fields[column.name];if(relation==="res.users"){column.widget=type==="many2one"?"many2one_avatar_user":"many2many_avatar_user";}}
return columns;},});return __exports;});;

/* /mail/static/src/views/web/model/sample_server_patch.js */
odoo.define('@mail/views/web/model/sample_server_patch',['@web/model/sample_server','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{SampleServer}=require("@web/model/sample_server");const{patch}=require("@web/core/utils/patch");patch(SampleServer.prototype,{_getRandomSelectionValue(modelName,field){if(field.name==="activity_exception_decoration"){return false;}
return super._getRandomSelectionValue(...arguments);},});return __exports;});;

/* /mail/static/src/webclient/web/webclient.js */
odoo.define('@mail/webclient/web/webclient',['@web/core/browser/browser','@web/core/utils/hooks','@web/core/utils/patch','@web/webclient/webclient','@odoo/owl','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{useService}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");const{WebClient}=require("@web/webclient/webclient");const{onWillDestroy}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const USER_DEVICES_MODEL="mail.push.device";patch(WebClient.prototype,{setup(){super.setup();this.orm=useService("orm");this.notification=useService("notification");if(this._canSendNativeNotification){this._subscribePush();}
if(browser.navigator.permissions){let notificationPerm;const onPermissionChange=()=>{if(this._canSendNativeNotification){this._subscribePush();}else{this._unsubscribePush();}};browser.navigator.permissions.query({name:"notifications"}).then((perm)=>{notificationPerm=perm;notificationPerm.addEventListener("change",onPermissionChange);});onWillDestroy(()=>{notificationPerm?.removeEventListener("change",onPermissionChange);});}},get _canSendNativeNotification(){return browser.Notification?.permission==="granted";},async _subscribePush(numberTry=1){const pushManager=await this.pushManager();if(!pushManager){return;}
let subscription=await pushManager.getSubscription();const previousEndpoint=browser.localStorage.getItem(`${USER_DEVICES_MODEL}_endpoint`);if(!subscription){try{subscription=await pushManager.subscribe({userVisibleOnly:true,applicationServerKey:await this._getApplicationServerKey(),});}catch(error){console.warn(error);this.notification.add(error.message,{title:_t("Failed to enable push notifications"),type:"danger",sticky:true,});if(await navigator.brave?.isBrave()){this.notification.add(_t("Brave: enable 'Google Services for Push Messaging' to enable push notifications"),{type:"warning",sticky:true,});}
return;}
browser.localStorage.setItem(`${USER_DEVICES_MODEL}_endpoint`,subscription.endpoint);}
const kwargs=subscription.toJSON();if(previousEndpoint&&subscription.endpoint!==previousEndpoint){kwargs.previous_endpoint=previousEndpoint;}
try{kwargs.vapid_public_key=this._arrayBufferToBase64(subscription.options.applicationServerKey);await this.orm.call(USER_DEVICES_MODEL,"register_devices",[],kwargs);}catch(e){const invalidVapidErrorClass="odoo.addons.mail.tools.jwt.InvalidVapidError";const warningMessage="Error sending subscription information to the server";if(e.data?.name===invalidVapidErrorClass){const MAX_TRIES=2;if(numberTry<MAX_TRIES){await subscription.unsubscribe();this._subscribePush(numberTry+1);}else{console.warn(warningMessage);}}else{console.warn(`${warningMessage}: ${e.data?.debug}`);}}},async _unsubscribePush(){const pushManager=await this.pushManager();if(!pushManager){return;}
const subscription=await pushManager.getSubscription();if(!subscription){return;}
await this.orm.call(USER_DEVICES_MODEL,"unregister_devices",[],{endpoint:subscription.endpoint,});await subscription.unsubscribe();browser.localStorage.removeItem(`${USER_DEVICES_MODEL}_endpoint`);},async pushManager(){const registration=await browser.navigator.serviceWorker?.getRegistration();return registration?.pushManager;},async _getApplicationServerKey(){const vapid_public_key_base64=await this.orm.call(USER_DEVICES_MODEL,"get_web_push_vapid_public_key");const padding="=".repeat((4-(vapid_public_key_base64.length%4))%4);const base64=(vapid_public_key_base64+padding).replace(/-/g,"+").replace(/_/g,"/");const rawData=atob(base64);const outputArray=new Uint8Array(rawData.length);for(let i=0;i<rawData.length;++i){outputArray[i]=rawData.charCodeAt(i);}
return outputArray;},_arrayBufferToBase64(buffer){const bytes=new Uint8Array(buffer);let binary="";for(let i=0;i<bytes.byteLength;i++){binary+=String.fromCharCode(bytes[i]);}
return window.btoa(binary).replaceAll("+","-").replaceAll("/","_").replaceAll("=","");},});return __exports;});;

/* /mail/static/src/discuss/core/common/action_panel.js */
odoo.define('@mail/discuss/core/common/action_panel',['@odoo/owl','@web/core/resizable_panel/resizable_panel','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{ResizablePanel}=require("@web/core/resizable_panel/resizable_panel");const{useService}=require("@web/core/utils/hooks");const ActionPanel=__exports.ActionPanel=class ActionPanel extends Component{static template="mail.ActionPanel";static components={ResizablePanel};static props=["icon?","title?","resizable?","slots?","initialWidth?","minWidth?"];static defaultProps={resizable:true};setup(){super.setup();this.store=useState(useService("mail.store"));}
get classNames(){return`o-mail-ActionPanel overflow-auto d-flex flex-column flex-shrink-0 position-relative py-2 pt-0 h-100 bg-inherit ${
            !this.env.inChatter ? " px-2" : " o-mail-ActionPanel-chatter"
        } ${this.env.inDiscussApp ? " o-mail-discussSidebarBgColor" : ""}`;}}
return __exports;});;

/* /mail/static/src/discuss/core/common/attachment_model_patch.js */
odoo.define('@mail/discuss/core/common/attachment_model_patch',['@mail/core/common/attachment_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Attachment}=require("@mail/core/common/attachment_model");const{patch}=require("@web/core/utils/patch");patch(Attachment.prototype,{get isDeletable(){if(this.message&&this.thread?.model==="discuss.channel"){return this.message.editable;}
return super.isDeletable;},get urlRoute(){if(!this.access_token&&this.thread?.model==="discuss.channel"){return this.isImage?`/discuss/channel/${this.thread.id}/image/${this.id}`:`/discuss/channel/${this.thread.id}/attachment/${this.id}`;}
return super.urlRoute;},});return __exports;});;

/* /mail/static/src/discuss/core/common/attachment_panel.js */
odoo.define('@mail/discuss/core/common/attachment_panel',['@mail/core/common/date_section','@mail/discuss/core/common/action_panel','@mail/core/common/attachment_list','@odoo/owl','@web/core/utils/hooks','@mail/utils/common/hooks'],function(require){'use strict';let __exports={};const{DateSection}=require("@mail/core/common/date_section");const{ActionPanel}=require("@mail/discuss/core/common/action_panel");const{AttachmentList}=require("@mail/core/common/attachment_list");const{Component,onWillStart,onWillUpdateProps}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{useSequential,useVisible}=require("@mail/utils/common/hooks");const AttachmentPanel=__exports.AttachmentPanel=class AttachmentPanel extends Component{static components={ActionPanel,AttachmentList,DateSection};static props=["thread"];static template="mail.AttachmentPanel";setup(){super.setup();this.sequential=useSequential();this.store=useService("mail.store");this.ormService=useService("orm");this.attachmentUploadService=useService("mail.attachment_upload");onWillStart(()=>{this.props.thread.fetchMoreAttachments();});onWillUpdateProps((nextProps)=>{if(nextProps.thread.notEq(this.props.thread)){nextProps.thread.fetchMoreAttachments();}});useVisible("load-older",(isVisible)=>{if(isVisible){this.props.thread.fetchMoreAttachments();}});}
get attachmentsByDate(){const attachmentsByDate={};for(const attachment of this.props.thread.attachments){const attachments=attachmentsByDate[attachment.monthYear]??[];attachments.push(attachment);attachmentsByDate[attachment.monthYear]=attachments;}
return attachmentsByDate;}
get hasToggleAllowPublicUpload(){return(this.props.thread.model!=="mail.box"&&this.props.thread.channel_type!=="chat"&&this.store.self.isInternalUser);}
toggleAllowPublicUpload(){this.sequential(()=>this.ormService.write("discuss.channel",[this.props.thread.id],{allow_public_upload:!this.props.thread.allow_public_upload,}));}}
return __exports;});;

/* /mail/static/src/discuss/core/common/attachment_upload_service_patch.js */
odoo.define('@mail/discuss/core/common/attachment_upload_service_patch',['@mail/core/common/attachment_upload_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{AttachmentUploadService}=require("@mail/core/common/attachment_upload_service");const{patch}=require("@web/core/utils/patch");patch(AttachmentUploadService.prototype,{setup(){super.setup(...arguments);this.env.services["bus_service"].subscribe("mail.record/insert",({Thread})=>{if(Thread&&"allow_public_upload"in Thread&&!Thread.allow_public_upload&&!this.store.self.isInternalUser){const attachments=[...this.store.Thread.insert(Thread).composer.attachments];for(const attachment of attachments){this.unlink(attachment);}}});},});return __exports;});;

/* /mail/static/src/discuss/core/common/channel_commands.js */
odoo.define('@mail/discuss/core/common/channel_commands',['@web/core/l10n/translation','@web/core/registry'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const commandRegistry=registry.category("discuss.channel_commands");commandRegistry.add("help",{help:_t("Show a helper message"),methodName:"execute_command_help",}).add("leave",{help:_t("Leave this channel"),methodName:"execute_command_leave",}).add("who",{channel_types:["channel","chat","group"],help:_t("List users in the current channel"),methodName:"execute_command_who",});return __exports;});;

/* /mail/static/src/discuss/core/common/channel_invitation.js */
odoo.define('@mail/discuss/core/common/channel_invitation',['@mail/core/common/im_status','@mail/discuss/core/common/action_panel','@odoo/owl','@web/core/l10n/translation','@web/core/utils/hooks','@mail/utils/common/hooks','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{ImStatus}=require("@mail/core/common/im_status");const{ActionPanel}=require("@mail/discuss/core/common/action_panel");const{Component,onMounted,onWillStart,useRef,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{useSequential}=require("@mail/utils/common/hooks");const{useDebounced}=require("@web/core/utils/timing");const ChannelInvitation=__exports.ChannelInvitation=class ChannelInvitation extends Component{static components={ImStatus,ActionPanel};static defaultProps={hasSizeConstraints:false};static props=["hasSizeConstraints?","thread","close","className?"];static template="discuss.ChannelInvitation";setup(){super.setup();this.discussCoreCommonService=useState(useService("discuss.core.common"));this.orm=useService("orm");this.store=useState(useService("mail.store"));this.rtc=useService("discuss.rtc");this.notification=useService("notification");this.suggestionService=useService("mail.suggestion");this.ui=useService("ui");this.inputRef=useRef("input");this.sequential=useSequential();this.searchStr="";this.state=useState({selectablePartners:[],selectedPartners:[],searchResultCount:0,});this.debouncedFetchPartnersToInvite=useDebounced(this.fetchPartnersToInvite.bind(this),250);onWillStart(()=>{if(this.store.self.type==="partner"){this.fetchPartnersToInvite();}});onMounted(()=>{if(this.store.self.type==="partner"){this.inputRef.el.focus();}});}
async fetchPartnersToInvite(){const results=await this.sequential(()=>this.orm.call("res.partner","search_for_channel_invite",[this.searchStr,this.props.thread.id,]));if(!results){return;}
const{Persona:selectablePartners=[]}=this.store.insert(results.data);this.state.selectablePartners=this.suggestionService.sortPartnerSuggestions(selectablePartners,this.searchStr,this.props.thread);this.state.searchResultCount=results["count"];}
onInput(){this.searchStr=this.inputRef.el.value;this.debouncedFetchPartnersToInvite();}
onClickSelectablePartner(partner){if(partner.in(this.state.selectedPartners)){const index=this.state.selectedPartners.indexOf(partner);if(index!==-1){this.state.selectedPartners.splice(index,1);}
return;}
this.state.selectedPartners.push(partner);}
onClickSelectedPartner(partner){const index=this.state.selectedPartners.indexOf(partner);this.state.selectedPartners.splice(index,1);}
onFocusInvitationLinkInput(ev){ev.target.select();}
async onClickCopy(ev){await navigator.clipboard.writeText(this.props.thread.invitationLink);this.notification.add(_t("Link copied!"),{type:"success"});}
async onClickInvite(){if(this.props.thread.channel_type==="chat"){const partnerIds=this.state.selectedPartners.map((partner)=>partner.id);if(this.props.thread.correspondent){partnerIds.unshift(this.props.thread.correspondent.persona.id);}
await this.discussCoreCommonService.startChat(partnerIds);}else{await this.orm.call("discuss.channel","add_members",[[this.props.thread.id]],{partner_ids:this.state.selectedPartners.map((partner)=>partner.id),invite_to_rtc_call:this.rtc.state.channel?.eq(this.props.thread),});}
this.props.close();}
get invitationButtonText(){if(this.props.thread.channel_type==="channel"){return _t("Invite to Channel");}else if(this.props.thread.channel_type==="group"){return _t("Invite to Group Chat");}else if(this.props.thread.channel_type==="chat"){if(this.props.thread.correspondent?.persona.eq(this.store.self)){if(this.state.selectedPartners.length===0){return _t("Invite");}
if(this.state.selectedPartners.length===1){const alreadyChat=Object.values(this.store.Thread.records).some((thread)=>thread.correspondent?.persona.eq(this.state.selectedPartners[0]));if(alreadyChat){return _t("Go to conversation");}
return _t("Start a Conversation");}}
return _t("Create Group Chat");}
return _t("Invite");}}
return __exports;});;

/* /mail/static/src/discuss/core/common/channel_member_list.js */
odoo.define('@mail/discuss/core/common/channel_member_list',['@mail/core/common/im_status','@mail/discuss/core/common/action_panel','@odoo/owl','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{ImStatus}=require("@mail/core/common/im_status");const{ActionPanel}=require("@mail/discuss/core/common/action_panel");const{Component,onWillUpdateProps,onWillStart,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const ChannelMemberList=__exports.ChannelMemberList=class ChannelMemberList extends Component{static components={ImStatus,ActionPanel};static props=["thread","openChannelInvitePanel","className?"];static template="discuss.ChannelMemberList";setup(){super.setup();this.store=useState(useService("mail.store"));onWillStart(()=>{if(this.props.thread.fetchMembersState==="not_fetched"){this.props.thread.fetchChannelMembers();}});onWillUpdateProps((nextProps)=>{if(nextProps.thread.fetchMembersState==="not_fetched"){nextProps.thread.fetchChannelMembers();}});}
get onlineSectionText(){return _t("Online - %(online_count)s",{online_count:this.props.thread.onlineMembers.length,});}
get offlineSectionText(){return _t("Offline - %(offline_count)s",{offline_count:this.props.thread.offlineMembers.length,});}
canOpenChatWith(member){if(this.store.inPublicPage){return false;}
if(member.persona.type==="guest"){return false;}
return true;}
onClickAvatar(ev,member){if(!this.canOpenChatWith(member)){return;}
this.store.openChat({partnerId:member.persona.id});}}
return __exports;});;

/* /mail/static/src/discuss/core/common/composer_patch.js */
odoo.define('@mail/discuss/core/common/composer_patch',['@mail/core/common/composer','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Composer}=require("@mail/core/common/composer");const{patch}=require("@web/core/utils/patch");patch(Composer.prototype,{get allowUpload(){const thread=this.thread??this.message.thread;return(super.allowUpload&&(thread.model!=="discuss.channel"||thread?.allow_public_upload||this.store.self.isInternalUser));},});return __exports;});;

/* /mail/static/src/discuss/core/common/discuss_core_common_service.js */
odoo.define('@mail/discuss/core/common/discuss_core_common_service',['@odoo/owl','@web/core/l10n/translation','@web/core/registry'],function(require){'use strict';let __exports={};const{reactive}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const DiscussCoreCommon=__exports.DiscussCoreCommon=class DiscussCoreCommon{constructor(env,services){this.busService=services.bus_service;this.env=env;this.notificationService=services.notification;this.orm=services.orm;this.presence=services.presence;this.store=services["mail.store"];}
setup(){this.busService.addEventListener("connect",()=>this.store.imStatusTrackedPersonas.forEach((p)=>{const model=p.type==="partner"?"res.partner":"mail.guest";this.busService.addChannel(`odoo-presence-${model}_${p.id}`);}),{once:true});this.busService.subscribe("discuss.channel/leave",(payload)=>{const{Thread}=this.store.insert(payload);const[thread]=Thread;if(thread.notifyOnLeave){this.notificationService.add(_t("You unsubscribed from %s.",thread.displayName),{type:"info",});}});this.busService.subscribe("discuss.channel/delete",(payload,metadata)=>{const thread=this.store.Thread.insert({id:payload.id,model:"discuss.channel",});this._handleNotificationChannelDelete(thread,metadata);});this.busService.subscribe("discuss.channel/new_message",(payload,metadata)=>{this.store.insert(payload.data,{html:true});this._handleNotificationNewMessage(payload,metadata);});this.busService.subscribe("discuss.channel/transient_message",(payload)=>{const{body,thread}=payload;const lastMessageId=this.store.getLastMessageId();const message=this.store.Message.insert({author:this.store.odoobot,body,id:lastMessageId+0.01,is_note:true,is_transient:true,thread,},{html:true});message.thread.messages.push(message);message.thread.transientMessages.push(message);});this.busService.subscribe("discuss.channel/unpin",(payload)=>{const thread=this.store.Thread.get({model:"discuss.channel",id:payload.id});if(thread){thread.is_pinned=false;this.notificationService.add(thread.parent_channel_id?_t(`You unpinned %(conversation_name)s`,{conversation_name:thread.displayName,}):_t(`You unpinned your conversation with %(user_name)s`,{user_name:thread.displayName,}),{type:"info"});}});this.busService.subscribe("discuss.channel.member/fetched",(payload)=>{const{channel_id,id,last_message_id,partner_id}=payload;this.store.ChannelMember.insert({id,fetched_message_id:{id:last_message_id},persona:{type:"partner",id:partner_id},thread:{id:channel_id,model:"discuss.channel"},});});this.env.bus.addEventListener("mail.message/delete",({detail:{message,notifId}})=>{if(message.thread){const{selfMember}=message.thread;if(message.id>selfMember?.seen_message_id.id&&notifId>selfMember.message_unread_counter_bus_id){selfMember.message_unread_counter--;}}});}
async createGroupChat({default_display_mode,partners_to}){const data=await this.orm.call("discuss.channel","create_group",[],{default_display_mode,partners_to,});const{Thread}=this.store.insert(data);const[channel]=Thread;channel.open();return channel;}
async startChat(partnerIds){const partners_to=[...new Set([this.store.self.id,...partnerIds])];if(partners_to.length===1){const chat=await this.store.joinChat(partners_to[0],true);this.store.ChatWindow?.get({thread:undefined})?.close();chat.open();}else if(partners_to.length===2){const correspondentId=partners_to.find((partnerId)=>partnerId!==this.store.self.id);const chat=await this.store.joinChat(correspondentId,true);chat.open();}else{await this.createGroupChat({partners_to});}}
_handleNotificationChannelDelete(thread,metadata){thread.closeChatWindow();thread.messages.splice(0,thread.messages.length);thread.delete();}
async _handleNotificationNewMessage(payload,{id:notifId}){const{data,id:channelId,silent,temporary_id}=payload;const channel=await this.store.Thread.getOrFetch({model:"discuss.channel",id:channelId,});if(!channel){return;}
const message=this.store.Message.get(data["mail.message"][0]);if(!message){return;}
if(message.notIn(channel.messages)){if(!channel.loadNewer){channel.addOrReplaceMessage(message,this.store.Message.get(temporary_id));}else if(channel.status==="loading"){channel.pendingNewMessages.push(message);}
if(message.isSelfAuthored&&channel.selfMember){channel.selfMember.seen_message_id=message;}else{if(!channel.isDisplayed&&channel.selfMember){channel.selfMember.syncUnread=true;channel.scrollUnread=true;}
if(notifId>channel.selfMember?.message_unread_counter_bus_id){channel.selfMember.message_unread_counter++;}}}
if(!channel.isCorrespondentOdooBot&&channel.channel_type!=="channel"&&this.store.self.type==="partner"&&channel.selfMember){channel.markAsFetched();}
if(!channel.loadNewer&&!message.isSelfAuthored&&channel.composer.isFocused&&this.store.self.type==="partner"&&channel.newestPersistentMessage?.eq(channel.newestMessage)){channel.markAsRead();}
this.env.bus.trigger("discuss.channel/new_message",{channel,message,silent});const authorMember=channel.channelMembers.find(({persona})=>persona?.eq(message.author));if(authorMember){authorMember.seen_message_id=message;}}}
const discussCoreCommon=__exports.discussCoreCommon={dependencies:["bus_service","mail.out_of_focus","mail.store","notification","orm","presence",],start(env,services){const discussCoreCommon=reactive(new DiscussCoreCommon(env,services));discussCoreCommon.setup(env,services);return discussCoreCommon;},};registry.category("services").add("discuss.core.common",discussCoreCommon);return __exports;});;

/* /mail/static/src/discuss/core/common/discuss_notification_settings.js */
odoo.define('@mail/discuss/core/common/discuss_notification_settings',['@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const DiscussNotificationSettings=__exports.DiscussNotificationSettings=class DiscussNotificationSettings extends Component{static props={};static template="mail.DiscussNotificationSettings";setup(){this.store=useState(useService("mail.store"));this.state=useState({selectedDuration:false,});}
onChangeDisplayMuteDetails(){if(!this.store.settings.mute_until_dt){const FOREVER=this.store.settings.MUTES.find((m)=>m.label==="forever").value;this.store.settings.setMuteDuration(FOREVER);this.state.selectedDuration=FOREVER;}else{this.store.settings.setMuteDuration(false);}}
onChangeMuteDuration(ev){if(ev.target.value==="default"){return;}
this.store.settings.setMuteDuration(parseInt(ev.target.value));this.state.selectedDuration=parseInt(ev.target.value);}}
return __exports;});;

/* /mail/static/src/discuss/core/common/discuss_notification_settings_client_action.js */
odoo.define('@mail/discuss/core/common/discuss_notification_settings_client_action',['@odoo/owl','@web/core/registry','@mail/discuss/core/common/discuss_notification_settings'],function(require){'use strict';let __exports={};const{Component,xml}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{DiscussNotificationSettings}=require("@mail/discuss/core/common/discuss_notification_settings");const DiscussNotificationSettingsClientAction=__exports.DiscussNotificationSettingsClientAction=class DiscussNotificationSettingsClientAction extends Component{static components={DiscussNotificationSettings};static props=["*"];static template=xml`
        <div class="o-mail-DiscussNotificationSettingsClientAction mx-3 my-2">
            <DiscussNotificationSettings/>
        </div>
    `;}
registry.category("actions").add("mail.discuss_notification_settings_action",DiscussNotificationSettingsClientAction);return __exports;});;

/* /mail/static/src/discuss/core/common/message_actions.js */
odoo.define('@mail/discuss/core/common/message_actions',['@mail/core/common/message_actions','@mail/utils/common/html','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{messageActionsRegistry}=require("@mail/core/common/message_actions");const{createDocumentFragmentFromContent}=require("@mail/utils/common/html");const{patch}=require("@web/core/utils/patch");const editAction=messageActionsRegistry.get("edit");patch(editAction,{onClick(component){const doc=createDocumentFragmentFromContent(component.message.body);const mentionedChannelElements=doc.querySelectorAll(".o_channel_redirect");component.message.mentionedChannelPromises=Array.from(mentionedChannelElements).filter((el)=>el.dataset.oeModel==="discuss.channel").map(async(el)=>{return component.store.Thread.getOrFetch({id:el.dataset.oeId,model:el.dataset.oeModel,});});return super.onClick(component);},});return __exports;});;

/* /mail/static/src/discuss/core/common/message_model_patch.js */
odoo.define('@mail/discuss/core/common/message_model_patch',['@mail/core/common/message_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message_model");const{patch}=require("@web/core/utils/patch");patch(Message.prototype,{mentionedChannelPromises:[],async edit(body,attachments=[],{mentionedChannels=[],mentionedPartners=[]}={}){const validChannels=(await Promise.all(this.mentionedChannelPromises)).filter((channel)=>channel!==undefined);const allChannels=this.store.Thread.insert([...validChannels,...mentionedChannels]);super.edit(body,attachments,{mentionedChannels:allChannels,mentionedPartners,});},});return __exports;});;

/* /mail/static/src/discuss/core/common/notification_settings.js */
odoo.define('@mail/discuss/core/common/notification_settings',['@odoo/owl','@mail/discuss/core/common/action_panel','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/utils/hooks','@mail/discuss/core/common/discuss_notification_settings_client_action','@web/core/dialog/dialog'],function(require){'use strict';let __exports={};const{Component,useState,xml}=require("@odoo/owl");const{ActionPanel}=require("@mail/discuss/core/common/action_panel");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{useService}=require("@web/core/utils/hooks");const{DiscussNotificationSettingsClientAction}=require("@mail/discuss/core/common/discuss_notification_settings_client_action");const{Dialog}=require("@web/core/dialog/dialog");class NotificationDialog extends Component{static props=["close?"];static components={Dialog,DiscussNotificationSettingsClientAction};static template=xml`
        <Dialog size="'md'" footer="false">
            <DiscussNotificationSettingsClientAction/>
        </Dialog>
    `;}
const NotificationSettings=__exports.NotificationSettings=class NotificationSettings extends Component{static components={ActionPanel,Dropdown,DropdownItem};static props=["hasSizeConstraints?","thread","close?","className?"];static template="discuss.NotificationSettings";setup(){this.store=useState(useService("mail.store"));this.dialog=useService("dialog");}
setMute(minutes){this.store.settings.setMuteDuration(minutes,this.props.thread);this.props.close?.();}
onClickAllConversationsMuted(){this.dialog.add(NotificationDialog);}}
return __exports;});;

/* /mail/static/src/discuss/core/common/partner_compare.js */
odoo.define('@mail/discuss/core/common/partner_compare',['@mail/core/common/partner_compare'],function(require){'use strict';let __exports={};const{partnerCompareRegistry}=require("@mail/core/common/partner_compare");partnerCompareRegistry.add("discuss.recent-chats",(p1,p2,{env,context})=>{const recentChatPartnerIds=context.recentChatPartnerIds||env.services["mail.store"].getRecentChatPartnerIds();const recentChatIndex_p1=recentChatPartnerIds.findIndex((partnerId)=>partnerId===p1.id);const recentChatIndex_p2=recentChatPartnerIds.findIndex((partnerId)=>partnerId===p2.id);if(recentChatIndex_p1!==-1&&recentChatIndex_p2===-1){return-1;}else if(recentChatIndex_p1===-1&&recentChatIndex_p2!==-1){return 1;}else if(recentChatIndex_p1<recentChatIndex_p2){return-1;}else if(recentChatIndex_p1>recentChatIndex_p2){return 1;}},{sequence:25});partnerCompareRegistry.add("discuss.members",(p1,p2,{thread,memberPartnerIds})=>{if(thread?.model==="discuss.channel"){const isMember1=memberPartnerIds.has(p1.id);const isMember2=memberPartnerIds.has(p2.id);if(isMember1&&!isMember2){return-1;}
if(!isMember1&&isMember2){return 1;}}},{sequence:40});return __exports;});;

/* /mail/static/src/discuss/core/common/store_service_patch.js */
odoo.define('@mail/discuss/core/common/store_service_patch',['@mail/core/common/store_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Store}=require("@mail/core/common/store_service");const{patch}=require("@web/core/utils/patch");const storeServicePatch={get onlineMemberStatuses(){return["away","bot","online"];},sortMembers(m1,m2){return m1.persona.name?.localeCompare(m2.persona.name)||m1.id-m2.id;},};patch(Store.prototype,storeServicePatch);return __exports;});;

/* /mail/static/src/discuss/core/common/suggestion_service_patch.js */
odoo.define('@mail/discuss/core/common/suggestion_service_patch',['@mail/core/common/suggestion_service','@mail/utils/common/format','@web/core/registry','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{SuggestionService}=require("@mail/core/common/suggestion_service");const{cleanTerm}=require("@mail/utils/common/format");const{registry}=require("@web/core/registry");const{patch}=require("@web/core/utils/patch");const commandRegistry=registry.category("discuss.channel_commands");patch(SuggestionService.prototype,{getSupportedDelimiters(thread){const res=super.getSupportedDelimiters(thread);return thread?.model==="discuss.channel"?[...res,["/",0]]:res;},searchSuggestions({delimiter,term},{thread,sort=false}={}){if(delimiter==="/"){return this.searchChannelCommand(cleanTerm(term),thread,sort);}
return super.searchSuggestions(...arguments);},searchChannelCommand(cleanedSearchTerm,thread,sort){if(!thread.model==="discuss.channel"){return;}
const commands=commandRegistry.getEntries().filter(([name,command])=>{if(!cleanTerm(name).includes(cleanedSearchTerm)){return false;}
if(command.channel_types){return command.channel_types.includes(thread.channel_type);}
return true;}).map(([name,command])=>{return{channel_types:command.channel_types,help:command.help,id:command.id,name,};});const sortFunc=(c1,c2)=>{if(c1.channel_types&&!c2.channel_types){return-1;}
if(!c1.channel_types&&c2.channel_types){return 1;}
const cleanedName1=cleanTerm(c1.name);const cleanedName2=cleanTerm(c2.name);if(cleanedName1.startsWith(cleanedSearchTerm)&&!cleanedName2.startsWith(cleanedSearchTerm)){return-1;}
if(!cleanedName1.startsWith(cleanedSearchTerm)&&cleanedName2.startsWith(cleanedSearchTerm)){return 1;}
if(cleanedName1<cleanedName2){return-1;}
if(cleanedName1>cleanedName2){return 1;}
return c1.id-c2.id;};return{type:"ChannelCommand",suggestions:sort?commands.sort(sortFunc):commands,};},});return __exports;});;

/* /mail/static/src/discuss/core/common/thread_actions.js */
odoo.define('@mail/discuss/core/common/thread_actions',['@mail/core/common/thread_actions','@mail/discuss/core/common/attachment_panel','@mail/discuss/core/common/channel_invitation','@mail/discuss/core/common/channel_member_list','@mail/discuss/core/common/notification_settings','@odoo/owl','@web/core/l10n/translation','@web/core/popover/popover_hook'],function(require){'use strict';let __exports={};const{threadActionsRegistry}=require("@mail/core/common/thread_actions");const{AttachmentPanel}=require("@mail/discuss/core/common/attachment_panel");const{ChannelInvitation}=require("@mail/discuss/core/common/channel_invitation");const{ChannelMemberList}=require("@mail/discuss/core/common/channel_member_list");const{NotificationSettings}=require("@mail/discuss/core/common/notification_settings");const{useComponent}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{usePopover}=require("@web/core/popover/popover_hook");threadActionsRegistry.add("notification-settings",{condition(component){return(component.thread?.model==="discuss.channel"&&component.store.self.type!=="guest"&&(!component.props.chatWindow||component.props.chatWindow.isOpen));},setup(action){const component=useComponent();if(!component.props.chatWindow){action.popover=usePopover(NotificationSettings,{onClose:()=>action.close(),position:"bottom-end",fixedPosition:true,popoverClass:action.panelOuterClass,});}},open(component,action){action.popover?.open(component.root.el.querySelector(`[name="${action.id}"]`),{hasSizeConstraints:true,thread:component.thread,});},close(component,action){action.popover?.close();},component:NotificationSettings,icon(component){return component.thread.isMuted?"fa fa-fw text-danger fa-bell-slash":"fa fa-fw fa-bell";},iconLarge(component){return component.thread.isMuted?"fa fa-fw fa-lg text-danger fa-bell-slash":"fa fa-fw fa-lg fa-bell";},name:_t("Notification Settings"),panelOuterClass:"bg-100 border border-secondary",sequence:10,sequenceGroup:30,toggle:true,}).add("attachments",{condition:(component)=>component.thread?.hasAttachmentPanel&&(!component.props.chatWindow||component.props.chatWindow.isOpen),component:AttachmentPanel,icon:"fa fa-fw fa-paperclip",iconLarge:"fa fa-fw fa-lg fa-paperclip",name:_t("Attachments"),sequence:10,sequenceGroup:10,toggle:true,}).add("invite-people",{close(component,action){action.popover?.close();},component:ChannelInvitation,componentProps(action){return{close:()=>action.close()};},condition(component){return(component.thread?.model==="discuss.channel"&&(!component.props.chatWindow||component.props.chatWindow.isOpen));},panelOuterClass(component){return`o-discuss-ChannelInvitation ${
                component.props.chatWindow ? "bg-inherit" : ""
            } bg-100 border border-secondary`;},icon:"fa fa-fw fa-user-plus",iconLarge:"fa fa-fw fa-lg fa-user-plus",name:_t("Invite People"),open(component,action){action.popover?.open(component.root.el.querySelector(`[name="${action.id}"]`),{hasSizeConstraints:true,thread:component.thread,});},sequence:10,sequenceGroup:20,setup(action){const component=useComponent();if(!component.props.chatWindow){action.popover=usePopover(ChannelInvitation,{onClose:()=>action.close(),popoverClass:action.panelOuterClass,});}},toggle:true,}).add("member-list",{component:ChannelMemberList,condition(component){return(component.thread?.hasMemberList&&(!component.props.chatWindow||component.props.chatWindow.isOpen));},componentProps(action,component){return{openChannelInvitePanel({keepPrevious}={}){component.threadActions.actions.find(({id})=>id==="invite-people")?.open({keepPrevious});},};},panelOuterClass:"o-discuss-ChannelMemberList bg-inherit",icon:"fa fa-fw fa-users",iconLarge:"fa fa-fw fa-lg fa-users",name:_t("Members"),close(component){if(component.env.inDiscussApp){component.store.discuss.isMemberPanelOpenByDefault=false;}},open(component){if(component.env.inDiscussApp){component.store.discuss.isMemberPanelOpenByDefault=true;}},sequence:30,sequenceGroup:10,toggle:true,});return __exports;});;

/* /mail/static/src/discuss/core/common/thread_model_patch.js */
odoo.define('@mail/discuss/core/common/thread_model_patch',['@mail/core/common/record','@mail/core/common/thread_model','@web/core/utils/patch','@web/core/utils/urls','@web/core/network/rpc','@web/core/utils/concurrency','@web/core/registry'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{Thread}=require("@mail/core/common/thread_model");const{patch}=require("@web/core/utils/patch");const{imageUrl}=require("@web/core/utils/urls");const{rpc}=require("@web/core/network/rpc");const{Mutex}=require("@web/core/utils/concurrency");const{registry}=require("@web/core/registry");const commandRegistry=registry.category("discuss.channel_commands");const threadPatch={setup(){super.setup();this.fetchChannelMutex=new Mutex();this.fetchChannelInfoDeferred=undefined;this.fetchChannelInfoState="not_fetched";this.onlineMembers=Record.many("ChannelMember",{compute(){return this.channelMembers.filter((member)=>this.store.onlineMemberStatuses.includes(member.persona.im_status)).sort((m1,m2)=>this.store.sortMembers(m1,m2));},});this.offlineMembers=Record.many("ChannelMember",{compute(){return this._computeOfflineMembers().sort((m1,m2)=>this.store.sortMembers(m1,m2));},});},_computeOfflineMembers(){return this.channelMembers.filter((member)=>!this.store.onlineMemberStatuses.includes(member.persona?.im_status));},get avatarUrl(){if(this.channel_type==="channel"||this.channel_type==="group"){return imageUrl("discuss.channel",this.id,"avatar_128",{unique:this.avatarCacheKey,});}
if(this.channel_type==="chat"&&this.correspondent){return this.correspondent.persona.avatarUrl;}
return super.avatarUrl;},get hasMemberList(){return["channel","group"].includes(this.channel_type);},async fetchChannelInfo(){return this.fetchChannelMutex.exec(async()=>{if(!(this.localId in this.store.Thread.records)){return;}
const data=await rpc("/discuss/channel/info",{channel_id:this.id});if(data){this.store.insert(data,{html:true});}else{this.delete();}
return data?this:undefined;});},async fetchMoreAttachments(limit=30){if(this.isLoadingAttachments||this.areAttachmentsLoaded){return;}
this.isLoadingAttachments=true;try{const data=await rpc("/discuss/channel/attachments",{before:Math.min(...this.attachments.map(({id})=>id)),channel_id:this.id,limit,});const{Attachment:attachments=[]}=this.store.insert(data);if(attachments.length<limit){this.areAttachmentsLoaded=true;}}finally{this.isLoadingAttachments=false;}},get notifyOnLeave(){return Boolean(this.displayName);},async post(body){if(this.model==="discuss.channel"&&body.startsWith("/")){const[firstWord]=body.substring(1).split(/\s/);const command=commandRegistry.get(firstWord,false);if(command&&(!command.channel_types||command.channel_types.includes(this.channel_type))){await this.executeCommand(command,body);return;}}
return super.post(...arguments);},};patch(Thread.prototype,threadPatch);return __exports;});;

/* /mail/static/src/discuss/core/public_web/bus_connection_alert.js */
odoo.define('@mail/discuss/core/public_web/bus_connection_alert',['@odoo/owl','@web/core/registry','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const BusConnectionAlert=__exports.BusConnectionAlert=class BusConnectionAlert extends Component{static template="mail.BusConnectionAlert";static props={};setup(){this.busMonitoring=useState(useService("bus.monitoring_service"));this.store=useState(useService("mail.store"));}}
const connectionAlertService=__exports.connectionAlertService={dependencies:["bus.monitoring_service","mail.store"],start(){registry.category("main_components").add("bus.connection_alert",{Component:BusConnectionAlert});},};registry.category("services").add("bus.connection_alert",connectionAlertService);return __exports;});;

/* /mail/static/src/discuss/core/public_web/discuss_client_action_patch.js */
odoo.define('@mail/discuss/core/public_web/discuss_client_action_patch',['@mail/core/public_web/discuss_client_action','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{DiscussClientAction}=require("@mail/core/public_web/discuss_client_action");const{patch}=require("@web/core/utils/patch");patch(DiscussClientAction.prototype,{async restoreDiscussThread(){await this.store.channels.fetch();return super.restoreDiscussThread(...arguments);},parseActiveId(rawActiveId){if(typeof rawActiveId==="number"){return["discuss.channel",rawActiveId];}
const[model,id]=super.parseActiveId(rawActiveId);if(model==="mail.channel"){return["discuss.channel",id];}
return[model,id];},});return __exports;});;

/* /mail/static/src/discuss/core/public_web/discuss_core_public_web_service.js */
odoo.define('@mail/discuss/core/public_web/discuss_core_public_web_service',['@odoo/owl','@web/core/browser/browser','@web/core/l10n/translation','@web/core/registry'],function(require){'use strict';let __exports={};const{reactive}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const DiscussCorePublicWeb=__exports.DiscussCorePublicWeb=class DiscussCorePublicWeb{constructor(env,services){this.env=env;this.store=services["mail.store"];this.busService=services.bus_service;this.notificationService=services.notification;try{this.sidebarCategoriesBroadcast=new browser.BroadcastChannel("discuss_core_public_web.sidebar_categories");this.sidebarCategoriesBroadcast.addEventListener("message",({data:{id,open}})=>{const category=this.store.DiscussAppCategory.get(id);if(category){category.open=open;}});}catch{}
this.busService.subscribe("discuss.channel/joined",async(payload)=>{const{channel,invited_by_user_id:invitedByUserId}=payload;const thread=this.store.Thread.insert(channel);await thread.fetchChannelInfo();if(invitedByUserId&&invitedByUserId!==this.store.self.userId){this.notificationService.add(_t("You have been invited to #%s",thread.displayName),{type:"info"});}});browser.navigator.serviceWorker?.addEventListener("message",async({data:{action,data}})=>{if(action==="OPEN_CHANNEL"){const channel=await this.store.Thread.getOrFetch({model:"discuss.channel",id:data.id,});channel?.open();}});}
broadcastCategoryState(category){this.sidebarCategoriesBroadcast?.postMessage({id:category.id,open:category.open});}}
const discussCorePublicWeb=__exports.discussCorePublicWeb={dependencies:["bus_service","mail.store","notification"],start(env,services){return reactive(new DiscussCorePublicWeb(env,services));},};registry.category("services").add("discuss.core.public.web",discussCorePublicWeb);return __exports;});;

/* /mail/static/src/discuss/core/public_web/discuss_sidebar_categories.js */
odoo.define('@mail/discuss/core/public_web/discuss_sidebar_categories',['@mail/core/common/country_flag','@mail/core/common/im_status','@mail/core/common/thread_icon','@mail/core/public_web/discuss_sidebar','@mail/utils/common/format','@mail/utils/common/hooks','@odoo/owl','@web/core/confirmation_dialog/confirmation_dialog','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_hooks','@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/core/utils/misc'],function(require){'use strict';let __exports={};const{CountryFlag}=require("@mail/core/common/country_flag");const{ImStatus}=require("@mail/core/common/im_status");const{ThreadIcon}=require("@mail/core/common/thread_icon");const{discussSidebarItemsRegistry}=require("@mail/core/public_web/discuss_sidebar");const{cleanTerm}=require("@mail/utils/common/format");const{useHover}=require("@mail/utils/common/hooks");const{Component,useState,useSubEnv}=require("@odoo/owl");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{Dropdown}=require("@web/core/dropdown/dropdown");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useAutofocus,useService}=require("@web/core/utils/hooks");const{markEventHandled}=require("@web/core/utils/misc");const discussSidebarChannelIndicatorsRegistry=__exports.discussSidebarChannelIndicatorsRegistry=registry.category("mail.discuss_sidebar_channel_indicators");const DiscussSidebarSubchannel=__exports.DiscussSidebarSubchannel=class DiscussSidebarSubchannel extends Component{static template="mail.DiscussSidebarSubchannel";static props=["thread","isFirst?"];static components={Dropdown};setup(){super.setup();this.store=useState(useService("mail.store"));this.hover=useHover(["root","floating*"],{onHover:()=>(this.floating.isOpen=true),onAway:()=>(this.floating.isOpen=false),});this.floating=useDropdownState();}
get thread(){return this.props.thread;}
get commands(){const commands=[];if(this.thread.canUnpin){commands.push({onSelect:()=>this.thread.unpin(),label:_t("Unpin Thread"),icon:"oi oi-close",sequence:20,});}
return commands;}
get sortedCommands(){const commands=[...this.commands];commands.sort((c1,c2)=>c1.sequence-c2.sequence);return commands;}
openThread(ev,thread){markEventHandled(ev,"sidebar.openThread");thread.setAsDiscussThread();}}
const DiscussSidebarChannel=__exports.DiscussSidebarChannel=class DiscussSidebarChannel extends Component{static template="mail.DiscussSidebarChannel";static props=["thread"];static components={CountryFlag,DiscussSidebarSubchannel,Dropdown,ImStatus,ThreadIcon};setup(){super.setup();this.store=useState(useService("mail.store"));this.dialogService=useService("dialog");this.hover=useHover(["root","floating*"],{onHover:()=>(this.floating.isOpen=true),onAway:()=>(this.floating.isOpen=false),});this.floating=useDropdownState();}
get attClass(){return{"bg-inherit":this.thread.notEq(this.store.discuss.thread),"o-active":this.thread.eq(this.store.discuss.thread),"o-unread":this.thread.selfMember?.message_unread_counter>0&&!this.thread.isMuted,"border-bottom-0 rounded-bottom-0":this.bordered,"opacity-50":this.thread.isMuted,"position-relative justify-content-center o-compact mt-0 p-1":this.store.discuss.isSidebarCompact,"px-0":!this.store.discuss.isSidebarCompact,};}
get attClassContainer(){return{"border border-dark rounded-2 o-bordered":this.bordered,"o-compact":this.store.discuss.isSidebarCompact,};}
get bordered(){return(this.store.discuss.isSidebarCompact&&Boolean(this.env.filteredThreads?.(this.thread.sub_channel_ids)?.length));}
get indicators(){return discussSidebarChannelIndicatorsRegistry.getAll();}
get commands(){const commands=[];if(this.thread.canLeave){commands.push({onSelect:()=>this.leaveChannel(),label:_t("Leave Channel"),icon:"oi oi-close",sequence:20,});}
if(this.thread.canUnpin){commands.push({onSelect:()=>this.thread.unpin(),label:_t("Unpin Conversation"),icon:"oi oi-close",sequence:20,});}
return commands;}
get sortedCommands(){const commands=[...this.commands];commands.sort((c1,c2)=>c1.sequence-c2.sequence);return commands;}
get thread(){return this.props.thread;}
get subChannels(){return this.env.filteredThreads?.(this.thread.sub_channel_ids)??[];}
showThread(sub){if(sub.eq(this.store.discuss.thread)){return true;}
if(!this.thread.discussAppCategory.open){return false;}
if(!this.thread.isMuted||sub.selfMember?.message_unread_counter>0){return true;}
return this.isSelfOrThreadActive&&!(this.thread.isMuted&&sub.isMuted);}
get isSelfOrThreadActive(){return(this.thread.eq(this.store.discuss.thread)||this.store.discuss.thread?.in(this.subChannels));}
askConfirmation(body){return new Promise((resolve)=>{this.dialogService.add(ConfirmationDialog,{body:body,confirmLabel:_t("Leave Conversation"),confirm:resolve,cancel:()=>{},});});}
async leaveChannel(){const thread=this.thread;if(thread.channel_type!=="group"&&thread.create_uid===thread.store.self.userId){await this.askConfirmation(_t("You are the administrator of this channel. Are you sure you want to leave?"));}
if(thread.channel_type==="group"){await this.askConfirmation(_t("You are about to leave this group conversation and will no longer have access to it unless you are invited again. Are you sure you want to continue?"));}
thread.leave();}
openThread(ev,thread){markEventHandled(ev,"sidebar.openThread");thread.setAsDiscussThread();}}
const DiscussSidebarCategory=__exports.DiscussSidebarCategory=class DiscussSidebarCategory extends Component{static template="mail.DiscussSidebarCategory";static props=["category"];static components={Dropdown};setup(){super.setup();this.store=useState(useService("mail.store"));this.discusscorePublicWebService=useState(useService("discuss.core.public.web"));this.hover=useHover(["root","floating*"],{onHover:()=>this.onHover(true),onAway:()=>this.onHover(false),});this.floating=useDropdownState();}
onHover(hovering){this.floating.isOpen=hovering;}
get category(){return this.props.category;}
get actions(){return[];}
toggle(){if(this.store.channels.status==="fetching"){return;}
this.category.open=!this.category.open;this.discusscorePublicWebService.broadcastCategoryState(this.category);}}
const DiscussSidebarQuickSearchInput=__exports.DiscussSidebarQuickSearchInput=class DiscussSidebarQuickSearchInput extends Component{static template="mail.DiscussSidebarQuickSearchInput";static props=["state","autofocus?"];setup(){super.setup();this.store=useState(useService("mail.store"));if(this.props.autofocus){useAutofocus({refName:"root"});}}
get state(){return this.props.state;}}
const DiscussSidebarCategories=__exports.DiscussSidebarCategories=class DiscussSidebarCategories extends Component{static template="mail.DiscussSidebarCategories";static props={};static components={DiscussSidebarCategory,DiscussSidebarChannel,DiscussSidebarQuickSearchInput,Dropdown,};setup(){super.setup();this.store=useState(useService("mail.store"));this.discusscorePublicWebService=useState(useService("discuss.core.public.web"));this.state=useState({quickSearchVal:"",floatingQuickSearchOpen:false});this.orm=useService("orm");this.quickSearchHover=useHover(["quick-search-btn","quick-search-floating*"],{onHover:()=>(this.quickSearchFloating.isOpen=true),onAway:()=>{if(!this.quickSearchHover.isHover&&!this.state.quickSearchVal.length){this.state.floatingQuickSearchOpen=false;}},});this.quickSearchFloating=useDropdownState();useSubEnv({filteredThreads:(threads)=>this.filteredThreads(threads),});}
filteredThreads(threads){return threads.filter((thread)=>thread.displayInSidebar&&(thread.parent_channel_id||!this.state.quickSearchVal||cleanTerm(thread.displayName).includes(cleanTerm(this.state.quickSearchVal))));}
get hasQuickSearch(){return(Object.values(this.store.Thread.records).filter((thread)=>thread.is_pinned&&thread.model==="discuss.channel").length>19);}}
discussSidebarItemsRegistry.add("channels",DiscussSidebarCategories,{sequence:30});return __exports;});;

/* /mail/static/src/discuss/core/public_web/message_actions.js */
odoo.define('@mail/discuss/core/public_web/message_actions',['@mail/core/common/message_actions','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{messageActionsRegistry}=require("@mail/core/common/message_actions");const{_t}=require("@web/core/l10n/translation");messageActionsRegistry.add("create-or-view-thread",{condition:(component)=>component.message.thread?.eq(component.props.thread)&&component.message.thread.hasSubChannelFeature&&component.store.self.isInternalUser,icon:"fa fa-comments-o",onClick:(component)=>{if(component.message.linkedSubChannel){component.message.linkedSubChannel.open();}else{component.message.thread.createSubChannel({initialMessage:component.message});}},title:(component)=>component.message.linkedSubChannel?_t("View Thread"):_t("Create Thread"),sequence:75,});return __exports;});;

/* /mail/static/src/discuss/core/public_web/message_model_patch.js */
odoo.define('@mail/discuss/core/public_web/message_model_patch',['@mail/core/common/message_model','@mail/model/record','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message_model");const{Record}=require("@mail/model/record");const{patch}=require("@web/core/utils/patch");patch(Message.prototype,{setup(){super.setup(...arguments);this.linkedSubChannel=Record.one("Thread",{inverse:"from_message_id"});},});return __exports;});;

/* /mail/static/src/discuss/core/public_web/message_patch.js */
odoo.define('@mail/discuss/core/public_web/message_patch',['@mail/core/common/message','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message");const{patch}=require("@web/core/utils/patch");patch(Message.prototype,{async onClickNotificationMessage(ev){const{oeType}=ev.target.dataset;if(oeType==="sub-channels-menu"){this.env.subChannelMenu?.open();}
await super.onClickNotificationMessage(...arguments);},});return __exports;});;

/* /mail/static/src/discuss/core/public_web/store_service_patch.js */
odoo.define('@mail/discuss/core/public_web/store_service_patch',['@mail/core/common/store_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Store}=require("@mail/core/common/store_service");const{patch}=require("@web/core/utils/patch");const StorePatch={setup(){super.setup(...arguments);this.channels=this.makeCachedFetchData({channels_as_member:true});},};patch(Store.prototype,StorePatch);return __exports;});;

/* /mail/static/src/discuss/core/public_web/sub_channel_list.js */
odoo.define('@mail/discuss/core/public_web/sub_channel_list',['@mail/core/public_web/notification_item','@mail/discuss/core/common/action_panel','@mail/utils/common/dates','@mail/utils/common/hooks','@odoo/owl','@web/core/l10n/translation','@web/core/network/rpc','@web/core/utils/hooks','@web/core/utils/search'],function(require){'use strict';let __exports={};const{NotificationItem}=require("@mail/core/public_web/notification_item");const{ActionPanel}=require("@mail/discuss/core/common/action_panel");const{isToday}=require("@mail/utils/common/dates");const{useSequential,useVisible}=require("@mail/utils/common/hooks");const{Component,useEffect,useRef,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{useAutofocus,useService}=require("@web/core/utils/hooks");const{fuzzyLookup}=require("@web/core/utils/search");const{DateTime}=luxon;const SubChannelList=__exports.SubChannelList=class SubChannelList extends Component{static template="mail.SubChannelList";static components={ActionPanel,NotificationItem};static props=["thread","close?"];setup(){this.store=useService("mail.store");this.state=useState({loading:false,searchTerm:"",lastSearchTerm:"",searching:false,subChannels:this.props.thread.sub_channel_ids,});this.searchRef=useRef("search");this.sequential=useSequential();useAutofocus({refName:"search"});useVisible("load-more",(isVisible)=>{if(isVisible){this.props.thread.loadMoreSubChannels({searchTerm:this.state.searching?this.state.searchTerm:undefined,});}});useEffect((searchTerm)=>{if(!searchTerm){this.clearSearch();}},()=>[this.state.searchTerm]);}
get NO_THREAD_FOUND(){return _t(`No thread named "%(thread_name)s"`,{thread_name:this.state.lastSearchTerm});}
async onClickSubThread(subThread){if(!subThread.hasSelfAsMember){await rpc("/discuss/channel/join",{channel_id:subThread.id});}
subThread.open();if(this.env.inChatWindow){this.props.close?.();}}
clearSearch(){this.state.searchTerm="";this.state.lastSearchTerm="";this.state.searching=false;this.state.loading=false;this.state.subChannels=this.props.thread.sub_channel_ids;}
dateText(message){if(isToday(message.datetime)){return message.datetime?.toLocaleString(DateTime.TIME_SIMPLE);}
return message.datetime?.toLocaleString(DateTime.DATE_MED);}
onKeydownSearch(ev){if(ev.key==="Enter"){this.search();}}
async onClickCreate(){await this.props.thread.createSubChannel({name:this.state.searchTerm});this._refreshSubChannelList();this.props.close?.();}
async search(){if(!this.state.searchTerm){return;}
this.sequential(async()=>{this.state.searching=true;this.state.loading=true;try{await this.props.thread.loadMoreSubChannels({searchTerm:this.state.searchTerm,});if(this.state.searching){this._refreshSubChannelList();this.state.lastSearchTerm=this.state.searchTerm;}}finally{this.state.loading=false;}});}
_refreshSubChannelList(){this.state.subChannels=fuzzyLookup(this.state.searchTerm??"",this.props.thread.sub_channel_ids,({name})=>name);}}
return __exports;});;

/* /mail/static/src/discuss/core/public_web/thread_actions.js */
odoo.define('@mail/discuss/core/public_web/thread_actions',['@mail/core/common/thread_actions','@mail/discuss/core/public_web/sub_channel_list','@odoo/owl','@web/core/l10n/translation','@web/core/popover/popover_hook'],function(require){'use strict';let __exports={};const{threadActionsRegistry}=require("@mail/core/common/thread_actions");const{SubChannelList}=require("@mail/discuss/core/public_web/sub_channel_list");const{useChildSubEnv,useComponent}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{usePopover}=require("@web/core/popover/popover_hook");threadActionsRegistry.add("show-threads",{close(component,action){action.popover?.close();},condition:(component)=>component.thread?.hasSubChannelFeature||component.thread?.parent_channel_id?.hasSubChannelFeature,icon:"fa fa-fw fa-comments-o",iconLarge:"fa fa-fw fa-lg fa-comments-o",name:_t("Threads"),component:SubChannelList,componentProps(action){return{close:()=>action.close()};},setup(action){const component=useComponent();if(!component.props.chatWindow){action.popover=usePopover(SubChannelList,{onClose:()=>action.close(),fixedPosition:true,popoverClass:action.panelOuterClass,});}
useChildSubEnv({subChannelMenu:{open:()=>action.open(),},});},open:(component,action)=>{const thread=component.thread?.parent_channel_id||component.thread;action.popover?.open(component.root.el.querySelector(`[name="${action.id}"]`),{thread});},panelOuterClass:"bg-100 border border-secondary",sequence:(comp)=>(comp.props.chatWindow?40:5),sequenceGroup:10,toggle:true,});return __exports;});;

/* /mail/static/src/discuss/core/public_web/thread_model_patch.js */
odoo.define('@mail/discuss/core/public_web/thread_model_patch',['@mail/core/common/thread_model','@web/core/utils/concurrency','@mail/model/record','@web/core/network/rpc','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Thread}=require("@mail/core/common/thread_model");const{Deferred}=require("@web/core/utils/concurrency");const{Record}=require("@mail/model/record");const{rpc}=require("@web/core/network/rpc");const{patch}=require("@web/core/utils/patch");patch(Thread,{async getOrFetch(data){let thread=super.get(data);if(data.model!=="discuss.channel"||!data.id){return thread;}
thread=this.insert({id:data.id,model:data.model});if(thread.fetchChannelInfoState==="fetched"){return Promise.resolve(thread);}
if(thread.fetchChannelInfoState==="fetching"){return thread.fetchChannelInfoDeferred;}
thread.fetchChannelInfoState="fetching";const def=new Deferred();thread.fetchChannelInfoDeferred=def;thread.fetchChannelInfo().then((result)=>{if(thread.exists()){thread.fetchChannelInfoState="fetched";thread.fetchChannelInfoDeferred=undefined;}
def.resolve(result);},(error)=>{if(thread.exists()){thread.fetchChannelInfoState="not_fetched";thread.fetchChannelInfoDeferred=undefined;}
def.reject(error);});return def;},});patch(Thread.prototype,{setup(){super.setup(...arguments);this.from_message_id=Record.one("Message");this.parent_channel_id=Record.one("Thread",{onDelete(){this.delete();},});this.sub_channel_ids=Record.many("Thread",{inverse:"parent_channel_id",sort:(a,b)=>b.id-a.id,});this.displayInSidebar=Record.attr(false,{compute(){return(this.displayToSelf||this.isLocallyPinned||this.sub_channel_ids.some((t)=>t.displayInSidebar));},});this.loadSubChannelsDone=false;this.lastSubChannelLoaded=null;},get canLeave(){return!this.parent_channel_id&&super.canLeave;},get canUnpin(){return(this.parent_channel_id&&this.importantCounter===0)||super.canUnpin;},get allowCalls(){return super.allowCalls&&!this.parent_channel_id;},delete(){if(this.model==="discuss.channel"){this.store.env.services.bus_service.deleteChannel(this.busChannel);}
super.delete(...arguments);},get hasSubChannelFeature(){return this.channel_type==="channel"&&!this.parent_channel_id;},get isEmpty(){return!this.from_message_id&&super.isEmpty;},get notifyOnLeave(){return super.notifyOnLeave&&!this.parent_channel_id;},async createSubChannel({initialMessage,name}={}){const{data,sub_channel}=await rpc("/discuss/channel/sub_channel/create",{parent_channel_id:this.id,from_message_id:initialMessage?.id,name,});this.store.insert(data,{html:true});this.store.Thread.get(sub_channel).open();},async loadMoreSubChannels({searchTerm}={}){if(this.loadSubChannelsDone){return;}
const limit=30;const data=await rpc("/discuss/channel/sub_channel/fetch",{before:this.lastSubChannelLoaded?.id,limit,parent_channel_id:this.id,search_term:searchTerm,});const{Thread:threads=[]}=this.store.insert(data,{html:true});if(searchTerm){return;}
const subChannels=threads.filter((thread)=>this.eq(thread.parent_channel_id));this.lastSubChannelLoaded=subChannels.reduce((min,channel)=>(!min||channel.id<min.id?channel:min),this.lastSubChannelLoaded);if(subChannels.length<limit){this.loadSubChannelsDone=true;}
return subChannels;},onPinStateUpdated(){super.onPinStateUpdated();if(this.is_pinned){this.isLocallyPinned=false;}
if(this.isLocallyPinned){this.store.env.services["bus_service"].addChannel(this.busChannel);}else{this.store.env.services["bus_service"].deleteChannel(this.busChannel);}
if(!this.is_pinned&&!this.isLocallyPinned){this.sub_channel_ids.forEach((c)=>(c.isLocallyPinned=false));}},setAsDiscussThread(){super.setAsDiscussThread(...arguments);if(!this.displayToSelf&&this.model==="discuss.channel"){this.isLocallyPinned=true;}},});return __exports;});;

/* /mail/static/src/discuss/core/public_web/thread_patch.js */
odoo.define('@mail/discuss/core/public_web/thread_patch',['@mail/core/common/thread','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Thread}=require("@mail/core/common/thread");const{patch}=require("@web/core/utils/patch");patch(Thread.prototype,{get orderedMessages(){const result=super.orderedMessages;if(this.props.thread.from_message_id&&!this.props.thread.from_message_id.isEmpty){if(this.props.order==="asc"){result.unshift(this.props.thread.from_message_id);}else{result.push(this.props.thread.from_message_id);}}
return result;},});return __exports;});;

/* /mail/static/src/discuss/core/web/channel_member_list_patch.js */
odoo.define('@mail/discuss/core/web/channel_member_list_patch',['@mail/discuss/core/common/channel_member_list','@mail/discuss/web/avatar_card/avatar_card_popover','@web/core/popover/popover_hook','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ChannelMemberList}=require("@mail/discuss/core/common/channel_member_list");const{AvatarCardPopover}=require("@mail/discuss/web/avatar_card/avatar_card_popover");const{usePopover}=require("@web/core/popover/popover_hook");const{patch}=require("@web/core/utils/patch");patch(ChannelMemberList.prototype,{setup(){super.setup(...arguments);this.avatarCard=usePopover(AvatarCardPopover,{position:"right",});},onClickAvatar(ev,member){if(!this.canOpenChatWith(member)){return;}
if(!this.avatarCard.isOpen){this.avatarCard.open(ev.currentTarget,{id:member.persona.userId,});}},});Object.assign(ChannelMemberList.components,{AvatarCardPopover});return __exports;});;

/* /mail/static/src/discuss/core/web/channel_selector.js */
odoo.define('@mail/discuss/core/web/channel_selector',['@mail/core/common/navigable_list','@mail/utils/common/format','@odoo/owl','@web/core/hotkeys/hotkey_service','@web/core/l10n/translation','@web/core/tags_list/tags_list','@web/core/utils/hooks','@web/core/utils/misc','@mail/utils/common/hooks'],function(require){'use strict';let __exports={};const{NavigableList}=require("@mail/core/common/navigable_list");const{cleanTerm}=require("@mail/utils/common/format");const{Component,useEffect,useRef,useState}=require("@odoo/owl");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const{_t}=require("@web/core/l10n/translation");const{TagsList}=require("@web/core/tags_list/tags_list");const{useService}=require("@web/core/utils/hooks");const{isEventHandled,markEventHandled}=require("@web/core/utils/misc");const{useSequential}=require("@mail/utils/common/hooks");const ChannelSelector=__exports.ChannelSelector=class ChannelSelector extends Component{static components={TagsList,NavigableList};static props=["category","onValidate?","autofocus?","multiple?","close?"];static defaultProps={multiple:true};static template="discuss.ChannelSelector";setup(){super.setup();this.discussCoreCommonService=useState(useService("discuss.core.common"));this.store=useState(useService("mail.store"));this.suggestionService=useService("mail.suggestion");this.orm=useService("orm");this.sequential=useSequential();this.state=useState({value:"",selectedPartners:[],navigableListProps:{anchorRef:undefined,position:"bottom-fit",onSelect:(ev,option)=>this.onSelect(option),optionTemplate:this.props.category.id==="channels"?"discuss.ChannelSelector.channel":"discuss.ChannelSelector.chat",options:[],isLoading:false,},});this.inputRef=useRef("input");this.rootRef=useRef("root");this.markEventHandled=markEventHandled;useEffect(()=>{this.state.navigableListProps.anchorRef=this.rootRef?.el;this.state.navigableListProps.optionTemplate=this.props.category.id==="channels"?"discuss.ChannelSelector.channel":"discuss.ChannelSelector.chat";},()=>[this.rootRef,this.props.category]);useEffect(()=>{this.fetchSuggestions();},()=>[this.state.value]);useEffect((focus)=>{if(focus&&this.inputRef.el){this.inputRef.el.focus();}},()=>[this.props.autofocus]);}
async fetchSuggestions(){const cleanedTerm=cleanTerm(this.state.value);if(cleanedTerm){if(this.props.category.id==="channels"){const domain=[["parent_channel_id","=",false],["channel_type","=","channel"],["name","ilike",cleanedTerm],];const fields=["name"];const results=await this.sequential(async()=>{this.state.navigableListProps.isLoading=true;const res=await this.orm.searchRead("discuss.channel",domain,fields,{limit:10,});this.state.navigableListProps.isLoading=false;return res;});if(!results){this.state.navigableListProps.options=[];return;}
const choices=results.map((channel)=>{return{channelId:channel.id,classList:"o-discuss-ChannelSelector-suggestion",label:channel.name,};});choices.push({channelId:"__create__",classList:"o-discuss-ChannelSelector-suggestion",label:this.state.value,});this.state.navigableListProps.options=choices;return;}
if(this.props.category.id==="chats"){const data=await this.sequential(async()=>{this.state.navigableListProps.isLoading=true;const data=await this.orm.call("res.partner","im_search",[cleanedTerm,10,this.state.selectedPartners,]);this.state.navigableListProps.isLoading=false;return data;});if(!data){this.state.navigableListProps.options=[];return;}
const{Persona:partners=[]}=this.store.insert(data);const suggestions=this.suggestionService.sortPartnerSuggestions(partners,cleanedTerm).map((suggestion)=>{return{classList:"o-discuss-ChannelSelector-suggestion",label:suggestion.name,partner:suggestion,};});if(this.store.self.name.includes(cleanedTerm)){suggestions.push({classList:"o-discuss-ChannelSelector-suggestion",label:this.store.self.name,partner:this.store.self,});}
if(suggestions.length===0){suggestions.push({classList:"o-discuss-ChannelSelector-suggestion",label:_t("No results found"),unselectable:true,});}
this.state.navigableListProps.options=suggestions;return;}}
this.state.navigableListProps.options=[];return;}
onSelect(option){if(this.props.category.id==="channels"){if(option.channelId==="__create__"){this.env.services.orm.call("discuss.channel","channel_create",[option.label,this.store.internalUserGroupId,]).then((data)=>{const{Thread}=this.store.insert(data);const[channel]=Thread;channel.open();});}else{this.store.joinChannel(option.channelId,option.label);}
this.onValidate();}
if(this.props.category.id==="chats"){if(!this.state.selectedPartners.includes(option.partner.id)){this.state.selectedPartners.push(option.partner.id);}
this.state.value="";}
if(!this.props.multiple){this.onValidate();}}
async onValidate(){if(this.props.category.id==="chats"){const selectedPartnerIds=this.state.selectedPartners;if(selectedPartnerIds.length===0){return;}
await this.discussCoreCommonService.startChat(selectedPartnerIds);}
if(this.props.onValidate){this.props.onValidate();}}
onKeydownInput(ev){const hotkey=getActiveHotkey(ev);switch(hotkey){case"enter":if(isEventHandled(ev,"NavigableList.select")||!this.state.value===""){return;}
this.onValidate();break;case"backspace":if(this.state.selectedPartners.length>0&&this.state.value===""){this.state.selectedPartners.pop();}
return;case"escape":this.props.close?.();return;default:return;}
ev.stopPropagation();ev.preventDefault();}
removeFromSelectedPartners(id){this.state.selectedPartners=this.state.selectedPartners.filter((partnerId)=>partnerId!==id);this.inputRef.el.focus();}
get inputPlaceholder(){return this.state.selectedPartners.length>0?_t("Press Enter to start"):this.props.category.addTitle;}
get tagsList(){const res=[];for(const partnerId of this.state.selectedPartners){const partner=this.store.Persona.get({type:"partner",id:partnerId});res.push({id:partner.id,text:partner.name,className:"m-1 py-1",colorIndex:Math.floor(partner.name.length%10),onDelete:()=>this.removeFromSelectedPartners(partnerId),});}
return res;}}
return __exports;});;

/* /mail/static/src/discuss/core/web/chat_window_patch.js */
odoo.define('@mail/discuss/core/web/chat_window_patch',['@mail/discuss/core/web/channel_selector','@mail/core/common/chat_window'],function(require){'use strict';let __exports={};const{ChannelSelector}=require("@mail/discuss/core/web/channel_selector");const{ChatWindow}=require("@mail/core/common/chat_window");Object.assign(ChatWindow.components,{ChannelSelector});return __exports;});;

/* /mail/static/src/discuss/core/web/command_palette.js */
odoo.define('@mail/discuss/core/web/command_palette',['@mail/utils/common/format','@odoo/owl','@web/core/l10n/translation','@web/core/registry','@web/core/utils/urls','@mail/core/common/im_status'],function(require){'use strict';let __exports={};const{cleanTerm}=require("@mail/utils/common/format");const{Component}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{imageUrl}=require("@web/core/utils/urls");const{ImStatus}=require("@mail/core/common/im_status");const commandSetupRegistry=registry.category("command_setup");const commandProviderRegistry=registry.category("command_provider");class DiscussCommand extends Component{static components={ImStatus};static template="mail.DiscussCommand";static props={counter:{type:Number,optional:true},executeCommand:Function,imgUrl:String,name:String,persona:{type:Object,optional:true},channel:{type:Object,optional:true},searchValue:String,slots:Object,};}
commandSetupRegistry.add("@",{debounceDelay:200,emptyMessage:_t("No user found"),name:_t("users"),placeholder:_t("Search for a user..."),});commandProviderRegistry.add("mail.partner",{namespace:"@",async provide(env,options){const store=env.services["mail.store"];await store.channels.fetch();const suggestionService=env.services["mail.suggestion"];const commands=[];const mentionedChannels=store.getNeedactionChannels();const displayedPartnerIds=new Set();if(!options.searchValue){mentionedChannels.slice(0,3).map((channel)=>{if(channel.channel_type==="chat"){displayedPartnerIds.add(channel.correspondent.persona.id);}
commands.push({Component:DiscussCommand,async action(){switch(channel.channel_type){case"chat":store.openChat({partnerId:channel.correspondent.persona.id});break;case"group":channel.open();break;case"channel":{await store.joinChannel(channel.id,channel.name);channel.open();}}},name:channel.displayName,category:"discuss_mentioned",props:{imgUrl:channel.avatarUrl,persona:channel.channel_type==="chat"?channel.correspondent.persona:undefined,counter:channel.importantCounter,},});});}
const searchResults=await store.searchPartners(options.searchValue);suggestionService.sortPartnerSuggestions(searchResults,options.searchValue).filter((partner)=>!displayedPartnerIds.has(partner.id)).map((partner)=>{const chat=partner.searchChat();commands.push({Component:DiscussCommand,action(){store.openChat({partnerId:partner.id});},name:partner.name,props:{imgUrl:partner.avatarUrl,persona:partner,counter:chat?chat.importantCounter:undefined,},});});return commands;},});commandSetupRegistry.add("#",{debounceDelay:200,emptyMessage:_t("No channel found"),name:_t("channels"),placeholder:_t("Search for a channel..."),});commandProviderRegistry.add("discuss.channel",{namespace:"#",async provide(env,options){const store=env.services["mail.store"];await store.channels.fetch();const commands=[];const recentChannels=store.getRecentChannels();const shownChannels=new Set();if(!options.searchValue){recentChannels.filter((channel)=>["channel","group"].includes(channel.channel_type)).slice(0,3).map((channel)=>{shownChannels.add(channel.id);commands.push({Component:DiscussCommand,async action(){await store.joinChannel(channel.id,channel.name);channel.open();},name:channel.displayName,category:"discuss_recent",props:{channel,imgUrl:channel.avatarUrl,counter:channel.importantCounter,},});});}
const domain=[["channel_type","=","channel"],["name","ilike",cleanTerm(options.searchValue)],];const channelsData=await env.services.orm.searchRead("discuss.channel",domain,["channel_type","name","avatar_cache_key","parent_channel_id"],{limit:10});channelsData.filter((data)=>!shownChannels.has(data.id)).map((data)=>{const channel=store.Thread.insert({...data,model:"discuss.channel",parent_channel_id:data.parent_channel_id?{id:data.parent_channel_id[0],model:"discuss.channel",name:data.parent_channel_id[1],}:null,});commands.push({Component:DiscussCommand,async action(){const channel=await store.joinChannel(data.id,data.name);channel.open();},name:data.name,props:{channel,imgUrl:imageUrl("discuss.channel",data.id,"avatar_128",{unique:data.avatar_cache_key,}),},});});const groups=recentChannels.filter((channel)=>!shownChannels.has(channel.id)&&channel.channel_type==="group"&&cleanTerm(channel.displayName).includes(cleanTerm(options.searchValue)));groups.map((channel)=>{commands.push({Component:DiscussCommand,async action(){channel.open();},name:channel.displayName,props:{imgUrl:channel.avatarUrl,counter:channel.importantCounter,},});});return commands;},});return __exports;});;

/* /mail/static/src/discuss/core/web/discuss_core_common_service_patch.js */
odoo.define('@mail/discuss/core/web/discuss_core_common_service_patch',['@mail/discuss/core/common/discuss_core_common_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{DiscussCoreCommon}=require("@mail/discuss/core/common/discuss_core_common_service");const{patch}=require("@web/core/utils/patch");const discussCoreCommon={async _handleNotificationNewMessage(...args){await this.store.channels.fetch();return super._handleNotificationNewMessage(...args);},};patch(DiscussCoreCommon.prototype,discussCoreCommon);return __exports;});;

/* /mail/static/src/discuss/core/web/discuss_core_web_service.js */
odoo.define('@mail/discuss/core/web/discuss_core_web_service',['@odoo/owl','@web/core/l10n/translation','@web/core/registry'],function(require){'use strict';let __exports={};const{reactive}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const DiscussCoreWeb=__exports.DiscussCoreWeb=class DiscussCoreWeb{constructor(env,services){this.env=env;this.busService=services.bus_service;this.notificationService=services.notification;this.ui=services.ui;this.store=services["mail.store"];this.multiTab=services.multi_tab;}
setup(){this.busService.subscribe("res.users/connection",async({partnerId,username})=>{const notification=_t("%(user)s connected. This is their first connection. Wish them luck.",{user:username});this.notificationService.add(notification,{type:"info"});if(!this.multiTab.isOnMainTab()){return;}
const chat=await this.store.getChat({partnerId});if(chat&&!this.ui.isSmall){this.store.chatHub.opened.add({thread:chat});}});this.busService.subscribe("discuss.Thread/fold_state",async(data)=>{const thread=await this.store.Thread.getOrFetch(data);if(data.fold_state&&thread&&data.foldStateCount>thread.foldStateCount){thread.foldStateCount=data.foldStateCount;thread.state=data.fold_state;if(thread.state==="closed"){const chatWindow=this.store.ChatWindow.get({thread});chatWindow?.close({notifyState:false});}}});this.env.bus.addEventListener("mail.message/delete",({detail:{message}})=>{if(message.thread?.model==="discuss.channel"){this.store.channels.fetch();}});this.busService.start();}}
const discussCoreWeb=__exports.discussCoreWeb={dependencies:["bus_service","mail.store","notification","ui","multi_tab"],start(env,services){const discussCoreWeb=reactive(new DiscussCoreWeb(env,services));discussCoreWeb.setup();return discussCoreWeb;},};registry.category("services").add("discuss.core.web",discussCoreWeb);return __exports;});;

/* /mail/static/src/discuss/core/web/discuss_sidebar_categories_patch.js */
odoo.define('@mail/discuss/core/web/discuss_sidebar_categories_patch',['@mail/discuss/core/web/channel_selector','@mail/utils/common/hooks','@web/core/utils/patch','@mail/discuss/core/public_web/discuss_sidebar_categories','@web/core/l10n/translation','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{ChannelSelector}=require("@mail/discuss/core/web/channel_selector");const{onExternalClick}=require("@mail/utils/common/hooks");const{patch}=require("@web/core/utils/patch");const{DiscussSidebarCategory,DiscussSidebarChannel,}=require("@mail/discuss/core/public_web/discuss_sidebar_categories");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{useEffect,useState}=require("@odoo/owl");DiscussSidebarCategory.components={...DiscussSidebarCategory.components,ChannelSelector};const DiscussSidebarChannelPatch={setup(){super.setup();this.actionService=useService("action");},get commands(){const commands=super.commands;if(this.thread.channel_type==="channel"){commands.push({onSelect:()=>this.openSettings(),label:_t("Channel settings"),icon:"fa fa-cog",sequence:10,});}
return commands;},openSettings(){if(this.thread.channel_type==="channel"){this.actionService.doAction({type:"ir.actions.act_window",res_model:"discuss.channel",res_id:this.thread.id,views:[[false,"form"]],target:"current",});}},};const DiscussSidebarCategoryPatch={setup(){super.setup();this.actionService=useService("action");this.state??=useState({});this.state.editing=false;onExternalClick("selector",()=>(this.state.editing=false));useEffect(()=>{if(this.store.discuss.isSidebarCompact&&!this.floating.isOpen){this.state.editing=false;}},()=>[this.floating.isOpen]);},addToCategory(){this.state.editing=true;},open(){if(this.category.id==="channels"){this.actionService.doAction({name:_t("Public Channels"),type:"ir.actions.act_window",res_model:"discuss.channel",views:[[false,"kanban"],[false,"form"],],domain:[["channel_type","=","channel"],["parent_channel_id","=",false],],});}},onHover(){if(this.state.editing&&this.store.discuss.isSidebarCompact){return;}
super.onHover(...arguments);if(this.store.discuss.isSidebarCompact&&!this.floating.isOpen){this.state.editing=false;}},stopEditing(){this.state.editing=false;},get actions(){const actions=super.actions;if(this.category.canView){actions.push({onSelect:()=>this.open(),label:_t("View or join channels"),icon:"fa fa-cog",});}
if(this.category.canAdd&&this.category.open){actions.push({onSelect:()=>this.addToCategory(),label:this.category.addTitle,icon:"fa fa-plus",hotkey:this.category.addHotkey,class:"o-mail-DiscussSidebarCategory-add",});}
return actions;},};patch(DiscussSidebarChannel.prototype,DiscussSidebarChannelPatch);patch(DiscussSidebarCategory.prototype,DiscussSidebarCategoryPatch);return __exports;});;

/* /mail/static/src/discuss/core/web/messaging_menu_patch.js */
odoo.define('@mail/discuss/core/web/messaging_menu_patch',['@mail/core/public_web/messaging_menu','@mail/discuss/core/web/channel_selector','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{MessagingMenu}=require("@mail/core/public_web/messaging_menu");const{ChannelSelector}=require("@mail/discuss/core/web/channel_selector");const{patch}=require("@web/core/utils/patch");Object.assign(MessagingMenu.components,{ChannelSelector});patch(MessagingMenu.prototype,{beforeOpen(){const res=super.beforeOpen(...arguments);this.store.channels.fetch();return res;},onClickNewMessage(){if(this.ui.isSmall||this.env.inDiscussApp){Object.assign(this.state,{adding:"chat"});}else{this.store.openNewMessage();this.dropdown.close();}},get counter(){const count=super.counter;const channelsContribution=this.store.channels.status!=="fetched"?this.store.initChannelsUnreadCounter:Object.values(this.store.Thread.records).filter((thread)=>thread.displayToSelf&&!thread.isMuted&&(thread.selfMember?.message_unread_counter||thread.message_needaction_counter)).length;const channelsNeedactionCounter=Object.values(this.store.Thread.records).reduce((acc,thread)=>{return(acc+
(thread.model==="discuss.channel"?thread.message_needaction_counter:0));},0);return count+channelsContribution-channelsNeedactionCounter;},});return __exports;});;

/* /mail/static/src/discuss/core/web/store_service_patch.js */
odoo.define('@mail/discuss/core/web/store_service_patch',['@mail/core/common/store_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Store}=require("@mail/core/common/store_service");const{patch}=require("@web/core/utils/patch");const StorePatch={setup(){super.setup(...arguments);this.initChannelsUnreadCounter=0;},onStarted(){super.onStarted();if(this.discuss.isActive){this.channels.fetch();}},};patch(Store.prototype,StorePatch);return __exports;});;

/* /mail/static/src/discuss/core/web/thread_actions.js */
odoo.define('@mail/discuss/core/web/thread_actions',['@mail/core/common/thread_actions','@odoo/owl','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{threadActionsRegistry}=require("@mail/core/common/thread_actions");const{useComponent}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");threadActionsRegistry.add("expand-discuss",{condition(component){return(component.thread&&component.props.chatWindow?.isOpen&&component.thread.model==="discuss.channel"&&!component.ui.isSmall);},setup(){const component=useComponent();component.actionService=useService("action");},icon:"fa fa-fw fa-expand",name:_t("Open in Discuss"),shouldClearBreadcrumbs(component){return false;},open(component){component.actionService.doAction({type:"ir.actions.client",tag:"mail.action_discuss",},{clearBreadcrumbs:this.shouldClearBreadcrumbs(component),additionalContext:{active_id:component.thread.id},});},sequence:40,sequenceGroup:20,});return __exports;});;

/* /mail/static/src/discuss/core/web/thread_model_patch.js */
odoo.define('@mail/discuss/core/web/thread_model_patch',['@mail/core/common/thread_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Thread}=require("@mail/core/common/thread_model");const{patch}=require("@web/core/utils/patch");patch(Thread.prototype,{setup(){super.setup(...arguments);this.foldStateCount=0;},onPinStateUpdated(){super.onPinStateUpdated();if(!this.displayToSelf&&!this.isLocallyPinned&&this.eq(this.store.discuss.thread)){if(this.store.discuss.isActive){const newThread=this.store.discuss.channels.threads.find((thread)=>thread.displayToSelf||thread.isLocallyPinned)||this.store.inbox;newThread.setAsDiscussThread();}else{this.store.discuss.thread=undefined;}}},});return __exports;});;

/* /mail/static/src/discuss/call/common/blur_manager.js */
odoo.define('@mail/discuss/call/common/blur_manager',['@mail/utils/common/misc','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{closeStream}=require("@mail/utils/common/misc");const{browser}=require("@web/core/browser/browser");function drawAndBlurImageOnCanvas(image,blurAmount,canvas){canvas.width=image.width;canvas.height=image.height;if(blurAmount===0){canvas.getContext("2d").drawImage(image,0,0,image.width,image.height);return;}
canvas.getContext("2d").clearRect(0,0,image.width,image.height);canvas.getContext("2d").save();canvas.getContext("2d").filter=`blur(${blurAmount}px)`;canvas.getContext("2d").drawImage(image,0,0,image.width,image.height);canvas.getContext("2d").restore();}
const BlurManager=__exports.BlurManager=class BlurManager{canvas=document.createElement("canvas");canvasBlur=document.createElement("canvas");canvasMask=document.createElement("canvas");canvasStream;isVideoDataLoaded=false;rejectStreamPromise;resolveStreamPromise;selfieSegmentation=new window.SelfieSegmentation({locateFile:(file)=>{return`https://cdn.jsdelivr.net/npm/@mediapipe/selfie_segmentation@0.1/${file}`;},});stream;video=document.createElement("video");constructor(stream,{backgroundBlur=10,edgeBlur=10,modelSelection=1,selfieMode=false}={}){this.edgeBlur=edgeBlur;this.backgroundBlur=backgroundBlur;this._onVideoPlay=this._onVideoPlay.bind(this);this.video.addEventListener("loadeddata",this._onVideoPlay);this.canvas.getContext("2d");this.canvasStream=this.canvas.captureStream();let rejectStreamPromise;let resolveStreamPromise;Object.assign(this,{stream:new Promise((resolve,reject)=>{rejectStreamPromise=reject;resolveStreamPromise=resolve;}),rejectStreamPromise,resolveStreamPromise,});this.video.srcObject=stream;this.video.load();this.selfieSegmentation.setOptions({selfieMode,modelSelection,});this.selfieSegmentation.onResults((r)=>this._onSelfieSegmentationResults(r));this.video.autoplay=true;Promise.resolve(this.video.play()).catch(()=>{});}
close(){this.video.removeEventListener("loadeddata",this._onVideoPlay);this.video.srcObject=null;this.isVideoDataLoaded=false;this.selfieSegmentation.reset();closeStream(this.canvasStream);this.canvasStream=null;if(this.rejectStreamPromise){this.rejectStreamPromise(new Error("The source stream was removed before the beginning of the blur process"));}}
_drawWithCompositing(image,compositeOperation){this.canvas.getContext("2d").globalCompositeOperation=compositeOperation;this.canvas.getContext("2d").drawImage(image,0,0);}
_onVideoPlay(){this.isVideoDataLoaded=true;this._requestFrame();}
async _onFrame(){if(!this.selfieSegmentation){return;}
if(!this.video){return;}
if(!this.isVideoDataLoaded){return;}
await this.selfieSegmentation.send({image:this.video});browser.setTimeout(()=>this._requestFrame(),Math.floor(1000/30));}
_onSelfieSegmentationResults(results){drawAndBlurImageOnCanvas(results.image,this.backgroundBlur,this.canvasBlur);this.canvas.width=this.canvasBlur.width;this.canvas.height=this.canvasBlur.height;drawAndBlurImageOnCanvas(results.segmentationMask,this.edgeBlur,this.canvasMask);this.canvas.getContext("2d").save();this.canvas.getContext("2d").drawImage(results.image,0,0,this.canvas.width,this.canvas.height);this._drawWithCompositing(this.canvasMask,"destination-in");this._drawWithCompositing(this.canvasBlur,"destination-over");this.canvas.getContext("2d").restore();}
_requestFrame(){browser.requestAnimationFrame(async()=>{await this._onFrame();this.resolveStreamPromise(this.canvasStream);});}}
return __exports;});;

/* /mail/static/src/discuss/call/common/call.js */
odoo.define('@mail/discuss/call/common/call',['@mail/discuss/call/common/call_action_list','@mail/discuss/call/common/call_participant_card','@mail/discuss/call/common/ptt_ad_banner','@web/core/utils/misc','@web/core/browser/feature_detection','@odoo/owl','@web/core/browser/browser','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{CallActionList}=require("@mail/discuss/call/common/call_action_list");const{CallParticipantCard}=require("@mail/discuss/call/common/call_participant_card");const{PttAdBanner}=require("@mail/discuss/call/common/ptt_ad_banner");const{isEventHandled,markEventHandled}=require("@web/core/utils/misc");const{isMobileOS}=require("@web/core/browser/feature_detection");const{Component,onMounted,onPatched,onWillUnmount,toRaw,useExternalListener,useRef,useState,}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const Call=__exports.Call=class Call extends Component{static components={CallActionList,CallParticipantCard,PttAdBanner};static props=["thread","compact?"];static template="discuss.Call";overlayTimeout;setup(){super.setup();this.grid=useRef("grid");this.notification=useService("notification");this.rtc=useState(useService("discuss.rtc"));this.isMobileOs=isMobileOS();this.state=useState({isFullscreen:false,sidebar:false,tileWidth:0,tileHeight:0,columnCount:0,overlay:false,insetCard:undefined,});this.store=useState(useService("mail.store"));onMounted(()=>{this.resizeObserver=new ResizeObserver(()=>this.arrangeTiles());this.resizeObserver.observe(this.grid.el);this.arrangeTiles();});onPatched(()=>this.arrangeTiles());onWillUnmount(()=>{this.resizeObserver.disconnect();browser.clearTimeout(this.overlayTimeout);});useExternalListener(browser,"fullscreenchange",this.onFullScreenChange);}
get isActiveCall(){return Boolean(this.props.thread.eq(this.rtc.state?.channel));}
get minimized(){if(this.state.isFullscreen||this.props.thread.activeRtcSession){return false;}
if(!this.isActiveCall||this.props.thread.videoCount===0||this.props.compact){return true;}
return false;}
get visibleCards(){const raisingHandCards=[];const sessionCards=[];const invitationCards=[];const filterVideos=this.store.settings.showOnlyVideo&&this.props.thread.videoCount>0;for(const session of this.props.thread.rtcSessions){const target=session.raisingHand?raisingHandCards:sessionCards;const cameraStream=session.isCameraOn?session.videoStreams.get("camera"):undefined;if(!filterVideos||cameraStream){target.push({key:"session_main_"+session.id,session,type:"camera",videoStream:cameraStream,});}
const screenStream=session.isScreenSharingOn?session.videoStreams.get("screen"):undefined;if(screenStream){target.push({key:"session_secondary_"+session.id,session,type:"screen",videoStream:screenStream,});}}
if(!filterVideos){for(const member of this.props.thread.invitedMembers){invitationCards.push({key:"member_"+member.id,member,});}}
raisingHandCards.sort((c1,c2)=>{return c1.session.raisingHand-c2.session.raisingHand;});sessionCards.sort((c1,c2)=>{return(c1.session.channelMember?.persona?.name?.localeCompare(c2.session.channelMember?.persona?.name)??1);});invitationCards.sort((c1,c2)=>{return c1.member.persona?.name?.localeCompare(c2.member.persona?.name)??1;});return raisingHandCards.concat(sessionCards,invitationCards);}
get visibleMainCards(){const activeSession=this.props.thread.activeRtcSession;if(!activeSession){this.state.insetCard=undefined;return this.visibleCards;}
const type=activeSession.mainVideoStreamType;if(type==="screen"||activeSession.isScreenSharingOn){this.setInset(activeSession,type==="camera"?"screen":"camera");}else{this.state.insetCard=undefined;}
return[{key:"session_"+activeSession.id,session:activeSession,type,videoStream:activeSession.getStream(type),},];}
setInset(session,videoType){const key="session_"+session.id;if(toRaw(this.state).insetCard?.key===key){this.state.insetCard.type=videoType;this.state.insetCard.videoStream=session.getStream(videoType);}else{this.state.insetCard={key,session,type:videoType,videoStream:session.getStream(videoType),};}}
get hasCallNotifications(){return Boolean((!this.props.compact||this.state.isFullscreen)&&this.isActiveCall&&this.rtc.notifications.size);}
get hasSidebarButton(){return Boolean(this.props.thread.activeRtcSession&&this.state.overlay&&!this.props.compact);}
get isControllerFloating(){return(this.state.isFullscreen||(this.props.thread.activeRtcSession&&!this.props.compact));}
onMouseleaveMain(ev){if(ev.relatedTarget&&ev.relatedTarget.closest(".o-dropdown--menu")){return;}
this.state.overlay=false;}
onMousemoveMain(ev){if(isEventHandled(ev,"CallMain.MousemoveOverlay")){return;}
this.showOverlay();}
onMousemoveOverlay(ev){markEventHandled(ev,"CallMain.MousemoveOverlay");this.state.overlay=true;browser.clearTimeout(this.overlayTimeout);}
showOverlay(){this.state.overlay=true;browser.clearTimeout(this.overlayTimeout);this.overlayTimeout=browser.setTimeout(()=>{this.state.overlay=false;},3000);}
arrangeTiles(){if(!this.grid.el){return;}
const{width,height}=this.grid.el.getBoundingClientRect();const aspectRatio=this.minimized?1:16/9;const tileCount=this.grid.el.children.length;let optimal={area:0,columnCount:0,tileHeight:0,tileWidth:0,};for(let columnCount=1;columnCount<=tileCount;columnCount++){const rowCount=Math.ceil(tileCount/columnCount);const potentialHeight=width/(columnCount*aspectRatio);const potentialWidth=height/rowCount;let tileHeight;let tileWidth;if(potentialHeight>potentialWidth){tileHeight=Math.floor(potentialWidth);tileWidth=Math.floor(tileHeight*aspectRatio);}else{tileWidth=Math.floor(width/columnCount);tileHeight=Math.floor(tileWidth/aspectRatio);}
const area=tileHeight*tileWidth;if(area<=optimal.area){continue;}
optimal={area,columnCount,tileHeight,tileWidth,};}
Object.assign(this.state,{tileWidth:optimal.tileWidth,tileHeight:optimal.tileHeight,columnCount:optimal.columnCount,});}
async enterFullScreen(){const el=document.body;try{if(el.requestFullscreen){await el.requestFullscreen();}else if(el.mozRequestFullScreen){await el.mozRequestFullScreen();}else if(el.webkitRequestFullscreen){await el.webkitRequestFullscreen();}
this.state.isFullscreen=true;}catch{this.state.isFullscreen=false;this.notification.add(_t("The Fullscreen mode was denied by the browser"),{type:"warning",});}}
async exitFullScreen(){const fullscreenElement=document.webkitFullscreenElement||document.fullscreenElement;if(fullscreenElement){if(document.exitFullscreen){await document.exitFullscreen();}else if(document.mozCancelFullScreen){await document.mozCancelFullScreen();}else if(document.webkitCancelFullScreen){await document.webkitCancelFullScreen();}}
this.state.isFullscreen=false;}
onFullScreenChange(){this.state.isFullscreen=Boolean(document.webkitFullscreenElement||document.fullscreenElement);}}
return __exports;});;

/* /mail/static/src/discuss/call/common/call_action_list.js */
odoo.define('@mail/discuss/call/common/call_action_list',['@odoo/owl','@web/core/browser/feature_detection','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/l10n/translation','@web/core/utils/hooks','@mail/discuss/call/common/call_actions'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{isMobileOS}=require("@web/core/browser/feature_detection");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{useCallActions}=require("@mail/discuss/call/common/call_actions");const CallActionList=__exports.CallActionList=class CallActionList extends Component{static components={Dropdown,DropdownItem};static props=["thread","fullscreen","compact?"];static template="discuss.CallActionList";setup(){super.setup();this.store=useState(useService("mail.store"));this.rtc=useState(useService("discuss.rtc"));this.callActions=useCallActions();}
get MORE(){return _t("More");}
get isOfActiveCall(){return Boolean(this.props.thread.eq(this.rtc.state?.channel));}
get isSmall(){return Boolean(this.props.compact&&!this.props.fullscreen.isActive);}
get isMobileOS(){return isMobileOS();}
async onClickRejectCall(ev){if(this.rtc.state.hasPendingRequest){return;}
await this.rtc.leaveCall(this.props.thread);}
async onClickToggleAudioCall(ev,{camera=false}={}){await this.rtc.toggleCall(this.props.thread,{camera,fullscreen:this.props.fullscreen});}}
return __exports;});;

/* /mail/static/src/discuss/call/common/call_actions.js */
odoo.define('@mail/discuss/call/common/call_actions',['@odoo/owl','@web/core/browser/feature_detection','@web/core/l10n/translation','@web/core/registry'],function(require){'use strict';let __exports={};const{useComponent,useState}=require("@odoo/owl");const{isBrowserSafari,isMobileOS}=require("@web/core/browser/feature_detection");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const callActionsRegistry=__exports.callActionsRegistry=registry.category("discuss.call/actions");callActionsRegistry.add("mute",{condition:(component)=>component.rtc,name:(component)=>(component.rtc.selfSession.isMute?_t("Unmute"):_t("Mute")),isActive:(component)=>component.rtc.selfSession?.isMute,inactiveIcon:"fa-microphone",icon:"fa-microphone-slash",activeClass:"text-danger",select:(component)=>{if(component.rtc.selfSession.isMute){if(component.rtc.selfSession.isSelfMuted){component.rtc.unmute();}
if(component.rtc.selfSession.isDeaf){component.rtc.undeafen();}}else{component.rtc.mute();}},sequence:10,}).add("deafen",{condition:(component)=>component.rtc,name:(component)=>(component.rtc.selfSession.isDeaf?_t("Undeafen"):_t("Deafen")),isActive:(component)=>component.rtc.selfSession?.isDeaf,inactiveIcon:"fa-headphones",icon:"fa-deaf",activeClass:"text-danger",select:(component)=>component.rtc.selfSession.isDeaf?component.rtc.undeafen():component.rtc.deafen(),sequence:20,}).add("camera-on",{condition:(component)=>component.rtc,name:(component)=>component.rtc.selfSession.isCameraOn?_t("Stop camera"):_t("Turn camera on"),isActive:(component)=>component.rtc.selfSession?.isCameraOn,icon:"fa-video-camera",activeClass:"text-success",select:(component)=>component.rtc.toggleVideo("camera"),sequence:30,}).add("raise-hand",{condition:(component)=>component.rtc,name:(component)=>component.rtc.selfSession.raisingHand?_t("Lower Hand"):_t("Raise Hand"),isActive:(component)=>component.rtc.selfSession?.raisingHand,icon:"fa-hand-paper-o",select:(component)=>component.rtc.raiseHand(!component.rtc.selfSession.raisingHand),sequence:50,}).add("share-screen",{condition:(component)=>component.rtc&&!isMobileOS(),name:(component)=>component.rtc.selfSession.isScreenSharingOn?_t("Stop Sharing Screen"):_t("Share Screen"),isActive:(component)=>component.rtc.selfSession?.isScreenSharingOn,icon:"fa-desktop",activeClass:"text-success",select:(component)=>component.rtc.toggleVideo("screen"),sequence:40,}).add("blur-background",{condition:(component)=>!isBrowserSafari()&&component.rtc&&component.rtc.selfSession?.isCameraOn,name:(component)=>component.store.settings.useBlur?_t("Remove Blur"):_t("Blur Background"),isActive:(component)=>component.store?.settings?.useBlur,icon:"fa-photo",select:(component)=>{component.store.settings.useBlur=!component.store.settings.useBlur;},sequence:60,}).add("fullscreen",{condition:(component)=>component.props&&component.props.fullscreen,name:(component)=>component.props.fullscreen.isActive?_t("Exit Fullscreen"):_t("Enter Full Screen"),isActive:(component)=>component.props.fullscreen.isActive,inactiveIcon:"fa-arrows-alt",icon:"fa-compress",select:(component)=>{if(component.props.fullscreen.isActive){component.props.fullscreen.exit();}else{component.props.fullscreen.enter();}},sequence:70,});function transformAction(component,id,action){return{id,get condition(){return action.condition(component);},get name(){return typeof action.name==="function"?action.name(component):action.name;},get isActive(){return action.isActive(component);},inactiveIcon:action.inactiveIcon,get icon(){return typeof action.icon==="function"?action.icon(component):action.icon;},activeClass:action.activeClass,select(){action.select(component);},get sequence(){return typeof action.sequence==="function"?action.sequence(component):action.sequence;},};}
__exports.useCallActions=useCallActions;function useCallActions(){const component=useComponent();const state=useState({actions:[]});state.actions=callActionsRegistry.getEntries().map(([id,action])=>transformAction(component,id,action));return{get actions(){return state.actions.filter((action)=>action.condition).sort((a1,a2)=>a1.sequence-a2.sequence);},};}
return __exports;});;

/* /mail/static/src/discuss/call/common/call_context_menu.js */
odoo.define('@mail/discuss/call/common/call_context_menu',['@odoo/owl','@web/core/browser/browser','@web/core/l10n/translation','@web/core/utils/hooks','@mail/discuss/call/common/rtc_service'],function(require){'use strict';let __exports={};const{Component,onMounted,onWillUnmount,useState}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{CONNECTION_TYPES}=require("@mail/discuss/call/common/rtc_service");const PROTOCOLS_TEXT={host:"HOST",srflx:"STUN",prflx:"STUN",relay:"TURN"};const CallContextMenu=__exports.CallContextMenu=class CallContextMenu extends Component{static props=["rtcSession","close?"];static template="discuss.CallContextMenu";updateStatsTimeout;rtcConnectionTypes=CONNECTION_TYPES;setup(){super.setup();this.store=useState(useService("mail.store"));this.rtc=useState(useService("discuss.rtc"));this.state=useState({downloadStats:{},uploadStats:{},producerStats:{},peerStats:{},});onMounted(()=>{if(!this.env.debug){return;}
this.updateStats();this.updateStatsTimeout=browser.setInterval(()=>this.updateStats(),3000);});onWillUnmount(()=>browser.clearInterval(this.updateStatsTimeout));}
get isSelf(){return this.rtc.selfSession?.eq(this.props.rtcSession);}
get inboundConnectionTypeText(){const candidateType=this.rtc.state.connectionType===CONNECTION_TYPES.SERVER?this.state.downloadStats.remoteCandidateType:this.state.peerStats.remoteCandidateType;return this.formatProtocol(candidateType);}
get outboundConnectionTypeText(){const candidateType=this.rtc.state.connectionType===CONNECTION_TYPES.SERVER?this.state.uploadStats.localCandidateType:this.state.peerStats.localCandidateType;return this.formatProtocol(candidateType);}
get volume(){return this.store.settings.getVolume(this.props.rtcSession);}
formatProtocol(candidateType){if(!candidateType){return _t("no connection");}
return _t("%(candidateType)s (%(protocol)s)",{candidateType,protocol:PROTOCOLS_TEXT[candidateType],});}
async updateStats(){if(this.rtc.selfSession?.eq(this.props.rtcSession)){if(this.rtc.sfuClient){const{uploadStats,downloadStats,...producerStats}=await this.rtc.sfuClient.getStats();if(!uploadStats||!downloadStats){return;}
const formattedUploadStats={};for(const value of uploadStats.values?.()||[]){switch(value.type){case"candidate-pair":if(value.state==="succeeded"&&value.localCandidateId){formattedUploadStats.localCandidateType=uploadStats.get(value.localCandidateId)?.candidateType||"";formattedUploadStats.availableOutgoingBitrate=value.availableOutgoingBitrate;}
break;case"transport":formattedUploadStats.dtlsState=value.dtlsState;formattedUploadStats.iceState=value.iceState;formattedUploadStats.packetsSent=value.packetsSent;break;}}
const formattedDownloadStats={};for(const value of downloadStats.values?.()||[]){switch(value.type){case"candidate-pair":if(value.state==="succeeded"&&value.localCandidateId){formattedDownloadStats.remoteCandidateType=downloadStats.get(value.remoteCandidateId)?.candidateType||"";}
break;case"transport":formattedDownloadStats.dtlsState=value.dtlsState;formattedDownloadStats.iceState=value.iceState;formattedDownloadStats.packetsReceived=value.packetsReceived;break;}}
const formattedProducerStats={};for(const[type,stat]of Object.entries(producerStats)){const currentTypeStats={};for(const value of stat.values()){switch(value.type){case"codec":currentTypeStats.codec=value.mimeType;currentTypeStats.clockRate=value.clockRate;break;}}
formattedProducerStats[type]=currentTypeStats;}
this.state.uploadStats=formattedUploadStats;this.state.downloadStats=formattedDownloadStats;this.state.producerStats=formattedProducerStats;}
return;}
this.state.peerStats=await this.rtc.p2pService.getFormattedStats(this.props.rtcSession.id);}
onChangeVolume(ev){const volume=Number(ev.target.value);this.store.settings.saveVolumeSetting({guestId:this.props.rtcSession?.guestId,partnerId:this.props.rtcSession?.partnerId,volume,});this.props.rtcSession.volume=volume;}}
return __exports;});;

/* /mail/static/src/discuss/call/common/call_invitation.js */
odoo.define('@mail/discuss/call/common/call_invitation',['@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,onWillUnmount,useRef,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const CallInvitation=__exports.CallInvitation=class CallInvitation extends Component{static props=["thread"];static template="discuss.CallInvitation";setup(){super.setup();this.rtc=useService("discuss.rtc");this.ui=useState(useService("ui"));this.state=useState({videoStream:null});this.videoRef=useRef("video");onWillUnmount(()=>{if(!this.state.videoStream){return;}
this.stopTracksOnMediaStream(this.state.videoStream);});}
async onClickAccept(ev,{camera=false}={}){this.props.thread.open();if(this.rtc.state.hasPendingRequest){return;}
await this.rtc.toggleCall(this.props.thread,{camera});}
onClickAvatar(ev){this.props.thread.open();}
get hasRtcSupport(){return Boolean(navigator.mediaDevices&&navigator.mediaDevices.getUserMedia&&window.MediaStream);}
onClickPreviewCamera(){this.enableVideo();}
async enableVideo(){if(!this.hasRtcSupport){return;}
try{this.state.videoStream=await navigator.mediaDevices.getUserMedia({video:true});this.videoRef.el.srcObject=this.state.videoStream;}catch{}}
stopTracksOnMediaStream(mediaStream){if(!mediaStream){return;}
for(const track of mediaStream.getTracks()){track.stop();}}
onClickRefuse(ev){if(this.rtc.state.hasPendingRequest){return;}
this.rtc.leaveCall(this.props.thread);}}
return __exports;});;

/* /mail/static/src/discuss/call/common/call_invitations.js */
odoo.define('@mail/discuss/call/common/call_invitations',['@mail/discuss/call/common/call_invitation','@odoo/owl','@web/core/registry','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{CallInvitation}=require("@mail/discuss/call/common/call_invitation");const{Component,useState}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const CallInvitations=__exports.CallInvitations=class CallInvitations extends Component{static props=[];static components={CallInvitation};static template="discuss.CallInvitations";setup(){super.setup();this.rtc=useState(useService("discuss.rtc"));this.store=useState(useService("mail.store"));}}
const callInvitationsService=__exports.callInvitationsService={dependencies:["discuss.rtc","mail.store"],start(){registry.category("main_components").add("discuss.CallInvitations",{Component:CallInvitations});},};registry.category("services").add("discuss.call_invitations",callInvitationsService);return __exports;});;

/* /mail/static/src/discuss/call/common/call_menu.js */
odoo.define('@mail/discuss/call/common/call_menu',['@odoo/owl','@web/core/registry','@web/core/utils/hooks','@mail/discuss/call/common/call_actions'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{callActionsRegistry,useCallActions}=require("@mail/discuss/call/common/call_actions");const CallMenu=__exports.CallMenu=class CallMenu extends Component{static props=[];static template="discuss.CallMenu";setup(){super.setup();this.rtc=useState(useService("discuss.rtc"));this.callActions=useCallActions();this.isEnterprise=odoo.info&&odoo.info.isEnterprise;}
get icon(){return(callActionsRegistry.get(this.rtc.lastSelfCallAction,undefined)?.icon??"fa-microphone");}}
registry.category("systray").add("discuss.CallMenu",{Component:CallMenu},{sequence:100});return __exports;});;

/* /mail/static/src/discuss/call/common/call_participant_card.js */
odoo.define('@mail/discuss/call/common/call_participant_card',['@mail/discuss/call/common/call_context_menu','@mail/discuss/call/common/call_participant_video','@mail/discuss/call/common/rtc_service','@mail/utils/common/hooks','@web/core/utils/misc','@web/core/browser/browser','@odoo/owl','@web/core/popover/popover_hook','@web/core/utils/hooks','@web/core/network/rpc'],function(require){'use strict';let __exports={};const{CallContextMenu}=require("@mail/discuss/call/common/call_context_menu");const{CallParticipantVideo}=require("@mail/discuss/call/common/call_participant_video");const{CONNECTION_TYPES}=require("@mail/discuss/call/common/rtc_service");const{useHover}=require("@mail/utils/common/hooks");const{isEventHandled,markEventHandled}=require("@web/core/utils/misc");const{browser}=require("@web/core/browser/browser");const{Component,onMounted,onWillUnmount,useRef,useState,useExternalListener,}=require("@odoo/owl");const{usePopover}=require("@web/core/popover/popover_hook");const{useService}=require("@web/core/utils/hooks");const{rpc}=require("@web/core/network/rpc");const HIDDEN_CONNECTION_STATES=new Set([undefined,"connected","completed"]);const CallParticipantCard=__exports.CallParticipantCard=class CallParticipantCard extends Component{static props=["className","cardData","thread","minimized?","inset?"];static components={CallParticipantVideo};static template="discuss.CallParticipantCard";setup(){super.setup();this.contextMenuAnchorRef=useRef("contextMenuAnchor");this.root=useRef("root");this.popover=usePopover(CallContextMenu);this.rtc=useState(useService("discuss.rtc"));this.store=useState(useService("mail.store"));this.ui=useState(useService("ui"));this.rootHover=useHover("root");this.dragPos=undefined;this.isDrag=false;this.parentBoundingRect=undefined;onMounted(()=>{if(!this.rtcSession){return;}
this.rtc.updateVideoDownload(this.rtcSession,{viewCountIncrement:1,});});onWillUnmount(()=>{if(!this.rtcSession){return;}
this.rtc.updateVideoDownload(this.rtcSession,{viewCountIncrement:-1,});});useExternalListener(browser,"fullscreenchange",this.onFullScreenChange);}
get isContextMenuAvailable(){if(!this.rtcSession){return false;}
return(!this.rtcSession.eq(this.rtc.selfSession)||(this.env.debug&&this.rtc.state.connectionType===CONNECTION_TYPES.SERVER));}
get rtcSession(){return this.props.cardData.session;}
get channelMember(){return this.rtcSession?this.rtcSession.channelMember:this.props.cardData.member;}
get isOfActiveCall(){return Boolean(this.rtcSession&&this.rtcSession.channel?.eq(this.rtc.state.channel));}
get showConnectionState(){if(!this.rtcSession||!this.isOfActiveCall||HIDDEN_CONNECTION_STATES.has(this.rtcSession.connectionState)){return false;}
if(this.rtc.state.connectionType===CONNECTION_TYPES.SERVER){return this.rtcSession.eq(this.rtc?.selfSession);}else{return this.rtcSession.notEq(this.rtc?.selfSession);}}
get showServerState(){return false;}
get name(){return this.channelMember?.persona.name;}
get hasMediaError(){return(this.isOfActiveCall&&Boolean(this.rtcSession?.videoError||this.rtcSession?.audioError));}
get hasVideo(){return Boolean(this.props.cardData.videoStream);}
get isTalking(){return Boolean(this.rtcSession&&this.rtcSession.isActuallyTalking&&!this.rtc.selfSession?.isDeaf);}
get hasRaisingHand(){const screenStream=this.rtcSession.videoStreams.get("screen");return Boolean(this.rtcSession.raisingHand&&(!screenStream||screenStream!==this.props.cardData.videoStream));}
async onClick(ev){if(isEventHandled(ev,"CallParticipantCard.clickVolumeAnchor")){return;}
if(this.isDrag){this.isDrag=false;return;}
if(this.rtcSession){const channel=this.rtcSession.channel;this.rtcSession.mainVideoStreamType=this.props.cardData.type;if(this.rtcSession.eq(channel.activeRtcSession)&&!this.props.inset){channel.activeRtcSession=undefined;this.rtcSession.mainVideoStreamType=undefined;}else{const activeRtcSession=channel.activeRtcSession;const currentMainVideoType=this.rtcSession.mainVideoStreamType;channel.activeRtcSession=this.rtcSession;if(this.props.inset&&activeRtcSession){this.props.inset(activeRtcSession,currentMainVideoType);}}
return;}
await rpc("/mail/rtc/channel/cancel_call_invitation",{channel_id:this.props.thread.id,member_ids:[this.channelMember.id],});}
async onClickReplay(){this.env.bus.trigger("RTC-SERVICE:PLAY_MEDIA");}
onContextMenu(ev){ev.preventDefault();markEventHandled(ev,"CallParticipantCard.clickVolumeAnchor");if(this.popover.isOpen){this.popover.close();return;}
if(!this.contextMenuAnchorRef?.el){return;}
this.popover.open(this.contextMenuAnchorRef.el,{rtcSession:this.rtcSession,});}
onMouseDown(){if(!this.props.inset){return;}
const onMousemove=(ev)=>this.drag(ev);const onMouseup=()=>{const insetEl=this.root.el;const bottomOffset=this.env.inChatWindow?window.innerHeight*0.05:0;if(parseInt(insetEl.style.left)<insetEl.parentNode.offsetWidth/2){insetEl.style.left="1vh";insetEl.style.right="";}else{insetEl.style.left="";insetEl.style.right="1vh";}
if(parseInt(insetEl.style.top)<(insetEl.parentNode.offsetHeight-bottomOffset)/2){insetEl.style.top="1vh";insetEl.style.bottom="";}else{insetEl.style.bottom=this.env.inChatWindow?"5vh":"1vh";insetEl.style.top="unset";}
this.dragPos=undefined;this.parentBoundingRect=undefined;document.removeEventListener("mouseup",onMouseup);document.removeEventListener("mousemove",onMousemove);};document.addEventListener("mouseup",onMouseup);document.addEventListener("mousemove",onMousemove);}
onTouchMove(ev){if(!this.props.inset){return;}
this.drag(ev);}
drag(ev){this.isDrag=true;const insetEl=this.root.el;const parent=insetEl.parentNode;const boundingRect=this.parentBoundingRect||(this.parentBoundingRect=parent.getBoundingClientRect());const bottomOffset=this.env.inChatWindow?window.innerHeight*0.05:0;const clientX=Math.max((ev.clientX??ev.touches[0].clientX)-boundingRect.left,0);const clientY=Math.max((ev.clientY??ev.touches[0].clientY)-boundingRect.top,0);if(!this.dragPos){this.dragPos={posX:clientX,posY:clientY};}
const dX=this.dragPos.posX-clientX;const dY=this.dragPos.posY-clientY;const widthOffset=parent.offsetWidth-insetEl.clientWidth;const heightOffset=parent.offsetHeight-insetEl.clientHeight-bottomOffset;this.dragPos.posX=Math.min(clientX,widthOffset);this.dragPos.posY=Math.min(clientY,heightOffset);insetEl.style.left=Math.min(Math.max(insetEl.offsetLeft-dX,0),widthOffset)+"px";insetEl.style.top=Math.min(Math.max(insetEl.offsetTop-dY,0),heightOffset)+"px";}
onFullScreenChange(){this.root.el.style="left:''; top:''";}}
return __exports;});;

/* /mail/static/src/discuss/call/common/call_participant_video.js */
odoo.define('@mail/discuss/call/common/call_participant_video',['@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,onMounted,onPatched,status,useExternalListener,useRef,useState,}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const CallParticipantVideo=__exports.CallParticipantVideo=class CallParticipantVideo extends Component{static props=["session","type","inset?"];static template="discuss.CallParticipantVideo";setup(){super.setup();this.rtc=useState(useService("discuss.rtc"));this.root=useRef("root");onMounted(()=>this._update());onPatched(()=>this._update());useExternalListener(this.env.bus,"RTC-SERVICE:PLAY_MEDIA",async()=>{await this.play();});}
_update(){if(!this.root.el){return;}
if(!this.props.session||!this.props.session.getStream(this.props.type)){this.root.el.srcObject=undefined;}else{this.root.el.srcObject=this.props.session.getStream(this.props.type);}
this.root.el.load();}
async play(){try{await this.root.el?.play?.();this.props.session.videoError=undefined;}catch(error){if(status(this)==="destroyed"){return;}
this.props.session.videoError=error.name;}}
async onVideoLoadedMetaData(){await this.play();}}
return __exports;});;

/* /mail/static/src/discuss/call/common/call_settings.js */
odoo.define('@mail/discuss/call/common/call_settings',['@odoo/owl','@web/core/l10n/translation','@web/core/browser/browser','@web/core/utils/timing','@web/core/browser/feature_detection','@web/core/utils/hooks','@mail/discuss/core/common/action_panel'],function(require){'use strict';let __exports={};const{Component,onWillStart,useExternalListener,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{debounce}=require("@web/core/utils/timing");const{isMobileOS}=require("@web/core/browser/feature_detection");const{useService}=require("@web/core/utils/hooks");const{ActionPanel}=require("@mail/discuss/core/common/action_panel");const CallSettings=__exports.CallSettings=class CallSettings extends Component{static template="discuss.CallSettings";static props=["withActionPanel?","*"];static defaultProps={withActionPanel:true,};static components={ActionPanel};setup(){super.setup();this.notification=useService("notification");this.store=useState(useService("mail.store"));this.rtc=useState(useService("discuss.rtc"));this.state=useState({userDevices:[],});this.pttExtService=useState(useService("discuss.ptt_extension"));this.saveBackgroundBlurAmount=debounce(()=>{browser.localStorage.setItem("mail_user_setting_background_blur_amount",this.store.settings.backgroundBlurAmount.toString());},2000);this.saveEdgeBlurAmount=debounce(()=>{browser.localStorage.setItem("mail_user_setting_edge_blur_amount",this.store.settings.edgeBlurAmount.toString());},2000);useExternalListener(browser,"keydown",this._onKeyDown,{capture:true});useExternalListener(browser,"keyup",this._onKeyUp,{capture:true});onWillStart(async()=>{if(!browser.navigator.mediaDevices){this.notification.add(_t("Media devices unobtainable. SSL might not be set up properly."),{type:"warning"});console.warn("Media devices unobtainable. SSL might not be set up properly.");return;}
this.state.userDevices=await browser.navigator.mediaDevices.enumerateDevices();});}
get pushToTalkKeyText(){const{shiftKey,ctrlKey,altKey,key}=this.store.settings.pushToTalkKeyFormat();const f=(k,name)=>(k?name:"");const keys=[f(ctrlKey,"Ctrl"),f(altKey,"Alt"),f(shiftKey,"Shift"),key].filter(Boolean);return keys.join(" + ");}
get isMobileOS(){return isMobileOS();}
_onKeyDown(ev){if(!this.store.settings.isRegisteringKey){return;}
ev.stopPropagation();ev.preventDefault();this.store.settings.setPushToTalkKey(ev);}
_onKeyUp(ev){if(!this.store.settings.isRegisteringKey){return;}
ev.stopPropagation();ev.preventDefault();this.store.settings.isRegisteringKey=false;}
onChangeLogRtc(ev){this.store.settings.logRtc=ev.target.checked;}
onChangeSelectAudioInput(ev){this.store.settings.setAudioInputDevice(ev.target.value);}
onClickDownloadLogs(){this.rtc.logSnapshot();const data=JSON.stringify(this.rtc.state.globalLogs);const blob=new Blob([data],{type:"application/json"});const downloadLink=document.createElement("a");const now=luxon.DateTime.now().toFormat("yyyy-ll-dd_HH-mm");downloadLink.download=`RtcLogs_${now}.json`;const url=URL.createObjectURL(blob);downloadLink.href=url;downloadLink.click();URL.revokeObjectURL(url);}
onClickRegisterKeyButton(){this.store.settings.isRegisteringKey=!this.store.settings.isRegisteringKey;}
onChangeDelay(ev){this.store.settings.setDelayValue(ev.target.value);}
onChangeThreshold(ev){this.store.settings.setThresholdValue(parseFloat(ev.target.value));}
onChangeBlur(ev){this.store.settings.useBlur=ev.target.checked;browser.localStorage.setItem("mail_user_setting_use_blur",this.store.settings.useBlur);}
onChangeShowOnlyVideo(ev){const showOnlyVideo=ev.target.checked;this.store.settings.showOnlyVideo=showOnlyVideo;browser.localStorage.setItem("mail_user_setting_show_only_video",this.store.settings.showOnlyVideo);const activeRtcSessions=this.store.allActiveRtcSessions;if(showOnlyVideo&&activeRtcSessions){activeRtcSessions.filter((rtcSession)=>!rtcSession.videoStream).forEach((rtcSession)=>{rtcSession.channel.activeRtcSession=undefined;});}}
onChangeBackgroundBlurAmount(ev){this.store.settings.backgroundBlurAmount=Number(ev.target.value);this.saveBackgroundBlurAmount();}
onChangeEdgeBlurAmount(ev){this.store.settings.edgeBlurAmount=Number(ev.target.value);this.saveEdgeBlurAmount();}}
return __exports;});;

/* /mail/static/src/discuss/call/common/channel_member_patch.js */
odoo.define('@mail/discuss/call/common/channel_member_patch',['@mail/core/common/channel_member_model','@mail/core/common/record','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ChannelMember}=require("@mail/core/common/channel_member_model");const{Record}=require("@mail/core/common/record");const{patch}=require("@web/core/utils/patch");const ChannelMemberPatch={setup(){super.setup(...arguments);this.rtcSession=Record.one("RtcSession");},};patch(ChannelMember.prototype,ChannelMemberPatch);return __exports;});;

/* /mail/static/src/discuss/call/common/chat_window_patch.js */
odoo.define('@mail/discuss/call/common/chat_window_patch',['@mail/core/common/chat_window','@mail/discuss/call/common/call'],function(require){'use strict';let __exports={};const{ChatWindow}=require("@mail/core/common/chat_window");const{Call}=require("@mail/discuss/call/common/call");Object.assign(ChatWindow.components,{Call});return __exports;});;

/* /mail/static/src/discuss/call/common/discuss_call_settings_client_action.js */
odoo.define('@mail/discuss/call/common/discuss_call_settings_client_action',['@odoo/owl','@web/core/registry','@mail/discuss/call/common/call_settings'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{CallSettings}=require("@mail/discuss/call/common/call_settings");const DiscussCallSettingsClientAction=__exports.DiscussCallSettingsClientAction=class DiscussCallSettingsClientAction extends Component{static components={CallSettings};static props=["*"];static template="mail.DiscussCallSettingsClientAction";}
registry.category("actions").add("mail.discuss_call_settings_action",DiscussCallSettingsClientAction);return __exports;});;

/* /mail/static/src/discuss/call/common/discuss_p2p_service.js */
odoo.define('@mail/discuss/call/common/discuss_p2p_service',['@web/core/registry','@mail/discuss/call/common/peer_to_peer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{PeerToPeer}=require("@mail/discuss/call/common/peer_to_peer");const discussP2P=__exports.discussP2P={dependencies:["bus_service"],start(env,services){const p2p=new PeerToPeer({notificationRoute:"/mail/rtc/session/notify_call_members"});services["bus_service"].subscribe("discuss.channel.rtc.session/peer_notification",({sender,notifications})=>{for(const content of notifications){p2p.handleNotification(sender,content);}});return p2p;},};registry.category("services").add("discuss.p2p",discussP2P);return __exports;});;

/* /mail/static/src/discuss/call/common/media_monitoring.js */
odoo.define('@mail/discuss/call/common/media_monitoring',[],function(require){'use strict';let __exports={};const HUMAN_VOICE_FREQUENCY_RANGE=[80,1000];__exports.monitorAudio=monitorAudio;async function monitorAudio(track,processorOptions){const monitoredTrack=track.clone();monitoredTrack.enabled=true;const stream=new window.MediaStream([monitoredTrack]);const AudioContext=window.AudioContext||window.webkitAudioContext;if(!AudioContext){throw"missing audio context";}
const audioContext=new AudioContext();const source=audioContext.createMediaStreamSource(stream);let processor;try{processor=await _loadAudioWorkletProcessor(source,audioContext,processorOptions);}catch{processor=_loadScriptProcessor(source,audioContext,processorOptions);}
return async()=>{processor.disconnect();source.disconnect();monitoredTrack.stop();try{await audioContext.close();}catch(e){if(e.name==="InvalidStateError"){return;}
throw e;}};}
function _loadScriptProcessor(source,audioContext,{frequencyRange=HUMAN_VOICE_FREQUENCY_RANGE,minimumActiveCycles=30,onThreshold,onTic,volumeThreshold=0.3,}={}){const bitSize=1024;const analyser=audioContext.createAnalyser();source.connect(analyser);const scriptProcessorNode=audioContext.createScriptProcessor(bitSize,1,1);analyser.connect(scriptProcessorNode);analyser.fftsize=bitSize;scriptProcessorNode.connect(audioContext.destination);const processInterval=50;const intervalInFrames=(processInterval/1000)*analyser.context.sampleRate;let nextUpdateFrame=processInterval;let activityBuffer=0;let wasAboveThreshold=undefined;let isAboveThreshold=false;scriptProcessorNode.onaudioprocess=()=>{nextUpdateFrame-=bitSize;if(nextUpdateFrame>=0){return;}
nextUpdateFrame+=intervalInFrames;const normalizedVolume=getFrequencyAverage(analyser,frequencyRange[0],frequencyRange[1]);if(normalizedVolume>=volumeThreshold){activityBuffer=minimumActiveCycles;}else if(normalizedVolume<volumeThreshold&&activityBuffer>0){activityBuffer--;}
isAboveThreshold=activityBuffer>0;onTic?.(normalizedVolume);if(wasAboveThreshold!==isAboveThreshold){wasAboveThreshold=isAboveThreshold;onThreshold?.(isAboveThreshold);}};return{disconnect:()=>{analyser.disconnect();scriptProcessorNode.disconnect();scriptProcessorNode.onaudioprocess=null;},};}
async function _loadAudioWorkletProcessor(source,audioContext,{frequencyRange=HUMAN_VOICE_FREQUENCY_RANGE,minimumActiveCycles=10,onThreshold,onTic,volumeThreshold=0.3,}={}){await audioContext.resume();await audioContext.audioWorklet.addModule("/mail/rtc/audio_worklet_processor");const thresholdProcessor=new window.AudioWorkletNode(audioContext,"audio-processor",{processorOptions:{minimumActiveCycles,volumeThreshold,frequencyRange,postAllTics:!!onTic,},});source.connect(thresholdProcessor);thresholdProcessor.port.onmessage=(event)=>{const{isAboveThreshold,volume}=event.data;if(isAboveThreshold!==undefined){onThreshold?.(isAboveThreshold);}
if(volume!==undefined){onTic?.(volume);}};return{disconnect:()=>{thresholdProcessor.disconnect();},};}
function getFrequencyAverage(analyser,lowerFrequency,higherFrequency){const frequencies=new window.Uint8Array(analyser.frequencyBinCount);analyser.getByteFrequencyData(frequencies);const sampleRate=analyser.context.sampleRate;const startIndex=_getFrequencyIndex(lowerFrequency,sampleRate,analyser.frequencyBinCount);const endIndex=_getFrequencyIndex(higherFrequency,sampleRate,analyser.frequencyBinCount);const count=endIndex-startIndex;let sum=0;for(let index=startIndex;index<endIndex;index++){sum+=frequencies[index]/255;}
if(!count){return 0;}
return sum/count;}
function _getFrequencyIndex(targetFrequency,sampleRate,binCount){const index=Math.round((targetFrequency/(sampleRate/2))*binCount);return Math.min(Math.max(0,index),binCount);}
return __exports;});;

/* /mail/static/src/discuss/call/common/peer_to_peer.js */
odoo.define('@mail/discuss/call/common/peer_to_peer',['@web/core/network/rpc','@web/core/utils/concurrency','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{Deferred}=require("@web/core/utils/concurrency");const{browser}=require("@web/core/browser/browser");const STREAM_TYPE=__exports.STREAM_TYPE=Object.freeze({AUDIO:"audio",CAMERA:"camera",SCREEN:"screen",});const UPDATE_EVENT=__exports.UPDATE_EVENT=Object.freeze({BROADCAST:"broadcast",CONNECTION_CHANGE:"connection_change",DISCONNECT:"disconnect",INFO_CHANGE:"info_change",TRACK:"track",});const LOG_LEVEL=Object.freeze({NONE:"none",DEBUG:"debug",INFO:"info",WARN:"warn",ERROR:"error",});const INTERNAL_EVENT=Object.freeze({ANSWER:"answer",BROADCAST:"broadcast",DISCONNECT:"disconnect",ICE_CANDIDATE:"ice-candidate",INFO:"info",OFFER:"offer",TRACK_CHANGE:"trackChange",});const ORDERED_TRANSCEIVER_TYPES=[STREAM_TYPE.AUDIO,STREAM_TYPE.CAMERA,STREAM_TYPE.SCREEN];const DEFAULT_BUS_BATCH_DELAY=100;const INITIAL_RECONNECT_DELAY=2_000+Math.random()*1_000;const MAXIMUM_RECONNECT_DELAY=25_000+Math.random()*5_000;const INVALID_ICE_CONNECTION_STATES=new Set(["disconnected","failed","closed"]);const IS_CLIENT_RTC_COMPATIBLE=Boolean(window.RTCPeerConnection&&window.MediaStream);const DEFAULT_ICE_SERVERS=[{urls:["stun:stun1.l.google.com:19302","stun:stun2.l.google.com:19302"]},];const DEFAULT_NOTIFICATION_ROUTE="/mail/rtc/session/notify_call_members";const Peer=__exports.Peer=class Peer{id;connection;connectRetryDelay=INITIAL_RECONNECT_DELAY;sequence=0;dataChannel;hasPriority=false;isBuildingOffer=false;isBuildingAnswer=false;medias=Object.seal({[STREAM_TYPE.AUDIO]:{track:null,active:false,accepted:true,},[STREAM_TYPE.SCREEN]:{track:null,active:false,accepted:true,},[STREAM_TYPE.CAMERA]:{track:null,active:false,accepted:true,},});constructor(id,{connection,dataChannel,hasPriority=false,connectRetryDelay=INITIAL_RECONNECT_DELAY,sequence=0,}){this.id=id;this.connection=connection;this.dataChannel=dataChannel;this.hasPriority=hasPriority;this.connectRetryDelay=connectRetryDelay;this.sequence=sequence;this.ready=new Deferred();}
disconnect(){if(this.connection){const RTCRtpSenders=this.connection.getSenders();for(const sender of RTCRtpSenders){try{this.connection.removeTrack(sender);}catch{}}
for(const transceiver of this.connection.getTransceivers()){try{transceiver.stop();}catch{}}}
this.ready.resolve?.();this.connection?.close();this.connection=undefined;this.dataChannel?.close();this.dataChannel=undefined;for(const media of Object.values(this.medias)){media.track?.stop();}}
getRecommendedTransceiverDirection(streamType,canUpload=false){if(this.medias[streamType].accepted){return canUpload?"sendrecv":"recvonly";}else{return canUpload?"sendonly":"inactive";}}
getTransceiver(streamType){if(!this.connection){return;}
const transceivers=this.connection.getTransceivers();return transceivers[ORDERED_TRANSCEIVER_TYPES.indexOf(streamType)];}
getTransceiverStreamType(transceiver){const transceivers=this.connection.getTransceivers();return ORDERED_TRANSCEIVER_TYPES[transceivers.indexOf(transceiver)];}}
const PeerToPeer=__exports.PeerToPeer=class PeerToPeer extends EventTarget{selfId;channelId;peers=new Map();acceptOffer=async(id,sequence)=>true;_batchDelay=DEFAULT_BUS_BATCH_DELAY;_localInfo=Object.seal({isSelfMuted:false,isRaisingHand:false,isDeaf:false,isTalking:false,isCameraOn:false,isScreenSharingOn:false,});_iceServers;_isPendingNotify=false;_notificationsToSend=new Map();_isAntiGlareEnabled=true;_tmpNotificationId=0;_recoverTimeouts=new Map();_notificationRoute;_isStreamingEnabled=true;_tracks=Object.seal({[STREAM_TYPE.AUDIO]:null,[STREAM_TYPE.SCREEN]:null,[STREAM_TYPE.CAMERA]:null,});_loggingFunctions={[LOG_LEVEL.DEBUG]:()=>{},[LOG_LEVEL.INFO]:()=>{},[LOG_LEVEL.WARN]:()=>{},[LOG_LEVEL.ERROR]:()=>{},};get isActive(){return Boolean(this.selfId!==undefined&&this.channelId!==undefined);}
constructor({notificationRoute=DEFAULT_NOTIFICATION_ROUTE,logLevel=LOG_LEVEL.WARN,batchDelay=DEFAULT_BUS_BATCH_DELAY,antiGlare=true,enableStreaming=true,}={}){super();this._isStreamingEnabled=enableStreaming;this._isAntiGlareEnabled=antiGlare;this._notificationRoute=notificationRoute;this._batchDelay=batchDelay;this.setLoggingLevel(logLevel);}
connect(selfId,channelId,{info={},iceServers=DEFAULT_ICE_SERVERS}={}){if(!IS_CLIENT_RTC_COMPATIBLE){throw new Error("RTCPeerConnection is not supported");}
this.selfId=selfId;this.channelId=channelId;this._iceServers=iceServers;this._localInfo=Object.assign(this._localInfo,info);}
removeALlPeers(){for(const peer of this.peers.values()){this.removePeer(peer.id);}
this.peers.clear();}
disconnect(){this.removeALlPeers();this.selfId=undefined;this.channelId=undefined;this._isPendingNotify=false;this._notificationsToSend.clear();this._localInfo=Object.assign(this._localInfo,{isSelfMuted:false,isRaisingHand:false,isDeaf:false,isTalking:false,isCameraOn:false,isScreenSharingOn:false,});}
async addPeer(id,options={}){const peer=this.peers.get(id);if(peer){return peer;}
const newPeer=this._createPeer(id,options);await newPeer.ready;return newPeer;}
removePeer(id){const recoverTimeoutId=this._recoverTimeouts.get(id);browser.clearTimeout(recoverTimeoutId);this._recoverTimeouts.delete(id);const peer=this.peers.get(id);if(!peer){return;}
this.peers.delete(id);peer.disconnect();}
broadcast(message){this._dataChannelBroadcast(INTERNAL_EVENT.BROADCAST,message);}
async getFormattedStats(id){const peer=this.peers.get(id);const formattedStats={};if(!peer){return formattedStats;}
formattedStats.connectionState=peer.connection.connectionState;formattedStats.iceConnectionState=peer.connection.iceConnectionState;formattedStats.iceGatheringState=peer.connection.iceGatheringState;const stats=await peer.connection.getStats();for(const value of stats?.values()||[]){switch(value.type){case"candidate-pair":if(value.state==="succeeded"&&value.localCandidateId){formattedStats.localCandidateType=stats.get(value.localCandidateId)?.candidateType||"";formattedStats.remoteCandidateType=stats.get(value.remoteCandidateId)?.candidateType||"";}
break;case"data-channel":formattedStats.dataChannelState=value.state;break;case"transport":formattedStats.dtlsState=value.dtlsState;formattedStats.iceState=value.iceState;formattedStats.packetsReceived=value.packetsReceived;formattedStats.packetsSent=value.packetsSent;break;}}
return formattedStats;}
updateDownload(id,states){const peer=this.peers.get(id);if(!peer){return;}
for(const[streamType,accepted]of Object.entries(states)){peer.medias[streamType].accepted=accepted;const transceiver=peer.getTransceiver(streamType);if(!transceiver){this._recover(id,`no transceiver available when updating direction`);return;}
transceiver.direction=peer.getRecommendedTransceiverDirection(streamType,Boolean(this._tracks[streamType]));}}
async updateUpload(streamType,track){this._tracks[streamType]=track||null;this.updateInfo({isScreenSharingOn:Boolean(this._tracks[STREAM_TYPE.SCREEN]),isCameraOn:Boolean(this._tracks[STREAM_TYPE.CAMERA]),});const proms=[];for(const peer of this.peers.values()){proms.push(peer.ready.then(()=>this._updateRemote(peer,streamType)));}
await Promise.all(proms);}
updateInfo(info){this._localInfo=Object.assign(this._localInfo,info);this._dataChannelBroadcast(INTERNAL_EVENT.INFO,this._localInfo);}
async handleNotification(id,content){const{event,channelId,payload}=JSON.parse(content);this._emitLog(id,`received notification: ${event}`,LOG_LEVEL.DEBUG);if(channelId!==this.channelId){return;}
let peer=this.peers.get(id);if(event!==INTERNAL_EVENT.OFFER&&!peer?.connection){this._emitLog(id,`received ${event} for missing peer ${id}`,LOG_LEVEL.WARN);return;}
switch(event){case INTERNAL_EVENT.ANSWER:{this._emitLog(id,`received answer`,LOG_LEVEL.DEBUG);if(INVALID_ICE_CONNECTION_STATES.has(peer.connection.iceConnectionState)||peer.connection.signalingState==="stable"||peer.connection.signalingState==="have-remote-offer"){return;}
const description=new window.RTCSessionDescription(payload.sdp);try{await peer.connection.setRemoteDescription(description);}catch{this._recover(id,"answer handling: Failed at setting remoteDescription");}
break;}
case INTERNAL_EVENT.BROADCAST:{this._emitUpdate({name:UPDATE_EVENT.BROADCAST,payload:{senderId:id,message:payload},});peer.ready.resolve(true);break;}
case INTERNAL_EVENT.DISCONNECT:{this.removePeer(id);this._emitUpdate({name:UPDATE_EVENT.DISCONNECT,payload:{sessionId:id}});break;}
case INTERNAL_EVENT.ICE_CANDIDATE:{if(INVALID_ICE_CONNECTION_STATES.has(peer.connection.iceConnectionState)){return;}
const rtcIceCandidate=new window.RTCIceCandidate(payload.candidate);try{await peer.connection.addIceCandidate(rtcIceCandidate);}catch{this._recover(id,"failed at adding ice candidate");}
break;}
case INTERNAL_EVENT.INFO:{const{isTalking,isCameraOn,isScreenSharingOn}=payload;peer.medias[STREAM_TYPE.AUDIO].active=isTalking;peer.medias[STREAM_TYPE.CAMERA].active=isCameraOn;peer.medias[STREAM_TYPE.SCREEN].active=isScreenSharingOn;this._emitUpdate({name:UPDATE_EVENT.INFO_CHANGE,payload:{[id]:payload},});break;}
case INTERNAL_EVENT.OFFER:{try{const accepted=await this.acceptOffer(id,payload.sequence);if(!accepted){this._emitLog(id,"offer rejected",LOG_LEVEL.INFO);return;}}catch(error){this._emitLog(id,`offer rejected: ${error}`,LOG_LEVEL.INFO);}
if(!peer){peer=this._createPeer(id,{sequence:payload.sequence});}
if(INVALID_ICE_CONNECTION_STATES.has(peer.connection.iceConnectionState)||peer.connection.signalingState==="have-remote-offer"){return;}
const isStable=peer.connection.signalingState==="stable"||peer.isBuildingAnswer;const hasOfferCollision=!isStable||peer.isBuildingOffer;if(hasOfferCollision&&peer.hasPriority&&this._isAntiGlareEnabled){this._emitLog(peer.id,`rolling back due to offer collision: ${peer.connection.signalingState}`,LOG_LEVEL.WARN);try{await peer.connection.setLocalDescription({type:"rollback"});}catch{this._recover(id,`failed rollback`);}}
const description=new window.RTCSessionDescription(payload.sdp);try{await peer.connection.setRemoteDescription(description);}catch{this._recover(id,"failed at setting remoteDescription");return;}
if(this._isStreamingEnabled){if(peer.connection.getTransceivers().length===0){for(const streamType of ORDERED_TRANSCEIVER_TYPES){const type=streamType===STREAM_TYPE.AUDIO?"audio":"video";peer.connection.addTransceiver(type);}}
for(const transceiverName of ORDERED_TRANSCEIVER_TYPES){await this._updateRemote(peer,transceiverName);}}
peer.isBuildingAnswer=true;try{await peer.connection.setLocalDescription(await peer.connection.createAnswer());}catch{peer.isBuildingAnswer=false;this._recover(id,"offer handling: failed at setting answer localDescription");return;}
peer.isBuildingAnswer=false;if(!this.isActive||!this.peers.has(id)){return;}
this._emitLog(id,`sending answer`,LOG_LEVEL.DEBUG);await this._busNotify(INTERNAL_EVENT.ANSWER,{payload:{sdp:peer.connection.localDescription,},targets:[peer.id],});this._recover(peer.id,"standard answer timeout");break;}}}
setLoggingLevel(logLevel){const makeLog=(level)=>(id,message)=>{this.dispatchEvent(new CustomEvent("log",{detail:{id,level,message}}));};this._loggingFunctions={[LOG_LEVEL.DEBUG]:()=>{},[LOG_LEVEL.INFO]:()=>{},[LOG_LEVEL.WARN]:()=>{},[LOG_LEVEL.ERROR]:()=>{},};switch(logLevel){case LOG_LEVEL.DEBUG:this._loggingFunctions[LOG_LEVEL.DEBUG]=makeLog(LOG_LEVEL.DEBUG);case LOG_LEVEL.INFO:this._loggingFunctions[LOG_LEVEL.INFO]=makeLog(LOG_LEVEL.INFO);case LOG_LEVEL.WARN:this._loggingFunctions[LOG_LEVEL.WARN]=makeLog(LOG_LEVEL.WARN);case LOG_LEVEL.ERROR:this._loggingFunctions[LOG_LEVEL.ERROR]=makeLog(LOG_LEVEL.ERROR);}}
_dataChannelBroadcast(internalEvent,message){for(const peer of this.peers.values()){if(!peer?.dataChannel||peer?.dataChannel.readyState!=="open"){continue;}
peer.dataChannel.send(JSON.stringify({event:internalEvent,channelId:this.channelId,payload:message,}));}}
_emitUpdate(detail){this.dispatchEvent(new CustomEvent("update",{detail}));}
_emitLog(id,message,level=LOG_LEVEL.DEBUG){this._loggingFunctions[level](id,message);}
_recover(id,reason=""){this._emitLog(id,`connection recovery candidate: ${reason}`,LOG_LEVEL.WARN);if(this._recoverTimeouts.get(id)){return;}
const peer=this.peers.get(id);if(!peer){return;}
const delay=Math.min(peer.connectRetryDelay*1.5,MAXIMUM_RECONNECT_DELAY)+1000*Math.random();this._recoverTimeouts.set(id,browser.setTimeout(async()=>{const peer=this.peers.get(id);this._recoverTimeouts.delete(id);const connectionSuccess=peer.connection.connectionState==="connected"||peer.connection.connectionState==="completed";const iceSuccess=peer.connection.iceConnectionState==="connected"||peer.connection.iceConnectionState==="completed";if(!peer?.connection||!this.channelId||(connectionSuccess&&iceSuccess)){return;}
this._emitLog(id,`attempting to recover connection: ${reason}`,LOG_LEVEL.ERROR);this._busNotify(INTERNAL_EVENT.DISCONNECT,{targets:[peer.id]});this.removePeer(peer.id);this.addPeer(peer.id,{connectRetryDelay:delay,sequence:peer.sequence});},delay));}
async _sendNotifications(){if(this._isPendingNotify){return;}
this._isPendingNotify=true;await new Promise((resolve)=>setTimeout(resolve,this._batchDelay));if(!this.isActive){this._isPendingNotify=false;return;}
const ids=[];const notifications=[];this._notificationsToSend.forEach((notification,id)=>{ids.push(id);notifications.push([notification.sender,notification.targets,JSON.stringify({event:notification.event,channelId:notification.channelId,payload:notification.payload,}),]);});try{await rpc(this._notificationRoute,{peer_notifications:notifications,},{silent:true});for(const id of ids){this._notificationsToSend.delete(id);}}finally{this._isPendingNotify=false;if(this._notificationsToSend.size>0){await this._sendNotifications();}}}
async _busNotify(event,{payload,targets}={}){targets=targets||Array.from(this.peers.keys());let id;if(event===INTERNAL_EVENT.OFFER){id=`latestOffer_to:${targets[0]}`;}else{id=++this._tmpNotificationId;}
this._notificationsToSend.set(id,{channelId:this.channelId,event,payload,sender:this.selfId,targets,});await this._sendNotifications();}
async _updateRemote(peer,streamType){const track=this._tracks[streamType];const transceiver=peer.getTransceiver(streamType);if(!transceiver){return;}
try{await transceiver.sender.replaceTrack(track);transceiver.direction=peer.getRecommendedTransceiverDirection(streamType,Boolean(track));}catch(error){this._recover(peer.id,`failed to update ${streamType} transceiver for peer ${peer.id}: ${error}`);}}
_createPeer(id,options={}){this.removePeer(id);const peerConnection=new window.RTCPeerConnection({iceServers:this._iceServers});const dataChannel=peerConnection.createDataChannel("notifications",{negotiated:true,id:1,});const peer=new Peer(id,{...options,connection:peerConnection,dataChannel,hasPriority:id>this.selfId,});this._emitUpdate({name:UPDATE_EVENT.CONNECTION_CHANGE,payload:{id,peer,state:"searching for network"},});this.peers.set(id,peer);peerConnection.addEventListener("icecandidate",async(event)=>{if(!event.candidate){return;}
if(!this.isActive||!this.peers.has(id)){return;}
await this._busNotify(INTERNAL_EVENT.ICE_CANDIDATE,{payload:{candidate:event.candidate,},targets:[id],});});peerConnection.addEventListener("iceconnectionstatechange",async()=>{switch(peerConnection.iceConnectionState){case"closed":this.removePeer(id);break;case"failed":case"disconnected":this._recover(peer.id,1000,"ice connection disconnected");break;}});peerConnection.addEventListener("icegatheringstatechange",()=>{this._emitLog(id,`gathering state change: ${peerConnection.iceGatheringState}`,LOG_LEVEL.INFO);});peerConnection.addEventListener("connectionstatechange",async()=>{this._emitUpdate({name:UPDATE_EVENT.CONNECTION_CHANGE,payload:{id,peer,state:peerConnection.connectionState},});switch(peerConnection.connectionState){case"closed":this.removePeer(id);break;case"failed":case"disconnected":this._recover(peer.id,1000,"connection disconnected");break;}
this._emitLog(id,`connection state change: ${peerConnection.connectionState}`,LOG_LEVEL.INFO);});peerConnection.addEventListener("icecandidateerror",async(error)=>{this._recover(id,`ice candidate error: ${error.errorText}`);});peerConnection.addEventListener("negotiationneeded",async()=>{peer.isBuildingOffer=true;try{await peerConnection.setLocalDescription(await peerConnection.createOffer());}catch(error){this._recover(id,`failed to set local Description for offer: ${error}`);peer.isBuildingOffer=false;return;}
peer.isBuildingOffer=false;if(!this.isActive||!this.peers.has(id)){return;}
await this._busNotify(INTERNAL_EVENT.OFFER,{payload:{sdp:peerConnection.localDescription,sequence:peer.sequence,},targets:[id],});});peerConnection.addEventListener("track",async({transceiver,track})=>{if(!peer?.id||!this.peers.has(peer.id)){return;}
const streamType=peer.getTransceiverStreamType(transceiver);if(!streamType){this._recover(id,"received track for unknown transceiver");return;}
peer.medias[streamType].track=track;if(!(await peer.ready)){return;}
this._emitUpdate({name:UPDATE_EVENT.TRACK,payload:{sessionId:id,type:streamType,track,active:peer.medias[streamType].active,sequence:peer.sequence,},});});dataChannel.addEventListener("message",async(event)=>{await this.handleNotification(id,event.data);});dataChannel.addEventListener("open",()=>{if(dataChannel.readyState!=="open"){return;}
dataChannel.send(JSON.stringify({event:INTERNAL_EVENT.INFO,channelId:this.channelId,payload:this._localInfo,}));this.broadcast({sequence:peer.sequence});});return peer;}}
return __exports;});;

/* /mail/static/src/discuss/call/common/ptt_ad_banner.js */
odoo.define('@mail/discuss/call/common/ptt_ad_banner',['@odoo/owl','@web/core/browser/browser','@web/core/browser/feature_detection','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{isMobileOS}=require("@web/core/browser/feature_detection");const{useService}=require("@web/core/utils/hooks");const PttAdBanner=__exports.PttAdBanner=class PttAdBanner extends Component{static template="discuss.pttAdBanner";static props={};static LOCAL_STORAGE_KEY="ptt_ad_banner_discarded";setup(){super.setup();this.pttExtService=useState(useService("discuss.ptt_extension"));this.store=useState(useService("mail.store"));this.state=useState({wasDiscarded:browser.localStorage.getItem(PttAdBanner.LOCAL_STORAGE_KEY),});}
onClickClose(){browser.localStorage.setItem(PttAdBanner.LOCAL_STORAGE_KEY,true);this.state.wasDiscarded=true;}
get isVisible(){return(!this.pttExtService.isEnabled&&this.store.settings.use_push_to_talk&&!isMobileOS()&&!this.state.wasDiscarded);}}
return __exports;});;

/* /mail/static/src/discuss/call/common/ptt_extension_service.js */
odoo.define('@mail/discuss/call/common/ptt_extension_service',['@odoo/owl','@mail/utils/common/misc','@web/core/browser/browser','@web/core/registry','@web/core/utils/strings','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{markup}=require("@odoo/owl");const{parseVersion}=require("@mail/utils/common/misc");const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{escape,sprintf}=require("@web/core/utils/strings");const{_t}=require("@web/core/l10n/translation");const pttExtensionHookService=__exports.pttExtensionHookService={start(env){const INITIAL_RELEASE_TIMEOUT=500;const COMMON_RELEASE_TIMEOUT=200;const EXT_ID="mdiacebcbkmjjlpclnbcgiepgifcnpmg";const versionPromise=window.chrome?.runtime?.sendMessage(EXT_ID,{type:"ask-version"})??Promise.resolve("1.0.0.0");let isEnabled=false;let voiceActivated=false;browser.addEventListener("message",({data,origin,source})=>{const rtc=env.services["discuss.rtc"];if(source!==window||origin!==location.origin||data.from!=="discuss-push-to-talk"||(!rtc&&data.type!=="answer-is-enabled")){return;}
switch(data.type){case"push-to-talk-pressed":{voiceActivated=false;const isFirstPress=!rtc.selfSession?.isTalking;rtc.onPushToTalk();if(rtc.selfSession?.isTalking){rtc.setPttReleaseTimeout(isFirstPress?INITIAL_RELEASE_TIMEOUT:COMMON_RELEASE_TIMEOUT);}}
break;case"toggle-voice":{if(voiceActivated){rtc.setPttReleaseTimeout(0);}else{rtc.onPushToTalk();}
voiceActivated=!voiceActivated;}
break;case"answer-is-enabled":isEnabled=true;break;}});async function sendMessage(type,value){if(!isEnabled&&type!=="ask-is-enabled"){return;}
const version=parseVersion(await versionPromise);if(version.isLowerThan("1.0.0.2")){window.postMessage({from:"discuss",type,value},location.origin);return;}
window.chrome?.runtime?.sendMessage(EXT_ID,{type,value});}
sendMessage("ask-is-enabled");return{notifyIsTalking(isTalking){sendMessage("is-talking",isTalking);},subscribe(){sendMessage("subscribe");},unsubscribe(){voiceActivated=false;sendMessage("unsubscribe");},get isEnabled(){return isEnabled;},downloadURL:`https://chromewebstore.google.com/detail/discuss-push-to-talk/${EXT_ID}`,get downloadText(){const translation=_t(`The Push-to-Talk feature is only accessible within tab focus. To enable the Push-to-Talk functionality outside of this tab, we recommend downloading our %(anchor_start)sextension%(anchor_end)s.`);return markup(sprintf(escape(translation),{anchor_start:`<a href="${this.downloadURL}" target="_blank" class="text-reset text-decoration-underline">`,anchor_end:"</a>",}));},};},};registry.category("services").add("discuss.ptt_extension",pttExtensionHookService);return __exports;});;

/* /mail/static/src/discuss/call/common/rtc_service.js */
odoo.define('@mail/discuss/call/common/rtc_service',['@mail/core/common/record','@mail/discuss/call/common/blur_manager','@mail/discuss/call/common/media_monitoring','@web/core/network/rpc','@mail/utils/common/misc','@odoo/owl','@web/core/browser/browser','@web/core/l10n/translation','@web/core/registry','@web/core/utils/timing','@web/core/assets','@web/core/utils/functions','@web/core/utils/urls','@mail/discuss/call/common/call_actions'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{BlurManager}=require("@mail/discuss/call/common/blur_manager");const{monitorAudio}=require("@mail/discuss/call/common/media_monitoring");const{rpc}=require("@web/core/network/rpc");const{closeStream,onChange}=require("@mail/utils/common/misc");const{reactive}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{debounce}=require("@web/core/utils/timing");const{loadBundle,loadJS}=require("@web/core/assets");const{memoize}=require("@web/core/utils/functions");const{url}=require("@web/core/utils/urls");const{callActionsRegistry}=require("@mail/discuss/call/common/call_actions");let sequence=1;const getSequence=()=>{return sequence++;};function subscribe(target,event,f){target.addEventListener(event,f);return()=>target.removeEventListener(event,f);}
const loadSfuAssets=memoize(async()=>await loadBundle("mail.assets_odoo_sfu"));const CONNECTION_TYPES=__exports.CONNECTION_TYPES={P2P:"p2p",SERVER:"server"};const SCREEN_CONFIG={width:{max:1920},height:{max:1080},aspectRatio:16/9,frameRate:{max:24,},};const CAMERA_CONFIG={width:{max:1280},height:{max:720},aspectRatio:16/9,frameRate:{max:30,},};const IS_CLIENT_RTC_COMPATIBLE=Boolean(window.RTCPeerConnection&&window.MediaStream);const DEFAULT_ICE_SERVERS=[{urls:["stun:stun1.l.google.com:19302","stun:stun2.l.google.com:19302"]},];function hasTurn(iceServers){return iceServers.some((server)=>{let hasTurn=false;if(server.url){hasTurn=server.url.startsWith("turn:");}
if(server.urls){if(Array.isArray(server.urls)){hasTurn=server.urls.some((url)=>url.startsWith("turn:"))||hasTurn;}else{hasTurn=server.urls.startsWith("turn:")||hasTurn;}}
return hasTurn;});}
class Network{p2p;sfu;_listeners=[];constructor(p2p,sfu){this.p2p=p2p;this.sfu=sfu;}
getSfuConsumerStats(sessionId){const consumers=this.sfu?._consumers.get(sessionId);if(!consumers){return[];}
return Object.entries(consumers).map(([type,consumer])=>{let state="active";if(!consumer){state="no consumer";}else if(consumer.closed){state="closed";}else if(consumer.paused){state="paused";}else if(!consumer.track){state="no track";}else if(!consumer.track.enabled){state="track disabled";}else if(consumer.track.muted){state="track muted";}
return{type,state};});}
addSfu(sfu){if(this.sfu){this.sfu.disconnect();}
this.sfu=sfu;}
removeSfu(){if(!this.sfu){return;}
for(const{name,f}of this._listeners){this.sfu.removeEventListener(name,f);}
this.sfu.disconnect();}
addEventListener(name,f){this._listeners.push({name,f});this.p2p.addEventListener(name,f);this.sfu?.addEventListener(name,f);}
async updateUpload(type,track){await Promise.all([this.p2p.updateUpload(type,track),this.sfu?.updateUpload(type,track),]);}
updateDownload(sessionId,states){this.p2p.updateDownload(sessionId,states);this.sfu?.updateDownload(sessionId,states);}
updateInfo(info,options={}){this.p2p.updateInfo(info,options);this.sfu?.updateInfo(info,options);}
disconnect(){for(const{name,f}of this._listeners.splice(0)){this.p2p.removeEventListener(name,f);this.sfu?.removeEventListener(name,f);}
this.p2p.disconnect();this.sfu?.disconnect();}}
const Rtc=__exports.Rtc=class Rtc extends Record{static get(data){return super.get(...arguments);}
static insert(data){return super.insert(...arguments);}
notifications=reactive(new Map());timeouts=new Map();downloadTimeouts=new Map();iceServers=Record.attr(undefined,{compute(){return this.iceServers?this.iceServers:DEFAULT_ICE_SERVERS;},});selfSession=Record.one("RtcSession");serverInfo;network;sfuClient=undefined;lastActions={};actionsStack=[];lastSelfCallAction=undefined;cleanups=[];sfuTimeout;callActions=Record.attr([],{compute(){return callActionsRegistry.getEntries().filter(([key,action])=>action.condition({rtc:this})).map(([key,action])=>[key,action.isActive({rtc:this})]);},onUpdate(){for(const[key,isActive]of this.callActions){if(isActive===this.lastActions[key]){continue;}
if(isActive){if(!this.actionsStack.includes(key)){this.actionsStack.unshift(key);}}else{this.actionsStack.splice(this.actionsStack.indexOf(key),1);}}
this.lastSelfCallAction=this.actionsStack[0];this.lastActions=Object.fromEntries(this.callActions);},});setup(){this.linkVoiceActivationDebounce=debounce(this.linkVoiceActivation,500);this.state=reactive({connectionType:undefined,hasPendingRequest:false,channel:undefined,globalLogs:{},logs:new Map(),sendCamera:false,sendScreen:false,updateAndBroadcastDebounce:undefined,audioTrack:undefined,cameraTrack:undefined,screenTrack:undefined,disconnectAudioMonitor:undefined,pttReleaseTimeout:undefined,sourceCameraStream:null,sourceScreenStream:null,fallbackMode:false,});this.blurManager=undefined;}
start(){const services=this.store.env.services;this.notification=services.notification;this.soundEffectsService=services["mail.sound_effects"];this.pttExtService=services["discuss.ptt_extension"];this.p2pService=services["discuss.p2p"];onChange(this.store.settings,"useBlur",()=>{if(this.state.sendCamera){this.toggleVideo("camera",true);}});onChange(this.store.settings,["edgeBlurAmount","backgroundBlurAmount"],()=>{if(this.blurManager){this.blurManager.edgeBlur=this.store.settings.edgeBlurAmount;this.blurManager.backgroundBlur=this.store.settings.backgroundBlurAmount;}});onChange(this.store.settings,["voiceActivationThreshold","use_push_to_talk"],()=>{this.linkVoiceActivationDebounce();});onChange(this.store.settings,"audioInputDeviceId",async()=>{if(this.selfSession){await this.resetAudioTrack({force:true});}});this.store.env.bus.addEventListener("RTC-SERVICE:PLAY_MEDIA",()=>{for(const session of this.state.channel.rtcSessions){session.playAudio();}});browser.addEventListener("keydown",(ev)=>{if(!this.store.settings.isPushToTalkKey(ev)){return;}
this.onPushToTalk();},{capture:true});browser.addEventListener("keyup",(ev)=>{if(!this.state.channel||!this.store.settings.use_push_to_talk||!this.store.settings.isPushToTalkKey(ev)||!this.selfSession.isTalking){return;}
this.setPttReleaseTimeout();},{capture:true});browser.addEventListener("pagehide",()=>{if(this.state.channel){const data=JSON.stringify({params:{channel_id:this.state.channel.id},});const blob=new Blob([data],{type:"application/json"});browser.navigator.sendBeacon("/mail/rtc/channel/leave_call",blob);this.sfuClient?.disconnect();}});browser.setInterval(async()=>{if(!this.selfSession||!this.state.channel){return;}
await this.ping();if(!this.selfSession||!this.state.channel){return;}
this.call();},30_000);}
setPttReleaseTimeout(duration=200){this.state.pttReleaseTimeout=browser.setTimeout(()=>{this.setTalking(false);if(!this.selfSession?.isMute){this.soundEffectsService.play("push-to-talk-off");}},Math.max(this.store.settings.voice_active_duration||0,duration));}
onPushToTalk(){if(!this.state.channel||this.store.settings.isRegisteringKey||!this.store.settings.use_push_to_talk){return;}
browser.clearTimeout(this.state.pttReleaseTimeout);if(!this.selfSession.isTalking&&!this.selfSession.isMute){this.soundEffectsService.play("push-to-talk-on");}
this.setTalking(true);}
addCallNotification({id,text,delay=3000}){if(this.notifications.has(id)){return;}
this.notifications.set(id,{id,text});this.timeouts.set(id,browser.setTimeout(()=>{this.notifications.delete(id);this.timeouts.delete(id);},delay));}
removeCallNotification(id){browser.clearTimeout(this.timeouts.get(id));this.notifications.delete(id);this.timeouts.delete(id);}
async leaveCall(channel=this.state.channel){this.state.hasPendingRequest=true;this.logSnapshot();await this.rpcLeaveCall(channel);this.endCall(channel);this.state.hasPendingRequest=false;}
endCall(channel=this.state.channel){channel.rtcInvitingSession=undefined;channel.activeRtcSession=undefined;if(channel.eq(this.state.channel)){this.pttExtService.unsubscribe();this.network?.disconnect();this.clear();this.soundEffectsService.play("channel-leave");}}
async deafen(){await this.setDeaf(true);this.soundEffectsService.play("deafen");}
setRemoteRaiseHand(session,active){if(Boolean(session.raisingHand)===active){return;}
Object.assign(session,{raisingHand:active?new Date():undefined,});const notificationId="raise_hand_"+session.id;if(session.raisingHand){this.addCallNotification({id:notificationId,text:_t("%s raised their hand",session.name),});}else{this.removeCallNotification(notificationId);}}
async mute(){await this.setMute(true);this.soundEffectsService.play("mute");}
async toggleCall(channel,{audio=true,fullscreen,camera}={}){await Promise.resolve(()=>loadJS(url("/mail/static/lib/selfie_segmentation/selfie_segmentation.js")).catch(()=>{}));if(this.state.hasPendingRequest){return;}
const isActiveCall=channel.eq(this.state.channel);if(this.state.channel){fullscreen?.exit();await this.leaveCall(this.state.channel);}
if(!isActiveCall){await this.joinCall(channel,{audio,camera});}}
async toggleMicrophone(){if(this.selfSession.isMute){await this.unmute();}else{await this.mute();}}
async undeafen(){await this.setDeaf(false);this.soundEffectsService.play("undeafen");}
async unmute(){if(this.state.audioTrack){await this.setMute(false);}else{await this.resetAudioTrack({force:true});}
this.soundEffectsService.play("unmute");}
async _loadSfu(){const load=async()=>{await loadSfuAssets();const sfuModule=odoo.loader.modules.get("@mail/../lib/odoo_sfu/odoo_sfu");this.SFU_CLIENT_STATE=sfuModule.SFU_CLIENT_STATE;this.sfuClient=new sfuModule.SfuClient();};try{await load();}catch{await new Promise((resolve,reject)=>{browser.setTimeout(async()=>{try{await load();}catch(error){reject(error);}
resolve();},1000);});}}
updateUpload(){this.network?.updateUpload("audio",this.state.audioTrack);this.network?.updateUpload("camera",this.state.cameraTrack);this.network?.updateUpload("screen",this.state.screenTrack);}
async _initConnection(){this.selfSession.connectionState="selecting network type";this.state.connectionType=CONNECTION_TYPES.P2P;this.network?.disconnect();this.p2pService.connect(this.selfSession.id,this.state.channel.id,{info:this.formatInfo(),iceServers:this.iceServers,});this.network=new Network(this.p2pService);this.updateUpload();if(this.serverInfo){this.log(this.selfSession,"loading sfu server",{step:"loading sfu server",serverInfo:this.serverInfo,});this.selfSession.connectionState="loading SFU assets";try{await this._loadSfu();this.state.connectionType=CONNECTION_TYPES.SERVER;if(this.network){this.network.addSfu(this.sfuClient);}else{return;}}catch(e){this.state.fallbackMode=true;this.notification.add(_t("Failed to load the SFU server, falling back to peer-to-peer"),{type:"warning",});this.log(this.selfSession,"failed to load sfu server",{error:e,important:true,});}
this.selfSession.connectionState="initializing";}else{this.log(this.selfSession,"no sfu server info, using peer-to-peer");}
this.network.addEventListener("stateChange",this._handleSfuClientStateChange);this.network.addEventListener("update",this._handleNetworkUpdates);this.network.addEventListener("log",({detail:{id,level,message}})=>{const session=this.store.RtcSession.get(id);if(session){this.log(session,message,{step:"p2p",level,important:true});}});if(this.state.channel){await this.call();this.updateUpload();}}
log(session,entry,{error,step,state,important,...data}={}){session.logStep=entry;if(!this.store.settings.logRtc&&!important){return;}
let sessionEntry=this.state.logs[session.id];if(!sessionEntry){this.state.logs[session.id]=sessionEntry={step:"",state:"",logs:[]};}
if(step){sessionEntry.step=step;}
if(state){sessionEntry.state=state;}
sessionEntry.logs.push({event:`${luxon.DateTime.now().toFormat("HH:mm:ss")}: ${entry}`,error:error&&{name:error.name,message:error.message,stack:error.stack&&error.stack.split("\n"),},...data,});}
async _handleNetworkUpdates({detail:{name,payload}}){if(!this.state.channel){return;}
switch(name){case"broadcast":{const{senderId,message:{sequence},}=payload;if(!sequence){return;}
const session=await this.store.RtcSession.getWhenReady(senderId);if(!session){return;}
if(!session.sequence||session.sequence<sequence){session.sequence=sequence;}}
return;case"connection_change":{const{id,state}=payload;const session=this.store.RtcSession.get(id);if(!session){return;}
session.connectionState=state;}
return;case"disconnect":{const{sessionId}=payload;const session=this.store.RtcSession.get(sessionId);if(!session){return;}
this.disconnect(session);}
return;case"info_change":if(!payload){return;}
for(const[id,info]of Object.entries(payload)){const session=await this.store.RtcSession.getWhenReady(Number(id));if(!session||!this.state.channel){return;}
this.setRemoteRaiseHand(session,info.isRaisingHand);delete info.isRaisingHand;Object.assign(session,info);}
return;case"track":{const{sessionId,type,track,active,sequence}=payload;const session=await this.store.RtcSession.getWhenReady(sessionId);if(!session||!this.state.channel){this.log(this.selfSession,`track received for unknown session ${sessionId} (${this.state.connectionType})`);return;}
if(sequence&&sequence<session.sequence){this.log(session,`track received for old sequence ${sequence} (${this.state.connectionType})`);return;}
this.log(session,`${type} track received (${this.state.connectionType})`);try{await this.handleRemoteTrack({session,track,type,active});}catch{}
setTimeout(()=>{this.updateVideoDownload(session);},2000);}
return;}}
_handleSfuClientStateChange({detail:{state,cause}}){this.log(this.selfSession,`sfu state change: ${state}. cause: ${cause}`,{state});this.selfSession.connectionState=state;switch(state){case this.SFU_CLIENT_STATE.AUTHENTICATED:this.p2pService.removeALlPeers();this.sfuClient.broadcast({sequence:getSequence()});break;case this.SFU_CLIENT_STATE.CONNECTED:browser.clearTimeout(this.sfuTimeout);this.sfuClient.updateInfo(this.formatInfo(),{needRefresh:true,});this.sfuClient.updateUpload("audio",this.state.audioTrack);this.sfuClient.updateUpload("camera",this.state.cameraTrack);this.sfuClient.updateUpload("screen",this.state.screenTrack);return;case this.SFU_CLIENT_STATE.CLOSED:{if(!this.state.channel){return;}
let text;if(cause==="full"){text=_t("Channel full");this.leaveCall();}else{text=_t("Connection to SFU server closed by the server, falling back to peer-to-peer");this.log(this.selfSession,text,{important:true});this._downgradeConnection();}
this.notification.add(text,{type:"warning",});}
return;}}
async _downgradeConnection(){this.serverInfo=undefined;this.state.fallbackMode=true;this.state.connectionType=CONNECTION_TYPES.P2P;this.network.removeSfu();await this.call();this.updateUpload();}
async call({asFallback=false}={}){if(asFallback&&!this.state.fallbackMode){return;}
if(this.state.connectionType===CONNECTION_TYPES.SERVER){if(this.sfuClient.state===this.SFU_CLIENT_STATE.DISCONNECTED){browser.clearTimeout(this.sfuTimeout);this.sfuTimeout=browser.setTimeout(()=>{this.log(this.selfSession,"sfu connection timeout",{important:true});this._downgradeConnection();},10000);await this.sfuClient.connect(this.serverInfo.url,this.serverInfo.jsonWebToken,{channelUUID:this.serverInfo.channelUUID,iceServers:this.iceServers,});}
return;}
if(this.state.channel.rtcSessions.length===0){return;}
const sequence=getSequence();for(const session of this.state.channel.rtcSessions){if(session.eq(this.selfSession)){continue;}
this.log(session,"init call",{step:"init call"});this.p2pService.addPeer(session.id,{sequence});}}
async handleRemoteTrack({session,track,type,active=true}){session.updateStreamState(type,active);await this.updateStream(session,track,{mute:this.selfSession.isDeaf,videoType:type,});this.updateActiveSession(session,type,{addVideo:true});}
async joinCall(channel,{audio=true,camera=false}={}){if(!IS_CLIENT_RTC_COMPATIBLE){this.notification.add(_t("Your browser does not support webRTC."),{type:"warning"});return;}
this.pttExtService.subscribe();this.state.hasPendingRequest=true;const data=await rpc("/mail/rtc/channel/join_call",{camera,channel_id:channel.id,check_rtc_session_ids:channel.rtcSessions.map((session)=>session.id),},{silent:true});this.state.hasPendingRequest=false;this.clear();this.state.channel=channel;this.store.insert(data);this.newLogs();this.state.updateAndBroadcastDebounce=debounce(async()=>{if(!this.selfSession){return;}
await rpc("/mail/rtc/session/update_and_broadcast",{session_id:this.selfSession.id,values:{is_camera_on:this.selfSession.isCameraOn,is_deaf:this.selfSession.isDeaf,is_muted:this.selfSession.isSelfMuted,is_screen_sharing_on:this.selfSession.isScreenSharingOn,},},{silent:true});},3000,{leading:true,trailing:true});this.state.channel.rtcInvitingSession=undefined;if(camera){await this.toggleVideo("camera");}
await this._initConnection();await this.resetAudioTrack({force:audio});if(!this.state.channel?.id){return;}
this.soundEffectsService.play("channel-join");this.cleanups.push(subscribe(browser,"beforeunload",(event)=>{event.preventDefault();}));}
newLogs(){const date=luxon.DateTime.now().toFormat("yyyy-MM-dd-HH:mm:ss");const id=`c:${this.state.channel.id}-s:${this.selfSession.id}-d:${date}`;this.state.logs=this.state.globalLogs[id]={};this.state.logs["hasTurn"]=hasTurn(this.iceServers);}
logSnapshot(){const peers=[];this.p2pService?.peers.forEach((peer)=>{peers.push({id:peer.id,state:peer.connection.connectionState,iceState:peer.connection.iceConnectionState,});});const server={};if(this.state.connectionType===CONNECTION_TYPES.SERVER){server.info=this.serverInfo;server.state=this.sfuClient?.state;server.consumersStats=this.state.channel.rtcSessions.map((session)=>this.network.getSfuConsumerStats(session.id));server.errors=this.sfuClient?.errors.map((error)=>error.message);}
this.state.globalLogs[`snapshot-${luxon.DateTime.now().toFormat("yyyy-MM-dd-HH-mm-ss")}`]={peers,server,connectionType:this.state.connectionType,};}
async rpcLeaveCall(channel){await rpc("/mail/rtc/channel/leave_call",{channel_id:channel.id,},{silent:true});}
async ping(){const data=await rpc("/discuss/channel/ping",{channel_id:this.state.channel.id,check_rtc_session_ids:this.state.channel.rtcSessions.map((session)=>session.id),rtc_session_id:this.selfSession.id,},{silent:true});this.store.insert(data);}
disconnect(session){const downloadTimeout=this.downloadTimeouts.get(session.id);if(downloadTimeout){clearTimeout(downloadTimeout);this.downloadTimeouts.delete(session.id);}
this.removeCallNotification("raise_hand_"+session.id);session.raisingHand=undefined;session.logStep=undefined;session.audioError=undefined;session.videoError=undefined;session.connectionState=undefined;session.isTalking=false;session.mainVideoStreamType=undefined;this.removeAudioFromSession(session);this.removeVideoFromSession(session);this.p2pService?.removePeer(session.id);this.log(session,"peer removed",{step:"peer removed"});}
clear(){if(this.state.channel){for(const session of this.state.channel.rtcSessions){this.removeAudioFromSession(session);this.removeVideoFromSession(session);session.isTalking=false;}
this.cleanups.splice(0).forEach((cleanup)=>cleanup());}
browser.clearTimeout(this.sfuTimeout);this.sfuClient=undefined;this.network=undefined;this.state.updateAndBroadcastDebounce?.cancel();this.state.disconnectAudioMonitor?.();this.state.audioTrack?.stop();this.state.cameraTrack?.stop();this.state.screenTrack?.stop();this.state.fallbackMode=undefined;closeStream(this.state.sourceCameraStream);this.state.sourceCameraStream=null;closeStream(this.state.sourceScreenStream);this.state.sourceScreenStream=null;if(this.blurManager){this.blurManager.close();this.blurManager=undefined;}
this.update({selfSession:undefined,serverInfo:undefined,});Object.assign(this.state,{updateAndBroadcastDebounce:undefined,connectionType:undefined,disconnectAudioMonitor:undefined,cameraTrack:undefined,screenTrack:undefined,audioTrack:undefined,sendCamera:false,sendScreen:false,channel:undefined,fallbackMode:false,});}
async setDeaf(isDeaf){this.updateAndBroadcast({isDeaf});for(const session of this.state.channel.rtcSessions){if(!session.audioElement){continue;}
session.audioElement.muted=isDeaf;}
await this.refreshAudioStatus();}
async setMute(isSelfMuted){this.updateAndBroadcast({isSelfMuted});await this.refreshAudioStatus();}
async raiseHand(raise){if(!this.selfSession||!this.state.channel){return;}
this.selfSession.raisingHand=raise?new Date():undefined;await this.network?.updateInfo(this.formatInfo());}
async setTalking(isTalking){if(!this.selfSession||isTalking===this.selfSession.isTalking){return;}
this.selfSession.isTalking=isTalking;if(!this.selfSession.isMute){this.pttExtService.notifyIsTalking(isTalking);await this.refreshAudioStatus();}}
async toggleVideo(type,force){if(!this.state.channel?.id){return;}
switch(type){case"camera":{const track=this.state.cameraTrack;const sendCamera=force??!this.state.sendCamera;this.state.sendCamera=false;await this.setVideo(track,type,sendCamera);break;}
case"screen":{const track=this.state.screenTrack;const sendScreen=force??!this.state.sendScreen;this.state.sendScreen=false;await this.setVideo(track,type,sendScreen);break;}}
if(this.selfSession){switch(type){case"camera":{this.removeVideoFromSession(this.selfSession,{type:"camera",cleanup:false,});if(this.state.cameraTrack){this.updateStream(this.selfSession,this.state.cameraTrack);}
break;}
case"screen":{if(!this.state.screenTrack){this.removeVideoFromSession(this.selfSession,{type:"screen",cleanup:false,});}else{this.updateStream(this.selfSession,this.state.screenTrack);}
break;}}}
const updatedTrack=type==="camera"?this.state.cameraTrack:this.state.screenTrack;await this.network?.updateUpload(type,updatedTrack);if(!this.selfSession){return;}
switch(type){case"camera":{this.updateAndBroadcast({isCameraOn:!!this.state.sendCamera,});break;}
case"screen":{this.updateAndBroadcast({isScreenSharingOn:!!this.state.sendScreen,});break;}}}
updateAndBroadcast(data){const session=this.selfSession;Object.assign(session,data);this.state.updateAndBroadcastDebounce?.();}
async refreshAudioStatus(){if(!this.state.audioTrack){return;}
this.state.audioTrack.enabled=!this.selfSession.isMute&&this.selfSession.isTalking;this.network?.updateInfo(this.formatInfo());}
async setVideo(track,type,activateVideo=false){const stopVideo=()=>{if(track){track.stop();}
switch(type){case"camera":{this.state.cameraTrack=undefined;closeStream(this.state.sourceCameraStream);this.state.sourceCameraStream=null;break;}
case"screen":{this.state.screenTrack=undefined;closeStream(this.state.sourceScreenStream);this.state.sourceScreenStream=null;break;}}};if(!activateVideo){if(type==="screen"){this.soundEffectsService.play("screen-sharing");}
if(type==="camera"&&this.blurManager){this.blurManager.close();this.blurManager=undefined;}
stopVideo();return;}
let sourceStream;try{if(type==="camera"){if(this.state.sourceCameraStream){sourceStream=this.state.sourceCameraStream;}else{sourceStream=await browser.navigator.mediaDevices.getUserMedia({video:CAMERA_CONFIG,});}}
if(type==="screen"){if(this.state.sourceScreenStream){sourceStream=this.state.sourceScreenStream;}else{sourceStream=await browser.navigator.mediaDevices.getDisplayMedia({video:SCREEN_CONFIG,});}
this.soundEffectsService.play("screen-sharing");}}catch{const str=type==="camera"?_t('%s" requires "camera" access',window.location.host):_t('%s" requires "screen recording" access',window.location.host);this.notification.add(str,{type:"warning"});stopVideo();return;}
let outputTrack=sourceStream?sourceStream.getVideoTracks()[0]:undefined;if(outputTrack){outputTrack.addEventListener("ended",async()=>{await this.toggleVideo(type,false);});}
if(this.store.settings.useBlur&&type==="camera"){try{this.blurManager?.close();this.blurManager=new BlurManager(sourceStream,{backgroundBlur:this.store.settings.backgroundBlurAmount,edgeBlur:this.store.settings.edgeBlurAmount,});const bluredStream=await this.blurManager.stream;outputTrack=bluredStream.getVideoTracks()[0];}catch(_e){this.notification.add(_t("%(name)s: %(message)s)",{name:_e.name,message:_e.message}),{type:"warning"});this.store.settings.useBlur=false;}}
switch(type){case"camera":{Object.assign(this.state,{sourceCameraStream:sourceStream,cameraTrack:outputTrack,sendCamera:Boolean(outputTrack),});break;}
case"screen":{Object.assign(this.state,{sourceScreenStream:sourceStream,screenTrack:outputTrack,sendScreen:Boolean(outputTrack),});break;}}}
async resetAudioTrack({force=false}){if(this.state.audioTrack){this.state.audioTrack.stop();this.state.audioTrack=undefined;}
if(!this.state.channel){return;}
if(this.selfSession){this.setMute(true);}
if(force){let audioTrack;try{const audioStream=await browser.navigator.mediaDevices.getUserMedia({audio:this.store.settings.audioConstraints,});audioTrack=audioStream.getAudioTracks()[0];if(this.selfSession){this.setMute(false);}}catch{this.notification.add(_t('"%(hostname)s" requires microphone access',{hostname:window.location.host,}),{type:"warning"});return;}
if(!this.selfSession){audioTrack.stop();return;}
audioTrack.addEventListener("ended",async()=>{await this.resetAudioTrack({force:false});this.setMute(true);});audioTrack.enabled=!this.selfSession.isMute&&this.selfSession.isTalking;this.state.audioTrack=audioTrack;this.linkVoiceActivationDebounce();await this.network?.updateUpload("audio",this.state.audioTrack);}}
async linkVoiceActivation(){this.state.disconnectAudioMonitor?.();if(!this.selfSession){return;}
if(this.store.settings.use_push_to_talk||!this.state.channel||!this.state.audioTrack){this.selfSession.isTalking=false;await this.refreshAudioStatus();return;}
try{this.state.disconnectAudioMonitor=await monitorAudio(this.state.audioTrack,{onThreshold:async(isAboveThreshold)=>{this.setTalking(isAboveThreshold);},volumeThreshold:this.store.settings.voiceActivationThreshold,});}catch{this.notification.add(_t("Your browser does not support voice activation"),{type:"warning",});this.selfSession.isTalking=true;}
await this.refreshAudioStatus();}
deleteSession(id){const session=this.store.RtcSession.get(id);if(session){if(this.selfSession&&session.eq(this.selfSession)){this.log(this.selfSession,"self session deleted, ending call",{important:true,});this.endCall();}
this.disconnect(session);session.delete();}}
formatInfo(){this.selfSession.isCameraOn=Boolean(this.state.cameraTrack);this.selfSession.isScreenSharingOn=Boolean(this.state.screenTrack);return this.selfSession.info;}
async updateStream(session,track,{mute,videoType}={}){const stream=new window.MediaStream();stream.addTrack(track);if(track.kind==="audio"){const audioElement=session.audioElement||new window.Audio();audioElement.srcObject=stream;audioElement.load();audioElement.muted=mute;audioElement.volume=this.store.settings.getVolume(session);audioElement.autoplay=true;session.audioElement=audioElement;session.audioStream=stream;session.isSelfMuted=false;session.isTalking=false;await session.playAudio();}
if(track.kind==="video"){videoType=videoType?videoType:track.id===this.state.cameraTrack?.id?"camera":"screen";session.videoStreams.set(videoType,stream);this.updateActiveSession(session,videoType,{addVideo:true});}}
removeVideoFromSession(session,{type,cleanup=true}={}){if(type){this.updateActiveSession(session,type);if(cleanup){closeStream(session.videoStreams.get(type));}
session.videoStreams.delete(type);}else{if(cleanup){for(const stream of session.videoStreams.values()){closeStream(stream);}}
session.videoStreams.clear();}}
removeAudioFromSession(session){closeStream(session.audioStream);if(session.audioElement){session.audioElement.pause();try{session.audioElement.srcObject=undefined;}catch{}}
session.audioStream=undefined;}
updateActiveSession(session,videoType,{addVideo=false}={}){const activeRtcSession=this.state.channel.activeRtcSession;if(addVideo){if(videoType==="screen"){this.state.channel.activeRtcSession=session;session.mainVideoStreamType=videoType;return;}
if(activeRtcSession&&session.hasVideo&&!session.isMainVideoStreamActive){session.mainVideoStreamType=videoType;}
return;}
if(!activeRtcSession||activeRtcSession.notEq(session)){return;}
if(activeRtcSession.isMainVideoStreamActive){if(videoType===session.mainVideoStreamType){if(videoType==="screen"){session.mainVideoStreamType="camera";}else if(this.actionsStack.includes("camera-on")&&this.actionsStack.includes("share-screen")){session.mainVideoStreamType="screen";}}}}
updateVideoDownload(rtcSession,{viewCountIncrement=0}={}){rtcSession.videoComponentCount+=viewCountIncrement;const downloadTimeout=this.downloadTimeouts.get(rtcSession.id);if(downloadTimeout){this.downloadTimeouts.delete(rtcSession.id);browser.clearTimeout(downloadTimeout);}
if(rtcSession.videoComponentCount>0){this.network?.updateDownload(rtcSession.id,{camera:true,screen:true,});}else{this.downloadTimeouts.set(rtcSession.id,browser.setTimeout(()=>{this.downloadTimeouts.delete(rtcSession.id);this.network?.updateDownload(rtcSession.id,{camera:false,screen:false,});},1000));}}}
Rtc.register();const rtcService=__exports.rtcService={dependencies:["bus_service","discuss.p2p","discuss.ptt_extension","mail.sound_effects","mail.store","notification",],start(env,services){const rtc=env.services["mail.store"].rtc;rtc.p2pService=services["discuss.p2p"];rtc.p2pService.acceptOffer=async(id,sequence)=>{const session=await this.store.RtcSession.getWhenReady(Number(id));return sequence>=session?.sequence;};services["bus_service"].subscribe("discuss.channel.rtc.session/sfu_hot_swap",async({serverInfo})=>{if(!rtc.selfSession){return;}
if(rtc.serverInfo?.channelUUID===serverInfo.channelUUID){return;}
rtc.serverInfo=serverInfo;await rtc._initConnection();});services["bus_service"].subscribe("discuss.channel.rtc.session/ended",({sessionId})=>{if(rtc.selfSession?.id===sessionId){rtc.endCall();services.notification.add(_t("Disconnected from the RTC call by the server"),{type:"warning",});}});services["bus_service"].subscribe("res.users.settings.volumes",(payload)=>{if(payload){rtc.store.Volume.insert(payload);}});services["bus_service"].subscribe("discuss.channel.rtc.session/update_and_broadcast",(payload)=>{const{data,channelId}=payload;if(channelId!==rtc.state.channel?.id){rtc.store.insert(data);}});return rtc;},};registry.category("services").add("discuss.rtc",rtcService);return __exports;});;

/* /mail/static/src/discuss/call/common/rtc_session_model.js */
odoo.define('@mail/discuss/call/common/rtc_session_model',['@mail/core/common/record','@web/core/utils/concurrency'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{Deferred}=require("@web/core/utils/concurrency");const RtcSession=__exports.RtcSession=class RtcSession extends Record{static id="id";static records={};static awaitedRecords=new Map();static get(data){return super.get(data);}
static async getWhenReady(id){const session=this.get(id);if(!session){let deferred=this.awaitedRecords.get(id);if(!deferred){deferred=new Deferred();this.awaitedRecords.set(id,deferred);setTimeout(()=>{deferred.resolve();this.awaitedRecords.delete(id);},120_000);}
return deferred;}
return session;}
static new(){const record=super.new(...arguments);this.awaitedRecords.get(record.id)?.resolve(record);this.awaitedRecords.delete(record.id);return record;}
static _insert(){const session=super._insert(...arguments);session.channel?.rtcSessions.add(session);return session;}
channelMember=Record.one("ChannelMember",{inverse:"rtcSession"});isCameraOn;isScreenSharingOn;id;isDeaf;isSelfMuted;audioElement;audioStream;dataChannel;audioError;videoError;isTalking=Record.attr(false,{onUpdate(){if(this.isTalking&&!this.isMute){this.talkingTime=this.store.nextTalkingTime++;}},});isActuallyTalking=Record.attr(false,{compute(){return this.isTalking&&!this.isMute;},});isVideoStreaming=Record.attr(false,{compute(){return this.isScreenSharingOn||this.isCameraOn;},});shortStatus=Record.attr(undefined,{compute(){if(this.isScreenSharingOn){return"live";}
if(this.isDeaf){return"deafen";}
if(this.isMute){return"mute";}},});talkingTime=0;localVolume;peerConnection;raisingHand;videoComponentCount=0;videoStreams=new Map();mainVideoStreamType;sequence=0;connectionState;localCandidateType;remoteCandidateType;dataChannelState;packetsReceived;packetsSent;dtlsState;iceState;iceGatheringState;logStep;get channel(){return this.channelMember?.thread;}
get isMute(){return this.isSelfMuted||this.isDeaf;}
get mainVideoStream(){return this.isMainVideoStreamActive&&this.videoStreams.get(this.mainVideoStreamType);}
get isMainVideoStreamActive(){if(!this.mainVideoStreamType){return false;}
return this.mainVideoStreamType==="camera"?this.isCameraOn:this.isScreenSharingOn;}
get hasVideo(){return this.isScreenSharingOn||this.isCameraOn;}
getStream(type){const isActive=type==="camera"?this.isCameraOn:this.isScreenSharingOn;return isActive&&this.videoStreams.get(type);}
get info(){return{isSelfMuted:this.isSelfMuted,isRaisingHand:Boolean(this.raisingHand),isDeaf:this.isDeaf,isTalking:this.isTalking,isCameraOn:this.isCameraOn,isScreenSharingOn:this.isScreenSharingOn,};}
get partnerId(){const persona=this.channelMember?.persona;return persona.type==="partner"?persona.id:undefined;}
get guestId(){const persona=this.channelMember?.persona;return persona.type==="guest"?persona.id:undefined;}
get name(){return this.channelMember?.persona.name;}
get volume(){return this.audioElement?.volume||this.localVolume;}
set volume(value){if(this.audioElement){this.audioElement.volume=value;}
this.localVolume=value;}
async playAudio(){if(!this.audioElement){return;}
try{await this.audioElement.play();this.audioError=undefined;}catch(error){this.audioError=error.name;}}
updateStreamState(type,state){if(type==="camera"){this.isCameraOn=state;}else if(type==="screen"){this.isScreenSharingOn=state;}}}
RtcSession.register();return __exports;});;

/* /mail/static/src/discuss/call/common/settings_model_patch.js */
odoo.define('@mail/discuss/call/common/settings_model_patch',['@mail/core/common/settings_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Settings}=require("@mail/core/common/settings_model");const{patch}=require("@web/core/utils/patch");const SettingsPatch={setup(){super.setup(...arguments);},getVolume(rtcSession){return(rtcSession.volume||this.volumes.find((volume)=>(volume.persona.type==="partner"&&volume.persona.id===rtcSession.partnerId)||(volume.persona.type==="guest"&&volume.persona.id===rtcSession.guestId))?.volume||0.5);},};patch(Settings.prototype,SettingsPatch);return __exports;});;

/* /mail/static/src/discuss/call/common/store_service_patch.js */
odoo.define('@mail/discuss/call/common/store_service_patch',['@mail/core/common/record','@mail/core/common/store_service','@mail/discuss/call/common/rtc_session_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{Store}=require("@mail/core/common/store_service");const{RtcSession}=require("@mail/discuss/call/common/rtc_session_model");const{patch}=require("@web/core/utils/patch");const StorePatch={setup(){super.setup(...arguments);this.RtcSession=RtcSession;this.rtc=Record.one("Rtc",{compute(){return{};},});this.ringingThreads=Record.many("Thread",{onUpdate(){if(this.ringingThreads.length>0){this.env.services["mail.sound_effects"].play("incoming-call",{loop:true,});}else{this.env.services["mail.sound_effects"].stop("incoming-call");}},});this.allActiveRtcSessions=Record.many("RtcSession");this.nextTalkingTime=1;},onStarted(){super.onStarted(...arguments);this.rtc.start();},sortMembers(m1,m2){const m1HasRtc=Boolean(m1.rtcSession);const m2HasRtc=Boolean(m2.rtcSession);if(m1HasRtc===m2HasRtc){const m1RaisingValue=m1.rtcSession?.raisingHand||Infinity;const m2RaisingValue=m2.rtcSession?.raisingHand||Infinity;if(m1HasRtc&&m1RaisingValue!==m2RaisingValue){return m1RaisingValue-m2RaisingValue;}else{return super.sortMembers(m1,m2);}}else{return m2HasRtc-m1HasRtc;}},};patch(Store.prototype,StorePatch);return __exports;});;

/* /mail/static/src/discuss/call/common/thread_actions.js */
odoo.define('@mail/discuss/call/common/thread_actions',['@mail/core/common/thread_actions','@mail/discuss/call/common/call_settings','@odoo/owl','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{threadActionsRegistry}=require("@mail/core/common/thread_actions");const{CallSettings}=require("@mail/discuss/call/common/call_settings");const{useComponent,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");threadActionsRegistry.add("call",{condition(component){return(component.thread?.allowCalls&&!component.thread?.eq(component.rtc.state.channel));},icon:"fa fa-fw fa-phone",iconLarge:"fa fa-fw fa-lg fa-phone",name:_t("Start a Call"),open(component){component.rtc.toggleCall(component.thread);},sequence:10,sequenceQuick:30,setup(){const component=useComponent();component.rtc=useState(useService("discuss.rtc"));},}).add("camera-call",{condition(component){return(component.thread?.allowCalls&&!component.thread?.eq(component.rtc.state.channel));},icon:"fa fa-fw fa-video-camera",iconLarge:"fa fa-fw fa-lg fa-video-camera",name:_t("Start a Video Call"),open(component){component.rtc.toggleCall(component.thread,{camera:true});},sequence:5,sequenceQuick:(component)=>(component.env.inDiscussApp?25:35),setup(){const component=useComponent();component.rtc=useState(useService("discuss.rtc"));},}).add("settings",{component:CallSettings,componentProps(action){return{isCompact:true};},condition(component){return(component.thread?.allowCalls&&(component.props.chatWindow?.isOpen||component.store.inPublicPage));},icon:"fa fa-fw fa-gear",iconLarge:"fa fa-fw fa-lg fa-gear",name:_t("Call Settings"),sequence:20,sequenceGroup:30,setup(){const component=useComponent();component.rtc=useState(useService("discuss.rtc"));},toggle:true,});return __exports;});;

/* /mail/static/src/discuss/call/common/thread_model_patch.js */
odoo.define('@mail/discuss/call/common/thread_model_patch',['@mail/core/common/record','@mail/core/common/thread_model','@web/core/browser/browser','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{Thread}=require("@mail/core/common/thread_model");const{browser}=require("@web/core/browser/browser");const{patch}=require("@web/core/utils/patch");const ThreadPatch={setup(){super.setup(...arguments);this.activeRtcSession=Record.one("RtcSession",{onAdd(r){this.store.allActiveRtcSessions.add(r);},onDelete(r){this.store.allActiveRtcSessions.delete(r);},});this.hadSelfSession=false;this.lastSessionIds=new Set();this.cancelRtcInvitationTimeout;this.rtcInvitingSession=Record.one("RtcSession",{onAdd(r){this.rtcSessions.add(r);this.store.ringingThreads.add(this);this.cancelRtcInvitationTimeout=browser.setTimeout(()=>{this.store.env.services["discuss.rtc"].leaveCall(this);},30000);},onDelete(r){browser.clearTimeout(this.cancelRtcInvitationTimeout);this.store.ringingThreads.delete(this);},});this.rtcSessions=Record.many("RtcSession",{onDelete(r){this.store.env.services["discuss.rtc"].deleteSession(r.id);},onUpdate(){const hadSelfSession=this.hadSelfSession;const lastSessionIds=this.lastSessionIds;this.hadSelfSession=Boolean(this.store.rtc.selfSession?.in(this.rtcSessions));this.lastSessionIds=new Set(this.rtcSessions.map((s)=>s.id));if(!hadSelfSession||!this.hadSelfSession||!this.store.env.services["multi_tab"].isOnMainTab()){return;}
if([...this.lastSessionIds].some((id)=>!lastSessionIds.has(id))){this.store.env.services["mail.sound_effects"].play("channel-join");this.store.rtc.call({asFallback:true});}
if([...lastSessionIds].some((id)=>!this.lastSessionIds.has(id))){this.store.env.services["mail.sound_effects"].play("member-leave");}},});},get videoCount(){return Object.values(this.store.RtcSession.records).filter((session)=>session.hasVideo).length;},};patch(Thread.prototype,ThreadPatch);return __exports;});;

/* /mail/static/src/discuss/gif_picker/common/composer_patch.js */
odoo.define('@mail/discuss/gif_picker/common/composer_patch',['@mail/core/common/composer','@web/core/utils/misc','@odoo/owl','@web/core/utils/hooks','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Composer}=require("@mail/core/common/composer");const{markEventHandled}=require("@web/core/utils/misc");const{useRef,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");const composerPatch={setup(){this.gifButton=useRef("gif-button");super.setup();this.ui=useState(useService("ui"));},get pickerSettings(){const setting=super.pickerSettings;if(this.hasGifPicker){setting.pickers.gif=(gif)=>this.sendGifMessage(gif);if(this.hasGifPickerButton){setting.buttons.push(this.gifButton);}}
return setting;},get hasGifPicker(){return((this.store.hasGifPickerFeature||this.store.self.isAdmin)&&!this.env.inChatter&&!this.props.composer.message);},get hasGifPickerButton(){return this.hasGifPicker&&!this.ui.isSmall&&!this.env.inChatWindow;},onClickAddGif(ev){markEventHandled(ev,"Composer.onClickAddGif");},async sendGifMessage(gif){await this._sendMessage(gif.url,{parentId:this.props.messageToReplyTo?.message?.id,});},};patch(Composer.prototype,composerPatch);return __exports;});;

/* /mail/static/src/discuss/gif_picker/common/gif_picker.js */
odoo.define('@mail/discuss/gif_picker/common/gif_picker',['@odoo/owl','@mail/utils/common/hooks','@web/core/user','@web/core/utils/hooks','@web/core/utils/timing','@web/core/network/rpc'],function(require){'use strict';let __exports={};const{Component,onWillStart,useState,useEffect}=require("@odoo/owl");const{useOnBottomScrolled,useSequential}=require("@mail/utils/common/hooks");const{user}=require("@web/core/user");const{useService,useAutofocus}=require("@web/core/utils/hooks");const{useDebounced}=require("@web/core/utils/timing");const{rpc}=require("@web/core/network/rpc");const GifPicker=__exports.GifPicker=class GifPicker extends Component{static template="discuss.GifPicker";static props=["PICKERS?","className?","close?","onSelect","state?"];setup(){super.setup();this.orm=useService("orm");this.store=useState(useService("mail.store"));this.sequential=useSequential();useAutofocus();useOnBottomScrolled("scroller",()=>{if(!this.state.showCategories){this.state.loadingGif=true;if(!this.showFavorite){this.search();}else{this.loadFavoritesDebounced(this.offset);}}},300);this.next="";this.showFavorite=false;this.offset=0;this.state=useState({favorites:{gifs:[],offset:0,},searchTerm:"",showCategories:true,categories:[],loadingGif:false,loadingError:false,evenGif:{gifs:new Map(),columnSize:0,},oddGif:{gifs:new Map(),columnSize:0,},});this.loadFavoritesDebounced=useDebounced(this.loadFavorites,200);onWillStart(()=>{this.loadCategories();});if(this.store.self.type==="partner"){onWillStart(()=>{this.loadFavorites();});}
useEffect(()=>{if(this.props.state?.picker!==this.props.PICKERS?.GIF){return;}
this.clear();this.state.loadingGif=true;this.search();if(this.searchTerm){this.closeCategories();}else{this.openCategories();}},()=>[this.searchTerm,this.props.state?.picker]);}
get style(){return"";}
get searchTerm(){return this.props.state?this.props.state.searchTerm:this.state.searchTerm;}
set searchTerm(value){if(this.props.state){this.props.state.searchTerm=value;}else{this.state.searchTerm=value;}}
async loadCategories(){try{let{language,region}=new Intl.Locale(user.lang);if(!region&&language==="sr"){region="RS";}
const{tags}=await rpc("/discuss/gif/categories",{country:region,locale:`${language}_${region}`,},{silent:true});if(tags){this.state.categories=tags;}}catch{this.state.loadingError=true;}}
openCategories(){this.showFavorite=false;this.state.showCategories=true;this.searchTerm="";this.clear();}
closeCategories(){this.state.showCategories=false;}
async search(){if(!this.searchTerm){return;}
try{let{language,region}=new Intl.Locale(user.lang);if(!region&&language==="sr"){region="RS";}
const params={country:region,locale:`${language}_${region}`,search_term:this.searchTerm,};if(this.next){params.position=this.next;}
const res=await this.sequential(()=>{this.state.loadingGif=true;const res=rpc("/discuss/gif/search",params,{silent:true,});this.state.loadingGif=false;return res;});if(res){const{next,results}=res;this.next=next;for(const gif of results){this.pushGif(gif);}
this.state.loadingError=false;}}catch{this.state.loadingError=true;}}
pushGif(gif){if(this.state.evenGif.columnSize<=this.state.oddGif.columnSize){this.state.evenGif.gifs.set(gif.id,gif);this.state.evenGif.columnSize+=gif.media_formats.tinygif.dims[1];}else{this.state.oddGif.gifs.set(gif.id,gif);this.state.oddGif.columnSize+=gif.media_formats.tinygif.dims[1];}}
onClickGif(gif){this.props.onSelect(gif,true);this.props.close?.();}
clear(){this.state.evenGif.gifs.clear();this.state.evenGif.columnSize=0;this.state.oddGif.gifs.clear();this.state.oddGif.columnSize=0;}
async onClickCategory(category){this.clear();this.props.state.searchTerm=category.searchterm;this.closeCategories();}
async onClickFavorite(gif){if(!this.isFavorite(gif)){this.state.favorites.gifs.push(gif);await this.orm.silent.create("discuss.gif.favorite",[{tenor_gif_id:gif.id}]);}else{const index=this.state.favorites.gifs.findIndex(({id})=>id===gif.id);if(index>=0){this.state.favorites.gifs.splice(index,1);}
await rpc("/discuss/gif/remove_favorite",{tenor_gif_id:gif.id},{silent:true});}}
async loadFavorites(){this.state.loadingGif=true;try{const[results]=await rpc("/discuss/gif/favorites",{offset:this.offset},{silent:true});this.offset+=20;this.state.favorites.gifs.push(...results);}catch{this.state.loadingError=true;}
this.state.loadingGif=false;}
isFavorite(gif){return this.state.favorites.gifs.map((favorite)=>favorite.id).includes(gif.id);}
onClickFavoritesCategory(){this.showFavorite=true;for(const gif of this.state.favorites.gifs){this.pushGif(gif);}
this.closeCategories();}}
return __exports;});;

/* /mail/static/src/discuss/gif_picker/common/picker_content_patch.js */
odoo.define('@mail/discuss/gif_picker/common/picker_content_patch',['@odoo/owl','@web/core/utils/patch','@web/core/utils/hooks','@mail/discuss/gif_picker/common/gif_picker','@mail/core/common/picker_content'],function(require){'use strict';let __exports={};const{useState}=require("@odoo/owl");const{patch}=require("@web/core/utils/patch");const{useService}=require("@web/core/utils/hooks");const{GifPicker}=require("@mail/discuss/gif_picker/common/gif_picker");const{PickerContent}=require("@mail/core/common/picker_content");Object.assign(PickerContent.components,{GifPicker});patch(PickerContent.prototype,{setup(){super.setup();this.store=useState(useService("mail.store"));},});return __exports;});;

/* /mail/static/src/discuss/gif_picker/common/picker_patch.js */
odoo.define('@mail/discuss/gif_picker/common/picker_patch',['@web/core/utils/patch','@mail/core/common/picker','@web/core/utils/misc'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{Picker}=require("@mail/core/common/picker");const{isEventHandled}=require("@web/core/utils/misc");patch(Picker.prototype,{isEventHandledByPicker(ev){return super.isEventHandledByPicker(ev)||isEventHandled(ev,"Composer.onClickAddGif");},async toggle(el,ev){await super.toggle(el,ev);if(isEventHandled(ev,"Composer.onClickAddGif")){if(this.popover.isOpen){if(this.props.state.picker===this.props.PICKERS.GIF){this.close();return;}
this.props.state.picker=this.props.PICKERS.GIF;}else{this.props.state.picker=this.props.PICKERS.GIF;this.popover.open(el,this.contentProps);}}},});return __exports;});;

/* /mail/static/src/discuss/gif_picker/common/store_service_patch.js */
odoo.define('@mail/discuss/gif_picker/common/store_service_patch',['@mail/core/common/store_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Store}=require("@mail/core/common/store_service");const{patch}=require("@web/core/utils/patch");const StorePatch={setup(){super.setup(...arguments);this.hasGifPickerFeature=false;},};patch(Store.prototype,StorePatch);return __exports;});;

/* /mail/static/src/discuss/message_pin/common/message_actions.js */
odoo.define('@mail/discuss/message_pin/common/message_actions',['@web/core/l10n/translation','@mail/core/common/message_actions'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{messageActionsRegistry}=require("@mail/core/common/message_actions");messageActionsRegistry.add("pin",{condition:(component)=>component.store.self.type==="partner"&&component.props.thread?.model==="discuss.channel",icon:"fa fa-thumb-tack",title:(component)=>(component.props.message.pinned_at?_t("Unpin"):_t("Pin")),onClick:(component)=>component.props.message.pin(),sequence:65,});return __exports;});;

/* /mail/static/src/discuss/message_pin/common/message_model_patch.js */
odoo.define('@mail/discuss/message_pin/common/message_model_patch',['@web/core/utils/patch','@mail/core/common/message_model','@mail/core/common/record','@web/core/l10n/translation','@mail/core/common/message_confirm_dialog','@web/core/utils/concurrency'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{Message}=require("@mail/core/common/message_model");const{Record}=require("@mail/core/common/record");const{_t}=require("@web/core/l10n/translation");const{MessageConfirmDialog}=require("@mail/core/common/message_confirm_dialog");const{Deferred}=require("@web/core/utils/concurrency");patch(Message.prototype,{setup(){super.setup();this.pinned_at=Record.attr(undefined,{type:"datetime"});},pin(){if(this.pinned_at){return this.unpin();}
const def=new Deferred();this.store.env.services.dialog.add(MessageConfirmDialog,{confirmText:_t("Yeah, pin it!"),message:this,prompt:_t("You sure want this message pinned to %(conversation)s forever and ever?",{conversation:this.thread.prefix+this.thread.displayName,}),size:"md",title:_t("Pin It"),onConfirm:()=>{def.resolve(true);this.store.env.services.orm.call("discuss.channel","set_message_pin",[this.thread.id],{message_id:this.id,pinned:true});},},{onClose:()=>def.resolve(false)});return def;},unpin(){const def=new Deferred();this.store.env.services.dialog.add(MessageConfirmDialog,{confirmColor:"btn-danger",confirmText:_t("Yes, remove it please"),message:this,prompt:_t("Well, nothing lasts forever, but are you sure you want to unpin this message?"),size:"md",title:_t("Unpin Message"),onConfirm:()=>{def.resolve(true);this.store.env.services.orm.call("discuss.channel","set_message_pin",[this.thread.id],{message_id:this.id,pinned:false});},},{onClose:()=>def.resolve(false)});return def;},});return __exports;});;

/* /mail/static/src/discuss/message_pin/common/message_patch.js */
odoo.define('@mail/discuss/message_pin/common/message_patch',['@mail/core/common/message','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message");const{patch}=require("@web/core/utils/patch");patch(Message,{components:{...Message.components},});patch(Message.prototype,{get isAlignedRight(){return!this.env.messageCard&&super.isAlignedRight;},get shouldDisplayAuthorName(){if(this.env.messageCard){return true;}
return super.shouldDisplayAuthorName;},async onClickNotificationMessage(ev){const{oeType}=ev.target.dataset;if(oeType==="pin-menu"){this.env.pinMenu?.open();}
await super.onClickNotificationMessage(...arguments);},});return __exports;});;

/* /mail/static/src/discuss/message_pin/common/pinned_messages_panel.js */
odoo.define('@mail/discuss/message_pin/common/pinned_messages_panel',['@mail/core/common/message_card_list','@mail/discuss/core/common/action_panel','@odoo/owl','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{MessageCardList}=require("@mail/core/common/message_card_list");const{ActionPanel}=require("@mail/discuss/core/common/action_panel");const{Component,onWillStart,onWillUpdateProps}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const PinnedMessagesPanel=__exports.PinnedMessagesPanel=class PinnedMessagesPanel extends Component{static components={MessageCardList,ActionPanel,};static props=["thread","className?"];static template="discuss.PinnedMessagesPanel";setup(){super.setup();onWillStart(()=>{this.props.thread.fetchPinnedMessages();});onWillUpdateProps((nextProps)=>{if(nextProps.thread.notEq(this.props.thread)){nextProps.thread.fetchPinnedMessages();}});}
get emptyText(){if(this.props.thread.channel_type==="channel"){return _t("This channel doesn't have any pinned messages.");}else{return _t("This conversation doesn't have any pinned messages.");}}}
return __exports;});;

/* /mail/static/src/discuss/message_pin/common/thread_actions.js */
odoo.define('@mail/discuss/message_pin/common/thread_actions',['@mail/core/common/thread_actions','@mail/discuss/message_pin/common/pinned_messages_panel','@odoo/owl','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{threadActionsRegistry}=require("@mail/core/common/thread_actions");const{PinnedMessagesPanel}=require("@mail/discuss/message_pin/common/pinned_messages_panel");const{useChildSubEnv}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");threadActionsRegistry.add("pinned-messages",{component:PinnedMessagesPanel,condition(component){return(component.thread?.model==="discuss.channel"&&(!component.props.chatWindow||component.props.chatWindow.isOpen));},panelOuterClass:"o-discuss-PinnedMessagesPanel bg-inherit",icon:"fa fa-fw fa-thumb-tack",iconLarge:"fa fa-fw fa-lg fa-thumb-tack",name:_t("Pinned Messages"),nameActive:_t("Hide Pinned Messages"),sequence:20,sequenceGroup:10,setup(action){useChildSubEnv({pinMenu:{open:()=>action.open(),close:()=>{if(action.isActive){action.close();}},},});},toggle:true,});return __exports;});;

/* /mail/static/src/discuss/message_pin/common/thread_model_patch.js */
odoo.define('@mail/discuss/message_pin/common/thread_model_patch',['@web/core/utils/patch','@mail/core/common/record','@mail/core/common/thread_model','@web/core/network/rpc'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{Record}=require("@mail/core/common/record");const{Thread}=require("@mail/core/common/thread_model");const{rpc}=require("@web/core/network/rpc");patch(Thread.prototype,{setup(){super.setup();this.pinnedMessagesState=undefined;this.pinnedMessages=Record.many("Message",{compute(){return this.allMessages.filter((m)=>m.pinned_at);},sort:(m1,m2)=>{if(m1.pinned_at===m2.pinned_at){return m1.id-m2.id;}
return m1.pinned_at<m2.pinned_at?1:-1;},});},async fetchPinnedMessages(){if(this.model!=="discuss.channel"||["loaded","loading"].includes(this.pinnedMessagesState)){return;}
this.pinnedMessagesState="loading";try{const data=await rpc("/discuss/channel/pinned_messages",{channel_id:this.id,});this.store.insert(data,{html:true});this.pinnedMessagesState="loaded";}catch(e){this.pinnedMessagesState="error";throw e;}},});return __exports;});;

/* /mail/static/src/discuss/typing/common/composer_patch.js */
odoo.define('@mail/discuss/typing/common/composer_patch',['@mail/core/common/composer','@mail/discuss/typing/common/typing','@web/core/network/rpc','@odoo/owl','@web/core/browser/browser','@web/core/registry','@web/core/utils/patch','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{Composer}=require("@mail/core/common/composer");const{Typing}=require("@mail/discuss/typing/common/typing");const{rpc}=require("@web/core/network/rpc");const{onWillDestroy}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{patch}=require("@web/core/utils/patch");const{useDebounced}=require("@web/core/utils/timing");const commandRegistry=registry.category("discuss.channel_commands");const SHORT_TYPING=__exports.SHORT_TYPING=5000;const LONG_TYPING=__exports.LONG_TYPING=50000;patch(Composer,{components:{...Composer.components,Typing},});patch(Composer.prototype,{setup(){super.setup();this.typingNotified=false;this.stopTypingDebounced=useDebounced(this.stopTyping.bind(this),SHORT_TYPING);onWillDestroy(()=>{this.stopTyping();});},notifyIsTyping(is_typing=true){if(this.thread?.model==="discuss.channel"&&this.thread.id>0){rpc("/discuss/channel/notify_typing",{channel_id:this.thread.id,is_typing,},{silent:true});}},detectTyping(){const value=this.props.composer.text;if(this.thread?.model==="discuss.channel"&&value.startsWith("/")){const[firstWord]=value.substring(1).split(/\s/);const command=commandRegistry.get(firstWord,false);if(value==="/"||this.hasSuggestions||(command&&(!command.channel_types||command.channel_types.includes(this.thread.channel_type)))){this.stopTyping();return;}}
if(!this.typingNotified&&value){this.typingNotified=true;this.notifyIsTyping();browser.setTimeout(()=>(this.typingNotified=false),LONG_TYPING);}
this.stopTypingDebounced();},async sendMessage(){await super.sendMessage();this.stopTyping();},stopTyping(){if(this.typingNotified){this.typingNotified=false;this.notifyIsTyping(false);}},addEmoji(str){super.addEmoji(str);this.detectTyping();},});return __exports;});;

/* /mail/static/src/discuss/typing/common/thread_icon_patch.js */
odoo.define('@mail/discuss/typing/common/thread_icon_patch',['@mail/core/common/thread_icon','@mail/discuss/typing/common/typing','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ThreadIcon}=require("@mail/core/common/thread_icon");const{Typing}=require("@mail/discuss/typing/common/typing");const{patch}=require("@web/core/utils/patch");patch(ThreadIcon,{components:{...ThreadIcon.components,Typing},});return __exports;});;

/* /mail/static/src/discuss/typing/common/typing.js */
odoo.define('@mail/discuss/typing/common/typing',['@odoo/owl','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const Typing=__exports.Typing=class Typing extends Component{static defaultProps={size:"small",displayText:true,};static props=["channel?","size?","displayText?","member?"];static template="discuss.Typing";get text(){const typingMemberNames=this.props.member?[this.props.member.name]:this.props.channel.otherTypingMembers.map(({name})=>name);if(typingMemberNames.length===1){return _t("%s is typing...",typingMemberNames[0]);}
if(typingMemberNames.length===2){return _t("%(user1)s and %(user2)s are typing...",{user1:typingMemberNames[0],user2:typingMemberNames[1],});}
return _t("%(user1)s, %(user2)s and more are typing...",{user1:typingMemberNames[0],user2:typingMemberNames[1],});}}
return __exports;});;

/* /mail/static/src/discuss/voice_message/common/attachment_list_patch.js */
odoo.define('@mail/discuss/voice_message/common/attachment_list_patch',['@mail/core/common/attachment_list','@mail/discuss/voice_message/common/voice_player','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{AttachmentList}=require("@mail/core/common/attachment_list");const{VoicePlayer}=require("@mail/discuss/voice_message/common/voice_player");const{patch}=require("@web/core/utils/patch");patch(AttachmentList,{components:{...AttachmentList.components,VoicePlayer},});return __exports;});;

/* /mail/static/src/discuss/voice_message/common/attachment_model_patch.js */
odoo.define('@mail/discuss/voice_message/common/attachment_model_patch',['@mail/core/common/attachment_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Attachment}=require("@mail/core/common/attachment_model");const{patch}=require("@web/core/utils/patch");patch(Attachment.prototype,{get isViewable(){return!this.voice&&super.isViewable;},delete(){if(this.voice&&this.id>0){this.store.env.services["discuss.voice_message"].activePlayer=null;}
super.delete(...arguments);},});return __exports;});;

/* /mail/static/src/discuss/voice_message/common/attachment_uploader_hook_patch.js */
odoo.define('@mail/discuss/voice_message/common/attachment_uploader_hook_patch',['@mail/core/common/attachment_upload_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{AttachmentUploadService}=require("@mail/core/common/attachment_upload_service");const{patch}=require("@web/core/utils/patch");patch(AttachmentUploadService.prototype,{_makeAttachmentData(upload,tmpId,thread,tmpUrl){const attachmentData=super._makeAttachmentData(...arguments);if(upload.data.get("voice")){attachmentData.voice=upload.data.get("voice");}
return attachmentData;},_buildFormData(formData,tmpURL,thread,composer,tmpId,options){super._buildFormData(...arguments);if(options?.voice){formData.append("voice",true);}
return formData;},});return __exports;});;

/* /mail/static/src/discuss/voice_message/common/composer_model_patch.js */
odoo.define('@mail/discuss/voice_message/common/composer_model_patch',['@mail/core/common/composer_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Composer}=require("@mail/core/common/composer_model");const{patch}=require("@web/core/utils/patch");patch(Composer.prototype,{get voiceAttachment(){return this.attachments.find((attachment)=>attachment.voice);},});return __exports;});;

/* /mail/static/src/discuss/voice_message/common/composer_patch.js */
odoo.define('@mail/discuss/voice_message/common/composer_patch',['@mail/core/common/composer','@mail/discuss/voice_message/common/voice_recorder','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Composer}=require("@mail/core/common/composer");const{VoiceRecorder}=require("@mail/discuss/voice_message/common/voice_recorder");const{patch}=require("@web/core/utils/patch");patch(Composer,{components:{...Composer.components,VoiceRecorder},});patch(Composer.prototype,{setup(){super.setup();this.state.recording=false;},get isSendButtonDisabled(){return this.state.recording||super.isSendButtonDisabled;},onKeydown(ev){if(ev.key==="Enter"&&this.state.recording){ev.preventDefault();return;}
return super.onKeydown(ev);},});return __exports;});;

/* /mail/static/src/discuss/voice_message/common/mp3_encoder.js */
odoo.define('@mail/discuss/voice_message/common/mp3_encoder',[],function(require){'use strict';let __exports={};const MAX_SAMPLES=1152;const Mp3Encoder=__exports.Mp3Encoder=class Mp3Encoder{config;encoding;mp3Encoder;samplesMono;constructor(config={}){this.config={sampleRate:44100,bitRate:128,};Object.assign(this.config,config);this.mp3Encoder=new lamejs.Mp3Encoder(1,this.config.sampleRate,this.config.bitRate);this.samplesMono=null;this.clearBuffer();}
clearBuffer(){this.dataBuffer=[];}
appendToBuffer(buffer){this.dataBuffer.push(new Int8Array(buffer));}
floatTo16BitPCM(input,output){for(let i=0;i<input.length;i++){const s=Math.max(-1,Math.min(1,input[i]));output[i]=s<0?s*0x8000:s*0x7fff;}}
convertBuffer(arrayBuffer){const data=new Float32Array(arrayBuffer);const out=new Int16Array(arrayBuffer.length);this.floatTo16BitPCM(data,out);return out;}
encode(arrayBuffer){this.encoding=true;this.samplesMono=this.convertBuffer(arrayBuffer);let remaining=this.samplesMono.length;for(let i=0;remaining>=0;i+=MAX_SAMPLES){const left=this.samplesMono.subarray(i,i+MAX_SAMPLES);const mp3buffer=this.mp3Encoder.encodeBuffer(left);this.appendToBuffer(mp3buffer);remaining-=MAX_SAMPLES;}}
finish(){if(this.encoding){this.appendToBuffer(this.mp3Encoder.flush());return this.dataBuffer;}else{return[];}}}
return __exports;});;

/* /mail/static/src/discuss/voice_message/common/voice_message_service.js */
odoo.define('@mail/discuss/voice_message/common/voice_message_service',['@web/core/assets','@web/core/registry','@web/core/utils/functions'],function(require){'use strict';let __exports={};const{loadBundle}=require("@web/core/assets");const{registry}=require("@web/core/registry");const{memoize}=require("@web/core/utils/functions");const loader={loadLamejs:memoize(()=>loadBundle("mail.assets_lamejs")),};__exports.loadLamejs=loadLamejs;async function loadLamejs(){try{await loader.loadLamejs();}catch{}}
const VoiceMessageService=__exports.VoiceMessageService=class VoiceMessageService{constructor(env){this.activePlayer=null;}}
const voiceMessageService=__exports.voiceMessageService={start(env){return new VoiceMessageService(env);},};registry.category("services").add("discuss.voice_message",voiceMessageService);return __exports;});;

/* /mail/static/src/discuss/voice_message/common/voice_player.js */
odoo.define('@mail/discuss/voice_message/common/voice_player',['@odoo/owl','@web/core/browser/browser','@web/core/utils/hooks','@web/core/utils/urls'],function(require){'use strict';let __exports={};const{Component,useState,onMounted,onWillUnmount,useEffect,useRef,status,}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{useService}=require("@web/core/utils/hooks");const{url}=require("@web/core/utils/urls");const WAVE_COLOR="#7775";const VoicePlayer=__exports.VoicePlayer=class VoicePlayer extends Component{static props=["attachment"];static template="mail.VoicePlayer";lastPlaytime=0;lastPos=0;startPosition=0;progressColor;gainNode;audioCtx;scheduledPause;buffer;analyser;source;width;height;wrapper;progressWave;waveCtx;progressCtx;setup(){super.setup();this.wrapperRef=useRef("wrapper");this.drawerRef=useRef("drawer");this.waveRef=useRef("wave");this.progressRef=useRef("progress");this.voiceMessageService=useService("discuss.voice_message");this.state=useState({paused:true,playing:false,repeat:false,visualTime:"-- : --",});useEffect((playing)=>{if(playing){this.addOnAudioProcess();}},()=>[this.state.playing]);useEffect((uploading)=>{if(uploading){return;}
if(this.wasUploading&&!uploading){this.makeAudio();}
this.wasUploading=uploading;},()=>[this.props.attachment.uploading]);onMounted(()=>{this.initElements();this.wrapper.addEventListener("click",(e)=>{if(this.props.attachment.uploading){return;}
const clientX=(e.targetTouches?e.targetTouches[0]:e).clientX;const bcr=this.wrapper.getBoundingClientRect();const progressPixels=clientX-bcr.left;const progress=Math.min(Math.max(0,progressPixels/this.wrapper.scrollWidth),1);this.seekTo(progress);});if(!this.props.attachment.uploading){this.makeAudio();}
this.wasUploading=this.props.attachment.uploading;});onWillUnmount(()=>{if(this.state.playing){this.pause();}
this.destroyWebAudio();});}
makeAudio(){this.audioCtx=new browser.AudioContext();this.gainNode=this.audioCtx.createGain();this.gainNode.connect(this.audioCtx.destination);this.analyser=this.audioCtx.createAnalyser();this.analyser.connect(this.gainNode);this.fetchFile(url(this.props.attachment.urlRoute,{...this.props.attachment.urlQueryParams,})).then((arrayBuffer)=>this.drawBuffer(arrayBuffer));}
_fetch(...args){return fetch(...args);}
async fetchFile(url){const response=await this._fetch(url);if(!response.ok){throw new Error("HTTP error status: "+response.status);}
const arrayBuffer=await response.arrayBuffer();return arrayBuffer;}
getPlayedTime(){return this.audioCtx.currentTime-this.lastPlaytime;}
getCurrentTime(){if(this.state.paused){return this.startPosition;}else{return this.startPosition+this.getPlayedTime();}}
play(){if(this.voiceMessageService.activePlayer){this.voiceMessageService.activePlayer.pause();}
this.voiceMessageService.activePlayer=this;this.state.repeat=false;this.createSource();const{start,end}=this.seekToElapsed();this.scheduledPause=end;this.source.start(0,start);this.state.playing=true;this.state.paused=false;}
pause(options){this.voiceMessageService.activePlayer=null;if(options?.end){this.state.repeat=true;}
this.scheduledPause=null;this.startPosition+=this.getPlayedTime();if(this.source){try{this.source.stop();}catch(e){if(e.name==="InvalidStateError"){return;}
throw e;}}
if(!options?.continue){this.state.paused=true;this.state.playing=false;}}
getPeaks(){const peaks=[];const sampleSize=this.buffer.length/this.width;const sampleStep=Math.floor(sampleSize/10);const chan=this.buffer.getChannelData(0);let i;for(i=0;i<this.width;i++){const start=Math.floor(i*sampleSize);const end=Math.floor(start+sampleSize);let min=chan[start];let max=min;let j;for(j=start;j<end;j+=sampleStep){const value=chan[j];if(value>max){max=value;}
if(value<min){min=value;}}
peaks[i]=max;}
return peaks;}
createSource(){this.source?.disconnect();this.source=this.audioCtx.createBufferSource();this.source.buffer=this.buffer;this.source.connect(this.analyser);}
seekToElapsed(start,end){this.scheduledPause=null;if(start===undefined){start=this.getCurrentTime();if(start>=this.buffer.duration){start=0;}}
if(end===undefined){end=this.buffer.duration;}
this.startPosition=start;this.lastPlaytime=this.audioCtx.currentTime;return{start,end};}
onProgress(progress){const position=Math.round(progress*this.width);if(position<this.lastPos||position-this.lastPos>=1){this.lastPos=position;this.progressWave.style.width=position+"px";}}
seekTo(progress){if(this.state.playing){this.pause({continue:true});}
this.state.repeat=false;const elapsedTime=progress*this.buffer.duration;this.state.visualTime=this.generateTime(Math.floor(elapsedTime));this.seekToElapsed(elapsedTime);this.onProgress(progress);if(this.state.playing){this.play();}}
async drawBuffer(arrayBuffer){const buffer=await this.audioCtx.decodeAudioData(arrayBuffer);this.state.visualTime=this.generateTime(Math.floor(buffer.duration));this.startPosition=0;this.lastPlaytime=this.audioCtx.currentTime;this.buffer=buffer;this.createSource();this.drawWave(this.getPeaks());}
async destroyWebAudio(){this.source?.disconnect();this.gainNode?.disconnect();this.analyser?.disconnect();try{await this.audioCtx?.close();}catch(e){if(e.name==="InvalidStateError"){return;}
throw e;}}
addOnAudioProcess(){if(status(this)==="destroyed"){return;}
const time=this.getCurrentTime();if(time>=this.scheduledPause&&this.state.playing){this.pause({end:true});}else if(this.state.playing){this.state.visualTime=this.generateTime(Math.floor(time));const playedPercents=this.getCurrentTime()/this.buffer.duration;this.onProgress(playedPercents);requestAnimationFrame(()=>this.addOnAudioProcess());}}
generateTime(timeInSecond){const second=timeInSecond%60;const minute=Math.floor(timeInSecond/60);return((minute<10?"0"+minute:minute)+" : "+(second<10?"0"+second:second));}
initElements(){this.wrapper=this.wrapperRef.el;this.progressWave=this.drawerRef.el;this.progressColor=getComputedStyle(this.wrapper).getPropertyValue("--primary");this.width=this.wrapper.clientWidth;this.height=this.wrapper.clientHeight;const wave=this.waveRef.el;wave.width=this.width;wave.height=this.height;this.waveCtx=wave.getContext("2d");this.waveCtx.fillStyle=WAVE_COLOR;const progress=this.progressRef.el;progress.width=this.width;progress.height=this.height;this.progressCtx=progress.getContext("2d");this.progressCtx.fillStyle=this.progressColor;}
drawWave(peaks){return requestAnimationFrame(()=>{this.drawLines(peaks);this.fillRect(0,this.height/2,this.width,0.5);});}
fillRect(x,y,width,height){const intersection={x1:x,y1:y,x2:x+width,y2:y+height,};if(intersection.x1<intersection.x2){this.fillRects(intersection.x1,intersection.y1,intersection.x2-intersection.x1,intersection.y2-intersection.y1);}}
fillRects(x,y,width,height){this.waveCtx.fillRect(x,y,width,height);this.progressCtx.fillRect(x,y,width,height);}
drawLines(peaks){this.drawLineToContext(this.waveCtx,peaks);this.drawLineToContext(this.progressCtx,peaks);}
drawLineToContext(ctx,peaks){const maxPeak=Math.max(...peaks);let i,peak;for(i=0;i<=peaks.length;i++){peak=peaks[i];const h=(peak*this.height)/maxPeak;ctx.fillRect(i,(this.height-h)/2,1.5,h);}}
onClickPlayPause(){if(this.props.attachment.uploading){return;}
if(this.state.paused){this.play();}else{this.pause();}}}
return __exports;});;

/* /mail/static/src/discuss/voice_message/common/voice_recorder.js */
odoo.define('@mail/discuss/voice_message/common/voice_recorder',['@odoo/owl','@web/core/utils/hooks','@web/core/l10n/translation','@web/core/browser/browser','@mail/discuss/voice_message/common/mp3_encoder','@mail/discuss/voice_message/common/voice_message_service'],function(require){'use strict';let __exports={};const{Component,useState,onWillUnmount,status}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{Mp3Encoder}=require("@mail/discuss/voice_message/common/mp3_encoder");const{loadLamejs}=require("@mail/discuss/voice_message/common/voice_message_service");const VoiceRecorder=__exports.VoiceRecorder=class VoiceRecorder extends Component{static props=["composer","attachmentUploader","onchangeRecording?"];static template="mail.VoiceRecorder";microphone;startTimeStamp;audioContext;streamSource;processor;encoder;store;notification;config;voiceMessageService;setup(){super.setup();this.state=useState({limitWarning:false,isActionPending:false,recording:false,elapsed:"00 : 00",});this.notification=useService("notification");this.store=useState(useService("mail.store"));this.voiceMessageService=useState(useService("discuss.voice_message"));this.config={bitRate:128,};onWillUnmount(()=>{if(this.state.recording){this.notification.add(_t("Voice recording stopped"),{type:"warning"});this.stopRecording();}else{this.cleanUp({unmounting:true});}});}
filename(){return("Voice-"+
new Date().toISOString().split("T")[0]+"-"+
Math.floor(Math.random()*100000)+".mp3");}
async startRecording(){if(this.state.isActionPending){return;}
this.state.isActionPending=true;if(!this.microphone){try{this.microphone=await browser.navigator.mediaDevices.getUserMedia({audio:this.store.settings.audioConstraints,});if(status(this)==="destroyed"){this.cleanUp({unmounting:true});return;}}catch{this.notification.add(_t('"%(hostname)s" needs to access your microphone',{hostname:window.location.host,}),{type:"warning"});this.state.isActionPending=false;return;}}
this.state.elapsed="00 : 00";this.props.onchangeRecording?.();this.state.recording=true;this.audioContext=new browser.AudioContext();await loadLamejs();await this.audioContext.audioWorklet.addModule("/discuss/voice/worklet_processor");this.processor=new browser.AudioWorkletNode(this.audioContext,"processor");this.processor.port.onmessage=(e)=>{if(this.state.recording&&!this.startTimeStamp){this.startTimeStamp=e.timeStamp;}
if(!this.startTimeStamp){return;}
const elapsedSeconds=Math.floor((e.timeStamp-this.startTimeStamp)/1000);const second=elapsedSeconds%60;const minute=Math.floor(elapsedSeconds/60);this.state.elapsed=(minute<10?"0"+minute:minute)+" : "+
(second<10?"0"+second:second);if(elapsedSeconds>55&&elapsedSeconds<60){this.state.limitWarning=true;}
if(elapsedSeconds===60){this.notification.add(_t("The duration of voice messages is limited to 1 minute."),{type:"warning"});this.stopRecording();}
if(!e.data){return;}
this._encode(e.data);};this.streamSource=this.audioContext.createMediaStreamSource(this.microphone);this.streamSource.connect(this.processor);this.processor.connect(this.audioContext.destination);this.config.sampleRate=this.audioContext.sampleRate;this.encoder=new Mp3Encoder(this.config);this.state.isActionPending=false;}
_encode(data){this.encoder.encode(data);}
_getEncoderBuffer(){return this.encoder.finish();}
_makeFile(buffer,type){return new File(buffer,this.filename(),{type});}
stopRecording(){this.getMp3().then((buffer)=>{const file=this._makeFile(buffer,"audio/mp3");this.props.attachmentUploader.uploadFile(file,{voice:true});}).catch(()=>{});this.cleanUp();}
cleanUp({unmounting=false}={}){if(this.processor&&this.streamSource){this.streamSource.disconnect();this.processor.disconnect();if(this.audioContext&&this.audioContext.state!=="closed"){this.audioContext.close();}}
this.startTimeStamp=false;this.microphone?.getTracks().forEach((track)=>track.stop());this.microphone=null;this.state.recording=false;this.state.limitWarning=false;if(!unmounting){this.props.onchangeRecording?.();}}
getMp3(){const finalBuffer=this._getEncoderBuffer();return new Promise((resolve,reject)=>{if(finalBuffer.length===0){reject(new Error("No buffer to send"));}else{resolve(finalBuffer);this.encoder.clearBuffer();}});}
onClick(ev){if(this.state.recording){this.stopRecording();}else{this.startRecording();}}}
return __exports;});;

/* /mail/static/src/discuss/call/public_web/discuss_sidebar_call_indicator.js */
odoo.define('@mail/discuss/call/public_web/discuss_sidebar_call_indicator',['@mail/core/common/thread_model','@mail/discuss/core/public_web/discuss_sidebar_categories','@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Thread}=require("@mail/core/common/thread_model");const{discussSidebarChannelIndicatorsRegistry}=require("@mail/discuss/core/public_web/discuss_sidebar_categories");const{Component,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const DiscussSidebarCallIndicator=__exports.DiscussSidebarCallIndicator=class DiscussSidebarCallIndicator extends Component{static template="mail.DiscussSidebarCallIndicator";static props={thread:{type:Thread}};static components={};setup(){super.setup();this.store=useState(useService("mail.store"));this.rtc=useState(useService("discuss.rtc"));}}
discussSidebarChannelIndicatorsRegistry.add("call-indicator",DiscussSidebarCallIndicator);return __exports;});;

/* /mail/static/src/discuss/call/public_web/discuss_sidebar_call_participants.js */
odoo.define('@mail/discuss/call/public_web/discuss_sidebar_call_participants',['@odoo/owl','@web/core/utils/hooks','@mail/core/common/thread_model','@mail/discuss/call/common/call_actions','@mail/utils/common/hooks','@web/core/dropdown/dropdown_hooks','@web/core/dropdown/dropdown'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{Thread}=require("@mail/core/common/thread_model");const{callActionsRegistry}=require("@mail/discuss/call/common/call_actions");const{useHover}=require("@mail/utils/common/hooks");const{useDropdownState}=require("@web/core/dropdown/dropdown_hooks");const{Dropdown}=require("@web/core/dropdown/dropdown");const DiscussSidebarCallParticipants=__exports.DiscussSidebarCallParticipants=class DiscussSidebarCallParticipants extends Component{static template="mail.DiscussSidebarCallParticipants";static props={thread:{type:Thread},compact:{type:Boolean,optional:true}};static components={DiscussSidebarCallParticipants,Dropdown};setup(){super.setup();this.store=useState(useService("mail.store"));this.rtc=useState(useService("discuss.rtc"));this.hover=useHover(["root","floating*"],{onHover:()=>(this.floating.isOpen=true),onAway:()=>(this.floating.isOpen=false),});this.floating=useDropdownState();}
get callActionsRegistry(){return callActionsRegistry;}
get compact(){if(typeof this.props.compact==="boolean"){return this.props.compact;}
return this.store.discuss.isSidebarCompact;}
get lastActiveSession(){const sessions=[...this.props.thread.rtcSessions];sessions?.sort((s1,s2)=>{if(s1.isActuallyTalking&&!s2.isActuallyTalking){return-1;}
if(!s1.isActuallyTalking&&s2.isActuallyTalking){return 1;}
if(s1.isVideoStreaming&&!s2.isVideoStreaming){return-1;}
if(!s1.isVideoStreaming&&s2.isVideoStreaming){return 1;}
return s2.talkingTime-s1.talkingTime;});return sessions[0];}
get sessions(){const sessions=[...this.props.thread.rtcSessions];return sessions.sort((s1,s2)=>{const persona1=s1.channelMember?.persona;const persona2=s2.channelMember?.persona;return(persona1?.name?.localeCompare(persona2?.name)||s1.channelMember?.id-s2.channelMember?.id||s1.id-s2.id);});}}
return __exports;});;

/* /mail/static/src/discuss/call/public_web/discuss_sidebar_categories_patch.js */
odoo.define('@mail/discuss/call/public_web/discuss_sidebar_categories_patch',['@mail/discuss/call/public_web/discuss_sidebar_call_participants','@mail/discuss/core/public_web/discuss_sidebar_categories','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{DiscussSidebarCallParticipants}=require("@mail/discuss/call/public_web/discuss_sidebar_call_participants");const{DiscussSidebarChannel}=require("@mail/discuss/core/public_web/discuss_sidebar_categories");const{patch}=require("@web/core/utils/patch");DiscussSidebarChannel.components=Object.assign(DiscussSidebarChannel.components||{},{DiscussSidebarCallParticipants,});patch(DiscussSidebarChannel.prototype,{get attClass(){return{...super.attClass,"o-ongoingCall":this.thread.rtcSessions.length>0,};},get attClassContainer(){return{...super.attClassContainer,"o-selfInCall":this.store.rtc.selfSession?.in(this.thread.rtcSessions),};},get bordered(){return super.bordered||this.thread.rtcSessions.length>0;},});return __exports;});;

/* /mail/static/src/discuss/public_web/discuss_patch.js */
odoo.define('@mail/discuss/public_web/discuss_patch',['@mail/core/public_web/discuss','@mail/discuss/call/common/call','@odoo/owl','@web/core/utils/hooks','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Discuss}=require("@mail/core/public_web/discuss");const{Call}=require("@mail/discuss/call/common/call");const{useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");Object.assign(Discuss.components,{Call});patch(Discuss.prototype,{setup(){super.setup(...arguments);this.rtc=useState(useService("discuss.rtc"));},});return __exports;});;

/* /mail/static/src/discuss/call/web/chat_window_patch.js */
odoo.define('@mail/discuss/call/web/chat_window_patch',['@mail/core/common/chat_window','@web/core/utils/patch','@odoo/owl'],function(require){'use strict';let __exports={};const{ChatWindow}=require("@mail/core/common/chat_window");const{patch}=require("@web/core/utils/patch");const{useEffect}=require("@odoo/owl");patch(ChatWindow.prototype,{setup(...args){super.setup(...args);useEffect(()=>{if(this.props.chatWindow.thread===this.store.openInviteThread){this.threadActions.actions.find((action)=>action.id==="invite-people")?.onSelect();this.store.openInviteThread=null;}},()=>[this.store.openInviteThread]);},});return __exports;});;

/* /mail/static/src/discuss/call/web/discuss_patch.js */
odoo.define('@mail/discuss/call/web/discuss_patch',['@mail/core/public_web/discuss','@web/core/utils/patch','@odoo/owl'],function(require){'use strict';let __exports={};const{Discuss}=require("@mail/core/public_web/discuss");const{patch}=require("@web/core/utils/patch");const{useEffect}=require("@odoo/owl");patch(Discuss.prototype,{setup(...args){super.setup(...args);useEffect(()=>{if(this.thread&&this.thread===this.store.openInviteThread){this.threadActions.actions.find((action)=>action.id==="invite-people")?.onSelect();this.store.openInviteThread=null;}},()=>[this.store.openInviteThread]);},});return __exports;});;

/* /mail/static/src/discuss/call/web/messaging_menu_patch.js */
odoo.define('@mail/discuss/call/web/messaging_menu_patch',['@mail/core/public_web/messaging_menu','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{MessagingMenu}=require("@mail/core/public_web/messaging_menu");const{patch}=require("@web/core/utils/patch");patch(MessagingMenu.prototype,{async onClickStartMeeting(){this.store.startMeeting();this.dropdown.close();},});return __exports;});;

/* /mail/static/src/discuss/web/avatar_card/avatar_card_popover.js */
odoo.define('@mail/discuss/web/avatar_card/avatar_card_popover',['@web/core/utils/hooks','@odoo/owl','@mail/core/web/open_chat_hook'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{Component,onWillStart}=require("@odoo/owl");const{useOpenChat}=require("@mail/core/web/open_chat_hook");const AvatarCardPopover=__exports.AvatarCardPopover=class AvatarCardPopover extends Component{static template="mail.AvatarCardPopover";static props={id:{type:Number,required:true},close:{type:Function,required:true},};setup(){this.actionService=useService("action");this.orm=useService("orm");this.openChat=useOpenChat("res.users");onWillStart(async()=>{[this.user]=await this.orm.read("res.users",[this.props.id],this.fieldNames);});}
get fieldNames(){return["name","email","phone","im_status","share","partner_id"];}
get email(){return this.user.email;}
get phone(){return this.user.phone;}
get showViewProfileBtn(){return true;}
async getProfileAction(){return{res_id:this.user.partner_id[0],res_model:"res.partner",type:"ir.actions.act_window",views:[[false,"form"]],};}
get userId(){return this.user.id;}
onSendClick(){this.openChat(this.userId);this.props.close();}
async onClickViewProfile(){const action=await this.getProfileAction();this.actionService.doAction(action);}}
return __exports;});;

/* /mail/static/src/discuss/web/discuss_core_common_service_patch.js */
odoo.define('@mail/discuss/web/discuss_core_common_service_patch',['@mail/discuss/core/common/discuss_core_common_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{DiscussCoreCommon}=require("@mail/discuss/core/common/discuss_core_common_service");const{patch}=require("@web/core/utils/patch");patch(DiscussCoreCommon.prototype,{_handleNotificationChannelDelete(thread,metadata){const{notifId}=metadata;const filteredStarredMessages=[];let starredCounter=0;for(const msg of this.store.starred.messages){if(!msg.thread?.eq(thread)){filteredStarredMessages.push(msg);}else{starredCounter++;}}
this.store.starred.messages=filteredStarredMessages;if(notifId>this.store.starred.counter_bus_id){this.store.starred.counter-=starredCounter;}
this.store.inbox.messages=this.store.inbox.messages.filter((msg)=>!msg.thread?.eq(thread));if(notifId>this.store.inbox.counter_bus_id){this.store.inbox.counter-=thread.message_needaction_counter;}
this.store.history.messages=this.store.history.messages.filter((msg)=>!msg.thread?.eq(thread));if(thread.eq(this.store.discuss.thread)){this.store.inbox.setAsDiscussThread();}
super._handleNotificationChannelDelete(thread,metadata);},});return __exports;});;

/* /mail/static/src/views/fields/statusbar_duration/statusbar_duration_field.js */
odoo.define('@mail/views/fields/statusbar_duration/statusbar_duration_field',['@web/core/l10n/dates','@web/core/l10n/translation','@web/core/registry','@web/views/fields/statusbar/statusbar_field'],function(require){'use strict';let __exports={};const{formatDuration}=require("@web/core/l10n/dates");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{statusBarField,StatusBarField}=require("@web/views/fields/statusbar/statusbar_field");const StatusBarDurationField=__exports.StatusBarDurationField=class StatusBarDurationField extends StatusBarField{static template="mail.StatusBarDurationField";getAllItems(){const items=super.getAllItems();const durationTracking=this.props.record.data.duration_tracking||{};if(Object.keys(durationTracking).length){for(const item of items){const duration=durationTracking[item.value];if(duration>0){item.shortTimeInStage=formatDuration(duration,false);item.fullTimeInStage=formatDuration(duration,true);}else{item.shortTimeInStage=0;}}}
return items;}}
const statusBarDurationField=__exports.statusBarDurationField={...statusBarField,component:StatusBarDurationField,displayName:_t("Status with time"),supportedTypes:["many2one"],fieldDependencies:[{name:"duration_tracking",type:"JSON"}],};registry.category("fields").add("statusbar_duration",statusBarDurationField);return __exports;});;

/* /onboarding/static/src/views/form/onboarding_step_form_controller.js */
odoo.define('@onboarding/views/form/onboarding_step_form_controller',['@web/views/form/form_controller','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{FormController}=require("@web/views/form/form_controller");const{useService}=require("@web/core/utils/hooks");const OnboardingStepFormController=__exports[Symbol.for("default")]=class OnboardingStepFormController extends FormController{setup(){super.setup();this.action=useService('action');this.orm=useService('orm');}
async save({closable,...otherParams}){const saved=await super.save(otherParams);if(saved){const{reloadOnFirstValidation,reloadAlways}=this.stepConfig;const validationResponse=await this.orm.call('onboarding.onboarding.step','action_validate_step',[this.stepName],);if(reloadAlways||(reloadOnFirstValidation&&validationResponse==="JUST_DONE")){this.action.restore(this.action.currentController.jsId);}else if(closable){this.action.doAction({type:"ir.actions.act_window_close"});}}
return saved;}
get stepName(){return''}
get stepConfig(){return{reloadAlways:false,reloadOnFirstValidation:false};}}
return __exports;});;

/* /product/static/src/js/pricelist_report/product_pricelist_report.js */
odoo.define('@product/js/pricelist_report/product_pricelist_report',['@odoo/owl','@web/core/l10n/translation','@web/core/network/download','@web/core/registry','@web/core/utils/hooks','@web/search/action_hook','@web/search/layout','@web/views/view_dialogs/select_create_dialog','@web/webclient/actions/action_service'],function(require){'use strict';let __exports={};const{Component,markup,onRendered,onWillStart,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{download}=require("@web/core/network/download");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{useSetupAction}=require("@web/search/action_hook");const{Layout}=require("@web/search/layout");const{SelectCreateDialog}=require("@web/views/view_dialogs/select_create_dialog");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");function sendCustomNotification(type,message){return{type:"ir.actions.client",tag:"display_notification",params:{"type":type,"message":message},}}
const ProductPricelistReport=__exports.ProductPricelistReport=class ProductPricelistReport extends Component{static props={...standardActionServiceProps};static components={Layout};static template="product.ProductPricelistReport";setup(){this.action=useService("action");this.orm=useService("orm");this.dialog=useService("dialog");this.MAX_QTY=5;const pastState=this.props.state||{};const active_model=pastState.activeModel||this.props.action.context.active_model;this.noProducts=active_model==='product.pricelist';this.activeIds=this.noProducts?[]:pastState.activeIds||this.props.action.context.active_ids;this.activeModel=this.noProducts?'product.template':active_model;this.defaultPricelistId=this.noProducts?this.props.action.context.active_id:false;this.state=useState({displayPricelistTitle:pastState.displayPricelistTitle||false,html:"",pricelists:[],_quantities:pastState.quantities||[1,5,10],selectedPricelist:{},});onWillStart(async()=>{this.state.pricelists=await this.getPricelists();if(this.defaultPricelistId){this.state.selectedPricelist=this.pricelists.find(p=>p.id===this.defaultPricelistId)||this.pricelists[0];}else{this.state.selectedPricelist=pastState.selectedPricelist||this.pricelists[0];}
if(this.noProducts){await this.onClickAddProducts();}
this.renderHtml();});onRendered(()=>{this.env.config.setDisplayName(_t("Pricelist Report"));});useSetupAction({getLocalState:()=>{return{displayPricelistTitle:this.displayPricelistTitle,quantities:this.quantities,selectedPricelist:this.selectedPricelist,activeModel:this.activeModel,activeIds:this.activeIds,};},});}
get displayPricelistTitle(){return this.state.displayPricelistTitle;}
get html(){return this.state.html;}
get pricelists(){return this.state.pricelists;}
get quantities(){return this.state._quantities;}
set quantities(value){this.state._quantities=value;}
get reportParams(){return{active_model:this.activeModel||'product.template',active_ids:this.activeIds||[],display_pricelist_title:this.displayPricelistTitle||'',pricelist_id:this.selectedPricelist.id||'',quantities:this.quantities||[1],};}
get selectedPricelist(){return this.state.selectedPricelist;}
getPricelists(){return this.orm.searchRead("product.pricelist",[],["id","name"]);}
async renderHtml(){if(this.noProducts){this.state.html="";return}
let html=await this.orm.call("report.product.report_pricelist","get_html",[],{data:this.reportParams});this.state.html=markup(html);}
async onClickAddQty(ev){ev.preventDefault();if(this.quantities.length>=this.MAX_QTY){let message=_t("At most %s quantities can be displayed simultaneously. Remove a selected quantity to add others.",this.MAX_QTY);await this.action.doAction(sendCustomNotification("warning",message));return;}
const qty=parseInt(ev.target.previousSibling.value);if(qty>0){if(this.quantities.indexOf(qty)===-1){this.quantities.push(qty);this.quantities=this.quantities.sort((a,b)=>a-b);this.renderHtml();}else{let message=_t("Quantity already present (%s).",qty);await this.action.doAction(sendCustomNotification("info",message));}}else{await this.action.doAction(sendCustomNotification("info",_t("Please enter a positive whole number.")));}}
onClickLink(ev){ev.preventDefault();const parent=ev.target.parentElement;let classes=parent.getAttribute("class","");let resModel=parent.getAttribute("data-model","");let resId=parent.getAttribute("data-res-id","");if(classes&&classes.includes("o_action")&&resModel&&resId){this.action.doAction({type:'ir.actions.act_window',res_model:resModel,res_id:parseInt(resId),views:[[false,'form']],target:'self',});}}
async onClickPrint(){if(this.noProducts){this.action.doAction(sendCustomNotification("warning",_t("Please select some products first.")));return;}
const selectedFormat=document.getElementById('formats').value;if(selectedFormat==='pdf'){this.export_pdf();}else{await this.export_pricelist_csv_xlsx(selectedFormat);}}
export_pdf(){this.action.doAction({type:'ir.actions.report',report_type:'qweb-pdf',report_name:'product.report_pricelist',report_file:'product.report_pricelist',data:this.reportParams,});}
async export_pricelist_csv_xlsx(format){try{await download({url:`/product/export/pricelist/`,data:{report_data:JSON.stringify(this.reportParams),export_format:format,}});}catch(error){console.error(`Error exporting ${format.toUpperCase()} file:`,error);await this.action.doAction(sendCustomNotification("danger",_t("Error exporting file. Please try again.")));}}
async onClickAddProducts(){this.dialog.add(SelectCreateDialog,{resModel:this.activeModel||'product.template',title:_t("Add Products to pricelist report"),noCreate:true,onSelected:async(resIds)=>{resIds.forEach((id)=>{if(!this.activeIds.includes(id)){this.activeIds.push(id);}});this.noProducts=false;await this.renderHtml();},});}
async onClickRemoveQty(ev){if(this.quantities.length<=1){await this.action.doAction(sendCustomNotification("warning",_t("You must leave at least one quantity.")));return;}
const qty=parseInt(ev.srcElement.parentElement.childNodes[0].data);this.quantities=this.quantities.filter(q=>q!==qty);this.renderHtml();}
onSelectPricelist(ev){this.state.selectedPricelist=this.pricelists.filter(pricelist=>pricelist.id===parseInt(ev.target.value))[0];this.renderHtml();}
onToggleDisplayPricelist(){this.state.displayPricelistTitle=!this.displayPricelistTitle;this.renderHtml();}}
registry.category("actions").add("generate_pricelist_report",ProductPricelistReport);return __exports;});;

/* /product/static/src/js/product_attribute_value_list.js */
odoo.define('@product/js/product_attribute_value_list',['@web/core/l10n/translation','@web/core/confirmation_dialog/confirmation_dialog','@web/views/list/list_renderer','@web/core/registry','@web/core/utils/hooks','@web/views/fields/x2many/x2many_field'],function(require){'use strict';let __exports={};const{_t}=require('@web/core/l10n/translation');const{ConfirmationDialog,deleteConfirmationMessage}=require('@web/core/confirmation_dialog/confirmation_dialog');const{ListRenderer}=require('@web/views/list/list_renderer');const{registry}=require('@web/core/registry');const{useService}=require('@web/core/utils/hooks');const{X2ManyField,x2ManyField}=require('@web/views/fields/x2many/x2many_field');const PAVListRenderer=__exports.PAVListRenderer=class PAVListRenderer extends ListRenderer{setup(){super.setup();this.dialog=useService("dialog");this.orm=useService("orm");}
async onDeleteRecord(record){const message=await this.orm.call('product.attribute.value','check_is_used_on_products',[record.resId],)
if(message){return this.dialog.add(ConfirmationDialog,{title:_t("Invalid Operation"),body:message,});}
if(record.isNew){return super.onDeleteRecord(...arguments);}
this.dialog.add(ConfirmationDialog,{title:_t("Bye-bye, record!"),body:deleteConfirmationMessage,confirmLabel:_t("Delete"),confirm:()=>this.onConfirmDelete(record),cancel:()=>{},cancelLabel:_t("No, keep it"),});}
async onConfirmDelete(record){await this.orm.unlink('product.attribute.value',[record.resId])
const res=await super.onDeleteRecord(record);await this.props.list.model.root.save();return res;}}
const PAVOne2ManyField=__exports.PAVOne2ManyField=class PAVOne2ManyField extends X2ManyField{static components={...X2ManyField.components,ListRenderer:PAVListRenderer,};}
const pavOne2ManyField=__exports.pavOne2ManyField={...x2ManyField,component:PAVOne2ManyField,}
registry.category("fields").add("pavs_one2many",pavOne2ManyField);return __exports;});;

/* /product/static/src/js/product_document_kanban/product_document_kanban_controller.js */
odoo.define('@product/js/product_document_kanban/product_document_kanban_controller',['@product/js/product_document_kanban/upload_button/upload_button','@web/views/kanban/kanban_controller'],function(require){'use strict';let __exports={};const{UploadButton}=require('@product/js/product_document_kanban/upload_button/upload_button');const{KanbanController}=require('@web/views/kanban/kanban_controller');const ProductDocumentKanbanController=__exports.ProductDocumentKanbanController=class ProductDocumentKanbanController extends KanbanController{static components={...KanbanController.components,UploadButton};setup(){super.setup();this.uploadRoute='/product/document/upload';this.formData={'res_model':this.props.context.default_res_model,'res_id':this.props.context.default_res_id,};}}
return __exports;});;

/* /product/static/src/js/product_document_kanban/product_document_kanban_record.js */
odoo.define('@product/js/product_document_kanban/product_document_kanban_record',['@web/views/kanban/kanban_record','@web/core/utils/hooks','@web/core/file_viewer/file_viewer_hook'],function(require){'use strict';let __exports={};const{CANCEL_GLOBAL_CLICK,KanbanRecord}=require("@web/views/kanban/kanban_record");const{useService}=require("@web/core/utils/hooks");const{useFileViewer}=require("@web/core/file_viewer/file_viewer_hook");const ProductDocumentKanbanRecord=__exports.ProductDocumentKanbanRecord=class ProductDocumentKanbanRecord extends KanbanRecord{setup(){super.setup();this.store=useService("mail.store");this.fileViewer=useFileViewer();}
onGlobalClick(ev){if(ev.target.closest(CANCEL_GLOBAL_CLICK)){return;}else if(ev.target.closest(".o_kanban_previewer")){const attachment=this.store.Attachment.insert({id:this.props.record.data.ir_attachment_id[0],filename:this.props.record.data.name,name:this.props.record.data.name,mimetype:this.props.record.data.mimetype,});this.fileViewer.open(attachment)
return;}
return super.onGlobalClick(...arguments);}}
return __exports;});;

/* /product/static/src/js/product_document_kanban/product_document_kanban_renderer.js */
odoo.define('@product/js/product_document_kanban/product_document_kanban_renderer',['@web/core/utils/hooks','@web/views/kanban/kanban_renderer','@product/js/product_document_kanban/product_document_kanban_record','@web/core/file_upload/file_upload_progress_container','@web/core/file_upload/file_upload_progress_record'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{ProductDocumentKanbanRecord}=require("@product/js/product_document_kanban/product_document_kanban_record");const{FileUploadProgressContainer}=require("@web/core/file_upload/file_upload_progress_container");const{FileUploadProgressKanbanRecord}=require("@web/core/file_upload/file_upload_progress_record");const ProductDocumentKanbanRenderer=__exports.ProductDocumentKanbanRenderer=class ProductDocumentKanbanRenderer extends KanbanRenderer{static components={...KanbanRenderer.components,FileUploadProgressContainer,FileUploadProgressKanbanRecord,KanbanRecord:ProductDocumentKanbanRecord,};static template="product.ProductDocumentKanbanRenderer";setup(){super.setup();this.fileUploadService=useService("file_upload");}}
return __exports;});;

/* /product/static/src/js/product_document_kanban/product_document_kanban_view.js */
odoo.define('@product/js/product_document_kanban/product_document_kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@product/js/product_document_kanban/product_document_kanban_controller','@product/js/product_document_kanban/product_document_kanban_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{ProductDocumentKanbanController}=require("@product/js/product_document_kanban/product_document_kanban_controller");const{ProductDocumentKanbanRenderer}=require("@product/js/product_document_kanban/product_document_kanban_renderer");const productDocumentKanbanView=__exports.productDocumentKanbanView={...kanbanView,Controller:ProductDocumentKanbanController,Renderer:ProductDocumentKanbanRenderer,buttonTemplate:"product.ProductDocumentKanbanView.Buttons",};registry.category("views").add("product_documents_kanban",productDocumentKanbanView);return __exports;});;

/* /product/static/src/js/product_document_kanban/upload_button/upload_button.js */
odoo.define('@product/js/product_document_kanban/upload_button/upload_button',['@web/core/l10n/translation','@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component,useRef}=require("@odoo/owl");const{useBus,useService}=require("@web/core/utils/hooks");const UploadButton=__exports.UploadButton=class UploadButton extends Component{static template="product.UploadButton";static props={formData:{type:Object,optional:true},allowedMIMETypes:{type:String,optional:true},load:Function,uploadRoute:String,}
static defaultProps={formData:{},}
setup(){this.uploadFileInputRef=useRef("uploadFileInput");this.fileUploadService=useService("file_upload");this.notification=useService('notification');useBus(this.fileUploadService.bus,"FILE_UPLOAD_LOADED",async()=>{await this.props.load();},);}
async onFileInputChange(ev){const files=[...ev.target.files].filter(file=>this.validFileType(file));if(!files.length){return;}
await this.fileUploadService.upload(this.props.uploadRoute,files,{buildFormData:(formData)=>this.buildFormData(formData)},);ev.target.value="";}
validFileType(file){if(this.props.allowedMIMETypes&&!this.props.allowedMIMETypes.includes(file.type)){this.notification.add(_t(`Oops! '%(fileName)s' didn’t upload since its format isn’t allowed.`,{fileName:file.name,}),{type:"danger",});return false;}
return true;}
buildFormData(formData){for(const[key,value]of Object.entries(this.props.formData)){formData.append(key,value);}}}
return __exports;});;

/* /product/static/src/product_catalog/kanban_controller.js */
odoo.define('@product/product_catalog/kanban_controller',['@web/views/kanban/kanban_controller','@odoo/owl','@web/core/utils/hooks','@web/core/utils/timing','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{KanbanController}=require("@web/views/kanban/kanban_controller");const{onWillStart}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{useDebounced}=require("@web/core/utils/timing");const{_t}=require("@web/core/l10n/translation");const ProductCatalogKanbanController=__exports.ProductCatalogKanbanController=class ProductCatalogKanbanController extends KanbanController{static template="ProductCatalogKanbanController";setup(){super.setup();this.action=useService("action");this.orm=useService("orm");this.orderId=this.props.context.order_id;this.orderResModel=this.props.context.product_catalog_order_model;this.backToQuotationDebounced=useDebounced(this.backToQuotation,500)
onWillStart(async()=>this._defineButtonContent());}
get canCreate(){return true;}
async _defineButtonContent(){const orderStateInfo=await this.orm.searchRead(this.orderResModel,[["id","=",this.orderId]],["state"]);const orderIsQuotation=["draft","sent"].includes(orderStateInfo[0].state);if(orderIsQuotation){this.buttonString=_t("Back to Quotation");}else{this.buttonString=_t("Back to Order");}}
async backToQuotation(){if(this.env.config.breadcrumbs.length>1){await this.action.restore();}else{await this.action.doAction({type:"ir.actions.act_window",res_model:this.orderResModel,views:[[false,"form"]],view_mode:"form",res_id:this.orderId,});}}}
return __exports;});;

/* /product/static/src/product_catalog/kanban_model.js */
odoo.define('@product/product_catalog/kanban_model',['@web/core/network/rpc','@web/model/relational_model/record','@web/model/relational_model/relational_model'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{Record}=require("@web/model/relational_model/record");const{RelationalModel}=require("@web/model/relational_model/relational_model");class ProductCatalogRecord extends Record{setup(config,data,options={}){this.productCatalogData=data.productCatalogData;data={...data};delete data.productCatalogData;super.setup(config,data,options);}}
const ProductCatalogKanbanModel=__exports.ProductCatalogKanbanModel=class ProductCatalogKanbanModel extends RelationalModel{static Record=ProductCatalogRecord;async _loadData(params){const result=await super._loadData(...arguments);if(!params.isMonoRecord&&!params.groupBy.length){const orderLinesInfo=await rpc("/product/catalog/order_lines_info",this._getOrderLinesInfoParams(params,result.records.map((rec)=>rec.id)));for(const record of result.records){record.productCatalogData=orderLinesInfo[record.id];}}
return result;}
_getOrderLinesInfoParams(params,productIds){return{order_id:params.context.order_id,product_ids:productIds,res_model:params.context.product_catalog_order_model,child_field:params.context?.child_field,}}}
return __exports;});;

/* /product/static/src/product_catalog/kanban_record.js */
odoo.define('@product/product_catalog/kanban_record',['@odoo/owl','@web/core/network/rpc','@web/core/utils/timing','@web/views/kanban/kanban_record','@product/product_catalog/order_line/order_line'],function(require){'use strict';let __exports={};const{useSubEnv}=require("@odoo/owl");const{rpc}=require("@web/core/network/rpc");const{useDebounced}=require("@web/core/utils/timing");const{KanbanRecord}=require("@web/views/kanban/kanban_record");const{ProductCatalogOrderLine}=require("@product/product_catalog/order_line/order_line");const ProductCatalogKanbanRecord=__exports.ProductCatalogKanbanRecord=class ProductCatalogKanbanRecord extends KanbanRecord{static template="ProductCatalogKanbanRecord";static components={...KanbanRecord.components,ProductCatalogOrderLine,};setup(){super.setup();this.debouncedUpdateQuantity=useDebounced(this._updateQuantity,500,{execBeforeUnmount:true,});useSubEnv({currencyId:this.props.record.context.product_catalog_currency_id,orderId:this.props.record.context.product_catalog_order_id,orderResModel:this.props.record.context.product_catalog_order_model,digits:this.props.record.context.product_catalog_digits,displayUoM:this.props.record.context.display_uom,precision:this.props.record.context.precision,productId:this.props.record.resId,addProduct:this.addProduct.bind(this),removeProduct:this.removeProduct.bind(this),increaseQuantity:this.increaseQuantity.bind(this),setQuantity:this.setQuantity.bind(this),decreaseQuantity:this.decreaseQuantity.bind(this),childField:this.props.record.context?.child_field});}
get orderLineComponent(){return ProductCatalogOrderLine;}
get productCatalogData(){return this.props.record.productCatalogData;}
onGlobalClick(ev){if(ev.target.closest(".o_product_catalog_cancel_global_click")){return;}
if(this.productCatalogData.quantity===0){this.addProduct();}else{this.increaseQuantity();}}
async _updateQuantity(){const price=await this._updateQuantityAndGetPrice();this.productCatalogData.price=parseFloat(price);}
_updateQuantityAndGetPrice(){return rpc("/product/catalog/update_order_line_info",this._getUpdateQuantityAndGetPriceParams());}
_getUpdateQuantityAndGetPriceParams(){return{order_id:this.env.orderId,product_id:this.env.productId,quantity:this.productCatalogData.quantity,res_model:this.env.orderResModel,child_field:this.env.childField,}}
updateQuantity(quantity){if(this.productCatalogData.readOnly){return;}
this.productCatalogData.quantity=quantity||0;this.debouncedUpdateQuantity();}
addProduct(qty=1){this.updateQuantity(qty);}
removeProduct(){this.updateQuantity(0);}
increaseQuantity(qty=1){this.updateQuantity(this.productCatalogData.quantity+qty);}
setQuantity(event){this.updateQuantity(parseFloat(event.target.value));}
decreaseQuantity(){this.updateQuantity(parseFloat(this.productCatalogData.quantity-1));}}
return __exports;});;

/* /product/static/src/product_catalog/kanban_renderer.js */
odoo.define('@product/product_catalog/kanban_renderer',['@web/views/kanban/kanban_renderer','@web/core/utils/hooks','@product/product_catalog/kanban_record'],function(require){'use strict';let __exports={};const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{useService}=require("@web/core/utils/hooks");const{ProductCatalogKanbanRecord}=require("@product/product_catalog/kanban_record");const ProductCatalogKanbanRenderer=__exports.ProductCatalogKanbanRenderer=class ProductCatalogKanbanRenderer extends KanbanRenderer{static template="ProductCatalogKanbanRenderer";static components={...KanbanRenderer.components,KanbanRecord:ProductCatalogKanbanRecord,};setup(){super.setup();this.action=useService("action");}
get createProductContext(){return{};}
async createProduct(){await this.action.doAction({type:"ir.actions.act_window",res_model:"product.product",target:"new",views:[[false,"form"]],view_mode:"form",context:this.createProductContext,},{onClose:()=>this.props.list.model.load(),});}}
return __exports;});;

/* /product/static/src/product_catalog/kanban_view.js */
odoo.define('@product/product_catalog/kanban_view',['@web/views/kanban/kanban_view','@web/core/registry','@product/product_catalog/kanban_controller','@product/product_catalog/kanban_model','@product/product_catalog/kanban_renderer','@product/product_catalog/search/search_panel'],function(require){'use strict';let __exports={};const{kanbanView}=require("@web/views/kanban/kanban_view");const{registry}=require("@web/core/registry");const{ProductCatalogKanbanController}=require("@product/product_catalog/kanban_controller");const{ProductCatalogKanbanModel}=require("@product/product_catalog/kanban_model");const{ProductCatalogKanbanRenderer}=require("@product/product_catalog/kanban_renderer");const{ProductCatalogSearchPanel}=require("@product/product_catalog/search/search_panel");const productCatalogKanbanView=__exports.productCatalogKanbanView={...kanbanView,Controller:ProductCatalogKanbanController,Model:ProductCatalogKanbanModel,Renderer:ProductCatalogKanbanRenderer,SearchPanel:ProductCatalogSearchPanel,};registry.category("views").add("product_kanban_catalog",productCatalogKanbanView);return __exports;});;

/* /product/static/src/product_catalog/order_line/order_line.js */
odoo.define('@product/product_catalog/order_line/order_line',['@odoo/owl','@web/views/fields/formatters'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{formatFloat,formatMonetary}=require("@web/views/fields/formatters");const ProductCatalogOrderLine=__exports.ProductCatalogOrderLine=class ProductCatalogOrderLine extends Component{static template="product.ProductCatalogOrderLine";static props={productId:Number,quantity:Number,price:Number,productType:String,readOnly:{type:Boolean,optional:true},warning:{type:String,optional:true},};_onFocus(ev){ev.target.select();}
isInOrder(){return this.props.quantity!==0;}
get disableRemove(){return false;}
get disabledButtonTooltip(){return"";}
get price(){const{currencyId,digits}=this.env;return formatMonetary(this.props.price,{currencyId,digits});}
get quantity(){const digits=[false,this.env.precision];const options={digits,decimalPoint:".",thousandsSep:""};return parseFloat(formatFloat(this.props.quantity,options));}
get showPrice(){return true;}}
return __exports;});;

/* /product/static/src/product_catalog/search/search_panel.js */
odoo.define('@product/product_catalog/search/search_panel',['@web/search/search_panel/search_panel','@odoo/owl'],function(require){'use strict';let __exports={};const{SearchPanel}=require("@web/search/search_panel/search_panel");const{useState}=require("@odoo/owl");const ProductCatalogSearchPanel=__exports.ProductCatalogSearchPanel=class ProductCatalogSearchPanel extends SearchPanel{static subTemplates={...SearchPanel.subTemplates,filtersGroup:"ProductCatalogSearchPanel.FiltersGroup",};setup(){super.setup();this.state=useState({...this.state,sectionOfAttributes:{},});}
updateActiveValues(){super.updateActiveValues();this.state.sectionOfAttributes=this.buildSection();}
buildSection(){const values=this.env.searchModel.filters[0].values;let sections=new Map();values.forEach(element=>{const name=element.display_name;const id=element.id;const count=element.__count;if(sections.has(name)){let currentAttr=sections.get(name);currentAttr.get('ids').push(id);currentAttr.set('count',currentAttr.get('count')+count);}else if(count>0){let newAttr=new Map();newAttr.set('ids',[id]);newAttr.set('count',count);sections.set(name,newAttr);}});return sections;}
toggleSectionFilterValue(filterId,attrIds,{currentTarget}){attrIds.forEach(id=>{this.toggleFilterValue(filterId,id,{currentTarget});})}}
return __exports;});;

/* /analytic/static/src/components/analytic_distribution/analytic_distribution.js */
odoo.define('@analytic/components/analytic_distribution/analytic_distribution',['@web/core/registry','@web/core/utils/hooks','@web/core/py_js/py','@web/core/utils/ui','@web/core/position/position_hook','@web/core/hotkeys/hotkey_service','@web/core/utils/arrays','@web/core/utils/numbers','@web/core/browser/feature_detection','@web/core/l10n/translation','@web/model/relational_model/utils','@web/views/fields/standard_field_props','@web/core/tags_list/tags_list','@web/views/fields/relational_utils','@web/views/fields/formatters','@web/model/record','@web/views/fields/field','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{evaluateExpr}=require("@web/core/py_js/py");const{getNextTabableElement,getPreviousTabableElement}=require("@web/core/utils/ui");const{usePosition}=require("@web/core/position/position_hook");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const{shallowEqual}=require("@web/core/utils/arrays");const{roundDecimals}=require("@web/core/utils/numbers");const{isMobileOS}=require("@web/core/browser/feature_detection");const{_t}=require("@web/core/l10n/translation");const{useRecordObserver}=require("@web/model/relational_model/utils");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{TagsList}=require("@web/core/tags_list/tags_list");const{useOpenMany2XRecord}=require("@web/views/fields/relational_utils");const{formatPercentage}=require("@web/views/fields/formatters");const{Record}=require("@web/model/record");const{Field}=require("@web/views/fields/field");const{Component,useState,useRef,useExternalListener,onWillStart,onPatched,}=require("@odoo/owl");const AnalyticDistribution=__exports.AnalyticDistribution=class AnalyticDistribution extends Component{static template="analytic.AnalyticDistribution";static components={TagsList,Record,Field,}
static props={...standardFieldProps,business_domain:{type:String,optional:true},account_field:{type:String,optional:true},product_field:{type:String,optional:true},amount_field:{type:String,optional:true},business_domain_compute:{type:String,optional:true},force_applicability:{type:String,optional:true},allow_save:{type:Boolean,optional:true},}
setup(){this.orm=useService("orm");this.batchedOrm=useService("batchedOrm");this.state=useState({showDropdown:false,formattedData:[],});this.widgetRef=useRef("analyticDistribution");this.dropdownRef=useRef("analyticDropdown");this.mainRef=useRef("mainElement");this.addLineButton=useRef("addLineButton");usePosition("analyticDropdown",()=>this.widgetRef.el);this.nextId=1;this.focusSelector=false;this.currentValue=this.props.record.data[this.props.name];onWillStart(this.willStart);useRecordObserver(this.willUpdateRecord.bind(this));onPatched(this.patched);useExternalListener(window,"click",this.onWindowClick,true);useExternalListener(window,"resize",this.onWindowResized);this.openTemplate=useOpenMany2XRecord({resModel:"account.analytic.distribution.model",activeActions:{create:true,edit:false,write:true,},isToMany:false,onRecordSaved:async(record)=>{if(!this.props.record.model.multiEdit){this.mainRef.el.focus();}},onClose:()=>{if(!this.props.record.model.multiEdit){this.mainRef.el.focus();}},fieldString:_t("Analytic Distribution Model"),});this.allPlans=[];this.lastAccount=this.props.account_field&&this.props.record.data[this.props.account_field]||false;this.lastProduct=this.props.product_field&&this.props.record.data[this.props.product_field]||false;}
async willStart(){if(this.editingRecord){await this.fetchAllPlans(this.props);}
await this.jsonToData(this.props.record.data[this.props.name]);}
async willUpdateRecord(record){const valueChanged=JSON.stringify(this.currentValue)!==JSON.stringify(record.data[this.props.name]);const currentAccount=this.props.account_field&&record.data[this.props.account_field]||false;const currentProduct=this.props.product_field&&record.data[this.props.product_field]||false;const accountChanged=!shallowEqual(this.lastAccount,currentAccount);const productChanged=!shallowEqual(this.lastProduct,currentProduct);if(valueChanged||accountChanged||productChanged){if(!this.props.force_applicability){await this.fetchAllPlans({record});}
this.lastAccount=accountChanged&&currentAccount||this.lastAccount;this.lastProduct=productChanged&&currentProduct||this.lastProduct;await this.jsonToData(record.data[this.props.name]);}
this.currentValue=record.data[this.props.name];}
patched(){this.focusToSelector();}
accountTotalsByPlan(){const accountTotals={};this.state.formattedData.map((line)=>{line.analyticAccounts.map((column)=>{if(column.accountId){let{accId=column.accountId,accName=column.accountDisplayName,total=0.0,planId=column.accountRootPlanId,planColor=column.accountColor,}=accountTotals[column.accountRootPlanId]?.[column.accountId]||{};total+=roundDecimals(line.percentage,this.decimalPrecision.digits[1]+2);accountTotals[planId]=accountTotals[planId]||{};accountTotals[planId][accId]={accId,accName,planId,total,planColor};}})});return accountTotals;}
planTotals(){const summary=this.accountTotalsByPlan();this.allPlans.map((plan)=>{const planTotal=(summary[plan.id]&&Object.values(summary[plan.id])||[]).reduce((prev,next)=>prev+next.total,0.0);const className=plan.applicability==="mandatory"&&!this.planIsComplete(planTotal)?'text-danger':plan.applicability==="mandatory"?'text-success':'';summary[plan.id]={value:planTotal,formattedValue:formatPercentage(planTotal,this.decimalPrecision),class:className,applicability:plan.applicability,}});return summary;}
planIsComplete(total){return roundDecimals(total,this.decimalPrecision.digits[1]+2)===1;}
planSummaryTags(){const accountTotals=this.accountTotalsByPlan();return Object.values(accountTotals).map((planSummary)=>{const accs=Object.values(planSummary);return{id:accs[0].planId,text:accs.reduce((p,n)=>p+(p.length?" | ":"")+(this.planIsComplete(n.total)?n.accName:`${formatPercentage(n.total)} ${n.accName}`),""),colorIndex:accs[0].planColor,onClick:(ev)=>this.tagClicked(ev),};});}
plansToArray(){return this.allPlans.map((plan)=>({planId:plan.id,planName:plan.name,planColor:plan.color,}));}
async jsonToData(jsonFieldValue){const analyticAccountIds=jsonFieldValue?Object.keys(jsonFieldValue).map((key)=>key.split(',')).flat().map((id)=>parseInt(id)):[];const analyticAccountDict=analyticAccountIds.length?await this.fetchAnalyticAccounts([["id","in",analyticAccountIds]]):[];let distribution=[];let accountNotFound=false;for(const[accountIds,percentage]of Object.entries(jsonFieldValue)){const defaultVals=this.plansToArray();const ids=accountIds.split(',');for(const id of ids){const account=analyticAccountDict[parseInt(id)];if(account){Object.assign(defaultVals.find((plan)=>plan.planId==account.root_plan_id[0])||defaultVals.push({})&&defaultVals[defaultVals.length-1],{accountId:parseInt(id),accountDisplayName:account.display_name,accountColor:account.color,accountRootPlanId:account.root_plan_id[0],});}else{accountNotFound=true;}}
distribution.push({analyticAccounts:defaultVals,percentage:percentage/100,id:this.nextId++,})}
this.state.formattedData=distribution;if(accountNotFound){await this.save();}}
recordProps(line){const analyticAccountFields={id:{type:"int"},display_name:{type:"char"},color:{type:"int"},plan_id:{type:"many2one"},root_plan_id:{type:"many2one"},};let recordFields={};const values={};line.analyticAccounts.map((account)=>{const fieldName=`x_plan${account.planId}_id`;recordFields[fieldName]={string:account.planName,relation:"account.analytic.account",type:"many2one",related:{fields:analyticAccountFields,activeFields:analyticAccountFields,},domain:[["root_plan_id","=",account.planId]],};values[fieldName]=account?.accountId||false;});recordFields['percentage']={string:_t("Percentage"),type:"percentage",cellClass:"numeric_column_width",...this.decimalPrecision,};values['percentage']=line.percentage;if(this.props.amount_field){const{string,name,type,currency_field}=this.props.record.fields[this.props.amount_field];recordFields[name]={string,name,type,currency_field,cellClass:"numeric_column_width"};values[name]=this.props.record.data[name]*values['percentage'];if(currency_field){const{string,name,type,relation}=this.props.record.fields[currency_field];recordFields[currency_field]={name,string,type,relation,invisible:true};values[currency_field]=this.props.record.data[currency_field][0];}}
return{fields:recordFields,values:values,activeFields:recordFields,onRecordChanged:async(record,changes)=>await this.lineChanged(record,changes,line),}}
accountCount(line){return line.analyticAccounts.map((acc)=>acc.accountId).filter(Boolean).length;}
lineIsValid(line){return this.accountCount(line)&&line.percentage;}
fetchPlansArgs({record}){let args={};if(this.props.business_domain_compute){args['business_domain']=evaluateExpr(this.props.business_domain_compute,record.evalContext);}
if(this.props.business_domain){args['business_domain']=this.props.business_domain;}
if(this.props.product_field&&record.data[this.props.product_field]){args['product']=record.data[this.props.product_field][0];}
if(this.props.account_field&&record.data[this.props.account_field]){args['account']=record.data[this.props.account_field][0];}
if(this.props.force_applicability){args['applicability']=this.props.force_applicability;}
const existing_account_ids=Object.keys(record.data[this.props.name]).map((k)=>k.split(",")).flat().map((i)=>parseInt(i));if(existing_account_ids.length){args['existing_account_ids']=existing_account_ids;}
if(record.data.company_id){args['company_id']=record.data.company_id[0];}
return args;}
async fetchAllPlans(props){const argsPlan=this.fetchPlansArgs(props);this.allPlans=await this.orm.call("account.analytic.plan","get_relevant_plans",[],argsPlan);}
async fetchAnalyticAccounts(domain){const args={domain:domain,fields:["id","display_name","root_plan_id","color"],context:[],}
const records=await this.batchedOrm.read("account.analytic.account",domain[0][2],args.fields,{});return Object.assign({},...records.map((r)=>{const{id,...rest}=r;return{[id]:rest};}));}
async lineChanged(record,changes,line){for(const account of line.analyticAccounts){const selected=record.data[`x_plan${account.planId}_id`];account.accountId=selected[0];account.accountDisplayName=selected[1];account.accountColor=account.planColor;account.accountRootPlanId=account.planId;}
if(changes.percentage!=line.percentage){roundDecimals(line.percentage=record.data.percentage,this.decimalPrecision.digits[1]+2);}else if(this.valueColumnEnabled&&changes[this.props.amount_field]!=line[this.props.amount_field]){line.percentage=roundDecimals(record.data[this.props.amount_field]/this.props.record.data[this.props.amount_field],this.decimalPrecision.digits[1]+2);}}
get valueColumnEnabled(){return Boolean(this.props.amount_field&&this.props.record.data[this.props.amount_field]);}
get decimalPrecision(){return{digits:[12,this.props.record.data.analytic_precision||2]};}
get allowSave(){return this.props.allow_save&&this.state.formattedData.some((line)=>this.lineIsValid(line));}
get editingRecord(){return!this.props.readonly;}
get isDropdownOpen(){return this.state.showDropdown&&!!this.dropdownRef.el;}
addLine(){let maxMandatory=0,maxOptional=0,hasMandatory=false;Object.values(this.planTotals()).filter((plan)=>plan.value<1).map((plan)=>{if(plan.applicability=="mandatory"){maxMandatory=Math.max(plan.value,maxMandatory);hasMandatory=true;}else{maxOptional=Math.max(plan.value,maxOptional);}});let noPlanTotal=this.state.formattedData.filter((line)=>!this.accountCount(line)).reduce((p,n)=>p+n.percentage,0);const remainder=roundDecimals(1-(hasMandatory?maxMandatory:(maxOptional||noPlanTotal)),this.decimalPrecision.digits[1]+2);const lineToAdd={id:this.nextId++,analyticAccounts:this.plansToArray(),percentage:Math.max(remainder,0)||1,}
this.state.formattedData.push(lineToAdd);this.setFocusSelector(`[name=line_${this.state.formattedData.length - 1}] td:first-of-type`);}
deleteLine(index){this.state.formattedData.splice(index,1);if(!this.state.formattedData.length){this.addLine();}}
dataToJson(){const result={};this.state.formattedData=this.state.formattedData.filter((line)=>this.accountCount(line));this.state.formattedData.map((line)=>{const key=line.analyticAccounts.reduce((p,n)=>p.concat(n.accountId?n.accountId:[]),[]);result[key]=(result[key]||0)+line.percentage*100;});return result;}
async save(){await this.props.record.update({[this.props.name]:this.dataToJson()});}
onSaveNew(){this.closeAnalyticEditor();const{record,product_field,account_field}=this.props;this.openTemplate({resId:false,context:{'default_analytic_distribution':this.dataToJson(),'default_partner_id':record.data['partner_id']?record.data['partner_id'][0]:undefined,'default_product_id':product_field?record.data[product_field][0]:undefined,'default_account_prefix':account_field?record.data[account_field][1].substr(0,3):undefined,}});}
forceCloseEditor(){this.preventOpen=true;this.closeAnalyticEditor();this.mainRef.el.focus();this.preventOpen=false;}
closeAnalyticEditor(){this.save();this.state.showDropdown=false;}
async openAnalyticEditor(){if(!this.allPlans.length){await this.fetchAllPlans(this.props);await this.jsonToData(this.props.record.data[this.props.name]);}
if(!this.state.formattedData.length){await this.addLine();}
this.setFocusSelector("[name='line_0'] td:first-of-type");this.state.showDropdown=true;}
async tagClicked(ev){if(this.editingRecord&&!this.isDropdownOpen){await this.openAnalyticEditor();}
if(this.isDropdownOpen){this.setFocusSelector("[name='line_0'] td:first-of-type");this.focusToSelector();ev.stopPropagation();}}
onMainElementFocus(ev){if(!this.isDropdownOpen&&!this.preventOpen){this.openAnalyticEditor();}}
focusToSelector(){if(this.focusSelector&&this.isDropdownOpen){this.focus(this.adjacentElementToFocus("next",this.dropdownRef.el.querySelector(this.focusSelector)));}
this.focusSelector=false;}
setFocusSelector(selector){this.focusSelector=selector;}
adjacentElementToFocus(direction,el=null){if(!this.isDropdownOpen){return null;}
if(!el){el=this.dropdownRef.el;}
return direction=="next"?getNextTabableElement(el):getPreviousTabableElement(el);}
focusAdjacent(direction){const elementToFocus=this.adjacentElementToFocus(direction);if(elementToFocus){this.focus(elementToFocus);return true;}
return false;}
focus(el){if(!el)return;el.focus();if(["INPUT","TEXTAREA"].includes(el.tagName)){if(el.selectionStart){el.selectionStart=0;el.selectionEnd=el.value.length;}
el.select();}}
async onWidgetKeydown(ev){if(!this.editingRecord){return;}
const hotkey=getActiveHotkey(ev);switch(hotkey){case"enter":case"tab":{if(this.isDropdownOpen){const closestCell=ev.target.closest("td, th");const row=closestCell.parentElement;const line=this.state.formattedData[parseInt(row.id)];if(this.adjacentElementToFocus("next")==this.addLineButton.el&&line&&this.lineIsValid(line)){this.addLine();break;}
this.focusAdjacent("next")||this.forceCloseEditor();break;};return;}
case"shift+tab":{if(this.isDropdownOpen){this.focusAdjacent("previous")||this.forceCloseEditor();break;};return;}
case"escape":{if(this.isDropdownOpen){this.forceCloseEditor();break;}}
case"arrowdown":{if(!this.isDropdownOpen){this.onMainElementFocus();break;}
return;}
default:{return;}}
ev.preventDefault();ev.stopPropagation();}
onWindowClick(ev){const selectors=[".o_popover",".modal:not(.o_inactive_modal):not(:has(.o_act_window))",];if(this.isDropdownOpen&&!this.widgetRef.el.contains(ev.target)&&!ev.target.closest(selectors.join(","))&&!ev.target.isSameNode(document.documentElement)){this.forceCloseEditor();}}
onWindowResized(){if(this.isDropdownOpen&&!isMobileOS()){this.forceCloseEditor();}}}
const analyticDistribution=__exports.analyticDistribution={component:AnalyticDistribution,supportedTypes:["char","text"],fieldDependencies:[{name:"analytic_precision",type:"integer"}],supportedOptions:[{label:_t("Disable save"),name:"disable_save",type:"boolean",},{label:_t("Force applicability"),name:"force_applicability",type:"boolean",},{label:_t("Business domain"),name:"business_domain",type:"string",},{label:_t("Product field"),name:"product_field",type:"field",availableTypes:["many2one"],},{label:_t("Amount field"),name:"amount_field",type:"field",availableTypes:["monetary"],},{label:_t("Account field"),name:"account_field",type:"field",availableTypes:["many2one"],}],extractProps:({attrs,options})=>({business_domain:options.business_domain,account_field:options.account_field,product_field:options.product_field,amount_field:options.amount_field,business_domain_compute:attrs.business_domain_compute,force_applicability:options.force_applicability,allow_save:!options.disable_save,}),};registry.category("fields").add("analytic_distribution",analyticDistribution);return __exports;});;

/* /analytic/static/src/services/batched_orm_service.js */
odoo.define('@analytic/services/batched_orm_service',['@web/core/registry','@web/core/orm_service','@web/core/utils/arrays','@web/core/utils/concurrency'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{ORM}=require("@web/core/orm_service");const{unique}=require("@web/core/utils/arrays");const{Deferred}=require("@web/core/utils/concurrency");class RequestBatcherORM extends ORM{constructor(){super();this.searchReadBatches={};this.searchReadBatchId=1;this.batches={};}
async batch(ids,keys,callback){const key=JSON.stringify(keys);let batch=this.batches[key];if(!batch){batch={deferred:new Deferred(),scheduled:false,ids:[],};this.batches[key]=batch;}
batch.ids=unique([...batch.ids,...ids]);if(!batch.scheduled){batch.scheduled=true;Promise.resolve().then(async()=>{delete this.batches[key];let result;try{result=await callback(batch.ids);}catch(e){return batch.deferred.reject(e);}
batch.deferred.resolve(result);});}
return batch.deferred;}
async read(resModel,resIds,fields,kwargs){const records=await this.batch(resIds,["read",resModel,fields,kwargs],(resIds)=>super.read(resModel,resIds,fields,kwargs));return records.filter((r)=>resIds.includes(r.id));}}
const batchedOrmService=__exports.batchedOrmService={async:["call","create","nameGet","read","readGroup","search","searchRead","unlink","webSearchRead","write",],start(){return new RequestBatcherORM();},};registry.category("services").add("batchedOrm",batchedOrmService);return __exports;});;

/* /web_editor/static/lib/vkbeautify/vkbeautify.0.99.00.beta.js */
(function(){function createShiftArr(step){var space='    ';if(isNaN(parseInt(step))){space=step;}else{switch(step){case 1:space=' ';break;case 2:space='  ';break;case 3:space='   ';break;case 4:space='    ';break;case 5:space='     ';break;case 6:space='      ';break;case 7:space='       ';break;case 8:space='        ';break;case 9:space='         ';break;case 10:space='          ';break;case 11:space='           ';break;case 12:space='            ';break;}}
var shift=['\n'];for(ix=0;ix<100;ix++){shift.push(shift[ix]+space);}
return shift;}
function vkbeautify(){this.step='    ';this.shift=createShiftArr(this.step);};vkbeautify.prototype.xml=function(text,step){var ar=text.replace(/>\s{0,}</g,"><").replace(/</g,"~::~<").replace(/\s*xmlns\:/g,"~::~xmlns:").replace(/\s*xmlns\=/g,"~::~xmlns=").split('~::~'),len=ar.length,inComment=false,deep=0,str='',ix=0,shift=step?createShiftArr(step):this.shift;for(ix=0;ix<len;ix++){if(ar[ix].search(/<!/)>-1){str+=shift[deep]+ar[ix];inComment=true;if(ar[ix].search(/-->/)>-1||ar[ix].search(/\]>/)>-1||ar[ix].search(/!DOCTYPE/)>-1){inComment=false;}}else
if(ar[ix].search(/-->/)>-1||ar[ix].search(/\]>/)>-1){str+=ar[ix];inComment=false;}else
if(/^<\w/.exec(ar[ix-1])&&/^<\/\w/.exec(ar[ix])&&/^<[\w:\-\.\,]+/.exec(ar[ix-1])==/^<\/[\w:\-\.\,]+/.exec(ar[ix])[0].replace('/','')){str+=ar[ix];if(!inComment)deep--;}else
if(ar[ix].search(/<\w/)>-1&&ar[ix].search(/<\//)==-1&&ar[ix].search(/\/>/)==-1){str=!inComment?str+=shift[deep++]+ar[ix]:str+=ar[ix];}else
if(ar[ix].search(/<\w/)>-1&&ar[ix].search(/<\//)>-1){str=!inComment?str+=shift[deep]+ar[ix]:str+=ar[ix];}else
if(ar[ix].search(/<\//)>-1){str=!inComment?str+=shift[--deep]+ar[ix]:str+=ar[ix];}else
if(ar[ix].search(/\/>/)>-1){str=!inComment?str+=shift[deep]+ar[ix]:str+=ar[ix];}else
if(ar[ix].search(/<\?/)>-1){str+=shift[deep]+ar[ix];}else
if(ar[ix].search(/xmlns\:/)>-1||ar[ix].search(/xmlns\=/)>-1){str+=shift[deep]+ar[ix];}
else{str+=ar[ix];}}
return(str[0]=='\n')?str.slice(1):str;}
vkbeautify.prototype.json=function(text,step){var step=step?step:this.step;if(typeof JSON==='undefined')return text;if(typeof text==="string")return JSON.stringify(JSON.parse(text),null,step);if(typeof text==="object")return JSON.stringify(text,null,step);return text;}
vkbeautify.prototype.css=function(text,step){var ar=text.replace(/\s{1,}/g,' ').replace(/\{/g,"{~::~").replace(/\}/g,"~::~}~::~").replace(/\;/g,";~::~").replace(/\/\*/g,"~::~/*").replace(/\*\//g,"*/~::~").replace(/~::~\s{0,}~::~/g,"~::~").split('~::~'),len=ar.length,deep=0,str='',ix=0,shift=step?createShiftArr(step):this.shift;for(ix=0;ix<len;ix++){if(/\{/.exec(ar[ix])){str+=shift[deep++]+ar[ix];}else
if(/\}/.exec(ar[ix])){str+=shift[--deep]+ar[ix];}else
if(/\*\\/.exec(ar[ix])){str+=shift[deep]+ar[ix];}
else{str+=shift[deep]+ar[ix];}}
return str.replace(/^\n{1,}/,'');}
function isSubquery(str,parenthesisLevel){return parenthesisLevel-(str.replace(/\(/g,'').length-str.replace(/\)/g,'').length)}
function split_sql(str,tab){return str.replace(/\s{1,}/g," ").replace(/ AND /ig,"~::~"+tab+tab+"AND ").replace(/ BETWEEN /ig,"~::~"+tab+"BETWEEN ").replace(/ CASE /ig,"~::~"+tab+"CASE ").replace(/ ELSE /ig,"~::~"+tab+"ELSE ").replace(/ END /ig,"~::~"+tab+"END ").replace(/ FROM /ig,"~::~FROM ").replace(/ GROUP\s{1,}BY/ig,"~::~GROUP BY ").replace(/ HAVING /ig,"~::~HAVING ").replace(/ IN /ig," IN ").replace(/ JOIN /ig,"~::~JOIN ").replace(/ CROSS~::~{1,}JOIN /ig,"~::~CROSS JOIN ").replace(/ INNER~::~{1,}JOIN /ig,"~::~INNER JOIN ").replace(/ LEFT~::~{1,}JOIN /ig,"~::~LEFT JOIN ").replace(/ RIGHT~::~{1,}JOIN /ig,"~::~RIGHT JOIN ").replace(/ ON /ig,"~::~"+tab+"ON ").replace(/ OR /ig,"~::~"+tab+tab+"OR ").replace(/ ORDER\s{1,}BY/ig,"~::~ORDER BY ").replace(/ OVER /ig,"~::~"+tab+"OVER ").replace(/\(\s{0,}SELECT /ig,"~::~(SELECT ").replace(/\)\s{0,}SELECT /ig,")~::~SELECT ").replace(/ THEN /ig," THEN~::~"+tab+"").replace(/ UNION /ig,"~::~UNION~::~").replace(/ USING /ig,"~::~USING ").replace(/ WHEN /ig,"~::~"+tab+"WHEN ").replace(/ WHERE /ig,"~::~WHERE ").replace(/ WITH /ig,"~::~WITH ").replace(/ ALL /ig," ALL ").replace(/ AS /ig," AS ").replace(/ ASC /ig," ASC ").replace(/ DESC /ig," DESC ").replace(/ DISTINCT /ig," DISTINCT ").replace(/ EXISTS /ig," EXISTS ").replace(/ NOT /ig," NOT ").replace(/ NULL /ig," NULL ").replace(/ LIKE /ig," LIKE ").replace(/\s{0,}SELECT /ig,"SELECT ").replace(/\s{0,}UPDATE /ig,"UPDATE ").replace(/ SET /ig," SET ").replace(/~::~{1,}/g,"~::~").split('~::~');}
vkbeautify.prototype.sql=function(text,step){var ar_by_quote=text.replace(/\s{1,}/g," ").replace(/\'/ig,"~::~\'").split('~::~'),len=ar_by_quote.length,ar=[],deep=0,tab=this.step,inComment=true,inQuote=false,parenthesisLevel=0,str='',ix=0,shift=step?createShiftArr(step):this.shift;;for(ix=0;ix<len;ix++){if(ix%2){ar=ar.concat(ar_by_quote[ix]);}else{ar=ar.concat(split_sql(ar_by_quote[ix],tab));}}
len=ar.length;for(ix=0;ix<len;ix++){parenthesisLevel=isSubquery(ar[ix],parenthesisLevel);if(/\s{0,}\s{0,}SELECT\s{0,}/.exec(ar[ix])){ar[ix]=ar[ix].replace(/\,/g,",\n"+tab+tab+"")}
if(/\s{0,}\s{0,}SET\s{0,}/.exec(ar[ix])){ar[ix]=ar[ix].replace(/\,/g,",\n"+tab+tab+"")}
if(/\s{0,}\(\s{0,}SELECT\s{0,}/.exec(ar[ix])){deep++;str+=shift[deep]+ar[ix];}else
if(/\'/.exec(ar[ix])){if(parenthesisLevel<1&&deep){deep--;}
str+=ar[ix];}
else{str+=shift[deep]+ar[ix];if(parenthesisLevel<1&&deep){deep--;}}
var junk=0;}
str=str.replace(/^\n{1,}/,'').replace(/\n{1,}/g,"\n");return str;}
vkbeautify.prototype.xmlmin=function(text,preserveComments){var str=preserveComments?text:text.replace(/\<![ \r\n\t]*(--([^\-]|[\r\n]|-[^\-])*--[ \r\n\t]*)\>/g,"").replace(/[ \r\n\t]{1,}xmlns/g,' xmlns');return str.replace(/>\s{0,}</g,"><");}
vkbeautify.prototype.jsonmin=function(text){if(typeof JSON==='undefined')return text;return JSON.stringify(JSON.parse(text),null,0);}
vkbeautify.prototype.cssmin=function(text,preserveComments){var str=preserveComments?text:text.replace(/\/\*([^*]|[\r\n]|(\*+([^*/]|[\r\n])))*\*+\//g,"");return str.replace(/\s{1,}/g,' ').replace(/\{\s{1,}/g,"{").replace(/\}\s{1,}/g,"}").replace(/\;\s{1,}/g,";").replace(/\/\*\s{1,}/g,"/*").replace(/\*\/\s{1,}/g,"*/");}
vkbeautify.prototype.sqlmin=function(text){return text.replace(/\s{1,}/g," ").replace(/\s{1,}\(/,"(").replace(/\s{1,}\)/,")");}
window.vkbeautify=new vkbeautify();})();;

/* /web_editor/static/src/js/common/browser_extensions.js */
odoo.define('@web_editor/js/common/browser_extensions',[],function(require){'use strict';let __exports={};const originalGetRangeAt=Selection.prototype.getRangeAt;Selection.prototype.getRangeAt=function(){let range=originalGetRangeAt.apply(this,arguments);if(range.startContainer&&!Object.getPrototypeOf(range.startContainer)){range=document.createRange();range.setStart(this.anchorNode,0);range.setEnd(this.focusNode,0);}
return range;};return __exports;});;

/* /web_editor/static/src/js/common/column_layout_mixin.js */
odoo.define('@web_editor/js/common/column_layout_mixin',[],function(require){'use strict';let __exports={};const ColumnLayoutMixin=__exports.ColumnLayoutMixin={_getNbColumns(columnEls,isMobile){if(!columnEls){return 0;}
if(this._areColsCustomized(columnEls,isMobile)){return"custom";}
const resolutionModifier=isMobile?"":"lg-";const colRegex=new RegExp(`(?:^|\\s+)col-${resolutionModifier}(\\d{1,2})(?!\\S)`);const colSize=parseInt(columnEls[0].className.match(colRegex)?.[1]||12);const offsetSize=this._getFirstItem(columnEls,isMobile).classList.contains(`offset-${resolutionModifier}1`)?1:0;return Math.floor((12-offsetSize)/colSize);},_getFirstItem(columnEls,isMobile){return isMobile&&[...columnEls].find(el=>el.style.order==="0")||columnEls[0];},_addMobileOrders(columnEls){for(let i=0;i<columnEls.length;i++){columnEls[i].style.order=i;columnEls[i].classList.add("order-lg-0");}},_removeMobileOrders(columnEls){for(const el of columnEls){el.style.order="";el.classList.remove("order-lg-0");}},_areColsCustomized(columnEls,isMobile){const resolutionModifier=isMobile?"":"lg-";const colRegex=new RegExp(`(?:^|\\s+)col-${resolutionModifier}(\\d{1,2})(?!\\S)`);const colSize=parseInt(columnEls[0].className.match(colRegex)?.[1]||12);const allColsSizesEqual=[...columnEls].every((columnEl)=>parseInt(columnEl.className.match(colRegex)?.[1]||12)===colSize);if(!allColsSizesEqual){return true;}
const offsetRegex=new RegExp(`(?:^|\\s+)offset-${resolutionModifier}[1-9][0-1]?(?!\\S)`);const nbOffsets=[...columnEls].filter((columnEl)=>columnEl.className.match(offsetRegex)).length;if(nbOffsets===0){return false;}
if(nbOffsets===1&&colSize===2&&this._getFirstItem(columnEls,isMobile).className.match(`offset-${resolutionModifier}1`)){return false;}
return true;},_fillRemovedItemGap(parentEl,itemOrder){[...parentEl.children].forEach(el=>{const elOrder=parseInt(el.style.order);if(elOrder>itemOrder){el.style.order=elOrder-1;}});},};return __exports;});;

/* /web_editor/static/src/js/common/grid_layout_utils.js */
odoo.define('@web_editor/js/common/grid_layout_utils',['@web/core/utils/render','@web_editor/js/editor/odoo-editor/src/utils/utils'],function(require){'use strict';let __exports={};const{renderToElement}=require("@web/core/utils/render");const{descendants,preserveCursor}=require("@web_editor/js/editor/odoo-editor/src/utils/utils");const rowSize=__exports.rowSize=50;const additionalRowLimit=__exports.additionalRowLimit=10;const defaultGridPadding=10;__exports._getGridProperties=_getGridProperties;function _getGridProperties(rowEl){const style=window.getComputedStyle(rowEl);const rowGap=parseFloat(style.rowGap);const columnGap=parseFloat(style.columnGap);const columnSize=(rowEl.clientWidth-11*columnGap)/12;return{rowGap:rowGap,rowSize:rowSize,columnGap:columnGap,columnSize:columnSize};}
__exports._setElementToMaxZindex=_setElementToMaxZindex;function _setElementToMaxZindex(element,rowEl){const childrenEls=[...rowEl.children].filter(el=>el!==element&&!el.classList.contains("o_we_grid_preview"));element.style.zIndex=Math.max(...childrenEls.map(el=>el.style.zIndex))+1;}
__exports._addBackgroundGrid=_addBackgroundGrid;function _addBackgroundGrid(rowEl,gridHeight){const gridProp=_getGridProperties(rowEl);const rowCount=Math.max(rowEl.dataset.rowCount,gridHeight);const backgroundGrid=renderToElement('web_editor.background_grid',{rowCount:rowCount+1,rowGap:gridProp.rowGap,rowSize:gridProp.rowSize,columnGap:gridProp.columnGap,columnSize:gridProp.columnSize,});rowEl.prepend(backgroundGrid);return rowEl.firstElementChild;}
__exports._resizeGrid=_resizeGrid;function _resizeGrid(rowEl){const columnEls=[...rowEl.children].filter(c=>c.classList.contains('o_grid_item'));rowEl.dataset.rowCount=Math.max(...columnEls.map(el=>el.style.gridRowEnd))-1;}
__exports._gridCleanUp=_gridCleanUp;function _gridCleanUp(rowEl,columnEl){columnEl.style.removeProperty('position');columnEl.style.removeProperty('top');columnEl.style.removeProperty('left');columnEl.style.removeProperty('height');columnEl.style.removeProperty('width');rowEl.style.removeProperty('position');}
__exports._toggleGridMode=_toggleGridMode;function _toggleGridMode(containerEl){let rowEl=containerEl.querySelector(':scope > .row');const outOfRowEls=[...containerEl.children].filter(el=>!el.classList.contains('row'));const avoidRollback=(el)=>{for(const node of descendants(el)){node.ouid=undefined;}};const restoreCursor=!rowEl||outOfRowEls.length>0?preserveCursor(containerEl.ownerDocument):()=>{};if(rowEl&&outOfRowEls.length>0){const columnEl=document.createElement('div');columnEl.classList.add('col-lg-12');for(let i=outOfRowEls.length-1;i>=0;i--){columnEl.prepend(outOfRowEls[i]);}
avoidRollback(columnEl);rowEl.prepend(columnEl);}
if(!rowEl){rowEl=document.createElement('div');rowEl.classList.add('row');const columnEl=document.createElement('div');columnEl.classList.add('col-lg-12');const containerChildren=containerEl.children;for(let i=containerChildren.length-1;i>=0;i--){columnEl.prepend(containerChildren[i]);}
avoidRollback(columnEl);rowEl.appendChild(columnEl);containerEl.appendChild(rowEl);}
restoreCursor();const columnEls=rowEl.children;const columnSize=(rowEl.clientWidth)/12;rowEl.style.position='relative';const rowCount=_placeColumns(columnEls,rowSize,0,columnSize,0)-1;rowEl.style.removeProperty('position');rowEl.dataset.rowCount=rowCount;const classesToRemove=[...rowEl.classList].filter(c=>{return/^align-items/.test(c);});rowEl.classList.remove(...classesToRemove);rowEl.classList.add('o_grid_mode');}
function _placeColumns(columnEls,rowSize,rowGap,columnSize,columnGap){let maxRowEnd=0;const columnSpans=[];let zIndex=1;const imageColumns=[];for(const columnEl of columnEls){let isImageColumn=_checkIfImageColumn(columnEl);const imageEl=columnEl.querySelector('img');const hasBackgroundColor=columnEl.classList.contains("o_cc");const isImageWithoutPadding=isImageColumn&&!hasBackgroundColor;const style=window.getComputedStyle(columnEl);const borderLeft=parseFloat(style.borderLeft);const columnLeft=isImageWithoutPadding&&!borderLeft?imageEl.offsetLeft:columnEl.offsetLeft;const paddingLeft=parseFloat(style.paddingLeft);let width=isImageWithoutPadding?parseFloat(imageEl.scrollWidth):parseFloat(columnEl.scrollWidth)-(hasBackgroundColor?0:2*paddingLeft);const borderX=borderLeft+parseFloat(style.borderRight);width+=borderX+(hasBackgroundColor||isImageColumn?0:2*defaultGridPadding);let columnSpan=Math.round((width+columnGap)/(columnSize+columnGap));if(columnSpan<1){columnSpan=1;}
const columnStart=Math.round(columnLeft/(columnSize+columnGap))+1;const columnEnd=columnStart+columnSpan;const borderTop=parseFloat(style.borderTop);const columnTop=isImageWithoutPadding&&!borderTop?imageEl.offsetTop:columnEl.offsetTop;const paddingTop=parseFloat(style.paddingTop);const paddingBottom=parseFloat(style.paddingBottom);const rowOffsetTop=Math.floor((paddingTop+rowGap)/(rowSize+rowGap));let height=isImageWithoutPadding?parseFloat(imageEl.scrollHeight):parseFloat(columnEl.scrollHeight)-(hasBackgroundColor?0:paddingTop+paddingBottom);const borderY=borderTop+parseFloat(style.borderBottom);height+=borderY+(hasBackgroundColor||isImageColumn?0:2*defaultGridPadding);const rowSpan=Math.ceil((height+rowGap)/(rowSize+rowGap));const rowStart=Math.round(columnTop/(rowSize+rowGap))+1+(hasBackgroundColor||isImageWithoutPadding?0:rowOffsetTop);const rowEnd=rowStart+rowSpan;columnEl.style.gridArea=`${rowStart} / ${columnStart} / ${rowEnd} / ${columnEnd}`;columnEl.classList.add('o_grid_item');columnEl.classList.add('g-col-lg-'+columnSpan,'g-height-'+rowSpan);columnEl.style.zIndex=zIndex++;if(hasBackgroundColor){columnEl.style.setProperty("--grid-item-padding-y",`${paddingTop}px`);columnEl.style.setProperty("--grid-item-padding-x",`${paddingLeft}px`);}
_reloadLazyImages(columnEl);maxRowEnd=Math.max(rowEnd,maxRowEnd);columnSpans.push(columnSpan);imageColumns.push(isImageColumn);}
for(const[i,columnEl]of[...columnEls].entries()){const regex=/^(((pt|pb)\d{1,3}$)|col-lg-|offset-lg-)/;const toRemove=[...columnEl.classList].filter(c=>{return regex.test(c);});columnEl.classList.remove(...toRemove);columnEl.classList.add('col-lg-'+columnSpans[i]);if(imageColumns[i]){_convertImageColumn(columnEl);}}
return maxRowEnd;}
__exports._reloadLazyImages=_reloadLazyImages;function _reloadLazyImages(columnEl){const imageEls=columnEl.querySelectorAll('img');for(const imageEl of imageEls){const src=imageEl.getAttribute("src");imageEl.src='';imageEl.src=src;}}
__exports._convertColumnToGrid=_convertColumnToGrid;function _convertColumnToGrid(rowEl,columnEl,columnWidth,columnHeight){if(_checkIfImageColumn(columnEl)){_convertImageColumn(columnEl);}
const paddingX=parseFloat(rowEl.style.getPropertyValue("--grid-item-padding-x"))||defaultGridPadding;const paddingY=parseFloat(rowEl.style.getPropertyValue("--grid-item-padding-y"))||defaultGridPadding;columnWidth+=2*paddingX;columnHeight+=2*paddingY;const gridProp=_getGridProperties(rowEl);const columnColCount=Math.round((columnWidth+gridProp.columnGap)/(gridProp.columnSize+gridProp.columnGap));const columnRowCount=Math.ceil((columnHeight+gridProp.rowGap)/(gridProp.rowSize+gridProp.rowGap));const regex=/^(pt|pb|col-|offset-)/;const toRemove=[...columnEl.classList].filter(c=>regex.test(c));columnEl.classList.remove(...toRemove);columnEl.classList.add('g-col-lg-'+columnColCount,'g-height-'+columnRowCount,'col-lg-'+columnColCount);columnEl.classList.add('o_grid_item');return{columnColCount:columnColCount,columnRowCount:columnRowCount};}
__exports._convertToNormalColumn=_convertToNormalColumn;function _convertToNormalColumn(columnEl){const gridSizeClasses=columnEl.className.match(/(g-col-lg|g-height)-[0-9]+/g);columnEl.classList.remove("o_grid_item","o_grid_item_image","o_grid_item_image_contain",...gridSizeClasses);columnEl.style.removeProperty("z-index");columnEl.style.removeProperty("--grid-item-padding-x");columnEl.style.removeProperty("--grid-item-padding-y");columnEl.style.removeProperty("grid-area");}
__exports._checkIfImageColumn=_checkIfImageColumn;function _checkIfImageColumn(columnEl){let isImageColumn=false;const imageEls=columnEl.querySelectorAll(":scope > img, :scope > a > img");const columnChildrenEls=[...columnEl.children].filter(el=>el.nodeName!=='BR');if(imageEls.length===1&&columnChildrenEls.length===1){const textNodeEls=[...columnEl.childNodes].filter(el=>el.nodeType===Node.TEXT_NODE);const areTextNodesEmpty=[...textNodeEls].every(textNodeEl=>textNodeEl.nodeValue.trim()==='');isImageColumn=areTextNodesEmpty;}
return isImageColumn;}
function _convertImageColumn(columnEl){columnEl.querySelectorAll('br').forEach(el=>el.remove());const textNodeEls=[...columnEl.childNodes].filter(el=>el.nodeType===Node.TEXT_NODE);textNodeEls.forEach(el=>el.remove());const imageEl=columnEl.querySelector('img');columnEl.classList.add('o_grid_item_image');imageEl.style.removeProperty('width');}
return __exports;});;

/* /web_editor/static/src/js/common/scrolling.js */
odoo.define('@web_editor/js/common/scrolling',['@web/core/utils/scrolling'],function(require){'use strict';let __exports={};const{getScrollingElement}=require("@web/core/utils/scrolling");function isScrollable(element){if(!element){return false;}
const overflowY=window.getComputedStyle(element).overflowY;return overflowY==='auto'||overflowY==='scroll'||(overflowY==='visible'&&element===element.ownerDocument.scrollingElement);}
__exports.closestScrollable=closestScrollable;function closestScrollable(element){const document=element.ownerDocument||window.document;while(element&&element!==document.scrollingElement){if(element instanceof Document){return null;}
if(isScrollable(element)){return element;}
element=element.parentElement;}
return element||document.scrollingElement;}
function scrollFixedOffset(doc=document){let size=0;const elements=doc.querySelectorAll('.o_top_fixed_element');elements.forEach(el=>{size+=el.offsetHeight;});return size;}
__exports.scrollTo=scrollTo;function scrollTo(el,options={}){if(!el){throw new Error("The scrollTo function was called without any given element");}
if(typeof el==='string'){el=document.querySelector(el);}
const isTopOrBottomHidden=(el==="top"||el==="bottom");const scrollable=isTopOrBottomHidden?document.scrollingElement:(options.scrollable||closestScrollable(el.parentElement));const scrollDocument=scrollable.ownerDocument;const isInOneDocument=isTopOrBottomHidden||scrollDocument===el.ownerDocument;const iframe=!isInOneDocument&&Array.from(scrollable.querySelectorAll('iframe')).find(node=>node.contentDocument.contains(el));const topLevelScrollable=getScrollingElement(scrollDocument);function _computeScrollTop(){if(el==='#top'||el.id==='top'){return 0;}
if(el==='#bottom'||el.id==='bottom'){return scrollable.scrollHeight-scrollable.clientHeight;}
el.classList.add("o_check_scroll_position");let offsetTop=el.getBoundingClientRect().top+window.scrollY;el.classList.remove("o_check_scroll_position");if(el.classList.contains('d-none')){el.classList.remove('d-none');offsetTop=el.getBoundingClientRect().top+window.scrollY;el.classList.add('d-none');}
const isDocScrollingEl=scrollable===el.ownerDocument.scrollingElement;let elPosition=offsetTop-(scrollable.getBoundingClientRect().top+window.scrollY-(isDocScrollingEl?0:scrollable.scrollTop));if(!isInOneDocument&&iframe){elPosition+=iframe.getBoundingClientRect().top+window.scrollY;}
let offset=options.forcedOffset;if(offset===undefined){offset=(scrollable===topLevelScrollable?scrollFixedOffset(scrollDocument):0)+(options.extraOffset||0);}
return Math.max(0,elPosition-offset);}
return new Promise(resolve=>{const start=scrollable.scrollTop;const duration=options.duration||600;const startTime=performance.now();function animateScroll(currentTime){const elapsedTime=currentTime-startTime;const progress=Math.min(elapsedTime/duration,1);const easeInOutQuad=progress<0.5?2*progress*progress:1-Math.pow(-2*progress+2,2)/2;const change=_computeScrollTop()-start;const newScrollTop=start+change*easeInOutQuad;scrollable.scrollTop=newScrollTop;if(elapsedTime<duration){requestAnimationFrame(animateScroll);}else{resolve();}}
requestAnimationFrame(animateScroll);});}
return __exports;});;

/* /web_editor/static/src/js/common/utils.js */
odoo.define('@web_editor/js/common/utils',['@web/core/ui/ui_service','@web/core/utils/colors'],function(require){'use strict';let __exports={};const{SIZES,MEDIAS_BREAKPOINTS}=require("@web/core/ui/ui_service");const{normalizeCSSColor,isCSSColor,}=require('@web/core/utils/colors');let editableWindow=window;const _setEditableWindow=(ew)=>editableWindow=ew;let editableDocument=document;const _setEditableDocument=(ed)=>editableDocument=ed;const COLOR_PALETTE_COMPATIBILITY_COLOR_NAMES=['primary','secondary','alpha','beta','gamma','delta','epsilon','success','info','warning','danger'];const EDITOR_COLOR_CSS_VARIABLES=[...COLOR_PALETTE_COMPATIBILITY_COLOR_NAMES];for(let i=1;i<=5;i++){EDITOR_COLOR_CSS_VARIABLES.push(`o-color-${i}`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-bg`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-bg-gradient`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-headings`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-text`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-btn-primary`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-btn-primary-text`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-btn-secondary`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-btn-secondary-text`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-btn-primary-border`);EDITOR_COLOR_CSS_VARIABLES.push(`o-cc${i}-btn-secondary-border`);}
for(let i=100;i<=900;i+=100){EDITOR_COLOR_CSS_VARIABLES.push(`${i}`);}
EDITOR_COLOR_CSS_VARIABLES.push("black","black-15","black-25","black-50","black-75","white","white-25","white-50","white-75","white-85");const CSS_SHORTHANDS={'border-width':['border-top-width','border-right-width','border-bottom-width','border-left-width'],'border-radius':['border-top-left-radius','border-top-right-radius','border-bottom-right-radius','border-bottom-left-radius'],'border-color':['border-top-color','border-right-color','border-bottom-color','border-left-color'],'border-style':['border-top-style','border-right-style','border-bottom-style','border-left-style'],'padding':['padding-top','padding-right','padding-bottom','padding-left'],};const CSS_UNITS_CONVERSION={'s-ms':()=>1000,'ms-s':()=>0.001,'rem-px':()=>_computePxByRem(),'px-rem':()=>_computePxByRem(true),'%-px':()=>-1,'px-%':()=>-1,};const DEFAULT_PALETTE={'1':'#3AADAA','2':'#7C6576','3':'#F6F6F6','4':'#FFFFFF','5':'#383E45',};const BACKGROUND_IMAGE_ATTRIBUTES=new Set(["originalId","originalSrc","mimetype","resizeWidth","glFilter","quality","bgSrc","filterOptions","mimetypeBeforeConversion",]);function _computePxByRem(toRem){if(editableDocument.PX_BY_REM===undefined){const htmlStyle=editableWindow.getComputedStyle(editableDocument.documentElement);editableDocument.PX_BY_REM=parseFloat(htmlStyle['font-size']);}
return toRem?(1/editableDocument.PX_BY_REM):editableDocument.PX_BY_REM;}
function _convertValueToUnit(value,unitTo,cssProp,$target){const m=_getNumericAndUnit(value);if(!m){return NaN;}
const numValue=parseFloat(m[0]);const valueUnit=m[1];return _convertNumericToUnit(numValue,valueUnit,unitTo,cssProp,$target);}
function _convertNumericToUnit(value,unitFrom,unitTo,cssProp,$target){if(Math.abs(value)<Number.EPSILON||unitFrom===unitTo){return value;}
const converter=CSS_UNITS_CONVERSION[`${unitFrom}-${unitTo}`];if(converter===undefined){throw new Error(`Cannot convert '${unitFrom}' units into '${unitTo}' units !`);}
return value*converter(cssProp,$target);}
function _getNumericAndUnit(value){const m=value.trim().match(/^(-?[0-9.]+(?:e[+|-]?[0-9]+)?)\s*([^\s]*)$/);if(!m){return null;}
return[m[1].trim(),m[2].trim()];}
function _areCssValuesEqual(value1,value2,cssProp,target){const $target=$(target);if(value1===value2){return true;}
if(cssProp&&cssProp.endsWith('-size')){const pseudoPartProp=cssProp+'-part';const re=/-?[0-9.]+(?:e[+|-]?[0-9]+)?\s*[A-Za-z%-]+|auto/g;const parts1=value1.match(re);const parts2=value2.match(re);for(const index of[0,1]){const part1=parts1&&parts1.length>index?parts1[index]:'auto';const part2=parts2&&parts2.length>index?parts2[index]:'auto';if(!_areCssValuesEqual(part1,part2,pseudoPartProp,$target)){return false;}}
return true;}
if(value1.startsWith('var(--')){value1=_getCSSVariableValue(value1.substring(6,value1.length-1));}
if(value2.startsWith('var(--')){value2=_getCSSVariableValue(value2.substring(6,value2.length-1));}
if(value1===value2){return true;}
const color1=normalizeCSSColor(value1);const color2=normalizeCSSColor(value2);if(color1===color2){return true;}
const value1IsGradient=_isColorGradient(value1);const value2IsGradient=_isColorGradient(value2);if(value1IsGradient!==value2IsGradient){return false;}
if(value1IsGradient){const temp1El=document.createElement('div');temp1El.style.backgroundImage=value1;document.body.appendChild(temp1El);value1=getComputedStyle(temp1El).backgroundImage;document.body.removeChild(temp1El);const temp2El=document.createElement('div');temp2El.style.backgroundImage=value2;document.body.appendChild(temp2El);value2=getComputedStyle(temp2El).backgroundImage;document.body.removeChild(temp2El);return value1===value2;}
if(cssProp==='box-shadow'){const temp1El=document.createElement('div');temp1El.style.boxShadow=value1;document.body.appendChild(temp1El);value1=getComputedStyle(temp1El).boxShadow;document.body.removeChild(temp1El);const temp2El=document.createElement('div');temp2El.style.boxShadow=value2;document.body.appendChild(temp2El);value2=getComputedStyle(temp2El).boxShadow;document.body.removeChild(temp2El);return value1===value2;}
const data=_getNumericAndUnit(value1);if(!data){return false;}
const numValue1=data[0];const numValue2=_convertValueToUnit(value2,data[1],cssProp,$target);return(Math.abs(numValue1-numValue2)<Number.EPSILON);}
function _isColorCombinationName(name){const number=parseInt(name);return(!isNaN(number)&&number%100!==0);}
function _computeColorClasses(colorNames,prefix='bg-'){let hasCCClasses=false;const isBgPrefix=(prefix==='bg-');const classes=colorNames.map(c=>{if(isBgPrefix&&_isColorCombinationName(c)){hasCCClasses=true;return`o_cc${c}`;}
return(prefix+c);});if(hasCCClasses){classes.push('o_cc');}
return classes;}
function _getCSSVariableValue(key,htmlStyle){if(htmlStyle===undefined){htmlStyle=editableWindow.getComputedStyle(editableWindow.document.documentElement);}
let value=htmlStyle.getPropertyValue(`--${key}`).trim();value=normalizeCSSColor(value);return value.replace(/"/g,"'");}
function _normalizeColor(color){if(isCSSColor(color)){return color;}
return _getCSSVariableValue(color);}
function _getBgImageURL(el){const parts=_backgroundImageCssToParts($(el).css('background-image'));const string=parts.url||'';const match=string.match(/^url\((['"])(.*?)\1\)$/);if(!match){return'';}
const matchedURL=match[2];const fullURL=new URL(matchedURL,window.location.origin);if(fullURL.origin===window.location.origin){return fullURL.href.slice(fullURL.origin.length);}
return matchedURL;}
function _backgroundImageCssToParts(css){const parts={};css=css||'';if(css.startsWith('url(')){const urlEnd=css.indexOf(')')+1;parts.url=css.substring(0,urlEnd).trim();const commaPos=css.indexOf(',',urlEnd);css=commaPos>0?css.substring(commaPos+1):'';}
if(_isColorGradient(css)){parts.gradient=css.trim();}
return parts;}
function _backgroundImagePartsToCss(parts){let css=parts.url||'';if(parts.gradient){css+=(css?', ':'')+parts.gradient;}
return css||'none';}
function _isColorGradient(value){return value&&value.includes('-gradient(');}
function _generateHTMLId(){return`o${Math.random().toString(36).substring(2, 15)}`;}
function _getColorClass(el,colorNames,prefix){const prefixedColorNames=_computeColorClasses(colorNames,prefix);return el.classList.value.split(' ').filter(cl=>prefixedColorNames.includes(cl)).join(' ');}
function _addBackgroundImageAttributes(...newAttributes){BACKGROUND_IMAGE_ATTRIBUTES.add(...newAttributes);}
function _isBackgroundImageAttribute(attribute){return BACKGROUND_IMAGE_ATTRIBUTES.has(attribute);}
function _shouldEditableMediaBeEditable(mediaEl){const parentEl=mediaEl.parentElement;const nonEditableAncestorRootEl=parentEl&&parentEl.closest('[contenteditable="false"]');return nonEditableAncestorRootEl&&nonEditableAncestorRootEl.parentElement&&nonEditableAncestorRootEl.parentElement.isContentEditable;}
function _isMobileView(targetEl){const mobileViewThreshold=MEDIAS_BREAKPOINTS[SIZES.LG].minWidth;const clientWidth=targetEl.ownerDocument.defaultView?.frameElement?.clientWidth||targetEl.ownerDocument.documentElement.clientWidth;return clientWidth&&clientWidth<mobileViewThreshold;}
function _getLinkLabel(linkEl){return linkEl.textContent.replaceAll("\u200B","").replaceAll("\uFEFF","");}
function _forwardToThumbnail(imgEl){const carouselEl=imgEl.closest(".carousel");if(carouselEl){const carouselInnerEl=imgEl.closest(".carousel-inner");const carouselItemEl=imgEl.closest(".carousel-item");if(carouselInnerEl&&carouselItemEl){const imageIndex=[...carouselInnerEl.children].indexOf(carouselItemEl);const miniatureEl=carouselEl.querySelector(`.carousel-indicators [data-bs-slide-to="${imageIndex}"]`);if(miniatureEl&&miniatureEl.style.backgroundImage){miniatureEl.style.backgroundImage=`url(${imgEl.getAttribute("src")})`;}}}}
async function _isImageCorsProtected(img){const src=img.getAttribute("src");if(!src){return false;}
let isCorsProtected=false;if(!src.startsWith("/")||/\/web\/image\/\d+-redirect\//.test(src)){isCorsProtected=await fetch(src,{method:"HEAD"}).then(()=>false).catch(()=>true);}
return isCorsProtected;}
async function _isSrcCorsProtected(src){const dummyImg=document.createElement("img");dummyImg.src=src;return _isImageCorsProtected(dummyImg);}
__exports[Symbol.for("default")]={COLOR_PALETTE_COMPATIBILITY_COLOR_NAMES:COLOR_PALETTE_COMPATIBILITY_COLOR_NAMES,CSS_SHORTHANDS:CSS_SHORTHANDS,CSS_UNITS_CONVERSION:CSS_UNITS_CONVERSION,DEFAULT_PALETTE:DEFAULT_PALETTE,EDITOR_COLOR_CSS_VARIABLES:EDITOR_COLOR_CSS_VARIABLES,computePxByRem:_computePxByRem,convertValueToUnit:_convertValueToUnit,convertNumericToUnit:_convertNumericToUnit,getNumericAndUnit:_getNumericAndUnit,areCssValuesEqual:_areCssValuesEqual,isColorCombinationName:_isColorCombinationName,isColorGradient:_isColorGradient,computeColorClasses:_computeColorClasses,getCSSVariableValue:_getCSSVariableValue,normalizeColor:_normalizeColor,getBgImageURL:_getBgImageURL,backgroundImageCssToParts:_backgroundImageCssToParts,backgroundImagePartsToCss:_backgroundImagePartsToCss,generateHTMLId:_generateHTMLId,getColorClass:_getColorClass,setEditableWindow:_setEditableWindow,setEditableDocument:_setEditableDocument,addBackgroundImageAttributes:_addBackgroundImageAttributes,isBackgroundImageAttribute:_isBackgroundImageAttribute,shouldEditableMediaBeEditable:_shouldEditableMediaBeEditable,isMobileView:_isMobileView,getLinkLabel:_getLinkLabel,forwardToThumbnail:_forwardToThumbnail,isImageCorsProtected:_isImageCorsProtected,isSrcCorsProtected:_isSrcCorsProtected,};return __exports;});;

/* /web_editor/static/src/js/common/wysiwyg_utils.js */
odoo.define('@web_editor/js/common/wysiwyg_utils',[],function(require){'use strict';let __exports={};__exports.isImg=isImg;function isImg(node){return(node&&(node.nodeName==="IMG"||(node.className&&node.className.match(/(^|\s)(media_iframe_video|o_image|fa)(\s|$)/i))));}
__exports.ancestors=ancestors;function ancestors(node,stopElement){if(!node||!node.parentElement||node===stopElement)return[];return[node.parentElement,...ancestors(node.parentElement,stopElement)];}
return __exports;});;

/* /web_editor/static/src/js/editor/odoo-editor/src/utils/utils.js */
odoo.define('@web_editor/js/editor/odoo-editor/src/utils/utils',[],function(require){'use strict';let __exports={};const DIRECTIONS=__exports.DIRECTIONS={LEFT:false,RIGHT:true,};const CTYPES=__exports.CTYPES={CONTENT:1,SPACE:2,BLOCK_OUTSIDE:4,BLOCK_INSIDE:8,BR:16,};__exports.ctypeToString=ctypeToString;function ctypeToString(ctype){return Object.keys(CTYPES).find((key)=>CTYPES[key]===ctype);}
const CTGROUPS=__exports.CTGROUPS={INLINE:CTYPES.CONTENT|CTYPES.SPACE,BLOCK:CTYPES.BLOCK_OUTSIDE|CTYPES.BLOCK_INSIDE,BR:CTYPES.BR,};const tldWhitelist=['com','net','org','ac','ad','ae','af','ag','ai','al','am','an','ao','aq','ar','as','at','au','aw','ax','az','ba','bb','bd','be','bf','bg','bh','bi','bj','bl','bm','bn','bo','br','bq','bs','bt','bv','bw','by','bz','ca','cc','cd','cf','cg','ch','ci','ck','cl','cm','cn','co','cr','cs','cu','cv','cw','cx','cy','cz','dd','de','dj','dk','dm','do','dz','ec','ee','eg','eh','er','es','et','eu','fi','fj','fk','fm','fo','fr','ga','gb','gd','ge','gf','gg','gh','gi','gl','gm','gn','gp','gq','gr','gs','gt','gu','gw','gy','hk','hm','hn','hr','ht','hu','id','ie','il','im','in','io','iq','ir','is','it','je','jm','jo','jp','ke','kg','kh','ki','km','kn','kp','kr','kw','ky','kz','la','lb','lc','li','lk','lr','ls','lt','lu','lv','ly','ma','mc','md','me','mf','mg','mh','mk','ml','mm','mn','mo','mp','mq','mr','ms','mt','mu','mv','mw','mx','my','mz','na','nc','ne','nf','ng','ni','nl','no','np','nr','nu','nz','om','pa','pe','pf','pg','ph','pk','pl','pm','pn','pr','ps','pt','pw','py','qa','re','ro','rs','ru','rw','sa','sb','sc','sd','se','sg','sh','si','sj','sk','sl','sm','sn','so','sr','ss','st','su','sv','sx','sy','sz','tc','td','tf','tg','th','tj','tk','tl','tm','tn','to','tp','tr','tt','tv','tw','tz','ua','ug','uk','um','us','uy','uz','va','vc','ve','vg','vi','vn','vu','wf','ws','ye','yt','yu','za','zm','zr','zw','co\\.uk'];const urlRegexBase=`|(?:www.))[-a-zA-Z0-9@:%._\\+~#=]{2,256}\\.[a-zA-Z][a-zA-Z0-9]{1,62}|(?:[-a-zA-Z0-9@:%._\\+~#=]{2,256}\\.(?:${tldWhitelist.join('|')})\\b))(?:(?:[/?#])[^\\s]*[^!.,})\\]'"\\s]|(?:[^!(){}.,[\\]'"\\s]+))?`;const httpCapturedRegex=`(https?:\\/\\/)`;const URL_REGEX=__exports.URL_REGEX=new RegExp(`((?:(?:${httpCapturedRegex}${urlRegexBase})`,'i');const YOUTUBE_URL_GET_VIDEO_ID=__exports.YOUTUBE_URL_GET_VIDEO_ID=/^(?:(?:https?:)?\/\/)?(?:(?:www|m)\.)?(?:youtube\.com|youtu\.be)(?:\/(?:[\w-]+\?v=|embed\/|v\/)?)([^\s?&#]+)(?:\S+)?$/i;const EMAIL_REGEX=__exports.EMAIL_REGEX=/^(mailto:)?[\w-.]+@(?:[\w-]+\.)+[\w-]{2,4}$/i;const PHONE_REGEX=__exports.PHONE_REGEX=/^(tel:(?:\/\/)?)?\+?[\d\s.\-()\/]{3,25}$/;const PROTECTED_BLOCK_TAG=__exports.PROTECTED_BLOCK_TAG=['TR','TD','TABLE','TBODY','UL','OL','LI'];const FONT_SIZE_CLASSES=__exports.FONT_SIZE_CLASSES=["display-1-fs","display-2-fs","display-3-fs","display-4-fs","h1-fs","h2-fs","h3-fs","h4-fs","h5-fs","h6-fs","base-fs","o_small-fs","small","o_small_twelve-fs","o_small_ten-fs","o_small_eight-fs"];const TEXT_STYLE_CLASSES=__exports.TEXT_STYLE_CLASSES=["display-1","display-2","display-3","display-4","lead","o_small","small"];const ZWNBSP_CHAR='\ufeff';const ZERO_WIDTH_CHARS=__exports.ZERO_WIDTH_CHARS=['\u200b',ZWNBSP_CHAR];const ZERO_WIDTH_CHARS_REGEX=__exports.ZERO_WIDTH_CHARS_REGEX=new RegExp(`[${ZERO_WIDTH_CHARS.join('')}]`,'g');__exports.leftPos=leftPos;function leftPos(node){return[node.parentNode,childNodeIndex(node)];}
__exports.rightPos=rightPos;function rightPos(node){return[node.parentNode,childNodeIndex(node)+1];}
__exports.boundariesOut=boundariesOut;function boundariesOut(node){const index=childNodeIndex(node);return[node.parentNode,index,node.parentNode,index+1];}
__exports.startPos=startPos;function startPos(node){return[node,0];}
__exports.endPos=endPos;function endPos(node){return[node,nodeSize(node)];}
__exports.boundariesIn=boundariesIn;function boundariesIn(node){return[node,0,node,nodeSize(node)];}
__exports.childNodeIndex=childNodeIndex;function childNodeIndex(node){let i=0;while(node.previousSibling){i++;node=node.previousSibling;}
return i;}
__exports.nodeSize=nodeSize;function nodeSize(node){const isTextNode=node.nodeType===Node.TEXT_NODE;return isTextNode?node.length:node.childNodes.length;}
const closestPath=__exports.closestPath=function*(node){while(node){yield node;node=node.parentNode;}};const PATH_END_REASONS={NO_NODE:0,BLOCK_OUT:1,BLOCK_HIT:2,OUT_OF_SCOPE:3,};__exports.createDOMPathGenerator=createDOMPathGenerator;function createDOMPathGenerator(direction,{leafOnly=false,inScope=false,stopTraverseFunction,stopFunction}={},){const nextDeepest=direction===DIRECTIONS.LEFT?node=>lastLeaf(node.previousSibling,stopTraverseFunction):node=>firstLeaf(node.nextSibling,stopTraverseFunction);const firstNode=direction===DIRECTIONS.LEFT?(node,offset)=>lastLeaf(node.childNodes[offset-1],stopTraverseFunction):(node,offset)=>firstLeaf(node.childNodes[offset],stopTraverseFunction);return function*(node,offset,reasons=[]){let movedUp=false;let currentNode=firstNode(node,offset);if(!currentNode){movedUp=true;currentNode=node;}
while(currentNode){if(stopFunction&&stopFunction(currentNode)){reasons.push(movedUp?PATH_END_REASONS.BLOCK_OUT:PATH_END_REASONS.BLOCK_HIT);break;}
if(inScope&&currentNode===node){reasons.push(PATH_END_REASONS.OUT_OF_SCOPE);break;}
if(!(leafOnly&&movedUp)){yield currentNode;}
movedUp=false;let nextNode=nextDeepest(currentNode);if(!nextNode){movedUp=true;nextNode=currentNode.parentNode;}
currentNode=nextNode;}
reasons.push(PATH_END_REASONS.NO_NODE);};}
__exports.findNode=findNode;function findNode(domPath,findCallback=()=>true,stopCallback=()=>false){for(const node of domPath){if(findCallback(node)){return node;}
if(stopCallback(node)){break;}}
return null;}
__exports.getFurthestUneditableParent=getFurthestUneditableParent;function getFurthestUneditableParent(node,parentLimit){if(node===parentLimit||(parentLimit&&!parentLimit.contains(node))){return undefined;}
let parent=node&&node.parentElement;let nonEditableElement;while(parent&&(!parentLimit||parent!==parentLimit)){if(!parent.isContentEditable){nonEditableElement=parent;}
if(parent.oid==="root"){break;}
parent=parent.parentElement;}
return nonEditableElement;}
__exports.closestElement=closestElement;function closestElement(node,predicate="*"){if(!node)return null;let element=node.nodeType===Node.ELEMENT_NODE?node:node.parentElement;if(typeof predicate==='function'){while(element&&!predicate(element)){element=element.parentElement;}}else{element=element?.closest(predicate);}
return element?.closest('.odoo-editor-editable')&&element;}
__exports.ancestors=ancestors;function ancestors(node,editable){if(!node||!node.parentElement||node===editable)return[];return[node.parentElement,...ancestors(node.parentElement,editable)];}
__exports.descendants=descendants;function descendants(node){const posterity=[];for(const child of(node.childNodes||[])){posterity.push(child,...descendants(child));}
return posterity;}
__exports.closestBlock=closestBlock;function closestBlock(node){return findNode(closestPath(node),node=>isBlock(node));}
__exports.lastLeaf=lastLeaf;function lastLeaf(node,stopTraverseFunction){while(node&&node.lastChild&&!(stopTraverseFunction&&stopTraverseFunction(node))){node=node.lastChild;}
return node;}
__exports.firstLeaf=firstLeaf;function firstLeaf(node,stopTraverseFunction){while(node&&node.firstChild&&!(stopTraverseFunction&&stopTraverseFunction(node))){node=node.firstChild;}
return node;}
__exports.previousLeaf=previousLeaf;function previousLeaf(node,editable,skipInvisible=false){let ancestor=node;while(ancestor&&!ancestor.previousSibling&&ancestor!==editable){ancestor=ancestor.parentElement;}
if(ancestor&&ancestor!==editable){if(skipInvisible&&!isVisible(ancestor.previousSibling)){return previousLeaf(ancestor.previousSibling,editable,skipInvisible);}else{const last=lastLeaf(ancestor.previousSibling);if(skipInvisible&&!isVisible(last)){return previousLeaf(last,editable,skipInvisible);}else{return last;}}}}
__exports.nextLeaf=nextLeaf;function nextLeaf(node,editable,skipInvisible=false){let ancestor=node;while(ancestor&&!ancestor.nextSibling&&ancestor!==editable){ancestor=ancestor.parentElement;}
if(ancestor&&ancestor!==editable){if(skipInvisible&&ancestor.nextSibling&&!isVisible(ancestor.nextSibling)){return nextLeaf(ancestor.nextSibling,editable,skipInvisible);}else{const first=firstLeaf(ancestor.nextSibling);if(skipInvisible&&!isVisible(first)){return nextLeaf(first,editable,skipInvisible);}else{return first;}}}}
__exports.getAdjacentPreviousSiblings=getAdjacentPreviousSiblings;function getAdjacentPreviousSiblings(node,predicate=n=>!!n){let previous=node.previousSibling;const list=[];while(previous&&predicate(previous)){list.push(previous);previous=previous.previousSibling;}
return list;}
__exports.getAdjacentNextSiblings=getAdjacentNextSiblings;function getAdjacentNextSiblings(node,predicate=n=>!!n){let next=node.nextSibling;const list=[];while(next&&predicate(next)){list.push(next);next=next.nextSibling;}
return list;}
__exports.getAdjacents=getAdjacents;function getAdjacents(node,predicate=n=>!!n){const previous=getAdjacentPreviousSiblings(node,predicate);const next=getAdjacentNextSiblings(node,predicate);return predicate(node)?[...previous.reverse(),node,...next]:[];}
__exports.hasTableSelection=hasTableSelection;function hasTableSelection(editable){return!!editable.querySelector('.o_selected_table');}
__exports.hasValidSelection=hasValidSelection;function hasValidSelection(editable){return hasTableSelection(editable)||editable.ownerDocument.getSelection().rangeCount>0;}
__exports.getNormalizedCursorPosition=getNormalizedCursorPosition;function getNormalizedCursorPosition(node,offset,full=true){const editable=closestElement(node,'.odoo-editor-editable');let closest=closestElement(node);while(closest&&closest!==editable&&(isSelfClosingElement(node)||!closest.isContentEditable)){[node,offset]=offset||!nodeSize(node)?rightPos(node):leftPos(node);closest=closestElement(node);}
offset=Math.min(Math.max(offset,0),nodeSize(node));if(full){let el;let elOffset;if(node.nodeType===Node.ELEMENT_NODE){el=node;elOffset=offset;}else if(node.nodeType===Node.TEXT_NODE){if(offset===0){el=node.parentNode;elOffset=childNodeIndex(node);}else if(offset===node.length){el=node.parentNode;elOffset=childNodeIndex(node)+1;}}
if(el){const leftInlineNode=leftLeafOnlyInScopeNotBlockEditablePath(el,elOffset).next().value;let leftVisibleEmpty=false;if(leftInlineNode){leftVisibleEmpty=isSelfClosingElement(leftInlineNode)||!closestElement(leftInlineNode).isContentEditable;[node,offset]=leftVisibleEmpty?rightPos(leftInlineNode):endPos(leftInlineNode);}
if(!leftInlineNode||leftVisibleEmpty){const rightInlineNode=rightLeafOnlyInScopeNotBlockEditablePath(el,elOffset).next().value;if(rightInlineNode){const closest=closestElement(rightInlineNode);const rightVisibleEmpty=isSelfClosingElement(rightInlineNode)||!closest||!closest.isContentEditable;if(!(leftVisibleEmpty&&rightVisibleEmpty)){[node,offset]=rightVisibleEmpty?leftPos(rightInlineNode):startPos(rightInlineNode);}}}}}
const prevNode=node.nodeType===Node.ELEMENT_NODE&&node.childNodes[offset-1];if(prevNode&&prevNode.nodeName==='BR'&&isFakeLineBreak(prevNode)){offset--;}
return[node,offset];}
__exports.insertSelectionChars=insertSelectionChars;function insertSelectionChars(anchorNode,anchorOffset,focusNode,focusOffset,startChar='[',endChar=']'){if(anchorNode===focusNode&&anchorOffset<=focusOffset){focusOffset+=(focusNode.nodeType===Node.TEXT_NODE?startChar.length:1);}
insertCharsAt(startChar,anchorNode,anchorOffset);insertCharsAt(endChar,focusNode,focusOffset);}
__exports.logSelection=logSelection;function logSelection(root,options={}){const sel=options.selection||root.ownerDocument.getSelection();if(!root.contains(sel.anchorNode)||!root.contains(sel.focusNode)){console.warn('The selection is not contained in the root.');return;}
let anchorClone,focusClone;const cloneTree=node=>{const clone=node.cloneNode();if(options.includeOids){clone.oid=node.oid;}
anchorClone=anchorClone||(node===sel.anchorNode&&clone);focusClone=focusClone||(node===sel.focusNode&&clone);for(const child of node.childNodes||[]){clone.append(cloneTree(child));}
return clone;}
const rootClone=cloneTree(root);insertSelectionChars(anchorClone,sel.anchorOffset,focusClone,sel.focusOffset,'%c[%c','%c]%c');rootClone.removeAttribute('data-last-history-steps');if(options.doFormat){const formatHtml=(node,spaces=0)=>{node.before(document.createTextNode('\n'+' '.repeat(spaces)));for(const child of[...node.childNodes]){formatHtml(child,spaces+4);}
if(node.nodeType!==Node.TEXT_NODE){node.appendChild(document.createTextNode('\n'+' '.repeat(spaces)));}
if(options.includeOids){if(node.nodeType===Node.TEXT_NODE){node.textContent+=` (${node.oid})`;}else{node.setAttribute('oid',node.oid);}}}
formatHtml(rootClone);}
const selectionCharacterStyle='color: #75bfff; font-weight: 700;';const defaultStyle='color: inherit; font-weight: inherit;';console.log(makeZeroWidthCharactersVisible(rootClone.outerHTML),selectionCharacterStyle,defaultStyle,selectionCharacterStyle,defaultStyle,);}
__exports.ensureFocus=ensureFocus;function ensureFocus(element){const activeElement=element.ownerDocument.activeElement;if(activeElement!==element&&(!element.contains(activeElement)||!activeElement.isContentEditable)){element.focus();}}
__exports.setSelection=setSelection;function setSelection(anchorNode,anchorOffset,focusNode=anchorNode,focusOffset=anchorOffset,normalize=true,){if(!anchorNode||!anchorNode.parentElement||!anchorNode.parentElement.closest('body')||!focusNode||!focusNode.parentElement||!focusNode.parentElement.closest('body')){return null;}
const document=anchorNode.ownerDocument;const seemsCollapsed=anchorNode===focusNode&&anchorOffset===focusOffset;[anchorNode,anchorOffset]=getNormalizedCursorPosition(anchorNode,anchorOffset,normalize);[focusNode,focusOffset]=seemsCollapsed?[anchorNode,anchorOffset]:getNormalizedCursorPosition(focusNode,focusOffset,normalize);const direction=getCursorDirection(anchorNode,anchorOffset,focusNode,focusOffset);const sel=document.getSelection();if(!sel){return null;}
try{const range=new Range();if(direction===DIRECTIONS.RIGHT){range.setStart(anchorNode,anchorOffset);range.collapse(true);}else{range.setEnd(anchorNode,anchorOffset);range.collapse(false);}
sel.removeAllRanges();sel.addRange(range);sel.extend(focusNode,focusOffset);}catch(e){if(e.name!=='NS_ERROR_FAILURE'){throw e;}}
return[anchorNode,anchorOffset,focusNode,focusOffset];}
__exports.setCursorStart=setCursorStart;function setCursorStart(node,normalize=true){const pos=startPos(node);return setSelection(...pos,...pos,normalize);}
__exports.setCursorEnd=setCursorEnd;function setCursorEnd(node,normalize=true){const pos=endPos(node);return setSelection(...pos,...pos,normalize);}
__exports.getCursorDirection=getCursorDirection;function getCursorDirection(anchorNode,anchorOffset,focusNode,focusOffset){if(anchorNode===focusNode){if(anchorOffset===focusOffset)return false;return anchorOffset<focusOffset?DIRECTIONS.RIGHT:DIRECTIONS.LEFT;}
return anchorNode.compareDocumentPosition(focusNode)&Node.DOCUMENT_POSITION_FOLLOWING?DIRECTIONS.RIGHT:DIRECTIONS.LEFT;}
__exports.getTraversedNodes=getTraversedNodes;function getTraversedNodes(editable,range=getDeepRange(editable)){const selectedTableCells=editable.querySelectorAll('.o_selected_td');const document=editable.ownerDocument;if(!range)return[];const iterator=document.createNodeIterator(range.commonAncestorContainer);let node;do{node=iterator.nextNode();}while(node&&node!==range.startContainer&&!(selectedTableCells.length&&node===selectedTableCells[0]));if(node&&!(selectedTableCells.length&&node===selectedTableCells[0])&&!range.collapsed&&node.nodeType===Node.ELEMENT_NODE&&node.childNodes.length&&range.startOffset&&node.childNodes[range.startOffset-1].nodeName==="BR"){const targetBr=node.childNodes[range.startOffset-1];while(node!=targetBr){node=iterator.nextNode();}
node=iterator.nextNode();}
if(node&&!range.collapsed&&node===range.startContainer&&range.startOffset===nodeSize(node)&&node.nextSibling&&node.nextSibling.nodeName==="BR"){node=iterator.nextNode();}
const traversedNodes=new Set([node,...descendants(node)]);while(node&&node!==range.endContainer){node=iterator.nextNode();if(node){const selectedTable=closestElement(node,'.o_selected_table');if(selectedTable){for(const selectedTd of selectedTable.querySelectorAll('.o_selected_td')){traversedNodes.add(selectedTd);descendants(selectedTd).forEach(descendant=>traversedNodes.add(descendant));}}else if(!(node===range.endContainer&&range.endOffset===0&&!range.collapsed&&node.previousSibling&&node.previousSibling.nodeName==="BR")){traversedNodes.add(node);}}}
if(node){for(const descendant of descendants(node)){if(descendant.parentElement===node&&childNodeIndex(descendant)>=range.endOffset){break;}
traversedNodes.add(descendant);}}
return[...traversedNodes];}
__exports.getSelectedNodes=getSelectedNodes;function getSelectedNodes(editable){const selectedTableCells=editable.querySelectorAll('.o_selected_td');const document=editable.ownerDocument;const sel=document.getSelection();if(!sel.rangeCount&&!selectedTableCells.length){return[];}
const range=sel.getRangeAt(0);return[...new Set(getTraversedNodes(editable).flatMap(node=>{const td=closestElement(node,'.o_selected_td');if(td){return descendants(td);}else if(range.isPointInRange(node,0)&&range.isPointInRange(node,nodeSize(node))){return node;}else{return[];}},))];}
__exports.getDeepRange=getDeepRange;function getDeepRange(editable,{range,sel,splitText,select,correctTripleClick}={}){sel=sel||editable.parentElement&&editable.ownerDocument.getSelection();if(sel&&sel.isCollapsed&&sel.anchorNode&&sel.anchorNode.nodeName==="BR"){setSelection(sel.anchorNode.parentElement,childNodeIndex(sel.anchorNode));}
range=range?range.cloneRange():sel&&sel.rangeCount&&sel.getRangeAt(0).cloneRange();if(!range)return;let start=range.startContainer;let startOffset=range.startOffset;let end=range.endContainer;let endOffset=range.endOffset;const isBackwards=!range.collapsed&&start===sel.focusNode&&startOffset===sel.focusOffset;[start,startOffset]=getDeepestPosition(start,startOffset);[end,endOffset]=getDeepestPosition(end,endOffset);if(splitText){const isInSingleContainer=start===end;if(end.nodeType===Node.TEXT_NODE&&endOffset!==0&&endOffset!==end.textContent.length){const endParent=end.parentNode;const splitOffset=splitTextNode(end,endOffset);end=endParent.childNodes[splitOffset-1]||endParent.firstChild;if(isInSingleContainer){start=end;}
endOffset=end.textContent.length;}
if(start.nodeType===Node.TEXT_NODE&&startOffset!==0&&startOffset!==start.textContent.length){splitTextNode(start,startOffset);startOffset=0;if(isInSingleContainer){endOffset=start.textContent.length;}}}
const endLeaf=firstLeaf(end);const beforeEnd=endLeaf.previousSibling;const isInsideColumn=closestElement(end,'.o_text_columns')
if(correctTripleClick&&!endOffset&&(start!==end||startOffset!==endOffset)&&(!beforeEnd||(beforeEnd.nodeType===Node.TEXT_NODE&&!isVisibleTextNode(beforeEnd)&&!isZWS(beforeEnd)))&&!closestElement(endLeaf,'table')&&!isInsideColumn){const previous=previousLeaf(endLeaf,editable,true);if(previous&&closestElement(previous).isContentEditable){[end,endOffset]=[previous,nodeSize(previous)];}}
if(select){if(isBackwards){[start,end,startOffset,endOffset]=[end,start,endOffset,startOffset];range.setEnd(start,startOffset);range.collapse(false);}else{range.setStart(start,startOffset);range.collapse(true);}
sel.removeAllRanges();sel.addRange(range);try{sel.extend(end,endOffset);}catch{}
range=sel.getRangeAt(0);}else{range.setStart(start,startOffset);range.setEnd(end,endOffset);}
return range;}
__exports.getAdjacentCharacter=getAdjacentCharacter;function getAdjacentCharacter(editable,side){let{focusNode,focusOffset}=editable.ownerDocument.getSelection();const originalBlock=closestBlock(focusNode);let adjacentCharacter;while(!adjacentCharacter&&focusNode){if(side==='previous'){adjacentCharacter=focusOffset>0&&focusNode.textContent[focusOffset-1];}else{adjacentCharacter=focusNode.textContent[focusOffset];}
if(!adjacentCharacter){if(side==='previous'){focusNode=previousLeaf(focusNode,editable);focusOffset=focusNode&&nodeSize(focusNode);}else{focusNode=nextLeaf(focusNode,editable);focusOffset=0;}
const characterIndex=side==='previous'?focusOffset-1:focusOffset;adjacentCharacter=focusNode&&focusNode.textContent[characterIndex];}}
return closestBlock(focusNode)===originalBlock?adjacentCharacter:undefined;}
__exports.isZwnbsp=isZwnbsp;function isZwnbsp(node){return node.nodeType===Node.TEXT_NODE&&node.textContent==='\ufeff';}
function isTangible(node){return isVisible(node)||isZwnbsp(node)||hasTangibleContent(node);}
function hasTangibleContent(node){return[...(node?.childNodes||[])].some(n=>isTangible(n));}
__exports.getDeepestPosition=getDeepestPosition;function getDeepestPosition(node,offset){let direction=DIRECTIONS.RIGHT;let next=node;while(next){if(isTangible(next)||isZWS(next)){if(next!==node){[node,offset]=[next,direction?0:nodeSize(next)];}
direction=offset<node.childNodes.length;next=node.childNodes[direction?offset:offset-1];}else if(direction&&next.nextSibling&&closestBlock(node)?.contains(next.nextSibling)){next=next.nextSibling;}else{direction=DIRECTIONS.LEFT;next=closestBlock(node)?.contains(next.previousSibling)&&next.previousSibling;}
next=!isSelfClosingElement(next)&&next;}
return[node,offset];}
__exports.getCursors=getCursors;function getCursors(document){const sel=document.getSelection();if(getCursorDirection(sel.anchorNode,sel.anchorOffset,sel.focusNode,sel.focusOffset)===DIRECTIONS.LEFT)
return[[sel.focusNode,sel.focusOffset],[sel.anchorNode,sel.anchorOffset],];return[[sel.anchorNode,sel.anchorOffset],[sel.focusNode,sel.focusOffset],];}
__exports.preserveCursor=preserveCursor;function preserveCursor(document){const sel=document.getSelection();const cursorPos=[sel.anchorNode,sel.anchorOffset,sel.focusNode,sel.focusOffset];return replace=>{replace=replace||new Map();cursorPos[0]=replace.get(cursorPos[0])||cursorPos[0];cursorPos[2]=replace.get(cursorPos[2])||cursorPos[2];return setSelection(...cursorPos,false);};}
__exports.isSelectionInSelectors=isSelectionInSelectors;function isSelectionInSelectors(selector){let anchor=document.getSelection().anchorNode;if(anchor&&anchor.nodeType&&anchor.nodeType!==Node.ELEMENT_NODE){anchor=anchor.parentElement;}
if(anchor&&closestElement(anchor,selector)){return true;}
return false;}
__exports.getOffsetAndCharSize=getOffsetAndCharSize;function getOffsetAndCharSize(nodeValue,offset,direction){const splittedNodeValue=[...nodeValue];let charSize=1;let newOffset=offset;let currentSize=0;for(const item of splittedNodeValue){currentSize+=item.length;if(currentSize>=offset){newOffset=direction==DIRECTIONS.LEFT?currentSize:currentSize-item.length;charSize=item.length;break;}}
return[newOffset,charSize];}
const formatsSpecs=__exports.formatsSpecs={italic:{tagName:'em',isFormatted:isItalic,isTag:(node)=>['EM','I'].includes(node.tagName),hasStyle:(node)=>Boolean(node.style&&node.style['font-style']),addStyle:(node)=>node.style['font-style']='italic',addNeutralStyle:(node)=>node.style['font-style']='normal',removeStyle:(node)=>removeStyle(node,'font-style'),},bold:{tagName:'strong',isFormatted:isBold,isTag:(node)=>['STRONG','B'].includes(node.tagName),hasStyle:(node)=>Boolean(node.style&&node.style['font-weight']),addStyle:(node)=>node.style['font-weight']='bolder',addNeutralStyle:(node)=>{node.style['font-weight']='normal'},removeStyle:(node)=>removeStyle(node,'font-weight'),},underline:{tagName:'u',isFormatted:isUnderline,isTag:(node)=>node.tagName==='U',hasStyle:(node)=>node.style&&node.style['text-decoration-line'].includes('underline'),addStyle:(node)=>node.style['text-decoration-line']+=' underline',removeStyle:(node)=>removeStyle(node,'text-decoration-line','underline'),},strikeThrough:{tagName:'s',isFormatted:isStrikeThrough,isTag:(node)=>node.tagName==='S',hasStyle:(node)=>node.style&&node.style['text-decoration-line'].includes('line-through'),addStyle:(node)=>node.style['text-decoration-line']+=' line-through',removeStyle:(node)=>removeStyle(node,'text-decoration-line','line-through'),},fontSize:{isFormatted:isFontSize,hasStyle:(node)=>node.style&&node.style['font-size'],addStyle:(node,props)=>{node.style['font-size']=props.size;node.classList.remove(...FONT_SIZE_CLASSES);},removeStyle:(node)=>removeStyle(node,'font-size'),},setFontSizeClassName:{isFormatted:hasClass,hasStyle:(node,props)=>FONT_SIZE_CLASSES.find(cls=>node.classList.contains(cls)),addStyle:(node,props)=>node.classList.add(props.className),removeStyle:(node)=>{node.classList.remove(...FONT_SIZE_CLASSES,...TEXT_STYLE_CLASSES);if(node.classList.length===0){node.removeAttribute("class");}},},switchDirection:{isFormatted:isDirectionSwitched,}}
const removeStyle=(node,styleName,item)=>{if(item){const newStyle=node.style[styleName].split(' ').filter(x=>x!==item).join(' ');node.style[styleName]=newStyle||null;}else{node.style[styleName]=null;}
if(node.getAttribute('style')===''){node.removeAttribute('style');}};const getOrCreateSpan=(node,ancestors)=>{const span=ancestors.find((element)=>element.tagName==='SPAN'&&element.isConnected);const lastInlineAncestor=ancestors.findLast((element)=>!isBlock(element)&&element.isConnected);if(span){return span;}else{const span=document.createElement('span');if(lastInlineAncestor){lastInlineAncestor.after(span);span.append(lastInlineAncestor);}else{node.after(span);span.append(node);}
return span;}}
const removeFormat=(node,formatSpec)=>{node=closestElement(node);if(formatSpec.hasStyle(node)){formatSpec.removeStyle(node);if(['SPAN','FONT'].includes(node.tagName)&&!node.getAttributeNames().length){return unwrapContents(node);}}
if(formatSpec.isTag&&formatSpec.isTag(node)){const attributesNames=node.getAttributeNames().filter((name)=>{return name!=='data-oe-zws-empty-inline';});if(attributesNames.length){const newNode=document.createElement('span');while(node.firstChild){newNode.appendChild(node.firstChild);}
for(let index=node.attributes.length-1;index>=0;--index){newNode.attributes.setNamedItem(node.attributes[index].cloneNode());}
node.parentNode.replaceChild(newNode,node);}else{unwrapContents(node);}}}
const formatSelection=__exports.formatSelection=(editor,formatName,{applyStyle,formatProps}={})=>{const selection=editor.document.getSelection();let direction
let wasCollapsed;if(editor.editable.querySelector('.o_selected_td')){direction=DIRECTIONS.RIGHT;}else{if(!selection.rangeCount)return;wasCollapsed=selection.getRangeAt(0).collapsed;direction=getCursorDirection(selection.anchorNode,selection.anchorOffset,selection.focusNode,selection.focusOffset);}
getDeepRange(editor.editable,{splitText:true,select:true,correctTripleClick:true});if(typeof applyStyle==='undefined'){applyStyle=!isSelectionFormat(editor.editable,formatName);}
let zws;if(wasCollapsed){if(selection.anchorNode.nodeType===Node.TEXT_NODE&&selection.anchorNode.textContent==='\u200b'){zws=selection.anchorNode;selection.getRangeAt(0).selectNode(zws);}else{zws=insertAndSelectZws(selection);}
getDeepRange(editor.editable,{splitText:true,select:true,correctTripleClick:true});}
const selectedNodes=getSelectedNodes(editor.editable).filter((n)=>((n.nodeType===Node.TEXT_NODE&&(isVisibleTextNode(n)||isZWS(n)))||n.nodeName==="BR")&&closestElement(n).isContentEditable);const selectedFieldNodes=new Set(getSelectedNodes(editor.editable).map(n=>closestElement(n,"*[t-field],*[t-out],*[t-esc]")).filter(Boolean));const formatSpec=formatsSpecs[formatName];for(const node of selectedNodes){const inlineAncestors=[];let currentNode=node;let parentNode=node.parentElement;while(parentNode&&!isBlock(parentNode)&&!isUnbreakable(parentNode)&&!isUnbreakable(currentNode)&&(parentNode.classList.length===0||[...parentNode.classList].every(cls=>FONT_SIZE_CLASSES.includes(cls)))){const isUselessZws=parentNode.tagName==='SPAN'&&parentNode.hasAttribute('data-oe-zws-empty-inline')&&parentNode.getAttributeNames().length===1;if(isUselessZws){unwrapContents(parentNode);}else{const newLastAncestorInlineFormat=splitAroundUntil(currentNode,parentNode);removeFormat(newLastAncestorInlineFormat,formatSpec);if(newLastAncestorInlineFormat.isConnected){inlineAncestors.push(newLastAncestorInlineFormat);currentNode=newLastAncestorInlineFormat;}}
parentNode=currentNode.parentElement;}
const isFormatted=formatName==="setFontSizeClassName"&&!formatProps?hasAnyFontSizeClass:formatSpec.isFormatted;const firstBlockOrClassHasFormat=isFormatted(parentNode,formatProps);if(firstBlockOrClassHasFormat&&!applyStyle){formatSpec.addNeutralStyle&&formatSpec.addNeutralStyle(getOrCreateSpan(node,inlineAncestors));}else if(!firstBlockOrClassHasFormat&&applyStyle){const tag=formatSpec.tagName&&document.createElement(formatSpec.tagName);if(tag){node.after(tag);tag.append(node);if(!isFormatted(tag,formatProps)){tag.after(node);tag.remove();formatSpec.addStyle(getOrCreateSpan(node,inlineAncestors),formatProps);}}else if(formatName!=='fontSize'||formatProps.size!==undefined){formatSpec.addStyle(getOrCreateSpan(node,inlineAncestors),formatProps);}}}
for(const selectedFieldNode of selectedFieldNodes){if(applyStyle){formatSpec.addStyle(selectedFieldNode,formatProps);}else{formatSpec.removeStyle(selectedFieldNode);}}
if(zws){const siblings=[...zws.parentElement.childNodes];if(!isBlock(zws.parentElement)&&selectedNodes.includes(siblings[0])&&selectedNodes.includes(siblings[siblings.length-1])){zws.parentElement.setAttribute('data-oe-zws-empty-inline','');}else{const span=document.createElement('span');span.setAttribute('data-oe-zws-empty-inline','');zws.before(span);span.append(zws);}}
if(selectedNodes.length===1&&selectedNodes[0].textContent==='\u200B'){setSelection(selectedNodes[0],0);}else if(selectedNodes.length){const firstNode=selectedNodes[0];const lastNode=selectedNodes[selectedNodes.length-1];if(direction===DIRECTIONS.RIGHT){setSelection(firstNode,0,lastNode,lastNode.length,false);}else{setSelection(lastNode,lastNode.length,firstNode,0,false);}}}
const isLinkEligibleForZwnbsp=__exports.isLinkEligibleForZwnbsp=(editable,link)=>{return link.parentElement.isContentEditable&&link.isContentEditable&&editable.contains(link)&&!([link,...link.querySelectorAll('*')].some(el=>el.nodeName==='IMG'||isBlock(el))||link.matches('nav a, a.nav-link'));}
const padLinkWithZws=__exports.padLinkWithZws=(editable,link)=>{if(!isLinkEligibleForZwnbsp(editable,link)){return;}
const selection=editable.ownerDocument.getSelection()||{};const{anchorOffset,focusOffset}=selection;let extraAnchorOffset=0;let extraFocusOffset=0;if(!link.textContent.startsWith('\uFEFF')){if(selection.anchorNode===link&&anchorOffset){extraAnchorOffset+=1;}
if(selection.focusNode===link&&focusOffset){extraFocusOffset+=1;}
link.prepend(document.createTextNode('\uFEFF'));}
if(!link.textContent.endsWith('\uFEFF')){if(selection.anchorNode===link&&anchorOffset+extraAnchorOffset===nodeSize(link)){extraAnchorOffset+=1;}
if(selection.focusNode===link&&focusOffset+extraFocusOffset===nodeSize(link)){extraFocusOffset+=1;}
link.append(document.createTextNode('\uFEFF'));}
const linkIndex=childNodeIndex(link);if(!(link.previousSibling&&link.previousSibling.textContent.endsWith('\uFEFF'))){if(selection.anchorNode===link.parentElement&&anchorOffset+extraAnchorOffset>linkIndex){extraAnchorOffset+=1;}
if(selection.focusNode===link.parentElement&&focusOffset+extraFocusOffset>linkIndex){extraFocusOffset+=1;}
link.before(document.createTextNode('\uFEFF'));}
if(!(link.nextSibling&&link.nextSibling.textContent.startsWith('\uFEFF'))){if(selection.anchorNode===link.parentElement&&anchorOffset+extraAnchorOffset>linkIndex+1){extraAnchorOffset+=1;}
if(selection.focusNode===link.parentElement&&focusOffset+extraFocusOffset>linkIndex+1){extraFocusOffset+=1;}
link.after(document.createTextNode('\uFEFF'));}
if(extraAnchorOffset||extraFocusOffset){setSelection(selection.anchorNode,anchorOffset+extraAnchorOffset,selection.focusNode,focusOffset+extraFocusOffset,);}}
const blockTagNames=['ADDRESS','ARTICLE','ASIDE','BLOCKQUOTE','DETAILS','DIALOG','DD','DIV','DL','DT','FIELDSET','FIGCAPTION','FIGURE','FOOTER','FORM','H1','H2','H3','H4','H5','H6','HEADER','HGROUP','HR','LI','MAIN','NAV','OL','P','PRE','SECTION','TABLE','UL','SELECT','OPTION','TR','TD','TBODY','THEAD','TH',];const computedStyles=new WeakMap();__exports.isBlock=isBlock;function isBlock(node){if(!node||node.nodeType!==Node.ELEMENT_NODE){return false;}
const tagName=node.nodeName.toUpperCase();if(tagName.startsWith('JW-')||(tagName==='T'&&node.getAttribute('t-esc')===null&&node.getAttribute('t-out')===null&&node.getAttribute('t-raw')===null)){return true;}
if(tagName==='BR'){return false;}
if(!node.isConnected){return blockTagNames.includes(tagName);}
let style=computedStyles.get(node);if(!style){style=node.ownerDocument.defaultView?.getComputedStyle(node);computedStyles.set(node,style);}
if(style?.display){return!style.display.includes('inline')&&style.display!=='contents';}
return blockTagNames.includes(tagName);}
__exports.isBold=isBold;function isBold(node){const fontWeight=+getComputedStyle(closestElement(node)).fontWeight;return fontWeight>500||fontWeight>+getComputedStyle(closestBlock(node)).fontWeight;}
__exports.isItalic=isItalic;function isItalic(node){return getComputedStyle(closestElement(node)).fontStyle==='italic';}
__exports.isUnderline=isUnderline;function isUnderline(node){let parent=closestElement(node);while(parent){if(getComputedStyle(parent).textDecorationLine.includes('underline')){return true;}
parent=parent.parentElement;}
return false;}
__exports.isStrikeThrough=isStrikeThrough;function isStrikeThrough(node){let parent=closestElement(node);while(parent){if(getComputedStyle(parent).textDecorationLine.includes('line-through')){return true;}
parent=parent.parentElement;}
return false;}
__exports.isFontSize=isFontSize;function isFontSize(node,props){const element=closestElement(node);return getComputedStyle(element)['font-size']===props.size;}
__exports.hasClass=hasClass;function hasClass(node,props){const element=closestElement(node);return element.classList.contains(props.className);}
__exports.hasAnyFontSizeClass=hasAnyFontSizeClass;function hasAnyFontSizeClass(node){return FONT_SIZE_CLASSES.find((cls)=>node?.classList?.contains(cls));}
__exports.isDirectionSwitched=isDirectionSwitched;function isDirectionSwitched(node,editable){const defaultDirection=editable.getAttribute('dir');return getComputedStyle(closestElement(node)).direction!==defaultDirection;}
__exports.isSelectionFormat=isSelectionFormat;function isSelectionFormat(editable,format){const selectedNodes=getTraversedNodes(editable).filter((n)=>n.nodeType===Node.TEXT_NODE&&n.nodeValue.replaceAll(ZWNBSP_CHAR,'').length);const isFormatted=format==="setFontSizeClassName"?hasAnyFontSizeClass:formatsSpecs[format].isFormatted;return selectedNodes.length&&selectedNodes.every(n=>isFormatted(n,editable));}
__exports.isUnbreakable=isUnbreakable;function isUnbreakable(node){if(!node||node.nodeType===Node.TEXT_NODE){return false;}
if(node.nodeType!==Node.ELEMENT_NODE){return true;}
return(isUnremovable(node)||['TABLE','THEAD','TBODY','TFOOT','TR','TH','TD','SECTION','DIV'].includes(node.tagName)||node.hasAttribute('t')||(node.nodeType===Node.ELEMENT_NODE&&(node.nodeName==='T'||node.getAttribute('t-if')||node.getAttribute('t-esc')||node.getAttribute('t-elif')||node.getAttribute('t-else')||node.getAttribute('t-foreach')||node.getAttribute('t-value')||node.getAttribute('t-out')||node.getAttribute('t-raw'))||node.getAttribute('t-field'))||node.matches(".oe_unbreakable, a.btn, a[role='tab'], a[role='button'], li.nav-item"));}
__exports.isUnremovable=isUnremovable;function isUnremovable(node){return((node.nodeType!==Node.COMMENT_NODE&&node.nodeType!==Node.ELEMENT_NODE&&node.nodeType!==Node.TEXT_NODE)||node.oid==='root'||(node.nodeType===Node.ELEMENT_NODE&&(node.classList.contains('o_editable')||node.getAttribute('t-set')||node.getAttribute('t-call')))||(node.classList&&node.classList.contains('oe_unremovable'))||(node.nodeName==='SPAN'&&node.parentElement&&node.parentElement.getAttribute('data-oe-type')==='monetary')||(node.ownerDocument&&node.ownerDocument.defaultWindow&&!ancestors(node).find(ancestor=>ancestor.oid==='root')));}
__exports.containsUnbreakable=containsUnbreakable;function containsUnbreakable(node){if(!node){return false;}
return isUnbreakable(node)||containsUnbreakable(node.firstChild);}
const iconTags=['I','SPAN'];const iconClasses=['fa','fab','fad','far','oi'];__exports.isIconElement=isIconElement;function isIconElement(node){return!!(node&&iconTags.includes(node.nodeName)&&iconClasses.some(cls=>node.classList.contains(cls)));}
const ICON_SELECTOR=__exports.ICON_SELECTOR=iconTags.map(tag=>{return iconClasses.map(cls=>{return`${tag}.${cls}`;}).join(', ');}).join(', ');__exports.isZWS=isZWS;function isZWS(node){return(node&&node.textContent==='\u200B');}
__exports.isEditorTab=isEditorTab;function isEditorTab(node){return(node&&(node.nodeName==='SPAN')&&node.classList.contains('oe-tabs'));}
__exports.isMediaElement=isMediaElement;function isMediaElement(node){return(isIconElement(node)||(node.classList&&(node.classList.contains('o_image')||node.classList.contains('media_iframe_video'))));}
__exports.isProtected=isProtected;function isProtected(node){const closestProtectedElement=closestElement(node,'[data-oe-protected]');if(closestProtectedElement){return["","true"].includes(closestProtectedElement.dataset.oeProtected);}
return false;}
const VOID_ELEMENT_NAMES=['AREA','BASE','BR','COL','EMBED','HR','IMG','INPUT','KEYGEN','LINK','META','PARAM','SOURCE','TRACK','WBR'];__exports.isArtificialVoidElement=isArtificialVoidElement;function isArtificialVoidElement(node){return isMediaElement(node)||node.nodeName==='HR';}
__exports.isNotAllowedContent=isNotAllowedContent;function isNotAllowedContent(node){return isArtificialVoidElement(node)||VOID_ELEMENT_NAMES.includes(node.nodeName);}
__exports.containsUnremovable=containsUnremovable;function containsUnremovable(node){if(!node){return false;}
return isUnremovable(node)||containsUnremovable(node.firstChild);}
__exports.getInSelection=getInSelection;function getInSelection(document,selector){const selection=document.getSelection();const range=selection&&!!selection.rangeCount&&selection.getRangeAt(0);if(range){const selectorInStartAncestors=closestElement(range.startContainer,selector);if(selectorInStartAncestors){return selectorInStartAncestors;}else{const commonElementAncestor=closestElement(range.commonAncestorContainer);return commonElementAncestor&&[...commonElementAncestor.querySelectorAll(selector)].find(node=>range.intersectsNode(node),);}}}
__exports.getRowIndex=getRowIndex;function getRowIndex(trOrTd){const tr=closestElement(trOrTd,'tr');const trParent=tr&&tr.parentElement;if(!trParent){return-1;}
const trSiblings=[...trParent.children].filter(child=>child.nodeName==='TR');return trSiblings.findIndex(child=>child===tr);}
__exports.getColumnIndex=getColumnIndex;function getColumnIndex(td){const tdParent=td.parentElement;if(!tdParent){return-1;}
const tdSiblings=[...tdParent.children].filter(child=>child.nodeName==='TD'||child.nodeName==='TH');return tdSiblings.findIndex(child=>child===td);}
const paragraphRelatedElements=__exports.paragraphRelatedElements=['P','H1','H2','H3','H4','H5','H6','PRE','BLOCKQUOTE',];__exports.allowsParagraphRelatedElements=allowsParagraphRelatedElements;function allowsParagraphRelatedElements(node){return isBlock(node)&&!['P','H1','H2','H3','H4','H5','H6'].includes(node.nodeName);}
__exports.makeContentsInline=makeContentsInline;function makeContentsInline(node){let childIndex=0;for(const child of node.childNodes){if(isBlock(child)){if(childIndex&&paragraphRelatedElements.includes(child.nodeName)){child.before(document.createElement('br'));}
for(const grandChild of child.childNodes){child.before(grandChild);makeContentsInline(grandChild);}
child.remove();}
childIndex+=1;}}
__exports.getOuid=getOuid;function getOuid(node,optimize=false){while(node&&!isUnbreakable(node)){if(node.ouid&&optimize)return node.ouid;node=node.parentNode;}
return node&&node.oid;}
__exports.isHtmlContentSupported=isHtmlContentSupported;function isHtmlContentSupported(node){return!closestElement(node,'[data-oe-model]:not([data-oe-field="arch"]):not([data-oe-type="html"]),[data-oe-translation-id]',true);}
const selfClosingElementTags=['BR','IMG','INPUT'];__exports.isSelfClosingElement=isSelfClosingElement;function isSelfClosingElement(node){return node&&selfClosingElementTags.includes(node.nodeName);}
__exports.isInPre=isInPre;function isInPre(node){const element=node.nodeType===Node.TEXT_NODE?node.parentElement:node;return(!!element&&(!!element.closest('pre')||getComputedStyle(element).getPropertyValue('white-space')==='pre'));}
const whitespace=`[^\\S\\u00A0\\u0009\\ufeff]`;const whitespaceRegex=new RegExp(`^${whitespace}*$`);__exports.isWhitespace=isWhitespace;function isWhitespace(value){const str=typeof value==='string'?value:value.nodeValue;return whitespaceRegex.test(str);}
__exports.isVisible=isVisible;function isVisible(node){return!!node&&((node.nodeType===Node.TEXT_NODE&&isVisibleTextNode(node))||(node.nodeType===Node.ELEMENT_NODE&&(node.getAttribute("t-esc")||node.getAttribute("t-out")))||isSelfClosingElement(node)||isIconElement(node)||hasVisibleContent(node));}
__exports.hasVisibleContent=hasVisibleContent;function hasVisibleContent(node){return[...(node?.childNodes||[])].some(n=>isVisible(n));}
__exports.isButton=isButton;function isButton(node){if(!node||node.nodeType!==Node.ELEMENT_NODE){return false;}
return node.nodeName==="BUTTON"||node.classList.contains("btn");}
const visibleCharRegex=/[^\s\u200b]|[\u00A0\u0009]$/;__exports.isVisibleTextNode=isVisibleTextNode;function isVisibleTextNode(testedNode){if(!testedNode||!testedNode.length||testedNode.nodeType!==Node.TEXT_NODE){return false;}
if(visibleCharRegex.test(testedNode.textContent)||(isInPre(testedNode)&&isWhitespace(testedNode))){return true;}
if(ZERO_WIDTH_CHARS.includes(testedNode.textContent)){return false;}
let preceding;let following;let foundTestedNode;const currentNodeParentBlock=closestBlock(testedNode);if(!currentNodeParentBlock){return false;}
const nodeIterator=document.createNodeIterator(currentNodeParentBlock);for(let node=nodeIterator.nextNode();node;node=nodeIterator.nextNode()){if(node.nodeType===Node.TEXT_NODE){if(foundTestedNode){following=node;break;}else if(testedNode===node){foundTestedNode=true;}else{preceding=node;}}else if(isBlock(node)){if(foundTestedNode){break;}else{preceding=null;}}else if(foundTestedNode&&!isWhitespace(node)){following=node;break;}}
while(following&&!visibleCharRegex.test(following.textContent)){following=following.nextSibling;}
if(!(preceding&&following)||currentNodeParentBlock!==closestBlock(preceding)||currentNodeParentBlock!==closestBlock(following)){return false;}
return visibleCharRegex.test(preceding.textContent);}
__exports.parentsGet=parentsGet;function parentsGet(node,root=undefined){const parents=[];while(node){parents.unshift(node);if(node===root){break;}
node=node.parentNode;}
return parents;}
__exports.commonParentGet=commonParentGet;function commonParentGet(node1,node2,root=undefined){if(!node1||!node2){return null;}
const n1p=parentsGet(node1,root);const n2p=parentsGet(node2,root);while(n1p.length>1&&n1p[1]===n2p[1]){n1p.shift();n2p.shift();}
return n1p[0]===n2p[0]?n1p[0]:null;}
__exports.getListMode=getListMode;function getListMode(pnode){if(!["UL","OL"].includes(pnode.tagName))return;if(pnode.tagName=='OL')return'OL';return pnode.classList.contains('o_checklist')?'CL':'UL';}
__exports.createList=createList;function createList(mode){const node=document.createElement(mode=='OL'?'OL':'UL');if(mode=='CL'){node.classList.add('o_checklist');}
return node;}
__exports.insertListAfter=insertListAfter;function insertListAfter(afterNode,mode,content=[]){const list=createList(mode);afterNode.after(list);list.append(...content.map(c=>{const li=document.createElement('LI');li.append(...[].concat(c));return li;}),);return list;}
__exports.toggleList=toggleList;function toggleList(node,mode,offset=0){let pnode=node.closest('ul, ol');if(!pnode)return;const listMode=getListMode(pnode)+mode;if(['OLCL','ULCL'].includes(listMode)){pnode.classList.add('o_checklist');for(let li=pnode.firstElementChild;li!==null;li=li.nextElementSibling){if(li.style.listStyle!=='none'){li.style.listStyle=null;if(!li.style.all)li.removeAttribute('style');}}
pnode=setTagName(pnode,'UL');}else if(['CLOL','CLUL'].includes(listMode)){toggleClass(pnode,'o_checklist');pnode=setTagName(pnode,mode);}else if(['OLUL','ULOL'].includes(listMode)){pnode=setTagName(pnode,mode);}else{let currNode=node;while(currNode){currNode=currNode.oShiftTab(offset);}
return;}
return pnode;}
__exports.convertList=convertList;function convertList(node,toMode){if(!["UL","OL","LI"].includes(node.nodeName))return;const listMode=getListMode(node);if(listMode&&toMode!==listMode){node=toggleList(node,toMode);}
for(const child of node.childNodes){convertList(child,toMode);}
return node;}
__exports.toggleClass=toggleClass;function toggleClass(node,className){node.classList.toggle(className);if(!node.className){node.removeAttribute('class');}}
__exports.makeZeroWidthCharactersVisible=makeZeroWidthCharactersVisible;function makeZeroWidthCharactersVisible(text){return text.replaceAll('\u200B','//ZWSP//').replaceAll('\uFEFF','//ZWNBSP//');}
__exports.isFakeLineBreak=isFakeLineBreak;function isFakeLineBreak(brEl){return!(getState(...rightPos(brEl),DIRECTIONS.RIGHT).cType&(CTYPES.CONTENT|CTGROUPS.BR));}
__exports.isEmptyBlock=isEmptyBlock;function isEmptyBlock(blockEl){if(!blockEl||blockEl.nodeType!==Node.ELEMENT_NODE){return false;}
if(isIconElement(blockEl)||visibleCharRegex.test(blockEl.textContent)){return false;}
if(blockEl.querySelectorAll('br').length>=2){return false;}
const nodes=blockEl.querySelectorAll('*');for(const node of nodes){if(node.nodeName!='BR'&&(isSelfClosingElement(node)||isIconElement(node))){return false;}}
return true;}
__exports.isShrunkBlock=isShrunkBlock;function isShrunkBlock(blockEl){return(isEmptyBlock(blockEl)&&!blockEl.querySelector('br')&&blockEl.nodeName!=="IMG");}
__exports.isColorGradient=isColorGradient;function isColorGradient(value){return value&&value.includes('-gradient(');}
__exports.getFontSizeDisplayValue=getFontSizeDisplayValue;function getFontSizeDisplayValue(sel,getCSSVariableValue,convertNumericToUnit){const tagNameRelatedToFontSize=["h1","h2","h3","h4","h5","h6"];const styleClassesRelatedToFontSize=["display-1","display-2","display-3","display-4","lead"];const closestStartContainerEl=closestElement(sel.getRangeAt(0).startContainer);const closestFontSizedEl=closestStartContainerEl.closest(`
        [style*='font-size'],
        ${FONT_SIZE_CLASSES.map(className => `.${className}`)},
        ${styleClassesRelatedToFontSize.map(className => `.${className}`)},
        ${tagNameRelatedToFontSize}
    `);let remValue;if(closestFontSizedEl){const useFontSizeInput=closestFontSizedEl.style.fontSize;if(useFontSizeInput){return parseFloat(getComputedStyle(closestStartContainerEl).fontSize);}
const fontSizeClass=FONT_SIZE_CLASSES.find(className=>closestFontSizedEl.classList.contains(className));let fsName;if(fontSizeClass){fsName=fontSizeClass.substring(0,fontSizeClass.length-3);}else{fsName=styleClassesRelatedToFontSize.find(className=>closestFontSizedEl.classList.contains(className))||closestFontSizedEl.tagName.toLowerCase();}
remValue=parseFloat(getCSSVariableValue(`${fsName}-font-size`));}
const pxValue=remValue&&convertNumericToUnit(remValue,"rem","px");return pxValue||parseFloat(getComputedStyle(closestStartContainerEl).fontSize);}
__exports.splitTextNode=splitTextNode;function splitTextNode(textNode,offset,originalNodeSide=DIRECTIONS.RIGHT){let parentOffset=childNodeIndex(textNode);if(offset>0){parentOffset++;if(offset<textNode.length){const left=textNode.nodeValue.substring(0,offset);const right=textNode.nodeValue.substring(offset);if(originalNodeSide===DIRECTIONS.LEFT){const newTextNode=document.createTextNode(right);textNode.after(newTextNode);textNode.nodeValue=left;}else{const newTextNode=document.createTextNode(left);textNode.before(newTextNode);textNode.nodeValue=right;}}}
return parentOffset;}
__exports.splitElement=splitElement;function splitElement(element,offset){const before=element.cloneNode();const after=element.cloneNode();let index=0;for(const child of[...element.childNodes]){index<offset?before.appendChild(child):after.appendChild(child);index++;}
const blockEl=closestBlock(after);if(blockEl){fillEmpty(blockEl);}
element.before(before);element.after(after);element.remove();return[before,after];}
__exports.splitAroundUntil=splitAroundUntil;function splitAroundUntil(elements,limitAncestor){elements=Array.isArray(elements)?elements:[elements];const firstNode=elements[0];const lastNode=elements[elements.length-1];if([firstNode,lastNode].includes(limitAncestor)){return limitAncestor;}
let before=firstNode.previousSibling;let after=lastNode.nextSibling;let beforeSplit,afterSplit;if(!before&&!after&&elements[0]!==limitAncestor){return splitAroundUntil(elements[0].parentElement,limitAncestor);}
while(after&&after.parentElement!==limitAncestor){afterSplit=splitElement(after.parentElement,childNodeIndex(after))[0];after=afterSplit.nextSibling;}
if(after){afterSplit=splitElement(limitAncestor,childNodeIndex(after))[0];limitAncestor=afterSplit;}
while(before&&before.parentElement!==limitAncestor){beforeSplit=splitElement(before.parentElement,childNodeIndex(before)+1)[1];before=beforeSplit.previousSibling;}
if(before){beforeSplit=splitElement(limitAncestor,childNodeIndex(before)+1)[1];}
return beforeSplit||afterSplit||limitAncestor;}
__exports.insertText=insertText;function insertText(sel,content){if(!content){return;}
if(sel.anchorNode.nodeType===Node.TEXT_NODE){const pos=[sel.anchorNode.parentElement,splitTextNode(sel.anchorNode,sel.anchorOffset)];setSelection(...pos,...pos,false);}
const txt=document.createTextNode(content||'#');const restore=prepareUpdate(sel.anchorNode,sel.anchorOffset);sel.getRangeAt(0).insertNode(txt);restore();setSelection(...boundariesOut(txt),false);return txt;}
__exports.insertCharsAt=insertCharsAt;function insertCharsAt(chars,node,offset){if(node.nodeType===Node.TEXT_NODE){const startValue=node.nodeValue;if(offset<0||offset>startValue.length){throw new Error(`Invalid ${chars} insertion in text node`);}
node.nodeValue=startValue.slice(0,offset)+chars+startValue.slice(offset);}else{if(offset<0||offset>node.childNodes.length){throw new Error(`Invalid ${chars} insertion in non-text node`);}
const textNode=document.createTextNode(chars);if(offset<node.childNodes.length){node.insertBefore(textNode,node.childNodes[offset]);}else{node.appendChild(textNode);}}}
__exports.unwrapContents=unwrapContents;function unwrapContents(node){const contents=[...node.childNodes];for(const child of contents){node.parentNode.insertBefore(child,node);}
node.parentNode.removeChild(node);return contents;}
__exports.fillEmpty=fillEmpty;function fillEmpty(el){const fillers={};const blockEl=closestBlock(el);if(isShrunkBlock(blockEl)){const br=document.createElement('br');blockEl.appendChild(br);fillers.br=br;}
if(!isTangible(el)&&!el.hasAttribute("data-oe-zws-empty-inline")&&isEmptyBlock(el)){const zws=document.createTextNode('\u200B');el.appendChild(zws);el.setAttribute("data-oe-zws-empty-inline","");fillers.zws=zws;const previousSibling=el.previousSibling;if(previousSibling&&previousSibling.nodeName==="BR"){previousSibling.remove();}
setSelection(zws,0,zws,0);}
if(!isVisible(el)&&el.nodeName!=='A'&&closestElement(el,'a')&&getComputedStyle(el).display==='inline'){el.style.display='inline-block';}
return fillers;}
__exports.insertAndSelectZws=insertAndSelectZws;function insertAndSelectZws(selection){const offset=selection.anchorOffset;const zws=insertText(selection,'\u200B');splitTextNode(zws,offset);selection.getRangeAt(0).selectNode(zws);return zws;}
__exports.setTagName=setTagName;function setTagName(el,newTagName){if(el.tagName===newTagName){return el;}
const n=document.createElement(newTagName);if(el.nodeName!=='LI'){el.style.removeProperty('list-style');const attributes=el.attributes;for(const attr of attributes){n.setAttribute(attr.name,attr.value);}}
while(el.firstChild){n.append(el.firstChild);}
if(el.tagName==='LI'){el.append(n);}else{el.parentNode.replaceChild(n,el);}
return n;}
__exports.moveNodes=moveNodes;function moveNodes(destinationEl,destinationOffset,sourceEl,startIndex=0,endIndex=sourceEl.childNodes.length,){if(selfClosingElementTags.includes(destinationEl.nodeName)){throw new Error(`moveNodes: Invalid destination element ${destinationEl.nodeName}`);}
const nodes=[];for(let i=startIndex;i<endIndex;i++){nodes.push(sourceEl.childNodes[i]);}
if(nodes.length){const restoreDestination=prepareUpdate(destinationEl,destinationOffset);const restoreMoved=prepareUpdate(...leftPos(sourceEl.childNodes[startIndex]),...rightPos(sourceEl.childNodes[endIndex-1]),);const fragment=document.createDocumentFragment();nodes.forEach(node=>fragment.appendChild(node));const posRightNode=destinationEl.childNodes[destinationOffset];if(posRightNode){destinationEl.insertBefore(fragment,posRightNode);}else{destinationEl.appendChild(fragment);}
restoreDestination();restoreMoved();}
if(!nodeSize(sourceEl)){const restoreOrigin=prepareUpdate(...boundariesOut(sourceEl));sourceEl.remove();restoreOrigin();}
const firstNode=nodes.find(node=>!!node.parentNode);return firstNode?leftPos(firstNode):[destinationEl,destinationOffset];}
__exports.resetOuids=resetOuids;function resetOuids(node){node.ouid=undefined;for(const descendant of descendants(node)){descendant.ouid=undefined;}}
const prepareUpdateLockedEditables=new Set();__exports.prepareUpdate=prepareUpdate;function prepareUpdate(...args){const closestRoot=args.length&&ancestors(args[0]).find(ancestor=>ancestor.oid==='root');const isPrepareUpdateLocked=closestRoot&&prepareUpdateLockedEditables.has(closestRoot);const hash=(Math.random()+1).toString(36).substring(7);const options={allowReenter:true,label:hash,debug:false,...(args.length&&args[args.length-1]instanceof Object?args.pop():{}),};if(options.debug){console.log('%cPreparing%c update: '+options.label+
(options.label===hash?'':` (${hash})`)+'%c'+(isPrepareUpdateLocked?' LOCKED':''),'color: cyan;','color: white;','color: red; font-weight: bold;',);}
if(isPrepareUpdateLocked){return()=>{if(options.debug){console.log('%cRestoring%c update: '+options.label+
(options.label===hash?'':` (${hash})`)+'%c LOCKED','color: lightgreen;','color: white;','color: red; font-weight: bold;',);}};}
if(!options.allowReenter&&closestRoot){prepareUpdateLockedEditables.add(closestRoot);}
const positions=[...args];const restoreData=[];let el,offset;while(positions.length){offset=positions.pop();el=positions.pop();const left=getState(el,offset,DIRECTIONS.LEFT);const right=getState(el,offset,DIRECTIONS.RIGHT,left.cType);if(options.debug){const editable=el&&closestElement(el,'.odoo-editor-editable');const oldEditableHTML=editable&&makeZeroWidthCharactersVisible(editable.innerHTML).replaceAll(' ','_')||'';left.oldEditableHTML=oldEditableHTML;right.oldEditableHTML=oldEditableHTML;}
restoreData.push(left,right);}
return function restoreStates(){if(options.debug){console.log('%cRestoring%c update: '+options.label+
(options.label===hash?'':` (${hash})`),'color: lightgreen;','color: white;',);}
for(const data of restoreData){restoreState(data,options.debug);}
if(!options.allowReenter&&closestRoot){prepareUpdateLockedEditables.delete(closestRoot);}};}
__exports.getState=getState;function getState(el,offset,direction,leftCType){const leftDOMPath=leftLeafOnlyNotBlockPath;const rightDOMPath=rightLeafOnlyNotBlockPath;let domPath;let inverseDOMPath;const whitespaceAtStartRegex=new RegExp('^'+whitespace+'+');const whitespaceAtEndRegex=new RegExp(whitespace+'+$');const reasons=[];if(direction===DIRECTIONS.LEFT){domPath=leftDOMPath(el,offset,reasons);inverseDOMPath=rightDOMPath(el,offset);}else{domPath=rightDOMPath(el,offset,reasons);inverseDOMPath=leftDOMPath(el,offset);}
const boundaryNode=inverseDOMPath.next().value;let cType=undefined;let lastSpace=null;for(const node of domPath){if(node.nodeType===Node.TEXT_NODE){const value=node.nodeValue.replaceAll('\ufeff','');if(direction===DIRECTIONS.LEFT){if(!isWhitespace(value)){if(lastSpace){cType=CTYPES.SPACE;}else{const rightLeaf=rightLeafOnlyNotBlockPath(node).next().value;const hasContentRight=rightLeaf&&!whitespaceAtStartRegex.test(rightLeaf.textContent);cType=!hasContentRight&&whitespaceAtEndRegex.test(node.textContent)?CTYPES.SPACE:CTYPES.CONTENT;}
break;}
if(value.length){lastSpace=node;}}else{leftCType=leftCType||getState(el,offset,DIRECTIONS.LEFT).cType;if(whitespaceAtStartRegex.test(value)){const leftLeaf=leftLeafOnlyNotBlockPath(node).next().value;const hasContentLeft=leftLeaf&&!whitespaceAtEndRegex.test(leftLeaf.textContent);const rct=!isWhitespace(value)?CTYPES.CONTENT:getState(...rightPos(node),DIRECTIONS.RIGHT).cType;cType=leftCType&CTYPES.CONTENT&&rct&(CTYPES.CONTENT|CTYPES.BR)&&!hasContentLeft?CTYPES.SPACE:rct;break;}
if(!isWhitespace(value)){cType=CTYPES.CONTENT;break;}}}else if(node.nodeName==='BR'){cType=CTYPES.BR;break;}else if(isVisible(node)){cType=CTYPES.CONTENT;break;}}
if(cType===undefined){cType=reasons.includes(PATH_END_REASONS.BLOCK_HIT)?CTYPES.BLOCK_OUTSIDE:CTYPES.BLOCK_INSIDE;}
return{node:boundaryNode,direction:direction,cType:cType,};}
const priorityRestoreStateRules=[[{cType1:CTYPES.CONTENT,cType2:CTYPES.SPACE|CTGROUPS.BLOCK},{spaceVisibility:true},],[{direction:DIRECTIONS.LEFT,cType1:CTGROUPS.INLINE,cType2:CTGROUPS.BR},{spaceVisibility:true},],[{direction:DIRECTIONS.RIGHT,cType1:CTGROUPS.CONTENT,cType2:CTGROUPS.BR},{spaceVisibility:true},],[{direction:DIRECTIONS.RIGHT,cType1:CTGROUPS.BR,cType2:CTYPES.SPACE|CTGROUPS.BLOCK},{spaceVisibility:true},],[{cType1:CTYPES.SPACE},{spaceVisibility:false},],[{direction:DIRECTIONS.LEFT,cType1:CTGROUPS.BR},{spaceVisibility:false},],[{cType1:CTGROUPS.BLOCK,cType2:CTGROUPS.INLINE|CTGROUPS.BR},{spaceVisibility:false},],[{direction:DIRECTIONS.RIGHT,cType1:CTGROUPS.INLINE,cType2:CTGROUPS.BLOCK},{brVisibility:true},],[{direction:DIRECTIONS.RIGHT,cType1:CTGROUPS.BLOCK,cType2:CTGROUPS.INLINE|CTGROUPS.BR,},{brVisibility:false},],[{direction:DIRECTIONS.LEFT,cType1:CTGROUPS.BR|CTGROUPS.BLOCK,cType2:CTGROUPS.INLINE,},{brVisibility:false,extraBRRemovalCondition:brNode=>isFakeLineBreak(brNode)},],];function restoreStateRuleHashCode(direction,cType1,cType2){return`${direction}-${cType1}-${cType2}`;}
const allRestoreStateRules=(function(){const map=new Map();const keys=['direction','cType1','cType2'];for(const direction of Object.values(DIRECTIONS)){for(const cType1 of Object.values(CTYPES)){for(const cType2 of Object.values(CTYPES)){const rule={direction:direction,cType1:cType1,cType2:cType2};const matchedRules=[];for(const entry of priorityRestoreStateRules){let priority=0;for(const key of keys){const entryKeyValue=entry[0][key];if(entryKeyValue!==undefined){if(typeof entryKeyValue==='boolean'?rule[key]===entryKeyValue:rule[key]&entryKeyValue){priority++;}else{priority=-1;break;}}}
if(priority>=0){matchedRules.push([priority,entry[1]]);}}
const finalRule={};for(let p=0;p<=keys.length;p++){for(const entry of matchedRules){if(entry[0]===p){Object.assign(finalRule,entry[1]);}}}
const hashCode=restoreStateRuleHashCode(direction,cType1,cType2);map.set(hashCode,finalRule);}}}
return map;})();__exports.restoreState=restoreState;function restoreState(prevStateData,debug=false){const{node,direction,cType:cType1,oldEditableHTML}=prevStateData;if(!node||!node.parentNode){return;}
const[el,offset]=direction===DIRECTIONS.LEFT?leftPos(node):rightPos(node);const{cType:cType2}=getState(el,offset,direction);const ruleHashCode=restoreStateRuleHashCode(direction,cType1,cType2);const rule=allRestoreStateRules.get(ruleHashCode);if(debug){const editable=closestElement(node,'.odoo-editor-editable');console.log('%c'+makeZeroWidthCharactersVisible(node.textContent).replaceAll(' ','_')+'\n'+'%c'+(direction===DIRECTIONS.LEFT?'left':'right')+'\n'+'%c'+ctypeToString(cType1)+'\n'+'%c'+ctypeToString(cType2)+'\n'+'%c'+'BEFORE: '+(oldEditableHTML||'(unavailable)')+'\n'+'%c'+'AFTER:  '+(editable?makeZeroWidthCharactersVisible(editable.innerHTML).replaceAll(' ','_'):'(unavailable)')+'\n','color: white; display: block; width: 100%;','color: '+(direction===DIRECTIONS.LEFT?'magenta':'lightgreen')+'; display: block; width: 100%;','color: pink; display: block; width: 100%;','color: lightblue; display: block; width: 100%;','color: white; display: block; width: 100%;','color: white; display: block; width: 100%;',rule,);}
if(Object.values(rule).filter(x=>x!==undefined).length){const inverseDirection=direction===DIRECTIONS.LEFT?DIRECTIONS.RIGHT:DIRECTIONS.LEFT;enforceWhitespace(el,offset,inverseDirection,rule);}
return rule;}
__exports.enforceWhitespace=enforceWhitespace;function enforceWhitespace(el,offset,direction,rule){let domPath,whitespaceAtEdgeRegex;if(direction===DIRECTIONS.LEFT){domPath=leftLeafOnlyNotBlockPath(el,offset);whitespaceAtEdgeRegex=new RegExp(whitespace+'+$');}else{domPath=rightLeafOnlyNotBlockPath(el,offset);whitespaceAtEdgeRegex=new RegExp('^'+whitespace+'+');}
const invisibleSpaceTextNodes=[];let foundVisibleSpaceTextNode=null;for(const node of domPath){if(node.nodeName==='BR'){if(rule.brVisibility===undefined){break;}
if(rule.brVisibility){node.before(document.createElement('br'));}else{if(!rule.extraBRRemovalCondition||rule.extraBRRemovalCondition(node)){node.remove();}}
break;}else if(node.nodeType===Node.TEXT_NODE&&!isInPre(node)){if(whitespaceAtEdgeRegex.test(node.nodeValue)){if(!isWhitespace(node)){foundVisibleSpaceTextNode=node;break;}else{invisibleSpaceTextNodes.push(node);}}else if(!isWhitespace(node)){break;}}else{break;}}
if(rule.spaceVisibility===undefined){return;}
if(!rule.spaceVisibility){for(const node of invisibleSpaceTextNodes){node.nodeValue='';const ancestorPath=closestPath(node.parentNode);let toRemove=null;for(const pNode of ancestorPath){if(toRemove){toRemove.remove();}
if(pNode.childNodes.length===1&&!isBlock(pNode)){pNode.after(node);toRemove=pNode;}else{break;}}}}
const spaceNode=foundVisibleSpaceTextNode||invisibleSpaceTextNodes[0];if(spaceNode){let spaceVisibility=rule.spaceVisibility;if(spaceVisibility&&!foundVisibleSpaceTextNode&&getState(...rightPos(spaceNode),DIRECTIONS.RIGHT).cType&CTGROUPS.BLOCK&&getState(...leftPos(spaceNode),DIRECTIONS.LEFT).cType!==CTYPES.CONTENT){spaceVisibility=false;}
spaceNode.nodeValue=spaceNode.nodeValue.replace(whitespaceAtEdgeRegex,spaceVisibility?'\u00A0':'');}}
__exports.rgbToHex=rgbToHex;function rgbToHex(rgb='',node=null){if(rgb.startsWith('#')){return rgb;}else if(rgb.startsWith('rgba')){const values=rgb.match(/[\d\.]{1,5}/g)||[];const alpha=parseFloat(values.pop());let bgRgbValues=[];if(node){let bgColor=getComputedStyle(node).backgroundColor;if(bgColor.startsWith('rgba')){bgColor=rgbToHex(bgColor,node.parentElement);}
if(bgColor&&bgColor.startsWith('#')){bgRgbValues=(bgColor.match(/[\da-f]{2}/gi)||[]).map(val=>parseInt(val,16));}else if(bgColor&&bgColor.startsWith('rgb')){bgRgbValues=(bgColor.match(/[\d\.]{1,5}/g)||[]).map(val=>parseInt(val));}}
bgRgbValues=bgRgbValues.length?bgRgbValues:[255,255,255];return('#'+
values.map((value,index)=>{const converted=Math.floor(alpha*parseInt(value)+(1-alpha)*bgRgbValues[index]);const hex=parseInt(converted).toString(16);return hex.length===1?'0'+hex:hex;}).join(''));}else{return('#'+
(rgb.match(/\d{1,3}/g)||[]).map(x=>{x=parseInt(x).toString(16);return x.length===1?'0'+x:x;}).join(''));}}
__exports.parseHTML=parseHTML;function parseHTML(document,html){const fragment=document.createDocumentFragment();const parser=new document.defaultView.DOMParser();const parsedDocument=parser.parseFromString(html,'text/html');fragment.replaceChildren(...parsedDocument.body.childNodes);return fragment;}
__exports.pxToFloat=pxToFloat;function pxToFloat(sizeString){return parseFloat(sizeString.replace('px',''));}
__exports.getRangePosition=getRangePosition;function getRangePosition(el,document,options={}){const selection=document.getSelection();if(!selection.rangeCount)return;const range=selection.getRangeAt(0);const isRtl=options.direction==='rtl';const marginRight=options.marginRight||20;const marginBottom=options.marginBottom||20;const marginTop=options.marginTop||10;const marginLeft=options.marginLeft||10;let offset;if(range.endOffset-1>0){const clonedRange=range.cloneRange();clonedRange.setStart(range.endContainer,range.endOffset-1);clonedRange.setEnd(range.endContainer,range.endOffset);const rect=clonedRange.getBoundingClientRect();offset={height:rect.height,left:rect.left+rect.width,top:rect.top};clonedRange.detach();}
if(!offset||offset.height===0){const clonedRange=range.cloneRange();const shadowCaret=document.createTextNode('|');clonedRange.insertNode(shadowCaret);clonedRange.selectNode(shadowCaret);const rect=clonedRange.getBoundingClientRect();offset={height:rect.height,left:rect.left,top:rect.top};shadowCaret.remove();clonedRange.detach();}
if(isRtl){offset.right=offset.left-el.offsetWidth;const leftMove=Math.max(0,offset.right+el.offsetWidth+marginLeft-window.innerWidth);if(leftMove&&offset.right-leftMove>marginRight){offset.right-=leftMove;}else if(offset.right-leftMove<marginRight){offset.right=marginRight;}}
const leftMove=Math.max(0,offset.left+el.offsetWidth+marginRight-window.innerWidth);if(leftMove&&offset.left-leftMove>marginLeft){offset.left-=leftMove;}else if(offset.left-leftMove<marginLeft){offset.left=marginLeft;}
if(options.getContextFromParentRect){const parentContextRect=options.getContextFromParentRect();offset.left+=parentContextRect.left;offset.top+=parentContextRect.top;if(isRtl){offset.right+=parentContextRect.left;}}
if(offset.top-marginTop+offset.height+el.offsetHeight>window.innerHeight&&offset.top-el.offsetHeight-marginBottom>0){offset.top-=el.offsetHeight;}else{offset.top+=offset.height;}
if(offset){offset.top+=window.scrollY;offset.left+=window.scrollX;if(isRtl){offset.right+=window.scrollX;}}
if(isRtl){offset.right=window.innerWidth-offset.right-el.offsetWidth;}
return offset;}
const isNotEditableNode=__exports.isNotEditableNode=node=>node.getAttribute&&node.getAttribute('contenteditable')&&node.getAttribute('contenteditable').toLowerCase()==='false';const isRoot=__exports.isRoot=node=>node.oid==="root";const leftLeafFirstPath=__exports.leftLeafFirstPath=createDOMPathGenerator(DIRECTIONS.LEFT);const leftLeafOnlyNotBlockPath=__exports.leftLeafOnlyNotBlockPath=createDOMPathGenerator(DIRECTIONS.LEFT,{leafOnly:true,stopTraverseFunction:isBlock,stopFunction:node=>isBlock(node)||isRoot(node),});const leftLeafOnlyInScopeNotBlockEditablePath=__exports.leftLeafOnlyInScopeNotBlockEditablePath=createDOMPathGenerator(DIRECTIONS.LEFT,{leafOnly:true,inScope:true,stopTraverseFunction:node=>isNotEditableNode(node)||isBlock(node),stopFunction:node=>isNotEditableNode(node)||isBlock(node)||isRoot(node),});const rightLeafOnlyNotBlockPath=__exports.rightLeafOnlyNotBlockPath=createDOMPathGenerator(DIRECTIONS.RIGHT,{leafOnly:true,stopTraverseFunction:isBlock,stopFunction:node=>isBlock(node)||isRoot(node),});const rightLeafOnlyPathNotBlockNotEditablePath=__exports.rightLeafOnlyPathNotBlockNotEditablePath=createDOMPathGenerator(DIRECTIONS.RIGHT,{leafOnly:true,stopFunction:node=>isRoot(node),});const rightLeafOnlyInScopeNotBlockEditablePath=__exports.rightLeafOnlyInScopeNotBlockEditablePath=createDOMPathGenerator(DIRECTIONS.RIGHT,{leafOnly:true,inScope:true,stopTraverseFunction:node=>isNotEditableNode(node)||isBlock(node),stopFunction:node=>isNotEditableNode(node)||isBlock(node)||isRoot(node),});const rightLeafOnlyNotBlockNotEditablePath=__exports.rightLeafOnlyNotBlockNotEditablePath=createDOMPathGenerator(DIRECTIONS.RIGHT,{leafOnly:true,stopTraverseFunction:node=>isNotEditableNode(node)||isBlock(node),stopFunction:node=>isBlock(node)&&!isNotEditableNode(node)||isRoot(node),});__exports.peek=peek;function peek(arr){return arr[arr.length-1];}
__exports.isMacOS=isMacOS;function isMacOS(){return window.navigator.userAgent.includes('Mac');}
__exports.cleanZWS=cleanZWS;function cleanZWS(node){[node,...descendants(node)].filter(node=>node.nodeType===Node.TEXT_NODE&&node.nodeValue.includes('\u200B')).forEach((node)=>{node.nodeValue=node.nodeValue.replace(/\u200B/g,"");if(node.nodeValue===""){node.remove();}});}
return __exports;});;

/* /web_editor/static/src/js/wysiwyg/fonts.js */
odoo.define('@web_editor/js/wysiwyg/fonts',[],function(require){'use strict';let __exports={};const fonts=__exports.fonts={cacheCssSelectors:{},getCssSelectors:function(filter){if(this.cacheCssSelectors[filter]){return this.cacheCssSelectors[filter];}
this.cacheCssSelectors[filter]=[];var sheets=document.styleSheets;for(var i=0;i<sheets.length;i++){var rules;try{rules=sheets[i].rules||sheets[i].cssRules;}catch{continue;}
if(!rules){continue;}
for(var r=0;r<rules.length;r++){var selectorText=rules[r].selectorText;if(!selectorText){continue;}
var selectors=selectorText.split(/\s*,\s*/);var data=null;for(var s=0;s<selectors.length;s++){var match=selectors[s].trim().match(filter);if(!match){continue;}
if(!data){data={selector:match[0],css:rules[r].cssText.replace(/(^.*\{\s*)|(\s*\}\s*$)/g,''),names:[match[1]]};}else{data.selector+=(', '+match[0]);data.names.push(match[1]);}}
if(data){this.cacheCssSelectors[filter].push(data);}}}
return this.cacheCssSelectors[filter];},fontIcons:[{base:'fa',parser:/\.(fa-(?:\w|-)+)::?before/i}],computedFonts:false,computeFonts:function(){if(!this.computedFonts){var self=this;this.fontIcons.forEach((data)=>{data.cssData=self.getCssSelectors(data.parser);data.alias=data.cssData.map((x)=>x.names).flat();});this.computedFonts=true;}},};__exports[Symbol.for("default")]=fonts;return __exports;});;

/* /web_editor/static/src/components/media_dialog/document_selector.js */
odoo.define('@web_editor/components/media_dialog/document_selector',['@web/core/l10n/translation','@web_editor/components/media_dialog/file_selector'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Attachment,FileSelector,IMAGE_MIMETYPES}=require("@web_editor/components/media_dialog/file_selector");const DocumentAttachment=__exports.DocumentAttachment=class DocumentAttachment extends Attachment{static template="web_editor.DocumentAttachment";}
const DocumentSelector=__exports.DocumentSelector=class DocumentSelector extends FileSelector{static mediaSpecificClasses=["o_image"];static mediaSpecificStyles=[];static mediaExtraClasses=[];static tagNames=["A"];static attachmentsListTemplate="web_editor.DocumentsListTemplate";static components={...FileSelector.components,DocumentAttachment,};setup(){super.setup();this.uploadText=_t("Upload a document");this.urlPlaceholder="https://www.odoo.com/mydocument";this.addText=_t("Add URL");this.searchPlaceholder=_t("Search a document");this.allLoadedText=_t("All documents have been loaded");}
get attachmentsDomain(){const domain=super.attachmentsDomain;domain.push(['mimetype','not in',IMAGE_MIMETYPES]);domain.unshift('&','|',['url','=',null],'!',['url','=like','/web/assets/%']);return domain;}
async onClickDocument(document){this.selectAttachment(document);await this.props.save();}
async fetchAttachments(...args){const attachments=await super.fetchAttachments(...args);if(this.selectInitialMedia()){for(const attachment of attachments){if(`/web/content/${attachment.id}`===this.props.media.getAttribute('href').replace(/[?].*/,'')){this.selectAttachment(attachment);}}}
return attachments;}
static async createElements(selectedMedia,{orm}){return Promise.all(selectedMedia.map(async attachment=>{const linkEl=document.createElement('a');let href=`/web/content/${encodeURIComponent(attachment.id)}?unique=${encodeURIComponent(attachment.checksum)}&download=true`;if(!attachment.public){let accessToken=attachment.access_token;if(!accessToken){[accessToken]=await orm.call('ir.attachment','generate_access_token',[attachment.id],);}
href+=`&access_token=${encodeURIComponent(accessToken)}`;}
linkEl.href=href;linkEl.title=attachment.name;linkEl.dataset.mimetype=attachment.mimetype;return linkEl;}));}}
return __exports;});;

/* /web_editor/static/src/components/media_dialog/file_selector.js */
odoo.define('@web_editor/components/media_dialog/file_selector',['@web/core/l10n/translation','@web/core/network/rpc','@web/core/utils/hooks','@web/core/confirmation_dialog/confirmation_dialog','@web/core/dialog/dialog','@web/core/utils/concurrency','@web/core/utils/timing','@web_editor/components/media_dialog/search_media','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{useService}=require('@web/core/utils/hooks');const{ConfirmationDialog}=require('@web/core/confirmation_dialog/confirmation_dialog');const{Dialog}=require('@web/core/dialog/dialog');const{KeepLast}=require("@web/core/utils/concurrency");const{useDebounced}=require("@web/core/utils/timing");const{SearchMedia}=require("@web_editor/components/media_dialog/search_media");const{Component,xml,useState,useRef,onWillStart,useEffect}=require("@odoo/owl");const IMAGE_MIMETYPES=__exports.IMAGE_MIMETYPES=['image/jpg','image/jpeg','image/jpe','image/png','image/svg+xml','image/gif','image/webp'];const IMAGE_EXTENSIONS=__exports.IMAGE_EXTENSIONS=['.jpg','.jpeg','.jpe','.png','.svg','.gif','.webp'];class RemoveButton extends Component{static template=xml`<i class="fa fa-trash o_existing_attachment_remove position-absolute top-0 end-0 p-2 bg-white-25 cursor-pointer opacity-0 opacity-100-hover z-1 transition-base" t-att-title="removeTitle" role="img" t-att-aria-label="removeTitle" t-on-click="this.remove"/>`;static props=["model?","remove"];setup(){this.removeTitle=_t("This file is attached to the current record.");if(this.props.model==='ir.ui.view'){this.removeTitle=_t("This file is a public view attachment.");}}
remove(ev){ev.stopPropagation();this.props.remove();}}
const AttachmentError=__exports.AttachmentError=class AttachmentError extends Component{static components={Dialog};static template=xml`
        <Dialog title="title">
            <div class="form-text">
                <p>The image could not be deleted because it is used in the
                    following pages or views:</p>
                <ul t-foreach="props.views"  t-as="view" t-key="view.id">
                    <li>
                        <a t-att-href="'/odoo/ir.ui.view/' + window.encodeURIComponent(view.id)">
                            <t t-esc="view.name"/>
                        </a>
                    </li>
                </ul>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="() => this.props.close()">
                    Ok
                </button>
            </t>
        </Dialog>`;static props=["views","close"];setup(){this.title=_t("Alert");}}
const Attachment=__exports.Attachment=class Attachment extends Component{static template="";static components={RemoveButton,};static props=["*"];setup(){this.dialogs=useService('dialog');}
remove(){this.dialogs.add(ConfirmationDialog,{body:_t("Are you sure you want to delete this file?"),confirm:async()=>{const prevented=await rpc('/web_editor/attachment/remove',{ids:[this.props.id],});if(!Object.keys(prevented).length){this.props.onRemoved(this.props.id);}else{this.dialogs.add(AttachmentError,{views:prevented[this.props.id],});}},});}}
const FileSelectorControlPanel=__exports.FileSelectorControlPanel=class FileSelectorControlPanel extends Component{static template="web_editor.FileSelectorControlPanel";static components={SearchMedia,};static props={uploadUrl:Function,validateUrl:Function,uploadFiles:Function,changeSearchService:Function,changeShowOptimized:Function,search:Function,accept:{type:String,optional:true},addText:{type:String,optional:true},multiSelect:{type:true,optional:true},needle:{type:String,optional:true},searchPlaceholder:{type:String,optional:true},searchService:{type:String,optional:true},showOptimized:{type:Boolean,optional:true},showOptimizedOption:{type:String,optional:true},uploadText:{type:String,optional:true},urlPlaceholder:{type:String,optional:true},urlWarningTitle:{type:String,optional:true},useMediaLibrary:{type:Boolean,optional:true},useUnsplash:{type:Boolean,optional:true},};setup(){this.state=useState({showUrlInput:false,urlInput:'',isValidUrl:false,isValidFileFormat:false,isValidatingUrl:false,});this.debouncedValidateUrl=useDebounced(this.props.validateUrl,500);this.fileInput=useRef('file-input');}
get showSearchServiceSelect(){return this.props.searchService&&this.props.needle;}
get enableUrlUploadClick(){return!this.state.showUrlInput||(this.state.urlInput&&this.state.isValidUrl&&this.state.isValidFileFormat);}
async onUrlUploadClick(){if(!this.state.showUrlInput){this.state.showUrlInput=true;}else{await this.props.uploadUrl(this.state.urlInput);this.state.urlInput='';}}
async onUrlInput(ev){this.state.isValidatingUrl=true;const{isValidUrl,isValidFileFormat}=await this.debouncedValidateUrl(ev.target.value);this.state.isValidFileFormat=isValidFileFormat;this.state.isValidUrl=isValidUrl;this.state.isValidatingUrl=false;}
onClickUpload(){this.fileInput.el.click();}
async onChangeFileInput(){const inputFiles=this.fileInput.el.files;if(!inputFiles.length){return;}
await this.props.uploadFiles(inputFiles);const fileInputEl=this.fileInput.el;if(fileInputEl){fileInputEl.value="";}}}
const FileSelector=__exports.FileSelector=class FileSelector extends Component{static template="web_editor.FileSelector";static components={FileSelectorControlPanel,};static props=["*"];setup(){this.notificationService=useService("notification");this.orm=useService('orm');this.uploadService=useService('upload');this.keepLast=new KeepLast();this.loadMoreButtonRef=useRef('load-more-button');this.existingAttachmentsRef=useRef("existing-attachments");this.state=useState({attachments:[],canScrollAttachments:false,canLoadMoreAttachments:false,isFetchingAttachments:false,needle:'',});this.NUMBER_OF_ATTACHMENTS_TO_DISPLAY=30;onWillStart(async()=>{this.state.attachments=await this.fetchAttachments(this.NUMBER_OF_ATTACHMENTS_TO_DISPLAY,0);});this.debouncedOnScroll=useDebounced(this.updateScroll,15);this.debouncedScrollUpdate=useDebounced(this.updateScroll,500);useEffect((modalEl)=>{if(modalEl){modalEl.addEventListener("scroll",this.debouncedOnScroll);return()=>{modalEl.removeEventListener("scroll",this.debouncedOnScroll);};}},()=>[this.props.modalRef.el?.querySelector("main.modal-body")]);useEffect(()=>{this.loadMoreButtonRef.el.classList.add("o_hide_loading");this.state.canScrollAttachments=false;this.debouncedScrollUpdate();},()=>[this.allAttachments.length]);}
get canLoadMore(){return this.state.canLoadMoreAttachments;}
get hasContent(){return this.state.attachments.length;}
get isFetching(){return this.state.isFetchingAttachments;}
get selectedAttachmentIds(){return this.props.selectedMedia[this.props.id].filter(media=>media.mediaType==='attachment').map(({id})=>id);}
get attachmentsDomain(){const domain=['&',['res_model','=',this.props.resModel],['res_id','=',this.props.resId||0]];domain.unshift('|',['public','=',true]);domain.push(['name','ilike',this.state.needle]);return domain;}
get allAttachments(){return this.state.attachments;}
validateUrl(url){const path=url.split('?')[0];const isValidUrl=/^.+\..+$/.test(path);const isValidFileFormat=true;return{isValidUrl,isValidFileFormat,path};}
async fetchAttachments(limit,offset){this.state.isFetchingAttachments=true;let attachments=[];try{attachments=await this.orm.call('ir.attachment','search_read',[],{domain:this.attachmentsDomain,fields:['name','mimetype','description','checksum','url','type','res_id','res_model','public','access_token','image_src','image_width','image_height','original_id'],order:'id desc',limit,offset,});attachments.forEach(attachment=>attachment.mediaType='attachment');}catch(e){if(e.exceptionName!=='odoo.exceptions.AccessError'){throw e;}}
this.state.canLoadMoreAttachments=attachments.length>=this.NUMBER_OF_ATTACHMENTS_TO_DISPLAY;this.state.isFetchingAttachments=false;return attachments;}
async handleLoadMore(){await this.loadMore();}
async loadMore(){return this.keepLast.add(this.fetchAttachments(this.NUMBER_OF_ATTACHMENTS_TO_DISPLAY,this.state.attachments.length)).then((newAttachments)=>{this.state.attachments.push(...newAttachments);});}
async handleSearch(needle){await this.search(needle);}
async search(needle){this.state.attachments=[];this.state.needle=needle;return this.keepLast.add(this.fetchAttachments(this.NUMBER_OF_ATTACHMENTS_TO_DISPLAY,0)).then((attachments)=>{this.state.attachments=attachments;});}
async uploadFiles(files){await this.uploadService.uploadFiles(files,{resModel:this.props.resModel,resId:this.props.resId},attachment=>this.onUploaded(attachment));}
async uploadUrl(url){await this.uploadService.uploadUrl(url,{resModel:this.props.resModel,resId:this.props.resId,},attachment=>this.onUploaded(attachment));}
async onUploaded(attachment){this.state.attachments=[attachment,...this.state.attachments.filter(attach=>attach.id!==attachment.id)];this.selectAttachment(attachment);if(!this.props.multiSelect){await this.props.save();}
if(this.props.onAttachmentChange){this.props.onAttachmentChange(attachment);}}
onRemoved(attachmentId){this.state.attachments=this.state.attachments.filter(attachment=>attachment.id!==attachmentId);}
selectAttachment(attachment){this.props.selectMedia({...attachment,mediaType:'attachment'});}
selectInitialMedia(){return this.props.media&&this.constructor.tagNames.includes(this.props.media.tagName)&&!this.selectedAttachmentIds.length;}
updateScroll(){const loadMoreTop=this.loadMoreButtonRef.el.getBoundingClientRect().top;const modalEl=this.props.modalRef.el.querySelector("main.modal-body");const modalBottom=modalEl.getBoundingClientRect().bottom;this.state.canScrollAttachments=loadMoreTop>=modalBottom;this.loadMoreButtonRef.el.classList.remove("o_hide_loading");}
isAttachmentHidden(attachmentEl){const attachmentBottom=Math.round(attachmentEl.getBoundingClientRect().bottom);const modalEl=this.props.modalRef.el.querySelector("main.modal-body");const modalBottom=modalEl.getBoundingClientRect().bottom;return attachmentBottom>modalBottom;}
handleScrollAttachments(){let scrollToEl=this.loadMoreButtonRef.el;const attachmentEls=[...this.existingAttachmentsRef.el.querySelectorAll(".o_existing_attachment_cell")];const firstHiddenAttachmentEl=attachmentEls.find(el=>this.isAttachmentHidden(el));if(firstHiddenAttachmentEl){const attachmentBottom=firstHiddenAttachmentEl.getBoundingClientRect().bottom;const attachmentIndex=attachmentEls.indexOf(firstHiddenAttachmentEl);const firstNextRowAttachmentEl=attachmentEls.slice(attachmentIndex).find(el=>{return el.getBoundingClientRect().bottom>attachmentBottom;})
scrollToEl=firstNextRowAttachmentEl||scrollToEl;}
scrollToEl.scrollIntoView({block:"end",inline:"nearest",behavior:"smooth"});}}
return __exports;});;

/* /web_editor/static/src/components/media_dialog/icon_selector.js */
odoo.define('@web_editor/components/media_dialog/icon_selector',['@web_editor/js/wysiwyg/fonts','@web_editor/components/media_dialog/search_media','@odoo/owl'],function(require){'use strict';let __exports={};const fonts=require('@web_editor/js/wysiwyg/fonts')[Symbol.for("default")];const{SearchMedia}=require("@web_editor/components/media_dialog/search_media");const{Component,useState}=require("@odoo/owl");const IconSelector=__exports.IconSelector=class IconSelector extends Component{static mediaSpecificClasses=["fa"];static mediaSpecificStyles=["color","background-color","border-width","border-color","border-style"];static mediaExtraClasses=["rounded-circle","rounded","img-thumbnail","shadow","border",/^text-\S+$/,/^bg-\S+$/,/^fa-\S+$/,];static tagNames=["SPAN","I"];static template="web_editor.IconSelector";static components={SearchMedia,};static props=["*"];setup(){this.state=useState({fonts:this.props.fonts,needle:'',});}
get selectedMediaIds(){return this.props.selectedMedia[this.props.id].map(({id})=>id);}
search(needle){this.state.needle=needle;if(!this.state.needle){this.state.fonts=this.props.fonts;}else{this.state.fonts=this.props.fonts.map(font=>{const icons=font.icons.filter(icon=>icon.alias.indexOf(this.state.needle)>=0);return{...font,icons};});}}
async onClickIcon(font,icon){this.props.selectMedia({...icon,fontBase:font.base,initialIconChanged:this.props.media&&!icon.names.some(name=>this.props.media.classList.contains(name)),});await this.props.save();}
static createElements(selectedMedia){return selectedMedia.map(icon=>{const iconEl=document.createElement('span');iconEl.classList.add(icon.fontBase,icon.names[0]);return iconEl;});}
static initFonts(){fonts.computeFonts();const allFonts=fonts.fontIcons.map(({cssData,base})=>{const uniqueIcons=Array.from(new Map(cssData.map(icon=>{const alias=icon.names.join(',');const id=`${base}_${alias}`;return[id,{...icon,alias,id}];})).values());return{base,icons:uniqueIcons};});return allFonts;}}
return __exports;});;

/* /web_editor/static/src/components/media_dialog/image_selector.js */
odoo.define('@web_editor/components/media_dialog/image_selector',['@web/core/l10n/translation','@web/core/network/rpc','@web_editor/js/common/utils','@web_editor/components/media_dialog/file_selector','@web/core/utils/concurrency','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const weUtils=require('@web_editor/js/common/utils')[Symbol.for("default")];const{Attachment,FileSelector,IMAGE_MIMETYPES,IMAGE_EXTENSIONS}=require("@web_editor/components/media_dialog/file_selector");const{KeepLast}=require("@web/core/utils/concurrency");const{useRef,useState,useEffect}=require("@odoo/owl");const AutoResizeImage=__exports.AutoResizeImage=class AutoResizeImage extends Attachment{static template="web_editor.AutoResizeImage";setup(){super.setup();this.image=useRef('auto-resize-image');this.container=useRef('auto-resize-image-container');this.state=useState({loaded:false,});useEffect(()=>{this.image.el.addEventListener('load',()=>this.onImageLoaded());return this.image.el.removeEventListener('load',()=>this.onImageLoaded());},()=>[]);}
async onImageLoaded(){if(!this.image.el){return;}
if(this.props.onLoaded){await this.props.onLoaded(this.image.el);if(!this.image.el){return;}}
const aspectRatio=this.image.el.offsetWidth/this.image.el.offsetHeight;const width=aspectRatio*this.props.minRowHeight;this.container.el.style.flexGrow=width;this.container.el.style.flexBasis=`${width}px`;this.state.loaded=true;}}
const newLocal="img-fluid";const ImageSelector=__exports.ImageSelector=class ImageSelector extends FileSelector{static mediaSpecificClasses=["img",newLocal,"o_we_custom_image"];static mediaSpecificStyles=[];static mediaExtraClasses=["rounded-circle","rounded","img-thumbnail","shadow","w-25","w-50","w-75","w-100",];static tagNames=["IMG"];static attachmentsListTemplate="web_editor.ImagesListTemplate";static components={...FileSelector.components,AutoResizeImage,};setup(){super.setup();this.keepLastLibraryMedia=new KeepLast();this.state.libraryMedia=[];this.state.libraryResults=null;this.state.isFetchingLibrary=false;this.state.searchService='all';this.state.showOptimized=false;this.NUMBER_OF_MEDIA_TO_DISPLAY=10;this.uploadText=_t("Upload an image");this.urlPlaceholder="https://www.odoo.com/logo.png";this.addText=_t("Add URL");this.searchPlaceholder=_t("Search an image");this.urlWarningTitle=_t("Uploaded image's format is not supported. Try with: "+IMAGE_EXTENSIONS.join(', '));this.allLoadedText=_t("All images have been loaded");this.showOptimizedOption=this.env.debug;this.MIN_ROW_HEIGHT=128;this.fileMimetypes=IMAGE_MIMETYPES.join(',');this.isImageField=!!(this.props.media&&this.props.media.closest("[data-oe-type=image]"))||!!this.env.addFieldImage;}
get canLoadMore(){if(this.state.searchService==='media-library'){return this.state.libraryResults&&this.state.libraryMedia.length<this.state.libraryResults;}
return super.canLoadMore;}
get hasContent(){if(this.state.searchService==='all'){return super.hasContent||!!this.state.libraryMedia.length;}else if(this.state.searchService==='media-library'){return!!this.state.libraryMedia.length;}
return super.hasContent;}
get isFetching(){return super.isFetching||this.state.isFetchingLibrary;}
get selectedMediaIds(){return this.props.selectedMedia[this.props.id].filter(media=>media.mediaType==='libraryMedia').map(({id})=>id);}
get allAttachments(){return[...super.allAttachments,...this.state.libraryMedia];}
get attachmentsDomain(){const domain=super.attachmentsDomain;domain.push(['mimetype','in',IMAGE_MIMETYPES]);if(!this.props.useMediaLibrary){domain.push("|",["url","=",false],"!","|",["url","=ilike","/html_editor/shape/%"],["url","=ilike","/web_editor/shape/%"],);}
domain.push('!',['name','=like','%.crop']);domain.push('|',['type','=','binary'],'!',['url','=like','/%/static/%']);if(!this.env.debug){const subDomain=[false];const originalId=this.props.media&&this.props.media.dataset.originalId;if(originalId){subDomain.push(originalId);}
domain.push(['original_id','in',subDomain]);}
return domain;}
async uploadFiles(files){await this.uploadService.uploadFiles(files,{resModel:this.props.resModel,resId:this.props.resId,isImage:true},(attachment)=>this.onUploaded(attachment));}
async uploadUrl(url){await fetch(url).then(async result=>{const blob=await result.blob();blob.id=new Date().getTime();blob.name=new URL(url,window.location.href).pathname.split("/").findLast(s=>s);await this.uploadFiles([blob]);}).catch(async()=>{await new Promise(resolve=>{const imageEl=document.createElement("img");imageEl.onerror=()=>{this.notificationService.add(_t("An error occurred while fetching the entered URL."),{title:_t("Error"),sticky:true,});resolve();};imageEl.onload=()=>{const urlPathname=new URL(url,window.location.href).pathname;const imageExtension=IMAGE_EXTENSIONS.find(format=>urlPathname.endsWith(format));if(this.isImageField&&imageExtension===".webp"){this.notificationService.add(_t("You can not replace a field by this image. If you want to use this image, first save it on your computer and then upload it here."),{title:_t("Error"),sticky:true,});return resolve();}
super.uploadUrl(url).then(resolve);};imageEl.src=url;});});}
async validateUrl(...args){const{isValidUrl,path}=super.validateUrl(...args);const isValidFileFormat=isValidUrl&&await new Promise(resolve=>{const img=new Image();img.src=path;img.onload=()=>resolve(true);img.onerror=()=>resolve(false);});return{isValidUrl,isValidFileFormat};}
isInitialMedia(attachment){if(this.props.media.dataset.originalSrc){return this.props.media.dataset.originalSrc===attachment.image_src;}
return this.props.media.getAttribute('src')===attachment.image_src;}
async fetchAttachments(limit,offset){const attachments=await super.fetchAttachments(limit,offset);if(this.isImageField){for(const attachment of attachments){if(attachment.mimetype==="image/webp"&&await weUtils.isSrcCorsProtected(attachment.image_src)){attachment.unselectable=true;}}}
const primaryColors={};for(let color=1;color<=5;color++){primaryColors[color]=weUtils.getCSSVariableValue('o-color-'+color);}
return attachments.map(attachment=>{if(attachment.image_src.startsWith('/')){const newURL=new URL(attachment.image_src,window.location.origin);if(attachment.image_src.startsWith('/html_editor/shape/')||attachment.image_src.startsWith('/web_editor/shape/')){newURL.searchParams.forEach((value,key)=>{const match=key.match(/^c([1-5])$/);if(match){newURL.searchParams.set(key,primaryColors[match[1]]);}});}else{newURL.searchParams.set('height',2*this.MIN_ROW_HEIGHT);}
attachment.thumbnail_src=newURL.pathname+newURL.search;}
if(this.selectInitialMedia()&&this.isInitialMedia(attachment)){this.selectAttachment(attachment);}
return attachment;});}
async fetchLibraryMedia(offset){if(!this.state.needle){return{media:[],results:null};}
this.state.isFetchingLibrary=true;try{const response=await rpc('/web_editor/media_library_search',{'query':this.state.needle,'offset':offset,},{silent:true,});this.state.isFetchingLibrary=false;const media=(response.media||[]).slice(0,this.NUMBER_OF_MEDIA_TO_DISPLAY);media.forEach(record=>record.mediaType='libraryMedia');return{media,results:response.results};}catch{console.error(`Couldn't reach API endpoint.`);this.state.isFetchingLibrary=false;return{media:[],results:null};}}
async loadMore(...args){await super.loadMore(...args);if(!this.props.useMediaLibrary||this.state.searchService!=='media-library'){return;}
return this.keepLastLibraryMedia.add(this.fetchLibraryMedia(this.state.libraryMedia.length)).then(({media})=>{this.state.libraryMedia.push(...media);});}
async search(...args){await super.search(...args);if(!this.props.useMediaLibrary){return;}
if(!this.state.needle){this.state.searchService='all';}
this.state.libraryMedia=[];this.state.libraryResults=0;return this.keepLastLibraryMedia.add(this.fetchLibraryMedia(0)).then(({media,results})=>{this.state.libraryMedia=media;this.state.libraryResults=results;});}
async onClickAttachment(attachment){if(attachment.unselectable){this.notificationService.add(_t("You can not replace a field by this image. If you want to use this image, first save it on your computer and then upload it here."),{title:_t("Error"),sticky:true,});return;}
this.selectAttachment(attachment);if(!this.props.multiSelect){await this.props.save();}}
async onClickMedia(media){this.props.selectMedia({...media,mediaType:'libraryMedia'});if(!this.props.multiSelect){await this.props.save();}}
static async createElements(selectedMedia,{orm}){const toSave=Object.fromEntries(selectedMedia.filter(media=>media.mediaType==='libraryMedia').map(media=>[media.id,{query:media.query||'',is_dynamic_svg:!!media.isDynamicSVG,dynamic_colors:media.dynamicColors,}]));let savedMedia=[];if(Object.keys(toSave).length!==0){savedMedia=await rpc('/web_editor/save_library_media',{media:toSave});}
const selected=selectedMedia.filter(media=>media.mediaType==='attachment').concat(savedMedia).map(attachment=>{if(attachment.image_src&&(attachment.image_src.startsWith('/html_editor/shape/')||attachment.image_src.startsWith('/web_editor/shape/'))){const colorCustomizedURL=new URL(attachment.image_src,window.location.origin);colorCustomizedURL.searchParams.forEach((value,key)=>{const match=key.match(/^c([1-5])$/);if(match){colorCustomizedURL.searchParams.set(key,weUtils.getCSSVariableValue(`o-color-${match[1]}`));}});attachment.image_src=colorCustomizedURL.pathname+colorCustomizedURL.search;}
return attachment;});return Promise.all(selected.map(async(attachment)=>{const imageEl=document.createElement('img');let src=attachment.image_src;if(!attachment.public&&!attachment.url){let accessToken=attachment.access_token;if(!accessToken){[accessToken]=await orm.call('ir.attachment','generate_access_token',[attachment.id],);}
src+=`?access_token=${encodeURIComponent(accessToken)}`;}
imageEl.src=src;imageEl.alt=attachment.description||'';return imageEl;}));}
async onImageLoaded(imgEl,attachment){this.debouncedScrollUpdate();if(attachment.mediaType==='libraryMedia'&&!imgEl.src.startsWith('blob')){await this.onLibraryImageLoaded(imgEl,attachment);}}
async onLibraryImageLoaded(imgEl,media){const mediaUrl=imgEl.src;try{const response=await fetch(mediaUrl);const contentType=response.headers.get("content-type");if(contentType&&contentType.startsWith("image/svg+xml")){let svg=await response.text();const dynamicColors={};const combinedColorsRegex=new RegExp(Object.values(weUtils.DEFAULT_PALETTE).join('|'),'gi');svg=svg.replace(combinedColorsRegex,match=>{const colorId=Object.keys(weUtils.DEFAULT_PALETTE).find(key=>weUtils.DEFAULT_PALETTE[key]===match.toUpperCase());const colorKey='c'+colorId
dynamicColors[colorKey]=weUtils.getCSSVariableValue('o-color-'+colorId);return dynamicColors[colorKey];});const fileName=mediaUrl.split('/').pop();const file=new File([svg],fileName,{type:"image/svg+xml",});imgEl.src=URL.createObjectURL(file);if(Object.keys(dynamicColors).length){media.isDynamicSVG=true;media.dynamicColors=dynamicColors;}}}catch{console.error('CORS is misconfigured on the API server, image will be treated as non-dynamic.');}}}
return __exports;});;

/* /web_editor/static/src/components/media_dialog/media_dialog.js */
odoo.define('@web_editor/components/media_dialog/media_dialog',['@web/core/l10n/translation','@web/core/utils/hooks','@web/core/utils/concurrency','@web/core/dialog/dialog','@web/core/notebook/notebook','@web_editor/components/media_dialog/image_selector','@web_editor/components/media_dialog/document_selector','@web_editor/components/media_dialog/icon_selector','@web_editor/components/media_dialog/video_selector','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService,useChildRef}=require('@web/core/utils/hooks');const{Mutex}=require("@web/core/utils/concurrency");const{Dialog}=require('@web/core/dialog/dialog');const{Notebook}=require('@web/core/notebook/notebook');const{ImageSelector}=require("@web_editor/components/media_dialog/image_selector");const{DocumentSelector}=require("@web_editor/components/media_dialog/document_selector");const{IconSelector}=require("@web_editor/components/media_dialog/icon_selector");const{VideoSelector}=require("@web_editor/components/media_dialog/video_selector");const{Component,useState,useRef,useEffect}=require("@odoo/owl");const TABS=__exports.TABS={IMAGES:{id:'IMAGES',title:_t("Images"),Component:ImageSelector,},DOCUMENTS:{id:'DOCUMENTS',title:_t("Documents"),Component:DocumentSelector,},ICONS:{id:'ICONS',title:_t("Icons"),Component:IconSelector,},VIDEOS:{id:'VIDEOS',title:_t("Videos"),Component:VideoSelector,},};const MediaDialog=__exports.MediaDialog=class MediaDialog extends Component{static template="web_editor.MediaDialog";static defaultProps={useMediaLibrary:true,};static components={...Object.keys(TABS).map((key)=>TABS[key].Component),Dialog,Notebook,};static props=["*"];setup(){this.size='xl';this.contentClass='o_select_media_dialog h-100';this.modalRef=useChildRef();this.orm=useService('orm');this.notificationService=useService('notification');this.mutex=new Mutex();this.tabs=[];this.selectedMedia=useState({});this.addButtonRef=useRef('add-button');this.initialIconClasses=[];this.addTabs();this.errorMessages={};this.state=useState({activeTab:this.initialActiveTab,});useEffect((nbSelectedAttachments)=>{this.addButtonRef.el.toggleAttribute("disabled",!nbSelectedAttachments);},()=>[this.selectedMedia[this.state.activeTab].length]);}
get initialActiveTab(){if(this.props.activeTab){return this.props.activeTab;}
if(this.props.media){const correspondingTab=Object.keys(TABS).find(id=>TABS[id].Component.tagNames.includes(this.props.media.tagName));if(correspondingTab){return correspondingTab;}}
return this.tabs[0].id;}
addTab(tab,additionalProps={}){this.selectedMedia[tab.id]=[];this.tabs.push({...tab,props:{...tab.props,...additionalProps,id:tab.id,resModel:this.props.resModel,resId:this.props.resId,media:this.props.media,multiImages:this.props.multiImages,selectedMedia:this.selectedMedia,selectMedia:(...args)=>this.selectMedia(...args,tab.id,additionalProps.multiSelect),save:this.save.bind(this),onAttachmentChange:this.props.onAttachmentChange,errorMessages:(errorMessage)=>this.errorMessages[tab.id]=errorMessage,modalRef:this.modalRef,},});}
addTabs(){const onlyImages=this.props.onlyImages||this.props.multiImages||(this.props.media&&this.props.media.parentElement&&(this.props.media.parentElement.dataset.oeField==='image'||this.props.media.parentElement.dataset.oeType==='image'));const noDocuments=onlyImages||this.props.noDocuments;const noIcons=onlyImages||this.props.noIcons;const noVideos=onlyImages||this.props.noVideos;if(!this.props.noImages){this.addTab(TABS.IMAGES,{useMediaLibrary:this.props.useMediaLibrary,multiSelect:this.props.multiImages,});}
if(!noDocuments){this.addTab(TABS.DOCUMENTS);}
if(!noIcons){const fonts=TABS.ICONS.Component.initFonts();this.addTab(TABS.ICONS,{fonts,});if(this.props.media&&TABS.ICONS.Component.tagNames.includes(this.props.media.tagName)){const classes=this.props.media.className.split(/\s+/);const mediaFont=fonts.find(font=>classes.includes(font.base));if(mediaFont){const selectedIcon=mediaFont.icons.find(icon=>icon.names.some(name=>classes.includes(name)));if(selectedIcon){this.initialIconClasses.push(...selectedIcon.names);this.selectMedia(selectedIcon,TABS.ICONS.id);}}}}
if(!noVideos){this.addTab(TABS.VIDEOS,{vimeoPreviewIds:this.props.vimeoPreviewIds,isForBgVideo:this.props.isForBgVideo,});}}
async renderMedia(selectedMedia){const elements=await this.mutex.exec(async()=>await TABS[this.state.activeTab].Component.createElements(selectedMedia,{orm:this.orm}));elements.forEach(element=>{if(this.props.media){element.classList.add(...this.props.media.classList);const style=this.props.media.getAttribute('style');if(style){element.setAttribute('style',style);}
if(this.state.activeTab===TABS.IMAGES.id){if(this.props.media.dataset.shape){element.dataset.shape=this.props.media.dataset.shape;}
if(this.props.media.dataset.shapeColors){element.dataset.shapeColors=this.props.media.dataset.shapeColors;}
if(this.props.media.dataset.shapeFlip){element.dataset.shapeFlip=this.props.media.dataset.shapeFlip;}
if(this.props.media.dataset.shapeRotate){element.dataset.shapeRotate=this.props.media.dataset.shapeRotate;}
if(this.props.media.dataset.hoverEffect){element.dataset.hoverEffect=this.props.media.dataset.hoverEffect;}
if(this.props.media.dataset.hoverEffectColor){element.dataset.hoverEffectColor=this.props.media.dataset.hoverEffectColor;}
if(this.props.media.dataset.hoverEffectStrokeWidth){element.dataset.hoverEffectStrokeWidth=this.props.media.dataset.hoverEffectStrokeWidth;}
if(this.props.media.dataset.hoverEffectIntensity){element.dataset.hoverEffectIntensity=this.props.media.dataset.hoverEffectIntensity;}
if(this.props.media.dataset.shapeAnimationSpeed){element.dataset.shapeAnimationSpeed=this.props.media.dataset.shapeAnimationSpeed;}}else if([TABS.VIDEOS.id,TABS.DOCUMENTS.id].includes(this.state.activeTab)){const parentEl=this.props.media.parentElement;if(parentEl&&parentEl.tagName==="A"&&parentEl.children.length===1&&this.props.media.tagName==="IMG"){parentEl.replaceWith(parentEl.firstElementChild);}}}
for(const otherTab of Object.keys(TABS).filter(key=>key!==this.state.activeTab)){for(const property of TABS[otherTab].Component.mediaSpecificStyles){element.style.removeProperty(property);}
element.classList.remove(...TABS[otherTab].Component.mediaSpecificClasses);const extraClassesToRemove=[];for(const name of TABS[otherTab].Component.mediaExtraClasses){if(typeof(name)==='string'){extraClassesToRemove.push(name);}else{for(const className of element.classList){if(className.match(name)){extraClassesToRemove.push(className);}}}}
element.classList.remove(...extraClassesToRemove.filter(candidateName=>{for(const name of TABS[this.state.activeTab].Component.mediaExtraClasses){if(typeof(name)==='string'){if(candidateName===name){return false;}}else{for(const className of element.classList){if(className.match(candidateName)){return false;}}}}
return true;}));}
element.classList.remove(...this.initialIconClasses);element.classList.remove('o_modified_image_to_save');element.classList.remove('oe_edited_link');element.classList.add(...TABS[this.state.activeTab].Component.mediaSpecificClasses);});return elements;}
selectMedia(media,tabId,multiSelect){if(multiSelect){const isMediaSelected=this.selectedMedia[tabId].map(({id})=>id).includes(media.id);if(!isMediaSelected){this.selectedMedia[tabId].push(media);}else{this.selectedMedia[tabId]=this.selectedMedia[tabId].filter(m=>m.id!==media.id);}}else{this.selectedMedia[tabId]=[media];}}
async save(){if(this.errorMessages[this.state.activeTab]){this.notificationService.add(this.errorMessages[this.state.activeTab],{type:'danger',});return;}
const selectedMedia=this.selectedMedia[this.state.activeTab];const saveSelectedMedia=selectedMedia.length&&(this.state.activeTab!==TABS.ICONS.id||selectedMedia[0].initialIconChanged||!this.props.media);if(saveSelectedMedia){const elements=await this.renderMedia(selectedMedia);if(this.props.multiImages){await this.props.save(elements);}else{await this.props.save(elements[0]);}}
this.props.close();}
onTabChange(tab){this.state.activeTab=tab;}}
return __exports;});;

/* /web_editor/static/src/components/media_dialog/search_media.js */
odoo.define('@web_editor/components/media_dialog/search_media',['@web/core/utils/timing','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useDebounced}=require('@web/core/utils/timing');const{useAutofocus}=require('@web/core/utils/hooks');const{Component,xml,useEffect,useState}=require("@odoo/owl");const SearchMedia=__exports.SearchMedia=class SearchMedia extends Component{static template=xml`
        <div class="position-relative mw-lg-25 flex-grow-1 me-auto">
            <input type="text" class="o_we_search o_input form-control" t-att-placeholder="props.searchPlaceholder.trim()" t-model="state.input" t-ref="autofocus"/>
            <i class="oi oi-search input-group-text position-absolute end-0 top-50 me-n3 px-2 py-1 translate-middle bg-transparent border-0" title="Search" role="img" aria-label="Search"/>
        </div>`;static props=["searchPlaceholder","search","needle"];setup(){useAutofocus();this.debouncedSearch=useDebounced(this.props.search,1000);this.state=useState({input:this.props.needle||'',});useEffect((input)=>{if(this.hasRendered){this.debouncedSearch(input);}else{this.hasRendered=true;}},()=>[this.state.input]);}}
return __exports;});;

/* /web_editor/static/src/components/media_dialog/video_selector.js */
odoo.define('@web_editor/components/media_dialog/video_selector',['@web/core/l10n/translation','@web/core/network/rpc','@web/core/utils/hooks','@web/core/utils/timing','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{useAutofocus,useService}=require('@web/core/utils/hooks');const{debounce}=require('@web/core/utils/timing');const{Component,useState,useRef,onMounted,onWillStart}=require("@odoo/owl");class VideoOption extends Component{static template="web_editor.VideoOption";static props={description:{type:String,optional:true},label:{type:String,optional:true},onChangeOption:Function,value:{type:Boolean,optional:true},};}
class VideoIframe extends Component{static template="web_editor.VideoIframe";static props={src:{type:String},};}
const VideoSelector=__exports.VideoSelector=class VideoSelector extends Component{static mediaSpecificClasses=["media_iframe_video"];static mediaSpecificStyles=[];static mediaExtraClasses=[];static tagNames=["IFRAME","DIV"];static template="web_editor.VideoSelector";static components={VideoIframe,VideoOption,};static props={selectMedia:Function,errorMessages:Function,vimeoPreviewIds:{type:Array,optional:true},isForBgVideo:{type:Boolean,optional:true},media:{type:Object,optional:true},"*":true,};static defaultProps={vimeoPreviewIds:[],isForBgVideo:false,};setup(){this.http=useService('http');this.PLATFORMS={youtube:'youtube',dailymotion:'dailymotion',vimeo:'vimeo',youku:'youku',};this.OPTIONS={autoplay:{label:_t("Autoplay"),description:_t("Videos are muted when autoplay is enabled"),platforms:[this.PLATFORMS.youtube,this.PLATFORMS.dailymotion,this.PLATFORMS.vimeo],urlParameter:'autoplay=1',},loop:{label:_t("Loop"),platforms:[this.PLATFORMS.youtube,this.PLATFORMS.vimeo],urlParameter:'loop=1',},hide_controls:{label:_t("Hide player controls"),platforms:[this.PLATFORMS.youtube,this.PLATFORMS.dailymotion,this.PLATFORMS.vimeo],urlParameter:'controls=0',},hide_fullscreen:{label:_t("Hide fullscreen button"),platforms:[this.PLATFORMS.youtube],urlParameter:'fs=0',isHidden:()=>this.state.options.filter(option=>option.id==='hide_controls')[0].value,},hide_dm_logo:{label:_t("Hide Dailymotion logo"),platforms:[this.PLATFORMS.dailymotion],urlParameter:'ui-logo=0',},hide_dm_share:{label:_t("Hide sharing button"),platforms:[this.PLATFORMS.dailymotion],urlParameter:'sharing-enable=0',},};this.state=useState({options:[],src:'',urlInput:'',platform:null,vimeoPreviews:[],errorMessage:'',});this.urlInputRef=useRef('url-input');onWillStart(async()=>{if(this.props.media){const src=this.props.media.dataset.oeExpression||this.props.media.dataset.src||(this.props.media.tagName==='IFRAME'&&this.props.media.getAttribute('src'))||'';if(src){this.state.urlInput=src;await this.updateVideo();this.state.options=this.state.options.map((option)=>{const{urlParameter}=this.OPTIONS[option.id];return{...option,value:src.indexOf(urlParameter)>=0};});}}});onMounted(async()=>this.prepareVimeoPreviews());useAutofocus();this.onChangeUrl=debounce((ev)=>this.updateVideo(ev.target.value),500);}
get shownOptions(){if(this.props.isForBgVideo){return[];}
return this.state.options.filter(option=>!this.OPTIONS[option.id].isHidden||!this.OPTIONS[option.id].isHidden());}
async onChangeOption(optionId){this.state.options=this.state.options.map(option=>{if(option.id===optionId){return{...option,value:!option.value};}
return option;});await this.updateVideo();}
async onClickSuggestion(src){this.state.urlInput=src;await this.updateVideo();}
async updateVideo(){if(!this.state.urlInput){this.state.src='';this.state.urlInput='';this.state.options=[];this.state.platform=null;this.state.errorMessage='';this.props.selectMedia({});return;}
const embedMatch=this.state.urlInput.match(/(src|href)=["']?([^"']+)?/);if(embedMatch&&embedMatch[2].length>0&&embedMatch[2].indexOf('instagram')){embedMatch[1]=embedMatch[2];}
const url=embedMatch?embedMatch[1]:this.state.urlInput;const options={};if(this.props.isForBgVideo){Object.keys(this.OPTIONS).forEach(key=>{options[key]=true;});}else{for(const option of this.shownOptions){options[option.id]=option.value;}}
const{embed_url:src,video_id:videoId,params,platform}=await this._getVideoURLData(url,options);if(!src){this.state.errorMessage=_t("The provided url is not valid");}else if(!platform){this.state.errorMessage=_t("The provided url does not reference any supported video");}else{this.state.errorMessage='';}
this.props.errorMessages(this.state.errorMessage);const newOptions=[];if(platform&&platform!==this.state.platform){Object.keys(this.OPTIONS).forEach(key=>{if(this.OPTIONS[key].platforms.includes(platform)){const{label,description}=this.OPTIONS[key];newOptions.push({id:key,label,description});}});}
this.state.src=src;this.props.selectMedia({id:src,src,platform,videoId,params});if(platform!==this.state.platform){this.state.platform=platform;this.state.options=newOptions;}}
async _getVideoURLData(url,options){return await rpc('/web_editor/video_url/data',{video_url:url,...options,});}
static createElements(selectedMedia){return selectedMedia.map(video=>{const div=document.createElement('div');div.dataset.oeExpression=video.src;div.innerHTML=`
                <div class="css_editable_mode_display"></div>
                <div class="media_iframe_video_size" contenteditable="false"></div>
                <iframe loading="lazy" frameborder="0" contenteditable="false" allowfullscreen="allowfullscreen"></iframe>
            `;div.querySelector('iframe').src=video.src;return div;});}
async prepareVimeoPreviews(){return Promise.all(this.props.vimeoPreviewIds.map(async(videoId)=>{const{thumbnail_url:thumbnailSrc}=await this.http.get(`https://vimeo.com/api/oembed.json?url=http%3A//vimeo.com/${encodeURIComponent(videoId)}`);this.state.vimeoPreviews.push({id:videoId,thumbnailSrc,src:`https://player.vimeo.com/video/${encodeURIComponent(videoId)}`});}));}}
return __exports;});;

/* /web_editor/static/src/components/upload_progress_toast/upload_progress_toast.js */
odoo.define('@web_editor/components/upload_progress_toast/upload_progress_toast',['@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require('@web/core/utils/hooks');const{Component,useState}=require("@odoo/owl");const ProgressBar=__exports.ProgressBar=class ProgressBar extends Component{static template="web_editor.ProgressBar";static props={progress:{type:Number,optional:true},hasError:{type:Boolean,optional:true},uploaded:{type:Boolean,optional:true},name:String,size:{type:String,optional:true},errorMessage:{type:String,optional:true},};static defaultProps={progress:0,hasError:false,uploaded:false,size:"",errorMessage:"",};get progress(){return Math.round(this.props.progress);}}
const UploadProgressToast=__exports.UploadProgressToast=class UploadProgressToast extends Component{static template="web_editor.UploadProgressToast";static components={ProgressBar,};static props={close:Function,};setup(){this.uploadService=useService('upload');this.state=useState(this.uploadService.progressToast);}}
return __exports;});;

/* /web_editor/static/src/components/upload_progress_toast/upload_service.js */
odoo.define('@web_editor/components/upload_progress_toast/upload_service',['@web/core/network/rpc','@web/core/registry','@web_editor/components/upload_progress_toast/upload_progress_toast','@web/core/l10n/translation','@web/core/utils/files','@web/core/utils/numbers','@web/core/utils/urls','@web/core/utils/strings','@odoo/owl'],function(require){'use strict';let __exports={};const{rpc}=require('@web/core/network/rpc');const{registry}=require('@web/core/registry');const{UploadProgressToast}=require("@web_editor/components/upload_progress_toast/upload_progress_toast");const{_t}=require("@web/core/l10n/translation");const{checkFileSize}=require("@web/core/utils/files");const{humanNumber}=require("@web/core/utils/numbers");const{getDataURLFromFile}=require("@web/core/utils/urls");const{sprintf}=require("@web/core/utils/strings");const{reactive}=require("@odoo/owl");const AUTOCLOSE_DELAY=__exports.AUTOCLOSE_DELAY=3000;const AUTOCLOSE_DELAY_LONG=__exports.AUTOCLOSE_DELAY_LONG=8000;const uploadService=__exports.uploadService={dependencies:['notification'],start(env,{notification}){let fileId=0;const progressToast=reactive({files:{},isVisible:false,});registry.category('main_components').add('UploadProgressToast',{Component:UploadProgressToast,props:{close:()=>progressToast.isVisible=false,}});const addFile=(file)=>{progressToast.files[file.id]=file;progressToast.isVisible=true;return progressToast.files[file.id];};const deleteFile=(fileId)=>{delete progressToast.files[fileId];if(!Object.keys(progressToast.files).length){progressToast.isVisible=false;}};return{get progressToast(){return progressToast;},get fileId(){return fileId;},addFile,deleteFile,incrementId(){fileId++;},uploadUrl:async(url,{resModel,resId},onUploaded)=>{const attachment=await rpc('/web_editor/attachment/add_url',{url,'res_model':resModel,'res_id':resId,});await onUploaded(attachment);},uploadFiles:async(files,{resModel,resId,isImage},onUploaded)=>{const sortedFiles=Array.from(files).sort((a,b)=>a.size-b.size);for(const file of sortedFiles){let fileSize=file.size;if(!checkFileSize(fileSize,notification)){return null;}
if(!fileSize){fileSize="";}else{fileSize=humanNumber(fileSize)+"B";}
const id=++fileId;file.progressToastId=id;addFile({id,name:file.name,size:fileSize,});}
for(const sortedFile of sortedFiles){const file=progressToast.files[sortedFile.progressToastId];let dataURL;try{dataURL=await getDataURLFromFile(sortedFile);}catch{deleteFile(file.id);env.services.notification.add(sprintf(_t('Could not load the file "%s".'),sortedFile.name),{type:'danger'});continue}
try{const xhr=new XMLHttpRequest();xhr.upload.addEventListener('progress',ev=>{const rpcComplete=ev.loaded/ev.total*100;file.progress=rpcComplete;});xhr.upload.addEventListener('load',function(){file.progress=100;});const attachment=await rpc('/web_editor/attachment/add_data',{'name':file.name,'data':dataURL.split(',')[1],'res_id':resId,'res_model':resModel,'is_image':!!isImage,'width':0,'quality':0,},{xhr});if(attachment.error){file.hasError=true;file.errorMessage=attachment.error;}else{if(attachment.mimetype==='image/webp'){const image=document.createElement('img');image.src=`data:image/webp;base64,${dataURL.split(',')[1]}`;await new Promise(resolve=>image.addEventListener('load',resolve));const canvas=document.createElement('canvas');canvas.width=image.width;canvas.height=image.height;const ctx=canvas.getContext('2d');ctx.fillStyle='rgb(255, 255, 255)';ctx.fillRect(0,0,canvas.width,canvas.height);ctx.drawImage(image,0,0);const altDataURL=canvas.toDataURL('image/jpeg',0.75);await rpc('/web_editor/attachment/add_data',{'name':file.name.replace(/\.webp$/,'.jpg'),'data':altDataURL.split(',')[1],'res_id':attachment.id,'res_model':'ir.attachment','is_image':true,'width':0,'quality':0,},{xhr});}
file.uploaded=true;await onUploaded(attachment);}
let message_autoclose_delay=file.hasError?AUTOCLOSE_DELAY_LONG:AUTOCLOSE_DELAY;setTimeout(()=>deleteFile(file.id),message_autoclose_delay);}catch(error){file.hasError=true;setTimeout(()=>deleteFile(file.id),AUTOCLOSE_DELAY_LONG);throw error;}}}};},};return __exports;});;

/* /website/static/src/components/media_dialog/file_documents_selector.js */
odoo.define('@website/components/media_dialog/file_documents_selector',['@web/core/utils/patch','@html_editor/main/media/media_dialog/file_documents_selector'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{FileDocumentsSelector}=require("@html_editor/main/media/media_dialog/file_documents_selector");patch(FileDocumentsSelector.prototype,{get attachmentsDomain(){const domain=super.attachmentsDomain;domain.push("|",["url","=",false],"!",["url","=like","/web/image/website.%"]);domain.push(["key","=",false]);return domain;},});return __exports;});;

/* /website/static/src/components/media_dialog/image_selector.js */
odoo.define('@website/components/media_dialog/image_selector',['@web/core/utils/patch','@web_editor/components/media_dialog/image_selector','@html_editor/main/media/media_dialog/image_selector'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{ImageSelector}=require('@web_editor/components/media_dialog/image_selector');const{ImageSelector:HtmlImageSelector}=require("@html_editor/main/media/media_dialog/image_selector");patch(ImageSelector.prototype,{get attachmentsDomain(){const domain=super.attachmentsDomain;domain.push('|',['url','=',false],'!',['url','=like','/web/image/website.%']);domain.push(['key','=',false]);return domain;}});patch(HtmlImageSelector.prototype,{get attachmentsDomain(){const domain=super.attachmentsDomain;domain.push('|',['url','=',false],'!',['url','=like','/web/image/website.%']);domain.push(['key','=',false]);return domain;}});return __exports;});;

/* /web_unsplash/static/src/media_dialog_legacy/image_selector.js */
odoo.define('@web_unsplash/media_dialog_legacy/image_selector',['@web/core/l10n/translation','@web/core/utils/patch','@web/core/utils/concurrency','@web_editor/components/media_dialog/media_dialog','@web_editor/components/media_dialog/image_selector','@web/core/network/rpc','@web/core/utils/hooks','@web_unsplash/unsplash_error/unsplash_error'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{KeepLast}=require("@web/core/utils/concurrency");const{MediaDialog,TABS}=require("@web_editor/components/media_dialog/media_dialog");const{ImageSelector}=require("@web_editor/components/media_dialog/image_selector");const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{UnsplashError}=require("@web_unsplash/unsplash_error/unsplash_error");patch(ImageSelector.prototype,{setup(){super.setup();this.unsplash=useService('unsplash');this.keepLastUnsplash=new KeepLast();this.state.unsplashRecords=[];this.state.isFetchingUnsplash=false;this.state.isMaxed=false;this.state.unsplashError=null;this.state.useUnsplash=true;this.NUMBER_OF_RECORDS_TO_DISPLAY=30;this.errorMessages={'key_not_found':{title:_t("Setup Unsplash to access royalty free photos."),subtitle:"",},401:{title:_t("Unauthorized Key"),subtitle:_t("Please check your Unsplash access key and application ID."),},403:{title:_t("Search is temporarily unavailable"),subtitle:_t("The max number of searches is exceeded. Please retry in an hour or extend to a better account."),},};},get canLoadMore(){if(this.state.searchService==='all'){return super.canLoadMore||this.state.needle&&!this.state.isMaxed&&!this.state.unsplashError;}else if(this.state.searchService==='unsplash'){return this.state.needle&&!this.state.isMaxed&&!this.state.unsplashError;}
return super.canLoadMore;},get hasContent(){if(this.state.searchService==='all'){return super.hasContent||!!this.state.unsplashRecords.length;}else if(this.state.searchService==='unsplash'){return!!this.state.unsplashRecords.length;}
return super.hasContent;},get errorTitle(){if(this.errorMessages[this.state.unsplashError]){return this.errorMessages[this.state.unsplashError].title;}
return _t("Something went wrong");},get errorSubtitle(){if(this.errorMessages[this.state.unsplashError]){return this.errorMessages[this.state.unsplashError].subtitle;}
return _t("Please check your internet connection or contact administrator.");},get selectedRecordIds(){return this.props.selectedMedia[this.props.id].filter(media=>media.mediaType==='unsplashRecord').map(({id})=>id);},get isFetching(){return super.isFetching||this.state.isFetchingUnsplash;},get combinedRecords(){function alternate(a,b){return[a.map((v,i)=>i<b.length?[v,b[i]]:v),b.slice(a.length),].flat(2);}
return alternate(this.state.unsplashRecords,this.state.libraryMedia);},get allAttachments(){return[...super.allAttachments,...this.state.unsplashRecords];},set canLoadMore(_){},set hasContent(_){},set isFetching(_){},set selectedMediaIds(_){},set attachmentsDomain(_){},set errorTitle(_){},set errorSubtitle(_){},set selectedRecordIds(_){},async fetchUnsplashRecords(offset){if(!this.state.needle){return{records:[],isMaxed:false};}
this.state.isFetchingUnsplash=true;try{const{isMaxed,images}=await this.unsplash.getImages(this.state.needle,offset,this.NUMBER_OF_RECORDS_TO_DISPLAY,this.props.orientation);this.state.isFetchingUnsplash=false;this.state.unsplashError=false;const existingIds=this.state.unsplashRecords.map(existing=>existing.id);const newImages=images.filter(record=>!existingIds.includes(record.id));const records=newImages.map(record=>{const url=new URL(record.urls.regular);url.searchParams.set('h',2*this.MIN_ROW_HEIGHT);url.searchParams.delete('w');return Object.assign({},record,{url:url.toString(),mediaType:'unsplashRecord',});});return{isMaxed,records};}catch(e){this.state.isFetchingUnsplash=false;if(e==='no_access'){this.state.useUnsplash=false;}else{this.state.unsplashError=e;}
return{records:[],isMaxed:true};}},async loadMore(...args){await super.loadMore(...args);return this.keepLastUnsplash.add(this.fetchUnsplashRecords(this.state.unsplashRecords.length)).then(({records,isMaxed})=>{this.state.unsplashRecords.push(...records);this.state.isMaxed=isMaxed;});},async search(...args){await super.search(...args);await this.searchUnsplash();},async searchUnsplash(){if(!this.state.needle){this.state.unsplashError=false;this.state.unsplashRecords=[];this.state.isMaxed=false;}
return this.keepLastUnsplash.add(this.fetchUnsplashRecords(0)).then(({records,isMaxed})=>{this.state.unsplashRecords=records;this.state.isMaxed=isMaxed;});},async onClickRecord(media){this.props.selectMedia({...media,mediaType:'unsplashRecord',query:this.state.needle});if(!this.props.multiSelect){await this.props.save();}},async submitCredentials(key,appId){this.state.unsplashError=null;await rpc('/web_unsplash/save_unsplash',{key,appId});await this.searchUnsplash();},});ImageSelector.components={...ImageSelector.components,UnsplashError,};patch(MediaDialog.prototype,{setup(){super.setup();this.unsplashService=useService('unsplash');},async save(){const selectedImages=this.selectedMedia[TABS.IMAGES.id];if(selectedImages){const unsplashRecords=selectedImages.filter(media=>media.mediaType==='unsplashRecord');if(unsplashRecords.length){await this.unsplashService.uploadUnsplashRecords(unsplashRecords,{resModel:this.props.resModel,resId:this.props.resId},(attachments)=>{this.selectedMedia[TABS.IMAGES.id]=this.selectedMedia[TABS.IMAGES.id].filter(media=>media.mediaType!=='unsplashRecord');this.selectedMedia[TABS.IMAGES.id]=this.selectedMedia[TABS.IMAGES.id].concat(attachments.map(attachment=>({...attachment,mediaType:'attachment'})));});}}
return super.save(...arguments);},});return __exports;});;

/* /web_editor/static/src/js/backend/QWebPlugin.js */
odoo.define('@web_editor/js/backend/QWebPlugin',['@web_editor/js/common/wysiwyg_utils','@web_editor/js/editor/odoo-editor/src/utils/utils'],function(require){'use strict';let __exports={};const{ancestors}=require('@web_editor/js/common/wysiwyg_utils');const{closestElement}=require("@web_editor/js/editor/odoo-editor/src/utils/utils");const QWebPlugin=__exports.QWebPlugin=class QWebPlugin{constructor(options={}){this._options=options;if(this._options.editor){this._editable=this._options.editor.editable;this._document=this._options.editor.document;this._selectQwebNode(this._options.editor);}else{this._editable=this._options.editable;this._document=this._options.document||window.document;}
this._getContextFromParentRect=this._options.editor?.options?.getContextFromParentRect||(()=>({top:0,left:0}));this._editable=this._options.editable||(this._options.editor&&this._options.editor.editable);this._document=this._options.document||(this._options.editor&&this._options.editor.document)||window.document;this._tGroupCount=0;this._hideBranchingSelection=this._hideBranchingSelection.bind(this);this._makeBranchingSelection();this._clickListeners=[];}
destroy(){this._selectElWrapper.remove();for(const listener of this._clickListeners){document.removeEventListener('click',listener);}}
cleanForSave(editable){for(const node of editable.querySelectorAll('[data-oe-t-group], [data-oe-t-inline], [data-oe-t-selectable], [data-oe-t-group-active]')){node.removeAttribute('data-oe-t-group-active');node.removeAttribute('data-oe-t-group');node.removeAttribute('data-oe-t-inline');node.removeAttribute('data-oe-t-selectable');}}
sanitizeElement(subRoot){if(subRoot.nodeType!==Node.ELEMENT_NODE){return;}
if(this._options.editor){this._options.editor.observerUnactive('qweb-plugin-sanitize');}
this._fixInlines(subRoot);const demoElements=subRoot.querySelectorAll('[t-esc], [t-raw], [t-out], [t-field]');for(const element of demoElements){element.setAttribute('contenteditable','false');}
this._groupQwebBranching(subRoot);if(this._options.editor){this._options.editor.observerActive('qweb-plugin-sanitize');}}
_groupQwebBranching(subRoot){const tNodes=subRoot.querySelectorAll('[t-if], [t-elif], [t-else]');const groupsEncounter=new Set();for(const node of tNodes){const parentTNode=[...node.parentElement.children];const index=parentTNode.indexOf(node);const prevNode=parentTNode[index-1];let groupId;if(prevNode&&node.previousElementSibling===prevNode&&!node.hasAttribute('t-if')){prevNode.setAttribute('data-oe-t-selectable','true');groupId=parseInt(prevNode.getAttribute('data-oe-t-group'));node.setAttribute('data-oe-t-selectable','true');}else{groupId=this._tGroupCount++;}
groupsEncounter.add(groupId);node.setAttribute('data-oe-t-group',groupId);const clickListener=e=>{e.stopImmediatePropagation();this._showBranchingSelection(node);};this._clickListeners.push(clickListener);node.addEventListener('click',clickListener);}
for(const groupId of groupsEncounter){const isOneElementActive=subRoot.querySelector(`[data-oe-t-group='${groupId}'][data-oe-t-group-active]`,);if(!isOneElementActive){subRoot.querySelector(`[data-oe-t-group='${groupId}']`).setAttribute('data-oe-t-group-active','true');}}}
_fixInlines(subRoot){const checkAllInline=el=>{return[...el.children].every(child=>{if(child.tagName==='T'){return checkAllInline(child);}else{return(child.nodeType!==Node.ELEMENT_NODE||window.getComputedStyle(child).display==='inline');}});};const tElements=subRoot.querySelectorAll('t');setTimeout(()=>{if(this._options.editor){this._options.editor.observerUnactive('qweb-plugin-checkAllInline');}
for(const tElement of tElements){if(checkAllInline(tElement)){tElement.setAttribute('data-oe-t-inline','true');}}
if(this._options.editor){this._options.editor.observerActive('qweb-plugin-checkAllInline');}});}
_selectQwebNode(editor){editor.addDomListener(editor.document,'selectionchange',e=>{const selection=editor.document.getSelection();const qwebNode=selection.anchorNode&&closestElement(selection.anchorNode,'[t-field],[t-esc],[t-out]');if(qwebNode){const range=new Range();range.selectNode(qwebNode);selection.removeAllRanges();selection.addRange(range);}});}
_makeBranchingSelection(){const document=this._options.document||window.document;this._selectElWrapper=document.createElement('div');this._selectElWrapper.classList.add('oe-qweb-select');this._selectElWrapper.innerHTML='';document.body.append(this._selectElWrapper);this._hideBranchingSelection();}
_showBranchingSelection(target){this._hideBranchingSelection();const branchingHierarchyElements=[target,...ancestors(target,this._editable)].filter(element=>element.getAttribute('data-oe-t-group-active')==='true').filter(element=>{const itemGroupId=element.getAttribute('data-oe-t-group');const groupItemsNodes=element.parentElement.querySelectorAll(`[data-oe-t-group='${itemGroupId}']`,);return groupItemsNodes.length>1;});if(!branchingHierarchyElements.length)return;const groupsActive=branchingHierarchyElements.map(node=>node.getAttribute('data-oe-t-group'),);for(const branchingElement of branchingHierarchyElements){this._selectElWrapper.prepend(this._renderBranchingSelection(branchingElement));}
const closeSelectHandler=event=>{const path=[event.target,...ancestors(event.target)];const shouldClose=!path.find(element=>element===this._selectElWrapper||groupsActive.includes(element.getAttribute('data-oe-t-group')),);if(shouldClose){this._hideBranchingSelection();document.removeEventListener('mousedown',closeSelectHandler);}};document.addEventListener('mousedown',closeSelectHandler);this._selectElWrapper.style.display='flex';this._updateBranchingSelectionPosition(branchingHierarchyElements[branchingHierarchyElements.length-1],);}
_updateBranchingSelectionPosition(target){const box=target.getBoundingClientRect();const selBox=this._selectElWrapper.getBoundingClientRect();const parentBox=this._getContextFromParentRect();const left=parentBox.left+window.scrollX+box.left;const top=parentBox.top+window.scrollY+box.top-selBox.height;this._selectElWrapper.style.left=`${left}px`;this._selectElWrapper.style.top=`${top}px`;}
_renderBranchingSelection(target){this._document.addEventListener('scroll',this._hideBranchingSelection);const selectEl=document.createElement('select');const groupId=parseInt(target.getAttribute('data-oe-t-group'));const groupElements=target.parentElement.querySelectorAll(`[data-oe-t-group='${groupId}']`,);for(const element of groupElements){const optionElement=document.createElement('option');if(element.hasAttribute('t-if')){optionElement.innerText=`if: "${element.getAttribute("t-if")}"`;}else if(element.hasAttribute('t-elif')){optionElement.innerText=`elif: "${element.getAttribute("t-elif")}"`;}else if(element.hasAttribute('t-else')){optionElement.innerText='else';}
if(element.hasAttribute('data-oe-t-group-active')){optionElement.selected=true;}
selectEl.appendChild(optionElement);}
selectEl.onchange=()=>{let activeElement;for(let i=0;i<groupElements.length;i++){if(i===selectEl.selectedIndex){activeElement=groupElements[i];groupElements[i].setAttribute('data-oe-t-group-active','true');}else{groupElements[i].removeAttribute('data-oe-t-group-active');}}
this._showBranchingSelection(activeElement);};return selectEl;}
_hideBranchingSelection(){this._selectElWrapper.style.display='none';this._selectElWrapper.innerHTML=``;this._document.removeEventListener('scroll',this._hideBranchingSelection);}}
return __exports;});;

/* /web_editor/static/src/js/backend/convert_inline.js */
odoo.define('@web_editor/js/backend/convert_inline',['@web_editor/js/editor/odoo-editor/src/utils/utils'],function(require){'use strict';let __exports={};const{getAdjacentPreviousSiblings,isBlock,rgbToHex,commonParentGet}=require("@web_editor/js/editor/odoo-editor/src/utils/utils");const RE_COL_MATCH=/(^| )col(-[\w\d]+)*( |$)/;const RE_COMMAS_OUTSIDE_PARENTHESES=/,(?![^(]*?\))/g;const RE_OFFSET_MATCH=/(^| )offset(-[\w\d]+)*( |$)/;const RE_PADDING_MATCH=/[ ]*padding[^;]*;/g;const RE_PADDING=/([\d.]+)/;const RE_WHITESPACE=/[\s\u200b]*/;const SELECTORS_IGNORE=/(^\*$|:hover|:before|:after|:active|:link|::|'|\([^(),]+[,(])|@page/;const FONT_PROPERTIES_TO_INHERIT=['color','font-size','font-family','font-weight','font-style','text-decoration','text-transform','text-align',];const TABLE_ATTRIBUTES=__exports.TABLE_ATTRIBUTES={cellspacing:0,cellpadding:0,border:0,width:'100%',align:'center',role:'presentation',};const TABLE_STYLES=__exports.TABLE_STYLES={'border-collapse':'collapse','text-align':'inherit','font-size':'unset','line-height':'inherit',};const GROUPED_STYLES={border:["border-top-width","border-right-width","border-bottom-width","border-left-width","border-top-style","border-right-style","border-bottom-style","border-left-style",],padding:["padding-top","padding-bottom","padding-left","padding-right"],margin:["margin-top","margin-bottom","margin-left","margin-right"],"border-radius":["border-top-left-radius","border-top-right-radius","border-bottom-right-radius","border-bottom-left-radius",],};function addTables($editable){const editable=$editable.get(0);for(const snippet of editable.querySelectorAll('.o_mail_snippet_general, .o_layout')){const table=_createTable(snippet.attributes);const row=document.createElement('tr');let col=document.createElement('td');row.appendChild(col);if(snippet.classList.contains('o_basic_theme')){const div=document.createElement('div');div.classList.add('o_apple_wrapper_padding');col.appendChild(div);col=div;const style=document.createElement('style');const padding='34px';style.textContent=`@media{@media{.o_basic_theme div.o_apple_wrapper_padding{padding:${snippet.style.padding};}}}`+`@media(min-width:961px){@media{@media{.o_basic_theme div.o_apple_wrapper_padding{padding-left:${padding};}}}}`;div.before(style);}
table.appendChild(row);for(const child of[...snippet.childNodes]){col.appendChild(child);}
snippet.before(table);snippet.remove();const childTables=[...col.children].filter(child=>child.nodeName==='TABLE');if(!childTables.length){const tableB=_createTable();const rowB=document.createElement('tr');const colB=document.createElement('td');rowB.appendChild(colB);tableB.appendChild(rowB);for(const child of[...col.childNodes]){colB.appendChild(child);}
col.appendChild(tableB);}}}
function attachmentThumbnailToLinkImg($editable){const editable=$editable.get(0);const links=[...editable.querySelectorAll(`a[href*="/web/content/"][data-mimetype]:empty`)].filter(link=>(RE_WHITESPACE.test(link.textContent)));for(const link of links){const image=document.createElement('img');image.setAttribute('src',_getStylePropertyValue(link,'background-image').replace(/(^url\(['"])|(['"]\)$)/g,''));image.setAttribute('height',Math.max(1,_getHeight(link)));image.setAttribute('width',Math.max(1,_getWidth(link)));link.prepend(image);};}
function bootstrapToTable(editable){for(const rowInColumn of[...editable.querySelectorAll('.row')].filter(row=>RE_COL_MATCH.test(row.parentElement.className))){const parentColumn=rowInColumn.parentElement;const previous=rowInColumn.previousElementSibling;if(previous&&previous.classList.contains('o_fake_table')){previous.append(rowInColumn);}else{_wrap(rowInColumn,'div','o_fake_table');}
const rowStyle=getComputedStyle(rowInColumn);const columnStyle=getComputedStyle(parentColumn);for(const side of['left','right']){const negativeMargin=+rowStyle[`margin-${side}`].replace('px','');const columnPadding=+columnStyle[`padding-${side}`].replace('px','');if(negativeMargin<0&&columnPadding>=Math.abs(negativeMargin)){parentColumn.style[`padding-${side}`]=`${columnPadding + negativeMargin}px`;rowInColumn.style[`margin-${side}`]=0;}}}
for(const masonryTopInnerContainer of editable.querySelectorAll('.s_masonry_block > .container')){masonryTopInnerContainer.style.setProperty('height','100%');}
for(const masonryGrid of editable.querySelectorAll('.o_masonry_grid_container')){masonryGrid.style.setProperty('padding',0);for(const fakeTable of[...masonryGrid.children].filter(c=>c.classList.contains('o_fake_table'))){fakeTable.style.setProperty('height',_getHeight(fakeTable)+'px');}}
for(const masonryRow of editable.querySelectorAll('.o_masonry_grid_container > .o_fake_table > .row.h-100')){masonryRow.style.removeProperty('height');masonryRow.parentElement.style.setProperty('height','100%');}
const containers=editable.querySelectorAll('.container, .container-fluid, .o_fake_table');for(const container of containers){container.setAttribute('o-temp-width',_getWidth(container));}
for(const container of[...containers].filter(n=>[...n.children].some(c=>c.classList.contains('row')))){const containerWidth=parseFloat(container.getAttribute('o-temp-width'));const table=_createTable(container.attributes);for(const child of[...container.childNodes]){table.append(child);}
table.classList.remove('container','container-fluid','o_fake_table');if(!table.className){table.removeAttribute('class');}
container.before(table);container.remove();for(const row of[...table.children].filter(child=>isBlock(child)&&!child.classList.contains('row'))){const newCol=_wrap(row,'div','col-12');_wrap(newCol,'div','row');}
for(const bootstrapRow of[...table.children].filter(c=>c.classList.contains('row'))){const tr=document.createElement('tr');for(const attr of bootstrapRow.attributes){tr.setAttribute(attr.name,attr.value);}
tr.classList.remove('row');if(!tr.className){tr.removeAttribute('class');}
for(const child of[...bootstrapRow.childNodes]){tr.append(child);}
bootstrapRow.before(tr);bootstrapRow.remove();const bootstrapColumns=[...tr.children].filter(column=>column.className&&column.className.match(RE_COL_MATCH));const flexColumns=bootstrapColumns.filter(column=>!/\d/.test(column.className.match(RE_COL_MATCH)[0]||'0'));const colTotalSize=bootstrapColumns.map(child=>_getColumnSize(child)+_getColumnOffsetSize(child)).reduce((a,b)=>a+b,0);const colSize=Math.max(1,Math.round((12-colTotalSize)/flexColumns.length));for(const flexColumn of flexColumns){flexColumn.classList.remove(flexColumn.className.match(RE_COL_MATCH)[0].trim());flexColumn.classList.add(`col-${colSize}`);}
let columnIndex=0;for(const bootstrapColumn of[...bootstrapColumns]){const offsetSize=_getColumnOffsetSize(bootstrapColumn);if(offsetSize){const newColumn=document.createElement('div');newColumn.classList.add(`col-${offsetSize}`);bootstrapColumn.classList.remove(bootstrapColumn.className.match(RE_OFFSET_MATCH)[0].trim());bootstrapColumn.before(newColumn);bootstrapColumns.splice(columnIndex,0,newColumn);columnIndex++;}
columnIndex++;}
let grid=_createColumnGrid();let gridIndex=0;let currentRow=tr.cloneNode();tr.after(currentRow);let currentCol;columnIndex=0;for(const bootstrapColumn of bootstrapColumns){const columnSize=_getColumnSize(bootstrapColumn);if(gridIndex+columnSize<12){currentCol=grid[gridIndex];_applyColspan(currentCol,columnSize,containerWidth);gridIndex+=columnSize;if(columnIndex===bootstrapColumns.length-1){_applyColspan(grid[gridIndex],12-gridIndex,containerWidth);currentRow.append(...grid.filter(td=>td.getAttribute('colspan')));}}else if(gridIndex+columnSize===12){currentCol=grid[gridIndex];if(currentCol){_applyColspan(currentCol,columnSize,containerWidth);}
currentRow.append(...grid.filter(td=>td.getAttribute('colspan')));if(columnIndex!==bootstrapColumns.length-1){const previousRow=currentRow;currentRow=currentRow.cloneNode();previousRow.after(currentRow);grid=_createColumnGrid();gridIndex=0;}}else{if(grid[gridIndex]){_applyColspan(grid[gridIndex],12-gridIndex,containerWidth);}
currentRow.append(...grid.filter(td=>td.getAttribute('colspan')));const previousRow=currentRow;currentRow=currentRow.cloneNode();previousRow.after(currentRow);grid=_createColumnGrid();currentCol=grid[0];_applyColspan(currentCol,columnSize,containerWidth);gridIndex=columnSize;if(columnIndex===bootstrapColumns.length-1&&gridIndex<12){_applyColspan(grid[gridIndex],12-gridIndex,containerWidth);currentRow.append(...grid.filter(td=>td.getAttribute('colspan')));}}
if(currentCol){for(const attr of bootstrapColumn.attributes){if(attr.name!=='colspan'){currentCol.setAttribute(attr.name,attr.value);}}
const colMatch=bootstrapColumn.className.match(RE_COL_MATCH);currentCol.classList.remove(colMatch[0].trim());if(!currentCol.className){currentCol.removeAttribute('class');}
for(const child of[...bootstrapColumn.childNodes]){currentCol.append(child);}
_applyColspan(currentCol,+currentCol.getAttribute('colspan'),containerWidth);}
columnIndex++;}
tr.remove();}}
for(const table of editable.querySelectorAll('table')){table.removeAttribute('o-temp-width');}
const tds=[...editable.querySelectorAll('td')].filter(td=>td.children.length>1&&[...td.children].every(child=>child.nodeName==='TABLE')).reverse();for(const td of tds){const table=_createTable();const trs=[...td.children].map(child=>_wrap(child,'td')).map(wrappedChild=>_wrap(wrappedChild,'tr'));trs[0].before(table);table.append(...trs);}}
function cardToTable(editable){for(const card of editable.querySelectorAll('.card')){const table=_createTable(card.attributes);table.style.removeProperty('overflow');const cardImgTopSuperRows=[];for(const child of[...card.childNodes]){const row=document.createElement('tr');const col=document.createElement('td');if(!['IMG','A'].includes(child.nodeName)&&isBlock(child)){for(const attr of child.attributes){col.setAttribute(attr.name,attr.value);}
for(const descendant of[...child.childNodes]){col.append(descendant);}
child.remove();}else if(child.nodeType===Node.TEXT_NODE){if(child.textContent.replace(RE_WHITESPACE,'').length){col.append(child);}else{continue;}}else{col.append(child);}
const subTable=_createTable();const superRow=document.createElement('tr');const superCol=document.createElement('td');row.append(col);subTable.append(row);superCol.append(subTable);superRow.append(superCol);table.append(superRow);if(child.nodeType===Node.ELEMENT_NODE){const hasImgTop=[child,...child.querySelectorAll('.card-img-top')].some(node=>(node.classList&&node.classList.contains('card-img-top')&&node.closest&&node.closest('.card')===table));if(hasImgTop){cardImgTopSuperRows.push(superRow);}}}
const smallestCardImgRow=Math.min(0,...cardImgTopSuperRows.map(row=>row.clientHeight));for(const row of cardImgTopSuperRows){row.style.height=smallestCardImgRow+'px';}
card.before(table);card.remove();}}
function classToStyle($editable,cssRules){const editable=$editable.get(0);const writes=[];const nodeToRules=new Map();const rulesToProcess=[];for(const rule of cssRules){const nodes=editable.querySelectorAll(rule.selector);if(nodes.length){rulesToProcess.push(rule);}
for(const node of nodes){const nodeRules=nodeToRules.get(node);if(!nodeRules){nodeToRules.set(node,[rule]);}else{nodeRules.push(rule);}}}
_computeStyleAndSpecificityOnRules(rulesToProcess);for(const rules of nodeToRules.values()){rules.sort((a,b)=>a.specificity-b.specificity);}
for(const node of nodeToRules.keys()){const nodeRules=nodeToRules.get(node);const css=nodeRules?_getMatchedCSSRules(node,nodeRules,true):{};for(const styleName of node.style){if(styleName.includes('flex')||`${node.style[styleName]}`.includes('flex')){writes.push(()=>{node.style[styleName]='';});}}
let style=node.getAttribute('style')||'';style=style.replace(/!important/g,'');for(const[key,value]of Object.entries(css)){if(!(new RegExp(`(^|;)\\s*${key}[ :]`).test(style))){style=`${key}:${value};${style}`;}};style=correctBorderAttributes(style);if(Object.keys(style||{}).length===0){writes.push(()=>{node.removeAttribute('style');});}else{writes.push(()=>{node.setAttribute('style',style);if(node.style.width){node.setAttribute('width',node.style.width.replace('px','').trim());}});}
if(node.nodeName==='IMG'){writes.push(()=>{if(node.classList.contains('s_media_list_img')){node.style.removeProperty('height');}
if(node.style.getPropertyValue('width')==='100%'&&node.style.getPropertyValue('object-fit')===''){node.style.setProperty('object-fit','cover');}});}
if(node.nodeName==='TD'&&!node.childNodes.length){writes.push(()=>{node.appendChild(document.createTextNode('\u00A0'));});}
if(node.nodeName==='A'&&node.classList.contains('btn')&&!node.classList.contains('btn-link')&&!node.children.length){writes.push(()=>{node.before(_createMso(`<table align="center" border="0"
                    role="presentation" cellpadding="0" cellspacing="0"
                    style="border-radius: 6px; border-collapse: separate !important;">
                        <tbody>
                            <tr>
                                <td style="${node.style.cssText.replace(RE_PADDING_MATCH, '').replaceAll('"', '&quot;')}" ${
                                    node.parentElement.style.textAlign === 'center' ? 'align="center" ' : ''
                                }bgcolor="${rgbToHex(node.style.backgroundColor)}">
                    `));node.after(_createMso(`</td>
                        </tr>
                    </tbody>
                </table>`));});}else if(node.nodeName==='IMG'&&node.classList.contains('mx-auto')&&node.classList.contains('d-block')){writes.push(()=>{_wrap(node,'p','o_outlook_hack','text-align:center;margin:0');});}
writes.push(()=>{let computedStyle;for(const styleName of node.style){const styleValue=node.style.getPropertyValue(styleName);if(styleValue.includes('var(')||styleValue.includes('calc(')){computedStyle=computedStyle||getComputedStyle(node);const prop=styleValue.includes('var(')?styleValue.replace(/var\((.*)\)/,'$1'):styleName;const value=computedStyle.getPropertyValue(prop)||computedStyle.getPropertyValue(styleName);node.style.setProperty(styleName,value);}}});writes.push(()=>{const propsToConvert=FONT_PROPERTIES_TO_INHERIT.filter(prop=>node.style[prop]==='inherit');if(propsToConvert.length){const computedStyle=getComputedStyle(node);for(const prop of propsToConvert){node.style.setProperty(prop,computedStyle[prop]);}}});};writes.forEach(fn=>fn());}
function enforceTablesResponsivity(editable){const trs=[...editable.querySelectorAll('.o_mail_wrapper tr')].filter(tr=>[...tr.children].some(td=>td.classList.contains('o_converted_col'))).reverse();for(const tr of trs){const commonTable=_createTable();commonTable.style.height='100%';const commonTr=document.createElement('tr');const commonTd=document.createElement('td');commonTr.appendChild(commonTd);commonTable.appendChild(commonTr);const tds=[...tr.children].filter(child=>child.nodeName==='TD');let index=0;for(const td of tds){const width=td.style.maxWidth;const div=document.createElement('div');div.style.display='inline-block';div.style.verticalAlign='top';div.classList.add('o_stacking_wrapper');commonTd.appendChild(div);const newTable=_createTable();newTable.style.width=width;newTable.classList.add('o_stacking_wrapper');div.appendChild(newTable);const newTr=document.createElement('tr');newTable.appendChild(newTr);newTr.appendChild(td);td.style.width='100%';td.removeAttribute('width');if(index===0){div.before(_createMso(`
                    <table cellpadding="0" cellspacing="0" border="0" role="presentation" style="width: 100%;">
                        <tr>
                            <td valign="top" style="width: ${width};">`));}else{div.before(_createMso(`</td><td valign="top" style="width: ${width};">`));}
if(index===tds.length-1){div.after(_createMso(`</td></tr></table>`));}
index++;}
const topTd=document.createElement('td');topTd.appendChild(commonTable);tr.prepend(topTd);}}
function handleMasonry(editable){const masonryTrs=editable.querySelectorAll('.s_masonry_block tr');for(const tr of masonryTrs){const height=_getHeight(tr);const tds=[...tr.children].filter(child=>child.nodeName==='TD');const tdsWithTable=tds.filter(td=>[...td.children].some(child=>child.nodeName==='TABLE'));if(tdsWithTable.length){for(const tdWithTable of tdsWithTable){tdWithTable.classList.add('o_desktop_h100');tdWithTable.style.setProperty('height','100%');}
tds.forEach(td=>td.style.setProperty('height',height+'px'));}
const trSiblings=[...tr.parentElement.children].filter(child=>child.nodeName==='TR');if(trSiblings.length>1&&(tr.classList.contains('h-100')||tr.style.getPropertyValue('height')==='100%')){tr.style.setProperty('height',`${_getHeight(tr.parentElement) / trSiblings.length}px`);}}
for(const tr of masonryTrs){const height=tr.style.height.includes('px')?parseFloat(tr.style.height.replace('px','').trim()):_getHeight(tr);tr.closest('table').classList.add('o_desktop_h100');tr.classList.add('o_desktop_h100');for(const td of[...tr.children].filter(child=>child.nodeName==='TD')){td.classList.add('o_desktop_h100');td.style.setProperty('height','100%');const childrenNames=[...td.children].map(child=>child.nodeName);if(!childrenNames.includes('TABLE')){const wrapper=document.createElement('div');wrapper.style.setProperty('display','inline-block');wrapper.style.setProperty('width','100%');const tdStyle=getComputedStyle(td);wrapper.style.setProperty('color',tdStyle.color);const firstNonCommentChild=[...td.childNodes].find(child=>child.nodeType!==Node.COMMENT_NODE);let anchor;if(firstNonCommentChild){anchor=getAdjacentPreviousSiblings(firstNonCommentChild).filter(sib=>sib.nodeType!==Node.TEXT_NODE).shift();}
for(const child of[...td.childNodes].filter(child=>child.nodeType!==Node.COMMENT_NODE)){wrapper.append(child);}
anchor?anchor.after(wrapper):td.append(wrapper);const centeringSpan=document.createElement('span');centeringSpan.style.setProperty('height','100%');centeringSpan.style.setProperty('display','inline-block');centeringSpan.style.setProperty('vertical-align','middle');td.prepend(centeringSpan);if(td.style.height.includes('%')){const newHeight=height*parseFloat(td.style.height.replace('%').trim())/100;td.style.setProperty('height',newHeight+'px');td.style.setProperty('max-height',newHeight+'px');wrapper.style.setProperty('max-height',newHeight+'px');if(wrapper.childElementCount===1&&wrapper.firstElementChild.nodeName==='IMG'&&wrapper.firstElementChild.style.height==='100%'){wrapper.firstElementChild.style.setProperty('max-height',newHeight+'px');}}}}}}
function enforceImagesResponsivity(editable){for(const image of editable.querySelectorAll('td > img')){const td=image.parentElement;if(td.childElementCount===1&&(image.classList.contains('h-100')||_getStylePropertyValue(image,'height')==='100%')){td.style.setProperty('height',_getHeight(td.parentElement)+'px');image.style.setProperty('height','100%');}}
for(const image of editable.querySelectorAll('img[width="100%"][height]')){image.before(_createMso(image.outerHTML));image.classList.add('mso-hide');image.removeAttribute('height');}}
__exports.toInline=toInline;async function toInline($editable,options){$editable.removeClass('odoo-editor-editable');const editable=$editable.get(0);const iframe=options.$iframe&&options.$iframe.get(0);const wysiwyg=$editable.data('wysiwyg')||options.wysiwyg;const doc=editable.ownerDocument;let cssRules=wysiwyg&&wysiwyg._rulesCache;if(!cssRules){cssRules=getCSSRules(doc);if(wysiwyg){wysiwyg._rulesCache=cssRules;}}
const displaysToRestore=[];if(_isHidden(editable)){let ancestor=editable;while(ancestor&&ancestor.nodeName!=='html'&&_isHidden(ancestor)){if(_getStylePropertyValue(ancestor,'display')==='none'){displaysToRestore.push([ancestor,ancestor.style.display]);ancestor.style.setProperty('display','block');}
ancestor=ancestor.parentElement;if((!ancestor||ancestor.nodeName==='HTML')&&iframe){ancestor=iframe;}}}
for(const imgTop of editable.querySelectorAll('.card-img-top')){imgTop.style.setProperty('height',_getHeight(imgTop)+'px');}
attachmentThumbnailToLinkImg($editable);fontToImg($editable);await svgToPng($editable);await webpToPng($editable);for(const image of editable.querySelectorAll('img.img-fluid')){const width=_getWidth(image);const clone=image.cloneNode();clone.setAttribute('width',width);clone.style.setProperty('width',width+'px');clone.style.removeProperty('max-width');image.before(_createMso(clone.outerHTML));_hideForOutlook(image);}
classToStyle($editable,cssRules);bootstrapToTable(editable);cardToTable(editable);listGroupToTable(editable);addTables($editable);handleMasonry(editable);const rootFontSizeProperty=getComputedStyle(editable.ownerDocument.documentElement).fontSize;const rootFontSize=parseFloat(rootFontSizeProperty.replace(/[^\d\.]/g,''));normalizeRem($editable,rootFontSize);enforceImagesResponsivity(editable);enforceTablesResponsivity(editable);flattenBackgroundImages(editable);formatTables($editable);normalizeColors($editable);responsiveToStaticForOutlook(editable);for(const attributeName of['width','height']){const images=editable.querySelectorAll('img');for(const image of images){if(image.style[attributeName]!=='auto'){const value=image.getAttribute(attributeName)||(attributeName==='height'&&image.offsetHeight)||(attributeName==='width'?_getWidth(image):_getHeight(image));if(value){image.setAttribute(attributeName,value);image.style.setProperty(attributeName,value+'px');}}};};for(const centeredImage of editable.querySelectorAll('td > img.mx-auto')){if(centeredImage.parentElement.children.length===1){centeredImage.parentElement.style.setProperty('text-align','center');}}
[editable,...editable.querySelectorAll('[contenteditable]')].forEach(node=>node.removeAttribute('contenteditable'));editable.querySelectorAll('.mso-hide').forEach(_hideForOutlook);editable.querySelectorAll('[style*=font-family]').forEach(n=>(n.nodeName==='IMG'?n.style.removeProperty('font-family'):n.setAttribute('style',n.getAttribute('style').replaceAll('"','\''))));$editable.find('style').remove();editable.querySelectorAll('.o_converted_col').forEach(node=>node.classList.remove('o_converted_col'));for(const[node,displayValue]of displaysToRestore){node.style.setProperty('display',displayValue);}
$editable.addClass('odoo-editor-editable');}
function flattenBackgroundImages(editable){const backgroundImages=[...editable.querySelectorAll('*[style*=background-image]')].filter(el=>!el.closest('.mso-hide')).reverse();for(const backgroundImage of backgroundImages){const vml=_backgroundImageToVml(backgroundImage);if(vml){backgroundImage.after(_createMso(vml));backgroundImage.classList.add('mso-hide');}
if(backgroundImage.hasAttribute('data-bg-src')){backgroundImage.removeAttribute('data-bg-src');}}}
function fontToImg($editable){const editable=$editable.get(0);const{fonts}=odoo.loader.modules.get("@web_editor/js/wysiwyg/fonts");for(const font of editable.querySelectorAll('.fa')){let icon,content;fonts.fontIcons.find(fontIcon=>{return fonts.getCssSelectors(fontIcon.parser).find(data=>{if(font.matches(data.selector.replace(/::?before/g,''))){icon=data.names[0].split('-').shift();content=data.css.match(/content:\s*['"]?(.)['"]?/)[1];return true;}});});if(content){const color=_getStylePropertyValue(font,'color').replace(/\s/g,'');let backgroundColoredElement=font;let bg,isTransparent;do{bg=_getStylePropertyValue(backgroundColoredElement,'background-color').replace(/\s/g,'');isTransparent=bg==='transparent'||bg==='rgba(0,0,0,0)';backgroundColoredElement=backgroundColoredElement.parentElement;}while(isTransparent&&backgroundColoredElement);if(bg==='rgba(0,0,0,0)'&&isTransparent){bg='rgb(255,255,255)';}
const style=font.getAttribute('style');const width=_getWidth(font);const height=_getHeight(font);const lineHeight=_getStylePropertyValue(font,'line-height');font.style.setProperty('height','fit-content');font.style.setProperty('width','fit-content');font.style.setProperty('line-height','normal');const intrinsicWidth=_getWidth(font);const intrinsicHeight=_getHeight(font);const hPadding=width&&intrinsicWidth&&(width-intrinsicWidth)/2;const vPadding=height&&intrinsicHeight&&(height-intrinsicHeight)/2;let padding='';if(hPadding||vPadding){padding=vPadding?vPadding+'px ':'0 ';padding+=hPadding?hPadding+'px':'0';}
const image=document.createElement('img');image.setAttribute('width',intrinsicWidth);image.setAttribute('height',intrinsicHeight);image.setAttribute('src',`/web_editor/font_to_img/${content.charCodeAt(0)}/${encodeURIComponent(color)}/${encodeURIComponent(bg)}/${Math.max(1, Math.round(intrinsicWidth))}x${Math.max(1, Math.round(intrinsicHeight))}`);image.setAttribute('data-class',font.getAttribute('class'));image.setAttribute('data-style',style);image.setAttribute('style',style);image.style.setProperty('box-sizing','border-box');image.style.setProperty('line-height',lineHeight);image.style.setProperty('width',intrinsicWidth+'px');image.style.setProperty('height',intrinsicHeight+'px');image.style.setProperty('vertical-align','unset');if(!padding){image.style.setProperty('margin',_getStylePropertyValue(font,'margin'));}
const wrapper=document.createElement('span');wrapper.style.setProperty('display','inline-block');wrapper.append(image);font.before(wrapper);if(font.classList.contains('mx-auto')){wrapper.parentElement.style.textAlign='center';}
font.remove();wrapper.style.setProperty('padding',padding);const wrapperWidth=width+['left','right'].reduce((sum,side)=>(sum+(+_getStylePropertyValue(image,`margin-${side}`).replace('px','')||0)),0);wrapper.style.setProperty('width',wrapperWidth+'px');wrapper.style.setProperty('height',height+'px');wrapper.style.setProperty('vertical-align','text-bottom');wrapper.style.setProperty('background-color',image.style.backgroundColor);wrapper.setAttribute('class','oe_unbreakable '+
font.getAttribute('class').replace(new RegExp('(^|\\s+)'+icon+'(-[^\\s]+)?','gi'),''));}else{font.remove();}}}
function formatTables($editable){const editable=$editable.get(0);const writes=[];for(const table of editable.querySelectorAll('table.o_mail_snippet_general, .o_mail_snippet_general table')){const tablePaddingTop=parseFloat(_getStylePropertyValue(table,'padding-top').match(RE_PADDING)[1]);const tablePaddingRight=parseFloat(_getStylePropertyValue(table,'padding-right').match(RE_PADDING)[1]);const tablePaddingBottom=parseFloat(_getStylePropertyValue(table,'padding-bottom').match(RE_PADDING)[1]);const tablePaddingLeft=parseFloat(_getStylePropertyValue(table,'padding-left').match(RE_PADDING)[1]);const rows=[...table.querySelectorAll('tr')].filter(tr=>tr.closest('table')===table);const columns=[...table.querySelectorAll('td')].filter(td=>td.closest('table')===table);for(const column of columns){const columnsInRow=[...column.closest('tr').querySelectorAll('td')].filter(td=>td.closest('table')===table);const columnIndex=columnsInRow.findIndex(col=>col===column);const rowIndex=rows.findIndex(row=>row===column.closest('tr'));if(!rowIndex){const match=_getStylePropertyValue(column,'padding-top').match(RE_PADDING);const columnPaddingTop=match?parseFloat(match[1]):0;writes.push(()=>{column.style['padding-top']=`${columnPaddingTop + tablePaddingTop}px`;});}
if(columnIndex===columnsInRow.length-1){const match=_getStylePropertyValue(column,'padding-right').match(RE_PADDING);const columnPaddingRight=match?parseFloat(match[1]):0;writes.push(()=>{column.style['padding-right']=`${columnPaddingRight + tablePaddingRight}px`;});}
if(rowIndex===rows.length-1){const match=_getStylePropertyValue(column,'padding-bottom').match(RE_PADDING);const columnPaddingBottom=match?parseFloat(match[1]):0;writes.push(()=>{column.style['padding-bottom']=`${columnPaddingBottom + tablePaddingBottom}px`;});}
if(!columnIndex){const match=_getStylePropertyValue(column,'padding-left').match(RE_PADDING);const columnPaddingLeft=match?parseFloat(match[1]):0;writes.push(()=>{column.style['padding-left']=`${columnPaddingLeft + tablePaddingLeft}px`;});}}
writes.push(()=>{table.style.removeProperty('padding');});}
writes.forEach((fn)=>fn());for(const table of[...editable.querySelectorAll('table')].filter(n=>![...n.children].some(c=>c.nodeName==='TBODY'))){const contents=[...table.childNodes];const tbody=document.createElement('tbody');tbody.style.setProperty('vertical-align','top');table.prepend(tbody);tbody.append(...contents);}
for(const node of[...editable.querySelectorAll('*')].filter(n=>(n.style&&n.style.getPropertyValue('height')==='100%'&&(!n.parentElement.style.getPropertyValue('height')||n.parentElement.style.getPropertyValue('height').includes('%'))))){let parent=node.parentElement;let height=parent.style.getPropertyValue('height');while(parent&&height&&height.includes('%')){parent=parent.parentElement;height=parent.style.getPropertyValue('height');}
if(parent){parent.style.setProperty('height',$(parent).height());}}
for(const cell of editable.querySelectorAll('td')){const alignSelf=cell.style.alignSelf;const justifyContent=cell.style.justifyContent;if(alignSelf==='start'||justifyContent==='start'||justifyContent==='flex-start'){cell.style.verticalAlign='top';}else if(alignSelf==='center'||justifyContent==='center'){const parentCell=cell.parentElement.closest('td');const parentTable=cell.closest('table');if(parentCell){parentTable.style.height=_getHeight(parentCell)+'px';}
cell.style.verticalAlign='middle';}else if(alignSelf==='end'||justifyContent==='end'||justifyContent==='flex-end'){cell.style.verticalAlign='bottom';}}
for(const row of editable.querySelectorAll('tr')){const alignItems=row.style.alignItems;if(alignItems==='flex-start'){row.style.verticalAlign='top';}else if(alignItems==='center'){row.style.verticalAlign='middle';}else if(alignItems==='flex-end'||alignItems==='baseline'){row.style.verticalAlign='bottom';}else if(alignItems==='stretch'){const columns=[...row.querySelectorAll('td.o_converted_col')];if(columns.length>1){const commonAncestor=commonParentGet(columns[0],columns[1]);const biggestHeight=commonAncestor.clientHeight;for(const column of columns){column.style.height=biggestHeight+'px';}}}}
for(const table of editable.querySelectorAll('table')){const propsToConvert=FONT_PROPERTIES_TO_INHERIT.filter(prop=>table.style[prop]==='inherit'||!table.style[prop]);if(propsToConvert.length){for(const prop of propsToConvert){let ancestor=table;while(ancestor&&(!ancestor.style[prop]||ancestor.style[prop]==='inherit')){ancestor=ancestor.parentElement;}
if(ancestor){table.style.setProperty(prop,ancestor.style[prop]);}}}}}
__exports.getCSSRules=getCSSRules;function getCSSRules(doc){const cssRules=[];for(const sheet of doc.styleSheets){let rules;try{rules=sheet.rules||sheet.cssRules;}catch(e){console.log("Can't read the css rules of: "+sheet.href,e);continue;}
for(const rule of(rules||[])){const subRules=[rule];const conditionText=rule.conditionText;const minWidthMatch=conditionText&&conditionText.match(/\(min-width *: *(\d+)/);const minWidth=minWidthMatch&&+(minWidthMatch[1]||'0');if(minWidth&&minWidth>=992){let mediaRules;try{mediaRules=rule.rules||rule.cssRules;subRules.push(...mediaRules);}catch(e){console.log(`Can't read the css rules of: ${sheet.href} (${conditionText})`,e);}}
for(const subRule of subRules){const selectorText=subRule.selectorText||'';for(const selector of selectorText.split(RE_COMMAS_OUTSIDE_PARENTHESES)){if(selector&&!SELECTORS_IGNORE.test(selector)){cssRules.push({selector:selector.trim(),rawRule:subRule});if(selector==='body'){cssRules.push({selector:'.o_layout',rawRule:subRule,specificity:1});}}}}}}
return cssRules;}
function listGroupToTable(editable){for(const listGroup of editable.querySelectorAll('.list-group')){let table;if(listGroup.querySelectorAll('.list-group-item').length){table=_createTable(listGroup.attributes);}else{table=listGroup.cloneNode();for(const attr of listGroup.attributes){table.setAttribute(attr.name,attr.value);}}
for(const child of[...listGroup.childNodes]){if(child.classList&&child.classList.contains('list-group-item')){const row=document.createElement('tr');const col=document.createElement('td');for(const attr of child.attributes){col.setAttribute(attr.name,attr.value);}
col.append(...child.childNodes);col.classList.remove('list-group-item');if(!col.className){col.removeAttribute('class');}
row.append(col);table.append(row);child.remove();}else if(child.nodeName==='LI'){table.append(...child.childNodes);}else{table.append(child);}}
table.classList.remove('list-group');if(!table.className){table.removeAttribute('class');}
if(listGroup.nodeName==='TD'){listGroup.append(table);listGroup.classList.remove('list-group');if(!listGroup.className){listGroup.removeAttribute('class');}}else{listGroup.before(table);listGroup.remove();}}}
function normalizeColors($editable){const editable=$editable.get(0);for(const node of editable.querySelectorAll('[style*="rgb"]')){const rgbaMatch=node.getAttribute('style').match(/rgba?\(([\d\.]+\s*,?\s*){3,4}\)/g);for(const rgb of rgbaMatch||[]){node.setAttribute('style',node.getAttribute('style').replace(rgb,rgbToHex(rgb,node)));}}}
function normalizeRem($editable,rootFontSize=16){const editable=$editable.get(0);for(const node of editable.querySelectorAll('[style*="rem"]')){const remMatch=node.getAttribute('style').match(/[\d\.]+\s*rem/g);for(const rem of remMatch||[]){const remValue=parseFloat(rem.replace(/[^\d\.]/g,''));const pxValue=Math.round(remValue*rootFontSize*100)/100;node.setAttribute('style',node.getAttribute('style').replace(rem,pxValue+'px'));}}}
function responsiveToStaticForOutlook(editable){for(const td of editable.querySelectorAll('td.o_converted_col:not(.mso-hide)')){const tdStyle=td.getAttribute('style')||'';const msoAttributes=[...td.attributes].filter(attr=>attr.name!=='style'&&attr.name!=='width');const msoWidth=td.style.getPropertyValue('max-width');const msoStyles=tdStyle.replace(/(^| |max-)width:[^;]*;\s*/g,'');const outlookTd=document.createElement('td');for(const attribute of msoAttributes){outlookTd.setAttribute(attribute.name,td.getAttribute(attribute.name));}
if(msoWidth){outlookTd.setAttribute('width',(''+msoWidth).replace('px','').trim());outlookTd.setAttribute('style',`${msoStyles}width: ${msoWidth};`);}else{outlookTd.setAttribute('style',msoStyles);}
if(td.closest('.s_masonry_block')){outlookTd.style.padding=0;}
if(td.children.length===1&&td.firstElementChild.nodeName==='IMG'){const tdComputedStyle=getComputedStyle(td);for(const side of['left','right']){if(td.firstElementChild.style.width==='100%'){const prop=`padding-${side}`;const imagePadding=+td.firstElementChild.style[prop].replace('px','');if(imagePadding>0){const tdPadding=+tdComputedStyle[prop].replace('px','')||0;outlookTd.style[prop]=tdPadding+imagePadding+'px';}}}}
td.before(_createMso(outlookTd.outerHTML.replace('</td>','')));_hideForOutlook(td,'opening');}}
async function convertToPng(img){await new Promise(resolve=>{img.onload=()=>resolve();if(img.complete){resolve();}});const image=document.createElement('img');const canvas=document.createElement('CANVAS');const width=_getWidth(img);const height=_getHeight(img);canvas.setAttribute('width',width);canvas.setAttribute('height',height);canvas.getContext('2d').drawImage(img,0,0,width,height);for(const attribute of img.attributes){image.setAttribute(attribute.name,attribute.value);}
image.setAttribute('src',canvas.toDataURL('png'));image.setAttribute('width',width);image.setAttribute('height',height);return image;}
async function svgToPng($editable){for(const svg of $editable.find('img[src*=".svg"]')){const image=await convertToPng(svg);svg.before(image);svg.remove();}}
async function webpToPng($editable){for(const webp of $editable.find('img[src*=".webp"]')){const image=await convertToPng(webp);webp.before(image);webp.remove();}
for(const webp of $editable.find('[style*="background-image"][style*=".webp"]')){const width=_getWidth(webp);const height=_getHeight(webp);const tempImage=document.createElement("img");tempImage.setAttribute("src",webp.style.backgroundImage.slice(5,-2));tempImage.setAttribute("width",width);tempImage.setAttribute("height",height);webp.before(tempImage);const image=await convertToPng(tempImage);webp.style.backgroundImage=`url(${image.getAttribute("src")})`;tempImage.remove();}}
function _applyColspan(element,colspan,tableWidth){element.setAttribute('colspan',colspan);const widthPercentage=+element.getAttribute('colspan')/12;const width=Math.round(tableWidth*widthPercentage*100)/100;element.style.setProperty('max-width',width+'px');element.classList.add('o_converted_col');}
function _backgroundImageToVml(backgroundImage){const matches=backgroundImage.style.backgroundImage.match(/url\("?(.+?)"?\)/);const url=matches&&matches[1];if(url){const clone=backgroundImage.cloneNode(true);const div=document.createElement('div');div.replaceChildren(...clone.childNodes);[['fontSize',0],['height','100%'],['width','100%']].forEach(([k,v])=>div.style[k]=v);const vmlContent=document.createElement('div');vmlContent.append(div);const style=getComputedStyle(backgroundImage);for(const prop of FONT_PROPERTIES_TO_INHERIT){div.style[prop]=backgroundImage.style[prop]||style[prop];}
[...div.children].forEach(child=>child.style.setProperty('font-size',child.style.fontSize||style.fontSize));for(const prop of['background','background-image','background-repeat','background-size']){clone.style.removeProperty(prop);}
clone.style.padding=0;clone.className=clone.className.replace(/p[bt]\d+/g,'');clone.setAttribute('background',url);clone.setAttribute('valign','middle');const[width,height]=[_getWidth(backgroundImage),_getHeight(backgroundImage)];const vml=`<v:image xmlns:v="urn:schemas-microsoft-com:vml" fill="true" stroke="false" `+`style="border: 0; display: inline-block; width: ${width}px; height: ${height}px;" src="${url}"/>
        <v:rect xmlns:v="urn:schemas-microsoft-com:vml" fill="true" stroke="false" `+`style="border: 0; display: inline-block; position: absolute; width:${width}px; height:${height}px; v-text-anchor:middle;">
            <v:fill opacity="0%" color="#000000"/>
            <v:textbox inset="0,0,0,0">
                <table border="0" cellpadding="0" cellspacing="0">
                    <tr>
                        <td width="${width}" align="center" style="text-align: center;">${vmlContent.outerHTML}</td>
                    </tr>
                </table>
            </v:textbox>
        </v:rect>`;return`${clone.outerHTML.replace(/<\/[\w-]+>[\s\n]*$/, '')}${vml}</${clone.nodeName.toLowerCase()}>`;}}
function _computeSpecificity(selector){let a=0;selector=selector.replace(/#[a-z0-9_-]+/gi,()=>{a++;return'';});let b=0;selector=selector.replace(/(\.[a-z0-9_-]+)|(\[.*?\])/gi,()=>{b++;return'';});let c=0;selector=selector.replace(/(^|\s+|:+)[a-z0-9_-]+/gi,a=>{if(!a.includes(':not('))c++;return'';});return(a*100)+(b*10)+c;}
function _computeStyleAndSpecificityOnRules(cssRules){for(const cssRule of cssRules){if(!cssRule.style&&cssRule.rawRule.style){const style=_normalizeStyle(cssRule.rawRule.style);if(Object.keys(style).length){Object.assign(cssRule,{style,specificity:_computeSpecificity(cssRule.selector)});}}}}
function _createColumnGrid(){return new Array(12).fill().map(()=>document.createElement('td'));}
function _createMso(content=""){const showRegex=/<!--\[if\s+mso\]>([\s\S]*?)<!\[endif\]-->/g;const hideRegex=/<!--\[if\s+!mso\]>([\s\S]*?)<!\[endif\]-->/g;let contentToInsert=content;contentToInsert=contentToInsert.replace(showRegex,(matchedContent,group)=>group);contentToInsert=contentToInsert.replace(hideRegex,"");return document.createComment(`[if mso]>${contentToInsert}<![endif]`);}
function _createTable(attributes=[]){const table=document.createElement('table');Object.entries(TABLE_ATTRIBUTES).forEach(([att,value])=>table.setAttribute(att,value));for(const attr of attributes){if(!(attr.name==='width'&&attr.value==='100%')){table.setAttribute(attr.name,attr.value);}}
table.style.setProperty('width','100%','important');if(table.classList.contains('o_layout')){const layoutStyles={...TABLE_STYLES};delete layoutStyles['font-size'];delete layoutStyles['line-height'];Object.entries(layoutStyles).forEach(([att,value])=>table.style[att]=value)}else{for(const styleName in TABLE_STYLES){if(!('style'in attributes&&attributes.style.value.includes(styleName+':'))){table.style[styleName]=TABLE_STYLES[styleName];}}}
return table;}
function _getColumnSize(column){const colMatch=column.className.match(RE_COL_MATCH);const colOptions=colMatch[2]&&colMatch[2].substr(1).split('-');const colSize=colOptions&&(colOptions.length===2?+colOptions[1]:+colOptions[0])||0;return colSize;}
function _getColumnOffsetSize(column){const offsetMatch=column.className.match(RE_OFFSET_MATCH);const offsetOptions=offsetMatch&&offsetMatch[2]&&offsetMatch[2].substr(1).split('-');const offsetSize=offsetOptions&&(offsetOptions.length===2?+offsetOptions[1]:+offsetOptions[0])||0;return offsetSize;}
function isBlacklistedStyle(node,selector,key){return(node.matches("table, thead, tbody, tfoot, tr, td, th")&&["table","thead","tbody","tfoot","tr","td","th"].some((elName)=>selector.includes(elName))&&key.includes("color"));}
function removeBlacklistedStyles(rule,node,checkBlacklisted){if(!checkBlacklisted||!rule.style){return rule.style;}
const styles={};for(const[key,value]of Object.entries(rule.style)){if(isBlacklistedStyle(node,rule.selector,key)){continue;}
styles[key]=value;}
return styles;}
function _getMatchedCSSRules(node,cssRules,checkBlacklisted=false){node.matches=node.matches||node.webkitMatchesSelector||node.mozMatchesSelector||node.msMatchesSelector||node.oMatchesSelector;const styles=cssRules.map((rule)=>removeBlacklistedStyles(rule,node,checkBlacklisted)).filter(Boolean);if(node.style.length){const inlineStyles={};for(const styleName of node.style){inlineStyles[styleName]=node.style[styleName];}
styles.push(inlineStyles);}
const processedStyle={};for(const style of styles){for(const[key,value]of Object.entries(style)){if(!processedStyle[key]||!processedStyle[key].includes('important')||value.includes('important')){processedStyle[key]=value;}}}
for(const[key,value]of Object.entries(processedStyle)){if(value&&value.endsWith('important')){processedStyle[key]=value.replace(/\s*!important\s*$/,'');}};const computedStyle=getComputedStyle(node);for(const groupName in GROUPED_STYLES){const force=!groupName.includes("margin")&&!groupName.includes("padding");const hasSubStyleApplied=GROUPED_STYLES[groupName].some((styleName)=>styleName in processedStyle);if(!force&&hasSubStyleApplied){continue;}
for(const styleName of GROUPED_STYLES[groupName]){const styleValue=computedStyle.getPropertyValue(styleName);if(styleValue&&typeof styleValue==="string"&&styleValue.length){processedStyle[styleName]=styleValue;}}}
if(processedStyle.display==='block'&&!(node.classList&&node.classList.contains('oe-nested'))){delete processedStyle.display;}
if(!processedStyle['box-sizing']){processedStyle['box-sizing']='border-box';}
for(const info of[{name:'margin'},{name:'padding'},{name:'border',suffix:'-style',defaultValue:'none'},]){const positions=['top','right','bottom','left'];const positionalKeys=positions.map(position=>`${info.name}-${position}${info.suffix || ''}`);const styles=positionalKeys.map(key=>processedStyle[key]).filter(s=>s);const hasVariableStyle=styles.some(style=>style.includes('calc(')||style.includes('var('));const inherits=positionalKeys.some(key=>['inherit','initial'].includes((processedStyle[key]||'').trim()));if(styles.length&&!hasVariableStyle&&!inherits){const propertyName=`${info.name}${info.suffix || ''}`;processedStyle[propertyName]=positionalKeys.every(key=>processedStyle[positionalKeys[0]]===processedStyle[key])?processedStyle[propertyName]=processedStyle[positionalKeys[0]]:positionalKeys.map(key=>processedStyle[key]||(info.defaultValue||0)).join(' ');for(const prop of positionalKeys){delete processedStyle[prop];}}};if(processedStyle['border-bottom-left-radius']){processedStyle['border-radius']=processedStyle['border-bottom-left-radius'];delete processedStyle['border-bottom-left-radius'];delete processedStyle['border-bottom-right-radius'];delete processedStyle['border-top-left-radius'];delete processedStyle['border-top-right-radius'];}
for(const styleName in processedStyle){if(styleName.includes('border')&&processedStyle[styleName]==='initial'){delete processedStyle[styleName];}};if(processedStyle['text-decoration-line']){processedStyle['text-decoration']=processedStyle['text-decoration-line'];delete processedStyle['text-decoration-line'];delete processedStyle['text-decoration-color'];delete processedStyle['text-decoration-style'];delete processedStyle['text-decoration-thickness'];}
for(const styleName in processedStyle){if(styleName.includes('flex')||`${processedStyle[styleName]}`.includes('flex')){delete processedStyle[styleName];}}
return processedStyle;}
let lastComputedStyleElement;let lastComputedStyle
function _getStylePropertyValue(element,propertyName){const computedStyle=lastComputedStyleElement===element?lastComputedStyle:getComputedStyle(element)
lastComputedStyleElement=element;lastComputedStyle=computedStyle;return computedStyle[propertyName]||element.style.getPropertyValue(propertyName);}
function _getWidth(element){return parseFloat(getComputedStyle(element).width.replace('px',''))||0;}
function _getHeight(element){return parseFloat(getComputedStyle(element).height.replace('px',''))||0;}
function _hideForOutlook(node,onlyHideTag=false){if(!onlyHideTag){node.setAttribute('style',`${node.getAttribute('style') || ''} mso-hide: all;`.trim());}
node[onlyHideTag==='closing'?'append':'before'](document.createComment('[if !mso]><!'));node[onlyHideTag==='opening'?'prepend':'after'](document.createComment('<![endif]'));}
function _isHidden(element){return element.offsetParent===null;}
function _normalizeStyle(style){const normalizedStyle={};for(const styleName of style){const value=style[styleName];if(value&&!styleName.includes("animation")&&!styleName.includes("-webkit")&&typeof value==="string"){const normalizedStyleName=styleName.replace(/-(.)/g,(a,b)=>b.toUpperCase());normalizedStyle[styleName]=style[normalizedStyleName];if(style.getPropertyPriority(styleName)==='important'){normalizedStyle[styleName]+=' !important';}}}
return normalizedStyle;}
function _wrap(element,wrapperTag,wrapperClass,wrapperStyle){const wrapper=document.createElement(wrapperTag);if(wrapperClass){wrapper.className=wrapperClass;}
if(wrapperStyle){wrapper.style.cssText=wrapperStyle;}
element.parentElement.insertBefore(wrapper,element);wrapper.append(element);return wrapper;}
function correctBorderAttributes(style){const stylesObject=style.replace(/\s+/g," ").split(";").reduce((styles,styleString)=>{const[attribute,value]=styleString.split(":").map((str)=>str.trim());if(attribute){styles[attribute]=value;}
return styles;},{});const BORDER_WIDTHS_ATTRIBUTES=["border-bottom-width","border-left-width","border-right-width","border-top-width",];const isBorderStyleApplied=BORDER_WIDTHS_ATTRIBUTES.some((attribute)=>attribute in stylesObject);if(!isBorderStyleApplied){return style;}
const totalBorderWidth=BORDER_WIDTHS_ATTRIBUTES.reduce((totalWidth,attribute)=>{const widthValue=stylesObject[attribute]||"0px";const numericWidth=parseFloat(widthValue.replace("px",""))||0;return totalWidth+numericWidth;},0);if(totalBorderWidth===0){let correctedStyle=style.trim();if(correctedStyle.slice(-1)!=';'){correctedStyle+=';';}
correctedStyle=correctedStyle.replace(/(;|^)\s*border-style\s*:[^;]*(;|$)|$/,'$1border-style:none$2');return correctedStyle;}
return style;}
__exports[Symbol.for("default")]={addTables:addTables,attachmentThumbnailToLinkImg:attachmentThumbnailToLinkImg,bootstrapToTable:bootstrapToTable,cardToTable:cardToTable,classToStyle:classToStyle,fontToImg:fontToImg,formatTables:formatTables,getCSSRules:getCSSRules,listGroupToTable:listGroupToTable,normalizeColors:normalizeColors,normalizeRem:normalizeRem,toInline:toInline,createMso:_createMso,};return __exports;});;

/* /web_editor/static/src/js/backend/html_field.js */
odoo.define('@web_editor/js/backend/html_field',['@web/core/registry','@web/core/l10n/translation','@web/views/fields/standard_field_props','@web_editor/js/backend/QWebPlugin','@web/views/fields/translation_button','@web/views/fields/dynamic_placeholder_hook','@web/core/utils/hooks','@web_editor/js/editor/odoo-editor/src/utils/utils','@web_editor/js/backend/convert_inline','@web/core/assets','@web/core/ensure_jquery','@odoo/owl','@web/core/utils/functions','@web/core/network/rpc','@web/views/fields/html/html_field','@web/core/utils/concurrency'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{QWebPlugin}=require('@web_editor/js/backend/QWebPlugin');const{TranslationButton}=require("@web/views/fields/translation_button");const{useDynamicPlaceholder}=require("@web/views/fields/dynamic_placeholder_hook");const{useBus,useSpellCheck}=require("@web/core/utils/hooks");const{getAdjacentPreviousSiblings,getAdjacentNextSiblings,getRangePosition}=require('@web_editor/js/editor/odoo-editor/src/utils/utils');const{toInline}=require('@web_editor/js/backend/convert_inline');const{getBundle,loadBundle}=require('@web/core/assets');const{ensureJQuery}=require('@web/core/ensure_jquery');const{Component,useRef,useState,onWillStart,onMounted,onWillUpdateProps,useEffect,onWillUnmount,status,}=require("@odoo/owl");const{uniqueId}=require('@web/core/utils/functions');const{rpc}=require("@web/core/network/rpc");require('@web/views/fields/html/html_field');const{Deferred}=require("@web/core/utils/concurrency");let stripHistoryIds;const HtmlField=__exports.HtmlField=class HtmlField extends Component{static template="web_editor.HtmlField";static components={TranslationButton,};static defaultProps={dynamicPlaceholder:false};static props={...standardFieldProps,placeholder:{type:String,optional:true},codeview:{type:Boolean,optional:true},isCollaborative:{type:Boolean,optional:true},dynamicPlaceholder:{type:Boolean,optional:true,default:false},dynamicPlaceholderModelReferenceField:{type:String,optional:true},cssReadonlyAssetId:{type:String,optional:true},isInlineStyle:{type:Boolean,optional:true},sandboxedPreview:{type:Boolean,optional:true},wrapper:{type:String,optional:true},wysiwygOptions:{type:Object},hasReadonlyModifiers:{type:Boolean,optional:true},};setup(){this.containsComplexHTML=this.computeContainsComplexHTML();this.sandboxedPreview=this.props.sandboxedPreview||this.containsComplexHTML;this.readonlyElementRef=useRef("readonlyElement");this.codeViewRef=useRef("codeView");this.iframeRef=useRef("iframe");this.codeViewButtonRef=useRef("codeViewButton");if(this.props.dynamicPlaceholder){this.dynamicPlaceholder=useDynamicPlaceholder();}
this.onIframeUpdated=this.env.onIframeUpdated||(()=>{});this.state=useState({showCodeView:false,iframeVisible:false,});const{model}=this.props.record;useBus(model.bus,"WILL_SAVE_URGENTLY",()=>this.commitChanges({urgent:true}));useBus(model.bus,"NEED_LOCAL_CHANGES",({detail})=>detail.proms.push(this.commitChanges({shouldInline:true})));useSpellCheck();this._onUpdateIframeId="onLoad_"+uniqueId("FieldHtml");onWillStart(async()=>{if(this.props.cssReadonlyAssetId){this.cssReadonlyAsset=await getBundle(this.props.cssReadonlyAssetId);}
await this._lazyloadWysiwyg();});this._lastRecordInfo={res_model:this.props.record.resModel,res_id:this.props.record.resId,};onWillUpdateProps((newProps)=>{if(!newProps.readonly&&!this.sandboxedPreview&&this.state.iframeVisible){this.state.iframeVisible=false;}
const newRecordInfo={res_model:newProps.record.resModel,res_id:newProps.record.resId,};if(JSON.stringify(this._lastRecordInfo)!==JSON.stringify(newRecordInfo)){this.currentEditingValue=undefined;}
this._lastRecordInfo=newRecordInfo;});useEffect(()=>{(async()=>{if(this._qwebPlugin){this._qwebPlugin.destroy();}
if(this.props.readonly||(!this.state.showCodeView&&this.sandboxedPreview)){if(this.showIframe){await this._setupReadonlyIframe();}else if(this.readonlyElementRef.el){this._qwebPlugin=new QWebPlugin();this._qwebPlugin.sanitizeElement(this.readonlyElementRef.el);retargetLinks(this.readonlyElementRef.el);const hasReadonlyModifiers=this.props.hasReadonlyModifiers;if(!hasReadonlyModifiers){const $el=$(this.readonlyElementRef.el);$el.off('.checklistBinding');$el.on('click.checklistBinding','ul.o_checklist > li',this._onReadonlyClickChecklist.bind(this));$el.on('click.checklistBinding','.o_stars .fa-star, .o_stars .fa-star-o',this._onReadonlyClickStar.bind(this));}}}else{const codeViewEl=this._getCodeViewEl();if(codeViewEl){codeViewEl.value=this.props.record.data[this.props.name];}}})();});onMounted(()=>{this.dynamicPlaceholder?.setElementRef(this.wysiwyg);});onWillUnmount(async()=>{if(!this.props.readonly&&this._isDirty()){await this.commitChanges();}
if(this._qwebPlugin){this._qwebPlugin.destroy();}
if(this.resizerHandleObserver){this.resizerHandleObserver.disconnect();}});}
computeContainsComplexHTML(){const domParser=new DOMParser();const parsedOriginal=domParser.parseFromString(this.props.record.data[this.props.name]||'','text/html');return!!parsedOriginal.head.innerHTML.trim();}
get isTranslatable(){return this.props.record.fields[this.props.name].translate;}
get markupValue(){return this.props.record.data[this.props.name];}
get showIframe(){return(this.sandboxedPreview&&!this.state.showCodeView)||(this.props.readonly&&this.props.cssReadonlyAssetId);}
get wysiwygOptions(){let dynamicPlaceholderOptions={};if(this.props.dynamicPlaceholder){dynamicPlaceholderOptions={powerboxItems:[{category:_t('Marketing Tools'),name:_t('Dynamic Placeholder'),priority:10,description:_t('Insert a field'),fontawesome:'fa-magic',callback:()=>{this.wysiwygRangePosition=getRangePosition(document.createElement('x'),this.wysiwyg.options.document||document);this.dynamicPlaceholder.updateModel(this.props.dynamicPlaceholderModelReferenceField);setTimeout(async()=>{await this.dynamicPlaceholder.open({validateCallback:this.onDynamicPlaceholderValidate.bind(this),closeCallback:this.onDynamicPlaceholderClose.bind(this),positionCallback:this.positionDynamicPlaceholder.bind(this),});});},}],powerboxFilters:[this._filterPowerBoxCommands.bind(this)],}}
const wysiwygOptions={...this.props.wysiwygOptions};const{sanitize_tags,sanitize}=this.props.record.fields[this.props.name];if(sanitize_tags||(sanitize_tags===undefined&&sanitize)){wysiwygOptions.allowCommandVideo=false;}
return{value:this.props.record.data[this.props.name],autostart:false,onAttachmentChange:this._onAttachmentChange.bind(this),onDblClickEditableMedia:this._onDblClickEditableMedia.bind(this),onWysiwygBlur:this._onWysiwygBlur.bind(this),...wysiwygOptions,...dynamicPlaceholderOptions,recordInfo:{res_model:this.props.record.resModel,res_id:this.props.record.resId,},collaborationChannel:this.props.isCollaborative&&{collaborationModelName:this.props.record.resModel,collaborationFieldName:this.props.name,collaborationResId:parseInt(this.props.record.resId),},fieldId:this.props.id,editorPlugins:[...(wysiwygOptions.editorPlugins||[]),QWebPlugin,this.MoveNodePlugin],record:this.props.record,};}
_filterPowerBoxCommands(commands){let selectionIsInForbidenSnippet=false;if(this.wysiwyg&&this.wysiwyg.odooEditor){const selection=this.wysiwyg.odooEditor.document.getSelection();selectionIsInForbidenSnippet=this.wysiwyg.closestElement(selection.anchorNode,'div[data-snippet="s_cover"], div[data-snippet="s_masonry_block"]');}
return selectionIsInForbidenSnippet?commands.filter((o)=>o.title!=="Dynamic Placeholder"):commands;}
getEditingValue(){const codeViewEl=this._getCodeViewEl();if(codeViewEl){return codeViewEl.value;}else{if(this.wysiwyg){return this.wysiwyg.getValue();}else{return null;}}}
async updateValue(){const value=this.getEditingValue();const lastValue=(this.props.record.data[this.props.name]||"").toString();if(value!==null&&!(!lastValue&&stripHistoryIds(value)==="<p><br></p>")&&stripHistoryIds(value)!==stripHistoryIds(lastValue)){this.props.record.model.bus.trigger("FIELD_IS_DIRTY",false);this.currentEditingValue=value;await this.props.record.update({[this.props.name]:value});}}
async startWysiwyg(wysiwyg){this.wysiwyg=wysiwyg;await this.wysiwyg.startEdition();wysiwyg.$editable[0].classList.add("odoo-editor-qweb");if(this.props.codeview){const $codeviewButtonToolbar=$(`
                <div id="codeview-btn-group" class="btn-group">
                    <button class="o_codeview_btn btn btn-primary">
                        <i class="fa fa-code"></i>
                    </button>
                </div>
            `);this.wysiwyg.toolbarEl.append($codeviewButtonToolbar[0]);$codeviewButtonToolbar.click(this.toggleCodeView.bind(this));}
this.wysiwyg.odooEditor.addEventListener("historyStep",()=>this.props.record.model.bus.trigger("FIELD_IS_DIRTY",this._isDirty()));if(this.props.isCollaborative){this.wysiwyg.odooEditor.addEventListener("onExternalHistorySteps",()=>this.props.record.model.bus.trigger("FIELD_IS_DIRTY",this._isDirty()));}
this.isRendered=true;}
toggleCodeView(){this.state.showCodeView=!this.state.showCodeView;if(this.wysiwyg){this.wysiwyg.odooEditor.observerUnactive('toggleCodeView');if(this.state.showCodeView){this.wysiwyg.$editable.remove();this.wysiwyg.odooEditor.toolbarHide();const value=this.wysiwyg.getValue();this.props.record.update({[this.props.name]:value});}else{this.wysiwyg.odooEditor.observerActive('toggleCodeView');}}
if(!this.state.showCodeView){const $codeview=$(this.codeViewRef.el);const value=$codeview.val();this.props.record.update({[this.props.name]:value});}}
onDynamicPlaceholderValidate(chain,defaultValue){if(chain){this.wysiwyg.focus();let dynamicPlaceholder="object."+chain;const t=document.createElement('T');t.setAttribute('t-out',dynamicPlaceholder);t.innerText=defaultValue;this.wysiwyg.odooEditor.execCommand('insert',t);this.wysiwyg.odooEditor.sanitize(t);}}
onDynamicPlaceholderClose(){this.wysiwyg.focus();}
positionDynamicPlaceholder(popover,position){const enoughSpaceBelow=window.innerHeight-popover.clientHeight-this.wysiwygRangePosition.top;let topPosition=(enoughSpaceBelow>0)?this.wysiwygRangePosition.top:this.wysiwygRangePosition.top+enoughSpaceBelow;let leftPosition=this.wysiwygRangePosition.left-14;const enoughSpaceRight=window.innerWidth-popover.clientWidth-leftPosition;leftPosition=(enoughSpaceRight>0)?leftPosition:leftPosition+enoughSpaceRight;popover.style.top=topPosition+'px';popover.style.left=leftPosition+'px';}
async commitChanges({urgent,shouldInline}={}){if(this.isCurrentlySaving&&!urgent){await this.isCurrentlySaving;}
if(this._isDirty()||urgent||(shouldInline&&this.props.isInlineStyle)){let savePendingImagesPromise,toInlinePromise;if(this.wysiwyg&&this.wysiwyg.odooEditor){if(!urgent){this.isCurrentlySaving=new Deferred();}
this.wysiwyg.odooEditor.observerUnactive('commitChanges');savePendingImagesPromise=this.wysiwyg.savePendingImages();if(this.props.isInlineStyle){toInlinePromise=this._toInline();}
if(urgent&&status(this)!=='destroyed'){await this.updateValue();}
await savePendingImagesPromise;const codeViewEl=this._getCodeViewEl();if(codeViewEl){codeViewEl.value=this.wysiwyg.getValue();}
if(this.props.isInlineStyle){await toInlinePromise;}
this.wysiwyg.odooEditor.observerActive('commitChanges');}
if(status(this)!=='destroyed'){await this.updateValue();}
if(this.isCurrentlySaving){this.isCurrentlySaving.resolve();}}}
async _lazyloadWysiwyg(){let wysiwygModule=await odoo.loader.modules.get('@web_editor/js/wysiwyg/wysiwyg');this.MoveNodePlugin=(await odoo.loader.modules.get('@web_editor/js/wysiwyg/MoveNodePlugin'))?.MoveNodePlugin;if(!wysiwygModule){await ensureJQuery();await loadBundle('web_editor.backend_assets_wysiwyg');wysiwygModule=await odoo.loader.modules.get('@web_editor/js/wysiwyg/wysiwyg');this.MoveNodePlugin=(await odoo.loader.modules.get('@web_editor/js/wysiwyg/MoveNodePlugin')).MoveNodePlugin;}
stripHistoryIds=wysiwygModule.stripHistoryIds;this.Wysiwyg=wysiwygModule.Wysiwyg;}
_isDirty(){const strippedPropValue=stripHistoryIds(String(this.props.record.data[this.props.name]));const strippedEditingValue=stripHistoryIds(this.getEditingValue());const domParser=new DOMParser();const codeViewEl=this._getCodeViewEl();let parsedPreviousValue;if(!codeViewEl&&this.wysiwyg){const editable=domParser.parseFromString(strippedPropValue||'<p><br></p>','text/html').body;const div=document.createElement('div');div.style.display='none';div.append(editable);document.body.append(div);const editableValue=stripHistoryIds(this.wysiwyg.getValue({$layout:$(editable)}));div.remove();parsedPreviousValue=domParser.parseFromString(editableValue,'text/html').body;}else{parsedPreviousValue=domParser.parseFromString(strippedPropValue||'<p><br></p>','text/html').body;}
const parsedNewValue=domParser.parseFromString(strippedEditingValue,'text/html').body;return!this.props.readonly&&parsedPreviousValue.innerHTML!==parsedNewValue.innerHTML;}
_getCodeViewEl(){return this.state.showCodeView&&this.codeViewRef.el;}
async _setupReadonlyIframe(){const iframeTarget=this.sandboxedPreview?this.iframeRef.el.contentDocument.documentElement:this.iframeRef.el.contentDocument.querySelector('#iframe_target');if(this.iframePromise&&iframeTarget){if(iframeTarget.innerHTML!==this.props.record.data[this.props.name]){iframeTarget.innerHTML=this.props.record.data[this.props.name];retargetLinks(iframeTarget);}
return this.iframePromise;}
this.iframePromise=new Promise((resolve)=>{let value=this.props.record.data[this.props.name];let avoidDoubleLoad=0;window.top[this._onUpdateIframeId]=(_avoidDoubleLoad)=>{if(_avoidDoubleLoad!==avoidDoubleLoad){console.warn('Wysiwyg iframe double load detected');return;}
resolve();this.state.iframeVisible=true;this.onIframeUpdated();};this.iframeRef.el.addEventListener('load',async()=>{const _avoidDoubleLoad=++avoidDoubleLoad;if(_avoidDoubleLoad!==avoidDoubleLoad){console.warn('Wysiwyg immediate iframe double load detected');return;}
const cwindow=this.iframeRef.el.contentWindow;try{cwindow.document;}catch{return;}
if(!this.sandboxedPreview){cwindow.document.open("text/html","replace").write('<!DOCTYPE html><html>'+'<head>'+'<meta charset="utf-8"/>'+'<meta http-equiv="X-UA-Compatible" content="IE=edge"/>\n'+'<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no"/>\n'+'</head>\n'+'<body class="o_in_iframe o_readonly" style="overflow: hidden;">\n'+'<div id="iframe_target"></div>\n'+'</body>'+'</html>');}
if(this.props.cssReadonlyAssetId){for(const cssLib of this.cssReadonlyAsset.cssLibs){const link=cwindow.document.createElement('link');link.setAttribute('type','text/css');link.setAttribute('rel','stylesheet');link.setAttribute('href',cssLib);cwindow.document.head.append(link);}}
if(!this.sandboxedPreview){const iframeTarget=cwindow.document.querySelector('#iframe_target');iframeTarget.innerHTML=value;const script=cwindow.document.createElement('script');script.setAttribute('type','text/javascript');const scriptTextNode=document.createTextNode(`if (window.top.${this._onUpdateIframeId}) {`+`window.top.${this._onUpdateIframeId}(${_avoidDoubleLoad})`+`}`);script.append(scriptTextNode);cwindow.document.body.append(script);}else{cwindow.document.documentElement.innerHTML=value;}
const height=cwindow.document.body.scrollHeight;this.iframeRef.el.style.height=Math.max(30,Math.min(height,500))+'px';retargetLinks(cwindow.document.body);if(this.sandboxedPreview){this.state.iframeVisible=true;this.onIframeUpdated();resolve();}});this.iframeRef.el.after(this.iframeRef.el);});return this.iframePromise;}
async _toInline(){const $editable=this.wysiwyg.getEditable();this.wysiwyg.odooEditor.sanitize(this.wysiwyg.odooEditor.editable);const html=this.wysiwyg.getValue();const $odooEditor=$editable.closest('.odoo-editor-editable');$odooEditor.removeClass('odoo-editor-editable');$editable.html(html);await toInline($editable,{$iframe:this.wysiwyg.$iframe,wysiwyg:this.wysiwyg});$odooEditor.addClass('odoo-editor-editable');this.wysiwyg.setValue($editable.html());this.wysiwyg.odooEditor.sanitize(this.wysiwyg.odooEditor.editable);}
_onAttachmentChange(attachment){if(!(this.props.record.fieldNames.includes('attachment_ids')&&this.props.record.resModel==='mail.compose.message')){return;}
this.props.record.data.attachment_ids.linkTo(attachment.id,attachment);}
_onDblClickEditableMedia(ev){const el=ev.currentTarget;if(el.nodeName==='IMG'&&el.src){this.wysiwyg.showImageFullscreen(el.src);}}
_onWysiwygBlur(){if(this.props.isInlineStyle){this.updateValue();}else{this.commitChanges();}}
async _onReadonlyClickChecklist(ev){if(ev.offsetX>0){return;}
ev.stopPropagation();ev.preventDefault();const checked=$(ev.target).hasClass('o_checked');let checklistId=$(ev.target).attr('id');checklistId=checklistId&&checklistId.replace('checkId-','');checklistId=parseInt(checklistId||'0');const value=await rpc('/web_editor/checklist',{res_model:this.props.record.resModel,res_id:this.props.record.resId,filename:this.props.name,checklistId:checklistId,checked:!checked,});if(value){this.props.record.update({[this.props.name]:value});}}
async _onReadonlyClickStar(ev){ev.stopPropagation();ev.preventDefault();const node=ev.target;const previousStars=getAdjacentPreviousSiblings(node,sib=>(sib.nodeType===Node.ELEMENT_NODE&&sib.className.includes('fa-star')));const nextStars=getAdjacentNextSiblings(node,sib=>(sib.nodeType===Node.ELEMENT_NODE&&sib.classList.contains('fa-star')));const shouldToggleOff=node.classList.contains('fa-star')&&!nextStars.length;const rating=shouldToggleOff?0:previousStars.length+1;let starsId=$(node).parent().attr('id');starsId=starsId&&starsId.replace('checkId-','');starsId=parseInt(starsId||'0');const value=await rpc('/web_editor/stars',{res_model:this.props.record.resModel,res_id:this.props.record.resId,filename:this.props.name,starsId,rating,});if(value){this.props.record.update({[this.props.name]:value});}}}
const htmlField=__exports.htmlField={component:HtmlField,displayName:_t("Html"),supportedOptions:[{label:_t("CSS Edit"),name:"cssEdit",type:"string"},{label:_t("Height"),name:"height",type:"string"},{label:_t("Min height"),name:"minHeight",type:"string"},{label:_t("Max height"),name:"maxHeight",type:"string"},{label:_t("Snippets"),name:"snippets",type:"string"},{label:_t("No videos"),name:"noVideos",type:"boolean",default:true},{label:_t("Resizable"),name:"resizable",type:"boolean",},{label:_t("Sandboxed preview"),name:"sandboxedPreview",type:"boolean",help:_t("With the option enabled, all content can only be viewed in a sandboxed iframe or in the code editor."),},{label:_t("Collaborative edition"),name:"collaborative",type:"boolean",},{label:_t("Collaborative trigger"),name:"collaborative_trigger",type:"selection",choices:[{label:_t("Focus"),value:"focus"},{label:_t("Start"),value:"start"},],default:"focus",help:_t("Specify when the collaboration starts. 'Focus' will start the collaboration session when the user clicks inside the text field (default), 'Start' when the record is loaded (could impact performance if set)."),},{label:_t("Codeview"),name:"codeview",type:"boolean",help:_t("Allow users to view and edit the field in HTML.")}],supportedTypes:["html"],extractProps({attrs,options},dynamicInfo){const wysiwygOptions={placeholder:attrs.placeholder,noAttachment:options['no-attachment'],inIframe:Boolean(options.cssEdit),iframeCssAssets:options.cssEdit,iframeHtmlClass:attrs.iframeHtmlClass,snippets:options.snippets,mediaModalParams:{noVideos:'noVideos'in options?options.noVideos:true,useMediaLibrary:true,},linkOptions:{forceNewWindow:true,},tabsize:0,height:options.height,minHeight:options.minHeight,maxHeight:options.maxHeight,resizable:'resizable'in options?options.resizable:false,};if('collaborative'in options){wysiwygOptions.collaborative=options.collaborative;wysiwygOptions.collaborativeTrigger=options.collaborative_trigger||'focus';}
if('style-inline'in options){wysiwygOptions.inlineStyle=Boolean(options['style-inline']);}
if('allowCommandImage'in options){wysiwygOptions.allowCommandImage=Boolean(options.allowCommandImage);}
if('allowCommandVideo'in options){wysiwygOptions.allowCommandVideo=Boolean(options.allowCommandVideo);}
return{codeview:Boolean(odoo.debug&&options.codeview),placeholder:attrs.placeholder,sandboxedPreview:Boolean(options.sandboxedPreview),isCollaborative:options.collaborative,cssReadonlyAssetId:options.cssReadonly,dynamicPlaceholder:options?.dynamic_placeholder||false,dynamicPlaceholderModelReferenceField:options?.dynamic_placeholder_model_reference_field||"",isInlineStyle:options['style-inline'],wysiwygOptions,hasReadonlyModifiers:dynamicInfo.readonly,};},additionalClasses:["o_field_html"],};registry.category("fields").add("html_legacy",htmlField,{force:true});const retargetLinks=(container)=>{for(const link of container.querySelectorAll('a')){link.setAttribute('target','_blank');link.setAttribute('rel','noreferrer');}}
return __exports;});;

/* /portal/static/src/views/fields/portal_wizard_user_one2many.js */
odoo.define('@portal/views/fields/portal_wizard_user_one2many',['@portal/views/list/portal_wizard_user_list_controller','@web/views/fields/x2many/x2many_field','@web/core/registry'],function(require){'use strict';let __exports={};const{PortalWizardUserListController}=require("@portal/views/list/portal_wizard_user_list_controller");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const{registry}=require("@web/core/registry");const PortalUserX2ManyField=__exports.PortalUserX2ManyField=class PortalUserX2ManyField extends X2ManyField{static components={...X2ManyField.components,Controller:PortalWizardUserListController,};}
const portalUserX2ManyField=__exports.portalUserX2ManyField={...x2ManyField,component:PortalUserX2ManyField,};registry.category("fields").add("portal_wizard_user_one2many",portalUserX2ManyField);return __exports;});;

/* /portal/static/src/views/list/portal_wizard_user_list_controller.js */
odoo.define('@portal/views/list/portal_wizard_user_list_controller',['@web/views/list/list_controller'],function(require){'use strict';let __exports={};const{ListController}=require("@web/views/list/list_controller");const PortalWizardUserListController=__exports.PortalWizardUserListController=class PortalWizardUserListController extends ListController{setup(){super.setup();this.isPortalActionOngoing=false;}
async beforeExecuteActionButton(clickParams){if(clickParams.name==='action_refresh_modal'||this.isPortalActionOngoing){return false;}
this.isPortalActionOngoing=true;return super.beforeExecuteActionButton(clickParams);}
async afterExecuteActionButton(clickParams){this.isPortalActionOngoing=false;}}
return __exports;});;

/* /resource/static/src/section_list_renderer.js */
odoo.define('@resource/section_list_renderer',['@web/views/list/list_renderer','@odoo/owl'],function(require){'use strict';let __exports={};const{ListRenderer}=require("@web/views/list/list_renderer");const{useEffect}=require("@odoo/owl");const SectionListRenderer=__exports.SectionListRenderer=class SectionListRenderer extends ListRenderer{setup(){super.setup();this.displayType="line_section";this.titleField="title";useEffect((table)=>{if(table){table.classList.add("o_section_list_view");}},()=>[this.tableRef.el]);}
getColumns(record){const columns=super.getColumns(record);if(this.isSection(record)){return this.getSectionColumns(columns);}
return columns;}
getRowClass(record){const classNames=super.getRowClass(record).split(" ");if(this.isSection(record)){classNames.push(`o_is_${this.displayType}`,`fw-bold`);}
return classNames.join(" ");}
getSectionColumns(columns){const sectionColumns=columns.filter((col)=>col.widget==="handle");let colspan=columns.length-sectionColumns.length;if(this.activeActions.onDelete){colspan++;}
const titleCol=columns.find((col)=>col.type==="field"&&col.name===this.titleField);sectionColumns.push({...titleCol,colspan});return sectionColumns;}
isSection(record){return record.data.display_type===this.displayType;}}
SectionListRenderer.recordRowTemplate="resource.SectionListRenderer.RecordRow";return __exports;});;

/* /resource/static/src/section_one2many_field.js */
odoo.define('@resource/section_one2many_field',['@resource/section_list_renderer','@web/core/registry','@web/views/fields/x2many/x2many_field'],function(require){'use strict';let __exports={};const{SectionListRenderer}=require("@resource/section_list_renderer");const{registry}=require("@web/core/registry");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");class SectionOneToManyField extends X2ManyField{static components={...X2ManyField.components,ListRenderer:SectionListRenderer,};static defaultProps={...X2ManyField.defaultProps,editable:"bottom",};}
registry.category("fields").add("section_one2many",{...x2ManyField,component:SectionOneToManyField,additionalClasses:[...x2ManyField.additionalClasses||[],"o_field_one2many"],});return __exports;});;

/* /resource/static/src/views/form_with_html_expander/form_controller_with_html_expander.js */
odoo.define('@resource/views/form_with_html_expander/form_controller_with_html_expander',['@odoo/owl','@web/views/form/form_controller'],function(require){'use strict';let __exports={};const{useState}=require("@odoo/owl");const{FormController}=require("@web/views/form/form_controller");const FormControllerWithHTMLExpander=__exports.FormControllerWithHTMLExpander=class FormControllerWithHTMLExpander extends FormController{static template="resource.FormViewWithHtmlExpander";setup(){super.setup();this.htmlExpanderState=useState({reload:true});const oldOnNotebookPageChange=this.onNotebookPageChange;this.onNotebookPageChange=(notebookId,page)=>{oldOnNotebookPageChange(notebookId,page);if(page&&!this.htmlExpanderState.reload){this.htmlExpanderState.reload=true;}};}
get modelParams(){const modelParams=super.modelParams;const onRootLoaded=modelParams.hooks.onRootLoaded;modelParams.hooks.onRootLoaded=async()=>{if(onRootLoaded){onRootLoaded();}
this.htmlExpanderState.reload=true;};return modelParams;}
notifyHTMLFieldExpanded(){this.htmlExpanderState.reload=false;}
async onRecordSaved(record,changes){super.onRecordSaved(record,changes);this.htmlExpanderState.reload=true;}}
return __exports;});;

/* /resource/static/src/views/form_with_html_expander/form_renderer_with_html_expander.js */
odoo.define('@resource/views/form_with_html_expander/form_renderer_with_html_expander',['@web/core/utils/hooks','@web/views/form/form_renderer','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{FormRenderer}=require("@web/views/form/form_renderer");const{useRef,useEffect}=require("@odoo/owl");const FormRendererWithHtmlExpander=__exports.FormRendererWithHtmlExpander=class FormRendererWithHtmlExpander extends FormRenderer{static props={...FormRenderer.props,reloadHtmlFieldHeight:{type:Boolean,optional:true},notifyHtmlExpander:{type:Function,optional:true},};static defaultProps={...FormRenderer.defaultProps,reloadHtmlFieldHeight:true,notifyHtmlExpander:()=>{},};setup(){super.setup();if(!this.uiService){this.uiService=useService("ui");}
const ref=useRef("compiled_view_root");useEffect((el,size)=>{if(el&&this._canExpandHTMLField(size)){const descriptionField=el.querySelector(this.htmlFieldQuerySelector);if(descriptionField){const containerEL=descriptionField.closest(this.getHTMLFieldContainerQuerySelector);const editor=descriptionField.querySelector(".note-editable");const elementToResize=editor||descriptionField;const{top,bottom}=elementToResize.getBoundingClientRect();const{bottom:containerBottom}=containerEL.getBoundingClientRect();const{paddingTop,paddingBottom}=window.getComputedStyle(containerEL);const nonEditableHeight=containerBottom-
bottom+
parseInt(paddingTop)+
parseInt(paddingBottom);const minHeight=document.documentElement.clientHeight-top-nonEditableHeight;elementToResize.style.minHeight=`${minHeight}px`;}}
this.props.notifyHtmlExpander();},()=>[ref.el,this.uiService.size,this.props.reloadHtmlFieldHeight]);}
get htmlFieldQuerySelector(){return".o_field_html[name=description]";}
get getHTMLFieldContainerQuerySelector(){return".o_form_sheet";}
_canExpandHTMLField(size){return size===6;}}
return __exports;});;

/* /resource/static/src/views/form_with_html_expander/form_view_with_html_expander.js */
odoo.define('@resource/views/form_with_html_expander/form_view_with_html_expander',['@web/core/registry','@web/views/form/form_view','@resource/views/form_with_html_expander/form_renderer_with_html_expander','@resource/views/form_with_html_expander/form_controller_with_html_expander'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");const{FormRendererWithHtmlExpander}=require("@resource/views/form_with_html_expander/form_renderer_with_html_expander");const{FormControllerWithHTMLExpander}=require("@resource/views/form_with_html_expander/form_controller_with_html_expander");const formViewWithHtmlExpander=__exports.formViewWithHtmlExpander={...formView,Controller:FormControllerWithHTMLExpander,Renderer:FormRendererWithHtmlExpander,};registry.category("views").add("form_description_expander",formViewWithHtmlExpander);return __exports;});;

/* /account/static/src/components/account_batch_sending_summary/account_batch_sending_summary.js */
odoo.define('@account/components/account_batch_sending_summary/account_batch_sending_summary',['@odoo/owl','@web/core/registry','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const AccountBatchSendingSummary=__exports.AccountBatchSendingSummary=class AccountBatchSendingSummary extends Component{static template="account.BatchSendingSummary";static props={...standardFieldProps,};setup(){super.setup();this.data=this.props.record.data[this.props.name];}}
const accountBatchSendingSummary=__exports.accountBatchSendingSummary={component:AccountBatchSendingSummary,}
registry.category("fields").add("account_batch_sending_summary",accountBatchSendingSummary);return __exports;});;

/* /account/static/src/components/account_file_uploader/account_file_uploader.js */
odoo.define('@account/components/account_file_uploader/account_file_uploader',['@web/core/l10n/translation','@web/core/registry','@account/components/document_file_uploader/document_file_uploader'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{DocumentFileUploader}=require("@account/components/document_file_uploader/document_file_uploader");const AccountFileUploader=__exports.AccountFileUploader=class AccountFileUploader extends DocumentFileUploader{static template="account.AccountFileUploader";static props={...DocumentFileUploader.props,btnClass:{type:String,optional:true},linkText:{type:String,optional:true},togglerTemplate:{type:String,optional:true},};getExtraContext(){const extraContext=super.getExtraContext();const record_data=this.props.record?this.props.record.data:false;return record_data?{...extraContext,default_journal_id:record_data.id,default_move_type:((record_data.type==='sale'&&'out_invoice')||(record_data.type==='purchase'&&'in_invoice')||'entry'),}:extraContext;}
getResModel(){return"account.journal";}}
const accountFileUploader=__exports.accountFileUploader={component:AccountFileUploader,extractProps:({attrs})=>({togglerTemplate:attrs.template||"account.JournalUploadLink",btnClass:attrs.btnClass||"",linkText:attrs.title||_t("Upload"),}),fieldDependencies:[{name:"id",type:"integer"},{name:"type",type:"selection"},],};registry.category("view_widgets").add("account_file_uploader",accountFileUploader);return __exports;});;

/* /account/static/src/components/account_many2one_barcode/account_many2one_barcode.js */
odoo.define('@account/components/account_many2one_barcode/account_many2one_barcode',['@web/core/registry','@web/views/fields/many2one_barcode/many2one_barcode_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Many2OneBarcodeField,many2OneBarcodeField}=require("@web/views/fields/many2one_barcode/many2one_barcode_field");const AccountMany2oneBarcode=__exports.AccountMany2oneBarcode=class AccountMany2oneBarcode extends Many2OneBarcodeField{get hasExternalButton(){const res=super.hasExternalButton;return res||(!!this.props.record.data[this.props.name]&&!this.state.isFloating);}}
registry.category("fields").add("account_many2one_barcode",{...many2OneBarcodeField,component:AccountMany2oneBarcode,});return __exports;});;

/* /account/static/src/components/account_merge_wizard_line_one2many/account_merge_wizard_line_one2many.js */
odoo.define('@account/components/account_merge_wizard_line_one2many/account_merge_wizard_line_one2many',['@web/core/registry','@account/components/section_and_note_fields_backend/section_and_note_fields_backend'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{SectionAndNoteListRenderer,SectionAndNoteFieldOne2Many,sectionAndNoteFieldOne2Many,}=require("@account/components/section_and_note_fields_backend/section_and_note_fields_backend");const AccountMergeWizardLinesRenderer=__exports.AccountMergeWizardLinesRenderer=class AccountMergeWizardLinesRenderer extends SectionAndNoteListRenderer{setup(){super.setup();this.titleField="info";}
getCellClass(column,record){const classNames=super.getCellClass(column,record);if(this.isSectionOrNote(record)&&column.name==="is_selected"){return classNames.replace(" o_hidden","");}
return classNames;}
getSectionColumns(columns){const sectionCols=columns.filter((col)=>col.type==="field"&&(col.name===this.titleField||col.name==="is_selected"));return sectionCols.map((col)=>{if(col.name===this.titleField){return{...col,colspan:columns.length-sectionCols.length+1};}else{return{...col};}});}
isSortable(column){return false;}}
const AccountMergeWizardLinesOne2Many=__exports.AccountMergeWizardLinesOne2Many=class AccountMergeWizardLinesOne2Many extends SectionAndNoteFieldOne2Many{static components={...SectionAndNoteFieldOne2Many.components,ListRenderer:AccountMergeWizardLinesRenderer,};}
const accountMergeWizardLinesOne2Many=__exports.accountMergeWizardLinesOne2Many={...sectionAndNoteFieldOne2Many,component:AccountMergeWizardLinesOne2Many,};registry.category("fields").add("account_merge_wizard_lines_one2many",accountMergeWizardLinesOne2Many);return __exports;});;

/* /account/static/src/components/account_move_form/account_move_form.js */
odoo.define('@account/components/account_move_form/account_move_form',['@web/core/registry','@web/core/utils/xml','@web/core/notebook/notebook','@web/views/form/form_view','@web/views/form/form_compiler','@web/views/form/form_renderer','@web/views/form/form_controller','@web/core/utils/hooks','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{createElement,append}=require("@web/core/utils/xml");const{Notebook}=require("@web/core/notebook/notebook");const{formView}=require("@web/views/form/form_view");const{FormCompiler}=require("@web/views/form/form_compiler");const{FormRenderer}=require("@web/views/form/form_renderer");const{FormController}=require('@web/views/form/form_controller');const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const AccountMoveFormController=__exports.AccountMoveFormController=class AccountMoveFormController extends FormController{setup(){super.setup();this.account_move_service=useService("account_move");}
get cogMenuProps(){return{...super.cogMenuProps,printDropdownTitle:_t("Download"),loadExtraPrintItems:this.loadExtraPrintItems.bind(this),};}
async loadExtraPrintItems(){if(!this.model.root.isNew){return[]}
return this.orm.call("account.move","get_extra_print_items",[this.model.root.resId]);}
async deleteRecord(){if(!await this.account_move_service.addDeletionDialog(this,this.model.root.resId)){return super.deleteRecord(...arguments);}}}
const AccountMoveFormNotebook=__exports.AccountMoveFormNotebook=class AccountMoveFormNotebook extends Notebook{static template="account.AccountMoveFormNotebook";static props={...Notebook.props,onBeforeTabSwitch:{type:Function,optional:true},};async changeTabTo(page_id){if(this.props.onBeforeTabSwitch){await this.props.onBeforeTabSwitch(page_id);}
this.state.currentPage=page_id;}}
const AccountMoveFormRenderer=__exports.AccountMoveFormRenderer=class AccountMoveFormRenderer extends FormRenderer{static components={...FormRenderer.components,AccountMoveFormNotebook:AccountMoveFormNotebook,};async saveBeforeTabChange(){if(this.props.record.isInEdition&&await this.props.record.isDirty()){const contentEl=document.querySelector('.o_content');const scrollPos=contentEl.scrollTop;await this.props.record.save();if(scrollPos){contentEl.scrollTop=scrollPos;}}}}
const AccountMoveFormCompiler=__exports.AccountMoveFormCompiler=class AccountMoveFormCompiler extends FormCompiler{compileNotebook(el,params){const originalNoteBook=super.compileNotebook(...arguments);const noteBook=createElement("AccountMoveFormNotebook");for(const attr of originalNoteBook.attributes){noteBook.setAttribute(attr.name,attr.value);}
noteBook.setAttribute("onBeforeTabSwitch","() => __comp__.saveBeforeTabChange()");const slots=originalNoteBook.childNodes;append(noteBook,[...slots]);return noteBook;}}
const AccountMoveFormView=__exports.AccountMoveFormView={...formView,Renderer:AccountMoveFormRenderer,Compiler:AccountMoveFormCompiler,Controller:AccountMoveFormController,};registry.category("views").add("account_move_form",AccountMoveFormView);return __exports;});;

/* /account/static/src/components/account_payment_field/account_payment_field.js */
odoo.define('@account/components/account_payment_field/account_payment_field',['@web/core/l10n/translation','@web/core/registry','@web/core/popover/popover_hook','@web/core/utils/hooks','@web/core/l10n/localization','@web/core/l10n/dates','@web/views/fields/formatters','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{usePopover}=require("@web/core/popover/popover_hook");const{useService}=require("@web/core/utils/hooks");const{localization}=require("@web/core/l10n/localization");const{formatDate,deserializeDate}=require("@web/core/l10n/dates");const{formatMonetary}=require("@web/views/fields/formatters");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");class AccountPaymentPopOver extends Component{static props={"*":{optional:true}};static template="account.AccountPaymentPopOver";}
const AccountPaymentField=__exports.AccountPaymentField=class AccountPaymentField extends Component{static props={...standardFieldProps};static template="account.AccountPaymentField";setup(){const position=localization.direction==="rtl"?"bottom":"left";this.popover=usePopover(AccountPaymentPopOver,{position});this.orm=useService("orm");this.action=useService("action");}
getInfo(){const info=this.props.record.data[this.props.name]||{content:[],outstanding:false,title:"",move_id:this.props.record.resId,};for(const[key,value]of Object.entries(info.content)){value.index=key;value.amount_formatted=formatMonetary(value.amount,{currencyId:value.currency_id,});if(value.date){value.formattedDate=formatDate(deserializeDate(value.date))}}
return{lines:info.content,outstanding:info.outstanding,title:info.title,moveId:info.move_id,};}
onInfoClick(ev,line){this.popover.open(ev.currentTarget,{title:_t("Journal Entry Info"),...line,_onRemoveMoveReconcile:this.removeMoveReconcile.bind(this),_onOpenMove:this.openMove.bind(this),});}
async assignOutstandingCredit(moveId,id){await this.orm.call(this.props.record.resModel,'js_assign_outstanding_line',[moveId,id],{});await this.props.record.model.root.load();}
async removeMoveReconcile(moveId,partialId){this.popover.close();await this.orm.call(this.props.record.resModel,'js_remove_outstanding_partial',[moveId,partialId],{});await this.props.record.model.root.load();}
async openMove(moveId){const action=await this.orm.call(this.props.record.resModel,'action_open_business_doc',[moveId],{});this.action.doAction(action);}}
const accountPaymentField=__exports.accountPaymentField={component:AccountPaymentField,supportedTypes:["char"],};registry.category("fields").add("payment",accountPaymentField);return __exports;});;

/* /account/static/src/components/account_payment_register_html/account_payment_register_html.js */
odoo.define('@account/components/account_payment_register_html/account_payment_register_html',['@web_editor/js/backend/html_field','@web/core/registry'],function(require){'use strict';let __exports={};const{HtmlField,htmlField}=require("@web_editor/js/backend/html_field");const{registry}=require("@web/core/registry");const AccountPaymentRegisterHtmlField=__exports.AccountPaymentRegisterHtmlField=class AccountPaymentRegisterHtmlField extends HtmlField{static template="account.AccountPaymentRegisterHtmlField";async switchInstallmentsAmount(ev){if(ev.srcElement.classList.contains("installments_switch_button")){const root=this.env.model.root;await root.update({amount:root.data.installments_switch_amount});}}}
const accountPaymentRegisterHtmlField=__exports.accountPaymentRegisterHtmlField={...htmlField,component:AccountPaymentRegisterHtmlField,};registry.category("fields").add("account_payment_register_html",accountPaymentRegisterHtmlField);return __exports;});;

/* /account/static/src/components/account_payment_term_form/payment_term_line_ids.js */
odoo.define('@account/components/account_payment_term_form/payment_term_line_ids',['@web/core/registry','@web/views/fields/x2many/x2many_field','@web/views/fields/relational_utils'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const{useAddInlineRecord}=require("@web/views/fields/relational_utils");const PaymentTermLineIdsOne2Many=__exports.PaymentTermLineIdsOne2Many=class PaymentTermLineIdsOne2Many extends X2ManyField{setup(){super.setup();this.addInLine=useAddInlineRecord({addNew:async(...args)=>{const newRecord=await this.list.addNewRecord(...args);newRecord.update({});}});}}
const PaymentTermLineIds=__exports.PaymentTermLineIds={...x2ManyField,component:PaymentTermLineIdsOne2Many,}
registry.category("fields").add("payment_term_line_ids",PaymentTermLineIds);return __exports;});;

/* /account/static/src/components/account_resequence/account_resequence_field.js */
odoo.define('@account/components/account_resequence/account_resequence_field',['@web/core/registry','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Component}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");class ChangeLine extends Component{static template="account.ResequenceChangeLine";static props=["changeLine","ordering"];}
class ShowResequenceRenderer extends Component{static template="account.ResequenceRenderer";static components={ChangeLine};static props={...standardFieldProps};getValue(){const value=this.props.record.data[this.props.name];return value?JSON.parse(value):{changeLines:[],ordering:"date"};}}
registry.category("fields").add("account_resequence_widget",{component:ShowResequenceRenderer,});return __exports;});;

/* /account/static/src/components/account_statusbar_secured/account_move_statusbar_secured.js */
odoo.define('@account/components/account_statusbar_secured/account_move_statusbar_secured',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/statusbar/statusbar_field'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{statusBarField,StatusBarField}=require("@web/views/fields/statusbar/statusbar_field");const AccountMoveStatusBarSecuredField=__exports.AccountMoveStatusBarSecuredField=class AccountMoveStatusBarSecuredField extends StatusBarField{static template="account.MoveStatusBarSecuredField";get isSecured(){return this.props.record.data['secured'];}
get currentItem(){return this.getAllItems().find((item)=>item.isSelected);}}
const accountMoveStatusBarSecuredField=__exports.accountMoveStatusBarSecuredField={...statusBarField,component:AccountMoveStatusBarSecuredField,displayName:_t("Status with secured indicator for Journal Entries"),supportedTypes:["state"],additionalClasses:["o_field_statusbar"],};registry.category("fields").add("account_move_statusbar_secured",accountMoveStatusBarSecuredField);return __exports;});;

/* /account/static/src/components/account_type_selection/account_type_selection.js */
odoo.define('@account/components/account_type_selection/account_type_selection',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/selection/selection_field'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{SelectionField,selectionField}=require("@web/views/fields/selection/selection_field");const AccountTypeSelection=__exports.AccountTypeSelection=class AccountTypeSelection extends SelectionField{static template="account.AccountTypeSelection";get hierarchyOptions(){const opts=this.options;return[{name:_t('Balance Sheet')},{name:_t('Assets'),children:opts.filter(x=>x[0]&&x[0].startsWith('asset'))},{name:_t('Liabilities'),children:opts.filter(x=>x[0]&&x[0].startsWith('liability'))},{name:_t('Equity'),children:opts.filter(x=>x[0]&&x[0].startsWith('equity'))},{name:_t('Profit & Loss')},{name:_t('Income'),children:opts.filter(x=>x[0]&&x[0].startsWith('income'))},{name:_t('Expense'),children:opts.filter(x=>x[0]&&x[0].startsWith('expense'))},{name:_t('Other'),children:opts.filter(x=>x[0]&&x[0]==='off_balance')},];}}
const accountTypeSelection=__exports.accountTypeSelection={...selectionField,component:AccountTypeSelection,};registry.category("fields").add("account_type_selection",accountTypeSelection);return __exports;});;

/* /account/static/src/components/actionable_errors/actionable_errors.js */
odoo.define('@account/components/actionable_errors/actionable_errors',['@web/core/registry','@odoo/owl','@web/views/fields/standard_field_props','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Component}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{useService}=require("@web/core/utils/hooks");const WARNING_TYPE_ORDER=["danger","warning","info"];const ActionableErrors=__exports.ActionableErrors=class ActionableErrors extends Component{static props={errorData:{type:Object}};static template="account.ActionableErrors";setup(){super.setup();this.actionService=useService("action");}
get errorData(){return this.props.errorData;}
async handleOnClick(errorData){if(errorData.action?.view_mode){errorData.action['views']=errorData.action.view_mode.split(',').map(mode=>[false,mode]);delete errorData.action['view_mode'];}
this.env.model.action.doAction(errorData.action);}
get sortedActionableErrors(){return this.errorData&&Object.fromEntries(Object.entries(this.errorData).sort((a,b)=>WARNING_TYPE_ORDER.indexOf(a[1]["level"]||"warning")-
WARNING_TYPE_ORDER.indexOf(b[1]["level"]||"warning"),),);}}
const ActionableErrorsField=__exports.ActionableErrorsField=class ActionableErrorsField extends ActionableErrors{static props={...standardFieldProps};get errorData(){return this.props.record.data[this.props.name];}}
const actionableErrorsField=__exports.actionableErrorsField={component:ActionableErrorsField};registry.category("fields").add("actionable_errors",actionableErrorsField);return __exports;});;

/* /account/static/src/components/auto_save_res_partner_bank/auto_save_res_partner_bank.js */
odoo.define('@account/components/auto_save_res_partner_bank/auto_save_res_partner_bank',['@web/core/registry','@web/views/fields/x2many/x2many_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const AutoSaveResPartnerField=__exports.AutoSaveResPartnerField=class AutoSaveResPartnerField extends X2ManyField{async onAdd({context,editable}={}){await this.props.record.model.root.save();await super.onAdd({context,editable});}}
const autoSaveResPartnerField=__exports.autoSaveResPartnerField={...x2ManyField,component:AutoSaveResPartnerField,};registry.category("fields").add("auto_save_res_partner",autoSaveResPartnerField);return __exports;});;

/* /account/static/src/components/autosave_many2many_tags/autosave_many2many_tags.js */
odoo.define('@account/components/autosave_many2many_tags/autosave_many2many_tags',['@web/core/registry','@web/model/relational_model/utils','@web/views/fields/many2many_tags/many2many_tags_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useRecordObserver}=require("@web/model/relational_model/utils");const{Many2ManyTagsField,many2ManyTagsField}=require("@web/views/fields/many2many_tags/many2many_tags_field");const AutosaveMany2ManyTagsField=__exports.AutosaveMany2ManyTagsField=class AutosaveMany2ManyTagsField extends Many2ManyTagsField{setup(){super.setup();this.lastBalance=this.props.record.data.balance;this.lastAccount=this.props.record.data.account_id;this.lastPartner=this.props.record.data.partner_id;const super_update=this.update;this.update=(recordlist)=>{super_update(recordlist);this._saveOnUpdate();};useRecordObserver(this.onRecordChange.bind(this));}
async deleteTag(id){await super.deleteTag(id);await this._saveOnUpdate();}
onRecordChange(record){const line=record.data;if(line.tax_ids.records.length>0){if(line.balance!==this.lastBalance||line.account_id[0]!==this.lastAccount[0]||line.partner_id[0]!==this.lastPartner[0]){this.lastBalance=line.balance;this.lastAccount=line.account_id;this.lastPartner=line.partner_id;return record.model.root.save();}}}
async _saveOnUpdate(){await this.props.record.model.root.save();}}
const autosaveMany2ManyTagsField=__exports.autosaveMany2ManyTagsField={...many2ManyTagsField,component:AutosaveMany2ManyTagsField,};registry.category("fields").add("autosave_many2many_tags",autosaveMany2ManyTagsField);return __exports;});;

/* /account/static/src/components/bill_guide/bill_guide.js */
odoo.define('@account/components/bill_guide/bill_guide',['@web/core/registry','@web/core/utils/hooks','@account/components/document_file_uploader/document_file_uploader','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{DocumentFileUploader}=require("@account/components/document_file_uploader/document_file_uploader");const{Component,onWillStart}=require("@odoo/owl");const BillGuide=__exports.BillGuide=class BillGuide extends Component{static template="account.BillGuide";static components={DocumentFileUploader,};static props=["*"];setup(){this.orm=useService("orm");this.action=useService("action");this.context=null;this.alias=null;onWillStart(this.onWillStart);}
async onWillStart(){const rec=this.props.record;const ctx=this.env.searchModel.context;if(rec){this.context={default_journal_id:rec.resId,default_move_type:(rec.data.type==='sale'&&'out_invoice')||(rec.data.type==='purchase'&&'in_invoice')||'entry',active_model:rec.resModel,active_ids:[rec.resId],}
this.alias=rec.data.alias_domain_id&&rec.data.alias_id[1]||false;}else if(!ctx?.default_journal_id&&ctx?.active_id){this.context={default_journal_id:ctx.active_id,}}}
handleButtonClick(action,model="account.journal"){this.action.doActionButton({resModel:model,name:action,context:this.context||this.env.searchModel.context,type:'object',});}}
const billGuide=__exports.billGuide={component:BillGuide,};registry.category("view_widgets").add("bill_upload_guide",billGuide);return __exports;});;

/* /account/static/src/components/char_with_placeholder_field/char_with_placeholder_field.js */
odoo.define('@account/components/char_with_placeholder_field/char_with_placeholder_field',['@web/core/registry','@web/views/fields/char/char_field','@mail/js/onchange_on_keydown'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{CharField,charField}=require("@web/views/fields/char/char_field");require("@mail/js/onchange_on_keydown");const CharWithPlaceholderField=__exports.CharWithPlaceholderField=class CharWithPlaceholderField extends CharField{static template="account.CharWithPlaceholderField";get formattedValue(){return super.formattedValue||this.placeholder;}}
const charWithPlaceholderField=__exports.charWithPlaceholderField={...charField,component:CharWithPlaceholderField,};registry.category("fields").add("char_with_placeholder_field",charWithPlaceholderField);return __exports;});;

/* /account/static/src/components/document_file_uploader/document_file_uploader.js */
odoo.define('@account/components/document_file_uploader/document_file_uploader',['@web/core/utils/hooks','@web/views/fields/file_handler','@web/views/widgets/standard_widget_props','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{FileUploader}=require("@web/views/fields/file_handler");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{Component,markup}=require("@odoo/owl");const DocumentFileUploader=__exports.DocumentFileUploader=class DocumentFileUploader extends Component{static template="account.DocumentFileUploader";static components={FileUploader,};static props={...standardWidgetProps,record:{type:Object,optional:true},slots:{type:Object,optional:true},resModel:{type:String,optional:true},};setup(){this.orm=useService("orm");this.action=useService("action");this.notification=useService("notification");this.attachmentIdsToProcess=[];this.extraContext=this.getExtraContext();}
getExtraContext(){return{};}
async onFileUploaded(file){const att_data={name:file.name,mimetype:file.type,datas:file.data,};const[att_id]=await this.orm.create("ir.attachment",[att_data],{context:{...this.extraContext,...this.env.searchModel.context},});this.attachmentIdsToProcess.push(att_id);}
getResModel(){return this.props.resModel;}
async onUploadComplete(){const resModal=this.getResModel();let action;try{action=await this.orm.call(resModal,"create_document_from_attachment",["",this.attachmentIdsToProcess],{context:{...this.extraContext,...this.env.searchModel.context}});}finally{this.attachmentIdsToProcess=[];}
if(action.context&&action.context.notifications){for(const[file,msg]of Object.entries(action.context.notifications)){this.notification.add(msg,{title:file,type:"info",sticky:true,});}
delete action.context.notifications;}
if(action.help?.length){action.help=markup(action.help);}
this.action.doAction(action);}}
return __exports;});;

/* /account/static/src/components/document_state/document_state_field.js */
odoo.define('@account/components/document_state/document_state_field',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/views/fields/selection/selection_field','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{SelectionField,selectionField}=require("@web/views/fields/selection/selection_field");const{Component}=require("@odoo/owl");const DocumentStatePopover=__exports.DocumentStatePopover=class DocumentStatePopover extends Component{static template="account.DocumentStatePopover";static props={close:Function,onClose:Function,copyText:Function,message:String,};}
const DocumentState=__exports.DocumentState=class DocumentState extends SelectionField{static template="account.DocumentState";setup(){super.setup();this.popover=useService("popover");this.notification=useService("notification");}
get message(){return this.props.record.data.message;}
copyText(){navigator.clipboard.writeText(this.message);this.notification.add(_t("Text copied"),{type:"success"});this.popoverCloseFn();this.popoverCloseFn=null;}
showMessagePopover(ev){const close=()=>{this.popoverCloseFn();this.popoverCloseFn=null;};if(this.popoverCloseFn){close();return;}
this.popoverCloseFn=this.popover.add(ev.currentTarget,DocumentStatePopover,{message:this.message,copyText:this.copyText.bind(this),onClose:close,},{closeOnClickAway:true,position:"top",},);}}
registry.category("fields").add("account_document_state",{...selectionField,component:DocumentState,});return __exports;});;

/* /account/static/src/components/dynamic_selection/dynamic_selection.js */
odoo.define('@account/components/dynamic_selection/dynamic_selection',['@web/core/registry','@web/views/fields/selection/selection_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{SelectionField,selectionField}=require("@web/views/fields/selection/selection_field");const DynamicSelectionField=__exports.DynamicSelectionField=class DynamicSelectionField extends SelectionField{static props={...SelectionField.props,available_field:{type:String},}
get availableOptions(){return this.props.record.data[this.props.available_field]?.split(",")||[];}
get options(){const availableOptions=this.availableOptions;return super.options.filter(x=>availableOptions.includes(x[0]));}
get string(){if(this.type==="selection"){return this.props.record.data[this.props.name]!==false?this.options.find((o)=>o[0]===this.props.record.data[this.props.name])?.[1]:"";}
return super.string;}}
registry.category("fields").add("dynamic_selection",{...selectionField,component:DynamicSelectionField,extractProps:(fieldInfo,dynamicInfo)=>({...selectionField.extractProps(fieldInfo,dynamicInfo),available_field:fieldInfo.options.available_field,}),})
return __exports;});;

/* /account/static/src/components/grouped_view_widget/grouped_view_widget.js */
odoo.define('@account/components/grouped_view_widget/grouped_view_widget',['@web/core/registry','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Component}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");class ListItem extends Component{static template="account.GroupedItemTemplate";static props=["item_vals","options"];}
class ListGroup extends Component{static template="account.GroupedItemsTemplate";static components={ListItem};static props=["group_vals","options"];}
class ShowGroupedList extends Component{static template="account.GroupedListTemplate";static components={ListGroup};static props={...standardFieldProps};getValue(){const value=this.props.record.data[this.props.name];return value?JSON.parse(value):{groups_vals:[],options:{discarded_number:"",columns:[]}};}}
registry.category("fields").add("grouped_view_widget",{component:ShowGroupedList,});return __exports;});;

/* /account/static/src/components/journal_dashboard_activity/journal_dashboard_activity.js */
odoo.define('@account/components/journal_dashboard_activity/journal_dashboard_activity',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const JournalDashboardActivity=__exports.JournalDashboardActivity=class JournalDashboardActivity extends Component{static template="account.JournalDashboardActivity";static props={...standardFieldProps};setup(){this.action=useService("action");this.MAX_ACTIVITY_DISPLAY=5;this.formatData(this.props);}
formatData(props){this.info=JSON.parse(this.props.record.data[this.props.name]);this.info.more_activities=false;if(this.info.activities.length>this.MAX_ACTIVITY_DISPLAY){this.info.more_activities=true;this.info.activities=this.info.activities.slice(0,this.MAX_ACTIVITY_DISPLAY);}}
async openActivity(activity){this.action.doAction({type:'ir.actions.act_window',name:_t('Journal Entry'),target:'current',res_id:activity.res_id,res_model:'account.move',views:[[false,'form']],});}
openAllActivities(e){this.action.doAction({type:'ir.actions.act_window',name:_t('Journal Entries'),res_model:'account.move',views:[[false,'kanban'],[false,'form']],search_view_id:[false],domain:[['journal_id','=',this.props.record.resId],['activity_ids','!=',false]],});}}
const journalDashboardActivity=__exports.journalDashboardActivity={component:JournalDashboardActivity,};registry.category("fields").add("kanban_vat_activity",journalDashboardActivity);return __exports;});;

/* /account/static/src/components/json_checkboxes/json_checkboxes.js */
odoo.define('@account/components/json_checkboxes/json_checkboxes',['@odoo/owl','@web/core/checkbox/checkbox','@web/core/registry','@web/views/fields/standard_field_props','@web/core/utils/timing','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{CheckBox}=require("@web/core/checkbox/checkbox");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{debounce}=require("@web/core/utils/timing");const{useRecordObserver}=require("@web/model/relational_model/utils");const JsonCheckboxes=__exports.JsonCheckboxes=class JsonCheckboxes extends Component{static template="account.JsonCheckboxes";static components={CheckBox};static props={...standardFieldProps,};setup(){super.setup();this.checkboxes=useState(this.props.record.data[this.props.name]);this.debouncedCommitChanges=debounce(this.commitChanges.bind(this),100);useRecordObserver((record)=>{Object.assign(this.checkboxes,record.data[this.props.name]);});}
commitChanges(){this.props.record.update({[this.props.name]:this.checkboxes});}
onChange(key,checked){this.checkboxes[key]['checked']=checked;this.debouncedCommitChanges();}}
const jsonCheckboxes=__exports.jsonCheckboxes={component:JsonCheckboxes,supportedTypes:["jsonb"],}
registry.category("fields").add("account_json_checkboxes",jsonCheckboxes);return __exports;});;

/* /account/static/src/components/mail_attachments/mail_attachments.js */
odoo.define('@account/components/mail_attachments/mail_attachments',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/core/file_input/file_input','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{FileInput}=require("@web/core/file_input/file_input");const{Component,onWillUnmount}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const MailAttachments=__exports.MailAttachments=class MailAttachments extends Component{static template="account.mail_attachments";static components={FileInput};static props={...standardFieldProps};setup(){this.orm=useService("orm");this.action=useService("action");this.notification=useService("notification");this.attachmentIdsToUnlink=new Set();onWillUnmount(this.onWillUnmount);}
getValue(){return this.props.record.data[this.props.name]||[];}
getUrl(attachmentId){return`/web/content/${attachmentId}?download=true`}
getExtension(file){return file.name.replace(/^.*\./,"");}
onFileUploaded(files){let extraFiles=[];for(const file of files){if(file.error){return this.notification.add(file.error,{title:_t("Uploading error"),type:"danger",});}
extraFiles.push({id:file.id,name:file.filename,mimetype:file.mimetype,placeholder:false,manual:true,});}
this.props.record.update({[this.props.name]:this.getValue().concat(extraFiles)});}
onFileRemove(deleteId){const newValue=[];for(let item of this.getValue()){if(item.id===deleteId){if(item.placeholder||item.protect_from_deletion){const copyItem=Object.assign({skip:true},item);newValue.push(copyItem);}else{this.attachmentIdsToUnlink.add(item.id);}}else{newValue.push(item);}}
this.props.record.update({[this.props.name]:newValue});}
async onWillUnmount(){if(!this.props.record.resId){this.getValue().forEach((item)=>{if(item.manual){this.attachmentIdsToUnlink.add(item.id);}});}
if(this.attachmentIdsToUnlink.size>0){await this.orm.unlink("ir.attachment",Array.from(this.attachmentIdsToUnlink));}}}
const mailAttachments=__exports.mailAttachments={component:MailAttachments,};registry.category("fields").add("mail_attachments",mailAttachments);return __exports;});;

/* /account/static/src/components/many2many_tax_tags/many2many_tax_tags.js */
odoo.define('@account/components/many2many_tax_tags/many2many_tax_tags',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/relational_utils','@web/views/fields/many2many_tags/many2many_tags_field','@account/components/tax_autocomplete/tax_autocomplete'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{Many2XAutocomplete}=require("@web/views/fields/relational_utils");const{Many2ManyTagsField,many2ManyTagsField,}=require("@web/views/fields/many2many_tags/many2many_tags_field");const{TaxAutoComplete}=require("@account/components/tax_autocomplete/tax_autocomplete");const Many2ManyTaxTagsAutocomplete=__exports.Many2ManyTaxTagsAutocomplete=class Many2ManyTaxTagsAutocomplete extends Many2XAutocomplete{static components={...Many2XAutocomplete.components,AutoComplete:TaxAutoComplete,};get SearchMoreButtonLabel(){return _t("Not sure... Help me!");}
search(name){return this.orm.call(this.props.resModel,"search_read",[],{domain:[...this.props.getDomain(),["name","ilike",name]],fields:["id","name","tax_scope"],}).then((records)=>{return this.orm.call("account.tax","fields_get",[],{attributes:["selection"]}).then((fields)=>{const selectionOptions=fields.tax_scope.selection;const recordsWithLabels=records.map((record)=>{const selectedOption=selectionOptions.find((option)=>option[0]===record.tax_scope);const label=selectedOption?selectedOption[1]:undefined;return{...record,tax_scope:label};});return recordsWithLabels;});});}
mapRecordToOption(result){return{value:result.id,label:result.name?result.name.split("\n")[0]:_t("Unnamed"),displayName:result.name,tax_scope:result.tax_scope,};}}
const Many2ManyTaxTagsField=__exports.Many2ManyTaxTagsField=class Many2ManyTaxTagsField extends Many2ManyTagsField{static components={...Many2ManyTagsField.components,Many2XAutocomplete:Many2ManyTaxTagsAutocomplete,};}
const many2ManyTaxTagsField=__exports.many2ManyTaxTagsField={...many2ManyTagsField,component:Many2ManyTaxTagsField,additionalClasses:['o_field_many2many_tags']};registry.category("fields").add("many2many_tax_tags",many2ManyTaxTagsField);return __exports;});;

/* /account/static/src/components/onboarding/onboarding.js */
odoo.define('@account/components/onboarding/onboarding',['@web/core/registry','@web/views/widgets/standard_widget_props','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");class AccountOnboardingWidget extends Component{static template="account.Onboarding";static props={...standardWidgetProps,};setup(){this.action=useService("action");this.orm=useService("orm");}
get recordOnboardingSteps(){return JSON.parse(this.props.record.data.kanban_dashboard).onboarding?.steps;}
async onboardingLinkClicked(step){const action=await this.orm.call("onboarding.onboarding.step",step.action,[],{context:{journal_id:this.props.record.resId,}});this.action.doAction(action);}}
const accountOnboarding=__exports.accountOnboarding={component:AccountOnboardingWidget,}
registry.category("view_widgets").add("account_onboarding",accountOnboarding);return __exports;});;

/* /account/static/src/components/open_move_line_move_widget/open_move_line_move_widget.js */
odoo.define('@account/components/open_move_line_move_widget/open_move_line_move_widget',['@web/core/registry','@web/views/fields/many2one/many2one_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Many2OneField,many2OneField}=require("@web/views/fields/many2one/many2one_field");class LineOpenMoveWidget extends Many2OneField{async openAction(){this.action.doActionButton({type:"object",resId:this.props.record.data[this.props.name][0],name:"action_open_business_doc",resModel:"account.move.line",});}}
const lineOpenMoveWidget=__exports.lineOpenMoveWidget={...many2OneField,component:LineOpenMoveWidget,};registry.category("fields").add("line_open_move_widget",lineOpenMoveWidget);return __exports;});;

/* /account/static/src/components/open_move_widget/open_move_widget.js */
odoo.define('@account/components/open_move_widget/open_move_widget',['@web/core/registry','@web/core/utils/hooks','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");class OpenMoveWidget extends Component{static template="account.OpenMoveWidget";static props={...standardFieldProps};setup(){super.setup();this.action=useService("action");}
async openMove(ev){this.action.doActionButton({type:"object",resId:this.props.record.resId,name:"action_open_business_doc",resModel:this.props.record.resModel,});}}
registry.category("fields").add("open_move_widget",{component:OpenMoveWidget,});return __exports;});;

/* /account/static/src/components/product_catalog/account_move_line.js */
odoo.define('@account/components/product_catalog/account_move_line',['@product/product_catalog/order_line/order_line'],function(require){'use strict';let __exports={};const{ProductCatalogOrderLine}=require("@product/product_catalog/order_line/order_line");const ProductCatalogAccountMoveLine=__exports.ProductCatalogAccountMoveLine=class ProductCatalogAccountMoveLine extends ProductCatalogOrderLine{static props={...ProductCatalogOrderLine.props,min_qty:{type:Number,optional:true},};}
return __exports;});;

/* /account/static/src/components/product_catalog/kanban_controller.js */
odoo.define('@account/components/product_catalog/kanban_controller',['@product/product_catalog/kanban_controller','@web/core/utils/patch','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{ProductCatalogKanbanController}=require("@product/product_catalog/kanban_controller");const{patch}=require("@web/core/utils/patch");const{_t}=require("@web/core/l10n/translation");patch(ProductCatalogKanbanController.prototype,{async _defineButtonContent(){const fields=this.orderResModel==="account.move"?["state","move_type"]:["state"];const orderStateInfo=await this.orm.searchRead(this.orderResModel,[["id","=",this.orderId]],fields,);if(orderStateInfo[0]?.move_type==="out_invoice"){this.buttonString=_t("Back to Invoice");}else if(orderStateInfo[0]?.move_type==="in_invoice"){this.buttonString=_t("Back to Bill");}else{super._defineButtonContent();}},});return __exports;});;

/* /account/static/src/components/product_catalog/kanban_record.js */
odoo.define('@account/components/product_catalog/kanban_record',['@product/product_catalog/kanban_record','@account/components/product_catalog/account_move_line','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ProductCatalogKanbanRecord}=require("@product/product_catalog/kanban_record");const{ProductCatalogAccountMoveLine}=require("@account/components/product_catalog/account_move_line");const{patch}=require("@web/core/utils/patch");patch(ProductCatalogKanbanRecord.prototype,{get orderLineComponent(){if(this.env.orderResModel==="account.move"){return ProductCatalogAccountMoveLine;}
return super.orderLineComponent;},addProduct(){if(this.productCatalogData.quantity===0&&this.productCatalogData.min_qty){super.addProduct(this.productCatalogData.min_qty);}else{super.addProduct(...arguments);}},})
return __exports;});;

/* /account/static/src/components/product_label_section_and_note_field/product_label_section_and_note_field.js */
odoo.define('@account/components/product_label_section_and_note_field/product_label_section_and_note_field',['@web/core/l10n/translation','@web/core/autocomplete/autocomplete','@web/core/hotkeys/hotkey_service','@web/views/fields/relational_utils','@web/views/fields/many2one/many2one_field','@odoo/owl','@web/core/registry','@account/components/section_and_note_fields_backend/section_and_note_fields_backend','@account/core/utils/product_and_label_autoresize','@web/views/fields/x2many/x2many_field'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{AutoComplete}=require("@web/core/autocomplete/autocomplete");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const{Many2XAutocomplete}=require("@web/views/fields/relational_utils");const{Many2OneField,many2OneField}=require("@web/views/fields/many2one/many2one_field");const{onMounted,onPatched,onWillUnmount,useEffect,useRef,useState}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{SectionAndNoteListRenderer,sectionAndNoteFieldOne2Many,}=require("@account/components/section_and_note_fields_backend/section_and_note_fields_backend");const{useProductAndLabelAutoresize}=require("@account/core/utils/product_and_label_autoresize");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const ProductLabelSectionAndNoteListRender=__exports.ProductLabelSectionAndNoteListRender=class ProductLabelSectionAndNoteListRender extends SectionAndNoteListRenderer{setup(){super.setup();this.productColumns=["product_id","product_template_id"];}
getCellTitle(column,record){if(this.productColumns.includes(column.name)){return;}
super.getCellTitle(column,record);}
getActiveColumns(list){let activeColumns=super.getActiveColumns(list);const productCol=activeColumns.find((col)=>this.productColumns.includes(col.name));const labelCol=activeColumns.find((col)=>col.name==="name");if(productCol){if(labelCol){list.records.forEach((record)=>(record.columnIsProductAndLabel=true));}else{list.records.forEach((record)=>(record.columnIsProductAndLabel=false));}
activeColumns=activeColumns.filter((col)=>col.name!=="name");this.titleField=productCol.name;}else{this.titleField="name";}
return activeColumns;}}
const ProductLabelSectionAndNoteOne2Many=__exports.ProductLabelSectionAndNoteOne2Many=class ProductLabelSectionAndNoteOne2Many extends X2ManyField{static components={...X2ManyField.components,ListRenderer:ProductLabelSectionAndNoteListRender,};}
const productLabelSectionAndNoteOne2Many=__exports.productLabelSectionAndNoteOne2Many={...x2ManyField,component:ProductLabelSectionAndNoteOne2Many,additionalClasses:sectionAndNoteFieldOne2Many.additionalClasses,};registry.category("fields").add("product_label_section_and_note_field_o2m",productLabelSectionAndNoteOne2Many);const ProductLabelSectionAndNoteAutocomplete=__exports.ProductLabelSectionAndNoteAutocomplete=class ProductLabelSectionAndNoteAutocomplete extends AutoComplete{setup(){super.setup();this.labelTextarea=useRef("labelNodeRef");}
onInputKeydown(event){super.onInputKeydown(event);const hotkey=getActiveHotkey(event);const labelVisibilityButton=document.getElementById('labelVisibilityButtonId');if(hotkey==="enter"){if(labelVisibilityButton&&!this.labelTextarea.el){labelVisibilityButton.click();event.stopPropagation();event.preventDefault();}}}}
const ProductLabelSectionAndNoteFieldAutocomplete=__exports.ProductLabelSectionAndNoteFieldAutocomplete=class ProductLabelSectionAndNoteFieldAutocomplete extends Many2XAutocomplete{static components={...Many2XAutocomplete.components,AutoComplete:ProductLabelSectionAndNoteAutocomplete,};static props={...Many2XAutocomplete.props,isNote:{type:Boolean},isSection:{type:Boolean},onFocusout:{type:Function,optional:true},updateLabel:{type:Function,optional:true},};static template="account.ProductLabelSectionAndNoteFieldAutocomplete";setup(){super.setup();this.input=useRef("section_and_note_input");}
get isSectionOrNote(){return this.props.isSection||this.props.isNote;}
get isSection(){return this.props.isSection;}}
const ProductLabelSectionAndNoteField=__exports.ProductLabelSectionAndNoteField=class ProductLabelSectionAndNoteField extends Many2OneField{static components={...Many2OneField.components,Many2XAutocomplete:ProductLabelSectionAndNoteFieldAutocomplete,};static template="account.ProductLabelSectionAndNoteField";setup(){super.setup();this.isPrintMode=useState({value:false});this.labelVisibility=useState({value:false});this.switchToLabel=false;this.columnIsProductAndLabel=useState({value:this.props.record.columnIsProductAndLabel});this.labelNode=useRef("labelNodeRef");useProductAndLabelAutoresize(this.labelNode,{targetParentName:this.props.name});this.productNode=useRef("productNodeRef");useProductAndLabelAutoresize(this.productNode,{targetParentName:this.props.name});useEffect(()=>{this.columnIsProductAndLabel.value=this.props.record.columnIsProductAndLabel;},()=>[this.props.record.columnIsProductAndLabel]);onPatched(()=>{if(this.labelNode.el&&this.switchToLabel){this.switchToLabel=false;this.labelNode.el.focus();}});this.onBeforePrint=()=>{this.isPrintMode.value=true;};this.onAfterPrint=()=>{this.isPrintMode.value=false;};onMounted(()=>{window.addEventListener("beforeprint",this.onBeforePrint);window.addEventListener("afterprint",this.onAfterPrint);});onWillUnmount(()=>{window.removeEventListener("beforeprint",this.onBeforePrint);window.removeEventListener("afterprint",this.onAfterPrint);});}
get productName(){return this.props.record.data[this.props.name][1];}
get label(){let label=this.props.record.data.name;if(label.includes(this.productName)){label=label.replace(this.productName,"");if(label.includes("\n")){label=label.replace("\n","");}}
return label;}
get Many2XAutocompleteProps(){const props=super.Many2XAutocompleteProps;props.isSection=this.isSection(this.props.record);props.isNote=this.isNote(this.props.record);props.placeholder=_t("Search a product");props.updateLabel=this.updateLabel.bind(this);return props;}
get isProductClickable(){return this.props.record.evalContext.parent.state!=="draft";}
get isSectionOrNote(){return this.isSection(this.props.record)||this.isNote(this.props.record);}
get sectionAndNoteClasses(){if(this.isSection()){return"fw-bold";}else if(this.isNote()){return"fst-italic";}
return"";}
isSection(record=null){record=record||this.props.record;return record.data.display_type==="line_section";}
isNote(record=null){record=record||this.props.record;return record.data.display_type==="line_note";}
switchLabelVisibility(){this.labelVisibility.value=!this.labelVisibility.value;this.switchToLabel=true;}
updateLabel(value){this.props.record.update({name:(this.productName&&value&&this.productName.concat("\n",value)||!value&&this.productName||value),});}}
const productLabelSectionAndNoteField=__exports.productLabelSectionAndNoteField={...many2OneField,listViewWidth:[240,400],component:ProductLabelSectionAndNoteField,};registry.category("fields").add("product_label_section_and_note_field",productLabelSectionAndNoteField);return __exports;});;

/* /account/static/src/components/section_and_note_fields_backend/section_and_note_fields_backend.js */
odoo.define('@account/components/section_and_note_fields_backend/section_and_note_fields_backend',['@web/core/registry','@web/views/list/list_renderer','@web/views/fields/x2many/x2many_field','@web/views/fields/text/text_field','@web/views/fields/char/char_field','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{ListRenderer}=require("@web/views/list/list_renderer");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const{TextField,ListTextField}=require("@web/views/fields/text/text_field");const{CharField}=require("@web/views/fields/char/char_field");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component,useEffect}=require("@odoo/owl");const SectionAndNoteListRenderer=__exports.SectionAndNoteListRenderer=class SectionAndNoteListRenderer extends ListRenderer{static template="account.sectionAndNoteListRenderer";setup(){super.setup();this.titleField="name";useEffect((editedRecord)=>this.focusToName(editedRecord),()=>[this.editedRecord])}
focusToName(editRec){if(editRec&&editRec.isNew&&this.isSectionOrNote(editRec)){const col=this.columns.find((c)=>c.name===this.titleField);this.focusCell(col,null);}}
isSectionOrNote(record=null){record=record||this.record;return['line_section','line_note'].includes(record.data.display_type);}
getRowClass(record){const existingClasses=super.getRowClass(record);return`${existingClasses} o_is_${record.data.display_type}`;}
getCellClass(column,record){const classNames=super.getCellClass(column,record);if(this.isSectionOrNote(record)&&column.widget!=="handle"&&column.name!==this.titleField){return`${classNames} o_hidden`;}
return classNames;}
getColumns(record){const columns=super.getColumns(record);if(this.isSectionOrNote(record)){return this.getSectionColumns(columns);}
return columns;}
getSectionColumns(columns){const sectionCols=columns.filter((col)=>col.widget==="handle"||col.type==="field"&&col.name===this.titleField);return sectionCols.map((col)=>{if(col.name===this.titleField){return{...col,colspan:columns.length-sectionCols.length+1};}else{return{...col};}});}}
const SectionAndNoteFieldOne2Many=__exports.SectionAndNoteFieldOne2Many=class SectionAndNoteFieldOne2Many extends X2ManyField{static components={...X2ManyField.components,ListRenderer:SectionAndNoteListRenderer,};}
const SectionAndNoteText=__exports.SectionAndNoteText=class SectionAndNoteText extends Component{static template="account.SectionAndNoteText";static props={...standardFieldProps};get componentToUse(){return this.props.record.data.display_type==='line_section'?CharField:TextField;}}
const ListSectionAndNoteText=__exports.ListSectionAndNoteText=class ListSectionAndNoteText extends SectionAndNoteText{get componentToUse(){return this.props.record.data.display_type!=="line_section"?ListTextField:super.componentToUse;}}
const sectionAndNoteFieldOne2Many=__exports.sectionAndNoteFieldOne2Many={...x2ManyField,component:SectionAndNoteFieldOne2Many,additionalClasses:[...x2ManyField.additionalClasses||[],"o_field_one2many"],};const sectionAndNoteText=__exports.sectionAndNoteText={component:SectionAndNoteText,additionalClasses:["o_field_text"],};const listSectionAndNoteText=__exports.listSectionAndNoteText={...sectionAndNoteText,component:ListSectionAndNoteText,};registry.category("fields").add("section_and_note_one2many",sectionAndNoteFieldOne2Many);registry.category("fields").add("section_and_note_text",sectionAndNoteText);registry.category("fields").add("list.section_and_note_text",listSectionAndNoteText);return __exports;});;

/* /account/static/src/components/tax_autocomplete/tax_autocomplete.js */
odoo.define('@account/components/tax_autocomplete/tax_autocomplete',['@web/core/autocomplete/autocomplete'],function(require){'use strict';let __exports={};const{AutoComplete}=require("@web/core/autocomplete/autocomplete");const TaxAutoComplete=__exports.TaxAutoComplete=class TaxAutoComplete extends AutoComplete{static template="account.TaxAutoComplete";}
return __exports;});;

/* /account/static/src/components/tax_totals/tax_totals.js */
odoo.define('@account/components/tax_totals/tax_totals',['@web/views/fields/formatters','@web/core/utils/numbers','@web/views/fields/parsers','@web/views/fields/standard_field_props','@web/core/registry','@odoo/owl','@web/views/fields/numpad_decimal_hook'],function(require){'use strict';let __exports={};const{formatMonetary}=require("@web/views/fields/formatters");const{formatFloat}=require("@web/core/utils/numbers");const{parseFloat}=require("@web/views/fields/parsers");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{registry}=require("@web/core/registry");const{Component,onPatched,onWillUpdateProps,onWillRender,toRaw,useRef,useState,}=require("@odoo/owl");const{useNumpadDecimal}=require("@web/views/fields/numpad_decimal_hook");class TaxGroupComponent extends Component{static props={totals:{optional:true},subtotal:{optional:true},taxGroup:{optional:true},onChangeTaxGroup:{optional:true},isReadonly:Boolean,invalidate:Function,};static template="account.TaxGroupComponent";setup(){this.inputTax=useRef("taxValueInput");this.state=useState({value:"readonly"});onPatched(()=>{if(this.state.value==="edit"){const{taxGroup}=this.props;const newVal=formatFloat(taxGroup.tax_amount_currency,{digits:this.props.totals.currency_pd});this.inputTax.el.value=newVal;this.inputTax.el.focus();}});onWillUpdateProps(()=>{this.setState("readonly");});useNumpadDecimal();}
formatMonetary(value){return formatMonetary(value,{currencyId:this.props.totals.currency_id});}
setState(value){if(["readonly","edit","disable"].includes(value)){this.state.value=value;}
else{this.state.value="readonly";}}
_onChangeTaxValue(){this.setState("disable");const oldValue=this.props.taxGroup.tax_amount_currency;let newValue;try{newValue=parseFloat(this.inputTax.el.value);}catch{this.inputTax.el.value=oldValue;this.setState("edit");return;}
if(newValue===oldValue||newValue===0){this.setState("readonly");return;}
const deltaValue=newValue-oldValue;this.props.taxGroup.tax_amount_currency+=deltaValue;this.props.subtotal.tax_amount_currency+=deltaValue;this.props.totals.tax_amount_currency+=deltaValue;this.props.totals.total_amount_currency+=deltaValue;this.props.onChangeTaxGroup({oldValue,newValue:newValue,taxGroupId:this.props.taxGroup.id,});}}
const TaxTotalsComponent=__exports.TaxTotalsComponent=class TaxTotalsComponent extends Component{static template="account.TaxTotalsField";static components={TaxGroupComponent};static props={...standardFieldProps,};setup(){this.totals={};this.formatData(this.props);onWillRender(()=>this.formatData(this.props));}
get readonly(){return this.props.readonly;}
invalidate(){return this.props.record.setInvalidField(this.props.name);}
formatMonetary(value){return formatMonetary(value,{currencyId:this.totals.currency_id});}
_onChangeTaxValueByTaxGroup({oldValue,newValue}){if(oldValue===newValue)return;this.props.record.update({[this.props.name]:this.totals});delete this.totals.cash_rounding_base_amount_currency;}
formatData(props){let totals=JSON.parse(JSON.stringify(toRaw(props.record.data[this.props.name])));if(!totals){return;}
this.totals=totals;}}
const taxTotalsComponent=__exports.taxTotalsComponent={component:TaxTotalsComponent,};registry.category("fields").add("account-tax-totals-field",taxTotalsComponent);return __exports;});;

/* /account/static/src/components/tests_shared_js_python/tests_shared_js_python.js */
odoo.define('@account/components/tests_shared_js_python/tests_shared_js_python',['@web/core/network/rpc','@web/core/registry','@account/helpers/account_tax','@odoo/owl'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{accountTaxHelpers}=require("@account/helpers/account_tax");const{xml,useState,Component}=require("@odoo/owl");const TestsSharedJsPython=__exports.TestsSharedJsPython=class TestsSharedJsPython extends Component{static template=xml`
        <button t-attf-class="#{state.done ? 'text-success' : ''}" t-on-click="processTests">Test</button>
    `;static props={tests:{type:Array,optional:true},};setup(){super.setup();this.state=useState({done:false});}
processTest(params){if(params.test==="taxes_computation"){const kwargs={product:params.product,precision_rounding:params.precision_rounding,rounding_method:params.rounding_method,};const results={results:accountTaxHelpers.get_tax_details(params.taxes,params.price_unit,params.quantity,kwargs,)};if(params.rounding_method==="round_globally"){results.total_excluded_results=accountTaxHelpers.get_tax_details(params.taxes,results.results.total_excluded/params.quantity,params.quantity,{...kwargs,special_mode:"total_excluded"});results.total_included_results=accountTaxHelpers.get_tax_details(params.taxes,results.results.total_included/params.quantity,params.quantity,{...kwargs,special_mode:"total_included"});}
return results;}
if(params.test==="adapt_price_unit_to_another_taxes"){return{price_unit:accountTaxHelpers.adapt_price_unit_to_another_taxes(params.price_unit,params.product,params.original_taxes,params.new_taxes)}}
if(params.test==="tax_totals_summary"){const document=this.populateDocument(params.document);const taxTotals=accountTaxHelpers.get_tax_totals_summary(document.lines,document.currency,document.company,{cash_rounding:document.cash_rounding});return{tax_totals:taxTotals,soft_checking:params.soft_checking};}}
async processTests(){const tests=this.props.tests||[];const results=tests.map(this.processTest.bind(this));await rpc("/account/post_tests_shared_js_python",{results:results});this.state.done=true;}
populateDocument(document){const base_lines=document.lines.map(line=>accountTaxHelpers.prepare_base_line_for_taxes_computation(null,line));accountTaxHelpers.add_tax_details_in_base_lines(base_lines,document.company);accountTaxHelpers.round_base_lines_tax_details(base_lines,document.company);return{...document,lines:base_lines,}}}
registry.category("public_components").add("account.tests_shared_js_python",TestsSharedJsPython);return __exports;});;

/* /account/static/src/components/upload_drop_zone/upload_drop_zone.js */
odoo.define('@account/components/upload_drop_zone/upload_drop_zone',['@web/core/l10n/translation','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{Component,useState}=require("@odoo/owl");const UploadDropZone=__exports.UploadDropZone=class UploadDropZone extends Component{static template="account.UploadDropZone";static props={visible:{type:Boolean,optional:true},hideZone:{type:Function,optional:true},dragIcon:{type:String,optional:true},dragText:{type:String,optional:true},dragTitle:{type:String,optional:true},};static defaultProps={hideZone:()=>{},};setup(){this.notificationService=useService("notification");this.dashboardState=useState(this.env.dashboardState||{});}
onDrop(ev){const selector='.document_file_uploader.o_input_file';let uploadInput=ev.target.closest('.o_drop_area').parentElement.querySelector(selector)||document.querySelector(selector);let files=ev.dataTransfer?ev.dataTransfer.files:false;if(uploadInput&&!!files){uploadInput.files=ev.dataTransfer.files;uploadInput.dispatchEvent(new Event("change"));}else{this.notificationService.add(_t("Could not upload files"),{type:"danger",});}
this.props.hideZone();}}
return __exports;});;

/* /account/static/src/components/x2many_buttons/x2many_buttons.js */
odoo.define('@account/components/x2many_buttons/x2many_buttons',['@web/core/l10n/translation','@web/views/fields/standard_field_props','@web/core/registry','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");class X2ManyButtons extends Component{static template="account.X2ManyButtons";static props={...standardFieldProps,treeLabel:{type:String},};setup(){this.orm=useService("orm");this.action=useService("action");}
async openTreeAndDiscard(){const ids=this.currentField.currentIds;await this.props.record.discard();this.action.doAction({name:this.props.treeLabel,type:"ir.actions.act_window",res_model:this.currentField.resModel,views:[[false,"list"],[false,"form"],],domain:[["id","in",ids]],context:{form_view_ref:"account.view_duplicated_moves_tree_js",},});}
async openFormAndDiscard(id){const action=await this.orm.call(this.currentField.resModel,"action_open_business_doc",[id],{});await this.props.record.discard();this.action.doAction(action);}
get currentField(){return this.props.record.data[this.props.name];}}
X2ManyButtons.template="account.X2ManyButtons";registry.category("fields").add("x2many_buttons",{component:X2ManyButtons,relatedFields:[{name:"display_name",type:"char"}],extractProps:({string})=>({treeLabel:string||_t("Records")}),});return __exports;});;

/* /account/static/src/services/account_move_service.js */
odoo.define('@account/services/account_move_service',['@web/core/l10n/translation','@web/core/confirmation_dialog/confirmation_dialog','@web/core/utils/strings','@odoo/owl','@web/core/registry'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{escape}=require("@web/core/utils/strings");const{markup}=require("@odoo/owl");const{registry}=require("@web/core/registry");const AccountMoveService=__exports.AccountMoveService=class AccountMoveService{constructor(env,services){this.setup(env,services);}
setup(env,services){this.env=env;this.action=services.action;this.dialog=services.dialog;this.orm=services.orm;}
async addDeletionDialog(component,moveIds){const isMoveEndOfChain=await this.orm.call("account.move","check_move_sequence_chain",[moveIds]);if(!isMoveEndOfChain){const message=_t("This operation will create a gap in the sequence.");const confirmationDialogProps=component.deleteConfirmationDialogProps;confirmationDialogProps.body=markup(`<div class="text-danger">${escape(message)}</div>${escape(confirmationDialogProps.body)}`);this.dialog.add(ConfirmationDialog,confirmationDialogProps);return true;}
return false;}
async downloadPdf(accountMoveId){const downloadAction=await this.orm.call("account.move","action_invoice_download_pdf",[accountMoveId]);await this.action.doAction(downloadAction);}}
const accountMoveService=__exports.accountMoveService={dependencies:["action","dialog","orm"],start(env,services){return new AccountMoveService(env,services);},};registry.category("services").add("account_move",accountMoveService);return __exports;});;

/* /account/static/src/services/account_notification_service.js */
odoo.define('@account/services/account_notification_service',['@web/core/l10n/translation','@web/core/registry'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const accountNotificationService=__exports.accountNotificationService={dependencies:["bus_service","notification","action"],start(env,{bus_service,notification,action}){bus_service.subscribe("account_notification",({message,sticky,title,type,action_button})=>{const buttons=[{name:action_button.name,primary:false,onClick:()=>{action.doAction({name:_t(action_button.action_name),type:'ir.actions.act_window',res_model:action_button.model,domain:[["id","in",action_button.res_ids]],views:[[false,'list'],[false,'form']],target:'current',});},}];notification.add(message,{sticky,title,type,buttons});});}};registry.category("services").add("accountNotification",accountNotificationService);return __exports;});;

/* /account/static/src/views/account_dashboard_kanban/account_dashboard_kanban_record.js */
odoo.define('@account/views/account_dashboard_kanban/account_dashboard_kanban_record',['@web/core/user','@account/components/account_file_uploader/account_file_uploader','@account/components/upload_drop_zone/upload_drop_zone','@web/views/kanban/kanban_dropdown_menu_wrapper','@web/views/kanban/kanban_record','@odoo/owl'],function(require){'use strict';let __exports={};const{user}=require("@web/core/user");const{AccountFileUploader}=require("@account/components/account_file_uploader/account_file_uploader");const{UploadDropZone}=require("@account/components/upload_drop_zone/upload_drop_zone");const{KanbanDropdownMenuWrapper}=require("@web/views/kanban/kanban_dropdown_menu_wrapper");const{KanbanRecord}=require("@web/views/kanban/kanban_record");const{useState,onWillStart}=require("@odoo/owl");const DashboardKanbanDropdownMenuWrapper=__exports.DashboardKanbanDropdownMenuWrapper=class DashboardKanbanDropdownMenuWrapper extends KanbanDropdownMenuWrapper{onClick(ev){if(!ev.target.tagName==="INPUT"&&!ev.target.closest('.file_upload_kanban_action_a')){super.onClick(ev);}}}
const DashboardKanbanRecord=__exports.DashboardKanbanRecord=class DashboardKanbanRecord extends KanbanRecord{static template="account.DashboardKanbanRecord";static components={...DashboardKanbanRecord.components,UploadDropZone,AccountFileUploader,KanbanDropdownMenuWrapper:DashboardKanbanDropdownMenuWrapper,};setup(){super.setup();onWillStart(async()=>{this.allowDrop=this.recordDropSettings.group?await user.hasGroup(this.recordDropSettings.group):true;});this.dropzoneState=useState({visible:false,});}
get recordDropSettings(){return JSON.parse(this.props.record.data.kanban_dashboard).drag_drop_settings;}
get dropzoneProps(){const{image,text}=this.recordDropSettings;return{visible:this.dropzoneState.visible,dragIcon:image,dragText:text,dragTitle:this.props.record.data.name,hideZone:()=>{this.dropzoneState.visible=false;},}}}
return __exports;});;

/* /account/static/src/views/account_dashboard_kanban/account_dashboard_kanban_renderer.js */
odoo.define('@account/views/account_dashboard_kanban/account_dashboard_kanban_renderer',['@web/views/kanban/kanban_renderer','@account/views/account_dashboard_kanban/account_dashboard_kanban_record','@odoo/owl'],function(require){'use strict';let __exports={};const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{DashboardKanbanRecord}=require("@account/views/account_dashboard_kanban/account_dashboard_kanban_record");const{useSubEnv,reactive}=require("@odoo/owl");const DashboardKanbanRenderer=__exports.DashboardKanbanRenderer=class DashboardKanbanRenderer extends KanbanRenderer{static template="account.DashboardKanbanRenderer";static components={...KanbanRenderer.components,KanbanRecord:DashboardKanbanRecord,};setup(){super.setup();useSubEnv({dashboardState:reactive({isDragging:false}),setDragging:this.setDragging.bind(this),});}
kanbanDragEnter(e){this.setDragging(e.dataTransfer.types.includes("Files"));}
kanbanDragLeave(e){const mouseX=e.clientX,mouseY=e.clientY;const{x,y,width,height}=this.rootRef.el.getBoundingClientRect();const mouseInsideKanbanRenderer=mouseX>x&&mouseX<=x+width&&mouseY>y&&mouseY<=y+height;if(!mouseInsideKanbanRenderer||!e.dataTransfer.types.includes("Files")){this.setDragging(false);}else{this.setDragging(true);}}
kanbanDragDrop(e){this.setDragging(false);return false;}
setDragging(value){this.env.dashboardState.isDragging=value;}}
return __exports;});;

/* /account/static/src/views/account_dashboard_kanban/account_dashboard_kanban_view.js */
odoo.define('@account/views/account_dashboard_kanban/account_dashboard_kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@account/views/account_dashboard_kanban/account_dashboard_kanban_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{DashboardKanbanRenderer}=require("@account/views/account_dashboard_kanban/account_dashboard_kanban_renderer");const accountDashboardKanbanView=__exports.accountDashboardKanbanView={...kanbanView,Renderer:DashboardKanbanRenderer,};registry.category("views").add("account_dashboard_kanban",accountDashboardKanbanView);return __exports;});;

/* /account/static/src/views/account_move_kanban/account_move_kanban_controller.js */
odoo.define('@account/views/account_move_kanban/account_move_kanban_controller',['@account/views/file_upload_kanban/file_upload_kanban_controller','@account/components/account_file_uploader/account_file_uploader'],function(require){'use strict';let __exports={};const{FileUploadKanbanController}=require("@account/views/file_upload_kanban/file_upload_kanban_controller");const{AccountFileUploader}=require("@account/components/account_file_uploader/account_file_uploader");const AccountMoveKanbanController=__exports.AccountMoveKanbanController=class AccountMoveKanbanController extends FileUploadKanbanController{static components={...FileUploadKanbanController.components,AccountFileUploader,};setup(){super.setup();this.showUploadButton=this.props.context.default_move_type!=='entry'||'active_id'in this.props.context;}}
return __exports;});;

/* /account/static/src/views/account_move_kanban/account_move_kanban_view.js */
odoo.define('@account/views/account_move_kanban/account_move_kanban_view',['@web/core/registry','@account/views/file_upload_kanban/file_upload_kanban_view','@account/views/account_move_kanban/account_move_kanban_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{fileUploadKanbanView}=require("@account/views/file_upload_kanban/file_upload_kanban_view");const{AccountMoveKanbanController}=require("@account/views/account_move_kanban/account_move_kanban_controller");const accountMoveUploadKanbanView=__exports.accountMoveUploadKanbanView={...fileUploadKanbanView,Controller:AccountMoveKanbanController,buttonTemplate:"account.AccountMoveKanbanView.Buttons",};registry.category("views").add("account_documents_kanban",accountMoveUploadKanbanView);return __exports;});;

/* /account/static/src/views/account_move_list/account_move_list_controller.js */
odoo.define('@account/views/account_move_list/account_move_list_controller',['@web/core/l10n/translation','@account/views/file_upload_list/file_upload_list_controller','@account/components/account_file_uploader/account_file_uploader','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{FileUploadListController}=require("@account/views/file_upload_list/file_upload_list_controller");const{AccountFileUploader}=require("@account/components/account_file_uploader/account_file_uploader");const{useService}=require("@web/core/utils/hooks");const AccountMoveListController=__exports.AccountMoveListController=class AccountMoveListController extends FileUploadListController{static components={...FileUploadListController.components,AccountFileUploader,};setup(){super.setup();this.orm=useService("orm");this.account_move_service=useService("account_move");this.showUploadButton=this.props.context.default_move_type!=='entry'||'active_id'in this.props.context;}
get actionMenuProps(){const actionMenuProps={...super.actionMenuProps,printDropdownTitle:_t("Download"),};if(this.props.resModel==="account.move"){actionMenuProps.loadExtraPrintItems=this.loadExtraPrintItems.bind(this);}
return actionMenuProps;}
async loadExtraPrintItems(){return this.orm.call("account.move","get_extra_print_items",[this.actionMenuProps.getActiveIds()]);}
async onDeleteSelectedRecords(){const selectedResIds=await this.getSelectedResIds();if(this.props.resModel!=="account.move"||!await this.account_move_service.addDeletionDialog(this,selectedResIds)){return super.onDeleteSelectedRecords(...arguments);}}}
return __exports;});;

/* /account/static/src/views/account_move_list/account_move_list_renderer.js */
odoo.define('@account/views/account_move_list/account_move_list_renderer',['@account/components/bill_guide/bill_guide','@account/views/file_upload_list/file_upload_list_renderer'],function(require){'use strict';let __exports={};const{BillGuide}=require("@account/components/bill_guide/bill_guide");const{FileUploadListRenderer}=require("@account/views/file_upload_list/file_upload_list_renderer");const AccountMoveListRenderer=__exports.AccountMoveListRenderer=class AccountMoveListRenderer extends FileUploadListRenderer{static template="account.AccountMoveListRenderer";static components={...FileUploadListRenderer.components,BillGuide,};getCellClass(column,record){const classNames=super.getCellClass(column,record);if(column.name==='ref'&&record.data.duplicated_ref_ids&&record.data.duplicated_ref_ids.count!==0){return`${classNames} table-warning`;}
return classNames;}}
return __exports;});;

/* /account/static/src/views/account_move_list/account_move_list_view.js */
odoo.define('@account/views/account_move_list/account_move_list_view',['@web/core/registry','@account/views/file_upload_list/file_upload_list_view','@account/views/account_move_list/account_move_list_controller','@account/views/account_move_list/account_move_list_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{fileUploadListView}=require("@account/views/file_upload_list/file_upload_list_view");const{AccountMoveListController}=require("@account/views/account_move_list/account_move_list_controller");const{AccountMoveListRenderer}=require("@account/views/account_move_list/account_move_list_renderer");const accountMoveUploadListView=__exports.accountMoveUploadListView={...fileUploadListView,Controller:AccountMoveListController,Renderer:AccountMoveListRenderer,buttonTemplate:"account.AccountMoveListView.Buttons",};registry.category("views").add("account_tree",accountMoveUploadListView);return __exports;});;

/* /account/static/src/views/account_x2many_list_controller.js */
odoo.define('@account/views/account_x2many_list_controller',['@web/views/list/list_controller','@web/core/utils/hooks','@web/core/registry','@web/views/list/list_view'],function(require){'use strict';let __exports={};const{ListController}=require("@web/views/list/list_controller");const{useService}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const AccountX2ManyListController=__exports.AccountX2ManyListController=class AccountX2ManyListController extends ListController{setup(){super.setup();this.orm=useService("orm");this.action=useService("action");}
async openRecord(record){const action=await this.orm.call(record.resModel,'action_open_business_doc',[record.resId],{});return this.actionService.doAction(action);}}
registry.category("views").add("account_x2many_list",{...listView,Controller:AccountX2ManyListController,});return __exports;});;

/* /account/static/src/views/file_upload_kanban/file_upload_kanban_controller.js */
odoo.define('@account/views/file_upload_kanban/file_upload_kanban_controller',['@web/views/kanban/kanban_controller','@account/components/document_file_uploader/document_file_uploader'],function(require){'use strict';let __exports={};const{KanbanController}=require("@web/views/kanban/kanban_controller");const{DocumentFileUploader}=require("@account/components/document_file_uploader/document_file_uploader");const FileUploadKanbanController=__exports.FileUploadKanbanController=class FileUploadKanbanController extends KanbanController{static components={...KanbanController.components,DocumentFileUploader,};}
return __exports;});;

/* /account/static/src/views/file_upload_kanban/file_upload_kanban_renderer.js */
odoo.define('@account/views/file_upload_kanban/file_upload_kanban_renderer',['@web/views/kanban/kanban_renderer','@account/components/upload_drop_zone/upload_drop_zone','@odoo/owl','@account/views/upload_file_from_data_hook'],function(require){'use strict';let __exports={};const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{UploadDropZone}=require("@account/components/upload_drop_zone/upload_drop_zone");const{useState}=require("@odoo/owl");const{uploadFileFromData}=require("@account/views/upload_file_from_data_hook");const FileUploadKanbanRenderer=__exports.FileUploadKanbanRenderer=class FileUploadKanbanRenderer extends KanbanRenderer{static template="account.FileUploadKanbanRenderer";static components={...KanbanRenderer.components,UploadDropZone,};setup(){super.setup();this.dropzoneState=useState({visible:false});this.uploadFileFromData=uploadFileFromData();}
async onPaste(ev){if(!ev.clipboardData?.items){return;}
ev.preventDefault();this.uploadFileFromData(ev.clipboardData);}
onDragStart(ev){if(ev.dataTransfer.types.includes("Files")){this.dropzoneState.visible=true;}}}
return __exports;});;

/* /account/static/src/views/file_upload_kanban/file_upload_kanban_view.js */
odoo.define('@account/views/file_upload_kanban/file_upload_kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@account/views/file_upload_kanban/file_upload_kanban_controller','@account/views/file_upload_kanban/file_upload_kanban_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{FileUploadKanbanController}=require("@account/views/file_upload_kanban/file_upload_kanban_controller");const{FileUploadKanbanRenderer}=require("@account/views/file_upload_kanban/file_upload_kanban_renderer");const fileUploadKanbanView=__exports.fileUploadKanbanView={...kanbanView,Controller:FileUploadKanbanController,Renderer:FileUploadKanbanRenderer,buttonTemplate:"account.FileuploadKanbanView.Buttons",};registry.category("views").add("file_upload_kanban",fileUploadKanbanView);return __exports;});;

/* /account/static/src/views/file_upload_list/file_upload_list_controller.js */
odoo.define('@account/views/file_upload_list/file_upload_list_controller',['@web/views/list/list_controller','@account/components/document_file_uploader/document_file_uploader'],function(require){'use strict';let __exports={};const{ListController}=require("@web/views/list/list_controller");const{DocumentFileUploader}=require("@account/components/document_file_uploader/document_file_uploader");const FileUploadListController=__exports.FileUploadListController=class FileUploadListController extends ListController{static components={...ListController.components,DocumentFileUploader,};};return __exports;});;

/* /account/static/src/views/file_upload_list/file_upload_list_renderer.js */
odoo.define('@account/views/file_upload_list/file_upload_list_renderer',['@web/views/list/list_renderer','@account/components/upload_drop_zone/upload_drop_zone','@odoo/owl','@account/views/upload_file_from_data_hook'],function(require){'use strict';let __exports={};const{ListRenderer}=require("@web/views/list/list_renderer");const{UploadDropZone}=require("@account/components/upload_drop_zone/upload_drop_zone");const{useState}=require("@odoo/owl");const{uploadFileFromData}=require("@account/views/upload_file_from_data_hook");const FileUploadListRenderer=__exports.FileUploadListRenderer=class FileUploadListRenderer extends ListRenderer{static template="account.FileUploadListRenderer";static components={...ListRenderer.components,UploadDropZone,};setup(){super.setup();this.dropzoneState=useState({visible:false});this.uploadFileFromData=uploadFileFromData();}
async onPaste(ev){if(!ev.clipboardData?.items){return;}
ev.preventDefault();this.uploadFileFromData(ev.clipboardData);}
onDragStart(ev){if(ev.dataTransfer.types.includes("Files")){this.dropzoneState.visible=true;}}}
return __exports;});;

/* /account/static/src/views/file_upload_list/file_upload_list_view.js */
odoo.define('@account/views/file_upload_list/file_upload_list_view',['@web/core/registry','@web/views/list/list_view','@account/views/file_upload_list/file_upload_list_controller','@account/views/file_upload_list/file_upload_list_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{FileUploadListController}=require("@account/views/file_upload_list/file_upload_list_controller");const{FileUploadListRenderer}=require("@account/views/file_upload_list/file_upload_list_renderer");const fileUploadListView=__exports.fileUploadListView={...listView,Controller:FileUploadListController,Renderer:FileUploadListRenderer,buttonTemplate:"account.FileuploadListView.Buttons",};registry.category("views").add("file_upload_list",fileUploadListView);return __exports;});;

/* /account/static/src/views/upload_file_from_data_hook.js */
odoo.define('@account/views/upload_file_from_data_hook',[],function(require){'use strict';let __exports={};const supportedFileTypes=["text/xml","application/pdf"];__exports.uploadFileFromData=uploadFileFromData;function uploadFileFromData(dataTransfer){return async(dataTransfer)=>{function uploadFiles(dataTransfer){const invalidFiles=[...dataTransfer.items].filter((item)=>item.kind!=="file"||!supportedFileTypes.includes(item.type));if(invalidFiles.length!==0){console.warn("Invalid files to extract details.");return;}
let uploadInput=document.querySelector('.document_file_uploader.o_input_file');uploadInput.files=dataTransfer.files;uploadInput.dispatchEvent(new Event("change"));}
if(dataTransfer.files.length!==0){uploadFiles(dataTransfer);}else{console.warn("Invalid data to extract details.");}}}
return __exports;});;

/* /account/static/src/js/tours/account.js */
odoo.define('@account/js/tours/account',['@web/core/l10n/translation','@web/core/registry','@web_tour/tour_service/tour_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{stepUtils}=require("@web_tour/tour_service/tour_utils");const{markup}=require("@odoo/owl");const accountTourSteps=__exports.accountTourSteps={goToAccountMenu(description="Open Invoicing Menu"){return stepUtils.goToAppSteps('account.menu_finance',description);},onboarding(){return[];},newInvoice(){return[{trigger:"button.o_list_button_add",content:_t("Now, we'll create your first invoice"),run:"click",},];},}
registry.category("web_tour.tours").add('account_tour',{url:"/odoo",steps:()=>[...accountTourSteps.goToAccountMenu(markup(_t('Send invoices to your customers in no time with the <b>Invoicing app</b>.'))),...accountTourSteps.onboarding(),...accountTourSteps.newInvoice(),{trigger:"div[name=partner_id] .o_input_dropdown",content:markup(_t("Write a customer name to <b>create one</b> or <b>see suggestions</b>.")),tooltipPosition:"right",run:"click",},{isActive:["auto"],trigger:"div[name=partner_id] input",run:"edit Test Customer",},{isActive:["auto"],trigger:".o_m2o_dropdown_option a:contains('Create')",content:_t("Select first partner"),run:"click",},{isActive:["auto"],trigger:".modal-content button.btn-primary",content:markup(_t("Once everything is set, you are good to continue. You will be able to edit this later in the <b>Customers</b> menu.")),run:"click",},{trigger:"div[name=invoice_line_ids] .o_field_x2many_list_row_add a",content:_t("Add a line to your invoice"),run:"click",},{trigger:"div[name=invoice_line_ids] div[name=product_id]",content:_t("Fill in the details of the product or see the suggestion."),tooltipPosition:"bottom",run:"click",},{isActive:["auto"],trigger:"div[name=invoice_line_ids] div[name=product_id] input",run:"edit Test Product",},{isActive:["auto"],trigger:"div[name=invoice_line_ids] div[name=product_id] .o_m2o_dropdown_option_create a:contains(create)",content:_t("Create the product."),run:"click",},{trigger:"div[name=invoice_line_ids] div[name=product_id] button[id=labelVisibilityButtonId]",content:_t("Click here to add a description to your product."),tooltipPosition:"bottom",run:"click",},{trigger:"div[name=invoice_line_ids] div[name=product_id] textarea",content:_t("Add a description to your item."),tooltipPosition:"bottom",run:"edit A very useful description.",},{isActive:["auto"],trigger:"div[name=invoice_line_ids] div[name=product_id] textarea",run:function(){const input=this.anchor;input.dispatchEvent(new InputEvent("input"));input.dispatchEvent(new Event("change"));},},{trigger:"div[name=invoice_line_ids] td[name=price_unit]",content:_t("Verify the price and update if necessary."),tooltipPosition:"bottom",run:"click",},{isActive:["auto"],trigger:"div[name=invoice_line_ids] div[name=price_unit] input",content:_t("Set a price."),run:"edit 100",},...stepUtils.saveForm(),{trigger:"button[name=action_post]",content:_t("Once your invoice is ready, confirm it."),run:"click",},{trigger:"button[name=action_invoice_sent]:contains(send)",content:_t("Send the invoice to the customer and check what he'll receive."),tooltipPosition:"bottom",run:"click",},{trigger:".o_field_widget[name=mail_partner_ids] input",content:_t("Send the invoice to the customer and check what he'll receive."),tooltipPosition:"bottom",run:"edit Test Customer",},{isActive:["auto"],trigger:".ui-menu-item a:contains('Test Customer')",content:_t("Select first partner"),run:"click",},{isActive:["auto"],trigger:".o_field_widget[name=email] input, input[name=email]",content:markup(_t("Write here <b>your own email address</b> to test the flow.")),run:"edit customer@example.com",},{isActive:["auto"],trigger:".modal button.o_form_button_save",content:_t("Validate."),run:"click",},{trigger:".modal button[name=action_send_and_print]",content:_t("Let's send the invoice."),tooltipPosition:"top",run:"click",},{trigger:"button[name=action_invoice_sent]:contains(send).btn-secondary",content:_t("The invoice having been sent, the button has changed priority."),run(){},},]});return __exports;});;

/* /account/static/src/js/search/search_bar/search_bar.js */
odoo.define('@account/js/search/search_bar/search_bar',['@web/core/l10n/translation','@web/core/utils/patch','@web/search/search_bar/search_bar'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{SearchBar}=require("@web/search/search_bar/search_bar");patch(SearchBar.prototype,{getPreposition(searchItem){let preposition=super.getPreposition(searchItem);if(this.fields[searchItem.fieldName].name==='payment_date'||this.fields[searchItem.fieldName].name==='next_payment_date'){preposition=_t("until");}
return preposition}});return __exports;});;

/* /account/static/src/helpers/account_tax.js */
odoo.define('@account/helpers/account_tax',['@web/core/utils/numbers','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{floatIsZero,roundPrecision}=require("@web/core/utils/numbers");const{_t}=require("@web/core/l10n/translation");const accountTaxHelpers=__exports.accountTaxHelpers={eval_taxes_computation_prepare_product_values(default_product_values,product){const product_values={};for(const[field_name,field_info]of Object.entries(default_product_values)){product_values[field_name]=product?product[field_name]||field_info.default_value:field_info.default_value;}
return product_values;},batch_for_taxes_computation(taxes,{special_mode=null}={}){function sort_key(taxes){return taxes.sort((t1,t2)=>t1.sequence-t2.sequence||t1.id-t2.id);}
const results={batch_per_tax:{},group_per_tax:{},sorted_taxes:[],};for(const tax of sort_key(taxes)){if(tax.amount_type==="group"){const children=sort_key(tax.children_tax_ids);for(const child of children){results.group_per_tax[child.id]=tax;results.sorted_taxes.push(child);}}else{results.sorted_taxes.push(tax);}}
let batch=[];let is_base_affected=false;for(const tax of results.sorted_taxes.toReversed()){if(batch.length>0){const same_batch=tax.amount_type===batch[0].amount_type&&(special_mode||tax.price_include===batch[0].price_include)&&tax.include_base_amount===batch[0].include_base_amount&&((tax.include_base_amount&&!is_base_affected)||!tax.include_base_amount);if(!same_batch){for(const batch_tax of batch){results.batch_per_tax[batch_tax.id]=batch;}
batch=[];}}
is_base_affected=tax.is_base_affected;batch.push(tax);}
if(batch.length!==0){for(const batch_tax of batch){results.batch_per_tax[batch_tax.id]=batch;}}
return results;},propagate_extra_taxes_base(taxes,tax,taxes_data,{special_mode=null}={}){function*get_tax_before(){for(const tax_before of taxes){if(taxes_data[tax.id].batch.includes(tax_before)){break;}
yield tax_before;}}
function*get_tax_after(){for(const tax_after of taxes.toReversed()){if(taxes_data[tax.id].batch.includes(tax_after)){break;}
yield tax_after;}}
function add_extra_base(other_tax,sign){const tax_amount=taxes_data[tax.id].tax_amount;if(!("tax_amount"in taxes_data[other_tax.id])){taxes_data[other_tax.id].extra_base_for_tax+=sign*tax_amount;}
taxes_data[other_tax.id].extra_base_for_base+=sign*tax_amount;}
if(tax.price_include){if(!special_mode||special_mode==="total_included"){if(tax.include_base_amount){for(const other_tax of get_tax_after()){if(!other_tax.is_base_affected){add_extra_base(other_tax,-1)}}}else{for(const other_tax of get_tax_after()){add_extra_base(other_tax,-1)}}
for(const other_tax of get_tax_before()){add_extra_base(other_tax,-1);}}else{if(tax.include_base_amount){for(const other_tax of get_tax_after()){if(other_tax.is_base_affected){add_extra_base(other_tax,1);}}}}}else if(!tax.price_include){if(!special_mode||special_mode==="total_excluded"){if(tax.include_base_amount){for(const other_tax of get_tax_after()){if(other_tax.is_base_affected){add_extra_base(other_tax,1);}}}}else{if(!tax.include_base_amount){for(const other_tax of get_tax_after()){add_extra_base(other_tax,-1);}}
for(const other_tax of get_tax_before()){add_extra_base(other_tax,-1);}}}},eval_tax_amount_fixed_amount(tax,batch,raw_base,evaluation_context){if(tax.amount_type==="fixed"){return evaluation_context.quantity*tax.amount;}
return null;},eval_tax_amount_price_included(tax,batch,raw_base,evaluation_context){if(tax.amount_type==="percent"){const total_percentage=batch.reduce((sum,batch_tax)=>sum+batch_tax.amount,0)/100.0;const to_price_excluded_factor=total_percentage!==-1?1/(1+total_percentage):0.0;return(raw_base*to_price_excluded_factor*tax.amount)/100.0;}
if(tax.amount_type==="division"){return(raw_base*tax.amount)/100.0;}
return null;},eval_tax_amount_price_excluded(tax,batch,raw_base,evaluation_context){if(tax.amount_type==="percent"){return(raw_base*tax.amount)/100.0;}
if(tax.amount_type==="division"){const total_percentage=batch.reduce((sum,batch_tax)=>sum+batch_tax.amount,0)/100.0;const incl_base_multiplicator=total_percentage===1.0?1.0:1-total_percentage;return(raw_base*tax.amount)/100.0/incl_base_multiplicator;}
return null;},get_tax_details(taxes,price_unit,quantity,{precision_rounding=null,rounding_method="round_per_line",product=null,special_mode=null,manual_tax_amounts=null,}={}){const self=this;function add_tax_amount_to_results(tax,tax_amount){taxes_data[tax.id].tax_amount=tax_amount;if(rounding_method==="round_per_line"){taxes_data[tax.id].tax_amount=roundPrecision(taxes_data[tax.id].tax_amount,precision_rounding);}
if(tax.has_negative_factor){reverse_charge_taxes_data[tax.id].tax_amount=-taxes_data[tax.id].tax_amount;}
self.propagate_extra_taxes_base(sorted_taxes,tax,taxes_data,{special_mode:special_mode,});}
function eval_tax_amount(tax_amount_function,tax){const is_already_computed="tax_amount"in taxes_data[tax.id];if(is_already_computed){return;}
let tax_amount=null;if(manual_tax_amounts&&tax.id in manual_tax_amounts){tax_amount=manual_tax_amounts[tax.id].tax_amount_currency;}else{tax_amount=tax_amount_function(tax,taxes_data[tax.id].batch,raw_base+taxes_data[tax.id].extra_base_for_tax,evaluation_context);}
if(tax_amount!==null){add_tax_amount_to_results(tax,tax_amount);}}
function prepare_tax_extra_data(tax,kwargs={}){let price_include;if(special_mode==="total_included"){price_include=true;}else if(special_mode==="total_excluded"){price_include=false;}else{price_include=tax.price_include;}
return{...kwargs,tax:tax,price_include:price_include,extra_base_for_tax:0.0,extra_base_for_base:0.0,};}
const batching_results=this.batch_for_taxes_computation(taxes,{special_mode:special_mode,});const sorted_taxes=batching_results.sorted_taxes;const taxes_data={};const reverse_charge_taxes_data={};for(const tax of sorted_taxes){taxes_data[tax.id]=prepare_tax_extra_data(tax,{group:batching_results.group_per_tax[tax.id],batch:batching_results.batch_per_tax[tax.id],});if(tax.has_negative_factor){reverse_charge_taxes_data[tax.id]={...taxes_data[tax.id],is_reverse_charge:true,}}}
let raw_base=quantity*price_unit;if(rounding_method==="round_per_line"){raw_base=roundPrecision(raw_base,precision_rounding);}
let evaluation_context={product:product||{},price_unit:price_unit,quantity:quantity,raw_base:raw_base,special_mode:special_mode,};for(const tax of sorted_taxes.toReversed()){eval_tax_amount(this.eval_tax_amount_fixed_amount.bind(this),tax);}
for(const tax of sorted_taxes.toReversed()){if(taxes_data[tax.id].price_include){eval_tax_amount(this.eval_tax_amount_price_included.bind(this),tax);}}
for(const tax of sorted_taxes){if(!taxes_data[tax.id].price_include){eval_tax_amount(this.eval_tax_amount_price_excluded.bind(this),tax);}}
for(const tax of sorted_taxes.toReversed()){const tax_data=taxes_data[tax.id];if(!("tax_amount"in tax_data)){continue;}
let base=null;if(manual_tax_amounts&&"base_amount_currency"in manual_tax_amounts[tax.id]){base=manual_tax_amounts[tax.id].base_amount_currency;}else{let total_tax_amount=taxes_data[tax.id].batch.reduce((sum,other_tax)=>sum+taxes_data[other_tax.id].tax_amount,0);total_tax_amount+=Object.values(taxes_data[tax.id].batch).filter(other_tax=>other_tax.has_negative_factor).reduce((sum,other_tax)=>sum+reverse_charge_taxes_data[other_tax.id].tax_amount,0);base=raw_base+taxes_data[tax.id].extra_base_for_base;if(tax_data.price_include&&(!special_mode||special_mode==="total_included")){base-=total_tax_amount;}}
tax_data.base=base;if(tax.has_negative_factor){const reverse_charge_tax_data=reverse_charge_taxes_data[tax.id];reverse_charge_tax_data.base=base;}}
const taxes_data_list=[];for(const tax of sorted_taxes){const tax_data=taxes_data[tax.id];if("tax_amount"in tax_data){taxes_data_list.push(tax_data);if(tax.has_negative_factor){taxes_data_list.push(reverse_charge_taxes_data[tax.id]);}}}
let total_excluded,total_included;if(taxes_data_list.length>0){total_excluded=taxes_data_list[0].base;const tax_amount=taxes_data_list.reduce((sum,tax_data)=>sum+tax_data.tax_amount,0);total_included=total_excluded+tax_amount;}else{total_excluded=total_included=raw_base;}
return{total_excluded:total_excluded,total_included:total_included,taxes_data:taxes_data_list.map(tax_data=>Object.assign({},{tax:tax_data.tax,group:batching_results.group_per_tax[tax_data.tax.id],batch:batching_results.batch_per_tax[tax_data.tax.id],tax_amount:tax_data.tax_amount,base_amount:tax_data.base,is_reverse_charge:tax_data.is_reverse_charge||false})),};},adapt_price_unit_to_another_taxes(price_unit,product,original_taxes,new_taxes){const original_tax_ids=new Set(original_taxes.map((x)=>x.id));const new_tax_ids=new Set(new_taxes.map((x)=>x.id));if((original_tax_ids.size===new_tax_ids.size&&[...original_tax_ids].every((value)=>new_tax_ids.has(value)))||original_taxes.some((x)=>!x.price_include)){return price_unit;}
let taxes_computation=this.get_tax_details(original_taxes,price_unit,1.0,{rounding_method:"round_globally",product:product,});price_unit=taxes_computation.total_excluded;taxes_computation=this.get_tax_details(new_taxes,price_unit,1.0,{rounding_method:"round_globally",product:product,special_mode:"total_excluded",});let delta=0.0;for(const tax_data of taxes_computation.taxes_data){if(tax_data.tax.price_include){delta+=tax_data.tax_amount;}}
return price_unit+delta;},get_base_line_field_value_from_record(record,field,extra_values,fallback){if(field in extra_values){return extra_values[field]||fallback;}
if(field in record){return record[field]||fallback;}
return fallback;},prepare_base_line_for_taxes_computation(record,kwargs={}){const load=(field,fallback)=>this.get_base_line_field_value_from_record(record,field,kwargs,fallback);const currency=(load('currency_id',null)||load('company_currency_id',null)||load('company_id',{}).currency_id||{})
return{...kwargs,record:record,id:load('id',0),product_id:load('product_id',{}),product_uom_id:load('product_uom_id',{}),tax_ids:load('tax_ids',{}),price_unit:load('price_unit',0.0),quantity:load('quantity',0.0),discount:load('discount',0.0),currency_id:currency,sign:load('sign',1.0),special_mode:kwargs.special_mode||null,special_type:kwargs.special_type||null,rate:load("rate",1.0),manual_tax_amounts:kwargs.manual_tax_amounts||null,}},add_tax_details_in_base_line(base_line,company){const price_unit_after_discount=base_line.price_unit*(1-(base_line.discount/100.0));const currency_pd=base_line.currency_id.rounding;const company_currency_pd=company.currency_id.rounding;const taxes_computation=this.get_tax_details(base_line.tax_ids,price_unit_after_discount,base_line.quantity,{precision_rounding:currency_pd,rounding_method:company.tax_calculation_rounding_method,product:base_line.product_id,special_mode:base_line.special_mode,manual_tax_amounts:base_line.manual_tax_amounts});const rate=base_line.rate;const tax_details=base_line.tax_details={raw_total_excluded_currency:taxes_computation.total_excluded,raw_total_excluded:rate?taxes_computation.total_excluded/rate:0.0,raw_total_included_currency:taxes_computation.total_included,raw_total_included:rate?taxes_computation.total_included/rate:0.0,taxes_data:[]};if(company.tax_calculation_rounding_method==='round_per_line'){tax_details.raw_total_excluded=roundPrecision(tax_details.raw_total_excluded,currency_pd);tax_details.raw_total_included=roundPrecision(tax_details.raw_total_included,currency_pd);}
for(const tax_data of taxes_computation.taxes_data){let tax_amount=rate?tax_data.tax_amount/rate:0.0;let base_amount=rate?tax_data.base_amount/rate:0.0;if(company.tax_calculation_rounding_method==='round_per_line'){tax_amount=roundPrecision(tax_amount,company_currency_pd);base_amount=roundPrecision(base_amount,company_currency_pd);}
tax_details.taxes_data.push({...tax_data,raw_tax_amount_currency:tax_data.tax_amount,raw_tax_amount:tax_amount,raw_base_amount_currency:tax_data.base_amount,raw_base_amount:base_amount});}},add_tax_details_in_base_lines(base_lines,company){for(const base_line of base_lines){this.add_tax_details_in_base_line(base_line,company);}},round_base_lines_tax_details(base_lines,company){const total_per_tax={};const total_per_base={};const country_code=company.account_fiscal_country_id.code;for(const base_line of base_lines){const currency=base_line.currency_id;const tax_details=base_line.tax_details;tax_details.total_excluded_currency=roundPrecision(tax_details.raw_total_excluded_currency,currency.rounding);tax_details.total_excluded=roundPrecision(tax_details.raw_total_excluded,company.currency_id.rounding);tax_details.delta_total_excluded_currency=0.0;tax_details.delta_total_excluded=0.0;tax_details.total_included_currency=roundPrecision(tax_details.raw_total_included_currency,currency.rounding);tax_details.total_included=roundPrecision(tax_details.raw_total_included,company.currency_id.rounding);const taxes_data=tax_details.taxes_data;let index=0;for(const tax_data of taxes_data){const tax=tax_data.tax;tax_data.tax_amount_currency=roundPrecision(tax_data.raw_tax_amount_currency,currency.rounding);tax_data.tax_amount=roundPrecision(tax_data.raw_tax_amount,company.currency_id.rounding);tax_data.base_amount_currency=roundPrecision(tax_data.raw_base_amount_currency,currency.rounding);tax_data.base_amount=roundPrecision(tax_data.raw_base_amount,company.currency_id.rounding);const tax_rounding_key=[tax.id,currency.id,base_line.is_refund,tax_data.is_reverse_charge];if(!(tax_rounding_key in total_per_tax)){total_per_tax[tax_rounding_key]={tax:tax,is_reverse_charge:tax_data.is_reverse_charge,currency:currency,base_amount_currency:0.0,base_amount:0.0,raw_base_amount_currency:0.0,raw_base_amount:0.0,tax_amount_currency:0.0,tax_amount:0.0,raw_tax_amount_currency:0.0,raw_tax_amount:0.0,raw_total_amount_currency:0.0,raw_total_amount:0.0,base_lines:[],};}
const tax_amounts=total_per_tax[tax_rounding_key];tax_amounts.tax_amount_currency+=tax_data.tax_amount_currency;tax_amounts.raw_tax_amount_currency+=tax_data.raw_tax_amount_currency;tax_amounts.tax_amount+=tax_data.tax_amount;tax_amounts.raw_tax_amount+=tax_data.raw_tax_amount;tax_amounts.base_amount_currency+=tax_data.base_amount_currency;tax_amounts.raw_base_amount_currency+=tax_data.raw_base_amount_currency;tax_amounts.base_amount+=tax_data.base_amount;tax_amounts.raw_base_amount+=tax_data.raw_base_amount;tax_amounts.raw_total_amount_currency+=tax_data.raw_base_amount_currency+tax_data.raw_tax_amount_currency;tax_amounts.raw_total_amount+=tax_data.raw_base_amount+tax_data.raw_tax_amount;if(!base_line.special_type){tax_amounts.base_lines.push(base_line);}
const base_rounding_key=[currency.id,base_line.is_refund];if(!(base_rounding_key in total_per_base)){total_per_base[base_rounding_key]={currency:currency,tax_amount_currency:0.0,tax_amount:0.0,base_amount_currency:0.0,base_amount:0.0,raw_base_amount_currency:0.0,raw_base_amount:0.0,raw_total_amount_currency:0.0,raw_total_amount:0.0,base_lines:[],};}
const base_amounts=total_per_base[base_rounding_key];base_amounts.tax_amount_currency+=tax_data.tax_amount_currency;base_amounts.tax_amount+=tax_data.tax_amount;base_amounts.raw_total_amount_currency+=tax_data.raw_tax_amount_currency;base_amounts.raw_total_amount+=tax_data.raw_tax_amount;if(index===0){base_amounts.base_amount_currency+=tax_data.base_amount_currency;base_amounts.raw_base_amount_currency+=tax_data.raw_base_amount_currency;base_amounts.base_amount+=tax_data.base_amount;base_amounts.raw_base_amount+=tax_data.raw_base_amount;base_amounts.raw_total_amount_currency+=tax_data.raw_base_amount_currency;base_amounts.raw_total_amount+=tax_data.raw_base_amount;if(!base_line.special_type){base_amounts.base_lines.push(base_line);}}
index++;}
if(!taxes_data.length){const tax_rounding_key=[null,currency.id,base_line.is_refund,false];if(!(tax_rounding_key in total_per_tax)){total_per_tax[tax_rounding_key]={tax:null,currency:currency,base_amount_currency:0.0,base_amount:0.0,raw_base_amount_currency:0.0,raw_base_amount:0.0,tax_amount_currency:0.0,tax_amount:0.0,raw_tax_amount_currency:0.0,raw_tax_amount:0.0,raw_total_amount_currency:0.0,raw_total_amount:0.0,base_lines:[]};}
const tax_amounts=total_per_tax[tax_rounding_key];tax_amounts.base_amount_currency+=tax_details.total_excluded_currency;tax_amounts.raw_base_amount_currency+=tax_details.raw_total_excluded_currency;tax_amounts.base_amount+=tax_details.total_excluded;tax_amounts.raw_base_amount+=tax_details.raw_total_excluded;tax_amounts.raw_total_amount_currency+=tax_details.raw_total_excluded_currency;tax_amounts.raw_total_amount+=tax_details.raw_total_excluded;if(!base_line.special_type){tax_amounts.base_lines.push(base_line);}
const base_rounding_key=[currency.id,base_line.is_refund];if(!(base_rounding_key in total_per_base)){total_per_base[base_rounding_key]={currency:currency,tax_amount_currency:0.0,tax_amount:0.0,base_amount_currency:0.0,base_amount:0.0,raw_base_amount_currency:0.0,raw_base_amount:0.0,raw_total_amount_currency:0.0,raw_total_amount:0.0,base_lines:[]};}
const base_amounts=total_per_base[base_rounding_key];base_amounts.base_amount_currency+=tax_details.total_excluded_currency;base_amounts.raw_base_amount_currency+=tax_details.raw_total_excluded_currency;base_amounts.base_amount+=tax_details.total_excluded;base_amounts.raw_base_amount+=tax_details.raw_total_excluded;base_amounts.raw_total_amount_currency+=tax_details.raw_total_excluded_currency;base_amounts.raw_total_amount+=tax_details.raw_total_excluded;if(!base_line.special_type){base_amounts.base_lines.push(base_line);}}}
for(const tax_amounts of Object.values(total_per_tax)){tax_amounts.raw_tax_amount_currency=roundPrecision(tax_amounts.raw_tax_amount_currency,tax_amounts.currency.rounding);tax_amounts.raw_tax_amount=roundPrecision(tax_amounts.raw_tax_amount,company.currency_id.rounding);tax_amounts.raw_base_amount_currency=roundPrecision(tax_amounts.raw_base_amount_currency,tax_amounts.currency.rounding);tax_amounts.raw_base_amount=roundPrecision(tax_amounts.raw_base_amount,company.currency_id.rounding);tax_amounts.raw_total_amount_currency=roundPrecision(tax_amounts.raw_total_amount_currency,tax_amounts.currency.rounding);tax_amounts.raw_total_amount=roundPrecision(tax_amounts.raw_total_amount,company.currency_id.rounding);}
for(const base_amounts of Object.values(total_per_base)){base_amounts.raw_base_amount_currency=roundPrecision(base_amounts.raw_base_amount_currency,base_amounts.currency.rounding);base_amounts.raw_base_amount=roundPrecision(base_amounts.raw_base_amount,company.currency_id.rounding);base_amounts.raw_total_amount_currency=roundPrecision(base_amounts.raw_total_amount_currency,base_amounts.currency.rounding);base_amounts.raw_total_amount=roundPrecision(base_amounts.raw_total_amount,company.currency_id.rounding);}
for(const tax_amounts of Object.values(total_per_tax)){const is_reverse_charge=tax_amounts.is_reverse_charge;const currency=tax_amounts.currency;const tax=tax_amounts.tax;if(!tax_amounts.base_lines.length){continue;}
tax_amounts.sorted_base_line_x_tax_data=tax_amounts.base_lines.sort((a,b)=>b.tax_details.total_included_currency-a.tax_details.total_included_currency).map(base_line=>[base_line,base_line.tax_details.taxes_data.map((tax_data,index)=>[index,tax_data]).find(([index,tax_data])=>tax_data.tax.id===tax.id&&tax_data.is_reverse_charge===is_reverse_charge)||null]);tax_amounts.total_included_currency=tax_amounts.base_lines.reduce((sum,base_line)=>sum+Math.abs(base_line.tax_details.total_included_currency),0);if(!tax||!tax_amounts.total_included_currency){continue;}
const delta_tax_amount_currency=tax_amounts.raw_tax_amount_currency-tax_amounts.tax_amount_currency;const delta_tax_amount=tax_amounts.raw_tax_amount-tax_amounts.tax_amount;for(const[delta,delta_field,delta_currency]of[[delta_tax_amount_currency,'tax_amount_currency',currency],[delta_tax_amount,'tax_amount',company.currency_id]]){if(floatIsZero(delta,delta_currency.decimal_places)){continue;}
const sign=delta<0.0?-1:1;let nb_of_errors=Math.round(Math.abs(delta/delta_currency.rounding));let remaining_errors=nb_of_errors;for(const[base_line,index_tax_data]of tax_amounts.sorted_base_line_x_tax_data){const tax_details=base_line.tax_details;if(!remaining_errors||!index_tax_data){break;}
const index=index_tax_data[0];const tax_data=index_tax_data[1];const nb_of_amount_to_distribute=Math.min(Math.ceil(Math.abs(tax_details.total_included_currency*nb_of_errors/tax_amounts.total_included_currency)),remaining_errors);remaining_errors-=nb_of_amount_to_distribute;const amount_to_distribute=sign*nb_of_amount_to_distribute*delta_currency.rounding;tax_data[delta_field]+=amount_to_distribute;tax_amounts[delta_field]+=amount_to_distribute;if(index===0){const base_rounding_key=[tax_amounts.currency.id,base_line.is_refund];const base_amounts=total_per_base[base_rounding_key];base_amounts[delta_field]+=amount_to_distribute;}}}}
for(const tax_amounts of Object.values(total_per_tax)){const currency=tax_amounts.currency;if(!tax_amounts.sorted_base_line_x_tax_data||!tax_amounts.total_included_currency){continue;}
let delta_base_amount_currency;let delta_base_amount;if(country_code==="PT"){delta_base_amount_currency=tax_amounts.raw_total_amount_currency-tax_amounts.base_amount_currency-tax_amounts.tax_amount_currency;delta_base_amount=tax_amounts.raw_total_amount-tax_amounts.base_amount-tax_amounts.tax_amount;}else{delta_base_amount_currency=tax_amounts.raw_base_amount_currency-tax_amounts.base_amount_currency;delta_base_amount=tax_amounts.raw_base_amount-tax_amounts.base_amount;}
for(const[delta,delta_currency_indicator,delta_currency]of[[delta_base_amount_currency,'_currency',currency],[delta_base_amount,'',company.currency_id]]){if(floatIsZero(delta,delta_currency.decimal_places)){continue;}
const sign=delta<0.0?-1:1;let nb_of_errors=Math.round(Math.abs(delta/delta_currency.rounding));let remaining_errors=nb_of_errors;for(const[base_line,index_tax_data]of tax_amounts.sorted_base_line_x_tax_data){const tax_details=base_line.tax_details;if(!remaining_errors){break;}
const nb_of_amount_to_distribute=Math.min(Math.ceil(Math.abs(tax_details.total_included_currency*nb_of_errors/tax_amounts.total_included_currency)),remaining_errors);remaining_errors-=nb_of_amount_to_distribute;const amount_to_distribute=sign*nb_of_amount_to_distribute*delta_currency.rounding;if(index_tax_data){const tax_data=index_tax_data[1];tax_data[`base_amount${delta_currency_indicator}`]+=amount_to_distribute;}else{tax_details[`delta_total_excluded${delta_currency_indicator}`]+=amount_to_distribute;const base_rounding_key=[currency.id,base_line.is_refund];const base_amounts=total_per_base[base_rounding_key];base_amounts[`base_amount${delta_currency_indicator}`]+=amount_to_distribute;}}}}
for(const base_amounts of Object.values(total_per_base)){if(!base_amounts.base_lines.length){continue;}
const base_line=base_amounts.base_lines.sort((a,b)=>a.tax_details.total_included_currency-b.tax_details.total_included_currency)[0];const tax_details=base_line.tax_details;let delta_base_amount_currency;let delta_base_amount;if(country_code==="PT"){delta_base_amount_currency=base_amounts.raw_total_amount_currency-base_amounts.base_amount_currency-base_amounts.tax_amount_currency;delta_base_amount=base_amounts.raw_total_amount-base_amounts.base_amount-base_amounts.tax_amount;}else{delta_base_amount_currency=base_amounts.raw_base_amount_currency-base_amounts.base_amount_currency;delta_base_amount=base_amounts.raw_base_amount-base_amounts.base_amount;}
if(floatIsZero(delta_base_amount_currency,base_amounts.currency.decimal_places)&&floatIsZero(delta_base_amount,company.currency_id.decimal_places)){continue;}
tax_details.delta_total_excluded_currency+=delta_base_amount_currency;tax_details.delta_total_excluded+=delta_base_amount;}},get_tax_totals_summary(base_lines,currency,company,{cash_rounding=null}={}){const company_pd=company.currency_id.rounding;const tax_totals_summary={currency_id:currency.id,currency_pd:currency.rounding,company_currency_id:company.currency_id.id,company_currency_pd:company.currency_id.rounding,has_tax_groups:false,subtotals:[],base_amount_currency:0.0,base_amount:0.0,tax_amount_currency:0.0,tax_amount:0.0,};const global_grouping_function=(base_line,tax_data)=>true;let base_lines_aggregated_values=this.aggregate_base_lines_tax_details(base_lines,global_grouping_function);let values_per_grouping_key=this.aggregate_base_lines_aggregated_values(base_lines_aggregated_values);for(const values of Object.values(values_per_grouping_key)){if(values.grouping_key){tax_totals_summary.has_tax_groups=true;}
tax_totals_summary.base_amount_currency+=values.total_excluded_currency;tax_totals_summary.base_amount+=values.total_excluded;tax_totals_summary.tax_amount_currency+=values.tax_amount_currency;tax_totals_summary.tax_amount+=values.tax_amount;}
const untaxed_amount_subtotal_label=_t("Untaxed Amount");const subtotals={};const tax_group_grouping_function=(base_line,tax_data)=>{return{grouping_key:tax_data.tax.tax_group_id.id,raw_grouping_key:tax_data.tax.tax_group_id,};}
base_lines_aggregated_values=this.aggregate_base_lines_tax_details(base_lines,tax_group_grouping_function);values_per_grouping_key=this.aggregate_base_lines_aggregated_values(base_lines_aggregated_values);const sorted_total_per_tax_group=Object.values(values_per_grouping_key).filter(values=>values.grouping_key).sort((a,b)=>(a.grouping_key.sequence-b.grouping_key.sequence)||(a.grouping_key.id-b.grouping_key.id));const encountered_base_amounts=new Set();const subtotals_order={};for(const[order,values]of sorted_total_per_tax_group.entries()){const tax_group=values.grouping_key;const involved_tax_ids=new Set();const involved_amount_types=new Set();const involved_price_include=new Set();values.base_line_x_taxes_data.forEach(([base_line,taxes_data])=>{taxes_data.forEach(tax_data=>{const tax=tax_data.tax;involved_tax_ids.add(tax.id);involved_amount_types.add(tax.amount_type);involved_price_include.add(tax.price_include);});});let display_base_amount=values.base_amount;let display_base_amount_currency=values.base_amount_currency;if(involved_amount_types.size===1&&involved_amount_types.has("fixed")){display_base_amount=null;display_base_amount_currency=null;}else if(involved_amount_types.size===1&&involved_amount_types.has("division")&&involved_price_include.size===1&&involved_price_include.has(true)){values.base_line_x_taxes_data.forEach(([base_line,_taxes_data])=>{base_line.tax_details.taxes_data.forEach(tax_data=>{if(tax_data.tax.amount_type==='division'){display_base_amount_currency+=tax_data.tax_amount_currency;display_base_amount+=tax_data.tax_amount;}});});}
if(display_base_amount_currency!==null){encountered_base_amounts.add(parseFloat(display_base_amount_currency.toFixed(currency.decimal_places)));}
const preceding_subtotal=tax_group.preceding_subtotal||untaxed_amount_subtotal_label;if(!(preceding_subtotal in subtotals)){subtotals[preceding_subtotal]={tax_groups:[],tax_amount_currency:0.0,tax_amount:0.0,base_amount_currency:0.0,base_amount:0.0,};}
if(!(preceding_subtotal in subtotals_order)){subtotals_order[preceding_subtotal]=order;}
subtotals[preceding_subtotal].tax_groups.push({id:tax_group.id,involved_tax_ids:Array.from(involved_tax_ids),tax_amount_currency:values.tax_amount_currency,tax_amount:values.tax_amount,base_amount_currency:values.base_amount_currency,base_amount:values.base_amount,display_base_amount_currency,display_base_amount,group_name:tax_group.name,group_label:tax_group.pos_receipt_label,});}
if(!Object.keys(subtotals).length){subtotals[untaxed_amount_subtotal_label]={tax_groups:[],tax_amount_currency:0.0,tax_amount:0.0,base_amount_currency:0.0,base_amount:0.0,};}
const ordered_subtotals=Array.from(Object.entries(subtotals)).sort((a,b)=>(subtotals_order[a[0]]||0)-(subtotals_order[b[0]]||0));let accumulated_tax_amount_currency=0.0;let accumulated_tax_amount=0.0;for(const[subtotal_label,subtotal]of ordered_subtotals){subtotal.name=subtotal_label;subtotal.base_amount_currency=tax_totals_summary.base_amount_currency+accumulated_tax_amount_currency;subtotal.base_amount=tax_totals_summary.base_amount+accumulated_tax_amount;for(const tax_group of subtotal.tax_groups){subtotal.tax_amount_currency+=tax_group.tax_amount_currency;subtotal.tax_amount+=tax_group.tax_amount;accumulated_tax_amount_currency+=tax_group.tax_amount_currency;accumulated_tax_amount+=tax_group.tax_amount;}
tax_totals_summary.subtotals.push(subtotal);}
const cash_rounding_lines=base_lines.filter(base_line=>base_line.special_type==='cash_rounding');if(cash_rounding_lines.length){tax_totals_summary.cash_rounding_base_amount_currency=0.0;tax_totals_summary.cash_rounding_base_amount=0.0;cash_rounding_lines.forEach(base_line=>{const tax_details=base_line.tax_details;tax_totals_summary.cash_rounding_base_amount_currency+=tax_details.total_excluded_currency;tax_totals_summary.cash_rounding_base_amount+=tax_details.total_excluded;});}else if(cash_rounding!==null){const strategy=cash_rounding.strategy;const cash_rounding_pd=cash_rounding.rounding;const cash_rounding_method=cash_rounding.rounding_method;const total_amount_currency=tax_totals_summary.base_amount_currency+tax_totals_summary.tax_amount_currency;const total_amount=tax_totals_summary.base_amount+tax_totals_summary.tax_amount;const expected_total_amount_currency=roundPrecision(total_amount_currency,cash_rounding_pd,cash_rounding_method);let cash_rounding_base_amount_currency=expected_total_amount_currency-total_amount_currency;const rate=total_amount?Math.abs(total_amount_currency/total_amount):0.0;let cash_rounding_base_amount=rate?roundPrecision(cash_rounding_base_amount_currency/rate,company_pd):0.0;if(!floatIsZero(cash_rounding_base_amount_currency,currency.decimal_places)){if(strategy==='add_invoice_line'){tax_totals_summary.cash_rounding_base_amount_currency=cash_rounding_base_amount_currency;tax_totals_summary.cash_rounding_base_amount=cash_rounding_base_amount;tax_totals_summary.base_amount_currency+=cash_rounding_base_amount_currency;tax_totals_summary.base_amount+=cash_rounding_base_amount;subtotals[untaxed_amount_subtotal_label].base_amount_currency+=cash_rounding_base_amount_currency;subtotals[untaxed_amount_subtotal_label].base_amount+=cash_rounding_base_amount;}else if(strategy==='biggest_tax'){const all_subtotal_tax_group=tax_totals_summary.subtotals.flatMap(subtotal=>subtotal.tax_groups.map(tax_group=>[subtotal,tax_group]));if(all_subtotal_tax_group.length){const[max_subtotal,max_tax_group]=all_subtotal_tax_group.reduce((a,b)=>(b[1].tax_amount_currency>a[1].tax_amount_currency?b:a));max_tax_group.tax_amount_currency+=cash_rounding_base_amount_currency;max_tax_group.tax_amount+=cash_rounding_base_amount;max_subtotal.tax_amount_currency+=cash_rounding_base_amount_currency;max_subtotal.tax_amount+=cash_rounding_base_amount;tax_totals_summary.tax_amount_currency+=cash_rounding_base_amount_currency;tax_totals_summary.tax_amount+=cash_rounding_base_amount;}else{cash_rounding_base_amount_currency=0.0
cash_rounding_base_amount=0.0}}}}
const cash_rounding_base_amount_currency=tax_totals_summary.cash_rounding_base_amount_currency||0.0;const cash_rounding_base_amount=tax_totals_summary.cash_rounding_base_amount||0.0;tax_totals_summary.base_amount_currency-=cash_rounding_base_amount_currency;tax_totals_summary.base_amount-=cash_rounding_base_amount;for(const subtotal of tax_totals_summary.subtotals){subtotal.base_amount_currency-=cash_rounding_base_amount_currency;subtotal.base_amount-=cash_rounding_base_amount;}
encountered_base_amounts.add(parseFloat(tax_totals_summary.base_amount_currency.toFixed(currency.decimal_places)));tax_totals_summary.same_tax_base=encountered_base_amounts.size===1;tax_totals_summary.total_amount_currency=tax_totals_summary.base_amount_currency+tax_totals_summary.tax_amount_currency+cash_rounding_base_amount_currency;tax_totals_summary.total_amount=tax_totals_summary.base_amount+tax_totals_summary.tax_amount+cash_rounding_base_amount;return tax_totals_summary;},aggregate_base_line_tax_details(base_line,grouping_function){const values_per_grouping_key={};const tax_details=base_line.tax_details;const taxes_data=tax_details.taxes_data;for(const tax_data of taxes_data){const generated_grouping_key=grouping_function(base_line,tax_data);let raw_grouping_key=generated_grouping_key;let grouping_key=generated_grouping_key;if(typeof raw_grouping_key==='object'&&("raw_grouping_key"in raw_grouping_key)){raw_grouping_key=generated_grouping_key.raw_grouping_key;grouping_key=generated_grouping_key.grouping_key;}
if(typeof grouping_key==='object'){grouping_key=JSON.stringify(raw_grouping_key);}
if(!(grouping_key in values_per_grouping_key)){values_per_grouping_key[grouping_key]={base_amount_currency:tax_data.base_amount_currency,base_amount:tax_data.base_amount,raw_base_amount_currency:tax_data.raw_base_amount_currency,raw_base_amount:tax_data.raw_base_amount,tax_amount_currency:0.0,tax_amount:0.0,raw_tax_amount_currency:0.0,raw_tax_amount:0.0,total_excluded_currency:tax_details.total_excluded_currency+tax_details.delta_total_excluded_currency,total_excluded:tax_details.total_excluded+tax_details.delta_total_excluded,taxes_data:[],grouping_key:raw_grouping_key};}
const values=values_per_grouping_key[grouping_key];values.taxes_data.push(tax_data);values.tax_amount_currency+=tax_data.tax_amount_currency;values.tax_amount+=tax_data.tax_amount;values.raw_tax_amount_currency+=tax_data.raw_tax_amount_currency;values.raw_tax_amount+=tax_data.raw_tax_amount;}
if(!taxes_data.length){values_per_grouping_key[null]={base_amount_currency:tax_details.total_excluded_currency+tax_details.delta_total_excluded_currency,base_amount:tax_details.total_excluded+tax_details.delta_total_excluded,raw_base_amount_currency:tax_details.raw_total_excluded_currency,raw_base_amount:tax_details.raw_total_excluded,total_excluded_currency:tax_details.total_excluded_currency+tax_details.delta_total_excluded_currency,total_excluded:tax_details.total_excluded+tax_details.delta_total_excluded,tax_amount_currency:0.0,tax_amount:0.0,raw_tax_amount_currency:0.0,raw_tax_amount:0.0,taxes_data:[],grouping_key:null};}
return values_per_grouping_key;},aggregate_base_lines_tax_details(base_lines,grouping_function){return base_lines.map(base_line=>[base_line,this.aggregate_base_line_tax_details(base_line,grouping_function)]);},aggregate_base_lines_aggregated_values(base_lines_aggregated_values){const default_float_fields=new Set(['base_amount_currency','base_amount','raw_base_amount_currency','raw_base_amount','tax_amount_currency','tax_amount','raw_tax_amount_currency','raw_tax_amount','total_excluded_currency','total_excluded']);const values_per_grouping_key={};for(const[base_line,aggregated_values]of base_lines_aggregated_values){for(const[raw_grouping_key,values]of Object.entries(aggregated_values)){const grouping_key=values.grouping_key;if(!(raw_grouping_key in values_per_grouping_key)){const initial_values=values_per_grouping_key[raw_grouping_key]={base_line_x_taxes_data:[],grouping_key:grouping_key,};default_float_fields.forEach(field=>{initial_values[field]=0.0;});}
const agg_values=values_per_grouping_key[raw_grouping_key];default_float_fields.forEach(field=>{agg_values[field]+=values[field];});agg_values.base_line_x_taxes_data.push([base_line,values.taxes_data]);}}
return values_per_grouping_key;},};return __exports;});;

/* /account/static/src/core/utils/product_and_label_autoresize.js */
odoo.define('@account/core/utils/product_and_label_autoresize',['@web/core/utils/autoresize'],function(require){'use strict';let __exports={};const{useAutoresize}=require("@web/core/utils/autoresize");__exports.useProductAndLabelAutoresize=useProductAndLabelAutoresize;function useProductAndLabelAutoresize(ref,options={}){useAutoresize(ref,{onResize:productAndLabelResizeTextArea,...options});}
__exports.productAndLabelResizeTextArea=productAndLabelResizeTextArea;function productAndLabelResizeTextArea(textarea,options={}){const style=window.getComputedStyle(textarea);if(options.targetParentName){let target=textarea.parentElement;let shouldContinue=true;while(target&&shouldContinue){const totalParentHeight=Array.from(target.children).reduce((total,child)=>{const childHeight=child.style.height||style.lineHeight;return total+parseFloat(childHeight);},0);target.style.height=`${totalParentHeight}px`;if(target.getAttribute("name")===options.targetParentName){shouldContinue=false;}
target=target.parentElement;}}}
return __exports;});;

/* /payment/static/src/js/payment_wizard_copy_clipboard_field.js */
odoo.define('@payment/js/payment_wizard_copy_clipboard_field',['@web/core/registry','@web/views/fields/copy_clipboard/copy_clipboard_field','@web/core/copy_button/copy_button'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{copyClipboardButtonField,CopyClipboardButtonField,}=require("@web/views/fields/copy_clipboard/copy_clipboard_field");const{CopyButton}=require("@web/core/copy_button/copy_button");class PaymentWizardCopyButton extends CopyButton{async onClick(){await this.env.model.mutex.getUnlockedDef();return super.onClick();}}
class PaymentWizardCopyClipboardButtonField extends CopyClipboardButtonField{static components={CopyButton:PaymentWizardCopyButton};}
const paymentWizardCopyClipboardButtonField={...copyClipboardButtonField,component:PaymentWizardCopyClipboardButtonField,};registry.category("fields").add("PaymentWizardCopyClipboardButtonField",paymentWizardCopyClipboardButtonField);return __exports;});;

/* /utm/static/src/js/utm_campaign_kanban_examples.js */
odoo.define('@utm/js/utm_campaign_kanban_examples',['@web/core/l10n/translation','@web/core/registry'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const exampleData={ghostColumns:[_t('Ideas'),_t('Design'),_t('Review'),_t('Send'),_t('Done')],applyExamplesText:_t("Use This For My Campaigns"),allowedGroupBys:['stage_id'],examples:[{name:_t('Creative Flow'),columns:[_t('Ideas'),_t('Design'),_t('Review'),_t('Send'),_t('Done')],description:_t("Collect ideas, design creative content and publish it once reviewed."),},{name:_t('Event-driven Flow'),columns:[_t('Later'),_t('This Month'),_t('This Week'),_t('Running'),_t('Sent')],description:_t("Track incoming events (e.g. Christmas, Black Friday, ...) and publish timely content."),},{name:_t('Soft-Launch Flow'),columns:[_t('Pre-Launch'),_t('Soft-Launch'),_t('Deploy'),_t('Report'),_t('Done')],description:_t("Prepare your Campaign, test it with part of your audience and deploy it fully afterwards."),},{name:_t('Audience-driven Flow'),columns:[_t('Gather Data'),_t('List-Building'),_t('Copywriting'),_t('Sent')],description:_t("Gather data, build a recipient list and write content based on your Marketing target."),},{name:_t('Approval-based Flow'),columns:[_t('To be Approved'),_t('Approved'),_t('Deployed')],description:_t("Prepare Campaigns and get them approved before making them go live."),}],};registry.category("kanban_examples").add("utm_campaign",exampleData);return __exports;});;

/* /sale/static/src/js/badge_extra_price/badge_extra_price.js */
odoo.define('@sale/js/badge_extra_price/badge_extra_price',['@odoo/owl','@web/core/currency'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{formatCurrency}=require("@web/core/currency");const BadgeExtraPrice=__exports.BadgeExtraPrice=class BadgeExtraPrice extends Component{static template="sale.BadgeExtraPrice";static props={price:Number,currencyId:Number,};getFormattedPrice(){return formatCurrency(Math.abs(this.props.price),this.props.currencyId);}}
return __exports;});;

/* /sale/static/src/js/sale_action_helper/sale_action_helper.js */
odoo.define('@sale/js/sale_action_helper/sale_action_helper',['@odoo/owl','@web/core/utils/hooks','@sale/js/sale_action_helper/sale_action_helper_dialog'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{SaleActionHelperDialog}=require("@sale/js/sale_action_helper/sale_action_helper_dialog")
const SaleActionHelper=__exports.SaleActionHelper=class SaleActionHelper extends Component{static template="sale.SaleActionHelper";static props={noContentHelp:String,}
setup(){this.dialogService=useService("dialog");}
openVideoPreview(){this.dialogService.add(SaleActionHelperDialog,{url:"https://www.youtube.com/embed/N4zw-2t6spk?autoplay=1",})}};return __exports;});;

/* /sale/static/src/js/sale_action_helper/sale_action_helper_dialog.js */
odoo.define('@sale/js/sale_action_helper/sale_action_helper_dialog',['@web/core/dialog/dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{Component}=require("@odoo/owl");const SaleActionHelperDialog=__exports.SaleActionHelperDialog=class SaleActionHelperDialog extends Component{static components={Dialog};static template="sale.SaleActionHelperDialog";static props={url:String,close:Function,};}
return __exports;});;

/* /sale/static/src/js/combo_configurator_dialog/combo_configurator_dialog.js */
odoo.define('@sale/js/combo_configurator_dialog/combo_configurator_dialog',['@web/core/l10n/translation','@web/core/dialog/dialog','@web/core/currency','@web/core/network/rpc','@web/core/utils/hooks','@odoo/owl','@sale/js/product_card/product_card','@sale/js/models/product_combo','@sale/js/models/product_template_attribute_line','@sale/js/product_configurator_dialog/product_configurator_dialog','@sale/js/quantity_buttons/quantity_buttons'],function(require){'use strict';let __exports={};const{_t}=require('@web/core/l10n/translation');const{Dialog}=require('@web/core/dialog/dialog');const{formatCurrency}=require('@web/core/currency');const{rpc}=require('@web/core/network/rpc');const{useService}=require('@web/core/utils/hooks');const{Component,useState,useSubEnv}=require('@odoo/owl');const{ProductCard}=require("@sale/js/product_card/product_card");const{ProductCombo}=require("@sale/js/models/product_combo");const{ProductTemplateAttributeLine}=require("@sale/js/models/product_template_attribute_line");const{ProductConfiguratorDialog}=require("@sale/js/product_configurator_dialog/product_configurator_dialog");const{QuantityButtons}=require("@sale/js/quantity_buttons/quantity_buttons");const ComboConfiguratorDialog=__exports.ComboConfiguratorDialog=class ComboConfiguratorDialog extends Component{static template='sale.ComboConfiguratorDialog';static components={Dialog,ProductCard,QuantityButtons};static props={product_tmpl_id:Number,display_name:String,quantity:Number,price:Number,combos:{type:Array,element:ProductCombo},currency_id:Number,company_id:{type:Number,optional:true},pricelist_id:{type:Number,optional:true},date:String,price_info:{type:String,optional:true},edit:{type:Boolean,optional:true},options:{type:Object,optional:true,shape:{showQuantity:{type:Boolean,optional:true},},},save:Function,discard:Function,close:Function,};static defaultProps={options:{showQuantity:true,},};setup(){this.dialog=useService('dialog');this.env.dialogData.dismiss=!this.props.edit&&this.props.discard.bind(this);this.state=useState({selectedComboItems:new Map(),quantity:this.props.quantity,basePrice:this.props.price,isLoading:false,});this._initSelectedComboItems();this.getPriceUrl='/sale/combo_configurator/get_price';useSubEnv({currency:{id:this.props.currency_id}});}
async selectComboItem(comboId,comboItem){comboItem=this.getSelectedOrProvidedComboItem(comboId,comboItem);let product=comboItem.product;if(comboItem.is_configurable){this.dialog.add(ProductConfiguratorDialog,{productTemplateId:product.product_tmpl_id,ptavIds:product.selectedPtavIds,customPtavs:product.selectedCustomPtavs,quantity:1,companyId:this.props.company_id,pricelistId:this.props.pricelist_id,currencyId:this.props.currency_id,soDate:this.props.date,edit:true,options:{canChangeVariant:false,showQuantity:false,showPrice:false},save:async configuredProduct=>{const selectedComboItem=comboItem.deepCopy();selectedComboItem.product.ptals=configuredProduct.attribute_lines.map(ProductTemplateAttributeLine.fromProductConfiguratorPtal);this.state.selectedComboItems.set(comboId,selectedComboItem);},discard:()=>{},...this._getAdditionalDialogProps(),});}else{this.state.selectedComboItems.set(comboId,comboItem.deepCopy());}}
async setQuantity(quantity){if(quantity<=0)quantity=1;this.state.quantity=quantity;this.state.basePrice=await rpc(this.getPriceUrl,{product_tmpl_id:this.props.product_tmpl_id,currency_id:this.props.currency_id,quantity:quantity,date:this.props.date,company_id:this.props.company_id,pricelist_id:this.props.pricelist_id,...this._getAdditionalRpcParams(),});}
getSelectedOrProvidedComboItem(comboId,comboItem){const selectedComboItem=this.state.selectedComboItems.get(comboId);const isComboItemAlreadySelected=selectedComboItem?.id===comboItem.id;return isComboItemAlreadySelected?selectedComboItem:comboItem;}
get totalMessage(){return _t("Total: %s",this.formattedTotalPrice);}
get formattedTotalPrice(){return formatCurrency(this.state.quantity*this._comboPrice,this.props.currency_id);}
get areAllCombosSelected(){return this.state.selectedComboItems.size===this.props.combos.length;}
async confirm(options){this.state.isLoading=true;await this.props.save(this._comboProductData,this._selectedComboItems,options).finally(()=>this.state.isLoading=false)
this.props.close();}
cancel(){if(!this.props.edit){this.props.discard();}
this.props.close();}
_initSelectedComboItems(){for(const combo of this.props.combos){const comboItem=combo.selectedComboItem;if(comboItem){this.state.selectedComboItems.set(combo.id,comboItem.deepCopy());}}}
get _comboPrice(){const extraPrice=Array.from(this.state.selectedComboItems.values()).reduce((price,item)=>price+item.totalExtraPrice,0);return this.state.basePrice+extraPrice;}
get _comboProductData(){return{'quantity':this.state.quantity};}
get _selectedComboItems(){const sortedItems=new Map([...this.state.selectedComboItems.entries()].sort((entry1,entry2)=>this.props.combos.findIndex(combo=>combo.id===entry1[0])
-this.props.combos.findIndex(combo=>combo.id===entry2[0])));return Array.from(sortedItems.values());}
_getAdditionalRpcParams(){return{};}
_getAdditionalDialogProps(){return{};}}
return __exports;});;

/* /sale/static/src/js/models/product_combo.js */
odoo.define('@sale/js/models/product_combo',['@sale/js/models/product_combo_item'],function(require){'use strict';let __exports={};const{ProductComboItem}=require("@sale/js/models/product_combo_item");const ProductCombo=__exports.ProductCombo=class ProductCombo{constructor({id,name,combo_items}){this.id=id;this.name=name;this.combo_items=combo_items.map(item=>new ProductComboItem(item));}
get selectedComboItem(){return this.combo_items.find(item=>item.is_selected);}}
return __exports;});;

/* /sale/static/src/js/models/product_combo_item.js */
odoo.define('@sale/js/models/product_combo_item',['@sale/js/models/product_product'],function(require){'use strict';let __exports={};const{ProductProduct}=require("@sale/js/models/product_product");const ProductComboItem=__exports.ProductComboItem=class ProductComboItem{constructor({id,extra_price,is_selected,is_configurable,product}){this.id=id;this.extra_price=extra_price;this.is_selected=is_selected;this.is_configurable=is_configurable;this.product=new ProductProduct(product);}
get totalExtraPrice(){return this.extra_price+this.product.selectedNoVariantPtavsPriceExtra;}
deepCopy(){return new ProductComboItem(JSON.parse(JSON.stringify(this)));}}
return __exports;});;

/* /sale/static/src/js/models/product_product.js */
odoo.define('@sale/js/models/product_product',['@sale/js/models/product_template_attribute_line'],function(require){'use strict';let __exports={};const{ProductTemplateAttributeLine}=require("@sale/js/models/product_template_attribute_line");const ProductProduct=__exports.ProductProduct=class ProductProduct{constructor(...args){this.setup(...args);}
setup({id,product_tmpl_id,display_name,ptals,image_src}){this.id=id;this.product_tmpl_id=product_tmpl_id;this.display_name=display_name;this.ptals=ptals.map(ptal=>new ProductTemplateAttributeLine(ptal));this.image_src=image_src;}
get noVariantPtals(){return this.ptals.filter(ptal=>ptal.create_variant==='no_variant');}
get selectedNoVariantPtavsPriceExtra(){return this.noVariantPtals.reduce((price,ptal)=>price+ptal.selectedPtavsPriceExtra,0);}
get selectedPtavIds(){return this.ptals.flatMap(ptal=>ptal.selected_ptavs).map(ptav=>ptav.id);}
get selectedNoVariantPtavIds(){return this.noVariantPtals.flatMap(ptal=>ptal.selected_ptavs).map(ptav=>ptav.id);}
get selectedCustomPtavs(){return this.ptals.filter(ptal=>ptal.hasSelectedCustomPtav).flatMap(ptal=>ptal.selected_ptavs).map(ptav=>({'id':ptav.id,'value':ptav.custom_value,}));}}
return __exports;});;

/* /sale/static/src/js/models/product_template_attribute_line.js */
odoo.define('@sale/js/models/product_template_attribute_line',['@sale/js/models/product_template_attribute_value'],function(require){'use strict';let __exports={};const{ProductTemplateAttributeValue}=require("@sale/js/models/product_template_attribute_value");const ProductTemplateAttributeLine=__exports.ProductTemplateAttributeLine=class ProductTemplateAttributeLine{constructor({id,name,create_variant,selected_ptavs}){this.id=id;this.name=name;this.create_variant=create_variant;this.selected_ptavs=selected_ptavs.map(ptav=>new ProductTemplateAttributeValue(ptav));}
static fromProductConfiguratorPtal(productConfiguratorPtal){const selectedPtavIds=new Set(productConfiguratorPtal.selected_attribute_value_ids);const selectedPtavs=productConfiguratorPtal.attribute_values.filter(ptav=>selectedPtavIds.has(ptav.id)).map(ptav=>new ProductTemplateAttributeValue({id:ptav.id,name:ptav.name,price_extra:ptav.price_extra,custom_value:productConfiguratorPtal.customValue,}));return new ProductTemplateAttributeLine({id:productConfiguratorPtal.id,name:productConfiguratorPtal.attribute.name,create_variant:productConfiguratorPtal.create_variant,selected_ptavs:selectedPtavs,});}
get selectedPtavsPriceExtra(){return this.selected_ptavs.reduce((price,ptav)=>price+ptav.price_extra,0);}
get hasSelectedCustomPtav(){return this.selected_ptavs.some(ptav=>ptav.custom_value);}
get ptalDisplayName(){const selectedPtavNames=this.selected_ptavs.map(ptav=>ptav.name).join(', ');let ptalDisplayName=`${this.name}: ${selectedPtavNames}`;if(this.hasSelectedCustomPtav){ptalDisplayName+=` (${this.selected_ptavs[0].custom_value})`;}
return ptalDisplayName;}}
return __exports;});;

/* /sale/static/src/js/models/product_template_attribute_value.js */
odoo.define('@sale/js/models/product_template_attribute_value',[],function(require){'use strict';let __exports={};const ProductTemplateAttributeValue=__exports.ProductTemplateAttributeValue=class ProductTemplateAttributeValue{constructor({id,name,price_extra,custom_value}){this.id=id;this.name=name;this.price_extra=price_extra;this.custom_value=custom_value;}}
return __exports;});;

/* /sale/static/src/js/product/product.js */
odoo.define('@sale/js/product/product',['@odoo/owl','@web/core/currency','@sale/js/product_template_attribute_line/product_template_attribute_line','@sale/js/quantity_buttons/quantity_buttons','@sale/js/sale_utils'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{formatCurrency}=require("@web/core/currency");const{ProductTemplateAttributeLine:PTAL}=require("@sale/js/product_template_attribute_line/product_template_attribute_line");const{QuantityButtons}=require("@sale/js/quantity_buttons/quantity_buttons");const{getSelectedCustomPtav}=require("@sale/js/sale_utils");const Product=__exports.Product=class Product extends Component{static components={PTAL,QuantityButtons};static template="sale.Product";static props={id:{type:[Number,{value:false}],optional:true},product_tmpl_id:Number,display_name:String,description_sale:[Boolean,String],price:Number,quantity:Number,attribute_lines:Object,optional:Boolean,imageURL:{type:String,optional:true},archived_combinations:Array,exclusions:Object,parent_exclusions:Object,parent_product_tmpl_id:{type:Number,optional:true},price_info:{type:String,optional:true},};getFormattedPrice(){return formatCurrency(this.props.price,this.env.currency.id);}
get isMainProduct(){return this.env.mainProductTmplId===this.props.product_tmpl_id;}
get imageUrl(){const modelPath=this.props.id?`product.product/${ this.props.id }`:`product.template/${ this.props.product_tmpl_id }`;return`/web/image/${ modelPath }/image_256`;}
shouldShowPtal(ptal){return this.env.canChangeVariant||ptal.create_variant==='no_variant'||!!getSelectedCustomPtav(ptal);}}
return __exports;});;

/* /sale/static/src/js/product_card/product_card.js */
odoo.define('@sale/js/product_card/product_card',['@odoo/owl','@sale/js/badge_extra_price/badge_extra_price','@sale/js/models/product_product'],function(require){'use strict';let __exports={};const{Component}=require('@odoo/owl');const{BadgeExtraPrice}=require("@sale/js/badge_extra_price/badge_extra_price");const{ProductProduct}=require("@sale/js/models/product_product");const ProductCard=__exports.ProductCard=class ProductCard extends Component{static template='sale.ProductCard';static components={BadgeExtraPrice};static props={product:ProductProduct,extraPrice:{type:Number,optional:true},onClick:Function,isSelected:{type:Boolean,optional:true},};shouldShowPtal(ptal){return(ptal.selected_ptavs.length>0&&(ptal.hasSelectedCustomPtav||ptal.create_variant==='no_variant'));}}
return __exports;});;

/* /sale/static/src/js/product_configurator_dialog/product_configurator_dialog.js */
odoo.define('@sale/js/product_configurator_dialog/product_configurator_dialog',['@odoo/owl','@web/core/dialog/dialog','@web/core/l10n/translation','@web/core/network/rpc','@sale/js/product_list/product_list'],function(require){'use strict';let __exports={};const{Component,onWillStart,useState,useSubEnv}=require("@odoo/owl");const{Dialog}=require('@web/core/dialog/dialog');const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{ProductList}=require("@sale/js/product_list/product_list");const ProductConfiguratorDialog=__exports.ProductConfiguratorDialog=class ProductConfiguratorDialog extends Component{static components={Dialog,ProductList};static template='sale.ProductConfiguratorDialog';static props={productTemplateId:Number,ptavIds:{type:Array,element:Number},customPtavs:{type:Array,element:Object,shape:{id:Number,value:String,}},quantity:Number,productUOMId:{type:Number,optional:true},companyId:{type:Number,optional:true},pricelistId:{type:Number,optional:true},currencyId:{type:Number,optional:true},soDate:String,edit:{type:Boolean,optional:true},options:{type:Object,optional:true,shape:{canChangeVariant:{type:Boolean,optional:true},showQuantity:{type:Boolean,optional:true},showPrice:{type:Boolean,optional:true},},},save:Function,discard:Function,close:Function,};static defaultProps={edit:false,}
setup(){this.title=_t("Configure your product");this.env.dialogData.dismiss=!this.props.edit&&this.props.discard.bind(this);this.state=useState({products:[],optionalProducts:[],});this.currency={id:this.props.currencyId};this.getValuesUrl='/sale/product_configurator/get_values';this.createProductUrl='/sale/product_configurator/create_product';this.updateCombinationUrl='/sale/product_configurator/update_combination';this.getOptionalProductsUrl='/sale/product_configurator/get_optional_products';useSubEnv({mainProductTmplId:this.props.productTemplateId,currency:this.currency,canChangeVariant:this.props.options?.canChangeVariant??true,showQuantity:this.props.options?.showQuantity??true,showPrice:this.props.options?.showPrice??true,addProduct:this._addProduct.bind(this),removeProduct:this._removeProduct.bind(this),setQuantity:this._setQuantity.bind(this),updateProductTemplateSelectedPTAV:this._updateProductTemplateSelectedPTAV.bind(this),updatePTAVCustomValue:this._updatePTAVCustomValue.bind(this),isPossibleCombination:this._isPossibleCombination,});onWillStart(async()=>{const{products,optional_products,currency_id,}=await this._loadData(this.props.edit);this.state.products=products;this.state.optionalProducts=optional_products;for(const customPtav of this.props.customPtavs){this._updatePTAVCustomValue(this.env.mainProductTmplId,customPtav.id,customPtav.value);}
this._checkExclusions(this.state.products[0]);this.currency.id??=currency_id;});}
async _loadData(onlyMainProduct){return rpc(this.getValuesUrl,{product_template_id:this.props.productTemplateId,quantity:this.props.quantity,currency_id:this.currency.id,so_date:this.props.soDate,product_uom_id:this.props.productUOMId,company_id:this.props.companyId,pricelist_id:this.props.pricelistId,ptav_ids:this.props.ptavIds,only_main_product:onlyMainProduct,...this._getAdditionalRpcParams(),});}
async _createProduct(product){return rpc(this.createProductUrl,{product_template_id:product.product_tmpl_id,ptav_ids:this._getCombination(product),});}
async _updateCombination(product,quantity){return rpc(this.updateCombinationUrl,{product_template_id:product.product_tmpl_id,ptav_ids:this._getCombination(product),currency_id:this.currency.id,so_date:this.props.soDate,quantity:quantity,product_uom_id:this.props.productUOMId,company_id:this.props.companyId,pricelist_id:this.props.pricelistId,...this._getAdditionalRpcParams(),});}
async _getOptionalProducts(product){return rpc(this.getOptionalProductsUrl,{product_template_id:product.product_tmpl_id,ptav_ids:this._getCombination(product),parent_ptav_ids:this._getParentsCombination(product),currency_id:this.currency.id,so_date:this.props.soDate,company_id:this.props.companyId,pricelist_id:this.props.pricelistId,...this._getAdditionalRpcParams(),});}
_getAdditionalRpcParams(){return{};}
async _addProduct(productTmplId){const index=this.state.optionalProducts.findIndex(p=>p.product_tmpl_id===productTmplId);if(index>=0){this.state.products.push(...this.state.optionalProducts.splice(index,1));const product=this._findProduct(productTmplId);const newOptionalProducts=(await this._getOptionalProducts(product)).filter(p=>!this._findProduct(p.product_tmpl_id));this.state.optionalProducts.push(...newOptionalProducts);}}
_removeProduct(productTmplId){const index=this.state.products.findIndex(p=>p.product_tmpl_id===productTmplId);if(index>=0){this.state.optionalProducts.push(...this.state.products.splice(index,1));for(const childProduct of this._getChildProducts(productTmplId)){this._removeProduct(childProduct.product_tmpl_id);this.state.optionalProducts.splice(this.state.optionalProducts.findIndex(p=>p.product_tmpl_id===childProduct.product_tmpl_id),1);}}}
async _setQuantity(productTmplId,quantity){if(quantity<=0){if(productTmplId===this.env.mainProductTmplId){quantity=1;}else{this._removeProduct(productTmplId);return true;}}
const product=this._findProduct(productTmplId);if(product.quantity===quantity){return false;}
const{price}=await this._updateCombination(product,quantity);product.quantity=quantity;product.price=parseFloat(price);return true;}
async _updateProductTemplateSelectedPTAV(productTmplId,ptalId,ptavId,isMulti){const product=this._findProduct(productTmplId);const ptal=product.attribute_lines.find(line=>line.id===ptalId);ptavId=parseInt(ptavId);if(isMulti){const selectedPtavIds=new Set(ptal.selected_attribute_value_ids);selectedPtavIds.has(ptavId)?selectedPtavIds.delete(ptavId):selectedPtavIds.add(ptavId);ptal.selected_attribute_value_ids=Array.from(selectedPtavIds);}else{ptal.selected_attribute_value_ids=[ptavId];}
this._checkExclusions(product);if(this._isPossibleCombination(product)){const updatedValues=await this._updateCombination(product,product.quantity);Object.assign(product,updatedValues);if(!product.id&&product.attribute_lines.every(ptal=>ptal.create_variant==="always")){const combination=this._getCombination(product);product.archived_combinations=product.archived_combinations.concat([combination]);this._checkExclusions(product);}}}
_updatePTAVCustomValue(productTmplId,ptavId,customValue){const product=this._findProduct(productTmplId);product.attribute_lines.find(ptal=>ptal.selected_attribute_value_ids.includes(ptavId)).customValue=customValue;}
_checkExclusions(product){const combination=this._getCombination(product);const exclusions=product.exclusions;const parentExclusions=product.parent_exclusions;const archivedCombinations=product.archived_combinations;const parentCombination=this._getParentsCombination(product);const childProducts=this._getChildProducts(product.product_tmpl_id)
const ptavList=product.attribute_lines.flat().flatMap(ptal=>ptal.attribute_values)
ptavList.map(ptav=>ptav.excluded=false);if(exclusions){for(const ptavId of combination){for(const excludedPtavId of exclusions[ptavId]){ptavList.find(ptav=>ptav.id===excludedPtavId).excluded=true;}}}
if(parentCombination){for(const ptavId of parentCombination){for(const excludedPtavId of(parentExclusions[ptavId]||[])){const ptav=ptavList.find(ptav=>ptav.id===excludedPtavId);if(ptav){ptav.excluded=true;}}}}
if(archivedCombinations){for(const excludedCombination of archivedCombinations){const ptavCommon=excludedCombination.filter((ptav)=>combination.includes(ptav));if(ptavCommon.length===combination.length){for(const excludedPtavId of ptavCommon){ptavList.find(ptav=>ptav.id===excludedPtavId).excluded=true;}}else if(ptavCommon.length===(combination.length-1)){const disabledPtavId=excludedCombination.find((ptav)=>!combination.includes(ptav));const excludedPtav=ptavList.find(ptav=>ptav.id===disabledPtavId)
if(excludedPtav){excludedPtav.excluded=true;}}}}
for(const optionalProductTmpl of childProducts){this._checkExclusions(optionalProductTmpl);}}
_findProduct(productTmplId){return this.state.products.find(p=>p.product_tmpl_id===productTmplId)||this.state.optionalProducts.find(p=>p.product_tmpl_id===productTmplId);}
_getChildProducts(productTmplId){return[...this.state.products.filter(p=>p.parent_product_tmpl_id===productTmplId),...this.state.optionalProducts.filter(p=>p.parent_product_tmpl_id===productTmplId)]}
_getCombination(product){return product.attribute_lines.flatMap(ptal=>ptal.selected_attribute_value_ids);}
_getParentsCombination(product){return product.parent_product_tmpl_id?this._getCombination(this._findProduct(product.parent_product_tmpl_id)):[];}
_isPossibleCombination(product){return product.attribute_lines.every(ptal=>{const selectedPtavIds=new Set(ptal.selected_attribute_value_ids);return ptal.attribute_values.filter(ptav=>selectedPtavIds.has(ptav.id)).every(ptav=>!ptav.excluded);});}
isPossibleConfiguration(){return[...this.state.products].every(p=>this._isPossibleCombination(p));}
async onConfirm(options){if(!this.isPossibleConfiguration())return;for(const product of this.state.products){if(!product.id&&product.attribute_lines.some(ptal=>ptal.create_variant==="dynamic")){const productId=await this._createProduct(product);product.id=parseInt(productId);}}
await this.props.save(this.state.products.find(p=>p.product_tmpl_id===this.env.mainProductTmplId),this.state.products.filter(p=>p.product_tmpl_id!==this.env.mainProductTmplId),options,);this.props.close();}
onDiscard(){if(!this.props.edit){this.props.discard();}
this.props.close();}}
return __exports;});;

/* /sale/static/src/js/product_list/product_list.js */
odoo.define('@sale/js/product_list/product_list',['@odoo/owl','@web/core/currency','@web/core/l10n/translation','@sale/js/product/product'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{formatCurrency}=require("@web/core/currency");const{_t}=require("@web/core/l10n/translation");const{Product}=require("@sale/js/product/product");const ProductList=__exports.ProductList=class ProductList extends Component{static components={Product};static template="sale.ProductList";static props={products:Array,areProductsOptional:{type:Boolean,optional:true},};static defaultProps={areProductsOptional:false,};setup(){this.optionalProductsTitle=_t("Add optional products");}
get totalMessage(){return _t("Total: %s",this.getFormattedTotal());}
getFormattedTotal(){return formatCurrency(this.props.products.reduce((totalPrice,product)=>totalPrice+product.price*product.quantity,0),this.env.currency.id,);}}
return __exports;});;

/* /sale/static/src/js/product_template_attribute_line/product_template_attribute_line.js */
odoo.define('@sale/js/product_template_attribute_line/product_template_attribute_line',['@web/core/l10n/translation','@odoo/owl','@web/core/currency','@sale/js/badge_extra_price/badge_extra_price','@sale/js/sale_utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component}=require("@odoo/owl");const{formatCurrency}=require("@web/core/currency");const{BadgeExtraPrice}=require("@sale/js/badge_extra_price/badge_extra_price");const{getSelectedCustomPtav}=require("@sale/js/sale_utils");const ProductTemplateAttributeLine=__exports.ProductTemplateAttributeLine=class ProductTemplateAttributeLine extends Component{static components={BadgeExtraPrice};static template="sale.ProductTemplateAttributeLine";static props={productTmplId:Number,id:Number,attribute:{type:Object,shape:{id:Number,name:String,display_type:{type:String,validate:type=>["color","multi","pills","radio","select"].includes(type),},},},attribute_values:{type:Array,element:{type:Object,shape:{id:Number,name:String,html_color:[Boolean,String],image:[Boolean,String],is_custom:Boolean,price_extra:Number,excluded:{type:Boolean,optional:true},},},},selected_attribute_value_ids:{type:Array,element:Number},create_variant:{type:String,validate:type=>["always","dynamic","no_variant"].includes(type),},customValue:{type:[{value:false},String],optional:true},};updateSelectedPTAV(event){this.env.updateProductTemplateSelectedPTAV(this.props.productTmplId,this.props.id,event.target.value,this.props.attribute.display_type=='multi');}
updateCustomValue(event){this.env.updatePTAVCustomValue(this.props.productTmplId,this.props.selected_attribute_value_ids[0],event.target.value);}
getPTAVTemplate(){switch(this.props.attribute.display_type){case'select':return'sale.ptav_select';case'radio':return'sale.ptav_radio';case'pills':return'sale.ptav_pills';case'color':return'sale.ptav_color';case'multi':return'sale.ptav_multi';}}
getPTAVSelectName(ptav){if(ptav.price_extra){const sign=ptav.price_extra>0?'+':'-';const price=formatCurrency(Math.abs(ptav.price_extra),this.env.currency.id);return ptav.name+" ("+sign+" "+price+")";}else{return ptav.name;}}
isSelectedPTAVCustom(){return!!getSelectedCustomPtav(this.props);}
get showValuesChoice(){return(this.env.canChangeVariant||this.props.create_variant==='no_variant')&&(this.props.attribute_values.length>1||this.props.attribute.display_type==='multi')}
get customValuePlaceholder(){return _t("Enter a customized value");}
hasPTAVCustom(){return this.props.attribute_values.some(ptav=>ptav.is_custom);}}
return __exports;});;

/* /sale/static/src/js/quantity_buttons/quantity_buttons.js */
odoo.define('@sale/js/quantity_buttons/quantity_buttons',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require('@odoo/owl');const QuantityButtons=__exports.QuantityButtons=class QuantityButtons extends Component{static template='sale.QuantityButtons';static props={quantity:Number,setQuantity:Function,isMinusButtonDisabled:{type:Boolean,optional:true},isPlusButtonDisabled:{type:Boolean,optional:true},btnClasses:{type:String,optional:true},};increaseQuantity(){this.props.setQuantity(this.props.quantity+1);}
decreaseQuantity(){this.props.setQuantity(this.props.quantity-1);}
async setQuantity(event){const quantity=parseFloat(event.target.value);const didUpdateQuantity=await this.props.setQuantity(isNaN(quantity)?0:quantity);if(!didUpdateQuantity){this.render();}}}
return __exports;});;

/* /sale/static/src/js/sale_order_line_field/sale_order_line_field.js */
odoo.define('@sale/js/sale_order_line_field/sale_order_line_field',['@web/core/registry','@web/views/fields/char/char_field','@account/components/product_label_section_and_note_field/product_label_section_and_note_field','@account/components/section_and_note_fields_backend/section_and_note_fields_backend'],function(require){'use strict';let __exports={};const{registry}=require('@web/core/registry');const{CharField}=require('@web/views/fields/char/char_field');const{productLabelSectionAndNoteOne2Many,ProductLabelSectionAndNoteOne2Many,ProductLabelSectionAndNoteListRender,}=require('@account/components/product_label_section_and_note_field/product_label_section_and_note_field');const{listSectionAndNoteText,sectionAndNoteFieldOne2Many,sectionAndNoteText,ListSectionAndNoteText,SectionAndNoteText,}=require('@account/components/section_and_note_fields_backend/section_and_note_fields_backend');const SaleOrderLineListRenderer=__exports.SaleOrderLineListRenderer=class SaleOrderLineListRenderer extends ProductLabelSectionAndNoteListRender{static recordRowTemplate='sale.ListRenderer.RecordRow';getCellTitle(column,record){if(column.name==='product_id'||column.name==='product_template_id'){return;}
super.getCellTitle(column,record);}
getActiveColumns(list){let activeColumns=super.getActiveColumns(list);let productTmplCol=activeColumns.find((col)=>col.name==='product_template_id');let productCol=activeColumns.find((col)=>col.name==='product_id');if(productCol&&productTmplCol){activeColumns=activeColumns.filter((col)=>col.name!='product_template_id')}
return activeColumns;}
isSectionOrNote(record=null){return super.isSectionOrNote(record)||this.isCombo(record);}
getRowClass(record){let classNames=super.getRowClass(record);if(this.isCombo(record)||this.isComboItem(record)){classNames=classNames.replace('o_row_draggable','');}
return`${classNames} ${this.isCombo(record) ? 'o_is_line_section' : ''}`;}
isCellReadonly(column,record){return super.isCellReadonly(column,record)||(this.isComboItem(record)&&![this.titleField,'tax_id','qty_delivered'].includes(column.name));}
async onDeleteRecord(record){if(this.isCombo(record)){await record.update({selected_combo_items:JSON.stringify([])});}
await super.onDeleteRecord(record);}
isCombo(record){return record.data.product_type==='combo';}
isComboItem(record){return!!record.data.combo_item_id;}}
const SaleOrderLineOne2Many=__exports.SaleOrderLineOne2Many=class SaleOrderLineOne2Many extends ProductLabelSectionAndNoteOne2Many{static components={...ProductLabelSectionAndNoteOne2Many.components,ListRenderer:SaleOrderLineListRenderer,};}
const saleOrderLineOne2Many=__exports.saleOrderLineOne2Many={...productLabelSectionAndNoteOne2Many,component:SaleOrderLineOne2Many,additionalClasses:sectionAndNoteFieldOne2Many.additionalClasses,};registry.category('fields').add('sol_o2m',saleOrderLineOne2Many);const SaleOrderLineText=__exports.SaleOrderLineText=class SaleOrderLineText extends SectionAndNoteText{get componentToUse(){return this.props.record.data.product_type==='combo'?CharField:super.componentToUse;}}
const ListSaleOrderLineText=__exports.ListSaleOrderLineText=class ListSaleOrderLineText extends ListSectionAndNoteText{get componentToUse(){return this.props.record.data.product_type==='combo'?CharField:super.componentToUse;}}
const saleOrderLineText=__exports.saleOrderLineText={...sectionAndNoteText,component:SaleOrderLineText,};const listSaleOrderLineText=__exports.listSaleOrderLineText={...listSectionAndNoteText,component:ListSaleOrderLineText,};registry.category('fields').add('sol_text',saleOrderLineText);registry.category('fields').add('list.sol_text',listSaleOrderLineText);return __exports;});;

/* /sale/static/src/js/sale_progressbar_field.js */
odoo.define('@sale/js/sale_progressbar_field',['@web/core/registry','@web/core/utils/hooks','@web/views/fields/progress_bar/kanban_progress_bar_field','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{KanbanProgressBarField,kanbanProgressBarField,}=require("@web/views/fields/progress_bar/kanban_progress_bar_field");const{useEffect}=require("@odoo/owl");const SaleProgressBarField=__exports.SaleProgressBarField=class SaleProgressBarField extends KanbanProgressBarField{static template="sale.SaleProgressBarField";setup(){super.setup();this.actionService=useService("action");this.orm=useService("orm");useEffect(()=>{this.state.isInvoicingTargetDefined=this.props.record.data[this.props.maxValueField];});}
async defineInvoicingTarget(){const{resId,resModel}=this.props.record;const action=await this.orm.call(resModel,"get_formview_action",[[resId]]);this.actionService.doAction(action,{props:{mode:"edit"}});}}
const saleProgressBarField=__exports.saleProgressBarField={...kanbanProgressBarField,component:SaleProgressBarField,};registry.category("fields").add("sales_team_progressbar",saleProgressBarField);return __exports;});;

/* /sale/static/src/js/tours/sale.js */
odoo.define('@sale/js/tours/sale',['@web/core/l10n/translation','@web/core/registry','@web_tour/tour_service/tour_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{stepUtils}=require("@web_tour/tour_service/tour_utils");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add("sale_tour",{url:"/odoo",steps:()=>[stepUtils.showAppsMenuItem(),{isActive:["community"],trigger:".o_app[data-menu-xmlid='sale.sale_menu_root']",content:_t("Let’s create a beautiful quotation in a few clicks ."),tooltipPosition:"right",run:"click",},{isActive:["enterprise"],trigger:".o_app[data-menu-xmlid='sale.sale_menu_root']",content:_t("Let’s create a beautiful quotation in a few clicks ."),tooltipPosition:"bottom",run:"click",},{trigger:".o_sale_order",},{trigger:"button.o_list_button_add",content:_t("Build your first quotation right here!"),tooltipPosition:"bottom",run:"click",},{trigger:".o_sale_order",},{trigger:".o_field_res_partner_many2one[name='partner_id'] input",content:_t("Search a customer name, or create one on the fly."),tooltipPosition:"right",run:"edit Agrolait",},{isActive:["auto"],trigger:".ui-menu-item > a:contains('Agrolait')",run:"click",},{trigger:".o_field_x2many_list_row_add > a",content:_t("Click here to add some products or services to your quotation."),tooltipPosition:"bottom",run:"click",},{trigger:".o_sale_order",},{trigger:`
                .o_field_widget[name='product_id'] input,
                .o_field_widget[name='product_template_id'] input
            `,content:_t("Select a product, or create a new one on the fly."),tooltipPosition:"right",run:"edit DESK0001",},{isActive:["auto"],trigger:"a:contains('DESK0001')",run:"click",},{trigger:".oi-arrow-right",},{trigger:".o_field_widget[name='price_unit'] input",content:_t("add the price of your product."),tooltipPosition:"right",run:"edit 10.0 && click body",},{isActive:["auto"],trigger:".o_field_cell[name='price_subtotal']:contains(10.00)",run:"click",},{isActive:["auto","mobile"],trigger:".o_statusbar_buttons button[name='action_quotation_send']",},...stepUtils.statusbarButtonsSteps("Send by Email",markup(_t("<b>Send the quote</b> to yourself and check what the customer will receive.")),),{isActive:["body:not(:has(.modal-footer button.o_mail_send))"],trigger:".modal-footer button[name='document_layout_save']",content:_t("let's continue"),tooltipPosition:"bottom",run:"click",},{trigger:".modal-footer button.o_mail_send",content:_t("Go ahead and send the quotation."),tooltipPosition:"bottom",run:"click",},{isActive:["auto"],trigger:"body:not(.modal-open)",run:"click",},],});return __exports;});;

/* /sale/static/src/js/sale_product_field.js */
odoo.define('@sale/js/sale_product_field',['@web/core/l10n/translation','@odoo/owl','@web/core/errors/error_dialogs','@web/core/l10n/dates','@web/core/orm_service','@web/core/registry','@web/core/network/rpc','@web/core/utils/hooks','@account/components/product_label_section_and_note_field/product_label_section_and_note_field','@sale/js/product_configurator_dialog/product_configurator_dialog','@web/views/utils','@sale/js/combo_configurator_dialog/combo_configurator_dialog','@sale/js/models/product_combo','@sale/js/sale_utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useEffect}=require('@odoo/owl');const{WarningDialog}=require("@web/core/errors/error_dialogs");const{serializeDateTime}=require("@web/core/l10n/dates");const{x2ManyCommands}=require("@web/core/orm_service");const{registry}=require("@web/core/registry");const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{ProductLabelSectionAndNoteField,productLabelSectionAndNoteField,}=require("@account/components/product_label_section_and_note_field/product_label_section_and_note_field");const{ProductConfiguratorDialog}=require("@sale/js/product_configurator_dialog/product_configurator_dialog");const{uuid}=require("@web/views/utils");const{ComboConfiguratorDialog}=require("@sale/js/combo_configurator_dialog/combo_configurator_dialog");const{ProductCombo}=require("@sale/js/models/product_combo");const{getLinkedSaleOrderLines,serializeComboItem,getSelectedCustomPtav}=require("@sale/js/sale_utils");async function applyProduct(record,product){const customAttributesCommands=[x2ManyCommands.set([]),];for(const ptal of product.attribute_lines){const selectedCustomPTAV=getSelectedCustomPtav(ptal);if(selectedCustomPTAV){customAttributesCommands.push(x2ManyCommands.create(undefined,{custom_product_template_attribute_value_id:[selectedCustomPTAV.id,"we don't care"],custom_value:ptal.customValue,}));};}
const noVariantPTAVIds=product.attribute_lines.filter(ptal=>ptal.create_variant==="no_variant").flatMap(ptal=>ptal.selected_attribute_value_ids);await record._update({product_id:[product.id,product.display_name],product_uom_qty:product.quantity,product_no_variant_attribute_value_ids:[x2ManyCommands.set(noVariantPTAVIds)],product_custom_attribute_value_ids:customAttributesCommands,});};const SaleOrderLineProductField=__exports.SaleOrderLineProductField=class SaleOrderLineProductField extends ProductLabelSectionAndNoteField{static template="sale.SaleProductField";static props={...ProductLabelSectionAndNoteField.props,readonlyField:{type:Boolean,optional:true},};setup(){super.setup();this.dialog=useService("dialog");this.notification=useService("notification");this.orm=useService("orm")
let isMounted=false;let isInternalUpdate=false;let wasCombo=false;const{updateRecord}=this;this.updateRecord=(value)=>{isInternalUpdate=true;wasCombo=this.isCombo;return updateRecord.call(this,value);};useEffect(value=>{if(!isMounted){isMounted=true;}else if(value&&isInternalUpdate){if(wasCombo){this.props.record.update({selected_combo_items:JSON.stringify([])});}
if(this.relation==="product.template"||this.isCombo){this._onProductTemplateUpdate();}else{this._onProductUpdate();}}
isInternalUpdate=false;},()=>[Array.isArray(this.value)&&this.value[0]]);}
get productName(){if(this.props.name=='product_template_id'){const product_id_data=this.props.record.data.product_id;if(product_id_data&&product_id_data[1]){return product_id_data[1].split("\n")[0];}}
return super.productName}
get isProductClickable(){return(this.props.readonlyField||(this.props.record.model.root.activeFields.order_line&&this.props.record.model.root._isReadonly("order_line")));}
get hasExternalButton(){const res=super.hasExternalButton;return res||(!!this.props.record.data[this.props.name]&&!this.state.isFloating);}
get hasConfigurationButton(){return this.isConfigurableLine||this.isConfigurableTemplate||this.isCombo;}
get isConfigurableLine(){return false;}
get isConfigurableTemplate(){return this.props.record.data.is_configurable_product;}
get isCombo(){return this.props.record.data.product_type==='combo';}
get isDownpayment(){return this.props.record.data.is_downpayment;}
get configurationButtonHelp(){return _t("Edit Configuration");}
get sectionAndNoteClasses(){const className=super.sectionAndNoteClasses;if(!className&&!this.productName&&!this.isDownpayment){return"text-warning";}
return className;}
onClick(ev){if(this.props.readonly){ev.stopPropagation();this.openAction();}else{super.onClick(ev);}}
async _onProductTemplateUpdate(){const result=await this.orm.call('product.template','get_single_product_variant',[this.props.record.data.product_template_id[0]],{context:this.context,});if(result&&result.product_id){if(this.props.record.data.product_id!=result.product_id.id){if(result.is_combo){await this.props.record.update({product_id:[result.product_id,result.product_name],});this._openComboConfigurator();}else if(result.has_optional_products){this._openProductConfigurator();}else{await this.props.record.update({product_id:[result.product_id,result.product_name],});this._onProductUpdate();}}}else{if(result&&result.sale_warning){const{type,title,message}=result.sale_warning
if(type==='block'){this.dialog.add(WarningDialog,{title,message});this.props.record.update({'product_template_id':false})
return}else if(type=='warning'){this.notification.add(message,{title,type:"warning",});}}
if(!result.mode||result.mode==='configurator'){this._openProductConfigurator();}else{this._openGridConfigurator();}}}
async _onProductUpdate(){}
onEditConfiguration(){if(this.isConfigurableLine){this._editLineConfiguration();}else if(this.isCombo){this._openComboConfigurator(true);}else if(this.isConfigurableTemplate){this._openProductConfigurator(true);}}
_editLineConfiguration(){}
async _openProductConfigurator(edit=false){const saleOrderRecord=this.props.record.model.root;const saleOrderLine=this.props.record.data;let ptavIds=this._getVariantPtavIds(saleOrderLine);let customPtavs=[];if(edit){ptavIds.push(...this._getNoVariantPtavIds(saleOrderLine));customPtavs=await this._getCustomPtavs(saleOrderLine);}
this.dialog.add(ProductConfiguratorDialog,{productTemplateId:saleOrderLine.product_template_id[0],ptavIds:ptavIds,customPtavs:customPtavs,quantity:saleOrderLine.product_uom_qty,productUOMId:saleOrderLine.product_uom[0],companyId:saleOrderRecord.data.company_id[0],pricelistId:saleOrderRecord.data.pricelist_id[0],currencyId:saleOrderLine.currency_id[0],soDate:serializeDateTime(saleOrderRecord.data.date_order),edit:edit,save:async(mainProduct,optionalProducts)=>{await Promise.all([applyProduct(this.props.record,mainProduct),...optionalProducts.map(async product=>{const line=await saleOrderRecord.data.order_line.addNewRecord({position:'bottom',mode:'readonly'});await applyProduct(line,product);}),]);this._onProductUpdate();saleOrderRecord.data.order_line.leaveEditMode();},discard:()=>{saleOrderRecord.data.order_line.delete(this.props.record);},...this._getAdditionalDialogProps(),});}
async _openComboConfigurator(edit=false){const saleOrder=this.props.record.model.root.data;const comboLineRecord=this.props.record;const comboItemLineRecords=getLinkedSaleOrderLines(comboLineRecord);const selectedComboItems=await Promise.all(comboItemLineRecords.map(async record=>({id:record.data.combo_item_id[0],no_variant_ptav_ids:edit?this._getNoVariantPtavIds(record.data):[],custom_ptavs:edit?await this._getCustomPtavs(record.data):[],})));const{combos,...remainingData}=await rpc('/sale/combo_configurator/get_data',{product_tmpl_id:comboLineRecord.data.product_template_id[0],currency_id:comboLineRecord.data.currency_id[0],quantity:comboLineRecord.data.product_uom_qty,date:serializeDateTime(saleOrder.date_order),company_id:saleOrder.company_id[0],pricelist_id:saleOrder.pricelist_id[0],selected_combo_items:selectedComboItems,...this._getAdditionalRpcParams(),});this.dialog.add(ComboConfiguratorDialog,{combos:combos.map(combo=>new ProductCombo(combo)),...remainingData,company_id:saleOrder.company_id[0],pricelist_id:saleOrder.pricelist_id[0],date:serializeDateTime(saleOrder.date_order),edit:edit,save:async(comboProductData,selectedComboItems)=>{saleOrder.order_line.leaveEditMode();const comboLineValues={product_uom_qty:comboProductData.quantity,selected_combo_items:JSON.stringify(selectedComboItems.map(serializeComboItem)),};if(!edit){comboLineValues.virtual_id=uuid();}
await comboLineRecord.update(comboLineValues);await saleOrder.order_line._sort();},discard:()=>saleOrder.order_line.delete(comboLineRecord),...this._getAdditionalDialogProps(),});}
_getAdditionalRpcParams(){return{};}
_getAdditionalDialogProps(){return{};}
_getVariantPtavIds(saleOrderLine){return saleOrderLine.product_template_attribute_value_ids.records.map(record=>record.resId);}
_getNoVariantPtavIds(saleOrderLine){return saleOrderLine.product_no_variant_attribute_value_ids.records.map(record=>record.resId);}
async _getCustomPtavs(saleOrderLine){const customPtavIds=saleOrderLine.product_custom_attribute_value_ids;const customPtavs=customPtavIds.records[0]?.isNew?customPtavIds.records.map(record=>record.data):customPtavIds.currentIds.length?await this.orm.read('product.attribute.custom.value',customPtavIds.currentIds,['custom_product_template_attribute_value_id','custom_value'],):[];return customPtavs.map(customPtav=>({id:customPtav.custom_product_template_attribute_value_id[0],value:customPtav.custom_value,}));}}
const saleOrderLineProductField=__exports.saleOrderLineProductField={...productLabelSectionAndNoteField,component:SaleOrderLineProductField,extractProps(fieldInfo,dynamicInfo){const props=productLabelSectionAndNoteField.extractProps(...arguments);props.readonlyField=dynamicInfo.readonly;return props;},};registry.category("fields").add("sol_product_many2one",saleOrderLineProductField);return __exports;});;

/* /sale/static/src/js/sale_utils.js */
odoo.define('@sale/js/sale_utils',[],function(require){'use strict';let __exports={};__exports.areSaleOrderLinesLinked=areSaleOrderLinesLinked;function areSaleOrderLinesLinked(linkingSaleOrderLine,linkedSaleOrderLine){const linkingId=linkedSaleOrderLine.isNew?linkingSaleOrderLine.data.linked_virtual_id:linkingSaleOrderLine.data.linked_line_id[0];const linkedId=linkedSaleOrderLine.isNew?linkedSaleOrderLine.data.virtual_id:linkedSaleOrderLine.resId;return linkingId&&linkingId===linkedId;}
__exports.getLinkedSaleOrderLines=getLinkedSaleOrderLines;function getLinkedSaleOrderLines(saleOrderLine){const saleOrder=saleOrderLine.model.root;return saleOrder.data.order_line.records.filter(record=>areSaleOrderLinesLinked(record,saleOrderLine));}
__exports.serializeComboItem=serializeComboItem;function serializeComboItem(comboItem){return{combo_item_id:comboItem.id,product_id:comboItem.product.id,no_variant_attribute_value_ids:comboItem.product.selectedNoVariantPtavIds,product_custom_attribute_values:comboItem.product.selectedCustomPtavs.map(customPtav=>({custom_product_template_attribute_value_id:customPtav.id,custom_value:customPtav.value,})),}}
__exports.getSelectedCustomPtav=getSelectedCustomPtav;function getSelectedCustomPtav(ptal){const selectedPtavIds=new Set(ptal.selected_attribute_value_ids);return ptal.attribute_values.find(ptav=>ptav.is_custom&&selectedPtavIds.has(ptav.id));}
return __exports;});;

/* /sale/static/src/views/sale_onboarding_kanban/sale_onboarding_kanban_renderer.js */
odoo.define('@sale/views/sale_onboarding_kanban/sale_onboarding_kanban_renderer',['@account/views/file_upload_kanban/file_upload_kanban_renderer','@sale/js/sale_action_helper/sale_action_helper'],function(require){'use strict';let __exports={};const{FileUploadKanbanRenderer}=require("@account/views/file_upload_kanban/file_upload_kanban_renderer");const{SaleActionHelper}=require("@sale/js/sale_action_helper/sale_action_helper");const SaleKanbanRenderer=__exports.SaleKanbanRenderer=class SaleKanbanRenderer extends FileUploadKanbanRenderer{static template="sale.SaleKanbanRenderer";static components={...FileUploadKanbanRenderer.components,SaleActionHelper,};};return __exports;});;

/* /sale/static/src/views/sale_onboarding_kanban/sale_onboarding_kanban_view.js */
odoo.define('@sale/views/sale_onboarding_kanban/sale_onboarding_kanban_view',['@sale/views/sale_onboarding_kanban/sale_onboarding_kanban_renderer','@account/views/file_upload_kanban/file_upload_kanban_view','@web/core/registry'],function(require){'use strict';let __exports={};const{SaleKanbanRenderer}=require("@sale/views/sale_onboarding_kanban/sale_onboarding_kanban_renderer");const{fileUploadKanbanView}=require("@account/views/file_upload_kanban/file_upload_kanban_view");const{registry}=require("@web/core/registry");const saleKanbanView=__exports.saleKanbanView={...fileUploadKanbanView,Renderer:SaleKanbanRenderer,};registry.category("views").add("sale_onboarding_kanban",saleKanbanView);return __exports;});;

/* /sale/static/src/views/sale_onboarding_list/sale_onboarding_list_renderer.js */
odoo.define('@sale/views/sale_onboarding_list/sale_onboarding_list_renderer',['@account/views/file_upload_list/file_upload_list_renderer','@sale/js/sale_action_helper/sale_action_helper'],function(require){'use strict';let __exports={};const{FileUploadListRenderer}=require("@account/views/file_upload_list/file_upload_list_renderer");const{SaleActionHelper}=require("@sale/js/sale_action_helper/sale_action_helper");const SaleListRenderer=__exports.SaleListRenderer=class SaleListRenderer extends FileUploadListRenderer{static template="sale.SaleListRenderer";static components={...FileUploadListRenderer.components,SaleActionHelper,};};return __exports;});;

/* /sale/static/src/views/sale_onboarding_list/sale_onboarding_list_view.js */
odoo.define('@sale/views/sale_onboarding_list/sale_onboarding_list_view',['@web/core/registry','@account/views/file_upload_list/file_upload_list_view','@sale/views/sale_onboarding_list/sale_onboarding_list_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{fileUploadListView}=require("@account/views/file_upload_list/file_upload_list_view");const{SaleListRenderer}=require("@sale/views/sale_onboarding_list/sale_onboarding_list_renderer");const SaleListView=__exports.SaleListView={...fileUploadListView,Renderer:SaleListRenderer,};registry.category("views").add("sale_onboarding_list",SaleListView);return __exports;});;

/* /calendar/static/src/activity/activity_list_popover_item_patch.js */
odoo.define('@calendar/activity/activity_list_popover_item_patch',['@mail/core/web/activity_list_popover_item','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ActivityListPopoverItem}=require("@mail/core/web/activity_list_popover_item");const{patch}=require("@web/core/utils/patch");patch(ActivityListPopoverItem.prototype,{get hasEditButton(){return super.hasEditButton&&!this.props.activity.calendar_event_id;},async onClickReschedule(){await this.props.activity.rescheduleMeeting();},});return __exports;});;

/* /calendar/static/src/activity/activity_menu_patch.js */
odoo.define('@calendar/activity/activity_menu_patch',['@mail/core/web/activity_menu','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ActivityMenu}=require("@mail/core/web/activity_menu");const{patch}=require("@web/core/utils/patch");patch(ActivityMenu.prototype,{openActivityGroup(group){if(group.model==="calendar.event"){this.dropdown.close();this.action.doAction("calendar.action_calendar_event",{additionalContext:{default_mode:"day",search_default_mymeetings:1,},clearBreadcrumbs:true,});}else{super.openActivityGroup(...arguments);}},});return __exports;});;

/* /calendar/static/src/activity/activity_model_patch.js */
odoo.define('@calendar/activity/activity_model_patch',['@mail/core/web/activity_model','@mail/utils/common/misc','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Activity}=require("@mail/core/web/activity_model");const{assignIn}=require("@mail/utils/common/misc");const{patch}=require("@web/core/utils/patch");patch(Activity,{_insert(data){const activity=super._insert(...arguments);assignIn(activity,data,["calendar_event_id"]);return activity;},});patch(Activity.prototype,{async rescheduleMeeting(){const action=await this.store.env.services.orm.call("mail.activity","action_create_calendar_event",[[this.id]]);this.store.env.services.action.doAction(action);},});return __exports;});;

/* /calendar/static/src/activity/activity_patch.js */
odoo.define('@calendar/activity/activity_patch',['@mail/core/web/activity','@web/core/utils/hooks','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Activity}=require("@mail/core/web/activity");const{useService}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");patch(Activity.prototype,{setup(){super.setup();this.orm=useService("orm");},async onClickReschedule(){await this.props.activity.rescheduleMeeting();},async unlink(){if(this.props.activity.calendar_event_id){const thread=this.thread;this.props.activity.remove();await this.orm.call("mail.activity","unlink_w_meeting",[[this.props.activity.id]]);this.props.onActivityChanged(thread);}else{super.unlink();}},});return __exports;});;

/* /calendar/static/src/components/calendar_provider_config/calendar_connect_provider.js */
odoo.define('@calendar/components/calendar_provider_config/calendar_connect_provider',['@web/core/network/rpc','@web/core/registry','@web/core/user','@web/views/widgets/standard_widget_props','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const providerData={google:{restart_sync_method:"restart_google_synchronization",sync_route:"/google_calendar/sync_data",},microsoft:{restart_sync_method:"restart_microsoft_synchronization",sync_route:"/microsoft_calendar/sync_data",},};const CalendarConnectProvider=__exports.CalendarConnectProvider=class CalendarConnectProvider extends Component{static props={...standardWidgetProps,};static template="calendar.CalendarConnectProvider";setup(){super.setup();this.orm=useService("orm");}
async onConnect(ev){ev.preventDefault();ev.stopImmediatePropagation();if(!(await this.props.record.save())){return;}
await this.orm.call(this.props.record.resModel,"action_calendar_prepare_external_provider_sync",[this.props.record.resId]);const{restart_sync_method,sync_route}=providerData[this.props.record.data.external_calendar_provider];await this.orm.call("res.users",restart_sync_method,[[user.userId]]);const response=await rpc(sync_route,{model:"calendar.event",fromurl:window.location.href,});await this._beforeLeaveContext();if(response.status==="need_auth"){window.location.assign(response.url);}else if(response.status==="need_refresh"){window.location.reload();}}
async _beforeLeaveContext(){return Promise.resolve();}}
const calendarConnectProvider={component:CalendarConnectProvider,};registry.category("view_widgets").add("calendar_connect_provider",calendarConnectProvider);return __exports;});;

/* /calendar/static/src/core/web/store_service_patch.js */
odoo.define('@calendar/core/web/store_service_patch',['@mail/core/common/store_service','@web/core/l10n/dates','@web/core/l10n/localization','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Store}=require("@mail/core/common/store_service");const{deserializeDateTime,formatDateTime}=require("@web/core/l10n/dates");const{localization}=require("@web/core/l10n/localization");const{patch}=require("@web/core/utils/patch");const StorePatch={onUpdateActivityGroups(){super.onUpdateActivityGroups(...arguments);for(const group of Object.values(this.activityGroups)){if(group.type==="meeting"){for(const meeting of group.meetings){if(meeting.start){const date=deserializeDateTime(meeting.start);meeting.formattedStart=formatDateTime(date,{format:localization.timeFormat,});}}}}},};patch(Store.prototype,StorePatch);return __exports;});;

/* /calendar/static/src/js/services/calendar_notification_service.js */
odoo.define('@calendar/js/services/calendar_notification_service',['@web/core/l10n/translation','@web/core/browser/browser','@web/core/network/rpc','@web/core/registry'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{ConnectionLostError,rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const calendarNotificationService=__exports.calendarNotificationService={dependencies:["action","bus_service","notification"],start(env,{action,bus_service,notification}){let calendarNotifTimeouts={};let nextCalendarNotifTimeout=null;const displayedNotifications=new Set();bus_service.subscribe("calendar.alarm",(payload)=>{displayCalendarNotification(payload);});bus_service.start();function displayCalendarNotification(notifications){let lastNotifTimer=0;browser.clearTimeout(nextCalendarNotifTimeout);Object.values(calendarNotifTimeouts).forEach((notif)=>browser.clearTimeout(notif));calendarNotifTimeouts={};notifications.forEach(function(notif){const key=notif.event_id+","+notif.alarm_id;if(displayedNotifications.has(key)){return;}
calendarNotifTimeouts[key]=browser.setTimeout(function(){const notificationRemove=notification.add(notif.message,{title:notif.title,type:"warning",sticky:true,onClose:()=>{displayedNotifications.delete(key);},buttons:[{name:_t("OK"),primary:true,onClick:async()=>{await rpc("/calendar/notify_ack");notificationRemove();},},{name:_t("Details"),onClick:async()=>{await action.doAction({type:"ir.actions.act_window",res_model:"calendar.event",res_id:notif.event_id,views:[[false,"form"]],});notificationRemove();},},{name:_t("Snooze"),onClick:()=>{notificationRemove();},},],});displayedNotifications.add(key);},notif.timer*1000);lastNotifTimer=Math.max(lastNotifTimer,notif.timer);});if(lastNotifTimer>0){nextCalendarNotifTimeout=browser.setTimeout(getNextCalendarNotif,lastNotifTimer*1000);}}
async function getNextCalendarNotif(){try{const result=await rpc("/calendar/notify",{},{silent:true});displayCalendarNotification(result);}catch(error){if(!(error instanceof ConnectionLostError)){throw error;}}}},};registry.category("services").add("calendarNotification",calendarNotificationService);return __exports;});;

/* /calendar/static/src/views/ask_recurrence_update_policy_dialog.js */
odoo.define('@calendar/views/ask_recurrence_update_policy_dialog',['@web/core/l10n/translation','@web/core/dialog/dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Dialog}=require("@web/core/dialog/dialog");const{Component}=require("@odoo/owl");const AskRecurrenceUpdatePolicyDialog=__exports.AskRecurrenceUpdatePolicyDialog=class AskRecurrenceUpdatePolicyDialog extends Component{static template="calendar.AskRecurrenceUpdatePolicyDialog";static components={Dialog,};static props={confirm:Function,close:Function,};setup(){this.possibleValues={self_only:{checked:true,label:_t("This event"),},future_events:{checked:false,label:_t("This and following events"),},all_events:{checked:false,label:_t("All events"),},};}
get selected(){return Object.entries(this.possibleValues).find((state)=>state[1].checked)[0];}
set selected(val){this.possibleValues[this.selected].checked=false;this.possibleValues[val].checked=true;}
confirm(){this.props.confirm(this.selected);this.props.close();}}
return __exports;});;

/* /calendar/static/src/views/ask_recurrence_update_policy_hook.js */
odoo.define('@calendar/views/ask_recurrence_update_policy_hook',['@web/core/utils/hooks','@calendar/views/ask_recurrence_update_policy_dialog'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{AskRecurrenceUpdatePolicyDialog}=require("@calendar/views/ask_recurrence_update_policy_dialog");__exports.askRecurrenceUpdatePolicy=askRecurrenceUpdatePolicy;function askRecurrenceUpdatePolicy(dialogService){return new Promise((resolve)=>{dialogService.add(AskRecurrenceUpdatePolicyDialog,{confirm:resolve,},{onClose:resolve.bind(null,false),});});}
__exports.useAskRecurrenceUpdatePolicy=useAskRecurrenceUpdatePolicy;function useAskRecurrenceUpdatePolicy(){const dialogService=useService("dialog");return askRecurrenceUpdatePolicy.bind(null,dialogService);}
return __exports;});;

/* /calendar/static/src/views/attendee_calendar/attendee_calendar_controller.js */
odoo.define('@calendar/views/attendee_calendar/attendee_calendar_controller',['@web/core/l10n/translation','@web/views/calendar/calendar_controller','@web/core/user','@web/core/utils/hooks','@odoo/owl','@calendar/views/calendar_form/calendar_quick_create'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{CalendarController}=require("@web/views/calendar/calendar_controller");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{onWillStart}=require("@odoo/owl");const{CalendarQuickCreate}=require("@calendar/views/calendar_form/calendar_quick_create");const AttendeeCalendarController=__exports.AttendeeCalendarController=class AttendeeCalendarController extends CalendarController{static template="calendar.AttendeeCalendarController";static components={...AttendeeCalendarController.components,QuickCreateFormView:CalendarQuickCreate,};setup(){super.setup();this.actionService=useService("action");this.orm=useService("orm");onWillStart(async()=>{this.isSystemUser=await user.hasGroup("base.group_system");});}
onClickAddButton(){this.actionService.doAction({type:"ir.actions.act_window",res_model:"calendar.event",views:[[false,"form"]],},{additionalContext:this.props.context,});}
goToFullEvent(resId,additionalContext){this.actionService.doAction({type:"ir.actions.act_window",res_model:"calendar.event",views:[[false,"form"]],res_id:resId||false,},{additionalContext:{...this.props.context,...additionalContext,},});}
getQuickCreateFormViewProps(record){const props=super.getQuickCreateFormViewProps(record);const onDialogClosed=()=>{this.model.load();};return{...props,size:"md",goToFullEvent:(contextData)=>{const fullContext={...props.context,...contextData,};this.goToFullEvent(false,fullContext);},onRecordSaved:()=>onDialogClosed(),};}
async editRecord(record,context={}){if(record.id){return this.goToFullEvent(record.id,context);}}
deleteRecord(record){if(user.partnerId===record.attendeeId&&user.partnerId===record.rawRecord.partner_id[0]){if(record.rawRecord.recurrency){this.openRecurringDeletionWizard(record);}else{super.deleteRecord(...arguments);}}else{this.orm.call("calendar.attendee","do_decline",[record.calendarAttendeeId]).then(this.model.load.bind(this.model));}}
openRecurringDeletionWizard(record){this.actionService.doAction({type:"ir.actions.act_window",res_model:"calendar.popover.delete.wizard",views:[[false,"form"]],view_mode:"form",name:"Delete Recurring Event",context:{default_record:record.id},target:"new",},{onClose:()=>{location.reload();},});}
configureCalendarProviderSync(providerName){this.actionService.doAction({name:_t("Connect your Calendar"),type:"ir.actions.act_window",res_model:"calendar.provider.config",views:[[false,"form"]],view_mode:"form",target:"new",context:{default_external_calendar_provider:providerName,dialog_size:"medium",},});}}
return __exports;});;

/* /calendar/static/src/views/attendee_calendar/attendee_calendar_model.js */
odoo.define('@calendar/views/attendee_calendar/attendee_calendar_model',['@web/core/l10n/translation','@web/core/network/rpc','@web/core/user','@web/views/calendar/calendar_model','@calendar/views/ask_recurrence_update_policy_hook','@web/core/confirmation_dialog/confirmation_dialog'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{user}=require("@web/core/user");const{CalendarModel}=require("@web/views/calendar/calendar_model");const{askRecurrenceUpdatePolicy}=require("@calendar/views/ask_recurrence_update_policy_hook");const{deleteConfirmationMessage,ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const AttendeeCalendarModel=__exports.AttendeeCalendarModel=class AttendeeCalendarModel extends CalendarModel{setup(params,{dialog}){super.setup(...arguments);this.dialog=dialog;this.rpc=rpc;}
async load(){const res=await super.load(...arguments);const[credentialStatus,syncStatus,defaultDuration]=await Promise.all([rpc("/calendar/check_credentials"),this.orm.call("res.users","check_synchronization_status",[[user.userId]]),this.orm.call("calendar.event","get_default_duration"),]);this.syncStatus=syncStatus;this.credentialStatus=credentialStatus;this.defaultDuration=defaultDuration;return res;}
get attendees(){return this.data.attendees;}
async updateRecord(record){const rec=this.records[record.id];if(rec.rawRecord.recurrency){const recurrenceUpdate=await askRecurrenceUpdatePolicy(this.dialog);if(!recurrenceUpdate){return this.notify();}
record.recurrenceUpdate=recurrenceUpdate;}
return await super.updateRecord(...arguments);}
buildRawRecord(partialRecord,options={}){const result=super.buildRawRecord(partialRecord,{...options,duration_hour:this.defaultDuration,});if(partialRecord.recurrenceUpdate){result.recurrence_update=partialRecord.recurrenceUpdate;}
return result;}
async loadFilterSection(fieldName,filterInfo,previousSection){let result=await super.loadFilterSection(fieldName,filterInfo,previousSection);if(result?.filters){user.updateContext({calendar_filters:{all:result?.filters?.find((f)=>f.type=="all")?.active??false,user:result?.filters?.find((f)=>f.type=="user")?.active??false,}});}
return result;}
async updateData(data){await super.updateData(...arguments);await this.updateAttendeeData(data);}
async updateAttendeeData(data){const attendeeFilters=data.filterSections.partner_ids;let isEveryoneFilterActive=false;let attendeeIds=[];const eventIds=Object.keys(data.records).map((id)=>Number.parseInt(id));if(attendeeFilters){const allFilter=attendeeFilters.filters.find((filter)=>filter.type==="all");isEveryoneFilterActive=(allFilter&&allFilter.active)||false;attendeeIds=attendeeFilters.filters.filter((filter)=>filter.type!=="all"&&filter.value).map((filter)=>filter.value);}
data.attendees=await this.orm.call("res.partner","get_attendee_detail",[attendeeIds,eventIds,]);const currentPartnerId=user.partnerId;if(!isEveryoneFilterActive){const activeAttendeeIds=new Set(attendeeFilters.filters.filter((filter)=>filter.type!=="all"&&filter.value&&filter.active).map((filter)=>filter.value));const newRecords={};let duplicatedRecordIdx=-1;for(const event of Object.values(data.records)){const eventData=event.rawRecord;const attendees=eventData.partner_ids&&eventData.partner_ids.length?eventData.partner_ids:[eventData.partner_id[0]];let duplicatedRecords=0;for(const attendee of attendees){if(!activeAttendeeIds.has(attendee)){continue;}
const record={...event};const attendeeInfo=data.attendees.find((a)=>a.id===attendee&&a.event_id===event.id);record.attendeeId=attendee;record.colorIndex=attendee;if(attendeeInfo){record.attendeeStatus=attendeeInfo.status;record.isAlone=attendeeInfo.is_alone;record.isCurrentPartner=attendeeInfo.id===currentPartnerId;record.calendarAttendeeId=attendeeInfo.attendee_id;}
const recordId=duplicatedRecords?duplicatedRecordIdx--:record.id;record._recordId=recordId;newRecords[recordId]=record;duplicatedRecords++;}}
data.records=newRecords;}else{for(const event of Object.values(data.records)){const eventData=event.rawRecord;event.attendeeId=eventData.partner_id&&eventData.partner_id[0];const attendeeInfo=data.attendees.find((a)=>a.id===currentPartnerId&&a.event_id===event.id);if(attendeeInfo){event.isAlone=attendeeInfo.is_alone;event.calendarAttendeeId=attendeeInfo.attendee_id;}}}}
async archiveRecord(record){let recurrenceUpdate=false;if(record.rawRecord.recurrency){recurrenceUpdate=await askRecurrenceUpdatePolicy(this.dialog);if(!recurrenceUpdate){return;}}else{const confirm=await new Promise((resolve)=>{this.dialog.add(ConfirmationDialog,{title:_t("Bye-bye, record!"),body:deleteConfirmationMessage,confirm:resolve.bind(null,true),confirmLabel:_t("Delete"),cancel:()=>resolve.bind(null,false),cancelLabel:_t("No, keep it"),});});if(!confirm){return;}}
await this._archiveRecord(record.id,recurrenceUpdate);}
async _archiveRecord(id,recurrenceUpdate){if(!recurrenceUpdate&&recurrenceUpdate!=="self_only"){await this.orm.call(this.resModel,"action_archive",[[id]]);}else{await this.orm.call(this.resModel,"action_mass_archive",[[id],recurrenceUpdate]);}
await this.load();}}
AttendeeCalendarModel.services=[...CalendarModel.services,"dialog","orm"];return __exports;});;

/* /calendar/static/src/views/attendee_calendar/attendee_calendar_renderer.js */
odoo.define('@calendar/views/attendee_calendar/attendee_calendar_renderer',['@web/views/calendar/calendar_renderer','@calendar/views/attendee_calendar/common/attendee_calendar_common_renderer','@calendar/views/attendee_calendar/year/attendee_calendar_year_renderer'],function(require){'use strict';let __exports={};const{CalendarRenderer}=require("@web/views/calendar/calendar_renderer");const{AttendeeCalendarCommonRenderer}=require("@calendar/views/attendee_calendar/common/attendee_calendar_common_renderer");const{AttendeeCalendarYearRenderer}=require("@calendar/views/attendee_calendar/year/attendee_calendar_year_renderer");const AttendeeCalendarRenderer=__exports.AttendeeCalendarRenderer=class AttendeeCalendarRenderer extends CalendarRenderer{static components={...CalendarRenderer.components,day:AttendeeCalendarCommonRenderer,week:AttendeeCalendarCommonRenderer,month:AttendeeCalendarCommonRenderer,year:AttendeeCalendarYearRenderer,};}
return __exports;});;

/* /calendar/static/src/views/attendee_calendar/attendee_calendar_view.js */
odoo.define('@calendar/views/attendee_calendar/attendee_calendar_view',['@web/core/registry','@web/views/calendar/calendar_view','@calendar/views/attendee_calendar/attendee_calendar_controller','@calendar/views/attendee_calendar/attendee_calendar_model','@calendar/views/attendee_calendar/attendee_calendar_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{calendarView}=require("@web/views/calendar/calendar_view");const{AttendeeCalendarController}=require("@calendar/views/attendee_calendar/attendee_calendar_controller");const{AttendeeCalendarModel}=require("@calendar/views/attendee_calendar/attendee_calendar_model");const{AttendeeCalendarRenderer}=require("@calendar/views/attendee_calendar/attendee_calendar_renderer");const attendeeCalendarView=__exports.attendeeCalendarView={...calendarView,Controller:AttendeeCalendarController,Model:AttendeeCalendarModel,Renderer:AttendeeCalendarRenderer,};registry.category("views").add("attendee_calendar",attendeeCalendarView);return __exports;});;

/* /calendar/static/src/views/attendee_calendar/common/attendee_calendar_common_popover.js */
odoo.define('@calendar/views/attendee_calendar/common/attendee_calendar_common_popover',['@odoo/owl','@web/views/calendar/calendar_common/calendar_common_popover','@web/core/utils/hooks','@calendar/views/ask_recurrence_update_policy_hook','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/user'],function(require){'use strict';let __exports={};const{onWillStart}=require("@odoo/owl");const{CalendarCommonPopover}=require("@web/views/calendar/calendar_common/calendar_common_popover");const{useService}=require("@web/core/utils/hooks");const{useAskRecurrenceUpdatePolicy}=require("@calendar/views/ask_recurrence_update_policy_hook");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{user}=require("@web/core/user");const AttendeeCalendarCommonPopover=__exports.AttendeeCalendarCommonPopover=class AttendeeCalendarCommonPopover extends CalendarCommonPopover{static components={...CalendarCommonPopover.components,Dropdown,DropdownItem,};static subTemplates={...CalendarCommonPopover.subTemplates,body:"calendar.AttendeeCalendarCommonPopover.body",footer:"calendar.AttendeeCalendarCommonPopover.footer",};setup(){super.setup();this.orm=useService("orm");this.actionService=useService("action");this.askRecurrenceUpdatePolicy=useAskRecurrenceUpdatePolicy();onWillStart(this.onWillStart);}
async onWillStart(){if(this.isEventEditable){const stateSelections=await this.env.services.orm.call(this.props.model.resModel,"get_state_selections");this.statusColors={accepted:"text-success",declined:"text-danger",tentative:"text-muted",needsAction:"false",};this.statusInfo={};for(const selection of stateSelections){this.statusInfo[selection[0]]={text:selection[1],color:this.statusColors[selection[0]],};}
this.selectedStatusInfo=this.statusInfo[this.props.record.attendeeStatus];}}
get isCurrentUserAttendee(){return(this.props.record.rawRecord.partner_ids.includes(user.partnerId)||this.props.record.rawRecord.partner_id[0]===user.partnerId);}
get isCurrentUserOrganizer(){return this.props.record.rawRecord.partner_id[0]===user.partnerId;}
get isEventPrivate(){return this.props.record.rawRecord.privacy==="private";}
get displayAttendeeAnswerChoice(){return(this.props.record.rawRecord.partner_ids.some((partner)=>partner!==user.partnerId)&&this.props.record.isCurrentPartner);}
get isEventDetailsVisible(){return this.isEventPrivate?this.isEventEditable:true;}
get isEventArchivable(){return false;}
async onClickOpenRecord(){const action=await this.orm.call("calendar.event","action_open_calendar_event",[this.props.record.id,]);this.actionService.doAction(action);}
get isEventDeletable(){return super.isEventDeletable&&this.isEventEditable&&!this.isEventArchivable;}
get isEventEditable(){return this.props.record.rawRecord.user_can_edit;}
get isEventViewable(){return this.isEventPrivate?this.isEventEditable:super.isEventEditable;}
get hasFooter(){return this.isEventViewable||super.hasFooter;}
async changeAttendeeStatus(selectedStatus){const record=this.props.record;if(record.attendeeStatus===selectedStatus){return this.props.close();}
let recurrenceUpdate=false;if(record.rawRecord.recurrency){recurrenceUpdate=await this.askRecurrenceUpdatePolicy();if(!recurrenceUpdate){return this.props.close();}}
await this.env.services.orm.call(this.props.model.resModel,"change_attendee_status",[[record.id],selectedStatus,recurrenceUpdate,]);await this.props.model.load();this.props.close();}
async onClickArchive(){this.props.close();await this.props.model.archiveRecord(this.props.record);}}
return __exports;});;

/* /calendar/static/src/views/attendee_calendar/common/attendee_calendar_common_renderer.js */
odoo.define('@calendar/views/attendee_calendar/common/attendee_calendar_common_renderer',['@web/views/calendar/calendar_common/calendar_common_renderer','@calendar/views/attendee_calendar/common/attendee_calendar_common_popover'],function(require){'use strict';let __exports={};const{CalendarCommonRenderer}=require("@web/views/calendar/calendar_common/calendar_common_renderer");const{AttendeeCalendarCommonPopover}=require("@calendar/views/attendee_calendar/common/attendee_calendar_common_popover");const AttendeeCalendarCommonRenderer=__exports.AttendeeCalendarCommonRenderer=class AttendeeCalendarCommonRenderer extends CalendarCommonRenderer{static eventTemplate="calendar.AttendeeCalendarCommonRenderer.event";static components={...CalendarCommonRenderer.components,Popover:AttendeeCalendarCommonPopover,};convertRecordToEvent(record){let editable=false;if(record&&record.rawRecord){editable=record.rawRecord.user_can_edit;}
return{...super.convertRecordToEvent(record),id:record._recordId||record.id,editable:editable,};}
eventClassNames({el,event}){const classesToAdd=super.eventClassNames(...arguments);const record=this.props.model.records[event.id];if(record){if(record.rawRecord.is_highlighted){classesToAdd.push("o_event_highlight");}
if(record.isAlone){classesToAdd.push("o_attendee_status_alone");}else{classesToAdd.push(`o_attendee_status_${record.attendeeStatus}`);}}
return classesToAdd;}
onEventDidMount({el,event}){super.onEventDidMount(...arguments);const record=this.props.model.records[event.id];if(record){if(this.env.searchModel?.context?.default_calendar_event_id===parseInt(event.id)){this.openPopover(el,record);}}}
isSelectionAllowed(event){return true;}}
return __exports;});;

/* /calendar/static/src/views/attendee_calendar/year/attendee_calendar_year_popover.js */
odoo.define('@calendar/views/attendee_calendar/year/attendee_calendar_year_popover',['@web/views/calendar/calendar_year/calendar_year_popover'],function(require){'use strict';let __exports={};const{CalendarYearPopover}=require("@web/views/calendar/calendar_year/calendar_year_popover");const AttendeeCalendarYearPopover=__exports.AttendeeCalendarYearPopover=class AttendeeCalendarYearPopover extends CalendarYearPopover{static subTemplates={...CalendarYearPopover.subTemplates,body:"calendar.AttendeeCalendarYearPopover.body",};getRecordClass(record){const classes=[super.getRecordClass(record)];if(record.isAlone){classes.push("o_attendee_status_alone");}else{classes.push(`o_attendee_status_${record.attendeeStatus}`);}
return classes.join(" ");}}
return __exports;});;

/* /calendar/static/src/views/attendee_calendar/year/attendee_calendar_year_renderer.js */
odoo.define('@calendar/views/attendee_calendar/year/attendee_calendar_year_renderer',['@web/views/calendar/calendar_year/calendar_year_renderer','@calendar/views/attendee_calendar/year/attendee_calendar_year_popover'],function(require){'use strict';let __exports={};const{CalendarYearRenderer}=require("@web/views/calendar/calendar_year/calendar_year_renderer");const{AttendeeCalendarYearPopover}=require("@calendar/views/attendee_calendar/year/attendee_calendar_year_popover");const AttendeeCalendarYearRenderer=__exports.AttendeeCalendarYearRenderer=class AttendeeCalendarYearRenderer extends CalendarYearRenderer{static components={...CalendarYearRenderer.components,Popover:AttendeeCalendarYearPopover,};}
return __exports;});;

/* /calendar/static/src/views/calendar_form/calendar_form_controller.js */
odoo.define('@calendar/views/calendar_form/calendar_form_controller',['@web/views/form/form_controller','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{FormController}=require("@web/views/form/form_controller");const{useService}=require("@web/core/utils/hooks");const{onWillStart}=require("@odoo/owl");const CalendarFormController=__exports.CalendarFormController=class CalendarFormController extends FormController{setup(){super.setup();const ormService=useService("orm");onWillStart(async()=>{this.discussVideocallLocation=await ormService.call("calendar.event","get_discuss_videocall_location");});}
async beforeExecuteActionButton(clickParams){const action=clickParams.name;if(action==="clear_videocall_location"||action==="set_discuss_videocall_location"){let newVal="";let videoCallSource="custom";let changes={};if(action==="set_discuss_videocall_location"){newVal=this.discussVideocallLocation;videoCallSource="discuss";changes.access_token=this.discussVideocallLocation.split("/").pop();}
changes=Object.assign(changes,{videocall_location:newVal,videocall_source:videoCallSource,});this.model.root.update(changes);return false;}
return super.beforeExecuteActionButton(...arguments);}}
return __exports;});;

/* /calendar/static/src/views/calendar_form/calendar_form_view.js */
odoo.define('@calendar/views/calendar_form/calendar_form_view',['@web/core/registry','@web/views/form/form_view','@calendar/views/calendar_form/calendar_form_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");const{CalendarFormController}=require("@calendar/views/calendar_form/calendar_form_controller");const CalendarFormView=__exports.CalendarFormView={...formView,Controller:CalendarFormController,};registry.category("views").add("calendar_form",CalendarFormView);return __exports;});;

/* /calendar/static/src/views/calendar_form/calendar_quick_create.js */
odoo.define('@calendar/views/calendar_form/calendar_quick_create',['@web/core/registry','@web/views/view_dialogs/form_view_dialog','@calendar/views/calendar_form/calendar_form_view','@calendar/views/calendar_form/calendar_form_controller','@web/core/l10n/dates'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");const{CalendarFormView}=require("@calendar/views/calendar_form/calendar_form_view");const{CalendarFormController}=require("@calendar/views/calendar_form/calendar_form_controller");const{serializeDate,serializeDateTime}=require("@web/core/l10n/dates");const QUICK_CREATE_CALENDAR_EVENT_FIELDS={name:{type:"string"},start:{type:"datetime"},start_date:{type:"date"},stop_date:{type:"date"},stop:{type:"datetime"},allday:{type:"boolean"},partner_ids:{type:"many2many"},videocall_location:{type:"string"},description:{type:"string"}};function getDefaultValuesFromRecord(data){const context={};for(let fieldName in QUICK_CREATE_CALENDAR_EVENT_FIELDS){if(fieldName in data){let value=data[fieldName];const{type}=QUICK_CREATE_CALENDAR_EVENT_FIELDS[fieldName]
if(type==='many2many'){value=value.records.map((record)=>record.resId);}else if(type==='date'){value=value&&serializeDate(value);}else if(type==="datetime"){value=value&&serializeDateTime(value);}
context[`default_${fieldName}`]=value||false;}}
return context;}
const CalendarQuickCreateFormController=__exports.CalendarQuickCreateFormController=class CalendarQuickCreateFormController extends CalendarFormController{static props={...CalendarFormController.props,goToFullEvent:Function,};goToFullEvent(){const context=getDefaultValuesFromRecord(this.model.root.data)
this.props.goToFullEvent(context);}}
registry.category("views").add("calendar_quick_create_form_view",{...CalendarFormView,Controller:CalendarQuickCreateFormController,});const CalendarQuickCreate=__exports.CalendarQuickCreate=class CalendarQuickCreate extends FormViewDialog{static props={...FormViewDialog.props,goToFullEvent:Function,};setup(){super.setup();Object.assign(this.viewProps,{...this.viewProps,buttonTemplate:"calendar.CalendarQuickCreateButtons",goToFullEvent:(contextData)=>{this.props.goToFullEvent(contextData);}});}}
return __exports;});;

/* /calendar/static/src/views/fields/attendee_tags_list.js */
odoo.define('@calendar/views/fields/attendee_tags_list',['@web/core/tags_list/tags_list'],function(require){'use strict';let __exports={};const{TagsList}=require("@web/core/tags_list/tags_list");const AttendeeTagsList=__exports.AttendeeTagsList=class AttendeeTagsList extends TagsList{static template="calendar.AttendeeTagsList";}
return __exports;});;

/* /calendar/static/src/views/fields/many2many_attendee.js */
odoo.define('@calendar/views/fields/many2many_attendee',['@web/core/registry','@web/views/fields/many2many_tags_avatar/many2many_tags_avatar_field','@web/views/fields/relational_utils','@calendar/views/fields/attendee_tags_list'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Many2ManyTagsAvatarField,many2ManyTagsAvatarField,}=require("@web/views/fields/many2many_tags_avatar/many2many_tags_avatar_field");const{useSpecialData}=require("@web/views/fields/relational_utils");const{AttendeeTagsList}=require("@calendar/views/fields/attendee_tags_list");const ICON_BY_STATUS={accepted:"fa-check",declined:"fa-times",tentative:"fa-question",};const Many2ManyAttendee=__exports.Many2ManyAttendee=class Many2ManyAttendee extends Many2ManyTagsAvatarField{static template="calendar.Many2ManyAttendee";static components={...Many2ManyAttendee.components,TagsList:AttendeeTagsList,};setup(){super.setup();this.specialData=useSpecialData((orm,props)=>{const{context,name,record}=props;return orm.call("res.partner","get_attendee_detail",[record.data[name].records.map((rec)=>rec.resId),[record.resId||false]],{context,});});}
get tags(){const partnerIds=this.specialData.data;const noEmailPartnerIds=this.props.record.data.invalid_email_partner_ids?this.props.record.data.invalid_email_partner_ids.records:[];const tags=super.tags.map((tag)=>{const partner=partnerIds.find((partner)=>tag.resId===partner.id);const noEmail=noEmailPartnerIds.find((partner)=>(tag.resId==partner.resId));if(partner){tag.status=partner.status;tag.statusIcon=ICON_BY_STATUS[partner.status];}
if(noEmail){tag.noEmail=true;}
return tag;});const organizer=partnerIds.find((partner)=>partner.is_organizer);if(organizer){const orgId=organizer.id;tags.sort((a,b)=>{const a_org=a.resId===orgId;return a_org?-1:1;});}
return tags;}}
const many2ManyAttendee=__exports.many2ManyAttendee={...many2ManyTagsAvatarField,component:Many2ManyAttendee,additionalClasses:["o_field_many2many_tags_avatar","w-100"],};registry.category("fields").add("many2manyattendee",many2ManyAttendee);return __exports;});;

/* /calendar/static/src/views/fields/many2many_attendee_expandable.js */
odoo.define('@calendar/views/fields/many2many_attendee_expandable',['@odoo/owl','@web/core/registry','@web/core/position/utils','@calendar/views/fields/many2many_attendee'],function(require){'use strict';let __exports={};const{useState,useEffect}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{reposition}=require("@web/core/position/utils");const{Many2ManyAttendee,many2ManyAttendee}=require("@calendar/views/fields/many2many_attendee");const Many2ManyAttendeeExpandable=__exports.Many2ManyAttendeeExpandable=class Many2ManyAttendeeExpandable extends Many2ManyAttendee{static template="calendar.Many2ManyAttendeeExpandable";state=useState({expanded:false});setup(){super.setup();this.attendeesCount=this.props.record.data.attendees_count;this.acceptedCount=this.props.record.data.accepted_count;this.declinedCount=this.props.record.data.declined_count;this.uncertainCount=this.attendeesCount-this.acceptedCount-this.declinedCount;if(!this.env.isSmall){useEffect(()=>{const popover=document.querySelector(".o_field_many2manyattendeeexpandable").closest(".o_popover");const target=document.querySelector(`.fc-event[data-event-id="${this.props.record.resId}"]`);reposition(popover,target,{position:"right",margin:0});},()=>[this.state.expanded]);}}
onExpanderClick(){this.state.expanded=!this.state.expanded;}}
const many2ManyAttendeeExpandable=__exports.many2ManyAttendeeExpandable={...many2ManyAttendee,component:Many2ManyAttendeeExpandable,};registry.category("fields").add("many2manyattendeeexpandable",many2ManyAttendeeExpandable);return __exports;});;

/* /calendar/static/src/views/list_view/calendar_list_view.js */
odoo.define('@calendar/views/list_view/calendar_list_view',['@web/views/list/list_view','@web/core/registry','@web/core/user'],function(require){'use strict';let __exports={};const{listView}=require("@web/views/list/list_view");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const CalendarListModel=__exports.CalendarListModel=class CalendarListModel extends listView.Model{setup(params,{action,dialog,notification,rpc,user,view,company}){super.setup(...arguments);}
async load(params={}){const filters=params?.context?.calendar_filters;const emptyDomain=Array.isArray(params?.domain)&&params.domain.length==0;if(filters&&emptyDomain){const selectedPartnerIds=await this.orm.call("res.users","get_selected_calendars_partner_ids",[[user.userId],filters["user"]]);if(!filters["all"])
params.domain.push(["partner_ids","in",selectedPartnerIds]);}
return super.load(params);}}
const CalendarListView=__exports.CalendarListView={...listView,Model:CalendarListModel,};function _mockGetCalendarPartnerIds(params){return[];}
registry.category("views").add("calendar_list_view",CalendarListView);registry.category("sample_server").add("get_selected_calendars_partner_ids",_mockGetCalendarPartnerIds);return __exports;});;

/* /calendar/static/src/views/widgets/calendar_week_days.js */
odoo.define('@calendar/views/widgets/calendar_week_days',['@web/core/registry','@web/views/widgets/week_days/week_days'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{WeekDays,weekDays}=require("@web/views/widgets/week_days/week_days");const CalendarWeekDays=__exports.CalendarWeekDays=class CalendarWeekDays extends WeekDays{static template="calendar.WeekDays";onChange(day){this.props.record.update({[day]:!this.data[day]});}};const calendarWeekDays=__exports.calendarWeekDays={component:CalendarWeekDays,fieldDependencies:weekDays.fieldDependencies,};registry.category("view_widgets").add("calendar_week_days",calendarWeekDays);return __exports;});;

/* /crm/static/src/activity_menu_patch.js */
odoo.define('@crm/activity_menu_patch',['@mail/core/web/activity_menu','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ActivityMenu}=require("@mail/core/web/activity_menu");const{patch}=require("@web/core/utils/patch");patch(ActivityMenu.prototype,{availableViews(group){if(group.model==="crm.lead"){return[[false,"list"],[false,"kanban"],[false,"form"],[false,"calendar"],[false,"pivot"],[false,"graph"],[false,"activity"],];}
return super.availableViews(...arguments);},openActivityGroup(group,filter="all"){const context={};if(group.model==="crm.lead"){this.dropdown.close();if(filter==="my"){context["search_default_activities_overdue"]=1;context["search_default_activities_today"]=1;}else{context["search_default_activities_"+filter]=1;}
context["force_search_count"]=1;this.action.doAction("crm.crm_lead_action_my_activities",{additionalContext:context,clearBreadcrumbs:true,});}else{return super.openActivityGroup(group,filter);}},});return __exports;});;

/* /crm/static/src/js/tours/crm.js */
odoo.define('@crm/js/tours/crm',['@web/core/l10n/translation','@web/core/registry','@web_tour/tour_service/tour_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{stepUtils}=require("@web_tour/tour_service/tour_utils");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add('crm_tour',{url:"/odoo",steps:()=>[stepUtils.showAppsMenuItem(),{isActive:["community"],trigger:'.o_app[data-menu-xmlid="crm.crm_menu_root"]',content:markup(_t('Ready to boost your sales? Let\'s have a look at your <b>Pipeline</b>.')),tooltipPosition:'bottom',run:"click",},{isActive:["enterprise"],trigger:'.o_app[data-menu-xmlid="crm.crm_menu_root"]',content:markup(_t('Ready to boost your sales? Let\'s have a look at your <b>Pipeline</b>.')),tooltipPosition:'bottom',run:"click",},{trigger:".o_opportunity_kanban",},{trigger:'.o_opportunity_kanban .o-kanban-button-new',content:markup(_t("<b>Create your first opportunity.</b>")),tooltipPosition:'bottom',run:"click",},{trigger:".o_kanban_quick_create .o_field_widget[name='partner_id'] input",content:markup(_t('<b>Write a few letters</b> to look for a company, or create a new one.')),tooltipPosition:"top",run:"edit Brandon Freeman",},{isActive:["auto"],trigger:".ui-menu-item > a",run:"click",},{trigger:".o_kanban_quick_create .o_kanban_add",content:markup(_t("Now, <b>add your Opportunity</b> to your Pipeline.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_opportunity_kanban",},{trigger:".o_opportunity_kanban:not(:has(.o_view_sample_data)) .o_kanban_group .o_kanban_record:last-of-type",content:markup(_t("<b>Drag &amp; drop opportunities</b> between columns as you progress in your sales cycle.")),tooltipPosition:"right",run:"drag_and_drop(.o_opportunity_kanban .o_kanban_group:eq(2))",},{trigger:".o_opportunity_kanban",},{trigger:".o_opportunity_kanban .o_kanban_group .o_kanban_record .o-mail-ActivityButton",content:markup(_t("Looks like nothing is planned. :(<br><br><i>Tip: Schedule activities to keep track of everything you have to do!</i>")),tooltipPosition:"bottom",run:"click",},{trigger:".o_opportunity_kanban",},{trigger:".o-mail-ActivityListPopover button:contains(Schedule an activity)",content:markup(_t("Let's <b>Schedule an Activity.</b>")),tooltipPosition:"bottom",run:"click",},{trigger:'.modal-footer button[name="action_schedule_activities"]',content:markup(_t("All set. Let’s <b>Schedule</b> it.")),tooltipPosition:"top",run:"click",},{id:"drag_opportunity_to_won_step",trigger:".o_opportunity_kanban .o_kanban_record:last-of-type",content:markup(_t("Drag your opportunity to <b>Won</b> when you get the deal. Congrats!")),tooltipPosition:"right",run:"drag_and_drop(.o_opportunity_kanban .o_kanban_group:eq(3))",},{trigger:".o_opportunity_kanban",},{trigger:".o_kanban_record",content:_t("Let’s have a look at an Opportunity."),tooltipPosition:"right",run:"click",},{trigger:".o_lead_opportunity_form .o_statusbar_status",content:_t("You can make your opportunity advance through your pipeline from here."),tooltipPosition:"bottom",run:"click",},{trigger:".breadcrumb-item:not(.active):first",content:_t("Click on the breadcrumb to go back to your Pipeline. Odoo will save all modifications as you navigate."),tooltipPosition:"bottom",run:"click .breadcrumb-item:not(.active):last",}]});return __exports;});;

/* /crm/static/src/views/check_rainbowman_message.js */
odoo.define('@crm/views/check_rainbowman_message',[],function(require){'use strict';let __exports={};__exports.checkRainbowmanMessage=checkRainbowmanMessage;async function checkRainbowmanMessage(orm,effect,recordId){const message=await orm.call("crm.lead","get_rainbowman_message",[[recordId]]);if(message){effect.add({message,type:"rainbow_man",});}}
return __exports;});;

/* /crm/static/src/views/crm_form/crm_form.js */
odoo.define('@crm/views/crm_form/crm_form',['@crm/views/check_rainbowman_message','@web/core/registry','@web/views/form/form_view'],function(require){'use strict';let __exports={};const{checkRainbowmanMessage}=require("@crm/views/check_rainbowman_message");const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");class CrmFormRecord extends formView.Model.Record{async _save(){if(this.resModel!=="crm.lead"){return super._save(...arguments);}
let changeStage=false;const needsSynchronizationEmail=this._changes.partner_email_update===undefined?this._values.partner_email_update:this._changes.partner_email_update;const needsSynchronizationPhone=this._changes.partner_phone_update===undefined?this._values.partner_phone_update:this._changes.partner_phone_update;if(needsSynchronizationEmail&&this._changes.email_from===undefined&&this._values.email_from){this._changes.email_from=this._values.email_from;}
if(needsSynchronizationPhone&&this._changes.phone===undefined&&this._values.phone){this._changes.phone=this._values.phone;}
if("stage_id"in this._changes){changeStage=this._values.stage_id!==this.data.stage_id;}
const res=await super._save(...arguments);if(changeStage){await checkRainbowmanMessage(this.model.orm,this.model.effect,this.resId);}
return res;}}
class CrmFormModel extends formView.Model{static Record=CrmFormRecord;static services=[...formView.Model.services,"effect"];setup(params,services){super.setup(...arguments);this.effect=services.effect;}}
registry.category("views").add("crm_form",{...formView,Model:CrmFormModel,});return __exports;});;

/* /crm/static/src/views/crm_kanban/crm_column_progress.js */
odoo.define('@crm/views/crm_kanban/crm_column_progress',['@odoo/owl','@web/core/user','@web/views/view_components/column_progress','@web/session','@web/core/currency'],function(require){'use strict';let __exports={};const{onWillStart}=require("@odoo/owl");const{user}=require("@web/core/user");const{ColumnProgress}=require("@web/views/view_components/column_progress");const{session}=require("@web/session");const{getCurrency}=require("@web/core/currency");const CrmColumnProgress=__exports.CrmColumnProgress=class CrmColumnProgress extends ColumnProgress{static props={...ColumnProgress.props,progressBarState:{type:Object},};static template="crm.ColumnProgress";setup(){super.setup();this.showRecurringRevenue=false;onWillStart(async()=>{if(this.props.progressBarState.progressAttributes.recurring_revenue_sum_field){this.showRecurringRevenue=await user.hasGroup("crm.group_use_recurring_revenues");}});}
getRecurringRevenueGroupAggregate(group){const rrField=this.props.progressBarState.progressAttributes.recurring_revenue_sum_field;const aggregatedValue=this.props.progressBarState.getAggregateValue(group,rrField);let currency=false;if(aggregatedValue.value&&rrField.currency_field){currency=getCurrency(session.company_currency_id);}
return{...aggregatedValue,currency};}}
return __exports;});;

/* /crm/static/src/views/crm_kanban/crm_kanban_arch_parser.js */
odoo.define('@crm/views/crm_kanban/crm_kanban_arch_parser',['@web/views/kanban/kanban_arch_parser','@web/core/utils/xml'],function(require){'use strict';let __exports={};const{KanbanArchParser}=require("@web/views/kanban/kanban_arch_parser");const{extractAttributes}=require("@web/core/utils/xml");const CrmKanbanArchParser=__exports.CrmKanbanArchParser=class CrmKanbanArchParser extends KanbanArchParser{parseProgressBar(progressBar,fields){const result=super.parseProgressBar(...arguments);const attrs=extractAttributes(progressBar,["recurring_revenue_sum_field"]);result.recurring_revenue_sum_field=fields[attrs.recurring_revenue_sum_field]||false;return result;}}
return __exports;});;

/* /crm/static/src/views/crm_kanban/crm_kanban_model.js */
odoo.define('@crm/views/crm_kanban/crm_kanban_model',['@crm/views/check_rainbowman_message','@web/model/relational_model/relational_model'],function(require){'use strict';let __exports={};const{checkRainbowmanMessage}=require("@crm/views/check_rainbowman_message");const{RelationalModel}=require("@web/model/relational_model/relational_model");const CrmKanbanModel=__exports.CrmKanbanModel=class CrmKanbanModel extends RelationalModel{setup(params,{effect}){super.setup(...arguments);this.effect=effect;}}
const CrmKanbanDynamicGroupList=__exports.CrmKanbanDynamicGroupList=class CrmKanbanDynamicGroupList extends RelationalModel.DynamicGroupList{async moveRecord(dataRecordId,dataGroupId,refId,targetGroupId){await super.moveRecord(...arguments);const sourceGroup=this.groups.find((g)=>g.id===dataGroupId);const targetGroup=this.groups.find((g)=>g.id===targetGroupId);if(dataGroupId!==targetGroupId&&sourceGroup&&targetGroup&&sourceGroup.groupByField.name==="stage_id"){const record=targetGroup.list.records.find((r)=>r.id===dataRecordId);await checkRainbowmanMessage(this.model.orm,this.model.effect,record.resId);}}}
CrmKanbanModel.DynamicGroupList=CrmKanbanDynamicGroupList;CrmKanbanModel.services=[...RelationalModel.services,"effect"];return __exports;});;

/* /crm/static/src/views/crm_kanban/crm_kanban_renderer.js */
odoo.define('@crm/views/crm_kanban/crm_kanban_renderer',['@crm/views/crm_kanban/crm_column_progress','@web/views/kanban/kanban_renderer','@web/views/kanban/kanban_header'],function(require){'use strict';let __exports={};const{CrmColumnProgress}=require("@crm/views/crm_kanban/crm_column_progress");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{KanbanHeader}=require("@web/views/kanban/kanban_header");class CrmKanbanHeader extends KanbanHeader{static template="crm.CrmKanbanHeader";static components={...KanbanHeader.components,ColumnProgress:CrmColumnProgress,};}
const CrmKanbanRenderer=__exports.CrmKanbanRenderer=class CrmKanbanRenderer extends KanbanRenderer{static components={...KanbanRenderer.components,KanbanHeader:CrmKanbanHeader,};}
return __exports;});;

/* /crm/static/src/views/crm_kanban/crm_kanban_view.js */
odoo.define('@crm/views/crm_kanban/crm_kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@crm/views/crm_kanban/crm_kanban_model','@crm/views/crm_kanban/crm_kanban_arch_parser','@crm/views/crm_kanban/crm_kanban_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{CrmKanbanModel}=require("@crm/views/crm_kanban/crm_kanban_model");const{CrmKanbanArchParser}=require("@crm/views/crm_kanban/crm_kanban_arch_parser");const{CrmKanbanRenderer}=require("@crm/views/crm_kanban/crm_kanban_renderer");const crmKanbanView=__exports.crmKanbanView={...kanbanView,ArchParser:CrmKanbanArchParser,Controller:class extends kanbanView.Controller{get progressBarAggregateFields(){const res=super.progressBarAggregateFields;const progressAttributes=this.props.archInfo.progressAttributes;if(progressAttributes&&progressAttributes.recurring_revenue_sum_field){res.push(progressAttributes.recurring_revenue_sum_field);}
return res;}},Model:CrmKanbanModel,Renderer:CrmKanbanRenderer,};registry.category("views").add("crm_kanban",crmKanbanView);return __exports;});;

/* /crm/static/src/views/fill_temporal_service.js */
odoo.define('@crm/views/fill_temporal_service',['@web/core/registry','@web/core/l10n/dates'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{serializeDate,serializeDateTime,}=require("@web/core/l10n/dates");const GRANULARITY_TABLE=__exports.GRANULARITY_TABLE={hour:{startOf:(x)=>x.startOf("hour"),cycle:24,cyclePos:(x)=>x.hour+1,},day:{startOf:(x)=>x.startOf("day"),cycle:7,cyclePos:(x)=>x.weekday,},week:{startOf:(x)=>x.startOf("week"),cycle:1,cyclePos:(x)=>1,},month:{startOf:(x)=>x.startOf("month"),cycle:12,cyclePos:(x)=>x.month,},quarter:{startOf:(x)=>x.startOf("quarter"),cycle:4,cyclePos:(x)=>x.quarter,},year:{startOf:(x)=>x.startOf("year"),cycle:1,cyclePos:(x)=>1,},};const FillTemporalPeriod=__exports.FillTemporalPeriod=class FillTemporalPeriod{constructor(modelName,field,granularity,minGroups){this.modelName=modelName;this.field=field;this.granularity=granularity||"month";this.setMinGroups(minGroups);this._computeStart();this._computeEnd();}
_computeStart(){this.start=GRANULARITY_TABLE[this.granularity].startOf(luxon.DateTime.now());}
_computeEnd(){const cycle=GRANULARITY_TABLE[this.granularity].cycle;const cyclePos=GRANULARITY_TABLE[this.granularity].cyclePos(this.start);const fillTemporalPeriod=((2*cycle-((this.minGroups-1)%cycle)-cyclePos)%cycle)+this.minGroups;this.end=this.start.plus({[`${this.granularity}s`]:fillTemporalPeriod});this.computedEnd=true;}
_getFormattedServerDate(bound){if(this.field.type==="date"){return serializeDate(bound);}else{return serializeDateTime(bound);}}
getDomain({domain,forceStartBound=true,forceEndBound=true}){if(!forceEndBound&&!forceStartBound){return domain;}
const originalDomain=domain.length?["&",...domain]:[];const defaultDomain=["|",[this.field.name,"=",false]];const linkDomain=forceStartBound&&forceEndBound?["&"]:[];const startDomain=!forceStartBound?[]:[[this.field.name,">=",this._getFormattedServerDate(this.start)]];const endDomain=!forceEndBound?[]:[[this.field.name,"<",this._getFormattedServerDate(this.end)]];return[...originalDomain,...defaultDomain,...linkDomain,...startDomain,...endDomain];}
getContext({context,forceFillingFrom=true,forceFillingTo=!this.computedEnd}){const fillTemporal={min_groups:this.minGroups,};if(forceFillingFrom){fillTemporal.fill_from=this._getFormattedServerDate(this.start);}
if(forceFillingTo){const minGranularity=this.field.type==="date"?"days":"seconds";fillTemporal.fill_to=this._getFormattedServerDate(this.end.minus({[minGranularity]:1}));}
context={...context,fill_temporal:fillTemporal};return context;}
setMinGroups(minGroups){this.minGroups=minGroups||1;}
setEnd(end){this.end=luxon.DateTime.max(this.start,end);this.computedEnd=false;}
setStart(start){this.start=luxon.DateTime.min(this.end,start);}
expand(){this.setEnd(this.end.plus({[`${this.granularity}s`]:1}));}}
const fillTemporalService=__exports.fillTemporalService={start(){const _fillTemporalPeriods={};const getFillTemporalPeriod=({modelName,field,granularity,minGroups=4,forceRecompute=false})=>{if(!(modelName in _fillTemporalPeriods)){_fillTemporalPeriods[modelName]={};}
if(!(field.name in _fillTemporalPeriods[modelName])){_fillTemporalPeriods[modelName][field.name]={};}
if(!(granularity in _fillTemporalPeriods[modelName][field.name])||forceRecompute){_fillTemporalPeriods[modelName][field.name][granularity]=new FillTemporalPeriod(modelName,field,granularity,minGroups);}else if(_fillTemporalPeriods[modelName][field.name][granularity].minGroups!=minGroups){_fillTemporalPeriods[modelName][field.name][granularity].setMinGroups(minGroups);}
return _fillTemporalPeriods[modelName][field.name][granularity];};return{getFillTemporalPeriod};},};registry.category("services").add("fillTemporalService",fillTemporalService);return __exports;});;

/* /crm/static/src/views/forecast_kanban/forecast_kanban_column_quick_create.js */
odoo.define('@crm/views/forecast_kanban/forecast_kanban_column_quick_create',['@web/core/l10n/translation','@web/search/utils/dates','@web/views/kanban/kanban_column_quick_create'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{INTERVAL_OPTIONS}=require("@web/search/utils/dates");const{KanbanColumnQuickCreate}=require("@web/views/kanban/kanban_column_quick_create");const ForecastKanbanColumnQuickCreate=__exports.ForecastKanbanColumnQuickCreate=class ForecastKanbanColumnQuickCreate extends KanbanColumnQuickCreate{get relatedFieldName(){const{granularity="month"}=this.props.groupByField;const{description}=INTERVAL_OPTIONS[granularity];return _t("Add next %s",description.toLocaleLowerCase());}
unfold(){this.props.onValidate();}}
return __exports;});;

/* /crm/static/src/views/forecast_kanban/forecast_kanban_controller.js */
odoo.define('@crm/views/forecast_kanban/forecast_kanban_controller',['@crm/views/crm_kanban/crm_kanban_view'],function(require){'use strict';let __exports={};const{crmKanbanView}=require("@crm/views/crm_kanban/crm_kanban_view");const ForecastKanbanController=__exports.ForecastKanbanController=class ForecastKanbanController extends crmKanbanView.Controller{isQuickCreateField(field){return super.isQuickCreateField(...arguments)||(field&&field.name==="date_deadline");}}
return __exports;});;

/* /crm/static/src/views/forecast_kanban/forecast_kanban_model.js */
odoo.define('@crm/views/forecast_kanban/forecast_kanban_model',['@crm/views/crm_kanban/crm_kanban_model','@web/core/l10n/dates'],function(require){'use strict';let __exports={};const{CrmKanbanModel}=require("@crm/views/crm_kanban/crm_kanban_model");const{deserializeDateTime}=require("@web/core/l10n/dates");const ForecastKanbanModel=__exports.ForecastKanbanModel=class ForecastKanbanModel extends CrmKanbanModel{setup(params,{fillTemporalService}){super.setup(...arguments);this.fillTemporalService=fillTemporalService;this.forceNextRecompute=!params.state?.groups;this.originalDomain=null;this.fillTemporalDomain=null;}
async _webReadGroup(config,orderBy){if(this.isForecastGroupBy(config)){config.context=this.fillTemporalPeriod(config).getContext({context:config.context,});if(!this.originalDomain||this.fillTemporalDomain!==config.domain){this.originalDomain=config.domain||[];}
this.fillTemporalDomain=this.fillTemporalPeriod(config).getDomain({domain:this.originalDomain,forceStartBound:false,});config.domain=this.fillTemporalDomain;}
return super._webReadGroup(...arguments);}
async _loadGroupedList(config){const res=await super._loadGroupedList(...arguments);if(this.isForecastGroupBy(config)){const lastGroup=res.groups.filter((grp)=>grp.value).slice(-1)[0];if(lastGroup){this.fillTemporalPeriod(config).setEnd(deserializeDateTime(lastGroup.range.to));}}
return res;}
isForecastGroupBy(config){const forecastField=config.context.forecast_field;const name=config.groupBy[0].split(":")[0];return forecastField&&forecastField===name;}
fillTemporalPeriod(config){const[groupByFieldName,granularity]=config.groupBy[0].split(":");const groupByField=config.fields[groupByFieldName];const minGroups=(config.context.fill_temporal&&config.context.fill_temporal.min_groups)||undefined;const{name,type}=groupByField;const forceRecompute=this.forceNextRecompute;this.forceNextRecompute=false;return this.fillTemporalService.getFillTemporalPeriod({modelName:config.resModel,field:{name,type,},granularity:granularity||"month",minGroups,forceRecompute,});}}
ForecastKanbanModel.services=[...CrmKanbanModel.services,"fillTemporalService"];return __exports;});;

/* /crm/static/src/views/forecast_kanban/forecast_kanban_renderer.js */
odoo.define('@crm/views/forecast_kanban/forecast_kanban_renderer',['@crm/views/crm_kanban/crm_kanban_renderer','@web/core/utils/hooks','@crm/views/forecast_kanban/forecast_kanban_column_quick_create'],function(require){'use strict';let __exports={};const{CrmKanbanRenderer}=require("@crm/views/crm_kanban/crm_kanban_renderer");const{useService}=require("@web/core/utils/hooks");const{ForecastKanbanColumnQuickCreate}=require("@crm/views/forecast_kanban/forecast_kanban_column_quick_create");const ForecastKanbanRenderer=__exports.ForecastKanbanRenderer=class ForecastKanbanRenderer extends CrmKanbanRenderer{static template="crm.ForecastKanbanRenderer";static components={...CrmKanbanRenderer.components,ForecastKanbanColumnQuickCreate,};setup(){super.setup(...arguments);this.fillTemporalService=useService("fillTemporalService");}
canCreateGroup(){return super.canCreateGroup(...arguments)||this.isGroupedByForecastField();}
isGroupedByForecastField(){return(this.props.list.context.forecast_field&&this.props.list.groupByField.name===this.props.list.context.forecast_field);}
isMovableField(field){return super.isMovableField(...arguments)||field.name==="date_deadline";}
async addForecastColumn(){const{name,type,granularity}=this.props.list.groupByField;this.fillTemporalService.getFillTemporalPeriod({modelName:this.props.list.resModel,field:{name,type,},granularity:granularity||"month",}).expand();await this.props.list.load();}}
return __exports;});;

/* /crm/static/src/views/forecast_kanban/forecast_kanban_view.js */
odoo.define('@crm/views/forecast_kanban/forecast_kanban_view',['@crm/views/forecast_kanban/forecast_kanban_controller','@crm/views/crm_kanban/crm_kanban_arch_parser','@crm/views/forecast_kanban/forecast_kanban_model','@crm/views/forecast_kanban/forecast_kanban_renderer','@crm/views/forecast_search_model','@web/core/registry','@web/views/kanban/kanban_view'],function(require){'use strict';let __exports={};const{ForecastKanbanController}=require("@crm/views/forecast_kanban/forecast_kanban_controller");const{CrmKanbanArchParser}=require("@crm/views/crm_kanban/crm_kanban_arch_parser");const{ForecastKanbanModel}=require("@crm/views/forecast_kanban/forecast_kanban_model");const{ForecastKanbanRenderer}=require("@crm/views/forecast_kanban/forecast_kanban_renderer");const{ForecastSearchModel}=require("@crm/views/forecast_search_model");const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const forecastKanbanView=__exports.forecastKanbanView={...kanbanView,ArchParser:CrmKanbanArchParser,Model:ForecastKanbanModel,Controller:ForecastKanbanController,Renderer:ForecastKanbanRenderer,SearchModel:ForecastSearchModel,};registry.category("views").add("forecast_kanban",forecastKanbanView);return __exports;});;

/* /crm/static/src/views/forecast_list/forecast_list_view.js */
odoo.define('@crm/views/forecast_list/forecast_list_view',['@web/core/registry','@web/views/list/list_view','@crm/views/forecast_search_model'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{ForecastSearchModel}=require("@crm/views/forecast_search_model");const forecastListView=__exports.forecastListView={...listView,SearchModel:ForecastSearchModel,};registry.category("views").add("forecast_list",forecastListView);return __exports;});;

/* /crm/static/src/views/forecast_search_model.js */
odoo.define('@crm/views/forecast_search_model',['@web/core/domain','@web/core/context','@web/search/search_model','@web/core/l10n/dates'],function(require){'use strict';let __exports={};const{Domain}=require("@web/core/domain");const{makeContext}=require("@web/core/context");const{SearchModel}=require("@web/search/search_model");const{serializeDate,serializeDateTime,}=require("@web/core/l10n/dates");const ForecastSearchModel=__exports.ForecastSearchModel=class ForecastSearchModel extends SearchModel{exportState(){const state=super.exportState();state.forecast={forecastStart:this.forecastStart,};return state;}
_getSearchItemDomain(activeItem){let domain=super._getSearchItemDomain(activeItem);const{searchItemId}=activeItem;const searchItem=this.searchItems[searchItemId];const context=makeContext([searchItem.context||{}]);if(context.forecast_filter){const forecastField=this.globalContext.forecast_field;const forecastStart=this._getForecastStart(forecastField);const forecastDomain=["|",[forecastField,"=",false],[forecastField,">=",forecastStart],];domain=Domain.and([domain,forecastDomain]);}
return domain;}
_getForecastStart(forecastField){if(!this.forecastStart){const{type}=this.searchViewFields[forecastField];const groupBy=this.groupBy;const firstForecastGroupBy=groupBy.find((gb)=>gb.includes(forecastField));let granularity="month";if(firstForecastGroupBy){granularity=firstForecastGroupBy.split(":")[1]||"month";}else if(groupBy.length){granularity="day";}
const startDateTime=luxon.DateTime.now().startOf(granularity);this.forecastStart=type==="datetime"?serializeDateTime(startDateTime):serializeDate(startDateTime);}
return this.forecastStart;}
_importState(state){super._importState(...arguments);if(state.forecast){this.forecastStart=state.forecast.forecastStart;}}
_reset(){super._reset();this.forecastStart=null;}}
return __exports;});;

/* /website/static/src/components/resource_editor/resource_editor.js */
odoo.define('@website/components/resource_editor/resource_editor',['@web/core/code_editor/code_editor','@web/core/confirmation_dialog/confirmation_dialog','@web/core/dropdown/dropdown','@web/core/dropdown/checkbox_item','@web/core/dropdown/dropdown_item','@web/core/l10n/translation','@web/core/network/rpc','@web/core/select_menu/select_menu','@web/core/user','@web/core/utils/arrays','@web/core/utils/concurrency','@web/core/utils/hooks','@website/components/resource_editor/resource_editor_warning','@website/components/resource_editor/utils','@odoo/owl'],function(require){'use strict';let __exports={};const{CodeEditor}=require("@web/core/code_editor/code_editor");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{Dropdown}=require("@web/core/dropdown/dropdown");const{CheckboxItem}=require("@web/core/dropdown/checkbox_item");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{SelectMenu}=require("@web/core/select_menu/select_menu");const{user}=require("@web/core/user");const{sortBy}=require("@web/core/utils/arrays");const{KeepLast}=require("@web/core/utils/concurrency");const{useService}=require("@web/core/utils/hooks");const{ResourceEditorWarningOverlay}=require("@website/components/resource_editor/resource_editor_warning");const{checkSCSS,checkXML,formatXML}=require("@website/components/resource_editor/utils");const{Component,onWillUnmount,onWillStart,reactive,useRef,useState}=require("@odoo/owl");const BUNDLES_RESTRICTION=["web.assets_frontend","web.assets_frontend_minimal","web.assets_frontend_lazy",];const ResourceEditor=__exports.ResourceEditor=class ResourceEditor extends Component{static components={ResourceEditorWarningOverlay,CodeEditor,Dropdown,CheckboxItem,DropdownItem,SelectMenu,};static template="website.ResourceEditor";static props={close:{type:Function,optional:true},};static defaultProps={close:()=>{},};setup(){this.website=useService("website");this.orm=useService("orm");this.dialog=useService("dialog");this.keepLast=new KeepLast();this.editorRef=useRef("editor");this.debug=this.env.debug;this.viewKey=this.website.pageDocument&&this.website.pageDocument.documentElement.dataset.viewXmlid;this.types={xml:"XML (HTML)",scss:"SCSS (CSS)",js:"JS",};this.typeToCodeEditorModeMap={xml:"qweb",scss:"scss",js:"javascript",};this.xmlFilters={views:_t("Only Views"),all:_t("Views and Assets bundles"),};this.scssFilters={custom:_t("Only Custom SCSS Files"),restricted:_t("Only Page SCSS Files"),all:_t("All SCSS Files"),};this.state=useState({type:"xml",xmlFilter:"views",scssFilter:"custom",currentResource:false,showEditWarning:true,resources:{xml:{},js:{},scss:{},},sortedXML:[],sortedSCSS:[],sortedJS:[],saving:false,});let showErrorInterval;this.errors=reactive([],()=>{clearInterval(showErrorInterval);if(this.errors.length){this.showErrorLine();showErrorInterval=setInterval(()=>this.showErrorLine(),500);}else{this.clearErrorLine();}});onWillUnmount(()=>clearInterval(showErrorInterval));onWillStart(async()=>this.loadResources());}
get context(){return{...user.context,website_id:this.website.currentWebsite.id,};}
get resourceInfo(){if(!this.state.currentResource){return"";}
if(this.state.type==="xml"){return _t("Template ID: %s",this.state.currentResource.key);}else if(this.state.type==="scss"){return _t("SCSS file: %s",this.state.currentResource.url);}else{return _t("JS file: %s",this.state.currentResource.url);}}
get selectMenuProps(){const props={onSelect:(value)=>{this.state.currentResource=this.state.resources[this.state.type][value];},autoSort:false,required:true,};if(this.state.type==="xml"){const choices=this.state.sortedXML.map((view)=>{return{value:view.id,label:view.label};});const value=this.state.currentResource?.id;return{...props,choices,value};}else{const{type,sortedSCSS,sortedJS}=this.state;const bundles=type==="scss"?sortedSCSS:sortedJS;const groups=bundles.map(([name,files])=>{const choices=files.map((file)=>({value:file.url,label:file.label}));return{label:name,choices};});const value=this.state.currentResource?.url;return{...props,groups,value};}}
isCustomResource(url){if(this.state.type==="scss"){return this.state.resources.scss[url].customized;}else if(this.state.type==="js"){return this.state.resources.js[url].customized;}
return false;}
async loadResources(){const resources=await this.keepLast.add(rpc("/web_editor/get_assets_editor_resources",{key:this.viewKey,bundles:this.state.xmlFilter==="all",bundles_restriction:BUNDLES_RESTRICTION,only_user_custom_files:this.state.scssFilter==="custom",}));this.state.resources={xml:{},js:{},scss:{}};this.processResources(resources.views||[],"xml");this.processResources(resources.scss||[],"scss");this.processResources(resources.js||[],"js");const type=this.state.type;if(this.state.currentResource){this.state.currentResource=this.state.resources[type][this.state.currentResource.id];}
if(!this.state.currentResource){this.setDefaultFile();}
this.errors.length=0;}
processResources(resources,type){if(type==="xml"){const indexedById={};resources.filter((view)=>view.active).forEach((view)=>{view.type="xml";indexedById[view.id]=view;});Object.assign(this.state.resources.xml,indexedById);const roots=[];Object.values(this.state.resources.xml).forEach((view)=>{view.level=0;view.children=[];});Object.values(this.state.resources.xml).forEach((view)=>{const parentId=view.inherit_id[0];const parent=parentId&&this.state.resources.xml[parentId];if(parent){parent.children.push(view);}else{roots.push(view);}});const sortedXML=[];const visit=(view,level)=>{view.level=level;sortedXML.push(view);view.children.forEach((child)=>{visit(child,level+1);});};roots.forEach((root)=>{visit(root,0);});this.state.sortedXML=sortedXML;Object.values(this.state.resources.xml).forEach((view)=>{view.label=`${"-".repeat(view.level)} ${view.name}`;if(this.debug&&view.xml_id){view.label+=` (${view.xml_id})`;}});}else if(type==="scss"||type==="js"){if(type==="scss"){this.state.sortedSCSS=resources;}else{this.state.sortedJS=resources;}
resources.forEach(([bundle,files])=>{const indexedByUrl={};files.forEach((file)=>{file.label=file.url.split("/").at(-1).split(".")[0];if(this.debug){file.label+=` (${file.url})`;}
file.bundle=bundle;file.id=file.url;file.type=type;indexedByUrl[file.url]=file;});if(type==="scss"){Object.assign(this.state.resources.scss,indexedByUrl);}else{Object.assign(this.state.resources.js,indexedByUrl);}});}}
async resetResource(){if(this.state.type==="xml"){throw new Error(_t("Reseting views is not supported yet"));}
const resource=this.state.currentResource;await this.orm.call("web_editor.assets","reset_asset",[resource.url,resource.bundle],{context:this.context,});await this.loadResources();this.website.contentWindow.location.reload();}
async saveResources(){const{js,scss,xml}=this.state.resources;const toSave={js:Object.values(js).filter((r)=>r.dirty),scss:Object.values(scss).filter((r)=>r.dirty),xml:sortBy(Object.values(xml).filter((r)=>r.dirty),"id").reverse(),};for(const[type,resources]of Object.entries(toSave)){for(let i=0;i<resources.length;i++){const arch=resources[i].arch;const{isValid,error}=type==="xml"?checkXML(arch):checkSCSS(arch);if(!isValid){this.errors.push({error,resource:resources[i]});}}}
if(this.errors.length){if(!this.errors.map(({resource})=>resource.id).includes(this.state.currentResource.id)){this.state.currentResource=this.errors[0].resource;this.state.type=this.errors[0].resource.type;}
return;}
for(const[type,resources]of Object.entries(toSave)){for(const resource of resources){if(type==="xml"){await this.saveXML(resource);}else{await this.saveSCSSorJS(resource);}}}
await this.loadResources();this.website.contentWindow.location.reload();}
async saveSCSSorJS(resource){const{url,arch}=resource;const isJSFile=String(url).endsWith(".js");const bundle=isJSFile?this.state.resources.js[url].bundle:this.state.resources.scss[url].bundle;const fileType=isJSFile?"js":"scss";const params=[url,bundle,arch,fileType];await this.orm.call("web_editor.assets","save_asset",params,{context:this.context});delete resource.dirty;}
async saveXML(resource){const{id,arch}=resource;await rpc("/website/save_xml",{view_id:id,arch:arch,})
delete resource.dirty;}
setDefaultFile(){if(this.state.type==="xml"){const views=Object.values(this.state.resources.xml);let view=views.find((view)=>[view.id,view.xml_id].includes(this.viewKey));if(!view){view=views.find((view)=>view.key===this.viewKey);}
this.state.currentResource=view||this.state.sortedXML[0]||false;}else if(this.state.type==="scss"){this.state.currentResource=this.state.resources.scss["/website/static/src/scss/user_custom_rules.scss"];}else{this.state.currentResource=this.state.sortedJS.map(([_,files])=>files).flat()[0]||false;}}
showErrorLine(){const resourceId=this.state.currentResource.id;const error=this.errors.find(({resource})=>resource.id===resourceId)?.error;if(error){const{line,message}=error;const gutterCell=this.editorRef.el.querySelectorAll(".ace_gutter-cell")[line-1];if(gutterCell&&!gutterCell.classList.contains("o_error")){gutterCell.classList.add("o_error");gutterCell.setAttribute("data-tooltip",message);gutterCell.setAttribute("data-tooltip-position","left");}}}
clearErrorLine(){const allGutterCells=this.editorRef.el.querySelectorAll(".ace_gutter-cell");for(const gutterCell of allGutterCells){gutterCell.classList.remove("o_error");gutterCell.removeAttribute("data-tooltip");gutterCell.removeAttribute("data-tooltip-position");}}
onEditorChange(value){const currentResource=this.state.currentResource;currentResource.arch=value;currentResource.dirty=true;this.errors.length=0;}
onFileTypeChange(type){if(type!==this.state.type){this.state.type=type;this.setDefaultFile();}}
onFilterChange(type,filter){if(type==="scss"){this.state.scssFilter=filter;}else if(type==="xml"){this.state.xmlFilter=filter;}
this.loadResources();}
onFormat(){if(this.state.type==="xml"){const{isValid,error}=checkXML(this.state.currentResource.arch);if(isValid){this.state.currentResource.arch=formatXML(this.state.currentResource.arch);}else{this.errors.push({error,resource:this.state.currentResource});}}}
onReset(){this.dialog.add(ConfirmationDialog,{title:_t("Careful"),body:_t("If you reset this file, all your customizations will be lost as it will be reverted to the default file."),confirm:()=>this.resetResource(),cancel:()=>{},});}
async onSave(){this.state.saving=true;try{await this.saveResources();}finally{this.state.saving=false;}}}
return __exports;});;

/* /website/static/src/components/resource_editor/resource_editor_warning.js */
odoo.define('@website/components/resource_editor/resource_editor_warning',['@website/components/edit_head_body_dialog/edit_head_body_dialog','@odoo/owl','@web/core/browser/browser','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{EditHeadBodyDialog}=require("@website/components/edit_head_body_dialog/edit_head_body_dialog");const{Component,useState}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{useService}=require("@web/core/utils/hooks");const ResourceEditorWarningOverlay=__exports.ResourceEditorWarningOverlay=class ResourceEditorWarningOverlay extends Component{static template="website.ResourceEditorWarningOverlay";static props={};setup(){this.website=useService("website");this.dialog=useService("dialog");const localStorageValue=browser.localStorage.getItem("website.ace.doNotShowWarning");this.state=useState({visible:!localStorageValue||localStorageValue==="false",});}
onCloseEditor(){this.website.context.showResourceEditor=false;}
onHideWarning(){this.state.visible=false;}
onStopAsking(){browser.localStorage.setItem("website.ace.doNotShowWarning","true");this.onHideWarning();}
onInjectCode(){this.dialog.add(EditHeadBodyDialog);this.onCloseEditor();}}
return __exports;});;

/* /website/static/src/components/resource_editor/utils.js */
odoo.define('@website/components/resource_editor/utils',['@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const MAPPING={'{':'}','}':'{','(':')',')':'(','[':']',']':'[',};const OPENINGS=['{','(','['];const CLOSINGS=['}',')',']'];__exports.checkSCSS=checkSCSS;function checkSCSS(scss){const stack=[];let line=1;for(let i=0;i<scss.length;i++){if(OPENINGS.includes(scss[i])){stack.push(scss[i]);}else if(CLOSINGS.includes(scss[i])){if(stack.pop()!==MAPPING[scss[i]]){return{isValid:false,error:{line,message:_t("Unexpected %(char)s",{char:scss[i]}),},};}}else if(scss[i]==='\n'){line++;}}
if(stack.length>0){return{isValid:false,error:{line,message:_t("Expected %(char)s",{char:MAPPING[stack.pop()]}),},};}
return{isValid:true};}
__exports.checkXML=checkXML;function checkXML(xml){const xmlDoc=(new window.DOMParser()).parseFromString(xml,'text/xml');const errorEls=xmlDoc.getElementsByTagName('parsererror');if(errorEls.length>0){const errorEl=errorEls[0];const sourceTextEls=errorEl.querySelectorAll('sourcetext');let codeEls=null;if(sourceTextEls.length){codeEls=[...sourceTextEls].map(el=>{const codeEl=document.createElement('code');codeEl.textContent=el.textContent;const brEl=document.createElement('br');brEl.classList.add('o_we_source_text_origin');el.parentElement.insertBefore(brEl,el);return codeEl;});for(const el of sourceTextEls){el.remove();}}
for(const el of[...errorEl.querySelectorAll(':not(code):not(pre):not(br)')]){const pEl=document.createElement('p');for(const cEl of[...el.childNodes]){pEl.appendChild(cEl);}
el.parentElement.insertBefore(pEl,el);el.remove();}
errorEl.querySelectorAll('.o_we_source_text_origin').forEach((el,i)=>{el.after(codeEls[i]);});return{isValid:false,error:{line:parseInt(errorEl.innerHTML.match(/[Ll]ine[^\d]+(\d+)/)[1],10),message:errorEl.textContent,},};}
return{isValid:true};}
__exports.formatXML=formatXML;function formatXML(xml){if(/<script(?: [^>]*)?>[^<][\s\S]*<\/script>/i.test(xml)){return xml;}
return window.vkbeautify.xml(xml,4);}
return __exports;});;

/* /website/static/src/components/edit_head_body_dialog/edit_head_body_dialog.js */
odoo.define('@website/components/edit_head_body_dialog/edit_head_body_dialog',['@web/core/utils/hooks','@odoo/owl','@web/core/dialog/dialog','@web/core/code_editor/code_editor'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{Component,onWillStart,useState}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{CodeEditor}=require("@web/core/code_editor/code_editor");const EditHeadBodyDialog=__exports.EditHeadBodyDialog=class EditHeadBodyDialog extends Component{static template="website.EditHeadBodyDialog";static components={CodeEditor,Dialog};static props={close:Function,};setup(){this.orm=useService("orm");this.website=useService("website");this.state=useState({head:"",body:"",});onWillStart(async()=>{const websites=await this.orm.read("website",[this.website.currentWebsite.id],["custom_code_head","custom_code_footer"],);const website=websites[0];this.state.head=website.custom_code_head||"";this.state.body=website.custom_code_footer||"";});}
async onSave(){await this.orm.write("website",[this.website.currentWebsite.id],{custom_code_head:this.state.head,custom_code_footer:this.state.body,});this.props.close();}}
return __exports;});;

/* /website/static/src/components/dialog/add_page_dialog.js */
odoo.define('@website/components/dialog/add_page_dialog',['@web/core/browser/feature_detection','@web/core/ensure_jquery','@web/core/network/rpc','@web/core/utils/concurrency','@web/core/utils/render','@web/core/utils/hooks','@web/core/l10n/translation','@website/components/dialog/dialog','@website/components/switch/switch','@website/js/text_processing','@odoo/owl','@website/js/utils'],function(require){'use strict';let __exports={};const{isBrowserFirefox}=require("@web/core/browser/feature_detection");const{ensureJQuery}=require("@web/core/ensure_jquery");const{rpc}=require("@web/core/network/rpc");const{Deferred}=require("@web/core/utils/concurrency");const{renderToElement}=require("@web/core/utils/render");const{useAutofocus,useService}=require('@web/core/utils/hooks');const{_t}=require("@web/core/l10n/translation");const{WebsiteDialog}=require('@website/components/dialog/dialog');const{Switch}=require('@website/components/switch/switch');const{applyTextHighlight}=require("@website/js/text_processing");const{useRef,useState,useSubEnv,Component,onWillStart,onMounted}=require("@odoo/owl");const wUtils=require('@website/js/utils')[Symbol.for("default")];const NO_OP=()=>{};const AddPageConfirmDialog=__exports.AddPageConfirmDialog=class AddPageConfirmDialog extends Component{static template="website.AddPageConfirmDialog";static props={close:Function,onAddPage:{type:Function,optional:true,},websiteId:Number,sectionsArch:{type:String,optional:true,},name:String,};static defaultProps={onAddPage:NO_OP,};static components={Switch,WebsiteDialog,};setup(){super.setup();useAutofocus();this.website=useService('website');this.http=useService('http');this.action=useService('action');this.state=useState({addMenu:true,name:this.props.name,});}
onChangeAddMenu(value){this.state.addMenu=value;}
async addPage(){const params={'add_menu':this.state.addMenu||'',csrf_token:odoo.csrf_token};if(this.props.sectionsArch){params.sections_arch=this.props.sectionsArch;}
const pageName=this.state.name.replace(/^\/*/,"")||_t("New Page");const url=`/website/add/${encodeURIComponent(pageName)}`;params['website_id']=this.props.websiteId;const data=await this.http.post(url,params);if(data.view_id){this.action.doAction({'res_model':'ir.ui.view','res_id':data.view_id,'views':[[false,'form']],'type':'ir.actions.act_window','view_mode':'form',});}else{this.website.goToWebsite({path:data.url,edition:true,websiteId:this.props.websiteId});}
this.props.onAddPage(this.state);}}
const AddPageTemplateBlank=__exports.AddPageTemplateBlank=class AddPageTemplateBlank extends Component{static template="website.AddPageTemplateBlank";static props={firstRow:{type:Boolean,optional:true,},};setup(){super.setup();this.holderRef=useRef("holder");onMounted(async()=>{this.holderRef.el.classList.add("o_ready");});}
select(){this.env.addPage();}}
const AddPageTemplatePreview=__exports.AddPageTemplatePreview=class AddPageTemplatePreview extends Component{static template="website.AddPageTemplatePreview";static props={template:Object,animationDelay:Number,firstRow:{type:Boolean,optional:true,},isCustom:{type:Boolean,optional:true,},};setup(){super.setup();this.iframeRef=useRef("iframe");this.previewRef=useRef("preview");this.holderRef=useRef("holder");onMounted(async()=>{const holderEl=this.holderRef.el;holderEl.classList.add("o_loading");if(!this.props.template.key){return;}
const previewEl=this.previewRef.el;const iframeEl=this.iframeRef.el;const isFirefox=isBrowserFirefox();if(isFirefox){await new Promise(resolve=>{iframeEl.contentDocument.body.onload=resolve;});}
for(const cssLinkEl of await this.env.getCssLinkEls()){const preloadLinkEl=document.createElement("link");preloadLinkEl.setAttribute("rel","preload");preloadLinkEl.setAttribute("href",cssLinkEl.getAttribute("href"));preloadLinkEl.setAttribute("as","style");iframeEl.contentDocument.head.appendChild(preloadLinkEl);iframeEl.contentDocument.head.appendChild(cssLinkEl.cloneNode(true));}
const styleEl=document.createElement("style");const carouselHeight=isFirefox?'450px':'fit-content';const fullHeight=getComputedStyle(document.querySelector(".o_action_manager")).height;const halfHeight=`${Math.round(parseInt(fullHeight) / 2)}px`;const css=`
                html, body {
                    /* Needed to prevent scrollbar to appear on chrome */
                    overflow: hidden;
                }
                #wrapwrap {
                    padding-right: 0px;
                    padding-left: 0px;
                    --snippet-preview-height: 340px;
                }
                section {
                    /* Avoid the zoom's missing pixel. */
                    transform: scale(101%);
                }
                section[data-snippet="s_carousel"],
                section[data-snippet="s_carousel_intro"],
                section[data-snippet="s_quotes_carousel_minimal"],
                section[data-snippet="s_quotes_carousel"] {
                    height: ${carouselHeight} !important;
                }
                section.o_half_screen_height {
                    min-height: ${halfHeight} !important;
                }
                section.o_full_screen_height {
                    min-height: ${fullHeight} !important;
                }
                section[data-snippet="s_three_columns"] .figure-img[style*="height:50vh"] {
                    /* In Travel theme. */
                    height: 170px !important;
                }
                .o_we_shape {
                    /* Avoid the zoom's missing pixel. */
                    transform: scale(101%);
                }
                .o_animate {
                    visibility: visible;
                    animation-name: none;
                }
            `;const cssText=document.createTextNode(css);styleEl.appendChild(cssText);iframeEl.contentDocument.head.appendChild(styleEl);const mainEl=document.createElement("main");const wrapwrapEl=document.createElement("div");wrapwrapEl.id="wrapwrap";wrapwrapEl.appendChild(mainEl);iframeEl.contentDocument.body.appendChild(wrapwrapEl);const templateDocument=new DOMParser().parseFromString(this.props.template.template,"text/html");const wrapEl=templateDocument.getElementById("wrap");mainEl.appendChild(wrapEl);const lazyLoadedImgEls=wrapEl.querySelectorAll("img[loading=lazy]");for(const imgEl of lazyLoadedImgEls){imgEl.setAttribute("loading","eager");}
mainEl.appendChild(wrapEl);await ensureJQuery();await wUtils.onceAllImagesLoaded($(wrapEl));for(const imgEl of lazyLoadedImgEls){imgEl.setAttribute("loading","lazy");}
if(!this.previewRef.el){return;}
await iframeEl.contentDocument.fonts.ready;holderEl.classList.remove("o_loading");const adjustHeight=()=>{if(!this.previewRef.el){return;}
const outerWidth=parseInt(window.getComputedStyle(previewEl).width);const innerHeight=wrapEl.getBoundingClientRect().height;const innerWidth=wrapEl.getBoundingClientRect().width;const ratio=outerWidth/innerWidth;iframeEl.height=Math.round(innerHeight);previewEl.style.setProperty("height",`${Math.round(innerHeight * ratio)}px`);setTimeout(adjustHeight,50);holderEl.classList.add("o_ready");};adjustHeight();if(this.props.isCustom){this.adaptCustomTemplate(wrapEl);}
setTimeout(()=>{for(const textEl of iframeEl.contentDocument?.querySelectorAll(".o_text_highlight")||[]){applyTextHighlight(textEl);}},200);});}
adaptCustomTemplate(wrapEl){for(const sectionEl of wrapEl.querySelectorAll("section:not(.o_snippet_desktop_invisible)")){const style=window.getComputedStyle(sectionEl);if(!style.height||style.display==='none'){const messageEl=renderToElement("website.AddPageTemplatePreviewDynamicMessage",{message:_t("No preview for the %s block because it is dynamically rendered.",sectionEl.dataset.name),});sectionEl.insertAdjacentElement("beforebegin",messageEl);}}}
select(){if(this.holderRef.el.classList.contains("o_loading")){return;}
const wrapEl=this.iframeRef.el.contentDocument.getElementById("wrap").cloneNode(true);for(const previewEl of wrapEl.querySelectorAll(".o_new_page_snippet_preview, .s_dialog_preview")){previewEl.remove();}
this.env.addPage(wrapEl.innerHTML,this.props.template.name&&_t("Copy of %s",this.props.template.name));}}
const AddPageTemplatePreviews=__exports.AddPageTemplatePreviews=class AddPageTemplatePreviews extends Component{static template="website.AddPageTemplatePreviews";static props={isCustom:{type:Boolean,optional:true,},templates:{type:Array,element:Object,},};static components={AddPageTemplateBlank,AddPageTemplatePreview,};setup(){super.setup();}
get columns(){const result=[[],[],[]];let currentColumnIndex=0;for(const template of this.props.templates){result[currentColumnIndex].push(template);currentColumnIndex=(currentColumnIndex+1)%result.length;}
return result;}}
const AddPageTemplates=__exports.AddPageTemplates=class AddPageTemplates extends Component{static template="website.AddPageTemplates";static props={onTemplatePageChanged:Function,};static components={AddPageTemplatePreviews,};setup(){super.setup();this.tabsRef=useRef("tabs");this.panesRef=useRef("panes");this.state=useState({pages:[{Component:AddPageTemplatePreviews,title:_t("Loading..."),isPreloading:true,props:{id:"basic",title:_t("Basic"),templates:[{isBlank:true},{},{},{},{},{}],},}],});this.pages=undefined;onWillStart(()=>{this.preparePages().then(pages=>{this.state.pages=pages;});});}
async preparePages(){await this.env.getCssLinkEls();if(this.pages){return this.pages;}
const newPageTemplates=await rpc("/website/get_new_page_templates");newPageTemplates[0].templates.unshift({isBlank:true,});const pages=[];for(const template of newPageTemplates){pages.push({Component:AddPageTemplatePreviews,title:template.title,props:template,id:`${template.id}`,});}
this.pages=pages;return pages;}
onTabClick(id){for(const page of this.state.pages){if(page.id===id){page.isAccessed=true;}}
const activeTabEl=this.tabsRef.el.querySelector(".active");const activePaneEl=this.panesRef.el.querySelector(".active");activeTabEl?.classList?.remove("active");activePaneEl?.classList?.remove("active");const tabEl=this.tabsRef.el.querySelector(`[data-id=${id}]`);const paneEl=this.panesRef.el.querySelector(`[data-id=${id}]`);tabEl.classList.add("active");paneEl.classList.add("active");this.props.onTemplatePageChanged(tabEl.dataset.id==="basic"?"":tabEl.textContent);}}
const AddPageDialog=__exports.AddPageDialog=class AddPageDialog extends Component{static template="website.AddPageDialog";static props={close:Function,onAddPage:{type:Function,optional:true,},websiteId:{type:Number,},};static defaultProps={onAddPage:NO_OP,};static components={WebsiteDialog,AddPageTemplates,AddPageTemplatePreviews,};setup(){super.setup();useAutofocus();this.primaryTitle=_t("Create");this.switchLabel=_t("Add to menu");this.website=useService('website');this.dialogs=useService("dialog");this.orm=useService('orm');this.http=useService('http');this.action=useService('action');this.cssLinkEls=undefined;this.lastTabName="";useSubEnv({addPage:(sectionsArch,name)=>this.addPage(sectionsArch,name),getCssLinkEls:()=>this.getCssLinkEls(),});}
onTemplatePageChanged(name){this.lastTabName=name;}
async addPage(sectionsArch,name){const props=this.props;this.dialogs.add(AddPageConfirmDialog,{onAddPage:()=>{props.onAddPage();props.close();},websiteId:this.props.websiteId,sectionsArch:sectionsArch,name:name||this.lastTabName,});}
getCssLinkEls(){if(!this.cssLinkEls){this.cssLinkEls=new Deferred();(async()=>{let contentDocument;const pageIframeEl=document.querySelector("iframe.o_iframe");if(pageIframeEl?.getAttribute("is-ready")==="true"){contentDocument=pageIframeEl.contentDocument;}
if(!contentDocument){const html=await this.http.get(`/website/force/${this.props.websiteId}?path=/`,"text");contentDocument=new DOMParser().parseFromString(html,"text/html");}
this.cssLinkEls.resolve(contentDocument.head.querySelectorAll("link[type='text/css']"));})();}
return this.cssLinkEls;}}
return __exports;});;

/* /website/static/src/components/dialog/dialog.js */
odoo.define('@website/components/dialog/dialog',['@web/core/dialog/dialog','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require('@web/core/dialog/dialog');const{_t}=require("@web/core/l10n/translation");const{useState,Component}=require("@odoo/owl");const NO_OP=()=>{};const WebsiteDialog=__exports.WebsiteDialog=class WebsiteDialog extends Component{static template="website.WebsiteDialog";static components={Dialog};static props={...Dialog.props,primaryTitle:{type:String,optional:true},primaryClick:{type:Function,optional:true},secondaryTitle:{type:String,optional:true},secondaryClick:{type:Function,optional:true},showSecondaryButton:{type:Boolean,optional:true},close:{type:Function,optional:true},closeOnClick:{type:Boolean,optional:true},body:{type:String,optional:true},slots:{type:Object,optional:true},showFooter:{type:Boolean,optional:true},};static defaultProps={...Dialog.defaultProps,title:_t("Confirmation"),showFooter:true,primaryTitle:_t("Ok"),secondaryTitle:_t("Cancel"),showSecondaryButton:true,size:"md",closeOnClick:true,close:NO_OP,};setup(){this.state=useState({disabled:false,});}
protectedClick(handler){return async()=>{if(this.state.disabled){return;}
this.state.disabled=true;if(handler){await handler();}
if(this.props.closeOnClick){return this.props.close();}
this.state.disabled=false;}}
get contentClasses(){const websiteDialogClass='o_website_dialog';if(this.props.contentClass){return`${websiteDialogClass} ${this.props.contentClass}`;}
return websiteDialogClass;}}
return __exports;});;

/* /website/static/src/components/dialog/edit_menu.js */
odoo.define('@website/components/dialog/edit_menu',['@web/core/utils/hooks','@web/core/utils/nested_sortable','@website/js/utils','@website/components/dialog/dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{useService,useAutofocus}=require('@web/core/utils/hooks');const{useNestedSortable}=require("@web/core/utils/nested_sortable");const wUtils=require('@website/js/utils')[Symbol.for("default")];const{WebsiteDialog}=require("@website/components/dialog/dialog");const{Component,useState,useEffect,onWillStart,useRef}=require("@odoo/owl");const useControlledInput=(initialValue,validate)=>{const input=useState({value:initialValue,hasError:false,});const isValid=()=>{if(validate(input.value)){return true;}
input.hasError=true;return false;};useEffect(()=>{input.hasError=false;},()=>[input.value]);return{input,isValid,};};const MenuDialog=__exports.MenuDialog=class MenuDialog extends Component{static template="website.MenuDialog";static components={WebsiteDialog};static props={name:{type:String,optional:true},url:{type:String,optional:true},isMegaMenu:{type:Boolean,optional:true},save:Function,close:Function,};setup(){this.website=useService('website');useAutofocus();this.name=useControlledInput(this.props.name,value=>!!value);this.url=useControlledInput(this.props.url,value=>!!value);this.urlInputRef=useRef('url-input');useEffect((input)=>{if(!input){return;}
const options={body:this.website.pageDocument.body,position:"bottom-fit",classes:{'ui-autocomplete':'o_edit_menu_autocomplete'},urlChosen:()=>{this.url.input.value=input.value;},};const unmountAutocompleteWithPages=wUtils.autocompleteWithPages(input,options);return()=>unmountAutocompleteWithPages();},()=>[this.urlInputRef.el]);}
onClickOk(){if(this.name.isValid()){if(this.props.isMegaMenu||this.url.isValid()){this.props.save(this.name.input.value,this.url.input.value);this.props.close();}}}}
class MenuRow extends Component{static template="website.MenuRow";static props={menu:Object,edit:Function,delete:Function,};static components={MenuRow,};edit(){this.props.edit(this.props.menu.fields['id']);}
delete(){this.props.delete(this.props.menu.fields['id']);}}
const EditMenuDialog=__exports.EditMenuDialog=class EditMenuDialog extends Component{static template="website.EditMenuDialog";static components={MenuRow,WebsiteDialog,};static props=["rootID?","close","save?"];setup(){this.orm=useService('orm');this.website=useService('website');this.dialogs=useService('dialog');this.menuEditor=useRef('menu-editor');this.state=useState({rootMenu:{}});onWillStart(async()=>{const menu=await this.orm.call('website.menu','get_tree',[this.website.currentWebsite.id,this.props.rootID],{context:{lang:this.website.currentWebsite.metadata.lang}});this.state.rootMenu=menu;this.map=new Map();this.populate(this.map,this.state.rootMenu);this.toDelete=[];});useNestedSortable({ref:this.menuEditor,handle:"div",nest:true,maxLevels:2,onDrop:this._moveMenu.bind(this),isAllowed:this._isAllowedMove.bind(this),useElementSize:true,onMove:({element,placeholder,parent})=>{element.style.width=getComputedStyle(placeholder).width;element.style.marginLeft=parent&&(element.parentElement===this.menuEditor.el)?"2rem":"";},});}
populate(map,menu){map.set(menu.fields['id'],menu);for(const submenu of menu.children){this.populate(map,submenu);}}
_isAllowedMove(current,elementSelector){const currentIsMegaMenu=current.element.dataset.isMegaMenu==="true";if(!currentIsMegaMenu){return current.placeHolder.parentNode.closest(`${elementSelector}[data-is-mega-menu="true"]`)===null;}
const isDropOnRoot=current.placeHolder.parentNode.closest(elementSelector)===null;return currentIsMegaMenu&&isDropOnRoot;}
_getMenuIdForElement(element){const menuIdStr=element.dataset.menuId;const menuId=parseInt(menuIdStr);return isNaN(menuId)?menuIdStr:menuId;}
_moveMenu({element,parent,previous}){const menuId=this._getMenuIdForElement(element);const menu=this.map.get(menuId);const parentId=menu.fields['parent_id']||this.state.rootMenu.fields['id'];let parentMenu=this.map.get(parentId);parentMenu.children=parentMenu.children.filter((m)=>m.fields['id']!==menuId);const menuParentId=parent?this._getMenuIdForElement(parent.closest("li")):this.state.rootMenu.fields['id'];parentMenu=this.map.get(menuParentId);menu.fields['parent_id']=parentMenu.fields['id'];if(previous){const previousMenu=this.map.get(this._getMenuIdForElement(previous));const index=parentMenu.children.findIndex((menu)=>menu===previousMenu);parentMenu.children.splice(index+1,0,menu);}else{parentMenu.children.unshift(menu);}}
addMenu(isMegaMenu){this.dialogs.add(MenuDialog,{isMegaMenu,save:(name,url,isNewWindow)=>{const newMenu={fields:{id:`menu_${(new Date).toISOString()}`,name,url:isMegaMenu?'#':url,new_window:isNewWindow,'is_mega_menu':isMegaMenu,sequence:0,'parent_id':false,},'children':[],};this.state.rootMenu.children.push(newMenu);this.map.set(newMenu.fields["id"],this.state.rootMenu.children.at(-1));},});}
editMenu(id){const menuToEdit=this.map.get(id);this.dialogs.add(MenuDialog,{name:menuToEdit.fields['name'],url:menuToEdit.fields['url'],isMegaMenu:menuToEdit.fields['is_mega_menu'],save:(name,url)=>{menuToEdit.fields['name']=name;menuToEdit.fields['url']=url;},});}
deleteMenu(id){const menuToDelete=this.map.get(id);for(const child of menuToDelete.children){this.deleteMenu(child.fields.id);}
const parentId=menuToDelete.fields['parent_id']||this.state.rootMenu.fields['id'];const parent=this.map.get(parentId);parent.children=parent.children.filter(menu=>menu.fields['id']!==id);this.map.delete(id);if(parseInt(id)){this.toDelete.push(id);}}
async onClickSave(){const data=[];this.map.forEach((menu,id)=>{if(this.state.rootMenu.fields['id']!==id){const menuFields=menu.fields;const parentId=menuFields.parent_id||this.state.rootMenu.fields['id'];const parentMenu=this.map.get(parentId);menuFields['sequence']=parentMenu.children.findIndex(m=>m.fields['id']===id);menuFields['parent_id']=parentId;data.push(menuFields);}});await this.orm.call('website.menu','save',[this.website.currentWebsite.id,{'data':data,'to_delete':this.toDelete,}],{context:{lang:this.website.currentWebsite.metadata.lang}});if(this.props.save){this.props.save();}else{this.website.goToWebsite();}}}
return __exports;});;

/* /website/static/src/components/dialog/page_properties.js */
odoo.define('@website/components/dialog/page_properties',['@web/core/checkbox/checkbox','@web/core/l10n/translation','@web/core/utils/hooks','@web/core/utils/strings','@website/components/dialog/dialog','@web/views/fields/standard_field_props','@web/views/view_dialogs/form_view_dialog','@web/views/form/form_view','@web/core/utils/render','@odoo/owl','@web/views/form/form_controller','@web/core/registry'],function(require){'use strict';let __exports={};const{CheckBox}=require('@web/core/checkbox/checkbox');const{_t}=require("@web/core/l10n/translation");const{useService,useAutofocus}=require("@web/core/utils/hooks");const{sprintf}=require("@web/core/utils/strings");const{WebsiteDialog}=require("@website/components/dialog/dialog");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");const{formView}=require('@web/views/form/form_view');const{renderToFragment}=require("@web/core/utils/render");const{Component,onWillDestroy,useEffect,useRef,useState,xml}=require("@odoo/owl");const{FormController}=require('@web/views/form/form_controller');const{registry}=require("@web/core/registry");const PageDependencies=__exports.PageDependencies=class PageDependencies extends Component{static template="website.PageDependencies";static popoverTemplate=xml`
        <div class="popover o_page_dependencies" role="tooltip">
            <div class="arrow"/>
            <h3 class="popover-header"/>
            <div class="popover-body"/>
        </div>
    `;static props={resIds:Array,resModel:String,mode:String,};setup(){super.setup();this.orm=useService('orm');this.action=useRef('action');this.sprintf=sprintf;useEffect(()=>{this.fetchDependencies();},()=>[]);this.state=useState({dependencies:{},});onWillDestroy(async()=>{await this.destroyDependenciesPopover();});}
async getResIds(){return this.props.resIds;}
async fetchDependencies(){this.state.dependencies=await this.orm.call('website','search_url_dependencies',[this.props.resModel,await this.getResIds()],);}
showDependencies(){const popover=window.Popover.getOrCreateInstance(this.action.el,{title:_t("Dependencies"),boundary:'viewport',placement:'right',trigger:'focus',content:()=>{return renderToFragment("website.PageDependencies.Tooltip",{dependencies:this.state.dependencies,});},});popover.toggle();}
async destroyDependenciesPopover(){const actionEl=this.action.el;const popover=window.Popover.getInstance(actionEl);if(popover){if(!popover.tip.classList.contains("show")){await new Promise((resolve)=>{const handler=()=>{actionEl.removeEventListener("hidden.bs.popover",handler);resolve();};actionEl.addEventListener("hidden.bs.popover",handler);});}
popover.dispose();}}}
const FormPageDependencies=__exports.FormPageDependencies=class FormPageDependencies extends PageDependencies{static props={...standardFieldProps,...PageDependencies.props,resIds:{type:Array,optional:true},};async getResIds(){const records=await this.orm.read(this.props.record.resModel,[this.props.record.resId],["target_model_id"],);return records.map((record)=>record.target_model_id[0]);}}
const formPageDependenciesWidget=__exports.formPageDependenciesWidget={component:FormPageDependencies,extractProps:({attrs})=>{const{mode,name,resModel,resIds}=attrs;return{mode,name:name||"",resModel,resIds,};},};registry.category("view_widgets").add("form_page_dependencies",formPageDependenciesWidget);const DeletePageDialog=__exports.DeletePageDialog=class DeletePageDialog extends Component{static template="website.DeletePageDialog";static components={PageDependencies,CheckBox,WebsiteDialog,};static props={resIds:Array,resModel:String,onDelete:{type:Function,optional:true},close:Function,hasNewPageTemplate:{type:Boolean,optional:true},};setup(){this.website=useService('website');this.state=useState({confirm:false,});}
onConfirmCheckboxChange(checked){this.state.confirm=checked;}
onClickDelete(){this.props.close();this.props.onDelete();}}
const DuplicatePageDialog=__exports.DuplicatePageDialog=class DuplicatePageDialog extends Component{static components={WebsiteDialog};static template="website.DuplicatePageDialog";static props={onDuplicate:Function,close:Function,pageIds:{type:Array,element:Number},};setup(){this.orm=useService('orm');this.website=useService('website');useAutofocus();this.state=useState({name:'',});}
async duplicate(){const duplicates=[];if(this.state.name){for(let count=0;count<this.props.pageIds.length;count++){const name=this.state.name+(count?` ${count + 1}`:"");duplicates.push(await this.orm.call('website.page','clone_page',[this.props.pageIds[count],name]));}}
this.props.onDuplicate(duplicates);}}
const PagePropertiesFormController=__exports.PagePropertiesFormController=class PagePropertiesFormController extends FormController{static props={...FormController.props,clonePage:{type:Function,optional:true},deletePage:{type:Function,optional:true},};}
registry.category("views").add("page_properties_dialog_form",{...formView,Controller:PagePropertiesFormController,});const PagePropertiesDialog=__exports.PagePropertiesDialog=class PagePropertiesDialog extends FormViewDialog{static props={...FormViewDialog.props,onClose:{type:Function,optional:true},resModel:{type:String,optional:true},};static defaultProps={...FormViewDialog.defaultProps,title:_t("Page Properties"),size:"md",onClose:()=>{},};setup(){super.setup();this.dialog=useService('dialog');this.orm=useService('orm');this.website=useService('website');this.viewProps={...this.viewProps,resId:this.resId,resModel:this.resModel,context:Object.assign({form_view_ref:this.isPage?"website.website_page_properties_view_form":"website.website_page_properties_base_view_form",},this.viewProps.context,),...(this.isPage?{buttonTemplate:"website.PagePropertiesDialogButtons",clonePage:this.clonePage.bind(this),deletePage:this.deletePage.bind(this),}:{}),};}
get resId(){return this.props.resId;}
get resModel(){if(this.props.resModel){return this.props.resModel;}
return this.isPage?"website.page.properties":"website.page.properties.base";}
get targetId(){return this.website.currentWebsite?.metadata.mainObject.id;}
get targetModel(){return this.website.currentWebsite?.metadata.mainObject.model;}
get isPage(){return this.targetModel==="website.page";}
clonePage(){this.dialog.add(DuplicatePageDialog,{pageIds:[this.targetId],onDuplicate:(duplicates)=>{this.props.close();this.props.onClose();this.website.goToWebsite({path:duplicates[0],edition:true});},});}
async deletePage(){const pageIds=[this.targetId];const newPageTemplateFields=await this.orm.read("website.page",pageIds,["is_new_page_template"]);this.dialog.add(DeletePageDialog,{resIds:pageIds,resModel:'website.page',onDelete:async()=>{await this.orm.unlink("website.page",pageIds);this.website.goToWebsite({path:'/'});this.props.close();this.props.onClose();},hasNewPageTemplate:newPageTemplateFields[0].is_new_page_template,});}}
return __exports;});;

/* /website/static/src/components/dialog/seo.js */
odoo.define('@website/components/dialog/seo',['@web/core/l10n/translation','@web/core/l10n/utils','@web/core/network/rpc','@web/core/utils/strings','@web/core/utils/hooks','@web_editor/components/media_dialog/media_dialog','@website/components/dialog/dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{pyToJsLocale,jsToPyLocale}=require("@web/core/l10n/utils");const{rpc}=require("@web/core/network/rpc");const{escapeRegExp}=require("@web/core/utils/strings");const{useService,useAutofocus}=require('@web/core/utils/hooks');const{MediaDialog}=require('@web_editor/components/media_dialog/media_dialog');const{WebsiteDialog}=require("@website/components/dialog/dialog");const{Component,useState,reactive,onMounted,onWillStart,useEffect}=require("@odoo/owl");const WORD_SEPARATORS_REGEX='([\\u2000-\\u206F\\u2E00-\\u2E7F\'!"#\\$%&\\(\\)\\*\\+,\\-\\.\\/:;<=>\\?¿¡@\\[\\]\\^_`\\{\\|\\}~\\s]+|^|$)';const seoContext=reactive({description:'',keywords:[],title:'',seoName:'',metaImage:'',defaultTitle:'',});class MetaImage extends Component{static template="website.MetaImage";static props=["active","src","custom","selectImage"];}
class ImageSelector extends Component{static template="website.ImageSelector";static components={MetaImage,};static props={previewDescription:String,defaultTitle:String,hasSocialDefaultImage:Boolean,pageImages:Array,url:String,};setup(){this.website=useService('website');this.dialogs=useService('dialog');this.seoContext=useState(seoContext);const firstImageId=this.props.hasSocialDefaultImage?'social_default_image':'logo';const firstImageSrc=`/web/image/website/${encodeURIComponent(this.website.currentWebsite.id)}/${firstImageId}`;const firstImage={src:firstImageSrc,active:this.areSameImages(firstImageSrc,this.seoContext.metaImage),custom:false,};this.state=useState({images:[firstImage,...this.props.pageImages.map((src)=>{return{src,active:this.areSameImages(src,this.seoContext.metaImage),custom:false,};}),],});if(this.seoContext.metaImage&&!this.state.images.map(({src})=>this.getImagePathname(src)).includes(this.getImagePathname(this.seoContext.metaImage))){this.state.images.push({src:this.seoContext.metaImage,active:true,custom:true,});}
if(!this.activeMetaImage){this.selectImage(this.state.images[0].src);}}
get title(){return this.seoContext.title||this.props.defaultTitle;}
get description(){return this.seoContext.description||this.props.previewDescription;}
get activeMetaImage(){const activeImage=this.state.images.find(({active})=>active);return activeImage&&activeImage.src;}
getImagePathname(src){return new URL(src,this.website.pageDocument.location.origin).pathname;}
areSameImages(src1,src2){return this.getImagePathname(src1)===this.getImagePathname(src2);}
selectImage(src){this.state.images=this.state.images.map(img=>{img.active=img.src===src;return img;});this.seoContext.metaImage=src;}
openMediaDialog(){this.dialogs.add(MediaDialog,{resModel:'ir.ui.view',useMediaLibrary:true,save:image=>{let existingImage;this.state.images=this.state.images.map(img=>{img.active=false;if(img.src===image.src){existingImage=img;img.active=true;}
return img;});if(!existingImage){this.state.images.push({src:image.src,active:true,custom:true,});}
this.seoContext.metaImage=image.src;},});}}
class Keyword extends Component{static template="website.Keyword";static props={language:String,keyword:String,addKeyword:Function,removeKeyword:Function,};setup(){this.website=useService('website');this.seoContext=useState(seoContext);this.state=useState({suggestions:[],});onMounted(async()=>{const suggestions=await rpc('/website/seo_suggest',{lang:jsToPyLocale(this.props.language),keywords:this.props.keyword,});const regex=new RegExp(WORD_SEPARATORS_REGEX+escapeRegExp(this.props.keyword)+WORD_SEPARATORS_REGEX,"gi");this.state.suggestions=[...new Set(JSON.parse(suggestions).map(word=>word.replace(regex,'').trim()))];});}
isKeywordIn(string){return new RegExp(WORD_SEPARATORS_REGEX+escapeRegExp(this.props.keyword)+WORD_SEPARATORS_REGEX,"gi").test(string);}
getHeaders(tag){return Array.from(this.website.pageDocument.documentElement.querySelectorAll(`#wrap ${tag}`)).map(header=>header.textContent);}
getBodyText(){return this.website.pageDocument.body.textContent;}
get usedInH1(){return this.isKeywordIn(this.getHeaders('h1'));}
get usedInH2(){return this.isKeywordIn(this.getHeaders('h2'));}
get usedInTitle(){return this.isKeywordIn(this.seoContext.title||this.seoContext.defaultTitle);}
get usedInDescription(){return this.isKeywordIn(this.seoContext.description);}
get usedInContent(){return this.isKeywordIn(this.getBodyText());}}
class MetaKeywords extends Component{static template="website.MetaKeywords";static components={Keyword,};static props={};setup(){this.website=useService('website');this.seoContext=useState(seoContext);this.state=useState({language:'',keyword:'',});this.maxKeywords=10;onWillStart(async()=>{this.languages=await rpc('/website/get_languages');this.state.language=this.getLanguage();});}
onKeyup(ev){if(ev.key==="Enter"){this.addKeyword(this.state.keyword);}}
getLanguage(){return(pyToJsLocale(this.website.pageDocument.documentElement.getAttribute("lang"))||"en-US");}
get isFull(){return this.seoContext.keywords.length>=this.maxKeywords;}
addKeyword(keyword){keyword=keyword.replaceAll(/,\s*/gi," ").trim();if(keyword&&!this.isFull&&!this.seoContext.keywords.includes(keyword)){this.seoContext.keywords.push(keyword);this.state.keyword='';}}
removeKeyword(keyword){this.seoContext.keywords=this.seoContext.keywords.filter(kw=>kw!==keyword);}}
class SEOPreview extends Component{static template="website.SEOPreview";static props={isIndexed:Boolean,title:String,description:String,url:String,};get description(){if(this.props.description.length>160){return this.props.description.substring(0,159)+'…';}
return this.props.description;}}
class TitleDescription extends Component{static template="website.TitleDescription";static props={canEditDescription:Boolean,canEditUrl:Boolean,canEditTitle:Boolean,seoNameHelp:String,seoNameDefault:{optional:true,String},isIndexed:Boolean,defaultTitle:String,previewDescription:String,url:String,};static components={SEOPreview,};setup(){this.seoContext=useState(seoContext);useAutofocus();this.previousSeoName=this.seoContext.seoName;this.maxRecommendedDescriptionSize=300;this.minRecommendedDescriptionSize=50;useEffect(()=>{document.title=this.title;},()=>[this.seoContext.title]);useEffect(()=>{const initialTitle=document.title;return()=>document.title=initialTitle;},()=>[]);}
get seoNameUrl(){return this.previousSeoName||this.props.seoNameDefault;}
get seoNamePre(){return this.pathname.split(this.seoNameUrl)[0];}
get seoNamePost(){return this.pathname.split(this.seoNameUrl).slice(-1)[0];}
get pathname(){return new URL(this.props.url).pathname;}
get url(){if(this.seoContext.seoName){return this.props.url.replace(this.seoNameUrl,this.seoContext.seoName);}
return this.props.url.replace(this.seoNameUrl,this.props.seoNameDefault);}
get title(){return this.seoContext.title||this.props.defaultTitle;}
get description(){return this.seoContext.description||this.props.previewDescription;}
get descriptionWarning(){if(!this.seoContext.description){return false;}
if(this.seoContext.description.length<this.minRecommendedDescriptionSize){return _t("Your description looks too short.");}else if(this.seoContext.description.length>this.maxRecommendedDescriptionSize){return _t("Your description looks too long.");}
return false;}
_updateInputValue(ev){ev.target.value=ev.target.value.trim().normalize('NFKD').toLowerCase().replace(/\s+/g,'-').replace(/[^\w-]+/g,'').replace(/--+/g,'-');this.seoContext.seoName=ev.target.value;}}
const OptimizeSEODialog=__exports.OptimizeSEODialog=class OptimizeSEODialog extends Component{static template="website.OptimizeSEODialog";static components={WebsiteDialog,TitleDescription,ImageSelector,MetaKeywords,};static props={close:Function,};setup(){this.website=useService('website');this.dialogs=useService('dialog');this.orm=useService('orm');this.title=_t("Optimize SEO");this.saveButton=_t("Save");this.size='lg';this.contentClass="oe_seo_configuration";onWillStart(async()=>{const{metadata:{mainObject,seoObject,path}}=this.website.currentWebsite;this.object=seoObject||mainObject;this.data=await rpc('/website/get_seo_data',{'res_id':this.object.id,'res_model':this.object.model,});this.canEditSeo=this.data.can_edit_seo;this.canEditDescription=this.canEditSeo&&'website_meta_description'in this.data;this.canEditTitle=this.canEditSeo&&'website_meta_title'in this.data;this.canEditUrl=this.canEditSeo&&'seo_name'in this.data;seoContext.title=this.canEditTitle&&this.data.website_meta_title;this.isIndexed='website_indexed'in this.data?this.data.website_indexed:true;this.seoNameHelp=_t("This value will be escaped to be compliant with all major browsers and used in url. Keep it empty to use the default name of the record.");this.previousSeoName=this.canEditUrl&&this.data.seo_name;seoContext.seoName=this.previousSeoName;this.seoNameDefault=this.canEditUrl&&this.data.seo_name_default;seoContext.description=this.getMeta({name:'description'});this.previewDescription=_t("The description will be generated by search engines based on page content unless you specify one.");this.defaultTitle=this.getMeta({name:'default_title'});seoContext.defaultTitle=this.defaultTitle;this.url=path;seoContext.metaImage=this.data.website_meta_og_img||this.getMeta({property:'og:image'});this.pageImages=this.getImages();this.socialPreviewDescription=_t("The description will be generated by social media based on page content unless you specify one.");this.hasSocialDefaultImage=this.data.has_social_default_image;this.canEditKeywords='website_meta_keywords'in this.data;seoContext.keywords=this.getMeta({name:'keywords'});});}
get pageDocumentElement(){return this.website.pageDocument.documentElement;}
getImages(){const imageEls=this.pageDocumentElement.querySelectorAll('#wrap img');return[...new Set(Array.from(imageEls).filter(img=>img.naturalHeight>200&&img.naturalWidth>200).map(({src})=>(src)))];}
getMeta({name,property}){let query='';if(name){query=`meta[name="${name}"]`;}
if(property){query=`meta[property="${property}"]`;}
const el=this.pageDocumentElement.querySelector(query);if(name==='keywords'){const parsed=el&&el.content.split(',').map(kw=>kw.trim());return parsed&&parsed[0]?[...new Set(parsed)]:[];}
return el&&el.content;}
async save(){const data={};if(this.canEditTitle){data.website_meta_title=seoContext.title;}
if(this.canEditDescription){data.website_meta_description=seoContext.description;}
if(this.canEditKeywords){data.website_meta_keywords=seoContext.keywords.join(',');}
if(this.canEditUrl){if(seoContext.seoName!==this.previousSeoName){data.seo_name=seoContext.seoName;}}
data.website_meta_og_img=seoContext.metaImage;await this.orm.write(this.object.model,[this.object.id],data,{context:{lang:this.website.currentWebsite.metadata.lang,'website_id':this.website.currentWebsite.id,},});this.website.goToWebsite({path:this.url.replace(this.previousSeoName||this.seoNameDefault,seoContext.seoName)});}}
return __exports;});;

/* /website/static/src/components/editor/editor.js */
odoo.define('@website/components/editor/editor',['@web/core/l10n/translation','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require('@web/core/utils/hooks');const{markup,Component,useState,useEffect,onWillStart,onMounted,onWillUnmount,}=require("@odoo/owl");const WebsiteEditorComponent=__exports.WebsiteEditorComponent=class WebsiteEditorComponent extends Component{static template="website.WebsiteEditorComponent";static props=["*"];setup(){this.websiteService=useService('website');this.notificationService=useService('notification');this.websiteContext=useState(this.websiteService.context);this.state=useState({reloading:false,showWysiwyg:false,});this.wysiwygOptions={};onWillStart(async()=>{await this.websiteService.loadWysiwyg();const adapterModule=await odoo.loader.modules.get('@website/components/wysiwyg_adapter/wysiwyg_adapter');this.WysiwygAdapterComponent=adapterModule.WysiwygAdapterComponent;});useEffect(isPublicRootReady=>{if(isPublicRootReady){this.publicRootReady();}},()=>[this.websiteContext.isPublicRootReady]);onMounted(()=>{this.websiteService.blockPreview(false);if(this.websiteContext.isPublicRootReady){this.publicRootReady();}});onWillUnmount(()=>{if(this.onWillUnmount){this.onWillUnmount();}});}
publicRootReady(){if(this.websiteService.currentWebsite.metadata.translatable){this.websiteContext.edition=false;this.websiteService.unblockPreview();}else{this.state.showWysiwyg=true;}}
wysiwygReady(){this.websiteContext.snippetsLoaded=true;if(this.state.reloading){document.body.classList.remove('editor_has_dummy_snippets');this.state.reloading=false;}
this.websiteService.unblockPreview();document.body.classList.add("o_website_navbar_transition_hide");setTimeout(()=>document.body.classList.add("o_website_navbar_hide"),400);}
willReload(widgetEl){this.websiteService.blockPreview();if(widgetEl){this.loadingDummy=markup(widgetEl.innerHTML);}
this.state.reloading=true;document.body.classList.add('editor_has_dummy_snippets');}
async reload({snippetOptionSelector,url}={}){this.notificationService.add(_t("Your modifications were saved to apply this option."),{title:_t("Content saved."),type:'success'});this.state.showWysiwyg=false;await this.props.reloadIframe(url);this.reloadSelector=snippetOptionSelector;}
async quit({reloadIframe=true,onLeave}={}){this.onWillUnmount=onLeave;if(reloadIframe){this.websiteService.blockPreview();await this.props.reloadIframe();this.websiteService.unblockPreview();}
this.websiteContext.snippetsLoaded=false;document.body.classList.remove("o_website_navbar_hide");setTimeout(()=>document.body.classList.remove("o_website_navbar_transition_hide"));setTimeout(this.destroyAfterTransition.bind(this),400);}
destroyAfterTransition(){this.state.showWysiwyg=false;this.websiteContext.edition=false;}}
return __exports;});;

/* /website/static/src/components/navbar/navbar.js */
odoo.define('@website/components/navbar/navbar',['@web/webclient/navbar/navbar','@web/core/utils/hooks','@web/core/registry','@web/core/utils/patch','@web/webclient/user_menu/user_menu','@odoo/owl'],function(require){'use strict';let __exports={};const{NavBar}=require('@web/webclient/navbar/navbar');const{useService,useBus}=require('@web/core/utils/hooks');const{registry}=require("@web/core/registry");const{patch}=require("@web/core/utils/patch");const{UserMenu}=require("@web/webclient/user_menu/user_menu");const{useEffect}=require("@odoo/owl");const websiteSystrayRegistry=registry.category('website_systray');websiteSystrayRegistry.add("UserMenu",{Component:UserMenu},{sequence:14});patch(NavBar.prototype,{setup(){super.setup();this.websiteService=useService('website');this.websiteCustomMenus=useService('website_custom_menus');useBus(websiteSystrayRegistry,'EDIT-WEBSITE',()=>this.render(true));if(this.env.debug&&!websiteSystrayRegistry.contains('web.debug_mode_menu')){websiteSystrayRegistry.add('web.debug_mode_menu',registry.category('systray').get('web.debug_mode_menu'),{sequence:100});}
let adaptCounter=0;const renderAndAdapt=()=>{this.render(true);adaptCounter++;};useEffect((adaptCounter)=>{if(adaptCounter>0){this.adapt();}},()=>[adaptCounter]);useBus(websiteSystrayRegistry,'CONTENT-UPDATED',renderAndAdapt);},get shouldDisplayWebsiteSystray(){return this.websiteService.currentWebsite&&this.websiteService.isRestrictedEditor;},set shouldDisplayWebsiteSystray(_){},get systrayItems(){if(this.websiteService.currentWebsite){const websiteItems=websiteSystrayRegistry.getEntries().map(([key,value],index)=>({key,...value,index})).filter((item)=>('isDisplayed'in item?item.isDisplayed(this.env):true)).reverse();if(!websiteItems.every((item)=>['burger_menu','web.debug_mode_menu'].includes(item.key))){return websiteItems;}}
return super.systrayItems;},get currentAppSections(){const currentAppSections=super.currentAppSections;if(this.currentApp&&this.currentApp.xmlid==='website.menu_website_configuration'){return this.websiteCustomMenus.addCustomMenus(currentAppSections).filter(section=>section.childrenTree.length);}
return currentAppSections;},async onNavBarDropdownItemSelection(menu){const websiteMenu=this.websiteCustomMenus.get(menu.xmlid);if(websiteMenu){return this.websiteCustomMenus.open(menu);}
return super.onNavBarDropdownItemSelection(menu);},});return __exports;});;

/* /website/static/src/components/burger_menu/burger_menu.js */
odoo.define('@website/components/burger_menu/burger_menu',['@web/webclient/burger_menu/burger_menu','@web/core/utils/hooks','@web/core/registry','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{BurgerMenu}=require('@web/webclient/burger_menu/burger_menu');const{useService}=require('@web/core/utils/hooks');const{registry}=require("@web/core/registry");const{patch}=require("@web/core/utils/patch");const websiteSystrayRegistry=registry.category('website_systray');patch(BurgerMenu.prototype,{setup(){super.setup();this.websiteCustomMenus=useService('website_custom_menus');if(!websiteSystrayRegistry.contains('burger_menu')){websiteSystrayRegistry.add('burger_menu',registry.category('systray').get('burger_menu'),{sequence:0});}},get currentAppSections(){const currentAppSections=super.currentAppSections;if(this.currentApp&&this.currentApp.xmlid==='website.menu_website_configuration'){return this.websiteCustomMenus.addCustomMenus(currentAppSections).filter(section=>section.childrenTree.length);}
return currentAppSections;},set currentAppSections(_){},async _onMenuClicked(menu){const websiteMenu=this.websiteCustomMenus.get(menu.xmlid);if(websiteMenu){await this.websiteCustomMenus.open(menu);this._closeBurger();}else{super._onMenuClicked(menu);}},});return __exports;});;

/* /website/static/src/components/switch/switch.js */
odoo.define('@website/components/switch/switch',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,xml}=require("@odoo/owl");const NO_OP=()=>{};const Switch=__exports.Switch=class Switch extends Component{static props={value:Boolean,extraClasses:String,disabled:{type:Boolean,optional:true},label:{type:String,optional:true},onChange:{Function,optional:true},};static defaultProps={onChange:NO_OP,};static template=xml`
    <label t-att-class="'o_switch' + extraClasses">
        <input type="checkbox" t-att-checked="props.value" t-att-disabled="props.disabled" t-on-change="(ev) => props.onChange(ev.target.checked)"/>
        <span/>
        <span t-if="props.label" t-esc="props.label" class="ms-2"/>
    </label>
    `;setup(){this.extraClasses=this.props.extraClasses?` ${this.props.extraClasses}`:'';}}
return __exports;});;

/* /website/static/src/components/wysiwyg_adapter/page_options.js */
odoo.define('@website/components/wysiwyg_adapter/page_options',[],function(require){'use strict';let __exports={};const pageOptionsCallbacks=__exports.pageOptionsCallbacks={header_overlay:function(value){this.document.getElementById('wrapwrap').classList.toggle('o_header_overlay',value);},header_visible:function(value){const headerEl=this.document.querySelector('#wrapwrap > header');headerEl.classList.toggle('d-none',!value);headerEl.classList.toggle('o_snippet_invisible',!value);},footer_visible:function(value){const footerEl=this.document.querySelector('#wrapwrap > footer');footerEl.classList.toggle('d-none',!value);footerEl.classList.toggle('o_snippet_invisible',!value);},};const PageOption=__exports.PageOption=class PageOption{constructor(el,document,name,isDirty=false){this.el=el;this.isDirty=isDirty;this.document=document;this.name=name;if(pageOptionsCallbacks[name]){this.callback=pageOptionsCallbacks[name].bind(this);}}
get value(){if(this.el.value.toLowerCase()==='true'){return true;}else if(this.el.value.toLowerCase()==='false'){return false;}
return this.el.value;}
set value(value){if(this.callback){this.callback(value);}
this.el.value=value;this.isDirty=true;}}
return __exports;});;

/* /website/static/src/components/translator/translator.js */
odoo.define('@website/components/translator/translator',['@web/core/l10n/translation','@web/core/utils/hooks','@website/components/editor/editor','@website/components/dialog/dialog','@web/core/browser/browser','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require('@web/core/utils/hooks');const{WebsiteEditorComponent}=require("@website/components/editor/editor");const{WebsiteDialog}=require("@website/components/dialog/dialog");const{browser}=require("@web/core/browser/browser");const{useEffect,useRef,Component,xml}=require("@odoo/owl");const localStorageNoDialogKey='website_translator_nodialog';const AttributeTranslateDialog=__exports.AttributeTranslateDialog=class AttributeTranslateDialog extends Component{static components={WebsiteDialog};static template="website.AttributeTranslateDialog";static props=["node","close"];setup(){this.title=_t("Translate Attribute");this.formEl=useRef('form-container');useEffect(()=>{this.translation=$(this.props.node).data('translation');const $group=$('<div/>',{class:'mb-3'}).appendTo(this.formEl.el);for(const[attr,node]of Object.entries(this.translation)){const $node=$(node);const $label=$('<label class="col-form-label"></label>').text(attr);const $input=$('<input class="form-control"/>').val($node.html());$input.on('change keyup',function(){const value=$input.val();$node.text(value).trigger('change',node);const $originalNode=$node.data('$node');const nodeAttribute=$node.data('attribute');if(nodeAttribute){$originalNode.attr(nodeAttribute,value);if(nodeAttribute==='value'){$originalNode[0].value=value;}
$originalNode.trigger('translate');}else{$originalNode.val(value).trigger('translate');}
$node.trigger('change');$originalNode[0].classList.add('oe_translated');});$group.append($label).append($input);}},()=>[this.props.node]);}}
const SelectTranslateDialog=__exports.SelectTranslateDialog=class SelectTranslateDialog extends Component{static components={WebsiteDialog};static template=xml`
    <WebsiteDialog close="props.close"
        title="title"
        showSecondaryButton="false">
        <input
            t-ref="input"
            type="text" class="form-control my-3"
            t-att-value="optionEl.textContent or ''"
            t-on-keyup="onInputKeyup"/>
    </WebsiteDialog>
    `;static props={node:String,close:Function,};setup(){this.title=_t("Translate Selection Option");this.inputEl=useRef('input');this.optionEl=this.props.node;}
onInputKeyup(){const value=this.inputEl.el.value;this.optionEl.textContent=value;this.optionEl.classList.toggle('oe_translated',value!==this.optionEl.dataset.initialTranslationValue);}}
const TranslatorInfoDialog=__exports.TranslatorInfoDialog=class TranslatorInfoDialog extends Component{static components={WebsiteDialog};static template="website.TranslatorInfoDialog";static props={close:Function,};setup(){this.strongOkButton=_t("Ok, never show me this again");this.okButton=_t("Ok");}
onStrongOkClick(){browser.localStorage.setItem(localStorageNoDialogKey,true);}}
const savableSelector='[data-oe-translation-source-sha], '+'[data-oe-model][data-oe-id][data-oe-field], '+'[placeholder*="data-oe-translation-source-sha="], '+'[title*="data-oe-translation-source-sha="], '+'[value*="data-oe-translation-source-sha="], '+'textarea:contains(data-oe-translation-source-sha), '+'[alt*="data-oe-translation-source-sha="]';const WebsiteTranslator=__exports.WebsiteTranslator=class WebsiteTranslator extends WebsiteEditorComponent{setup(){super.setup();this.dialogService=useService('dialog');this.wysiwygOptions.enableTranslation=true;this.wysiwygOptions.devicePreview=false;this.editableElements=(...args)=>this._editableElements(...args);this.beforeEditorActive=(...args)=>this._beforeEditorActive(...args);}
publicRootReady(){if(!this.websiteService.currentWebsite.metadata.translatable){this.websiteContext.translation=false;}else{this.state.showWysiwyg=true;this.deleteQueryParam("edit_translations",this.websiteService.contentWindow,true);}}
destroyAfterTransition(){this.state.showWysiwyg=false;this.websiteContext.translation=false;}
get savableSelector(){return savableSelector;}
getEditableArea(){return this.$wysiwygEditable.find(':o_editable').add(this.$editables);}
_editableElements(){return $(this.websiteService.pageDocument).find(savableSelector).not('[data-oe-readonly]');}
getTranslationObject(nodeEl){const{oeModel,oeId,oeField,oeTranslationInitialMd5}=nodeEl.dataset;const id=[oeModel,oeId,oeField,oeTranslationInitialMd5].join(',');let translation=this.translations.filter(t=>t.id===id)[0];if(!translation){translation={id};this.translations.push(translation);}
return translation;}
async _beforeEditorActive($wysiwygEditable){this.$wysiwygEditable=$wysiwygEditable;const self=this;var attrs=['placeholder','title','alt','value'];const $editable=this.getEditableArea();const translationRegex=/<span [^>]*data-oe-translation-source-sha="([^"]+)"[^>]*>([\s\S]*?)<\/span>/;let $edited=$();attrs.forEach((attr)=>{const attrEdit=$editable.filter('['+attr+'*="data-oe-translation-source-sha="]').filter(':empty, input, select, textarea, img');attrEdit.each(function(){var $node=$(this);var translation=$node.data('translation')||{};var trans=$node.attr(attr);var match=trans.match(translationRegex);var $trans=$(trans).addClass('d-none o_editable o_editable_translatable_attribute').appendTo(self.websiteService.pageDocument.body);$trans.data('$node',$node).data('attribute',attr);translation[attr]=$trans[0];$node.attr(attr,match[2]);if(attr==='value'){$node[0].value=match[2];}
$node.addClass('o_translatable_attribute').data('translation',translation);});$edited=$edited.add(attrEdit);});const textEdit=$editable.filter('textarea:contains(data-oe-translation-source-sha)');textEdit.each(function(){var $node=$(this);var translation=$node.data('translation')||{};var trans=$node.text();var match=trans.match(translationRegex);var $trans=$(trans).addClass('d-none o_editable o_editable_translatable_text').appendTo(self.websiteService.pageDocument.body);$trans.data('$node',$node);translation['textContent']=$trans[0];$node.val(match[2]);$node[0].innerText=match[2];$node.addClass('o_translatable_text').removeClass('o_text_content_invisible').data('translation',translation);});$editable.filter('[data-oe-translation-source-sha] > select').each((index,select)=>{const selectTranslationEl=document.createElement('div');selectTranslationEl.className='o_translation_select';const optionNames=[...select.options].map(option=>option.text);optionNames.forEach(option=>{const optionEl=document.createElement('div');optionEl.textContent=option;optionEl.dataset.initialTranslationValue=option;optionEl.className='o_translation_select_option';selectTranslationEl.appendChild(optionEl);});select.before(selectTranslationEl);});this.translations=[];this.$translations=this.getEditableArea().filter('.o_translatable_attribute, .o_translatable_text');this.$editables=$(this.websiteService.pageDocument).find('.o_editable_translatable_attribute, .o_editable_translatable_text');this.markTranslatableNodes();this.$translations.filter('input[type=hidden].o_translatable_input_hidden').prop('type','text');$(this.websiteService.pageDocument).find('.dropdown-menu').on('click','.o_editable',function(ev){ev.stopPropagation();ev.preventDefault();});if(!browser.localStorage.getItem(localStorageNoDialogKey)){this.dialogService.add(TranslatorInfoDialog);}
$(this.websiteService.pageDocument).find(savableSelector).filter(':has('+savableSelector+')').attr('data-oe-readonly',true).removeAttr('contenteditable');const styleEl=document.createElement('style');styleEl.id="translate-stylesheet";this.websiteService.pageDocument.head.appendChild(styleEl);const toTranslateColor=window.getComputedStyle(document.documentElement).getPropertyValue('--o-we-content-to-translate-color');const translatedColor=window.getComputedStyle(document.documentElement).getPropertyValue('--o-we-translated-content-color');styleEl.sheet.insertRule(`[data-oe-translation-state].o_dirty {background: ${translatedColor} !important;}`);styleEl.sheet.insertRule(`[data-oe-translation-state="translated"] {background: ${translatedColor} !important;}`);styleEl.sheet.insertRule(`[data-oe-translation-state] {background: ${toTranslateColor} !important;}`);const showNotification=ev=>{let message=_t('This translation is not editable.');if(ev.target.closest('.s_table_of_content_navbar_wrap')){message=_t('Translate header in the text. Menu is generated automatically.');}
this.env.services.notification.add(message,{type:'info',sticky:false,});};for(const translationEl of $editable){if(translationEl.closest('.o_not_editable')){translationEl.addEventListener('click',showNotification);}
if(translationEl.closest('.s_table_of_content_navbar_wrap')){const href=translationEl.closest('a').getAttribute('href');const headerEl=translationEl.closest('.s_table_of_content').querySelector(`${href} [data-oe-translation-source-sha]`);if(headerEl){if(translationEl.dataset.oeTranslationSourceSha!==headerEl.dataset.oeTranslationSourceSha){translationEl.dataset.oeTranslationSaveSha=translationEl.dataset.oeTranslationSourceSha;translationEl.dataset.oeTranslationSourceSha=headerEl.dataset.oeTranslationSourceSha;}
translationEl.classList.add('o_translation_without_style');}}}}
markTranslatableNodes(){const self=this;this.getEditableArea().each(function(){var $node=$(this);const translation=self.getTranslationObject(this);translation.value=(translation.value?translation.value:$node.html()).replace(/[ \t\n\r]+/,' ');});this.$translations.each(function(){var $node=$(this);var translation=$node.data('translation');Object.values(translation).forEach((node)=>{var trans=self.getTranslationObject(node);trans.value=(trans.value?trans.value:$node.html()).replace(/[ \t\n\r]+/,' ');trans.state=node.dataset.oeTranslationState;if($node[0].dataset.oeTranslationState==='translated'){return;}
$node.attr('data-oe-translation-state',(trans.state||'to_translate'));});});this.$translations.add(this.getEditableArea().filter('.o_translation_select_option')).prependEvent('click.translator',(ev)=>{const node=ev.target;const isSelectTranslation=!!node.closest('.o_translation_select');this.dialogService.add(isSelectTranslation?SelectTranslateDialog:AttributeTranslateDialog,{node});});}
_onSave(ev){ev.stopPropagation();}
deleteQueryParam(param,target=window,adaptBrowserUrl=false){const url=new URL(target.location.href);url.searchParams.delete(param);target.history.replaceState(target.history.state,null,url);if(adaptBrowserUrl){this.deleteQueryParam(param);}}}
return __exports;});;

/* /website/static/src/js/new_content_form.js */
odoo.define('@website/js/new_content_form',['@web/views/form/form_view','@web/core/registry'],function(require){'use strict';let __exports={};const{formView}=require("@web/views/form/form_view");const{registry}=require("@web/core/registry");const NewContentFormController=__exports.NewContentFormController=class NewContentFormController extends formView.Controller{async save(){return super.save({computePath:()=>this.computePath(),...arguments});}
computePath(){return this.model.root.data.website_url;}}
const NewContentFormView=__exports.NewContentFormView={...formView,display:{controlPanel:false},Controller:NewContentFormController,};registry.category("views").add("website_new_content_form",NewContentFormView);return __exports;});;

/* /website/static/src/services/website_custom_menus.js */
odoo.define('@website/services/website_custom_menus',['@web/core/l10n/translation','@web/core/registry','@website/components/dialog/edit_menu','@website/components/dialog/seo','@website/components/dialog/page_properties'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{EditMenuDialog}=require('@website/components/dialog/edit_menu');const{OptimizeSEODialog}=require('@website/components/dialog/seo');const{PagePropertiesDialog}=require('@website/components/dialog/page_properties');const websiteCustomMenus=__exports.websiteCustomMenus={dependencies:['website','orm','dialog','ui'],start(env,{website,orm,dialog,ui}){const services={website,orm,dialog,ui};return{get(xmlId){return registry.category('website_custom_menus').get(xmlId,null);},async open(customMenu){const menuConfig=this.get(customMenu.xmlid);if(menuConfig.openWidget){return menuConfig.openWidget(services);}
const menuProps={...(menuConfig.getProps&&(await menuConfig.getProps(services))),...customMenu.dynamicProps,};return dialog.add(menuConfig.Component,menuProps,);},addCustomMenus(sections){const filteredSections=[];for(const section of sections){const isWebsiteCustomMenu=!!this.get(section.xmlid);const displayWebsiteCustomMenu=isWebsiteCustomMenu&&website.isRestrictedEditor&&this.get(section.xmlid).isDisplayed(env);if(!isWebsiteCustomMenu||displayWebsiteCustomMenu){let subSections=[];if(section.childrenTree.length){subSections=this.addCustomMenus(section.childrenTree);}
if(section.xmlid==='website.custom_menu_edit_menu'){filteredSections.push(...website.currentWebsite.metadata.contentMenus.map((menu,index)=>({...section,name:_t("Edit %s",menu[0]),dynamicProps:{rootID:parseInt(menu[1],10)},id:`${section.id}-${index}`,})));}else{filteredSections.push(Object.assign({},section,{childrenTree:subSections}));}}}
for(const section of filteredSections){section.childrenTree=section.childrenTree.filter(tree=>!(tree.children.length&&!tree.childrenTree.length));}
return filteredSections;},};}};registry.category('services').add('website_custom_menus',websiteCustomMenus);registry.category('website_custom_menus').add('website.menu_edit_menu',{Component:EditMenuDialog,isDisplayed:(env)=>!!env.services.website.currentWebsite&&env.services.website.isDesigner&&!env.services.website.currentWebsite.metadata.translatable,});registry.category('website_custom_menus').add('website.menu_optimize_seo',{Component:OptimizeSEODialog,isDisplayed:(env)=>env.services.website.currentWebsite&&env.services.website.isRestrictedEditor&&!!env.services.website.currentWebsite.metadata.canOptimizeSeo,});registry.category('website_custom_menus').add('website.menu_ace_editor',{openWidget:(services)=>services.website.context.showResourceEditor=true,isDisplayed:(env)=>env.services.website.currentWebsite&&env.services.website.currentWebsite.metadata.viewXmlid&&!env.services.ui.isSmall,});registry.category('website_custom_menus').add('website.menu_page_properties',{Component:PagePropertiesDialog,isDisplayed:(env)=>env.services.website.currentWebsite&&env.services.website.isDesigner&&!!env.services.website.currentWebsite.metadata.mainObject,getProps:async({orm,website})=>{const mainObject=website.currentWebsite.metadata.mainObject;const isPage=mainObject.model==="website.page";const model=isPage?"website.page.properties":"website.page.properties.base";return{resId:await orm.call(model,"create",[isPage?{target_model_id:mainObject.id,website_id:website.currentWebsite.id,}:{target_model_id:`${mainObject.model},${mainObject.id}`,url:window.location.pathname,website_id:website.currentWebsite.id,},]),resModel:model,onRecordSaved:async(record)=>{const page=isPage?(await orm.read("website.page",[mainObject.id],["website_id","url"]))[0]:undefined;return website.goToWebsite({websiteId:page?.website_id?.[0]??website.currentWebsite.id,path:page?.url??website.currentWebsite.metadata.path,});},};},});registry.category('website_custom_menus').add('website.custom_menu_edit_menu',{Component:EditMenuDialog,isDisplayed:(env)=>env.services.website.currentWebsite&&env.services.website.currentWebsite.metadata.contentMenus&&env.services.website.currentWebsite.metadata.contentMenus.length,});return __exports;});;

/* /website/static/src/js/tours/homepage.js */
odoo.define('@website/js/tours/homepage',['@website/js/tours/tour_utils'],function(require){'use strict';let __exports={};const{changeBackgroundColor,clickOnSnippet,clickOnText,insertSnippet,goBackToBlocks,registerThemeHomepageTour,}=require("@website/js/tours/tour_utils");const snippets=[{id:'s_banner',name:'Banner',groupName:"Intro",},{id:'s_three_columns',name:'Columns',groupName:"Columns",},{id:'s_text_image',name:'Image - Text',groupName:"Content",},{id:'s_masonry_block',name:'Masonry',groupName:"Images",},{id:'s_title',name:'Title',groupName:"Text",},{id:'s_showcase',name:'Showcase',groupName:"Content",},{id:'s_call_to_action',name:'Call to Action',groupName:"Content",},{id:'s_quotes_carousel',name:'Quotes',groupName:"People",},];registerThemeHomepageTour('homepage',()=>[...insertSnippet(snippets[0],"top"),...clickOnText(snippets[0],"h1"),goBackToBlocks(),...insertSnippet(snippets[1]),...insertSnippet(snippets[2]),...clickOnSnippet(snippets[2],"top"),changeBackgroundColor(),goBackToBlocks(),...insertSnippet(snippets[3]),...insertSnippet(snippets[4],"top"),...insertSnippet(snippets[5]),...insertSnippet(snippets[6]),...insertSnippet(snippets[7]),]);return __exports;});;

/* /website/static/src/systray_items/edit_in_backend.js */
odoo.define('@website/systray_items/edit_in_backend',['@web/core/registry','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService,useBus}=require("@web/core/utils/hooks");const{Component,onWillStart,useState}=require("@odoo/owl");const websiteSystrayRegistry=registry.category('website_systray');const EditInBackendSystray=__exports.EditInBackendSystray=class EditInBackendSystray extends Component{static template="website.EditInBackendSystray";static props={};setup(){this.websiteService=useService('website');this.actionService=useService('action');this.state=useState({mainObjectName:''});onWillStart(this._updateMainObjectName);useBus(websiteSystrayRegistry,'CONTENT-UPDATED',this._updateMainObjectName);}
editInBackend(){const{metadata:{mainObject}}=this.websiteService.currentWebsite;this.actionService.doAction({res_model:mainObject.model,res_id:mainObject.id,views:[[false,"form"]],type:"ir.actions.act_window",view_mode:"form",});}
async _updateMainObjectName(){this.state.mainObjectName=await this.websiteService.getUserModelName();}}
const systrayItem=__exports.systrayItem={Component:EditInBackendSystray,isDisplayed:env=>env.services.website.currentWebsite&&env.services.website.currentWebsite.metadata.editableInBackend,};registry.category("website_systray").add("EditInBackend",systrayItem,{sequence:10});return __exports;});;

/* /website/static/src/systray_items/edit_website.js */
odoo.define('@website/systray_items/edit_website',['@web/core/l10n/translation','@web/core/network/rpc','@web/core/registry','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{useService}=require('@web/core/utils/hooks');const{Component,useState,useEffect}=require("@odoo/owl");class EditWebsiteSystray extends Component{static template="website.EditWebsiteSystray";static components={Dropdown,DropdownItem,};static props={};setup(){this.websiteService=useService('website');this.websiteContext=useState(this.websiteService.context);this.state=useState({isLoading:false,});useEffect((edition)=>{if(edition){this.state.isLoading=true;}},()=>[this.websiteContext.edition]);useEffect((snippetsLoaded)=>{if(snippetsLoaded){this.state.isLoading=false;}},()=>[this.websiteContext.snippetsLoaded]);}
get translatable(){return this.websiteService.currentWebsite&&this.websiteService.currentWebsite.metadata.translatable&&this.websiteContext.isPublicRootReady;}
get label(){return _t("Edit");}
async attemptStartTranslate(){if(this.websiteService.isRestrictedEditor&&!this.websiteService.isDesigner){const object=this.websiteService.currentWebsite.metadata.mainObject;const objects={[object.model]:object.id,};const otherRecordEls=this.websiteService.websiteRootInstance.el.querySelectorAll("[data-res-model][data-res-id]:not([data-res-model='ir.ui.view']), [data-oe-model][data-oe-id]:not([data-oe-model='ir.ui.view'])");for(const el of otherRecordEls){const model=el.dataset.resModel||el.dataset.oeModel;if(!objects[model]){objects[model]=parseInt(el.dataset.resId||el.dataset.oeId);}}
await rpc('/website/check_can_modify_any',{records:Object.entries(objects).map(([res_model,res_id])=>({res_model,res_id,})),})}
this.startTranslate();}
startTranslate(){const{pathname,search,hash}=this.websiteService.contentWindow.location;if(!search.includes('edit_translations')){const searchParams=new URLSearchParams(search);searchParams.set('edit_translations','1');this.websiteService.goToWebsite({path:pathname+`?${searchParams.toString() + hash}`,translation:true});}else{this.websiteContext.translation=true;}}
startEdit(){if(this.translatable){const{pathname,search,hash}=this.websiteService.contentWindow.location;const languagePrefix=`${pathname}/`.indexOf('/',1);const defaultLanguagePathname=pathname.substring(languagePrefix);this.websiteService.goToWebsite({path:defaultLanguagePathname+search+hash,lang:'default',edition:true});}else{this.websiteContext.edition=true;}}}
const systrayItem=__exports.systrayItem={Component:EditWebsiteSystray,isDisplayed:(env)=>env.services.website.isRestrictedEditor&&(env.services.website.currentWebsite.metadata.editable||env.services.website.currentWebsite.metadata.translatable),};registry.category("website_systray").add("EditWebsite",systrayItem,{sequence:7});return __exports;});;

/* /website/static/src/systray_items/mobile_preview.js */
odoo.define('@website/systray_items/mobile_preview',['@web/core/registry','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{Component,useState}=require("@odoo/owl");class MobilePreviewSystray extends Component{static template="website.MobilePreviewSystray";static props={};setup(){this.websiteService=useService('website');this.state=useState(this.websiteService.context);}}
const systrayItem=__exports.systrayItem={Component:MobilePreviewSystray,isDisplayed:(env)=>env.services.website.isRestrictedEditor,};registry.category("website_systray").add("MobilePreview",systrayItem,{sequence:11});return __exports;});;

/* /website/static/src/systray_items/new_content.js */
odoo.define('@website/systray_items/new_content',['@web/core/l10n/translation','@web/core/network/rpc','@web/core/registry','@web/core/user','@web/core/utils/hooks','@web/core/utils/urls','@website/components/dialog/dialog','@website/components/dialog/add_page_dialog','@web/core/hotkeys/hotkey_hook','@web/core/utils/strings','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{registry}=require('@web/core/registry');const{user}=require("@web/core/user");const{useService}=require('@web/core/utils/hooks');const{redirect}=require("@web/core/utils/urls");const{WebsiteDialog}=require("@website/components/dialog/dialog");const{AddPageDialog}=require("@website/components/dialog/add_page_dialog");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{sprintf}=require('@web/core/utils/strings');const{Component,xml,useState,onWillStart}=require("@odoo/owl");const MODULE_STATUS=__exports.MODULE_STATUS={NOT_INSTALLED:'NOT_INSTALLED',INSTALLING:'INSTALLING',FAILED_TO_INSTALL:'FAILED_TO_INSTALL',INSTALLED:'INSTALLED',};class NewContentElement extends Component{static template="website.NewContentElement";static props={name:{type:String,optional:true},title:String,onClick:Function,status:{type:String,optional:true},moduleXmlId:{type:String,optional:true},slots:Object,};static defaultProps={status:MODULE_STATUS.INSTALLED,};setup(){this.MODULE_STATUS=MODULE_STATUS;}
onClick(ev){ev.preventDefault();ev.stopPropagation();this.props.onClick();}}
class InstallModuleDialog extends Component{static components={WebsiteDialog};static template="website.InstallModuleDialog";static props={title:String,installationText:String,installModule:Function,close:Function,};setup(){this.installButton=_t("Install");}
onClickInstall(){this.props.close();this.props.installModule();}}
const NewContentModal=__exports.NewContentModal=class NewContentModal extends Component{static template="website.NewContentModal";static components={NewContentElement};static props={};setup(){this.orm=useService('orm');this.dialogs=useService('dialog');this.website=useService('website');this.action=useService('action');this.isSystem=user.isSystem;this.newContentText={failed:_t('Failed to install "%s"'),installInProgress:_t("The installation of an App is already in progress."),installNeeded:_t('Do you want to install the "%s" App?'),installPleaseWait:_t('Installing "%s"'),};this.state=useState({newContentElements:[{moduleName:'website_blog',moduleXmlId:'base.module_website_blog',status:MODULE_STATUS.NOT_INSTALLED,icon:xml`<i class="fa fa-newspaper-o"/>`,title:_t('Blog Post'),},{moduleName:'website_event',moduleXmlId:'base.module_website_event',status:MODULE_STATUS.NOT_INSTALLED,icon:xml`<i class="fa fa-ticket"/>`,title:_t('Event'),},{moduleName:'website_forum',moduleXmlId:'base.module_website_forum',status:MODULE_STATUS.NOT_INSTALLED,icon:xml`<i class="fa fa-comment"/>`,redirectUrl:'/forum',title:_t('Forum'),},{moduleName:'website_hr_recruitment',moduleXmlId:'base.module_website_hr_recruitment',status:MODULE_STATUS.NOT_INSTALLED,icon:xml`<i class="fa fa-briefcase"/>`,title:_t('Job Position'),},{moduleName:'website_sale',moduleXmlId:'base.module_website_sale',status:MODULE_STATUS.NOT_INSTALLED,icon:xml`<i class="fa fa-shopping-cart"/>`,title:_t('Product'),},{moduleName:'website_slides',moduleXmlId:'base.module_website_slides',status:MODULE_STATUS.NOT_INSTALLED,icon:xml`<i class="fa module_icon" style="background-image: url('/website/static/src/img/apps_thumbs/website_slide.svg');background-repeat: no-repeat; background-position: center;"/>`,title:_t('Course'),},{moduleName:'website_livechat',moduleXmlId:'base.module_website_livechat',status:MODULE_STATUS.NOT_INSTALLED,icon:xml`<i class="fa fa-comments"/>`,title:_t('Livechat Widget'),redirectUrl:'/livechat'},]});this.websiteContext=useState(this.website.context);useHotkey('escape',()=>{if(this.websiteContext.showNewContentModal){this.websiteContext.showNewContentModal=false;}});onWillStart(this.onWillStart.bind(this));}
async onWillStart(){this.isDesigner=await user.hasGroup('website.group_website_designer');this.canInstall=await user.isAdmin;if(this.canInstall){const moduleNames=this.state.newContentElements.filter(({status})=>status===MODULE_STATUS.NOT_INSTALLED).map(({moduleName})=>moduleName);this.modulesInfo={};for(const record of await this.orm.searchRead("ir.module.module",[['name','in',moduleNames]],["id","name","shortdesc"],)){this.modulesInfo[record.name]={id:record.id,name:record.shortdesc};}}
const modelsToCheck=[];const elementsToUpdate={};for(const element of this.state.newContentElements){if(element.model){modelsToCheck.push(element.model);elementsToUpdate[element.model]=element;}}
const accesses=await rpc("/website/check_new_content_access_rights",{models:modelsToCheck,});for(const[model,access]of Object.entries(accesses)){elementsToUpdate[model].isDisplayed=access;}}
get sortedNewContentElements(){return this.state.newContentElements.filter(({status})=>status!==MODULE_STATUS.NOT_INSTALLED).concat(this.state.newContentElements.filter(({status})=>status===MODULE_STATUS.NOT_INSTALLED));}
createNewPage(){this.dialogs.add(AddPageDialog,{onAddPage:()=>this.websiteContext.showNewContentModal=false,websiteId:this.website.currentWebsite.id,});}
async installModule(id,redirectUrl){await this.orm.silent.call('ir.module.module','button_immediate_install',[id],);if(redirectUrl){this.website.prepareOutLoader();window.location.replace(redirectUrl);}else{const{id,metadata:{path,viewXmlid}}=this.website.currentWebsite;const url=new URL(path);if(viewXmlid==='website.page_404'){url.pathname='';}
this.website.prepareOutLoader();redirect(`/odoo/action-website.website_preview?website_id=${id}&path=${encodeURIComponent(url.toString())}&display_new_content=true`);}}
onClickNewContent(element){if(element.createNewContent){return element.createNewContent();}
const{id,name}=this.modulesInfo[element.moduleName];const dialogProps={title:element.title,installationText:sprintf(this.newContentText.installNeeded,name),installModule:async()=>{this.state.newContentElements=this.state.newContentElements.map(el=>{if(el.moduleXmlId===element.moduleXmlId){el.status=MODULE_STATUS.INSTALLING;el.icon=xml`<i class="fa fa-spin fa-circle-o-notch"/>`;el.title=sprintf(this.newContentText.installPleaseWait,name);}
return el;});this.website.showLoader({title:_t("Building your %s",name)});try{await this.installModule(id,element.redirectUrl);}catch(error){this.website.hideLoader();this.state.newContentElements=this.state.newContentElements.map(el=>{if(el.moduleXmlId===element.moduleXmlId){el.status=MODULE_STATUS.FAILED_TO_INSTALL;el.icon=xml`<i class="fa fa-exclamation-triangle"/>`;el.title=sprintf(this.newContentText.failed,name);}
return el;});console.error(error);}},};this.dialogs.add(InstallModuleDialog,dialogProps);}
async onAddContent(action,edition=false,context=null){this.action.doAction(action,{additionalContext:(context)?context:{},onClose:(infos)=>{if(infos){this.website.goToWebsite({path:infos.path,edition:edition});}},props:{onSave:(record,params)=>{if(record.resId){const path=params.computePath();this.action.doAction({type:"ir.actions.act_window_close",infos:{path}});}}}});}}
class NewContentSystray extends Component{static template="website.NewContentSystray";static components={NewContentModal};static props={};setup(){this.website=useService('website');this.websiteContext=useState(this.website.context);}
onClick(){this.websiteContext.showNewContentModal=!this.websiteContext.showNewContentModal;}}
const systrayItem=__exports.systrayItem={Component:NewContentSystray,isDisplayed:(env)=>env.services.website.isRestrictedEditor,};registry.category("website_systray").add("NewContent",systrayItem,{sequence:9});return __exports;});;

/* /website/static/src/systray_items/publish.js */
odoo.define('@website/systray_items/publish',['@web/core/l10n/translation','@web/core/network/rpc','@web/core/registry','@web/core/checkbox/checkbox','@web/core/utils/hooks','@odoo/owl','@website/components/dialog/seo','@website/js/utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{CheckBox}=require('@web/core/checkbox/checkbox');const{useService,useBus}=require('@web/core/utils/hooks');const{Component,xml,useState}=require("@odoo/owl");const{OptimizeSEODialog}=require("@website/components/dialog/seo");const{checkAndNotifySEO}=require("@website/js/utils");const websiteSystrayRegistry=registry.category('website_systray');class PublishSystray extends Component{static template=xml`
        <div t-on-click="publishContent" class="o_menu_systray_item o_website_publish_container d-flex ms-auto" t-att-data-processing="state.processing and 1">
            <a href="#" class="d-flex align-items-center mx-1 px-2 px-md-0" data-hotkey="p">
                <span class="o_nav_entry d-none d-md-block mx-0 pe-1" t-esc="this.label"/>
                <CheckBox value="state.published" className="'form-switch d-flex justify-content-center m-0 pe-none'"/>
            </a>
        </div>`;static components={CheckBox,};static props={};setup(){this.website=useService('website');this.orm=useService('orm');this.dialogService=useService("dialog");this.notificationService=useService("notification");this.state=useState({published:this.website.currentWebsite.metadata.isPublished,processing:false,});useBus(websiteSystrayRegistry,'CONTENT-UPDATED',()=>this.state.published=this.website.currentWebsite.metadata.isPublished);}
get label(){return this.state.published?_t("Published"):_t("Unpublished");}
async publishContent(){if(this.state.processing){return;}
this.state.processing=true;this.state.published=!this.state.published;const{metadata:{mainObject}}=this.website.currentWebsite;return this.orm.call(mainObject.model,"website_publish_button",[[mainObject.id]],).then(async(published)=>{this.state.published=published;if(published&&this.website.currentWebsite.metadata.canOptimizeSeo){const seo_data=await rpc("/website/get_seo_data",{res_id:mainObject.id,res_model:mainObject.model,});checkAndNotifySEO(seo_data,OptimizeSEODialog,{notification:this.notificationService,dialog:this.dialogService,});}
this.state.processing=false;return published;},(err)=>{this.state.published=!this.state.published;this.state.processing=false;throw err;});}}
const systrayItem=__exports.systrayItem={Component:PublishSystray,isDisplayed:env=>env.services.website.currentWebsite&&env.services.website.currentWebsite.metadata.canPublish,};websiteSystrayRegistry.add("Publish",systrayItem,{sequence:12});return __exports;});;

/* /website/static/src/systray_items/website_switcher.js */
odoo.define('@website/systray_items/website_switcher',['@web/core/l10n/translation','@web/core/browser/browser','@web/core/registry','@web/core/utils/hooks','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/session','@website/js/utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{session}=require("@web/session");const wUtils=require('@website/js/utils')[Symbol.for("default")];const{Component}=require("@odoo/owl");const WebsiteSwitcherSystray=__exports.WebsiteSwitcherSystray=class WebsiteSwitcherSystray extends Component{static template="website.WebsiteSwitcherSystray";static components={Dropdown,DropdownItem,};static props={};setup(){this.websiteService=useService('website');this.notificationService=useService("notification");this.actionService=useService("action");}
getElements(){return this.websiteService.websites.map((website)=>({name:website.name,id:website.id,domain:website.domain,dataset:Object.assign({'data-website-id':website.id,},website.domain?{}:{'data-tooltip':_t('This website does not have a domain configured.'),'data-tooltip-position':'left',}),callback:()=>{if(!session.website_bypass_domain_redirect&&website.domain&&!wUtils.isHTTPSorNakedDomainRedirection(website.domain,window.location.origin)){const{location:{pathname,search,hash}}=this.websiteService.contentWindow;const path=pathname+search+hash;window.location.href=`${encodeURI(website.domain)}/odoo/action-website.website_preview?path=${encodeURIComponent(path)}&website_id=${encodeURIComponent(website.id)}`;}else{this.websiteService.goToWebsite({websiteId:website.id,path:"",lang:"default"});if(!website.domain){const closeFn=this.notificationService.add(_t("This website does not have a domain configured. To avoid unexpected behaviours during website edition, we recommend closing (or refreshing) other browser tabs.\nTo remove this message please set a domain in your website settings"),{type:"warning",title:_t("No website domain configured for this website."),sticky:true,buttons:[{onClick:()=>{this.actionService.doAction("website.action_website_configuration");closeFn();},primary:true,name:"Go to Settings",},],});browser.setTimeout(closeFn,7000);}}},class:website.id===this.websiteService.currentWebsite.id?'text-truncate active':'text-truncate',}));}}
const systrayItem=__exports.systrayItem={Component:WebsiteSwitcherSystray,isDisplayed:env=>env.services.website.hasMultiWebsites,};registry.category("website_systray").add("WebsiteSwitcher",systrayItem,{sequence:12});return __exports;});;

/* /website/static/src/js/backend/view_hierarchy/hierarchy_navbar.js */
odoo.define('@website/js/backend/view_hierarchy/hierarchy_navbar',['@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@odoo/owl'],function(require){'use strict';let __exports={};const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{Component,useRef,useState}=require("@odoo/owl");const HierarchyNavbar=__exports.HierarchyNavbar=class HierarchyNavbar extends Component{static template="website.hierarchy_navbar";static components={Dropdown,DropdownItem,};static props={toggleInactive:Function,websites:Object,selectWebsite:Function,searchView:Function,};setup(){this.searchInput=useRef("search");this.websiteNamesState=useState(Array.from(this.props.websites.names));}
get websiteNames(){return this.websiteNamesState.map((websiteName)=>({label:websiteName,onSelected:()=>this.props.selectWebsite(websiteName),}));}
onInputKeydown(event){if(event.key==="Enter"||event.key==="Tab"){event.preventDefault();this.props.searchView(event.target.value,!event.shiftKey);}}
onInputClick(event){this.props.searchView(this.searchInput.el.value,!event.shiftKey);}}
return __exports;});;

/* /website/static/src/js/backend/view_hierarchy/view_hierarchy.js */
odoo.define('@website/js/backend/view_hierarchy/view_hierarchy',['@website/js/backend/view_hierarchy/hierarchy_navbar','@web/search/layout','@web/core/registry','@web/core/utils/hooks','@odoo/owl','@web/core/browser/router','@web/webclient/actions/action_service'],function(require){'use strict';let __exports={};const{HierarchyNavbar}=require("@website/js/backend/view_hierarchy/hierarchy_navbar");const{Layout}=require("@web/search/layout");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{Component,onWillStart,useEffect,useState}=require("@odoo/owl");const{router}=require("@web/core/browser/router");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");const ViewHierarchy=__exports.ViewHierarchy=class ViewHierarchy extends Component{static components={Layout,HierarchyNavbar};static template="website.view_hierarchy";static props={...standardActionServiceProps};setup(){this.action=useService("action");this.orm=useService("orm");this.state=useState({showInactive:false,searchedView:{},viewTree:{}});this.websites=useState({names:new Set(["All Websites"]),selected:"All Websites"});this.viewId=this.props.action.context.active_id||router.current.active_id;this.hideGenericViewByWebsite={};onWillStart(async()=>{({sibling_views:this.siblingViews,hierarchy:this.state.viewTree,}=await this.orm.call("ir.ui.view","get_view_hierarchy",[this.viewId],{}));this.setupWebsiteNames();this.setupHideGenericViewByWebsite();this.linkViewsToParent();});useEffect((searchFoundElem)=>{if(searchFoundElem){searchFoundElem.scrollIntoView({behavior:"smooth",block:"center"});}},()=>[document.querySelector(".o_search_found")]);}
selectWebsite(websiteName){this.websites.selected=websiteName;}
toggleInactive(checked){this.state.showInactive=checked;}
getSearchResults(keyword){const exactMatches=[];const matches=[];const lowercaseKeyword=keyword.toLowerCase();this.viewTraversal(this.state.viewTree,(currentView)=>{if(this.isViewDisplayed(currentView)&&(currentView.name.toLowerCase()===lowercaseKeyword||currentView.key.toLowerCase()===lowercaseKeyword||currentView.id===parseInt(lowercaseKeyword))){exactMatches.push(currentView);}else if(this.isViewDisplayed(currentView)&&(currentView.name.toLowerCase().includes(lowercaseKeyword)||currentView.key.toLowerCase().includes(lowercaseKeyword))){matches.push(currentView);}},(currentView)=>this.isViewDisplayed(currentView));return exactMatches.concat(matches);}
searchView(keyword,forward=true){const matches=this.getSearchResults(keyword);let index=0;if(this.state.searchedView.keyword===keyword){index=matches.findIndex((view)=>this.state.searchedView.id===view.id);index=forward?index+1:index-1;index=index-matches.length*Math.floor(index/matches.length);}
const view=matches[index];if(view){this.state.searchedView={id:view.id,keyword:keyword,total:matches.length,index,};}}
viewTraversal(currentView,fn,continueRec=(view)=>true){fn(currentView);if(continueRec(currentView)){currentView.inherit_children.forEach((childView)=>{this.viewTraversal(childView,fn,continueRec);});}}
setupWebsiteNames(){this.viewTraversal(this.state.viewTree,(currentView)=>{if(currentView.website_name){this.websites.names.add(currentView.website_name);}});}
setupHideGenericViewByWebsite(){this.viewTraversal(this.state.viewTree,(currentView)=>{if(currentView.website_name){if(!this.hideGenericViewByWebsite[currentView.website_name]){this.hideGenericViewByWebsite[currentView.website_name]={};}
this.hideGenericViewByWebsite[currentView.website_name][currentView.name]=true;}});}
linkViewsToParent(){this.viewTraversal(this.state.viewTree,(currentView)=>{currentView.inherit_children.forEach((child)=>(child.parent=currentView));});}
onCollapseClick(view){view.collapsed=!view.collapsed;if(view.collapsed){this.viewTraversal(view,(child)=>{child.collapsed=view.collapsed;});}}
isViewDisplayed(view,isCollapsedDisplayed=false){let isCollapsed=view.parent?view.parent.collapsed:false;if(isCollapsedDisplayed){isCollapsed=false;}
const isActive=this.state.showInactive||view.active;const isWebsiteDisplayed=this.websites.selected==="All Websites"||view.website_name===this.websites.selected||(!view.website_name&&!this.hideGenericViewByWebsite[this.websites.selected][view.name]);return!isCollapsed&&isActive&&isWebsiteDisplayed;}
hasChildToUnfold(view){return view.inherit_children.some((child)=>this.isViewDisplayed(child,true));}
onShowDiffClick(viewId){this.action.doAction("base.reset_view_arch_wizard_action",{additionalContext:{active_model:"ir.ui.view",active_ids:[viewId],},});}
openFormView(viewId){this.action.doAction({type:"ir.actions.act_window",res_model:"ir.ui.view",res_id:viewId,views:[[false,"form"]],});}
onShowHierarchy(viewId){this.action.doAction({type:"ir.actions.client",tag:"website_view_hierarchy",name:"View Hierarchy",context:{active_id:viewId,},});}}
registry.category("actions").add("website_view_hierarchy",ViewHierarchy);return __exports;});;

/* /website_sale/static/src/js/systray_items/new_content.js */
odoo.define('@website_sale/js/systray_items/new_content',['@website/systray_items/new_content','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{NewContentModal,MODULE_STATUS}=require('@website/systray_items/new_content');const{patch}=require("@web/core/utils/patch");patch(NewContentModal.prototype,{setup(){super.setup();const newProductElement=this.state.newContentElements.find(element=>element.moduleXmlId==='base.module_website_sale');newProductElement.createNewContent=()=>this.onAddContent('website_sale.product_product_action_add',true,{default_is_published:true});newProductElement.status=MODULE_STATUS.INSTALLED;newProductElement.model='product.product';},});return __exports;});;

/* /website_hr_recruitment/static/src/js/systray_items/new_content.js */
odoo.define('@website_hr_recruitment/js/systray_items/new_content',['@website/systray_items/new_content','@web/core/network/rpc','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{NewContentModal,MODULE_STATUS}=require('@website/systray_items/new_content');const{rpc}=require("@web/core/network/rpc");const{patch}=require("@web/core/utils/patch");patch(NewContentModal.prototype,{setup(){super.setup();const newJobElement=this.state.newContentElements.find(element=>element.moduleXmlId==='base.module_website_hr_recruitment');newJobElement.createNewContent=()=>this.createNewJob();newJobElement.status=MODULE_STATUS.INSTALLED;newJobElement.model='hr.job';},async createNewJob(){const url=await rpc('/jobs/add');this.website.goToWebsite({path:url,edition:true});this.websiteContext.showNewContentModal=false;}});return __exports;});;

/* /website_helpdesk/static/src/js/website_helpdesk_edit_menu.js */
odoo.define('@website_helpdesk/js/website_helpdesk_edit_menu',['@web/core/l10n/translation','@web/core/utils/patch','@web/core/utils/hooks','@website/components/dialog/edit_menu'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{useService}=require("@web/core/utils/hooks");const{MenuDialog}=require("@website/components/dialog/edit_menu");patch(MenuDialog.prototype,{setup(){super.setup();this.notification=useService('notification');},onClickOk(){if(this.url.isValid()){const isHelpdeskUrl=this.url.input.value==="/helpdesk";const isHelpdeskTeamPattern=isHelpdeskUrl||/^\/helpdesk\/([a-zA-Z]+-)+\d+$/.test(this.url.input.value);if(isHelpdeskUrl||isHelpdeskTeamPattern){this.url.input.hasError=true;this.notification.add(isHelpdeskUrl?_t("This URL is reserved for the helpdesk teams with 'website form' feature enabled."):_t("The %s URL is reserved for the helpdesk team with the same name. \
                        To use it, please enable the 'website form' feature on that team instead.",this.url.input.value),{type:'danger'},);return;}}
super.onClickOk();},});return __exports;});;

/* /website_forum/static/src/js/systray_items/forum_forum_add_form.js */
odoo.define('@website_forum/js/systray_items/forum_forum_add_form',['@website/js/new_content_form','@web/core/registry'],function(require){'use strict';let __exports={};const{NewContentFormController,NewContentFormView}=require('@website/js/new_content_form');const{registry}=require("@web/core/registry");const AddForumFormController=__exports.AddForumFormController=class AddForumFormController extends NewContentFormController{computePath(){return`/forum/${encodeURIComponent(this.model.root.resId)}`;}}
const AddForumFormView=__exports.AddForumFormView={...NewContentFormView,Controller:AddForumFormController,};registry.category("views").add("website_forum_add_form",AddForumFormView);return __exports;});;

/* /website_forum/static/src/js/systray_items/new_content.js */
odoo.define('@website_forum/js/systray_items/new_content',['@website/systray_items/new_content','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{NewContentModal,MODULE_STATUS}=require('@website/systray_items/new_content');const{patch}=require("@web/core/utils/patch");patch(NewContentModal.prototype,{setup(){super.setup();const newForumElement=this.state.newContentElements.find(element=>element.moduleXmlId==='base.module_website_forum');newForumElement.createNewContent=()=>this.onAddContent('website_forum.forum_forum_action_add');newForumElement.status=MODULE_STATUS.INSTALLED;newForumElement.model='forum.forum';},});return __exports;});;

/* /website_livechat/static/src/js/systray_items/new_content.js */
odoo.define('@website_livechat/js/systray_items/new_content',['@website/systray_items/new_content','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{NewContentModal,MODULE_STATUS}=require("@website/systray_items/new_content");const{patch}=require("@web/core/utils/patch");patch(NewContentModal.prototype,{setup(){super.setup();const newChannelElement=this.state.newContentElements.find((element)=>element.moduleXmlId==="base.module_website_livechat");newChannelElement.createNewContent=()=>this.onAddContent("website_livechat.im_livechat_channel_action_add");newChannelElement.status=MODULE_STATUS.INSTALLED;newChannelElement.model="im_livechat.channel";},});return __exports;});;

/* /website_enterprise/static/src/js/systray_items/new_content.js */
odoo.define('@website_enterprise/js/systray_items/new_content',['@web/core/l10n/translation','@website/systray_items/new_content','@web/core/utils/patch','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{NewContentModal,MODULE_STATUS}=require('@website/systray_items/new_content');const{patch}=require("@web/core/utils/patch");const{xml}=require("@odoo/owl");patch(NewContentModal.prototype,{setup(){super.setup();this.state.newContentElements.push({moduleName:'website_appointment',moduleXmlId:'base.module_website_appointment',status:MODULE_STATUS.NOT_INSTALLED,icon:xml`<i class="fa fa-calendar"/>`,title:_t('Appointment Form'),});},});return __exports;});;

/* /website_enterprise/static/src/services/color_scheme_service_patch.js */
odoo.define('@website_enterprise/services/color_scheme_service_patch',['@web/core/browser/browser','@web/core/utils/patch','@web_enterprise/webclient/color_scheme/color_scheme_service'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{patch}=require("@web/core/utils/patch");const{colorSchemeService}=require("@web_enterprise/webclient/color_scheme/color_scheme_service");patch(colorSchemeService,{reload(){if(document.querySelector("header.o_navbar + .o_action_manager > .o_website_preview")){browser.location.pathname="/@"+browser.location.pathname;}else{super.reload();}},});return __exports;});;

/* /website_appointment/static/src/js/systray_items/new_content.js */
odoo.define('@website_appointment/js/systray_items/new_content',['@website/systray_items/new_content','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{NewContentModal,MODULE_STATUS}=require('@website/systray_items/new_content');const{patch}=require("@web/core/utils/patch");patch(NewContentModal.prototype,{setup(){super.setup();const newAppointmentTypeElement=this.state.newContentElements.find(element=>element.moduleXmlId==='base.module_website_appointment');newAppointmentTypeElement.createNewContent=()=>this.onAddContent('website_appointment.appointment_type_action_add_simplified');newAppointmentTypeElement.status=MODULE_STATUS.INSTALLED;newAppointmentTypeElement.model='appointment.type';},});return __exports;});;

/* /website_links/static/src/services/website_custom_menus.js */
odoo.define('@website_links/services/website_custom_menus',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require('@web/core/registry');registry.category('website_custom_menus').add('website_links.menu_link_tracker',{openWidget:(services)=>services.website.goToWebsite({path:`/r?u=${encodeURIComponent(services.website.contentWindow.location.href)}`}),isDisplayed:(env)=>env.services.website.currentWebsite&&env.services.website.contentWindow,});return __exports;});;

/* /website_blog/static/src/js/tours/website_blog.js */
odoo.define('@website_blog/js/tours/website_blog',['@web/core/l10n/translation','@website/js/tours/tour_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{clickOnSave,registerWebsitePreviewTour,}=require('@website/js/tours/tour_utils');const{markup}=require("@odoo/owl");registerWebsitePreviewTour("blog",{url:"/",},()=>[{trigger:"body:not(:has(#o_new_content_menu_choices)) .o_new_content_container > a",content:_t("Click here to add new content to your website."),tooltipPosition:'bottom',run:"click",},{trigger:'a[data-module-xml-id="base.module_website_blog"]',content:_t("Select this menu item to create a new blog post."),tooltipPosition:"bottom",run:"click",},{trigger:'div[name="name"] input',content:_t("Enter your post's title"),tooltipPosition:"bottom",run:"edit Test",},{trigger:'div.o_field_widget[name="blog_id"]',},{trigger:"button.o_form_button_save",content:_t("Select the blog you want to add the post to."),run:"click",},{trigger:"#oe_snippets.o_loaded",timeout:15000,},{trigger:":iframe h1[data-oe-expression=\"blog_post.name\"]",content:_t("Edit your title, the subtitle is optional."),tooltipPosition:"top",run:"editor Test",},{trigger:`:iframe #wrap h1[data-oe-expression="blog_post.name"]:not(:contains(''))`,},{trigger:"we-button[data-background]:eq(0)",content:markup(_t("Set a blog post <b>cover</b>.")),tooltipPosition:"top",run:"click",},{trigger:".o_select_media_dialog .o_we_search",content:_t("Search for an image. (eg: type \"business\")"),tooltipPosition:"top",},{trigger:".o_select_media_dialog .o_existing_attachment_cell:first img",content:_t("Choose an image from the library."),tooltipPosition:"top",run:"click",},{trigger:":iframe #o_wblog_post_content p",content:markup(_t("<b>Write your story here.</b> Use the top toolbar to style your text: add an image or table, set bold or italic, etc. Drag and drop building blocks for more graphical blogs.")),tooltipPosition:"top",run:"editor Blog content",},...clickOnSave(),{trigger:".o_menu_systray_item.o_mobile_preview > a",content:markup(_t("Use this icon to preview your blog post on <b>mobile devices</b>.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_website_preview.o_is_mobile",},{trigger:".o_menu_systray_item.o_mobile_preview > a",content:_t("Once you have reviewed the content on mobile, you can switch back to the normal view by clicking here again"),tooltipPosition:"right",run:"click",},{trigger:":iframe body:not(.editor_enable)",},{trigger:'.o_menu_systray_item a:contains("Unpublished")',tooltipPosition:"bottom",content:markup(_t("<b>Publish your blog post</b> to make it visible to your visitors.")),run:"click",},{trigger:'.o_menu_systray_item a:contains("Published")',}]);return __exports;});;

/* /website_blog/static/src/js/systray_items/new_content.js */
odoo.define('@website_blog/js/systray_items/new_content',['@website/systray_items/new_content','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{NewContentModal,MODULE_STATUS}=require('@website/systray_items/new_content');const{patch}=require("@web/core/utils/patch");patch(NewContentModal.prototype,{setup(){super.setup();const newBlogElement=this.state.newContentElements.find(element=>element.moduleXmlId==='base.module_website_blog');newBlogElement.createNewContent=()=>this.onAddContent('website_blog.blog_post_action_add',true);newBlogElement.status=MODULE_STATUS.INSTALLED;newBlogElement.model='blog.post';},});return __exports;});;

/* /website/static/src/js/tours/tour_utils.js */
odoo.define('@website/js/tours/tour_utils',['@web/core/l10n/translation','@web/core/registry','@web/core/browser/cookie','@odoo/owl','@web/core/utils/objects','@web/core/macro'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{cookie}=require("@web/core/browser/cookie");const{markup}=require("@odoo/owl");const{omit}=require("@web/core/utils/objects");const{waitForStable}=require("@web/core/macro");__exports.addMedia=addMedia;function addMedia(position="right"){return{trigger:`.modal-content footer .btn-primary`,content:markup(_t("<b>Add</b> the selected image.")),tooltipPosition:position,run:"click",};}
__exports.assertCssVariable=assertCssVariable;function assertCssVariable(variableName,variableValue,trigger=':iframe body'){return{isActive:["auto"],content:`Check CSS variable ${variableName}=${variableValue}`,trigger:trigger,run(){const styleValue=getComputedStyle(this.anchor).getPropertyValue(variableName);if((styleValue&&styleValue.trim().replace(/["']/g,''))!==variableValue.trim().replace(/["']/g,'')){throw new Error(`Failed precondition: ${variableName}=${styleValue} (should be ${variableValue})`);}},};}
__exports.assertPathName=assertPathName;function assertPathName(pathname,trigger){return{content:`Check if we have been redirected to ${pathname}`,trigger:trigger,async run(){await new Promise((resolve)=>{let elapsedTime=0;const intervalTime=100;const interval=setInterval(()=>{if(window.location.pathname.startsWith(pathname)){clearInterval(interval);resolve();}
elapsedTime+=intervalTime;if(elapsedTime>=5000){clearInterval(interval);console.error(`The pathname ${pathname} has not been found`);}},intervalTime);});},};}
__exports.changeBackground=changeBackground;function changeBackground(snippet,position="bottom"){return[{trigger:".o_we_customize_panel .o_we_bg_success",content:markup(_t("<b>Customize</b> any block through this menu. Try to change the background image of this block.")),tooltipPosition:position,run:"click",},];}
__exports.changeBackgroundColor=changeBackgroundColor;function changeBackgroundColor(position="bottom"){return{trigger:".o_we_customize_panel .o_we_color_preview",content:markup(_t("<b>Customize</b> any block through this menu. Try to change the background color of this block.")),tooltipPosition:position,run:"click",};}
__exports.selectColorPalette=selectColorPalette;function selectColorPalette(position="left"){return{trigger:".o_we_customize_panel .o_we_so_color_palette we-selection-items, .o_we_customize_panel .o_we_color_preview",content:markup(_t(`<b>Select</b> a Color Palette.`)),tooltipPosition:position,run:'click',};}
__exports.changeColumnSize=changeColumnSize;function changeColumnSize(position="right"){return{trigger:`:iframe .oe_overlay.o_draggable.o_we_overlay_sticky.oe_active .o_handle.e`,content:markup(_t("<b>Slide</b> this button to change the column size.")),tooltipPosition:position,run:"click",};}
__exports.changeImage=changeImage;function changeImage(snippet,position="bottom"){return[{trigger:"body.editor_enable",},{trigger:snippet.id?`#wrapwrap .${snippet.id} img`:snippet,content:markup(_t("<b>Double click on an image</b> to change it with one of your choice.")),tooltipPosition:position,run:"dblclick",},];}
__exports.changeOption=changeOption;function changeOption(optionName,weName='',optionTooltipLabel='',position="bottom",allowPalette=false){const noPalette=allowPalette?'':'.o_we_customize_panel:not(:has(.o_we_so_color_palette.o_we_widget_opened))';const option_block=`${noPalette} we-customizeblock-option[class='snippet-option-${optionName}']`;return{trigger:`${option_block} ${weName}, ${option_block} [title='${weName}']`,content:markup(_t("<b>Click</b> on this option to change the %s of the block.",optionTooltipLabel)),tooltipPosition:position,run:"click",};}
__exports.selectNested=selectNested;function selectNested(trigger,optionName,altTrigger=null,optionTooltipLabel='',position="top",allowPalette=false){const noPalette=allowPalette?'':'.o_we_customize_panel:not(:has(.o_we_so_color_palette.o_we_widget_opened))';const option_block=`${noPalette} we-customizeblock-option[class='snippet-option-${optionName}']`;return{trigger:trigger+(altTrigger?`, ${option_block} ${altTrigger}`:""),content:markup(_t("<b>Select</b> a %s.",optionTooltipLabel)),tooltipPosition:position,run:'click',};}
__exports.changePaddingSize=changePaddingSize;function changePaddingSize(direction){let paddingDirection="n";let position="top";if(direction==="bottom"){paddingDirection="s";position="bottom";}
return{trigger:`:iframe .oe_overlay.o_draggable.o_we_overlay_sticky.oe_active .o_handle.${paddingDirection}`,content:markup(_t("<b>Slide</b> this button to change the %s padding",direction)),tooltipPosition:position,run:"click",};}
__exports.checkIfVisibleOnScreen=checkIfVisibleOnScreen;function checkIfVisibleOnScreen(elementSelector){return{content:"Check if the element is visible on screen",trigger:`${elementSelector}`,run(){const boundingRect=this.anchor.getBoundingClientRect();const centerX=boundingRect.left+boundingRect.width/2;const centerY=boundingRect.top+boundingRect.height/2;const iframeDocument=document.querySelector(".o_iframe").contentDocument;const el=iframeDocument.elementFromPoint(centerX,centerY);if(!this.anchor.contains(el)){console.error("The element is not visible on screen");}},};}
__exports.clickOnElement=clickOnElement;function clickOnElement(elementName,selector){return{content:`Clicking on the ${elementName}`,trigger:selector,run:'click'};}
__exports.clickOnEditAndWaitEditMode=clickOnEditAndWaitEditMode;function clickOnEditAndWaitEditMode(position="bottom"){return[{content:markup(_t("<b>Click Edit</b> to start designing your homepage.")),trigger:"body:not(.editor_has_snippets) .o_menu_systray .o_edit_website_container a",tooltipPosition:position,run:"click",},{content:"Check that we are in edit mode",trigger:".o_website_preview.editor_enable.editor_has_snippets",}];}
__exports.clickOnEditAndWaitEditModeInTranslatedPage=clickOnEditAndWaitEditModeInTranslatedPage;function clickOnEditAndWaitEditModeInTranslatedPage(position="bottom"){return[{content:markup(_t("<b>Click Edit</b> dropdown")),trigger:".o_edit_website_container button",tooltipPosition:position,run:"click",},{content:markup(_t("<b>Click Edit</b> to start designing your homepage.")),trigger:".o_edit_website_dropdown_item",tooltipPosition:position,run:"click",},{content:"Check that we are in edit mode",trigger:".o_website_preview.editor_enable.editor_has_snippets",}];}
__exports.clickOnSnippet=clickOnSnippet;function clickOnSnippet(snippet,position="bottom"){const trigger=snippet.id?`#wrapwrap .${snippet.id}`:snippet;return[{trigger:"body.editor_has_snippets",noPrepend:true,},{trigger:`:iframe ${trigger}`,content:markup(_t("<b>Click on a snippet</b> to access its options menu.")),tooltipPosition:position,run:"click",},];}
__exports.clickOnSave=clickOnSave;function clickOnSave(position="bottom",timeout=50000){return[{trigger:"#oe_snippets:not(:has(.o_we_ongoing_insertion))",},{trigger:"body:not(:has(.o_dialog))",noPrepend:true,},{trigger:"button[data-action=save]:enabled:contains(save)",content:markup(_t("Good job! It's time to <b>Save</b> your work.")),tooltipPosition:position,async run(actions){await waitForStable(document,1000);await actions.click();},timeout,},{trigger:"body:not(.editor_has_dummy_snippets):not(.o_website_navbar_hide):not(.editor_has_snippets):not(:has(.o_notification_bar))",noPrepend:true,timeout,},];}
__exports.clickOnText=clickOnText;function clickOnText(snippet,element,position="bottom"){return[{trigger:":iframe body.editor_enable",},{trigger:snippet.id?`:iframe #wrapwrap .${snippet.id} ${element}`:snippet,content:markup(_t("<b>Click on a text</b> to start editing it.")),tooltipPosition:position,run:"click",},];}
__exports.insertSnippet=insertSnippet;function insertSnippet(snippet,position="bottom"){const blockEl=snippet.groupName||snippet.name;const insertSnippetSteps=[{trigger:".o_website_preview.editor_enable.editor_has_snippets",noPrepend:true,}];if(snippet.groupName){insertSnippetSteps.push({content:markup(_t("Click on the <b>%s</b> category.",blockEl)),trigger:`#oe_snippets .oe_snippet[name="${blockEl}"].o_we_draggable .oe_snippet_thumbnail:not(.o_we_ongoing_insertion)`,tooltipPosition:position,run:"click",},{content:markup(_t("Click on the <b>%s</b> building block.",snippet.name)),trigger:`:iframe .o_snippet_preview_wrap[data-snippet-id="${snippet.id}"]:not(.d-none)`,noPrepend:true,tooltipPosition:"top",run:"click",},{trigger:`#oe_snippets .oe_snippet[name="${blockEl}"].o_we_draggable .oe_snippet_thumbnail:not(.o_we_ongoing_insertion)`,});}else{insertSnippetSteps.push({content:markup(_t("Drag the <b>%s</b> block and drop it at the bottom of the page.",blockEl)),trigger:`#oe_snippets .oe_snippet[name="${blockEl}"].o_we_draggable .oe_snippet_thumbnail:not(.o_we_ongoing_insertion)`,tooltipPosition:position,run:"drag_and_drop :iframe #wrapwrap > footer",});}
return insertSnippetSteps;}
__exports.goBackToBlocks=goBackToBlocks;function goBackToBlocks(position="bottom"){return{trigger:'.o_we_add_snippet_btn',content:_t("Click here to go back to block tab."),tooltipPosition:position,run:"click",};}
__exports.goToTheme=goToTheme;function goToTheme(position="bottom"){return[{trigger:"#oe_snippets.o_loaded",},{trigger:".o_we_customize_theme_btn",content:_t("Go to the Theme tab"),tooltipPosition:position,run:"click",},];}
__exports.selectHeader=selectHeader;function selectHeader(position="bottom"){return{trigger:`:iframe header#top`,content:markup(_t(`<b>Click</b> on this header to configure it.`)),tooltipPosition:position,run:"click",};}
__exports.selectSnippetColumn=selectSnippetColumn;function selectSnippetColumn(snippet,index=0,position="bottom"){return{trigger:`:iframe #wrapwrap .${snippet.id} .row div[class*="col-lg-"]:eq(${index})`,content:markup(_t("<b>Click</b> on this column to access its options.")),tooltipPosition:position,run:"click",};}
__exports.prepend_trigger=prepend_trigger;function prepend_trigger(steps,prepend_text=''){for(const step of steps){if(!step.noPrepend&&prepend_text){step.trigger=prepend_text+step.trigger;}}
return steps;}
__exports.getClientActionUrl=getClientActionUrl;function getClientActionUrl(path,edition){let url=`/odoo/action-website.website_preview`;if(path){url+=`?path=${encodeURIComponent(path)}`;}
if(edition){url+=`${path ? '&' : '?'}enable_editor=1`;}
return url;}
__exports.clickOnExtraMenuItem=clickOnExtraMenuItem;function clickOnExtraMenuItem(stepOptions,backend=false){return Object.assign({content:"Click on the extra menu dropdown toggle if it is there and not shown",trigger:`${
                backend ? ":iframe" : ""
            } ul.top_menu`,run(actions){const extraMenuButton=this.anchor.querySelector(".o_extra_menu_items a.nav-link");if(extraMenuButton&&!extraMenuButton.classList.contains("show")){actions.click(extraMenuButton);}},},stepOptions);}
__exports.registerWebsitePreviewTour=registerWebsitePreviewTour;function registerWebsitePreviewTour(name,options,steps){if(typeof steps!=="function"){throw new Error(`tour.steps has to be a function that returns TourStep[]`);}
registry.category("web_tour.tours").remove(name);return registry.category("web_tour.tours").add(name,{...omit(options,"edition"),url:getClientActionUrl(options.url,!!options.edition),steps:()=>{const tourSteps=[...steps()];if(options.edition){tourSteps.unshift({content:"Wait for the edit mode to be started",trigger:".o_website_preview.editor_enable.editor_has_snippets",timeout:30000,});}else{tourSteps[0].timeout=20000;}
return tourSteps.map((step)=>{delete step.noPrepend;return step;});},});}
__exports.registerThemeHomepageTour=registerThemeHomepageTour;function registerThemeHomepageTour(name,steps){if(typeof steps!=="function"){throw new Error(`tour.steps has to be a function that returns TourStep[]`);}
return registerWebsitePreviewTour("homepage",{url:"/",},()=>[...clickOnEditAndWaitEditMode(),...prepend_trigger(steps().concat(clickOnSave()),".o_website_preview[data-view-xmlid='website.homepage'] "),]);}
__exports.registerBackendAndFrontendTour=registerBackendAndFrontendTour;function registerBackendAndFrontendTour(name,options,steps){if(typeof steps!=="function"){throw new Error(`tour.steps has to be a function that returns TourStep[]`);}
if(window.location.pathname==='/odoo'){return registerWebsitePreviewTour(name,options,()=>{const newSteps=[];for(const step of steps()){const newStep=Object.assign({},step);newStep.trigger=`:iframe ${step.trigger}`;newSteps.push(newStep);}
return newSteps;});}
return registry.category("web_tour.tours").add(name,{url:options.url,steps:()=>{return steps();},});}
__exports.selectElementInWeSelectWidget=selectElementInWeSelectWidget;function selectElementInWeSelectWidget(widgetName,elementName,searchNeeded=false){const steps=[clickOnElement(`${widgetName} toggler`,`we-select[data-name=${widgetName}] we-toggler`)];if(searchNeeded){steps.push({content:`Inputing ${elementName} in m2o widget search`,trigger:`we-select[data-name=${widgetName}] div.o_we_m2o_search input`,run:`edit ${elementName}`,});}
steps.push(clickOnElement(`${elementName} in the ${widgetName} widget`,`we-select[data-name="${widgetName}"] we-button:contains("${elementName}"), `+`we-select[data-name="${widgetName}"] we-button[data-select-label="${elementName}"]`));return steps;}
__exports.switchWebsite=switchWebsite;function switchWebsite(websiteId,websiteName){return[{content:`Click on the website switch to switch to website '${websiteName}'`,trigger:'.o_website_switcher_container button',run:"click",},{trigger:`:iframe html:not([data-website-id="${websiteId}"])`,},{content:`Switch to website '${websiteName}'`,trigger:`.o-dropdown--menu .dropdown-item[data-website-id="${websiteId}"]:contains("${websiteName}")`,run:"click",},{content:"Wait for the iframe to be loaded",timeout:20000,trigger:`:iframe html[data-website-id="${websiteId}"]`,}];}
__exports.testSwitchWebsite=testSwitchWebsite;function testSwitchWebsite(websiteName){const websiteIdMapping=JSON.parse(cookie.get('websiteIdMapping')||'{}');const websiteId=websiteIdMapping[websiteName];return switchWebsite(websiteId,websiteName)}
__exports.toggleMobilePreview=toggleMobilePreview;function toggleMobilePreview(toggleOn){const onOrOff=toggleOn?"on":"off";const mobileOnSelector=".o_is_mobile";const mobileOffSelector=":not(.o_is_mobile)";return[{trigger:`:iframe html${toggleOn ? mobileOffSelector : mobileOnSelector}`,},{content:`Toggle the mobile preview ${onOrOff}`,trigger:".o_we_website_top_actions [data-action='mobile']",run:"click",},{content:`Check that the mobile preview is ${onOrOff}`,trigger:`:iframe html${toggleOn ? mobileOnSelector : mobileOffSelector}`,},];}
return __exports;});;

/* /website/static/src/js/text_processing.js */
odoo.define('@website/js/text_processing',['@web/core/utils/ui','@web_editor/js/editor/odoo-editor/src/utils/utils'],function(require){'use strict';let __exports={};const{isVisible}=require("@web/core/utils/ui");const OdooEditorLib=require("@web_editor/js/editor/odoo-editor/src/utils/utils");const _textHighlightFactory={underline:targetEl=>{return drawPath(targetEl,{mode:"line"});},freehand_1:targetEl=>{const template=(w,h)=>[`M 0,${h * 1.1} C ${w / 8},${h * 1.05} ${w / 4},${h} ${w},${h}`];return drawPath(targetEl,{mode:"free",template});},freehand_2:targetEl=>{const template=(w,h)=>[`M181.27 13.873c-.451-1.976-.993-3.421-1.072-4.9-.125-2.214-.61-4.856.384-6.539.756-1.287 3.636-2.055 5.443-1.852 3.455.395 7.001 1.231`+` 10.14 2.676 1.728.802 3.174 3.06 3.817 4.98.237.712-1.953 2.824-3.399 3.4-2.766 1.095-5.748 1.75-8.706 2.179-2.394.339-4.879.068-6.584.068l-.023-.012ZM8.416 3.90`+`2c3.862.26 7.78.249 11.574.926 1.65.294 3.027 2.033 4.54 3.117-1.095 1.186-1.987 2.982-3.343 3.456a67.118 67.118 0 0 1-11.19 2.823c-3.253.53-6.494-.339-8.617-2.98`+`1C.364 9.978-.302 7.686.138 6.263c.361-1.152 2.54-2 4.077-2.44 1.287-.372 2.789.046 4.2.102v-.023Zm154.267 9.983c-4.291-.305-8.153-1.58-9.915-5.623-.745-1.694-.39`+`5-4.382.474-6.121 1.073-2.168 3.512-1.965 5.613-1.005 2.541 1.174 5.251 2.157 7.509 3.76 1.502 1.073 3.557 3.445 3.207 4.574-.519 1.694-2.857 2.913-4.562 4.133-.5`+`76.406-1.592.203-2.326.282ZM72.58 17.42c-2.733-1.807-5.307-3.004-7.137-4.913-.892-.925-.892-3.376-.361-4.776.407-1.05 2.304-2.112 3.546-2.135 3.602-.056 7.238.215`+` 10.818.723 3.828.542 5.15 4.1 2.213 6.539-2.439 2.021-5.77 2.958-9.079 4.562Zm30.795-.802c-2.507-1.536-5.228-2.823-7.397-4.743-.925-.813-1.377-3.297-.813-4.359.6`+`78-1.265 2.677-2.507 4.11-2.518 3.016-.023 6.155.418 9.001 1.389 1.412.485 3.173 2.552 3.185 3.907 0 1.57-1.423 3.557-2.801 4.619-1.152.892-3.139.711-4.743 1.005-`+`.181.226-.35.463-.531.689l-.011.01Zm-59.704-1.457c-2.066-1.163-4.788-2.224-6.82-4.054-.915-.824-1.04-3.478-.407-4.765.486-.983 2.722-1.559 4.156-1.502 2.676.101 5`+`.398.542 7.95 1.332 1.457.452 3.523 1.75 3.681 2.891.18 1.31-1.13 3.309-2.383 4.201-1.411 1.005-3.466 1.118-6.188 1.886l.011.011Zm88.489-1.863c-2.643-1.48-5.567-2`+`.62-7.803-4.574-1.005-.88-1.31-3.692-.667-5.002.509-1.04 2.982-1.615 4.529-1.513 2.032.135 4.054 1.027 6.007 1.772 2.485.95 5.026 2.236 4.382 5.455-.644 3.15-3.49`+` 2.947-5.963 3.004-.169.293-.327.575-.496.87l.011-.012Z`];return drawPath(targetEl,{mode:"fill",template,SVGWidth:200,SVGHeight:18,position:"bottom"});},freehand_3:targetEl=>{const template=(w,h)=>[`M189.705 18.285c-3.99.994-7.968 2.015-11.958 2.972-1.415.344-2.926 1.008-4.278.727-6.305-1.327-12.568-3.036-18.874-4.376-1.995-.42-4.2`+`46-.701-6.133-.038-5.867 2.067-11.54 2.386-17.374-.242-1.491-.676-3.56-.421-5.125.217-5.523 2.22-10.789 3.597-16.494.127-1.64-.995-4.675-.038-6.584 1.148-6.102 3.`+`789-12.01 4.414-18.198.434-.998-.638-2.681-.638-3.754-.115-6.852 3.355-13.404 2.858-20.043-1.008-1.5-.867-4.02-.6-5.608.307-7.528 4.35-14.842 5.702-22.07-.638-2.1`+`44-1.875-3.71-.37-5.394 1.046-4.622 3.89-9.565 6.327-15.367 4.286C6.338 20.989.505 13.067.022 5.949-.085 4.38.194 1.753.955 1.332 2.253.617 4.537.553 5.588 1.51 7`+`.55 3.27 9.18 5.77 10.52 8.296c2.82 5.269 4.15 5.766 8.504 2.156 1.555-1.288 2.992-2.768 4.396-4.286 4.022-4.311 7.143-4.465 11.26-.472 7.068 6.837 8.226 7.067 15`+`.979 1.314 3.721-2.755 7.206-2.653 10.627.128 4.987 4.056 9.791 4.49 14.853.191 2.702-2.296 5.78-2.296 8.45.115 4.29 3.89 8.45 3.33 12.719.166.847-.638 1.705-1.26`+`3 2.552-1.914 3.035-2.309 6.048-2.5 9.019.166 3.453 3.087 7.12 3.15 10.616.472 4.107-3.138 7.85-3.342 12.16-.306 3.668 2.59 7.83 1.964 11.594-.255 3.935-2.322 7.6`+`67-2.488 11.409.408.365.28.794.612 1.213.65 6.799.549 13.522 3.394 20.428.779 1.887-.715 3.914-1.034 5.899-1.148 3.313-.192 6.659-.358 9.941 0 1.993.23 4.354.905 `+`5.737 2.436 1.308 1.429 2.113 4.235 2.123 6.442.022 3.023-2.424 3.431-4.472 3.597-1.887.153-3.796.038-5.695.038-.053-.216-.106-.446-.16-.663l.032-.025Z`];return drawPath(targetEl,{mode:"fill",template,SVGWidth:200,SVGHeight:24,position:"bottom"});},double:targetEl=>{const template=(w,h)=>[`M 0,${h * 0.9} h ${w}`,`M 0,${h * 1.1} h ${w}`,];return drawPath(targetEl,{mode:"free",template});},wavy:targetEl=>{const template=(w,h)=>[`c ${w / 4},0 ${w / 4},-${h / 2} ${w / 2},-${h / 2}`+`c ${w / 4},0 ${w / 4},${h / 2} ${w / 2},${h / 2}`];return drawPath(targetEl,{mode:"pattern",template});},circle_1:targetEl=>{const template=(w,h)=>[`M ${w / 2.88},${h / 1.1} C ${w / 1.1},${h / 1.05} ${w * 1.05},${h / 1.1} ${w * 1.023},${h / 2.32}`+`C ${w}, ${h / 14.6} ${w / 1.411},0 ${w / 2},0 S -2,${h / 14.6} -2,${h / 2.2}`+`S ${w / 4.24},${h} ${w / 1.36},${h * 1.04}`];return drawPath(targetEl,{mode:"free",template});},circle_2:targetEl=>{const template=(w,h)=>[`M112.58 21.164h18.516c-.478-.176-1.722-.64-2.967-1.105.101-.401.214-.803.315-1.192 12.255 2.912 24.561 5.573 36.716 8.823 5.896 1.582 `+`11.628 3.967 17.171 6.527 10.433 4.832 14.418 14.22 16.479 24.739.377 1.92.566 3.878.83 5.823 2.212 15.94-5.858 23.986-21.595 33.813-.993.615-2.288.79-3.181 1.494`+`-14.229 11.308-31.412 14.32-48.608 17.107-29.01 4.694-57.431 2.209-84.91-8.372-8.145-3.138-16.164-6.853-23.706-11.22C6.176 90.986 1.16 80.053.193 67.25c-1.798-23.`+`809 9.025-42.485 30.356-53.304C44.678 6.793 59.8 3.367 75.45 2.375 90.583 1.42 105.793.379 120.927.78c16.089.427 32.041 3.05 46.911 9.84 2.074.941 3.67 2.912 4.91`+`5 5.083-9.73-1.443-19.433-2.987-29.175-4.305-4.89-.665-9.842-1.067-14.77-1.33-23.82-1.28-47.376.514-70.391 7.003a133.771 133.771 0 0 0-22.639 8.648c-17.9 8.786-27`+`.616 26.935-25.567 46.364.666 6.263 3.507 11.133 9.05 14.308 26.862 15.401 55.748 21.965 86.645 19.819 15.561-1.08 31.01-2.787 45.767-8.284 11.099-4.142 21.658-9.`+`25 30.595-17.195 9.779-8.698 11.715-18.55 5.669-30.249-1.131-2.196-3.256-4.079-5.33-5.56-7.981-5.736-17.773-7.48-26.459-11.534-13.249-6.175-27.541-6.916-41.343-10`+`.167-.817-.188-1.571-.64-2.35-.966.037-.364.088-.728.125-1.092Z`];return drawPath(targetEl,{mode:"fill",template,SVGWidth:200,SVGHeight:120});},circle_3:targetEl=>{const template=(w,h)=>[`M78.653 89.204c-14.815 0-29.403-1.096-43.354-4.698-5.227-1.346-10.407-3.069-14.997-5.199-22.996-10.649-27.04-28.502-9.135-43.035 12.18`+`-9.866 26.813-18.04 43.355-24.242C88.515-.718 124.19-3.725 161.228 4.889c13.224 3.07 24.449 8.268 31.902 16.662 8.862 9.992 9.453 20.422 0 30.068-5.817 5.889-13.2`+`24 11.37-21.359 15.786-27.176 14.752-58.579 21.518-93.072 21.8h-.046Zm3.5-4.228c4.408-.282 11.725-.47 18.86-1.253 30.357-3.351 57.579-11.432 79.211-26.842 5.362-3`+`.82 10.134-8.832 12.27-13.875 2.545-5.982 5.817-13.311-6.226-17.352-.454-.156-.727-.563-1.045-.845-10.771-9.146-25.086-14.157-41.719-15.348-39.674-2.85-76.62 3.19`+`5-109.66 18.762-8.18 3.883-15.497 9.177-21.359 14.752-9.725 9.27-8.044 19.889 3.727 28.032 4.862 3.383 10.997 6.233 17.269 8.237 14.406 4.605 30.04 5.544 48.58 5.`+`763l.092-.03ZM130.37 3.573c-24.813-1.88-48.263 1.378-70.44 9.146 22.814-5.481 46.172-9.02 70.44-9.146Z`];return drawPath(targetEl,{mode:"fill",template,SVGWidth:200,SVGHeight:90});},over_underline:targetEl=>{const template=(w,h)=>[`M 0,0 h ${w}`,`M 0,${h} h ${w}`,];return drawPath(targetEl,{mode:"free",template});},scribble_1:targetEl=>{const template=(w,h)=>[`M ${w / 2},${h * 0.9} c ${w / 16},0 ${w},1 ${w / 5},1 c 2,0 -${w / 10},-2 -${w / 2},-1`+`c -${w / 20},0 -${w / 5},2 -${w / 5},4 c -2,0 ${w / 10},-1 ${w / 2},${h / 16}`+`c ${w / 25},0 ${w / 10},0 ${w / 5},1 c 0,0 -${w / 10},1 -${w / 8},1`+`c -${w / 40},0 -${w / 16},0 -${w / 4},${h / 22}`];return drawPath(targetEl,{mode:"free",template});},scribble_2:targetEl=>{const template=(w,h)=>[`M200 3.985c-.228-.332-3.773.541-.01-.006-.811-.037-6.705-1.442-9.978-1.706-1.473.194-2.907.534-4.351.818-1.398.27-2.937.985-4.144.756-`+`9.56-1.782-19.3-1.089-28.955-1.31C118.932 1.767 85.301.942 51.671.45c-13.732-.201-27.492.333-41.233.665C6.561 1.212 3.026 2.363.84 4.838.09 5.684-.262 7.126.223 7`+`.993c.313.554 2.518.79 3.839.728 2.47-.118 4.922-.548 8.096-.936-.96 1.227-1.568 1.865-1.986 2.558-1.368 2.302.029 4 3.203 4.083 24.716.666 49.424 1.4 74.15 2.01 `+`21.087.52 42.145.34 63.146-1.414 4.495-.374 8.999-.644 14.425-1.026-3.117-1.629-4.723-3.521-8.39-3.535-17.999-.077-36.016-.07-54.005-.534-22.246-.576-44.464-1.58-`+`66.7-2.406-.276-.007-.551-.097-.817-.471 1.016 0 2.033-.021 3.04 0 21.961.506 43.913.998 65.864 1.539 25.249.624 50.47.367 75.642-1.144 5.892-.354 11.765-.93 17.6`+`19-1.54.788-.082 1.416-.99 2.651-1.92Z`];return drawPath(targetEl,{mode:"fill",template,SVGWidth:200,SVGHeight:17,position:"bottom"});},scribble_3:targetEl=>{const template=(w,h)=>[`M133.953 15.961c7.87.502 15.751.975 23.611 1.522 2.027.141 4.055.44 5.999.79 4.118.727 7.202 4.977 2.53 6.707.606.293 1.181.564 1.902.`+`908-8.477 2.069-17.267 2.65-26.203 2.818-19.023.361-38.056.603-57.068 1.088-13.807.355-27.572 1.06-41.369 1.545-3.23.113-6.532.096-9.73-.147-1.548-.118-3.492-.721`+`-4.234-1.42-.93-.88-1.484-2.199-.93-3.1.397-.655 2.812-1.263 4.41-1.33 6.397-.277 12.825-.333 19.243-.474 26.976-.592 53.942-1.156 80.919-1.804 3.742-.09 7.452-.5`+`92 11.173-.908 0-.174-.01-.35-.021-.524-2.717-.197-5.435-.53-8.163-.575-21.865-.383-43.741-1.009-65.607-.936-11.34.04-22.65 1.432-34 2.047-6.898.377-13.88.732-20.`+`779.569-7.044-.17-9.406-3.568-5.34-6.742 3.428-2.677 7.567-4.391 13.984-4.757 16.441-.93 32.798-2.26 49.219-3.27 14.162-.868 28.366-1.516 42.549-2.266.586-.034 1.`+`15-.147 1.641-.45-5.006 0-10.023-.012-15.029.01-1.077 0-2.154.186-3.24.192-18.793.18-37.596.355-56.389.507-10.672.085-21.343.13-32.014.153a65.89 65.89 0 0 1-6.167`+`-.277C1.787 5.555-.02 4.247 0 2.59 0 1.384.89.72 3.293.742c5.874.056 11.748.124 17.622.09C41.045.708 61.186.409 81.317.42c28.408.012 56.827.158 85.225.417 8.686.0`+`8 17.35.7 26.015 1.122 3.23.158 5.832.902 7.024 2.678 1.055 1.572.125 2.21-2.875 1.95a30.51 30.51 0 0 0-2.268-.107c-.397 0-.805.073-1.557.146.721.451 1.306.767 1.`+`777 1.128 2.926 2.238 1.641 4.013-3.272 4.369-13.483.958-26.966 1.91-40.459 2.767-3.334.214-6.752 0-10.118.085-2.31.062-4.609.299-6.909.462l.042.519.011.005Z`];return drawPath(targetEl,{mode:"fill",template,SVGWidth:200,SVGHeight:32,position:"bottom"});},scribble_4:targetEl=>{const template=(w,h)=>[`M96.414 17.157c1.34-2.173 2.462-4.075 3.649-5.944 2.117-3.335 5.528-4.302 9.372-2.694 3.962 1.651 4.89 3.575 3.908 8.073-.205.967-.388`+` 1.934-.022 3.118 1.513-3.075 3.013-6.15 4.557-9.203 1.306-2.586 4.297-3.433 7.859-2.195 2.765.968 4.395 2.706 3.564 5.922-.529 2.054-1.005 4.118-.918 6.487.463-.`+`859 1.015-1.685 1.371-2.586 1.447-3.673 3.002-7.324 4.2-11.083.896-2.792 2.192-3.955 5.323-3.564 4.772.598 7.049 3.412 5.84 7.986-.626 2.38-1.22 4.77-1.144 7.486.`+`745-1.358 1.544-2.683 2.213-4.074a138.72 138.72 0 0 0 2.926-6.487c2.376-5.66 3.12-4.704 8.724-3.618 3.552.685 5.063 4.031 4.34 7.997-.616 3.423-1.166 6.856-1.749 `+`10.29l.95.358c.993-2.151 2.062-4.27 2.958-6.454.594-1.456.886-3.042 1.403-4.53 2.43-6.911 2.43-6.813 9.566-5.542.928.163 2.656-.967 3.078-1.923.992-2.26 2.332-2.7`+`16 4.523-2.097 4.297 1.206 8.659 2.184 12.945 3.444 2.796.826 4.319 2.988 4.135 5.889-.173 2.684-.961 5.324-1.274 8.008-.734 6.4-1.361 12.799-2.019 19.21-.065.673`+`.043 1.38-.097 2.031-.551 2.477-.41 5.465-3.476 6.421-2.311.717-6.489-2.194-7.644-5.03-.206-.5-.357-1.01-.918-2.63-1.22 3.27-2.073 5.629-2.991 7.965-2.095 5.345-3`+`.66 5.954-8.874 3.705-.853-.37-2.354-.783-2.786-.359-3.163 3.075-5.971 1.217-8.853-.358-.378-.207-.81-.316-1.188-.457-5.851 7.65-12.502 4.596-15.061-3.944-1.543 3`+`.042-2.883 5.726-4.265 8.399-3.357 6.53-7.783 6.975-12.47 1.25-.485-.587-.992-1.152-1.511-1.75-5.647 6.715-12.848 2.293-15.19-6.063-1.253 2.25-2.257 3.88-3.099 5.`+`596-1.285 2.64-2.883 4.65-6.23 3.868-3.498-.826-6.532-4.085-6.65-7.225-.054-1.424 0-2.847-.475-4.433-1.393 2.879-2.71 5.802-4.19 8.637-3.228 6.204-6.067 6.824-11.`+`67 2.912-.962-.673-2.57-.988-3.704-.728-3.681.837-6.272-.619-8.626-3.248-.691-.783-2.084-1.771-2.807-1.543-4.243 1.347-6.91-.641-9.166-3.836-.378-.543-.8-1.053-1.`+`555-2.031-1.08 2.194-2.008 4.041-2.915 5.9-2.397 4.943-5.528 5.932-10.02 2.835-2.008-1.38-3.713-2.118-6.37-1.738-5.117.728-8.54-3.444-7.762-8.649.227-1.521.378-3.`+`064-.086-4.9-.853 1.369-1.793 2.684-2.548 4.107-2.775 5.259-5.301 5.856-10.074 2.206-.971-.75-1.803-1.674-2.86-2.673-.67.271-1.598 1.043-2.257.858-2.71-.771-5.625`+`-1.423-7.838-3.01-.842-.608-.378-3.683.108-5.465 2.008-7.41 4.232-14.755 6.413-22.11.572-1.945 1.166-3.901 1.943-5.77 1.89-4.52 5.02-5.454 9.145-2.89 1.144.706 2.`+`408 1.217 3.552 1.923 2.364 1.456 4.696 2.988 7.439 4.737C32.423 7.14 37.444 6.64 42.82 10.41c2.602-2.107 1.803-7.17 6.748-6.323 3.369.587 6.478 1.217 7.439 4.878`+` 2.289-2.281 4.221-5.693 6.877-6.42 2.624-.718 5.992 1.26 9.599 2.216-.044.054.636-.565.96-1.348 1.048-2.499 2.883-3.4 5.42-2.825 2.775.62 5.474 1.304 6.284 4.76.`+`216.89 1.285 2.042 2.159 2.248 7.58 1.793 7.6 1.739 8.108 9.55v.012Z`];return drawPath(targetEl,{mode:"fill",template,SVGWidth:200,SVGHeight:61});},jagged:targetEl=>{const template=(w,h)=>[`q ${4 * w / 3} -${2 * w / 3} ${2 * w / 3} 0`+`c -${w / 3} ${w / 3} -${w / 3} ${w / 3} ${w / 3} 0`];return drawPath(targetEl,{mode:"pattern",template});},cross:targetEl=>{const template=(w,h)=>[`M 0,0 L ${w},${h}`,`M 0,${h} L ${w},0`,];return drawPath(targetEl,{mode:"free",template});},diagonal:targetEl=>{const template=(w,h)=>[`M 0,${h} L${w},0`];return drawPath(targetEl,{mode:"free",template});},strikethrough:targetEl=>{return drawPath(targetEl,{mode:"line",position:"center"});},bold:targetEl=>{const template=(w,h)=>[`M136.604 41.568c5.373.513 10.746 1.047 16.12 1.479 14.437 1.13 29.327 4.047 42.858-4.294 4.92-3.04 2.346-13.56-2.687-13.395-.825.02-1.`+`635.062-2.46.082.858-3.677-.34-8.3-3.545-9.41 2.655.062 5.309.104 7.963.165 6.863.185 6.863-14.176 0-14.36A1958.994 1958.994 0 0 0 5.263 5.778C-.4 6.169-2.392 18.`+`455 3.84 19.893c9.727 2.24 19.454 4.335 29.214 6.307-1.085 1.09-1.764 2.671-2.023 4.356-.615.061-1.214.102-1.83.164-6.748.74-6.959 14.587 0 14.361l107.42-3.513h-.`+`016Z`];return drawPath(targetEl,{mode:"fill",template,SVGWidth:200,SVGHeight:46});},bold_1:targetEl=>{const template=(w,h)=>[`M190.276 34.01c5.618-.25 7.136-6.526 4.444-9.755.037-.25.055-.5.072-.749 7.046-.949 7.01-11.752-.523-11.553-.796.017-1.59.017-2.403.05`+`C196.78 9.573 195.931.8 189.264.983L13.784 5.678c-7.226.2-7.497 9.422-1.499 11.32-2.186 0-4.354 0-6.54-.017-7.696-.05-7.624 11.286 0 11.635 8.22.383 16.423.733 24`+`.643 1.016l-7.823.35c-7.624.349-7.678 11.985 0 11.635 55.915-2.53 111.813-5.077 167.729-7.607h-.018Z`];return drawPath(targetEl,{mode:"fill",template,SVGWidth:200,SVGHeight:42});},bold_2:targetEl=>{const template=(w,h)=>[`M193.221 20.193c.555 1.245.863 2.005 1.22 2.734 1.399 2.84 2.758 5.757 1.607 9.509-1.21 3.95-3.651 4.208-6.072 4.314-5.059.212-10.129.`+`152-15.178.592-15.873 1.367-31.737 3.585-47.619 4.238-19.921.82-39.862.638-59.802.486-13.938-.106-27.887-.88-41.825-1.428-4.018-.151-8.046-.47-12.064-.896-2.758-.`+`304-4.772-2.46-6.21-6.182-.645-1.656-1.756-2.993-2.798-4.177-2.768-3.13-5.06-6.38-3.899-12.502C.9 15.226.393 13.16.165 11.307c-.715-5.818.903-9.524 4.722-9.646 10`+`.218-.35 20.437-.38 30.655-.577C51.236.78 66.94-.04 82.635.264c14.652.273 29.296 1.655 43.948 2.643 19.822 1.336 39.643 2.02 59.455-.426.923-.121 1.835-.5 2.758-.`+`622 1.329-.183 2.688-.456 4.008-.274 3.829.501 7.073 5.666 7.192 11.21.09 4.466-1.418 6.213-6.775 7.428v-.03Z`];return drawPath(targetEl,{mode:"fill",template,SVGWidth:200,SVGHeight:43});},};const getDOMRectWidth=__exports.getDOMRectWidth=el=>el.getBoundingClientRect().width;function drawPath(textEl,options){const width=textEl.offsetWidth;const height=textEl.offsetHeight;options={...options,width,height};const yStart=options.position==="center"?height/2:height;switch(options.mode){case"pattern":{let i=0,d=[];const nbrChars=textEl.textContent.length;const w=width/nbrChars,h=height*0.2;while(i<nbrChars){d.push(options.template(w,h));i++;}
return buildPath([`M 0,${yStart} ${d.join(" ")}`],options);}
case"line":{return buildPath([`M 0,${yStart} h ${width}`],options);}}
return buildPath(options.template(width,height),options);}
function buildPath(templates,options){return templates.map(d=>{const path=document.createElementNS("http://www.w3.org/2000/svg","path");path.setAttribute("stroke-width","var(--text-highlight-width)");path.setAttribute("stroke","var(--text-highlight-color)");path.setAttribute("stroke-linecap","round");if(options.mode==="fill"){let wScale=options.width/options.SVGWidth;let hScale=options.height/options.SVGHeight;const transforms=[];if(options.position==="bottom"){hScale*=0.3;transforms.push(`translate(0 ${options.height * 0.8})`);}
transforms.push(`scale(${wScale}, ${hScale})`);path.setAttribute("fill","var(--text-highlight-color)");path.setAttribute("transform",transforms.join(" "));}
path.setAttribute("d",d);return path;});}
__exports.drawTextHighlightSVG=drawTextHighlightSVG;function drawTextHighlightSVG(textEl,highlightID){const svg=document.createElementNS("http://www.w3.org/2000/svg","svg");svg.setAttribute("fill","none");svg.classList.add("o_text_highlight_svg","o_content_no_merge","position-absolute","overflow-visible","top-0","start-0","w-100","h-100","pe-none");_textHighlightFactory[highlightID](textEl).forEach(pathEl=>{pathEl.classList.add(`o_text_highlight_path_${highlightID}`);svg.appendChild(pathEl);});return svg;}
__exports.applyTextHighlight=applyTextHighlight;function applyTextHighlight(topTextEl,highlightID){const endHighlightUpdate=()=>topTextEl.dispatchEvent(new Event("text_highlight_added",{bubbles:true}));if(topTextEl.querySelector(".o_text_highlight_item")||!isVisible(topTextEl)){return endHighlightUpdate();}
const style=window.getComputedStyle(topTextEl);if(!style.getPropertyValue("--text-highlight-width")){topTextEl.style.setProperty("--text-highlight-width",`${Math.round(parseFloat(style.fontSize) * 0.1)}px`);}
const lines=[];let lineIndex=0;const nodeIsBR=node=>node.nodeName==="BR";const isRTL=el=>window.getComputedStyle(el).direction==="rtl";[...topTextEl.childNodes].forEach(child=>{if(nodeIsBR(child)){lines[++lineIndex]=[child];return lineIndex++;}
const textLines=splitNodeLines(child);let lastNodeInLine=false;if(child.textContent&&child.nextSibling?.textContent){const range=document.createRange();const lastCurrentText=selectAllTextNodes(child).at(-1);range.setStart(lastCurrentText,lastCurrentText.length-1);range.setEnd(lastCurrentText,lastCurrentText.length);const currentEnd=range.getBoundingClientRect()[isRTL(topTextEl)?"left":"right"];const firstnextText=selectAllTextNodes(child.nextSibling)[0];range.setStart(firstnextText,0);range.setEnd(firstnextText,1);const nextStart=range.getBoundingClientRect()[isRTL(topTextEl)?"right":"left"];lastNodeInLine=nextStart+1<currentEnd;}
textLines.map((node,i,{length})=>{if(!lines[lineIndex]){lines[lineIndex]=[];}
lines[lineIndex].push(node);if(i!==length-1||lastNodeInLine){lineIndex++;}});});topTextEl.replaceChildren(...lines.map(textLine=>{return nodeIsBR(textLine[0])?textLine[0]:createHighlightContainer(textLine);}));[...topTextEl.querySelectorAll(".o_text_highlight_item")].forEach(container=>{container.append(drawTextHighlightSVG(container,highlightID||getCurrentTextHighlight(topTextEl)));});endHighlightUpdate();}
__exports.removeTextHighlight=removeTextHighlight;function removeTextHighlight(topTextEl){topTextEl.dispatchEvent(new Event("text_highlight_remove",{bubbles:true}));[...topTextEl.querySelectorAll(".o_text_highlight_item")].forEach(unit=>{unit.after(...[...unit.childNodes].filter((node)=>node.tagName!=="svg"));unit.remove();});let child=topTextEl.firstElementChild;while(child){let next=child.nextElementSibling;if(next&&next===child.nextSibling&&child.cloneNode().isEqualNode(next.cloneNode())){child.replaceChildren(...child.childNodes,...next.childNodes);next.remove();}else{child=next;}}
topTextEl.normalize();}
__exports.switchTextHighlight=switchTextHighlight;function switchTextHighlight(textEl,highlightID){if(!isVisible(textEl)){return;}
highlightID=highlightID||getCurrentTextHighlight(textEl);const ownerDocument=textEl.ownerDocument;const sel=ownerDocument.getSelection();const restoreSelection=sel.rangeCount===1&&textEl.contains(sel.anchorNode);let rangeCollapsed,cursorEndPosition=0,rangeSize=0;if(restoreSelection){const range=sel.getRangeAt(0);rangeSize=range.toString().length;rangeCollapsed=range.collapsed;const globalRange=range.cloneRange();globalRange.selectNodeContents(textEl);globalRange.setEnd(range.endContainer,range.endOffset);cursorEndPosition=globalRange.toString().length;}
if(highlightID){removeTextHighlight(textEl);applyTextHighlight(textEl,highlightID);}
if(restoreSelection&&cursorEndPosition){if(rangeCollapsed){const selectionOffset=getOffsetNode(textEl,cursorEndPosition);OdooEditorLib.setSelection(...selectionOffset,...selectionOffset);}else{OdooEditorLib.setSelection(...getOffsetNode(textEl,cursorEndPosition-rangeSize),...getOffsetNode(textEl,cursorEndPosition));}}}
function createHighlightContainer(nodes){const highlightContainer=document.createElement("span");highlightContainer.className="o_text_highlight_item";highlightContainer.append(...nodes);return highlightContainer;}
__exports.getCurrentTextHighlight=getCurrentTextHighlight;function getCurrentTextHighlight(el){const topTextEl=el.closest(".o_text_highlight");const match=topTextEl?.className.match(/o_text_highlight_(?<value>[\w]+)/);let highlight="";if(match){highlight=match.groups.value;}
return highlight;}
function splitNodeLines(node){const isTextContainer=node.childNodes.length===1&&node.firstChild.nodeType===Node.TEXT_NODE;if(node.nodeType!==Node.TEXT_NODE&&!isTextContainer){return[node];}
const text=node.textContent;const textNode=isTextContainer?node.firstChild:node;const lines=[];const range=document.createRange();let i=-1;while(++i<text.length){range.setStart(textNode,0);range.setEnd(textNode,i+1);const clientRects=range.getClientRects().length||1;const lineIndex=clientRects-1;const currentText=lines[lineIndex];lines[lineIndex]=(currentText||"")+text.charAt(i);}
if(lines.length===1){return[node];}
return lines.map(line=>{if(isTextContainer){const wrapper=node.cloneNode();wrapper.appendChild(document.createTextNode(line));return wrapper;}
return document.createTextNode(line);});}
__exports.selectAllTextNodes=selectAllTextNodes;function selectAllTextNodes(topNode){const textNodes=[];const selectTextNodes=(node)=>{if(node.nodeType===Node.TEXT_NODE){textNodes.push(node);}else{[...node.childNodes].forEach(child=>selectTextNodes(child));}};selectTextNodes(topNode);return textNodes;}
__exports.getOffsetNode=getOffsetNode;function getOffsetNode(textEl,offset){let index=0,offsetNode;for(const node of selectAllTextNodes(textEl)){const stepLength=node.textContent.length;if(index+stepLength<offset-1){index+=stepLength;}else{offsetNode=node;break;}}
return[offsetNode,offset-index];}
return __exports;});;

/* /website/static/src/client_actions/configurator/configurator.js */
odoo.define('@website/client_actions/configurator/configurator',['@web/core/browser/browser','@web/core/autocomplete/autocomplete','@web/core/utils/concurrency','@web/core/utils/urls','@web_editor/js/common/utils','@web/core/l10n/translation','@website/js/utils','@web/core/utils/hooks','@web/core/registry','@web/core/network/rpc','@web/core/utils/colors','@web/core/browser/router','@odoo/owl','@web/webclient/actions/action_service','@web/core/utils/ui'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const sessionStorage=browser.sessionStorage;const{AutoComplete}=require("@web/core/autocomplete/autocomplete");const{delay}=require("@web/core/utils/concurrency");const{getDataURLFromFile,redirect}=require("@web/core/utils/urls");const weUtils=require('@web_editor/js/common/utils')[Symbol.for("default")];const{_t}=require("@web/core/l10n/translation");const{svgToPNG,webpToPNG}=require("@website/js/utils");const{useService}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const{rpc}=require("@web/core/network/rpc");const{mixCssColors}=require('@web/core/utils/colors');const{router}=require("@web/core/browser/router");const{Component,onMounted,reactive,useEffect,useEnv,useRef,useState,useSubEnv,onWillStart,useExternalListener,}=require("@odoo/owl");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");const{addLoadingEffect:addButtonLoadingEffect}=require("@web/core/utils/ui");const ROUTES=__exports.ROUTES={descriptionScreen:2,paletteSelectionScreen:3,featuresSelectionScreen:4,themeSelectionScreen:5,};const WEBSITE_TYPES=__exports.WEBSITE_TYPES={1:{id:1,label:_t("a business website"),name:'business'},2:{id:2,label:_t("an online store"),name:'online_store'},3:{id:3,label:_t("a blog"),name:'blog'},4:{id:4,label:_t("an event website"),name:'event'},5:{id:5,label:_t("an elearning platform"),name:'elearning'},};const WEBSITE_PURPOSES=__exports.WEBSITE_PURPOSES={1:{id:1,label:_t("get leads"),name:'get_leads'},2:{id:2,label:_t("develop the brand"),name:'develop_brand'},3:{id:3,label:_t("sell more"),name:'sell_more'},4:{id:4,label:_t("inform customers"),name:'inform_customers'},5:{id:5,label:_t("schedule appointments"),name:'schedule_appointments'},};const PALETTE_NAMES=__exports.PALETTE_NAMES=['default-light-1','default-light-2','default-light-4','default-light-3','default-light-5','default-24','default-light-7','default-light-6','default-light-11','default-light-14','default-light-8','default-6','default-7','default-8','default-9','default-23','default-25','default-12','default-14','default-22','default-15','default-16','default-17','default-light-10','default-19','default-20','default-5','default-4','default-light-9','default-2','default-light-13','default-27','default-light-12','default-1','default-28','default-21',];const CUSTOM_BG_COLOR_ATTRS=__exports.CUSTOM_BG_COLOR_ATTRS=["menu","footer"];const MAX_NBR_DISPLAY_MAIN_THEMES=3;async function getRecommendedThemes(orm,state,resultNbrMax=MAX_NBR_DISPLAY_MAIN_THEMES){return orm.call("website","configurator_recommended_themes",[],{"industry_id":state.selectedIndustry.id,"palette":state.selectedPalette,"result_nbr_max":resultNbrMax,},);}
const SkipButton=__exports.SkipButton=class SkipButton extends Component{static template="website.Configurator.SkipButton";static props={skip:Function,};}
const WelcomeScreen=__exports.WelcomeScreen=class WelcomeScreen extends Component{static template="website.Configurator.WelcomeScreen";static components={SkipButton};static props={skip:Function,navigate:Function,};setup(){this.state=useStore();}
goToDescription(){this.props.navigate(ROUTES.descriptionScreen);}}
const IndustrySelectionAutoComplete=__exports.IndustrySelectionAutoComplete=class IndustrySelectionAutoComplete extends AutoComplete{static timeout=400;get dropdownOptions(){return{...super.dropdownOptions,position:"bottom-fit",};}
get ulDropdownClass(){return`${super.ulDropdownClass} custom-ui-autocomplete shadow-lg border-0 o_configurator_show_fast o_configurator_industry_dropdown`;}}
const DescriptionScreen=__exports.DescriptionScreen=class DescriptionScreen extends Component{static template='website.Configurator.DescriptionScreen';static components={SkipButton,AutoComplete:IndustrySelectionAutoComplete};static props={navigate:Function,skip:Function,};setup(){this.industrySelection=useRef('industrySelection');this.state=useStore();this.orm=useService('orm');onMounted(()=>this.onMounted());}
onMounted(){this.selectWebsitePurpose();}
_setSelectedIndustry(suggestion){const{label,id}=Object.getPrototypeOf(suggestion);this.state.selectIndustry(label,id);this.checkDescriptionCompletion();}
get sources(){return[{options:(request)=>{return request.length<1?[]:this._autocompleteSearch(request);},},];}
_autocompleteSearch(term){const terms=term.toLowerCase().split(/[|,\n]+/);const limit=30;const sortLimit=7;let matches=this.state.industries.filter((val,index)=>{for(const candidate of[val.label,...(val.synonyms||'').split(/[|,\n]+/)]){if(terms.every(term=>candidate.toLowerCase().includes(term))){return true;}}});if(matches.length>limit){matches=matches.sort((x,y)=>x.wordCount-y.wordCount).slice(0,limit).sort((x,y)=>x.hitCountOrder-y.hitCountOrder);}
if(matches.length<=sortLimit){matches=matches.sort((x,y)=>(x.label<y.label?-1:x.label>y.label?1:0));}
return matches.length?matches:[{label:term,id:-1}];}
selectWebsiteType(id){this.state.selectWebsiteType(id);setTimeout(()=>{this.industrySelection.el.querySelector("input").focus();});this.checkDescriptionCompletion();}
selectWebsitePurpose(id){this.state.selectWebsitePurpose(id);this.checkDescriptionCompletion();}
checkDescriptionCompletion(){const{selectedType,selectedPurpose,selectedIndustry}=this.state;if(selectedType&&selectedPurpose&&selectedIndustry){if(selectedIndustry.id===-1){this.orm.call('website','configurator_missing_industry',[],{'unknown_industry':selectedIndustry.label,});}
this.props.navigate(ROUTES.paletteSelectionScreen);}}}
const PaletteSelectionScreen=__exports.PaletteSelectionScreen=class PaletteSelectionScreen extends Component{static components={SkipButton};static template='website.Configurator.PaletteSelectionScreen';static props={navigate:Function,skip:Function,};setup(){this.state=useStore();this.logoInputRef=useRef('logoSelectionInput');this.notification=useService("notification");this.orm=useService('orm');onMounted(()=>{if(this.state.logo){this.updatePalettes();}});}
uploadLogo(){this.logoInputRef.el.click();}
async removeLogo(ev){ev.stopPropagation();this.logoInputRef.el.value="";if(this.state.logoAttachmentId){await this._removeAttachments([this.state.logoAttachmentId]);}
this.state.changeLogo();this.state.setRecommendedPalette();}
async changeLogo(){const logoSelectInput=this.logoInputRef.el;if(logoSelectInput.files.length===1){const previousLogoAttachmentId=this.state.logoAttachmentId;const file=logoSelectInput.files[0];if(file.size>2500000){this.notification.add(_t("The logo is too large. Please upload a logo smaller than 2.5 MB."),{title:file.name,type:"warning",});return;}
const data=await getDataURLFromFile(file);const attachment=await rpc('/web_editor/attachment/add_data',{'name':'logo','data':data.split(',')[1],'is_image':true,});if(!attachment.error){if(previousLogoAttachmentId){await this._removeAttachments([previousLogoAttachmentId]);}
this.state.changeLogo(data,attachment.id);this.updatePalettes();}else{this.notification.add(attachment.error,{title:file.name,});}}}
async updatePalettes(){let img=this.state.logo;if(img.startsWith('data:image/svg+xml')){img=await svgToPNG(img);}
if(img.startsWith('data:image/webp')){img=await webpToPNG(img);}
img=img.split(',')[1];const[color1,color2]=await this.orm.call('base.document.layout','extract_image_primary_secondary_colors',[img],{mitigate:255},);this.state.setRecommendedPalette(color1,color2);}
selectPalette(paletteName){this.state.selectPalette(paletteName);this.props.navigate(ROUTES.featuresSelectionScreen);}
async _removeAttachments(ids){rpc("/web_editor/attachment/remove",{ids:ids});}}
const ApplyConfiguratorScreen=__exports.ApplyConfiguratorScreen=class ApplyConfiguratorScreen extends Component{static template="";static props=["*"];setup(){this.websiteService=useService('website');}
async applyConfigurator(themeName){if(!this.state.selectedIndustry){return this.props.navigate(ROUTES.descriptionScreen);}
if(!this.state.selectedPalette){return this.props.navigate(ROUTES.paletteSelectionScreen);}
const attemptConfiguratorApply=async(data,retryCount=0)=>{try{return await this.orm.silent.call('website','configurator_apply',[],data);}catch(error){await delay(5000);if(retryCount<3){return attemptConfiguratorApply(data,retryCount+1);}
document.querySelector('.o_website_loader_container').remove();throw error;}};if(themeName!==undefined){const selectedFeatures=Object.values(this.state.features).filter((feature)=>feature.selected).map((feature)=>feature.id);this.websiteService.showLoader({showTips:true,selectedFeatures:selectedFeatures,showWaitingMessages:true,});let selectedPalette=this.state.selectedPalette.name;if(!selectedPalette){selectedPalette=[this.state.selectedPalette.color1,this.state.selectedPalette.color2,this.state.selectedPalette.color3,this.state.selectedPalette.color4,this.state.selectedPalette.color5,];}
const data={'selected_features':selectedFeatures,'industry_id':this.state.selectedIndustry.id,'industry_name':this.state.selectedIndustry.label.toLowerCase(),'selected_palette':selectedPalette,'theme_name':themeName,'website_purpose':WEBSITE_PURPOSES[this.state.selectedPurpose||this.state.formerSelectedPurpose].name,'website_type':WEBSITE_TYPES[this.state.selectedType].name,'logo_attachment_id':this.state.logoAttachmentId,};const resp=await attemptConfiguratorApply(data);this.props.clearStorage();this.websiteService.prepareOutLoader();redirect(`/odoo/action-website.website_preview?website_id=${encodeURIComponent(resp.website_id)}`);}}}
const FeaturesSelectionScreen=__exports.FeaturesSelectionScreen=class FeaturesSelectionScreen extends ApplyConfiguratorScreen{static components={SkipButton};static template='website.Configurator.FeatureSelection';setup(){super.setup();this.orm=useService("orm");this.state=useStore();}
async buildWebsite(){const industryId=this.state.selectedIndustry&&this.state.selectedIndustry.id;if(!industryId){return this.props.navigate(ROUTES.descriptionScreen);}
const themes=await getRecommendedThemes(this.orm,this.state);if(!themes.length){await this.applyConfigurator('theme_default');}else{this.state.updateRecommendedThemes(themes);this.props.navigate(ROUTES.themeSelectionScreen);}}}
const ThemeSelectionScreen=__exports.ThemeSelectionScreen=class ThemeSelectionScreen extends ApplyConfiguratorScreen{static template="website.Configurator.ThemeSelectionScreen";setup(){super.setup();this.uiService=useService('ui');this.orm=useService('orm');this.maxNbrDisplayExtraThemes=100;const env=useEnv();env.store["extraThemesLoaded"]=false;env.store["extraThemes"]=[];this.state=useState(env.store);this.themeSVGPreviews=[useRef('ThemePreview1'),useRef('ThemePreview2'),useRef('ThemePreview3')];this.extraThemesButtonRef=useRef("extraThemesButton");this.extraThemeSVGPreviews=[];for(let i=0;i<this.maxNbrDisplayExtraThemes;i++){this.extraThemeSVGPreviews.push(useRef(`ExtraThemePreview${i}`));}
onMounted(()=>{this.blockUiDuringImageLoading(this.state.themes,this.themeSVGPreviews);});useEffect(()=>this.blockUiDuringImageLoading(this.state.extraThemes,this.extraThemeSVGPreviews),()=>[this.state.extraThemes]);}
get showViewMoreThemesButton(){return!this.state.extraThemesLoaded&&this.state.themes.length===MAX_NBR_DISPLAY_MAIN_THEMES;}
blockUiDuringImageLoading(themes,themeSVGPreviews){if(!themes.length){return;}
const proms=[];this.uiService.block({delay:700});themes.forEach((theme,idx)=>{const svgEl=new DOMParser().parseFromString(theme.svg,"image/svg+xml").documentElement;for(const imgEl of svgEl.querySelectorAll("image")){proms.push(new Promise((resolve,reject)=>{imgEl.addEventListener("load",()=>{resolve(imgEl);},{once:true});imgEl.addEventListener("error",()=>{reject(imgEl);},{once:true});}));}
themeSVGPreviews[idx].el.appendChild(svgEl);});Promise.allSettled(proms).then(()=>{this.uiService.unblock();});}
async chooseTheme(themeName){await this.applyConfigurator(themeName);}
async getMoreThemes(){const removeLoadingEffect=addButtonLoadingEffect(this.extraThemesButtonRef.el);const themes=await getRecommendedThemes(this.orm,this.state,this.maxNbrDisplayExtraThemes);const mainThemeNames=this.state.themes.map((theme)=>theme.name);this.state.extraThemes=themes.filter((extraTheme)=>!mainThemeNames.includes(extraTheme.name));this.state.extraThemesLoaded=true;removeLoadingEffect();}
getExtraThemeName(idx){return this.state.extraThemes.length>idx&&this.state.extraThemes[idx].name;}}
const Store=__exports.Store=class Store{async start(getInitialState){Object.assign(this,await getInitialState());}
getWebsiteTypes(){return Object.values(WEBSITE_TYPES);}
getSelectedType(id){return id&&WEBSITE_TYPES[id];}
getWebsitePurpose(){return Object.values(WEBSITE_PURPOSES);}
getSelectedPurpose(id){return id&&WEBSITE_PURPOSES[id];}
getFeatures(){return Object.values(this.features);}
getPalettes(){return Object.values(this.palettes);}
getThemeName(idx){return this.themes.length>idx&&this.themes[idx].name;}
getSelectedPaletteName(){const palette=this.selectedPalette;return palette?(palette.name||'recommendedPalette'):false;}
selectWebsiteType(id){Object.values(this.features).filter((feature)=>feature.module_state!=='installed').forEach((feature)=>{feature.selected=feature.website_config_preselection.includes(WEBSITE_TYPES[id].name);});this.selectedType=id;}
selectWebsitePurpose(id){if(!id&&this.selectedPurpose){this.formerSelectedPurpose=this.selectedPurpose;}
Object.values(this.features).filter((feature)=>feature.module_state!=='installed').forEach((feature)=>{feature.selected|=id&&feature.website_config_preselection.includes(WEBSITE_PURPOSES[id].name);});this.selectedPurpose=id;}
selectIndustry(label,id){if(!label||!id){this.selectedIndustry=undefined;}else{this.selectedIndustry={id,label};}}
changeLogo(data,attachmentId){this.logo=data;this.logoAttachmentId=attachmentId;}
selectPalette(paletteName){if(paletteName==='recommendedPalette'){this.selectedPalette=this.recommendedPalette;}else{this.selectedPalette=this.palettes[paletteName];}}
toggleFeature(featureId){const feature=this.features[featureId];const isModuleInstalled=feature.module_state==='installed';feature.selected=!feature.selected||isModuleInstalled;}
setRecommendedPalette(color1,color2){if(color1&&color2){if(color1===color2){color2=mixCssColors('#FFFFFF',color1,0.2);}
const recommendedPalette={color1:color1,color2:color2,color3:mixCssColors('#FFFFFF',color2,0.9),color4:'#FFFFFF',color5:mixCssColors(color1,'#000000',0.125),};CUSTOM_BG_COLOR_ATTRS.forEach((attr)=>{recommendedPalette[attr]=recommendedPalette[this.defaultColors[attr]];});this.recommendedPalette=recommendedPalette;}else{this.recommendedPalette=undefined;}
this.selectedPalette=this.recommendedPalette;}
updateRecommendedThemes(themes){this.themes=themes.slice(0,MAX_NBR_DISPLAY_MAIN_THEMES);}}
function useStore(){const env=useEnv();return useState(env.store);}
const Configurator=__exports.Configurator=class Configurator extends Component{static components={WelcomeScreen,DescriptionScreen,PaletteSelectionScreen,FeaturesSelectionScreen,ThemeSelectionScreen,};static template='website.Configurator.Configurator';static props={...standardActionServiceProps};setup(){this.orm=useService('orm');this.action=useService('action');useExternalListener(window,"popstate",(ev)=>{if(ev.state&&"configuratorStep"in ev.state){this.state.currentStep=ev.state.configuratorStep;}});const initialStep=this.props.action.context.params&&this.props.action.context.params.step;const store=reactive(new Store(),()=>this.updateStorage(store));this.state=useState({currentStep:initialStep,});useSubEnv({store});onWillStart(async()=>{this.websiteId=(await this.orm.call('website','get_current_website')).match(/\d+/)[0];await store.start(()=>this.getInitialState());this.updateStorage(store);if(!store.industries){await this.skipConfigurator();}});onMounted(()=>{setTimeout(()=>{router.cancelPushes();this.updateBrowserUrl();});});}
get pathname(){return`/website/configurator${this.state.currentStep ? `/${encodeURIComponent(this.state.currentStep)}` : ''}`;}
get storageItemName(){return`websiteConfigurator${this.websiteId}`;}
updateBrowserUrl(){history.pushState({skipRouteChange:true,configuratorStep:this.state.currentStep},'',this.pathname);}
navigate(step,reload=false){this.state.currentStep=step;if(reload){redirect(this.pathname);}else{this.updateBrowserUrl();}}
clearStorage(){sessionStorage.removeItem(this.storageItemName);}
async getInitialState(){var results=await this.orm.call('website','configurator_init');const r={industries:results.industries,logo:results.logo?'data:image/png;base64,'+results.logo:false,};r.industries=r.industries.map((industry,index)=>({...industry,wordCount:industry.label.split(" ").length,hitCountOrder:index,}));const palettes={};const style=window.getComputedStyle(document.documentElement);PALETTE_NAMES.forEach((paletteName)=>{const palette={name:paletteName};for(let j=1;j<=5;j+=1){palette[`color${j}`]=weUtils.getCSSVariableValue(`o-palette-${paletteName}-o-color-${j}`,style);}
CUSTOM_BG_COLOR_ATTRS.forEach((attr)=>{palette[attr]=weUtils.getCSSVariableValue(`o-palette-${paletteName}-${attr}-bg`,style);});palettes[paletteName]=palette;});const localState=JSON.parse(sessionStorage.getItem(this.storageItemName));if(localState){let themes=[];if(localState.selectedIndustry&&localState.selectedPalette){themes=await getRecommendedThemes(this.orm,localState);}
return Object.assign(r,{...localState,palettes,themes});}
const features={};results.features.forEach(feature=>{features[feature.id]=Object.assign({},feature,{selected:feature.module_state==='installed'});const wtp=features[feature.id]['website_config_preselection'];features[feature.id]['website_config_preselection']=wtp?wtp.split(','):[];});const defaultColors={};CUSTOM_BG_COLOR_ATTRS.forEach((attr)=>{const color=weUtils.getCSSVariableValue(`o-default-${attr}-bg`,style);const match=color.match(/o-color-(?<idx>[1-5])/);const colorIdx=parseInt(match.groups['idx']);defaultColors[attr]=`color${colorIdx}`;});return Object.assign(r,{selectedType:undefined,selectedPurpose:undefined,formerSelectedPurpose:undefined,selectedIndustry:undefined,selectedPalette:undefined,recommendedPalette:undefined,defaultColors:defaultColors,palettes:palettes,features:features,themes:[],logoAttachmentId:undefined,});}
updateStorage(state){const newState=JSON.stringify({defaultColors:state.defaultColors,features:state.features,logo:state.logo,logoAttachmentId:state.logoAttachmentId,selectedIndustry:state.selectedIndustry,selectedPalette:state.selectedPalette,selectedPurpose:state.selectedPurpose,formerSelectedPurpose:state.formerSelectedPurpose,selectedType:state.selectedType,recommendedPalette:state.recommendedPalette,});sessionStorage.setItem(this.storageItemName,newState);}
async skipConfigurator(){await this.orm.call('website','configurator_skip');this.clearStorage();this.action.doAction('website.theme_install_kanban_action',{clearBreadcrumbs:true,});}}
registry.category('actions').add('website_configurator',Configurator);return __exports;});;

/* /website/static/src/client_actions/open_custom_menu/open_custom_menu.js */
odoo.define('@website/client_actions/open_custom_menu/open_custom_menu',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");__exports.openCustomMenu=openCustomMenu;async function openCustomMenu(env,action){const websiteCustomMenus=env.services["website_custom_menus"];const websiteMenu=websiteCustomMenus.get(action.context.xmlid);if(websiteMenu){websiteCustomMenus.open({xmlid:action.context.xmlid});}}
registry.category("actions").add("open_website_custom_menu",openCustomMenu);return __exports;});;

/* /website/static/src/client_actions/website_dashboard/website_dashboard.js */
odoo.define('@website/client_actions/website_dashboard/website_dashboard',['@web/core/network/rpc','@web/core/registry','@web/search/layout','@odoo/owl','@web/core/utils/concurrency','@web/views/widgets/documentation_link/documentation_link'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{Layout}=require("@web/search/layout");const{Component,useEffect,useState}=require("@odoo/owl");const{KeepLast}=require("@web/core/utils/concurrency");const{DocumentationLink}=require("@web/views/widgets/documentation_link/documentation_link");class WebsiteDashboard extends Component{static template="website.WebsiteDashboardMain";static components={Layout,DocumentationLink};static props=["*"];setup(){super.setup();this.keepLast=new KeepLast();this.state=useState({website:false,groups:{},websites:[],dashboards:{},});useEffect(()=>{this.fetchData();},()=>[this.state.website]);}
get display(){return{controlPanel:{},};}
async fetchData(){const dashboardData=await this.keepLast.add(rpc("/website/fetch_dashboard_data",{website_id:this.state.website,}));Object.assign(this.state,dashboardData);}}
registry.category("actions").add("backend_dashboard",WebsiteDashboard);return __exports;});;

/* /website/static/src/client_actions/website_preview/website_preview.js */
odoo.define('@website/client_actions/website_preview/website_preview',['@web/core/l10n/translation','@web/core/browser/browser','@web/core/registry','@web/core/resizable_panel/resizable_panel','@web/core/utils/hooks','@web/core/utils/urls','@web/session','@website/components/resource_editor/resource_editor','@website/components/editor/editor','@website/components/translator/translator','@website/services/website_service','@website/components/dialog/seo','@website/components/dialog/dialog','@web/core/hotkeys/hotkey_service','@website/js/utils','@web/core/utils/render','@web/core/ui/ui_service','@web/webclient/actions/action_service','@odoo/owl','@web/core/utils/scrolling','@web/core/browser/feature_detection'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{browser}=require('@web/core/browser/browser');const{registry}=require('@web/core/registry');const{ResizablePanel}=require('@web/core/resizable_panel/resizable_panel');const{useService,useBus}=require('@web/core/utils/hooks');const{redirect}=require("@web/core/utils/urls");const{session}=require("@web/session");const{ResourceEditor}=require("@website/components/resource_editor/resource_editor");const{WebsiteEditorComponent}=require("@website/components/editor/editor");const{WebsiteTranslator}=require("@website/components/translator/translator");const{unslugHtmlDataObject}=require("@website/services/website_service");const{OptimizeSEODialog}=require('@website/components/dialog/seo');const{WebsiteDialog}=require("@website/components/dialog/dialog");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const wUtils=require('@website/js/utils')[Symbol.for("default")];const{renderToElement}=require("@web/core/utils/render");const{SIZES,utils:uiUtils}=require("@web/core/ui/ui_service");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");const{Component,onWillStart,onMounted,onWillUnmount,useRef,useEffect,useState,useExternalListener,}=require("@odoo/owl");const{getScrollingElement}=require("@web/core/utils/scrolling");const{isBrowserMicrosoftEdge}=require("@web/core/browser/feature_detection");class BlockPreview extends Component{static template="website.BlockPreview";static props={};}
const WebsitePreview=__exports.WebsitePreview=class WebsitePreview extends Component{static template="website.WebsitePreview";static components={WebsiteEditorComponent,BlockPreview,WebsiteTranslator,ResourceEditor,ResizablePanel,};static props={...standardActionServiceProps};setup(){this.websiteService=useService('website');this.dialogService=useService('dialog');this.title=useService('title');this.action=useService('action');this.orm=useService('orm');this.iframeFallbackUrl='/website/iframefallback';this.iframe=useRef('iframe');this.iframefallback=useRef('iframefallback');this.container=useRef('container');this.websiteContext=useState(this.websiteService.context);this.blockedState=useState({isBlocked:false,showLoader:false,});this.isRestored=this.props.action.jsId===this.websiteService.actionJsId;this.websiteService.actionJsId=this.props.action.jsId;useBus(this.websiteService.bus,'BLOCK',(event)=>this.block(event.detail));useBus(this.websiteService.bus,'UNBLOCK',()=>this.unblock());useExternalListener(window,"keydown",this._onKeydownRefresh.bind(this));onWillStart(async()=>{const[backendWebsiteRepr]=await Promise.all([this.orm.call('website','get_current_website'),this.websiteService.fetchWebsites(),this.websiteService.fetchUserGroups(),]);this.backendWebsiteId=unslugHtmlDataObject(backendWebsiteRepr).id;const encodedPath=encodeURIComponent(this.path);if(!session.website_bypass_domain_redirect&&1===0&&this.websiteDomain&&!wUtils.isHTTPSorNakedDomainRedirection(this.websiteDomain,window.location.origin)){this.dialogService.add(WebsiteDialog,{title:_t("Redirecting..."),body:_t("You are about to be redirected to the domain configured for your website ( %s ). This is necessary to edit or view your website from the Website app. You might need to log back in.",this.websiteDomain),showSecondaryButton:false,},{onClose:()=>{window.location.href=`${encodeURI(this.websiteDomain)}/odoo/action-website.website_preview?path=${encodedPath}&website_id=${encodeURIComponent(this.websiteId)}`;}});}else{this.initialUrl=`/website/force/${encodeURIComponent(this.websiteId)}?path=${encodedPath}`;}});useEffect(()=>{this.websiteService.currentWebsiteId=this.websiteId;if(this.isRestored){return;}
const isScreenLargeEnoughForEdit=uiUtils.getSize()>=SIZES.MD;if(!isScreenLargeEnoughForEdit&&this.props.action.context.params){this.props.action.context.params.enable_editor=false;this.props.action.context.params.with_loader=false;}
this.websiteService.context.showNewContentModal=this.props.action.context.params&&this.props.action.context.params.display_new_content;this.websiteService.context.edition=this.props.action.context.params&&!!this.props.action.context.params.enable_editor;this.websiteService.context.translation=this.props.action.context.params&&!!this.props.action.context.params.edit_translations;if(this.props.action.context.params&&this.props.action.context.params.enable_seo){this.iframe.el.addEventListener('load',()=>{this.websiteService.pageDocument=this.iframe.el.contentDocument;this.dialogService.add(OptimizeSEODialog);},{once:true});}
if(this.props.action.context.params&&this.props.action.context.params.with_loader){this.websiteService.showLoader({showTips:true});}},()=>[this.props.action.context.params]);useEffect(()=>{this.websiteContext.showResourceEditor=false;},()=>[this.websiteContext.showNewContentModal,this.websiteContext.edition,this.websiteContext.translation,]);onMounted(()=>{this.websiteService.blockPreview(true,'load-iframe');this.iframe.el.addEventListener('load',()=>this.websiteService.unblockPreview('load-iframe'),{once:true});this.iframe.el.addEventListener('OdooFrameContentLoaded',()=>this.websiteService.unblockPreview('load-iframe'),{once:true});});onWillUnmount(()=>{this.websiteService.context.showResourceEditor=false;const{pathname,search,hash}=this.iframe.el.contentWindow.location;this.websiteService.lastUrl=`${pathname}${search}${hash}`;this.websiteService.currentWebsiteId=null;this.websiteService.websiteRootInstance=undefined;this.websiteService.pageDocument=null;});useEffect(()=>{const backendIconEl=document.querySelector("link[rel~='icon']");const backendIconHref=backendIconEl.href;this.iframe.el.addEventListener('load',()=>{const frontendIconEl=this.iframe.el.contentDocument.querySelector("link[rel~='icon']");if(frontendIconEl){backendIconEl.href=frontendIconEl.href;}},{once:true});return()=>{backendIconEl.href=backendIconHref;};},()=>[]);const toggleIsMobile=()=>{this.iframe.el.contentDocument.documentElement.classList.toggle('o_is_mobile',this.websiteContext.isMobile);};useEffect(toggleIsMobile,()=>[this.websiteContext.isMobile]);useEffect(()=>{this.iframe.el.addEventListener('OdooFrameContentLoaded',toggleIsMobile);return()=>this.iframe.el.removeEventListener('OdooFrameContentLoaded',toggleIsMobile);},()=>[]);}
get websiteId(){let websiteId=this.props.action.context.params&&this.props.action.context.params.website_id;if(!websiteId){websiteId=this.backendWebsiteId;}
if(!websiteId){websiteId=this.websiteService.websites[0].id;}
return websiteId;}
get websiteDomain(){return this.websiteService.websites.find(website=>website.id===this.websiteId).domain;}
get path(){let path=this.isRestored?this.websiteService.lastUrl:this.props.action.context.params&&this.props.action.context.params.path;if(path){const url=new URL(path,window.location.origin);if(this._isTopWindowURL(url)){path='/';}else{path=url.pathname+url.search;}}else{path='/';}
return path;}
get testMode(){return false;}
get aceEditorWidth(){const storedWidth=browser.localStorage.getItem("ace_editor_width");return storedWidth?parseInt(storedWidth):720;}
get isMicrosoftEdge(){return isBrowserMicrosoftEdge();}
reloadIframe(url){return new Promise((resolve,reject)=>{this.websiteService.websiteRootInstance=undefined;this.iframe.el.addEventListener('OdooFrameContentLoaded',resolve,{once:true});if(url){this.iframe.el.contentWindow.location=url;}else{this.iframe.el.contentWindow.location.reload();}});}
block({showLoader=true}={}){this.blockedState.isBlocked=true;this.blockedState.showLoader=showLoader;}
unblock(){this.blockedState.isBlocked=false;this.blockedState.showLoader=false;}
addWelcomeMessage(){if(this.websiteService.isRestrictedEditor){const wrap=this.iframe.el.contentDocument.querySelector('#wrapwrap.homepage #wrap');if(wrap&&!wrap.innerHTML.trim()){this.welcomeMessage=renderToElement('website.homepage_editor_welcome_message');this.welcomeMessage.classList.add('o_homepage_editor_welcome_message','h-100');while(wrap.firstChild){wrap.removeChild(wrap.lastChild);}
wrap.append(this.welcomeMessage);}}}
removeWelcomeMessage(){if(this.welcomeMessage){this.welcomeMessage.remove();}}
_isTopWindowURL({host,pathname}){const backendRoutes=['/web','/web/session/logout','/odoo'];return host!==window.location.host||(pathname&&(backendRoutes.includes(pathname)||pathname.startsWith('/@/')||pathname.startsWith('/odoo/')||pathname.startsWith('/web/content/')||pathname.startsWith('/document/share/')));}
_replaceBrowserUrl(){if(!wUtils.isHTTPSorNakedDomainRedirection(this.iframe.el.contentWindow.location.origin,window.location.origin)){history.replaceState(history.state,document.title,'/odoo');return;}
const currentTitle=this.iframe.el.contentDocument.title;history.replaceState(history.state,currentTitle,this.iframe.el.contentDocument.location.href);this.title.setParts({action:currentTitle});}
_onPageLoaded(ev){if(navigator.userAgent.toLowerCase().includes("chrome")&&!this.iframe.el.src.includes("iframe_reload")){try{this.iframe.el.contentWindow.location.href;}catch(err){if(err.name==="SecurityError"){ev.stopImmediatePropagation();const srcUrl=new URL(this.iframe.el.src);const pathUrl=new URL(srcUrl.searchParams.get("path"),srcUrl.origin);pathUrl.searchParams.set("iframe_reload","1");srcUrl.searchParams.set("path",`${pathUrl.pathname}${pathUrl.search}`);this.iframe.el.src=srcUrl.toString();return;}}}
if(this.lastHiddenPageURL!==this.iframe.el.contentWindow.location.href){this.websiteService.context.showResourceEditor=false;this.lastHiddenPageURL=undefined;}
if(this.props.action.context.params?.with_loader){this.websiteService.hideLoader();this.props.action.context.params.with_loader=false;}
this.iframe.el.contentWindow.addEventListener('beforeunload',this._onPageUnload.bind(this));this._replaceBrowserUrl();this.iframe.el.contentWindow.addEventListener('popstate',this._replaceBrowserUrl.bind(this));this.iframe.el.contentWindow.addEventListener('pagehide',this._onPageHide.bind(this));this.websiteService.pageDocument=this.iframe.el.contentDocument;const{editable,viewXmlid}=this.websiteService.currentWebsite.metadata;this.container.el.dataset.viewXmlid=viewXmlid;if(!editable&&this.iframefallback.el){this.iframefallback.el.classList.add('d-none');}
this.iframe.el.contentWindow.addEventListener('PUBLIC-ROOT-READY',(event)=>{this.iframe.el.setAttribute('is-ready','true');if(!this.websiteContext.edition&&editable){this.addWelcomeMessage();}
this.websiteService.websiteRootInstance=event.detail.rootInstance;});this.iframe.el.contentDocument.addEventListener('click',(ev)=>{const isEditing=this.websiteContext.edition||this.websiteContext.translation;if(!isEditing){this.iframe.el.dispatchEvent(new MouseEvent('click',ev));}else{if(!ev.target.closest('#oe_manipulators')){ev.preventDefault();}}
const linkEl=ev.target.closest('[href]');if(!linkEl){return;}
const{href,target,classList}=linkEl;if(classList.contains('o_add_language')){ev.preventDefault();const searchParams=new URLSearchParams(href);this.action.doAction('base.action_view_base_language_install',{target:'new',additionalContext:{params:{website_id:this.websiteId,url_return:searchParams.get("url_return"),},},});}else if(classList.contains('js_change_lang')&&isEditing){ev.preventDefault();const lang=linkEl.dataset['url_code'];const destinationUrl=new URL(href,window.location);destinationUrl.searchParams.delete('edit_translations');destinationUrl.hash=this.websiteService.contentWindow.location.hash;this.websiteService.bus.trigger('LEAVE-EDIT-MODE',{onLeave:()=>{this.websiteService.goToWebsite({path:destinationUrl.toString(),lang});},reloadIframe:false,});}else if(href&&target!=='_blank'&&!isEditing){if(this._isTopWindowURL(linkEl)){ev.preventDefault();browser.location.assign(href);}else if(this.iframe.el.contentWindow.location.pathname!==new URL(href).pathname){this.websiteService.websiteRootInstance=undefined;}}});this.iframe.el.contentDocument.addEventListener('keydown',ev=>{if(getActiveHotkey(ev)==='control+k'&&!this.websiteContext.edition){ev.preventDefault();}
this._onKeydownRefresh(ev);this.iframe.el.dispatchEvent(new KeyboardEvent('keydown',ev));});this.iframe.el.contentDocument.addEventListener('keyup',ev=>{this.iframe.el.dispatchEvent(new KeyboardEvent('keyup',ev));});}
_cleanIframeFallback(){const iframesEl=this.iframefallback.el.contentDocument.querySelectorAll('iframe[src]:not([src=""])');for(const iframeEl of iframesEl){const url=new URL(iframeEl.src);url.searchParams.delete('autoplay');iframeEl.src=url.toString();}}
_onResourceEditorResize(width){browser.localStorage.setItem("ace_editor_width",width);}
_onPageUnload(){this.iframe.el.setAttribute('is-ready','false');if(!this.websiteContext.edition&&this.iframe.el.contentDocument.body&&this.iframefallback.el){this.iframefallback.el.contentDocument.body.replaceWith(this.iframe.el.contentDocument.body.cloneNode(true));this.iframefallback.el.classList.remove('d-none');getScrollingElement(this.iframefallback.el.contentDocument).scrollTop=getScrollingElement(this.iframe.el.contentDocument).scrollTop;this._cleanIframeFallback();}}
_onPageHide(){this.lastHiddenPageURL=this.iframe.el&&this.iframe.el.contentWindow.location.href;this.websiteService.websiteRootInstance=undefined;}
_onKeydownRefresh(ev){const hotkey=getActiveHotkey(ev);if(hotkey!=='control+r'&&hotkey!=='f5'){return;}
if(this.websiteService.contentWindow===undefined){return;}
ev.preventDefault();const path=this.websiteService.contentWindow.location;const debugMode=this.env.debug?`&debug=${this.env.debug}`:"";redirect(`/odoo/action-website.website_preview?path=${encodeURIComponent(path)}${debugMode}`);}}
registry.category('actions').add('website_preview',WebsitePreview);return __exports;});;

/* /website/static/src/components/fields/fields.js */
odoo.define('@website/components/fields/fields',['@website/components/dialog/page_properties','@web/views/fields/standard_field_props','@web/views/fields/url/url_field','@web/core/registry','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{PageDependencies}=require('@website/components/dialog/page_properties');const{standardFieldProps}=require('@web/views/fields/standard_field_props');const{UrlField,urlField}=require("@web/views/fields/url/url_field");const{registry}=require('@web/core/registry');const{_t}=require('@web/core/l10n/translation');const{Component,useEffect,useRef}=require("@odoo/owl");class PageUrlField extends UrlField{static components={PageDependencies};static template="website.PageUrlField";static defaultProps={...UrlField.defaultProps,websitePath:true,};setup(){super.setup();this.serverUrl=`${window.location.origin}/`;this.inputRef=useRef("input");useEffect((inputEl)=>{if(inputEl){const fireChangeEvent=()=>{inputEl.dispatchEvent(new Event("change"));};inputEl.addEventListener("input",fireChangeEvent);return()=>{inputEl.removeEventListener("input",fireChangeEvent);};}},()=>[this.inputRef.el],);}
get value(){let value=super.value;if(value[0]==="/"){value=value.substring(1);}
this.props.record.data[this.props.name]=`/${value.trim()}`;return value;}}
const pageUrlField={...urlField,component:PageUrlField,};registry.category("fields").add("page_url",pageUrlField);const ImageRadioField=__exports.ImageRadioField=class ImageRadioField extends Component{static template="website.FieldImageRadio";static props={...standardFieldProps,images:{type:Array,element:String},};setup(){const selection=this.props.record.fields[this.props.name].selection;this.values=selection.filter(item=>{return item[0]||item[1];}).map((value,index)=>{return[...value,this.props.images&&this.props.images[index]||''];});}
onSelectValue(value){this.props.record.update({[this.props.name]:value});}}
const imageRadioField=__exports.imageRadioField={component:ImageRadioField,supportedOptions:[{label:_t("Images"),name:"images",type:"string",help:_t("Use an array to list the images to use in the radio selection.")}],supportedTypes:['selection'],extractProps:({options})=>({images:options.images,}),};registry.category("fields").add("image_radio",imageRadioField);return __exports;});;

/* /website/static/src/components/fields/publish_button.js */
odoo.define('@website/components/fields/publish_button',['@web/core/registry','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Component}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");class PublishField extends Component{static template="website.PublishField";static props={...standardFieldProps};}
registry.category("fields").add("website_publish_button",{component:PublishField,});return __exports;});;

/* /website/static/src/components/fields/redirect_field.js */
odoo.define('@website/components/fields/redirect_field',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/objects','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{pick}=require("@web/core/utils/objects");const{Component}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");class RedirectField extends Component{static template="website.RedirectField";static props={...standardFieldProps};get info(){return this.props.record.data[this.props.name]?_t("Published"):_t("Unpublished");}
onClick(){this.env.onClickViewButton({clickParams:{type:"object",name:"open_website_url",},getResParams:()=>pick(this.props.record,"context","evalContext","resModel","resId","resIds"),});}}
registry.category("fields").add("website_redirect_button",{component:RedirectField,});return __exports;});;

/* /website/static/src/components/fields/widget_iframe.js */
odoo.define('@website/components/fields/widget_iframe',['@web/core/registry','@web/core/utils/hooks','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{registry}=require('@web/core/registry');const{useBus}=require("@web/core/utils/hooks");const{Component,useState}=require("@odoo/owl");const{standardFieldProps}=require('@web/views/fields/standard_field_props');class FieldIframePreview extends Component{static template="website.iframeWidget";static props={...standardFieldProps};setup(){this.state=useState({isMobile:false});useBus(this.env.bus,'THEME_PREVIEW:SWITCH_MODE',(ev)=>{this.state.isMobile=ev.detail.mode==='mobile';});}}
const fieldIframePreview=__exports.fieldIframePreview={component:FieldIframePreview,};registry.category("fields").add("iframe",fieldIframePreview);return __exports;});;

/* /website/static/src/components/fullscreen_indication/fullscreen_indication.js */
odoo.define('@website/components/fullscreen_indication/fullscreen_indication',['@web/core/utils/hooks','@odoo/owl','@web/core/utils/strings','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{useBus}=require("@web/core/utils/hooks");const{EventBus,Component,useState,markup}=require("@odoo/owl");const{escape,sprintf}=require("@web/core/utils/strings");const{_t}=require("@web/core/l10n/translation");const FullscreenIndication=__exports.FullscreenIndication=class FullscreenIndication extends Component{static props={bus:EventBus,};static template="website.FullscreenIndication";setup(){this.state=useState({isVisible:false});useBus(this.props.bus,"FULLSCREEN-INDICATION-SHOW",this.show.bind(this));useBus(this.props.bus,"FULLSCREEN-INDICATION-HIDE",this.hide.bind(this));}
show(){setTimeout(()=>this.state.isVisible=true);this.autofade=setTimeout(()=>this.state.isVisible=false,2000);}
hide(){if(this.state.isVisible){this.state.isVisible=false;clearTimeout(this.autofade);}}
get fullScreenIndicationText(){return markup(sprintf(escape(_t("Press %(key)s to exit full screen")),{key:"<span>esc</span>"}));}}
return __exports;});;

/* /website/static/src/components/website_loader/website_loader.js */
odoo.define('@website/components/website_loader/website_loader',['@web/core/network/rpc','@web/core/utils/hooks','@web/core/utils/strings','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{useBus,useService}=require("@web/core/utils/hooks");const{sprintf}=require("@web/core/utils/strings");const{_t}=require("@web/core/l10n/translation");const{EventBus,Component,markup,useEffect,useState}=require("@odoo/owl");const WebsiteLoader=__exports.WebsiteLoader=class WebsiteLoader extends Component{static props={bus:EventBus,};static template="website.website_loader";setup(){this.website=useService("website");const initialState={isVisible:false,title:'',flag:false,showTips:false,selectedFeatures:[],showWaitingMessages:false,progressPercentage:0,bottomMessageTemplate:undefined,showLoader:true,showCloseButton:false,};const defaultMessages=[{title:_t("Building your website."),description:_t("Applying your colors and design..."),flag:"colors",},{title:_t("Building your website."),description:_t("Searching your images...."),flag:"images",},{title:_t("Building your website."),description:_t("Generating inspiring text..."),flag:"text",}];let messagesInterval;this.state=useState({...initialState,});this.waitingMessages=useState(defaultMessages);this.currentWaitingMessage=useState({...defaultMessages[0]});this.featuresInstallInfo={nbInstalled:0,total:undefined};useEffect((selectedFeatures)=>{if(this.state.showWaitingMessages){let messagesToDisplay=[...defaultMessages];if(selectedFeatures.length>0){messagesToDisplay.push(...this.getWaitingMessages(selectedFeatures));}
this.waitingMessages.splice(0,this.waitingMessages.length,...messagesToDisplay);this.trackModules(selectedFeatures).catch(console.error);return()=>{clearTimeout(this.trackModulesTimeout);clearInterval(this.updateProgressInterval);};}},()=>[this.state.selectedFeatures]);useEffect(()=>{if(this.state.showWaitingMessages){let msgIndex=0;messagesInterval=setInterval(()=>{msgIndex++;const nextMessage=this.waitingMessages[msgIndex];Object.assign(this.currentWaitingMessage,nextMessage);if(this.waitingMessages.length-1===msgIndex){clearInterval(messagesInterval);}},6000);return()=>clearInterval(messagesInterval);}},()=>[this.waitingMessages.length]);useEffect((isVisible)=>{if(isVisible){window.addEventListener("beforeunload",this.showRefreshConfirmation);if(!this.state.selectedFeatures||this.state.selectedFeatures.length===0){this.initProgressBar();}}else{window.removeEventListener("beforeunload",this.showRefreshConfirmation);}
return()=>{window.removeEventListener("beforeunload",this.showRefreshConfirmation);clearInterval(this.updateProgressInterval);};},()=>[this.state.isVisible]);useBus(this.props.bus,"SHOW-WEBSITE-LOADER",(ev)=>{const props=ev.detail;this.state.isVisible=true;for(const prop of["title","selectedFeatures","showWaitingMessages","bottomMessageTemplate","showCloseButton","flag",]){this.state[prop]=props&&props[prop];}
this.state.showLoader=props&&props.showLoader!==false;});useBus(this.props.bus,"HIDE-WEBSITE-LOADER",()=>{for(const key of Object.keys(initialState)){this.state[key]=initialState[key];}
clearInterval(messagesInterval);clearTimeout(this.trackModulesTimeout);clearInterval(this.updateProgressInterval);});useBus(this.props.bus,"PREPARE-OUT-WEBSITE-LOADER",()=>{window.removeEventListener("beforeunload",this.showRefreshConfirmation);});}
initProgressBar(){if(this.updateProgressInterval){return;}
const nbModulesToInstall=this.featuresInstallInfo.total||0;const isSomethingToInstall=nbModulesToInstall>0;let currentProgress=0;const progressStep=isSomethingToInstall?0.04:0.02;let progressForAfterModules=isSomethingToInstall?30:100;let progressForAllModules=100-progressForAfterModules;let lastTotalInstalled=0;let progressPerModule=isSomethingToInstall?progressForAllModules/nbModulesToInstall:0;this.updateProgressInterval=setInterval(()=>{if(this.featuresInstallInfo.nbInstalled!==lastTotalInstalled){currentProgress=0;lastTotalInstalled=this.featuresInstallInfo.nbInstalled;}
currentProgress+=progressStep;const limit=this.featuresInstallInfo.nbInstalled===nbModulesToInstall?progressForAfterModules:progressPerModule;this.state.progressPercentage=(lastTotalInstalled*progressPerModule)+
Math.atan(currentProgress)/(Math.PI/2)*limit;},100);}
async trackModules(selectedFeatures){const installInfo=await rpc("/website/track_installing_modules",{'selected_features':selectedFeatures,'total_features':this.featuresInstallInfo.total,},{silent:true});if(!this.featuresInstallInfo.total||this.featuresInstallInfo.nbInstalled!==installInfo.nbInstalled){this.featuresInstallInfo=installInfo;}
this.initProgressBar();if(this.featuresInstallInfo.nbInstalled!==this.featuresInstallInfo.total){this.trackModulesTimeout=setTimeout(()=>this.trackModules(selectedFeatures),1000);}}
getWaitingMessages(selectedFeatures){const websiteFeaturesMessages=[{id:5,title:_t("Adding features."),name:_t("blog"),description:_t("Enabling your %s."),flag:"generic",},{id:7,title:_t("Adding features."),name:_t("recruitment platform"),description:_t("Integrating your %s."),flag:"generic",},{id:8,title:_t("Adding features."),name:_t("online store"),description:_t("Activating your %s."),flag:"generic",},{id:9,title:_t("Adding features."),name:_t("online appointment system"),description:_t("Configuring your %s."),flag:"generic",},{id:10,title:_t("Adding features."),name:_t("forum"),description:_t("Setting up your %s."),flag:"generic",},{id:12,title:_t("Adding features."),name:_t("e-learning platform"),description:_t("Installing your %s."),flag:"generic",},{id:"last",title:_t("Finalizing."),description:_t("Activating the last features."),flag:"generic",}];const filteredIds=[...selectedFeatures,"last"];const messagesList=websiteFeaturesMessages.filter((msg)=>{if(filteredIds.includes(msg.id)){if(msg.name){const highlight=sprintf('<span class="o_website_loader_text_highlight">%s</span>',msg.name);msg.description=markup(sprintf(msg.description,highlight));}
return true;}});return messagesList;}
showRefreshConfirmation=(ev)=>{if(this.state.isVisible){ev.preventDefault();ev.returnValue="";return ev.returnValue;}};close(){this.website.hideLoader();}}
return __exports;});;

/* /website/static/src/components/views/page_kanban.js */
odoo.define('@website/components/views/page_kanban',['@website/components/views/page_views_mixin','@website/components/views/page_search_model','@web/core/registry','@web/views/kanban/kanban_view','@web/core/dropdown/checkbox_item'],function(require){'use strict';let __exports={};const{PageControllerMixin}=require("@website/components/views/page_views_mixin");const{PageSearchModel}=require("@website/components/views/page_search_model");const{registry}=require('@web/core/registry');const{kanbanView}=require("@web/views/kanban/kanban_view");const{CheckboxItem}=require("@web/core/dropdown/checkbox_item");const PageKanbanController=__exports.PageKanbanController=class PageKanbanController extends PageControllerMixin(kanbanView.Controller){static template="website.PageKanbanView";static components={...kanbanView.Controller.components,CheckboxItem,};async createRecord(){return this.createWebsiteContent();}}
const PageKanbanView=__exports.PageKanbanView={...kanbanView,Controller:PageKanbanController,SearchModel:PageSearchModel,};registry.category("views").add("website_pages_kanban",PageKanbanView);return __exports;});;

/* /website/static/src/components/views/page_list.js */
odoo.define('@website/components/views/page_list',['@web/core/l10n/translation','@website/components/views/page_views_mixin','@website/components/views/page_search_model','@web/core/registry','@web/views/list/list_view','@web/core/confirmation_dialog/confirmation_dialog','@website/components/dialog/page_properties','@web/core/dropdown/checkbox_item'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{PageControllerMixin}=require("@website/components/views/page_views_mixin");const{PageSearchModel}=require("@website/components/views/page_search_model");const{registry}=require('@web/core/registry');const{listView}=require('@web/views/list/list_view');const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{DeletePageDialog,DuplicatePageDialog}=require('@website/components/dialog/page_properties');const{CheckboxItem}=require("@web/core/dropdown/checkbox_item");const PageListController=__exports.PageListController=class PageListController extends PageControllerMixin(listView.Controller){static template=`website.PageListView`;static components={...listView.Controller.components,CheckboxItem,};setup(){super.setup();if(this.props.resModel==="website.page"){this.archiveEnabled=false;}}
onClickCreate(){return this.createWebsiteContent();}
getStaticActionMenuItems(){const menuItems=super.getStaticActionMenuItems();if(this.props.fields.hasOwnProperty('is_published')){menuItems.publish={sequence:15,icon:"fa fa-globe",description:_t("Publish"),callback:async()=>{this.dialogService.add(ConfirmationDialog,{title:_t("Publish Website Content"),body:_t("%s record(s) selected, are you sure you want to publish them all?",this.model.root.selection.length),confirm:()=>this.togglePublished(true),});},};menuItems.unpublish={sequence:16,icon:"fa fa-chain-broken",description:_t("Unpublish"),callback:async()=>this.togglePublished(false),};}
if(this.props.resModel==="website.page"){menuItems.duplicate.callback=async(records=[])=>{const resIds=this.model.root.selection.map((record)=>record.resId);this.dialog.add(DuplicatePageDialog,{pageIds:resIds,onDuplicate:()=>{this.model.load();},});};}
return menuItems;}
async onDeleteSelectedRecords(){const pageIds=this.model.root.selection.map((record)=>record.resId);const newPageTemplateRecords=await this.orm.read("website.page",pageIds,["is_new_page_template"]);this.dialogService.add(DeletePageDialog,{resIds:pageIds,resModel:this.props.resModel,onDelete:()=>{this.model.root.deleteRecords();},hasNewPageTemplate:newPageTemplateRecords.some(record=>record.is_new_page_template),});}
async togglePublished(publish){const resIds=this.model.root.selection.map(record=>record.resId);await this.orm.write(this.props.resModel,resIds,{is_published:publish});this.actionService.switchView('list');}}
const PageListRenderer=__exports.PageListRenderer=class PageListRenderer extends listView.Renderer{static recordRowTemplate="website.PageListRenderer.RecordRow";}
const PageListView=__exports.PageListView={...listView,Renderer:PageListRenderer,Controller:PageListController,SearchModel:PageSearchModel,};registry.category("views").add("website_pages_list",PageListView);return __exports;});;

/* /website/static/src/components/views/page_search_model.js */
odoo.define('@website/components/views/page_search_model',['@web/core/utils/hooks','@web/core/domain','@web/search/search_model','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{Domain}=require('@web/core/domain');const{SearchModel}=require('@web/search/search_model');const{onWillStart,useState}=require("@odoo/owl");const PageSearchModel=__exports.PageSearchModel=class PageSearchModel extends SearchModel{setup(){super.setup(...arguments);this.website=useService('website');this.pagesState=useState({websiteDomain:false,});onWillStart(async()=>{await this.website.fetchWebsites();const website=await this.getCurrentWebsite();await this.notifyWebsiteChange(website.id);});}
exportState(){const state=super.exportState();state.websiteDomain=this.pagesState.websiteDomain;return state;}
_importState(state){super._importState(...arguments);if(state.websiteDomain){this.pagesState.websiteDomain=state.websiteDomain;}}
_getDomain(params={}){let domain=super._getDomain(params);if(!this.pagesState.websiteDomain){return domain;}
domain=Domain.and([domain,this.pagesState.websiteDomain,]);return params.raw?domain:domain.toList();}
async notifyWebsiteChange(websiteId){let websiteDomain=[];if(websiteId&&'website_id'in this.searchViewFields){if(this.resModel==='website.page'){const pageIds=await this.orm.call("website","get_website_page_ids",[websiteId],);websiteDomain=[['id','in',pageIds]];}else{websiteDomain=[['website_id','in',[false,websiteId]]];}}
this.pagesState.websiteDomain=websiteDomain;this._notify();}
async getCurrentWebsite(){const currentWebsite=(await this.orm.call('website','get_current_website')).match(/\d+/);if(currentWebsite){return this.website.websites.find(w=>w.id===parseInt(currentWebsite[0]));}
return this.website.websites[0];}}
return __exports;});;

/* /website/static/src/components/views/page_views_mixin.js */
odoo.define('@website/components/views/page_views_mixin',['@web/core/l10n/translation','@web/core/network/rpc','@web/core/utils/hooks','@website/components/dialog/add_page_dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{AddPageDialog}=require("@website/components/dialog/add_page_dialog");const{onWillStart,useState}=require("@odoo/owl");const PageControllerMixin=__exports.PageControllerMixin=(component)=>class extends component{setup(){super.setup();this.website=useService('website');this.dialog=useService('dialog');this.orm=useService('orm');this.websiteSelection=odoo.debug?[{id:0,name:_t("All Websites")}]:[];this.state=useState({activeWebsite:undefined,});onWillStart(async()=>{this.websiteSelection.push(...this.website.websites);this.state.activeWebsite=await this.env.searchModel.getCurrentWebsite();});}
async createWebsiteContent(){if(this.props.resModel==='website.page'){return this.dialog.add(AddPageDialog,{websiteId:this.state.activeWebsite.id,});}
const action=this.props.context.create_action;if(action){if(/^\//.test(action)){const url=await rpc(action);this.website.goToWebsite({path:url,edition:true});return;}
this.actionService.doAction(action,{onClose:(infos)=>{if(infos){this.website.goToWebsite({path:infos.path});}},props:{onSave:(record,params)=>{if(record.resId&&params.computePath){const path=params.computePath();this.actionService.doAction({type:"ir.actions.act_window_close",infos:{path}});}}}});}}
onSelectWebsite(website){this.state.activeWebsite=website;this.env.searchModel.notifyWebsiteChange(website.id);}};return __exports;});;

/* /website/static/src/components/views/theme_preview_form.js */
odoo.define('@website/components/views/theme_preview_form',['@web/search/control_panel/control_panel','@web/views/form/form_controller','@web/views/form/form_view','@web/core/registry','@web/core/utils/hooks','@web/views/view_button/view_button','@odoo/owl'],function(require){'use strict';let __exports={};const{ControlPanel}=require("@web/search/control_panel/control_panel");const{FormController}=require("@web/views/form/form_controller");const{formView}=require("@web/views/form/form_view");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{ViewButton}=require("@web/views/view_button/view_button");const{useSubEnv,onMounted,useEnv}=require("@odoo/owl");__exports.useLoaderOnClick=useLoaderOnClick;function useLoaderOnClick(){const website=useService('website');const orm=useService('orm');const action=useService('action');const env=useEnv();const previousOnClickViewButton=env.onClickViewButton;useSubEnv({async onClickViewButton(params){const name=params.clickParams.name;if(['button_refresh_theme','button_choose_theme'].includes(name)){website.invalidateSnippetCache=true;website.showLoader({showTips:name!=='button_refresh_theme'});try{const resParams=params.getResParams();const callback=await orm.silent.call(resParams.resModel,name,[[resParams.resId]]);let keepLoader=false;if(callback){callback.target='main';await action.doAction(callback);if(callback.tag==='website_preview'&&callback.context.params.with_loader){keepLoader=true;}}
if(!keepLoader){website.hideLoader();}}catch(error){website.hideLoader();throw error;}}else{return previousOnClickViewButton(...arguments);}}});}
class ThemePreviewFormController extends FormController{static components={...FormController.components,ViewButton};static template="website.ThemePreviewFormController";setup(){super.setup();useLoaderOnClick();onMounted(()=>{setTimeout(()=>{document.querySelector('button[name="button_choose_theme"]')?.click();},0);});}
get className(){return{...super.className,'o_view_form_theme_preview_controller':true};}
back(){this.env.config.historyBack();}}
class ThemePreviewFormControlPanel extends ControlPanel{static template="website.ThemePreviewForm.ControlPanel";onMobileClick(){this.env.bus.trigger('THEME_PREVIEW:SWITCH_MODE',{mode:'mobile'});}
onDesktopClick(){this.env.bus.trigger('THEME_PREVIEW:SWITCH_MODE',{mode:'desktop'});}
back(){this.env.config.historyBack();}}
const ThemePreviewFormView={...formView,Controller:ThemePreviewFormController,ControlPanel:ThemePreviewFormControlPanel,};registry.category('views').add('theme_preview_form',ThemePreviewFormView);return __exports;});;

/* /website/static/src/components/views/theme_preview_kanban.js */
odoo.define('@website/components/views/theme_preview_kanban',['@web/search/control_panel/control_panel','@web/views/kanban/kanban_view','@web/views/kanban/kanban_controller','@web/core/registry','@web/core/utils/hooks','@website/components/views/theme_preview_form','@web/views/kanban/kanban_record','@web/views/kanban/kanban_renderer'],function(require){'use strict';let __exports={};const{ControlPanel}=require("@web/search/control_panel/control_panel");const{kanbanView}=require("@web/views/kanban/kanban_view");const{KanbanController}=require("@web/views/kanban/kanban_controller");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{useLoaderOnClick}=require("@website/components/views/theme_preview_form");const{KanbanRecord}=require("@web/views/kanban/kanban_record");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");class ThemePreviewKanbanController extends KanbanController{setup(){super.setup();useLoaderOnClick();}}
class ThemePreviewControlPanel extends ControlPanel{static template="website.ThemePreviewKanban.ControlPanel";setup(){super.setup();this.website=useService('website');}
close(){this.website.goToWebsite();}
get display(){return{layoutActions:false,...this.props.display,};}}
class ThemePreviewKanbanrecord extends KanbanRecord{getRecordClasses(){return super.getRecordClasses()+" p-0 border-0 bg-transparent";}}
const ThemePreviewKanbanRenderer=__exports.ThemePreviewKanbanRenderer=class ThemePreviewKanbanRenderer extends KanbanRenderer{static components={...KanbanRenderer.components,KanbanRecord:ThemePreviewKanbanrecord,};}
const ThemePreviewKanbanView={...kanbanView,Controller:ThemePreviewKanbanController,ControlPanel:ThemePreviewControlPanel,Renderer:ThemePreviewKanbanRenderer,display:{controlPanel:{},},};registry.category('views').add('theme_preview_kanban',ThemePreviewKanbanView);return __exports;});;

/* /website/static/src/services/website_service.js */
odoo.define('@website/services/website_service',['@web/core/l10n/utils','@web/core/l10n/translation','@web/core/registry','@web/core/user','@web/core/assets','@web/core/ensure_jquery','@web/core/utils/ui','@website/components/fullscreen_indication/fullscreen_indication','@website/components/website_loader/website_loader','@odoo/owl'],function(require){'use strict';let __exports={};const{jsToPyLocale}=require("@web/core/l10n/utils");const{_t}=require("@web/core/l10n/translation");const{registry}=require('@web/core/registry');const{user}=require("@web/core/user");const{loadBundle}=require("@web/core/assets");const{ensureJQuery}=require("@web/core/ensure_jquery");const{isVisible}=require("@web/core/utils/ui");const{FullscreenIndication}=require("@website/components/fullscreen_indication/fullscreen_indication");const{WebsiteLoader}=require("@website/components/website_loader/website_loader");const{reactive,EventBus}=require("@odoo/owl");const websiteSystrayRegistry=registry.category('website_systray');const unslugHtmlDataObject=__exports.unslugHtmlDataObject=(repr)=>{const match=repr&&repr.match(/(.+)\((\d+),(.*)\)/);if(!match){return null;}
return{model:match[1],id:match[2]|0,};};const ANONYMOUS_PROCESS_ID='ANONYMOUS_PROCESS_ID';const websiteService=__exports.websiteService={dependencies:['orm','action','hotkey'],async start(env,{orm,action,hotkey}){let websites=[];let currentWebsiteId;let currentMetadata={};let fullscreen;let pageDocument;let contentWindow;let lastUrl;let websiteRootInstance;let isRestrictedEditor;let isDesigner;let hasMultiWebsites;let actionJsId;let blockingProcesses=[];let modelNamesProm=null;const modelNames={};let invalidateSnippetCache=false;let lastWebsiteId=null;const context=reactive({showNewContentModal:false,showResourceEditor:false,edition:false,isPublicRootReady:false,snippetsLoaded:false,isMobile:false,});const bus=new EventBus();hotkey.add("escape",()=>{if((!currentWebsiteId&&!fullscreen)||(pageDocument&&isVisible(pageDocument.querySelector(".modal")))){return;}
fullscreen=!fullscreen;document.body.classList.toggle('o_website_fullscreen',fullscreen);bus.trigger(fullscreen?'FULLSCREEN-INDICATION-SHOW':'FULLSCREEN-INDICATION-HIDE');},{global:true});registry.category('main_components').add('FullscreenIndication',{Component:FullscreenIndication,props:{bus},});registry.category('main_components').add('WebsiteLoader',{Component:WebsiteLoader,props:{bus},});return{set currentWebsiteId(id){if(id&&id!==lastWebsiteId){invalidateSnippetCache=true;lastWebsiteId=id;}
currentWebsiteId=id;websiteSystrayRegistry.trigger('EDIT-WEBSITE');},get currentWebsite(){const currentWebsite=websites.find(w=>w.id===currentWebsiteId);if(currentWebsite){currentWebsite.metadata=currentMetadata;}
return currentWebsite;},get websites(){return websites;},get context(){return context;},get bus(){return bus;},set pageDocument(document){pageDocument=document;if(!document){currentMetadata={};contentWindow=null;return;}
const{dataset}=document.documentElement;const isWebsitePage=dataset&&dataset.websiteId;if(!isWebsitePage){currentMetadata={};}else{const{mainObject,seoObject,isPublished,canOptimizeSeo,canPublish,editableInBackend,translatable,viewXmlid,defaultLangName,langName}=dataset;const contentMenus=[...new Map([...document.querySelectorAll("[data-content_menu_id]")].map((menuEl)=>[menuEl.dataset.content_menu_id,[menuEl.dataset.menu_name,menuEl.dataset.content_menu_id],])).values(),];currentMetadata={path:document.location.href,mainObject:unslugHtmlDataObject(mainObject),seoObject:unslugHtmlDataObject(seoObject),isPublished:isPublished==='True',canOptimizeSeo:canOptimizeSeo==='True',canPublish:canPublish==='True',editableInBackend:editableInBackend==='True',title:document.title,translatable:!!translatable,contentMenus,editable:!!document.getElementById('wrapwrap'),viewXmlid:viewXmlid,lang:jsToPyLocale(document.documentElement.getAttribute("lang")),defaultLangName:defaultLangName,langName:langName,direction:document.documentElement.querySelector('#wrapwrap.o_rtl')?'rtl':'ltr',};}
contentWindow=document.defaultView;websiteSystrayRegistry.trigger('CONTENT-UPDATED');},get pageDocument(){return pageDocument;},get contentWindow(){return contentWindow;},get websiteRootInstance(){return websiteRootInstance;},set websiteRootInstance(rootInstance){websiteRootInstance=rootInstance;context.isPublicRootReady=!!rootInstance;},set lastUrl(url){lastUrl=url;},get lastUrl(){return lastUrl;},get isRestrictedEditor(){return isRestrictedEditor===true;},get isDesigner(){return isDesigner===true;},get hasMultiWebsites(){return hasMultiWebsites===true;},get actionJsId(){return actionJsId;},set actionJsId(jsId){actionJsId=jsId;},get invalidateSnippetCache(){return invalidateSnippetCache;},set invalidateSnippetCache(value){invalidateSnippetCache=value;},goToWebsite({websiteId,path,edition,translation,lang}={}){this.websiteRootInstance=undefined;if(lang){invalidateSnippetCache=true;path=`/website/lang/${encodeURIComponent(lang)}?r=${encodeURIComponent(path)}`;}
action.doAction('website.website_preview',{clearBreadcrumbs:true,additionalContext:{params:{website_id:websiteId||currentWebsiteId,path:path||(contentWindow&&contentWindow.location.href)||'/',enable_editor:edition,edit_translations:translation,},},});},async fetchUserGroups(){[isRestrictedEditor,isDesigner,hasMultiWebsites]=await Promise.all([user.hasGroup('website.group_website_restricted_editor'),user.hasGroup('website.group_website_designer'),user.hasGroup('website.group_multi_website'),]);},async fetchWebsites(){websites=[...(await orm.searchRead('website',[],['domain','id','name']))];},async loadWysiwyg(){await ensureJQuery();await loadBundle('website.backend_assets_all_wysiwyg');},blockPreview(showLoader,processId){if(!blockingProcesses.length){bus.trigger('BLOCK',{showLoader});}
blockingProcesses.push(processId||ANONYMOUS_PROCESS_ID);},unblockPreview(processId){const processIndex=blockingProcesses.indexOf(processId||ANONYMOUS_PROCESS_ID);if(processIndex>-1){blockingProcesses.splice(processIndex,1);if(blockingProcesses.length===0){bus.trigger('UNBLOCK');}}},showLoader(props){bus.trigger('SHOW-WEBSITE-LOADER',props);},hideLoader(){bus.trigger('HIDE-WEBSITE-LOADER');},prepareOutLoader(){bus.trigger("PREPARE-OUT-WEBSITE-LOADER");},async getUserModelName(model=this.currentWebsite.metadata.mainObject.model){if(!modelNamesProm){modelNamesProm=orm.call("ir.model","get_available_models").then(modelsData=>{for(const modelData of modelsData){modelNames[modelData['model']]=modelData['display_name'];}}).catch(()=>{});}
await modelNamesProm;return modelNames[model]||_t("Data");},};},};registry.category('services').add('website',websiteService);return __exports;});;

/* /website/static/src/js/utils.js */
odoo.define('@website/js/utils',['@web/core/utils/arrays','@web/core/l10n/translation','@web/core/utils/render','@odoo/owl','@web/core/templates','@website/components/autocomplete_with_pages/url_autocomplete'],function(require){'use strict';let __exports={};const{intersection}=require("@web/core/utils/arrays");const{_t}=require("@web/core/l10n/translation");const{renderToElement}=require("@web/core/utils/render");const{App,Component}=require("@odoo/owl");const{getTemplate}=require("@web/core/templates");const{UrlAutoComplete}=require("@website/components/autocomplete_with_pages/url_autocomplete");function loadAnchors(url,body){return new Promise(function(resolve,reject){if(url===window.location.pathname||url[0]==='#'){resolve(body?body:document.body.outerHTML);}else if(url.length&&!url.startsWith("http")){$.get(window.location.origin+url).then(resolve,reject);}else{resolve();}}).then(function(response){const anchors=$(response).find('[id][data-anchor=true], .modal[id][data-display="onClick"]').toArray().map((el)=>{return'#'+el.id;});if(!anchors.includes('#top')){anchors.unshift('#top');}
if(!anchors.includes('#bottom')){anchors.push('#bottom');}
return anchors;}).catch(error=>{console.debug(error);return[];});}
function autocompleteWithPages(input,options={}){const owlApp=new App(UrlAutoComplete,{env:Component.env,dev:Component.env.debug,getTemplate,props:{options,loadAnchors,targetDropdown:input,},translatableAttributes:["data-tooltip"],translateFn:_t,});const container=document.createElement("div");container.classList.add("ui-widget","ui-autocomplete","ui-widget-content","border-0");document.body.appendChild(container);owlApp.mount(container)
return()=>{owlApp.destroy();container.remove();}}
function onceAllImagesLoaded($element,$excluded){var defs=Array.from($element.find("img").addBack("img")).map((img)=>{if(img.complete||$excluded&&($excluded.is(img)||$excluded.has(img).length)){return;}
var def=new Promise(function(resolve,reject){$(img).one('load',function(){resolve();});});return def;});return Promise.all(defs);}
function prompt(options,_qweb){if(typeof options==='string'){options={text:options};}
if(typeof _qweb==="undefined"){_qweb='website.prompt';}
options=Object.assign({window_title:'',field_name:'','default':'',init:function(){},btn_primary_title:_t('Create'),btn_secondary_title:_t('Cancel'),},options||{});var type=intersection(Object.keys(options),['input','textarea','select']);type=type.length?type[0]:'input';options.field_type=type;options.field_name=options.field_name||options[type];var def=new Promise(function(resolve,reject){var dialog=$(renderToElement(_qweb,options)).appendTo('body');options.$dialog=dialog;var field=dialog.find(options.field_type).first();field.val(options['default']);field.fillWith=function(data){if(field.is('select')){var select=field[0];data.forEach(function(item){select.options[select.options.length]=new window.Option(item[1],item[0]);});}else{field.val(data);}};var init=options.init(field,dialog);Promise.resolve(init).then(function(fill){if(fill){field.fillWith(fill);}
dialog.modal('show');field.focus();dialog.on('click','.btn-primary',function(){var backdrop=$('.modal-backdrop');resolve({val:field.val(),field:field,dialog:dialog});dialog.modal('hide').remove();backdrop.remove();});});dialog.on('hidden.bs.modal',function(){var backdrop=$('.modal-backdrop');reject();dialog.remove();backdrop.remove();});if(field.is('input[type="text"], select')){field.keypress(function(e){if(e.key==="Enter"){e.preventDefault();dialog.find('.btn-primary').trigger('click');}});}});return def;}
function websiteDomain(self){var websiteID;self.trigger_up('context_get',{callback:function(ctx){websiteID=ctx['website_id'];},});return['|',['website_id','=',false],['website_id','=',websiteID]];}
function isHTTPSorNakedDomainRedirection(url1,url2){try{url1=new URL(url1).host;url2=new URL(url2).host;}catch{return false;}
return url1===url2||url1.replace(/^www\./,'')===url2.replace(/^www\./,'');}
function sendRequest(route,params){function _addInput(form,name,value){let param=document.createElement('input');param.setAttribute('type','hidden');param.setAttribute('name',name);param.setAttribute('value',value);form.appendChild(param);}
let form=document.createElement('form');form.setAttribute('action',route);form.setAttribute('method',params.method||'POST');if(params.forceTopWindow){form.setAttribute('target','_top');}
if(odoo.csrf_token){_addInput(form,'csrf_token',odoo.csrf_token);}
for(const key in params){const value=params[key];if(Array.isArray(value)&&value.length){for(const val of value){_addInput(form,key,val);}}else{_addInput(form,key,value);}}
document.body.appendChild(form);form.submit();}
__exports.svgToPNG=svgToPNG;async function svgToPNG(src){return _exportToPNG(src,"svg+xml");}
__exports.webpToPNG=webpToPNG;async function webpToPNG(src){return _exportToPNG(src,"webp");}
async function _exportToPNG(src,format){function checkImg(imgEl){return(imgEl.naturalHeight!==0);}
function toPNGViaCanvas(imgEl){const canvas=document.createElement('canvas');canvas.width=imgEl.width;canvas.height=imgEl.height;canvas.getContext('2d').drawImage(imgEl,0,0);return canvas.toDataURL('image/png');}
if(src instanceof HTMLImageElement){const loadedImgEl=src;if(checkImg(loadedImgEl)){return toPNGViaCanvas(loadedImgEl);}
src=loadedImgEl.src;}
return new Promise(resolve=>{const imgEl=new Image();imgEl.onload=()=>{if(format!=="svg+xml"||checkImg(imgEl)){resolve(imgEl);return;}
imgEl.height=1000;imgEl.style.opacity=0;document.body.appendChild(imgEl);const request=new XMLHttpRequest();request.open('GET',imgEl.src,true);request.onload=()=>{const parser=new DOMParser();const result=parser.parseFromString(request.responseText,'text/xml');const svgEl=result.getElementsByTagName("svg")[0];svgEl.setAttribute('width',imgEl.width);svgEl.setAttribute('height',imgEl.height);imgEl.remove();const svg64=btoa(new XMLSerializer().serializeToString(svgEl));const finalImg=new Image();finalImg.onload=()=>{resolve(finalImg);};finalImg.src=`data:image/svg+xml;base64,${svg64}`;};request.send();};imgEl.src=src;}).then(loadedImgEl=>toPNGViaCanvas(loadedImgEl));}
__exports.generateGMapIframe=generateGMapIframe;function generateGMapIframe(){const iframeEl=document.createElement('iframe');iframeEl.classList.add('s_map_embedded','o_not_editable');iframeEl.setAttribute('width','100%');iframeEl.setAttribute('height','100%');iframeEl.setAttribute('frameborder','0');iframeEl.setAttribute('scrolling','no');iframeEl.setAttribute('marginheight','0');iframeEl.setAttribute('marginwidth','0');iframeEl.setAttribute('src','about:blank');iframeEl.setAttribute('aria-label',_t("Map"));return iframeEl;}
__exports.generateGMapLink=generateGMapLink;function generateGMapLink(dataset){return'https://maps.google.com/maps?q='+encodeURIComponent(dataset.mapAddress)
+'&t='+encodeURIComponent(dataset.mapType)
+'&z='+encodeURIComponent(dataset.mapZoom)
+'&ie=UTF8&iwloc=&output=embed';}
function isMobile(self){let isMobile;self.trigger_up("service_context_get",{callback:(ctx)=>{isMobile=ctx["isMobile"];},});return isMobile;}
function getParsedDataFor(formId,parentEl){const dataForEl=parentEl.querySelector(`[data-for='${formId}']`);if(!dataForEl){return;}
return JSON.parse(dataForEl.dataset.values.replace(/([,:\[]\s*)True/g,'$1true').replace(/([,:\[]\s*)(False|None)/g,'$1""').replace(/'(\s*[,:\]}])/g,'"$1').replace(/([{\[:,]\s*)'/g,'$1"'));}
__exports.cloneContentEls=cloneContentEls;function cloneContentEls(content,keepScripts=false){let copyFragment;if(typeof content==="string"){copyFragment=new Range().createContextualFragment(content);}else{copyFragment=new DocumentFragment();const els=[...content.children].map(el=>el.cloneNode(true));copyFragment.append(...els);}
if(!keepScripts){copyFragment.querySelectorAll("script").forEach(scriptEl=>scriptEl.remove());}
return copyFragment;}
__exports.checkAndNotifySEO=checkAndNotifySEO;function checkAndNotifySEO(seo_data,OptimizeSEODialog,services){if(seo_data){let message;if(!seo_data.website_meta_title){message=_t("Page title not set.");}else if(!seo_data.website_meta_description){message=_t("Page description not set.");}
if(message){const closeNotification=services.notification.add(message,{type:"warning",sticky:false,buttons:[{name:_t("Optimize SEO"),onClick:()=>{services.dialog.add(OptimizeSEODialog);closeNotification();},},],});}}}
__exports[Symbol.for("default")]={loadAnchors:loadAnchors,autocompleteWithPages:autocompleteWithPages,onceAllImagesLoaded:onceAllImagesLoaded,prompt:prompt,sendRequest:sendRequest,websiteDomain:websiteDomain,isHTTPSorNakedDomainRedirection:isHTTPSorNakedDomainRedirection,svgToPNG:svgToPNG,webpToPNG:webpToPNG,generateGMapIframe:generateGMapIframe,generateGMapLink:generateGMapLink,isMobile:isMobile,getParsedDataFor:getParsedDataFor,cloneContentEls:cloneContentEls,checkAndNotifySEO:checkAndNotifySEO,};return __exports;});;

/* /website/static/src/components/autocomplete_with_pages/autocomplete_with_pages.js */
odoo.define('@website/components/autocomplete_with_pages/autocomplete_with_pages',['@web/core/autocomplete/autocomplete','@odoo/owl'],function(require){'use strict';let __exports={};const{AutoComplete}=require("@web/core/autocomplete/autocomplete");const{useEffect}=require("@odoo/owl");const AutoCompleteWithPages=__exports.AutoCompleteWithPages=class AutoCompleteWithPages extends AutoComplete{static props={...AutoComplete.props,targetDropdown:{type:HTMLElement},dropdownClass:{type:String,optional:true},dropdownOptions:{type:Object,optional:true},};static template="website.AutoCompleteWithPages";setup(){super.setup();useEffect((input,inputRef)=>{if(inputRef){inputRef.value=input.value;}
const targetBlur=this.onInputBlur.bind(this);const targetClick=this._syncInputClick.bind(this);const targetChange=this.onInputChange.bind(this);const targetInput=this._syncInputValue.bind(this);const targetKeydown=this.onInputKeydown.bind(this);const targetFocus=this.onInputFocus.bind(this);input.addEventListener("blur",targetBlur);input.addEventListener("click",targetClick);input.addEventListener("change",targetChange);input.addEventListener("input",targetInput);input.addEventListener("keydown",targetKeydown);input.addEventListener("focus",targetFocus);return()=>{input.removeEventListener("blur",targetBlur);input.removeEventListener("click",targetClick);input.removeEventListener("change",targetChange);input.removeEventListener("input",targetInput);input.removeEventListener("keydown",targetKeydown);input.removeEventListener("focus",targetFocus);};},()=>[this.targetDropdown,this.inputRef.el]);}
get dropdownOptions(){if(this.props.dropdownOptions){return{...super.dropdownOptions,...this.props.dropdownOptions,};}
return super.dropdownOptions;}
get ulDropdownClass(){let classList=super.ulDropdownClass;if(this.props.dropdownClass){classList+=` ${this.props.dropdownClass}`;}
return classList;}
get targetDropdown(){return this.props.targetDropdown;}
_syncInputClick(ev){ev.stopPropagation();this.onInputClick(ev);}
async _syncInputValue(){if(this.inputRef.el){this.inputRef.el.value=this.targetDropdown.value;this.onInput();}}
_isCategory(option){return!!option?.separator;}
getOption(indices){const[sourceIndex,optionIndex]=indices;return this.sources[sourceIndex]?.options[optionIndex];}
onOptionMouseEnter(indices){if(!this._isCategory(this.getOption(indices))){return super.onOptionMouseEnter(...arguments);}}
onOptionMouseLeave(indices){if(!this._isCategory(this.getOption(indices))){return super.onOptionMouseLeave(...arguments);}}
isActiveSourceOption(indices){if(!this._isCategory(this.getOption(indices))){return super.isActiveSourceOption(...arguments);}}
selectOption(option){if(!this._isCategory(option)){const{value}=Object.getPrototypeOf(option);this.targetDropdown.value=value;return super.selectOption(...arguments);}}
navigate(direction){super.navigate(direction);if(direction!==0&&this.state.activeSourceOption){let[sourceIndex,optionIndex]=this.state.activeSourceOption;const option=this.sources[sourceIndex]?.options[optionIndex];if(option){if(!!option.separator){this.navigate(direction);}
const suggestion=Object.getPrototypeOf(option);if(suggestion&&suggestion.value){this.inputRef.el.value=suggestion.value;}}}}
onInputFocus(ev){this.targetDropdown.setSelectionRange(0,this.targetDropdown.value.length);this.props.onFocus(ev);}}
return __exports;});;

/* /website/static/src/components/autocomplete_with_pages/url_autocomplete.js */
odoo.define('@website/components/autocomplete_with_pages/url_autocomplete',['@odoo/owl','@web/core/network/rpc','@website/components/autocomplete_with_pages/autocomplete_with_pages'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{rpc}=require("@web/core/network/rpc");const{AutoCompleteWithPages}=require("@website/components/autocomplete_with_pages/autocomplete_with_pages");const UrlAutoComplete=__exports.UrlAutoComplete=class UrlAutoComplete extends Component{static props={options:{type:Object},loadAnchors:{type:Function},targetDropdown:{type:HTMLElement},};static template="website.UrlAutoComplete";static components={AutoCompleteWithPages};_mapItemToSuggestion(item){return{...item,classList:item.separator?"ui-autocomplete-category":"ui-autocomplete-item",};}
get dropdownClass(){const classList=[];for(const key in this.props.options?.classes){classList.push(key,this.props.options.classes[key]);}
return classList.join(" ")}
get dropdownOptions(){const options={};if(this.props.options?.position){options.position=this.props.options?.position;}
return options;}
get sources(){return[{optionTemplate:"website.AutoCompleteWithPagesItem",options:async(term)=>{if(term[0]==="#"){const anchors=await this.props.loadAnchors(term,this.props.options&&this.props.options.body);return anchors.map((anchor)=>this._mapItemToSuggestion({label:anchor,value:anchor}));}else if(term.startsWith("http")||term.length===0){return[];}
if(this.props.options.isDestroyed?.()){return[];}
const res=await rpc("/website/get_suggested_links",{needle:term,limit:15,});let choices=res.matching_pages;res.others.forEach((other)=>{if(other.values.length){choices=choices.concat([{separator:other.title,label:other.title}],other.values);}});return choices.map(this._mapItemToSuggestion);},},];}
onSelect(selectedSubjection,{input}){const{value}=Object.getPrototypeOf(selectedSubjection);input.value=value;this.props.targetDropdown.value=value;this.props.options.urlChosen?.();}
onInput({inputValue}){this.props.targetDropdown.value=inputValue;}}
return __exports;});;

/* /barcodes/static/src/barcode_handler_field.js */
odoo.define('@barcodes/barcode_handler_field',['@web/core/registry','@web/views/fields/standard_field_props','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{useBus,useService}=require("@web/core/utils/hooks");const{Component,xml}=require("@odoo/owl");const BarcodeHandlerField=__exports.BarcodeHandlerField=class BarcodeHandlerField extends Component{static template=xml``;static props={...standardFieldProps};setup(){const barcode=useService("barcode");useBus(barcode.bus,"barcode_scanned",this.onBarcodeScanned);}
onBarcodeScanned(event){const{barcode}=event.detail;this.props.record.update({[this.props.name]:barcode});}}
const barcodeHandlerField=__exports.barcodeHandlerField={component:BarcodeHandlerField,};registry.category("fields").add("barcode_handler",barcodeHandlerField);return __exports;});;

/* /barcodes/static/src/barcode_handlers.js */
odoo.define('@barcodes/barcode_handlers',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/ui','@web/core/macro','@odoo/hoot-dom'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{getVisibleElements}=require("@web/core/utils/ui");const{Macro}=require("@web/core/macro");const{click,edit}=require("@odoo/hoot-dom");function clickOnButton(selector){const button=document.body.querySelector(selector);if(button){button.click();}}
function updatePager(position){const pager=document.body.querySelector("nav.o_pager");if(!pager||pager.innerText.includes("-")){return;}
let next;if(position==="first"){next=1;}else{next=parseInt(pager.querySelector(".o_pager_limit").textContent,10);}
let current=parseInt(pager.innerText.split('/')[0],10);if(current===next){return;}
new Macro({name:"updating pager",timeout:1000,steps:[{trigger:"span.o_pager_value",async action(trigger){await click(trigger);},},{trigger:"input.o_pager_value",async action(trigger){await click(trigger);await edit(next,{confirm:"blur"});},},],}).start();}
const COMMANDS=__exports.COMMANDS={"OCDEDIT":()=>clickOnButton(".o_form_button_edit"),"OCDDISC":()=>clickOnButton(".o_form_button_cancel"),"OCDSAVE":()=>clickOnButton(".o_form_button_save"),"OCDPREV":()=>clickOnButton(".o_pager_previous"),"OCDNEXT":()=>clickOnButton(".o_pager_next"),"OCDPAGERFIRST":()=>updatePager("first"),"OCDPAGERLAST":()=>updatePager("last"),};const barcodeGenericHandlers=__exports.barcodeGenericHandlers={dependencies:["ui","barcode","notification"],start(env,{ui,barcode,notification}){barcode.bus.addEventListener("barcode_scanned",(ev)=>{const barcode=ev.detail.barcode;if(barcode.startsWith("OBT")){let targets=[];try{targets=getVisibleElements(ui.activeElement,`[barcode_trigger=${barcode.slice(3)}]`);}catch{console.warn(`Barcode '${barcode}' is not valid`);}
for(let elem of targets){elem.click();}}
if(barcode.startsWith("OCD")){const fn=COMMANDS[barcode];if(fn){fn();}else{notification.add(_t("Barcode: %(barcode)s",{barcode}),{title:_t("Unknown barcode command"),type:"danger"});}}});}};registry.category("services").add("barcode_handlers",barcodeGenericHandlers);return __exports;});;

/* /barcodes/static/src/barcode_service.js */
odoo.define('@barcodes/barcode_service',['@web/core/browser/feature_detection','@web/core/registry','@web/session','@odoo/owl'],function(require){'use strict';let __exports={};const{isBrowserChrome,isMobileOS}=require("@web/core/browser/feature_detection");const{registry}=require("@web/core/registry");const{session}=require("@web/session");const{EventBus,whenReady}=require("@odoo/owl");function isEditable(element){return element.matches('input,textarea,[contenteditable="true"]');}
function makeBarcodeInput(){const inputEl=document.createElement('input');inputEl.setAttribute("style","position:fixed;top:50%;transform:translateY(-50%);z-index:-1;opacity:0");inputEl.setAttribute("autocomplete","off");inputEl.setAttribute("inputmode","none");inputEl.classList.add("o-barcode-input");inputEl.setAttribute('name','barcode');return inputEl;}
const barcodeService=__exports.barcodeService={maxTimeBetweenKeysInMs:session.max_time_between_keys_in_ms||150,isMobileChrome:isMobileOS()&&isBrowserChrome(),cleanBarcode:function(barcode){return barcode.replace(/Alt|Shift|Control/g,'');},start(){const bus=new EventBus();let timeout=null;let bufferedBarcode="";let currentTarget=null;let barcodeInput=null;function handleBarcode(barcode,target){bus.trigger('barcode_scanned',{barcode,target});if(target.getAttribute('barcode_events')==="true"){const barcodeScannedEvent=new CustomEvent("barcode_scanned",{detail:{barcode,target}});target.dispatchEvent(barcodeScannedEvent);}}
function checkBarcode(ev){let str=barcodeInput?barcodeInput.value:bufferedBarcode;str=barcodeService.cleanBarcode(str);if(str.length>=3){if(ev){ev.preventDefault();}
handleBarcode(str,currentTarget);}
if(barcodeInput){barcodeInput.value="";}
bufferedBarcode="";currentTarget=null;}
function keydownHandler(ev){if(!ev.key){return;}
const isSpecialKey=!['Control','Alt'].includes(ev.key)&&(ev.key.length>1||ev.metaKey);const isEndCharacter=ev.key.match(/(Enter|Tab)/);if(isSpecialKey&&!isEndCharacter){return;}
currentTarget=ev.target;if(currentTarget!==barcodeInput&&isEditable(currentTarget)&&!currentTarget.dataset.enableBarcode&&currentTarget.getAttribute("barcode_events")!=="true"){return;}
clearTimeout(timeout);if(isEndCharacter){checkBarcode(ev);}else{bufferedBarcode+=ev.key;timeout=setTimeout(checkBarcode,barcodeService.maxTimeBetweenKeysInMs);}}
function mobileChromeHandler(ev){if(ev.key==="Unidentified"){return;}
if(document.activeElement&&!document.activeElement.matches('input:not([type]), input[type="text"], textarea, [contenteditable], '+'[type="email"], [type="number"], [type="password"], [type="tel"], [type="search"]')){barcodeInput.focus();}
keydownHandler(ev);}
whenReady(()=>{const isMobileChrome=barcodeService.isMobileChrome;if(isMobileChrome){barcodeInput=makeBarcodeInput();document.body.appendChild(barcodeInput);}
const handler=isMobileChrome?mobileChromeHandler:keydownHandler;document.body.addEventListener('keydown',handler);});return{bus,};},};registry.category("services").add("barcode",barcodeService);return __exports;});;

/* /barcodes/static/src/components/barcode_scanner.js */
odoo.define('@barcodes/components/barcode_scanner',['@web/core/l10n/translation','@web/core/barcode/barcode_dialog','@web/core/barcode/barcode_video_scanner','@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{scanBarcode}=require("@web/core/barcode/barcode_dialog");const{isBarcodeScannerSupported}=require("@web/core/barcode/barcode_video_scanner");const{Component}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const BarcodeScanner=__exports.BarcodeScanner=class BarcodeScanner extends Component{static template="barcodes.BarcodeScanner";static props={onBarcodeScanned:{type:Function},};setup(){this.notification=useService("notification");this.isBarcodeScannerSupported=isBarcodeScannerSupported();this.scanBarcode=()=>scanBarcode(this.env,this.facingMode);}
get facingMode(){return"environment";}
async openMobileScanner(){let error=null;let barcode=null;try{barcode=await this.scanBarcode();}catch(err){error=err.message;}
if(barcode){this.props.onBarcodeScanned(barcode);if("vibrate"in window.navigator){window.navigator.vibrate(100);}}else{this.notification.add(error||_t("Please, Scan again!"),{type:"warning",});}}}
return __exports;});;

/* /barcodes/static/src/float_scannable_field.js */
odoo.define('@barcodes/float_scannable_field',['@web/core/registry','@web/views/fields/float/float_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{FloatField,floatField}=require("@web/views/fields/float/float_field");const FloatScannableField=__exports.FloatScannableField=class FloatScannableField extends FloatField{static template="barcodes.FloatScannableField";onBarcodeScanned(){this.inputRef.el.dispatchEvent(new InputEvent("input"));}}
const floatScannableField=__exports.floatScannableField={...floatField,component:FloatScannableField,};registry.category("fields").add("field_float_scannable",floatScannableField);return __exports;});;

/* /barcodes/static/src/js/barcode_parser.js */
odoo.define('@barcodes/js/barcode_parser',[],function(require){'use strict';let __exports={};const BarcodeParser=__exports.BarcodeParser=class BarcodeParser{static barcodeNomenclatureFields=["name","rule_ids","upc_ean_conv"];static barcodeRuleFields=["name","sequence","type","encoding","pattern","alias"];static async fetchNomenclature(orm,id){const[nomenclature]=await orm.read("barcode.nomenclature",[id],this.barcodeNomenclatureFields);let rules=await orm.searchRead("barcode.rule",[["barcode_nomenclature_id","=",id]],this.barcodeRuleFields);rules=rules.sort((a,b)=>{return a.sequence-b.sequence;});nomenclature.rules=rules;return nomenclature;}
constructor(){this.setup(...arguments);}
setup({nomenclature}){this.nomenclature=nomenclature;}
get_barcode_check_digit(numericBarcode){let oddsum=0,evensum=0,total=0;const code=numericBarcode.split('').reverse();code.shift();for(let i=0;i<code.length;i++){if(i%2===0){evensum+=parseInt(code[i]);}else{oddsum+=parseInt(code[i]);}}
total=evensum*3+oddsum;return(10-total%10)%10;}
check_encoding(barcode,encoding){if(encoding==='any'){return true;}
const barcodeSizes={ean8:8,ean13:13,upca:12,};return barcode.length===barcodeSizes[encoding]&&/^\d+$/.test(barcode)&&this.get_barcode_check_digit(barcode)===parseInt(barcode[barcode.length-1]);}
sanitize_ean(ean){ean=ean.substr(0,13);ean="0".repeat(13-ean.length)+ean;return ean.substr(0,12)+this.get_barcode_check_digit(ean);}
sanitize_upc(upc){return this.sanitize_ean(upc).substr(1,12);}
match_pattern(barcode,pattern,encoding){var match={value:0,base_code:barcode,match:false,};barcode=barcode.replace("\\","\\\\").replace("{",'\{').replace("}","\}").replace(".","\.");var numerical_content=pattern.match(/[{][N]*[D]*[}]/);var base_pattern=pattern;if(numerical_content){var num_start=numerical_content.index;var num_length=numerical_content[0].length;var value_string=barcode.substr(num_start,num_length-2);var whole_part_match=numerical_content[0].match("[{][N]*[D}]");var decimal_part_match=numerical_content[0].match("[{N][D]*[}]");var whole_part=value_string.substr(0,whole_part_match.index+whole_part_match[0].length-2);var decimal_part="0."+value_string.substr(decimal_part_match.index,decimal_part_match[0].length-1);if(whole_part===''){whole_part='0';}
match.value=parseInt(whole_part)+parseFloat(decimal_part);match.base_code=barcode.substr(0,num_start);base_pattern=pattern.substr(0,num_start);for(var i=0;i<(num_length-2);i++){match.base_code+="0";base_pattern+="0";}
match.base_code+=barcode.substr(num_start+num_length-2,barcode.length-1);base_pattern+=pattern.substr(num_start+num_length,pattern.length-1);match.base_code=match.base_code.replace("\\\\","\\").replace("\{","{").replace("\}","}").replace("\.",".");var base_code=match.base_code.split('');if(encoding==='ean13'){base_code[12]=''+this.get_barcode_check_digit(match.base_code);}else if(encoding==='ean8'){base_code[7]=''+this.get_barcode_check_digit(match.base_code);}else if(encoding==='upca'){base_code[11]=''+this.get_barcode_check_digit(match.base_code);}
match.base_code=base_code.join('');}
base_pattern=base_pattern.split('|').map(part=>part.startsWith('^')?part:'^'+part).join('|');match.match=match.base_code.match(base_pattern);return match;}
parse_barcode(barcode){if(barcode.match(/^urn:/)){return this.parseURI(barcode);}
return this.parseBarcodeNomenclature(barcode);}
parseBarcodeNomenclature(barcode){const parsed_result={encoding:'',type:'error',code:barcode,base_code:barcode,value:0,};if(!this.nomenclature){return parsed_result;}
var rules=this.nomenclature.rules;for(var i=0;i<rules.length;i++){var rule=rules[i];var cur_barcode=barcode;if(rule.encoding==='ean13'&&this.check_encoding(barcode,'upca')&&this.nomenclature.upc_ean_conv in{'upc2ean':'','always':''}){cur_barcode='0'+cur_barcode;}else if(rule.encoding==='upca'&&this.check_encoding(barcode,'ean13')&&barcode[0]==='0'&&this.nomenclature.upc_ean_conv in{'ean2upc':'','always':''}){cur_barcode=cur_barcode.substr(1,12);}
if(!this.check_encoding(cur_barcode,rule.encoding)){continue;}
var match=this.match_pattern(cur_barcode,rules[i].pattern,rule.encoding);if(match.match){if(rules[i].type==='alias'){barcode=rules[i].alias;parsed_result.code=barcode;parsed_result.type='alias';}
else{parsed_result.encoding=rules[i].encoding;parsed_result.type=rules[i].type;parsed_result.value=match.value;parsed_result.code=cur_barcode;if(rules[i].encoding==="ean13"){parsed_result.base_code=this.sanitize_ean(match.base_code);}
else{parsed_result.base_code=match.base_code;}
return parsed_result;}}}
return parsed_result;}
parseURI(barcode){const uriParts=barcode.split(":").map(v=>v.trim());const identifier=uriParts[3];const data=uriParts[4].split(".");if(identifier==="lgtin"||identifier==="sgtin"){return this.convertURIGTINDataIntoProductAndTrackingNumber(barcode,data);}else if(identifier==="sgtin-96"||identifier==="sgtin-198"){return this.convertURIGTINDataIntoProductAndTrackingNumber(barcode,data.slice(1));}else if(identifier==="sscc"){return this.convertURISSCCDataIntoPackage(barcode,data);}else if(identifier==="sscc-96"){return this.convertURISSCCDataIntoPackage(barcode,data.slice(1));}
return barcode;}
convertURIGTINDataIntoProductAndTrackingNumber(base_code,data){const[gs1CompanyPrefix,itemRefAndIndicator,trackingNumber]=data;const indicator=itemRefAndIndicator[0];const itemRef=itemRefAndIndicator.slice(1);let productBarcode=indicator+gs1CompanyPrefix+itemRef;productBarcode+=this.get_barcode_check_digit(productBarcode+"0");return[{base_code,code:productBarcode,string_value:productBarcode,type:"product",value:productBarcode,},{base_code,code:trackingNumber,string_value:trackingNumber,type:"lot",value:trackingNumber,}];}
convertURISSCCDataIntoPackage(base_code,data){const[gs1CompanyPrefix,serialReference]=data;const extension=serialReference[0];const serialRef=serialReference.slice(1);let sscc=extension+gs1CompanyPrefix+serialRef;sscc+=this.get_barcode_check_digit(sscc+"0");return[{base_code,code:sscc,string_value:sscc,type:"package",value:sscc,}];}}
return __exports;});;

/* /barcodes_gs1_nomenclature/static/src/js/barcode_parser.js */
odoo.define('@barcodes_gs1_nomenclature/js/barcode_parser',['@web/core/utils/patch','@barcodes/js/barcode_parser','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{BarcodeParser}=require("@barcodes/js/barcode_parser");const{_t}=require("@web/core/l10n/translation");const GS1BarcodeError=__exports.GS1BarcodeError=class GS1BarcodeError extends Error{};const FNC1_CHAR=__exports.FNC1_CHAR=String.fromCharCode(29);patch(BarcodeParser,{barcodeNomenclatureFields:[...BarcodeParser.barcodeNomenclatureFields,"is_gs1_nomenclature","gs1_separator_fnc1",],barcodeRuleFields:[...BarcodeParser.barcodeRuleFields,"gs1_content_type","gs1_decimal_usage","associated_uom_id",],});patch(BarcodeParser.prototype,{setup(attributes){super.setup(...arguments);const nomenclatureSeparator=this.nomenclature&&this.nomenclature.gs1_separator_fnc1;this.gs1SeparatorRegex=new RegExp(nomenclatureSeparator||'.^','g');},gs1_date_to_date(gs1Date){const now=new Date();const substractYear=parseInt(gs1Date.slice(0,2))-(now.getFullYear()%100);let century=Math.floor(now.getFullYear()/100);if(51<=substractYear&&substractYear<=99){century--;}else if(-99<=substractYear&&substractYear<=-50){century++;}
const year=century*100+parseInt(gs1Date.slice(0,2));const date=new Date(year,parseInt(gs1Date.slice(2,4)-1));if(gs1Date.slice(-2)==='00'){date.setDate(new Date(year,parseInt(gs1Date.slice(2,4)),0).getDate());}else{date.setDate(parseInt(gs1Date.slice(-2)));}
return date;},parse_gs1_rule_pattern(match,rule){const result={rule:Object.assign({},rule),ai:match[1],string_value:match[2],code:match[2],base_code:match[2],type:rule.type};if(rule.gs1_content_type==='measure'){let decimalPosition=0;if(rule.gs1_decimal_usage){decimalPosition=parseInt(match[1][match[1].length-1]);}
if(decimalPosition>0){const integral=match[2].slice(0,match[2].length-decimalPosition);const decimal=match[2].slice(match[2].length-decimalPosition);result.value=parseFloat(integral+"."+decimal);}else{result.value=parseInt(match[2]);}}else if(rule.gs1_content_type==='identifier'){if(parseInt(match[2][match[2].length-1])!==this.get_barcode_check_digit("0".repeat(18-match[2].length)+match[2])){throw new Error(_t("Invalid barcode: the check digit is incorrect"));}
result.value=match[2];}else if(rule.gs1_content_type==='date'){if(match[2].length!==6){throw new Error(_t("Invalid barcode: can't be formated as date"));}
result.value=this.gs1_date_to_date(match[2]);}else{result.value=match[2];}
return result;},gs1_decompose_extanded(barcode){const results=[];const rules=this.nomenclature.rules.filter(rule=>rule.encoding==='gs1-128');const separatorReg=`(?:${FNC1_CHAR}+)?`;barcode=this._convertGS1Separators(barcode);barcode=this.cleanBarcode(barcode);while(barcode.length>0){const barcodeLength=barcode.length;for(const rule of rules){const match=barcode.match("^"+rule.pattern+separatorReg);if(match&&match.length>=3){const res=this.parse_gs1_rule_pattern(match,rule);if(res){barcode=barcode.slice(match.index+match[0].length);results.push(res);if(barcode.length===0){return results;}}else{throw new GS1BarcodeError(_t("This barcode can't be parsed by any barcode rules."));}}}
if(barcodeLength===barcode.length){throw new GS1BarcodeError(_t("This barcode can't be partially or fully parsed."));}}
return results;},parseBarcodeNomenclature(barcode){if(this.nomenclature&&this.nomenclature.is_gs1_nomenclature){return this.gs1_decompose_extanded(barcode);}
return super.parseBarcodeNomenclature(...arguments);},cleanBarcode(barcode){if(barcode[0]===FNC1_CHAR){barcode=barcode.slice(1);}
return barcode;},_convertGS1Separators:function(barcode){barcode=barcode.replace(this.gs1SeparatorRegex,FNC1_CHAR);return barcode;},});return __exports;});;

/* /barcodes_gs1_nomenclature/static/src/js/barcode_service.js */
odoo.define('@barcodes_gs1_nomenclature/js/barcode_service',['@web/session','@web/core/utils/patch','@barcodes/barcode_service','@barcodes_gs1_nomenclature/js/barcode_parser'],function(require){'use strict';let __exports={};const{session}=require("@web/session");const{patch}=require("@web/core/utils/patch");const{barcodeService}=require('@barcodes/barcode_service');const{FNC1_CHAR}=require("@barcodes_gs1_nomenclature/js/barcode_parser");patch(barcodeService,{gs1SeparatorRegex:new RegExp(session.gs1_group_separator_encodings||'.^','g'),cleanBarcode(barcode){barcode=barcode.replace(barcodeService.gs1SeparatorRegex,FNC1_CHAR);return super.cleanBarcode(barcode);},});return __exports;});;

/* /stock/static/src/client_actions/multi_print.js */
odoo.define('@stock/client_actions/multi_print',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{sprintf}=require("@web/core/utils/strings");async function doMultiPrint(env,action){for(const report of action.params.reports){if(report.type!="ir.actions.report"){env.services.notification.add(_t("Incorrect type of action submitted as a report, skipping action"),{title:_t("Report Printing Error"),});continue}else if(report.report_type==="qweb-html"){env.services.notification.add(sprintf(_t("HTML reports cannot be auto-printed, skipping report: %s"),report.name),{title:_t("Report Printing Error"),});continue}
await env.services.action.doAction({type:"ir.actions.report",...report});}
if(action.params.anotherAction){return env.services.action.doAction(action.params.anotherAction);}else if(action.params.onClose){action.params.onClose()}else{return env.services.action.doAction("reload_context");}}
registry.category("actions").add("do_multi_print",doMultiPrint);return __exports;});;

/* /stock/static/src/client_actions/stock_traceability_report_backend.js */
odoo.define('@stock/client_actions/stock_traceability_report_backend',['@web/core/l10n/translation','@odoo/owl','@web/core/network/download','@web/core/registry','@web/core/utils/hooks','@web/search/action_hook','@web/search/layout','@web/webclient/actions/action_service'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component,onWillStart,useState}=require("@odoo/owl");const{download}=require("@web/core/network/download");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{useSetupAction}=require("@web/search/action_hook");const{Layout}=require("@web/search/layout");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");function processLine(line){return{...line,lines:[],isFolded:true};}
function extractPrintData(lines){const data=[];for(const line of lines){const{id,model_id,model,unfoldable,level}=line;data.push({id:id,model_id:model_id,model_name:model,unfoldable,level:level||1,});if(!line.isFolded){data.push(...extractPrintData(line.lines));}}
return data;}
const TraceabilityReport=__exports.TraceabilityReport=class TraceabilityReport extends Component{static template="stock.TraceabilityReport";static components={Layout};static props={...standardActionServiceProps};setup(){this.actionService=useService("action");this.orm=useService("orm");onWillStart(this.onWillStart);useSetupAction({getLocalState:()=>({lines:[...this.state.lines],}),});this.state=useState({lines:this.props.state?.lines||[],});const{active_id,active_model,auto_unfold,context,lot_name,ttype,url,lang}=this.props.action.context;this.controllerUrl=url;this.context=context||{};Object.assign(this.context,{active_id:active_id||this.props.action.params.active_id,auto_unfold:auto_unfold||false,model:active_model||this.props.action.context.params?.active_model||false,lot_name:lot_name||false,ttype:ttype||false,lang:lang||false,});if(this.context.model){this.props.updateActionState({active_model:this.context.model});}
this.display={controlPanel:{},searchPanel:false,};}
async onWillStart(){if(!this.state.lines.length){const mainLines=await this.orm.call("stock.traceability.report","get_main_lines",[this.context,]);this.state.lines=mainLines.map(processLine);}}
onClickBoundLink(line){this.actionService.doAction({type:"ir.actions.act_window",res_model:line.res_model,res_id:line.res_id,views:[[false,"form"]],target:"current",});}
onCLickOpenLot(line){this.actionService.doAction({type:"ir.actions.client",tag:"stock_report_generic",name:line.lot_name!==undefined&&line.lot_name.toString(),context:{active_id:line.lot_id,active_model:"stock.lot",url:"/stock/output_format/stock?active_id=:active_id&active_model=:active_model",},});}
onClickUpDownStream(line){this.actionService.doAction({type:"ir.actions.client",tag:"stock_report_generic",name:_t("Traceability Report"),context:{active_id:line.model_id,active_model:line.model,auto_unfold:true,lot_name:line.lot_name!==undefined&&line.lot_name,url:"/stock/output_format/stock/active_id",},});}
onClickPrint(){const data=JSON.stringify(extractPrintData(this.state.lines));const url=this.controllerUrl.replace(":active_id",this.context.active_id).replace(":active_model",this.context.model).replace("output_format","pdf");download({data:{data},url,});}
async toggleLine(line){line.isFolded=!line.isFolded;if(!line.lines.length){line.lines=(await this.orm.call("stock.traceability.report","get_lines",[line.id],{model_id:line.model_id,model_name:line.model,level:line.level+30||1,})).map(processLine);}}}
registry.category("actions").add("stock_report_generic",TraceabilityReport);return __exports;});;

/* /stock/static/src/components/reception_report_line/stock_reception_report_line.js */
odoo.define('@stock/components/reception_report_line/stock_reception_report_line',['@web/core/utils/hooks','@web/views/fields/formatters','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{formatFloat}=require("@web/views/fields/formatters");const{Component}=require("@odoo/owl");const ReceptionReportLine=__exports.ReceptionReportLine=class ReceptionReportLine extends Component{static template="stock.ReceptionReportLine";static props={data:Object,parentIndex:String,showUom:Boolean,precision:Number,};setup(){this.ormService=useService("orm");this.actionService=useService("action");this.formatFloat=(val)=>formatFloat(val,{digits:[false,this.props.precision]});}
async onClickForecast(){const action=await this.ormService.call("stock.move","action_product_forecast_report",[[this.data.move_out_id]],);return this.actionService.doAction(action);}
async onClickPrint(){if(!this.data.move_out_id){return;}
const reportFile='stock.report_reception_report_label';const modelIds=[this.data.move_out_id];const productQtys=[Math.ceil(this.data.quantity)||'1'];return this.actionService.doAction({type:"ir.actions.report",report_type:"qweb-pdf",report_name:`${reportFile}?docids=${modelIds}&quantity=${productQtys}`,report_file:reportFile,});}
async onClickAssign(){await this.ormService.call("report.stock.report_reception","action_assign",[false,[this.data.move_out_id],[this.data.quantity],[this.data.move_ins]],);this.env.bus.trigger("update-assign-state",{isAssigned:true,tableIndex:this.props.parentIndex,lineIndex:this.data.index});}
async onClickUnassign(){const done=await this.ormService.call("report.stock.report_reception","action_unassign",[false,this.data.move_out_id,this.data.quantity,this.data.move_ins])
if(done){this.env.bus.trigger("update-assign-state",{isAssigned:false,tableIndex:this.props.parentIndex,lineIndex:this.data.index});}}
get data(){return this.props.data;}}
return __exports;});;

/* /stock/static/src/components/reception_report_main/stock_reception_report_main.js */
odoo.define('@stock/components/reception_report_main/stock_reception_report_main',['@web/core/registry','@web/core/utils/hooks','@web/search/control_panel/control_panel','@stock/components/reception_report_table/stock_reception_report_table','@odoo/owl','@web/webclient/actions/action_service'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useBus,useService}=require("@web/core/utils/hooks");const{ControlPanel}=require("@web/search/control_panel/control_panel");const{ReceptionReportTable}=require("@stock/components/reception_report_table/stock_reception_report_table");const{Component,onWillStart,useState}=require("@odoo/owl");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");const ReceptionReportMain=__exports.ReceptionReportMain=class ReceptionReportMain extends Component{static template="stock.ReceptionReportMain";static components={ControlPanel,ReceptionReportTable,};static props={...standardActionServiceProps};setup(){this.controlPanelDisplay={};this.ormService=useService("orm");this.actionService=useService("action");this.reportName="stock.report_reception";this.state=useState({sourcesToLines:{},});useBus(this.env.bus,"update-assign-state",(ev)=>this._changeAssignedState(ev.detail));onWillStart(async()=>{let defaultDocIds;const{rfield,rids}=this.props.action.context.params||{};if(rfield&&rids){const parsedIds=JSON.parse(rids);defaultDocIds=[rfield,parsedIds instanceof Array?parsedIds:[parsedIds]];}else{defaultDocIds=Object.entries(this.context).find(([k,v])=>k.startsWith("default_"));if(!defaultDocIds){defaultDocIds=[false,[0]];}}
this.contextDefaultDoc={field:defaultDocIds[0],ids:defaultDocIds[1]};if(this.contextDefaultDoc.field){this.props.updateActionState({rfield:this.contextDefaultDoc.field,rids:JSON.stringify(this.contextDefaultDoc.ids)});}
this.data=await this.getReportData();this.state.sourcesToLines=this.data.sources_to_lines;});}
async getReportData(){const context={...this.context,[this.contextDefaultDoc.field]:this.contextDefaultDoc.ids};const args=[this.contextDefaultDoc.ids,{context,report_type:"html"},];return this.ormService.call("report.stock.report_reception","get_report_data",args,{context},);}
async onClickAssignAll(){const moveIds=[];const quantities=[];const inIds=[];for(const lines of Object.values(this.state.sourcesToLines)){for(const line of lines){if(line.is_assigned)continue;moveIds.push(line.move_out_id);quantities.push(line.quantity);inIds.push(line.move_ins);}}
await this.ormService.call("report.stock.report_reception","action_assign",[false,moveIds,quantities,inIds],);this._changeAssignedState({isAssigned:true});}
async onClickTitle(docId){return this.actionService.doAction({type:"ir.actions.act_window",res_model:this.data.doc_model,res_id:docId,views:[[false,"form"]],target:"current",});}
onClickPrint(){return this.actionService.doAction({type:"ir.actions.report",report_type:"qweb-pdf",report_name:`${this.reportName}/?context={"${this.contextDefaultDoc.field}": ${JSON.stringify(this.contextDefaultDoc.ids)}}`,report_file:this.reportName,});}
onClickPrintLabels(){const reportFile='stock.report_reception_report_label';const modelIds=[];const quantities=[];for(const lines of Object.values(this.state.sourcesToLines)){for(const line of lines){if(!line.is_assigned)continue;modelIds.push(line.move_out_id);quantities.push(Math.ceil(line.quantity)||1);}}
if(!modelIds.length){return;}
return this.actionService.doAction({type:"ir.actions.report",report_type:"qweb-pdf",report_name:`${reportFile}?docids=${modelIds}&quantity=${quantities}`,report_file:reportFile,});}
_changeAssignedState(options){const{isAssigned,tableIndex,lineIndex}=options;for(const[tabIndex,lines]of Object.entries(this.state.sourcesToLines)){if(tableIndex&&tableIndex!=tabIndex)continue;lines.forEach(line=>{if(isNaN(lineIndex)||lineIndex==line.index){line.is_assigned=isAssigned;}});}}
get context(){return this.props.action.context;}
get hasContent(){return this.data.sources_to_lines&&Object.keys(this.data.sources_to_lines).length>0;}
get isAssignAllDisabled(){return Object.values(this.state.sourcesToLines).every(lines=>lines.every(line=>line.is_assigned||!line.is_qty_assignable));}
get isPrintLabelDisabled(){return Object.values(this.state.sourcesToLines).every(lines=>lines.every(line=>!line.is_assigned));}}
registry.category("actions").add("reception_report",ReceptionReportMain);return __exports;});;

/* /stock/static/src/components/reception_report_table/stock_reception_report_table.js */
odoo.define('@stock/components/reception_report_table/stock_reception_report_table',['@web/core/utils/hooks','@stock/components/reception_report_line/stock_reception_report_line','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{ReceptionReportLine}=require("@stock/components/reception_report_line/stock_reception_report_line");const{Component}=require("@odoo/owl");const ReceptionReportTable=__exports.ReceptionReportTable=class ReceptionReportTable extends Component{static template="stock.ReceptionReportTable";static components={ReceptionReportLine,};static props={index:String,scheduledDate:{type:String,optional:true},lines:Array,source:Array,showUom:Boolean,precision:Number,};setup(){this.actionService=useService("action");this.ormService=useService("orm");}
async onClickAssignAll(){const moveIds=[];const quantities=[];const inIds=[];for(const line of this.props.lines){if(line.is_assigned)continue;moveIds.push(line.move_out_id);quantities.push(line.quantity);inIds.push(line.move_ins);}
await this.ormService.call("report.stock.report_reception","action_assign",[false,moveIds,quantities,inIds],);this.env.bus.trigger("update-assign-state",{isAssigned:true,tableIndex:this.props.index});}
async onClickLink(resModel,resId,viewType){return this.actionService.doAction({type:"ir.actions.act_window",res_model:resModel,res_id:resId,views:[[false,viewType]],target:"current",});}
async onClickPrintLabels(){const reportFile='stock.report_reception_report_label';const modelIds=[];const quantities=[];for(const line of this.props.lines){if(!line.is_assigned)continue;modelIds.push(line.move_out_id);quantities.push(Math.ceil(line.quantity)||1);}
if(!modelIds.length){return;}
return this.actionService.doAction({type:"ir.actions.report",report_type:"qweb-pdf",report_name:`${reportFile}?docids=${modelIds}&quantity=${quantities}`,report_file:reportFile,});}
get hasMovesIn(){return this.props.lines.some(line=>line.move_ins&&line.move_ins.length>0);}
get hasAssignAllButton(){return this.props.lines.some(line=>line.is_qty_assignable);}
get isAssignAllDisabled(){return this.props.lines.every(line=>line.is_assigned);}
get isPrintLabelDisabled(){return this.props.lines.every(line=>!line.is_assigned);}}
return __exports;});;

/* /stock/static/src/components/stock_overview/stock_overview.js */
odoo.define('@stock/components/stock_overview/stock_overview',['@web/core/registry','@web/views/kanban/kanban_view','@web/views/kanban/kanban_renderer','@web/model/relational_model/dynamic_record_list','@web/model/relational_model/dynamic_group_list'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{DynamicRecordList}=require("@web/model/relational_model/dynamic_record_list");const{DynamicGroupList}=require("@web/model/relational_model/dynamic_group_list");const StockKanbanRenderer=__exports.StockKanbanRenderer=class StockKanbanRenderer extends KanbanRenderer{setup(){super.setup();}
getGroupsOrRecords(){const{list}=this.props;let records=[];if(list instanceof DynamicRecordList){records.push(...list.records);}else if(list instanceof DynamicGroupList){list.groups.forEach(g=>{records.push(...g.list.records);});}
let allEmpty=records.every(r=>{return r.data.kanban_dashboard_graph.includes('"type": "sample"');});if(allEmpty){records.forEach(r=>{let parsedDashboardData=JSON.parse(r.data.kanban_dashboard_graph);parsedDashboardData[0].values.forEach(d=>{d.value=Math.floor(Math.random()*9+1);});r.data.kanban_dashboard_graph=JSON.stringify(parsedDashboardData);});}
return super.getGroupsOrRecords();}}
const StockKanbanView=__exports.StockKanbanView={...kanbanView,Renderer:StockKanbanRenderer,};registry.category("views").add("stock_dashboard_kanban",StockKanbanView);return __exports;});;

/* /stock/static/src/fields/stock_move_line_x2_many_field.js */
odoo.define('@stock/fields/stock_move_line_x2_many_field',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/x2many/x2many_field','@web/views/fields/relational_utils','@web/core/utils/hooks','@web/core/domain'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const{useSelectCreate,useOpenMany2XRecord}=require("@web/views/fields/relational_utils");const{useService}=require("@web/core/utils/hooks");const{Domain}=require("@web/core/domain");const SMLX2ManyField=__exports.SMLX2ManyField=class SMLX2ManyField extends X2ManyField{setup(){super.setup();this.orm=useService("orm");this.dirtyQuantsData=new Map();const selectCreate=useSelectCreate({resModel:"stock.quant",activeActions:this.activeActions,onSelected:(resIds)=>this.selectRecord(resIds),onCreateEdit:()=>this.createOpenRecord(),});this.selectCreate=(params)=>{return selectCreate(params);};this.openQuantRecord=useOpenMany2XRecord({resModel:"stock.quant",activeActions:this.activeActions,onRecordSaved:(record)=>this.selectRecord([record.resId]),fieldString:this.props.string,is2Many:true,});}
async onAdd({context,editable}={}){if(!this.props.record.data.show_quant){return super.onAdd(...arguments);}
await this.updateDirtyQuantsData();context={...context,single_product:true,list_view_ref:"stock.view_stock_quant_tree_simple",search_default_on_hand:true,search_default_in_stock:true,};const productName=this.props.record.data.product_id[1];const title=_t("Add line: %s",productName);let domain=[["product_id","=",this.props.record.data.product_id[0]],["location_id","child_of",this.props.context.default_location_id],];if(this.dirtyQuantsData.size){const notFullyUsed=[];const fullyUsed=[];for(const[quantId,quantData]of this.dirtyQuantsData.entries()){if(quantData.available_quantity>0){notFullyUsed.push(quantId);}else{fullyUsed.push(quantId);}}
if(fullyUsed.length){domain=Domain.and([domain,[["id","not in",fullyUsed]]]).toList();}
if(notFullyUsed.length){domain=Domain.or([domain,[["id","in",notFullyUsed]]]).toList();}}
return this.selectCreate({domain,context,title});}
async updateDirtyQuantsData(){this.dirtyQuantsData.clear();const dirtyQuantityMoveLines=this.props.record.data.move_line_ids.records.filter((ml)=>!ml.data.quant_id&&ml._values.quantity-ml._changes.quantity);const dirtyQuantMoveLines=this.props.record.data.move_line_ids.records.filter((ml)=>ml.data.quant_id[0]);const dirtyMoveLines=[...dirtyQuantityMoveLines,...dirtyQuantMoveLines];if(!dirtyMoveLines.length){return;}
const match=await this.orm.call("stock.move.line","get_move_line_quant_match",[this.props.record.data.move_line_ids.records.filter((rec)=>rec.resId).map((rec)=>rec.resId),this.props.record.resId,dirtyMoveLines.filter((rec)=>rec.resId).map((rec)=>rec.resId),dirtyQuantMoveLines.map((ml)=>ml.data.quant_id[0]),],{});const quants=match[0];if(!quants.length){return;}
const dbMoveLinesData=new Map();for(const data of match[1]){dbMoveLinesData.set(data[0],{quantity:data[1].quantity,quantId:data[1].quant_id});}
const offsetByQuant=new Map();for(const ml of dirtyQuantMoveLines){const quantId=ml.data.quant_id[0];offsetByQuant.set(quantId,(offsetByQuant.get(quantId)||0)-ml.data.quantity);const dbQuantId=dbMoveLinesData.get(ml.resId)?.quantId;if(dbQuantId&&quantId!=dbQuantId){offsetByQuant.set(dbQuantId,(offsetByQuant.get(dbQuantId)||0)+dbMoveLinesData.get(ml.resId).quantity);}}
const offsetByQuantity=new Map();for(const ml of dirtyQuantityMoveLines){offsetByQuantity.set(ml.resId,ml._values.quantity-ml._changes.quantity);}
for(const quant of quants){const quantityOffest=quant[1].move_line_ids.map((ml)=>offsetByQuantity.get(ml)||0).reduce((val,sum)=>val+sum,0);const quantOffest=offsetByQuant.get(quant[0])||0;this.dirtyQuantsData.set(quant[0],{available_quantity:quant[1].available_quantity+quantityOffest+quantOffest,});}}
async selectRecord(res_ids){const demand=this.props.record.data.product_uom_qty-
this.props.record.data.move_line_ids.records.map((ml)=>ml.data.quantity).reduce((val,sum)=>val+sum,0);const params={context:{default_quant_id:res_ids[0]},};if(demand<=0){params.context.default_quantity=0;}else if(this.dirtyQuantsData.has(res_ids[0])){params.context.default_quantity=Math.min(this.dirtyQuantsData.get(res_ids[0]).available_quantity,demand);}
this.list.addNewRecord(params).then((record)=>{record.dirty=true;});}
createOpenRecord(){const activeElement=document.activeElement;this.openQuantRecord({context:{...this.props.context,form_view_ref:"stock.view_stock_quant_form",},immediate:true,onClose:()=>{if(activeElement){activeElement.focus();}},});}}
const smlX2ManyField=__exports.smlX2ManyField={...x2ManyField,component:SMLX2ManyField,};registry.category("fields").add("sml_x2_many",smlX2ManyField);return __exports;});;

/* /stock/static/src/picking_type_dashboard_graph/picking_type_dashboard_graph_field.js */
odoo.define('@stock/picking_type_dashboard_graph/picking_type_dashboard_graph_field',['@web/core/browser/cookie','@web/core/colors/colors','@web/core/utils/hooks','@web/core/registry','@web/views/fields/journal_dashboard_graph/journal_dashboard_graph_field'],function(require){'use strict';let __exports={};const{cookie}=require("@web/core/browser/cookie");const{getColor,getCustomColor}=require("@web/core/colors/colors");const{useService}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const{JournalDashboardGraphField}=require("@web/views/fields/journal_dashboard_graph/journal_dashboard_graph_field");const PickingTypeDashboardGraphField=__exports.PickingTypeDashboardGraphField=class PickingTypeDashboardGraphField extends JournalDashboardGraphField{setup(){super.setup();this.actionService=useService("action");}
getBarChartConfig(){const data=[];const labels=[];const backgroundColor=[];const colorPast=getColor(8,cookie.get("color_scheme"));const colorPresent=getColor(16,cookie.get("color_scheme"));const colorFuture=getColor(12,cookie.get("color_scheme"));this.data[0].values.forEach((pt)=>{data.push(pt.value);labels.push(pt.label);if(pt.type==="past"){backgroundColor.push(colorPast);}else if(pt.type==="present"){backgroundColor.push(colorPresent);}else if(pt.type==="future"){backgroundColor.push(colorFuture);}else{backgroundColor.push(getCustomColor(cookie.get("color_scheme"),"#ebebeb","#3C3E4B"));}});return{type:"bar",data:{labels,datasets:[{backgroundColor,data,fill:"start",label:this.data[0].key,},],},options:{onClick:(e)=>{const pickingTypeId=e.chart.config._config.options.pickingTypeId;if(!pickingTypeId){return;}
const columnIndex=e.chart.tooltip.dataPoints[0].parsed.x;const dateCategories={0:"before",1:"yesterday",2:"today",3:"day_1",4:"day_2",5:"after",};const dateCategory=dateCategories[columnIndex];const additionalContext={picking_type_id:pickingTypeId,search_default_picking_type_id:[pickingTypeId],};additionalContext["search_default_".concat(dateCategory)]=true;this.actionService.doAction("stock.click_dashboard_graph",{additionalContext:additionalContext});},plugins:{legend:{display:false},tooltip:{intersect:false,position:"nearest",caretSize:0,},},scales:{y:{display:false,},x:{display:false,},},pickingTypeId:this.data[0].picking_type_id,maintainAspectRatio:false,elements:{line:{tension:0.000001,},},},};}}
const pickingTypeDashboardGraphField=__exports.pickingTypeDashboardGraphField={component:PickingTypeDashboardGraphField,supportedTypes:["text"],extractProps:({attrs})=>({graphType:attrs.graph_type,}),};registry.category("fields").add("picking_type_dashboard_graph",pickingTypeDashboardGraphField);return __exports;});;

/* /stock/static/src/stock_forecasted/forecasted_buttons.js */
odoo.define('@stock/stock_forecasted/forecasted_buttons',['@web/core/l10n/translation','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const ForecastedButtons=__exports.ForecastedButtons=class ForecastedButtons extends Component{static template="stock.ForecastedButtons";static props={action:Object,resModel:{type:String,optional:true},reloadReport:Function,};setup(){this.actionService=useService("action");this.orm=useService("orm");this.context=this.props.action.context;this.productId=this.context.active_id;this.resModel=this.props.resModel||this.context.active_model||this.context.params?.active_model||'product.template';}
_onClose(res){return res?.special||this.props.reloadReport();}
async _onClickReplenish(){const context={...this.context};if(this.resModel==='product.product'){context.default_product_id=this.productId;}else if(this.resModel==='product.template'){context.default_product_tmpl_id=this.productId;}
context.default_warehouse_id=this.context.warehouse_id;const action={res_model:'product.replenish',name:_t('Product Replenish'),type:'ir.actions.act_window',views:[[false,'form']],target:'new',context:context,};return this.actionService.doAction(action,{onClose:this._onClose.bind(this)});}
async _onClickUpdateQuantity(){const action=await this.orm.call(this.resModel,"action_update_quantity_on_hand",[[this.productId]]);if(action.res_model==="stock.quant"){action.views=[[false,"list"]];}
return this.actionService.doAction(action,{onClose:this._onClose.bind(this)});}}
return __exports;});;

/* /stock/static/src/stock_forecasted/forecasted_details.js */
odoo.define('@stock/stock_forecasted/forecasted_details',['@web/views/fields/formatters','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{formatFloat}=require("@web/views/fields/formatters");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const ForecastedDetails=__exports.ForecastedDetails=class ForecastedDetails extends Component{static template="stock.ForecastedDetails";static props={docs:Object,openView:Function,reloadReport:Function};setup(){this.orm=useService("orm");this.onHandCondition=this.props.docs.lines.length&&!this.props.docs.lines.some((line)=>line.document_in||line.replenishment_filled);this._formatFloat=(num)=>{return formatFloat(num,{digits:this.props.docs.precision});};}
async _reserve(move_id){await this.orm.call('stock.forecasted_product_product','action_reserve_linked_picks',[move_id],);this.props.reloadReport();}
async _unreserve(move_id){await this.orm.call('stock.forecasted_product_product','action_unreserve_linked_picks',[move_id],);this.props.reloadReport();}
async _onClickChangePriority(modelName,record){const value=record.priority=="0"?"1":"0";await this.orm.call(modelName,"write",[[record.id],{priority:value}]);this.props.reloadReport();}
displayReserve(line){return!line.in_transit&&this.canReserveOperation(line);}
canReserveOperation(line){return line.move_out?.picking_id;}
get futureVirtualAvailable(){return this.props.docs.virtual_available+this.props.docs.qty.in-this.props.docs.qty.out;}}
return __exports;});;

/* /stock/static/src/stock_forecasted/forecasted_header.js */
odoo.define('@stock/stock_forecasted/forecasted_header',['@web/core/utils/hooks','@web/views/fields/formatters','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{formatFloat}=require("@web/views/fields/formatters");const{Component,markup}=require("@odoo/owl");const ForecastedHeader=__exports.ForecastedHeader=class ForecastedHeader extends Component{static template="stock.ForecastedHeader";static props={docs:Object,openView:Function};setup(){this.orm=useService("orm");this.action=useService("action");this._formatFloat=(num)=>formatFloat(num,{digits:this.props.docs.precision});}
async _onClickInventory(){const context=this._getActionContext();const action=await this.orm.call('stock.quant','action_view_quants',[],{context});if(action.help){action.help=markup(action.help);}
return this.action.doAction(action);}
_getActionContext(){const context={...this.context};const templates=this.props.docs.product_templates_ids;if(templates){context.search_default_product_tmpl_id=templates;}else{context.search_default_product_id=this.props.docs.product_variants_ids;}
return context;}}
return __exports;});;

/* /stock/static/src/stock_forecasted/forecasted_warehouse_filter.js */
odoo.define('@stock/stock_forecasted/forecasted_warehouse_filter',['@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{useService}=require("@web/core/utils/hooks");const{Component,onWillStart}=require("@odoo/owl");const ForecastedWarehouseFilter=__exports.ForecastedWarehouseFilter=class ForecastedWarehouseFilter extends Component{static template="stock.ForecastedWarehouseFilter";static components={Dropdown,DropdownItem};static props={action:Object,setWarehouseInContext:Function,warehouses:Array};setup(){this.orm=useService("orm");this.context=this.props.action.context;this.warehouses=this.props.warehouses;onWillStart(this.onWillStart)}
async onWillStart(){this.displayWarehouseFilter=(this.warehouses.length>1);}
_onSelected(id){this.props.setWarehouseInContext(Number(id));}
get activeWarehouse(){let warehouseId=null;if(Array.isArray(this.context.warehouse_id)){const validWarehouseIds=this.context.warehouse_id.filter(Number.isInteger);warehouseId=validWarehouseIds.length?validWarehouseIds[0]:null;}else if(Number.isInteger(this.context.warehouse_id)){warehouseId=this.context.warehouse_id;}
return warehouseId?this.warehouses.find((w)=>w.id==warehouseId):this.warehouses[0];}
get warehousesItems(){return this.warehouses.map(warehouse=>({id:warehouse.id,label:warehouse.name,onSelected:()=>this._onSelected(warehouse.id),}));}}
return __exports;});;

/* /stock/static/src/stock_forecasted/stock_forecasted.js */
odoo.define('@stock/stock_forecasted/stock_forecasted',['@web/core/utils/hooks','@web/core/l10n/translation','@web/core/registry','@web/views/view','@web/search/control_panel/control_panel','@stock/stock_forecasted/forecasted_buttons','@stock/stock_forecasted/forecasted_details','@stock/stock_forecasted/forecasted_header','@stock/stock_forecasted/forecasted_warehouse_filter','@odoo/owl','@web/webclient/actions/action_service'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{View}=require("@web/views/view");const{ControlPanel}=require("@web/search/control_panel/control_panel");const{ForecastedButtons}=require("@stock/stock_forecasted/forecasted_buttons");const{ForecastedDetails}=require("@stock/stock_forecasted/forecasted_details");const{ForecastedHeader}=require("@stock/stock_forecasted/forecasted_header");const{ForecastedWarehouseFilter}=require("@stock/stock_forecasted/forecasted_warehouse_filter");const{Component,onWillStart,useState}=require("@odoo/owl");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");const StockForecasted=__exports.StockForecasted=class StockForecasted extends Component{static template="stock.Forecasted";static components={ControlPanel,ForecastedButtons,ForecastedWarehouseFilter,ForecastedHeader,View,ForecastedDetails,};static props={...standardActionServiceProps};setup(){this.orm=useService("orm");this.action=useService("action");this.context=useState(this.props.action.context);this.productId=this.context.active_id;this.resModel=this.context.active_model;this.title=this.props.action.name||_t("Forecasted Report");if(!this.context.active_id){this.context.active_id=this.props.action.params.active_id;this.reloadReport();}
this.warehouses=useState([]);onWillStart(this._getReportValues);}
async _getReportValues(){await this._getResModel();const isTemplate=!this.resModel||this.resModel==='product.template';this.reportModelName=`stock.forecasted_product_${isTemplate ? "template" : "product"}`;this.warehouses.splice(0,this.warehouses.length);this.warehouses.push(...await this.orm.searchRead('stock.warehouse',[],['id','name','code']));if(!this.context.warehouse_id){this.updateWarehouse(this.warehouses[0].id);}
const reportValues=await this.orm.call(this.reportModelName,"get_report_values",[],{context:this.context,docids:[this.productId],});this.docs={...reportValues.docs,...reportValues.precision,lead_days_date:this.context.lead_days_date,qty_to_order:this.context.qty_to_order,visibility_days_date:this.context.visibility_days_date,qty_to_order_with_visibility_days:this.context.qty_to_order_with_visibility_days};}
async _getResModel(){this.resModel=this.context.active_model||this.context.params?.active_model;if(!this.resModel){let resModel=this.props.action.res_model;if(resModel){if(/^\d+$/.test(resModel)){const actionModel=await this.orm.read('ir.model',[Number(resModel)],['model']);resModel=actionModel[0]?.model;}
this.resModel=resModel;}else if(this.props.action._originalAction){const originalContextAction=JSON.parse(this.props.action._originalAction).context;if(typeof originalContextAction==="string"){this.resModel=JSON.parse(originalContextAction.replace(/'/g,'"')).active_model;}else if(originalContextAction){this.resModel=originalContextAction.active_model;}}
this.context.active_model=this.resModel;}}
async updateWarehouse(id){const hasPreviousValue=this.context.warehouse_id!==undefined;this.context.warehouse_id=id;if(hasPreviousValue){await this.reloadReport();}}
async reloadReport(){const actionRequest={id:this.props.action.id,type:"ir.actions.client",tag:"stock_forecasted",context:this.context,name:this.title,};const options={stackPosition:"replaceCurrentAction"};return this.action.doAction(actionRequest,options);}
get graphDomain(){let warehouseId=null;if(Array.isArray(this.context.warehouse_id)){const validWarehouseIds=this.context.warehouse_id.filter(Number.isInteger);warehouseId=validWarehouseIds.length?validWarehouseIds[0]:null;}else if(Number.isInteger(this.context.warehouse_id)){warehouseId=this.context.warehouse_id;}
const domain=[["state","=","forecast"],["warehouse_id","=",warehouseId],];if(this.resModel==="product.template"){domain.push(["product_tmpl_id","=",this.productId]);}else if(this.resModel==="product.product"){domain.push(["product_id","=",this.productId]);}
return domain;}
get graphInfo(){return{noContentHelp:_t("Try to add some incoming or outgoing transfers.")};}
async openView(resModel,view,resId){const action={type:"ir.actions.act_window",res_model:resModel,views:[[false,view]],view_mode:view,res_id:resId,};return this.action.doAction(action);}}
registry.category("actions").add("stock_forecasted",StockForecasted);return __exports;});;

/* /stock/static/src/stock_warehouse_service.js */
odoo.define('@stock/stock_warehouse_service',['@web/core/registry','@web/core/browser/browser','@web/core/orm_service','@web/core/network/rpc'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{browser}=require("@web/core/browser/browser");const{UPDATE_METHODS}=require("@web/core/orm_service");const{rpcBus}=require("@web/core/network/rpc");registry.category("services").add("stock_warehouse",{dependencies:["action"],start(env,{action}){rpcBus.addEventListener("RPC:RESPONSE",(ev)=>{const{data,error}=ev.detail;const{model,method}=data.params;if(!error&&model==="stock.warehouse"){if(UPDATE_METHODS.includes(method)&&!browser.localStorage.getItem("running_tour")){action.doAction("reload_context");}}});},});return __exports;});;

/* /stock/static/src/views/list/auto_column_width_list_renderer.js */
odoo.define('@stock/views/list/auto_column_width_list_renderer',['@web/views/list/list_renderer','@odoo/owl'],function(require){'use strict';let __exports={};const{ListRenderer}=require("@web/views/list/list_renderer");const{useEffect}=require("@odoo/owl");const AutoColumnWidthListRenderer=__exports.AutoColumnWidthListRenderer=class AutoColumnWidthListRenderer extends ListRenderer{static props=[...ListRenderer.props];setup(){super.setup();useEffect(()=>{this.keepColumnWidths=false;},()=>[this.columns]);}}
return __exports;});;

/* /stock/static/src/views/list/inventory_report_list_model.js */
odoo.define('@stock/views/list/inventory_report_list_model',['@web/core/l10n/translation','@web/model/relational_model/dynamic_record_list','@web/model/relational_model/relational_model'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{DynamicRecordList}=require("@web/model/relational_model/dynamic_record_list");const{RelationalModel}=require("@web/model/relational_model/relational_model");const InventoryReportListModel=__exports.InventoryReportListModel=class InventoryReportListModel extends RelationalModel{setup(params,{action,dialog,notification,rpc,user,view,company}){this._lastCreatedRecordId;return super.setup(...arguments);}
async _updateSimilarRecords(reloadedRecord,serverValues){if(this.config.isMonoRecord){return;}
const justCreated=reloadedRecord.id==this._lastCreatedRecordId;if(justCreated&&serverValues.create_date!==serverValues.write_date){this.notification.add(_t("You tried to create a record that already exists. The existing record was modified instead."),{title:_t("This record already exists.")});const duplicateRecords=this.root.records.filter((record)=>record.resId===reloadedRecord.resId&&record.id!==reloadedRecord.id);if(duplicateRecords.length>0){await this.root._removeRecords([reloadedRecord.id]);for(const record of duplicateRecords){record._applyValues(serverValues);}}}else{super._updateSimilarRecords(...arguments)}}}
const InventoryReportListDynamicRecordList=__exports.InventoryReportListDynamicRecordList=class InventoryReportListDynamicRecordList extends DynamicRecordList{async addNewRecord(){const record=await super.addNewRecord(...arguments);record.model._lastCreatedRecordId=record.id;return record;}}
InventoryReportListModel.DynamicRecordList=InventoryReportListDynamicRecordList;return __exports;});;

/* /stock/static/src/views/list/inventory_report_list_view.js */
odoo.define('@stock/views/list/inventory_report_list_view',['@web/views/list/list_view','@stock/views/list/inventory_report_list_model','@web/core/registry'],function(require){'use strict';let __exports={};const{listView}=require("@web/views/list/list_view");const{InventoryReportListModel}=require("@stock/views/list/inventory_report_list_model");const{registry}=require("@web/core/registry");const InventoryReportListView=__exports.InventoryReportListView={...listView,Model:InventoryReportListModel,};registry.category("views").add('inventory_report_list',InventoryReportListView);return __exports;});;

/* /stock/static/src/views/list/stock_report_list_view.js */
odoo.define('@stock/views/list/stock_report_list_view',['@web/views/list/list_view','@web/core/registry','@stock/views/search/stock_report_search_model','@stock/views/search/stock_report_search_panel'],function(require){'use strict';let __exports={};const{listView}=require('@web/views/list/list_view');const{registry}=require("@web/core/registry");const{StockReportSearchModel}=require("@stock/views/search/stock_report_search_model");const{StockReportSearchPanel}=require("@stock/views/search/stock_report_search_panel");const StockReportListView=__exports.StockReportListView={...listView,SearchModel:StockReportSearchModel,SearchPanel:StockReportSearchPanel,};registry.category("views").add("stock_report_list_view",StockReportListView);return __exports;});;

/* /stock/static/src/views/picking_form/stock_move_one2many.js */
odoo.define('@stock/views/picking_form/stock_move_one2many',['@web/core/registry','@stock/views/list/auto_column_width_list_renderer','@web/views/fields/x2many/x2many_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{AutoColumnWidthListRenderer}=require("@stock/views/list/auto_column_width_list_renderer");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const MovesListRenderer=__exports.MovesListRenderer=class MovesListRenderer extends AutoColumnWidthListRenderer{static recordRowTemplate="stock.MovesListRenderer.RecordRow";processAllColumn(allColumns,list){let cols=super.processAllColumn(...arguments);if(list.resModel==="stock.move"){cols.push({type:'opendetailsop',id:`column_detailOp_${cols.length}`,column_invisible:'parent.state=="draft"',});}
return cols;}}
const StockMoveX2ManyField=__exports.StockMoveX2ManyField=class StockMoveX2ManyField extends X2ManyField{static components={...X2ManyField.components,ListRenderer:MovesListRenderer};setup(){super.setup();this.canOpenRecord=true;}
get isMany2Many(){return false;}
async openRecord(record){if(this.canOpenRecord&&!record.isNew){const dirty=await record.isDirty();if(await record._parentRecord.isDirty()||(dirty&&'quantity'in record._changes)){await record._parentRecord.save({reload:true});record=record._parentRecord.data[this.props.name].records.find(e=>e.resId===record.resId);if(!record){return;}}}
return super.openRecord(record);}}
const stockMoveX2ManyField=__exports.stockMoveX2ManyField={...x2ManyField,component:StockMoveX2ManyField,additionalClasses:[...x2ManyField.additionalClasses||[],"o_field_one2many"],};registry.category("fields").add("stock_move_one2many",stockMoveX2ManyField);return __exports;});;

/* /stock/static/src/views/search/stock_orderpoint_search_model.js */
odoo.define('@stock/views/search/stock_orderpoint_search_model',['@web/core/utils/hooks','@web/search/search_model','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{SearchModel}=require("@web/search/search_model");const{debounce}=require("@web/core/utils/timing");const StockOrderpointSearchModel=__exports.StockOrderpointSearchModel=class StockOrderpointSearchModel extends SearchModel{static DEBOUNCE_DELAY=500;setup(services){super.setup(services);this.ui=useService("ui");this.applyGlobalVisibilityDays=debounce(this.applyGlobalVisibilityDays.bind(this),StockOrderpointSearchModel.DEBOUNCE_DELAY);}
async applyGlobalVisibilityDays(globalVisibilityDays){this.ui.block();this.globalContext={...this.globalContext,global_visibility_days:globalVisibilityDays,};this._context=false;await this.orm.call("stock.warehouse.orderpoint","action_open_orderpoints",[],{context:this.context,});await this._fetchSections(this.categories,this.filters);this._notify();this.ui.unblock();}}
return __exports;});;

/* /stock/static/src/views/search/stock_orderpoint_search_panel.js */
odoo.define('@stock/views/search/stock_orderpoint_search_panel',['@web/core/utils/hooks','@odoo/owl','@web/search/search_panel/search_panel'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{onWillStart,useState}=require('@odoo/owl');const{SearchPanel}=require("@web/search/search_panel/search_panel");const StockOrderpointSearchPanel=__exports.StockOrderpointSearchPanel=class StockOrderpointSearchPanel extends SearchPanel{static template="stock.StockOrderpointSearchPanel";setup(){this.orm=useService("orm");super.setup(...arguments);this.globalVisibilityDays=useState({value:0});this.state.sidebarExpanded=false;onWillStart(this.getVisibilityParameter);}
async getVisibilityParameter(){let res=await this.orm.call("stock.warehouse.orderpoint","get_visibility_days",[]);this.globalVisibilityDays.value=Math.abs(parseInt(res))||0;}
async applyGlobalVisibilityDays(ev){this.globalVisibilityDays.value=Math.max(parseInt(ev.target.value),0);await this.env.searchModel.applyGlobalVisibilityDays(this.globalVisibilityDays.value);}}
return __exports;});;

/* /stock/static/src/views/search/stock_report_search_model.js */
odoo.define('@stock/views/search/stock_report_search_model',['@web/search/search_model'],function(require){'use strict';let __exports={};const{SearchModel}=require("@web/search/search_model");const StockReportSearchModel=__exports.StockReportSearchModel=class StockReportSearchModel extends SearchModel{async load(){await super.load(...arguments);await this._loadWarehouses();}
getWarehouses(){return this.warehouses;}
async _loadWarehouses(){this.warehouses=await this.orm.call('stock.warehouse','get_current_warehouses',[[]],{context:this.context},);}
clearWarehouseContext(){delete this.globalContext.warehouse_id;this._notify();}
applyWarehouseContext(warehouse_id){this.globalContext['warehouse_id']=warehouse_id;this._notify();}}
return __exports;});;

/* /stock/static/src/views/search/stock_report_search_panel.js */
odoo.define('@stock/views/search/stock_report_search_panel',['@web/search/search_panel/search_panel'],function(require){'use strict';let __exports={};const{SearchPanel}=require("@web/search/search_panel/search_panel");const StockReportSearchPanel=__exports.StockReportSearchPanel=class StockReportSearchPanel extends SearchPanel{static template="stock.StockReportSearchPanel";setup(){super.setup(...arguments);this.selectedWarehouse=false;}
get warehouses(){return this.env.searchModel.getWarehouses();}
clearWarehouseContext(){this.env.searchModel.clearWarehouseContext();this.selectedWarehouse=null;}
applyWarehouseContext(warehouse_id){this.env.searchModel.applyWarehouseContext(warehouse_id);this.selectedWarehouse=warehouse_id;}}
return __exports;});;

/* /stock/static/src/views/stock_empty_list_help.js */
odoo.define('@stock/views/stock_empty_list_help',['@web/core/registry','@web/views/list/list_view','@web/views/list/list_renderer','@odoo/owl','@web/views/view_hook'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{ListRenderer}=require("@web/views/list/list_renderer");const{Component}=require("@odoo/owl");const{useActionLinks}=require("@web/views/view_hook");const StockActionHelper=__exports.StockActionHelper=class StockActionHelper extends Component{static template="stock.StockActionHelper";static props=["noContentHelp"];setup(){const resModel="searchModel"in this.env?this.env.searchModel.resModel:undefined;this.handler=useActionLinks(resModel);}}
const StockListRenderer=__exports.StockListRenderer=class StockListRenderer extends ListRenderer{static template="stock.StockListRenderer";static components={...StockListRenderer.components,StockActionHelper,};}
const StockListView=__exports.StockListView={...listView,Renderer:StockListRenderer,};registry.category("views").add("stock_list_view",StockListView);return __exports;});;

/* /stock/static/src/views/stock_orderpoint_list_controller.js */
odoo.define('@stock/views/stock_orderpoint_list_controller',['@web/views/list/list_controller','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item'],function(require){'use strict';let __exports={};const{ListController}=require('@web/views/list/list_controller');const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const StockOrderpointListController=__exports.StockOrderpointListController=class StockOrderpointListController extends ListController{static template="stock.StockOrderpoint.listView";static components={...super.components,Dropdown,DropdownItem,}
async onClickOrder(force_to_max){const resIds=await this.getSelectedResIds();const action=await this.model.orm.call(this.props.resModel,'action_replenish',[resIds],{context:this.props.context,force_to_max:force_to_max,});if(action){await this.actionService.doAction(action);}
return this.actionService.doAction('stock.action_replenishment',{stackPosition:'replaceCurrentAction',});}
async onClickSnooze(){const resIds=await this.getSelectedResIds();this.actionService.doAction('stock.action_orderpoint_snooze',{additionalContext:{default_orderpoint_ids:resIds},onClose:()=>{this.actionService.doAction('stock.action_replenishment',{stackPosition:'replaceCurrentAction',});}});}}
return __exports;});;

/* /stock/static/src/views/stock_orderpoint_list_view.js */
odoo.define('@stock/views/stock_orderpoint_list_view',['@web/views/list/list_view','@web/core/registry','@stock/views/stock_orderpoint_list_controller','@stock/views/search/stock_orderpoint_search_panel','@stock/views/search/stock_orderpoint_search_model'],function(require){'use strict';let __exports={};const{listView}=require('@web/views/list/list_view');const{registry}=require("@web/core/registry");const{StockOrderpointListController:Controller}=require("@stock/views/stock_orderpoint_list_controller");const{StockOrderpointSearchPanel}=require("@stock/views/search/stock_orderpoint_search_panel");const{StockOrderpointSearchModel}=require("@stock/views/search/stock_orderpoint_search_model");const StockOrderpointListView=__exports.StockOrderpointListView={...listView,Controller,SearchPanel:StockOrderpointSearchPanel,SearchModel:StockOrderpointSearchModel,};registry.category("views").add("stock_orderpoint_list",StockOrderpointListView);return __exports;});;

/* /stock/static/src/widgets/counted_quantity_widget.js */
odoo.define('@stock/widgets/counted_quantity_widget',['@web/views/fields/float/float_field','@web/core/registry','@web/core/hotkeys/hotkey_service','@odoo/owl'],function(require){'use strict';let __exports={};const{FloatField,floatField}=require("@web/views/fields/float/float_field");const{registry}=require("@web/core/registry");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const{useEffect,useRef}=require("@odoo/owl");const CountedQuantityWidgetField=__exports.CountedQuantityWidgetField=class CountedQuantityWidgetField extends FloatField{setup(){super.setup();const inputRef=useRef("numpadDecimal");useEffect((inputEl)=>{if(inputEl){inputEl.addEventListener("input",this.onInput.bind(this));inputEl.addEventListener("keydown",this.onKeydown.bind(this));inputEl.addEventListener("blur",this.onBlur.bind(this));return()=>{inputEl.removeEventListener("input",this.onInput.bind(this));inputEl.removeEventListener("keydown",this.onKeydown.bind(this));inputEl.removeEventListener("blur",this.onBlur.bind(this));};}},()=>[inputRef.el]);}
onInput(ev){return this.props.record.update({inventory_quantity_set:true});}
updateValue(ev){try{const val=this.parse(ev.target.value);this.props.record.update({[this.props.name]:val});}catch{}}
onBlur(ev){if(!this.props.record.data.inventory_quantity_set){return;}
this.updateValue(ev);}
onKeydown(ev){const hotkey=getActiveHotkey(ev);if(["enter","tab","shift+tab"].includes(hotkey)){this.updateValue(ev);this.onInput(ev);}}
get formattedValue(){if(this.props.readonly&&!this.props.record.data[this.props.name]&!this.props.record.data.inventory_quantity_set){return"";}
return super.formattedValue;}}
const countedQuantityWidgetField=__exports.countedQuantityWidgetField={...floatField,component:CountedQuantityWidgetField,};registry.category("fields").add("counted_quantity_widget",countedQuantityWidgetField);return __exports;});;

/* /stock/static/src/widgets/forecast_widget.js */
odoo.define('@stock/widgets/forecast_widget',['@web/views/fields/float/float_field','@web/core/l10n/dates','@web/views/fields/formatters','@web/core/registry','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{FloatField,floatField}=require("@web/views/fields/float/float_field");const{formatDate}=require("@web/core/l10n/dates");const{formatFloat}=require("@web/views/fields/formatters");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const ForecastWidgetField=__exports.ForecastWidgetField=class ForecastWidgetField extends FloatField{static template="stock.ForecastWidget";setup(){const{data,fields,resId}=this.props.record;this.actionService=useService("action");this.orm=useService("orm");this.resId=resId;this.reservedAvailability=formatFloat(data.quantity,{...fields.quantity,...this.nodeOptions,});this.forecastExpectedDate=formatDate(data.forecast_expected_date,fields.forecast_expected_date);if(data.forecast_expected_date&&data.date_deadline){this.forecastIsLate=data.forecast_expected_date>data.date_deadline;}
const digits=fields.forecast_availability.digits;const options={digits,thousandsSep:"",decimalPoint:"."};const forecast_availability=parseFloat(formatFloat(data.forecast_availability,options));const product_qty=parseFloat(formatFloat(data.product_qty,options));this.willBeFulfilled=forecast_availability>=product_qty;this.state=data.state;}
async _openReport(ev){ev.preventDefault();ev.stopPropagation();if(!this.resId){return;}
const action=await this.orm.call("stock.move","action_product_forecast_report",[this.resId,]);this.actionService.doAction(action);}}
const forecastWidgetField=__exports.forecastWidgetField={...floatField,component:ForecastWidgetField,};registry.category("fields").add("forecast_widget",forecastWidgetField);return __exports;});;

/* /stock/static/src/widgets/generate_serial.js */
odoo.define('@stock/widgets/generate_serial',['@web/core/l10n/translation','@web/core/orm_service','@web/core/dialog/dialog','@web/core/utils/hooks','@web/core/registry','@web/views/fields/parsers','@web/model/relational_model/utils','@odoo/owl','@web/views/widgets/standard_widget_props'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{x2ManyCommands}=require("@web/core/orm_service");const{Dialog}=require('@web/core/dialog/dialog');const{useService}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const{parseInteger}=require("@web/views/fields/parsers");const{getId}=require("@web/model/relational_model/utils");const{Component,useRef,onMounted}=require("@odoo/owl");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const GenerateDialog=__exports.GenerateDialog=class GenerateDialog extends Component{static template="stock.generate_serial_dialog";static components={Dialog};static props={mode:{type:String},move:{type:Object},close:{type:Function},};setup(){this.size='md';if(this.props.mode==='generate'){this.title=this.props.move.data.has_tracking==='lot'?_t("Generate Lot numbers"):_t("Generate Serial numbers");}else{this.title=this.props.move.data.has_tracking==='lot'?_t("Import Lots"):_t("Import Serials");}
this.nextSerial=useRef('nextSerial');this.nextSerialCount=useRef('nextSerialCount');this.totalReceived=useRef('totalReceived');this.keepLines=useRef('keepLines');this.lots=useRef('lots');this.orm=useService("orm");onMounted(()=>{if(this.props.mode==='generate'){this.nextSerialCount.el.value=this.props.move.data.product_uom_qty||2;if(this.props.move.data.has_tracking==='lot'){this.totalReceived.el.value=this.props.move.data.quantity;}}});}
async _onGenerate(){let count;let qtyToProcess;if(this.props.move.data.has_tracking==='lot'){count=parseFloat(this.nextSerialCount.el?.value||'0');qtyToProcess=parseFloat(this.totalReceived.el?.value||this.props.move.data.product_qty);}else{count=parseInteger(this.nextSerialCount.el?.value||'0');qtyToProcess=this.props.move.data.product_qty;}
const move_line_vals=await this.orm.call("stock.move","action_generate_lot_line_vals",[{...this.props.move.context,default_product_id:this.props.move.data.product_id[0],default_location_dest_id:this.props.move.data.location_dest_id[0],default_location_id:this.props.move.data.location_id[0],default_tracking:this.props.move.data.has_tracking,default_quantity:qtyToProcess,},this.props.mode,this.nextSerial.el?.value,count,this.lots.el?.value,]);const newlines=[];let lines=[]
lines=this.props.move.data.move_line_ids;for(const values of move_line_vals){newlines.push(lines._createRecordDatapoint(values,{mode:'readonly',virtualId:getId("virtual"),manuallyAdded:false,}));}
if(!this.keepLines.el.checked){await lines._applyCommands(lines._currentIds.map((currentId)=>[x2ManyCommands.DELETE,currentId,]));}
lines.records.push(...newlines);lines._commands.push(...newlines.map((record)=>[x2ManyCommands.CREATE,record._virtualId,]));lines._currentIds.push(...newlines.map((record)=>record._virtualId));await lines._onUpdate();this.props.close();}}
class GenerateSerials extends Component{static template="stock.GenerateSerials";static props={...standardWidgetProps};setup(){this.dialog=useService("dialog");}
openDialog(ev){this.dialog.add(GenerateDialog,{move:this.props.record,mode:'generate',});}}
class ImportLots extends Component{static template="stock.ImportLots";static props={...standardWidgetProps};setup(){this.dialog=useService("dialog");}
openDialog(ev){this.dialog.add(GenerateDialog,{move:this.props.record,mode:'import',});}}
registry.category("view_widgets").add("import_lots",{component:ImportLots});registry.category("view_widgets").add("generate_serials",{component:GenerateSerials});return __exports;});;

/* /stock/static/src/widgets/json_widget.js */
odoo.define('@stock/widgets/json_widget',['@web/core/registry','@web/core/l10n/translation','@web/core/user','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{Component,onWillStart}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const JsonPopOver=__exports.JsonPopOver=class JsonPopOver extends Component{static template="";static props={...standardFieldProps};get jsonValue(){return JSON.parse(this.props.record.data[this.props.name]);}}
const jsonPopOver=__exports.jsonPopOver={component:JsonPopOver,displayName:_t("Json Popup"),supportedTypes:["char"],};const PopOverLeadDays=__exports.PopOverLeadDays=class PopOverLeadDays extends JsonPopOver{static template="stock.leadDays";setup(){super.setup();onWillStart(async()=>{this.displayUOM=await user.hasGroup("uom.group_uom");});}
get qtyForecast(){return this._formatQty("qty_forecast");}
get qtyToOrder(){return this._formatQty("qty_to_order");}
get productMaxQty(){return this._formatQty("product_max_qty");}
get productMinQty(){return this._formatQty("product_min_qty");}
_formatQty(field){return this.displayUOM?`${this.jsonValue[field]} ${this.jsonValue.product_uom_name}`:this.jsonValue[field];}}
const popOverLeadDays=__exports.popOverLeadDays={...jsonPopOver,component:PopOverLeadDays,};registry.category("fields").add("lead_days_widget",popOverLeadDays);const ReplenishmentHistoryWidget=__exports.ReplenishmentHistoryWidget=class ReplenishmentHistoryWidget extends JsonPopOver{static template="stock.replenishmentHistory";}
const replenishmentHistoryWidget=__exports.replenishmentHistoryWidget={...jsonPopOver,component:ReplenishmentHistoryWidget,};registry.category("fields").add("replenishment_history_widget",replenishmentHistoryWidget);return __exports;});;

/* /stock/static/src/widgets/popover_widget.js */
odoo.define('@stock/widgets/popover_widget',['@web/core/registry','@web/core/popover/popover_hook','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{usePopover}=require("@web/core/popover/popover_hook");const{Component}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const PopoverComponent=__exports.PopoverComponent=class PopoverComponent extends Component{static template="stock.popoverContent";static props=["record","*"];}
const PopoverWidgetField=__exports.PopoverWidgetField=class PopoverWidgetField extends Component{static template="stock.popoverButton";static components={Popover:PopoverComponent};static props={...standardFieldProps};setup(){let fieldValue=this.props.record.data[this.props.name];this.jsonValue=JSON.parse(fieldValue||"{}");const position=this.jsonValue.position||"top";this.popover=usePopover(this.constructor.components.Popover,{position});this.color=this.jsonValue.color||'text-primary';this.icon=this.jsonValue.icon||'fa-info-circle';}
showPopup(ev){this.popover.open(ev.currentTarget,{...this.jsonValue,record:this.props.record});}}
const popoverWidgetField=__exports.popoverWidgetField={component:PopoverWidgetField,supportedTypes:['char'],};registry.category("fields").add("popover_widget",popoverWidgetField);return __exports;});;

/* /stock/static/src/widgets/stock_pick_from.js */
odoo.define('@stock/widgets/stock_pick_from',['@web/core/registry','@web/views/fields/many2one/many2one_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Many2OneField,many2OneField}=require("@web/views/fields/many2one/many2one_field");const StockPickFrom=__exports.StockPickFrom=class StockPickFrom extends Many2OneField{get displayName(){return super.displayName||this._quant_display_name();}
get value(){return super.value||[0,this._quant_display_name()];}
_quant_display_name(){let name_parts=[];const data=this.props.record.data;name_parts.push(data.location_id?.[1])
if(data.lot_id){name_parts.push(data.lot_id?.[1]||data.lot_name)}
if(data.package_id){name_parts.push(data.package_id?.[1])}
if(data.owner){name_parts.push(data.owner?.[1])}
const result=name_parts.join(" - ");if(result)return result;return"";}}
const stockPickFrom=__exports.stockPickFrom={...many2OneField,component:StockPickFrom,fieldDependencies:[...(many2OneField.fieldDependencies||[]),{name:"location_id",type:"relation"},{name:"location_dest_id",type:"relation"},{name:"package_id",type:"relation"},{name:"owner_id",type:"relation"},],};registry.category("fields").add("pick_from",stockPickFrom);return __exports;});;

/* /stock/static/src/widgets/stock_rescheduling_popover.js */
odoo.define('@stock/widgets/stock_rescheduling_popover',['@web/core/utils/hooks','@web/core/registry','@stock/widgets/popover_widget'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const{PopoverComponent,PopoverWidgetField,popoverWidgetField,}=require("@stock/widgets/popover_widget");const StockRescheculingPopoverComponent=__exports.StockRescheculingPopoverComponent=class StockRescheculingPopoverComponent extends PopoverComponent{setup(){this.action=useService("action");}
openElement(ev){this.action.doAction({res_model:ev.currentTarget.getAttribute('element-model'),res_id:parseInt(ev.currentTarget.getAttribute('element-id')),views:[[false,"form"]],type:"ir.actions.act_window",view_mode:"form",});}}
const StockRescheculingPopover=__exports.StockRescheculingPopover=class StockRescheculingPopover extends PopoverWidgetField{static components={Popover:StockRescheculingPopoverComponent};setup(){super.setup();this.color=this.jsonValue.color||'text-danger';this.icon=this.jsonValue.icon||'fa-exclamation-triangle';}
showPopup(ev){if(!this.jsonValue.late_elements){return;}
super.showPopup(ev);}}
registry.category("fields").add("stock_rescheduling_popover",{...popoverWidgetField,component:StockRescheculingPopover,});return __exports;});;

/* /web_enterprise/static/src/webclient/burger_menu/burger_menu.js */
odoo.define('@web_enterprise/webclient/burger_menu/burger_menu',['@web/webclient/burger_menu/burger_menu','@web/core/utils/hooks','@web/core/registry'],function(require){'use strict';let __exports={};const{BurgerMenu}=require("@web/webclient/burger_menu/burger_menu");const{useService}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const EnterpriseBurgerMenu=__exports.EnterpriseBurgerMenu=class EnterpriseBurgerMenu extends BurgerMenu{setup(){super.setup();this.hm=useService("home_menu");}
get currentApp(){return!this.hm.hasHomeMenu&&super.currentApp;}}
const systrayItem={Component:EnterpriseBurgerMenu,};registry.category("systray").add("burger_menu",systrayItem,{sequence:0,force:true});return __exports;});;

/* /web_enterprise/static/src/webclient/color_scheme/color_scheme_menu_items.js */
odoo.define('@web_enterprise/webclient/color_scheme/color_scheme_menu_items',['@web/core/l10n/translation','@web/core/browser/cookie'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{cookie:cookieManager}=require("@web/core/browser/cookie");__exports.switchColorSchemeItem=switchColorSchemeItem;function switchColorSchemeItem(env){return{type:"switch",id:"color_scheme.switch_theme",description:_t("Dark Mode"),callback:()=>{const cookie=cookieManager.get("color_scheme");const scheme=cookie==="dark"?"light":"dark";env.services.color_scheme.switchToColorScheme(scheme);},isChecked:cookieManager.get("color_scheme")==="dark",sequence:30,};}
return __exports;});;

/* /web_enterprise/static/src/webclient/color_scheme/color_scheme_service.js */
odoo.define('@web_enterprise/webclient/color_scheme/color_scheme_service',['@web/core/registry','@web/core/browser/browser','@web/core/browser/cookie','@web_enterprise/webclient/color_scheme/color_scheme_menu_items'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{browser}=require("@web/core/browser/browser");const{cookie}=require("@web/core/browser/cookie");const{switchColorSchemeItem}=require("@web_enterprise/webclient/color_scheme/color_scheme_menu_items");const serviceRegistry=registry.category("services");const userMenuRegistry=registry.category("user_menuitems");const colorSchemeService=__exports.colorSchemeService={dependencies:["ui"],start(env,{ui}){userMenuRegistry.add("color_scheme.switch",switchColorSchemeItem);return{switchToColorScheme:(scheme)=>{cookie.set("color_scheme",scheme);ui.block();this.reload();},};},reload(){browser.location.reload();},};serviceRegistry.add("color_scheme",colorSchemeService);return __exports;});;

/* /web_enterprise/static/src/webclient/home_menu/enterprise_subscription_service.js */
odoo.define('@web_enterprise/webclient/home_menu/enterprise_subscription_service',['@web/core/registry','@web/session','@web/core/browser/browser','@web/core/l10n/dates','@web/core/utils/hooks','@web/core/l10n/translation','@web_enterprise/webclient/home_menu/expiration_panel','@web/core/browser/cookie','@web/core/network/rpc','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{session}=require("@web/session");const{browser}=require("@web/core/browser/browser");const{deserializeDateTime,serializeDate,formatDate}=require("@web/core/l10n/dates");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const{ExpirationPanel}=require("@web_enterprise/webclient/home_menu/expiration_panel");const{cookie}=require("@web/core/browser/cookie");const{rpc}=require("@web/core/network/rpc");const{DateTime}=luxon;const{Component,xml,useState}=require("@odoo/owl");function daysUntil(datetime){const duration=datetime.diff(DateTime.utc(),"days");return Math.round(duration.values.days);}
const SubscriptionManager=__exports.SubscriptionManager=class SubscriptionManager{constructor(env,{orm,notification}){this.env=env;this.orm=orm;this.notification=notification;if(session.expiration_date){this.expirationDate=deserializeDateTime(session.expiration_date);}else{this.expirationDate=DateTime.utc().plus({days:30});}
this.expirationReason=session.expiration_reason;this.hasInstalledApps="storeData"in session;this.warningType=session.warning;this.lastRequestStatus=null;this.isWarningHidden=cookie.get("oe_instance_hide_panel");}
get formattedExpirationDate(){return formatDate(this.expirationDate,{format:"DDD"});}
get daysLeft(){return daysUntil(this.expirationDate);}
get unregistered(){return["trial","demo",false].includes(this.expirationReason);}
hideWarning(){cookie.set("oe_instance_hide_panel",true,24*60*60);this.isWarningHidden=true;}
async buy(){const limitDate=serializeDate(DateTime.utc().minus({days:15}));const args=[[["share","=",false],["login_date",">=",limitDate],],];const nbUsers=await this.orm.call("res.users","search_count",args);browser.location=`https://www.odoo.com/odoo-enterprise/upgrade?num_users=${nbUsers}`;}
async submitCode(enterpriseCode){const[oldDate,]=await Promise.all([this.orm.call("ir.config_parameter","get_param",["database.expiration_date"]),this.orm.call("ir.config_parameter","set_param",["database.enterprise_code",enterpriseCode,])]);await this.orm.call("publisher_warranty.contract","update_notification",[[]]);const[linkedSubscriptionUrl,linkedEmail,expirationDate]=await Promise.all([this.orm.call("ir.config_parameter","get_param",["database.already_linked_subscription_url",]),this.orm.call("ir.config_parameter","get_param",["database.already_linked_email"]),this.orm.call("ir.config_parameter","get_param",["database.expiration_date",])]);if(linkedSubscriptionUrl){this.lastRequestStatus="link";this.linkedSubscriptionUrl=linkedSubscriptionUrl;this.mailDeliveryStatus=null;this.linkedEmail=linkedEmail;}else if(expirationDate!==oldDate){this.lastRequestStatus="success";this.expirationDate=deserializeDateTime(expirationDate);if(this.daysLeft>30){this.notification.add(_t("Thank you, your registration was successful! Your database is valid until %s.",this.formattedExpirationDate),{type:"success"});}}else{this.lastRequestStatus="error";}}
async checkStatus(){await this.orm.call("publisher_warranty.contract","update_notification",[[]]);const expirationDateStr=await this.orm.call("ir.config_parameter","get_param",["database.expiration_date",]);this.lastRequestStatus="update";this.expirationDate=deserializeDateTime(expirationDateStr);}
async sendUnlinkEmail(){const sendUnlinkInstructionsUrl=await this.orm.call("ir.config_parameter","get_param",["database.already_linked_send_mail_url",]);this.mailDeliveryStatus="ongoing";const{result,reason}=await rpc(sendUnlinkInstructionsUrl);if(result){this.mailDeliveryStatus="success";}else{this.mailDeliveryStatus="fail";this.mailDeliveryStatusError=reason;}}
async renew(){const enterpriseCode=await this.orm.call("ir.config_parameter","get_param",["database.enterprise_code",]);const url="https://www.odoo.com/odoo-enterprise/renew";const contractQueryString=enterpriseCode?`?contract=${enterpriseCode}`:"";browser.location=`${url}${contractQueryString}`;}
async upsell(){const limitDate=serializeDate(DateTime.utc().minus({days:15}));const[enterpriseCode,nbUsers]=await Promise.all([this.orm.call("ir.config_parameter","get_param",["database.enterprise_code"]),this.orm.call("res.users","search_count",[[["share","=",false],["login_date",">=",limitDate],],]),]);const url="https://www.odoo.com/odoo-enterprise/upsell";const contractQueryString=enterpriseCode?`&contract=${enterpriseCode}`:"";browser.location=`${url}?num_users=${nbUsers}${contractQueryString}`;}}
class ExpiredSubscriptionBlockUI extends Component{static props={};static template=xml`
        <t t-if="subscription.daysLeft &lt;= 0">
            <div class="o_blockUI"/>
            <div style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; z-index: 1100" class="d-flex align-items-center justify-content-center">
                <ExpirationPanel/>
            </div>
        </t>`;static components={ExpirationPanel};setup(){this.subscription=useState(useService("enterprise_subscription"));}}
const enterpriseSubscriptionService=__exports.enterpriseSubscriptionService={name:"enterprise_subscription",dependencies:["orm","notification"],start(env,{orm,notification}){registry.category("main_components").add("expired_subscription_block_ui",{Component:ExpiredSubscriptionBlockUI});return new SubscriptionManager(env,{orm,notification});},};registry.category("services").add("enterprise_subscription",enterpriseSubscriptionService);return __exports;});;

/* /web_enterprise/static/src/webclient/home_menu/expiration_panel.js */
odoo.define('@web_enterprise/webclient/home_menu/expiration_panel',['@web/core/utils/hooks','@web/core/transition','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{Transition}=require("@web/core/transition");const{_t}=require("@web/core/l10n/translation");const{Component,useState,useRef}=require("@odoo/owl");const ExpirationPanel=__exports.ExpirationPanel=class ExpirationPanel extends Component{static template="DatabaseExpirationPanel";static props={};static components={Transition};setup(){this.subscription=useState(useService("enterprise_subscription"));this.state=useState({displayRegisterForm:false,});this.inputRef=useRef("input");}
get buttonText(){return this.subscription.lastRequestStatus==="error"?_t("Retry"):_t("Register");}
get alertType(){if(this.subscription.lastRequestStatus==="success"){return"success";}
const{daysLeft}=this.subscription;if(daysLeft<=6){return"danger";}else if(daysLeft<=16){return"warning";}
return"info";}
get expirationMessage(){const{daysLeft}=this.subscription;if(daysLeft<=0){return _t("This database has expired. ");}
const delay=daysLeft===30?_t("1 month"):_t("%s days",daysLeft);if(this.subscription.expirationReason==="demo"){return _t("This demo database will expire in %s. ",delay);}
return _t("This database will expire in %s. ",delay);}
showRegistrationForm(){this.state.displayRegisterForm=!this.state.displayRegisterForm;}
async onCodeSubmit(){const enterpriseCode=this.inputRef.el.value;if(!enterpriseCode){return;}
await this.subscription.submitCode(enterpriseCode);if(this.subscription.lastRequestStatus==="success"){this.state.displayRegisterForm=false;}else{this.state.buttonText=_t("Retry");}}}
return __exports;});;

/* /web_enterprise/static/src/webclient/home_menu/home_menu.js */
odoo.define('@web_enterprise/webclient/home_menu/home_menu',['@web/core/browser/feature_detection','@web/core/hotkeys/hotkey_hook','@web/core/user','@web/core/utils/hooks','@web_enterprise/webclient/home_menu/expiration_panel','@web/core/utils/sortable_owl','@odoo/owl'],function(require){'use strict';let __exports={};const{hasTouch,isIosApp,isMacOS}=require("@web/core/browser/feature_detection");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{ExpirationPanel}=require("@web_enterprise/webclient/home_menu/expiration_panel");const{useSortable}=require("@web/core/utils/sortable_owl");const{Component,useExternalListener,onMounted,onPatched,onWillUpdateProps,useState,useRef,}=require("@odoo/owl");class FooterComponent extends Component{static template="web_enterprise.HomeMenu.CommandPalette.Footer";static props={switchNamespace:{type:Function,optional:true},};setup(){this.controlKey=isMacOS()?"COMMAND":"CONTROL";}}
const HomeMenu=__exports.HomeMenu=class HomeMenu extends Component{static template="web_enterprise.HomeMenu";static components={ExpirationPanel};static props={apps:{type:Array,element:{type:Object,shape:{actionID:Number,href:String,appID:Number,id:Number,label:String,parents:String,webIcon:{type:[Boolean,String,{type:Object,optional:1,shape:{iconClass:String,color:String,backgroundColor:String,},},],optional:true,},webIconData:{type:String,optional:1},xmlid:String,},},},reorderApps:{type:Function},};setup(){this.command=useService("command");this.menus=useService("menu");this.homeMenuService=useService("home_menu");this.subscription=useState(useService("enterprise_subscription"));this.ui=useService("ui");this.state=useState({focusedIndex:null,isIosApp:isIosApp(),});this.inputRef=useRef("input");this.rootRef=useRef("root");this.pressTimer;if(!this.env.isSmall){this._registerHotkeys();}
useSortable({enable:this._enableAppsSorting,ref:this.rootRef,elements:".o_draggable",cursor:"move",delay:500,tolerance:10,onWillStartDrag:(params)=>this._sortStart(params),onDrop:(params)=>this._sortAppDrop(params),});onWillUpdateProps(()=>{this.state.focusedIndex=null;});onMounted(()=>{if(!hasTouch()){this._focusInput();}});onPatched(()=>{if(this.state.focusedIndex!==null&&!this.env.isSmall){const selectedItem=document.querySelector(".o_home_menu .o_menuitem.o_focused");if(selectedItem){selectedItem.scrollIntoView({block:"center"});}}});}
get displayedApps(){return this.props.apps;}
get maxIconNumber(){const w=window.innerWidth;if(w<576){return 3;}else if(w<768){return 4;}else{return 6;}}
_openMenu(menu){return this.menus.selectMenu(menu);}
_updateFocusedIndex(cmd){const nbrApps=this.displayedApps.length;const lastIndex=nbrApps-1;const focusedIndex=this.state.focusedIndex;if(lastIndex<0){return;}
if(focusedIndex===null){this.state.focusedIndex=0;return;}
const lineNumber=Math.ceil(nbrApps/this.maxIconNumber);const currentLine=Math.ceil((focusedIndex+1)/this.maxIconNumber);let newIndex;switch(cmd){case"previousElem":newIndex=focusedIndex-1;break;case"nextElem":newIndex=focusedIndex+1;break;case"previousColumn":if(focusedIndex%this.maxIconNumber){newIndex=focusedIndex-1;}else{newIndex=focusedIndex+Math.min(lastIndex-focusedIndex,this.maxIconNumber-1);}
break;case"nextColumn":if(focusedIndex===lastIndex||(focusedIndex+1)%this.maxIconNumber===0){newIndex=(currentLine-1)*this.maxIconNumber;}else{newIndex=focusedIndex+1;}
break;case"previousLine":if(currentLine===1){newIndex=focusedIndex+(lineNumber-1)*this.maxIconNumber;if(newIndex>lastIndex){newIndex=lastIndex;}}else{newIndex=focusedIndex-this.maxIconNumber;}
break;case"nextLine":if(currentLine===lineNumber){newIndex=focusedIndex%this.maxIconNumber;}else{newIndex=focusedIndex+Math.min(this.maxIconNumber,lastIndex-focusedIndex);}
break;}
if(newIndex<0){newIndex=lastIndex;}else if(newIndex>lastIndex){newIndex=0;}
this.state.focusedIndex=newIndex;}
_focusInput(){if(!this.env.isSmall&&this.inputRef.el){this.inputRef.el.focus({preventScroll:true});}}
_enableAppsSorting(){return true;}
_sortAppDrop({element,previous}){const order=this.props.apps.map((app)=>app.xmlid);const elementId=element.children[0].dataset.menuXmlid;const elementIndex=order.indexOf(elementId);order.splice(elementIndex,1);if(previous){const prevIndex=order.indexOf(previous.children[0].dataset.menuXmlid);order.splice(prevIndex+1,0,elementId);}else{order.splice(0,0,elementId);}
this.props.reorderApps(order);user.setUserSettings("homemenu_config",JSON.stringify(order));}
_sortStart({element,addClass}){addClass(element.children[0],"o_dragged_app");}
_onAppClick(app){this._openMenu(app);}
_registerHotkeys(){const hotkeys=[["ArrowDown",()=>this._updateFocusedIndex("nextLine")],["ArrowRight",()=>this._updateFocusedIndex("nextColumn")],["ArrowUp",()=>this._updateFocusedIndex("previousLine")],["ArrowLeft",()=>this._updateFocusedIndex("previousColumn")],["Tab",()=>this._updateFocusedIndex("nextElem")],["shift+Tab",()=>this._updateFocusedIndex("previousElem")],["Enter",()=>{const menu=this.displayedApps[this.state.focusedIndex];if(menu){this._openMenu(menu);}},],["Escape",()=>this.homeMenuService.toggle(false)],];hotkeys.forEach((hotkey)=>{useHotkey(...hotkey,{allowRepeat:true,});});useExternalListener(window,"keydown",this._onKeydownFocusInput);}
_onKeydownFocusInput(){if(document.activeElement!==this.inputRef.el&&this.ui.activeElement===document&&!["TEXTAREA","INPUT"].includes(document.activeElement.tagName)){this._focusInput();}}
_onInputSearch(){const onClose=()=>{this._focusInput();this.inputRef.el.value="";};const searchValue=this.compositionStart?"/":`/${this.inputRef.el.value.trim()}`;this.compositionStart=false;this.command.openMainPalette({searchValue,FooterComponent},onClose);}
_onInputBlur(){if(hasTouch()){return;}
setTimeout(()=>{if(document.activeElement===document.body&&this.ui.activeElement===document){this._focusInput();}},0);}
_onCompositionStart(){this.compositionStart=true;}}
return __exports;});;

/* /web_enterprise/static/src/webclient/home_menu/home_menu_service.js */
odoo.define('@web_enterprise/webclient/home_menu/home_menu_service',['@web/core/l10n/translation','@web/core/registry','@web/core/user','@web/core/utils/concurrency','@web/core/utils/hooks','@web/webclient/menus/menu_helpers','@web/webclient/actions/action_service','@web_enterprise/webclient/home_menu/home_menu','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{Mutex}=require("@web/core/utils/concurrency");const{useService}=require("@web/core/utils/hooks");const{computeAppsAndMenuItems,reorderApps}=require("@web/webclient/menus/menu_helpers");const{ControllerNotFoundError,standardActionServiceProps,}=require("@web/webclient/actions/action_service");const{HomeMenu}=require("@web_enterprise/webclient/home_menu/home_menu");const{Component,onMounted,onWillUnmount,useState,reactive,xml}=require("@odoo/owl");const homeMenuService=__exports.homeMenuService={dependencies:["action"],start(env){const state=reactive({hasHomeMenu:false,hasBackgroundAction:false,toggle,});const mutex=new Mutex();class HomeMenuAction extends Component{static components={HomeMenu};static target="current";static props={...standardActionServiceProps};static template=xml`<HomeMenu t-props="homeMenuProps"/>`;static displayName=_t("Home");setup(){this.menus=useService("menu");const homemenuConfig=JSON.parse(user.settings?.homemenu_config||"null");const apps=useState(computeAppsAndMenuItems(this.menus.getMenuAsTree("root")).apps);if(homemenuConfig){reorderApps(apps,homemenuConfig);}
this.homeMenuProps={apps:apps,reorderApps:(order)=>{reorderApps(apps,order);},};onMounted(()=>this.onMounted());onWillUnmount(this.onWillUnmount);}
async onMounted(){const{breadcrumbs}=this.env.config;state.hasHomeMenu=true;state.hasBackgroundAction=breadcrumbs.length>0;this.env.bus.trigger("HOME-MENU:TOGGLED");}
onWillUnmount(){state.hasHomeMenu=false;state.hasBackgroundAction=false;this.env.bus.trigger("HOME-MENU:TOGGLED");}}
registry.category("actions").add("menu",HomeMenuAction);env.bus.addEventListener("HOME-MENU:TOGGLED",()=>{document.body.classList.toggle("o_home_menu_background",state.hasHomeMenu);});async function toggle(show){return mutex.exec(async()=>{show=show===undefined?!state.hasHomeMenu:Boolean(show);if(show!==state.hasHomeMenu){if(show){await env.services.action.doAction("menu");}else{try{await env.services.action.restore();}catch(err){if(!(err instanceof ControllerNotFoundError)){throw err;}}}}
return new Promise((r)=>setTimeout(r));});}
return state;},};registry.category("services").add("home_menu",homeMenuService);return __exports;});;

/* /web_enterprise/static/src/webclient/navbar/navbar.js */
odoo.define('@web_enterprise/webclient/navbar/navbar',['@web/webclient/navbar/navbar','@web/core/utils/hooks','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{NavBar}=require("@web/webclient/navbar/navbar");const{useService,useBus}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const{useState,useEffect,useRef}=require("@odoo/owl");const EnterpriseNavBar=__exports.EnterpriseNavBar=class EnterpriseNavBar extends NavBar{static template="web_enterprise.EnterpriseNavBar";setup(){super.setup();this.hm=useState(useService("home_menu"));this.pwa=useService("pwa");this.menuAppsRef=useRef("menuApps");this.navRef=useRef("nav");this._busToggledCallback=()=>this._updateMenuAppsIcon();useBus(this.env.bus,"HOME-MENU:TOGGLED",this._busToggledCallback);useEffect(()=>this._updateMenuAppsIcon());}
get hasBackgroundAction(){return this.hm.hasBackgroundAction;}
get isInApp(){return!this.hm.hasHomeMenu;}
_openAppMenuSidebar(){if(this.hm.hasHomeMenu){this.hm.toggle(false);}else{this.state.isAppMenuSidebarOpened=true;}}
_updateMenuAppsIcon(){const menuAppsEl=this.menuAppsRef.el;menuAppsEl.classList.toggle("o_hidden",!this.isInApp&&!this.hasBackgroundAction);menuAppsEl.classList.toggle("o_menu_toggle_back",!this.isInApp&&this.hasBackgroundAction);if(!this.isScopedApp){const title=!this.isInApp&&this.hasBackgroundAction?_t("Previous view"):_t("Home menu");menuAppsEl.title=title;menuAppsEl.ariaLabel=title;}
const menuBrand=this.navRef.el.querySelector(".o_menu_brand");if(menuBrand){menuBrand.classList.toggle("o_hidden",!this.isInApp);}
const menuBrandIcon=this.navRef.el.querySelector(".o_menu_brand_icon");if(menuBrandIcon){menuBrandIcon.classList.toggle("o_hidden",!this.isInApp);}
const appSubMenus=this.appSubMenus.el;if(appSubMenus){appSubMenus.classList.toggle("o_hidden",!this.isInApp);}
const breadcrumb=this.navRef.el.querySelector(".o_breadcrumb");if(breadcrumb){breadcrumb.classList.toggle("o_hidden",!this.isInApp);}}
onAllAppsBtnClick(){super.onAllAppsBtnClick();this.hm.toggle(true);this._closeAppMenuSidebar();}}
return __exports;});;

/* /web_enterprise/static/src/webclient/promote_studio_dialog/promote_studio_dialog.js */
odoo.define('@web_enterprise/webclient/promote_studio_dialog/promote_studio_dialog',['@web/core/browser/browser','@web/core/dialog/dialog','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{Dialog}=require("@web/core/dialog/dialog");const{useChildRef,useService}=require("@web/core/utils/hooks");const{Component,useExternalListener}=require("@odoo/owl");const PromoteStudioDialog=__exports.PromoteStudioDialog=class PromoteStudioDialog extends Component{static template="web_enterprise.PromoteStudioDialog";static components={Dialog};static props={title:String,close:Function,};setup(){this.ormService=useService("orm");this.uiService=useService("ui");this.modalRef=useChildRef();useExternalListener(window,"mousedown",this.onWindowMouseDown);}
async onClickInstallStudio(){this.disableClick=true;this.uiService.block();const modules=await this.ormService.searchRead("ir.module.module",[["name","=","web_studio"]],["id"]);await this.ormService.call("ir.module.module","button_immediate_install",[[modules[0].id],]);this.uiService.unblock();browser.localStorage.setItem("openStudioOnReload","main");browser.location.reload();}
onWindowMouseDown(ev){const dialogContent=this.modalRef.el.querySelector(".modal-content");if(!this.disableClick&&!dialogContent.contains(ev.target)){this.props.close();}}}
const PromoteStudioAutomationDialog=__exports.PromoteStudioAutomationDialog=class PromoteStudioAutomationDialog extends PromoteStudioDialog{static template="web_enterprise.PromoteStudioAutomationDialog";}
return __exports;});;

/* /web_enterprise/static/src/webclient/share_url/burger_menu.js */
odoo.define('@web_enterprise/webclient/share_url/burger_menu',['@web/core/browser/feature_detection','@web/core/utils/patch','@web/webclient/burger_menu/burger_menu','@web_enterprise/webclient/share_url/share_url'],function(require){'use strict';let __exports={};const{isDisplayStandalone}=require("@web/core/browser/feature_detection");const{patch}=require("@web/core/utils/patch");const{BurgerMenu}=require("@web/webclient/burger_menu/burger_menu");const{shareUrl}=require("@web_enterprise/webclient/share_url/share_url");if(navigator.share&&isDisplayStandalone()){patch(BurgerMenu.prototype,{shareUrl,});patch(BurgerMenu,{template:"web_enterprise.BurgerMenu",});}
return __exports;});;

/* /web_enterprise/static/src/webclient/share_url/share_url.js */
odoo.define('@web_enterprise/webclient/share_url/share_url',['@web/core/l10n/translation','@odoo/owl','@web/core/registry','@web/core/browser/browser','@web/core/browser/feature_detection','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{markup}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{browser}=require("@web/core/browser/browser");const{isDisplayStandalone}=require("@web/core/browser/feature_detection");const{escape}=require("@web/core/utils/strings");__exports.shareUrl=shareUrl;async function shareUrl(){await navigator.share({url:browser.location.href,title:document.title,}).catch((e)=>{if(!(e instanceof DOMException&&e.name==="AbortError")){throw e;}});}
__exports.shareUrlMenuItem=shareUrlMenuItem;function shareUrlMenuItem(env){const translatedText=_t("Share");return{type:"item",hide:env.isSmall||!isDisplayStandalone(),id:"share_url",description:markup(`<div class="d-flex align-items-center justify-content-between">
                <span>${escape(translatedText)}</span>
                <span class="fa fa-share-alt"></span>
            </div>`),callback:shareUrl,sequence:25,};}
if(navigator.share){registry.category("user_menuitems").add("share_url",shareUrlMenuItem);}
return __exports;});;

/* /web_enterprise/static/src/webclient/webclient.js */
odoo.define('@web_enterprise/webclient/webclient',['@web/webclient/webclient','@web/core/utils/hooks','@web_enterprise/webclient/navbar/navbar'],function(require){'use strict';let __exports={};const{WebClient}=require("@web/webclient/webclient");const{useService}=require("@web/core/utils/hooks");const{EnterpriseNavBar}=require("@web_enterprise/webclient/navbar/navbar");const WebClientEnterprise=__exports.WebClientEnterprise=class WebClientEnterprise extends WebClient{static components={...WebClient.components,NavBar:EnterpriseNavBar,};setup(){super.setup();this.hm=useService("home_menu");}
_loadDefaultApp(){return this.hm.toggle(true);}}
return __exports;});;

/* /web_enterprise/static/src/views/kanban/kanban_header_patch.js */
odoo.define('@web_enterprise/views/kanban/kanban_header_patch',['@web/core/registry','@web/core/utils/patch','@web/views/kanban/kanban_header','@web_enterprise/webclient/promote_studio_dialog/promote_studio_dialog','@web/core/l10n/translation','@web/core/user'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{patch}=require("@web/core/utils/patch");const{KanbanHeader}=require("@web/views/kanban/kanban_header");const{PromoteStudioAutomationDialog}=require("@web_enterprise/webclient/promote_studio_dialog/promote_studio_dialog");const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");patch(KanbanHeader.prototype,{get permissions(){const permissions=super.permissions;Object.defineProperty(permissions,"canEditAutomations",{get:()=>user.isAdmin,configurable:true,});return permissions;},async openAutomations(){if(typeof this._openAutomations==="function"){return this._openAutomations();}else{this.env.services.dialog.add(PromoteStudioAutomationDialog,{title:_t("Odoo Studio - Customize workflows in minutes"),});}},});registry.category("kanban_header_config_items").add("open_automations",{label:_t("Automations"),method:"openAutomations",isVisible:({permissions})=>permissions.canEditAutomations,class:"o_column_automations",},{sequence:25,force:true});return __exports;});;

/* /web_enterprise/static/src/views/list/list_renderer_desktop.js */
odoo.define('@web_enterprise/views/list/list_renderer_desktop',['@web/core/browser/feature_detection','@web/core/user','@web/core/utils/hooks','@web/core/utils/patch','@web/views/list/list_renderer','@web_enterprise/webclient/promote_studio_dialog/promote_studio_dialog','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{isMobileOS}=require("@web/core/browser/feature_detection");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");const{ListRenderer}=require("@web/views/list/list_renderer");const{PromoteStudioDialog}=require("@web_enterprise/webclient/promote_studio_dialog/promote_studio_dialog");const{_t}=require("@web/core/l10n/translation");const{onWillDestroy,useState}=require("@odoo/owl");const patchListRendererDesktop=__exports.patchListRendererDesktop=()=>({setup(){super.setup(...arguments);this.actionService=useService("action");const list=this.props.list;const{actionId,actionType}=this.env.config||{};const isPotentiallyEditable=!isMobileOS()&&!this.env.inDialog&&user.isSystem&&list===list.model.root&&actionId&&actionType==="ir.actions.act_window";this.studioEditable=useState({value:isPotentiallyEditable});if(isPotentiallyEditable){const computeStudioEditable=(action)=>{if(!action.xml_id){return false;}
if(action.res_model.indexOf("settings")>-1&&action.res_model.indexOf("x_")!==0){return false;}
if(action.res_model==="board.board"){return false;}
if(action.view_mode==="qweb"){return false;}
if(action.res_model==="knowledge.article"){return false;}
return Boolean(action.res_model);};const onUiUpdated=()=>{const action=this.actionService.currentController.action;if(action.id===actionId){this.studioEditable.value=computeStudioEditable(action);}
stopListening();};const stopListening=()=>this.env.bus.removeEventListener("ACTION_MANAGER:UI-UPDATED",onUiUpdated);this.env.bus.addEventListener("ACTION_MANAGER:UI-UPDATED",onUiUpdated);onWillDestroy(stopListening);}},isStudioEditable(){return this.studioEditable.value;},get displayOptionalFields(){return this.isStudioEditable()||super.displayOptionalFields;},onSelectedAddCustomField(){this.env.services.dialog.add(PromoteStudioDialog,{title:_t("Odoo Studio - Add new fields to any view"),});},});const unpatchListRendererDesktop=__exports.unpatchListRendererDesktop=patch(ListRenderer.prototype,patchListRendererDesktop());return __exports;});;

/* /web_mobile/static/src/js/core/hooks.js */
odoo.define('@web_mobile/js/core/hooks',['@web_mobile/js/services/core','@odoo/owl'],function(require){'use strict';let __exports={};const ServiceCore=require("@web_mobile/js/services/core")[Symbol.for("default")];const{onMounted,onPatched,onWillUnmount,useComponent}=require("@odoo/owl");__exports.useBackButton=useBackButton;function useBackButton(func,shouldEnable){const component=useComponent();let isEnabled=false;function enable(){ServiceCore.backButtonManager.addListener(component,func);isEnabled=true;}
function disable(){ServiceCore.backButtonManager.removeListener(component);isEnabled=false;}
onMounted(()=>{if(shouldEnable&&!shouldEnable()){return;}
enable();});onPatched(()=>{if(!shouldEnable){return;}
const shouldBeEnabled=shouldEnable();if(shouldBeEnabled&&!isEnabled){enable();}else if(!shouldBeEnabled&&isEnabled){disable();}});onWillUnmount(()=>{if(isEnabled){disable();}});}
return __exports;});;

/* /web_mobile/static/src/js/core/mixins.js */
odoo.define('@web_mobile/js/core/mixins',['@web/core/user','@web_mobile/js/services/core','@web/core/browser/feature_detection','@web/core/utils/urls'],function(require){'use strict';let __exports={};const{user}=require("@web/core/user");const mobile=require("@web_mobile/js/services/core")[Symbol.for("default")];const{isIosApp}=require("@web/core/browser/feature_detection");const{url}=require("@web/core/utils/urls");const DEFAULT_AVATAR_SIZE=128;const accountMethodsForMobile=__exports.accountMethodsForMobile={url,async updateAccount(){if(!mobile.methods.updateAccount){return;}
const base64Avatar=await accountMethodsForMobile.fetchAvatar();return mobile.methods.updateAccount({avatar:base64Avatar.substring(base64Avatar.indexOf(',')+1),name:user.name,username:user.login,});},fetchAvatar(){const avatarUrl=accountMethodsForMobile.url('/web/image',{model:'res.users',field:'image_medium',id:user.userId,});return new Promise((resolve,reject)=>{const canvas=document.createElement('canvas');canvas.width=DEFAULT_AVATAR_SIZE;canvas.height=DEFAULT_AVATAR_SIZE;const context=canvas.getContext('2d');const image=new Image();image.addEventListener('load',()=>{context.drawImage(image,0,0,DEFAULT_AVATAR_SIZE,DEFAULT_AVATAR_SIZE);resolve(canvas.toDataURL('image/png'));});image.addEventListener('error',reject);image.src=avatarUrl;});},};const UpdateDeviceAccountControllerMixin={async save(){const isSaved=await this._super(...arguments);if(!isSaved){return false;}
const updated=accountMethodsForMobile.updateAccount();if(!isIosApp()){await updated;}
return true;},};__exports.updateAccountOnMobileDevice=updateAccountOnMobileDevice;async function updateAccountOnMobileDevice(){const updated=accountMethodsForMobile.updateAccount();if(!isIosApp()){await updated;}}
accountMethodsForMobile.updateAccount();__exports[Symbol.for("default")]={UpdateDeviceAccountControllerMixin,updateAccountOnMobileDevice,};return __exports;});;

/* /web_mobile/static/src/js/core/network/download.js */
odoo.define('@web_mobile/js/core/network/download',['@web_mobile/js/services/core','@web/core/network/download'],function(require){'use strict';let __exports={};const mobile=require("@web_mobile/js/services/core")[Symbol.for("default")];const{download}=require("@web/core/network/download");const _download=download._download;download._download=async function(options){if(mobile.methods.downloadFile){if(odoo.csrf_token){options.csrf_token=odoo.csrf_token;}
mobile.methods.downloadFile(options);return Promise.resolve();}else{return _download.apply(this,arguments);}};return __exports;});;

/* /web_mobile/static/src/js/core/popover.js */
odoo.define('@web_mobile/js/core/popover',['@web/core/popover/popover','@web_mobile/js/core/hooks','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Popover}=require("@web/core/popover/popover");const{useBackButton}=require("@web_mobile/js/core/hooks");const{patch}=require("@web/core/utils/patch");patch(Popover.prototype,{setup(){super.setup(...arguments);useBackButton(this.onBackButton.bind(this),()=>this.props.target.isConnected);},onBackButton(){this.props.close();},});return __exports;});;

/* /web_mobile/static/src/js/crash_manager.js */
odoo.define('@web_mobile/js/crash_manager',['@web/core/registry','@web_mobile/js/services/core'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const mobile=require("@web_mobile/js/services/core")[Symbol.for("default")];function mobileErrorHandler(env,error,originalError){if(mobile.methods.crashManager){error.originalError=originalError;mobile.methods.crashManager(error);}}
registry.category("error_handlers").add("web_mobile.errorHandler",mobileErrorHandler,{sequence:3});return __exports;});;

/* /web_mobile/static/src/js/hook_event_bus.js */
odoo.define('@web_mobile/js/hook_event_bus',['@odoo/owl'],function(require){'use strict';let __exports={};const{EventBus}=require("@odoo/owl");const HookEventBus=__exports.HookEventBus=class HookEventBus extends EventBus{constructor(hooks={}){super();this.hooks=hooks;}
addEventListener(eventName,listener){super.addEventListener(eventName,listener);this.hooks.onAddListener?.(eventName,listener);}
removeEventListener(eventName,listener){super.removeEventListener(eventName,listener);this.hooks.onRemoveListener?.(eventName,listener);}}
return __exports;});;

/* /web_mobile/static/src/js/mobile_service.js */
odoo.define('@web_mobile/js/mobile_service',['@web_mobile/js/hook_event_bus','@web/core/registry','@web/session','@web_mobile/js/services/core','@web_mobile/js/user_menu_items'],function(require){'use strict';let __exports={};const{HookEventBus}=require("@web_mobile/js/hook_event_bus");const{registry}=require("@web/core/registry");const{session}=require("@web/session");const mobile=require("@web_mobile/js/services/core")[Symbol.for("default")];const{shortcutItem,switchAccountItem}=require("@web_mobile/js/user_menu_items");const serviceRegistry=registry.category("services");const userMenuRegistry=registry.category("user_menuitems");const mobileService=__exports.mobileService={timeBetweenReadsInMs:session.time_between_reads_in_ms||100,idInterval:null,start(){let listenerCount=0;this.bus=new HookEventBus({onAddListener:(eventName,listener)=>{listenerCount++;if(listenerCount===1){api.enableReader();}},onRemoveListener:(eventName,listener)=>{listenerCount--;if(listenerCount===0){api.stopReader();}},});const api={bus:this.bus,enableReader:this.enableReader,stopReader:this.stopReader,};if(mobile.methods.addHomeShortcut){userMenuRegistry.add("web_mobile.shortcut",shortcutItem);}
if(mobile.methods.switchAccount){userMenuRegistry.remove('log_out');userMenuRegistry.remove('odoo_account');userMenuRegistry.add("web_mobile.switch",switchAccountItem);}
return api;},enableReader(){if(mobile.methods.enableReader&&mobile.methods.getReaderData){mobile.methods.enableReader().catch(e=>console.error(e));if(!this.idInterval){this.idInterval=setInterval(async()=>{try{const value=await mobile.methods.getReaderData();if(value.success){const data=value.data;if(data.length>0){this.bus.trigger("mobile_reader_scanned",{data});}}}catch(e){console.error(e);}},this.timeBetweenReadsInMs);}}},stopReader(){if(this.idInterval){clearInterval(this.idInterval);this.idInterval=null;}},};serviceRegistry.add("mobile",mobileService);return __exports;});;

/* /web_mobile/static/src/js/services/core.js */
odoo.define('@web_mobile/js/services/core',['@web/core/utils/functions','@web/core/browser/browser','@web/core/browser/router'],function(require){'use strict';let __exports={};const{uniqueId}=require("@web/core/utils/functions");const{browser}=require("@web/core/browser/browser");const{parseSearchQuery}=require("@web/core/browser/router");var available=typeof OdooDeviceUtility!=='undefined';var DeviceUtility;var deferreds={};var methods=__exports.methods={};if(available){DeviceUtility=OdooDeviceUtility;delete window.OdooDeviceUtility;}
function native_invoke(name,args){if(args===undefined){args={};}
var id=uniqueId();args=JSON.stringify(args);DeviceUtility.execute(name,args,id);return new Promise(function(resolve,reject){deferreds[id]={successCallback:resolve,errorCallback:reject};});}
window.odoo.native_notify=function(id,result){if(deferreds.hasOwnProperty(id)){if(result.success){deferreds[id].successCallback(result);}else{deferreds[id].errorCallback(result);}}};var plugins=available?JSON.parse(DeviceUtility.list_plugins()):[];plugins.forEach((plugin)=>{methods[plugin.name]=function(args){return native_invoke(plugin.action,args);};});if(methods.hashChange){var currentSearch;browser.addEventListener("popstate",function(){const search=parseSearchQuery(browser.location.search);if(JSON.stringify(currentSearch)!==JSON.stringify(search)){methods.hashChange(search);}
currentSearch=search;});}
class BackButtonListenerError extends Error{}
class BackButtonManager{constructor(){this._listeners=new Map();this._onGlobalBackButton=this._onGlobalBackButton.bind(this);}
addListener(listener,func){if(!methods.overrideBackButton){return;}
if(this._listeners.has(listener)){throw new BackButtonListenerError("This listener was already registered.");}
this._listeners.set(listener,func);if(this._listeners.size===1){document.addEventListener('backbutton',this._onGlobalBackButton);methods.overrideBackButton({enabled:true});}}
removeListener(listener){if(!methods.overrideBackButton){return;}
if(!this._listeners.has(listener)){throw new BackButtonListenerError("This listener has already been unregistered.");}
this._listeners.delete(listener);if(this._listeners.size===0){document.removeEventListener('backbutton',this._onGlobalBackButton);methods.overrideBackButton({enabled:false});}}
_onGlobalBackButton(){const[listener,func]=[...this._listeners].pop();if(listener){func.apply(listener,arguments);}}}
const backButtonManager=new BackButtonManager();__exports[Symbol.for("default")]={BackButtonManager,BackButtonListenerError,backButtonManager,methods,};return __exports;});;

/* /web_mobile/static/src/js/user_menu_items.js */
odoo.define('@web_mobile/js/user_menu_items',['@web/core/l10n/translation','@web_mobile/js/services/core'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const mobile=require("@web_mobile/js/services/core")[Symbol.for("default")];__exports.shortcutItem=shortcutItem;function shortcutItem(env){return{type:"item",id:"web_mobile.shortcut",description:_t("Add to Home Screen"),callback:()=>{const menu=env.services.menu.getCurrentApp();if(menu){const base64Icon=menu.webIconData;mobile.methods.addHomeShortcut({title:document.title,shortcut_url:document.URL,web_icon:base64Icon.substring(base64Icon.indexOf(",")+1),});}else{env.services.notification.add(_t("No shortcut for Home Menu"));}},sequence:100,};}
__exports.switchAccountItem=switchAccountItem;function switchAccountItem(env){return{type:"item",id:"web_mobile.switch",description:_t("Switch/Add Account"),callback:()=>{mobile.methods.switchAccount();},sequence:100,};}
return __exports;});;

/* /web_mobile/static/src/views/user_preferences_form_view.js */
odoo.define('@web_mobile/views/user_preferences_form_view',['@web/core/registry','@web/views/form/form_view','@web_mobile/js/core/mixins'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");const{updateAccountOnMobileDevice}=require("@web_mobile/js/core/mixins");class ResUsersPreferenceController extends formView.Controller{onRecordSaved(record){return updateAccountOnMobileDevice();}}
registry.category("views").add("res_users_preferences_form",{...formView,Controller:ResUsersPreferenceController,});return __exports;});;

/* /mail_enterprise/static/src/core/common/message_patch.js */
odoo.define('@mail_enterprise/core/common/message_patch',['@web/core/utils/patch','@mail/core/common/message'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{Message}=require("@mail/core/common/message");patch(Message,{SHADOW_LINK_COLOR:"#017e84",SHADOW_LINK_HOVER_COLOR:"#016b70",});return __exports;});;

/* /mail_enterprise/static/src/attachments/attachment_viewer_patch.js */
odoo.define('@mail_enterprise/attachments/attachment_viewer_patch',['@web/core/file_viewer/file_viewer','@web/core/utils/patch','@web_mobile/js/core/hooks'],function(require){'use strict';let __exports={};const{FileViewer}=require("@web/core/file_viewer/file_viewer");const{patch}=require("@web/core/utils/patch");const{useBackButton}=require("@web_mobile/js/core/hooks");patch(FileViewer.prototype,{setup(){super.setup();useBackButton(()=>this.close());},});return __exports;});;

/* /mail_enterprise/static/src/web/chat_window/chat_window_patch.js */
odoo.define('@mail_enterprise/web/chat_window/chat_window_patch',['@mail/core/common/chat_window','@web/core/utils/hooks','@web/core/utils/patch','@web_mobile/js/core/hooks'],function(require){'use strict';let __exports={};const{ChatWindow}=require("@mail/core/common/chat_window");const{useService}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");const{useBackButton}=require("@web_mobile/js/core/hooks");patch(ChatWindow.prototype,{setup(){super.setup();useBackButton(()=>this.props.chatWindow.close());this.homeMenuService=useService("home_menu");},});return __exports;});;

/* /mail_enterprise/static/src/web/messaging_menu/messaging_menu_patch.js */
odoo.define('@mail_enterprise/web/messaging_menu/messaging_menu_patch',['@mail/core/public_web/messaging_menu','@web/core/utils/patch','@web_mobile/js/core/hooks'],function(require){'use strict';let __exports={};const{MessagingMenu}=require("@mail/core/public_web/messaging_menu");const{patch}=require("@web/core/utils/patch");const{useBackButton}=require("@web_mobile/js/core/hooks");patch(MessagingMenu.prototype,{setup(){super.setup();useBackButton(()=>this.dropdown.close(),()=>this.dropdown.isOpen);},});return __exports;});;

/* /mail_enterprise/static/src/web/thread_action_patch.js */
odoo.define('@mail_enterprise/web/thread_action_patch',['@mail/core/common/thread_actions'],function(require){'use strict';let __exports={};const{threadActionsRegistry}=require("@mail/core/common/thread_actions");threadActionsRegistry.get("expand-discuss").shouldClearBreadcrumbs=(component)=>{return component.homeMenuService.hasHomeMenu;};return __exports;});;

/* /account_accountant/static/src/js/tours/account_accountant.js */
odoo.define('@account_accountant/js/tours/account_accountant',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/patch','@odoo/owl','@account/js/tours/account'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{patch}=require("@web/core/utils/patch");const{markup}=require("@odoo/owl");const{accountTourSteps}=require("@account/js/tours/account");patch(accountTourSteps,{newInvoice(){return[{trigger:"button[name=action_create_new]",content:_t("Now, we'll create your first invoice (accountant)"),run:"click",}]},});registry.category("web_tour.tours").add('account_accountant_tour',{url:"/odoo",steps:()=>[...accountTourSteps.goToAccountMenu('Let’s automate your bills, bank transactions and accounting processes.'),{trigger:'a[name="action_create_vendor_bill"]',content:markup(_t('Create your first vendor bill.<br/><br/><i>Tip: If you don’t have one on hand, use our sample bill.</i>')),tooltipPosition:'bottom',run:"click",},{trigger:'button.btn-primary[name="action_post"]',content:_t('After the data extraction, check and validate the bill. If no vendor has been found, add one before validating.'),tooltipPosition:'bottom',run:"click",},{trigger:'.dropdown-item[data-menu-xmlid="account.menu_board_journal_1"]',content:_t('Let’s go back to the dashboard.'),tooltipPosition:'bottom',run:"click",},{trigger:'a[name="open_action"] span:contains(bank)',content:_t('Connect your bank and get your latest transactions.'),tooltipPosition:'bottom',run:"click",},{trigger:'button.o-kanban-button-new',content:_t('Create a new transaction.'),run:"click",},{trigger:"div[name=amount] div input[id=amount_0]",content:_t("Set an amount."),tooltipPosition:"bottom",run:"edit -19250.00",},{trigger:"div[name=payment_ref] input[id=payment_ref_0]",content:_t("Set the payment reference."),tooltipPosition:"bottom",run:"edit Payment Deco Adict",},{trigger:"button.o_kanban_edit",content:_t("Confirm the transaction."),tooltipPosition:"bottom",run:"click",},{trigger:'.o_kanban_renderer:not(:has(.o_bank_rec_quick_create)) .o_bank_rec_st_line:not(.o_bank_rec_selected_st_line)',content:_t('Click on a fetched bank transaction to start the reconciliation process.'),run:"click",},{isActive:['auto'],trigger:'.dropdown-item[data-menu-xmlid="account.menu_board_journal_1"]',content:_t('Let’s go back to the dashboard.'),run:"click",},]});return __exports;});;

/* /account_accountant/static/src/components/bank_reconciliation/amls_list_view.js */
odoo.define('@account_accountant/components/bank_reconciliation/amls_list_view',['@web/core/registry','@account_accountant/components/bank_reconciliation/embedded_list_view','@web/views/list/list_renderer','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{EmbeddedListView}=require("@account_accountant/components/bank_reconciliation/embedded_list_view");const{ListRenderer}=require("@web/views/list/list_renderer");const{useState,onWillUnmount}=require("@odoo/owl");const BankRecAmlsRenderer=__exports.BankRecAmlsRenderer=class BankRecAmlsRenderer extends ListRenderer{setup(){super.setup();this.globalState=useState(this.env.methods.getState());onWillUnmount(this.saveSearchState);}
getRowClass(record){const classes=super.getRowClass(record);const amlId=this.globalState.bankRecRecordData.selected_aml_ids.currentIds.find((x)=>x===record.resId);if(amlId){return`${classes} o_rec_widget_list_selected_item table-info`;}
return classes;}
async onCellClicked(record,column,ev){const amlId=this.globalState.bankRecRecordData.selected_aml_ids.currentIds.find((x)=>x===record.resId);if(amlId){this.env.config.actionRemoveNewAml(record.resId);}else{this.env.config.actionAddNewAml(record.resId);}}
saveSearchState(){const initParams=this.globalState.bankRecEmbeddedViewsData.amls;const searchModel=this.env.searchModel;initParams.exportState={searchModel:JSON.stringify(searchModel.exportState())};}}
const BankRecAmls=__exports.BankRecAmls={...EmbeddedListView,Renderer:BankRecAmlsRenderer,};registry.category("views").add("bank_rec_amls_list_view",BankRecAmls);return __exports;});;

/* /account_accountant/static/src/components/bank_reconciliation/bank_rec_quick_create.js */
odoo.define('@account_accountant/components/bank_reconciliation/bank_rec_quick_create',['@web/views/kanban/kanban_record_quick_create'],function(require){'use strict';let __exports={};const{KanbanRecordQuickCreate,KanbanQuickCreateController}=require("@web/views/kanban/kanban_record_quick_create");const BankRecQuickCreateController=__exports.BankRecQuickCreateController=class BankRecQuickCreateController extends KanbanQuickCreateController{static template="account.BankRecQuickCreateController";}
const BankRecQuickCreate=__exports.BankRecQuickCreate=class BankRecQuickCreate extends KanbanRecordQuickCreate{static template="account.BankRecQuickCreate";static props={...Object.fromEntries(Object.entries(KanbanRecordQuickCreate.props).filter(([k,v])=>k!=='group')),globalState:{type:Object,optional:true},};static components={BankRecQuickCreateController};async getQuickCreateProps(props){await super.getQuickCreateProps({...props,group:{resModel:props.globalState.quickCreateState.resModel,context:props.globalState.quickCreateState.context,}});}}
return __exports;});;

/* /account_accountant/static/src/components/bank_reconciliation/bank_rec_record.js */
odoo.define('@account_accountant/components/bank_reconciliation/bank_rec_record',['@web/model/relational_model/record','@web/model/relational_model/relational_model','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{Record}=require("@web/model/relational_model/record");const{RelationalModel}=require("@web/model/relational_model/relational_model");const{parseServerValue}=require("@web/model/relational_model/utils");const BankRecRecord=__exports.BankRecRecord=class BankRecRecord extends Record{async _update(changes){if(this.resModel==="bank.rec.widget.line"){for(const fieldName of Object.keys(changes)){this.model.lineIdsChangedField=fieldName;}}
return super._update(...arguments);}
async updateToDoCommand(methodName,args,kwargs){this.dirty=true;const onChangeFields=["todo_command"];const changes={todo_command:{method_name:methodName,args:args,kwargs:kwargs,},};const localChanges=this._getChanges({...this._changes,...changes},{withReadonly:true});const otherChanges=await this.model._onchange(this.config,{changes:localChanges,fieldNames:onChangeFields,evalContext:this.evalContext,});const data={...this.data,...changes};for(const fieldName in otherChanges){data[fieldName]=parseServerValue(this.fields[fieldName],otherChanges[fieldName]);}
const applyChanges=()=>{Object.assign(changes,this._parseServerValues(otherChanges,this.data));if(Object.keys(changes).length>0){this._applyChanges(changes);}};return{data,applyChanges};}
bindActionOnLineChanged(callback){this._onUpdate=async()=>{const lineIdsChangedField=this.model.lineIdsChangedField;if(lineIdsChangedField){this.model.lineIdsChangedField=null;await callback(lineIdsChangedField);}}}}
const BankRecRelationalModel=__exports.BankRecRelationalModel=class BankRecRelationalModel extends RelationalModel{setup(params,{action,dialog,notification,rpc,user,view,company}){super.setup(...arguments);this.lineIdsChangedField=null;}
load({values}){this.root=this._createRoot(this.config,values);}
getInitialValues(){return this.root._getChanges(this.root.data,{withReadonly:true})}}
BankRecRelationalModel.Record=BankRecRecord;return __exports;});;

/* /account_accountant/static/src/components/bank_reconciliation/embedded_list_view.js */
odoo.define('@account_accountant/components/bank_reconciliation/embedded_list_view',['@web/views/list/list_controller','@web/views/list/list_view'],function(require){'use strict';let __exports={};const{ListController}=require("@web/views/list/list_controller");const{listView}=require("@web/views/list/list_view");const BankRecEmbeddedListController=__exports.BankRecEmbeddedListController=class BankRecEmbeddedListController extends ListController{static template="account_accountant.BankRecEmbeddedListController";}
const BankRecWidgetFormEmbeddedListModel=__exports.BankRecWidgetFormEmbeddedListModel=class BankRecWidgetFormEmbeddedListModel extends listView.Model{setup(params,{action,dialog,notification,rpc,user,view,company}){super.setup(...arguments);this.storedDomainString=null;}
async load(params={}){const currentDomain=params.domain.toString();if(currentDomain!==this.storedDomainString){this.storedDomainString=currentDomain;return super.load(params);}}}
const EmbeddedListView=__exports.EmbeddedListView={...listView,Controller:BankRecEmbeddedListController,Model:BankRecWidgetFormEmbeddedListModel,};return __exports;});;

/* /account_accountant/static/src/components/bank_reconciliation/finish_buttons.js */
odoo.define('@account_accountant/components/bank_reconciliation/finish_buttons',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const BankRecFinishButtons=__exports.BankRecFinishButtons=class BankRecFinishButtons extends Component{static template="account_accountant.BankRecFinishButtons";static props={};setup(){this.breadcrumbs=useState(this.env.config.breadcrumbs);}
getJournalFilter(){return Object.values(this.searchModel.searchItems).filter(i=>i.type=="field"&&i.fieldName=="journal_id")[0];}
get searchModel(){return this.env.searchModel;}
get otherFiltersActive(){const facets=this.searchModel.facets;const journalFilterItem=this.getJournalFilter();for(const facet of facets){if(facet.groupId!==journalFilterItem.groupId){return true;}}
return false;}
clearFilters(){const facets=this.searchModel.facets;const journalFilterItem=this.getJournalFilter();for(const facet of facets){if(facet.groupId!==journalFilterItem.groupId){this.searchModel.deactivateGroup(facet.groupId);}}}
breadcrumbBackOrDashboard(){if(this.breadcrumbs.length>1){this.env.services.action.restore();}else{this.env.services.action.doAction("account.open_account_journal_dashboard_kanban",{clearBreadcrumbs:true});}}}
return __exports;});;

/* /account_accountant/static/src/components/bank_reconciliation/global_info.js */
odoo.define('@account_accountant/components/bank_reconciliation/global_info',['@odoo/owl','@web/core/user'],function(require){'use strict';let __exports={};const{Component,onWillStart}=require("@odoo/owl");const{user}=require("@web/core/user");const BankRecGlobalInfo=__exports.BankRecGlobalInfo=class BankRecGlobalInfo extends Component{static template="account_accountant.BankRecGlobalInfo";static props={journalId:{type:Number},journalBalanceAmount:{type:String},};setup(){this.hasGroupReadOnly=false;onWillStart(async()=>{this.hasGroupReadOnly=await user.hasGroup("account.group_account_readonly");})}
actionOpenBankGL(){this.env.methods.actionOpenBankGL(this.props.journalId);}}
return __exports;});;

/* /account_accountant/static/src/components/bank_reconciliation/kanban.js */
odoo.define('@account_accountant/components/bank_reconciliation/kanban',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/core/utils/scrolling','@web/core/currency','@web/views/fields/formatters','@web/core/l10n/dates','@web/core/l10n/localization','@web/search/action_hook','@web/model/relational_model/relational_model','@web/model/relational_model/utils','@web/views/kanban/kanban_view','@web/views/kanban/kanban_controller','@web/views/kanban/kanban_renderer','@web/views/kanban/kanban_record','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@mail/chatter/web_portal/chatter','@web/views/fields/many2many_tags/many2many_tags_field','@web/views/fields/many2one/many2one_field','@web/views/fields/datetime/datetime_field','@web/views/fields/char/char_field','@analytic/components/analytic_distribution/analytic_distribution','@web/core/tags_list/tags_list','@web_editor/js/backend/html_field','@web/core/effects/rainbow_man','@web/core/notebook/notebook','@web/core/user','@account_accountant/components/bank_reconciliation/bank_rec_record','@account_accountant/components/bank_reconciliation/monetary_field_auto_signed_amount','@account_accountant/components/bank_reconciliation/view_embedder','@account_accountant/components/bank_reconciliation/rainbowman_content','@account_accountant/components/bank_reconciliation/finish_buttons','@account_accountant/components/bank_reconciliation/global_info','@account_accountant/components/bank_reconciliation/bank_rec_quick_create','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{scrollTo}=require("@web/core/utils/scrolling");const{getCurrency}=require("@web/core/currency");const{formatMonetary}=require("@web/views/fields/formatters");const{formatDate}=require("@web/core/l10n/dates");const{localization}=require("@web/core/l10n/localization");const{CallbackRecorder,useSetupAction}=require("@web/search/action_hook");const{RelationalModel}=require("@web/model/relational_model/relational_model");const{makeActiveField}=require("@web/model/relational_model/utils");const{kanbanView}=require("@web/views/kanban/kanban_view");const{KanbanController}=require("@web/views/kanban/kanban_controller");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{KanbanRecord}=require("@web/views/kanban/kanban_record");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{Chatter}=require("@mail/chatter/web_portal/chatter");const{Many2ManyTagsField}=require("@web/views/fields/many2many_tags/many2many_tags_field");const{Many2OneField}=require("@web/views/fields/many2one/many2one_field");const{DateTimeField}=require("@web/views/fields/datetime/datetime_field");const{CharField}=require("@web/views/fields/char/char_field");const{AnalyticDistribution}=require("@analytic/components/analytic_distribution/analytic_distribution");const{TagsList}=require("@web/core/tags_list/tags_list");const{HtmlField}=require("@web_editor/js/backend/html_field");const{RainbowMan}=require("@web/core/effects/rainbow_man");const{Notebook}=require("@web/core/notebook/notebook");const{user}=require("@web/core/user");const{BankRecRelationalModel}=require("@account_accountant/components/bank_reconciliation/bank_rec_record");const{BankRecMonetaryField}=require("@account_accountant/components/bank_reconciliation/monetary_field_auto_signed_amount");const{BankRecViewEmbedder}=require("@account_accountant/components/bank_reconciliation/view_embedder");const{BankRecRainbowContent}=require("@account_accountant/components/bank_reconciliation/rainbowman_content");const{BankRecFinishButtons}=require("@account_accountant/components/bank_reconciliation/finish_buttons");const{BankRecGlobalInfo}=require("@account_accountant/components/bank_reconciliation/global_info");const{BankRecQuickCreate}=require("@account_accountant/components/bank_reconciliation/bank_rec_quick_create");const{onPatched,useState,useEffect,useRef,useChildSubEnv,markRaw}=require("@odoo/owl");const BankRecKanbanRecord=__exports.BankRecKanbanRecord=class BankRecKanbanRecord extends KanbanRecord{static template="account.BankRecKanbanRecord";setup(){super.setup();this.state=useState(this.env.methods.getState());}
getRecordClasses(){let classes=`${super.getRecordClasses()} w-100 o_bank_rec_st_line`;if(this.props.record.resId===this.state.bankRecStLineId){classes=`${classes} o_bank_rec_selected_st_line table-info`;}
return classes;}}
const BankRecKanbanController=__exports.BankRecKanbanController=class BankRecKanbanController extends KanbanController{static template="account.BankRecoKanbanController";static props={...KanbanController.props,skipRestore:{optional:true},};static components={...KanbanController.components,Dropdown,DropdownItem,Many2OneField,Many2ManyTagsField,DateTimeField,CharField,AnalyticDistribution,Chatter,TagsList,HtmlField,BankRecMonetaryField,Notebook,BankRecViewEmbedder,};async setup(){super.setup();this.action=useService("action");this.orm=useService("orm");this.ui=useService("ui");this.relationalModelServices=Object.fromEntries(RelationalModel.services.map((servName)=>{return[servName,useService(servName)];}));this.relationalModelServices.orm=useService("orm");useChildSubEnv(this.getChildSubEnv());this.env.searchModel.addEventListener("update",()=>{this.model.bus.addEventListener("update",this.onKanbanSearchModelChanged.bind(this),{once:true},);},);this.bankRecModel=null;this.state=useState({bankRecStLineId:null,bankRecRecordData:null,bankRecEmbeddedViewsData:null,bankRecNotebookPage:null,bankRecClickedColumn:null,journalId:null,journalBalanceAmount:"",lockedStLineIds:new Set(),lockedAmlIds:new Set(),quickCreateState:{isVisible:false,view:this.props.archInfo.quickCreateView,context:this.props.context,},});this.counter={startTime:null,timeDiff:null,count:null,};useEffect(()=>{if(this.state.bankRecNotebookPage==="manual_operations_tab"&&this.state.bankRecRecordData&&!this.state.bankRecRecordData.form_index){this.actionMountLastLineInEdit();}},()=>[this.state.bankRecNotebookPage],);this.viewRef=useRef("root");useSetupAction({rootRef:this.viewRef,getLocalState:()=>{const exportState={};if(this.bankRecModel.root.data.st_line_id){exportState.backupValues=Object.assign({},this.state.bankRecEmbeddedViewsData,{bankRecStLineId:this.state.bankRecStLineId,initial_values:this.bankRecModel.getInitialValues(),},);}
return exportState;}});onPatched(()=>{if(this.state.bankRecClickedColumn&&this.focusManualOperationField(this.state.bankRecClickedColumn)){this.state.bankRecClickedColumn=null;}});this.kanbanLock=false;this.bankRecLock=false;this.bankRecPromise=null;}
async execProtectedAction(func){if(this.kanbanLock){return;}
this.kanbanLock=true;if(this.bankRecPromise){await this.bankRecPromise;}
await func();this.kanbanLock=false;}
async execProtectedBankRecAction(func){if(this.bankRecLock){return;}
this.bankRecLock=true;try{this.bankRecPromise=func();await this.bankRecPromise;}finally{this.bankRecPromise=null;this.bankRecLock=false;}}
getState(){return this.state;}
async withNewState(func){const newState={...this.state};await func(newState);if(newState.__commitChanges){newState.__commitChanges();delete newState.__commitChanges;}
Object.assign(this.state,newState);}
get modelOptions(){return{...super.modelOptions,onWillStartAfterLoad:this.onWillStartAfterLoad.bind(this),}}
getChildSubEnv(){return{__beforeLeave__:new CallbackRecorder(),__getLocalState__:new CallbackRecorder(),__getGlobalState__:new CallbackRecorder(),__getContext__:new CallbackRecorder(),methods:{withNewState:this.withNewState.bind(this),actionOpenBankGL:this.actionOpenBankGL.bind(this),focusManualOperationField:this.focusManualOperationField.bind(this),getState:this.getState.bind(this),actionAddNewAml:this.actionAddNewAml.bind(this),actionRemoveNewAml:this.actionRemoveNewAml.bind(this),showRainbowMan:this.showRainbowMan.bind(this),initReconCounter:this.initReconCounter.bind(this),getCounterSummary:this.getCounterSummary.bind(this),getRainbowManContentProps:this.getRainbowManContentProps.bind(this),updateJournalState:this.updateJournalState.bind(this),},};}
async onWillStartAfterLoad(){this.hasGroupAnalyticAccounting=await user.hasGroup("analytic.group_analytic_accounting");this.hasGroupReadOnly=await user.hasGroup("account.group_account_readonly");await this.initBankRecModel();let stLineId=null;let backupValues=null;if(this.props.state&&this.props.state.backupValues&&!this.props.skipRestore){const backupStLineId=this.props.state.backupValues.bankRecStLineId;if(this.model.root.records.find(x=>x.resId===backupStLineId)){stLineId=backupStLineId;backupValues=this.props.state.backupValues;}}
if(!stLineId){stLineId=this.getNextAvailableStLineId();}
await this.withNewState(async(newState)=>{if(stLineId){await this._mountStLineInEdit(newState,stLineId,backupValues);}else{await this.updateJournalState(newState);}
this.initReconCounter();});}
async onKanbanSearchModelChanged(){await this.execProtectedAction(async()=>{await this.withNewState(async(newState)=>{if(this.model.root.records.find(x=>x.resId===newState.bankRecStLineId)){return;}
const nextStLineId=this.getNextAvailableStLineId();await this._mountStLineInEdit(newState,nextStLineId);});});}
async openRecord(record,mode){const currentStLineId=this.bankRecModel?this.bankRecModel.root.data.st_line_id[0]:null;const isSameStLineId=currentStLineId&&currentStLineId===record.resId;if(isSameStLineId){return;}
await this.execProtectedAction(async()=>{await this.withNewState(async(newState)=>{await this._mountStLineInEdit(newState,record.resId);});});}
async onUpdatedPager(){await this.execProtectedAction(async()=>{await this.withNewState(async(newState)=>{const nextStLineId=this.getNextAvailableStLineId();await this._mountStLineInEdit(newState,nextStLineId);});});}
onPageUpdate(page){if(this.state.bankRecNotebookPage!==page){this.state.bankRecNotebookPage=page;}}
get canQuickCreate(){return true;}
createRecord(){const{onCreate}=this.props.archInfo;const searchModel=this.env.searchModel;const journalFilter=Object.values(searchModel.searchItems).filter(i=>i.type=="field"&&i.fieldName=="journal_id")[0];if(!this.model.root.records.length){searchModel.facets.forEach(facet=>{if(facet.groupId!==journalFilter.groupId)
searchModel.deactivateGroup(facet.groupId)});}
if(onCreate==="quick_create"&&this.canQuickCreate){this.state.quickCreateState={...this.state.quickCreateState,isVisible:true,resModel:this.props.resModel,model:this.model,};}}
getNextAvailableStLineId(afterStLineId=null,records=null){const stLines=this.model.root.records;const isRecordReady=(x)=>(!x.data.is_reconciled||!x.data.checked);let waitBeforeReturn=Boolean(afterStLineId);let availableRecordIds=[];for(const stLine of(records||stLines)){if(waitBeforeReturn){if(stLine.resId===afterStLineId){waitBeforeReturn=false;}}else if(isRecordReady(stLine)){availableRecordIds.push(stLine.resId);}}
if(!availableRecordIds.length&&stLines.length===1){availableRecordIds=[stLines[0].resId];}
if(availableRecordIds.length){return availableRecordIds[0];}else if(stLines.length){return stLines[0].resId;}else{return null;}}
async _mountStLineInEdit(newState,stLineId,initialData=null){newState.bankRecStLineId=stLineId;let data={};if(initialData){data=await this.onchange(newState,"restore_st_line_data",[initialData]);const bankRecEmbeddedViewsData=data.return_todo_command;for(const[key,value]of Object.entries(bankRecEmbeddedViewsData)){if(value instanceof Object){bankRecEmbeddedViewsData[key]=Object.assign({},initialData[key]||{},value);}else{bankRecEmbeddedViewsData[key]=value;}}
newState.bankRecEmbeddedViewsData=markRaw(bankRecEmbeddedViewsData);newState.bankRecNotebookPage=null;}else if(stLineId){data=await this.onchange(newState,"mount_st_line",[stLineId]);const bankRecEmbeddedViewsData=data.return_todo_command
newState.bankRecEmbeddedViewsData=bankRecEmbeddedViewsData;newState.bankRecNotebookPage=null;}else{newState.bankRecNotebookPage=null;newState.bankRecRecordData=null;}
await this.updateJournalState(newState,data);if(stLineId&&this.viewRef.el){const selectedKanbanCardEl=this.viewRef.el.querySelector(`[st-line-id="${stLineId}"]`);if(selectedKanbanCardEl){scrollTo(selectedKanbanCardEl,{});}}}
async mountStLineInEdit(stLineId,initialData=null){await this.withNewState(async(newState)=>{await this._mountStLineInEdit(newState,stLineId,initialData);});}
async initBankRecModel(){const initialData=await this.orm.call("bank.rec.widget","fetch_initial_data",);function makeActiveFields(fields){const activeFields={};for(const fieldName in fields){const field=fields[fieldName];activeFields[fieldName]=makeActiveField({onChange:field.onChange});if(field.relatedFields){activeFields[fieldName].related={fields:field.relatedFields,activeFields:makeActiveFields(field.relatedFields),}}}
return activeFields;}
const activeFields=makeActiveFields(initialData.fields);this.bankRecModel=new BankRecRelationalModel(this.env,{config:{resModel:"bank.rec.widget",fields:initialData.fields,activeFields,mode:"edit",isMonoRecord:true,}},this.relationalModelServices,);await this.bankRecModel.load({values:initialData.initial_values,});const record=this.bankRecModel.root;record.bindActionOnLineChanged(async(changedField)=>{await this.actionLineChanged(changedField);});}
getBankRecRecordLineInEdit(){const data=this.state.bankRecRecordData;const lineIndex=data.form_index;return data.line_ids.records.find((x)=>x.data.index===lineIndex);}
async updateJournalState(newState,data={}){let journalId=null;const stLineJournalId=data.st_line_journal_id;if(stLineJournalId){journalId=stLineJournalId[0];}else if(this.model.root.records.length){journalId=this.model.root.records[0].data.journal_id[0];}else{journalId=this.props.context.default_journal_id;}
newState.journalId=journalId;const values=await this.orm.call("bank.rec.widget","collect_global_info_data",[journalId],);newState.journalBalanceAmount=values.balance_amount;}
initReconCounter(){this.counter.startTime=luxon.DateTime.now();this.counter.timeDiff=null;this.counter.count=0;}
incrementReconCounter(){const start=this.counter.startTime.set({millisecond:0});const end=luxon.DateTime.now().set({millisecond:0});this.counter.timeDiff=end.diff(start,"seconds");this.counter.count+=1;}
showRainbowMan(){return this.counter.count>0;}
getCounterSummary(){const diff=this.counter.timeDiff;const total=this.counter.count;const diffInSeconds=diff.seconds;let units=["seconds"];if(diffInSeconds>60){units.unshift("minutes");}
if(diffInSeconds>3600){units.unshift("hours");}
return{counter:total,secondsPerTransaction:Math.round(diffInSeconds/total),formattedDuration:diff.toFormat(localization.timeFormat.replace(/HH/,"hh")),humanDuration:diff.shiftTo(...units).toHuman(),}}
getRainbowManContentProps(){return{fadeout:"no",message:"",imgUrl:"/web/static/img/smile.svg",Component:BankRecRainbowContent,close:()=>{},}}
async moveToNextLine(newState){const records=this.model.root.records;const counter=newState.counter;await this.model.root.load();const nextStLineId=this.getNextAvailableStLineId(newState.bankRecStLineId,records);if(nextStLineId!=newState.bankRecStLineId){await this._mountStLineInEdit(newState,nextStLineId);}
newState.counter=counter;newState.__kanbanNotify=true;}
formatMonetaryField(amount,currencyId){const currencyDigits=getCurrency(currencyId)?.digits;return formatMonetary(amount,{digits:currencyDigits,currencyId:currencyId,});}
isMonetaryZero(amount,currencyId){const currencyDigits=getCurrency(currencyId)?.digits;return Number(amount.toFixed(currencyDigits?currencyDigits[1]:2))===0;}
formatDateField(date){return formatDate(date);}
async onchange(newState,methodName,args,kwargs){const record=this.bankRecModel.root;const{data,applyChanges}=await record.updateToDoCommand(methodName,args,kwargs);newState.__commitChanges=()=>{applyChanges();newState.bankRecRecordData=record.data;newState.__bankRecRecordNotify=true;};return data;}
getOne2ManyColumns(){const data=this.state.bankRecRecordData;let lineIdsRecords=data.line_ids.records;let columns=[["date",_t("Date")],["partner",_t("Partner")],];if(lineIdsRecords.some((x)=>Boolean(Object.keys(x.data.analytic_distribution).length))){columns.push(["analytic_distribution",_t("Analytic")]);}
if(lineIdsRecords.some((x)=>x.data.tax_ids.records.length)){columns.push(["taxes",_t("Taxes")]);}
if(lineIdsRecords.some((x)=>x.data.currency_id[0]!==data.company_currency_id[0])){columns.push(["amount_currency",_t("Amount in Currency")],["currency",_t("Currency")]);}
if(this.hasGroupReadOnly){columns.unshift(["account",_t("Account")]);columns.push(["debit",_t("Debit")],["credit",_t("Credit")],["__trash",""],);}else{columns.push(["balance",_t("Amount")],["__trash",""],);}
return columns;}
getKey(lineData){return`${lineData.index} ${JSON.stringify(lineData.analytic_distribution)}`;}
checkBankRecLineRequiredField(line,invalidFields,fieldName,condition){if(!line.data[fieldName]&&(!condition||condition())){invalidFields.push(fieldName);}}
getBankRecLineInvalidFields(line){const invalidFields=[];this.checkBankRecLineRequiredField(line,invalidFields,"account_id");this.checkBankRecLineRequiredField(line,invalidFields,"date",()=>line.data.flag==="liquidity");return invalidFields;}
checkBankRecLinesInvalidFields(data){return data.line_ids.records.filter((l)=>this.getBankRecLineInvalidFields(l).length>0).length===0;}
notebookAmlsListViewProps(){const initParams=this.state.bankRecEmbeddedViewsData.amls;const ctx=initParams.context;const suspenseLine=this.state.bankRecRecordData.line_ids.records.filter((l)=>l.data.flag=="auto_balance");if(suspenseLine.length){ctx['preferred_aml_value']=suspenseLine[0].data.amount_currency*-1;ctx['preferred_aml_currency_id']=suspenseLine[0].data.currency_id[0];}
return{type:"list",noBreadcrumbs:true,resModel:"account.move.line",searchMenuTypes:["filter","favorite"],domain:initParams.domain,dynamicFilters:initParams.dynamic_filters,context:ctx,allowSelectors:false,searchViewId:false,globalState:initParams.exportState,loadIrFilters:true,}}
focusManualOperationField(clickedColumn){if(['debit','credit'].includes(clickedColumn)){if(this.focusElement("div[name='balance'] input")){return true;}
if(this.focusElement("div[name='amount_currency'] input")){return true;}}
if(this.focusElement(`div[name='${clickedColumn}'] input`)){return true;}
if(this.focusElement(`input[name='${clickedColumn}']`)){return true;}
return false;}
focusElement(selector){const inputEl=this.viewRef.el.querySelector(selector);if(!inputEl){return false;}
if(inputEl.tagName==="INPUT"){inputEl.focus();inputEl.select();}else{inputEl.focus();}
return true;}
async actionOpenBankGL(journalId){const actionData=await this.orm.call("account.journal","action_open_bank_balance_in_gl",[journalId],);this.action.doAction(actionData);}
async actionRemoveLine(line){await this.execProtectedBankRecAction(async()=>{await this.withNewState(async(newState)=>{await this.onchange(newState,"remove_line",[line.data.index]);if(newState.bankRecNotebookPage==="manual_operations_tab"){newState.bankRecNotebookPage="amls_tab";}});});}
async actionSelectRecoModel(recoModel){await this.execProtectedBankRecAction(async()=>{await this.withNewState(async(newState)=>{const data=newState.bankRecRecordData;if(recoModel.resId==data.selected_reco_model_id.id){return;}
const{return_todo_command:actionData}=await this.onchange(newState,"select_reconcile_model",[recoModel.resId])
if(actionData){this.action.doAction(actionData);}});});}
actionCreateRecoModel(){this.execProtectedBankRecAction(async()=>{const journalId=this.state.bankRecRecordData.st_line_journal_id[0];const lines=this.state.bankRecRecordData.line_ids.records;const defaultLineIds=[];let balance=lines.filter(line=>line.data.flag==="liquidity")[0].data.balance
if(!this.isMonetaryZero(balance,this.state.bankRecRecordData.company_currency_id[0])){for(const line of lines){const data=line.data;if(!["manual","aml"].includes(data.flag)){continue;}
defaultLineIds.push([0,0,{label:data.name,account_id:data.account_id[0],tax_ids:[[6,0,data.tax_ids.currentIds]],amount_type:"percentage",amount_string:((-data.balance/balance)*100).toFixed(5),}]);balance+=data.balance;}}
this.action.doAction({type:"ir.actions.act_window",res_model:"account.reconcile.model",views:[[false,"form"]],target:"current",context:{default_match_journal_ids:[journalId],default_line_ids:defaultLineIds,default_to_check:!this.state.bankRecRecordData.checked,},});});}
actionViewRecoModels(){this.execProtectedBankRecAction(async()=>{this.action.doAction("account.action_account_reconcile_model");});}
async _actionValidate(newState){const{return_todo_command:result}=await this.onchange(newState,"validate");if(result.done){this.incrementReconCounter();await this.moveToNextLine(newState);}
return result;}
async actionValidate(){await this.execProtectedBankRecAction(async()=>{await this.withNewState(async(newState)=>{await this._actionValidate(newState);});});}
async actionReset(){await this.execProtectedBankRecAction(async()=>{await this.withNewState(async(newState)=>{const{return_todo_command:result}=await this.onchange(newState,"reset");if(result.done){await this.model.root.load();const stLineId=newState.bankRecStLineId;if(!stLineId){return;}
const records=this.model.root.records;if(!records.length){newState.bankRecStLineId=null;newState.bankRecNotebookPage=null;newState.bankRecRecordData=null;}else if(!records.find((x)=>x.resId===stLineId)){const nextStLineId=this.getNextAvailableStLineId(stLineId);await this._mountStLineInEdit(newState,nextStLineId);}
if(newState.bankRecNotebookPage!="amls_tab"){newState.bankRecNotebookPage="amls_tab";}
newState.__kanbanNotify=true;}});});}
async actionToCheck(){await this.execProtectedBankRecAction(async()=>{await this.withNewState(async(newState)=>{const{return_todo_command:result}=await this.onchange(newState,"to_check");if(result.done){await this.moveToNextLine(newState);}});});}
async actionSetAsChecked(){await this.execProtectedBankRecAction(async()=>{await this.withNewState(async(newState)=>{const data=await this.onchange(newState,"set_as_checked");const result=data.return_todo_command;if(result.done&&data.state==="reconciled"){await this.moveToNextLine(newState);}else{await this.model.root.load();newState.__kanbanNotify=true;}});});}
async actionAddNewAml(amlId){await this.execProtectedBankRecAction(async()=>{await this.withNewState(async(newState)=>{await this.onchange(newState,"add_new_aml",[amlId]);});});}
async actionRemoveNewAml(amlId){await this.execProtectedBankRecAction(async()=>{await this.withNewState(async(newState)=>{await this.onchange(newState,"remove_new_aml",[amlId]);});});}
async _actionMountLineInEdit(newState,line){const data=newState.bankRecRecordData;const currentLineIndex=data.form_index;if(line.data.index!=currentLineIndex){await this.onchange(newState,"mount_line_in_edit",[line.data.index]);}
if(newState.bankRecNotebookPage!=="manual_operations_tab"){newState.bankRecNotebookPage="manual_operations_tab";}}
async actionMountLineInEdit(line){await this.execProtectedBankRecAction(async()=>{await this.withNewState(async(newState)=>{await this._actionMountLineInEdit(newState,line);});});}
async actionMountLastLineInEdit(){await this.execProtectedBankRecAction(async()=>{await this.withNewState(async(newState)=>{const data=newState.bankRecRecordData;const line=data.line_ids.records.at(-1);await this._actionMountLineInEdit(newState,line);});});}
async postprocessLineChangedReturnTodoCommand(newState,data){const todo=data.return_todo_command;if(!todo){return;}
if(todo.reset_record){await this.model.root.load();newState.__kanbanNotify=true;}
if(todo.reset_global_info){await this.updateJournalState(newState,data);}}
async actionLineChanged(fieldName){await this.execProtectedBankRecAction(async()=>{const line=this.getBankRecRecordLineInEdit();await this.withNewState(async(newState)=>{if(line){const data=await this.onchange(newState,"line_changed",[line.data.index,fieldName]);await this.postprocessLineChangedReturnTodoCommand(newState,data);}});});}
async actionSetPartnerReceivableAccount(){await this.execProtectedBankRecAction(async()=>{const line=this.getBankRecRecordLineInEdit();await this.withNewState(async(newState)=>{if(line){const data=await this.onchange(newState,"line_set_partner_receivable_account",[line.data.index])
await this.postprocessLineChangedReturnTodoCommand(newState,data);}});});}
async actionSetPartnerPayableAccount(){await this.execProtectedBankRecAction(async()=>{const line=this.getBankRecRecordLineInEdit();await this.withNewState(async(newState)=>{if(line){const data=await this.onchange(newState,"line_set_partner_payable_account",[line.data.index])
await this.postprocessLineChangedReturnTodoCommand(newState,data);}});});}
async actionRedirectToSourceMove(line){await this.execProtectedBankRecAction(async()=>{await this.withNewState(async(newState)=>{const{return_todo_command:actionData}=await this.onchange(newState,"redirect_to_move",[line.data.index])
if(actionData){this.action.doAction(actionData);}});});}
async actionApplyLineSuggestion(){await this.execProtectedBankRecAction(async()=>{const line=this.getBankRecRecordLineInEdit();await this.withNewState(async(newState)=>{if(line){await this.onchange(newState,"apply_line_suggestion",[line.data.index])}});});}
async handleLineClicked(ev,line){const lineIndexBeforeClick=this.state.bankRecRecordData.form_index;await this.actionMountLineInEdit(line);let clickedColumn=null;const target=ev.target.tagName==="TD"?ev.target:ev.target.closest("td");if(target?.attributes&&target.attributes.field){clickedColumn=target.attributes.field.value;}
if(clickedColumn){if(lineIndexBeforeClick===line.data.index){this.focusManualOperationField(clickedColumn);this.state.bankRecClickedColumn=null;}else{this.state.bankRecClickedColumn=clickedColumn;}}}
async handleSuggestionHtmlClicked(ev){if(ev.target.tagName==="BUTTON"){const buttonName=ev.target.attributes&&ev.target.attributes.name?ev.target.attributes.name.value:null;if(!buttonName){return;}
if(buttonName==="action_redirect_to_move"){const line=this.getBankRecRecordLineInEdit();await this.actionRedirectToSourceMove(line);}else if(buttonName==="action_apply_line_suggestion"){await this.actionApplyLineSuggestion();}}}}
const BankRecKanbanRenderer=__exports.BankRecKanbanRenderer=class BankRecKanbanRenderer extends KanbanRenderer{static template="account.BankRecKanbanRenderer";static components={...KanbanRenderer.components,KanbanRecord:BankRecKanbanRecord,RainbowMan,BankRecFinishButtons,BankRecGlobalInfo,BankRecQuickCreate,};setup(){super.setup();this.globalState=useState(this.env.methods.getState());this.action=useService("action");}
groups(){const{list}=this.props;let statementGroups=[];for(const record of list.records){let lastItem=statementGroups.slice(-1);let statementId=record.data.statement_id&&record.data.statement_id[0];if(statementId&&(!lastItem.length||lastItem[0].id!=statementId)){statementGroups.push({id:statementId,name:record.data.statement_name,balance:formatMonetary(record.data.statement_balance_end_real,{currencyId:record.data.currency_id[0]}),});}}
return statementGroups;}
openStatementDialog(statementId){const action={type:"ir.actions.act_window",res_model:"account.bank.statement",res_id:statementId,views:[[false,"form"]],target:"current",context:{form_view_ref:"account_accountant.view_bank_statement_form_bank_rec_widget",},};this.action.doAction(action);}
cancelQuickCreate(){this.globalState.quickCreateState.isVisible=false;}
validateQuickCreate(_recordId,mode){this.globalState.quickCreateState.model.load()
if(mode==="add_close"){this.globalState.quickCreateState.isVisible=false;}}}
const BankRecKanbanView=__exports.BankRecKanbanView={...kanbanView,Controller:BankRecKanbanController,Renderer:BankRecKanbanRenderer,searchMenuTypes:["filter","favorite"],};registry.category("views").add('bank_rec_widget_kanban',BankRecKanbanView);return __exports;});;

/* /account_accountant/static/src/components/bank_reconciliation/list.js */
odoo.define('@account_accountant/components/bank_reconciliation/list',['@web/core/registry','@web/views/list/list_view','@web/views/list/list_controller','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{ListController}=require("@web/views/list/list_controller");const{useChildSubEnv}=require("@odoo/owl");const BankRecListController=__exports.BankRecListController=class BankRecListController extends ListController{setup(){super.setup(...arguments);this.skipKanbanRestore={};useChildSubEnv({skipKanbanRestoreNeeded:(stLineId)=>this.skipKanbanRestore[stLineId],});}
async onRecordSaved(record){this.skipKanbanRestore[record.resId]=true;return super.onRecordSaved(...arguments);}}
const bankRecListView=__exports.bankRecListView={...listView,Controller:BankRecListController,}
registry.category("views").add("bank_rec_list",bankRecListView);return __exports;});;

/* /account_accountant/static/src/components/bank_reconciliation/list_view_switcher.js */
odoo.define('@account_accountant/components/bank_reconciliation/list_view_switcher',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const ListViewSwitcher=__exports.ListViewSwitcher=class ListViewSwitcher extends Component{static template="account_accountant.ListViewSwitcher";static props=standardFieldProps;setup(){this.action=useService("action");}
switchView(){const searchItem=Object.values(this.env.searchModel.searchItems).find((i)=>i.fieldName==="statement_line_id");const stLineId=this.props.record.resId;const autocompleteValue={label:this.props.record.data.move_id[1],operator:"=",value:stLineId,}
this.env.searchModel.addAutoCompletionValues(searchItem.id,autocompleteValue);this.action.switchView("kanban",{skipRestore:this.env.skipKanbanRestoreNeeded(stLineId)});}
get buttonLabel(){return this.props.record.data.is_reconciled?_t("View"):_t("Match");}}
registry.category("fields").add('bank_rec_list_view_switcher',{component:ListViewSwitcher});return __exports;});;

/* /account_accountant/static/src/components/bank_reconciliation/many2one_field_multi_edit.js */
odoo.define('@account_accountant/components/bank_reconciliation/many2one_field_multi_edit',['@web/core/registry','@web/views/fields/many2one/many2one_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Many2OneField,many2OneField}=require("@web/views/fields/many2one/many2one_field");const BankRecMany2OneMultiID=__exports.BankRecMany2OneMultiID=class BankRecMany2OneMultiID extends Many2OneField{get Many2XAutocompleteProps(){const props=super.Many2XAutocompleteProps;if(this.props.record.selected&&this.props.record.model.multiEdit){props.context.active_ids=this.env.model.root.selection.map((r)=>r.resId);}
return props;}}
const bankRecMany2OneMultiID=__exports.bankRecMany2OneMultiID={...many2OneField,component:BankRecMany2OneMultiID,};registry.category("fields").add("bank_rec_list_many2one_multi_id",bankRecMany2OneMultiID);return __exports;});;

/* /account_accountant/static/src/components/bank_reconciliation/monetary_field_auto_signed_amount.js */
odoo.define('@account_accountant/components/bank_reconciliation/monetary_field_auto_signed_amount',['@web/views/fields/monetary/monetary_field'],function(require){'use strict';let __exports={};const{MonetaryField,monetaryField}=require("@web/views/fields/monetary/monetary_field");const BankRecMonetaryField=__exports.BankRecMonetaryField=class BankRecMonetaryField extends MonetaryField{static template="account_accountant.BankRecMonetaryField";static props={...MonetaryField.props,hasForcedNegativeValue:{type:Boolean},};get inputOptions(){const options=super.inputOptions;const parse=options.parse;options.parse=(value)=>{let parsedValue=parse(value);if(this.props.hasForcedNegativeValue){parsedValue=-Math.abs(parsedValue);}
return parsedValue;};return options;}
get value(){let value=super.value;if(this.props.hasForcedNegativeValue){value=Math.abs(value);}
return value;}}
const bankRecMonetaryField=__exports.bankRecMonetaryField={...monetaryField,component:BankRecMonetaryField,};return __exports;});;

/* /account_accountant/static/src/components/bank_reconciliation/rainbowman_content.js */
odoo.define('@account_accountant/components/bank_reconciliation/rainbowman_content',['@account_accountant/components/bank_reconciliation/finish_buttons','@odoo/owl'],function(require){'use strict';let __exports={};const{BankRecFinishButtons}=require("@account_accountant/components/bank_reconciliation/finish_buttons");const{Component,onMounted,onWillUnmount}=require("@odoo/owl");const BankRecRainbowContent=__exports.BankRecRainbowContent=class BankRecRainbowContent extends Component{static template="account_accountant.BankRecRainbowContent";static components={BankRecFinishButtons};static props={};setup(){onWillUnmount(()=>{this.env.methods.initReconCounter();});onMounted(()=>{document.querySelector(".o_reward").style.pointerEvents="none";document.querySelector(".o_reward_msg").style.pointerEvents="auto";});}}
return __exports;});;

/* /account_accountant/static/src/components/bank_reconciliation/view_embedder.js */
odoo.define('@account_accountant/components/bank_reconciliation/view_embedder',['@web/views/view','@odoo/owl'],function(require){'use strict';let __exports={};const{View}=require("@web/views/view");const{Component,useSubEnv}=require("@odoo/owl");const BankRecViewEmbedder=__exports.BankRecViewEmbedder=class BankRecViewEmbedder extends Component{static props=["viewProps"];static template="account_accountant.BankRecViewEmbedder";static components={View};setup(){useSubEnv({config:{...this.env.methods},});}}
return __exports;});;

/* /account_accountant/static/src/components/export_data_dialog/export_data_dialog.js */
odoo.define('@account_accountant/components/export_data_dialog/export_data_dialog',['@web/core/utils/patch','@web/core/network/rpc','@web/views/view_dialogs/export_data_dialog'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{rpc}=require("@web/core/network/rpc");const{ExportDataDialog}=require("@web/views/view_dialogs/export_data_dialog");patch(ExportDataDialog.prototype,{async fetchFields(value){await super.fetchFields(value);const analyticLineIdsField=this.knownFields['analytic_line_ids'];if(analyticLineIdsField){this.state.exportList=this.state.exportList.filter((field)=>field.id!=='analytic_distribution');const analyticLineFields=await rpc("/web/export/get_fields",{model:analyticLineIdsField.params.model,prefix:analyticLineIdsField.params.prefix,parent_name:analyticLineIdsField.params.parent_field.string,import_compat:analyticLineIdsField.default_export,parent_field_type:analyticLineIdsField.params.parent_field.type,domain:[],});const filteredAnalyticLineFields=analyticLineFields.filter((field)=>field.params?.model==='account.analytic.account'&&!field.id.includes('auto_account_id')||field.id==='analytic_line_ids/amount');this.state.exportList.push(...filteredAnalyticLineFields);}},});return __exports;});;

/* /account_accountant/static/src/components/matching_link_widget/matching_link_widget.js */
odoo.define('@account_accountant/components/matching_link_widget/matching_link_widget',['@web/core/registry','@web/core/utils/hooks','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");class MatchingLink extends Component{static props={...standardFieldProps};static template="account_accountant.MatchingLink";setup(){this.orm=useService("orm");this.action=useService("action");}
async reconcile(){this.action.doAction("account_accountant.action_move_line_posted_unreconciled",{additionalContext:{search_default_partner_id:this.props.record.data.partner_id[0],search_default_account_id:this.props.record.data.account_id[0],},});}
async viewMatch(){const action=await this.orm.call("account.move.line","open_reconcile_view",[this.props.record.resId],{});this.action.doAction(action,{additionalContext:{is_matched_view:true}});}
get colorCode(){const matchValue=this.props.record.data[this.props.name];const matchColorValue=matchValue.replace('P','');if(matchColorValue==='*'){return 0;}else{return parseInt(matchColorValue)%11+1;}}}
registry.category("fields").add("matching_link_widget",{component:MatchingLink,});return __exports;});;

/* /account_accountant/static/src/components/move_line_list/attachment_view_move_line.js */
odoo.define('@account_accountant/components/move_line_list/attachment_view_move_line',['@mail/core/common/attachment_view','@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{AttachmentView}=require("@mail/core/common/attachment_view");const{onMounted}=require("@odoo/owl");const{useBus}=require("@web/core/utils/hooks");const AttachmentViewMoveLine=__exports.AttachmentViewMoveLine=class AttachmentViewMoveLine extends AttachmentView{static props=[...AttachmentView.props,"openInPopout"];static components={AttachmentView};setup(){super.setup();if(this.props.openInPopout){onMounted(this.onClickPopout);}
useBus(this.uiService.bus,"resize",()=>this.env.setPopout(false));}}
return __exports;});;

/* /account_accountant/static/src/components/move_line_list/move_line_list.js */
odoo.define('@account_accountant/components/move_line_list/move_line_list',['@account_accountant/components/move_line_list/attachment_view_move_line','@web/core/registry','@web/core/utils/hooks','@web/views/list/list_view','@web/views/list/list_renderer','@web/views/list/list_controller','@web/core/ui/ui_service','@odoo/owl','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{AttachmentViewMoveLine}=require("@account_accountant/components/move_line_list/attachment_view_move_line");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{listView}=require("@web/views/list/list_view");const{ListRenderer}=require("@web/views/list/list_renderer");const{ListController}=require("@web/views/list/list_controller");const{SIZES}=require("@web/core/ui/ui_service");const{useChildSubEnv,useState}=require("@odoo/owl");const{makeActiveField}=require("@web/model/relational_model/utils");const AccountMoveLineListController=__exports.AccountMoveLineListController=class AccountMoveLineListController extends ListController{static template="account_accountant.MoveLineListView";static components={...ListController.components,AttachmentViewMoveLine,};setup(){super.setup();this.store=useState(useService("mail.store"));this.ui=useState(useService("ui"));this.mailPopoutService=useState(useService("mail.popout"));this.attachmentPreviewState=useState({displayAttachment:localStorage.getItem("account.move_line_pdf_previewer_hidden")!=="false",selectedRecord:false,thread:null,});this.popout=useState({active:false});useChildSubEnv({setPopout:this.setPopout.bind(this),});this.openRecord=()=>{}}
get previewEnabled(){return(!this.env.searchModel.context.disable_preview&&(this.ui.size>=SIZES.XXL||this.mailPopoutService.externalWindow));}
get modelParams(){const params=super.modelParams;params.config.activeFields.move_attachment_ids=makeActiveField();params.config.activeFields.move_attachment_ids.related={fields:{mimetype:{name:"mimetype",type:"char"},},activeFields:{mimetype:makeActiveField(),},};return params;}
togglePreview(){this.attachmentPreviewState.displayAttachment=!this.attachmentPreviewState.displayAttachment;localStorage.setItem("account.move_line_pdf_previewer_hidden",this.attachmentPreviewState.displayAttachment);}
setPopout(value){if(this.attachmentPreviewState.thread?.attachmentsInWebClientView.length){this.popout.active=value;}}
setSelectedRecord(accountMoveLineData){this.attachmentPreviewState.selectedRecord=accountMoveLineData;this.setThread(this.attachmentPreviewState.selectedRecord);}
async setThread(accountMoveLineData){if(!accountMoveLineData||!accountMoveLineData.data.move_attachment_ids.records.length){this.attachmentPreviewState.thread=null;return;}
const thread=this.store.Thread.insert({attachments:accountMoveLineData.data.move_attachment_ids.records.map((attachment)=>({id:attachment.resId,mimetype:attachment.data.mimetype,})),id:accountMoveLineData.data.move_id[0],model:accountMoveLineData.fields["move_id"].relation,});if(!thread.mainAttachment&&thread.attachmentsInWebClientView.length>0){thread.update({mainAttachment:thread.attachmentsInWebClientView[0]});}
this.attachmentPreviewState.thread=thread;}}
const AccountMoveLineListRenderer=__exports.AccountMoveLineListRenderer=class AccountMoveLineListRenderer extends ListRenderer{static props=[...ListRenderer.props,"setSelectedRecord?"];onCellClicked(record,column,ev){this.props.setSelectedRecord(record);super.onCellClicked(record,column,ev);}
findFocusFutureCell(cell,cellIsInGroupRow,direction){const futureCell=super.findFocusFutureCell(cell,cellIsInGroupRow,direction);if(futureCell){const dataPointId=futureCell.closest("tr").dataset.id;const record=this.props.list.records.filter((x)=>x.id===dataPointId)[0];this.props.setSelectedRecord(record);}
return futureCell;}}
const AccountMoveLineListView=__exports.AccountMoveLineListView={...listView,Renderer:AccountMoveLineListRenderer,Controller:AccountMoveLineListController,};registry.category("views").add("account_move_line_list",AccountMoveLineListView);return __exports;});;

/* /account_accountant/static/src/components/move_line_list_reconcile/move_line_list_reconcile.js */
odoo.define('@account_accountant/components/move_line_list_reconcile/move_line_list_reconcile',['@web/core/registry','@odoo/owl','@account_accountant/components/move_line_list/move_line_list'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useSubEnv}=require("@odoo/owl");const{AccountMoveLineListController,AccountMoveLineListRenderer,AccountMoveLineListView}=require("@account_accountant/components/move_line_list/move_line_list");const AccountMoveLineReconcileListController=__exports.AccountMoveLineReconcileListController=class AccountMoveLineReconcileListController extends AccountMoveLineListController{setup(){super.setup();useSubEnv({callAutoReconcileAction:this.openAutoReconcileWizard.bind(this),});}
openAutoReconcileWizard(group=null){if(group){return this.actionService.doAction("account_accountant.action_open_auto_reconcile_wizard",{additionalContext:{domain:group.list.domain,}});}else{return this.actionService.doAction("account_accountant.action_open_auto_reconcile_wizard");}}}
const AccountMoveLineReconcileListRenderer=__exports.AccountMoveLineReconcileListRenderer=class AccountMoveLineReconcileListRenderer extends AccountMoveLineListRenderer{static groupRowTemplate="account_accountant.AccountMoveLineReconcileGroupRow";setup(){super.setup();this.props.list.groups?.map(group=>this.toggleGroup(group));}}
const AccountMoveLineReconcileLineListView=__exports.AccountMoveLineReconcileLineListView={...AccountMoveLineListView,Controller:AccountMoveLineReconcileListController,Renderer:AccountMoveLineReconcileListRenderer,buttonTemplate:"account_accountant.ListViewReconcile.Buttons",}
registry.category("views").add("account_move_line_reconcile_list",AccountMoveLineReconcileLineListView);return __exports;});;

/* /accountant/static/src/js/tours/accountant.js */
odoo.define('@accountant/js/tours/accountant',['@web/core/utils/patch','@account/js/tours/account','@web_tour/tour_service/tour_utils'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{accountTourSteps}=require("@account/js/tours/account");const{stepUtils}=require("@web_tour/tour_service/tour_utils");patch(accountTourSteps,{goToAccountMenu(description="Open Accounting Menu"){return stepUtils.goToAppSteps('accountant.menu_accounting',description);},});return __exports;});;

/* /purchase/static/src/components/monetary_field_no_zero/monetary_field_no_zero.js */
odoo.define('@purchase/components/monetary_field_no_zero/monetary_field_no_zero',['@web/views/fields/monetary/monetary_field','@web/core/registry','@web/core/utils/numbers'],function(require){'use strict';let __exports={};const{monetaryField,MonetaryField}=require("@web/views/fields/monetary/monetary_field");const{registry}=require("@web/core/registry");const{floatIsZero}=require("@web/core/utils/numbers");const MonetaryFieldNoZero=__exports.MonetaryFieldNoZero=class MonetaryFieldNoZero extends MonetaryField{static props={...MonetaryField.props,};get value(){const originalValue=super.value;const decimals=this.currencyDigits?this.currencyDigits[1]:2;return floatIsZero(originalValue,decimals)?false:originalValue;}}
const monetaryFieldNoZero=__exports.monetaryFieldNoZero={...monetaryField,component:MonetaryFieldNoZero,};registry.category("fields").add("monetary_no_zero",monetaryFieldNoZero);return __exports;});;

/* /purchase/static/src/components/open_match_line_widget/open_match_line_widget.js */
odoo.define('@purchase/components/open_match_line_widget/open_match_line_widget',['@web/core/registry','@web/core/utils/hooks','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");class OpenMatchLineWidget extends Component{static template="purchase.OpenMatchLineWidget";static props={...standardFieldProps};setup(){super.setup();this.action=useService("action");}
async openMatchLine(){this.action.doActionButton({type:"object",resId:this.props.record.resId,name:"action_open_line",resModel:"purchase.bill.line.match",});}}
registry.category("fields").add("open_match_line_widget",{component:OpenMatchLineWidget,});return __exports;});;

/* /purchase/static/src/product_catalog/kanban_record.js */
odoo.define('@purchase/product_catalog/kanban_record',['@product/product_catalog/kanban_record','@purchase/product_catalog/purchase_order_line/purchase_order_line','@web/core/network/rpc','@web/core/utils/patch','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{ProductCatalogKanbanRecord}=require("@product/product_catalog/kanban_record");const{ProductCatalogPurchaseOrderLine}=require("@purchase/product_catalog/purchase_order_line/purchase_order_line");const{rpc}=require("@web/core/network/rpc");const{patch}=require("@web/core/utils/patch");const{useService}=require("@web/core/utils/hooks");const{useSubEnv}=require("@odoo/owl");patch(ProductCatalogKanbanRecord.prototype,{setup(){super.setup();this.orm=useService("orm");useSubEnv({updatePackagingQuantity:this.updatePackagingQuantity.bind(this),});},get orderLineComponent(){if(this.env.orderResModel==="purchase.order"){return ProductCatalogPurchaseOrderLine;}
return super.orderLineComponent;},addProduct(){if(this.productCatalogData.quantity===0&&this.productCatalogData.min_qty){super.addProduct(this.productCatalogData.min_qty);}else{super.addProduct(...arguments);}},async updatePackagingQuantity(packaging){const productPackagingQty=Math.floor(this.productCatalogData.quantity/packaging.qty)+1;this.productCatalogData.quantity=productPackagingQty*packaging.qty;const price=await rpc("/product/catalog/update_order_line_info",{order_id:this.env.orderId,product_id:this.env.productId,product_packaging_id:packaging.id,product_packaging_qty:productPackagingQty,res_model:this.env.orderResModel,});this.productCatalogData.price=parseFloat(price);},});return __exports;});;

/* /purchase/static/src/product_catalog/purchase_order_line/purchase_order_line.js */
odoo.define('@purchase/product_catalog/purchase_order_line/purchase_order_line',['@product/product_catalog/order_line/order_line'],function(require){'use strict';let __exports={};const{ProductCatalogOrderLine}=require("@product/product_catalog/order_line/order_line");const ProductCatalogPurchaseOrderLine=__exports.ProductCatalogPurchaseOrderLine=class ProductCatalogPurchaseOrderLine extends ProductCatalogOrderLine{static template="ProductCatalogPurchaseOrderLine";static props={...ProductCatalogPurchaseOrderLine.props,min_qty:{type:Number,optional:true},packaging:{type:Object,optional:true},purchase_uom:{type:Object,optional:true},uom:Object,};get highlightUoM(){return true;}
addPackagingQty(){this.env.updatePackagingQuantity(this.props.packaging);}}
return __exports;});;

/* /purchase/static/src/toaster_button/toaster_button_widget.js */
odoo.define('@purchase/toaster_button/toaster_button_widget',['@web/core/registry','@web/core/utils/hooks','@odoo/owl','@web/views/widgets/standard_widget_props'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");class ButtonWithNotification extends Component{static template="purchase.ButtonWithNotification";static props={...standardWidgetProps,method:String,title:String,};setup(){this.orm=useService("orm");this.notification=useService("notification");}
async onClick(){const result=await this.orm.call(this.props.record.resModel,this.props.method,[this.props.record.resId,]);const message=result.toast_message;this.notification.add(message,{type:"success"});}}
const buttonWithNotification=__exports.buttonWithNotification={component:ButtonWithNotification,extractProps:({attrs})=>{return{method:attrs.button_name,title:attrs.title,};},};registry.category("view_widgets").add("toaster_button",buttonWithNotification);return __exports;});;

/* /purchase/static/src/views/purchase_dashboard.js */
odoo.define('@purchase/views/purchase_dashboard',['@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{Component,onWillStart}=require("@odoo/owl");const PurchaseDashBoard=__exports.PurchaseDashBoard=class PurchaseDashBoard extends Component{static template="purchase.PurchaseDashboard";static props={};setup(){this.orm=useService("orm");this.action=useService("action");onWillStart(async()=>{this.purchaseData=await this.orm.call("purchase.order","retrieve_dashboard");});}
setSearchContext(ev){const filter_name=ev.currentTarget.getAttribute("filter_name");const filters=filter_name.split(",");const searchItems=this.env.searchModel.getSearchItems((item)=>filters.includes(item.name));this.env.searchModel.query=[];for(const item of searchItems){this.env.searchModel.toggleSearchItem(item.id);}}}
return __exports;});;

/* /purchase/static/src/views/purchase_kanbanview.js */
odoo.define('@purchase/views/purchase_kanbanview',['@web/core/registry','@web/views/kanban/kanban_view','@web/views/kanban/kanban_renderer','@purchase/views/purchase_dashboard'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{PurchaseDashBoard}=require("@purchase/views/purchase_dashboard");const PurchaseDashBoardKanbanRenderer=__exports.PurchaseDashBoardKanbanRenderer=class PurchaseDashBoardKanbanRenderer extends KanbanRenderer{static template="purchase.PurchaseKanbanView";static components=Object.assign({},KanbanRenderer.components,{PurchaseDashBoard});}
const PurchaseDashBoardKanbanView=__exports.PurchaseDashBoardKanbanView={...kanbanView,Renderer:PurchaseDashBoardKanbanRenderer,};registry.category("views").add("purchase_dashboard_kanban",PurchaseDashBoardKanbanView);return __exports;});;

/* /purchase/static/src/views/purchase_listview.js */
odoo.define('@purchase/views/purchase_listview',['@web/core/registry','@web/views/list/list_view','@web/views/list/list_renderer','@purchase/views/purchase_dashboard'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{ListRenderer}=require("@web/views/list/list_renderer");const{PurchaseDashBoard}=require("@purchase/views/purchase_dashboard");const PurchaseDashBoardRenderer=__exports.PurchaseDashBoardRenderer=class PurchaseDashBoardRenderer extends ListRenderer{static template="purchase.PurchaseListView";static components=Object.assign({},ListRenderer.components,{PurchaseDashBoard});}
const PurchaseDashBoardListView=__exports.PurchaseDashBoardListView={...listView,Renderer:PurchaseDashBoardRenderer,};registry.category("views").add("purchase_dashboard_list",PurchaseDashBoardListView);return __exports;});;

/* /purchase/static/src/js/tours/purchase.js */
odoo.define('@purchase/js/tours/purchase',['@web/core/l10n/translation','@web/core/registry','@web_tour/tour_service/tour_utils','@purchase/js/tours/purchase_steps'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{stepUtils}=require("@web_tour/tour_service/tour_utils");const PurchaseAdditionalTourSteps=require("@purchase/js/tours/purchase_steps")[Symbol.for("default")];registry.category("web_tour.tours").add("purchase_tour",{url:"/odoo",steps:()=>[stepUtils.showAppsMenuItem(),{isActive:["community"],trigger:'.o_app[data-menu-xmlid="purchase.menu_purchase_root"]',content:_t("Let's try the Purchase app to manage the flow from purchase to reception and invoice control."),tooltipPosition:"right",run:"click",},{isActive:["enterprise"],trigger:'.o_app[data-menu-xmlid="purchase.menu_purchase_root"]',content:_t("Let's try the Purchase app to manage the flow from purchase to reception and invoice control."),tooltipPosition:"bottom",run:"click",},{trigger:".o_purchase_order",},{trigger:".o_list_button_add",content:_t("Let's create your first request for quotation."),tooltipPosition:"bottom",run:"click",},{trigger:".o_purchase_order",},{trigger:".o_field_res_partner_many2one[name='partner_id'] input",content:_t("Search a vendor name, or create one on the fly."),tooltipPosition:"bottom",async run(actions){const input=this.anchor.querySelector("input");await actions.edit("Azure Interior",input||this.anchor);},},{isActive:["auto"],trigger:".ui-menu-item > a:contains('Azure Interior')",run:"click",},{trigger:".o_field_res_partner_many2one[name='partner_id'] .o_external_button",},{trigger:".o_field_x2many_list_row_add > a",content:_t("Add some products or services to your quotation."),tooltipPosition:"bottom",run:"click",},{trigger:".o_purchase_order",},{trigger:".o_field_widget[name=product_id], .o_field_widget[name=product_template_id]",content:_t("Select a product, or create a new one on the fly."),tooltipPosition:"right",async run(actions){const input=this.anchor.querySelector("input");await actions.edit("DESK0001",input||this.anchor);},},{isActive:["auto"],trigger:"a:contains('DESK0001')",run:"click",},{trigger:".o_field_text[name='name'] textarea:value(DESK0001)",},{trigger:".o_purchase_order",},{trigger:"div.o_field_widget[name='product_qty'] input ",content:_t("Indicate the product quantity you want to order."),tooltipPosition:"right",run:"edit 12.0",},{isActive:["auto","mobile"],trigger:".o_statusbar_buttons .o_arrow_button_current[name='action_rfq_send']",},...stepUtils.statusbarButtonsSteps("Send by Email",_t("Send the request for quotation to your vendor.")),{trigger:".modal-footer button[name='action_send_mail']",},{trigger:".modal-footer button[name='action_send_mail']",content:_t("Send the request for quotation to your vendor."),tooltipPosition:"left",run:"click",},{trigger:".o_purchase_order",},{content:"Select price",trigger:'tbody tr.o_data_row .o_list_number[name="price_unit"]',},{trigger:"tbody tr.o_data_row .o_list_number[name='price_unit']",content:_t("Once you get the price from the vendor, you can complete the purchase order with the right price."),tooltipPosition:"right",run:"edit 200.00",},{isActive:["auto"],trigger:".o_purchase_order",run:"click",},...stepUtils.statusbarButtonsSteps("Confirm Order",_t("Confirm your purchase.")),...new PurchaseAdditionalTourSteps()._get_purchase_stock_steps(),],});return __exports;});;

/* /purchase/static/src/js/tours/purchase_steps.js */
odoo.define('@purchase/js/tours/purchase_steps',[],function(require){'use strict';let __exports={};class PurchaseAdditionalTourSteps{_get_purchase_stock_steps(){return[{isActive:["auto"],trigger:".o_purchase_order",run:"click",},];}}
__exports[Symbol.for("default")]=PurchaseAdditionalTourSteps;return __exports;});;

/* /rating/static/src/core/common/message_model_patch.js */
odoo.define('@rating/core/common/message_model_patch',['@mail/core/common/message_model','@mail/core/common/record','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message_model");const{Record}=require("@mail/core/common/record");const{patch}=require("@web/core/utils/patch");patch(Message.prototype,{setup(){super.setup(...arguments);this.rating_id=Record.one("rating.rating");},});return __exports;});;

/* /rating/static/src/core/common/rating_model.js */
odoo.define('@rating/core/common/rating_model',['@mail/core/common/record'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const Rating=__exports.Rating=class Rating extends Record{static _name="rating.rating";static id="id";id;rating;rating_image_url;rating_text;}
Rating.register();return __exports;});;

/* /rating/static/src/core/web/notification_item_patch.js */
odoo.define('@rating/core/web/notification_item_patch',['@mail/core/public_web/notification_item'],function(require){'use strict';let __exports={};const{NotificationItem}=require("@mail/core/public_web/notification_item");NotificationItem.props=[...NotificationItem.props,"rating?"];return __exports;});;

/* /project/static/src/core/web/follower_list_patch.js */
odoo.define('@project/core/web/follower_list_patch',['@mail/core/web/follower_list','@web/core/confirmation_dialog/confirmation_dialog','@web/core/l10n/translation','@web/core/utils/hooks','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{FollowerList}=require("@mail/core/web/follower_list");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");const followerListPatch={setup(){super.setup();this.dialogService=useService("dialog");},async onClickRemove(ev,follower){if(follower.partner.in(follower.thread.collaborator_ids)){this.dialogService.add(ConfirmationDialog,{title:_t("Remove Collaborator"),body:_t("This follower is currently a project collaborator. Removing them will revoke their portal access to the project. Are you sure you want to proceed?"),confirmLabel:_t("Remove Collaborator"),cancelLabel:_t("Discard"),confirm:()=>super.onClickRemove(ev,follower),cancel:()=>{},});}else{super.onClickRemove(ev,follower);}},};patch(FollowerList.prototype,followerListPatch);return __exports;});;

/* /project/static/src/core/web/thread_model_patch.js */
odoo.define('@project/core/web/thread_model_patch',['@mail/core/common/record','@mail/core/common/thread_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{Thread}=require("@mail/core/common/thread_model");const{patch}=require("@web/core/utils/patch");const threadPatch={setup(){super.setup();this.collaborator_ids=Record.many("Persona");},};patch(Thread.prototype,threadPatch);return __exports;});;

/* /project/static/src/utils/project_utils.js */
odoo.define('@project/utils/project_utils',[],function(require){'use strict';let __exports={};const STATUS_COLORS=__exports.STATUS_COLORS={'on_track':20,'at_risk':22,'off_track':23,'on_hold':21,'done':24,};const STATUS_COLOR_PREFIX=__exports.STATUS_COLOR_PREFIX='o_status_bubble mx-0 o_color_bubble_';return __exports;});;

/* /project/static/src/components/notebook_task_one2many_field/notebook_task_list_renderer.js */
odoo.define('@project/components/notebook_task_one2many_field/notebook_task_list_renderer',['@odoo/owl','@web/core/l10n/translation','@project/components/task_list_renderer'],function(require){'use strict';let __exports={};const{useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{TaskListRenderer}=require("@project/components/task_list_renderer");const NotebookTaskListRenderer=__exports.NotebookTaskListRenderer=class NotebookTaskListRenderer extends TaskListRenderer{static rowsTemplate="project.NotebookTaskListRenderer.Rows";setup(){super.setup();this.hideState=useState({hide:localStorage.getItem(this._getStorageKey)==='true',});}
get _getStorageKey(){return`hide_closed_${this.constructor.name}`;}
get hideClosed(){return this.hideState.hide;}
get closedX2MCount(){return this.props.list.context.closed_X2M_count;}
get openLabel(){return typeof this.closedX2MCount==="undefined"?_t("Show closed tasks"):_t("%s closed tasks",this.closedX2MCount);}
get closeLabel(){return _t("Hide closed tasks");}
get toggleListHideLabel(){return this.hideClosed?this.openLabel:this.closeLabel;}
get ShowX2MRecords(){return this.closedX2MCount>0||typeof this.closedX2MCount==="undefined";}
toggleHideClosed(){this.hideState.hide=!this.hideState.hide;localStorage.setItem(this._getStorageKey,this.hideState.hide);document.activeElement.blur();}}
return __exports;});;

/* /project/static/src/components/notebook_task_one2many_field/notebook_task_one2many_field.js */
odoo.define('@project/components/notebook_task_one2many_field/notebook_task_one2many_field',['@web/core/registry','@web/views/fields/x2many/x2many_field','@project/components/notebook_task_one2many_field/notebook_task_list_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{X2ManyField,x2ManyField}=require('@web/views/fields/x2many/x2many_field');const{NotebookTaskListRenderer}=require("@project/components/notebook_task_one2many_field/notebook_task_list_renderer");const NotebookTaskOne2ManyField=__exports.NotebookTaskOne2ManyField=class NotebookTaskOne2ManyField extends X2ManyField{static components={...X2ManyField.components,ListRenderer:NotebookTaskListRenderer,};}
const notebookTaskOne2ManyField=__exports.notebookTaskOne2ManyField={...x2ManyField,component:NotebookTaskOne2ManyField,}
registry.category("fields").add("notebook_task_one2many",notebookTaskOne2ManyField);return __exports;});;

/* /project/static/src/components/project_is_favorite/project_is_favorite_field.js */
odoo.define('@project/components/project_is_favorite/project_is_favorite_field',['@web/core/registry','@web/views/fields/boolean_favorite/boolean_favorite_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{booleanFavoriteField}=require("@web/views/fields/boolean_favorite/boolean_favorite_field");const projectIsFavoriteField=__exports.projectIsFavoriteField={...booleanFavoriteField,extractProps:(fieldsInfo,dynamicInfo)=>{return{...booleanFavoriteField.extractProps(fieldsInfo,dynamicInfo),readonly:Boolean(fieldsInfo.attrs.readonly),};},};registry.category("fields").add("project_is_favorite",projectIsFavoriteField);return __exports;});;

/* /project/static/src/components/project_many2one_field/project_many2one_field.js */
odoo.define('@project/components/project_many2one_field/project_many2one_field',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/many2one/many2one_field'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require('@web/core/registry');const{Many2OneField,many2OneField}=require('@web/views/fields/many2one/many2one_field');const ProjectMany2OneField=__exports.ProjectMany2OneField=class ProjectMany2OneField extends Many2OneField{static template="project.ProjectMany2OneField";get Many2XAutocompleteProps(){const props=super.Many2XAutocompleteProps;const{record}=this.props;if(!record.data.project_id&&!record._isRequired("project_id")){props.placeholder=_t("Private");}
return props;}}
const projectMany2OneField=__exports.projectMany2OneField={...many2OneField,component:ProjectMany2OneField,fieldDependencies:[...(many2OneField.fieldDependencies||[]),],};registry.category("fields").add("project",projectMany2OneField);return __exports;});;

/* /project/static/src/components/project_right_side_panel/components/project_milestone.js */
odoo.define('@project/components/project_right_side_panel/components/project_milestone',['@web/core/l10n/dates','@web/core/utils/hooks','@web/core/confirmation_dialog/confirmation_dialog','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{formatDate}=require("@web/core/l10n/dates");const{useService}=require('@web/core/utils/hooks');const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{_t}=require("@web/core/l10n/translation");const{Component,useState,onWillUpdateProps,status}=require("@odoo/owl");const{DateTime}=luxon;const ProjectMilestone=__exports.ProjectMilestone=class ProjectMilestone extends Component{static props={context:Object,milestone:Object,open:Function,load:Function,};static template="project.ProjectMilestone";setup(){this.orm=useService('orm');this.dialog=useService("dialog");this.milestone=useState(this.props.milestone);this.state=useState({colorClass:this._getColorClass(),checkboxIcon:this._getCheckBoxIcon(),});onWillUpdateProps(this.onWillUpdateProps);}
get resModel(){return'project.milestone';}
get deadline(){if(!this.milestone.deadline)return;return formatDate(DateTime.fromISO(this.milestone.deadline));}
_getColorClass(){return this.milestone.is_deadline_exceeded&&!this.milestone.can_be_marked_as_done?"text-danger":this.milestone.can_be_marked_as_done?"text-success":"";}
_getCheckBoxIcon(){return this.milestone.is_reached?"fa-check-square-o":"fa-square-o";}
onWillUpdateProps(nextProps){if(nextProps.milestone){this.milestone=nextProps.milestone;this.state.colorClass=this._getColorClass();this.state.checkboxIcon=this._getCheckBoxIcon();}
if(nextProps.context){this.contextValue=nextProps.context;}}
async onDeleteMilestone(){this.dialog.add(ConfirmationDialog,{body:_t("Are you sure you want to delete this record?"),confirm:async()=>{await this.orm.call('project.milestone','unlink',[this.milestone.id]);await this.props.load();},cancel:()=>{},});}
async onOpenMilestone(){if(!this.write_mutex){this.write_mutex=true;this.props.open({resModel:this.resModel,resId:this.milestone.id,title:_t("Milestone"),},{onClose:async()=>{if(status(this)==="mounted"){await this.props.load();this.write_mutex=false;}},});}}
async toggleIsReached(){if(!this.write_mutex){this.write_mutex=true;this.milestone=await this.orm.call(this.resModel,'toggle_is_reached',[[this.milestone.id],!this.milestone.is_reached],);this.state.colorClass=this._getColorClass();this.state.checkboxIcon=this._getCheckBoxIcon();this.write_mutex=false;}}}
return __exports;});;

/* /project/static/src/components/project_right_side_panel/components/project_profitability.js */
odoo.define('@project/components/project_right_side_panel/components/project_profitability',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const ProjectProfitability=__exports.ProjectProfitability=class ProjectProfitability extends Component{static props={data:Object,labels:Object,formatMonetary:Function,onProjectActionClick:Function,onClick:Function,};static template="project.ProjectProfitability";get revenues(){return this.props.data.revenues;}
get costs(){return this.props.data.costs;}
get margin(){const invoiced_billed=this.revenues.total.invoiced+this.costs.total.billed;const to_invoice_to_bill=this.revenues.total.to_invoice+this.costs.total.to_bill;return{invoiced_billed,to_invoice_to_bill,total:invoiced_billed+to_invoice_to_bill,};}}
return __exports;});;

/* /project/static/src/components/project_right_side_panel/components/project_right_side_panel_section.js */
odoo.define('@project/components/project_right_side_panel/components/project_right_side_panel_section',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const ProjectRightSidePanelSection=__exports.ProjectRightSidePanelSection=class ProjectRightSidePanelSection extends Component{static props={name:{type:String,optional:true},header:{type:Boolean,optional:true},show:Boolean,showData:{type:Boolean,optional:true},slots:{type:Object,shape:{default:Object,header:{type:Object,optional:true},title:{type:Object,optional:true},},},dataClassName:{type:String,optional:true},headerClassName:{type:String,optional:true},};static defaultProps={header:true,showData:true,};static template="project.ProjectRightSidePanelSection";}
return __exports;});;

/* /project/static/src/components/project_right_side_panel/project_right_side_panel.js */
odoo.define('@project/components/project_right_side_panel/project_right_side_panel',['@web/core/l10n/translation','@web/core/utils/hooks','@web/views/fields/formatters','@web/views/view_button/view_button','@web/views/view_dialogs/form_view_dialog','@project/components/project_right_side_panel/components/project_right_side_panel_section','@project/components/project_right_side_panel/components/project_milestone','@project/components/project_right_side_panel/components/project_profitability','@web/core/currency','@odoo/owl','@web/core/ui/ui_service'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useBus,useService}=require("@web/core/utils/hooks");const{formatFloat}=require("@web/views/fields/formatters");const{ViewButton}=require('@web/views/view_button/view_button');const{FormViewDialog}=require('@web/views/view_dialogs/form_view_dialog');const{ProjectRightSidePanelSection}=require("@project/components/project_right_side_panel/components/project_right_side_panel_section");const{ProjectMilestone}=require("@project/components/project_right_side_panel/components/project_milestone");const{ProjectProfitability}=require("@project/components/project_right_side_panel/components/project_profitability");const{getCurrency}=require('@web/core/currency');const{Component,onWillStart,useState}=require("@odoo/owl");const{SIZES}=require("@web/core/ui/ui_service");const ProjectRightSidePanel=__exports.ProjectRightSidePanel=class ProjectRightSidePanel extends Component{static components={ProjectRightSidePanelSection,ProjectMilestone,ViewButton,ProjectProfitability,};static template="project.ProjectRightSidePanel";static props={context:Object,domain:Array,};setup(){this.orm=useService('orm');this.actionService=useService('action');this.dialog=useService('dialog');this.uiService=useService("ui");useBus(this.uiService.bus,"resize",this.updateGridTemplateColumns)
this.state=useState({data:{milestones:{data:[],},profitability_items:{costs:{data:[],total:{billed:0.0,to_bill:0.0}},revenues:{data:[],total:{invoiced:0.0,to_invoice:0.0}},},user:{},currency_id:false,},gridTemplateColumns:this._getGridTemplateColumns(),});onWillStart(()=>this.loadData());}
_getGridTemplateColumns(){switch(this.uiService.size){case SIZES.XS:return 2;case SIZES.VSM:return 3;case SIZES.XXL:return 6;default:return 4;}}
updateGridTemplateColumns(){this.state.gridTemplateColumns=this._getGridTemplateColumns();}
get panelVisible(){return this.state.data.show_milestones||this.state.data.show_project_profitability_helper;}
get context(){return this.props.context;}
get domain(){return this.props.domain;}
get projectId(){return this.context.active_id;}
get currencyId(){return this.state.data.currency_id;}
get sectionNames(){return{'milestones':_t('Milestones'),'profitability':_t('Profitability'),};}
get showProjectProfitability(){const{costs,revenues}=this.state.data.profitability_items;return costs.data.length||revenues.data.length;}
formatFloat(value){return formatFloat(value,{digits:[false,1]});}
formatMonetary(value,options={}){const valueFormatted=formatFloat(value,{...options,'digits':[false,0],'noSymbol':true,});const currency=getCurrency(this.currencyId);if(!currency){return valueFormatted;}
if(currency.position==="after"){return`${valueFormatted}\u00A0${currency.symbol}`;}else{return`${currency.symbol}\u00A0${valueFormatted}`;}}
async loadData(){if(!this.projectId){return{};}
const data=await this.orm.call('project.project','get_panel_data',[[this.projectId]],{context:this.context},);this.state.data=data;return data;}
async loadMilestones(){const milestones=await this.orm.call('project.project','get_milestones',[[this.projectId]],{context:this.context},);this.state.data.milestones=milestones;return milestones;}
addMilestone(){const context={...this.context,'default_project_id':this.projectId,};this.openFormViewDialog({context,title:_t('New Milestone'),resModel:'project.milestone',onRecordSaved:async()=>{await this.loadMilestones();},});}
async openFormViewDialog(params,options={}){this.dialog.add(FormViewDialog,params,options);}
async onProjectActionClick(params){this.actionService.doActionButton({type:'action',resId:this.projectId,context:this.context,resModel:'project.project',...params,});}
_getStatButtonClickParams(statButton){return{type:statButton.action_type,name:statButton.action,context:statButton.additional_context||'{}',};}
_getStatButtonRecordParams(){return{resId:this.projectId,context:this.context,resModel:'project.project',};}}
return __exports;});;

/* /project/static/src/components/project_state_selection/project_state_selection.js */
odoo.define('@project/components/project_state_selection/project_state_selection',['@web/core/registry','@web/views/fields/state_selection/state_selection_field','@project/utils/project_utils'],function(require){'use strict';let __exports={};const{registry}=require('@web/core/registry');const{StateSelectionField,stateSelectionField,}=require("@web/views/fields/state_selection/state_selection_field");const{STATUS_COLORS,STATUS_COLOR_PREFIX}=require("@project/utils/project_utils");const ProjectStateSelectionField=__exports.ProjectStateSelectionField=class ProjectStateSelectionField extends StateSelectionField{setup(){super.setup();this.colorPrefix=STATUS_COLOR_PREFIX;this.colors=STATUS_COLORS;}
get options(){return super.options.filter(o=>o[0]!=='to_define');}}
const projectStateSelectionField=__exports.projectStateSelectionField={...stateSelectionField,component:ProjectStateSelectionField,};registry.category("fields").add("project_state_selection",projectStateSelectionField);return __exports;});;

/* /project/static/src/components/project_status_with_color_selection/project_status_with_color_selection_field.js */
odoo.define('@project/components/project_status_with_color_selection/project_status_with_color_selection_field',['@web/views/fields/selection/selection_field','@web/core/registry','@project/utils/project_utils'],function(require){'use strict';let __exports={};const{SelectionField,selectionField}=require('@web/views/fields/selection/selection_field');const{registry}=require('@web/core/registry');const{STATUS_COLORS,STATUS_COLOR_PREFIX}=require("@project/utils/project_utils");const ProjectStatusWithColorSelectionField=__exports.ProjectStatusWithColorSelectionField=class ProjectStatusWithColorSelectionField extends SelectionField{static props={...SelectionField.props,statusLabel:{type:String,optional:true},hideStatusName:{type:Boolean,optional:true},};static template="project.ProjectStatusWithColorSelectionField";setup(){super.setup();this.colorPrefix=STATUS_COLOR_PREFIX;this.colors=STATUS_COLORS;}
get currentValue(){return this.props.record.data[this.props.name]||this.options[0][0];}
statusColor(value){return this.colors[value]?this.colorPrefix+this.colors[value]:"";}}
const projectStatusWithColorSelectionField=__exports.projectStatusWithColorSelectionField={...selectionField,component:ProjectStatusWithColorSelectionField,extractProps:(fieldInfo,dynamicInfo)=>{const props=selectionField.extractProps(fieldInfo,dynamicInfo);props.statusLabel=fieldInfo.attrs.status_label;props.hideStatusName=Boolean(fieldInfo.attrs.hideStatusName);return props;},};registry.category("fields").add("status_with_color",projectStatusWithColorSelectionField);return __exports;});;

/* /project/static/src/components/project_task_name_with_subtask_count_char_field/project_task_name_with_subtask_count_char_field.js */
odoo.define('@project/components/project_task_name_with_subtask_count_char_field/project_task_name_with_subtask_count_char_field',['@web/core/registry','@web/views/fields/char/char_field'],function(require){'use strict';let __exports={};const{registry}=require('@web/core/registry');const{CharField,charField}=require('@web/views/fields/char/char_field');const ProjectTaskNameWithSubtaskCountCharField=__exports.ProjectTaskNameWithSubtaskCountCharField=class ProjectTaskNameWithSubtaskCountCharField extends CharField{static template="project.ProjectTaskNameWithSubtaskCountCharField";}
const projectTaskNameWithSubtaskCountCharField=__exports.projectTaskNameWithSubtaskCountCharField={...charField,component:ProjectTaskNameWithSubtaskCountCharField,fieldDependencies:[{name:"subtask_count",type:"integer"},{name:"closed_subtask_count",type:"integer"},],}
registry.category("fields").add("name_with_subtask_count",projectTaskNameWithSubtaskCountCharField);return __exports;});;

/* /project/static/src/components/project_task_priority_switch_field/project_task_priority_switch_field.js */
odoo.define('@project/components/project_task_priority_switch_field/project_task_priority_switch_field',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/priority/priority_field'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{PriorityField,priorityField}=require("@web/views/fields/priority/priority_field");const PrioritySwitchField=__exports.PrioritySwitchField=class PrioritySwitchField extends PriorityField{get commands(){return this.options.map(([id,name])=>[_t("Set priority as %s",name),()=>this.updateRecord(id),{category:"smart_action",hotkey:"alt+r",isAvailable:()=>this.props.record.data[this.props.name]!==id,},]);}}
const prioritySwitchField=__exports.prioritySwitchField={...priorityField,component:PrioritySwitchField,extractProps({viewType}){const props=priorityField.extractProps(...arguments);props.withCommand=viewType==="form";return props;},};registry.category("fields").add("priority_switch",prioritySwitchField);return __exports;});;

/* /project/static/src/components/project_task_state_selection/project_task_stage_state_selection/project_task_stage_with_state_selection.js */
odoo.define('@project/components/project_task_state_selection/project_task_stage_state_selection/project_task_stage_with_state_selection',['@odoo/owl','@web/core/l10n/translation','@web/core/registry','@web/core/utils/objects','@web/views/fields/many2one/many2one_field','@web/views/fields/standard_field_props','@project/components/project_task_state_selection/project_task_state_selection'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{omit}=require("@web/core/utils/objects");const{Many2OneField}=require("@web/views/fields/many2one/many2one_field");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{ProjectTaskStateSelection}=require("@project/components/project_task_state_selection/project_task_state_selection");const TaskStageWithStateSelection=__exports.TaskStageWithStateSelection=class TaskStageWithStateSelection extends Component{static template="project.TaskStageWithStateSelection";static props={...standardFieldProps,stateReadonly:{type:Boolean,optional:true},viewType:{type:String},};static components={ProjectTaskStateSelection,Many2OneField,};get stageProps(){return omit(this.props,"stateReadonly","viewType");}
get stateProps(){return{...this.stageProps,name:"state",readonly:this.props.stateReadonly,viewType:this.props.viewType,showLabel:false,};}}
const taskStageWithStateSelection=__exports.taskStageWithStateSelection={component:TaskStageWithStateSelection,supportedOptions:[{label:_t("State readonly"),name:"state_readonly",type:"boolean",default:true,},],fieldDependencies:[{name:"state",type:"selection"}],supportedTypes:["many2one"],extractProps({options,viewType}){return{stateReadonly:"state_readonly"in options?options.state_readonly:true,viewType:viewType,};},};registry.category("fields").add("task_stage_with_state_selection",taskStageWithStateSelection);return __exports;});;

/* /project/static/src/components/project_task_state_selection/project_task_state_selection.js */
odoo.define('@project/components/project_task_state_selection/project_task_state_selection',['@web/core/l10n/translation','@web/views/fields/state_selection/state_selection_field','@web/core/commands/command_hook','@web/views/fields/formatters','@web/core/registry','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{StateSelectionField,stateSelectionField,}=require("@web/views/fields/state_selection/state_selection_field");const{useCommand}=require("@web/core/commands/command_hook");const{formatSelection}=require("@web/views/fields/formatters");const{registry}=require("@web/core/registry");const{useState}=require("@odoo/owl");const ProjectTaskStateSelection=__exports.ProjectTaskStateSelection=class ProjectTaskStateSelection extends StateSelectionField{static template="project.ProjectTaskStateSelection";static props={...stateSelectionField.component.props,isToggleMode:{type:Boolean,optional:true},viewType:{type:String},};setup(){this.state=useState({isStateButtonHighlighted:false,});this.icons={"01_in_progress":"o_status","03_approved":"o_status o_status_green","02_changes_requested":"fa fa-lg fa-exclamation-circle","1_done":"fa fa-lg fa-check-circle","1_canceled":"fa fa-lg fa-times-circle","04_waiting_normal":"fa fa-lg fa-hourglass-o",};this.colorIcons={"01_in_progress":"","03_approved":"text-success","02_changes_requested":"o_status_changes_requested","1_done":"text-success","1_canceled":"text-danger","04_waiting_normal":"btn-outline-info",};this.colorButton={"01_in_progress":"btn-outline-secondary","03_approved":"btn-outline-success","02_changes_requested":"btn-outline-warning","1_done":"btn-outline-success","1_canceled":"btn-outline-danger","04_waiting_normal":"btn-outline-info",};if(this.props.viewType!='form'){super.setup();}else{const commandName=_t("Set state as...");useCommand(commandName,()=>{return{placeholder:commandName,providers:[{provide:()=>this.options.map(subarr=>({name:subarr[1],action:()=>{this.updateRecord(subarr[0]);},})),},],};},{category:"smart_action",hotkey:"alt+f",isAvailable:()=>!this.props.readonly&&!this.props.isDisabled,});}}
get options(){const labels=new Map(super.options);const states=["1_canceled","1_done"];const currentState=this.props.record.data[this.props.name];if(currentState!="04_waiting_normal"){states.unshift("01_in_progress","02_changes_requested","03_approved");}
return states.map((state)=>[state,labels.get(state)]);}
get availableOptions(){return this.options;}
get label(){const waitOption=super.options.findLast(([state,_])=>state==="04_waiting_normal");const fullSelection=[...this.options,waitOption];return formatSelection(this.currentValue,{selection:fullSelection,});}
stateIcon(value){return this.icons[value]||"";}
statusColor(value){return this.colorIcons[value]||"";}
get isToggleMode(){return this.props.isToggleMode||!this.props.record.data.project_id;}
isView(viewNames){return viewNames.includes(this.props.viewType);}
async toggleState(){const toggleVal=this.currentValue=="1_done"?"01_in_progress":"1_done";await this.updateRecord(toggleVal);}
getDropdownPosition(){if(this.isView(['activity','kanban','list','calendar'])||this.env.isSmall){return'';}
return'bottom-end';}
getTogglerClass(currentValue){if(this.isView(['activity','kanban','list','calendar'])||this.env.isSmall){return'btn btn-link d-flex p-0';}
return'o_state_button btn rounded-pill '+this.colorButton[currentValue];}
async updateRecord(value){const result=await super.updateRecord(value);this.state.isStateButtonHighlighted=false;if(result){return result;}}
onMouseEnterStateButton(ev){if(!this.env.isSmall){this.state.isStateButtonHighlighted=true;}}
onMouseLeaveStateButton(ev){this.state.isStateButtonHighlighted=false;}}
const projectTaskStateSelection=__exports.projectTaskStateSelection={...stateSelectionField,component:ProjectTaskStateSelection,fieldDependencies:[{name:"project_id",type:"many2one"}],supportedOptions:[...stateSelectionField.supportedOptions,{label:_t("Is toggle mode"),name:"is_toggle_mode",type:"boolean"}],extractProps({options,viewType}){const props=stateSelectionField.extractProps(...arguments);props.isToggleMode=Boolean(options.is_toggle_mode);props.viewType=viewType;return props;},}
registry.category("fields").add("project_task_state_selection",projectTaskStateSelection);return __exports;});;

/* /project/static/src/components/subtask_kanban_list/subtask_kanban_create/subtask_kanban_create.js */
odoo.define('@project/components/subtask_kanban_list/subtask_kanban_create/subtask_kanban_create',['@odoo/owl','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,useState,useRef}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{useAutofocus}=require("@web/core/utils/hooks");const SubtaskCreate=__exports.SubtaskCreate=class SubtaskCreate extends Component{static template="project.SubtaskCreate";static props={name:String,isReadonly:{type:Boolean,optional:true},onSubtaskCreateNameChanged:{type:Function},onBlur:{type:Function},};setup(){this.placeholder=_t("Add Sub-tasks");this.state=useState({inputSize:1,name:this.props.name,});this.input=useRef("subtaskCreateInput");useAutofocus({refName:"subtaskCreateInput"});}
_onFocus(ev){ev.target.value=this.placeholder;ev.target.select();}
_onInput(ev){const value=ev.target.value;this.state.name=value;}
_onClick(){this.input.el.focus();}
async _onBlur(){this.props.onBlur();}
_onNameChanged(ev){const value=ev.target.value.trim();this.props.onSubtaskCreateNameChanged(value);ev.target.blur();}
_onSaveClick(){if(this.input.el.value!==""){this.props.onSubtaskCreateNameChanged(this.input.el.value);}}}
return __exports;});;

/* /project/static/src/components/subtask_kanban_list/subtask_kanban_list.js */
odoo.define('@project/components/subtask_kanban_list/subtask_kanban_list',['@odoo/owl','@web/core/utils/hooks','@web/core/registry','@web/views/fields/field','@web/views/widgets/standard_widget_props','@project/components/subtask_kanban_list/subtask_kanban_create/subtask_kanban_create'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const{Field,getPropertyFieldInfo}=require("@web/views/fields/field");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{SubtaskCreate}=require("@project/components/subtask_kanban_list/subtask_kanban_create/subtask_kanban_create");const SubtaskKanbanList=__exports.SubtaskKanbanList=class SubtaskKanbanList extends Component{static components={Field,SubtaskCreate,};static props={...standardWidgetProps,isReadonly:{type:Boolean,optional:true,},};static template="project.SubtaskKanbanList";setup(){this.actionService=useService("action");this.orm=useService("orm");this.subtaskCreate=useState({open:false,name:"",});}
get list(){return this.props.record.data.child_ids;}
get closedList(){return this.list.records.filter((child)=>{return!["1_done","1_canceled"].includes(child.data.state);});}
get fieldInfo(){return{state:{...getPropertyFieldInfo({name:"state",type:"project_task_state_selection"}),viewType:"kanban",},};}
async goToSubtask(subtask_id){return this.actionService.doAction({type:"ir.actions.act_window",res_model:this.list.resModel,res_id:subtask_id,views:[[false,"form"]],target:"current",context:{active_id:subtask_id,},});}
async onSubTaskCreated(ev){this.subtaskCreate.open=true;}
async _onBlur(){this.subtaskCreate.open=false;}
async _onSubtaskCreateNameChanged(name){await this.orm.create("project.task",[{display_name:name,parent_id:this.props.record.resId,project_id:this.props.record.data.project_id[0],user_ids:this.props.record.data.user_ids.resIds,}]);this.subtaskCreate.open=false;this.subtaskCreate.name="";this.props.record.load();}}
const subtaskKanbanList={component:SubtaskKanbanList,};registry.category("view_widgets").add("subtask_kanban_list",subtaskKanbanList);return __exports;});;

/* /project/static/src/components/subtask_one2many_field/subtask_list_renderer.js */
odoo.define('@project/components/subtask_one2many_field/subtask_list_renderer',['@web/core/l10n/translation','@web/core/confirmation_dialog/confirmation_dialog','@project/components/notebook_task_one2many_field/notebook_task_list_renderer'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{NotebookTaskListRenderer}=require("@project/components/notebook_task_one2many_field/notebook_task_list_renderer");const SubtaskListRenderer=__exports.SubtaskListRenderer=class SubtaskListRenderer extends NotebookTaskListRenderer{async onDeleteRecord(record){this.dialog.add(ConfirmationDialog,{body:_t("Are you sure you want to delete this record?"),confirm:()=>super.onDeleteRecord(record),cancel:()=>{},});}}
return __exports;});;

/* /project/static/src/components/subtask_one2many_field/subtask_one2many_field.js */
odoo.define('@project/components/subtask_one2many_field/subtask_one2many_field',['@web/core/registry','@web/views/fields/x2many/x2many_field','@project/components/subtask_one2many_field/subtask_list_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{X2ManyField,x2ManyField}=require('@web/views/fields/x2many/x2many_field');const{SubtaskListRenderer}=require("@project/components/subtask_one2many_field/subtask_list_renderer");const SubtaskOne2ManyField=__exports.SubtaskOne2ManyField=class SubtaskOne2ManyField extends X2ManyField{static components={...X2ManyField.components,ListRenderer:SubtaskListRenderer,};}
const subtaskOne2ManyField=__exports.subtaskOne2ManyField={...x2ManyField,component:SubtaskOne2ManyField,additionalClasses:["o_field_one2many"],}
registry.category("fields").add("subtasks_one2many",subtaskOne2ManyField);return __exports;});;

/* /project/static/src/components/task_list_renderer.js */
odoo.define('@project/components/task_list_renderer',['@web/core/utils/hooks','@web/views/list/list_renderer','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{ListRenderer}=require("@web/views/list/list_renderer");const{useEffect}=require("@odoo/owl");const TaskListRenderer=__exports.TaskListRenderer=class TaskListRenderer extends ListRenderer{setup(){super.setup();this.dialog=useService("dialog");useEffect((editedRecord)=>this.focusName(editedRecord),()=>[this.editedRecord]);}
focusName(editedRecord){if(editedRecord?.isNew&&!editedRecord.dirty){const col=this.columns.find((c)=>c.name==="name");this.focusCell(col);}}}
return __exports;});;

/* /project/static/src/views/analytic_account_form/analytic_account_form_controller.js */
odoo.define('@project/views/analytic_account_form/analytic_account_form_controller',['@web/core/confirmation_dialog/confirmation_dialog','@web/core/l10n/translation','@web/views/form/form_controller'],function(require){'use strict';let __exports={};const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{_t}=require("@web/core/l10n/translation");const{FormController}=require("@web/views/form/form_controller");const AnalyticAccountFormController=__exports.AnalyticAccountFormController=class AnalyticAccountFormController extends FormController{getStaticActionMenuItems(){const menuItems=super.getStaticActionMenuItems();if(this.model.root.data.project_count){menuItems.archive.callback=async()=>{const projects=await this.orm.call("project.project","search_read",[[["account_id","=",this.props.resId]],["name"],]);this.dialogService.add(ConfirmationDialog,{...this.archiveDialogProps,body:_t("This analytic account is associated with the following projects:\n%(projectList)s\n\nArchiving the account will remove the option to log timesheets for these projects.\n\nAre you sure you want to proceed?",{projectList:projects.map((project)=>`\t- ${project.name}`).join(`\n`),}),confirmLabel:_t("Archive Account"),cancelLabel:_t("Discard"),});};}
return menuItems;}}
return __exports;});;

/* /project/static/src/views/analytic_account_form/analytic_account_form_view.js */
odoo.define('@project/views/analytic_account_form/analytic_account_form_view',['@web/core/registry','@web/views/form/form_view','@project/views/analytic_account_form/analytic_account_form_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");const{AnalyticAccountFormController}=require("@project/views/analytic_account_form/analytic_account_form_controller");const AnalyticAccountFormView=__exports.AnalyticAccountFormView={...formView,Controller:AnalyticAccountFormController,};registry.category("views").add("analytic_account_form_view",AnalyticAccountFormView);return __exports;});;

/* /project/static/src/views/analytic_account_list/analytic_account_list_controller.js */
odoo.define('@project/views/analytic_account_list/analytic_account_list_controller',['@web/core/l10n/translation','@web/views/list/list_controller'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ListController}=require("@web/views/list/list_controller");const AnalyticAccountListController=__exports.AnalyticAccountListController=class AnalyticAccountListController extends ListController{get archiveDialogProps(){let dialogProps=super.archiveDialogProps;const selectedRecords=this.model.root.selection;if(selectedRecords.length){const analyticAccountWithProjects=selectedRecords.filter((record)=>record.data.project_count).map((record)=>record.data.name);if(analyticAccountWithProjects.length){dialogProps={...dialogProps,body:_t("Some of the selected analytic accounts are associated with a project:\n%(accountList)s\n\nArchiving these accounts will remove the option to log timesheets for their respective projects.\n\nAre you sure you want to proceed?",{accountList:analyticAccountWithProjects.map((name)=>`\t- ${name}`).join("\n"),}),confirmLabel:_t("Archive Accounts"),cancelLabel:_t("Discard"),};}}
return dialogProps;}}
return __exports;});;

/* /project/static/src/views/analytic_account_list/analytic_account_list_view.js */
odoo.define('@project/views/analytic_account_list/analytic_account_list_view',['@web/core/registry','@web/views/list/list_view','@project/views/analytic_account_list/analytic_account_list_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{AnalyticAccountListController}=require("@project/views/analytic_account_list/analytic_account_list_controller");const AnalyticAccountListView=__exports.AnalyticAccountListView={...listView,Controller:AnalyticAccountListController,};registry.category("views").add("analytic_account_list_view",AnalyticAccountListView);return __exports;});;

/* /project/static/src/views/project_project_calendar/project_project_calendar_controller.js */
odoo.define('@project/views/project_project_calendar/project_project_calendar_controller',['@web/views/calendar/calendar_controller','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{CalendarController}=require("@web/views/calendar/calendar_controller");const{_t}=require("@web/core/l10n/translation");const ProjectProjectCalendarController=__exports.ProjectProjectCalendarController=class ProjectProjectCalendarController extends CalendarController{get editRecordDefaultDisplayText(){return _t("New Project");}}
return __exports;});;

/* /project/static/src/views/project_project_calendar/project_project_calendar_view.js */
odoo.define('@project/views/project_project_calendar/project_project_calendar_view',['@web/core/registry','@web/views/calendar/calendar_view','@project/views/project_project_calendar/project_project_calendar_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{calendarView}=require("@web/views/calendar/calendar_view");const{ProjectProjectCalendarController}=require("@project/views/project_project_calendar/project_project_calendar_controller");const viewRegistry=registry.category("views");const projectProjectCalendarView={...calendarView,Controller:ProjectProjectCalendarController,};viewRegistry.add("project_project_calendar",projectProjectCalendarView);return __exports;});;

/* /project/static/src/views/project_project_kanban/project_project_kanban_header.js */
odoo.define('@project/views/project_project_kanban/project_project_kanban_header',['@web/views/kanban/kanban_header','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{KanbanHeader}=require("@web/views/kanban/kanban_header");const{useService}=require("@web/core/utils/hooks");const ProjectProjectKanbanHeader=__exports.ProjectProjectKanbanHeader=class ProjectProjectKanbanHeader extends KanbanHeader{setup(){super.setup();this.action=useService("action");}
async deleteGroup(){if(this.group.groupByField.name==='stage_id'){const action=await this.group.model.orm.call(this.group.groupByField.relation,'unlink_wizard',[this.group.value],{context:this.group.context},);this.action.doAction(action);return;}
super.deleteGroup();}}
return __exports;});;

/* /project/static/src/views/project_project_kanban/project_project_kanban_renderer.js */
odoo.define('@project/views/project_project_kanban/project_project_kanban_renderer',['@web/views/kanban/kanban_renderer','@project/views/project_project_kanban/project_project_kanban_header'],function(require){'use strict';let __exports={};const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{ProjectProjectKanbanHeader}=require("@project/views/project_project_kanban/project_project_kanban_header");const ProjectProjectKanbanRenderer=__exports.ProjectProjectKanbanRenderer=class ProjectProjectKanbanRenderer extends KanbanRenderer{static components={...KanbanRenderer.components,KanbanHeader:ProjectProjectKanbanHeader,};}
return __exports;});;

/* /project/static/src/views/project_project_kanban/project_task_kanban_view.js */
odoo.define('@project/views/project_project_kanban/project_task_kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@project/views/project_project_kanban/project_project_kanban_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{ProjectProjectKanbanRenderer}=require("@project/views/project_project_kanban/project_project_kanban_renderer");const projectProjectKanbanView=__exports.projectProjectKanbanView={...kanbanView,Renderer:ProjectProjectKanbanRenderer,};registry.category("views").add("project_project_kanban",projectProjectKanbanView);return __exports;});;

/* /project/static/src/views/project_project_list/project_project_list_renderer.js */
odoo.define('@project/views/project_project_list/project_project_list_renderer',['@web/views/list/list_renderer','@web/views/kanban/kanban_record'],function(require){'use strict';let __exports={};const{ListRenderer}=require("@web/views/list/list_renderer");const{getRawValue}=require("@web/views/kanban/kanban_record");const ProjectProjectListRenderer=__exports.ProjectProjectListRenderer=class ProjectProjectListRenderer extends ListRenderer{isCellReadonly(column,record){let readonly=super.isCellReadonly(column,record);const{selection}=this.props.list;if(column.name==="stage_id"&&selection.length){const companyId=getRawValue(selection[0],"company_id");readonly=selection.some((task)=>getRawValue(task,"company_id")!==companyId);}
return readonly;}}
return __exports;});;

/* /project/static/src/views/project_project_list/project_project_list_view.js */
odoo.define('@project/views/project_project_list/project_project_list_view',['@web/core/registry','@web/views/list/list_view','@project/views/project_project_list/project_project_list_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require('@web/views/list/list_view');const{ProjectProjectListRenderer}=require("@project/views/project_project_list/project_project_list_renderer");const projectProjectListView=__exports.projectProjectListView={...listView,Renderer:ProjectProjectListRenderer,};registry.category("views").add("project_project_list",projectProjectListView);return __exports;});;

/* /project/static/src/views/project_task_calendar/project_task_calendar_controller.js */
odoo.define('@project/views/project_task_calendar/project_task_calendar_controller',['@web/core/l10n/translation','@web/views/calendar/calendar_controller','@project/views/project_task_form/project_task_form_controller','@project/views/project_task_calendar/project_task_calendar_filter_panel/project_task_calendar_filter_panel'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{CalendarController}=require("@web/views/calendar/calendar_controller");const{subTaskDeleteConfirmationMessage}=require("@project/views/project_task_form/project_task_form_controller");const{ProjectTaskCalendarFilterPanel}=require("@project/views/project_task_calendar/project_task_calendar_filter_panel/project_task_calendar_filter_panel");const ProjectTaskCalendarController=__exports.ProjectTaskCalendarController=class ProjectTaskCalendarController extends CalendarController{static components={...ProjectTaskCalendarController.components,FilterPanel:ProjectTaskCalendarFilterPanel,};get editRecordDefaultDisplayText(){return _t("New Task");}
deleteConfirmationDialogProps(record){const deleteConfirmationDialogProps=super.deleteConfirmationDialogProps(record);if(!record.rawRecord.subtask_count){return deleteConfirmationDialogProps;}
return{...deleteConfirmationDialogProps,body:subTaskDeleteConfirmationMessage,}}}
return __exports;});;

/* /project/static/src/views/project_task_calendar/project_task_calendar_filter_panel/project_task_calendar_filter_panel.js */
odoo.define('@project/views/project_task_calendar/project_task_calendar_filter_panel/project_task_calendar_filter_panel',['@web/views/calendar/filter_panel/calendar_filter_panel'],function(require){'use strict';let __exports={};const{CalendarFilterPanel}=require("@web/views/calendar/filter_panel/calendar_filter_panel");const ProjectTaskCalendarFilterPanel=__exports.ProjectTaskCalendarFilterPanel=class ProjectTaskCalendarFilterPanel extends CalendarFilterPanel{static subTemplates={filter:"project.ProjectTaskCalendarFilterPanel.filter",};}
return __exports;});;

/* /project/static/src/views/project_task_calendar/project_task_calendar_model.js */
odoo.define('@project/views/project_task_calendar/project_task_calendar_model',['@web/core/l10n/translation','@web/views/calendar/calendar_model'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{CalendarModel}=require('@web/views/calendar/calendar_model');const ProjectTaskCalendarModel=__exports.ProjectTaskCalendarModel=class ProjectTaskCalendarModel extends CalendarModel{get defaultFilterLabel(){this.isCheckProject='project_id'in this.meta.filtersInfo;if(this.isCheckProject){return _t("Private");}
return super.defaultFilterLabel;}}
return __exports;});;

/* /project/static/src/views/project_task_calendar/project_task_calendar_view.js */
odoo.define('@project/views/project_task_calendar/project_task_calendar_view',['@web/core/registry','@web/views/calendar/calendar_view','@project/views/project_task_calendar/project_task_calendar_controller','@project/views/project_task_calendar/project_task_calendar_model'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{calendarView}=require("@web/views/calendar/calendar_view");const{ProjectTaskCalendarController}=require("@project/views/project_task_calendar/project_task_calendar_controller");const{ProjectTaskCalendarModel}=require("@project/views/project_task_calendar/project_task_calendar_model");const projectTaskCalendarView=__exports.projectTaskCalendarView={...calendarView,Controller:ProjectTaskCalendarController,Model:ProjectTaskCalendarModel,};registry.category("views").add("project_task_calendar",projectTaskCalendarView);return __exports;});;

/* /project/static/src/views/project_task_form/project_task_form_controller.js */
odoo.define('@project/views/project_task_form/project_task_form_controller',['@web/core/l10n/translation','@web/core/confirmation_dialog/confirmation_dialog','@html_editor/components/history_dialog/history_dialog','@web/core/utils/hooks','@odoo/owl','@web/core/utils/strings','@resource/views/form_with_html_expander/form_controller_with_html_expander'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{HistoryDialog}=require("@html_editor/components/history_dialog/history_dialog");const{useService}=require('@web/core/utils/hooks');const{markup}=require('@odoo/owl');const{escape}=require('@web/core/utils/strings');const{FormControllerWithHTMLExpander}=require('@resource/views/form_with_html_expander/form_controller_with_html_expander');const subTaskDeleteConfirmationMessage=__exports.subTaskDeleteConfirmationMessage=_t(`Deleting a task will also delete its associated sub-tasks. \
If you wish to preserve the sub-tasks, make sure to unlink them from their parent task beforehand.

Are you sure you want to proceed?`);const ProjectTaskFormController=__exports.ProjectTaskFormController=class ProjectTaskFormController extends FormControllerWithHTMLExpander{setup(){super.setup();this.notifications=useService("notification");}
getStaticActionMenuItems(){return{...super.getStaticActionMenuItems(),openHistoryDialog:{sequence:50,icon:"fa fa-history",description:_t("Version History"),callback:()=>this.openHistoryDialog(),},};}
get deleteConfirmationDialogProps(){const deleteConfirmationDialogProps=super.deleteConfirmationDialogProps;if(!this.model.root.data.subtask_count){return deleteConfirmationDialogProps;}
return{...deleteConfirmationDialogProps,body:subTaskDeleteConfirmationMessage,}}
async openHistoryDialog(){const record=this.model.root;const versionedFieldName='description';const historyMetadata=record.data["html_field_history_metadata"]?.[versionedFieldName];if(!historyMetadata){this.notifications.add(escape(_t("The task description lacks any past content that could be restored at the moment.")));return;}
this.dialogService.add(HistoryDialog,{title:_t("Task Description History"),noContentHelper:markup(`<span class='text-muted fst-italic'>${escape(
                        _t(
                            "The task description was empty at the time."
                        )
                    )}</span>`),recordId:record.resId,recordModel:this.props.resModel,versionedFieldName,historyMetadata,restoreRequested:(html,close)=>{this.dialogService.add(ConfirmationDialog,{title:_t("Are you sure you want to restore this version ?"),body:_t("Restoring will replace the current content with the selected version. Any unsaved changes will be lost."),confirm:()=>{const restoredData={};restoredData[versionedFieldName]=html;record.update(restoredData);close();},confirmLabel:_t("Restore"),});},},);}}
return __exports;});;

/* /project/static/src/views/project_task_form/project_task_form_view.js */
odoo.define('@project/views/project_task_form/project_task_form_view',['@resource/views/form_with_html_expander/form_view_with_html_expander','@web/core/registry','@project/views/project_task_form/project_task_form_controller'],function(require){'use strict';let __exports={};const{formViewWithHtmlExpander}=require("@resource/views/form_with_html_expander/form_view_with_html_expander");const{registry}=require("@web/core/registry");const{ProjectTaskFormController}=require("@project/views/project_task_form/project_task_form_controller");const projectTaskFormView=__exports.projectTaskFormView={...formViewWithHtmlExpander,Controller:ProjectTaskFormController,};registry.category("views").add("project_task_form",projectTaskFormView);return __exports;});;

/* /project/static/src/views/project_task_kanban/project_task_kanban_compiler.js */
odoo.define('@project/views/project_task_kanban/project_task_kanban_compiler',['@web/views/kanban/kanban_compiler'],function(require){'use strict';let __exports={};const{KanbanCompiler}=require("@web/views/kanban/kanban_compiler");const ProjectTaskKanbanCompiler=__exports.ProjectTaskKanbanCompiler=class ProjectTaskKanbanCompiler extends KanbanCompiler{setup(){super.setup();this.subtaskListComponentCompiled={button:false,component:false,};this.compilers.unshift({selector:'widget[name="subtask_counter"]',fn:this.compileSubtaskListButton},{selector:'widget[name="subtask_kanban_list"]',fn:this.compileSubtaskListComponent},);}
compileSubtaskListButton(el){this.subtaskListComponentCompiled.button=true;return this.compileWidget(el);}
compileSubtaskListComponent(el){this.subtaskListComponentCompiled.component=true;return this.compileWidget(el);}
compile(key,params={}){const newRoot=super.compile(key,params);if(this.subtaskListComponentCompiled.component!==this.subtaskListComponentCompiled.button){throw new Error("The subtask list component cannot be rendered if the button and the component are not in the view definition.");}
return newRoot;}}
return __exports;});;

/* /project/static/src/views/project_task_kanban/project_task_kanban_examples.js */
odoo.define('@project/views/project_task_kanban/project_task_kanban_examples',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/render','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{renderToMarkup}=require('@web/core/utils/render');const{markup}=require("@odoo/owl");const greenBullet=markup(`<span class="o_status d-inline-block o_status_green"></span>`);const orangeBullet=markup(`<span class="o_status d-inline-block text-warning"></span>`);const star=markup(`<a style="color: gold;" class="fa fa-star"></a>`);const clock=markup(`<a class="fa fa-clock-o"></a>`);const exampleData={ghostColumns:[_t('New'),_t('Assigned'),_t('In Progress'),_t('Done')],applyExamplesText:_t("Use This For My Project"),allowedGroupBys:['stage_id'],foldField:"fold",examples:[{name:_t('Software Development'),columns:[_t('Backlog'),_t('Specifications'),_t('Development'),_t('Tests')],foldedColumns:[_t('Delivered')],get description(){return renderToMarkup("project.example.generic");},bullets:[greenBullet,orangeBullet,star],},{name:_t('Agile Scrum'),columns:[_t('Backlog'),_t('Sprint Backlog'),_t('Sprint in Progress')],foldedColumns:[_t('Sprint Complete'),_t('Old Completed Sprint')],get description(){return renderToMarkup("project.example.agilescrum");},bullets:[greenBullet,orangeBullet],},{name:_t('Digital Marketing'),columns:[_t('Ideas'),_t('Researching'),_t('Writing'),_t('Editing')],foldedColumns:[_t('Done')],get description(){return renderToMarkup("project.example.digitalmarketing");},bullets:[greenBullet,orangeBullet],},{name:_t('Customer Feedback'),columns:[_t('New'),_t('In development')],foldedColumns:[_t('Done'),_t('Refused')],get description(){return renderToMarkup("project.example.customerfeedback");},bullets:[greenBullet,orangeBullet],},{name:_t('Consulting'),columns:[_t('New Projects'),_t('Resources Allocation'),_t('In Progress')],foldedColumns:[_t('Done')],get description(){return renderToMarkup("project.example.consulting");},bullets:[greenBullet,orangeBullet],},{name:_t('Research Project'),columns:[_t('Brainstorm'),_t('Research'),_t('Draft')],foldedColumns:[_t('Final Document')],get description(){return renderToMarkup("project.example.researchproject");},bullets:[greenBullet,orangeBullet],},{name:_t('Website Redesign'),columns:[_t('Page Ideas'),_t('Copywriting'),_t('Design')],foldedColumns:[_t('Live')],get description(){return renderToMarkup("project.example.researchproject");},},{name:_t('T-shirt Printing'),columns:[_t('New Orders'),_t('Logo Design'),_t('To Print')],foldedColumns:[_t('Done')],get description(){return renderToMarkup("project.example.tshirtprinting");},bullets:[star],},{name:_t('Design'),columns:[_t('New Request'),_t('Design'),_t('Client Review')],foldedColumns:[_t('Handoff')],get description(){return renderToMarkup("project.example.generic");},bullets:[greenBullet,orangeBullet,star,clock],},{name:_t('Publishing'),columns:[_t('Ideas'),_t('Writing'),_t('Editing')],foldedColumns:[_t('Published')],get description(){return renderToMarkup("project.example.generic");},bullets:[greenBullet,orangeBullet,star,clock],},{name:_t('Manufacturing'),columns:[_t('New Orders'),_t('Material Sourcing'),_t('Manufacturing'),_t('Assembling')],foldedColumns:[_t('Delivered')],get description(){return renderToMarkup("project.example.generic");},bullets:[greenBullet,orangeBullet,star,clock],},{name:_t('Podcast and Video Production'),columns:[_t('Research'),_t('Script'),_t('Recording'),_t('Mixing')],foldedColumns:[_t('Published')],get description(){return renderToMarkup("project.example.generic");},bullets:[greenBullet,orangeBullet,star,clock],}],};registry.category("kanban_examples").add('project',exampleData);return __exports;});;

/* /project/static/src/views/project_task_kanban/project_task_kanban_header.js */
odoo.define('@project/views/project_task_kanban/project_task_kanban_header',['@web/core/l10n/translation','@web/core/user','@web/core/utils/hooks','@web/views/kanban/kanban_header','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{useService}=require('@web/core/utils/hooks');const{KanbanHeader}=require("@web/views/kanban/kanban_header");const{onWillStart}=require("@odoo/owl");const ProjectTaskKanbanHeader=__exports.ProjectTaskKanbanHeader=class ProjectTaskKanbanHeader extends KanbanHeader{setup(){super.setup();this.action=useService('action');this.isProjectManager=false;onWillStart(this.onWillStart);}
async onWillStart(){if(this.props.list.isGroupedByStage){this.isProjectManager=await user.hasGroup('project.group_project_manager');}}
async deleteGroup(){if(this.group.groupByField.name==='stage_id'){const action=await this.group.model.orm.call(this.group.groupByField.relation,'unlink_wizard',[this.group.value],{context:this.group.context},);this.action.doAction(action);return;}
super.deleteGroup();}
canEditGroup(group){return super.canEditGroup(group)&&(!this.props.list.isGroupedByStage||this.isProjectManager);}
canDeleteGroup(group){return super.canDeleteGroup(group)&&(!this.props.list.isGroupedByStage||this.isProjectManager);}
_getEmptyGroupLabel(fieldName){if(fieldName==="project_id"){return _t("🔒 Private");}else if(fieldName==="user_ids"){return _t("👤 Unassigned");}else{return super._getEmptyGroupLabel(fieldName);}}}
return __exports;});;

/* /project/static/src/views/project_task_kanban/project_task_kanban_model.js */
odoo.define('@project/views/project_task_kanban/project_task_kanban_model',['@web/model/relational_model/relational_model','@web/model/relational_model/record','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{RelationalModel}=require("@web/model/relational_model/relational_model");const{Record}=require("@web/model/relational_model/record");const{makeActiveField}=require("@web/model/relational_model/utils");const ProjectTaskKanbanDynamicGroupList=__exports.ProjectTaskKanbanDynamicGroupList=class ProjectTaskKanbanDynamicGroupList extends RelationalModel.DynamicGroupList{get isGroupedByStage(){return!!this.groupByField&&this.groupByField.name==="stage_id";}}
const ProjectTaskRecord=__exports.ProjectTaskRecord=class ProjectTaskRecord extends Record{setup(){super.setup(...arguments);this.displaySubtasks=false;this.canSaveOnUpdate=true;}
async toggleSubtasksList(){const{display_name,project_id,state,user_ids}=this.config.fields;const activeField=makeActiveField({onChange:true});activeField.related={activeFields:{display_name:makeActiveField(),state:makeActiveField(),user_ids:makeActiveField(),project_id:makeActiveField(),},fields:{display_name,project_id,state,user_ids,},};await this._load({activeFields:{...this.config.activeFields,child_ids:activeField},});this.displaySubtasks=!this.displaySubtasks;}}
const ProjectTaskKanbanModel=__exports.ProjectTaskKanbanModel=class ProjectTaskKanbanModel extends RelationalModel{async _webReadGroup(config,firstGroupByName,orderBy){config.context={...config.context,project_kanban:true,};return super._webReadGroup(...arguments);}}
ProjectTaskKanbanModel.DynamicGroupList=ProjectTaskKanbanDynamicGroupList;ProjectTaskKanbanModel.Record=ProjectTaskRecord;return __exports;});;

/* /project/static/src/views/project_task_kanban/project_task_kanban_record.js */
odoo.define('@project/views/project_task_kanban/project_task_kanban_record',['@web/views/kanban/kanban_record','@odoo/owl','@project/views/project_task_kanban/project_task_kanban_compiler','@project/components/subtask_kanban_list/subtask_kanban_list'],function(require){'use strict';let __exports={};const{KanbanRecord}=require("@web/views/kanban/kanban_record");const{useState}=require("@odoo/owl");const{ProjectTaskKanbanCompiler}=require("@project/views/project_task_kanban/project_task_kanban_compiler");const{SubtaskKanbanList}=require("@project/components/subtask_kanban_list/subtask_kanban_list")
const ProjectTaskKanbanRecord=__exports.ProjectTaskKanbanRecord=class ProjectTaskKanbanRecord extends KanbanRecord{static Compiler=ProjectTaskKanbanCompiler;static components={...KanbanRecord.components,SubtaskKanbanList,};setup(){super.setup();this.state=useState({folded:true});}
get renderingContext(){const context=super.renderingContext;context["state"]=this.state;return context;}}
return __exports;});;

/* /project/static/src/views/project_task_kanban/project_task_kanban_renderer.js */
odoo.define('@project/views/project_task_kanban/project_task_kanban_renderer',['@web/views/kanban/kanban_renderer','@project/views/project_task_kanban/project_task_kanban_record','@project/views/project_task_kanban/project_task_kanban_header','@web/core/utils/hooks','@odoo/owl','@web/core/user'],function(require){'use strict';let __exports={};const{KanbanRenderer}=require('@web/views/kanban/kanban_renderer');const{ProjectTaskKanbanRecord}=require("@project/views/project_task_kanban/project_task_kanban_record");const{ProjectTaskKanbanHeader}=require("@project/views/project_task_kanban/project_task_kanban_header");const{useService}=require('@web/core/utils/hooks');const{onWillStart}=require("@odoo/owl");const{user}=require("@web/core/user");const ProjectTaskKanbanRenderer=__exports.ProjectTaskKanbanRenderer=class ProjectTaskKanbanRenderer extends KanbanRenderer{static components={...KanbanRenderer.components,KanbanRecord:ProjectTaskKanbanRecord,KanbanHeader:ProjectTaskKanbanHeader,};setup(){super.setup();this.action=useService('action');onWillStart(async()=>{this.isProjectManager=await user.hasGroup('project.group_project_manager');});}
canCreateGroup(){return super.canCreateGroup()&&(this.isProjectTasksContext()==this.props.list.isGroupedByStage&&this.isProjectManager||this.props.list.groupByField.name==='personal_stage_type_id');}
isProjectTasksContext(){return(["project.project","project.task.type.delete.wizard"].includes(this.props.list.context.active_model)&&!!this.props.list.context.default_project_id);}}
return __exports;});;

/* /project/static/src/views/project_task_kanban/project_task_kanban_view.js */
odoo.define('@project/views/project_task_kanban/project_task_kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@project/views/project_task_kanban/project_task_kanban_model','@project/views/project_task_kanban/project_task_kanban_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require('@web/views/kanban/kanban_view');const{ProjectTaskKanbanModel}=require("@project/views/project_task_kanban/project_task_kanban_model");const{ProjectTaskKanbanRenderer}=require("@project/views/project_task_kanban/project_task_kanban_renderer");const projectTaskKanbanView=__exports.projectTaskKanbanView={...kanbanView,Model:ProjectTaskKanbanModel,Renderer:ProjectTaskKanbanRenderer,};registry.category('views').add('project_task_kanban',projectTaskKanbanView);return __exports;});;

/* /project/static/src/views/project_task_list/project_task_list_controller.js */
odoo.define('@project/views/project_task_list/project_task_list_controller',['@web/views/list/list_controller','@project/views/project_task_form/project_task_form_controller'],function(require){'use strict';let __exports={};const{ListController}=require("@web/views/list/list_controller");const{subTaskDeleteConfirmationMessage}=require("@project/views/project_task_form/project_task_form_controller");const ProjectTaskListController=__exports.ProjectTaskListController=class ProjectTaskListController extends ListController{get deleteConfirmationDialogProps(){const deleteConfirmationDialogProps=super.deleteConfirmationDialogProps;const hasSubtasks=this.model.root.selection.some(task=>task.data.subtask_count>0)
if(!hasSubtasks){return deleteConfirmationDialogProps;}
return{...deleteConfirmationDialogProps,confirm:async()=>{await this.model.root.deleteRecords();await this.model.load();},body:subTaskDeleteConfirmationMessage,}}}
return __exports;});;

/* /project/static/src/views/project_task_list/project_task_list_renderer.js */
odoo.define('@project/views/project_task_list/project_task_list_renderer',['@web/views/list/list_renderer','@web/views/kanban/kanban_record','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{ListRenderer}=require("@web/views/list/list_renderer");const{getRawValue}=require("@web/views/kanban/kanban_record");const{_t}=require("@web/core/l10n/translation");const ProjectTaskListRenderer=__exports.ProjectTaskListRenderer=class ProjectTaskListRenderer extends ListRenderer{areSelectedTasksInSameProject(){if(this._areSelectedTasksInSameProject===undefined){const selection=this.props.list.selection;const projectId=selection.length&&getRawValue(selection[0],"project_id");this._areSelectedTasksInSameProject=selection.every((task)=>getRawValue(task,"project_id")===projectId);Promise.resolve().then(()=>{delete this._areSelectedTasksInSameProject;});}
return this._areSelectedTasksInSameProject;}
isCellReadonly(column,record){let readonly=false;if(column.name==="stage_id"){readonly=!this.areSelectedTasksInSameProject();}
return readonly||super.isCellReadonly(column,record);}
getGroupDisplayName(group){if(group.groupByField.name==="project_id"&&!group.value){return _t("🔒 Private");}else if(group.groupByField.name==="user_ids"&&!group.value){return _t("👤 Unassigned");}else{return super.getGroupDisplayName(group);}}}
return __exports;});;

/* /project/static/src/views/project_task_list/project_task_list_view.js */
odoo.define('@project/views/project_task_list/project_task_list_view',['@web/core/registry','@web/views/list/list_view','@project/views/project_task_list/project_task_list_controller','@project/views/project_task_list/project_task_list_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require('@web/views/list/list_view');const{ProjectTaskListController}=require("@project/views/project_task_list/project_task_list_controller");const{ProjectTaskListRenderer}=require("@project/views/project_task_list/project_task_list_renderer");const projectTaskListView=__exports.projectTaskListView={...listView,Controller:ProjectTaskListController,Renderer:ProjectTaskListRenderer,};registry.category("views").add("project_task_list",projectTaskListView);return __exports;});;

/* /project/static/src/views/project_update_kanban/project_update_kanban_controller.js */
odoo.define('@project/views/project_update_kanban/project_update_kanban_controller',['@web/views/kanban/kanban_controller','@project/components/project_right_side_panel/project_right_side_panel'],function(require){'use strict';let __exports={};const{KanbanController}=require('@web/views/kanban/kanban_controller');const{ProjectRightSidePanel}=require("@project/components/project_right_side_panel/project_right_side_panel");const ProjectUpdateKanbanController=__exports.ProjectUpdateKanbanController=class ProjectUpdateKanbanController extends KanbanController{static template="project.ProjectUpdateKanbanView";static components={...KanbanController.components,ProjectRightSidePanel,};get className(){return super.className+' o_controller_with_rightpanel';}}
return __exports;});;

/* /project/static/src/views/project_update_kanban/project_update_kanban_view.js */
odoo.define('@project/views/project_update_kanban/project_update_kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@project/views/project_update_kanban/project_update_kanban_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{ProjectUpdateKanbanController}=require("@project/views/project_update_kanban/project_update_kanban_controller");const projectUpdateKanbanView=__exports.projectUpdateKanbanView={...kanbanView,Controller:ProjectUpdateKanbanController,};registry.category('views').add('project_update_kanban',projectUpdateKanbanView);return __exports;});;

/* /project/static/src/views/project_update_list/project_update_list_controller.js */
odoo.define('@project/views/project_update_list/project_update_list_controller',['@web/views/list/list_controller','@project/components/project_right_side_panel/project_right_side_panel'],function(require){'use strict';let __exports={};const{ListController}=require('@web/views/list/list_controller');const{ProjectRightSidePanel}=require("@project/components/project_right_side_panel/project_right_side_panel");const ProjectUpdateListController=__exports.ProjectUpdateListController=class ProjectUpdateListController extends ListController{static template="project.ProjectUpdateListView";static components={...ListController.components,ProjectRightSidePanel,};get className(){return super.className+' o_controller_with_rightpanel';}}
return __exports;});;

/* /project/static/src/views/project_update_list/project_update_list_view.js */
odoo.define('@project/views/project_update_list/project_update_list_view',['@web/core/registry','@web/views/list/list_view','@project/views/project_update_list/project_update_list_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{ProjectUpdateListController}=require("@project/views/project_update_list/project_update_list_controller");const projectUpdateListView=__exports.projectUpdateListView={...listView,Controller:ProjectUpdateListController,};registry.category('views').add('project_update_list',projectUpdateListView);return __exports;});;

/* /project/static/src/views/widget/subtask_counter.js */
odoo.define('@project/views/widget/subtask_counter',['@web/core/l10n/translation','@odoo/owl','@web/core/registry','@web/views/widgets/standard_widget_props'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const SubtaskCounter=__exports.SubtaskCounter=class SubtaskCounter extends Component{static template="project.SubtaskCounter";static props={...standardWidgetProps,};onClick(){this.props.record.toggleSubtasksList();}
get closedSubtaskCount(){return this.props.record.data.closed_subtask_count;}
get subtaskCount(){return this.props.record.data.subtask_count;}
get counterTitle(){return _t("%(closedCount)s sub-tasks closed out of %(totalCount)s",{closedCount:this.closedSubtaskCount,totalCount:this.subtaskCount,});}
get counterDisplay(){return _t("%(count1)s/%(count2)s",{count1:this.closedSubtaskCount,count2:this.subtaskCount,});}}
const subtaskCounter=__exports.subtaskCounter={component:SubtaskCounter,fieldDependencies:[{name:"closed_subtask_count",type:"integer"},{name:"subtask_count",type:"integer"},],};registry.category("view_widgets").add("subtask_counter",subtaskCounter);return __exports;});;

/* /project/static/src/js/tours/project.js */
odoo.define('@project/js/tours/project',['@web/core/l10n/translation','@web/core/registry','@web_tour/tour_service/tour_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{stepUtils}=require("@web_tour/tour_service/tour_utils");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add('project_tour',{url:"/odoo",steps:()=>[stepUtils.showAppsMenuItem(),{isActive:["community"],trigger:'.o_app[data-menu-xmlid="project.menu_main_pm"]',content:markup(_t('Want a better way to <b>manage your projects</b>? <i>It starts here.</i>')),tooltipPosition:'right',run:"click",},{isActive:["enterprise"],trigger:'.o_app[data-menu-xmlid="project.menu_main_pm"]',content:markup(_t('Want a better way to <b>manage your projects</b>? <i>It starts here.</i>')),tooltipPosition:'bottom',run:"click",},{trigger:".o_project_kanban",},{trigger:'.o-kanban-button-new',content:markup(_t('Let\'s create your first <b>project</b>.')),tooltipPosition:'bottom',run:"click",},{trigger:'.o_project_name input',content:markup(_t('Choose a <b>name</b> for your project. <i>It can be anything you want: the name of a customer, of a product, of a team, of a construction site, etc.</i>')),tooltipPosition:'right',run:"edit Test",},{trigger:'.o_open_tasks',content:markup(_t('Let\'s create your first <b>project</b>.')),tooltipPosition:'top',run:"click .modal:visible .btn.btn-primary",},{trigger:".o_kanban_project_tasks .o_column_quick_create .o_kanban_header input",content:markup(_t("Add columns to organize your tasks into <b>stages</b> <i>e.g. New - In Progress - Done</i>.")),tooltipPosition:'bottom',run:"edit Test",},{trigger:".o_kanban_project_tasks .o_column_quick_create .o_kanban_add",content:markup(_t('Let\'s create your first <b>stage</b>.')),tooltipPosition:'right',run:"click",},{trigger:".o_kanban_group",},{trigger:".o_kanban_project_tasks .o_column_quick_create .o_kanban_header input",content:markup(_t("Add columns to organize your tasks into <b>stages</b> <i>e.g. New - In Progress - Done</i>.")),tooltipPosition:'bottom',run:"edit Test",},{trigger:".o_kanban_project_tasks .o_column_quick_create .o_kanban_add",content:markup(_t('Let\'s create your second <b>stage</b>.')),tooltipPosition:'right',run:"click",},{trigger:".o_kanban_group:eq(1)",},{trigger:'.o-kanban-button-new',content:markup(_t("Let's create your first <b>task</b>.")),tooltipPosition:'bottom',run:"click",},{trigger:".o_kanban_project_tasks",},{trigger:'.o_kanban_quick_create div.o_field_char[name=display_name] input',content:markup(_t('Choose a task <b>name</b> <i>(e.g. Website Design, Purchase Goods...)</i>')),tooltipPosition:'right',run:"edit Test",},{trigger:".o_kanban_project_tasks",},{trigger:'.o_kanban_quick_create .o_kanban_add',content:_t("Add your task once it is ready."),tooltipPosition:"bottom",run:"click",},{trigger:".o_kanban_project_tasks",},{trigger:".o_kanban_record",content:markup(_t("<b>Drag &amp; drop</b> the card to change your task from stage.")),tooltipPosition:"bottom",run:"drag_and_drop(.o_kanban_group:eq(1))",},{trigger:".o_kanban_project_tasks",},{trigger:".o_kanban_record:first",content:_t("Let's start working on your task."),tooltipPosition:"bottom",run:"click",},{trigger:".o_form_project_tasks",},{trigger:".o-mail-Chatter-topbar button.o-mail-Chatter-sendMessage",content:markup(_t("Use the chatter to <b>send emails</b> and communicate efficiently with your customers. Add new people to the followers' list to make them aware of the main changes about this task.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_form_project_tasks",},{trigger:"button.o-mail-Chatter-logNote",content:markup(_t("<b>Log notes</b> for internal communications <i>(the people following this task won't be notified of the note you are logging unless you specifically tag them)</i>. Use @ <b>mentions</b> to ping a colleague or # <b>mentions</b> to reach an entire team.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_form_project_tasks",},{trigger:".o-mail-Chatter-topbar button.o-mail-Chatter-activity",content:markup(_t("Create <b>activities</b> to set yourself to-dos or to schedule meetings.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_form_project_tasks",},{trigger:".modal-dialog .btn-primary",content:_t("Schedule your activity once it is ready."),tooltipPosition:"bottom",run:"click",},{trigger:".o_form_project_tasks",},{isActive:["auto"],trigger:".o_field_widget[name='user_ids'] input",content:_t("Assign a responsible to your task"),tooltipPosition:"right",run:"edit Admin",},{isActive:["manual"],trigger:".o_field_widget[name='user_ids']",content:_t("Assign a responsible to your task"),tooltipPosition:"right",run:"click",},{isActive:["desktop","auto"],trigger:"a.dropdown-item[id*='user_ids'] span",content:_t("Select an assignee from the menu"),run:"click",},{isActive:["mobile"],trigger:"div.o_kanban_renderer > article.o_kanban_record",run:"click",},{isActive:["auto"],trigger:'a[name="sub_tasks_page"]',content:_t('Open sub-tasks notebook section'),run:'click',},{isActive:["auto"],trigger:'.o_field_subtasks_one2many .o_list_renderer a[role="button"]',content:_t('Add a sub-task'),run:'click',},{isActive:["auto"],trigger:'.o_field_subtasks_one2many div[name="name"] input',content:markup(_t('Give the sub-task a <b>name</b>')),run:"edit New Sub-task",},{trigger:".o_form_project_tasks .o_form_dirty",},{isActive:["auto"],trigger:".o_form_button_save",content:markup(_t("You have unsaved changes - no worries! Odoo will automatically save it as you navigate.<br/> You can discard these changes from here or manually save your task.<br/>Let's save it manually.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_form_project_tasks",},{trigger:".o_breadcrumb .o_back_button",content:markup(_t("Let's go back to the <b>kanban view</b> to have an overview of your next tasks.")),tooltipPosition:"right",run:'click',},{isActive:["auto"],trigger:".o_kanban_record .o_widget_subtask_counter .subtask_list_button",content:_t("You can open sub-tasks from the kanban card!"),run:"click",},{trigger:".o_widget_subtask_kanban_list .subtask_list",},{isActive:["auto"],trigger:".o_kanban_record .o_widget_subtask_kanban_list .subtask_create",content:_t("Create a new sub-task"),run:"click",},{trigger:".subtask_create_input",},{isActive:["auto"],trigger:".o_kanban_record .o_widget_subtask_kanban_list .subtask_create_input input",content:markup(_t("Give the sub-task a <b>name</b>")),run:"edit Newer Sub-task && click body",},{isActive:["auto"],trigger:".o_kanban_record .o_widget_subtask_kanban_list .subtask_list_row:contains(newer sub-task) .o_field_project_task_state_selection button",content:_t("You can change the sub-task state here!"),run:"click",},{trigger:".project_task_state_selection_menu.dropdown-menu",},{isActive:["auto"],trigger:".project_task_state_selection_menu.dropdown-menu span.text-danger",content:markup(_t("Mark the task as <b>Cancelled</b>")),run:"click",},{trigger:".o-overlay-container:not(:visible):not(:has(.project_task_state_selection_menu))",},{isActive:["auto"],trigger:".o_kanban_record .o_widget_subtask_counter .subtask_list_button:contains('1/2')",content:_t("Close the sub-tasks list"),run:"click",},{isActive:["auto"],trigger:'.o_kanban_renderer',run:"click",}]});return __exports;});;

/* /website_sale/static/src/js/tours/tour_utils.js */
odoo.define('@website_sale/js/tours/tour_utils',['@web/core/l10n/translation','@website/js/tours/tour_utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{clickOnElement}=require('@website/js/tours/tour_utils');__exports.addToCart=addToCart;function addToCart({productName,search=true,productHasVariants=false}){const steps=[];if(search){steps.push(...searchProduct(productName));}
steps.push(clickOnElement(productName,`a:contains(${productName})`));steps.push(clickOnElement('Add to cart','#add_to_cart'));if(productHasVariants){steps.push(clickOnElement('Continue Shopping','button:contains("Continue Shopping")'));}
return steps;}
__exports.assertCartAmounts=assertCartAmounts;function assertCartAmounts({taxes=false,untaxed=false,total=false,delivery=false}){let steps=[];if(taxes){steps.push({content:'Check if the tax is correct',trigger:`tr#order_total_taxes .oe_currency_value:contains(/^${taxes}$/)`,});}
if(untaxed){steps.push({content:'Check if the tax is correct',trigger:`tr#order_total_untaxed .oe_currency_value:contains(/^${untaxed}$/)`,});}
if(total){steps.push({content:'Check if the tax is correct',trigger:`tr#order_total .oe_currency_value:contains(/^${total}$/)`,});}
if(delivery){steps.push({content:'Check if the tax is correct',trigger:`tr#order_delivery .oe_currency_value:contains(/^${delivery}$/)`,});}
return steps}
__exports.assertCartContains=assertCartContains;function assertCartContains({productName,backend,notContains=false}={}){let trigger=`a:contains(${productName})`;if(notContains){trigger=`:not(${trigger})`;}
return{content:`Checking if ${productName} is in the cart`,trigger:`${backend ? ":iframe" : ""} ${trigger}`,};}
__exports.assertProductPrice=assertProductPrice;function assertProductPrice(attribute,value,productName){return{content:`The ${attribute} of the ${productName} is ${value}`,trigger:`div:contains("${productName}") [data-oe-expression="template_price_vals['${attribute}']"] .oe_currency_value:contains("${value}")`,};}
__exports.fillAdressForm=fillAdressForm;function fillAdressForm(adressParams={name:"John Doe",phone:"123456789",email:"johndoe@gmail.com",street:"1 rue de la paix",city:"Paris",zip:"75000",}){const steps=[];steps.push({trigger:"#o_country_id",run:"selectByLabel Belgium",});for(const arg of["name","phone","email","street","city","zip"]){steps.push({content:`Address filling ${arg}`,trigger:`form.checkout_autoformat input[name=${arg}]`,run:`edit ${adressParams[arg]}`,});}
steps.push({content:"Continue checkout",trigger:"#save_address",run:"click",});return steps;}
__exports.goToCart=goToCart;function goToCart({quantity=1,position="bottom",backend=false}={}){return{content:_t("Go to cart"),trigger:`${backend ? ":iframe" : ""} a sup.my_cart_quantity:contains(/^${quantity}$/)`,tooltipPosition:position,run:"click",};}
__exports.goToCheckout=goToCheckout;function goToCheckout(){return{content:'Checkout your order',trigger:'a[href^="/shop/checkout"]',run:'click',};}
__exports.confirmOrder=confirmOrder;function confirmOrder(){return{content:'Confirm',trigger:'a[href^="/shop/confirm_order"]',run:'click',};}
__exports.pay=pay;function pay(){return{content:'Pay',trigger:'button[name="o_payment_submit_button"]:visible:not(:disabled)',run:"click",};}
__exports.payWithDemo=payWithDemo;function payWithDemo(){return[{content:'eCommerce: select Test payment provider',trigger:'input[name="o_payment_radio"][data-payment-method-code="demo"]',run:"click",},{content:'eCommerce: add card number',trigger:'input[name="customer_input"]',run:"edit 4242424242424242",},pay(),{content:'eCommerce: check that the payment is successful',trigger:'.oe_website_sale_tx_status:contains("Your payment has been successfully processed.")',}]}
__exports.payWithTransfer=payWithTransfer;function payWithTransfer(redirect=false){const first_step={content:"Select `Wire Transfer` payment method",trigger:'input[name="o_payment_radio"][data-payment-method-code="wire_transfer"]',run:"click",}
if(!redirect){return[first_step,pay(),{content:"Last step",trigger:'.oe_website_sale_tx_status:contains("Please use the following transfer details")',timeout:30000,}]}else{return[first_step,pay(),{content:"Last step",trigger:'.oe_website_sale_tx_status:contains("Please use the following transfer details")',timeout:30000,run(){window.location.href='/contactus';},},{content:"wait page loaded",trigger:'h1:contains("Contact us")',}]}}
__exports.searchProduct=searchProduct;function searchProduct(productName){return[{content:"Search for the product",trigger:'form input[name="search"]',run:`edit ${productName}`,},clickOnElement('Search','form:has(input[name="search"]) .oe_search_button'),];}
__exports.selectPriceList=selectPriceList;function selectPriceList(pricelist){return[{content:"Click on pricelist dropdown",trigger:"div.o_pricelist_dropdown a[data-bs-toggle=dropdown]",run:"click",},{content:"Click on pricelist",trigger:`span:contains(${pricelist})`,run:"click",},];}
return __exports;});;

/* /website_sale/static/src/js/website_sale_video_field_preview.js */
odoo.define('@website_sale/js/website_sale_video_field_preview',['@web/core/registry','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Component}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const FieldVideoPreview=__exports.FieldVideoPreview=class FieldVideoPreview extends Component{static template="website_sale.FieldVideoPreview";static props={...standardFieldProps};}
const fieldVideoPreview=__exports.fieldVideoPreview={component:FieldVideoPreview,};registry.category("fields").add("video_preview",fieldVideoPreview);return __exports;});;

/* /website_sale/static/src/js/tours/website_sale_shop.js */
odoo.define('@website_sale/js/tours/website_sale_shop',['@web/core/l10n/translation','@website/js/tours/tour_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{insertSnippet,goBackToBlocks,registerWebsitePreviewTour,}=require('@website/js/tours/tour_utils');const{markup}=require("@odoo/owl");registerWebsitePreviewTour("test_01_admin_shop_tour",{url:'/shop',},()=>[{trigger:":iframe .js_sale",},{trigger:".o_menu_systray .o_new_content_container > a",content:_t("Let's create your first product."),tooltipPosition:"bottom",run:"click",},{trigger:"a[data-module-xml-id='base.module_website_sale']",content:markup(_t("Select <b>New Product</b> to create it and manage its properties to boost your sales.")),tooltipPosition:"bottom",run:"click",},{trigger:".modal-dialog input[type=text]",content:_t("Enter a name for your new product"),tooltipPosition:"left",run:"edit Test",},{trigger:".modal-footer button.btn-primary",content:markup(_t("Click on <em>Save</em> to create the product.")),tooltipPosition:"right",run:"click",},{trigger:"#oe_snippets.o_loaded",},{trigger:":iframe .product_price .oe_currency_value:visible",content:_t("Edit the price of this product by clicking on the amount."),tooltipPosition:"bottom",run:"editor 1.99",timeout:30000,},{trigger:":iframe .product_price .o_dirty .oe_currency_value:not(:contains(/^1.00$/))",},{trigger:":iframe #wrap img.product_detail_img",content:_t("Double click here to set an image describing your product."),tooltipPosition:"top",run:"dblclick",},{isActive:["auto"],trigger:".o_select_media_dialog .o_upload_media_button",content:_t("Upload a file from your local library."),tooltipPosition:"bottom",run:"click .modal-footer .btn-secondary",},goBackToBlocks(),{trigger:"body:not(.modal-open)",},...insertSnippet({id:"s_text_image",name:"Text - Image",groupName:"Content",}),{trigger:".o_we_external_history_buttons button.fa-undo:not([disabled])",},{trigger:"button[data-action=save]",content:markup(_t("Once you click on <b>Save</b>, your product is updated.")),tooltipPosition:"bottom",run:"click",},{trigger:":iframe body:not(.editor_enable)",},{trigger:".o_menu_systray_item.o_website_publish_container a",content:_t("Click on this button so your customers can see it."),tooltipPosition:"bottom",run:"click",},{trigger:"button[data-menu-xmlid='website.menu_reporting']",content:_t("Click here to open the reporting menu"),tooltipPosition:"bottom",run:"click",},{trigger:"a[data-menu-xmlid='website.menu_website_dashboard'], a[data-menu-xmlid='website.menu_website_analytics']",content:_t("Let's now take a look at your eCommerce dashboard to get your eCommerce website ready in no time."),tooltipPosition:"bottom",}]);return __exports;});;

/* /mass_mailing/static/src/js/mailing_m2o_filter.js */
odoo.define('@mass_mailing/js/mailing_m2o_filter',['@web/core/l10n/translation','@web/core/domain','@web/core/registry','@web/core/dropdown/dropdown','@web/core/utils/hooks','@web/views/fields/many2one/many2one_field','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Domain}=require('@web/core/domain');const{registry}=require('@web/core/registry');const{Dropdown}=require("@web/core/dropdown/dropdown");const{useService}=require("@web/core/utils/hooks");const{Many2OneField,many2OneField}=require('@web/views/fields/many2one/many2one_field');const{useState,useEffect}=require("@odoo/owl");const MailingFilterDropdown=__exports.MailingFilterDropdown=class MailingFilterDropdown extends Dropdown{setup(){super.setup();useEffect((inputFilterEl)=>{if(inputFilterEl){inputFilterEl.focus();}},()=>[document.querySelector('.o_mass_mailing_filter_name')]);}}
const FieldMany2OneMailingFilter=__exports.FieldMany2OneMailingFilter=class FieldMany2OneMailingFilter extends Many2OneField{static template="mass_mailing.MailingFilter";static components={...Many2OneField.components,MailingFilterDropdown,};static props={...Many2OneField.props,domain_field:{type:String,optional:true},model_field:{type:String,optional:true},};static defaultProps={...Many2OneField.defaultProps,domain_field:"mailing_domain",model_field:"mailing_model_id",};setup(){super.setup();this.notification=useService("notification");this.filter=useState({canSaveFilter:false,});useEffect(()=>this._updateFilterIcons());}
_updateFilterIcons(){const el=document.querySelector('.o_mass_mailing_filter_container');if(!el||this.props.readonly){return;}
const filterCount=this.props.record.data.mailing_filter_count;const dropdown=document.querySelector('.o_field_mailing_filter > .o_field_many2one_selection > .o_input_dropdown')
if(dropdown){dropdown.classList.toggle('d-none',!filterCount);}
let recordDomain;let filterDomain;try{recordDomain=new Domain(this.props.record.data[this.props.domain_field]||[]).toString();filterDomain=new Domain(this.props.record.data.mailing_filter_domain||[]).toString();}catch{this.filter.canSaveFilter=false;this.filter.canRemoveFilter=false;return;}
const modelFieldElement=this.props.model_field&&document.querySelector(`input#${this.props.model_field},div [name="${this.props.model_field}"]`);let value="";if(modelFieldElement&&modelFieldElement.tagName==="span"){value=modelFieldElement.textContent;}else if(modelFieldElement&&modelFieldElement.tagName==="input"){value=modelFieldElement.value;}
el.classList.toggle('d-none',recordDomain==='[]');this.filter.canSaveFilter=!this.props.record.data.mailing_filter_id||value.length||this.state.isFloating||filterDomain!==recordDomain;this.filter.canRemoveFilter=!this.filter.canSaveFilter}
onFilterNameInputKeydown(ev){const btnSave=document.querySelector('.o_mass_mailing_btn_save_filter');if(ev.key==='Tab'){ev.preventDefault();btnSave.focus();}else if(ev.key==='Enter'){btnSave.click();}}
async onRemoveFilter(ev){const filterId=this.props.record.data.mailing_filter_id[0];const mailingDomain=this.props.record.data[this.props.domain_field];ev.target.disabled=true;await this.orm.unlink('mailing.filter',[filterId]);this.update(false);this.props.record.update({[this.props.domain_field]:mailingDomain});}
async onSaveFilter(ev){const filterInput=document.querySelector('input.o_mass_mailing_filter_name');const filterName=filterInput.value.trim();if(filterName.length===0){this.notification.add(_t("Please provide a name for the filter"),{type:'danger'});ev.stopPropagation();filterInput.focus();}else{const[newFilterId]=await this.env.model.orm.create("mailing.filter",[{name:filterName,mailing_domain:this.props.record.data[this.props.domain_field],mailing_model_id:this.props.record.data[this.props.model_field][0],}]);this.update([{id:newFilterId,name:filterName}]);}}}
const fieldMany2OneMailingFilter=__exports.fieldMany2OneMailingFilter={...many2OneField,component:FieldMany2OneMailingFilter,supportedOptions:[...many2OneField.supportedOptions,{label:_t("Domain field"),name:"domain_field",type:"field",availableTypes:["char"]},{label:_t("Model field"),name:"model_field",type:"field",availableTypes:["char"]}],extractProps({options}){const props=many2OneField.extractProps(...arguments);props.domain_field=options.domain_field;props.model_field=options.model_field;return props;},};registry.category("fields").add("mailing_filter",fieldMany2OneMailingFilter);return __exports;});;

/* /mass_mailing/static/src/js/mass_mailing_design_constants.js */
odoo.define('@mass_mailing/js/mass_mailing_design_constants',[],function(require){'use strict';let __exports={};const CSS_PREFIX=__exports.CSS_PREFIX='.o_mail_wrapper';const BTN_SIZE_STYLES=__exports.BTN_SIZE_STYLES={'btn-sm':{'padding':'3px 7.5px','font-size':'0.875rem','line-height':'1.5rem',},'btn-lg':{'padding':'7px 14px','font-size':'1.25rem','line-height':'1.5rem',},'btn-md':{'padding':false,'font-size':'14px','line-height':false,},};const DEFAULT_BUTTON_SIZE=__exports.DEFAULT_BUTTON_SIZE='btn-md';const PRIORITY_STYLES=__exports.PRIORITY_STYLES={'h1':['font-family'],'h2':['font-family'],'h3':['font-family'],'p':['font-family'],'a:not(.btn)':[],'a.btn.btn-primary':[],'a.btn.btn-secondary':[],'hr':['border-top-width','border-top-style','border-top-color'],};const RE_CSS_TEXT_MATCH=__exports.RE_CSS_TEXT_MATCH=/([^{]+)([^}]+)/;const RE_SELECTOR_ENDS_WITH_GT_STAR=__exports.RE_SELECTOR_ENDS_WITH_GT_STAR=/>\s*\*\s*$/;const transformFontFamilySelector=__exports.transformFontFamilySelector=selector=>{if(selector.trim().endsWith(':not(.fa)')){return[selector];}
if(!selector.endsWith('*')){return[`${selector.trim()}:not(.fa)`,`${selector.trim()} :not(.fa)`];}else if(RE_SELECTOR_ENDS_WITH_GT_STAR.test(selector)){return[`${selector.replace(RE_SELECTOR_ENDS_WITH_GT_STAR, '').trim()} :not(.fa)`];}}
const splitCss=__exports.splitCss=css=>{const styleElement=document.createElement('style');styleElement.textContent=css;document.head.appendChild(styleElement);const rules=[...styleElement.sheet.cssRules];styleElement.remove();const stylesToWrite={};for(const rule of rules){const styles=rule.style;for(let selector of rule.selectorText.split(',')){if(!selector.trim().startsWith(CSS_PREFIX)){selector=`${CSS_PREFIX} ${selector.trim()}`;}
for(const style of rule.style){let selectors=[selector];if(style==='font-family'){selectors=transformFontFamilySelector(selector);}
for(const selectorToWriteTo of selectors){if(!stylesToWrite[selectorToWriteTo]){stylesToWrite[selectorToWriteTo]=[];}
stylesToWrite[selectorToWriteTo].push([style,styles[style]+(styles.getPropertyPriority(style)==='important'?' !important':'')]);}}}}
return Object.entries(stylesToWrite).map(([selector,styles])=>(`${selector.trim()} {\n${styles.map(([styleName, style]) => `${styleName}:${style};`).join('\n')}\n}`)).join('\n');};const getFontName=__exports.getFontName=fontFamily=>fontFamily.split(',')[0].replace(/"/g,'').replace(/([a-z])([A-Z])/g,(v,a,b)=>`${a} ${b}`).trim();const normalizeFontFamily=__exports.normalizeFontFamily=fontFamily=>fontFamily.replace(/"/g,'').replace(/, /g,',');const initializeDesignTabCss=__exports.initializeDesignTabCss=$editable=>{let styleElement=$editable.get(0).ownerDocument.querySelector('#design-element');if(styleElement){styleElement.textContent=splitCss(styleElement.textContent);}else{styleElement=document.createElement('style');styleElement.setAttribute('id','design-element');}
$editable.find('.o_layout').prepend(styleElement);};const FONT_FAMILIES=__exports.FONT_FAMILIES=['Arial, "Helvetica Neue", Helvetica, sans-serif','"Courier New", Courier, "Lucida Sans Typewriter", "Lucida Typewriter", monospace','Georgia, Times, "Times New Roman", serif','"Helvetica Neue", Helvetica, Arial, sans-serif','"Lucida Grande", "Lucida Sans Unicode", "Lucida Sans", Geneva, Verdana, sans-serif','Tahoma, Verdana, Segoe, sans-serif','TimesNewRoman, "Times New Roman", Times, Baskerville, Georgia, serif','"Trebuchet MS", "Lucida Grande", "Lucida Sans Unicode", "Lucida Sans", Tahoma, sans-serif','Verdana, Geneva, sans-serif',].map(fontFamily=>normalizeFontFamily(fontFamily));__exports[Symbol.for("default")]={CSS_PREFIX,BTN_SIZE_STYLES,DEFAULT_BUTTON_SIZE,PRIORITY_STYLES,RE_CSS_TEXT_MATCH,FONT_FAMILIES,RE_SELECTOR_ENDS_WITH_GT_STAR,splitCss,getFontName,normalizeFontFamily,initializeDesignTabCss,transformFontFamilySelector,}
return __exports;});;

/* /mass_mailing/static/src/js/mass_mailing_mobile_preview.js */
odoo.define('@mass_mailing/js/mass_mailing_mobile_preview',['@odoo/owl','@web/core/dialog/dialog','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{Component,markup,useEffect,useRef}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{escape}=require("@web/core/utils/strings");const MassMailingMobilePreviewDialog=__exports.MassMailingMobilePreviewDialog=class MassMailingMobilePreviewDialog extends Component{static components={Dialog,};static template="mass_mailing.MobilePreviewDialog";static props={title:{type:String},preview:{type:String},close:Function,};appendPreview(){const iframe=this.iframeRef.el.contentDocument;const body=iframe.querySelector("body");const isMarkup=this.props.preview instanceof markup().constructor;const safePreview=isMarkup?this.props.preview:escape(this.props.preview);body.innerHTML=safePreview;}
setup(){this.iframeRef=useRef("iframeRef");useEffect((modalEl)=>{if(modalEl){this.modalBody=modalEl.querySelector(".modal-body");modalEl.classList.add("o_mailing_mobile_preview");}},()=>[document.querySelector(":not(.o_inactive_modal).o_dialog")]);}
toggle(){this.modalBody.classList.toggle("o_invert_orientation");}}
delete MassMailingMobilePreviewDialog.props.slots;return __exports;});;

/* /mass_mailing/static/src/js/mass_mailing_html_field.js */
odoo.define('@mass_mailing/js/mass_mailing_html_field',['@web/core/registry','@web/core/l10n/translation','@web/model/relational_model/utils','@web/views/fields/standard_field_props','@mass_mailing/js/mass_mailing_design_constants','@web_editor/js/backend/convert_inline','@web/core/assets','@web/core/utils/render','@web/core/utils/hooks','@web_editor/js/backend/html_field','@web_editor/js/editor/odoo-editor/src/utils/utils','@web/core/ui/ui_service','@web/core/utils/scrolling','@web/core/utils/timing','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{useRecordObserver}=require("@web/model/relational_model/utils");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{initializeDesignTabCss}=require("@mass_mailing/js/mass_mailing_design_constants")
const{toInline}=require("@web_editor/js/backend/convert_inline");const{loadBundle}=require("@web/core/assets");const{renderToElement}=require("@web/core/utils/render");const{useService}=require("@web/core/utils/hooks");const{HtmlField,htmlField}=require("@web_editor/js/backend/html_field");const{getRangePosition}=require('@web_editor/js/editor/odoo-editor/src/utils/utils');const{utils:uiUtils}=require("@web/core/ui/ui_service");const{closestScrollableY}=require("@web/core/utils/scrolling");const{useThrottleForAnimation}=require("@web/core/utils/timing");const{onWillUnmount,onWillStart,reactive,status,useSubEnv}=require("@odoo/owl");const MassMailingHtmlField=__exports.MassMailingHtmlField=class MassMailingHtmlField extends HtmlField{static props={...standardFieldProps,...HtmlField.props,filterTemplates:{type:Boolean,optional:true},inlineField:{type:String,optional:true},iframeHtmlClass:{type:String,optional:true},}
setup(){super.setup();this.fieldConfig=reactive({selectedTheme:null,$scrollable:null,});useSubEnv({onWysiwygReset:this._resetIframe.bind(this),switchImages:this._switchImages.bind(this),fieldConfig:this.fieldConfig,});onWillStart(async()=>{const themesHTML=await this.orm.call("ir.ui.view","render_public_asset",["mass_mailing.email_designer_themes"]);this.themesEl=new DOMParser().parseFromString(themesHTML,"text/html").body;});this.action=useService('action');this.orm=useService('orm');this.dialog=useService('dialog');const onIframeUpdated=this.onIframeUpdated;this.onIframeUpdated=()=>{onIframeUpdated();this._updateIframe();};const throttledOnResizeObserved=useThrottleForAnimation(()=>{this._resizeMailingEditorIframe();this._repositionMailingEditorSidebar();});this._resizeObserver=new ResizeObserver(throttledOnResizeObserved);onWillUnmount(()=>{this._resizeObserver.disconnect();});useRecordObserver((record)=>{if("mailing_model_id"in record.data){this._onModelChange(record);}});}
get wysiwygOptions(){return{...super.wysiwygOptions,onIframeUpdated:()=>this.onIframeUpdated(),getCodeViewValue:(editableEl)=>this._getCodeViewValue(editableEl),snippets:'mass_mailing.email_designer_snippets',resizable:false,linkOptions:{...super.wysiwygOptions.linkOptions,initialIsNewWindow:true,},toolbarOptions:{...super.wysiwygOptions.toolbarOptions,dropDirection:'dropup',},onWysiwygBlur:()=>{this.commitChanges();this.wysiwyg.odooEditor.toolbarHide();},dropImageAsAttachment:false,useResponsiveFontSizes:false,...this.props.wysiwygOptions,};}
positionDynamicPlaceholder(popover,position){const editable=this.wysiwyg.$iframe?this.wysiwyg.$iframe[0]:this.wysiwyg.$editable[0];const relativeParentPosition=editable.getBoundingClientRect();let topPosition=relativeParentPosition.top;let leftPosition=relativeParentPosition.left;const rangePosition=getRangePosition(popover,this.wysiwyg.options.document);topPosition+=rangePosition.top;leftPosition+=rangePosition.left-14;popover.style.top=topPosition+'px';popover.style.left=leftPosition+'px';}
async commitChanges(...args){if(this.props.readonly||!this.isRendered){return super.commitChanges(...args);}
if(!this._isDirty()||this._pendingCommitChanges){return this._pendingCommitChanges;}
this._pendingCommitChanges=(async()=>{const codeViewEl=this._getCodeViewEl();if(codeViewEl){this.wysiwyg.setValue(this._getCodeViewValue(codeViewEl));}
if(this.wysiwyg.$iframeBody.find('.o_basic_theme').length){this.wysiwyg.$iframeBody.find('*').css('font-family','');}
const $editable=this.wysiwyg.getEditable();this.wysiwyg.odooEditor.historyPauseSteps();await this.wysiwyg.cleanForSave();if(args.length){await super.commitChanges({...args[0],urgent:true});}else{await super.commitChanges({urgent:true});}
const $editorEnable=$editable.closest('.editor_enable');$editorEnable.removeClass('editor_enable');this.wysiwyg.odooEditor.observerUnactive('toInline');const iframe=document.createElement('iframe');iframe.style.height='0px';iframe.style.visibility='hidden';iframe.setAttribute('sandbox','allow-same-origin');const clonedHtmlNode=$editable[0].closest('html').cloneNode(true);const clonedBody=clonedHtmlNode.querySelector('body');const clonedIframeTarget=clonedHtmlNode.querySelector('#iframe_target');clonedBody.replaceChildren(clonedIframeTarget);clonedHtmlNode.querySelectorAll('script').forEach(script=>script.remove());iframe.srcdoc=clonedHtmlNode.outerHTML;const iframePromise=new Promise((resolve)=>{iframe.addEventListener("load",resolve);});document.body.append(iframe);await iframePromise;const editableClone=iframe.contentDocument.querySelector('.note-editable');await toInline($(editableClone),{$iframe:$(iframe),wysiwyg:this.wysiwyg});iframe.remove();this.wysiwyg.odooEditor.observerActive('toInline');const inlineHtml=editableClone.innerHTML;$editorEnable.addClass('editor_enable');this.wysiwyg.odooEditor.historyUnpauseSteps();this.wysiwyg.odooEditor.historyRevertCurrentStep();const fieldName=this.props.inlineField;await this.props.record.update({[fieldName]:inlineHtml});this._pendingCommitChanges=false;})();return this._pendingCommitChanges;}
async startWysiwyg(...args){await super.startWysiwyg(...args);await loadBundle("mass_mailing.assets_wysiwyg");if(status(this)==="destroyed"){return;}
await this._resetIframe();}
_updateIframe(){const iframe=this.wysiwyg?.$iframe?.[0];if(!iframe||!iframe.contentDocument){return;}
const hasIframeChanged=!this.iframe||!this.iframe.contentDocument||iframe!==this.iframe;this.iframe=iframe;this._resizeMailingEditorIframe();const iframeTarget=this.iframe.contentDocument.querySelector("#iframe_target");if(hasIframeChanged&&iframeTarget){this._resizeObserver.disconnect();this._resizeObserver.observe(iframeTarget);}
if(iframeTarget){const isFullscreen=this._isFullScreen();iframeTarget.style.display=isFullscreen?"":"flex";iframeTarget.style.flexDirection=isFullscreen?"":"column";}}
_isFullScreen(){return window.top.document.body.classList.contains("o_field_widgetTextHtml_fullscreen");}
_resizeMailingEditorIframe(){if(!this.wysiwyg||!this.iframe){return;}
const minHeight=window.innerHeight-Math.abs(this.iframe.getBoundingClientRect().y);const themeSelectorNew=this.iframe.contentDocument.querySelector(".o_mail_theme_selector_new");const iframeTarget=this.iframe.contentDocument.querySelector("#iframe_target");const elementToResize=themeSelectorNew||iframeTarget;if(elementToResize){this.iframe.parentNode.style.height=`${this._isFullScreen()
                ? window.innerHeight
                : Math.max(elementToResize.scrollHeight, minHeight)}px`;}}
_repositionMailingEditorSidebar(){const sidebar=document.querySelector("#oe_snippets");if(!sidebar){return;}else if(this._isFullScreen()){sidebar.style.height="";sidebar.style.top="0";}else if(this.env.inDialog){const scrollableY=closestScrollableY(sidebar);if(scrollableY){const rect=scrollableY.getBoundingClientRect();sidebar.style.height=`${rect.height}px`;sidebar.style.top="0";}}else{const scrollableY=closestScrollableY(sidebar);const top=scrollableY?`${-1 * (parseInt(getComputedStyle(scrollableY).paddingTop) || 0)}px`:"0";const maxHeight=this.iframe.parentNode.getBoundingClientRect().height;const offsetHeight=window.innerHeight-document.querySelector(".o_content").getBoundingClientRect().y;sidebar.style.height=`${Math.min(maxHeight, offsetHeight)}px`;sidebar.style.top=top;}}
async _resetIframe(){if(this._switchingTheme){return;}
this.wysiwyg.$iframeBody.find('.o_mail_theme_selector_new').remove();await this._onSnippetsLoaded();this.wysiwyg.$iframeBody.find('.o_layout').addBack().data('name','Mailing');this.wysiwyg.$iframeBody.find('.odoo-editor-editable').removeClass('o_editable');initializeDesignTabCss(this.wysiwyg.getEditable());this.wysiwyg.getEditable().find('img').attr('loading','');this.wysiwyg.odooEditor.observerFlush();this.wysiwyg.odooEditor.historyReset();this.wysiwyg.$iframeBody.addClass('o_mass_mailing_iframe');this.onIframeUpdated();}
_onModelChange(record){this._hideIrrelevantTemplates(record);}
async _onSnippetsLoaded(){if(status(this)==='destroyed')return;if($(window.top.document).find('.o_mass_mailing_form_full_width')[0]){this.fieldConfig.$scrollable=$(closestScrollableY(this.wysiwyg.$el[0]));this.fieldConfig.$scrollable.css('overflow-y','scroll');}
const args=this.props.filterTemplates?[[['mailing_model_id','=',this.props.record.data.mailing_model_id[0]]]]:[];const result=await this.orm.call('mailing.mailing','action_fetch_favorites',args);if(status(this)==='destroyed')return;const templatesParams=result.map(values=>{return{id:values.id,modelId:values.mailing_model_id[0],modelName:values.mailing_model_id[1],name:`template_${values.id}`,nowrap:true,subject:values.subject,template:values.body_arch,userId:values.user_id[0],userName:values.user_id[1],};});const themesEls=this.themesEl.children;if(!this._themeParams){this._themeClassNames="";const displayableThemes=uiUtils.isSmall()?Array.from(themesEls).filter(theme=>!theme.dataset.hideFromMobile):themesEls;this._themeParams=Array.from(displayableThemes).map((theme)=>{const $theme=$(theme);const name=$theme.data("name");if(name==="training"){$theme.get(0).querySelector("div.oe_img_bg").classList.add("col-lg-12");}
const classname="o_"+name+"_theme";this._themeClassNames+=" "+classname;const imagesInfo=Object.assign({all:{}},$theme.data("imagesInfo")||{});for(const[key,info]of Object.entries(imagesInfo)){imagesInfo[key]=Object.assign({module:"mass_mailing",format:"jpg"},imagesInfo.all,info);}
return{name:name,title:$theme.attr("title")||"",className:classname||"",img:$theme.data("img")||"",template:$theme.html().trim(),nowrap:!!$theme.data('nowrap'),get_image_info:function(filename){if(imagesInfo[filename]){return imagesInfo[filename];}
return imagesInfo.all;},layoutStyles:$theme.data('layout-styles'),};});}
if(!this._themeParams.length){return;}
const themesParams=[...this._themeParams];const $themeSelectorNew=$(renderToElement("mass_mailing.theme_selector_new",{themes:themesParams,templates:templatesParams,modelName:this.props.record.data.mailing_model_id[1]||'',}));const $layout=this.wysiwyg.$iframeBody.find(".o_layout");let $mailWrapper=$layout.children(".o_mail_wrapper");let $mailWrapperContent=$mailWrapper.find('.o_mail_wrapper_td');if(!$mailWrapperContent.length){$mailWrapperContent=$mailWrapper;}
let value;if($mailWrapperContent.length>0){value=$mailWrapperContent.html();}else if($layout.length){value=$layout.html();}else{value=this.wysiwyg.getValue();}
let blankEditable="<p><br></p>";$themeSelectorNew.on('click','.dropdown-item',async(e)=>{e.preventDefault();e.stopImmediatePropagation();const themeName=$(e.currentTarget).attr('id');this.fieldConfig.selectedTheme=[...themesParams,...templatesParams].find(theme=>theme.name===themeName);await this._switchThemes(this.fieldConfig.selectedTheme);this.wysiwyg.$iframeBody.closest('body').removeClass("o_force_mail_theme_choice");$themeSelectorNew.remove();const isSnippetsFolded=uiUtils.isSmall()||themeName==='basic';this.wysiwyg.setSnippetsMenuFolded(isSnippetsFolded);const $editable=this.wysiwyg.$editable.find('.o_editable');this.$editorMessageElements=$editable.not('[data-editor-message]').attr('data-editor-message',_t('DRAG BUILDING BLOCKS HERE'));$editable.filter(':empty').attr('contenteditable',false);setTimeout(()=>{this.wysiwyg.historyReset();this.wysiwyg.odooEditor.dispatchEvent(new Event('historyStep'));const document=this.wysiwyg.odooEditor.document;const selection=document.getSelection();const p=this.wysiwyg.odooEditor.editable.querySelector('p');if(p&&selection){const range=document.createRange();range.setStart(p,0);range.setEnd(p,0);selection.removeAllRanges();selection.addRange(range);}
$editable.addClass('theme_selection_done');this.onIframeUpdated();},0);});$themeSelectorNew.on('click','.o_mail_template_preview i.o_mail_template_remove_favorite',async(ev)=>{ev.stopPropagation();ev.preventDefault();const $target=$(ev.currentTarget);const mailingId=$target.data('id');const action=await this.orm.call('mailing.mailing','action_remove_favorite',[mailingId]);this.action.doAction(action);$target.parents('.o_mail_template_preview').remove();});this.wysiwyg.$iframeBody.closest('body').removeClass(this._themeClassNames);this.fieldConfig.selectedTheme=this._getSelectedTheme(themesParams);if(this.fieldConfig.selectedTheme){this.wysiwyg.$iframeBody.closest('body').addClass(this.fieldConfig.selectedTheme.className);}else if(this.wysiwyg.$iframeBody.find('.o_layout').length){themesParams.push({name:'o_mass_mailing_no_theme',className:'o_mass_mailing_no_theme',img:"",template:this.wysiwyg.$iframeBody.find('.o_layout').addClass('o_mass_mailing_no_theme').clone().find('oe_structure').empty().end().html().trim(),nowrap:true,get_image_info:function(){}});this.fieldConfig.selectedTheme=this._getSelectedTheme(themesParams);}
this.wysiwyg.setSnippetsMenuFolded(uiUtils.isSmall()||(this.fieldConfig.selectedTheme&&this.fieldConfig.selectedTheme.name==='basic'));const editableAreaIsEmpty=value===""||value===blankEditable;if(editableAreaIsEmpty){this.wysiwyg.setSnippetsMenuFolded(false);this.wysiwyg.state.snippetsMenuFolded=true;$themeSelectorNew.appendTo(this.wysiwyg.$iframeBody);}
if(this.wysiwyg){this._hideIrrelevantTemplates(this.props.record);}
this.wysiwyg.odooEditor.activateContenteditable();}
_getCodeViewEl(){const codeView=this.wysiwyg&&this.wysiwyg.$iframe&&this.wysiwyg.$iframe.contents().find('textarea.o_codeview')[0];return codeView&&!codeView.classList.contains('d-none')&&codeView;}
_getCodeViewValue(codeViewEl){const editable=this.wysiwyg.$editable[0];const initialDropZone=editable.querySelector('.o_mail_wrapper_td');if(initialDropZone){const parsedHtml=new DOMParser().parseFromString(codeViewEl.value,"text/html");if(!parsedHtml.querySelector('.o_mail_wrapper_td')){initialDropZone.replaceChildren(...parsedHtml.body.childNodes);return editable.innerHTML;}}
return codeViewEl.value;}
_hideIrrelevantTemplates(record){if(!this.wysiwyg){return;}
const iframeContent=this.wysiwyg.$iframe.contents();const mailing_model_id=record.data.mailing_model_id[0];iframeContent.find(`.o_mail_template_preview[model-id!="${mailing_model_id}"]`).addClass('d-none').removeClass('d-inline-block');const sameModelTemplates=iframeContent.find(`.o_mail_template_preview[model-id="${mailing_model_id}"]`);sameModelTemplates.removeClass('d-none').addClass('d-inline-block');if(sameModelTemplates.length){iframeContent.find('.o_mailing_template_message').addClass('d-none');iframeContent.find('.o_mailing_template_preview_wrapper').removeClass('d-none');}else{iframeContent.find('.o_mailing_template_message').removeClass('d-none');iframeContent.find('.o_mailing_template_message span').text(record.data.mailing_model_id[1]);iframeContent.find('.o_mailing_template_preview_wrapper').addClass('d-none');}}
_getSelectedTheme(themesParams){const $layout=this.wysiwyg.$iframeBody.find(".o_layout");let selectedTheme=false;if($layout.length!==0){themesParams.forEach((themeParams)=>{if($layout.hasClass(themeParams.className)){selectedTheme=themeParams;}});}
return selectedTheme;}
_switchImages(themeParams,$container){if(!themeParams){return;}
for(const img of $container.find("img")){const $img=$(img);const src=$img.attr("src");$img.removeAttr('loading');let m=src.match(/^\/web\/image\/\w+\.s_default_image_(?:theme_[a-z]+_)?(.+)$/);if(!m){m=src.match(/^\/\w+\/static\/src\/img\/(?:theme_[a-z]+\/)?s_default_image_(.+)\.[a-z]+$/);}
if(!m){return;}
if(themeParams.get_image_info){const file=m[1];const imgInfo=themeParams.get_image_info(file);const src=imgInfo.format?`/${imgInfo.module}/static/src/img/theme_${themeParams.name}/s_default_image_${file}.${imgInfo.format}`:`/web/image/${imgInfo.module}.s_default_image_theme_${themeParams.name}_${file}`;$img.attr('src',src);}}}
async _switchThemes(themeParams){if(!themeParams||this.switchThemeLast===themeParams){return;}
this.switchThemeLast=themeParams;this.wysiwyg.$iframeBody.closest('body').removeClass(this._themeClassNames).addClass(themeParams.className);const old_layout=this.wysiwyg.$editable.find('.o_layout')[0];let $newWrapper;let $newWrapperContent;if(themeParams.nowrap){$newWrapper=$('<div/>',{class:'oe_structure'});$newWrapperContent=$newWrapper;}else{$newWrapper=$('<div/>',{class:'container o_mail_wrapper o_mail_regular oe_unremovable',});$newWrapperContent=$('<div/>',{class:'col o_mail_no_options o_mail_wrapper_td bg-white oe_structure o_editable'});$newWrapper.append($('<div class="row"/>').append($newWrapperContent));}
const $newLayout=$('<div/>',{class:'o_layout oe_unremovable oe_unmovable bg-200 '+themeParams.className,style:themeParams.layoutStyles,'data-name':'Mailing',}).append($newWrapper);const $contents=themeParams.template;$newWrapperContent.append($contents);this._switchImages(themeParams,$newWrapperContent);old_layout&&old_layout.remove();this.wysiwyg.odooEditor.resetContent($newLayout[0].outerHTML);$newWrapperContent.find('*').addBack().contents().filter(function(){return this.nodeType===3&&this.textContent.match(/\S/);}).parent().addClass('o_default_snippet_text');if(themeParams.name==='basic'){this.wysiwyg.$editable[0].focus();}
initializeDesignTabCss(this.wysiwyg.$editable);this.onIframeUpdated();this.wysiwyg.odooEditor.historyStep(true);this._switchingTheme=true;await this.commitChanges();this._switchingTheme=false;}
async _setupReadonlyIframe(){if(!this.props.record.data[this.props.name].length){this.props.record.data[this.props.name]=this.props.record.data.body_html;}
await super._setupReadonlyIframe();}
async _lazyloadWysiwyg(){await super._lazyloadWysiwyg(...arguments);const wysiwygModule=await odoo.loader.modules.get('@mass_mailing/js/mass_mailing_wysiwyg');this.Wysiwyg=wysiwygModule.MassMailingWysiwyg;}}
const massMailingHtmlField=__exports.massMailingHtmlField={...htmlField,component:MassMailingHtmlField,displayName:_t("Email"),supportedOptions:[...htmlField.supportedOptions,{label:_t("Filter templates"),name:"filterTemplates",type:"boolean"},{label:_t("Inline field"),name:"inline-field",type:"field"}],extractProps({attrs,options}){const props=htmlField.extractProps(...arguments);props.filterTemplates=options.filterTemplates;props.inlineField=options['inline-field'];props.iframeHtmlClass=attrs.iframeHtmlClass;return props;},fieldDependencies:[{name:'body_html',type:'html',readonly:'false'}],};registry.category("fields").add("mass_mailing_html",massMailingHtmlField);return __exports;});;

/* /mass_mailing/static/src/js/tours/mass_mailing_tour.js */
odoo.define('@mass_mailing/js/tours/mass_mailing_tour',['@web/core/registry','@web_tour/tour_service/tour_utils','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{stepUtils}=require("@web_tour/tour_service/tour_utils");const{_t}=require("@web/core/l10n/translation");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add('mass_mailing_tour',{url:'/odoo',steps:()=>[stepUtils.showAppsMenuItem(),{isActive:["enterprise"],trigger:'.o_app[data-menu-xmlid="mass_mailing.mass_mailing_menu_root"]',content:_t("Let's try the Email Marketing app."),tooltipPosition:'bottom',run:"click",},{isActive:["community"],trigger:'.o_app[data-menu-xmlid="mass_mailing.mass_mailing_menu_root"]',content:_t("Let's try the Email Marketing app."),run:"click",},{trigger:".o_mass_mailing_mailing_tree",},{trigger:'.o_list_button_add',content:markup(_t("Start by creating your first <b>Mailing</b>.")),tooltipPosition:'bottom',run:"click",},{trigger:'div[name="subject"]',content:markup(_t('Pick the <b>email subject</b>.')),tooltipPosition:'bottom',run:'click',},{isActive:["auto"],trigger:'div[name="contact_list_ids"] > .o_input_dropdown > input[type="text"]',run:'click',},{isActive:["auto"],trigger:'li.ui-menu-item',run:'click',},{isActive:["enterprise"],trigger:'div[name="body_arch"] :iframe #newsletter',content:markup(_t('Choose this <b>theme</b>.')),tooltipPosition:'left',run:'click',},{isActive:["community"],trigger:'div[name="body_arch"] :iframe #default',content:markup(_t('Choose this <b>theme</b>.')),tooltipPosition:'right',run:'click',},{isActive:["enterprise"],trigger:'div[name="body_arch"] :iframe div.theme_selection_done div.s_text_block',content:_t('Click on this paragraph to edit it.'),tooltipPosition:'top',run:'click',},{isActive:["community"],trigger:'div[name="body_arch"] :iframe div.o_mail_block_title_text',content:_t('Click on this paragraph to edit it.'),tooltipPosition:'top',run:'click',},{trigger:'button[name="action_set_favorite"]',content:_t('Click on this button to add this mailing to your templates.'),tooltipPosition:'bottom',run:'click',},{trigger:'button[name="action_test"]',content:_t("Test this mailing by sending a copy to yourself."),tooltipPosition:'bottom',run:"click",},{trigger:'button[name="send_mail_test"]',content:_t("Check the email address and click send."),tooltipPosition:'bottom',run:"click",},{trigger:'button[name="action_launch"]',content:_t("Ready for take-off!"),tooltipPosition:'bottom',run:"click",},{trigger:'.btn-primary:contains("Send to all")',content:_t("Don't worry, the mailing contact we created is an internal user."),tooltipPosition:'bottom',run:"click",},{trigger:'.o_back_button',content:markup(_t("By using the <b>Breadcrumb</b>, you can navigate back to the overview.")),tooltipPosition:'bottom',run:'click',}]});return __exports;});;

/* /project_enterprise/static/src/views/project_highlight_tasks.js */
odoo.define('@project_enterprise/views/project_highlight_tasks',['@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");__exports.useProjectModelActions=useProjectModelActions;function useProjectModelActions({getContext,getHighlightPlannedIds}){const orm=useService("orm");return{async getHighlightIds(){const context=getContext();if(!context||(!context.highlight_conflicting_task&&!context.highlight_planned)){return;}
if(context.highlight_conflicting_task){const highlightConflictingIds=await orm.search("project.task",[["planning_overlap","!=",false],]);if(context.highlight_planned){return Array.from(new Set([...highlightConflictingIds,...getHighlightPlannedIds()]));}
return highlightConflictingIds;}
return getHighlightPlannedIds()||[];},};}
return __exports;});;

/* /project_enterprise/static/src/views/project_task_search_model.js */
odoo.define('@project_enterprise/views/project_task_search_model',['@web/search/search_model'],function(require){'use strict';let __exports={};const{SearchModel}=require("@web/search/search_model");const ProjectTaskSearchModel=__exports.ProjectTaskSearchModel=class ProjectTaskSearchModel extends SearchModel{exportState(){return{...super.exportState(),highlightPlannedIds:this.highlightPlannedIds,};}
_importState(state){this.highlightPlannedIds=state.highlightPlannedIds;super._importState(state);}
deactivateGroup(groupId){if(this._getHighlightPlannedSearchItems()?.groupId===groupId){this.highlightPlannedIds=null;}
super.deactivateGroup(groupId);}
toggleHighlightPlannedFilter(highlightPlannedIds){const highlightPlannedSearchItems=this._getHighlightPlannedSearchItems();if(highlightPlannedIds){this.highlightPlannedIds=highlightPlannedIds;if(highlightPlannedSearchItems){if(this.query.find((queryElem)=>queryElem.searchItemId===highlightPlannedSearchItems.id)){this._notify();}else{this.toggleSearchItem(highlightPlannedSearchItems.id);}}}else if(highlightPlannedSearchItems){this.deactivateGroup(highlightPlannedSearchItems.groupId);}}
_getHighlightPlannedSearchItems(){return Object.values(this.searchItems).find((v)=>v.name==="tasks_scheduled");}}
return __exports;});;

/* /project_enterprise/static/src/views/highlight_project_task_search_model.js */
odoo.define('@project_enterprise/views/highlight_project_task_search_model',['@project_enterprise/views/project_task_search_model','@web/core/domain'],function(require){'use strict';let __exports={};const{ProjectTaskSearchModel}=require("@project_enterprise/views/project_task_search_model");const{Domain}=require("@web/core/domain");const HighlightProjectTaskSearchModel=__exports.HighlightProjectTaskSearchModel=class HighlightProjectTaskSearchModel extends ProjectTaskSearchModel{_getDomain(params={}){let domain=super._getDomain(params);if(this.highlightPlannedIds?.length){domain=Domain.and([domain,[["id","in",this.highlightPlannedIds]]]);domain=params.raw?domain:domain.toList();}
return domain;}
async load(config){await super.load(config);if(this.context&&this.context.highlight_conflicting_task){this.highlightPlannedIds=await this.orm.search("project.task",[["planning_overlap","!=",false],]);}}}
return __exports;});;

/* /project_enterprise/static/src/components/project_right_side_panel/components/project_right_side_panel_section.js */
odoo.define('@project_enterprise/components/project_right_side_panel/components/project_right_side_panel_section',['@web/core/utils/hooks','@web/core/utils/patch','@project/components/project_right_side_panel/components/project_right_side_panel_section','@odoo/owl'],function(require){'use strict';let __exports={};const{useBus,useService}=require('@web/core/utils/hooks');const{patch}=require("@web/core/utils/patch");const{ProjectRightSidePanelSection}=require('@project/components/project_right_side_panel/components/project_right_side_panel_section');const{useState}=require("@odoo/owl");patch(ProjectRightSidePanelSection.prototype,{setup(){this.state=useState({isClosed:!!this.env.isSmall&&this.props.canBeClosed});this.ui=useService('ui');useBus(this.ui.bus,"resize",this.setDefaultIsClosed);},setDefaultIsClosed(){this.state.isClosed=this.ui.isSmall&&this.props.canBeClosed;},toggleSection(){if(!this.env.isSmall||!this.props.canBeClosed){this.state.isClosed=false;}else{this.state.isClosed=!this.state.isClosed;}}});ProjectRightSidePanelSection.props.canBeClosed={type:Boolean,optional:true};ProjectRightSidePanelSection.defaultProps.canBeClosed=true;return __exports;});;

/* /project_enterprise/static/src/views/project_task_calendar/common/project_task_calendar_common_renderer.js */
odoo.define('@project_enterprise/views/project_task_calendar/common/project_task_calendar_common_renderer',['@web/views/calendar/calendar_common/calendar_common_renderer'],function(require){'use strict';let __exports={};const{CalendarCommonRenderer}=require("@web/views/calendar/calendar_common/calendar_common_renderer");const ProjectTaskCalendarCommonRenderer=__exports.ProjectTaskCalendarCommonRenderer=class ProjectTaskCalendarCommonRenderer extends CalendarCommonRenderer{eventClassNames(info){const classesToAdd=super.eventClassNames(info);const{event}=info;const highlightIds=this.env.searchModel.highlightPlannedIds;const record=this.props.model.records[event.id];if(record&&highlightIds?.length&&!highlightIds.includes(record.id)){classesToAdd.push("opacity-25");}
return classesToAdd;}}
return __exports;});;

/* /project_enterprise/static/src/views/project_task_calendar/project_task_calendar_model.js */
odoo.define('@project_enterprise/views/project_task_calendar/project_task_calendar_model',['@web/core/l10n/dates','@project/views/project_task_calendar/project_task_calendar_model','@project_enterprise/views/project_highlight_tasks'],function(require){'use strict';let __exports={};const{deserializeDate}=require("@web/core/l10n/dates");const{ProjectTaskCalendarModel}=require("@project/views/project_task_calendar/project_task_calendar_model");const{useProjectModelActions}=require("@project_enterprise/views/project_highlight_tasks");const ProjectEnterpriseTaskCalendarModel=__exports.ProjectEnterpriseTaskCalendarModel=class ProjectEnterpriseTaskCalendarModel extends ProjectTaskCalendarModel{setup(){super.setup(...arguments);this.getHighlightIds=useProjectModelActions({getContext:()=>this.env.searchModel._context,getHighlightPlannedIds:()=>this.env.searchModel.highlightPlannedIds,}).getHighlightIds;}
async loadRecords(data){this.highlightIds=await this.getHighlightIds();return await super.loadRecords(data);}
makeContextDefaults(record){const{default_planned_date_start,...context}=super.makeContextDefaults(record);if(["day","week"].includes(this.meta.scale)||!deserializeDate(default_planned_date_start).hasSame(deserializeDate(context["default_date_deadline"]),"day")){context.default_planned_date_begin=default_planned_date_start;}
return{...context,scale:this.meta.scale};}}
return __exports;});;

/* /project_enterprise/static/src/views/project_task_calendar/project_task_calendar_renderer.js */
odoo.define('@project_enterprise/views/project_task_calendar/project_task_calendar_renderer',['@web/views/calendar/calendar_renderer','@project_enterprise/views/project_task_calendar/common/project_task_calendar_common_renderer'],function(require){'use strict';let __exports={};const{CalendarRenderer}=require("@web/views/calendar/calendar_renderer");const{ProjectTaskCalendarCommonRenderer}=require("@project_enterprise/views/project_task_calendar/common/project_task_calendar_common_renderer");const ProjectTaskCalendarRenderer=__exports.ProjectTaskCalendarRenderer=class ProjectTaskCalendarRenderer extends CalendarRenderer{static components={...CalendarRenderer.components,day:ProjectTaskCalendarCommonRenderer,week:ProjectTaskCalendarCommonRenderer,month:ProjectTaskCalendarCommonRenderer,};}
return __exports;});;

/* /project_enterprise/static/src/views/project_task_calendar/project_task_calendar_view.js */
odoo.define('@project_enterprise/views/project_task_calendar/project_task_calendar_view',['@web/core/registry','@project/views/project_task_calendar/project_task_calendar_view','@project_enterprise/views/project_task_calendar/project_task_calendar_model','@project_enterprise/views/project_task_calendar/project_task_calendar_renderer','@project_enterprise/views/project_task_search_model'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{projectTaskCalendarView}=require("@project/views/project_task_calendar/project_task_calendar_view");const{ProjectEnterpriseTaskCalendarModel}=require("@project_enterprise/views/project_task_calendar/project_task_calendar_model");const{ProjectTaskCalendarRenderer}=require("@project_enterprise/views/project_task_calendar/project_task_calendar_renderer");const{ProjectTaskSearchModel}=require("@project_enterprise/views/project_task_search_model");const projectEnterpriseTaskCalendarView=__exports.projectEnterpriseTaskCalendarView={...projectTaskCalendarView,Model:ProjectEnterpriseTaskCalendarModel,Renderer:ProjectTaskCalendarRenderer,SearchModel:ProjectTaskSearchModel,};registry.category("views").add("project_enterprise_task_calendar",projectEnterpriseTaskCalendarView);return __exports;});;

/* /project_enterprise/static/src/views/project_task_tree/project_task_list_view.js */
odoo.define('@project_enterprise/views/project_task_tree/project_task_list_view',['@project/views/project_task_list/project_task_list_view','@web/core/registry','@project_enterprise/views/highlight_project_task_search_model'],function(require){'use strict';let __exports={};const{projectTaskListView}=require("@project/views/project_task_list/project_task_list_view");const{registry}=require("@web/core/registry");const{HighlightProjectTaskSearchModel}=require("@project_enterprise/views/highlight_project_task_search_model");const projectEnterpriseTaskListView=__exports.projectEnterpriseTaskListView={...projectTaskListView,SearchModel:HighlightProjectTaskSearchModel,};registry.category("views").add("project_enterprise_task_list",projectEnterpriseTaskListView);return __exports;});;

/* /project_enterprise/static/src/views/project_task_kanban/project_task_kanban_view.js */
odoo.define('@project_enterprise/views/project_task_kanban/project_task_kanban_view',['@web/core/registry','@project/views/project_task_kanban/project_task_kanban_view','@project_enterprise/views/highlight_project_task_search_model'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{projectTaskKanbanView}=require("@project/views/project_task_kanban/project_task_kanban_view");const{HighlightProjectTaskSearchModel}=require("@project_enterprise/views/highlight_project_task_search_model");registry.category("views").add("project_enterprise_task_kanban",{...projectTaskKanbanView,SearchModel:HighlightProjectTaskSearchModel,});return __exports;});;

/* /project_enterprise/static/src/views/view_dialogs/select_auto_plan_create_dialog.js */
odoo.define('@project_enterprise/views/view_dialogs/select_auto_plan_create_dialog',['@web/views/view_dialogs/select_create_dialog'],function(require){'use strict';let __exports={};const{SelectCreateDialog}=require("@web/views/view_dialogs/select_create_dialog")
const SelectCreateAutoPlanDialog=__exports.SelectCreateAutoPlanDialog=class SelectCreateAutoPlanDialog extends SelectCreateDialog{static template="project_enterprise.SelectCreateAutoPlanDialog";static props={...SelectCreateDialog.props,onSelectedNoSmartSchedule:{type:Function},}
select(resIds){if(this.props.onSelectedNoSmartSchedule){this.executeOnceAndClose(()=>this.props.onSelectedNoSmartSchedule(resIds));}}
selectWithSmartSchedule(resIds){if(this.props.onSelected){this.executeOnceAndClose(()=>this.props.onSelected(resIds));}}}
return __exports;});;

/* /resource_mail/static/src/components/avatar_card_resource/avatar_card_resource_popover.js */
odoo.define('@resource_mail/components/avatar_card_resource/avatar_card_resource_popover',['@odoo/owl','@web/core/utils/hooks','@mail/core/web/open_chat_hook','@mail/discuss/web/avatar_card/avatar_card_popover'],function(require){'use strict';let __exports={};const{onWillStart}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{useOpenChat}=require("@mail/core/web/open_chat_hook");const{AvatarCardPopover}=require("@mail/discuss/web/avatar_card/avatar_card_popover");const AvatarCardResourcePopover=__exports.AvatarCardResourcePopover=class AvatarCardResourcePopover extends AvatarCardPopover{static template="resource_mail.AvatarCardResourcePopover";static props={...AvatarCardPopover.props,recordModel:{type:String,optional:true,},};static defaultProps={...AvatarCardPopover.defaultProps,recordModel:"resource.resource",};setup(){this.orm=useService("orm");this.actionService=useService("action");this.openChat=useOpenChat("res.users");onWillStart(this.onWillStart);}
async onWillStart(){[this.record]=await this.orm.call('resource.resource','get_avatar_card_data',[[this.props.id],this.fieldNames],{});await Promise.all(this.loadAdditionalData());}
loadAdditionalData(){return[];}
get fieldNames(){const excludedFields=new Set(["partner_id"]);return super.fieldNames.concat(["user_id","resource_type"]).filter((field)=>!excludedFields.has(field));}
get email(){return this.record.email;}
get phone(){return this.record.phone;}
get displayAvatar(){return this.record.user_id?.length;}
get showViewProfileBtn(){return false;}
get userId(){return this.record.user_id[0];}}
return __exports;});;

/* /resource_mail/static/src/views/fields/many2many_avatar_resource/many2many_avatar_resource_field.js */
odoo.define('@resource_mail/views/fields/many2many_avatar_resource/many2many_avatar_resource_field',['@web/core/registry','@web/core/popover/popover_hook','@mail/views/web/fields/many2many_avatar_user_field/many2many_avatar_user_field','@web/views/fields/relational_utils','@resource_mail/components/avatar_card_resource/avatar_card_resource_popover','@web/core/domain'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{usePopover}=require("@web/core/popover/popover_hook");const{Many2ManyTagsAvatarUserField,many2ManyTagsAvatarUserField,Many2ManyAvatarUserTagsList,}=require("@mail/views/web/fields/many2many_avatar_user_field/many2many_avatar_user_field");const{AvatarMany2XAutocomplete}=require("@web/views/fields/relational_utils");const{AvatarCardResourcePopover}=require("@resource_mail/components/avatar_card_resource/avatar_card_resource_popover");const{Domain}=require("@web/core/domain");const AvatarResourceMany2XAutocomplete=__exports.AvatarResourceMany2XAutocomplete=class AvatarResourceMany2XAutocomplete extends AvatarMany2XAutocomplete{get optionsSource(){return{...super.optionsSource,optionTemplate:"resource_mail.AvatarResourceMany2XAutocomplete",};}
search(request){return this.orm.call(this.props.resModel,"search_read",[this.getDomain(request),["id","display_name","resource_type","color"]],{context:this.props.context,limit:this.props.searchLimit+1,});}
getDomain(request){return Domain.and([[["name","ilike",request]],this.props.getDomain()]).toList(this.props.context);}
mapRecordToOption(result){return{resModel:this.props.resModel,value:result.id,resourceType:result.resource_type,label:result.display_name,color:result.color,};}}
class Many2ManyAvatarResourceTagsList extends Many2ManyAvatarUserTagsList{static template="resource_mail.Many2ManyAvatarResourceTagsList";}
const Many2ManyAvatarResourceField=__exports.Many2ManyAvatarResourceField=class Many2ManyAvatarResourceField extends Many2ManyTagsAvatarUserField{setup(){super.setup(...arguments);if(this.relation=="resource.resource"){this.avatarCard=usePopover(AvatarCardResourcePopover);}}
static components={...super.components,Many2XAutocomplete:AvatarResourceMany2XAutocomplete,TagsList:Many2ManyAvatarResourceTagsList,};displayAvatarCard(record){return!this.env.isSmall&&this.relation==="resource.resource"&&record.data.resource_type==="user";}
getTagProps(record){return{...super.getTagProps(...arguments),icon:record.data.resource_type==="user"?null:"fa-wrench",img:record.data.resource_type==="user"?`/web/image/${this.relation}/${record.resId}/avatar_128`:null,};}}
const many2ManyAvatarResourceField=__exports.many2ManyAvatarResourceField={...many2ManyTagsAvatarUserField,component:Many2ManyAvatarResourceField,additionalClasses:["o_field_many2many_tags_avatar"],relatedFields:(fieldInfo)=>{return[...many2ManyTagsAvatarUserField.relatedFields(fieldInfo),{name:"resource_type",type:"selection",},];},};registry.category("fields").add("many2many_avatar_resource",many2ManyAvatarResourceField);return __exports;});;

/* /resource_mail/static/src/views/fields/many2one_avatar_resource/many2one_avatar_resource_field.js */
odoo.define('@resource_mail/views/fields/many2one_avatar_resource/many2one_avatar_resource_field',['@web/core/registry','@web/core/popover/popover_hook','@mail/views/web/fields/many2one_avatar_user_field/many2one_avatar_user_field','@resource_mail/components/avatar_card_resource/avatar_card_resource_popover','@resource_mail/views/fields/many2many_avatar_resource/many2many_avatar_resource_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{usePopover}=require("@web/core/popover/popover_hook");const{Many2OneAvatarUserField,many2OneAvatarUserField,}=require("@mail/views/web/fields/many2one_avatar_user_field/many2one_avatar_user_field");const{AvatarCardResourcePopover}=require("@resource_mail/components/avatar_card_resource/avatar_card_resource_popover");const{AvatarResourceMany2XAutocomplete}=require("@resource_mail/views/fields/many2many_avatar_resource/many2many_avatar_resource_field");const ExtendMany2OneAvatarToResource=(T)=>class extends T{setup(){super.setup();this.avatarCard=usePopover(AvatarCardResourcePopover);}
get displayAvatarCard(){return!this.env.isSmall&&this.relation==="resource.resource"&&this.props.record.data.resource_type==="user";}};const Many2OneAvatarResourceField=__exports.Many2OneAvatarResourceField=class Many2OneAvatarResourceField extends ExtendMany2OneAvatarToResource(Many2OneAvatarUserField){static template="resource_mail.Many2OneAvatarResourceField";static components={...super.components,Many2XAutocomplete:AvatarResourceMany2XAutocomplete,};}
const many2OneAvatarResourceField=__exports.many2OneAvatarResourceField={...many2OneAvatarUserField,component:Many2OneAvatarResourceField,fieldDependencies:[{name:"resource_type",type:"selection",},],};registry.category("fields").add("many2one_avatar_resource",many2OneAvatarResourceField);const KanbanMany2OneAvatarResourceField=__exports.KanbanMany2OneAvatarResourceField=class KanbanMany2OneAvatarResourceField extends ExtendMany2OneAvatarToResource(Many2OneAvatarResourceField){static template="resource_mail.KanbanMany2OneAvatarResourceField";}
const kanbanMany2OneAvatarResourceField=__exports.kanbanMany2OneAvatarResourceField={...many2OneAvatarResourceField,component:KanbanMany2OneAvatarResourceField,};registry.category("fields").add("kanban.many2one_avatar_resource",kanbanMany2OneAvatarResourceField);return __exports;});;

/* /hr/static/src/components/avatar_card/avatar_card_popover_patch.js */
odoo.define('@hr/components/avatar_card/avatar_card_popover_patch',['@web/core/utils/patch','@mail/discuss/web/avatar_card/avatar_card_popover'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{AvatarCardPopover}=require("@mail/discuss/web/avatar_card/avatar_card_popover");const patchAvatarCardPopover=__exports.patchAvatarCardPopover={setup(){super.setup();this.userInfoTemplate="hr.avatarCardUserInfos";},get fieldNames(){const fields=super.fieldNames;return fields.concat(["work_phone","work_email","work_location_name","work_location_type","job_title","department_id",this.props.recordModel?"employee_id":"employee_ids",]);},get email(){return this.user.work_email||this.user.email;},get phone(){return this.user.work_phone||this.user.phone;},async getProfileAction(){return this.user.employee_ids?.length>0?this.orm.call("hr.employee","get_formview_action",[this.user.employee_ids[0]]):super.getProfileAction(...arguments);},};const unpatchAvatarCardPopover=__exports.unpatchAvatarCardPopover=patch(AvatarCardPopover.prototype,patchAvatarCardPopover);return __exports;});;

/* /hr/static/src/components/avatar_card_employee/avatar_card_employee_popover.js */
odoo.define('@hr/components/avatar_card_employee/avatar_card_employee_popover',['@resource_mail/components/avatar_card_resource/avatar_card_resource_popover'],function(require){'use strict';let __exports={};const{AvatarCardResourcePopover}=require("@resource_mail/components/avatar_card_resource/avatar_card_resource_popover");const AvatarCardEmployeePopover=__exports.AvatarCardEmployeePopover=class AvatarCardEmployeePopover extends AvatarCardResourcePopover{static defaultProps={...AvatarCardResourcePopover.defaultProps,recordModel:"hr.employee",};async onWillStart(){await super.onWillStart();this.record.employee_id=[this.props.id];}
get fieldNames(){const excludedFields=["employee_id","resource_type"];return super.fieldNames.filter((field)=>!excludedFields.includes(field));}}
return __exports;});;

/* /hr/static/src/components/avatar_card_resource/avatar_card_resource_popover_patch.js */
odoo.define('@hr/components/avatar_card_resource/avatar_card_resource_popover_patch',['@web/core/utils/patch','@resource_mail/components/avatar_card_resource/avatar_card_resource_popover','@web/core/utils/hooks','@web/core/tags_list/tags_list'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{AvatarCardResourcePopover}=require("@resource_mail/components/avatar_card_resource/avatar_card_resource_popover");const{useService}=require("@web/core/utils/hooks");const{TagsList}=require("@web/core/tags_list/tags_list");const patchAvatarCardResourcePopover={setup(){super.setup();(this.userInfoTemplate="hr.avatarCardResourceInfos"),(this.actionService=useService("action"));},get fieldNames(){return[...super.fieldNames,"show_hr_icon_display","hr_icon_display"];},get email(){return this.record.work_email||this.record.email;},get phone(){return this.record.work_phone||this.record.phone;},get showViewProfileBtn(){return this.record.employee_id?.length>0;},async getProfileAction(){return await this.orm.call("hr.employee","get_formview_action",[this.record.employee_id[0],]);},};patch(AvatarCardResourcePopover.prototype,patchAvatarCardResourcePopover);patch(AvatarCardResourcePopover,{components:{...AvatarCardResourcePopover.components,TagsList,},});return __exports;});;

/* /hr/static/src/components/background_image/background_image.js */
odoo.define('@hr/components/background_image/background_image',['@web/core/registry','@web/views/fields/image/image_field'],function(require){'use strict';let __exports={};const{registry}=require('@web/core/registry');const{ImageField,imageField}=require('@web/views/fields/image/image_field');const BackgroundImageField=__exports.BackgroundImageField=class BackgroundImageField extends ImageField{static template="hr.BackgroundImage";}
const backgroundImageField=__exports.backgroundImageField={...imageField,component:BackgroundImageField,};registry.category("fields").add("background_image",backgroundImageField);return __exports;});;

/* /hr/static/src/components/department_chart/department_chart.js */
odoo.define('@hr/components/department_chart/department_chart',['@web/core/registry','@web/core/utils/hooks','@web/views/widgets/standard_widget_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{onWillStart,useState,onWillUpdateProps,Component}=require("@odoo/owl");const DepartmentChart=__exports.DepartmentChart=class DepartmentChart extends Component{static template="hr.DepartmentChart";static props={...standardWidgetProps,};setup(){super.setup();this.action=useService("action");this.orm=useService("orm");this.state=useState({hierarchy:{},});onWillStart(async()=>await this.fetchHierarchy(this.props.record.resId));onWillUpdateProps(async(nextProps)=>{await this.fetchHierarchy(nextProps.record.resId);});}
async fetchHierarchy(departmentId){this.state.hierarchy=await this.orm.call("hr.department","get_department_hierarchy",[departmentId,]);}
async openDepartmentEmployees(departmentId){const dialogAction=await this.orm.call(this.props.record.resModel,"action_employee_from_department",[departmentId],{});this.action.doAction(dialogAction);}}
const departmentChart=__exports.departmentChart={component:DepartmentChart,};registry.category("view_widgets").add("hr_department_chart",departmentChart);return __exports;});;

/* /hr/static/src/components/employee_chat/employee_chat.js */
odoo.define('@hr/components/employee_chat/employee_chat',['@web/core/registry','@web/views/widgets/standard_widget_props','@mail/core/web/open_chat_hook','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{useOpenChat}=require("@mail/core/web/open_chat_hook");const{Component}=require("@odoo/owl");const HrEmployeeChat=__exports.HrEmployeeChat=class HrEmployeeChat extends Component{static props={...standardWidgetProps,};static template="hr.OpenChat";setup(){super.setup();this.openChat=useOpenChat(this.props.record.resModel);}}
const hrEmployeeChat=__exports.hrEmployeeChat={component:HrEmployeeChat,};registry.category("view_widgets").add("hr_employee_chat",hrEmployeeChat);return __exports;});;

/* /hr/static/src/components/float_without_trailing_zeros/float_without_trailing_zeros.js */
odoo.define('@hr/components/float_without_trailing_zeros/float_without_trailing_zeros',['@web/core/registry','@web/views/fields/float/float_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{floatField,FloatField}=require("@web/views/fields/float/float_field");const fieldRegistry=registry.category("fields");class FloatWithoutTrailingZeros extends FloatField{get formattedValue(){return super.formattedValue.replace(/\.0+$/,"");}}
const floatWithoutTrailingZeros={...floatField,component:FloatWithoutTrailingZeros};fieldRegistry.add("float_without_trailing_zeros",floatWithoutTrailingZeros);return __exports;});;

/* /hr/static/src/components/hr_presence_status/hr_presence_status.js */
odoo.define('@hr/components/hr_presence_status/hr_presence_status',['@odoo/owl','@web/core/l10n/translation','@web/core/registry','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const HrPresenceStatus=__exports.HrPresenceStatus=class HrPresenceStatus extends Component{static template="hr.HrPresenceStatus";static props={...standardFieldProps,tag:{type:String,optional:true},};static defaultProps={tag:"small",};get classNames(){const classNames=["fa"];classNames.push(this.icon,"fa-fw","o_button_icon","hr_presence","align-middle",this.color,)
return classNames.join(" ");}
get color(){switch(this.value){case"presence_present":return"text-success";case"presence_absent":return"o_icon_employee_absent";case"presence_out_of_working_hour":case"presence_archive":return"text-muted";default:return"";}}
get icon(){return`fa-circle${this.value.startsWith("presence_archive") ? "-o" : ""}`;}
get label(){return this.value!==false?this.options.find(([value,label])=>value===this.value)[1]:"";}
get options(){return this.props.record.fields[this.props.name].selection.filter((option)=>option[0]!==false&&option[1]!=="");}
get value(){return this.props.record.data[this.props.name];}}
const hrPresenceStatus=__exports.hrPresenceStatus={component:HrPresenceStatus,displayName:_t("HR Presence Status"),extractProps({viewType},dynamicInfo){return{tag:viewType==="kanban"?"span":"small",};},};registry.category("fields").add("hr_presence_status",hrPresenceStatus)
return __exports;});;

/* /hr/static/src/components/hr_presence_status_private/hr_presence_status_private.js */
odoo.define('@hr/components/hr_presence_status_private/hr_presence_status_private',['@web/core/registry','@hr/components/hr_presence_status/hr_presence_status'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{HrPresenceStatus,hrPresenceStatus}=require("@hr/components/hr_presence_status/hr_presence_status");const HrPresenceStatusPrivate=__exports.HrPresenceStatusPrivate=class HrPresenceStatusPrivate extends HrPresenceStatus{}
const hrPresenceStatusPrivate=__exports.hrPresenceStatusPrivate={...hrPresenceStatus,component:HrPresenceStatusPrivate,};registry.category("fields").add("hr_presence_status_private",hrPresenceStatusPrivate);return __exports;});;

/* /hr/static/src/components/radio_image_field/radio_image_field.js */
odoo.define('@hr/components/radio_image_field/radio_image_field',['@web/core/registry','@web/views/fields/radio/radio_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{RadioField,radioField}=require("@web/views/fields/radio/radio_field");class RadioImageField extends RadioField{static template="hr_homeworking.RadioImageField";}
registry.category("fields").add("hr_homeworking_radio_image",{...radioField,component:RadioImageField,});return __exports;});;

/* /hr/static/src/components/work_permit_upload/work_permit_upload.js */
odoo.define('@hr/components/work_permit_upload/work_permit_upload',['@web/core/registry','@web/views/fields/binary/binary_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{BinaryField,binaryField}=require("@web/views/fields/binary/binary_field");const WorkPermitUploadField=__exports.WorkPermitUploadField=class WorkPermitUploadField extends BinaryField{static template="hr.WorkPermitUploadField";}
const workPermitUploadField=__exports.workPermitUploadField={...binaryField,component:WorkPermitUploadField,};registry.category("fields").add("work_permit_upload",workPermitUploadField);return __exports;});;

/* /hr/static/src/core/common/persona_model_patch.js */
odoo.define('@hr/core/common/persona_model_patch',['@mail/core/common/persona_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Persona}=require("@mail/core/common/persona_model");const{patch}=require("@web/core/utils/patch");patch(Persona.prototype,{employeeId:undefined,});return __exports;});;

/* /hr/static/src/core/web/thread_actions.js */
odoo.define('@hr/core/web/thread_actions',['@mail/core/common/thread_actions','@web/core/l10n/translation','@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{threadActionsRegistry}=require("@mail/core/common/thread_actions");const{_t}=require("@web/core/l10n/translation");const{useComponent}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");threadActionsRegistry.add("open-hr-profile",{condition(component){return(component.thread?.channel_type==="chat"&&component.props.chatWindow?.isOpen&&component.thread.correspondent?.persona.employeeId);},icon:"fa fa-fw fa-id-card",name:_t("Open Profile"),async open(component){component.actionService.doAction({type:"ir.actions.act_window",res_id:component.thread.correspondent.persona.employeeId,res_model:"hr.employee.public",views:[[false,"form"]],});},async setup(action){const component=useComponent();const orm=useService("orm");let employeeId;if(!component.thread?.correspondent?.persona.employeeId&&component.thread?.correspondent){const employees=await orm.silent.searchRead("hr.employee",[["user_partner_id","=",component.thread.correspondent.persona.id]],["id"]);employeeId=employees[0]?.id;if(employeeId){component.thread.correspondent.persona.employeeId=employeeId;}}},sequence:16,});return __exports;});;

/* /hr/static/src/store_service_patch.js */
odoo.define('@hr/store_service_patch',['@web/core/l10n/translation','@mail/core/common/store_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Store}=require("@mail/core/common/store_service");const{patch}=require("@web/core/utils/patch");const storeServicePatch={setup(){super.setup();this.employees={};},async getChat(person){const{employeeId}=person;if(!employeeId){return super.getChat(person);}
let employee=this.employees[employeeId];if(!employee){this.employees[employeeId]={id:employeeId};employee=this.employees[employeeId];}
if(!employee.user_id&&!employee.hasCheckedUser){employee.hasCheckedUser=true;const[employeeData]=await this.env.services.orm.silent.read("hr.employee.public",[employee.id],["user_id","user_partner_id"],{context:{active_test:false}});if(employeeData){employee.user_id=employeeData.user_id[0];let user=this.users[employee.user_id];if(!user){this.users[employee.user_id]={id:employee.user_id};user=this.users[employee.user_id];}
user.partner_id=employeeData.user_partner_id[0];this.Persona.insert({displayName:employeeData.user_partner_id[1],id:employeeData.user_partner_id[0],type:"partner",});}}
if(!employee.user_id){this.env.services.notification.add(_t("You can only chat with employees that have a dedicated user."),{type:"info"});return;}
return super.getChat({userId:employee.user_id});},};patch(Store.prototype,storeServicePatch);return __exports;});;

/* /hr/static/src/user_menu/my_profile.js */
odoo.define('@hr/user_menu/my_profile',['@web/core/l10n/translation','@web/core/registry','@web/webclient/user_menu/user_menu_items'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{preferencesItem}=require("@web/webclient/user_menu/user_menu_items");__exports.hrPreferencesItem=hrPreferencesItem;function hrPreferencesItem(env){return Object.assign({},preferencesItem(env),{description:_t('My Profile'),});}
registry.category("user_menuitems").add('profile',hrPreferencesItem,{force:true})
return __exports;});;

/* /hr/static/src/views/archive_employee_hook.js */
odoo.define('@hr/views/archive_employee_hook',['@web/core/l10n/translation','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{useComponent}=require("@odoo/owl");__exports.useArchiveEmployee=useArchiveEmployee;function useArchiveEmployee(){const component=useComponent();const action=useService("action");return(id)=>{action.doAction({type:"ir.actions.act_window",name:_t("Employee Termination"),res_model:"hr.departure.wizard",views:[[false,"form"]],view_mode:"form",target:"new",context:{active_id:id,toggle_active:true,},},{onClose:async()=>{await component.model.load();},});};}
return __exports;});;

/* /hr/static/src/views/fields/employee_field_relation_mixin.js */
odoo.define('@hr/views/fields/employee_field_relation_mixin',['@odoo/owl','@web/core/user'],function(require){'use strict';let __exports={};const{onWillStart}=require("@odoo/owl");const{user}=require("@web/core/user");__exports.EmployeeFieldRelationMixin=EmployeeFieldRelationMixin;function EmployeeFieldRelationMixin(fieldClass){return class extends fieldClass{static props={...fieldClass.props,relation:{type:String,optional:true},};setup(){super.setup();onWillStart(async()=>{this.isHrUser=await user.hasGroup("hr.group_hr_user");});}
get relation(){if(this.props.relation){return this.props.relation;}
return this.isHrUser?"hr.employee":"hr.employee.public";}};}
return __exports;});;

/* /hr/static/src/views/fields/many2many_avatar_employee_field/many2many_avatar_employee_field.js */
odoo.define('@hr/views/fields/many2many_avatar_employee_field/many2many_avatar_employee_field',['@web/core/registry','@mail/views/web/fields/many2many_avatar_user_field/many2many_avatar_user_field','@hr/views/fields/employee_field_relation_mixin'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Many2ManyTagsAvatarUserField,KanbanMany2ManyTagsAvatarUserField,many2ManyTagsAvatarUserField,kanbanMany2ManyTagsAvatarUserField,listMany2ManyTagsAvatarUserField,}=require("@mail/views/web/fields/many2many_avatar_user_field/many2many_avatar_user_field");const{EmployeeFieldRelationMixin}=require("@hr/views/fields/employee_field_relation_mixin");const Many2ManyTagsAvatarEmployeeField=__exports.Many2ManyTagsAvatarEmployeeField=class Many2ManyTagsAvatarEmployeeField extends EmployeeFieldRelationMixin(Many2ManyTagsAvatarUserField){}
const many2ManyTagsAvatarEmployeeField=__exports.many2ManyTagsAvatarEmployeeField={...many2ManyTagsAvatarUserField,component:Many2ManyTagsAvatarEmployeeField,additionalClasses:[...many2ManyTagsAvatarUserField.additionalClasses,"o_field_many2many_avatar_user",],extractProps:(fieldInfo,dynamicInfo)=>({...many2ManyTagsAvatarUserField.extractProps(fieldInfo,dynamicInfo),canQuickCreate:false,relation:fieldInfo.options?.relation,}),};registry.category("fields").add("many2many_avatar_employee",many2ManyTagsAvatarEmployeeField);const KanbanMany2ManyTagsAvatarEmployeeField=__exports.KanbanMany2ManyTagsAvatarEmployeeField=class KanbanMany2ManyTagsAvatarEmployeeField extends EmployeeFieldRelationMixin(KanbanMany2ManyTagsAvatarUserField){}
const kanbanMany2ManyTagsAvatarEmployeeField=__exports.kanbanMany2ManyTagsAvatarEmployeeField={...kanbanMany2ManyTagsAvatarUserField,component:KanbanMany2ManyTagsAvatarEmployeeField,additionalClasses:[...kanbanMany2ManyTagsAvatarUserField.additionalClasses,"o_field_many2many_avatar_user",],extractProps:(fieldInfo,dynamicInfo)=>({...kanbanMany2ManyTagsAvatarUserField.extractProps(fieldInfo,dynamicInfo),relation:fieldInfo.options?.relation,}),};registry.category("fields").add("kanban.many2many_avatar_employee",kanbanMany2ManyTagsAvatarEmployeeField);const listMany2ManyTagsAvatarEmployeeField=__exports.listMany2ManyTagsAvatarEmployeeField={...listMany2ManyTagsAvatarUserField,additionalClasses:[...listMany2ManyTagsAvatarUserField.additionalClasses,"o_field_many2many_avatar_user",],};registry.category("fields").add("list.many2many_avatar_employee",listMany2ManyTagsAvatarEmployeeField);return __exports;});;

/* /hr/static/src/views/fields/many2many_avatar_user_field/many2many_avatar_user_field_patch.js */
odoo.define('@hr/views/fields/many2many_avatar_user_field/many2many_avatar_user_field_patch',['@web/core/utils/patch','@web/core/popover/popover_hook','@hr/components/avatar_card_employee/avatar_card_employee_popover','@mail/views/web/fields/many2many_avatar_user_field/many2many_avatar_user_field'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{usePopover}=require("@web/core/popover/popover_hook");const{AvatarCardEmployeePopover}=require("@hr/components/avatar_card_employee/avatar_card_employee_popover");const{Many2ManyTagsAvatarUserField,ListMany2ManyTagsAvatarUserField,KanbanMany2ManyTagsAvatarUserField,}=require("@mail/views/web/fields/many2many_avatar_user_field/many2many_avatar_user_field");const many2manyAvatarUserPatch={setup(){super.setup(...arguments);if(["hr.employee","hr.employee.public"].includes(this.relation)){this.avatarCard=usePopover(AvatarCardEmployeePopover,{closeOnClickAway:true});}},displayAvatarCard(record){return((!this.env.isSmall&&["hr.employee","hr.employee.public"].includes(this.relation))||super.displayAvatarCard);},getAvatarCardProps(record){const originalProps=super.getAvatarCardProps(record);if(["hr.employee","hr.employee.public"].includes(this.relation)){return{...originalProps,recordModel:this.relation,};}
return originalProps;},};patch(Many2ManyTagsAvatarUserField.prototype,many2manyAvatarUserPatch);patch(KanbanMany2ManyTagsAvatarUserField.prototype,many2manyAvatarUserPatch);patch(ListMany2ManyTagsAvatarUserField.prototype,many2manyAvatarUserPatch);return __exports;});;

/* /hr/static/src/views/fields/many2one_avatar_employee_field/many2one_avatar_employee_field.js */
odoo.define('@hr/views/fields/many2one_avatar_employee_field/many2one_avatar_employee_field',['@web/core/registry','@mail/views/web/fields/many2one_avatar_user_field/many2one_avatar_user_field','@hr/views/fields/employee_field_relation_mixin'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Many2OneAvatarUserField,KanbanMany2OneAvatarUserField,many2OneAvatarUserField,kanbanMany2OneAvatarUserField,}=require("@mail/views/web/fields/many2one_avatar_user_field/many2one_avatar_user_field");const{EmployeeFieldRelationMixin}=require("@hr/views/fields/employee_field_relation_mixin");const Many2OneAvatarEmployeeField=__exports.Many2OneAvatarEmployeeField=class Many2OneAvatarEmployeeField extends EmployeeFieldRelationMixin(Many2OneAvatarUserField){get many2OneProps(){return{...super.many2OneProps,relation:this.relation,};}}
const many2OneAvatarEmployeeField=__exports.many2OneAvatarEmployeeField={...many2OneAvatarUserField,component:Many2OneAvatarEmployeeField,additionalClasses:[...many2OneAvatarUserField.additionalClasses,"o_field_many2one_avatar_user",],extractProps:(fieldInfo,dynamicInfo)=>({...many2OneAvatarUserField.extractProps(fieldInfo,dynamicInfo),canQuickCreate:false,relation:fieldInfo.options?.relation,}),};registry.category("fields").add("many2one_avatar_employee",many2OneAvatarEmployeeField);const KanbanMany2OneAvatarEmployeeField=__exports.KanbanMany2OneAvatarEmployeeField=class KanbanMany2OneAvatarEmployeeField extends EmployeeFieldRelationMixin(KanbanMany2OneAvatarUserField){get many2OneProps(){return{...super.many2OneProps,relation:this.relation,};}}
const kanbanMany2OneAvatarEmployeeField=__exports.kanbanMany2OneAvatarEmployeeField={...kanbanMany2OneAvatarUserField,component:KanbanMany2OneAvatarEmployeeField,extractProps:(fieldInfo,dynamicInfo)=>({...kanbanMany2OneAvatarUserField.extractProps(fieldInfo,dynamicInfo),relation:fieldInfo.options?.relation,}),};registry.category("fields").add("kanban.many2one_avatar_employee",kanbanMany2OneAvatarEmployeeField);return __exports;});;

/* /hr/static/src/views/fields/many2one_avatar_user_field/many2one_avatar_user_field_patch.js */
odoo.define('@hr/views/fields/many2one_avatar_user_field/many2one_avatar_user_field_patch',['@web/core/utils/patch','@web/core/popover/popover_hook','@mail/views/web/fields/many2one_avatar_user_field/many2one_avatar_user_field','@hr/components/avatar_card_employee/avatar_card_employee_popover'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{usePopover}=require("@web/core/popover/popover_hook");const{Many2OneAvatarUserField,KanbanMany2OneAvatarUserField,}=require("@mail/views/web/fields/many2one_avatar_user_field/many2one_avatar_user_field");const{AvatarCardEmployeePopover}=require("@hr/components/avatar_card_employee/avatar_card_employee_popover");const patchMany2OneAvatarUserField=__exports.patchMany2OneAvatarUserField={setup(){super.setup(...arguments);if(["hr.employee","hr.employee.public"].includes(this.relation)){this.avatarCard=usePopover(AvatarCardEmployeePopover,{closeOnClickAway:true});}},get displayAvatarCard(){return((!this.env.isSmall&&["hr.employee","hr.employee.public"].includes(this.relation))||super.displayAvatarCard);},getAvatarCardProps(){const originalProps=super.getAvatarCardProps();if(["hr.employee","hr.employee.public"].includes(this.relation)){return{...originalProps,recordModel:this.relation,};}
return originalProps;},};patch(Many2OneAvatarUserField.prototype,patchMany2OneAvatarUserField);patch(KanbanMany2OneAvatarUserField.prototype,patchMany2OneAvatarUserField);return __exports;});;

/* /hr/static/src/views/form_view.js */
odoo.define('@hr/views/form_view',['@web/core/registry','@web/views/form/form_view','@web/views/form/form_controller','@hr/views/archive_employee_hook'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");const{FormController}=require("@web/views/form/form_controller");const{useArchiveEmployee}=require("@hr/views/archive_employee_hook");const EmployeeFormController=__exports.EmployeeFormController=class EmployeeFormController extends FormController{setup(){super.setup();this.archiveEmployee=useArchiveEmployee();}
getStaticActionMenuItems(){const menuItems=super.getStaticActionMenuItems();menuItems.archive.callback=this.archiveEmployee.bind(this,this.model.root.resId);return menuItems;}}
registry.category("views").add("hr_employee_form",{...formView,Controller:EmployeeFormController,});return __exports;});;

/* /hr/static/src/views/hr_action_helper.js */
odoo.define('@hr/views/hr_action_helper',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const HrActionHelper=__exports.HrActionHelper=class HrActionHelper extends Component{static template="hr.EmployeeActionHelper";static props={noContentTitle:{type:String},noContentParagraph:{type:String}};}
return __exports;});;

/* /hr/static/src/views/list_view.js */
odoo.define('@hr/views/list_view',['@web/core/registry','@web/views/list/list_view','@web/views/list/list_controller','@hr/views/archive_employee_hook'],function(require){'use strict';let __exports={};const{registry}=require('@web/core/registry');const{listView}=require('@web/views/list/list_view');const{ListController}=require('@web/views/list/list_controller');const{useArchiveEmployee}=require('@hr/views/archive_employee_hook');const EmployeeListController=__exports.EmployeeListController=class EmployeeListController extends ListController{setup(){super.setup();this.archiveEmployee=useArchiveEmployee();}
getStaticActionMenuItems(){const menuItems=super.getStaticActionMenuItems();const selectedRecords=this.model.root.selection;if(selectedRecords.length===1&&selectedRecords[0].data.active){menuItems.archive.callback=this.archiveEmployee.bind(this,selectedRecords[0].resId);}
return menuItems;}}
registry.category('views').add('hr_employee_list',{...listView,Controller:EmployeeListController,});return __exports;});;

/* /hr/static/src/views/open_chat_hook.js */
odoo.define('@hr/views/open_chat_hook',['@mail/core/web/open_chat_hook','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{helpers}=require("@mail/core/web/open_chat_hook");const{patch}=require("@web/core/utils/patch");patch(helpers,{SUPPORTED_M2X_AVATAR_MODELS:[...helpers.SUPPORTED_M2X_AVATAR_MODELS,"hr.employee","hr.employee.public",],buildOpenChatParams(resModel,id){if(["hr.employee","hr.employee.public"].includes(resModel)){return{employeeId:id};}
return super.buildOpenChatParams(...arguments);}});return __exports;});;

/* /hr/static/src/views/profile_form_view.js */
odoo.define('@hr/views/profile_form_view',['@web/core/registry','@web/core/utils/hooks','@web/views/form/form_view'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{formView}=require("@web/views/form/form_view");const EmployeeProfileController=__exports.EmployeeProfileController=class EmployeeProfileController extends formView.Controller{setup(){super.setup();this.action=useService("action");this.mustReload=false;}
onWillSaveRecord(record,changes){this.mustReload="lang"in changes;}
async onRecordSaved(record){await super.onRecordSaved(...arguments);if(this.mustReload){this.mustReload=false;return this.action.doAction("reload_context");}}}
registry.category("views").add("hr_employee_profile_form",{...formView,Controller:EmployeeProfileController,});return __exports;});;

/* /hr_timesheet/static/src/components/progress_bar/project_task_progress_bar_field.js */
odoo.define('@hr_timesheet/components/progress_bar/project_task_progress_bar_field',['@web/core/registry','@web/views/fields/formatters','@web/views/fields/progress_bar/progress_bar_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formatPercentage}=require("@web/views/fields/formatters");const{progressBarField,ProgressBarField}=require("@web/views/fields/progress_bar/progress_bar_field");const ProjectTaskProgressBarField=__exports.ProjectTaskProgressBarField=class ProjectTaskProgressBarField extends ProgressBarField{get currentValue(){return super.currentValue*100;}
get progressBarColorClass(){if(this.currentValue>this.maxValue){return super.progressBarColorClass;}
return this.currentValue<80?"bg-success":"bg-warning";}}
const projectTaskProgressBarField=__exports.projectTaskProgressBarField={...progressBarField,component:ProjectTaskProgressBarField,};registry.category("fields").add("project_task_progressbar",projectTaskProgressBarField);registry.category("formatters").add("project_task_progressbar",formatPercentage);return __exports;});;

/* /hr_timesheet/static/src/components/task_with_hours/task_with_hours.js */
odoo.define('@hr_timesheet/components/task_with_hours/task_with_hours',['@web/core/registry','@web/views/fields/many2one/many2one_field','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Many2OneField,many2OneField}=require("@web/views/fields/many2one/many2one_field");const{onWillStart}=require("@odoo/owl");const TaskWithHours=__exports.TaskWithHours=class TaskWithHours extends Many2OneField{setup(){super.setup();onWillStart(this.onWillStart);}
async onWillStart(){}
canCreate(){return Boolean(this.context.default_project_id);}
get displayName(){const displayName=super.displayName;return displayName?displayName.split('\u00A0')[0]:displayName;}
get context(){return{...super.context,hr_timesheet_display_remaining_hours:true};}
get Many2XAutocompleteProps(){const props=super.Many2XAutocompleteProps;if(!this.canCreate()){props.quickCreate=null;}
return props;}
computeActiveActions(props){super.computeActiveActions(props);const activeActions=this.state.activeActions;activeActions.create=activeActions.create&&this.canCreate(props);activeActions.createEdit=activeActions.createEdit&&this.canCreate(props);}}
const taskWithHours=__exports.taskWithHours={...many2OneField,component:TaskWithHours,};registry.category("fields").add("task_with_hours",taskWithHours);return __exports;});;

/* /hr_timesheet/static/src/components/time_hour_field/time_hour_field.js */
odoo.define('@hr_timesheet/components/time_hour_field/time_hour_field',['@web/core/registry','@web/core/l10n/translation','@web/views/fields/float_time/float_time_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{FloatTimeField}=require("@web/views/fields/float_time/float_time_field");const TimeHourField=__exports.TimeHourField=class TimeHourField extends FloatTimeField{get formattedValue(){const unitAmount=super.formattedValue;const[hourStr,minuteStr]=unitAmount.split(":");const hours=parseInt(hourStr,10);const minutes=parseInt(minuteStr,10);return minutes?_t("%(hours)sh%(minutes)s",{hours,minutes}):_t("%(hours)sh",{hours});}}
const timeHourField=__exports.timeHourField={component:TimeHourField,};registry.category("fields").add("time_hour_uom",timeHourField);return __exports;});;

/* /hr_timesheet/static/src/components/timesheet_duration_uom/timesheet_duration_uom.js */
odoo.define('@hr_timesheet/components/timesheet_duration_uom/timesheet_duration_uom',['@web/core/registry','@hr_timesheet/components/timesheet_uom/timesheet_uom','@hr_timesheet/components/time_hour_field/time_hour_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{TimesheetUOM}=require("@hr_timesheet/components/timesheet_uom/timesheet_uom");const{TimeHourField}=require("@hr_timesheet/components/time_hour_field/time_hour_field");const TimesheetDurationUOM=__exports.TimesheetDurationUOM=class TimesheetDurationUOM extends TimesheetUOM{static components={...TimesheetUOM.components,TimeHourField,};get timesheetComponent(){if(this.timesheetUOMService.timesheetWidget==="float_time"){return this.timesheetUOMService.getTimesheetComponent("time_hour_uom");}
return super.timesheetComponent;}}
const timesheetDurationUOM=__exports.timesheetDurationUOM={component:TimesheetDurationUOM,};registry.category("fields").add("timesheet_duration_uom",timesheetDurationUOM);return __exports;});;

/* /hr_timesheet/static/src/components/timesheet_uom/timesheet_uom.js */
odoo.define('@hr_timesheet/components/timesheet_uom/timesheet_uom',['@web/core/utils/hooks','@web/core/registry','@web/views/fields/float_factor/float_factor_field','@web/views/fields/float_toggle/float_toggle_field','@web/views/fields/float_time/float_time_field','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const{FloatFactorField}=require("@web/views/fields/float_factor/float_factor_field");const{FloatToggleField}=require("@web/views/fields/float_toggle/float_toggle_field");const{FloatTimeField}=require("@web/views/fields/float_time/float_time_field");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const TimesheetUOM=__exports.TimesheetUOM=class TimesheetUOM extends Component{static props={...standardFieldProps,};static template="hr_timesheet.TimesheetUOM";static components={FloatFactorField,FloatToggleField,FloatTimeField};setup(){this.timesheetUOMService=useService("timesheet_uom");}
get timesheetComponent(){return this.timesheetUOMService.getTimesheetComponent();}
get timesheetComponentProps(){return this.timesheetUOMService.getTimesheetComponentProps(this.props);}}
const timesheetUOM=__exports.timesheetUOM={component:TimesheetUOM,};registry.category("fields").add("timesheet_uom",timesheetUOM);return __exports;});;

/* /hr_timesheet/static/src/components/timesheet_uom_no_toggle/timesheet_uom_no_toggle.js */
odoo.define('@hr_timesheet/components/timesheet_uom_no_toggle/timesheet_uom_no_toggle',['@web/core/registry','@hr_timesheet/components/timesheet_uom/timesheet_uom'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{TimesheetUOM,timesheetUOM}=require("@hr_timesheet/components/timesheet_uom/timesheet_uom");const TimesheetUOMNoToggle=__exports.TimesheetUOMNoToggle=class TimesheetUOMNoToggle extends TimesheetUOM{get timesheetComponent(){if(this.timesheetUOMService.timesheetWidget==="float_toggle"){return this.timesheetUOMService.getTimesheetComponent("float_factor");}
return super.timesheetComponent;}}
delete TimesheetUOMNoToggle.components.FloatToggleField;const timesheetUOMNoToggle=__exports.timesheetUOMNoToggle={...timesheetUOM,component:TimesheetUOMNoToggle,};registry.category("fields").add("timesheet_uom_no_toggle",timesheetUOMNoToggle);return __exports;});;

/* /hr_timesheet/static/src/services/timesheet_uom_service.js */
odoo.define('@hr_timesheet/services/timesheet_uom_service',['@web/session','@web/core/registry','@web/views/fields/formatters','@web/core/utils/numbers','@web/views/fields/float_factor/float_factor_field'],function(require){'use strict';let __exports={};const{session}=require("@web/session");const{registry}=require("@web/core/registry");const{formatFloatTime,formatFloatFactor}=require("@web/views/fields/formatters");const{formatFloat}=require("@web/core/utils/numbers");const{FloatFactorField}=require("@web/views/fields/float_factor/float_factor_field");const timesheetUOMService=__exports.timesheetUOMService={dependencies:["company"],start(env,{company}){const service={get timesheetUOMId(){return company.currentCompany.timesheet_uom_id;},get timesheetWidget(){let timesheet_widget="float_factor";if(session.uom_ids&&this.timesheetUOMId in session.uom_ids){timesheet_widget=session.uom_ids[this.timesheetUOMId].timesheet_widget;}
return timesheet_widget;},getTimesheetComponent(widgetName=this.timesheetWidget){return registry.category("fields").get(widgetName,{component:FloatFactorField}).component;},getTimesheetComponentProps(props){const factorDependantComponents=["float_toggle","float_factor"];return factorDependantComponents.includes(this.timesheetWidget)?this._getFactorCompanyDependentProps(props):props;},_getFactorCompanyDependentProps(props){const factor=company.currentCompany.timesheet_uom_factor||props.factor;return{...props,factor};},get formatter(){if(this.timesheetWidget==="float_time"){return formatFloatTime;}
const factor=company.currentCompany.timesheet_uom_factor||1;if(this.timesheetWidget==="float_toggle"){return(value,options={})=>formatFloat(value*factor,options);}
return(value,options={})=>formatFloatFactor(value,Object.assign({factor},options));},};if(!registry.category("formatters").contains("timesheet_uom")){registry.category("formatters").add("timesheet_uom",service.formatter);}
if(!registry.category("formatters").contains("timesheet_uom_no_toggle")){registry.category("formatters").add("timesheet_uom_no_toggle",service.formatter);}
return service;},};registry.category("services").add("timesheet_uom",timesheetUOMService);return __exports;});;

/* /timer/static/src/component/timer_start_field/timer_start_field.js */
odoo.define('@timer/component/timer_start_field/timer_start_field',['@odoo/owl','@web/core/registry','@web/model/relational_model/utils','@web/views/fields/standard_field_props','@timer/hooks/use_timer'],function(require){'use strict';let __exports={};const{Component,onWillUnmount,useState}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{useRecordObserver}=require("@web/model/relational_model/utils");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{useTimer}=require("@timer/hooks/use_timer");const TimerStartField=__exports.TimerStartField=class TimerStartField extends Component{static props={...standardFieldProps,};static template="timer.TimerStartField";setup(){super.setup(...arguments);this.timerReactive=useState(useTimer());useRecordObserver(this.onRecordChange.bind(this));onWillUnmount(()=>{clearInterval(this.timer);});}
onRecordChange(record){clearInterval(this.timer);const timerPause=record.data.timer_pause;if(timerPause&&!record.data.timer_pause){this.timerReactive.clearTimer();}
this.startTimer(record.data[this.props.name],timerPause);}
startTimer(timerStart,timerPause){if(timerStart){let currentTime;if(timerPause){currentTime=timerPause;this.timerReactive.computeOffset(currentTime);}else{currentTime=this.timerReactive.getCurrentTime();}
this.timerReactive.setTimer(0,timerStart,currentTime);this.timerReactive.formatTime();clearInterval(this.timer);this.timer=setInterval(()=>{if(timerPause){clearInterval(this.timer);}else{this.timerReactive.updateTimer(timerStart);this.timerReactive.formatTime();}},1000);}else if(!timerPause){clearInterval(this.timer);this.timerReactive.clearTimer();}}}
const timerStartField=__exports.timerStartField={component:TimerStartField,fieldDependencies:[{name:"timer_pause",type:"datetime"}],};registry.category("fields").add("timer_start_field",timerStartField);return __exports;});;

/* /timer/static/src/component/timer_toggle_button/timer_toggle_button.js */
odoo.define('@timer/component/timer_toggle_button/timer_toggle_button',['@web/core/l10n/translation','@web/views/fields/standard_field_props','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const TimerToggleButton=__exports.TimerToggleButton=class TimerToggleButton extends Component{static props={...standardFieldProps,context:{type:Object},};static template="timer.ToggleButton";setup(){this.orm=useService("orm");}
get buttonClass(){const layout=this.props.record.data[this.props.name]?'danger':'primary';return`bg-${layout} text-bg-${layout}`;}
get iconClass(){const icon=this.props.record.data[this.props.name]?"stop":"play";return`fa fa-${icon}-circle`;}
get title(){return this.props.record.data[this.props.name]?_t("Stop"):_t("Start");}
async onClick(ev){const action=this.props.record.data[this.props.name]?"stop":"start";await this.orm.call(this.props.record.resModel,`action_timer_${action}`,[[this.props.record.resId]],{context:this.props.context});await this.props.record.model.load();}}
return __exports;});;

/* /timer/static/src/hooks/use_timer.js */
odoo.define('@timer/hooks/use_timer',['@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{onWillStart,useComponent}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");__exports.useTimer=useTimer;function useTimer(){const component=useComponent();const timerService=useService("timer");const timerReactive=timerService.createTimer();onWillStart(timerService.getServerOffset.bind(component));return timerReactive;}
return __exports;});;

/* /timer/static/src/models/timer_reactive.js */
odoo.define('@timer/models/timer_reactive',['@web/core/l10n/dates','@web/core/utils/reactive'],function(require){'use strict';let __exports={};const{deserializeDateTime}=require("@web/core/l10n/dates");const{Reactive}=require("@web/core/utils/reactive");const{DateTime,Interval}=luxon;const TimerReactive=__exports.TimerReactive=class TimerReactive extends Reactive{constructor(env){super();this.orm=env.services.orm;this.clearTimer();}
get toSeconds(){return(this.hours*60+this.minutes)*60+this.seconds;}
get floatValue(){return this.toSeconds/3600;}
formatTime(){const hours=`${this.hours}`.padStart(2,"0");const minutes=`${this.minutes}`.padStart(2,"0");const seconds=`${this.seconds}`.padStart(2,"0");this.time=`${hours}:${minutes}:${seconds}`;}
addHours(hours){this.hours+=hours;}
addMinutes(minutes){minutes+=this.minutes;this.minutes=minutes%60;this.addHours(Math.floor(minutes/60));}
addSeconds(seconds){seconds+=this.seconds;this.seconds=seconds%60;this.addMinutes(Math.floor(seconds/60));}
computeOffset(serverTime){const{seconds}=this.getInterval(DateTime.now(),serverTime).toDuration(["seconds","milliseconds"]).toObject();this.serverOffset=seconds;}
setTimer(timeElapsed,timerStart,serverTime){this.resetTimer();this.addFloatTime(timeElapsed);this.timeElapsed=this.toSeconds;if(!serverTime&&this.serverOffset!==null){serverTime=timerStart.plus({seconds:this.serverOffset});}
if(timerStart&&serverTime){const dateStart=timerStart;const{hours,minutes,seconds}=this.getInterval(dateStart,serverTime).toDuration(["hours","minutes","seconds","milliseconds"]).toObject();this.addHours(hours);this.addMinutes(minutes);this.addSeconds(seconds);}else if((timerStart&&!serverTime)||(!timerStart&&serverTime)){console.error("Missing parameter: the timerStart or serverTime when one of them is defined.");}}
getInterval(dateA,dateB){let startDate,endDate;if(dateA<=dateB){startDate=dateA;endDate=dateB;}else{startDate=dateB;endDate=dateA;}
return Interval.fromDateTimes(startDate,endDate);}
getCurrentTime(){return DateTime.now().plus({seconds:this.serverOffset});}
async getServerTime(){const serverTime=deserializeDateTime(await this.orm.call("timer.timer","get_server_time"));return serverTime.setZone("utc");}
addFloatTime(timeElapsed){if(timeElapsed===0){this.hours=this.minutes=this.seconds=0;return;}
const minutes=timeElapsed%1;this.hours=timeElapsed-minutes;this.minutes=minutes*60;}
updateTimer(timerStart){const currentTime=this.getCurrentTime();const timeElapsed=this.getInterval(timerStart,currentTime);const{seconds}=timeElapsed.toDuration(["seconds","milliseconds"]).toObject();this.addSeconds(seconds-this.toSeconds+this.timeElapsed);}
resetTimer(){this.hours=0;this.minutes=0;this.seconds=0;this.time="";}
clearTimer(){this.resetTimer();}}
return __exports;});;

/* /timer/static/src/services/timer_service.js */
odoo.define('@timer/services/timer_service',['@web/core/registry','@timer/models/timer_reactive'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{TimerReactive}=require("@timer/models/timer_reactive");const timerService=__exports.timerService={start(env){let serverOffset=null;let timer;return{createTimer(){timer=new TimerReactive(env);return timer;},async getServerOffset(){if(serverOffset==null){const serverTime=await timer.getServerTime();timer.computeOffset(serverTime);serverOffset=timer.serverOffset;}
return serverOffset;},};},};registry.category("services").add("timer",timerService);return __exports;});;

/* /hr_org_chart/static/src/fields/hooks.js */
odoo.define('@hr_org_chart/fields/hooks',['@web/core/l10n/translation','@web/core/user','@web/core/network/rpc','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");__exports.onEmployeeSubRedirect=onEmployeeSubRedirect;function onEmployeeSubRedirect(){const actionService=useService('action');const orm=useService('orm');return async(event)=>{const employeeId=parseInt(event.currentTarget.dataset.employeeId);if(!employeeId){return{};}
const type=event.currentTarget.dataset.type||'direct';const subordinateIds=await rpc('/hr/get_subordinates',{employee_id:employeeId,subordinates_type:type,context:user.context});let action=await orm.call('hr.employee','get_formview_action',[employeeId]);action={...action,name:_t('Team'),view_mode:'kanban,list,form',views:[[false,'kanban'],[false,'list'],[false,'form']],domain:[['id','in',subordinateIds]],res_id:false,context:{default_parent_id:employeeId,}};actionService.doAction(action);};}
return __exports;});;

/* /hr_org_chart/static/src/fields/hr_org_chart.js */
odoo.define('@hr_org_chart/fields/hr_org_chart',['@web/core/network/rpc','@web/core/registry','@web/core/utils/hooks','@web/core/popover/popover_hook','@web/core/user','@hr_org_chart/fields/hooks','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{usePopover}=require("@web/core/popover/popover_hook");const{user}=require("@web/core/user");const{onEmployeeSubRedirect}=require("@hr_org_chart/fields/hooks");const{Component,onWillStart,onWillRender,useState}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");class HrOrgChartPopover extends Component{static template="hr_org_chart.hr_orgchart_emp_popover";static props={employee:Object,close:Function,};async setup(){super.setup();this.orm=useService('orm');this.actionService=useService("action");this._onEmployeeSubRedirect=onEmployeeSubRedirect();}
async _onEmployeeRedirect(employeeId){const action=await this.orm.call('hr.employee','get_formview_action',[employeeId]);this.actionService.doAction(action);}}
const HrOrgChart=__exports.HrOrgChart=class HrOrgChart extends Component{static template="hr_org_chart.hr_org_chart";static props={...standardFieldProps};async setup(){super.setup();this.orm=useService('orm');this.actionService=useService("action");this.popover=usePopover(HrOrgChartPopover);this.state=useState({'employee_id':null});this.lastParent=null;this._onEmployeeSubRedirect=onEmployeeSubRedirect();onWillStart(this.handleComponentUpdate.bind(this));onWillRender(this.handleComponentUpdate.bind(this));}
async handleComponentUpdate(){this.employee=this.props.record.data;this.state.employee_id=this.employee.employee_ids!==undefined?this.employee.employee_ids.resIds[0]:this.props.record.resId;const manager=this.employee.parent_id||this.employee.employee_parent_id;const forceReload=this.lastRecord!==this.props.record||this.lastParent!=manager;this.lastParent=manager;this.lastRecord=this.props.record;await this.fetchEmployeeData(this.state.employee_id,forceReload);}
async fetchEmployeeData(employeeId,force=false){if(!employeeId){this.managers=[];this.children=[];if(this.view_employee_id){this.render(true);}
this.view_employee_id=null;}else if(employeeId!==this.view_employee_id||force){this.view_employee_id=employeeId;let orgData=await rpc('/hr/get_org_chart',{employee_id:employeeId,context:user.context,});if(Object.keys(orgData).length===0){orgData={managers:[],children:[],}}
this.managers=orgData.managers;this.children=orgData.children;this.managers_more=orgData.managers_more;this.self=orgData.self;this.render(true);}}
_onOpenPopover(event,employee){this.popover.open(event.currentTarget,{employee});}
async _onEmployeeRedirect(employeeId){const action=await this.orm.call('hr.employee','get_formview_action',[employeeId]);this.actionService.doAction(action);}
async _onEmployeeMoreManager(managerId){await this.fetchEmployeeData(managerId);this.state.employee_id=managerId;}}
const hrOrgChart=__exports.hrOrgChart={component:HrOrgChart,};registry.category("fields").add("hr_org_chart",hrOrgChart);return __exports;});;

/* /timesheet_grid/static/src/components/employee_overtime_indication/employee_overtime_indication.js */
odoo.define('@timesheet_grid/components/employee_overtime_indication/employee_overtime_indication',['@web/views/fields/formatters','@web/core/utils/numbers','@odoo/owl'],function(require){'use strict';let __exports={};const{formatFloatTime}=require("@web/views/fields/formatters");const{formatFloat}=require("@web/core/utils/numbers");const{Component}=require("@odoo/owl");const EmployeeOvertimeIndication=__exports.EmployeeOvertimeIndication=class EmployeeOvertimeIndication extends Component{static props={allocated_hours:{type:Number,optional:true},uom:{type:String,optional:true},worked_hours:{type:Number,optional:true},};static defaultProps={uom:"hours",};static template="timesheet_grid.EmployeeOvertimeIndication";get shouldShowHours(){return this.props.allocated_hours>0;}
get colorClasses(){if(!this.shouldShowHours){return"";}
return this.props.worked_hours<this.props.allocated_hours?"text-danger":"text-success";}
get overtime(){return this.props.worked_hours-this.props.allocated_hours;}
get overtimeIndication(){if(!this.shouldShowHours){return null;}
if(this.overtime===0){return null;}
let overtimeIndication=this.overtime>0?"+":"";if(this.props.uom==="days"){overtimeIndication+=formatFloat(this.overtime);}else{overtimeIndication+=formatFloatTime(this.overtime);}
return overtimeIndication;}}
return __exports;});;

/* /timesheet_grid/static/src/components/grid_timer_button_cell/grid_timer_button_cell.js */
odoo.define('@timesheet_grid/components/grid_timer_button_cell/grid_timer_button_cell',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,onWillUpdateProps,useState}=require("@odoo/owl");const GridTimerButtonCell=__exports.GridTimerButtonCell=class GridTimerButtonCell extends Component{static template="timesheet_grid.GridTimerButtonCell";static props={hotKey:{type:String,optional:true},row:Object,addTimeMode:Boolean,hovered:{type:Boolean,optional:true},timerRunning:{type:Boolean,optional:true},onTimerClick:Function,};setup(){this.state=useState({timerRunning:this.props.timerRunning||this.props.row.timerRunning,});onWillUpdateProps(this.onWillUpdateProps);}
onWillUpdateProps(nextProps){this.state.timerRunning=nextProps.timerRunning||nextProps.row.timerRunning;}}
return __exports;});;

/* /timesheet_grid/static/src/components/grid_timesheet_timer_header/grid_timesheet_timer_header.js */
odoo.define('@timesheet_grid/components/grid_timesheet_timer_header/grid_timesheet_timer_header',['@web/core/l10n/translation','@web/core/domain','@web/core/utils/hooks','@web/model/record','@web/views/kanban/kanban_record','@web/views/fields/field','@timesheet_grid/components/timesheet_timer_header/timesheet_timer_header','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Domain}=require("@web/core/domain");const{useService}=require("@web/core/utils/hooks");const{Record}=require("@web/model/record");const{getRawValue}=require("@web/views/kanban/kanban_record");const{getPropertyFieldInfo}=require("@web/views/fields/field");const{TimesheetTimerHeader}=require("@timesheet_grid/components/timesheet_timer_header/timesheet_timer_header");const{Component,onWillStart}=require("@odoo/owl");const GridTimesheetTimerHeader=__exports.GridTimesheetTimerHeader=class GridTimesheetTimerHeader extends Component{static components={TimesheetTimerHeader,Record,};static props={stepTimer:Number,timerRunning:Boolean,addTimeMode:Boolean,otherCompany:{type:Boolean,optional:true},model:Object,resId:{type:Number,optional:true},updateTimesheet:Function,onTimerStarted:Function,onTimerStopped:Function,onTimerUnlinked:Function,};static template="timesheet_grid.GridTimesheetTimerHeader";setup(){this.notificationService=useService("notification");this.timesheetUOMService=useService("timesheet_uom");this.timerService=useService("timer");this.timerReactive=this.timerService.createTimer();onWillStart(this.onWillStart);}
async onWillStart(){if(!this.props.model.timerFieldsInfo){await this.props.model.fetchTimerHeaderFields(this.fieldNames);}}
get fields(){return this.props.model.timerFieldsInfo;}
get fieldNames(){return["name","project_id","task_id","company_id","timer_start","unit_amount"];}
getFieldInfo(fieldName){const field=this.fields[fieldName];let fieldType=field.type;if(fieldName==="task_id"){fieldType='task_with_hours';}
const domain=field.domain||"[]";const fieldInfo=getPropertyFieldInfo({field:field,name:fieldName,type:fieldType,domain,required:"False",});fieldInfo.placeholder=field.string||"";if(fieldName==="project_id"){fieldInfo.domain=Domain.and([fieldInfo.domain,new Domain([["allow_timesheets","=",true]]),]).toString();fieldInfo.context=`{'search_default_my_projects': True}`;fieldInfo.required="True";}else if(fieldName==="task_id"){fieldInfo.domain=domain;fieldInfo.context=`{'default_project_id': project_id, 'search_default_my_tasks': True, 'search_default_open_tasks': True}`;}else if(fieldName==="name"){fieldInfo.placeholder=_t("Describe your activity...");}
if(field.depends?.length){fieldInfo.onChange=true;}
return fieldInfo;}
get activeFields(){const activeFields={};for(const fieldName of this.fieldNames){activeFields[fieldName]=this.getFieldInfo(fieldName);}
return activeFields;}
async onTimesheetChanged(timesheet,changes){const secondsElapsed=this.timerReactive.toSeconds;if(timesheet.isNew){if(changes.project_id||changes.task_id){timesheet.save({reload:false}).then(()=>{this.props.updateTimesheet({...Object.fromEntries(this.fieldNames.map((f)=>[f,getRawValue(timesheet,f)])),id:timesheet.resId,},secondsElapsed);});}
return;}
if(changes.name===""&&Object.keys(changes).length===1&&((!("name"in this.props.model.data.timer)&&this.props.model.data.timer.description==="/")||this.props.model.data.timer.name==="/")){return;}
timesheet.save({reload:false});this.props.updateTimesheet(Object.fromEntries(this.fieldNames.map((f)=>[f,getRawValue(timesheet,f)])));}}
return __exports;});;

/* /timesheet_grid/static/src/components/timesheet_display_timer/timesheet_display_timer.js */
odoo.define('@timesheet_grid/components/timesheet_display_timer/timesheet_display_timer',['@web/views/fields/formatters','@web/views/fields/float_time/float_time_field','@web/views/fields/standard_field_props','@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{formatFloatTime}=require("@web/views/fields/formatters");const{FloatTimeField}=require("@web/views/fields/float_time/float_time_field");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component,onWillDestroy,onWillStart,onWillUpdateProps,status,useState,}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const TimesheetTimerFloatTimerField=__exports.TimesheetTimerFloatTimerField=class TimesheetTimerFloatTimerField extends FloatTimeField{static template="timesheet_grid.TimesheetTimerFloatTimeField";static props={...FloatTimeField.props,timerRunning:{type:Boolean},displayRed:{type:Boolean},value:true,name:{optional:true},context:{type:Object,optional:true},};get formattedValue(){return formatFloatTime(this.value,{displaySeconds:this.props.timerRunning});}
get value(){return this.props.value;}}
const TimesheetDisplayTimer=__exports.TimesheetDisplayTimer=class TimesheetDisplayTimer extends Component{static template="timesheet_grid.TimesheetDisplayTimer";static components={TimesheetTimerFloatTimerField};static props={...standardFieldProps,timerRunning:{type:Boolean,optional:true},context:{type:Object,optional:true},displayRed:{type:Boolean,optional:true},timerReactive:{type:Object,optional:true},};static defaultProps={displayRed:true};static fieldDependencies={timer_pause:{type:"datetime"},timer_start:{type:"datetime"},};setup(){this.timerService=useService("timer");this.timerReactive=this.props.timerReactive||this.timerService.createTimer();this.state=useState({timerStart:this.props.record.data.timer_start,timerRunning:Boolean(this.props.record.data.timer_start||this.props.timerRunning)&&!this.props.record.data.timer_pause,value:this.props.record.data[this.props.name],});onWillStart(this.onWillStart);onWillUpdateProps(this.onWillUpdateProps);onWillDestroy(this._stopTimeRefresh);}
async onWillUpdateProps(nextProps){let newValue=nextProps.record.data[nextProps.name];this.state.timerRunning=Boolean(nextProps.record.data.timer_start||nextProps.timerRunning)&&!nextProps.record.data.timer_pause;const shouldReloadTimer=this.props.record.data.timer_start!==nextProps.record.data.timer_start||this.props.record.data.timer_pause!==nextProps.record.data.timer_pause||this.props.value!==nextProps.value;if(this.state.timerRunning&&shouldReloadTimer){this._stopTimeRefresh();this.timerReactive.clearTimer();if(nextProps.record.data.timer_start){this.state.timerStart=nextProps.record.data.timer_start;}
this.timerReactive.setTimer(newValue,this.state.timerStart,this.serverTime);this.timerReactive.updateTimer(this.state.timerStart);newValue=this.timerReactive.floatValue;this._startTimeRefresh();}
this.state.value=newValue;}
async onWillStart(){if(this.state.timerRunning){await this.timerService.getServerOffset();if(!this.state.timerStart){this.state.timerStart=this.timerReactive.getCurrentTime();}
this.timerReactive.setTimer(this.state.value,this.state.timerStart,this.serverTime);this.timerReactive.updateTimer(this.state.timerStart);this.state.value=this.timerReactive.floatValue;this._startTimeRefresh();}}
_startTimeRefresh(){if(!this.timeRefresh&&status(this)!=="destroyed"){this.timeRefresh=setInterval(()=>{this.timerReactive.updateTimer(this.state.timerStart);this.state.value=this.timerReactive.floatValue;},1000);}}
_stopTimeRefresh(){if(this.timeRefresh){clearTimeout(this.timeRefresh);this.timeRefresh=0;}}
get TimesheetTimerFloatTimerFieldProps(){const{timerRunning,value}=this.state;const props={...this.props};delete props.timerReactive;return{...props,timerRunning,value};}}
return __exports;});;

/* /timesheet_grid/static/src/components/timesheet_overtime_indication/timesheet_overtime_indication.js */
odoo.define('@timesheet_grid/components/timesheet_overtime_indication/timesheet_overtime_indication',['@web/core/l10n/translation','@timesheet_grid/components/employee_overtime_indication/employee_overtime_indication'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{EmployeeOvertimeIndication}=require("@timesheet_grid/components/employee_overtime_indication/employee_overtime_indication");const TimesheetOvertimeIndication=__exports.TimesheetOvertimeIndication=class TimesheetOvertimeIndication extends EmployeeOvertimeIndication{static template="timesheet_grid.TimesheetOvertimeIndication";static props={...EmployeeOvertimeIndication.props,name:String,};get colorClasses(){if(!this.shouldShowHours){return"";}
const progression=this.props.worked_hours/this.props.allocated_hours;return progression<=0.8?"text-success":progression<=0.99?"text-warning":"text-danger";}
get overtime(){return this.props.allocated_hours-this.props.worked_hours;}
get title(){if(this.props.name==="project_id"){return _t("Difference between the allocated %(uom)s (%(allocated_hours)s) and the %(uom)s spent (%(worked_hours)s) on the project",{uom:this.props.uom,allocated_hours:this.props.allocated_hours,worked_hours:this.props.worked_hours,});}else if(this.props.name==="task_id"){return _t("Difference between the allocated %(uom)s (%(allocated_hours)s) and the %(uom)s spent (%(worked_hours)s) on the task",{uom:this.props.uom,allocated_hours:this.props.allocated_hours,worked_hours:this.props.worked_hours,});}else{return _t("Difference between the time allocated and the time recorded");}}}
return __exports;});;

/* /timesheet_grid/static/src/components/timesheet_timer_header/timesheet_timer_header.js */
odoo.define('@timesheet_grid/components/timesheet_timer_header/timesheet_timer_header',['@web/views/fields/field','@timesheet_grid/components/timesheet_display_timer/timesheet_display_timer','@web/core/utils/hooks','@web/core/user','@odoo/owl'],function(require){'use strict';let __exports={};const{Field,getPropertyFieldInfo}=require("@web/views/fields/field");const{TimesheetDisplayTimer}=require("@timesheet_grid/components/timesheet_display_timer/timesheet_display_timer");const{useService,useAutofocus}=require("@web/core/utils/hooks");const{user}=require("@web/core/user");const{Component,onWillStart,useRef,useExternalListener}=require("@odoo/owl");const TimesheetTimerHeader=__exports.TimesheetTimerHeader=class TimesheetTimerHeader extends Component{static template="timesheet_grid.TimesheetTimerHeader";static components={TimesheetDisplayTimer,Field,};static props={timesheet:{type:Object,optional:true},stepTimer:Number,timerRunning:Boolean,addTimeMode:Boolean,fields:{type:Object,optional:true},otherCompany:{type:Boolean,optional:true},timerReactive:{type:Object,optional:true},onTimerStarted:Function,onTimerStopped:Function,onTimerUnlinked:Function,onClick:{type:Function,optional:true},className:{type:String,optional:true},};static defaultProps={onClick(){},};setup(){this.orm=useService("orm");this.startButton=useRef("startButton");this.stopButton=useRef("stopButton");onWillStart(async()=>await this.onWillStart());useAutofocus({refName:"startButton"});useAutofocus({refName:"stopButton"});useExternalListener(document.body,"click",(ev)=>{if(ev.target.closest(".modal")||["input","textarea"].includes(ev.target.tagName.toLowerCase())){return;}
this.startButton.el?this.startButton.el.focus():this.stopButton.el.focus();});}
async onWillStart(){this.isProjectManager=await user.hasGroup('project.group_project_manager');}
getIsProjectManager(){return this.isProjectManager;}
onWillUpdateProps(nextProps){if(nextProps.timesheet&&nextProps.timesheet.data.name==="/"){this._clearTimesheetName(nextProps.timesheet);}}
get _addTimeMode(){return this.props.addTimeMode;}
get _timerIsRunning(){return this.props.timerRunning;}
get otherCompany(){return this.props.otherCompany;}
get isMobile(){return this.env.isSmall;}
get viewType(){return this.env.config.viewType;}
getFieldType(fieldName){if(fieldName==="task_id"){return"task_with_hours";}
return this.props.fields[fieldName].type;}
get fieldsInfo(){return{task_id:{...getPropertyFieldInfo({name:"task_id",type:this.getFieldType("task_id")}),viewType:this.viewType,context:this.props.fields.task_id.context,},};}
_clearTimesheetName(timesheet=null){(timesheet||this.props.timesheet).update({name:""},{silent:true});}
async _onClickStartTimer(ev){await this.props.onTimerStarted();}
async _onClickStopTimer(ev){if(await this.props.timesheet?.save()){await this.props.onTimerStopped();}}
async _onClickUnlinkTimer(ev){await this.props.onTimerUnlinked();}
_onKeyDown(ev){if(ev.key==='Enter'){this._onClickStopTimer();}}}
return __exports;});;

/* /timesheet_grid/static/src/components/timesheet_uom_hour_timer/timesheet_uom_hour_timer.js */
odoo.define('@timesheet_grid/components/timesheet_uom_hour_timer/timesheet_uom_hour_timer',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@timesheet_grid/components/timesheet_display_timer/timesheet_display_timer','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{TimesheetDisplayTimer}=require("@timesheet_grid/components/timesheet_display_timer/timesheet_display_timer");const{Component,useState}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const TimesheetUOMHourTimer=__exports.TimesheetUOMHourTimer=class TimesheetUOMHourTimer extends Component{static components={TimesheetDisplayTimer};static template="timesheet_grid.TimesheetUOMHourTimer";static props={...standardFieldProps,context:{type:Object,optional:true},};setup(){this.ormService=useService("orm");this.state=useState(this.env.timerState||{});}
get displayButton(){return this.props.record.data.display_timer&&this.props.readonly;}
get iconClass(){const icon=this.addTimeMode?"plus":this.isTimerRunning?"stop":"play";const textColor=this.isTimerRunning?"danger":"primary";return`fa fa-${icon} text-${textColor}`;}
get isTimerRunning(){return this.props.record.data.is_timer_running;}
get addTimeMode(){return this.state.addTimeMode;}
get title(){return this.isTimerRunning?_t("Stop"):_t("Start");}
async onClick(ev){ev.preventDefault();const action=this.addTimeMode?"increase":this.isTimerRunning?"stop":"start";await this.ormService.call(this.props.record.resModel,`action_timer_${action}`,[[this.props.record.resId]],{context:this.props.context});await this.props.record.model.load();}}
const timesheetUOMHourTimer=__exports.timesheetUOMHourTimer={component:TimesheetUOMHourTimer,extractProps(fieldInfo,dynamicInfo){return{context:dynamicInfo.context,};},fieldDependencies:[{name:"duration_unit_amount",type:"float"},{name:"display_timer",type:"boolean"},{name:"is_timer_running",type:"boolean"},],};registry.category("fields").add("timesheet_uom_hour_timer",timesheetUOMHourTimer);return __exports;});;

/* /timesheet_grid/static/src/components/timesheet_uom_timer/timesheet_uom_timer.js */
odoo.define('@timesheet_grid/components/timesheet_uom_timer/timesheet_uom_timer',['@web/core/registry','@web/views/fields/float_factor/float_factor_field','@web/views/fields/float_toggle/float_toggle_field','@hr_timesheet/components/timesheet_uom/timesheet_uom','@timesheet_grid/components/timesheet_uom_hour_timer/timesheet_uom_hour_timer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{FloatFactorField}=require("@web/views/fields/float_factor/float_factor_field");const{FloatToggleField}=require("@web/views/fields/float_toggle/float_toggle_field");const{TimesheetUOM,timesheetUOM}=require("@hr_timesheet/components/timesheet_uom/timesheet_uom");const{TimesheetUOMHourTimer}=require("@timesheet_grid/components/timesheet_uom_hour_timer/timesheet_uom_hour_timer");class TimesheetUOMTimer extends TimesheetUOM{static components={...TimesheetUOM.components,FloatFactorField,FloatToggleField,TimesheetUOMHourTimer,};get timesheetComponent(){if(this.timesheetUOMService.timesheetWidget==="float_time"){return this.timesheetUOMService.getTimesheetComponent("timesheet_uom_hour_timer");}
return super.timesheetComponent;}}
delete TimesheetUOMTimer.components.FloatTimeField;registry.category("fields").add("timesheet_uom_timer",{...timesheetUOM,component:TimesheetUOMTimer,additionalClasses:["o_field_timesheet_uom"],});return __exports;});;

/* /timesheet_grid/static/src/hooks/timesheet_timer_hooks.js */
odoo.define('@timesheet_grid/hooks/timesheet_timer_hooks',['@web/core/l10n/translation','@web/core/domain','@web/core/utils/hooks','@web/core/utils/patch','@web/model/relational_model/dynamic_record_list','@web/model/relational_model/dynamic_group_list','@web/views/fields/field','@odoo/owl','@timesheet_grid/views/timesheet_list/timesheet_timer_list_controller','@timesheet_grid/views/timesheet_kanban/timesheet_timer_kanban_controller'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Domain}=require("@web/core/domain");const{useService}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");const{DynamicRecordList}=require("@web/model/relational_model/dynamic_record_list");const{DynamicGroupList}=require("@web/model/relational_model/dynamic_group_list");const{getPropertyFieldInfo}=require("@web/views/fields/field");const{useState,useComponent,onWillStart,onMounted,onWillUnmount,onWillUpdateProps,useEffect,useExternalListener,useSubEnv,}=require("@odoo/owl");const{TimesheetTimerListController}=require("@timesheet_grid/views/timesheet_list/timesheet_timer_list_controller");const{TimesheetTimerKanbanController}=require("@timesheet_grid/views/timesheet_kanban/timesheet_timer_kanban_controller");const TimesheetTimerRendererHook=__exports.TimesheetTimerRendererHook=class TimesheetTimerRendererHook{constructor(propsList,env){this.propsList=propsList;this.env=env;this.setup();}
setup(){this.orm=useService("orm");this.timesheetUOMService=useService("timesheet_uom");this.notification=useService("notification");this.timerState=useState({timesheetId:undefined,addTimeMode:false,timerRunning:false,otherCompany:false,});}
get showTimer(){return this.timesheetUOMService.timesheetWidget==="float_time";}
getFieldInfo(fieldName,field){const fieldInfo=getPropertyFieldInfo({field:field,name:fieldName,type:field.type,domain:field.domain||"[]",required:"False",});fieldInfo.placeholder=field.string||"";if(fieldName==="project_id"){fieldInfo.domain=Domain.and([fieldInfo.domain,new Domain([["allow_timesheets","=",true]]),]).toString();fieldInfo.context=`{'search_default_my_projects': True}`;fieldInfo.required="True";}else if(fieldName==="task_id"){fieldInfo.context=`{'default_project_id': project_id, 'search_default_my_tasks': True, 'search_default_open_tasks': True}`;}else if(fieldName==="name"){fieldInfo.placeholder=_t("Describe your activity...");}
if(field.depends?.length){fieldInfo.onChange=true;}
return fieldInfo;}
get fields(){const fields={};for(const[fieldName]of Object.entries(this.propsList.activeFields)){const fieldInfo=this.getFieldInfo(fieldName,this.propsList.fields[fieldName]);fields[fieldName]=fieldInfo;}
return fields;}
async onWillStart(){await this._fetchRunningTimer();await this._popRecord();this._setAddTimeMode(false);}
async onMounted(){if(this.timesheet){await this.propsList.enterEditMode(this.timesheet);}}
onWillUnmount(){}
async onWillUpdateProps(nextProps){await this._fetchRunningTimer();await this._popRecord(nextProps.list);if(this.timesheet&&this.env.config.viewType==='kanban'){await this.propsList.enterEditMode(this.timesheet);}
this._setAddTimeMode(this.timerState.addTimeMode);}
async _newTimesheetTimer(){if(this.propsList.addNewRecord){return this.propsList.addNewRecord(true);}
const values=await this.propsList.model._loadNewRecord({resModel:this.propsList.resModel,activeFields:this.propsList.activeFields,fields:this.propsList.fields,context:this.propsList.context,});if(values.project_id){const timesheetTimerData=await this.startNewTimesheetTimer(values);if(timesheetTimerData.id){values.id=timesheetTimerData.id;}}
return new this.propsList.model.constructor.Record(this.propsList.model,{context:this.propsList.context,activeFields:this.propsList.activeFields,resModel:this.propsList.resModel,fields:this.propsList.fields,resId:values.id||false,resIds:values.id?[values.id]:[],isMonoRecord:true,currentCompanyId:this.propsList.currentCompanyId,mode:"edit",},values,{manuallyAdded:!values.id});}
async _onTimerStarted(){this.timerState.timerRunning=true;this.timerState.addTimeMode=false;let timesheetData=await this.orm.call(this.propsList.resModel,"action_start_new_timesheet_timer",[{}]);if(timesheetData===false){this.timesheet=await this._newTimesheetTimer();timesheetData={...this.timesheet.data,id:false,};}
this._setTimerStateData(timesheetData);await this.propsList.model.load();}
async _onTimerStopped(){const timesheetId=this.timesheet.resId;const tryToMatch=this.timesheet&&!this.timesheet.data.unit_amount;this.timesheet=undefined;this._resetTimerState();await this.orm.call(this.propsList.resModel,"action_timer_stop",[timesheetId,tryToMatch,]);this.propsList.model.load();}
async _onTimerUnlinked(){if(this.timerState.timesheetId!==false){await this.orm.call(this.propsList.resModel,"action_timer_unlink",[this.timerState.timesheetId,]);}
const timesheetId=this.timesheet?.id;if(timesheetId){this.propsList._removeRecords([timesheetId]);}
this.timesheet=undefined;this._resetTimerState();this.propsList.model.load();}
async _popRecord(propsList=this.propsList){if(!this.timerState.timesheetId||(this.timesheet&&this.timesheet.resId===this.timerState.timesheetId)||this.timerState.otherCompany){if(this.timesheet?.data.project_id){this.timesheet=undefined;}
return;}
let timesheet=propsList.records.find((record)=>record.resId===this.timerState.timesheetId);if(!timesheet&&propsList instanceof DynamicRecordList){timesheet=await propsList.addExistingRecord(this.timerState.timesheetId,true);}
if(!timesheet&&propsList instanceof DynamicGroupList){const foldedList=this._getFoldedList(propsList);let recordList=await this._getDynamicRecordList(foldedList);timesheet=await recordList.addExistingRecord(this.timerState.timesheetId,true);}
if(!timesheet){return;}
this.timesheet=timesheet;}
_getFoldedList(list){for(const groupId in list.groups){if(list.groups[groupId]._config.isFolded){return list.groups[groupId].list;}
if(list.groups[groupId].list instanceof DynamicGroupList){const foldedList=this._getFoldedList(list.groups[groupId].list);if(foldedList){return foldedList;}}}
return false;}
async _getDynamicRecordList(list){while(list instanceof DynamicGroupList){if(list.groups[0]!==undefined){return list.group[0].list;}
await list.load();list=list.groups[0].list;}
return list;}
async _fetchRunningTimer(){const result=await this.orm.call(this.propsList.resModel,"get_running_timer",[]);this._setTimerStateData(result);}
_setTimerStateData(vals){if(vals.id||vals.other_company){Object.assign(this.timerState,{timerRunning:true,timesheetId:vals.id,otherCompany:!!vals.other_company,});}else if(this.timerState.timerRunning&&this.timesheet?.data.project_id){this._resetTimerState();}
if("step_timer"in vals){this.timerState.stepTimer=vals.step_timer;}}
_setAddTimeMode(addTimeMode){this.timerState.addTimeMode=addTimeMode;}
_resetTimerState(){Object.assign(this.timerState,{timesheetId:undefined,timerRunning:false,otherCompany:false,});}
_onKeydown(ev){if(this.propsList.editedRecord||['input','textarea'].includes(ev.target.tagName.toLowerCase())){return;}
const{otherCompany,timerRunning}=this.timerState;switch(ev.key){case"Enter":ev.preventDefault();if(!otherCompany){if(timerRunning){this._onTimerStopped();}else{this._onTimerStarted();}}
break;case"Escape":if(!otherCompany&&timerRunning){ev.preventDefault();this._onTimerUnlinked();}
break;case"Shift":ev.preventDefault();this._setAddTimeMode(true);break;}}
_onKeyup(ev){if(ev.key==="Shift"){this._setAddTimeMode(false);}}
async onTimerHeaderClick(ev){if(this.timesheet&&!this.timesheet.isInEdition){this.propsList.leaveEditMode();await this.propsList.enterEditMode(this.timesheet);}}}
__exports.useTimesheetTimerRendererHook=useTimesheetTimerRendererHook;function useTimesheetTimerRendererHook(){const component=useComponent();const timesheetTimerRendererHook=new TimesheetTimerRendererHook(component.props.list,component.env);useSubEnv({timerState:timesheetTimerRendererHook.timerState,});onWillStart(timesheetTimerRendererHook.onWillStart.bind(timesheetTimerRendererHook));onMounted(timesheetTimerRendererHook.onMounted.bind(timesheetTimerRendererHook));onWillUnmount(timesheetTimerRendererHook.onWillUnmount.bind(timesheetTimerRendererHook));onWillUpdateProps(timesheetTimerRendererHook.onWillUpdateProps.bind(timesheetTimerRendererHook));useEffect((reloadTimer)=>{if(reloadTimer){timesheetTimerRendererHook._fetchRunningTimer();}},()=>[component.props.timerState?.reload]);useExternalListener(window,"keydown",timesheetTimerRendererHook._onKeydown.bind(timesheetTimerRendererHook));useExternalListener(window,"keyup",timesheetTimerRendererHook._onKeyup.bind(timesheetTimerRendererHook));return timesheetTimerRendererHook;}
const patchController=()=>({onChangeWriteValues(record){const{project_id,task_id,name}=record._getChanges();return{project_id,task_id,name,};},get modelParams(){const params=super.modelParams;params.hooks.onRecordChanged=async(record)=>{if(record.isNew){if(!record.data.project_id||!record.data.is_timer_running){return params;}
const{project_id,task_id,employee_id,user_id,company_id}=record.data;await record.model.orm.call(record.resModel,"action_start_new_timesheet_timer",[{project_id:project_id&&project_id[0],task_id:task_id&&task_id[0],employee_id:employee_id&&employee_id[0],user_id:user_id&&user_id[0],company_id:company_id&&company_id[0],},]);}else if(record.data.is_timer_running){const writeValues=this.onChangeWriteValues(record);if(writeValues.project_id!=false){await record.model.orm.write(record.resModel,[record.resId],writeValues);}}};return params;},});patch(TimesheetTimerListController.prototype,patchController());patch(TimesheetTimerKanbanController.prototype,patchController());return __exports;});;

/* /timesheet_grid/static/src/hooks/useTimesheetOvertimeProps.js */
odoo.define('@timesheet_grid/hooks/useTimesheetOvertimeProps',['@odoo/owl'],function(require){'use strict';let __exports={};const{useComponent}=require("@odoo/owl");__exports.useTimesheetOvertimeProps=useTimesheetOvertimeProps;function useTimesheetOvertimeProps(){const comp=useComponent();return{get props(){if(comp.resId&&comp.props.workingHours&&comp.resId in comp.props.workingHours){return comp.props.workingHours[comp.resId];}else{return{};}},};}
return __exports;});;

/* /timesheet_grid/static/src/js/tours/timesheet_grid.js */
odoo.define('@timesheet_grid/js/tours/timesheet_grid',['@web/core/l10n/translation','@web/core/registry','@web_tour/tour_service/tour_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{stepUtils}=require("@web_tour/tour_service/tour_utils");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add('timesheet_tour',{url:"/odoo",steps:()=>[stepUtils.showAppsMenuItem(),{trigger:'.o_app[data-menu-xmlid="hr_timesheet.timesheet_menu_root"]',content:markup(_t('Track the <b>time spent</b> on your projects. <i>It starts here.</i>')),tooltipPosition:'bottom',run:"click",},{trigger:'.btn_start_timer',content:markup(_t('Launch the <b>timer</b> to start a new activity.')),tooltipPosition:'bottom',run:"click",},{trigger:'div[name=name] input',content:markup(_t('Describe your activity <i>(e.g. sent an e-mail, meeting with the customer...)</i>.')),tooltipPosition:'bottom',run:"edit My Activity",},{trigger:'div[name=project_id] .o_field_many2one_selection',content:markup(_t('Select the <b>project</b> on which you are working.')),tooltipPosition:'right',run:"click",},{trigger:'.btn_stop_timer',content:markup(_t('Stop the <b>timer</b> when you are done. <i>Tip: hit <b>[Enter]</b> in the description to automatically log your activity.</i>')),tooltipPosition:'bottom',run:"click",},{trigger:'.btn_timer_line',content:markup(_t('Launch the <b>timer</b> for this project by pressing the <b>[a] key</b>. Easily switch from one project to another by using those keys. <i>Tip: you can also directly add 15 minutes to this project by hitting the <b>shift + [A] keys</b>.</i>')),tooltipPosition:'right',run:"click",},{trigger:'.o_grid_view .o_grid_row:not(.o_grid_section).o_grid_cell_today, .o_grid_component_timesheet_uom',content:_t("Click on the cell to set the number of hours you spent on this project."),tooltipPosition:'bottom',run:"click",},{trigger:'.o_grid_view .o_grid_cell',content:_t("Click on the cell to set the number of hours you spent on this project."),tooltipPosition:'bottom',run:"click",},{trigger:'.o_grid_view .o_grid_cell',content:markup(_t('Set the number of hours you spent on this project (e.g. 1:30 or 1.5). <i>Tip: use the tab keys to easily navigate from one cell to another.</i>')),tooltipPosition:'bottom',run:"edit 1:30",}]});return __exports;});;

/* /timesheet_grid/static/src/views/timesheet_kanban/timesheet_timer_kanban_controller.js */
odoo.define('@timesheet_grid/views/timesheet_kanban/timesheet_timer_kanban_controller',['@odoo/owl','@web/views/kanban/kanban_controller'],function(require){'use strict';let __exports={};const{useSubEnv}=require("@odoo/owl");const{KanbanController}=require("@web/views/kanban/kanban_controller");const TimesheetTimerKanbanController=__exports.TimesheetTimerKanbanController=class TimesheetTimerKanbanController extends KanbanController{setup(){super.setup();useSubEnv({config:{...this.env.config,disableSearchBarAutofocus:true,},});}}
return __exports;});;

/* /timesheet_grid/static/src/views/timesheet_kanban/timesheet_timer_kanban_renderer.js */
odoo.define('@timesheet_grid/views/timesheet_kanban/timesheet_timer_kanban_renderer',['@web/views/kanban/kanban_renderer','@timesheet_grid/components/timesheet_timer_header/timesheet_timer_header','@timesheet_grid/hooks/timesheet_timer_hooks'],function(require){'use strict';let __exports={};const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{TimesheetTimerHeader}=require("@timesheet_grid/components/timesheet_timer_header/timesheet_timer_header");const{useTimesheetTimerRendererHook}=require("@timesheet_grid/hooks/timesheet_timer_hooks");const TimesheetTimerKanbanRenderer=__exports.TimesheetTimerKanbanRenderer=class TimesheetTimerKanbanRenderer extends KanbanRenderer{static template="timesheet_grid.TimesheetTimerKanbanRenderer";static components={...KanbanRenderer.components,TimesheetTimerHeader:TimesheetTimerHeader,};setup(){super.setup();this.timesheetTimerRendererHook=useTimesheetTimerRendererHook();}}
return __exports;});;

/* /timesheet_grid/static/src/views/timesheet_kanban/timesheet_timer_kanban_view.js */
odoo.define('@timesheet_grid/views/timesheet_kanban/timesheet_timer_kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@timesheet_grid/views/timesheet_kanban/timesheet_timer_kanban_controller','@timesheet_grid/views/timesheet_kanban/timesheet_timer_kanban_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{TimesheetTimerKanbanController}=require("@timesheet_grid/views/timesheet_kanban/timesheet_timer_kanban_controller");const{TimesheetTimerKanbanRenderer}=require("@timesheet_grid/views/timesheet_kanban/timesheet_timer_kanban_renderer");const timesheetTimerKanbanView=__exports.timesheetTimerKanbanView={...kanbanView,Controller:TimesheetTimerKanbanController,Renderer:TimesheetTimerKanbanRenderer,};registry.category("views").add("timesheet_timer_kanban",timesheetTimerKanbanView);return __exports;});;

/* /timesheet_grid/static/src/views/timesheet_kanban/timesheet_validation_kanban_controller.js */
odoo.define('@timesheet_grid/views/timesheet_kanban/timesheet_validation_kanban_controller',['@web/views/kanban/kanban_controller'],function(require){'use strict';let __exports={};const{KanbanController}=require("@web/views/kanban/kanban_controller");const TimesheetValidationKanbanController=__exports.TimesheetValidationKanbanController=class TimesheetValidationKanbanController extends KanbanController{async validateTimesheet(){const result=await this.model.orm.call(this.props.resModel,"action_validate_timesheet",[this.props.resIds,]);await this.model.notification.add(result.params.message,{type:result.params.type});this.render(true);}}
return __exports;});;

/* /timesheet_grid/static/src/views/timesheet_kanban/timesheet_validation_kanban_view.js */
odoo.define('@timesheet_grid/views/timesheet_kanban/timesheet_validation_kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@timesheet_grid/views/timesheet_kanban/timesheet_validation_kanban_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{TimesheetValidationKanbanController}=require("@timesheet_grid/views/timesheet_kanban/timesheet_validation_kanban_controller");const timesheetValidationKanbanView=__exports.timesheetValidationKanbanView={...kanbanView,Controller:TimesheetValidationKanbanController,buttonTemplate:"timesheet_grid.TimesheetValidationKanbanView.Buttons",};registry.category("views").add("timesheet_validation_kanban",timesheetValidationKanbanView);return __exports;});;

/* /timesheet_grid/static/src/views/timesheet_list/timesheet_timer_list_controller.js */
odoo.define('@timesheet_grid/views/timesheet_list/timesheet_timer_list_controller',['@odoo/owl','@web/views/list/list_controller'],function(require){'use strict';let __exports={};const{useState,useSubEnv}=require("@odoo/owl");const{ListController}=require("@web/views/list/list_controller");const TimesheetTimerListController=__exports.TimesheetTimerListController=class TimesheetTimerListController extends ListController{static template="timesheet_grid.TimesheetTimerListController";setup(){super.setup();useSubEnv({config:{...this.env.config,disableSearchBarAutofocus:true,},});this.timerState=useState({reload:false});}
get deleteConfirmationDialogProps(){this.timerState.reload=false;const dialogProps=super.deleteConfirmationDialogProps;if(this.model.root.selection.some((t)=>t.data.is_timer_running)){const oldConfirm=dialogProps.confirm;dialogProps.confirm=async()=>{await oldConfirm();this.timerState.reload=true;}}
return dialogProps;}}
return __exports;});;

/* /timesheet_grid/static/src/views/timesheet_list/timesheet_timer_list_renderer.js */
odoo.define('@timesheet_grid/views/timesheet_list/timesheet_timer_list_renderer',['@web/views/list/list_renderer','@timesheet_grid/components/timesheet_timer_header/timesheet_timer_header','@timesheet_grid/hooks/timesheet_timer_hooks'],function(require){'use strict';let __exports={};const{ListRenderer}=require("@web/views/list/list_renderer");const{TimesheetTimerHeader}=require("@timesheet_grid/components/timesheet_timer_header/timesheet_timer_header");const{useTimesheetTimerRendererHook}=require("@timesheet_grid/hooks/timesheet_timer_hooks");const TimesheetTimerListRenderer=__exports.TimesheetTimerListRenderer=class TimesheetTimerListRenderer extends ListRenderer{static template="timesheet_grid.TimesheetTimerListRenderer";static components={...ListRenderer.components,TimesheetTimerHeader:TimesheetTimerHeader,};static props=[...ListRenderer.props,"timerState"];setup(){super.setup();this.timesheetTimerRendererHook=useTimesheetTimerRendererHook();}
onGlobalClick(ev){if(ev.target.closest(".timesheet-timer")){return;}
super.onGlobalClick(ev);}}
return __exports;});;

/* /timesheet_grid/static/src/views/timesheet_list/timesheet_timer_list_view.js */
odoo.define('@timesheet_grid/views/timesheet_list/timesheet_timer_list_view',['@web/core/registry','@timesheet_grid/views/timesheet_list/timesheet_timer_list_controller','@timesheet_grid/views/timesheet_list/timesheet_timer_list_renderer','@web/views/list/list_view'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{TimesheetTimerListController}=require("@timesheet_grid/views/timesheet_list/timesheet_timer_list_controller");const{TimesheetTimerListRenderer}=require("@timesheet_grid/views/timesheet_list/timesheet_timer_list_renderer");const{listView}=require("@web/views/list/list_view");const timesheetTimerListView=__exports.timesheetTimerListView={...listView,Controller:TimesheetTimerListController,Renderer:TimesheetTimerListRenderer,};registry.category("views").add("timesheet_timer_list",timesheetTimerListView);return __exports;});;

/* /hr_expense/static/src/components/attachment_view.js */
odoo.define('@hr_expense/components/attachment_view',['@web/core/utils/patch','@mail/core/common/attachment_view'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{AttachmentView}=require("@mail/core/common/attachment_view");patch(AttachmentView.prototype,{get displayName(){if(this.state.thread.model==='hr.expense.sheet'){return(this.state.thread.mainAttachment.res_name||this.state.thread.name);}
return super.displayName;}});return __exports;});;

/* /hr_expense/static/src/components/expense_dashboard.js */
odoo.define('@hr_expense/components/expense_dashboard',['@web/core/utils/hooks','@web/views/fields/formatters','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require('@web/core/utils/hooks');const{formatMonetary}=require("@web/views/fields/formatters");const{Component,onWillStart,useState}=require("@odoo/owl");const ExpenseDashboard=__exports.ExpenseDashboard=class ExpenseDashboard extends Component{static template="hr_expense.ExpenseDashboard";static props={};setup(){super.setup();this.orm=useService('orm');this.actionService=useService("action");this.state=useState({expenses:{}});onWillStart(async()=>{const expense_states=await this.orm.call("hr.expense",'get_expense_dashboard',[]);this.state.expenses=expense_states;});}
renderMonetaryField(value,currency_id){return formatMonetary(value,{currencyId:currency_id});;}
async applyFilter(filterName){const{actionId}=this.env.config;const action=actionId?await this.actionService.loadAction(actionId):{};action['context']={[`search_default_${filterName}`]:1};action['tag']='menu';return this.actionService.doAction(action);}}
return __exports;});;

/* /hr_expense/static/src/components/nb_attachment.js */
odoo.define('@hr_expense/components/nb_attachment',['@web/core/registry','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Component}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");class AttachmentNumber extends Component{static template="hr_expense.AttachmentNumber";static props={...standardFieldProps};setup(){super.setup();this.nb_attachment=this.props.record.data.nb_attachment}}
registry.category("fields").add("nb_attachment",{component:AttachmentNumber});return __exports;});;

/* /hr_expense/static/src/components/qrcode_action.js */
odoo.define('@hr_expense/components/qrcode_action',['@odoo/owl','@web/core/registry','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{sprintf}=require("@web/core/utils/strings");const actionRegistry=registry.category("actions");class QRModalComponent extends Component{static props={action:Object,actionId:{type:Number,optional:true},className:{type:String,optional:true},};static template="hr_expense.QRModalComponent";setup(){this.url=sprintf("/report/barcode/?barcode_type=QR&value=%s&width=256&height=256&humanreadable=1",this.props.action.params.url);}}
actionRegistry.add("expense_qr_code_modal",QRModalComponent);return __exports;});;

/* /hr_expense/static/src/mixins/document_upload.js */
odoo.define('@hr_expense/mixins/document_upload',['@web/core/l10n/translation','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useBus,useRefListener,useService}=require('@web/core/utils/hooks');const{onWillStart,useRef,useEffect,useState}=require("@odoo/owl");const ExpenseDocumentDropZone=__exports.ExpenseDocumentDropZone=(T)=>class ExpenseDocumentDropZone extends T{static props=[...T.props,'uploadDocument',];setup(){super.setup();this.dragState=useState({showDragZone:false,});this.root=useRef("root");useEffect((el)=>{if(!el){return;}
const highlight=this.highlight.bind(this);const unhighlight=this.unhighlight.bind(this);const drop=this.onDrop.bind(this);el.addEventListener("dragover",highlight);el.addEventListener("dragleave",unhighlight);el.addEventListener("drop",drop);return()=>{el.removeEventListener("dragover",highlight);el.removeEventListener("dragleave",unhighlight);el.removeEventListener("drop",drop);};},()=>[document.querySelector('.o_content')]);useRefListener(this.root,'click',(ev)=>{let targetElement=ev.target;if(targetElement.closest('.o_view_nocontent_expense_receipt')){this.props.uploadDocument();}});}
highlight(ev){ev.stopPropagation();ev.preventDefault();this.dragState.showDragZone=true;}
unhighlight(ev){ev.stopPropagation();ev.preventDefault();this.dragState.showDragZone=false;}
async onDrop(ev){ev.preventDefault();await this.env.bus.trigger("change_file_input",{files:ev.dataTransfer.files,});}};const ExpenseDocumentUpload=__exports.ExpenseDocumentUpload=(T)=>class ExpenseDocumentUpload extends T{setup(){super.setup();this.actionService=useService('action');this.notification=useService('notification');this.orm=useService('orm');this.http=useService('http');this.shareTarget=useService("shareTarget");this.fileInput=useRef('fileInput');this.root=useRef("root");useBus(this.env.bus,"change_file_input",async(ev)=>{this.fileInput.el.files=ev.detail.files;await this.onChangeFileInput();});onWillStart(async()=>{if(this.shareTarget.hasSharedFiles()){const files=this.shareTarget.getSharedFilesToUpload();await this._onChangeFileInput(files);}});}
displayCreateReport(){const isExpenseSheet=this.model.config.resModel==="hr.expense.sheet";const usesSampleData=this.model.useSampleModel;const records=this.model.root.records;return!usesSampleData&&!isExpenseSheet&&records.length&&records.some(record=>record.data.state==="draft");}
async action_show_expenses_to_submit(){const records=this.model.root.selection;const res=await this.orm.call(this.model.config.resModel,'get_expenses_to_submit',[records.map((record)=>record.resId)]);if(res){await this.actionService.doAction(res,{});}}
uploadDocument(){this.fileInput.el.click();}
async onChangeFileInput(){await this._onChangeFileInput([...this.fileInput.el.files]);}
async _onChangeFileInput(files){const params={csrf_token:odoo.csrf_token,ufile:files,model:'hr.expense',id:0,};const fileData=await this.http.post('/web/binary/upload_attachment',params,"text");const attachments=JSON.parse(fileData);if(attachments.error){throw new Error(attachments.error);}
await this.onUpload(attachments);}
async onUpload(attachments){const attachmentIds=attachments.map((a)=>a.id);if(!attachmentIds.length){this.notification.add(_t('An error occurred during the upload'));return;}
const action=await this.orm.call('hr.expense','create_expense_from_attachments',[attachmentIds,this.env.config.viewType],{context:this.props.context},);await this.actionService.doAction(action);}};return __exports;});;

/* /hr_expense/static/src/mixins/qrcode.js */
odoo.define('@hr_expense/mixins/qrcode',['@web/core/l10n/translation','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{onMounted,onPatched,useRef}=require("@odoo/owl");const ExpenseMobileQRCode=__exports.ExpenseMobileQRCode=(T)=>class ExpenseMobileQRCode extends T{setup(){super.setup();this.root=useRef('root');this.actionService=useService('action');onMounted(this.bindAppsIcons);onPatched(this.bindAppsIcons);}
bindAppsIcons(){const apps=this.root.el.querySelectorAll('.o_expense_mobile_app');if(!apps){return;}
const handler=this.handleClick.bind(this);for(const app of apps){app.addEventListener('click',handler);}}
handleClick(ev){ev.preventDefault();ev.stopPropagation();const url=ev.currentTarget&&ev.currentTarget.href;if(!this.env.isSmall){this.actionService.doAction({name:_t("Download our App"),type:"ir.actions.client",tag:'expense_qr_code_modal',target:"new",params:{url},});}else{this.actionService.doAction({type:"ir.actions.act_url",url});}}};return __exports;});;

/* /hr_expense/static/src/views/expense_form_view.js */
odoo.define('@hr_expense/views/expense_form_view',['@web/core/l10n/translation','@web/core/utils/hooks','@web/core/registry','@web/views/form/form_controller','@web/views/form/form_view','@web/core/confirmation_dialog/confirmation_dialog'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const{FormController}=require("@web/views/form/form_controller");const{formView}=require("@web/views/form/form_view");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const ExpenseFormController=__exports.ExpenseFormController=class ExpenseFormController extends FormController{setup(){super.setup();this.dialogService=useService("dialog");this.orm=useService("orm");}
async beforeExecuteActionButton(clickParams){const record=this.model.root;if(clickParams.name==="action_submit_expenses"&&record.data.duplicate_expense_ids.count){return new Promise((resolve)=>{this.dialogService.add(ConfirmationDialog,{body:_t("An expense of same category, amount and date already exists."),confirm:async()=>{await this.orm.call("hr.expense","action_approve_duplicates",[record.resId]);resolve(true);},},{onClose:resolve.bind(null,false),});});}
return super.beforeExecuteActionButton(...arguments);}}
const ExpenseFormView=__exports.ExpenseFormView={...formView,Controller:ExpenseFormController,};registry.category("views").add("hr_expense_form_view",ExpenseFormView);return __exports;});;

/* /hr_expense/static/src/views/expense_line_widget.js */
odoo.define('@hr_expense/views/expense_line_widget',['@web/core/registry','@web/core/utils/hooks','@web/views/list/list_renderer','@web/views/fields/x2many/x2many_field','@web/views/kanban/kanban_renderer','@web/views/kanban/kanban_record','@web/core/utils/functions','@web/core/file_viewer/file_viewer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{ListRenderer}=require("@web/views/list/list_renderer");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{KanbanRecord}=require("@web/views/kanban/kanban_record");const{uniqueId}=require("@web/core/utils/functions");const{FileViewer}=require("@web/core/file_viewer/file_viewer");const ExpenseLinesListRenderer=__exports.ExpenseLinesListRenderer=class ExpenseLinesListRenderer extends ListRenderer{setup(){super.setup();this.store=useService("mail.store");this.sheetId=this.env.model.root.resId;this.sheetThread=this.store.Thread.insert({model:"hr.expense.sheet",id:this.sheetId});}
async onCellClicked(record,column,ev){const attachmentChecksum=record.data.message_main_attachment_checksum;if(attachmentChecksum&&this.sheetThread.mainAttachment?.checksum!==attachmentChecksum){this.sheetThread.update({mainAttachment:this.sheetThread.attachments.find((attachment)=>attachment.checksum===attachmentChecksum)});}
super.onCellClicked(record,column,ev);}}
const ExpenseLinesKanbanRecord=__exports.ExpenseLinesKanbanRecord=class ExpenseLinesKanbanRecord extends KanbanRecord{setup(){super.setup();this.orm=useService("orm");}
async onGlobalClick(ev){const expenseName=this.props.record.data.name;const attachments=await this.orm.call('hr.expense','get_expense_attachments',[this.props.record.resId]);const files=attachments.map((attachment,index)=>({isImage:true,isViewable:true,displayName:expenseName+` (${index + 1})`,defaultSource:attachment,downloadUrl:attachment,}));const viewerId=uniqueId('web.file_viewer');if(files.length){registry.category("main_components").add(viewerId,{Component:FileViewer,props:{files:files,startIndex:0,close:()=>{registry.category('main_components').remove(viewerId);},},});}
super.onGlobalClick(ev);}}
const ExpenseLinesKanbanRenderer=__exports.ExpenseLinesKanbanRenderer=class ExpenseLinesKanbanRenderer extends KanbanRenderer{static components={...KanbanRenderer.components,KanbanRecord:ExpenseLinesKanbanRecord,};}
const ExpenseLinesWidget=__exports.ExpenseLinesWidget=class ExpenseLinesWidget extends X2ManyField{static components={...X2ManyField.components,ListRenderer:ExpenseLinesListRenderer,KanbanRenderer:ExpenseLinesKanbanRenderer,};setup(){super.setup();this.canOpenRecord=false;}
get isMany2Many(){return true;}}
const expenseLinesWidget=__exports.expenseLinesWidget={...x2ManyField,component:ExpenseLinesWidget,additionalClasses:["o_field_many2many"],};registry.category("fields").add("expense_lines_widget",expenseLinesWidget);return __exports;});;

/* /hr_expense/static/src/views/kanban.js */
odoo.define('@hr_expense/views/kanban',['@web/core/registry','@hr_expense/components/expense_dashboard','@hr_expense/mixins/qrcode','@hr_expense/mixins/document_upload','@web/views/kanban/kanban_view','@web/views/kanban/kanban_controller','@web/views/kanban/kanban_renderer'],function(require){'use strict';let __exports={};const{registry}=require('@web/core/registry');const{ExpenseDashboard}=require("@hr_expense/components/expense_dashboard");const{ExpenseMobileQRCode}=require("@hr_expense/mixins/qrcode");const{ExpenseDocumentUpload,ExpenseDocumentDropZone}=require("@hr_expense/mixins/document_upload");const{kanbanView}=require('@web/views/kanban/kanban_view');const{KanbanController}=require('@web/views/kanban/kanban_controller');const{KanbanRenderer}=require('@web/views/kanban/kanban_renderer');const ExpenseKanbanController=__exports.ExpenseKanbanController=class ExpenseKanbanController extends ExpenseDocumentUpload(KanbanController){static template="hr_expense.KanbanView";}
const ExpenseKanbanRenderer=__exports.ExpenseKanbanRenderer=class ExpenseKanbanRenderer extends ExpenseDocumentDropZone(ExpenseMobileQRCode(KanbanRenderer)){static template="hr_expense.KanbanRenderer";}
const ExpenseDashboardKanbanRenderer=__exports.ExpenseDashboardKanbanRenderer=class ExpenseDashboardKanbanRenderer extends ExpenseKanbanRenderer{static components={...ExpenseDashboardKanbanRenderer.components,ExpenseDashboard};static template="hr_expense.DashboardKanbanRenderer";}
registry.category('views').add('hr_expense_kanban',{...kanbanView,buttonTemplate:'hr_expense.KanbanButtons',Controller:ExpenseKanbanController,Renderer:ExpenseKanbanRenderer,});registry.category('views').add('hr_expense_dashboard_kanban',{...kanbanView,buttonTemplate:'hr_expense.KanbanButtons',Controller:ExpenseKanbanController,Renderer:ExpenseDashboardKanbanRenderer,});return __exports;});;

/* /hr_expense/static/src/views/list.js */
odoo.define('@hr_expense/views/list',['@hr_expense/components/expense_dashboard','@hr_expense/mixins/qrcode','@hr_expense/mixins/document_upload','@web/core/registry','@web/core/utils/hooks','@web/core/user','@web/views/list/list_view','@web/views/list/list_controller','@web/views/list/list_renderer','@odoo/owl'],function(require){'use strict';let __exports={};const{ExpenseDashboard}=require("@hr_expense/components/expense_dashboard");const{ExpenseMobileQRCode}=require("@hr_expense/mixins/qrcode");const{ExpenseDocumentUpload,ExpenseDocumentDropZone}=require("@hr_expense/mixins/document_upload");const{registry}=require('@web/core/registry');const{useService}=require('@web/core/utils/hooks');const{user}=require("@web/core/user");const{listView}=require("@web/views/list/list_view");const{ListController}=require("@web/views/list/list_controller");const{ListRenderer}=require("@web/views/list/list_renderer");const{onWillStart}=require("@odoo/owl");const ExpenseListController=__exports.ExpenseListController=class ExpenseListController extends ExpenseDocumentUpload(ListController){static template=`hr_expense.ListView`;setup(){super.setup();this.orm=useService('orm');this.actionService=useService('action');this.isExpenseSheet=this.model.config.resModel==="hr.expense.sheet";onWillStart(async()=>{this.userIsExpenseTeamApprover=await user.hasGroup("hr_expense.group_hr_expense_team_approver");this.userIsAccountInvoicing=await user.hasGroup("account.group_account_invoice");});}
displaySubmit(){const records=this.model.root.selection;return records.length&&records.every(record=>record.data.state==='draft')&&this.isExpenseSheet;}
displayApprove(){const records=this.model.root.selection;return this.userIsExpenseTeamApprover&&records.length&&records.every(record=>record.data.state==='submit')&&this.isExpenseSheet;}
displayPost(){const records=this.model.root.selection;return this.userIsAccountInvoicing&&records.length&&records.every(record=>record.data.state==='approve')&&this.isExpenseSheet;}
displayPayment(){const records=this.model.root.selection;return this.userIsAccountInvoicing&&records.length&&records.every(record=>record.data.state==='post'&&record.data.payment_state==='not_paid')&&this.isExpenseSheet;}
async onClick(action){const records=this.model.root.selection;const recordIds=records.map((a)=>a.resId);const model=this.model.config.resModel;const context={};if(action==='action_approve_expense_sheets'){context['validate_analytic']=true;}
const res=await this.orm.call(model,action,[recordIds],{context:context});if(res){await this.actionService.doAction(res,{additionalContext:{dont_redirect_to_payments:1,},onClose:async()=>{await this.model.root.load();this.render(true);}});}
await this.model.root.load();}}
const ExpenseListRenderer=__exports.ExpenseListRenderer=class ExpenseListRenderer extends ExpenseDocumentDropZone(ExpenseMobileQRCode(ListRenderer)){static template="hr_expense.ListRenderer";}
const ExpenseDashboardListRenderer=__exports.ExpenseDashboardListRenderer=class ExpenseDashboardListRenderer extends ExpenseListRenderer{static components={...ExpenseDashboardListRenderer.components,ExpenseDashboard};static template="hr_expense.DashboardListRenderer";}
registry.category('views').add('hr_expense_tree',{...listView,buttonTemplate:'hr_expense.ListButtons',Controller:ExpenseListController,Renderer:ExpenseListRenderer,});registry.category('views').add('hr_expense_dashboard_tree',{...listView,buttonTemplate:'hr_expense.ListButtons',Controller:ExpenseListController,Renderer:ExpenseDashboardListRenderer,});return __exports;});;

/* /hr_expense/static/src/js/tours/hr_expense.js */
odoo.define('@hr_expense/js/tours/hr_expense',['@web/core/l10n/translation','@web/core/registry','@web_tour/tour_service/tour_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{stepUtils}=require("@web_tour/tour_service/tour_utils");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add('hr_expense_tour',{url:"/odoo",steps:()=>[stepUtils.showAppsMenuItem(),{isActive:["community"],trigger:'.o_app[data-menu-xmlid="hr_expense.menu_hr_expense_root"]',content:markup(_t("<b>Wasting time recording your receipts?</b> Let’s try a better way.")),tooltipPosition:'right',run:"click",},{isActive:["enterprise"],trigger:'.o_app[data-menu-xmlid="hr_expense.menu_hr_expense_root"]',content:markup(_t("<b>Wasting time recording your receipts?</b> Let’s try a better way.")),tooltipPosition:'bottom',run:"click",},{isActive:["desktop"],trigger:".o_button_upload_expense",},{isActive:["desktop"],trigger:'.o_list_button_add',content:_t("It all begins here - let's go!"),tooltipPosition:'bottom',run:"click",},{isActive:["mobile"],trigger:".o_button_upload_expense",},{isActive:["mobile"],trigger:'.o-kanban-button-new',content:_t("It all begins here - let's go!"),tooltipPosition:'bottom',run:"click",},{trigger:".o_hr_expense_form_view_view",},{trigger:'.o_field_widget[name="product_id"] .o_input_dropdown',content:_t("Enter a name then choose a category and configure the amount of your expense."),tooltipPosition:'bottom',run:"click",},{trigger:".o_hr_expense_form_view_view",},{trigger:'.o_form_status_indicator_dirty .o_form_button_save',content:markup(_t("Ready? You can save it manually or discard modifications from here. You don't <em>need to save</em> - Odoo will save eveyrthing for you when you navigate.")),tooltipPosition:'bottom',run:"click",},...stepUtils.statusbarButtonsSteps(_t("Attach Receipt"),_t("Attach a receipt - usually an image or a PDF file.")),...stepUtils.statusbarButtonsSteps(_t("Create Report"),_t("Create a report to submit one or more expenses to your manager.")),...stepUtils.statusbarButtonsSteps(_t("Submit to Manager"),markup(_t('Once your <b>Expense Report</b> is ready, you can submit it to your manager and wait for approval.'))),{isActive:["mobile"],trigger:".o_hr_expense_form_view_view",},{isActive:["mobile"],trigger:".o_back_button",content:_t("Use the breadcrumbs to go back to the list of expenses."),tooltipPosition:"bottom",run:"click",},{trigger:".o_hr_expense_form_view_view",},{isActive:["desktop"],trigger:'.breadcrumb > li.breadcrumb-item:first',content:_t("Let's go back to your expenses."),tooltipPosition:'bottom',run:"click",},{trigger:'.o_expense_container',content:_t("The status of all your current expenses is visible from here."),tooltipPosition:'bottom',run:"click",},{isActive:["mobile"],trigger:".o_mobile_menu_toggle",content:_t("Open bugger menu."),tooltipPosition:"bottom",run:"click",},{trigger:".o_main_navbar",},{trigger:"[data-menu-xmlid='hr_expense.menu_hr_expense_report']",content:_t("Let's check out where you can manage all your employees expenses"),tooltipPosition:"bottom",run:"click",},{isActive:["desktop"],trigger:'.o_list_renderer tbody tr[data-id]',content:_t('Managers can inspect all expenses from here.'),tooltipPosition:'bottom',run:"click",},{isActive:["mobile"],trigger:'.o_kanban_renderer .oe_kanban_card',content:_t('Managers can inspect all expenses from here.'),tooltipPosition:'bottom',run:"click",},...stepUtils.statusbarButtonsSteps(_t("Approve"),_t("Managers can approve the report here, then an accountant can post the accounting entries.")),]});return __exports;});;

/* /hr_expense/static/src/js/tours/show_expense_receipt_tour.js */
odoo.define('@hr_expense/js/tours/show_expense_receipt_tour',['@web/core/registry','@web_tour/tour_service/tour_utils'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{stepUtils}=require("@web_tour/tour_service/tour_utils");registry.category("web_tour.tours").add("show_expense_receipt_tour",{url:"/odoo",steps:()=>[...stepUtils.goToAppSteps("hr_expense.menu_hr_expense_root","Go to the Expenses app"),{content:"Go to Expense Reports",trigger:'.dropdown-item[data-menu-xmlid="hr_expense.menu_hr_expense_report"]',tooltipPosition:"bottom",run:"click",},{content:"Go to a report",trigger:'.o_data_row .o_data_cell[name="payment_state"]',run:"click",},{content:"Wait chatter is loaded to avoid lost focus on the next step",trigger:".o-mail-Chatter:contains(the conversation is empty)",},{content:"Click on an expense line 2",trigger:'.o_data_row .o_data_cell[data-tooltip="expense_2"]',run:"click",},{content:"Check attachment",trigger:".o_attachment_preview .o-mail-Attachment-imgContainer .img[src*='test_file_2.png']",run:"click",},{content:"Click on an expense line 3",trigger:'.o_data_row .o_data_cell[data-tooltip="expense_3"]',run:"click",},{content:"Check attachment",trigger:".o_attachment_preview .o-mail-Attachment-imgContainer .img[src*='test_file_3.png']",run:"click",},{content:"Click on an expense line 1",trigger:'.o_data_row .o_data_cell[data-tooltip="expense_1"]',run:"click",},{content:"Check attachment",trigger:".o_attachment_preview .o-mail-Attachment-imgContainer .img[src*='test_file_1.png']",run:"click",},],});return __exports;});;

/* /hr_expense/static/src/js/web/activity_menu_patch.js */
odoo.define('@hr_expense/js/web/activity_menu_patch',['@mail/core/web/activity_menu','@web/core/ui/ui_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ActivityMenu}=require("@mail/core/web/activity_menu");const{MEDIAS_BREAKPOINTS,SIZES}=require("@web/core/ui/ui_service");const{patch}=require("@web/core/utils/patch");patch(ActivityMenu.prototype,{openActivityGroup(group){const expenseModels=["hr.expense.sheet","hr.expense"];if(expenseModels.includes(group.model)){const mobileMaxWidth=MEDIAS_BREAKPOINTS[SIZES.MD].minWidth;const onMobile=window.innerWidth<=mobileMaxWidth;if(onMobile){group.view_type="kanban";}}
return super.openActivityGroup(...arguments);},});return __exports;});;

/* /iap/static/src/action_buttons_widget/action_buttons_widget.js */
odoo.define('@iap/action_buttons_widget/action_buttons_widget',['@web/core/registry','@web/core/utils/hooks','@web/views/widgets/standard_widget_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{Component}=require("@odoo/owl");class IAPActionButtonsWidget extends Component{static template="iap.ActionButtonsWidget";static props={...standardWidgetProps,serviceName:String,showServiceButtons:Boolean,};setup(){this.orm=useService("orm");this.action=useService("action");}
async onViewServicesClicked(){this.action.doAction("iap.iap_account_action");}
async onManageServiceLinkClicked(){const account_id=await this.orm.silent.call("iap.account","get_account_id",[this.props.serviceName]);this.action.doAction({type:"ir.actions.act_window",res_model:"iap.account",res_id:account_id,views:[[false,"form"]],});}}
const iapActionButtonsWidget=__exports.iapActionButtonsWidget={component:IAPActionButtonsWidget,extractProps:({attrs})=>{return{serviceName:attrs.service_name,showServiceButtons:!Boolean(attrs.hide_service),};},};registry.category("view_widgets").add("iap_buy_more_credits",iapActionButtonsWidget);return __exports;});;

/* /iap/static/src/js/insufficient_credit_error_handler.js */
odoo.define('@iap/js/insufficient_credit_error_handler',['@web/core/dialog/dialog','@web/core/registry','@web/core/utils/hooks','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const{Component,onWillStart}=require("@odoo/owl");class InsufficientCreditDialog extends Component{static components={Dialog};static template="iap.InsufficientCreditDialog";static props={errorData:Object,close:Function,};setup(){this.orm=useService("orm");onWillStart(this.onWillStart);}
async onWillStart(){const{errorData}=this.props;this.url=await this.orm.call("iap.account","get_credits_url",[],{base_url:errorData.base_url,service_name:errorData.service_name,credit:errorData.credit,trial:errorData.trial,});this.style=errorData.body?"padding:0;":"";const{isEnterprise}=odoo.info;if(errorData.trial&&isEnterprise){this.buttonMessage=_t("Start a Trial at Odoo");}else{this.buttonMessage=_t("Buy credits");}}
buyCredits(){window.open(this.url,"_blank");this.props.close();}}
function insufficientCreditHandler(env,error,originalError){if(!originalError){return false;}
const{data}=originalError;if(data&&data.name==="odoo.addons.iap.tools.iap_tools.InsufficientCreditError"){env.services.dialog.add(InsufficientCreditDialog,{errorData:JSON.parse(data.message),});return true;}
return false;}
registry.category("error_handlers").add("insufficientCreditHandler",insufficientCreditHandler,{sequence:0});return __exports;});;

/* /iap_mail/static/src/js/services/iap_notification_service.js */
odoo.define('@iap_mail/js/services/iap_notification_service',['@web/core/l10n/translation','@web/core/registry','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{markup}=require("@odoo/owl");const iapNotificationService=__exports.iapNotificationService={dependencies:["bus_service","notification"],start(env,{bus_service,notification}){bus_service.subscribe("iap_notification",(params)=>{if(params.type=="no_credit"){displayCreditErrorNotification(params);}else{displayNotification(params);}});bus_service.start();function displayNotification(params){notification.add(params.message,{title:params.title,type:params.type,});}
function displayCreditErrorNotification(params){const translatedText=_t("Buy more credits");const message=markup(`
            <a class='btn btn-link' href='${params.get_credits_url}' target='_blank'>
                <i class='oi oi-arrow-right'></i>
                ${translatedText}
            </a>`);notification.add(message,{title:params.title,type:'danger',});}}};registry.category("services").add("iapNotification",iapNotificationService);return __exports;});;

/* /sms/static/src/components/phone_field/phone_field.js */
odoo.define('@sms/components/phone_field/phone_field',['@web/core/l10n/translation','@web/core/utils/patch','@web/views/fields/phone/phone_field','@sms/components/sms_button/sms_button'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{PhoneField,phoneField,formPhoneField}=require("@web/views/fields/phone/phone_field");const{SendSMSButton}=require('@sms/components/sms_button/sms_button');patch(PhoneField,{components:{...PhoneField.components,SendSMSButton},defaultProps:{...PhoneField.defaultProps,enableButton:true,},props:{...PhoneField.props,enableButton:{type:Boolean,optional:true},},});const patchDescr=()=>({extractProps({options}){const props=super.extractProps(...arguments);props.enableButton=options.enable_sms;return props;},supportedOptions:[{label:_t("Enable SMS"),name:"enable_sms",type:"boolean",default:true,}],});patch(phoneField,patchDescr());patch(formPhoneField,patchDescr());return __exports;});;

/* /sms/static/src/components/sms_button/sms_button.js */
odoo.define('@sms/components/sms_button/sms_button',['@web/core/l10n/translation','@web/core/user','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{Component,status}=require("@odoo/owl");const SendSMSButton=__exports.SendSMSButton=class SendSMSButton extends Component{static template="sms.SendSMSButton";static props=["*"];setup(){this.action=useService("action");this.title=_t("Send SMS");}
get phoneHref(){return"sms:"+this.props.record.data[this.props.name].replace(/\s+/g,"");}
async onClick(){await this.props.record.save();this.action.doAction({type:"ir.actions.act_window",target:"new",name:this.title,res_model:"sms.composer",views:[[false,"form"]],context:{...user.context,default_res_model:this.props.record.resModel,default_res_id:this.props.record.resId,default_number_field_name:this.props.name,default_composition_mode:"comment",},},{onClose:()=>{if(status(this)==="destroyed"){return;}
this.props.record.load();},});}}
return __exports;});;

/* /sms/static/src/components/sms_widget/fields_sms_widget.js */
odoo.define('@sms/components/sms_widget/fields_sms_widget',['@web/core/l10n/translation','@mail/views/web/fields/emojis_text_field/emojis_text_field','@web/core/utils/hooks','@web/core/registry'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{EmojisTextField,emojisTextField,}=require("@mail/views/web/fields/emojis_text_field/emojis_text_field");const{useService}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const SmsWidget=__exports.SmsWidget=class SmsWidget extends EmojisTextField{static template="sms.SmsWidget";setup(){super.setup();this._emojiAdded=()=>this.props.record.update({[this.props.name]:this.targetEditElement.el.value});this.notification=useService('notification');}
get encoding(){return this._extractEncoding(this.props.record.data[this.props.name]||'');}
get nbrChar(){const content=this._getValueForSmsCounts(this.props.record.data[this.props.name]||"");return content.length+(content.match(/\n/g)||[]).length;}
get nbrCharExplanation(){return"";}
get nbrSMS(){return this._countSMS(this.nbrChar,this.encoding);}
_countSMS(nbrChar,encoding){if(nbrChar===0){return 0;}
if(encoding==='UNICODE'){if(nbrChar<=70){return 1;}
return Math.ceil(nbrChar/67);}
if(nbrChar<=160){return 1;}
return Math.ceil(nbrChar/153);}
_extractEncoding(content){if(String(content).match(RegExp("^[@£$¥èéùìòÇ\\nØø\\rÅåΔ_ΦΓΛΩΠΨΣΘΞÆæßÉ !\\\"#¤%&'()*+,-./0123456789:;<=>?¡ABCDEFGHIJKLMNOPQRSTUVWXYZÄÖÑÜ§¿abcdefghijklmnopqrstuvwxyzäöñüà]*$"))){return'GSM7';}
return'UNICODE';}
_getValueForSmsCounts(value){return value;}
async onBlur(){await super.onBlur();var content=this.props.record.data[this.props.name]||'';if(!content.trim().length&&content.length>0){this.notification.add(_t("Your SMS Text Message must include at least one non-whitespace character"),{type:'danger'},)
await this.props.record.update({[this.props.name]:content.trim()});}}
async onInput(ev){super.onInput(...arguments);await this.props.record.update({[this.props.name]:this.targetEditElement.el.value});}}
const smsWidget=__exports.smsWidget={...emojisTextField,component:SmsWidget,additionalClasses:[...(emojisTextField.additionalClasses||[]),"o_field_text","o_field_text_emojis",],};registry.category("fields").add("sms_widget",smsWidget);return __exports;});;

/* /sms/static/src/core/failure_model_patch.js */
odoo.define('@sms/core/failure_model_patch',['@mail/core/common/failure_model','@web/core/l10n/translation','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Failure}=require("@mail/core/common/failure_model");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");patch(Failure.prototype,{get iconSrc(){if(this.type==="sms"){return"/sms/static/img/sms_failure.svg";}
return super.iconSrc;},get body(){if(this.type==="sms"){if(this.notifications.length===1&&this.lastMessage?.thread){return _t("An error occurred when sending an SMS on “%(record_name)s”",{record_name:this.lastMessage.thread.name,});}
return _t("An error occurred when sending an SMS");}
return super.body;},});return __exports;});;

/* /sms/static/src/core/notification_model_patch.js */
odoo.define('@sms/core/notification_model_patch',['@mail/core/common/notification_model','@web/core/l10n/translation','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Notification}=require("@mail/core/common/notification_model");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");patch(Notification.prototype,{get icon(){if(this.notification_type==="sms"){return"fa fa-mobile";}
return super.icon;},get label(){if(this.notification_type==="sms"){return _t("SMS");}
return super.label;},});return __exports;});;

/* /sms/static/src/messaging_menu/messaging_menu_patch.js */
odoo.define('@sms/messaging_menu/messaging_menu_patch',['@mail/core/public_web/messaging_menu','@web/core/l10n/translation','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{MessagingMenu}=require("@mail/core/public_web/messaging_menu");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");patch(MessagingMenu.prototype,{openFailureView(failure){if(failure.type==="email"){return super.openFailureView(failure);}
this.env.services.action.doAction({name:_t("SMS Failures"),type:"ir.actions.act_window",view_mode:"kanban,list,form",views:[[false,"kanban"],[false,"list"],[false,"form"],],target:"current",res_model:failure.resModel,domain:[["message_has_sms_error","=",true]],context:{create:false},});this.dropdown.close();},getFailureNotificationName(failure){if(failure.type==="sms"){return _t("SMS Failure: %(modelName)s",{modelName:failure.modelName});}
return super.getFailureNotificationName(...arguments);},});return __exports;});;

/* /sms/static/src/thread/message_patch.js */
odoo.define('@sms/thread/message_patch',['@mail/core/common/message','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message");const{patch}=require("@web/core/utils/patch");patch(Message.prototype,{onClickFailure(){if(this.message.message_type==="sms"){this.env.services.action.doAction("sms.sms_resend_action",{additionalContext:{default_mail_message_id:this.message.id,},});}else{super.onClickFailure(...arguments);}},});return __exports;});;

/* /base_automation/static/src/base_automation_actions_one2many_field.js */
odoo.define('@base_automation/base_automation_actions_one2many_field',['@odoo/owl','@web/core/l10n/translation','@web/core/registry','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{Component,useExternalListener,useEffect,useRef}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useThrottleForAnimation}=require("@web/core/utils/timing");class ActionsOne2ManyField extends Component{static props=["*"];static template="base_automation.ActionsOne2ManyField";static actionStates={code:_t("Execute Python Code"),object_create:_t("Create a new Record"),object_write:_t("Update the Record"),multi:_t("Execute several actions"),mail_post:_t("Send email"),followers:_t("Add followers"),remove_followers:_t("Remove followers"),next_activity:_t("Create next activity"),sms:_t("Send SMS"),};setup(){this.root=useRef("root");let adaptCounter=0;useEffect(()=>{this.adapt();},()=>[adaptCounter]);const throttledRenderAndAdapt=useThrottleForAnimation(()=>{adaptCounter++;this.render();});useExternalListener(window,"resize",throttledRenderAndAdapt);this.currentActions=this.props.record.data[this.props.name].records;this.hiddenActionsCount=0;}
async adapt(){const rootWidth=this.root.el.getBoundingClientRect().width;const actionsEls=Array.from(this.root.el.children).filter((el)=>el.dataset.actionId);actionsEls.forEach((el)=>el.classList.remove("d-none"));const actionsTotalWidth=actionsEls.reduce((sum,el)=>sum+el.getBoundingClientRect().width,0);let overflowingActionId;if(actionsTotalWidth>rootWidth){let width=56;for(const el of actionsEls){const elWidth=el.getBoundingClientRect().width;if(width+elWidth>rootWidth){overflowingActionId=el.dataset.actionId;const firstOverflowingEl=actionsEls.find((el)=>el.dataset.actionId===overflowingActionId);const firstOverflowingIndex=actionsEls.indexOf(firstOverflowingEl);const overflowingEls=actionsEls.slice(firstOverflowingIndex);overflowingEls.forEach((el)=>el.classList.add("d-none"));break;}
width+=elWidth;}}
const initialHiddenActionsCount=this.hiddenActionsCount;this.hiddenActionsCount=overflowingActionId?this.currentActions.length-
this.currentActions.findIndex((action)=>action.id===overflowingActionId):0;if(initialHiddenActionsCount!==this.hiddenActionsCount){return this.render();}}
getActionType(action){return this.constructor.actionStates[action.data.state]||action.data.state;}
get moreText(){const isPlural=this.hiddenActionsCount>1;return isPlural?_t("%s actions",this.hiddenActionsCount):_t("1 action");}}
const actionsOne2ManyField={component:ActionsOne2ManyField,relatedFields:[{name:"name",type:"char"},{name:"state",type:"selection",selection:[["code",_t("Execute Python Code")],["object_create",_t("Create a new Record")],["object_write",_t("Update the Record")],["multi",_t("Execute several actions")],["mail_post",_t("Send email")],["followers",_t("Add followers")],["remove_followers",_t("Remove followers")],["next_activity",_t("Create next activity")],["sms",_t("Send SMS")],],},{name:"code",type:"text"},{name:"crud_model_id",type:"many2one"},{name:"crud_model_name",type:"char"},{name:"partner_ids",type:"many2many"},{name:"template_id",type:"many2one"},{name:"mail_post_autofollow",type:"boolean"},{name:"mail_post_method",type:"selection",selection:[["email",_t("Email")],["comment",_t("Post as Message")],["note",_t("Post as Note")],],},{name:"activity_type_id",type:"many2one"},{name:"activity_summary",type:"char"},{name:"activity_note",type:"html"},{name:"activity_date_deadline_range",type:"integer"},{name:"activity_date_deadline_range_type",type:"selection",selection:[["days",_t("Days")],["weeks",_t("Weeks")],["months",_t("Months")],],},{name:"activity_user_type",type:"selection",selection:[["specific",_t("Specific User")],["generic",_t("Generic User")],],},{name:"activity_user_id",type:"many2one"},{name:"activity_user_field_name",type:"char"},],};registry.category("fields").add("base_automation_actions_one2many",actionsOne2ManyField);return __exports;});;

/* /base_automation/static/src/base_automation_error_dialog.js */
odoo.define('@base_automation/base_automation_error_dialog',['@web/core/errors/error_dialogs','@web/core/registry','@web/core/utils/hooks','@web/core/user'],function(require){'use strict';let __exports={};const{RPCErrorDialog}=require("@web/core/errors/error_dialogs");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{user}=require("@web/core/user");const BaseAutomationErrorDialog=__exports.BaseAutomationErrorDialog=class BaseAutomationErrorDialog extends RPCErrorDialog{static template="base_automation.ErrorDialog";setup(){super.setup(...arguments);const{id,name}=this.props.data.context.base_automation;this.automationId=id;this.automationName=name;this.isUserAdmin=user.isAdmin;this.actionService=useService("action");this.orm=useService("orm");}
async disableAutomation(ev){await this.orm.write("base.automation",[this.automationId],{active:false});this.props.close();}
editAutomation(ev){this.actionService.doAction({name:"Automation Rules",res_model:"base.automation",res_id:this.automationId,views:[[false,"form"]],type:"ir.actions.act_window",view_mode:"form",target:"new",});this.props.close();}}
registry.category("error_dialogs").add("base_automation",BaseAutomationErrorDialog);return __exports;});;

/* /base_automation/static/src/base_automation_trigger_selection_field.js */
odoo.define('@base_automation/base_automation_trigger_selection_field',['@odoo/owl','@web/core/l10n/translation','@web/core/registry','@web/model/relational_model/utils','@web/views/fields/selection/selection_field','@base_automation/utils','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useRecordObserver}=require("@web/model/relational_model/utils");const{selectionField,SelectionField}=require("@web/views/fields/selection/selection_field");const{TRIGGER_FILTERS}=require("@base_automation/utils");const{useService}=require("@web/core/utils/hooks");const OPT_GROUPS=[{group:{sequence:10,key:"values",name:_t("Values Updated")},triggers:["on_stage_set","on_user_set","on_tag_set","on_state_set","on_priority_set","on_archive","on_unarchive",],},{group:{sequence:30,key:"timing",name:_t("Timing Conditions")},triggers:["on_time","on_time_created","on_time_updated"],},{group:{sequence:40,key:"custom",name:_t("Custom")},triggers:["on_create_or_write","on_unlink","on_change"],},{group:{sequence:50,key:"external",name:_t("External")},triggers:["on_webhook"],},{group:{sequence:20,key:"mail",name:_t("Email Events")},triggers:["on_message_sent","on_message_received"],},{group:{sequence:60,key:"deprecated",name:_t("Deprecated (do not use)")},triggers:["on_create","on_write"],},];function computeDerivedOptions(options,fields,currentSelection,{excludeGroups=[]}={}){const derivedOptions=[];for(const[value,label]of options){const{group,triggers}=OPT_GROUPS.find((g)=>g.triggers.includes(value));if((group.key==="deprecated"&&!triggers.includes(currentSelection))||excludeGroups.includes(group.key)){continue;}
const filterFn=TRIGGER_FILTERS[value];if(filterFn){const triggerFields=fields.filter(filterFn);if(triggerFields.length===0){continue;}}
const option={group,value,label};derivedOptions.push(option);}
return derivedOptions;}
const TriggerSelectionField=__exports.TriggerSelectionField=class TriggerSelectionField extends SelectionField{static template="base_automation.TriggerSelectionField";setup(){super.setup();this.groupedOptions=useState([]);const orm=useService("orm");let lastRelatedModelId;let relatedModelFields;useRecordObserver(async(record)=>{const{data,fields}=record;const modelId=data.model_id?.[0];if(lastRelatedModelId!==modelId){lastRelatedModelId=modelId;relatedModelFields=await orm.searchRead("ir.model.fields",[["model_id","=",modelId]],["field_description","name","ttype","relation"]);}
const derivedOptions=computeDerivedOptions(fields[this.props.name].selection,relatedModelFields,data[this.props.name],{excludeGroups:data.model_is_mail_thread?[]:["mail"]});this.groupedOptions.length=0;for(const option of derivedOptions){const group=this.groupedOptions.find((g)=>g.key===option.group.key)??{...option.group,options:[],};group.options.push(option);if(!this.groupedOptions.includes(group)){this.groupedOptions.push(group);}}
this.groupedOptions.sort((a,b)=>a.sequence-b.sequence);});}}
const triggerSelectionField=__exports.triggerSelectionField={...selectionField,component:TriggerSelectionField,fieldDependencies:[{name:"model_is_mail_thread",type:"boolean"}],};registry.category("fields").add("base_automation_trigger_selection",triggerSelectionField);return __exports;});;

/* /base_automation/static/src/kanban_header_patch.js */
odoo.define('@base_automation/kanban_header_patch',['@web/core/l10n/translation','@web/core/registry','@web/core/user','@web/core/utils/hooks','@web/core/utils/patch','@web/views/kanban/kanban_header','@base_automation/utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");const{KanbanHeader}=require("@web/views/kanban/kanban_header");const{TRIGGER_FILTERS}=require("@base_automation/utils");const SUPPORTED_TRIGGERS=["on_stage_set","on_tag_set","on_state_set","on_priority_set","on_user_set","on_archive",];function enrichContext(context,group){const{displayName,groupByField,value}=group;const{name,relation,type:ttype}=groupByField;for(const trigger of SUPPORTED_TRIGGERS){if(!TRIGGER_FILTERS[trigger]({name,relation,ttype})){continue;}
switch(trigger){case"on_stage_set":return{...context,default_trigger:trigger,default_name:_t('Stage is set to "%s"',displayName),default_trg_field_ref:value,};case"on_tag_set":return{...context,default_trigger:trigger,default_name:_t('"%s" tag is added',displayName),default_trg_field_ref:value,};default:return{...context,default_trigger:trigger};}}
return{...context,default_trigger:"on_create_or_write"};}
patch(KanbanHeader.prototype,{setup(){super.setup();this.action=useService("action");},get permissions(){const permissions=super.permissions;Object.defineProperty(permissions,"canEditAutomations",{get:()=>user.isAdmin,configurable:true,});return permissions;},async openAutomations(){return this._openAutomations();},async _openAutomations(){const domain=[["model","=",this.props.list.resModel]];const modelId=await this.orm.search("ir.model",domain,{limit:1});const context={active_test:false,default_model_id:modelId[0],search_default_model_id:modelId[0],};this.action.doAction("base_automation.base_automation_act",{additionalContext:enrichContext(context,this.group),});},});registry.category("kanban_header_config_items").add("open_automations",{label:_t("Automations"),method:"openAutomations",isVisible:({permissions})=>permissions.canEditAutomations,class:"o_column_automations",},{sequence:25,force:true});return __exports;});;

/* /base_automation/static/src/utils.js */
odoo.define('@base_automation/utils',[],function(require){'use strict';let __exports={};const TRIGGER_FILTERS=__exports.TRIGGER_FILTERS={on_create_or_write:(f)=>true,on_create:(f)=>true,on_write:(f)=>true,on_change:(f)=>true,on_unlink:(f)=>true,on_time:(f)=>true,on_time_created:(f)=>f.ttype==="datetime"&&f.name==="create_date",on_time_updated:(f)=>f.ttype==="datetime"&&f.name==="write_date",on_stage_set:(f)=>f.ttype==="many2one"&&["stage_id","x_studio_stage_id"].includes(f.name),on_user_set:(f)=>f.relation==="res.users"&&["many2one","many2many"].includes(f.ttype)&&["user_id","user_ids","x_studio_user_id","x_studio_user_ids"].includes(f.name),on_tag_set:(f)=>f.ttype==="many2many"&&["tag_ids","x_studio_tag_ids"].includes(f.name),on_state_set:(f)=>f.ttype==="selection"&&["state","x_studio_state"].includes(f.name),on_priority_set:(f)=>f.ttype==="selection"&&["priority","x_studio_priority"].includes(f.name),on_archive:(f)=>f.ttype==="boolean"&&["active","x_active"].includes(f.name),on_unarchive:(f)=>f.ttype==="boolean"&&["active","x_active"].includes(f.name),on_webhook:(f)=>true,};return __exports;});;

/* /base_import_module/static/src/base_import_list_renderer.js */
odoo.define('@base_import_module/base_import_list_renderer',['@web/views/list/list_renderer'],function(require){'use strict';let __exports={};const{ListRenderer}=require("@web/views/list/list_renderer");const ImportModuleListRenderer=__exports.ImportModuleListRenderer=class ImportModuleListRenderer extends ListRenderer{get hasSelectors(){return super.hasSelectors&&this.props.list.records.every(record=>record._values.module_type!='industries');}
async onCellClicked(record,column,ev){if(record._values.module_type&&record._values.module_type!=='official'){const re_action={name:"more_info",res_model:"ir.module.module",res_id:-1,type:"ir.actions.act_window",views:[[false,"form"]],context:{'module_name':record._values.name,'module_type':record._values.module_type,}}
this.env.services.action.doAction(re_action);}
else{super.onCellClicked(record,column,ev);}}}
return __exports;});;

/* /base_import_module/static/src/base_import_list_view.js */
odoo.define('@base_import_module/base_import_list_view',['@web/core/registry','@web/views/list/list_view','@base_import_module/base_import_list_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{ImportModuleListRenderer}=require("@base_import_module/base_import_list_renderer");const ImportModuleListView=__exports.ImportModuleListView={...listView,Renderer:ImportModuleListRenderer,}
registry.category("views").add("ir_module_module_tree_view",ImportModuleListView);return __exports;});;

/* /web_studio/static/src/systray_item/systray_item.js */
odoo.define('@web_studio/systray_item/systray_item',['@web/core/registry','@web/core/user','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{Component,useRef}=require("@odoo/owl");class StudioSystray extends Component{static template="web_studio.SystrayItem";static props={};setup(){this.hm=useService("home_menu");this.studio=useService("studio");this.rootRef=useRef("root");this.isLoading=false;this.env.bus.addEventListener("ACTION_MANAGER:UPDATE",()=>{this.isLoading=true;if(this.rootRef.el){this.rootRef.el.classList.toggle("o_disabled",this.buttonDisabled);}});this.env.bus.addEventListener("ACTION_MANAGER:UI-UPDATED",(ev)=>{this.isLoading=false;const mode=ev.detail;if(mode!=="new"&&this.rootRef.el){this.rootRef.el.classList.toggle("o_disabled",this.buttonDisabled);}});}
get buttonDisabled(){return this.isLoading||!this.studio.isStudioEditable();}
_onClick(){if(!this.isLoading){this.studio.open();}}}
const systrayItem=__exports.systrayItem={Component:StudioSystray,isDisplayed:()=>user.isSystem,};registry.category("systray").add("StudioSystrayItem",systrayItem,{sequence:1});return __exports;});;

/* /web_studio/static/src/studio_service.js */
odoo.define('@web_studio/studio_service',['@web/core/network/rpc','@web/core/registry','@web/views/view_compiler','@web/core/l10n/translation','@odoo/owl','@web/core/utils/hooks','@web/core/browser/router'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{resetViewCompilerCache}=require("@web/views/view_compiler");const{_t}=require("@web/core/l10n/translation");const{EventBus,onWillUnmount,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{router}=require("@web/core/browser/router");const URL_VIEW_KEY="_view_type";const URL_ACTION_KEY="_action";const URL_TAB_KEY="_tab";const URL_MODE_KEY="mode";const URL_REPORT_ID_KEY="_report_id";const MODES=__exports.MODES={EDITOR:"editor",HOME_MENU:"home_menu",APP_CREATOR:"app_creator",};const NotEditableActionError=__exports.NotEditableActionError=class NotEditableActionError extends Error{}
const SUPPORTED_VIEW_TYPES={activity:_t("Activity"),calendar:_t("Calendar"),cohort:_t("Cohort"),form:_t("Form"),gantt:_t("Gantt"),graph:_t("Graph"),kanban:_t("Kanban"),list:_t("List"),map:_t("Map"),pivot:_t("Pivot"),search:_t("Search"),};__exports.viewTypeToString=viewTypeToString;function viewTypeToString(vType){return SUPPORTED_VIEW_TYPES[vType]||vType;}
const studioService=__exports.studioService={dependencies:["action","home_menu","menu","notification"],async start(env,{menu,notification}){const supportedViewTypes=Object.keys(SUPPORTED_VIEW_TYPES);function _getCurrentAction(){const currentController=env.services.action.currentController;return currentController&&!currentController.virtual?currentController.action:null;}
function _isStudioEditable(action){if(action.type==="ir.actions.client"){return action.tag==="menu"?true:false;}
if(action.type==="ir.actions.act_window"&&action.xml_id){if(action.res_model.indexOf("settings")>-1&&action.res_model.indexOf("x_")!==0){return false;}
if(action.res_model==="board.board"){return false;}
if(action.view_mode==="qweb"){return false;}
if(action.res_model==="knowledge.article"){return false;}
if(action.view_id&&action.view_id[1]==="res.users.preferences.form.inherit"){return false;}
return action.res_model?true:false;}
return false;}
function isViewEditable(view){return view&&supportedViewTypes.includes(view);}
const bus=new EventBus();let inStudio=false;const menuSelectMenu=menu.selectMenu;menu.selectMenu=async(argMenu)=>{if(!inStudio){return menuSelectMenu.call(menu,argMenu);}else{try{argMenu=typeof argMenu==="number"?menu.getMenu(argMenu):argMenu;await open(MODES.EDITOR,argMenu.actionID);menu.setCurrentMenu(argMenu);}catch(e){if(e instanceof NotEditableActionError){notification.add(_t("This action is not editable by Studio"),{type:"danger",});return;}
throw e;}}};const state={studioMode:null,editedViewType:null,editedAction:null,editedControllerState:null,editorTab:"views",editedReport:null,};async function _loadParamsFromURL(){const urlState=router.current;if(urlState.action==="studio"){state.studioMode=urlState[URL_MODE_KEY];state.editedViewType=urlState[URL_VIEW_KEY]||null;const editorTab=urlState[URL_TAB_KEY]||null;state.editorTab=editorTab;if(editorTab==="reports"){const reportId=urlState[URL_REPORT_ID_KEY]||null;if(reportId){state.editedReport={res_id:reportId};}}
const editedActionId=urlState[URL_ACTION_KEY];const additionalContext={};if(state.studioMode===MODES.EDITOR){const{active_id,active_ids}=urlState;if(active_id){additionalContext.active_id=active_id;additionalContext.active_ids=[active_id];}
if(active_ids){additionalContext.active_ids=active_ids.split(",").map(Number);}
if(editedActionId){state.editedAction=await env.services.action.loadAction(editedActionId,additionalContext);}else{state.editedAction=null;}}
if(!state.editedAction||!_isStudioEditable(state.editedAction)){state.studioMode=state.studioMode||MODES.HOME_MENU;state.editedAction=null;state.editedViewType=null;state.editorTab=null;}}}
const studioProm=_loadParamsFromURL();async function _openStudio(targetMode,action=false,viewType=false){if(!targetMode){throw new Error("mode is mandatory");}
const previousState={...state};const options={};if(targetMode===MODES.EDITOR){let controllerState;if(!action){const currentController=env.services.action.currentController;if(currentController){action=currentController.action;viewType=currentController.view.type;controllerState=Object.assign({},currentController.getLocalState());const{resIds}=currentController.getGlobalState()||{};controllerState.resIds=resIds||[controllerState.resId];}}
if(!_isStudioEditable(action)){throw new NotEditableActionError();}
if(action!==state.editedAction){options.clearBreadcrumbs=true;options.noEmptyTransition=true;}
state.editedAction=action;const vtype=viewType||action.views[0][1];state.editedViewType=isViewEditable(vtype)?vtype:null;state.editorTab="views";state.editedControllerState=controllerState||{};}
if(inStudio){options.stackPosition="replaceCurrentAction";}
state.studioMode=targetMode;let res;try{res=await env.services.action.doAction("studio",options);}catch(e){Object.assign(state,previousState);throw e;}
return res;}
async function open(mode=false,actionId=false){if(!mode&&inStudio){throw new Error("can't already be in studio");}
if(!mode){mode=env.services.home_menu.hasHomeMenu?MODES.HOME_MENU:MODES.EDITOR;}
let action;if(actionId){action=await env.services.action.loadAction(actionId);}
resetViewCompilerCache();return _openStudio(mode,action);}
async function leave(actionId){if(!inStudio){throw new Error("leave when not in studio???");}
env.bus.trigger("CLEAR-CACHES");const options={onActionReady:()=>resetViewCompilerCache(),stackPosition:"replacePreviousAction",};if(!actionId){if(state.studioMode===MODES.EDITOR){actionId=state.editedAction.id;options.additionalContext=state.editedAction.context;options.viewType=state.editedViewType;if(state.editedControllerState){options.props={resId:state.editedControllerState.resId};}}else{actionId="menu";}}
await env.services.action.doAction(actionId,options);env.bus.trigger("MENUS:APP-CHANGED");state.studioMode=null;}
async function reload(params={},reset=true){resetViewCompilerCache();env.bus.trigger("CLEAR-CACHES");const actionContext=state.editedAction.context;let additionalContext;if(actionContext.active_id){additionalContext={active_id:actionContext.active_id};}
if(actionContext.active_ids){additionalContext=Object.assign(additionalContext||{},{active_ids:actionContext.active_ids,});}
const action=await env.services.action.loadAction(state.editedAction.id,additionalContext);setParams({action,...params},reset);}
function toggleHomeMenu(){if(!inStudio){throw new Error("is it possible?");}
let targetMode;if(state.studioMode===MODES.APP_CREATOR||state.studioMode===MODES.EDITOR){targetMode=MODES.HOME_MENU;}else{targetMode=MODES.EDITOR;}
const action=targetMode===MODES.EDITOR?state.editedAction:null;if(targetMode===MODES.EDITOR&&!action){throw new Error("this button should not be clickable/visible");}
const viewType=targetMode===MODES.EDITOR?state.editedViewType:null;return _openStudio(targetMode,action,viewType);}
function pushState(){const search={action:"studio"};search[URL_MODE_KEY]=state.studioMode;search[URL_ACTION_KEY]=undefined;search[URL_VIEW_KEY]=undefined;search[URL_TAB_KEY]=undefined;if(state.studioMode===MODES.EDITOR){search[URL_ACTION_KEY]=JSON.stringify(state.editedAction.id);search[URL_VIEW_KEY]=state.editedViewType||undefined;search[URL_TAB_KEY]=state.editorTab;}
if(state.editedAction&&state.editedAction.context&&state.editedAction.context.active_id){search.active_id=state.editedAction.context.active_id;}
if(state.editorTab==="reports"&&state.editedReport){search[URL_REPORT_ID_KEY]=state.editedReport.res_id;}
router.pushState(search,{replace:true});}
function setParams(params={},reset=true){if("mode"in params){state.studioMode=params.mode;}
if("viewType"in params){state.editedViewType=params.viewType||null;}
if("action"in params){if((state.editedAction&&state.editedAction.id)!==params.action.id){state.editedControllerState=null;}
state.editedAction=params.action||null;}
if("editorTab"in params){state.editorTab=params.editorTab;if(!("viewType"in params)){state.editedViewType=null;}
if(!("editedReport"in params)){state.editedReport=null;}}
if("editedReport"in params){state.editedReport=params.editedReport;}
if("controllerState"in params){state.editedControllerState=params.controllerState;}
if(state.editorTab!=="reports"){state.editedReport=null;}
bus.trigger("UPDATE",{reset});}
env.bus.addEventListener("ACTION_MANAGER:UI-UPDATED",(ev)=>{const mode=ev.detail;if(mode==="new"){return;}
const action=_getCurrentAction();inStudio=action.tag==="studio";});const isAllowedCache={activity:{},chatter:{},};function isAllowed(type,resModel){if(!Object.keys(isAllowedCache).includes(type)){return;}
let val;if(resModel in isAllowedCache[type]){val=isAllowedCache[type][resModel];}else{val=rpc(`/web_studio/${type}_allowed`,{model:resModel});isAllowedCache[type][resModel]=val;}
return val;}
return{MODES,bus,isStudioEditable(){const action=_getCurrentAction();return action?_isStudioEditable(action):false;},open,reload,pushState,leave,toggleHomeMenu,setParams,get ready(){return studioProm;},get mode(){return state.studioMode;},get editedAction(){return state.editedAction;},get editedViewType(){return state.editedViewType;},get editedControllerState(){return state.editedControllerState;},get editedReport(){return state.editedReport;},get editorTab(){return state.editorTab;},isAllowed,};},};registry.category("services").add("studio",studioService);__exports.useStudioServiceAsReactive=useStudioServiceAsReactive;function useStudioServiceAsReactive(){const studio=useService("studio");const state=useState({...studio});state.requestId=1;function onUpdate({detail}){Object.assign(state,studio);if(detail.reset){state.requestId++;}}
studio.bus.addEventListener("UPDATE",onUpdate);onWillUnmount(()=>studio.bus.removeEventListener("UPDATE",onUpdate));return state;}
function actionLeave(env,action){const actionId=action.context.action_id;return env.services.studio.leave(actionId);}
registry.category("actions").add("action_web_studio_leave_with",actionLeave);return __exports;});;

/* /web_studio/static/src/utils.js */
odoo.define('@web_studio/utils',[],function(require){'use strict';let __exports={};const COLORS=__exports.COLORS=["#FFFFFF","#262c34","#f1c40f","#FBB130","#FC787D","#EB5A46","#9b59b6","#0079BF","#1BB6F9","#4dd0e1","#00CEB3","#2ecc71",];const BG_COLORS=__exports.BG_COLORS=["#FFFFFF","#1abc9c","#58a177","#B4C259","#56829f","#636DA9","#34495e","#BC4242","#C6572A","#d49054","#D89F45","#DAB852","#606060","#6B6C70","#838383",];__exports.getFontAwesomeIcons=getFontAwesomeIcons;function getFontAwesomeIcons(){const styleSheet=[...document.styleSheets].find((s)=>s&&s.href&&s.href.includes("/web/"));const fontAwesomeStyles=[...styleSheet.cssRules].filter((e)=>/^\.fa-.*:before/.test(e.selectorText)).filter((e)=>e&&e.style&&e.style.length===1&&e.style[0]==="content");return fontAwesomeStyles.map((rule)=>{const classNames=rule.selectorText.split(/:?:before|,/).filter((e)=>e.length>1);const searchTerms=classNames.map((selector)=>selector.replace(".fa-","").replace(/-o$/g," (Outline)").replaceAll("-"," "));return{className:"fa "+classNames[0].slice(1),searchTerms,tooltip:searchTerms[0].charAt(0).toUpperCase()+searchTerms[0].slice(1),};});}
__exports.randomString=randomString;function randomString(string_length){var chars="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";var randomstring="";for(var i=0;i<string_length;i++){var rnum=Math.floor(Math.random()*chars.length);randomstring+=chars.substring(rnum,rnum+1);}
return randomstring;}
__exports[Symbol.for("default")]={BG_COLORS,COLORS,randomString,};return __exports;});;

/* /web_studio/static/src/client_action/studio_action_loader.js */
odoo.define('@web_studio/client_action/studio_action_loader',['@web/core/registry','@web/core/assets','@web/core/browser/cookie','@web/webclient/actions/action_service','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{LazyComponent}=require("@web/core/assets");const{cookie}=require("@web/core/browser/cookie");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");const{Component,xml}=require("@odoo/owl");class StudioActionLoader extends Component{static components={LazyComponent};static template=xml`
        <LazyComponent bundle="bundle" Component="'StudioClientAction'" props="props"/>
    `;static props={...standardActionServiceProps,props:{type:Object,optional:true},Component:{type:Function,optional:true},};setup(){this.bundle=cookie.get("color_scheme")==="dark"?"web_studio.studio_assets_dark":"web_studio.studio_assets";}}
registry.category("actions").add("studio",StudioActionLoader);return __exports;});;

/* /web_studio/static/src/client_action/app_creator/app_creator_shortcut.js */
odoo.define('@web_studio/client_action/app_creator/app_creator_shortcut',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const actionRegistry=registry.category("actions");actionRegistry.add("action_web_studio_app_creator",(env)=>env.services.studio.open(env.services.studio.MODES.APP_CREATOR));return __exports;});;

/* /web_studio/static/src/client_action/components/font_awesome_icon_selector/font_awesome_icon_selector.js */
odoo.define('@web_studio/client_action/components/font_awesome_icon_selector/font_awesome_icon_selector',['@odoo/owl','@web/core/select_menu/select_menu','@web_studio/utils'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{SelectMenu}=require("@web/core/select_menu/select_menu");const{getFontAwesomeIcons}=require("@web_studio/utils");const FontAwesomeIconSelector=__exports.FontAwesomeIconSelector=class FontAwesomeIconSelector extends Component{static defaultProps={className:"",menuClassName:"",};static template="web_studio.FontAwesomeIconSelector";static props={className:{type:String,optional:true},menuClassName:{type:String,optional:true},value:{type:String},onSelect:{type:Function,optional:true},slots:true,};static components={SelectMenu};setup(){this.ICONS=getFontAwesomeIcons();}
get iconChoices(){return this.ICONS.map((icon)=>{return{label:icon.searchTerms.join(" "),value:icon.className,};});}
getIconTooltip(value){return this.ICONS.find((icon)=>icon.className===value).tooltip;}}
return __exports;});;

/* /web_studio/static/src/client_action/components/sidebar_draggable_item/sidebar_draggable_item.js */
odoo.define('@web_studio/client_action/components/sidebar_draggable_item/sidebar_draggable_item',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const SidebarDraggableItem=__exports.SidebarDraggableItem=class SidebarDraggableItem extends Component{static template="web_studio.SidebarDraggableItem";static props={className:{type:String,optional:true},description:{type:String,optional:true},dropData:{optional:true},string:{type:String},structure:{type:String},};}
return __exports;});;

/* /web_studio/static/src/client_action/components/thumbnail_item/thumbnail_item.js */
odoo.define('@web_studio/client_action/components/thumbnail_item/thumbnail_item',['@odoo/owl','@web/core/dropdown/dropdown'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const ThumbnailItem=__exports.ThumbnailItem=class ThumbnailItem extends Component{static defaultProps={showMoreMenu:true,onClick:()=>{},};static template="web_studio.ThumbnailItem";static props={className:{type:String,optional:true},showMoreMenu:{type:Boolean,optional:true},icon:{type:Object},onClick:{type:Function,optional:true},slots:true,};static components={Dropdown};get hasDropdown(){return this.props.showMoreMenu&&this.props.slots&&this.props.slots.dropdown;}}
return __exports;});;

/* /web_studio/static/src/export/studio_export_action.js */
odoo.define('@web_studio/export/studio_export_action',['@web/core/registry','@web/core/network/download','@web/core/utils/objects'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{download}=require("@web/core/network/download");const{pick}=require("@web/core/utils/objects");async function studioExportAction(_env,action){await download({url:"/web_studio/export",data:pick(action.context,["active_id"]),});}
registry.category("actions").add("studio_export_action",studioExportAction);return __exports;});;

/* /web_studio/static/src/home_menu/home_menu.js */
odoo.define('@web_studio/home_menu/home_menu',['@web_enterprise/webclient/home_menu/home_menu','@web/core/utils/urls','@web/core/utils/patch','@odoo/owl'],function(require){'use strict';let __exports={};const{HomeMenu}=require("@web_enterprise/webclient/home_menu/home_menu");const{url}=require("@web/core/utils/urls");const{patch}=require("@web/core/utils/patch");const{onMounted,onWillUnmount}=require("@odoo/owl");patch(HomeMenu.prototype,{setup(){super.setup();if(!this.menus.getMenu("root").backgroundImage){return;}
this.backgroundImageUrl=url("/web/image",{id:this.env.services.company.currentCompany.id,model:"res.company",field:"background_image",});onMounted(()=>{document.body.classList.add("o_home_menu_background");document.body.classList.toggle("o_home_menu_background_custom",this.menus.getMenu("root").backgroundImage);});onWillUnmount(()=>{document.body.classList.remove("o_home_menu_background","o_home_menu_background_custom");});},});return __exports;});;

/* /web_studio/static/src/views/list/list_renderer.js */
odoo.define('@web_studio/views/list/list_renderer',['@web/core/utils/patch','@web/views/list/list_renderer','@web/core/utils/hooks','@web_enterprise/views/list/list_renderer_desktop'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{ListRenderer}=require("@web/views/list/list_renderer");const{useService}=require("@web/core/utils/hooks");require("@web_enterprise/views/list/list_renderer_desktop");const patchListRendererStudio=__exports.patchListRendererStudio=()=>({setup(){super.setup(...arguments);this.studioService=useService("studio");},onSelectedAddCustomField(){this.studioService.open();},isStudioEditable(){return!this.studioService.mode&&super.isStudioEditable();},});const unpatchListRendererStudio=__exports.unpatchListRendererStudio=patch(ListRenderer.prototype,patchListRendererStudio());return __exports;});;

/* /web_studio/static/src/js/tours/web_studio_tour.js */
odoo.define('@web_studio/js/tours/web_studio_tour',['@web/core/l10n/translation','@web/core/registry','@odoo/owl','@web_studio/utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{markup}=require("@odoo/owl");const utils=require("@web_studio/utils")[Symbol.for("default")];registry.category("web_tour.tours").add("web_studio_new_app_tour",{url:"/odoo/action-studio?mode=home_menu",steps:()=>[{trigger:".o_web_studio_new_app",tooltipPosition:"bottom",run:"click",},{trigger:".o_web_studio_app_creator_next",content:markup(_t("I bet you can <b>build an app</b> in 5 minutes. Ready for the challenge?")),tooltipPosition:"top",run:"click",},{trigger:".o_web_studio_app_creator_name > input",content:markup(_t("How do you want to <b>name</b> your app? Library, Academy, …?")),tooltipPosition:"right",run:"edit "+utils.randomString(6),},{trigger:".o_web_studio_selectors .o_web_studio_selector_icon > button",content:_t("Now, customize your icon. Make it yours."),tooltipPosition:"top",run:"click",},{trigger:".o_web_studio_app_creator_next.is_ready",content:_t("Go on, you are almost done!"),tooltipPosition:"top",run:"click",},{trigger:".o_web_studio_menu_creator > input",content:markup(_t("How do you want to name your first <b>menu</b>? My books, My courses?")),tooltipPosition:"right",run:"edit "+utils.randomString(6),},{trigger:".o_web_studio_app_creator_next.is_ready",content:_t("Continue to configure some typical behaviors for your new type of object."),tooltipPosition:"bottom",run:"click",},{trigger:".o_web_studio_model_configurator_next",content:markup(_t("All set? You are just one click away from <b>generating your first app</b>.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_web_studio_sidebar .o_web_studio_field_type_container:eq(1) .o_web_studio_field_char",content:markup(_t("Nicely done! Let's build your screen now; <b>drag</b> a <i>text field</i> and <b>drop</b> it in your view, on the right.")),tooltipPosition:"bottom",run:"drag_and_drop .o_web_studio_form_view_editor .o_inner_group",timeout:60000,},{trigger:".o_web_studio_form_view_editor .o_wrap_label label",content:markup(_t("To <b>customize a field</b>, click on its <i>label</i>.")),tooltipPosition:"bottom",run:"click",},{trigger:'.o_web_studio_sidebar input[name="string"]',content:markup(_t("Here, you can <b>name</b> your field (e.g. Book reference, ISBN, Internal Note, etc.).")),tooltipPosition:"bottom",run:"edit My Field && click body",},{trigger:".o_web_studio_form_view_editor .o_wrap_label label:contains(My Field)",},{trigger:".o_web_studio_sidebar .o_web_studio_new",content:markup(_t("Good job! To add more <b>fields</b>, come back to the <i>Add tab</i>.")),tooltipPosition:"bottom",timeout:20000,run:"click",},{trigger:".o_web_studio_sidebar .o_web_studio_field_type_container:eq(1) .o_web_studio_field_selection",content:markup(_t("Drag & drop <b>another field</b>. Let's try with a <i>selection field</i>.")),tooltipPosition:"bottom",run:"drag_and_drop .o_web_studio_form_view_editor .o_inner_group",},{trigger:".o_web_studio_selection_editor .o_web_studio_add_selection input",content:markup(_t("Create your <b>selection values</b> (e.g.: Romance, Polar, Fantasy, etc.)")),tooltipPosition:"top",run:"edit "+utils.randomString(6),},{trigger:".o_web_studio_selection_editor .o_web_studio_add_selection .o-web-studio-interactive-list-edit-item",run:"click",},{trigger:".modal-footer > button:eq(0)",run:"click",},{trigger:".o_web_studio_form_view_editor .o-mail-Chatter",content:_t("Click to edit messaging features on your model."),tooltipPosition:"top",run:"click",timeout:15000,},{trigger:'.o_web_studio_sidebar input[name="email_alias"]',content:markup(_t("Set an <b>email alias</b>. Then, try to send an email to this address; it will create a document automatically for you. Pretty cool, huh?")),tooltipPosition:"bottom",run:"edit Test",},{trigger:".o_web_studio_leave",content:markup(_t("Let's check the result. Close Odoo Studio to get an <b>overview of your app</b>.")),tooltipPosition:"left",run:"click",},{trigger:".o_field_char.o_required_modifier > input",tooltipPosition:"bottom",run:"edit Test",},{trigger:".o_control_panel .o_form_button_save",content:_t("Save."),tooltipPosition:"right",run:"click",},{trigger:".o_form_view .o_form_saved",},{trigger:".o_web_studio_navbar_item",content:markup(_t("Wow, nice! And I'm sure you can make it even better! Use this icon to open <b>Odoo Studio</b> and customize any screen.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_web_studio_menu .o_menu_sections li:contains(Views)",content:markup(_t("Want more fun? Let's create more <b>views</b>.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_web_studio_view_category .o_web_studio_thumbnail_kanban.disabled",content:markup(_t("What about a <b>Kanban view</b>?")),tooltipPosition:"bottom",run:"click",},{trigger:".o_web_studio_sidebar .o_web_studio_new",content:markup(_t("Now you're on your own. Enjoy your <b>super power</b>.")),tooltipPosition:"bottom",},],});return __exports;});;

/* /web_studio/static/src/approval/approval_hook.js */
odoo.define('@web_studio/approval/approval_hook',['@web/core/utils/hooks','@web/core/l10n/translation','@odoo/owl','@web/model/relational_model/utils','@web/core/utils/concurrency','@web/core/registry'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const{reactive,useComponent,useEnv,toRaw,onMounted,onWillDestroy}=require("@odoo/owl");const{useRecordObserver}=require("@web/model/relational_model/utils");const{Deferred}=require("@web/core/utils/concurrency");const{registry}=require("@web/core/registry");function batched(callback,synchronize=()=>Promise.resolve()){const map=new Map();let callId=0;return(...args)=>{if(!map.has(callId)){const argsList=[args];const prom=new Deferred();map.set(callId,{argsList,prom});synchronize().then(()=>{const currentCallId=callId++;Promise.resolve(callback(...argsList)).then(prom.resolve).catch(prom.reject).finally(()=>map.delete(currentCallId));});return prom;}else{const{prom,argsList}=map.get(callId);argsList.push(args);return prom;}};}
__exports.buildApprovalKey=buildApprovalKey;function buildApprovalKey(...args){return args.join("-");}
const getApprovalSpecBatchedService=__exports.getApprovalSpecBatchedService={name:"web_studio.get_approval_spec_batched",dependencies:["orm"],start(env,{orm}){return batched(async(...argsLists)=>{const approvals=await orm.silent.call("studio.approval.rule","get_approval_spec",[argsLists.flat(),]);for(const[key,tupleList]of Object.entries(approvals)){if(key==="all_rules"){continue;}
approvals[key]=Object.fromEntries(tupleList.map(([tuple,value])=>{return[buildApprovalKey(...tuple),value];}));}
return approvals;});},};registry.category("services").add(getApprovalSpecBatchedService.name,getApprovalSpecBatchedService);function getMissingApprovals(entries,rules){const missingApprovals=[];const doneApprovals=entries.filter((e)=>e.approved).map((e)=>e.rule_id[0]);rules.forEach((r)=>{if(!doneApprovals.includes(r.id)){missingApprovals.push(r);}});return missingApprovals;}
class StudioApproval{constructor({getApprovalSpecBatched,model}){this._data=reactive({});this.model=model;this.rules={};const promSet=new WeakSet();this.getApprovalSpecBatched=(...args)=>{const prom=getApprovalSpecBatched(...args);if(!promSet.has(prom)){promSet.add(prom);prom.then((approvals)=>{Object.assign(this.rules,approvals.all_rules);});}
return prom;};this.orm=null;this.studio=null;this.notification=null;this.resModel=null;this.resId=null;this.method=null;this.action=null;}
get dataKey(){return buildApprovalKey(this.resModel,this.resId||false,this.method,this.action);}
get state(){const state=this._getState();if(state.rules===null&&!state.syncing&&!this.willCheck){this.fetchApprovals();}
return state;}
get inStudio(){return this.studio;}
displayNotification(data){const missingApprovals=getMissingApprovals(data.entries,data.rules);this.notification.add(missingApprovals.length>1?_t("Some approvals are missing"):_t("An approval is missing"),{type:"warning",});}
async checkApproval(){const args=[this.resModel,this.resId,this.method,this.action];const state=this._getState();state.syncing=true;const result=await this.orm.call("studio.approval.rule","check_approval",args);const approved=result.approved;if(!approved){this.displayNotification(result);}
this.willCheck=false;this.fetchApprovals();return approved;}
async fetchApprovals(){const state=this._getState();state.syncing=true;const resId=!this.inStudio&&this.resId;try{const allApprovals=await this.getApprovalSpecBatched({model:this.resModel,method:this.method,action_id:this.action,res_id:resId,});const myApproval=allApprovals[this.resModel][buildApprovalKey(resId,this.method||false,this.action||false)]||{rules:[],entries:[]};Object.assign(state,myApproval);}catch{Object.assign(state,{rules:[],entries:[]});}finally{state.syncing=false;}}
async setApproval(ruleId,approved){try{await this.orm.call("studio.approval.rule","set_approval",[[ruleId]],{res_id:this.resId,approved,});}catch(e){this.fetchApprovals();throw e;}
return await this.model.root.load();}
async cancelApproval(ruleId){try{await this.orm.call("studio.approval.rule","delete_approval",[[ruleId]],{res_id:this.resId,});}catch(e){this.fetchApprovals();throw e;}
return this.model.root.load();}
_getState(){if(!(this.dataKey in this._data)){this._data[this.dataKey]={rules:null};}
return this._data[this.dataKey];}}
const approvalMap=new WeakMap();__exports.useApproval=useApproval;function useApproval({getRecord,method,action}){const protectedOrm=useService("orm");const unprotectedOrm=useEnv().services.orm;const notification=useService("notification");const record=getRecord(useComponent().props);const model=toRaw(record.model);const getApprovalSpecBatched=useEnv().services["web_studio.get_approval_spec_batched"];let approvalModelCache=approvalMap.get(model);if(!approvalModelCache){approvalModelCache={approval:new StudioApproval({getApprovalSpecBatched,model}),onRecordSaved:new Map(),};approvalMap.set(model,approvalModelCache);const onRecordSaved=model.hooks.onRecordSaved;model.hooks.onRecordSaved=(...args)=>{approvalModelCache.onRecordSaved.forEach((fn)=>fn(args[0]));return onRecordSaved(...args);};const onRootLoaded=model.hooks.onRootLoaded;model.hooks.onRootLoaded=(...args)=>{for(const data of Object.values(approvalModelCache.approval._data)){data.rules=null;}
if(onRootLoaded){return onRootLoaded(...args);}};}
const specialize={resModel:record.resModel,resId:record.resId,method,action,orm:unprotectedOrm,studio:!!record.context.studio,notification,};const approval=reactive(Object.assign(Object.create(approvalModelCache.approval),specialize));approvalModelCache.onRecordSaved.set(toRaw(approval),()=>{if(!approval.resId&&record.resId){approval.resId=record.resId;}else{delete approval._data[approval.dataKey];}});onWillDestroy(()=>approvalModelCache.onRecordSaved.delete(toRaw(approval)));useRecordObserver((record)=>{approval.resId=record.resId;approval.resModel=record.resModel;});onMounted(()=>{approval.orm=protectedOrm;});return approval;}
return __exports;});;

/* /web_studio/static/src/approval/approval_infos.js */
odoo.define('@web_studio/approval/approval_infos',['@web/core/l10n/dates','@web/core/dialog/dialog','@web/core/user','@odoo/owl','@web/core/utils/hooks','@web/core/utils/arrays'],function(require){'use strict';let __exports={};const{formatDate,deserializeDate}=require("@web/core/l10n/dates");const{Dialog}=require("@web/core/dialog/dialog");const{user}=require("@web/core/user");const{useState,Component,onWillRender}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{groupBy,sortBy}=require("@web/core/utils/arrays");const StudioApprovalInfos=__exports.StudioApprovalInfos=class StudioApprovalInfos extends Component{static template="StudioApprovalInfos";static components={Dialog};static props={isPopover:Boolean,approval:Object,close:{type:Function,optional:true},};setup(){this.user=user;const approval=this.props.approval;this.approval=approval;this.state=useState(approval.state);this.actionService=useService("action");onWillRender(()=>{this.ruleIdToEntry=Object.fromEntries(this.state.entries.map((e)=>[e.rule_id[0],e]));let ruleGrouped=groupBy(Object.values(this.props.approval.rules),"notification_order");ruleGrouped=sortBy(Object.entries(ruleGrouped),([key,group])=>parseInt(key),"desc");let canRevoke=false;for(const group of ruleGrouped){const localCanRevoke=canRevoke;group[1].forEach((r)=>{r._canRevoke=localCanRevoke;canRevoke=canRevoke||r.can_validate;});}});}
formatDate(val,format){return formatDate(deserializeDate(val),{format});}
getEntry(ruleId){return this.ruleIdToEntry[ruleId];}
setApproval(ruleId,approved){return this.approval.setApproval(ruleId,approved);}
canRevokeEntry(ruleId){const rule=this.props.approval.rules[ruleId];const entry=this.getEntry(ruleId);return entry.user_id[0]===this.user.userId||rule._canRevoke;}
cancelApproval(ruleId){return this.approval.cancelApproval(ruleId);}
openKanbanApprovalRules(){const{resModel,method,action}=this.approval;return this.actionService.doActionButton({type:"object",name:"open_kanban_rules",resModel:"studio.approval.rule",resIds:[],args:JSON.stringify([resModel,method,action]),});}}
return __exports;});;

/* /web_studio/static/src/approval/form_controller.js */
odoo.define('@web_studio/approval/form_controller',['@odoo/owl','@web/core/utils/patch','@web/views/form/form_controller'],function(require){'use strict';let __exports={};const{useSubEnv}=require("@odoo/owl");const{patch}=require("@web/core/utils/patch");const{FormController}=require("@web/views/form/form_controller");patch(FormController.prototype,{setup(){super.setup();if(this._shouldUseSubEnv()){const{relatedModels}=this.props;const hasApprovalRules={};for(const model in relatedModels||{}){hasApprovalRules[model]=relatedModels[model].has_approval_rules||false;}
useSubEnv({hasApprovalRules});}},_shouldUseSubEnv(){return true;},});return __exports;});;

/* /web_studio/static/src/approval/studio_approval.js */
odoo.define('@web_studio/approval/studio_approval',['@web/core/popover/popover_hook','@web/core/utils/hooks','@web_studio/approval/approval_infos','@odoo/owl'],function(require){'use strict';let __exports={};const{usePopover}=require("@web/core/popover/popover_hook");const{useService}=require("@web/core/utils/hooks");const{StudioApprovalInfos}=require("@web_studio/approval/approval_infos");const{Component,onWillUnmount,useRef}=require("@odoo/owl");function useOpenExternal(){const closeFns=[];function open(_open){const close=_open();closeFns.push(close);return close;}
onWillUnmount(()=>{closeFns.forEach((cb)=>cb());});return open;}
const StudioApproval=__exports.StudioApproval=class StudioApproval extends Component{static props={approval:Object,};static template="StudioApproval";setup(){this.dialog=useService("dialog");this.popover=usePopover(StudioApprovalInfos);this.rootRef=useRef("root");this.openExternal=useOpenExternal();}
get approval(){return this.props.approval;}
get state(){return this.approval.state;}
toggleApprovalInfo(){if(this.env.isSmall){if(this.isOpened){this.closeInfos();this.closeInfos=null;return;}
const onClose=()=>{this.isOpened=false;};this.closeInfos=this.openExternal(()=>this.dialog.add(StudioApprovalInfos,{approval:this.approval,isPopover:false},{onClose}));}else{this.popover.open(this.rootRef.el,{approval:this.approval,isPopover:true});}}
getEntry(ruleId){return this.state.entries.find((e)=>e.rule_id[0]===ruleId);}}
return __exports;});;

/* /web_studio/static/src/approval/view_button_approval.js */
odoo.define('@web_studio/approval/view_button_approval',['@odoo/owl','@web/core/network/rpc','@web/core/orm_service','@web/core/registry','@web/core/utils/patch','@web/views/view_button/view_button','@web_studio/approval/approval_hook','@web_studio/approval/studio_approval'],function(require){'use strict';let __exports={};const{useSubEnv}=require("@odoo/owl");const{rpcBus}=require("@web/core/network/rpc");const{UPDATE_METHODS}=require("@web/core/orm_service");const{registry}=require("@web/core/registry");const{patch}=require("@web/core/utils/patch");const{ViewButton}=require("@web/views/view_button/view_button");const{useApproval}=require("@web_studio/approval/approval_hook");const{StudioApproval}=require("@web_studio/approval/studio_approval");registry.category("services").add("clear_caches_on_approval_rules_change",{start(env){rpcBus.addEventListener("RPC:RESPONSE",(ev)=>{const{model,method}=ev.detail.data.params;if(["studio.approval.rule"].includes(model)&&UPDATE_METHODS.includes(method)){env.bus.trigger("CLEAR-CACHES");}});},});patch(ViewButton.prototype,{setup(){super.setup(...arguments);if(this._shouldUseApproval()){let{type,name}=this.props.clickParams;if(type&&type.endsWith("=")){type=type.slice(0,-1);}
const action=type==="action"&&name;const method=type==="object"&&name;this.approval=useApproval({getRecord:(props)=>props.record,action,method,});const onClickViewButton=this.env.onClickViewButton;useSubEnv({onClickViewButton:(params)=>{if(params.clickParams.type==="action"){params.beforeExecute=this.checkBeforeExecute.bind(this);}
onClickViewButton(params);},});}},_shouldUseApproval(){const{name}=this.props.clickParams||{};const{resModel}=this.props.record||{};return name&&resModel&&this.env.hasApprovalRules?.[resModel];},async checkBeforeExecute(){this.approval.willCheck=true;if(!this.approval.resId){const model=this.props.record.model;const rec="resId"in model.root?model.root:this.props.record;await rec.save();}else if(this.props.record&&this.props.record.isDirty){await this.props.record.save();}
return this.approval.checkApproval();},});ViewButton.props.push("studioApproval?");ViewButton.components=Object.assign(ViewButton.components||{},{StudioApproval});return __exports;});;

/* /documents/static/src/model/sample_server.js */
odoo.define('@documents/model/sample_server',['@web/model/sample_server','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{SampleServer}=require("@web/model/sample_server");const{patch}=require("@web/core/utils/patch");patch(SampleServer.prototype,{_getRandomSelectionValue(modelName,field){if(modelName==="documents.document"&&field.name==="thumbnail_status"){return false;}
return super._getRandomSelectionValue(...arguments);},});return __exports;});;

/* /documents/static/src/attachments/attachment_model_patch.js */
odoo.define('@documents/attachments/attachment_model_patch',['@mail/core/common/attachment_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Attachment}=require("@mail/core/common/attachment_model");const{patch}=require("@web/core/utils/patch");patch(Attachment.prototype,{documentId:null,documentData:null,get urlRoute(){if(this.documentId){return this.isImage?`/web/image/${this.documentId}`:`/web/content/${this.documentId}`;}
return super.urlRoute;},get defaultSource(){if(this.isPdf&&this.documentId){const encodedRoute=encodeURIComponent(`/documents/content/${encodeURIComponent(
                    this.documentData.access_token
                )}?download=0`);return`/web/static/lib/pdfjs/web/viewer.html?file=${encodedRoute}#pagemode=none`;}
return super.defaultSource;},get urlQueryParams(){const res=super.urlQueryParams;if(this.documentId){res["model"]="documents.document";return res;}
return res;},});return __exports;});;

/* /documents/static/src/attachments/document_file_viewer.js */
odoo.define('@documents/attachments/document_file_viewer',['@web/core/utils/hooks','@web/core/file_viewer/file_viewer','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{FileViewer:WebFileViewer}=require("@web/core/file_viewer/file_viewer");const{onWillUpdateProps}=require("@odoo/owl");const FileViewer=__exports.FileViewer=class FileViewer extends WebFileViewer{static template="documents.FileViewer";setup(){super.setup();this.documentService=useService("document.document");this.onSelectDocument=this.documentService.documentList?.onSelectDocument;onWillUpdateProps((nextProps)=>{const indexOfFileToPreview=nextProps.startIndex;if(indexOfFileToPreview!==this.state.index&&indexOfFileToPreview!==this.props.startIndex){this.activateFile(indexOfFileToPreview);}
this.documentService.setPreviewedDocument(this.documentService.documentList.documents[nextProps.startIndex]);});}
get currentFolderId(){return this.env.searchModel.getSelectedFolderId();}
get hasSplitPdf(){if(!this.documentService.userIsInternal){return false;}
if(this.documentService.documentList?.initialRecordSelectionLength===1){return this.documentService.documentList.selectedDocument.attachment.isPdf;}
return this.documentService.documentList?.documents.every((document)=>document.attachment.isPdf);}
get withDownload(){if(this.documentService.documentList?.initialRecordSelectionLength===1){return this.documentService.documentList.selectedDocument.attachment.isUrlYoutube;}
return this.documentService.documentList?.documents.every((document)=>document.attachment.isUrlYoutube);}
onClickPdfSplit(){this.close();if(this.documentService.documentList?.initialRecordSelectionLength===1){return this.documentService.documentList?.pdfManagerOpenCallback([this.documentService.documentList.selectedDocument.record,]);}
return this.documentService.documentList?.pdfManagerOpenCallback(this.documentService.documentList.documents.map((document)=>document.record));}
close(){this.documentService.documentList?.onDeleteCallback();this.documentService.setPreviewedDocument(null);super.close();}
next(){super.next();this.documentService.setPreviewedDocument(this.documentService.documentList.documents[this.state.index]);if(this.onSelectDocument){const documentList=this.documentService.documentList;if(!documentList||!documentList.selectedDocument||!documentList.documents||!documentList.documents.length){return;}
const index=documentList.documents.findIndex((document)=>document===documentList.selectedDocument);const nextIndex=index===documentList.documents.length-1?0:index+1;documentList.selectedDocument=documentList.documents[nextIndex];this.onSelectDocument(documentList.selectedDocument.record);}}
previous(){super.previous();this.documentService.setPreviewedDocument(this.documentService.documentList.documents[this.state.index]);if(this.onSelectDocument){const documentList=this.documentService.documentList;if(!documentList||!documentList.selectedDocument||!documentList.documents||!documentList.documents.length){return;}
const index=documentList.documents.findIndex((doc)=>doc===documentList.selectedDocument);const previousIndex=index===0?documentList.documents.length-1:index-1;documentList.selectedDocument=documentList.documents[previousIndex];this.onSelectDocument(documentList.selectedDocument.record);}}}
return __exports;});;

/* /documents/static/src/core/document_model.js */
odoo.define('@documents/core/document_model',[],function(require){'use strict';let __exports={};const Document=__exports.Document=class Document{id;attachment;name;mimetype;url;displayName;record;store;}
return __exports;});;

/* /documents/static/src/core/document_service.js */
odoo.define('@documents/core/document_service',['@documents/core/document_model','@documents/components/documents_manage_versions_panel/documents_manage_versions_panel','@odoo/owl','@web/core/browser/browser','@web/core/browser/router','@web/core/l10n/translation','@web/core/registry','@web/core/network/rpc','@web/core/user','@web/core/utils/timing','@web/session','@web/views/fields/formatters','@web/core/utils/functions'],function(require){'use strict';let __exports={};const{Document}=require("@documents/core/document_model");const{DocumentsManageVersions}=require("@documents/components/documents_manage_versions_panel/documents_manage_versions_panel");const{EventBus,reactive}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{parseSearchQuery,router}=require("@web/core/browser/router");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{rpc}=require("@web/core/network/rpc");const{user}=require("@web/core/user");const{debounce}=require("@web/core/utils/timing");const{session}=require("@web/session");const{formatFloat}=require("@web/views/fields/formatters");const{memoize}=require("@web/core/utils/functions");const loadMaxUploadSize=memoize((_null,orm)=>orm.call("documents.document","get_document_max_upload_limit"));const DocumentService=__exports.DocumentService=class DocumentService{documentList;constructor(env,services){this.env=env;this.store=services["mail.store"];this.orm=services["orm"];this.action=services["action"];this.notification=services["notification"];this.dialog=services["dialog"];this.fileUpload=services["file_upload"];this.logAccess=debounce(this._logAccess,1000,false);this.currentFolderAccessToken=null;this.bus=new EventBus();this.userIsDocumentManager=false;this.userIsDocumentUser=false;this.userIsErpManager=false;this.userIsInternal=false;const urlSearch=parseSearchQuery(browser.location.search);const{documents_init}=session;const openPreview=Boolean(urlSearch.documents_init_open_preview)||documents_init?.open_preview;const documentId=Number(urlSearch.documents_init_document_id)||documents_init?.document_id;this.documentIdToRestoreOnce=documentId;const initFolderId=urlSearch.documents_init_folder_id;const folderId=['MY','COMPANY','SHARED','TRASH'].includes(initFolderId)?initFolderId:Number(initFolderId)||documents_init?.folder_id;this._initData={documentId,folderId,openPreview};if(this._initData.folderId){browser.localStorage.setItem("searchpanel_documents_document",this._initData.folderId);}}
getOnceDocumentIdToRestore(){const res=this.documentIdToRestoreOnce;this.documentIdToRestoreOnce=undefined;return res;}
async start(){[this.userIsDocumentManager,this.userIsDocumentUser,this.userIsErpManager,this.userIsInternal,]=await Promise.all([user.hasGroup("documents.group_documents_manager"),user.hasGroup("documents.group_documents_user"),user.hasGroup("base.group_erp_manager"),user.hasGroup("base.group_user"),]);const initialState=this.userIsInternal&&JSON.parse(localStorage.getItem("documentsChatterVisible"));this.chatterState=reactive({visible:initialState,isChatterVisible:initialState,},()=>{localStorage.setItem("documentsChatterVisible",this.chatterState.visible);});}
insert(data){let document=this.store.Document.records[data.id];if(document?.record.id!==data.record.id){document=new Document();if("id"in data){document.id=data.id;}
if("attachment"in data){document.attachment=this.store.Attachment.insert(data.attachment);}
if("name"in data){document.name=data.name;}
if("mimetype"in data){document.mimetype=data.mimetype;}
if("url"in data){document.url=data.url;}
if("displayName"in data){document.displayName=data.displayName;}
if("record"in data){document.record=data.record;}
document.store=this.store;this.store.Document.records[data.id]=document;document=this.store.Document.records[data.id];}
return document;}
canUploadInFolder(folder){const userPermission=folder.target_user_permission||folder.user_permission;return(folder&&((typeof folder.id==="number"&&userPermission==="edit")||(this.userIsInternal&&["MY","RECENT",false].includes(folder.id))||(this.userIsDocumentManager&&folder.id==="COMPANY")));}
canDownload(document){return document&&typeof document.id==="number";}
isEditable(document){return(document&&typeof document.id==="number"&&document.user_permission==="edit"&&(!document.is_pinned_folder||this.userIsDocumentManager));}
isFolderSharable(folder){return folder&&typeof folder.id==="number"&&!folder.shortcut_document_id;}
async openDialogDetails(documentId,editable){return new Promise((resolve)=>{this.action.doAction({type:"ir.actions.act_window",res_model:"documents.document",res_id:documentId,views:[[false,"form"]],target:"new",context:{active_id:documentId,form_view_ref:"documents.document_view_form_details",editable:Boolean(editable),dialog_size:"medium",},},{onClose:async()=>{resolve();},});});}
async openDialogRename(documentId){return new Promise((resolve)=>{this.action.doAction({name:_t("Rename"),type:"ir.actions.act_window",res_model:"documents.document",res_id:documentId,views:[[false,"form"]],target:"new",context:{active_id:documentId,dialog_size:"medium",form_view_ref:"documents.document_view_form_rename",},},{onClose:async()=>{resolve();},});});}
async openDialogManageVersions(documentId){this.dialog.add(DocumentsManageVersions,{documentId});}
async goToServerActionsView(){const userHasAccessRight=await user.checkAccessRight("ir.actions.server","create");if(!userHasAccessRight){return this.notification.add(_t("Contact your Administrator to get access if needed."),{title:_t("Access to Server Actions"),type:"info",});}
return await this.action.doActionButton({name:"action_open_documents_server_action_view",type:"object",resModel:"ir.actions.server",});}
async createShortcut(documentIds){if(documentIds.length!==1){this.notificationService.add(_t("Shortcuts can only be created one at a time."),{type:"danger",});return;}
await this.orm.call("documents.document","action_create_shortcut",documentIds);}
async moveOrCreateShortcut(data,targetFolderId,forceShortcut){let message="";if(forceShortcut){await this.orm.call("documents.document","action_create_shortcut",[data.recordIds,targetFolderId,]);message=data.recordIds.length==1?_t("A shortcut has been created."):_t("%s shortcuts have been created.",data.recordIds.length);}else{if(data.movableRecordIds.length){await this.orm.call("documents.document","action_move_documents",[data.movableRecordIds,targetFolderId]);message=data.movableRecordIds.length==1?_t("The document has been moved."):_t("%s documents have been moved.",data.movableRecordIds.length);}
if(data.nonMovableRecordIds.length){await this.orm.call("documents.document","action_create_shortcut",[data.nonMovableRecordIds,targetFolderId]);message=_t("At least one document couldn't be moved due to access rights. Shortcuts have been created.");}}
this.notification.add(message,{type:"success"});}
async toggleFavorite(document){await this.orm.write("documents.document",[document.id],{is_favorited:!document.is_favorited,});}
get initData(){return this._initData;}
reload(){this.bus.trigger("DOCUMENT_RELOAD");}
updateDocumentURL(folderChange,inspectedDocuments){let accessToken;if(folderChange){accessToken=folderChange.access_token;this.currentFolderAccessToken=accessToken;}else if(inspectedDocuments&&inspectedDocuments.length===1){accessToken=inspectedDocuments[0].data.access_token;}else if(!inspectedDocuments||inspectedDocuments.length===0){accessToken=this.currentFolderAccessToken;}else{accessToken=undefined;}
router.pushState({access_token:accessToken});}
updateDocumentURLRefresh(){if(this.currentFolderAccessToken){router.pushState({access_token:this.currentFolderAccessToken});}}
_logAccess(accessToken){if(!accessToken){return;}
rpc(`/documents/touch/${encodeURIComponent(accessToken)}`);}
async getActions(folderId){if(!this.userIsInternal){return[];}
return await this.orm.call("documents.document","get_documents_actions",[folderId,]);}
async enableAction(folderId,actionId){return await this.orm.call("documents.document","action_folder_embed_action",[folderId,actionId,]);}
isChatterVisible(){return this.chatterState.visible;}
setChatterVisible(visible){}
toggleChatterState(){this.chatterState.visible=!this.chatterState.visible;this.chatterState.isChatterVisible=!this.chatterState.isChatterVisible;}
setPreviewedDocument(document){this.previewedDocument=document;this.bus.trigger("DOCUMENT_PREVIEWED");}
async uploadDocument(files,accessToken,context){const maxUploadSize=await loadMaxUploadSize(null,this.orm);const validFiles=[...files].filter((file)=>file.size<=maxUploadSize);if(validFiles.length!==0){const encodedToken=encodeURIComponent(accessToken||"");await this.fileUpload.upload(`/documents/upload/${encodedToken}`,validFiles,{buildFormData:(formData)=>{if(context){for(const key of["default_owner_id","default_partner_id","default_res_id","default_res_model",]){if(context[key]){formData.append(key.replace("default_",""),context[key]);}}
if(context.allowed_company_ids){formData.append("allowed_company_ids",JSON.stringify(context.allowed_company_ids));}}},displayErrorNotification:false,});}
if(validFiles.length>=files.length){return;}
const message=_t("Some files could not be uploaded (max size: %s).",formatFloat(maxUploadSize,{humanReadable:true}));this.notification.add(message,{type:"danger"});}}
const documentService=__exports.documentService={dependencies:["action","mail.store","notification","orm","dialog","file_upload"],async start(env,services){const service=new DocumentService(env,services);await service.start();return service;},};registry.category("services").add("document.document",documentService);return __exports;});;

/* /documents/static/src/core/router.js */
odoo.define('@documents/core/router',['@web/core/browser/router','@web/core/utils/patch','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{router}=require("@web/core/browser/router");const{patch}=require("@web/core/utils/patch");const{browser}=require("@web/core/browser/browser");browser.addEventListener("click",(ev)=>{if(ev.defaultPrevented||ev.target.closest("[contenteditable]")){return;}
const href=ev.target.closest("a")?.getAttribute("href");if(href&&!href.startsWith("#")){let url;try{url=new URL(href);}catch{return;}
if(browser.location.host===url.host&&browser.location.pathname.startsWith("/odoo")&&url.pathname.startsWith("/odoo/documents/")&&ev.target.target!=="_blank"){ev.stopPropagation();}}},{capture:true,});patch(router,{stateToUrl(state){const url=super.stateToUrl(state);if(url.startsWith("/odoo/documents")&&state.access_token){return(`/odoo/documents/${encodeURIComponent(state.access_token)}`+
(odoo.debug?`?debug=${odoo.debug}`:""));}
return url;},});return __exports;});;

/* /documents/static/src/core/store_service_patch.js */
odoo.define('@documents/core/store_service_patch',['@mail/core/common/store_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Store}=require("@mail/core/common/store_service");const{patch}=require("@web/core/utils/patch");let self;patch(Store.prototype,{hasDocumentsUserGroup:false,Document:{records:{},insert:(data)=>self.env.services["document.document"].insert(data),},setup(){super.setup();self=this;},});return __exports;});;

/* /documents/static/src/js/tours/documents.js */
odoo.define('@documents/js/tours/documents',['@web/core/l10n/translation','@web/core/registry','@odoo/owl','@odoo/hoot-dom'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{markup}=require("@odoo/owl");const{queryOne}=require("@odoo/hoot-dom");registry.category("web_tour.tours").add("documents_tour",{url:"/odoo",steps:()=>[{trigger:'.o_app[data-menu-xmlid="documents.menu_root"]',content:markup(_t("Want to become a <b>paperless company</b>? Let's discover Odoo Documents.")),tooltipPosition:"bottom",run:"click",},{trigger:'body:not(:has(.o-FileViewer)) img[src="https://img.youtube.com/vi/Ayab6wZ_U1A/0.jpg"]',content:markup(_t("Click on a thumbnail to <b>preview the document</b>.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_documents_kanban",},{trigger:"[title='Close (Esc)']",content:markup(_t("Click the cross to <b>exit preview</b>.")),tooltipPosition:"left",run:"click",},{trigger:".o_search_panel_label",},{trigger:".o_search_panel_filter_value:eq(0)",content:markup(_t("Let's process documents in your Inbox.<br/><i>Tip: Use Tags to filter documents and structure your process.</i>")),tooltipPosition:"bottom",run:function(actions){queryOne(".o_search_panel_filter_value:eq(0) .o_search_panel_label_title").click();},},{trigger:"body:not(:has(.o-FileViewer)) .o_documents_kanban",},{trigger:".o_kanban_record:contains(mail.png)",content:markup(_t("Click on a card to <b>select the document</b>.")),tooltipPosition:"bottom",run:"click",},{trigger:'.o_inspector_rule[data-id="3"] .o_inspector_trigger_rule',content:markup(_t("Let's tag this mail as legal<br/> <i>Tips: actions can be tailored to your process, according to the workspace.</i>")),tooltipPosition:"bottom",run:"click",},{trigger:".o_documents_kanban",},{trigger:".o_kanban_record:nth(0):contains(Mails_inbox.pdf)",content:_t("Let's process this document, coming from our scanner."),tooltipPosition:"bottom",run:"click",},{trigger:'[title="Mails_inbox.pdf"]',},{trigger:".o_inspector_split",content:_t("As this PDF contains multiple documents, let's split and process in bulk."),tooltipPosition:"bottom",run:"click",},{trigger:".o_documents_pdf_canvas:nth(5)",},{trigger:".o_page_splitter_wrapper:nth(3)",content:markup(_t("Click on the <b>page separator</b>: we don't want to split these two pages as they belong to the same document.")),tooltipPosition:"right",run:"click",},{trigger:".o_documents_pdf_manager",},{trigger:".o_documents_pdf_page_selector:nth(5)",content:markup(_t("<b>Deselect this page</b> as we plan to process all bills first.")),tooltipPosition:"left",run:"click",},{trigger:".o_documents_pdf_manager",},{trigger:".o_pdf_manager_button:nth-last-child(2)",content:_t("Let's process these bills: send to Finance workspace."),tooltipPosition:"bottom",run:"click",},{trigger:".o_documents_pdf_manager",},{trigger:".o_documents_pdf_page_selector",content:markup(_t("<b>Select</b> this page to continue.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_pdf_manager_button:not(:disabled)",},{trigger:".o_pdf_manager_button:nth-child(4)",content:_t("Send this letter to the legal department, by assigning the right tags."),tooltipPosition:"bottom",run:"click",},],});return __exports;});;

/* /documents/static/src/owl/components/pdf_exit_dialog/pdf_exit_dialog.js */
odoo.define('@documents/owl/components/pdf_exit_dialog/pdf_exit_dialog',['@web/core/dialog/dialog','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{useChildRef}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const ExitSplitToolsDialog=__exports.ExitSplitToolsDialog=class ExitSplitToolsDialog extends Component{static components={Dialog};static props={close:Function,isEmbeddedActionApplied:Boolean,onDeleteRemainingPages:Function,onGatherRemainingPages:Function,};static template="documents.ExitToolsDialog";setup(){this.modalRef=useChildRef();}
deleteRemainingPages(){this.props.onDeleteRemainingPages();this.props.close();}
gatherRemainingPages(){this.props.onGatherRemainingPages();this.props.close();}}
return __exports;});;

/* /documents/static/src/owl/components/pdf_group_name/pdf_group_name.js */
odoo.define('@documents/owl/components/pdf_group_name/pdf_group_name',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,useRef}=require("@odoo/owl");const PdfGroupName=__exports.PdfGroupName=class PdfGroupName extends Component{static props={groupId:String,name:String,edit:Boolean,onToggleEdit:{type:Function,optional:true,},onEditName:{type:Function,optional:true,},};static template="documents.component.PdfGroupName";setup(){this.nameInputRef=useRef("nameInput");}
onBlur(){this.props.onEditName(this.props.groupId,this.nameInputRef.el.value);}
onClickGroupName(){this.props.onToggleEdit(this.props.groupId,true);}
onKeyDown(ev){if(ev.code!=="Enter"){return;}
ev.stopPropagation();this.props.onEditName(this.props.groupId,this.nameInputRef.el.value);this.props.onToggleEdit(this.props.groupId,false);}}
return __exports;});;

/* /documents/static/src/owl/components/pdf_manager/pdf_manager.js */
odoo.define('@documents/owl/components/pdf_manager/pdf_manager',['@documents/owl/components/pdf_group_name/pdf_group_name','@documents/owl/components/pdf_page/pdf_page','@web/libs/pdfjs','@web/core/commands/command_hook','@web/core/confirmation_dialog/confirmation_dialog','@web/core/dialog/dialog','@web/core/hotkeys/hotkey_hook','@web/core/l10n/translation','@web/core/ui/ui_service','@web/core/utils/functions','@web/core/utils/hooks','@documents/owl/components/pdf_exit_dialog/pdf_exit_dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{PdfGroupName}=require("@documents/owl/components/pdf_group_name/pdf_group_name");const{PdfPage}=require("@documents/owl/components/pdf_page/pdf_page");const{loadPDFJSAssets}=require("@web/libs/pdfjs");const{useCommand}=require("@web/core/commands/command_hook");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{Dialog}=require("@web/core/dialog/dialog");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{_t}=require("@web/core/l10n/translation");const{useActiveElement}=require("@web/core/ui/ui_service");const{uniqueId}=require("@web/core/utils/functions");const{useService}=require("@web/core/utils/hooks");const{ExitSplitToolsDialog}=require("@documents/owl/components/pdf_exit_dialog/pdf_exit_dialog");const{Component,onWillStart,toRaw,useRef,useState,useEffect}=require("@odoo/owl");const BLANK_PAGE_THRESHOLD=2500;const BLANK_PIXEL_FILTER_VALUE=220;const PdfManager=__exports.PdfManager=class PdfManager extends Component{static components={Dialog,PdfPage,PdfGroupName,};static defaultProps={embeddedActions:[],};static props={documents:Array,embeddedActions:{type:Array,optional:true},onProcessDocuments:{type:Function},close:{type:Function},};static template="documents.component.PdfManager";setup(){this.root=useRef("root");useActiveElement("root");this.pageViewer=useRef("pageViewer");this.selectionBox=useRef("selectionBox");this.addFileInput=useRef("addFileInput");this.notification=useService("notification");this.dialog=useService("dialog");this.commandService=useService("command");this.state=useState({uploadingLock:false,groupData:{},groupIds:[],pages:{},pageCanvases:{},focusedPage:undefined,lastSelectedPage:undefined,viewedPage:undefined,viewedPageName:undefined,viewedPageIndex:undefined,numberOfPages:undefined,archive:true,keepDocument:true,remaining:false,fileName:"",edit:false,isSelecting:false,selectionBoxArgs:{left:"0px",top:"0px",width:"0px",height:"0px"},});this._exitSplitToolsClick=false;this._newFiles={};this._selectionX=0.0;this._selectionY=0.0;this._selectionScrollTop=0.0;this._selectionScrollLeft=0.0;this._embeddedActionApplied=false;this._onMouseDown=this._onMouseDown.bind(this);this._onMouseUp=this._onMouseUp.bind(this);this._onMouseMove=this._onMouseMove.bind(this);this._onShiftDown=this._onShiftDown.bind(this);this._setUseCommand=this._setUseCommand.bind(this);this._exitSplitTools=this._exitSplitTools.bind(this);onWillStart(async()=>{await this._loadAssets();});useEffect(()=>{const _onOutsideClick=this._onOutsideClick.bind(this);if(this.props.documents.length===1){this.state.fileName=this._removePdfExtension(this.props.documents[0].name);}
for(const pdf_document of this.props.documents){this._addFile(pdf_document.name,{url:`/documents/content/${encodeURIComponent(pdf_document.access_token)}`,documentId:pdf_document.id,});}
document.addEventListener("click",_onOutsideClick,true);document.addEventListener("mousedown",this._onMouseDown,true);document.addEventListener("mouseup",this._onMouseUp,true);document.addEventListener("mousemove",this._onMouseMove,true);document.addEventListener("keydown",this._onShiftDown,true);return()=>{document.removeEventListener("click",_onOutsideClick,true);document.removeEventListener("mousedown",this._onMouseDown,true);document.removeEventListener("mouseup",this._onMouseUp,true);document.removeEventListener("mousemove",this._onMouseMove,true);document.removeEventListener("keydown",this._onShiftDown,true);};},()=>[]);this._setUseCommand(_t("Focus previous page"),this._focusNextPage.bind(this,"left",false),"arrowleft",{allowRepeat:true,});this._setUseCommand(_t("Focus next page"),this._focusNextPage.bind(this,"right",false),"arrowright",{allowRepeat:true,});this._setUseCommand(_t("Focus first page of previous group"),this._focusNextGroup.bind(this,"left"),"control+ArrowLeft");this._setUseCommand(_t("Focus first page of next group"),this._focusNextGroup.bind(this,"right"),"control+ArrowRight");this._setUseCommand(_t("Select focused page"),this._spaceKeySelect.bind(this),"control+space",{allowRepeat:true,});this._setUseCommand(_t("Select/Deselect all pages"),this._selectAll.bind(this),"control+a");this._setUseCommand(_t("Select previous page"),this._focusNextPage.bind(this,"left",true),"shift+ArrowLeft",{allowRepeat:true,});this._setUseCommand(_t("Select next page"),this._focusNextPage.bind(this,"right",true),"shift+ArrowRight",{allowRepeat:true,});this._setUseCommand(_t("Select previous pages of the group"),this._selectUntilSplit.bind(this,"left"),"control+shift+ArrowLeft");this._setUseCommand(_t("Select next pages of the group"),this._selectUntilSplit.bind(this,"right"),"control+shift+ArrowRight");this._setUseCommand(_t("Escape Preview/Deselect/Exit"),this._onPushExit.bind(this),"escape");this._setUseCommand(_t("Split selected pages"),this._splitSelectionHandler.bind(this),"control+s",{allowRepeat:true,});this._setUseCommand(_t("Split all white pages"),this._splitWhitePagesHandler.bind(this),"shift+s",);this._setUseCommand(_t("Delete focused or selected pages"),this.onArchive.bind(this),"alt+backspace");useHotkey("ArrowDown",this._focusNextPage.bind(this,"down",false),{allowRepeat:true,});useHotkey("ArrowUp",this._focusNextPage.bind(this,"up",false),{allowRepeat:true});useHotkey("shift+ArrowDown",this._focusNextPage.bind(this,"down",true),{allowRepeat:true,});useHotkey("shift+ArrowUp",this._focusNextPage.bind(this,"up",true),{allowRepeat:true,});useHotkey("enter",this._togglePreviewer.bind(this),{allowRepeat:true,});useHotkey("delete",this.onArchive.bind(this));}
_setUseCommand(name,callback,hotkey,options){useCommand(name,callback,{category:"smart_action",hotkey:hotkey,hotkeyOptions:options,});}
get ignoredPageIds(){return Object.keys(this.state.pages).filter((key)=>!this.state.pages[key].isSelected&&this.state.pages[key].groupId);}
get selectedPageIds(){return Object.keys(this.state.pages).filter((key)=>this.state.pages[key].isSelected&&this.state.pages[key].groupId);}
get isDebugMode(){return Boolean(odoo.debug);}
get allSelected(){return!Object.values(this.state.pages).some((page)=>!page.isSelected);}
get sortedPagesIds(){return this.state.groupIds.flatMap((groupId)=>Object.values(this.state.groupData[groupId].pageIds));}
onToggleEdit(groupId,toggle){this.state.edit=toggle?groupId:false;const toggleActivation=this.state.groupData[groupId].pageIds.some((pageId)=>this.state.pages[pageId].isSelected!==true);this.state.groupData[groupId].pageIds.map((pageId)=>{this.state.pages[pageId].isSelected=toggleActivation;});this.state.focusedPage=undefined;}
_computeCardsPerLine(){const allPages=[...document.querySelectorAll(".o_documents_pdf_page_frame")];const top=allPages[0].getBoundingClientRect().top;return allPages.filter((page)=>page.getBoundingClientRect().top===top).length;}
_unSelectPages(){for(const pageId of this.selectedPageIds){this.state.pages[pageId].isSelected=false;}}
_splitSelectionHandler(){if(this.state.viewedPage){return;}
const selectedPages=this.selectedPageIds;const focusedPageisSelected=selectedPages.includes(this.state.focusedPage);const sortedPagesIds=this.sortedPagesIds;if(this.state.focusedPage&&!focusedPageisSelected){const indexPage=sortedPagesIds.indexOf(this.state.focusedPage);const previousPageId=sortedPagesIds[indexPage-1];if(indexPage!==0){this._pageSeparator(previousPageId,this.state.pages[previousPageId].groupId);}
return;}
let toggleSeparatorBool=true;const pagesToSplit=[];const pagesToGather=[];for(const pageId of selectedPages){const indexPage=sortedPagesIds.indexOf(pageId);if(indexPage<sortedPagesIds.length-1&&this.state.pages[sortedPagesIds[indexPage+1]].isSelected){const parent=document.querySelector(`[data-id=${pageId}]`).closest(".o_documents_pdf_page_frame");const isSeparatorActive=parent.nextElementSibling.classList.contains("o_pdf_separator_selected");toggleSeparatorBool=toggleSeparatorBool&&isSeparatorActive;if(isSeparatorActive){pagesToGather.push(this.state.pages[pageId]);}else{pagesToSplit.push(this.state.pages[pageId]);}}}
const pagesToTreat=toggleSeparatorBool?pagesToGather:pagesToSplit;for(const page of pagesToTreat){this._pageSeparator(page.pageId,page.groupId);}}
async _splitWhitePagesHandler(){let precedingPageIsBlank=false;let docCount=1;const allPagesIds=this.sortedPagesIds;this.state.groupData={};this.state.groupIds=[];this._createGroup({pageIds:allPagesIds,name:this.state.pages[allPagesIds[0]].isBlank?_t("Blank Page"):_t("sub-doc-%s",docCount++),});for(const pageId in this.state.pages){const page=this.state.pages[pageId];const createGroup=(name)=>{const group=this.state.groupData[page.groupId];const groupPageIds=group.pageIds;const newGroupPageIds=groupPageIds.slice(groupPageIds.indexOf(pageId));this._createGroup({name:name,pageIds:newGroupPageIds,});group.pageIds=groupPageIds.filter((page)=>!newGroupPageIds.includes(page));};if(page.isBlank&&!precedingPageIsBlank){createGroup(_t("Blank Page"));}else if(!page.isBlank&&precedingPageIsBlank){createGroup(_t("sub-doc-%s",docCount++));}
page.isSelected=!page.isBlank;precedingPageIsBlank=page.isBlank;}}
_pageSeparator(pageId,groupId){const page=this.state.pages[pageId];const groupPageIds=this.state.groupData[groupId].pageIds;const pageIndex=groupPageIds.indexOf(pageId);const groupIndex=this.state.groupIds.indexOf(groupId);const isLastPage=pageIndex===groupPageIds.length-1;if(isLastPage){const targetGroupId=this.state.groupIds[groupIndex+1];if(targetGroupId){const pageIds=this.state.groupData[targetGroupId].pageIds;for(const pageId of pageIds){this._addPage(pageId,page.groupId);}}}else{const newGroupPages=groupPageIds.slice(pageIndex+1);const newGroupId=this._createGroup({index:groupIndex+1,});for(const page of newGroupPages){this._addPage(page,newGroupId);}}}
async _addFile(name,{documentId,file,url}){if(!url){if(!file&&!documentId){return;}
url=URL.createObjectURL(file);}
this.state.uploadingLock=true;const fileId=uniqueId("file");const pdf=await this._getPdf(url);if(file){this._newFiles[fileId]={type:"file",file};}else if(documentId){this._newFiles[fileId]={type:"document",documentId};}
name=this._removePdfExtension(name||_t("New File"));const pageCount=pdf.numPages;const{pageIds,newPages}=this._createPages({fileId,name,pageCount});this._newFiles[fileId].pageIds=this._newFiles[fileId].selectedPageIds=pageIds;this.state.uploadingLock=false;await this._loadCanvases({newPages,pageCount,pdf});}
_addPage(pageId,groupId,{index}={}){if(!this.state.groupData[groupId]){return;}
this._removePage(pageId);if(index!==undefined){this.state.groupData[groupId].pageIds.splice(index,0,pageId);}else{this.state.groupData[groupId].pageIds.push(pageId);}
this.state.pages[pageId].groupId=groupId;this.state.numberOfPages=this.sortedPagesIds.length;}
_displayErrorNotification(message){this.notification.add(message,{title:_t("Error"),});}
_displayNumberCreatedDocuments(number){this.notification.add(_t("%s new document(s) created",number),{type:"success"});}
_displayNumberDeletedPages(number){this.notification.add(_t("%s page(s) deleted",number),{type:"success"});}
async _applyChanges(actionId){let processedPageIds=this.selectedPageIds;let pageIds=this.ignoredPageIds;if(processedPageIds.length===0&&!this.state.focusedPage){this._displayErrorNotification(_t("No document has been selected"));return;}
if(processedPageIds.length===0){processedPageIds=[this.state.focusedPage];pageIds=pageIds.filter((pageId)=>pageId!==this.state.focusedPage);}
const exit=!pageIds.length;let fileName=_t("Remaining Pages");if(this.state.fileName){fileName=this.state.fileName+" "+fileName;}
try{const documentIds=await this._sendChanges();await this.props.onProcessDocuments({documentIds,actionId,exit});this._displayNumberCreatedDocuments(documentIds.length);if(!exit){this._embeddedActionApplied=true;for(const pageId of processedPageIds){this._removePage(pageId,{fromFile:true});}}else{this.props.close();}}catch(error){this._displayErrorNotification(error.message||error);if(pageIds.length){this._createGroup({name:fileName,pageIds:pageIds,isSelected:true});}}finally{this.state.uploadingLock=false;this.state.remaining=true;this.state.numberOfPages=this.sortedPagesIds.length;}}
_createGroup({name,pageIds,index,isSelected}={}){const groupId=uniqueId("group");pageIds=pageIds||[];this.state.groupData[groupId]={groupId,name:name||_t("New Group"),pageIds,};for(const pageId of pageIds){this.state.pages[pageId].groupId=groupId;if(isSelected!==undefined){this.state.pages[pageId].isSelected=isSelected;}}
if(index){this.state.groupIds.splice(index,0,groupId);}else{this.state.groupIds.push(groupId);}
return groupId;}
async _isBlankPage(page,canvas){const pageContent=await page.getTextContent();const hasText=pageContent.items.length>0;return!hasText&&this._hasBlankGraphics(canvas);}
async _hasBlankGraphics(canvas){const pixels=canvas.getContext("2d").getImageData(0,0,canvas.width,canvas.height,{colorSpace:"display-p3"}).data;let totalSum=0;for(const pixel of pixels){if(pixel<BLANK_PIXEL_FILTER_VALUE){totalSum+=255-pixel;if(totalSum>=BLANK_PAGE_THRESHOLD){return false;}}}
return true;}
_createPages({fileId,name,pageCount}){let groupId;let groupName=name;const multipleFiles=this.props.documents.length>1;let groupLock=false;const pageIds=[];const newPages={};for(let pageNumber=0;pageNumber<pageCount;pageNumber++){if(multipleFiles&&!groupLock){groupId=this._createGroup({name:groupName});groupLock=true;}else if(!multipleFiles){groupName=`${name}-p${pageNumber + 1}`;groupId=this._createGroup({name:groupName});}
const pageId=uniqueId("page");this.state.pages[pageId]={pageId,groupId,fileId,localPageNumber:pageNumber+1,isSelected:true,};newPages[pageNumber+1]=pageId;this.state.pageCanvases[pageId]={};this.state.groupData[groupId].pageIds.push(pageId);pageIds.push(pageId);}
this.state.numberOfPages=this.sortedPagesIds.length;return{pageIds,newPages};}
async _getPdf(url){return globalThis.pdfjsLib.getDocument(url).promise;}
async _loadAssets(){await loadPDFJSAssets();}
async _loadCanvases({newPages,pageCount,pdf}){for(let pageNumber=1;pageNumber<=pageCount;pageNumber++){if(!this.root.el){break;}
const pageId=newPages[pageNumber];const page=await pdf.getPage(pageNumber);const canvas=await this._renderCanvas(toRaw(page),{width:160,height:230,});this.state.pageCanvases[pageId]={page,canvas};this.state.pages[pageId].isBlank=await this._isBlankPage(page,canvas);}}
async _renderCanvas(page,{width,height}){const viewPort=page.getViewport({scale:1});const isLandscape=viewPort.width>viewPort.height;const canvas=document.createElement("canvas");canvas.className="o_documents_pdf_canvas";canvas.width=width;canvas.height=height;const scale=isLandscape?Math.min(canvas.width/viewPort.height,canvas.height/viewPort.width):Math.min(canvas.width/viewPort.width,canvas.height/viewPort.height);await page.render({canvasContext:canvas.getContext("2d"),viewport:page.getViewport({scale,rotation:isLandscape?270:viewPort.rotation}),}).promise;return canvas;}
async _sendChanges(){this.state.uploadingLock=true;const fileIds=[];const files=[];for(const key in this._newFiles){if(this._newFiles[key].type==="file"){files.push(this._newFiles[key].file);fileIds.push(key);}}
const fileGroups=Object.values(JSON.parse(JSON.stringify(this.state.groupData)));let activePages=this.selectedPageIds;if(!activePages.length){activePages=this.state.focusedPage;this.state.focusedPage=false;}
for(const group of fileGroups){group.pageIds=group.pageIds.filter((page)=>activePages.includes(page));}
const newFiles=fileGroups.filter((group)=>group.pageIds.length>0);for(const newFile of newFiles){newFile.new_pages=[];for(const pageId of newFile.pageIds){const fileId=this.state.pages[pageId].fileId;const file=this._newFiles[fileId];const old_file_type=file.type;const old_file_index=old_file_type==="file"?fileIds.indexOf(fileId):file.documentId;newFile.new_pages.push({old_file_type,old_file_index,old_page_number:this.state.pages[pageId].localPageNumber,});}
delete newFile.pageIds;}
newFiles.reverse();const document=this.props.documents[0];const data=new FormData();data.append("csrf_token",odoo.csrf_token);for(const file of files){data.append("ufile",file);}
data.append("new_files",JSON.stringify(newFiles));data.append("archive",this.state.archive);data.append("vals",JSON.stringify({folder_id:document.folder_id[0],tag_ids:document.tag_ids.currentIds,owner_id:document.owner_id[0],partner_id:document.partner_id[0],active:this.state.keepDocument,}));const response=await fetch("/documents/pdf_split",{method:"post",body:data,});return response.json();}
_removeGroup(groupId){if(this.state.groupData[groupId].pageIds.length>0){return;}
for(const pageId in this.state.pages){const page=this.state.pages[pageId];if(page.groupId===groupId){page.groupId=false;}}
this.state.groupIds=this.state.groupIds.filter((listedGroupId)=>listedGroupId!==groupId);delete this.state.groupData[groupId];this.state.numberOfPages=this.sortedPagesIds.length;}
_removePage(pageId,{fromFile}={}){const page=this.state.pages[pageId];if(!page){return;}
const pageIds=this.state.groupData[page.groupId].pageIds;this.state.groupData[page.groupId].pageIds=pageIds.filter((number)=>number!==pageId);if(page.groupId){this._removeGroup(page.groupId);}
page.groupId=false;if(fromFile){const selectedPageIds=this._newFiles[page.fileId].selectedPageIds;this._newFiles[page.fileId].selectedPageIds=selectedPageIds.filter((number)=>number!==pageId);if(this._newFiles[page.fileId].selectedPageIds.length===0){this._removeFile(page.fileId);}
page.fileId=false;}
this.state.numberOfPages=this.sortedPagesIds.length;}
_removeFile(fileId){for(const pageId of this._newFiles[fileId].pageIds){delete this.state.pageCanvases[pageId];delete this.state.pages[pageId];}
delete this._newFiles[fileId];this.state.numberOfPages=this.sortedPagesIds.length;}
_removePdfExtension(name){return name.replace(/\.pdf$/gi,"");}
_exitSplitTools(formerTargetCallback=()=>{}){this.dialog.add(ExitSplitToolsDialog,{isEmbeddedActionApplied:this._embeddedActionApplied,onDeleteRemainingPages:async()=>{await this.props.close();formerTargetCallback();},onGatherRemainingPages:async()=>{await this._exitByGatheringRemainingPages();formerTargetCallback();},close:()=>{},});}
async _exitByGatheringRemainingPages(){const allPages=this.sortedPagesIds;this.state.groupData={};this.state.groupIds=[];this._createGroup({name:this.state.fileName?_t("%s (remaining pages)",this.state.fileName):_t("Remaining Pages"),pageIds:allPages,isSelected:true});await this._applyChanges();}
_keepFocusedPageInScreen(){const card=document.querySelector(`[data-id=${this.state.focusedPage}]`);const focusedCardCoordinates=card.getBoundingClientRect();const pageViewerCoordinates=this.pageViewer.el.getBoundingClientRect();const bottomDifference=focusedCardCoordinates.bottom-pageViewerCoordinates.bottom;const topDifference=focusedCardCoordinates.top-pageViewerCoordinates.top;if(bottomDifference>0){this.pageViewer.el.scrollBy(0,bottomDifference+60);}
if(topDifference<0){this.pageViewer.el.scrollBy(0,topDifference-10);}}
_onShiftDown(ev){if(document.activeElement.classList.contains("o_pdf_name_input")){ev.stopPropagation();return;}
if(ev.key==="Shift"&&!ev.metaKey&&!ev.ctrlKey&&!ev.altKey&&!this.state.viewedPage&&this.state.focusedPage){this.state.pages[this.state.focusedPage].isSelected=!this.state.pages[this.state.focusedPage].isSelected;}}
_focusNextPage(direction,doSelect){if(this.state.viewedPage){if(direction==="left"){this.onClickPrevious();}
if(direction==="right"){this.onClickNext();}
return;}
if(this.state.focusedPage){const sortedPagesIds=this.sortedPagesIds;let nextFocusedPageId;if(!sortedPagesIds.includes(this.state.focusedPage)){nextFocusedPageId=sortedPagesIds[0];}else{const indexFocusedPage=sortedPagesIds.indexOf(this.state.focusedPage);const numberPerLine=this._computeCardsPerLine();const shift={right:1,left:-1,down:numberPerLine,up:-numberPerLine}[direction];nextFocusedPageId=sortedPagesIds[indexFocusedPage+shift];}
if(nextFocusedPageId){if(doSelect){this.state.pages[this.state.focusedPage].isSelected=!this.state.pages[nextFocusedPageId].isSelected;this.state.pages[nextFocusedPageId].isSelected=true;}
this.state.focusedPage=nextFocusedPageId;}}else if(this.state.lastSelectedPage){this.state.focusedPage=this.state.lastSelectedPage;this._focusNextPage(direction,doSelect);}else{this.state.focusedPage=this.sortedPagesIds[0];if(doSelect){this.state.pages[this.state.focusedPage].isSelected=!this.state.pages[this.state.focusedPage].isSelected;}}
this._keepFocusedPageInScreen();}
_focusNextGroup(direction){if(this.state.viewedPage){return;}
if(this.state.focusedPage){const index=this.state.groupIds.indexOf(this.state.pages[this.state.focusedPage].groupId);const shift=direction==="right"?1:-1;const nextNeigbor=this.state.groupData[this.state.groupIds[index+shift]];if(nextNeigbor){this.state.focusedPage=nextNeigbor.pageIds[0];}}else if(this.state.lastSelectedPage){this.state.focusedPage=this.state.lastSelectedPage;this._focusNextGroup(direction);}else{this.state.focusedPage=this.sortedPagesIds[0];}
this._keepFocusedPageInScreen();}
_togglePreviewer(){if(this.state.focusedPage&&!this.state.viewedPage){this.onClickPage(this.state.focusedPage);}
if(this.state.focusedPage&&this.state.viewedPage){this._onPushExit();}}
_spaceKeySelect(){if(this.state.focusedPage&&!this.state.viewedPage){this.state.pages[this.state.focusedPage].isSelected=!this.state.pages[this.state.focusedPage].isSelected;}}
_selectUntilSplit(direction){if(this.state.viewedPage){return;}
if(this.state.focusedPage){const groupData=this.state.groupData[this.state.pages[this.state.focusedPage].groupId];const pageIndex=groupData.pageIds.indexOf(this.state.focusedPage);const pagesToSelect=direction==="right"?groupData.pageIds.slice(pageIndex,groupData.pageIds.length):groupData.pageIds.slice(0,pageIndex+1);const toggleSelectBool=pagesToSelect.every((pageId)=>this.state.pages[pageId].isSelected);for(const pageId of pagesToSelect){this.state.pages[pageId].isSelected=!toggleSelectBool;}}else if(this.state.lastSelectedPage){this.state.focusedPage=this.state.lastSelectedPage;this._selectUntilSplit(direction);}else{this.state.focusedPage=this.sortedPagesIds[0];}}
_selectAll(){if(this.state.viewedPage){return;}
const allSelected=this.allSelected;for(const page of Object.values(this.state.pages)){page.isSelected=!allSelected;}}
_onPushExit(){if(this.state.viewedPage){this.state.focusedPage=this.state.viewedPage;this.previewCanvas=undefined;this.state.viewedPage=undefined;return;}
if(this.selectedPageIds.length){this._unSelectPages();return;}
if(this.state.focusedPage){this.state.focusedPage=undefined;return;}
this._exitSplitTools();}
_onMouseDown(ev){if(ev.target.closest(".o_pdf_page")||ev.target.closest(".o_page_splitter_wrapper")||ev.target.closest(".o_documents_pdf_manager_top_bar")||ev.target.closest(".o_main_navbar")||ev.target.closest(".o_documents_pdf_page_preview")||ev.target.closest(".o_pdf_group_name_block")||ev.button!==0){return;}
this._selectionX=ev.pageX;this._selectionY=ev.pageY-40;this._selectionScrollTop=this.pageViewer.el.scrollTop;this._selectionScrollLeft=this.pageViewer.el.scrollLeft;this.state.selectionBoxArgs["left"]=this._selectionX+"px";this.state.selectionBoxArgs["top"]=this._selectionY+"px";this.state.selectionBoxArgs["width"]=0+"px";this.state.selectionBoxArgs["height"]=0+"px";this.state.isSelecting=true;if(!ev.ctrlKey&&!ev.metaKey&&!ev.shiftKey){if(!this.selectedPageIds.length){this.state.focusedPage=undefined;}
this.state.edit=false;this._unSelectPages();}}
_onMouseMove(ev){if(!this.state.isSelecting){return;}
this.state.focusedPage=false;const x=ev.pageX;const y=ev.pageY-40;const scrollTopDiff=this.pageViewer.el.scrollTop-this._selectionScrollTop;const scrollLeftDiff=this.pageViewer.el.scrollLeft-this._selectionScrollLeft;this.state.selectionBoxArgs["left"]=x-this._selectionX+scrollLeftDiff<0?x+"px":this._selectionX-scrollLeftDiff+"px";this.state.selectionBoxArgs["top"]=y-this._selectionY+scrollTopDiff<0?y+"px":this._selectionY-scrollTopDiff+"px";this.state.selectionBoxArgs["width"]=Math.abs(x-(this._selectionX-scrollLeftDiff))+"px";this.state.selectionBoxArgs["height"]=Math.abs(y-(this._selectionY-scrollTopDiff))+"px";const boxCoordinates=this.selectionBox.el.getBoundingClientRect();const boxTop=boxCoordinates.top;const boxBottom=boxTop+boxCoordinates.height;const boxLeft=boxCoordinates.left;const boxRight=boxLeft+boxCoordinates.width;const cards=document.querySelectorAll(".o_pdf_page");for(const card of cards){const cardCoordinates=card.getBoundingClientRect();const cardTop=cardCoordinates.top;const cardBottom=cardTop+cardCoordinates.height;const cardLeft=cardCoordinates.left;const cardRight=cardLeft+cardCoordinates.width;if(boxLeft<cardRight&&boxRight>cardLeft&&boxTop<cardBottom&&boxBottom>cardTop){this.state.pages[card.dataset.id].isSelected=!ev.shiftKey;}else if(!ev.metaKey&&!ev.ctrlKey&&!ev.shiftKey){this.state.pages[card.dataset.id].isSelected=false;}}}
_onMouseUp(){this.state.isSelecting=false;}
onClickEmbeddedAction(actionId){this._applyChanges(actionId);}
onClickSplit(){this.state.keepDocument=true;this._applyChanges();}
onClickArchive(ev){ev.target.blur();this.state.archive=!this.state.archive;}
onClickGlobalAdd(){this.addFileInput.el.click();}
async onArchive(){let pagesToDelete=this.selectedPageIds;if(pagesToDelete.length===0&&!this.state.focusedPage&&!this.state.viewedPage){this._displayErrorNotification(_t("No document has been selected"));return;}
const sortedPagesIds=this.sortedPagesIds;let messageInput=_t("Are you sure that you want to delete the selected page(s)");let nextFocusedPageId=pagesToDelete.includes(this.state.focusedPage)?false:this.state.focusedPage;if(pagesToDelete.length===0||this.state.viewedPage||(this.state.focusedPage&&!pagesToDelete.includes(this.state.focusedPage))){pagesToDelete=[this.state.focusedPage];messageInput=this.state.viewedPage?_t("Are you sure that you want to delete this page ?"):_t("Are you sure that you want to delete the focused page ?");const focusedPageIndex=sortedPagesIds.indexOf(this.state.focusedPage);if(focusedPageIndex+1<sortedPagesIds.length){nextFocusedPageId=sortedPagesIds[focusedPageIndex+1];}else if(focusedPageIndex-1>=0){nextFocusedPageId=sortedPagesIds[focusedPageIndex-1];}else{nextFocusedPageId=undefined;}}
this.dialog.add(ConfirmationDialog,{body:messageInput,confirm:async()=>{for(const pageId of pagesToDelete){this._removePage(pageId,{fromFile:true});}
if(this.state.numberOfPages===0){await this.props.onProcessDocuments({isForcingDelete:true});await this.props.close();}
this._displayNumberDeletedPages(pagesToDelete.length);this.state.focusedPage=nextFocusedPageId;if(this.state.viewedPage&&nextFocusedPageId){await this.onClickPage(nextFocusedPageId);}else{this.state.viewedPage=undefined;}},cancel:()=>{},});}
async onFileInputChange(ev){this.state.fileName="";if(!ev.target.files.length){return;}
const files=ev.target.files;for(const file of files){await this._addFile(file.name,{file});}
ev.target.value=null;}
onClickExit(){this._exitSplitTools();}
_onOutsideClick(ev){if((!this._exitSplitToolsClick&&(ev.target.closest(".dropdown-item")||ev.target.closest(".o_menu_toggle"))&&ev.target.closest(".dropdown-item")?.dataset.menu!=="shortcuts"&&ev.target.closest(".dropdown-item")?.dataset.menu!=="settings"&&ev.target.closest(".dropdown-item")?.dataset.menu!=="support"&&ev.target.closest(".dropdown-item")?.dataset.menu!=="documentation"&&!ev.target.closest("[data-dropdown-is-mobile]"))||ev.target.closest(".o_burger_menu_content")){ev.stopPropagation();ev.preventDefault();this._exitSplitTools(()=>{this._exitSplitToolsClick=true;ev.target.click();});}}
async onClickPage(pageId){this.state.focusedPage=pageId;const page=this.state.pageCanvases[pageId].page;if(!page){return;}
const previewWrapper=document.querySelector(".o_documents_pdf_page_preview");const ratio=18/13;const width=previewWrapper.clientWidth-(30*window.innerWidth)/100;this.previewCanvas=await this._renderCanvas(toRaw(page),{width:width,height:width*ratio,});this.state.viewedPage=pageId;const targetGroup=this.state.groupData[this.state.pages[pageId].groupId];this.state.viewedPageName=targetGroup.name+"-p"+(targetGroup.pageIds.indexOf(pageId)+1);const sortedPagesIds=this.sortedPagesIds;this.state.viewedPageIndex=sortedPagesIds.indexOf(pageId);}
async onClickPrevious(){if(this.state.viewedPageIndex>0){await this.onClickPage(this.sortedPagesIds[this.state.viewedPageIndex-1]);}}
async onClickNext(){if(this.state.viewedPageIndex<this.state.numberOfPages-1){await this.onClickPage(this.sortedPagesIds[this.state.viewedPageIndex+1]);}}
onClickExitPreview(ev){if(ev.target.classList.contains("o_documents_pdf_page_preview")||ev.target.closest(".o_close_button")){this.state.focusedPage=this.state.viewedPage;this.previewCanvas=undefined;this.state.viewedPage=undefined;}}
onSelectClicked(pageId,isRangeSelection,ctrlKey){this.state.pages[pageId].isSelected=!this.state.pages[pageId].isSelected;if(isRangeSelection&&this.state.lastSelectedPage&&this.state.pages[pageId].isSelected){const sortedPagesIds=this.sortedPagesIds;const pageIndex=sortedPagesIds.indexOf(pageId);const lastSelectedPageIndex=sortedPagesIds.indexOf(this.state.lastSelectedPage);const pagesToSelect=pageIndex<lastSelectedPageIndex?sortedPagesIds.slice(pageIndex,lastSelectedPageIndex+1):sortedPagesIds.slice(lastSelectedPageIndex,pageIndex+1);for(const pageId of pagesToSelect){this.state.pages[pageId].isSelected=true;}}
this.state.lastSelectedPage=pageId;}
onClickPageSeparator(pageId,groupId){this._pageSeparator(pageId,groupId);}
onEditName(groupId,name){this.state.groupData[groupId].name=name||_t("unnamed");}
onPageDragStart(ev){ev.stopPropagation();}
onPageDrop(targetPageId,pageId){const targetGroupId=this.state.pages[targetPageId].groupId;const index=this.state.groupData[targetGroupId].pageIds.indexOf(targetPageId);this._addPage(pageId,targetGroupId,{index});}}
return __exports;});;

/* /documents/static/src/owl/components/pdf_page/pdf_page.js */
odoo.define('@documents/owl/components/pdf_page/pdf_page',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,onMounted,onPatched,useState,useRef}=require("@odoo/owl");const PdfPage=__exports.PdfPage=class PdfPage extends Component{static defaultProps={isPreview:false,isSelected:false,};static props={canvas:{type:Object,optional:true},isPreview:{type:Boolean,optional:true},isSelected:{type:Boolean,optional:true},isFocused:{type:Boolean,optional:true},onPageClicked:{type:Function,optional:true},onPageDragged:{type:Function,optional:true},onPageDropped:{type:Function,optional:true},onSelectClicked:{type:Function,optional:true},toRender:{type:Boolean,optional:true},pageId:String,};static template="documents.component.PdfPage";setup(){this.state=useState({isHover:false,});this.canvasWrapperRef=useRef("canvasWrapper");this.isRendered=false;onMounted(()=>this.renderPage(this.props.canvas));onPatched(()=>this.renderPage(this.props.canvas));}
renderPage(canvas){if(this.props.toRender){this.isRendered=false;}
if(!canvas||this.isRendered){return;}
this.canvasWrapperRef.el.querySelector(".o_documents_pdf_canvas")?.remove();this.canvasWrapperRef.el.appendChild(canvas);this.isRendered=true;}
onClickWrapper(ev){if(this.props.onPageClicked){this.props.onPageClicked(this.props.pageId);}}
onClickSelect(ev){if(this.props.onSelectClicked){this.props.onSelectClicked(this.props.pageId,ev.shiftKey,ev.ctrlKey||ev.metaKey);}}
onDragEnter(ev){ev.preventDefault();this.state.isHover=true;}
onDragLeave(ev){ev.preventDefault();this.state.isHover=false;}
onDragOver(ev){ev.preventDefault();}
onDragStart(ev){if(this.props.onPageDragged){this.props.onPageDragged(ev);}
ev.dataTransfer.setData("o_documents_pdf_data",this.props.pageId);}
onDrop(ev){this.state.isHover=false;if(!ev.dataTransfer.types.includes("o_documents_pdf_data")){return;}
const pageId=ev.dataTransfer.getData("o_documents_pdf_data");if(pageId===this.props.pageId){return;}
if(this.props.onPageDropped){this.props.onPageDropped(this.props.pageId,pageId);}}}
return __exports;});;

/* /documents/static/src/views/cog_menu/documents_cog_menu.js */
odoo.define('@documents/views/cog_menu/documents_cog_menu',['@web/search/cog_menu/cog_menu','@documents/views/cog_menu/documents_cog_menu_item_archive','@documents/views/cog_menu/documents_cog_menu_pin_actions','@documents/views/cog_menu/documents_cog_menu_item_details','@documents/views/cog_menu/documents_cog_menu_item_download','@documents/views/cog_menu/documents_cog_menu_item_share','@documents/views/cog_menu/documents_cog_menu_item_rename','@documents/views/cog_menu/documents_cog_menu_item_shortcut','@documents/views/cog_menu/documents_cog_menu_item_star','@documents/views/cog_menu/documents_cog_menu_item_automations'],function(require){'use strict';let __exports={};const{CogMenu}=require("@web/search/cog_menu/cog_menu");const{documentsCogMenuItemArchive}=require("@documents/views/cog_menu/documents_cog_menu_item_archive");const{documentCogMenuPinAction}=require("@documents/views/cog_menu/documents_cog_menu_pin_actions");const{documentsCogMenuItemDetails}=require("@documents/views/cog_menu/documents_cog_menu_item_details");const{documentsCogMenuItemDownload}=require("@documents/views/cog_menu/documents_cog_menu_item_download");const{documentsCogMenuItemShare}=require("@documents/views/cog_menu/documents_cog_menu_item_share");const{documentsCogMenuItemRename}=require("@documents/views/cog_menu/documents_cog_menu_item_rename");const{documentsCogMenuItemShortcut}=require("@documents/views/cog_menu/documents_cog_menu_item_shortcut");const{documentsCogMenuItemStarAdd,documentsCogMenuItemStarRemove,}=require("@documents/views/cog_menu/documents_cog_menu_item_star");const{documentsCogMenuItemAutomations}=require("@documents/views/cog_menu/documents_cog_menu_item_automations");const documentMenuItems=[documentsCogMenuItemDownload,documentsCogMenuItemRename,documentsCogMenuItemShare,documentsCogMenuItemShortcut,documentsCogMenuItemStarAdd,documentsCogMenuItemStarRemove,documentsCogMenuItemDetails,documentsCogMenuItemArchive,documentCogMenuPinAction,documentsCogMenuItemAutomations,];const DocumentsCogMenu=__exports.DocumentsCogMenu=class DocumentsCogMenu extends CogMenu{async _registryItems(){const enabledItems=[];for(const item of documentMenuItems){if(await item.isDisplayed(this.env)){enabledItems.push({Component:item.Component,groupNumber:item.groupNumber,key:item.Component.name,});}}
return enabledItems;}}
return __exports;});;

/* /documents/static/src/views/cog_menu/documents_cog_menu_group.js */
odoo.define('@documents/views/cog_menu/documents_cog_menu_group',['@web/search/action_menus/action_menus'],function(require){'use strict';let __exports={};const{STATIC_ACTIONS_GROUP_NUMBER}=require("@web/search/action_menus/action_menus");const STATIC_COG_GROUP_ACTION_BASIC=__exports.STATIC_COG_GROUP_ACTION_BASIC=STATIC_ACTIONS_GROUP_NUMBER;const STATIC_COG_GROUP_ACTION_ADVANCED=__exports.STATIC_COG_GROUP_ACTION_ADVANCED=STATIC_ACTIONS_GROUP_NUMBER+1;const STATIC_COG_GROUP_ACTION_CLEANUP=__exports.STATIC_COG_GROUP_ACTION_CLEANUP=STATIC_ACTIONS_GROUP_NUMBER+2;const STATIC_COG_GROUP_ACTION_PIN=__exports.STATIC_COG_GROUP_ACTION_PIN=STATIC_ACTIONS_GROUP_NUMBER+3;return __exports;});;

/* /documents/static/src/views/cog_menu/documents_cog_menu_item.js */
odoo.define('@documents/views/cog_menu/documents_cog_menu_item',['@odoo/owl','@web/core/dropdown/dropdown_item','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{useService}=require("@web/core/utils/hooks");const DocumentsCogMenuItem=__exports.DocumentsCogMenuItem=class DocumentsCogMenuItem extends Component{static template="documents.DocumentCogMenuItem";static components={DropdownItem};static props={};static isVisible({config,searchModel,services},isVisibleAdditional=false){if(!(config&&searchModel&&searchModel.resModel==="documents.document"&&services)){return false;}
const folder=searchModel?.getSelectedFolder();const documentService=services["document.document"];return(folder&&documentService&&["kanban","list"].includes(config.viewType)&&(!isVisibleAdditional||isVisibleAdditional({folder,config,searchModel,documentService})));}
setup(){this.action=useService("action");}
async onItemSelected(){const folder=this.env?.searchModel?.getSelectedFolder();if(!folder){return;}
await this.doActionOnFolder(folder);}
async reload(){await this.env.searchModel._reloadSearchModel(true);await this.env.model.load();await this.env.model.notify();}
async doActionOnFolder(folder){}}
return __exports;});;

/* /documents/static/src/views/cog_menu/documents_cog_menu_item_archive.js */
odoo.define('@documents/views/cog_menu/documents_cog_menu_item_archive',['@documents/views/cog_menu/documents_cog_menu_group','@documents/views/cog_menu/documents_cog_menu_item','@documents/views/hooks','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{STATIC_COG_GROUP_ACTION_CLEANUP}=require("@documents/views/cog_menu/documents_cog_menu_group");const{DocumentsCogMenuItem}=require("@documents/views/cog_menu/documents_cog_menu_item");const{toggleArchive}=require("@documents/views/hooks");const{_t}=require("@web/core/l10n/translation");const DocumentsCogMenuItemArchive=__exports.DocumentsCogMenuItemArchive=class DocumentsCogMenuItemArchive extends DocumentsCogMenuItem{setup(){this.icon="fa-trash";this.label=_t("Move to trash");super.setup();}
async doActionOnFolder(folder){await toggleArchive(this.env.model,"documents.document",folder.id,true);await this.reload();}}
const documentsCogMenuItemArchive=__exports.documentsCogMenuItemArchive={Component:DocumentsCogMenuItemArchive,groupNumber:STATIC_COG_GROUP_ACTION_CLEANUP,isDisplayed:(env)=>DocumentsCogMenuItem.isVisible(env,({folder,documentService})=>documentService.userIsInternal&&documentService.isEditable(folder)),};return __exports;});;

/* /documents/static/src/views/cog_menu/documents_cog_menu_item_automations.js */
odoo.define('@documents/views/cog_menu/documents_cog_menu_item_automations',['@documents/views/cog_menu/documents_cog_menu_group','@documents/views/cog_menu/documents_cog_menu_item','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{STATIC_COG_GROUP_ACTION_PIN}=require("@documents/views/cog_menu/documents_cog_menu_group");const{DocumentsCogMenuItem}=require("@documents/views/cog_menu/documents_cog_menu_item");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const DocumentsCogMenuItemAutomations=__exports.DocumentsCogMenuItemAutomations=class DocumentsCogMenuItemAutomations extends DocumentsCogMenuItem{setup(){this.icon="fa-cog";this.label=_t("Automations");super.setup();this.orm=useService("orm");this.dialog=useService("dialog");}
async doActionOnFolder(folder){this.env?.documentsView.bus.trigger("documents-open-automations",{folderId:folder.id,folderDisplayName:folder.display_name,});}}
const documentsCogMenuItemAutomations=__exports.documentsCogMenuItemAutomations={Component:DocumentsCogMenuItemAutomations,groupNumber:STATIC_COG_GROUP_ACTION_PIN,isDisplayed:(env)=>env.model.documentService.userIsDocumentUser&&DocumentsCogMenuItem.isVisible(env,({folder,documentService})=>documentService.isEditable(folder)),};return __exports;});;

/* /documents/static/src/views/cog_menu/documents_cog_menu_item_details.js */
odoo.define('@documents/views/cog_menu/documents_cog_menu_item_details',['@documents/views/cog_menu/documents_cog_menu_group','@documents/views/cog_menu/documents_cog_menu_item','@web/core/utils/hooks','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{STATIC_COG_GROUP_ACTION_ADVANCED}=require("@documents/views/cog_menu/documents_cog_menu_group");const{DocumentsCogMenuItem}=require("@documents/views/cog_menu/documents_cog_menu_item");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const DocumentsCogMenuItemDetails=__exports.DocumentsCogMenuItemDetails=class DocumentsCogMenuItemDetails extends DocumentsCogMenuItem{setup(){this.icon="fa-info-circle";this.label=_t("Info & Tags");this.documentService=useService("document.document");super.setup();}
async doActionOnFolder(folder){this.documentService.toggleChatterState();}}
const documentsCogMenuItemDetails=__exports.documentsCogMenuItemDetails={Component:DocumentsCogMenuItemDetails,groupNumber:STATIC_COG_GROUP_ACTION_ADVANCED,isDisplayed:(env)=>DocumentsCogMenuItem.isVisible(env,({documentService,folder})=>documentService.userIsInternal&&typeof folder.id==="number"),};return __exports;});;

/* /documents/static/src/views/cog_menu/documents_cog_menu_item_download.js */
odoo.define('@documents/views/cog_menu/documents_cog_menu_item_download',['@documents/views/cog_menu/documents_cog_menu_group','@documents/views/cog_menu/documents_cog_menu_item','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{STATIC_COG_GROUP_ACTION_BASIC}=require("@documents/views/cog_menu/documents_cog_menu_group");const{DocumentsCogMenuItem}=require("@documents/views/cog_menu/documents_cog_menu_item");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const DocumentsCogMenuItemDownload=__exports.DocumentsCogMenuItemDownload=class DocumentsCogMenuItemDownload extends DocumentsCogMenuItem{setup(){this.icon="fa-download";this.label=_t("Download");super.setup();this.action=useService("action");}
async doActionOnFolder(folder){this.action.doAction({type:"ir.actions.act_url",url:`/documents/content/${encodeURIComponent(folder.access_token)}`,});}}
const documentsCogMenuItemDownload=__exports.documentsCogMenuItemDownload={Component:DocumentsCogMenuItemDownload,groupNumber:STATIC_COG_GROUP_ACTION_BASIC,isDisplayed:(env)=>DocumentsCogMenuItem.isVisible(env,({folder,documentService})=>documentService.canDownload(folder)),};return __exports;});;

/* /documents/static/src/views/cog_menu/documents_cog_menu_item_rename.js */
odoo.define('@documents/views/cog_menu/documents_cog_menu_item_rename',['@documents/views/cog_menu/documents_cog_menu_group','@documents/views/cog_menu/documents_cog_menu_item','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{STATIC_COG_GROUP_ACTION_BASIC}=require("@documents/views/cog_menu/documents_cog_menu_group");const{DocumentsCogMenuItem}=require("@documents/views/cog_menu/documents_cog_menu_item");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const DocumentsCogMenuItemRename=__exports.DocumentsCogMenuItemRename=class DocumentsCogMenuItemRename extends DocumentsCogMenuItem{setup(){this.icon="fa-edit";this.label=_t("Rename");super.setup();this.documentService=useService("document.document");}
async doActionOnFolder(folder){await this.documentService.openDialogRename(folder.id);await this.reload();}}
const documentsCogMenuItemRename=__exports.documentsCogMenuItemRename={Component:DocumentsCogMenuItemRename,groupNumber:STATIC_COG_GROUP_ACTION_BASIC,isDisplayed:(env)=>DocumentsCogMenuItem.isVisible(env,({folder,documentService})=>documentService.isEditable(folder)),};return __exports;});;

/* /documents/static/src/views/cog_menu/documents_cog_menu_item_share.js */
odoo.define('@documents/views/cog_menu/documents_cog_menu_item_share',['@documents/views/cog_menu/documents_cog_menu_group','@documents/views/cog_menu/documents_cog_menu_item','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{STATIC_COG_GROUP_ACTION_ADVANCED}=require("@documents/views/cog_menu/documents_cog_menu_group");const{DocumentsCogMenuItem}=require("@documents/views/cog_menu/documents_cog_menu_item");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const DocumentsCogMenuItemShare=__exports.DocumentsCogMenuItemShare=class DocumentsCogMenuItemShare extends DocumentsCogMenuItem{setup(){this.icon="fa-share-alt";this.label=_t("Share");super.setup();this.documentService=useService("document.document");}
async doActionOnFolder(folder){this.env?.documentsView.bus.trigger("documents-open-share",{id:folder.id,shortcut_document_id:folder.shortcut_document_id,});}}
const documentsCogMenuItemShare=__exports.documentsCogMenuItemShare={Component:DocumentsCogMenuItemShare,groupNumber:STATIC_COG_GROUP_ACTION_ADVANCED,isDisplayed:(env)=>DocumentsCogMenuItem.isVisible(env,({folder,documentService})=>documentService.userIsInternal&&documentService.isFolderSharable(folder)),};return __exports;});;

/* /documents/static/src/views/cog_menu/documents_cog_menu_item_shortcut.js */
odoo.define('@documents/views/cog_menu/documents_cog_menu_item_shortcut',['@documents/views/cog_menu/documents_cog_menu_group','@documents/views/cog_menu/documents_cog_menu_item','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{STATIC_COG_GROUP_ACTION_ADVANCED}=require("@documents/views/cog_menu/documents_cog_menu_group");const{DocumentsCogMenuItem}=require("@documents/views/cog_menu/documents_cog_menu_item");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const DocumentsCogMenuItemShortcut=__exports.DocumentsCogMenuItemShortcut=class DocumentsCogMenuItemShortcut extends DocumentsCogMenuItem{setup(){this.icon="fa-external-link-square";this.label=_t("Add shortcut");super.setup();this.documentService=useService("document.document");}
async doActionOnFolder(folder){await this.documentService.createShortcut([folder.id]);await this.reload();}}
const documentsCogMenuItemShortcut=__exports.documentsCogMenuItemShortcut={Component:DocumentsCogMenuItemShortcut,groupNumber:STATIC_COG_GROUP_ACTION_ADVANCED,isDisplayed:(env)=>DocumentsCogMenuItem.isVisible(env,({folder,documentService})=>documentService.isEditable(folder)&&!folder.shortcut_document_id&&typeof folder.folder_id==="number"),};return __exports;});;

/* /documents/static/src/views/cog_menu/documents_cog_menu_item_star.js */
odoo.define('@documents/views/cog_menu/documents_cog_menu_item_star',['@documents/views/cog_menu/documents_cog_menu_group','@documents/views/cog_menu/documents_cog_menu_item','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{STATIC_COG_GROUP_ACTION_ADVANCED}=require("@documents/views/cog_menu/documents_cog_menu_group");const{DocumentsCogMenuItem}=require("@documents/views/cog_menu/documents_cog_menu_item");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const DocumentsCogMenuItemStar=__exports.DocumentsCogMenuItemStar=class DocumentsCogMenuItemStar extends DocumentsCogMenuItem{setup(isAdd){this.icon=isAdd?"fa-star-o":"fa-star";this.label=isAdd?_t("Add star"):_t("Remove star");super.setup();this.documentService=useService("document.document");}
async doActionOnFolder(folder){await this.documentService.toggleFavorite(folder);await this.reload();}}
const DocumentsCogMenuItemStarAdd=__exports.DocumentsCogMenuItemStarAdd=class DocumentsCogMenuItemStarAdd extends DocumentsCogMenuItemStar{setup(){super.setup(true);}}
const DocumentsCogMenuItemStarRemove=__exports.DocumentsCogMenuItemStarRemove=class DocumentsCogMenuItemStarRemove extends DocumentsCogMenuItemStar{setup(){super.setup(false);}}
const documentsCogMenuItemStarAdd=__exports.documentsCogMenuItemStarAdd={Component:DocumentsCogMenuItemStarAdd,groupNumber:STATIC_COG_GROUP_ACTION_ADVANCED,isDisplayed:(env)=>DocumentsCogMenuItem.isVisible(env,({folder,documentService})=>documentService.isEditable(folder)&&!folder.is_favorited),};const documentsCogMenuItemStarRemove=__exports.documentsCogMenuItemStarRemove={Component:DocumentsCogMenuItemStarRemove,groupNumber:STATIC_COG_GROUP_ACTION_ADVANCED,isDisplayed:(env)=>DocumentsCogMenuItem.isVisible(env,({folder,documentService})=>documentService.isEditable(folder)&&folder.is_favorited),};return __exports;});;

/* /documents/static/src/views/cog_menu/documents_cog_menu_pin_actions.js */
odoo.define('@documents/views/cog_menu/documents_cog_menu_pin_actions',['@odoo/owl','@web/core/utils/hooks','@documents/views/cog_menu/documents_cog_menu_group','@web/core/dropdown/dropdown','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Component,useState,onWillStart}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{STATIC_COG_GROUP_ACTION_PIN}=require("@documents/views/cog_menu/documents_cog_menu_group");const{Dropdown}=require("@web/core/dropdown/dropdown");const{_t}=require("@web/core/l10n/translation");const DocumentCogMenuPinAction=__exports.DocumentCogMenuPinAction=class DocumentCogMenuPinAction extends Component{static template="documents.DocumentCogMenuPinAction";static components={Dropdown};static props={};static isVisible({config,searchModel,services},isVisibleAdditional=false){if(!(config&&searchModel&&searchModel.resModel==="documents.document"&&services)){return false;}
const folder=searchModel?.getSelectedFolder();const documentService=services["document.document"];return(folder&&documentService&&["kanban","list"].includes(config.viewType)&&(!isVisibleAdditional||isVisibleAdditional({folder,config,searchModel,documentService})));}
setup(){this.action=useService("action");this.documentService=useService("document.document");this.notification=useService("notification");this.documentsState=useState({actions:null});onWillStart(async()=>{const folderId=this.env.searchModel.getSelectedFolderId();this.documentsState.actions=await this.documentService.getActions(folderId);});}
async onEnableAction(actionId){const currentFolderId=this.env.searchModel.getSelectedFolderId();if(!currentFolderId||typeof currentFolderId!=="number"){this.notification.add(_t("You can not pin actions for that folder."),{type:"warning",});return;}
this.documentsState.actions=await this.documentService.enableAction(currentFolderId,actionId);this.env.searchModel._reloadSearchModel(true);}}
const documentCogMenuPinAction=__exports.documentCogMenuPinAction={Component:DocumentCogMenuPinAction,groupNumber:STATIC_COG_GROUP_ACTION_PIN,isDisplayed:(env)=>env.model.documentService.userIsDocumentUser&&DocumentCogMenuPinAction.isVisible(env,({folder,documentService})=>documentService.isEditable(folder))};return __exports;});;

/* /documents/static/src/views/documents_controller_mixin.js */
odoo.define('@documents/views/documents_controller_mixin',['@web/search/search_bar/search_bar_toggler','@odoo/owl'],function(require){'use strict';let __exports={};const{useSearchBarToggler}=require("@web/search/search_bar/search_bar_toggler");const{useSubEnv}=require("@odoo/owl");const DocumentsControllerMixin=__exports.DocumentsControllerMixin=(component)=>class extends component{setup(){super.setup(...arguments);this.searchBarToggler=useSearchBarToggler();useSubEnv({searchBarToggler:this.searchBarToggler,});}
get modelParams(){const modelParams=super.modelParams;const knownDescriptions={bool:{...modelParams.config.activeFields.is_access_via_link_hidden},char:{...modelParams.config.activeFields.name},m2o:{...modelParams.config.activeFields.owner_id},m2m:{...modelParams.config.activeFields.tag_ids},}
Object.assign(modelParams.config.activeFields,{alias_domain_id:modelParams.config.activeFields.alias_domain_id||knownDescriptions.m2o,alias_name:modelParams.config.activeFields.alias_name||knownDescriptions.char,alias_tag_ids:modelParams.config.activeFields.alias_tag_ids||knownDescriptions.m2m,create_activity_user_id:modelParams.config.activeFields.create_activity_user_id||knownDescriptions.m2o,create_activity_type_id:modelParams.config.activeFields.create_activity_type_id||knownDescriptions.m2o,file_size:modelParams.config.activeFields.file_size||{...modelParams.config.activeFields.id},is_pinned_folder:modelParams.config.activeFields.is_pinned_folder||{...knownDescriptions.bool},res_name:modelParams.config.activeFields.res_name||{...knownDescriptions.char,readonly:true},});modelParams.multiEdit=true;return modelParams;}};return __exports;});;

/* /documents/static/src/views/documents_folder_many2one/documents_folder_many2one.js */
odoo.define('@documents/views/documents_folder_many2one/documents_folder_many2one',['@web/core/registry','@web/views/fields/many2one/many2one_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Many2OneField,many2OneField}=require("@web/views/fields/many2one/many2one_field");const DocumentsFolderMany2One=__exports.DocumentsFolderMany2One=class DocumentsFolderMany2One extends Many2OneField{async openAction(){await this.action.doAction("documents.document_action",{additionalContext:{no_documents_unique_folder_id:true,searchpanel_default_folder_id:this.resId,},});}
onExternalBtnClick(){this.openAction();}}
const documentsFolderMany2One=__exports.documentsFolderMany2One={...many2OneField,component:DocumentsFolderMany2One,};registry.category("fields").add("documents_folder_many2one",documentsFolderMany2One);return __exports;});;

/* /documents/static/src/views/documents_model_mixin.js */
odoo.define('@documents/views/documents_model_mixin',['@web/core/l10n/translation','@web/core/user','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{user}=require('@web/core/user');const{useService}=require("@web/core/utils/hooks");const DocumentsModelMixin=__exports.DocumentsModelMixin=(component)=>class extends component{setup(params){super.setup(...arguments);if(this.config.resModel==="documents.document"){this.originalSelection=params.state?.sharedSelection;}
this.documentService=useService("document.document");this.initialLimit=40;}
exportSelection(){return this.root.selection.map((rec)=>rec.resId);}
async load(){const selection=this.root?.selection;if(!this.originalSelection&&selection&&selection.length>0){this.originalSelection=selection.map((rec)=>rec.resId);}
for(let arg of arguments){arg.context['skip_res_field_check']=true;}
const res=await super.load(...arguments);if(this.config.resModel!=="documents.document"){return res;}
this.env.searchModel.skipLoadClosePreview?this.env.searchModel.skipLoadClosePreview=false:this.env.documentsView.bus.trigger("documents-close-preview");this._reapplySelection();this._computeFileSize();this.shortcutTargetRecords=this.orm.isSample?[]:await this._loadShortcutTargetRecords();return res;}
_reapplySelection(){const records=this.root.records;if(this.originalSelection&&this.originalSelection.length>0&&records){const originalSelection=new Set(this.originalSelection);records.forEach((record)=>{record.selected=originalSelection.has(record.resId);});delete this.originalSelection;}}
_computeFileSize(){let size=0;if(this.root.groups){size=this.root.groups.reduce((size,group)=>{return size+group.aggregates.file_size;},0);}else if(this.root.records){size=this.root.records.reduce((size,rec)=>{return size+rec.data.file_size;},0);}
size/=1000*1000;this.fileSize=Math.round(size*100)/100;}
async _loadShortcutTargetRecords(){const shortcuts=this.root.records.filter((record)=>!!record.data.shortcut_document_id,);if(!shortcuts.length){return[];}
const shortcutTargetRecords=[];const targetRecords=await this._loadRecords({...this.config,resIds:shortcuts.map((record)=>record.data.shortcut_document_id[0]),});for(const targetRecord of targetRecords){shortcutTargetRecords.push(this._createRecordDatapoint(targetRecord));}
return shortcutTargetRecords;}
_createRecordDatapoint(data,mode="readonly"){return new this.constructor.Record(this,{context:this.config.context,activeFields:this.config.activeFields,resModel:this.config.resModel,fields:this.config.fields,resId:data.id||false,resIds:data.id?[data.id]:[],isMonoRecord:true,currentCompanyId:this.config.currentCompanyId,mode,},data,{manuallyAdded:!data.id});}};const DocumentsRecordMixin=__exports.DocumentsRecordMixin=(component)=>class extends component{async update(changes,options={}){const modelMultiEdit=this.model.multiEdit;let movedRecordsIds=this.model.root.selection.map((rec)=>rec.id);if(this.resId===this.model.documentService.previewedDocument?.record.resId){options.save=true;this.model.multiEdit=false;movedRecordsIds=[this.model.root.records.find((rec)=>rec.data.id===this.resId).id];}
const originalFolderId=this.data.folder_id[0];const ret=await super.update(changes,options);if(this.data.folder_id&&this.data.folder_id[0]!==originalFolderId){this.model.root._removeRecords(movedRecordsIds);this.model.env.documentsView.bus.trigger("documents-close-preview");}
this.model.multiEdit=modelMultiEdit;return ret;}
isPdf(){return this.data.mimetype==="application/pdf"||this.data.mimetype==="application/pdf;base64";}
isRequest(){return!this.data.shortcut_document_id&&this.data.type==="binary"&&!this.data.attachment_id;}
isShortcut(){return!!this.data.shortcut_document_id;}
isURL(){return!this.data.shortcut_document_id&&this.data.type==="url";}
get shortcutTarget(){if(!this.isShortcut()){return this;}
return this.model.shortcutTargetRecords.find((rec)=>rec.resId===this.data.shortcut_document_id[0],)||this;}
hasStoredThumbnail(){return this.data.thumbnail_status==="present";}
isViewable(){const thisRecord=this.shortcutTarget;return(thisRecord.data.type!=="folder"&&(["image/bmp","image/gif","image/jpeg","image/png","image/svg+xml","image/tiff","image/x-icon","image/webp","application/javascript","application/json","text/css","text/html","text/plain","application/pdf","application/pdf;base64","audio/mpeg","video/x-matroska","video/mp4","video/webm",].includes(thisRecord.data.mimetype)||(thisRecord.data.url&&thisRecord.data.url.includes("youtu"))));}
async onClickPreview(ev){if(this.isRequest()){ev.stopPropagation();ev.target.querySelector(".o_kanban_replace_document")?.click();}else if(this.isViewable()){ev.stopPropagation();ev.preventDefault();const folder=this.model.env.searchModel.getFolders().filter((folder)=>folder.id===this.data.folder_id[0]);const hasPdfSplit=(!this.data.lock_uid||this.data.lock_uid[0]===user.userId)&&folder.user_permission==="edit";const selection=this.model.root.selection;const documents=selection.length>1&&selection.find(rec=>rec===this)&&selection.filter(rec=>rec.isViewable())||[this];const embeddedActions=this.data.available_embedded_actions_ids?.records.map((rec)=>({id:rec.resId,name:rec.data.display_name}))||[];await this.model.env.documentsView.bus.trigger("documents-open-preview",{documents,mainDocument:this,isPdfSplit:false,embeddedActions,hasPdfSplit,});}else if(this.isURL()){window.open(this.data.url,"_blank");}}
onRecordClick(ev,options={}){Object.assign(options,{isKeepSelection:options.isKeepSelection??(ev.ctrlKey||ev.metaKey),isRangeSelection:options.isRangeSelection??ev.shiftKey,});if(this.model.env.searchModel.getSelectedFolderId()==="TRASH"||this.data.type!=="folder"||options.isKeepSelection||options.isRangeSelection){this.selectRecord(ev,options);}else{this.openFolder();}}
openFolder(){const section=this.model.env.searchModel.getSections()[0];const target=this.isShortcut()?this.shortcutTarget:this;const folderId=target.data.active?target.data.id:"TRASH";this.model.env.searchModel.toggleCategoryValue(section.id,folderId);this.model.originalSelection=[this.shortcutTarget.resId];this.model.env.documentsView.bus.trigger("documents-expand-folder",{folderId:folderId});}
selectRecord(ev,options={}){const{isKeepSelection,isRangeSelection}=options;const root=this.model.root;const anchor=root._documentsAnchor;if(!isRangeSelection||root.selection.length===0){root._documentsAnchor=this;}
if(isRangeSelection&&anchor){const selectionDocumentIds=root.selection.map((r)=>r.resId);const documentIds=Array.from(document.querySelectorAll(".o_kanban_record:not(.o_kanban_ghost)"),).map((el)=>parseInt(el.querySelector("div").dataset.id));const indexFrom=documentIds.indexOf(anchor.resId);const indexTo=documentIds.indexOf(this.resId);const lowerIdx=Math.min(indexFrom,indexTo);const upperIdx=Math.max(indexFrom,indexTo)+1;const toSelectDocumentIds=[...new Set([...selectionDocumentIds,...documentIds.slice(lowerIdx,upperIdx)]),];root.records.forEach((r)=>{r.selected=r!=this&&toSelectDocumentIds.includes(r.resId);});}else if(!isKeepSelection){root.selection.forEach((rec)=>{rec.selected=false;});}
this.toggleSelection();}
async toggleSelection(selected){await super.toggleSelection(selected);if(this.selected){this.model.documentService.logAccess(this.data.access_token);}
this.model.documentService.updateDocumentURL(null,this.model.root.selection);}
jumpToTarget(){const section=this.model.env.searchModel.getSections()[0];let folderId;if(!this.shortcutTarget.data.active){folderId="TRASH";}else if(this.shortcutTarget.data.type==="folder"){folderId=this.data.shortcut_document_id?.[0]||this.shortcutTarget.data.id;}else if(this.shortcutTarget.data.folder_id){folderId=this.shortcutTarget.data.folder_id[0];}else if(this.shortcutTarget.data.owner_id[0]===this.model.documentService.store.odoobot.userId){folderId="COMPANY";}else if(this.shortcutTarget.data.owner_id[0]===user.userId){folderId="MY";}
if(!folderId||!this.model.env.searchModel.getFolderById(folderId)){folderId="SHARED";}
this.model.env.searchModel.toggleCategoryValue(section.id,folderId);this.model.originalSelection=[this.shortcutTarget.resId];this.model.env.documentsView.bus.trigger("documents-expand-folder",{folderId:folderId});}
async onDragStart(ev){const currentFolder=this.model.env.searchModel.getSelectedFolder();if(currentFolder.id==="TRASH"){ev.preventDefault();return this.model.notification.add(_t("You cannot move folders or files when in the trash."),{title:_t("Invalid operation"),type:"warning"});}
if(!this.selected){this.model.root.selection.forEach((rec)=>rec.selected=false);this.selected=true;}
const root=this.model.root;const draggableRecords=root.selection.filter((record)=>(!record.data.lock_uid||record.data.lock_uid[0]===this.context.uid));if(draggableRecords.length===0){ev.preventDefault();return;}
const foldersById=Object.fromEntries(this.model.env.searchModel.getFolders().map((folder)=>[folder.id,folder]));const movableRecords=draggableRecords.filter((record)=>record.data.user_permission==="edit"&&(!record.data.folder_id||foldersById[record.data.folder_id[0]].user_permission==="edit"),);const nonMovableRecords=draggableRecords.filter((record)=>!movableRecords.includes(record),);const lockedCount=root.selection.reduce((count,record)=>{return count+(record.data.lock_uid&&record.data.lock_uid[0]!==this.context.uid);},0);const folderCount=draggableRecords.reduce((count,record)=>{return count+(record.data.type==="folder");},0);const fileCount=draggableRecords.length-folderCount;ev.dataTransfer.setData("o_documents_data",JSON.stringify({recordIds:draggableRecords.map((record)=>record.resId),movableRecordIds:movableRecords.map((record)=>record.resId),nonMovableRecordIds:nonMovableRecords.map((record)=>record.resId),lockedCount,}));let dragText;if(draggableRecords.length===1){dragText=draggableRecords[0].data.name?draggableRecords[0].data.display_name:_t("Unnamed");}else{let fileCountText,folderCountText;if(fileCount){fileCountText=(fileCount.length===1)?_t("1 File"):_t("%s Files",fileCount);}
if(folderCount){folderCountText=(folderCount.length===1)?_t("1 Folder"):_t("%s Folders",folderCount);}
dragText=fileCount?fileCountText:"";dragText+=folderCount?fileCount?" "+folderCountText:folderCountText:"";}
if(lockedCount>0){dragText+=_t(" (%s locked)",lockedCount);}
const newElement=document.createElement("span");newElement.classList.add("o_documents_drag_icon");newElement.innerText=dragText;document.body.append(newElement);ev.dataTransfer.setDragImage(newElement,-5,-5);setTimeout(()=>newElement.remove());}
async onDrop(ev){if(!this.isValidDragTarget(ev)){return;}
if(this.data.user_permission!="edit"){return this.model.notification.add(_t("You don't have the rights to move documents nor create shortcut to that folder."),{title:_t("Access Error"),type:"warning",});}
if(ev.dataTransfer.types.includes("o_documents_data")){const data=JSON.parse(ev.dataTransfer.getData("o_documents_data"));this.model.root.selection.forEach((rec)=>rec.selected=false);await this.model.documentService.moveOrCreateShortcut(data,this.data.id,ev.ctrlKey);await this.model.env.searchModel._reloadSearchModel(true);}}
isValidDragTarget({dataTransfer}){const data=JSON.parse(dataTransfer.getData("o_documents_data"));return this.data.type=="folder"&&!data.recordIds.includes(this.resId);}};return __exports;});;

/* /documents/static/src/views/documents_renderer_mixin.js */
odoo.define('@documents/views/documents_renderer_mixin',['@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useBus,useService}=require("@web/core/utils/hooks");const{useState}=require("@odoo/owl");const DocumentsRendererMixin=__exports.DocumentsRendererMixin=(component)=>class extends component{setup(){super.setup();this.documentService=useService("document.document");this.documentService.chatterState.previewedDocument=null;this.chatterState=useState(this.documentService.chatterState);useBus(this.documentService.bus,"DOCUMENT_PREVIEWED",async(ev)=>{this.chatterState.previewedDocument=this.documentService.previewedDocument;});}
getContainerRecord(){const folder=this.env.searchModel.getSelectedFolder();const folderData=this.env.searchModel.getFolderAndParents(folder);const folderId=typeof folder.folder_id==="object"?folder.folder_id:folderData?.length>1&&typeof folderData[1].id==="number"?[folderData[1].id,folderData[1].display_name]:false;const data=Object.assign({},folder,{folder_id:folderId,name:folder.display_name,type:"folder",file_size:(this.props.list.model.fileSize||0)*1e6,});const config={...this.env.model.config,resId:data.id}
const record=new this.env.model.constructor.Record(this.env.model,config,data);record.isContainer=true;record._update=async(changes,{})=>{record.dirty=true;const fieldsToSave=new Set(Object.keys(changes));await Promise.all([record._preprocessMany2oneChanges(changes),record._preprocessMany2OneReferenceChanges(changes),record._preprocessReferenceChanges(changes),record._preprocessX2manyChanges(changes),]);record._applyChanges(changes);const changesToSave=Object.fromEntries(Object.entries(record._getChanges()).filter(([k,_v])=>fieldsToSave.has(k)));await this.env.model.orm.write('documents.document',[record.data.id],changesToSave);await this.env.searchModel._reloadSearchPanel();};record.load=async()=>{await this.env.searchModel._reloadSearchPanel();};record._save=async()=>true;return record;}
getNbViewItems(){return this.props.list.model.useSampleModel?0:this.props.list.count;}
get targetRecords(){return this.chatterState.previewedDocument?[this.chatterState.previewedDocument.record]:this.props.list.selection;}};return __exports;});;

/* /documents/static/src/views/documents_type_icon/documents_type_icon.js */
odoo.define('@documents/views/documents_type_icon/documents_type_icon',['@odoo/owl','@web/core/registry','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");class DocumentsTypeIcon extends Component{static template="documents.DocumentsTypeIcon";static props={...standardFieldProps};}
const documentsTypeIcon={component:DocumentsTypeIcon,};registry.category("fields").add("documents_type_icon",documentsTypeIcon);return __exports;});;

/* /documents/static/src/views/fields/documents_details_many2many_tags.js */
odoo.define('@documents/views/fields/documents_details_many2many_tags',['@web/views/fields/many2many_tags/many2many_tags_field'],function(require){'use strict';let __exports={};const{Many2ManyTagsField}=require("@web/views/fields/many2many_tags/many2many_tags_field");const DocumentsDetailsMany2ManyTagsField=__exports.DocumentsDetailsMany2ManyTagsField=class DocumentsDetailsMany2ManyTagsField extends Many2ManyTagsField{setup(){super.setup();const superUpdate=this.update;this.update=(recordlist)=>{const ret=superUpdate(recordlist);this.props.record.save();return ret;};if(this.quickCreate){const superQuickCreate=this.quickCreate;this.quickCreate=async(name)=>{const ret=await superQuickCreate(name);this.props.record.save();return ret;};}}
async deleteTag(id){await super.deleteTag(id);await this.props.record.save();}}
return __exports;});;

/* /documents/static/src/views/fields/kanban_many2many_tags.js */
odoo.define('@documents/views/fields/kanban_many2many_tags',['@web/views/fields/many2many_tags/many2many_tags_field','@web/views/fields/many2many_tags/kanban_many2many_tags_field','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Many2ManyTagsField}=require("@web/views/fields/many2many_tags/many2many_tags_field");const{KanbanMany2ManyTagsField}=require("@web/views/fields/many2many_tags/kanban_many2many_tags_field");const{patch}=require("@web/core/utils/patch");patch(KanbanMany2ManyTagsField.prototype,{get tags(){if(this.props.record._config.resModel==='documents.document'){return Object.getOwnPropertyDescriptor(Many2ManyTagsField.prototype,'tags').get.call(this);}
return super.tags;}});return __exports;});;

/* /documents/static/src/views/form/folder_form_controller.js */
odoo.define('@documents/views/form/folder_form_controller',['@web/views/form/form_controller','@web/core/confirmation_dialog/confirmation_dialog','@web/core/utils/hooks','@web/core/l10n/translation','@documents/views/hooks'],function(require){'use strict';let __exports={};const{FormController}=require('@web/views/form/form_controller');const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const{preSuperSetupFolder}=require("@documents/views/hooks");const FolderFormController=__exports.FolderFormController=class FolderFormController extends FormController{setup(){preSuperSetupFolder();super.setup();this.action=useService("action");this.orm=useService("orm");this.dialog=useService("dialog");}
getStaticActionMenuItems(){const{activeActions}=this.archInfo;return{duplicate:{isAvailable:()=>activeActions.create&&activeActions.duplicate,sequence:30,icon:"fa fa-clone",description:_t("Duplicate"),callback:()=>this.duplicateRecord(),},unarchive:{isAvailable:()=>!this.model.root.data.active,sequence:20,icon:"fa fa-history",description:_t("Restore"),callback:()=>this.model.root.unarchive(),},delete:{isAvailable:()=>activeActions.delete&&!this.model.root.isNew&&this.model.root.data.active,sequence:40,icon:"fa fa-trash-o",description:_t("Delete"),callback:()=>this.deleteRecord(),skipSave:true,},};}
async deleteRecord(){const displayDialog=await this.orm.call(this.props.resModel,"is_folder_containing_document",[this.model.root.resId]);if(displayDialog){this.dialog.add(ConfirmationDialog,{title:_t("Move to trash?"),body:_t("Files will be sent to trash and deleted forever after %s days.",this._deletionDelay),confirmLabel:_t("Move to trash"),confirm:async()=>{await this.orm.call(this.props.resModel,"action_archive",[this.model.root.resId]);this.env.config.historyBack();},cancel:()=>{},});}else{await this.orm.call(this.props.resModel,"action_archive",[this.model.root.resId]);this.env.config.historyBack();}}}
return __exports;});;

/* /documents/static/src/views/form/folder_form_view.js */
odoo.define('@documents/views/form/folder_form_view',['@web/core/registry','@web/views/form/form_view','@documents/views/form/folder_form_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require('@web/views/form/form_view');const{FolderFormController}=require("@documents/views/form/folder_form_controller");const FolderFormView=__exports.FolderFormView={...formView,Controller:FolderFormController,};registry.category("views").add("folder_form",FolderFormView);return __exports;});;

/* /documents/static/src/views/helper/documents_action_helper.js */
odoo.define('@documents/views/helper/documents_action_helper',['@web/core/utils/hooks','@odoo/owl','@web/core/utils/strings','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{Component,markup,onWillStart,onWillUpdateProps,useState}=require("@odoo/owl");const{escape}=require("@web/core/utils/strings");const{_t}=require("@web/core/l10n/translation");const DocumentsActionHelper=__exports.DocumentsActionHelper=class DocumentsActionHelper extends Component{static template="documents.DocumentsActionHelper";static props=["noContentHelp",];setup(){this.orm=useService("orm");this.state=useState({mailTo:undefined,});onWillStart(async()=>{await this.updateShareInformation();});onWillUpdateProps(async()=>{await this.updateShareInformation();});}
get selectedFolderId(){return this.env.searchModel.getSelectedFolderId();}
get noContentHelp(){if(!this.selectedFolderId||["RECENT","SHARED","TRASH","MY","COMPANY"].includes(this.selectedFolderId)){const helpMessage=(()=>{switch(this.selectedFolderId){case"TRASH":return _t("Documents moved to trash will show up here");case"RECENT":return _t("Recently accessed Documents will show up here");case"SHARED":return _t("Documents shared with you will appear here");case"MY":return _t("Your personal space");default:return _t("Select a folder to upload a document");}})();return markup(`<p class="o_view_nocontent_smiling_face">${escape(helpMessage)}</p>`);}
return this.props.noContentHelp;}
async updateShareInformation(){this.state.mailTo=undefined;const filteredDomain=this.env.searchModel.domain.filter((leaf)=>Array.isArray(leaf)&&leaf.includes("folder_id"));if(filteredDomain.length!==1||typeof this.selectedFolderId!=="number"){return;}
const selectedFolder=this.env.searchModel.getFolderById(this.selectedFolderId);if(!selectedFolder||selectedFolder.user_permission==="none"||!selectedFolder.alias_name||!selectedFolder.alias_domain_id){return;}
this.state.mailTo=`${selectedFolder.alias_name}@${selectedFolder.alias_domain_id[1]}`;}}
return __exports;});;

/* /documents/static/src/views/helper/documents_drop_zone.js */
odoo.define('@documents/views/helper/documents_drop_zone',['@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,useEffect,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const DocumentsDropZone=__exports.DocumentsDropZone=class DocumentsDropZone extends Component{static template="documents.DocumentsDropZone";static props=["parentRoot",];setup(){this.state=useState({dragOver:false,topOffset:0,});this.documentService=useService("document.document");useEffect((el)=>{if(!el){return;}
this.state.topOffset=el.scrollTop;const overHandler=this.onDragOver.bind(this);const leaveHandler=this.onDragLeave.bind(this);const scrollHandler=()=>{this.state.topOffset=el.scrollTop;};el.addEventListener("dragover",overHandler);el.addEventListener("dragleave",leaveHandler);el.addEventListener("scroll",scrollHandler);return()=>{el.removeEventListener("dragover",overHandler);el.removeEventListener("dragleave",leaveHandler);el.removeEventListener("scroll",scrollHandler);};},()=>[this.props.parentRoot.el]);}
get root(){return this.props.parentRoot;}
get canDrop(){return this.documentService.canUploadInFolder(this.env.searchModel.getSelectedFolder());}
get rootDropOverClass(){return this.canDrop?"o_documents_drop_over":"o_documents_drop_over_unauthorized";}
onDragOver(ev){if(!ev.dataTransfer.types.includes("Files")||ev.dataTransfer.types.includes("o_documents_data")){return;}
ev.stopPropagation();ev.preventDefault();this.root?.el?.classList.toggle(this.rootDropOverClass,true);this.state.dragOver=true;}
onDragLeave(ev){ev.stopPropagation();ev.preventDefault();this.root?.el?.classList.remove(this.rootDropOverClass);this.state.dragOver=false;}
onDrop(ev){if(!ev.dataTransfer.types.includes("Files")){return;}
this.root?.el?.classList.remove(this.rootDropOverClass);this.state.dragOver=false;if(this.canDrop){this.env.documentsView.bus.trigger("documents-upload-files",{files:ev.dataTransfer.files,accessToken:this.documentService.currentFolderAccessToken,});}}}
return __exports;});;

/* /documents/static/src/views/helper/documents_file_viewer.js */
odoo.define('@documents/views/helper/documents_file_viewer',['@documents/attachments/document_file_viewer','@odoo/owl'],function(require){'use strict';let __exports={};const{FileViewer}=require("@documents/attachments/document_file_viewer");const{Component,useEffect,useRef,useState}=require("@odoo/owl");const DocumentsFileViewer=__exports.DocumentsFileViewer=class DocumentsFileViewer extends Component{static template="documents.DocumentsFileViewer";static components={FileViewer,};static props=["parentRoot","previewStore",];setup(){this.root=useRef("root");this.state=useState({topOffset:0,leftOffset:0,});const onKeydown=this.onIframeKeydown.bind(this);useEffect((iframe)=>{if(!iframe){return;}
const onLoad=()=>{if(!iframe.contentDocument){return;}
iframe.contentDocument.addEventListener("keydown",onKeydown);};iframe.addEventListener("load",onLoad);return()=>{iframe.removeEventListener("load",onLoad);};},()=>[this.root.el&&this.root.el.querySelector("iframe")]);useEffect((el)=>{if(!el){return;}
this.state.topOffset=el.scrollTop;this.state.leftOffset=el.scrollLeft;const scrollHandler=()=>{this.state.topOffset=el.scrollTop;this.state.leftOffset=el.scrollLeft;};el.addEventListener("scroll",scrollHandler);return()=>{el.removeEventListener("scroll",scrollHandler);};},()=>[this.parentRoot.el]);}
get parentRoot(){return this.props.parentRoot;}
onGlobalKeydown(ev){const cancelledKeys=["ArrowUp","ArrowDown"];if(cancelledKeys.includes(ev.key)){ev.stopPropagation();}}
onIframeKeydown(ev){if(ev.key==="Escape"){this.env.model.env.documentsView.bus.trigger("documents-close-preview");}}}
return __exports;});;

/* /documents/static/src/views/helper/documents_pdf_thumbnail_service.js */
odoo.define('@documents/views/helper/documents_pdf_thumbnail_service',['@web/core/registry','@web/core/utils/hooks','@web/core/utils/concurrency','@web/libs/pdfjs','@odoo/owl','@web/core/network/rpc'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useBus}=require("@web/core/utils/hooks");const{Mutex}=require("@web/core/utils/concurrency");const{loadPDFJSAssets}=require("@web/libs/pdfjs");const{useComponent}=require("@odoo/owl");const{rpc}=require("@web/core/network/rpc");const documentsPdfThumbnailService=__exports.documentsPdfThumbnailService={dependencies:["orm"],start(env,{orm}){let enabled=true;const mutex=new Mutex();const width=200;const height=140;let queue=Promise.resolve();const checkForThumbnail=async(record)=>{let initialWorkerSrc=false;if(record.data.thumbnail_status!=="client_generated"||record.hasStoredThumbnail()||!enabled){return;}
try{await loadPDFJSAssets();initialWorkerSrc=globalThis.pdfjsLib.GlobalWorkerOptions.workerSrc;globalThis.pdfjsLib.GlobalWorkerOptions.workerSrc="/web/static/lib/pdfjs/build/pdf.worker.js";}catch{enabled=false;return;}
let thumbnail=undefined;try{const pdf=await globalThis.pdfjsLib.getDocument(`/documents/content/${encodeURIComponent(record.data.access_token)}?download=0`).promise;const page=await pdf.getPage(1);const viewPort=page.getViewport({scale:1});const canvas=document.createElement("canvas");canvas.width=width;canvas.height=height;const scale=canvas.width/viewPort.width;await page.render({canvasContext:canvas.getContext("2d"),viewport:page.getViewport({scale}),}).promise;thumbnail=canvas.toDataURL("image/jpeg").replace("data:image/jpeg;base64,","");}catch(_error){if(_error.name!=="UnexpectedResponseException"&&_error.status&&_error.status!==403){thumbnail=false;}}finally{if(thumbnail!==undefined){await rpc(`/documents/document/${record.resId}/update_thumbnail`,{thumbnail,});record.data.thumbnail_status=thumbnail?"present":"error";if(thumbnail){env.bus.trigger("documents-new-pdf-thumbnail",{record});}}
globalThis.pdfjsLib.GlobalWorkerOptions.workerSrc=initialWorkerSrc;}};const enqueueRecord=(record)=>{queue=queue.then(()=>checkForThumbnail(record));};return{enqueueRecords(records){if(!enabled||env.isSmall){return;}
mutex.exec(()=>{for(const record of records){enqueueRecord(record);}});},};},};__exports.onNewPdfThumbnail=onNewPdfThumbnail;function onNewPdfThumbnail(callback){const component=useComponent();useBus(component.env.bus,"documents-new-pdf-thumbnail",callback);}
registry.category("services").add("documents_pdf_thumbnail",documentsPdfThumbnailService);return __exports;});;

/* /documents/static/src/views/hooks.js */
odoo.define('@documents/views/hooks',['@web/core/confirmation_dialog/confirmation_dialog','@web_enterprise/webclient/promote_studio_dialog/promote_studio_dialog','@web/core/l10n/translation','@web/core/user','@web/core/utils/hooks','@web/core/utils/strings','@web/search/action_hook','@documents/components/documents_permission_panel/documents_permission_panel','@documents/owl/components/pdf_manager/pdf_manager','@odoo/owl','@documents/core/document_service'],function(require){'use strict';let __exports={};const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{PromoteStudioAutomationDialog}=require("@web_enterprise/webclient/promote_studio_dialog/promote_studio_dialog");const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{useBus,useService}=require("@web/core/utils/hooks");const{escape}=require("@web/core/utils/strings");const{useSetupAction}=require("@web/search/action_hook");const{DocumentsPermissionPanel}=require("@documents/components/documents_permission_panel/documents_permission_panel");const{PdfManager}=require("@documents/owl/components/pdf_manager/pdf_manager");const{EventBus,onMounted,onWillStart,markup,useComponent,useEnv,useRef,useSubEnv}=require("@odoo/owl");const{loadMaxUploadSize:loadMaxUploadSizeDocumentService}=require("@documents/core/document_service");const loadMaxUploadSize=__exports.loadMaxUploadSize=loadMaxUploadSizeDocumentService;__exports.openDeleteConfirmationDialog=openDeleteConfirmationDialog;function openDeleteConfirmationDialog(model,isPermanent){return new Promise((resolve,reject)=>{const root=model.root;const dialogProps={title:isPermanent?_t("Delete permanently"):_t("Move to trash"),body:isPermanent?root.isDomainSelected||root.selection.length>1?_t("Are you sure you want to permanently erase the documents?"):_t("Are you sure you want to permanently erase the document?"):_t("Items moved to the trash will be deleted forever after %s days.",model.env.searchModel.deletionDelay),confirmLabel:isPermanent?_t("Delete permanently"):_t("Move to trash"),cancelLabel:_t("Discard"),confirm:async()=>{resolve(true);},cancel:()=>{resolve(false);},};model.dialog.add(ConfirmationDialog,dialogProps);});}
__exports.toggleArchive=toggleArchive;async function toggleArchive(model,resModel,resIds,doArchive){if(doArchive&&!(await openDeleteConfirmationDialog(model,false))){return;}
const action=await model.orm.call(resModel,doArchive?"action_archive":"action_unarchive",[resIds]);if(action&&Object.keys(action).length!==0){model.action.doAction(action);}
if(doArchive){await model.env.documentsView.bus.trigger("documents-close-preview");}}
__exports.preSuperSetupFolder=preSuperSetupFolder;function preSuperSetupFolder(){const component=useComponent();const orm=useService("orm");onWillStart(async()=>{component._deletionDelay=await orm.call("documents.document","get_deletion_delay",[[]]);});}
__exports.preSuperSetup=preSuperSetup;function preSuperSetup(){useSubEnv({documentsView:{bus:new EventBus(),},});const component=useComponent();const props=component.props;if(props.globalState&&props.globalState.sharedSelection){if(!props.state){props.state={};}
if(!props.state.modelState){props.state.modelState={};}
props.state.modelState.sharedSelection=props.globalState.sharedSelection;}}
__exports.useDocumentView=useDocumentView;function useDocumentView(helpers){const component=useComponent();const props=component.props;const root=useRef("root");const orm=useService("orm");const notification=useService("notification");const dialogService=useService("dialog");const action=useService("action");const documentService=useService("document.document");useSubEnv({model:component.model,});const env=useEnv();const bus=env.documentsView.bus;const _openShareDialog=async({id,shortcut_document_id})=>{const document=shortcut_document_id?{id:shortcut_document_id[0]}:{id};dialogService.add(DocumentsPermissionPanel,{document,onChangesSaved:()=>env.searchModel.trigger("update"),});};const _openAutomations=async({folderId,folderDisplayName})=>{const checkBaseAutomation=await orm.searchCount("ir.module.module",[["name","=","base_automation"],["state","=","installed"],]);if(!checkBaseAutomation>0){return dialogService.add(PromoteStudioAutomationDialog,{title:_t("Odoo Studio - Customize workflows in minutes"),});}
const userHasAccessRight=await user.checkAccessRight("base.automation","create");if(!userHasAccessRight){return notification.add(_t("Contact your Administrator to get access if needed."),{title:_t("Access to Automations"),type:"info",});}
const documentsModelId=await orm.search("ir.model",[["model","=","documents.document"]],{limit:1});return await action.doAction("base_automation.base_automation_act",{additionalContext:{active_test:false,default_model_id:documentsModelId[0],search_default_model_id:documentsModelId[0],default_name:_t("Put in %s",folderDisplayName),default_filter_domain:[["folder_id","in",[folderId]]],default_trigger:"on_create_or_write",},});};useSetupAction({rootRef:root,getGlobalState:()=>({sharedSelection:component.model.exportSelection(),}),});useBus(bus,"documents-open-share",(ev)=>{_openShareDialog(ev.detail);});useBus(bus,"documents-open-automations",(ev)=>{_openAutomations(ev.detail);});onWillStart(async()=>{component.isDocumentsManager=await user.hasGroup("documents.group_documents_manager");});onMounted(async()=>{documentService.updateDocumentURLRefresh();});return{root,orm,notification,dialogService,actionService:action,...useDocumentsViewFilePreviewer(helpers),canUploadInFolder:(folder)=>documentService.canUploadInFolder(folder),...useDocumentsViewFileUpload(),...useEmbeddedAction(),hasShareDocuments:()=>{const folder=env.searchModel.getSelectedFolder();const selectedRecords=env.model.root.selection.length;return typeof folder.id!=="number"&&!selectedRecords;},userIsInternal:documentService.userIsInternal,userIsDocumentManager:documentService.userIsDocumentManager,onClickDocumentsRequest:()=>{action.doAction("documents.action_request_form",{additionalContext:{default_partner_id:props.context.default_partner_id||false,default_folder_id:env.searchModel.getSelectedFolderId()||env.searchModel.getFolders()[1].id,default_res_id:props.context.default_res_id||false,default_res_model:props.context.default_res_model||false,default_requestee_id:props.context.default_partner_id||false,},fullscreen:env.isSmall,onClose:async()=>{await env.model.load();env.model.useSampleModel=env.model.root.records.length===0;env.model.notify();},});},onClickDocumentsAddUrl:()=>{const folderId=env.searchModel.getSelectedFolderId();action.doAction("documents.action_url_form",{additionalContext:{default_type:"url",default_partner_id:props.context.default_partner_id||false,default_folder_id:env.searchModel.getSelectedFolderId(),default_res_id:props.context.default_res_id||false,default_res_model:props.context.default_res_model||false,...(folderId==="COMPANY"?{default_owner_id:documentService.store.odoobot.userId}:{}),},fullscreen:env.isSmall,onClose:async()=>{await env.model.load();env.model.useSampleModel=env.model.root.records.length===0;env.model.notify();},});},onClickAddFolder:()=>{const currentFolder=env.searchModel.getSelectedFolderId();action.doAction("documents.action_folder_form",{additionalContext:{default_type:"folder",default_folder_id:currentFolder||false,...(currentFolder==="COMPANY"?{default_access_internal:"edit",default_owner_id:documentService.store.odoobot.userId,}:{}),},fullscreen:env.isSmall,onClose:async()=>{await env.searchModel._reloadSearchModel(true);bus.trigger("documents-expand-folder",{folderId:[false,"COMPANY"].includes(currentFolder)?"MY":currentFolder,});},});},onClickShareFolder:async()=>{if(env.model.root.selection.length>0){if(env.model.root.selection.length!==1){return;}
const rec=env.model.root.selection[0];await _openShareDialog({id:rec.resId,name:rec._values.name,shortcut_document_id:rec._values.shortcut_document_id,});}else{const folder=env.searchModel.getSelectedFolder();await _openShareDialog({id:folder.id,shortcut_document_id:folder.shortcut_document_id,});}},};}
function useDocumentsViewFilePreviewer({getSelectedDocumentsElements,setPreviewStore,isRecordPreviewable=()=>true,}){const component=useComponent();const env=useEnv();const bus=env.documentsView.bus;const documentService=useService("document.document");const store=useService("mail.store");const onOpenDocumentsPreview=async({documents,mainDocument,isPdfSplit,embeddedActions,hasPdfSplit,})=>{const openPdfSplitter=(documents)=>{let newDocumentIds=[];let forceDelete=false;component.dialogService.add(PdfManager,{documents:documents.map((doc)=>doc.data),embeddedActions,onProcessDocuments:async({documentIds,actionId,exit,isForcingDelete,})=>{forceDelete=isForcingDelete;if(documentIds&&documentIds.length){newDocumentIds=[...new Set(newDocumentIds.concat(documentIds))];}
if(actionId){await component.embeddedAction(documentIds,actionId,!exit);}},},{onClose:async()=>{if(!newDocumentIds.length&&!forceDelete){return;}
await component.model.load();for(const record of documents){if(!newDocumentIds.includes(record.resId)){await record.model.root.deleteRecords(record);}}
let count=0;for(const record of env.model.root.records.filter((r)=>newDocumentIds.includes(r.resId),)){record.onRecordClick(null,{isKeepSelection:count++!==0,isRangeSelection:false,});}},});};if(isPdfSplit){openPdfSplitter(documents);return;}
const documentsRecords=((documents.length===1&&component.model.root.records)||documents).filter((rec)=>isRecordPreviewable(rec)&&rec.isViewable()).map((rec)=>{const getRecordAttachment=(rec)=>{rec=rec.shortcutTarget;return{id:rec.data.attachment_id[0],name:rec.data.attachment_id[1],mimetype:rec.data.mimetype,url:rec.data.url,documentId:rec.resId,documentData:rec.data,};};return store.Document.insert({id:rec.resId,attachment:getRecordAttachment(rec),name:rec.data.name,mimetype:rec.data.mimetype,url:rec.data.url,displayName:rec.data.display_name,record:rec,});});if(component.root.el){component.root.el.querySelector(".o_documents_view").classList.add("overflow-hidden");}
const selectedDocument=documentsRecords.find((rec)=>rec.id===(mainDocument||documents[0]).resId);documentService.documentList={documents:documentsRecords||[],initialRecordSelectionLength:documents.length,pdfManagerOpenCallback:(documents)=>{openPdfSplitter(documents);},onDeleteCallback:()=>{const elements=getSelectedDocumentsElements();if(elements.length){elements[0].focus();}
if(component.root?.el){component.root.el.querySelector(".o_documents_view").classList.remove("overflow-hidden");}
setPreviewStore({});},hasPdfSplit,selectedDocument,};const previewStore={documentList:documentService.documentList,startIndex:documentsRecords.indexOf(selectedDocument),attachments:documentsRecords.map((doc)=>doc.attachment),};documentService.setPreviewedDocument(selectedDocument);setPreviewStore({...previewStore});};useBus(bus,"documents-open-preview",async(ev)=>{component.onOpenDocumentsPreview(ev.detail);});useBus(bus,"documents-close-preview",()=>{documentService.setPreviewedDocument(null);documentService.documentList?.onDeleteCallback();});return{onOpenDocumentsPreview,};}
function useDocumentsViewFileUpload(){const component=useComponent();const env=useEnv();const bus=env.documentsView.bus;const notification=useService("notification");const fileUpload=useService("file_upload");const documentService=useService("document.document");const handleUploadError=(result)=>{notification.add(result.error,{title:_t("Error"),sticky:true,});};let wasUsingSampleModel=false;useBus(fileUpload.bus,"FILE_UPLOAD_ADDED",()=>{if(env.model.useSampleModel){wasUsingSampleModel=true;env.model.useSampleModel=false;}});useBus(fileUpload.bus,"FILE_UPLOAD_ERROR",async(ev)=>{const{upload}=ev.detail;if(wasUsingSampleModel){wasUsingSampleModel=false;env.model.useSampleModel=true;}
if(upload.state!=="error"){return;}
handleUploadError({error:_t("An error occured while uploading."),});});useBus(documentService.bus,"DOCUMENT_RELOAD",async(ev)=>{await env.searchModel._reloadSearchModel(true);await env.model.load();await env.model.notify();});useBus(fileUpload.bus,"FILE_UPLOAD_LOADED",async(ev)=>{wasUsingSampleModel=false;const{upload}=ev.detail;const xhr=upload.xhr;if(xhr.status!==200){handleUploadError({error:_t("status code: %(status)s, message: %(message)s",{status:xhr.status,message:xhr.response,})});return}
const response=JSON.parse(xhr.response);const newDocumentIds=Array.isArray(response)?response:undefined;env.model.useSampleModel=false;await env.model.load(component.props);if(!newDocumentIds){return;}
const records=env.model.root.records;let count=0;for(const record of records){if(!newDocumentIds.includes(record.resId)){continue;}
record.onRecordClick(null,{isKeepSelection:count++!==0,isRangeSelection:false,});}});const uploadFiles=async({files,accessToken,context})=>{if(env.searchModel.getSelectedFolderId()==="COMPANY"){context.default_owner_id=documentService.store.odoobot.userId;}
await documentService.uploadDocument(files,accessToken,context);};useBus(bus,"documents-upload-files",(ev)=>{component.uploadFiles({context:component.props.context,...ev.detail});});return{uploadFiles,onFileInputChange:async(ev)=>{if(!ev.target.files.length){return;}
await component.uploadFiles({files:ev.target.files,accessToken:documentService.currentFolderAccessToken,context:component.props.context,});ev.target.value="";},};}
__exports.useEmbeddedAction=useEmbeddedAction;function useEmbeddedAction(){const env=useEnv();const orm=useService("orm");const notification=useService("notification");const action=useService("action");return{embeddedAction:async(documentIds,actionId,preventReload=false)=>{const context={active_model:"documents.document",active_ids:documentIds,};const result=await orm.call("documents.document","action_execute_embedded_action",[actionId],{context,});if(result&&typeof result==="object"){if(Object.prototype.hasOwnProperty.call(result,"warning")){notification.add(markup(`<ul>${result["warning"]["documents"]
                                .map((d) => `<li>${escape(d)}</li>`)
                                .join("")}</ul>`),{title:result["warning"]["title"],type:"danger",});if(!preventReload){await env.model.load();}}else if(!preventReload){await action.doAction(result,{onClose:async()=>await env.model.load(),});return;}}else if(!preventReload){await env.model.load();}},};}
return __exports;});;

/* /documents/static/src/views/kanban/documents_kanban_arch_parser.js */
odoo.define('@documents/views/kanban/documents_kanban_arch_parser',['@web/views/kanban/kanban_arch_parser'],function(require){'use strict';let __exports={};const{KanbanArchParser}=require("@web/views/kanban/kanban_arch_parser");const DocumentsKanbanArchParser=__exports.DocumentsKanbanArchParser=class DocumentsKanbanArchParser extends KanbanArchParser{parse(xmlDoc,models,modelName){const archInfo=super.parse(xmlDoc,models,modelName);archInfo.canOpenRecords=false;return archInfo;}}
return __exports;});;

/* /documents/static/src/views/kanban/documents_kanban_compiler.js */
odoo.define('@documents/views/kanban/documents_kanban_compiler',['@web/views/kanban/kanban_compiler','@web/views/view_compiler','@web/core/utils/xml'],function(require){'use strict';let __exports={};const{KanbanCompiler}=require("@web/views/kanban/kanban_compiler");const{isTextNode}=require("@web/views/view_compiler");const{createElement}=require("@web/core/utils/xml");const DocumentsKanbanCompiler=__exports.DocumentsKanbanCompiler=class DocumentsKanbanCompiler extends KanbanCompiler{setup(){super.setup();this.compilers.push({selector:"[t-name='card']",fn:this.compileCard});this.compilers.push({selector:"div.o_documents_attachment",fn:this.compileDocumentsAttachment});this.compilers.push({selector:"div.o_kanban_image_wrapper",fn:this.compileImageWrapper});}
compileCard(){const result=super.compileGenericNode(...arguments);const cards=result.childNodes;for(const card of cards){if(isTextNode(card)){continue;}
const dummyElement=createElement("a");dummyElement.classList.add("o_hidden","o_documents_dummy_action");card.prepend(dummyElement);card.setAttribute("t-on-dragstart.stop",`(ev) => __comp__.props.record.onDragStart(ev)`);card.setAttribute("t-on-drop",`(ev) => __comp__.props.record.onDrop(ev)`);const fileInput=card.querySelector("input.o_kanban_replace_document");if(fileInput){fileInput.setAttribute("t-on-change.stop.prevent",`(ev) => __comp__.props.record.onReplaceDocument(ev)`);fileInput.setAttribute("t-on-click.stop",`() => {}`);}}
return result;}
compileDocumentsAttachment(){const elem=super.compileGenericNode(...arguments);elem.setAttribute("t-attf-class",(elem.getAttribute("t-attf-class")||"")
+" {{(record.type.raw_value === 'binary' && !record.attachment_id.raw_value && !record.shortcut_document_id.raw_value) ? 'oe_file_request' : ''}}"
+" {{__comp__.props.record.selected ? 'o_record_selected' : ''}}");const content=new DOMParser().parseFromString(`
            <t>
                <t t-set="fileUpload" t-value="__comp__.getFileUpload()"/>
                <t t-if="fileUpload">
                    <FileUploadProgressBar fileUpload="fileUpload"/>
                </t>
            </t>
            `,"application/xml");elem.prepend(...content.documentElement.children);return elem;}
compileImageWrapper(){const elem=super.compileGenericNode(...arguments);elem.setAttribute("t-attf-class",(elem.getAttribute("t-attf-class")||"")+" {{(hasStoredThumbnail or youtubeVideoToken or __comp__.props.record.isViewable()) ? 'oe_kanban_previewer' : ''}}");return elem;}}
return __exports;});;

/* /documents/static/src/views/kanban/documents_kanban_controller.js */
odoo.define('@documents/views/kanban/documents_kanban_controller',['@documents/views/hooks','@documents/views/documents_controller_mixin','@odoo/owl','@web/core/utils/hooks','@web/views/kanban/kanban_controller'],function(require){'use strict';let __exports={};const{preSuperSetup,useDocumentView}=require("@documents/views/hooks");const{DocumentsControllerMixin}=require("@documents/views/documents_controller_mixin");const{onMounted,useRef,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{KanbanController}=require("@web/views/kanban/kanban_controller");const DocumentsKanbanController=__exports.DocumentsKanbanController=class DocumentsKanbanController extends DocumentsControllerMixin(KanbanController){static template="documents.DocumentsKanbanView";setup(){preSuperSetup();super.setup(...arguments);this.documentService=useService("document.document");this.uploadFileInputRef=useRef("uploadFileInput");const properties=useDocumentView(this.documentsViewHelpers());Object.assign(this,properties);this.documentStates=useState({previewStore:{},});onMounted(()=>{const initData=this.documentService.initData;if(initData.documentId){const document=this.model.root.records.find((record)=>record.data.id===initData.documentId);if(document){document.selected=true;if(initData.openPreview){initData.openPreview=false;document.onClickPreview(new Event("click"));}}}});}
documentsViewHelpers(){return{getSelectedDocumentsElements:()=>this.root?.el?.querySelectorAll(".o_kanban_record.o_record_selected")||[],setPreviewStore:(previewStore)=>{this.documentStates.previewStore=previewStore;},isRecordPreviewable:this.isRecordPreviewable.bind(this),};}
isRecordPreviewable(record){return record.isViewable();}
onUnselectAll(){this.model.root.selection.forEach((record)=>{record.toggleSelection(false);});this.model.root.selectDomain(false);}}
return __exports;});;

/* /documents/static/src/views/kanban/documents_kanban_model.js */
odoo.define('@documents/views/kanban/documents_kanban_model',['@web/core/domain','@web/core/utils/hooks','@web/model/relational_model/relational_model','@documents/views/documents_model_mixin'],function(require){'use strict';let __exports={};const{Domain}=require("@web/core/domain");const{useService}=require("@web/core/utils/hooks");const{RelationalModel}=require("@web/model/relational_model/relational_model");const{DocumentsModelMixin,DocumentsRecordMixin,}=require("@documents/views/documents_model_mixin");const DocumentsKanbanModel=__exports.DocumentsKanbanModel=class DocumentsKanbanModel extends DocumentsModelMixin(RelationalModel){setup(){super.setup(...arguments);this.documentService=useService("document.document");}
async _loadData(config){const data=await super._loadData(config);const documentIdToRestore=this.documentService.getOnceDocumentIdToRestore();if(documentIdToRestore&&!data.records.some((record)=>record.id===documentIdToRestore)){const missingData=await super._loadData({...config,domain:Domain.and([config.domain,[["id","=",documentIdToRestore]]]).toList(),});if(missingData?.records?.length){data.records.push(missingData.records[0]);}}
return data;}}
const DocumentsKanbanRecord=__exports.DocumentsKanbanRecord=class DocumentsKanbanRecord extends DocumentsRecordMixin(RelationalModel.Record){async onReplaceDocument(ev){if(!ev.target.files.length){return;}
await this.model.env.documentsView.bus.trigger("documents-upload-files",{files:ev.target.files,accessToken:this.data.access_token,});ev.target.value="";}}
DocumentsKanbanModel.Record=DocumentsKanbanRecord;return __exports;});;

/* /documents/static/src/views/kanban/documents_kanban_record.js */
odoo.define('@documents/views/kanban/documents_kanban_record',['@web/core/l10n/translation','@web/core/user','@web/views/kanban/kanban_record','@documents/views/kanban/documents_kanban_compiler','@web/core/file_upload/file_upload_progress_bar','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{KanbanRecord}=require("@web/views/kanban/kanban_record");const{DocumentsKanbanCompiler}=require("@documents/views/kanban/documents_kanban_compiler");const{FileUploadProgressBar}=require("@web/core/file_upload/file_upload_progress_bar");const{useBus,useService}=require("@web/core/utils/hooks");const{useState,xml}=require("@odoo/owl");const CANCEL_GLOBAL_CLICK=["a",".dropdown",".oe_kanban_action"].join(",");const COMPANY_ROOT_OWNER_ID=1;const DocumentsKanbanRecord=__exports.DocumentsKanbanRecord=class DocumentsKanbanRecord extends KanbanRecord{static components={...KanbanRecord.components,FileUploadProgressBar,};static defaultProps={...KanbanRecord.defaultProps,Compiler:DocumentsKanbanCompiler,};static template=xml`
        <div
            role="article"
            t-att-class="getRecordClasses()"
            t-att-data-id="props.canResequence and props.record.id"
            t-att-tabindex="props.record.model.useSampleModel ? -1 : 0"
            t-on-click.synthetic="onGlobalClick"
            t-on-dragenter.stop.prevent="onDragEnter"
            t-on-dragover.stop.prevent="onDragOver"
            t-on-dragleave.stop.prevent="onDragLeave"
            t-on-drop.stop.prevent="onDrop"
            t-on-keydown.synthetic="onKeydown"
            t-ref="root">
            <t t-call="{{ templates[this.constructor.KANBAN_CARD_ATTRIBUTE] }}" t-call-context="this.renderingContext"/>
        </div>`;setup(){super.setup();const{bus,uploads}=useService("file_upload");this.documentUploads=uploads;useBus(bus,"FILE_UPLOAD_ADDED",(ev)=>{if(ev.detail.upload.data.get("document_id")==this.props.record.resId){this.render(true);}});this.drag=useState({state:"none"});this.pdfService=useService("documents_pdf_thumbnail");this.pdfService.enqueueRecords([this.props.record]);}
getRecordClasses(){let result=super.getRecordClasses();if(this.props.record.selected){result+=" o_record_selected";}
if(this.props.record.isRequest()){result+=" oe_file_request";}
if(this.props.record.data.type=="folder"){result+=" o_folder_record";}
if(this.drag.state==="hover"){result+=" o_drag_hover";}else if(this.drag.state==="invalid"){result+=" o_drag_invalid";}
return result;}
get renderingContext(){const context=super.renderingContext;context.encodeURIComponent=encodeURIComponent;if([false,"TRASH","RECENT"].includes(this.env.searchModel.getSelectedFolderId())){context.inFolder=this.props.record.data.folder_id?.[1]||(this.props.record.data?.owner_id[0]===user.userId?_t("My Drive"):this.props.record.data?.owner_id[0]===COMPANY_ROOT_OWNER_ID?_t("Company"):_t("Shared with me"));}
context.mimetype=this.props.record.shortcutTarget.data.mimetype;return context;}
getFileUpload(){return Object.values(this.documentUploads).find((upload)=>upload.data.get("document_id")==this.props.record.resId);}
onGlobalClick(ev){if(ev.target.closest(CANCEL_GLOBAL_CLICK)){return;}
if(ev.target.closest("div[name='document_preview']")){this.props.record.onClickPreview(ev);if(ev.cancelBubble){return;}}
this.props.record.onRecordClick(ev);}
onKeydown(ev){if(ev.key!=="Enter"&&ev.key!==" "){return;}
ev.preventDefault();const options={};if(ev.key==="Enter"&&this.props.record.data.type!=="folder"){this.props.record.onClickPreview(ev);}else if(ev.key===" "){options.isKeepSelection=true;}
return this.props.record.onRecordClick(ev,options);}
onDragEnter(ev){if(this.props.record.data.type!=="folder"){return;}
const isInvalidFolder=this.props.list.selection.map((r)=>r.data.id).includes(this.props.record.data.id);this.drag.state=isInvalidFolder?"invalid":"hover";const icon=this.rootRef.el.querySelector(".fa-folder-o");icon?.classList.remove("fa-folder-o");icon?.classList.add("fa-folder-open-o");}
onDragOver(ev){const isInvalidTarget=this.props.record.data.type!=="folder"||this.props.list.selection.map((r)=>r.data.id).includes(this.props.record.data.id);const dropEffect=isInvalidTarget?"none":ev.ctrlKey?"link":"move";ev.dataTransfer.dropEffect=dropEffect;}
onDragLeave(ev){const elemBounding=this.rootRef.el.getBoundingClientRect();const isOutside=ev.clientX<elemBounding.left||ev.clientX>elemBounding.right||ev.clientY<elemBounding.top||ev.clientY>elemBounding.bottom;if(!isOutside){return;}
if(this.props.record.data.type!=="folder"){return;}
this.drag.state="none";const icon=this.rootRef.el.querySelector(".fa-folder-open-o");icon?.classList.remove("fa-folder-open-o");icon?.classList.add("fa-folder-o");}
onDrop(ev){this.drag.state="none";const icon=this.rootRef.el.querySelector(".fa-folder-open-o");icon?.classList.remove("fa-folder-open-o");icon?.classList.add("fa-folder-o");}}
return __exports;});;

/* /documents/static/src/views/kanban/documents_kanban_renderer.js */
odoo.define('@documents/views/kanban/documents_kanban_renderer',['@web/core/l10n/translation','@web/views/kanban/kanban_renderer','@web/core/utils/hooks','@documents/views/helper/documents_drop_zone','@web/core/file_upload/file_upload_progress_container','@web/core/file_upload/file_upload_progress_record','@documents/views/documents_renderer_mixin','@documents/views/kanban/documents_kanban_record','@documents/views/helper/documents_action_helper','@documents/views/helper/documents_file_viewer','@documents/components/documents_details_panel/documents_details_panel','@web/core/commands/command_hook','@odoo/owl','@mail/chatter/web_portal/chatter'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{useService}=require("@web/core/utils/hooks");const{DocumentsDropZone}=require("@documents/views/helper/documents_drop_zone");const{FileUploadProgressContainer}=require("@web/core/file_upload/file_upload_progress_container");const{FileUploadProgressKanbanRecord}=require("@web/core/file_upload/file_upload_progress_record");const{DocumentsRendererMixin}=require("@documents/views/documents_renderer_mixin");const{DocumentsKanbanRecord}=require("@documents/views/kanban/documents_kanban_record");const{DocumentsActionHelper}=require("@documents/views/helper/documents_action_helper");const{DocumentsFileViewer}=require("@documents/views/helper/documents_file_viewer");const{DocumentsDetailsPanel}=require("@documents/components/documents_details_panel/documents_details_panel");const{useCommand}=require("@web/core/commands/command_hook");const{useRef}=require("@odoo/owl");const{Chatter}=require("@mail/chatter/web_portal/chatter");const DocumentsKanbanRenderer=__exports.DocumentsKanbanRenderer=class DocumentsKanbanRenderer extends DocumentsRendererMixin(KanbanRenderer){static props=[...KanbanRenderer.props,"previewStore"];static template="documents.DocumentsKanbanRenderer";static components=Object.assign({},KanbanRenderer.components,{DocumentsDropZone,FileUploadProgressContainer,FileUploadProgressKanbanRecord,KanbanRecord:DocumentsKanbanRecord,DocumentsActionHelper,DocumentsFileViewer,DocumentsDetailsPanel,Chatter,});setup(){super.setup();this.root=useRef("root");const{uploads}=useService("file_upload");this.documentUploads=uploads;useCommand(_t("Select all"),()=>{const allSelected=this.props.list.selection.length===this.props.list.records.length;this.props.list.records.forEach((record)=>{record.toggleSelection(!allSelected);});},{category:"smart_action",hotkey:"control+a",});useCommand(_t("Toggle favorite"),()=>{if(this.props.list.selection.length){this.props.list.selection[0].update({is_favorited:!this.props.list.selection[0].data.is_favorited,});}},{category:"smart_action",hotkey:"alt+t",});}
onGlobalClick(ev){if(ev.target.closest(".o_kanban_record:not(.o_kanban_ghost)")){return;}
this.props.list.selection.forEach((el)=>el.toggleSelection(false));}
focusNextCard(area,direction){const cards=area.querySelectorAll(".o_kanban_record:not(.o_kanban_ghost)");if(!cards.length){return;}
let cardsPerRow=0;const allCards=area.querySelectorAll(".o_kanban_record");const firstCardClientTop=allCards[0].getBoundingClientRect().top;for(const card of allCards){if(card.getBoundingClientRect().top===firstCardClientTop){cardsPerRow++;}else{break;}}
const focusedCardIdx=[...cards].indexOf(document.activeElement);let newIdx=focusedCardIdx;const folderCount=this.folderCount();if(direction==="up"){const oldIdx=newIdx;newIdx-=cardsPerRow;if(newIdx<folderCount&&oldIdx>=folderCount){if((oldIdx-folderCount)%cardsPerRow>=folderCount%cardsPerRow){newIdx=folderCount-1;}else{newIdx=folderCount-((folderCount%cardsPerRow)-(oldIdx-folderCount)%cardsPerRow);}}}else if(direction==="down"){const oldIdx=newIdx;newIdx+=cardsPerRow;if(newIdx>=cards.length){newIdx=cards.length-1;}
if(oldIdx<folderCount&&newIdx>=folderCount){if(oldIdx%cardsPerRow>=folderCount%cardsPerRow){newIdx=folderCount-1;}else{newIdx=folderCount+(oldIdx%cardsPerRow);}}}else if(direction==="left"){newIdx-=1;}else if(direction==="right"){newIdx+=1;}
if(newIdx>=0&&newIdx<cards.length&&cards[newIdx]instanceof HTMLElement){cards[newIdx].focus();return true;}}
getDocumentsAttachmentViewerProps(){return{previewStore:this.props.previewStore};}
folderCount(){return this.props.list.records.reduce((count,record)=>(record.data.type==='folder'?count+1:count),0);}
hasFolders(){return this.props.list.records.some((record)=>record.data.type==='folder');}
hasFiles(){return this.props.list.records.some((record)=>record.data.type!=='folder');}
get isRecentFolder(){const groupBy=this.env.model.config.groupBy;return groupBy?.length===1&&groupBy[0]==="last_access_date_group";}
get isMobile(){return this.env.isSmall;}
getFolderRecords(){return this.props.list.records.filter((record)=>record.data.type==='folder').map((record)=>({record,key:record.id}));}
getGroupsOrRecords(){if(this.props.list.isGrouped){return super.getGroupsOrRecords();}
return this.props.list.records.filter((record)=>record.data.type!=='folder').map((record)=>({record,key:record.id}));}}
return __exports;});;

/* /documents/static/src/views/kanban/documents_kanban_view.js */
odoo.define('@documents/views/kanban/documents_kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@documents/views/search/documents_control_panel','@documents/views/kanban/documents_kanban_controller','@documents/views/kanban/documents_kanban_model','@documents/views/kanban/documents_kanban_renderer','@documents/views/search/documents_search_model','@documents/views/search/documents_search_panel','@documents/views/kanban/documents_kanban_arch_parser'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{DocumentsControlPanel}=require("@documents/views/search/documents_control_panel");const{DocumentsKanbanController}=require("@documents/views/kanban/documents_kanban_controller");const{DocumentsKanbanModel}=require("@documents/views/kanban/documents_kanban_model");const{DocumentsKanbanRenderer}=require("@documents/views/kanban/documents_kanban_renderer");const{DocumentsSearchModel}=require("@documents/views/search/documents_search_model");const{DocumentsSearchPanel}=require("@documents/views/search/documents_search_panel");const{DocumentsKanbanArchParser}=require("@documents/views/kanban/documents_kanban_arch_parser");const DocumentsKanbanView=__exports.DocumentsKanbanView=Object.assign({},kanbanView,{ArchParser:DocumentsKanbanArchParser,SearchModel:DocumentsSearchModel,SearchPanel:DocumentsSearchPanel,ControlPanel:DocumentsControlPanel,Controller:DocumentsKanbanController,Model:DocumentsKanbanModel,Renderer:DocumentsKanbanRenderer,searchMenuTypes:["filter","groupBy","favorite"],});registry.category("views").add("documents_kanban",DocumentsKanbanView);return __exports;});;

/* /documents/static/src/views/list/document_count_field.js */
odoo.define('@documents/views/list/document_count_field',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/integer/integer_field'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{IntegerField}=require("@web/views/fields/integer/integer_field");const DocumentCountIntegerField=__exports.DocumentCountIntegerField=class DocumentCountIntegerField extends IntegerField{get formattedValue(){if(!this.value){return"";}else if(this.value==1){return _t("1 document",this.value);}
return _t("%s documents",this.value);}}
const documentCountIntegerField={component:DocumentCountIntegerField,displayName:_t("DocumentCountIntegerField"),supportedTypes:["integer"],};registry.category("fields").add("document_count",documentCountIntegerField);return __exports;});;

/* /documents/static/src/views/list/documents_list_controller.js */
odoo.define('@documents/views/list/documents_list_controller',['@web/views/list/list_controller','@web/core/l10n/translation','@web/core/utils/hooks','@documents/views/documents_controller_mixin','@documents/views/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{ListController}=require("@web/views/list/list_controller");const{_t}=require("@web/core/l10n/translation");const{useBus}=require("@web/core/utils/hooks");const{DocumentsControllerMixin}=require("@documents/views/documents_controller_mixin");const{openDeleteConfirmationDialog,preSuperSetup,useDocumentView}=require("@documents/views/hooks");const{useRef,useState}=require("@odoo/owl");const DocumentsListController=__exports.DocumentsListController=class DocumentsListController extends DocumentsControllerMixin(ListController){static template="documents.DocumentsListController";setup(){preSuperSetup();super.setup(...arguments);this.uploadFileInputRef=useRef("uploadFileInput");const properties=useDocumentView(this.documentsViewHelpers());Object.assign(this,properties);useBus(this.model.env.documentsView.bus,"documents-export-selection",(ev)=>{this.onExportData();});this.documentStates=useState({previewStore:{},});}
documentsViewHelpers(){return{getSelectedDocumentsElements:()=>this.root?.el?.querySelectorAll(".o_data_row.o_data_row_selected .o_list_record_selector")||[],setPreviewStore:(previewStore)=>{this.documentStates.previewStore=previewStore;},isRecordPreviewable:this.isRecordPreviewable.bind(this),};}
getStaticActionMenuItems(){const isM2MGrouped=this.model.root.isM2MGrouped;return{export:{isAvailable:()=>this.isExportEnable,sequence:10,description:_t("Export"),callback:()=>this.onExportData(),},delete:{isAvailable:()=>{return this.activeActions.delete&&!isM2MGrouped&&this.model.root.records.length;},sequence:40,description:_t("Delete"),callback:()=>{return this.model.root.records[0].isActive?this.onArchiveSelectedRecords():this.onDeleteSelectedRecords();},},};}
async onDeleteSelectedRecords(){if(!(await openDeleteConfirmationDialog(this.model,true))){return;}
const root=this.model.root;await root.deleteRecords(root.records.filter((record)=>record.selected));await this.model.notify();await this.model.env.documentsView.bus.trigger("documents-close-preview");}
async onArchiveSelectedRecords(){if(!(await openDeleteConfirmationDialog(this.model,false))){return;}
await this.toggleArchiveState(true);await this.model.env.documentsView.bus.trigger("documents-close-preview");}
isRecordPreviewable(record){return record.isViewable();}}
return __exports;});;

/* /documents/static/src/views/list/documents_list_model.js */
odoo.define('@documents/views/list/documents_list_model',['@web/views/list/list_view','@documents/views/documents_model_mixin'],function(require){'use strict';let __exports={};const{listView}=require("@web/views/list/list_view");const{DocumentsModelMixin,DocumentsRecordMixin}=require("@documents/views/documents_model_mixin");const ListModel=listView.Model;const DocumentsListModel=__exports.DocumentsListModel=class DocumentsListModel extends DocumentsModelMixin(ListModel){}
DocumentsListModel.Record=class DocumentsListRecord extends DocumentsRecordMixin(ListModel.Record){};return __exports;});;

/* /documents/static/src/views/list/documents_list_renderer.js */
odoo.define('@documents/views/list/documents_list_renderer',['@web/core/l10n/translation','@web/views/list/list_renderer','@web/core/utils/hooks','@web/core/file_upload/file_upload_progress_container','@web/core/file_upload/file_upload_progress_record','@documents/views/helper/documents_drop_zone','@documents/views/helper/documents_action_helper','@documents/views/helper/documents_file_viewer','@documents/views/documents_renderer_mixin','@documents/views/list/documents_list_renderer_checkbox','@documents/components/documents_details_panel/documents_details_panel','@web/core/commands/command_hook','@odoo/owl','@web/core/hotkeys/hotkey_service','@mail/chatter/web_portal/chatter'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ListRenderer}=require("@web/views/list/list_renderer");const{useService}=require("@web/core/utils/hooks");const{FileUploadProgressContainer}=require("@web/core/file_upload/file_upload_progress_container");const{FileUploadProgressDataRow}=require("@web/core/file_upload/file_upload_progress_record");const{DocumentsDropZone}=require("@documents/views/helper/documents_drop_zone");const{DocumentsActionHelper}=require("@documents/views/helper/documents_action_helper");const{DocumentsFileViewer}=require("@documents/views/helper/documents_file_viewer");const{DocumentsRendererMixin}=require("@documents/views/documents_renderer_mixin");const{DocumentsListRendererCheckBox}=require("@documents/views/list/documents_list_renderer_checkbox");const{DocumentsDetailsPanel}=require("@documents/components/documents_details_panel/documents_details_panel");const{useCommand}=require("@web/core/commands/command_hook");const{useRef}=require("@odoo/owl");const{getActiveHotkey}=require("@web/core/hotkeys/hotkey_service");const{Chatter}=require("@mail/chatter/web_portal/chatter");const DocumentsListRenderer=__exports.DocumentsListRenderer=class DocumentsListRenderer extends DocumentsRendererMixin(ListRenderer){static props=[...ListRenderer.props,"previewStore"];static template="documents.DocumentsListRenderer";static recordRowTemplate="documents.DocumentsListRenderer.RecordRow";static components=Object.assign({},ListRenderer.components,{DocumentsListRendererCheckBox,FileUploadProgressContainer,FileUploadProgressDataRow,DocumentsDropZone,DocumentsActionHelper,DocumentsFileViewer,DocumentsDetailsPanel,Chatter,});setup(){super.setup();this.root=useRef("root");const{uploads}=useService("file_upload");this.documentUploads=uploads;useCommand(_t("Select all"),()=>{const allSelected=this.props.list.selection.length===this.props.list.records.length;this.props.list.records.forEach((record)=>{record.toggleSelection(!allSelected);});},{category:"smart_action",hotkey:"control+a",});}
getDocumentsAttachmentViewerProps(){return{previewStore:this.props.previewStore};}
onGlobalKeydown(ev){if(ev.key!=="Enter"&&ev.key!==" "||this.editedRecord){return;}
const row=ev.target.closest(".o_data_row");const record=row&&this.props.list.records.find((rec)=>rec.id===row.dataset.id);if(!record){return;}
if(ev.key==="Enter"&&record.data.type!=="folder"){record.onClickPreview(ev);}
ev.stopPropagation();ev.preventDefault();this.toggleRecordSelection(record);}
onCellClicked(record,column,ev){ev.stopPropagation();const isSelectionKeyPressed=ev.ctrlKey||ev.metaKey||ev.shiftKey;if(isSelectionKeyPressed){this.toggleRecordSelection(record);}else if(record.selected&&this.editableColumns.includes(column.name)){return super.onCellClicked(...arguments);}else if(record.data.type!=="folder"){return record.onClickPreview(ev);}else{record.openFolder();}}
get editableColumns(){return["name","tag_ids","partner_id","owner_id","company_id","folder_id"];}
onGlobalClick(ev){if(ev.target.closest(".o_data_row")||!ev.target.closest(".o_list_renderer")){return;}
if(ev.target.closest(".o_documents_view thead")){return;}
this.props.list.selection.forEach((el)=>el.toggleSelection(false));}
getFolderInfo(){return{count:this.props.list.model.useSampleModel?0:this.props.list.count,fileSize:this.props.list.model.fileSize,};}
onCellKeydown(ev,group=null,record=null){const hotkey=getActiveHotkey(ev);if(hotkey==="enter"){return;}
return super.onCellKeydown(...arguments);}
get hasSelectors(){return this.props.allowSelectors;}
get isMobile(){return this.env.isSmall;}
onDragEnter(ev){const row=ev.target.closest(".o_data_row");const record=row&&this.props.list.records.find((rec)=>rec.id===row.dataset.id);if(record.data.type!=="folder"){return;}
if(record.selected){row.classList.remove("table-info");}
const isInvalidFolder=this.props.list.selection.map((r)=>r.data.id).includes(record.data.id);row.classList.add(isInvalidFolder?"table-danger":"table-success");}
onDragLeave(ev){const row=ev.target.closest(".o_data_row");const elemBounding=row.getBoundingClientRect();const isOutside=ev.clientX<elemBounding.left||ev.clientX>elemBounding.right||ev.clientY<elemBounding.top||ev.clientY>elemBounding.bottom;if(!isOutside){return;}
const record=row&&this.props.list.records.find((rec)=>rec.id===row.dataset.id);if(record.data.type!=="folder"){return;}
if(record.selected){row.classList.add("table-info");}
row.classList.remove("table-success","table-danger");}
onDragOver(ev){const row=ev.target.closest(".o_data_row");const record=row&&this.props.list.records.find((rec)=>rec.id===row.dataset.id);const isInvalidTarget=record.data.type!=="folder"||this.props.list.selection.map((r)=>r.data.id).includes(record.data.id);const dropEffect=isInvalidTarget?"none":ev.ctrlKey?"link":"move";ev.dataTransfer.dropEffect=dropEffect;}
onDrop(ev){const row=ev.target.closest(".o_data_row");const record=row&&this.props.list.records.find((rec)=>rec.id===row.dataset.id);if(record.data.type!=="folder"){return;}
row.classList.remove("table-success","table-danger");record.onDrop(ev);}}
return __exports;});;

/* /documents/static/src/views/list/documents_list_renderer_checkbox.js */
odoo.define('@documents/views/list/documents_list_renderer_checkbox',['@web/core/checkbox/checkbox'],function(require){'use strict';let __exports={};const{CheckBox}=require("@web/core/checkbox/checkbox");const DocumentsListRendererCheckBox=__exports.DocumentsListRendererCheckBox=class DocumentsListRendererCheckBox extends CheckBox{onChange(ev){}
onClick(ev){}}
return __exports;});;

/* /documents/static/src/views/list/documents_list_view.js */
odoo.define('@documents/views/list/documents_list_view',['@web/core/registry','@web/views/list/list_view','@documents/views/search/documents_control_panel','@documents/views/list/documents_list_controller','@documents/views/list/documents_list_model','@documents/views/list/documents_list_renderer','@documents/views/search/documents_search_model','@documents/views/search/documents_search_panel'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{DocumentsControlPanel}=require("@documents/views/search/documents_control_panel");const{DocumentsListController}=require("@documents/views/list/documents_list_controller");const{DocumentsListModel}=require("@documents/views/list/documents_list_model");const{DocumentsListRenderer}=require("@documents/views/list/documents_list_renderer");const{DocumentsSearchModel}=require("@documents/views/search/documents_search_model");const{DocumentsSearchPanel}=require("@documents/views/search/documents_search_panel");const DocumentsListView=__exports.DocumentsListView=Object.assign({},listView,{SearchModel:DocumentsSearchModel,SearchPanel:DocumentsSearchPanel,ControlPanel:DocumentsControlPanel,Controller:DocumentsListController,Model:DocumentsListModel,Renderer:DocumentsListRenderer,searchMenuTypes:["filter","groupBy","favorite"],});registry.category("views").add("documents_list",DocumentsListView);return __exports;});;

/* /documents/static/src/views/search/documents_control_panel.js */
odoo.define('@documents/views/search/documents_control_panel',['@web/search/control_panel/control_panel','@documents/components/documents_breadcrumbs','@documents/views/cog_menu/documents_cog_menu','@odoo/owl','@web/core/utils/hooks','@web/core/l10n/translation','@web/core/network/download','@web/core/l10n/dates','@documents/views/hooks','@web/core/browser/browser','@web/core/user'],function(require){'use strict';let __exports={};const{ControlPanel}=require("@web/search/control_panel/control_panel");const{DocumentsBreadcrumbs}=require("@documents/components/documents_breadcrumbs");const{DocumentsCogMenu}=require("@documents/views/cog_menu/documents_cog_menu");const{onPatched,onWillPatch,onWillStart,useState}=require("@odoo/owl");const{useService,useBus}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const{download}=require("@web/core/network/download");const{serializeDate}=require("@web/core/l10n/dates");const{DateTime}=luxon;const{toggleArchive,openDeleteConfirmationDialog}=require("@documents/views/hooks");const{browser}=require("@web/core/browser/browser");const{user}=require("@web/core/user");const DocumentsControlPanel=__exports.DocumentsControlPanel=class DocumentsControlPanel extends ControlPanel{static template="documents.ControlPanel";static components={...ControlPanel.components,DocumentsBreadcrumbs,DocumentsCogMenu,};setup(){super.setup();this.action=useService("action");this.notification=useService("notification");this.orm=useService("orm");this.documentService=useService("document.document");this.documentService.chatterState.previewedDocument=null;this.documentService.chatterState.viewType=false;this.documentsState=useState(this.documentService.chatterState);this.firstLoad=true;onWillPatch(()=>{this.firstLoad=false;});onPatched(()=>{const searchPanelContainer=document.querySelector('.o_search_panel');if(searchPanelContainer){searchPanelContainer.classList.toggle('d-none',this.env.isSmall&&this.targetRecords.length);}});onWillStart(async()=>{this.canExport=await user.hasGroup("base.group_allow_export");});this.isEditable=this.documentService.isEditable;this.canDownload=this.documentService.canDownload;this.isFolderSharable=this.documentService.isFolderSharable;useBus(this.documentService.bus,"DOCUMENT_PREVIEWED",async(ev)=>{this.documentsState.previewedDocument=this.documentService.previewedDocument;});}
async onDoAction(actionId){const documentIds=this.targetRecords.map((record)=>record.data.id);const context={active_model:"documents.document",active_ids:documentIds,};const action=await this.orm.call("documents.document","action_execute_embedded_action",[actionId],{context});if(action){await this.action.doAction(action,{onClose:()=>{this.env.searchModel._reloadSearchModel(true);},});if(action.tag!=="display_notification"){return;}}
this.env.searchModel._reloadSearchModel(true);this.documentsState.previewedDocument=null;}
async onShare(){const documents=this.targetRecords;if(documents.length!==1){return;}
this.env.documentsView.bus.trigger("documents-open-share",{id:documents[0].data.id,shortcut_document_id:documents[0].data.shortcut_document_id,});}
onDownload(){const documents=this.targetRecords.filter((rec)=>!rec.isRequest());if(!documents.length){return;}
const linkDocuments=documents.filter((el)=>el.data.type==="url");const noLinkDocuments=documents.filter((el)=>el.data.type!=="url");if(documents.length===1&&linkDocuments.length){let url=linkDocuments[0].data.url;url=/^(https?|ftp):\/\//.test(url)?url:`http://${url}`;window.open(url,"_blank");}else if(noLinkDocuments.length){if(noLinkDocuments.length===1){download({data:{},url:`/documents/content/${noLinkDocuments[0].data.access_token}`,});}else{download({data:{file_ids:noLinkDocuments.map((rec)=>rec.data.id),zip_name:`documents-${serializeDate(DateTime.now())}.zip`,},url:"/documents/zip",});}}}
async onDelete(){const records=!this.documentService.userIsInternal?this.targetRecords:this.targetRecords.filter((r)=>!r.data.active);if(!(await openDeleteConfirmationDialog(this.env.model,true))){return;}
const model=this.env.model;await model.root.deleteRecords(records);await model.load(this.env.model.config);await this.notifyChange();}
async onDropdownOpen(){const currentController=this.action.currentController;this.documentsState.viewType=currentController.state.view_type;}
onExport(){this.env.documentsView.bus.trigger("documents-export-selection");}
async onArchive(){const records=this.targetRecords.filter((r)=>r.data.active);const recordIds=records.map((r)=>r.data.id);await toggleArchive(records[0].model,records[0].resModel,recordIds,true);await this.notifyChange();}
async onDuplicate(){const records=this.targetRecords.filter((r)=>r.data.active);const recordIds=records.map((r)=>r.data.id);await this.orm.call("documents.document","copy",[recordIds]);await this.notifyChange();const copiedInMyDrive=records.filter((r)=>(r.data.folder_id&&this.env.searchModel.getFolderById(r.data.folder_id[0]).user_permission!=="edit")||(!r.data.folder_id&&!this.documentService.userIsDocumentManager));if(this.env.searchModel.getSelectedFolderId()==="MY"){return;}
if(copiedInMyDrive.length!==0){let message=_t("%s has been copied in My Drive.",copiedInMyDrive[0].data.name);if(copiedInMyDrive.length>1){const names=copiedInMyDrive.map((r)=>r.data.name).join(", ");message=_t("%s have been copied in My Drive.",names);}
this.notificationService.add(message,{type:"success"});}}
async onRestore(){const records=this.targetRecords.filter((r)=>!r.data.active);const recordIds=records.map((r)=>r.data.id);await toggleArchive(records[0].model,records[0].resModel,recordIds,false);await this.env.searchModel._reloadSearchModel(true);}
onSplitPDF(){const documents=this.targetRecords;if(!documents||!documents.every((d)=>d.isPdf())){return;}
this.env.documentsView.bus.trigger("documents-open-preview",{documents:documents,mainDocument:this.targetRecords[0],isPdfSplit:true,hasPdfSplit:true,embeddedActions:this.embeddedActions,});}
async onToggleLock(){if(this.targetRecords.length!==1){return;}
const record=this.targetRecords[0];await this.orm.call("documents.document","toggle_lock",[record.data.id]);await record.load();}
async onRename(){if(this.targetRecords.length!==1){return;}
await this.documentService.openDialogRename(this.targetRecords[0].data.id);await this.notifyChange();}
async onToggleChatter(){this.documentService.toggleChatterState();if(this.documentsState.isChatterVisible){this.observer?.disconnect();this.observer=new MutationObserver(()=>{const chatterContainer=document.querySelector('.o-mail-Thread');if(chatterContainer&&this.env.isSmall){chatterContainer.scrollIntoView({behavior:"smooth"});this.observer.disconnect();return;}
const view=this.action.currentController.props.type;if(chatterContainer&&this.targetRecords.length&&["kanban","list"].includes(view)){const selectedRecordClass=view==="kanban"?".o_kanban_record.o_record_selected":".o_data_row.o_data_row_selected";document.querySelector(selectedRecordClass)?.scrollIntoView({behavior:"instant",block:view==="kanban"?"start":"center",});this.observer.disconnect();}});this.observer.observe(document.querySelector('.o_documents_content'),{childList:true,subtree:true});}}
async onCreateShortcut(){const documents=this.targetRecords;if(documents.length!==1){this.notificationService.add(_t("Shortcuts can only be created one at a time."),{type:"danger",});return;}
await this.orm.call("documents.document","action_create_shortcut",[this.targetRecords[0].data.id],);await this.notifyChange();}
async onCopyLinks(){const documents=this.targetRecords;await this.populateMissingAccessURLsIfAny(documents);const linksToShare=documents.length>1?documents.map((d)=>d.data.access_url).join(", "):documents[0].data.access_url;await browser.navigator.clipboard.writeText(linksToShare);const message=documents.length>1?_t("Links copied to clipboard!"):_t("Link copied to clipboard!");this.notification.add(message,{type:"success"});}
get canDuplicateSelection(){return(this.currentFolderId!=="TRASH"&&this.documentService.isEditable(this.env.searchModel.getFolderById(this.currentFolderId)));}
get canManageVersions(){if(this.targetRecords.length!==1){return false;}
const singleSelection=this.targetRecords[0];return(this.userIsInternal&&singleSelection&&this.currentFolderId!=="TRASH"&&singleSelection.data.type==="binary"&&singleSelection.data.attachment_id);}
async onManageVersions(){await this.documentService.openDialogManageVersions(this.targetRecords[0].data.id);}
onUnselectAll(){this.env.model.root.selection.forEach((record)=>{record.toggleSelection(false);});this.env.model.root.selectDomain(false);}
get allFoldersIds(){const folderIds=this.env.model.root.records.map((d)=>d.data.folder_id[0]).filter((f)=>f);if(this.currentFolderId&&typeof this.currentFolderId==="number"){folderIds.push(this.currentFolderId);}
return[...new Set(folderIds)];}
get embeddedActions(){if(!this.targetRecords[0]?.data.available_embedded_actions_ids?.records.length){return[];}
const actionsList=this.targetRecords.map((d)=>d.data.available_embedded_actions_ids.records.map((rec)=>({id:rec.resId,name:rec.data.display_name,})));const actionsListIds=actionsList.map((actions)=>actions.map((a)=>a.id));return actionsList[0].filter((action)=>actionsListIds.every((a)=>a.includes(action.id)));}
get currentFolderId(){return this.env.searchModel.getSelectedFolderId();}
get targetRecords(){return this.documentsState.previewedDocument?[this.documentsState.previewedDocument.record]:this.env.model.root.selection;}
get areTargetRecordsDeletable(){const documents=this.targetRecords.map((r)=>r.data);if(this.userIsInternal){return documents.some((d)=>!d.active);}
return documents.every((r)=>r.owner_id?.[0]===user.userId&&["binary","url"].includes(r.type)&&typeof r.folder_id?.[0]==="number"&&this.env.searchModel.getFolderById(r.folder_id[0]).user_permission==="edit");}
async notifyChange(){await this.env.model.load();await this.env.model.notify();await this.env.searchModel._reloadSearchModel(true);this.documentService.setPreviewedDocument(null);}
get pathBreadcrumbs(){if(this.env.model.config.context.active_model){return[...this.env.config.breadcrumbs.slice(0,-1),{name:this.env.searchModel.getSelectedFolder().display_name,},];}
return this.env.searchModel.getSelectedFolderAndParents().reverse().map(folder=>{return{jsId:folder.id,name:folder.display_name,onSelected:()=>{const folderSection=this.env.searchModel.getSections()[0];this.env.searchModel.toggleCategoryValue(folderSection.id,folder.id);}}});}
async populateMissingAccessURLsIfAny(documents){if(documents.every(({data})=>data.access_url)){return;}
const accessURLsMap=Object.fromEntries((await this.orm.read("documents.document",documents.map(({data:{id}})=>id),["access_url"])).map(({id,access_url})=>[id,access_url]))
documents.forEach(({data})=>data.access_url=accessURLsMap[data.id]);}}
return __exports;});;

/* /documents/static/src/views/search/documents_search_model.js */
odoo.define('@documents/views/search/documents_search_model',['@web/search/action_hook','@web/search/search_model','@web/core/browser/browser','@web/core/browser/router','@web/core/domain','@web/core/user','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useSetupAction}=require("@web/search/action_hook");const{SearchModel}=require("@web/search/search_model");const{browser}=require("@web/core/browser/browser");const{router}=require("@web/core/browser/router");const{Domain}=require("@web/core/domain");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{onWillStart}=require("@odoo/owl");const DocumentsSearchModel=__exports.DocumentsSearchModel=class DocumentsSearchModel extends SearchModel{setup(services){super.setup(services);this.documentService=useService("document.document");this.orm=useService("orm");this.skipLoadClosePreview=false;onWillStart(async()=>{this.deletionDelay=await this.orm.call("documents.document","get_deletion_delay",[[]]);});useSetupAction({beforeLeave:()=>{this._updateRouteState({folder_id:undefined});},});}
async load(config){if(this.documentService.initData.documentId){config.irFilters.forEach((fil)=>{fil.is_default=false;});for(const key in config.context){const searchDefaultMatch=/^search_default_(.*)$/.exec(key);if(searchDefaultMatch){delete config.context[key];}}}
await super.load(config);let folderId=router.current.folder_id||this.getSelectedFolderId();if(folderId){const folderSection=this.getSections()[0];if(!folderSection.values.has(folderId)){folderId=false;}
this.toggleCategoryValue(folderSection.id,folderId);}}
_createCategoryTree(sectionId,result){const category=this.sections.get(sectionId);for(const folderId of category.values.keys()){if(typeof folderId==="number"){category.values.delete(folderId);}}
super._createCategoryTree(...arguments);const findRootId=(folder)=>{if(!folder.parentId){return folder.id;}
const parent=category.values.get(folder.parentId);if(!parent){return false;}
if(parent.rootId!==undefined){return parent.rootId;}else{const rootId=findRootId(parent);parent.rootId=rootId;return rootId;}}
for(const[,folder]of category.values){if(!folder.rootId){folder.rootId=findRootId(folder);}}}
_extractSearchDefaultsFromGlobalContext(){const{searchDefaults,searchPanelDefaults}=super._extractSearchDefaultsFromGlobalContext(...arguments);if(searchPanelDefaults.folder_id&&!this.globalContext.no_documents_unique_folder_id){this.globalContext['documents_unique_folder_id']=searchPanelDefaults.folder_id;}
return{searchDefaults,searchPanelDefaults};}
getFolders(){const{values}=this.getSections()[0];return[...values.values()];}
getFolderById(folderId){const folderSection=this.getSections()[0];const folder=folderSection&&folderSection.values.get(folderId);return folder||false;}
getSelectedFolderId(){const{activeValueId}=this.getSections()[0];return activeValueId;}
getSelectedFolder(){const folderSection=this.getSections()[0];return this.getFolderById(folderSection.activeValueId);}
getFolderAndParents(folder){const folders=[];const folderSection=this.getSections()[0];while(folder){folders.push(folder);folder=folder.folder_id?folderSection.values.get(folder.folder_id):false;}
return folders;}
getSelectedFolderAndParents(){const folderSection=this.getSections()[0];const folder=folderSection.values.get(folderSection.activeValueId);return this.getFolderAndParents(folder);}
async getTags(){if(this._tags){return this._tags;}
const result=await this.orm.call("documents.tag","name_search",[],{});this._tags=result.map((tag)=>({id:tag[0],name:tag[1]}));return this._tags;}
toggleCategoryValue(sectionId,valueId){super.toggleCategoryValue(...arguments);browser.localStorage.setItem("searchpanel_documents_document",valueId);const selectedFolder=this.getSelectedFolder();this.documentService.updateDocumentURL(selectedFolder);if(typeof valueId==="number"){this.documentService.logAccess(selectedFolder.access_token);}}
async updateRecordFolderId(recordIds,valueId){await this.orm.call("documents.document","action_move_documents",[recordIds,valueId]);this.trigger("update");}
async updateRecordTagId(recordIds,valueId,x2mCommand=4){await this.orm.write("documents.document",recordIds,{tag_ids:[[x2mCommand,valueId]],});this.skipLoadClosePreview=true;this.trigger("update");}
async _reloadSearchModel(reloadCategories){if(reloadCategories){await this._reloadSearchPanel(true);}
await this._notify();}
async _reloadSearchPanel(skipUpdate=false){await this._fetchSections(this.getSections((s)=>s.type==="category"),[]);if(!skipUpdate){this.trigger("update-search-panel");}}
_getCategoryDomain(){const folderCategory=this.categories.find((cat)=>cat.fieldName==="folder_id");if(folderCategory.activeValueId==="COMPANY"){return[["folder_id","=",false],["owner_id","=",this.documentService.store.odoobot.userId],];}
if(folderCategory.activeValueId==="TRASH"){return[["active","=",false]];}
if(folderCategory.activeValueId==="MY"){return[["folder_id","=",false],["owner_id","=",user.userId],];}
if(folderCategory.activeValueId==="SHARED"){return Domain.and([[["shortcut_document_id","=",false]],Domain.or([Domain.and([[["folder_id","=",false]],[["owner_id","not in",[user.userId,this.documentService.store.odoobot.userId]]],]),Domain.and([[['folder_id','!=',false]],[['folder_id','not any',[]]]]),])]).toList();}
if(folderCategory.activeValueId==="RECENT"){return[['access_ids','any',[['partner_id','=',user.partnerId],['last_access_date','!=',false]]]];}
if(!folderCategory.activeValueId){return[];}
const folder=this.getSelectedFolder();const folderIdToOpen=folder?.shortcut_document_id?.length?folder.shortcut_document_id[0]:folderCategory.activeValueId;const result=super._getCategoryDomain();const folderLeafIdx=result.findIndex((leaf)=>leaf[0]==="folder_id"&&leaf[1]==="child_of");if(folderLeafIdx!==-1){result.splice(folderLeafIdx,1,...[["folder_id","=",folderIdToOpen]],);}
return result;}
get orderBy(){const order=super.orderBy;if(!order?.length&&this.sections.get(1).activeValueId==="TRASH"){return[{name:"write_date",asc:false},{name:"is_folder",asc:false},];}
if(!order?.length&&this.sections.get(1).activeValueId==="RECENT"){return[{name:"is_folder",asc:true},{name:"last_access_date_group",asc:false},];}
if(this.sections.get(1).activeValueId===false){order.push({name:"last_access_date_group",asc:false});}
return order;}
get groupBy(){const groupBy=super.groupBy;if(!groupBy?.length&&this.sections.get(1).activeValueId==="RECENT"){return["last_access_date_group"];}
return groupBy;}
_isCategoryValueReachable(category,valueId){const queue=[...category.rootIds];let folder;while((folder=category.values.get(queue.pop()))){if(folder.id===valueId){return true;}
queue.push(...folder.childrenIds);}
return false;}
_ensureCategoryValue(category,valueIds){if(valueIds.includes(category.activeValueId)&&this._isCategoryValueReachable(category,category.activeValueId)){return;}
const storageItem=browser.localStorage.getItem("searchpanel_documents_document");category.activeValueId=storageItem&&!["COMPANY","MY","RECENT","SHARED","TRASH"].includes(storageItem)?JSON.parse(storageItem):storageItem;if(["COMPANY","MY","RECENT","SHARED","TRASH"].includes(category.activeValueId)||(valueIds.includes(category.activeValueId)&&this._isCategoryValueReachable(category,category.activeValueId))){return;}
if(category.values.has(category.activeValueId)){let newSection=category.values.get(category.values.get(category.activeValueId).parentId);while(newSection&&!this._isCategoryValueReachable(category,newSection.id)){newSection=category.values.get(newSection.parentId);}
if(newSection){category.activeValueId=newSection.id||valueIds[Number(valueIds.length>1)];}else{category.activeValueId=this.documentService.userIsInternal?"COMPANY":valueIds[0];}
browser.localStorage.setItem("searchpanel_documents_document",category.activeValueId);}else{category.activeValueId=this.documentService.userIsInternal?false:valueIds[0];}}
_shouldWaitForData(){return true;}
_updateRouteState(state){router.pushState(state);}}
return __exports;});;

/* /documents/static/src/views/search/documents_search_panel.js */
odoo.define('@documents/views/search/documents_search_panel',['@web/core/l10n/translation','@web/core/browser/browser','@web/search/search_panel/search_panel','@web/core/utils/nested_sortable','@web/core/popover/popover_hook','@web/core/user','@web/core/utils/hooks','@web/core/ui/ui_service','@odoo/owl','@documents/views/hooks'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{SearchPanel}=require("@web/search/search_panel/search_panel");const{useNestedSortable}=require("@web/core/utils/nested_sortable");const{usePopover}=require("@web/core/popover/popover_hook");const{user}=require("@web/core/user");const{useBus,useService}=require("@web/core/utils/hooks");const{utils:uiUtils}=require("@web/core/ui/ui_service");const{Component,onWillStart,useState}=require("@odoo/owl");const{toggleArchive}=require("@documents/views/hooks");const VALUE_SELECTOR=[".o_search_panel_category_value",".o_search_panel_filter_value"].join();const FOLDER_VALUE_SELECTOR=".o_search_panel_category_value";const LONG_TOUCH_THRESHOLD=400;const DocumentsSearchPanelItemSettingsPopover=__exports.DocumentsSearchPanelItemSettingsPopover=class DocumentsSearchPanelItemSettingsPopover extends Component{static template="documents.DocumentsSearchPanelItemSettingsPopover";static props=["close","createChildEnabled","onCreateChild","onEdit","isShareable","onShare","isEditable",];}
const DocumentsSearchPanel=__exports.DocumentsSearchPanel=class DocumentsSearchPanel extends SearchPanel{static modelExtension="DocumentsSearchPanel";static template=!uiUtils.isSmall()?"documents.SearchPanel":"documents.SearchPanel.Small";static subTemplates=!uiUtils.isSmall()?{section:"web.SearchPanel.Section",category:"documents.SearchPanel.Category",filtersGroup:"documents.SearchPanel.FiltersGroup",}:{section:"web.SearchPanel.Section",category:"documents.SearchPanel.Category.Small",filtersGroup:"documents.SearchPanel.FiltersGroup.Small",};static rootIcons={false:"fa-folder-o",COMPANY:"fa-building",MY:"fa-hdd-o",RECENT:"fa-clock-o",SHARED:"fa-users",TRASH:"fa-trash",};setup(){super.setup(...arguments);const{uploads}=useService("file_upload");this.documentService=useService("document.document");this.documentUploads=uploads;useState(uploads);this.notification=useService("notification");this.orm=useService("orm");this.action=useService("action");this.popover=usePopover(DocumentsSearchPanelItemSettingsPopover,{onClose:()=>this.onPopoverClose?.(),popoverClass:"o_search_panel_item_settings_popover",});this.dialog=useService("dialog");onWillStart(async()=>{this.isDocumentManager=await user.hasGroup("documents.group_documents_manager");if(this.env.model.config.context.active_model){const categories=this.env.searchModel.getSections((s)=>s.type==="category");for(const category of categories){this.state.expanded[category.id]={};}}else{const selectedFolderId=this.env.searchModel.getSelectedFolderId();if(selectedFolderId){this.state.expanded[this.sections[0].id]["COMPANY"]=true;this._expandFolder({folderId:selectedFolderId});}}});useBus(this.env.documentsView.bus,"documents-expand-folder",(ev)=>{this._expandFolder(ev.detail);});useBus(this.env.searchModel,"update-search-panel",async()=>{this.updateActiveValues();this.render();});useBus(this.env.documentsView.bus,"documents-open-edit-selected-folder",()=>{const selectedFolderId=this.env.searchModel.getSelectedFolderId();if(selectedFolderId){this.editSectionValue("documents.document",selectedFolderId);}});useNestedSortable({ref:this.root,groups:".o_search_panel_category",elements:"li:not(.o_all_or_trash_category)",enable:()=>this.isDocumentManager,nest:true,nestInterval:10,onMove:({parent,newGroup,prevPos,placeholder})=>{if(parent){parent.classList.add("o_has_treeEntry");placeholder.classList.add("o_treeEntry");const parentSectionId=parseInt(newGroup.dataset.sectionId);const parentValueId=parseInt(parent.dataset.valueId);this.state.expanded[parentSectionId][parentValueId]=true;}else{placeholder.classList.remove("o_treeEntry");}
if(prevPos.parent&&!prevPos.parent.querySelector("li")){prevPos.parent.classList.remove("o_has_treeEntry");}},onDrop:async({element,parent})=>{const draggingFolderId=parseInt(element.dataset.valueId);const draggingFolderRootId=this.env.searchModel.getFolderById(draggingFolderId).rootId;let parentFolderId=parent?parent.dataset.valueId:false;if(draggingFolderId===parentFolderId){return;}
if(!parentFolderId||this._notify_wrong_drop_destination(parentFolderId)){return;}
const parentFolderRootId=this.env.searchModel.getFolderById(parentFolderId).rootId;if(parentFolderRootId==="MY"&&draggingFolderRootId!=="MY"){await this.orm.call("documents.document","action_create_shortcut",[draggingFolderId],{location_folder_id:parentFolderId==="MY"?false:parentFolderId},);return this.env.searchModel._reloadSearchModel(true);}else if(parentFolderId==="COMPANY"){await this.orm.call("documents.document","action_set_as_company_root",[draggingFolderId],);return this.env.searchModel._reloadSearchModel(true);}else if(parentFolderId){parentFolderId=parseInt(parentFolderId);}
await this.orm.call("documents.document","action_move_documents",[draggingFolderId,parentFolderId],);await this.env.searchModel._reloadSearchModel(true);},});}
isUploadingInFolder(folderId){return Object.values(this.documentUploads).find((upload)=>upload.data.get("folder_id")===folderId);}
async toggleCategory(category,value){if(category.activeValueId!==value.id){const folder=this.env.searchModel.getFolderById(value.id);const isShortcut=!!folder.shortcut_document_id?.length;if(isShortcut&&!this.env.searchModel.getFolderById(folder.shortcut_document_id[0])){return this.env.searchModel.toggleCategoryValue(category.id,"TRASH");}
this.env.searchModel.toggleCategoryValue(category.id,value.id);}}
async toggleFold(category,value){if(value.childrenIds.length){const categoryState=this.state.expanded[category.id];categoryState[value.id]=!categoryState[value.id];}else{this.getDropdownState(category.id).close();}}
resetLongTouchTimer(){if(this.longTouchTimer){browser.clearTimeout(this.longTouchTimer);this.longTouchTimer=null;}}
onSectionValueTouchStart(ev,section,value){if(!uiUtils.isSmall()||typeof value!=="number"){return;}
this.touchStartMs=Date.now();if(!this.longTouchTimer){this.longTouchTimer=browser.setTimeout(()=>{this.openEditPopover(ev,section,value);this.resetLongTouchTimer();},LONG_TOUCH_THRESHOLD);}}
onSectionValueTouchEnd(){const elapsedTime=Date.now()-this.touchStartMs;if(elapsedTime<LONG_TOUCH_THRESHOLD){this.resetLongTouchTimer();}}
onSectionValueTouchMove(){this.resetLongTouchTimer();}
_expandFolder({folderId}){let needRefresh=false;const sectionId=this.sections[0].id;const folders=this.env.searchModel.getFolderAndParents(this.env.searchModel.getFolderById(folderId));if(folders[0].rootId!=="COMPANY"||this.state.expanded[sectionId]["COMPANY"]){for(const folder of folders){if(!this.state.expanded[sectionId][folder.id]){this.state.expanded[sectionId][folder.id]=true;needRefresh=true;}}}
if(needRefresh){this.render(true);}}
async editSectionValue(resModel,resId){this.env.documentsView.bus.trigger("documents-close-preview");return this.action.doAction({res_model:resModel,res_id:resId,name:_t("Edit"),type:"ir.actions.act_window",target:"new",views:[[false,"form"]],context:{create:false,},},{onClose:()=>this.env.searchModel._reloadSearchModel(true),});}
updateDragOverClass(newDragFocus){const allSelected=this.root.el.querySelectorAll(":scope .o_drag_over_selector");for(const selected of allSelected){selected.classList.remove("o_drag_over_selector");}
if(newDragFocus){newDragFocus.classList.add("o_drag_over_selector");}}
isValidDragTransfer(section,value,target,dataTransfer){if(dataTransfer.types.includes("o_documents_data")){return(value.id&&target&&target.closest(VALUE_SELECTOR));}else if(dataTransfer.types.includes("o_documents_drag_folder")){return(section.fieldName==="folder_id"&&this.draggingFolder.id!==value.id&&this.draggingFolder.parent_folder_id!==value.id&&target&&target.closest(FOLDER_VALUE_SELECTOR));}
return false;}
onDragEnter(section,value,ev){if(!this.isValidDragTransfer(section,value,ev.currentTarget,ev.dataTransfer)){this.updateDragOverClass(null);return;}
this.updateDragOverClass(ev.currentTarget);if(value.childrenIds&&value.childrenIds.length){this.state.expanded[section.id][value.id]=true;}}
onDragLeave(section,{relatedTarget,dataTransfer}){if(!this.isValidDragTransfer(section,{id:-1},relatedTarget,dataTransfer)){this.updateDragOverClass(null);}}
onDragOver(section,value,ev){const currentFolder=this.env.searchModel.getSelectedFolder();const dropEffect=value.rootId==="MY"&&currentFolder.rootId!=="MY"||ev.ctrlKey?"link":"move";ev.dataTransfer.dropEffect=dropEffect;}
async onDrop(section,value,ev){this.updateDragOverClass(null);if(this.isValidDragTransfer(section,value,ev.relatedTarget,ev.dataTransfer)){return;}
if(ev.dataTransfer.types.includes("o_documents_data")){await this.onDropDocuments(section,value,ev);}}
async onDropDocuments(section,value,ev){const{currentTarget,dataTransfer}=ev;if(currentTarget.querySelector(":scope > .active")||!this.isValidDragTransfer(section,value,currentTarget,dataTransfer)){return;}
let targetFolderId=value.id==="MY"?false:value.id;const data=JSON.parse(dataTransfer.getData("o_documents_data"));const currentFolder=this.env.searchModel.getSelectedFolder();const movedRecords=this.env.model.root.records.map((r)=>r.data).filter((r)=>data.recordIds.includes(r.id));const isEditable=(folder)=>{return(!folder.id||folder.user_permission==="edit"||(folder.id==="COMPANY"&&this.isDocumentManager));};if(this._notify_wrong_drop_destination(value.id)){return;}
if(!isEditable(value)){return this.notification.add(_t("You don't have the rights to move documents nor create shortcut to that folder."),{title:_t("Access Error"),type:"warning",});}
if(value.rootId==="MY"&&currentFolder.rootId!=="MY"){await this.orm.call("documents.document","action_create_shortcut",[data.recordIds,targetFolderId]);await this.env.searchModel._reloadSearchModel(true);return this.notification.add(_t("Shortcut created"),{title:_t("Done!"),type:"success"});}
if(targetFolderId==="COMPANY"){if(movedRecords.some((r)=>r.type==="binary"&&!r.checksum?.length&&!r.shortcut_document_id)){return this.notification.add(_t("You cannot move request in the company folder"),{title:_t("Access Error"),type:"warning",});}
await this.orm.call("documents.document","action_set_as_company_root",[data.recordIds]);await this.env.searchModel._reloadSearchModel(true);return;}
if(targetFolderId==="TRASH"){const model=this.env.model;await toggleArchive(model,model.root.resModel,data.recordIds,true);await model.load();await model.notify();await model.env.searchModel._reloadSearchModel(true);return;}
if(data.lockedCount){this.notification.add(_t("%s file(s) not moved because they are locked by another user",data.lockedCount),{title:_t("Partial transfer"),type:"warning"});}
await this.documentService.moveOrCreateShortcut(data,targetFolderId,ev.ctrlKey);await this.env.searchModel._reloadSearchModel(true);}
_notify_wrong_drop_destination(folderId){if(["RECENT","SHARED"].includes(folderId)){this.notification.add(_t("You can't create shortcuts in or move documents to this special folder."),{title:_t("Invalid operation"),type:"warning",});return true;}}}
return __exports;});;

/* /documents/static/src/web/activity/activity_menu_patch.js */
odoo.define('@documents/web/activity/activity_menu_patch',['@mail/core/web/activity_menu','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ActivityMenu}=require("@mail/core/web/activity_menu");const{patch}=require("@web/core/utils/patch");patch(ActivityMenu.prototype,{async onClickRequestDocument(){this.dropdown.close();this.env.services.action.doAction("documents.action_request_form");},});return __exports;});;

/* /documents/static/src/web/activity/activity_model_patch.js */
odoo.define('@documents/web/activity/activity_model_patch',['@mail/core/web/activity_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Activity}=require("@mail/core/web/activity_model");const{patch}=require("@web/core/utils/patch");patch(Activity.prototype,{async markAsDone(attachmentIds=[]){await super.markAsDone(...arguments);if(this.chaining_type==="trigger"){this?.store?.env?.services["document.document"]?.reload();}},});return __exports;});;

/* /documents/static/src/web/documents_domain_selector.js */
odoo.define('@documents/web/documents_domain_selector',['@web/core/domain_selector/domain_selector','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{DomainSelector}=require("@web/core/domain_selector/domain_selector");const{patch}=require("@web/core/utils/patch");patch(DomainSelector.prototype,{getShowArchivedCheckBox(_,props){if(props.resModel==="documents.document"){return false;}
return super.getShowArchivedCheckBox(...arguments);},});return __exports;});;

/* /documents/static/src/web/error_dialog/error_dialog_patch.js */
odoo.define('@documents/web/error_dialog/error_dialog_patch',['@web/core/browser/browser','@web/core/errors/error_dialogs','@web/core/l10n/translation','@web/core/utils/hooks','@web/core/copy_button/copy_button','@web/core/utils/patch','@odoo/owl'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{ErrorDialog}=require("@web/core/errors/error_dialogs");const{_t}=require("@web/core/l10n/translation");const{useBus,useService}=require("@web/core/utils/hooks");const{CopyButton}=require("@web/core/copy_button/copy_button");const{patch}=require("@web/core/utils/patch");const{onWillStart}=require("@odoo/owl");patch(ErrorDialog.components,{CopyButton,});patch(ErrorDialog.prototype,{setup(){super.setup();this.orm=useService("orm");this.fileUpload=useService("file_upload");this.dialogService=useService("dialog");this.notification=useService("notification");this.state.tracebackUrl=null;this.state.processed=false;this.canUploadTraceback=false;useBus(this.fileUpload.bus,"FILE_UPLOAD_LOADED",async(ev)=>{if(ev.detail.upload.xhr.status===200&&this.state.processed){const response=JSON.parse(ev.detail.upload.xhr.response);if(response.length===1){this.state.tracebackUrl=response[0];setTimeout(async()=>{await browser.navigator.clipboard.writeText(response[0]);this.notification.add(_t("The document URL has been copied to your clipboard."),{type:"success"});});}}});onWillStart(async()=>{try{this.canUploadTraceback=await this.orm.call("documents.document","can_upload_traceback");}catch{this.canUploadTraceback=false;}});},shareTraceback(){if(!this.state.processed){this.state.processed=true;const file=new File([`${this.props.name}\n\n${this.props.message}\n\n${this.contextDetails}\n\n${
                        this.traceback || this.props.traceback
                    }`,],`${this.constructor.title} - ${luxon.DateTime.local().toFormat(
                    "yyyy-MM-dd HH:mm:ss"
                )}.txt`,{type:"text/plain"});this.fileUpload.upload("/documents/upload_traceback",[file],{});}},});return __exports;});;

/* /documents/static/src/components/documents_breadcrumbs.js */
odoo.define('@documents/components/documents_breadcrumbs',['@documents/views/cog_menu/documents_cog_menu','@web/search/breadcrumbs/breadcrumbs'],function(require){'use strict';let __exports={};const{DocumentsCogMenu}=require("@documents/views/cog_menu/documents_cog_menu");const{Breadcrumbs}=require("@web/search/breadcrumbs/breadcrumbs");const DocumentsBreadcrumbs=__exports.DocumentsBreadcrumbs=class DocumentsBreadcrumbs extends Breadcrumbs{static components={...Breadcrumbs.components,DocumentsCogMenu,};static template="documents.Breadcrumbs";}
return __exports;});;

/* /documents/static/src/components/documents_details_panel/documents_details_panel.js */
odoo.define('@documents/components/documents_details_panel/documents_details_panel',['@web/core/l10n/translation','@web/core/user','@web/core/utils/hooks','@web/core/utils/numbers','@web/views/fields/char/char_field','@web/views/fields/many2one_avatar/many2one_avatar_field','@web/views/fields/many2one/many2one_field','@documents/views/fields/documents_details_many2many_tags','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{formatFloat}=require("@web/core/utils/numbers");const{CharField}=require("@web/views/fields/char/char_field");const{Many2OneAvatarField}=require("@web/views/fields/many2one_avatar/many2one_avatar_field");const{Many2OneField}=require("@web/views/fields/many2one/many2one_field");const{DocumentsDetailsMany2ManyTagsField}=require("@documents/views/fields/documents_details_many2many_tags")
const{Component,onWillRender,reactive}=require("@odoo/owl");const COMPANY_ROOT_OWNER_ID=1;const DocumentsDetailsPanel=__exports.DocumentsDetailsPanel=class DocumentsDetailsPanel extends Component{static components={CharField,DocumentsDetailsMany2ManyTagsField,Many2OneAvatarField,Many2OneField,};static props={record:{type:Object,optional:true},nbViewItems:{type:Number,optional:true},};static template="documents.DocumentsDetailsPanel";setup(){this.action=useService("action");this.documentService=useService("document.document");this.orm=useService("orm");onWillRender(()=>{this.record=reactive(this.props.record||{},async()=>{if(this.props.record?.data?.type==="folder"){await this.env.searchModel._reloadSearchPanel();this.render();}});});}
async openLinkedRecord(){const{res_model,res_id}=this.record.data||{};if(!res_id?.resId||!res_model){return;}
return this.action.doAction({type:"ir.actions.act_window",res_id:res_id.resId,res_model,views:[[false,"form"]],target:"current",});}
get userPermissionViewOnly(){return(this.record.data?.user_permission!=="edit"||(!this.documentService.userIsDocumentManager&&this.record.data?.is_pinned_folder));}
get fileSize(){if(this.record.data?.type!=="folder"||this.props.record.isContainer){const nBytes=this.record.data.file_size||0;if(nBytes){return`${this.record.isContainer ? '~' : ''}${formatFloat(nBytes, { humanReadable: true })}B`;}}
return"";}
get rootFolderPlaceholder(){return this.props.record.data?.owner_id[0]===user.userId?_t("My Drive"):this.props.record.data?.owner_id[0]===COMPANY_ROOT_OWNER_ID?_t("Company"):_t("Shared with me");}}
return __exports;});;

/* /documents/static/src/components/documents_manage_versions_panel/documents_manage_versions_panel.js */
odoo.define('@documents/components/documents_manage_versions_panel/documents_manage_versions_panel',['@web/core/dialog/dialog','@web/core/l10n/translation','@web/core/utils/hooks','@odoo/owl','@web/core/l10n/dates','@web/core/network/download','@web/core/confirmation_dialog/confirmation_dialog'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{_t}=require("@web/core/l10n/translation");const{useBus,useService}=require("@web/core/utils/hooks");const{Component,onWillStart,useState,useRef}=require("@odoo/owl");const{formatDate,deserializeDate}=require("@web/core/l10n/dates");const{download}=require("@web/core/network/download");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const DocumentsManageVersions=__exports.DocumentsManageVersions=class DocumentsManageVersions extends Component{static components={Dialog,};static props={documentId:Number,close:Function,};static template="documents.ManageVersions";setup(){this.orm=useService("orm");this.dialog=useService("dialog");this.documentService=useService("document.document");this.fileUploadService=useService("file_upload");this.fileInputRef=useRef("uploadFileInput");this.formatDate=(d)=>formatDate(deserializeDate(d),{format:"HH:mm DDD"});this.state=useState({documentName:"",accessToken:"",versions:[]});onWillStart(async()=>await this.load());useBus(this.fileUploadService.bus,"FILE_UPLOAD_LOADED",async()=>await this.load());}
async load(){const attachmentFields={name:1,create_date:1,mimetype:1,create_uid:{fields:{name:1}},};const documentData=await this.orm.call("documents.document","web_read",[this.props.documentId,{name:1,access_token:1,user_permission:1,attachment_id:{fields:attachmentFields},previous_attachment_ids:{fields:attachmentFields},},]);Object.assign(this.state,{documentName:documentData[0].name,userPermission:documentData[0].user_permission,accessToken:documentData[0].access_token,versions:[documentData[0].attachment_id,...documentData[0].previous_attachment_ids],});}
get panelTitle(){return _t('Manage Versions of "%s"',this.state.documentName);}
onUploadNewVersion(){this.fileInputRef.el.click();}
async onReplace(ev){if(!ev.target.files.length){return;}
await this.documentService.uploadDocument(ev.target.files,this.state.accessToken,{});ev.target.value="";}
async onDownload(attachmentId){await download({data:{},url:`/web/content/${attachmentId}?download=true`,});}
async onDelete(attachmentId){return this.dialog.add(ConfirmationDialog,{body:_t("Are you sure you want to delete this attachment?"),confirmLabel:"Delete",confirm:async()=>{await this.orm.call("documents.document","action_delete_from_history",[this.props.documentId,attachmentId,]);await this.load();this.documentService.reload();},cancel:()=>{},});}}
return __exports;});;

/* /documents/static/src/components/documents_permission_panel/documents_access_expiration_date_btn.js */
odoo.define('@documents/components/documents_permission_panel/documents_access_expiration_date_btn',['@web/core/datetime/datetime_hook','@web/core/l10n/dates','@web/core/user','@odoo/owl'],function(require){'use strict';let __exports={};const{useDateTimePicker}=require("@web/core/datetime/datetime_hook");const{deserializeDateTime,today}=require("@web/core/l10n/dates");const{user}=require("@web/core/user");const{Component}=require("@odoo/owl");const DocumentsAccessExpirationDateBtn=__exports.DocumentsAccessExpirationDateBtn=class DocumentsAccessExpirationDateBtn extends Component{static defaultProps={editionMode:false};static props={accessPartner:Object,disabled:Boolean,setExpirationDate:Function,editionMode:{type:Boolean,optional:true},};static template="documents.AccessExpirationDateBtn";setup(){const pickerProps={type:"datetime",value:this.props.accessPartner.expiration_date?deserializeDateTime(this.props.accessPartner.expiration_date,{tz:user.context.tz,}):today(),};this.dateTimePicker=useDateTimePicker({target:`datetime-picker-target-${this.props.accessPartner.partner_id.id}`,onApply:(date)=>{this.props.setExpirationDate(this.props.accessPartner,date);},get pickerProps(){return pickerProps;},});}
onClickDateTimePickerBtn(){if(!this.props.disabled){this.dateTimePicker.open();}}}
return __exports;});;

/* /documents/static/src/components/documents_permission_panel/documents_access_settings.js */
odoo.define('@documents/components/documents_permission_panel/documents_access_settings',['@web/core/checkbox/checkbox','@web/core/l10n/translation','@documents/components/documents_permission_panel/documents_permission_select','@odoo/owl'],function(require){'use strict';let __exports={};const{CheckBox}=require("@web/core/checkbox/checkbox");const{_t}=require("@web/core/l10n/translation");const{DocumentsPermissionSelect}=require("@documents/components/documents_permission_panel/documents_permission_select");const{Component}=require("@odoo/owl");const accessProps={access_internal:String,access_via_link:String,is_access_via_link_hidden:Boolean,};const DocumentsAccessSettings=__exports.DocumentsAccessSettings=class DocumentsAccessSettings extends Component{static components={CheckBox,DocumentsPermissionSelect,};static props={access:accessProps,baseAccess:accessProps,disabled:Boolean,onChangeAccessInternal:Function,onChangeAccessLink:Function,onChangeIsAccessLinkHidden:Function,selections:Object,};static template="documents.AccessSettings";get accessInternalHelper(){if(this.props.access.access_internal==="view"){return _t("Internal users can view");}
if(this.props.access.access_internal==="edit"){return _t("Internal users can edit");}
return _t("Only people with access can open with the link");}
get accessLinkHelper(){if(this.props.access.access_via_link==="view"){return _t("Anyone on the internet with the link can view");}
if(this.props.access.access_via_link==="edit"){return _t("Anyone on the internet with the link can edit");}
return _t("No one on the internet can access");}
get errorAccessLinkEdit(){return undefined;}
get errorAccessInternalEdit(){return undefined;}}
return __exports;});;

/* /documents/static/src/components/documents_permission_panel/documents_member_invite.js */
odoo.define('@documents/components/documents_permission_panel/documents_member_invite',['@documents/components/documents_permission_panel/documents_permission_select','@web/core/dropdown/dropdown_item','@web/core/network/rpc','@web/core/utils/hooks','@web/core/utils/strings','@html_editor/utils/dom_info','@html_editor/wysiwyg','@mail/views/web/fields/html_mail_field/html_mail_field','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{DocumentsPermissionSelect,DocumentsPermissionSelectMenu,}=require("@documents/components/documents_permission_panel/documents_permission_select");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{rpcBus}=require("@web/core/network/rpc");const{useBus,useService}=require("@web/core/utils/hooks");const{isEmail}=require("@web/core/utils/strings");const{isEmpty}=require("@html_editor/utils/dom_info");const{Wysiwyg}=require("@html_editor/wysiwyg");const{HtmlMailField}=require("@mail/views/web/fields/html_mail_field/html_mail_field");const{_t}=require("@web/core/l10n/translation");const{Component,onWillUpdateProps,useState}=require("@odoo/owl");const cssRulesByElement=new WeakMap();const DocumentsMemberInvite=__exports.DocumentsMemberInvite=class DocumentsMemberInvite extends Component{static components={DocumentsPermissionSelect,DocumentsPermissionSelectMenu,DropdownItem,Wysiwyg,};static props={access:Object,accessPartners:Array,autoSave:Function,close:Function,selectedPartnersRole:String,invitePage:Boolean,disabled:Boolean,roles:Array,pendingSave:Boolean,showMainPage:Function,updateAccessRights:Function,};static template="documents.MemberInvite";setup(){this.actionService=useService("action");this.createdPartners={choices:[],values:[]};this.orm=useService("orm");this.state=useState({notify:true,fetchedPartners:[],selectedPartners:[],selectedPartnersRole:this.props.selectedPartnersRole,sharing:false,});const wysiwygPlaceholder=_t("Optional message...");this.wysiwyg={config:{content:`<p placeholder="${wysiwygPlaceholder}"><br/></p>`,placeholder:wysiwygPlaceholder,disableVideo:true,},editor:undefined,message:"",};useBus(rpcBus,"RPC:RESPONSE",this.responseCall);onWillUpdateProps((nextProps)=>{if(!nextProps.invitePage){this.state.selectedPartners=[];this.state.selectedPartnersRole=this.props.selectedPartnersRole;}});}
get noEditorMessage(){return undefined;}
async getPartners(domain=[],limit=4){const partners=await this.orm.call("res.partner","web_search_read",[],{domain:domain,specification:this._getPartnersSpecification(),limit:Math.max(limit,8),count_limit:1,});return partners.records.slice(0,limit);}
_getPartnersSpecification(){return{display_name:1,email:1};}
async createPartners(defaultName,andEdit=false){const onClose=async()=>{if(this.createdPartners.choices){this.state.fetchedPartners=this.state.fetchedPartners.concat(this.createdPartners.choices);this.state.selectedPartners=this.state.selectedPartners.concat(this.createdPartners.values);this.props.showMainPage(false);}};if(andEdit){return this.actionService.doActionButton({name:"action_create_members_to_invite",type:"object",resModel:"res.partner",buttonContext:{default_name:defaultName,dialog_size:"medium",},onClose,});}
const partnerId=await this.orm.call("res.partner","create",[{name:defaultName,email:defaultName,},]);if(partnerId){const createdPartners=await this.orm.webRead("res.partner",[partnerId],{specification:{name:1,email:1},});this._addCreatedPartners(createdPartners);}
await onClose();}
async onSearchPartners(search){const selectedPartners=this.state.fetchedPartners.filter((p)=>this.state.selectedPartners.includes(p.id));const partners=await this.getPartners([["id","!=",[...this.props.accessPartners.flatMap((a)=>(a.role?[a.partner_id.id]:[])),...selectedPartners.map((s)=>s.id),this.props.access.owner_id.partner_id?.id,],],"|",["name","ilike",search.trim()],["email","ilike",search.trim()],]);this.state.fetchedPartners=[...partners,...selectedPartners];}
matchPartners(partner){return`${partner.display_name} ${partner.email}`;}
onChangeRoleForMemberToInvite(event){this.state.selectedPartnersRole=event.target.selectedOptions[0].value;}
onSelectPartnerToInvite(values){this.state.selectedPartners=values;if(this.props.pendingSave){this.props.autoSave();}
if(!this.props.invitePage){this.props.showMainPage(false);}}
onClickNotify(){this.state.notify=!this.state.notify;}
async onShare(){const partners={};this.state.selectedPartners.forEach((p)=>(partners[p]=[this.state.selectedPartnersRole,false]));if(this.state.notify){await this.getFormattedWysiwygContent();}
this.state.sharing=true;await this.props.updateAccessRights(partners,this.state.notify,this.wysiwyg.message);await this.props.close();}
onDiscard(){this.state.notify=true;this.props.showMainPage(true);}
isEmail(value){return isEmail(value);}
onLoadWysiwyg(editor){this.wysiwyg.editor=editor;}
async getFormattedWysiwygContent(){const el=this.wysiwyg.editor.getElContent();await HtmlMailField.getInlinedEditorContent(cssRulesByElement,this.wysiwyg.editor,el);this.wysiwyg.message=isEmpty(el.firstChild)?"":this.wysiwyg.editor.getContent();}
responseCall({detail}){if(detail.result){if(detail.data.params.method==="web_save"&&detail.data.params.model==="res.partner"){this._addCreatedPartners(detail.result);}}}
_addCreatedPartners(createdPartners){this.createdPartners={choices:[],values:[]};for(const partner of createdPartners){this.createdPartners.choices.push(this._addCreatedPartnersValues(partner));this.createdPartners.values.push(partner.id);}}
_addCreatedPartnersValues(partner){return{id:partner.id,display_name:partner.name,email:partner.email,};}}
return __exports;});;

/* /documents/static/src/components/documents_permission_panel/documents_partner_access.js */
odoo.define('@documents/components/documents_permission_panel/documents_partner_access',['@documents/components/documents_permission_panel/documents_access_expiration_date_btn','@documents/components/documents_permission_panel/documents_permission_select','@documents/components/documents_permission_panel/documents_remove_partner_button','@web/core/l10n/dates','@web/core/user','@odoo/owl'],function(require){'use strict';let __exports={};const{DocumentsAccessExpirationDateBtn}=require("@documents/components/documents_permission_panel/documents_access_expiration_date_btn");const{DocumentsPermissionSelect}=require("@documents/components/documents_permission_panel/documents_permission_select");const{DocumentsRemovePartnerButton}=require("@documents/components/documents_permission_panel/documents_remove_partner_button");const{deserializeDateTime}=require("@web/core/l10n/dates");const{user}=require("@web/core/user");const{Component}=require("@odoo/owl");const DocumentsPartnerAccess=__exports.DocumentsPartnerAccess=class DocumentsPartnerAccess extends Component{static components={DocumentsAccessExpirationDateBtn,DocumentsPermissionSelect,DocumentsRemovePartnerButton,};static props={access:Object,accessPartners:Array,basePartnersRole:Object,basePartnersAccessExpDate:Object,isAdmin:Boolean,isInternalUser:Boolean,isCurrentUser:Function,disabled:Boolean,ownerUser:[Object,Boolean],onChangePartnerRole:Function,removeDocumentAccess:Function,selections:Array,setExpirationDate:Function,};static template="documents.PartnerAccess";noEditorMessage(partner){return undefined;}
getFormattedLocalExpirationDate(accessPartner){return deserializeDateTime(accessPartner.expiration_date,{tz:user.context.tz,}).setLocale(user.context.lang.replaceAll("_","-")).toLocaleString(luxon.DateTime.DATETIME_SHORT);}}
return __exports;});;

/* /documents/static/src/components/documents_permission_panel/documents_permission_panel.js */
odoo.define('@documents/components/documents_permission_panel/documents_permission_panel',['@web/core/copy_button/copy_button','@web/core/dialog/dialog','@documents/components/documents_permission_panel/documents_access_settings','@documents/components/documents_permission_panel/documents_member_invite','@documents/components/documents_permission_panel/documents_partner_access','@web/core/l10n/dates','@web/core/l10n/translation','@web/core/utils/hooks','@web/core/network/rpc','@web/core/user','@odoo/owl'],function(require){'use strict';let __exports={};const{CopyButton}=require("@web/core/copy_button/copy_button");const{Dialog}=require("@web/core/dialog/dialog");const{DocumentsAccessSettings}=require("@documents/components/documents_permission_panel/documents_access_settings");const{DocumentsMemberInvite}=require("@documents/components/documents_permission_panel/documents_member_invite");const{DocumentsPartnerAccess}=require("@documents/components/documents_permission_panel/documents_partner_access");const{serializeDateTime}=require("@web/core/l10n/dates");const{_t}=require("@web/core/l10n/translation");const{useBus,useService}=require("@web/core/utils/hooks");const{rpcBus}=require("@web/core/network/rpc");const{user}=require("@web/core/user");const{Component,onWillStart,useState}=require("@odoo/owl");const DocumentsPermissionPanel=__exports.DocumentsPermissionPanel=class DocumentsPermissionPanel extends Component{static components={CopyButton,Dialog,DocumentsAccessSettings,DocumentsMemberInvite,DocumentsPartnerAccess,};static props={document:{type:Object,shape:{id:Number,name:{type:String,optional:true},},},close:Function,onChangesSaved:{type:Function,optional:true},};static template="documents.PermissionPanel";setup(){this.actionService=useService("action");this.basePartnersRole={};this.createdPartners={choices:[],values:[]};this.dialog=useService("dialog");this.isAdmin=user.isAdmin;this.orm=useService("orm");this.documentService=useService("document.document");this.isInternalUser=this.documentService.userIsInternal;this.state=useState({loading:true,mainPage:true,didSave:false,});useBus(rpcBus,"RPC:RESPONSE",this.responseCall);onWillStart(async()=>{this.state.loading=true;await this.loadMainPage();this.state.loading=false;});}
get panelTitle(){return _t("Share: %(documentName)s",{documentName:this.state.access.display_name});}
get pendingSave(){return(Object.entries(this.baseAccess).some(([fieldName,value])=>this.state.access[fieldName]!==value)||this.partnersRoleIsDirty||this.partnersAccessExpDateIsDirty);}
get copyText(){return this.pendingSave?_t("Save or discard changes first"):_t("Copy Link");}
get warningMessage(){if(this.state.access.access_via_link==="edit"&&(this.state.access.access_internal==="view"||this.state.access.access_ids.some((a)=>a.role==="view"))){const documentType=this.state.access.type==="folder"?_t("folder"):_t("document");return _t("All users with access to this %(documentType)s or its parent will have edit permissions.",{documentType});}
return null;}
get partnersRoleIsDirty(){return this.state.access.access_ids.some((a)=>a.role!==this.basePartnersRole[a.id]);}
get partnersAccessExpDateIsDirty(){return this.state.access.access_ids.some((a)=>a.expiration_date!==this.basePartnersAccessExpDate[a.id]);}
revertChanges(){Object.assign(this.state.access,this.baseAccess);for(const[id,role]of Object.entries(this.basePartnersRole)){const accessPartner=this.state.access.access_ids.find((a)=>a.id===parseInt(id));accessPartner.role=role;accessPartner.expiration_date=this.basePartnersAccessExpDate[id];}}
showMainPage(value=true){this.state.mainPage=value;}
async save(){this.state.loading=true;const userPermission=await this.updateAccessRights();if(userPermission==="none"){await this.actionService.restore(this.actionService.currentController.jsId);return;}
await this.loadMainPage();this.state.loading=false;}
async loadMainPage(){const permissionsData=await this.orm.call("documents.document","permission_panel_data",[this.props.document.id,]);this.state.access=permissionsData.record;this.state.selections=permissionsData.selections;this.selectedPartnersRole=this.state.selections.doc_access_roles?this.state.selections.doc_access_roles[0][0]:"";this.baseAccess=Object.fromEntries(["access_internal","access_via_link","is_access_via_link_hidden"].map((fieldName)=>[fieldName,this.state.access[fieldName],]));this.basePartnersRole={};(this.state.access.access_ids||[]).forEach((a)=>(this.basePartnersRole[a.id]=a.role));this.basePartnersAccessExpDate={};(this.state.access.access_ids||[]).forEach((a)=>(this.basePartnersAccessExpDate[a.id]=a.expiration_date));}
async updateAccessRights(partners=undefined,notify=false,message=""){const accessValuesToSend=Object.fromEntries(Object.entries(this.baseAccess).map(([field,oldValue])=>[field,oldValue!==this.state.access[field]?this.state.access[field]:null,]));let partnersToUpdate=partners;if(this.partnersRoleIsDirty||this.partnersAccessExpDateIsDirty){partnersToUpdate=partnersToUpdate||{};this.state.access.access_ids.forEach((a)=>{const roleUpdated=a.role!==this.basePartnersRole[a.id];const expirationUpdated=a.expiration_date!==this.basePartnersAccessExpDate[a.id];if(roleUpdated||expirationUpdated){partnersToUpdate[a.partner_id.id]=[a.role,expirationUpdated?a.expiration_date:null,];}});}
const userPermission=(await this.orm.call("documents.document","action_update_access_rights",[[this.props.document.id],accessValuesToSend.access_internal,accessValuesToSend.access_via_link,accessValuesToSend.is_access_via_link_hidden,partnersToUpdate,notify,message,]))[0];this.state.didSave=true;return userPermission;}
removeDocumentAccess(accessPartner){accessPartner.role=false;this.state.partnersRoleIsDirty=true;}
isCurrentUser(accessPartner){return accessPartner.partner_id.id===user.partnerId;}
close(){if(this.state.didSave){this.props.onChangesSaved?.();}
this.props.close();}
onDiscard(){return this.pendingSave?this.revertChanges():this.close();}
onShare(){return this.pendingSave&&this.state.access.user_permission==="edit"?this.save():this.close();}
onChangeDocumentAccessInternal(event){this.state.access.access_internal=event.target.selectedOptions[0].value;}
onChangeDocumentAccessLink(event){this.state.access.access_via_link=event.target.selectedOptions[0].value;}
onChangeDocumentIsAccessLinkHidden(event){this.state.access.is_access_via_link_hidden=!!parseInt(event.target.value);}
onChangePartnerRole(event,accessPartner){accessPartner.role=event.target.selectedOptions[0].value;}
setExpirationDate(accessPartner,value){accessPartner.expiration_date=value?serializeDateTime(value):value;}
responseCall({detail}){if(detail.error&&detail.data.params.model==="documents.document"){this.state.mainPage=true;this.revertChanges();this.state.loading=false;}}}
return __exports;});;

/* /documents/static/src/components/documents_permission_panel/documents_permission_select.js */
odoo.define('@documents/components/documents_permission_panel/documents_permission_select',['@web/core/select_menu/select_menu','@odoo/owl'],function(require){'use strict';let __exports={};const{SelectMenu}=require("@web/core/select_menu/select_menu");const{Component}=require("@odoo/owl");const DocumentsPermissionSelect=__exports.DocumentsPermissionSelect=class DocumentsPermissionSelect extends Component{static defaultProps={ariaLabel:"Document permission select",disabled:false,};static props={ariaLabel:{type:String,optional:true},disabled:{type:Boolean,optional:true},label:{type:String,optional:true},labelHelper:{type:String,optional:true},options:Array,onChange:{type:Function,optional:true},selectClass:{type:String,optional:true},showFeedbackChange:{type:Boolean,optional:true},value:[String,Number,Boolean],noEditorMessage:{type:String,optional:true},};static template="documents.PermissionSelect";get selectClass(){return`${
            this.props.selectClass ? this.props.selectClass : this.props.label ? "w-75" : "w-50"
        } ${this.props.showFeedbackChange ? "border-primary" : ""}`;}}
const DocumentsPermissionSelectMenu=__exports.DocumentsPermissionSelectMenu=class DocumentsPermissionSelectMenu extends SelectMenu{static defaultProps={...super.defaultProps,hasColor:false,};static props={...super.props,buttonText:{type:String,optional:true},hasColor:{type:Boolean,optional:true},onOpen:{type:Function,optional:true},};static template="documents.PermissionSelectMenu";onStateChanged(open){super.onStateChanged(open);if(open){this.menuRef.el.querySelector("input").focus();this.props.onOpen?.();}}
get multiSelectChoices(){if(this.props.hasColor){const choices=[...this.props.choices,...this.props.groups.flatMap((g)=>g.choices),].filter((c)=>this.props.value.includes(c.value));return choices.map((c)=>{return{id:c.value,text:c.label,colorIndex:c.colorIndex,onDelete:()=>{const values=[...this.props.value];values.splice(values.indexOf(c.value),1);this.props.onSelect(values);},};});}
return super.multiSelectChoices;}}
return __exports;});;

/* /documents/static/src/components/documents_permission_panel/documents_remove_partner_button.js */
odoo.define('@documents/components/documents_permission_panel/documents_remove_partner_button',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const DocumentsRemovePartnerButton=__exports.DocumentsRemovePartnerButton=class DocumentsRemovePartnerButton extends Component{static defaultProps={disabled:false};static props={accessPartner:Object,disabled:{type:Boolean,optional:true},isInternalUser:Boolean,isCurrentUser:Function,removeAccess:Function,};static template="documents.RemovePartnerButton";}
return __exports;});;

/* /hr_holidays/static/src/components/float_time_selection/float_time_selection.js */
odoo.define('@hr_holidays/components/float_time_selection/float_time_selection',['@odoo/owl','@web/core/registry','@web/core/popover/popover_hook','@hr_holidays/components/float_time_selection/float_time_selection_popover','@web/views/fields/float_time/float_time_field'],function(require){'use strict';let __exports={};const{onWillStart,useState}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{usePopover}=require("@web/core/popover/popover_hook");const{FloatTimeSelectionPopover}=require("@hr_holidays/components/float_time_selection/float_time_selection_popover");const{FloatTimeField,floatTimeField}=require("@web/views/fields/float_time/float_time_field");function floatToHoursMinutes(floatValue){const hours=Math.floor(floatValue);const minutes=Math.round((floatValue-hours)*60);return{hours:String(hours).padStart(2,"0"),minutes:String(minutes).padStart(2,"0")};}
function hoursMinutesToFloat(hours,minutes){return parseInt(hours)+minutes/60;}
const FloatTimeSelectionField=__exports.FloatTimeSelectionField=class FloatTimeSelectionField extends FloatTimeField{static template="hr_holidays.FloatTimeSelectionField";static props={...FloatTimeField.props,};setup(){super.setup();this.popover=usePopover(FloatTimeSelectionPopover,{onClose:this.onClose.bind(this),});this.timeValues=useState({hours:"00",minutes:"00",floatValue:0,});onWillStart(()=>{const initialValue=this.props.record.data[this.props.name];const{hours,minutes}=floatToHoursMinutes(initialValue);this.timeValues.hours=hours;this.timeValues.minutes=minutes;this.timeValues.floatValue=initialValue;});}
onCharHoursClick(ev){ev.preventDefault();this.popover.open(ev.currentTarget,{timeValues:this.timeValues,onTimeChange:this.onTimeChange.bind(this),});setTimeout(()=>{this.inputFloatTimeRef.el.focus();},0);}
onTimeChange(newTimeValues){this.timeValues.hours=newTimeValues.hours;this.timeValues.minutes=newTimeValues.minutes;this.timeValues.floatValue=parseInt(newTimeValues.hours)+newTimeValues.minutes/60;}
handleInputChange(){this.popover.close();const inputValue=this.inputFloatTimeRef.el.value;const[hours,minutes]=inputValue.split(":").map(Number);if(!isNaN(hours)&&!isNaN(minutes)){this.timeValues.hours=String(hours).padStart(2,"0");this.timeValues.minutes=String(minutes).padStart(2,"0");this.timeValues.floatValue=hoursMinutesToFloat(hours,minutes);}else{const{hours,minutes}=floatToHoursMinutes(parseFloat(inputValue));this.timeValues.hours=hours;this.timeValues.minutes=minutes;this.timeValues.floatValue=parseFloat(inputValue);}}
onClose(){this.props.record.update({[this.props.name]:this.timeValues.floatValue});}}
const charHours=__exports.charHours={...floatTimeField,component:FloatTimeSelectionField,};registry.category("fields").add("float_time_selection",charHours);return __exports;});;

/* /hr_holidays/static/src/components/float_time_selection/float_time_selection_popover.js */
odoo.define('@hr_holidays/components/float_time_selection/float_time_selection_popover',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const numberRange=(min,max)=>[...Array(max-min)].map((_,i)=>i+min);const HOURS=numberRange(0,24).map((hour)=>[hour,String(hour)]);const MINUTES=numberRange(0,60).map((minute)=>[minute,String(minute||0).padStart(2,"0")]);const FloatTimeSelectionPopover=__exports.FloatTimeSelectionPopover=class FloatTimeSelectionPopover extends Component{static props={close:{type:Function},onTimeChange:{type:Function},timeValues:{type:Object,shape:{hours:"00",minutes:"00",floatValue:0,},},};static template="hr_holidays.FloatTimeSelectionPopover";setup(){this.availableHours=HOURS;this.availableMinutes=MINUTES;this.state=useState({selectedHours:this.props.timeValues.hours,selectedMinutes:this.props.timeValues.minutes,});}
onTimeChange(){this.props.onTimeChange({hours:this.state.selectedHours,minutes:this.state.selectedMinutes,});}}
return __exports;});;

/* /hr_holidays/static/src/components/hr_presence_status/hr_presence_status.js */
odoo.define('@hr_holidays/components/hr_presence_status/hr_presence_status',['@web/core/utils/patch','@hr/components/hr_presence_status/hr_presence_status','@hr/components/hr_presence_status_private/hr_presence_status_private'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{HrPresenceStatus}=require("@hr/components/hr_presence_status/hr_presence_status");const{HrPresenceStatusPrivate,hrPresenceStatusPrivate}=require("@hr/components/hr_presence_status_private/hr_presence_status_private");const patchHrPresenceStatus=()=>({get icon(){if(this.value.startsWith("presence_holiday")){return"fa-plane";}
return super.icon;},get color(){if(this.value.startsWith("presence_holiday")){return`${this.value === "presence_holiday_present" ? "text-success" : "o_icon_employee_absent"}`;}
return super.color;},});patch(HrPresenceStatus.prototype,patchHrPresenceStatus());patch(HrPresenceStatusPrivate.prototype,patchHrPresenceStatus());patch(HrPresenceStatusPrivate.prototype,{get label(){return this.props.record.data.current_leave_id?this.props.record.data.current_leave_id[1]:super.label;}});Object.assign(hrPresenceStatusPrivate,{fieldDependencies:[...(hrPresenceStatusPrivate.fieldDependencies||[]),{name:"current_leave_id",type:"many2one"}],});return __exports;});;

/* /hr_holidays/static/src/components/multi_time_off_generation_menu/multiple_time_off_generation_menu.js */
odoo.define('@hr_holidays/components/multi_time_off_generation_menu/multiple_time_off_generation_menu',['@odoo/owl','@web/core/registry','@web/core/user','@web/core/utils/hooks','@web/core/dropdown/dropdown_item','@web/search/action_menus/action_menus'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{STATIC_ACTIONS_GROUP_NUMBER}=require("@web/search/action_menus/action_menus");const cogMenuRegistry=registry.category("cogMenu");const MultiTimeOffGenerationMenu=__exports.MultiTimeOffGenerationMenu=class MultiTimeOffGenerationMenu extends Component{static template="hr_holidays.MultipleTimeOffGeneraion";static components={DropdownItem};static props={};setup(){this.action=useService("action");}
async openMatchingJobApplicants(){const resModel=this.env.searchModel.resModel;if(resModel==="hr.leave"){return this.action.doAction("hr_holidays.action_hr_leave_generate_multi_wizard");}else{return this.action.doAction("hr_holidays.action_hr_leave_allocation_generate_multi_wizard");}}}
const multiTimeOffGenerationMenu=__exports.multiTimeOffGenerationMenu={Component:MultiTimeOffGenerationMenu,groupNumber:STATIC_ACTIONS_GROUP_NUMBER,isDisplayed:async({config,searchModel})=>{return(config.viewType!=="form"&&["hr.leave","hr.leave.allocation"].includes(searchModel.resModel)&&(await user.hasGroup("hr_holidays.group_hr_holidays_user")));},};cogMenuRegistry.add("multi-time-off-generation-menu",multiTimeOffGenerationMenu,{sequence:11});return __exports;});;

/* /hr_holidays/static/src/dashboard/time_off_card.js */
odoo.define('@hr_holidays/dashboard/time_off_card',['@web/core/popover/popover_hook','@web/core/user','@hr_holidays/views/hooks','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{usePopover}=require("@web/core/popover/popover_hook");const{user}=require("@web/core/user");const{formatNumber,useNewAllocationRequest}=require("@hr_holidays/views/hooks");const{useService}=require("@web/core/utils/hooks");const{Component,onWillRender}=require("@odoo/owl");const TimeOffCardPopover=__exports.TimeOffCardPopover=class TimeOffCardPopover extends Component{static template="hr_holidays.TimeOffCardPopover";static props=["allocated","accrual_bonus","approved","planned","left","warning","closest","request_unit","exceeding_duration","close?","allows_negative","max_allowed_negative","onClickNewAllocationRequest?","errorLeaves","accrualExcess",];setup(){this.actionService=useService("action");}
async openLeaves(){this.actionService.doAction({type:"ir.actions.act_window",res_model:"hr.leave",views:[[false,"list"],[false,"form"],],domain:[["id","in",this.props.errorLeaves]],});}}
const TimeOffCard=__exports.TimeOffCard=class TimeOffCard extends Component{static template="hr_holidays.TimeOffCard";static props=["name","data","requires_allocation","employeeId","holidayStatusId"];setup(){this.popover=usePopover(TimeOffCardPopover,{position:"bottom",popoverClass:"bg-view",});this.newAllocationRequest=useNewAllocationRequest();this.lang=user.lang;this.formatNumber=formatNumber;const{data}=this.props;this.errorLeaves=Object.values(data.virtual_excess_data).map((data)=>data.leave_id);this.errorLeavesDuration=Object.values(data.virtual_excess_data).reduce((acc,data)=>acc+data.amount,0);this.updateWarning();onWillRender(this.updateWarning);}
updateWarning(){const{data}=this.props;const errorLeavesSignificant=data.allows_negative?this.errorLeavesDuration>data.max_allowed_negative:this.errorLeavesDuration>0;const accrualExcess=this.getAccrualExcess(data);const closeExpire=data.closest_allocation_duration&&data.closest_allocation_duration<data.virtual_remaining_leaves;this.warning=errorLeavesSignificant||accrualExcess||closeExpire;}
onClickInfo(ev){const{data}=this.props;this.popover.open(ev.target,{allocated:formatNumber(this.lang,data.max_leaves),accrual_bonus:formatNumber(this.lang,data.accrual_bonus),approved:formatNumber(this.lang,data.leaves_approved),planned:formatNumber(this.lang,data.leaves_requested),left:formatNumber(this.lang,data.virtual_remaining_leaves),warning:this.warning,closest:data.closest_allocation_duration,request_unit:data.request_unit,exceeding_duration:data.exceeding_duration,allows_negative:data.allows_negative,max_allowed_negative:data.max_allowed_negative,onClickNewAllocationRequest:this.newAllocationRequestFrom.bind(this),errorLeaves:this.errorLeaves,accrualExcess:this.getAccrualExcess(data),});}
getAccrualExcess(data){return data.allows_negative?-data.exceeding_duration>data.max_allowed_negative:-data.exceeding_duration>0;}
async newAllocationRequestFrom(){this.popover.close();await this.newAllocationRequest(this.props.employeeId,this.props.holidayStatusId);}}
const TimeOffCardMobile=__exports.TimeOffCardMobile=class TimeOffCardMobile extends TimeOffCard{static template="hr_holidays.TimeOffCardMobile";}
return __exports;});;

/* /hr_holidays/static/src/dashboard/time_off_dashboard.js */
odoo.define('@hr_holidays/dashboard/time_off_dashboard',['@hr_holidays/dashboard/time_off_card','@hr_holidays/views/hooks','@web/core/utils/hooks','@web/core/datetime/datetime_input','@odoo/owl'],function(require){'use strict';let __exports={};const{TimeOffCard}=require("@hr_holidays/dashboard/time_off_card");const{useNewAllocationRequest}=require("@hr_holidays/views/hooks");const{useBus,useService}=require("@web/core/utils/hooks");const{DateTimeInput}=require("@web/core/datetime/datetime_input");const{Component,useState,onWillStart}=require("@odoo/owl");const TimeOffDashboard=__exports.TimeOffDashboard=class TimeOffDashboard extends Component{static components={TimeOffCard,DateTimeInput};static template="hr_holidays.TimeOffDashboard";static props=["employeeId"];setup(){this.orm=useService("orm");this.actionService=useService("action");this.newRequest=useNewAllocationRequest();this.state=useState({date:luxon.DateTime.now(),today:luxon.DateTime.now(),holidays:[],allocationRequests:0,});useBus(this.env.timeOffBus,"update_dashboard",async()=>{await this.loadDashboardData();});onWillStart(async()=>{await this.loadDashboardData();const context=this.getContext();this.hasAccrualAllocation=await this.orm.call("hr.leave.type","has_accrual_allocation",[],{context:context,});});}
getContext(){const context={from_dashboard:true};if(this.props&&this.props.employeeId!==null){context["employee_id"]=this.props.employeeId;}
return context;}
async loadDashboardData(date=false){const context=this.getContext();if(date){this.state.date=date;}
this.state.holidays=await this.orm.call("hr.leave.type","get_allocation_data_request",[this.state.date,false],{context:context,});this.state.allocationRequests=await this.orm.call("hr.employee","get_allocation_requests_amount",[],{context:context,});}
async newAllocationRequest(){await this.newRequest(this.props.employeeId);}
resetDate(){this.state.date=luxon.DateTime.now();this.loadDashboardData();}
async openPendingRequests(){if(!this.state.allocationRequests){return;}
const action=await this.orm.call("hr.leave","open_pending_requests",[],{context:this.getContext(),});this.actionService.doAction(action);}}
return __exports;});;

/* /hr_holidays/static/src/js/accrual_levels_widget.js */
odoo.define('@hr_holidays/js/accrual_levels_widget',['@web/core/registry','@web/views/fields/x2many/x2many_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const AccrualLevelsX2ManyField=__exports.AccrualLevelsX2ManyField=class AccrualLevelsX2ManyField extends X2ManyField{static template="hr_holidays.AccrualLevelsX2ManyField";}
const accrualLevelsX2ManyField=__exports.accrualLevelsX2ManyField={...x2ManyField,component:AccrualLevelsX2ManyField,};registry.category("fields").add("accrual_levels_one2many",accrualLevelsX2ManyField);return __exports;});;

/* /hr_holidays/static/src/leave_stats/leave_stats.js */
odoo.define('@hr_holidays/leave_stats/leave_stats',['@web/core/registry','@web/core/utils/hooks','@web/model/relational_model/utils','@odoo/owl','@web/views/widgets/standard_widget_props'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{useRecordObserver}=require("@web/model/relational_model/utils");const{Component,useState,onWillStart}=require("@odoo/owl");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{DateTime}=luxon;const LeaveStatsComponent=__exports.LeaveStatsComponent=class LeaveStatsComponent extends Component{static template="hr_holidays.LeaveStatsComponent";static props={...standardWidgetProps};setup(){this.orm=useService("orm");this.state=useState({leaves:[],departmentLeaves:[],date:DateTime,department:null,employee:null,type:null,});this.state.date=this.props.record.data.date_from||DateTime.now();this.state.department=this.props.record.data.department_id;this.state.employee=this.props.record.data.employee_id;onWillStart(async()=>{await this.loadLeaves(this.state.date,this.state.employee);await this.loadDepartmentLeaves(this.state.date,this.state.department,this.state.employee);});useRecordObserver(async(record)=>{const dateFrom=record.data.date_from||DateTime.now();const dateChanged=!this.state.date.equals(dateFrom);const employee=record.data.employee_id;const department=record.data.department_id;const proms=[];if(dateChanged||(employee&&(this.state.employee&&this.state.employee[0])!==employee[0])){proms.push(this.loadLeaves(dateFrom,employee));}
if(dateChanged||(department&&(this.state.department&&this.state.department[0])!==department[0])){proms.push(this.loadDepartmentLeaves(dateFrom,department,employee));}
await Promise.all(proms);this.state.date=dateFrom;this.state.employee=employee;this.state.department=department;});}
get thisYear(){return this.state.date.toFormat("yyyy");}
async loadDepartmentLeaves(date,department,employee){if(!(department&&employee&&date)){this.state.departmentLeaves=[];return;}
const dateFrom=date.startOf("month");const dateTo=date.endOf("month");const departmentLeaves=await this.orm.searchRead("hr.leave",[["department_id","=",department[0]],["state","=","validate"],["date_from","<=",dateTo],["date_to",">=",dateFrom],],["employee_id","date_from","date_to","number_of_days","number_of_hours","leave_type_request_unit",]);this.state.departmentLeaves=departmentLeaves.map((leave)=>{const dateFormat=leave.leave_type_request_unit==="hour"?{...DateTime.TIME_24_SIMPLE,year:"numeric",month:"2-digit",day:"2-digit",}:{year:"numeric",month:"2-digit",day:"2-digit",};return Object.assign({},leave,{dateFrom:DateTime.fromSQL(leave.date_from,{zone:"utc"}).toLocal().toLocaleString(dateFormat),dateTo:DateTime.fromSQL(leave.date_to,{zone:"utc"}).toLocal().toLocaleString(dateFormat),sameEmployee:leave.employee_id[0]===employee[0],});});}
async loadLeaves(date,employee){if(!(employee&&date)){this.state.leaves=[];return;}
const dateFrom=date.startOf("year");const dateTo=date.endOf("year");this.state.leaves=await this.orm.readGroup("hr.leave",[["employee_id","=",employee[0]],["state","=","validate"],["date_from","<=",dateTo],["date_to",">=",dateFrom],],["holiday_status_id","number_of_days","number_of_hours","leave_type_request_unit:array_agg",],["holiday_status_id"]);}}
const leaveStatsComponent=__exports.leaveStatsComponent={component:LeaveStatsComponent,};registry.category("view_widgets").add("hr_leave_stats",leaveStatsComponent);return __exports;});;

/* /hr_holidays/static/src/persona_model_patch.js */
odoo.define('@hr_holidays/persona_model_patch',['@mail/core/common/persona_model','@web/core/l10n/dates','@web/core/l10n/translation','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Persona}=require("@mail/core/common/persona_model");const{deserializeDateTime}=require("@web/core/l10n/dates");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{DateTime}=luxon;patch(Persona.prototype,{get outOfOfficeText(){if(!this.out_of_office_date_end){return"";}
const date=deserializeDateTime(this.out_of_office_date_end);const fdate=date.toLocaleString(DateTime.DATE_MED);return _t("Back on %s",fdate);},});return __exports;});;

/* /hr_holidays/static/src/radio_image_field/radio_image_field.js */
odoo.define('@hr_holidays/radio_image_field/radio_image_field',['@web/core/registry','@web/views/fields/radio/radio_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{RadioField,radioField}=require("@web/views/fields/radio/radio_field");class RadioImageField extends RadioField{static template="hr_holidays.RadioImageField";}
registry.category("fields").add("hr_holidays_radio_image",{...radioField,component:RadioImageField,});return __exports;});;

/* /hr_holidays/static/src/store_service_patch.js */
odoo.define('@hr_holidays/store_service_patch',['@mail/core/common/store_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Store}=require("@mail/core/common/store_service");const{patch}=require("@web/core/utils/patch");const storeServicePatch={get onlineMemberStatuses(){return super.onlineMemberStatuses+["leave_online","leave_away"];},};patch(Store.prototype,storeServicePatch);return __exports;});;

/* /hr_holidays/static/src/tours/hr_holidays_tour.js */
odoo.define('@hr_holidays/tours/hr_holidays_tour',['@web/core/l10n/translation','@web/core/registry','@web_tour/tour_service/tour_utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{stepUtils}=require("@web_tour/tour_service/tour_utils");const leaveType="NotLimitedHR";const leaveDateFrom="01/17/2022";const leaveDateTo="01/17/2022";const description="Days off";registry.category("web_tour.tours").add("hr_holidays_tour",{url:"/odoo",steps:()=>[stepUtils.showAppsMenuItem(),{trigger:'.o_app[data-menu-xmlid="hr_holidays.menu_hr_holidays_root"]',content:_t("Let's discover the Time Off application"),tooltipPosition:"bottom",run:"click",},{trigger:"button.btn-time-off",content:_t("Click on any date or on this button to request a time-off"),tooltipPosition:"bottom",run:"click",},{trigger:'div[name="holiday_status_id"] input',content:_t("Let's try to create a Sick Time Off, select it in the list"),run:`edit ${leaveType.slice(0, leaveType.length - 1)}`,},{isActive:["auto"],trigger:`.ui-autocomplete .ui-menu-item a:contains("${leaveType}")`,run:"click",},{trigger:`.o_field_widget[name='holiday_status_id'] input:value("${leaveType}")`,},{trigger:"input[data-field=request_date_from]",content:_t("You can select the period you need to take off, from start date to end date"),tooltipPosition:"right",run:`edit ${leaveDateFrom}`,},{trigger:"input[data-field=request_date_to]",content:_t("You can select the period you need to take off, from start date to end date"),tooltipPosition:"right",run:`edit ${leaveDateTo}`,},{trigger:'div[name="name"] textarea',content:_t("Add some description for the people that will validate it"),run:`edit ${description}`,tooltipPosition:"right",},{trigger:`button:contains(${_t("Save")})`,content:_t("Submit your request"),tooltipPosition:"bottom",run:"click",},{trigger:'button[data-menu-xmlid="hr_holidays.menu_hr_holidays_management"]',content:_t("Let's go validate it"),tooltipPosition:"bottom",run:"click",},{trigger:'a[data-menu-xmlid="hr_holidays.menu_open_department_leave_approve"]',content:_t("Select Time Off"),tooltipPosition:"right",run:"click",},{tooltipPosition:"bottom",content:_t("Select the request you just created"),trigger:"table.o_list_table tr.o_data_row:eq(0)",run:"click",},{trigger:'button[name="action_approve"]',content:_t("Let's approve it"),tooltipPosition:"bottom",run:"click",},{trigger:`tr.o_data_row:first:not(:has(button[name="action_approve"])),table tbody:not(tr.o_data_row)`,content:"Verify leave is approved",},],});return __exports;});;

/* /hr_holidays/static/src/views/calendar/calendar_controller.js */
odoo.define('@hr_holidays/views/calendar/calendar_controller',['@web/core/l10n/translation','@web/core/confirmation_dialog/confirmation_dialog','@web/views/calendar/calendar_controller','@web/views/view_dialogs/form_view_dialog','@web/core/dropdown/dropdown','@web/core/l10n/dates','@hr_holidays/views/calendar/filter_panel/calendar_filter_panel','@hr_holidays/views/view_dialog/form_view_dialog','@hr_holidays/views/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{CalendarController}=require("@web/views/calendar/calendar_controller");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");const{Dropdown,DropdownItem}=require("@web/core/dropdown/dropdown");const{serializeDate}=require("@web/core/l10n/dates");const{TimeOffCalendarFilterPanel}=require("@hr_holidays/views/calendar/filter_panel/calendar_filter_panel");const{TimeOffFormViewDialog}=require("@hr_holidays/views/view_dialog/form_view_dialog");const{useLeaveCancelWizard}=require("@hr_holidays/views/hooks");const{EventBus,useSubEnv}=require("@odoo/owl");const TimeOffCalendarController=__exports.TimeOffCalendarController=class TimeOffCalendarController extends CalendarController{static components={...TimeOffCalendarController.components,Dropdown,DropdownItem,FilterPanel:TimeOffCalendarFilterPanel,};static template="hr_holidays.CalendarController";setup(){super.setup();useSubEnv({timeOffBus:new EventBus(),});this.leaveCancelWizard=useLeaveCancelWizard();}
get employeeId(){return this.model.employeeId;}
get filterPanelProps(){return{...super.filterPanelProps,employee_id:this.employeeId,};}
newTimeOffRequest(){const context={};if(this.employeeId){context["default_employee_id"]=this.employeeId;}
if(this.model.meta.scale=="day"){context["default_date_from"]=serializeDate(this.model.data.range.start.set({hours:7}),"datetime");context["default_date_to"]=serializeDate(this.model.data.range.end.set({hours:19}),"datetime");}
this.displayDialog(FormViewDialog,{resModel:"hr.leave",title:_t("New Time Off"),viewId:this.model.formViewId,onRecordSaved:()=>{this.model.load();this.env.timeOffBus.trigger("update_dashboard");},context:context,});}
_deleteRecord(resId,canCancel){if(!canCancel){this.displayDialog(ConfirmationDialog,{title:_t("Confirmation"),body:_t("Are you sure you want to delete this record?"),confirm:async()=>{await this.model.unlinkRecord(resId);this.env.timeOffBus.trigger("update_dashboard");},cancel:()=>{},});}else{this.leaveCancelWizard(resId,()=>{this.model.load();this.env.timeOffBus.trigger("update_dashboard");});}}
deleteRecord(record){this._deleteRecord(record.id,record.rawRecord.can_cancel);}
async editRecord(record,context={},shouldFetchFormViewId=true){const onDialogClosed=()=>{this.model.load();this.env.timeOffBus.trigger("update_dashboard");};return new Promise((resolve)=>{this.displayDialog(TimeOffFormViewDialog,{resModel:this.model.resModel,resId:record.id||false,context,title:_t("Time Off Request"),viewId:this.model.formViewId,onRecordSaved:onDialogClosed,onRecordDeleted:(record)=>this._deleteRecord(record.resId,record.data.can_cancel),onLeaveCancelled:onDialogClosed,size:"md",},{onClose:()=>resolve()});});}}
return __exports;});;

/* /hr_holidays/static/src/views/calendar/calendar_model.js */
odoo.define('@hr_holidays/views/calendar/calendar_model',['@web/views/calendar/calendar_model','@web/core/l10n/dates'],function(require){'use strict';let __exports={};const{CalendarModel}=require('@web/views/calendar/calendar_model');const{deserializeDate,deserializeDateTime,serializeDate,serializeDateTime,}=require("@web/core/l10n/dates");const TimeOffCalendarModel=__exports.TimeOffCalendarModel=class TimeOffCalendarModel extends CalendarModel{setup(params,services){super.setup(params,services);this.data.mandatoryDays={};if(this.env.isSmall){this.meta.scale='month';}}
normalizeRecord(rawRecord){let result=super.normalizeRecord(...arguments);if(rawRecord.employee_id){const employee=rawRecord.employee_id[1];if(!result.title.startsWith(employee)){result.title=[employee,result.title].join(' ');}}
return result;}
makeContextDefaults(record){const context=super.makeContextDefaults(record);if(this.employeeId){context["default_employee_id"]=this.employeeId;}
function deserialize(str){return str.length>10?deserializeDateTime(str):deserializeDate(str);}
if("default_date_from"in context){context["default_date_from"]=serializeDateTime(deserialize(context["default_date_from"]).set({hours:7}));}
if("default_date_to"in context){context["default_date_to"]=serializeDateTime(deserialize(context["default_date_to"]).set({hours:19}));}
return context;}
async updateData(data){await super.updateData(data);data.mandatoryDays=await this.fetchMandatoryDays(data);}
fetchUnusualDays(data){return this.orm.call(this.meta.resModel,"get_unusual_days",[serializeDateTime(data.range.start),serializeDateTime(data.range.end),],{context:{'employee_id':this.employeeId,}});}
async fetchMandatoryDays(data){return this.orm.call("hr.employee","get_mandatory_days",[this.employeeId,serializeDate(data.range.start,"datetime"),serializeDate(data.range.end,"datetime"),]);}
get mandatoryDays(){return this.data.mandatoryDays;}
get employeeId(){return this.meta.context.employee_id&&this.meta.context.employee_id[0]||null;}
fetchRecords(data){const{fieldNames,resModel}=this.meta;const context={};if(!this.employeeId){context['short_name']=1;}
return this.orm.searchRead(resModel,this.computeDomain(data),fieldNames,{context});}
computeDomain(data){return[...super.computeDomain(data),['state','!=','cancel'],]}}
return __exports;});;

/* /hr_holidays/static/src/views/calendar/calendar_renderer.js */
odoo.define('@hr_holidays/views/calendar/calendar_renderer',['@web/views/calendar/calendar_renderer','@hr_holidays/views/calendar/common/calendar_common_renderer','@hr_holidays/views/calendar/year/calendar_year_renderer','@hr_holidays/dashboard/time_off_dashboard'],function(require){'use strict';let __exports={};const{CalendarRenderer}=require('@web/views/calendar/calendar_renderer');const{TimeOffCalendarCommonRenderer}=require("@hr_holidays/views/calendar/common/calendar_common_renderer");const{TimeOffCalendarYearRenderer}=require("@hr_holidays/views/calendar/year/calendar_year_renderer");const{TimeOffDashboard}=require("@hr_holidays/dashboard/time_off_dashboard");const TimeOffCalendarRenderer=__exports.TimeOffCalendarRenderer=class TimeOffCalendarRenderer extends CalendarRenderer{static template="hr_holidays.CalendarRenderer";static components={...TimeOffCalendarRenderer.components,day:TimeOffCalendarCommonRenderer,week:TimeOffCalendarCommonRenderer,month:TimeOffCalendarCommonRenderer,year:TimeOffCalendarYearRenderer,TimeOffDashboard,};get employeeId(){return this.props.model.employeeId;}
get showDashboard(){return false;}}
const TimeOffDashboardCalendarRenderer=__exports.TimeOffDashboardCalendarRenderer=class TimeOffDashboardCalendarRenderer extends TimeOffCalendarRenderer{get showDashboard(){return!this.env.isSmall;}}
return __exports;});;

/* /hr_holidays/static/src/views/calendar/calendar_view.js */
odoo.define('@hr_holidays/views/calendar/calendar_view',['@web/views/calendar/calendar_view','@hr_holidays/views/calendar/calendar_controller','@hr_holidays/views/calendar/calendar_model','@hr_holidays/views/calendar/calendar_renderer','@web/core/registry'],function(require){'use strict';let __exports={};const{calendarView}=require('@web/views/calendar/calendar_view');const{TimeOffCalendarController}=require("@hr_holidays/views/calendar/calendar_controller");const{TimeOffCalendarModel}=require("@hr_holidays/views/calendar/calendar_model");const{TimeOffCalendarRenderer,TimeOffDashboardCalendarRenderer}=require("@hr_holidays/views/calendar/calendar_renderer");const{registry}=require('@web/core/registry');const TimeOffCalendarView={...calendarView,Controller:TimeOffCalendarController,Renderer:TimeOffCalendarRenderer,Model:TimeOffCalendarModel,}
registry.category('views').add('time_off_calendar',TimeOffCalendarView);registry.category('views').add('time_off_calendar_dashboard',{...TimeOffCalendarView,Renderer:TimeOffDashboardCalendarRenderer,});return __exports;});;

/* /hr_holidays/static/src/views/calendar/common/calendar_common_popover.js */
odoo.define('@hr_holidays/views/calendar/common/calendar_common_popover',['@web/views/calendar/calendar_common/calendar_common_popover','@odoo/owl','@web/core/user','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{CalendarCommonPopover}=require("@web/views/calendar/calendar_common/calendar_common_popover");const{onWillStart}=require("@odoo/owl");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const TimeOffCalendarCommonPopover=__exports.TimeOffCalendarCommonPopover=class TimeOffCalendarCommonPopover extends CalendarCommonPopover{static subTemplates={...CalendarCommonPopover.subTemplates,footer:"hr_holidays.TimeOffCalendarCommonPopover.footer",};setup(){super.setup();this.orm=useService("orm");this.viewType="calendar";onWillStart(async()=>{this.record=this.props.record.rawRecord;this.state=this.record.state;this.isManager=(await user.hasGroup("hr_holidays.group_hr_holidays_user"))||this.record.leave_manager_id?.[0]===user.userId;});}
get isEventDeletable(){return this.props.record.rawRecord.can_cancel||this.state&&!['validate','refuse','cancel'].includes(this.state);}
get isEventEditable(){return this.state!==undefined;}
async onClickButton(ev){const args=(ev.target.name==="action_approve")?[this.record.id,false]:[this.record.id];await this.orm.call("hr.leave",ev.target.name,args);await this.props.model.load();this.props.close();}}
return __exports;});;

/* /hr_holidays/static/src/views/calendar/common/calendar_common_renderer.js */
odoo.define('@hr_holidays/views/calendar/common/calendar_common_renderer',['@web/views/calendar/calendar_common/calendar_common_renderer','@hr_holidays/views/hooks','@hr_holidays/views/calendar/common/calendar_common_popover'],function(require){'use strict';let __exports={};const{CalendarCommonRenderer}=require('@web/views/calendar/calendar_common/calendar_common_renderer');const{useMandatoryDays}=require("@hr_holidays/views/hooks");const{TimeOffCalendarCommonPopover}=require("@hr_holidays/views/calendar/common/calendar_common_popover");const TimeOffCalendarCommonRenderer=__exports.TimeOffCalendarCommonRenderer=class TimeOffCalendarCommonRenderer extends CalendarCommonRenderer{static components={...TimeOffCalendarCommonRenderer,Popover:TimeOffCalendarCommonPopover,};setup(){super.setup();this.mandatoryDays=useMandatoryDays(this.props);}
getDayCellClassNames(info){return[...super.getDayCellClassNames(info),...this.mandatoryDays(info)];}}
return __exports;});;

/* /hr_holidays/static/src/views/calendar/filter_panel/calendar_filter_panel.js */
odoo.define('@hr_holidays/views/calendar/filter_panel/calendar_filter_panel',['@web/views/calendar/filter_panel/calendar_filter_panel','@hr_holidays/dashboard/time_off_card','@web/views/calendar/utils','@web/core/utils/hooks','@web/core/l10n/dates','@odoo/owl'],function(require){'use strict';let __exports={};const{CalendarFilterPanel}=require("@web/views/calendar/filter_panel/calendar_filter_panel");const{TimeOffCardMobile}=require("@hr_holidays/dashboard/time_off_card");const{getFormattedDateSpan}=require("@web/views/calendar/utils");const{useService}=require("@web/core/utils/hooks");const{serializeDate}=require("@web/core/l10n/dates");const{useState,onWillStart,onWillUpdateProps}=require("@odoo/owl");const TimeOffCalendarFilterPanel=__exports.TimeOffCalendarFilterPanel=class TimeOffCalendarFilterPanel extends CalendarFilterPanel{static template="hr_holidays.CalendarFilterPanel";static components={...TimeOffCalendarFilterPanel.components,TimeOffCardMobile,};static props={...CalendarFilterPanel.props,employee_id:[Number,{value:null}],};static subTemplates={filter:"hr_holidays.CalendarFilterPanel.filter",};setup(){super.setup();this.orm=useService("orm");this.getFormattedDateSpan=getFormattedDateSpan;this.leaveState=useState({holidays:[],mandatoryDays:[],bankHolidays:[],});onWillStart(async()=>{await this.loadFilterData();await this.updateSpecialDays();});onWillUpdateProps(this.updateSpecialDays);}
async updateSpecialDays(){const context={employee_id:this.props.employee_id,};const specialDays=await this.orm.call("hr.employee","get_special_days_data",[serializeDate(this.props.model.rangeStart,"datetime"),serializeDate(this.props.model.rangeEnd,"datetime"),],{context:context,});specialDays["bankHolidays"].forEach((bankHoliday)=>{bankHoliday.start=luxon.DateTime.fromISO(bankHoliday.start);bankHoliday.end=luxon.DateTime.fromISO(bankHoliday.end);});specialDays["mandatoryDays"].forEach((mandatoryDay)=>{mandatoryDay.start=luxon.DateTime.fromISO(mandatoryDay.start);mandatoryDay.end=luxon.DateTime.fromISO(mandatoryDay.end);});this.leaveState.bankHolidays=specialDays["bankHolidays"];this.leaveState.mandatoryDays=specialDays["mandatoryDays"];}
async loadFilterData(){if(!this.env.isSmall){return;}
const filterData={};const data=await this.orm.call("hr.leave.type","get_allocation_data_request",[]);data.forEach((leave)=>{filterData[leave[3]]=leave;});this.leaveState.holidays=filterData;}}
return __exports;});;

/* /hr_holidays/static/src/views/calendar/year/calendar_year_popover.js */
odoo.define('@hr_holidays/views/calendar/year/calendar_year_popover',['@web/core/dialog/dialog','@web/views/calendar/calendar_year/calendar_year_popover'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{CalendarYearPopover}=require("@web/views/calendar/calendar_year/calendar_year_popover");const TimeOffCalendarYearPopover=__exports.TimeOffCalendarYearPopover=class TimeOffCalendarYearPopover extends CalendarYearPopover{static components={Dialog};static template="web.CalendarYearPopover";static subTemplates={...CalendarYearPopover.subTemplates,body:"hr_holidays.MandatoryDayCalendarYearPopover.body",};}
return __exports;});;

/* /hr_holidays/static/src/views/calendar/year/calendar_year_renderer.js */
odoo.define('@hr_holidays/views/calendar/year/calendar_year_renderer',['@web/views/calendar/calendar_year/calendar_year_renderer','@web/core/utils/hooks','@hr_holidays/views/hooks','@web/views/calendar/hooks','@hr_holidays/views/calendar/year/calendar_year_popover','@odoo/owl'],function(require){'use strict';let __exports={};const{CalendarYearRenderer}=require("@web/views/calendar/calendar_year/calendar_year_renderer");const{useService}=require("@web/core/utils/hooks");const{useMandatoryDays}=require("@hr_holidays/views/hooks");const{useCalendarPopover}=require("@web/views/calendar/hooks");const{TimeOffCalendarYearPopover}=require("@hr_holidays/views/calendar/year/calendar_year_popover");const{useEffect}=require("@odoo/owl");const TimeOffCalendarYearRenderer=__exports.TimeOffCalendarYearRenderer=class TimeOffCalendarYearRenderer extends CalendarYearRenderer{setup(){super.setup();this.orm=useService("orm");this.mandatoryDays=useMandatoryDays(this.props);this.mandatoryDaysList=[];this.mandatoryDayPopover=useCalendarPopover(TimeOffCalendarYearPopover);useEffect((el)=>{for(const lastWeek of el){if(!lastWeek.querySelector("[data-date]")){lastWeek.remove();}}},()=>[this.rootRef.el&&this.rootRef.el.querySelectorAll(".fc-scrollgrid-sync-table tr:nth-child(6)"),]);}
get options(){return Object.assign(super.options,{weekNumbers:true,});}
get customOptions(){return{...super.customOptions,weekNumbersWithinDays:false,};}
async onDateClick(info){const is_mandatory_day=[...info.dayEl.classList].some((elClass)=>elClass.startsWith("hr_mandatory_day_"));this.mandatoryDayPopover.close();if(is_mandatory_day&&!this.env.isSmall){this.popover.close();const date=luxon.DateTime.fromISO(info.dateStr);const target=info.dayEl;const mandatory_days_data=await this.orm.call("hr.employee","get_mandatory_days_data",[date,date]);mandatory_days_data.forEach((mandatory_day_data)=>{mandatory_day_data["start"]=luxon.DateTime.fromISO(mandatory_day_data["start"]);mandatory_day_data["end"]=luxon.DateTime.fromISO(mandatory_day_data["end"]);});const records=Object.values(this.props.model.records).filter((r)=>luxon.Interval.fromDateTimes(r.start.startOf("day"),r.end.endOf("day")).contains(date));const props=this.getPopoverProps(date,records);props["records"]=mandatory_days_data.concat(props["records"]);this.mandatoryDayPopover.open(target,props,"o_cw_popover");}else{super.onDateClick(info);}}
getDayCellClassNames(info){return[...super.getDayCellClassNames(info),...this.mandatoryDays(info)];}}
return __exports;});;

/* /hr_holidays/static/src/views/hooks.js */
odoo.define('@hr_holidays/views/hooks',['@web/core/l10n/translation','@web/core/utils/hooks','@web/views/view_dialogs/form_view_dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService,useOwnedDialogs}=require("@web/core/utils/hooks");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");const{useComponent}=require("@odoo/owl");__exports.formatNumber=formatNumber;function formatNumber(lang,number,maxDecimals=2){const numberFormat=new Intl.NumberFormat(lang,{maximumFractionDigits:maxDecimals});return numberFormat.format(number);}
__exports.useMandatoryDays=useMandatoryDays;function useMandatoryDays(props){return(info)=>{const date=luxon.DateTime.fromJSDate(info.date).toISODate();const mandatoryDay=props.model.mandatoryDays[date];if(mandatoryDay){return[`hr_mandatory_day hr_mandatory_day_${mandatoryDay}`];}
return[];};}
__exports.useLeaveCancelWizard=useLeaveCancelWizard;function useLeaveCancelWizard(){const action=useService("action");return(leaveId,callback)=>{action.doAction({name:_t("Cancel Time Off"),type:"ir.actions.act_window",res_model:"hr.holidays.cancel.leave",target:"new",views:[[false,"form"]],context:{default_leave_id:leaveId,},},{onClose:callback,});};}
__exports.useNewAllocationRequest=useNewAllocationRequest;function useNewAllocationRequest(){const addDialog=useOwnedDialogs();const component=useComponent();return async(employeeId,holidayStatusId)=>{const context={form_view_ref:"hr_holidays.hr_leave_allocation_view_form_dashboard",is_employee_allocation:true,};if(employeeId){context["default_employee_id"]=employeeId;context["form_view_ref"]="hr_holidays.hr_leave_allocation_view_form_manager_dashboard";}
if(holidayStatusId){context["default_holiday_status_id"]=holidayStatusId;}
addDialog(FormViewDialog,{resModel:"hr.leave.allocation",title:_t("New Allocation"),context:context,onRecordSaved:()=>{component.env.timeOffBus.trigger("update_dashboard");},});};}
return __exports;});;

/* /hr_holidays/static/src/views/view_dialog/form_view_dialog.js */
odoo.define('@hr_holidays/views/view_dialog/form_view_dialog',['@web/views/view_dialogs/form_view_dialog','@web/core/registry','@web/core/utils/hooks','@web/views/form/form_view','@web/views/form/form_controller','@hr_holidays/views/hooks'],function(require){'use strict';let __exports={};const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{formView}=require("@web/views/form/form_view");const{FormController}=require("@web/views/form/form_controller");const{useLeaveCancelWizard}=require("@hr_holidays/views/hooks");const TimeOffDialogFormController=__exports.TimeOffDialogFormController=class TimeOffDialogFormController extends FormController{static props={...FormController.props,onCancelLeave:Function,onRecordDeleted:Function,onLeaveCancelled:Function,onLeaveUpdated:Function,};setup(){super.setup();this.leaveCancelWizard=useLeaveCancelWizard();this.orm=useService("orm");}
get record(){return this.model.root;}
async onClick(action){const args=action==="action_approve"?[this.record.resId,false]:[this.record.resId];await this.orm.call("hr.leave",action,args);this.props.onLeaveUpdated();}
get canApprove(){return(!this.model.root.isNew&&this.record.data.can_approve&&["confirm","refuse"].includes(this.record.data.state));}
get canValidate(){return(!this.model.root.isNew&&this.record.data.can_approve&&this.record.data.state==="validate1");}
get canRefuse(){return(!this.model.root.isNew&&this.record.data.can_approve&&this.record.data.state&&["confirm","validate1","validate"].includes(this.record.data.state));}
deleteRecord(){this.props.onRecordDeleted(this.record);this.props.onCancelLeave();}
cancelRecord(){this.deleteRecord();this.leaveCancelWizard(this.record.resId,()=>{this.props.onLeaveCancelled();});}
get canCancel(){return!this.model.root.isNew&&this.record.data.can_cancel;}
get canDelete(){return(!this.canCancel&&!this.model.root.isNew&&this.record.data.state&&!["validate","refuse","cancel"].includes(this.record.data.state));}}
registry.category("views").add("timeoff_dialog_form",{...formView,Controller:TimeOffDialogFormController,});const TimeOffFormViewDialog=__exports.TimeOffFormViewDialog=class TimeOffFormViewDialog extends FormViewDialog{static props={...TimeOffFormViewDialog.props,onRecordDeleted:Function,onLeaveCancelled:Function,};setup(){super.setup();this.viewProps=Object.assign(this.viewProps,{jsClass:"timeoff_dialog_form",buttonTemplate:"hr_holidays.FormViewDialog.buttons",onCancelLeave:()=>{this.props.close();},onLeaveUpdated:()=>{this.props.onRecordSaved();this.props.close();},onRecordDeleted:(record)=>{this.props.onRecordDeleted(record);},onLeaveCancelled:this.props.onLeaveCancelled.bind(this),});}}
return __exports;});;

/* /hr_recruitment/static/src/applicant_char/applicant_char.js */
odoo.define('@hr_recruitment/applicant_char/applicant_char',['@web/views/fields/char/char_field','@web/core/registry','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{CharField,charField}=require("@web/views/fields/char/char_field");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const ApplicantCharField=__exports.ApplicantCharField=class ApplicantCharField extends CharField{static template="hr_recruitment.ApplicantCharField";setup(){super.setup();this.action=useService("action");}
onClick(){const record=this.props.record.data;if(record.res_id&&record.res_model=='hr.applicant'){this.action.doAction({type:'ir.actions.act_window',res_model:'hr.applicant',res_id:record.res_id.resId,views:[[false,"form"]],view_mode:"form",target:"current",});}}}
const applicantCharField=__exports.applicantCharField={...charField,component:ApplicantCharField,};registry.category("fields").add("applicant_char",applicantCharField);return __exports;});;

/* /hr_recruitment/static/src/js/tours/hr_recruitment.js */
odoo.define('@hr_recruitment/js/tours/hr_recruitment',['@web/core/l10n/translation','@web/core/registry','@web_tour/tour_service/tour_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{stepUtils}=require("@web_tour/tour_service/tour_utils");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add('hr_recruitment_tour',{url:"/odoo",steps:()=>[stepUtils.showAppsMenuItem(),{isActive:["community"],trigger:'.o_app[data-menu-xmlid="hr_recruitment.menu_hr_recruitment_root"]',content:markup(_t("Let's have a look at how to <b>improve</b> your <b>hiring process</b>.")),tooltipPosition:'right',run:"click",},{isActive:["enterprise"],trigger:'.o_app[data-menu-xmlid="hr_recruitment.menu_hr_recruitment_root"]',content:markup(_t("Let's have a look at how to <b>improve</b> your <b>hiring process</b>.")),tooltipPosition:'bottom',run:"click",},{trigger:".o-kanban-button-new",content:_t("Create your first Job Position."),tooltipPosition:"bottom",run:"click",},{trigger:".o_hr_job_simple_form",},{trigger:".o_job_name",content:_t("What do you want to recruit today? Choose a job title..."),tooltipPosition:"right",run:"click",},{trigger:'.o_hr_job_simple_form',},{trigger:".o_job_alias",content:_t("Choose an application email."),tooltipPosition:"right",run:"click",},{trigger:'.o_create_job',content:_t('Let\'s create the position. An email will be setup for applications, and a public job description, if you use the Website app.'),tooltipPosition:'bottom',run:"click .modal:visible .btn.btn-primary",},{trigger:".o_copy_paste_email",content:_t("Copy this email address, to paste it in your email composer, to apply."),tooltipPosition:"bottom",run:"click",},{trigger:".o_kanban_applicant",},{trigger:".breadcrumb-item:not(.active):last",content:_t("Let’s go back to the dashboard."),tooltipPosition:"bottom",run:"click",},{trigger:".o_hr_recruitment_kanban",},{trigger:"button.oe_kanban_action",content:markup(_t("<b>Did you apply by sending an email?</b> Check incoming applications.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_kanban_applicant",},{trigger:".oe_kanban_card",content:markup(_t("<b>Drag this card</b>, to qualify him for a first interview.")),tooltipPosition:"bottom",run:"drag_and_drop(.o_kanban_group:eq(1))",},{trigger:".o_kanban_applicant",},{trigger:".oe_kanban_card",content:markup(_t("<b>Click to view</b> the application.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_applicant_form",},{trigger:"button:contains(Send message)",content:markup(_t("<div><b>Try to send an email</b> to the applicant.</div><div><i>Tips: All emails sent or received are saved in the history here</i>")),tooltipPosition:"bottom",run:"click",},{trigger:".o_applicant_form",},{trigger:".o-mail-Chatter .o-mail-Composer button[aria-label='Send']",content:_t("Send your email. Followers will get a copy of the communication."),tooltipPosition:"bottom",run:"click",},{trigger:".o_applicant_form",},{trigger:"button:contains(Log note)",content:_t("Or talk about this applicant privately with your colleagues."),tooltipPosition:"bottom",run:"click",},{trigger:".o_applicant_form",},{trigger:".o_create_employee",content:_t("Let’s create this new employee now."),tooltipPosition:"bottom",run:"click",},{trigger:".o_hr_employee_form_view",},{trigger:".o_form_button_save",content:_t("Save it!"),tooltipPosition:"bottom",run:"click",}]});return __exports;});;

/* /hr_recruitment/static/src/views/form_view.js */
odoo.define('@hr_recruitment/views/form_view',['@web/core/registry','@web/views/form/form_view','@web/views/form/form_controller'],function(require){'use strict';let __exports={};const{registry}=require('@web/core/registry');const{formView}=require('@web/views/form/form_view');const{FormController}=require('@web/views/form/form_controller');const InterviewerFormController=__exports.InterviewerFormController=class InterviewerFormController extends FormController{get className(){const result=super.className;const root=this.model.root;if(!root.data.interviewer_ids||!root.data.user_id){return result;}
result["o_applicant_interviewer_form"]=root.data.interviewer_ids.records.findIndex(interviewer=>interviewer.resId===root.data.user_id[0])>-1;return result;}}
registry.category('views').add('hr_recruitment_interviewer',{...formView,Controller:InterviewerFormController,});return __exports;});;

/* /hr_recruitment/static/src/views/recruitment_form_controller.js */
odoo.define('@hr_recruitment/views/recruitment_form_controller',['@web/core/l10n/translation','@web/views/form/form_controller'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{FormController}=require("@web/views/form/form_controller");const RecruitmentFormController=__exports.RecruitmentFormController=class RecruitmentFormController extends FormController{get archiveDialogProps(){const result=super.archiveDialogProps;result.body=this.model.root.data.all_application_count>0?_t("This job position and all related applicants will be archived. Are you sure?"):_t("Are you sure that you want to archive this job position?");console.log(this.model.root.data.all_application_count);return result;}}
return __exports;});;

/* /hr_recruitment/static/src/views/recruitment_form_view.js */
odoo.define('@hr_recruitment/views/recruitment_form_view',['@web/core/registry','@web/views/form/form_view','@hr_recruitment/views/recruitment_form_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");const{RecruitmentFormController}=require("@hr_recruitment/views/recruitment_form_controller");const RecruitmentFormView=__exports.RecruitmentFormView={...formView,Controller:RecruitmentFormController,};registry.category("views").add("recruitment_form_view",RecruitmentFormView);return __exports;});;

/* /hr_recruitment/static/src/views/recruitment_helper_view.js */
odoo.define('@hr_recruitment/views/recruitment_helper_view',['@web/core/utils/hooks','@web/core/user','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{user}=require("@web/core/user");const{Component,onWillStart,useState}=require("@odoo/owl");const RecruitmentActionHelper=__exports.RecruitmentActionHelper=class RecruitmentActionHelper extends Component{static template="hr_recruitment.RecruitmentActionHelper";static props=["noContentHelp"];setup(){this.orm=useService("orm");this.actionService=useService("action");this.state=useState({hasDemoData:false,});onWillStart(async()=>{const categoryTags=await this.orm.searchRead("hr.applicant.category",[],["name"]);const demoTag=categoryTags.filter((tag)=>tag.name==="Demo");this.state.hasDemoData=demoTag.length===1;this.isRecruitmentUser=await user.hasGroup("hr_recruitment.group_hr_recruitment_user");});}
loadRecruitmentScenario(){this.actionService.doAction("hr_recruitment.action_load_demo_data");}}
return __exports;});;

/* /hr_recruitment/static/src/views/recruitment_kanban_view.js */
odoo.define('@hr_recruitment/views/recruitment_kanban_view',['@web/core/l10n/translation','@web/core/registry','@web/core/confirmation_dialog/confirmation_dialog','@web/views/kanban/kanban_view','@web/views/kanban/kanban_renderer','@hr_recruitment/views/recruitment_helper_view'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{kanbanView}=require("@web/views/kanban/kanban_view");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{RecruitmentActionHelper}=require("@hr_recruitment/views/recruitment_helper_view");const RecruitmentKanbanRenderer=__exports.RecruitmentKanbanRenderer=class RecruitmentKanbanRenderer extends KanbanRenderer{static template="hr_recruitment.RecruitmentKanbanRenderer";static components={...KanbanRenderer.components,RecruitmentActionHelper,};async archiveRecord(record,active){if(active&&record.data.application_count>0){this.dialog.add(ConfirmationDialog,{body:_t("This job position and all related applicants will be archived. Are you sure?"),confirmLabel:_t("Archive"),confirm:()=>{record.archive();this.props.list.load();},cancel:()=>{},});}else if(active){record.archive();this.props.list.load();}else{record.unarchive();this.props.list.load();}}}
const RecruitmentKanbanView=__exports.RecruitmentKanbanView={...kanbanView,Renderer:RecruitmentKanbanRenderer,};registry.category("views").add("recruitment_kanban_view",RecruitmentKanbanView);return __exports;});;

/* /hr_recruitment/static/src/views/recruitment_list_controller.js */
odoo.define('@hr_recruitment/views/recruitment_list_controller',['@web/core/l10n/translation','@web/views/list/list_controller'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ListController}=require("@web/views/list/list_controller");const RecruitmentListController=__exports.RecruitmentListController=class RecruitmentListController extends ListController{get archiveDialogProps(){const result=super.archiveDialogProps;result.body=this.model.root.isDomainSelected||this.model.root.selection.length>1?_t("These job positions and all related applicants will be archived. Are you sure?"):_t("This job position and all related applicants will be archived. Are you sure?");return result;}}
return __exports;});;

/* /hr_recruitment/static/src/views/recruitment_list_view.js */
odoo.define('@hr_recruitment/views/recruitment_list_view',['@web/core/registry','@web/views/list/list_view','@web/views/list/list_renderer','@hr_recruitment/views/recruitment_helper_view','@hr_recruitment/views/recruitment_list_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{ListRenderer}=require("@web/views/list/list_renderer");const{RecruitmentActionHelper}=require("@hr_recruitment/views/recruitment_helper_view");const{RecruitmentListController}=require("@hr_recruitment/views/recruitment_list_controller");const RecruitmentListRenderer=__exports.RecruitmentListRenderer=class RecruitmentListRenderer extends ListRenderer{static template="hr_recruitment.RecruitmentListRenderer";static components={...ListRenderer.components,RecruitmentActionHelper,};}
const RecruitmentListView=__exports.RecruitmentListView={...listView,Controller:RecruitmentListController,Renderer:RecruitmentListRenderer,};registry.category("views").add("recruitment_list_view",RecruitmentListView);return __exports;});;

/* /sign/static/src/js/sign_datetime_widget.js */
odoo.define('@sign/js/sign_datetime_widget',['@web/views/fields/datetime/datetime_field','@web/core/l10n/dates','@web/core/l10n/localization','@web/core/registry'],function(require){'use strict';let __exports={};const{DateTimeField,dateTimeField}=require('@web/views/fields/datetime/datetime_field');const{formatDateTime}=require('@web/core/l10n/dates');const{localization}=require("@web/core/l10n/localization");const{registry}=require("@web/core/registry");class DateTimeNoSeconds extends DateTimeField{static template="sign.DateTimeNoSeconds";getFormattedValue(){const timeFormat=localization.dateTimeFormat.replace(":ss","");const{data}=this.props.record;return formatDateTime(data.create_date,{format:timeFormat});}}
const dateTimeNoSeconds=__exports.dateTimeNoSeconds={...dateTimeField,component:DateTimeNoSeconds,}
registry.category("fields").add('datetime_no_seconds',dateTimeNoSeconds);return __exports;});;

/* /sign/static/src/js/tours/sign.js */
odoo.define('@sign/js/tours/sign',['@web/core/l10n/translation','@web/core/registry','@web_tour/tour_service/tour_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{stepUtils}=require("@web_tour/tour_service/tour_utils");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add("sign_tour",{url:"/odoo",steps:()=>[stepUtils.showAppsMenuItem(),{trigger:'.o_app[data-menu-xmlid="sign.menu_document"]',content:markup(_t("Let's <b>prepare & sign</b> our first document.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_nocontent_help .o_sign_sample",content:_t("Try out this sample contract."),tooltipPosition:"bottom",run:"click",},{trigger:":iframe .o_sign_field_type_button:contains("+_t("Signature")+")",content:markup(_t("<b>Drag & drop “Signature”</b> into the bottom of the document.")),tooltipPosition:"bottom",run:"drag_and_drop :iframe #viewer",},{trigger:".o_control_panel .o_sign_template_send",content:markup(_t("Well done, your document is ready!<br>Let's send it to get our first signature.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_field_signer_x2many",content:markup(_t("Select the contact who should sign, according to their role.<br>In this example, select your own contact to sign the document yourself.")),tooltipPosition:"bottom",run:"click",},{trigger:'button[name="send_request"]',content:_t("Let's send the request by email."),tooltipPosition:"bottom",run:"click",},{trigger:".o_control_panel .o_sign_sign_directly",content:markup(_t("Since you're the one signing this document, you can do it directly within Odoo.<br>External users can use the link provided by email.")),tooltipPosition:"bottom",run:"click",},{trigger:":iframe .o_sign_sign_item_navigator",content:_t("Follow the guide to sign the document."),tooltipPosition:"bottom",run:"click",},{trigger:":iframe .o_sign_sign_item_navigator, :iframe .o_sign_sign_item[data-signature]",content:markup(_t("Draw your most beautiful signature!<br>You can also create one automatically or load a signature from your computer.")),tooltipPosition:"bottom",run:"click",},{trigger:"footer.modal-footer button.btn-primary:enabled",content:_t("Nearly there, keep going!"),tooltipPosition:"bottom",run:"click",},{trigger:":iframe body:not(:has(footer.modal-footer button.btn-primary))",},{trigger:".o_sign_validate_banner button.o_validate_button",content:_t("Congrats, your signature is ready to be submitted!"),tooltipPosition:"top",run:"click",},{trigger:'.modal-dialog button:contains("'+_t("Close")+'")',content:markup(_t("That's it, all done!<br>The document is signed, and a copy has been sent by email to all participants, along with a traceability report.")),tooltipPosition:"bottom",run:"click",},],});return __exports;});;

/* /sign/static/src/activity/activity_list_popover_item_patch.js */
odoo.define('@sign/activity/activity_list_popover_item_patch',['@mail/core/web/activity_list_popover_item','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ActivityListPopoverItem}=require("@mail/core/web/activity_list_popover_item");const{patch}=require("@web/core/utils/patch");patch(ActivityListPopoverItem.prototype,{get hasMarkDoneButton(){return super.hasMarkDoneButton&&this.props.activity.activity_category!=="sign_request";},async onClickRequestSign(){const{res_model,res_id}=this.props;const documentReference=res_model&&res_id?`${res_model},${res_id}`:false;await this.props.activity.requestSignature(this.props.onActivityChanged,documentReference);},});return __exports;});;

/* /sign/static/src/activity/activity_model_patch.js */
odoo.define('@sign/activity/activity_model_patch',['@mail/core/web/activity_model','@web/core/utils/patch','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Activity}=require("@mail/core/web/activity_model");const{patch}=require("@web/core/utils/patch");const{_t}=require("@web/core/l10n/translation");patch(Activity.prototype,{requestSignature(onClose=()=>{},documentReference=false){const additionalContext={sign_directly_without_mail:false,default_activity_id:this.id,};if(documentReference){additionalContext.default_reference_doc=documentReference;}
return this.store.env.services.action.doAction({name:_t("Signature Request"),type:"ir.actions.act_window",view_mode:"form",views:[[false,"form"]],target:"new",res_model:"sign.send.request",},{additionalContext,onClose});},});return __exports;});;

/* /sign/static/src/activity/activity_patch.js */
odoo.define('@sign/activity/activity_patch',['@mail/core/web/activity','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Activity}=require("@mail/core/web/activity");const{patch}=require("@web/core/utils/patch");patch(Activity.prototype,{async onClickRequestSign(){const{res_model,res_id}=this.props.activity;const documentReference=res_model&&res_id?`${res_model},${res_id}`:false;await this.props.activity.requestSignature(this.props.reloadParentView,documentReference);},});return __exports;});;

/* /sign/static/src/mixin/document_upload.js */
odoo.define('@sign/mixin/document_upload',['@odoo/owl'],function(require){'use strict';let __exports={};const{useRef,useEffect,useState}=require("@odoo/owl");const SignDocumentDropZone=__exports.SignDocumentDropZone=(T)=>class SignDocumentDropZone extends T{setup(){super.setup();this.root=useRef("root");this.dragState=useState({showDragZone:false,});useEffect((el)=>{if(!el){return;}
const highlight=this.highlight.bind(this);const unhighlight=this.unhighlight.bind(this);const drop=this.onDrop.bind(this);el.addEventListener("dragover",highlight);el.addEventListener("dragleave",unhighlight);el.addEventListener("drop",drop);return()=>{el.removeEventListener("dragover",highlight);el.removeEventListener("dragleave",unhighlight);el.removeEventListener("drop",drop);};},()=>[document.querySelector('.o_content')]);}
highlight(ev){ev.stopPropagation();ev.preventDefault();this.dragState.showDragZone=true;}
unhighlight(ev){ev.stopPropagation();ev.preventDefault();this.dragState.showDragZone=false;}
async onDrop(ev){ev.preventDefault();const files=ev.dataTransfer.files;const resModel=this.props.list.config.resModel;if(files.length){await this.env.bus.trigger("change_file_input",{files,resModel});}
this.dragState.showDragZone=false;}};return __exports;});;

/* /sign/static/src/components/sign_request/PDF_iframe.js */
odoo.define('@sign/components/sign_request/PDF_iframe',['@web/core/l10n/translation','@web/core/network/rpc','@web/core/utils/render','@web/core/confirmation_dialog/confirmation_dialog','@sign/components/sign_request/utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{renderToString}=require("@web/core/utils/render");const{AlertDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{normalizePosition,isVisible}=require("@sign/components/sign_request/utils");const PDFIframe=__exports.PDFIframe=class PDFIframe{constructor(root,env,owlServices,props){this.root=root;this.env=env;Object.assign(this,owlServices);this.props=props;this.cleanupFns=[];this.readonly=props.readonly;this.signItemTypesById=this.props.signItemTypes.reduce((obj,type)=>{obj[type.id]=type;return obj;},{});this.selectionOptionsById=this.props.signItemOptions.reduce((obj,option)=>{obj[option.id]=option;return obj;},{});this.radioSets=this.props.radioSets;if(this.root){this.waitForPagesToLoad();}}
waitForPagesToLoad(){const errorElement=this.root.querySelector("#errorMessage");if(isVisible(errorElement)){return this.dialog.add(AlertDialog,{body:_t("Need a valid PDF to add signature fields!"),});}
this.pageCount=this.root.querySelectorAll(".page").length;if(this.pageCount>0){this.start();}else{setTimeout(()=>this.waitForPagesToLoad(),50);}}
start(){this.signItems=this.getSignItems();this.loadCustomCSS().then(()=>{this.pageCount=this.root.querySelectorAll(".page").length;this.clearNativePDFViewerButtons();this.startPinchService();this.preRender();this.renderSidebar();this.addCanvasLayer();this.renderSignItems();this.postRender();});}
unmount(){this.cleanupFns.forEach((fn)=>typeof fn==="function"&&fn());}
async loadCustomCSS(){const assets=await rpc("/sign/render_assets_pdf_iframe",{args:[{debug:this.env.debug}],});this.root.querySelector("head").insertAdjacentHTML("beforeend",assets);}
clearNativePDFViewerButtons(){const selectors=["#pageRotateCw","#pageRotateCcw","#openFile","#presentationMode","#viewBookmark","#print","#download","#secondaryOpenFile","#secondaryPresentationMode","#secondaryViewBookmark","#secondaryPrint","#secondaryDownload",];const elements=this.root.querySelectorAll(selectors.join(", "));elements.forEach((element)=>{element.style.display="none";});this.root.querySelector("#lastPage").nextElementSibling.style.display="none";this.root.querySelector("#findInput").value="";this.root.querySelector("#findInput").setAttribute("autocomplete","off");const passwordInputs=this.root.querySelectorAll("[type=password]");Array.from(passwordInputs).forEach((input)=>input.setAttribute("autocomplete","new-password"));}
addCanvasLayer(){const viewer=this.root.querySelector("#viewer");const layer=document.createElement("canvas");const scale=this.getCanvasScale();layer.id="canvas_layer_0";layer.style.position="absolute";layer.style.top="0";layer.style.left="0";layer.style.zIndex=1;layer.style.width=viewer.offsetWidth+"px";layer.style.height=viewer.offsetHeight+"px";layer.width=viewer.offsetWidth/scale;layer.height=viewer.offsetHeight/scale;viewer.appendChild(layer);}
renderSidebar(){}
renderSignItems(){for(const page in this.signItems){const pageContainer=this.getPageContainer(page);for(const id in this.signItems[page]){const signItem=this.signItems[page][id];signItem.el=this.renderSignItem(signItem.data,pageContainer);}}
this.updateFontSize();this.renderAllConnectingLines();}
renderAllConnectingLines(){}
enableCustom(signItem){}
startPinchService(){const pinchTarget=this.root.querySelector("#viewerContainer #viewer");const handleTouchMove=(e)=>{if(e.touches.length==2){e.preventDefault();}};pinchTarget.addEventListener("touchmove",handleTouchMove);this.cleanupFns.push(()=>{pinchTarget.removeEventListener("touchmove",handleTouchMove);});}
renderSignItem(signItemData,target){const signItemElement=renderToString("sign.signItem",this.getContext(signItemData));target.insertAdjacentHTML("beforeend",signItemElement);const signItem=target.lastChild;signItem.classList.add("d-none");this.enableCustom({el:signItem,data:signItemData});return signItem;}
getContext(signItem){const normalizedPosX=Math.round(normalizePosition(signItem.posX,signItem.width)*1000)/1000;const normalizedPosY=Math.round(normalizePosition(signItem.posY,signItem.height)*1000)/1000;const responsible=parseInt(signItem.responsible??(signItem.responsible_id?.[0]||0));const type=this.signItemTypesById[signItem.type_id].item_type;if(type==="selection"){const options=signItem.option_ids.map((id)=>this.selectionOptionsById[id]);signItem.options=options;}
if(signItem.value===0){signItem.value="0";}
const readonly=this.readonly||(responsible>0&&responsible!==this.currentRole)||!!signItem.value;const isCurrentRole=this.currentRole===parseInt(responsible);const placeholder=signItem.placeholder||(isCurrentRole&&signItem.name)||(this.readonly&&`${signItem.name}\n${signItem.responsible_name}`)||"";return Object.assign(signItem,{readonly:signItem.readonly??readonly,editMode:signItem.editMode??false,required:Boolean(signItem.required),responsible,type,placeholder:placeholder,classes:`
                ${isCurrentRole ? "o_sign_sign_item_default" : ""}
                ${signItem.required && isCurrentRole ? "o_sign_sign_item_required" : ""}
                ${readonly && isCurrentRole ? "o_readonly_mode" : ""}
                ${this.readonly ? "o_sign_sign_item_pdfview" : ""}`,style:`top: ${normalizedPosY * 100}%; left: ${normalizedPosX * 100}%;
                    width: ${signItem.width * 100}%; height: ${signItem.height * 100}%;
                    text-align: ${signItem.alignment}`,});}
refreshSignItems(){for(const page in this.signItems){const pageContainer=this.getPageContainer(page);for(const id in this.signItems[page]){const signItem=this.signItems[page][id].el;signItem.classList.remove("d-none");if(signItem&&signItem.hasAttribute("data-signature")){signItem.addEventListener("dragstart",(event)=>{event.preventDefault();});}
if(!signItem.parentElement||!signItem.parentElement.classList.contains("page")){pageContainer.append(signItem);}}}
this.updateFontSize();this.renderAllConnectingLines();}
preRender(){const viewerContainer=this.root.querySelector("#viewerContainer");viewerContainer.style.visibility="visible";this.setInitialZoom();}
get normalSize(){return this.root.querySelector(".page").clientHeight*0.015;}
updateFontSize(){for(const page in this.signItems){for(const id in this.signItems[page]){const signItem=this.signItems[page][id];this.updateSignItemFontSize(signItem);}}}
updateSignItemFontSize({el,data}){const largerTypes=["signature","initial","textarea","selection"];const size=largerTypes.includes(data.type)?this.normalSize:parseFloat(el.clientHeight);el.style.fontSize=`${size * 0.8}px`;}
async rotatePDF(e){const button=e.target;button.setAttribute("disabled","");const result=await this.props.rotatePDF();if(result){this.root.querySelector("#pageRotateCw").click();button.removeAttribute("disabled");this.refreshSignItems();}}
setInitialZoom(){let button=this.root.querySelector("button#zoomIn");if(!this.env.isSmall){button=this.root.querySelector("button#zoomOut");button.click();}
button.click();}
postRender(){const refreshSignItemsIntervalId=setInterval(()=>this.refreshSignItems(),1000);this.cleanupFns.push(()=>clearInterval(refreshSignItemsIntervalId));}
createSignItemDataFromType(typeId){const type=this.signItemTypesById[typeId];return{required:true,editMode:true,readonly:true,updated:true,responsible:this.currentRole,option_ids:[],options:[],name:type.name,width:type.default_width,height:type.default_height,alignment:"center",type:type.item_type,placeholder:type.placeholder,classes:`o_color_responsible_${this.signRolesById[this.currentRole].color}`,style:`width: ${type.default_width * 100}%; height: ${type.default_height * 100}%;`,type_id:[type.id],};}
getSignItems(){const signItems={};for(let currentPage=1;currentPage<=this.pageCount;currentPage++){signItems[currentPage]={};}
for(const signItem of this.props.signItems){signItems[signItem.page][signItem.id]={data:signItem,el:null,};}
return signItems;}
getPageContainer(page){return this.root.querySelector(`.page[data-page-number="${page}"]`);}
getCanvas(){return this.root.querySelector("#canvas_layer_0");}
getCanvasScale(){const MAX_CANVAS_HEIGHT=16384;const viewer_height=this.root.querySelector("#viewer").offsetHeight;return Math.ceil(viewer_height/MAX_CANVAS_HEIGHT);}}
return __exports;});;

/* /sign/static/src/components/sign_request/document_signable.js */
odoo.define('@sign/components/sign_request/document_signable',['@odoo/owl','@web/core/main_components_container','@web/core/utils/hooks','@web/core/templates','@web/env','@sign/dialogs/dialogs','@sign/components/sign_request/signable_PDF_iframe','@sign/components/sign_request/utils','@web/core/l10n/translation','@web/core/network/rpc'],function(require){'use strict';let __exports={};const{App,Component,xml,whenReady,useEffect,useComponent}=require("@odoo/owl");const{MainComponentsContainer}=require("@web/core/main_components_container");const{useService}=require("@web/core/utils/hooks");const{getTemplate}=require("@web/core/templates");const{makeEnv,startServices}=require("@web/env");const{SignRefusalDialog}=require("@sign/dialogs/dialogs");const{SignablePDFIframe}=require("@sign/components/sign_request/signable_PDF_iframe");const{buildPDFViewerURL}=require("@sign/components/sign_request/utils");const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");function datasetFromElements(elements){return Array.from(elements).map((el)=>{return Object.entries(el.dataset).reduce((dataset,[key,value])=>{try{dataset[key]=JSON.parse(value);}catch{dataset[key]=value;}
return dataset;},{});});}
const Document=__exports.Document=class Document extends Component{static template=xml`<t t-slot='default'/>`;static props=["parent","PDFIframeClass"];setup(){this.orm=useService("orm");this.dialog=useService("dialog");this.ui=useService("ui");this.signInfo=useService("signInfo");useEffect(()=>{this.getDataFromHTML();this.signInfo.set({documentId:this.requestID,signRequestToken:this.requestToken,signRequestState:this.requestState,signRequestItemToken:this.accessToken,todayFormattedDate:this.todayFormattedDate,});},()=>[]);}
getDataFromHTML(){const{el:parentEl}=this.props.parent;this.attachmentLocation=parentEl.querySelector("#o_sign_input_attachment_location")?.value;this.templateName=parentEl.querySelector("#o_sign_input_template_name")?.value;this.templateID=parseInt(parentEl.querySelector("#o_sign_input_template_id")?.value);this.templateItemsInProgress=parseInt(parentEl.querySelector("#o_sign_input_template_in_progress_count")?.value);this.requestID=parseInt(parentEl.querySelector("#o_sign_input_sign_request_id")?.value);this.requestToken=parentEl.querySelector("#o_sign_input_sign_request_token")?.value;this.requestState=parentEl.querySelector("#o_sign_input_sign_request_state")?.value;this.accessToken=parentEl.querySelector("#o_sign_input_access_token")?.value;this.todayFormattedDate=parentEl.querySelector("#o_sign_input_today_formatted_date")?.value;this.templateEditable=Boolean(parentEl.querySelector("#o_sign_input_template_editable"));this.authMethod=parentEl.querySelector("#o_sign_input_auth_method")?.value;this.signerName=parentEl.querySelector("#o_sign_signer_name_input_info")?.value;this.signerPhone=parentEl.querySelector("#o_sign_signer_phone_input_info")?.value;this.redirectURL=parentEl.querySelector("#o_sign_input_optional_redirect_url")?.value;this.redirectURLText=parentEl.querySelector("#o_sign_input_optional_redirect_url")?.value;this.redirectURLText=parentEl.querySelector("#o_sign_input_optional_redirect_url_text")?.value;this.types=datasetFromElements(parentEl.querySelectorAll(".o_sign_field_type_input_info"));this.items=datasetFromElements(parentEl.querySelectorAll(".o_sign_item_input_info"));this.selectOptions=datasetFromElements(parentEl.querySelectorAll(".o_sign_select_options_input_info"));this.validateBanner=parentEl.querySelector(".o_sign_validate_banner");this.validateButton=parentEl.querySelector(".o_validate_button");this.currentRole=parseInt(parentEl.querySelector("#o_sign_input_current_role")?.value);this.currentName=parentEl.querySelector("#o_sign_input_current_role_name")?.value;this.isUnknownPublicUser=Boolean(parentEl.querySelector("#o_sign_is_public_user"));this.frameHash=parentEl.querySelector("#o_sign_input_sign_frame_hash")?.value;this.PDFIframe=parentEl.querySelector("iframe.o_sign_pdf_iframe");this.PDFIframe.setAttribute("src",buildPDFViewerURL(this.attachmentLocation,this.env.isSmall));this.PDFIframe.onload=()=>{setTimeout(()=>this.initializeIframe(),1);};}
initializeIframe(){this.iframe=new this.props.PDFIframeClass(this.PDFIframe.contentDocument,this.env,{rpc,orm:this.orm,dialog:this.dialog,ui:this.ui,signInfo:this.signInfo,},this.iframeProps);}
get iframeProps(){return{attachmentLocation:this.attachmentLocation,requestID:this.requestID,requestToken:this.requestToken,accessToken:this.accessToken,signItemTypes:this.types,signItems:this.items,hasSignRequests:false,signItemOptions:this.selectOptions,currentRole:this.currentRole,currentName:this.currentName,readonly:this.PDFIframe.getAttribute("readonly")==="readonly",frameHash:this.frameHash,signerName:this.signerName,signerPhone:this.signerPhone,validateBanner:this.validateBanner,validateButton:this.validateButton,isUnknownPublicUser:this.isUnknownPublicUser,authMethod:this.authMethod,redirectURL:this.redirectURL,redirectURLText:this.redirectURLText,templateEditable:this.templateEditable,};}}
function usePublicRefuseButton(){const component=useComponent();useEffect(()=>{const refuseButtons=document.querySelectorAll(".o_sign_refuse_document_button");if(refuseButtons){refuseButtons.forEach((button)=>button.addEventListener("click",()=>{component.dialog.add(SignRefusalDialog);}));}},()=>[]);}
const SignableDocument=__exports.SignableDocument=class SignableDocument extends Document{static components={MainComponentsContainer,};static template=xml`<MainComponentsContainer/>`;setup(){super.setup();this.coords={};usePublicRefuseButton();useEffect(()=>{if(this.requestID){const{el:parentEl}=this.props.parent;const askLocation=parentEl.getElementById("o_sign_ask_location_input");if(askLocation&&navigator.geolocation){navigator.geolocation.getCurrentPosition(({coords:{latitude,longitude}})=>{Object.assign(this.coords,{latitude,longitude,});if(this.requestState!=="shared"){rpc(`/sign/save_location/${this.requestID}/${this.accessToken}`,this.coords);}},()=>{},{enableHighAccuracy:true});}}},()=>[this.requestID]);}
get iframeProps(){return{...super.iframeProps,coords:this.coords,};}}
__exports.initDocumentToSign=initDocumentToSign;async function initDocumentToSign(parent){const env=makeEnv();await startServices(env);await whenReady();const app=new App(SignableDocument,{name:"Signable Document",env,props:{parent:{el:parent},PDFIframeClass:SignablePDFIframe},getTemplate,dev:env.debug,translatableAttributes:["data-tooltip"],translateFn:_t,});await app.mount(parent.body);}
return __exports;});;

/* /sign/static/src/components/sign_request/mobile_input_bottom_sheet.js */
odoo.define('@sign/components/sign_request/mobile_input_bottom_sheet',['@web/core/utils/render'],function(require){'use strict';let __exports={};const{renderToString}=require("@web/core/utils/render");const MobileInputBottomSheet=__exports.MobileInputBottomSheet=class MobileInputBottomSheet{constructor(options){this.type=options.type||"text";this.placeholder=options.placeholder||"";this.label=options.label||this.placeholder;this.value=options.value||"";this.buttonText=options.buttonText;this.element=options.element;this.onTextChange=options.onTextChange||function(){};this.onValidate=options.onValidate||function(){};document.body.insertAdjacentHTML("beforeend",renderToString("sign.MobileInputBottomSheet",this));this.el=document.body.lastChild;this.registerEvents();}
registerEvents(){const field=this.el.querySelector(".o_sign_item_bottom_sheet_field");const nextButton=this.el.querySelector(".o_sign_next_button");if(field){field.addEventListener("blur",()=>{this._onBlurField();});field.addEventListener("keyup",()=>{this._onKeyUpField();});}
if(nextButton){nextButton.addEventListener("click",()=>{this._onClickNext();});}}
updateInputText(text){this.value=text;this.el.querySelector(".o_sign_item_bottom_sheet_field").value=text;this._toggleButton();}
show(){const bottomSheet=document.querySelector(".o_sign_item_bottom_sheet.show");if(bottomSheet){bottomSheet.classList.remove("show");}
this._toggleButton();setTimeout(()=>this.el.classList.add("show"));this.el.querySelector(".o_sign_item_bottom_sheet_field").focus();}
hide(){this.el.classList.remove("show");this.el.addEventListener("transitionend",()=>(this.el.style.display="none"),{once:true,});}
_toggleButton(){const buttonNext=this.el.querySelector(".o_sign_next_button");this.value.length?buttonNext.removeAttribute("disabled"):buttonNext.setAttribute("disabled","disabled");}
_updateText(){this.value=this.el.querySelector(".o_sign_item_bottom_sheet_field").value;this.onTextChange(this.value);this._toggleButton();}
_onBlurField(){this._updateText();}
_onClickNext(){this.onValidate(this.value);}
_onKeyUpField(){this._updateText();}}
return __exports;});;

/* /sign/static/src/components/sign_request/sign_item_navigator.js */
odoo.define('@sign/components/sign_request/sign_item_navigator',['@web/core/l10n/translation','@sign/components/sign_request/utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{offset}=require("@sign/components/sign_request/utils");__exports.startSignItemNavigator=startSignItemNavigator;function startSignItemNavigator(parent,target,types,env){function setTip(text){navigator.style.fontFamily="Helvetica";navigator.innerText=text;}
const state={started:false,isScrolling:false,};const navigator=document.createElement("div");navigator.classList.add("o_sign_sign_item_navigator");navigator.addEventListener("click",goToNextSignItem);target.append(navigator);const navLine=document.createElement("div");navLine.classList.add("o_sign_sign_item_navline");navigator.before(navLine);setTip(_t("Click to start"));navigator.focus();function goToNextSignItem(){if(!state.started){state.started=true;parent.refreshSignItems();goToNextSignItem();return false;}
const selectedElements=target.querySelectorAll(".ui-selected");selectedElements.forEach((selectedElement)=>{selectedElement.classList.remove("ui-selected");});const signItemsToComplete=parent.checkSignItemsCompletion().sort((a,b)=>{return(100*(a.data.page-b.data.page)+
10*(a.data.posY-b.data.posY)+
(a.data.posX-b.data.posX));});if(signItemsToComplete.length>0){scrollToSignItem(signItemsToComplete[0]);}}
function highligtRadioSet(radio_set_id){parent.checkSignItemsCompletion().filter((item)=>item.data.radio_set_id===radio_set_id).forEach(item=>{item.el.classList.add("ui-selected");});}
function scrollToSignItem({el:item,data}){_scrollToSignItemPromise(item).then(()=>{const type=types[data.type_id];if(type.item_type==="text"&&item.querySelector("input")){item.value=item.querySelector("input").value;item.focus=()=>item.querySelector("input").focus();}
if(item.value===""&&!item.dataset.signature){setTip(type.tip);}
parent.refreshSignItems();if(data.type==="radio"){highligtRadioSet(data.radio_set_id);}else{item.focus();item.classList.add("ui-selected");}
if(["signature","initial"].includes(type.item_type)){if(item.dataset.hasFocus){const clickableElement=data.isSignItemEditable?item.querySelector(".o_sign_item_display"):item;clickableElement.click();}else{item.dataset.hasFocus=true;}}
state.isScrolling=false;});}
function _scrollToSignItemPromise(item){if(env.isSmall){return new Promise((resolve)=>{state.isScrolling=true;item.scrollIntoView({behavior:"smooth",block:"center",inline:"center",});resolve();});}
state.isScrolling=true;const viewer=target.querySelector("#viewer");const containerHeight=target.offsetHeight;const viewerHeight=viewer.offsetHeight;let scrollOffset=containerHeight/4;const scrollTop=offset(item).top-offset(viewer).top-scrollOffset;if(scrollTop+containerHeight>viewerHeight){scrollOffset+=scrollTop+containerHeight-viewerHeight;}
if(scrollTop<0){scrollOffset+=scrollTop;}
scrollOffset+=offset(target).top-
navigator.offsetHeight/2+
item.getBoundingClientRect().height/2;const duration=Math.max(Math.min(500,5*(Math.abs(target.scrollTop-scrollTop)+
Math.abs(navigator.getBoundingClientRect().top)-
scrollOffset)),100);return new Promise((resolve,reject)=>{target.scrollTo({top:scrollTop,behavior:"smooth"});const an=navigator.animate({top:`${scrollOffset}px`},{duration,fill:"forwards"});const an2=navLine.animate({top:`${scrollOffset}px`},{duration,fill:"forwards"});Promise.all([an.finished,an2.finished]).then(()=>resolve());});}
function toggle(force){navigator.style.display=force?"":"none";navLine.style.display=force?"":"none";}
return{setTip,goToNextSignItem,toggle,state,};}
return __exports;});;

/* /sign/static/src/components/sign_request/signable_PDF_iframe.js */
odoo.define('@sign/components/sign_request/signable_PDF_iframe',['@web/core/network/rpc','@web/core/l10n/translation','@web/core/user','@sign/components/sign_request/PDF_iframe','@sign/components/sign_request/sign_item_navigator','@web/core/confirmation_dialog/confirmation_dialog','@sign/dialogs/dialogs'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{PDFIframe}=require("@sign/components/sign_request/PDF_iframe");const{startSignItemNavigator}=require("@sign/components/sign_request/sign_item_navigator");const{AlertDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{SignNameAndSignatureDialog,ThankYouDialog,PublicSignerDialog,SMSSignerDialog,NextDirectSignDialog,}=require("@sign/dialogs/dialogs");const SignablePDFIframe=__exports.SignablePDFIframe=class SignablePDFIframe extends PDFIframe{constructor(root,env,owlServices,props){super(root,env,owlServices,props);this.currentRole=this.props.currentRole;this.currentRoleName=this.props.currentName;this.signerName=props.signerName;this.frameHash=(this.props.frameHash&&this.props.frameHash.substring(0,10)+"...")||"";this.radioSets={};this.props.signItems.forEach((item)=>{if(item.radio_set_id){if(item.radio_set_id in this.radioSets){this.radioSets[item.radio_set_id].items.push(item);}else{this.radioSets[item.radio_set_id]={selected:null,items:[item],}}}})
for(const radio_set_id in this.radioSets){this.radioSets[radio_set_id].items=this.radioSets[radio_set_id].items.sort((a,b)=>{return(100*(a.page-b.page)+
10*(a.posY-b.posY)+
(a.posX-b.posX));});}}
getSignItemById(id){for(const page in this.signItems){if(this.signItems[page].hasOwnProperty(id)){return this.signItems[page][id];}}
return undefined;}
handleRadioItemSelected(signItem){const radio_set_id=signItem.data.radio_set_id;if(this.radioSets[radio_set_id].selected!==signItem.data.id){this.radioSets[signItem.data.radio_set_id].selected=signItem.data.id;}else if(!signItem.data.required){signItem.el.checked=false;this.radioSets[radio_set_id].selected=undefined;}}
enableCustom(signItem){if(this.readonly||signItem.data.responsible!==this.currentRole){return;}
const signItemElement=signItem.el;const signItemData=signItem.data;const signItemType=this.signItemTypesById[signItemData.type_id];const{name,item_type:type,auto_value:autoValue}=signItemType;if(name===_t("Date")){signItemElement.addEventListener("focus",(e)=>{this.fillTextSignItem(e.currentTarget,this.signInfo.get('todayFormattedDate'));});}else if(type==="signature"||type==="initial"){signItemElement.addEventListener("click",(e)=>{this.handleSignatureDialogClick(e.currentTarget,signItemType);});}else if(type==="radio"){signItemElement.addEventListener("click",(e)=>{this.handleRadioItemSelected(signItem);})}
if(autoValue&&["text","textarea"].includes(type)){signItemElement.addEventListener("focus",(e)=>{this.fillTextSignItem(e.currentTarget,autoValue);});}
if(type==="selection"){if(signItemElement.value){this.handleInput();}
const optionDiv=signItemElement.querySelector(".o_sign_select_options_display");optionDiv.addEventListener("click",(e)=>{if(e.target.classList.contains("o_sign_item_option")){const option=e.target;const selectedValue=option.dataset.id;signItemElement.value=selectedValue;option.classList.add("o_sign_selected_option");option.classList.remove("o_sign_not_selected_option");const notSelected=optionDiv.querySelectorAll(`.o_sign_item_option:not([data-id='${selectedValue}'])`);[...notSelected].forEach((el)=>{el.classList.remove("o_sign_selected_option");el.classList.add("o_sign_not_selected_option");});this.handleInput();}});}
signItemElement.addEventListener("input",this.handleInput.bind(this));}
handleInput(){this.checkSignItemsCompletion();this.navigator.setTip(_t("next"));}
handleSignatureDialogClick(signatureItem,signItemType){this.refreshSignItems();const signature=signatureItem.dataset.signature;const{auto_value:autoValue,frame_value:frameValue,item_type:type}=signItemType;if(autoValue&&!signature){Promise.all([this.adjustSignatureSize(autoValue,signatureItem),this.adjustSignatureSize(frameValue,signatureItem),]).then(([data,frameData])=>{this.fillItemWithSignature(signatureItem,data,{frame:frameData,hash:"0"});this.handleInput();});}else if(type==="initial"&&this.nextInitial&&!signature){this.adjustSignatureSize(this.nextInitial,signatureItem).then((data)=>{this.fillItemWithSignature(signatureItem,data);this.handleInput();});}else{this.openSignatureDialog(signatureItem,signItemType);}}
fillTextSignItem(signItemElement,value){if(signItemElement.value===""){signItemElement.value=value;this.handleInput();}}
adjustSignatureSize(data,signatureItem){if(!data){return Promise.resolve(false);}
return new Promise((resolve,reject)=>{const img=new Image();img.onload=()=>{const c=document.createElement("canvas");if(!signatureItem.parentElement||!signatureItem.parentElement.classList.contains("page")){this.refreshSignItems();}
const{width:boxWidth,height:boxHeight}=signatureItem.getBoundingClientRect();const imgHeight=img.height;const imgWidth=img.width;const ratioBoxWidthHeight=boxWidth/boxHeight;const ratioImageWidthHeight=imgWidth/imgHeight;const[canvasHeight,canvasWidth]=ratioBoxWidthHeight>ratioImageWidthHeight?[imgHeight,imgHeight*ratioBoxWidthHeight]:[imgWidth/ratioBoxWidthHeight,imgWidth];c.height=canvasHeight;c.width=canvasWidth;const ctx=c.getContext("2d");const oldShadowColor=ctx.shadowColor;ctx.shadowColor="transparent";ctx.drawImage(img,c.width/2-img.width/2,c.height/2-img.height/2,img.width,img.height);ctx.shadowColor=oldShadowColor;resolve(c.toDataURL());};img.src=data;});}
fillItemWithSignature(signatureItem,image,frameData=false){signatureItem.dataset.signature=image;signatureItem.replaceChildren();const signHelperSpan=document.createElement("span");signHelperSpan.classList.add("o_sign_helper");signatureItem.append(signHelperSpan);if(frameData&&frameData.frame){signatureItem.dataset.frameHash=frameData.hash;signatureItem.dataset.frame=frameData.frame;const frameImage=document.createElement("img");frameImage.src=frameData.frame;frameImage.classList.add("o_sign_frame");signatureItem.append(frameImage);}else{delete signatureItem.dataset.frame;}
const signatureImage=document.createElement("img");signatureImage.src=image;signatureItem.append(signatureImage);}
closeDialog(){this.closeFn&&this.closeFn();this.closeFn=false;}
openSignatureDialog(signatureItem,type){if(this.dialogOpen){return;}
const signature={name:this.signerName||"",};const frame={};const{height,width}=signatureItem.getBoundingClientRect();const signFrame=signatureItem.querySelector(".o_sign_frame");this.dialogOpen=true;const signatureImage=signatureItem?.dataset?.signature;const signMode=type.auto_value?"draw":"auto"
if(signMode=="draw"&&signatureImage){signature.signatureImage=signatureImage;}
this.closeFn=this.dialog.add(SignNameAndSignatureDialog,{frame,signature,signatureType:type.item_type,displaySignatureRatio:width/height,activeFrame:Boolean(signFrame)||!type.auto_value,mode:signMode,defaultFrame:type.frame_value||"",hash:this.frameHash,signatureImage,onConfirm:async()=>{if(!signature.isSignatureEmpty&&signature.signatureChanged){const signatureName=signature.name;this.signerName=signatureName;await frame.updateFrame();const frameData=frame.getFrameImageSrc();const signatureSrc=signature.getSignatureImage();type.auto_value=signatureSrc;type.frame_value=frameData;if(user.userId){await this.updateUserSignature(type);}
this.fillItemWithSignature(signatureItem,signatureSrc,{frame:frameData,hash:this.frameHash,});}else if(signature.signatureChanged){delete signatureItem.dataset.signature;delete signatureItem.dataset.frame;signatureItem.replaceChildren();const signHelperSpan=document.createElement("span");signHelperSpan.classList.add("o_sign_helper");signatureItem.append(signHelperSpan);if(type.placeholder){const placeholderSpan=document.createElement("span");placeholderSpan.classList.add("o_placeholder");placeholderSpan.innerText=type.placeholder;signatureItem.append(placeholderSpan);}}
this.closeDialog();this.handleInput();},onConfirmAll:async()=>{const signatureName=signature.name;this.signerName=signatureName;await frame.updateFrame();const frameData=frame.getFrameImageSrc();const signatureSrc=signature.getSignatureImage();type.auto_value=signatureSrc;type.frame_value=frameData;if(user.userId){await this.updateUserSignature(type);}
for(const page in this.signItems){await Promise.all(Object.values(this.signItems[page]).reduce((promiseList,signItem)=>{if(signItem.data.responsible===this.currentRole&&signItem.data.type_id===type.id){promiseList.push(Promise.all([this.adjustSignatureSize(signatureSrc,signItem.el),this.adjustSignatureSize(frameData,signItem.el),]).then(([data,frameData])=>{this.fillItemWithSignature(signItem.el,data,{frame:frameData,hash:this.frameHash,});}));}
return promiseList;},[]));}
this.closeDialog();this.handleInput();},onCancel:()=>{this.closeDialog();},},{onClose:()=>{this.dialogOpen=false;},});}
checkSignItemsCompletion(){this.refreshSignItems();const itemsToSign=[];for(const page in this.signItems){Object.values(this.signItems[page]).forEach((signItem)=>{if(signItem.data.required&&signItem.data.responsible===this.currentRole&&!signItem.data.value){if(signItem.data.type==="radio"&&this.radioSets[signItem.data.radio_set_id].selected){return;}
const el=signItem.data.isEditMode&&signItem.el.type==="text"?el.querySelector("input"):signItem.el;const uncheckedBox=el.value==="on"&&!el.checked;if(!((el.value&&el.value.trim())||el.dataset.signature)||uncheckedBox){itemsToSign.push(signItem);}}});}
itemsToSign.length?this.hideBanner():this.showBanner();this.navigator.toggle(itemsToSign.length>0);return itemsToSign;}
showBanner(){this.props.validateBanner.style.display="block";const an=this.props.validateBanner.animate({opacity:1},{duration:500,fill:"forwards"});an.finished.then(()=>{if(this.env.isSmall){this.props.validateBanner.scrollIntoView({behavior:"smooth",block:"center",inline:"center",});}});}
hideBanner(){this.props.validateBanner.style.display="none";this.props.validateBanner.style.opacity=0;}
updateUserSignature(type){return rpc("/sign/update_user_signature",{sign_request_id:this.props.requestID,role:this.currentRole,signature_type:type.item_type==="signature"?"sign_signature":"sign_initials",datas:type.auto_value,frame_datas:type.frame_value,});}
getContext(signItem){return super.getContext(signItem);}
preRender(){super.preRender();}
postRender(){super.postRender();if(this.readonly){return;}
this.navigator=startSignItemNavigator(this,this.root.querySelector("#viewerContainer"),this.signItemTypesById,this.env);this.checkSignItemsCompletion();this.root.querySelector("#viewerContainer").addEventListener("scroll",()=>{if(!this.navigator.state.isScrolling&&this.navigator.state.started){this.navigator.setTip(_t("next"));}});this.root.querySelector("#viewerContainer").addEventListener("keydown",(e)=>{if(e.key!=="Enter"||(e.target.tagName.toLowerCase()==='textarea')){return;}
this.navigator.goToNextSignItem();});this.props.validateBanner.querySelector(".o_validate_button").addEventListener("click",()=>{this.signDocument();});}
getMailFromSignItems(){let mail="";for(const page in this.signItems){Object.values(this.signItems[page]).forEach(({el})=>{const childInput=el.querySelector("input");const value=el.value||(childInput&&childInput.value);if(value&&value.indexOf("@")>=0){mail=value;}});}
return mail;}
signDocument(){this.props.validateBanner.setAttribute("disabled",true);this.signatureInfo={name:this.signerName||"",mail:this.getMailFromSignItems()};[this.signatureInfo.signatureValues,this.signatureInfo.frameValues,this.signatureInfo.newSignItems,]=this.getSignatureValuesFromConfiguration();if(!this.signatureInfo.signatureValues){this.checkSignItemsCompletion();this.dialog.add(AlertDialog,{title:_t("Warning"),body:_t("Some fields have still to be completed"),});this.props.validateBanner.removeAttribute("disabled");return;}
this.signatureInfo.hasNoSignature=Object.keys(this.signatureInfo.signatureValues).length==0&&Object.keys(this.signItems).length==0;this._signDocument();}
async _signDocument(){this.props.validateButton.setAttribute("disabled",true);if(this.signatureInfo.hasNoSignature){const signature={name:this.signerName||"",};this.closeFn=this.dialog.add(SignNameAndSignatureDialog,{signature,onConfirm:()=>{this.signatureInfo.name=signature.name;this.signatureInfo.signatureValues=signature.getSignatureImage().split(",")[1];this.signatureInfo.frameValues=[];this.signatureInfo.hasNoSignature=false;this.closeDialog();this._signDocument();},onCancel:()=>{this.closeDialog();},});}else if(this.props.isUnknownPublicUser){this.closeFn=this.dialog.add(PublicSignerDialog,{name:this.signatureInfo.name,mail:this.signatureInfo.mail,postValidation:async(requestID,requestToken,accessToken)=>{this.signInfo.set({documentId:requestID,signRequestToken:requestToken,signRequestItemToken:accessToken,});this.props.requestID=requestID;this.props.requestToken=requestToken;this.props.accessToken=accessToken;if(this.props.coords){await rpc(`/sign/save_location/${requestID}/${accessToken}`,this.props.coords);}
this.props.isUnknownPublicUser=false;this._signDocument();},},{onClose:()=>{this.props.validateButton.removeAttribute("disabled");},});}else if(this.props.authMethod){this.openAuthDialog();}else{this._sign();}}
_getRouteAndParams(){const route=this.signatureInfo.smsToken?`/sign/sign/${encodeURIComponent(this.props.requestID)}/${encodeURIComponent(
                  this.props.accessToken
              )}/${encodeURIComponent(this.signatureInfo.smsToken)}`:`/sign/sign/${encodeURIComponent(this.props.requestID)}/${encodeURIComponent(
                  this.props.accessToken
              )}`;const params={signature:this.signatureInfo.signatureValues,frame:this.signatureInfo.frameValues,new_sign_items:this.signatureInfo.newSignItems,};return[route,params];}
async _sign(){const[route,params]=this._getRouteAndParams();this.ui.block();const response=await rpc(route,params).finally(()=>this.ui.unblock());this.props.validateButton.removeAttribute("disabled");if(response.success){if(response.url){document.location.pathname=response.url;}else{this.disableItems();const nameList=this.signInfo.get("nameList");if(nameList&&nameList.length>0){this.dialog.add(NextDirectSignDialog);}else{this.openThankYouDialog();}}
this.hideBanner();}else{if(response.sms){this.dialog.add(AlertDialog,{title:_t("Error"),body:_t("Your signature was not submitted. Ensure the SMS validation code is correct."),});}else{this.dialog.add(AlertDialog,{title:_t("Error"),body:_t("Sorry, an error occurred, please try to fill the document again."),},{onClose:()=>{window.location.reload();},});}
this.props.validateButton.setAttribute("disabled",true);}}
getSignatureValuesFromConfiguration(){const signatureValues={};const frameValues={};const newSignItems={};for(const page in this.signItems){for(const item of Object.values(this.signItems[page])){const responsible=item.data.responsible||0;if(responsible>0&&responsible!==this.currentRole){continue;}
const value=this.getSignatureValueFromElement(item);const[frameValue,frameHash]=item.el.dataset.signature?[item.el.dataset.frame,item.el.dataset.frameHash]:[false,false];if(!value){if(item.data.required){return[{},{}];}
continue;}
signatureValues[item.data.id]=value;frameValues[item.data.id]={frameValue,frameHash};if(item.data.isSignItemEditable){newSignItems[item.data.id]={type_id:item.data.type_id,required:item.data.required,name:item.data.name||false,option_ids:item.data.option_ids,responsible_id:responsible,page:page,posX:item.data.posX,posY:item.data.posY,width:item.data.width,height:item.data.height,};}}}
return[signatureValues,frameValues,newSignItems];}
getSignatureValueFromElement(item){const types={text:()=>{const textValue=item.el.textContent&&item.el.textContent.trim()?item.el.textContent:false;const value=item.el.value&&item.el.value.trim()?item.el.value:item.el.querySelector("input")?.value||false;return value||textValue;},initial:()=>item.el.dataset.signature,signature:()=>item.el.dataset.signature,textarea:()=>this.textareaApplyLineBreak(item.el),selection:()=>(item.el.value&&item.el.value.trim()?item.el.value:false),checkbox:()=>{if(item.el.checked){return"on";}else{return item.data.required?false:"off";}},radio:()=>{if(item.el.checked){return"on";}else{return"off";}}};const type=item.data.type;return type in types?types[type]():types["text"]();}
textareaApplyLineBreak(element){element.setAttribute("wrap","off");const strRawValue=element.value;element.value="";const nEmptyWidth=element.scrollWidth;let nLastWrappingIndex=-1;strRawValue.split("").forEach((curChar,i)=>{element.value+=curChar;if(curChar===" "||curChar==="-"||curChar==="+"){nLastWrappingIndex=i;}
if(element.scrollWidth>nEmptyWidth){let buffer="";if(nLastWrappingIndex>=0){for(let j=nLastWrappingIndex+1;j<i;j++){buffer+=strRawValue.charAt(j);}
nLastWrappingIndex=-1;}
buffer+=curChar;element.value=element.value.substr(0,element.value.length-buffer.length);element.value+="\n"+buffer;}});element.setAttribute("wrap","");return element.value;}
disableItems(){const items=this.root.querySelectorAll(".o_sign_sign_item");for(const item of Array.from(items)){item.classList.add("o_sign_sign_item_pdfview");}}
openThankYouDialog(){this.dialog.add(ThankYouDialog,{redirectURL:this.props.redirectURL,redirectURLText:this.props.redirectURLText,});}
async openAuthDialog(){const authDialog=await this.getAuthDialog();if(authDialog.component){this.closeFn=this.dialog.add(authDialog.component,authDialog.props,{onClose:()=>{this.props.validateButton.removeAttribute("disabled");},});}else{this._sign();}}
async getAuthDialog(){if(this.props.authMethod==="sms"&&!this.signatureInfo.smsToken){const credits=await rpc("/sign/has_sms_credits");if(credits){return{component:SMSSignerDialog,props:{signerPhone:this.props.signerPhone,postValidation:(code)=>{this.signatureInfo.smsToken=code;return this._signDocument();},},};}
return false;}
return false;}}
return __exports;});;

/* /sign/static/src/components/sign_request/utils.js */
odoo.define('@sign/components/sign_request/utils',['@web/core/utils/timing'],function(require){'use strict';let __exports={};const{setRecurringAnimationFrame,debounce}=require("@web/core/utils/timing");const MIN_ID=-(2**30);__exports.startHelperLines=startHelperLines;function startHelperLines(target){function showHelperLinesAt(signItem,coords){const calculate={left:(pos)=>({left:`${pos.left}px`}),right:(pos)=>({left:`${pos.left + pos.width}px`}),top:(pos)=>({top:`${pos.top}px`}),bottom:(pos)=>({top:`${pos.top + pos.height}px`}),};const rect=signItem.getBoundingClientRect();const positions={top:(coords&&coords.y)||rect.top,left:(coords&&coords.x)||rect.left,height:signItem.clientHeight,width:signItem.clientWidth,};for(const line in helperLines){const newPos=calculate[line](positions);Object.assign(helperLines[line].style,{visibility:"visible",...newPos,});}}
function hideHelperLines(){for(const line in helperLines){helperLines[line].style.visibility="hidden";}}
const top=target.createElement("div");const bottom=target.createElement("div");top.className="o_sign_drag_helper o_sign_drag_top_helper";bottom.className="o_sign_drag_helper o_sign_drag_top_helper";const left=target.createElement("div");const right=target.createElement("div");left.className="o_sign_drag_helper o_sign_drag_side_helper";right.className="o_sign_drag_helper o_sign_drag_side_helper";const body=target.querySelector("body");body.appendChild(top);body.appendChild(bottom);body.appendChild(left);body.appendChild(right);const helperLines={top,bottom,left,right,};return{show:showHelperLinesAt,hide:hideHelperLines,};}
__exports.isVisible=isVisible;function isVisible(e){return e&&!!(e.offsetWidth||e.offsetHeight||e.getClientRects().length);}
__exports.offset=offset;function offset(el){const box=el.getBoundingClientRect();const docElem=document.documentElement;return{top:box.top+window.scrollY-docElem.clientTop,left:box.left+window.scrollY-docElem.clientLeft,};}
__exports.normalizePosition=normalizePosition;function normalizePosition(position,itemDimension){if(position<0){return 0;}else if(position+itemDimension>1.0){return 1.0-itemDimension;}
return position;}
__exports.normalizeDimension=normalizeDimension;function normalizeDimension(dimension,position){if(position+dimension>1){return 1-position;}
return dimension;}
__exports.generateRandomId=generateRandomId;function generateRandomId(){return Math.floor(Math.random()*MIN_ID)-1;}
__exports.startSmoothScroll=startSmoothScroll;function startSmoothScroll(container,element,dragImageElement=null,helperLines){const boundary=0.2;const directions={up:-1,down:1,left:-1,right:1,};const mouse={};const containerOffset=offset(container);const dragAmount=10;const el=dragImageElement||element;function updateMousePosition(e){mouse.x=e.clientX-containerOffset.left;mouse.y=e.clientY-containerOffset.top;helperLines.show(el,{x:e.clientX,y:e.clientY});}
const debouncedOnMouseMove=debounce(updateMousePosition,"animationFrame",true);container.addEventListener("dragover",debouncedOnMouseMove);const cleanup=setRecurringAnimationFrame(()=>{const{x,y}=mouse;let scrollX,scrollY=0;if(x<=container.clientWidth*boundary){scrollX=directions.left*dragAmount;}else if(x>=container.clientWidth*(1-boundary)){scrollX=directions.right*dragAmount;}
if(y<=container.clientHeight*boundary){scrollY=directions.up*dragAmount;}else if(y>=container.clientHeight*(1-boundary)){scrollY=directions.down*dragAmount;}
container.scrollBy(scrollX,scrollY);});return()=>{cleanup();container.removeEventListener("dragover",debouncedOnMouseMove);helperLines.hide();};}
__exports.startResize=startResize;function startResize(signItem,onResize){const page=signItem.el.parentElement;const mouse={};const resizeHandleWidth=signItem.el.querySelector(".resize_width");const resizeHandleHeight=signItem.el.querySelector(".resize_height");const resizeHandleBoth=signItem.el.querySelector(".resize_both");const computeDimensions=(e)=>{const{direction,x,y}=mouse;const computedStyle=getComputedStyle(signItem.el);const signItemAbsoluteWidth=parseInt(computedStyle.width);const signItemAbsoluteHeight=parseInt(computedStyle.height);const dX=e.clientX-x;const dY=e.clientY-y;Object.assign(mouse,{x:e.clientX,y:e.clientY,});const factor={x:(dX+signItemAbsoluteWidth)/signItemAbsoluteWidth,y:(dY+signItemAbsoluteHeight)/signItemAbsoluteHeight,};if(dX<0&&Math.abs(dX)>=signItemAbsoluteWidth){factor.x=1;}
if(dY<0&&Math.abs(dY)>=signItemAbsoluteHeight){factor.y=1;}
const width=direction==="width"||direction==="both"?Math.round(normalizeDimension(factor.x*signItem.data.width,signItem.data.posX)*1000)/1000:signItem.data.width;const height=direction==="height"||direction==="both"?Math.round(normalizeDimension(factor.y*signItem.data.height,signItem.data.posY)*1000)/1000:signItem.data.height;return{height,width};};const handleMouseMove=(e)=>{if(signItem.el.classList.contains("o_resizing")){e.preventDefault();onResize(signItem,computeDimensions(e),false);}};const debouncedOnMouseMove=debounce(handleMouseMove,"animationFrame",true);const handleMouseDown=(e,direction)=>{e.preventDefault();signItem.el.classList.add("o_resizing");Object.assign(mouse,{x:e.clientX,y:e.clientY,direction});page.addEventListener("mousemove",debouncedOnMouseMove);};resizeHandleWidth.addEventListener("mousedown",(e)=>handleMouseDown(e,"width"));resizeHandleHeight.addEventListener("mousedown",(e)=>handleMouseDown(e,"height"));resizeHandleBoth.addEventListener("mousedown",(e)=>handleMouseDown(e,"both"));page.addEventListener("mouseup",(e)=>{if(signItem.el.classList.contains("o_resizing")){signItem.el.classList.remove("o_resizing");page.removeEventListener("mousemove",debouncedOnMouseMove);onResize(signItem,computeDimensions(e),true);}});}
__exports.pinchService=pinchService;function pinchService(target,handlers){let prevDiff=null;const{increaseDistanceHandler,decreaseDistanceHandler}=handlers;target.addEventListener("touchstart",reset);target.addEventListener("touchmove",touchMove);target.addEventListener("touchend",reset);function touchMove(e){const touches=e.touches;if(touches.length===2){const deltaX=touches[0].pageX-touches[1].pageX;const deltaY=touches[0].pageY-touches[1].pageY;const curDiff=Math.hypot(deltaX,deltaY);if(prevDiff===null){prevDiff=curDiff;}
const scale=prevDiff/curDiff;if(scale<1){decreaseDistanceHandler(e);}else if(scale>1){increaseDistanceHandler(e);}}}
function reset(){prevDiff=null;}
return()=>{target.removeEventListener("touchstart",reset);target.removeEventListener("touchmove",touchMove);target.removeEventListener("touchend",reset);};}
__exports.buildPDFViewerURL=buildPDFViewerURL;function buildPDFViewerURL(attachmentLocation,isSmall){const date=new Date().toISOString();const baseURL="/web/static/lib/pdfjs/web/viewer.html";attachmentLocation=encodeURIComponent(attachmentLocation).replace(/'/g,"%27").replace(/"/g,"%22");const zoom=isSmall?"page-fit":"page-width";return`${baseURL}?unique=${date}&file=${attachmentLocation}#page=1&zoom=${zoom}`;}
return __exports;});;

/* /sign/static/src/backend_components/cog_menu/sign_request_cog_menu.js */
odoo.define('@sign/backend_components/cog_menu/sign_request_cog_menu',['@web/core/dropdown/dropdown_item','@web/core/registry','@odoo/owl','@web/core/utils/hooks','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{registry}=require("@web/core/registry");const{Component}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const cogMenuRegistry=registry.category("cogMenu");const SignRequestCogMenu=__exports.SignRequestCogMenu=class SignRequestCogMenu extends Component{static template="sign.SignRequestCogMenu";static components={DropdownItem};static props={};setup(){this.action=useService("action");}
signRequest(){const resModel=this.action.currentController.props.resModel;const resId=this.action.currentController.currentState?.resId;const referenceDoc=resId&&resModel?`${resModel},${resId}`:false;if(referenceDoc){this.action.doAction({name:_t("Signature Request"),type:"ir.actions.act_window",view_mode:"form",views:[[false,"form"]],target:"new",res_model:"sign.send.request",},{additionalContext:{sign_directly_without_mail:false,default_reference_doc:referenceDoc,},});}}}
const SignRequestCogMenuItem=__exports.SignRequestCogMenuItem={Component:SignRequestCogMenu,isDisplayed:async({config,searchModel})=>{const is_mail_thread=searchModel.searchViewFields?.['message_ids'];return(searchModel.resModel!=="sign.request"&&is_mail_thread&&config.viewType==="form"&&config.actionType==="ir.actions.act_window");},groupNumber:1,};cogMenuRegistry.add("sign-request-menu",SignRequestCogMenuItem,{sequence:10});return __exports;});;

/* /sign/static/src/backend_components/editable_pdf_iframe_mixin.js */
odoo.define('@sign/backend_components/editable_pdf_iframe_mixin',['@web/core/utils/render','@sign/components/sign_request/utils','@sign/dialogs/initials_all_pages_dialog','@web/core/browser/feature_detection'],function(require){'use strict';let __exports={};const{renderToString}=require("@web/core/utils/render");const{startHelperLines,offset,normalizePosition,generateRandomId,startSmoothScroll,startResize,}=require("@sign/components/sign_request/utils");const{InitialsAllPagesDialog}=require("@sign/dialogs/initials_all_pages_dialog");const{isMobileOS}=require("@web/core/browser/feature_detection");const EditablePDFIframeMixin=__exports.EditablePDFIframeMixin=(pdfClass)=>class extends pdfClass{onResizeItem(signItem,change,end=false){this.setCanvasVisibility("hidden");this.helperLines.show(signItem.el);if(change.width>=0.055&&change.height>=0.01){Object.assign(signItem.el.style,{height:`${change.height * 100}%`,width:`${change.width * 100}%`,});Object.assign(signItem.data,{width:change.width,height:change.height,updated:true,});Object.assign(this.getSignItemById(signItem.data.id).data,{width:change.width,height:change.height,updated:true,});this.updateSignItemFontSize(signItem);}
if(end){this.helperLines.hide();this.setCanvasVisibility("visible");this.saveChanges();}}
get allowEdit(){return false;}
getSignItemById(id){for(const page in this.signItems){if(this.signItems[page].hasOwnProperty(id)){return this.signItems[page][id];}}
return undefined;}
setCanvasVisibility(visibility){const canvas_layer=this.getPageContainer(1).parentElement.parentElement.querySelector("#canvas_layer_0");if(canvas_layer){canvas_layer.style.visibility=visibility;}}
renderSignItem(){const signItem=super.renderSignItem(...arguments);if(isMobileOS()){for(const node of signItem.querySelectorAll(".o_sign_config_handle, .o_resize_handler")){node.classList.add("d-none");}}
return signItem;}
renderSignItems(){super.renderSignItems();if(this.allowEdit){this.startDragAndDrop();this.helperLines=startHelperLines(this.root);}}
startDragAndDrop(){this.root.querySelectorAll(".page").forEach((page)=>{page.addEventListener("dragover",(e)=>this.onDragOver(e));page.addEventListener("drop",(e)=>this.onDrop(e));});this.root.querySelectorAll(".o_sign_field_type_button").forEach((sidebarItem)=>{sidebarItem.setAttribute("draggable",true);sidebarItem.addEventListener("dragstart",(e)=>this.onSidebarDragStart(e));sidebarItem.addEventListener("dragend",(e)=>this.onSidebarDragEnd(e));});}
onDragStart(e){this.setCanvasVisibility("hidden");const signItem=e.currentTarget.parentElement.parentElement.parentElement;const page=signItem.parentElement;e.dataTransfer.effectAllowed="move";e.dataTransfer.setData("page",page.dataset.pageNumber);e.dataTransfer.setData("id",signItem.dataset.id);e.dataTransfer.setDragImage(signItem,0,0);requestAnimationFrame(()=>{if(signItem){signItem.style.visibility="hidden";}},0);this.scrollCleanup=startSmoothScroll(this.root.querySelector("#viewerContainer"),signItem,null,this.helperLines);}
onDragEnd(e){this.scrollCleanup();let signItem=e.currentTarget.parentElement.parentElement.parentElement;if(signItem)
signItem.style.visibility="visible";this.setCanvasVisibility("visible");}
onSidebarDragStart(e){this.setCanvasVisibility("hidden");const signTypeElement=e.currentTarget;const firstPage=this.root.querySelector('.page[data-page-number="1"]');firstPage.insertAdjacentHTML("beforeend",renderToString("sign.signItem",this.createSignItemDataFromType(signTypeElement.dataset.itemTypeId)));this.ghostSignItem=firstPage.lastChild;const itemData=this.signItemTypesById[signTypeElement.dataset.itemTypeId];this.updateSignItemFontSize({el:this.ghostSignItem,data:{type:itemData.item_type}});e.dataTransfer.setData("typeId",signTypeElement.dataset.itemTypeId);e.dataTransfer.setDragImage(this.ghostSignItem,0,0);this.scrollCleanup=startSmoothScroll(this.root.querySelector("#viewerContainer"),e.currentTarget,this.ghostSignItem,this.helperLines);requestAnimationFrame(()=>{if(this.ghostSignItem){this.ghostSignItem.style.visibility="hidden";}},0);}
onSidebarDragEnd(){this.scrollCleanup();const firstPage=this.root.querySelector('.page[data-page-number="1"]');firstPage.removeChild(this.ghostSignItem);this.ghostSignItem=false;this.setCanvasVisibility("visible");}
onDragOver(e){e.preventDefault();e.dataTransfer.dropEffect="move";}
onDrop(e){e.preventDefault();const page=e.currentTarget;const textLayer=page.querySelector(".textLayer");const targetPage=Number(page.dataset.pageNumber);const{top,left}=offset(textLayer);const typeId=e.dataTransfer.getData("typeId");const box=textLayer.getBoundingClientRect();const height=box.bottom-box.top;const width=box.right-box.left;if(typeId){const id=generateRandomId();const data=this.createSignItemDataFromType(typeId);const posX=Math.round(normalizePosition((e.pageX-left)/width,data.width)*1000)/1000;const posY=Math.round(normalizePosition((e.pageY-top)/height,data.height)*1000)/1000;Object.assign(data,{id,posX,posY,page:targetPage});if(data.type==="initial"){this.helperLines.hide();if(this.pageCount>1){return this.openDialogAfterInitialDrop(data);}}else if(data.type=="radio"){return this.addRadioSet(data);}
this.signItems[targetPage][id]={data,el:this.renderSignItem(data,page),};this.refreshSignItems();}else if(e.dataTransfer.getData("page")&&e.dataTransfer.getData("id")){const initialPage=Number(e.dataTransfer.getData("page"));const id=Number(e.dataTransfer.getData("id"));const signItem=this.signItems[initialPage][id];const signItemEl=signItem.el;const posX=Math.round(normalizePosition((e.pageX-left)/width,signItem.data.width)*1000)/1000;const posY=Math.round(normalizePosition((e.pageY-top)/height,signItem.data.height)*1000)/1000;if(initialPage!==targetPage){signItem.data.page=targetPage;this.signItems[targetPage][id]=signItem;delete this.signItems[initialPage][id];page.appendChild(signItemEl.parentElement.removeChild(signItemEl));}
Object.assign(signItem.data,{posX,posY,updated:true,});Object.assign(signItemEl.style,{top:`${posY * 100}%`,left:`${posX * 100}%`,visibility:"visible",});startResize(signItem,this.onResizeItem.bind(this));}else{return;}
this.saveChanges();}
enableCustom(signItem){super.enableCustom(signItem);if(signItem.data.isSignItemEditable){startResize(signItem,this.onResizeItem.bind(this));this.registerDragEventsForSignItem(signItem);}}
openDialogAfterInitialDrop(data){this.dialog.add(InitialsAllPagesDialog,{addInitial:(role,targetAllPages)=>{data.responsible=role;this.currentRole=role;this.addInitialSignItem(data,targetAllPages);},responsible:this.currentRole,roles:this.signRolesById,pageCount:this.pageCount});}
addInitialSignItem(data,targetAllPages=false){if(targetAllPages){for(let page=1;page<=this.pageCount;page++){const hasSignatureItemsAtPage=Object.values(this.signItems[page]).some(({data})=>data.type==="signature");if(!hasSignatureItemsAtPage){const id=generateRandomId();const signItemData={...data,...{page,id}};this.signItems[page][id]={data:signItemData,el:this.renderSignItem(signItemData,this.getPageContainer(page)),};}}}else{this.signItems[data.page][data.id]={data,el:this.renderSignItem(data,this.getPageContainer(data.page)),};}
this.saveChanges();}
addRadioSet(data){const id2=generateRandomId();const signItemData1={...data};const signItemData2={...data};signItemData2['id']=id2;signItemData2['posY']+=0.025;this.signItems[data.page][data.id]={data:signItemData1,el:this.renderSignItem(signItemData1,this.getPageContainer(data.page)),}
this.signItems[data.page][id2]={data:signItemData2,el:this.renderSignItem(signItemData2,this.getPageContainer(data.page)),}
this.refreshSignItems();this.saveChanges();}
saveChanges(){}
registerDragEventsForSignItem(signItem){const handle=signItem.el.querySelector(".o_sign_config_handle");handle.setAttribute("draggable",true);handle.addEventListener("dragstart",(e)=>this.onDragStart(e));handle.addEventListener("dragend",(e)=>this.onDragEnd(e));}
deleteSignItem(signItem){const{id,page}=signItem.data;signItem.el.parentElement.removeChild(signItem.el);delete this.signItems[page][id];this.saveChanges();}
async deleteSignItems(deletedItems){deletedItems.forEach((signItem)=>{this.deletedSignItemIds.push(signItem.data.id);signItem.el.parentElement.removeChild(signItem.el);delete this.signItems[signItem.data.page][signItem.data.id];if(signItem.data.type=="radio"){this.radioSets[signItem.data.radio_set_id].num_options--;this.radioSets[signItem.data.radio_set_id].radio_item_ids=this.radioSets[signItem.data.radio_set_id].radio_item_ids.filter((id)=>id!=signItem.data.id);}})
await this.saveChanges();}};return __exports;});;

/* /sign/static/src/backend_components/multi_file_upload.js */
odoo.define('@sign/backend_components/multi_file_upload',[],function(require){'use strict';let __exports={};const addNewFiles=(files)=>{sessionStorage.setItem("signMultiFileData",JSON.stringify(files));return true;};const getNext=()=>{return(JSON.parse(sessionStorage.getItem("signMultiFileData"))||[]).shift();};const removeFile=(id)=>{const files=JSON.parse(sessionStorage.getItem("signMultiFileData"))||[];sessionStorage.setItem("signMultiFileData",JSON.stringify(files.reduce((files,file)=>{if(file.template===id){return files;}
files.push(file);return files;},[])));};const multiFileUpload=__exports.multiFileUpload={addNewFiles:addNewFiles,getNext:getNext,removeFile:removeFile,};__exports[Symbol.for("default")]=multiFileUpload;return __exports;});;

/* /sign/static/src/backend_components/sign_request/edit_while_signing_signable_pdf_iframe.js */
odoo.define('@sign/backend_components/sign_request/edit_while_signing_signable_pdf_iframe',['@web/core/l10n/translation','@web/core/utils/render','@sign/components/sign_request/signable_PDF_iframe','@sign/backend_components/editable_pdf_iframe_mixin'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{renderToString}=require("@web/core/utils/render");const{SignablePDFIframe}=require("@sign/components/sign_request/signable_PDF_iframe");const{EditablePDFIframeMixin}=require("@sign/backend_components/editable_pdf_iframe_mixin");const EditWhileSigningSignablePDFIframe=__exports.EditWhileSigningSignablePDFIframe=class EditWhileSigningSignablePDFIframe extends EditablePDFIframeMixin(SignablePDFIframe){toggleSidebar(){const sidebar=this.root.querySelector(".o_sign_field_type_toolbar");sidebar.classList.toggle("d-none");}
renderSidebar(){if(this.allowEdit){const sideBar=renderToString("sign.signItemTypesSidebar",{signItemTypes:this.props.signItemTypes.filter((type)=>type.editWhileSigningAllowed),sidebarHidden:true,});this.root.body.insertAdjacentHTML("afterbegin",sideBar);this.signRolesById={};this.signRolesById[this.currentRole]={name:this.props.currentName};}}
get allowEdit(){return!this.readonly&&this.props.templateEditable&&!this.env.isSmall;}
registerCloseEvent(signItem){const configArea=signItem.el.querySelector(".o_sign_config_area");const closeButton=configArea.querySelector(".fa-times");closeButton.addEventListener("click",()=>{this.deleteSignItem(signItem);this.checkSignItemsCompletion();},{once:true});}
showBanner(){super.showBanner();const nameList=this.signInfo.get("nameList");if(nameList&&nameList.length>0){const nextName=nameList[0];const bannerTitle=_t("Validate & the next signatory is “%s”",nextName);this.props.validateButton.textContent=bannerTitle;}}
createSignItemDataFromType(typeId){const type=this.signItemTypesById[typeId];return{required:true,editMode:true,readonly:true,updated:true,isSignItemEditable:true,responsible:this.currentRole,option_ids:[],options:[],name:type.name,width:type.defaultWidth,height:type.defaultHeight,alignment:"center",type:type.item_type,placeholder:type.placeholder,classes:"o_sign_sign_item_required",style:`width: ${type.defaultWidth * 100}%; height: ${type.defaultHeight * 100}%;`,type_id:type.id,};}
enableCustom(signItem){super.enableCustom(signItem);if(signItem.data.isSignItemEditable){this.registerCloseEvent(signItem);}}}
return __exports;});;

/* /sign/static/src/backend_components/sign_request/sign_request_action.js */
odoo.define('@sign/backend_components/sign_request/sign_request_action',['@web/core/network/rpc','@web/core/registry','@web/core/utils/hooks','@odoo/owl','@sign/backend_components/sign_request/sign_request_control_panel','@sign/components/sign_request/document_signable','@sign/components/sign_request/PDF_iframe','@web/webclient/actions/action_service'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{Component,onWillStart,useRef,markup}=require("@odoo/owl");const{SignRequestControlPanel}=require("@sign/backend_components/sign_request/sign_request_control_panel");const{Document}=require("@sign/components/sign_request/document_signable");const{PDFIframe}=require("@sign/components/sign_request/PDF_iframe");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");const SignRequest=__exports.SignRequest=class SignRequest extends Component{static template="sign.SignRequest";static components={SignRequestControlPanel,Document,};static props={...standardActionServiceProps};get markupHtml(){return markup(this.html);}
get documentProps(){return{parent:this.documentRoot,PDFIframeClass:PDFIframe,};}
setup(){this.orm=useService("orm");this.notification=useService("notification");this.action=useService("action");this.signInfo=useService("signInfo");const action=this.props.action;const context=action?.context;this.signInfo.reset({documentId:context.id||action.params.id,signRequestToken:context.token||action.params.token,createUid:context.create_uid||action.params.create_uid,signRequestState:context.state||action.params.state,requestItemStates:context.request_item_states,needToSign:context.need_to_sign,todayFormattedDate:context.today_formatted_date,});if(this.signInfo){this.props.updateActionState({id:this.signInfo.get("documentId"),token:this.signInfo.get("signRequestToken"),create_uid:this.signInfo.get("createUid"),state:this.signInfo.get("signRequestState"),});}
this.documentRoot=useRef("sign-document");onWillStart(()=>this.fetchDocument());}
async fetchDocument(){if(!this.signInfo.get("documentId")){return this.goBackToKanban();}
const{html,context}=await rpc(`/sign/get_document/${this.signInfo.get("documentId")}/${this.signInfo.get(
                "signRequestToken"
            )}`);this.html=html.trim();if(Object.keys(context).length>0){this.signInfo.set({refusalAllowed:context.refusal_allowed,signRequestItemToken:this.signInfo.get("signRequestToken"),signRequestToken:context.sign_request_token,});}
const parser=new DOMParser();const doc=parser.parseFromString(this.html,"text/html");this.signerStatus=doc.querySelector(".o_sign_cp_pager");}
goBackToKanban(){return this.action.doAction("sign.sign_request_action",{clearBreadcrumbs:true});}
get controlPanelProps(){return{signerStatus:this.signerStatus,goBackToKanban:this.goBackToKanban.bind(this),};}}
registry.category("actions").add("sign.Document",SignRequest);return __exports;});;

/* /sign/static/src/backend_components/sign_request/sign_request_control_panel.js */
odoo.define('@sign/backend_components/sign_request/sign_request_control_panel',['@web/core/user','@web/core/l10n/translation','@odoo/owl','@web/core/utils/hooks','@web/search/control_panel/control_panel','@sign/backend_components/multi_file_upload'],function(require){'use strict';let __exports={};const{user}=require("@web/core/user");const{_t}=require("@web/core/l10n/translation");const{Component,useEffect,useComponent,markup}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{ControlPanel}=require("@web/search/control_panel/control_panel");const multiFileUpload=require("@sign/backend_components/multi_file_upload")[Symbol.for("default")];function useResendButtons(){const component=useComponent();const onClickResend=async(e)=>{const parent=e.currentTarget.parentNode;const signRequestItemId=parseInt(parent.dataset.id);await component.orm.call("sign.request.item","send_signature_accesses",[signRequestItemId],{context:user.context});e.target.innerText=_t("Resent!");};useEffect((showResendButtons)=>{if(!showResendButtons){return;}
const status=document.querySelector("div.signer-status");const signerNames=status.querySelectorAll(".o_sign_signer_status.o_sign_signer_waiting");Array.from(signerNames).forEach((signerNameEl)=>{const stateSet=component.signInfo.get("requestItemStates")[signerNameEl.dataset.id];const title=stateSet?_t("Resend the invitation"):_t("Send the invitation");const text=stateSet?_t("Resend"):_t("Send");const button=document.createElement("button");button.title=title;button.innerText=text;button.className="o_sign_resend_access_button btn btn-link ms-2 me-2";button.style="vertical-align: baseline;";signerNameEl.insertBefore(button,signerNameEl.firstChild);button.addEventListener("click",onClickResend);});},()=>[component.showResendButtons]);}
const SignRequestControlPanel=__exports.SignRequestControlPanel=class SignRequestControlPanel extends Component{static template="sign.SignRequestControlPanel";static components={ControlPanel,};static props={signerStatus:{type:Object,optional:true,},goBackToKanban:{type:Function},};setup(){this.controlPanelDisplay={};this.action=useService("action");this.orm=useService("orm");this.signInfo=useService("signInfo");this.nextTemplate=multiFileUpload.getNext();useResendButtons();}
get markupSignerStatus(){return markup(this.props.signerStatus.innerHTML);}
get showResendButtons(){const documentSent=this.signInfo.get("signRequestState")==="sent";const isAuthor=this.signInfo.get("createUid")===user.userId;return isAuthor&&documentSent;}
get allowCancel(){const needToSign=this.signInfo.get("needToSign");const state=this.signInfo.get("signRequestState");return needToSign&&!["signed","canceled"].includes(state);}
async signDocument(){const action=await this.orm.call("sign.request","go_to_signable_document",[[this.signInfo.get("documentId")],]);action.name=_t("Sign");this.action.doAction(action);}
async cancelDocument(){await this.orm.call("sign.request","cancel",[this.signInfo.get("documentId")]);const result=await this.orm.call("sign.request","get_close_values",[[this.signInfo.get("documentId")]],);const context=result.custom_action?{}:{clearBreadcrumbs:true};this.env.services.action.doAction(result.action,context);}
async goToNextDocument(){const templateName=this.nextTemplate.name;const templateId=parseInt(this.nextTemplate.template);multiFileUpload.removeFile(this.nextTemplate.template);await this.action.doAction({type:"ir.actions.client",tag:"sign.Template",name:_t("Template %s",templateName),params:{sign_edit_call:"sign_send_request",id:templateId,sign_directly_without_mail:false,},},{clear_breadcrumbs:true});}}
return __exports;});;

/* /sign/static/src/backend_components/sign_request/signable_sign_request_action.js */
odoo.define('@sign/backend_components/sign_request/signable_sign_request_action',['@web/core/utils/hooks','@web/core/registry','@sign/components/sign_request/document_signable','@sign/backend_components/sign_request/sign_request_action','@odoo/owl','@sign/backend_components/sign_request/signable_sign_request_control_panel','@sign/backend_components/sign_request/edit_while_signing_signable_pdf_iframe'],function(require){'use strict';let __exports={};const{useBus}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const{Document}=require("@sign/components/sign_request/document_signable");const{SignRequest}=require("@sign/backend_components/sign_request/sign_request_action");const{useSubEnv,EventBus}=require("@odoo/owl");const{SignableRequestControlPanel}=require("@sign/backend_components/sign_request/signable_sign_request_control_panel");const{EditWhileSigningSignablePDFIframe}=require("@sign/backend_components/sign_request/edit_while_signing_signable_pdf_iframe");class EditWhileSigningDocument extends Document{setup(){super.setup();useBus(this.env.editWhileSigningBus,"toggleEditBar",()=>{this.iframe.toggleSidebar();});}}
const SignableSignRequest=__exports.SignableSignRequest=class SignableSignRequest extends SignRequest{static components={...SignableSignRequest.components,Document:EditWhileSigningDocument,SignRequestControlPanel:SignableRequestControlPanel,};setup(){super.setup();this.signInfo.set({editWhileSigning:this.props.action.context.template_editable,tokenList:this.tokenList,nameList:this.nameList,});useSubEnv({editWhileSigningBus:new EventBus(),});}
get nameList(){return this.props.action.context.name_list;}
get tokenList(){return this.props.action.context.token_list;}
get documentProps(){return{...super.documentProps,PDFIframeClass:EditWhileSigningSignablePDFIframe,};}}
registry.category("actions").add("sign.SignableDocument",SignableSignRequest);return __exports;});;

/* /sign/static/src/backend_components/sign_request/signable_sign_request_control_panel.js */
odoo.define('@sign/backend_components/sign_request/signable_sign_request_control_panel',['@web/search/control_panel/control_panel','@web/core/utils/hooks','@odoo/owl','@sign/dialogs/dialogs'],function(require){'use strict';let __exports={};const{ControlPanel}=require("@web/search/control_panel/control_panel");const{useService}=require("@web/core/utils/hooks");const{Component,markup}=require("@odoo/owl");const{SignRefusalDialog}=require("@sign/dialogs/dialogs");const SignableRequestControlPanel=__exports.SignableRequestControlPanel=class SignableRequestControlPanel extends Component{static template="sign.SignSignableRequestControlPanel";static components={ControlPanel,};static props={signerStatus:{type:"String"},goBackToKanban:{type:Function},};setup(){this.controlPanelDisplay={};this.action=useService("action");this.orm=useService("orm");this.dialog=useService("dialog");this.signInfo=useService("signInfo");}
refuseDocument(){this.dialog.add(SignRefusalDialog);}
get markupSignerStatus(){return markup(this.props.signerStatus.innerHTML);}
toggleEditBar(){this.env.editWhileSigningBus.trigger("toggleEditBar");}}
return __exports;});;

/* /sign/static/src/backend_components/sign_template/sign_item_custom_popover.js */
odoo.define('@sign/backend_components/sign_template/sign_item_custom_popover',['@web/core/l10n/translation','@web/model/record','@web/views/fields/many2many_tags/many2many_tags_field','@web/views/fields/many2one/many2one_field','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Record}=require("@web/model/record");const{many2ManyTagsField,Many2ManyTagsField,}=require("@web/views/fields/many2many_tags/many2many_tags_field");const{Many2OneField}=require("@web/views/fields/many2one/many2one_field");const{Component,useState}=require("@odoo/owl");const actionFieldsGet={option_ids:{type:"many2many",relation:"sign.item.option",string:"Selected Options"},responsible_id:{type:"many2one",relation:"sign.item.role",string:"Responsible"},};function getActionActiveFields(){const activeFields={};for(const fName of Object.keys(actionFieldsGet)){if(actionFieldsGet[fName].type==="many2many"){const related=Object.fromEntries(many2ManyTagsField.relatedFields({options:{}}).map((f)=>[f.name,f]));activeFields[fName]={related:{activeFields:related,fields:related,},};}else{activeFields[fName]=actionFieldsGet[fName];}}
return activeFields;}
const SignItemCustomPopover=__exports.SignItemCustomPopover=class SignItemCustomPopover extends Component{static template="sign.SignItemCustomPopover";static components={Record,Many2ManyTagsField,Many2OneField,};static props={id:{type:Number},alignment:{type:String},header_title:{type:String},placeholder:{type:String},required:{type:Boolean},option_ids:{type:Array},responsible:{type:Number},onValidate:{type:Function},updateSelectionOptions:{type:Function},updateRoles:{type:Function},type:{type:String},onDelete:{type:Function},onClose:{type:Function},debug:{type:String},roles:{type:Object},close:{type:Function},num_options:{type:Number,optional:true},radio_set_id:{type:Number,optional:true},};setup(){this.alignmentOptions=[{title:_t("Left"),key:"left"},{title:_t("Center"),key:"center"},{title:_t("Right"),key:"right"},];this.state=useState({alignment:this.props.alignment,placeholder:this.props.placeholder,required:this.props.required,option_ids:this.props.option_ids,responsible:this.props.responsible,num_options:this.props.num_options,radio_set_id:this.props.radio_set_id,});this.signItemFieldsGet=getActionActiveFields();this.typesWithAlignment=new Set(["text","textarea"]);}
handleNumOptionsChange(value){if(Number(value)<2){return;}
this.state['num_options']=Number(value);}
onChange(key,value){this.state[key]=value;}
onValidate(){this.props.onValidate(this.state);}
get recordProps(){return{mode:"edit",resModel:"sign.item",resId:this.props.id,fieldNames:this.signItemFieldsGet,activeFields:this.signItemFieldsGet,onRecordChanged:async(record,changes)=>{if(changes.option_ids){const ids=record.data.option_ids.currentIds;this.state.option_ids=ids;this.props.updateSelectionOptions(ids);}
if(changes.responsible_id){const id=changes.responsible_id;this.state.responsible=id;this.props.updateRoles(id);}},};}
getMany2XProps(record,fieldName){return{name:fieldName,id:fieldName,record,readonly:false,canCreateEdit:false,canQuickCreate:true,};}
getOptionsProps(record,fieldName){return{...this.getMany2XProps(record,fieldName),domain:[["available","=",true]],noSearchMore:true,};}
get showAlignment(){return this.typesWithAlignment.has(this.props.type);}}
return __exports;});;

/* /sign/static/src/backend_components/sign_template/sign_template_action.js */
odoo.define('@sign/backend_components/sign_template/sign_template_action',['@web/core/l10n/translation','@web/core/registry','@web/core/user','@web/core/utils/hooks','@sign/backend_components/sign_template/sign_template_control_panel','@sign/backend_components/sign_template/sign_template_body','@odoo/owl','@web/webclient/actions/action_service'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{SignTemplateControlPanel}=require("@sign/backend_components/sign_template/sign_template_control_panel");const{SignTemplateBody}=require("@sign/backend_components/sign_template/sign_template_body");const{Component,onWillStart}=require("@odoo/owl");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");const SignTemplate=__exports.SignTemplate=class SignTemplate extends Component{static template="sign.Template";static components={SignTemplateControlPanel,SignTemplateBody,};static props={...standardActionServiceProps,};setup(){this.orm=useService("orm");this.notification=useService("notification");this.action=useService("action");const params=this.props.action.params;this.templateID=params.id;if(this.templateID){this.props.updateActionState({id:this.templateID});}
this.actionType=params.sign_edit_call||"";this.resModel=params.resModel||"";onWillStart(async()=>{if(!this.templateID){return this.goBackToKanban();}
return Promise.all([this.checkManageTemplateAccess(),this.fetchTemplateData()]);});}
async fetchTemplateData(){const template=await this.orm.call("sign.template","read",[[this.templateID],["id","attachment_id","has_sign_requests","responsible_count","display_name","active"],]);if(!template.length){this.templateID=undefined;this.notification.add(_t("The template doesn't exist anymore."),{title:_t("Warning"),type:"warning",});return;}
this.signTemplate=template[0];this.hasSignRequests=this.signTemplate.has_sign_requests;this.responsibleCount=this.signTemplate.responsible_count;this.attachmentLocation=`/web/content/${this.signTemplate.attachment_id[0]}`;return Promise.all([this.fetchSignItemData(),this.fetchAttachment(),this.fetchSignItemTypes(),this.fetchSignRoles(),this.fetchRadioSets(),]);}
async fetchRadioSets(){this.radioSets=await this.orm.call("sign.template","get_radio_sets_dict",[this.signTemplate.id]);}
async fetchSignItemTypes(){this.signItemTypes=await this.orm.call("sign.item.type","search_read",[],{context:user.context,});}
async fetchSignRoles(){this.signRoles=await this.orm.call("sign.item.role","search_read",[],{context:user.context,});}
async fetchSignItemData(){this.signItems=await this.orm.call("sign.item","search_read",[[["template_id","=",this.signTemplate.id]]],{context:user.context});this.signItems.forEach((item)=>{item.radio_set_id=item?.radio_set_id[0]||undefined;});this.signItemOptions=await this.orm.call("sign.item.option","search_read",[[],["id","value"]],{context:user.context});}
async fetchAttachment(){const attachment=await this.orm.call("ir.attachment","read",[[this.signTemplate.attachment_id[0]],["mimetype","name"]],{context:user.context});this.signTemplateAttachment=attachment[0];this.isPDF=this.signTemplateAttachment.mimetype.indexOf("pdf")>-1;}
async checkManageTemplateAccess(){this.manageTemplateAccess=await user.hasGroup("sign.manage_template_access");}
goBackToKanban(){return this.action.doAction("sign.sign_template_action",{clearBreadcrumbs:true});}}
registry.category("actions").add("sign.Template",SignTemplate);return __exports;});;

/* /sign/static/src/backend_components/sign_template/sign_template_body.js */
odoo.define('@sign/backend_components/sign_template/sign_template_body',['@web/core/l10n/translation','@web/core/utils/hooks','@sign/backend_components/sign_template/sign_template_iframe','@sign/backend_components/sign_template/sign_template_top_bar','@odoo/owl','@sign/components/sign_request/utils','@web/core/confirmation_dialog/confirmation_dialog'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{SignTemplateIframe}=require("@sign/backend_components/sign_template/sign_template_iframe");const{SignTemplateTopBar}=require("@sign/backend_components/sign_template/sign_template_top_bar");const{Component,useRef,useEffect,onWillUnmount}=require("@odoo/owl");const{buildPDFViewerURL}=require("@sign/components/sign_request/utils");const{AlertDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const SignTemplateBody=__exports.SignTemplateBody=class SignTemplateBody extends Component{static template="sign.SignTemplateBody";static components={SignTemplateTopBar,};static props={signItemTypes:{type:Array},signItems:{type:Array},signRoles:{type:Array},radioSets:{type:Object},hasSignRequests:{type:Boolean},signItemOptions:{type:Array},attachmentLocation:{type:String},signTemplate:{type:Object},goBackToKanban:{type:Function},manageTemplateAccess:{type:Boolean},isPDF:{type:Boolean},resModel:{type:String},};setup(){this.orm=useService("orm");this.notification=useService("notification");this.popover=useService("popover");this.dialog=useService("dialog");this.PDFIframe=useRef("PDFIframe");this.PDFViewerURL=buildPDFViewerURL(this.props.attachmentLocation,this.env.isSmall);useEffect(()=>{return this.waitForPDF();},()=>[]);onWillUnmount(()=>{if(this.iframe){this.saveTemplate();this.iframe.unmount();this.iframe=null;if(this.props.signTemplate.active){this.notification.add(_t("Saved"),{type:"success"});}}});}
waitForPDF(){this.PDFIframe.el.onload=()=>setTimeout(()=>this.doPDFPostLoad(),1);}
doPDFPostLoad(){this.preventDroppingImagesOnViewerContainer();this.iframe=new SignTemplateIframe(this.PDFIframe.el.contentDocument,this.env,{orm:this.orm,popover:this.popover,dialog:this.dialog,},{signItemTypes:this.props.signItemTypes,signItems:this.props.signItems,signRoles:this.props.signRoles,hasSignRequests:this.props.hasSignRequests,signItemOptions:this.props.signItemOptions,radioSets:this.props.radioSets,saveTemplate:()=>this.saveTemplate(),getRadioSetInfo:(id)=>this.getRadioSetInfo(id),rotatePDF:()=>this.rotatePDF(),});}
preventDroppingImagesOnViewerContainer(){const viewerContainer=this.PDFIframe.el.contentDocument.querySelector("#viewerContainer");viewerContainer.addEventListener("drop",(e)=>{if(e.dataTransfer.files&&e.dataTransfer.files.length){e.stopImmediatePropagation();e.stopPropagation();}},true);}
onTemplateNameChange(e){const value=e.target.value;if(value!=""){this.props.signTemplate.display_name=value;this.saveTemplate(value);}}
async saveTemplate(newTemplateName){const[updatedSignItems,Id2UpdatedItem]=this.prepareTemplateData();const newId2ItemIdMap=await this.orm.call("sign.template","update_from_pdfviewer",[this.props.signTemplate.id,updatedSignItems,this.iframe.deletedSignItemIds,newTemplateName||"",]);if(!newId2ItemIdMap){this.showBlockedTemplateDialog();return false;}
for(const[newId,itemId]of Object.entries(newId2ItemIdMap)){Id2UpdatedItem[newId].id=itemId;}
return Id2UpdatedItem;}
async getRadioSetInfo(sign_item_ids){const info=await this.orm.call("sign.template","get_radio_set_info_by_item_id",[this.props.signTemplate.id,sign_item_ids,])
return info;}
prepareTemplateData(){const updatedSignItems={};const Id2UpdatedItem={};const items=this.iframe?.signItems??{};for(const page in items){for(const id in items[page]){const signItem=items[page][id].data;if(signItem.updated){Id2UpdatedItem[id]=signItem;const responsible=signItem.responsible;updatedSignItems[id]={type_id:signItem.type_id[0],required:signItem.required,name:signItem.placeholder||signItem.name,alignment:signItem.alignment,option_ids:signItem.option_ids,responsible_id:responsible,page:page,posX:signItem.posX,posY:signItem.posY,width:signItem.width,height:signItem.height,radio_set_id:signItem.radio_set_id,};if(id<0){updatedSignItems[id]["transaction_id"]=id;}}}}
return[updatedSignItems,Id2UpdatedItem];}
async rotatePDF(){const result=await this.orm.call("sign.template","rotate_pdf",[this.props.signTemplate.id,]);if(!result){this.showBlockedTemplateDialog();}
return result;}
showBlockedTemplateDialog(){this.dialog.add(AlertDialog,{confirm:()=>{this.props.goBackToKanban();},body:_t("Somebody is already filling a document which uses this template"),});}}
return __exports;});;

/* /sign/static/src/backend_components/sign_template/sign_template_control_panel.js */
odoo.define('@sign/backend_components/sign_template/sign_template_control_panel',['@web/core/l10n/translation','@web/core/utils/hooks','@odoo/owl','@web/search/control_panel/control_panel','@sign/backend_components/multi_file_upload'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const{ControlPanel}=require("@web/search/control_panel/control_panel");const{multiFileUpload}=require("@sign/backend_components/multi_file_upload");const SignTemplateControlPanel=__exports.SignTemplateControlPanel=class SignTemplateControlPanel extends Component{static template="sign.SignTemplateControlPanel";static components={ControlPanel,};static props={responsibleCount:{type:Number},isPDF:{type:Boolean},hasSignRequests:{type:Boolean},actionType:{type:String},signTemplate:{type:Object},goBackToKanban:{type:Function},};setup(){this.controlPanelDisplay={};this.nextTemplate=multiFileUpload.getNext()??false;this.action=useService("action");this.orm=useService("orm");}
get showShareButton(){return this.props.actionType!=="sign_send_request"&&this.props.responsibleCount<=1;}
onSendClick(){this.action.doAction("sign.action_sign_send_request",{additionalContext:{active_id:this.props.signTemplate.id,sign_directly_without_mail:false,show_email:true,},});}
onSignNowClick(){this.action.doAction("sign.action_sign_send_request",{additionalContext:{active_id:this.props.signTemplate.id,sign_directly_without_mail:true,},});}
async onShareClick(){const action=await this.orm.call("sign.template","open_shared_sign_request",[this.props.signTemplate.id,]);this.action.doAction(action);}
onNextDocumentClick(){const templateName=this.nextTemplate.name;const templateId=parseInt(this.nextTemplate.template);multiFileUpload.removeFile(templateId);this.action.doAction({type:"ir.actions.client",tag:"sign.Template",name:_t("Template %s",templateName),params:{sign_edit_call:"sign_template_edit",id:templateId,sign_directly_without_mail:false,},});}}
return __exports;});;

/* /sign/static/src/backend_components/sign_template/sign_template_iframe.js */
odoo.define('@sign/backend_components/sign_template/sign_template_iframe',['@web/core/l10n/translation','@web/core/utils/render','@web/core/utils/arrays','@sign/components/sign_request/utils','@sign/backend_components/sign_template/sign_item_custom_popover','@sign/components/sign_request/PDF_iframe','@sign/backend_components/editable_pdf_iframe_mixin','@web/core/user','@web/core/utils/concurrency','@web/core/browser/feature_detection'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{renderToString}=require("@web/core/utils/render");const{shallowEqual}=require("@web/core/utils/arrays");const{normalizePosition,startResize,generateRandomId}=require("@sign/components/sign_request/utils");const{SignItemCustomPopover}=require("@sign/backend_components/sign_template/sign_item_custom_popover");const{PDFIframe}=require("@sign/components/sign_request/PDF_iframe");const{EditablePDFIframeMixin}=require("@sign/backend_components/editable_pdf_iframe_mixin");const{user}=require("@web/core/user");const{Deferred}=require("@web/core/utils/concurrency");const{isMobileOS}=require("@web/core/browser/feature_detection");const SignTemplateIframe=__exports.SignTemplateIframe=class SignTemplateIframe extends EditablePDFIframeMixin(PDFIframe){constructor(root,env,owlServices,props){super(root,env,owlServices,props);this.deletedSignItemIds=[];this.currentRole=this.props.signRoles[0].id;this.closePopoverFns={};this.signItemTypesById=this.props.signItemTypes.reduce((obj,type)=>{obj[type.id]=type;return obj;},{});this.signRolesById=this.props.signRoles.reduce((obj,role)=>{obj[role.id]=role;return obj;},{});this.selectionOptionsById=this.props.signItemOptions.reduce((obj,option)=>{obj[option.id]=option;return obj;},{});this.negativeIds={};this.radioSets=this.props.radioSets;}
get allowEdit(){return!this.props.hasSignRequests;}
renderSidebar(){super.renderSidebar();if(this.allowEdit&&!isMobileOS()){const sideBar=renderToString("sign.signItemTypesSidebar",{signItemTypes:this.props.signItemTypes,});this.root.body.insertAdjacentHTML("afterbegin",sideBar);}}
renderConnectingLine(signItem1,signItem2){const page1=this.getPageContainer(signItem1.data.page);const page2=this.getPageContainer(signItem2.data.page);const dx1=page1.offsetLeft+page1.clientLeft;const dy1=page1.offsetTop+page1.clientTop;const dx2=page2.offsetLeft+page2.clientLeft;const dy2=page2.offsetTop+page2.clientTop;const x1=signItem1.data.posX*page1.clientWidth+dx1;const y1=signItem1.data.posY*page1.clientHeight+dy1;const w1=signItem1.data.width*page1.clientWidth;const h1=signItem1.data.height*page1.clientHeight;const c1={x:x1+w1/2,y:y1+h1/2};const x2=signItem2.data.posX*page2.clientWidth+dx2;const y2=signItem2.data.posY*page2.clientHeight+dy2;const w2=signItem2.data.width*page2.clientWidth;const h2=signItem2.data.height*page2.clientHeight;const c2={x:x2+w2/2,y:y2+h2/2};if(!(x2>x1+w1||x1>x2+w2)){let midx=(Math.max(x1,x2)+Math.min(x1+w1,x2+w2))/2;if(y1>y2){this.renderLine({start:{x:midx,y:y2+h2,},end:{x:midx,y:y1,}});}else{this.renderLine({start:{x:midx,y:y1+h1,},end:{x:midx,y:y2,}});}}
else if(!(y2>y1+h1||y1>y2+h2)){let midy=(Math.max(y1,y2)+Math.min(y1+h1,y2+h2))/2;if(x1>x2){this.renderLine({start:{x:x2+w2,y:midy,},end:{x:x1,y:midy,}});}else{this.renderLine({start:{x:x1+w1,y:midy,},end:{x:x2,y:midy,}});}}else{if(y2+h2<y1&&x2+w2<x1){const corner={x:c2.x,y:c1.y,}
this.renderLine({start:{x:x1,y:c1.y,},end:corner});this.renderLine({start:corner,end:{x:c2.x,y:y2+h2,}});}else if(y2+h2<y1&&x2>x1+w1){const corner={x:c2.x,y:c1.y}
this.renderLine({start:corner,end:{x:x1+w1,y:c1.y}});this.renderLine({start:corner,end:{x:c2.x,y:y2+h2,}});}else if(y2>y1+h1&&x2+w2<x1){const corner={x:c1.x,y:c2.y}
this.renderLine({start:corner,end:{x:c1.x,y:y1+h1,}});this.renderLine({start:corner,end:{x:x2+w2,y:c2.y}});}else if(y2>y1+h1&&x2>x1+w1){const corner={x:c1.x,y:c2.y}
this.renderLine({start:corner,end:{x:c1.x,y:y1+h1,}});this.renderLine({start:corner,end:{x:x2,y:c2.y}});}}}
renderLine(data){const canvas=this.getCanvas();const ctx=canvas.getContext('2d');const scale=this.getCanvasScale();ctx.lineWidth=3/scale;ctx.setLineDash([15/scale,7/scale]);ctx.strokeStyle="orange";ctx.beginPath();ctx.moveTo(data.start.x/scale,data.start.y/scale);ctx.lineTo(data.end.x/scale,data.end.y/scale);ctx.stroke();}
renderAllConnectingLines(){const canvas=this.getCanvas();if(canvas){const ctx=canvas.getContext('2d');ctx.clearRect(0,0,canvas.width,canvas.height);}
for(const radio_set_id in this.radioSets){this.radioSets[radio_set_id].radio_item_ids=this.radioSets[radio_set_id].radio_item_ids.sort((id1,id2)=>{const data1=this.getSignItemById(id1).data;const data2=this.getSignItemById(id2).data;return(100*(data1.page-data2.page)+
10*(data1.posY-data2.posY)+
(data1.posX-data2.posX));});for(let i=1;i<this.radioSets[radio_set_id].radio_item_ids.length;i++){const item1=this.getSignItemById(this.radioSets[radio_set_id].radio_item_ids[i-1]);const item2=this.getSignItemById(this.radioSets[radio_set_id].radio_item_ids[i]);this.renderConnectingLine(item1,item2);}}}
registerDragEventsForSignItem(signItem){super.registerDragEventsForSignItem(signItem);const display=signItem.el.querySelector(".o_sign_item_display");display.addEventListener("click",()=>this.openSignItemPopup(signItem));}
async openSignItemPopup(signItem){const shouldOpenNewPopover=!(signItem.data.id in this.closePopoverFns);this.closePopover();if(shouldOpenNewPopover){if(signItem.data.id in this.negativeIds){await this.negativeIds[signItem.data.id];}
const header_title=signItem.data.type=="radio"?"Radio Button":signItem.data.placeholder;const closeFn=this.popover.add(signItem.el,SignItemCustomPopover,{debug:this.env.debug,responsible:signItem.data.responsible,roles:this.signRolesById,alignment:signItem.data.alignment,required:signItem.data.required,header_title:header_title,placeholder:signItem.data.placeholder,id:signItem.data.id,type:signItem.data.type,option_ids:signItem.data.option_ids,num_options:this.getSignItemById(signItem.data.id).data.num_options,radio_set_id:signItem.data.radio_set_id,onValidate:(data)=>{this.updateSignItem(signItem,data);this.closePopover();},onDelete:()=>{this.closePopover();this.deleteSignItem(signItem);},onClose:()=>{this.closePopover();},updateSelectionOptions:(ids)=>this.updateSelectionOptions(ids),updateRoles:(id)=>this.updateRoles(id),},{position:"right",onClose:()=>{this.closePopoverFns={};},closeOnClickAway:(target)=>!target.closest(".modal"),popoverClass:"sign-popover",});this.closePopoverFns[signItem.data.id]={close:closeFn,signItem,};}}
closePopover(){if(Object.keys(this.closePopoverFns)){for(const id in this.closePopoverFns){this.closePopoverFns[id].close();}
this.closePopoverFns={};}}
async updateRadioButton(sign_item_id,data){const signItem=this.getSignItemById(sign_item_id);const{radio_set_id,num_options,responsible,required,placeholder}=signItem.data;if(num_options!=data.num_options){await this.updateRadioNumOptions(radio_set_id,Number(data.num_options));}
let changes={};if(responsible!=data.responsible){changes['responsible']=Number(data.responsible);}
if(required!=data.required){changes['required']=data.required;}
if(placeholder!=data.placeholder){changes['placeholder']=data.placeholder;}
this.updateRadioSet(radio_set_id,changes);}
updateSignItem(signItem,data){if(signItem.data.type=="radio"){return this.updateRadioButton(signItem.data.id,data);}
const changes=Object.keys(data).reduce((changes,key)=>{if(key in signItem.data){if(Array.isArray(data[key])){if(!shallowEqual(signItem.data[key],data[key])){changes[key]=data[key];}}else if(signItem.data[key]!==data[key]){changes[key]=data[key];}}
return changes;},{});if(Object.keys(changes).length){const pageNumber=signItem.data.page;const page=this.getPageContainer(pageNumber);signItem.el.parentElement.removeChild(signItem.el);const newData={...signItem.data,...changes,updated:true,};this.signItems[pageNumber][newData.id]={data:newData,el:this.renderSignItem(newData,page),};this.refreshSignItems();this.currentRole=newData.responsible;this.saveChanges();}}
deleteRadioSet(radio_set_id){const radioSet=this.radioSets[radio_set_id];radioSet.radio_item_ids.forEach((id)=>{const signItem=this.getSignItemById(id);signItem.el.parentElement.removeChild(signItem.el);delete this.signItems[signItem.data.page][id];})
delete this.radioSets[radio_set_id];this.renderAllConnectingLines();this.orm.unlink('sign.item.radio.set',[radio_set_id]);}
deleteSignItem(signItem){if(signItem.data.type=="radio"){return this.deleteRadioSet(this.getSignItemById(signItem.data.id).data.radio_set_id);}
this.deletedSignItemIds.push(signItem.data.id);super.deleteSignItem(signItem);}
enableCustom(signItem){if(this.allowEdit){startResize(signItem,this.onResizeItem.bind(this));this.registerDragEventsForSignItem(signItem);}}
getContext(signItem){const normalizedPosX=Math.round(normalizePosition(signItem.posX,signItem.width)*1000)/1000;const normalizedPosY=Math.round(normalizePosition(signItem.posY,signItem.height)*1000)/1000;const responsible=signItem.responsible??(signItem.responsible_id?.[0]||0);const type=this.signItemTypesById[signItem.type_id[0]].item_type;if(type==="selection"){const options=signItem.option_ids.map((id)=>this.selectionOptionsById[id]);signItem.options=options;}
return Object.assign(signItem,{readonly:true,editMode:true,required:Boolean(signItem.required),responsible,type,placeholder:signItem.placeholder||signItem.name||"",responsibleName:this.signRolesById[responsible].name,classes:`o_color_responsible_${this.signRolesById[responsible].color} o_readonly_mode`,style:`top: ${normalizedPosY * 100}%; left: ${normalizedPosX * 100}%;
                    width: ${signItem.width * 100}%; height: ${signItem.height * 100}%;
                    text-align: ${signItem.alignment}`,});}
preRender(){super.preRender();if(this.allowEdit&&!isMobileOS()){const outerContainer=this.root.querySelector("#outerContainer");Object.assign(outerContainer.style,{width:"auto",marginLeft:"14rem",});outerContainer.classList.add("o_sign_field_type_toolbar_visible");this.root.dispatchEvent(new Event("resize"));}else if(!this.allowEdit){const div=this.root.createElement("div");Object.assign(div.style,{position:"absolute",top:0,left:0,width:"100%",height:"100%",zIndex:110,opacity:0.75,});this.root.querySelector("#viewer").style.position="relative";this.root.querySelector("#viewer").prepend(div);}
this.insertRotatePDFButton();}
insertRotatePDFButton(){const printButton=this.root.querySelector("#print");const button=this.root.createElement("button");button.setAttribute("id","pageRotateCw");button.className="toolbarButton o_sign_rotate rotateCw";button.title=_t("Rotate Clockwise");printButton.parentNode.insertBefore(button,printButton);button.addEventListener("click",(e)=>this.rotatePDF(e));}
postRender(){super.postRender();if(this.allowEdit){const viewerContainer=this.root.querySelector("#viewerContainer");viewerContainer.addEventListener("click",(e)=>{if(!e.target.closest(".o_sign_item_display")){this.closePopover();}},{capture:true});this.root.addEventListener("keyup",(e)=>this.handleKeyUp(e));}}
handleKeyUp(e){if(e.key==="Delete"&&Object.keys(this.closePopoverFns)){for(const id in this.closePopoverFns){const{close,signItem}=this.closePopoverFns[id];typeof close==="function"&&close();this.deleteSignItem(signItem);}
this.closePopoverFns={};}}
async saveChanges(){const items=this.signItems;for(const page in items){for(const id in items[page]){const signItem=items[page][id].data;if(signItem.id<0){this.negativeIds[id]=new Deferred();}}}
let new_radio_items=[]
const Id2UpdatedItem=await this.props.saveTemplate();Object.entries(Id2UpdatedItem).forEach(([previousId,{page,id}])=>{if(Number(previousId)!==id&&this.signItems[page][previousId]){const prevEl=this.signItems[page][previousId].el;const prevData=this.signItems[page][previousId].data;this.signItems[page][id]={data:prevData,el:prevEl,};this.negativeIds[previousId]?.resolve();delete this.negativeIds[previousId];delete this.signItems[page][previousId];this.signItems[page][id].el.dataset.id=id;if(prevData.type=="radio"){new_radio_items.push({'page':page,'id':id});}}
this.signItems[page][id].data.updated=false;});if(new_radio_items.length){const info=await this.props.getRadioSetInfo(new_radio_items.map((obj)=>obj.id));new_radio_items.forEach(({page,id})=>{const{data,el}=this.signItems[page][id];const updatedData=Object.assign({},data,info[id]);const{radio_set_id,num_options}=info[id];if(!this.radioSets[radio_set_id]){this.radioSets[radio_set_id]={num_options:0,radio_item_ids:[],}}
this.radioSets[radio_set_id].num_options=num_options;this.radioSets[radio_set_id].radio_item_ids.push(id);this.signItems[page]={...this.signItems[page],[id]:{data:updatedData,el:el,},};});}
this.deletedSignItemIds=[];this.renderAllConnectingLines();}
async updateSelectionOptions(optionIds){const newIds=optionIds.filter((id)=>!(id in this.selectionOptionsById));const newOptions=await this.orm.searchRead("sign.item.option",[["id","in",newIds]],["id","value"],{context:user.context});for(const option of newOptions){this.selectionOptionsById[option.id]=option;}}
async render_new_radio_items(lastSignItem,count){let tail=lastSignItem;for(let i=0;i<count;i++){const new_id=generateRandomId();const new_data={...tail.data};new_data['id']=new_id;new_data['posY']+=0.025;this.signItems[new_data.page][new_id]={data:new_data,el:this.renderSignItem(new_data,this.getPageContainer(new_data.page)),}
tail=this.signItems[new_data.page][new_id];new_data.updated=true;}
this.refreshSignItems();await this.saveChanges();}
async deleteRadioItems(radio_item_ids,count){let deleted_sign_items=[];for(let i=0;i<count;i++){const id=radio_item_ids[radio_item_ids.length-1-i];const signItem=this.getSignItemById(id);deleted_sign_items.push(signItem);}
await this.deleteSignItems(deleted_sign_items);}
async updateRadioSet(radio_set_id,changes){if(Object.keys(changes).length===0){return;}
const radio_set=this.radioSets[radio_set_id];radio_set.radio_item_ids.forEach((id)=>{const signItem=this.getSignItemById(id);const pageNumber=signItem.data.page;const page=this.getPageContainer(pageNumber);signItem.el.parentElement.removeChild(signItem.el);const newData={...signItem.data,...changes,updated:true,};this.signItems[pageNumber][id]={data:newData,el:this.renderSignItem(newData,page),};});this.refreshSignItems();await this.saveChanges();}
async updateRadioNumOptions(radio_set_id,count){const radio_set=this.radioSets[radio_set_id];if(radio_set.num_options<count){const signItem=this.getSignItemById(radio_set.radio_item_ids[radio_set.num_options-1]);await this.render_new_radio_items(signItem,count-radio_set.num_options);}else if(radio_set.num_options>count){await this.deleteRadioItems(radio_set.radio_item_ids,radio_set.num_options-count);}
const new_radio_set=this.radioSets[radio_set_id];new_radio_set.radio_item_ids.forEach((id)=>{const signItem=this.getSignItemById(id);signItem.data.num_options=new_radio_set.num_options;})}
async updateRoles(id){if(!(id in this.signRolesById)){const newRole=await this.orm.searchRead("sign.item.role",[["id","=",id]],[]);this.signRolesById[newRole[0].id]=newRole[0];}}}
return __exports;});;

/* /sign/static/src/backend_components/sign_template/sign_template_top_bar.js */
odoo.define('@sign/backend_components/sign_template/sign_template_top_bar',['@web/core/l10n/translation','@web/core/utils/hooks','@web/model/record','@web/views/fields/many2many_tags/many2many_tags_field','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{Record}=require("@web/model/record");const{many2ManyTagsField,Many2ManyTagsField,Many2ManyTagsFieldColorEditable,}=require("@web/views/fields/many2many_tags/many2many_tags_field");const{Component,useRef,useState}=require("@odoo/owl");const actionFieldsGet={tag_ids:{type:"many2many",relation:"sign.template.tag",string:"Tags"},authorized_ids:{type:"many2many",relation:"res.users",string:"Authorized Users"},group_ids:{type:"many2many",relation:"res.groups",string:"Authorized Groups"},};function getActionActiveFields(){const activeFields={};for(const fName of Object.keys(actionFieldsGet)){const related=Object.fromEntries(many2ManyTagsField.relatedFields({options:{}}).map((f)=>[f.name,f]));activeFields[fName]={related:{activeFields:related,fields:related,},};}
activeFields.tag_ids.related.activeFields.color={type:"integer",string:"Color"};return activeFields;}
const SignTemplateTopBar=__exports.SignTemplateTopBar=class SignTemplateTopBar extends Component{static template="sign.SignTemplateTopBar";static components={Many2ManyTagsFieldColorEditable,Many2ManyTagsField,Record,};static props={signTemplate:{type:Object},hasSignRequests:{type:Boolean},onTemplateNameChange:{type:Function},manageTemplateAccess:{type:Boolean},resModel:{type:String},isPDF:{type:Boolean},};setup(){this.displayNameInput=useRef("display-name");this.action=useService("action");this.notification=useService("notification");this.orm=useService("orm");this.signTemplateFieldsGet=getActionActiveFields();this.state=useState({properties:false,});}
changeInputSize(){const el=this.displayNameInput.el;if(el){el.size=el.value.length+1;}}
get displayNameSize(){return this.props.signTemplate.display_name.length+1;}
editDisplayName(){this.displayNameInput.el.focus();this.displayNameInput.el.select();}
onKeyDown(e){if(e.key==="Enter"){this.displayNameInput.el.blur();}}
async onTemplateSaveClick(){const templateId=this.props.signTemplate.id;this.state.properties=await this.orm.call("sign.template","write",[[templateId],{active:true}]);this.props.signTemplate.active=true;this.notification.add(_t("Document saved as Template."),{type:"success"});return this.state.properties;}
onTemplatePropertiesClick(){this.action.doAction({name:"Edit Template Form",type:"ir.actions.act_window",res_model:"sign.template",res_id:this.props.signTemplate.id,views:[[false,"form"]],});}
getMany2ManyProps(record,fieldName){return{name:fieldName,id:fieldName,record,readonly:this.props.hasSignRequests,};}
get recordProps(){return{mode:this.props.hasSignRequests?"readonly":"edit",onRecordChanged:(record,changes)=>{this.saveChanges(record,changes);},resModel:"sign.template",resId:this.props.signTemplate.id,fieldNames:this.signTemplateFieldsGet,activeFields:this.signTemplateFieldsGet,};}
async saveChanges(record,changes){const result=await this.orm.write("sign.template",[record.resId],changes);return result;}
get showEditButton(){return this.props.hasSignRequests&&this.props.isPDF;}
async editTemplate(){const duplicatedTemplateIds=await this.orm.call("sign.template","copy",[[this.props.signTemplate.id],]);this.action.doAction({type:"ir.actions.client",tag:"sign.Template",name:_t("Edit Template"),params:{id:duplicatedTemplateIds[0],},});}}
return __exports;});;

/* /sign/static/src/backend_components/template_alert_dialog/template_alert_dialog.js */
odoo.define('@sign/backend_components/template_alert_dialog/template_alert_dialog',['@web/core/confirmation_dialog/confirmation_dialog'],function(require){'use strict';let __exports={};const{ConfirmationDialog,AlertDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const TemplateAlertDialog=__exports.TemplateAlertDialog=class TemplateAlertDialog extends AlertDialog{static props={...AlertDialog.props,body:{type:String,optional:true},failedTemplates:{type:Array},successTemplateCount:{type:Number,optional:true},};static defaultProps={...ConfirmationDialog.defaultProps,...AlertDialog.defaultProps,};static template="sign.TemplateAlertDialog";}
return __exports;});;

/* /sign/static/src/views/helper/sign_action_helper.js */
odoo.define('@sign/views/helper/sign_action_helper',['@sign/views/hooks','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useSignViewButtons}=require("@sign/views/hooks");const{useService}=require("@web/core/utils/hooks");const{useRef,Component}=require("@odoo/owl");const SignActionHelper=__exports.SignActionHelper=class SignActionHelper extends Component{static template="sign.SignActionHelper";static props=["resModel"];setup(){super.setup(...arguments);this.actionService=useService("action");this.fileInput=useRef("uploadFileInput");const functions=useSignViewButtons();Object.assign(this,functions);}
onClickUpload(context){return this.requestFile(context);}
onClicksampleSign(){return this.actionService.doAction("sign.sign_template_tour_trigger_action");}}
return __exports;});;

/* /sign/static/src/views/hooks.js */
odoo.define('@sign/views/hooks',['@web/core/l10n/translation','@web/core/utils/hooks','@sign/backend_components/multi_file_upload','@web/core/user','@web/core/utils/urls','@sign/backend_components/template_alert_dialog/template_alert_dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService,useBus}=require("@web/core/utils/hooks");const{multiFileUpload}=require("@sign/backend_components/multi_file_upload");const{user}=require("@web/core/user");const{getDataURLFromFile}=require("@web/core/utils/urls");const{TemplateAlertDialog}=require("@sign/backend_components/template_alert_dialog/template_alert_dialog");const{onWillStart,useComponent,useRef,useEnv}=require("@odoo/owl");__exports.useSignViewButtons=useSignViewButtons;function useSignViewButtons(){const component=useComponent();const fileInput=useRef("uploadFileInput");const orm=useService("orm");const dialog=useService("dialog");const action=useService("action");const env=useEnv();onWillStart(async()=>{component.isSignUser=await user.hasGroup("sign.group_sign_user");});let latestRequestContext;let inactive;let resModel;const uploadFile=async(file)=>{const dataUrl=await getDataURLFromFile(file);inactive=resModel==='sign.template'?true:false;const args=[file.name,dataUrl.split(",")[1],inactive];return await orm.call("sign.template","create_with_attachment_data",args);};const handleTemplates=(templates)=>{if(!templates||!templates.length){return;}
const file=templates.shift();multiFileUpload.addNewFiles(templates);action.doAction({type:"ir.actions.client",tag:"sign.Template",name:_t("Template %s",file.name),params:{sign_edit_call:latestRequestContext,id:file.template,sign_directly_without_mail:false,resModel:resModel,},});};const upload={onFileInputChange:async(ev)=>{const files=ev?.type==="change"?ev.target.files:ev.detail.files;if(!files||!files.length){return;}
const uploadedTemplates=await Promise.all(Array.from(files).map(uploadFile));const templates=uploadedTemplates.map((template,index)=>({template,name:files[index].name,}));const{true:succesfulTemplates,false:failedTemplates}=templates.reduce((result,item)=>{const key=Boolean(item.template);if(!result[key]){result[key]=[];}
result[key].push(item);return result;},{});if(failedTemplates&&failedTemplates.length){dialog.add(TemplateAlertDialog,{title:_t("File Error"),failedTemplates,successTemplateCount:succesfulTemplates&&succesfulTemplates.length,confirm:handleTemplates.bind(undefined,succesfulTemplates),});}else{handleTemplates(succesfulTemplates);}
ev.target.value="";},requestFile(context){latestRequestContext=context;resModel=this.props.resModel;fileInput.el.click();},};useBus(env.bus,"change_file_input",async(ev)=>{fileInput.el.files=ev.detail.files;resModel=ev.detail.resModel
await upload.onFileInputChange(ev);});return upload}
return __exports;});;

/* /sign/static/src/views/sign_kanban/sign_kanban_controller.js */
odoo.define('@sign/views/sign_kanban/sign_kanban_controller',['@web/views/kanban/kanban_controller','@sign/views/hooks','@web/core/dropdown/dropdown'],function(require){'use strict';let __exports={};const{KanbanController}=require("@web/views/kanban/kanban_controller");const{useSignViewButtons}=require("@sign/views/hooks");const{Dropdown,DropdownItem}=require("@web/core/dropdown/dropdown");const SignKanbanController=__exports.SignKanbanController=class SignKanbanController extends KanbanController{static template="sign.SignKanbanController";static components={...KanbanController.components,Dropdown,DropdownItem,};setup(){super.setup(...arguments);const functions=useSignViewButtons();Object.assign(this,functions);}}
return __exports;});;

/* /sign/static/src/views/sign_kanban/sign_kanban_renderer.js */
odoo.define('@sign/views/sign_kanban/sign_kanban_renderer',['@web/views/kanban/kanban_renderer','@sign/mixin/document_upload','@sign/views/helper/sign_action_helper'],function(require){'use strict';let __exports={};const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{SignDocumentDropZone}=require("@sign/mixin/document_upload");const{SignActionHelper}=require('@sign/views/helper/sign_action_helper');const SignKanbanRenderer=__exports.SignKanbanRenderer=class SignKanbanRenderer extends SignDocumentDropZone(KanbanRenderer){static template="sign.KanbanRenderer";static components={...KanbanRenderer.components,SignActionHelper,};get canMoveRecords(){return super.canMoveRecords&&this.props.list.resModel!=="sign.request";}
get canResequenceGroups(){return super.canResequenceGroups&&this.props.list.resModel!=="sign.request";}}
return __exports;});;

/* /sign/static/src/views/sign_kanban/sign_kanban_view.js */
odoo.define('@sign/views/sign_kanban/sign_kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@sign/views/sign_kanban/sign_kanban_controller','@sign/views/sign_kanban/sign_kanban_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{SignKanbanController}=require("@sign/views/sign_kanban/sign_kanban_controller");const{SignKanbanRenderer}=require("@sign/views/sign_kanban/sign_kanban_renderer");const signKanbanView=__exports.signKanbanView={...kanbanView,Controller:SignKanbanController,Renderer:SignKanbanRenderer,};registry.category("views").add("sign_kanban",signKanbanView);return __exports;});;

/* /sign/static/src/views/sign_list/sign_list_controller.js */
odoo.define('@sign/views/sign_list/sign_list_controller',['@web/views/list/list_controller','@web/views/list/list_renderer','@sign/views/hooks','@web/core/dropdown/dropdown','@sign/mixin/document_upload','@sign/views/helper/sign_action_helper'],function(require){'use strict';let __exports={};const{ListController}=require("@web/views/list/list_controller");const{ListRenderer}=require("@web/views/list/list_renderer");const{useSignViewButtons}=require("@sign/views/hooks");const{Dropdown,DropdownItem}=require("@web/core/dropdown/dropdown");const{SignDocumentDropZone}=require("@sign/mixin/document_upload");const{SignActionHelper}=require('@sign/views/helper/sign_action_helper');const SignListController=__exports.SignListController=class SignListController extends ListController{static template="sign.SignListController";static components={...ListController.components,Dropdown,DropdownItem,};setup(){super.setup(...arguments);const functions=useSignViewButtons();Object.assign(this,functions);}}
const SignListRenderer=__exports.SignListRenderer=class SignListRenderer extends SignDocumentDropZone(ListRenderer){static template="sign.ListRenderer";static components={...ListRenderer.components,SignActionHelper,};}
return __exports;});;

/* /sign/static/src/views/sign_list/sign_list_view.js */
odoo.define('@sign/views/sign_list/sign_list_view',['@web/core/registry','@web/views/list/list_view','@sign/views/sign_list/sign_list_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{SignListController,SignListRenderer}=require("@sign/views/sign_list/sign_list_controller");const signListView=__exports.signListView={...listView,Controller:SignListController,Renderer:SignListRenderer,};registry.category("views").add("sign_list",signListView);return __exports;});;

/* /sign/static/src/dialogs/dialogs.js */
odoo.define('@sign/dialogs/dialogs',['@sign/dialogs/initials_all_pages_dialog','@sign/dialogs/public_signer_dialog','@sign/dialogs/sign_name_and_signature_dialog','@sign/dialogs/sms_signer_dialog','@sign/dialogs/thank_you_dialog','@sign/dialogs/next_direct_sign_dialog','@sign/dialogs/encrypted_dialog','@sign/dialogs/sign_refusal_dialog'],function(require){'use strict';let __exports={};const{InitialsAllPagesDialog}=require("@sign/dialogs/initials_all_pages_dialog");const{PublicSignerDialog}=require("@sign/dialogs/public_signer_dialog");const{SignNameAndSignatureDialog}=require("@sign/dialogs/sign_name_and_signature_dialog");const{SMSSignerDialog}=require("@sign/dialogs/sms_signer_dialog");const{ThankYouDialog}=require("@sign/dialogs/thank_you_dialog");const{NextDirectSignDialog}=require("@sign/dialogs/next_direct_sign_dialog");const{EncryptedDialog}=require("@sign/dialogs/encrypted_dialog");const{SignRefusalDialog}=require("@sign/dialogs/sign_refusal_dialog");Object.assign(__exports,{InitialsAllPagesDialog,PublicSignerDialog,SignNameAndSignatureDialog,SMSSignerDialog,ThankYouDialog,NextDirectSignDialog,EncryptedDialog,SignRefusalDialog,});return __exports;});;

/* /sign/static/src/dialogs/encrypted_dialog.js */
odoo.define('@sign/dialogs/encrypted_dialog',['@web/core/l10n/translation','@web/core/utils/hooks','@web/core/confirmation_dialog/confirmation_dialog','@web/core/dialog/dialog','@web/core/network/rpc','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{AlertDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{Dialog}=require("@web/core/dialog/dialog");const{rpc}=require("@web/core/network/rpc");const{Component,useRef}=require("@odoo/owl");const EncryptedDialog=__exports.EncryptedDialog=class EncryptedDialog extends Component{static template="sign.EncryptedDialog";static components={Dialog,};static props={close:Function,};setup(){this.passwordInput=useRef("password");this.dialog=useService("dialog");this.signInfo=useService("signInfo");}
get dialogProps(){return{title:_t("PDF is encrypted"),fullscreen:this.env.isSmall,size:"md",};}
async validatePassword(){const passwordInput=this.passwordInput.el;if(!passwordInput.value){passwordInput.classList.toggle("is-invalid",!passwordInput.value);return false;}
const route=`/sign/password/${this.signInfo.get("documentId")}`;const params={password:passwordInput.value,};const response=await rpc(route,params);if(!response){return this.dialog.add(AlertDialog,{body:_t("Password is incorrect."),});}else{this.props.close();}}}
return __exports;});;

/* /sign/static/src/dialogs/initials_all_pages_dialog.js */
odoo.define('@sign/dialogs/initials_all_pages_dialog',['@web/core/l10n/translation','@odoo/owl','@web/core/dialog/dialog'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component,useRef}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const InitialsAllPagesDialog=__exports.InitialsAllPagesDialog=class InitialsAllPagesDialog extends Component{static template="sign.InitialsAllPagesDialog";static components={Dialog,};static props={addInitial:Function,close:Function,roles:Object,responsible:Number,pageCount:Number,};setup(){this.selectRef=useRef("role_select");}
get currentRole(){return parseInt(this.selectRef.el?.value);}
onAddOnceClick(){this.props.addInitial(this.currentRole,false);this.props.close();}
onAddToAllPagesClick(){this.props.addInitial(this.currentRole,true);this.props.close();}
get dialogProps(){return{size:"md",title:_t("Add Initials"),};}}
return __exports;});;

/* /sign/static/src/dialogs/next_direct_sign_dialog.js */
odoo.define('@sign/dialogs/next_direct_sign_dialog',['@web/core/l10n/translation','@odoo/owl','@web/core/utils/hooks','@web/core/dialog/dialog'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{Dialog}=require("@web/core/dialog/dialog");const NextDirectSignDialog=__exports.NextDirectSignDialog=class NextDirectSignDialog extends Component{static template="sign.NextDirectSignDialog";static components={Dialog,};static props={close:Function,};setup(){this.action=useService("action");this.signInfo=useService("signInfo");this.title=_t("Thank You!");}
goToNextSigner(){const newCurrentToken=this.signInfo.get("tokenList").shift();this.signInfo.get("nameList").shift();this.action.doAction({type:"ir.actions.client",tag:"sign.SignableDocument",name:_t("Sign"),},{additionalContext:{id:this.signInfo.get("documentId"),create_uid:this.signInfo.get("createUid"),state:this.signInfo.get("signRequestState"),token:newCurrentToken,token_list:this.signInfo.get("tokenList"),name_list:this.signInfo.get("nameList"),},stackPosition:"replaceCurrentAction",});this.props.close();}
get nextSigner(){return this.signInfo.get("nameList")[0];}
get dialogProps(){return{size:"md",technical:this.env.isSmall,fullscreen:this.env.isSmall,};}}
return __exports;});;

/* /sign/static/src/dialogs/public_signer_dialog.js */
odoo.define('@sign/dialogs/public_signer_dialog',['@odoo/owl','@web/core/l10n/translation','@web/core/network/rpc','@web/core/utils/hooks','@web/core/dialog/dialog'],function(require){'use strict';let __exports={};const{Component,useRef}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{Dialog}=require("@web/core/dialog/dialog");const PublicSignerDialog=__exports.PublicSignerDialog=class PublicSignerDialog extends Component{static template="sign.PublicSignerDialog";static components={Dialog,};static props={name:String,mail:String,postValidation:Function,close:Function,};setup(){this.nameInput=useRef("name");this.mailInput=useRef("mail");this.signInfo=useService("signInfo");}
get dialogProps(){return{title:_t("Final Validation"),size:"md",technical:this.env.isSmall,fullscreen:this.env.isSmall,};}
async submit(){const name=this.nameInput.el.value;const mail=this.mailInput.el.value;if(!this.validateForm(name,mail)){return false;}
const response=await rpc(`/sign/send_public/${this.signInfo.get("documentId")}/${this.signInfo.get(
                "signRequestToken"
            )}`,{name,mail});await this.props.postValidation(response["requestID"],response["requestToken"],response["accessToken"]);this.props.close();}
validateForm(name,mail){const isEmailInvalid=!mail||mail.indexOf("@")<0;if(!name||isEmailInvalid){this.nameInput.el.classList.toggle("is-invalid",!name);this.mailInput.el.classList.toggle("is-invalid",isEmailInvalid);return false;}
return true;}}
return __exports;});;

/* /sign/static/src/dialogs/sign_name_and_signature_dialog.js */
odoo.define('@sign/dialogs/sign_name_and_signature_dialog',['@web/core/network/rpc','@web/core/l10n/translation','@web/core/dialog/dialog','@web/core/user','@web/core/assets','@odoo/owl','@web/core/l10n/localization','@web/core/signature/name_and_signature'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{_t}=require("@web/core/l10n/translation");const{Dialog}=require("@web/core/dialog/dialog");const{user}=require("@web/core/user");const{loadJS}=require("@web/core/assets");const{Component,onWillStart,useRef,useState}=require("@odoo/owl");const{localization}=require("@web/core/l10n/localization");const{NameAndSignature}=require("@web/core/signature/name_and_signature");const SignNameAndSignature=__exports.SignNameAndSignature=class SignNameAndSignature extends NameAndSignature{static template="sign.NameAndSignature";static props={...NameAndSignature.props,activeFrame:Boolean,defaultFrame:String,frame:{type:Object,optional:true},hash:String,onNameChange:Function,onSignatureChange:{type:Function,optional:true},};setup(){super.setup();this.props.signature.signatureChanged=this.state.signMode!=="draw";if(this.props.frame){this.state.activeFrame=this.props.activeFrame||false;this.frame=this.props.defaultFrame;this.signFrame=useRef("signFrame");this.props.frame.updateFrame=()=>{if(this.state.activeFrame){this.props.signature.signatureChanged=true;const xOffset=localization.direction==="rtl"?0.75:0.06;this.signFrame.el.classList.toggle("active",true);return html2canvas(this.signFrame.el,{backgroundColor:null,width:this.signatureRef.el.width,height:this.signatureRef.el.height,x:-this.signatureRef.el.width*xOffset,y:-this.signatureRef.el.height*0.09,}).then((canvas)=>{this.frame=canvas.toDataURL("image/png");});}
return Promise.resolve(false);};this.props.frame.getFrameImageSrc=()=>{return this.state.activeFrame?this.frame:false;};}
onWillStart(()=>{if(this.props.frame){return Promise.all([user.hasGroup("base.group_user").then((isSystemUser)=>{this.showFrameCheck=isSystemUser;}),loadJS("/web_editor/static/lib/html2canvas.js"),]);}});}
onFrameChange(){this.state.activeFrame=!this.state.activeFrame;}
onSignatureAreaClick(){if(this.state.signMode==="draw"){this.props.signature.signatureChanged=true;this.props.onSignatureChange(this.state.signMode);}}
onClickSignLoad(){super.onClickSignLoad();this.props.signature.signatureChanged=true;}
async onClickSignAuto(){super.onClickSignAuto();this.props.signature.signatureChanged=true;if(this.fonts.length<=1){this.fonts=await rpc(`/web/sign/get_fonts/`);}}
onClickSignDrawClear(){super.onClickSignDrawClear();this.props.signature.signatureChanged=true;}
get signFrameClass(){return this.state.activeFrame&&this.state.signMode!=="draw"?"active":"";}
onInputSignName(e){super.onInputSignName(e);this.props.onNameChange(this.props.signature.name);this.props.onSignatureChange(this.state.signMode);}}
const SignNameAndSignatureDialog=__exports.SignNameAndSignatureDialog=class SignNameAndSignatureDialog extends Component{static props={signature:Object,frame:{type:Object,optional:true},signatureType:{type:String,optional:true},displaySignatureRatio:Number,activeFrame:Boolean,defaultFrame:{type:String,optional:true},mode:{type:String,optional:true},signatureImage:{type:String,optional:true},hash:String,onConfirm:Function,onConfirmAll:Function,onCancel:Function,close:Function,};static template="sign.SignNameAndSignatureDialog";static components={Dialog,SignNameAndSignature,};setup(){this.footerState=useState({signButtonDisabled:!this.props.signature.name||!this.props.signature.signatureChanged,signAllButtonsDisabled:!this.props.signature.name,});}
get nameAndSignatureProps(){return{signature:this.props.signature||"signature",signatureType:this.props.signatureType,displaySignatureRatio:this.props.displaySignatureRatio,activeFrame:this.props.activeFrame,defaultFrame:this.props.defaultFrame||"",mode:this.props.mode||"auto",frame:this.props.frame||false,hash:this.props.hash,onNameChange:this.onNameChange.bind(this),defaultFont:"LaBelleAurore-Regular.ttf",onSignatureChange:this.onSignatureChange.bind(this),};}
get dialogProps(){return{title:_t("Adopt Your Signature"),size:"md",};}
onNameChange(name){const isNameFilled=Boolean(name);this.footerState.signButtonDisabled=!isNameFilled;this.footerState.signAllButtonsDisabled=!isNameFilled;}
onSignatureChange(signMode){const signature=this.props.signature;const isNotValidSignature=!signature.name||(signature.isSignatureEmpty&&(!signMode||signMode!=="auto"));this.footerState.signAllButtonsDisabled=isNotValidSignature;this.footerState.signButtonDisabled=isNotValidSignature||!signature.signatureChanged;}}
return __exports;});;

/* /sign/static/src/dialogs/sign_refusal_dialog.js */
odoo.define('@sign/dialogs/sign_refusal_dialog',['@odoo/owl','@web/core/l10n/translation','@web/core/network/rpc','@web/core/utils/hooks','@web/core/dialog/dialog','@web/core/confirmation_dialog/confirmation_dialog','@sign/dialogs/thank_you_dialog'],function(require){'use strict';let __exports={};const{Component,useRef}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{Dialog}=require("@web/core/dialog/dialog");const{AlertDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{ThankYouDialog}=require("@sign/dialogs/thank_you_dialog");const SignRefusalDialog=__exports.SignRefusalDialog=class SignRefusalDialog extends Component{static template="sign.SignRefusalDialog";static components={Dialog,};static props={close:Function,};setup(){this.refuseReasonEl=useRef("refuse-reason");this.refuseButton=useRef("refuse-button");this.dialog=useService("dialog");this.signInfo=useService("signInfo");}
get dialogProps(){return{size:"md",title:_t("Refuse to sign"),};}
checkForChanges(){const value=this.refuseReasonEl.el.value.trim();this.refuseButton.el.disabled=value.length===0?"disabled":"";}
async refuse(){const reason=this.refuseReasonEl.el.value;const route=`/sign/refuse/${this.signInfo.get("documentId")}/${this.signInfo.get(
            "signRequestItemToken"
        )}`;const params={refusal_reason:reason,};const response=await rpc(route,params);if(!response){this.dialog.add(AlertDialog,{body:_t("Sorry, you cannot refuse this document"),},{onClose:()=>window.location.reload(),});}
this.dialog.add(ThankYouDialog,{subtitle:_t("The document has been refused"),message:_t("We'll send an email to warn other contacts in copy & signers with the reason you provided."),});this.props.close();}}
return __exports;});;

/* /sign/static/src/dialogs/sms_signer_dialog.js */
odoo.define('@sign/dialogs/sms_signer_dialog',['@web/core/l10n/translation','@odoo/owl','@web/core/network/rpc','@web/core/utils/hooks','@web/core/dialog/dialog','@web/core/confirmation_dialog/confirmation_dialog','@web/core/browser/browser'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component,useState,useRef,useEffect}=require("@odoo/owl");const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{Dialog}=require("@web/core/dialog/dialog");const{AlertDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{browser}=require("@web/core/browser/browser");const SMSSignerDialog=__exports.SMSSignerDialog=class SMSSignerDialog extends Component{static template="sign.SMSSignerDialog";static components={Dialog,};static props={signerPhone:{type:String,optional:true,},postValidation:Function,close:Function,};setup(){this.validationCodeInput=useRef("code");this.phoneInput=useRef("phone");this.dialog=useService("dialog");this.signInfo=useService("signInfo");this.SMSInfo={phoneNumber:this.props.signerPhone||""};this.state=useState({sendingSMS:false,SMSCount:0,});useEffect(()=>{return()=>{browser.clearTimeout(this.timeout);};},()=>[]);}
sendSMS(phoneNumber){this.state.sendingSMS=true;const route=`/sign/send-sms/${this.signInfo.get("documentId")}/${this.signInfo.get(
            "signRequestItemToken"
        )}/${phoneNumber}`;rpc(route).then((success)=>{if(success){this.handleSendSMSSuccess();}else{this.handleSMSError();}}).catch((_)=>{this.handleSMSError();});}
handleSendSMSSuccess(){this.timeout=browser.setTimeout(()=>{this.state.sendingSMS=false;this.state.SMSCount++;},15000);}
handleSMSError(){this.state.sendingSMS=false;this.dialog.add(AlertDialog,{title:_t("Error"),body:_t("Unable to send the SMS, please contact the sender of the document."),});}
onSendSMSClick(e){const sendButton=e.target;sendButton.setAttribute("disabled",true);const phoneNumber=this.phoneInput.el.value;if(phoneNumber){this.SMSInfo.phoneNumber=phoneNumber;this.sendSMS(phoneNumber);}
sendButton.removeAttribute("disabled");}
async validateSMS(e){const validateButton=e.target;const validationCode=this.validationCodeInput.el?.value;if(!validationCode){this.validationCodeInput.el.classList.toggle("is-invalid");return false;}
validateButton.setAttribute("disabled",true);await this.props.postValidation(validationCode);validateButton.removeAttribute("disabled");this.props.close();}
get dialogProps(){return{size:"md",title:_t("Final Validation"),fullscreen:this.env.isSmall,};}}
return __exports;});;

/* /sign/static/src/dialogs/thank_you_dialog.js */
odoo.define('@sign/dialogs/thank_you_dialog',['@web/core/l10n/translation','@web/session','@web/core/user','@web/core/dialog/dialog','@web/core/network/rpc','@web/core/utils/hooks','@sign/dialogs/encrypted_dialog','@odoo/owl','@web/core/browser/feature_detection'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{session}=require("@web/session");const{user}=require("@web/core/user");const{Dialog}=require("@web/core/dialog/dialog");const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{EncryptedDialog}=require("@sign/dialogs/encrypted_dialog");const{Component,onWillStart,useState}=require("@odoo/owl");const{isMobileOS}=require("@web/core/browser/feature_detection");const ThankYouDialog=__exports.ThankYouDialog=class ThankYouDialog extends Component{static template="sign.ThankYouDialog";static components={Dialog,};static props={message:{type:String,optional:true,},subtitle:{type:String,optional:true,},redirectURL:{type:String,optional:true,},redirectURLText:{type:String,optional:true,},close:Function,};setup(){this.dialog=useService("dialog");this.signInfo=useService("signInfo");this.orm=useService("orm");this.state=useState({nextDocuments:[],buttons:[],});this.redirectURL=this.processURL(this.props.redirectURL);this.message=this.props.message||_t("You will get the signed document by email.");onWillStart(this.willStart);this.isMobileOS=isMobileOS();}
get suggestSignUp(){return!user.userId;}
get dialogProps(){return{size:"md",};}
async checkIfEncryptedDialog(){const route=`/sign/encrypted/${this.signInfo.get("documentId")}`;return rpc(route);}
async willStart(){const isEncrypted=await this.checkIfEncryptedDialog();if(isEncrypted){this.dialog.add(EncryptedDialog);}
this.signRequestState=await rpc(`/sign/sign_request_state/${this.signInfo.get("documentId")}/${this.signInfo.get(
                "signRequestToken"
            )}`);this.closeLabel=_t("Close");if(!session.is_frontend){const result=await this.orm.call("sign.request","get_close_values",[[this.signInfo.get("documentId")],]);this.closeAction=result.action;this.closeLabel=result.label;const closeContext=result.custom_action?{}:{clearBreadcrumbs:true};this.closeContext=closeContext;}
if(!this.suggestSignUp&&!session.is_website_user){const result=await rpc("/sign/sign_request_items",{request_id:this.signInfo.get("documentId"),token:this.signInfo.get("signRequestToken"),});if(result&&result.length){this.state.nextDocuments=result.map((doc)=>{return{id:doc.id,name:doc.name,date:doc.date,user:doc.user,accessToken:doc.token,requestId:doc.requestId,canceled:false,};});}}
this.generateButtons();}
generateButtons(){if(this.redirectURL){this.state.buttons.push({name:this.props.redirectURLText,click:()=>{window.location.assign(this.redirectURL);},classes:'o_sign_thankyou_redirect_button',});}
if(!this.redirectURL){this.state.buttons.push({name:this.closeLabel,click:()=>{if(this.suggestSignUp){window.open(`https://odoo.com/app/sign`);}
if(session.is_frontend){const signatureRequestId=this.signInfo.get("documentId");window.location.assign(`/my/signature/${signatureRequestId}`);}else{this.props.close();this.env.services.action.doAction(this.closeAction,this.closeContext);}},classes:'o_sign_thankyou_close_button'});}
for(let i=0;i<this.state.buttons.length;i++){if(this.state.buttons[i].ignored){continue;}
const buttonClass="btn btn-secondary";this.state.buttons[i].classes=`${this.state.buttons[i].classes} ${buttonClass}`;}}
processURL(url){if(url&&!/^(f|ht)tps?:\/\//i.test(url)){url=`http://${url}`;}
return url;}
goToDocument(id,token){window.location.assign(this.makeURI("/sign/document",id,token,undefined,{portal:1}));}
clickNextSign(id,token){this.goToDocument(id,token);}
clickButtonNext(){const nextDocument=this.state.nextDocuments.find((document)=>!document.canceled);this.goToDocument(nextDocument.requestId,nextDocument.accessToken);}
async clickNextCancel(doc){await this.orm.call("sign.request","cancel",[doc.requestId]);this.state.nextDocuments=this.state.nextDocuments.map((nextDoc)=>{if(nextDoc.id===doc.id){return{...nextDoc,canceled:true,};}
return nextDoc;});if(this.state.nextDocuments.every((doc)=>doc.canceled)){this.state.buttons=this.state.buttons.map((button)=>{if(button.name===_t("Sign Next Document")){return{...button,disabled:true,};}
return button;});}}
async downloadDocument(){window.location.assign(this.makeURI("/sign/download",this.signInfo.get("documentId"),this.signInfo.get("signRequestToken"),"/completed"));}
makeURI(baseUrl,requestID,token,suffix="",params=""){params=params?"?"+new URLSearchParams(params).toString():"";return`${baseUrl}/${requestID}/${token}${suffix}${params}`;}}
return __exports;});;

/* /sign/static/src/services/sign_info_service.js */
odoo.define('@sign/services/sign_info_service',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const signInfoService=__exports.signInfoService={dependencies:[],start(){let signInfo={};function set(data){Object.assign(signInfo,data);}
function reset(data){signInfo=data;}
function get(key){return signInfo[key];}
return{set,reset,get,};},};registry.category("services").add("signInfo",signInfoService);return __exports;});;

/* /sign/static/src/fields/ many2many_binary_field/ many2many_binary_field.js */
odoo.define('@sign/fields/',['@web/core/registry','@web/views/fields/many2many_binary/many2many_binary_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Many2ManyBinaryField,many2ManyBinaryField}=require("@web/views/fields/many2many_binary/many2many_binary_field");const Many2ManyBinaryFieldSignRequest=__exports.Many2ManyBinaryFieldSignRequest=class Many2ManyBinaryFieldSignRequest extends Many2ManyBinaryField{static template="sign.Many2ManyBinaryField";}
const many2ManyBinaryFieldSignRequest=__exports.many2ManyBinaryFieldSignRequest={...many2ManyBinaryField,component:Many2ManyBinaryFieldSignRequest,};registry.category("fields").add("many2many_binary_sign_request",many2ManyBinaryFieldSignRequest);return __exports;});;

/* /sign/static/src/fields/signer_x2many.js */
odoo.define('@sign/fields/signer_x2many',['@web/core/registry','@web/core/l10n/translation','@web/views/fields/x2many/x2many_field','@web/views/fields/many2one/many2one_field','@web/views/fields/integer/integer_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const{Many2OneField}=require("@web/views/fields/many2one/many2one_field");const{IntegerField}=require("@web/views/fields/integer/integer_field");const SignerX2Many=__exports.SignerX2Many=class SignerX2Many extends X2ManyField{static template="sign.SignerX2Many";static components={...X2ManyField.components,Many2OneField,IntegerField,};static props={...X2ManyField.props,};get partnerIdFieldInfo(){return{name:"partner_id",additionalProps:{readonly:false,placeholder:_t("Type a name or email..."),context:{force_email:true,show_email:true},},};}
get shouldShowOrder(){return this.props.record.data["set_sign_order"];}}
const signerX2Many={component:SignerX2Many,displayName:_t("Signer One 2 Many"),additionalClasses:["o_required_modifier"],supportedTypes:["one2many"],relatedFields:()=>{return[{name:"role_id",type:"many2one",relation:"sign.item.role",readonly:false},{name:"partner_id",type:"many2one",relation:"res.partner",readonly:false},{name:"mail_sent_order",type:"integer",readonly:false},];},fieldDependencies:[{name:"set_sign_order",type:"boolean"}],extractProps:x2ManyField.extractProps,};registry.category("fields").add("signer_x2many",signerX2Many);return __exports;});;

/* /knowledge/static/src/components/article_selection_dialog/article_selection_dialog.js */
odoo.define('@knowledge/components/article_selection_dialog/article_selection_dialog',['@web/core/l10n/translation','@web/core/utils/hooks','@web/core/dialog/dialog','@web/core/select_menu/select_menu','@web/core/dropdown/dropdown_item','@web/core/user','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require('@web/core/utils/hooks');const{Dialog}=require('@web/core/dialog/dialog');const{SelectMenu}=require('@web/core/select_menu/select_menu');const{DropdownItem}=require('@web/core/dropdown/dropdown_item');const{user}=require("@web/core/user");const{Component,useEffect,onWillStart,useRef,useState}=require('@odoo/owl');const ArticleSelectionDialog=__exports.ArticleSelectionDialog=class ArticleSelectionDialog extends Component{static template='knowledge.ArticleSelectionDialog';static components={Dialog,DropdownItem,SelectMenu};static props={articleSelected:Function,close:Function,confirmLabel:String,title:String,parentArticleId:{type:Number,optional:true},};setup(){super.setup();this.orm=useService('orm');this.placeholderLabel=_t('Choose an Article...');this.toggler=useRef('togglerRef');this.state=useState({selectedArticleName:false,knowledgeArticles:[],createLabel:''});useEffect((toggler)=>{toggler.click();},()=>[this.toggler.el]);onWillStart(async()=>{await this.fetchArticles();this.state.isInternalUser=await user.hasGroup('base.group_user');});}
async createKnowledgeArticle(label){const articleId=await this.orm.call('knowledge.article','article_create',[],{title:label,parent_id:this.props.parentArticleId});this.props.articleSelected({articleId:articleId,displayName:`📄 ${label}`});this.props.close();if(this.props.parentArticleId){this.env.bus.trigger('knowledge.sidebar.insertNewArticle',{articleId:articleId,name:label,icon:'📄',parentId:this.props.parentArticleId,});}}
async fetchArticles(searchValue){this.state.createLabel=_t('Create "%s"',searchValue);const domain=[['user_has_access','=',true],['is_template','=',false]];if(searchValue){domain.push(['name','=ilike',`%${searchValue}%`]);}
const knowledgeArticles=await this.orm.searchRead('knowledge.article',domain,['id','display_name','root_article_id'],{limit:20});this.state.knowledgeArticles=knowledgeArticles.map(({id,display_name,root_article_id})=>{return{value:{articleId:id,rootArticleName:root_article_id[0]!==id?root_article_id[1]:''},label:display_name};});}
async selectArticle(value){this.selectedArticle=this.state.knowledgeArticles.find(knowledgeArticle=>knowledgeArticle.value.articleId===value.articleId);this.state.selectedArticleName=this.selectedArticle.label;}
confirmArticleSelection(){this.props.articleSelected({articleId:this.selectedArticle.value.articleId,displayName:this.selectedArticle.label});this.props.close();}}
return __exports;});;

/* /knowledge/static/src/components/article_template_picker_dialog/article_template_picker_dialog.js */
odoo.define('@knowledge/components/article_template_picker_dialog/article_template_picker_dialog',['@odoo/owl','@web/core/dialog/dialog','@web/core/utils/arrays','@web/model/record','@web/core/utils/hooks','@knowledge/components/knowledge_html_viewer/knowledge_html_viewer','@knowledge/components/with_sub_env/with_sub_env','@html_editor/others/embedded_components/embedding_sets','@knowledge/editor/embedded_components/embedding_sets'],function(require){'use strict';let __exports={};const{Component,onWillStart,useEffect,useRef,useState}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{groupBy}=require("@web/core/utils/arrays");const{Record}=require("@web/model/record");const{useService}=require("@web/core/utils/hooks");const{KnowledgeHtmlViewer}=require("@knowledge/components/knowledge_html_viewer/knowledge_html_viewer");const{WithSubEnv}=require("@knowledge/components/with_sub_env/with_sub_env");const{READONLY_MAIN_EMBEDDINGS}=require("@html_editor/others/embedded_components/embedding_sets");const{KNOWLEDGE_READONLY_EMBEDDINGS}=require("@knowledge/editor/embedded_components/embedding_sets");const ArticleTemplatePickerDialog=__exports.ArticleTemplatePickerDialog=class ArticleTemplatePickerDialog extends Component{static template="knowledge.ArticleTemplatePickerDialog";static components={Dialog,Record,KnowledgeHtmlViewer,WithSubEnv};static props={onLoadTemplate:{type:Function},close:{type:Function},};setup(){super.setup();this.size="fs";this.orm=useService("orm");this.scrollView=useRef("scroll-view");this.state=useState({});onWillStart(async()=>{const templates=await this.orm.searchRead("knowledge.article",[["is_template","=",true],["parent_id","=",false]],["id","icon","template_name","template_category_id","template_category_sequence","template_sequence",],{});const groups=groupBy(templates,template=>template["template_category_id"][0]);this.groups=Object.values(groups).sort((a,b)=>{return a[0]["template_category_sequence"]>b[0]["template_category_sequence"];}).map(group=>group.sort((a,b)=>{return a["template_sequence"]>b["template_sequence"];}));if(this.groups.length>0){this.state.resId=this.groups[0][0].id;}});useEffect(()=>{const{el}=this.scrollView;if(el){el.style.visibility="visible";}},()=>[this.state.resId]);}
async onSelectTemplate(articleTemplateId){const{el}=this.scrollView;el.scrollTop=0;if(articleTemplateId!==this.state.resId){el.style.visibility="hidden";this.state.resId=articleTemplateId;}}
async onLoadTemplate(){this.props.onLoadTemplate(this.state.resId);this.props.close();}
getHtmlViewerConfig(record){return{config:{value:record.data.template_preview,embeddedComponents:[...READONLY_MAIN_EMBEDDINGS,...KNOWLEDGE_READONLY_EMBEDDINGS],},};}
get articleTemplateFieldNames(){return["cover_image_url","icon","id","parent_id","template_name","template_preview","template_description",];}}
return __exports;});;

/* /knowledge/static/src/components/breadcrumbs/breadcrumbs.js */
odoo.define('@knowledge/components/breadcrumbs/breadcrumbs',['@web/core/utils/hooks','@web/model/relational_model/utils','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{useRecordObserver}=require("@web/model/relational_model/utils");const{Component}=require("@odoo/owl");const KnowledgeBreadcrumbs=__exports[Symbol.for("default")]=class KnowledgeBreadcrumbs extends Component{static template="knowledge.KnowledgeBreadcrumbs";static props={record:Object,};setup(){super.setup();this.actionService=useService("action");this.articlesIndexes=[this.props.record.resId];this.articleIndex=0;this.canRestorePreviousAction=this.env.config.breadcrumbs?.length>1;useRecordObserver((record)=>{if(record.resId!==this.articlesIndexes[this.articleIndex]){this.articlesIndexes.splice(++this.articleIndex,this.articlesIndexes.length-this.articleIndex,record.resId,);}});}
get isGoBackEnabled(){return this.articleIndex>0||this.canRestorePreviousAction;}
get isGoNextEnabled(){return this.articleIndex<this.articlesIndexes.length-1;}
onClickBack(){if(this.isGoBackEnabled){if(this.articleIndex===0){this.actionService.restore();}else{this.env.openArticle(this.articlesIndexes[--this.articleIndex]);}}}
onClickNext(){if(this.isGoNextEnabled){this.env.openArticle(this.articlesIndexes[++this.articleIndex]);}}}
return __exports;});;

/* /knowledge/static/src/components/chatter_panel/chatter_panel.js */
odoo.define('@knowledge/components/chatter_panel/chatter_panel',['@web/core/registry','@web/views/widgets/standard_widget_props','@web/core/utils/hooks','@mail/chatter/web_portal/chatter','@web/core/ui/ui_service','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require('@web/core/registry');const{standardWidgetProps}=require('@web/views/widgets/standard_widget_props');const{useService}=require("@web/core/utils/hooks");const{Chatter}=require('@mail/chatter/web_portal/chatter');const{SIZES}=require("@web/core/ui/ui_service");const{Component,useRef,useState}=require('@odoo/owl');const KnowledgeArticleChatter=__exports.KnowledgeArticleChatter=class KnowledgeArticleChatter extends Component{static template='knowledge.KnowledgeArticleChatter';static components={Chatter};static props={...standardWidgetProps};setup(){this.state=useState({displayChatter:false,});this.root=useRef('root')
this.ui=useService("ui");this.env.bus.addEventListener('KNOWLEDGE:TOGGLE_CHATTER',this.toggleChatter.bind(this));}
toggleChatter(event){this.state.displayChatter=event.detail.displayChatter;if(this.state.displayChatter){this.root.el?.parentElement?.classList.remove('d-none');}else{this.root.el?.parentElement?.classList.add('d-none');}}
get isChatterAside(){return this.ui.size>=SIZES.LG;}}
const knowledgeChatterPanel=__exports.knowledgeChatterPanel={component:KnowledgeArticleChatter,additionalClasses:['o_knowledge_chatter','col-12','col-lg-4','position-relative','d-none','p-0','test']};registry.category('view_widgets').add('knowledge_chatter_panel',knowledgeChatterPanel);return __exports;});;

/* /knowledge/static/src/components/custom_favorite_item/custom_favorite_filter.js */
odoo.define('@knowledge/components/custom_favorite_item/custom_favorite_filter',['@web/search/custom_favorite_item/custom_favorite_item','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{CustomFavoriteItem}=require("@web/search/custom_favorite_item/custom_favorite_item");const{patch}=require("@web/core/utils/patch");patch(CustomFavoriteItem.prototype,{setup(){super.setup(...arguments);if(this.isKnowledgeEmbeddedView()){this.state.isShared=true;}},isKnowledgeEmbeddedView(){return(this.env.searchModel&&this.env.searchModel.context&&this.env.searchModel.context.knowledgeEmbeddedViewId);},});return __exports;});;

/* /knowledge/static/src/components/embedded_view_actions_menu/embedded_view_actions_menu.js */
odoo.define('@knowledge/components/embedded_view_actions_menu/embedded_view_actions_menu',['@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/registry','@odoo/owl'],function(require){'use strict';let __exports={};const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{registry}=require("@web/core/registry");const{Component}=require("@odoo/owl");const cogMenuRegistry=registry.category("cogMenu");const EmbeddedViewActionsMenu=__exports.EmbeddedViewActionsMenu=class EmbeddedViewActionsMenu extends Component{static props={};static template="knowledge.EmbeddedViewActionsMenu";static components={Dropdown,DropdownItem};_onOpenEmbeddedView(){this.env.bus.trigger(`KNOWLEDGE_EMBEDDED_${this.env.searchModel.context.knowledgeEmbeddedViewId}:OPEN`);}
_onEditEmbeddedView(){this.env.bus.trigger(`KNOWLEDGE_EMBEDDED_${this.env.searchModel.context.knowledgeEmbeddedViewId}:EDIT`);}}
cogMenuRegistry.add('embedded-view-actions-menu',{Component:EmbeddedViewActionsMenu,groupNumber:10,isDisplayed:(env)=>{return env.searchModel.context.knowledgeEmbeddedViewId&&!env.searchModel.context.isOpenedEmbeddedView;},},);return __exports;});;

/* /knowledge/static/src/components/external_embedded_view_favorite_menu/embedded_view_favorite_menu.js */
odoo.define('@knowledge/components/external_embedded_view_favorite_menu/embedded_view_favorite_menu',['@odoo/owl','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/l10n/translation','@web/core/registry','@web/core/user','@web/core/utils/hooks','@web/core/utils/objects','@web/core/utils/render','@web/views/view_dialogs/select_create_dialog'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{useOwnedDialogs,useService}=require("@web/core/utils/hooks");const{omit}=require("@web/core/utils/objects");const{renderToElement}=require("@web/core/utils/render");const{SelectCreateDialog}=require("@web/views/view_dialogs/select_create_dialog");const cogMenuRegistry=registry.category("cogMenu");const supportedEmbeddedViews=new Set(["calendar","graph","hierarchy","kanban","list","pivot","cohort","gantt","map",]);class InsertEmbeddedViewMenu extends Component{static props={};static template="knowledge.InsertEmbeddedViewMenu";static components={Dropdown,DropdownItem};setup(){this.orm=useService("orm");this.actionService=useService("action");this.addDialog=useOwnedDialogs();this.knowledgeCommandsService=useService("knowledgeCommandsService");}
extractCurrentViewEmbedTemplateProps(){const viewProps={context:this.getViewContext(),displayName:this.env.config.getDisplayName(),viewType:this.env.config.viewType,};const xmlId=this.actionService.currentController?.action?.xml_id;if(xmlId){viewProps.actionXmlId=xmlId;return{embeddedProps:{viewProps}};}
const originalAction=this.actionService.currentController?.action?._originalAction;if(originalAction){const action=JSON.parse(originalAction);delete action.help;viewProps.actWindow=action;return{embeddedProps:{viewProps}};}
return null;}
getViewContext(){const context={};if(this.env.searchModel){Object.assign(context,omit(this.env.searchModel.context,...Object.keys(user.context)));Object.assign(context,{knowledge_search_model_state:JSON.stringify(this.env.searchModel.exportState()),});}
const fns=this.env.__getContext__.callbacks;const localContext=Object.assign({},...fns.map((fn)=>fn()));const extraContext={};this.env.searchModel.trigger("insert-embedded-view",extraContext);Object.assign(context,localContext,extraContext);return context;}
insertCurrentViewInKnowledge(template){const config=this.env.config;const templateProps=this.extractCurrentViewEmbedTemplateProps();if(config.actionType!=="ir.actions.act_window"||!templateProps){throw new Error('This view can not be embedded in an article: the action is not an "ir.actions.act_window" or is not serializable.');}
this.openArticleSelector(async(id)=>{this.knowledgeCommandsService.setPendingEmbeddedBlueprint({embeddedBlueprint:renderToElement(template,{embeddedProps:JSON.stringify(templateProps.embeddedProps),}),model:"knowledge.article",field:"body",resId:id,});this.actionService.doAction("knowledge.ir_actions_server_knowledge_home_page",{additionalContext:{res_id:id,},});});}
onInsertEmbeddedViewInArticle(){this.insertCurrentViewInKnowledge("knowledge.EmbeddedViewBlueprint");}
onInsertViewLinkInArticle(){this.insertCurrentViewInKnowledge("knowledge.EmbeddedViewLinkBlueprint");}
openArticleSelector(onSelectCallback){this.addDialog(SelectCreateDialog,{title:_t("Select an article"),noCreate:false,multiSelect:false,resModel:"knowledge.article",context:{},domain:[["user_has_write_access","=",true],["is_template","=",false],],onSelected:(resIds)=>{onSelectCallback(resIds[0]);},onCreateEdit:async()=>{const articleId=await this.orm.call("knowledge.article","article_create",[],{is_private:true,});onSelectCallback(articleId);},});}}
cogMenuRegistry.add("insert-embedded-view-menu",{Component:InsertEmbeddedViewMenu,groupNumber:10,isDisplayed:(env)=>{return(env.config.actionId&&!env.searchModel.context.knowledgeEmbeddedViewId&&supportedEmbeddedViews.has(env.config.viewType));},});return __exports;});;

/* /knowledge/static/src/components/external_embedded_view_insertion/views_renderers_patches.js */
odoo.define('@knowledge/components/external_embedded_view_insertion/views_renderers_patches',['@web/core/utils/hooks','@web/core/utils/patch','@web/views/list/list_renderer'],function(require){'use strict';let __exports={};const{useBus}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");const{ListRenderer}=require("@web/views/list/list_renderer");patch(ListRenderer.prototype,{setup(){super.setup();if(this.env.searchModel){useBus(this.env.searchModel,"insert-embedded-view",(ev)=>{Object.assign(ev.detail,{orderBy:JSON.stringify(this.props.list.orderBy),keyOptionalFields:this.keyOptionalFields,});});}},createViewKey(){if(this.env.searchModel?.context.knowledgeEmbeddedViewId){return`${super.createViewKey()},${this.env.searchModel.context.knowledgeEmbeddedViewId}`;}
return super.createViewKey();},});return __exports;});;

/* /knowledge/static/src/components/form_status_indicator/form_status_indicator.js */
odoo.define('@knowledge/components/form_status_indicator/form_status_indicator',['@web/views/form/form_status_indicator/form_status_indicator'],function(require){'use strict';let __exports={};const{FormStatusIndicator}=require("@web/views/form/form_status_indicator/form_status_indicator");const KnowledgeFormStatusIndicator=__exports.KnowledgeFormStatusIndicator=class KnowledgeFormStatusIndicator extends FormStatusIndicator{static template='knowledge.FormStatusIndicator';}
return __exports;});;

/* /knowledge/static/src/components/hierarchy/hierarchy.js */
odoo.define('@knowledge/components/hierarchy/hierarchy',['@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/utils/hooks','@web/model/relational_model/utils','@knowledge/components/breadcrumbs/breadcrumbs','@knowledge/components/knowledge_icon/knowledge_icon','@odoo/owl'],function(require){'use strict';let __exports={};const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{useService}=require("@web/core/utils/hooks");const{useRecordObserver}=require("@web/model/relational_model/utils");const KnowledgeBreadcrumbs=require("@knowledge/components/breadcrumbs/breadcrumbs")[Symbol.for("default")];const KnowledgeIcon=require("@knowledge/components/knowledge_icon/knowledge_icon")[Symbol.for("default")];const{Component,useState}=require("@odoo/owl");const KnowledgeHierarchy=__exports[Symbol.for("default")]=class KnowledgeHierarchy extends Component{static components={Dropdown,DropdownItem,KnowledgeBreadcrumbs,KnowledgeIcon,};static props={record:Object};static template="knowledge.KnowledgeHierarchy";setup(){super.setup();this.orm=useService("orm");this.state=useState({articleName:this.props.record.data.name,isLoadingArticleHierarchy:false,});useRecordObserver((record)=>{if(this.state.articleName!==record.data.name){this.state.articleName=record.data.name;}});}
get displayDropdownToggle(){return this.props.record.data.parent_path.split("/").length>4;}
get isReadonly(){return this.props.record.data.is_locked||!this.props.record.data.user_can_write;}
get parentId(){return this.props.record.data.parent_id?.[0];}
get parentName(){return this.props.record.data.parent_id?.[1];}
get rootId(){return this.props.record.data.root_article_id[0];}
get rootName(){return this.props.record.data.root_article_id[1];}
async loadHierarchy(){this.articleHierarchy=await this.orm.call("knowledge.article","get_article_hierarchy",[this.props.record.resId],{exclude_article_ids:[this.rootId,this.parentId,this.props.record.resId]},);this.state.isLoadingArticleHierarchy=false;}
async onBeforeOpen(){this.state.isLoadingArticleHierarchy=true;this.loadHierarchy();}}
return __exports;});;

/* /knowledge/static/src/components/item_calendar_props_dialog/item_calendar_props_dialog.js */
odoo.define('@knowledge/components/item_calendar_props_dialog/item_calendar_props_dialog',['@web/core/l10n/translation','@web/core/dialog/dialog','@web/core/dropdown/dropdown_item','@web/views/calendar/calendar_controller','@web/core/select_menu/select_menu','@web/core/utils/hooks','@web/views/utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Dialog}=require("@web/core/dialog/dialog");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{SCALE_LABELS}=require("@web/views/calendar/calendar_controller");const{SelectMenu}=require("@web/core/select_menu/select_menu");const{useAutofocus,useService}=require("@web/core/utils/hooks");const{uuid}=require("@web/views/utils");const{Component,onWillStart,useExternalListener,useState}=require("@odoo/owl");const ItemCalendarPropsDialog=__exports.ItemCalendarPropsDialog=class ItemCalendarPropsDialog extends Component{static template="knowledge.ItemCalendarPropsDialog";static components={DropdownItem,Dialog,SelectMenu,};static props={knowledgeArticleId:{type:Number,optional:true},close:{type:Function,optional:true},colorPropertyId:{type:String,optional:true},dateStartPropertyId:{type:String,optional:true},dateStopPropertyId:{type:String,optional:true},dateType:{type:String,optional:true},isNew:{type:Boolean,optional:true},name:{type:String,optional:true},saveItemCalendarProps:{type:Function},scale:{type:String,optional:true},showWeekEnds:{type:Boolean,optional:true},slotMaxTime:{type:String,optional:true},slotMinTime:{type:String,optional:true},};static defaultProps={showWeekEnds:true,slotMinTime:"00:00",slotMaxTime:"24:00",};setup(){super.setup();useAutofocus();this.orm=useService("orm");this.notification=useService("notification");this.state=useState({name:this.props.name,scale:this.props.scale||"week",showWeekEnds:this.props.showWeekEnds,slotMaxTime:this.props.slotMaxTime,slotMinTime:this.props.slotMinTime,});this.colorChoices=[];this.dateChoices=[];this.dateTimeChoices=[];this.propertyFieldEntries={};this.scalesChoices=Object.entries(SCALE_LABELS).map(([value,label])=>({value,label}));onWillStart(async()=>{const propertiesDefinitions=await this.orm.read("knowledge.article",[this.props.knowledgeArticleId],["article_properties_definition"]);this.propertiesDefinitions=propertiesDefinitions[0].article_properties_definition;for(const definition of this.propertiesDefinitions){this.propertyFieldEntries[definition.name]={label:definition.string,type:definition.type,};const choice={value:definition.name,label:definition.string,};if(definition.type==="datetime"){this.dateTimeChoices.push(choice);}else if(definition.type==="date"){this.dateChoices.push(choice);}else if(["boolean","many2one","selection"].includes(definition.type)){this.colorChoices.push(choice);}}
if(this.props.isNew){if(!this.dateTimeChoices.length&&!this.dateChoices.length){this.autoCreateDateProperties=true;this.createProperty(_t("Start Date Time"),"datetime","dateStart");this.createProperty(_t("End Date Time"),"datetime","dateStop");}else{if(this.dateTimeChoices.length>1){this.selectDateStart(this.dateTimeChoices[0].value);this.selectDateStop(this.dateTimeChoices[1].value);}else if(this.dateChoices.length>1){this.selectDateStart(this.dateChoices[0].value);this.selectDateStop(this.dateChoices[1].value);}else if(this.dateTimeChoices.length!==0){this.selectDateStart(this.dateTimeChoices[0].value);}else{this.selectDateStart(this.dateChoices[0].value);}}}else{for(const propName of["dateStartPropertyId","dateStopPropertyId","colorPropertyId"]){if(this.propertyFieldEntries[this.props[propName]]){this.state[propName]=this.props[propName];}}}});useExternalListener(window,"keydown",(event)=>{if(event.key==="Enter"){this.save();}});}
get availableDateStartProperties(){return[{label:_t("Date and Time Properties"),choices:this.dateTimeChoices},{label:_t("Date Properties"),choices:this.dateChoices,}];}
get availableDateStopProperties(){if(this.dateStartProperty?.type==="datetime"){return[{label:_t("Date and Time Properties"),choices:this.dateTimeChoices.filter(choice=>choice.value!==this.state.dateStartPropertyId),}];}
return[{label:_t("Date Properties"),choices:this.dateChoices.filter(choice=>choice.value!==this.state.dateStartPropertyId),}];}
get colorProperty(){return this.propertyFieldEntries[this.state.colorPropertyId];}
get dateStartProperty(){return this.propertyFieldEntries[this.state.dateStartPropertyId];}
get dateStopProperty(){return this.propertyFieldEntries[this.state.dateStopPropertyId];}
createProperty(label,type,calendarProp){const newPropertyId=uuid();this.propertyFieldEntries[newPropertyId]={isNew:true,label:label,type:type,};const newChoice={value:newPropertyId,label,};if(type==="date"){this.dateChoices.push(newChoice);}else if(type==="datetime"){this.dateTimeChoices.push(newChoice);}else{this.colorChoices.push(newChoice);}
if(calendarProp==="dateStart"){this.selectDateStart(newPropertyId);}else if(calendarProp==="dateStop"){this.selectDateStop(newPropertyId);}else if(calendarProp==="color"){this.selectColor(newPropertyId);}}
async save(){if(!this.state.dateStartPropertyId){this.notification.add(_t("The start date property is required."),{type:"danger"});return;}
if(this.dateStartProperty.isNew||this.dateStopProperty?.isNew||this.colorProperty?.isNew){const propertiesDefinitions=[...this.propertiesDefinitions];if(this.dateStartProperty.isNew){propertiesDefinitions.push({name:this.state.dateStartPropertyId,string:this.dateStartProperty.label,type:this.dateStartProperty.type,});}
if(this.dateStopProperty?.isNew){propertiesDefinitions.push({name:this.state.dateStopPropertyId,string:this.dateStopProperty.label,type:this.dateStopProperty.type,});}
if(this.colorProperty?.isNew){propertiesDefinitions.push({name:this.state.colorPropertyId,string:this.colorProperty.label,type:this.colorProperty.type,});}
try{await this.orm.write("knowledge.article",[this.props.knowledgeArticleId],{article_properties_definition:propertiesDefinitions});}catch(e){this.notification.add(_t("New property could not be created."),{type:"danger"});console.error(e);return;}}
this.props.saveItemCalendarProps(this.state.name,{dateStartPropertyId:this.state.dateStartPropertyId,dateStopPropertyId:this.state.dateStopPropertyId||undefined,colorPropertyId:this.state.colorPropertyId||undefined,scale:this.state.scale,dateType:this.dateStartProperty.type,showWeekEnds:this.state.showWeekEnds,slotMinTime:this.state.slotMinTime||"00:00",slotMaxTime:this.state.slotMaxTime||"24:00",});this.props.close();}
selectColor(value){this.state.colorPropertyId=value;}
selectDateStop(value){this.state.dateStopPropertyId=value;}
selectScale(value){this.state.scale=value;}
selectDateStart(value){this.state.dateStartPropertyId=value;if(this.state.dateStopPropertyId&&(this.dateStartProperty.type!==this.dateStopProperty.type||this.state.dateStopPropertyId===this.state.dateStartPropertyId)){this.state.dateStopPropertyId=false;}}}
return __exports;});;

/* /knowledge/static/src/components/knowledge_cover/knowledge_cover.js */
odoo.define('@knowledge/components/knowledge_cover/knowledge_cover',['@web/core/registry','@web/views/widgets/standard_widget_props','@web/core/user','@web/core/utils/timing','@web/model/relational_model/utils','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{user}=require("@web/core/user");const{throttleForAnimation}=require("@web/core/utils/timing");const{useRecordObserver}=require("@web/model/relational_model/utils");const{Component,onWillStart,useRef,useState}=require("@odoo/owl");class KnowledgeCover extends Component{static props=standardWidgetProps;static template="knowledge.KnowledgeCover";setup(){super.setup();this.root=useRef("root");this.image=useRef("image");this.state=useState({repositioning:false,grabbing:false,verticalPosition:this.props.record.data.cover_image_position||50,});onWillStart(async()=>{this.isInternalUser=await user.hasGroup('base.group_user');});let previousArticleId=this.props.record.resId;useRecordObserver((record)=>{if(!previousArticleId||previousArticleId!==record.resId){previousArticleId=record.resId;this.state.repositioning=false;this.state.grabbing=false;this.state.verticalPosition=record.data.cover_image_position||50;}});}
get isEditable(){const recordData=this.props.record.data;return!recordData.is_locked&&recordData.user_can_write&&recordData.active&&this.isInternalUser;}
changeCover(){this.env.ensureArticleName();this.env.openCoverSelector();}
removeCover(){this.props.record.update({cover_image_id:false});}
repositionCover(){this.state.repositioning=true;const cover=this.image.el;let prevPos;const moveCover=throttleForAnimation(ev=>{if(prevPos!==ev.y){const verticalPosition=this.state.verticalPosition+(prevPos-ev.y)/5;this.state.verticalPosition=Math.max(0.01,Math.min(100,verticalPosition));prevPos=ev.y;}});const onPointerUp=()=>{this.state.grabbing=false;document.removeEventListener('pointermove',moveCover);};const onPointerDown=(ev)=>{ev.preventDefault();ev.stopPropagation();prevPos=ev.y;this.state.grabbing=true;document.addEventListener('pointermove',moveCover);document.addEventListener('pointerup',onPointerUp,{once:true});};cover.addEventListener('pointerdown',onPointerDown);document.addEventListener('pointerdown',(ev)=>{cover.removeEventListener('pointerdown',onPointerDown);this.state.repositioning=false;if(ev.target.classList.contains('o_knowledge_undo_cover_move')){this.state.verticalPosition=this.props.record.data.cover_image_position||50;}else{this.props.record.update({cover_image_position:this.state.verticalPosition});}},{once:true});}}
const knowledgeCover=__exports.knowledgeCover={component:KnowledgeCover,};registry.category("view_widgets").add("knowledge_cover",knowledgeCover);return __exports;});;

/* /knowledge/static/src/components/knowledge_cover/knowledge_cover_dialog.js */
odoo.define('@knowledge/components/knowledge_cover/knowledge_cover_dialog',['@web/core/l10n/translation','@html_editor/main/media/media_dialog/image_selector','@web/core/confirmation_dialog/confirmation_dialog','@web/core/dialog/dialog','@web_unsplash/unsplash_error/unsplash_error','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{AutoResizeImage,ImageSelector,}=require("@html_editor/main/media/media_dialog/image_selector");const{ConfirmationDialog}=require('@web/core/confirmation_dialog/confirmation_dialog');const{Dialog}=require('@web/core/dialog/dialog');const{UnsplashError}=require('@web_unsplash/unsplash_error/unsplash_error');const{useService,useChildRef}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const AutoResizeCover=__exports.AutoResizeCover=class AutoResizeCover extends AutoResizeImage{setup(){super.setup();this.orm=useService("orm");}
remove(){this.dialogs.add(ConfirmationDialog,{body:_t("Are you sure you want to delete this cover? It will be removed from every article it is used in."),confirm:async()=>{const res=await this.orm.unlink(this.props.model,[this.props.resId],);if(res){this.props.onRemoved(this.props.id,this.props.resId);}},});}}
const KnowledgeCoverSelector=__exports.KnowledgeCoverSelector=class KnowledgeCoverSelector extends ImageSelector{static defaultProps={resModel:"knowledge.cover",orientation:"landscape",};static attachmentsListTemplate="knowledge.CoversListTemplate";static components={...ImageSelector.components,AutoResizeCover,UnsplashError,};setup(){super.setup();this.unsplashService=useService("unsplash");this.state.needle=this.props.searchTerm;this.searchUnsplash(this.state.needle);}
get attachmentsDomain(){return['&',['res_model','=',this.props.resModel],['name','ilike',this.state.needle]];}
onClickAttachment(attachment){this.props.save(attachment.res_id);}
onClickRecord(unsplashRecord){this.unsplashService.uploadUnsplashRecords([unsplashRecord],{resModel:this.props.resModel,resId:this.props.articleCoverId},async(attachments)=>this.onUploaded(attachments[0]));}
onRemoved(attachmentId,coverId){super.onRemoved(attachmentId);if(coverId===this.props.articleCoverId){this.props.save(false);}}
async onUploaded(attachment){const[coverId]=await this.orm.create(this.props.resModel,[{attachment_id:attachment.id}]);this.props.save(coverId);}
get selectedAttachmentIds(){return[];}
get selectedRecordIds(){return[];}}
const KnowledgeCoverDialog=__exports.KnowledgeCoverDialog=class KnowledgeCoverDialog extends Component{static template='knowledge.KnowledgeCoverDialog';static components={KnowledgeCoverSelector,Dialog};static props={articleCoverId:{type:Number,optional:true},articleName:String,save:Function,close:Function,};setup(){this.size='xl';this.contentClass='o_select_media_dialog h-100';this.modalRef=useChildRef();}
save(coverId){this.props.save(coverId);this.props.close();}}
return __exports;});;

/* /knowledge/static/src/components/knowledge_dropdown/knowledge_dropdown_patch.js */
odoo.define('@knowledge/components/knowledge_dropdown/knowledge_dropdown_patch',['@web/core/utils/patch','@web/core/dropdown/dropdown'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{Dropdown}=require("@web/core/dropdown/dropdown");patch(Dropdown.prototype,{popoverCloseOnClickAway(target,activeEl){const currentActiveEl=this.uiService.getActiveElementOf(target);return(super.popoverCloseOnClickAway(target,activeEl)||(currentActiveEl!==activeEl&&activeEl&&activeEl.contains(currentActiveEl)&&currentActiveEl.dataset.embedded));},});return __exports;});;

/* /knowledge/static/src/components/knowledge_html_field/knowledge_html_field.js */
odoo.define('@knowledge/components/knowledge_html_field/knowledge_html_field',['@html_editor/fields/html_field','@knowledge/editor/embedded_components/embedding_sets','@knowledge/editor/plugin_sets','@web/core/registry','@odoo/owl','@knowledge/components/knowledge_html_viewer/knowledge_html_viewer','@knowledge/components/knowledge_wysiwyg/knowledge_wysiwyg','@web/search/action_hook','@web/model/relational_model/utils','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{HtmlField,htmlField}=require("@html_editor/fields/html_field");const{KNOWLEDGE_EMBEDDINGS,KNOWLEDGE_READONLY_EMBEDDINGS,}=require("@knowledge/editor/embedded_components/embedding_sets");const{KNOWLEDGE_EMBEDDED_COMPONENT_PLUGINS,KNOWLEDGE_PLUGINS,}=require("@knowledge/editor/plugin_sets");const{registry}=require("@web/core/registry");const{useState,useSubEnv}=require("@odoo/owl");const{KnowledgeHtmlViewer}=require("@knowledge/components/knowledge_html_viewer/knowledge_html_viewer");const{KnowledgeWysiwyg}=require("@knowledge/components/knowledge_wysiwyg/knowledge_wysiwyg");const{CallbackRecorder}=require("@web/search/action_hook");const{useRecordObserver}=require("@web/model/relational_model/utils");const{useService}=require("@web/core/utils/hooks");const KnowledgeHtmlField=__exports.KnowledgeHtmlField=class KnowledgeHtmlField extends HtmlField{static components={...HtmlField.components,Wysiwyg:KnowledgeWysiwyg,HtmlViewer:KnowledgeHtmlViewer,};setup(){super.setup();useSubEnv({__onLayoutGeometryChange__:new CallbackRecorder(),});this.commentsService=useService("knowledge.comments");this.commentsState=useState(this.commentsService.getCommentsState());useRecordObserver((record)=>{if(record.resId!==this.commentsState.articleId){this.commentsService.setArticleId(record.resId);this.commentsService.loadRecords(record.resId,{ignoreBatch:true,includeLoaded:true,});}});}
getConfig(){const config=super.getConfig();if(this.props.embeddedComponents){config.resources.embedded_components=[...(config.resources.embedded_components||[]),...KNOWLEDGE_EMBEDDINGS,];config.Plugins=config.Plugins.filter((P)=>P.id!=="file");config.Plugins.push(...KNOWLEDGE_EMBEDDED_COMPONENT_PLUGINS);}
config.Plugins.push(...KNOWLEDGE_PLUGINS);config.onLayoutGeometryChange=()=>this.onLayoutGeometryChange();return config;}
getReadonlyConfig(){const config=super.getReadonlyConfig();if(this.props.embeddedComponents){config.embeddedComponents=[...(config.embeddedComponents||[]),...KNOWLEDGE_READONLY_EMBEDDINGS,];}
config.onLayoutGeometryChange=()=>this.onLayoutGeometryChange();return config;}
onLayoutGeometryChange(){for(const cb of this.env.__onLayoutGeometryChange__.callbacks){cb();}}}
const knowledgeHtmlField=__exports.knowledgeHtmlField={...htmlField,component:KnowledgeHtmlField,};registry.category("fields").add("knowledge_html",knowledgeHtmlField);return __exports;});;

/* /knowledge/static/src/components/knowledge_html_viewer/knowledge_html_viewer.js */
odoo.define('@knowledge/components/knowledge_html_viewer/knowledge_html_viewer',['@html_editor/fields/html_viewer','@html_editor/local_overlay_container','@html_editor/position_hook','@odoo/owl','@web/core/registry','@knowledge/comments/comments_handler/comments_handler','@knowledge/comments/comment_beacon_manager','@web/core/utils/hooks','@web/core/utils/functions','@web/core/utils/reactive','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{HtmlViewer}=require("@html_editor/fields/html_viewer");const{LocalOverlayContainer}=require("@html_editor/local_overlay_container");const{usePositionHook}=require("@html_editor/position_hook");const{onWillDestroy,useEffect,useExternalListener,useState,useSubEnv}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{KnowledgeCommentsHandler}=require("@knowledge/comments/comments_handler/comments_handler");const{CommentBeaconManager}=require("@knowledge/comments/comment_beacon_manager");const{useChildRef,useService}=require("@web/core/utils/hooks");const{uniqueId}=require("@web/core/utils/functions");const{effect}=require("@web/core/utils/reactive");const{batched}=require("@web/core/utils/timing");const KnowledgeHtmlViewer=__exports.KnowledgeHtmlViewer=class KnowledgeHtmlViewer extends HtmlViewer{static template="knowledge.KnowledgeHtmlViewer";static components={...HtmlViewer.components,LocalOverlayContainer,};setup(){super.setup();this.commentsService=useService("knowledge.comments");this.commentsState=useState(this.commentsService.getCommentsState());let editorThreadsKeys;this.alive=true;useExternalListener(window,"click",this.onWindowClick);effect(batched((state)=>{if(!this.alive){return;}
const editorThreads=state.editorThreads;const keys=Object.keys(editorThreads).toString();if(keys!==editorThreadsKeys){this.commentBeaconManager?.sortThreads();this.commentBeaconManager?.drawThreadOverlays();editorThreadsKeys=keys;}}),[this.commentsState]);onWillDestroy(()=>{this.alive=false;});this.overlayRef=useChildRef();useSubEnv({localOverlayContainerKey:uniqueId("html_viewer"),});usePositionHook(this.readonlyElementRef,document,()=>{this.commentBeaconManager?.drawThreadOverlays();this.props.config.onLayoutGeometryChange?.();});this.overlayComponentsKey=uniqueId("KnowledgeCommentsHandler");useEffect(()=>{let overlayContainer;if(this.readonlyElementRef.el&&this.overlayRef.el&&this.env.model.root.data.user_permission&&this.env.model.root.data.user_permission!=="none"){overlayContainer=this.makeLocalOverlay();this.overlayRef.el.append(overlayContainer);this.commentBeaconManager=new CommentBeaconManager({document,source:this.readonlyElementRef.el,overlayContainer:overlayContainer,commentsState:this.commentsState,readonly:true,});this.commentBeaconManager.sortThreads();this.commentBeaconManager.drawThreadOverlays();registry.category(this.env.localOverlayContainerKey).add(this.overlayComponentsKey,{Component:KnowledgeCommentsHandler,props:{commentBeaconManager:this.commentBeaconManager,contentRef:this.readonlyElementRef,},});}
return()=>{overlayContainer?.remove();this.commentBeaconManager?.destroy();this.commentBeaconManager=undefined;registry.category(this.env.localOverlayContainerKey).remove(this.overlayComponentsKey);};},()=>[this.readonlyElementRef.el,this.overlayRef.el]);}
onWindowClick(ev){const selector=".oe-local-overlay, .o_knowledge_comment_box";const closestElement=ev.target.closest(selector);if(!closestElement){this.commentsState.activeThreadId=undefined;}}
makeLocalOverlay(){const overlayContainer=document.createElement("div");overlayContainer.className=`oe-local-overlay`;overlayContainer.setAttribute("data-oe-local-overlay-id","KnowledgeThreadBeacons");return overlayContainer;}}
return __exports;});;

/* /knowledge/static/src/components/knowledge_icon/knowledge_icon.js */
odoo.define('@knowledge/components/knowledge_icon/knowledge_icon',['@web/core/emoji_picker/emoji_picker','@web/core/registry','@web/core/utils/strings','@web/views/fields/standard_field_props','@knowledge/js/knowledge_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{useEmojiPicker}=require("@web/core/emoji_picker/emoji_picker");const{registry}=require("@web/core/registry");const{exprToBoolean}=require("@web/core/utils/strings");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{getRandomIcon}=require("@knowledge/js/knowledge_utils");const{Component,useRef}=require("@odoo/owl");const KnowledgeIcon=__exports[Symbol.for("default")]=class KnowledgeIcon extends Component{static template="knowledge.KnowledgeIcon";static props={record:Object,readonly:Boolean,iconClasses:{type:String,optional:true},allowRandomIconSelection:{type:Boolean,optional:true},autoSave:{type:Boolean,optional:true},fallbackDefaultIcon:{type:Boolean,optional:true},};setup(){super.setup();this.iconRef=useRef("icon");this.emojiPicker=useEmojiPicker(this.iconRef,{hasRemoveFeature:true,onSelect:this.updateIcon.bind(this)});}
get icon(){return this.props.record.data.icon||(this.props.fallbackDefaultIcon&&"📄");}
async selectRandomIcon(){this.updateIcon(await getRandomIcon());}
updateIcon(icon){this.props.record.update({icon});if(this.props.autoSave){this.props.record.save();}}}
class KnowledgeIconField extends KnowledgeIcon{static props={...standardFieldProps,allowRandomIconSelection:Boolean,autoSave:Boolean,};}
registry.category("fields").add("knowledge_icon",{component:KnowledgeIconField,extractProps({attrs,viewType},dynamicInfo){return{autoSave:viewType==="kanban",readonly:dynamicInfo.readonly,allowRandomIconSelection:exprToBoolean(attrs.allow_random_icon_selection),};},});return __exports;});;

/* /knowledge/static/src/components/knowledge_wysiwyg/knowledge_wysiwyg.js */
odoo.define('@knowledge/components/knowledge_wysiwyg/knowledge_wysiwyg',['@html_editor/wysiwyg','@html_editor/utils/dom_info','@knowledge/components/wysiwyg_article_helper/wysiwyg_article_helper','@odoo/owl'],function(require){'use strict';let __exports={};const{Wysiwyg}=require("@html_editor/wysiwyg");const{isEmptyBlock}=require("@html_editor/utils/dom_info");const{WysiwygArticleHelper}=require("@knowledge/components/wysiwyg_article_helper/wysiwyg_article_helper");const{useState}=require("@odoo/owl");const KnowledgeWysiwyg=__exports.KnowledgeWysiwyg=class KnowledgeWysiwyg extends Wysiwyg{static template="knowledge.KnowledgeWysiwyg";static components={...Wysiwyg.components,WysiwygArticleHelper,};setup(){super.setup();this.articleHelperState=useState({isVisible:false,});}
getEditorConfig(){const config=super.getEditorConfig();return{...config,onChange:()=>{this.articleHelperState.isVisible=isEmptyBlock(this.editor.editable);config.onChange?.();},onEditorReady:()=>{this.articleHelperState.isVisible=isEmptyBlock(this.editor.editable);},};}}
return __exports;});;

/* /knowledge/static/src/components/move_article_dialog/move_article_dialog.js */
odoo.define('@knowledge/components/move_article_dialog/move_article_dialog',['@web/core/dialog/dialog','@web/core/user','@web/core/utils/hooks','@web/core/select_menu/select_menu','@odoo/owl','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Dialog}=require('@web/core/dialog/dialog');const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{SelectMenu}=require('@web/core/select_menu/select_menu');const{Component,onWillStart,useEffect,useRef,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");class MoveArticleDialog extends Component{static template="knowledge.MoveArticleDialog";static components={Dialog,SelectMenu};static props={close:Function,knowledgeArticleRecord:Object};setup(){this.size='md';this.orm=useService("orm");this.state=useState({selectedParentArticle:false,selectionDisplayGroups:[]});this.placeholderLabel=_t('Choose an Article...');this.toggler=useRef("togglerRef");onWillStart(this.fetchValues);useEffect((toggler)=>{toggler.click();},()=>[this.toggler.el]);}
async fetchValues(searchValue){const knowledgeArticles=await this.orm.call('knowledge.article','get_valid_parent_options',[this.props.knowledgeArticleRecord.resId],{search_term:searchValue});const formattedKnowledgeArticles=knowledgeArticles.map(({id,display_name,root_article_id})=>{return{value:{parentArticleId:id,rootArticleName:root_article_id[0]!==id?root_article_id[1]:''},label:display_name};});const selectionGroups=[{label:_t('Categories'),choices:[{value:{parentArticleId:'private'},label:_t('Private'),},{value:{parentArticleId:'workspace'},label:_t('Workspace')}],},{label:_t('Articles'),choices:formattedKnowledgeArticles,}];if(this.props.knowledgeArticleRecord.data.category!=='private'){selectionGroups[0].choices.push({value:{parentArticleId:'shared'},label:_t('Shared'),});}
this.state.selectionDisplayGroups=selectionGroups;this.state.choices=[...selectionGroups[0].choices,...formattedKnowledgeArticles];}
selectArticle(value){this.state.selectedParentArticle=this.state.choices.find((knowledgeArticle)=>knowledgeArticle.value.parentArticleId===value.parentArticleId);}
async confirmArticleMove(){if(!this.state.selectedParentArticle){return;}
const selectedParentArticle=this.state.selectedParentArticle.value.parentArticleId;const params={};if(typeof selectedParentArticle==='number'){params.parent_id=selectedParentArticle;}else{params.category=selectedParentArticle;}
await this.orm.call('knowledge.article','move_to',[this.props.knowledgeArticleRecord.resId],params);await this.props.knowledgeArticleRecord.model.load();this.props.close();}
get loggedUserPicture(){return`/web/image?model=res.users&field=avatar_128&id=${user.userId}`;}
get moveArticleLabel(){return _t('Move "%s" under:',this.props.knowledgeArticleRecord.data.display_name);}}
__exports[Symbol.for("default")]=MoveArticleDialog;return __exports;});;

/* /knowledge/static/src/components/permission_panel/permission_panel.js */
odoo.define('@knowledge/components/permission_panel/permission_panel',['@web/core/user','@web/core/network/rpc','@web/core/confirmation_dialog/confirmation_dialog','@web/core/l10n/translation','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{user}=require("@web/core/user");const{rpc}=require("@web/core/network/rpc");const{ConfirmationDialog,AlertDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{_t}=require("@web/core/l10n/translation");const{useService}=require('@web/core/utils/hooks');const{Component,onWillStart,useEffect,useState}=require("@odoo/owl");const permissionLevel={'none':0,'read':1,'write':2}
const restrictMessage=_t("Are you sure you want to restrict access to this article? "
+"This means it will no longer inherit access rights from its parents.");const loseWriteMessage=_t('Are you sure you want to remove your own "Write" access?');const PermissionPanel=__exports.PermissionPanel=class PermissionPanel extends Component{static template="knowledge.PermissionPanel";static props={record:Object,};setup(){this.actionService=useService('action');this.dialog=useService('dialog');this.orm=useService('orm');this.mailStore=useService("mail.store");this.state=useState({loading:true,partner_id:user.partnerId});onWillStart(async()=>{this.isInternalUser=await user.hasGroup('base.group_user');});useEffect(()=>{this.loadPanel();},()=>[this.props.record.resId]);}
async loadPanel(){Object.assign(this.state,{...await this.loadData(),loading:false});}
loadData(){return rpc("/knowledge/get_article_permission_panel_data",{article_id:this.props.record.resId});}
getInternalPermissionOptions(){return this.state.internal_permission_options;}
isLoggedUser(member){return member.partner_id===user.partnerId;}
_onInviteMembersClick(){this.env._saveIfDirty();this.actionService.doAction('knowledge.knowledge_invite_action_from_article',{additionalContext:{active_id:this.props.record.resId},onClose:async()=>{await this.loadPanel();this.env.model.root.load();}});}
_onChangeInternalPermission(event){const select=event.target;const index=this.state.members.findIndex(current=>{return current.partner_id===user.partnerId;});const newPermission=select.value;const oldPermission=this.state.internal_permission;const willRestrict=this.state.based_on&&permissionLevel[newPermission]<permissionLevel[oldPermission]&&permissionLevel[newPermission]<permissionLevel[this.state.parent_permission];const willLoseAccess=select.value==='none'&&(index>=0&&this.state.members[index].permission==='none');const confirm=async()=>{const res=await rpc('/knowledge/article/set_internal_permission',{article_id:this.props.record.resId,permission:newPermission,});if(this._onChangedPermission(res,willLoseAccess)){this.loadPanel();}};if(!willLoseAccess&&!willRestrict){confirm();return;}
const discard=()=>{select.value=oldPermission;this.loadPanel();};const loseAccessMessage=_t('Are you sure you want to set the internal permission to "none"? If you do, you will no longer have access to the article.');const confirmLabel=willLoseAccess?_t('Lose Access'):_t('Restrict Access');const confirmTitle=willLoseAccess?false:_t('Restrict Access');this._showConfirmDialog(willLoseAccess?loseAccessMessage:restrictMessage,confirmTitle,{confirmLabel,confirm,cancel:discard});}
async _onChangeMemberPermission(event,member){const index=this.state.members.indexOf(member);if(index<0){return;}
const select=event.target;const newPermission=select.value;const oldPermission=member.permission;const willLoseAccess=this.isLoggedUser(member)&&newPermission==='none';const willRestrict=this.state.based_on&&permissionLevel[newPermission]<permissionLevel[oldPermission];const willLoseWrite=this.isLoggedUser(member)&&newPermission!=='write'&&oldPermission==='write';const willGainWrite=this.isLoggedUser(member)&&newPermission==='write'&&oldPermission!=='write';const confirm=async()=>{const res=await rpc('/knowledge/article/set_member_permission',{article_id:this.props.record.resId,permission:newPermission,member_id:member.based_on?false:member.id,inherited_member_id:member.based_on?member.id:false,});const reloadArticleId=willLoseWrite&&!willLoseAccess?this.props.record.resId:false;if(this._onChangedPermission(res,willLoseAccess||willLoseWrite,reloadArticleId)){this.loadPanel();}};if(!willLoseAccess&&!willRestrict&&!willLoseWrite){await confirm();if(willGainWrite){this.env.model.root.load();}
return;}
const discard=()=>{select.value=this.state.members[index].permission;this.loadPanel();};const loseAccessMessage=_t('Are you sure you want to set your permission to "none"? If you do, you will no longer have access to the article.');const message=willLoseAccess?loseAccessMessage:willLoseWrite?loseWriteMessage:restrictMessage;const title=willLoseAccess?_t('Leave Article'):_t('Change Permission');const confirmLabel=willLoseAccess?_t('Lose Access'):this.isLoggedUser(member)?_t('Restrict own access'):_t('Restrict Access');this._showConfirmDialog(message,title,{confirmLabel,confirm,cancel:discard});}
_onRemoveMember(event,member){if(!this.state.members.includes(member)){return;}
const willRestrict=member.based_on?true:false;const willLoseAccess=this.isLoggedUser(member)&&member.permission!=="none";const confirm=async()=>{const res=await rpc('/knowledge/article/remove_member',{article_id:this.props.record.resId,member_id:member.based_on?false:member.id,inherited_member_id:member.based_on?member.id:false,});if(this._onChangedPermission(res,willLoseAccess)){this.loadPanel();}};if(!willLoseAccess&&!willRestrict){confirm();return;}
const discard=()=>{this.loadPanel();};let message=restrictMessage;let title=_t('Restrict Access');let confirmLabel=title;if(this.isLoggedUser(member)&&this.state.category==='private'){message=_t('Are you sure you want to leave your private Article? As you are its last member, it will be moved to the Trash.');title=_t('Leave Private Article');confirmLabel=_t('Move to Trash');}else if(willLoseAccess){message=_t('Are you sure you want to remove your member? By leaving an article, you may lose access to it.');title=_t('Leave Article');confirmLabel=_t('Leave');}
this._showConfirmDialog(message,title,{confirmLabel,confirm,cancel:discard});}
_onRestore(event){const articleId=this.props.record.resId;const confirm=async()=>{const res=await this.orm.call('knowledge.article','restore_article_access',[[articleId]],);if(res){if(this._onChangedPermission({success:res})){this.loadPanel();}}};const message=_t('Are you sure you want to restore access? This means this article will now inherit any access set on its parent articles.');const title=_t('Restore Access');const confirmLabel=_t('Restore Access');this._showConfirmDialog(message,title,{confirmLabel,confirm});}
async _onMemberAvatarClick(event,member){if(!member.partner_share){const partnerRead=await this.orm.read('res.partner',[member.partner_id],['user_ids'],);const userIds=partnerRead&&partnerRead.length===1?partnerRead[0]['user_ids']:false;const userId=userIds&&userIds.length===1?userIds[0]:false;if(userId){this.mailStore.openChat({userId});}}}
_showConfirmDialog(message,title,options){options=options||{};if(!options.cancel){options.cancel=this.loadPanel.bind(this);}
this.dialog.add(ConfirmationDialog,{title:title||_t("Confirmation"),body:message,...options});}
async _onChangedPermission(result,reloadAll,reloadArticleId){if(result.error){this.dialog.add(AlertDialog,{title:_t("Error"),body:result.error,});}else if(reloadAll&&reloadArticleId){if(await this.props.record.isDirty()){await this.props.record.save({reload:false});}
await this.env.model.root.load();return false;}else if(reloadAll){window.location.replace('/knowledge/home');}else if(result.new_category){if(await this.props.record.isDirty()){await this.props.record.save();}
await this.env.model.root.load();}
return true;}
async _onChangeVisibility(event){const input=event.target;const articleId=this.props.record.resId;await this.orm.call('knowledge.article','set_is_article_visible_by_everyone',[articleId,input.value==='everyone']);if(await this.props.record.isDirty()){await this.props.record.save();}
await this.props.record.load();}}
__exports[Symbol.for("default")]=PermissionPanel;return __exports;});;

/* /knowledge/static/src/components/prompt_embedded_view_name_dialog/prompt_embedded_view_name_dialog.js */
odoo.define('@knowledge/components/prompt_embedded_view_name_dialog/prompt_embedded_view_name_dialog',['@web/core/l10n/translation','@web/core/dialog/dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Dialog}=require("@web/core/dialog/dialog");const{Component,onMounted,useRef}=require("@odoo/owl");const PromptEmbeddedViewNameDialog=__exports.PromptEmbeddedViewNameDialog=class PromptEmbeddedViewNameDialog extends Component{static template="knowledge.PromptEmbeddedViewNameDialog";static components={Dialog};static props={defaultName:{type:String,optional:true},isNew:{type:Boolean,optional:true},viewType:{type:String},save:{type:Function},close:{type:Function,optional:true}};setup(){super.setup();this.input=useRef('input');onMounted(()=>{window.setTimeout(()=>{this.input.el?.focus();},0);});}
async save(){await this.props.save(this.input.el.value);this.props.close();}
get placeholder(){if(this.props.viewType==='kanban'){return _t('e.g. Buildings');}
if(this.props.viewType==='list'){return _t('e.g. Todos');}}
get title(){if(this.props.viewType==='list'){return _t('Insert a List View');}
if(this.props.viewType==='kanban'){return _t('Insert a Kanban View');}
return _t('Embed a View');}
onInputKeydown(event){if(event.key==='Enter'){this.save();}}}
return __exports;});;

/* /knowledge/static/src/components/properties_panel/properties_panel.js */
odoo.define('@knowledge/components/properties_panel/properties_panel',['@web/core/registry','@web/views/widgets/standard_widget_props','@web/views/fields/properties/properties_field','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require('@web/core/registry');const{standardWidgetProps}=require('@web/views/widgets/standard_widget_props');const{PropertiesField}=require('@web/views/fields/properties/properties_field');const{Component,useRef,useState}=require('@odoo/owl');const KnowledgeArticleProperties=__exports.KnowledgeArticleProperties=class KnowledgeArticleProperties extends Component{static template='knowledge.KnowledgeArticleProperties';static props={...standardWidgetProps};static components={PropertiesField};setup(){this.state=useState({displayPropertyPanel:false,});this.root=useRef('root');this.env.bus.addEventListener('KNOWLEDGE:TOGGLE_PROPERTIES',this.toggleProperties.bind(this));}
get showNoContentHelper(){return this.props.record.data.article_properties.every((prop)=>prop.definition_deleted);}
toggleProperties(event){this.state.displayPropertyPanel=event.detail.displayPropertyPanel;if(this.state.displayPropertyPanel){this.root.el?.parentElement?.classList.remove('d-none');}else{this.root.el?.parentElement?.classList.add('d-none');}}}
const knowledgePropertiesPanel=__exports.knowledgePropertiesPanel={component:KnowledgeArticleProperties,additionalClasses:['o_knowledge_properties','o_field_highlight','col-12','col-lg-2','position-relative','d-none','p-0','border-start']};registry.category('view_widgets').add('knowledge_properties_panel',knowledgePropertiesPanel);return __exports;});;

/* /knowledge/static/src/components/sidebar/sidebar.js */
odoo.define('@knowledge/components/sidebar/sidebar',['@web/core/l10n/translation','@knowledge/components/article_selection_dialog/article_selection_dialog','@knowledge/components/article_template_picker_dialog/article_template_picker_dialog','@web/core/browser/browser','@web/core/confirmation_dialog/confirmation_dialog','@knowledge/components/sidebar/sidebar_section','@web/core/l10n/localization','@web/core/user','@web/core/utils/timing','@web/core/utils/nested_sortable','@web/core/utils/hooks','@web/model/relational_model/utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ArticleSelectionDialog}=require("@knowledge/components/article_selection_dialog/article_selection_dialog");const{ArticleTemplatePickerDialog}=require("@knowledge/components/article_template_picker_dialog/article_template_picker_dialog");const{browser}=require('@web/core/browser/browser')
const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{KnowledgeSidebarFavoriteSection,KnowledgeSidebarPrivateSection,KnowledgeSidebarSharedSection,KnowledgeSidebarWorkspaceSection}=require("@knowledge/components/sidebar/sidebar_section");const{localization}=require("@web/core/l10n/localization");const{user}=require("@web/core/user");const{throttleForAnimation}=require("@web/core/utils/timing");const{useNestedSortable}=require("@web/core/utils/nested_sortable");const{useService}=require("@web/core/utils/hooks");const{useRecordObserver}=require("@web/model/relational_model/utils");const{Component,onWillStart,reactive,useRef,useState,useChildSubEnv}=require("@odoo/owl");const SORTABLE_TOLERANCE=__exports.SORTABLE_TOLERANCE=10;const KnowledgeSidebar=__exports.KnowledgeSidebar=class KnowledgeSidebar extends Component{static props={record:Object,};static template="knowledge.Sidebar";static components={KnowledgeSidebarFavoriteSection,KnowledgeSidebarPrivateSection,KnowledgeSidebarSharedSection,KnowledgeSidebarWorkspaceSection,};setup(){super.setup();this.actionService=useService("action");this.dialog=useService("dialog");this.orm=useService("orm");this.favoriteTree=useRef("favoriteTree");this.mainTree=useRef("mainTree");this.currentData={};this.storageKeys={size:"knowledge.sidebarSize",unfoldedArticles:"knowledge.unfolded.ids",unfoldedFavorites:"knowledge.unfolded.favorite.ids",};this.unfoldedArticlesIds=reactive(new Set(localStorage.getItem(this.storageKeys.unfoldedArticles)?.split(";").map(Number)),()=>localStorage.setItem(this.storageKeys.unfoldedArticles,Array.from(this.unfoldedArticlesIds).join(";")));this.unfoldedFavoritesIds=reactive(new Set(localStorage.getItem(this.storageKeys.unfoldedFavorites)?.split(";").map(Number)),()=>localStorage.setItem(this.storageKeys.unfoldedFavorites,Array.from(this.unfoldedFavoritesIds).join(";")));useChildSubEnv({fold:this.fold.bind(this),getArticle:this.getArticle.bind(this),model:this.props.record.model,unfold:this.unfold.bind(this),});this.state=useState({dragging:false,sidebarSize:localStorage.getItem(this.storageKeys.size)||300,});this.loadArticles();useNestedSortable({ref:this.favoriteTree,edgeScrolling:{speed:10,threshold:15,},preventDrag:(el)=>{return(!el.parentElement.classList.contains("o_tree")&&el.classList.contains("readonly"));},tolerance:SORTABLE_TOLERANCE,onDrop:({element,next,parent})=>{if(!parent){const articleId=parseInt(element.dataset.articleId);const beforeId=next?parseInt(next.dataset.articleId):false;this.resequenceFavorites(articleId,beforeId);}else{const article=this.getArticle(parseInt(element.dataset.articleId));const parentId=parseInt(parent.dataset.articleId);const currentPosition={category:article.category,parentId:article.parent_id,beforeArticleId:parseInt(element.nextElementSibling?.dataset.articleId)||false,};const newPosition={category:article.category,parentId:parentId,beforeArticleId:parseInt(next?.dataset.articleId)||false,};this.moveArticle(article,currentPosition,newPosition);}},});useNestedSortable({ref:this.mainTree,groups:()=>this.isInternalUser?".o_section":".o_section[data-section='private']",connectGroups:()=>this.isInternalUser,nest:true,preventDrag:(el)=>el.classList.contains("readonly"),tolerance:SORTABLE_TOLERANCE,onDragStart:()=>this.state.dragging=true,onDragEnd:()=>this.state.dragging=false,onDrop:async({element,next,group,newGroup,parent,placeholder})=>{const article=this.getArticle(parseInt(element.dataset.articleId));if(newGroup.classList.contains("o_knowledge_sidebar_trash")){this.moveToTrash(article);return;}
const parentId=parent?parseInt(parent.dataset.articleId):false;if(placeholder.classList.contains('bg-danger')){this.rejectDrop(article,parentId);return;}
const currentPosition={category:article.category,parentId:article.parent_id,beforeArticleId:parseInt(element.nextElementSibling?.dataset.articleId)||false,};const newPosition={category:newGroup.dataset.section,parentId:parentId,beforeArticleId:parseInt(next?.dataset.articleId)||false,};this.moveArticle(article,currentPosition,newPosition);},onMove:({element,parent,group,newGroup,prevPos,placeholder})=>{if(prevPos.parent){const prevParent=this.getArticle(parseInt(prevPos.parent.dataset.articleId));if(!prevParent.has_article_children||prevParent.child_ids.length===1&&prevParent.child_ids[0]===parseInt(element.dataset.articleId)){prevPos.parent.classList.remove('o_article_has_children');}}
if(parent){const currentParentId=element.parentElement.parentElement.dataset.articleId;const targetParentId=parent.dataset.articleId;if(currentParentId!==targetParentId&&parent.classList.contains('readonly')){placeholder.classList.add('bg-danger');return;}
parent.classList.add('o_article_has_children');}else if(newGroup.dataset.section==="shared"){const article=this.getArticle(parseInt(element.dataset.articleId));if(article.category==="private"){placeholder.classList.add('bg-danger');return;}}
placeholder.classList.remove('bg-danger');},});onWillStart(async()=>{this.isInternalUser=await user.hasGroup('base.group_user');});useRecordObserver(async(record)=>{const nextDataParentId=record.data.parent_id?record.data.parent_id[0]:false;const article=this.getArticle(record.resId)||{id:record.resId,name:record.data.name,icon:record.data.icon,category:record.data.category,parent_id:nextDataParentId,is_locked:record.data.is_locked,user_can_write:record.data.user_can_write,is_article_item:record.data.is_article_item,is_user_favorite:record.data.is_user_favorite,child_ids:[],};if(this.state.articles[record.resId]){if(record.data.is_article_item!==article.is_article_item){if(record.data.is_article_item){this.removeArticle(article);}else{this.insertArticle(article,{parentId:article.parent_id});this.showArticle(article);}}
if(record.data.is_user_favorite!==article.is_user_favorite){if(record.data.is_user_favorite){this.state.favoriteIds.push(article.id);}else{this.state.favoriteIds.splice(this.state.favoriteIds.indexOf(article.id),1);}}
if((nextDataParentId!==article.parent_id||record.data.category!==article.category)&&(record.data.parent_id!==this.currentData.parent_id||record.data.category!==this.currentData.category)){if(!this.getArticle(nextDataParentId)){await this.loadArticles();this.showArticle(this.getArticle(record.resId));}else{this.repositionArticle(article,{parentId:nextDataParentId,category:record.data.category,});}}
Object.assign(article,{name:record.data.name,icon:record.data.icon,is_locked:record.data.is_locked,user_can_write:record.data.user_can_write,is_article_item:record.data.is_article_item,is_user_favorite:record.data.is_user_favorite,});}else if(!this.state.loading){if(record.data.is_user_favorite){this.state.favoriteIds.push(record.resId);}
this.state.articles[article.id]=article;if(!record.data.is_article_item){await this.insertArticle(article,{category:article.category,parentId:article.parent_id,});this.showArticle(article);if(nextDataParentId&&this.getArticle(nextDataParentId)?.is_user_favorite){this.unfold(nextDataParentId,true);}}}
this.currentData={parent_id:record.data.parent_id,category:record.data.category,};});this.env.bus.addEventListener("knowledge.sidebar.insertNewArticle",async({detail})=>{if(this.getArticle(detail.articleId)){return;}
const parent=detail.parentId?this.getArticle(detail.parentId):false;const newArticle={id:detail.articleId,name:detail.name,icon:detail.icon,parent_id:parent?parent.id:false,category:parent?parent.category:false,is_locked:false,user_can_write:true,is_article_item:false,is_user_favorite:false,child_ids:[],};this.state.articles[newArticle.id]=newArticle;await this.insertArticle(newArticle,{parentId:newArticle.parent_id,category:parent?parent.category:false});});}
browseTemplates(){this.dialog.add(ArticleTemplatePickerDialog,{onLoadTemplate:async articleTemplateId=>{await this.actionService.doAction("knowledge.ir_actions_server_knowledge_home_page",{stackPosition:"replaceCurrentAction",additionalContext:{res_id:await this.orm.call("knowledge.article","create_article_from_template",[articleTemplateId])}});}});}
async changeCategory(article,category){article.category=category;if(article.id===this.props.record.id){if(await this.props.record.isDirty()){await this.props.record.save();}else{await this.props.record.model.load();}}
for(const childId of article.child_ids){this.changeCategory(this.getArticle(childId),category);}}
createArticle(category,targetParentId){try{this.env.createArticle(category,targetParentId);}catch{this.loadArticles();}}
fold(articleId,isFavorite){if(isFavorite){this.unfoldedFavoritesIds.delete(articleId);}else{this.unfoldedArticlesIds.delete(articleId);}}
getArticle(articleId){return this.state.articles[articleId];}
getCategoryIds(category){return this.state[`${category}Ids`];}
async insertArticle(article,position){if(position.parentId){const parent=this.getArticle(position.parentId);if(parent){if(!this.unfoldedArticlesIds.has(parent.id)){await this.unfold(parent.id,false);if(parent.child_ids.includes(article.id)){return;}}
if(position.beforeArticleId){parent.child_ids.splice(parent.child_ids.indexOf(position.beforeArticleId),0,article.id);}else{parent.child_ids.push(article.id);}
parent.has_article_children=true;}}else{const categoryIds=this.getCategoryIds(position.category);if(categoryIds){if(position.beforeArticleId){categoryIds.splice(categoryIds.indexOf(position.beforeArticleId),0,article.id);}else{categoryIds.push(article.id);}}}}
isAncestor(articleId){let article=this.getArticle(this.props.record.resId);while(article){if(article.id===articleId){return true;}
article=this.getArticle(article.parent_id);}
return false;}
async loadArticles(){this.state.loading=true;Object.assign(this.state,{articles:{},favoriteIds:[],workspaceIds:[],sharedIds:[],privateIds:[],});const res=await this.orm.call(this.props.record.resModel,"get_sidebar_articles",[this.props.record.resId],{unfolded_ids:[...this.unfoldedArticlesIds,...this.unfoldedFavoritesIds]});const children={};for(const article of res.articles){this.state.articles[article.id]={...article,child_ids:children[article.id]?children[article.id]:[],};if(!article.is_article_item){if(article.parent_id){const parent=this.getArticle(article.parent_id);if(parent){parent.child_ids.push(article.id);}else{if(children[article.parent_id]){children[article.parent_id].push(article.id);}else{children[article.parent_id]=[article.id];}}}else{this.getCategoryIds(article.category).push(article.id);}}}
const ancestorRootArticleId=res.active_article_accessible_root_id;if(ancestorRootArticleId){this.getCategoryIds(this.getArticle(ancestorRootArticleId).category).push(ancestorRootArticleId);}
this.state.favoriteIds=res.favorite_ids;this.showArticle(this.getArticle(this.props.record.resId));this.state.loading=false;this.resetUnfoldedArticles();}
async loadChildren(article){const children=await this.orm.searchRead(this.props.record.resModel,[['parent_id','=',article.id],['is_article_item','=',false]],['name','icon','is_locked','user_can_write','has_article_children'],{'load':'None','order':'sequence, id',});for(const child of children){article.child_ids.push(child.id);if(this.getArticle(child.id)){continue;}
this.state.articles[child.id]={...child,parent_id:article.id,child_ids:[],category:article.category,is_article_item:false,is_user_favorite:false,};}}
async moveArticle(article,currentPosition,newPosition){const confirmMove=async(article,position)=>{if(this.props.record.resId===article.id&&await this.props.record.isDirty()){await this.props.record.save();}
try{await this.orm.call(this.props.record.resModel,'move_to',[article.id],{category:position.category,parent_id:position.parentId,before_article_id:position.beforeArticleId,});}catch(error){this.loadArticles();throw error;}
await this.props.record.model.load();};this.repositionArticle(article,newPosition);if(currentPosition.category===newPosition.category){confirmMove(article,newPosition);}else{const emoji=article.icon||'';const name=article.name;let message;let confirmLabel;if(newPosition.category==='workspace'){message=_t('Are you sure you want to move "%(icon)s%(title)s" to the Workspace? It will be shared with all internal users.',{icon:emoji,title:name||_t("Untitled")});confirmLabel=_t("Move to Workspace");}else if(newPosition.category==='private'){message=_t('Are you sure you want to move "%(icon)s%(title)s" to private? Only you will be able to access it.',{icon:emoji,title:name||_t("Untitled")});confirmLabel=_t("Move to Private");}else if(newPosition.category==='shared'){if(newPosition.parentId){const parent=this.getArticle(newPosition.parentId);message=_t('Are you sure you want to move "%(icon)s%(title)s" under "%(parentIcon)s%(parentTitle)s"? It will be shared with the same persons.',{icon:emoji,title:name||_t("Untitled"),parentIcon:parent.icon||"",parentTitle:parent.name||_t("Untitled"),});}else{message=_t('Are you sure you want to move "%(icon)s%(title)s" to the Shared section? It will be shared with all listed members.',{icon:emoji,title:name||_t("Untitled")});}
confirmLabel=_t('Move to Shared')}
this.dialog.add(ConfirmationDialog,{body:message,confirmLabel:confirmLabel,confirm:()=>confirmMove(article,newPosition),cancel:()=>{this.repositionArticle(article,currentPosition);},});}}
async moveToTrash(article){try{await this.orm.call("knowledge.article","action_send_to_trash",[article.id],);}catch{await this.loadArticles();return;}
if(this.isAncestor(article.id)){this.actionService.doAction(await this.orm.call('knowledge.article','action_home_page',[false]),{stackPosition:'replaceCurrentAction'});}else{this.removeArticle(article);this.removeFavorite(article);}}
onSearchBarClick(){if(this.isInternalUser){this.env.services.command.openMainPalette({searchValue:'?'});}else{this.dialog.add(ArticleSelectionDialog,{title:_t('Search an Article...'),confirmLabel:_t('Open'),articleSelected:(article)=>this.env.openArticle(article.articleId),});}}
rejectDrop(article,parentId){let message;if(parentId){const parent=this.getArticle(parentId);message=_t('Could not move "%(icon)s%(title)s" under "%(parentIcon)s%(parentTitle)s", because you do not have write permission on the latter.',{icon:article.icon||"",title:article.name,parentIcon:parent.icon||"",parentTitle:parent.name,});}else{message=_t('You need at least 2 members for the Article to be shared.');}
this.dialog.add(ConfirmationDialog,{confirmLabel:_t("Close"),title:_t("Move cancelled"),body:message,});}
removeArticle(article){if(article.parent_id){const parent=this.getArticle(article.parent_id);if(parent){const articleIdx=parent.child_ids.indexOf(article.id);if(articleIdx!==-1){parent.child_ids.splice(parent.child_ids.indexOf(article.id),1);if(!parent.child_ids.length){this.fold(parent.id);this.fold(parent.id,true);parent.has_article_children=false;}}}}else{const categoryIds=this.getCategoryIds(article.category);const articleIdx=categoryIds.indexOf(article.id);if(articleIdx!==-1){categoryIds.splice(articleIdx,1);}}}
removeFavorite(article){const favoriteIdx=this.state.favoriteIds.indexOf(article.id);if(favoriteIdx!==-1){this.state.favoriteIds.splice(favoriteIdx,1);}}
async repositionArticle(article,position){this.removeArticle(article);await this.insertArticle(article,position);if(article.parent_id!==position.parentId){article.parent_id=position.parentId;}
if(article.category!==position.category){this.changeCategory(article,position.category);}
this.showArticle(article);}
resequenceFavorites(articleId,beforeId){this.state.favoriteIds.splice(this.state.favoriteIds.indexOf(articleId),1);if(beforeId){this.state.favoriteIds.splice(this.state.favoriteIds.indexOf(beforeId),0,articleId);}else{this.state.favoriteIds.push(articleId);}
this.orm.call("knowledge.article.favorite","resequence_favorites",[false],{article_ids:this.state.favoriteIds,});}
resetUnfoldedArticles(){this.unfoldedArticlesIds.forEach(id=>{if(!this.getArticle(id)){this.unfoldedArticlesIds.delete(id);}});this.unfoldedFavoritesIds.forEach(id=>{if(!this.getArticle(id)){this.unfoldedFavoritesIds.delete(id);}});}
resize(){const isRtl=localization.direction==="rtl";const onPointerMove=throttleForAnimation(event=>{event.preventDefault();this.state.sidebarSize=isRtl?document.documentElement.clientWidth-event.pageX:event.pageX;browser.dispatchEvent(new Event("resize"));});const onPointerUp=()=>{document.removeEventListener('pointermove',onPointerMove);document.body.style.cursor="auto";document.body.style.userSelect="auto";localStorage.setItem(this.storageKeys.size,this.state.sidebarSize);browser.dispatchEvent(new Event("resize"));};document.body.style.cursor="col-resize";document.body.style.userSelect="none";document.addEventListener('pointermove',onPointerMove);document.addEventListener('pointerup',onPointerUp,{once:true});}
showArticle(article){while(article&&article.parent_id&&article.parent_id in this.state.articles){this.unfold(article.parent_id,false);article=this.getArticle(article.parent_id);}}
async unfold(articleId,isFavorite){const article=this.getArticle(articleId);if(article.has_article_children&&!article.child_ids.length){await this.loadChildren(article);}
if(isFavorite){this.unfoldedFavoritesIds.add(articleId);}else{this.unfoldedArticlesIds.add(articleId);}}}
return __exports;});;

/* /knowledge/static/src/components/sidebar/sidebar_row.js */
odoo.define('@knowledge/components/sidebar/sidebar_row',['@knowledge/components/knowledge_icon/knowledge_icon','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const KnowledgeIcon=require("@knowledge/components/knowledge_icon/knowledge_icon")[Symbol.for("default")];const{useService}=require("@web/core/utils/hooks");const{Component,onWillUpdateProps,useState}=require("@odoo/owl");class KnowledgeSidebarIcon extends KnowledgeIcon{static props={article:Object,readonly:Boolean,record:Object,iconClasses:{type:String,optional:true},};setup(){super.setup();this.orm=useService("orm");}
get icon(){return this.props.article.icon||'📄';}
async updateIcon(icon){if(this.props.record.resId===this.props.article.id){this.props.record.update({icon});}else{await this.orm.write("knowledge.article",[this.props.article.id],{icon});this.props.article.icon=icon;}}}
const KnowledgeSidebarRow=__exports.KnowledgeSidebarRow=class KnowledgeSidebarRow extends Component{static props={article:Object,unfolded:Boolean,unfoldedIds:Set,record:Object,};static template="knowledge.SidebarRow";static components={KnowledgeSidebarIcon,KnowledgeSidebarRow};setup(){super.setup();this.orm=useService("orm");this.state=useState({unfolded:false,});onWillUpdateProps(nextProps=>{if(this.state.loading&&nextProps.unfolded===true){this.state.loading=false;}});}
get hasChildren(){return this.props.article.has_article_children;}
get isActive(){return this.props.record.resId===this.props.article.id;}
get isLocked(){return this.props.article.is_locked;}
get isReadonly(){return!this.props.article.user_can_write;}
createChild(){this.env.createArticle(this.props.article.category,this.props.article.id);}
onCaretClick(){if(!this.props.article.has_article_children){return;}
if(this.props.unfolded){this.env.fold(this.props.article.id);}else if(!this.state.loading){this.state.loading=true;if(this.props.article.child_ids.length>500){setTimeout(()=>this.env.unfold(this.props.article.id),0);}else{this.env.unfold(this.props.article.id);}}}
onNameClick(){this.env.openArticle(this.props.article.id);}}
return __exports;});;

/* /knowledge/static/src/components/sidebar/sidebar_section.js */
odoo.define('@knowledge/components/sidebar/sidebar_section',['@knowledge/components/sidebar/sidebar_row','@web/core/user','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{KnowledgeSidebarRow}=require("@knowledge/components/sidebar/sidebar_row");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{Component,onWillStart,useChildSubEnv}=require("@odoo/owl");const KnowledgeSidebarSection=__exports.KnowledgeSidebarSection=class KnowledgeSidebarSection extends Component{static template="";static props={rootIds:Array,unfoldedIds:Set,record:Object,};static components={KnowledgeSidebarRow,};setup(){super.setup();onWillStart(async()=>{this.isInternalUser=await user.hasGroup('base.group_user');});}}
const KnowledgeSidebarFavoriteSection=__exports.KnowledgeSidebarFavoriteSection=class KnowledgeSidebarFavoriteSection extends KnowledgeSidebarSection{static template="knowledge.SidebarFavoriteSection";setup(){super.setup();useChildSubEnv({fold:id=>this.env.fold(id,true),unfold:id=>this.env.unfold(id,true),});}}
const KnowledgeSidebarWorkspaceSection=__exports.KnowledgeSidebarWorkspaceSection=class KnowledgeSidebarWorkspaceSection extends KnowledgeSidebarSection{static template="knowledge.SidebarWorkspaceSection";setup(){super.setup();this.command=useService("command");}
createRoot(){this.env.createArticle("workspace");}
searchHiddenArticle(){this.command.openMainPalette({searchValue:"$"});}}
const KnowledgeSidebarSharedSection=__exports.KnowledgeSidebarSharedSection=class KnowledgeSidebarSharedSection extends KnowledgeSidebarSection{static template="knowledge.SidebarSharedSection";}
const KnowledgeSidebarPrivateSection=__exports.KnowledgeSidebarPrivateSection=class KnowledgeSidebarPrivateSection extends KnowledgeSidebarSection{static template="knowledge.SidebarPrivateSection";createRoot(){this.env.createArticle("private");}}
return __exports;});;

/* /knowledge/static/src/components/topbar/topbar.js */
odoo.define('@knowledge/components/topbar/topbar',['@web/core/browser/browser','@web/core/l10n/dates','@web/core/network/rpc','@web/core/registry','@web/views/widgets/standard_widget_props','@web/core/user','@web/core/utils/hooks','@mail/core/web/open_chat_hook','@web/core/ui/ui_service','@web/core/l10n/translation','@odoo/owl','@knowledge/js/knowledge_utils','@knowledge/components/hierarchy/hierarchy','@knowledge/components/move_article_dialog/move_article_dialog','@knowledge/components/permission_panel/permission_panel','@knowledge/components/form_status_indicator/form_status_indicator','@knowledge/editor/embedded_components/embedding_sets','@html_editor/others/embedded_components/embedding_sets','@html_editor/components/history_dialog/history_dialog'],function(require){'use strict';let __exports={};const{browser}=require('@web/core/browser/browser')
const{formatDateTime}=require('@web/core/l10n/dates');const{rpc}=require("@web/core/network/rpc");const{registry}=require('@web/core/registry');const{standardWidgetProps}=require('@web/views/widgets/standard_widget_props');const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{useOpenChat}=require("@mail/core/web/open_chat_hook");const{utils:uiUtils}=require("@web/core/ui/ui_service");const{_t}=require("@web/core/l10n/translation");const{Component,onWillStart,useEffect,useRef,useState}=require('@odoo/owl');const{getRandomIcon}=require('@knowledge/js/knowledge_utils');const KnowledgeHierarchy=require('@knowledge/components/hierarchy/hierarchy')[Symbol.for("default")];const MoveArticleDialog=require('@knowledge/components/move_article_dialog/move_article_dialog')[Symbol.for("default")];const PermissionPanel=require('@knowledge/components/permission_panel/permission_panel')[Symbol.for("default")];const{KnowledgeFormStatusIndicator}=require("@knowledge/components/form_status_indicator/form_status_indicator");const{KNOWLEDGE_READONLY_EMBEDDINGS}=require("@knowledge/editor/embedded_components/embedding_sets");const{READONLY_MAIN_EMBEDDINGS}=require("@html_editor/others/embedded_components/embedding_sets");const{HistoryDialog}=require("@html_editor/components/history_dialog/history_dialog");class KnowledgeTopbar extends Component{static template="knowledge.KnowledgeTopbar";static props={...standardWidgetProps,};static components={KnowledgeHierarchy,KnowledgeFormStatusIndicator,PermissionPanel,};setup(){super.setup();this.actionService=useService('action');this.dialog=useService('dialog');this.orm=useService('orm');this.uiService=useService('ui');this.buttonSharePanel=useRef('sharePanel_button');this.optionsBtn=useRef('optionsBtn');this.formatDateTime=formatDateTime;this.state=useState({displayChatter:false,displayHistory:false,displayPropertyPanel:!this.articlePropertiesIsEmpty,addingProperty:false,displaySharePanel:false,});this.commentsService=useService("knowledge.comments");this.commentsState=useState(this.commentsService.getCommentsState());this.openChat=useOpenChat('res.users');onWillStart(async()=>{this.isInternalUser=await user.hasGroup('base.group_user');});useEffect((optionsBtn)=>{if(optionsBtn){optionsBtn.addEventListener('shown.bs.dropdown',()=>this._setDates());}},()=>[this.optionsBtn.el]);useEffect(()=>{if(!uiUtils.isSmall()&&!this.articlePropertiesIsEmpty){this.addProperties();}else if(this.articlePropertiesIsEmpty&&this.state.displayPropertyPanel){this.toggleProperties();}
this.state.addingProperty=false;},()=>[this.props.record.resId,this.articlePropertiesIsEmpty]);useEffect((shareBtn)=>{if(shareBtn){shareBtn.addEventListener('hide.bs.dropdown',(ev)=>{if(this.uiService.activeElement!==document){ev.preventDefault();}});shareBtn.addEventListener('shown.bs.dropdown',()=>this.state.displaySharePanel=true);shareBtn.addEventListener('hidden.bs.dropdown',()=>this.state.displaySharePanel=false);}},()=>[this.buttonSharePanel.el]);}
get addFavoriteLabel(){return _t("Add to favorites");}
get removeFavoriteLabel(){return _t("Remove from favorites");}
get displayCommentsPanelButton(){return(this.commentsState.displayMode==="panel"||Object.keys(this.commentsState.threadRecords).length);}
async addCover(event){event.target.classList.add('disabled');this.env.ensureArticleName();let res={};try{res=await rpc(`/knowledge/article/${this.props.record.resId}/add_random_cover`,{query:this.props.record.data.name,orientation:'landscape',});}catch(e){console.error(e);}
if(res.cover_id){await this.props.record.update({cover_image_id:[res.cover_id]});}else{this.env.openCoverSelector();}
event.target.classList.remove('disabled');}
async addIcon(event){this.props.record.update({icon:await getRandomIcon()});}
_setDates(){if(this.props.record.data.create_date&&this.props.record.data.last_edition_date){this.state.createDate=this.props.record.data.create_date.toRelative();this.state.editionDate=this.props.record.data.last_edition_date.toRelative();}}
get articlePropertiesIsEmpty(){return this.props.record.data.article_properties.filter((prop)=>!prop.definition_deleted).length===0;}
toggleProperties(){this.state.displayPropertyPanel=!this.state.displayPropertyPanel;this.env.bus.trigger('KNOWLEDGE:TOGGLE_PROPERTIES',{displayPropertyPanel:this.state.displayPropertyPanel});if(this.state.addingProperty){this.state.addingProperty=false;}}
addProperties(){this.state.displayPropertyPanel=true;this.state.addingProperty=true;this.env.bus.trigger('KNOWLEDGE:TOGGLE_PROPERTIES',{displayPropertyPanel:true});}
toggleComments(){if(this.commentsState.displayMode==="handler"){this.commentsState.displayMode="panel";}else{this.commentsState.displayMode="handler";}}
toggleFullWidth(){this.props.record.update({full_width:!this.props.record.data.full_width});browser.dispatchEvent(new Event("resize"));}
async cloneArticle(){await this.env._saveIfDirty();const articleId=await this.orm.call('knowledge.article','action_clone',[this.props.record.resId]);this.env.openArticle(articleId,true);}
async exportToPdf(){window.print();}
async setLockStatus(newLockStatus){await this.props.record.model.root.isDirty();await this.env._saveIfDirty();await this.orm.call('knowledge.article',`action_set_${newLockStatus ? 'lock' : 'unlock'}`,[this.props.record.resId],);await this.props.record.load();}
async onMoveArticleClick(){await this.env._saveIfDirty();this.dialog.add(MoveArticleDialog,{knowledgeArticleRecord:this.props.record});}
toggleChatter(){if(this.props.record.resId){this.state.displayChatter=!this.state.displayChatter;this.env.bus.trigger('KNOWLEDGE:TOGGLE_CHATTER',{displayChatter:this.state.displayChatter});}}
async openHistory(){if(this.props.record.resId){this.state.displayHistory=true;await this.env.model.root.save();const versionedFieldName='body';const historyMetadata=this.props.record.data["html_field_history_metadata"]?.[versionedFieldName];if(historyMetadata){this.dialog.add(HistoryDialog,{recordId:this.props.record.resId,recordModel:this.props.record.resModel,versionedFieldName:versionedFieldName,historyMetadata:historyMetadata,restoreRequested:(html,close)=>{const restoredData={};restoredData[versionedFieldName]=html;this.props.record.update(restoredData);close();},embeddedComponents:[...READONLY_MAIN_EMBEDDINGS,...KNOWLEDGE_READONLY_EMBEDDINGS,],},{onClose:()=>this.state.displayHistory=false});}}}
async unarchiveArticle(){await this.orm.call('knowledge.article','action_unarchive',[this.props.record.resId]);await this.props.record.load();}
async setIsArticleItem(newArticleItemStatus){await this.props.record.update({is_article_item:newArticleItemStatus});}
async sendToTrash(){await this.orm.call('knowledge.article','action_send_to_trash',[this.props.record.resId]);await this.actionService.doAction(await this.orm.call('knowledge.article','action_redirect_to_parent',[this.props.record.resId]),{stackPosition:'replaceCurrentAction'});}
async _onMemberAvatarClick(event,userId){event.preventDefault();event.stopPropagation();if(userId){await this.openChat(userId);}}}
const knowledgeTopbar=__exports.knowledgeTopbar={component:KnowledgeTopbar,fieldDependencies:[{name:"create_uid",type:"many2one",relation:"res.users"},{name:"html_field_history_metadata",type:"jsonb"},{name:"last_edition_uid",type:"many2one",relation:"res.users"},{name:"parent_path",type:"char"},{name:"root_article_id",type:"many2one",relation:"knowledge.article"},],};registry.category('view_widgets').add('knowledge_topbar',knowledgeTopbar);return __exports;});;

/* /knowledge/static/src/components/with_lazy_loading/with_lazy_loading.js */
odoo.define('@knowledge/components/with_lazy_loading/with_lazy_loading',['@odoo/owl','@knowledge/js/knowledge_utils'],function(require){'use strict';let __exports={};const{Component,onMounted,onWillUnmount,useRef,useState}=require("@odoo/owl");const{setIntersectionObserver}=require("@knowledge/js/knowledge_utils");const WithLazyLoading=__exports.WithLazyLoading=class WithLazyLoading extends Component{static template="knowledge.WithLazyLoading";static props={slots:{type:Object},};setup(){this.loader=useRef("loader");this.state=useState({isLoaded:false});onMounted(()=>{const{el}=this.loader;this.observer=setIntersectionObserver(el,()=>{this.state.isLoaded=true;});});onWillUnmount(()=>{this.observer.disconnect();});}}
return __exports;});;

/* /knowledge/static/src/components/with_sub_env/with_sub_env.js */
odoo.define('@knowledge/components/with_sub_env/with_sub_env',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,useSubEnv,xml}=require("@odoo/owl");const WithSubEnv=__exports.WithSubEnv=class WithSubEnv extends Component{static template=xml`<t t-slot="default"/>`;static props=["*"];setup(){useSubEnv(this.props);}}
return __exports;});;

/* /knowledge/static/src/components/wysiwyg_article_helper/wysiwyg_article_helper.js */
odoo.define('@knowledge/components/wysiwyg_article_helper/wysiwyg_article_helper',['@odoo/owl','@html_editor/main/chatgpt/chatgpt_prompt_dialog','@html_editor/utils/html','@knowledge/components/article_template_picker_dialog/article_template_picker_dialog','@knowledge/components/item_calendar_props_dialog/item_calendar_props_dialog','@knowledge/components/prompt_embedded_view_name_dialog/prompt_embedded_view_name_dialog','@web/core/l10n/translation','@web/core/user','@web/core/utils/render','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,onWillStart}=require("@odoo/owl");const{ChatGPTPromptDialog}=require("@html_editor/main/chatgpt/chatgpt_prompt_dialog");const{parseHTML}=require("@html_editor/utils/html");const{ArticleTemplatePickerDialog}=require("@knowledge/components/article_template_picker_dialog/article_template_picker_dialog");const{ItemCalendarPropsDialog}=require("@knowledge/components/item_calendar_props_dialog/item_calendar_props_dialog");const{PromptEmbeddedViewNameDialog}=require("@knowledge/components/prompt_embedded_view_name_dialog/prompt_embedded_view_name_dialog");const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{renderToFragment}=require("@web/core/utils/render");const{useService}=require("@web/core/utils/hooks");const WysiwygArticleHelper=__exports.WysiwygArticleHelper=class WysiwygArticleHelper extends Component{static template="knowledge.WysiwygArticleHelper";static props={editor:{type:Object},isVisible:{type:Boolean},record:{type:Object},};setup(){this.actionService=useService("action");this.dialogService=useService("dialog");this.orm=useService("orm");onWillStart(async()=>{this.isPortalUser=await user.hasGroup("base.group_portal");});}
onLoadTemplateBtnClick(){this.dialogService.add(ArticleTemplatePickerDialog,{onLoadTemplate:async(articleTemplateId)=>{const body=await this.orm.call("knowledge.article","apply_template",[this.props.record.resId],{template_id:articleTemplateId,skip_body_update:true,});this.props.editor.editable.replaceChildren(parseHTML(this.props.editor.document,body));this.props.editor.shared.selection.setCursorEnd(this.props.editor.editable);this.props.editor.shared.history.addStep();await this.actionService.doAction("knowledge.ir_actions_server_knowledge_home_page",{stackPosition:"replaceCurrentAction",additionalContext:{res_id:this.props.record.resId,},});},});}
onBuildItemCalendarBtnClick(){this.dialogService.add(ItemCalendarPropsDialog,{isNew:true,knowledgeArticleId:this.props.record.resId,saveItemCalendarProps:async(name,itemCalendarProps)=>{const title=name||_t("Article Items");const displayName=name?_t("Calendar of %s",name):_t("Calendar of Article Items");const embeddedProps={viewProps:{additionalViewProps:{itemCalendarProps},actionXmlId:"knowledge.knowledge_article_action_item_calendar",displayName:displayName,viewType:"calendar",context:{active_id:this.props.record.resId,default_parent_id:this.props.record.resId,default_is_article_item:true,},},};const fragment=renderToFragment("knowledge.ArticleItemTemplate",{embeddedProps:JSON.stringify(embeddedProps),title,});this.props.editor.editable.replaceChildren(...fragment.children);this.props.editor.shared.selection.setCursorEnd(this.props.editor.editable);this.props.editor.shared.history.addStep();this.props.record.update({name:title});},});}
onBuildItemKanbanBtnClick(){this.dialogService.add(PromptEmbeddedViewNameDialog,{isNew:true,viewType:"kanban",save:async(name)=>{const embeddedProps={viewProps:{actionXmlId:"knowledge.knowledge_article_item_action_stages",displayName:name?_t("Kanban of %s",name):_t("Kanban of Article Items"),viewType:"kanban",context:{active_id:this.props.record.resId,default_parent_id:this.props.record.resId,default_is_article_item:true,},},};const title=name||_t("Article Items");await this.orm.call("knowledge.article","create_default_item_stages",[this.props.record.resId,]);const fragment=renderToFragment("knowledge.ArticleItemTemplate",{embeddedProps:JSON.stringify(embeddedProps),title,});this.props.editor.editable.replaceChildren(...fragment.children);this.props.editor.shared.selection.setCursorEnd(this.props.editor.editable);this.props.editor.shared.history.addStep();this.props.record.update({name:title});},});}
onBuildItemListBtnClick(){this.dialogService.add(PromptEmbeddedViewNameDialog,{isNew:true,viewType:"list",save:async(name)=>{const embeddedProps={viewProps:{actionXmlId:"knowledge.knowledge_article_item_action",displayName:name?_t("List of %s",name):_t("List of Article Items"),viewType:"list",context:{active_id:this.props.record.resId,default_parent_id:this.props.record.resId,default_is_article_item:true,},},};const title=name||_t("Article Items");const fragment=renderToFragment("knowledge.ArticleItemTemplate",{embeddedProps:JSON.stringify(embeddedProps),title,});this.props.editor.editable.replaceChildren(...fragment.children);this.props.editor.shared.selection.setCursorEnd(this.props.editor.editable);this.props.editor.shared.history.addStep();this.props.record.update({name:title});},});}
onGenerateArticleClick(){this.dialogService.add(ChatGPTPromptDialog,{initialPrompt:_t("Write an article about"),baseContainer:"P",insert:(fragment)=>{const generatedContentTitle=fragment.querySelector("h1,h2");const articleTitle=this.props.editor.document.createElement("h1");if(generatedContentTitle&&generatedContentTitle.tagName!=="H1"){articleTitle.innerText=generatedContentTitle.innerText;generatedContentTitle.replaceWith(articleTitle);}else if(!generatedContentTitle){const br=this.props.editor.document.createElement("BR");articleTitle.replaceChildren(br);fragment.prepend(articleTitle);}
this.props.editor.editable.replaceChildren(...fragment.children);this.props.editor.shared.selection.setCursorEnd(this.props.editor.editable);this.props.editor.shared.history.addStep();},sanitize:(fragment)=>{return DOMPurify.sanitize(fragment,{IN_PLACE:true,ADD_TAGS:["#document-fragment"],ADD_ATTR:["contenteditable"],});},});}}
return __exports;});;

/* /knowledge/static/src/editor/embedded_components/backend/article_index/article_index.js */
odoo.define('@knowledge/editor/embedded_components/backend/article_index/article_index',['@odoo/owl','@html_editor/others/embedded_component_utils','@html_editor/others/embedded_components/core/embedded_component_toolbar/embedded_component_toolbar','@web/core/utils/hooks','@knowledge/editor/embedded_components/core/article_index/readonly_article_index','@web/core/utils/concurrency'],function(require){'use strict';let __exports={};const{onWillStart,useState}=require("@odoo/owl");const{getEmbeddedProps,useEmbeddedState,StateChangeManager,}=require("@html_editor/others/embedded_component_utils");const{EmbeddedComponentToolbar,EmbeddedComponentToolbarButton,}=require("@html_editor/others/embedded_components/core/embedded_component_toolbar/embedded_component_toolbar");const{useService}=require("@web/core/utils/hooks");const{ReadonlyEmbeddedArticleIndexComponent}=require("@knowledge/editor/embedded_components/core/article_index/readonly_article_index");const{KeepLast}=require("@web/core/utils/concurrency");const EmbeddedArticleIndexComponent=__exports.EmbeddedArticleIndexComponent=class EmbeddedArticleIndexComponent extends ReadonlyEmbeddedArticleIndexComponent{static template="knowledge.EmbeddedArticleIndex";static components={...ReadonlyEmbeddedArticleIndexComponent.components,EmbeddedComponentToolbar,EmbeddedComponentToolbarButton,};static props={...ReadonlyEmbeddedArticleIndexComponent.props,host:{type:Object},};setup(){this.orm=useService("orm");this.embeddedState=useEmbeddedState(this.props.host);this.keepLastFetch=new KeepLast();this.state=useState({loading:false,});onWillStart(async()=>{if(this.embeddedState.articles===undefined){this.loadArticleIndex({firstLoad:true});}});}
async fetchAllArticles(resId,showAllChildren){const domain=[["parent_id",!showAllChildren?"=":"child_of",resId],["is_article_item","=",false],];const{records}=await this.orm.webSearchRead("knowledge.article",domain,{specification:{display_name:{},parent_id:{},},order:"sequence",});return records;}
async loadArticleIndex({showAllChildren=undefined,firstLoad=false}={}){this.state.loading=true;if(showAllChildren===undefined){showAllChildren=this.embeddedState.showAllChildren;}
const resId=this.env.model.root.resId;const promise=this.fetchAllArticles(resId,showAllChildren);const articles=await this.keepLastFetch.add(promise);if(firstLoad&&this.embeddedState.articles!==undefined){this.state.loading=false;return;}
const buildIndex=(parentId)=>{return articles.filter((article)=>{return article.parent_id&&article.parent_id===parentId;}).map((article)=>{return{id:article.id,name:article.display_name,childIds:buildIndex(article.id),};});};this.state.loading=false;this.embeddedState.showAllChildren=showAllChildren;this.embeddedState.articles=buildIndex(resId);}
async onSwitchModeBtnClick(){this.loadArticleIndex({showAllChildren:!this.embeddedState.showAllChildren,});}
async onRefreshBtnClick(){this.loadArticleIndex();}}
const articleIndexEmbedding=__exports.articleIndexEmbedding={name:"articleIndex",Component:EmbeddedArticleIndexComponent,getStateChangeManager:(config)=>{return new StateChangeManager(config);},getProps:(host)=>{return{host,...getEmbeddedProps(host),};},};return __exports;});;

/* /knowledge/static/src/editor/embedded_components/backend/clipboard/macros_embedded_clipboard.js */
odoo.define('@knowledge/editor/embedded_components/backend/clipboard/macros_embedded_clipboard',['@html_editor/main/signature_plugin','@html_editor/others/embedded_component_utils','@html_editor/utils/dom_info','@web/core/l10n/translation','@knowledge/editor/embedded_components/core/clipboard/embedded_clipboard','@web/core/user','@web/core/utils/hooks','@web/core/utils/render','@knowledge/macros/clipboard_macros','@odoo/owl'],function(require){'use strict';let __exports={};const{SIGNATURE_CLASS}=require("@html_editor/main/signature_plugin");const{getEditableDescendants,getEmbeddedProps,}=require("@html_editor/others/embedded_component_utils");const{isEmptyBlock}=require("@html_editor/utils/dom_info");const{_t}=require("@web/core/l10n/translation");const{EmbeddedClipboardComponent}=require("@knowledge/editor/embedded_components/core/clipboard/embedded_clipboard");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{renderToElement}=require("@web/core/utils/render");const{SendAsMessageMacro,UseAsDescriptionMacro}=require("@knowledge/macros/clipboard_macros");const{markup}=require("@odoo/owl");const MacrosEmbeddedClipboardComponent=__exports.MacrosEmbeddedClipboardComponent=class MacrosEmbeddedClipboardComponent extends EmbeddedClipboardComponent{static template="knowledge.MacrosEmbeddedClipboard";setup(){super.setup();this.actionService=useService("action");this.dialogService=useService("dialog");this.knowledgeCommandsService=useService("knowledgeCommandsService");this.orm=useService("orm");this.uiService=useService("ui");this.macrosServices={action:this.actionService,dialog:this.dialogService,ui:this.uiService,};this.targetRecordInfo=this.knowledgeCommandsService.getCommandsRecordInfo();this.htmlFieldTargetMessage=_t("Use as %s",this.targetRecordInfo?.fieldInfo?.string||"Description");}
createHtmlDataTransfer(){const dataTransfer=new DataTransfer();const content=this.descendants.clipboardContent;const value=`<p></p>${content.innerHTML}<p></p>`;dataTransfer.setData("application/vnd.odoo.odoo-editor",value);return dataTransfer;}
async onClickSendAsMessage(ev){const rows=await this.orm.read("res.users",[user.userId],["signature"]);const signature=renderToElement("html_editor.Signature",{signature:markup(rows[0]?.signature||""),signatureClass:SIGNATURE_CLASS,});const dataTransfer=new DataTransfer();dataTransfer.setData("application/vnd.odoo.odoo-editor",this.descendants.clipboardContent.innerHTML+(isEmptyBlock(signature)?"":signature.outerHTML));const macro=new SendAsMessageMacro({targetXmlDoc:this.targetRecordInfo.xmlDoc,breadcrumbs:this.targetRecordInfo.breadcrumbs,data:{dataTransfer:dataTransfer,},services:this.macrosServices,});macro.start();}
onClickUseAsDescription(ev){const dataTransfer=this.createHtmlDataTransfer();const macro=new UseAsDescriptionMacro({targetXmlDoc:this.targetRecordInfo.xmlDoc,breadcrumbs:this.targetRecordInfo.breadcrumbs,data:{fieldName:this.targetRecordInfo.fieldInfo.name,pageName:this.targetRecordInfo.fieldInfo.pageName,dataTransfer:dataTransfer,},services:this.macrosServices,});macro.start();}}
const macrosClipboardEmbedding=__exports.macrosClipboardEmbedding={name:"clipboard",Component:MacrosEmbeddedClipboardComponent,getProps:(host)=>{return{host,...getEmbeddedProps(host)};},getEditableDescendants:getEditableDescendants,};return __exports;});;

/* /knowledge/static/src/editor/embedded_components/backend/embedded_view_link/embedded_view_link.js */
odoo.define('@knowledge/editor/embedded_components/backend/embedded_view_link/embedded_view_link',['@html_editor/others/embedded_component_utils','@web/core/utils/hooks','@web/core/popover/popover_hook','@knowledge/editor/embedded_components/backend/embedded_view_link/embedded_view_link_popover','@knowledge/editor/embedded_components/backend/embedded_view_link/embedded_view_link_edit_dialog','@knowledge/editor/embedded_components/backend/embedded_view_link/readonly_embedded_view_link'],function(require){'use strict';let __exports={};const{getEmbeddedProps,useEmbeddedState,StateChangeManager,}=require("@html_editor/others/embedded_component_utils");const{useService}=require("@web/core/utils/hooks");const{usePopover}=require("@web/core/popover/popover_hook");const{EmbeddedViewLinkPopover}=require("@knowledge/editor/embedded_components/backend/embedded_view_link/embedded_view_link_popover");const{EmbeddedViewLinkEditDialog}=require("@knowledge/editor/embedded_components/backend/embedded_view_link/embedded_view_link_edit_dialog");const{ReadonlyViewLinkComponent}=require("@knowledge/editor/embedded_components/backend/embedded_view_link/readonly_embedded_view_link");const EmbeddedViewLinkComponent=__exports.EmbeddedViewLinkComponent=class EmbeddedViewLinkComponent extends ReadonlyViewLinkComponent{static template="knowledge.EmbeddedViewLink";static props={...ReadonlyViewLinkComponent.props,host:{type:Object},copyViewLink:{type:Function},removeViewLink:{type:Function},};setup(){this.actionService=useService("action");this.dialogService=useService("dialog");this.notificationService=useService("notification");this.popover=usePopover(EmbeddedViewLinkPopover,{popoverClass:"o_edit_menu_popover",});this.embeddedState=useEmbeddedState(this.props.host);}
set displayName(value){this.embeddedState.displayName=value;}
get displayName(){return this.embeddedState.displayName;}
set linkStyle(value){this.embeddedState.linkStyle=value;}
get linkStyle(){return this.embeddedState.linkStyle;}
onCopyViewLinkClick(){this.props.copyViewLink();this.popover.close();}
onEditViewLinkClick(){this.dialogService.add(EmbeddedViewLinkEditDialog,{name:this.displayName||"",style:this.linkStyle,onSave:(name,style)=>{this.displayName=name;this.linkStyle=style;},});this.popover.close();}
onRemoveViewLinkClick(){this.props.removeViewLink(this.displayName||"");this.popover.close();}
openEmbeddedViewLinkPopover(){this.popover.open(this.props.host,{name:this.displayName,openViewLink:this.openViewLink.bind(this),onCopyViewLinkClick:this.onCopyViewLinkClick.bind(this),onEditViewLinkClick:this.onEditViewLinkClick.bind(this),onRemoveViewLinkClick:this.onRemoveViewLinkClick.bind(this),});}}
const viewLinkEmbedding=__exports.viewLinkEmbedding={name:"viewLink",Component:EmbeddedViewLinkComponent,getProps:(host)=>{return{host,...getEmbeddedProps(host)};},getStateChangeManager:(config)=>{return new StateChangeManager(Object.assign(config,{getEmbeddedState:(host)=>{const props=getEmbeddedProps(host);return{displayName:props.viewProps.displayName,linkStyle:props.linkStyle||"link",};},stateToEmbeddedProps:(host,state)=>{const props=getEmbeddedProps(host);props.viewProps.displayName=state.displayName;props.linkStyle=state.linkStyle;return props;},}));},};return __exports;});;

/* /knowledge/static/src/editor/embedded_components/backend/embedded_view_link/embedded_view_link_edit_dialog.js */
odoo.define('@knowledge/editor/embedded_components/backend/embedded_view_link/embedded_view_link_edit_dialog',['@odoo/owl','@web/core/dialog/dialog','@knowledge/editor/embedded_components/core/embedded_view_link/embedded_view_link_style'],function(require){'use strict';let __exports={};const{Component,useState,useRef}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{EMBEDDED_VIEW_LINK_STYLES}=require("@knowledge/editor/embedded_components/core/embedded_view_link/embedded_view_link_style");const EmbeddedViewLinkEditDialog=__exports.EmbeddedViewLinkEditDialog=class EmbeddedViewLinkEditDialog extends Component{static template="knowledge.EmbeddedViewLinkEditDialog";static components={Dialog};static props={style:{type:String},close:{type:Function},name:{type:String},onSave:{type:Function},};setup(){this.state=useState({name:this.props.name,style:this.props.style,});this.input=useRef("input");}
get name(){return this.state.name.trim();}
get styles(){return EMBEDDED_VIEW_LINK_STYLES;}
onConfirm(){if(!this.name){return this.input.el.focus();}
this.props.onSave(this.name,this.state.style);this.props.close();}
updateStyle(style){this.state.style=style;}}
return __exports;});;

/* /knowledge/static/src/editor/embedded_components/backend/embedded_view_link/embedded_view_link_popover.js */
odoo.define('@knowledge/editor/embedded_components/backend/embedded_view_link/embedded_view_link_popover',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const EmbeddedViewLinkPopover=__exports.EmbeddedViewLinkPopover=class EmbeddedViewLinkPopover extends Component{static template="knowledge.EmbeddedViewLinkPopover";static props={close:{type:Function},name:{type:String},onCopyViewLinkClick:{type:Function},onEditViewLinkClick:{type:Function},onRemoveViewLinkClick:{type:Function},openViewLink:{type:Function},};}
return __exports;});;

/* /knowledge/static/src/editor/embedded_components/backend/embedded_view_link/readonly_embedded_view_link.js */
odoo.define('@knowledge/editor/embedded_components/backend/embedded_view_link/readonly_embedded_view_link',['@odoo/owl','@web/core/utils/hooks','@html_editor/others/embedded_component_utils','@knowledge/editor/embedded_components/core/embedded_view_link/embedded_view_link_style','@web/core/context'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{getEmbeddedProps}=require("@html_editor/others/embedded_component_utils");const{EMBEDDED_VIEW_LINK_STYLES}=require("@knowledge/editor/embedded_components/core/embedded_view_link/embedded_view_link_style");const{makeContext}=require("@web/core/context");const ReadonlyViewLinkComponent=__exports.ReadonlyViewLinkComponent=class ReadonlyViewLinkComponent extends Component{static template="knowledge.ReadonlyEmbeddedViewLink";static props={viewProps:{type:Object},linkStyle:{type:String,optional:true},};static defaultProps={linkStyle:"link",};get displayName(){return this.props.viewProps.displayName;}
get linkStyle(){return this.props.linkStyle;}
setup(){this.actionService=useService("action");}
getLinkClass(){return EMBEDDED_VIEW_LINK_STYLES[this.linkStyle].class;}
async openViewLink(){const context=makeContext([this.props.viewProps.context||{}]);const action=await this.actionService.loadAction(this.props.viewProps.actWindow||this.props.viewProps.actionXmlId,context);if(action.type!=="ir.actions.act_window"){throw new Error(`Invalid action type "${action.type}". Expected "ir.actions.act_window"`);}
if(this.displayName){action.name=this.displayName;action.display_name=this.displayName;}
action.globalState={searchModel:this.props.viewProps.context.knowledge_search_model_state,};const props={};if(action.context.orderBy){try{props.orderBy=JSON.parse(this.action.context.orderBy);}catch{console.error("Parsing orderBy failed");}}
this.actionService.doAction(action,{viewType:this.props.viewProps.viewType,props,});}}
const readonlyViewLinkEmbedding=__exports.readonlyViewLinkEmbedding={name:"viewLink",Component:ReadonlyViewLinkComponent,getProps:(host)=>{return{...getEmbeddedProps(host)};},};return __exports;});;

/* /knowledge/static/src/editor/embedded_components/backend/file/macros_file.js */
odoo.define('@knowledge/editor/embedded_components/backend/file/macros_file',['@html_editor/others/embedded_components/backend/file/file','@knowledge/editor/embedded_components/backend/file/macros_file_mixin'],function(require){'use strict';let __exports={};const{fileEmbedding,EmbeddedFileComponent,}=require("@html_editor/others/embedded_components/backend/file/file");const{MacrosFileMixin}=require("@knowledge/editor/embedded_components/backend/file/macros_file_mixin");const MacrosEmbeddedFileComponent=__exports.MacrosEmbeddedFileComponent=MacrosFileMixin(EmbeddedFileComponent,"knowledge.EmbeddedFile");const macrosFileEmbedding=__exports.macrosFileEmbedding={...fileEmbedding,Component:MacrosEmbeddedFileComponent,};return __exports;});;

/* /knowledge/static/src/editor/embedded_components/backend/file/macros_file_mixin.js */
odoo.define('@knowledge/editor/embedded_components/backend/file/macros_file_mixin',['@web/core/network/rpc','@web/core/utils/hooks','@web/core/utils/urls','@knowledge/macros/file_macros'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{getDataURLFromFile}=require("@web/core/utils/urls");const{AttachToMessageMacro,UseAsAttachmentMacro}=require("@knowledge/macros/file_macros");const MacrosFileMixin=__exports.MacrosFileMixin=(T,template)=>{return class extends T{static template=template;setup(){super.setup();this.actionService=useService("action");this.uiService=useService("ui");this.knowledgeCommandsService=useService("knowledgeCommandsService");this.macrosServices={action:this.actionService,dialog:this.dialogService,ui:this.uiService,};this.targetRecordInfo=this.knowledgeCommandsService.getCommandsRecordInfo();}
async onClickAttachToMessage(ev){const dataTransfer=new DataTransfer();try{const response=await window.fetch(this.fileModel.urlRoute);const blob=await response.blob();const file=new File([blob],this.fileModel.name,{type:blob.type,});dataTransfer.items.add(file);}catch{return;}
const macro=new AttachToMessageMacro({targetXmlDoc:this.targetRecordInfo.xmlDoc,breadcrumbs:this.targetRecordInfo.breadcrumbs,data:{dataTransfer:dataTransfer,},services:this.macrosServices,});macro.start();}
async onClickUseAsAttachment(ev){let attachment;try{const response=await window.fetch(this.fileModel.urlRoute);const blob=await response.blob();const dataURL=await getDataURLFromFile(blob);attachment=await rpc("/html_editor/attachment/add_data",{name:this.fileModel.name,data:dataURL.split(",")[1],is_image:false,res_id:this.targetRecordInfo.resId,res_model:this.targetRecordInfo.resModel,});}catch{return;}
if(!attachment){return;}
const macro=new UseAsAttachmentMacro({targetXmlDoc:this.targetRecordInfo.xmlDoc,breadcrumbs:this.targetRecordInfo.breadcrumbs,data:null,services:this.macrosServices,});macro.start();}};};return __exports;});;

/* /knowledge/static/src/editor/embedded_components/backend/file/readonly_macros_file.js */
odoo.define('@knowledge/editor/embedded_components/backend/file/readonly_macros_file',['@html_editor/others/embedded_components/core/file/readonly_file','@knowledge/editor/embedded_components/backend/file/macros_file_mixin'],function(require){'use strict';let __exports={};const{readonlyFileEmbedding,ReadonlyEmbeddedFileComponent,}=require("@html_editor/others/embedded_components/core/file/readonly_file");const{MacrosFileMixin}=require("@knowledge/editor/embedded_components/backend/file/macros_file_mixin");const ReadonlyMacrosEmbeddedFileComponent=__exports.ReadonlyMacrosEmbeddedFileComponent=MacrosFileMixin(ReadonlyEmbeddedFileComponent,"knowledge.ReadonlyEmbeddedFile");const readonlyMacrosFileEmbedding=__exports.readonlyMacrosFileEmbedding={...readonlyFileEmbedding,Component:ReadonlyMacrosEmbeddedFileComponent,};return __exports;});;

/* /knowledge/static/src/editor/embedded_components/backend/view/embedded_view.js */
odoo.define('@knowledge/editor/embedded_components/backend/view/embedded_view',['@knowledge/editor/embedded_components/backend/view/readonly_embedded_view','@html_editor/others/embedded_component_utils','@knowledge/components/item_calendar_props_dialog/item_calendar_props_dialog','@knowledge/components/prompt_embedded_view_name_dialog/prompt_embedded_view_name_dialog','@web/core/utils/hooks','@web/views/utils','@odoo/owl'],function(require){'use strict';let __exports={};const{ReadonlyEmbeddedViewComponent,readonlyViewEmbedding,}=require("@knowledge/editor/embedded_components/backend/view/readonly_embedded_view");const{applyObjectPropertyDifference,getEmbeddedProps,StateChangeManager,useEmbeddedState,}=require("@html_editor/others/embedded_component_utils");const{ItemCalendarPropsDialog}=require("@knowledge/components/item_calendar_props_dialog/item_calendar_props_dialog");const{PromptEmbeddedViewNameDialog}=require("@knowledge/components/prompt_embedded_view_name_dialog/prompt_embedded_view_name_dialog");const{useBus,useService}=require("@web/core/utils/hooks");const{uuid}=require("@web/views/utils");const{useSubEnv}=require("@odoo/owl");const EmbeddedViewComponent=__exports.EmbeddedViewComponent=class EmbeddedViewComponent extends ReadonlyEmbeddedViewComponent{setup(){this.embeddedState=useEmbeddedState(this.props.host);if(!this.id){this.initNewView();}
super.setup();useSubEnv({isEmbeddedReadonly:false,});this.dialogService=useService("dialog");useBus(this.env.bus,`KNOWLEDGE_EMBEDDED_${this.id}:EDIT`,()=>{if(this.additionalViewProps&&Object.keys(this.additionalViewProps).length){this.editView();}else{this.renameView();}});}
set additionalViewProps(value){this.embeddedState.additionalViewProps=value;}
get additionalViewProps(){return this.embeddedState.additionalViewProps;}
set displayName(value){this.embeddedState.displayName=value;}
get displayName(){return this.embeddedState.displayName;}
get favoriteFilters(){return this.embeddedState.favoriteFilters;}
set id(value){this.embeddedState.id=value;}
get id(){return this.embeddedState.id;}
deleteFavoriteFilter(searchItem){delete this.favoriteFilters[searchItem.description];}
editView(){if(this.action.res_model==="knowledge.article"&&this.action.view_mode==="calendar"){this.dialogService.add(ItemCalendarPropsDialog,{isNew:false,name:this.displayName,saveItemCalendarProps:(name,itemCalendarProps)=>{this.displayName=name;this.additionalViewProps.itemCalendarProps=itemCalendarProps;},knowledgeArticleId:this.env.model.root.resId,...this.additionalViewProps.itemCalendarProps,});}else{throw new Error("Cannot edit the view: the dialog is not implemented");}}
initNewView(){if(!this.env.model.root.data.full_width){this.env.model.root.update({full_width:true});}
this.id=uuid();const keyOptionalFields=this.props.viewProps.context.keyOptionalFields;if(keyOptionalFields){const optionalFields=localStorage.getItem(keyOptionalFields);if(optionalFields){localStorage.setItem(`${keyOptionalFields},${this.id}`,optionalFields);}}}
renameView(){this.dialogService.add(PromptEmbeddedViewNameDialog,{isNew:false,defaultName:this.displayName,viewType:this.props.viewProps.viewType,save:(name)=>{this.displayName=name;},});}
saveFavoriteFilter(filter){this.favoriteFilters[filter.name]=filter;}}
const viewEmbedding=__exports.viewEmbedding={...readonlyViewEmbedding,Component:EmbeddedViewComponent,getStateChangeManager:(config)=>{return new StateChangeManager(Object.assign(config,{getEmbeddedState:(host)=>{const props=getEmbeddedProps(host);return{additionalViewProps:props.viewProps.additionalViewProps||{},displayName:props.viewProps.displayName,favoriteFilters:props.viewProps.favoriteFilters||{},id:props.viewProps.id,};},propertyUpdater:{favoriteFilters:(state,previous,next)=>{applyObjectPropertyDifference(state,"favoriteFilters",previous.favoriteFilters,next.favoriteFilters);},},stateToEmbeddedProps:(host,state)=>{const props=getEmbeddedProps(host);props.viewProps.additionalViewProps=state.additionalViewProps;props.viewProps.displayName=state.displayName;props.viewProps.favoriteFilters=state.favoriteFilters;props.viewProps.id=state.id;return props;},}));},};return __exports;});;

/* /knowledge/static/src/editor/embedded_components/backend/view/readonly_embedded_view.js */
odoo.define('@knowledge/editor/embedded_components/backend/view/readonly_embedded_view',['@html_editor/others/embedded_component_utils','@knowledge/views/embedded_view','@knowledge/components/with_lazy_loading/with_lazy_loading','@web/core/context','@web/core/l10n/translation','@web/core/debug/debug_context','@web/core/utils/hooks','@web/search/action_hook','@web/views/view','@odoo/owl'],function(require){'use strict';let __exports={};const{getEmbeddedProps}=require("@html_editor/others/embedded_component_utils");const{EmbeddedView}=require("@knowledge/views/embedded_view");const{WithLazyLoading}=require("@knowledge/components/with_lazy_loading/with_lazy_loading");const{makeContext}=require("@web/core/context");const{_t}=require("@web/core/l10n/translation");const{useOwnDebugContext}=require("@web/core/debug/debug_context");const{useBus,useService}=require("@web/core/utils/hooks");const{CallbackRecorder}=require("@web/search/action_hook");const{getDefaultConfig}=require("@web/views/view");const{Component,onError,onWillStart,useExternalListener,useState,useSubEnv,}=require("@odoo/owl");const VIEW_RECORDS_LIMITS={kanban:20,list:40,};const ReadonlyEmbeddedViewComponent=__exports.ReadonlyEmbeddedViewComponent=class ReadonlyEmbeddedViewComponent extends Component{static components={EmbeddedView,WithLazyLoading};static props={host:{type:Object},viewProps:{type:Object},};static template="knowledge.EmbeddedView";setup(){super.setup();this.actionService=useService("action");this.notificationService=useService("notification");this.uiService=useService("ui");this.viewFilters=useService("knowledgeEmbedViewsFilters");useOwnDebugContext();this.state=useState({error:false,isLoaded:false,});const services=this.env.services;const extendedServices=Object.create(services);extendedServices.action=Object.create(services.action);extendedServices.action.switchView=(viewType,props={})=>{if(props.resId){this.action.res_id=props.resId;}
this.action.globalState=this.getEmbeddedViewGlobalState();this.actionService.doAction(this.action,{viewType});};useSubEnv({config:{...getDefaultConfig(),disableSearchBarAutofocus:true},isEmbeddedView:true,isEmbeddedReadonly:true,services:extendedServices,});useBus(this.env.bus,`KNOWLEDGE_EMBEDDED_${this.id}:OPEN`,()=>{this.openView();});useExternalListener(this.props.host,"focusin",()=>{if(!this.props.host.contains(this.uiService.activeElement)){this.uiService.activateElement(this.props.host);}});useExternalListener(this.props.host,"focusout",(event)=>{if(!this.props.host.contains(event.relatedTarget)){this.uiService.deactivateElement(this.props.host);}});onWillStart(async()=>{await this.loadEmbeddedView();});onError((error)=>{console.error(error);this.state.error=true;});}
get embeddedViewProps(){return{...this.staticEmbeddedViewProps,additionalViewProps:{...this.additionalViewProps},displayName:this.displayName,irFilters:this.irFilters,};}
get additionalViewProps(){return this.props.viewProps.additionalViewProps;}
get displayName(){return this.props.viewProps.displayName;}
get favoriteFilters(){return this.props.viewProps.favoriteFilters;}
get id(){return this.props.viewProps.id;}
get irFilters(){return(Object.values(this.favoriteFilters||{})||[]).map((filter)=>({...filter,context:JSON.stringify(filter.context),}));}
async createRecord(){this.saveFilters();this.actionService.doAction({res_model:this.action.res_model,type:'ir.actions.act_window',views:[this.action.views.find(([_,type])=>type==="form")||[false,"form"]],});}
deleteFavoriteFilter(searchItem){this.notificationService.add(_t("You are not allowed to delete a favorite filter in this article."),{type:"danger",});}
getEmbeddedViewGlobalState(){const callbacks=this.__getGlobalState__.callbacks;let globalState;if(callbacks.length){globalState=callbacks.reduce((res,callback)=>{return{...res,...callback()};},{});}
return{searchModel:globalState&&globalState.searchModel};}
async loadEmbeddedView(){this.__getGlobalState__=new CallbackRecorder();const context=this.makeEmbeddedContext();this.action=await this.loadAction(context);this.env.config.views=this.action.views;this.env.config.setDisplayName(this.action.name);this.staticEmbeddedViewProps=this.prepareStaticEmbeddedViewProps(context);this.viewFilters.applyFilter(this.actionService.currentController,this.id,this.staticEmbeddedViewProps);this.state.isLoaded=true;}
async loadAction(context){if(this.props.actWindow?.help){delete this.props.actWindow.help;}
const action=await this.actionService.loadAction(this.props.viewProps.actWindow||this.props.viewProps.actionXmlId,context);if(action.type!=="ir.actions.act_window"){throw new Error(`Invalid action type "${action.type}". Expected "ir.actions.act_window"`);}
if(this.displayName){action.name=this.displayName;action.display_name=this.displayName;}
return action;}
makeEmbeddedContext(){const context=makeContext([this.props.viewProps.context||{},{knowledgeEmbeddedViewId:this.id,},]);return context;}
openView(){this.saveFilters();const props=this.additionalViewProps||{};if(this.action.context.orderBy){try{props.orderBy=JSON.parse(this.action.context.orderBy);}catch{console.error("Parsing orderBy failed");}}
if(this.displayName!==this.action.display_name){this.action.display_name=this.displayName;this.action.name=this.displayName;}
this.action.globalState=this.getEmbeddedViewGlobalState();this.actionService.doAction(this.action,{viewType:this.props.viewProps.viewType,props,additionalContext:{knowledgeEmbeddedViewId:this.id,isOpenedEmbeddedView:true,},});}
prepareStaticEmbeddedViewProps(context){return{context,createRecord:this.createRecord.bind(this),deleteEmbeddedViewFavoriteFilter:this.deleteFavoriteFilter.bind(this),domain:this.action.domain||[],__getGlobalState__:this.__getGlobalState__,globalState:{searchModel:context.knowledge_search_model_state},irFilters:this.irFilters,limit:VIEW_RECORDS_LIMITS[this.props.viewProps.type],loadActionMenus:true,loadIrFilters:true,noContentHelp:this.action.help,resModel:this.action.res_model,saveEmbeddedViewFavoriteFilter:this.saveFavoriteFilter.bind(this),searchViewId:this.action.searchViewId?.[0],selectRecord:this.selectRecord.bind(this),type:this.props.viewProps.viewType,};}
saveFilters(){this.viewFilters.saveFilters(this.actionService.currentController,this.id,this.getEmbeddedViewGlobalState().searchModel);}
saveFavoriteFilter(filter){this.notificationService.add(_t("You are not allowed to save a favorite filter in this article."),{type:"danger",});}
selectRecord(resId){this.saveFilters();if(this.action.res_model==="knowledge.article"){this.env.openArticle(resId);}else{this.actionService.doAction({res_id:resId,res_model:this.action.res_model,type:"ir.actions.act_window",views:[this.action.views.find((_,type)=>type==="form")||[false,"form"]],});}}}
const readonlyViewEmbedding=__exports.readonlyViewEmbedding={name:"view",Component:ReadonlyEmbeddedViewComponent,getProps:(host)=>{return{host,...getEmbeddedProps(host)};},};return __exports;});;

/* /knowledge/static/src/editor/embedded_components/core/article_index/article_index_list.js */
odoo.define('@knowledge/editor/embedded_components/core/article_index/article_index_list',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const ArticleIndexList=__exports.ArticleIndexList=class ArticleIndexList extends Component{static template="knowledge.ArticleIndexList";static props={articles:{type:Object},};onArticleLinkClick(ev,articleId){if(this.env.openArticle){ev.preventDefault();ev.stopPropagation();this.env.openArticle(articleId);}}}
return __exports;});;

/* /knowledge/static/src/editor/embedded_components/core/article_index/readonly_article_index.js */
odoo.define('@knowledge/editor/embedded_components/core/article_index/readonly_article_index',['@odoo/owl','@html_editor/others/embedded_component_utils','@knowledge/editor/embedded_components/core/article_index/article_index_list'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{getEmbeddedProps}=require("@html_editor/others/embedded_component_utils");const{ArticleIndexList}=require("@knowledge/editor/embedded_components/core/article_index/article_index_list");const ReadonlyEmbeddedArticleIndexComponent=__exports.ReadonlyEmbeddedArticleIndexComponent=class ReadonlyEmbeddedArticleIndexComponent extends Component{static props={articles:{type:Object,optional:true},showAllChildren:{type:Boolean,optional:true},};static defaultProps={showAllChildren:true,};static template="knowledge.ReadonlyEmbeddedArticleIndex";static components={ArticleIndexList};}
const readonlyArticleIndexEmbedding=__exports.readonlyArticleIndexEmbedding={name:"articleIndex",Component:ReadonlyEmbeddedArticleIndexComponent,getProps:(host)=>{return{...getEmbeddedProps(host),};},};return __exports;});;

/* /knowledge/static/src/editor/embedded_components/core/clipboard/embedded_clipboard.js */
odoo.define('@knowledge/editor/embedded_components/core/clipboard/embedded_clipboard',['@html_editor/others/embedded_component_utils','@html_editor/others/embedded_components/core/embedded_component_toolbar/embedded_component_toolbar','@web/core/browser/browser','@web/core/l10n/translation','@web/core/tooltip/tooltip','@web/core/popover/popover_hook','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{getEditableDescendants,useEditableDescendants,}=require("@html_editor/others/embedded_component_utils");const{EmbeddedComponentToolbar,EmbeddedComponentToolbarButton,}=require("@html_editor/others/embedded_components/core/embedded_component_toolbar/embedded_component_toolbar");const{browser}=require("@web/core/browser/browser");const{_t}=require("@web/core/l10n/translation");const{Tooltip}=require("@web/core/tooltip/tooltip");const{usePopover}=require("@web/core/popover/popover_hook");const{useChildRef}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const EmbeddedClipboardComponent=__exports.EmbeddedClipboardComponent=class EmbeddedClipboardComponent extends Component{static components={EmbeddedComponentToolbar,EmbeddedComponentToolbarButton,};static props={host:{type:Object},};static template="knowledge.EmbeddedClipboard";setup(){this.popover=usePopover(Tooltip);this.descendants=useEditableDescendants(this.props.host);this.copyToClipboardButtonRef=useChildRef();}
async onClickCopyToClipboard(){const selection=document.getSelection();selection.removeAllRanges();const range=new Range();range.selectNodeContents(this.descendants.clipboardContent);selection.addRange(range);if(document.execCommand("copy")){this.popover.open(this.copyToClipboardButtonRef.el,{tooltip:_t("Content copied to clipboard."),});browser.setTimeout(this.popover.close,800);}
selection.removeAllRanges();}}
const clipboardEmbedding=__exports.clipboardEmbedding={name:"clipboard",Component:EmbeddedClipboardComponent,getEditableDescendants:getEditableDescendants,getProps:(host)=>{return{host};},};return __exports;});;

/* /knowledge/static/src/editor/embedded_components/core/embedded_view_link/embedded_view_link_style.js */
odoo.define('@knowledge/editor/embedded_components/core/embedded_view_link/embedded_view_link_style',['@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const EMBEDDED_VIEW_LINK_STYLES=__exports.EMBEDDED_VIEW_LINK_STYLES={link:{display:_t("Link"),class:"btn btn-link"},primary:{display:_t("Primary"),class:"btn btn-primary"},secondary:{display:_t("Secondary"),class:"btn btn-secondary"},};return __exports;});;

/* /knowledge/static/src/editor/embedded_components/embedding_sets.js */
odoo.define('@knowledge/editor/embedded_components/embedding_sets',['@knowledge/editor/embedded_components/backend/clipboard/macros_embedded_clipboard','@knowledge/editor/embedded_components/backend/file/macros_file','@knowledge/editor/embedded_components/backend/file/readonly_macros_file','@knowledge/editor/embedded_components/backend/article_index/article_index','@knowledge/editor/embedded_components/core/article_index/readonly_article_index','@knowledge/editor/embedded_components/backend/view/readonly_embedded_view','@knowledge/editor/embedded_components/backend/view/embedded_view','@knowledge/editor/embedded_components/backend/embedded_view_link/readonly_embedded_view_link','@knowledge/editor/embedded_components/backend/embedded_view_link/embedded_view_link'],function(require){'use strict';let __exports={};const{macrosClipboardEmbedding}=require("@knowledge/editor/embedded_components/backend/clipboard/macros_embedded_clipboard");const{macrosFileEmbedding}=require("@knowledge/editor/embedded_components/backend/file/macros_file");const{readonlyMacrosFileEmbedding}=require("@knowledge/editor/embedded_components/backend/file/readonly_macros_file");const{articleIndexEmbedding}=require("@knowledge/editor/embedded_components/backend/article_index/article_index");const{readonlyArticleIndexEmbedding}=require("@knowledge/editor/embedded_components/core/article_index/readonly_article_index");const{readonlyViewEmbedding}=require("@knowledge/editor/embedded_components/backend/view/readonly_embedded_view");const{viewEmbedding}=require("@knowledge/editor/embedded_components/backend/view/embedded_view");const{readonlyViewLinkEmbedding}=require("@knowledge/editor/embedded_components/backend/embedded_view_link/readonly_embedded_view_link");const{viewLinkEmbedding}=require("@knowledge/editor/embedded_components/backend/embedded_view_link/embedded_view_link");const KNOWLEDGE_EMBEDDINGS=__exports.KNOWLEDGE_EMBEDDINGS=[articleIndexEmbedding,macrosClipboardEmbedding,macrosFileEmbedding,viewEmbedding,viewLinkEmbedding,];const KNOWLEDGE_READONLY_EMBEDDINGS=__exports.KNOWLEDGE_READONLY_EMBEDDINGS=[macrosClipboardEmbedding,readonlyArticleIndexEmbedding,readonlyMacrosFileEmbedding,readonlyViewEmbedding,readonlyViewLinkEmbedding,];return __exports;});;

/* /knowledge/static/src/editor/embedded_components/plugins/article_index_plugin/article_index_plugin.js */
odoo.define('@knowledge/editor/embedded_components/plugins/article_index_plugin/article_index_plugin',['@html_editor/plugin','@html_editor/utils/resource','@web/core/l10n/translation','@web/core/utils/render'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{withSequence}=require("@html_editor/utils/resource");const{_t}=require("@web/core/l10n/translation");const{renderToElement}=require("@web/core/utils/render");const ArticleIndexPlugin=__exports.ArticleIndexPlugin=class ArticleIndexPlugin extends Plugin{static id="articleIndex";static dependencies=["history","dom"];resources={user_commands:[{id:"insertArticleIndex",title:_t("Index"),description:_t("Show nested articles"),icon:"fa-list",run:this.insertArticleIndex.bind(this),},],powerbox_categories:[withSequence(20,{id:"knowledge",name:_t("Knowledge"),}),],powerbox_items:[{categoryId:"knowledge",commandId:"insertArticleIndex",}],};insertArticleIndex(){const articleIndexBlueprint=renderToElement("knowledge.ArticleIndexBlueprint");this.dependencies.dom.insert(articleIndexBlueprint);this.dependencies.history.addStep();}}
return __exports;});;

/* /knowledge/static/src/editor/embedded_components/plugins/embedded_clipboard_plugin/embedded_clipboard_plugin.js */
odoo.define('@knowledge/editor/embedded_components/plugins/embedded_clipboard_plugin/embedded_clipboard_plugin',['@html_editor/plugin','@html_editor/utils/base_container','@html_editor/utils/dom_traversal','@web/core/l10n/translation','@web/core/utils/render'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{getBaseContainerSelector}=require("@html_editor/utils/base_container");const{closestElement}=require("@html_editor/utils/dom_traversal");const{_t}=require("@web/core/l10n/translation");const{renderToElement}=require("@web/core/utils/render");const EmbeddedClipboardPlugin=__exports.EmbeddedClipboardPlugin=class EmbeddedClipboardPlugin extends Plugin{static id="embeddedClipboard";static dependencies=["baseContainer","history","dom","selection"];resources={user_commands:[{id:"insertClipboard",title:_t("Clipboard"),description:_t("Add a clipboard section"),icon:"fa-pencil-square",run:this.insertClipboard.bind(this),},],powerbox_items:[{categoryId:"media",commandId:"insertClipboard",isAvailable:(selection)=>!closestElement(selection.anchorNode,"[data-embedded='clipboard']"),},],mount_component_handlers:this.setupNewClipboard.bind(this),};insertClipboard(){const baseContainer=this.dependencies.baseContainer.createBaseContainer();const baseContainerNodeName=baseContainer.nodeName;const baseContainerClass=baseContainer.className;const baseContainerSelector=getBaseContainerSelector(baseContainerNodeName);const clipboardBlock=renderToElement("knowledge.EmbeddedClipboardBlueprint",{baseContainerNodeName,baseContainerAttributes:{class:baseContainerClass,},});this.dependencies.dom.insert(clipboardBlock);this.dependencies.selection.setCursorStart(clipboardBlock.querySelector(baseContainerSelector));this.dependencies.history.addStep();}
setupNewClipboard({name,env}){if(name==="clipboard"){Object.assign(env,{editorShared:{preserveSelection:this.dependencies.selection.preserveSelection,},});}}}
return __exports;});;

/* /knowledge/static/src/editor/embedded_components/plugins/embedded_view_link_plugin/embedded_view_link_plugin.js */
odoo.define('@knowledge/editor/embedded_components/plugins/embedded_view_link_plugin/embedded_view_link_plugin',['@html_editor/plugin','@html_editor/utils/position','@html_editor/plugin_sets','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{boundariesOut}=require("@html_editor/utils/position");const{EMBEDDED_COMPONENT_PLUGINS}=require("@html_editor/plugin_sets");const{_t}=require("@web/core/l10n/translation");const EmbeddedViewLinkPlugin=__exports.EmbeddedViewLinkPlugin=class EmbeddedViewLinkPlugin extends Plugin{static id="embeddedViewLink";static dependencies=["history","dom","selection"];resources={mount_component_handlers:this.setupNewComponent.bind(this),};setupNewComponent({name,props}){if(name==="viewLink"){Object.assign(props,{removeViewLink:(text)=>{this.replaceElementWith(props.host,text);this.dependencies.history.addStep();},copyViewLink:()=>{const cursors=this.dependencies.selection.preserveSelection();this.copyElementToClipboard(props.host);cursors?.restore();},});}}
replaceElementWith(target,element){const[anchorNode,anchorOffset,focusNode,focusOffset]=boundariesOut(target);this.dependencies.selection.setSelection({anchorNode,anchorOffset,focusNode,focusOffset,});this.dependencies.dom.insert(element);}
copyElementToClipboard(element){const range=document.createRange();range.selectNode(element);const selection=window.getSelection();selection.removeAllRanges();selection.addRange(range);const copySucceeded=document.execCommand("copy");selection.removeAllRanges();if(copySucceeded){this.services.notification.add(_t("Link copied to clipboard."),{type:"success",});}}}
EMBEDDED_COMPONENT_PLUGINS.push(EmbeddedViewLinkPlugin);return __exports;});;

/* /knowledge/static/src/editor/embedded_components/plugins/embedded_view_plugin/embedded_view_plugin.js */
odoo.define('@knowledge/editor/embedded_components/plugins/embedded_view_plugin/embedded_view_plugin',['@html_editor/plugin','@html_editor/utils/dom_traversal','@knowledge/components/item_calendar_props_dialog/item_calendar_props_dialog','@knowledge/components/prompt_embedded_view_name_dialog/prompt_embedded_view_name_dialog','@web/core/l10n/translation','@web/core/utils/render'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{closestElement}=require("@html_editor/utils/dom_traversal");const{ItemCalendarPropsDialog}=require("@knowledge/components/item_calendar_props_dialog/item_calendar_props_dialog");const{PromptEmbeddedViewNameDialog}=require("@knowledge/components/prompt_embedded_view_name_dialog/prompt_embedded_view_name_dialog");const{_t}=require("@web/core/l10n/translation");const{renderToElement}=require("@web/core/utils/render");function isAvailable(selection){return!closestElement(selection.anchorNode,".o_editor_banner, table, [data-embedded]");}
const EmbeddedViewPlugin=__exports.EmbeddedViewPlugin=class EmbeddedViewPlugin extends Plugin{static id="embeddedView";static dependencies=["history","dom","selection"];resources={user_commands:[{id:"insertEmbeddedViewKanban",title:_t("Item Kanban"),description:_t("Insert a Kanban view of article items"),icon:"fa-th-large",run:()=>{this.promptInsertEmbeddedView("kanban",true);},},{id:"insertEmbeddedViewCards",title:_t("Item Cards"),description:_t("Insert a Card view of article items"),icon:"fa-address-card",run:()=>{this.promptInsertEmbeddedView("kanban");},},{id:"insertEmbeddedViewList",title:_t("Item List"),description:_t("Insert a List view of article items"),icon:"fa-th-list",run:()=>{this.promptInsertEmbeddedView("list");},},{id:"insertEmbeddedViewCalendar",title:_t("Item Calendar"),description:_t("Insert a Calendar view of article items"),icon:"fa-calendar-plus-o",run:()=>{this.promptInsertEmbeddedCalendarView();},}],powerbox_items:[{categoryId:"knowledge",commandId:"insertEmbeddedViewKanban",isAvailable,},{categoryId:"knowledge",commandId:"insertEmbeddedViewCards",isAvailable,},{categoryId:"knowledge",commandId:"insertEmbeddedViewList",isAvailable,},{categoryId:"knowledge",commandId:"insertEmbeddedViewCalendar",isAvailable,},],};insertEmbeddedView(actionXmlId,name,viewType,additionalViewProps={}){const resId=this.config.getRecordInfo().resId;const embeddedViewBlueprint=renderToElement("knowledge.EmbeddedViewBlueprint",{embeddedProps:JSON.stringify({viewProps:{actionXmlId,additionalViewProps,context:{active_id:resId,default_parent_id:resId,default_is_article_item:true,},displayName:name,viewType,},}),});this.dependencies.dom.insert(embeddedViewBlueprint);this.dependencies.history.addStep();}
promptInsertEmbeddedCalendarView(){let cursor=this.dependencies.selection.preserveSelection();const resId=this.config.getRecordInfo().resId;this.services.dialog.add(ItemCalendarPropsDialog,{isNew:true,knowledgeArticleId:resId,saveItemCalendarProps:(name,itemCalendarProps)=>{cursor=null;this.insertEmbeddedView("knowledge.knowledge_article_action_item_calendar",name,"calendar",{itemCalendarProps});},},{onClose:()=>{cursor?.restore();},});}
promptInsertEmbeddedView(viewType,withStages){let cursor=this.dependencies.selection.preserveSelection();const resId=this.config.getRecordInfo().resId;this.services.dialog.add(PromptEmbeddedViewNameDialog,{isNew:true,save:async(name)=>{cursor=null;if(withStages){await this.services.orm.call("knowledge.article","create_default_item_stages",[resId]);}
this.insertEmbeddedView(`knowledge.knowledge_article_item_action${withStages ? "_stages" : ""}`,name,viewType);},viewType,},{onClose:()=>{cursor?.restore();},});}}
return __exports;});;

/* /knowledge/static/src/editor/html_migrations/html_upgrade_manager.js */
odoo.define('@knowledge/editor/html_migrations/html_upgrade_manager',['@html_editor/html_migrations/html_upgrade_manager'],function(require){'use strict';let __exports={};{const{HtmlUpgradeManager}=require("@html_editor/html_migrations/html_upgrade_manager");Object.assign(__exports,{HtmlUpgradeManager})};return __exports;});;

/* /knowledge/static/src/editor/html_migrations/manifest.js */
odoo.define('@knowledge/editor/html_migrations/manifest',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");registry.category("html_editor_upgrade").category("1.0").add("knowledge","@knowledge/editor/html_migrations/migration-1.0");return __exports;});;

/* /knowledge/static/src/editor/html_migrations/migration-1.0.js */
odoo.define('@knowledge/editor/html_migrations/migration-1.0',['@knowledge/editor/html_migrations/utils','@web/core/utils/urls','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{decodeDataBehaviorProps,getPropNameNode}=require("@knowledge/editor/html_migrations/utils");const{getOrigin}=require("@web/core/utils/urls");const{_t}=require("@web/core/l10n/translation");__exports.upgrade=upgrade;function upgrade(container,env){for(const[key,selector]of Object.entries(selectors)){const elements=container.querySelectorAll(selector);if(elements.length){upgrades[key](elements,env);}}}
function upgradeSearchModelState(searchModelState){searchModelState=JSON.parse(searchModelState);const dfOptMap={this_year:"year",last_year:"year-1",antepenultimate_year:"year-2",this_month:"month",last_month:"month-1",antepenultimate_month:"month-2",};for(const searchItem of Object.values(searchModelState.searchItems)){if(searchItem.type==="dateFilter"){const newDefaults=new Set();for(const generatorId of searchItem.defaultGeneratorIds){if(generatorId in dfOptMap){newDefaults.add(dfOptMap[generatorId]);}}
if(newDefaults.size){searchItem.defaultGeneratorIds=Array.from(newDefaults);}
if(!searchItem.optionsParams){searchItem.optionsParams={startYear:-2,endYear:0,startMonth:-2,endMonth:0,customOptions:[],};}
for(const queryItem of searchModelState.query){if(queryItem.searchItemId===searchItem.id&&queryItem.generatorId&&queryItem.generatorId in dfOptMap){queryItem.generatorId=dfOptMap[queryItem.generatorId];}}}}
return JSON.stringify(searchModelState);}
const selectors={articleBehavior:".o_knowledge_behavior_type_article",articlesStructureBehavior:".o_knowledge_behavior_type_articles_structure",comments:".knowledge-thread-comment",drawBehavior:".o_knowledge_behavior_type_draw",embeddedViewBehavior:".o_knowledge_behavior_type_embedded_view",fileBehavior:".o_knowledge_behavior_type_file",tableOfContentBehavior:".o_knowledge_behavior_type_toc",templateBehavior:".o_knowledge_behavior_type_template",videoBehavior:".o_knowledge_behavior_type_video",viewLinkBehavior:".o_knowledge_behavior_type_view_link",};const upgrades={articleBehavior:(elements)=>{for(const el of elements){const oldProps=decodeDataBehaviorProps(el.dataset.behaviorProps);if(!oldProps?.article_id||!oldProps?.display_name){continue;}
delete el.dataset.behaviorProps;el.dataset.res_id=oldProps?.article_id;el.removeAttribute("tabindex");el.classList.remove("o_knowledge_behavior_anchor","o_knowledge_behavior_type_article");el.classList.add("o_knowledge_article_link");el.replaceChildren(document.createTextNode(oldProps.display_name));}},articlesStructureBehavior:(elements)=>{function buildIndex(el,props){const index=[];while(el){const anchor=el.querySelector("a");const id=parseInt(anchor.getAttribute("href").match(/(\d+)$/).at(1));const name=anchor.textContent;const article={id,name,childIds:[]};el=el.nextElementSibling;const child=el?.querySelector(":scope > ol > li");if(child){article.childIds=buildIndex(child,props);props.showAllChildren=true;el=el.nextElementSibling;}
index.push(article);}
return index;}
for(const el of elements){const props={};try{const content=getPropNameNode("content",el);const articles=buildIndex(content.querySelector("li"),props);if(articles.length){props.articles=articles;el.dataset.embeddedProps=JSON.stringify(props);}}catch{}
el.removeAttribute("class");el.removeAttribute("tabindex");el.dataset.embedded="articleIndex";el.replaceChildren();}},comments:(elements,env)=>{function createBeacon({type,threadId,resId,resModel,disabled}){const anchor=document.createElement("A");anchor.classList.add("oe_unremovable","oe_thread_beacon");anchor.dataset.id=threadId;anchor.dataset.res_id=resId;anchor.dataset.resModel=resModel;anchor.dataset.oeType=type;if(disabled){anchor.classList.add("oe_disabled_thread_beacon");}
return anchor;}
function createBeacons({anchors,threadId,resId,resModel}){const start=anchors.at(0);const end=anchors.at(-1);if(!start||!end){return;}
const disabled=!start.classList.contains("knowledge-thread-highlighted-comment");const beaconStart=createBeacon({type:"threadBeaconStart",threadId,resId,resModel,disabled,});const beaconEnd=createBeacon({type:"threadBeaconEnd",threadId,resId,resModel,disabled,});start.before(beaconStart);end.after(beaconEnd);}
function groupComments(anchors){const comments={};for(const anchor of anchors){const threadId=anchor.dataset.id;if(!threadId){continue;}
comments[threadId]||=[];comments[threadId].push(anchor);}
return comments;}
const resId=env.model?.root?.resId;const resModel=env.model?.root?.resModel;if(resId&&resModel){const comments=groupComments(elements);for(const threadId in comments){createBeacons({anchors:comments[threadId],threadId,resId,resModel});}}
for(const el of[...elements]){if(el.nodeName==="SPAN"){const childNodes=[];while(el.firstChild){childNodes.push(el.firstChild);el.firstChild.remove();}
el.replaceWith(...childNodes);continue;}
el.classList.remove("focused-comment","knowledge-thread-highlighted-comment","knowledge-thread-comment");delete el.dataset.id;el.removeAttribute("tabindex");}},drawBehavior:(elements)=>{for(const el of elements){const oldProps=decodeDataBehaviorProps(el.dataset.behaviorProps);if(!oldProps||!oldProps.source){continue;}
const props={height:oldProps.height,source:oldProps.source,width:oldProps.width,};el.dataset.embedded="draw";el.dataset.embeddedProps=JSON.stringify(props);delete el.dataset.behaviorProps;delete el.dataset.oeTransientContent;el.removeAttribute("class");el.removeAttribute("tabindex");el.replaceChildren();}},embeddedViewBehavior:(elements)=>{for(const el of elements){const oldProps=decodeDataBehaviorProps(el.dataset.behaviorProps);const viewProps={context:oldProps.context,displayName:oldProps.display_name,favoriteFilters:{},id:oldProps.embedded_view_id,viewType:oldProps.view_type,};if(oldProps.act_window){viewProps.actWindow=oldProps.act_window;}else{viewProps.actionXmlId=oldProps.action_xml_id;}
if(oldProps.additionalViewProps){viewProps.additionalViewProps=oldProps.additionalViewProps;}
if(oldProps.favorites){for(const filter of oldProps.favorites){viewProps.favoriteFilters[filter.name]=filter;}}
if(viewProps.context.knowledge_search_model_state){viewProps.context.knowledge_search_model_state=upgradeSearchModelState(viewProps.context.knowledge_search_model_state);}
delete el.dataset.behaviorProps;el.removeAttribute("class");el.removeAttribute("tabindex");el.dataset.embedded="view";el.dataset.embeddedProps=JSON.stringify({viewProps});el.replaceChildren();}},fileBehavior:(elements)=>{for(const el of elements){const oldProps=decodeDataBehaviorProps(el.dataset.behaviorProps);const htmlFileName=getPropNameNode("fileName",el)?.textContent;const htmlFileExtension=getPropNameNode("fileExtension",el)?.textContent;const htmlFileImageLink=getPropNameNode("fileImage",el)?.querySelector("a");const href=htmlFileImageLink?.getAttribute("href");const mimetype=htmlFileImageLink?.dataset.mimetype;let accessToken,checksum,id,type,url;if(href?.startsWith(getOrigin())){id=parseInt((href.match(/\/web\/(?:content|image)\/(\d+)/)||[])[1]);checksum=(href.match(/unique=([^&]+)/)||[])[1];accessToken=(href.match(/access_token=([^&]+)/)||[])[1];}
if(!id){type="url";url=href?.replace(/\?.*$/,"");}else{type="binary";}
const fileName=htmlFileName||oldProps?.fileName||_t("Untitled");const extension=htmlFileExtension||oldProps?.fileExtension;let fileData=oldProps?.fileData;if(fileData?.accessToken){fileData.access_token=fileData.accessToken;delete fileData.accessToken;}
if(!id&&!url&&!fileData){continue;}
if(!fileData){fileData={access_token:accessToken,checksum,extension,filename:fileName,id,mimetype,name:fileName,type,url,};}
const props={fileData,};el.removeAttribute("class");el.removeAttribute("tabindex");delete el.dataset.behaviorProps;el.dataset.embedded="file";el.dataset.embeddedProps=JSON.stringify(props);el.replaceChildren();}},tableOfContentBehavior:(elements)=>{for(const el of elements){el.removeAttribute("class");el.removeAttribute("tabindex");el.dataset.embedded="tableOfContent";el.replaceChildren();}},templateBehavior:(elements)=>{for(const el of elements){let content=getPropNameNode("content",el);if(!content){content=document.createElement("DIV");const p=document.createElement("P");const br=document.createElement("BR");p.append(br);content.append(p);}
content.removeAttribute("class");delete content.dataset.propName;content.dataset.embeddedEditable="clipboardContent";el.removeAttribute("class");el.removeAttribute("tabindex");el.dataset.embedded="clipboard";el.replaceChildren(content);}},videoBehavior:(elements)=>{for(const el of elements){const oldProps=decodeDataBehaviorProps(el.dataset.behaviorProps);if(!oldProps||!oldProps.platform||!oldProps.videoId){continue;}
delete el.dataset.behaviorProps;const props={platform:oldProps.platform,videoId:oldProps.videoId,params:oldProps.params,};el.removeAttribute("class");el.removeAttribute("tabindex");el.dataset.embedded="video";el.dataset.embeddedProps=JSON.stringify(props);el.replaceChildren();}},viewLinkBehavior:(elements)=>{for(const el of elements){const oldProps=decodeDataBehaviorProps(el.dataset.behaviorProps);const viewProps={context:oldProps.context,displayName:oldProps.name,viewType:oldProps.view_type,};const props={};if(oldProps.style){props.linkStyle=oldProps.style;}
if(oldProps.act_window){viewProps.actWindow=oldProps.act_window;}else{viewProps.actionXmlId=oldProps.action_xml_id;}
if(viewProps.context.knowledge_search_model_state){viewProps.context.knowledge_search_model_state=upgradeSearchModelState(viewProps.context.knowledge_search_model_state);}
delete el.dataset.behaviorProps;el.removeAttribute("class");el.removeAttribute("tabindex");el.dataset.embedded="viewLink";el.dataset.embeddedProps=JSON.stringify({viewProps,...props});el.replaceChildren();}},};return __exports;});;

/* /knowledge/static/src/editor/html_migrations/utils.js */
odoo.define('@knowledge/editor/html_migrations/utils',[],function(require){'use strict';let __exports={};__exports.decodeDataBehaviorProps=decodeDataBehaviorProps;function decodeDataBehaviorProps(dataBehaviorPropsAttribute){if(!dataBehaviorPropsAttribute){return undefined;}
return JSON.parse(decodeURIComponent(dataBehaviorPropsAttribute));}
__exports.getPropNameNode=getPropNameNode;function getPropNameNode(propName,anchor){const propNodes=anchor.querySelectorAll(`[data-prop-name="${propName}"]`);for(let i=propNodes.length-1;i>=0;i--){const closest=propNodes[i].closest(".o_knowledge_behavior_anchor");if(closest===anchor){return propNodes[i];}}}
__exports.uuid=uuid;function uuid(){const array=new Uint8Array(8);window.crypto.getRandomValues(array);return[...array].map((b)=>b.toString(16).padStart(2,"0")).join("");}
return __exports;});;

/* /knowledge/static/src/editor/plugin_sets.js */
odoo.define('@knowledge/editor/plugin_sets',['@html_editor/plugin_sets','@knowledge/editor/plugins/autofocus_plugin/autofocus_plugin','@knowledge/editor/plugins/article_plugin/article_plugin','@knowledge/editor/plugins/comments_plugin/comments_plugin','@knowledge/editor/embedded_components/plugins/article_index_plugin/article_index_plugin','@knowledge/editor/embedded_components/plugins/embedded_clipboard_plugin/embedded_clipboard_plugin','@knowledge/editor/embedded_components/plugins/embedded_view_plugin/embedded_view_plugin','@knowledge/editor/plugins/insert_pending_element_plugin/insert_pending_element_plugin','@html_editor/others/embedded_components/plugins/embedded_file_plugin/embedded_file_plugin'],function(require){'use strict';let __exports={};const{MAIN_PLUGINS}=require("@html_editor/plugin_sets");const{AutofocusPlugin}=require("@knowledge/editor/plugins/autofocus_plugin/autofocus_plugin");const{KnowledgeArticlePlugin}=require("@knowledge/editor/plugins/article_plugin/article_plugin");const{KnowledgeCommentsPlugin}=require("@knowledge/editor/plugins/comments_plugin/comments_plugin");const{ArticleIndexPlugin}=require("@knowledge/editor/embedded_components/plugins/article_index_plugin/article_index_plugin");const{EmbeddedClipboardPlugin}=require("@knowledge/editor/embedded_components/plugins/embedded_clipboard_plugin/embedded_clipboard_plugin");const{EmbeddedViewPlugin}=require("@knowledge/editor/embedded_components/plugins/embedded_view_plugin/embedded_view_plugin");const{InsertPendingElementPlugin}=require("@knowledge/editor/plugins/insert_pending_element_plugin/insert_pending_element_plugin");const{EmbeddedFilePlugin}=require("@html_editor/others/embedded_components/plugins/embedded_file_plugin/embedded_file_plugin");MAIN_PLUGINS.push(KnowledgeArticlePlugin);const KNOWLEDGE_PLUGINS=__exports.KNOWLEDGE_PLUGINS=[AutofocusPlugin,InsertPendingElementPlugin,KnowledgeCommentsPlugin,];const KNOWLEDGE_EMBEDDED_COMPONENT_PLUGINS=__exports.KNOWLEDGE_EMBEDDED_COMPONENT_PLUGINS=[ArticleIndexPlugin,EmbeddedClipboardPlugin,EmbeddedViewPlugin,EmbeddedFilePlugin,];return __exports;});;

/* /knowledge/static/src/editor/plugins/article_plugin/article_plugin.js */
odoo.define('@knowledge/editor/plugins/article_plugin/article_plugin',['@html_editor/plugin','@html_editor/utils/position','@knowledge/components/article_selection_dialog/article_selection_dialog','@web/core/l10n/translation','@web/core/utils/render'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{rightPos}=require("@html_editor/utils/position");const{ArticleSelectionDialog}=require("@knowledge/components/article_selection_dialog/article_selection_dialog");const{_t}=require("@web/core/l10n/translation");const{renderToElement}=require("@web/core/utils/render");const ARTICLE_LINKS_SELECTOR=".o_knowledge_article_link";const KnowledgeArticlePlugin=__exports.KnowledgeArticlePlugin=class KnowledgeArticlePlugin extends Plugin{static id="article";static dependencies=["history","dom","selection","dialog"];resources={user_commands:[{id:"insertArticle",title:_t("Article"),description:_t("Insert an Article shortcut"),icon:"fa-newspaper-o",run:this.addArticle.bind(this),},],powerbox_items:[{categoryId:"navigation",commandId:"insertArticle",},],clean_for_save_handlers:this.cleanForSave.bind(this),normalize_handlers:this.normalize.bind(this),};setup(){super.setup();this.boundOpenArticle=this.openArticle.bind(this);}
addArticle(){const recordInfo=this.config.getRecordInfo();let parentArticleId;if(recordInfo.resModel==="knowledge.article"&&recordInfo.resId){parentArticleId=recordInfo.resId;}
this.dependencies.dialog.addDialog(ArticleSelectionDialog,{title:_t("Link an Article"),confirmLabel:_t("Insert Link"),articleSelected:(article)=>{const articleLinkBlock=renderToElement("knowledge.ArticleBlueprint",{href:`/knowledge/article/${article.articleId}`,articleId:article.articleId,displayName:article.displayName,});this.dependencies.dom.insert(articleLinkBlock);this.dependencies.history.addStep();const[anchorNode,anchorOffset]=rightPos(articleLinkBlock);this.dependencies.selection.setSelection({anchorNode,anchorOffset});},parentArticleId,});}
scanForArticleLinks(element){const articleLinks=[...element.querySelectorAll(ARTICLE_LINKS_SELECTOR)];if(element.matches(ARTICLE_LINKS_SELECTOR)){articleLinks.unshift(element);}
return articleLinks;}
async openArticle(ev){if(this.config.embeddedComponentInfo?.env?.openArticle){const articleId=parseInt(ev.target.dataset.res_id);if(articleId){ev.preventDefault();await this.config.embeddedComponentInfo.env.openArticle(articleId);}}}
normalize(element){const articleLinks=this.scanForArticleLinks(element);for(const articleLink of articleLinks){articleLink.setAttribute("target","_blank");articleLink.setAttribute("contenteditable","false");articleLink.addEventListener("click",this.boundOpenArticle);}}
cleanForSave({root}){const articleLinks=this.scanForArticleLinks(root);for(const articleLink of articleLinks){articleLink.removeAttribute("contenteditable");}}
destroy(){super.destroy();const articleLinks=this.scanForArticleLinks(this.editable);for(const articleLink of articleLinks){articleLink.removeEventListener("click",this.boundOpenArticle);}}}
return __exports;});;

/* /knowledge/static/src/editor/plugins/autofocus_plugin/autofocus_plugin.js */
odoo.define('@knowledge/editor/plugins/autofocus_plugin/autofocus_plugin',['@html_editor/plugin','@html_editor/utils/dom_info'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{paragraphRelatedElementsSelector}=require("@html_editor/utils/dom_info");const AutofocusPlugin=__exports.AutofocusPlugin=class AutofocusPlugin extends Plugin{static id="autofocus";static dependencies=["selection"];resources={start_edition_handlers:this.focusFirstElement.bind(this),};focusFirstElement(){for(const paragraph of this.editable.querySelectorAll(paragraphRelatedElementsSelector)){if(paragraph.isContentEditable){const{anchorNode,anchorOffset,focusNode,focusOffset}=this.dependencies.selection.setSelection({anchorNode:paragraph,anchorOffset:0,});const selectionData=this.dependencies.selection.getSelectionData();if(!selectionData.documentSelectionIsInEditable){const selection=this.document.getSelection();selection.setBaseAndExtent(anchorNode,anchorOffset,focusNode,focusOffset);}
break;}}}}
return __exports;});;

/* /knowledge/static/src/editor/plugins/comments_plugin/comments_plugin.js */
odoo.define('@knowledge/editor/plugins/comments_plugin/comments_plugin',['@html_editor/plugin','@html_editor/utils/position','@web/core/utils/render','@knowledge/comments/comment_beacon_manager','@web/core/registry','@knowledge/comments/comments_handler/comments_handler','@web/core/l10n/translation','@html_editor/utils/dom_traversal','@html_editor/utils/selection','@html_editor/utils/dom','@html_editor/utils/dom_info','@web/core/utils/functions','@web/core/utils/reactive','@web/core/utils/timing','@html_editor/utils/resource'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{leftPos,rightPos,nodeSize}=require("@html_editor/utils/position");const{renderToElement}=require("@web/core/utils/render");const{CommentBeaconManager}=require("@knowledge/comments/comment_beacon_manager");const{registry}=require("@web/core/registry");const{KnowledgeCommentsHandler}=require("@knowledge/comments/comments_handler/comments_handler");const{_t}=require("@web/core/l10n/translation");const{closestElement,childNodes}=require("@html_editor/utils/dom_traversal");const{callbacksForCursorUpdate}=require("@html_editor/utils/selection");const{fillEmpty}=require("@html_editor/utils/dom");const{isParagraphRelatedElement,isPhrasingContent,isContentEditable,isZwnbsp,isListItemElement,}=require("@html_editor/utils/dom_info");const{uniqueId}=require("@web/core/utils/functions");const{effect}=require("@web/core/utils/reactive");const{batched}=require("@web/core/utils/timing");const{withSequence}=require("@html_editor/utils/resource");function isAllowedBeaconPosition(node){return isPhrasingContent(node)||isParagraphRelatedElement(node)||isListItemElement(node);}
const KnowledgeCommentsPlugin=__exports.KnowledgeCommentsPlugin=class KnowledgeCommentsPlugin extends Plugin{static id="knowledgeComments";static dependencies=["history","dom","protectedNode","selection","position","localOverlay","linkSelection","format","delete",];resources={user_commands:[{id:"addComments",icon:"fa-commenting",run:this.addCommentToSelection.bind(this),},],toolbar_groups:[withSequence(60,{id:"knowledge",}),withSequence(60,{id:"knowledge_image",namespace:"image",}),],toolbar_items:[{id:"comments",groupId:"knowledge",commandId:"addComments",title:_t("Add a comment to selection"),text:_t("Comment"),},{id:"comments_image",groupId:"knowledge_image",commandId:"addComments",title:_t("Add a comment to an image"),text:_t("Comment"),},],layout_geometry_change_handlers:()=>{this.commentBeaconManager?.drawThreadOverlays();this.config.onLayoutGeometryChange();},selectionchange_handlers:(selectionData)=>{if(!selectionData.documentSelectionIsInEditable||!selectionData.editableSelection||selectionData.documentSelectionIsProtected||selectionData.documentSelectionIsProtecting){return;}
const editableSelection=selectionData.editableSelection;const target=editableSelection.anchorNode.nodeType===Node.TEXT_NODE?editableSelection.anchorNode:childNodes(editableSelection.anchorNode).at(editableSelection.anchorOffset);if(!target||!target.isConnected){return;}
this.commentBeaconManager.activateRelatedThread(target);},restore_savepoint_handlers:this.updateBeacons.bind(this),history_reset_handlers:()=>this.updateBeacons(),history_reset_from_steps_handlers:this.updateBeacons.bind(this),step_added_handlers:()=>this.commentBeaconManager.drawThreadOverlays(),external_step_added_handlers:this.updateBeacons.bind(this),clean_for_save_handlers:this.cleanForSave.bind(this),normalize_handlers:this.normalize.bind(this),delete_forward_overrides:withSequence(1,this.handleDeleteForward.bind(this)),delete_backward_overrides:withSequence(1,this.handleDeleteBackward.bind(this)),intangible_char_for_keyboard_navigation_predicates:this.arrowShouldSkip.bind(this),};setup(){this.peerId=this.config.collaboration?.peerId??"";this.commentsService=this.services["knowledge.comments"];this.commentsState=this.commentsService.getCommentsState();let previousActiveThreadId;this.alive=true;effect(batched((state)=>{if(!this.alive){return;}
if(previousActiveThreadId===state.activeThreadId){return;}
if(previousActiveThreadId!=="undefined"&&state.activeThreadId==="undefined"){this.commentBeaconManager.pendingBeacons=new Set();}else if(previousActiveThreadId==="undefined"){this.commentBeaconManager.sortThreads();if(this.commentBeaconManager.bogusBeacons.size){this.commentBeaconManager.removeBogusBeacons();this.dependencies.history.addStep();}
this.commentBeaconManager.drawThreadOverlays();}
previousActiveThreadId=state.activeThreadId;}),[this.commentsState]);this.localOverlay=this.dependencies.localOverlay.makeLocalOverlay("KnowledgeThreadBeacons");this.commentBeaconManager=new CommentBeaconManager({document:this.document,source:this.editable,overlayContainer:this.localOverlay,commentsState:this.commentsState,peerId:this.peerId,removeBeacon:this.removeBeacon.bind(this),setSelection:this.dependencies.selection.setSelection,onStep:()=>{this.dependencies.history.addStep();},});this.addDomListener(window,"click",this.onWindowClick.bind(this));this.overlayComponentsKey=uniqueId("KnowledgeCommentsHandler");registry.category(this.config.localOverlayContainers.key).add(this.overlayComponentsKey,{Component:KnowledgeCommentsHandler,props:{commentBeaconManager:this.commentBeaconManager,contentRef:{el:this.editable,},},},{force:true});}
arrowShouldSkip(ev,char,lastSkipped){if(char!==undefined||lastSkipped!=="\uFEFF"){return;}
const selection=this.document.getSelection();if(!selection){return;}
const{anchorNode,focusNode}=selection;if(!this.editable.contains(anchorNode)||(focusNode!==anchorNode&&!this.editable.contains(focusNode))){return;}
const screenDirection=ev.key==="ArrowLeft"?"left":"right";const isRtl=closestElement(focusNode,"[dir]")?.dir==="rtl";const domDirection=(screenDirection==="left")^isRtl?"previous":"next";let targetNode;let targetOffset;const range=selection.getRangeAt(0);if(ev.shiftKey){targetNode=selection.focusNode;targetOffset=selection.focusOffset;}else{if(domDirection==="previous"){targetNode=range.startContainer;targetOffset=range.startOffset;}else{targetNode=range.endContainer;targetOffset=range.endOffset;}}
if(domDirection==="previous"){const beacon=this.identifyPreviousBeacon({endContainer:targetNode,endOffset:targetOffset,});return beacon&&this.commentBeaconManager.isDisabled(beacon);}else{const beacon=this.identifyNextBeacon({startContainer:targetNode,startOffset:targetOffset,});return beacon&&this.commentBeaconManager.isDisabled(beacon);}}
identifyNextBeacon(range){const{startContainer,startOffset}=range;if(startContainer.nodeType!==Node.TEXT_NODE){return;}
let container;if(isZwnbsp(startContainer)){container=startContainer;}else if(startOffset===nodeSize(startContainer)&&startContainer.nextSibling?.nodeType===Node.TEXT_NODE&&isZwnbsp(startContainer.nextSibling)){container=startContainer.nextSibling;}
if(container){const[anchorNode,anchorOffset]=rightPos(container);const target=childNodes(anchorNode).at(anchorOffset);if(target?.matches?.(".oe_thread_beacon")){return target;}}}
identifyPreviousBeacon(range){const{endContainer,endOffset}=range;if(endContainer.nodeType!==Node.TEXT_NODE){return;}
let container;if(isZwnbsp(endContainer)){container=endContainer;}else if(endOffset===0&&endContainer.previousSibling?.nodeType===Node.TEXT_NODE&&isZwnbsp(endContainer.previousSibling)){container=endContainer.previousSibling;}
if(container){const[anchorNode,anchorOffset]=leftPos(container);if(anchorOffset===0){return;}
const target=childNodes(anchorNode).at(anchorOffset-1);if(target?.matches?.(".oe_thread_beacon")){return target;}}}
handleDeleteForward(range){const target=this.identifyNextBeacon(range);if(target){const[anchorNode,anchorOffset]=rightPos(target);this.dependencies.selection.setSelection({anchorNode,anchorOffset,});this.dependencies.delete.delete("forward","character");return true;}}
handleDeleteBackward(range){const target=this.identifyPreviousBeacon(range);if(target){const[anchorNode,anchorOffset]=leftPos(target);this.dependencies.selection.setSelection({anchorNode,anchorOffset,});this.dependencies.delete.delete("backward","character");return true;}}
addCommentToSelection(){const{startContainer,startOffset,endContainer,endOffset}=this.dependencies.selection.getEditableSelection({deep:true});const isCollapsed=startContainer===endContainer&&startOffset===endOffset;if(isCollapsed||!isAllowedBeaconPosition(startContainer)||!isAllowedBeaconPosition(endContainer)||!isContentEditable(startContainer)||!isContentEditable(endContainer)){return;}
const previousUndefinedBeacons=[...this.editable.querySelectorAll(".oe_thread_beacon[data-id='undefined']"),];this.commentBeaconManager.pendingBeacons=new Set();const endBeacon=renderToElement("knowledge.threadBeacon",{threadId:"undefined",type:"threadBeaconEnd",recordId:this.commentsState.articleId,recordModel:"knowledge.article",peerId:this.peerId,});this.dependencies.selection.setSelection({anchorNode:endContainer,anchorOffset:endOffset,});this.commentBeaconManager.pendingBeacons.add(endBeacon);this.dependencies.dom.insert(endBeacon);const startBeacon=renderToElement("knowledge.threadBeacon",{threadId:"undefined",type:"threadBeaconStart",recordId:this.commentsState.articleId,recordModel:"knowledge.article",peerId:this.peerId,});this.dependencies.selection.setSelection({anchorNode:startContainer,anchorOffset:startOffset,});this.commentBeaconManager.pendingBeacons.add(startBeacon);this.dependencies.dom.insert(startBeacon);this.commentBeaconManager.cleanupThread("undefined");for(const beacon of previousUndefinedBeacons){this.removeBeacon(beacon);}
const[anchorNode,anchorOffset]=rightPos(startBeacon);this.dependencies.selection.setSelection({anchorNode,anchorOffset,});this.commentsState.displayMode="handler";this.commentsService.createVirtualThread();this.commentsState.activeThreadId="undefined";this.dependencies.history.addStep();}
onWindowClick(ev){const selector=`.oe-local-overlay, .o_knowledge_comment_box, .o-we-toolbar, .o-overlay-container`;const closestElement=ev.target.closest(selector);if(!closestElement&&!this.editable.contains(ev.target)){this.commentsState.activeThreadId=undefined;}}
normalize(elem){this.commentBeaconManager.sortThreads();this.commentBeaconManager.removeBogusBeacons();for(const beacon of elem.querySelectorAll(".oe_thread_beacon")){if(beacon.isConnected&&!isAllowedBeaconPosition(beacon.parentElement)){this.commentBeaconManager.cleanupBeaconPair(beacon.dataset.id);this.removeBeacon(beacon);continue;}
this.dependencies.linkSelection.padLinkWithZwnbsp(beacon);this.dependencies.protectedNode.setProtectingNode(beacon,true);}}
cleanZwnbsp(beacon){if(!beacon.isConnected){return;}
const cursors=this.dependencies.selection.preserveSelection();if(isZwnbsp(beacon.previousSibling)&&beacon.previousSibling.previousSibling?.nodeName!=="A"){cursors.update(callbacksForCursorUpdate.remove(beacon.previousSibling));beacon.previousSibling.remove();}
if(isZwnbsp(beacon.nextSibling)&&beacon.nextSibling.nextSibling?.nodeName!=="A"){cursors.update(callbacksForCursorUpdate.remove(beacon.nextSibling));beacon.nextSibling.remove();}
cursors.restore();}
removeBeacon(beacon){if(!beacon.isConnected){return;}
this.cleanZwnbsp(beacon);const cursors=this.dependencies.selection.preserveSelection();const parent=beacon.parentElement;cursors.update(callbacksForCursorUpdate.remove(beacon));beacon.remove();cursors.restore();fillEmpty(parent);this.dependencies.format.mergeAdjacentInlines(parent);}
updateBeacons(){this.commentBeaconManager.sortThreads();this.commentBeaconManager.drawThreadOverlays();}
destroy(){super.destroy();this.alive=false;registry.category(this.config.localOverlayContainers.key).remove(this.overlayComponentsKey);this.commentBeaconManager.destroy();this.localOverlay.remove();}
cleanForSave({root}){const bogusIds=new Set(["undefined"]);for(const beacon of this.commentBeaconManager.bogusBeacons){bogusIds.add(beacon.dataset.id);}
for(const beacon of root.querySelectorAll(".oe_thread_beacon")){if(bogusIds.has(beacon.dataset.id)){beacon.remove();}else{beacon.replaceChildren();delete beacon.dataset.peerId;}}}}
return __exports;});;

/* /knowledge/static/src/editor/plugins/insert_pending_element_plugin/insert_pending_element_plugin.js */
odoo.define('@knowledge/editor/plugins/insert_pending_element_plugin/insert_pending_element_plugin',['@html_editor/plugin','@html_editor/utils/dom_info'],function(require){'use strict';let __exports={};const{Plugin}=require("@html_editor/plugin");const{isPhrasingContent}=require("@html_editor/utils/dom_info");const InsertPendingElementPlugin=__exports.InsertPendingElementPlugin=class InsertPendingElementPlugin extends Plugin{static id="insertPendingElement";static dependencies=["baseContainer","history","dom","selection"];resources={start_edition_handlers:this.insertEmbeddedBluePrint.bind(this),};insertEmbeddedBluePrint(){const{resModel,resId}=this.config.getRecordInfo();const embeddedBlueprint=this.services.knowledgeCommandsService.popPendingEmbeddedBlueprint({field:"body",resId,model:resModel,});if(embeddedBlueprint){let insert;if(isPhrasingContent(embeddedBlueprint)){insert=()=>{const paragraph=this.dependencies.baseContainer.createBaseContainer();paragraph.appendChild(embeddedBlueprint);this.dependencies.selection.setCursorEnd(this.editable);this.dependencies.dom.insert(paragraph);this.dependencies.history.addStep();};}else{insert=()=>{this.dependencies.selection.setCursorEnd(this.editable);this.dependencies.dom.insert(embeddedBlueprint);const paragraph=this.dependencies.baseContainer.createBaseContainer();paragraph.appendChild(document.createElement("br"));this.dependencies.selection.setCursorEnd(this.editable);this.dependencies.dom.insert(paragraph);this.dependencies.history.addStep();};}
insert();this.editable.addEventListener("onHistoryResetFromPeer",insert,{once:true});}}}
return __exports;});;

/* /knowledge/static/src/comments/comment/comment.js */
odoo.define('@knowledge/comments/comment/comment',['@web/core/user','@web/core/utils/hooks','@web/core/popover/popover_hook','@mail/core/common/composer','@knowledge/mail/thread/knowledge_thread','@web/core/utils/scrolling','@web/core/browser/feature_detection','@knowledge/comments/comments_popover/comments_popover','@knowledge/mail/composer/composer','@knowledge/comments/comment/comment_anchor_text','@web/core/utils/urls','@odoo/owl','@web/core/utils/reactive','@web/core/utils/timing'],function(require){'use strict';let __exports={};const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{usePopover}=require("@web/core/popover/popover_hook");const{Composer}=require("@mail/core/common/composer");const{KnowledgeThread}=require("@knowledge/mail/thread/knowledge_thread");const{scrollTo}=require("@web/core/utils/scrolling");const{isBrowserChrome}=require("@web/core/browser/feature_detection");const{KnowledgeCommentsPopover}=require("@knowledge/comments/comments_popover/comments_popover");const{KnowledgeCommentCreatorComposer}=require("@knowledge/mail/composer/composer");const{CommentAnchorText}=require("@knowledge/comments/comment/comment_anchor_text");const{imageUrl}=require("@web/core/utils/urls");const{Component,onWillStart,useSubEnv,useRef,useEffect,useState,onWillDestroy,}=require("@odoo/owl");const{effect}=require("@web/core/utils/reactive");const{batched}=require("@web/core/utils/timing");const DEFAULT_ANCHOR_TEXT_SIZE=50;const MIN_THREAD_WIDTH=__exports.MIN_THREAD_WIDTH=300;const KnowledgeCommentsThread=__exports.KnowledgeCommentsThread=class KnowledgeCommentsThread extends Component{static components={CommentAnchorText,Composer,KnowledgeThread,KnowledgeCommentCreatorComposer,};static props={threadId:{type:String},horizontalDimensions:{type:Object,optional:true},top:{type:Number,optional:true},readonly:{type:Boolean,optional:true},};static template="knowledge.KnowledgeCommentsThread";setup(){this.commentsService=useService("knowledge.comments");this.threadScrollableRef=useRef("threadScrollableRef");this.targetRef=useRef("targetRef");this.composerRef=useRef("composerRef");this.commentsState=useState(this.commentsService.getCommentsState());let previousThreadId;this.alive=true;effect(batched((state)=>{if(!this.alive){return;}
if(previousThreadId!==state.activeThreadId){if(previousThreadId===this.props.threadId&&this.editorThread){this.editorThread.onActivate(new CustomEvent("knowledge.deactivateThread"));}
previousThreadId=state.activeThreadId;}}),[this.commentsState]);onWillDestroy(()=>{this.alive=false;});this.state=useState({hasFullAnchorText:false,});useSubEnv({inChatter:false,chatter:false,closeThread:this.updateResolveState.bind(this,true),inKnowledge:true,isResolved:this.isResolved.bind(this),openThread:this.updateResolveState.bind(this,false),});this.popover=usePopover(KnowledgeCommentsPopover,{closeOnClickAway:true,onClose:()=>{this.onClosePopover();},env:this.env,position:"left-start",popoverClass:"o_knowledge_comments_popover",});const onActivate=(ev)=>{switch(ev.type){case"click":this.activateThread();break;case"knowledge.deactivateThread":this.focusOut();break;}};const onFocus=(ev)=>{switch(ev.type){case"mouseenter":this.focusIn();break;case"mouseleave":this.focusOut();break;}};useEffect(()=>{const editorThread=this.editorThread;if(editorThread){editorThread.onActivateMap.set("main",onActivate);editorThread.onFocusMap.set("main",onFocus);}
return()=>{if(editorThread){editorThread.onActivateMap.delete(onActivate);editorThread.onFocusMap.delete(onFocus);}};},()=>[this.editorThread]);let wasActive;useEffect(()=>{if(this.isActive&&!wasActive&&!this.smallUI){const scrollable=this.threadScrollableRef.el;const composer=this.composerRef.el;if(scrollable&&composer){const composerRect=composer.getBoundingClientRect();scrollable.scrollBy({top:composerRect.height,});}}
if(this.isActive!==wasActive){wasActive=this.isActive;}},()=>[this.isActive,this.smallUI]);if(this.commentsState.displayMode==="handler"){const setTargetHeight=(target)=>{const targetRect=target.getBoundingClientRect();if(!(this.props.threadId in this.env.threadHeights)){this.env.threadHeights[this.props.threadId]={height:undefined,};}
this.env.threadHeights[this.props.threadId].height=targetRect.height;};useEffect(()=>{if(this.targetRef.el){const observer=new ResizeObserver((entries)=>{for(const entry of entries){if(entry.target){setTargetHeight(entry.target);}}});observer.observe(this.targetRef.el);setTargetHeight(this.targetRef.el);return()=>observer.disconnect();}},()=>[this.targetRef.el]);useEffect(()=>{if(this.editorThread&&this.editorThread.threadId==="undefined"&&this.targetRef.el&&this.isActive&&this.smallUI){this.openPopover();}},()=>[this.targetRef.el,this.isActive,this.smallUI,this.editorThread]);useEffect(()=>{if(!this.smallUI&&this.popover.isOpen){this.popover.close();}},()=>[this.smallUI]);}
if(this.props.threadId==="undefined"){onWillStart(()=>{this.commentsService.loadThreads([this.props.threadId]);});}else{useEffect(()=>{if(!(this.props.threadId in this.commentsState.threadRecords)){this.commentsService.loadRecords(this.env.model.root.resId,{threadId:this.props.threadId,});}},()=>[this.commentsState.articleId,this.commentsState.displayMode]);useEffect(()=>{if(this.props.threadId in this.commentsState.threadRecords&&!(this.props.threadId in this.commentsState.threads)){this.commentsService.loadThreads([this.props.threadId]);this.thread.knowledgePreLoading=true;this.thread.fetchNewMessages().then(()=>{if(this.editorThread?.isProtected()){return;}
let isEmpty=true;for(const message of this.thread.messages){if(message.message_type==="comment"&&message.body.toString()){isEmpty=false;break;}}
if(isEmpty){this.commentsService.deleteThread(this.props.threadId);}});this.thread.knowledgePreLoading=false;}},()=>[this.threadRecord]);}
onWillDestroy(()=>{if(this.isActive){this.commentsState.activeThreadId=undefined;}
this.commentsState.focusedThreads.delete(this.props.threadId);});}
get hasLoaded(){return(this.props.threadId==="undefined"||(this.props.threadId in this.commentsState.threadRecords&&this.props.threadId in this.commentsState.threads));}
get hasAllDimensions(){return(this.props.top!==undefined&&this.props.horizontalDimensions!==undefined&&this.props.horizontalDimensions.left!==undefined&&this.props.horizontalDimensions.width!==undefined);}
get style(){if(this.commentsState.displayMode==="panel"){return"";}
return`
            position: absolute;
            top: ${this.props.top}px;
            left: ${this.props.horizontalDimensions.left}px;
            width: ${this.props.horizontalDimensions.width}px;
            transition: top 0.3s, left 0.2s, filter 0.2s;
            z-index: ${this.isActive ? 1 : "auto"};
            filter: ${
                !this.smallUI ||
                this.hasFocus ||
                (!this.commentsState.activeThreadId && !this.commentsState.focusedThreads.size)
                    ? "none"
                    : "grayscale(50%) contrast(50%)"
            };
        `;}
get editorThread(){return this.commentsState.editorThreads[this.props.threadId];}
get authorUrl(){if(this.thread?.messages?.length){return this.thread.messages.at(-1).author.avatarUrl;}
return imageUrl("res.users",user.userId,"avatar_128");}
get anchorText(){let text=this.fullAnchorText;const brIndex=text.indexOf("<br>");const excludeIndex=brIndex===-1?DEFAULT_ANCHOR_TEXT_SIZE:brIndex;if(text.length>excludeIndex){text=text.substring(0,excludeIndex)+"...";}
return text;}
get fullAnchorText(){let text;if(!this.editorThread){text=this.threadRecord?.article_anchor_text||"";}else{text=this.editorThread.anchorText;}
return text.replaceAll("\n","<br>");}
get hasFocus(){return this.commentsState.hasFocus(this.props.threadId);}
get isActive(){return this.commentsState.activeThreadId===this.props.threadId;}
get showReadMore(){const anchorText=this.anchorText;const fullAnchorText=this.fullAnchorText;return fullAnchorText.length>0&&anchorText.length!==fullAnchorText.length;}
get thread(){return this.commentsState.threads[this.props.threadId];}
get threadRecord(){return this.commentsState.threadRecords[this.props.threadId];}
get smallUI(){return(this.commentsState.displayMode==="handler"&&this.props.horizontalDimensions.width<MIN_THREAD_WIDTH);}
activateThread(){this.commentsState.activeThreadId=this.props.threadId;if(this.smallUI){this.openPopover();}}
isResolved(){if(this.props.threadId==="undefined"){return false;}
return this.threadRecord.is_resolved;}
onClick(ev){if(this.editorThread){this.editorThread.onActivate(ev);}else{this.activateThread();}}
focusIn(){this.commentsState.focusedThreads.add(this.props.threadId);}
focusOut(){this.commentsState.focusedThreads.delete(this.props.threadId);}
onMouseEnter(ev){if(this.editorThread){this.editorThread.onFocus(ev);}else{this.focusIn();}}
onMouseLeave(ev){if(this.editorThread){this.editorThread.onFocus(ev);}else{this.focusOut();}}
openPopover(){if(!this.popover.isOpen){const popoverProps={threadId:this.props.threadId,};if(this.targetRef.el){this.popover.open(this.targetRef.el,popoverProps);}}}
onClosePopover(){this.focusOut();}
showEditorAnchor(){if(!this.editorThread){return;}
if(isBrowserChrome()){scrollTo(this.editorThread.beaconPair.start,{behavior:"smooth",});}else{this.editorThread.beaconPair.start.scrollIntoView({behavior:"smooth",block:"center",});}}
async updateResolveState(value){const changed=await this.commentsService.updateResolveState(this.props.threadId,value);if(changed&&this.commentsState.displayMode==="panel"){await this.thread.fetchNewMessages();}}
onCreateThreadCallback(thread){if(thread){this.commentsState.editorThreads[thread.id]?.select();}}}
return __exports;});;

/* /knowledge/static/src/comments/comment/comment_anchor_text.js */
odoo.define('@knowledge/comments/comment/comment_anchor_text',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,onWillUpdateProps}=require("@odoo/owl");const CommentAnchorText=__exports.CommentAnchorText=class CommentAnchorText extends Component{static template="knowledge.CommentAnchorText";static props={anchorText:{String},};setup(){this.anchorTextArray=this.props.anchorText.split("<br>");onWillUpdateProps((newProps)=>{this.anchorTextArray=newProps.anchorText.split("<br>");});}}
return __exports;});;

/* /knowledge/static/src/comments/comment_beacon_manager.js */
odoo.define('@knowledge/comments/comment_beacon_manager',['@html_editor/utils/position','@knowledge/comments/editor_thread_info','@web/core/utils/timing','@html_editor/utils/dom_traversal'],function(require){'use strict';let __exports={};const{leftPos,rightPos}=require("@html_editor/utils/position");const{EditorThreadInfo}=require("@knowledge/comments/editor_thread_info");const{throttleForAnimation}=require("@web/core/utils/timing");const{childNodes}=require("@html_editor/utils/dom_traversal");function binarySearch(comparator,needle,array){let first=0;let last=array.length-1;while(first<=last){const mid=(first+last)>>1;const c=comparator(needle,array[mid]);if(c>0){first=mid+1;}else if(c<0){last=mid-1;}else{return mid;}}
return first;}
__exports.compareDOMPosition=compareDOMPosition;function compareDOMPosition(a,b){const compare=a.compareDocumentPosition(b);if(compare&2){return 1;}else if(compare&4){return-1;}else{return 0;}}
__exports.compareBeaconsThreadIds=compareBeaconsThreadIds;function compareBeaconsThreadIds(a,b){const id=(beacon)=>parseInt(beacon.dataset.id)||-1;const bound=(beacon)=>(beacon.dataset.oeType==="threadBeaconStart"?0:1);const idA=id(a);const boundA=bound(a);const idB=id(b);const boundB=bound(b);if(idA>idB){return 1;}else if(idB>idA){return-1;}else if(boundA>boundB){return 1;}else if(boundB>boundA){return-1;}else{return 0;}}
const CommentBeaconManager=__exports.CommentBeaconManager=class CommentBeaconManager{constructor({commentsState,document,overlayContainer,peerId,readonly=false,source,onStep=()=>{},removeBeacon=()=>{},setSelection=()=>{},}={}){this.document=document;this.source=source;this.overlayContainer=overlayContainer;this.beacons=[];this.searchBeaconIndex=binarySearch.bind(undefined,compareDOMPosition);this.beaconsByThreadId=[];this.searchBeaconIndexByThreadId=binarySearch.bind(undefined,compareBeaconsThreadIds);this.bogusBeacons=new Set();this.beaconPairs={};this.sortedThreadIds=[];this.cleanups={};this.peerId=peerId;this.readonly=readonly;this.commentsState=commentsState;this.onStep=onStep;this.removeBeacon=removeBeacon;this.setSelection=setSelection;this.drawThreadOverlays=throttleForAnimation(this.drawThreadOverlays.bind(this));this.pendingBeacons=new Set();}
addBeacons(beacons){for(const beacon of beacons){const index=this.searchBeaconIndex(beacon,this.beacons);this.beacons.splice(index,0,beacon);}}
deleteBeacons(beacons){for(const beacon of beacons){const index=this.searchBeaconIndex(beacon,this.beacons);this.beacons.splice(index,1);}}
sortThreads(){this.beacons=[...this.source.querySelectorAll(".oe_thread_beacon")];this.beaconsByThreadId=this.beacons.toSorted(compareBeaconsThreadIds);const starts={};const beaconPairs={};this.bogusBeacons=new Set();for(const beacon of[...this.beacons]){if(beacon.dataset.oeType==="threadBeaconStart"){if(beacon.dataset.id!=="undefined"||beacon.dataset.peerId===this.peerId){starts[beacon.dataset.id]={start:beacon,};}
this.bogusBeacons.add(beacon);}else if(beacon.dataset.id in starts){const beaconPair=starts[beacon.dataset.id];delete starts[beacon.dataset.id];beaconPair.end=beacon;if(!this.validate(beaconPair)){this.bogusBeacons.add(beaconPair.end);}else{this.preserveExistingBeaconPair(beaconPair);this.removeDuplicate(beaconPair.start);this.removeDuplicate(beaconPair.end);this.bogusBeacons.delete(beaconPair.start);beaconPairs[beacon.dataset.id]=beaconPair;}}else{this.bogusBeacons.add(beacon);}}
for(const beacon of[...this.bogusBeacons]){if(beacon.dataset.id==="undefined"&&beacon.dataset.peerId!==this.peerId){this.bogusBeacons.delete(beacon);}}
for(const beacon of this.pendingBeacons){this.bogusBeacons.delete(beacon);}
const threadIds=new Set(Object.keys(beaconPairs));for(const threadId of Object.keys(this.beaconPairs)){if(!threadIds.has(threadId)){this.cleanupThread(threadId);}}
const threadIdsToSort=[];for(const threadId of threadIds){if(!(threadId in this.beaconPairs)){this.beaconPairs[threadId]=beaconPairs[threadId];}else{if(this.beaconPairs[threadId].start!==beaconPairs[threadId].start){this.beaconPairs[threadId].start=beaconPairs[threadId].start;}
if(this.beaconPairs[threadId].end!==beaconPairs[threadId].end){this.beaconPairs[threadId].end=beaconPairs[threadId].end;}}
let editorThread=this.commentsState.editorThreads[threadId]||this.commentsState.disabledEditorThreads[threadId];if(!editorThread){editorThread=new EditorThreadInfo({beaconPair:this.beaconPairs[threadId],threadId,computeTextMap:this.computeTextMap.bind(this),removeBeaconPair:(beaconPair)=>{this.cleanupThread(beaconPair.start.dataset.id);this.removeBeacon(beaconPair.start);this.removeBeacon(beaconPair.end);this.onStep();},setSelectionInBeaconPair:(beaconPair)=>{if(this.validate(beaconPair)){const[anchorNode,anchorOffset]=rightPos(beaconPair.start);this.setSelection({anchorNode,anchorOffset,});}},setBeaconPairId:(beaconPair,id)=>{beaconPair.start.dataset.id=id;beaconPair.end.dataset.id=id;this.onStep();},enableBeaconPair:(beaconPair)=>{if(this.isDisabled(beaconPair.start)){this.enable(beaconPair.start);}
if(this.isDisabled(beaconPair.end)){this.enable(beaconPair.end);}
const threadId=beaconPair.start.dataset.id;const editorThread=this.commentsState.disabledEditorThreads[threadId];if(editorThread){this.commentsState.editorThreads[threadId]=editorThread;delete this.commentsState.disabledEditorThreads[threadId];}
this.onStep();},disableBeaconPair:(beaconPair)=>{if(!this.isDisabled(beaconPair.start)){this.disable(beaconPair.start);}
if(!this.isDisabled(beaconPair.end)){this.disable(beaconPair.end);}
const threadId=beaconPair.start.dataset.id;const editorThread=this.commentsState.editorThreads[threadId];if(editorThread){this.commentsState.disabledEditorThreads[threadId]=editorThread;delete this.commentsState.editorThreads[threadId];}
this.onStep();},isOwned:(beaconPair)=>{if(!this.peerId){return true;}else{const peerId=beaconPair.start.dataset.peerId;return!peerId||this.peerId===peerId;}},});}else{editorThread.beaconPair=this.beaconPairs[threadId];}
if(this.isDisabled(this.beaconPairs[threadId].start)||this.isDisabled(this.beaconPairs[threadId].end)){if(!(threadId in this.commentsState.disabledEditorThreads)){this.commentsState.disabledEditorThreads[threadId]=editorThread;}
if(threadId in this.commentsState.editorThreads){delete this.commentsState.editorThreads[threadId];}
this.cleanupBeaconPair(threadId);}else{if(!(threadId in this.commentsState.editorThreads)){this.commentsState.editorThreads[threadId]=editorThread;}
if(threadId in this.commentsState.disabledEditorThreads){delete this.commentsState.disabledEditorThreads[threadId];}
threadIdsToSort.push(threadId);}}
this.sortedThreadIds=threadIdsToSort.sort((a,b)=>{return compareDOMPosition(this.beaconPairs[a].start,this.beaconPairs[b].start);});}
drawThreadOverlays(){const overlayRect=this.overlayContainer.getBoundingClientRect();for(const threadId of this.sortedThreadIds){this.cleanupBeaconPair(threadId);const beaconPair=this.beaconPairs[threadId];if(!beaconPair.start.isConnected||!beaconPair.end.isConnected){continue;}
const range=new Range();range.setStart(...rightPos(beaconPair.start));range.setEnd(...leftPos(beaconPair.end));const clientRects=Array.from(range.getClientRects());if(!clientRects.length){continue;}
this.commentsState.editorThreads[threadId].top=clientRects[0].y-overlayRect.y;clientRects.reverse();const identifyRect=(big,small)=>{if(big.width===0||big.height===0){return;}
if(small&&Math.floor(big.x)<=small.x&&Math.floor(big.y)<=small.y&&Math.ceil(big.x+big.width)>=small.x+small.width&&Math.ceil(big.y+big.height)>=small.y+small.height){return;}
const target=this.document.elementFromPoint(big.x+big.width/2,big.y+big.height/2);if(!target){return;}
let valid=true;let closestEditable=target.closest("[data-embedded-editable]");if(!this.source.contains(closestEditable)){closestEditable=undefined;}
let embedded=target.closest("[data-embedded]");if(!this.source.contains(embedded)){embedded=undefined;}
if(embedded&&(!closestEditable||!embedded.contains(closestEditable))){valid=false;}
if(!valid||(target.textContent===""&&target.nodeName!=="IMG")){return;}
return target;};let previousRect;const indicators=[];for(const rect of clientRects){const identity=identifyRect(rect,previousRect);if(rect.width&&rect.height){previousRect=rect;}
if(!identity||!this.source.contains(identity)){continue;}
let rectElement;let onFocus;let onActivate;switch(identity.nodeName){case"IMG":rectElement=this.createImgOverlay(rect,overlayRect,threadId,getComputedStyle(identity));onFocus=()=>{const style=getComputedStyle(identity);rectElement.style.setProperty("border-radius",style.borderRadius);rectElement.style.setProperty("box-shadow",`0 0 0 8px ${this.getThreadOverlayColor(
                                    this.commentsState.hasFocus(threadId)
                                )}`);};onActivate=onFocus;break;default:rectElement=this.createTextOverlay(rect,overlayRect,threadId);onFocus=()=>{rectElement.style.setProperty("background-color",this.getThreadOverlayColor(this.commentsState.hasFocus(threadId)));};onActivate=onFocus;break;}
if(rectElement){this.setupOverlayEvents({rectElement,threadId,onFocus,onActivate,});indicators.push(rectElement);}}
this.overlayContainer.append(...indicators);}}
createTextOverlay(rect,overlayRect,threadId){const{x,y,width,height}=rect;const rectElement=this.document.createElement("div");rectElement.style=`
            position: absolute;
            top: ${y - overlayRect.y}px;
            left: ${x - overlayRect.x}px;
            width: ${width}px;
            height: ${height}px;
            pointer-events: ${this.readonly ? "auto" : "none"};
            cursor: ${this.readonly ? "grab" : "auto"};
            background-color: ${this.getThreadOverlayColor(this.commentsState.hasFocus(threadId))};
            opacity: 0.5;
        `;rectElement.dataset.threadId=threadId;return rectElement;}
createImgOverlay(rect,overlayRect,threadId,style){const{x,y,width,height}=rect;const rectElement=this.document.createElement("div");rectElement.style=`
            position: absolute;
            top: ${y - overlayRect.y}px;
            left: ${x - overlayRect.x}px;
            width: ${width}px;
            height: ${height}px;
            pointer-events: ${this.readonly ? "auto" : "none"};
            cursor: ${this.readonly ? "grab" : "auto"};
            box-shadow: 0 0 0 8px ${this.getThreadOverlayColor(
                this.commentsState.hasFocus(threadId)
            )};
            border-radius: ${style.borderRadius};
            opacity: 0.5;
        `;rectElement.dataset.threadId=threadId;return rectElement;}
setupOverlayEvents({rectElement,threadId,onFocus,onActivate}){this.cleanups[threadId]||=new Set();const thread=this.commentsState.editorThreads[threadId];if(onActivate){thread.onActivateMap.set(rectElement,onActivate);}
if(onFocus){thread.onFocusMap.set(rectElement,onFocus);}
const onReadonlyActivate=(ev)=>{thread.onActivate(ev);};const onReadonlyFocus=(ev)=>{thread.onFocus(ev);};if(this.readonly){rectElement.addEventListener("click",onReadonlyActivate);rectElement.addEventListener("mouseenter",onReadonlyFocus);rectElement.addEventListener("mouseleave",onReadonlyFocus);}
this.cleanups[threadId].add(()=>{if(this.readonly){rectElement.removeEventListener("click",onReadonlyActivate);rectElement.removeEventListener("mouseenter",onReadonlyFocus);rectElement.removeEventListener("mouseleave",onReadonlyFocus);}
thread.onActivateMap.delete(rectElement);thread.onFocusMap.delete(rectElement);rectElement.remove();});}
getThreadOverlayColor(focus){return`rgba(27, 161, 228, ${focus ? "0.75" : "0.25"})`;}
computeTextMap(beaconPair){const range=new Range();range.setStart(...rightPos(beaconPair.start));range.setEnd(...leftPos(beaconPair.end));const fragment=range.cloneContents();const embeds=[...fragment.querySelectorAll("[data-embedded]")].reverse();for(const embed of embeds){embed.replaceWith(...embed.querySelectorAll("[data-embedded-editable]"));}
return childNodes(fragment).map((node)=>{if(node.nodeName==="IMG"){return node.src;}
return node.textContent.trim();});}
validate(beaconPair){if(!beaconPair.start.isConnected||!beaconPair.end.isConnected){return false;}
if(compareDOMPosition(beaconPair.start,beaconPair.end)!==-1){return false;}
if(parseInt(beaconPair.start.dataset.res_id)!==this.commentsState.articleId||parseInt(beaconPair.end.dataset.res_id)!==this.commentsState.articleId){return false;}
if(this.commentsState.deletedThreadIds.has(beaconPair.start.dataset.id)){return false;}
if(this.commentsState.activeThreadId!=="undefined"&&beaconPair.start.dataset.id==="undefined"&&(!this.pendingBeacons.has(beaconPair.start)||!this.pendingBeacons.has(beaconPair.end))){return false;}
if(this.computeTextMap(beaconPair).join("").trim()===""){return false;}
return true;}
removeDuplicate(beacon){let index=this.searchBeaconIndexByThreadId(beacon,this.beaconsByThreadId);let currentBeacon=this.beaconsByThreadId.at(index);while(currentBeacon&&!compareBeaconsThreadIds(beacon,currentBeacon)){this.beaconsByThreadId.splice(index,1);if(beacon!==currentBeacon){this.bogusBeacons.add(currentBeacon);this.deleteBeacons([currentBeacon]);}
index=this.searchBeaconIndexByThreadId(beacon,this.beaconsByThreadId);currentBeacon=this.beaconsByThreadId.at(index);}}
preserveExistingBeaconPair(beaconPair){const concurrentBeaconPair=this.beaconPairs[beaconPair.start.dataset.id];if(concurrentBeaconPair&&beaconPair!==concurrentBeaconPair&&this.validate(concurrentBeaconPair)&&compareDOMPosition(concurrentBeaconPair.start,concurrentBeaconPair.end)===-1){if(beaconPair.start!==concurrentBeaconPair.start){beaconPair.start=concurrentBeaconPair.start;}
if(beaconPair.end!==concurrentBeaconPair.end){beaconPair.end=concurrentBeaconPair.end;}}}
activateRelatedThread(target){this.sortThreads();const index=this.searchBeaconIndex(target,this.beacons);const ends={};let threadId;for(let i=index-1;i>=0;i--){const beacon=this.beacons[i];if(beacon.dataset.oeType==="threadBeaconEnd"){ends[beacon.dataset.id]={end:beacon,};}else if(beacon.dataset.id in ends||!(beacon.dataset.id in this.beaconPairs)||!this.beaconPairs[beacon.dataset.id].end.isConnected){continue;}else if(beacon.dataset.id in this.commentsState.editorThreads){threadId=beacon.dataset.id;break;}}
this.commentsState.activeThreadId=threadId;this.drawThreadOverlays();}
isDisabled(beacon){return beacon.classList.contains("oe_disabled_thread_beacon");}
enable(beacon){beacon.classList.remove("oe_disabled_thread_beacon");}
disable(beacon){beacon.classList.add("oe_disabled_thread_beacon");}
removeBogusBeacons(){for(const beacon of this.bogusBeacons){this.cleanupBeaconPair(beacon.dataset.id);this.removeBeacon(beacon);}
this.bogusBeacons=new Set();}
cleanupBeaconPair(threadId){for(const cleanup of this.cleanups[threadId]||[]){cleanup();}
delete this.cleanups[threadId];}
destroy(){for(const threadId of Object.keys(this.cleanups)){this.cleanupThread(threadId);}
for(const threadId of Object.keys(this.commentsState.editorThreads)){delete this.commentsState.editorThreads[threadId];}
for(const threadId of Object.keys(this.commentsState.disabledEditorThreads)){delete this.commentsState.disabledEditorThreads[threadId];}}
cleanupThread(threadId){this.cleanupBeaconPair(threadId);delete this.beaconPairs[threadId];delete this.commentsState.editorThreads[threadId];delete this.commentsState.disabledEditorThreads[threadId];}}
return __exports;});;

/* /knowledge/static/src/comments/comments_handler/comments_handler.js */
odoo.define('@knowledge/comments/comments_handler/comments_handler',['@knowledge/comments/comment/comment','@web/search/action_hook','@odoo/owl','@knowledge/comments/comment_beacon_manager','@web/core/utils/hooks','@web/core/utils/timing','@web/core/l10n/localization'],function(require){'use strict';let __exports={};const{MIN_THREAD_WIDTH,KnowledgeCommentsThread}=require("@knowledge/comments/comment/comment");const{useCallbackRecorder}=require("@web/search/action_hook");const{batched,Component,reactive,useEffect,useState,useSubEnv}=require("@odoo/owl");const{CommentBeaconManager}=require("@knowledge/comments/comment_beacon_manager");const{useService}=require("@web/core/utils/hooks");const{debounce}=require("@web/core/utils/timing");const{localization}=require("@web/core/l10n/localization");const MAX_THREAD_WIDTH=400;const SMALL_THREAD_WIDTH=40;const KnowledgeCommentsHandler=__exports.KnowledgeCommentsHandler=class KnowledgeCommentsHandler extends Component{static template="knowledge.KnowledgeCommentsHandler";static components={KnowledgeCommentsThread};static props={commentBeaconManager:{type:CommentBeaconManager},contentRef:{type:Object},};setup(){this.commentsService=useService("knowledge.comments");this.commentsState=useState(this.commentsService.getCommentsState());const debouncedThreadDimensions=debounce(()=>{this.computeThreadDimensions();},300);const batchedComputeVerticalDimensions=batched(this.computeVerticalDimensions.bind(this));useSubEnv({threadHeights:reactive({},batchedComputeVerticalDimensions),});this.lastActiveThreadId;this.state=useState({threadDimensions:{horizontal:{},threadTops:{},},});useCallbackRecorder(this.env.__onLayoutGeometryChange__,debouncedThreadDimensions);let activeThreadId;useEffect(()=>{if(this.commentsState.activeThreadId!==activeThreadId){activeThreadId=this.commentsState.activeThreadId;batchedComputeVerticalDimensions();}},()=>[this.commentsState.activeThreadId]);useEffect(()=>{const editorThreads=Object.keys(this.commentsState.editorThreads);if(editorThreads.some((threadId)=>{return this.props.commentBeaconManager.sortedThreadIds.includes(threadId);})){debouncedThreadDimensions();}},()=>[this.commentsState.editorThreads,Object.keys(this.commentsState.editorThreads).toString(),]);}
get mainPositionThreadId(){if(this.commentsState.activeThreadId&&this.commentsState.activeThreadId!==this.lastActiveThreadId){this.lastActiveThreadId=this.commentsState.activeThreadId;}else if(!this.props.commentBeaconManager.sortedThreadIds.includes(this.lastActiveThreadId)){this.lastActiveThreadId=undefined;}
return this.lastActiveThreadId||this.props.commentBeaconManager.sortedThreadIds.at(0);}
computeHorizontalDimensions(){if(!this.props.contentRef.el){return;}
const rtl=localization.direction==="rtl";const keys={paddingRight:"paddingRight",left:"left",right:"right",};if(rtl){Object.assign(keys,{paddingRight:"paddingLeft",left:"right",right:"left",});}
const contentStyle=getComputedStyle(this.props.contentRef.el);const paddingRight=parseInt(contentStyle[keys.paddingRight])||0;const contentRect=this.props.contentRef.el.getBoundingClientRect();const parentRect=this.props.contentRef.el.parentElement.getBoundingClientRect();const marginRight=Math.abs(parentRect[keys.right]-contentRect[keys.right]);const marginLeft=Math.abs(parentRect[keys.left]-contentRect[keys.left]);const availableWidth=Math.max(0,Math.floor(marginRight+paddingRight));let width=Math.min(MAX_THREAD_WIDTH,Math.max(0,availableWidth-20));if(!width){return;}
if(width<MIN_THREAD_WIDTH){width=SMALL_THREAD_WIDTH;}
const left=(rtl?-1:1)*Math.ceil(marginLeft+
contentRect.width-
paddingRight+
(availableWidth+(rtl?1:-1)*width)/2);this.state.threadDimensions.horizontal={left,width};}
computeVerticalDimensions(){const activeId=this.mainPositionThreadId;if(!activeId||this.commentsState.editorThreads[activeId]?.top===undefined){return;}
const threadIds=this.props.commentBeaconManager.sortedThreadIds.filter((threadId)=>{return(threadId in this.commentsState.editorThreads&&this.commentsState.editorThreads[threadId].top);});const index=threadIds.indexOf(activeId);this.setThreadTop(activeId,this.commentsState.editorThreads[activeId].top);let masterTop=this.getThreadTop(activeId);for(let i=index-1;i>=0;i--){const threadId=threadIds[i];const expectedTop=this.commentsState.editorThreads[threadId].top;const height=this.env.threadHeights[threadId]?.height||0;if(expectedTop+height<masterTop){masterTop=expectedTop;}else{masterTop-=height;}
this.setThreadTop(threadId,masterTop);}
masterTop=this.getThreadTop(activeId)+(this.env.threadHeights[activeId]?.height||0);for(let i=index+1;i<threadIds.length;i++){const threadId=threadIds[i];const expectedTop=this.commentsState.editorThreads[threadId].top;masterTop=Math.max(masterTop,expectedTop);this.setThreadTop(threadId,masterTop);masterTop+=this.env.threadHeights[threadId]?.height||0;}}
computeThreadDimensions(){this.computeHorizontalDimensions();this.computeVerticalDimensions();}
setThreadTop(threadId,top){if(!(threadId in this.state.threadDimensions.threadTops)){this.state.threadDimensions.threadTops[threadId]={top:undefined,};}
this.state.threadDimensions.threadTops[threadId].top=top;}
getThreadTop(threadId){return this.state.threadDimensions.threadTops[threadId]?.top;}}
return __exports;});;

/* /knowledge/static/src/comments/comments_panel/comments_panel.js */
odoo.define('@knowledge/comments/comments_panel/comments_panel',['@web/core/registry','@web/views/widgets/standard_widget_props','@web/core/user','@web/core/utils/hooks','@knowledge/comments/comment/comment','@odoo/owl','@web/core/utils/timing','@web/core/utils/reactive','@knowledge/comments/comments_service'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{KnowledgeCommentsThread}=require("@knowledge/comments/comment/comment");const{Component,onWillDestroy,onWillStart,useEffect,useRef,useState}=require("@odoo/owl");const{batched,debounce}=require("@web/core/utils/timing");const{effect}=require("@web/core/utils/reactive");const{LOAD_THREADS_LIMIT}=require("@knowledge/comments/comments_service");const KnowledgeCommentsPanel=__exports.KnowledgeCommentsPanel=class KnowledgeCommentsPanel extends Component{static template="knowledge.KnowledgeCommentsPanel";static components={KnowledgeCommentsThread};static props={...standardWidgetProps};setup(){this.rootRef=useRef("root");this.commentsService=useService("knowledge.comments");this.commentsState=useState(this.commentsService.getCommentsState());let threadRecordsKeys;this.alive=true;effect(batched((state)=>{if(!this.alive){return;}
if(state.displayMode!=="panel"){return;}
const threadRecords=state.threadRecords;const threadIds=Object.keys(threadRecords);const keys=threadIds.toString();if(keys!==threadRecordsKeys){this.computeThreadIds();threadRecordsKeys=keys;}}),[this.commentsState]);onWillDestroy(()=>{this.alive=false;});this.state=useState({mode:"unresolved",loadMoreResolved:false,loadMoreOpen:false,loading:false,threadIds:[],});let firstLoad=true;useEffect(()=>{if(this.commentsState.displayMode!=="panel"){return;}
this.computeThreadIds();this.commentsService.loadRecords(this.env.model.root.resId,{ignoreBatch:true,includeLoaded:true,domain:this.domain,}).then((count)=>{if(firstLoad){firstLoad=false;if(count!==undefined&&count<LOAD_THREADS_LIMIT){this.sealLoadMoreState();}else{this.state.loadMoreOpen=true;this.state.loadMoreResolved=true;}}});},()=>[this.state.mode,this.commentsState.articleId,this.commentsState.displayMode]);useEffect(()=>{if(this.commentsState.displayMode==="panel"){this.rootRef.el?.parentElement.classList.remove("d-none");}else{this.rootRef.el?.parentElement.classList.add("d-none");}},()=>[this.commentsState.displayMode]);onWillStart(async()=>{if(this.env.services.action.currentController?.action?.context?.show_resolved_threads){this.commentsState.displayMode="panel";this.mode="resolved";this.env.services.action.currentController.action.context.show_resolved_threads=false;}
this.isPortalUser=await user.hasGroup("base.group_portal");this.isInternalUser=await user.hasGroup("base.group_user");});const loadMore=debounce(this.loadMore.bind(this),500);this.loadMore=()=>{this.state.loading=true;loadMore();};}
canDisplayRecord(threadId){if(!this.commentsState.threadRecords[threadId]){return true;}
if(this.state.mode==="unresolved"){return!this.commentsState.threadRecords[threadId].is_resolved;}else if(this.state.mode==="resolved"){return this.commentsState.threadRecords[threadId].is_resolved;}
return true;}
get couldLoadMore(){if(this.state.mode==="unresolved"){return this.state.loadMoreOpen;}else if(this.state.mode==="resolved"){return this.state.loadMoreResolved;}else{return this.state.loadMoreOpen||this.state.loadMoreResolved;}}
get domain(){let domain=undefined;if(this.state.mode==="unresolved"){domain=[["is_resolved","=",false]];}else if(this.state.mode==="resolved"){domain=[["is_resolved","=",true]];}
return domain;}
computeThreadIds(){const threadIds=[];for(const[threadId,record]of Object.entries(this.commentsState.threadRecords)){if(this.state.mode==="all"||(this.state.mode==="resolved"&&record.is_resolved)||(this.state.mode==="unresolved"&&!record.is_resolved)){threadIds.push(threadId);}}
this.state.threadIds=threadIds.sort((threadIdA,threadIdB)=>{const dateA=this.commentsState.threadRecords[threadIdA].write_date;const dateB=this.commentsState.threadRecords[threadIdB].write_date;if(dateA<dateB){return 1;}else if(dateA>dateB){return-1;}else{return 0;}});}
onChangeMode(ev){this.state.mode=ev.target.value;}
async loadMore(){const count=await this.commentsService.loadRecords(this.env.model.root.resId,{ignoreBatch:true,domain:this.domain,});if(count!==undefined&&count<LOAD_THREADS_LIMIT){this.sealLoadMoreState();}
this.state.loading=false;}
sealLoadMoreState(){if(this.state.mode==="unresolved"){this.state.loadMoreOpen=false;}else if(this.state.mode==="resolved"){this.state.loadMoreResolved=false;}else{this.state.loadMoreResolved=false;this.state.loadMoreOpen=false;}}}
const knowledgeCommentsPanel=__exports.knowledgeCommentsPanel={component:KnowledgeCommentsPanel,additionalClasses:["d-none","col-12","col-lg-4","border-start","d-print-none"],};registry.category("view_widgets").add("knowledge_comments_panel",knowledgeCommentsPanel);return __exports;});;

/* /knowledge/static/src/comments/comments_popover/comments_popover.js */
odoo.define('@knowledge/comments/comments_popover/comments_popover',['@mail/core/common/composer','@knowledge/mail/composer/composer','@knowledge/mail/thread/knowledge_thread','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{Composer}=require("@mail/core/common/composer");const{KnowledgeCommentCreatorComposer}=require("@knowledge/mail/composer/composer");const{KnowledgeThread}=require("@knowledge/mail/thread/knowledge_thread");const{useService}=require("@web/core/utils/hooks");const{Component,useRef,useState}=require("@odoo/owl");const KnowledgeCommentsPopover=__exports.KnowledgeCommentsPopover=class KnowledgeCommentsPopover extends Component{static template="knowledge.KnowledgeCommentsPopover";static props={threadId:{type:String},close:{type:Function},};static components={Composer,KnowledgeThread,KnowledgeCommentCreatorComposer};setup(){this.commentsService=useService("knowledge.comments");this.commentsState=useState(this.commentsService.getCommentsState());this.rootRef=useRef("rootRef");}
onPostCallback(){this.props.close();}
onCreateThreadCallback(thread){if(thread){this.commentsState.editorThreads[thread.id]?.select();}}
get thread(){return this.commentsState.threads[this.props.threadId];}}
return __exports;});;

/* /knowledge/static/src/comments/comments_service.js */
odoo.define('@knowledge/comments/comments_service',['@web/core/registry','@odoo/owl','@web/core/utils/concurrency','@web/core/network/rpc','@web/core/browser/browser','@web/views/utils','@web/core/utils/reactive'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{batched,reactive}=require("@odoo/owl");const{Deferred}=require("@web/core/utils/concurrency");const{rpc}=require("@web/core/network/rpc");const{browser}=require("@web/core/browser/browser");const{uuid}=require("@web/views/utils");const{effect}=require("@web/core/utils/reactive");const ARTICLE_THREAD_FIELDS=["id","article_id","article_anchor_text","is_resolved","write_date",];const LOAD_THREADS_LIMIT=__exports.LOAD_THREADS_LIMIT=30;function clearThreadComposer(composer){if(!composer){return;}
composer.clear();browser.localStorage.removeItem(composer.localId);}
const knowledgeCommentsService=__exports.knowledgeCommentsService={dependencies:["orm","mail.store"],start(env,services){this.services=services;this.commentsState=reactive({articleId:undefined,activeThreadId:undefined,threadRecords:{},threads:{},disabledEditorThreads:{},editorThreads:{},displayMode:"handler",focusedThreads:new Set(),deletedThreadIds:new Set(),hasFocus(threadId){return this.focusedThreads.has(threadId)||this.activeThreadId===threadId;},});let previousArticleId;effect((state)=>{if(previousArticleId!==state.articleId){this.resetForArticleId();previousArticleId=state.articleId;}},[this.commentsState]);return{createThread:this.createThread.bind(this),createVirtualThread:this.createVirtualThread.bind(this),deleteThread:this.deleteThread.bind(this),fetchMessages:this.fetchMessages.bind(this),getCommentsState:this.getCommentsState.bind(this),loadRecords:this.loadRecords.bind(this),loadThreads:this.loadThreads.bind(this),setArticleId:this.setArticleId.bind(this),updateResolveState:this.updateResolveState.bind(this),};},async createThread(value,postData){if(!value||!("undefined"in this.commentsState.editorThreads)){return;}
const loadingId=this.loadingId;const record=await rpc("/knowledge/thread/create",{article_id:this.commentsState.articleId,article_anchor_text:this.commentsState.editorThreads["undefined"].anchorText,fields:ARTICLE_THREAD_FIELDS,});if(loadingId!==this.loadingId){return;}
this.commentsState.threadRecords[record.id]=record;this.commentsState.editorThreads[record.id]=this.commentsState.editorThreads["undefined"];delete this.commentsState.editorThreads["undefined"];this.commentsState.editorThreads[record.id].setThreadId(record.id);clearThreadComposer(this.commentsState.threads["undefined"].composer);const thread=this.services["mail.store"].Thread.insert({id:record.id,model:"knowledge.article.thread",articleId:this.commentsState.articleId,});this.commentsState.threads[record.id]=thread;thread.post(value,postData);return thread;},createVirtualThread(){this.commentsState.threads["undefined"]=this.services["mail.store"].Thread.insert({id:undefined,model:"knowledge.article.thread",articleId:this.commentsState.articleId,});clearThreadComposer(this.commentsState.threads["undefined"].composer);return this.commentsState.threads["undefined"];},async deleteThread(resId){if(resId==="undefined"){return;}
this.batchedDeleteThread.threadIds.add(resId);this.batchedDeleteThread();},async fetchMessages(threadId){const deferred=new Deferred();this.batchedFetchMessages.deferredPromises[threadId]||=[];this.batchedFetchMessages.deferredPromises[threadId].push(deferred);this.batchedFetchMessages.threadIds.add(threadId);this.batchedFetchMessages();return await deferred;},getCommentsState(){return this.commentsState;},loadRecords(articleId,{domain,ignoreBatch,includeLoaded,limit,threadId}={}){if(this.commentsState.articleId!==articleId){return;}
if(ignoreBatch){return this._loadRecords({domain,limit,includeLoaded,});}
if(threadId){if(threadId==="undefined"){return;}
this.batchedLoadRecords.threadIds.add(threadId);this.batchedLoadRecords();}},loadThreads(resIds){for(const resId of resIds){this.commentsState.threads[resId]=this.services["mail.store"].Thread.insert({id:resId==="undefined"?undefined:resId,model:"knowledge.article.thread",articleId:this.commentsState.articleId,});}},makeBatchedDeleteThread(){const deleteThread=async()=>{if(this.loadingId!==batch.loadingId){return;}
const resIds=[];for(const resId of batch.threadIds){resIds.push(parseInt(resId));}
batch.threadIds=new Set();try{await this.services["orm"].unlink("knowledge.article.thread",resIds);}catch{}
if(this.loadingId!==batch.loadingId){return;}
for(const resId of resIds){delete this.commentsState.threadRecords[resId];delete this.commentsState.threads[resId];this.commentsState.deletedThreadIds.add(resId.toString());this.commentsState.editorThreads[resId]?.removeBeacons();}};const batch=batched(deleteThread);batch.threadIds=new Set();batch.loadingId=this.loadingId;return batch;},makeBatchedFetchMessages(){const fetchMessages=async()=>{if(this.loadingId!==batch.loadingId){return;}
const deferredPromises=batch.deferredPromises;const thread_ids=Array.from(batch.threadIds);batch.threadIds=new Set();batch.deferredPromises={};let error;let result;try{result=await rpc("/knowledge/threads/messages",{thread_model:"knowledge.article.thread",thread_ids,});}catch(e){error=e;}
for(const thread_id in deferredPromises){for(const deferred of deferredPromises[thread_id]){if(error){deferred.reject(error);}else{deferred.resolve(result[thread_id]);}}}};const batch=batched(fetchMessages);batch.deferredPromises={};batch.threadIds=new Set();batch.loadingId=this.loadingId;return batch;},makeBatchedLoadRecords(){const loadRecords=async()=>{if(this.loadingId!==batch.loadingId){return;}
const excludedSet=new Set(Object.keys(this.commentsState.threadRecords));const targetedSet=batch.threadIds;batch.threadIds=new Set();for(const threadId of[...targetedSet]){if(excludedSet.has(threadId)){targetedSet.delete(threadId);}}
let threadRecords=[];if(targetedSet.size){const queryDomain=[["article_id","=",this.commentsState.articleId],["id","in",[...targetedSet]],];threadRecords=await this.services["orm"].searchRead("knowledge.article.thread",queryDomain,ARTICLE_THREAD_FIELDS);if(this.loadingId!==batch.loadingId){return;}
for(const threadRecord of threadRecords){const threadId=threadRecord.id.toString();this.commentsState.threadRecords[threadId]=threadRecord;if(threadRecord.is_resolved){this.commentsState.editorThreads[threadId]?.disableBeacons();}else{this.commentsState.disabledEditorThreads[threadId]?.enableBeacons();}}}
if(targetedSet.size){for(const threadId of targetedSet){if(!(threadId in this.commentsState.threadRecords)&&!this.commentsState.editorThreads[threadId]?.isProtected()){this.batchedDeleteThread.threadIds.add(threadId);}}
if(this.batchedDeleteThread.threadIds.size){this.batchedDeleteThread();}}};const batch=batched(loadRecords);batch.loadingId=this.loadingId;batch.threadIds=new Set();return batch;},makeLoadRecords(){const loadRecords=async({domain,limit,includeLoaded}={})=>{if(!limit){limit=LOAD_THREADS_LIMIT;}
const options={limit,};const queryDomain=[["article_id","=",this.commentsState.articleId]];if(domain){queryDomain.push(...domain);}
if(!includeLoaded){const excludedThreadIds=Object.keys(this.commentsState.threadRecords);queryDomain.push(["id","not in",excludedThreadIds]);}
const threadRecords=await this.services["orm"].searchRead("knowledge.article.thread",queryDomain,ARTICLE_THREAD_FIELDS,options);if(this.loadingId!==loadRecords.loadingId){return;}
for(const threadRecord of threadRecords){const threadId=threadRecord.id.toString();this.commentsState.threadRecords[threadId]=threadRecord;if(threadRecord.is_resolved){this.commentsState.editorThreads[threadId]?.disableBeacons();}else{this.commentsState.disabledEditorThreads[threadId]?.enableBeacons();}}
return threadRecords.length;};loadRecords.loadingId=this.loadingId;return loadRecords;},resetForArticleId(){this.loadingId=uuid();this.commentsState.activeThreadId=undefined;this.commentsState.focusedThreads=new Set();this.commentsState.threadRecords={};this.commentsState.threads={};this.commentsState.disabledEditorThreads={};this.commentsState.editorThreads={};this.batchedFetchMessages=this.makeBatchedFetchMessages();this.batchedDeleteThread=this.makeBatchedDeleteThread();this.batchedLoadRecords=this.makeBatchedLoadRecords();this._loadRecords=this.makeLoadRecords();},setArticleId(articleId){if(articleId!==this.commentsState.articleId){this.commentsState.articleId=articleId;this.resetForArticleId();}},async updateResolveState(resId,resolvedState){const loadingId=this.loadingId;try{await this.services["orm"].write("knowledge.article.thread",[parseInt(resId)],{is_resolved:resolvedState,});}catch{return false;}
if(this.loadingId!==loadingId){return false;}
this.commentsState.threadRecords[resId].is_resolved=resolvedState;if(resolvedState){this.commentsState.editorThreads[resId]?.disableBeacons();}else{this.commentsState.disabledEditorThreads[resId]?.enableBeacons();}
return true;},};registry.category("services").add("knowledge.comments",knowledgeCommentsService);return __exports;});;

/* /knowledge/static/src/comments/editor_thread_info.js */
odoo.define('@knowledge/comments/editor_thread_info',[],function(require){'use strict';let __exports={};const EditorThreadInfo=__exports.EditorThreadInfo=class EditorThreadInfo{constructor({beaconPair,threadId,computeTextMap=()=>[],enableBeaconPair=()=>{},disableBeaconPair=()=>{},isOwned=()=>{},removeBeaconPair=()=>{},setSelectionInBeaconPair=()=>{},setBeaconPairId=()=>{},}={}){this.beaconPair=beaconPair;this.threadId=threadId;this.computeTextMap=computeTextMap;this.isOwned=isOwned;this.removeBeaconPair=removeBeaconPair;this.setSelectionInBeaconPair=setSelectionInBeaconPair;this.setBeaconPairId=setBeaconPairId;this.enableBeaconPair=enableBeaconPair;this.disableBeaconPair=disableBeaconPair;this.onActivateMap=new Map();this.onFocusMap=new Map();this.hover=false;this.top=0;this.anchorText=this.computeCurrentAnchorText();}
computeCurrentAnchorText(){return this.computeTextMap(this.beaconPair).join("\n").trim();}
setThreadId(id){this.threadId=id;this.setBeaconPairId(this.beaconPair,id);}
enableBeacons(){this.enableBeaconPair(this.beaconPair);}
disableBeacons(){this.disableBeaconPair(this.beaconPair);}
removeBeacons(){this.removeBeaconPair(this.beaconPair);}
select(){this.setSelectionInBeaconPair(this.beaconPair);}
handleEventMapEntries(ev,map){map.get("main")?.(ev);for(const[key,handler]of map.entries()){if(key.isConnected){handler(ev);}else if(key!=="main"){map.delete(key);}}}
isProtected(){return!this.isOwned(this.beaconPair);}
onActivate(ev){this.handleEventMapEntries(ev,this.onActivateMap);}
onFocus(ev){this.handleEventMapEntries(ev,this.onFocusMap);}}
return __exports;});;

/* /knowledge/static/src/mail/composer/composer.js */
odoo.define('@knowledge/mail/composer/composer',['@mail/core/common/composer','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{Composer}=require("@mail/core/common/composer");const{useService}=require("@web/core/utils/hooks");const{onWillDestroy}=require("@odoo/owl");const KnowledgeCommentCreatorComposer=__exports.KnowledgeCommentCreatorComposer=class KnowledgeCommentCreatorComposer extends Composer{static props=[...Composer.props,"onCreateThreadCallback?"];setup(){super.setup();this.commentsService=useService("knowledge.comments");this.newThread=undefined;onWillDestroy(()=>{this.props.onCreateThreadCallback?.(this.newThread);});}
async _sendMessage(value,postData){this.newThread=await this.commentsService.createThread(value,postData);this.clear();}}
return __exports;});;

/* /knowledge/static/src/mail/composer/composer_patch.js */
odoo.define('@knowledge/mail/composer/composer_patch',['@mail/core/common/composer','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Composer}=require("@mail/core/common/composer");const{patch}=require("@web/core/utils/patch");const composerPatch={get hasGifPicker(){return super.hasGifPicker&&!this.env.inKnowledge;},};patch(Composer.prototype,composerPatch);return __exports;});;

/* /knowledge/static/src/mail/emoji_picker/emoji_picker_patch.js */
odoo.define('@knowledge/mail/emoji_picker/emoji_picker_patch',['@web/core/emoji_picker/emoji_picker','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{EmojiPicker}=require("@web/core/emoji_picker/emoji_picker");const{patch}=require("@web/core/utils/patch");EmojiPicker.props.push("hasRemoveFeature?");patch(EmojiPicker.prototype,{removeEmoji(){this.props.onSelect(false);this.gridRef.el.scrollTop=0;this.props.close?.();this.props.onClose?.();},});return __exports;});;

/* /knowledge/static/src/mail/message/knowledge_message.js */
odoo.define('@knowledge/mail/message/knowledge_message',['@mail/core/common/message','@web/core/user','@odoo/owl'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message");const{user}=require("@web/core/user");const{onWillStart}=require("@odoo/owl");const KnowledgeMessage=__exports.KnowledgeMessage=class KnowledgeMessage extends Message{setup(){super.setup(...arguments);onWillStart(async()=>{this.isPortalUser=await user.hasGroup("base.group_portal");this.isInternalUser=await user.hasGroup("base.group_user");});}
get quickActionCount(){return 3;}
get canToggleStar(){return super.canToggleStar&&this.isInternalUser;}
get showUnfollow(){return super.showUnfollow&&this.isInternalUser;}}
return __exports;});;

/* /knowledge/static/src/mail/message/message_actions.js */
odoo.define('@knowledge/mail/message/message_actions',['@web/core/l10n/translation','@mail/core/common/message_actions'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{messageActionsRegistry}=require("@mail/core/common/message_actions");messageActionsRegistry.add("closeThread",{condition:(component)=>component.env.closeThread&&!component.env.isResolved(),icon:"fa fa-check",title:()=>_t("Mark the discussion as resolved"),onClick:(component)=>component.env.closeThread(),sequence:0,});messageActionsRegistry.add("openThread",{condition:(component)=>component.env.openThread&&component.env.isResolved(),icon:"fa fa-retweet",title:()=>_t("Re-open the discussion"),onClick:(component)=>component.env.openThread(),sequence:0,});return __exports;});;

/* /knowledge/static/src/mail/message/message_model_patch.js */
odoo.define('@knowledge/mail/message/message_model_patch',['@mail/core/common/message_model','@web/core/utils/patch','@web/core/l10n/translation','@web/core/browser/browser','@web/core/utils/urls'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message_model");const{patch}=require("@web/core/utils/patch");const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{url}=require("@web/core/utils/urls");patch(Message.prototype,{async copyLink(){if(this.thread?.model==="knowledge.article.thread"){let notification=_t("Message Link Copied!");let type="info";try{await browser.navigator.clipboard.writeText(url(`/knowledge/article/${this.thread.articleId}`));}catch{notification=_t("Message Link Copy Failed (Permission denied?)!");type="danger";}
this.store.env.services.notification.add(notification,{type});}else{return super.copyLink(...arguments);}},});return __exports;});;

/* /knowledge/static/src/mail/message/message_patch.js */
odoo.define('@knowledge/mail/message/message_patch',['@mail/core/common/message','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message");const{patch}=require("@web/core/utils/patch");patch(Message.prototype,{async openRecord(){if(this.message.model==="knowledge.article.thread"){const[articleThread]=await this.env.services.orm.searchRead("knowledge.article.thread",[["id","=",this.message.thread.id]],["article_id"]);this.action.doAction({type:"ir.actions.act_window",res_id:articleThread.article_id[0],res_model:"knowledge.article",views:[[false,"form"]],});return;}
super.openRecord();},});return __exports;});;

/* /knowledge/static/src/mail/thread/knowledge_thread.js */
odoo.define('@knowledge/mail/thread/knowledge_thread',['@knowledge/mail/message/knowledge_message','@mail/core/common/thread','@odoo/owl'],function(require){'use strict';let __exports={};const{KnowledgeMessage}=require("@knowledge/mail/message/knowledge_message");const{Thread}=require("@mail/core/common/thread");const{onMounted}=require("@odoo/owl");const KnowledgeThread=__exports.KnowledgeThread=class KnowledgeThread extends Thread{static components={...Thread.components,Message:KnowledgeMessage};setup(){super.setup();this.props.thread.knowledgePreLoading=true;onMounted(()=>{this.props.thread.knowledgePreLoading=false;});}}
return __exports;});;

/* /knowledge/static/src/mail/thread/thread_actions_patch.js */
odoo.define('@knowledge/mail/thread/thread_actions_patch',['@mail/core/common/thread_actions','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{threadActionsRegistry}=require("@mail/core/common/thread_actions");const{patch}=require("@web/core/utils/patch");patch(threadActionsRegistry.get("expand-form"),{async open(component){if(component.thread.model==="knowledge.article.thread"){const[articleThreadData]=await component.env.services.orm.read("knowledge.article.thread",[component.thread.id],["article_id"],{load:false});component.actionService.doAction("knowledge.ir_actions_server_knowledge_home_page",{stackPosition:"replaceCurrentAction",additionalContext:{res_id:articleThreadData["article_id"],},});await component.props.chatWindow.close();}else{super.open(component);}},});return __exports;});;

/* /knowledge/static/src/mail/thread/thread_model_patch.js */
odoo.define('@knowledge/mail/thread/thread_model_patch',['@mail/core/common/thread_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Thread}=require("@mail/core/common/thread_model");const{patch}=require("@web/core/utils/patch");patch(Thread.prototype,{knowledgePreLoading:undefined,articleId:undefined,async fetchMessagesData({after,around,before}){if(!this.knowledgePreLoading){return await super.fetchMessagesData(...arguments);}else{return await this.store.env.services["knowledge.comments"].fetchMessages(this.id);}},});return __exports;});;

/* /knowledge/static/src/search_model/search_model.js */
odoo.define('@knowledge/search_model/search_model',['@web/search/search_model'],function(require){'use strict';let __exports={};const{SearchModel}=require("@web/search/search_model");const KnowledgeSearchModelMixin=__exports.KnowledgeSearchModelMixin=(T)=>class extends T{setup(services,args){this.saveEmbeddedViewFavoriteFilter=args.saveEmbeddedViewFavoriteFilter;this.deleteEmbeddedViewFavoriteFilter=args.deleteEmbeddedViewFavoriteFilter;super.setup(services,args);}
async load(config){await super.load(config);if(config.state&&!this.isStateCompleteForEmbeddedView){let defaultFavoriteId=null;const activateFavorite="activateFavorite"in config?config.activateFavorite:true;if(activateFavorite){defaultFavoriteId=this._createGroupOfFavorites(this.irFilters||[]);if(defaultFavoriteId){this._activateDefaultSearchItems(defaultFavoriteId);}}}}
async _createIrFilters(irFilter){this.saveEmbeddedViewFavoriteFilter(irFilter);return null;}
async _deleteIrFilters(searchItem){this.deleteEmbeddedViewFavoriteFilter(searchItem);}
exportState(){const state=super.exportState();state.isStateCompleteForEmbeddedView=true;return state;}
_importState(state){super._importState(state);this.isStateCompleteForEmbeddedView=state.isStateCompleteForEmbeddedView;}};const KnowledgeSearchModel=__exports.KnowledgeSearchModel=class KnowledgeSearchModel extends KnowledgeSearchModelMixin(SearchModel){}
return __exports;});;

/* /knowledge/static/src/web/chatter_patch.js */
odoo.define('@knowledge/web/chatter_patch',['@web/core/utils/hooks','@web/core/utils/concurrency','@web/core/utils/patch','@mail/chatter/web_portal/chatter','@web/search/action_hook','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{Deferred,KeepLast}=require("@web/core/utils/concurrency");const{patch}=require("@web/core/utils/patch");const{Chatter}=require("@mail/chatter/web_portal/chatter");const{useCallbackRecorder}=require("@web/search/action_hook");const{onWillUnmount,useEffect,}=require("@odoo/owl");const ChatterPatch={setup(){super.setup(...arguments);if(this.env.__knowledgeUpdateCommandsRecordInfo__){this.knowledgeCommandsService=useService("knowledgeCommandsService");const keepLastRecordInfoRequest=new KeepLast();let chatterThreadReady=new Deferred();let previousThreadId=this.props.threadId;useEffect((threadId,canPostOnReadonly,hasReadAccess,hasWriteAccess)=>{if(previousThreadId!==threadId){chatterThreadReady.resolve(false);chatterThreadReady=new Deferred();}
if(canPostOnReadonly!==undefined&&hasReadAccess!==undefined&&hasWriteAccess!==undefined){chatterThreadReady.resolve(true);}
previousThreadId=threadId;},()=>[this.props.threadId,this.state.thread?.canPostOnReadonly,this.state.thread?.hasReadAccess,this.state.thread?.hasWriteAccess,]);onWillUnmount(()=>{chatterThreadReady.resolve(false);});useCallbackRecorder(this.env.__knowledgeUpdateCommandsRecordInfo__,async(recordInfo)=>{const chatterThreadReadyForRecordInfo=keepLastRecordInfoRequest.add(chatterThreadReady);if(!await chatterThreadReadyForRecordInfo){return;}
if(!this.env.model.root?.resId||recordInfo.resId!==this.env.model.root.resId||recordInfo.resModel!==this.env.model.root.resModel){return;}
Object.assign(recordInfo,{canPostMessages:this.props.threadId&&(this.state.thread?.hasWriteAccess||(this.state.thread?.hasReadAccess&&this.state.thread?.canPostOnReadonly)),canAttachFiles:this.props.threadId&&this.state.thread?.hasWriteAccess,});if(this.knowledgeCommandsService.isRecordCompatibleWithMacro(recordInfo)){this.knowledgeCommandsService.setCommandsRecordInfo(recordInfo);}});}}};patch(Chatter.prototype,ChatterPatch);return __exports;});;

/* /knowledge/static/src/js/knowledge_controller.js */
odoo.define('@knowledge/js/knowledge_controller',['@web/core/confirmation_dialog/confirmation_dialog','@web/core/l10n/translation','@web/views/form/form_controller','@knowledge/components/sidebar/sidebar','@web/core/utils/hooks','@web/core/utils/concurrency','@odoo/owl'],function(require){'use strict';let __exports={};const{AlertDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{_t}=require("@web/core/l10n/translation");const{FormController}=require('@web/views/form/form_controller');const{KnowledgeSidebar}=require('@knowledge/components/sidebar/sidebar');const{useBus,useService}=require("@web/core/utils/hooks");const{Deferred}=require("@web/core/utils/concurrency");const{onMounted,onWillStart,useChildSubEnv,useEffect,useExternalListener,useRef,}=require("@odoo/owl");const KnowledgeArticleFormController=__exports.KnowledgeArticleFormController=class KnowledgeArticleFormController extends FormController{static template="knowledge.ArticleFormView";static defaultProps={...FormController.defaultProps,mode:"edit",};static components={...FormController.components,KnowledgeSidebar,};setup(){super.setup();this.root=useRef('root');this.orm=useService('orm');this.actionService=useService('action');this.dialogService=useService("dialog");this.topbarMountedPromise=new Deferred();useChildSubEnv({createArticle:this.createArticle.bind(this),ensureArticleName:this.ensureArticleName.bind(this),openArticle:this.openArticle.bind(this),renameArticle:this.renameArticle.bind(this),toggleAsideMobile:this.toggleAsideMobile.bind(this),topbarMountedPromise:this.topbarMountedPromise,save:this.save.bind(this),discard:this.discard.bind(this),});useBus(this.env.bus,'KNOWLEDGE:OPEN_ARTICLE',(event)=>{this.openArticle(event.detail.id);});onWillStart(()=>{if(!this.env.inDialog&&this.env.config.breadcrumbs&&this.env.config.breadcrumbs.length){this.knowledgeCommandsService.unregisterCommandsRecordInfo(this.env.config.breadcrumbs);}});onMounted(()=>{this.topbarMountedPromise.resolve();});useExternalListener(document.documentElement,'mouseleave',async()=>{if(await this.model.root.isDirty()){await this.model.root.save();}});useEffect(()=>{const scrollView=this.root.el?.querySelector(".o_scroll_view_lg");if(scrollView){scrollView.scrollTop=0;}
const mobileScrollView=this.root.el?.querySelector(".o_knowledge_main_view");if(mobileScrollView){mobileScrollView.scrollTop=0;}},()=>[this.model.root.resId]);}
async beforeLeave(){if(this.model.root.resId){await this.ensureArticleName();}
await this.model.root.isDirty();return super.beforeLeave();}
async beforeUnload(ev){if(this.model.root.resId){await this.ensureArticleName();if(await this.model.root.isDirty()){await super.beforeUnload(ev);}}}
ensureArticleName(){const recordData=this.model.root.data;if(!recordData.name&&!(recordData.is_locked||!recordData.user_can_write||!recordData.active)){return this.renameArticle();}}
get resId(){return this.model.root.resId;}
async createArticle(category,targetParentId){const articleId=await this.orm.call("knowledge.article","article_create",[],{is_private:category==='private',parent_id:targetParentId?targetParentId:false});this.openArticle(articleId);}
getHtmlTitle(){const titleEl=this.root.el.querySelector(".note-editable.odoo-editor-editable h1");if(titleEl){const title=titleEl.textContent.trim();if(title){return title;}}}
displayName(){return this.model.root.data.name||_t("New");}
async onWillSaveRecord(record,changes){if(!record.data.name){const title=this.getHtmlTitle();if(title){changes.name=title;}}}
async openArticle(resId){if(!resId||resId===this.resId){return;}
document.activeElement.blur();try{if(this.model.root.isNew){await this.model.load({resId});}else{await this.ensureArticleName();if(await this.model.root.isDirty()){await this.model.root.save({onError:this.onSaveError.bind(this),nextId:resId,});}else{await this.model.load({resId});}}}catch{this.dialogService.add(AlertDialog,{title:_t("Access Denied"),body:_t("The article you are trying to open has either been removed or is inaccessible.",),confirmLabel:_t("Close"),});}
this.toggleAsideMobile(false);}
renameArticle(name){if(!name){const title=this.getHtmlTitle();if(!title){return;}
name=title;}
return this.model.root.update({name});}
toggleAsideMobile(force){const container=this.root.el.querySelector('.o_knowledge_form_view');container.classList.toggle('o_toggle_aside',force);}}
return __exports;});;

/* /knowledge/static/src/js/knowledge_utils.js */
odoo.define('@knowledge/js/knowledge_utils',['@web/core/emoji_picker/emoji_picker'],function(require){'use strict';let __exports={};const{loadEmoji}=require("@web/core/emoji_picker/emoji_picker");const iconsBlocklist=["💩","💀","☠️","🤮","🖕","🤢","😒"];__exports.getRandomIcon=getRandomIcon;async function getRandomIcon(){const{emojis}=await loadEmoji();const randomEmojis=emojis.filter((emoji)=>!iconsBlocklist.includes(emoji.codepoints));return randomEmojis[Math.floor(Math.random()*randomEmojis.length)].codepoints;}
__exports.setIntersectionObserver=setIntersectionObserver;function setIntersectionObserver(element,callback){const options={root:null,rootMargin:'0px'};const observer=new window.IntersectionObserver(entries=>{const entry=entries[0];if(entry.isIntersecting){observer.unobserve(entry.target);callback();}},options);observer.observe(element);return observer;}
return __exports;});;

/* /knowledge/static/src/js/knowledge_renderers.js */
odoo.define('@knowledge/js/knowledge_renderers',['@web/views/form/form_renderer','@knowledge/components/knowledge_cover/knowledge_cover_dialog','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{FormRenderer}=require('@web/views/form/form_renderer');const{KnowledgeCoverDialog}=require('@knowledge/components/knowledge_cover/knowledge_cover_dialog');const{useService}=require("@web/core/utils/hooks");const{useChildSubEnv,useExternalListener,useRef}=require("@odoo/owl");const KnowledgeArticleFormRenderer=__exports.KnowledgeArticleFormRenderer=class KnowledgeArticleFormRenderer extends FormRenderer{setup(){super.setup();this.actionService=useService("action");this.dialog=useService("dialog");this.orm=useService("orm");this.root=useRef('compiled_view_root');useChildSubEnv({openCoverSelector:this.openCoverSelector.bind(this),config:this.env.config,toggleFavorite:this.toggleFavorite.bind(this),_saveIfDirty:this._saveIfDirty.bind(this),});useExternalListener(document,"click",event=>{if(event.target.classList.contains("o_nocontent_create_btn")){this.env.createArticle("private");}});}
openCoverSelector(){this.dialog.add(KnowledgeCoverDialog,{articleCoverId:this.props.record.data.cover_image_id[0],articleName:this.props.record.data.name||"",save:(id)=>this.props.record.update({cover_image_id:[id]})});}
get resId(){return this.props.record.resId;}
async toggleFavorite(event){await this._saveIfDirty();await this.orm.call(this.props.record.resModel,"action_toggle_favorite",[[this.resId]]);await this.props.record.load();}
async _saveIfDirty(){if(await this.props.record.isDirty()){await this.props.record.save();}}
_scrollToElement(container,element){const rect=element.getBoundingClientRect();container.scrollTo(rect.left,rect.top);}}
return __exports;});;

/* /knowledge/static/src/js/knowledge_views.js */
odoo.define('@knowledge/js/knowledge_views',['@web/views/form/form_view','@web/core/registry','@knowledge/js/knowledge_controller','@knowledge/js/knowledge_renderers'],function(require){'use strict';let __exports={};const{formView}=require('@web/views/form/form_view');const{registry}=require("@web/core/registry");const{KnowledgeArticleFormController}=require("@knowledge/js/knowledge_controller");const{KnowledgeArticleFormRenderer}=require("@knowledge/js/knowledge_renderers");const knowledgeArticleFormView=__exports.knowledgeArticleFormView={...formView,Controller:KnowledgeArticleFormController,Renderer:KnowledgeArticleFormRenderer,display:{controlPanel:false}};registry.category('views').add('knowledge_article_view_form',knowledgeArticleFormView);return __exports;});;

/* /knowledge/static/src/webclient/commands/command_category.js */
odoo.define('@knowledge/webclient/commands/command_category',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const commandCategoryRegistry=registry.category("command_categories");commandCategoryRegistry.add("knowledge_articles",{namespace:"?"},{sequence:10});commandCategoryRegistry.add("knowledge_extra",{namespace:"?"},{sequence:20});return __exports;});;

/* /knowledge/static/src/webclient/commands/knowledge_providers.js */
odoo.define('@knowledge/webclient/commands/knowledge_providers',['@web/core/l10n/translation','@web/core/registry','@web/core/commands/default_providers','@web/core/commands/command_palette','@odoo/owl','@web/core/user'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{HotkeyCommandItem}=require("@web/core/commands/default_providers");const{DefaultCommandItem,splitCommandName}=require("@web/core/commands/command_palette");const{markup}=require("@odoo/owl");const{user}=require("@web/core/user");class KnowledgeCommand extends DefaultCommandItem{static template="KnowledgeCommandTemplate";static props={...DefaultCommandItem.props,headline:String,icon_string:String,isFavorite:Boolean,splitSubjectName:Array,subjectName:[String,Boolean],};}
class Knowledge404Command extends DefaultCommandItem{static template="Knowledge404CommandTemplate";static props={...DefaultCommandItem.props,articleName:String,};}
class KnowledgeExtraCommand extends HotkeyCommandItem{static template="KnowledgeExtraCommandTemplate";}
const commandSetupRegistry=registry.category("command_setup");commandSetupRegistry.add("?",{debounceDelay:500,emptyMessage:_t("No article found."),name:_t("articles"),placeholder:_t("Search for an article..."),});const commandProviderRegistry=registry.category("command_provider");const fn=(hidden)=>{const canCreate=()=>user.checkAccessRight("knowledge.article","create");let articlesData;return async function provide(env,options){articlesData=await env.services.orm.call("knowledge.article","get_user_sorted_articles",[[]],{search_query:options.searchValue,hidden_mode:hidden,});if(!hidden){if(articlesData.length===0){if(options.searchValue.length>2&&await canCreate()){return[{Component:Knowledge404Command,async action(){const articleId=await env.services.orm.call('knowledge.article','article_create',[options.searchValue],{is_private:true},);env.services.action.doAction('knowledge.ir_actions_server_knowledge_home_page',{additionalContext:{res_id:articleId,}});},name:_t('No Article found. Create "%s"',options.searchValue),props:{articleName:options.searchValue,},}];}
else{return[];}}}
const knowledgeMainMenuId=env.services.menu.getAll().find(menu=>menu.xmlid==='knowledge.knowledge_menu_root').id;const result=articlesData.map(article=>({Component:KnowledgeCommand,action(){env.services.action.doAction('knowledge.ir_actions_server_knowledge_home_page',{additionalContext:{res_id:article.id,}});},category:"knowledge_articles",href:`/odoo/knowledge.article/${article.id}?menu_id=${knowledgeMainMenuId}`,name:article.name||_t("Untitled"),props:{isFavorite:article.is_user_favorite,headline:article.headline?markup(article.headline):'',subjectName:article.root_article_id[0]!=article.id?article.root_article_id[1]:false,splitSubjectName:splitCommandName(article.root_article_id[1],options.searchValue),icon_string:article.icon||'📄',},}));if(!hidden){result.push({Component:KnowledgeExtraCommand,async action(){const articleIds=articlesData.map(article=>article.id);const action=await env.services.action.loadAction('knowledge.knowledge_article_action');delete action.context.search_default_filter_not_is_article_item;env.services.action.doAction(action,{additionalContext:{search_default_filter_search_article_ids:1,search_article_ids:articleIds,},});},category:"knowledge_extra",name:_t("Advanced Search"),props:{hotkey:"alt+B",},});}
return result;};};commandProviderRegistry.add("knowledge",{debounceDelay:500,namespace:"?",provide:fn(false),});commandSetupRegistry.add("$",{debounceDelay:500,emptyMessage:_t("Oops, there's nothing here. Try another search."),placeholder:_t("Search hidden Articles..."),});commandProviderRegistry.add("knowledge_members_only_articles",{debounceDelay:500,namespace:"$",provide:fn(true),});return __exports;});;

/* /knowledge/static/src/views/embedded_controllers_patch.js */
odoo.define('@knowledge/views/embedded_controllers_patch',['@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{useService}=require('@web/core/utils/hooks');const EmbeddedControllersPatch=__exports.EmbeddedControllersPatch=(T)=>class EmbeddedControllersPatch extends T{setup(){super.setup(...arguments);this.orm=useService('orm');}
async createRecord(){const{onCreate}=this.props.archInfo;if(this.canQuickCreate&&onCreate==="quick_create"){return super.createRecord(...arguments);}
const articleId=await this.orm.call('knowledge.article','article_create',[],{is_article_item:true,is_private:false,parent_id:this.props.context.active_id||false});this.props.selectRecord(articleId,{});}};return __exports;});;

/* /knowledge/static/src/views/embedded_kanban_view.js */
odoo.define('@knowledge/views/embedded_kanban_view',['@knowledge/views/embedded_controllers_patch','@web/views/kanban/kanban_controller','@web/views/kanban/kanban_view','@web/core/registry'],function(require){'use strict';let __exports={};const{EmbeddedControllersPatch}=require("@knowledge/views/embedded_controllers_patch");const{KanbanController}=require("@web/views/kanban/kanban_controller");const{kanbanView}=require("@web/views/kanban/kanban_view");const{registry}=require("@web/core/registry");const KnowledgeArticleItemsKanbanController=__exports.KnowledgeArticleItemsKanbanController=class KnowledgeArticleItemsKanbanController extends EmbeddedControllersPatch(KanbanController){setup(){super.setup();if(!("isEmbeddedReadonly"in this.env)||this.env.isEmbeddedReadonly){["create","createGroup","deleteGroup","editGroup"].forEach((action)=>(this.props.archInfo.activeActions[action]=false));this.props.archInfo.groupsDraggable=false;this.props.archInfo.activeActions.quickCreate=false;}}}
registry.category("views").add("knowledge_article_view_kanban_embedded",{...kanbanView,Controller:KnowledgeArticleItemsKanbanController,});return __exports;});;

/* /knowledge/static/src/views/embedded_list_view.js */
odoo.define('@knowledge/views/embedded_list_view',['@knowledge/views/embedded_controllers_patch','@web/views/list/list_controller','@web/views/list/list_view','@web/core/registry'],function(require){'use strict';let __exports={};const{EmbeddedControllersPatch}=require("@knowledge/views/embedded_controllers_patch");const{ListController}=require("@web/views/list/list_controller");const{listView}=require("@web/views/list/list_view");const{registry}=require("@web/core/registry");const KnowledgeArticleItemsListController=__exports.KnowledgeArticleItemsListController=class KnowledgeArticleItemsListController extends EmbeddedControllersPatch(ListController){setup(){super.setup();if(!("isEmbeddedReadonly"in this.env)||this.env.isEmbeddedReadonly){this.activeActions.create=false;}}}
registry.category("views").add("knowledge_article_view_tree_embedded",{...listView,Controller:KnowledgeArticleItemsListController,});return __exports;});;

/* /knowledge/static/src/views/embedded_view.js */
odoo.define('@knowledge/views/embedded_view',['@knowledge/search_model/search_model','@web/search/search_model','@web/views/view'],function(require){'use strict';let __exports={};const{KnowledgeSearchModelMixin}=require("@knowledge/search_model/search_model");const{SearchModel}=require("@web/search/search_model");const{View}=require("@web/views/view");const EmbeddedView=__exports.EmbeddedView=class EmbeddedView extends View{static props={...View.props,saveEmbeddedViewFavoriteFilter:Function,deleteEmbeddedViewFavoriteFilter:Function,};async loadView(props){const{additionalViewProps,saveEmbeddedViewFavoriteFilter,deleteEmbeddedViewFavoriteFilter,...viewProps}=props;delete viewProps.displayName;Object.assign(viewProps,additionalViewProps);await super.loadView(viewProps);this.withSearchProps.SearchModel=KnowledgeSearchModelMixin(this.withSearchProps.SearchModel||SearchModel);this.withSearchProps.searchModelArgs={saveEmbeddedViewFavoriteFilter,deleteEmbeddedViewFavoriteFilter,};}
async onWillUpdateProps(nextProps){super.onWillUpdateProps(nextProps);this.env.config.setDisplayName(nextProps.displayName);if(JSON.stringify(this.props.additionalViewProps)!==JSON.stringify(nextProps.additionalViewProps)){Object.assign(this.componentProps,nextProps.additionalViewProps);}}}
return __exports;});;

/* /knowledge/static/src/views/item_calendar/item_calendar_model.js */
odoo.define('@knowledge/views/item_calendar/item_calendar_model',['@web/views/calendar/calendar_model','@web/core/l10n/dates'],function(require){'use strict';let __exports={};const{CalendarModel}=require("@web/views/calendar/calendar_model");const{serializeDate,serializeDateTime,deserializeDate,deserializeDateTime,}=require("@web/core/l10n/dates");const ItemCalendarModel=__exports.ItemCalendarModel=class ItemCalendarModel extends CalendarModel{get canCreate(){if(this.meta.invalid){return false;}
return this.meta.canCreate;}
get canEdit(){return true;}
get hasAllDaySlot(){return true;}
buildRawRecord(partialRecord,options={}){let start=partialRecord.start;let end=partialRecord.end;if(!end||!end.isValid){if(this.meta.propertiesDateType==="date"){end=start;}else{end=start.plus({hours:1});}}
if(this.meta.propertiesDateType==="datetime"&&partialRecord.isAllDay){if(partialRecord.id){start=start.set({hours:this.data.records[partialRecord.id].start.hour});end=end.set({hours:this.data.records[partialRecord.id].end.hour});}else{start=start.set({hours:7});end=end.set({hours:19});}}
start=this.meta.propertiesDateType==="date"?serializeDate(start):serializeDateTime(start);end=this.meta.propertiesDateType==="date"?serializeDate(end):serializeDateTime(end);let properties={};if(partialRecord.id){properties=this.data.records[partialRecord.id].rawRecord.article_properties;properties.find(property=>property.name===this.meta.fieldMapping.date_start).value=start;if(this.meta.fieldMapping.date_stop){properties.find(property=>property.name===this.meta.fieldMapping.date_stop).value=end;}}else{properties[this.meta.fieldMapping.date_start]=start;if(this.meta.fieldMapping.date_stop){properties[this.meta.fieldMapping.date_stop]=end;}}
return{article_properties:properties};}
loadRecords(data){if(this.meta.invalid){return{};}
return super.loadRecords(data);}
normalizeRecord(rawRecord){const{fieldMapping,propertiesDateType,scale}=this.meta;const isDate=propertiesDateType==="date";const startValue=rawRecord.article_properties.find(property=>property.name===fieldMapping.date_start)?.value;const stopValue=rawRecord.article_properties.find(property=>property.name===fieldMapping.date_stop)?.value;const start=isDate?deserializeDate(startValue):deserializeDateTime(startValue);const end=stopValue?isDate?deserializeDate(stopValue):deserializeDateTime(stopValue):start;const showTime=scale==="month"&&!isDate;const colorValue=rawRecord.article_properties.find(property=>property.name===fieldMapping.color)?.value;const colorIndex=Array.isArray(colorValue)?colorValue[0]:colorValue;return{id:rawRecord.id,title:rawRecord.display_name,isAllDay:isDate,start,startType:propertiesDateType,end,endType:propertiesDateType,colorIndex,isTimeHidden:!showTime,rawRecord,};}
computeRangeDomain(data){const{fieldMapping}=this.meta;const formattedEnd=serializeDateTime(data.range.end);const formattedStart=serializeDateTime(data.range.start);const domain=[[`article_properties.${fieldMapping.date_start}`,"<=",formattedEnd],['parent_id.article_properties_definition','ilike',`"${fieldMapping.date_start}"`]];if(fieldMapping.date_stop){domain.push([`article_properties.${fieldMapping.date_stop}`,">=",formattedStart],['parent_id.article_properties_definition','ilike',`"${fieldMapping.date_stop}"`]);}
return domain;}}
return __exports;});;

/* /knowledge/static/src/views/item_calendar/item_calendar_view.js */
odoo.define('@knowledge/views/item_calendar/item_calendar_view',['@web/core/l10n/translation','@web/views/calendar/calendar_common/calendar_common_popover','@web/views/calendar/calendar_common/calendar_common_renderer','@web/views/calendar/calendar_controller','@web/views/calendar/calendar_renderer','@web/views/calendar/calendar_view','@web/core/confirmation_dialog/confirmation_dialog','@knowledge/views/item_calendar/item_calendar_model','@web/core/registry','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{CalendarCommonPopover}=require("@web/views/calendar/calendar_common/calendar_common_popover");const{CalendarCommonRenderer}=require("@web/views/calendar/calendar_common/calendar_common_renderer");const{CalendarController}=require("@web/views/calendar/calendar_controller");const{CalendarRenderer}=require("@web/views/calendar/calendar_renderer");const{calendarView}=require("@web/views/calendar/calendar_view");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{ItemCalendarModel}=require("@knowledge/views/item_calendar/item_calendar_model");const{registry}=require("@web/core/registry");const{onMounted,onWillUpdateProps,useEffect}=require("@odoo/owl");const KnowledgeArticleItemsCalendarController=__exports.KnowledgeArticleItemsCalendarController=class KnowledgeArticleItemsCalendarController extends CalendarController{static template="knowledge.ArticleItemsCalendarController";setup(){super.setup();if(!("isEmbeddedReadonly"in this.env)||this.env.isEmbeddedReadonly){this.model.meta.canCreate=false;}
onMounted(async()=>{if(!this.model.meta.invalid&&Object.keys(this.model.data.records).length===0){const propertiesDefinition=await this.orm.read(this.props.resModel,[this.props.context.active_id],["article_properties_definition"]);this.state.missingConfiguration=!propertiesDefinition[0].article_properties_definition.some((property)=>property.name===this.props.itemCalendarProps.dateStartPropertyId);}});onWillUpdateProps((nextProps)=>{if(JSON.stringify(this.props.itemCalendarProps)!==JSON.stringify(nextProps.itemCalendarProps)){this.updateModel(nextProps.itemCalendarProps);this.state.isWeekendVisible=nextProps.itemCalendarProps.showWeekEnds??this.state.isWeekendVisible;this.state.missingConfiguration=false;}});}
get showSideBar(){return!this.env.isEmbeddedView&&super.showSideBar;}
async createRecord(record){if(this.model.canCreate){const createValues={is_article_item:true,parent_id:this.props.context.active_id||false,};if(record){const rawRecord=this.model.buildRawRecord(record);Object.assign(createValues,rawRecord);}
const articleId=await this.orm.call("knowledge.article","article_create",[],createValues);this.selectRecord(articleId);}}
deleteRecord(record){this.displayDialog(ConfirmationDialog,{title:_t("Confirmation"),body:_t("Are you sure you want to send this article to the trash?"),confirm:async()=>{await this.orm.call("knowledge.article","action_send_to_trash",[record.id]);this.model.load();},confirmLabel:_t("Send to trash"),cancel:()=>{},});}
editRecord(record){this.selectRecord(record.id);}
onWillStartModel(){if(this.props.itemCalendarProps){this.updateModel(this.props.itemCalendarProps);this.state.isWeekendVisible=this.props.itemCalendarProps.showWeekEnds??this.state.isWeekendVisible;}else{this.state.missingConfiguration=true;this.model.meta.invalid=true;}}
selectRecord(articleId){if(this.env.isEmbeddedView){this.props.selectRecord(articleId);}else{this.action.doAction(this.orm.call("knowledge.article","action_home_page",[articleId]),{});}}
updateModel(modelProps){this.model.meta.fieldMapping.date_start=modelProps.dateStartPropertyId;this.model.meta.fieldMapping.date_stop=modelProps.dateStopPropertyId;this.model.meta.fieldMapping.color=modelProps.colorPropertyId;this.model.meta.propertiesDateType=modelProps.dateType;if(modelProps.scale){this.model.meta.scale=modelProps.scale;}}
get rendererProps(){return{...super.rendererProps,slotMaxTime:this.props.itemCalendarProps?.slotMaxTime||"24:00",slotMinTime:this.props.itemCalendarProps?.slotMinTime||"00:00",};}}
class KnowledgeArticleItemsCommonPopover extends CalendarCommonPopover{static subTemplates={...CalendarCommonPopover.subTemplates,body:"knowledge.ArticleItemsCalendarCommonPopover.body",footer:"knowledge.ArticleItemsCalendarCommonPopover.footer",};get isEventDeletable(){return super.isEventDeletable&&this.props.record.rawRecord.user_can_write;}}
class KnowledgeArticleItemsCommonRenderer extends CalendarCommonRenderer{static props={...CalendarCommonRenderer.props,slotMinTime:{type:String},slotMaxTime:{type:String},};static components={...CalendarCommonRenderer.components,Popover:KnowledgeArticleItemsCommonPopover,};get options(){return{...super.options,slotMinTime:this.props.slotMinTime,slotMaxTime:this.props.slotMaxTime,};}
setup(){super.setup();useEffect((slotMinTime,slotMaxTime)=>{this.fc.api.setOption("slotMinTime",slotMinTime);this.fc.api.setOption("slotMaxTime",slotMaxTime);},()=>[this.options.slotMinTime,this.options.slotMaxTime]);}}
class KnowledgeArticleItemsCalendarRenderer extends CalendarRenderer{static props={...CalendarRenderer.props,slotMinTime:{type:String},slotMaxTime:{type:String},};static components={...CalendarRenderer.components,day:KnowledgeArticleItemsCommonRenderer,week:KnowledgeArticleItemsCommonRenderer,month:KnowledgeArticleItemsCommonRenderer,};}
registry.category("views").add("knowledge_article_view_calendar_embedded",{...calendarView,Controller:KnowledgeArticleItemsCalendarController,Model:ItemCalendarModel,Renderer:KnowledgeArticleItemsCalendarRenderer,});return __exports;});;

/* /knowledge/static/src/views/list_view.js */
odoo.define('@knowledge/views/list_view',['@web/core/l10n/translation','@web/core/registry','@web/core/user','@web/views/list/list_view','@web/views/list/list_controller'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require('@web/core/registry');const{user}=require("@web/core/user");const{listView}=require('@web/views/list/list_view');const{ListController}=require('@web/views/list/list_controller');const KnowledgeArticleController=__exports.KnowledgeArticleController=class KnowledgeArticleController extends ListController{setup(){super.setup();this.activeActions.create=false;}
getStaticActionMenuItems(){const menuItems=super.getStaticActionMenuItems();menuItems.duplicate={isAvailable:()=>this.nbSelected&&user.isAdmin,sequence:15,icon:"fa fa-clone",description:_t("Duplicate"),callback:async()=>{const selectedResIds=await this.getSelectedResIds();if(selectedResIds.length===1){await this.model.orm.call(this.props.resModel,"copy",[selectedResIds]);}else{await this.model.orm.call(this.props.resModel,"copy_batch",[selectedResIds]);}
this.model.load();},};return menuItems;}}
registry.category("views").add('knowledge_article_view_tree',{...listView,Controller:KnowledgeArticleController,});return __exports;});;

/* /knowledge/static/src/services/knowledge_commands_service.js */
odoo.define('@knowledge/services/knowledge_commands_service',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const knowledgeCommandsService=__exports.knowledgeCommandsService={start(env){let commandsRecordInfo=null;function setCommandsRecordInfo(recordInfo){commandsRecordInfo=recordInfo;}
function getCommandsRecordInfo(){return commandsRecordInfo;}
function getBreadcrumbsIdentifier(breadcrumbs){return breadcrumbs.map(breadcrumb=>{return{jsId:breadcrumb.jsId,name:breadcrumb.name,};});}
function isRecordCompatibleWithMacro(recordInfo){return recordInfo.canAttachFiles||recordInfo.canPostMessages||recordInfo.withHtmlField;}
function unregisterCommandsRecordInfo(breadcrumbs){const commandsRecordInfo=getCommandsRecordInfo();if(!commandsRecordInfo){return;}
breadcrumbs=getBreadcrumbsIdentifier(breadcrumbs);if(breadcrumbs.length<=commandsRecordInfo.breadcrumbs.length||breadcrumbs[commandsRecordInfo.breadcrumbs.length-1].jsId!==commandsRecordInfo.breadcrumbs.at(-1).jsId){setCommandsRecordInfo(null);}}
let pendingEmbeddedBlueprints={};function setPendingEmbeddedBlueprint({embeddedBlueprint,model,field,resId}){if(!(model in pendingEmbeddedBlueprints)){pendingEmbeddedBlueprints[model]={};}
if(!(field in pendingEmbeddedBlueprints[model])){pendingEmbeddedBlueprints[model][field]={};}
pendingEmbeddedBlueprints[model][field][resId]=embeddedBlueprint;}
function popPendingEmbeddedBlueprint({model,field,resId}){if(model in pendingEmbeddedBlueprints&&field in pendingEmbeddedBlueprints[model]){const pendingEmbeddedBlueprint=pendingEmbeddedBlueprints[model][field][resId];delete pendingEmbeddedBlueprints[model][field][resId];return pendingEmbeddedBlueprint;}}
const knowledgeCommandsService={setCommandsRecordInfo,getCommandsRecordInfo,getBreadcrumbsIdentifier,isRecordCompatibleWithMacro,unregisterCommandsRecordInfo,setPendingEmbeddedBlueprint,popPendingEmbeddedBlueprint,};return knowledgeCommandsService;}};registry.category("services").add("knowledgeCommandsService",knowledgeCommandsService);return __exports;});;

/* /knowledge/static/src/services/knowledge_embedded_filters_service.js */
odoo.define('@knowledge/services/knowledge_embedded_filters_service',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const knowledgeEmbedViewsFilters=__exports.knowledgeEmbedViewsFilters={start(env){const embeddedFilters={};const commands={saveFilters:(currentController,filterKey,searchModel)=>{if(!embeddedFilters[filterKey]){embeddedFilters[filterKey]={};}
embeddedFilters[filterKey][currentController.jsId]=searchModel;},applyFilter:(currentController,filterKey,ViewProps)=>{const currentJsId=currentController.jsId;const embedSearchFilters=embeddedFilters[filterKey];if(embedSearchFilters&&embedSearchFilters[currentJsId]){ViewProps.globalState.searchModel=embeddedFilters[filterKey][currentJsId];delete embeddedFilters[filterKey][currentJsId];}
if(currentController.config.breadcrumbs.length===1){delete embeddedFilters[filterKey];}}};return commands;}};registry.category("services").add("knowledgeEmbedViewsFilters",knowledgeEmbedViewsFilters);return __exports;});;

/* /knowledge/static/src/macros/abstract_macro.js */
odoo.define('@knowledge/macros/abstract_macro',['@web/core/l10n/translation','@web/core/confirmation_dialog/confirmation_dialog','@web/core/utils/ui','@web/core/macro'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{AlertDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{isVisible}=require("@web/core/utils/ui");const{Macro}=require("@web/core/macro");class KnowledgeMacroError extends Error{}
const AbstractMacro=__exports.AbstractMacro=class AbstractMacro extends Macro{constructor({targetXmlDoc,breadcrumbs,data,services}){super({name:"restore_recort",steps:[],});this.targetXmlDoc=targetXmlDoc;this.targetBreadcrumbs=breadcrumbs;this.data=data;this.services=services;this.steps=this.buildSteps();}
blockUI(){if(!this.services.ui.isBlocked){this.services.ui.block();}}
buildSteps(){const steps=this.getSteps();if(!steps.length){return[];}
return[{action:()=>this.blockUI(),},{trigger:()=>{return document.querySelector(`.o_knowledge_header i.oi-chevron-left`);},action:async()=>{try{await this.services.action.restore(this.targetBreadcrumbs.at(-1).jsId);}catch{throw new KnowledgeMacroError(_t('The record that this macro is targeting could not be found.'));}},},{trigger:()=>{const controllerBreadcrumbs=this.services.action.currentController.config.breadcrumbs;if(this.targetBreadcrumbs.at(-1).jsId===controllerBreadcrumbs.at(-1)?.jsId){return this.getFirstVisibleElement(".o_breadcrumb .o_last_breadcrumb_item");}
return null;},},...steps,];}
onError(error,step,index){this.blockUI();if(error instanceof KnowledgeMacroError){this.services.dialog.add(AlertDialog,{body:error.message,title:_t("Error"),confirmLabel:_t("Close"),});}else{console.error(error);}}
onTimeout(){throw new KnowledgeMacroError(_t("The operation could not be completed."));}
getFirstVisibleElement(selector,filter=false,reverse=false){const elementsArray=typeof(selector)==='string'?Array.from(document.querySelectorAll(selector)):[selector];const sel=filter?elementsArray.filter(filter):elementsArray;for(let i=0;i<sel.length;i++){i=reverse?sel.length-1-i:i;if(isVisible(sel[i])){return sel[i];}}
return null;}
getSteps(){return[];}
unblockUI(){if(this.services.ui.isBlocked){this.services.ui.unblock();}}
validatePage(){const controllerBreadcrumbs=this.services.action.currentController.config.breadcrumbs;if(this.targetBreadcrumbs.at(-1).jsId!==controllerBreadcrumbs.at(-1)?.jsId){throw new KnowledgeMacroError(_t('The record that this macro is targeting could not be found.'));}}
searchInXmlDocNotebookTab(targetSelector){const searchElement=this.targetXmlDoc.querySelector(targetSelector);const page=searchElement?searchElement.closest('page'):undefined;const pageName=page?page.getAttribute('name'):undefined;if(!pageName){return;}
const pageEl=this.getFirstVisibleElement(`.o_notebook .nav-link[name=${pageName}]:not(.active)`);if(pageEl){pageEl.click();}}}
return __exports;});;

/* /knowledge/static/src/macros/clipboard_macros.js */
odoo.define('@knowledge/macros/clipboard_macros',['@knowledge/macros/abstract_macro','@odoo/hoot-dom','@knowledge/macros/utils'],function(require){'use strict';let __exports={};const{AbstractMacro}=require("@knowledge/macros/abstract_macro");const{click}=require("@odoo/hoot-dom");const{pasteElements,replaceHtmlFieldContentWith}=require("@knowledge/macros/utils");const SendAsMessageMacro=__exports.SendAsMessageMacro=class SendAsMessageMacro extends AbstractMacro{getSteps(){let sendMessageLastClickedEl=null;return[{trigger:()=>{this.validatePage();const el=this.getFirstVisibleElement(".o-mail-Chatter-sendMessage:not([disabled])");if(el){if(el.classList.contains("active")){return el;}else if(el!==sendMessageLastClickedEl){el.click();sendMessageLastClickedEl=el;}}else{this.searchInXmlDocNotebookTab("chatter");}
return null;},},{trigger:()=>{this.validatePage();return this.getFirstVisibleElement(".o-mail-Composer-fullComposer:not([disabled])");},async action(trigger){await click(trigger);},},{trigger:()=>{this.validatePage();const dialog=this.getFirstVisibleElement(".o_dialog .o_mail_composer_form");if(dialog){return this.getFirstVisibleElement(dialog.querySelector('.o_field_html[name="body"] .odoo-editor-editable'));}
return null;},action:(el)=>{replaceHtmlFieldContentWith(this.data.dataTransfer,el);},},{action:()=>this.unblockUI(),},];}}
const UseAsDescriptionMacro=__exports.UseAsDescriptionMacro=class UseAsDescriptionMacro extends AbstractMacro{getSteps(){return[{trigger:()=>this.getFirstVisibleElement(".o_form_editable"),},{trigger:()=>{this.validatePage();const el=this.getFirstVisibleElement(`.o_field_html[name="${this.data.fieldName}"]`,(element)=>element.querySelector(".odoo-editor-editable"));if(el){return el;}
if(this.data.pageName){this.searchInXmlDocNotebookTab(`page[name="${this.data.pageName}"]`);}
return null;},async action(trigger){await click(trigger);},},{trigger:()=>{this.validatePage();return this.getFirstVisibleElement(`.o_field_html[name="${this.data.fieldName}"] .odoo-editor-editable`);},action:(el)=>{el.addEventListener("onHistoryResetFromPeer",(ev)=>pasteElements(this.data.dataTransfer,el),{once:true});pasteElements(this.data.dataTransfer,el);},},{action:()=>this.unblockUI(),},];}}
return __exports;});;

/* /knowledge/static/src/macros/file_macros.js */
odoo.define('@knowledge/macros/file_macros',['@knowledge/macros/abstract_macro','@knowledge/macros/utils'],function(require){'use strict';let __exports={};const{AbstractMacro}=require("@knowledge/macros/abstract_macro");const{dragAndDrop}=require("@knowledge/macros/utils");const UseAsAttachmentMacro=__exports.UseAsAttachmentMacro=class UseAsAttachmentMacro extends AbstractMacro{getSteps(){let attachFilesLastClickedEl=null;return[{trigger:()=>{this.validatePage();const el=this.getFirstVisibleElement(".o-mail-Chatter-attachFiles:not([disabled])",(matchEl)=>{const attachmentsCountEl=matchEl.querySelector("sup");return(attachmentsCountEl&&Number.parseInt(attachmentsCountEl.textContent)>0);});if(el){const attachmentBoxEl=this.getFirstVisibleElement(".o-mail-AttachmentBox .o-mail-AttachmentList");if(attachmentBoxEl){return attachmentBoxEl;}else if(el!==attachFilesLastClickedEl){el.click();attachFilesLastClickedEl=el;}}else{this.searchInXmlDocNotebookTab("chatter");}
return null;},action:(el)=>el.scrollIntoView(),},{action:()=>this.unblockUI(),},];}}
const AttachToMessageMacro=__exports.AttachToMessageMacro=class AttachToMessageMacro extends AbstractMacro{getSteps(){let sendMessageLastClickedEl=null;return[{trigger:()=>{this.validatePage();const el=this.getFirstVisibleElement(".o-mail-Chatter-sendMessage:not([disabled])");if(el){if(el.classList.contains("active")){return el;}else if(el!==sendMessageLastClickedEl){el.click();sendMessageLastClickedEl=el;}}else{this.searchInXmlDocNotebookTab("chatter");}
return null;},action:(el)=>{el.scrollIntoView();},},{trigger:()=>{this.validatePage();return this.getFirstVisibleElement(".o-mail-Composer-attachFiles:not([disabled])");},action:dragAndDrop.bind(this,"dragenter",this.data.dataTransfer),},{trigger:()=>{this.validatePage();return this.getFirstVisibleElement(".o-mail-Composer-dropzone");},action:dragAndDrop.bind(this,"drop",this.data.dataTransfer),},{action:()=>this.unblockUI(),},];}}
return __exports;});;

/* /knowledge/static/src/macros/utils.js */
odoo.define('@knowledge/macros/utils',[],function(require){'use strict';let __exports={};__exports.dragAndDrop=dragAndDrop;function dragAndDrop(type,dataTransfer,target){const fakeDragAndDrop=new Event(type,{bubbles:true,cancelable:true,composed:true,});fakeDragAndDrop.dataTransfer=dataTransfer;target.dispatchEvent(fakeDragAndDrop);}
__exports.pasteElements=pasteElements;function pasteElements(dataTransfer,target){const fakePaste=new Event('paste',{bubbles:true,cancelable:true,composed:true,});fakePaste.clipboardData=dataTransfer;const sel=document.getSelection();sel.removeAllRanges();const range=document.createRange();const lastChild=target.lastChild;if(!lastChild){range.setStart(target,0);range.setEnd(target,0);}else{const subLastChild=lastChild.lastChild;if(subLastChild){if(subLastChild.nodeType===Node.ELEMENT_NODE&&subLastChild.tagName==='BR'){range.setStartBefore(subLastChild);range.setEndBefore(subLastChild);}else{range.setStartAfter(subLastChild);range.setEndAfter(subLastChild);}}else{range.setStartAfter(lastChild);range.setEndAfter(lastChild);}}
const lastElementChild=target.lastElementChild;if(lastElementChild){lastElementChild.scrollIntoView();}else{target.scrollIntoView();}
sel.addRange(range);target.dispatchEvent(fakePaste);}
__exports.replaceHtmlFieldContentWith=replaceHtmlFieldContentWith;function replaceHtmlFieldContentWith(dataTransfer,editable){editable.replaceChildren();const event=new Event("paste",{bubbles:true,cancelable:true,composed:true,});event.clipboardData=dataTransfer;editable.dispatchEvent(event);}
return __exports;});;

/* /whatsapp/static/src/core/common/composer_model_patch.js */
odoo.define('@whatsapp/core/common/composer_model_patch',['@mail/core/common/composer_model'],function(require){'use strict';let __exports={};const{Composer}=require("@mail/core/common/composer_model");Object.assign(Composer.prototype,"whatsapp_composer_model",{threadExpired:false,});return __exports;});;

/* /whatsapp/static/src/core/common/composer_patch.js */
odoo.define('@whatsapp/core/common/composer_patch',['@mail/core/common/composer','@web/core/l10n/translation','@web/core/utils/patch','@odoo/owl'],function(require){'use strict';let __exports={};const{Composer}=require("@mail/core/common/composer");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{onWillDestroy,useEffect}=require("@odoo/owl");patch(Composer.prototype,{setup(){super.setup();this.composerDisableCheckTimeout=null;useEffect(()=>{clearTimeout(this.composerDisableCheckTimeout);this.checkComposerDisabled();},()=>[this.thread?.whatsapp_channel_valid_until]);onWillDestroy(()=>clearTimeout(this.composerDisableCheckTimeout));},get placeholder(){if(this.thread&&this.thread.channel_type==="whatsapp"&&!this.state.active&&this.props.composer.threadExpired){return _t("Can't send message as it has been 24 hours since the last message of the User.");}
return super.placeholder;},checkComposerDisabled(){if(this.thread&&this.thread.channel_type==="whatsapp"){const datetime=this.thread.whatsappChannelValidUntilDatetime;if(!datetime){return;}
const delta=datetime.ts-Date.now();if(delta<=0){this.state.active=false;this.props.composer.threadExpired=true;}else{this.state.active=true;this.props.composer.threadExpired=false;this.composerDisableCheckTimeout=setTimeout(()=>{this.checkComposerDisabled();},delta);}}},get hasSendButtonNonEditing(){if(this.thread?.channel_type==="whatsapp"&&!this.state.active){return false;}
return super.hasSendButtonNonEditing;},get isSendButtonDisabled(){const whatsappInactive=this.thread&&this.thread.channel_type==="whatsapp"&&!this.state.active;return super.isSendButtonDisabled||whatsappInactive;},onDropFile(ev){this.processFileUploading(ev,super.onDropFile.bind(this));},onPaste(ev){if(ev.clipboardData.files.length===0){return super.onPaste(ev);}
this.processFileUploading(ev,super.onPaste.bind(this));},processFileUploading(ev,superCb){if(this.thread?.channel_type==="whatsapp"&&this.props.composer.attachments.length>0){ev.preventDefault();this.env.services.notification.add(_t("Only one attachment is allowed for each message"),{type:"warning"});return;}
superCb(ev);},});return __exports;});;

/* /whatsapp/static/src/core/common/message_model_patch.js */
odoo.define('@whatsapp/core/common/message_model_patch',['@mail/core/common/message_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message_model");const{patch}=require("@web/core/utils/patch");patch(Message.prototype,{get editable(){if(this.thread?.channel_type==="whatsapp"){return false;}
return super.editable;},canReplyTo(thread){return super.canReplyTo(thread)&&!this.thread?.composer?.threadExpired;},});return __exports;});;

/* /whatsapp/static/src/core/common/message_patch.js */
odoo.define('@whatsapp/core/common/message_patch',['@mail/core/common/message','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message");const{patch}=require("@web/core/utils/patch");patch(Message.prototype,{get showSeenIndicator(){return super.showSeenIndicator&&this.message.whatsappStatus!=="error";},async onClick(ev){const id=Number(ev.target.dataset.oeId);if(ev.target.closest(".o_whatsapp_channel_redirect")){ev.preventDefault();let thread=await this.store.Thread.getOrFetch({model:"discuss.channel",id});if(!thread?.hasSelfAsMember){await this.env.services.orm.call("discuss.channel","add_members",[[id]],{partner_ids:[this.store.self.id],});thread=await this.store.Thread.getOrFetch({model:"discuss.channel",id});}
thread.open();return;}
super.onClick(ev);},});return __exports;});;

/* /whatsapp/static/src/core/common/store_service_patch.js */
odoo.define('@whatsapp/core/common/store_service_patch',['@mail/core/common/store_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Store}=require("@mail/core/common/store_service");const{patch}=require("@web/core/utils/patch");patch(Store.prototype,{async getMessagePostParams({thread}){const params=await super.getMessagePostParams(...arguments);if(thread.channel_type==="whatsapp"){params.post_data.message_type="whatsapp_message";}
return params;},async openWhatsAppChannel(id,name){const thread=this.Thread.insert({channel_type:"whatsapp",id,model:"discuss.channel",name,});if(!thread.avatarCacheKey){thread.avatarCacheKey="hello";}
if(!thread.hasSelfAsMember){const data=await this.env.services.orm.call("discuss.channel","whatsapp_channel_join_and_pin",[[id]]);this.insert(data);}else if(!thread.is_pinned){thread.pin();}
thread.open();},});return __exports;});;

/* /whatsapp/static/src/core/common/thread_model_patch.js */
odoo.define('@whatsapp/core/common/thread_model_patch',['@mail/core/common/thread_model','@web/core/utils/patch','@web/core/l10n/dates','@odoo/owl'],function(require){'use strict';let __exports={};const{Thread}=require("@mail/core/common/thread_model");const{patch}=require("@web/core/utils/patch");const{deserializeDateTime}=require("@web/core/l10n/dates");const{toRaw}=require("@odoo/owl");patch(Thread.prototype,{get importantCounter(){if(this.channel_type==="whatsapp"){return this.selfMember?.message_unread_counter||this.message_needaction_counter;}
return super.importantCounter;},get autoOpenChatWindowOnNewMessage(){return this.channel_type==="whatsapp"||super.autoOpenChatWindowOnNewMessage;},get canLeave(){return this.channel_type!=="whatsapp"&&super.canLeave;},get canUnpin(){if(this.channel_type==="whatsapp"){return this.importantCounter===0;}
return super.canUnpin;},get avatarUrl(){if(this.channel_type==="whatsapp"&&this.correspondent){return this.correspondent.persona.avatarUrl;}
return super.avatarUrl;},get isChatChannel(){return this.channel_type==="whatsapp"||super.isChatChannel;},get whatsappChannelValidUntilDatetime(){if(!this.whatsapp_channel_valid_until){return undefined;}
return toRaw(deserializeDateTime(this.whatsapp_channel_valid_until));},});return __exports;});;

/* /whatsapp/static/src/core/common/thread_patch.js */
odoo.define('@whatsapp/core/common/thread_patch',['@mail/core/common/thread','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Thread}=require("@mail/core/common/thread");const{patch}=require("@web/core/utils/patch");patch(Thread.prototype,{isSquashed(msg,prevMsg){if(msg.whatsappStatus==="error"){return false;}
return super.isSquashed(msg,prevMsg);},});return __exports;});;

/* /whatsapp/static/src/core/web/channel_member_list_patch.js */
odoo.define('@whatsapp/core/web/channel_member_list_patch',['@mail/discuss/core/common/channel_member_list','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ChannelMemberList}=require("@mail/discuss/core/common/channel_member_list");const{patch}=require("@web/core/utils/patch");const channelMemberListPatch={canOpenChatWith(member){return(super.canOpenChatWith(member)&&member.persona.notEq(member.thread.whatsapp_partner_id));},};patch(ChannelMemberList.prototype,channelMemberListPatch);return __exports;});;

/* /whatsapp/static/src/core/web/channel_selector_patch.js */
odoo.define('@whatsapp/core/web/channel_selector_patch',['@mail/discuss/core/web/channel_selector','@mail/utils/common/format','@web/core/utils/patch','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{ChannelSelector}=require("@mail/discuss/core/web/channel_selector");const{cleanTerm}=require("@mail/utils/common/format");const{patch}=require("@web/core/utils/patch");const{_t}=require("@web/core/l10n/translation");patch(ChannelSelector.prototype,{async fetchSuggestions(){const cleanedTerm=cleanTerm(this.state.value);if(this.props.category.id==="whatsapp"&&cleanedTerm){const domain=[["channel_type","=","whatsapp"],["name","ilike",cleanedTerm],];const results=await this.sequential(()=>this.orm.searchRead("discuss.channel",domain,["name"],{limit:10,}));if(!results){this.state.navigableListProps.options=[];return;}
const choices=results.map((channel)=>{return{channelId:channel.id,classList:"o-mail-ChannelSelector-suggestion",label:channel.name,};});if(choices.length===0){choices.push({classList:"o-mail-ChannelSelector-suggestion",label:_t("No results found"),unselectable:true,});}
this.state.navigableListProps.options=choices;return;}
return super.fetchSuggestions();},onSelect(option){if(this.props.category.id==="whatsapp"){this.store.openWhatsAppChannel(option.channelId,option.label);this.onValidate();}else{super.onSelect(option);}},});return __exports;});;

/* /whatsapp/static/src/core/web/discuss_app_category_model_patch.js */
odoo.define('@whatsapp/core/web/discuss_app_category_model_patch',['@web/core/utils/patch','@mail/core/public_web/discuss_app_category_model','@mail/utils/common/misc'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{DiscussAppCategory}=require("@mail/core/public_web/discuss_app_category_model");const{compareDatetime}=require("@mail/utils/common/misc");patch(DiscussAppCategory.prototype,{sortThreads(t1,t2){if(this.id==="whatsapp"){return compareDatetime(t2.lastInterestDt,t1.lastInterestDt)||t2.id-t1.id;}
return super.sortThreads(t1,t2);},});return __exports;});;

/* /whatsapp/static/src/core/public_web/discuss_app_model_patch.js */
odoo.define('@whatsapp/core/public_web/discuss_app_model_patch',['@mail/core/public_web/discuss_app_model','@mail/core/common/record','@web/core/l10n/translation','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{DiscussApp}=require("@mail/core/public_web/discuss_app_model");const{Record}=require("@mail/core/common/record");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");patch(DiscussApp,{new(data){const res=super.new(data);res.whatsapp={extraClass:"o-mail-DiscussSidebarCategory-whatsapp",icon:"fa fa-whatsapp",id:"whatsapp",name:_t("WhatsApp"),hideWhenEmpty:true,canView:false,canAdd:true,addTitle:_t("Search WhatsApp Channel"),serverStateKey:"is_discuss_sidebar_category_whatsapp_open",sequence:20,};return res;},});patch(DiscussApp.prototype,{setup(env){super.setup(env);this.whatsapp=Record.one("DiscussAppCategory");},});return __exports;});;

/* /whatsapp/static/src/core/public_web/messaging_menu_patch.js */
odoo.define('@whatsapp/core/public_web/messaging_menu_patch',['@mail/core/public_web/messaging_menu','@mail/core/common/thread_icon','@web/core/utils/patch','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{MessagingMenu}=require("@mail/core/public_web/messaging_menu");const{ThreadIcon}=require("@mail/core/common/thread_icon");const{patch}=require("@web/core/utils/patch");const{_t}=require("@web/core/l10n/translation");patch(MessagingMenu,{components:{...MessagingMenu.components,ThreadIcon},});patch(MessagingMenu.prototype,{get tabs(){const items=super.tabs;const hasWhatsApp=Object.values(this.store.Thread.records).some(({channel_type})=>channel_type==="whatsapp");if(hasWhatsApp){items.push({icon:"fa fa-whatsapp",id:"whatsapp",label:_t("WhatsApp"),});}
return items;},get displayStartConversation(){return super.displayStartConversation&&this.store.discuss.activeTab!=="whatsapp";},});return __exports;});;

/* /whatsapp/static/src/core/public_web/thread_model_patch.js */
odoo.define('@whatsapp/core/public_web/thread_model_patch',['@mail/core/common/thread_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Thread}=require("@mail/core/common/thread_model");const{patch}=require("@web/core/utils/patch");patch(Thread.prototype,{_computeDiscussAppCategory(){return this.channel_type==="whatsapp"?this.store.discuss.whatsapp:super._computeDiscussAppCategory();},});return __exports;});;

/* /whatsapp/static/src/discuss/core/common/thread_model_patch.js */
odoo.define('@whatsapp/discuss/core/common/thread_model_patch',['@mail/core/common/record','@mail/core/common/thread_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{Thread}=require("@mail/core/common/thread_model");const{patch}=require("@web/core/utils/patch");const threadPatch={setup(){super.setup(...arguments);this.whatsapp_partner_id=Record.one("Persona");this.whatsappMember=Record.one("ChannelMember",{compute(){return(this.channel_type==="whatsapp"&&this.channelMembers.find((member)=>member.persona?.eq(this.whatsapp_partner_id)));},});},_computeOfflineMembers(){const res=super._computeOfflineMembers();if(this.channel_type==="whatsapp"){return res.filter((member)=>member.persona?.notEq(this.whatsapp_partner_id));}
return res;},get hasMemberList(){return this.channel_type==="whatsapp"||super.hasMemberList;},};patch(Thread.prototype,threadPatch);return __exports;});;

/* /whatsapp/static/src/chatter/web/chatter_patch.js */
odoo.define('@whatsapp/chatter/web/chatter_patch',['@mail/chatter/web_portal/chatter','@web/core/l10n/translation','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Chatter}=require("@mail/chatter/web_portal/chatter");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");patch(Chatter.prototype,{sendWhatsapp(){const send=async(thread)=>{await new Promise((resolve)=>{this.env.services.action.doAction({type:"ir.actions.act_window",name:_t("Send WhatsApp Message"),res_model:"whatsapp.composer",view_mode:"form",views:[[false,"form"]],target:"new",context:{active_model:thread.model,active_id:thread.id,},},{onClose:resolve});});this.store.Thread.insert({model:this.props.threadModel,id:this.props.threadId,}).fetchNewMessages();};if(this.state.thread.id){send(this.state.thread);}else{this.onThreadCreated=send;this.props.saveRecord?.();}},});return __exports;});;

/* /whatsapp/static/src/components/phone_field/phone_field.js */
odoo.define('@whatsapp/components/phone_field/phone_field',['@web/core/l10n/translation','@web/core/utils/patch','@web/views/fields/phone/phone_field','@whatsapp/components/whatsapp_button/whatsapp_button'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{PhoneField,phoneField,formPhoneField}=require("@web/views/fields/phone/phone_field");const{SendWhatsAppButton}=require("@whatsapp/components/whatsapp_button/whatsapp_button");patch(PhoneField,{components:{...PhoneField.components,SendWhatsAppButton,},defaultProps:{...PhoneField.defaultProps,enableWhatsAppButton:true,},props:{...PhoneField.props,enableWhatsAppButton:{type:Boolean,optional:true},},});const patchDescr={extractProps({options}){const props=super.extractProps(...arguments);props.enableWhatsAppButton=options.enable_whatsapp;return props;},supportedOptions:[...(phoneField.supportedOptions?phoneField.supportedOptions:[]),{label:_t("Enable WhatsApp"),name:"enable_whatsapp",type:"boolean",default:true,},],};patch(phoneField,patchDescr);patch(formPhoneField,patchDescr);return __exports;});;

/* /whatsapp/static/src/components/whatsapp_button/whatsapp_button.js */
odoo.define('@whatsapp/components/whatsapp_button/whatsapp_button',['@web/core/l10n/translation','@web/core/user','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const SendWhatsAppButton=__exports.SendWhatsAppButton=class SendWhatsAppButton extends Component{static template="whatsapp.SendWhatsAppButton";static props=["*"];setup(){this.action=useService("action");this.title=_t("Send WhatsApp Message");}
async onClick(){await this.props.record.save();this.action.doAction({type:"ir.actions.act_window",target:"new",name:this.title,res_model:"whatsapp.composer",views:[[false,"form"]],context:{...user.context,active_model:this.props.record.resModel,active_id:this.props.record.resId,default_phone:this.props.record.data[this.props.name],},},{onClose:()=>{this.props.record.load();this.props.record.model.notify();},});}}
return __exports;});;

/* /whatsapp/static/src/components/whatsapp_variables_text_field/whatsapp_variables_text_field.js */
odoo.define('@whatsapp/components/whatsapp_variables_text_field/whatsapp_variables_text_field',['@web/core/l10n/translation','@web/core/browser/browser','@web/core/registry','@web/views/fields/text/text_field','@web/core/tooltip/tooltip','@web/core/popover/popover_hook','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");const{TextField,textField}=require("@web/views/fields/text/text_field");const{Tooltip}=require("@web/core/tooltip/tooltip");const{usePopover}=require("@web/core/popover/popover_hook");const{useRef}=require("@odoo/owl");const WhatsappVariablesTextField=__exports.WhatsappVariablesTextField=class WhatsappVariablesTextField extends TextField{static template="whatsapp.WhatsappVariablesTextField";static components={...TextField.components};setup(){super.setup();this.textareaRef=useRef('textarea');this.variablesButton=useRef('variablesButton');this.popover=usePopover(Tooltip,{animation:false,position:"left"});}
_onClickAddVariables(){const originalContent=this.textareaRef.el.value;const start=this.textareaRef.el.selectionStart;const end=this.textareaRef.el.selectionEnd;const matches=Array.from(originalContent.matchAll(/{{(\d+)}}/g));const integerList=matches.map(match=>parseInt(match[1]));const nextVariable=Math.max(...integerList,0)+1;if(nextVariable>10){this.popover.open(this.variablesButton.el,{tooltip:_t("You can set a maximum of 10 variables.")});browser.setTimeout(this.popover.close,2600);return;}
const separator=originalContent.slice(0,start)?' ':'';this.textareaRef.el.value=originalContent.slice(0,start)+separator+'{{'+nextVariable+'}}'+originalContent.slice(end,originalContent.length);this.textareaRef.el.dispatchEvent(new InputEvent("input"));this.textareaRef.el.dispatchEvent(new KeyboardEvent("keydown",{key:'Enter'}));this.textareaRef.el.focus();const newCursorPos=start+separator.length+nextVariable.toString().length+4;this.textareaRef.el.setSelectionRange(newCursorPos,newCursorPos);}}
const whatsappVariablesTextField=__exports.whatsappVariablesTextField={...textField,component:WhatsappVariablesTextField,additionalClasses:[...(textField.additionalClasses||[]),"o_field_text"],};registry.category("fields").add("whatsapp_text_variables",whatsappVariablesTextField);return __exports;});;

/* /whatsapp/static/src/views/whatsapp_channel_list/whatsapp_channel_list_view.js */
odoo.define('@whatsapp/views/whatsapp_channel_list/whatsapp_channel_list_view',['@web/views/list/list_view','@web/core/registry','@whatsapp/views/whatsapp_channel_list/whatsapp_channel_list_view_controller'],function(require){'use strict';let __exports={};const{listView}=require("@web/views/list/list_view");const{registry}=require("@web/core/registry");const{WhatsappChannelListController}=require("@whatsapp/views/whatsapp_channel_list/whatsapp_channel_list_view_controller");const whatsappChannelListView={...listView,Controller:WhatsappChannelListController,};registry.category("views").add("whatsapp.discuss_channel_list",whatsappChannelListView);return __exports;});;

/* /whatsapp/static/src/views/whatsapp_channel_list/whatsapp_channel_list_view_controller.js */
odoo.define('@whatsapp/views/whatsapp_channel_list/whatsapp_channel_list_view_controller',['@odoo/owl','@web/views/list/list_controller','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{useState}=require("@odoo/owl");const{ListController}=require("@web/views/list/list_controller");const{useService}=require("@web/core/utils/hooks");const WhatsappChannelListController=__exports.WhatsappChannelListController=class WhatsappChannelListController extends ListController{setup(){super.setup(...arguments);this.store=useState(useService("mail.store"));}
async openRecord(record){const thread=await this.store.Thread.getOrFetch({model:"discuss.channel",id:record.resId,});if(thread){return thread.open();}
return super.openRecord(record);}}
return __exports;});;

/* /helpdesk/static/src/components/helpdesk_sla_many2many_tags/helpdesk_sla_many2many_tags.js */
odoo.define('@helpdesk/components/helpdesk_sla_many2many_tags/helpdesk_sla_many2many_tags',['@web/core/registry','@web/views/fields/many2many_tags/many2many_tags_field','@helpdesk/components/helpdesk_sla_tags_list/helpdesk_sla_tags_list'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Many2ManyTagsField,many2ManyTagsField,}=require("@web/views/fields/many2many_tags/many2many_tags_field");const{HelpdeskSLATagsList}=require("@helpdesk/components/helpdesk_sla_tags_list/helpdesk_sla_tags_list");class HelpdeskSLAMany2ManyTags extends Many2ManyTagsField{static components={...Many2ManyTagsField.components,TagsList:HelpdeskSLATagsList};getTagProps(record){return{...super.getTagProps(record),slaStatus:record.data.status};}}
const helpdeskSLAMany2ManyTags=__exports.helpdeskSLAMany2ManyTags={...many2ManyTagsField,component:HelpdeskSLAMany2ManyTags,relatedFields:(fieldInfo)=>{return[...many2ManyTagsField.relatedFields(fieldInfo),{name:"status",type:"selection",selection:[]},];},additionalClasses:[...(many2ManyTagsField.additionalClasses||[]),"o_field_many2many_tags"],};registry.category("fields").add("helpdesk_sla_many2many_tags",helpdeskSLAMany2ManyTags);return __exports;});;

/* /helpdesk/static/src/components/helpdesk_sla_tags_list/helpdesk_sla_tags_list.js */
odoo.define('@helpdesk/components/helpdesk_sla_tags_list/helpdesk_sla_tags_list',['@web/core/tags_list/tags_list'],function(require){'use strict';let __exports={};const{TagsList}=require("@web/core/tags_list/tags_list");const HelpdeskSLATagsList=__exports.HelpdeskSLATagsList=class HelpdeskSLATagsList extends TagsList{static template="helpdesk.SLATagsList";getSLAStatusIcon(tag){let iconType="";if(tag.slaStatus==="failed"){iconType="times";}else if(tag.slaStatus==="reached"){iconType="check";}
return iconType?`fa fa-${iconType}-circle me-2`:"";}}
return __exports;});;

/* /helpdesk/static/src/components/helpdesk_team_dashboard/helpdesk_team_dashboard.js */
odoo.define('@helpdesk/components/helpdesk_team_dashboard/helpdesk_team_dashboard',['@web/core/user','@web/views/fields/formatters','@web/core/utils/numbers','@web/core/utils/hooks','@helpdesk/components/helpdesk_team_target/helpdesk_team_target','@odoo/owl'],function(require){'use strict';let __exports={};const{user}=require('@web/core/user');const{formatFloatTime}=require('@web/views/fields/formatters');const{formatFloat}=require("@web/core/utils/numbers");const{useService}=require("@web/core/utils/hooks");const{HelpdeskTeamTarget}=require("@helpdesk/components/helpdesk_team_target/helpdesk_team_target");const{Component,useState,onWillStart}=require("@odoo/owl");const HelpdeskTeamDashboard=__exports.HelpdeskTeamDashboard=class HelpdeskTeamDashboard extends Component{static template="helpdesk.HelpdeskTeamDashboard";static components={HelpdeskTeamTarget,};static props={};setup(){this.action=useService('action');this.orm=useService('orm');this.state=useState({dashboardValues:null,});onWillStart(this.onWillStart);}
get showDemo(){return Boolean(this.state.dashboardValues)&&this.state.dashboardValues.show_demo;}
get demoClass(){return this.showDemo?'o_demo o_disabled o_cursor_default':'';}
async onWillStart(){await this._fetchData();}
async updateHelpdeskTarget(targetName,value){await this.orm.write('res.users',[user.userId],{[targetName]:value},);this.state.dashboardValues[targetName]=value;}
async onActionClicked(e){if(this.showDemo){return;}
const action=e.currentTarget;const actionRef=action.getAttribute('name');const title=action.dataset.actionTitle||action.getAttribute('title');const searchViewRef=action.getAttribute('search_view_ref');const buttonContext=action.getAttribute('context')||'';if(action.getAttribute('name').includes('helpdesk.')){return await this.action.doActionButton({resModel:'helpdesk.ticket',name:'create_action',args:JSON.stringify([actionRef,title,searchViewRef]),context:'',buttonContext,type:'object',});}else{if(['action_view_rating_today','action_view_rating_7days'].includes(actionRef)){return this.action.doActionButton({resModel:'helpdesk.team',name:actionRef,context:'',buttonContext,type:'object',});}
return this.action.doAction(actionRef);}}
async _fetchData(){this.state.dashboardValues=await this.orm.call('helpdesk.team','retrieve_dashboard',[],{context:user.context},);}
formatFloat(value,options={}){return formatFloat(value,options);}
formatTime(value,options={}){return formatFloatTime(value,options);}
parseInteger(value){return parseInt(value);}}
return __exports;});;

/* /helpdesk/static/src/components/helpdesk_team_target/helpdesk_team_target.js */
odoo.define('@helpdesk/components/helpdesk_team_target/helpdesk_team_target',['@web/core/l10n/translation','@web/core/l10n/localization','@web/core/utils/strings','@web/core/utils/hooks','@web/views/fields/formatters','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{localization}=require("@web/core/l10n/localization");const{escapeRegExp}=require("@web/core/utils/strings");const{useAutofocus,useService}=require("@web/core/utils/hooks");const{formatFloat,formatPercentage}=require("@web/views/fields/formatters");const{Component,useRef,useState}=require("@odoo/owl");const HelpdeskTeamTarget=__exports.HelpdeskTeamTarget=class HelpdeskTeamTarget extends Component{static template="helpdesk.HelpdeskTeamTarget";static props={showDemo:{type:Boolean,optional:true},demoClass:{type:String,optional:true},update:Function,percentage:{type:Boolean,optional:true},rating:{type:Boolean,optional:true},value:Number,hotkey:{type:String,optional:true},};static defaultProps={showDemo:false,demoClass:"",percentage:false,rating:false,};setup(){useAutofocus({refName:'inputRef',selectAll:true});this.inputRef=useRef("inputRef");this.notification=useService("notification");this.state=useState({isFocused:false,value:this.props.value,});}
get valueString(){return this.props.rating?`${this.state.value} / 5`:!this.props.percentage?this.state.value:formatPercentage(this.state.value/100);}
get helpdeskTeamTargetTitle(){if(this.props.showDemo){return _t("Average rating daily target");}else if(this.props.rating){return _t("Click to Set Your Daily Rating Target");}else{return _t("Click to set");}}
_toggleFocus(){this.state.isFocused=!this.state.isFocused;}
_onInputKeydown(ev){if(ev.key==='Enter'){this.inputRef.el.blur();}}
async _onValueChange(){let inputValue=this.inputRef.el.value;inputValue=inputValue.replaceAll(new RegExp(escapeRegExp(localization.thousandsSep||""),"g")||",","");const targetValue=this.props.rating?parseFloat(inputValue):parseInt(inputValue);if(Number.isNaN(targetValue)){this.notification.add(_t("Please enter a number."),{type:"danger"});return;}
if(targetValue<=0){this.notification.add(_t("Please enter a positive value."),{type:"danger"});return;}
if(this.props.percentage&&targetValue>100){this.notification.add(_t("Please enter a percentage below 100."),{type:"danger"});return;}else if(this.props.rating&&targetValue>5){this.notification.add(_t("Please enter a value less than or equal to 5."),{type:"danger",});return;}
this.state.value=formatFloat(targetValue,{digits:[1,0]});await this.props.update(targetValue);}}
return __exports;});;

/* /helpdesk/static/src/components/helpdesk_ticket_smiley_badge/helpdesk_ticket_smiley_badge.js */
odoo.define('@helpdesk/components/helpdesk_ticket_smiley_badge/helpdesk_ticket_smiley_badge',['@web/core/registry','@web/views/fields/badge/badge_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{BadgeField}=require("@web/views/fields/badge/badge_field");const HelpdeskSmileBadge=__exports.HelpdeskSmileBadge=class HelpdeskSmileBadge extends BadgeField{static template="helpdesk.SmileyBadge";}
const helpdeskSmileBadge=__exports.helpdeskSmileBadge={component:HelpdeskSmileBadge,};registry.category("fields").add("helpdesk_smiley_badge",helpdeskSmileBadge);return __exports;});;

/* /helpdesk/static/src/views/helpdesk_team_form/helpdesk_team_form_controller.js */
odoo.define('@helpdesk/views/helpdesk_team_form/helpdesk_team_form_controller',['@web/views/form/form_controller','@odoo/owl'],function(require){'use strict';let __exports={};const{FormController}=require("@web/views/form/form_controller");const{onMounted,onWillStart,onPatched}=require("@odoo/owl");const HelpdeskTeamController=__exports.HelpdeskTeamController=class HelpdeskTeamController extends FormController{setup(){super.setup();this.reloadInstall=false;this.fieldsToObserve={};this.featuresToObserve={};this.featuresToCheck=[];this.helpdeskResId=this.props.resId;onWillStart(this.onWillStart);onMounted(()=>{this.updateFieldsToObserve();});onPatched(this.onPatched);}
async onWillStart(){this.featuresToObserve=await this.orm.call(this.modelParams.config.resModel,"check_features_enabled",[]);}
onPatched(){if(this.helpdeskResId!==this.model.root.resId){this.helpdeskResId=this.model.root.resId;this.fieldsToObserve={};this.updateFieldsToObserve();}}
updateFieldsToObserve(){for(const[fieldName,value]of Object.entries(this.model.root.data)){if(fieldName.startsWith("use_")){this.fieldsToObserve[fieldName]=value;}}}
async onWillSaveRecord(record,changes){const res=await super.onWillSaveRecord(...arguments);const fields=[];for(const[fName,value]of Object.entries(changes)){if(value&&fName in this.fieldsToObserve&&this.fieldsToObserve[fName]!==value){fields.push(fName);}
if(fName in this.featuresToObserve&&value!==this.featuresToObserve[fName]){this.featuresToCheck.push(fName);}}
if(Object.keys(fields).length){this.reloadInstall=await record.model.orm.call(record.resModel,"check_modules_to_install",[fields]);}
return res;}
async onRecordSaved(record){await super.onRecordSaved(...arguments);let updatedEnabledFeatures={};if(!this.reloadInstall&&this.featuresToCheck.length){updatedEnabledFeatures=await record.model.orm.call(record.resModel,"check_features_enabled",[this.featuresToCheck]);}
if(this.reloadInstall||Object.entries(updatedEnabledFeatures).some(([fName,value])=>value!==this.featuresToObserve[fName])){this.reloadInstall=false;this.model.action.doAction("reload_context");}
this.updateFieldsToObserve();this.featuresToCheck=[];}}
return __exports;});;

/* /helpdesk/static/src/views/helpdesk_team_form/helpdesk_team_form_view.js */
odoo.define('@helpdesk/views/helpdesk_team_form/helpdesk_team_form_view',['@web/core/registry','@web/views/form/form_view','@helpdesk/views/helpdesk_team_form/helpdesk_team_form_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");const{HelpdeskTeamController}=require("@helpdesk/views/helpdesk_team_form/helpdesk_team_form_controller");registry.category("views").add("helpdesk_team_form",{...formView,Controller:HelpdeskTeamController,});return __exports;});;

/* /helpdesk/static/src/views/helpdesk_team_kanban/helpdesk_team_kanban_controller.js */
odoo.define('@helpdesk/views/helpdesk_team_kanban/helpdesk_team_kanban_controller',['@web/views/kanban/kanban_controller','@helpdesk/components/helpdesk_team_dashboard/helpdesk_team_dashboard'],function(require){'use strict';let __exports={};const{KanbanController}=require('@web/views/kanban/kanban_controller');const{HelpdeskTeamDashboard}=require('@helpdesk/components/helpdesk_team_dashboard/helpdesk_team_dashboard');const HelpdeskTeamKanbanController=__exports.HelpdeskTeamKanbanController=class HelpdeskTeamKanbanController extends KanbanController{static template="helpdesk.HelpdeskTeamKanbanView";static components={...KanbanController.components,HelpdeskTeamDashboard,};}
return __exports;});;

/* /helpdesk/static/src/views/helpdesk_team_kanban/helpdesk_team_kanban_view.js */
odoo.define('@helpdesk/views/helpdesk_team_kanban/helpdesk_team_kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@helpdesk/views/helpdesk_team_kanban/helpdesk_team_kanban_controller'],function(require){'use strict';let __exports={};const{registry}=require('@web/core/registry');const{kanbanView}=require('@web/views/kanban/kanban_view');const{HelpdeskTeamKanbanController}=require("@helpdesk/views/helpdesk_team_kanban/helpdesk_team_kanban_controller");const HelpdeskTeamKanbanView=__exports.HelpdeskTeamKanbanView={...kanbanView,Controller:HelpdeskTeamKanbanController,searchview_hidden:true,};registry.category('views').add('helpdesk_team_kanban_view',HelpdeskTeamKanbanView);return __exports;});;

/* /helpdesk/static/src/views/helpdesk_ticket_kanban/helpdesk_ticket_kanban_header.js */
odoo.define('@helpdesk/views/helpdesk_ticket_kanban/helpdesk_ticket_kanban_header',['@web/core/l10n/translation','@web/core/utils/hooks','@web/views/kanban/kanban_header'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{KanbanHeader}=require("@web/views/kanban/kanban_header");const HelpdeskTicketKanbanHeader=__exports.HelpdeskTicketKanbanHeader=class HelpdeskTicketKanbanHeader extends KanbanHeader{setup(){super.setup();this.action=useService("action");}
_getEmptyGroupLabel(fieldName){if(fieldName==="sla_deadline"){return _t("Deadline reached");}else{return super._getEmptyGroupLabel(fieldName);}}
async deleteGroup(){if(this.group.groupByField.name==="stage_id"){const action=await this.group.model.orm.call(this.group.groupByField.relation,"action_unlink_wizard",[this.group.value],{context:this.group.context});this.action.doAction(action);return;}
super.deleteGroup();}}
return __exports;});;

/* /helpdesk/static/src/views/helpdesk_ticket_kanban/helpdesk_ticket_kanban_renderer.js */
odoo.define('@helpdesk/views/helpdesk_ticket_kanban/helpdesk_ticket_kanban_renderer',['@web/views/kanban/kanban_renderer','@helpdesk/views/helpdesk_ticket_kanban/helpdesk_ticket_kanban_header','@odoo/owl','@web/core/user'],function(require){'use strict';let __exports={};const{KanbanRenderer}=require('@web/views/kanban/kanban_renderer');const{HelpdeskTicketKanbanHeader}=require("@helpdesk/views/helpdesk_ticket_kanban/helpdesk_ticket_kanban_header");const{onWillStart}=require("@odoo/owl");const{user}=require("@web/core/user");const HelpdeskTicketRenderer=__exports.HelpdeskTicketRenderer=class HelpdeskTicketRenderer extends KanbanRenderer{static components={...KanbanRenderer.components,KanbanHeader:HelpdeskTicketKanbanHeader,};setup(){super.setup();onWillStart(async()=>{this.isHelpdeskManager=await user.hasGroup('helpdesk.group_helpdesk_manager');});}
canCreateGroup(){return super.canCreateGroup()&&!!this.props.list.context.default_team_id;}
get canResequenceGroups(){return super.canResequenceGroups&&this.isHelpdeskManager;}}
return __exports;});;

/* /helpdesk/static/src/views/helpdesk_ticket_kanban/helpdesk_ticket_kanban_view.js */
odoo.define('@helpdesk/views/helpdesk_ticket_kanban/helpdesk_ticket_kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@helpdesk/views/helpdesk_ticket_kanban/helpdesk_ticket_kanban_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require('@web/views/kanban/kanban_view');const{HelpdeskTicketRenderer}=require("@helpdesk/views/helpdesk_ticket_kanban/helpdesk_ticket_kanban_renderer");const helpdeskTicketKanbanView=__exports.helpdeskTicketKanbanView={...kanbanView,Renderer:HelpdeskTicketRenderer,};registry.category('views').add('helpdesk_ticket_kanban',helpdeskTicketKanbanView);return __exports;});;

/* /helpdesk/static/src/views/helpdesk_ticket_list/helpdesk_ticket_list_renderer.js */
odoo.define('@helpdesk/views/helpdesk_ticket_list/helpdesk_ticket_list_renderer',['@web/core/l10n/translation','@web/views/list/list_renderer'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ListRenderer}=require("@web/views/list/list_renderer");const HelpdeskTicketListRenderer=__exports.HelpdeskTicketListRenderer=class HelpdeskTicketListRenderer extends ListRenderer{getGroupDisplayName(group){if(group.groupByField.name==="sla_deadline"&&!group.value){return _t("Deadline reached");}else{return super.getGroupDisplayName(group);}}}
return __exports;});;

/* /helpdesk/static/src/views/helpdesk_ticket_list/helpdesk_ticket_list_view.js */
odoo.define('@helpdesk/views/helpdesk_ticket_list/helpdesk_ticket_list_view',['@web/core/registry','@web/views/list/list_view','@helpdesk/views/helpdesk_ticket_list/helpdesk_ticket_list_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require('@web/views/list/list_view');const{HelpdeskTicketListRenderer}=require("@helpdesk/views/helpdesk_ticket_list/helpdesk_ticket_list_renderer");const helpdeskTicketListView=__exports.helpdeskTicketListView={...listView,Renderer:HelpdeskTicketListRenderer,};registry.category("views").add("helpdesk_ticket_list",helpdeskTicketListView);return __exports;});;

/* /helpdesk/static/src/js/tours/helpdesk.js */
odoo.define('@helpdesk/js/tours/helpdesk',['@web/core/l10n/translation','@web/core/registry','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add("helpdesk_tour",{url:"/odoo",steps:()=>[{trigger:'.o_app[data-menu-xmlid="helpdesk.menu_helpdesk_root"]',content:markup(_t('Want to <b>boost your customer satisfaction</b>?<br/><i>Click Helpdesk to start.</i>')),tooltipPosition:'bottom',run:"click",},{trigger:".o_helpdesk_ticket_btn",},{trigger:'button.oe_kanban_action',content:markup(_t('Let\'s view your <b>team\'s tickets</b>.')),tooltipPosition:'bottom',run:"click",},{trigger:".o_helpdesk_ticket_kanban_view",},{trigger:'.o-kanban-button-new',content:markup(_t('Let\'s create your first <b>ticket</b>.')),tooltipPosition:'bottom',run:"click",},{trigger:".o_form_editable",},{trigger:'.o_field_widget input.o_input',content:markup(_t('Enter the <b>subject</b> of your ticket <br/><i>(e.g. Problem with my installation, Wrong order, etc.).</i>')),tooltipPosition:'right',run:"edit SAP is bad, paid by Odoo",},{trigger:".o_form_editable",},{isActive:["manual"],trigger:".o_field_widget[name='partner_id']",content:markup(_t('Select the <b>customer</b> of your ticket.')),tooltipPosition:"top",run:"click",},{isActive:["auto"],trigger:'div[name=partner_id] input',content:markup(_t('Select the <b>customer</b> of your ticket.')),tooltipPosition:'top',run:"edit Admin",},{trigger:".o_form_editable",},{isActive:["auto"],trigger:".ui-autocomplete > li > a:not(:has(i.fa))",run:"click",tooltipPosition:"right",},{trigger:".o_form_view",},{trigger:'.o_kanban_quick_create button.o_kanban_add',content:_t('Save this ticket and the modifications you\'ve made to it.'),tooltipPosition:'bottom',run:"click",},{trigger:".o_form_view",},{trigger:'.o_kanban_record',content:_t('Open the ticket.'),tooltipPosition:'bottom',run:"click",},{trigger:".o_form_view",},{trigger:".o-mail-Chatter-topbar button.o-mail-Chatter-sendMessage",content:markup(_t("Use the chatter to <b>send emails</b> and communicate efficiently with your customers. Add new people to the followers' list to make them aware of the progress of this ticket.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_form_view",},{trigger:"button.o-mail-Chatter-logNote",content:markup(_t("<b>Log notes</b> for internal communications (you will only notify the persons you specifically tag). Use <b>@ mentions</b> to ping a colleague or <b># mentions</b> to contact a group of people.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_form_view .o_form_saved",},{trigger:"button.o-mail-Chatter-activity",content:markup(_t("Use <b>activities</b> to organize your daily work.")),run:"click",},{trigger:".modal-dialog .btn-primary",content:markup(_t("Schedule your <b>activity</b>.")),tooltipPosition:"right",run:"click",},{trigger:".o_form_view",},{trigger:'.o_back_button',content:markup(_t("Let's go back to the <b>kanban view</b> to get an overview of your next tickets.")),tooltipPosition:'bottom',run:"click",},{trigger:'body:not(:has(div.o_view_sample_data)) .o_helpdesk_ticket_kanban_view .o_kanban_record',content:markup(_t('<b>Drag &amp; drop</b> the card to change the stage of your ticket.')),tooltipPosition:'right',run:"drag_and_drop(.o_kanban_group:eq(2))",},{trigger:".o_column_quick_create .o_quick_create_folded",content:markup(_t('Adapt your <b>pipeline</b> to your workflow by adding <b>stages</b> <i>(e.g. Awaiting Customer Feedback, etc.).</i>')),tooltipPosition:'bottom',run:"click",},{trigger:".o_column_quick_create .o_kanban_add",content:_t("Add your stage and place it at the right step of your workflow by dragging & dropping it."),tooltipPosition:'bottom',run:"click",},{trigger:".o_column_quick_create .o_kanban_add",content:"Clicking on 'Add' when input name is empty won't do anything, 'Add' will still be displayed",},],});return __exports;});;

/* /sale_subscription/static/src/js/combo_configurator_dialog/combo_configurator_dialog.js */
odoo.define('@sale_subscription/js/combo_configurator_dialog/combo_configurator_dialog',['@web/core/utils/patch','@sale/js/combo_configurator_dialog/combo_configurator_dialog'],function(require){'use strict';let __exports={};const{patch}=require('@web/core/utils/patch');const{ComboConfiguratorDialog}=require('@sale/js/combo_configurator_dialog/combo_configurator_dialog');patch(ComboConfiguratorDialog,{props:{...ComboConfiguratorDialog.props,subscriptionPlanId:{type:Number,optional:true},},});patch(ComboConfiguratorDialog.prototype,{_getAdditionalRpcParams(){const params=super._getAdditionalRpcParams();if(this.props.subscriptionPlanId){params.plan_id=this.props.subscriptionPlanId;}
return params;},_getAdditionalDialogProps(){const props=super._getAdditionalDialogProps();if(this.props.subscriptionPlanId){props.subscriptionPlanId=this.props.subscriptionPlanId;}
return props;},});return __exports;});;

/* /sale_subscription/static/src/js/product_configurator_dialog/product_configurator_dialog.js */
odoo.define('@sale_subscription/js/product_configurator_dialog/product_configurator_dialog',['@web/core/utils/patch','@sale/js/product_configurator_dialog/product_configurator_dialog'],function(require){'use strict';let __exports={};const{patch}=require('@web/core/utils/patch');const{ProductConfiguratorDialog}=require('@sale/js/product_configurator_dialog/product_configurator_dialog');patch(ProductConfiguratorDialog,{props:{...ProductConfiguratorDialog.props,subscriptionPlanId:{type:Number,optional:true},},});patch(ProductConfiguratorDialog.prototype,{_getAdditionalRpcParams(){const params=super._getAdditionalRpcParams();if(this.props.subscriptionPlanId){params.plan_id=this.props.subscriptionPlanId;}
return params;},});return __exports;});;

/* /sale_subscription/static/src/js/sale_product_field.js */
odoo.define('@sale_subscription/js/sale_product_field',['@web/core/utils/patch','@sale/js/sale_product_field'],function(require){'use strict';let __exports={};const{patch}=require('@web/core/utils/patch');const{SaleOrderLineProductField}=require('@sale/js/sale_product_field');patch(SaleOrderLineProductField.prototype,{_getAdditionalRpcParams(){const params=super._getAdditionalRpcParams();const saleOrder=this.props.record.model.root;if(saleOrder.data.is_subscription){params.plan_id=saleOrder.data.plan_id[0];}
return params;},_getAdditionalDialogProps(){const props=super._getAdditionalDialogProps();const saleOrder=this.props.record.model.root;if(saleOrder.data.is_subscription){props.subscriptionPlanId=saleOrder.data.plan_id[0];}
return props;},});return __exports;});;

/* /sale_subscription/static/src/js/tours/sale_subscription.js */
odoo.define('@sale_subscription/js/tours/sale_subscription',['@web/core/l10n/translation','@web/core/registry','@odoo/owl'],function(require){'use strict';let __exports={};"use_strict";const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add('sale_subscription_tour',{url:"/odoo",steps:()=>[{trigger:'.o_app[data-menu-xmlid="sale_subscription.menu_sale_subscription_root"]',content:_t('Want a recurring billing through subscription management? Get started by clicking here'),tooltipPosition:'bottom',run:"click",},{trigger:'.dropdown-toggle[data-menu-xmlid="sale_subscription.product_menu_catalog"]',content:_t('Let\'s go to the catalog to create our first subscription product'),tooltipPosition:'bottom',run:"click",},{trigger:'.dropdown-item[data-menu-xmlid="sale_subscription.menu_sale_subscription_product"]',content:_t('Create your first subscription product here'),tooltipPosition:'right',run:"click",},{trigger:'.o_kanban_renderer',},{trigger:'.o-kanban-button-new',content:_t('Go ahead and create a new product'),tooltipPosition:'right',run:"click",},{trigger:'.o_form_editable',},{trigger:'#name_0',content:markup(_t('Choose a product name.<br/><i>(e.g. eLearning Access)</i>')),tooltipPosition:'right',run:"click",},{trigger:'.o_form_editable',},{trigger:'a.nav-link[name="subscription_pricing"]',content:_t("Let's add a pricing with a recurrence"),tooltipPosition:'right',run:"click",},{trigger:'.o_form_editable',},{trigger:".o_field_x2many_list_row_add > a",content:_t("Add a new rule"),run:"click",},{trigger:'.o_form_editable',},{trigger:'.o_list_many2one[name="plan_id"]',content:_t("Add a recurring plan for this product, or create a new one with the desired recurrence (e.g., Monthly)"),run:"click",},{trigger:'.o_form_editable',},{trigger:'.o_field_cell[name="price"]',content:_t("Let's add price for selected recurrence"),run:"click",},{trigger:'.dropdown-toggle[data-menu-xmlid="sale_subscription.menu_sale_subscription"]',content:_t('Go back to the subscription view'),tooltipPosition:'bottom',run:"click",},{trigger:'.dropdown-item[data-menu-xmlid="sale_subscription.menu_sale_subscription_action"]',content:_t('Go back to the subscription view'),tooltipPosition:'right',run:"click",},{trigger:'button.o_list_button_add',content:_t('Go ahead and create a new subscription'),tooltipPosition:'right',run:"click",},{trigger:'.o_field_widget[name="partner_id"]',content:_t("Let's choose the customer for your subscription"),tooltipPosition:'right',run:"click",},{trigger:".o_field_x2many_list_row_add > a",content:_t('Click here to add some products or services'),tooltipPosition:'top',run:'click',},{trigger:".o_sale_order",},{trigger:".o_field_widget[name='product_id'], .o_field_widget[name='product_template_id']",content:_t("Select a recurring product"),tooltipPosition:"right",run:"click",},{trigger:'div.o_row',content:_t("Choose the invoice duration for your subscription"),tooltipPosition:"bottom",run:"click",},]});return __exports;});;

/* /planning/static/src/components/address_recurrency_confirmation_dialog/address_recurrency_confirmation_dialog.js */
odoo.define('@planning/components/address_recurrency_confirmation_dialog/address_recurrency_confirmation_dialog',['@web/core/l10n/translation','@web/core/confirmation_dialog/confirmation_dialog'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const AddressRecurrencyConfirmationDialog=__exports.AddressRecurrencyConfirmationDialog=class AddressRecurrencyConfirmationDialog extends ConfirmationDialog{static template="planning.AddressRecurrencyConfirmationDialog";static props={...ConfirmationDialog.props,body:{type:String,optional:true},onChangeRecurrenceUpdate:{type:Function},selected:{type:String},};static defaultProps={...ConfirmationDialog.defaultProps,body:"",cancel:()=>{},title:_t("Delete Recurring Shift")};}
return __exports;});;

/* /planning/static/src/components/avatar_card_employee/avatar_card_employee_patch.js */
odoo.define('@planning/components/avatar_card_employee/avatar_card_employee_patch',['@web/core/utils/patch','@hr/components/avatar_card_employee/avatar_card_employee_popover'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{AvatarCardEmployeePopover}=require("@hr/components/avatar_card_employee/avatar_card_employee_popover");const patchAvatarCardEmployeePopover={get fieldNames(){const excludedFields=["role_ids","default_role_id"];return super.fieldNames.filter((field)=>!excludedFields.includes(field));},}
patch(AvatarCardEmployeePopover.prototype,patchAvatarCardEmployeePopover)
return __exports;});;

/* /planning/static/src/components/avatar_card_resource/avatar_card_resource_popover_patch.js */
odoo.define('@planning/components/avatar_card_resource/avatar_card_resource_popover_patch',['@web/core/utils/patch','@resource_mail/components/avatar_card_resource/avatar_card_resource_popover'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{AvatarCardResourcePopover}=require("@resource_mail/components/avatar_card_resource/avatar_card_resource_popover");const patchAvatarCardResourcePopover=__exports.patchAvatarCardResourcePopover={async onWillStart(){await super.onWillStart();this.roles=this.record.role_ids;},get fieldNames(){const additionalFields=["role_ids"];const excludedFields=["work_location_name","work_location_type"];return[...super.fieldNames,...additionalFields,].filter((field)=>!excludedFields.includes(field));},get roleTags(){return this.roles.map(({id,color,name})=>({id,colorIndex:color,text:name,icon:id===this.record.default_role_id?.[0]&&this.roles.length>1&&"fa-star",className:"o_planning_avatar_role_tag",}));},};const unpatchAvatarCardResourcePopover=__exports.unpatchAvatarCardResourcePopover=patch(AvatarCardResourcePopover.prototype,patchAvatarCardResourcePopover);return __exports;});;

/* /planning/static/src/components/conflicting_slot_ids_field/conflicting_slot_ids_field.js */
odoo.define('@planning/components/conflicting_slot_ids_field/conflicting_slot_ids_field',['@web/core/registry','@web/views/fields/formatters','@web/views/fields/standard_field_props','@web/views/utils','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formatFloatTime}=require("@web/views/fields/formatters");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{getFormattedValue}=require("@web/views/utils");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const ConflictingSlotIdsField=__exports.ConflictingSlotIdsField=class ConflictingSlotIdsField extends Component{static template="planning.ConflictingSlotIdsField";static props={...standardFieldProps,};setup(){this.actionService=useService("action");}
get conflictingSlots(){return this.props.record.data[this.props.name].records.map((r)=>({...r,data:Object.fromEntries(Object.keys(r.data).map((fieldName)=>{let formattedValue="";if(fieldName==="allocated_hours"){formattedValue=formatFloatTime(r.data.allocated_hours,{noLeadingZeroHour:true,}).replace(/(:00|:)/g,"h");}else{formattedValue=getFormattedValue(r,fieldName);}
if(fieldName==="allocated_percentage"){formattedValue+="%";}
return[fieldName,formattedValue];})),}));}
getConflictSlotMessage(slot){return slot.data.role_id;}
async showConflictedSlots(){if(this.props.record.isNew){await this.props.record.save({noReload:true});}
this.actionService.doActionButton({type:"object",resId:this.props.record.resId,name:"action_see_overlaping_slots",resModel:"planning.slot",});}}
const conflictingSlotIdsField=__exports.conflictingSlotIdsField={component:ConflictingSlotIdsField,supportedTypes:["many2many"],relatedFields:()=>{return[{name:"start_datetime",type:"datetime"},{name:"end_datetime",type:"datetime"},{name:"allocated_hours",type:"float_time"},{name:"allocated_percentage",type:"float"},{name:"role_id",type:"many2one",relation:"planning.role"},];},};registry.category("fields").add("conflicting_slot_ids",conflictingSlotIdsField);return __exports;});;

/* /planning/static/src/views/fields/many2many_avatar_resource/many2many_avatar_resource_field.js */
odoo.define('@planning/views/fields/many2many_avatar_resource/many2many_avatar_resource_field',['@web/core/utils/patch','@resource_mail/views/fields/many2many_avatar_resource/many2many_avatar_resource_field','@mail/views/web/fields/many2many_avatar_user_field/many2many_avatar_user_field','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{Many2ManyAvatarResourceField,many2ManyAvatarResourceField,}=require("@resource_mail/views/fields/many2many_avatar_resource/many2many_avatar_resource_field");const{many2ManyTagsAvatarUserField}=require("@mail/views/web/fields/many2many_avatar_user_field/many2many_avatar_user_field");const{_t}=require("@web/core/l10n/translation");const patchM2mResourceFieldPrototype=__exports.patchM2mResourceFieldPrototype={displayAvatarCard(record){return!this.env.isSmall&&this.relation==="resource.resource"&&(record.data.resource_type==="user"||record.data.role_ids.records.length>1);},};const patchM2mResourceField=__exports.patchM2mResourceField={relatedFields:(fieldInfo)=>{return[...many2ManyTagsAvatarUserField.relatedFields(fieldInfo),{name:"resource_type",type:"selection",selection:[["user",_t("Human")],["material",_t("Material")],],},{name:"role_ids",type:"many2many",},];},};patch(Many2ManyAvatarResourceField.prototype,patchM2mResourceFieldPrototype);patch(many2ManyAvatarResourceField,patchM2mResourceField);return __exports;});;

/* /planning/static/src/views/fields/many2one_avatar_resource/many2one_avatar_resource_field_patch.js */
odoo.define('@planning/views/fields/many2one_avatar_resource/many2one_avatar_resource_field_patch',['@web/core/utils/patch','@resource_mail/views/fields/many2one_avatar_resource/many2one_avatar_resource_field'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{Many2OneAvatarResourceField,many2OneAvatarResourceField,KanbanMany2OneAvatarResourceField,kanbanMany2OneAvatarResourceField}=require("@resource_mail/views/fields/many2one_avatar_resource/many2one_avatar_resource_field");const patchM2oResourceFieldPrototype=__exports.patchM2oResourceFieldPrototype={get displayAvatarCard(){return!this.env.isSmall&&this.relation==="resource.resource"&&(this.props.record.data.resource_type=="user"||this.props.record.data.resource_roles?.records.length>1);},};const patchM2oResourceField=__exports.patchM2oResourceField={fieldDependencies:[...many2OneAvatarResourceField.fieldDependencies,{name:"resource_roles",type:"many2many"},{name:"resource_color",type:"integer"},],};patch(Many2OneAvatarResourceField.prototype,patchM2oResourceFieldPrototype);const unpatchM2oResourceFieldPlanning=__exports.unpatchM2oResourceFieldPlanning=patch(many2OneAvatarResourceField,patchM2oResourceField);patch(KanbanMany2OneAvatarResourceField.prototype,patchM2oResourceFieldPrototype);const unpatchKanbanM2oResourceFieldPlanning=__exports.unpatchKanbanM2oResourceFieldPlanning=patch(kanbanMany2OneAvatarResourceField,patchM2oResourceField);return __exports;});;

/* /planning/static/src/views/planning_calendar/common/planning_calendar_common_popover.js */
odoo.define('@planning/views/planning_calendar/common/planning_calendar_common_popover',['@odoo/owl','@web/core/user','@web/views/calendar/calendar_common/calendar_common_popover','@web/views/fields/formatters','@web/core/utils/numbers'],function(require){'use strict';let __exports={};const{onWillStart}=require("@odoo/owl");const{user}=require("@web/core/user");const{CalendarCommonPopover}=require("@web/views/calendar/calendar_common/calendar_common_popover");const{formatFloatTime}=require("@web/views/fields/formatters");const{formatFloat}=require("@web/core/utils/numbers");const PlanningCalendarCommonPopover=__exports.PlanningCalendarCommonPopover=class PlanningCalendarCommonPopover extends CalendarCommonPopover{static subTemplates={...CalendarCommonPopover.subTemplates,body:"planning.PlanningCalendarCommonPopover.body",};setup(){super.setup(...arguments);onWillStart(this.onWillStart);}
async onWillStart(){this.isManager=await user.hasGroup("planning.group_planning_manager");}
get isEventEditable(){return this.isManager&&super.isEventEditable;}
get data(){return this.props.record.rawRecord;}
get allocatedHoursFormatted(){return this.data.allocated_hours&&formatFloatTime(this.data.allocated_hours);}
get allocatedPercentageFormatted(){return this.data.allocated_percentage&&formatFloat(this.data.allocated_percentage);}
get hasFooter(){return this.isManager&&super.hasFooter;}
isSet(fieldName){return this.data[fieldName];}}
return __exports;});;

/* /planning/static/src/views/planning_calendar/common/planning_calendar_common_renderer.js */
odoo.define('@planning/views/planning_calendar/common/planning_calendar_common_renderer',['@web/views/calendar/calendar_common/calendar_common_renderer','@planning/views/planning_calendar/common/planning_calendar_common_popover'],function(require){'use strict';let __exports={};const{CalendarCommonRenderer}=require("@web/views/calendar/calendar_common/calendar_common_renderer");const{PlanningCalendarCommonPopover}=require("@planning/views/planning_calendar/common/planning_calendar_common_popover");const PlanningCalendarCommonRenderer=__exports.PlanningCalendarCommonRenderer=class PlanningCalendarCommonRenderer extends CalendarCommonRenderer{static components={...CalendarCommonRenderer.components,Popover:PlanningCalendarCommonPopover,};onEventRender(info){super.onEventRender(info);const{el,event}=info;const model=this.props.model;const record=model.records[event.id];if(record&&model.highlightIds&&!model.highlightIds.includes(record.id)){el.classList.add("opacity-25");}}}
return __exports;});;

/* /planning/static/src/views/planning_calendar/planning_ask_recurrence_update/planning_ask_recurrence_update_dialog.js */
odoo.define('@planning/views/planning_calendar/planning_ask_recurrence_update/planning_ask_recurrence_update_dialog',['@web/core/l10n/translation','@web/core/dialog/dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Dialog}=require("@web/core/dialog/dialog");const{Component}=require("@odoo/owl");const PlanningAskRecurrenceUpdateDialog=__exports.PlanningAskRecurrenceUpdateDialog=class PlanningAskRecurrenceUpdateDialog extends Component{static template="planning.PlanningAskRecurrenceUpdateDialog";static components={Dialog,};static props={confirm:{type:Function},close:{type:Function},};setup(){this.possibleValues={this:{checked:true,label:_t("This shift"),},subsequent:{checked:false,label:_t("This and following shifts"),},all:{checked:false,label:_t("All shifts"),},};}
get selected(){return Object.entries(this.possibleValues).find(state=>state[1].checked)[0];}
set selected(val){this.possibleValues[this.selected].checked=false;this.possibleValues[val].checked=true;}
confirm(){this.props.confirm(this.selected);this.props.close();}}
return __exports;});;

/* /planning/static/src/views/planning_calendar/planning_ask_recurrence_update/planning_ask_recurrence_update_hook.js */
odoo.define('@planning/views/planning_calendar/planning_ask_recurrence_update/planning_ask_recurrence_update_hook',['@planning/views/planning_calendar/planning_ask_recurrence_update/planning_ask_recurrence_update_dialog'],function(require){'use strict';let __exports={};const{PlanningAskRecurrenceUpdateDialog}=require("@planning/views/planning_calendar/planning_ask_recurrence_update/planning_ask_recurrence_update_dialog");__exports.planningAskRecurrenceUpdate=planningAskRecurrenceUpdate;function planningAskRecurrenceUpdate(dialogService){return new Promise((resolve)=>{dialogService.add(PlanningAskRecurrenceUpdateDialog,{confirm:resolve,},{onClose:resolve.bind(null,false),});});}
return __exports;});;

/* /planning/static/src/views/planning_calendar/planning_calendar_controller.js */
odoo.define('@planning/views/planning_calendar/planning_calendar_controller',['@odoo/owl','@web/core/l10n/dates','@web/core/user','@web/views/calendar/calendar_controller','@planning/views/planning_calendar/planning_filter_panel/planning_calendar_filter_panel','@planning/views/planning_hooks','@web/core/l10n/translation','@web/views/view_dialogs/form_view_dialog','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{onWillStart}=require("@odoo/owl");const{serializeDateTime}=require("@web/core/l10n/dates");const{user}=require("@web/core/user");const{CalendarController}=require("@web/views/calendar/calendar_controller");const{PlanningCalendarFilterPanel}=require("@planning/views/planning_calendar/planning_filter_panel/planning_calendar_filter_panel");const{usePlanningControllerActions}=require("@planning/views/planning_hooks");const{_t}=require("@web/core/l10n/translation");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");const{sprintf}=require("@web/core/utils/strings");const PlanningCalendarController=__exports.PlanningCalendarController=class PlanningCalendarController extends CalendarController{static template="planning.PlanningCalendarController";static components={...CalendarController.components,FilterPanel:PlanningCalendarFilterPanel,};setup(){super.setup(...arguments);onWillStart(this.onWillStart);const getDomain=()=>this.model.computeDomain(this.model.data);this.planningControllerActions=usePlanningControllerActions({getDomain,getStartDate:()=>this.model.rangeStart,getRecords:()=>Object.values(this.model.records),getResModel:()=>this.model.resModel,getAdditionalContext:()=>({default_start_datetime:serializeDateTime(this.model.rangeStart),default_end_datetime:serializeDateTime(this.model.rangeEnd),default_slot_ids:Object.values(this.model.records).map(rec=>rec.id),scale:this.model.scale,active_domain:getDomain(),}),toggleHighlightPlannedFilter:(highlightPlannedIds)=>this.env.searchModel.toggleHighlightPlannedFilter(highlightPlannedIds),reload:()=>this.model.load(),});}
get editRecordDefaultDisplayText(){return _t("New Shift");}
async onWillStart(){this.isManager=await user.hasGroup("planning.group_planning_manager");}
async editRecord(record,context={}){const newContext={...context,is_record_created:!record.id,view_start_date:serializeDateTime(this.model.rangeStart),view_end_date:serializeDateTime(this.model.rangeEnd),};return new Promise((resolve)=>{this.displayDialog(FormViewDialog,{resModel:this.model.resModel,resId:record.id||false,context:newContext,title:record.id?sprintf(_t("Open: %s"),record.title):_t("New Event"),viewId:this.model.formViewId,},{onClose:()=>{this.model.load();resolve();},});});}}
return __exports;});;

/* /planning/static/src/views/planning_calendar/planning_calendar_model.js */
odoo.define('@planning/views/planning_calendar/planning_calendar_model',['@web/views/calendar/calendar_model','@planning/views/planning_hooks','@planning/views/planning_calendar/planning_ask_recurrence_update/planning_ask_recurrence_update_hook','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{CalendarModel}=require("@web/views/calendar/calendar_model");const{usePlanningModelActions}=require("@planning/views/planning_hooks");const{planningAskRecurrenceUpdate}=require("@planning/views/planning_calendar/planning_ask_recurrence_update/planning_ask_recurrence_update_hook");const{_t}=require("@web/core/l10n/translation");const PlanningCalendarModel=__exports.PlanningCalendarModel=class PlanningCalendarModel extends CalendarModel{static services=[...CalendarModel.services,"dialog","orm"];setup(params,services){super.setup(...arguments);this.dialog=services.dialog;this.getHighlightIds=usePlanningModelActions({getHighlightPlannedIds:()=>this.env.searchModel.highlightPlannedIds,getContext:()=>this.env.searchModel._context,}).getHighlightIds;this.meta.scale=this.env.isSmall?"day":this.meta.scale;}
get defaultFilterLabel(){return _t("Open Shifts");}
addFilterFields(record,filterInfo){if(filterInfo.fieldName=='resource_id'){return{colorIndex:record.rawRecord.resource_type=='material'?record.rawRecord['resource_color']:'',resourceType:record.rawRecord['resource_type'],};}
return{...super.addFilterFields(record,filterInfo),resourceType:record.rawRecord['resource_type'],};}
async loadRecords(data){this.highlightIds=await this.getHighlightIds();return await super.loadRecords(data);}
async updateRecord(record){const rec=this.records[record.id];if(rec.rawRecord.repeat){const recurrenceUpdate=await planningAskRecurrenceUpdate(this.dialog);if(!recurrenceUpdate){return this.notify();}
record.recurrenceUpdate=recurrenceUpdate;}
return await super.updateRecord(...arguments);}
buildRawRecord(partialRecord,options={}){const result=super.buildRawRecord(partialRecord,options);if(partialRecord.recurrenceUpdate){result.recurrence_update=partialRecord.recurrenceUpdate;}
return result;}
makeFilterDynamic(filterInfo,previousFilter,fieldName,rawFilter,rawColors){return{...super.makeFilterDynamic(filterInfo,previousFilter,fieldName,rawFilter,rawColors),resourceType:rawFilter['resourceType'],colorIndex:rawFilter['colorIndex'],};}
makeContextDefaults(rawRecord){const context=super.makeContextDefaults(...arguments);if(["day","week"].includes(this.meta.scale)){context['planning_keep_default_datetime']=true;}
return context;}
getAllDayDates(start,end){return[start.startOf('day'),end.endOf('day')];}}
return __exports;});;

/* /planning/static/src/views/planning_calendar/planning_calendar_renderer.js */
odoo.define('@planning/views/planning_calendar/planning_calendar_renderer',['@web/views/calendar/calendar_renderer','@planning/views/planning_calendar/common/planning_calendar_common_renderer'],function(require){'use strict';let __exports={};const{CalendarRenderer}=require("@web/views/calendar/calendar_renderer");const{PlanningCalendarCommonRenderer}=require("@planning/views/planning_calendar/common/planning_calendar_common_renderer");const PlanningCalendarRenderer=__exports.PlanningCalendarRenderer=class PlanningCalendarRenderer extends CalendarRenderer{static components={...CalendarRenderer.components,day:PlanningCalendarCommonRenderer,week:PlanningCalendarCommonRenderer,month:PlanningCalendarCommonRenderer,};}
return __exports;});;

/* /planning/static/src/views/planning_calendar/planning_calendar_view.js */
odoo.define('@planning/views/planning_calendar/planning_calendar_view',['@web/core/registry','@web/views/calendar/calendar_view','@planning/views/planning_calendar/planning_calendar_model','@planning/views/planning_calendar/planning_calendar_controller','@planning/views/planning_calendar/planning_calendar_renderer','@planning/views/planning_search_model'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{calendarView}=require("@web/views/calendar/calendar_view");const{PlanningCalendarModel}=require("@planning/views/planning_calendar/planning_calendar_model");const{PlanningCalendarController}=require("@planning/views/planning_calendar/planning_calendar_controller");const{PlanningCalendarRenderer}=require("@planning/views/planning_calendar/planning_calendar_renderer");const{PlanningSearchModel}=require("@planning/views/planning_search_model");const planningCalendarView=__exports.planningCalendarView={...calendarView,SearchModel:PlanningSearchModel,Model:PlanningCalendarModel,Controller:PlanningCalendarController,Renderer:PlanningCalendarRenderer,buttonTemplate:"planning.PlanningCalendarController.controlButtons",};registry.category("views").add("planning_calendar",planningCalendarView);return __exports;});;

/* /planning/static/src/views/planning_calendar/planning_filter_panel/planning_calendar_filter_panel.js */
odoo.define('@planning/views/planning_calendar/planning_filter_panel/planning_calendar_filter_panel',['@web/views/calendar/filter_panel/calendar_filter_panel'],function(require){'use strict';let __exports={};const{CalendarFilterPanel}=require("@web/views/calendar/filter_panel/calendar_filter_panel");const PlanningCalendarFilterPanel=__exports.PlanningCalendarFilterPanel=class PlanningCalendarFilterPanel extends CalendarFilterPanel{static subTemplates={filter:"planning.PlanningCalendarFilterPanel.filter",};getNoColor(filter){return this.section.fieldName=='resource_id'?'no_filter_color':'';}}
return __exports;});;

/* /planning/static/src/views/planning_form/planning_form_view.js */
odoo.define('@planning/views/planning_form/planning_form_view',['@web/core/l10n/translation','@odoo/owl','@web/core/registry','@web/core/utils/hooks','@web/core/utils/strings','@web/views/form/form_controller','@web/views/form/form_view','@web/views/view_dialogs/form_view_dialog','@web/core/confirmation_dialog/confirmation_dialog','@planning/components/address_recurrency_confirmation_dialog/address_recurrency_confirmation_dialog','@web/core/l10n/dates','@planning/views/planning_hooks'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{markup,onMounted,useState}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{escape}=require("@web/core/utils/strings");const{FormController}=require("@web/views/form/form_controller");const{formView}=require("@web/views/form/form_view");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{AddressRecurrencyConfirmationDialog}=require("@planning/components/address_recurrency_confirmation_dialog/address_recurrency_confirmation_dialog");const{deserializeDateTime}=require("@web/core/l10n/dates");const{usePlanningRecurringDeleteAction}=require("@planning/views/planning_hooks");const PlanningFormController=__exports.PlanningFormController=class PlanningFormController extends FormController{setup(){super.setup();this.action=useService("action");this.notification=useService("notification");this.orm=useService("orm");this.state=useState({recurrenceUpdate:"this",});this.planningRecurrenceDeletion=usePlanningRecurringDeleteAction();onMounted(()=>{this.initialTemplateCreation=this.model.root.data.template_creation;});}
async saveButtonClicked(params={}){try{return await super.saveButtonClicked(params);}catch{this.env.config.historyBack()}
return false;}
async onRecordSaved(record,changes){if("repeat"in changes&&record.data["repeat"]){const message=_t("Recurring shifts created");this.notification.add(markup(`<i class="fa fa-fw fa-check"></i><span class="ms-1">${escape(message)}</span>`),{type:"success"});}
if(record.context.is_record_created&&(deserializeDateTime(record.context.view_start_date)>record.data.start_datetime||deserializeDateTime(record.context.view_end_date)<record.data.end_datetime)){this.notification.add(_t("The shift has successfully been created."),{type:"success",});}}
async beforeExecuteActionButton(clickParams){const shift=this.model.root;this.state.recurrenceUpdate=shift.data.recurrence_update;if(clickParams.name==="unlink"){const canProceed=await new Promise((resolve)=>{if(shift.data.recurrency_id){this.dialogService.add(AddressRecurrencyConfirmationDialog,{cancel:()=>resolve(false),close:()=>resolve(false),confirm:async()=>{await this.planningRecurrenceDeletion._actionAddressRecurrency(shift,this.state.recurrenceUpdate);return resolve(true);},onChangeRecurrenceUpdate:this.planningRecurrenceDeletion._setRecurrenceUpdate.bind(this),selected:this.state.recurrenceUpdate,});}else{this.dialogService.add(ConfirmationDialog,{body:_t("Are you sure you want to delete this shift?"),confirmLabel:_t("Delete"),cancel:()=>resolve(false),close:()=>resolve(false),confirm:()=>resolve(true),});}});if(!canProceed){return false;}}else if(clickParams.name==='action_send'){if(shift.resId){const result=await this.orm.call(this.props.resModel,"get_employees_without_work_email",[shift.resId]);if(result){const{res_ids:resIds,relation:resModel,context}=result;const canProceed=await this.displayDialogWhenEmployeeNoEmail(resIds,resModel,context);if(!canProceed){return false;}}}else if(shift.data.employee_id&&!shift.data.work_email){const canProceed=await new Promise((resolve)=>{this.dialogService.add(FormViewDialog,{title:"Add Work Email",resModel:"hr.employee",resId:shift.data.employee_id[0],context:{form_view_ref:'planning.hr_employee_view_form_email',force_email:true,},onRecordSaved:()=>resolve(true),},{onClose:()=>resolve(false)});});if(!canProceed){return false;}}}
if(shift.data.allow_template_creation&&clickParams.name==='action_save_template'){const message=_t("Shift saved as template");this.notification.add(markup(`<i class="fa fa-fw fa-check"></i><span class="ms-1">${escape(message)}</span>`),{type:"success"},);}
return super.beforeExecuteActionButton(clickParams);}
async displayDialogWhenEmployeeNoEmail(resIds,resModel,context){const results=await Promise.all(resIds.map((resId)=>{return new Promise((resolve)=>{this.dialogService.add(FormViewDialog,{title:"",resModel,resId,context,preventCreate:true,onRecordSaved:()=>resolve(true),},{onClose:()=>resolve(false)});});}));return results.every((r)=>r);}
async deleteRecord(){const shift=this.model.root;if(shift.data.recurrency_id){this.dialogService.add(AddressRecurrencyConfirmationDialog,{confirm:async()=>{await this.planningRecurrenceDeletion._actionAddressRecurrency(shift,this.state.recurrenceUpdate);await shift.delete().then(()=>{if(!shift.resId){this.env.config.historyBack();}},()=>{this.env.config.historyBack();});},onChangeRecurrenceUpdate:this.planningRecurrenceDeletion._setRecurrenceUpdate.bind(this),});}else{await super.deleteRecord(...arguments);}}}
const planningFormView=__exports.planningFormView={...formView,Controller:PlanningFormController,};registry.category("views").add("planning_form",planningFormView);return __exports;});;

/* /planning/static/src/views/planning_hooks.js */
odoo.define('@planning/views/planning_hooks',['@web/core/l10n/translation','@odoo/owl','@web/core/l10n/dates','@web/core/utils/hooks','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{markup,useEnv,onWillUnmount,useEffect}=require("@odoo/owl");const{serializeDateTime}=require("@web/core/l10n/dates");const{useService}=require("@web/core/utils/hooks");const{escape}=require("@web/core/utils/strings");const PlanningControllerActions=__exports.PlanningControllerActions=class PlanningControllerActions{constructor({getAdditionalContext,getDomain,getRecords,getResModel,getStartDate,toggleHighlightPlannedFilter,reload,}){this.getAdditionalContext=getAdditionalContext;this.getDomain=getDomain;this.getRecords=getRecords;this.getResModel=getResModel;this.getStartDate=getStartDate;this.toggleHighlightPlannedFilter=toggleHighlightPlannedFilter;this.reload=reload;this.actionService=useService("action");this.env=useEnv();this.notifications=useService("notification");this.orm=useService("orm");}
async copyPrevious(){const resModel=this.getResModel();const startDate=serializeDateTime(this.getStartDate());const domain=this.getDomain();const result=await this.orm.call(resModel,"action_copy_previous_week",[startDate,domain,]);if(result){const notificationRemove=this.notifications.add(markup(`<i class="fa fa-fw fa-check"></i><span class="ms-1">${escape(_t(
                        "Previous week's shifts copied"
                    ))}</span>`),{type:"success",sticky:true,className:"planning_notification",buttons:[{name:'Undo',icon:'fa-undo',onClick:async()=>{await this.orm.call(resModel,'action_rollback_copy_previous_week',result,);this.toggleHighlightPlannedFilter(false);this.notifications.add(markup(`<i class="fa fa-fw fa-check"></i><span class="ms-1">${escape(_t(
                                        "Previous week's copied shifts removed"
                                    ))}</span>`),{type:'success'},);notificationRemove();},}],});this.toggleHighlightPlannedFilter(result[0]);this.notificationFn=notificationRemove;}else{this.notifications.add(_t("There are no shifts planned for the previous week, or they have already been copied."),{type:"danger"});}}
async publish(){const records=this.getRecords();if(!records?.length){return this.notifications.add(_t("The shifts have already been published, or there are no shifts to publish."),{type:"danger"});}
return this.actionService.doAction("planning.planning_send_action",{additionalContext:this.getAdditionalContext(),onClose:this.reload,});}
async autoPlan(){const additionalContext=this.getAdditionalContext();const res=await this.orm.call(this.getResModel(),"auto_plan_ids",[this.autoPlanDomain()],{context:additionalContext,});const{open_shift_assigned=[],sale_line_planned=[]}=res;if(!open_shift_assigned.length&&!sale_line_planned.length){this.notifications.add(this.autoPlanFailureNotification(),{type:"danger"});return;}
let multipleClickProtection=false;const notificationRemove=this.notifications.add(markup(`<i class="fa fa-fw fa-check"></i><span class="ms-1">${escape(
                    this.autoPlanSuccessNotification()
                )}</span>`),{type:"success",sticky:true,buttons:[{name:"Undo",icon:"fa-undo",onClick:async()=>{if(multipleClickProtection){return;}
multipleClickProtection=true;await this.orm.call(this.getResModel(),"action_rollback_auto_plan_ids",[res]);await this.reload();this.notifications.add(markup(`<i class="fa fa-fw fa-check"></i><span class="ms-1">${escape(
                                        this.autoPlanRollbackSuccessNotification()
                                    )}</span>`),{type:"success"});this.toggleHighlightPlannedFilter(false);notificationRemove();},},],});this.toggleHighlightPlannedFilter([...open_shift_assigned,...sale_line_planned]);this.notificationFn=notificationRemove;}
autoPlanDomain(){return this.getDomain();}
autoPlanSuccessNotification(){return _t("Open shifts assigned");}
autoPlanFailureNotification(){return _t("All open shifts have already been assigned, or there are no resources available to take them at this time.");}
autoPlanRollbackSuccessNotification(){return _t("Open shifts unscheduled");}}
__exports.usePlanningControllerActions=usePlanningControllerActions;function usePlanningControllerActions(){const planningControllerActions=new PlanningControllerActions(...arguments);onWillUnmount(()=>{planningControllerActions.notificationFn?.();});return planningControllerActions;}
__exports.usePlanningModelActions=usePlanningModelActions;function usePlanningModelActions({getHighlightPlannedIds,getContext,}){const orm=useService("orm");return{async getHighlightIds(){const context=getContext();if(!context.highlight_conflicting&&!context.highlight_planned){return;}
if(context.highlight_conflicting){const highlightConflictingIds=await orm.search("planning.slot",[["overlap_slot_count",">",0]],);if(context.highlight_planned){return Array.from(new Set([...highlightConflictingIds,...getHighlightPlannedIds()]));}
return highlightConflictingIds;}
return getHighlightPlannedIds()||[];},};}
__exports.setupDisplayName=setupDisplayName;function setupDisplayName(displayNameRef){useEffect((displayNameEl)=>{const displayNameMatch=displayNameEl.textContent.match(/^(.*)(\(.*\))$/);if(displayNameMatch){const textMuted=document.createElement("span");textMuted.className="text-muted text-truncate";textMuted.textContent=displayNameMatch[2];const displayNameText=document.createElement("span");displayNameText.textContent=displayNameMatch[1];displayNameEl.replaceChildren(displayNameText);displayNameEl.appendChild(textMuted);}else{displayNameEl.replaceChildren(document.createTextNode(displayNameEl.textContent));}},()=>[displayNameRef.el]);}
__exports.usePlanningRecurringDeleteAction=usePlanningRecurringDeleteAction;function usePlanningRecurringDeleteAction(){const orm=useService("orm");return{async _actionAddressRecurrency(shift,recurrenceUpdate){if(['subsequent','all'].includes(recurrenceUpdate)){await orm.call(shift.resModel,'action_address_recurrency',[shift.resId,recurrenceUpdate],);}},_setRecurrenceUpdate(recurrenceUpdate){this.state.recurrenceUpdate=recurrenceUpdate;},};}
return __exports;});;

/* /planning/static/src/views/planning_kanban/planning_kanban.js */
odoo.define('@planning/views/planning_kanban/planning_kanban',['@web/core/registry','@web/views/kanban/kanban_view','@planning/views/planning_search_model','@planning/views/planning_relational_model'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{PlanningSearchModel}=require("@planning/views/planning_search_model");const{PlanningRelationalModel}=require("@planning/views/planning_relational_model");registry.category("views").add("planning_kanban",{...kanbanView,SearchModel:PlanningSearchModel,Model:PlanningRelationalModel,});return __exports;});;

/* /planning/static/src/views/planning_relational_model.js */
odoo.define('@planning/views/planning_relational_model',['@web/core/domain','@web/model/relational_model/relational_model','@planning/views/planning_hooks'],function(require){'use strict';let __exports={};const{Domain}=require("@web/core/domain");const{RelationalModel}=require("@web/model/relational_model/relational_model");const{usePlanningModelActions}=require("@planning/views/planning_hooks");const PlanningRelationalModel=__exports.PlanningRelationalModel=class PlanningRelationalModel extends RelationalModel{setup(){super.setup(...arguments);this.getHighlightIds=usePlanningModelActions({getHighlightPlannedIds:()=>this.env.searchModel.highlightPlannedIds,getContext:()=>this.env.searchModel._context,}).getHighlightIds;}
async load(params={}){const highlightIds=await this.getHighlightIds();if(highlightIds){params.domain=Domain.and([params.domain,[["id","in",highlightIds]]]).toList();}
await super.load(...arguments);}}
return __exports;});;

/* /planning/static/src/views/planning_search_model.js */
odoo.define('@planning/views/planning_search_model',['@web/search/search_model'],function(require){'use strict';let __exports={};const{SearchModel}=require("@web/search/search_model");const PlanningSearchModel=__exports.PlanningSearchModel=class PlanningSearchModel extends SearchModel{exportState(){return{...super.exportState(),highlightPlannedIds:this.highlightPlannedIds,};}
_importState(state){this.highlightPlannedIds=state.highlightPlannedIds;super._importState(state);}
deactivateGroup(groupId){if(this._getHighlightPlannedSearchItems()?.groupId===groupId){this.highlightPlannedIds=null;}
super.deactivateGroup(groupId);}
toggleHighlightPlannedFilter(highlightPlannedIds){const highlightPlannedSearchItems=this._getHighlightPlannedSearchItems();if(highlightPlannedIds){this.highlightPlannedIds=highlightPlannedIds;if(highlightPlannedSearchItems){if(this.query.find((queryElem)=>queryElem.searchItemId===highlightPlannedSearchItems.id)){this._notify();}else{this.toggleSearchItem(highlightPlannedSearchItems.id);}}}else if(highlightPlannedSearchItems){this.deactivateGroup(highlightPlannedSearchItems.groupId);}}
_getHighlightPlannedSearchItems(){return Object.values(this.searchItems).find((v)=>v.name==="shift_planned");}}
return __exports;});;

/* /planning/static/src/views/planning_tree/planning_tree.js */
odoo.define('@planning/views/planning_tree/planning_tree',['@web/core/registry','@web/views/list/list_view','@planning/views/planning_search_model','@planning/views/planning_relational_model'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{PlanningSearchModel}=require("@planning/views/planning_search_model");const{PlanningRelationalModel}=require("@planning/views/planning_relational_model");registry.category("views").add("planning_tree",{...listView,SearchModel:PlanningSearchModel,Model:PlanningRelationalModel,});return __exports;});;

/* /planning/static/src/views/resource_form/resource_form_controller.js */
odoo.define('@planning/views/resource_form/resource_form_controller',['@web/core/l10n/translation','@web/views/form/form_controller'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{FormController}=require("@web/views/form/form_controller");const ResourceFormController=__exports.ResourceFormController=class ResourceFormController extends FormController{get archiveDialogProps(){let result=super.archiveDialogProps;result.body=_t("Archiving this resource will transform all of its future shifts into open shifts. Are you sure you want to continue?");return result;}}
return __exports;});;

/* /planning/static/src/views/resource_form/resource_form_view.js */
odoo.define('@planning/views/resource_form/resource_form_view',['@web/core/registry','@web/views/form/form_view','@planning/views/resource_form/resource_form_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");const{ResourceFormController}=require("@planning/views/resource_form/resource_form_controller");const ResourceFormView=__exports.ResourceFormView={...formView,Controller:ResourceFormController,};registry.category("views").add("resource_form_view",ResourceFormView);return __exports;});;

/* /planning/static/src/views/resource_list/resource_list_controller.js */
odoo.define('@planning/views/resource_list/resource_list_controller',['@web/core/l10n/translation','@web/views/list/list_controller'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ListController}=require('@web/views/list/list_controller');const ResourceListController=__exports.ResourceListController=class ResourceListController extends ListController{get archiveDialogProps(){let result=super.archiveDialogProps;result['body']=_t("Archiving this resource will transform all of its future shifts into open shifts. Are you sure you want to continue?");return result;}}
return __exports;});;

/* /planning/static/src/views/resource_list/resource_list_view.js */
odoo.define('@planning/views/resource_list/resource_list_view',['@web/core/registry','@web/views/list/list_view','@planning/views/resource_list/resource_list_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require('@web/views/list/list_view');const{ResourceListController}=require("@planning/views/resource_list/resource_list_controller");const resourceListView=__exports.resourceListView={...listView,Controller:ResourceListController,};registry.category("views").add("resource_list_view",resourceListView);return __exports;});;

/* /planning/static/src/js/tours/planning.js */
odoo.define('@planning/js/tours/planning',['@web/core/l10n/translation','@web/core/registry','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add('planning_tour',{url:'/odoo',steps:()=>[{trigger:'.o_app[data-menu-xmlid="planning.planning_menu_root"]',content:markup(_t("Let's start managing your employees' schedule!")),tooltipPosition:'bottom',run:"click",},{isActive:["mobile"],trigger:"tr td[data-time='08:00:00'].fc-timegrid-slot-lane",content:markup(_t("Let's schedule a <b>shift</b> for this time range.")),tooltipPosition:'bottom',run:"click",},{isActive:["desktop"],trigger:".o_gantt_button_add",content:markup(_t("Let's create your first <b>shift</b>. <i>Tip: use the (+) shortcut available on each cell of the Gantt view to save time.</i>")),tooltipPosition:"bottom",run:"click",},{trigger:".o_field_widget[name='resource_id']",content:markup(_t("Assign a <b>resource</b>, or leave it open for the moment. <i>Tip: Create open shifts for the roles you will be needing to complete a mission. Then, assign those open shifts to the resources that are available.</i>")),tooltipPosition:"right",run:"click",},{trigger:".o_field_widget[name='role_id'] .o_field_many2one_selection",content:markup(_t("Write the <b>role</b> your employee will perform (<i>e.g. Chef, Bartender, Waiter, etc.</i>). <i>Tip: Create open shifts for the roles you will be needing to complete a mission. Then, assign those open shifts to the resources that are available.</i>")),tooltipPosition:"right",run:"click",},{trigger:"button[special='save']:enabled",content:_t("Save this shift once it is ready."),tooltipPosition:"bottom",run:"click",},{isActive:["mobile"],trigger:'.o_cp_switch_buttons .btn',content:markup(_t("Let's check out the Gantt view for cool features. Get ready to <b>share your schedule</b> and easily plan your shifts with just one click by <em>copying the previous week's schedule</em>.")),tooltipPosition:'bottom',run:"click",},{isActive:["mobile"],trigger:'span.o-dropdown-item:has(i.fa-tasks)',content:markup(_t("Let's check out the Gantt view for cool features. Get ready to <b>share your schedule</b> and easily plan your shifts with just one click by <em>copying the previous week's schedule</em>.")),tooltipPosition:'bottom',run:"click",},{isActive:["auto","desktop"],trigger:".o_action:not(.o_view_sample_data)",},{isActive:["desktop"],trigger:".o_gantt_pill:not(.o_gantt_consolidated_pill)",content:markup(_t("<b>Drag & drop</b> your shift to reschedule it. <i>Tip: hit CTRL (or Cmd) to duplicate it instead.</i> <b>Adjust the size</b> of the shift to modify its period.")),tooltipPosition:"bottom",run:"drag_and_drop .o_gantt_cell:nth-child(6)",},{isActive:["mobile"],trigger:".o_control_panel .dropdown-toggle",content:_t("Share the schedule with your team by publishing and sending it. Open the menu to access this option."),tooltipPosition:"bottom",run:"click",},{isActive:["mobile"],trigger:".o_gantt_button_send_all",content:markup(_t("If you are happy with your planning, you can now <b>send</b> it to your employees.")),tooltipPosition:"right",run:"click",},{isActive:["desktop"],trigger:".o_gantt_button_send_all",content:markup(_t("If you are happy with your planning, you can now <b>send</b> it to your employees.")),tooltipPosition:"bottom",run:"click",},{isActive:["mobile"],trigger:"button[name='action_check_emails']",content:markup(_t("If you are happy with your planning, you can now <b>send</b> it to your employees.")),tooltipPosition:"right",run:"click",},{isActive:["desktop"],trigger:"button[name='action_check_emails']",content:markup(_t("<b>Publish & send</b> your employee's planning.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_gantt_renderer_controls button i.fa-arrow-right",content:markup(_t("Now that this week is ready, let's get started on <b>next week's schedule</b>.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_control_panel .dropdown-toggle",content:markup(_t("Plan your shifts in one click by <b>copying the schedule from the previous week</b>. Open the menu to access this option.")),tooltipPosition:"bottom",run:"click",},{trigger:".o_gantt_button_copy_previous_week",content:markup(_t("Plan your shifts in one click by <b>copying the schedule from the previous week</b>.")),tooltipPosition:"right",run:"click",},]});return __exports;});;

/* /social/static/src/js/fields/post_formatter_field.js */
odoo.define('@social/js/fields/post_formatter_field',['@web/core/registry','@web/views/fields/standard_field_props','@social/js/social_post_formatter_mixin','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{SocialPostFormatterMixin}=require("@social/js/social_post_formatter_mixin");const{Component,markup}=require("@odoo/owl");const PostFormatterField=__exports.PostFormatterField=class PostFormatterField extends SocialPostFormatterMixin(Component){static template="social.PostFormatterField";static props={...standardFieldProps,};get formattedPost(){return markup(this._formatPost(this.props.record.data[this.props.name]||''));}}
const postFormatterField=__exports.postFormatterField={component:PostFormatterField,};registry.category("fields").add("social_post_formatter",postFormatterField);return __exports;});;

/* /social/static/src/js/fields/social_many2many_images.js */
odoo.define('@social/js/fields/social_many2many_images',['@social/js/images_carousel_dialog','@web/core/registry','@web/views/fields/standard_field_props','@odoo/owl','@web/core/utils/hooks','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{ImagesCarouselDialog}=require("@social/js/images_carousel_dialog");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const SocialMany2manyImages=__exports.SocialMany2manyImages=class SocialMany2manyImages extends Component{static template="social.SocialMany2manyImages";static props=standardFieldProps;setup(){super.setup();this.dialog=useService("dialog");}
get attachmentsIds(){return this.props.record.data[this.props.name].records.map((record)=>record.resId);}
onClickMoreImages(){this.dialog.add(ImagesCarouselDialog,{title:_t("Post Images"),activeIndex:0,images:this.attachmentsIds.map((attachmentId)=>`/web/image/${attachmentId}`),});}}
const socialMany2manyImages=__exports.socialMany2manyImages={component:SocialMany2manyImages,supportedTypes:["many2many"],};registry.category("fields").add("social_many2many_images",socialMany2manyImages);return __exports;});;

/* /social/static/src/js/fields/social_post_split_per_media.js */
odoo.define('@social/js/fields/social_post_split_per_media',['@web/core/registry','@web/views/fields/standard_field_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{Component}=require("@odoo/owl");const SocialPostSplitPerMedia=__exports.SocialPostSplitPerMedia=class SocialPostSplitPerMedia extends Component{static template="social.SocialPostSplitPerMedia";static props=standardFieldProps;onClick(){this.props.record.update({[this.props.name]:true});}}
const socialPostSplitPerMedia=__exports.socialPostSplitPerMedia={component:SocialPostSplitPerMedia,supportedTypes:["boolean"],};registry.category("fields").add("social_post_split_per_media",socialPostSplitPerMedia);return __exports;});;

/* /social/static/src/js/add_stream_modal.js */
odoo.define('@social/js/add_stream_modal',['@web/core/l10n/translation','@web/core/dialog/dialog','@web/views/view_dialogs/form_view_dialog','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Dialog}=require('@web/core/dialog/dialog');const{FormViewDialog}=require('@web/views/view_dialogs/form_view_dialog');const{useChildRef,useService}=require('@web/core/utils/hooks');const{Component}=require("@odoo/owl");const AddSocialStreamDialog=__exports.AddSocialStreamDialog=class AddSocialStreamDialog extends Component{static components={Dialog};static template="social.AddSocialStreamDialog";static props={title:String,socialAccounts:Array,isSocialManager:Boolean,onSaved:Function,close:Function,socialMedia:Object,companies:Array,};setup(){super.setup();this.dialog=useService('dialog');this.modalRef=useChildRef();this.orm=useService('orm');}
_onClickSocialAccount(event){const target=event.currentTarget;this.dialog.add(FormViewDialog,{title:_t('Add a Stream'),resModel:'social.stream',context:{default_media_id:parseInt(target.dataset.mediaId),default_account_id:parseInt(target.dataset.accountId),form_view_ref:'social.social_stream_view_form_wizard',},onRecordSaved:(result)=>this.props.onSaved(result),});this.props.close();}
_onClickSocialMedia(event){const mediaId=parseInt(event.currentTarget.dataset.mediaId);const selectCompany=this.modalRef.el.querySelector('select[name="company_id"]');const companyId=selectCompany?parseInt(selectCompany.value)||0:undefined;this.orm.call('social.media','action_add_account',[mediaId],{company_id:companyId}).then((action)=>{document.location=action.url;});}}
return __exports;});;

/* /social/static/src/js/images_carousel_dialog.js */
odoo.define('@social/js/images_carousel_dialog',['@web/core/dialog/dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{Component}=require("@odoo/owl");const ImagesCarouselDialog=__exports.ImagesCarouselDialog=class ImagesCarouselDialog extends Component{static components={Dialog};static template="social.ImagesCarouselDialog";static props={title:String,images:Array,activeIndex:Number,close:Function,};}
return __exports;});;

/* /social/static/src/js/post_kanban_view.js */
odoo.define('@social/js/post_kanban_view',['@web/core/l10n/translation','@web/views/kanban/kanban_renderer','@web/views/kanban/kanban_view','@web/core/registry','@web/core/utils/hooks','@social/js/images_carousel_dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{kanbanView}=require("@web/views/kanban/kanban_view");const{registry}=require("@web/core/registry");const{useService}=require('@web/core/utils/hooks');const{ImagesCarouselDialog}=require("@social/js/images_carousel_dialog");const{useEffect,useRef}=require("@odoo/owl");const PostKanbanRenderer=__exports.PostKanbanRenderer=class PostKanbanRenderer extends KanbanRenderer{setup(){super.setup();this.dialog=useService('dialog');const rootRef=useRef("root");useEffect((images)=>{const onClickMoreImages=this.onClickMoreImages.bind(this);images.forEach((image)=>image.addEventListener('click',onClickMoreImages));return()=>{images.forEach((image)=>image.removeEventListener('click',onClickMoreImages));};},()=>[rootRef.el.querySelectorAll('.o_social_stream_post_image_more')]);}
onClickMoreImages(ev){ev.stopPropagation();this.dialog.add(ImagesCarouselDialog,{title:_t("Post Images"),activeIndex:parseInt(ev.currentTarget.dataset.index),images:ev.currentTarget.dataset.imageUrls.split(',')})}}
const PostKanbanView=__exports.PostKanbanView={...kanbanView,Renderer:PostKanbanRenderer,};registry.category("views").add("social_post_kanban_view",PostKanbanView);return __exports;});;

/* /social/static/src/js/social_post_formatter_mixin.js */
odoo.define('@social/js/social_post_formatter_mixin',['@mail/js/emojis_mixin'],function(require){'use strict';let __exports={};const{formatText}=require('@mail/js/emojis_mixin');const SocialPostFormatterRegex=__exports.SocialPostFormatterRegex={REGEX_AT:/\B@([\w\dÀ-ÿ-.]+)/g,REGEX_HASHTAG:/(^|\s|<br>)#([a-zA-Z\d\-_]+)/g,REGEX_URL:/http(s)?:\/\/(www\.)?[a-zA-Z0-9@:%_+~#=~#?&/=\-;!.]{3,2000}/g,};const SocialPostFormatterMixinBase=__exports.SocialPostFormatterMixinBase={_formatPost(value){value=formatText(value);value=value.replace(SocialPostFormatterRegex.REGEX_URL,"<a href='$&' class='text-truncate' target='_blank' rel='noreferrer noopener'>$&</a>");return value;},_getMediaType(){return this.props&&this.props.mediaType||this.props.record&&this.props.record.data.media_type||this.originalPost&&this.originalPost.media_type.raw_value||'';}};const SocialPostFormatterMixin=__exports.SocialPostFormatterMixin=(T)=>class extends T{_formatPost(){return SocialPostFormatterMixinBase._formatPost.call(this,...arguments);}
_getMediaType(){return SocialPostFormatterMixinBase._getMediaType.call(this,...arguments);}};return __exports;});;

/* /social_youtube/static/src/js/social_post_formatter_mixin.js */
odoo.define('@social_youtube/js/social_post_formatter_mixin',['@social/js/social_post_formatter_mixin','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{SocialPostFormatterMixinBase,SocialPostFormatterRegex}=require('@social/js/social_post_formatter_mixin');const{patch}=require("@web/core/utils/patch");patch(SocialPostFormatterMixinBase,{_formatPost(value){value=super._formatPost(...arguments);if(['youtube','youtube_preview'].includes(this._getMediaType())){value=value.replace(SocialPostFormatterRegex.REGEX_HASHTAG,`$1<a href='https://www.youtube.com/results?search_query=%23$2' target='_blank'>#$2</a>`);}
return value;}});return __exports;});;

/* /social_twitter/static/src/js/social_post_formatter_mixin.js */
odoo.define('@social_twitter/js/social_post_formatter_mixin',['@social/js/social_post_formatter_mixin','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{SocialPostFormatterMixinBase,SocialPostFormatterRegex}=require('@social/js/social_post_formatter_mixin');const{patch}=require("@web/core/utils/patch");patch(SocialPostFormatterMixinBase,{_formatPost(value){value=super._formatPost(...arguments);if(this._getMediaType()==='twitter'){value=value.replace(SocialPostFormatterRegex.REGEX_HASHTAG,`$1<a href='https://twitter.com/hashtag/$2?src=hash' target='_blank'>#$2</a>`);value=value.replace(SocialPostFormatterRegex.REGEX_AT,`<a href='https://twitter.com/$1' target='_blank'>@$1</a>`);}
return value;}});return __exports;});;

/* /social_linkedin/static/src/js/social_post_formatter_mixin.js */
odoo.define('@social_linkedin/js/social_post_formatter_mixin',['@social/js/social_post_formatter_mixin','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{SocialPostFormatterMixinBase,SocialPostFormatterRegex}=require('@social/js/social_post_formatter_mixin');const{patch}=require("@web/core/utils/patch");const LINKEDIN_HASHTAG_REGEX=__exports.LINKEDIN_HASHTAG_REGEX=/{hashtag\|#\|([a-zA-Z\d\-_]+)}/g;patch(SocialPostFormatterMixinBase,{_formatPost(value){value=super._formatPost(...arguments);if(this._getMediaType()==='linkedin'){value=value.replace(SocialPostFormatterRegex.REGEX_HASHTAG,`$1<a href='https://www.linkedin.com/feed/hashtag/?keywords=$2' target='_blank'>#$2</a>`);value=value.replace(LINKEDIN_HASHTAG_REGEX,`<a href='https://www.linkedin.com/feed/hashtag/?keywords=$1' target='_blank'>#$1</a>`);}
return value;}});return __exports;});;

/* /social_instagram/static/src/js/social_post_formatter_mixin.js */
odoo.define('@social_instagram/js/social_post_formatter_mixin',['@social/js/social_post_formatter_mixin','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{SocialPostFormatterMixinBase,SocialPostFormatterRegex}=require('@social/js/social_post_formatter_mixin');const{patch}=require("@web/core/utils/patch");patch(SocialPostFormatterMixinBase,{_formatPost(value){value=super._formatPost(...arguments);if(this._getMediaType()==='instagram'){value=value.replace(SocialPostFormatterRegex.REGEX_HASHTAG,`$1<a href='https://www.instagram.com/explore/tags/$2' target='_blank'>#$2</a>`);value=value.replace(SocialPostFormatterRegex.REGEX_AT,`<a href='https://www.instagram.com/$1' target='_blank'>@$1</a>`);}
return value;}});return __exports;});;

/* /social_facebook/static/src/js/social_post_formatter_mixin.js */
odoo.define('@social_facebook/js/social_post_formatter_mixin',['@social/js/social_post_formatter_mixin','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{SocialPostFormatterMixinBase,SocialPostFormatterRegex}=require('@social/js/social_post_formatter_mixin');const{patch}=require("@web/core/utils/patch");patch(SocialPostFormatterMixinBase,{_formatPost(value){value=super._formatPost(...arguments);const mediaType=this._getMediaType();if(['facebook','facebook_preview'].includes(mediaType)){value=value.replace(SocialPostFormatterRegex.REGEX_HASHTAG,`$1<a href='https://www.facebook.com/hashtag/$2' target='_blank'>#$2</a>`);const accountId=this.record&&this.record.account_id.raw_value||this.originalPost&&this.originalPost.account_id.raw_value;if(accountId){const REGEX_AT_FACEBOOK=/\B@\[([0-9]*)\]\s([\w\dÀ-ÿ-]+)/g;value=value.replace(REGEX_AT_FACEBOOK,`<a href='/social_facebook/redirect_to_profile/`+encodeURIComponent(accountId)+`/$1?name=$2' target='_blank'>$2</a>`);}}
return value;},});return __exports;});;

/* /social/static/src/js/social_post_preview_field.js */
odoo.define('@social/js/social_post_preview_field',['@social/js/social_post_formatter_mixin','@web_editor/js/backend/html_field','@web/core/registry','@odoo/owl'],function(require){'use strict';let __exports={};const{SocialPostFormatterMixin}=require("@social/js/social_post_formatter_mixin");const{HtmlField,htmlField}=require("@web_editor/js/backend/html_field");const{registry}=require("@web/core/registry");const{markup}=require("@odoo/owl");const FieldPostPreview=__exports.FieldPostPreview=class FieldPostPreview extends SocialPostFormatterMixin(HtmlField){static props={...FieldPostPreview.props,mediaType:{type:String,optional:true},};get markupValue(){const $html=$(this.props.record.data[this.props.name]+'');$html.find('.o_social_preview_message').each((index,previewMessage)=>{$(previewMessage).html(this._formatPost($(previewMessage).text().trim()));});return markup($html[0]?.outerHTML||"");}}
const fieldPostPreview=__exports.fieldPostPreview={...htmlField,component:FieldPostPreview,extractProps({attrs}){const props=htmlField.extractProps(...arguments);props.mediaType=attrs.media_type||'';return props;},};registry.category("fields").add("social_post_preview",fieldPostPreview);return __exports;});;

/* /social/static/src/js/stream_post_comment.js */
odoo.define('@social/js/stream_post_comment',['@web/core/l10n/translation','@social/js/social_post_formatter_mixin','@social/js/stream_post_comments_reply','@web/core/network/rpc','@web/core/confirmation_dialog/confirmation_dialog','@web/core/utils/strings','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{SocialPostFormatterMixin}=require("@social/js/social_post_formatter_mixin");const{StreamPostCommentsReply}=require("@social/js/stream_post_comments_reply");const{rpc}=require("@web/core/network/rpc");const{ConfirmationDialog}=require('@web/core/confirmation_dialog/confirmation_dialog');const{escape}=require('@web/core/utils/strings');const{useService}=require('@web/core/utils/hooks');const{Component,markup,useState}=require("@odoo/owl");const StreamPostComment=__exports.StreamPostComment=class StreamPostComment extends SocialPostFormatterMixin(Component){static template="social.StreamPostComment";setup(){super.setup();this.dialog=useService('dialog');this.action=useState({showSubComment:false,showReplyComment:false,});this.state=useState({isEditMode:false,});}
async _onLoadReplies(){this.action.showSubComment=true;}
async _onReplyComment(){this.action.showReplyComment=true;}
_toggleEditMode(){this.state.isEditMode=!this.state.isEditMode;}
_deleteComment(){this.dialog.add(ConfirmationDialog,{title:_t('Delete Comment'),body:_t('Do you really want to delete this %s?',this.commentName),confirmLabel:_t("Delete"),confirm:()=>{this._confirmDeleteComment();},cancel:()=>{},});}
async _confirmDeleteComment(){await rpc(this.deleteCommentEndpoint,{stream_post_id:this.originalPost.id.raw_value,comment_id:this.comment.id,});this.props.onDeleteComment();}
_htmlEscape(message){return escape(message);}
formatComment(commentMessage){return markup(this._formatPost(commentMessage));}
get comment(){return this.props.comment;}
get account(){return this.props.account;}
get originalPost(){return this.props.originalPost;}
get deleteCommentEndpoint(){return null;}
get authorPictureSrc(){return'';}
get currentAuthorPictureSrc(){return'';}
get commentName(){return _t('comment/reply');}
get link(){return'';}
get isDeletable(){return this.isAuthor;}
get isEditable(){return this.isAuthor;}
isManageable(){return this.isDeletable||this.isEditable;}
get isAuthor(){return false;}
get isLikable(){return true;}
get likesClass(){return'fa-thumbs-up';}
get commentComponent(){return this.constructor;}
get commentReplyComponent(){return StreamPostCommentsReply;}
get commentCreatedTime(){return luxon.DateTime.fromISO(this.comment.created_time);}}
return __exports;});;

/* /social_crm/static/src/js/stream_post_comment.js */
odoo.define('@social_crm/js/stream_post_comment',['@social/js/stream_post_comment','@web/core/utils/patch','@web/core/utils/hooks','@web/core/l10n/dates'],function(require){'use strict';let __exports={};const{StreamPostComment}=require('@social/js/stream_post_comment');const{patch}=require("@web/core/utils/patch");const{useService}=require("@web/core/utils/hooks");const{serializeDateTime}=require("@web/core/l10n/dates");patch(StreamPostComment.prototype,{setup(){super.setup(...arguments);this.actionService=useService("action");},isManageable(){return super.isManageable()||this.isConvertibleToLead();},isConvertibleToLead(){return!this.isAuthor;},generateLeadFromComment(){this.actionService.doAction("social_crm.social_post_to_lead_action",{additionalContext:{default_conversion_source:'comment',default_social_stream_post_id:this.originalPost.id.raw_value,default_social_account_id:this.originalPost.account_id.raw_value,default_author_name:this.comment.from.name,default_post_content:this._formatPost(this.comment.message),default_post_image_urls:(this.comment.attachment?.type==='photo')?`["${this.comment.attachment.media.image.src}"]`:false,default_post_datetime:serializeDateTime(this.commentCreatedTime),default_post_link:this.originalPost.post_link.raw_value}});this.env.closeCommentsModal();}});return __exports;});;

/* /social/static/src/js/stream_post_comment_list.js */
odoo.define('@social/js/stream_post_comment_list',['@social/js/stream_post_comment','@odoo/owl'],function(require){'use strict';let __exports={};const{StreamPostComment}=require("@social/js/stream_post_comment");const{Component}=require("@odoo/owl");const StreamPostCommentList=__exports.StreamPostCommentList=class StreamPostCommentList extends Component{static template="social.StreamPostCommentsWrapper";static props={comments:Array,account:{type:Object,optional:true},error:{type:String,optional:true},mediaSpecificProps:Object,originalPost:Object,preventAddComment:Function,};toggleUserLikes(comment){}
_updateLikes(comment){if(comment.user_likes){if(comment.likes.summary.total_count>0)
comment.likes.summary.total_count--;}else{comment.likes.summary.total_count++;}
comment.user_likes=!comment.user_likes;}
get comments(){return this.props.comments;}
get account(){return this.props.account;}
get originalPost(){return this.props.originalPost;}
get commentComponent(){return StreamPostComment;}}
return __exports;});;

/* /social/static/src/js/stream_post_comments.js */
odoo.define('@social/js/stream_post_comments',['@social/js/images_carousel_dialog','@social/js/stream_post_comment_list','@social/js/stream_post_comments_reply','@social/js/social_post_formatter_mixin','@web/core/confirmation_dialog/confirmation_dialog','@web/core/dialog/dialog','@web/core/l10n/translation','@web/core/network/rpc','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{ImagesCarouselDialog}=require("@social/js/images_carousel_dialog");const{StreamPostCommentList}=require("@social/js/stream_post_comment_list");const{StreamPostCommentsReply}=require("@social/js/stream_post_comments_reply");const{SocialPostFormatterMixin}=require("@social/js/social_post_formatter_mixin");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{Dialog}=require("@web/core/dialog/dialog");const{_t}=require("@web/core/l10n/translation");const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{Component,markup,useSubEnv,useState}=require("@odoo/owl");const StreamPostComments=__exports.StreamPostComments=class StreamPostComments extends SocialPostFormatterMixin(Component){static template="social.StreamPostComments";static components={Dialog};setup(){super.setup();this.orm=useService('orm');this.dialog=useService('dialog');this.comments=useState(this.props.comments);this.postId=this.props.postId;this.state=useState({displayModal:true,showLoadMoreComments:false,isEditMode:false,message:this._formatStreamPostForEdition(this.originalPost.message.raw_value),});this.mediaSpecificProps={};useSubEnv({closeCommentsModal:this.closeCommentsModal.bind(this)});}
onClickMoreImages(index,images){this.dialog.add(ImagesCarouselDialog,{title:_t("Post Images"),activeIndex:index,images:images})}
closeCommentsModal(){this.state.displayModal=false;}
loadMoreComments(){}
onAddComment(newComment){this.comments.unshift(newComment);}
onDeletePost(){this.dialog.add(ConfirmationDialog,{title:_t("Delete Post"),body:_t("Do you really want to delete this Post ?"),confirm:async()=>{await rpc(`/social_${this.props.originalPost.media_type.raw_value}/delete_post`,{stream_post_id:this.originalPost.id.raw_value,});if(this.props.onPostDeleted){this.props.onPostDeleted();}},confirmLabel:_t("Delete"),cancel:()=>{},});}
async onEditPost(event){const textarea=event.currentTarget;if(event.key!=="Enter"||event.ctrlKey||event.shiftKey||textarea.value.trim()===""){return;}
this.state.isEditMode=false;this.state.message=textarea.value;await rpc(`/social_${this.props.originalPost.media_type.raw_value}/edit_post`,{stream_post_id:this.originalPost.id.raw_value,new_message:textarea.value,});this.props?.onPostUpdate(textarea.value);}
preventAddComment(textarea,replyToCommentId){return false;}
_formatCommentStreamPost(message){return markup(this._formatPost(message));}
_formatStreamPostForEdition(message){return message;}
get bodyClass(){return'o_social_comments_modal o_social_comments_modal_'+this.originalPost.media_type.raw_value+' pt-0 px-0 bg-100';}
get originalPost(){return this.props.originalPost;}
get JSON(){return JSON;}
get commentListComponent(){return StreamPostCommentList;}
get commentReplyComponent(){return StreamPostCommentsReply;}
get isAuthor(){return this.originalPost.is_author&&this.originalPost.is_author.raw_value;}
get isDeletable(){return false;}
get isEditable(){return false;}}
return __exports;});;

/* /social_crm/static/src/js/stream_post_comments.js */
odoo.define('@social_crm/js/stream_post_comments',['@social/js/stream_post_comments','@web/core/utils/patch','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{StreamPostComments}=require('@social/js/stream_post_comments');const{patch}=require("@web/core/utils/patch");const{useService}=require("@web/core/utils/hooks");patch(StreamPostComments.prototype,{setup(){super.setup(...arguments);this.actionService=useService("action");},isConvertibleToLead(){return!this.isAuthor;},generateLeadFromPost(){this.actionService.doAction("social_crm.social_post_to_lead_action",{additionalContext:{default_conversion_source:'stream_post',default_social_stream_post_id:this.originalPost.id.raw_value,default_social_account_id:this.originalPost.account_id.raw_value,default_post_content:this._formatPost(this.originalPost.message.raw_value),default_post_image_urls:this.originalPost.stream_post_image_urls.raw_value,}});this.env.closeCommentsModal();}});return __exports;});;

/* /social/static/src/js/stream_post_comments_reply.js */
odoo.define('@social/js/stream_post_comments_reply',['@web/core/l10n/translation','@web/core/utils/strings','@web/views/fields/file_handler','@web/core/utils/hooks','@web/core/emoji_picker/emoji_picker','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{escape}=require("@web/core/utils/strings");const{FileUploader}=require("@web/views/fields/file_handler");const{useAutofocus,useService}=require("@web/core/utils/hooks");const{useEmojiPicker}=require("@web/core/emoji_picker/emoji_picker");const{Component,useState,useRef,markup}=require("@odoo/owl");const StreamPostCommentsReply=__exports.StreamPostCommentsReply=class StreamPostCommentsReply extends Component{static template="social.StreamPostCommentsReply";static components={FileUploader};static props={comment:{type:Object,optional:true},account:{type:Object,optional:true},originalPost:{type:Object,optional:true},bubble_design:{type:Boolean,optional:true},classes:{type:String,optional:true},initialValue:{type:String,optional:true},attachmentSrc:{type:String,optional:true},isCommentEdit:{type:Boolean,optional:true},isCommentReply:{type:Boolean,optional:true},mediaSpecificProps:Object,onAddComment:Function,preventAddComment:Function,toggleEditMode:{type:Function,optional:true},};static defaultProps={isCommentReply:false,isCommentEdit:false,};setup(){super.setup();this.state=useState({disabled:false,attachmentSrc:false,});this.inputRef=useAutofocus();this._onAddEmoji=this._onAddEmoji.bind(this);this.notification=useService("notification");useEmojiPicker(useRef("emoji-picker"),{onSelect:(str)=>this._onAddEmoji(str),onClose:()=>this.state.autofocus++,});}
_onAddComment(event){if(event.key!=="Enter"||event.ctrlKey||event.shiftKey){return;}
event.preventDefault();const textarea=event.currentTarget;if(textarea.value.trim()===""&&(!this.state.attachmentSrc||!this.allowImageOnlyComment)){return;}
this.state.disabled=true;this._addComment(textarea);}
async _addComment(textarea){if(this.props.preventAddComment(textarea,this.isCommentReply?this.comment.id:undefined)){return;}
const formData=new FormData(textarea.closest(".o_social_write_reply").querySelector("form"));const xhr=new window.XMLHttpRequest();xhr.open("POST",this.addCommentEndpoint);formData.append("csrf_token",odoo.csrf_token);formData.append("stream_post_id",this.originalPost.id.raw_value);if(this.isCommentEdit){formData.append("is_edit",this.isCommentEdit);}
if(this.isCommentEdit||this.isCommentReply){formData.append("comment_id",this.comment.id);}
if(this.state.attachmentSrc){const base64Response=await fetch(this.state.attachmentSrc);const file=new File([await base64Response.blob()],"attachment");formData.set("attachment",file);}
const existingAttachmentId=textarea.dataset.existingAttachmentId;if(existingAttachmentId){formData.append("existing_attachment_id",this.props.attachmentSrc);}
xhr.send(formData);xhr.onload=()=>{let comment=JSON.parse(xhr.response);if(this.isCommentEdit){comment={...this.comment,...comment};}
if(comment.error){this.notification.add(markup(_t("Something went wrong while posting the comment.")+"<br/><br/>"+
escape(comment.error)),{type:"danger"});}else{this.props.onAddComment(comment);}
this.state.attachmentSrc=false;this.inputRef.el.value="";this.state.disabled=false;if(this.isCommentEdit){this.props.toggleEditMode();}};}
_onAddEmoji(str){const input=this.inputRef.el;const selectionStart=input.selectionStart;input.value=input.value.slice(0,selectionStart)+str+input.value.slice(selectionStart);input.focus();input.setSelectionRange(selectionStart+str.length,selectionStart+str.length);}
_onAddImage(event){event.currentTarget.closest(".o_social_write_reply").querySelector(".o_input_file").click();}
_onImageChange({data,type}){this.state.attachmentSrc="data:"+type+";base64,"+data;}
_onImageRemove(){this.state.attachmentSrc=false;}
get comment(){return this.props.comment;}
get account(){return this.props.account;}
get originalPost(){return this.props.originalPost;}
get authorPictureSrc(){return"";}
get addCommentEndpoint(){return null;}
get isCommentReply(){return this.props.isCommentReply;}
get isCommentEdit(){return this.props.isCommentEdit;}
get initialValue(){return this.props.initialValue;}
get canAddImage(){return true;}
get allowImageOnlyComment(){return false;}}
return __exports;});;

/* /social/static/src/js/stream_post_kanban_controller.js */
odoo.define('@social/js/stream_post_kanban_controller',['@web/core/l10n/translation','@social/js/add_stream_modal','@social/js/stream_post_kanban_refresh_banner','@social/js/stream_post_kanban_dashboard','@web/model/model','@web/views/kanban/kanban_controller','@web/core/user','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{AddSocialStreamDialog}=require("@social/js/add_stream_modal");const{NewContentRefreshBanner}=require("@social/js/stream_post_kanban_refresh_banner");const{StreamPostDashboard}=require("@social/js/stream_post_kanban_dashboard");const{useModelWithSampleData}=require("@web/model/model");const{KanbanController}=require('@web/views/kanban/kanban_controller');const{user}=require("@web/core/user");const{useService}=require('@web/core/utils/hooks');const{onWillStart,useEffect,useSubEnv,useState}=require("@odoo/owl");const StreamPostKanbanController=__exports.StreamPostKanbanController=class StreamPostKanbanController extends KanbanController{static template="social.SocialKanbanView";static components={...KanbanController.components,NewContentRefreshBanner,StreamPostDashboard,};setup(){super.setup();this.model=useModelWithSampleData(this.props.Model,this.modelParams);this.company=useService('company');this.dialog=useService('dialog');this.orm=useService('orm');this.notification=useService('notification');this.state=useState({refreshRequired:false,disableSyncButton:false,});useSubEnv({refreshStats:this._onRefreshStats.bind(this)});useEffect((addStreamLink)=>{if(addStreamLink){addStreamLink.addEventListener('click',this._onNewStream.bind(this));}},()=>[document.querySelector('.o_social_js_add_stream')]);onWillStart(async()=>{this.isSocialManager=await user.hasGroup("social.group_social_manager");this.hasAccounts=await this.orm.searchCount('social.account',[])>0;this.accounts=await this.model._loadAccountsStats();});onWillStart(()=>this._onRefreshStats());}
async _onRefreshStats(){this.state.disableSyncButton=true;Promise.all([this.model._refreshStreams().then((result)=>{this.state.refreshRequired=result;}),this.model._refreshAccountsStats().then((result)=>{this.accounts=result;}),]).then(()=>this.state.disableSyncButton=false);}
_refreshView(){this.state.refreshRequired=false;this.model.load();}
_onNewPost(){this.actionService.doAction({name:_t('New Post'),type:'ir.actions.act_window',res_model:'social.post',views:[[false,"form"]],});}
_onNewStream(){if(this.accounts.length>0||this.isSocialManager){this._addNewStream();}else{this.notification.add(_t("No social accounts configured, please contact your administrator."),{type:'danger'});}}
_addNewStream(){this._fetchSocialMedia().then((socialMedia)=>this.dialog.add(AddSocialStreamDialog,{title:_t('Add a Stream'),isSocialManager:this.isSocialManager,socialMedia:socialMedia,socialAccounts:this.accounts,companies:this._getCompanies(),onSaved:this._onStreamAdded.bind(this),}))}
async _onStreamAdded(stream){const streams=await this.orm.searchRead('social.stream',[['id','=',stream.data.id],['stream_post_ids','=',false]],['name']);if(streams.length){this.notification.add(_t("It will appear in the Feed once it has posts to display."),{title:_t("Stream Added (%s)",streams[0].name),type:"success"});}else{await this.model.load();this.model.notify();}}
async _fetchSocialMedia(){if(this.socialMedia){return this.socialMedia;}else{this.socialMedia=await this.orm.searchRead('social.media',[['has_streams','=','True']],['id','name'],);return this.socialMedia;}}
_getCompanies(){const companies=this.company.allowedCompanies;return this.company.activeCompanyIds.map(companyId=>companies[companyId]);}}
return __exports;});;

/* /social/static/src/js/stream_post_kanban_dashboard.js */
odoo.define('@social/js/stream_post_kanban_dashboard',['@web/core/l10n/translation','@web/views/fields/formatters','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{formatInteger}=require('@web/views/fields/formatters');const{useService}=require('@web/core/utils/hooks');const{Component,onMounted,onWillUnmount,useRef}=require("@odoo/owl");const StreamPostDashboard=__exports.StreamPostDashboard=class StreamPostDashboard extends Component{static template="social.KanbanDashboard";static props={accounts:Array,isSocialManager:Boolean,};setup(){super.setup();this.dashboard=useRef('dashboard');this.notification=useService('notification');this.orm=useService('orm');this.popover=[];onMounted(()=>this._initPopover());onWillUnmount(()=>this._disposePopover());}
formatStatValue(statValue){return formatInteger(statValue);}
_onRelinkAccount(event){const mediaId=parseInt(event.currentTarget.dataset.mediaId);if(this.props.isSocialManager){this.orm.call('social.media','action_add_account',[mediaId]).then((action)=>{document.location=action.url;});}else{this.notification.add(_t('Sorry, you\'re not allowed to re-link this account, please contact your administrator.'),{type:'danger'});}}
_initPopover(){this.dashboard.el.querySelectorAll('[data-bs-toggle="popover"]').forEach(el=>{this.popover.push(new Popover(el,{trigger:'hover',delay:{show:500,hide:0},}));});}
_disposePopover(){this.popover.forEach((popover)=>{popover.dispose();})}
_hasAudience(account){return true;}
_hasEngagement(account){return true;}
_hasStories(account){return true;}}
return __exports;});;

/* /social/static/src/js/stream_post_kanban_model.js */
odoo.define('@social/js/stream_post_kanban_model',['@web/model/relational_model/relational_model'],function(require){'use strict';let __exports={};const{RelationalModel}=require("@web/model/relational_model/relational_model");const StreamPostKanbanModel=__exports.StreamPostKanbanModel=class StreamPostKanbanModel extends RelationalModel{_refreshStreams(){return this.orm.silent.call('social.stream','refresh_all',[]);}
_refreshAccountsStats(){this.orm.silent.call('social.live.post','refresh_statistics',[]);return this.orm.silent.call('social.account','refresh_statistics',[]);}
_loadAccountsStats(){return this.orm.searchRead('social.account',[['has_account_stats','=',true]],['id','name','is_media_disconnected','audience','audience_trend','engagement','engagement_trend','stories','stories_trend','has_trends','media_id','media_type','stats_link','image',]);}
hasData(){return this.root.records.length>0;}}
return __exports;});;

/* /social/static/src/js/stream_post_kanban_record.js */
odoo.define('@social/js/stream_post_kanban_record',['@web/views/kanban/kanban_record'],function(require){'use strict';let __exports={};const{KanbanRecord}=require('@web/views/kanban/kanban_record');const CANCEL_GLOBAL_CLICK=__exports.CANCEL_GLOBAL_CLICK=["a",".o_social_subtle_btn","img"].join(",");const DEFAULT_COMMENT_COUNT=20;const StreamPostKanbanRecord=__exports.StreamPostKanbanRecord=class StreamPostKanbanRecord extends KanbanRecord{onGlobalClick(ev){if(ev.target.closest(CANCEL_GLOBAL_CLICK)){return;}
this.rootRef.el.querySelector('.o_social_comments').click();}
async _updateLikesCount(userLikeField,likesCountField){const userLikes=this.props.record.data[userLikeField];let likesCount=this.props.record.data[likesCountField];if(userLikes){if(likesCount>0){likesCount--;}}else{likesCount++;}
await this.props.record.update({[userLikeField]:!userLikes,[likesCountField]:likesCount,...this._prepareLikeAdditionnalValues(likesCount,!userLikes),});await this.props.record.save();}
_prepareLikeAdditionnalValues(likesCount,userLikes){return{};}
get commentCount(){return this.props.commentCount||DEFAULT_COMMENT_COUNT;}}
return __exports;});;

/* /social/static/src/js/stream_post_kanban_refresh_banner.js */
odoo.define('@social/js/stream_post_kanban_refresh_banner',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const NewContentRefreshBanner=__exports.NewContentRefreshBanner=class NewContentRefreshBanner extends Component{static template="social.NewContentRefreshBanner";static props=["refreshRequired","onClickRefresh",];}
return __exports;});;

/* /social/static/src/js/stream_post_kanban_renderer.js */
odoo.define('@social/js/stream_post_kanban_renderer',['@web/core/l10n/translation','@web/views/kanban/kanban_header','@web/views/kanban/kanban_renderer','@web/core/utils/hooks','@social/js/stream_post_kanban_record','@social/js/images_carousel_dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{KanbanHeader}=require('@web/views/kanban/kanban_header');const{KanbanRenderer}=require('@web/views/kanban/kanban_renderer');const{useService}=require('@web/core/utils/hooks');const{StreamPostKanbanRecord}=require("@social/js/stream_post_kanban_record");const{ImagesCarouselDialog}=require("@social/js/images_carousel_dialog");const{useEffect,useRef}=require("@odoo/owl");class StreamPostKanbanHeader extends KanbanHeader{static template="social.KanbanHeader";}
const StreamPostKanbanRenderer=__exports.StreamPostKanbanRenderer=class StreamPostKanbanRenderer extends KanbanRenderer{static components={...KanbanRenderer.components,KanbanRecord:StreamPostKanbanRecord,KanbanHeader:StreamPostKanbanHeader,};setup(){super.setup();this.dialog=useService('dialog');const rootRef=useRef("root");useEffect((images)=>{const onClickMoreImages=this.onClickMoreImages.bind(this);images.forEach((image)=>image.addEventListener('click',onClickMoreImages));return()=>{images.forEach((image)=>image.removeEventListener('click',onClickMoreImages));};},()=>[rootRef.el.querySelectorAll('.o_social_stream_post_image_more')]);}
onClickMoreImages(ev){ev.stopPropagation();this.dialog.add(ImagesCarouselDialog,{title:_t("Post Images"),activeIndex:parseInt(ev.currentTarget.dataset.index),images:ev.currentTarget.dataset.imageUrls.split(',')})}
get showNoContentHelper(){const{model}=this.props.list;return!model.hasData();}}
return __exports;});;

/* /social/static/src/js/stream_post_kanban_view.js */
odoo.define('@social/js/stream_post_kanban_view',['@social/js/stream_post_kanban_controller','@social/js/stream_post_kanban_model','@social/js/stream_post_kanban_renderer','@web/views/kanban/kanban_view','@web/core/registry'],function(require){'use strict';let __exports={};const{StreamPostKanbanController}=require("@social/js/stream_post_kanban_controller");const{StreamPostKanbanModel}=require("@social/js/stream_post_kanban_model");const{StreamPostKanbanRenderer}=require("@social/js/stream_post_kanban_renderer");const{kanbanView}=require('@web/views/kanban/kanban_view');const{registry}=require('@web/core/registry');const StreamPostKanbanView=__exports.StreamPostKanbanView={...kanbanView,Controller:StreamPostKanbanController,Model:StreamPostKanbanModel,Renderer:StreamPostKanbanRenderer,buttonTemplate:'StreamPostKanbanView.buttons',};registry.category("views").add("social_stream_post_kanban_view",StreamPostKanbanView);return __exports;});;

/* /social/static/src/js/tours/social.js */
odoo.define('@social/js/tours/social',['@web/core/l10n/translation','@web/core/registry','@web_tour/tour_service/tour_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{stepUtils}=require("@web_tour/tour_service/tour_utils");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add("social_tour",{url:"/odoo",steps:()=>[stepUtils.showAppsMenuItem(),{trigger:'.o_app[data-menu-xmlid="social.menu_social_global"]',content:markup(_t("Let's create your own <b>social media</b> dashboard.")),tooltipPosition:'bottom',run:"click",},{trigger:'button.o_stream_post_kanban_new_stream',content:markup(_t("Let's <b>connect</b> to Facebook, LinkedIn or X.")),tooltipPosition:'bottom',run:"click",},{trigger:'.o_social_media_cards',content:markup(_t("Choose which <b>account</b> you would like to link first.")),tooltipPosition:'right',run:"click",},{trigger:'button.o_stream_post_kanban_new_post',content:_t("Let's start posting."),tooltipPosition:'bottom',run:"click",},{trigger:'.o_field_widget[name="message"] .o_input',content:_t("Write a message to get a preview of your post."),tooltipPosition:'bottom',run:'edit Awesome post!',},{trigger:'button[name="action_post"]',content:_t("Happy with the result? Let's post it!"),tooltipPosition:'bottom',run:"click",},],});return __exports;});;

/* /approvals/static/src/views/kanban/approvals_category_kanban_controller.js */
odoo.define('@approvals/views/kanban/approvals_category_kanban_controller',['@web/core/l10n/translation','@web/core/confirmation_dialog/confirmation_dialog','@web/core/utils/hooks','@web/views/kanban/kanban_controller','@web/views/kanban/kanban_renderer'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{useService}=require("@web/core/utils/hooks");const{KanbanController}=require("@web/views/kanban/kanban_controller");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const ApprovalCategoryKanbanController=__exports.ApprovalCategoryKanbanController=class ApprovalCategoryKanbanController extends KanbanController{async setup(){super.setup();this.action=useService("action");}
OpenNewApprovalRequest(){this.action.doAction({type:"ir.actions.act_window",res_model:"approval.request",views:[[false,"form"]],target:"current",});}}
const ApprovalKanbanRenderer=__exports.ApprovalKanbanRenderer=class ApprovalKanbanRenderer extends KanbanRenderer{async archiveRecord(record,active){if(active){this.dialog.add(ConfirmationDialog,{body:_t("Are you sure that you want to archive this record?"),confirmLabel:_t("Archive"),confirm:()=>{record.archive();this.props.list.load();},cancel:()=>{},});}else{record.unarchive();this.props.list.load();}}}
return __exports;});;

/* /approvals/static/src/views/kanban/approvals_category_kanban_view.js */
odoo.define('@approvals/views/kanban/approvals_category_kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@approvals/views/kanban/approvals_category_kanban_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{ApprovalKanbanRenderer,ApprovalCategoryKanbanController}=require("@approvals/views/kanban/approvals_category_kanban_controller");const approvalsCategoryKanbanView=__exports.approvalsCategoryKanbanView={...kanbanView,Controller:ApprovalCategoryKanbanController,Renderer:ApprovalKanbanRenderer,buttonTemplate:"approvals.ApprovalsCategoryKanbanView.Buttons",};registry.category("views").add("approvals_category_kanban",approvalsCategoryKanbanView);return __exports;});;

/* /approvals/static/src/web/activity/activity_list_popover_item_patch.js */
odoo.define('@approvals/web/activity/activity_list_popover_item_patch',['@approvals/web/activity/approval','@mail/core/web/activity_list_popover_item','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Approval}=require("@approvals/web/activity/approval");const{ActivityListPopoverItem}=require("@mail/core/web/activity_list_popover_item");const{patch}=require("@web/core/utils/patch");Object.assign(ActivityListPopoverItem.components,{Approval});patch(ActivityListPopoverItem.prototype,{get hasEditButton(){if(this.props.activity.approval){return false;}
return super.hasEditButton;},get hasMarkDoneButton(){if(this.props.activity.approval){return false;}
return super.hasMarkDoneButton;},});return __exports;});;

/* /approvals/static/src/web/activity/activity_model_patch.js */
odoo.define('@approvals/web/activity/activity_model_patch',['@mail/core/web/activity_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Activity}=require("@mail/core/web/activity_model");const{patch}=require("@web/core/utils/patch");patch(Activity,{_insert(data){const activity=super._insert(...arguments);if("approver_id"in data&&"approver_status"in data){if(!data.approver_id){delete activity.approval;}else{activity.approval={id:data.approver_id,status:data.approver_status};}}
return activity;},});return __exports;});;

/* /approvals/static/src/web/activity/activity_patch.js */
odoo.define('@approvals/web/activity/activity_patch',['@mail/core/web/activity','@approvals/web/activity/approval'],function(require){'use strict';let __exports={};const{Activity}=require("@mail/core/web/activity");const{Approval}=require("@approvals/web/activity/approval");Object.assign(Activity.components,{Approval});return __exports;});;

/* /approvals/static/src/web/activity/approval.js */
odoo.define('@approvals/web/activity/approval',['@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const Approval=__exports.Approval=class Approval extends Component{static template="approvals.Approval";static props={activity:Object,onChange:Function,};setup(){this.store=useState(useService("mail.store"));}
async onClickApprove(){await this.env.services.orm.call("approval.approver","action_approve",[this.props.activity.approval.id,]);this.props.activity.remove();this.props.onChange();}
async onClickRefuse(){await this.env.services.orm.call("approval.approver","action_refuse",[this.props.activity.approval.id,]);this.props.activity.remove();this.props.onChange();}}
return __exports;});;

/* /marketing_automation/static/src/js/campaign_form_view/marketing_campaign_form_controller.js */
odoo.define('@marketing_automation/js/campaign_form_view/marketing_campaign_form_controller',['@web/core/utils/hooks','@web/views/form/form_controller','@marketing_automation/components/campaign_template_picker_dialog/campaign_template_picker_dialog'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{FormController}=require("@web/views/form/form_controller");const{CampaignTemplatePickerDialog}=require("@marketing_automation/components/campaign_template_picker_dialog/campaign_template_picker_dialog");const CampaignFormController=__exports.CampaignFormController=class CampaignFormController extends FormController{setup(){super.setup();this.dialog=useService("dialog");}
async create(){this.dialog.add(CampaignTemplatePickerDialog,{});}}
return __exports;});;

/* /marketing_automation/static/src/js/campaign_form_view/marketing_campaign_form_view.js */
odoo.define('@marketing_automation/js/campaign_form_view/marketing_campaign_form_view',['@web/core/registry','@web/views/form/form_view','@marketing_automation/js/campaign_form_view/marketing_campaign_form_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");const{CampaignFormController}=require("@marketing_automation/js/campaign_form_view/marketing_campaign_form_controller");const CampaignFormView=__exports.CampaignFormView={...formView,Controller:CampaignFormController,};registry.category("views").add("marketing_campaign_form_view",CampaignFormView);return __exports;});;

/* /marketing_automation/static/src/js/campaign_kanban_view/marketing_campaign_kanban_controller.js */
odoo.define('@marketing_automation/js/campaign_kanban_view/marketing_campaign_kanban_controller',['@web/core/utils/hooks','@web/views/kanban/kanban_controller','@marketing_automation/components/campaign_template_picker_dialog/campaign_template_picker_dialog'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{KanbanController}=require("@web/views/kanban/kanban_controller");const{CampaignTemplatePickerDialog}=require("@marketing_automation/components/campaign_template_picker_dialog/campaign_template_picker_dialog");const CampaignKanbanController=__exports.CampaignKanbanController=class CampaignKanbanController extends KanbanController{setup(){super.setup();this.dialog=useService("dialog");}
async createRecord(){this.dialog.add(CampaignTemplatePickerDialog,{});}}
return __exports;});;

/* /marketing_automation/static/src/js/campaign_kanban_view/marketing_campaign_kanban_view.js */
odoo.define('@marketing_automation/js/campaign_kanban_view/marketing_campaign_kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@marketing_automation/js/campaign_kanban_view/marketing_campaign_kanban_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{CampaignKanbanController}=require("@marketing_automation/js/campaign_kanban_view/marketing_campaign_kanban_controller");const CampaignKanbanView=__exports.CampaignKanbanView={...kanbanView,Controller:CampaignKanbanController,};registry.category("views").add("marketing_campaign_kanban_view",CampaignKanbanView);return __exports;});;

/* /marketing_automation/static/src/js/campaign_list_view/marketing_campaign_list_controller.js */
odoo.define('@marketing_automation/js/campaign_list_view/marketing_campaign_list_controller',['@web/core/utils/hooks','@web/views/list/list_controller','@marketing_automation/components/campaign_template_picker_dialog/campaign_template_picker_dialog'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{ListController}=require("@web/views/list/list_controller");const{CampaignTemplatePickerDialog}=require("@marketing_automation/components/campaign_template_picker_dialog/campaign_template_picker_dialog");const CampaignListController=__exports.CampaignListController=class CampaignListController extends ListController{setup(){super.setup();this.dialog=useService("dialog");}
async createRecord(){this.dialog.add(CampaignTemplatePickerDialog,{});}}
return __exports;});;

/* /marketing_automation/static/src/js/campaign_list_view/marketing_campaign_list_view.js */
odoo.define('@marketing_automation/js/campaign_list_view/marketing_campaign_list_view',['@web/core/registry','@web/views/list/list_view','@marketing_automation/js/campaign_list_view/marketing_campaign_list_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{CampaignListController}=require("@marketing_automation/js/campaign_list_view/marketing_campaign_list_controller");const CampaignListView=__exports.CampaignListView={...listView,Controller:CampaignListController,};registry.category("views").add("marketing_campaign_list_view",CampaignListView);return __exports;});;

/* /marketing_automation/static/src/js/marketing_automation_graph.js */
odoo.define('@marketing_automation/js/marketing_automation_graph',['@web/core/assets','@web/core/registry','@web/core/browser/cookie','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{loadJS}=require("@web/core/assets");const{registry}=require("@web/core/registry");const{cookie}=require("@web/core/browser/cookie");const{Component,onWillStart,onWillUnmount,useEffect,useRef}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const fieldRegistry=registry.category("fields");const MarketingActivityGraph=__exports.MarketingActivityGraph=class MarketingActivityGraph extends Component{static template="marketing_automation.MarketingActivityGraph";static props={...standardFieldProps};setup(){this.chart=null;this.canvasRef=useRef("canvas");this.isDarkMode=cookie.get("color_scheme");onWillStart(()=>loadJS("/web/static/lib/Chart/Chart.js"));useEffect(()=>this.renderChart());onWillUnmount(this.onWillUnmount);}
onWillUnmount(){if(this.chart){this.chart.destroy();}}
renderChart(){if(this.chart){this.chart.destroy();}
const config=this.getChartConfig();this.chart=new Chart(this.canvasRef.el,config);}
getChartConfig(){const chartData=JSON.parse(this.props.record.data[this.props.name]);if(this.isDarkMode=='dark'){chartData[0].color='#6afb81';chartData[1].color='#fb6a6a';}
const datasets=chartData.map((group)=>{const borderColor=this.hexToRGBA(group.color,1);const fillColor=this.hexToRGBA(group.color,0.6);return{label:group.label,data:group.points,fill:'origin',backgroundColor:fillColor,borderColor:borderColor,borderWidth:2,pointBackgroundColor:'rgba(0, 0, 0, 0)',pointBorderColor:borderColor,};});const labels=chartData[0].points.map((point)=>{return point.x;});return{type:'line',data:{labels:labels,datasets:datasets,},options:{elements:{line:{tension:0,},},animation:false,layout:{padding:{left:25,right:20,top:5,bottom:20}},plugins:{legend:{display:false,},tooltip:{mode:'index',intersect:false,bodyColor:"rgba(0,0,0,1)",titleFont:{size:13,},titleColor:"rgba(0,0,0,1)",backgroundColor:'rgba(255,255,255,0.6)',borderColor:'rgba(0,0,0,0.2)',borderWidth:2,callbacks:{labelColor:(tooltipItem)=>{const dataset=tooltipItem.dataset;return{borderColor:"rgba(255,255,255,0.6)",backgroundColor:dataset.backgroundColor,};},},},},maintainAspectRatio:false,scales:{y:{type:'linear',display:false,beginAtZero:true,},x:{ticks:{maxRotation:0,},},},}};}
hexToRGBA(hex,opacity){const result=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);const rgb=result.slice(1,4).map((n)=>{return parseInt(n,16);}).join(',');return'rgba('+rgb+','+opacity+')';}}
const marketingActivityGraph=__exports.marketingActivityGraph={component:MarketingActivityGraph,};fieldRegistry.add('marketing_activity_graph',marketingActivityGraph);return __exports;});;

/* /marketing_automation/static/src/js/marketing_automation_one2many.js */
odoo.define('@marketing_automation/js/marketing_automation_one2many',['@web/core/l10n/translation','@web/core/confirmation_dialog/confirmation_dialog','@web/core/registry','@web/core/utils/hooks','@web/core/utils/xml','@web/views/fields/relational_utils','@web/views/fields/x2many/x2many_field','@web/views/kanban/kanban_record','@web/views/kanban/kanban_renderer','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{append,createElement,parseXML}=require("@web/core/utils/xml");const{useX2ManyCrud,useOpenX2ManyRecord}=require("@web/views/fields/relational_utils");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const{KanbanRecord}=require("@web/views/kanban/kanban_record");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{useEffect,useRef,useSubEnv}=require("@odoo/owl");const fieldRegistry=registry.category("fields");const HierarchyKanbanRecord=__exports.HierarchyKanbanRecord=class HierarchyKanbanRecord extends KanbanRecord{static components={...KanbanRecord.components,HierarchyKanbanRecord,};static defaultProps={...KanbanRecord.defaultProps,};static props=KanbanRecord.props.concat(["is_readonly?","getRecordDepth"]);setup(){super.setup();this.dialogService=useService("dialog");if(this.props.is_readonly!==undefined){this.props.readonly=this.props.is_readonly;}
this.activeTab='graph';useEffect(()=>{const activityTabs=this.rootRef.el.querySelectorAll('.o_ma_activity_tab');const onMarketingActivityTabClick=this.onMarketingActivityTabClick.bind(this);activityTabs.forEach((el)=>{el.addEventListener("click",onMarketingActivityTabClick);});return()=>{activityTabs.forEach((el)=>{el.removeEventListener("click",onMarketingActivityTabClick);});};},()=>[]);useEffect(this.applyTabPanelVisibility.bind(this),()=>[this.rootRef.el]);useEffect(()=>{const addChildActivityButtons=this.rootRef.el.querySelectorAll('.o_add_child_activity');const onAddChildActivityClick=this.onAddChildActivityClick.bind(this);addChildActivityButtons.forEach((el)=>{el.addEventListener("click",onAddChildActivityClick);});return()=>{addChildActivityButtons.forEach((el)=>{el.removeEventListener("click",onAddChildActivityClick);});};},()=>[]);}
triggerAction(params){const{group,list,record}=this.props;const listOrGroup=group||list;const{type}=params;const directChildren=list.records.filter((listRecord)=>listRecord.data.parent_id&&listRecord.data.parent_id[0]==record.resId);if(type==="delete"&&!listOrGroup.deleteRecords&&directChildren&&directChildren.length!==0){this.dialogService.add(ConfirmationDialog,{body:_t("Deleting this activity will delete ALL its children activities. Are you sure?"),confirmLabel:_t("Delete"),confirm:()=>super.triggerAction(...arguments),cancel:()=>{},});}else{super.triggerAction(...arguments);}}
async onAddChildActivityClick(ev){await this.props.list.model.root.save();const context={default_parent_id:this.props.record.resId,default_trigger_type:ev.target.dataset.triggerType,};this.env.onAddMarketingActivity({context});}
onMarketingActivityTabClick(ev){ev.stopPropagation();this.activeTab=ev.currentTarget.dataset.tabType;this.applyTabPanelVisibility();this.props.record.model.notify();}
applyTabPanelVisibility(){const graphTab=this.rootRef.el.querySelector('.o_pane_graph');const filterTab=this.rootRef.el.querySelector('.o_pane_filter');if(!graphTab||!filterTab){return;}
this.rootRef.el.querySelectorAll('.o_ma_activity_tab').forEach(el=>el.classList.remove('active'));if(this.activeTab==='graph'){graphTab.classList.remove('d-none');filterTab.classList.add('d-none');const graphTabButton=this.rootRef.el.querySelector('[data-tab-type="graph"]');if(graphTabButton){graphTabButton.classList.add('active');}}else if(this.activeTab==='filter'){graphTab.classList.add('d-none');filterTab.classList.remove('d-none');const filterTabButton=this.rootRef.el.querySelector('[data-tab-type="filter"]');if(filterTabButton){filterTabButton.classList.add('active');}}}}
const HierarchyKanbanRenderer=__exports.HierarchyKanbanRenderer=class HierarchyKanbanRenderer extends KanbanRenderer{static template="marketing_automation.HierarchyKanbanRenderer";static components={...KanbanRenderer.components,KanbanRecord:HierarchyKanbanRecord,};setup(){super.setup();const rootEl=this.props.archInfo.templateDocs["card"].firstElementChild;const rootTemplate=createElement("t",{"t-name":"root"});append(rootTemplate,rootEl);this.props.archInfo.templateDocs.root=rootTemplate;const mainTemplate=parseXML(`
            <t t-name="card">
                <t t-set="currentDepth" t-value="currentDepth ? currentDepth + 1 : 1"/>
                <div t-if="__comp__.props.getRecordDepth(__comp__.props.record) - currentDepth + 1 > 0" class="o_ma_body_wrapper"
                    t-call="{{ __comp__.templates['card'] }}"/>
                <t t-else="" t-call="{{ __comp__.templates.root }}"/>
            </t>
            `,);this.props.archInfo.templateDocs["card"]=mainTemplate;this.rootRef=useRef("root");}
getGroupsOrRecords(){return this._getSortedRecordsByHierarchy(this.props.list.records,false).map((record)=>({record,key:record.id,}));}
getRecordDepth(record){let parentByChildMap=this._getParentByChildMap(this.props.list.records);let childId=record.resId;let depth=0;while(childId){childId=parentByChildMap[childId];if(childId){depth++;}}
return depth;}
_getParentByChildMap(records){const parentMap={};records.forEach((activityRecord)=>{const parentId=activityRecord.data.parent_id;if(parentId){parentMap[activityRecord.resId]=parentId[0];}});return parentMap;}
_getSortedRecordsByHierarchy(records,parentId){return records.flatMap(record=>{if(!record.resId){return[]}else if(!record.data.parent_id&&parentId){return[];}else if(record.data.parent_id&&record.data.parent_id[0]!==parentId){return[];}
return[record,...this._getSortedRecordsByHierarchy(records,record.resId)];});};}
const HierarchyKanban=__exports.HierarchyKanban=class HierarchyKanban extends X2ManyField{static components={...X2ManyField.components,KanbanRenderer:HierarchyKanbanRenderer};setup(){super.setup();const{saveRecord,updateRecord}=useX2ManyCrud(()=>this.list,this.isMany2Many);const openRecord=useOpenX2ManyRecord({resModel:this.list.resModel,activeField:this.activeField,activeActions:this.activeActions,getList:()=>this.list,saveRecord:async(record)=>{await saveRecord(record);await this.props.record.save();},updateRecord:updateRecord,});this._openRecord=openRecord;useSubEnv({onAddMarketingActivity:this.onAdd.bind(this),});}}
const hierarchyKanban=__exports.hierarchyKanban={...x2ManyField,component:HierarchyKanban,};fieldRegistry.add("hierarchy_kanban",hierarchyKanban);return __exports;});;

/* /marketing_automation/static/src/components/campaign_template_picker_dialog/campaign_template_picker_dialog.js */
odoo.define('@marketing_automation/components/campaign_template_picker_dialog/campaign_template_picker_dialog',['@web/core/dialog/dialog','@web/core/notebook/notebook','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{Notebook}=require("@web/core/notebook/notebook");const{useService}=require("@web/core/utils/hooks");const{Component,onWillStart,useState}=require("@odoo/owl");const CampaignTemplatePickerDialog=__exports.CampaignTemplatePickerDialog=class CampaignTemplatePickerDialog extends Component{static template="marketing_automation.CampaignTemplatePickerDialog";static components={Dialog,Notebook,};static props={close:{type:Function,optional:true},};setup(){super.setup();this.orm=useService("orm");this.action=useService("action");this.activeTemplate=useState({});this.notebookPages=[];onWillStart(async()=>{const templateGroups=await this.orm.call("marketing.campaign","get_campaign_templates_info",[]);const firstGroup=Object.keys(templateGroups)[0];this.setActive(Object.keys(templateGroups[firstGroup].templates)[0]);for(const[groupId,groupValues]of Object.entries(templateGroups)){this.notebookPages.push({Component:CampaignTemplatePickerSheet,id:groupId,props:{activeTemplate:this.activeTemplate,setActive:(arg)=>this.setActive(arg),templates:groupValues.templates,},title:groupValues.label,});}});}
async onLoadTemplate(){const action=await this.orm.call("marketing.campaign","get_action_marketing_campaign_from_template",[this.activeTemplate.name]);if(!action){return;}
this.action.doAction(action);this.props.close();}
setActive(templateName){this.activeTemplate.name=templateName;}}
class CampaignTemplatePickerSheet extends Component{static template="marketing_automation.CampaignTemplatePickerDialogSheet";static props={activeTemplate:{type:Object},setActive:{type:Function},templates:{type:Object},};}
return __exports;});;

/* /im_livechat/static/src/js/colors_reset_button/colors_reset_button.js */
odoo.define('@im_livechat/js/colors_reset_button/colors_reset_button',['@web/core/registry','@web/views/widgets/standard_widget_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{Component}=require("@odoo/owl");const ColorsResetButton=__exports.ColorsResetButton=class ColorsResetButton extends Component{static template=`im_livechat.ColorsResetButton`;static props={...standardWidgetProps,default_colors:{type:Object},};onColorsResetButtonClick(){this.props.record.update(this.props.default_colors);}}
const colorsResetButton=__exports.colorsResetButton={component:ColorsResetButton,extractProps:({options})=>({default_colors:options.default_colors,}),};registry.category("view_widgets").add("colors_reset_button",colorsResetButton);return __exports;});;

/* /im_livechat/static/src/js/im_livechat_chatbot_steps_one2many.js */
odoo.define('@im_livechat/js/im_livechat_chatbot_steps_one2many',['@web/core/registry','@web/views/fields/relational_utils','@web/views/fields/x2many/x2many_field','@web/views/list/list_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useX2ManyCrud,useOpenX2ManyRecord}=require("@web/views/fields/relational_utils");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const{ListRenderer}=require("@web/views/list/list_renderer");const fieldRegistry=registry.category("fields");const ChatbotStepsOne2manyRenderer=__exports.ChatbotStepsOne2manyRenderer=class ChatbotStepsOne2manyRenderer extends ListRenderer{setup(){super.setup();for(const[,properties]of Object.entries(this.fields)){properties.sortable=false;}}}
const ChatbotStepsOne2many=__exports.ChatbotStepsOne2many=class ChatbotStepsOne2many extends X2ManyField{static components={...X2ManyField.components,ListRenderer:ChatbotStepsOne2manyRenderer,};setup(){super.setup();const{saveRecord,updateRecord}=useX2ManyCrud(()=>this.list,this.isMany2Many);const openRecord=useOpenX2ManyRecord({resModel:this.list.resModel,activeField:this.activeField,activeActions:this.activeActions,getList:()=>this.list,saveRecord:async(record)=>{await saveRecord(record);await this.props.record.save();},updateRecord:updateRecord,});this._openRecord=(params)=>{const activeElement=document.activeElement;openRecord({...params,onClose:()=>{if(activeElement){activeElement.focus();}},});};}}
const chatbotStepsOne2many=__exports.chatbotStepsOne2many={...x2ManyField,component:ChatbotStepsOne2many,};fieldRegistry.add("chatbot_steps_one2many",chatbotStepsOne2many);return __exports;});;

/* /im_livechat/static/src/js/im_livechat_chatbot_script_answers_m2m.js */
odoo.define('@im_livechat/js/im_livechat_chatbot_script_answers_m2m',['@web/core/registry','@web/core/user','@web/views/fields/many2many_tags/many2many_tags_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const{Many2ManyTagsField,many2ManyTagsField,}=require("@web/views/fields/many2many_tags/many2many_tags_field");const fieldRegistry=registry.category("fields");const ChatbotScriptTriggeringAnswersMany2Many=__exports.ChatbotScriptTriggeringAnswersMany2Many=class ChatbotScriptTriggeringAnswersMany2Many extends Many2ManyTagsField{setup(){super.setup();if(this.props.record.model.root.resId){user.updateContext({force_domain_chatbot_script_id:this.props.record.model.root.resId,});}}}
const chatbotScriptTriggeringAnswersMany2Many=__exports.chatbotScriptTriggeringAnswersMany2Many={...many2ManyTagsField,component:ChatbotScriptTriggeringAnswersMany2Many,};fieldRegistry.add("chatbot_triggering_answers_widget",chatbotScriptTriggeringAnswersMany2Many);return __exports;});;

/* /im_livechat/static/src/views/discuss_channel_kanban/discuss_channel_kanban_view.js */
odoo.define('@im_livechat/views/discuss_channel_kanban/discuss_channel_kanban_view',['@web/views/kanban/kanban_controller','@web/views/kanban/kanban_view','@web/core/registry','@im_livechat/views/livechat_view_controller_mixin'],function(require){'use strict';let __exports={};const{KanbanController}=require("@web/views/kanban/kanban_controller");const{kanbanView}=require("@web/views/kanban/kanban_view");const{registry}=require("@web/core/registry");const{LivechatViewControllerMixin}=require("@im_livechat/views/livechat_view_controller_mixin");class DiscussChannelKanbanController extends LivechatViewControllerMixin(KanbanController){}
const discussChannelKanbanView={...kanbanView,Controller:DiscussChannelKanbanController,};registry.category("views").add("im_livechat.discuss_channel_kanban",discussChannelKanbanView);return __exports;});;

/* /im_livechat/static/src/views/discuss_channel_list/discuss_channel_list_view.js */
odoo.define('@im_livechat/views/discuss_channel_list/discuss_channel_list_view',['@web/views/list/list_controller','@im_livechat/views/livechat_view_controller_mixin','@web/views/list/list_view','@web/core/registry'],function(require){'use strict';let __exports={};const{ListController}=require("@web/views/list/list_controller");const{LivechatViewControllerMixin}=require("@im_livechat/views/livechat_view_controller_mixin");const{listView}=require("@web/views/list/list_view");const{registry}=require("@web/core/registry");class DiscussChannelListController extends LivechatViewControllerMixin(ListController){}
const discussChannelListView={...listView,Controller:DiscussChannelListController,};registry.category("views").add("im_livechat.discuss_channel_list",discussChannelListView);return __exports;});;

/* /im_livechat/static/src/views/livechat_channel_kanban/livechat_channel_kanban_record.js */
odoo.define('@im_livechat/views/livechat_channel_kanban/livechat_channel_kanban_record',['@web/views/kanban/kanban_record'],function(require){'use strict';let __exports={};const{KanbanRecord}=require("@web/views/kanban/kanban_record");const LivechatChannelKanbanRecord=__exports.LivechatChannelKanbanRecord=class LivechatChannelKanbanRecord extends KanbanRecord{}
LivechatChannelKanbanRecord.menuTemplate="im_livechat.KanbanRecordMenu";return __exports;});;

/* /im_livechat/static/src/views/livechat_channel_kanban/livechat_channel_kanban_renderer.js */
odoo.define('@im_livechat/views/livechat_channel_kanban/livechat_channel_kanban_renderer',['@web/views/kanban/kanban_renderer','@im_livechat/views/livechat_channel_kanban/livechat_channel_kanban_record'],function(require){'use strict';let __exports={};const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{LivechatChannelKanbanRecord}=require("@im_livechat/views/livechat_channel_kanban/livechat_channel_kanban_record");const LivechatChannelKanbanRenderer=__exports.LivechatChannelKanbanRenderer=class LivechatChannelKanbanRenderer extends KanbanRenderer{static components={...KanbanRenderer.components,KanbanRecord:LivechatChannelKanbanRecord,};}
return __exports;});;

/* /im_livechat/static/src/views/livechat_channel_kanban/livechat_channel_kanban_view.js */
odoo.define('@im_livechat/views/livechat_channel_kanban/livechat_channel_kanban_view',['@im_livechat/views/livechat_channel_kanban/livechat_channel_kanban_renderer','@web/core/registry','@web/views/kanban/kanban_view'],function(require){'use strict';let __exports={};const{LivechatChannelKanbanRenderer}=require("@im_livechat/views/livechat_channel_kanban/livechat_channel_kanban_renderer");const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const livechatChannelKanbanView={...kanbanView,Renderer:LivechatChannelKanbanRenderer,};registry.category("views").add("im_livechat.livechat_channel_kanban",livechatChannelKanbanView);return __exports;});;

/* /im_livechat/static/src/views/livechat_view_controller_mixin.js */
odoo.define('@im_livechat/views/livechat_view_controller_mixin',['@odoo/owl','@web/core/utils/hooks','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const LivechatViewControllerMixin=__exports.LivechatViewControllerMixin=(ViewController)=>class extends ViewController{setup(){super.setup(...arguments);this.store=useState(useService("mail.store"));this.ui=useState(useService("ui"));}
async openRecord(record){if(!this.ui.isSmall){return this.actionService.doAction("mail.action_discuss",{name:_t("Discuss"),additionalContext:{active_id:record.resId},});}
const thread=await this.store.Thread.getOrFetch({model:"discuss.channel",id:record.resId,});if(thread){return thread.open();}
return super.openRecord(record);}};return __exports;});;

/* /im_livechat/static/src/core/common/channel_member_model_patch.js */
odoo.define('@im_livechat/core/common/channel_member_model_patch',['@mail/core/common/channel_member_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ChannelMember}=require("@mail/core/common/channel_member_model");const{patch}=require("@web/core/utils/patch");patch(ChannelMember.prototype,{get name(){if(this.thread.channel_type==="livechat"&&this.persona.user_livechat_username){return this.persona.user_livechat_username;}
if(this.persona.is_public){return this.thread.anonymous_name;}
return super.name;},});return __exports;});;

/* /im_livechat/static/src/core/common/livechat_channel_model.js */
odoo.define('@im_livechat/core/common/livechat_channel_model',['@mail/core/common/record'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const LivechatChannel=__exports.LivechatChannel=class LivechatChannel extends Record{static _name="im_livechat.channel";static id="id";are_you_inside;id;name;}
LivechatChannel.register();return __exports;});;

/* /im_livechat/static/src/core/common/message_patch.js */
odoo.define('@im_livechat/core/common/message_patch',['@mail/core/common/message','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message");const{patch}=require("@web/core/utils/patch");patch(Message.prototype,{get authorName(){if(this.message.author?.user_livechat_username&&this.message.thread?.channel_type==="livechat"){return this.message.author.user_livechat_username;}
return super.authorName;},});return __exports;});;

/* /im_livechat/static/src/core/common/thread_model_patch.js */
odoo.define('@im_livechat/core/common/thread_model_patch',['@mail/core/common/record','@mail/core/common/thread_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{Thread}=require("@mail/core/common/thread_model");const{patch}=require("@web/core/utils/patch");patch(Thread.prototype,{setup(){super.setup();this.operator=Record.one("Persona");},get autoOpenChatWindowOnNewMessage(){return this.channel_type==="livechat"||super.autoOpenChatWindowOnNewMessage;},get typesAllowingCalls(){return super.typesAllowingCalls.concat(["livechat"]);},get isChatChannel(){return this.channel_type==="livechat"||super.isChatChannel;},});return __exports;});;

/* /im_livechat/static/src/core/public_web/discuss_app_category_model_patch.js */
odoo.define('@im_livechat/core/public_web/discuss_app_category_model_patch',['@web/core/utils/patch','@mail/core/public_web/discuss_app_category_model','@mail/core/common/record','@mail/utils/common/misc'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{DiscussAppCategory}=require("@mail/core/public_web/discuss_app_category_model");const{Record}=require("@mail/core/common/record");const{compareDatetime}=require("@mail/utils/common/misc");patch(DiscussAppCategory.prototype,{setup(){super.setup(...arguments);this.livechatChannel=Record.one("im_livechat.channel",{inverse:"appCategory",onDelete(){this.delete();},});},sortThreads(t1,t2){if(this.livechatChannel||this.eq(this.app?.defaultLivechatCategory)){return compareDatetime(t2.lastInterestDt,t1.lastInterestDt)||t2.id-t1.id;}
return super.sortThreads(t1,t2);},});return __exports;});;

/* /im_livechat/static/src/core/public_web/discuss_app_model_patch.js */
odoo.define('@im_livechat/core/public_web/discuss_app_model_patch',['@mail/core/public_web/discuss_app_model','@mail/core/common/record','@web/core/l10n/translation','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{DiscussApp}=require("@mail/core/public_web/discuss_app_model");const{Record}=require("@mail/core/common/record");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");patch(DiscussApp.prototype,{setup(env){super.setup(env);this.defaultLivechatCategory=Record.one("DiscussAppCategory",{compute(){return{extraClass:"o-mail-DiscussSidebarCategory-livechat",icon:"fa fa-comments",hideWhenEmpty:true,id:`im_livechat.category_default`,name:_t("Livechat"),sequence:21,};},});this.livechats=Record.many("Thread",{inverse:"appAsLivechats"});},});return __exports;});;

/* /im_livechat/static/src/core/public_web/livechat_channel_model_patch.js */
odoo.define('@im_livechat/core/public_web/livechat_channel_model_patch',['@im_livechat/core/common/livechat_channel_model','@mail/core/common/record','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{LivechatChannel}=require("@im_livechat/core/common/livechat_channel_model");const{Record}=require("@mail/core/common/record");const{patch}=require("@web/core/utils/patch");const livechatChannelPatch={setup(){super.setup(...arguments);this.appCategory=Record.one("DiscussAppCategory",{compute(){return{extraClass:"o-mail-DiscussSidebarCategory-livechat",hideWhenEmpty:!this.are_you_inside,id:`im_livechat.category_${this.id}`,name:this.name,sequence:22,};},inverse:"livechatChannel",});this.threads=Record.many("Thread",{inverse:"livechatChannel"});},};patch(LivechatChannel.prototype,livechatChannelPatch);return __exports;});;

/* /im_livechat/static/src/core/public_web/messaging_menu_patch.js */
odoo.define('@im_livechat/core/public_web/messaging_menu_patch',['@mail/core/public_web/messaging_menu','@web/core/l10n/translation','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{MessagingMenu}=require("@mail/core/public_web/messaging_menu");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");patch(MessagingMenu.prototype,{get tabs(){const items=super.tabs;const hasLivechats=Object.values(this.store.Thread.records).some(({channel_type})=>channel_type==="livechat");if(hasLivechats){items.push({id:"livechat",icon:"fa fa-comments",label:_t("Livechat"),});}
return items;},});return __exports;});;

/* /im_livechat/static/src/core/public_web/thread_model_patch.js */
odoo.define('@im_livechat/core/public_web/thread_model_patch',['@mail/core/common/record','@mail/core/common/thread_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{Thread}=require("@mail/core/common/thread_model");const{patch}=require("@web/core/utils/patch");patch(Thread.prototype,{setup(){super.setup(...arguments);this.appAsLivechats=Record.one("DiscussApp",{compute(){return this.channel_type==="livechat"?this.store.discuss:null;},});this.livechatChannel=Record.one("im_livechat.channel",{inverse:"threads"});this.anonymous_country=Record.one("Country");},_computeDiscussAppCategory(){if(this.channel_type!=="livechat"){return super._computeDiscussAppCategory();}
return this.livechatChannel?.appCategory??this.appAsLivechats?.defaultLivechatCategory;},get hasMemberList(){return this.channel_type==="livechat"||super.hasMemberList;},get canLeave(){return this.channel_type!=="livechat"&&super.canLeave;},get canUnpin(){if(this.channel_type==="livechat"){return!this.selfMember||this.selfMember.message_unread_counter===0;}
return super.canUnpin;},get correspondents(){return super.correspondents.filter((correspondent)=>!correspondent.is_bot);},computeCorrespondent(){let correspondent=super.computeCorrespondent();if(this.channel_type==="livechat"&&!correspondent){const orderedChannelMembers=[...this.channelMembers].sort((a,b)=>a.id-b.id);const isFirstMemberOperator=orderedChannelMembers[0]?.persona.eq(this.operator);correspondent=isFirstMemberOperator?orderedChannelMembers[1]:orderedChannelMembers[0];}
return correspondent;},get displayName(){if(this.channel_type!=="livechat"||!this.correspondent){return super.displayName;}
if(!this.correspondent.persona.is_public&&this.correspondent.persona.country){return`${this.correspondent.name} (${this.correspondent.persona.country.name})`;}
if(this.anonymous_country){return`${this.correspondent.name} (${this.anonymous_country.name})`;}
return this.correspondent.name;},get avatarUrl(){if(this.channel_type==="livechat"&&this.correspondent){return this.correspondent.persona.avatarUrl;}
return super.avatarUrl;},setAsDiscussThread(pushState){super.setAsDiscussThread(pushState);if(this.store.env.services.ui.isSmall&&this.channel_type==="livechat"){this.store.discuss.activeTab="livechat";}},});return __exports;});;

/* /im_livechat/static/src/core/web/channel_commands_patch.js */
odoo.define('@im_livechat/core/web/channel_commands_patch',['@web/core/l10n/translation','@web/core/registry'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");registry.category("discuss.channel_commands").add("history",{channel_types:["livechat"],help:_t("See 15 last visited pages"),methodName:"execute_command_history",});return __exports;});;

/* /im_livechat/static/src/core/web/channel_member_list_patch.js */
odoo.define('@im_livechat/core/web/channel_member_list_patch',['@mail/discuss/core/common/channel_member_list','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ChannelMemberList}=require("@mail/discuss/core/common/channel_member_list");const{patch}=require("@web/core/utils/patch");patch(ChannelMemberList.prototype,{canOpenChatWith(member){return super.canOpenChatWith(member)&&!member.persona.is_public&&!member.is_bot;},});return __exports;});;

/* /im_livechat/static/src/core/web/chat_window_patch.js */
odoo.define('@im_livechat/core/web/chat_window_patch',['@mail/core/common/chat_window','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ChatWindow}=require("@mail/core/common/chat_window");const{patch}=require("@web/core/utils/patch");patch(ChatWindow.prototype,{async close(options){const thread=this.thread;await super.close(options);if(thread?.channel_type==="livechat"){await thread?.isLoadedDeferred;if(thread.messages.length===0){thread.unpin();}}},});return __exports;});;

/* /im_livechat/static/src/core/web/composer_patch.js */
odoo.define('@im_livechat/core/web/composer_patch',['@mail/core/common/composer','@web/core/l10n/translation','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Composer}=require("@mail/core/common/composer");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");patch(Composer.prototype,{onKeydown(ev){super.onKeydown(ev);if(ev.key==="Tab"&&this.thread?.channel_type==="livechat"&&!this.props.composer.text){const threadChanged=this.store.goToOldestUnreadLivechatThread();if(threadChanged){ev.stopPropagation();}}},get placeholder(){if(this.displayNextLivechatHint()&&this.props.composer.isFocused&&this.env.inChatWindow){return _t("Tab to next livechat");}
return super.placeholder;},displayNextLivechatHint(){return(this.thread?.channel_type==="livechat"&&this.store.discuss.livechats.some((thread)=>thread.notEq(this.thread)&&thread.isUnread));},});return __exports;});;

/* /im_livechat/static/src/core/web/discuss_client_action_patch.js */
odoo.define('@im_livechat/core/web/discuss_client_action_patch',['@mail/core/public_web/discuss_client_action','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{DiscussClientAction}=require("@mail/core/public_web/discuss_client_action");const{patch}=require("@web/core/utils/patch");patch(DiscussClientAction.prototype,{async restoreDiscussThread(){if(this.store.has_access_livechat){this.store.livechatChannels.fetch();}
return super.restoreDiscussThread(...arguments);},});return __exports;});;

/* /im_livechat/static/src/core/web/discuss_sidebar_category_patch.js */
odoo.define('@im_livechat/core/web/discuss_sidebar_category_patch',['@mail/discuss/core/public_web/discuss_sidebar_categories','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{DiscussSidebarCategory}=require("@mail/discuss/core/public_web/discuss_sidebar_categories");const{patch}=require("@web/core/utils/patch");const DiscussSidebarCategoryPatch={get actions(){const actions=super.actions;if(this.store.has_access_livechat&&this.category.livechatChannel&&this.category.open){actions.push({onSelect:()=>{if(this.category.livechatChannel.are_you_inside){this.category.livechatChannel.leave({notify:false});}else{this.category.livechatChannel.join({notify:false});}},label:this.category.livechatChannel.are_you_inside?this.category.livechatChannel.leaveTitle:this.category.livechatChannel.joinTitle,icon:this.category.livechatChannel.are_you_inside?"fa fa-sign-out text-danger":"fa fa-sign-in text-success",});}
return actions;},};patch(DiscussSidebarCategory.prototype,DiscussSidebarCategoryPatch);return __exports;});;

/* /im_livechat/static/src/core/web/livechat_channel_command_provider.js */
odoo.define('@im_livechat/core/web/livechat_channel_command_provider',['@odoo/owl','@web/core/registry'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{registry}=require("@web/core/registry");class LivechatChannelCommand extends Component{static template="im_livechat.LivechatChannelCommand";static props={executeCommand:Function,iconClass:String,name:String,searchValue:String,slots:Object,};}
registry.category("command_provider").add("im_livechat.channel_join_leave",{async provide(env){const store=env.services["mail.store"];if(!store?.has_access_livechat){return[];}
await store.livechatChannels.fetch();const activeChannels=new Set(Object.values(store["im_livechat.channel"].records).filter((c)=>c.threads.length>0).map((c)=>c.id));return Object.values(store["im_livechat.channel"].records).sort((c)=>(activeChannels.has(c.id)?-1:1)).map((c)=>({action:c.are_you_inside?c.leave.bind(c):c.join.bind(c),Component:LivechatChannelCommand,name:c.are_you_inside?c.leaveTitle:c.joinTitle,props:{iconClass:c.are_you_inside?"fa fa-sign-out text-danger":"fa fa-sign-in text-success",},}));},});return __exports;});;

/* /im_livechat/static/src/core/web/livechat_channel_model_patch.js */
odoo.define('@im_livechat/core/web/livechat_channel_model_patch',['@im_livechat/core/common/livechat_channel_model','@mail/utils/common/hooks','@web/core/l10n/translation','@web/core/utils/patch','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{LivechatChannel}=require("@im_livechat/core/common/livechat_channel_model");const{useSequential}=require("@mail/utils/common/hooks");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{sprintf}=require("@web/core/utils/strings");const sequential=useSequential();const livechatChannelPatch={async join({notify=true}={}){this.are_you_inside=true;if(notify){this.store.env.services.notification.add(_t("You joined %s.",this.name),{type:"info",});}
await sequential(()=>this.store.env.services.orm.call("im_livechat.channel","action_join",[this.id]));},get joinTitle(){return sprintf(_t("Join %s"),this.name);},async leave({notify=true}={}){this.are_you_inside=false;if(notify){this.store.env.services.notification.add(_t("You left %s.",this.name),{type:"info",});}
await sequential(()=>this.store.env.services.orm.call("im_livechat.channel","action_quit",[this.id]));},get leaveTitle(){return sprintf(_t("Leave %s"),this.name);},};patch(LivechatChannel.prototype,livechatChannelPatch);return __exports;});;

/* /im_livechat/static/src/core/web/partner_compare.js */
odoo.define('@im_livechat/core/web/partner_compare',['@mail/core/common/partner_compare'],function(require){'use strict';let __exports={};const{partnerCompareRegistry}=require("@mail/core/common/partner_compare");partnerCompareRegistry.add("im_livechat.available",(p1,p2,{thread})=>{if(thread?.channel_type==="livechat"&&p1.is_available!==p2.is_available){return p1.is_available?-1:1;}},{sequence:15});partnerCompareRegistry.add("im_livechat.invite-count",(p1,p2,{thread})=>{if(thread?.channel_type==="livechat"&&p1.invite_by_self_count!==p2.invite_by_self_count){return p2.invite_by_self_count-p1.invite_by_self_count;}},{sequence:20});return __exports;});;

/* /im_livechat/static/src/core/web/store_service_patch.js */
odoo.define('@im_livechat/core/web/store_service_patch',['@mail/core/common/store_service','@mail/utils/common/misc','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Store}=require("@mail/core/common/store_service");const{compareDatetime}=require("@mail/utils/common/misc");const{patch}=require("@web/core/utils/patch");patch(Store.prototype,{setup(){super.setup(...arguments);this.livechatChannels=this.makeCachedFetchData({livechat_channels:true});this.has_access_livechat=false;},onStarted(){super.onStarted(...arguments);if(this.discuss.isActive&&this.has_access_livechat){this.livechatChannels.fetch();}},goToOldestUnreadLivechatThread(){const[oldestUnreadThread]=this.discuss.livechats.filter((thread)=>thread.isUnread).sort((t1,t2)=>compareDatetime(t1.lastInterestDt,t2.lastInterestDt)||t1.id-t2.id);if(!oldestUnreadThread){return false;}
if(this.discuss.isActive){oldestUnreadThread.setAsDiscussThread();return true;}
const chatWindow=this.ChatWindow.insert({thread:oldestUnreadThread});chatWindow.open();chatWindow.focus();return true;},tabToThreadType(tab){const threadTypes=super.tabToThreadType(tab);if(tab==="chat"&&!this.env.services.ui.isSmall){threadTypes.push("livechat");}
if(tab==="livechat"){threadTypes.push("livechat");}
return threadTypes;},});return __exports;});;

/* /im_livechat/static/src/core/web/suggestion_service_patch.js */
odoo.define('@im_livechat/core/web/suggestion_service_patch',['@mail/core/common/suggestion_service','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{SuggestionService}=require("@mail/core/common/suggestion_service");const{patch}=require("@web/core/utils/patch");patch(SuggestionService.prototype,{getSupportedDelimiters(thread){const res=super.getSupportedDelimiters(...arguments);return thread.channel_type==="livechat"?res.filter((delimiter)=>delimiter.at(0)!=="#"):res;},});return __exports;});;

/* /im_livechat/static/src/core/web/thread_icon_patch.js */
odoo.define('@im_livechat/core/web/thread_icon_patch',['@mail/core/common/thread_icon','@web/core/l10n/translation','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ThreadIcon}=require("@mail/core/common/thread_icon");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");patch(ThreadIcon.prototype,{get defaultChatIcon(){if(this.props.thread.channel_type==="livechat"){return{class:"fa fa-comments opacity-75",title:_t("Livechat")};}
return super.defaultChatIcon;},});return __exports;});;

/* /appointment/static/src/views/appointment_calendar/appointment_calendar_controller.js */
odoo.define('@appointment/views/appointment_calendar/appointment_calendar_controller',['@web/core/l10n/translation','@calendar/views/attendee_calendar/attendee_calendar_controller','@web/core/utils/patch','@web/core/popover/popover_hook','@web/core/network/rpc','@web/core/tooltip/tooltip','@web/core/browser/browser','@web/core/l10n/dates','@web/core/utils/hooks','@odoo/owl','@web/core/dropdown/dropdown','@web/core/user','@appointment/views/custom_appointment_form_dialog/custom_appointment_form_dialog'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{AttendeeCalendarController}=require("@calendar/views/attendee_calendar/attendee_calendar_controller");const{patch}=require("@web/core/utils/patch");const{usePopover}=require("@web/core/popover/popover_hook");const{rpc}=require("@web/core/network/rpc");const{Tooltip}=require("@web/core/tooltip/tooltip");const{browser}=require("@web/core/browser/browser");const{serializeDateTime}=require("@web/core/l10n/dates");const{useService}=require("@web/core/utils/hooks");const{useRef,useState,useSubEnv,onWillStart}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const{user}=require("@web/core/user");const{CustomAppointmentFormViewDialog}=require("@appointment/views/custom_appointment_form_dialog/custom_appointment_form_dialog");patch(AttendeeCalendarController,{components:{...AttendeeCalendarController.components,Dropdown},});patch(AttendeeCalendarController.prototype,{setup(){super.setup(...arguments);this.popover=usePopover(Tooltip,{position:"bottom"});this.copyLinkRef=useRef("copyLinkRef");this.orm=useService("orm");this.appointmentState=useState({data:{},lastAppointment:false,});useSubEnv({calendarState:useState({mode:"default",}),});onWillStart(async()=>{this.appointmentState.data=await rpc("/appointment/appointment_type/get_staff_user_appointment_types");this.isAppointmentUser=await user.hasGroup("appointment.group_appointment_user");});},async _createCustomAppointmentType(){const customAppointment=await rpc("/appointment/appointment_type/create_custom",{slots:this._getSlots(),context:this.props.context,},);if(customAppointment.appointment_type_id){this.appointmentState.lastAppointment={'id':customAppointment.appointment_type_id,'isCustom':true,'url':customAppointment.invite_url,'viewId':customAppointment.view_id,}}},hasSlotEvents(){return Object.keys(this.model.data.slots).length;},_getSlots(){return Object.values(this.model.data.slots).map(slot=>({start:serializeDateTime(slot.start),end:serializeDateTime(slot.start===slot.end?slot.end.plus({days:1}):slot.end),allday:slot.isAllDay,}));},async _updateCustomAppointmentSlots(){await rpc("/appointment/appointment_type/update_custom",{appointment_type_id:this.appointmentState.lastAppointment.id,slots:this._getSlots(),},);},_writeUrlToClipboard(){if(!this.appointmentState.lastAppointment){return;}
setTimeout(async()=>await navigator.clipboard.writeText(this.appointmentState.lastAppointment.url));},onClickCustomLink(){this.actionService.doAction({type:'ir.actions.act_window',res_model:'appointment.invite',name:_t('Share Link'),views:[[false,'form']],target:'new',context:{...this.props.context,dialog_size:'medium',},})},onClickSelectAvailabilities(){this.env.calendarState.mode="slots-creation";},async onClickGetShareLink(){if(!this.appointmentState.lastAppointment){await this._createCustomAppointmentType();}else if(this.appointmentState.lastAppointment.isCustom&&this.env.calendarState.mode==="slots-creation"){await this._updateCustomAppointmentSlots();}
this._writeUrlToClipboard();if(!this.copyLinkRef.el){return;}
if(this.appointmentState.lastAppointment.isCustom){this.env.calendarState.mode="default";this.model.clearSlots();}
this.appointmentState.lastAppointment.waitingCopyLinkCustomType=false;this.popover.open(this.copyLinkRef.el,{tooltip:_t("Copied!")});browser.setTimeout(this.popover.close,800);},async onClickOpenForm(){if(!this.appointmentState.lastAppointment){await this._createCustomAppointmentType();}else if(this.appointmentState.lastAppointment.isCustom&&this.env.calendarState.mode==="slots-creation"){await this._updateCustomAppointmentSlots();}
if(this.appointmentState.lastAppointment.isCustom){this.appointmentState.lastAppointment.waitingCopyLinkCustomType=this.env.calendarState.mode==="slots-creation";this.displayDialog(CustomAppointmentFormViewDialog,{context:this.props.context,inviteUrl:this.appointmentState.lastAppointment.url,resId:this.appointmentState.lastAppointment.id,resModel:'appointment.type',size:'md',title:_t('Share Availabilities'),viewId:this.appointmentState.lastAppointment.viewId,onLinkCopied:()=>{;this.appointmentState.lastAppointment.waitingCopyLinkCustomType=false;this.env.calendarState.mode="default";this.model.clearSlots();},});}
else{this.actionService.doAction({name:_t('Open Appointment Type Form'),type:'ir.actions.act_window',res_model:'appointment.type',views:[[false,'form']],res_id:this.appointmentState.lastAppointment.id,});}},onClickDiscard(){if(this.env.calendarState.mode==="slots-creation"){this.model.clearSlots();}
this.env.calendarState.mode="default";this.appointmentState.lastAppointment=false;},async onClickSearchCreateAnytimeAppointment(){const anytimeAppointment=await rpc("/appointment/appointment_type/search_create_anytime",{context:this.props.context,});if(anytimeAppointment.appointment_type_id){this.appointmentState.lastAppointment={'id':anytimeAppointment.appointment_type_id,'url':anytimeAppointment.invite_url,}
this._writeUrlToClipboard();}},async onClickGetAppointmentUrl(appointmentTypeId){const appointment=await rpc("/appointment/appointment_type/get_book_url",{appointment_type_id:appointmentTypeId,context:this.props.context,});this.appointmentState.lastAppointment={'id':appointment.appointment_type_id,'url':appointment.invite_url,}
this._writeUrlToClipboard();},});return __exports;});;

/* /appointment/static/src/views/appointment_calendar/appointment_calendar_model.js */
odoo.define('@appointment/views/appointment_calendar/appointment_calendar_model',['@calendar/views/attendee_calendar/attendee_calendar_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{AttendeeCalendarModel}=require("@calendar/views/attendee_calendar/attendee_calendar_model");const{patch}=require("@web/core/utils/patch");patch(AttendeeCalendarModel.prototype,{setup(){super.setup(...arguments);this.data.slots={};this.defaultSlotDurationMinutes=30;this.slotId=1;},buildRawRecord(partialRecord,options){if('default_duration'in this.meta.context){const defaultDuration=this.meta.context.default_duration;if(partialRecord.start&&(!partialRecord.end||!partialRecord.end.isValid)&&!partialRecord.isAllDay){partialRecord.end=partialRecord.start.plus({hours:defaultDuration});}}
return super.buildRawRecord(...arguments);},processPartialSlotRecord(record){if(!record.end||!record.end.isValid){if(record.isAllDay){record.end=record.start;}else{record.end=record.start.plus({minutes:this.defaultSlotDurationMinutes});}}
if(!record.isAllDay){record.title="";if(record.start&&record.end){const datesInterval=luxon.Interval.fromDateTimes(record.start,record.end);this.defaultSlotDurationMinutes=datesInterval.length('minutes');}}else{const isSameDay=record.start.hasSame(record.end,"day");if(!isSameDay&&record.start.hasSame(record.end,"month")){record.title=record.start.toFormat("LLLL d")+"-"+record.end.toFormat("d, y");}else{record.title=isSameDay?record.start.toFormat("DDD"):record.start.toFormat("DDD")+" - "+record.end.toFormat("DDD");}}},createSlot(record){this.processPartialSlotRecord(record);const slotId=this.slotId++;this.data.slots[slotId]={id:slotId,title:record.title,start:record.start,end:record.end,isAllDay:record.isAllDay,};this.notify();return this.data.slots[slotId];},updateSlot(eventRecord){this.processPartialSlotRecord(eventRecord);const slot=this.data.slots[eventRecord.slotId];Object.assign(slot,{title:eventRecord.title,start:eventRecord.start,end:eventRecord.end,isAllDay:eventRecord.isAllDay,});this.notify();},removeSlot(slotId){delete this.data.slots[slotId];this.notify();},clearSlots(){this.data.slots={};this.notify();},});return __exports;});;

/* /appointment/static/src/views/appointment_calendar/common/appointment_calendar_common_renderer.js */
odoo.define('@appointment/views/appointment_calendar/common/appointment_calendar_common_renderer',['@calendar/views/attendee_calendar/common/attendee_calendar_common_renderer','@web/core/utils/patch','@appointment/views/appointment_calendar/hooks'],function(require){'use strict';let __exports={};const{AttendeeCalendarCommonRenderer}=require("@calendar/views/attendee_calendar/common/attendee_calendar_common_renderer");const{patch}=require("@web/core/utils/patch");const{useAppointmentRendererHook}=require("@appointment/views/appointment_calendar/hooks");patch(AttendeeCalendarCommonRenderer.prototype,{setup(){super.setup(...arguments);const fns=useAppointmentRendererHook(()=>[this.fc.el],);Object.assign(this,fns);},get options(){const options=super.options;if(this.getEventTimeFormat){options.eventTimeFormat=this.getEventTimeFormat();}
options.eventAllow=this.onEventAllow;return options;},mapRecordsToEvents(){this.maxResId=Math.max(Object.keys(this.props.model.data.records).map((id)=>Number.parseInt(id)));const res=[...super.mapRecordsToEvents(...arguments),...Object.values(this.props.model.data.slots).map((r)=>this.convertSlotToEvent(r)),];return res;},convertSlotToEvent(record){const result={...this.convertRecordToEvent(record),id:this.maxResId+record.id,slotId:record.id,};result.editable=true;return result;},fcEventToRecord(event){if(!event.extendedProps||!event.extendedProps.slotId){return super.fcEventToRecord(...arguments);}
return{...super.fcEventToRecord({allDay:event.allDay,date:event.date,start:event.start,end:event.end,}),slotId:event.extendedProps.slotId,};},onEventClick(info){if(!this.isSlotCreationMode()){return super.onEventClick(...arguments);}
info.jsEvent.preventDefault();info.jsEvent.stopPropagation();if(info.event.extendedProps.slotId){info.event.remove();this.props.model.removeSlot(info.event.extendedProps.slotId);}},eventClassNames({event}){const classesToAdd=super.eventClassNames(...arguments);if(event.extendedProps.slotId){classesToAdd.push("o_calendar_slot");}
return classesToAdd;},onEventDidMount(info){super.onEventDidMount(...arguments);const{el,event}=info;if(event.extendedProps.slotId){const bg=el.querySelector(".fc-event-main");if(bg){const duration=(event.end-event.start)/3600000;const iconSize=duration<1||event.allDay||this.props.model.scale==="month"?"":"fa-2x";const domParser=new DOMParser();const injectedContentEl=domParser.parseFromString(`
                    <div class="fc-bg position-absolute top-0 end-0 bottom-0 start-0 o_calendar_slot_delete">
                        <button class="close btn d-flex align-items-center justify-content-center w-100 h-100 m-0 border-0 p-0 bg-success bg-opacity-50 o_hidden">
                            <i class='fa fa-trash ${iconSize}'></i>
                        </button>
                    </div>
                `,"text/html").body.firstChild;bg.insertAdjacentElement("afterend",injectedContentEl);}}},isSelectionAllowed(event){let result=super.isSelectionAllowed(...arguments);if(this.isSlotCreationMode()){result=result&&luxon.DateTime.fromJSDate(event.start)>luxon.DateTime.now();}
return result;},async onSelect(info){info.jsEvent.preventDefault();if(!this.isSlotCreationMode()){return super.onSelect(...arguments);}
this.props.model.createSlot(this.fcEventToRecord(info));this.fc.api.unselect();},onDateClick(info){if(info.jsEvent.defaultPrevented){return;}
if(!this.isSlotCreationMode()){return super.onDateClick(...arguments);}
if(this.props.model.scale==="month"){return;}
const date=luxon.DateTime.fromISO(info.dateStr);if(date<luxon.DateTime.now()){return;}
this.props.model.createSlot(this.fcEventToRecord(info));},onEventDrop(info){if(!this.isSlotCreationMode()){return super.onEventDrop(...arguments);}
this.props.model.updateSlot(this.fcEventToRecord(info.event));},onEventResize(info){if(!this.isSlotCreationMode()){return super.onEventResize(...arguments);}
this.props.model.updateSlot(this.fcEventToRecord(info.event));},onEventDragStart(info){if(!this.isSlotCreationMode()){return super.onEventDragStart(...arguments);}},onEventResizeStart(info){if(!this.isSlotCreationMode()){return super.onEventResizeStart(...arguments);}},onEventMouseEnter(info){if(!this.isSlotCreationMode()){return super.onEventMouseEnter(...arguments);}
const buttonEl=info.el.querySelector(".fc-bg > button");buttonEl&&buttonEl.classList.remove("o_hidden");},onEventMouseLeave(info){if(!this.isSlotCreationMode()){return super.onEventMouseLeave(...arguments);}
const buttonEl=info.el.querySelector(".fc-bg > button");buttonEl&&buttonEl.classList.add("o_hidden");},onEventAllow(dropInfo,draggedEvent){if(!this.isSlotCreationMode()){return super.onEventAllow?.(...arguments)||true;}
return draggedEvent.extendedProps.slotId&&luxon.DateTime.fromJSDate(dropInfo.start)>luxon.DateTime.now();},});return __exports;});;

/* /appointment/static/src/views/appointment_calendar/hooks.js */
odoo.define('@appointment/views/appointment_calendar/hooks',['@web/core/l10n/localization','@odoo/owl'],function(require){'use strict';let __exports={};const{localization}=require("@web/core/l10n/localization");const{useComponent,useEffect,useEnv,useState}=require("@odoo/owl");__exports.useAppointmentRendererHook=useAppointmentRendererHook;function useAppointmentRendererHook(getFcElements){const component=useComponent();const env=useEnv();useState(env.calendarState);useEffect((fcEls,calendarMode)=>{if(calendarMode==="slots-creation"){for(const fcEl of fcEls){const daysToDisable=fcEl.querySelectorAll(".fc-day-past:not(.fc-col-header-cell), .fc-day-today:not(.fc-col-header-cell)");fcEl.classList.add('o_calendar_slots_in_creation');for(const el of daysToDisable){el.classList.add("o_calendar_slot_selection");}
const todayColumn=fcEl.querySelectorAll(".fc-day-today:not(.fc-col-header-cell)")[1];const bgColumn=todayColumn?.querySelector(".fc-timegrid-col-bg");const nowIndicator=todayColumn?.querySelector(".fc-timegrid-now-indicator-line");if(bgColumn&&nowIndicator&&['timeGridWeek','timeGridDay'].includes(component.fc.api.view.type)){const height=nowIndicator.style.top.slice(0,-2);const childEl=document.createElement("div");childEl.classList.add("o_calendar_slot_selection_now","position-absolute","start-0","end-0");childEl.style.height=`${height}px`;bgColumn.appendChild(childEl);}}
return()=>{for(const fcEl of fcEls){const daysToDisable=fcEl.querySelectorAll(".fc-day-past:not(.fc-col-header-cell), .fc-day-today:not(.fc-col-header-cell)");fcEl.classList.remove('o_calendar_slots_in_creation');for(const el of daysToDisable){el.classList.remove("o_calendar_slot_selection");}
const todayColumn=fcEl.querySelectorAll(".fc-day-today:not(.fc-col-header-cell)")[1];if(todayColumn){const childEl=todayColumn.querySelector(".o_calendar_slot_selection_now");childEl&&childEl.remove();}}};}},()=>[getFcElements(),env.calendarState.mode],);return{isSlotCreationMode(){return env.calendarState.mode==="slots-creation";},getEventTimeFormat(){const format12Hour={hour:'numeric',minute:'2-digit',omitZeroMinute:true,meridiem:'short'};const format24Hour={hour:'numeric',minute:'2-digit',hour12:false,};return localization.timeFormat.search("HH")===0?format24Hour:format12Hour;},}}
return __exports;});;

/* /appointment/static/src/views/appointment_calendar/year/appointment_calendar_year_renderer.js */
odoo.define('@appointment/views/appointment_calendar/year/appointment_calendar_year_renderer',['@calendar/views/attendee_calendar/year/attendee_calendar_year_renderer','@web/core/utils/patch','@appointment/views/appointment_calendar/hooks'],function(require){'use strict';let __exports={};const{AttendeeCalendarYearRenderer}=require("@calendar/views/attendee_calendar/year/attendee_calendar_year_renderer");const{patch}=require("@web/core/utils/patch");const{useAppointmentRendererHook}=require("@appointment/views/appointment_calendar/hooks");patch(AttendeeCalendarYearRenderer.prototype,{setup(){super.setup(...arguments);const fns=useAppointmentRendererHook(()=>Object.values(this.fcs).map((fc)=>fc.el));Object.assign(this,fns);},get options(){const options=super.options;if(this.getEventTimeFormat){options.eventTimeFormat=this.getEventTimeFormat();}
options.eventAllow=this.onEventAllow;options.selectAllow=this.isSelectionAllowed;return options;},mapRecordsToEvents(){this.maxResId=Math.max(Object.keys(this.props.model.data.records).map((id)=>Number.parseInt(id)));const res=[...super.mapRecordsToEvents(...arguments),...Object.values(this.props.model.data.slots).map((r)=>this.convertSlotToEvent(r)),];return res;},convertSlotToEvent(record){const result={...this.convertRecordToEvent(record),id:this.maxResId+record.id,slotId:record.id,};result.editable=true;return result;},fcEventToRecord(event){if(!event.extendedProps||!event.extendedProps.slotId){return super.fcEventToRecord(...arguments);}
return{...super.fcEventToRecord({allDay:event.allDay,date:event.date,start:event.start,end:event.end,}),slotId:event.extendedProps.slotId,};},eventClassNames({event}){const classesToAdd=super.eventClassNames(...arguments);if(event.extendedProps.slotId){classesToAdd.push("o_calendar_slot");}
return classesToAdd;},onEventDidMount(info){super.onEventDidMount(...arguments);const{el,event}=info;if(event.extendedProps.slotId){const bg=el.querySelector(".fc-bg");if(bg){const duration=(event.end-event.start)/3600000;const iconSize=duration<1||event.allDay||this.props.model.scale==="month"?"":"h1";const domParser=new DOMParser();const injectedContentEl=domParser.parseFromString(`
                    <button class="close btn d-flex align-items-center justify-content-center w-100 h-100 m-0 border-0 p-0 bg-success bg-opacity-50 o_hidden">
                        <i class='fa fa-trash ${iconSize}'></i>
                    </button>
                `,"text/html").body.firstChild;bg.appendChild(injectedContentEl);}}},findMatchingSlot(start,end=undefined){let predicate;if(end){predicate=(slot)=>(slot.start.equals(start)&&slot.end.equals(end));}else{predicate=(slot)=>(slot.start.equals(start));}
return Object.values(this.props.model.data.slots).find(predicate);},async onSelect(info){if(!this.isSlotCreationMode()){return super.onSelect(...arguments);}
const start=luxon.DateTime.fromISO(info.startStr);const end=luxon.DateTime.fromISO(info.endStr).minus({days:1});if(start===end){this.unselect();return;}
const existingSlot=this.findMatchingSlot(start,end);if(existingSlot){this.props.model.removeSlot(existingSlot.id);}else{this.props.model.createSlot({start,end,isAllDay:true,});}
this.unselect();},onDateClick(info){if(!this.isSlotCreationMode()){return super.onDateClick(...arguments);}
if(this.props.model.scale==="month"){return;}
const date=luxon.DateTime.fromISO(info.dateStr);if(date<luxon.DateTime.now()){return;}
const existingSlot=this.findMatchingSlot(date);if(existingSlot){this.props.model.removeSlot(existingSlot.id);}else{this.props.model.createSlot({start:luxon.DateTime.fromISO(info.dateStr),isAllDay:true,});}},isSelectionAllowed(event){if(!this.isSlotCreationMode){return super.isSelectionAllowed?.(...arguments)||true;}
return luxon.DateTime.fromJSDate(event.start)>luxon.DateTime.now();},onEventAllow(dropInfo,draggedEvent){if(!this.isSlotCreationMode()){return super.onEventAllow?.(...arguments)||true;}
return draggedEvent.extendedProps.slotId&&luxon.DateTime.fromJSDate(dropInfo.start)>luxon.DateTime.now();},});return __exports;});;

/* /appointment/static/src/views/appointment_invite/appointment_share_link_list_controller.js */
odoo.define('@appointment/views/appointment_invite/appointment_share_link_list_controller',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/views/list/list_controller','@web/views/list/list_view','@web/views/view_dialogs/form_view_dialog'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{ListController}=require("@web/views/list/list_controller");const{listView}=require("@web/views/list/list_view");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");class AppointmentShareLinkListController extends ListController{setup(){super.setup();this.dialog=useService("dialog");}
async onClickCreate(){this.dialog.add(FormViewDialog,{resModel:"appointment.invite",size:"md",title:_t("Create a Share Link"),});}
async openRecord(record){this.dialog.add(FormViewDialog,{resId:record.resId,resModel:"appointment.invite",size:"md",title:_t("Update a Share Link"),});}}
registry.category("views").add("appointment_share_link_list",{...listView,Controller:AppointmentShareLinkListController,});return __exports;});;

/* /appointment/static/src/views/custom_appointment_form_dialog/custom_appointment_form_dialog.js */
odoo.define('@appointment/views/custom_appointment_form_dialog/custom_appointment_form_dialog',['@web/core/l10n/translation','@web/views/form/form_controller','@web/views/form/form_view','@web/views/view_dialogs/form_view_dialog','@web/core/utils/hooks','@web/core/registry'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{FormController}=require('@web/views/form/form_controller');const{formView}=require('@web/views/form/form_view');const{FormViewDialog}=require('@web/views/view_dialogs/form_view_dialog');const{useService}=require("@web/core/utils/hooks");const{registry}=require('@web/core/registry');const CustomAppointmentFormController=__exports.CustomAppointmentFormController=class CustomAppointmentFormController extends FormController{static props={...FormController.props,inviteUrl:String,onLinkCopied:Function,};setup(){super.setup(...arguments);this.actionService=useService("action");}
async onClickMoreOptions(){if(await super.saveButtonClicked()){this.actionService.doAction({name:_t('Open Appointment Type Form'),type:'ir.actions.act_window',res_model:'appointment.type',views:[[false,'form']],res_id:this.model.root.resId,});}}
async onClickSaveAndCopy(){if(await super.saveButtonClicked()){setTimeout(async()=>await navigator.clipboard.writeText(this.props.inviteUrl));this.props.onLinkCopied();}}}
const CustomAppointmentFormViewDialog=__exports.CustomAppointmentFormViewDialog=class CustomAppointmentFormViewDialog extends FormViewDialog{static props={...CustomAppointmentFormViewDialog.props,inviteUrl:String,onLinkCopied:Function,};setup(){super.setup();Object.assign(this.viewProps,{buttonTemplate:'appointment.FormViewDialog.buttons',inviteUrl:this.props.inviteUrl,onLinkCopied:this.props.onLinkCopied.bind(this),jsClass:"appointment_type_view_form_custom_share",});}}
registry.category('views').add('appointment_type_view_form_custom_share',{...formView,Controller:CustomAppointmentFormController,});return __exports;});;

/* /appointment/static/src/views/kanban/kanban_controller.js */
odoo.define('@appointment/views/kanban/kanban_controller',['@web/views/kanban/kanban_controller','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{KanbanController}=require("@web/views/kanban/kanban_controller");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const AppointmentTypeKanbanController=__exports.AppointmentTypeKanbanController=class AppointmentTypeKanbanController extends KanbanController{setup(){super.setup();this.actionService=useService('action');}
onClickShareAppointmentLink(){this.actionService.doAction({type:'ir.actions.act_window',res_model:'appointment.invite',name:_t('Share Appointment'),views:[[false,'form']],target:'new',context:{dialog_size:'medium'},});}}
return __exports;});;

/* /appointment/static/src/views/kanban/kanban_record.js */
odoo.define('@appointment/views/kanban/kanban_record',['@web/views/kanban/kanban_record'],function(require){'use strict';let __exports={};const{KanbanRecord}=require("@web/views/kanban/kanban_record");const AppointmentTypeKanbanRecord=__exports.AppointmentTypeKanbanRecord=class AppointmentTypeKanbanRecord extends KanbanRecord{static menuTemplate="appointment.AppointmentTypeKanbanRecordMenu";}
return __exports;});;

/* /appointment/static/src/views/kanban/kanban_renderer.js */
odoo.define('@appointment/views/kanban/kanban_renderer',['@web/views/kanban/kanban_renderer','@appointment/components/appointment_type_action_helper/appointment_type_action_helper','@appointment/views/kanban/kanban_record'],function(require){'use strict';let __exports={};const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{AppointmentTypeActionHelper}=require("@appointment/components/appointment_type_action_helper/appointment_type_action_helper");const{AppointmentTypeKanbanRecord}=require("@appointment/views/kanban/kanban_record");const AppointmentTypeKanbanRenderer=__exports.AppointmentTypeKanbanRenderer=class AppointmentTypeKanbanRenderer extends KanbanRenderer{static template="appointment.AppointmentTypeKanbanRenderer";static components={...KanbanRenderer.components,KanbanRecord:AppointmentTypeKanbanRecord,AppointmentTypeActionHelper,};}
return __exports;});;

/* /appointment/static/src/views/kanban/kanban_view.js */
odoo.define('@appointment/views/kanban/kanban_view',['@web/core/registry','@web/views/kanban/kanban_view','@appointment/views/kanban/kanban_renderer','@appointment/views/kanban/kanban_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{kanbanView}=require("@web/views/kanban/kanban_view");const{AppointmentTypeKanbanRenderer}=require("@appointment/views/kanban/kanban_renderer");const{AppointmentTypeKanbanController}=require("@appointment/views/kanban/kanban_controller");const AppointmentTypeKanbanView=__exports.AppointmentTypeKanbanView={...kanbanView,Renderer:AppointmentTypeKanbanRenderer,Controller:AppointmentTypeKanbanController,buttonTemplate:'AppointmentTypeKanbanView.buttons',};registry.category("views").add("appointment_type_kanban",AppointmentTypeKanbanView);return __exports;});;

/* /appointment/static/src/views/list/list_renderer.js */
odoo.define('@appointment/views/list/list_renderer',['@web/core/l10n/translation','@appointment/components/appointment_type_action_helper/appointment_type_action_helper','@web/views/list/list_renderer','@web/core/user','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{AppointmentTypeActionHelper}=require("@appointment/components/appointment_type_action_helper/appointment_type_action_helper");const{ListRenderer}=require("@web/views/list/list_renderer");const{user}=require("@web/core/user");const{onWillStart}=require("@odoo/owl");const AppointmentBookingListRenderer=__exports.AppointmentBookingListRenderer=class AppointmentBookingListRenderer extends ListRenderer{static template="appointment.AppointmentBookingListRenderer";setup(){super.setup();onWillStart(async()=>{this.isAppointmentManager=await user.hasGroup("appointment.group_appointment_manager");});}
async onClickAddLeave(){this.env.services.action.doAction({name:_t("Add Closing Day(s)"),type:"ir.actions.act_window",res_model:"appointment.manage.leaves",view_mode:"form",views:[[false,"form"]],target:"new",context:{},});}}
const AppointmentTypeListRenderer=__exports.AppointmentTypeListRenderer=class AppointmentTypeListRenderer extends ListRenderer{static template="appointment.AppointmentTypeListRenderer";static components={...ListRenderer.components,AppointmentTypeActionHelper,};}
return __exports;});;

/* /appointment/static/src/views/list/list_view.js */
odoo.define('@appointment/views/list/list_view',['@web/core/registry','@web/views/list/list_view','@appointment/views/list/list_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{AppointmentBookingListRenderer,AppointmentTypeListRenderer}=require("@appointment/views/list/list_renderer");const AppointmentBookingListView=__exports.AppointmentBookingListView={...listView,Renderer:AppointmentBookingListRenderer,};registry.category("views").add("appointment_booking_list",AppointmentBookingListView);const AppointmentTypeListView=__exports.AppointmentTypeListView={...listView,Renderer:AppointmentTypeListRenderer,};registry.category("views").add("appointment_type_list",AppointmentTypeListView);return __exports;});;

/* /appointment/static/src/components/appointment_invite/appointment_invite_copy_close.js */
odoo.define('@appointment/components/appointment_invite/appointment_invite_copy_close',['@web/core/l10n/translation','@web/core/browser/browser','@web/core/registry','@web/views/widgets/standard_widget_props','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{registry}=require('@web/core/registry');const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const AppointmentInviteCopyClose=__exports.AppointmentInviteCopyClose=class AppointmentInviteCopyClose extends Component{static props={...standardWidgetProps,};static template="appointment.AppointmentInviteCopyClose";setup(){this.notification=useService("notification");this.action=useService("action");}
async onSaveAndCopy(ev){if(this.props.readonly){return;}
if(await this.props.record.save()){const bookUrl=this.props.record.data.book_url;setTimeout(async()=>{await browser.navigator.clipboard.writeText(bookUrl);this.notification.add(_t("Link copied to clipboard!"),{type:"success"});this.env.dialogData.close();if(this.action.currentController?.props?.resModel==="appointment.invite"){this.action.loadState();}});}}}
const appointmentInviteCopyClose=__exports.appointmentInviteCopyClose={component:AppointmentInviteCopyClose,fieldDependencies:[{name:"disable_save_button",type:"boolean"},],};registry.category("view_widgets").add("appointment_invite_copy_close",appointmentInviteCopyClose);return __exports;});;

/* /appointment/static/src/components/appointment_sync_button/appointment_sync_button.js */
odoo.define('@appointment/components/appointment_sync_button/appointment_sync_button',['@web/core/l10n/translation','@web/core/registry','@web/views/widgets/standard_widget_props','@web/core/utils/hooks','@odoo/owl','@web/core/network/rpc'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require('@web/core/registry');const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const{rpc}=require("@web/core/network/rpc");const AppointmentSyncButton=__exports.AppointmentSyncButton=class AppointmentSyncButton extends Component{static props={...standardWidgetProps,calendarName:String,iconSrc:String,};static template="appointment.AppointmentSyncButton";setup(){this.notification=useService("notification");this.pendingSync=false;}
async onConnectCalendar(){if(!this.pendingSync){const calendarData=this._getCalendarSyncData(this.props.calendarName);if(!calendarData){return;}
this.pendingSync=true;const syncResult=await rpc(calendarData.syncRoute,{model:'calendar.event',fromurl:window.location.href,},);if(syncResult.status==="need_auth"){window.open(syncResult.url,"_blank");}else if(syncResult.status===calendarData.noNewEventKey||syncResult.status==="need_refresh"){this.notification.add(_t("Your calendar is already configured and was successfully synchronized."),{type:"success"},);}else{this.notification.add(_t("The configuration has changed and synchronization is not possible anymore. Please reload the page."),{type:"warning"},);}
this.pendingSync=false;}}
_getCalendarSyncData(calendarName){return false;}}
const appointmentSyncButton=__exports.appointmentSyncButton={component:AppointmentSyncButton,extractProps:({attrs})=>({calendarName:attrs.calendarName,iconSrc:attrs.iconSrc,}),};registry.category("view_widgets").add("appointment_sync_button",appointmentSyncButton);return __exports;});;

/* /appointment/static/src/components/appointment_type_action_helper/appointment_type_action_helper.js */
odoo.define('@appointment/components/appointment_type_action_helper/appointment_type_action_helper',['@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require('@web/core/utils/hooks');const{Component,onWillStart}=require('@odoo/owl');const AppointmentTypeActionHelper=__exports.AppointmentTypeActionHelper=class AppointmentTypeActionHelper extends Component{static template='appointment.AppointmentTypeActionHelper';static props={};setup(){this.orm=useService('orm');this.action=useService('action');onWillStart(async()=>{this.appointmentTypeTemplateData=await this.orm.call('appointment.type','get_appointment_type_templates_data',[]);});}
async onTemplateClick(templateInfo){const action=await this.orm.call('appointment.type','action_setup_appointment_type_template',[templateInfo.template_key],);this.action.doAction(action);}};return __exports;});;

/* /appointment/static/src/components/appointment_type_sync_duration/appointment_type_sync_duration.js */
odoo.define('@appointment/components/appointment_type_sync_duration/appointment_type_sync_duration',['@odoo/owl','@web/views/fields/many2one/many2one_field','@web/core/registry','@web/model/relational_model/utils'],function(require){'use strict';let __exports={};const{onWillStart}=require("@odoo/owl");const{Many2OneField,many2OneField}=require("@web/views/fields/many2one/many2one_field");const{registry}=require("@web/core/registry");const{useRecordObserver}=require("@web/model/relational_model/utils");const AppointmentTypeSyncDuration=__exports.AppointmentTypeSyncDuration=class AppointmentTypeSyncDuration extends Many2OneField{setup(){super.setup();this.appointmentTypeId=this.props.record.data.appointment_type_id[0];this.isDefaultDuration=false;onWillStart(async()=>{if(this.appointmentTypeId){const appointmentDuration=await this.orm.read("appointment.type",[this.appointmentTypeId],['appointment_duration']);this.isDefaultDuration=this.props.record.data.duration===appointmentDuration?.[0].appointment_duration;}});useRecordObserver(async(record)=>{if(record.data.appointment_type_id[0]!==this.appointmentTypeId&&this.isDefaultDuration){this.appointmentTypeId=record.data.appointment_type_id[0];if(this.appointmentTypeId){const appointmentDuration=await this.orm.read("appointment.type",[this.appointmentTypeId],['appointment_duration']);if(appointmentDuration.length!==0){record.update({'duration':appointmentDuration[0].appointment_duration});}}}});}}
registry.category("fields").add("appointment_type_sync_duration",{...many2OneField,component:AppointmentTypeSyncDuration,});return __exports;});;

/* /appointment/static/src/js/appointment_insert_link_form_controller.js */
odoo.define('@appointment/js/appointment_insert_link_form_controller',['@web/core/registry','@web/views/form/form_view','@web/views/form/form_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");const{FormController}=require("@web/views/form/form_controller");class AppointmentInsertLinkFormController extends FormController{static props={...FormController.props,insertLink:{type:Function},closeDialog:{type:Function},};async beforeExecuteActionButton(clickParams){if(clickParams.special){if(clickParams.special==="save"){const saved=await this.model.root.save();if(saved){this.props.insertLink(this.model.root.data.book_url);}else{return false;}}
this.props.closeDialog();return false;}
return super.beforeExecuteActionButton(...arguments);}}
registry.category("views").add("appointment_insert_link_form",{...formView,Controller:AppointmentInsertLinkFormController,});return __exports;});;

/* /appointment/static/src/appointment_plugin.js */
odoo.define('@appointment/appointment_plugin',['@web/core/l10n/translation','@html_editor/plugin','@html_editor/plugin_sets','@web/views/view_dialogs/form_view_dialog'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Plugin}=require("@html_editor/plugin");const{MAIN_PLUGINS}=require("@html_editor/plugin_sets");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");class AppointmentFormViewDialog extends FormViewDialog{static props={...FormViewDialog.props,insertLink:{type:Function},};setup(){super.setup();this.viewProps.insertLink=this.props.insertLink;this.viewProps.closeDialog=this.props.close;}}
class AppointmentPlugin extends Plugin{static id="appointment";static dependencies=["selection","link","dialog"];resources={user_commands:[{id:"insertAppointment",title:_t("Appointment"),description:_t("Add a specific appointment"),icon:"fa-calendar",run:this.addAppointment.bind(this),},],powerbox_items:[{categoryId:"navigation",commandId:"insertAppointment",},],};addAppointment(){this.dependencies.dialog.addDialog(AppointmentFormViewDialog,{resModel:"appointment.invite",context:{form_view_ref:"appointment.appointment_invite_view_form_insert_link",default_appointment_type_ids:[],default_staff_user_ids:[],},size:"md",title:_t("Insert Appointment Link"),mode:"edit",insertLink:(url)=>this.dependencies.link.insertLink(url,_t("Schedule an Appointment")),});}}
MAIN_PLUGINS.push(AppointmentPlugin);return __exports;});;

/* /survey/static/src/question_page/description_page_field.js */
odoo.define('@survey/question_page/description_page_field',['@web/views/fields/char/char_field','@web/core/registry','@odoo/owl'],function(require){'use strict';let __exports={};const{CharField,charField}=require("@web/views/fields/char/char_field");const{registry}=require("@web/core/registry");const{useEffect,useRef}=require("@odoo/owl");class DescriptionPageField extends CharField{static template="survey.DescriptionPageField";setup(){super.setup();const inputRef=useRef("input");useEffect((input)=>{if(input){input.classList.add("col");}},()=>[inputRef.el]);}
onExternalBtnClick(){this.env.openRecord(this.props.record);}}
registry.category("fields").add("survey_description_page",{...charField,component:DescriptionPageField,});return __exports;});;

/* /survey/static/src/question_page/question_page_list_renderer.js */
odoo.define('@survey/question_page/question_page_list_renderer',['@web/core/context','@web/views/list/list_renderer','@odoo/owl'],function(require){'use strict';let __exports={};const{makeContext}=require("@web/core/context");const{ListRenderer}=require("@web/views/list/list_renderer");const{useEffect}=require("@odoo/owl");const QuestionPageListRenderer=__exports.QuestionPageListRenderer=class QuestionPageListRenderer extends ListRenderer{setup(){super.setup();this.discriminant="is_page";this.fieldsToShow=["random_questions_count"];this.titleField="title";useEffect((table)=>{if(table){table.classList.add("o_section_list_view");}},()=>[this.tableRef.el]);}
add(params){let editable=false;if(params.context&&!this.env.isSmall){const evaluatedContext=makeContext([params.context]);if(evaluatedContext[`default_${this.discriminant}`]){editable=this.props.editable;}}
super.add({...params,editable});}
getColumns(record){const columns=super.getColumns(record);if(this.isSection(record)){return this.getSectionColumns(columns);}
return columns;}
getRowClass(record){const classNames=super.getRowClass(record).split(" ");if(this.isSection(record)){classNames.push(`o_is_section`,`fw-bold`);}
return classNames.join(" ");}
getCellClass(column,record){const classNames=super.getCellClass(column,record);if(column.type==="button_group"){return`${classNames} text-end`;}
return classNames;}
getSectionColumns(columns){let titleColumnIndex=0;let found=false;let colspan=1;for(let index=0;index<columns.length;index++){const col=columns[index];if(!found&&col.name!==this.titleField){continue;}
if(!found){found=true;titleColumnIndex=index;continue;}
if(col.type!=="field"||this.fieldsToShow.includes(col.name)){break;}
colspan+=1;}
const sectionColumns=columns.slice(0,titleColumnIndex+1).concat(columns.slice(titleColumnIndex+colspan));sectionColumns[titleColumnIndex]={...sectionColumns[titleColumnIndex],colspan};return sectionColumns;}
isInlineEditable(record){return this.isSection(record)&&this.props.editable;}
isSection(record){return record.data[this.discriminant];}
focusCell(column,forward=true){const actualColumn=column.name?this.columns.find((col)=>col.name===column.name):column;super.focusCell(actualColumn,forward);}
onCellKeydownEditMode(hotkey){switch(hotkey){case"enter":case"tab":case"shift+tab":{this.props.list.leaveEditMode();return true;}}
return super.onCellKeydownEditMode(...arguments);}
async onDeleteRecord(record){const triggeredRecords=this.props.list.records.filter((rec)=>rec.data.triggering_question_ids.records.map(a=>a.resId).includes(record.resId));if(triggeredRecords.length){const res=await super.onDeleteRecord(record);await this.props.list.model.root.save();return res;}else{return super.onDeleteRecord(record);}}}
return __exports;});;

/* /survey/static/src/question_page/question_page_one2many_field.js */
odoo.define('@survey/question_page/question_page_one2many_field',['@web/core/l10n/translation','@survey/question_page/question_page_list_renderer','@web/core/registry','@web/views/fields/relational_utils','@web/views/fields/x2many/x2many_field','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{QuestionPageListRenderer}=require("@survey/question_page/question_page_list_renderer");const{registry}=require("@web/core/registry");const{useOpenX2ManyRecord,useX2ManyCrud}=require("@web/views/fields/relational_utils");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const{useSubEnv}=require("@odoo/owl");class SurveySaveError extends Error{}
function SurveySaveErrorHandler(env,error,originalError){if(originalError instanceof SurveySaveError){env.services.notification.add(originalError.message,{title:_t("Validation Error"),type:"danger",});return true;}}
registry.category("error_handlers").add("surveySaveErrorHandler",SurveySaveErrorHandler,{sequence:10});class QuestionPageOneToManyField extends X2ManyField{static components={...X2ManyField.components,ListRenderer:QuestionPageListRenderer,};static defaultProps={...X2ManyField.defaultProps,editable:"bottom",};setup(){super.setup();useSubEnv({openRecord:(record)=>this.openRecord(record),});const{saveRecord:superSaveRecord,updateRecord:superUpdateRecord}=useX2ManyCrud(()=>this.list,this.isMany2Many);const self=this;const saveRecord=async(record)=>{await superSaveRecord(record);try{await self.props.record.save();}catch(error){await this.list.delete(record);throw new SurveySaveError(error.data.message);}};const updateRecord=async(record)=>{await superUpdateRecord(record);try{await self.props.record.save();}catch(error){throw new SurveySaveError(error.data.message);}};const openRecord=useOpenX2ManyRecord({resModel:this.list.resModel,activeField:this.activeField,activeActions:this.activeActions,getList:()=>this.list,saveRecord,updateRecord,});this._openRecord=async(params)=>{const{record,name}=this.props;if(!await record.save()){return;}
if(params.record){params.record=record.data[name].records.find(r=>r.resId===params.record.resId);}
await openRecord(params);};this.canOpenRecord=true;}}
const questionPageOneToManyField=__exports.questionPageOneToManyField={...x2ManyField,component:QuestionPageOneToManyField,additionalClasses:[...x2ManyField.additionalClasses||[],"o_field_one2many"],};registry.category("fields").add("question_page_one2many",questionPageOneToManyField);return __exports;});;

/* /survey/static/src/views/survey_views.js */
odoo.define('@survey/views/survey_views',['@web/core/registry','@web/views/list/list_renderer','@web/views/kanban/kanban_renderer','@web/views/list/list_view','@web/views/kanban/kanban_view','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require('@web/core/registry');const{ListRenderer}=require("@web/views/list/list_renderer");const{KanbanRenderer}=require("@web/views/kanban/kanban_renderer");const{listView}=require('@web/views/list/list_view');const{kanbanView}=require('@web/views/kanban/kanban_view');const{useService}=require("@web/core/utils/hooks");const{useEffect,useRef}=require("@odoo/owl");__exports.useSurveyLoadSampleHook=useSurveyLoadSampleHook;function useSurveyLoadSampleHook(selector){const rootRef=useRef("root");const actionService=useService("action");const orm=useService('orm');let isLoadingSample=false;const loadSample=async(method)=>{isLoadingSample=true;const action=await orm.call('survey.survey',method);actionService.doAction(action);};useEffect((elems)=>{if(!elems||!elems.length){return;}
const handler=(ev)=>{if(!isLoadingSample){const surveyMethod=ev.currentTarget.closest('.o_survey_sample_container').getAttribute('action');loadSample(surveyMethod);}}
for(const elem of elems){elem.addEventListener('click',handler);}
return()=>{for(const elem of elems){elem.removeEventListener('click',handler);}};},()=>[rootRef.el&&rootRef.el.querySelectorAll(selector)]);};const SurveyListRenderer=__exports.SurveyListRenderer=class SurveyListRenderer extends ListRenderer{setup(){super.setup();if(this.canCreate){useSurveyLoadSampleHook('.o_survey_load_sample');}}};registry.category('views').add('survey_view_tree',{...listView,Renderer:SurveyListRenderer,});const SurveyKanbanRenderer=__exports.SurveyKanbanRenderer=class SurveyKanbanRenderer extends KanbanRenderer{setup(){super.setup();this.canCreate=this.props.archInfo.activeActions.create;if(this.canCreate){useSurveyLoadSampleHook('.o_survey_load_sample');}}};registry.category('views').add('survey_view_kanban',{...kanbanView,Renderer:SurveyKanbanRenderer,});return __exports;});;

/* /survey/static/src/views/widgets/boolean_update_flag_field/boolean_update_flag_fields.js */
odoo.define('@survey/views/widgets/boolean_update_flag_field/boolean_update_flag_fields',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/boolean/boolean_field'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{booleanField,BooleanField}=require("@web/views/fields/boolean/boolean_field");const BooleanUpdateFlagField=__exports.BooleanUpdateFlagField=class BooleanUpdateFlagField extends BooleanField{static props={...BooleanField.props,flagFieldName:{type:String},referenceValue:{type:Boolean},}
async onChange(newValue){super.onChange(...arguments);await this.props.record._update({[this.props.flagFieldName]:newValue!==this.props.referenceValue});}}
const booleanUpdateFlagField=__exports.booleanUpdateFlagField={...booleanField,component:BooleanUpdateFlagField,displayName:_t("Checkbox updating comparison flag"),extractProps({options},{context:{referenceValue}}){return{flagFieldName:options.flagFieldName,referenceValue:referenceValue,}}};registry.category("fields").add("boolean_update_flag",booleanUpdateFlagField);return __exports;});;

/* /survey/static/src/views/widgets/integer_update_flag_field/integer_update_flag_fields.js */
odoo.define('@survey/views/widgets/integer_update_flag_field/integer_update_flag_fields',['@web/core/l10n/translation','@web/core/registry','@web/views/fields/integer/integer_field','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{integerField,IntegerField}=require("@web/views/fields/integer/integer_field");const{useEffect,useRef}=require("@odoo/owl");const IntegerUpdateFlagField=__exports.IntegerUpdateFlagField=class IntegerUpdateFlagField extends IntegerField{static props={...IntegerField.props,flagFieldName:{type:String},referenceValue:{type:Number},}
setup(){super.setup(...arguments);const inputRef=useRef("numpadDecimal");const onChange=async()=>{await this.props.record._update({[this.props.flagFieldName]:parseInt(this.formattedValue)!==this.props.referenceValue});}
useEffect((inputEl)=>{if(inputEl){inputEl.addEventListener("change",onChange);return()=>{inputEl.removeEventListener("change",onChange);};}},()=>[inputRef.el]);}}
const integerUpdateFlagField=__exports.integerUpdateFlagField={...integerField,component:IntegerUpdateFlagField,displayName:_t("Integer updating comparison flag"),extractProps({attrs,options},{context:{referenceValue}}){return{...integerField.extractProps(...arguments),flagFieldName:options.flagFieldName,referenceValue:referenceValue,}}};registry.category("fields").add("integer_update_flag",integerUpdateFlagField)
return __exports;});;

/* /survey/static/src/views/widgets/radio_selection_with_filter/radio_selection_field_with_filter.js */
odoo.define('@survey/views/widgets/radio_selection_with_filter/radio_selection_field_with_filter',['@web/views/fields/radio/radio_field','@web/core/l10n/translation','@web/core/registry'],function(require){'use strict';let __exports={};const{RadioField,radioField}=require("@web/views/fields/radio/radio_field");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const RadioSelectionFieldWithFilter=__exports.RadioSelectionFieldWithFilter=class RadioSelectionFieldWithFilter extends RadioField{static props={...RadioField.props,allowed_selection:{type:Array},};get items(){return super.items.filter(([value,label])=>{return this.props.allowed_selection.includes(value);});}}
const radioSelectionFieldWithFilter=__exports.radioSelectionFieldWithFilter={...radioField,component:RadioSelectionFieldWithFilter,displayName:_t("Radio for Selection With Filter"),supportedTypes:["selection"],extractProps({options},{context:{allowed_selection}}){return{...radioField.extractProps(...arguments),allowed_selection:allowed_selection,};},};registry.category("fields").add("radio_selection_with_filter",radioSelectionFieldWithFilter);return __exports;});;

/* /survey/static/src/views/widgets/survey_question_trigger/survey_question_trigger.js */
odoo.define('@survey/views/widgets/survey_question_trigger/survey_question_trigger',['@web/core/l10n/translation','@web/core/registry','@web/views/widgets/standard_widget_props','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{Component,useEffect,useRef,useState}=require("@odoo/owl");const SurveyQuestionTriggerWidget=__exports.SurveyQuestionTriggerWidget=class SurveyQuestionTriggerWidget extends Component{static template="survey.surveyQuestionTrigger";static props={...standardWidgetProps,};setup(){super.setup();this.button=useRef('survey_question_trigger');this.state=useState({surveyIconWarning:false,triggerTooltip:"",});useEffect(()=>{if(this.button?.el&&this.props.record.data.triggering_question_ids.records?.length!==0){const{triggerError,misplacedTriggerQuestionRecords}=this.surveyQuestionTriggerError;if(triggerError==="MISPLACED_TRIGGER_WARNING"){this.state.surveyIconWarning=true;this.state.triggerTooltip='⚠ '+_t('Triggers based on the following questions will not work because they are positioned after this question:\n"%s".',misplacedTriggerQuestionRecords.map((question)=>question.data.title).join('", "'));}else if(triggerError==="WRONG_QUESTIONS_SELECTION_WARNING"){this.state.surveyIconWarning=true;this.state.triggerTooltip='⚠ '+_t("Conditional display is not available when questions are randomly picked.");}else if(triggerError==="MISSING_TRIGGER_ERROR"){}else{this.state.surveyIconWarning=false;this.state.triggerTooltip=_t('Displayed if "%s".',this.props.record.data.triggering_answer_ids.records.map((answer)=>answer.data.display_name).join('", "'),);}}else{this.state.surveyIconWarning=false;this.state.triggerTooltip="";}});}
get surveyQuestionTriggerError(){const record=this.props.record;if(!record.data.triggering_question_ids.records.length){return{triggerError:"",misplacedTriggerQuestionRecords:[]};}
if(this.props.record.data.questions_selection==='random'){return{triggerError:'WRONG_QUESTIONS_SELECTION_WARNING',misplacedTriggerQuestionRecords:[]};}
const missingTriggerQuestionsIds=[];let triggerQuestionsRecords=[];for(const triggeringQuestion of record.data.triggering_question_ids.records){const triggeringQuestionRecord=record.model.root.data.question_and_page_ids.records.find(rec=>rec.resId===triggeringQuestion.resId);if(triggeringQuestionRecord){triggerQuestionsRecords.push(triggeringQuestionRecord);}else{missingTriggerQuestionsIds.push(triggeringQuestion.resId);}}
if(missingTriggerQuestionsIds.length===this.props.record.data.triggering_question_ids.records.length){return{triggerError:'MISSING_TRIGGER_ERROR',misplacedTriggerQuestionRecords:[]};}
const misplacedTriggerQuestionRecords=[];for(const triggerQuestionRecord of triggerQuestionsRecords){if(record.data.sequence<triggerQuestionRecord.data.sequence||(record.data.sequence===triggerQuestionRecord.data.sequence&&record.resId<triggerQuestionRecord.resId)){misplacedTriggerQuestionRecords.push(triggerQuestionRecord);}}
return{triggerError:misplacedTriggerQuestionRecords.length?"MISPLACED_TRIGGER_WARNING":"",misplacedTriggerQuestionRecords:misplacedTriggerQuestionRecords,};}}
const surveyQuestionTriggerWidget=__exports.surveyQuestionTriggerWidget={component:SurveyQuestionTriggerWidget,fieldDependencies:[{name:"triggering_question_ids",type:"many2one"},{name:"triggering_answer_ids",type:"many2one"},],};registry.category("view_widgets").add("survey_question_trigger",surveyQuestionTriggerWidget);return __exports;});;

/* /survey/static/src/js/tours/survey_tour.js */
odoo.define('@survey/js/tours/survey_tour',['@web/core/l10n/translation','@web/core/registry','@web_tour/tour_service/tour_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{stepUtils}=require("@web_tour/tour_service/tour_utils");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add('survey_tour',{url:"/odoo",steps:()=>[...stepUtils.goToAppSteps('survey.menu_surveys',markup(_t("Ready to change the way you <b>gather data</b>?"))),{trigger:'.btn-outline-primary.o_survey_load_sample',content:markup(_t("Load a <b>sample Survey</b> to get started quickly.")),tooltipPosition:'left',run:"click",},{trigger:'button[name=action_test_survey]',content:_t("Let's give it a spin!"),tooltipPosition:'bottom',run:"click",},{trigger:'button[type=submit]',content:_t("Let's get started!"),tooltipPosition:'bottom',run:"click",},{trigger:'.js_question-wrapper span:contains("How frequently")',},{trigger:'button[type=submit]',content:_t("Whenever you pick an answer, Odoo saves it for you."),tooltipPosition:'bottom',run:"click",},{trigger:'.js_question-wrapper span:contains("How many")',},{trigger:'button[type=submit]',content:_t("Only a single question left!"),tooltipPosition:'bottom',run:"click",},{trigger:'.js_question-wrapper span:contains("How likely")',},{trigger:'button[value=finish]',content:_t("Now that you are done, submit your form."),tooltipPosition:'bottom',run:"click",},{trigger:'.o_survey_review',content:_t("Let's have a look at your answers!"),tooltipPosition:'bottom',run:"click",},{trigger:'.survey_button_form_view_hook',content:_t("Now, use this shortcut to go back to the survey."),tooltipPosition:'bottom',run:"click",},{trigger:'button[name=action_survey_user_input_completed]',content:_t("Here, you can overview all the participations."),tooltipPosition:'bottom',run:"click",},{trigger:'td[name=survey_id]',content:_t("Let's open the survey you just submitted."),tooltipPosition:'bottom',run:"click",},{trigger:'.breadcrumb a:contains("Feedback Form")',content:_t("Use the breadcrumbs to quickly go back to the dashboard."),tooltipPosition:'bottom',run:"click",}]});return __exports;});;

/* /project_todo/static/src/components/todo_chatter_panel/todo_chatter_panel.js */
odoo.define('@project_todo/components/todo_chatter_panel/todo_chatter_panel',['@mail/chatter/web_portal/chatter','@odoo/owl','@web/core/registry','@web/views/widgets/standard_widget_props','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Chatter}=require("@mail/chatter/web_portal/chatter");const{Component,useState,useRef}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{useBus}=require("@web/core/utils/hooks");const TodoChatterPanel=__exports.TodoChatterPanel=class TodoChatterPanel extends Component{static template="project_todo.TodoChatterPanel";static components={Chatter};static props={...standardWidgetProps,};setup(){this.state=useState({displayChatter:this.env.isSmall,});this.rootRef=useRef("root");useBus(this.env.bus,"TODO:TOGGLE_CHATTER",this.toggleChatter);}
toggleChatter(ev){this.state.displayChatter=ev.detail.displayChatter;this.rootRef.el?.parentElement?.classList.toggle('d-none',!this.state.displayChatter);}}
const todoChatterPanel=__exports.todoChatterPanel={component:TodoChatterPanel,additionalClasses:["o_todo_chatter","d-none","position-relative","p-0","overflow-y-auto"],};registry.category("view_widgets").add("todo_chatter_panel",todoChatterPanel);return __exports;});;

/* /project_todo/static/src/components/todo_done_checkmark/todo_done_checkmark.js */
odoo.define('@project_todo/components/todo_done_checkmark/todo_done_checkmark',['@odoo/owl','@web/core/registry','@web/views/fields/state_selection/state_selection_field'],function(require){'use strict';let __exports={};const{useState,onRendered,onMounted}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{StateSelectionField,stateSelectionField}=require("@web/views/fields/state_selection/state_selection_field");const TodoDoneCheckmark=__exports.TodoDoneCheckmark=class TodoDoneCheckmark extends StateSelectionField{static template="project_todo.TodoDoneCheckmark";static props={...stateSelectionField.component.props,viewType:{type:String},};setup(){super.setup();this.stateDone=useState({isDone:false,notReloadState:false,});onMounted(()=>{const fieldValue=this.props.record.data[this.props.name]
this.notDoneState=fieldValue=='1_done'?'01_in_progress':fieldValue;});onRendered(()=>{if(!this.stateDone.notReloadState){this.stateDone.isDone=this.props.record.data[this.props.name]=='1_done';}});}
actualizeDoneState(ev){this.stateDone.notReloadState=false;}
freezeDoneState(ev){this.stateDone.notReloadState=true;}
async onDoneToggled(ev){const value=this.props.record.data[this.props.name]!='1_done'?'1_done':this.notDoneState;if(['kanban','list'].includes(this.props.viewType)){await super.updateRecord(value);}
else{await this.props.record.update({[this.props.name]:value,});}}}
const todoDoneCheckmark=__exports.todoDoneCheckmark={...stateSelectionField,component:TodoDoneCheckmark,extractProps:(fieldInfo,dynamicInfo)=>{const props=stateSelectionField.extractProps(fieldInfo,dynamicInfo);props.viewType=fieldInfo.viewType;return props;},}
registry.category("fields").add("todo_done_checkmark",todoDoneCheckmark);return __exports;});;

/* /project_todo/static/src/views/todo_activity_wizard/todo_activity_wizard_controller.js */
odoo.define('@project_todo/views/todo_activity_wizard/todo_activity_wizard_controller',['@odoo/owl','@web/views/form/form_controller'],function(require){'use strict';let __exports={};const{onMounted}=require("@odoo/owl");const{FormController}=require("@web/views/form/form_controller");const TodoActivityWizardController=__exports.TodoActivityWizardController=class TodoActivityWizardController extends FormController{setup(){super.setup();onMounted(()=>{const firstInput=document.querySelector('div.o_field_widget input');firstInput.focus();});}}
return __exports;});;

/* /project_todo/static/src/views/todo_activity_wizard/todo_activity_wizard_view.js */
odoo.define('@project_todo/views/todo_activity_wizard/todo_activity_wizard_view',['@web/core/registry','@web/views/form/form_view','@project_todo/views/todo_activity_wizard/todo_activity_wizard_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");const{TodoActivityWizardController}=require("@project_todo/views/todo_activity_wizard/todo_activity_wizard_controller");const todoActivityWizardView=__exports.todoActivityWizardView={...formView,Controller:TodoActivityWizardController,};registry.category("views").add("todo_activity_wizard",todoActivityWizardView);return __exports;});;

/* /project_todo/static/src/views/todo_conversion_form/todo_conversion_form_controller.js */
odoo.define('@project_todo/views/todo_conversion_form/todo_conversion_form_controller',['@odoo/owl','@web/views/form/form_controller'],function(require){'use strict';let __exports={};const{onMounted}=require("@odoo/owl");const{FormController}=require("@web/views/form/form_controller");const TodoConversionFormController=__exports.TodoConversionFormController=class TodoConversionFormController extends FormController{setup(){super.setup();onMounted(()=>{const firstConversionInput=document.querySelector('div.o_todo_conversion_form_view input');firstConversionInput.focus();});}}
return __exports;});;

/* /project_todo/static/src/views/todo_conversion_form/todo_conversion_form_view.js */
odoo.define('@project_todo/views/todo_conversion_form/todo_conversion_form_view',['@web/core/registry','@web/views/form/form_view','@project_todo/views/todo_conversion_form/todo_conversion_form_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");const{TodoConversionFormController}=require("@project_todo/views/todo_conversion_form/todo_conversion_form_controller");const todoConversionFormView=__exports.todoConversionFormView={...formView,Controller:TodoConversionFormController,};registry.category("views").add("todo_conversion_form",todoConversionFormView);return __exports;});;

/* /project_todo/static/src/views/todo_form/todo_form_control_panel.js */
odoo.define('@project_todo/views/todo_form/todo_form_control_panel',['@odoo/owl','@web/core/browser/browser','@web/core/browser/router','@web/search/control_panel/control_panel'],function(require){'use strict';let __exports={};const{onMounted,useEffect}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{router}=require("@web/core/browser/router");const{ControlPanel}=require("@web/search/control_panel/control_panel");const TodoFormControlPanel=__exports.TodoFormControlPanel=class TodoFormControlPanel extends ControlPanel{static template="project_todo.TodoFormControlPanel";setup(){super.setup();useEffect((isSmall)=>{if(isSmall&&!this.state.displayChatter){this.toggleChatter();}},()=>[this.env.isSmall]);onMounted(()=>{const isFromActivityView=router.current.actionStack?.[router.current.actionStack?.length-1]?.view_type==="activity";if(!this.env.isSmall&&!this.state.displayChatter&&(isFromActivityView||JSON.parse(browser.localStorage.getItem("isChatterOpened")))){this.toggleChatter();}});}
toggleChatter(ev){this.state.displayChatter=!this.state.displayChatter;if(ev){browser.localStorage.setItem("isChatterOpened",this.state.displayChatter);}
this.env.bus.trigger("TODO:TOGGLE_CHATTER",{displayChatter:this.state.displayChatter});}}
return __exports;});;

/* /project_todo/static/src/views/todo_form/todo_form_controller.js */
odoo.define('@project_todo/views/todo_form/todo_form_controller',['@odoo/owl','@web/core/l10n/translation','@web/core/user','@resource/views/form_with_html_expander/form_controller_with_html_expander'],function(require){'use strict';let __exports={};const{onWillStart}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{FormControllerWithHTMLExpander}=require("@resource/views/form_with_html_expander/form_controller_with_html_expander");const TodoFormController=__exports.TodoFormController=class TodoFormController extends FormControllerWithHTMLExpander{setup(){super.setup();onWillStart(async()=>{this.projectAccess=await user.hasGroup("project.group_project_user");});}
get actionMenuItems(){const actionToKeep=["archive","unarchive","duplicate","delete"];const menuItems=super.actionMenuItems;const filteredActions=menuItems.action?.filter((action)=>actionToKeep.includes(action.key))||[];if(this.projectAccess){filteredActions.push({description:_t("Convert to Task"),callback:()=>{this.model.action.doAction("project_todo.project_task_action_convert_todo_to_task",{props:{resId:this.model.root.resId,},});},});}
menuItems.action=filteredActions;menuItems.print=[];return menuItems;}}
return __exports;});;

/* /project_todo/static/src/views/todo_form/todo_form_renderer.js */
odoo.define('@project_todo/views/todo_form/todo_form_renderer',['@resource/views/form_with_html_expander/form_renderer_with_html_expander','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{FormRendererWithHtmlExpander}=require("@resource/views/form_with_html_expander/form_renderer_with_html_expander");const{useBus}=require("@web/core/utils/hooks");const TodoFormRenderer=__exports.TodoFormRenderer=class TodoFormRenderer extends FormRendererWithHtmlExpander{setup(){super.setup();useBus(this.env.bus,"TODO:TOGGLE_CHATTER",this.toggleChatter);this.sizeToExpandHTMLField=1;}
toggleChatter(ev){this.sizeToExpandHTMLField=ev.detail.displayChatter?6:1;}
_canExpandHTMLField(size){return size>=this.sizeToExpandHTMLField;}}
return __exports;});;

/* /project_todo/static/src/views/todo_form/todo_form_view.js */
odoo.define('@project_todo/views/todo_form/todo_form_view',['@web/core/registry','@web/views/form/form_view','@project_todo/views/todo_form/todo_form_controller','@project_todo/views/todo_form/todo_form_control_panel','@project_todo/views/todo_form/todo_form_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");const{TodoFormController}=require("@project_todo/views/todo_form/todo_form_controller");const{TodoFormControlPanel}=require("@project_todo/views/todo_form/todo_form_control_panel");const{TodoFormRenderer}=require("@project_todo/views/todo_form/todo_form_renderer");const todoFormView=__exports.todoFormView={...formView,Controller:TodoFormController,ControlPanel:TodoFormControlPanel,Renderer:TodoFormRenderer,};registry.category("views").add("todo_form",todoFormView);return __exports;});;

/* /project_todo/static/src/views/todo_list/todo_list_controller.js */
odoo.define('@project_todo/views/todo_list/todo_list_controller',['@web/views/list/list_controller'],function(require){'use strict';let __exports={};const{ListController}=require("@web/views/list/list_controller");const TodoListController=__exports.TodoListController=class TodoListController extends ListController{get actionMenuItems(){this.archiveEnabled=true;const actionToKeep=["export","archive","unarchive","duplicate","delete"];const menuItems=super.actionMenuItems;const filteredActions=menuItems.action?.filter(action=>actionToKeep.includes(action.key))||[];menuItems.action=filteredActions;menuItems.print=[];return menuItems;}}
return __exports;});;

/* /project_todo/static/src/views/todo_list/todo_list_view.js */
odoo.define('@project_todo/views/todo_list/todo_list_view',['@web/core/registry','@web/views/list/list_view','@project_todo/views/todo_list/todo_list_controller','@project/components/task_list_renderer'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{TodoListController}=require("@project_todo/views/todo_list/todo_list_controller");const{TaskListRenderer}=require("@project/components/task_list_renderer");const todoListView=__exports.todoListView={...listView,Controller:TodoListController,Renderer:TaskListRenderer,};registry.category("views").add("todo_list",todoListView);return __exports;});;

/* /project_todo/static/src/web/activity/activity_menu_patch.js */
odoo.define('@project_todo/web/activity/activity_menu_patch',['@web/core/l10n/translation','@mail/core/web/activity_menu','@web/views/view_dialogs/form_view_dialog','@web/core/commands/command_hook','@web/core/utils/hooks','@web/core/utils/patch','@web/core/registry'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ActivityMenu}=require("@mail/core/web/activity_menu");const{FormViewDialog}=require("@web/views/view_dialogs/form_view_dialog");const{useCommand}=require("@web/core/commands/command_hook");const{useService}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");const{registry}=require("@web/core/registry");registry.category("command_categories").add("to-do",{},{sequence:105});patch(ActivityMenu.prototype,{setup(){super.setup(...arguments);this.orm=useService("orm");this.dialogService=useService("dialog");useCommand(_t("Add a To-Do"),()=>{document.body.click();this.createActivityTodo();},{category:"to-do",hotkey:"alt+shift+t",global:true,});},async createActivityTodo(){const wizard=await this.orm.call("mail.activity.todo.create","create",[{"user_id":this.userId,}]);this.dialogService.add(FormViewDialog,{title:_t("Add a To-Do"),resModel:"mail.activity.todo.create",resId:wizard,preventCreate:true,size:"md",});},availableViews(group){if(group.is_todo){return this.todoViews;}
return super.availableViews(group);},async loadTodoViews(){this.todoViews=await this.orm.call("project.task","get_todo_views_id",[],);},async onClickAction(action,group){if(group.is_todo){await this.loadTodoViews();}
return super.onClickAction(...arguments);},async openActivityGroup(group,filter="all"){if(group.is_todo){await this.loadTodoViews();}
return super.openActivityGroup(...arguments);},});return __exports;});;

/* /hr_skills/static/src/fields/skills_one2many/skills_one2many.js */
odoo.define('@hr_skills/fields/skills_one2many/skills_one2many',['@web/views/fields/x2many/x2many_field','@web/views/fields/relational_utils','@web/core/registry','@web/core/l10n/translation','@web/core/user','@hr_skills/views/skills_list_renderer','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const{useX2ManyCrud,useOpenX2ManyRecord,}=require("@web/views/fields/relational_utils");const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{CommonSkillsListRenderer}=require("@hr_skills/views/skills_list_renderer");const{useService}=require('@web/core/utils/hooks');const{onWillStart}=require("@odoo/owl");const SkillsListRenderer=__exports.SkillsListRenderer=class SkillsListRenderer extends CommonSkillsListRenderer{static template="hr_skills.SkillsListRenderer";setup(){super.setup();this.orm=useService('orm');this.actionService=useService("action");onWillStart(async()=>{const res=await this.orm.searchCount('hr.skill.type',[]);this.anySkills=res>0;[this.user]=await this.orm.read("res.users",[user.userId],["employee_ids"]);this.IsHrUser=await user.hasGroup("hr.group_hr_user");this.userSubordinates=(await this.orm.searchRead("hr.employee",[["id","child_of",this.user.employee_ids]],["id"])).map((record)=>record["id"]);});}
get groupBy(){return'skill_type_id';}
async skillTypesAction(){return this.actionService.doAction("hr_skills.hr_skill_type_action");}
async openSkillsReport(){const id=this.env.model.root.data.id||this.env.model.root.data.employee_id[0];-this.actionService.doAction({type:"ir.actions.act_window",name:_t("Skills Report"),res_model:"hr.employee.skill.log",view_mode:"graph,list",views:[[false,"graph"],[false,"list"]],context:{'fill_temporal':0,},target:"current",domain:[['employee_id','=',id]],});}
get showTimeline(){return this.SkillsRight&&!this.props.list.context.no_timeline;}
get SkillsRight(){let isSubordinate=false;if(this.env.model.root.data.employee_id){isSubordinate=this.userSubordinates.includes(this.env.model.root.data.employee_id[0]);}
return this.IsHrUser||isSubordinate;}}
const SkillsX2ManyField=__exports.SkillsX2ManyField=class SkillsX2ManyField extends X2ManyField{static components={...X2ManyField.components,ListRenderer:SkillsListRenderer,};setup(){super.setup()
const{saveRecord,updateRecord}=useX2ManyCrud(()=>this.list,this.isMany2Many);const openRecord=useOpenX2ManyRecord({resModel:this.list.resModel,activeField:this.activeField,activeActions:this.activeActions,getList:()=>this.list,saveRecord:async(record)=>{await saveRecord(record);await this.props.record.save();},updateRecord:updateRecord,withParentId:this.props.widget!=="many2many",});this._openRecord=(params)=>{params.title=this.getWizardTitleName();openRecord({...params});};}
getWizardTitleName(){return _t("Select Skills")}
async onAdd({context,editable}={}){const employeeId=this.props.record.resModel==="res.users"?this.props.record.data.employee_id[0]:this.props.record.resId;return super.onAdd({editable,context:{...context,default_employee_id:employeeId,}});}}
const skillsX2ManyField=__exports.skillsX2ManyField={...x2ManyField,component:SkillsX2ManyField,};registry.category("fields").add("skills_one2many",skillsX2ManyField);return __exports;});;

/* /hr_skills/static/src/fields/auto_save_skill_type/auto_save_skill_type.js */
odoo.define('@hr_skills/fields/auto_save_skill_type/auto_save_skill_type',['@web/core/registry','@web/views/fields/x2many/x2many_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const AutoSaveSkillTypeField=__exports.AutoSaveSkillTypeField=class AutoSaveSkillTypeField extends X2ManyField{async onAdd({context,editable}={}){await this.props.record.model.root.save();await super.onAdd({context,editable});}}
const autoSaveSkillTypeField=__exports.autoSaveSkillTypeField={...x2ManyField,component:AutoSaveSkillTypeField,};registry.category("fields").add("auto_save_skill_type",autoSaveSkillTypeField);return __exports;});;

/* /hr_skills/static/src/fields/boolean_toggle_load/boolean_toggle_load.js */
odoo.define('@hr_skills/fields/boolean_toggle_load/boolean_toggle_load',['@web/core/registry','@web/views/fields/boolean_toggle/list_boolean_toggle_field'],function(require){'use strict';let __exports={};const{registry}=require('@web/core/registry');const{ListBooleanToggleField,listBooleanToggleField}=require("@web/views/fields/boolean_toggle/list_boolean_toggle_field");const ListBooleanToggleLoadField=__exports.ListBooleanToggleLoadField=class ListBooleanToggleLoadField extends ListBooleanToggleField{async onChange(value){await super.onChange(value);await this.props.record.model.root.save();return this.env.model.load();}}
const listBooleanToggleLoadField=__exports.listBooleanToggleLoadField={...listBooleanToggleField,component:ListBooleanToggleLoadField,};registry.category("fields").add("boolean_toggle_load",listBooleanToggleLoadField);return __exports;});;

/* /hr_skills/static/src/fields/hr_skills_tags_list/hr_skills_tags_list.js */
odoo.define('@hr_skills/fields/hr_skills_tags_list/hr_skills_tags_list',['@web/core/tags_list/tags_list'],function(require){'use strict';let __exports={};const{TagsList}=require("@web/core/tags_list/tags_list");const SkillsTagList=__exports.SkillsTagList=class SkillsTagList extends TagsList{static template="hr_skills.SkillsTagsList";getTextStyle(tag){return tag.defaultLevel}}
return __exports;});;

/* /hr_skills/static/src/fields/many2many_tags_skills/many2many_tags_skills.js */
odoo.define('@hr_skills/fields/many2many_tags_skills/many2many_tags_skills',['@web/core/registry','@web/views/fields/many2many_tags/many2many_tags_field','@hr_skills/fields/hr_skills_tags_list/hr_skills_tags_list'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Many2ManyTagsField,many2ManyTagsField,}=require("@web/views/fields/many2many_tags/many2many_tags_field");const{SkillsTagList}=require("@hr_skills/fields/hr_skills_tags_list/hr_skills_tags_list");class SkillsMany2ManyTags extends Many2ManyTagsField{static components={...Many2ManyTagsField.components,TagsList:SkillsTagList};getTagProps(record){return{...super.getTagProps(record),defaultLevel:record.data.default_level};}}
const skillsMany2ManyTags=__exports.skillsMany2ManyTags={...many2ManyTagsField,component:SkillsMany2ManyTags,relatedFields:(fieldInfo)=>{return[...many2ManyTagsField.relatedFields(fieldInfo),{name:"default_level",type:"boolean"},];},};registry.category("fields").add("many2many_tags_skills",skillsMany2ManyTags);return __exports;});;

/* /hr_skills/static/src/fields/resume_one2many/resume_one2many.js */
odoo.define('@hr_skills/fields/resume_one2many/resume_one2many',['@web/core/l10n/translation','@web/core/registry','@odoo/owl','@web/core/l10n/dates','@hr_skills/fields/skills_one2many/skills_one2many','@hr_skills/views/skills_list_renderer'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{onMounted,onPatched,useRef}=require("@odoo/owl");const{formatDate}=require("@web/core/l10n/dates");const{SkillsX2ManyField,skillsX2ManyField}=require("@hr_skills/fields/skills_one2many/skills_one2many");const{CommonSkillsListRenderer}=require("@hr_skills/views/skills_list_renderer");const ResumeListRenderer=__exports.ResumeListRenderer=class ResumeListRenderer extends CommonSkillsListRenderer{static template="hr_skills.ResumeListRenderer";static rowsTemplate="hr_skills.ResumeListRenderer.Rows";static recordRowTemplate="hr_skills.ResumeListRenderer.RecordRow";static useMagicColumnWidths=false;setup(){super.setup();this.linkRef=useRef("link-target-blank");onMounted(this._setLinksToOpenInNewTab);onPatched(this._setLinksToOpenInNewTab);}
get groupBy(){return"line_type_id";}
get colspan(){if(this.props.activeActions){return 3;}
return 2;}
formatDate(date){return formatDate(date);}
_setLinksToOpenInNewTab(){const resumeLines=this.linkRef.el;if(resumeLines){const links=resumeLines.querySelectorAll('a');links.forEach(link=>{link.setAttribute('target','_blank');});}}}
const ResumeX2ManyField=__exports.ResumeX2ManyField=class ResumeX2ManyField extends SkillsX2ManyField{static components={...SkillsX2ManyField.components,ListRenderer:ResumeListRenderer,};getWizardTitleName(){return _t("New Resume line");}}
const resumeX2ManyField=__exports.resumeX2ManyField={...skillsX2ManyField,component:ResumeX2ManyField,};registry.category("fields").add("resume_one2many",resumeX2ManyField);return __exports;});;

/* /hr_skills/static/src/views/skills_list_renderer.js */
odoo.define('@hr_skills/views/skills_list_renderer',['@web/core/l10n/translation','@web/views/list/list_renderer'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ListRenderer}=require("@web/views/list/list_renderer");const CommonSkillsListRenderer=__exports.CommonSkillsListRenderer=class CommonSkillsListRenderer extends ListRenderer{get colspan(){const span=this.allColumns.length;if(this.isEditable){return span+1;}
return span;}
get groupBy(){return'';}
get groupedList(){const grouped={};for(const record of this.list.records){const data=record.data;const group=data[this.groupBy];if(grouped[group[1]]===undefined){grouped[group[1]]={id:parseInt(group[0]),name:group[1]||_t('Other'),list:{records:[],},};}
grouped[group[1]].list.records.push(record);}
return grouped;}
get showTable(){return this.props.list.records.length;}
get isEditable(){return this.props.editable!==false;}
async onCellClicked(record,column,ev){if(!this.isEditable){return;}
return await super.onCellClicked(record,column,ev);}}
CommonSkillsListRenderer.rowsTemplate="hr_skills.SkillsListRenderer.Rows";return __exports;});;

/* /hr_skills/static/src/components/avatar_card_resource/avatar_card_resource_popover_patch.js */
odoo.define('@hr_skills/components/avatar_card_resource/avatar_card_resource_popover_patch',['@web/core/utils/patch','@resource_mail/components/avatar_card_resource/avatar_card_resource_popover'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{AvatarCardResourcePopover}=require("@resource_mail/components/avatar_card_resource/avatar_card_resource_popover");const patchAvatarCardResourcePopover=__exports.patchAvatarCardResourcePopover={loadAdditionalData(){const promises=super.loadAdditionalData();this.skills=false;if(this.record.employee_skill_ids?.length){promises.push(this.orm.read("hr.employee.skill",this.record.employee_skill_ids,["display_name","color"]).then((skills)=>{this.skills=skills;}));}
return promises;},get fieldNames(){return[...super.fieldNames,"employee_skill_ids",];},get skillTags(){return this.skills.map(({id,display_name,color})=>({id,text:display_name,colorIndex:color,}));},};const unpatchAvatarCardResourcePopover=__exports.unpatchAvatarCardResourcePopover=patch(AvatarCardResourcePopover.prototype,patchAvatarCardResourcePopover);return __exports;});;

/* /hr_contract/static/src/widgets/tooltip_warning_widget.js */
odoo.define('@hr_contract/widgets/tooltip_warning_widget',['@web/core/registry','@web/core/l10n/translation','@odoo/owl','@web/views/widgets/standard_widget_props'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{Component}=require("@odoo/owl");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const ContractWarningTooltip=__exports.ContractWarningTooltip=class ContractWarningTooltip extends Component{static template="hr_contract.ContractWarningTooltip";static props={...standardWidgetProps};get tooltipInfo(){return JSON.stringify({"text":_t("Calendar Mismatch: The employee's calendar does not match this contract's calendar. This could lead to unexpected behaviors."),})}}
const contractWarningTooltip=__exports.contractWarningTooltip={component:ContractWarningTooltip,};registry.category("view_widgets").add("contract_warning_tooltip",contractWarningTooltip);return __exports;});;

/* /hr_work_entry_contract/static/src/components/work_entry_source_field/work_entry_source_field.js */
odoo.define('@hr_work_entry_contract/components/work_entry_source_field/work_entry_source_field',['@web/core/registry','@web/views/fields/radio/radio_field','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{RadioField,radioField}=require("@web/views/fields/radio/radio_field");const{_t}=require("@web/core/l10n/translation");const WorkEntrySourceField=__exports.WorkEntrySourceField=class WorkEntrySourceField extends RadioField{static template="hr_work_entry_contract.WorkEntrySourceField";get isFullyFlexible(){return!this.props.record.data.resource_calendar_id;}
get tooltipWarning(){return JSON.stringify({"text":_t("Invalid option: For fully flexible calendars, the work entry source cannot be 'Working Hours'."),})}}
const workEntrySourceField=__exports.workEntrySourceField={...radioField,component:WorkEntrySourceField,fieldDependencies:[{name:"resource_calendar_id",type:"many2one",relation:"resource.calendar"},],};registry.category("fields").add("work_entry_source_field",workEntrySourceField);return __exports;});;

/* /hr_work_entry_contract/static/src/views/work_entry_calendar/work_entry_calendar_controller.js */
odoo.define('@hr_work_entry_contract/views/work_entry_calendar/work_entry_calendar_controller',['@web/core/registry','@web/views/calendar/calendar_controller','@hr_work_entry_contract/views/work_entry_calendar/work_entry_calendar_model','@web/views/calendar/calendar_view','@hr_work_entry_contract/views/work_entry_hook'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{CalendarController}=require('@web/views/calendar/calendar_controller');const{WorkEntryCalendarModel}=require("@hr_work_entry_contract/views/work_entry_calendar/work_entry_calendar_model");const{calendarView}=require("@web/views/calendar/calendar_view");const{useWorkEntry}=require("@hr_work_entry_contract/views/work_entry_hook");const WorkEntryCalendarController=__exports.WorkEntryCalendarController=class WorkEntryCalendarController extends CalendarController{setup(){super.setup(...arguments);const{onRegenerateWorkEntries}=useWorkEntry({getEmployeeIds:this.getEmployeeIds.bind(this),getRange:this.model.computeRange.bind(this.model),onClose:this.model.load.bind(this.model)});this.onRegenerateWorkEntries=onRegenerateWorkEntries;}
getEmployeeIds(){return[...new Set(Object.values(this.model.records).map(rec=>rec.rawRecord.employee_id[0]))];}}
const WorkEntryCalendarView=__exports.WorkEntryCalendarView={...calendarView,Controller:WorkEntryCalendarController,Model:WorkEntryCalendarModel,buttonTemplate:"hr_work_entry_contract.calendar.controlButtons",}
registry.category("views").add("work_entries_calendar",WorkEntryCalendarView);return __exports;});;

/* /hr_work_entry_contract/static/src/views/work_entry_calendar/work_entry_calendar_model.js */
odoo.define('@hr_work_entry_contract/views/work_entry_calendar/work_entry_calendar_model',['@web/core/l10n/translation','@web/views/calendar/calendar_model','@hr_work_entry_contract/views/work_entry_hook'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{CalendarModel}=require("@web/views/calendar/calendar_model");const{useWorkEntry}=require("@hr_work_entry_contract/views/work_entry_hook");const{DateTime}=luxon;const WorkEntryCalendarModel=__exports.WorkEntryCalendarModel=class WorkEntryCalendarModel extends CalendarModel{setup(){super.setup(...arguments);const{generateWorkEntries}=useWorkEntry({getRange:this.computeRange.bind(this)});this.generateWorkEntries=generateWorkEntries;}
computeRange(){const{scale,date}=this.meta;const start=date.startOf(scale);const end=date.endOf(scale);return{start,end};}
makeFilterAll(){return{...super.makeFilterAll(...arguments),label:_t("Everybody's work entries"),active:true,};}
async updateData(data){const{start}=this.computeRange();const shouldGenerateWorkEntries=start<=DateTime.now();if(shouldGenerateWorkEntries){await this.generateWorkEntries();}
await super.updateData(data);}}
return __exports;});;

/* /hr_work_entry_contract/static/src/views/work_entry_hook.js */
odoo.define('@hr_work_entry_contract/views/work_entry_hook',['@web/core/l10n/dates','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{serializeDate}=require("@web/core/l10n/dates");const{useService}=require("@web/core/utils/hooks");__exports.useWorkEntry=useWorkEntry;function useWorkEntry({getEmployeeIds,getRange,onClose}){const orm=useService("orm");const action=useService("action");return{onRegenerateWorkEntries:()=>{const{start,end}=getRange();action.doAction('hr_work_entry_contract.hr_work_entry_regeneration_wizard_action',{additionalContext:{default_employee_ids:getEmployeeIds(),date_start:serializeDate(start),date_end:serializeDate(end),},onClose:onClose});},generateWorkEntries:()=>{const{start,end}=getRange();return orm.call('hr.employee','generate_work_entries',[[],serializeDate(start),serializeDate(end)]);},}}
return __exports;});;

/* /hr_payroll/static/src/components/add_payslips/add_payslips.js */
odoo.define('@hr_payroll/components/add_payslips/add_payslips',['@web/core/registry','@web/views/widgets/standard_widget_props','@odoo/owl','@hr_payroll/views/add_payslips_hook'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{Component,}=require("@odoo/owl");const{useAddPayslips}=require("@hr_payroll/views/add_payslips_hook");const AddPayslips=__exports.AddPayslips=class AddPayslips extends Component{static template="hr_payroll.AddPayslips";static props={...standardWidgetProps,string:{type:String},};setup(){super.setup();this.addPayslips=useAddPayslips();}
async onAddPayslips(){await this.addPayslips(this.props.record);}}
const addPayslips=__exports.addPayslips={component:AddPayslips,extractProps:({attrs})=>{const{string}=attrs;return{string};},};registry.category("view_widgets").add("add_payslips",addPayslips);return __exports;});;

/* /hr_payroll/static/src/components/dashboard/action_box/action_box.js */
odoo.define('@hr_payroll/components/dashboard/action_box/action_box',['@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{Component,useState,onWillStart}=require("@odoo/owl");const PayrollDashboardActionBox=__exports.PayrollDashboardActionBox=class PayrollDashboardActionBox extends Component{static template="hr_payroll.ActionBox";static props=["*"];setup(){this.actionService=useService("action");this.orm=useService('orm');this.state=useState({loading:true,warnings:{},})
onWillStart(()=>{this.orm.call('hr.payslip','get_dashboard_warnings').then(data=>{this.state.warnings=data;this.state.loading=false;})
return Promise.resolve(true);})}}
return __exports;});;

/* /hr_payroll/static/src/components/dashboard/payroll_dashboard.js */
odoo.define('@hr_payroll/components/dashboard/payroll_dashboard',['@web/core/registry','@web/core/utils/hooks','@hr_payroll/components/dashboard/action_box/action_box','@hr_payroll/components/dashboard/payslip_batch/payslip_batch','@hr_payroll/components/dashboard/todo_list/todo_list','@hr_payroll/components/dashboard/payroll_stats/payroll_stats','@odoo/owl','@web/webclient/actions/action_service'],function(require){'use strict';let __exports={};const{registry}=require('@web/core/registry');const{useService}=require("@web/core/utils/hooks");const{PayrollDashboardActionBox}=require('@hr_payroll/components/dashboard/action_box/action_box');const{PayrollDashboardPayslipBatch}=require('@hr_payroll/components/dashboard/payslip_batch/payslip_batch');const{PayrollDashboardTodo}=require('@hr_payroll/components/dashboard/todo_list/todo_list');const{PayrollDashboardStats}=require('@hr_payroll/components/dashboard/payroll_stats/payroll_stats');const{Component,onWillStart}=require("@odoo/owl");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");class PayrollDashboardComponent extends Component{static template="hr_payroll.Dashboard";static components={PayrollDashboardActionBox,PayrollDashboardPayslipBatch,PayrollDashboardTodo,PayrollDashboardStats,};static props={...standardActionServiceProps};setup(){this.orm=useService('orm');onWillStart(async()=>{this.dashboardData=await this.orm.call('hr.payslip','get_payroll_dashboard_data',[]);});}
async updateNoteMemo(id,memo){await this.orm.write('hr.payroll.note',[id],{memo});this.reloadNotes();}
async reloadNotes(){const kwargs={sections:['notes']};const newData=await this.orm.call('hr.payslip','get_payroll_dashboard_data',[],kwargs);this.dashboardData.notes=newData.notes;this.render();}}
registry.category('actions').add('hr_payroll_dashboard',PayrollDashboardComponent);__exports[Symbol.for("default")]=PayrollDashboardComponent;return __exports;});;

/* /hr_payroll/static/src/components/dashboard/payroll_stats/payroll_stats.js */
odoo.define('@hr_payroll/components/dashboard/payroll_stats/payroll_stats',['@web/core/assets','@web/core/utils/hooks','@web/core/colors/colors','@web/core/browser/cookie','@odoo/owl'],function(require){'use strict';let __exports={};const{loadJS}=require("@web/core/assets");const{useService}=require("@web/core/utils/hooks");const{getColor,getCustomColor}=require("@web/core/colors/colors");const{cookie}=require("@web/core/browser/cookie");const{Component,onWillUnmount,useEffect,useRef,useState,onWillStart}=require("@odoo/owl");const colorScheme=cookie.get("color_scheme")
const GRAPH_GRID_COLOR=getCustomColor(colorScheme,"#d8dadd","#3C3E4B");const GRAPH_LABEL_COLOR=getCustomColor(colorScheme,"#111827","#E4E4E4");const PayrollDashboardStats=__exports.PayrollDashboardStats=class PayrollDashboardStats extends Component{static template="hr_payroll.DashboardStats";static props={title:String,help:{type:String,optional:true},id:{type:String,optional:true},actions:Array,type:String,data:Object,is_sample:Boolean,label:String,};setup(){this.actionService=useService("action");this.canvasRef=useRef('canvas');this.state=useState({monthly:true});onWillStart(()=>loadJS("/web/static/lib/Chart/Chart.js"));useEffect(()=>this.renderChart());onWillUnmount(()=>{if(this.chart){this.chart.destroy();}});}
get tooltipInfo(){return JSON.stringify({help:this.props.help,});}
toggle(){this.state.monthly=!this.state.monthly;}
get graphData(){return this.props.data[this.state.monthly?'monthly':'yearly'];}
renderChart(){if(this.chart){this.chart.destroy();}
const ctx=this.canvasRef.el.getContext('2d');this.chart=new Chart(ctx,this.getChartConfig());}
getChartConfig(){const type=this.props.type;if(type==='line'){return this.getLineChartConfig();}else if(type==='bar'){return this.getBarChartConfig();}else if(type==='stacked_bar'){return this.getStackedBarChartConfig();}
return{};}
getLineChartConfig(){const data=this.graphData
const labels=data.map(function(pt){return pt.x;});const borderColor=this.props.is_sample?'#dddddd':'#875a7b';const backgroundColor=this.props.is_sample?'#ebebeb':'#dcd0d9';return{type:'line',data:{labels:labels,datasets:[{data:data,fill:'start',label:this.props.label,backgroundColor:backgroundColor,borderColor:borderColor,borderWidth:2,}],},options:{plugins:{legend:{display:false},tooltip:{intersect:false,position:'nearest',caretSize:0,},},scales:{y:{display:false,beginAtZero:true,},x:{display:false},},maintainAspectRatio:false,elements:{line:{tension:0.000001,},},},};}
getBarChartConfig(){const data=[];const labels=[];const backgroundColors=[];const color19=getColor(1,cookie.get("color_scheme"),"odoo");this.graphData.forEach((pt)=>{data.push(pt.value);labels.push(pt.label);let color;if(this.props.is_sample){color='#ebebeb';}else if(pt.type==='past'){color='#ccbdc8';}else if(pt.type==='future'){color='#a5d8d7';}else{color=color19;}
backgroundColors.push(color);});return{type:'bar',data:{labels:labels,datasets:[{data:data,fill:'start',label:this.props.label,backgroundColor:backgroundColors,}],},options:{plugins:{legend:{display:false},tooltip:{intersect:false,position:'nearest',caretSize:0,},},scales:{y:{grid:{color:GRAPH_GRID_COLOR},ticks:{color:GRAPH_LABEL_COLOR}},x:{grid:{color:GRAPH_GRID_COLOR},ticks:{color:GRAPH_LABEL_COLOR}}},maintainAspectRatio:false,elements:{line:{tension:0.000001}}}};}
getStackedBarChartConfig(){const labels=[];const datasets=[];const datasets_labels=[];let colors;if(this.props.is_sample){colors=['#e7e7e7','#dddddd','#f0f0f0','#fafafa'];}else{colors=[getColor(14,cookie.get("color_scheme"),"odoo"),'#a5d8d7','#ebebeb','#ebebeb'];}
Object.entries(this.graphData).forEach(([code,graphData])=>{datasets_labels.push(code);const dataset_data=[];const formatted_data=[]
graphData.forEach(function(pt){if(!labels.includes(pt.label)){labels.push(pt.label);}
formatted_data.push(`${code}: ${pt.formatted_value || pt.value}`);dataset_data.push(pt.value);})
datasets.push({data:dataset_data,label:code,backgroundColor:colors[datasets_labels.length-1],formatted_data:formatted_data})});return{type:'bar',data:{labels:labels,datasets:datasets,},options:{responsive:true,plugins:{legend:{display:false},tooltip:{intersect:false,position:'nearest',caretSize:0,callbacks:{label:(tooltipItem)=>{const{datasetIndex,index}=tooltipItem;return datasets[datasetIndex].formatted_data[index];},},},},scales:{x:{stacked:true,grid:{color:GRAPH_GRID_COLOR},ticks:{color:GRAPH_LABEL_COLOR},border:{color:GRAPH_GRID_COLOR},},y:{display:false,stacked:true,beginAtZero:true,grid:{color:GRAPH_GRID_COLOR},}},maintainAspectRatio:false,elements:{line:{tension:0.000001}}}}}}
return __exports;});;

/* /hr_payroll/static/src/components/dashboard/payslip_batch/payslip_batch.js */
odoo.define('@hr_payroll/components/dashboard/payslip_batch/payslip_batch',['@web/core/l10n/translation','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const PayrollDashboardPayslipBatch=__exports.PayrollDashboardPayslipBatch=class PayrollDashboardPayslipBatch extends Component{static template="hr_payroll.PayslipBatch";static props=["batches"];setup(){this.actionService=useService("action");}
onClickTitle(){this.actionService.doAction('hr_payroll.action_hr_payslip_run_tree');}
getColorFromState(state){const colorMap={'New':'text-bg-secondary','Confirmed':'text-bg-success','Done':'text-bg-primary','Paid':'text-bg-warning',};return colorMap[state]||'text-bg-primary'}
onClickLine(batchID,batchName){this.actionService.doAction({type:'ir.actions.act_window',name:_t('Employee Payslips'),res_model:'hr.payslip.run',res_id:batchID,views:[[false,'form']],});}}
return __exports;});;

/* /hr_payroll/static/src/components/dashboard/todo_list/todo_list.js */
odoo.define('@hr_payroll/components/dashboard/todo_list/todo_list',['@web/core/l10n/translation','@odoo/owl','@web/core/confirmation_dialog/confirmation_dialog','@web/core/utils/hooks','@web/search/utils/order_by','@web/views/fields/field','@web/model/record','@web/search/action_hook'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component,onWillStart,useState}=require("@odoo/owl");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{useAutofocus,useService}=require("@web/core/utils/hooks");const{orderByToString}=require("@web/search/utils/order_by");const{Field}=require("@web/views/fields/field");const{Record}=require("@web/model/record");const{useSetupAction}=require("@web/search/action_hook");const PayrollDashboardTodo=__exports.PayrollDashboardTodo=class PayrollDashboardTodo extends Component{static template="hr_payroll.TodoList";static components={Field,Record,};static props=["orderBy"];setup(){this.company=useService("company");this.orm=useService("orm");this.dialog=useService("dialog");this.state=useState({activeNoteId:-1,isEditingNoteName:false,records:[],});this.recordInfo={model:"hr.payroll.note",specification:{name:{}},};this.autofocusInput=useAutofocus({selectAll:true});useSetupAction({beforeLeave:()=>this.saveNote(),beforeUnload:()=>{if(this.editedNote){return this.editedNote.urgentSave();}},});onWillStart(async()=>{this.state.records=(await this.orm.webSearchRead(this.recordInfo.model,[],{specification:this.recordInfo.specification,order:orderByToString(this.props.orderBy),})).records;const record=this.state.records[0];this.state.activeNoteId=record&&record.id;});}
async createNoteForm(){const result=await this.orm.create("hr.payroll.note",[{name:"Untitled",company_id:this.company.currentCompany.id,note:'',},]);const noteId=result[0];const specification=this.recordInfo.specification;const createdNote=(await this.orm.webRead(this.recordInfo.model,[noteId],{specification}))[0];this.state.records.push(createdNote);this.state.activeNoteId=noteId;this.startNameEdition(createdNote);}
async onClickNoteTab(record){if(record.id===this.state.activeNoteId){return;}
await this.saveNote();this.state.isEditingNoteName=false;this.state.activeNoteId=record.id;}
onRecordChanged(editedRecord){this.editedNote=editedRecord;}
startNameEdition(record){if(record.id===this.state.activeNoteId){this.state.isEditingNoteName=true;this.bufferedText=record.name;}}
onInputNoteNameInput(ev){this.bufferedText=ev.target.value;}
handleBlur(){this._applyNoteRename();}
onKeyDownNoteNameInput(ev){switch(ev.key){case"Enter":this._applyNoteRename();break;case"Escape":this.state.isEditingNoteName=false;break;}}
async _applyNoteRename(){const value=this.bufferedText.trim();const record=this.state.records.find((record)=>record.id===this.state.activeNoteId);if(value!==record.name){record.name=value;this.orm.write(this.recordInfo.model,[record.id],{name:value});}
this.state.isEditingNoteName=false;}
async onNoteDelete(){const message=_t("Are you sure you want to delete this note? All content will be definitely lost.");this.dialog.add(ConfirmationDialog,{body:message,confirm:()=>this._deleteNote(this.state.activeNoteId),});}
async _deleteNote(noteId){await this.orm.unlink(this.recordInfo.model,[noteId]);this.state.records=this.state.records.filter((record)=>record.id!==noteId);this.state.activeNoteId=this.state.records.length&&this.state.records[0].id;}
async onClickCreateNote(){await this.saveNote();this.createNoteForm();}
async saveNote(){if(this.editedNote){this.editedNote.save();}}}
return __exports;});;

/* /hr_payroll/static/src/js/employee_line_many2many.js */
odoo.define('@hr_payroll/js/employee_line_many2many',['@web/core/registry','@web/core/utils/hooks','@web/views/fields/x2many/x2many_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const EmployeeLineMany2Many=__exports.EmployeeLineMany2Many=class EmployeeLineMany2Many extends X2ManyField{setup(){super.setup(...arguments);this.orm=useService("orm");}
async onAdd({context,editable}){await this.props.record.model.root.save();const domain=await this.orm.call("hr.payslip.employees","get_employees_domain",[this.props.record.resId]);this.props.domain=domain
return super.onAdd({context,editable});}}
const employeeLineMany2Many=__exports.employeeLineMany2Many={...x2ManyField,component:EmployeeLineMany2Many,};registry.category("fields").add("employee_line_many2many",employeeLineMany2Many);return __exports;});;

/* /hr_payroll/static/src/js/hooks.js */
odoo.define('@hr_payroll/js/hooks',['@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{useComponent}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");__exports.useOpenViews=useOpenViews;function useOpenViews(){const orm=useService('orm')
const component=useComponent();const actionService=useService('action')
const{title}=component.model.metaData;return async(domain,views,context)=>{const result=await orm.searchRead("hr.payroll.report",domain,["payslip_id"]);const contractDomain=[["id","in",result.map((r)=>r.payslip_id[0])]];actionService.doAction({type:"ir.actions.act_window",name:title,views:[[false,"list"],[false,"form"],],context,res_model:"hr.payslip",target:"current",domain:contractDomain,});};}
return __exports;});;

/* /hr_payroll/static/src/js/payslip_line_one2many.js */
odoo.define('@hr_payroll/js/payslip_line_one2many',['@web/core/registry','@web/core/utils/hooks','@web/views/fields/field','@web/views/fields/x2many/x2many_field','@web/views/list/list_renderer','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{Field}=require("@web/views/fields/field");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const{ListRenderer}=require("@web/views/list/list_renderer");const{useEnv}=require("@odoo/owl");const WorkedDaysField=__exports.WorkedDaysField=class WorkedDaysField extends Field{setup(){super.setup(...arguments);this.actionService=useService("action");this.orm=useEnv().services.orm;}
get fieldComponentProps(){const props=super.fieldComponentProps;const record=this.props.record;if(!record.isWorkedDaysField){record.isWorkedDaysField=true;const oldUpdate=record.update.bind(record);record.update=async(changes)=>{if('amount'in changes||'quantity'in changes){await oldUpdate(changes);await record._parentRecord.save();const wizardId=record.model.config.resId;if(wizardId){const action=await this.orm.call("hr.payroll.edit.payslip.lines.wizard","recompute_worked_days_lines",[wizardId]);if(action){await this.actionService.doAction(action);}}}else{await oldUpdate(changes);}}}
return props;}}
const WorkedDaysRenderer=__exports.WorkedDaysRenderer=class WorkedDaysRenderer extends ListRenderer{static components={...ListRenderer.components,Field:WorkedDaysField,};}
const WorkedDaysLineOne2Many=__exports.WorkedDaysLineOne2Many=class WorkedDaysLineOne2Many extends X2ManyField{static components={...X2ManyField.components,ListRenderer:WorkedDaysRenderer,};async onAdd({context,editable}){const wizardId=this.props.record.resId;return super.onAdd({context:{...context,default_edit_payslip_lines_wizard_id:wizardId,},editable});}}
const workedDaysLineOne2Many=__exports.workedDaysLineOne2Many={...x2ManyField,component:WorkedDaysLineOne2Many,};const PayslipLineField=__exports.PayslipLineField=class PayslipLineField extends Field{setup(){super.setup(...arguments);this.actionService=useService("action");this.orm=useEnv().services.orm;}
get fieldComponentProps(){const props=super.fieldComponentProps;const record=this.props.record;if(!record.isPayslipLineField){record.isPayslipLineField=true;const oldUpdate=record.update.bind(record);record.update=async(changes)=>{if('amount'in changes||'quantity'in changes){oldUpdate(changes,{save:true});await record.save();const wizardId=record.model.config.resId;if(wizardId){const line_id=record.resId;const action=await this.orm.call("hr.payroll.edit.payslip.lines.wizard","recompute_following_lines",[wizardId,line_id]);await this.actionService.doAction(action);}}else{await oldUpdate(changes);}}}
return props;}}
const PayslipLineRenderer=__exports.PayslipLineRenderer=class PayslipLineRenderer extends ListRenderer{static components={...ListRenderer.components,Field:PayslipLineField}}
const PayslipLineOne2Many=__exports.PayslipLineOne2Many=class PayslipLineOne2Many extends X2ManyField{static components={...X2ManyField.components,ListRenderer:PayslipLineRenderer};async onAdd({context,editable}){const wizardId=this.props.record.resId;return super.onAdd({context:{...context,default_edit_payslip_lines_wizard_id:wizardId,},editable});}}
const payslipLineOne2Many=__exports.payslipLineOne2Many={...x2ManyField,component:PayslipLineOne2Many,};registry.category("fields").add("payslip_line_one2many",payslipLineOne2Many);registry.category("fields").add("worked_days_line_one2many",workedDaysLineOne2Many);return __exports;});;

/* /hr_payroll/static/src/js/tours/hr_payroll.js */
odoo.define('@hr_payroll/js/tours/hr_payroll',['@web/core/l10n/translation','@web/core/registry','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add('payroll_tours',{url:"/odoo",steps:()=>[{trigger:`.o_app[data-menu-xmlid='hr_work_entry_contract_enterprise.menu_hr_payroll_root']`,content:markup(_t("Click on Payroll to manage your employee's <strong>Work Entries</strong>, <strong>Contracts</strong> and <strong>Payslips</strong>.")),tooltipPosition:'bottom',run:"click",},{trigger:"button[data-menu-xmlid='hr_payroll.menu_hr_payroll_employees_root']",content:markup(_t("First, we'll create a new <strong>Contract</strong>.")),tooltipPosition:'bottom',run:"click",},{trigger:"a[data-menu-xmlid='hr_payroll.hr_menu_all_contracts']",content:markup(_t('Click on Employees to pick one of your <strong>Employees</strong>.')),tooltipPosition:'right',run:"click",},{trigger:`.o_list_button_add`,content:markup(_t('Click here to create a new <strong>Contract</strong>.')),tooltipPosition:'bottom',run:"click",},{trigger:`div[name='name'] input`,content:markup(_t('Add a <strong>name</strong> to the contract.')),tooltipPosition:'bottom',run:'edit Test',},{trigger:".o_field_widget[name='employee_id'] input",content:_t("Add a employee to your contract"),tooltipPosition:"right",run:'click',},{isActive:["auto"],trigger:".ui-autocomplete > li > a:not(:has(i.fa))",id:'hr_payroll_start',run:'click',},{trigger:'.o_hr_contract_salary_information',content:markup(_t('Click on <strong>Salary Information</strong> to access additional fields.')),tooltipPosition:'bottom',run:"click",},{trigger:`.o_notebook div[name='wage'] input`,content:markup(_t('Define a <strong>Wage</strong>.')),tooltipPosition:'bottom',run:'edit 1000',},{trigger:"button.o_form_button_save",content:"Save Contract",tooltipPosition:'bottom',run:"click",},{trigger:`.o_form_statusbar button[data-value='open']`,content:markup(_t('Set the Contract as <strong><q>Running</q></strong>.')),tooltipPosition:'bottom',run:"click",},{trigger:`button[data-menu-xmlid='hr_work_entry_contract_enterprise.menu_hr_payroll_work_entries_root']`,content:markup(_t('Click on the <strong>Work Entries</strong> menu.')),tooltipPosition:'bottom',run:"click",},{trigger:`a[data-menu-xmlid='hr_work_entry_contract_enterprise.menu_work_entry']`,content:markup(_t('Check the <strong>Work Entries</strong> linked to your newly created Contract.')),tooltipPosition:'right',run:"click",},{trigger:".o_searchview .o_facet_remove",content:_t('Remove "Conflicting" filter'),run:"click",},{trigger:'.o_gantt_pill_wrapper',content:markup(_t('Work Entries are generated for each <strong>time period</strong> defined in the Working Schedule of the Contract.')),tooltipPosition:'top',run:"click",},{trigger:'button.btn-payslip-generate',content:markup(_t('Click here to generate a <strong>Batch</strong> for the displayed Employees.')),tooltipPosition:'bottom',run:"click",},{trigger:`button[name='action_open_payslips']`,content:markup(_t('On the smartbutton, you can find all the <strong>Payslips</strong> included in the Batch.')),tooltipPosition:'top',run:"click",},{trigger:`table.o_list_table tr.o_data_row:last .o_data_cell[name='number']`,content:markup(_t('Click on the <strong>Payslip</strong>.')),tooltipPosition:'top',run:"click",},{trigger:`.o_hr_payroll_worked_days_input`,content:markup(_t('On the first tab is the amount of worked time giving you a <strong>gross amount</strong>.')),tooltipPosition:'top',run:"click",},{trigger:`.o_hr_payroll_salary_computation`,content:markup(_t('On the second tab is the computation of the rules linked to the Structure resulting in a <strong>net amount</strong>.')),tooltipPosition:'top',run:"click",},{trigger:`button[name='action_payslip_done']`,content:markup(_t('Confirm the <strong>Payslip</strong>.')),tooltipPosition:'bottom',run:'click',},]});return __exports;});;

/* /hr_payroll/static/src/views/add_payslips_hook.js */
odoo.define('@hr_payroll/views/add_payslips_hook',['@web/core/l10n/translation','@web/core/utils/hooks','@web/views/view_dialogs/select_create_dialog'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{useOwnedDialogs,useService}=require("@web/core/utils/hooks");const{SelectCreateDialog}=require("@web/views/view_dialogs/select_create_dialog");__exports.useAddPayslips=useAddPayslips;function useAddPayslips(){const addDialog=useOwnedDialogs();const notification=useService("notification");const orm=useService('orm');return async(record)=>{if(!await record.save()){return;}
addDialog(SelectCreateDialog,{resModel:'hr.payslip',title:_t('Add Payslips'),noCreate:true,domain:[['payslip_run_id','=',false]],onSelected:async(resIds)=>{const slipIds=resIds.map((id)=>id);await orm.write('hr.payslip',slipIds,{'payslip_run_id':record.resId,});await record.load();notification.add(_t('The payslips(s) are now added to the batch'),{type:'success'});}});}}
return __exports;});;

/* /hr_payroll/static/src/views/payslip_batch_form/payslip_batch_form.js */
odoo.define('@hr_payroll/views/payslip_batch_form/payslip_batch_form',['@web/core/l10n/translation','@web/core/registry','@web/views/form/form_controller','@web/views/form/form_view','@hr_payroll/views/add_payslips_hook'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{FormController}=require("@web/views/form/form_controller");const{formView}=require("@web/views/form/form_view");const{useAddPayslips}=require("@hr_payroll/views/add_payslips_hook");const PayslipBatchFormController=__exports.PayslipBatchFormController=class PayslipBatchFormController extends FormController{setup(){super.setup();this.addPayslips=useAddPayslips();}
getStaticActionMenuItems(){const menuItems=super.getStaticActionMenuItems();if(['draft','verify'].includes(this.model.root.data.state)){menuItems.add_payslips={sequence:50,description:_t('Add Payslips'),callback:async()=>{await this.addPayslips(this.model.root);},};}
return menuItems;}}
registry.category("views").add("hr_payslip_batch_form",{...formView,Controller:PayslipBatchFormController,});return __exports;});;

/* /hr_payroll/static/src/views/work_entry_calendar/work_entry_calendar_controller.js */
odoo.define('@hr_payroll/views/work_entry_calendar/work_entry_calendar_controller',['@web/core/utils/patch','@hr_work_entry_contract/views/work_entry_calendar/work_entry_calendar_controller','@hr_payroll/views/work_entry_calendar/work_entry_calendar_hook'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{WorkEntryCalendarController}=require('@hr_work_entry_contract/views/work_entry_calendar/work_entry_calendar_controller');const{useWorkEntryPayslip}=require('@hr_payroll/views/work_entry_calendar/work_entry_calendar_hook');patch(WorkEntryCalendarController.prototype,{setup(){super.setup(...arguments);this.onGeneratePayslips=useWorkEntryPayslip({getEmployeeIds:this.getEmployeeIds.bind(this),getRange:this.model.computeRange.bind(this.model),});},checkConflicts(){return Object.values(this.model.records).some(record=>record.rawRecord.state==='conflict')?"disabled":"";},getShowGeneratePayslipsButton(){const allValidated=Object.values(this.model.records).every(record=>record.rawRecord.state==='validated');return!allValidated&&Object.keys(this.model.records).length!==0;},});return __exports;});;

/* /hr_payroll/static/src/views/work_entry_calendar/work_entry_calendar_hook.js */
odoo.define('@hr_payroll/views/work_entry_calendar/work_entry_calendar_hook',['@web/core/l10n/dates','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{serializeDate}=require("@web/core/l10n/dates");const{useService}=require("@web/core/utils/hooks");__exports.useWorkEntryPayslip=useWorkEntryPayslip;function useWorkEntryPayslip({getEmployeeIds,getRange}){const action=useService("action");return()=>{const{start,end}=getRange();action.doAction("hr_payroll.action_generate_payslips_from_work_entries",{additionalContext:{default_date_start:serializeDate(start),default_date_end:serializeDate(end),active_employee_ids:getEmployeeIds()}});}}
return __exports;});;

/* /website_hr_recruitment/static/src/js/widgets/copy_link_menuitem.js */
odoo.define('@website_hr_recruitment/js/widgets/copy_link_menuitem',['@web/core/l10n/translation','@web/core/registry','@web/core/copy_button/copy_button','@web/core/utils/hooks','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{CopyButton}=require("@web/core/copy_button/copy_button");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const CopyButtonJob=__exports.CopyButtonJob=class CopyButtonJob extends CopyButton{static template="website_hr_recruitment.CopyButtonJob";setup(){super.setup();this.notification=useService("notification");}
showTooltip(){this.notification.add(_t("The job link has been copied to the clipboard."),{type:'success',});}}
const CopyClipboardCharField=__exports.CopyClipboardCharField=class CopyClipboardCharField extends Component{static components={CopyButtonJob};static template="website_hr_recruitment.CopyJobLinkButton";static props={...standardFieldProps}
setup(){this.copyText=_t("Share Job");this.successText=_t("Copied");}}
const copyClipboardJobLinkButton=__exports.copyClipboardJobLinkButton={component:CopyClipboardCharField,};registry.category("fields").add("CopyClipboardJobLinkButton",copyClipboardJobLinkButton);return __exports;});;

/* /website_hr_recruitment/static/src/fields/boolean_toggle_labeled_field.js */
odoo.define('@website_hr_recruitment/fields/boolean_toggle_labeled_field',['@web/core/l10n/translation','@web/core/registry','@web/model/relational_model/utils','@web/views/fields/boolean_toggle/boolean_toggle_field'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{useRecordObserver}=require("@web/model/relational_model/utils");const{BooleanToggleField,booleanToggleField,}=require("@web/views/fields/boolean_toggle/boolean_toggle_field");const BooleanToggleFieldLabeled=__exports.BooleanToggleFieldLabeled=class BooleanToggleFieldLabeled extends BooleanToggleField{static template="website_hr_recruitment.BooleanToggleFieldLabeled";static props={...BooleanToggleField.props,true_label:{type:String},false_label:{type:String},};setup(){super.setup(...arguments);useRecordObserver((record)=>{this.state.label=record.data[this.props.name]?this.props.true_label:this.props.false_label;});}
async onChange(newValue){super.onChange(...arguments);this.state.label=newValue?this.props.true_label:this.props.false_label;}}
const booleanToggleFieldLabeled=__exports.booleanToggleFieldLabeled={...booleanToggleField,component:BooleanToggleFieldLabeled,displayName:_t("ToggleLabeled"),supportedOptions:[{label:_t("Autosave"),name:"autosave",type:"boolean",default:true,help:_t("If checked, the record will be saved immediately when the field is modified."),},{label:_t("Label"),name:"true_label",type:"string",help:_t("A clickable label for the toggle. Contains text for the true state."),},{label:_t("Label"),name:"false_label",type:"string",help:_t("A clickable label for the toggle. Contains text for the false state."),},],extractProps({options},dynamicInfo){return{autosave:"autosave"in options?Boolean(options.autosave):true,readonly:dynamicInfo.readonly,true_label:_t(options.true_label),false_label:_t(options.false_label),};},};registry.category("fields").add("boolean_toggle_labeled",booleanToggleFieldLabeled);return __exports;});;

/* /stock_account/static/src/fields/boolean_confirm.js */
odoo.define('@stock_account/fields/boolean_confirm',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/hooks','@web/core/checkbox/checkbox','@web/core/confirmation_dialog/confirmation_dialog','@web/views/fields/boolean_toggle/boolean_toggle_field'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require('@web/core/registry');const{useService}=require("@web/core/utils/hooks");const{CheckBox}=require("@web/core/checkbox/checkbox");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{BooleanToggleField,booleanToggleField,}=require("@web/views/fields/boolean_toggle/boolean_toggle_field");const ConfirmCheckBox=__exports.ConfirmCheckBox=class ConfirmCheckBox extends CheckBox{onClick(ev){ev.preventDefault();if(ev.target.tagName!=="INPUT"){return;}
this.props.onChange(ev.target.checked);}}
const BooleanToggleConfirm=__exports.BooleanToggleConfirm=class BooleanToggleConfirm extends BooleanToggleField{static template="stock_account.BooleanToggleConfirm";static components={ConfirmCheckBox};setup(){super.setup();this.dialogService=useService('dialog');}
onChange(value){const record=this.props.record.data;const updateAndSave=()=>{this.props.record.update({[this.props.name]:value},{save:true});};if(record.lot_valuated&&!value){this.dialogService.add(ConfirmationDialog,{body:_t("This operation might lead in a loss of data. Valuation will be identical for all lots/SN. Do you want to proceed ? "),confirm:updateAndSave,cancel:()=>{},});}
else{updateAndSave();}}}
const booleanToggleConfirm=__exports.booleanToggleConfirm={...booleanToggleField,component:BooleanToggleConfirm,};registry.category("fields").add("confirm_boolean",booleanToggleConfirm);return __exports;});;

/* /stock_account/static/src/stock_account_forecasted/forecasted_header.js */
odoo.define('@stock_account/stock_account_forecasted/forecasted_header',['@web/core/l10n/translation','@web/core/utils/patch','@stock/stock_forecasted/forecasted_header'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{ForecastedHeader:Parent}=require("@stock/stock_forecasted/forecasted_header");const StockAccountForecastedHeader=__exports.StockAccountForecastedHeader=class StockAccountForecastedHeader extends Parent{static template="stock_account.ForecastedHeader";}
patch(Parent.prototype,{async _onClickValuation(){const context=this._getActionContext();return this.action.doAction({name:_t('Stock Valuation'),res_model:'stock.valuation.layer',type:'ir.actions.act_window',view_mode:'list,form',views:[[false,'list'],[false,'form']],target:'current',context:context,});}});return __exports;});;

/* /account_reports/static/src/components/account_report/account_report.js */
odoo.define('@account_reports/components/account_report/account_report',['@web/core/registry','@web/core/utils/hooks','@web/search/control_panel/control_panel','@odoo/owl','@account_reports/components/account_report/controller','@account_reports/components/account_report/buttons_bar/buttons_bar','@account_reports/components/account_report/cog_menu/cog_menu','@account_reports/components/account_report/ellipsis/ellipsis','@account_reports/components/account_report/filters/filters','@account_reports/components/account_report/header/header','@account_reports/components/account_report/line/line','@account_reports/components/account_report/line_cell/line_cell','@account_reports/components/account_report/line_name/line_name','@account_reports/components/account_report/search_bar/search_bar','@web/webclient/actions/action_service','@web/search/action_hook'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{ControlPanel}=require("@web/search/control_panel/control_panel");const{Component,onWillStart,useRef,useState,useSubEnv}=require("@odoo/owl");const{AccountReportController}=require("@account_reports/components/account_report/controller");const{AccountReportButtonsBar}=require("@account_reports/components/account_report/buttons_bar/buttons_bar");const{AccountReportCogMenu}=require("@account_reports/components/account_report/cog_menu/cog_menu");const{AccountReportEllipsis}=require("@account_reports/components/account_report/ellipsis/ellipsis");const{AccountReportFilters}=require("@account_reports/components/account_report/filters/filters");const{AccountReportHeader}=require("@account_reports/components/account_report/header/header");const{AccountReportLine}=require("@account_reports/components/account_report/line/line");const{AccountReportLineCell}=require("@account_reports/components/account_report/line_cell/line_cell");const{AccountReportLineName}=require("@account_reports/components/account_report/line_name/line_name");const{AccountReportSearchBar}=require("@account_reports/components/account_report/search_bar/search_bar");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");const{useSetupAction}=require("@web/search/action_hook");const AccountReport=__exports.AccountReport=class AccountReport extends Component{static template="account_reports.AccountReport";static props={...standardActionServiceProps};static components={ControlPanel,AccountReportButtonsBar,AccountReportCogMenu,AccountReportSearchBar,};static customizableComponents=[AccountReportEllipsis,AccountReportFilters,AccountReportHeader,AccountReportLine,AccountReportLineCell,AccountReportLineName,];static defaultComponentsMap=[];setup(){this.rootRef=useRef("root");useSetupAction({rootRef:this.rootRef,getLocalState:()=>{return{keep_journal_groups_options:true,};}})
if(this.props?.state?.keep_journal_groups_options!==undefined){this.props.action.keep_journal_groups_options=true;}
this.env.config.viewSwitcherEntries=[];this.orm=useService("orm");this.actionService=useService("action");this.controller=useState(new AccountReportController(this.props.action));this.initialQuery=this.props.action.context?.default_filter_accounts;for(const customizableComponent of AccountReport.customizableComponents)
AccountReport.defaultComponentsMap[customizableComponent.name]=customizableComponent;onWillStart(async()=>{await this.controller.load(this.env);});useSubEnv({controller:this.controller,component:this.getComponent.bind(this),template:this.getTemplate.bind(this),});}
static registerCustomComponent(customComponent){registry.category("account_reports_custom_components").add(customComponent.template,customComponent);}
get cssCustomClass(){return this.controller.data.custom_display.css_custom_class||"";}
getComponent(name){const customComponents=this.controller.data.custom_display.components;if(customComponents&&customComponents[name])
return registry.category("account_reports_custom_components").get(customComponents[name]);return AccountReport.defaultComponentsMap[name];}
getTemplate(name){const customTemplates=this.controller.data.custom_display.templates;if(customTemplates&&customTemplates[name])
return customTemplates[name];return`account_reports.${ name }Customizable`;}
get tableClasses(){let classes="";if(this.controller.options.columns.length>1){classes+=" striped";}
if(this.controller.options['horizontal_split'])
classes+=" w-50 mx-2";return classes;}}
registry.category("actions").add("account_report",AccountReport);return __exports;});;

/* /account_reports/static/src/components/account_report/buttons_bar/buttons_bar.js */
odoo.define('@account_reports/components/account_report/buttons_bar/buttons_bar',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const AccountReportButtonsBar=__exports.AccountReportButtonsBar=class AccountReportButtonsBar extends Component{static template="account_reports.AccountReportButtonsBar";static props={};setup(){this.controller=useState(this.env.controller);}
get barButtons(){const buttons=[];for(const button of this.controller.buttons){if(button.always_show){buttons.push(button);}}
return buttons;}}
return __exports;});;

/* /account_reports/static/src/components/account_report/cog_menu/cog_menu.js */
odoo.define('@account_reports/components/account_report/cog_menu/cog_menu',['@odoo/owl','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const AccountReportCogMenu=__exports.AccountReportCogMenu=class AccountReportCogMenu extends Component{static template="account_reports.AccountReportCogMenu";static components={Dropdown,DropdownItem};static props={};setup(){this.controller=useState(this.env.controller);}
get cogButtons(){const buttons=[];for(const button of this.controller.buttons){if(!button.always_show){buttons.push(button);}}
return buttons;}}
return __exports;});;

/* /account_reports/static/src/components/account_report/controller.js */
odoo.define('@account_reports/components/account_report/controller',['@web/core/browser/browser','@web/session','@web/core/utils/hooks','@account_reports/js/util'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{session}=require("@web/session");const{useService}=require("@web/core/utils/hooks");const{removeTaxGroupingFromLineId}=require("@account_reports/js/util");const AccountReportController=__exports.AccountReportController=class AccountReportController{constructor(action){this.action=action;this.actionService=useService("action");this.dialog=useService("dialog");this.orm=useService("orm");}
async load(env){this.env=env;this.reportOptionsMap={};this.reportInformationMap={};this.lastOpenedSectionByReport={};this.loadingCallNumberByCacheKey=new Proxy({},{get(target,name){return name in target?target[name]:0;},set(target,name,newValue){target[name]=newValue;return true;},});this.actionReportId=this.action.context.report_id;const isOpeningReport=!this.action?.keep_journal_groups_options
const mainReportOptions=await this.loadReportOptions(this.actionReportId,false,this.action.params?.ignore_session,isOpeningReport);const cacheKey=this.getCacheKey(mainReportOptions['sections_source_id'],mainReportOptions['report_id']);this.options=mainReportOptions;this.reportOptionsMap[cacheKey]=mainReportOptions;this.incrementCallNumber(cacheKey);this.options["loading_call_number"]=this.loadingCallNumberByCacheKey[cacheKey];this.saveSessionOptions(mainReportOptions);const activeSectionPromise=this.displayReport(mainReportOptions['report_id']);this.preLoadClosedSections();await activeSectionPromise;}
getCacheKey(sectionsSourceId,reportId){return`${sectionsSourceId}_${reportId}`}
incrementCallNumber(cacheKey=null){if(!cacheKey){cacheKey=this.getCacheKey(this.options['sections_source_id'],this.options['report_id']);}
this.loadingCallNumberByCacheKey[cacheKey]+=1;}
async displayReport(reportId){const cacheKey=await this.loadReport(reportId);const options=await this.reportOptionsMap[cacheKey];const informationMap=await this.reportInformationMap[cacheKey];if(options!==undefined&&this.loadingCallNumberByCacheKey[cacheKey]===options["loading_call_number"]&&(this.lastOpenedSectionByReport==={}||this.lastOpenedSectionByReport[options['selected_variant_id']]===options['selected_section_id'])){this.options=options;if(informationMap!==undefined){this.data=informationMap;if(this.areLinesOrdered()){await this.sortLines();}
this.setLineVisibility(this.lines);this.refreshVisibleAnnotations();this.saveSessionOptions(this.options);}}}
async reload(optionPath,newOptions){const rootOptionKey=optionPath?optionPath.split(".")[0]:"";for(const[cacheKey,cachedOptionsPromise]of Object.entries(this.reportOptionsMap)){let cachedOptions=await cachedOptionsPromise;if(rootOptionKey===""||cachedOptions.hasOwnProperty(rootOptionKey)){delete this.reportOptionsMap[cacheKey];delete this.reportInformationMap[cacheKey];}}
this.saveSessionOptions(newOptions);await this.displayReport(newOptions['report_id']);}
async preLoadClosedSections(){let sectionLoaded=false;for(const section of this.options['sections']){const cacheKey=this.getCacheKey(this.options['sections_source_id'],section.id);if(section.id!=this.options['report_id']&&!this.reportInformationMap[cacheKey]){await this.loadReport(section.id,true);sectionLoaded=true;break;}}
let nextCallDelay=(sectionLoaded)?100:1000;const self=this;setTimeout(()=>self.preLoadClosedSections(),nextCallDelay);}
async loadReport(reportId,preloading=false){const options=await this.loadReportOptions(reportId,preloading,false);const reportToDisplayId=options['report_id'];const cacheKey=this.getCacheKey(options['sections_source_id'],reportToDisplayId)
if(!this.reportInformationMap[cacheKey]){this.reportInformationMap[cacheKey]=this.orm.call("account.report",options.readonly_query?"get_report_information_readonly":"get_report_information",[reportToDisplayId,options,],{context:this.action.context,},);}
await this.reportInformationMap[cacheKey];if(!preloading){if(options['sections'].length)
this.lastOpenedSectionByReport[options['sections_source_id']]=options['selected_section_id'];}
return cacheKey;}
async loadReportOptions(reportId,preloading=false,ignore_session=false,isOpeningReport=false){const loadOptions=(ignore_session||!this.hasSessionOptions())?(this.action.params?.options||{}):this.sessionOptions();const cacheKey=this.getCacheKey(loadOptions['sections_source_id']||reportId,reportId);if(!(cacheKey in this.loadingCallNumberByCacheKey)){this.incrementCallNumber(cacheKey);}
loadOptions["loading_call_number"]=this.loadingCallNumberByCacheKey[cacheKey];loadOptions["is_opening_report"]=isOpeningReport;if(!this.reportOptionsMap[cacheKey]){if(preloading)
loadOptions['selected_section_id']=reportId;else{if(this.lastOpenedSectionByReport[reportId])
loadOptions['selected_section_id']=this.lastOpenedSectionByReport[reportId];}
this.reportOptionsMap[cacheKey]=this.orm.call("account.report","get_options",[reportId,loadOptions,],{context:this.action.context,},);let reportOptions=await this.reportOptionsMap[cacheKey];const loadedOptionsCacheKey=this.getCacheKey(reportOptions['sections_source_id'],reportOptions['report_id']);if(loadedOptionsCacheKey!==cacheKey){delete this.reportOptionsMap[cacheKey];this.reportOptionsMap[loadedOptionsCacheKey]=reportOptions;this.loadingCallNumberByCacheKey[loadedOptionsCacheKey]=1;delete this.loadingCallNumberByCacheKey[cacheKey];return reportOptions;}}
return this.reportOptionsMap[cacheKey];}
get buttons(){return this.options.buttons;}
get caretOptions(){return this.data.caret_options;}
get columnHeadersRenderData(){return this.data.column_headers_render_data;}
get columnGroupsTotals(){return this.data.column_groups_totals;}
get context(){return this.data.context;}
get filters(){return this.data.filters;}
get annotations(){return this.data.annotations;}
get groups(){return this.data.groups;}
get lines(){return this.data.lines;}
get warnings(){return this.data.warnings;}
get linesOrder(){return this.data.lines_order;}
get report(){return this.data.report;}
get visibleAnnotations(){return this.data.visible_annotations;}
set annotations(value){this.data.annotations=value;}
set columnGroupsTotals(value){this.data.column_groups_totals=value;}
set lines(value){this.data.lines=value;this.setLineVisibility(this.lines);}
set linesOrder(value){this.data.lines_order=value;}
set visibleAnnotations(value){this.data.visible_annotations=value;}
get needsColumnPercentComparison(){return this.options.column_percent_comparison==="growth";}
get hasCustomSubheaders(){return this.columnHeadersRenderData.custom_subheaders.length>0;}
get hasDebugColumn(){return Boolean(this.options.show_debug_column);}
get hasStringDate(){return"date"in this.options&&"string"in this.options.date;}
get hasVisibleAnnotations(){return Boolean(this.visibleAnnotations.length);}
async _updateOption(operationType,optionPath,optionValue=null,reloadUI=false){const optionKeys=optionPath.split(".");let currentOptionKey=null;let option=this.options;while(optionKeys.length>1){currentOptionKey=optionKeys.shift();option=option[currentOptionKey];if(option===undefined)
throw new Error(`Invalid option key in _updateOption(): ${ currentOptionKey } (${ optionPath })`);}
switch(operationType){case"update":option[optionKeys[0]]=optionValue;break;case"delete":delete option[optionKeys[0]];break;case"toggle":option[optionKeys[0]]=!option[optionKeys[0]];break;default:throw new Error(`Invalid operation type in _updateOption(): ${ operationType }`);}
if(reloadUI){this.incrementCallNumber();await this.reload(optionPath,this.options);}}
async updateOption(optionPath,optionValue,reloadUI=false){await this._updateOption('update',optionPath,optionValue,reloadUI);}
async deleteOption(optionPath,reloadUI=false){await this._updateOption('delete',optionPath,null,reloadUI);}
async toggleOption(optionPath,reloadUI=false){await this._updateOption('toggle',optionPath,null,reloadUI);}
async switchToSection(reportId){this.saveSessionOptions({...this.options,'selected_section_id':reportId});this.displayReport(reportId);}
sessionOptionsID(){return`account.report:${ this.actionReportId }:${ session.user_companies.current_company }`;}
hasSessionOptions(){return Boolean(browser.sessionStorage.getItem(this.sessionOptionsID()))}
saveSessionOptions(options){browser.sessionStorage.setItem(this.sessionOptionsID(),JSON.stringify(options));}
sessionOptions(){return JSON.parse(browser.sessionStorage.getItem(this.sessionOptionsID()));}
lineHasDebugData(lineIndex){return'debug_popup_data'in this.lines[lineIndex];}
lineHasGrowthComparisonData(lineIndex){return Boolean(this.lines[lineIndex].column_percent_comparison_data);}
isLineAncestorOf(ancestorLineId,lineId){return lineId.startsWith(`${ancestorLineId}|`);}
isLineChildOf(childLineId,lineId){return childLineId.startsWith(`${lineId}|`);}
isLineRelatedTo(relatedLineId,lineId){return this.isLineAncestorOf(relatedLineId,lineId)||this.isLineChildOf(relatedLineId,lineId);}
isNextLineChild(index,lineId){return index<this.lines.length&&this.lines[index].id.startsWith(`${lineId}|`);}
isNextLineDirectChild(index,lineId){return index<this.lines.length&&this.lines[index].parent_id===lineId;}
isTotalLine(lineIndex){return this.lines[lineIndex].id.includes("|total~~");}
isLoadMoreLine(lineIndex){return this.lines[lineIndex].id.includes("|load_more~~");}
isLoadedLine(lineIndex){const lineID=this.lines[lineIndex].id;const nextLineIndex=lineIndex+1;return this.isNextLineChild(nextLineIndex,lineID)&&!this.isTotalLine(nextLineIndex)&&!this.isLoadMoreLine(nextLineIndex);}
async replaceLineWith(replaceIndex,newLines){await this.insertLines(replaceIndex,1,newLines);}
async insertLinesAfter(insertIndex,newLines){await this.insertLines(insertIndex+1,0,newLines);}
async insertLines(lineIndex,deleteCount,newLines){this.lines.splice(lineIndex,deleteCount,...newLines);}
async unfoldLoadedLine(lineIndex){const lineId=this.lines[lineIndex].id;let nextLineIndex=lineIndex+1;while(this.isNextLineChild(nextLineIndex,lineId)){if(this.isNextLineDirectChild(nextLineIndex,lineId)){const nextLine=this.lines[nextLineIndex];nextLine.visible=true;if(!nextLine.unfoldable&&this.isNextLineChild(nextLineIndex+1,nextLine.id)){await this.unfoldLine(nextLineIndex);}}
nextLineIndex+=1;}
return nextLineIndex;}
async unfoldNewLine(lineIndex){const options=await this.options;const newLines=await this.orm.call("account.report",options.readonly_query?"get_expanded_lines_readonly":"get_expanded_lines",[this.options['report_id'],this.options,this.lines[lineIndex].id,this.lines[lineIndex].groupby,this.lines[lineIndex].expand_function,this.lines[lineIndex].progress,0,this.lines[lineIndex].horizontal_split_side,],);if(this.areLinesOrdered()){this.updateLinesOrderIndexes(lineIndex,newLines,false)}
this.insertLinesAfter(lineIndex,newLines);const totalIndex=lineIndex+newLines.length+1;if(this.filters.show_totals&&this.lines[totalIndex]&&this.isTotalLine(totalIndex))
this.lines[totalIndex].visible=true;this.options.unfolded_lines.push(...newLines.filter(line=>line.unfolded).map(({id})=>id));this.saveSessionOptions(this.options);return totalIndex}
updateLinesOrderIndexes(lineIndex,newLines,replaceLine){let unfoldedLineIndex;const offset=replaceLine?0:1;for(const[lineOrderIndex,lineOrderValue]of Object.entries(this.linesOrder)){if(lineOrderValue>lineIndex){this.linesOrder[lineOrderIndex]+=newLines.length-replaceLine;}
if(lineOrderValue===lineIndex){unfoldedLineIndex=parseInt(lineOrderIndex)}}
const arrayOfNewIndex=Array.from({length:newLines.length},(dummy,index)=>this.linesOrder[unfoldedLineIndex]+index+offset);this.linesOrder.splice(unfoldedLineIndex+offset,replaceLine,...arrayOfNewIndex);}
async unfoldLine(lineIndex){const targetLine=this.lines[lineIndex];let lastLineIndex=lineIndex+1;if(this.isLoadedLine(lineIndex))
lastLineIndex=await this.unfoldLoadedLine(lineIndex);else if(targetLine.expand_function){lastLineIndex=await this.unfoldNewLine(lineIndex);}
this.setLineVisibility(this.lines.slice(lineIndex+1,lastLineIndex));targetLine.unfolded=true;this.refreshVisibleAnnotations();if(!this.options.unfolded_lines.includes(targetLine.id))
this.options.unfolded_lines.push(targetLine.id);this.saveSessionOptions(this.options);}
foldLine(lineIndex){const targetLine=this.lines[lineIndex];let foldedLinesIDs=new Set([targetLine.id]);let nextLineIndex=lineIndex+1;while(this.isNextLineChild(nextLineIndex,targetLine.id)){this.lines[nextLineIndex].unfolded=false;this.lines[nextLineIndex].visible=false;foldedLinesIDs.add(this.lines[nextLineIndex].id);nextLineIndex+=1;}
targetLine.unfolded=false;this.refreshVisibleAnnotations();this.options.unfolded_lines=this.options.unfolded_lines.filter(unfoldedLineID=>!foldedLinesIDs.has(unfoldedLineID));this.saveSessionOptions(this.options);}
linesCurrentOrderByColumn(columnIndex){if(this.areLinesOrderedByColumn(columnIndex))
return this.options.order_column.direction;return"default";}
areLinesOrdered(){return this.linesOrder!=null&&this.options.order_column!=null;}
areLinesOrderedByColumn(columnIndex){return this.areLinesOrdered()&&this.options.order_column.expression_label===this.options.columns[columnIndex].expression_label;}
async sortLinesByColumnAsc(columnIndex){this.options.order_column={expression_label:this.options.columns[columnIndex].expression_label,direction:"ASC",};await this.sortLines();this.saveSessionOptions(this.options);}
async sortLinesByColumnDesc(columnIndex){this.options.order_column={expression_label:this.options.columns[columnIndex].expression_label,direction:"DESC",};await this.sortLines();this.saveSessionOptions(this.options);}
sortLinesByDefault(){delete this.options.order_column;delete this.data.lines_order;this.saveSessionOptions(this.options);}
async sortLines(){this.linesOrder=await this.orm.call("account.report","sort_lines",[this.lines,this.options,true,],{context:this.action.context,},);}
async refreshAnnotations(){this.annotations=await this.orm.call("account.report","get_annotations",[this.action.context.report_id,this.options,]);this.refreshVisibleAnnotations();}
refreshVisibleAnnotations(){const visibleAnnotations=new Proxy({},{get(target,name){return name in target?target[name]:[];},set(target,name,newValue){target[name]=newValue;return true;},});this.lines.forEach((line)=>{line["visible_annotations"]=[];const lineWithoutTaxGrouping=removeTaxGroupingFromLineId(line.id);if(line.visible&&this.annotations[lineWithoutTaxGrouping]){for(const index in this.annotations[lineWithoutTaxGrouping]){const annotation=this.annotations[lineWithoutTaxGrouping][index];visibleAnnotations[lineWithoutTaxGrouping]=[...visibleAnnotations[lineWithoutTaxGrouping],{...annotation},];line["visible_annotations"].push({...annotation,});}}
if(line.visible_annotations&&(!this.annotations[lineWithoutTaxGrouping]||!line.visible)){delete line.visible_annotations;}});this.visibleAnnotations=visibleAnnotations;}
setLineVisibility(linesToAssign){let needHidingChildren=new Set();linesToAssign.forEach((line)=>{line.visible=!needHidingChildren.has(line.parent_id);if(!line.visible||(line.unfoldable&!line.unfolded))
needHidingChildren.add(line.id);});if(this.options.hide_0_lines){this.hideZeroLines(linesToAssign);}}
hideZeroLines(lines){const hasVisibleChildren=new Set();const reversed_lines=[...lines].reverse()
const number_figure_types=['integer','float','monetary','percentage'];reversed_lines.forEach((line)=>{const isZero=line.columns.every(column=>!number_figure_types.includes(column.figure_type)||column.is_zero);if(!hasVisibleChildren.has(line.id)&&isZero){line.visible=false;}
if(line.parent_id&&line.visible){hasVisibleChildren.add(line.parent_id);}})}
buttonAction(ev,button){this.reportAction(ev,button.error_action||button.action,button.action_param,true);}
async reportAction(ev,action,actionParam=null,callOnSectionsSource=false,actionContext=null){ev?.preventDefault();ev?.stopPropagation();let actionOptions=this.options;if(callOnSectionsSource){const allUnfoldedLines=this.options.sections.length?[]:[...this.options['unfolded_lines']]
for(const sectionData of this.options['sections']){const cacheKey=this.getCacheKey(this.options['sections_source_id'],sectionData['id']);const sectionOptions=await this.reportOptionsMap[cacheKey];if(sectionOptions)
allUnfoldedLines.push(...sectionOptions['unfolded_lines']);}
actionOptions={...this.options,unfolded_lines:allUnfoldedLines};}
const dispatchReportAction=await this.orm.call("account.report","dispatch_report_action",[this.options['report_id'],actionOptions,action,actionParam,callOnSectionsSource,],{context:Object.assign({},this.context,actionContext)});if(dispatchReportAction?.help){dispatchReportAction.help=owl.markup(dispatchReportAction.help)}
return dispatchReportAction?this.actionService.doAction(dispatchReportAction):null;}
async openBudget(budget){this.actionService.doAction({type:"ir.actions.act_window",res_model:"account.report.budget",res_id:budget.id,views:[[false,"form"]],});}}
return __exports;});;

/* /account_reports/static/src/components/account_report/ellipsis/ellipsis.js */
odoo.define('@account_reports/components/account_report/ellipsis/ellipsis',['@web/core/l10n/translation','@web/core/l10n/localization','@web/core/utils/hooks','@odoo/owl','@account_reports/components/account_report/ellipsis/popover/ellipsis_popover'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{localization}=require("@web/core/l10n/localization");const{useService}=require("@web/core/utils/hooks");const{Component,useState}=require("@odoo/owl");const{AccountReportEllipsisPopover}=require("@account_reports/components/account_report/ellipsis/popover/ellipsis_popover");const AccountReportEllipsis=__exports.AccountReportEllipsis=class AccountReportEllipsis extends Component{static template="account_reports.AccountReportEllipsis";static props={name:{type:String,optional:true},no_format:{optional:true},type:{type:String,optional:true},maxCharacters:Number,};setup(){this.popover=useService("popover");this.notification=useService("notification");this.controller=useState(this.env.controller);}
get triggersEllipsis(){if(this.props.name)
return this.props.name.length>this.props.maxCharacters;return false;}
copyEllipsisText(){navigator.clipboard.writeText(this.props.name);this.notification.add(_t("Text copied"),{type:'success'});this.popoverCloseFn();this.popoverCloseFn=null;}
showEllipsisPopover(ev){ev.preventDefault();ev.stopPropagation();if(this.popoverCloseFn){this.popoverCloseFn();this.popoverCloseFn=null;}
this.popoverCloseFn=this.popover.add(ev.currentTarget,AccountReportEllipsisPopover,{name:this.props.name,copyEllipsisText:this.copyEllipsisText.bind(this),},{closeOnClickAway:true,position:localization.direction==="rtl"?"left":"right",},);}}
return __exports;});;

/* /account_reports/static/src/components/account_report/ellipsis/popover/ellipsis_popover.js */
odoo.define('@account_reports/components/account_report/ellipsis/popover/ellipsis_popover',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const AccountReportEllipsisPopover=__exports.AccountReportEllipsisPopover=class AccountReportEllipsisPopover extends Component{static template="account_reports.AccountReportEllipsisPopover";static props={close:Function,name:String,copyEllipsisText:Function,};}
return __exports;});;

/* /account_reports/static/src/components/account_report/filters/filters.js */
odoo.define('@account_reports/components/account_report/filters/filters',['@web/core/l10n/translation','@odoo/owl','@web/core/utils/hooks','@web/core/errors/error_dialogs','@web/core/datetime/datetime_input','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/record_selectors/multi_record_selector','@web/core/l10n/dates'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{WarningDialog}=require("@web/core/errors/error_dialogs");const{DateTimeInput}=require('@web/core/datetime/datetime_input');const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{MultiRecordSelector}=require("@web/core/record_selectors/multi_record_selector");const{formatDate}=require("@web/core/l10n/dates");const{DateTime}=luxon;const AccountReportFilters=__exports.AccountReportFilters=class AccountReportFilters extends Component{static template="account_reports.AccountReportFilters";static props={};static components={DateTimeInput,Dropdown,DropdownItem,MultiRecordSelector,};setup(){this.dialog=useService("dialog");this.orm=useService("orm");this.notification=useService("notification");this.companyService=useService("company");this.controller=useState(this.env.controller);if(this.env.controller.options.date){this.dateFilter=useState(this.initDateFilters());}
this.budgetName=useState({value:"",invalid:false,});this.timeout=null;}
focusInnerInput(index,items){const selectedItem=items[index];selectedItem.el.querySelector(":scope input")?.focus();}
get selectedFiscalPositionName(){switch(this.controller.options.fiscal_position){case"domestic":return _t("Domestic");case"all":return _t("All");default:for(const fiscalPosition of this.controller.options.available_vat_fiscal_positions){if(fiscalPosition.id===this.controller.options.fiscal_position){return fiscalPosition.name;}}}
return _t("None");}
get selectedHorizontalGroupName(){for(const horizontalGroup of this.controller.options.available_horizontal_groups){if(horizontalGroup.id===this.controller.options.selected_horizontal_group_id){return horizontalGroup.name;}}
return _t("None");}
get isHorizontalGroupSelected(){return this.controller.options.available_horizontal_groups.some((group)=>{return group.id===this.controller.options.selected_horizontal_group_id;});}
get selectedTaxUnitName(){for(const taxUnit of this.controller.options.available_tax_units){if(taxUnit.id===this.controller.options.tax_unit){return taxUnit.name;}}
return _t("Company Only");}
get selectedVariantName(){for(const variant of this.controller.options.available_variants){if(variant.id===this.controller.options.selected_variant_id){return variant.name;}}
return _t("None");}
get selectedSectionName(){for(const section of this.controller.options.sections)
if(section.id===this.controller.options.selected_section_id)
return section.name;}
get selectedAccountType(){let selectedAccountType=this.controller.options.account_type.filter((accountType)=>accountType.selected,);if(!selectedAccountType.length||selectedAccountType.length===this.controller.options.account_type.length){return _t("All");}
const accountTypeMappings=[{list:["trade_receivable","non_trade_receivable"],name:_t("All Receivable")},{list:["trade_payable","non_trade_payable"],name:_t("All Payable")},{list:["trade_receivable","trade_payable"],name:_t("Trade Partners")},{list:["non_trade_receivable","non_trade_payable"],name:_t("Non Trade Partners")},];const listToDisplay=[];for(const mapping of accountTypeMappings){if(mapping.list.every((accountType)=>selectedAccountType.map((accountType)=>accountType.id).includes(accountType),)){listToDisplay.push(mapping.name);selectedAccountType=selectedAccountType.filter((accountType)=>!mapping.list.includes(accountType.id),);}}
return listToDisplay.concat(selectedAccountType.map((accountType)=>accountType.name)).join(", ");}
get selectedAmlIrFilters(){const selectedFilters=this.controller.options.aml_ir_filters.filter((irFilter)=>irFilter.selected,);if(selectedFilters.length===1){return selectedFilters[0].name;}else if(selectedFilters.length>1){return _t("%s selected",selectedFilters.length);}else{return _t("None");}}
get availablePeriodOrder(){return{descending:_t("Descending"),ascending:_t("Ascending")};}
get periodOrder(){return this.controller.options.comparison.period_order==="descending"?_t("Descending"):_t("Ascending");}
get selectedExtraOptions(){const selectedExtraOptions=[];if(this.controller.groups.account_readonly&&this.controller.filters.show_draft){selectedExtraOptions.push(this.controller.options.all_entries?_t("With Draft Entries"):_t("Posted Entries"),);}
if(this.controller.filters.show_unreconciled&&this.controller.options.unreconciled){selectedExtraOptions.push(_t("Unreconciled Entries"));}
if(this.controller.options.include_analytic_without_aml){selectedExtraOptions.push(_t("Including Analytic Simulations"));}
return selectedExtraOptions.join(", ");}
get dropdownProps(){return{shouldFocusChildInput:false,hotkeys:{arrowright:(index,items)=>this.focusInnerInput(index,items),},};}
get periodLabel(){return this.controller.options.comparison.number_period>1?_t("Periods"):_t("Period");}
get hasAnalyticGroupbyFilter(){return Boolean(this.controller.groups.analytic_accounting)&&(Boolean(this.controller.filters.show_analytic_groupby)||Boolean(this.controller.filters.show_analytic_plan_groupby));}
get hasCodesFilter(){return Boolean(this.controller.options.sales_report_taxes?.operation_category?.goods);}
get hasExtraOptionsFilter(){return("report_cash_basis"in this.controller.options||this.controller.filters.show_draft||this.controller.filters.show_all||this.controller.filters.show_unreconciled||this.hasUIFilter);}
get hasUIFilter(){return(this.controller.filters.show_hide_0_lines!=="never"||"horizontal_split"in this.controller.options);}
get hasFiscalPositionFilter(){const isMultiCompany=this.controller.options.companies.length>1;const minimumFiscalPosition=this.controller.options.allow_domestic?0:1;const hasFiscalPositions=this.controller.options.available_vat_fiscal_positions.length>minimumFiscalPosition;return hasFiscalPositions&&isMultiCompany;}
get isBudgetSelected(){return this.controller.options.budgets?.some((budget)=>{return budget.selected;});}
dateFrom(optionKey){return DateTime.fromISO(this.controller.options[optionKey].date_from);}
dateTo(optionKey){return DateTime.fromISO(this.controller.options[optionKey].date_to);}
setDate(optionKey,type,date){if(date){this.controller.options[optionKey][`date_${type}`]=date;this.applyFilters(optionKey);}
else{this.dialog.add(WarningDialog,{title:_t("Odoo Warning"),message:_t("Date cannot be empty"),});}}
setDateFrom(optionKey,dateFrom){this.setDate(optionKey,'from',dateFrom);}
setDateTo(optionKey,dateTo){this.setDate(optionKey,'to',dateTo);}
dateFilters(mode){switch(mode){case"single":return[{"name":_t("End of Month"),"period":"month"},{"name":_t("End of Quarter"),"period":"quarter"},{"name":_t("End of Year"),"period":"year"},];case"range":return[{"name":_t("Month"),"period":"month"},{"name":_t("Quarter"),"period":"quarter"},{"name":_t("Year"),"period":"year"},];default:throw new Error(`Invalid mode in dateFilters(): ${ mode }`);}}
initDateFilters(){const filters={"month":0,"quarter":0,"year":0,"tax_period":0};const specifier=this.controller.options.date.filter.split('_')[0];const periodType=this.controller.options.date.period_type;const period=periodType==="fiscalyear"?"year":periodType;filters[period]=this.controller.options.date.period||(specifier==='previous'?-1:specifier==='next'?1:0);return filters;}
getDateFilter(periodType){if(this.dateFilter[periodType]>0){return`next_${periodType}`;}else if(this.dateFilter[periodType]===0){return`this_${periodType}`;}else{return`previous_${periodType}`;}}
selectDateFilter(periodType,reload=false){this.filterClicked({optionKey:"date.filter",optionValue:this.getDateFilter(periodType)});this.filterClicked({optionKey:"date.period",optionValue:this.dateFilter[periodType],reload:reload});}
selectPreviousPeriod(periodType){this._changePeriod(periodType,-1);}
selectNextPeriod(periodType){this._changePeriod(periodType,1);}
_changePeriod(periodType,increment){this.dateFilter[periodType]=this.dateFilter[periodType]+increment;this.controller.updateOption("date.filter",this.getDateFilter(periodType));this.controller.updateOption("date.period",this.dateFilter[periodType]);this.applyFilters("date.period");}
isPeriodSelected(periodType){return this.controller.options.date.filter.includes(periodType)}
displayPeriod(periodType){const dateTo=DateTime.now();switch(periodType){case"month":return this._displayMonth(dateTo);case"quarter":return this._displayQuarter(dateTo);case"year":return this._displayYear(dateTo);case"tax_period":return this._displayTaxPeriod(dateTo);default:throw new Error(`Invalid period type in displayPeriod(): ${ periodType }`);}}
_displayMonth(dateTo){return dateTo.plus({months:this.dateFilter.month}).toFormat("MMMM yyyy");}
_displayQuarter(dateTo){const quarterMonths={1:{'start':1,'end':3},2:{'start':4,'end':6},3:{'start':7,'end':9},4:{'start':10,'end':12},}
dateTo=dateTo.plus({months:this.dateFilter.quarter*3});const quarterDateFrom=DateTime.utc(dateTo.year,quarterMonths[dateTo.quarter]['start'],1)
const quarterDateTo=DateTime.utc(dateTo.year,quarterMonths[dateTo.quarter]['end'],1)
return`${ formatDate(quarterDateFrom, {format: "MMM"}) } - ${ formatDate(quarterDateTo, {format: "MMM yyyy"}) }`;}
_displayYear(dateTo){return dateTo.plus({years:this.dateFilter.year}).toFormat("yyyy");}
_displayTaxPeriod(dateTo){const periodicitySettings=this.controller.options.tax_periodicity;const targetDateInPeriod=dateTo.plus({months:periodicitySettings.months_per_period*this.dateFilter['tax_period']})
const[start,end]=this._computeTaxPeriodDates(periodicitySettings,targetDateInPeriod);if(periodicitySettings.start_month==1&&periodicitySettings.start_day==1){switch(periodicitySettings.months_per_period){case 1:return end.toFormat("MMMM yyyy");case 3:return`Q${end.quarter} ${dateTo.year}`;case 12:return end.toFormat("yyyy");}}
return formatDate(start)+' - '+formatDate(end);}
_computeTaxPeriodDates(periodicitySettings,dateInsideTargettesPeriod){const startMonth=periodicitySettings.start_month;const startDay=periodicitySettings.start_day
const monthsPerPeriod=periodicitySettings.months_per_period;const aligned_date=dateInsideTargettesPeriod.minus({days:startDay-1})
let year=aligned_date.year;const monthOffset=aligned_date.month-startMonth;let periodNumber=Math.floor(monthOffset/monthsPerPeriod)+1;if(dateInsideTargettesPeriod<DateTime.now().set({year:year,month:startMonth,day:startDay})){year-=1;periodNumber=Math.floor((12+monthOffset)/monthsPerPeriod)+1;}
let deltaMonth=periodNumber*monthsPerPeriod;const endDate=DateTime.utc(year,startMonth,1).plus({months:deltaMonth,days:startDay-2})
const startDate=DateTime.utc(year,startMonth,1).plus({months:deltaMonth-monthsPerPeriod}).set({day:startDay})
return[startDate,endDate];}
setNumberPeriods(ev){const numberPeriods=ev.target.value;if(numberPeriods>=1)
this.controller.options.comparison.number_period=parseInt(numberPeriods);else
this.dialog.add(WarningDialog,{title:_t("Odoo Warning"),message:_t("Number of periods cannot be smaller than 1"),});}
getMultiRecordSelectorProps(resModel,optionKey){return{resModel,resIds:this.controller.options[optionKey],update:(resIds)=>{this.filterClicked({optionKey:optionKey,optionValue:resIds,reload:true});},};}
roundingUnitName(roundingUnit){return _t("In %s",this.controller.options["rounding_unit_names"][roundingUnit][0]);}
async filterClicked({optionKey,optionValue=undefined,reload=false}){if(optionValue!==undefined){await this.controller.updateOption(optionKey,optionValue);}else{await this.controller.toggleOption(optionKey);}
if(reload){await this.applyFilters(optionKey);}}
async applyFilters(optionKey=null,delay=500){if(this.timeout){clearTimeout(this.timeout);}
this.controller.incrementCallNumber();this.timeout=setTimeout(async()=>{await this.controller.reload(optionKey,this.controller.options);},delay);}
selectJournal(journal){if(journal.model==="account.journal.group"){const wasSelected=journal.selected;this.ToggleSelectedJournal(journal);this.controller.options.__journal_group_action={action:wasSelected?"remove":"add",id:parseInt(journal.id),};journal.selected=!wasSelected;}else{journal.selected=!journal.selected;}
this.applyFilters("journals");}
ToggleSelectedJournal(selectedJournal){if(selectedJournal.selected){this.controller.options.journals.forEach((journal)=>{journal.selected=false;});}else{this.controller.options.journals.forEach((journal)=>{journal.selected=selectedJournal.journals.includes(journal.id)&&journal.model==="account.journal";});}}
unfoldCompanyJournals(selectedCompany){let inSelectedCompanySection=false;for(const journal of this.controller.options.journals){if(journal.id==="divider"&&journal.model==="res.company"){if(journal.name===selectedCompany.name){journal.unfolded=!journal.unfolded;inSelectedCompanySection=true;}else if(inSelectedCompanySection){break;}}
if(inSelectedCompanySection&&journal.model==="account.journal"){journal.visible=!journal.visible;}}}
async filterVariant(reportId){this.controller.saveSessionOptions({...this.controller.options,selected_variant_id:reportId,sections_source_id:reportId,});const cacheKey=this.controller.getCacheKey(reportId,reportId);if(!(cacheKey in this.controller.loadingCallNumberByCacheKey)){this.controller.incrementCallNumber(cacheKey);}
await this.controller.displayReport(reportId);}
async filterTaxUnit(taxUnit){await this.filterClicked({optionKey:"tax_unit",optionValue:taxUnit.id});this.controller.saveSessionOptions(this.controller.options);this.companyService.setCompanies(taxUnit.company_ids);}
async toggleHideZeroLines(){await this.controller.toggleOption("hide_0_lines",false);this.controller.saveSessionOptions(this.controller.options);this.controller.setLineVisibility(this.controller.lines);}
async toggleHorizontalSplit(){await this.controller.toggleOption("horizontal_split",false);this.controller.saveSessionOptions(this.controller.options);}
async filterRoundingUnit(rounding){await this.controller.updateOption('rounding_unit',rounding,false);this.controller.saveSessionOptions(this.controller.options);this.controller.lines=await this.controller.orm.call("account.report","format_column_values",[this.controller.options,this.controller.lines,],);}
async selectHorizontalGroup(horizontalGroupId){if(horizontalGroupId===this.controller.options.selected_horizontal_group_id){return;}
if(this.isBudgetSelected){this.notification.add(_t("It's not possible to select a budget with the horizontal group feature."),{type:"warning",});return;}
await this.filterClicked({optionKey:"selected_horizontal_group_id",optionValue:horizontalGroupId,reload:true});}
selectBudget(budget){if(this.isHorizontalGroupSelected){this.notification.add(_t("It's not possible to select a horizontal group with the budget feature."),{type:"warning",});return;}
budget.selected=!budget.selected;this.applyFilters('budgets')}
async createBudget(){const budgetName=this.budgetName.value.trim();if(!budgetName.length){this.budgetName.invalid=true;this.notification.add(_t("Please enter a valid budget name."),{type:"danger",});return;}
const createdId=await this.orm.call("account.report.budget","create",[{name:budgetName},]);this.budgetName.value="";this.budgetName.invalid=false;const options=this.controller.options;this.controller.reload("budgets",{...options,budgets:[...options.budgets,{id:createdId,selected:!this.isHorizontalGroupSelected},],});}}
return __exports;});;

/* /account_reports/static/src/components/account_report/header/header.js */
odoo.define('@account_reports/components/account_report/header/header',['@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{useService}=require("@web/core/utils/hooks")
const{Component,useState}=require("@odoo/owl");const AccountReportHeader=__exports.AccountReportHeader=class AccountReportHeader extends Component{static template="account_reports.AccountReportHeader";static props={};static components={Dropdown,DropdownItem,}
setup(){this.orm=useService("orm");this.controller=useState(this.env.controller);}
get columnHeaders(){let columnHeaders=[];this.controller.options.column_headers.forEach((columnHeader,columnHeaderIndex)=>{let columnHeadersRow=[];for(let i=0;i<this.controller.columnHeadersRenderData.level_repetitions[columnHeaderIndex];i++){columnHeadersRow=[...columnHeadersRow,...columnHeader];}
columnHeaders.push(columnHeadersRow);});return columnHeaders;}
columnHeadersColspan(column_index,header,compactOffset=0){let colspan=header.colspan||this.controller.columnHeadersRenderData.level_colspan[column_index]
if(this.controller.options.show_horizontal_group_total&&column_index===0){colspan+=1;}
return colspan;}
get subheaders(){const columns=JSON.parse(JSON.stringify(this.controller.options.columns));const columnsPerGroupKey={};columns.forEach((column)=>{columnsPerGroupKey[`${column.column_group_key}_${column.expression_label}`]=column;});return this.controller.lines[0].columns.map((column)=>{if(columnsPerGroupKey[`${column.column_group_key}_${column.expression_label}`]){return columnsPerGroupKey[`${column.column_group_key}_${column.expression_label}`];}else{return{expression_label:"",sortable:false,name:"",colspan:1,};}});}
get customSubheaders(){let customSubheaders=[];this.controller.columnHeadersRenderData.custom_subheaders.forEach(customSubheader=>{customSubheaders.push(customSubheader);});return customSubheaders;}
sortableClasses(columIndex){switch(this.controller.linesCurrentOrderByColumn(columIndex)){case"ASC":return"fa fa-long-arrow-up";case"DESC":return"fa fa-long-arrow-down";default:return"fa fa-arrows-v";}}
async sortLinesByColumn(columnIndex,column){if(column.sortable){switch(this.controller.linesCurrentOrderByColumn(columnIndex)){case"default":await this.controller.sortLinesByColumnAsc(columnIndex);break;case"ASC":await this.controller.sortLinesByColumnDesc(columnIndex);break;case"DESC":this.controller.sortLinesByDefault();break;default:throw new Error(`Invalid value: ${ this.controller.linesCurrentOrderByColumn(columnIndex) }`);}}}}
return __exports;});;

/* /account_reports/static/src/components/account_report/line/line.js */
odoo.define('@account_reports/components/account_report/line/line',['@web/core/l10n/localization','@web/core/utils/hooks','@odoo/owl','@account_reports/components/account_report/line/popover/debug_popover','@account_reports/components/account_report/line_cell_editable/line_cell_editable'],function(require){'use strict';let __exports={};const{localization}=require("@web/core/l10n/localization");const{useService}=require("@web/core/utils/hooks");const{Component,useState}=require("@odoo/owl");const{AccountReportDebugPopover}=require("@account_reports/components/account_report/line/popover/debug_popover");const{AccountReportLineCellEditable}=require("@account_reports/components/account_report/line_cell_editable/line_cell_editable");const AccountReportLine=__exports.AccountReportLine=class AccountReportLine extends Component{static template="account_reports.AccountReportLine";static props={lineIndex:Number,line:Object,};static components={AccountReportLineCellEditable,};setup(){this.popover=useService("popover");this.controller=useState(this.env.controller);}
get lineClasses(){let classes=('level'in this.props.line)?`line_level_${this.props.line.level}`:'line_level_default';if(!this.props.line.visible||this.isHiddenBySearchFilter())
classes+=" d-none";if(this.props.line.unfolded&&this.hasVisibleChild())
classes+=" unfolded";if(this.controller.isTotalLine(this.props.lineIndex))
classes+=" total";if(this.props.line.class)
classes+=` ${this.props.line.class}`;return classes;}
hasVisibleChild(){let nextLineIndex=this.props.lineIndex+1;while(this.controller.isNextLineChild(nextLineIndex,this.props.line['id'])){if(this.controller.lines[nextLineIndex].visible&&!this.isHiddenBySearchFilter(this.controller.lines[nextLineIndex].id))
return true;nextLineIndex+=1;}
return false;}
get growthComparisonClasses(){let classes="text-end";switch(this.props.line.column_percent_comparison_data.mode){case"green":classes+=" text-success";break;case"muted":classes+=" muted";break;case"red":classes+=" text-danger";break;}
return classes;}
get HorizontalGroupTotalClasses(){let classes="text-end";switch(Math.sign(this.props.line.horizontal_group_total_data?.no_format)){case 1:break;case 0:classes+=" muted";break;case-1:classes+=" text-danger";break;}
return classes;}
isHiddenBySearchFilter(lineId=null){lineId||=this.props.line.id;if(!("lines_searched"in this.controller))
return false;for(let searchLineId of this.controller.lines_searched)
if(this.controller.isLineRelatedTo(searchLineId,lineId)||lineId===searchLineId)
return false;return true;}
showDebugPopover(ev){const close=()=>{this.popoverCloseFn();this.popoverCloseFn=null;}
if(this.popoverCloseFn)
close();this.popoverCloseFn=this.popover.add(ev.currentTarget,AccountReportDebugPopover,{expressionsDetail:JSON.parse(this.props.line.debug_popup_data).expressions_detail,onClose:close,},{closeOnClickAway:true,position:localization.direction==="rtl"?"left":"right",},);}}
return __exports;});;

/* /account_reports/static/src/components/account_report/line/popover/debug_popover.js */
odoo.define('@account_reports/components/account_report/line/popover/debug_popover',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const AccountReportDebugPopover=__exports.AccountReportDebugPopover=class AccountReportDebugPopover extends Component{static template="account_reports.AccountReportDebugPopover";static props={close:Function,expressionsDetail:Array,onClose:Function,};}
return __exports;});;

/* /account_reports/static/src/components/account_report/line_cell/line_cell.js */
odoo.define('@account_reports/components/account_report/line_cell/line_cell',['@web/core/l10n/localization','@web/core/utils/hooks','@account_reports/components/account_report/line_cell/popover/carryover_popover','@account_reports/components/account_report/line_cell/popover/edit_popover','@odoo/owl'],function(require){'use strict';let __exports={};const{localization}=require("@web/core/l10n/localization");const{useService}=require("@web/core/utils/hooks");const{AccountReportCarryoverPopover}=require("@account_reports/components/account_report/line_cell/popover/carryover_popover");const{AccountReportEditPopover}=require("@account_reports/components/account_report/line_cell/popover/edit_popover");const{Component,markup,useState}=require("@odoo/owl");const AccountReportLineCell=__exports.AccountReportLineCell=class AccountReportLineCell extends Component{static template="account_reports.AccountReportLineCell";static props={line:{type:Object,optional:true,},cell:Object,};setup(){this.action=useService("action");this.orm=useService("orm");this.popover=useService("popover");this.controller=useState(this.env.controller);}
isNumeric(type){return['float','integer','monetary','percentage'].includes(type);}
get cellClasses(){if(this.props.cell.comparison_mode){return this.comparisonClasses;}
let classes="";if(this.props.cell.auditable)
classes+=" auditable";if(this.props.cell.figure_type==='date')
classes+=" date";if(this.props.cell.figure_type==='string')
classes+=" text";if(this.isNumeric(this.props.cell.figure_type)){classes+=" numeric text-end";if(this.props.cell.no_format!==undefined)
switch(Math.sign(this.props.cell.no_format)){case 1:break;case 0:case-0:classes+=" muted";break;case-1:classes+=" text-danger";break;}}
if(this.props.cell.class)
classes+=` ${this.props.cell.class}`;return classes;}
async audit(){const auditAction=await this.orm.call("account.report","dispatch_report_action",[this.controller.options.report_id,this.controller.options,"action_audit_cell",{report_line_id:this.props.cell.report_line_id,expression_label:this.props.cell.expression_label,calling_line_dict_id:this.props.line.id,column_group_key:this.props.cell.column_group_key,},],{context:this.controller.context,});if(auditAction.help){auditAction.help=markup(auditAction.help);}
return this.action.doAction(auditAction);}
editPopover(ev){const close=()=>{this.popoverCloseFn();this.popoverCloseFn=null;}
if(this.popoverCloseFn)
close();this.popoverCloseFn=this.popover.add(ev.currentTarget,AccountReportEditPopover,{line_id:this.props.line.id,cell:this.props.cell,controller:this.controller,onClose:close,},{closeOnClickAway:true,position:localization.direction==="rtl"?"bottom":"left",},);}
carryoverPopover(ev){if(this.popoverCloseFn){this.popoverCloseFn();this.popoverCloseFn=null;}
this.popoverCloseFn=this.popover.add(ev.currentTarget,AccountReportCarryoverPopover,{carryoverData:JSON.parse(this.props.cell.info_popup_data),options:this.controller.options,context:this.controller.context,},{closeOnClickAway:true,position:localization.direction==="rtl"?"bottom":"right",},);}
get comparisonClasses(){let classes="text-end";switch(this.props.cell.comparison_mode){case"green":classes+=" text-success";break;case"muted":classes+=" muted";break;case"red":classes+=" text-danger";break;}
return classes;}}
return __exports;});;

/* /account_reports/static/src/components/account_report/line_cell/popover/carryover_popover.js */
odoo.define('@account_reports/components/account_report/line_cell/popover/carryover_popover',['@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const AccountReportCarryoverPopover=__exports.AccountReportCarryoverPopover=class AccountReportCarryoverPopover extends Component{static template="account_reports.AccountReportCarryoverPopover";static props={close:Function,carryoverData:Object,options:Object,context:Object,};setup(){this.actionService=useService("action");this.orm=useService("orm");}
async viewCarryoverLinesAction(expressionId,columnGroupKey){const viewCarryoverLinesAction=await this.orm.call("account.report.expression","action_view_carryover_lines",[expressionId,this.props.options,columnGroupKey,],{context:this.props.context,});this.props.close()
return this.actionService.doAction(viewCarryoverLinesAction);}}
return __exports;});;

/* /account_reports/static/src/components/account_report/line_cell/popover/edit_popover.js */
odoo.define('@account_reports/components/account_report/line_cell/popover/edit_popover',['@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useAutofocus,useService}=require("@web/core/utils/hooks");const{Component,useRef}=require("@odoo/owl");const AccountReportEditPopover=__exports.AccountReportEditPopover=class AccountReportEditPopover extends Component{static template="account_reports.AccountReportEditPopover";static props={line_id:String,cell:Object,controller:Object,onClose:Function,close:Function,};setup(){this.orm=useService("orm");if(this.props.cell.figure_type==='boolean'){this.booleanTrue=useRef("booleanTrue");this.booleanFalse=useRef("booleanFalse");}else{this.input=useRef("input");useAutofocus({refName:"input"});}}
async edit(){let editValue;const editPopupData=JSON.parse(this.props.cell.edit_popup_data);if(this.props.cell.figure_type==='boolean')
editValue=Number(this.booleanTrue.el.checked&&!this.booleanFalse.el.checked);else
editValue=this.input.el.value;const res=await this.orm.call("account.report","action_modify_manual_value",[this.props.controller.options.report_id,this.props.line_id,this.props.controller.options,editPopupData.column_group_key,editValue,editPopupData.target_expression_id,editPopupData.rounding,this.props.controller.columnGroupsTotals,],{context:this.props.controller.context,});this.props.controller.lines=res.lines;this.props.controller.columnGroupsTotals=res.column_groups_totals;this.props.onClose();}}
return __exports;});;

/* /account_reports/static/src/components/account_report/line_cell_editable/line_cell_editable.js */
odoo.define('@account_reports/components/account_report/line_cell_editable/line_cell_editable',['@odoo/owl','@web/core/hotkeys/hotkey_hook','@account_reports/components/account_report/line_cell/line_cell'],function(require){'use strict';let __exports={};const{useRef,useState}=require("@odoo/owl");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{AccountReportLineCell}=require("@account_reports/components/account_report/line_cell/line_cell");const AccountReportLineCellEditable=__exports.AccountReportLineCellEditable=class AccountReportLineCellEditable extends AccountReportLineCell{static template="account_reports.AccountReportLineCellEditable";setup(){super.setup();this.input=useRef("input");this.focused=useState({value:false});useHotkey("Enter",(ev)=>{ev.target.blur();},{bypassEditableProtection:true});}
get cellClasses(){let classes=super.cellClasses;if(this.hasEditPopupData){classes+=" editable-cell";}
return classes;}
get hasEditPopupData(){return Boolean(this.props.cell?.edit_popup_data);}
async onChange(){if(!this.input.el.value.trim()){return;}
const editValue=this.input.el.value;const cellEditData=this.hasEditPopupData?JSON.parse(this.props.cell.edit_popup_data):{};const res=await this.orm.call("account.report","action_modify_manual_value",[this.controller.options.report_id,this.props.line.id,this.controller.options,cellEditData.column_group_key,editValue,cellEditData.target_expression_id,cellEditData.rounding,this.controller.columnGroupsTotals,],{context:this.controller.context,});this.controller.lines=res.lines;this.controller.columnGroupsTotals=res.column_groups_totals;this.focused.value=false;}
get inputValue(){return this.focused.value?this.props.cell.no_format:this.props.cell.name;}
onFocus(){this.focused.value=true;}
onBlur(){if(JSON.stringify(this.props.cell.no_format)===this.input.el.value){this.focused.value=false;}}}
return __exports;});;

/* /account_reports/static/src/components/account_report/line_name/line_name.js */
odoo.define('@account_reports/components/account_report/line_name/line_name',['@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/utils/hooks','@web/core/popover/popover_hook','@odoo/owl','@account_reports/components/account_report/line_name/popover/annotations_popover'],function(require){'use strict';let __exports={};const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{useService}=require("@web/core/utils/hooks");const{usePopover}=require("@web/core/popover/popover_hook");const{Component,useState,useRef}=require("@odoo/owl");const{AccountReportAnnotationsPopover}=require("@account_reports/components/account_report/line_name/popover/annotations_popover");const AccountReportLineName=__exports.AccountReportLineName=class AccountReportLineName extends Component{static template="account_reports.AccountReportLineName";static props={lineIndex:Number,line:Object,};static components={Dropdown,DropdownItem,}
setup(){this.action=useService("action");this.orm=useService("orm");this.controller=useState(this.env.controller);this.annotationPopOver=usePopover(AccountReportAnnotationsPopover,{setActiveElement:false,position:"bottom",animation:false,closeOnClickAway:(target)=>!target.closest(".annotation_popover"),});this.lineNameCell=useRef("lineNameCell");}
get caretOptions(){return this.controller.caretOptions[this.props.line.caret_options];}
get hasCaretOptions(){return this.caretOptions?.length>0;}
async caretAction(caretOption){const res=await this.orm.call("account.report","dispatch_report_action",[this.controller.options.report_id,this.controller.options,caretOption.action,{line_id:this.props.line.id,action_param:caretOption.action_param,},],{context:this.controller.context,});return this.action.doAction(res);}
get lineNameClasses(){let classes="text";if(this.props.line.unfoldable)
classes+=" unfoldable";if(this.props.line.class)
classes+=` ${ this.props.line.class }`;return classes;}
async triggerAction(){const res=await this.orm.call("account.report","execute_action",[this.controller.options.report_id,this.controller.options,{id:this.props.line.id,actionId:this.props.line.action_id,},],{context:this.controller.context,});return this.action.doAction(res);}
async loadMore(){const newLines=await this.orm.call("account.report","get_expanded_lines",[this.controller.options.report_id,this.controller.options,this.props.line.parent_id,this.props.line.groupby,this.props.line.expand_function,this.props.line.progress,this.props.line.offset,this.props.line.horizontal_split_side,],);this.controller.setLineVisibility(newLines)
if(this.controller.areLinesOrdered()){this.controller.updateLinesOrderIndexes(this.props.lineIndex,newLines,true)}
await this.controller.replaceLineWith(this.props.lineIndex,newLines);}
toggleFoldable(){if(this.props.line.unfoldable)
if(this.props.line.unfolded)
this.controller.foldLine(this.props.lineIndex);else
this.controller.unfoldLine(this.props.lineIndex);}
get hasVisibleAnnotation(){return this.props.line.visible_annotations;}
async toggleAnnotationPopover(){if(this.annotationPopOver.isOpen){this.annotationPopOver.close();}else{this.annotationPopOver.open(this.lineNameCell.el,{controller:this.controller,lineName:this,lineID:this.props.line.id,});}}
async addAnnotation(ev){this.annotationPopOver.open(this.lineNameCell.el,{controller:this.controller,lineName:this,isAddingAnnotation:true,lineID:this.props.line.id,});}}
return __exports;});;

/* /account_reports/static/src/components/account_report/line_name/popover/annotations_popover.js */
odoo.define('@account_reports/components/account_report/line_name/popover/annotations_popover',['@odoo/owl','@web/core/utils/hooks','@web/core/datetime/datetime_input','@account_reports/components/account_report/line_name/popover_line/annotation_popover_line','@account_reports/js/util'],function(require){'use strict';let __exports={};const{Component,useState,useRef,onWillDestroy}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{DateTimeInput}=require("@web/core/datetime/datetime_input");const{AnnotationPopoverLine}=require("@account_reports/components/account_report/line_name/popover_line/annotation_popover_line");const{removeTaxGroupingFromLineId}=require("@account_reports/js/util");const{DateTime}=luxon;const AccountReportAnnotationsPopover=__exports.AccountReportAnnotationsPopover=class AccountReportAnnotationsPopover extends Component{static template="account_reports.AccountReportAnnotationsPopover";static props={controller:Object,lineName:Object,lineID:String,close:{type:Function,optional:true},isAddingAnnotation:{type:Boolean,optional:true},};static components={DateTimeInput,AnnotationPopoverLine,};setup(){this.notificationService=useService("notification");this.newAnnotation=useState({value:this.props.isAddingAnnotation?this._getNewAnnotation():{},});this.annotations=useState(this.props.controller.visibleAnnotations[removeTaxGroupingFromLineId(this.props.lineID)]);this.popoverTable=useRef("popoverTable");this.currentPromise=null;onWillDestroy(async()=>{if(this.currentPromise){await this.currentPromise;}});}
get isAddingAnnotation(){return Object.keys(this.newAnnotation.value).length!==0;}
async refreshAnnotations(){this.currentPromise=null;await this.props.controller.refreshAnnotations();this.annotations=this.props.controller.visibleAnnotations[removeTaxGroupingFromLineId(this.props.lineID)];if(this.isAddingAnnotation){this.cleanNewAnnotation();}}
_getNewAnnotation(){const date=this.props.controller.options.date.filter==="today"?new Date().toISOString().split("T")[0]:this.props.controller.options.date.date_to;return{date:DateTime.fromISO(date),text:"",lineID:this.props.lineID,};}
cleanNewAnnotation(){this.newAnnotation.value={};}
addAnnotation(){this.newAnnotation.value=this._getNewAnnotation();}
formatAnnotation(annotation){return{id:annotation.id,date:annotation.date?DateTime.fromISO(annotation.date):null,text:annotation.text,lineID:annotation.line_id,};}
async saveNewAnnotation(newAnnotation){if(newAnnotation.text){this.currentPromise=this.env.services.orm.call("account.report.annotation","create",[{report_id:this.props.controller.options.report_id,line_id:newAnnotation.lineID,text:newAnnotation.text,date:newAnnotation.date?newAnnotation.date.toFormat("yyyy-LL-dd"):null,fiscal_position_id:this.props.controller.options.fiscal_position,},],{context:this.props.context,});this.currentPromise.then(async()=>{await this.refreshAnnotations();if(this.popoverTable.el){this.popoverTable.el.scrollIntoView({behavior:"smooth",block:"end"});}});}}
async deleteAnnotation(annotationId){this.currentPromise=this.env.services.orm.call("account.report.annotation","unlink",[annotationId],{context:this.props.controller.context});await this.currentPromise;await this.refreshAnnotations();}
async editAnnotation(editedAnnotation,existingAnnotation){this.currentPromise=this.env.services.orm.call("account.report.annotation","write",[[existingAnnotation.id],{text:editedAnnotation.text,date:editedAnnotation.date}],{context:this.props.controller.context,});await this.currentPromise;await this.refreshAnnotations();}}
return __exports;});;

/* /account_reports/static/src/components/account_report/line_name/popover_line/annotation_popover_line.js */
odoo.define('@account_reports/components/account_report/line_name/popover_line/annotation_popover_line',['@odoo/owl','@web/core/utils/hooks','@web/core/l10n/translation','@web/core/datetime/datetime_input'],function(require){'use strict';let __exports={};const{Component,useState,useRef,useEffect}=require("@odoo/owl");const{useAutofocus,useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const{DateTimeInput}=require("@web/core/datetime/datetime_input");const{DateTime}=luxon;const AnnotationPopoverLine=__exports.AnnotationPopoverLine=class AnnotationPopoverLine extends Component{static template="account_report.AnnotationPopoverLine";static props={annotation:{type:Object,shape:{date:{type:[DateTime,{value:false},{value:null}],optional:true},text:String,lineID:String,id:{type:Number,optional:true},},},onEdit:Function,onDelete:Function,};static components={DateTimeInput,};setup(){this.applyAutoresizeToAll(".annotation_popover_autoresize_textarea");this.annotation=useState(this.props.annotation);this.notificationService=useService("notification");if(this.annotation.text.length){this.textArea=useRef("annotationText");}else{this.textArea=useAutofocus({refName:"annotationText"});}}
applyAutoresizeToAll(selector){useEffect(()=>{const resizeTextArea=(textarea)=>{textarea.style.height=`${textarea.scrollHeight}px`;textarea.parentElement.style.height=`${textarea.scrollHeight}px`;};const textareas=document.querySelectorAll(selector);for(const textarea of textareas){Object.assign(textarea.style,{width:"auto",paddingTop:0,paddingBottom:0,});resizeTextArea(textarea);textarea.addEventListener("input",()=>{resizeTextArea(textarea);});}});}
annotationEditDate(date){this.annotation.date=date;this.props.onEdit(this.annotation);}
annotationEditText(){if(this.textArea.el.value){if(this.textArea.el.value!==this.annotation.text){this.annotation.text=this.textArea.el.value;this.props.onEdit(this.annotation);}}else{this.notificationService.add(_t("The annotation shouldn't have an empty value."));}}
deleteAnnotation(){this.props.onDelete(this.annotation.id);}}
return __exports;});;

/* /account_reports/static/src/components/account_report/search_bar/search_bar.js */
odoo.define('@account_reports/components/account_report/search_bar/search_bar',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,useRef,useState,onMounted}=require("@odoo/owl");const AccountReportSearchBar=__exports.AccountReportSearchBar=class AccountReportSearchBar extends Component{static template="account_reports.AccountReportSearchBar";static props={initialQuery:{type:String,optional:true},};setup(){this.searchText=useRef("search_bar_input");this.controller=useState(this.env.controller);onMounted(()=>{if(this.props.initialQuery){this.searchText.el.value=this.props.initialQuery;this.search();}});}
search(){const inputText=this.searchText.el.value.trim();const query=inputText.toLowerCase();const linesIDsMatched=[];if(query.length){for(const line of this.controller.lines){if(!line.name)continue;const lineName=line.name.trim().toLowerCase();const match=(lineName.indexOf(query)!==-1);if(match){linesIDsMatched.push(line.id);}}
this.controller.lines_searched=linesIDsMatched;this.controller.updateOption("filter_search_bar",inputText);}else{delete this.controller.lines_searched;this.controller.deleteOption("filter_search_bar");}}}
return __exports;});;

/* /account_reports/static/src/components/aged_partner_balance/filters.js */
odoo.define('@account_reports/components/aged_partner_balance/filters',['@web/core/l10n/translation','@web/core/errors/error_dialogs','@account_reports/components/account_report/account_report','@account_reports/components/account_report/filters/filters'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{WarningDialog}=require("@web/core/errors/error_dialogs");const{AccountReport}=require("@account_reports/components/account_report/account_report");const{AccountReportFilters}=require("@account_reports/components/account_report/filters/filters");const AgedPartnerBalanceFilters=__exports.AgedPartnerBalanceFilters=class AgedPartnerBalanceFilters extends AccountReportFilters{static template="account_reports.AgedPartnerBalanceFilters";async setAgingInterval(ev){const agingInterval=parseInt(ev.target.value);if(agingInterval<1){this.dialog.add(WarningDialog,{title:_t("Odoo Warning"),message:_t("Intervals cannot be smaller than 1"),});return;}
await this.filterClicked({optionKey:"aging_interval",optionValue:agingInterval,reload:true});}}
AccountReport.registerCustomComponent(AgedPartnerBalanceFilters);return __exports;});;

/* /account_reports/static/src/components/journal_dashboard_activity/journal_dashboard_activity.js */
odoo.define('@account_reports/components/journal_dashboard_activity/journal_dashboard_activity',['@web/core/registry','@web/core/utils/hooks','@account/components/journal_dashboard_activity/journal_dashboard_activity'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{JournalDashboardActivity,journalDashboardActivity}=require("@account/components/journal_dashboard_activity/journal_dashboard_activity");const JournalDashboardActivityTaxReport=__exports.JournalDashboardActivityTaxReport=class JournalDashboardActivityTaxReport extends JournalDashboardActivity{setup(){super.setup();this.orm=useService("orm");}
async openActivity(activity){if(activity.activity_category==='tax_report'){const act=await this.orm.call("mail.activity","action_open_tax_activity",[activity.id],{});this.action.doAction(act);}else{super.openActivity(activity);}}}
const journalDashboardActivityTaxReport=__exports.journalDashboardActivityTaxReport={...journalDashboardActivity,component:JournalDashboardActivityTaxReport,};registry.category("fields").add("kanban_vat_activity",journalDashboardActivityTaxReport,{force:true});return __exports;});;

/* /account_reports/static/src/components/journal_report/filters.js */
odoo.define('@account_reports/components/journal_report/filters',['@web/core/utils/patch','@account_reports/components/account_report/filters/filters'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{AccountReportFilters}=require("@account_reports/components/account_report/filters/filters");patch(AccountReportFilters.prototype,{get hasExtraOptionsFilter(){return super.hasExtraOptionsFilter||"show_payment_lines"in this.controller.options;},});return __exports;});;

/* /account_reports/static/src/components/journal_report/line/line.js */
odoo.define('@account_reports/components/journal_report/line/line',['@account_reports/components/account_report/account_report','@account_reports/components/account_report/line/line'],function(require){'use strict';let __exports={};const{AccountReport}=require("@account_reports/components/account_report/account_report");const{AccountReportLine}=require("@account_reports/components/account_report/line/line");const JournalReportLine=__exports.JournalReportLine=class JournalReportLine extends AccountReportLine{static template="account_reports.JournalReportLine";get lineClasses(){let classes=super.lineClasses;if(this.props.line.id.includes("|headers~~"))
classes+=' accent_header';if(this.props.line.move_id)
classes+=' accent_line';return classes;}
async openTaxJournalItems(ev,name,taxType){return this.controller.reportAction(ev,"journal_report_action_open_tax_journal_items",{name:name,tax_type:taxType,journal_id:this.props.line.journal_id,journal_type:this.props.line.journal_type,date_form:this.props.line.date_from,date_to:this.props.line.date_to,})}}
AccountReport.registerCustomComponent(JournalReportLine);return __exports;});;

/* /account_reports/static/src/components/journal_report/move_line_list/move_line_list.js */
odoo.define('@account_reports/components/journal_report/move_line_list/move_line_list',['@web/core/registry','@account_accountant/components/move_line_list/move_line_list'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{AccountMoveLineListRenderer,AccountMoveLineListView}=require("@account_accountant/components/move_line_list/move_line_list");const JournalReportAccountMoveLineReconcileListRenderer=__exports.JournalReportAccountMoveLineReconcileListRenderer=class JournalReportAccountMoveLineReconcileListRenderer extends AccountMoveLineListRenderer{setup(){super.setup();this.props.list.groups?.forEach(group=>{group.list?.groups?.forEach(innerGroup=>{this.toggleGroup(innerGroup);});});}}
const JournalReportAccountMoveLineReconcileLineListView=__exports.JournalReportAccountMoveLineReconcileLineListView={...AccountMoveLineListView,Renderer:JournalReportAccountMoveLineReconcileListRenderer,};registry.category("views").add("account_move_line_journal_report_list",JournalReportAccountMoveLineReconcileLineListView);return __exports;});;

/* /account_reports/static/src/components/multicurrency_revaluation_report/filters/filters.js */
odoo.define('@account_reports/components/multicurrency_revaluation_report/filters/filters',['@account_reports/components/account_report/account_report','@account_reports/components/account_report/filters/filters'],function(require){'use strict';let __exports={};const{AccountReport}=require("@account_reports/components/account_report/account_report");const{AccountReportFilters}=require("@account_reports/components/account_report/filters/filters");const MulticurrencyRevaluationReportFilters=__exports.MulticurrencyRevaluationReportFilters=class MulticurrencyRevaluationReportFilters extends AccountReportFilters{static template="account_reports.MulticurrencyRevaluationReportFilters";async filterExchangeRate(ev,currencyId){this.controller.options.currency_rates[currencyId].rate=ev.currentTarget.value;}}
AccountReport.registerCustomComponent(MulticurrencyRevaluationReportFilters);return __exports;});;

/* /account_reports/static/src/components/partner_ledger/line_cell.js */
odoo.define('@account_reports/components/partner_ledger/line_cell',['@account_reports/components/account_report/account_report','@account_reports/components/account_report/line_cell/line_cell'],function(require){'use strict';let __exports={};const{AccountReport}=require("@account_reports/components/account_report/account_report");const{AccountReportLineCell}=require("@account_reports/components/account_report/line_cell/line_cell");const{DateTime}=luxon;const PartnerLedgerLineCell=__exports.PartnerLedgerLineCell=class PartnerLedgerLineCell extends AccountReportLineCell{static template="account_reports.PartnerLedgerLineCell";get cellClasses(){let superCellClasses=super.cellClasses;const cell=this.props.cell;if(cell.figure_type==='date'&&cell.expression_label=='date_maturity'&&cell.no_format&&DateTime.fromISO(cell.no_format).startOf('day')<DateTime.now().startOf('day')){superCellClasses+=' text-danger';}
return superCellClasses;}}
AccountReport.registerCustomComponent(PartnerLedgerLineCell);return __exports;});;

/* /account_reports/static/src/components/redirectAction/redirectAction.js */
odoo.define('@account_reports/components/redirectAction/redirectAction',['@web/core/registry','@web/core/utils/hooks','@odoo/owl','@web/webclient/actions/action_service','@web/core/dialog/dialog'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");const{Dialog}=require("@web/core/dialog/dialog");class RedirectAction extends Component{static template="account_reports.redirectAction";static components={Dialog};static props={...standardActionServiceProps,action:Object}
setup(){this.actionService=useService("action");}
openClientAction(){this.actionService.doAction(this.props.action.params.depending_action);}
close(){this.actionService.doAction({type:'ir.actions.act_window_close'});}}
registry.category("actions").add("account_reports.redirect_action",RedirectAction);return __exports;});;

/* /account_reports/static/src/components/sales_report/filters/filters.js */
odoo.define('@account_reports/components/sales_report/filters/filters',['@web/core/l10n/translation','@account_reports/components/account_report/account_report','@account_reports/components/account_report/filters/filters'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{AccountReport}=require("@account_reports/components/account_report/account_report");const{AccountReportFilters}=require("@account_reports/components/account_report/filters/filters");const SalesReportFilters=__exports.SalesReportFilters=class SalesReportFilters extends AccountReportFilters{static template="account_reports.SalesReportFilters";get selectedEcTaxName(){const selected=this.controller.options.ec_tax_filter_selection.filter((ecTax)=>ecTax.selected,);switch(selected.length){case this.controller.options.ec_tax_filter_selection.length:return _t("All");case 0:return _t("None");default:return selected.map((s)=>s.name.substring(0,1)).join(", ");}}}
AccountReport.registerCustomComponent(SalesReportFilters);return __exports;});;

/* /account_reports/static/src/js/action_manager_account_report_dl.js */
odoo.define('@account_reports/js/action_manager_account_report_dl',['@web/core/registry','@web/core/network/download'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{download}=require("@web/core/network/download");async function executeAccountReportDownload({env,action}){env.services.ui.block();const url="/account_reports";const data=action.data;try{await download({url,data});env.services.action.doAction({type:'ir.actions.act_window_close'});}catch(e){if(e.exceptionName==='AccountReportFileDownloadException'){const reportOptions=JSON.parse(data.options);const reportAction=await env.services.orm.call('account.report','open_account_report_file_download_error_wizard',[reportOptions.report_id,e.data.arguments[0],e.data.arguments[1]],);env.services.action.doAction(reportAction);}else{throw e;}}finally{env.services.ui.unblock();}}
registry.category("action_handlers").add('ir_actions_account_report_download',executeAccountReportDownload);return __exports;});;

/* /account_reports/static/src/js/util.js */
odoo.define('@account_reports/js/util',[],function(require){'use strict';let __exports={};const LINE_ID_HIERARCHY_DELIMITER="|";const LINE_ID_GROUP_DELIMITER="~";__exports.buildLineId=buildLineId;function buildLineId(current){const convertNull=(value)=>{if(value===null||value===undefined||value===false){return"";}else if(typeof value==="object"){return JSON.stringify(value).replaceAll('":','": ');}
return value;};return current.map(([markup,model,value])=>{const lineValues=[convertNull(markup),convertNull(model),convertNull(value)];return lineValues.join(LINE_ID_GROUP_DELIMITER);}).join(LINE_ID_HIERARCHY_DELIMITER);}
__exports.parseLineId=parseLineId;function parseLineId(lineID,markupAsString=false){const parseMarkup=(markup)=>{if(!markup){return markup;}
try{const result=JSON.parse(markup);return typeof result==="object"?result:markup;}catch{return markup;}};if(!lineID){return[];}
return lineID.split(LINE_ID_HIERARCHY_DELIMITER).map((key)=>{const[markup,model,value]=key.split(LINE_ID_GROUP_DELIMITER);return[(markupAsString?markup:parseMarkup(markup))||null,model||null,model&&value?parseInt(value):value||null,];});}
__exports.removeTaxGroupingFromLineId=removeTaxGroupingFromLineId;function removeTaxGroupingFromLineId(lineId){return buildLineId(parseLineId(lineId,true).filter(([markup,model,value])=>{return model!=="account.group";}));}
return __exports;});;

/* /account_reports/static/src/widgets/account_report_x2many/account_report_x2many.js */
odoo.define('@account_reports/widgets/account_report_x2many/account_report_x2many',['@odoo/owl','@web/core/confirmation_dialog/confirmation_dialog','@web/core/errors/error_dialogs','@web/core/l10n/translation','@web/core/utils/hooks','@web/core/utils/nested_sortable','@web/core/registry','@web/views/list/list_renderer','@web/views/fields/x2many/x2many_field','@web/views/fields/relational_utils'],function(require){'use strict';let __exports={};const{useRef,onWillRender}=require("@odoo/owl");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{WarningDialog}=require("@web/core/errors/error_dialogs");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const{useNestedSortable}=require("@web/core/utils/nested_sortable");const{registry}=require("@web/core/registry");const{ListRenderer}=require("@web/views/list/list_renderer");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const{useOpenX2ManyRecord,useX2ManyCrud}=require("@web/views/fields/relational_utils");const AccountReportListRenderer=__exports.AccountReportListRenderer=class AccountReportListRenderer extends ListRenderer{static template="account_reports.AccountReportList";setup(){this.dialog=useService("dialog");this.orm=useService("orm");this.allColumns=this.processAllColumn(this.props.archInfo.columns,this.props.list);this.keyOptionalFields=`optional_fields,${this.createViewKey()}`;this.optionalActiveFields=this.computeOptionalActiveFields();this.columns=this.getActiveColumns(this.props.list);this.env.model.config.activeFields.line_ids.defaultOrderBy=[{"name":"sequence","asc":true},{"name":"id","asc":true}]
useNestedSortable({ref:useRef("root"),elements:"li.draggable",nest:true,nestInterval:10,onDragStart:(ctx)=>this.onDragStart(ctx),onDragEnd:()=>this.onDragEnd(),onDrop:(ctx)=>this.onDrop(ctx),});onWillRender(()=>{this.allColumns=this.processAllColumn(this.props.archInfo.columns,this.props.list);this.columns=this.getActiveColumns(this.props.list);});}
recordsDataDeepCopy(records){const fields=this.allColumns.map((column)=>column.name);return records.map((record)=>{let recordData={};for(const field of fields)
recordData[field]=record.data[field];return recordData;});}
formatData(){let idToIndexMap={};let tree=[];let lines=this.recordsDataDeepCopy(this.props.list.records);for(const[index,line]of lines.entries()){line.index=index;line.children=[];line.descendants_count=0;idToIndexMap[line.id]=index;if(line.parent_id?.[0]){let parentLine=lines[idToIndexMap[line.parent_id[0]]];if(parentLine){parentLine?.children.push(line);while(parentLine){parentLine.descendants_count+=1;parentLine=lines[idToIndexMap[parentLine.parent_id?.[0]]];}}else{line.out_of_sequence_error=true;tree.push(line);}}else{tree.push(line);}}
return tree;}
onDragStart(ctx){function sanitize(element){if(element.nodeName==='LI'){["data-record_index","data-record_id","data-descendants_count"].forEach((attribute)=>{element.removeAttribute(attribute);});element.classList.remove("draggable");}
Array.from(element.childNodes).forEach((child)=>{sanitize(child);});}
const placeholder=ctx.element.cloneNode(true);placeholder.removeAttribute("style");placeholder.classList.replace("o_dragged","o_dragged_placeholder");sanitize(placeholder);document.querySelector(".o_nested_sortable_placeholder").after(placeholder);}
onDragEnd(){document.querySelector(".o_dragged_placeholder").remove();}
async setRecordParent(currentElement,parentElement){const currentRecordIndex=currentElement.dataset.record_index;const parentRecordIndex=parentElement?.dataset.record_index;let parent=false;if(parentRecordIndex){parent=[this.props.list.records[parentRecordIndex].data.id,this.props.list.records[parentRecordIndex].data.name,];}
await this.props.list.records[currentRecordIndex].update({'parent_id':parent});}
async setRecordHierarchy(currentElement,parentElement){const currentRecordIndex=parseInt(currentElement.dataset.record_index);const parentRecordIndex=parentElement?.dataset.record_index;const parentRecord=(parentRecordIndex)?this.props.list.records[parentRecordIndex].data:null;const hierarchyLevels={};if(parentRecord)
hierarchyLevels[parentRecord.id]=parentRecord.hierarchy_level;const ancestors=new Set();for(let index=currentRecordIndex;index<this.props.list.records.length;index++){const record=this.props.list.records[index];const parentId=(record.data.parent_id)?record.data.parent_id[0]:false;if(ancestors.size&&!ancestors.has(parentId))
break;let parentHierarchyLevel=(record.data.parent_id)?hierarchyLevels[record.data.parent_id[0]]:null;if(parentHierarchyLevel!=null){parentHierarchyLevel=(parentHierarchyLevel===0)?1:parentHierarchyLevel;await record.update({'hierarchy_level':parentHierarchyLevel+2});}else{await record.update({'hierarchy_level':1});}
ancestors.add(record.data.id);hierarchyLevels[record.data.id]=record.data.hierarchy_level;}}
async setRecordSequence(currentElement,parentElement,previousElement,previousElementDescendantCount,nextElement){const currentRecordIndex=currentElement.dataset.record_index;const currentRecordDescendantsCount=parseInt(currentElement.dataset.descendants_count);const lastDescendantIndex=parseInt(currentRecordIndex)+currentRecordDescendantsCount
const recordsToMove=this.props.list.records.slice(currentRecordIndex,lastDescendantIndex+1);this.props.list.records.splice(currentRecordIndex,recordsToMove.length);const previousRecordIndex=previousElement?.dataset.record_index;const nextRecordIndex=nextElement?.dataset.record_index;let newCurrentRecordIndex;if(previousRecordIndex){newCurrentRecordIndex=parseInt(previousRecordIndex)+1+parseInt(previousElementDescendantCount);}else if(nextRecordIndex){newCurrentRecordIndex=parseInt(nextRecordIndex);}else{newCurrentRecordIndex=parseInt(parentElement?.dataset.record_index)+1;}
if(currentRecordIndex<newCurrentRecordIndex){newCurrentRecordIndex-=(1+currentRecordDescendantsCount);}
this.props.list.records.splice(newCurrentRecordIndex,0,...recordsToMove);for(const[index,record]of this.props.list.records.entries())
await record.update({'sequence':index+1});}
async onDrop(ctx){const parentRecordIndex=ctx.parent?.dataset.record_index;if(this.props.list.records[parentRecordIndex]?.data.user_groupby)
return this.dialog.add(WarningDialog,{message:_t("A line with a 'Group By' value cannot have children."),});const previousElementDescendantCount=ctx.previous?.dataset.descendants_count
await this.setRecordParent(ctx.element,ctx.parent);await this.setRecordHierarchy(ctx.element,ctx.parent);await this.setRecordSequence(ctx.element,ctx.parent,ctx.previous,previousElementDescendantCount,ctx.next);}
onDeleteRecord(recordIndex){const currentRecordId=this.props.list.records[recordIndex].data.id
const nextRecordParentId=this.props.list.records[recordIndex+1]?.data.parent_id[0]
if(nextRecordParentId===currentRecordId)
return this.dialog.add(ConfirmationDialog,{body:_t("This line and all its children will be deleted. Are you sure you want to proceed?"),confirmLabel:"Delete",confirm:()=>{this.deleteRecord(recordIndex)},cancel:()=>{},});this.deleteRecord(recordIndex);}
deleteRecord(recordIndex){const recordToDelete=this.props.list.records[recordIndex];const recordsToDelete=[recordToDelete];const ancestors=new Set([recordToDelete.data.id]);for(let index=recordIndex+1;index<this.props.list.records.length;index++){const record=this.props.list.records[index];if(!ancestors.has(record.data.parent_id[0]))
break;recordsToDelete.push(record);ancestors.add(record.data.id);}
for(const record of recordsToDelete)
this.props.list.delete(record);}}
const AccountReportsLinesListX2ManyField=__exports.AccountReportsLinesListX2ManyField=class AccountReportsLinesListX2ManyField extends X2ManyField{static components={...X2ManyField.components,ListRenderer:AccountReportListRenderer,}
setup(){super.setup();const{saveRecord,updateRecord}=useX2ManyCrud(()=>this.list,this.isMany2Many);const openRecord=useOpenX2ManyRecord({resModel:this.list.resModel,activeField:this.activeField,activeActions:this.activeActions,getList:()=>this.list,saveRecord:async(record)=>{for(const[index,record]of this.props.record.data.line_ids.records.entries())
record.update({'sequence':index+1});record.update({'sequence':this.props.record.data.line_ids.records.length,});await saveRecord(record);await this.props.record.save();},updateRecord:updateRecord,isMany2Many:this.isMany2Many,});this._openRecord=(params)=>{const activeElement=document.activeElement;openRecord({...params,onClose:()=>{if(activeElement){activeElement.focus();}},});};}}
registry.category("fields").add("account_report_lines_list_x2many",{...x2ManyField,component:AccountReportsLinesListX2ManyField,});return __exports;});;

/* /account_asset/static/src/components/move_reversed/move_reversed.js */
odoo.define('@account_asset/components/move_reversed/move_reversed',['@web/core/registry','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Component}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const MoveReversed=__exports.MoveReversed=class MoveReversed extends Component{static template="account_asset.moveReversed";static props={...standardFieldProps};}
const moveReversed=__exports.moveReversed={component:MoveReversed,};registry.category("fields").add("deprec_lines_reversed",moveReversed);return __exports;});;

/* /base_import/static/src/binary_file_manager.js */
odoo.define('@base_import/binary_file_manager',['@web/core/utils/concurrency','@web/core/utils/files'],function(require){'use strict';let __exports={};const{Mutex}=require("@web/core/utils/concurrency");const{checkFileSize}=require("@web/core/utils/files");const BinaryFileManager=__exports.BinaryFileManager=class BinaryFileManager{constructor(resModel,fields,parameters,context,orm,notificationService){this.resModel=resModel;this.fields=[".id",...fields];this.parameters=parameters;this.context=context;this.orm=orm;this.notificationService=notificationService;this.maxBatchSize=this.parameters.maxBatchSize*0.95;this.delayAfterEachBatch=this.parameters.delayAfterEachBatch*1000;this.dataToSend={};this.mutex=new Mutex();}
async addFile(id,field,file){let data=await this._readFile(file);if(typeof data==="string"&&data.startsWith("data:")){data=data.split(",")[1];}
const dataSize=data.length;if(!checkFileSize(dataSize,this.notificationService)){return;}
if(this.getCurrentSize()+dataSize>=this.maxBatchSize){await this.mutex.exec(async()=>await this._send());}
if(!(id in this.dataToSend)){this.dataToSend[id]=Array(this.fields.length);this.dataToSend[id][0]=id;}
const indexOfField=this.fields.indexOf(field,1);this.dataToSend[id][indexOfField]=data;}
async sendLastPayload(){if(Object.keys(this.dataToSend).length>0){await this.mutex.exec(async()=>await this._send());}}
async _send(){await new Promise((resolve)=>{setTimeout(resolve,this.delayAfterEachBatch);});const data=Object.values(this.dataToSend);this.dataToSend={};const context={...this.context,import_file:true,tracking_disable:this.parameters.tracking_disable,name_create_enabled_fields:this.parameters.name_create_enabled_fields||{},import_set_empty_fields:this.parameters.import_set_empty_fields||[],import_skip_records:this.parameters.import_skip_records||[],};let res;try{res=await this.orm.call(this.resModel,"load",[],{fields:this.fields,data,context,});}catch(error){console.error(error);return{error};}
return res;}
_readFile(file){return new Promise((resolve,reject)=>{const reader=new FileReader();reader.onerror=(event)=>reject(event);reader.onabort=(event)=>reject(event);reader.onload=(event)=>resolve(event.target.result);reader.readAsDataURL(file);});}
getCurrentSize(){return JSON.stringify(this.dataToSend).length;}}
return __exports;});;

/* /base_import/static/src/import_action/import_action.js */
odoo.define('@base_import/import_action/import_action',['@web/core/l10n/translation','@odoo/owl','@web/core/registry','@web/core/utils/files','@web/core/utils/hooks','@web/core/file_input/file_input','@web/core/dropzone/dropzone_hook','@base_import/import_model','@base_import/import_data_content/import_data_content','@base_import/import_data_progress/import_data_progress','@base_import/import_data_sidepanel/import_data_sidepanel','@web/search/layout','@web/core/browser/router','@web/webclient/actions/action_service','@web/views/widgets/documentation_link/documentation_link'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Component,onWillStart,onMounted,useRef,useState}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{useFileUploader}=require("@web/core/utils/files");const{useService}=require("@web/core/utils/hooks");const{FileInput}=require("@web/core/file_input/file_input");const{useDropzone}=require("@web/core/dropzone/dropzone_hook");const{useImportModel}=require("@base_import/import_model");const{ImportDataContent}=require("@base_import/import_data_content/import_data_content");const{ImportDataProgress}=require("@base_import/import_data_progress/import_data_progress");const{ImportDataSidepanel}=require("@base_import/import_data_sidepanel/import_data_sidepanel");const{Layout}=require("@web/search/layout");const{router}=require("@web/core/browser/router");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");const{DocumentationLink}=require("@web/views/widgets/documentation_link/documentation_link");const ImportAction=__exports.ImportAction=class ImportAction extends Component{static template="ImportAction";static nextId=1;static components={FileInput,ImportDataContent,ImportDataSidepanel,Layout,DocumentationLink,};static props={...standardActionServiceProps};setup(){this.notification=useService("notification");this.orm=useService("orm");this.env.config.setDisplayName(this.props.action.name||_t("Import a File"));this.resModel=this.props.action.params.model||this.props.action.params.active_model;if(this.resModel){this.props.updateActionState({active_model:this.resModel});}
this.model=useImportModel({env:this.env,resModel:this.resModel,context:this.props.action.params.context||{},orm:this.orm,});this.state=useState({filename:undefined,fileLength:0,importMessages:[],importProgress:{value:0,step:1,},isPaused:false,previewError:"",});this.uploadFiles=useFileUploader();useDropzone(useRef("root"),async event=>{const{files}=event.dataTransfer;if(files.length===0){this.notification.add(_t("Please upload an Excel (.xls or .xlsx) or .csv file to import."),{type:"danger",});}else if(files.length>1){this.notification.add(_t("Please upload a single file."),{type:"danger",});}else{const file=files[0];const isValidFile=file.name.endsWith(".csv")||file.name.endsWith(".xls")||file.name.endsWith(".xlsx");if(!isValidFile){this.notification.add(_t("Please upload an Excel (.xls or .xlsx) or .csv file to import."),{type:"danger",});}else{await this.uploadFiles(this.uploadFilesRoute,{csrf_token:odoo.csrf_token,ufile:[file],model:this.resModel,id:this.model.id,});this.handleFilesUpload([file]);}}});onWillStart(()=>this.model.init());onMounted(()=>this.enter());}
enter(){const newState={action:"import",model:this.resModel};router.pushState(newState,{replace:true});}
exit(resIds){this.env.config.historyBack();}
get display(){return{controlPanel:{},};}
get importTemplates(){return this.model.importTemplates;}
get uploadFilesRoute(){return"/base_import/set_file";}
get formattingOptions(){return this.model.formattingOptions;}
get totalToImport(){return this.state.fileLength-parseInt(this.importOptions.skip);}
get totalSteps(){return this.isBatched?Math.ceil(this.totalToImport/this.importOptions.limit):1;}
get importOptions(){return this.model.importOptions;}
get isPreviewing(){return this.state.filename!==undefined;}
get isBatched(){return this.state.fileLength>100;}
async onOptionChanged(name,value,fieldName=null){this.model.block();const result=await this.model.setOption(name,value,fieldName);if(result){const{res,error}=result;if(!error&&res.file_length){this.state.fileLength=res.file_length;}}
this.model.unblock();}
async reload(){this.model.block();await this.model.updateData();this.model.unblock();}
async handleFilesUpload(files){if(!files||files.length<=0){return;}
this.state.filename=files[0].name;this.state.importMessages=[];this.model.block(_t("Loading file..."));const{res,error}=await this.model.updateData(true);if(error){this.state.previewError=error;}else{this.state.fileLength=res.file_length;this.state.previewError=undefined;}
this.model.unblock();}
async handleImport(isTest=true){const message=isTest?_t("Testing"):_t("Importing");let blockComponent;if(this.isBatched){blockComponent={class:ImportDataProgress,props:{stopImport:()=>this.stopImport(),totalSteps:this.totalSteps,importProgress:this.state.importProgress,},};}
this.model.block(message,blockComponent);let res={ids:[]};try{const data=await this.model.executeImport(isTest,this.totalSteps,this.state.importProgress);res=data.res;}finally{this.model.unblock();}
if(!isTest&&res.nextrow){this.state.isPaused=true;}
if(!isTest&&res.ids.length){this.notification.add(_t("%s records successfully imported",res.ids.length),{type:"success",});this.exit(res.ids);}}
stopImport(){this.model.stopImport();}
onFieldChanged(column,fieldInfo){this.model.setColumnField(column,fieldInfo);}
isFieldSet(column){return column.fieldInfo!=null;}
get hasBinaryFields(){return this.model.columns.some((column)=>column.fieldInfo?.type==="binary");}}
registry.category("actions").add("import",ImportAction);return __exports;});;

/* /base_import/static/src/import_block_ui.js */
odoo.define('@base_import/import_block_ui',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const ImportBlockUI=__exports.ImportBlockUI=class ImportBlockUI extends Component{static props={message:{type:String,optional:true},blockComponent:{type:Object,optional:true},};static template="base_import.BlockUI";}
return __exports;});;

/* /base_import/static/src/import_data_column_error/import_data_column_error.js */
odoo.define('@base_import/import_data_column_error/import_data_column_error',['@odoo/owl','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,useState}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const ImportDataColumnError=__exports.ImportDataColumnError=class ImportDataColumnError extends Component{static template="ImportDataColumnError";static props={errors:{type:Array},fieldInfo:{type:Object},resultNames:{type:Array},};setup(){this.action=useService("action");this.orm=useService("orm");this.state=useState({isExpanded:false,moreInfoContent:undefined,});}
get moreInfo(){const moreInfoObjects=this.props.errors.map((error)=>error.moreinfo);return moreInfoObjects.length&&moreInfoObjects[0];}
isErrorVisible(index){return this.state.isExpanded||index<3;}
onMoreInfoClicked(){const moreInfo=this.moreInfo;if(this.state.moreInfoContent){this.state.moreInfoContent=undefined;}else if(moreInfo instanceof Array){this.state.moreInfoContent=moreInfo;}else{this.action.doAction(moreInfo);}}}
return __exports;});;

/* /base_import/static/src/import_data_content/import_data_content.js */
odoo.define('@base_import/import_data_content/import_data_content',['@odoo/owl','@web/core/select_menu/select_menu','@base_import/import_data_column_error/import_data_column_error','@base_import/import_data_options/import_data_options','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{SelectMenu}=require("@web/core/select_menu/select_menu");const{ImportDataColumnError}=require("@base_import/import_data_column_error/import_data_column_error");const{ImportDataOptions}=require("@base_import/import_data_options/import_data_options");const{_t}=require("@web/core/l10n/translation");const ImportDataContent=__exports.ImportDataContent=class ImportDataContent extends Component{static template="ImportDataContent";static components={ImportDataColumnError,ImportDataOptions,SelectMenu,};static props={columns:{type:Array},isFieldSet:{type:Function},onOptionChanged:{type:Function},onFieldChanged:{type:Function},options:{type:Object},importMessages:{type:Object},previewError:{type:String,optional:true},};getGroups(column){const groups=[{choices:this.makeChoices(column.fields.basic)},{choices:this.makeChoices(column.fields.suggested),label:_t("Suggested Fields")},{choices:this.makeChoices(column.fields.additional),label:column.fields.suggested.length>0?_t("Additional Fields"):_t("Standard Fields"),},{choices:this.makeChoices(column.fields.relational),label:_t("Relation Fields")},];return groups;}
makeChoices(fields){return fields.map((field)=>({label:field.label,value:field.fieldPath,iconClass:`o_import_field_icon_${field.type}`,}));}
getTooltipDetails(field){return JSON.stringify({resModel:field.model_name,debug:true,field:{name:field.name,label:field.string,type:field.type,},});}
getTooltip(column){const displayCount=5;if(column.previews.length>displayCount){return JSON.stringify({lines:[...column.previews.slice(0,displayCount-1),`(+${column.previews.length - displayCount + 1})`,],});}else{return JSON.stringify({lines:column.previews.slice(0,displayCount)});}}
getErrorMessageClass(messages,type,index){return`alert alert-${type} m-0 p-2 ${index === messages.length - 1 ? "" : "mb-2"}`;}
getCommentClass(column,comment,index){return`alert-${comment.type} ${index < column.comments.length - 1 ? "mb-2" : "mb-0"}`;}
onFieldChanged(column,fieldPath){const fields=[...column.fields.basic,...column.fields.suggested,...column.fields.additional,...column.fields.relational,];const fieldInfo=fields.find((f)=>f.fieldPath===fieldPath);this.props.onFieldChanged(column,fieldInfo);}}
return __exports;});;

/* /base_import/static/src/import_data_options/import_data_options.js */
odoo.define('@base_import/import_data_options/import_data_options',['@odoo/owl','@web/core/l10n/translation','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,useState,onWillStart}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{useService}=require("@web/core/utils/hooks");const ImportDataOptions=__exports.ImportDataOptions=class ImportDataOptions extends Component{static template="ImportDataOptions";static props={importOptions:{type:Object,optional:true},fieldInfo:{type:Object},onOptionChanged:{type:Function},};setup(){this.orm=useService("orm");this.state=useState({options:[],});this.currentModel=this.props.fieldInfo.comodel_name||this.props.fieldInfo.model_name;onWillStart(async()=>{this.state.options=await this.loadOptions();});}
get isVisible(){return["many2one","many2many","selection","boolean"].includes(this.props.fieldInfo.type);}
async loadOptions(){const options=[["prevent",_t("Prevent import")]];if(this.props.fieldInfo.type==="boolean"){options.push(["false",_t("Set to: False")]);options.push(["true",_t("Set to: True")]);!this.props.fieldInfo.required&&options.push(["import_skip_records",_t("Skip record")]);}
if(["many2one","many2many","selection"].includes(this.props.fieldInfo.type)){if(!this.props.fieldInfo.required){options.push(["import_set_empty_fields",_t("Set value as empty")]);options.push(["import_skip_records",_t("Skip record")]);}
if(this.props.fieldInfo.type==="selection"){const fields=await this.orm.call(this.currentModel,"fields_get");const selection=fields[this.props.fieldInfo.name].selection.map((opt)=>[opt[0],_t("Set to: %s",opt[1]),]);options.push(...selection);}else{options.push(["name_create_enabled_fields",_t("Create new values")]);}}
return options;}
onSelectionChanged(ev){if(["name_create_enabled_fields","import_set_empty_fields","import_skip_records",].includes(ev.target.value)){this.props.onOptionChanged(ev.target.value,ev.target.value,this.props.fieldInfo.fieldPath);}else{const value={fallback_value:ev.target.value,field_model:this.currentModel,field_type:this.props.fieldInfo.type,};this.props.onOptionChanged("fallback_values",value,this.props.fieldInfo.fieldPath);}}}
return __exports;});;

/* /base_import/static/src/import_data_progress/import_data_progress.js */
odoo.define('@base_import/import_data_progress/import_data_progress',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component,useEffect,useState}=require("@odoo/owl");const ImportDataProgress=__exports.ImportDataProgress=class ImportDataProgress extends Component{static template="ImportDataProgress";static props={importProgress:{type:Object},stopImport:{type:Function},totalSteps:{type:Number},};setup(){this.timer=undefined;this.timeStart=Date.now();this.state=useState({isInterrupted:false,timeLeft:null,});useEffect(()=>{this.updateTimer();return()=>{clearInterval(this.timer);};},()=>[]);}
get minutesLeft(){return this.state.timeLeft.toFixed(2);}
get secondsLeft(){return Math.round(this.state.timeLeft*60);}
interrupt(){this.state.isInterrupted=true;this.props.stopImport();}
updateTimer(){if(this.timer){clearInterval(this.timer);}
this.state.timeLeft=((Date.now()-this.timeStart)*((100-this.props.importProgress.value)/this.props.importProgress.value))/60000;this.timer=setInterval(()=>this.updateTimer(),1000);}}
return __exports;});;

/* /base_import/static/src/import_data_sidepanel/import_data_sidepanel.js */
odoo.define('@base_import/import_data_sidepanel/import_data_sidepanel',['@odoo/owl','@web/core/checkbox/checkbox','@web/core/l10n/translation','@web/views/widgets/documentation_link/documentation_link'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{CheckBox}=require("@web/core/checkbox/checkbox");const{_t}=require("@web/core/l10n/translation");const{DocumentationLink}=require("@web/views/widgets/documentation_link/documentation_link");const ImportDataSidepanel=__exports.ImportDataSidepanel=class ImportDataSidepanel extends Component{static template="ImportDataSidepanel";static components={CheckBox,DocumentationLink};static props={filename:{type:String},formattingOptions:{type:Object,optional:true},options:{type:Object},importTemplates:{type:Array,optional:true},isBatched:{type:Boolean,optional:true},onOptionChanged:{type:Function},onReload:{type:Function},hasBinaryFields:{type:Boolean},binaryFilesParams:{type:Object},onBinaryFilesParamsChanged:{type:Function},};get fileName(){return this.props.filename.split(".")[0];}
get fileExtension(){return"."+this.props.filename.split(".").pop();}
getOptionValue(name){if(name==="skip"){return(this.props.options.skip+1).toString();}
return this.props.options[name].toString();}
setOptionValue(name,value){this.props.onOptionChanged(name,isNaN(parseFloat(value))?value:Number(value));}
onLimitChange(ev){this.props.onOptionChanged("skip",ev.target.value?ev.target.value-1:0);}
get binaryFilesLabel(){const files=this.props.binaryFilesParams.binaryFiles.value;const number=Object.keys(files).length;if(number>0){return _t("%(number)s file(s) selected",{number});}
return _t("No file selected");}}
return __exports;});;

/* /base_import/static/src/import_model.js */
odoo.define('@base_import/import_model',['@web/core/l10n/translation','@web/core/registry','@web/core/utils/files','@web/core/utils/hooks','@web/core/utils/objects','@web/core/utils/arrays','@web/core/utils/functions','@web/session','@odoo/owl','@base_import/import_block_ui','@base_import/binary_file_manager'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{checkFileSize,DEFAULT_MAX_FILE_SIZE}=require("@web/core/utils/files");const{useService}=require("@web/core/utils/hooks");const{pick}=require("@web/core/utils/objects");const{groupBy,sortBy}=require("@web/core/utils/arrays");const{memoize}=require("@web/core/utils/functions");const{session}=require("@web/session");const{useState}=require("@odoo/owl");const{ImportBlockUI}=require("@base_import/import_block_ui");const{BinaryFileManager}=require("@base_import/binary_file_manager");const mainComponentRegistry=registry.category("main_components");const strftimeFormatTable={d:"w",DD:"d",ddd:"a",dddd:"A",DDDD:"j",ww:"U",WW:"W",mm:"M",MM:"m",MMM:"b",MMMM:"B",YYYY:"Y",YY:"y",ss:"S",hh:"h",HH:"H",A:"p",};const humanToStrftimeFormat=memoize(function humanToStrftimeFormat(value){const regex=/(dddd|ddd|dd|d|mmmm|mmm|mm|ww|yyyy|yy|hh|ss|a)/gi;return value.replace(regex,(value)=>{if(strftimeFormatTable[value]){return"%"+strftimeFormatTable[value];}
return("%"+
(strftimeFormatTable[value.toLowerCase()]||strftimeFormatTable[value.toUpperCase()]));});});const strftimeToHumanFormat=memoize(function strftimeToHumanFormat(value){Object.entries(strftimeFormatTable).forEach(([k,v])=>{value=value.replace(`%${v}`,k);});return value;});const BaseImportModel=__exports.BaseImportModel=class BaseImportModel{constructor({env,resModel,context,orm}){this.id=1;this.env=env;this.orm=orm;this.handleInterruption=false;this.resModel=resModel;this.context=context||{};this.fields=[];this.columns=[];this.importMessages=[];this._importOptions={};this.importTemplates=[];this.formattingOptionsValues=this._getCSVFormattingOptions();this.importOptionsValues={...this.formattingOptionsValues,advanced:{reloadParse:true,value:true,},has_headers:{reloadParse:true,value:true,},keep_matches:{value:false,},limit:{value:2000,},sheets:{value:[],},sheet:{label:_t("Selected Sheet:"),reloadParse:true,value:"",},skip:{value:0,},tracking_disable:{value:true,},};const maxUploadSize=session.max_file_upload_size||DEFAULT_MAX_FILE_SIZE;this.binaryFilesParams={binaryFiles:{value:{},},maxSizePerBatch:{help:_t("Defines how many megabytes can be imported in each batch import"),value:10,max:Math.round(maxUploadSize/1024/1024),min:0,},delayAfterEachBatch:{help:_t("After each batch import, this delay is applied to avoid unthrottled calls"),value:1,min:1,},};this.fieldsToHandle={};this.notificationService=useService("notification");}
get formattingOptions(){return pick(this.importOptionsValues,...Object.keys(this.formattingOptionsValues));}
get formattedImportOptions(){const options=this.importOptions;options.date_format=humanToStrftimeFormat(options.date_format);options.datetime_format=humanToStrftimeFormat(options.datetime_format);return options;}
get importOptions(){const tempImportOptions={import_skip_records:[],import_set_empty_fields:[],fallback_values:{},name_create_enabled_fields:{},};for(const[name,option]of Object.entries(this.importOptionsValues)){tempImportOptions[name]=option.value;}
for(const key in this.fieldsToHandle){const value=this.fieldsToHandle[key];if(value){if(value.optionName==="import_skip_records"){tempImportOptions.import_skip_records.push(key);}else if(value.optionName==="import_set_empty_fields"){tempImportOptions.import_set_empty_fields.push(key);}else if(value.optionName==="name_create_enabled_fields"){tempImportOptions.name_create_enabled_fields[key]=true;}else if(value.optionName==="fallback_values"){tempImportOptions.fallback_values[key]=value.value;}}}
this._importOptions=tempImportOptions;return tempImportOptions;}
set importOptions(options){for(const key in options){this.importOptionsValues[key].value=options[key];}}
block(message,blockComponent){mainComponentRegistry.add("ImportBlockUI",{Component:ImportBlockUI,props:{blockComponent,message,},},{force:true});}
unblock(){mainComponentRegistry.remove("ImportBlockUI");}
async init(){[this.importTemplates,this.id]=await Promise.all([this.orm.call(this.resModel,"get_import_templates",[],{context:this.context,}),this.orm.call("base_import.import","create",[{res_model:this.resModel}]),]);}
async executeImport(isTest=false,totalSteps,importProgress){this.handleInterruption=false;this._updateComments();this.importMessages=[];const startRow=this.importOptions.skip;const importRes={ids:[],fields:this.columns.map((e)=>Boolean(e.fieldInfo)&&e.fieldInfo.fieldPath),columns:this.columns.map((e)=>e.name.trim().toLowerCase()),hasError:false,};for(let i=1;i<=totalSteps;i++){if(this.handleInterruption){if(importRes.hasError||isTest){importRes.nextrow=startRow;this.setOption("skip",startRow);}
break;}
const error=await this._executeImportStep(isTest,importRes);if(error){const errorData=error.data||{};const message=errorData.arguments&&(errorData.arguments[1]||errorData.arguments[0])||_t("An unknown issue occurred during import (possibly lost connection, data limit exceeded or memory limits exceeded). Please retry in case the issue is transient. If the issue still occurs, try to split the file rather than import it at once.");if(error.message){this._addMessage("danger",[error.message,message]);}else{this._addMessage("danger",[message]);}
importRes.hasError=true;break;}
if(importProgress){importProgress.step=i;importProgress.value=Math.round((100*(i-1))/totalSteps);}}
if(!importRes.hasError){if(importRes.nextrow){this._addMessage("warning",[_t("Click 'Resume' to proceed with the import, resuming at line %s.",importRes.nextrow+1),_t("You can test or reload your file before resuming the import."),]);}
if(isTest){this._addMessage("info",[_t("Everything seems valid.")]);}}else{importRes.nextrow=startRow;}
return{res:importRes};}
async updateData(fileChanged=false){if(fileChanged){this.importOptionsValues.sheet.value="";}
this.importMessages=[];const res=await this.orm.call("base_import.import","parse_preview",[this.id,this.formattedImportOptions,]);if(!res.error){res.options.date_format=strftimeToHumanFormat(res.options.date_format);res.options.datetime_format=strftimeToHumanFormat(res.options.datetime_format);this._onLoadSuccess(res);}else{this._onLoadError();}
return{res,error:res.error};}
async setOption(optionName,value,fieldName){if(fieldName){this.fieldsToHandle[fieldName]={optionName,value,};return;}
this.importOptionsValues[optionName].value=value;if(this.importOptionsValues[optionName].reloadParse){return this.updateData();}}
onBinaryFilesParamsChanged(parameterName,value){if(parameterName==="binaryFiles"){const files={};for(const file of value){if(checkFileSize(file.size,this.notificationService)){files[file.name]=file;}}
value=files;}
this.binaryFilesParams[parameterName].value=value;}
setColumnField(column,fieldInfo){column.fieldInfo=fieldInfo;this._updateComments(column);}
isColumnFieldSet(column){return column.fieldInfo!=null;}
stopImport(){this.handleInterruption=true;}
_addMessage(type,lines){const importMsgs=this.importMessages;importMsgs.push({type:type.replace("error","danger"),lines,});this.importMessages=importMsgs;}
async _executeImportStep(isTest,importRes){const importArgs=[this.id,importRes.fields,importRes.columns,this.formattedImportOptions,];const{ids,messages,nextrow,name,error,binary_filenames}=await this._callImport(isTest,importArgs);if(error){return error;}
if(ids){importRes.ids=importRes.ids.concat(ids);}
if(messages&&messages.length){importRes.hasError=true;this.stopImport();if(this._handleImportErrors(messages,name)){return false;}}
await this._pushLocalImageToRecords(ids,binary_filenames,isTest);if(nextrow){this.setOption("skip",nextrow);importRes.nextrow=nextrow;}else{this.stopImport();}
return false;}
async _pushLocalImageToRecords(ids,binaryFilenames,isTest){if(typeof binaryFilenames==="object"){const parameters={tracking_disable:this.importOptions.tracking_disable,delayAfterEachBatch:this.binaryFilesParams.delayAfterEachBatch.value,maxBatchSize:this.binaryFilesParams.maxSizePerBatch.value*1024*1024,};if(!this.binaryFilesParams.binaryFiles){return;}
const binaryFiles=this.binaryFilesParams.binaryFiles.value;const fields=Object.keys(binaryFilenames);const binaryFileManager=new BinaryFileManager(this.resModel,fields,parameters,this.context,this.orm,this.notificationService);for(let rowIndex=0;rowIndex<ids.length;rowIndex++){const id=ids[rowIndex];for(const field of fields){const fileName=binaryFilenames[field][rowIndex];if(!fileName){continue;}
if(fileName in binaryFiles){const file=binaryFiles[fileName];if(!file||isTest){continue;}
await binaryFileManager.addFile(id,field,file);}}}
if(!isTest){await binaryFileManager.sendLastPayload();}}}
async _callImport(dryrun,args){try{const res=await this.orm.silent.call("base_import.import","execute_import",args,{dryrun,context:{...this.context,tracking_disable:this.importOptions.tracking_disable,},});return res;}catch(error){return{error};}}
_handleImportErrors(messages,name){if(messages[0].not_matching_error){this._addMessage(messages[0].type,[messages[0].message]);return true;}
const sortedMessages=this._groupErrorsByField(messages);if(sortedMessages[0]){this._addMessage(sortedMessages[0].type,[sortedMessages[0].message]);delete sortedMessages[0];}else{this._addMessage("danger",[_t("The file contains blocking errors (see below)")]);}
for(const[columnFieldId,errors]of Object.entries(sortedMessages)){const column=this.columns.find((e)=>e.fieldInfo&&e.fieldInfo.fieldPath===columnFieldId);if(column){column.resultNames=name;column.errors=errors;}else{for(const error of errors){if(error.record!==undefined){this._addMessage("danger",[error.rows.from===error.rows.to?_t('Error at row %(row)s: "%(error)s"',{row:error.record,error:error.message,}):_t("%s at multiple rows",error.message),]);}
else{this._addMessage("danger",[error.message]);}}}}}
_groupErrorsByField(messages){const groupedErrors={};const errorsByMessage=groupBy(this._sortErrors(messages),(f)=>f.message||"0");for(const[message,errors]of Object.entries(errorsByMessage)){if(!message.record){const foundError=errors.find((e)=>e.record===undefined);if(foundError){groupedErrors[0]=foundError;continue;}}
errors[0].rows.to=errors[errors.length-1].rows.to;const fieldId=errors[0].field_path?errors[0].field_path.join("/"):errors[0].field;if(groupedErrors[fieldId]){groupedErrors[fieldId].push(errors[0]);}else{groupedErrors[fieldId]=[errors[0]];}}
return groupedErrors;}
_sortErrors(messages){return sortBy(messages,(e)=>["error","warning","info"].indexOf(e.priority));}
_onLoadSuccess(res){for(const key in res.options){if(this.importOptionsValues[key]){this.importOptionsValues[key].value=res.options[key];}}
if(!res.fields.length){this.importOptionsValues.advanced.value=res.advanced_mode;}
this.fields=res.fields;this.columns=this._getColumns(res);if(res.headers.length===1){this._addMessage("warning",[_t("A single column was found in the file, this often means the file separator is incorrect."),]);}
this._updateComments();}
_onLoadError(){this.columns=[];this.importMessages=[];}
_getColumns(res){function getId(res,index){return res.matches&&index in res.matches&&res.matches[index].length>0?res.matches[index].join("/"):undefined;}
if(this.importOptions.has_headers&&res.headers&&res.preview.length>0){return res.headers.flatMap((header,index)=>{return this._createColumn(res,getId(res,index),header,index,res.preview[index],res.preview[index][0]);});}else if(res.preview&&res.preview.length>=2){return res.preview.flatMap((preview,index)=>this._createColumn(res,preview[0],this.importOptions.has_headers?preview[0]:preview.join(", "),index,preview,preview[1]));}
return[];}
_createColumn(res,id,name,index,previews,preview){const fields=this._getFields(res,index);return{id,name,preview,previews,fields,fieldInfo:this._findField(fields,id),comments:[],errors:[],};}
_findField(fields,id){return Object.entries(fields).flatMap((e)=>e[1]).find((field)=>field.fieldPath===id);}
_getFields(res,index){const advanced=this.importOptionsValues.advanced.value;const fields={basic:[],suggested:[],additional:[],relational:[],};function isRegular(subfields){return(!subfields||subfields.length===0||(subfields.length===2&&subfields[0].name==="id"&&subfields[1].name===".id"));}
function hasType(types,field){return types&&types.indexOf(field.type)!==-1;}
const sortSingleField=(field,ancestors,collection,types)=>{ancestors.push(field);field.fieldPath=ancestors.map((f)=>f.name).join("/");field.label=ancestors.map((f)=>f.string).join(" / ");if(!collection){if(field.name==="id"){collection=fields.basic;}else if(isRegular(field.fields)){collection=hasType(types,field)?fields.suggested:fields.additional;}else{collection=fields.relational;}}
collection.push(field);if(advanced){for(const subfield of field.fields){sortSingleField(subfield,[...ancestors],collection,types);}}};for(const field of this.fields){if(!field.isRelation){if(advanced){sortSingleField(field,[],undefined,["all"]);}else{const acceptedTypes=res.header_types[index];sortSingleField(field,[],undefined,acceptedTypes);}}}
return fields;}
_updateComments(updatedColumn){for(const column of this.columns){column.comments=[];column.errors=[];column.resultNames=[];column.importOptions=column.fieldInfo&&this.fieldsToHandle[column.fieldInfo.fieldPath];if(!column.fieldInfo){continue;}
if(["char","text","many2many"].includes(column.fieldInfo.type)){if(column.fieldInfo.type==="many2many"){column.comments.push({type:"info",content:_t("To import multiple values, separate them by a comma."),});}
const samefieldColumns=this.columns.filter((col)=>col.fieldInfo&&col.fieldInfo.fieldPath===column.fieldInfo.fieldPath);if(samefieldColumns.length>=2){column.comments.push({type:"info",content:_t("This column will be concatenated in field"),fieldName:column.fieldInfo.string,});}}else if(updatedColumn&&column.id!==updatedColumn.id&&updatedColumn.fieldInfo){if(updatedColumn.fieldInfo.fieldPath===column.fieldInfo.fieldPath){column.fieldInfo=null;}}}}
_getCSVFormattingOptions(){return{encoding:{label:_t("Encoding:"),type:"select",value:"",options:["utf-8","utf-16","windows-1252","latin1","latin2","big5","gb18030","shift_jis","windows-1251","koi8_r",],},separator:{label:_t("Separator:"),type:"select",value:"",options:[{value:",",label:_t("Comma")},{value:";",label:_t("Semicolon")},{value:"\t",label:_t("Tab")},{value:" ",label:_t("Space")},],},quoting:{label:_t("Text Delimiter:"),type:"input",value:'"',},date_format:{help:_t("Use YYYY to represent the year, MM for the month and DD for the day. Include separators such as a dot, forward slash or dash. You can use a custom format in addition to the suggestions provided. Leave empty to let Odoo guess the format (recommended)"),label:_t("Date Format:"),type:"input",value:"",options:["YYYY-MM-DD","YYYY/MM/DD","DD/MM/YYYY","DDMMYYYY","MM/DD/YYYY","MMDDYYYY",],},datetime_format:{help:_t("Use HH for hours in a 24h system, use II in conjonction with 'p' for a 12h system. You can use a custom format in addition to the suggestions provided. Leave empty to let Odoo guess the format (recommended)"),label:_t("Datetime Format:"),type:"input",value:"",options:["YYYY-MM-DD HH:mm:SS","YYYY/MM/DD HH:mm:SS","DD/MM/YYYY HH:mm:SS","DDMMYYYY HH:mm:SS","MM/DD/YYYY II:mm:SS p","MMDDYYYY II:mm:SS p",],},float_thousand_separator:{label:_t("Thousands Separator:"),type:"select",value:",",options:[{value:",",label:_t("Comma")},{value:".",label:_t("Dot")},{value:"",label:_t("No Separator")},],},float_decimal_separator:{label:_t("Decimals Separator:"),type:"select",value:".",options:[{value:",",label:_t("Comma")},{value:".",label:_t("Dot")},],},};}}
__exports.useImportModel=useImportModel;function useImportModel({env,resModel,context,orm}){return useState(new BaseImportModel({env,resModel,context,orm}));}
return __exports;});;

/* /base_import/static/src/import_records/import_records.js */
odoo.define('@base_import/import_records/import_records',['@odoo/owl','@web/core/dropdown/dropdown_item','@web/core/registry','@web/core/utils/hooks','@web/core/utils/strings','@web/search/action_menus/action_menus'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{exprToBoolean}=require("@web/core/utils/strings");const{STATIC_ACTIONS_GROUP_NUMBER}=require("@web/search/action_menus/action_menus");const cogMenuRegistry=registry.category("cogMenu");const ImportRecords=__exports.ImportRecords=class ImportRecords extends Component{static template="base_import.ImportRecords";static components={DropdownItem};static props={};setup(){this.action=useService("action");}
importRecords(){const{context,resModel}=this.env.searchModel;this.action.doAction({type:"ir.actions.client",tag:"import",params:{active_model:resModel,context},});}}
const importRecordsItem=__exports.importRecordsItem={Component:ImportRecords,groupNumber:STATIC_ACTIONS_GROUP_NUMBER,isDisplayed:({config,isSmall})=>!isSmall&&config.actionType==="ir.actions.act_window"&&["kanban","list"].includes(config.viewType)&&exprToBoolean(config.viewArch.getAttribute("import"),true)&&exprToBoolean(config.viewArch.getAttribute("create"),true),};cogMenuRegistry.add("import-menu",importRecordsItem,{sequence:1});return __exports;});;

/* /account_loans/static/src/components/loans/file_upload.js */
odoo.define('@account_loans/components/loans/file_upload',['@web/core/registry','@web/core/utils/hooks','@web/views/fields/file_handler','@web/views/widgets/standard_widget_props','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{FileUploader}=require("@web/views/fields/file_handler");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{Component}=require("@odoo/owl");const NewLoanComponent=__exports.NewLoanComponent=class NewLoanComponent extends Component{static template="account_accountant.NewLoan";static components={FileUploader,};static props={...standardWidgetProps,record:{type:Object,optional:true},};setup(){this.orm=useService("orm");this.action=useService("action");}
async onFileUploaded(file){if(this.props.record&&this.props.record.data.name){await this.props.record.model.root.save({reload:false});}
const att_data={name:file.name,mimetype:file.type,datas:file.data,};const[att_id]=await this.orm.create("ir.attachment",[att_data]);const action=await this.orm.call("account.loan","action_upload_amortization_schedule",[this.props.record?.resId,att_id]);this.action.doAction(action);}
async openComputeWizard(){if(this.props.record&&this.props.record.data.name){await this.props.record.model.root.save({reload:false});}
const action=await this.orm.call("account.loan","action_open_compute_wizard",[this.props.record?.resId]);this.action.doAction(action);}}
const newLoan=__exports.newLoan={component:NewLoanComponent,};registry.category("view_widgets").add("new_loan",newLoan);return __exports;});;

/* /account_loans/static/src/components/loans/import_action.js */
odoo.define('@account_loans/components/loans/import_action',['@odoo/owl','@web/core/registry','@web/core/utils/hooks','@base_import/import_action/import_action','@base_import/import_model'],function(require){'use strict';let __exports={};const{useState,onWillStart}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{ImportAction}=require("@base_import/import_action/import_action");const{BaseImportModel}=require("@base_import/import_model");class AccountLoanImportModel extends BaseImportModel{async init(){return Promise.resolve();}}
const AccountLoanImportAction=__exports.AccountLoanImportAction=class AccountLoanImportAction extends ImportAction{setup(){super.setup();this.action=useService("action");this.model=useState(new AccountLoanImportModel({env:this.env,resModel:this.resModel,context:this.props.action.params.context||{},orm:this.orm,}));onWillStart(async()=>{if(this.props.action.params.context){this.model.id=this.props.action.params.context.wizard_id;await super.handleFilesUpload([{name:this.props.action.params.filename}])}});}
async exit(){if(this.model.resModel==="account.loan.line"){const action=await this.orm.call("account.loan","action_file_uploaded",[this.model.context.default_loan_id]);return this.action.doAction(action);}
super.exit();}}
registry.category("actions").add("import_loan",AccountLoanImportAction);return __exports;});;

/* /website_forum/static/src/js/tours/website_forum.js */
odoo.define('@website_forum/js/tours/website_forum',['@web/core/l10n/translation','@website/js/tours/tour_utils'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registerBackendAndFrontendTour,}=require('@website/js/tours/tour_utils');registerBackendAndFrontendTour("question",{url:'/forum/1',},()=>[{trigger:".o_wforum_ask_btn",tooltipPosition:"left",content:_t("Create a new post in this forum by clicking on the button."),run:"click",},{trigger:"input[name=post_name]",tooltipPosition:"top",content:_t("Give your post title."),run:"edit Test",},{trigger:`input[name=post_name]:not(:empty)`,},{trigger:".note-editable p",content:_t("Put your question here."),tooltipPosition:"bottom",run:"editor Test",},{trigger:`.note-editable p:not(:contains(/^<br>$/))`,},{trigger:".o_select_menu_toggler",content:_t("Insert tags related to your question."),tooltipPosition:"top",run:"click",},{trigger:".o_select_menu_sticky",run:"edit Test",},{trigger:`.o_popover input.o_select_menu_sticky:not(:contains(Please enter 2 or more characters))`,},{content:"Select found select menu item",trigger:".o_popover.o_select_menu_menu .o_select_menu_item span:contains('Test')",run:'click',},{content:"Close search bar",trigger:"body",run:'click',},{trigger:"button:contains(/^Post/)",content:_t("Click to post your question."),tooltipPosition:"bottom",run:"click",},{trigger:".o_wforum_content_wrapper h3:contains(test)",},{isActive:["auto"],trigger:".modal.modal_shown.show:contains(thanks for posting!) button.btn-close",run:"click",},{trigger:"a:contains(Reply).collapsed",content:_t("Click to reply."),tooltipPosition:"bottom",run:"click",},{trigger:".note-editable p",content:_t("Put your answer here."),tooltipPosition:"bottom",run:"editor Test",},{trigger:`.note-editable p:not(:contains(/^<br>$/))`,},{trigger:"button:contains(\"Post Answer\")",content:_t("Click to post your answer."),tooltipPosition:"bottom",run:"click",},{trigger:".o_wforum_content_wrapper h3:contains(test)",},{isActive:["auto"],trigger:".modal.modal_shown.show:contains(thanks for posting!) button.btn-close",run:"click",},{trigger:".o_wforum_validate_toggler[data-karma]:first",content:_t("Click here to accept this answer."),tooltipPosition:"right",run:"click",},{content:"Check edit button is there",trigger:"a:contains('Edit your answer')",}]);return __exports;});;

/* /website_livechat/static/src/web/channel_member_model_patch.js */
odoo.define('@website_livechat/web/channel_member_model_patch',['@mail/core/common/channel_member_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ChannelMember}=require("@mail/core/common/channel_member_model");const{patch}=require("@web/core/utils/patch");patch(ChannelMember.prototype,{getLangName(){if(this.persona.is_public&&this.thread.visitor?.langName){return this.thread.visitor.langName;}
return super.getLangName();},});return __exports;});;

/* /website_livechat/static/src/web/thread_model_patch.js */
odoo.define('@website_livechat/web/thread_model_patch',['@mail/core/common/record','@mail/core/common/thread_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Record}=require("@mail/core/common/record");const{Thread}=require("@mail/core/common/thread_model");const{patch}=require("@web/core/utils/patch");patch(Thread.prototype,{setup(){super.setup(...arguments);this.visitor=Record.one("Persona");this.visitorPartner=Record.one("Persona");},});return __exports;});;

/* /website_livechat/static/src/web/thread_patch.js */
odoo.define('@website_livechat/web/thread_patch',['@mail/core/common/thread','@mail/core/common/im_status'],function(require){'use strict';let __exports={};const{Thread}=require("@mail/core/common/thread");const{ImStatus}=require("@mail/core/common/im_status");Object.assign(Thread.components,{ImStatus});return __exports;});;

/* /website_livechat/static/src/web/website_livechat_notification_handler.js */
odoo.define('@website_livechat/web/website_livechat_notification_handler',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const websiteLivechatNotifications=__exports.websiteLivechatNotifications={dependencies:["bus_service","mail.store"],start(env,{bus_service:busService,"mail.store":store}){busService.subscribe("website_livechat.send_chat_request",(payload)=>{const{Thread}=store.insert(payload);for(const thread of Thread){const chatWindow=store.ChatWindow.insert({thread});chatWindow.open();chatWindow.focus();}});},};registry.category("services").add("website_livechat.notifications",websiteLivechatNotifications);return __exports;});;

/* /website_helpdesk_livechat/static/src/core/web/store_service_patch.js */
odoo.define('@website_helpdesk_livechat/core/web/store_service_patch',['@mail/core/common/store_service','@web/core/l10n/translation','@web/core/registry','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Store}=require("@mail/core/common/store_service");const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{patch}=require("@web/core/utils/patch");const StorePatch={onStarted(){super.onStarted();if(this.helpdesk_livechat_active){registry.category("discuss.channel_commands").add("ticket",{help:_t("Create a new helpdesk ticket (/ticket ticket title)"),methodName:"execute_command_helpdesk",},{force:true}).add("search_tickets",{force:true,help:_t("Search helpdesk tickets (/search_tickets keyword)"),methodName:"execute_command_helpdesk_search",},{force:true});}else{registry.category("discuss.channel_commands").remove("ticket");registry.category("discuss.channel_commands").remove("search_tickets");}},};patch(Store.prototype,StorePatch);return __exports;});;

/* /website_helpdesk_livechat/static/src/message_service_patch.js */
odoo.define('@website_helpdesk_livechat/message_service_patch',['@mail/core/common/message','@odoo/owl','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message");const{markup}=require("@odoo/owl");const{patch}=require("@web/core/utils/patch");function addNewTicketsToMessage(oldMessage,newElement){const parsedDoc=new DOMParser().parseFromString(oldMessage,'text/html');const loadMoreDiv=parsedDoc.querySelector('.o_load_more');if(loadMoreDiv){loadMoreDiv.parentElement.removeChild(loadMoreDiv);}
const tempContainer=parsedDoc.createElement('div');tempContainer.innerHTML=newElement;const bodyElement=parsedDoc.querySelector('.o_mail_notification');while(tempContainer.firstChild){bodyElement.appendChild(tempContainer.firstChild);}
return markup(parsedDoc.documentElement.outerHTML);}
patch(Message.prototype,{async loadMoreTickets(message,listKeywords,loadCounter){const ticketsHTML=await this.env.services.orm.call("discuss.channel","fetch_ticket_by_keyword",[this.props.message.resId],{list_keywords:listKeywords.split(" "),load_counter:parseInt(loadCounter),});message.body=addNewTicketsToMessage(message.body,ticketsHTML);},onClick(ev){const{oeLst,oeLoadCounter,oeType}=ev.target.dataset;if(oeType=="load"){this.loadMoreTickets(this.props.message,oeLst,oeLoadCounter);return;}
super.onClick(ev);},});return __exports;});;

/* /purchase_stock/static/src/js/tours/purchase_stock.js */
odoo.define('@purchase_stock/js/tours/purchase_stock',['@web/core/l10n/translation','@purchase/js/tours/purchase_steps','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const PurchaseAdditionalTourSteps=require("@purchase/js/tours/purchase_steps")[Symbol.for("default")];const{patch}=require("@web/core/utils/patch");patch(PurchaseAdditionalTourSteps.prototype,{_get_purchase_stock_steps:function(){return[{trigger:".o-form-buttonbox button[name='action_view_picking']",},{trigger:".o-form-buttonbox button[name='action_view_picking']",content:_t("Receive the ordered products."),tooltipPosition:"bottom",run:'click',},{trigger:".o_statusbar_buttons button[name='button_validate']",content:_t("Validate the receipt of all ordered products."),tooltipPosition:"bottom",run:'click',},{trigger:".modal-dialog",},{trigger:".modal-footer .btn-primary",content:_t("Process all the receipt quantities."),tooltipPosition:"bottom",run:"click",},{trigger:".o_back_button a, .breadcrumb-item:not('.active'):last",content:_t('Go back to the purchase order to generate the vendor bill.'),tooltipPosition:'bottom',run:"click",},{trigger:".o_statusbar_buttons button[name='action_create_invoice']",content:_t("Generate the draft vendor bill."),tooltipPosition:"bottom",run:'click',}];}});__exports[Symbol.for("default")]=PurchaseAdditionalTourSteps;return __exports;});;

/* /base_iban/static/src/components/iban_widget/iban_widget.js */
odoo.define('@base_iban/components/iban_widget/iban_widget',['@web/core/registry','@web/views/fields/char/char_field','@web/core/utils/timing','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{CharField,charField}=require("@web/views/fields/char/char_field");const{useDebounced}=require("@web/core/utils/timing");const{useService}=require("@web/core/utils/hooks");const{useState}=require("@odoo/owl");const DELAY=__exports.DELAY=400;const IbanWidget=__exports.IbanWidget=class IbanWidget extends CharField{static template="base_iban.iban";setup(){super.setup();this.state=useState({isValidIBAN:null});this.orm=useService("orm");this.validateIbanDebounced=useDebounced(async(ev)=>{const iban=ev.target.value;if(!iban){this.state.isValidIBAN=null;}else if(!/[A-Za-z]{2}.{3,}/.test(iban)){this.state.isValidIBAN=false;}else{this.state.isValidIBAN=await this.orm.call("res.partner.bank","check_iban",[[],iban]);}},DELAY);}}
const ibanWidget=__exports.ibanWidget={...charField,component:IbanWidget,};registry.category("fields").add("iban",ibanWidget);return __exports;});;

/* /hr_payroll_holidays/static/src/js/hr_payslip_form.js */
odoo.define('@hr_payroll_holidays/js/hr_payslip_form',['@hr_payroll_holidays/views/hooks','@web/core/registry','@web/views/form/form_controller','@web/views/form/form_view'],function(require){'use strict';let __exports={};const{TimeOffToDeferWarning,useTimeOffToDefer}=require("@hr_payroll_holidays/views/hooks");const{registry}=require("@web/core/registry");const{FormController}=require("@web/views/form/form_controller");const{formView}=require("@web/views/form/form_view");const PayslipFormController=__exports.PayslipFormController=class PayslipFormController extends FormController{static template="hr_payroll_holidays.PayslipFormController";static components={...PayslipFormController.components,TimeOffToDeferWarning};setup(){super.setup();this.timeOff=useTimeOffToDefer();}}
registry.category("views").add("hr_payslip_form",{...formView,Controller:PayslipFormController,});return __exports;});;

/* /hr_payroll_holidays/static/src/js/hr_payslip_list.js */
odoo.define('@hr_payroll_holidays/js/hr_payslip_list',['@hr_payroll_holidays/views/hooks','@web/core/registry','@web/views/list/list_renderer','@web/views/list/list_view'],function(require){'use strict';let __exports={};const{TimeOffToDeferWarning,useTimeOffToDefer}=require("@hr_payroll_holidays/views/hooks");const{registry}=require("@web/core/registry");const{ListRenderer}=require("@web/views/list/list_renderer");const{listView}=require("@web/views/list/list_view");class PayslipListRenderer extends ListRenderer{static template="hr_payroll_holidays.PayslipListRenderer";static components={...ListRenderer.components,TimeOffToDeferWarning};setup(){super.setup();this.timeOff=useTimeOffToDefer();}}
const PayslipListView={...listView,Renderer:PayslipListRenderer,};registry.category("views").add("hr_payroll_payslip_tree",PayslipListView);return __exports;});;

/* /hr_payroll_holidays/static/src/views/hooks.js */
odoo.define('@hr_payroll_holidays/views/hooks',['@odoo/owl','@web/core/l10n/translation','@web/core/user','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component,onWillStart}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const TimeOffToDeferWarning=__exports.TimeOffToDeferWarning=class TimeOffToDeferWarning extends Component{static props={};static template="hr_payroll_holidays.TimeOffToDeferWarning";setup(){this.actionService=useService("action");}
get timeOffButtonText(){const[,before,inside,after]=_t("You have some <button>time off</button> to defer to the next month.").match(/(.*)<button>(.*)<\/button>(.*)/)??["You have some","time off","to defer to the next month.",];return{before,inside,after};}
onTimeOffToDefer(){this.actionService.doAction("hr_payroll_holidays.hr_leave_action_open_to_defer");}}
__exports.useTimeOffToDefer=useTimeOffToDefer;function useTimeOffToDefer(){const orm=useService("orm");const timeOff={};onWillStart(async()=>{const result=await orm.searchCount('hr.leave',[["payslip_state","=","blocked"],["state","=","validate"],["employee_company_id","in",user.context.allowed_company_ids]]);timeOff.hasTimeOffToDefer=result>0;});return timeOff;}
return __exports;});;

/* /hr_payroll_holidays/static/src/views/work_entry_calendar/hr_work_entry_calendar_controller.js */
odoo.define('@hr_payroll_holidays/views/work_entry_calendar/hr_work_entry_calendar_controller',['@hr_payroll_holidays/views/hooks','@hr_work_entry_contract/views/work_entry_calendar/work_entry_calendar_controller','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{TimeOffToDeferWarning,useTimeOffToDefer}=require("@hr_payroll_holidays/views/hooks");const{WorkEntryCalendarController}=require("@hr_work_entry_contract/views/work_entry_calendar/work_entry_calendar_controller");const{patch}=require("@web/core/utils/patch");patch(WorkEntryCalendarController.prototype,{setup(){super.setup(...arguments);this.timeOff=useTimeOffToDefer();},});patch(WorkEntryCalendarController,{template:"hr_payroll_holidays.WorkEntryCalendarController",components:{...WorkEntryCalendarController.components,TimeOffToDeferWarning},});return __exports;});;

/* /account_bank_statement_import/static/src/account_bank_statement_import_model.js */
odoo.define('@account_bank_statement_import/account_bank_statement_import_model',['@base_import/import_model','@web/core/utils/patch','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{BaseImportModel}=require("@base_import/import_model");const{patch}=require("@web/core/utils/patch");const{_t}=require("@web/core/l10n/translation");patch(BaseImportModel.prototype,{async init(){await super.init(...arguments);if(this.resModel==="account.bank.statement"){this.importTemplates.push({label:_t("Import Template for Bank Statements"),template:"/account_bank_statement_import/static/csv/account.bank.statement.csv",});}}});return __exports;});;

/* /account_bank_statement_import/static/src/bank_reconciliation/finish_buttons.js */
odoo.define('@account_bank_statement_import/bank_reconciliation/finish_buttons',['@web/core/utils/patch','@account/components/account_file_uploader/account_file_uploader','@account_accountant/components/bank_reconciliation/finish_buttons'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{AccountFileUploader}=require("@account/components/account_file_uploader/account_file_uploader");const{BankRecFinishButtons}=require("@account_accountant/components/bank_reconciliation/finish_buttons");patch(BankRecFinishButtons,{components:{AccountFileUploader,}})
return __exports;});;

/* /account_bank_statement_import/static/src/bank_reconciliation/kanban.js */
odoo.define('@account_bank_statement_import/bank_reconciliation/kanban',['@web/core/registry','@account/components/account_file_uploader/account_file_uploader','@account/components/upload_drop_zone/upload_drop_zone','@account_accountant/components/bank_reconciliation/kanban','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{AccountFileUploader}=require("@account/components/account_file_uploader/account_file_uploader");const{UploadDropZone}=require("@account/components/upload_drop_zone/upload_drop_zone");const{BankRecKanbanView,BankRecKanbanController,BankRecKanbanRenderer}=require("@account_accountant/components/bank_reconciliation/kanban");const{useState}=require("@odoo/owl");const BankRecKanbanUploadController=__exports.BankRecKanbanUploadController=class BankRecKanbanUploadController extends BankRecKanbanController{static components={...BankRecKanbanController.components,AccountFileUploader,}}
const BankRecUploadKanbanRenderer=__exports.BankRecUploadKanbanRenderer=class BankRecUploadKanbanRenderer extends BankRecKanbanRenderer{static template="account.BankRecKanbanUploadRenderer";static components={...BankRecKanbanRenderer.components,UploadDropZone,};setup(){super.setup();this.dropzoneState=useState({visible:false,});}
onDragStart(ev){if(ev.dataTransfer.types.includes("Files")){this.dropzoneState.visible=true}}}
const BankRecKanbanUploadView=__exports.BankRecKanbanUploadView={...BankRecKanbanView,Controller:BankRecKanbanUploadController,Renderer:BankRecUploadKanbanRenderer,buttonTemplate:"account.BankRecKanbanButtons",};registry.category("views").add('bank_rec_widget_kanban',BankRecKanbanUploadView,{force:true});return __exports;});;

/* /account_bank_statement_import/static/src/bank_reconciliation/list.js */
odoo.define('@account_bank_statement_import/bank_reconciliation/list',['@web/core/registry','@web/views/list/list_renderer','@account/components/account_file_uploader/account_file_uploader','@account/components/upload_drop_zone/upload_drop_zone','@account_accountant/components/bank_reconciliation/list','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{ListRenderer}=require("@web/views/list/list_renderer");const{AccountFileUploader}=require("@account/components/account_file_uploader/account_file_uploader");const{UploadDropZone}=require("@account/components/upload_drop_zone/upload_drop_zone");const{bankRecListView,BankRecListController}=require("@account_accountant/components/bank_reconciliation/list");const{useState}=require("@odoo/owl");const BankRecListUploadController=__exports.BankRecListUploadController=class BankRecListUploadController extends BankRecListController{static components={...BankRecListController.components,AccountFileUploader,}}
const BankRecListUploadRenderer=__exports.BankRecListUploadRenderer=class BankRecListUploadRenderer extends ListRenderer{static template="account.BankRecListUploadRenderer";static components={...ListRenderer.components,UploadDropZone,}
setup(){super.setup();this.dropzoneState=useState({visible:false});}
onDragStart(ev){if(ev.dataTransfer.types.includes("Files")){this.dropzoneState.visible=true}}}
const bankRecListUploadView=__exports.bankRecListUploadView={...bankRecListView,Controller:BankRecListUploadController,Renderer:BankRecListUploadRenderer,buttonTemplate:"account.BankRecListUploadButtons",}
registry.category("views").add("bank_rec_list",bankRecListUploadView,{force:true});return __exports;});;

/* /iap_extract/static/src/components/status_header/status.js */
odoo.define('@iap_extract/components/status_header/status',['@odoo/owl','@web/views/fields/standard_field_props','@web/core/utils/hooks','@web/core/registry'],function(require){'use strict';let __exports={};const{Component,onWillDestroy,onWillStart,onWillUpdateProps,useState}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{useService}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const CHECK_OCR_WAIT_DELAY=5*1000;const StatusHeader=__exports.StatusHeader=class StatusHeader extends Component{static template="account_invoice_extract.Status";static props=standardFieldProps;setup(){this.state=useState({status:this.props.record.data.extract_state,errorMessage:this.props.record.data.extract_error_message,retryLoading:false,checkStatusLoading:false,});this.orm=useService("orm");this.action=useService("action");this.busService=this.env.services.bus_service;onWillStart(()=>{this.subscribeToChannel(this.props.record.data.extract_document_uuid);this.busService.subscribe("state_change",({status,error_message})=>{this.state.status=status;this.state.errorMessage=error_message;});this.enableTimeout();});onWillDestroy(()=>{this.busService.deleteChannel(this.channelName);clearTimeout(this.timeoutId);});onWillUpdateProps((nextProps)=>{if(nextProps.record.id!==this.props.record.id){this.state.errorMessage=nextProps.record.data.extract_error_message;this.state.status=nextProps.record.data.extract_state;this.subscribeToChannel(nextProps.record.data.extract_document_uuid);this.enableTimeout();}});}
subscribeToChannel(documentUUID){if(!documentUUID){return;}
this.busService.deleteChannel(this.channelName);this.channelName=`extract.mixin.status#${documentUUID}`;this.busService.addChannel(this.channelName);}
enableTimeout(){if(!['waiting_extraction','extract_not_ready'].includes(this.state.status)){return;}
clearTimeout(this.timeoutId);this.timeoutId=setTimeout(async()=>{if(['waiting_extraction','extract_not_ready'].includes(this.state.status)){const[status,errorMessage]=(await this.orm.call(this.props.record.resModel,"check_ocr_status",[this.props.record.resId],{}))[0];this.state.status=status;this.state.errorMessage=errorMessage;}},CHECK_OCR_WAIT_DELAY);}
async checkOcrStatus(){this.state.checkStatusLoading=true;const[status,errorMessage]=(await this.orm.call(this.props.record.resModel,"check_ocr_status",[this.props.record.resId],{}))[0];if(status==="waiting_validation"){await this.refreshPage();return;}
this.state.status=status;this.state.errorMessage=errorMessage;this.state.checkStatusLoading=false;}
async refreshPage(){await this.action.switchView("form",{resId:this.props.record.resId,resIds:this.props.record.resIds});}
async buyCredits(){const actionData=await this.orm.call(this.props.record.resModel,"buy_credits",[this.props.record.resId],{});this.action.doAction(actionData);}
async retryDigitalization(){this.state.retryLoading=true;const[status,errorMessage,documentUUID]=await this.orm.call(this.props.record.resModel,"action_manual_send_for_digitization",[this.props.record.resId],{});this.subscribeToChannel(documentUUID);this.state.status=status;this.state.errorMessage=errorMessage;this.state.retryLoading=false;this.enableTimeout();}}
registry.category("fields").add("extract_state_header",{component:StatusHeader});return __exports;});;

/* /account_bank_statement_import_csv/static/src/bank_statement_csv_import_action.js */
odoo.define('@account_bank_statement_import_csv/bank_statement_csv_import_action',['@odoo/owl','@web/core/registry','@web/core/utils/hooks','@web/core/l10n/translation','@base_import/import_action/import_action','@account_bank_statement_import_csv/bank_statement_csv_import_model'],function(require){'use strict';let __exports={};const{onWillStart}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const{ImportAction}=require("@base_import/import_action/import_action");const{useBankStatementCSVImportModel}=require("@account_bank_statement_import_csv/bank_statement_csv_import_model");const BankStatementImportAction=__exports.BankStatementImportAction=class BankStatementImportAction extends ImportAction{setup(){super.setup();this.action=useService("action");this.model=useBankStatementCSVImportModel({env:this.env,resModel:this.resModel,context:this.props.action.params.context||{},orm:this.orm,});this.env.config.setDisplayName(_t("Import Bank Statement"));this.state.filename=this.props.action.params.filename||undefined;onWillStart(async()=>{if(this.props.action.params.context){this.model.id=this.props.action.params.context.wizard_id;await super.handleFilesUpload([{name:this.state.filename}])}});}
async exit(){if(this.model.statement_id){const res=await this.orm.call("account.bank.statement","action_open_bank_reconcile_widget",[this.model.statement_id]);return this.action.doAction(res);}
super.exit();}}
registry.category("actions").add("import_bank_stmt",BankStatementImportAction);return __exports;});;

/* /account_bank_statement_import_csv/static/src/bank_statement_csv_import_model.js */
odoo.define('@account_bank_statement_import_csv/bank_statement_csv_import_model',['@odoo/owl','@base_import/import_model'],function(require){'use strict';let __exports={};const{useState}=require("@odoo/owl");const{BaseImportModel}=require("@base_import/import_model");class BankStatementCSVImportModel extends BaseImportModel{async init(){this.importOptionsValues.bank_stmt_import={value:true,};return Promise.resolve();}
async _onLoadSuccess(res){super._onLoadSuccess(res);if(!res.messages||res.messages.length===0||res.messages.length>1){return;}
const message=res.messages[0];if(message.ids){this.statement_line_ids=message.ids}
if(message.messages&&message.messages.length>0){this.statement_id=message.messages[0].statement_id}}}
__exports.useBankStatementCSVImportModel=useBankStatementCSVImportModel;function useBankStatementCSVImportModel({env,resModel,context,orm}){return useState(new BankStatementCSVImportModel({env,resModel,context,orm}));}
return __exports;});;

/* /account_base_import/static/src/js/account_import_action.js */
odoo.define('@account_base_import/js/account_import_action',['@web/core/registry','@base_import/import_action/import_action','@web/core/utils/hooks','@web/core/l10n/translation','@account_base_import/js/account_import_model'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{ImportAction}=require("@base_import/import_action/import_action");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const{useAccountMoveLineImportModel}=require("@account_base_import/js/account_import_model");const AccountImportAction=__exports.AccountImportAction=class AccountImportAction extends ImportAction{setup(){super.setup();this.actionService=useService("action");this.model=useAccountMoveLineImportModel({env:this.env,resModel:this.resModel,context:this.props.action.params.context||{},orm:this.orm,});}
exit(resIds=null){if(resIds&&["account.move.line","account.account","res.partner"].includes(this.resModel)){const names={"account.move.line":_t("Journal Items"),"account.account":_t("Chart of Accounts"),"res.partner":_t("Customers"),}
const action={name:names[this.resModel],res_model:this.resModel,type:"ir.actions.act_window",views:[[false,"list"],[false,"form"]],view_mode:"list",domain:[["id","in",resIds]],}
if(this.resModel=="account.move.line"){action.context={"search_default_posted":0};}
return this.actionService.doAction(action);}
super.exit();}};registry.category("actions").add("account_import_action",AccountImportAction);return __exports;});;

/* /account_base_import/static/src/js/account_import_guide.js */
odoo.define('@account_base_import/js/account_import_guide',['@web/core/l10n/translation','@web/search/control_panel/control_panel','@web/core/registry','@web/core/utils/hooks','@odoo/owl','@web/webclient/actions/action_service'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ControlPanel}=require("@web/search/control_panel/control_panel");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{Component,onWillStart,onWillRender}=require("@odoo/owl");const{standardActionServiceProps}=require("@web/webclient/actions/action_service");const AccountImportGuide=__exports.AccountImportGuide=class AccountImportGuide extends Component{static template="account_base_import.accountImportTemplate";static components={ControlPanel};static props={...standardActionServiceProps};setup(){this.actionService=useService("action");this.orm=useService("orm");this.env.config.setDisplayName(_t("Accounting Import Guide"))
onWillStart(async()=>{const current_company_id=this.env.services.company.currentCompany.id
this.data=await this.orm.searchRead("res.company",[["id","=",current_company_id]],["country_code"])
this.isFecImportModuleInstalled=await this.orm.searchCount("ir.module.module",[["name","=","l10n_fr_fec_import"],["state","=","installed"]]);});onWillRender(()=>{this.countryCode=this.data[0].country_code});}
_importAccountGuideAction(action){this.actionService.doAction(action);}
_openModuleInstallation(module){this.actionService.doAction({name:_t("Install a module"),res_model:"ir.module.module",type:"ir.actions.act_window",views:[[false,"kanban"],[false,"list"],[false,"form"]],view_mode:"kanban,list,form",context:{"search_default_name":module,"search_default_extra":true,},});}};registry.category("actions").add("account_import_guide",AccountImportGuide);return __exports;});;

/* /account_base_import/static/src/js/account_import_model.js */
odoo.define('@account_base_import/js/account_import_model',['@odoo/owl','@base_import/import_model'],function(require){'use strict';let __exports={};const{useState}=require("@odoo/owl");const{BaseImportModel}=require("@base_import/import_model");class AccountMoveLineImportModel extends BaseImportModel{get importOptions(){const options=super.importOptions;if(this.resModel==="account.move.line"){Object.assign(options.name_create_enabled_fields,{journal_id:true,account_id:true,partner_id:true,});}
return options;}}
__exports.useAccountMoveLineImportModel=useAccountMoveLineImportModel;function useAccountMoveLineImportModel({env,resModel,context,orm}){return useState(new AccountMoveLineImportModel({env,resModel,context,orm}));}
return __exports;});;

/* /account_followup/static/src/components/change_trust_widget/followup_trust_widget.js */
odoo.define('@account_followup/components/change_trust_widget/followup_trust_widget',['@web/core/registry','@web/core/popover/popover_hook','@web/core/l10n/localization','@odoo/owl','@web/views/fields/standard_field_props'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{usePopover}=require("@web/core/popover/popover_hook");const{localization}=require("@web/core/l10n/localization");const{Component}=require("@odoo/owl");const{standardFieldProps}=require("@web/views/fields/standard_field_props");class FollowupTrustPopOver extends Component{static template="account_followup.FollowupTrustPopOver";static props={record:Object,widget:Object,close:{optional:true,type:Function},};}
class FollowupTrustWidget extends Component{static template="account_followup.FollowupTrustWidget";static props={...standardFieldProps};setup(){super.setup();const position=localization.direction==="rtl"?"bottom":"right";this.popover=usePopover(FollowupTrustPopOver,{position});}
displayTrust(){var selections=this.props.record.fields.trust.selection;var trust=this.props.record.data[this.props.name];for(var i=0;i<selections.length;i++){if(selections[i][0]==trust){return selections[i][1];}}}
onTrustClick(ev){this.popover.open(ev.currentTarget,{record:this.props.record,widget:this,});}
async setTrust(trust){this.props.record.update({[this.props.name]:trust});this.popover.close();}}
registry.category("fields").add("followup_trust_widget",{component:FollowupTrustWidget,});return __exports;});;

/* /account_followup/static/src/components/download_close_wizard_action/download_close_wizard_action.js */
odoo.define('@account_followup/components/download_close_wizard_action/download_close_wizard_action',['@web/core/browser/browser','@web/core/registry'],function(require){'use strict';let __exports={};const{browser}=require("@web/core/browser/browser");const{registry}=require("@web/core/registry");__exports.downloadAndCloseFollowupWizardAction=downloadAndCloseFollowupWizardAction;async function downloadAndCloseFollowupWizardAction(env,action){const url=action.params.url
try{browser.open(url);}
finally{return{type:"ir.actions.act_window_close"};}}
registry.category("actions").add("close_followup_wizard",downloadAndCloseFollowupWizardAction);return __exports;});;

/* /account_online_synchronization/static/src/components/account_duplicate_transaction/account_duplicate_transaction_form.js */
odoo.define('@account_online_synchronization/components/account_duplicate_transaction/account_duplicate_transaction_form',['@web/views/form/form_view','@web/views/form/form_controller','@web/core/registry','@account_online_synchronization/components/account_duplicate_transaction/account_duplicate_transaction_hook'],function(require){'use strict';let __exports={};const{formView}=require("@web/views/form/form_view");const{FormController}=require("@web/views/form/form_controller");const{registry}=require("@web/core/registry");const{useCheckDuplicateService}=require("@account_online_synchronization/components/account_duplicate_transaction/account_duplicate_transaction_hook");const AccountDuplicateTransactionsFormController=__exports.AccountDuplicateTransactionsFormController=class AccountDuplicateTransactionsFormController extends FormController{setup(){super.setup();this.duplicateCheckService=useCheckDuplicateService();}
async beforeExecuteActionButton(clickParams){if(clickParams.name==="delete_selected_transactions"){const selected=this.duplicateCheckService.selectedLines;if(selected.size){await this.orm.call("account.bank.statement.line","unlink",[Array.from(selected)],);this.env.services.action.doAction({type:'ir.actions.client',tag:'reload'});}
return false;}
return super.beforeExecuteActionButton(...arguments);}
get cogMenuProps(){const props=super.cogMenuProps;props.items.action=[];return props;}}
const form=__exports.form={...formView,Controller:AccountDuplicateTransactionsFormController};registry.category("views").add("account_duplicate_transactions_form",form);return __exports;});;

/* /account_online_synchronization/static/src/components/account_duplicate_transaction/account_duplicate_transaction_hook.js */
odoo.define('@account_online_synchronization/components/account_duplicate_transaction/account_duplicate_transaction_hook',['@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{useState}=require("@odoo/owl");__exports.useCheckDuplicateService=useCheckDuplicateService;function useCheckDuplicateService(){return useState(useService("account_online_synchronization.duplicate_check_service"));}
return __exports;});;

/* /account_online_synchronization/static/src/components/account_duplicate_transaction/account_duplicate_transaction_service.js */
odoo.define('@account_online_synchronization/components/account_duplicate_transaction/account_duplicate_transaction_service',['@web/core/registry'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");class AccountDuplicateTransactionsServiceModel{constructor(){this.selectedLines=new Set();}
updateLIne(selected,id){this.selectedLines[selected?"add":"delete"](id);}}
const duplicateCheckService={start(env,services){return new AccountDuplicateTransactionsServiceModel();},};registry.category("services").add("account_online_synchronization.duplicate_check_service",duplicateCheckService);return __exports;});;

/* /account_online_synchronization/static/src/components/account_duplicate_transaction/account_duplicate_transactions_x2many.js */
odoo.define('@account_online_synchronization/components/account_duplicate_transaction/account_duplicate_transactions_x2many',['@odoo/owl','@web/core/registry','@web/views/list/list_renderer','@web/views/fields/x2many/x2many_field','@account_online_synchronization/components/account_duplicate_transaction/account_duplicate_transaction_hook'],function(require){'use strict';let __exports={};const{onMounted}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{ListRenderer}=require("@web/views/list/list_renderer");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const{useCheckDuplicateService}=require("@account_online_synchronization/components/account_duplicate_transaction/account_duplicate_transaction_hook");const AccountDuplicateTransactionsListRenderer=__exports.AccountDuplicateTransactionsListRenderer=class AccountDuplicateTransactionsListRenderer extends ListRenderer{static template="account_online_synchronization.AccountDuplicateTransactionsListRenderer";static recordRowTemplate="account_online_synchronization.AccountDuplicateTransactionsRecordRow";setup(){super.setup();this.duplicateCheckService=useCheckDuplicateService();onMounted(()=>{this.deleteButton=document.querySelector('button[name="delete_selected_transactions"]');this.deleteButton.disabled=true;});}
toggleRecordSelection(selected,record){this.duplicateCheckService.updateLIne(selected,record.data.id);this.deleteButton.disabled=this.duplicateCheckService.selectedLines.size===0;}
get hasSelectors(){return true;}
getRowClass(record){let classes=super.getRowClass(record);const firstIdsInGroup=this.env.model.root.data.first_ids_in_group;if(firstIdsInGroup instanceof Array&&firstIdsInGroup.includes(record.data.id)){classes+=" account_duplicate_transactions_lines_list_x2many_group_line";}
return classes;}}
const AccountDuplicateTransactionsLinesListX2ManyField=__exports.AccountDuplicateTransactionsLinesListX2ManyField=class AccountDuplicateTransactionsLinesListX2ManyField extends X2ManyField{static components={...X2ManyField.components,ListRenderer:AccountDuplicateTransactionsListRenderer,};}
registry.category("fields").add("account_duplicate_transactions_lines_list_x2many",{...x2ManyField,component:AccountDuplicateTransactionsLinesListX2ManyField,});return __exports;});;

/* /account_online_synchronization/static/src/components/bank_configure/bank_configure.js */
odoo.define('@account_online_synchronization/components/bank_configure/bank_configure',['@web/core/registry','@web/views/widgets/standard_widget_props','@web/core/utils/hooks','@web/core/ui/ui_service','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{useService,useBus}=require("@web/core/utils/hooks");const{SIZES}=require("@web/core/ui/ui_service");const{Component,useState,useRef,onWillStart}=require("@odoo/owl");class BankConfigureWidget extends Component{static template="account.BankConfigureWidget";static props={...standardWidgetProps,}
setup(){this.container=useRef("container");this.allInstitutions=[];this.state=useState({isLoading:true,institutions:[],gridStyle:"grid-template-columns: repeat(5, minmax(90px, 1fr));"});this.orm=useService("orm");this.action=useService("action");this.ui=useService("ui");onWillStart(this.fetchInstitutions);useBus(this.ui.bus,"resize",this.computeGrid);}
computeGrid(){if(this.allInstitutions.length>4){let containerWidth=this.container.el?this.container.el.offsetWidth-32:0;if(!containerWidth){if(this.ui.size>=SIZES.XXL){containerWidth=window.innerWidth/(this.props.record.model.root.count<6?2:3);}else{containerWidth=Math.max(this.ui.size*100,400);}}
const canFit=Math.floor(containerWidth/100);const numberOfRows=(Math.floor((this.allInstitutions.length+1)/2)>=canFit)+1;this.state.gridStyle=`grid-template-columns: repeat(${canFit}, minmax(90px, 1fr));
                                    grid-template-rows: repeat(${numberOfRows}, 1fr);
                                    grid-auto-rows: 0px;
                                   `;}
this.state.institutions=this.allInstitutions;}
async fetchInstitutions(){this.orm.silent.call(this.props.record.resModel,"fetch_online_sync_favorite_institutions",[this.props.record.resId]).then((response)=>{this.allInstitutions=response;}).finally(()=>{this.state.isLoading=false;this.computeGrid();});}
async connectBank(institutionId=null){const action=await this.orm.call("account.online.link","action_new_synchronization",[[]],{preferred_inst:institutionId,journal_id:this.props.record.resId,})
this.action.doAction(action);}
async fallbackConnectBank(){const action=await this.orm.call('account.online.link','create_new_bank_account_action',[],{context:{active_model:'account.journal',active_id:this.props.record.resId,}});this.action.doAction(action);}}
const bankConfigureWidget=__exports.bankConfigureWidget={component:BankConfigureWidget,}
registry.category("view_widgets").add("bank_configure",bankConfigureWidget);return __exports;});;

/* /account_online_synchronization/static/src/components/bank_reconciliation/fetch_missing_transactions_cog_menu.js */
odoo.define('@account_online_synchronization/components/bank_reconciliation/fetch_missing_transactions_cog_menu',['@odoo/owl','@web/core/dropdown/dropdown_item','@web/core/registry','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const cogMenuRegistry=registry.category("cogMenu");const FetchMissingTransactions=__exports.FetchMissingTransactions=class FetchMissingTransactions extends Component{static template="account_online_synchronization.FetchMissingTransactions";static components={DropdownItem};static props={};setup(){this.action=useService("action");}
async openFetchMissingTransactionsWizard(){const{context}=this.env.searchModel;const activeModel=context.active_model;let activeIds=[];if(activeModel==="account.journal"){activeIds=context.active_ids;}else if(!!context.default_journal_id){activeIds=context.default_journal_id;}
const action=await this.env.services.orm.call("account.journal","action_open_missing_transaction_wizard",[activeIds]);return this.action.doAction(action);}}
const fetchMissingTransactionItem=__exports.fetchMissingTransactionItem={Component:FetchMissingTransactions,groupNumber:5,isDisplayed:({config,isSmall})=>{return!isSmall&&config.actionType==="ir.actions.act_window"&&["kanban","list"].includes(config.viewType)&&["bank_rec_widget_kanban","bank_rec_list"].includes(config.viewSubType);},};cogMenuRegistry.add("fetch-missing-transaction-menu",fetchMissingTransactionItem,{sequence:1});return __exports;});;

/* /account_online_synchronization/static/src/components/bank_reconciliation/find_duplicate_transactions_cog_menu.js */
odoo.define('@account_online_synchronization/components/bank_reconciliation/find_duplicate_transactions_cog_menu',['@odoo/owl','@web/core/dropdown/dropdown_item','@web/core/registry','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const FindDuplicateTransactions=__exports.FindDuplicateTransactions=class FindDuplicateTransactions extends Component{static template="account_online_synchronization.FindDuplicateTransactions";static components={DropdownItem};static props={};setup(){this.action=useService("action");}
async openFindDuplicateTransactionsWizard(){const{context}=this.env.searchModel;const activeModel=context.active_model;let activeIds=[];if(activeModel==="account.journal"){activeIds=context.active_ids;}else if(context.default_journal_id){activeIds=context.default_journal_id;}
return this.action.doActionButton({type:"object",resModel:"account.journal",name:"action_open_duplicate_transaction_wizard",resIds:activeIds,})}}
const findDuplicateTransactionItem=__exports.findDuplicateTransactionItem={Component:FindDuplicateTransactions,groupNumber:5,isDisplayed:({config,isSmall})=>{return(!isSmall&&config.actionType==="ir.actions.act_window"&&["kanban","list"].includes(config.viewType)&&["bank_rec_widget_kanban","bank_rec_list"].includes(config.viewSubType))},};registry.category("cogMenu").add("find-duplicate-transaction-menu",findDuplicateTransactionItem,{sequence:3},);return __exports;});;

/* /account_online_synchronization/static/src/components/connected_until_widget/connected_until_widget.js */
odoo.define('@account_online_synchronization/components/connected_until_widget/connected_until_widget',['@web/core/registry','@web/views/widgets/standard_widget_props','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{useService}=require("@web/core/utils/hooks");const{Component,useState}=require("@odoo/owl");class ConnectedUntil extends Component{static template="account_online_synchronization.ConnectedUntil";static props={...standardWidgetProps};setup(){this.state=useState({isHovered:false,displayReconnectButton:false,});if(this.isConnectionExpiredIn(0)){this.state.displayReconnectButton=true;}
this.action=useService("action");this.orm=useService("orm");}
get cssClasses(){let cssClasses="text-nowrap w-100";if(this.isConnectionExpiredIn(7)){cssClasses+=this.isConnectionExpiredIn(3)?" text-danger":" text-warning";}
return cssClasses;}
onMouseEnter(){this.state.isHovered=true;}
onMouseLeave(){this.state.isHovered=false;}
isConnectionExpiredIn(nbDays){return this.props.record.data.expiring_synchronization_due_day<=nbDays;}
async extendConnection(){const action=await this.orm.call("account.journal","action_extend_consent",[this.props.record.resId],{});this.action.doAction(action);}}
const connectedUntil=__exports.connectedUntil={component:ConnectedUntil,};registry.category("view_widgets").add("connected_until_widget",connectedUntil);return __exports;});;

/* /account_online_synchronization/static/src/components/online_account_radio/online_account_radio.js */
odoo.define('@account_online_synchronization/components/online_account_radio/online_account_radio',['@odoo/owl','@web/core/registry','@web/views/fields/radio/radio_field','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{onMounted,useState}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{RadioField,radioField}=require("@web/views/fields/radio/radio_field");const{useService}=require('@web/core/utils/hooks');class OnlineAccountRadio extends RadioField{static template="account_online_synchronization.OnlineAccountRadio";setup(){super.setup();this.orm=useService("orm");this.state=useState({balances:{}});onMounted(async()=>{this.state.balances=await this.loadData();this.onChange(this.items[0]);});}
async loadData(){const ids=this.items.map(i=>i[0]);return await this.orm.call("account.online.account","get_formatted_balances",[ids]);}
getBalanceName(itemID){return this.state.balances?.[itemID]?.[0]??"Loading ...";}
isNegativeAmount(itemID){return this.state.balances?.[itemID]?.[1]<0;}}
registry.category("fields").add("online_account_radio",{...radioField,component:OnlineAccountRadio,});return __exports;});;

/* /account_online_synchronization/static/src/components/refresh_spin_journal_widget/refresh_spin_journal_widget.js */
odoo.define('@account_online_synchronization/components/refresh_spin_journal_widget/refresh_spin_journal_widget',['@web/core/registry','@web/views/widgets/standard_widget_props','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const{useService}=require("@web/core/utils/hooks");const{Component,useState,onWillStart}=require("@odoo/owl");class RefreshSpin extends Component{static template="account_online_synchronization.RefreshSpin";static props={...standardWidgetProps};setup(){this.state=useState({isHovered:false,fetchingStatus:false,connectionStateDetails:null,});this.actionService=useService("action");this.busService=this.env.services.bus_service;this.orm=useService("orm");this.state.fetchingStatus=this.props.record.data.online_sync_fetching_status;this.busService.subscribe("online_sync",(notification)=>{if(notification?.id===this.recordId&&notification?.connection_state_details){this.state.connectionStateDetails=notification.connection_state_details;}});onWillStart(()=>{this._initConnectionStateDetails();});}
refresh(){this.actionService.restore(this.actionService.currentController.jsId);}
onMouseEnter(){this.state.isHovered=true;}
onMouseLeave(){this.state.isHovered=false;}
async openAction(){const action=await this.orm.call("account.journal","action_open_dashboard_asynchronous_action",[this.recordId],);this.actionService.doAction(action);this.state.connectionStateDetails=null;}
async fetchTransactions(){const action=await this.orm.call("account.journal","manual_sync",[this.recordId]);this.state.connectionStateDetails={status:"fetching"};if(action){this.actionService.doAction(action);}}
_initConnectionStateDetails(){const kanbanDashboardData=JSON.parse(this.props.record.data.kanban_dashboard);this.state.connectionStateDetails=kanbanDashboardData?.connection_state_details;}
get recordId(){return this.props.record.data.id;}
get connectionStatus(){return this.state.connectionStateDetails?.status;}}
const refreshSpin=__exports.refreshSpin={component:RefreshSpin,};registry.category("view_widgets").add("refresh_spin_widget",refreshSpin);return __exports;});;

/* /account_online_synchronization/static/src/components/transient_bank_statement_line_list_view/transient_bank_statement_line_list_view.js */
odoo.define('@account_online_synchronization/components/transient_bank_statement_line_list_view/transient_bank_statement_line_list_view',['@web/views/list/list_renderer','@web/views/list/list_controller','@web/core/registry','@web/views/list/list_view','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{ListRenderer}=require("@web/views/list/list_renderer");const{ListController}=require("@web/views/list/list_controller");const{registry}=require("@web/core/registry");const{listView}=require("@web/views/list/list_view");const{useService}=require("@web/core/utils/hooks");const TransientBankStatementLineListController=__exports.TransientBankStatementLineListController=class TransientBankStatementLineListController extends ListController{setup(){super.setup();this.orm=useService("orm");this.action=useService("action");}
async onClickImportTransactions(){const resIds=await this.getSelectedResIds();const resultAction=await this.orm.call("account.bank.statement.line.transient","action_import_transactions",[resIds]);this.action.doAction(resultAction);}}
const TransientBankStatementLineListRenderer=__exports.TransientBankStatementLineListRenderer=class TransientBankStatementLineListRenderer extends ListRenderer{static template="account_online_synchronization.TransientBankStatementLineRenderer";setup(){super.setup();this.orm=useService("orm");this.action=useService("action");}
async openManualEntries(){if(this.env.searchModel.context.active_model==="account.missing.transaction.wizard"&&this.env.searchModel.context.active_ids){const activeIds=this.env.searchModel.context.active_ids;const action=await this.orm.call("account.missing.transaction.wizard","action_open_manual_bank_statement_lines",activeIds);this.action.doAction(action);}}}
const TransientBankStatementLineListView=__exports.TransientBankStatementLineListView={...listView,Renderer:TransientBankStatementLineListRenderer,Controller:TransientBankStatementLineListController,buttonTemplate:"TransientBankStatementLineButtonTemplate",}
registry.category("views").add("transient_bank_statement_line_list_view",TransientBankStatementLineListView);return __exports;});;

/* /account_online_synchronization/static/src/components/views/account_online_authorization_kanban.js */
odoo.define('@account_online_synchronization/components/views/account_online_authorization_kanban',['@web/core/utils/patch','@account_accountant/components/bank_reconciliation/kanban'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{BankRecKanbanController}=require("@account_accountant/components/bank_reconciliation/kanban");patch(BankRecKanbanController.prototype,{setup(){super.setup();this.displayDuplicateWarning=!!this.props.context.duplicates_from_date;},async onWarningClick(){const{context}=this.env.searchModel;return this.action.doActionButton({type:"object",resModel:"account.journal",name:"action_open_duplicate_transaction_wizard",resId:this.state.journalId,args:JSON.stringify([context.duplicates_from_date]),})},})
return __exports;});;

/* /account_online_synchronization/static/src/js/odoo_fin_connector.js */
odoo.define('@account_online_synchronization/js/odoo_fin_connector',['@web/core/registry','@web/core/assets','@web/core/browser/cookie','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{loadJS}=require("@web/core/assets");const{cookie}=require("@web/core/browser/cookie");const{markup}=require("@odoo/owl");const actionRegistry=registry.category('actions');function OdooFinConnector(parent,action){const orm=parent.services.orm;const actionService=parent.services.action;const notificationService=parent.services.notification;const debugMode=parent.debug;const id=action.id;action.params.colorScheme=cookie.get("color_scheme");let mode=action.params.mode||'link';const modeRegexp=/^[a-z0-9-_]+$/;const runbotRegexp=/^https:\/\/[a-z0-9-_]+\.[a-z0-9-_]+\.odoo\.com$/;if(!modeRegexp.test(action.params.proxyMode)&&!runbotRegexp.test(action.params.proxyMode)){return;}
let url='https://'+action.params.proxyMode+'.odoofin.com/proxy/v1/odoofin_link';if(runbotRegexp.test(action.params.proxyMode)){url=action.params.proxyMode+'/proxy/v1/odoofin_link';}
let actionResult=false;loadJS(url).then(function(){const params={data:action.params,proxyMode:action.params.proxyMode,onEvent:async function(event,data){switch(event){case'close':return;case'reload':return actionService.doAction({type:'ir.actions.client',tag:'reload'});case'notification':notificationService.add(data.message,data);break;case'exchange_token':await orm.call('account.online.link','exchange_token',[[id],data],{context:action.context});break;case'success':mode=data.mode||mode;actionResult=await orm.call('account.online.link','success',[[id],mode,data],{context:action.context});actionResult.help=markup(actionResult.help)
return actionService.doAction(actionResult);case'connect_existing_account':actionResult=await orm.call('account.online.link','connect_existing_account',[data],{context:action.context});actionResult.help=markup(actionResult.help)
return actionService.doAction(actionResult);default:return;}},onAddBank:async function(){actionResult=await orm.call('account.online.link','create_new_bank_account_action',[],{context:action.context});actionResult.help=markup(actionResult.help)
return actionService.doAction(actionResult);}};if(typeof debugMode!=="undefined"&&debugMode){params.data["debug"]=debugMode;}
OdooFin.create(params);OdooFin.open();});return;}
actionRegistry.add('odoo_fin_connector',OdooFinConnector);__exports[Symbol.for("default")]=OdooFinConnector;return __exports;});;

/* /account_reports_cash_basis/static/src/components/cash_basis_report/filters.js */
odoo.define('@account_reports_cash_basis/components/cash_basis_report/filters',['@web/core/l10n/translation','@web/core/utils/patch','@account_reports/components/account_report/filters/filters'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{AccountReportFilters}=require("@account_reports/components/account_report/filters/filters");patch(AccountReportFilters.prototype,{get selectedExtraOptions(){let selectedExtraOptionsName=super.selectedExtraOptions;if(this.controller.filters.show_cash_basis){const cashBasisFilterName=this.controller.options.report_cash_basis?_t("Cash Basis"):_t("Accrual Basis");selectedExtraOptionsName=selectedExtraOptionsName?`${selectedExtraOptionsName}, ${cashBasisFilterName}`:cashBasisFilterName;}
return selectedExtraOptionsName;},get hasExtraOptionsFilter(){return super.hasExtraOptionsFilter||this.controller.filters.show_cash_basis;},});return __exports;});;

/* /crm_enterprise/static/src/activity_menu_patch.js */
odoo.define('@crm_enterprise/activity_menu_patch',['@mail/core/web/activity_menu','@web/core/utils/patch','@crm/activity_menu_patch'],function(require){'use strict';let __exports={};const{ActivityMenu}=require("@mail/core/web/activity_menu");const{patch}=require("@web/core/utils/patch");require("@crm/activity_menu_patch");patch(ActivityMenu.prototype,{availableViews(group){if(group.model==="crm.lead"){return[[false,"list"],[false,"kanban"],[false,"form"],[false,"calendar"],[false,"pivot"],[false,"cohort"],[false,"map"],[false,"activity"],];}
return super.availableViews(...arguments);},});return __exports;});;

/* /crm_iap_mine/static/src/js/tours/crm_iap_lead.js */
odoo.define('@crm_iap_mine/js/tours/crm_iap_lead',['@web/core/registry','@web/core/l10n/translation','@crm/js/tours/crm','@web/core/utils/patch','@odoo/owl'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");require("@crm/js/tours/crm");const{patch}=require("@web/core/utils/patch");const{markup}=require("@odoo/owl");patch(registry.category("web_tour.tours").get("crm_tour"),{steps(){const originalSteps=super.steps();const DragOppToWonStepIndex=originalSteps.findIndex((step)=>step.id==="drag_opportunity_to_won_step");originalSteps.splice(DragOppToWonStepIndex+1,0,{trigger:".o_button_generate_leads",content:markup(_t("Looking for more opportunities?<br>Try the <b>Lead Generation</b> tool.")),tooltipPosition:"bottom",run:"click .o_button_generate_leads",},{trigger:".modal-body .o_industry",content:_t("Which Industry do you want to target?"),tooltipPosition:"right",run:"click",},{isActive:["manual"],trigger:".modal-footer button[name=action_submit]",content:_t("Now, just let the magic happen!"),tooltipPosition:"bottom",run:"click",},{isActive:["auto"],trigger:".modal-footer button[special=cancel]",content:_t("Now, just let the magic happen!"),tooltipPosition:"bottom",run:"click",});return originalSteps;},});return __exports;});;

/* /crm_livechat/static/src/core/channel_commands.js */
odoo.define('@crm_livechat/core/channel_commands',['@web/core/l10n/translation','@web/core/registry'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");registry.category("discuss.channel_commands").add("lead",{help:_t("Create a new lead (/lead lead title)"),methodName:"execute_command_lead",});return __exports;});;

/* /documents_account/static/src/attachments/attachment_model.js */
odoo.define('@documents_account/attachments/attachment_model',['@mail/core/common/attachment_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Attachment}=require("@mail/core/common/attachment_model");const{patch}=require("@web/core/utils/patch");patch(Attachment.prototype,{get isPdf(){if(this.documentData&&this.documentData.has_embedded_pdf){return true;}
return super.isPdf;},});return __exports;});;

/* /documents_account/static/src/js/document_file_viewer.js */
odoo.define('@documents_account/js/document_file_viewer',['@web/core/utils/patch','@documents/attachments/document_file_viewer'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{FileViewer}=require("@documents/attachments/document_file_viewer");patch(FileViewer.prototype,{get hasSplitPdf(){if(this.documentService.documentList?.initialRecordSelectionLength===1){if(this.documentService.documentList.selectedDocument.record.data.has_embedded_pdf){return false;}}else if(this.documentService.documentList?.documents.some((document)=>document.record.data.has_embedded_pdf)){return false;}
return super.hasSplitPdf;},});return __exports;});;

/* /documents_account/static/src/js/tour.js */
odoo.define('@documents_account/js/tour',['@web/core/l10n/translation','@web/core/registry','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add("documents_account_tour",{url:"/odoo",steps:()=>[{trigger:'.o_app[data-menu-xmlid="documents.menu_root"]',content:markup(_t("Want to become a <b>paperless company</b>? Let's discover Odoo Documents.")),tooltipPosition:"bottom",},{trigger:'body:not(:has(.o-FileViewer)) img[src="https://img.youtube.com/vi/Ayab6wZ_U1A/0.jpg"]',content:markup(_t("Click on a thumbnail to <b>preview the document</b>.")),tooltipPosition:"bottom",},{trigger:".o_documents_kanban",},{trigger:'[title="Close (Esc)"]',content:markup(_t("Click the cross to <b>exit preview</b>.")),tooltipPosition:"left",},{trigger:".o_search_panel_label",},{trigger:'.o_search_panel_filter_value:eq(0)',content:markup(_t("Let's process documents in your Inbox.<br/><i>Tip: Use Tags to filter documents and structure your process.</i>")),tooltipPosition:"bottom",},{trigger:".o_search_panel_filter_value:eq(0) .o_search_panel_label_title",run:"click",},{trigger:"body:not(:has(.o-FileViewer)) .o_documents_kanban",},{trigger:'.o_kanban_record:contains(mail.png)',content:markup(_t("Click on a card to <b>select the document</b>.")),tooltipPosition:"bottom",},{trigger:'.o_inspector_rule[data-id="3"] .o_inspector_trigger_rule',content:markup(_t("Let's tag this mail as legal<br/> <i>Tips: actions can be tailored to your process, according to the workspace.</i>")),tooltipPosition:"bottom",},{trigger:".o_documents_kanban",},{trigger:'.o_kanban_record:nth(0):contains(Mails_inbox.pdf)',content:_t("Let's process this document, coming from our scanner."),tooltipPosition:"bottom",},{trigger:'[title="Mails_inbox.pdf"]',},{trigger:'.o_inspector_split',content:_t("As this PDF contains multiple documents, let's split and process in bulk."),tooltipPosition:"bottom",},{trigger:".o_documents_pdf_canvas:nth(5)",},{trigger:'.o_page_splitter_wrapper:nth(3)',content:markup(_t("Click on the <b>page separator</b>: we don't want to split these two pages as they belong to the same document.")),tooltipPosition:"right",},{trigger:".o_documents_pdf_manager",},{trigger:'.o_documents_pdf_page_selector:nth(5)',content:markup(_t("<b>Deselect this page</b> as we plan to process all bills first.")),tooltipPosition:"left",},{trigger:".o_documents_pdf_manager",},{trigger:'.o_pdf_manager_button:nth-last-child(2)',content:_t("Let's process these bills: turn them into vendor bills."),tooltipPosition:"bottom",},{trigger:".o_documents_pdf_manager",},{trigger:'.o_documents_pdf_page_selector',content:markup(_t("<b>Select</b> this page to continue.")),tooltipPosition:"bottom",},{trigger:".o_pdf_manager_button:not(:disabled)",},{trigger:'.o_pdf_manager_button:nth-child(4)',content:_t("Send this letter to the legal department, by assigning the right tags."),tooltipPosition:"bottom",},],});return __exports;});;

/* /documents_account/static/src/views/documents_model_mixin.js */
odoo.define('@documents_account/views/documents_model_mixin',['@documents/views/kanban/documents_kanban_model','@documents/views/list/documents_list_model','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{DocumentsKanbanModel}=require("@documents/views/kanban/documents_kanban_model");const{DocumentsListModel}=require("@documents/views/list/documents_list_model");const{patch}=require("@web/core/utils/patch");const AccountIsViewablePatch=__exports.AccountIsViewablePatch={isViewable(){if(this.data.mimetype.endsWith("/xml")&&this.data.has_embedded_pdf){return true;}
return super.isViewable(...arguments);},};patch(DocumentsKanbanModel.Record.prototype,AccountIsViewablePatch);patch(DocumentsListModel.Record.prototype,AccountIsViewablePatch);return __exports;});;

/* /hr_expense_extract/static/src/js/tours/expense_tour.js */
odoo.define('@hr_expense_extract/js/tours/expense_tour',['@web/core/l10n/translation','@web/core/registry','@web_tour/tour_service/tour_utils','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{stepUtils}=require("@web_tour/tour_service/tour_utils");const{markup}=require("@odoo/owl");registry.category("web_tour.tours").add('hr_expense_extract_tour',{url:"/odoo",steps:()=>[stepUtils.showAppsMenuItem(),{trigger:'.o_app[data-menu-xmlid="hr_expense.menu_hr_expense_root"]',content:markup(_t("<b>Wasting time recording your receipts?</b> Let’s try a better way.")),tooltipPosition:'bottom',run:"click",},{trigger:'.o_nocontent_help a.btn-primary',content:_t("Try the AI with a sample receipt."),tooltipPosition:'bottom',run:"click",},{trigger:".o_expense_flex",content:_t("Choose a receipt."),tooltipPosition:'top',run:"click",},{trigger:"button[name='action_submit_expenses']",content:_t("Report this expense to your manager for validation."),tooltipPosition:'bottom',run:"click",},{trigger:'.dropdown-toggle[data-menu-xmlid="hr_expense.menu_hr_expense_report"]',content:_t("Your manager will have to approve (or refuse) your expense reports."),tooltipPosition:'bottom',run:"click",},{trigger:'.dropdown-item[data-menu-xmlid="hr_expense.menu_hr_expense_sheet_all_to_approve"]',content:_t("Your manager will have to approve (or refuse) your expense reports."),tooltipPosition:'bottom',run:"click",}]});return __exports;});;

/* /hr_expense_extract/static/src/views/extract_sample_controller.js */
odoo.define('@hr_expense_extract/views/extract_sample_controller',['@web/views/form/form_controller','@web/core/browser/cookie','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{FormController}=require("@web/views/form/form_controller");const{cookie}=require("@web/core/browser/cookie");const{useService}=require("@web/core/utils/hooks");const{onMounted}=require("@odoo/owl");const VIDEO_WIDTH=300
const VIDEO_HEIGHT=360;const ExtractSampleFormController=__exports.ExtractSampleFormController=class ExtractSampleFormController extends FormController{setup(){super.setup();this.orm=useService("orm");this.actionService=useService("action");onMounted(()=>{const dialog=document.getElementsByClassName("o_dialog")[0];dialog.style.display="none";this.showAnimation();});}
get animationSource(){return cookie.get("color_scheme")==="dark"?"/hr_expense_extract/static/img/sample_animation_dark.webm":"/hr_expense_extract/static/img/sample_animation.webm";}
showAnimation(){const content=document.getElementsByClassName("o_content")[0];const videoOverlay=document.createElement("div");videoOverlay.className="o_extract_sample_animation_overlay position-absolute top-0 end-0 bottom-0 start-0 d-flex justify-content-center align-items-center bg-100";const video=document.createElement("video");video.width=VIDEO_WIDTH;video.height=VIDEO_HEIGHT;const source=document.createElement("source");source.src=this.animationSource;source.type="video/webm";video.append(source);videoOverlay.append(video);content.append(videoOverlay);setTimeout(()=>{videoOverlay.classList.add("opacity-100");setTimeout(()=>{video.play();setTimeout(async()=>{const action=await this.orm.call("expense.sample.receipt","action_choose_sample",[this.props.resId]);this.actionService.doAction(action);},2400);},400);},10);}}
return __exports;});;

/* /hr_expense_extract/static/src/views/extract_sample_form.js */
odoo.define('@hr_expense_extract/views/extract_sample_form',['@web/core/registry','@web/views/form/form_view','@hr_expense_extract/views/extract_sample_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");const{ExtractSampleFormController}=require("@hr_expense_extract/views/extract_sample_controller");const ExtractSampleFormView=__exports.ExtractSampleFormView={...formView,Controller:ExtractSampleFormController,};registry.category("views").add("extract_sample_form",ExtractSampleFormView);return __exports;});;

/* /sale_project/static/src/components/project_right_side_panel/components/project_profitability.js */
odoo.define('@sale_project/components/project_right_side_panel/components/project_profitability',['@web/core/utils/patch','@project/components/project_right_side_panel/components/project_profitability','@sale_project/components/project_right_side_panel/components/project_profitability_section'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{ProjectProfitability}=require("@project/components/project_right_side_panel/components/project_profitability");const{ProjectProfitabilitySection}=require("@sale_project/components/project_right_side_panel/components/project_profitability_section");patch(ProjectProfitability,{props:{...ProjectProfitability.props,projectId:Number,context:Object,},components:{...ProjectProfitability.components,ProjectProfitabilitySection,},});return __exports;});;

/* /sale_project/static/src/components/project_right_side_panel/components/project_profitability_section.js */
odoo.define('@sale_project/components/project_right_side_panel/components/project_profitability_section',['@web/core/utils/hooks','@odoo/owl','@web/views/fields/formatters'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{Component,useState}=require("@odoo/owl");const{formatFloat,formatFloatTime}=require("@web/views/fields/formatters");const ProjectProfitabilitySection=__exports.ProjectProfitabilitySection=class ProjectProfitabilitySection extends Component{static props={revenue:Object,labels:Object,formatMonetary:Function,onProjectActionClick:Function,onClick:Function,projectId:Number,context:Object,};static template="sale_project.ProjectProfitabilitySection";setup(){this.orm=useService("orm");this.actionService=useService("action");this.state=useState({isFolded:true,displayLoadMore:null,});this.sale_items=[];}
get revenue(){return this.props.revenue;}
async toggleSaleItems(){if(this.state.displayLoadMore===null){await this.onLoadMoreClick()}
this.state.isFolded=!this.state.isFolded;}
formatValue(value,unit){return unit==="Hours"?formatFloatTime(value):formatFloat(value);}
_getOrmValue(offset,section_id){return{function:"get_sale_items_data",args:[this.props.projectId,offset,5,true,section_id],};}
async onLoadMoreClick(){const offset=this.sale_items.length;const orm_value=this._getOrmValue(offset,this.props.revenue.id);const newItems=await this.orm.call("project.project",orm_value.function,orm_value.args,{context:this.props.context,});this.sale_items=[...this.sale_items,...newItems.sol_items];this.state.displayLoadMore=newItems.displayLoadMore;this.render();}
async onSaleItemActionClick(params){if(params.resId&&params.type!=="object"){const action=await this.actionService.loadAction(params.name,this.props.context);this.actionService.doAction({...action,res_id:params.resId,views:[[false,"form"]],});}else{this.props.onProjectActionClick(params);}}}
return __exports;});;

/* /sale_project/static/src/components/project_right_side_panel/project_right_side_panel.js */
odoo.define('@sale_project/components/project_right_side_panel/project_right_side_panel',['@web/core/utils/patch','@project/components/project_right_side_panel/project_right_side_panel'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{ProjectRightSidePanel}=require('@project/components/project_right_side_panel/project_right_side_panel');patch(ProjectRightSidePanel.prototype,{get panelVisible(){return super.panelVisible||this.state.data.show_sale_items;},});return __exports;});;

/* /sale_project/static/src/views/project_task_list/project_task_list_sale_line.js */
odoo.define('@sale_project/views/project_task_list/project_task_list_sale_line',['@web/core/utils/patch','@project/views/project_task_list/project_task_list_renderer','@web/views/kanban/kanban_record'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{ProjectTaskListRenderer}=require("@project/views/project_task_list/project_task_list_renderer");const{getRawValue}=require("@web/views/kanban/kanban_record");patch(ProjectTaskListRenderer.prototype,{haveSelectedTasksSamePartner(){if(this._haveSelectedTasksSamePartner===undefined){const selection=this.props.list.selection;const partnerId=selection.length&&getRawValue(selection[0],"partner_id");this._haveSelectedTasksSamePartner=selection.every((task)=>getRawValue(task,"partner_id")===partnerId);Promise.resolve().then(()=>{delete this._haveSelectedTasksSamePartner;});}
return this._haveSelectedTasksSamePartner;},isCellReadonly(column,record){let readonly=false;if(column.name==="sale_line_id"){readonly=!this.haveSelectedTasksSamePartner();}
return readonly||super.isCellReadonly(column,record);}});return __exports;});;

/* /spreadsheet/static/src/assets_backend/constants.js */
odoo.define('@spreadsheet/assets_backend/constants',['@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const FILTER_DATE_OPTION=__exports.FILTER_DATE_OPTION={quarter:["first_quarter","second_quarter","third_quarter","fourth_quarter"],};const monthsOptions=__exports.monthsOptions=[{id:"january",description:_t("January")},{id:"february",description:_t("February")},{id:"march",description:_t("March")},{id:"april",description:_t("April")},{id:"may",description:_t("May")},{id:"june",description:_t("June")},{id:"july",description:_t("July")},{id:"august",description:_t("August")},{id:"september",description:_t("September")},{id:"october",description:_t("October")},{id:"november",description:_t("November")},{id:"december",description:_t("December")},];return __exports;});;

/* /spreadsheet/static/src/assets_backend/helpers.js */
odoo.define('@spreadsheet/assets_backend/helpers',['@web/core/assets'],function(require){'use strict';let __exports={};const{loadBundle}=require("@web/core/assets");__exports.loadSpreadsheetDependencies=loadSpreadsheetDependencies;async function loadSpreadsheetDependencies(){await loadBundle("web.chartjs_lib");}
return __exports;});;

/* /spreadsheet/static/src/assets_backend/spreadsheet_action_loader.js */
odoo.define('@spreadsheet/assets_backend/spreadsheet_action_loader',['@web/core/l10n/translation','@web/core/registry','@web/core/assets','@spreadsheet/assets_backend/helpers'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{loadBundle}=require("@web/core/assets");const{loadSpreadsheetDependencies}=require("@spreadsheet/assets_backend/helpers");const actionRegistry=registry.category("actions");__exports.addSpreadsheetActionLazyLoader=addSpreadsheetActionLazyLoader;function addSpreadsheetActionLazyLoader(actionName,path,displayName){const actionLazyLoader=async(env,action)=>{await loadSpreadsheetDependencies();await loadBundle("spreadsheet.o_spreadsheet");if(actionRegistry.get(actionName)===actionLazyLoader){actionRegistry.add(actionName,()=>{const msg=_t("%s couldn't be loaded",actionName);env.services.notification.add(msg,{type:"danger"});},{force:true});}
return action;};if(path){actionLazyLoader.path=path;}
if(displayName){actionLazyLoader.displayName=displayName;}
actionRegistry.add(actionName,actionLazyLoader);}
addSpreadsheetActionLazyLoader("action_download_spreadsheet");return __exports;});;

/* /spreadsheet/static/src/assets_backend/spreadsheet_binary_field/spreadsheet_binary_field.js */
odoo.define('@spreadsheet/assets_backend/spreadsheet_binary_field/spreadsheet_binary_field',['@web/core/registry','@web/views/fields/binary/binary_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{BinaryField,binaryField}=require("@web/views/fields/binary/binary_field");const SpreadsheetBinaryField=__exports.SpreadsheetBinaryField=class SpreadsheetBinaryField extends BinaryField{static template="spreadsheet.SpreadsheetBinaryField";setup(){super.setup();}
async onFileDownload(){}}
const spreadsheetBinaryField=__exports.spreadsheetBinaryField={...binaryField,component:SpreadsheetBinaryField,};registry.category("fields").add("binary_spreadsheet",spreadsheetBinaryField);return __exports;});;

/* /spreadsheet_edition/static/src/assets/components/many2one_spreadsheet_field.js */
odoo.define('@spreadsheet_edition/assets/components/many2one_spreadsheet_field',['@web/core/registry','@web/core/utils/hooks','@web/views/fields/many2one/many2one_field','@web/views/fields/relational_utils'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{Many2OneField,many2OneField}=require("@web/views/fields/many2one/many2one_field");const{Many2XAutocomplete}=require("@web/views/fields/relational_utils");class Many2XSpreadsheetAutocomplete extends Many2XAutocomplete{setup(){super.setup();const actionService=useService("action");this.openMany2X=async({context})=>{const action=await this.orm.call(this.props.resModel,"action_open_new_spreadsheet",[],{context});this.props.update([{id:action.params.spreadsheet_id}]);await this.env.model.root.save();await actionService.doAction(action);};}}
class Many2OneSpreadsheetField extends Many2OneField{static components={...Many2OneField.components,Many2XAutocomplete:Many2XSpreadsheetAutocomplete,};}
registry.category("fields").add("many2one_spreadsheet",{...many2OneField,component:Many2OneSpreadsheetField,});return __exports;});;

/* /spreadsheet_edition/static/src/assets/components/spreadsheet_selector_dialog/spreadsheet_selector_dialog.js */
odoo.define('@spreadsheet_edition/assets/components/spreadsheet_selector_dialog/spreadsheet_selector_dialog',['@web/core/l10n/translation','@web/core/dialog/dialog','@web/core/utils/hooks','@web/core/notebook/notebook','@odoo/owl','@spreadsheet_edition/assets/components/spreadsheet_selector_dialog/spreadsheet_selector_panel'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Dialog}=require("@web/core/dialog/dialog");const{useService}=require("@web/core/utils/hooks");const{Notebook}=require("@web/core/notebook/notebook");const{Component,onWillStart,useState}=require("@odoo/owl");const{SpreadsheetSelectorPanel}=require("@spreadsheet_edition/assets/components/spreadsheet_selector_dialog/spreadsheet_selector_panel");const LABELS={PIVOT:_t("pivot"),LIST:_t("list"),LINK:_t("link"),GRAPH:_t("graph"),};const SpreadsheetSelectorDialog=__exports.SpreadsheetSelectorDialog=class SpreadsheetSelectorDialog extends Component{static template="spreadsheet_edition.SpreadsheetSelectorDialog";static components={Dialog,Notebook};static props={actionOptions:Object,type:String,threshold:{type:Number,optional:true},maxThreshold:{type:Number,optional:true},name:String,close:Function,};setup(){this.state=useState({threshold:this.props.threshold,name:this.props.name,confirmationIsPending:false,});this.actionState={getOpenSpreadsheetAction:()=>{},notificationMessage:"",};this.notification=useService("notification");this.actionService=useService("action");const orm=useService("orm");onWillStart(async()=>{const spreadsheetModels=await orm.call("spreadsheet.mixin","get_selector_spreadsheet_models");this.noteBookPages=spreadsheetModels.map(({model,display_name,allow_create})=>{return{Component:SpreadsheetSelectorPanel,id:model,title:display_name,props:{model,displayBlank:allow_create,onSpreadsheetSelected:this.onSpreadsheetSelected.bind(this),onSpreadsheetDblClicked:this._confirm.bind(this),},};});});}
get nameLabel(){return _t("Name of the %s:",LABELS[this.props.type]);}
get title(){return _t("Select a spreadsheet to insert your %s.",LABELS[this.props.type]);}
onSpreadsheetSelected({getOpenSpreadsheetAction,notificationMessage}){this.actionState={getOpenSpreadsheetAction,notificationMessage,};}
async _confirm(){if(this.state.confirmationIsPending){return;}
this.state.confirmationIsPending=true;const action=await this.actionState.getOpenSpreadsheetAction();const threshold=this.state.threshold?parseInt(this.state.threshold,10):0;const name=this.state.name.toString();if(this.actionState.notificationMessage){this.notification.add(this.actionState.notificationMessage,{type:"info"});}
const actionOpen=action.tag==="display_notification"?action.params.next:action;actionOpen.params=this._addToPreprocessingAction(actionOpen.params,threshold,name);this.actionService.doAction(action);this.props.close();}
_addToPreprocessingAction(actionParams,threshold,name){return{...this.props.actionOptions,preProcessingAsyncActionData:{...this.props.actionOptions.preProcessingAsyncActionData,threshold,name,},preProcessingActionData:{...this.props.actionOptions.preProcessingActionData,threshold,name,},...actionParams,};}
_cancel(){this.props.close();}}
return __exports;});;

/* /spreadsheet_edition/static/src/assets/components/spreadsheet_selector_dialog/spreadsheet_selector_panel.js */
odoo.define('@spreadsheet_edition/assets/components/spreadsheet_selector_dialog/spreadsheet_selector_panel',['@web/core/l10n/translation','@web/core/browser/browser','@web/core/utils/concurrency','@web/core/utils/hooks','@web/core/pager/pager','@web/core/hotkeys/hotkey_hook','@spreadsheet_edition/assets/components/spreadsheet_selector_grid/spreadsheet_selector_grid','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{KeepLast}=require("@web/core/utils/concurrency");const{useService}=require("@web/core/utils/hooks");const{Pager}=require("@web/core/pager/pager");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{SpreadsheetSelectorGrid}=require("@spreadsheet_edition/assets/components/spreadsheet_selector_grid/spreadsheet_selector_grid");const{Component,onWillStart,useState,onWillUnmount}=require("@odoo/owl");const DEFAULT_LIMIT=9;const SpreadsheetSelectorPanel=__exports.SpreadsheetSelectorPanel=class SpreadsheetSelectorPanel extends Component{static template="spreadsheet_edition.SpreadsheetSelectorPanel";static components={Pager,SpreadsheetSelectorGrid};static defaultProps={displayBlank:true,};static props={onSpreadsheetSelected:Function,onSpreadsheetDblClicked:Function,model:String,displayBlank:{type:Boolean,optional:true,},};setup(){this.state=useState({spreadsheets:{},selectedSpreadsheetId:null,pagerProps:{offset:0,limit:this.props.displayBlank?DEFAULT_LIMIT:DEFAULT_LIMIT+1,total:0,},});this.keepLast=new KeepLast();this.orm=useService("orm");this.domain=[];this.debounce=undefined;onWillStart(async()=>{await this._fetchSpreadsheets();const selectedItem=!this.props.displayBlank&&this.state.spreadsheets.length?this.state.spreadsheets[0].id:null;this._selectItem(selectedItem);});onWillUnmount(()=>{browser.clearTimeout(this.debounce);});useHotkey("Enter",()=>{this.props.onSpreadsheetDblClicked();});}
async _fetchSpreadsheets(){const{offset,limit}=this.state.pagerProps;const{records,total}=await this.keepLast.add(this.orm.call(this.props.model,"get_spreadsheets",[this.domain],{offset,limit,}));this.state.spreadsheets=records;this.state.pagerProps.total=total;}
async _getOpenSpreadsheetAction(){return this.orm.call(this.props.model,"action_open_spreadsheet",[[this.state.selectedSpreadsheetId],]);}
async _getCreateAndOpenSpreadsheetAction(){return this.orm.call(this.props.model,"action_open_new_spreadsheet");}
async onSearchInput(ev){const currentSearch=ev.target.value;this.domain=currentSearch!==""?[["name","ilike",currentSearch]]:[];this.state.pagerProps.offset=0;this._debouncedFetchSpreadsheets();}
_debouncedFetchSpreadsheets(){browser.clearTimeout(this.debounce);this.debounce=browser.setTimeout(this._fetchSpreadsheets.bind(this),400);}
onUpdatePager({offset,limit}){this.state.pagerProps.offset=offset;this.state.pagerProps.limit=limit;this._fetchSpreadsheets();}
_selectItem(id){this.state.selectedSpreadsheetId=id;const spreadsheet=this.state.selectedSpreadsheetId&&this.state.spreadsheets.find((s)=>s.id===this.state.selectedSpreadsheetId);const notificationMessage=spreadsheet?_t("New sheet inserted in '%s'",spreadsheet.display_name):"";this.props.onSpreadsheetSelected({spreadsheet,notificationMessage,getOpenSpreadsheetAction:spreadsheet?this._getOpenSpreadsheetAction.bind(this):this._getCreateAndOpenSpreadsheetAction.bind(this),});}
getThumbnailURL(spreadsheet){if(!spreadsheet.display_thumbnail){return false;}
return`data:image/jpeg;charset=utf-8;base64,${spreadsheet.display_thumbnail}`;}}
return __exports;});;

/* /spreadsheet_edition/static/src/assets/components/spreadsheet_selector_grid/spreadsheet_selector_grid.js */
odoo.define('@spreadsheet_edition/assets/components/spreadsheet_selector_grid/spreadsheet_selector_grid',['@odoo/owl','@web/core/l10n/translation','@web/core/hotkeys/hotkey_hook'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const DEFAULT_LIMIT=9;const BLANK_SPREADSHEET_TEMPLATE={id:null,display_name:_t("Blank spreadsheet"),thumbnail:"/spreadsheet/static/img/spreadsheet.svg",};const SpreadsheetSelectorGrid=__exports.SpreadsheetSelectorGrid=class SpreadsheetSelectorGrid extends Component{static template="documents_spreadsheet.SpreadsheetSelectorGrid";static defaultProps={displayBlank:true,};static props={spreadsheets:Array,onSpreadsheetSelected:Function,onSpreadsheetDblClicked:Function,getThumbnailURL:Function,selectedSpreadsheetId:Number|null,displayBlank:{type:Boolean,optional:true,},};blankThumbnailPlaceholder="/spreadsheet/static/img/spreadsheet.svg";setup(){useHotkey("ArrowRight",()=>this._onArrowKey("right"),{allowRepeat:true,});useHotkey("ArrowLeft",()=>this._onArrowKey("left"),{allowRepeat:true,});}
get spreadsheets(){if(!this.props.displayBlank){return this.props.spreadsheets;}
return[BLANK_SPREADSHEET_TEMPLATE,...this.props.spreadsheets];}
get itemsPerPage(){return this.props.displayBlank?DEFAULT_LIMIT:DEFAULT_LIMIT+1;}
async _onArrowKey(direction){const index=this.spreadsheets.findIndex((spreadsheet)=>spreadsheet.id===this.props.selectedSpreadsheetId);const navigateToSpreadsheet=(newSpreadsheetId)=>{if(newSpreadsheetId===this.props.selectedSpreadsheetId){return;}
this.props.onSpreadsheetSelected(newSpreadsheetId);};switch(direction){case"left":if(index>0&&index<this.spreadsheets.length){navigateToSpreadsheet(this.spreadsheets[index-1].id);}
break;case"right":if(index<this.spreadsheets.length-1){navigateToSpreadsheet(this.spreadsheets[index+1].id);}
break;default:break;}}}
return __exports;});;

/* /spreadsheet_edition/static/src/assets/insert_action_link_menu/insert_action_link_menu.js */
odoo.define('@spreadsheet_edition/assets/insert_action_link_menu/insert_action_link_menu',['@web/core/dropdown/dropdown_item','@web/core/utils/hooks','@spreadsheet_edition/assets/components/spreadsheet_selector_dialog/spreadsheet_selector_dialog','@odoo/owl'],function(require){'use strict';let __exports={};const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{useService}=require("@web/core/utils/hooks");const{SpreadsheetSelectorDialog}=require("@spreadsheet_edition/assets/components/spreadsheet_selector_dialog/spreadsheet_selector_dialog");const{Component}=require("@odoo/owl");const InsertViewSpreadsheet=__exports.InsertViewSpreadsheet=class InsertViewSpreadsheet extends Component{static props={};static template="spreadsheet_edition.InsertActionSpreadsheet";static components={DropdownItem};setup(){this.notification=useService("notification");this.actionService=useService("action");this.dialogManager=useService("dialog");}
async linkInSpreadsheet(){const actionToLink=await this.getViewDescription();const actionOptions={preProcessingAction:"insertLink",preProcessingActionData:actionToLink,};this.dialogManager.add(SpreadsheetSelectorDialog,{type:"LINK",actionOptions,name:this.env.config.getDisplayName(),});}
async getViewDescription(){const{resModel}=this.env.searchModel;const{views=[],actionId,viewType}=this.env.config;const{xml_id}=actionId?await this.actionService.loadAction(actionId,this.env.searchModel.context):{};const{context}=this.env.searchModel.getIrFilterValues();const action={xmlId:xml_id,domain:this.env.searchModel.domain,context,modelName:resModel,views:views.map(([,type])=>[false,type]),};return{viewType,action,};}}
return __exports;});;

/* /spreadsheet_edition/static/src/assets/list_view/insert_list_spreadsheet_menu_owl.js */
odoo.define('@spreadsheet_edition/assets/list_view/insert_list_spreadsheet_menu_owl',['@web/core/dropdown/dropdown_item','@odoo/owl'],function(require){'use strict';let __exports={};const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{Component}=require("@odoo/owl");const InsertListSpreadsheetMenu=__exports.InsertListSpreadsheetMenu=class InsertListSpreadsheetMenu extends Component{static props={};static template="spreadsheet_edition.InsertListSpreadsheetMenu";static components={DropdownItem};_onClick(){this.env.bus.trigger("insert-list-spreadsheet");}}
return __exports;});;

/* /spreadsheet_edition/static/src/assets/list_view/list_controller.js */
odoo.define('@spreadsheet_edition/assets/list_view/list_controller',['@web/core/utils/patch','@web/views/list/list_controller','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{ListController}=require("@web/views/list/list_controller");const{_t}=require("@web/core/l10n/translation");const patchListControllerExportSelection=__exports.patchListControllerExportSelection={getStaticActionMenuItems(){const list=this.model.root;const isM2MGrouped=list.groupBy.some((groupBy)=>{const fieldName=groupBy.split(":")[0];return list.fields[fieldName].type==="many2many";});const menuItems=super.getStaticActionMenuItems(...arguments);menuItems["insert"]={isAvailable:()=>!isM2MGrouped,sequence:15,icon:"oi oi-view-list",description:_t("Insert in spreadsheet"),callback:()=>this.env.bus.trigger("insert-list-spreadsheet"),};return menuItems;},};const unpatchListControllerExportSelection=__exports.unpatchListControllerExportSelection=patch(ListController.prototype,patchListControllerExportSelection);return __exports;});;

/* /spreadsheet_edition/static/src/assets/list_view/list_renderer.js */
odoo.define('@spreadsheet_edition/assets/list_view/list_renderer',['@web/core/utils/patch','@web/views/list/list_renderer','@web/core/user','@web/core/utils/hooks','@web/core/utils/objects','@spreadsheet_edition/assets/components/spreadsheet_selector_dialog/spreadsheet_selector_dialog','@web/views/fields/handle/handle_field','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{ListRenderer}=require("@web/views/list/list_renderer");const{user}=require("@web/core/user");const{useService,useBus}=require("@web/core/utils/hooks");const{omit}=require("@web/core/utils/objects");const{SpreadsheetSelectorDialog}=require("@spreadsheet_edition/assets/components/spreadsheet_selector_dialog/spreadsheet_selector_dialog");const{HandleField}=require("@web/views/fields/handle/handle_field");const{_t}=require("@web/core/l10n/translation");patch(ListRenderer.prototype,{setup(){super.setup(...arguments);this.dialogService=useService("dialog");this.actionService=useService("action");useBus(this.env.bus,"insert-list-spreadsheet",this.insertListSpreadsheet.bind(this));},async insertListSpreadsheet(){const model=this.env.model.root;const count=model.groups?model.groups.reduce((acc,group)=>group.count+acc,0):model.count;const selection=await model.getResIds(true);const threshold=selection.length>0?selection.length:Math.min(count,model.limit);let name=this.env.config.getDisplayName();const sortBy=model.orderBy[0]?.name;const groupBy=model.groupBy[0];if(sortBy||groupBy){name=_t("%(field name)s by %(order)s",{"field name":name,order:model.fields[sortBy]?.string??groupBy,});}
const{list,fields}=await this.getListForSpreadsheet(name);if(selection.length>0){list.domain=[["id","in",selection]];}
const actionOptions={preProcessingAsyncAction:"insertList",preProcessingAsyncActionData:{list,threshold,fields},};const params={threshold,type:"LIST",name,actionOptions,};this.dialogService.add(SpreadsheetSelectorDialog,params);},getColumnsForSpreadsheet(){const fields=this.env.model.root.fields;return this.columns.filter((col)=>col.type==="field"&&col.field.component!==HandleField&&!col.relatedPropertyField&&!["binary","json"].includes(fields[col.name].type)).map((col)=>({name:col.name,type:fields[col.name].type}));},async getListForSpreadsheet(name){const model=this.env.model.root;const{actionId}=this.env.config;const{xml_id}=actionId?await this.actionService.loadAction(actionId,this.props.list.context):{};const fieldNames=model.fieldNames;const filteredOrderBy=(model.orderBy).filter(order=>fieldNames.includes(order.name));return{list:{model:model.resModel,domain:this.env.searchModel.domainString,orderBy:filteredOrderBy,context:omit(model.context,...Object.keys(user.context)),columns:this.getColumnsForSpreadsheet(),name,actionXmlId:xml_id,},fields:model.fields,};},});return __exports;});;

/* /spreadsheet_edition/static/src/assets/message_model_patch.js */
odoo.define('@spreadsheet_edition/assets/message_model_patch',['@web/core/utils/patch','@mail/core/common/message','@mail/core/web/message_patch'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{Message}=require("@mail/core/common/message");require("@mail/core/web/message_patch");patch(Message.prototype,{async openRecord(){if(this.message.model==="spreadsheet.cell.thread"){const action=await this.env.services.orm.call("spreadsheet.cell.thread","get_spreadsheet_access_action",[this.message.thread.id]);this.action.doAction(action);return;}else{super.openRecord();}},});return __exports;});;

/* /spreadsheet_edition/static/src/assets/spreadsheet_cog_menu/spreadsheet_cog_menu.js */
odoo.define('@spreadsheet_edition/assets/spreadsheet_cog_menu/spreadsheet_cog_menu',['@web/core/dropdown/dropdown','@web/core/registry','@web/session','@spreadsheet_edition/assets/insert_action_link_menu/insert_action_link_menu','@spreadsheet_edition/assets/list_view/insert_list_spreadsheet_menu_owl','@odoo/owl'],function(require){'use strict';let __exports={};const{Dropdown}=require("@web/core/dropdown/dropdown");const{registry}=require("@web/core/registry");const{session}=require("@web/session");const{InsertViewSpreadsheet}=require("@spreadsheet_edition/assets/insert_action_link_menu/insert_action_link_menu");const{InsertListSpreadsheetMenu}=require("@spreadsheet_edition/assets/list_view/insert_list_spreadsheet_menu_owl");const{Component}=require("@odoo/owl");const cogMenuRegistry=registry.category("cogMenu");const SpreadsheetCogMenu=__exports.SpreadsheetCogMenu=class SpreadsheetCogMenu extends Component{static template="spreadsheet_edition.SpreadsheetCogMenu";static components={Dropdown,InsertViewSpreadsheet,InsertListSpreadsheetMenu};static props={};}
cogMenuRegistry.add("spreadsheet-cog-menu",{Component:SpreadsheetCogMenu,groupNumber:30,isDisplayed:({config,isSmall})=>!isSmall&&config.actionType==="ir.actions.act_window"&&config.viewType!=="form"&&session.can_insert_in_spreadsheet,},{sequence:1});return __exports;});;

/* /spreadsheet_edition/static/src/assets/spreadsheet_history_action_loader.js */
odoo.define('@spreadsheet_edition/assets/spreadsheet_history_action_loader',['@spreadsheet/assets_backend/spreadsheet_action_loader'],function(require){'use strict';let __exports={};const{addSpreadsheetActionLazyLoader}=require("@spreadsheet/assets_backend/spreadsheet_action_loader");addSpreadsheetActionLazyLoader("action_open_spreadsheet_history");return __exports;});;

/* /documents_spreadsheet/static/src/documents_view/documents_spreadsheet_controller_mixin.js */
odoo.define('@documents_spreadsheet/documents_view/documents_spreadsheet_controller_mixin',['@documents_spreadsheet/spreadsheet_template/spreadsheet_template_dialog','@web/core/utils/hooks','@web/core/confirmation_dialog/confirmation_dialog','@documents_spreadsheet/spreadsheet_clone_xlsx_dialog/spreadsheet_clone_xlsx_dialog','@web/core/l10n/translation','@documents_spreadsheet/helpers'],function(require){'use strict';let __exports={};const{TemplateDialog}=require("@documents_spreadsheet/spreadsheet_template/spreadsheet_template_dialog");const{useService}=require("@web/core/utils/hooks");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{SpreadsheetCloneXlsxDialog}=require("@documents_spreadsheet/spreadsheet_clone_xlsx_dialog/spreadsheet_clone_xlsx_dialog");const{_t}=require("@web/core/l10n/translation");const{XLSX_MIME_TYPES}=require("@documents_spreadsheet/helpers");const DocumentsSpreadsheetControllerMixin=__exports.DocumentsSpreadsheetControllerMixin=()=>({setup(){super.setup(...arguments);this.orm=useService("orm");this.action=useService("action");this.dialogService=useService("dialog");this.notification=useService("notification");this.baseOnOpenDocumentsPreview=this.onOpenDocumentsPreview.bind(this);this.onOpenDocumentsPreview=this._onOpenDocumentsPreview.bind(this);},isRecordPreviewable(record){return(super.isRecordPreviewable(...arguments)&&!["spreadsheet","frozen_spreadsheet"].includes(record.data.handler));},async _onOpenDocumentsPreview({mainDocument}){const mainDocumentOrTarget=mainDocument.shortcutTarget;if(["spreadsheet","frozen_spreadsheet"].includes(mainDocumentOrTarget.data.handler)){this.action.doAction({type:"ir.actions.client",tag:"action_open_spreadsheet",params:{spreadsheet_id:mainDocumentOrTarget.resId,},});}else if(XLSX_MIME_TYPES.includes(mainDocumentOrTarget.data.mimetype)){if(!mainDocument.data.active){this.dialogService.add(ConfirmationDialog,{title:_t("Restore file?"),body:_t("Spreadsheet files cannot be handled from the Trash. Would you like to restore this document?"),cancel:()=>{},confirm:async()=>{await this.orm.call("documents.document","action_unarchive",[mainDocument.resId,]);this.env.searchModel.toggleCategoryValue(1,mainDocument.data.folder_id[0]);},confirmLabel:_t("Restore"),});}else{this.dialogService.add(SpreadsheetCloneXlsxDialog,{title:_t("Excel file preview"),cancel:()=>{},cancelLabel:_t("Discard"),documentId:mainDocumentOrTarget.resId,confirmLabel:_t("Open with Odoo Spreadsheet"),});}}else{return this.baseOnOpenDocumentsPreview(...arguments);}},async onClickCreateSpreadsheet(ev){const folderId=this.env.searchModel.getSelectedFolderId()||undefined;const context=this.props.context;if(folderId==="COMPANY"){context.default_owner_id=this.documentService.store.odoobot.userId;}
this.dialogService.add(TemplateDialog,{folderId,context,folders:this.env.searchModel.getFolders().filter((folder)=>folder.id&&typeof folder.id==="number"),});},});return __exports;});;

/* /documents_spreadsheet/static/src/documents_view/kanban/documents_kanban_controller.js */
odoo.define('@documents_spreadsheet/documents_view/kanban/documents_kanban_controller',['@web/core/utils/patch','@documents/views/kanban/documents_kanban_controller','@documents_spreadsheet/documents_view/documents_spreadsheet_controller_mixin'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{DocumentsKanbanController}=require("@documents/views/kanban/documents_kanban_controller");const{DocumentsSpreadsheetControllerMixin}=require("@documents_spreadsheet/documents_view/documents_spreadsheet_controller_mixin");patch(DocumentsKanbanController.prototype,DocumentsSpreadsheetControllerMixin());return __exports;});;

/* /documents_spreadsheet/static/src/documents_view/kanban/documents_kanban_model.js */
odoo.define('@documents_spreadsheet/documents_view/kanban/documents_kanban_model',['@web/core/utils/patch','@documents/views/kanban/documents_kanban_model','@documents_spreadsheet/helpers'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{DocumentsKanbanRecord}=require("@documents/views/kanban/documents_kanban_model");const{XLSX_MIME_TYPES}=require("@documents_spreadsheet/helpers");patch(DocumentsKanbanRecord.prototype,{isViewable(){return(["spreadsheet","frozen_spreadsheet"].includes(this.data.handler)||XLSX_MIME_TYPES.includes(this.data.mimetype)||super.isViewable(...arguments));},});return __exports;});;

/* /documents_spreadsheet/static/src/documents_view/list/documents_list_controller.js */
odoo.define('@documents_spreadsheet/documents_view/list/documents_list_controller',['@web/core/utils/patch','@documents/views/list/documents_list_controller','@documents_spreadsheet/documents_view/documents_spreadsheet_controller_mixin'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{DocumentsListController}=require("@documents/views/list/documents_list_controller");const{DocumentsSpreadsheetControllerMixin}=require("@documents_spreadsheet/documents_view/documents_spreadsheet_controller_mixin");patch(DocumentsListController.prototype,DocumentsSpreadsheetControllerMixin());return __exports;});;

/* /documents_spreadsheet/static/src/documents_view/list/documents_list_model.js */
odoo.define('@documents_spreadsheet/documents_view/list/documents_list_model',['@web/core/utils/patch','@documents/views/list/documents_list_model','@documents_spreadsheet/helpers'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{DocumentsListModel}=require("@documents/views/list/documents_list_model");const{XLSX_MIME_TYPES}=require("@documents_spreadsheet/helpers");patch(DocumentsListModel.Record.prototype,{isViewable(){return(["spreadsheet","frozen_spreadsheet"].includes(this.data.handler)||XLSX_MIME_TYPES.includes(this.data.mimetype)||super.isViewable(...arguments));},});return __exports;});;

/* /documents_spreadsheet/static/src/documents_view/search/documents_search_model.js */
odoo.define('@documents_spreadsheet/documents_view/search/documents_search_model',[],function(require){'use strict';let __exports={};return __exports;});;

/* /documents_spreadsheet/static/src/documents_control_panel/documents_control_panel.js */
odoo.define('@documents_spreadsheet/documents_control_panel/documents_control_panel',['@web/core/l10n/translation','@web/core/utils/patch','@documents/views/search/documents_control_panel','@web/core/assets'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{DocumentsControlPanel}=require("@documents/views/search/documents_control_panel");const{loadBundle}=require("@web/core/assets");patch(DocumentsControlPanel.prototype,{async onClickFreezeAndShareSpreadsheet(){const selection=this.env.model.root.selection;if(selection.length!==1||!["spreadsheet","frozen_spreadsheet"].includes(selection[0].data.handler)){this.notification.add(_t("Select one and only one spreadsheet"));return;}
const doc=selection[0];await loadBundle("spreadsheet.o_spreadsheet");const{fetchSpreadsheetModel,freezeOdooData}=odoo.loader.modules.get("@spreadsheet/helpers/model");const model=await fetchSpreadsheetModel(this.env,"documents.document",doc.resId);const spreadsheetData=JSON.stringify(await freezeOdooData(model));const excelFiles=model.exportXLSX().files;const record=await this.orm.call("documents.document","action_freeze_and_copy",[doc.resId,spreadsheetData,excelFiles,]);await this.env.searchModel._reloadSearchModel(true);await this.env.documentsView.bus.trigger("documents-open-share",{id:record.id,withUpload:false,shortcut_document_id:record.shortcut_document_id,});},get canManageVersions(){return super.canManageVersions&&!this.targetRecords[0].data.handler;},onInsertInSpreadsheet(){this.env.bus.trigger("insert-list-spreadsheet");},});return __exports;});;

/* /documents_spreadsheet/static/src/documents_permission_panel/documents_access_settings.js */
odoo.define('@documents_spreadsheet/documents_permission_panel/documents_access_settings',['@web/core/l10n/translation','@web/core/utils/patch','@documents/components/documents_permission_panel/documents_access_settings'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{DocumentsAccessSettings}=require("@documents/components/documents_permission_panel/documents_access_settings");patch(DocumentsAccessSettings.prototype,{get errorAccessLinkEdit(){if(this.props.access.handler==="frozen_spreadsheet"){return _t("The frozen spreadsheets are readonly.");}else if(this.props.access.handler==="spreadsheet"){return _t("The spreadsheets can not be shared in edit mode with a link, change Internal to give write access.");}
return super.errorAccessLinkEdit;},get errorAccessInternalEdit(){if(this.props.access.handler==="frozen_spreadsheet"){return _t("The frozen spreadsheets are readonly.");}
return super.errorAccessInternalEdit;},});return __exports;});;

/* /documents_spreadsheet/static/src/documents_permission_panel/documents_member_invite.js */
odoo.define('@documents_spreadsheet/documents_permission_panel/documents_member_invite',['@web/core/l10n/translation','@web/core/utils/patch','@documents/components/documents_permission_panel/documents_member_invite'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{DocumentsMemberInvite}=require("@documents/components/documents_permission_panel/documents_member_invite");patch(DocumentsMemberInvite.prototype,{_getPartnersSpecification(){return{...super._getPartnersSpecification(),partner_share:1};},_addCreatedPartnersValues(partner){return{...super._addCreatedPartnersValues(partner),partner_share:true,};},get noEditorMessage(){const partners=this.state.fetchedPartners.filter((p)=>this.state.selectedPartners.includes(p.id));if(partners.some((p)=>p.partner_share)&&this.props.access.handler==="spreadsheet"){return _t("You can not share spreadsheet in edit mode to non-internal user.");}else if(this.props.access.handler==="frozen_spreadsheet"){return _t("The frozen spreadsheets are readonly.");}
return super.noEditorMessage;},});return __exports;});;

/* /documents_spreadsheet/static/src/documents_permission_panel/documents_partner_access.js */
odoo.define('@documents_spreadsheet/documents_permission_panel/documents_partner_access',['@web/core/l10n/translation','@web/core/utils/patch','@documents/components/documents_permission_panel/documents_partner_access'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{DocumentsPartnerAccess}=require("@documents/components/documents_permission_panel/documents_partner_access");patch(DocumentsPartnerAccess.prototype,{noEditorMessage(partner){const partnerInfo=this.props.accessPartners.find((p)=>p.id===partner.id).partner_id;if(partnerInfo.partner_share&&this.props.access.handler==="spreadsheet"){return _t("You can not share spreadsheet in edit mode to non-internal user.");}else if(this.props.access.handler==="frozen_spreadsheet"){return _t("The frozen spreadsheets are readonly.");}
return super.noEditorMessage(partner);},});return __exports;});;

/* /documents_spreadsheet/static/src/spreadsheet_clone_xlsx_dialog/spreadsheet_clone_xlsx_dialog.js */
odoo.define('@documents_spreadsheet/spreadsheet_clone_xlsx_dialog/spreadsheet_clone_xlsx_dialog',['@web/core/confirmation_dialog/confirmation_dialog','@web/core/utils/objects','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{omit}=require("@web/core/utils/objects");const{useService}=require("@web/core/utils/hooks");const{useState}=require("@odoo/owl");const SpreadsheetCloneXlsxDialog=__exports.SpreadsheetCloneXlsxDialog=class SpreadsheetCloneXlsxDialog extends ConfirmationDialog{static template="documents_spreadsheet.SpreadsheetCloneXlsxDialog";static props={...omit(ConfirmationDialog.props,"body","confirm"),documentId:{type:Number},};setup(){super.setup();this.archiveDocumentState=useState({willArchive:true});this.action=useService("action");this.orm=useService("orm");}
async _confirm(){this.execButton(async()=>{const spreadsheetId=await this.orm.call("documents.document","clone_xlsx_into_spreadsheet",[this.props.documentId],{archive_source:this.archiveDocumentState.willArchive});this.action.doAction({type:"ir.actions.client",tag:"action_open_spreadsheet",params:{spreadsheet_id:spreadsheetId,},});});}}
return __exports;});;

/* /documents_spreadsheet/static/src/spreadsheet_template/spreadsheet_template_dialog.js */
odoo.define('@documents_spreadsheet/spreadsheet_template/spreadsheet_template_dialog',['@web/core/dialog/dialog','@web/search/search_bar/search_bar','@web/core/pager/pager','@spreadsheet_edition/assets/components/spreadsheet_selector_grid/spreadsheet_selector_grid','@web/core/utils/concurrency','@web/search/search_model','@web/core/utils/hooks','@web/core/hotkeys/hotkey_hook','@web/views/view','@web/core/l10n/translation','@odoo/owl'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{SearchBar}=require("@web/search/search_bar/search_bar");const{Pager}=require("@web/core/pager/pager");const{SpreadsheetSelectorGrid}=require("@spreadsheet_edition/assets/components/spreadsheet_selector_grid/spreadsheet_selector_grid");const{KeepLast}=require("@web/core/utils/concurrency");const{SearchModel}=require("@web/search/search_model");const{useBus,useService}=require("@web/core/utils/hooks");const{useHotkey}=require("@web/core/hotkeys/hotkey_hook");const{getDefaultConfig}=require("@web/views/view");const{_t}=require("@web/core/l10n/translation");const{Component,useState,useSubEnv,useChildSubEnv,onWillStart,useEffect}=require("@odoo/owl");const TemplateDialog=__exports.TemplateDialog=class TemplateDialog extends Component{static components={Dialog,SearchBar,Pager,SpreadsheetSelectorGrid};static template="documents_spreadsheet.TemplateDialog";static props={context:Object,folderId:{type:[String,Number],optional:true},close:Function,folders:Array,};setup(){this.orm=useService("orm");this.viewService=useService("view");this.actionService=useService("action");this.companyService=useService("company");this.data=this.env.dialogData;useHotkey("escape",()=>this.data.close());useHotkey("Enter",async()=>{await this._createSpreadsheet();});this.dialogTitle=_t("Create a Spreadsheet or select a Template");this.limit=9;this.state=useState({isOpen:true,templates:[],templatesCount:0,selectedTemplateId:null,offset:0,isCreating:false,});useSubEnv({config:{...getDefaultConfig(),disableSearchBarAutofocus:true,},});this.model=new SearchModel(this.env,{orm:this.orm,view:useService("view"),});useChildSubEnv({searchModel:this.model,});useBus(this.model,"update",()=>this._fetchTemplates());this.keepLast=new KeepLast();onWillStart(async()=>{const defaultFolder=await this.orm.searchRead("res.company",[["id","=",this.companyService.currentCompany.id]],["document_spreadsheet_folder_id"]);this.documentsSpreadsheetFolderId=defaultFolder[0].document_spreadsheet_folder_id[0];const views=await this.viewService.loadViews({resModel:"spreadsheet.template",context:this.props.context,views:[[false,"search"]],});await this.model.load({resModel:"spreadsheet.template",context:this.props.context,orderBy:"id",searchMenuTypes:[],searchViewArch:views.views.search.arch,searchViewId:views.views.search.id,searchViewFields:views.fields,});await this._fetchTemplates();});useEffect(()=>{this.state.offset=0;},()=>[this.model.searchDomain]);}
async _fetchTemplates(offset=0){const{domain,context}=this.model;const{records,length}=await this.keepLast.add(this.orm.webSearchRead("spreadsheet.template",domain,{specification:{display_name:{}},domain,context,offset,limit:this.limit,order:"sequence, id",}));this.state.templates=records;this.state.templatesCount=length;}
async _createSpreadsheet(){if(!this._hasSelection()){return;}
this.state.isCreating=true;this.actionService.doAction(await this._getOpenSpreadsheetAction(),{additionalContext:this.props.context,});this.data.close();}
async _getOpenSpreadsheetAction(){const context=this.props.context;const templateId=this.state.selectedTemplateId;const folder_id=this.props.folderId?typeof this.props.folderId==="number"?this.props.folderId:false:this.documentsSpreadsheetFolderId;if(templateId){return this.orm.call("spreadsheet.template","action_create_spreadsheet",[templateId,{folder_id}],{context});}
return this.orm.call("documents.document","action_open_new_spreadsheet",[{folder_id}],{context,});}
_selectTemplate(templateId){this.state.selectedTemplateId=templateId;}
_isSelected(templateId){return this.state.selectedTemplateId===templateId;}
_hasSelection(){return(this.state.templates.find((template)=>template.id===this.state.selectedTemplateId)||this.state.selectedTemplateId===null);}
_onPagerChanged({offset}){this.state.offset=offset;return this._fetchTemplates(this.state.offset);}
_buttonDisabled(){return this.state.isCreating||!this._hasSelection();}
getThumbnailURL(template){return`/web/image?model=spreadsheet.template&id=${template.id}&field=display_thumbnail`;}}
return __exports;});;

/* /documents_spreadsheet/static/src/helpers.js */
odoo.define('@documents_spreadsheet/helpers',[],function(require){'use strict';let __exports={};const XLSX_MIME_TYPES=__exports.XLSX_MIME_TYPES=["application/vnd.openxmlformats-officedocument.spreadsheetml.sheet","application/wps-office.xlsx",];return __exports;});;

/* /documents_spreadsheet/static/src/spreadsheet_action_loader.js */
odoo.define('@documents_spreadsheet/spreadsheet_action_loader',['@spreadsheet/assets_backend/spreadsheet_action_loader','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{addSpreadsheetActionLazyLoader}=require("@spreadsheet/assets_backend/spreadsheet_action_loader");const{_t}=require("@web/core/l10n/translation");addSpreadsheetActionLazyLoader("action_open_spreadsheet","spreadsheet",_t("Spreadsheet"));addSpreadsheetActionLazyLoader("action_open_template");return __exports;});;

/* /dp_xml_sync_mx/static/src/js/dashboard_form.js */
odoo.define('@dp_xml_sync_mx/js/dashboard_form',['@web/core/registry','@web/views/form/form_view','@web/views/form/form_controller'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{formView}=require("@web/views/form/form_view");const{FormController}=require("@web/views/form/form_controller");class DashboardFormController extends FormController{setup(){super.setup();}
async updateDashboard(){await this.model.root.save();await this.model.root.reload();}
async onDateChange(){await this.updateDashboard();}}
const dashboardForm=__exports.dashboardForm={...formView,Controller:DashboardFormController,};registry.category("views").add("dashboard_form",dashboardForm);return __exports;});;

/* /google_calendar/static/src/views/google_calendar/common/google_calendar_common_popover.js */
odoo.define('@google_calendar/views/google_calendar/common/google_calendar_common_popover',['@calendar/views/attendee_calendar/common/attendee_calendar_common_popover','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{AttendeeCalendarCommonPopover}=require("@calendar/views/attendee_calendar/common/attendee_calendar_common_popover");const{patch}=require("@web/core/utils/patch");patch(AttendeeCalendarCommonPopover.prototype,{get isEventArchivable(){return super.isEventArchivable||(this.isCurrentUserOrganizer&&this.props.record.rawRecord.google_id);},});return __exports;});;

/* /google_calendar/static/src/views/google_calendar/google_calendar_controller.js */
odoo.define('@google_calendar/views/google_calendar/google_calendar_controller',['@calendar/views/attendee_calendar/attendee_calendar_controller','@web/core/l10n/translation','@web/core/user','@web/core/utils/patch','@web/core/utils/hooks','@web/core/confirmation_dialog/confirmation_dialog'],function(require){'use strict';let __exports={};const{AttendeeCalendarController}=require("@calendar/views/attendee_calendar/attendee_calendar_controller");const{_t}=require("@web/core/l10n/translation");const{user}=require("@web/core/user");const{patch}=require("@web/core/utils/patch");const{useService}=require("@web/core/utils/hooks");const{ConfirmationDialog,AlertDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");patch(AttendeeCalendarController.prototype,{setup(){super.setup(...arguments);this.dialog=useService("dialog");this.notification=useService("notification");},async onGoogleSyncCalendar(){await this.orm.call("res.users","restart_google_synchronization",[[user.userId]],);const syncResult=await this.model.syncGoogleCalendar();if(syncResult.status==="need_auth"){window.location.assign(syncResult.url);}else if(syncResult.status==="need_config_from_admin"){if(this.isSystemUser){this.dialog.add(ConfirmationDialog,{title:_t("Configuration"),body:_t("The Google Synchronization needs to be configured before you can use it, do you want to do it now?"),confirm:this.actionService.doAction.bind(this.actionService,syncResult.action),confirmLabel:_t("Configure"),cancel:()=>{},cancelLabel:_t("Discard"),});}else{this.dialog.add(AlertDialog,{title:_t("Configuration"),body:_t("An administrator needs to configure Google Synchronization before you can use it!"),});}}else{await this.model.load();this.render(true);}},async onStopGoogleSynchronization(){await this.orm.call("res.users","stop_google_synchronization",[[user.userId]],);await this.model.load();this.render(true);},async onUnpauseGoogleSynchronization(){await this.orm.call("res.users","unpause_google_synchronization",[[user.userId]],);await this.onStopGoogleSynchronization();this.render(true);}});return __exports;});;

/* /google_calendar/static/src/views/google_calendar/google_calendar_model.js */
odoo.define('@google_calendar/views/google_calendar/google_calendar_model',['@calendar/views/attendee_calendar/attendee_calendar_model','@web/core/network/rpc','@web/core/utils/patch','@odoo/owl'],function(require){'use strict';let __exports={};const{AttendeeCalendarModel}=require("@calendar/views/attendee_calendar/attendee_calendar_model");const{rpc}=require("@web/core/network/rpc");const{patch}=require("@web/core/utils/patch");const{useState}=require("@odoo/owl");patch(AttendeeCalendarModel.prototype,{setup(params){super.setup(...arguments);this.isAlive=params.isAlive;this.googlePendingSync=false;this.state=useState({googleIsSync:true,googleIsPaused:false,});},async updateData(){if(this.googlePendingSync){return super.updateData(...arguments);}
try{await Promise.race([new Promise(resolve=>setTimeout(resolve,1000)),this.syncGoogleCalendar(true)]);}catch(error){if(error.event){error.event.preventDefault();}
console.error("Could not synchronize Google events now.",error);this.googlePendingSync=false;}
if(this.isAlive()){return super.updateData(...arguments);}
return new Promise(()=>{});},async syncGoogleCalendar(silent=false){this.googlePendingSync=true;const result=await rpc("/google_calendar/sync_data",{model:this.resModel,fromurl:window.location.href},{silent,},);if(["need_config_from_admin","need_auth","sync_stopped","sync_paused"].includes(result.status)){this.state.googleIsSync=false;}else if(result.status==="no_new_event_from_google"||result.status==="need_refresh"){this.state.googleIsSync=true;}
this.state.googleIsPaused=result.status=="sync_paused";this.googlePendingSync=false;return result;},get googleCredentialsSet(){return this.credentialStatus['google_calendar']??false;}});return __exports;});;

/* /helpdesk_timesheet/static/src/components/grid_timesheet_timer_header/grid_timesheet_timer_header.js */
odoo.define('@helpdesk_timesheet/components/grid_timesheet_timer_header/grid_timesheet_timer_header',['@web/core/l10n/translation','@web/core/utils/patch','@timesheet_grid/components/grid_timesheet_timer_header/grid_timesheet_timer_header'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require('@web/core/utils/patch');const{GridTimesheetTimerHeader}=require('@timesheet_grid/components/grid_timesheet_timer_header/grid_timesheet_timer_header');patch(GridTimesheetTimerHeader.prototype,{get fieldNames(){return[...super.fieldNames,'helpdesk_ticket_id'];},getFieldInfo(fieldName){const fieldInfo=super.getFieldInfo(fieldName);if(fieldName==="helpdesk_ticket_id"){fieldInfo.context=`{'search_default_my_ticket': True, 'search_default_is_open': True, 'search_view_ref': 'helpdesk.helpdesk_ticket_view_search_analysis'}`;fieldInfo.placeholder=_t("Ticket");}
return fieldInfo;},});return __exports;});;

/* /helpdesk_timesheet/static/src/components/timesheet_timer_header/timesheet_timer_header.js */
odoo.define('@helpdesk_timesheet/components/timesheet_timer_header/timesheet_timer_header',['@web/core/utils/patch','@timesheet_grid/components/timesheet_timer_header/timesheet_timer_header','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{patch}=require('@web/core/utils/patch');const{TimesheetTimerHeader}=require('@timesheet_grid/components/timesheet_timer_header/timesheet_timer_header');const{useService}=require("@web/core/utils/hooks");patch(TimesheetTimerHeader.prototype,{setup(){super.setup();this.helpdeskTimerService=useService("helpdesk_timer_header");},async onWillStart(){super.onWillStart(...arguments);if(this.props.timerRunning&&this.helpdeskTimerService.helpdeskProjects==undefined){await this.helpdeskTimerService.fetchHelpdeskProjects();}},get hasHelpdeskProject(){const project=this.props.timesheet?.data?.project_id;const task=this.props.timesheet?.data?.task_id;return!task&&Boolean(project)&&this.helpdeskTimerService.helpdeskProjects?.includes(project[0]);},});return __exports;});;

/* /helpdesk_timesheet/static/src/hooks/timesheet_timer_header.js */
odoo.define('@helpdesk_timesheet/hooks/timesheet_timer_header',['@web/core/utils/hooks','@web/core/utils/patch','@timesheet_grid/hooks/timesheet_timer_hooks','@timesheet_grid/views/timesheet_list/timesheet_timer_list_controller','@timesheet_grid/views/timesheet_kanban/timesheet_timer_kanban_controller'],function(require){'use strict';let __exports={};const{useService}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");const{TimesheetTimerRendererHook}=require("@timesheet_grid/hooks/timesheet_timer_hooks");const{TimesheetTimerListController}=require("@timesheet_grid/views/timesheet_list/timesheet_timer_list_controller");const{TimesheetTimerKanbanController}=require("@timesheet_grid/views/timesheet_kanban/timesheet_timer_kanban_controller");patch(TimesheetTimerRendererHook.prototype,{setup(){super.setup();this.helpdeskTimerHeaderService=useService("helpdesk_timer_header");},async onWillStart(){await super.onWillStart();this.helpdeskTimerHeaderService.invalidateCache();},});const patchController=()=>({onChangeWriteValues(record){const{helpdesk_ticket_id}=record._getChanges();return{...super.onChangeWriteValues(record),helpdesk_ticket_id,};},});patch(TimesheetTimerListController.prototype,patchController());patch(TimesheetTimerKanbanController.prototype,patchController());return __exports;});;

/* /helpdesk_timesheet/static/src/services/helpdesk_timer_header_service.js */
odoo.define('@helpdesk_timesheet/services/helpdesk_timer_header_service',['@web/core/registry','@web/core/user'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{user}=require("@web/core/user");const timerHelpdeskService=__exports.timerHelpdeskService={dependencies:["orm"],async:["fetchHelpdeskProjects",],start(env,{orm}){let helpdeskProjects;return{async fetchHelpdeskProjects(){const isHelpdeskUser=await user.hasGroup("helpdesk.group_helpdesk_user");if(!isHelpdeskUser){return[];}
const result=await orm.readGroup("helpdesk.ticket",[["project_id","!=",false]],["project_id"],["project_id"],);if(result?.length){helpdeskProjects=result.map((r)=>r.project_id[0]);}},get helpdeskProjects(){return helpdeskProjects;},invalidateCache(){helpdeskProjects=undefined;}};}};registry.category('services').add('helpdesk_timer_header',timerHelpdeskService);return __exports;});;

/* /sale_timesheet/static/src/components/so_line_field/so_line_field.js */
odoo.define('@sale_timesheet/components/so_line_field/so_line_field',['@web/core/registry','@web/views/fields/many2one/many2one_field','@web/views/fields/x2many/x2many_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{Many2OneField,many2OneField}=require("@web/views/fields/many2one/many2one_field");const{X2ManyField,x2ManyField}=require("@web/views/fields/x2many/x2many_field");const SoLineField=__exports.SoLineField=class SoLineField extends Many2OneField{setup(){super.setup();const update=this.update;this.update=(value,params={})=>{update(value,params);if(!this.props.record.data.is_so_line_edited&&this.value[0]!=value[0]?.id){this.props.record.update({is_so_line_edited:true});}};}}
const soLineField=__exports.soLineField={...many2OneField,component:SoLineField,};registry.category("fields").add("so_line_field",soLineField);const TimesheetsOne2ManyField=__exports.TimesheetsOne2ManyField=class TimesheetsOne2ManyField extends X2ManyField{}
const timesheetsOne2ManyField=__exports.timesheetsOne2ManyField={...x2ManyField,component:TimesheetsOne2ManyField,additionalClasses:['o_field_one2many'],};return __exports;});;

/* /sale_timesheet_enterprise/static/src/components/many2one_avatar_rank_field/many2one_avatar_rank_field.js */
odoo.define('@sale_timesheet_enterprise/components/many2one_avatar_rank_field/many2one_avatar_rank_field',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const Many2OneAvatarRankField=__exports.Many2OneAvatarRankField=class Many2OneAvatarRankField extends Component{static template="sale_timesheet_enterprise.Many2OneAvatarRankField";static props={rank:{type:Number},id:{type:Number,optional:true},size:{type:String,optional:true},class:{type:String,optional:true},};static defaultProps={id:0,size:"small",class:"",};get imgSrc(){return this.props.id===0?"/hr/static/src/img/default_image.png":`/web/image/hr.employee.public/${this.props.id}/avatar_128`;}
get rankingClassBorder(){if(this.props.rank<4)return"o-border-"+this.props.rank;return"border-primary";}
get rankingClassBackground(){if(this.props.rank<4)return"o-bg-"+this.props.rank;return"bg-primary";}}
return __exports;});;

/* /sale_timesheet_enterprise/static/src/components/timesheet_leaderboard/timesheet_leaderboard.js */
odoo.define('@sale_timesheet_enterprise/components/timesheet_leaderboard/timesheet_leaderboard',['@sale_timesheet_enterprise/components/many2one_avatar_rank_field/many2one_avatar_rank_field','@odoo/owl','@sale_timesheet_enterprise/views/timesheet_leaderboard_dialog/timesheet_leaderboard_dialog','@web/core/utils/hooks','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Many2OneAvatarRankField}=require("@sale_timesheet_enterprise/components/many2one_avatar_rank_field/many2one_avatar_rank_field");const{Component}=require("@odoo/owl");const{TimesheetLeaderboardDialog}=require("@sale_timesheet_enterprise/views/timesheet_leaderboard_dialog/timesheet_leaderboard_dialog");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const{DateTime}=luxon;const TimesheetLeaderboard=__exports.TimesheetLeaderboard=class TimesheetLeaderboard extends Component{static template="sale_timesheet_enterprise.TimesheetLeaderboard";static components={Many2OneAvatarRankField,};static props={model:{type:Object,optional:true},date:{type:Object,optional:true},showIndicators:{type:Boolean},showLeaderboard:{type:Boolean},leaderboard:{type:Object},type:{type:String},changeType:{type:Function},};static defaultProps={date:DateTime.local().startOf("month"),};setup(){this.orm=useService("orm");this.dialog=useService("dialog");this.timesheetUOMService=useService("timesheet_uom");}
openLeaderboardPopup(){this.dialog.add(TimesheetLeaderboardDialog,{date:this.props.date,model:this.props.model,changeType:this.changeType.bind(this),type:this.props.type,});}
changeType(newType){this.props.changeType(newType);}
get isMobile(){return this.env.isSmall;}
get avatarDisplayLimit(){return(this.props.leaderboard.current_employee?.index||0)<3-this.isMobile?3-this.isMobile:2-this.isMobile;}
get currentBillingRateText(){const percentage=Math.round(this.props.leaderboard.current_employee.billing_rate);return this.isMobile?_t("%(percentage)s%",{percentage}):_t("(%(percentage)s%)",{percentage});}
get currentBillableTimeText(){return this.format(this.props.leaderboard.current_employee.billable_time);}
get currentBillingText(){return _t("%(currentBillableTimeText)s / %(currentTargetTotalTimeText)s ",{currentBillableTimeText:this.currentBillableTimeText,currentTargetTotalTimeText:this.currentTargetTotalTimeText,});}
get currentTotalTimeText(){if(this.timesheetUOMService.timesheetWidget==="float_toggle"){if(this.isMobile){return _t("%(totalTime)s d",{totalTime:this.format(this.props.leaderboard.current_employee.total_time),});}
return _t("%(totalTime)s days",{totalTime:this.format(this.props.leaderboard.current_employee.total_time),});}
if(this.isMobile){return _t("%(totalTime)s h",{totalTime:this.format(this.props.leaderboard.current_employee.total_time),});}
return _t("%(totalTime)s hours",{totalTime:this.format(this.props.leaderboard.current_employee.total_time),});}
get currentTargetTotalTimeText(){return this.format(this.props.leaderboard.current_employee.billable_time_target);}
format(value){return this.timesheetUOMService.formatter(value,{noLeadingZeroHour:true,}).replace(/(:00|\.00)/g,"");}}
return __exports;});;

/* /sale_timesheet_enterprise/static/src/components/timesheet_overtime_indication/timesheet_overtime_indication.js */
odoo.define('@sale_timesheet_enterprise/components/timesheet_overtime_indication/timesheet_overtime_indication',['@web/core/l10n/translation','@web/core/utils/patch','@timesheet_grid/components/timesheet_overtime_indication/timesheet_overtime_indication'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{TimesheetOvertimeIndication}=require("@timesheet_grid/components/timesheet_overtime_indication/timesheet_overtime_indication");patch(TimesheetOvertimeIndication.prototype,{get title(){if(this.props.name==="so_line"){return _t("Difference between the allocated %(uom)s (%(allocated_hours)s) on the sales order line and the %(uom)s spent (%(worked_hours)s) on all related projects and tasks",{uom:this.props.uom,allocated_hours:this.props.allocated_hours,worked_hours:this.props.worked_hours,});}
return super.title;},});return __exports;});;

/* /sale_timesheet_enterprise/static/src/hooks/timesheet_leaderboard_timer_hook.js */
odoo.define('@sale_timesheet_enterprise/hooks/timesheet_leaderboard_timer_hook',['@web/core/user','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");__exports.timesheetLeaderboardTimerHook=timesheetLeaderboardTimerHook;function timesheetLeaderboardTimerHook(){const orm=useService("orm");const companyService=useService("company");return{getLeaderboardRendering:async()=>{const read=await orm.read("res.company",[companyService.currentCompany.id],["timesheet_show_rates","timesheet_show_leaderboard"]);const{timesheet_show_rates,timesheet_show_leaderboard:showLeaderboard}=read[0];let showIndicators=timesheet_show_rates;if(timesheet_show_rates){const result=await orm.call("hr.employee","get_billable_time_target",[[user.userId],]);const billableTimeTarget=result.length?result[0].billable_time_target:0;showIndicators=billableTimeTarget>0;}
return{showIndicators:showIndicators,showLeaderboard:showLeaderboard,showLeaderboardComponent:showIndicators||showLeaderboard,};},};}
return __exports;});;

/* /sale_timesheet_enterprise/static/src/hooks/timesheet_timer_renderer_hook.js */
odoo.define('@sale_timesheet_enterprise/hooks/timesheet_timer_renderer_hook',['@odoo/owl','@web/core/browser/browser','@web/core/utils/patch','@web/core/user','@timesheet_grid/hooks/timesheet_timer_hooks'],function(require){'use strict';let __exports={};const{reactive}=require("@odoo/owl");const{browser}=require("@web/core/browser/browser");const{patch}=require("@web/core/utils/patch");const{user}=require("@web/core/user");const{TimesheetTimerRendererHook}=require("@timesheet_grid/hooks/timesheet_timer_hooks");const{DateTime}=luxon;patch(TimesheetTimerRendererHook.prototype,{setup(){super.setup();if(!browser.localStorage.getItem("leaderboardType")){browser.localStorage.setItem("leaderboardType","billing_rate");}
this.leaderboardType=browser.localStorage.getItem("leaderboardType");this.leaderboard=reactive({});},async onWillStart(){await super.onWillStart();this._getLeaderboardData();},async _getLeaderboardData(){const today=DateTime.local().startOf("day");const periodStart=today.startOf("month");const periodEnd=today.endOf("month");const data=await this.orm.call("res.company","get_timesheet_ranking_data",[periodStart,periodEnd,today,false],{context:user.context});this.leaderboard.show_leaderboard=data.show_leaderboard;this.leaderboard.total_time_target=data.total_time_target;this.leaderboard.stored_leaderboard=data.leaderboard;this.leaderboard.leaderboard=this._sortAndFilterLeaderboard(this.leaderboard.stored_leaderboard,this.leaderboardType);this.leaderboard.current_employee=this._setCurrentEmployeeIndexFromLeaderboard(this.leaderboard.leaderboard,data.employee_id);this.leaderboard.current_employee_id=data.employee_id;},_sortAndFilterLeaderboard(array,order_by){const min=order_by==="billing_rate"?0.5:0;array.sort((a,b)=>b[order_by]-a[order_by]);return array.filter((line)=>line[order_by]>min);},_setCurrentEmployeeIndexFromLeaderboard(array,employee_id){const index=array.findIndex(object=>object.id===employee_id);if(index>=0){array[index].index=index;}
return array[index];},changeLeaderboardType(type){this.leaderboardType=type;browser.localStorage.setItem("leaderboardType",type);this.leaderboard.leaderboard=this._sortAndFilterLeaderboard(this.leaderboard.stored_leaderboard,type);this.leaderboard.current_employee=this._setCurrentEmployeeIndexFromLeaderboard(this.leaderboard.leaderboard,this.leaderboard.current_employee_id);},});return __exports;});;

/* /sale_timesheet_enterprise/static/src/views/patch_renderer.js */
odoo.define('@sale_timesheet_enterprise/views/patch_renderer',['@odoo/owl','@sale_timesheet_enterprise/components/timesheet_leaderboard/timesheet_leaderboard','@sale_timesheet_enterprise/hooks/timesheet_leaderboard_timer_hook','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{onWillStart}=require("@odoo/owl");const{TimesheetLeaderboard}=require("@sale_timesheet_enterprise/components/timesheet_leaderboard/timesheet_leaderboard");const{timesheetLeaderboardTimerHook}=require("@sale_timesheet_enterprise/hooks/timesheet_leaderboard_timer_hook");const{patch}=require("@web/core/utils/patch");__exports.patchRenderer=patchRenderer;function patchRenderer(Renderer){patch(Renderer.components,{TimesheetLeaderboard});patch(Renderer.prototype,{setup(){super.setup();const{getLeaderboardRendering}=timesheetLeaderboardTimerHook();onWillStart(async()=>{const{showIndicators,showLeaderboard,showLeaderboardComponent}=await getLeaderboardRendering();this.showIndicators=showIndicators;this.showLeaderboard=showLeaderboard;this.showLeaderboardComponent=showLeaderboardComponent;});},});}
return __exports;});;

/* /sale_timesheet_enterprise/static/src/views/timesheet_leaderboard_dialog/timesheet_leaderboard_dialog.js */
odoo.define('@sale_timesheet_enterprise/views/timesheet_leaderboard_dialog/timesheet_leaderboard_dialog',['@web/core/dialog/dialog','@sale_timesheet_enterprise/components/many2one_avatar_rank_field/many2one_avatar_rank_field','@odoo/owl','@web/core/user','@web/core/utils/hooks','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Dialog}=require("@web/core/dialog/dialog");const{Many2OneAvatarRankField}=require("@sale_timesheet_enterprise/components/many2one_avatar_rank_field/many2one_avatar_rank_field");const{Component,onWillStart,useState}=require("@odoo/owl");const{user}=require("@web/core/user");const{useService}=require("@web/core/utils/hooks");const{_t}=require("@web/core/l10n/translation");const TimesheetLeaderboardDialog=__exports.TimesheetLeaderboardDialog=class TimesheetLeaderboardDialog extends Component{static template="sale_timesheet_enterprise.TimesheetLeaderboardDialog";static components={Dialog,Many2OneAvatarRankField,};static props={model:{type:Object,optional:true},date:{type:Object},close:{type:Function},type:{type:String},changeType:{type:Function},};setup(){this.orm=useService("orm");this.timesheetUOMService=useService("timesheet_uom");this.state=useState({date:this.props.date.startOf("month"),type:this.props.type,showAll:false,leaderboard:[],stored_leaderboard:[],current_employee:{},});onWillStart(this.onWillStart);}
async onWillStart(){await this.getLeaderboardData(true);}
async getLeaderboardData(fetchTip=false){const periodEnd=this.state.date.endOf("month");const data=await this.orm.call("res.company","get_timesheet_ranking_data",[this.state.date,periodEnd,periodEnd,fetchTip],{context:user.context});if(fetchTip){this.tip=data.tip;}
this.state.stored_leaderboard=data.leaderboard;this.state.leaderboard=this.sortAndFilterLeaderboard(this.state.stored_leaderboard,this.state.type);this.state.current_employee=this.setCurrentEmployeeIndexFromLeaderboard(this.state.leaderboard,data.employee_id);this.state.current_employee_id=data.employee_id;}
sortAndFilterLeaderboard(array,order_by){const min=order_by==="billing_rate"?0.5:0;array.sort((a,b)=>b[order_by]-a[order_by]);return array.filter((line)=>line[order_by]>min);}
setCurrentEmployeeIndexFromLeaderboard(array,employee_id){const index=array.findIndex(object=>object.id===employee_id);if(index>=0){array[index].index=index;}
return array[index]||{};}
changeType(type){this.props.changeType(type);this.state.type=type;this.state.leaderboard=this.sortAndFilterLeaderboard(this.state.stored_leaderboard,type);this.state.current_employee=this.setCurrentEmployeeIndexFromLeaderboard(this.state.leaderboard,this.state.current_employee_id)}
async goNextMonth(){this.state.date=this.state.date.plus({month:1})
this.getLeaderboardData();}
async goLastMonth(){this.state.date=this.state.date.minus({month:1})
this.getLeaderboardData();}
async goCurrentMonth(){this.state.date=this.props.date;this.getLeaderboardData();}
async onKeyUp(ev){switch(ev.key){case"ArrowRight":await this.goNextMonth();break;case"ArrowLeft":await this.goLastMonth();break;case"ArrowDown":await this.goCurrentMonth();break;case"t":this.changeType(this.state.type==="billing_rate"?"total_time":"billing_rate");break;}}
getBillingRateText(employee){return _t("%(billableTime)s / %(billable_time_target)s (%(billingRate)s%)",{billableTime:this.format(employee.billable_time),billable_time_target:this.format(employee.billable_time_target),billingRate:Math.round(employee.billing_rate),});}
getTotalTimeText(employee){return _t("Total: %(totalTime)s",{totalTime:this.format(employee.total_time),});}
getTitle(type){return type==="billing_rate"?_t("Billing Rate Leaderboard"):_t("Total Time Leaderboard");}
get displayLimit(){return this.state.showAll?Infinity:10;}
get isMobile(){return this.env.isSmall;}
get currentFormattedDate(){return this.state.date.setLocale(user.lang).toLocaleString({year:"numeric",month:"long",});}
format(value){return this.timesheetUOMService.formatter(value,{noLeadingZeroHour:true,}).replace(/(:|\.)00/g,"");}}
return __exports;});;

/* /sale_timesheet_enterprise/static/src/views/timesheet_leaderboard_timer_kanban/timesheet_leaderboard_timer_kanban_renderer.js */
odoo.define('@sale_timesheet_enterprise/views/timesheet_leaderboard_timer_kanban/timesheet_leaderboard_timer_kanban_renderer',['@timesheet_grid/views/timesheet_kanban/timesheet_timer_kanban_renderer','@sale_timesheet_enterprise/views/patch_renderer'],function(require){'use strict';let __exports={};const{TimesheetTimerKanbanRenderer}=require("@timesheet_grid/views/timesheet_kanban/timesheet_timer_kanban_renderer");const{patchRenderer}=require("@sale_timesheet_enterprise/views/patch_renderer");patchRenderer(TimesheetTimerKanbanRenderer);return __exports;});;

/* /sale_timesheet_enterprise/static/src/views/timesheet_leaderboard_timer_list/timesheet_leaderboard_timer_list_renderer.js */
odoo.define('@sale_timesheet_enterprise/views/timesheet_leaderboard_timer_list/timesheet_leaderboard_timer_list_renderer',['@timesheet_grid/views/timesheet_list/timesheet_timer_list_renderer','@sale_timesheet_enterprise/views/patch_renderer'],function(require){'use strict';let __exports={};const{TimesheetTimerListRenderer}=require("@timesheet_grid/views/timesheet_list/timesheet_timer_list_renderer");const{patchRenderer}=require("@sale_timesheet_enterprise/views/patch_renderer");patchRenderer(TimesheetTimerListRenderer);return __exports;});;

/* /hr_calendar/static/src/calendar/calendar_model.js */
odoo.define('@hr_calendar/calendar/calendar_model',['@calendar/views/attendee_calendar/attendee_calendar_model','@web/core/l10n/dates','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{AttendeeCalendarModel}=require("@calendar/views/attendee_calendar/attendee_calendar_model");const{serializeDate}=require("@web/core/l10n/dates");const{patch}=require("@web/core/utils/patch");patch(AttendeeCalendarModel.prototype,{setup(){super.setup(...arguments)
this.data.workingHours={};},get workingHours(){return this.data.workingHours;},async updateData(data){await super.updateData(...arguments)
data.workingHours=await this.fetchWorkingHours(data);},async fetchWorkingHours(data){if(this.meta.scale!=="day"&&this.meta.scale!=="week"){return[];}
const attendeeFilters=data.filterSections.partner_ids;const activeAttendeeIds=attendeeFilters.filters.filter((filter)=>filter.type!=="all"&&filter.value&&filter.active).map((filter)=>filter.value);const allFilter=attendeeFilters.filters.find((filter)=>filter.type==="all");return this.orm.call("res.partner","get_working_hours_for_all_attendees",[activeAttendeeIds,serializeDate(data.range.start),serializeDate(data.range.end),allFilter?.active]);},});return __exports;});;

/* /hr_calendar/static/src/calendar/common/calendar_common_renderer.js */
odoo.define('@hr_calendar/calendar/common/calendar_common_renderer',['@calendar/views/attendee_calendar/common/attendee_calendar_common_renderer','@web/core/utils/patch','@odoo/owl'],function(require){'use strict';let __exports={};const{AttendeeCalendarCommonRenderer}=require("@calendar/views/attendee_calendar/common/attendee_calendar_common_renderer");const{patch}=require("@web/core/utils/patch");const{onWillUpdateProps}=require("@odoo/owl");patch(AttendeeCalendarCommonRenderer.prototype,{setup(){super.setup(...arguments);onWillUpdateProps(()=>{this.fc.api.setOption("businessHours",this.props.model.workingHours)});},get options(){return Object.assign(super.options,{businessHours:this.props.model.workingHours,});},});return __exports;});;

/* /hr_calendar/static/src/calendar/filter_panel/calendar_filter_panel.js */
odoo.define('@hr_calendar/calendar/filter_panel/calendar_filter_panel',['@web/views/calendar/filter_panel/calendar_filter_panel','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{CalendarFilterPanel}=require("@web/views/calendar/filter_panel/calendar_filter_panel");const{patch}=require("@web/core/utils/patch");patch(CalendarFilterPanel.prototype,{updateSelectCreateDialogProps(props){const updatedProps=super.updateSelectCreateDialogProps(props);updatedProps.context={search_view_ref:'hr_calendar.view_res_partner_filter_inherit_calendar',};return updatedProps;}})
return __exports;});;

/* /hr_calendar/static/src/views/fields/many2many_attendees.js */
odoo.define('@hr_calendar/views/fields/many2many_attendees',['@calendar/views/fields/many2many_attendee','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Many2ManyAttendee}=require("@calendar/views/fields/many2many_attendee");const{patch}=require("@web/core/utils/patch");patch(Many2ManyAttendee.prototype,{get tags(){const tags=super.tags;if(this.props.record.data.unavailable_partner_ids){const unavailablePartnerIds=this.props.record.data.unavailable_partner_ids.records;for(const tag of tags){if(unavailablePartnerIds.find((partner)=>(tag.resId==partner.resId))){tag.unavailableIcon=true;}}}
return tags;}})
return __exports;});;

/* /hr_mobile/static/src/js/language_mobile.js */
odoo.define('@hr_mobile/js/language_mobile',['@web/core/utils/patch','@web_mobile/js/core/mixins','@hr/views/profile_form_view'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{updateAccountOnMobileDevice}=require("@web_mobile/js/core/mixins");const{EmployeeProfileController}=require("@hr/views/profile_form_view");patch(EmployeeProfileController.prototype,{async onRecordSaved(record){await updateAccountOnMobileDevice();return await super.onRecordSaved(...arguments);},});return __exports;});;

/* /hr_recruitment_reports/static/src/components/ranking_panel.js */
odoo.define('@hr_recruitment_reports/components/ranking_panel',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const RankingPanel=__exports[Symbol.for("default")]=class RankingPanel extends Component{static template="hr_recruitment_reports.RankingPanel";static props={ranked_list:Object,};}
return __exports;});;

/* /l10n_mx_edi/static/src/components/cancellation_reason/cancellation_reason.js */
odoo.define('@l10n_mx_edi/components/cancellation_reason/cancellation_reason',['@web/core/registry','@web/views/fields/selection/selection_field'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{SelectionField,selectionField}=require("@web/views/fields/selection/selection_field");const CancellationReason=__exports.CancellationReason=class CancellationReason extends SelectionField{get availableOptions(){return this.props.record.data.available_cancellation_reasons.split(",");}
get options(){const availableOptions=this.availableOptions;return super.options.filter(x=>availableOptions.includes(x[0]));}}
registry.category("fields").add("l10n_mx_edi_cancellation_reason",{...selectionField,component:CancellationReason,});return __exports;});;

/* /sale_stock/static/src/product_catalog/kanban_record.js */
odoo.define('@sale_stock/product_catalog/kanban_record',['@product/product_catalog/kanban_record','@sale_stock/product_catalog/sale_order_line/sale_order_line','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{ProductCatalogKanbanRecord}=require("@product/product_catalog/kanban_record");const{ProductCatalogSaleOrderLine}=require("@sale_stock/product_catalog/sale_order_line/sale_order_line");const{patch}=require("@web/core/utils/patch");patch(ProductCatalogKanbanRecord.prototype,{updateQuantity(quantity){if(this.env.orderResModel!=="sale.order"||this.productCatalogData.productType=="service"){super.updateQuantity(...arguments);}else if(this.productCatalogData.quantity===this.productCatalogData.deliveredQty&&quantity<this.productCatalogData.quantity){this.props.record.load();this.props.record.model.notify();}else{super.updateQuantity(Math.max(quantity,this.productCatalogData.deliveredQty));}},get orderLineComponent(){if(this.env.orderResModel==="sale.order"){return ProductCatalogSaleOrderLine;}
return super.orderLineComponent;},});return __exports;});;

/* /sale_stock/static/src/product_catalog/sale_order_line/sale_order_line.js */
odoo.define('@sale_stock/product_catalog/sale_order_line/sale_order_line',['@web/core/l10n/translation','@product/product_catalog/order_line/order_line'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{ProductCatalogOrderLine}=require("@product/product_catalog/order_line/order_line");const ProductCatalogSaleOrderLine=__exports.ProductCatalogSaleOrderLine=class ProductCatalogSaleOrderLine extends ProductCatalogOrderLine{static props={...ProductCatalogOrderLine.props,deliveredQty:Number,}
get disableRemove(){return this.props.quantity===this.props.deliveredQty;}
get disabledButtonTooltip(){if(this.disableRemove){return _t("The ordered quantity cannot be decreased below the amount already delivered. Instead, create a return in your inventory.");}
return super.disabledButtonTooltip;}}
return __exports;});;

/* /sale_stock/static/src/sale_stock_forecasted/forecasted_details.js */
odoo.define('@sale_stock/sale_stock_forecasted/forecasted_details',['@web/views/fields/formatters','@web/core/utils/patch','@stock/stock_forecasted/forecasted_details'],function(require){'use strict';let __exports={};const{formatMonetary}=require("@web/views/fields/formatters");const{patch}=require("@web/core/utils/patch");const{ForecastedDetails}=require("@stock/stock_forecasted/forecasted_details");patch(ForecastedDetails.prototype,{_formatMonetary(num,currencyId){return formatMonetary(num,{currencyId:currencyId});}});return __exports;});;

/* /sale_stock/static/src/widgets/qty_at_date_widget.js */
odoo.define('@sale_stock/widgets/qty_at_date_widget',['@web/core/l10n/dates','@web/core/l10n/localization','@web/core/registry','@web/core/utils/hooks','@web/core/popover/popover_hook','@odoo/owl','@web/views/widgets/standard_widget_props'],function(require){'use strict';let __exports={};const{formatDateTime}=require("@web/core/l10n/dates");const{localization}=require("@web/core/l10n/localization");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{usePopover}=require("@web/core/popover/popover_hook");const{Component,onWillRender}=require("@odoo/owl");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const QtyAtDatePopover=__exports.QtyAtDatePopover=class QtyAtDatePopover extends Component{static template="sale_stock.QtyAtDatePopover";static props={record:Object,calcData:Object,close:Function,};setup(){this.actionService=useService("action");}
openForecast(){this.actionService.doAction("stock.stock_forecasted_product_product_action",{additionalContext:{active_model:'product.product',active_id:this.props.record.data.product_id[0],warehouse_id:this.props.record.data.warehouse_id&&this.props.record.data.warehouse_id[0],move_to_match_ids:this.props.record.data.move_ids.records.map(record=>record.resId),sale_line_to_match_id:this.props.record.resId,},});}}
const QtyAtDateWidget=__exports.QtyAtDateWidget=class QtyAtDateWidget extends Component{static components={Popover:QtyAtDatePopover};static template="sale_stock.QtyAtDate";static props={...standardWidgetProps};setup(){this.popover=usePopover(this.constructor.components.Popover,{position:"top"});this.calcData={};onWillRender(()=>{this.initCalcData();})}
initCalcData(){const{data}=this.props.record;if(data.scheduled_date){if(data.state==='sale'){this.calcData.will_be_fulfilled=data.free_qty_today>=data.qty_to_deliver;}else{this.calcData.will_be_fulfilled=data.virtual_available_at_date>=data.qty_to_deliver;}
this.calcData.will_be_late=data.forecast_expected_date&&data.forecast_expected_date>data.scheduled_date;if(['draft','sent'].includes(data.state)){this.calcData.forecasted_issue=!this.calcData.will_be_fulfilled&&!data.is_mto;}else{this.calcData.forecasted_issue=!this.calcData.will_be_fulfilled||this.calcData.will_be_late;}}}
updateCalcData(){const{data}=this.props.record;if(!data.scheduled_date){return;}
this.calcData.delivery_date=formatDateTime(data.scheduled_date,{format:localization.dateFormat});if(data.forecast_expected_date){this.calcData.forecast_expected_date_str=formatDateTime(data.forecast_expected_date,{format:localization.dateFormat});}}
showPopup(ev){this.updateCalcData();this.popover.open(ev.currentTarget,{record:this.props.record,calcData:this.calcData,});}}
const qtyAtDateWidget=__exports.qtyAtDateWidget={component:QtyAtDateWidget,};registry.category("view_widgets").add("qty_at_date_widget",qtyAtDateWidget);return __exports;});;

/* /l10n_mx_reports_closing/static/src/components/trial_balance/filters.js */
odoo.define('@l10n_mx_reports_closing/components/trial_balance/filters',['@account_reports/components/account_report/account_report','@account_reports/components/account_report/filters/filters'],function(require){'use strict';let __exports={};const{AccountReport}=require("@account_reports/components/account_report/account_report");const{AccountReportFilters}=require("@account_reports/components/account_report/filters/filters");const{DateTime}=luxon;const L10nMXTrialBalanceReportFilters=__exports.L10nMXTrialBalanceReportFilters=class L10nMXTrialBalanceReportFilters extends AccountReportFilters{static template="l10n_mx_reports_closing.TrialBalanceFilters";initDateFilters(){const filters=super.initDateFilters();filters["year13"]=0;return filters;}
displayPeriod(periodType){if(periodType==='year13'){return this._displayMonth13(DateTime.now());}
return super.displayPeriod(periodType);}
_displayMonth13(dateTo){return dateTo.plus({years:this.dateFilter.year13}).toFormat("yyyy");}
isPeriodSelected(periodType){const isYear13Selected=this.controller.options.date.filter.includes("year13");this.controller.options.l10n_mx_month_13=isYear13Selected;return periodType==="year"&&isYear13Selected?false:super.isPeriodSelected(periodType);}}
AccountReport.registerCustomComponent(L10nMXTrialBalanceReportFilters);return __exports;});;

/* /mail_mobile/static/src/js/mobile_device_register.js */
odoo.define('@mail_mobile/js/mobile_device_register',['@web_mobile/js/services/core','@web/core/network/rpc','@web/session'],function(require){'use strict';let __exports={};const mobile=require("@web_mobile/js/services/core")[Symbol.for("default")];const{rpc}=require("@web/core/network/rpc");const{session}=require("@web/session");if(mobile.methods.getFCMKey){var registerDevice=function(fcm_project_id){mobile.methods.getFCMKey({project_id:fcm_project_id,inbox_action:session.inbox_action,}).then(function(response){if(response.success){rpc('/web/dataset/call_kw/res.config.settings/register_device',{model:'res.config.settings',method:'register_device',args:[response.data.subscription_id,response.data.device_name,response.data.fcm_token_old,],kwargs:{},}).then(function(ocn_token){if(mobile.methods.setOCNToken){mobile.methods.setOCNToken({ocn_token:ocn_token});}});}}).catch(e=>console.error(e));};if(session.fcm_project_id){registerDevice(session.fcm_project_id);}else{rpc('/web/dataset/call_kw/res.config.settings/get_fcm_project_id',{model:'res.config.settings',method:'get_fcm_project_id',args:[],kwargs:{},}).then(function(response){if(response){registerDevice(response);}});}}
return __exports;});;

/* /partner_autocomplete/static/src/js/partner_autocomplete_component.js */
odoo.define('@partner_autocomplete/js/partner_autocomplete_component',['@web/core/autocomplete/autocomplete'],function(require){'use strict';let __exports={};const{AutoComplete}=require("@web/core/autocomplete/autocomplete");const PartnerAutoComplete=__exports.PartnerAutoComplete=class PartnerAutoComplete extends AutoComplete{static template="partner_autocomplete.PartnerAutoComplete";setup(){super.setup();this.shouldSearchWorldwide=false;}
loadOptions(options,request){if(typeof options==="function"){return options(request,this.shouldSearchWorldwide);}else{return options;}}
async searchWorldwide(ev){this.shouldSearchWorldwide=true;ev.preventDefault();super.close();super.open(true);}}
return __exports;});;

/* /partner_autocomplete/static/src/js/partner_autocomplete_core.js */
odoo.define('@partner_autocomplete/js/partner_autocomplete_core',['@web/core/assets','@web/core/l10n/translation','@web/core/browser/browser','@web/core/utils/concurrency','@web/core/utils/hooks','@web/core/utils/render','@web/core/utils/urls','@odoo/owl'],function(require){'use strict';let __exports={};const{loadJS}=require("@web/core/assets");const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{KeepLast}=require("@web/core/utils/concurrency");const{useService}=require("@web/core/utils/hooks");const{renderToMarkup}=require("@web/core/utils/render");const{getDataURLFromFile}=require("@web/core/utils/urls");const{onWillStart}=require("@odoo/owl");__exports.usePartnerAutocomplete=usePartnerAutocomplete;function usePartnerAutocomplete(){const keepLastOdoo=new KeepLast();const notification=useService("notification");const orm=useService("orm");onWillStart(async()=>{await loadJS("/partner_autocomplete/static/lib/jsvat.js");});function sanitizeVAT(value){return value?value.replace(/[^A-Za-z0-9]/g,''):'';}
async function isVATNumber(value){return checkVATNumber(sanitizeVAT(value));}
function isGSTNumber(value){let isGST=false;if(value&&value.length===15){const allGSTinRe=[/\d{2}[a-zA-Z]{5}\d{4}[a-zA-Z][1-9A-Za-z][Zz1-9A-Ja-j][0-9a-zA-Z]/,/\d{4}[A-Z]{3}\d{5}[UO]N[A-Z0-9]/,/\d{4}[a-zA-Z]{3}\d{5}NR[0-9a-zA-Z]/,/\d{2}[a-zA-Z]{4}[a-zA-Z0-9]\d{4}[a-zA-Z][1-9A-Za-z][DK][0-9a-zA-Z]/,/\d{2}[a-zA-Z]{5}\d{4}[a-zA-Z][1-9A-Za-z]C[0-9a-zA-Z]/];isGST=allGSTinRe.some((re)=>re.test(value));}
return isGST;}
async function autocomplete(value,queryCountryId){value=value.trim();const isVAT=await isVATNumber(value);if(isVAT){value=sanitizeVAT(value);}
const isGST=isGSTNumber(value);return await getSuggestions(value,isVAT||isGST,queryCountryId);}
function enrichCompany(company){if(isGSTNumber(company.query)){return orm.call('res.partner','enrich_by_gst',[company.query]);}
return orm.call('res.partner','enrich_by_duns',[company.duns]);}
function removeUselessFields(company,fieldsToKeep){for(const field in company){if(!fieldsToKeep.includes(field)){delete company[field]}}
return company;};function getCreateData(company,fieldsToKeep){return new Promise((resolve)=>{const enrichPromise=enrichCompany(company);const logoPromise=company.logoUrl?getCompanyLogo(company.logoUrl):false;whenAll([enrichPromise,logoPromise]).then(([companyData,logoData])=>{if(companyData.error){if(companyData.error_message==='Insufficient Credit'){notifyNoCredits();}
else if(companyData.error_message==='No Account Token'){notifyAccountToken();}
else{notification.add(companyData.error_message);}
companyData={...company,...companyData,};}
resolve({company:companyData,logo:logoData});})});}
async function fetchNoCaching(url){try{const response=await browser.fetch(url,{method:'GET',cache:'no-cache',});return await response.json();}catch{return{}}}
async function getClearbitLogoUrl(company){let clearbitData=await fetchNoCaching(encodeURI(`https://autocomplete.clearbit.com/v1/companies/suggest?query=${company.name}`));if(!clearbitData.length){if(company.domain){clearbitData=await fetchNoCaching(encodeURI(`https://autocomplete.clearbit.com/v1/companies/suggest?query=${company.domain}`));}
if(!clearbitData.length){return'';}}
const firstResult=clearbitData[0];if(firstResult.name.toLowerCase()===company.name.toLowerCase()||(company.domain!==undefined&&firstResult.domain===company.domain)){return firstResult.logo;}
return'';}
async function getCompanyLogo(logoUrl){try{if(!logoUrl){return false;}
const base64Image=await getBase64Image(logoUrl);return base64Image?base64Image.replace(/^data:image[^;]*;base64,?/,''):false;}
catch{return false;}}
function getBase64Image(url){return new Promise((resolve,reject)=>{const xhr=new XMLHttpRequest();xhr.onload=()=>{getDataURLFromFile(xhr.response).then(resolve);};xhr.open('GET',url);xhr.responseType='blob';xhr.onerror=reject;xhr.send();});}
async function getSuggestions(value,isVAT,queryCountryId){const method=isVAT?'autocomplete_by_vat':'autocomplete_by_name';const prom=orm.silent.call('res.partner',method,[value,queryCountryId],);const suggestions=await keepLastOdoo.add(prom);await Promise.all(suggestions.map(async(suggestion)=>{suggestion.query=value;suggestion.logoUrl=await getClearbitLogoUrl(suggestion);suggestion.description='';if(suggestion.city){suggestion.description+=suggestion.city;}
if(queryCountryId===0&&suggestion.country_id&&suggestion.country_id.display_name){suggestion.description+=', '+suggestion.country_id.display_name;}
return suggestion;}));return suggestions;}
function whenAll(promises){return Promise.all(promises.map((p)=>{return Promise.resolve(p);}));}
async function notifyNoCredits(){const url=await orm.call('iap.account','get_credits_url',['partner_autocomplete'],);const title=_t('Not enough credits for Partner Autocomplete');const content=renderToMarkup('partner_autocomplete.InsufficientCreditNotification',{credits_url:url});notification.add(content,{title,});}
async function notifyAccountToken(){const url=await orm.call('iap.account','get_config_account_url',[]);const title=_t('IAP Account Token missing');if(url){const content=renderToMarkup('partner_autocomplete.AccountTokenMissingNotification',{account_url:url});notification.add(content,{title,});}
else{notification.add(title);}}
return{autocomplete,getCreateData,removeUselessFields};}
return __exports;});;

/* /partner_autocomplete/static/src/js/partner_autocomplete_fieldchar.js */
odoo.define('@partner_autocomplete/js/partner_autocomplete_fieldchar',['@web/core/utils/hooks','@web/core/registry','@web/core/l10n/translation','@web/views/fields/char/char_field','@web/views/fields/input_field_hook','@partner_autocomplete/js/partner_autocomplete_core','@partner_autocomplete/js/partner_autocomplete_component'],function(require){'use strict';let __exports={};const{useChildRef,useService}=require("@web/core/utils/hooks");const{registry}=require("@web/core/registry");const{_t}=require("@web/core/l10n/translation");const{CharField,charField}=require("@web/views/fields/char/char_field");const{useInputField}=require("@web/views/fields/input_field_hook");const{usePartnerAutocomplete}=require("@partner_autocomplete/js/partner_autocomplete_core");const{PartnerAutoComplete}=require("@partner_autocomplete/js/partner_autocomplete_component");const PartnerAutoCompleteCharField=__exports.PartnerAutoCompleteCharField=class PartnerAutoCompleteCharField extends CharField{static template="partner_autocomplete.PartnerAutoCompleteCharField";static components={...CharField.components,PartnerAutoComplete,};setup(){super.setup();this.orm=useService("orm");this.partnerAutocomplete=usePartnerAutocomplete();this.inputRef=useChildRef();useInputField({getValue:()=>this.props.record.data[this.props.name]||"",parse:(v)=>this.parse(v),ref:this.inputRef});}
async validateSearchTerm(request){return request&&request.length>2;}
get sources(){return[{options:async(request,shouldSearchWorldWide)=>{if(await this.validateSearchTerm(request)){let queryCountryId=this.props.record.data?.country_id?this.props.record.data.country_id[0]:false;if(shouldSearchWorldWide){queryCountryId=0;}
const suggestions=await this.partnerAutocomplete.autocomplete(request,queryCountryId);suggestions.forEach((suggestion)=>{suggestion.classList="partner_autocomplete_dropdown_char";});return suggestions;}
else{return[];}},optionTemplate:"partner_autocomplete.DropdownOption",placeholder:_t('Searching Autocomplete...'),},];}
async onSelect(option){let data=await this.partnerAutocomplete.getCreateData(Object.getPrototypeOf(option));if(!data?.company){return;}
if(data.logo){const logoField=this.props.record.resModel==='res.partner'?'image_1920':'logo';data.company[logoField]=data.logo;}
const many2oneFields=['country_id','state_id'];many2oneFields.forEach((field)=>{if(data.company[field]){data.company[field]=[data.company[field].id,data.company[field].display_name];}});const unspsc_codes=data.company.unspsc_codes
data.company=this.partnerAutocomplete.removeUselessFields(data.company,Object.keys(this.props.record.fields));if(data.company.name){await this.props.record.update({name:data.company.name});}
await this.props.record.update(data.company);if(this.props.record.resModel==='res.partner'&&unspsc_codes){const saved=await this.props.record.save();if(saved){await this.props.record.load();await this.orm.call("res.partner","iap_partner_autocomplete_add_tags",[this.props.record.resId,unspsc_codes]);await this.props.record.load();}}
if(this.props.setDirty){this.props.setDirty(false);}}}
const partnerAutoCompleteCharField=__exports.partnerAutoCompleteCharField={...charField,component:PartnerAutoCompleteCharField,};registry.category("fields").add("field_partner_autocomplete",partnerAutoCompleteCharField);return __exports;});;

/* /partner_autocomplete/static/src/js/partner_autocomplete_many2one.js */
odoo.define('@partner_autocomplete/js/partner_autocomplete_many2one',['@web/views/fields/relational_utils','@web/views/fields/many2one/many2one_field','@web/core/l10n/translation','@web/core/registry','@partner_autocomplete/js/partner_autocomplete_core','@partner_autocomplete/js/partner_autocomplete_component'],function(require){'use strict';let __exports={};const{Many2XAutocomplete}=require('@web/views/fields/relational_utils');const{Many2OneField,many2OneField}=require('@web/views/fields/many2one/many2one_field');const{_t}=require("@web/core/l10n/translation");const{registry}=require("@web/core/registry");const{usePartnerAutocomplete}=require("@partner_autocomplete/js/partner_autocomplete_core");const{PartnerAutoComplete}=require("@partner_autocomplete/js/partner_autocomplete_component");const PartnerMany2XAutocomplete=__exports.PartnerMany2XAutocomplete=class PartnerMany2XAutocomplete extends Many2XAutocomplete{static template="partner_autocomplete.PartnerAutoCompleteMany2XField";static components={...Many2XAutocomplete.components,PartnerAutoComplete,};setup(){super.setup();this.partnerAutocomplete=usePartnerAutocomplete();}
validateSearchTerm(request){return request&&request.length>2;}
get sources(){const sources=super.sources;if(!this.props.canCreate){return sources;}
return sources.concat({options:async(request,shouldSearchWorldWide)=>{if(this.validateSearchTerm(request)){let queryCountryId=false;if(shouldSearchWorldWide){queryCountryId=0;}
const suggestions=await this.partnerAutocomplete.autocomplete(request,queryCountryId);suggestions.forEach((suggestion)=>{suggestion.classList="partner_autocomplete_dropdown_many2one";suggestion.isFromPartnerAutocomplete=true;});return suggestions;}
else{return[];}},optionTemplate:"partner_autocomplete.DropdownOption",placeholder:_t("Searching Autocomplete..."),},);}
async onSelect(option,params){if(option.isFromPartnerAutocomplete){const data=await this.partnerAutocomplete.getCreateData(Object.getPrototypeOf(option));if(!data?.company){return;}
let context={'default_is_company':true};for(const[key,val]of Object.entries(data.company)){context['default_'+key]=val&&val.id?val.id:val;}
if(data.logo){context.default_image_1920=data.logo;}
return this.openMany2X({context});}
else{return super.onSelect(option,params);}}}
PartnerMany2XAutocomplete.props={...Many2XAutocomplete.props,canCreate:{type:Boolean,optional:true},}
const PartnerAutoCompleteMany2one=__exports.PartnerAutoCompleteMany2one=class PartnerAutoCompleteMany2one extends Many2OneField{static components={...Many2OneField.components,Many2XAutocomplete:PartnerMany2XAutocomplete,};static props={...Many2OneField.props,canCreate:this.props.canCreate,};get Many2XAutocompleteProps(){return{...super.Many2XAutocompleteProps,canCreate:this.props.canCreate,};}}
const partnerAutoCompleteMany2one=__exports.partnerAutoCompleteMany2one={...many2OneField,component:PartnerAutoCompleteMany2one,};registry.category("fields").add("res_partner_many2one",partnerAutoCompleteMany2one);return __exports;});;

/* /partner_autocomplete/static/src/js/web_company_autocomplete.js */
odoo.define('@partner_autocomplete/js/web_company_autocomplete',['@web/core/registry','@web/session'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{session}=require("@web/session");const companyAutocompleteService=__exports.companyAutocompleteService={dependencies:["orm","company"],start(env,{orm,company}){if(session.iap_company_enrich){const currentCompanyId=company.currentCompany.id;orm.silent.call("res.company","iap_enrich_auto",[currentCompanyId],{});}},};registry.category("services").add("partner_autocomplete.companyAutocomplete",companyAutocompleteService);return __exports;});;

/* /product_barcodelookup/static/src/widgets/barcode_scanner.js */
odoo.define('@product_barcodelookup/widgets/barcode_scanner',['@web/core/registry','@web/views/fields/char/char_field','@web/core/barcode/barcode_dialog'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{CharField,charField}=require("@web/views/fields/char/char_field");const{scanBarcode}=require("@web/core/barcode/barcode_dialog");const BarcodeScannerWidget=__exports.BarcodeScannerWidget=class BarcodeScannerWidget extends CharField{static template="product_barcodelookup.barcodeformbarcode";setup(){super.setup();}
async onBarcodeBtnClick(){const barcode=await scanBarcode(this.env);if(barcode){await this.props.record.update({barcode:barcode,});}}}
const barcodeScannerWidget=__exports.barcodeScannerWidget={...charField,component:BarcodeScannerWidget,};registry.category("fields").add("productScanner",barcodeScannerWidget);return __exports;});;

/* /project_account_budget/static/src/components/project_right_side_panel/project_right_side_panel.js */
odoo.define('@project_account_budget/components/project_right_side_panel/project_right_side_panel',['@web/core/l10n/translation','@web/core/utils/patch','@project/components/project_right_side_panel/project_right_side_panel'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{ProjectRightSidePanel}=require('@project/components/project_right_side_panel/project_right_side_panel');patch(ProjectRightSidePanel.prototype,{async loadBudgets(){const budgets=await this.orm.call('project.project','get_budget_items',[[this.projectId]],{context:this.context},);this.state.data.budget_items=budgets;return budgets;},addBudget(){const context={...this.context,project_update:true,default_project_id:this.projectId,default_company_id:this.state.data.budget_items.company_id,};this.openFormViewDialog({context,title:_t('New Budget'),resModel:'budget.analytic',onRecordSaved:async()=>{await this.loadBudgets();},viewId:this.state.data.budget_items.form_view_id,});},get panelVisible(){return super.panelVisible||this.state.data.show_budget_items;},});return __exports;});;

/* /project_purchase/static/src/product_catalog/kanban_record.js */
odoo.define('@project_purchase/product_catalog/kanban_record',['@web/core/utils/patch','@product/product_catalog/kanban_record'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{ProductCatalogKanbanRecord}=require("@product/product_catalog/kanban_record");patch(ProductCatalogKanbanRecord.prototype,{_getUpdateQuantityAndGetPriceParams(){return{...super._getUpdateQuantityAndGetPriceParams(),project_id:this.props.record.context.project_id,};},});return __exports;});;

/* /project_report_pdf/static/src/js/action_manager.js */
odoo.define('@project_report_pdf/js/action_manager',['@web/core/registry','@web/core/ui/block_ui','@web/core/network/download'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{BlockUI}=require("@web/core/ui/block_ui");const{download}=require("@web/core/network/download");registry.category("ir.actions.report handlers").add("xlsx",async function(action){if(action.report_type==='xlsx'){const blockUI=new BlockUI();await download({url:'/xlsx_reports',data:action.data,complete:()=>unblockUI,error:(error)=>self.call('crash_manager','rpc_error',error),});}});return __exports;});;

/* /sale_expense/static/src/js/sale_order_many2one.js */
odoo.define('@sale_expense/js/sale_order_many2one',['@web/views/fields/many2one/many2one_field','@web/core/registry'],function(require){'use strict';let __exports={};const{Many2OneField,many2OneField}=require('@web/views/fields/many2one/many2one_field');const{registry}=require("@web/core/registry");const OrderField=__exports.OrderField=class OrderField extends Many2OneField{setup(){super.setup();}
get Many2XAutocompleteProps(){return{...super.Many2XAutocompleteProps,noSearchMore:true,}}}
const orderField=__exports.orderField={...many2OneField,component:OrderField,};registry.category("fields").add("sale_order_many2one",orderField);registry.add('sale_order_many2one',OrderField);return __exports;});;

/* /project_sale_subscription/static/src/components/project_right_side_panel/components/project_profitabilitySection.js */
odoo.define('@project_sale_subscription/components/project_right_side_panel/components/project_profitabilitySection',['@web/core/utils/patch','@sale_project/components/project_right_side_panel/components/project_profitability_section'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{ProjectProfitabilitySection}=require("@sale_project/components/project_right_side_panel/components/project_profitability_section");patch(ProjectProfitabilitySection.prototype,{_getOrmValue(offset,section_id){if(section_id==="subscriptions"){return{function:"get_subscription_items_data",args:[this.props.projectId,offset,5],};}else{return super._getOrmValue(offset,section_id);}},});return __exports;});;

/* /sale_account_accountant/static/src/components/bank_reconciliation/kanban.js */
odoo.define('@sale_account_accountant/components/bank_reconciliation/kanban',['@web/core/utils/patch','@account_accountant/components/bank_reconciliation/kanban'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{BankRecKanbanController}=require("@account_accountant/components/bank_reconciliation/kanban");patch(BankRecKanbanController.prototype,{async actionRedirectToSaleOrders(){await this.execProtectedBankRecAction(async()=>{await this.withNewState(async(newState)=>{const{return_todo_command:actionData}=await this.onchange(newState,"redirect_to_matched_sale_orders");if(actionData){this.action.doAction(actionData);}});});},});return __exports;});;

/* /sale_pdf_quote_builder/static/src/js/custom_content_kanban_like_widget/custom_content_kanban_like_widget.js */
odoo.define('@sale_pdf_quote_builder/js/custom_content_kanban_like_widget/custom_content_kanban_like_widget',['@odoo/owl','@sale_pdf_quote_builder/js/custom_content_kanban_like_widget/custom_field_card/custom_field_card','@web/core/orm_service','@web/core/registry','@web/core/utils/hooks','@web/views/widgets/standard_widget_props'],function(require){'use strict';let __exports={};const{Component,useEffect,useState}=require("@odoo/owl");const{CustomFieldCard}=require("@sale_pdf_quote_builder/js/custom_content_kanban_like_widget/custom_field_card/custom_field_card");const{x2ManyCommands}=require("@web/core/orm_service");const{registry}=require('@web/core/registry');const{useService}=require("@web/core/utils/hooks");const{standardWidgetProps}=require("@web/views/widgets/standard_widget_props");const CustomContentKanbanLikeWidget=__exports.CustomContentKanbanLikeWidget=class CustomContentKanbanLikeWidget extends Component{static components={CustomFieldCard};static template="sale_pdf_quote_builder.CustomContentKanbanLike";static props={...standardWidgetProps,};setup(){this.orm=useService("orm");this.state=useState({headers:{},lines:{},footers:{},});useEffect((saleOrderTemplate)=>{this.updateState();},()=>[this.props.record.data.sale_order_template_id]);}
async updateState(){const saved=await this.props.record.save();if(saved){const{headers,lines,footers}=await this.orm.call('sale.order','get_update_included_pdf_params',[this.props.record.resId])
this.state.headers=headers;this.state.lines=lines;this.state.footers=footers;}}
updateJson(){const selectedHeaders=this.state.headers.files.filter(f=>f.is_selected);const selectedFooters=this.state.footers.files.filter(f=>f.is_selected);const value=JSON.stringify({'header':Object.assign({},...selectedHeaders.map(header=>{return{[header.id]:{document_name:header.name,custom_form_fields:Object.assign({},...header.custom_form_fields.map(formField=>({[formField.name]:formField.value}))),}}})),'line':Object.assign({},...this.state.lines.map(line=>{return{[line.id]:Object.assign({},...line.files.filter(f=>f.is_selected).map(doc=>{return{[doc.id]:{document_name:doc.name,custom_form_fields:Object.assign({},...doc.custom_form_fields.map(formField=>({[formField.name]:formField.value}))),}}})),}})),'footer':Object.assign({},...selectedFooters.map(footer=>{return{[footer.id]:{document_name:footer.name,custom_form_fields:Object.assign({},...footer.custom_form_fields.map(formField=>({[formField.name]:formField.value}))),}}})),})
this.props.record.update({['customizable_pdf_form_fields']:value});}
async saveProductDocument(lineId,docId,isSelected){const sol=this.props.record.data.order_line.records.find(sol=>sol.resId===lineId);sol._noUpdateParent=true;if(isSelected){await sol.update({product_document_ids:[x2ManyCommands.link(docId)]},{save:true});}else{await sol.update({product_document_ids:[x2ManyCommands.unlink(docId)]},{save:true});}
await this.props.record.data.order_line._onUpdate({withoutOnchange:true});this.updateJson();};async saveQuotationDocument(docId,isSelected){if(isSelected){await this.props.record.update({quotation_document_ids:[x2ManyCommands.link(docId),],});}else{await this.props.record.update({quotation_document_ids:[x2ManyCommands.unlink(docId),],});}
this.updateJson();};}
const customContentKanbanLikeWidget=__exports.customContentKanbanLikeWidget={component:CustomContentKanbanLikeWidget,};registry.category("view_widgets").add("customContentKanbanLikeWidget",customContentKanbanLikeWidget);return __exports;});;

/* /sale_pdf_quote_builder/static/src/js/custom_content_kanban_like_widget/custom_field_card/custom_field_card.js */
odoo.define('@sale_pdf_quote_builder/js/custom_content_kanban_like_widget/custom_field_card/custom_field_card',['@odoo/owl','@web/core/l10n/translation','@web/core/utils/autoresize'],function(require){'use strict';let __exports={};const{Component,useRef}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const{useAutoresize}=require("@web/core/utils/autoresize");const CustomFieldCard=__exports.CustomFieldCard=class CustomFieldCard extends Component{static template="sale_pdf_quote_builder.customFieldCard";static props={name:String,value:String,onChange:Function,};setup(){this.customFormFieldTextAreaRef=useRef('customFieldCardTextArea');this.placeholder=_t("Click to write content for the PDF quote...");useAutoresize(this.customFormFieldTextAreaRef);}
expandTextArea(ev){const textarea=ev.target;textarea.style.height=textarea.scrollHeight+'px';}}
return __exports;});;

/* /sale_pdf_quote_builder/static/src/js/quotation_document_kanban/quotation_document_kanban_controller.js */
odoo.define('@sale_pdf_quote_builder/js/quotation_document_kanban/quotation_document_kanban_controller',['@odoo/owl','@product/js/product_document_kanban/upload_button/upload_button','@web/views/kanban/kanban_controller'],function(require){'use strict';let __exports={};const{onWillRender}=require("@odoo/owl");const{UploadButton}=require('@product/js/product_document_kanban/upload_button/upload_button');const{KanbanController}=require('@web/views/kanban/kanban_controller');const QuotationDocumentKanbanController=__exports.QuotationDocumentKanbanController=class QuotationDocumentKanbanController extends KanbanController{static components={...KanbanController.components,UploadButton};setup(){super.setup();this.uploadRoute='/sale_pdf_quote_builder/quotation_document/upload';this.allowedMIMETypes='application/pdf';onWillRender(()=>{this.formData={'allowed_company_ids':JSON.stringify(this.props.context.allowed_company_ids),};});}}
return __exports;});;

/* /sale_pdf_quote_builder/static/src/js/quotation_document_kanban/quotation_document_kanban_view.js */
odoo.define('@sale_pdf_quote_builder/js/quotation_document_kanban/quotation_document_kanban_view',['@product/js/product_document_kanban/product_document_kanban_view','@sale_pdf_quote_builder/js/quotation_document_kanban/quotation_document_kanban_controller','@web/core/registry'],function(require){'use strict';let __exports={};const{productDocumentKanbanView}=require('@product/js/product_document_kanban/product_document_kanban_view');const{QuotationDocumentKanbanController}=require('@sale_pdf_quote_builder/js/quotation_document_kanban/quotation_document_kanban_controller');const{registry}=require('@web/core/registry');const quotationDocumentKanbanView=__exports.quotationDocumentKanbanView={...productDocumentKanbanView,Controller:QuotationDocumentKanbanController,};registry.category('views').add('quotation_document_kanban',quotationDocumentKanbanView);return __exports;});;

/* /sale_pdf_quote_builder/static/src/js/quotation_document_kanban/quotation_document_kanban_widget.js */
odoo.define('@sale_pdf_quote_builder/js/quotation_document_kanban/quotation_document_kanban_widget',['@product/js/product_document_kanban/product_document_kanban_renderer','@product/js/product_document_kanban/upload_button/upload_button','@web/core/registry','@web/views/fields/x2many/x2many_field','@odoo/owl'],function(require){'use strict';let __exports={};const{ProductDocumentKanbanRenderer}=require("@product/js/product_document_kanban/product_document_kanban_renderer");const{UploadButton}=require('@product/js/product_document_kanban/upload_button/upload_button');const{registry}=require('@web/core/registry');const{X2ManyField,x2ManyField}=require('@web/views/fields/x2many/x2many_field');const{onWillRender}=require("@odoo/owl");const QuotationDocumentX2ManyField=__exports.QuotationDocumentX2ManyField=class QuotationDocumentX2ManyField extends X2ManyField{static template='sale_pdf_quote_builder.QuotationDocumentX2ManyField';static components={...X2ManyField.components,UploadButton,KanbanRenderer:ProductDocumentKanbanRenderer,};setup(){super.setup();this.uploadRoute='/sale_pdf_quote_builder/quotation_document/upload';this.allowedMIMETypes='application/pdf';onWillRender(()=>{this.formData={'sale_order_template_id':this.props.record.resId,};});}}
const quotationDocumentX2ManyField=__exports.quotationDocumentX2ManyField={...x2ManyField,component:QuotationDocumentX2ManyField,};registry.category('fields').add('quotation_document_many2many',quotationDocumentX2ManyField);return __exports;});;

/* /sale_planning/static/src/components/conflicting_slot_ids_field/conflicting_slot_ids_field.js */
odoo.define('@sale_planning/components/conflicting_slot_ids_field/conflicting_slot_ids_field',['@planning/components/conflicting_slot_ids_field/conflicting_slot_ids_field','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{conflictingSlotIdsField,ConflictingSlotIdsField,}=require("@planning/components/conflicting_slot_ids_field/conflicting_slot_ids_field");const{patch}=require("@web/core/utils/patch");patch(ConflictingSlotIdsField.prototype,{getConflictSlotMessage(slot){const message=super.getConflictSlotMessage(slot);if(!slot.data.sale_line_id){return message;}else if(message.length&&slot.data.sale_line_id){return`${message} - ${slot.data.sale_line_id}`;}
return slot.data.sale_line_id;},});const relatedFields=conflictingSlotIdsField.relatedFields;Object.assign(conflictingSlotIdsField,{relatedFields:(fieldInfo)=>{const fields=relatedFields(fieldInfo);fields.push({name:"sale_line_id",type:"many2one",relation:"sale.order.line"});return fields;},});return __exports;});;

/* /sale_planning/static/src/views/planning_hooks.js */
odoo.define('@sale_planning/views/planning_hooks',['@web/core/l10n/translation','@web/core/utils/patch','@planning/views/planning_hooks','@web/core/domain'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");const{PlanningControllerActions}=require("@planning/views/planning_hooks");const{Domain}=require("@web/core/domain");patch(PlanningControllerActions.prototype,{autoPlanDomain(){const domain=super.autoPlanDomain(...arguments);return Domain.and([domain,["|",["sale_line_id","=",false],["sale_line_id.state","!=","cancel"]],]).toList();},autoPlanSuccessNotification(){return _t("Open shifts and sales orders assigned");},autoPlanFailureNotification(){return _t("All open shifts and sales orders have already been assigned, or there are no resources available to take them at this time.");},autoPlanRollbackSuccessNotification(){return _t("Open shifts and sales orders unscheduled");},});return __exports;});;

/* /snailmail/static/src/core/failure_model_patch.js */
odoo.define('@snailmail/core/failure_model_patch',['@mail/core/common/failure_model','@web/core/l10n/translation','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Failure}=require("@mail/core/common/failure_model");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");patch(Failure.prototype,{get iconSrc(){if(this.type==="snail"){return"/snailmail/static/img/snailmail_failure.png";}
return super.iconSrc;},get body(){if(this.type==="snail"){if(this.notifications.length===1&&this.lastMessage?.thread){return _t("An error occurred when sending a letter with Snailmail on “%(record_name)s”",{record_name:this.lastMessage.thread.name});}
return _t("An error occurred when sending a letter with Snailmail.");}
return super.body;},});return __exports;});;

/* /snailmail/static/src/core/notification_model_patch.js */
odoo.define('@snailmail/core/notification_model_patch',['@mail/core/common/notification_model','@web/core/utils/patch','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{Notification}=require("@mail/core/common/notification_model");const{patch}=require("@web/core/utils/patch");const{_t}=require("@web/core/l10n/translation");patch(Notification.prototype,{get icon(){if(this.notification_type==="snail"){return"fa fa-paper-plane";}
return super.icon;},get statusIcon(){if(this.notification_type==="snail"){switch(this.notification_status){case"sent":return"fa fa-check";case"ready":return"fa fa-clock-o";case"canceled":return"fa fa-trash-o";default:return"fa fa-exclamation text-danger";}}
return super.statusIcon;},get statusTitle(){if(this.notification_type==="snail"){switch(this.notification_status){case"sent":return _t("Sent");case"ready":return _t("Awaiting Dispatch");case"canceled":return _t("Cancelled");default:return _t("Error");}}
return super.statusTitle;},});return __exports;});;

/* /snailmail/static/src/core_ui/message_patch.js */
odoo.define('@snailmail/core_ui/message_patch',['@mail/core/common/message','@snailmail/core_ui/snailmail_error','@snailmail/core_ui/snailmail_notification_popover','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{Message}=require("@mail/core/common/message");const{SnailmailError}=require("@snailmail/core_ui/snailmail_error");const{SnailmailNotificationPopover}=require("@snailmail/core_ui/snailmail_notification_popover");const{patch}=require("@web/core/utils/patch");patch(Message.prototype,{onClickFailure(){if(this.message.message_type==="snailmail"){const failureType=this.message.notifications[0].failure_type;switch(failureType){case"sn_credit":case"sn_trial":case"sn_price":case"sn_error":this.env.services.dialog.add(SnailmailError,{failureType:failureType,messageId:this.message.id,});break;case"sn_fields":this.openMissingFieldsLetterAction();break;case"sn_format":this.openFormatLetterAction();break;}}else{super.onClickFailure(...arguments);}},async openMissingFieldsLetterAction(){const letterIds=await this.env.services.orm.searchRead("snailmail.letter",[["message_id","=",this.message.id]],["id"]);this.env.services.action.doAction("snailmail.snailmail_letter_missing_required_fields_action",{additionalContext:{default_letter_id:letterIds[0].id,},});},openFormatLetterAction(){this.env.services.action.doAction("snailmail.snailmail_letter_format_error_action",{additionalContext:{message_id:this.message.id,},});},});Message.components={...Message.components,Popover:SnailmailNotificationPopover,SnailmailError,};return __exports;});;

/* /snailmail/static/src/core_ui/snailmail_error.js */
odoo.define('@snailmail/core_ui/snailmail_error',['@odoo/owl','@web/core/dialog/dialog','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{Dialog}=require("@web/core/dialog/dialog");const{useService}=require("@web/core/utils/hooks");const SnailmailError=__exports.SnailmailError=class SnailmailError extends Component{static components={Dialog};static props=["close","failureType","messageId"];static template="snailmail.SnailmailError";setup(){this.orm=useService("orm");}
async fetchSnailmailCreditsUrl(){return await this.orm.call("iap.account","get_credits_url",["snailmail"]);}
async fetchSnailmailCreditsUrlTrial(){return await this.orm.call("iap.account","get_credits_url",["snailmail","",0,true]);}
async onClickResendLetter(){await this.orm.call("mail.message","send_letter",[[this.props.messageId]]);this.props.close();}
async onClickCancelLetter(){await this.orm.call("mail.message","cancel_letter",[[this.props.messageId]]);this.props.close();}
get snailmailCreditsUrl(){return this.fetchSnailmailCreditsUrl();}
get snailmailCreditsUrlTrial(){return this.fetchSnailmailCreditsUrlTrial();}}
return __exports;});;

/* /snailmail/static/src/core_ui/snailmail_notification_popover.js */
odoo.define('@snailmail/core_ui/snailmail_notification_popover',['@odoo/owl'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const SnailmailNotificationPopover=__exports.SnailmailNotificationPopover=class SnailmailNotificationPopover extends Component{static template="snailmail.SnailmailNotificationPopover";static props=["message","close?"];}
return __exports;});;

/* /snailmail/static/src/messaging_menu/messaging_menu_patch.js */
odoo.define('@snailmail/messaging_menu/messaging_menu_patch',['@mail/core/public_web/messaging_menu','@web/core/l10n/translation','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{MessagingMenu}=require("@mail/core/public_web/messaging_menu");const{_t}=require("@web/core/l10n/translation");const{patch}=require("@web/core/utils/patch");patch(MessagingMenu.prototype,{openFailureView(failure){if(failure.type!=="snail"){return super.openFailureView(failure);}
this.env.services.action.doAction({name:_t("Snailmail Failures"),type:"ir.actions.act_window",view_mode:"kanban,list,form",views:[[false,"kanban"],[false,"list"],[false,"form"],],target:"current",res_model:failure.resModel,domain:[["message_ids.snailmail_error","=",true]],});this.dropdown.close();},getFailureNotificationName(failure){if(failure.type==="snail"){return _t("Snailmail Failure: %(modelName)s",{modelName:failure.modelName});}
return super.getFailureNotificationName(...arguments);},});return __exports;});;

/* /social_facebook/static/src/js/utils.js */
odoo.define('@social_facebook/js/utils',[],function(require){'use strict';let __exports={};const _FACEBOOK_REACTIONS={LIKE:"👍",LOVE:"❤️",HAHA:"😆",WOW:"😮",SAD:"😥",ANGRY:"😡",CARE:"🥰",};__exports.formatFacebookReactions=formatFacebookReactions;function formatFacebookReactions(reactions,limit){let sorted=Object.entries(reactions||{}).filter(([_reactionName,reactionCount])=>reactionCount!==0).sort(([_reactionName1,reactionCount1],[_reactionName2,reactionCount2])=>reactionCount2-reactionCount1);if(limit){sorted=sorted.slice(0,limit);}
return sorted.map(([reactionName,reactionCount])=>[_FACEBOOK_REACTIONS[reactionName],reactionCount,]);}
return __exports;});;

/* /social_facebook/static/src/components/social_facebook_reactions/social_facebook_reactions.js */
odoo.define('@social_facebook/components/social_facebook_reactions/social_facebook_reactions',['@odoo/owl','@web/core/registry','@web/views/fields/standard_field_props','@social_facebook/js/utils'],function(require){'use strict';let __exports={};const{Component}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{standardFieldProps}=require("@web/views/fields/standard_field_props");const{formatFacebookReactions}=require("@social_facebook/js/utils");const SocialFacebookReactions=__exports.SocialFacebookReactions=class SocialFacebookReactions extends Component{static template="SocialFacebookReactions";static props=standardFieldProps;get mostUsedReactions(){return formatFacebookReactions(JSON.parse(this.props.record.data[this.props.name]||[]),2).map((reaction)=>reaction[0]).join("");}}
registry.category("fields").add("social_facebook_reactions",{component:SocialFacebookReactions,});return __exports;});;

/* /social_facebook/static/src/js/stream_post_comment.js */
odoo.define('@social_facebook/js/stream_post_comment',['@social/js/stream_post_comment','@social_facebook/js/stream_post_comments_reply','@social_facebook/js/utils','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{StreamPostComment}=require('@social/js/stream_post_comment');const{StreamPostCommentsReplyFacebook}=require("@social_facebook/js/stream_post_comments_reply");const{formatFacebookReactions}=require("@social_facebook/js/utils");const{sprintf}=require('@web/core/utils/strings');const StreamPostCommentFacebook=__exports.StreamPostCommentFacebook=class StreamPostCommentFacebook extends StreamPostComment{get authorLink(){if(this.comment.from.id){return sprintf('/social_facebook/redirect_to_profile/%s/%s?name=%s',encodeURIComponent(this.props.mediaSpecificProps.accountId),encodeURIComponent(this.comment.from.id),encodeURIComponent(this.comment.from.name));}else{return"#";}}
get authorPictureSrc(){if(this.comment.from&&this.comment.from.picture){return this.comment.from.picture.data.url;}else{return'/web/static/img/user_placeholder.jpg';}}
get commentReplyComponent(){return StreamPostCommentsReplyFacebook;}
get deleteCommentEndpoint(){return'/social_facebook/delete_comment';}
get isAuthor(){return this.comment.from.id===this.props.mediaSpecificProps.pageFacebookId;}
get link(){return sprintf('https://www.facebook.com/%s',this.comment.id);}
get facebookReactions(){return formatFacebookReactions(this.comment.reactions);}}
return __exports;});;

/* /social_facebook/static/src/js/stream_post_comment_list.js */
odoo.define('@social_facebook/js/stream_post_comment_list',['@web/core/network/rpc','@social/js/stream_post_comment_list','@social_facebook/js/stream_post_comment'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{StreamPostCommentList}=require('@social/js/stream_post_comment_list');const{StreamPostCommentFacebook}=require("@social_facebook/js/stream_post_comment");const StreamPostCommentListFacebook=__exports.StreamPostCommentListFacebook=class StreamPostCommentListFacebook extends StreamPostCommentList{_updateLikes(comment){comment.reactions=comment.reactions||{};comment.reactions["LIKE"]=comment.user_likes?Math.max(0,(comment.reactions["LIKE"]||0)-1):(comment.reactions["LIKE"]||0)+1;comment.user_likes=!comment.user_likes;}
toggleUserLikes(comment){rpc('/social_facebook/like_comment',{stream_post_id:this.originalPost.id.raw_value,comment_id:comment.id,like:!comment.user_likes,});this._updateLikes(comment);}
get commentComponent(){return StreamPostCommentFacebook;}}
return __exports;});;

/* /social_facebook/static/src/js/stream_post_comments.js */
odoo.define('@social_facebook/js/stream_post_comments',['@web/core/network/rpc','@social/js/stream_post_comments','@social_facebook/js/stream_post_comment_list','@social_facebook/js/stream_post_comments_reply','@social_facebook/js/utils','@odoo/owl'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{StreamPostComments}=require('@social/js/stream_post_comments');const{StreamPostCommentListFacebook}=require("@social_facebook/js/stream_post_comment_list");const{StreamPostCommentsReplyFacebook}=require("@social_facebook/js/stream_post_comments_reply");const{formatFacebookReactions}=require("@social_facebook/js/utils");const{onWillStart}=require("@odoo/owl");const StreamPostCommentsFacebook=__exports.StreamPostCommentsFacebook=class StreamPostCommentsFacebook extends StreamPostComments{setup(){super.setup();this.totalLoadedComments=this.props.comments.length;this.nextRecordsToken=this.props.nextRecordsToken;this.commentsCount=this.props.commentsCount;this.state.showLoadMoreComments=this.totalLoadedComments<this.props.summary.total_count;onWillStart(async()=>{const facebookInfo=await this.orm.read('social.account',[this.props.accountId],['name','facebook_account_id']);this.mediaSpecificProps=Object.assign(this.mediaSpecificProps,{accountId:this.props.accountId,accountName:facebookInfo[0].name,pageFacebookId:facebookInfo[0].facebook_account_id,});});}
async loadMoreComments(){const nextComments=await rpc('/social_facebook/get_comments',{stream_post_id:this.originalPost.id.raw_value,next_records_token:this.nextRecordsToken,comments_count:this.commentsCount});this.totalLoadedComments+=nextComments.comments.length;if(this.totalLoadedComments>=this.props.summary.total_count){this.state.showLoadMoreComments=false;}
this.comments.push(...nextComments.comments);this.nextRecordsToken=nextComments.nextRecordsToken;}
async _onFacebookPostLike(){await this.props.onFacebookPostLike();}
get commentListComponent(){return StreamPostCommentListFacebook;}
get commentReplyComponent(){return StreamPostCommentsReplyFacebook;}
get facebookReactions(){const reactionsCount=JSON.parse(this.props.originalPost.facebook_reactions_count.raw_value||"{}");return formatFacebookReactions(reactionsCount);}}
return __exports;});;

/* /social_facebook/static/src/js/stream_post_comments_reply.js */
odoo.define('@social_facebook/js/stream_post_comments_reply',['@social/js/stream_post_comments_reply','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{StreamPostCommentsReply}=require('@social/js/stream_post_comments_reply');const{sprintf}=require('@web/core/utils/strings');const StreamPostCommentsReplyFacebook=__exports.StreamPostCommentsReplyFacebook=class StreamPostCommentsReplyFacebook extends StreamPostCommentsReply{get authorPictureSrc(){return sprintf('https://graph.facebook.com/v17.0/%s/picture?height=48&width=48',this.props.mediaSpecificProps.pageFacebookId);}
get addCommentEndpoint(){return'/social_facebook/comment';}}
return __exports;});;

/* /social_facebook/static/src/js/stream_post_kanban_record.js */
odoo.define('@social_facebook/js/stream_post_kanban_record',['@web/core/network/rpc','@web/core/l10n/translation','@social/js/stream_post_kanban_record','@social_facebook/js/stream_post_comments','@web/core/utils/timing','@web/core/utils/patch','@odoo/owl'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{_t}=require("@web/core/l10n/translation");const{StreamPostKanbanRecord}=require('@social/js/stream_post_kanban_record');const{StreamPostCommentsFacebook}=require("@social_facebook/js/stream_post_comments");const{debounce}=require("@web/core/utils/timing");const{patch}=require("@web/core/utils/patch");const{useEffect}=require("@odoo/owl");patch(StreamPostKanbanRecord.prototype,{setup(){super.setup(...arguments);useEffect((commentEl)=>{if(commentEl){const onFacebookCommentsClick=debounce(this._onFacebookCommentsClick.bind(this),300,true);commentEl.addEventListener('click',onFacebookCommentsClick);return()=>{commentEl.removeEventListener('click',onFacebookCommentsClick);};}},()=>[this.rootRef.el.querySelector('.o_social_facebook_comments')]);useEffect((likeEl)=>{if(likeEl){const onFacebookPostLike=this._onFacebookPostLike.bind(this);likeEl.addEventListener('click',onFacebookPostLike);return()=>{likeEl.removeEventListener('click',onFacebookPostLike);};}},()=>[this.rootRef.el.querySelector('.o_social_facebook_likes')]);},_onFacebookCommentsClick(ev){ev.stopPropagation();const postId=this.record.id.raw_value;rpc('/social_facebook/get_comments',{stream_post_id:postId,comments_count:this.commentsCount,}).then((result)=>{this.dialog.add(StreamPostCommentsFacebook,{title:_t('Facebook Comments'),accountId:this.record.account_id.raw_value,originalPost:this.record,commentsCount:this.commentsCount,postId:postId,comments:result.comments,summary:result.summary,nextRecordsToken:result.nextRecordsToken,onFacebookPostLike:this._onFacebookPostLike.bind(this),});});},async _onFacebookPostLike(){const userLikes=this.record.facebook_user_likes.raw_value;rpc("/social_facebook/like_post",{stream_post_id:this.record.id.raw_value,like:!userLikes,});await this._updateLikesCount("facebook_user_likes","facebook_likes_count");},_prepareLikeAdditionnalValues(likesCount,userLikes){const additionnalValues=super._prepareLikeAdditionnalValues(likesCount,userLikes);if(this.record.media_type.raw_value==="facebook"){const reactionsCount=JSON.parse(this.record.facebook_reactions_count.raw_value);reactionsCount["LIKE"]=userLikes?(reactionsCount["LIKE"]||0)+1:Math.max(0,(reactionsCount["LIKE"]||0)-1);additionnalValues.facebook_reactions_count=JSON.stringify(reactionsCount);}
return additionnalValues;},});return __exports;});;

/* /social_instagram/static/src/js/stream_post_comment.js */
odoo.define('@social_instagram/js/stream_post_comment',['@social/js/stream_post_comment','@social_instagram/js/stream_post_comments_reply','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{StreamPostComment}=require('@social/js/stream_post_comment');const{StreamPostCommentsReplyInstagram}=require("@social_instagram/js/stream_post_comments_reply");const{sprintf}=require('@web/core/utils/strings');const StreamPostCommentInstagram=__exports.StreamPostCommentInstagram=class StreamPostCommentInstagram extends StreamPostComment{get authorPictureSrc(){return sprintf('https://graph.facebook.com/v17.0/%s/picture',this.originalPost.instagram_facebook_author_id.raw_value);}
get link(){return sprintf('https://www.instagram.com/%s',encodeURI(this.comment.from.name));}
get authorLink(){return this.originalPost.post_link.raw_value;}
get isAuthor(){return this.comment.from.id===this.props.mediaSpecificProps.instagramAccountId;}
get commentReplyComponent(){return StreamPostCommentsReplyInstagram;}
get deleteCommentEndpoint(){return'/social_instagram/delete_comment';}
get likesClass(){return'fa-heart';}
get isLikable(){return false;}
get isDeletable(){return true;}
get isEditable(){return false;}}
return __exports;});;

/* /social_instagram/static/src/js/stream_post_comment_list.js */
odoo.define('@social_instagram/js/stream_post_comment_list',['@social/js/stream_post_comment_list','@social_instagram/js/stream_post_comment'],function(require){'use strict';let __exports={};const{StreamPostCommentList}=require('@social/js/stream_post_comment_list');const{StreamPostCommentInstagram}=require("@social_instagram/js/stream_post_comment");const StreamPostCommentListInstagram=__exports.StreamPostCommentListInstagram=class StreamPostCommentListInstagram extends StreamPostCommentList{get commentComponent(){return StreamPostCommentInstagram;}}
return __exports;});;

/* /social_instagram/static/src/js/stream_post_comments.js */
odoo.define('@social_instagram/js/stream_post_comments',['@web/core/network/rpc','@social/js/stream_post_comments','@social_instagram/js/stream_post_comment_list','@social_instagram/js/stream_post_comments_reply','@odoo/owl'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{StreamPostComments}=require('@social/js/stream_post_comments');const{StreamPostCommentListInstagram}=require("@social_instagram/js/stream_post_comment_list");const{StreamPostCommentsReplyInstagram}=require("@social_instagram/js/stream_post_comments_reply");const{onWillStart}=require("@odoo/owl");const StreamPostCommentsInstagram=__exports.StreamPostCommentsInstagram=class StreamPostCommentsInstagram extends StreamPostComments{setup(){super.setup();this.commentsCount=this.props.commentsCount;this.totalLoadedComments=this.props.comments.length;this.state.showLoadMoreComments=!!this.props.nextRecordsToken;this.nextRecordsToken=this.props.nextRecordsToken;onWillStart(async()=>{const instagramInfo=await this.orm.read('social.account',[this.props.accountId],['name','instagram_account_id']);this.mediaSpecificProps=Object.assign(this.mediaSpecificProps,{accountId:this.props.accountId,accountName:instagramInfo[0].name,instagramAccountId:instagramInfo[0].instagram_account_id,});});}
async loadMoreComments(){const nextComments=await rpc('/social_instagram/get_comments',{stream_post_id:this.originalPost.id.raw_value,next_records_token:this.nextRecordsToken,comments_count:this.commentsCount});this.state.showLoadMoreComments=!!nextComments.nextRecordsToken;this.comments.push(...nextComments.comments);this.nextRecordsToken=nextComments.nextRecordsToken;}
get commentListComponent(){return StreamPostCommentListInstagram;}
get commentReplyComponent(){return StreamPostCommentsReplyInstagram;}}
return __exports;});;

/* /social_instagram/static/src/js/stream_post_comments_reply.js */
odoo.define('@social_instagram/js/stream_post_comments_reply',['@social/js/stream_post_comments_reply'],function(require){'use strict';let __exports={};const{StreamPostCommentsReply}=require('@social/js/stream_post_comments_reply');const StreamPostCommentsReplyInstagram=__exports.StreamPostCommentsReplyInstagram=class StreamPostCommentsReplyInstagram extends StreamPostCommentsReply{get authorPictureSrc(){return'/social_instagram/static/src/img/instagram_user.png';}
get canAddImage(){return false;}
get addCommentEndpoint(){return'/social_instagram/comment';}}
return __exports;});;

/* /social_instagram/static/src/js/stream_post_kanban_dashboard.js */
odoo.define('@social_instagram/js/stream_post_kanban_dashboard',['@social/js/stream_post_kanban_dashboard','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{StreamPostDashboard}=require('@social/js/stream_post_kanban_dashboard');const{patch}=require("@web/core/utils/patch");patch(StreamPostDashboard.prototype,{_hasStories(account){return account.media_type!=='instagram'&&super._hasStories(...arguments);},});return __exports;});;

/* /social_instagram/static/src/js/stream_post_kanban_record.js */
odoo.define('@social_instagram/js/stream_post_kanban_record',['@web/core/network/rpc','@web/core/l10n/translation','@social/js/stream_post_kanban_record','@social_instagram/js/stream_post_comments','@web/core/utils/timing','@web/core/utils/patch','@odoo/owl'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{_t}=require("@web/core/l10n/translation");const{StreamPostKanbanRecord}=require('@social/js/stream_post_kanban_record');const{StreamPostCommentsInstagram}=require("@social_instagram/js/stream_post_comments");const{debounce}=require("@web/core/utils/timing");const{patch}=require("@web/core/utils/patch");const{useEffect}=require("@odoo/owl");patch(StreamPostKanbanRecord.prototype,{setup(){super.setup(...arguments);useEffect((commentEl)=>{if(commentEl){const onInstagramCommentsClick=debounce(this._onInstagramCommentsClick.bind(this),300,true);commentEl.addEventListener('click',onInstagramCommentsClick);return()=>{commentEl.removeEventListener('click',onInstagramCommentsClick);};}},()=>[this.rootRef.el.querySelector('.o_social_instagram_comments')]);},_onInstagramCommentsClick(ev){ev.stopPropagation();const postId=this.record.id.raw_value;rpc('/social_instagram/get_comments',{stream_post_id:postId,comments_count:this.commentsCount,}).then((result)=>{this.dialog.add(StreamPostCommentsInstagram,{title:_t('Instagram Comments'),commentCount:this.commentCount,originalPost:this.record,accountId:this.record.account_id.raw_value,postId:postId,comments:result.comments,nextRecordsToken:result.nextRecordsToken,});});},});return __exports;});;

/* /social_linkedin/static/src/js/stream_post_comment.js */
odoo.define('@social_linkedin/js/stream_post_comment',['@social/js/stream_post_comment','@social_linkedin/js/stream_post_comments_reply','@web/core/network/rpc','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{StreamPostComment}=require('@social/js/stream_post_comment');const{StreamPostCommentsReplyLinkedin}=require("@social_linkedin/js/stream_post_comments_reply");const{rpc}=require("@web/core/network/rpc");const{sprintf}=require('@web/core/utils/strings');const StreamPostCommentLinkedin=__exports.StreamPostCommentLinkedin=class StreamPostCommentLinkedin extends StreamPostComment{async _onReplyComment(){if(!this.action.showReplyComment){await this._onLoadReplies();}
await super._onReplyComment();}
async _onLoadReplies(){const innerComments=await rpc('/social_linkedin/get_comments',{stream_post_id:this.originalPost.id.raw_value,comment_urn:this.comment.id,comments_count:this.commentsCount});this.comment.comments.data=innerComments.comments;super._onLoadReplies();}
get authorPictureSrc(){return this.comment.from.picture;}
get link(){let activityUrn=this.comment.id.split('(')[1].split(',')[0];return sprintf('https://www.linkedin.com/feed/update/%s?commentUrn=%s',encodeURIComponent(activityUrn),encodeURIComponent(this.comment.id));}
get authorLink(){if(this.comment.from.isOrganization){return`https://www.linkedin.com/company/${encodeURIComponent(this.comment.from.vanityName)}`;}
return`https://www.linkedin.com/in/${encodeURIComponent(this.comment.from.vanityName)}`;}
get isAuthor(){return this.comment.from.id===this.props.mediaSpecificProps.currentUserUrn;}
get commentReplyComponent(){return StreamPostCommentsReplyLinkedin;}
get deleteCommentEndpoint(){return'/social_linkedin/delete_comment';}
get isLikable(){return true;}
get isEditable(){return true;}
get commentCreatedTime(){const createdTime=super.commentCreatedTime;return!createdTime.invalid?createdTime:luxon.DateTime.fromMillis(this.comment.created_time);}}
return __exports;});;

/* /social_linkedin/static/src/js/stream_post_comment_list.js */
odoo.define('@social_linkedin/js/stream_post_comment_list',['@social/js/stream_post_comment_list','@social_linkedin/js/stream_post_comment','@web/core/network/rpc'],function(require){'use strict';let __exports={};const{StreamPostCommentList}=require('@social/js/stream_post_comment_list');const{StreamPostCommentLinkedin}=require("@social_linkedin/js/stream_post_comment");const{rpc}=require("@web/core/network/rpc");const StreamPostCommentListLinkedin=__exports.StreamPostCommentListLinkedin=class StreamPostCommentListLinkedin extends StreamPostCommentList{async toggleUserLikes(comment){await rpc("/social_linkedin/like_comment",{stream_post_id:this.originalPost.id.raw_value,comment_id:comment.id,like:!comment.user_likes,});this._updateLikes(comment);}
get commentComponent(){return StreamPostCommentLinkedin;}}
return __exports;});;

/* /social_linkedin/static/src/js/stream_post_comments.js */
odoo.define('@social_linkedin/js/stream_post_comments',['@social/js/stream_post_comments','@social_linkedin/js/stream_post_comment_list','@social_linkedin/js/stream_post_comments_reply','@social_linkedin/js/social_post_formatter_mixin','@odoo/owl','@web/core/network/rpc','@web/core/user'],function(require){'use strict';let __exports={};const{StreamPostComments}=require('@social/js/stream_post_comments');const{StreamPostCommentListLinkedin}=require("@social_linkedin/js/stream_post_comment_list");const{StreamPostCommentsReplyLinkedin}=require("@social_linkedin/js/stream_post_comments_reply");const{LINKEDIN_HASHTAG_REGEX}=require("@social_linkedin/js/social_post_formatter_mixin");const{onWillStart,useState}=require("@odoo/owl");const{rpc}=require("@web/core/network/rpc");const{user}=require("@web/core/user");const StreamPostCommentsLinkedin=__exports.StreamPostCommentsLinkedin=class StreamPostCommentsLinkedin extends StreamPostComments{setup(){super.setup();this.commentsCount=this.props.commentsCount;this.totalLoadedComments=this.props.comments.length;this.state.showLoadMoreComments=this.totalLoadedComments<this.props.summary.total_count;this.offset=this.props.offset;this.mediaSpecificProps=Object.assign(this.mediaSpecificProps,{accountId:this.props.accountId,accountName:'',postAuthorImage:this.props.postAuthorImage,currentUserUrn:this.props.currentUserUrn,});this.aclState=useState({isDeletable:false,isEditable:false,});onWillStart(async()=>{[this.aclState.isDeletable,this.aclState.isEditable]=await Promise.all([user.checkAccessRight("social.stream.post","unlink"),user.checkAccessRight("social.stream.post","write"),]);});}
async loadMoreComments(){const nextComments=await rpc('/social_linkedin/get_comments',{stream_post_id:this.originalPost.id.raw_value,offset:this.offset,comments_count:this.commentsCount});this.totalLoadedComments+=nextComments.comments.length;if(this.totalLoadedComments>=this.props.summary.total_count){this.state.showLoadMoreComments=false;}
this.comments.push(...nextComments.comments);this.offset=nextComments.offset;}
_formatStreamPostForEdition(message){return message.replace(LINKEDIN_HASHTAG_REGEX,"#$1");}
get commentListComponent(){return StreamPostCommentListLinkedin;}
get commentReplyComponent(){return StreamPostCommentsReplyLinkedin;}
get isDeletable(){return this.aclState.isDeletable;}
get isEditable(){return this.aclState.isEditable;}}
return __exports;});;

/* /social_linkedin/static/src/js/stream_post_comments_reply.js */
odoo.define('@social_linkedin/js/stream_post_comments_reply',['@social/js/stream_post_comments_reply'],function(require){'use strict';let __exports={};const{StreamPostCommentsReply}=require('@social/js/stream_post_comments_reply');const StreamPostCommentsReplyLinkedin=__exports.StreamPostCommentsReplyLinkedin=class StreamPostCommentsReplyLinkedin extends StreamPostCommentsReply{get authorPictureSrc(){return this.props.mediaSpecificProps.postAuthorImage;}
get canAddImage(){return true;}
get addCommentEndpoint(){return'/social_linkedin/comment';}
get allowImageOnlyComment(){return true;}}
return __exports;});;

/* /social_linkedin/static/src/js/stream_post_kanban_record.js */
odoo.define('@social_linkedin/js/stream_post_kanban_record',['@web/core/l10n/translation','@social/js/stream_post_kanban_record','@social_linkedin/js/stream_post_comments','@web/core/utils/timing','@web/core/network/rpc','@web/core/utils/patch','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{StreamPostKanbanRecord}=require('@social/js/stream_post_kanban_record');const{StreamPostCommentsLinkedin}=require("@social_linkedin/js/stream_post_comments");const{debounce}=require("@web/core/utils/timing");const{rpc}=require("@web/core/network/rpc");const{patch}=require("@web/core/utils/patch");const{useEffect}=require("@odoo/owl");patch(StreamPostKanbanRecord.prototype,{setup(){super.setup(...arguments);useEffect((commentEl)=>{if(commentEl){const onLinkedInCommentsClick=debounce(this._onLinkedInCommentsClick.bind(this),300,true);commentEl.addEventListener('click',onLinkedInCommentsClick);return()=>{commentEl.removeEventListener('click',onLinkedInCommentsClick);};}},()=>[this.rootRef.el.querySelector('.o_social_linkedin_comments')]);},_onLinkedInCommentsClick(ev){ev.stopPropagation();const postId=this.record.id.raw_value;rpc('/social_linkedin/get_comments',{stream_post_id:postId,comments_count:this.commentsCount}).then((result)=>{const closeDialog=this.dialog.add(StreamPostCommentsLinkedin,{title:_t('LinkedIn Comments'),commentsCount:this.commentsCount,accountId:this.record.account_id.raw_value,originalPost:this.record,postId:postId,comments:result.comments,summary:result.summary,postAuthorImage:result.postAuthorImage,currentUserUrn:result.currentUserUrn,offset:result.offset,onPostUpdate:(newMessage)=>this.props.record.update({message:newMessage}),onPostDeleted:async()=>{await this.props.record.model.root._removeRecords([this.props.record.id]);closeDialog();},});});},});return __exports;});;

/* /social_twitter/static/src/js/stream_post_comment.js */
odoo.define('@social_twitter/js/stream_post_comment',['@web/core/l10n/translation','@social/js/stream_post_comment','@social_twitter/js/stream_post_comments_reply','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{StreamPostComment}=require('@social/js/stream_post_comment');const{StreamPostCommentsReplyTwitter}=require("@social_twitter/js/stream_post_comments_reply");const{sprintf}=require('@web/core/utils/strings');const StreamPostCommentTwitter=__exports.StreamPostCommentTwitter=class StreamPostCommentTwitter extends StreamPostComment{get authorPictureSrc(){return this.comment.from.profile_image_url}
get link(){return sprintf('https://www.twitter.com/%s/statuses/%s',encodeURIComponent(this.comment.from.id),encodeURIComponent(this.comment.id));}
get authorLink(){return sprintf('https://twitter.com/intent/user?user_id=%s',encodeURIComponent(this.comment.from.id));}
get isAuthor(){return this.comment.from.id===this.props.mediaSpecificProps.twitterUserId;}
get commentReplyComponent(){return StreamPostCommentsReplyTwitter;}
get deleteCommentEndpoint(){return'/social_twitter/delete_tweet';}
get isEditable(){return false;}
get likesClass(){return'fa-heart';}
get commentName(){return _t('Tweet');}
get commentCreatedTime(){const createdTime=super.commentCreatedTime;return!createdTime.invalid?createdTime:luxon.DateTime.fromFormat(this.comment.created_time,{format:'EEE MMM d HH:mm:ss ZZZ yyyy'});}}
return __exports;});;

/* /social_twitter/static/src/js/stream_post_comment_list.js */
odoo.define('@social_twitter/js/stream_post_comment_list',['@social/js/stream_post_comment_list','@social_twitter/js/stream_post_comment','@web/core/network/rpc','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{StreamPostCommentList}=require('@social/js/stream_post_comment_list');const{StreamPostCommentTwitter}=require("@social_twitter/js/stream_post_comment");const{rpc}=require("@web/core/network/rpc");const{sprintf}=require('@web/core/utils/strings');const StreamPostCommentListTwitter=__exports.StreamPostCommentListTwitter=class StreamPostCommentListTwitter extends StreamPostCommentList{toggleUserLikes(comment){rpc(sprintf('/social_twitter/%s/like_tweet',this.originalPost.stream_id.raw_value),{tweet_id:comment.id,like:!comment.user_likes,});this._updateLikes(comment);}
get commentComponent(){return StreamPostCommentTwitter;}}
return __exports;});;

/* /social_twitter/static/src/js/stream_post_comments.js */
odoo.define('@social_twitter/js/stream_post_comments',['@web/core/l10n/translation','@social/js/stream_post_comments','@social_twitter/js/stream_post_comment_list','@social_twitter/js/stream_post_comments_reply','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{StreamPostComments}=require('@social/js/stream_post_comments');const{StreamPostCommentListTwitter}=require("@social_twitter/js/stream_post_comment_list");const{StreamPostCommentsReplyTwitter}=require("@social_twitter/js/stream_post_comments_reply");const{onWillStart}=require("@odoo/owl");const MAX_ALLOWED_REPLIES=3;const StreamPostCommentsTwitter=__exports.StreamPostCommentsTwitter=class StreamPostCommentsTwitter extends StreamPostComments{setup(){super.setup();this.page=1;this.commentsCount=this.props.commentsCount;this.allComments=this.props.allComments;this.state.showLoadMoreComments=this.allComments.length>this.commentsCount;onWillStart(async()=>{const twitterUserInfo=await this.orm.read('social.account',[this.props.accountId],['name','twitter_user_id','social_account_handle']);this.mediaSpecificProps=Object.assign(this.mediaSpecificProps,{accountId:this.props.accountId,accountName:twitterUserInfo[0].name,twitterUserId:twitterUserInfo[0].twitter_user_id,twitterUserScreenName:twitterUserInfo[0].social_account_handle,});});}
async loadMoreComments(){this.page+=1;var start=(this.page-1)*this.commentsCount;var end=start+this.commentsCount;this.comments.push(...this.allComments.slice(start,end));if(end>=this.allComments.length){this.state.showLoadMoreComments=false;}}
onAddComment(comment){super.onAddComment(...arguments);this.allComments.push(comment);}
preventAddComment(textarea,replyToCommentId){if(!this.props.isReplyLimited){return false;}
const allCommentsFlatten=this.allComments.reduce((result,currentComment)=>{if(currentComment.comments){const subComments=currentComment.comments.data;result.push(currentComment,...subComments);}else{result.push(currentComment);}
return result;},[]);const tweetId=String(replyToCommentId?replyToCommentId:this.originalPost.twitter_tweet_id.raw_value);const existingAnswers=allCommentsFlatten.filter((comment)=>comment.from&&comment.from.screen_name===this.mediaSpecificProps.twitterUserScreenName&&String(comment.in_reply_to_tweet_id)===tweetId);if(existingAnswers.length>=MAX_ALLOWED_REPLIES){textarea.disabled=true;const textAreaMessage=textarea.closest('.o_social_write_reply').querySelector('.o_social_textarea_message');textAreaMessage.classList.add('text-danger');textAreaMessage.textContent=_t("Easy, tiger! No spamming allowed. Let's stick to three replies per Tweet.");return true;}
return false;}
get commentListComponent(){return StreamPostCommentListTwitter;}
get commentReplyComponent(){return StreamPostCommentsReplyTwitter;}}
return __exports;});;

/* /social_twitter/static/src/js/stream_post_comments_reply.js */
odoo.define('@social_twitter/js/stream_post_comments_reply',['@social/js/stream_post_comments_reply','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{StreamPostCommentsReply}=require('@social/js/stream_post_comments_reply');const{sprintf}=require('@web/core/utils/strings');const StreamPostCommentsReplyTwitter=__exports.StreamPostCommentsReplyTwitter=class StreamPostCommentsReplyTwitter extends StreamPostCommentsReply{get authorPictureSrc(){return sprintf('/web/image/social.account/%s/image/48x48',this.props.mediaSpecificProps.accountId);}
get addCommentEndpoint(){return sprintf('/social_twitter/%s/comment',this.originalPost.stream_id.raw_value);}}
return __exports;});;

/* /social_twitter/static/src/js/stream_post_comments_reply_quote.js */
odoo.define('@social_twitter/js/stream_post_comments_reply_quote',['@social_twitter/js/stream_post_comments_reply'],function(require){'use strict';let __exports={};const{StreamPostCommentsReplyTwitter}=require("@social_twitter/js/stream_post_comments_reply");const StreamPostCommentsReplyTwitterQuote=__exports.StreamPostCommentsReplyTwitterQuote=class StreamPostCommentsReplyTwitterQuote extends StreamPostCommentsReplyTwitter{static template="social_twitter.StreamPostCommentsReplyQuote";}
return __exports;});;

/* /social_twitter/static/src/js/stream_post_kanban_record.js */
odoo.define('@social_twitter/js/stream_post_kanban_record',['@web/core/l10n/translation','@social/js/stream_post_kanban_record','@social_twitter/js/stream_post_comments','@social_twitter/js/stream_post_twitter_quote','@web/core/utils/timing','@web/core/network/rpc','@web/core/utils/patch','@web/core/utils/strings','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{StreamPostKanbanRecord}=require('@social/js/stream_post_kanban_record');const{StreamPostCommentsTwitter}=require("@social_twitter/js/stream_post_comments");const{StreamPostTwitterQuote}=require("@social_twitter/js/stream_post_twitter_quote");const{debounce}=require("@web/core/utils/timing");const{rpc}=require("@web/core/network/rpc");const{patch}=require("@web/core/utils/patch");const{sprintf}=require('@web/core/utils/strings');const{useService}=require('@web/core/utils/hooks');const{useEffect}=require("@odoo/owl");patch(StreamPostKanbanRecord.prototype,{setup(){super.setup(...arguments);this.notification=useService('notification');useEffect((commentEl)=>{if(commentEl){const onTwitterCommentsClick=debounce(this._onTwitterCommentsClick.bind(this),300,true);commentEl.addEventListener('click',onTwitterCommentsClick);return()=>{commentEl.removeEventListener('click',onTwitterCommentsClick);};}},()=>[this.rootRef.el.querySelector('.o_social_twitter_comments')]);useEffect((likeEl)=>{if(likeEl){const onTwitterTweetLike=this._onTwitterTweetLike.bind(this);likeEl.addEventListener('click',onTwitterTweetLike);return()=>{likeEl.removeEventListener('click',onTwitterTweetLike);};}},()=>[this.rootRef.el.querySelector('.o_social_twitter_likes')]);useEffect((retweetEl)=>{if(retweetEl){const onTwitterRetweet=this._onTwitterRetweet.bind(this);retweetEl.addEventListener('click',onTwitterRetweet);return()=>{retweetEl.removeEventListener('click',onTwitterRetweet);};}},()=>[this.rootRef.el.querySelector('.o_social_twitter_retweet')]);useEffect((quoteEl)=>{if(quoteEl){const onTwitterQuote=this._onTwitterQuote.bind(this);quoteEl.addEventListener('click',onTwitterQuote);return()=>{quoteEl.removeEventListener('click',onTwitterQuote);};}},()=>[this.rootRef.el.querySelector('.o_social_twitter_quote')]);},_onTwitterCommentsClick(ev){ev.stopPropagation();const postId=this.record.id.raw_value;const modalInfo={title:_t("Twitter Comments"),accountId:this.record.account_id.raw_value,originalPost:this.record,postId:postId,streamId:this.record.stream_id.raw_value,};rpc("/social_twitter/get_comments",{stream_post_id:postId}).then((result)=>{this.dialog.add(StreamPostCommentsTwitter,{...modalInfo,commentsCount:this.commentsCount,allComments:result.comments,comments:result.comments.slice(0,this.commentsCount),isReplyLimited:result.is_reply_limited,});}).catch((error)=>{this.dialog.add(StreamPostCommentsTwitter,{...modalInfo,commentsCount:0,allComments:[],comments:[],isReplyLimited:true,error:error.data.message,});});},async _onTwitterTweetLike(){const userLikes=this.record.twitter_user_likes.raw_value;rpc(sprintf('/social_twitter/%s/like_tweet',this.record.stream_id.raw_value),{tweet_id:this.record.twitter_tweet_id.raw_value,like:!userLikes});await this._updateLikesCount("twitter_user_likes","twitter_likes_count");},_onTwitterRetweet(ev){rpc(sprintf('/social_twitter/%s/%s',this.record.stream_id.raw_value,this.record.twitter_can_retweet.raw_value?'retweet':'unretweet'),{tweet_id:this.record.twitter_tweet_id.raw_value,stream_id:this.record.stream_id.raw_value,}).then((result)=>{result=JSON.parse(result);if(result===true){const retweetCount=this.record.twitter_can_retweet.raw_value?this.record.twitter_retweet_count.raw_value+1:this.record.twitter_retweet_count.raw_value-1;this.props.record.update({'twitter_can_retweet':!this.record.twitter_can_retweet.raw_value,'twitter_retweet_count':retweetCount,});}else if(result.error){this.notification.add(result.error,{title:_t('Error'),type:'danger',});}});},_onTwitterQuote(){this.dialog.add(StreamPostTwitterQuote,{title:_t('Quote a Tweet'),mediaSpecificProps:{accountId:this.record.account_id.raw_value,accountName:this.record.author_name.value,},originalPost:this.record,refreshStats:()=>this.env.refreshStats(),});},});return __exports;});;

/* /social_twitter/static/src/js/stream_post_twitter_quote.js */
odoo.define('@social_twitter/js/stream_post_twitter_quote',['@web/core/l10n/translation','@social_twitter/js/stream_post_comments_reply_quote','@social/js/social_post_formatter_mixin','@web/core/dialog/dialog','@web/core/utils/strings','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{StreamPostCommentsReplyTwitterQuote}=require("@social_twitter/js/stream_post_comments_reply_quote");const{SocialPostFormatterMixin}=require('@social/js/social_post_formatter_mixin');const{Dialog}=require('@web/core/dialog/dialog');const{sprintf}=require('@web/core/utils/strings');const{useService}=require('@web/core/utils/hooks');const{Component,markup,useState}=require("@odoo/owl");const StreamPostTwitterQuote=__exports.StreamPostTwitterQuote=class StreamPostTwitterQuote extends SocialPostFormatterMixin(Component){static template="social_twitter.TwitterQuoteDialog";static components={Dialog,StreamPostCommentsReplyTwitterQuote};setup(){super.setup();this.notification=useService('notification');this.state=useState({isEditMode:false,});}
_confirmQuoteTweet(event){let formData=new FormData(event.currentTarget.closest('.modal-content').querySelector('form'));const xhr=new window.XMLHttpRequest();xhr.open('POST',sprintf('/social_twitter/%s/quote',this.originalPost.stream_id.raw_value));formData.append('csrf_token',odoo.csrf_token);formData.append('tweet_id',this.originalPost.twitter_tweet_id.raw_value);formData.append('stream_id',this.originalPost.stream_id.raw_value);xhr.send(formData);xhr.onload=()=>{const result=JSON.parse(xhr.response);if(result===true){this.props.refreshStats();}else if(result.error){this.notification.add(result.error,{type:'danger'});}};xhr.onerror=()=>{this.notification.add(_t('Error while sending the data to the server.'),{type:'warning'});};xhr.onloadend=()=>{this.props.close();};}
_formatCommentStreamPost(message){return markup(this._formatPost(message));}
get originalPost(){return this.props.originalPost;}
get JSON(){return JSON;}}
return __exports;});;

/* /social_twitter/static/src/js/twitter_users_autocomplete.js */
odoo.define('@social_twitter/js/twitter_users_autocomplete',['@web/core/autocomplete/autocomplete','@web/views/fields/char/char_field','@web/core/registry','@web/core/utils/hooks'],function(require){'use strict';let __exports={};const{AutoComplete}=require("@web/core/autocomplete/autocomplete");const{CharField,charField}=require("@web/views/fields/char/char_field");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");class TwitterUsersAutocomplete extends AutoComplete{static timeout=500;get autoCompleteRootClass(){return`${super.autoCompleteRootClass} o_social_twitter_users_autocomplete`;}}
const TwitterUsersAutocompleteField=__exports.TwitterUsersAutocompleteField=class TwitterUsersAutocompleteField extends CharField{static template="social_twitter.TwitterUsersAutocompleteField";static components={...CharField.components,AutoComplete:TwitterUsersAutocomplete}
setup(){super.setup();this.orm=useService("orm");this.value="";}
async selectTwitterUser(selectedSubjection){const twitterUser=Object.getPrototypeOf(selectedSubjection);this.value=twitterUser.name;const twitterAccountId=await this.orm.call('social.twitter.account','create',[{name:twitterUser.name,twitter_id:twitterUser.id}]);await this.props.record.update({twitter_followed_account_id:[twitterAccountId,twitterUser.name]});}
get sources(){return[{optionTemplate:"social_twitter.users_autocomplete_element",options:async(request)=>{if(request.length<2){return[];}
const accountId=this.props.record.data.account_id[0];const userInfo=await this.orm.call('social.account','twitter_get_user_by_username',[[accountId],request]);return userInfo?[userInfo]:[];}}];}}
const twitterUsersAutocompleteField=__exports.twitterUsersAutocompleteField={...charField,component:TwitterUsersAutocompleteField,};registry.category("fields").add("twitter_users_autocomplete",twitterUsersAutocompleteField);return __exports;});;

/* /social_youtube/static/src/js/social_youtube_upload_field.js */
odoo.define('@social_youtube/js/social_youtube_upload_field',['@web/core/registry','@web/views/fields/char/char_field','@web/core/confirmation_dialog/confirmation_dialog','@web/core/utils/hooks','@web/core/utils/binary','@odoo/owl','@web/core/l10n/translation'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{CharField,charField}=require('@web/views/fields/char/char_field');const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{useService}=require("@web/core/utils/hooks");const{humanSize}=require("@web/core/utils/binary");const{useRef,useState}=require("@odoo/owl");const{_t}=require("@web/core/l10n/translation");const YoutubeUploadField=__exports.YoutubeUploadField=class YoutubeUploadField extends CharField{static template="social_youtube.YoutubeUploadField";setup(){super.setup();this.fileInputRef=useRef('fileInput');this.state=useState({uploading:false,showSocialYoutubeBar:true,socialYoutubeText:_t("Uploading... 0%"),uploadProgress:0,uploadErrorMessage:false,});this.notification=useService("notification");this.dialogService=useService("dialog");this.useFileAPI=!!window.FileReader;this.maxUploadSize=128*1024*1024*1024;}
_awaitPostProcessing(uploadedVideoId){return new Promise((resolve,reject)=>{this.uploadedVideoId=uploadedVideoId;this.videoProcessedResolve=resolve;this.processingInfoInterval=setInterval(this._updateProcessingInfo.bind(this),1500);});}
_listenUploadProgress(){const xhr=new window.XMLHttpRequest();xhr.upload.addEventListener("progress",(e)=>{if(e.lengthComputable){const roundedProgress=Math.round((e.loaded/e.total)*100);this.state.uploadProgress=roundedProgress;this.state.socialYoutubeText=_t('Uploading... %s%',this.state.uploadProgress);}},false);return xhr;}
async _openUploadSession(fileSize,fileType){return new Promise((resolve,reject)=>{const data=this.props.record.data;const title=data.youtube_title;const description=data.youtube_description;$.ajax({url:'https://www.googleapis.com/upload/youtube/v3/videos?uploadType=resumable&part=status%2Csnippet',type:'POST',beforeSend:(request)=>{request.setRequestHeader("Authorization","Bearer "+this.props.record.data.youtube_access_token);request.setRequestHeader('Content-Type','application/json');request.setRequestHeader("X-Upload-Content-Length",fileSize);request.setRequestHeader("x-Upload-Content-Type",fileType);},data:JSON.stringify({status:{privacyStatus:"private"},snippet:{title:title,description:description},}),dataType:'text',processData:false,cache:false,success:(data,textStatus,request)=>{resolve(request.getResponseHeader('location'));},error:(e)=>{if(e.responseText){const errorReason=JSON.parse(e.responseText).error?.errors[0]?.reason;console.error(errorReason);}
this._uploadFailed();reject();},});});}
_updateProcessingInfo(){$.ajax({url:'https://www.googleapis.com/youtube/v3/videos',type:'GET',beforeSend:(request)=>{request.setRequestHeader("Authorization","Bearer "+this.props.record.data.youtube_access_token);},data:{part:'processingDetails',id:this.uploadedVideoId},success:(response)=>{if('items'in response&&response.items.length===1&&'processingDetails'in response.items[0]){var processingDetails=response.items[0].processingDetails;this.state.socialYoutubeText=_t('Processing...');if(processingDetails.processingStatus==='succeeded'){clearInterval(this.processingInfoInterval);this.videoProcessedResolve();}}else{this._uploadFailed();this._resetYoutubeVideoValues();}},});}
_uploadFailed(){this.notification.add(_t('Upload failed. Please try again.'),{type:'warning',});this.fileInputRef.el.value='';}
async _uploadFile(location,file){return new Promise((resolve,reject)=>{$.ajax({url:location,type:'PUT',beforeSend:(request)=>{request.setRequestHeader("Authorization","Bearer "+this.props.record.data.youtube_access_token);request.setRequestHeader("Content-Type",'application/octet-stream');},success:(response)=>{resolve({videoId:response.id,categoryId:response.snippet.categoryId})},error:()=>{this._uploadFailed();reject();},data:file,cache:false,contentType:false,processData:false,xhr:this._listenUploadProgress.bind(this)});});}
_onClearClick(){this.dialogService.add(ConfirmationDialog,{confirmLabel:_t("Yes, delete it"),cancelLabel:_t("No"),title:_t("Confirmation"),body:_t("Do you also want to remove the video from your YouTube account?"),confirm:()=>{$.ajax({url:'https://www.googleapis.com/youtube/v3/videos',type:'DELETE',beforeSend:(request)=>{request.setRequestHeader("Authorization","Bearer "+this.props.record.data.youtube_access_token);},data:{id:this.props.record.data.youtube_video_id},});this.uploadedVideoId=null;this._resetYoutubeVideoValues();},cancel:()=>{this._resetYoutubeVideoValues();},});}
_resetYoutubeVideoValues(){this.props.record.update({youtube_video:false,youtube_video_id:false,youtube_video_category_id:false,});}
async _onFileChanged(e){const fileNodes=e.target;const hasReadableFile=this.useFileAPI&&fileNodes.files.length!==0;const accessToken=this.props.record.data.youtube_access_token;if(!accessToken||!hasReadableFile){return;}
const file=fileNodes.files[0];if(file.size>this.maxUploadSize){const message=_t("The selected video exceeds the maximum allowed size of %s.",humanSize(this.maxUploadSize));this.notification.add(message,{title:_t("Video Upload"),type:'danger',});return false;}
this.state.uploading=true;const sessionLocation=await this._openUploadSession(file.size,file.type);const{videoId,categoryId}=await this._uploadFile(sessionLocation,file);await this._awaitPostProcessing(videoId);const fileName=this.fileInputRef.el.value.match(/([^\\.]+)\.\w+$/)[0];this.state.uploading=false;await this.props.record.update({[this.props.name]:fileName,youtube_video_id:videoId,youtube_video_category_id:categoryId,});}
_onUploadClick(){const title=this.props.record.data.youtube_title;const description=this.props.record.data.youtube_description;let message;if(!title){message=_t("You need to give your video a title.");}else if(!description){message=_t("You need to give your video a description.");}else if(title.includes("<")||title.includes(">")||description.includes("<")||description.includes(">")){message=_t("You cannot use '>' or '<' in both title and description.");}else if([...title].length>100){message=_t("Your title cannot exceed 100 characters.");}else if([...description].length>5000){message=_t("Your description cannot exceed 5000 characters.");}else{message=false;}
if(message){this.state.uploadErrorMessage=message;return;}
this.state.uploadErrorMessage=false;this.fileInputRef.el.click();}}
const youtubeUploadField=__exports.youtubeUploadField={...charField,component:YoutubeUploadField,};registry.category("fields").add("youtube_upload",youtubeUploadField);return __exports;});;

/* /social_youtube/static/src/js/stream_post_comment.js */
odoo.define('@social_youtube/js/stream_post_comment',['@social/js/stream_post_comment','@social_youtube/js/stream_post_comments_reply'],function(require){'use strict';let __exports={};const{StreamPostComment}=require('@social/js/stream_post_comment');const{StreamPostCommentsReplyYoutube}=require("@social_youtube/js/stream_post_comments_reply");const StreamPostCommentYoutube=__exports.StreamPostCommentYoutube=class StreamPostCommentYoutube extends StreamPostComment{get authorPictureSrc(){return this.comment.from.author_image_url;}
get link(){return`https://www.youtube.com/watch?v=${encodeURIComponent(this.originalPost.youtube_video_id.raw_value)}&lc=${encodeURIComponent(this.comment.id)}&feature=em-comments`}
get authorLink(){return this.comment.from?this.comment.from.author_channel_url:null;}
get isAuthor(){return this.comment.from.id===this.props.mediaSpecificProps.youtubeChannelId;}
get commentReplyComponent(){return StreamPostCommentsReplyYoutube;}
get deleteCommentEndpoint(){return'/social_youtube/delete_comment';}
get isLikable(){return false;}
get isDeletable(){return true;}}
return __exports;});;

/* /social_youtube/static/src/js/stream_post_comment_list.js */
odoo.define('@social_youtube/js/stream_post_comment_list',['@social/js/stream_post_comment_list','@social_youtube/js/stream_post_comment'],function(require){'use strict';let __exports={};const{StreamPostCommentList}=require('@social/js/stream_post_comment_list');const{StreamPostCommentYoutube}=require("@social_youtube/js/stream_post_comment");const StreamPostCommentListYoutube=__exports.StreamPostCommentListYoutube=class StreamPostCommentListYoutube extends StreamPostCommentList{get commentComponent(){return StreamPostCommentYoutube;}}
return __exports;});;

/* /social_youtube/static/src/js/stream_post_comments.js */
odoo.define('@social_youtube/js/stream_post_comments',['@social/js/stream_post_comments','@social_youtube/js/stream_post_comment_list','@social_youtube/js/stream_post_comments_reply','@web/core/network/rpc','@odoo/owl'],function(require){'use strict';let __exports={};const{StreamPostComments}=require('@social/js/stream_post_comments');const{StreamPostCommentListYoutube}=require("@social_youtube/js/stream_post_comment_list");const{StreamPostCommentsReplyYoutube}=require("@social_youtube/js/stream_post_comments_reply");const{rpc}=require("@web/core/network/rpc");const{onWillStart}=require("@odoo/owl");const StreamPostCommentsYoutube=__exports.StreamPostCommentsYoutube=class StreamPostCommentsYoutube extends StreamPostComments{setup(){super.setup();this.nextPageToken=this.props.nextPageToken;this.commentsCount=this.props.commentsCount;this.state.showLoadMoreComments=!!this.nextPageToken;onWillStart(async()=>{const youtubeInfo=await this.orm.read('social.account',[this.props.accountId],['name','youtube_channel_id']);this.mediaSpecificProps=Object.assign(this.mediaSpecificProps,{accountId:this.props.accountId,accountName:youtubeInfo[0].name,youtubeChannelId:youtubeInfo[0].youtube_channel_id,});});}
async loadMoreComments(){const nextComments=await rpc('/social_youtube/get_comments',{stream_post_id:this.originalPost.id.raw_value,next_page_token:this.nextPageToken,comments_count:this.commentsCount});this.comments.push(...nextComments.comments);this.nextPageToken=nextComments.nextPageToken;this.state.showLoadMoreComments=!!this.nextPageToken;}
get commentListComponent(){return StreamPostCommentListYoutube;}
get commentReplyComponent(){return StreamPostCommentsReplyYoutube;}}
return __exports;});;

/* /social_youtube/static/src/js/stream_post_comments_reply.js */
odoo.define('@social_youtube/js/stream_post_comments_reply',['@social/js/stream_post_comments_reply','@web/core/utils/strings'],function(require){'use strict';let __exports={};const{StreamPostCommentsReply}=require('@social/js/stream_post_comments_reply');const{sprintf}=require('@web/core/utils/strings');const StreamPostCommentsReplyYoutube=__exports.StreamPostCommentsReplyYoutube=class StreamPostCommentsReplyYoutube extends StreamPostCommentsReply{get authorPictureSrc(){return sprintf('/web/image/social.account/%s/image/48x48',this.props.mediaSpecificProps.accountId);}
get canAddImage(){return false;}
get addCommentEndpoint(){return'/social_youtube/comment';}}
return __exports;});;

/* /social_youtube/static/src/js/stream_post_kanban_dashboard.js */
odoo.define('@social_youtube/js/stream_post_kanban_dashboard',['@social/js/stream_post_kanban_dashboard','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{StreamPostDashboard}=require('@social/js/stream_post_kanban_dashboard');const{patch}=require("@web/core/utils/patch");patch(StreamPostDashboard.prototype,{_hasAudience(account){return account.media_type!=='youtube'&&super._hasAudience(...arguments);},_hasEngagement(account){return account.media_type!=='youtube'&&super._hasEngagement(...arguments);},_hasStories(account){return account.media_type!=='youtube'&&super._hasStories(...arguments);},});return __exports;});;

/* /social_youtube/static/src/js/stream_post_kanban_record.js */
odoo.define('@social_youtube/js/stream_post_kanban_record',['@web/core/l10n/translation','@social/js/stream_post_kanban_record','@social_youtube/js/stream_post_comments','@web/core/utils/timing','@web/core/network/rpc','@web/core/utils/patch','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{CANCEL_GLOBAL_CLICK,StreamPostKanbanRecord}=require('@social/js/stream_post_kanban_record');const{StreamPostCommentsYoutube}=require("@social_youtube/js/stream_post_comments");const{debounce}=require("@web/core/utils/timing");const{rpc}=require("@web/core/network/rpc");const{patch}=require("@web/core/utils/patch");const{useEffect}=require("@odoo/owl");patch(StreamPostKanbanRecord.prototype,{setup(){super.setup(...arguments);useEffect((commentEl)=>{if(commentEl){const onYoutubeCommentsClick=debounce(this._onYoutubeCommentsClick.bind(this),300,true);commentEl.addEventListener('click',onYoutubeCommentsClick);return()=>{commentEl.removeEventListener('click',onYoutubeCommentsClick);};}},()=>[this.rootRef.el.querySelector('.o_social_youtube_comments')]);},_onYoutubeCommentsClick(ev){ev.stopPropagation();const postId=this.record.id.raw_value;rpc('/social_youtube/get_comments',{stream_post_id:postId,comments_count:this.commentsCount,}).then((result)=>{this.dialog.add(StreamPostCommentsYoutube,{title:_t('YouTube Comments'),accountId:this.record.account_id.raw_value,originalPost:this.record,postId:postId,comments:result.comments,nextPageToken:result.nextPageToken,});});},onGlobalClick(ev){if(ev.target.closest('.o_social_youtube_thumbnail')){ev.preventDefault();}else if(ev.target.closest(CANCEL_GLOBAL_CLICK)){return;}
this.rootRef.el.querySelector('.o_social_comments').click();}});return __exports;});;

/* /spreadsheet_dashboard/static/src/assets/dashboard_action_loader.js */
odoo.define('@spreadsheet_dashboard/assets/dashboard_action_loader',['@spreadsheet/assets_backend/spreadsheet_action_loader'],function(require){'use strict';let __exports={};const{addSpreadsheetActionLazyLoader}=require("@spreadsheet/assets_backend/spreadsheet_action_loader");addSpreadsheetActionLazyLoader("action_spreadsheet_dashboard");return __exports;});;

/* /spreadsheet_dashboard_edition/static/src/assets/dashboard_edit_action_loader.js */
odoo.define('@spreadsheet_dashboard_edition/assets/dashboard_edit_action_loader',['@spreadsheet/assets_backend/spreadsheet_action_loader'],function(require){'use strict';let __exports={};const{addSpreadsheetActionLazyLoader}=require("@spreadsheet/assets_backend/spreadsheet_action_loader");addSpreadsheetActionLazyLoader("action_edit_dashboard");return __exports;});;

/* /spreadsheet_dashboard_documents/static/src/assets/dashboard_add_spreadsheet_action.js */
odoo.define('@spreadsheet_dashboard_documents/assets/dashboard_add_spreadsheet_action',['@web/core/registry','@spreadsheet_dashboard_documents/assets/document_selector_dialog/document_selector_dialog'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{DocumentSelectorDialog}=require("@spreadsheet_dashboard_documents/assets/document_selector_dialog/document_selector_dialog");async function addSpreadsheetToDashboardSection(env,action){const{dashboardGroupId}=action.params;const params={dashboardGroupId};env.services.dialog.add(DocumentSelectorDialog,params);}
registry.category("actions").add("action_dashboard_add_spreadsheet",addSpreadsheetToDashboardSection);return __exports;});;

/* /spreadsheet_dashboard_documents/static/src/assets/document_selector_dialog/document_selector_dialog.js */
odoo.define('@spreadsheet_dashboard_documents/assets/document_selector_dialog/document_selector_dialog',['@spreadsheet_edition/assets/components/spreadsheet_selector_dialog/spreadsheet_selector_panel','@web/core/dialog/dialog','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{SpreadsheetSelectorPanel}=require("@spreadsheet_edition/assets/components/spreadsheet_selector_dialog/spreadsheet_selector_panel");const{Dialog}=require("@web/core/dialog/dialog");const{useService}=require("@web/core/utils/hooks");const{Component}=require("@odoo/owl");const DocumentSelectorDialog=__exports.DocumentSelectorDialog=class DocumentSelectorDialog extends Component{static template="spreadsheet_dashboard_documents.DocumentSelectorDialog";static components={Dialog,SpreadsheetSelectorPanel};static props={close:Function,dashboardGroupId:Number,};setup(){this.selectedSpreadsheet=null;this.orm=useService("orm");this.actionService=useService("action");}
onSpreadsheetSelected({spreadsheet}){this.selectedSpreadsheet=spreadsheet;}
async _confirm(){if(this.selectedSpreadsheet){await this.orm.call("spreadsheet.dashboard","add_document_spreadsheet_to_dashboard",[this.props.dashboardGroupId,this.selectedSpreadsheet.id,]);this.actionService.switchView("form",{resId:this.props.dashboardGroupId,});}else{const action=await this.orm.call("spreadsheet.dashboard","action_open_new_dashboard",[this.props.dashboardGroupId]);this.actionService.doAction(action,{clear_breadcrumbs:false});}
this.props.close();}
_cancel(){this.props.close();}}
return __exports;});;

/* /spreadsheet_sale_management/static/src/assets/field_sync_action_loader.js */
odoo.define('@spreadsheet_sale_management/assets/field_sync_action_loader',['@spreadsheet/assets_backend/spreadsheet_action_loader'],function(require){'use strict';let __exports={};const{addSpreadsheetActionLazyLoader}=require("@spreadsheet/assets_backend/spreadsheet_action_loader");addSpreadsheetActionLazyLoader("action_sale_order_spreadsheet","sale-order-spreadsheet");return __exports;});;

/* /website_enterprise/static/src/client_actions/configurator/configurator.js */
odoo.define('@website_enterprise/client_actions/configurator/configurator',['@odoo/owl','@web/core/utils/hooks','@web/core/utils/patch','@website/client_actions/configurator/configurator'],function(require){'use strict';let __exports={};const{onWillStart}=require("@odoo/owl");const{useService}=require("@web/core/utils/hooks");const{patch}=require("@web/core/utils/patch");const{ROUTES,WelcomeScreen}=require("@website/client_actions/configurator/configurator");const WEBSITE_GENERATOR_ROUTE=__exports.WEBSITE_GENERATOR_ROUTE=6;patch(WelcomeScreen.prototype,{setup(){super.setup(...arguments);this.orm=useService("orm");this.ui=useService("ui");onWillStart(async()=>{this.showWebsiteGeneratorButton=await this.orm.call("website","is_website_generator_available",);});},async goToWebsiteGeneratorRequest(){if(ROUTES.websiteGenerator){this.props.navigate(ROUTES.websiteGenerator);return;}
this.ui.block();const modules=await this.orm.searchRead("ir.module.module",[["name","=","website_generator"]],["id"],);await this.orm.call("ir.module.module","button_immediate_install",[[modules[0].id]]);this.props.navigate(WEBSITE_GENERATOR_ROUTE,true);this.ui.unblock();},});return __exports;});;

/* /website_knowledge/static/src/backend/client_actions/website_preview/website_preview.js */
odoo.define('@website_knowledge/backend/client_actions/website_preview/website_preview',['@web/core/utils/patch','@website/client_actions/website_preview/website_preview'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{WebsitePreview}=require('@website/client_actions/website_preview/website_preview');patch(WebsitePreview.prototype,{_isTopWindowURL({pathname}){return(pathname&&(pathname.startsWith('/knowledge/article/')||pathname.includes('/knowledge/home')))||super._isTopWindowURL(...arguments);}});return __exports;});;

/* /website_knowledge/static/src/backend/components/permission_panel/permission_panel.js */
odoo.define('@website_knowledge/backend/components/permission_panel/permission_panel',['@web/core/utils/patch','@knowledge/components/permission_panel/permission_panel','@web/views/fields/copy_clipboard/copy_clipboard_field'],function(require){'use strict';let __exports={};const{patch}=require("@web/core/utils/patch");const{PermissionPanel}=require("@knowledge/components/permission_panel/permission_panel");const{CopyClipboardCharField}=require("@web/views/fields/copy_clipboard/copy_clipboard_field");const PermissionPanelWebsiteKnowledgePatch={toggleWebsitePublished(){if((this.props.record.data.user_can_write&&this.isInternalUser)||this.state.user_is_admin){this.props.record.update({website_published:!this.props.record.data.website_published},{save:true});}}};patch(PermissionPanel.prototype,PermissionPanelWebsiteKnowledgePatch);PermissionPanel.components={...PermissionPanel.components,CopyClipboardCharField,};return __exports;});;

/* /board/static/src/add_to_board/add_to_board.js */
odoo.define('@board/add_to_board/add_to_board',['@web/core/l10n/translation','@web/core/dropdown/dropdown','@web/core/network/rpc','@web/core/registry','@web/core/utils/hooks','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{Dropdown}=require("@web/core/dropdown/dropdown");const{rpc}=require("@web/core/network/rpc");const{registry}=require("@web/core/registry");const{useAutofocus,useService}=require("@web/core/utils/hooks");const{Component,useState}=require("@odoo/owl");const cogMenuRegistry=registry.category("cogMenu");const AddToBoard=__exports.AddToBoard=class AddToBoard extends Component{static template="board.AddToBoard";static components={Dropdown};static props={};setup(){this.notification=useService("notification");this.state=useState({name:this.env.config.getDisplayName()});useAutofocus();}
async addToBoard(){const{domain,globalContext}=this.env.searchModel;const{context,groupBys,orderBy}=this.env.searchModel.getPreFavoriteValues();const comparison=this.env.searchModel.comparison;const contextToSave={...Object.fromEntries(Object.entries(globalContext).filter((entry)=>!entry[0].startsWith("search_default_"))),...context,orderedBy:orderBy,group_by:groupBys,dashboard_merge_domains_contexts:false,};if(comparison){contextToSave.comparison=comparison;}
const result=await rpc("/board/add_to_dashboard",{action_id:this.env.config.actionId||false,context_to_save:contextToSave,domain,name:this.state.name,view_mode:this.env.config.viewType,});if(result){this.notification.add(_t("Please refresh your browser for the changes to take effect."),{title:_t("“%s” added to dashboard",this.state.name),type:"warning",});this.state.name=this.env.config.getDisplayName();}else{this.notification.add(_t("Could not add filter to dashboard"),{type:"danger",});}}
onInputKeydown(ev){if(ev.key==="Enter"){ev.preventDefault();this.addToBoard();}}}
const addToBoardItem=__exports.addToBoardItem={Component:AddToBoard,groupNumber:20,isDisplayed:({config})=>{const{actionType,actionId,viewType}=config;return actionType==="ir.actions.act_window"&&actionId&&viewType!=="form";},};cogMenuRegistry.add("add-to-board",addToBoardItem,{sequence:10});return __exports;});;

/* /board/static/src/board_action.js */
odoo.define('@board/board_action',['@web/core/network/rpc','@web/core/utils/hooks','@web/views/view','@web/core/context','@web/core/user','@odoo/owl'],function(require){'use strict';let __exports={};const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{View}=require("@web/views/view");const{makeContext}=require("@web/core/context");const{user}=require("@web/core/user");const{Component,onWillStart}=require("@odoo/owl");const BoardAction=__exports.BoardAction=class BoardAction extends Component{static template="board.BoardAction";static components={View};static props={action:Object,actionId:{type:Number,optional:true},className:{type:String,optional:true},};static cache={};setup(){this.actionService=useService("action");const action=this.props.action;this.formViewId=false;this.isValid=true;onWillStart(async()=>{let result=BoardAction.cache[action.actionId];if(!result){result=await rpc("/web/action/load",{action_id:action.actionId});BoardAction.cache[action.actionId]=result;}
if(!result){this.isValid=false;return;}
const viewMode=action.viewMode||result.views[0][1];const formView=result.views.find((v)=>v[1]==="form");if(formView){this.formViewId=formView[0];}
this.viewProps={resModel:result.res_model,type:viewMode,display:{controlPanel:false},selectRecord:(resId)=>this.selectRecord(result.res_model,resId),};const view=result.views.find((v)=>v[1]===viewMode);if(view){this.viewProps.viewId=view[0];}
const searchView=result.views.find((v)=>v[1]==="search");this.viewProps.views=[[this.viewProps.viewId||false,viewMode],[(searchView&&searchView[0])||false,"search"],];if(action.context){this.viewProps.context=makeContext([action.context,{lang:user.context.lang}]);if("group_by"in this.viewProps.context){const groupBy=this.viewProps.context.group_by;this.viewProps.groupBy=typeof groupBy==="string"?[groupBy]:groupBy;}
if("comparison"in this.viewProps.context){const comparison=this.viewProps.context.comparison;if(comparison!==null&&typeof comparison==="object"&&"domains"in comparison&&"fieldName"in comparison){this.viewProps.comparison=comparison;}}}
if(action.domain){this.viewProps.domain=action.domain;}
if(viewMode==="list"){this.viewProps.allowSelectors=false;}});}
selectRecord(resModel,resId){this.actionService.doAction({type:"ir.actions.act_window",res_model:resModel,views:[[this.formViewId,"form"]],res_id:resId,});}}
return __exports;});;

/* /board/static/src/board_controller.js */
odoo.define('@board/board_controller',['@web/core/l10n/translation','@web/core/browser/browser','@web/core/confirmation_dialog/confirmation_dialog','@web/core/dropdown/dropdown','@web/core/dropdown/dropdown_item','@web/core/network/rpc','@web/core/utils/hooks','@web/core/utils/render','@web/core/utils/sortable_owl','@web/views/standard_view_props','@board/board_action','@odoo/owl'],function(require){'use strict';let __exports={};const{_t}=require("@web/core/l10n/translation");const{browser}=require("@web/core/browser/browser");const{ConfirmationDialog}=require("@web/core/confirmation_dialog/confirmation_dialog");const{Dropdown}=require("@web/core/dropdown/dropdown");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{rpc}=require("@web/core/network/rpc");const{useService}=require("@web/core/utils/hooks");const{renderToString}=require("@web/core/utils/render");const{useSortable}=require("@web/core/utils/sortable_owl");const{standardViewProps}=require("@web/views/standard_view_props");const{BoardAction}=require("@board/board_action");const{blockDom,Component,useState,useRef}=require("@odoo/owl");const BoardController=__exports.BoardController=class BoardController extends Component{static template="board.BoardView";static components={BoardAction,Dropdown,DropdownItem};static props={...standardViewProps,board:Object,};setup(){this.board=useState(this.props.board);this.dialogService=useService("dialog");if(this.env.isSmall){this.selectLayout("1",false);}else{const mainRef=useRef("main");useSortable({ref:mainRef,elements:".o-dashboard-action",handle:".o-dashboard-action-header",cursor:"move",groups:".o-dashboard-column",connectGroups:true,onDrop:({element,previous,parent})=>{const fromColIdx=parseInt(element.parentElement.dataset.idx,10);const fromActionIdx=parseInt(element.dataset.idx,10);const toColIdx=parseInt(parent.dataset.idx,10);const toActionIdx=previous?parseInt(previous.dataset.idx,10)+1:0;if(fromColIdx!==toColIdx){element.classList.add("d-none");}
this.moveAction(fromColIdx,fromActionIdx,toColIdx,toActionIdx);},});}}
moveAction(fromColIdx,fromActionIdx,toColIdx,toActionIdx){const action=this.board.columns[fromColIdx].actions[fromActionIdx];if(fromColIdx!==toColIdx){this.board.columns[fromColIdx].actions.splice(fromActionIdx,1);this.board.columns[toColIdx].actions.splice(toActionIdx,0,action);}else{if(fromActionIdx===toActionIdx){return;}
const actions=this.board.columns[fromColIdx].actions;if(fromActionIdx<toActionIdx){actions.splice(toActionIdx+1,0,action);actions.splice(fromActionIdx,1);}else{actions.splice(fromActionIdx,1);actions.splice(toActionIdx,0,action);}}
this.saveBoard();}
selectLayout(layout,save=true){const currentColNbr=this.board.colNumber;const nextColNbr=layout.split("-").length;if(nextColNbr<currentColNbr){const cols=this.board.columns;const lastVisibleCol=cols[nextColNbr-1];for(let i=nextColNbr;i<currentColNbr;i++){lastVisibleCol.actions.push(...cols[i].actions);cols[i].actions=[];}}
this.board.layout=layout;this.board.colNumber=nextColNbr;if(save){this.saveBoard();}
if(document.querySelector("canvas")){browser.requestAnimationFrame(()=>this.render(true));}}
closeAction(column,action){this.dialogService.add(ConfirmationDialog,{body:_t("Are you sure that you want to remove this item?"),confirm:()=>{const index=column.actions.indexOf(action);column.actions.splice(index,1);this.saveBoard();},cancel:()=>{},});}
toggleAction(action,save=true){action.isFolded=!action.isFolded;if(save){this.saveBoard();}}
saveBoard(){const templateFn=renderToString.app.getTemplate("board.arch");const bdom=templateFn(this.board,{});const root=document.createElement("rendertostring");blockDom.mount(bdom,root);const result=xmlSerializer.serializeToString(root);const arch=result.slice(result.indexOf("<",1),result.indexOf("</rendertostring>"));rpc("/web/view/edit_custom",{custom_id:this.board.customViewId,arch,});this.env.bus.trigger("CLEAR-CACHES");}}
const xmlSerializer=new XMLSerializer();return __exports;});;

/* /board/static/src/board_view.js */
odoo.define('@board/board_view',['@web/core/registry','@board/board_controller','@web/core/utils/xml','@web/core/domain'],function(require){'use strict';let __exports={};const{registry}=require("@web/core/registry");const{BoardController}=require("@board/board_controller");const{visitXML}=require("@web/core/utils/xml");const{Domain}=require("@web/core/domain");const BoardArchParser=__exports.BoardArchParser=class BoardArchParser{parse(arch,customViewId){let nextId=1;const archInfo={title:null,layout:null,colNumber:0,isEmpty:true,columns:[{actions:[]},{actions:[]},{actions:[]}],customViewId,};let currentIndex=-1;visitXML(arch,(node)=>{switch(node.tagName){case"form":archInfo.title=node.getAttribute("string");break;case"board":archInfo.layout=node.getAttribute("style");archInfo.colNumber=archInfo.layout.split("-").length;break;case"column":currentIndex++;break;case"action":{archInfo.isEmpty=false;const isFolded=Boolean(node.hasAttribute("fold")?parseInt(node.getAttribute("fold"),10):0);const action={id:nextId++,title:node.getAttribute("string"),actionId:parseInt(node.getAttribute("name"),10),viewMode:node.getAttribute("view_mode"),context:node.getAttribute("context"),isFolded,};if(node.hasAttribute("domain")){const domain=node.getAttribute("domain");action.domain=new Domain(domain).toList();action.domain.toString=()=>node.getAttribute("domain");}
archInfo.columns[currentIndex].actions.push(action);break;}}});return archInfo;}}
const boardView=__exports.boardView={type:"form",Controller:BoardController,props:(genericProps,view)=>{const{arch,info}=genericProps;const board=new BoardArchParser().parse(arch,info.customViewId);return{...genericProps,className:"o_dashboard",board,};},};registry.category("views").add("board",boardView);return __exports;});;

/* /hr_recruitment_skills/static/src/components/search_job_applicant_menu/search_job_applicant_menu.js */
odoo.define('@hr_recruitment_skills/components/search_job_applicant_menu/search_job_applicant_menu',['@odoo/owl','@web/core/registry','@web/core/utils/hooks','@web/core/dropdown/dropdown_item','@web/search/action_menus/action_menus'],function(require){'use strict';let __exports={};const{Component,markup}=require("@odoo/owl");const{registry}=require("@web/core/registry");const{useService}=require("@web/core/utils/hooks");const{DropdownItem}=require("@web/core/dropdown/dropdown_item");const{STATIC_ACTIONS_GROUP_NUMBER}=require("@web/search/action_menus/action_menus");const cogMenuRegistry=registry.category("cogMenu");const SearchJobApplicant=__exports.SearchJobApplicant=class SearchJobApplicant extends Component{static template="hr_recruitment_skills.SearchJobApplicant";static components={DropdownItem};static props={};setup(){this.action=useService("action");}
async openMatchingJobApplicants(){const{globalContext}=this.env.searchModel;const action=await this.env.services.orm.call("hr.job","action_search_matching_candidates",[globalContext.active_id],);action.help=markup(action.help);return this.action.doAction(action);}}
const searchJobApplicant=__exports.searchJobApplicant={Component:SearchJobApplicant,groupNumber:STATIC_ACTIONS_GROUP_NUMBER,isDisplayed:({config,searchModel})=>{return(searchModel.resModel==="hr.applicant"&&searchModel.globalContext.allow_search_matching_applicants&&config.viewArch.classList.contains('o_search_matching_applicant'));},};cogMenuRegistry.add("search-job-applicants-menu",searchJobApplicant,{sequence:11});return __exports;});;

/* /appointment_crm/static/src/views/appointment_calendar/appointment_crm_calendar_controller.js */
odoo.define('@appointment_crm/views/appointment_calendar/appointment_crm_calendar_controller',['@calendar/views/attendee_calendar/attendee_calendar_controller','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{AttendeeCalendarController}=require("@calendar/views/attendee_calendar/attendee_calendar_controller");const{patch}=require("@web/core/utils/patch");patch(AttendeeCalendarController.prototype,{getOpportunityName(){if(!this.props.context.default_opportunity_id){return undefined;}
return this.props.context.default_name;},});return __exports;});;

/* /website_documents/static/src/views/list/documents_list_renderer.js */
odoo.define('@website_documents/views/list/documents_list_renderer',['@documents/views/list/documents_list_renderer','@web/core/utils/patch'],function(require){'use strict';let __exports={};const{DocumentsListRenderer}=require("@documents/views/list/documents_list_renderer");const{patch}=require("@web/core/utils/patch");patch(DocumentsListRenderer.prototype,{get editableColumns(){return super.editableColumns.concat(["website_id"]);}});return __exports;});;

/* /web_enterprise/static/src/main.js */
odoo.define('@web_enterprise/main',['@web/start','@web_enterprise/webclient/webclient'],function(require){'use strict';let __exports={};const{startWebClient}=require("@web/start");const{WebClientEnterprise}=require("@web_enterprise/webclient/webclient");startWebClient(WebClientEnterprise);return __exports;});;

/* /web/static/src/start.js */
odoo.define('@web/start',['@web/env','@web/core/l10n/localization','@web/session','@web/core/browser/feature_detection','@web/core/user','@odoo/owl'],function(require){'use strict';let __exports={};const{mountComponent}=require("@web/env");const{localization}=require("@web/core/l10n/localization");const{session}=require("@web/session");const{hasTouch}=require("@web/core/browser/feature_detection");const{user}=require("@web/core/user");const{Component,whenReady}=require("@odoo/owl");__exports.startWebClient=startWebClient;async function startWebClient(Webclient){odoo.info={db:session.db,server_version:session.server_version,server_version_info:session.server_version_info,isEnterprise:session.server_version_info.slice(-1)[0]==="e",};odoo.isReady=false;await whenReady();const app=await mountComponent(Webclient,document.body,{name:"Odoo Web Client"});const{env}=app;Component.env=env;const classList=document.body.classList;if(localization.direction==="rtl"){classList.add("o_rtl");}
if(user.userId===1){classList.add("o_is_superuser");}
if(env.debug){classList.add("o_debug");}
if(hasTouch()){classList.add("o_touch_device");}
odoo.isReady=true;}
return __exports;});

                    /*******************************************
                    *  Templates                               *
                    *******************************************/

                    odoo.define("web.assets_web.bundle.xml", ["@web/core/templates"], function(require) {
                        "use strict";
                        const { checkPrimaryTemplateParents, registerTemplate, registerTemplateExtension } = require("@web/core/templates");
                        /* web.assets_web */
                        registerTemplate("web.ActionSwiper", `/web/static/src/core/action_swiper/action_swiper.xml`, `<t t-name="web.ActionSwiper" xml:space="preserve">
        <t t-if="props.onRightSwipe || props.onLeftSwipe">
            <div class="o_actionswiper" t-on-touchend="_onTouchEndSwipe" t-on-touchmove="_onTouchMoveSwipe" t-on-touchstart="_onTouchStartSwipe" t-ref="root">
                <div class="o_actionswiper_overflow_container position-relative overflow-hidden">
                    <div class="o_actionswiper_target_container" t-ref="targetContainer" t-att-style="state.containerStyle" t-att-class="{ o_actionswiper_swiping: state.isSwiping }">
                        <t t-slot="default"/>
                        <t t-if="localizedProps.onRightSwipe and (localizedProps.onRightSwipe.icon or localizedProps.onRightSwipe.bgColor)">
                            <div t-att-style="'max-width: ' + swipedDistance + 'px;'" class="o_actionswiper_right_swipe_area position-absolute overflow-hidden w-100 h-100 d-flex align-items-center justify-content-center rounded-end" t-att-class="localizedProps.onRightSwipe.bgColor">
                                <span><i class="fa fa-2x" t-att-class="localizedProps.onRightSwipe.icon"/></span>
                            </div>
                        </t>
                        <t t-if="localizedProps.onLeftSwipe and (localizedProps.onLeftSwipe.icon or localizedProps.onLeftSwipe.bgColor)">
                            <div t-att-style="'max-width: ' + -swipedDistance + 'px;'" class="o_actionswiper_left_swipe_area position-absolute overflow-hidden w-100 h-100 d-flex align-items-center justify-content-center rounded-start" t-att-class="localizedProps.onLeftSwipe.bgColor">
                                <span><i class="fa fa-2x" t-att-class="localizedProps.onLeftSwipe.icon"/></span>
                            </div>
                        </t>
                    </div>
                </div>
            </div>
        </t>
        <t t-else="">
            <t t-slot="default"/>
        </t>
    </t>
`);
registerTemplate("web.AutoComplete", `/web/static/src/core/autocomplete/autocomplete.xml`, `<t t-name="web.AutoComplete" xml:space="preserve">
        <div class="o-autocomplete" t-ref="root" t-att-class="autoCompleteRootClass">
            <input type="text" t-att-id="props.id" class="o-autocomplete--input o_input pe-3" autocomplete="off" t-att-placeholder="props.placeholder" role="combobox" t-att-aria-activedescendant="activeSourceOptionId" t-att-aria-expanded="displayOptions ? 'true' : 'false'" aria-autocomplete="list" aria-haspopup="listbox" t-model="state.value" t-on-blur="onInputBlur" t-on-click="onInputClick" t-on-change="onInputChange" t-on-input="onInput" t-on-keydown="onInputKeydown" t-on-focus="onInputFocus" t-ref="input"/>
            <t t-if="displayOptions">
                <ul role="menu" class="o-autocomplete--dropdown-menu ui-widget show" t-att-class="ulDropdownClass" t-ref="sourcesList">
                    <t t-foreach="sources" t-as="source" t-key="source.id">
                        <t t-if="source.isLoading">
                            <li class="ui-menu-item" t-att-class="{                                     'o-autocomplete--dropdown-item': props.dropdown,                                     'd-block': !props.dropdown                                 }">
                                <a t-attf-id="{{props.id or 'autocomplete'}}_{{source_index}}_loading" role="option" href="#" class="o_loading dropdown-item ui-menu-item-wrapper" aria-selected="true">
                                    <i class="fa fa-spin fa-circle-o-notch"/> <t t-esc="source.placeholder"/>
                                </a>
                            </li>
                        </t>
                        <t t-else="">
                            <t t-foreach="source.options" t-as="option" t-key="option.id">
                                <li class="o-autocomplete--dropdown-item ui-menu-item d-block" t-att-class="option.classList" t-on-mouseenter="() =&gt; this.onOptionMouseEnter([source_index, option_index])" t-on-mouseleave="() =&gt; this.onOptionMouseLeave([source_index, option_index])" t-on-click="() =&gt; this.onOptionClick(option)" t-on-pointerdown="() =&gt; this.ignoreBlur = true">
                                    <a t-attf-id="{{props.id or 'autocomplete'}}_{{source_index}}_{{option_index}}" role="option" href="#" class="dropdown-item ui-menu-item-wrapper text-truncate" t-att-class="{ 'ui-state-active': isActiveSourceOption([source_index, option_index]) }" t-att-aria-selected="isActiveSourceOption([source_index, option_index]) ? 'true' : 'false'">
                                        <t t-if="source.optionTemplate">
                                            <t t-call="{{ source.optionTemplate }}"/>
                                        </t>
                                        <t t-else="">
                                            <t t-esc="option.label"/>
                                        </t>
                                    </a>
                                </li>
                            </t>
                        </t>
                    </t>
                </ul>
            </t>
        </div>
    </t>

`);
registerTemplate("web.BarcodeDialog", `/web/static/src/core/barcode/barcode_dialog.xml`, `<t t-name="web.BarcodeDialog" xml:space="preserve">
        <Dialog title.translate="Barcode Scanner" fullscreen="true" footer="false" contentClass="'o-barcode-modal'">
            <BarcodeVideoScanner t-if="state.barcodeScannerSupported" t-props="props" onError.bind="onError" onResult.bind="onResult"/>
            <div t-else="" t-ref="videoPreview" class="h-100 d-flex flex-column justify-content-center align-items-center gap-1">
                <i class="fa fa-2x fa-camera text-muted"/>
                <strong>Unable to access camera</strong>
                <span class="text-muted" t-out="state.errorMessage"/>
            </div>
        </Dialog>
    </t>
`);
registerTemplate("web.BarcodeVideoScanner", `/web/static/src/core/barcode/barcode_video_scanner.xml`, `<t t-name="web.BarcodeVideoScanner" xml:space="preserve">
        <CropOverlay onResize.bind="this.onResize" isReady="state.isReady">
            <video t-ref="videoPreview" muted="true" autoplay="true" playsinline="true" t-att-class="props.cssClass"/>
        </CropOverlay>
    </t>
`);
registerTemplate("web.CropOverlay", `/web/static/src/core/barcode/crop_overlay.xml`, `<t t-name="web.CropOverlay" xml:space="preserve">
        <div t-ref="crop-container" t-on-mousedown="pointerDown" t-on-touchstart="pointerDown" t-on-mousemove="pointerMove" t-on-touchmove="pointerMove" t-on-mouseup="pointerUp" t-on-touchend="pointerUp" class="d-grid align-content-center justify-content-center h-100 o_crop_container">
            <t t-slot="default"/>
            <t t-if="props.isReady">
                <div class="o_crop_overlay"/>
                <img class="o_crop_icon" src="/web/static/img/transform.svg" draggable="false"/>
            </t>
        </div>
    </t>
`);
registerTemplate("web.CheckBox", `/web/static/src/core/checkbox/checkbox.xml`, `<t t-name="web.CheckBox" xml:space="preserve">
    <div class="o-checkbox form-check" t-attf-class="{{ props.slots ? 'form-check' : '' }}" t-att-class="props.className" t-on-click="onClick" t-ref="root">
        <input t-att-id="props.id or id" type="checkbox" class="form-check-input" t-att-disabled="props.disabled" t-att-checked="props.value" t-att-name="props.name" t-on-change="onChange"/>
        <label t-att-for="props.id or id" class="form-check-label">
            <t t-slot="default"/>
        </label>
    </div>
</t>

`);
registerTemplate("web.CodeEditor", `/web/static/src/core/code_editor/code_editor.xml`, `<t t-name="web.CodeEditor" xml:space="preserve">
        <div t-ref="editorRef" class="w-100" t-att-class="props.class" t-att-data-mode="state.activeMode"/>
    </t>

`);
registerTemplate("web.ColorList", `/web/static/src/core/colorlist/colorlist.xml`, `<t t-name="web.ColorList" xml:space="preserve">
        <div class="o_colorlist d-flex flex-wrap align-items-center mw-100 gap-2" aria-atomic="true" t-ref="colorlist">
            <t t-if="!props.forceExpanded and !state.isExpanded">
                <button t-on-click="onToggle" role="menuitem" t-att-title="colors[props.selectedColor]" t-att-data-color="props.selectedColor" t-att-aria-label="colors[props.selectedColor]" t-attf-class="btn p-0 rounded-0 o_colorlist_toggler o_colorlist_item_color_{{ props.selectedColor }}"/>
            </t>
            <t t-else="" t-foreach="props.colors" t-as="colorId" t-key="colorId">
                <button t-on-click.prevent.stop="() =&gt; this.onColorSelected(colorId)" role="menuitem" t-att-title="colors[colorId]" t-att-data-color="colorId" t-att-aria-label="colors[colorId]" t-attf-class="btn p-0 rounded-0 o_colorlist_item_color_{{ colorId }} {{ colorId === props.selectedColor ? 'o_colorlist_selected' : '' }}"/>
            </t>
        </div>
    </t>

`);
registerTemplate("web.Colorpicker", `/web/static/src/core/colorpicker/colorpicker.xml`, `<t t-name="web.Colorpicker" xml:space="preserve">
    <div class="o_colorpicker_widget" t-ref="el" t-on-click="onClick" t-on-keydown="onKeydown">
        <div class="d-flex justify-content-between align-items-stretch mb-2">
            <div t-ref="colorPickerArea" class="o_color_pick_area position-relative w-75" t-att-style="props.noTransparency ? 'width: 89%;' : None" t-on-mousedown="onMouseDownPicker">
                <div t-ref="colorPickerPointer" class="o_picker_pointer rounded-circle p-1 position-absolute" tabindex="-1"/>
            </div>
            <div t-ref="colorSlider" class="o_color_slider position-relative" t-on-mousedown="onMouseDownSlider">
                <div t-ref="colorSliderPointer" class="o_slider_pointer" tabindex="-1"/>
            </div>
            <div t-ref="opacitySlider" class="o_opacity_slider position-relative" t-if="!props.noTransparency" t-on-mousedown="onMouseDownOpacitySlider">
                <div t-ref="opacitySliderPointer" class="o_opacity_pointer" tabindex="-1"/>
            </div>
        </div>
        <div class="o_color_picker_inputs d-flex justify-content-between mb-2" t-on-change="debouncedOnChangeInputs">
            <t t-set="input_classes" t-value="'p-0 border-0 text-center font-monospace bg-transparent'"/>

            <div class="o_hex_div px-1 d-flex align-items-baseline">
                <input type="text" t-attf-class="o_hex_input {{input_classes}}" data-color-method="hex" size="1" t-on-input="onHexColorInput"/>
                <label class="flex-grow-0 ms-1 mb-0">hex</label>
            </div>
            <div class="o_rgba_div px-1 d-flex align-items-baseline">
                <input type="text" t-attf-class="o_red_input {{input_classes}}" data-color-method="rgb" size="1"/>
                <input type="text" t-attf-class="o_green_input {{input_classes}}" data-color-method="rgb" size="1"/>
                <input type="text" t-attf-class="o_blue_input {{input_classes}}" data-color-method="rgb" size="1"/>
                <t t-if="!props.noTransparency">
                    <input type="text" t-attf-class="o_opacity_input {{input_classes}}" data-color-method="opacity" size="1"/>
                    <label class="flex-grow-0 ms-1 mb-0">
                        RGBA
                    </label>
                </t>
                <label t-else="" class="flex-grow-0 ms-1 mb-0">
                    RGB
                </label>
            </div>
        </div>
    </div>
</t>

`);
registerTemplate("web.DefaultFooter", `/web/static/src/core/commands/command_items.xml`, `<t t-name="web.DefaultFooter" owl="1" xml:space="preserve">
    <span>
      <span class="fw-bolder text-primary">TIP</span> — search for
      <t t-foreach="elements" t-as="element" t-key="element.namespace">
          <t t-if="!(element_first || element_last)">, </t>
          <t t-if="element_last and !element_first"> and </t>
          <span class="o_namespace btn-link text-primary cursor-pointer" t-on-click="() =&gt; this.onClick(element.namespace)">
              <span t-out="element.namespace" class="fw-bolder text-primary"/><t t-out="element.name"/>
          </span>
      </t>
    </span>
  </t>

  `);
registerTemplate("web.DefaultCommandItem", `/web/static/src/core/commands/command_items.xml`, `<t t-name="web.DefaultCommandItem" xml:space="preserve">
    <div class="o_command_default d-flex align-items-center justify-content-between px-4 py-2 cursor-pointer">
      <t t-slot="name"/>
      <t t-slot="focusMessage"/>
    </div>
  </t>

  `);
registerTemplate("web.HotkeyCommandItem", `/web/static/src/core/commands/command_items.xml`, `<t t-name="web.HotkeyCommandItem" xml:space="preserve">
    <div class="o_command_hotkey d-flex align-items-center justify-content-between px-4 py-2 cursor-pointer">
      <t t-slot="name"/>
      <span>
        <t t-foreach="getKeysToPress(props)" t-as="key" t-key="key_index">
          <kbd t-out="key" class="d-inline-block px-3 py-1"/>
          <span t-if="!key_last"> + </span>
        </t>
      </span>
    </div>
  </t>

`);
registerTemplate("web.CommandPalette", `/web/static/src/core/commands/command_palette.xml`, `<t t-name="web.CommandPalette" xml:space="preserve">
    <Dialog header="false" footer="false" size="'md'" contentClass="'o_command_palette'">
      <div t-ref="root">
        <div class="o_command_palette_search input-group mb-2 px-4 py-3 border-bottom">
          <span t-if="state.namespace !== 'default'" class="o_namespace d-flex align-items-center me-1" t-out="state.namespace"/>
          <input class="form-control border-0 p-0" type="text" data-allow-hotkeys="true" t-att-value="state.searchValue" t-ref="autofocus" t-att-placeholder="state.placeholder" t-on-input="onSearchInput" t-on-keydown="onKeyDown" role="combobox" t-attf-aria-activedescendant="o_command_{{state.commands.length ? state.commands.indexOf(state.selectedCommand) : 'empty'}}" aria-expanded="true" aria-autocomplete="list" aria-haspopup="listbox"/>
          <div class="input-group-text border-0 bg-transparent">
              <i t-if="state.isLoading" title="Loading..." role="img" aria-label="Loading..." class="fa fa-spinner fa-spin"/>
              <i t-else="" t-att-title="state.placeholder" role="img" t-att-aria-label="state.placeholder" class="oi oi-search"/>
          </div>
        </div>

        <div t-ref="listbox" role="listbox" class="o_command_palette_listbox position-relative overflow-auto">
          <div t-if="!state.commands.length" id="o_command_empty" role="option" aria-selected="true" class="o_command_palette_listbox_empty px-4 py-3 fst-italic" t-out="state.emptyMessage"/>
          <t t-if="!isFuzzySearch" t-foreach="commandsByCategory" t-as="category" t-key="category.keyId">
            <div class="o_command_category px-0">
              <span t-if="category.name" class="text-truncate text-uppercase fw-bold fs-6 px-3" t-out="category.name"/>
              <t t-foreach="category.commands" t-as="command" t-key="command.keyId">
                <t t-set="commandIndex" t-value="state.commands.indexOf(command)"/>
                <div t-attf-id="o_command_{{commandIndex}}" class="o_command" role="option" t-att-aria-selected="state.selectedCommand === command ? 'true' : 'false'" t-att-class="{ focused: state.selectedCommand === command }" t-on-click="(event) =&gt; this.onCommandClicked(event, commandIndex)" t-on-mouseenter="() =&gt; this.onCommandMouseEnter(commandIndex)" t-on-close="() =&gt; this.props.closeMe()">
                  <a t-att-href="command.href">
                    <t t-component="command.Component || DefaultCommandItem" name="command.name" searchValue="state.searchValue" t-props="command.props" executeCommand="() =&gt; this.executeCommand(command)">
                      <t t-set-slot="name">
                        <span class="o_command_name text-ellipsis" t-att-title="command.name">
                          <t t-foreach="command.splitName" t-as="name" t-key="name_index">
                            <b t-if="name_index % 2" t-out="name" class="text-primary"/>
                            <t t-else="" t-out="name"/>
                          </t>
                        </span>
                      </t>
                      <t t-set-slot="focusMessage">
                          <small t-if="!isMobileOS and command.href and state.selectedCommand === command" class="o_command_focus text-muted"><kbd><t t-if="isMacOS">CMD</t><t t-else="">CTRL</t></kbd>+<kbd>⏎</kbd><span class="ms-1">new tab</span></small>
                      </t>
                    </t>
                  </a>
                </div>
              </t>
            </div>

            <hr class="my-2 mx-0" t-if="!category_last"/>
          </t>
        </div>

        <div t-if="state.FooterComponent" class="o_command_palette_footer mt-2 px-4 py-2 border-top rounded-bottom bg-100 text-muted">
          <t t-component="state.FooterComponent" switchNamespace="(namespace) =&gt; this.debounceSearch(namespace.concat(this.state.searchValue))"/>
        </div>
      </div>
    </Dialog>
  </t>

`);
registerTemplate("web.ConfirmationDialog", `/web/static/src/core/confirmation_dialog/confirmation_dialog.xml`, `<t t-name="web.ConfirmationDialog" xml:space="preserve">
    <Dialog size="'md'" title="props.title" modalRef="modalRef">
      <p t-out="props.body" class="text-prewrap"/>
      <t t-set-slot="footer">
        <button class="btn" t-att-class="props.confirmClass" t-on-click="_confirm" t-esc="props.confirmLabel"/>
        <button t-if="props.cancel" class="btn btn-secondary" t-on-click="_cancel" t-esc="props.cancelLabel"/>
      </t>
    </Dialog>
  </t>

  `);
registerTemplate("web.AlertDialog", `/web/static/src/core/confirmation_dialog/confirmation_dialog.xml`, `<t t-name="web.AlertDialog" xml:space="preserve">
    <Dialog size="'sm'" title="props.title" contentClass="props.contentClass">
      <p t-out="props.body" class="text-prewrap"/>
      <t t-set-slot="footer">
        <button class="btn" t-att-class="props.confirmClass" t-on-click="_confirm" t-esc="props.confirmLabel"/>
        <button t-if="props.cancel" class="btn btn-secondary" t-on-click="_cancel" t-esc="props.cancelLabel"/>
      </t>
    </Dialog>
  </t>

`);
registerTemplate("web.CopyButton", `/web/static/src/core/copy_button/copy_button.xml`, `<t t-name="web.CopyButton" xml:space="preserve">
        <button class="text-nowrap" t-ref="button" t-att-disabled="props.disabled" t-attf-class="btn o_clipboard_button {{ props.className || '' }}" t-on-click.stop="onClick">
            <span class="mx-1" t-attf-class="fa {{ props.icon || 'fa-clipboard' }}"/>
            <span t-if="props.copyText" t-esc="props.copyText"/>
        </button>
    </t>

`);
registerTemplate("web.DateTimeInput", `/web/static/src/core/datetime/datetime_input.xml`, `<t t-name="web.DateTimeInput" xml:space="preserve">
        <input type="text" t-ref="start-date" t-att-id="props.id" class="o_datetime_input o_input cursor-pointer" autocomplete="off" t-att-placeholder="props.placeholder"/>
    </t>
`);
registerTemplate("web.DateTimePicker.Days", `/web/static/src/core/datetime/datetime_picker.xml`, `<t t-name="web.DateTimePicker.Days" xml:space="preserve">
        <div class="d-flex gap-3">
            <t t-foreach="items" t-as="month" t-key="month.id">
                <div class="o_date_picker d-grid flex-grow-1 bg-view rounded overflow-auto" t-on-pointerleave="() =&gt; (state.hoveredDate = null)">
                    <t t-foreach="month.daysOfWeek" t-as="dayOfWeek" t-key="dayOfWeek[0]">
                        <div class="o_day_of_week_cell o_text_sm o_cell_md fw-bolder bg-100 border-bottom border-2 d-flex align-items-center justify-content-center" t-att-title="dayOfWeek[1]">
                            <div class="text-nowrap overflow-hidden" t-esc="props.daysOfWeekFormat === 'narrow' ? dayOfWeek[2] : dayOfWeek[0]"/>
                        </div>
                    </t>
                    <t t-foreach="month.weeks" t-as="week" t-key="week.number">
                        <t t-if="props.showWeekNumbers ?? !props.range">
                            <div class="o_week_number_cell o_center o_cell_md o_text_sm bg-100 fw-bolder" t-att-class="{ 'border-bottom': !week_last }" t-esc="week.number"/>
                        </t>
                        <t t-foreach="week.days" t-as="itemInfo" t-key="itemInfo.id">
                            <t t-set="arInfo" t-value="getActiveRangeInfo(itemInfo)"/>
                            <t t-if="itemInfo.isOutOfRange">
                                <div class="o_date_item_cell o_out_of_range o_cell_md"/>
                            </t>
                            <t t-else="">
                                <button class="o_date_item_cell o_datetime_button o_center o_cell_md btn p-1 border-0 fw-normal" tabindex="-1" t-att-class="{                                         'o_selected': arInfo.isSelected,                                         o_select_start: arInfo.isSelectStart,                                         o_select_end: arInfo.isSelectEnd,                                         o_highlighted: arInfo.isHighlighted,                                         o_current: arInfo.isCurrent,                                         o_today: itemInfo.includesToday,                                         [itemInfo.extraClass]: true,                                     }" t-att-disabled="!itemInfo.isValid" t-on-pointerenter="() =&gt; (state.hoveredDate = itemInfo.range[0])" t-on-click="() =&gt; this.zoomOrSelect(itemInfo)">
                                    <span t-esc="itemInfo.label" class="z-1"/>
                                </button>
                            </t>
                        </t>
                    </t>
                </div>
            </t>
        </div>
        <div t-attf-class="position-relative d-flex flex-column flex-md-row gap-4 gap-md-3 {{ props.type === 'datetime' ? 'justify-content-center' : 'justify-content-end' }}">
            <div t-attf-class="d-flex gap-3 w-100 {{ props.type === 'datetime' ? 'justify-content-center' : 'd-none' }}">
                <t t-if="props.type === 'datetime'">
                    <t t-foreach="state.timeValues" t-as="timeValue" t-key="timeValue_index">
                        <div t-if="timeValue" class="o_time_picker d-flex align-items-center justify-content-center w-lg-50 w-100 gap-1">
                            <t t-call="web.DateTimePicker.Select">
                                <t t-set="unitIndex" t-value="0"/>
                                <t t-set="unitList" t-value="availableHours"/>
                            </t>
                            <span>:</span>
                            <t t-call="web.DateTimePicker.Select">
                                <t t-set="unitIndex" t-value="1"/>
                                <t t-set="unitList" t-value="availableMinutes"/>
                            </t>
                            <t t-if="availableSeconds.length">
                                <span>:</span>
                                <t t-call="web.DateTimePicker.Select">
                                    <t t-set="unitIndex" t-value="2"/>
                                    <t t-set="unitList" t-value="availableSeconds"/>
                                </t>
                            </t>
                            <t t-if="meridiems">
                                <t t-call="web.DateTimePicker.Select">
                                    <t t-set="unitIndex" t-value="3"/>
                                    <t t-set="unitList" t-value="meridiems"/>
                                </t>
                            </t>
                        </div>
                    </t>
                </t>
            </div>

            <div t-attf-class="o_datetime_buttons {{ props.type === 'datetime' ? 'position-md-absolute h-100 start-0' : '' }}">
                <t t-slot="bottom_left"/>
            </div>
            <div t-attf-class="o_datetime_buttons {{ props.type === 'datetime' ? 'position-md-absolute h-100 end-0' : '' }}">
                <t t-slot="buttons"/>
            </div>
        </div>
    </t>

    `);
registerTemplate("web.DateTimePicker.Grid", `/web/static/src/core/datetime/datetime_picker.xml`, `<t t-name="web.DateTimePicker.Grid" xml:space="preserve">
        <div class="o_date_item_picker d-grid">
            <t t-foreach="items" t-as="itemInfo" t-key="itemInfo.id">
                <t t-set="arInfo" t-value="getActiveRangeInfo(itemInfo)"/>
                <button class="o_date_item_cell o_datetime_button btn o_center o_cell_lg btn p-1 border-0" tabindex="-1" t-att-class="{                         o_selected: arInfo.isSelected,                         o_select_start: arInfo.isSelectStart,                         o_select_end: arInfo.isSelectEnd,                         o_highlighted: arInfo.isHighlighted,                         o_today: itemInfo.includesToday,                     }" t-att-disabled="!itemInfo.isValid" t-on-click="() =&gt; this.zoomOrSelect(itemInfo)">
                    <span t-esc="itemInfo.label" class="z-1"/>
                </button>
            </t>
        </div>
    </t>

    `);
registerTemplate("web.DateTimePicker.Select", `/web/static/src/core/datetime/datetime_picker.xml`, `<t t-name="web.DateTimePicker.Select" xml:space="preserve">

        <select class="o_time_picker_select form-control form-control-sm w-auto" tabindex="-1" t-model="timeValue[unitIndex]" t-on-change="() =&gt; this.selectTime(timeValue_index)">
            <option t-if="unitIndex === 1 and !!(timeValue[unitIndex] % props.rounding)" class="text-center" value="" selected="true"/>
            <t t-foreach="unitList" t-as="unit" t-key="unit[0]">
                <option class="text-center" t-att-value="unit[0]" t-esc="unit[1]" t-att-selected="timeValue[unitIndex] === unit[0].toString()"/>
            </t>
        </select>
    </t>

    `);
registerTemplate("web.DateTimePicker", `/web/static/src/core/datetime/datetime_picker.xml`, `<t t-name="web.DateTimePicker" xml:space="preserve">
        <div class="o_datetime_picker d-flex flex-column gap-2 user-select-none p-2 p-lg-3" t-attf-style="--DateTimePicker__Day-template-columns: {{ props.showWeekNumbers ?? !props.range ? 8 : 7 }}">
            <nav class="o_datetime_picker_header btn-group">
                <button class="o_previous btn btn-light flex-grow-0" t-on-click="previous" tabindex="-1">
                    <i class="oi oi-chevron-left" t-att-title="activePrecisionLevel.prevTitle"/>
                </button>
                <button class="o_zoom_out o_datetime_button btn d-flex align-items-center px-0 text-truncate justify-content-around" tabindex="-1" t-att-class="{ 'btn-light': !isLastPrecisionLevel }" t-att-title="!isLastPrecisionLevel and activePrecisionLevel.mainTitle" t-on-click="zoomOut">
                    <t t-foreach="titles" t-as="title" t-key="title">
                        <strong t-attf-class="o_header_part fs-5 {{ props.range ? 'flex-basis-50' : 'flex-basis-100' }}" t-esc="title"/>
                    </t>
                </button>
                <button class="o_next btn btn-light flex-grow-0" t-on-click="next" tabindex="-1">
                    <i class="oi oi-chevron-right" t-att-title="activePrecisionLevel.nextTitle"/>
                </button>
            </nav>
            <t t-if="state.precision === 'days'">
                <t t-call="web.DateTimePicker.Days"/>
            </t>
            <t t-else="">
                <t t-call="web.DateTimePicker.Grid"/>
            </t>
        </div>
    </t>
`);
registerTemplate("web.DateTimePickerPopover", `/web/static/src/core/datetime/datetime_picker_popover.xml`, `<t t-name="web.DateTimePickerPopover" xml:space="preserve">
        <DateTimePicker t-props="props.pickerProps">
            <t t-set-slot="buttons">
                <t t-if="isDateTimeRange">
                    <button class="o_apply btn btn-primary btn-sm h-100 w-100 w-md-auto d-flex align-items-center justify-content-center gap-1" tabindex="-1" t-on-click="props.close">
                        <i class="fa fa-check"/>
                        <span>Apply</span>
                    </button>
                </t>
            </t>
            <t t-set-slot="bottom_left">
                <t t-if="isDateTimeRange">
                    <button class="btn btn-secondary btn-sm h-100 w-100 w-md-auto d-flex align-items-center justify-content-center" tabindex="-1" t-on-click="props.close">
                        <span>Close</span>
                    </button>
                </t>
            </t>
        </DateTimePicker>
    </t>
`);
registerTemplate("web.DebugMenu", `/web/static/src/core/debug/debug_menu.xml`, `<t t-name="web.DebugMenu" xml:space="preserve">
        <div class="o_debug_manager">
            <Dropdown beforeOpen.bind="loadGroupedItems" position="'bottom-end'">
                <button t-att-class="\`o-dropdown--narrow \${env.inDialog?'btn btn-link':''}\`">
                    <i class="fa fa-bug" role="img" aria-label="Open developer tools"/>
                </button>
                <t t-set-slot="content">
                    <t t-foreach="sectionEntries" t-as="entry" t-key="entry[0]">
                        <div class="dropdown-menu_group dropdown-header">
                            <t t-esc="getSectionLabel(entry[0])"/>
                        </div>
                        <t t-foreach="entry[1]" t-as="element" t-key="element_index">
                            <DropdownItem t-if="element.type == 'item'" onSelected="element.callback" attrs="{ href: element.href }">
                                <span t-att-style="entry[0] and 'padding-left: 12px;'" t-esc="element.description"/>
                            </DropdownItem>
                            <t t-if="element.type == 'component'" t-component="element.Component" t-props="element.props"/>
                        </t>
                    </t>
                </t>
            </Dropdown>
        </div>
    </t>

`);
registerTemplate("web.DebugMenu.SetDefaultDialog", `/web/static/src/core/debug/debug_menu_items.xml`, `<t t-name="web.DebugMenu.SetDefaultDialog" xml:space="preserve">
        <Dialog title.translate="Set Default Values">
            <table style="width: 100%">
                <tr>
                    <td>
                        <label for="formview_default_fields" class="oe_label oe_align_right">
                            Default:
                        </label>
                    </td>
                    <td class="oe_form_required">
                        <select id="formview_default_fields" class="o_input" t-model="state.fieldToSet">
                            <option value=""/>
                            <option t-foreach="defaultFields" t-as="field" t-att-value="field.name" t-key="field.name">
                                <t t-esc="field.string"/> = <t t-esc="field.displayed"/>
                            </option>
                        </select>
                    </td>
                </tr>
                <tr t-if="conditions.length">
                    <td>
                        <label for="formview_default_conditions" class="oe_label oe_align_right">
                            Condition:
                        </label>
                    </td>
                    <td>
                        <select id="formview_default_conditions" class="o_input" t-model="state.condition">
                            <option value=""/>
                            <option t-foreach="conditions" t-as="cond" t-att-value="cond.name + '=' + cond.value" t-key="cond.name">
                                <t t-esc="cond.string"/>=<t t-esc="cond.displayed"/>
                            </option>
                        </select>
                    </td>
                </tr>
                <tr>
                    <td colspan="2">
                        <input type="radio" id="formview_default_self" value="self" name="scope" t-model="state.scope"/>
                        <label for="formview_default_self" class="oe_label" style="display: inline;">
                            Only you
                        </label>
                        <br/>
                        <input type="radio" id="formview_default_all" value="all" name="scope" t-model="state.scope"/>
                        <label for="formview_default_all" class="oe_label" style="display: inline;">
                            All users
                        </label>
                    </td>
                </tr>
            </table>
            <t t-set-slot="footer">
                <button class="btn btn-secondary" t-on-click="props.close">Close</button>
                <button class="btn btn-secondary" t-on-click="saveDefault">Save default</button>
            </t>
        </Dialog>
    </t>

    `);
registerTemplate("web.DebugMenu.GetMetadataDialog", `/web/static/src/core/debug/debug_menu_items.xml`, `<t t-name="web.DebugMenu.GetMetadataDialog" xml:space="preserve">
        <Dialog title.translate="Metadata">
            <table class="table table-sm table-striped">
                <tr>
                    <th>ID:</th>
                    <td><t t-esc="state.id"/></td>
                </tr>
                <tr>
                    <th>XML ID:</th>
                    <td>
                        <t t-if="state.xmlids.length &gt; 1">
                            <t t-foreach="state.xmlids" t-as="imd" t-key="imd['xmlid']">
                                <div t-att-class="&quot;p-0 &quot; + (imd[&quot;xmlid&quot;] === state.xmlid ? &quot;fw-bolder &quot; : &quot;&quot;) + (imd[&quot;noupdate&quot;] === true ? &quot;fst-italic &quot; : &quot;&quot;)" t-esc="imd['xmlid']"/>
                            </t>
                        </t>
                        <t t-elif="state.xmlid" t-esc="state.xmlid"/>
                        <t t-else="">
                            / <a t-on-click="onClickCreateXmlid"> (create)</a>
                        </t>
                    </td>
                </tr>
                <tr>
                    <th>No Update:</th>
                    <td>
                        <t t-esc="state.noupdate"/>
                        <t t-if="state.xmlid">
                            <a t-on-click="toggleNoupdate"> (change)</a>
                        </t>
                    </td>
                </tr>
                <tr>
                    <th>Creation User:</th>
                    <td><t t-esc="state.creator"/></td>
                </tr>
                <tr>
                    <th>Creation Date:</th>
                    <td><t t-esc="state.createDate"/></td>
                </tr>
                <tr>
                    <th>Latest Modification by:</th>
                    <td><t t-esc="state.lastModifiedBy"/></td>
                </tr>
                <tr>
                    <th>Latest Modification Date:</th>
                    <td><t t-esc="state.writeDate"/></td>
                </tr>
            </table>
        </Dialog>
    </t>

    `);
registerTemplate("web.DebugMenu.GetViewDialog", `/web/static/src/core/debug/debug_menu_items.xml`, `<t t-name="web.DebugMenu.GetViewDialog" xml:space="preserve">
        <Dialog title.translate="Get View">
            <pre t-esc="props.arch"/>
            <t t-set-slot="footer">
                <button class="btn btn-primary o-default-button" t-on-click="() =&gt; props.close()">Close</button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("web.Dialog", `/web/static/src/core/dialog/dialog.xml`, `<t t-name="web.Dialog" xml:space="preserve">
        <div class="o_dialog" t-att-id="id" t-att-class="{ o_inactive_modal: !data.isActive }">
            <div role="dialog" class="modal d-block" tabindex="-1" t-att-class="{ o_technical_modal: props.technical, o_modal_full: isFullscreen, o_inactive_modal: !data.isActive }" t-ref="modalRef">
                <div class="modal-dialog modal-dialog-centered" t-attf-class="modal-{{props.size}}">
                    <div class="modal-content" t-att-class="props.contentClass" t-att-style="contentStyle">
                        <header t-if="props.header" class="modal-header">
                            <t t-slot="header" close="data.close" isFullscreen="isFullscreen">
                                <t t-call="web.Dialog.header">
                                    <t t-set="fullscreen" t-value="isFullscreen"/>
                                    <t t-set="onExpand" t-value="props.onExpand"/>
                                </t>
                            </t>
                        </header>
                        <main class="modal-body" t-attf-class="{{ props.bodyClass }} {{ !props.withBodyPadding ? 'p-0': '' }}">
                            <t t-slot="default" close="() =&gt; this.data.close()"/>
                        </main>
                        <footer t-if="props.footer" class="modal-footer justify-content-around justify-content-md-start flex-wrap gap-1 w-100">
                            <t t-slot="footer" close="() =&gt; this.data.close()">
                                <button class="btn btn-primary o-default-button" t-on-click="() =&gt; this.data.close()">
                                    <t>Ok</t>
                                </button>
                            </t>
                        </footer>
                    </div>
                </div>
            </div>
        </div>
    </t>

    `);
registerTemplate("web.Dialog.header", `/web/static/src/core/dialog/dialog.xml`, `<t t-name="web.Dialog.header" xml:space="preserve">
        <t t-if="fullscreen">
            <button class="btn oi oi-arrow-left" data-bs-dismiss="modal" aria-label="Close" t-on-click="dismiss"/>
        </t>
        <h4 class="modal-title text-break flex-grow-1" t-att-class="{ 'me-auto': fullscreen }">
            <t t-esc="props.title"/>
        </h4>
        <t t-if="onExpand">
            <button type="button" class="fa fa-expand btn o_expand_button" aria-label="Expand" tabindex="-1" t-on-click="onExpand"/>
        </t>
        <t t-if="!fullscreen">
            <button type="button" class="btn-close" aria-label="Close" tabindex="-1" t-on-click="dismiss"/>
        </t>
    </t>
`);
registerTemplate("web.DomainSelector", `/web/static/src/core/domain_selector/domain_selector.xml`, `<t t-name="web.DomainSelector" xml:space="preserve">
        <div class="o_domain_selector w-100" aria-atomic="true" t-att-class="props.className">
            <t t-if="tree">
                <TreeEditor resModel="props.resModel" tree="tree" update.bind="update" readonly="props.readonly" isDebugMode="props.isDebugMode" defaultConnector="props.defaultConnector" getDefaultCondition.bind="getDefaultCondition" getOperatorEditorInfo.bind="getOperatorEditorInfo" getDefaultOperator.bind="getDefaultOperator" getPathEditorInfo.bind="getPathEditorInfo">
                    <CheckBox t-if="showArchivedCheckbox" value="includeArchived" disabled="props.readonly" className="'form-switch'" onChange.bind="toggleIncludeArchived">
                        Include archived
                    </CheckBox>
                </TreeEditor>
            </t>
            <t t-else="">
                <div class="o_domain_selector_row d-flex align-items-center">
                    This domain is not supported.
                    <t t-if="!props.readonly">
                        <button class="btn btn-sm btn-primary ms-2" t-on-click="() =&gt; this.resetDomain()">Reset domain</button>
                    </t>
                </div>
            </t>
            <t t-if="props.isDebugMode and (!tree or !props.readonly)">
                <label class="o_domain_selector_debug_container d-block mt-3 border rounded p-3 bg-100 text-muted font-monospace">
                    <span class="small"># Code editor</span>
                    <textarea class="pt-2 border-0 bg-transparent text-body" type="text" t-att-readonly="props.readonly" spellcheck="false" t-att-value="props.domain" t-on-input="(ev) =&gt; this.onDomainInput(ev.target.value)" t-on-change="(ev) =&gt; this.onDomainChange(ev.target.value)"/>
                </label>
            </t>
        </div>
    </t>

`);
registerTemplate("web.DomainSelectorDialog", `/web/static/src/core/domain_selector_dialog/domain_selector_dialog.xml`, `<t t-name="web.DomainSelectorDialog" xml:space="preserve">
        <Dialog title="dialogTitle">
            <div t-if="props.text" class="mb-3" t-out="props.text"/>
            <DomainSelector t-props="domainSelectorProps"/>
            <t t-set-slot="footer">
                <t t-if="props.readonly">
                    <button class="btn btn-secondary" t-on-click="() =&gt; props.close()">Close</button>
                </t>
                <t t-else="">
                    <button class="btn btn-primary" t-att-disabled="disabled" t-on-click="onConfirm" t-ref="confirm"><t t-esc="confirmButtonText"/></button>
                    <button class="btn btn-secondary" t-on-click="onDiscard"><t t-esc="discardButtonText"/></button>
                </t>
            </t>
        </Dialog>
    </t>

`);
registerTemplate("web.AccordionItem", `/web/static/src/core/dropdown/accordion_item.xml`, `<t t-name="web.AccordionItem" xml:space="preserve">
        <div class="o_accordion position-relative">
            <button class="o_menu_item o_accordion_toggle dropdown-item o-navigable" tabindex="0" t-att-class="{'selected': props.selected, 'open': state.open}" t-attf-class="{{ props.class }}" t-att-aria-expanded="state.open ? 'true' : 'false'" t-esc="props.description" t-on-click="() =&gt; state.open = !state.open"/>
            <t t-if="state.open">
                <div class="o_accordion_values ms-4 border-start">
                    <t t-slot="default"/>
                </div>
            </t>
        </div>
    </t>

`);
registerTemplate("web.DropdownItem", `/web/static/src/core/dropdown/dropdown_item.xml`, `<t t-name="web.DropdownItem" xml:space="preserve">
    <t t-tag="props.attrs and props.attrs.href ? 'a' : 'span'" class="o-dropdown-item dropdown-item o-navigable" t-att-class="props.class" t-on-click.stop="onClick" t-on-mouseenter="() =&gt; this.dropdownControl.closeChildren()" role="menuitem" tabindex="0" t-att="props.attrs">
      <t t-slot="default"/>
    </t>
  </t>


  `);
registerTemplate("web.CheckboxItem", `/web/static/src/core/dropdown/dropdown_item.xml`, `<t t-name="web.CheckboxItem" t-inherit="web.DropdownItem" t-inherit-mode="primary" xml:space="preserve">
    <xpath expr="//t[@role='menuitem']" position="attributes">
      <attribute name="role">menuitemcheckbox</attribute>
      <attribute name="t-att-aria-checked">props.checked ? 'true' : 'false'</attribute>
    </xpath>
  </t>

`);
registerTemplate("web.Dropzone", `/web/static/src/core/dropzone/dropzone.xml`, `<t t-name="web.Dropzone" xml:space="preserve">
    <div class="o-Dropzone position-fixed align-items-center justify-content-center d-flex border-primary bg-100 text-primary opacity-75" t-att-class="{ 'o-dragging-inside': state.isDraggingInside }" t-attf-class="{{ props.extraClass }}" t-on-dragenter="() =&gt; state.isDraggingInside = true" t-on-dragleave="() =&gt; state.isDraggingInside = false" t-on-drop="props.onDrop" t-ref="root">
        <t t-slot="default">
            <h4>Drag Files Here <i class="fa fa-download"/></h4>
        </t>
    </div>
</t>

`);
registerTemplate("web.RainbowMan", `/web/static/src/core/effects/rainbow_man.xml`, `<t t-name="web.RainbowMan" xml:space="preserve">
        <div class="o_reward position-fixed top-0 start-0 w-100 h-100" t-att-class="{ o_reward_fading: state.isFading }" t-on-animationend="onAnimationEnd">
            <svg class="o_reward_rainbow_man position-absolute top-0 bottom-0 start-0 end-0 m-auto overflow-visible" viewBox="0 0 400 400">
                <defs>
                    <radialGradient id="o_reward_gradient_bg" cx="200" cy="200" r="200" gradientUnits="userSpaceOnUse">
                        <stop offset="0.3" stop-color="#edeff4"/>
                        <stop offset="1" stop-color="#edeff4" stop-opacity="0"/>
                    </radialGradient>
                    <symbol id="o_reward_star">
                        <path d="M33 15.9C26.3558 13.6951 21.1575 8.4597 19 1.8 19 1.2477 18.5523.8 18 .8 17.4477.8 17 1.2477 17 1.8 14.6431 8.6938 9.0262 13.9736 2 15.9 1.3649 15.9.85 16.4149.85 17.05.85 17.6851 1.3649 18.2 2 18.2 8.6215 20.3845 13.8155 25.5785 16 32.2 16 32.7523 16.4477 33.2 17 33.2 17.5523 33.2 18 32.7523 18 32.2 20.3569 25.3062 25.9738 20.0264 33 18.1 33.6351 18.1 34.15 17.5851 34.15 16.95 34.15 16.3149 33.6351 15.8 33 15.8" fill="#FFFFFF"/>
                    </symbol>
                    <symbol id="o_reward_thumb">
                        <path d="M10 52C6 51 3 48 3 44 2 42 3 39 5 38 3 36 2 34 2 32 2 29 3 27 5 26 3 24 2 21 2 19 2 15 7 12 10 12L23 12C23 11 23 11 23 11L23 10C23 8 24 6 25 4 27 2 29 2 31 2 33 2 35 2 36 4 38 5 39 7 39 10L39 38C39 41 37 45 35 47 32 50 28 51 25 52L10 52 10 52Z" fill="#FBFBFC"/>
                        <polygon fill="#ECF1FF" points="25 11 25 51 5 52 5 12"/>
                        <path d="M31 0C28 0 26 1 24 3 22 5 21 7 21 10L10 10C8 10 6 11 4 12 2 14 1 16 1 19 1 21 1 24 2 26 1 27 1 29 1 32 1 34 1 36 2 38 1 40 0 42 1 45 1 50 5 53 10 54L25 54C29 54 33 52 36 49 39 46 41 42 41 38L41 10C41 4 36 0 31 0M31 4C34 4 37 6 37 10L37 38C37 41 35 44 33 46 31 48 28 49 25 50L10 50C7 49 5 47 5 44 4 41 6 38 9 37L9 37C6 37 5 35 5 32 5 28 6 26 9 26L9 26C6 26 5 22 5 19 5 16 8 14 11 14L23 14C24 14 25 12 25 11L25 10C25 7 28 4 31 4" fill="#A1ACBA"/>
                    </symbol>
                </defs>
                <rect width="400" height="400" fill="url(#o_reward_gradient_bg)"/>
                <g transform="translate(47 45) scale(0.9)" class="o_reward_rainbow">
                    <path d="M270,170a100,100,0,0,0-200,0" class="o_reward_rainbow_line" stroke="#FF9E80" stroke-linecap="round" stroke-width="21" fill="none" stroke-dasharray="600 600" stroke-dashoffset="-600"/>
                    <path d="M290,170a120,120,0,0,0-240,0" class="o_reward_rainbow_line" stroke="#FFE57F" stroke-linecap="round" stroke-width="21" fill="none" stroke-dasharray="600 600" stroke-dashoffset="-600"/>
                    <path d="M310,170a140,140,0,0,0-280,0" class="o_reward_rainbow_line" stroke="#80D8FF" stroke-linecap="round" stroke-width="21" fill="none" stroke-dasharray="600 600" stroke-dashoffset="-600"/>
                    <path d="M330,170a160,160,0,0,0-320,0" class="o_reward_rainbow_line" stroke="#C794BA" stroke-linecap="round" stroke-width="21" fill="none" stroke-dasharray="600 600" stroke-dashoffset="-600"/>
                </g>
                <g transform="translate(80 125)">
                    <use href="#o_reward_star" transform-origin="center" class="o_reward_box o_reward_star_01"/>
                </g>
                <g transform="translate(140 75)">
                    <use href="#o_reward_star" transform-origin="center" class="o_reward_box o_reward_star_02"/>
                </g>
                <g transform="translate(230 90)">
                    <use href="#o_reward_star" transform-origin="center" class="o_reward_box o_reward_star_03"/>
                </g>
                <g transform="translate(275 120)">
                    <use href="#o_reward_star" transform-origin="center" class="o_reward_box o_reward_star_04"/>
                </g>
                <g class="o_reward_face_group o_reward_box" transform-origin="center top">
                    <g class="o_reward_shadow_container o_reward_box">
                        <ellipse class="o_reward_shadow o_reward_box" cx="200" cy="105%" rx="100" ry="6" fill="#000" opacity="0.25" transform-origin="center"/>
                    </g>
                    <g class="o_reward_face_wrap o_reward_box" transform-origin="center">
                        <image class="o_reward_face" x="132" y="125" width="136" height="136" t-attf-href="{{props.imgUrl}}"/>
                    </g>
                    <g transform="translate(258 174)">
                        <use href="#o_reward_thumb" class="o_reward_box o_reward_thumbup" transform-origin="center"/>
                    </g>
                </g>
            </svg>
            <div class="o_reward_rainbow_man o_reward_msg_container position-absolute top-0 bottom-0 start-0 end-0 m-auto">
                <div class="o_reward_face_group h-100 w-75 mx-auto">
                    <svg viewBox="0 0 42 60" preserveAspectRatio="xMinYMax meet" width="37" height="65%" class="overflow-visible position-relative ms-5">
                        <g class="o_reward_box">
                            <use href="#o_reward_thumb" x="-60%" y="0" transform="rotate(-90) scale(1 -1)" transform-origin="center"/>
                        </g>
                    </svg>
                    <div class="o_reward_msg mx-4">
                        <div class="o_reward_msg_card">
                            <div class="o_reward_msg_content text-muted px-3 py-4 bg-view d-inline-block border border-light border-top-0">
                                <t t-if="!props.Component">
                                    <t t-out="props.message"/>
                                </t>
                                <t t-else="" t-component="props.Component" t-props="props.props"/>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("web.EmojiPicker", `/web/static/src/core/emoji_picker/emoji_picker.xml`, `<t t-name="web.EmojiPicker" xml:space="preserve">
    <div class="o-EmojiPicker d-flex flex-column justify-content-center rounded-3 bg-100" t-att-class="{ 'align-items-center': emojis.length === 0 }" t-on-click="onClick" t-on-keydown="onKeydown">
        <t t-if="emojis.length === 0">
            <span class="o-EmojiPicker-empty">😵‍💫</span>
            <span class="fs-5 text-muted">Failed to load emojis...</span>
        </t>
        <t t-else="">
            <div class="o-EmojiPicker-search d-flex align-items-center mx-2 mt-2 rounded">
                <span class="d-flex mx-1 w-100 rounded o-active align-items-center justify-content-center border border-secondary bg-white">
                    <t t-call="web.EmojiPicker.searchInput">
                        <t t-if="props.state" t-set="localState" t-value="props.state"/>
                        <t t-else="" t-set="localState" t-value="state"/>
                    </t>
                    <i class="oi oi-search px-2 py-1 fs-7 rounded-start-0 rounded-3 o-active opacity-50" title="Search..." role="img" aria-label="Search..."/>
                </span>
            </div>
            <t t-set="itemIndex" t-value="0"/>
            <t t-set="emojisFromSearch" t-value="getEmojisFromSearch()"/>
            <div class="o-EmojiPicker-content overflow-auto d-flex flex-grow-1 w-100 flex-wrap align-items-center user-select-none mt-1" t-att-class="emojisFromSearch.length === 0 ? 'flex-column justify-content-center' : 'align-content-start'" t-ref="emoji-grid" t-on-scroll="highlightActiveCategory">
                <t t-if="searchTerm and emojisFromSearch.length === 0" class="d-flex flex-column">
                    <span class="o-EmojiPicker-empty">😢</span>
                    <span class="fs-5 text-muted">No emoji matches your search</span>
                </t>
                <t t-if="recentEmojis.length &gt; 0">
                    <t t-if="!searchTerm" t-call="web.EmojiPicker.section">
                        <t t-set="category" t-value="recentCategory"/>
                    </t>
                    <t t-foreach="recentEmojis" t-as="emoji" t-key="'recent_' + emoji_index">
                        <t t-call="web.EmojiPicker.emoji">
                            <t t-set="inRecent" t-value="true"/>
                            <t t-set="emoji" t-value="emoji"/>
                        </t>
                        <t t-set="itemIndex" t-value="itemIndex + 1"/>
                    </t>
                </t>
                <t t-set="current" t-value=""/>
                <t t-foreach="getEmojis()" t-as="emoji" t-key="emoji_index">
                    <t t-if="!searchTerm and current !== emoji.category">
                        <t t-set="current" t-value="emoji.category"/>
                        <t t-set="category" t-value="categories.find(c =&gt; c.name === current)"/>
                        <t t-call="web.EmojiPicker.section">
                            <t t-set="category" t-value="category"/>
                        </t>
                    </t>
                    <t t-elif="searchTerm" t-set="categorySortId" t-value="null"/>
                    <t t-call="web.EmojiPicker.emoji">
                        <t t-set="emoji" t-value="emoji"/>
                    </t>
                    <t t-set="itemIndex" t-value="itemIndex + 1"/>
                </t>
            </div>
            <div class="o-EmojiPicker-navbar d-flex flex-shrink-0 w-100 align-items-center justify-content-center overflow-auto px-1 gap-1 border-top border-secondary" t-att-class="{ 'opacity-0': !state.emojiNavbarRepr }" t-ref="navbar">
                <t t-if="currentNavbarPanel">
                    <t t-set="allCategories" t-value="getAllCategories()"/>
                    <t t-foreach="currentNavbarPanel" t-as="navbarItemId" t-key="navbarItemId">
                        <t t-if="navbarItemId === 'next'" t-call="web.EmojiPicker.tabNext"/>
                        <t t-elif="navbarItemId === 'previous'" t-call="web.EmojiPicker.tabPrev"/>
                        <t t-elif="typeof navbarItemId === 'string' and navbarItemId.startsWith('empty')" t-call="web.EmojiPicker.tabEmpty"/>
                        <t t-else="">
                            <t t-set="category" t-value="allCategories.find(cat =&gt; cat.sortId === navbarItemId)"/>
                            <t t-if="category" t-call="web.EmojiPicker.tab">
                                <t t-set="category" t-value="category"/>
                            </t>
                        </t>
                    </t>
                </t>
            </div>
        </t>
    </div>
</t>

`);
registerTemplate("web.EmojiPicker.tab", `/web/static/src/core/emoji_picker/emoji_picker.xml`, `<t t-name="web.EmojiPicker.tab" xml:space="preserve">
    <span class="o-Emoji text-center fs-5 rounded-3 cursor-pointer d-flex align-items-center align-self-stretch" t-att-class="{'o-active': category.sortId === state.categoryId}" t-att-title="category.name" t-att-data-id="category.sortId" t-on-click="() =&gt; this.selectCategory(category.sortId)">
        <span t-esc="category.title"/>
    </span>
</t>

`);
registerTemplate("web.EmojiPicker.tabNext", `/web/static/src/core/emoji_picker/emoji_picker.xml`, `<t t-name="web.EmojiPicker.tabNext" xml:space="preserve">
    <span class="o-Emoji text-center fs-5 rounded-3 cursor-pointer d-flex align-items-center align-self-stretch" title="To previous categories" t-on-click="onClickToNextCategories">
        <span class="position-relative">
            <i class="oi oi-chevron-right fa-fw smaller opacity-0"/>
            <i class="oi oi-chevron-right fa-fw smaller position-absolute opacity-75" style="left: 3px; transform: translateY(75%);"/>
            <i class="oi oi-chevron-right fa-fw smaller position-absolute opacity-75" style="left: -3px; transform: translateY(75%);"/>
        </span>
    </span>
</t>

`);
registerTemplate("web.EmojiPicker.tabPrev", `/web/static/src/core/emoji_picker/emoji_picker.xml`, `<t t-name="web.EmojiPicker.tabPrev" xml:space="preserve">
    <span class="o-Emoji text-center fs-5 rounded-3 cursor-pointer d-flex align-items-center align-self-stretch" title="To next categories" t-on-click="onClickToPreviousCategories">
        <span class="position-relative">
            <i class="oi oi-chevron-left fa-fw smaller opacity-0"/>
            <i class="oi oi-chevron-left fa-fw smaller position-absolute opacity-75" style="left: 3px; transform: translateY(75%);"/>
            <i class="oi oi-chevron-left fa-fw smaller position-absolute opacity-75" style="left: -3px; transform: translateY(75%);"/>
        </span>
    </span>
</t>

`);
registerTemplate("web.EmojiPicker.tabEmpty", `/web/static/src/core/emoji_picker/emoji_picker.xml`, `<t t-name="web.EmojiPicker.tabEmpty" xml:space="preserve">
    <span class="o-Emoji text-center fs-5 rounded-3 cursor-pointer d-flex align-items-center align-self-stretch opacity-0">
        <span>🫥</span>
    </span>
</t>

`);
registerTemplate("web.EmojiPicker.section", `/web/static/src/core/emoji_picker/emoji_picker.xml`, `<t t-name="web.EmojiPicker.section" xml:space="preserve">
    <span class="w-100 fs-7 px-2 py-1 position-sticky top-0 bg-100 align-self-stretch" t-att-data-category="category.sortId"><span class="o-EmojiPicker-sectionIcon fs-5 opacity-50" t-esc="category.title"/><span class="ms-2 text-muted text-uppercase fs-7 opacity-50" t-esc="category.displayName"/></span>
    <span class="o-EmojiPicker-category opacity-100 fs-7 py-2" t-att-data-category="category.sortId"/>
</t>

`);
registerTemplate("web.EmojiPicker.emoji", `/web/static/src/core/emoji_picker/emoji_picker.xml`, `<t t-name="web.EmojiPicker.emoji" xml:space="preserve">
    <span class="o-Emoji cursor-pointer d-flex justify-content-center rounded-3 align-items-center align-self-stretch" t-att-class="{ 'o-active': state.activeEmojiIndex === itemIndex, 'fs-2': !ui.isSmall, 'fs-1': ui.isSmall }" t-att-title="emoji.name" t-att-data-codepoints="emoji.codepoints" t-att-data-index="itemIndex" t-att-data-category="inRecent ? recentCategory.sortId : categories.find(c =&gt; c.name === emoji.category).sortId" t-on-click="selectEmoji">
        <span t-esc="emoji.codepoints"/>
    </span>
</t>

`);
registerTemplate("web.EmojiPicker.searchInput", `/web/static/src/core/emoji_picker/emoji_picker.xml`, `<t t-name="web.EmojiPicker.searchInput" xml:space="preserve">
    <input class="form-control border-0 flex-grow-1 rounded-3 rounded-end-0 o-active lh-1" placeholder="Search emoji" t-model="localState.searchTerm" t-ref="autofocus" t-att-model="localState.searchTerm" t-on-input="() =&gt; this.state.activeEmojiIndex = 0" t-att-tabindex="isMobileOS ? -1 : 0"/>
</t>

`);
registerTemplate("web.WarningDialog", `/web/static/src/core/errors/error_dialogs.xml`, `<t t-name="web.WarningDialog" xml:space="preserve">
        <Dialog title="title" size="'xl'" contentClass="'o_error_dialog'">
            <div role="alert">
                <p t-esc="message" class="text-prewrap"/>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary o-default-button" t-on-click="props.close">Close</button>
            </t>
        </Dialog>
    </t>

    `);
registerTemplate("web.RedirectWarningDialog", `/web/static/src/core/errors/error_dialogs.xml`, `<t t-name="web.RedirectWarningDialog" xml:space="preserve">
        <Dialog title="title" size="'xl'" contentClass="'o_error_dialog'">
            <div role="alert">
                <p t-esc="message" class="text-prewrap"/>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="onClick" t-esc="buttonText"/>
                <button class="btn btn-secondary" t-on-click="props.close">Close</button>
            </t>
        </Dialog>
    </t>

    `);
registerTemplate("web.Error504Dialog", `/web/static/src/core/errors/error_dialogs.xml`, `<t t-name="web.Error504Dialog" xml:space="preserve">
        <Dialog title.translate="Request timeout" size="'xl'" contentClass="'o_error_dialog'">
            <div role="alert">
                <p class="text-prewrap">
                    The operation was interrupted. This usually means that the current operation is taking too much time.
                </p>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary o-default-button" t-on-click="props.close">Close</button>
            </t>
        </Dialog>
    </t>

    `);
registerTemplate("web.SessionExpiredDialog", `/web/static/src/core/errors/error_dialogs.xml`, `<t t-name="web.SessionExpiredDialog" xml:space="preserve">
        <Dialog title.translate="Odoo Session Expired" size="'xl'" contentClass="'o_error_dialog'">
            <div role="alert">
                <p class="text-prewrap">
                    Your Odoo session expired. The current page is about to be refreshed.
                </p>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary o-default-button" t-on-click="onClick">Close</button>
            </t>
        </Dialog>
    </t>

    `);
registerTemplate("web.ErrorDialog", `/web/static/src/core/errors/error_dialogs.xml`, `<t t-name="web.ErrorDialog" xml:space="preserve">
        <Dialog title.translate="Oops!" size="'xl'" contentClass="'o_error_dialog'">
            <div role="alert">
                <p class="text-prewrap">
                    Something went wrong... If you really are stuck, share the report with your friendly support service
                </p>
                <button class="btn btn-link p-0" t-on-click="() =&gt; { state.showTraceback = !state.showTraceback }" t-esc="state.showTraceback ? this.constructor.hideTracebackButtonText : this.constructor.showTracebackButtonText"/>
                <div t-if="state.showTraceback" class="bg-100 mb-0 clearfix mt-3 position-relative o_error_detail">
                    <button class="btn position-absolute bg-100" t-ref="copyButton" t-on-click="onClickClipboard">
                        <span class="fa fa-clone"/>
                    </button>
                    <div class="ps-3 pt-3">
                        <p class="m-0"><b t-esc="title or this.constructor.title"/></p>
                        <code t-if="props.name" t-esc="props.name"/>
                        <p class="m-0" t-if="props.message" t-esc="props.message"/>
                        <p class="m-0" t-if="contextDetails" t-esc="contextDetails"/>
                        <pre class="m-0 p-0 mt-2" t-esc="traceback or props.traceback"/>
                    </div>
                </div>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary o-default-button" t-on-click="props.close">Close</button>
            </t>
        </Dialog>
    </t>

`);
registerTemplateExtension("web.ErrorDialog", `/documents/static/src/web/error_dialog/error_dialog_patch.xml`, `<t t-inherit="web.ErrorDialog" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//t[@t-set-slot='footer']//button" position="after">
            <button t-if="canUploadTraceback" class="btn btn-secondary ms-auto ms-md-2" t-on-click="shareTraceback" t-att-disabled="state.processed">
                Share
            </button>
            <div t-if="state.tracebackUrl" class="o_field_widget o_readonly_modifier o_field_CopyClipboardChar ms-0 ms-md-2 w-md-auto w-100">
                <div class="d-grid rounded-2 overflow-hidden">
                    <span t-out="state.tracebackUrl"/>
                    <CopyButton className="'o_btn_char_copy btn-sm'" content="state.tracebackUrl" icon="'fa-clone'" successText.translate="The document URL has been copied to your clipboard."/>
                </div>
            </div>
        </xpath>
    </t>
`);
registerTemplate("web.ExpressionEditor", `/web/static/src/core/expression_editor/expression_editor.xml`, `<t t-name="web.ExpressionEditor" xml:space="preserve">
        <div class="o_expression_editor w-100" aria-atomic="true">
            <t t-if="tree">
                <TreeEditor resModel="props.resModel" tree="tree" isDebugMode="isDebugMode" update.bind="update" getDefaultCondition.bind="getDefaultCondition" getDefaultOperator.bind="getDefaultOperator" getOperatorEditorInfo.bind="getOperatorEditorInfo" getPathEditorInfo.bind="getPathEditorInfo"/>
            </t>
            <t t-else="">
                This expression is not supported.
                <button t-on-click="() =&gt; this.resetExpression()">Reset expression</button>
            </t>
            <t t-if="isDebugMode">
                <div class="o_expression_editor_debug_container d-block mt-3 border rounded p-3 bg-100 text-muted font-monospace">
                    <span class="small"># Code editor</span>
                    <textarea class="pt-2 border-0 bg-transparent text-body" type="text" spellcheck="false" t-att-value="props.expression" t-on-change="(ev) =&gt; this.onExpressionChange(ev.target.value)"/>
                </div>
            </t>
        </div>
    </t>

`);
registerTemplate("web.ExpressionEditorDialog", `/web/static/src/core/expression_editor_dialog/expression_editor_dialog.xml`, `<t t-name="web.ExpressionEditorDialog" xml:space="preserve">
        <Dialog title.translate="Edit Condition">
            <ExpressionEditor t-props="expressionEditorProps"/>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="onConfirm" t-ref="confirm">Confirm</button>
                <button class="btn btn-secondary" t-on-click="onDiscard">Discard</button>
            </t>
        </Dialog>
    </t>

`);
registerTemplate("web.FileInput", `/web/static/src/core/file_input/file_input.xml`, `<t t-name="web.FileInput" xml:space="preserve">
        <span class="o_file_input" t-att-class="{ 'd-none': props.hidden, 'show opacity-50 pe-none': state.isDisable}" aria-atomic="true">
            <span t-if="!props.hidden" class="o_file_input_trigger" t-on-click.prevent="onTriggerClicked">
                <t t-slot="default">
                    <button class="btn btn-primary">Choose File</button>
                </t>
            </span>
            <input type="file" name="ufile" class="o_input_file d-none" t-att-multiple="props.multiUpload" t-att-accept="props.acceptedFileExtensions" t-ref="file-input" t-att-disabled="state.isDisable" t-on-change="onFileInputChange"/>
        </span>
    </t>

`);
registerTemplate("web.FileUploadProgressBar", `/web/static/src/core/file_upload/file_upload_progress_bar.xml`, `<t t-name="web.FileUploadProgressBar" xml:space="preserve">
        <div class="position-absolute top-0 start-0 h-100 w-100">
            <div class="o-file-upload-progress-bar-value h-100" t-ref="bar" t-att-style="'width: ' + (this.props.fileUpload.progress * 100) + '%;'"/>
            <span class="position-absolute top-0 end-0 cursor-pointer o-file-upload-progress-bar-abort fa fa-times-circle" title="Cancel Upload" aria-label="Cancel Upload" t-on-click.stop.prevent="onCancel"/>
        </div>
    </t>
`);
registerTemplate("web.FileUploadProgressContainer", `/web/static/src/core/file_upload/file_upload_progress_container.xml`, `<t t-name="web.FileUploadProgressContainer" xml:space="preserve">
        <t t-foreach="Object.values(props.fileUploads)" t-as="fileUpload" t-key="fileUpload.id">
            <t t-if="!props.shouldDisplay || props.shouldDisplay(fileUpload)" t-component="props.Component" fileUpload="fileUpload" selector="props.selector"/>
        </t>
    </t>
`);
registerTemplate("web.FileUploadProgressKanbanRecord", `/web/static/src/core/file_upload/file_upload_progress_record.xml`, `<t t-name="web.FileUploadProgressKanbanRecord" xml:space="preserve">
        <t t-set="progressTexts" t-value="getProgressTexts()"/>
        <div class="o_kanban_record d-flex flex-grow-1 flex-md-shrink-1 flex-shrink-0">
            <div class="o_kanban_progress_card o_kanban_attachment position-relative p-0 cursor-pointer">
                <div class="o_kanban_image">
                    <div class="o_kanban_image_wrapper">
                        <div class="o_image o_image_thumbnail" t-att-data-mimetype="props.fileUpload.type"/>
                    </div>
                </div>
                <div class="o_kanban_details">
                    <div class="o_kanban_details_wrapper">
                        <div t-att-title="props.fileUpload.title" t-att-aria-label="props.fileUpload.title" class="o_kanban_record_title">
                            <span t-esc="props.fileUpload.title"/>
                        </div>
                        <div class="o_kanban_record_body"/>
                        <div class="o_kanban_record_bottom">
                            <div class="oe_kanban_bottom_left">
                                <div class="o_file_upload_progress_text_left" t-esc="progressTexts.left"/>
                            </div>
                            <div class="oe_kanban_bottom_right">
                                <span class="o_file_upload_progress_text_right" t-esc="progressTexts.right"/>
                            </div>
                        </div>
                    </div>
                </div>
                <FileUploadProgressBar fileUpload="props.fileUpload"/>
            </div>
        </div>
    </t>

    `);
registerTemplate("web.FileUploadProgressDataRow", `/web/static/src/core/file_upload/file_upload_progress_record.xml`, `<t t-name="web.FileUploadProgressDataRow" xml:space="preserve">
        <t t-set="progressTexts" t-value="getProgressTexts()"/>
        <div class="o_data_row o_list_progress_card position-relative align-middle p-0">
            <span class="o_file_upload_upload_title" t-esc="props.fileUpload.title"/>
            <span class="o_file_upload_progress_text_left" t-esc="progressTexts.left"/>
            <span class="o_file_upload_progress_text_right" t-esc="progressTexts.right"/>
            <FileUploadProgressBar fileUpload="props.fileUpload"/>
        </div>
    </t>

`);
registerTemplate("web.FileViewer", `/web/static/src/core/file_viewer/file_viewer.xml`, `<t t-name="web.FileViewer" xml:space="preserve">
        <div class="d-flex justify-content-center" t-att-class="{ 'modal modal-fullscreen': props.modal }">
            <div class="o-FileViewer flex-column align-items-center d-flex w-100 h-100" tabindex="0" t-ref="autofocus" t-on-keydown.stop="(ev) =&gt; this.onKeydown(ev)">
                <div class="o-FileViewer-header position-absolute top-0 d-flex w-100" t-on-click.stop="">
                    <div t-if="isViewable" class="d-flex align-items-center ms-4 me-2">
                        <i t-if="state.file.isImage" class="fa fa-picture-o" role="img" title="Image"/>
                        <i t-if="state.file.isPdf" class="fa fa-file-text" role="img" title="PDF file"/>
                        <i t-if="state.file.isText" class="fa fa-file-text" role="img" title="Text file"/>
                        <i t-if="state.file.isVideo" class="fa fa-video-camera" role="img" title="Video"/>
                    </div>
                    <div class="d-flex align-items-center ms-4 overflow-auto">
                        <span class="text-truncate" t-out="state.file.displayName"/>
                    </div>
                    <div class="flex-grow-1"/>
                    <div class="o-FileViewer-download o-FileViewer-headerButton d-flex align-items-center px-3 cursor-pointer" role="button" title="Download" t-on-click.stop="">
                        <a t-att-href="state.file.downloadUrl" class="text-reset d-flex align-items-baseline" download="">
                            <i class="fa fa-download fa-fw me-1" role="img"/>
                            <span>Download</span>
                        </a>
                    </div>

                    <div t-on-click.stop="close" class="o-FileViewer-headerButton d-flex align-items-center mb-0 px-3 h4 text-reset cursor-pointer" role="button" title="Close (Esc)" aria-label="Close">
                        <i class="fa fa-fw fa-times" role="img"/>
                    </div>
                </div>
                <div t-on-click.stop="close" t-on-mousemove="onMousemoveView" class="o-FileViewer-main position-absolute top-0 bottom-0 start-0 end-0 align-items-center justify-content-center d-flex" t-att-class="{ 'o_with_img overflow-hidden': state.file.isImage }">
                    <div t-if="state.file.isImage" class="o-FileViewer-zoomer position-absolute align-items-center justify-content-center d-flex w-100 h-100" t-ref="zoomer">
                        <div t-if="!state.imageLoaded" class="position-absolute">
                            <i class="fa fa-3x fa-circle-o-notch fa-fw fa-spin text-white" role="img" title="Loading"/>
                        </div>
                        <img t-on-click.stop="" t-on-load="onImageLoaded" t-on-wheel="onWheelImage" t-on-mousedown.stop="onMousedownImage" t-on-mouseup.stop="onMouseupImage" class="o-FileViewer-view o-FileViewer-viewImage mw-100 mh-100 transition-base" t-att-src="state.file.defaultSource" t-att-style="imageStyle" draggable="false" alt="Viewer" t-ref="image"/>
                    </div>
                    <iframe t-if="state.file.isPdf" class="o-FileViewer-view w-75 h-100 border-0" t-ref="iframeViewerPdf" t-att-class="{ 'w-100': ui.isSmall }" t-att-src="state.file.defaultSource"/>
                    <iframe t-if="state.file.isText" class="o-FileViewer-view o-isText o_text w-75 h-100 border-0" t-att-src="state.file.defaultSource"/>
                    <iframe t-if="state.file.isUrlYoutube" allow="autoplay; encrypted-media" class="o-FileViewer-view w-75 h-100 border-0" t-att-src="state.file.defaultSource" height="315" width="560"/>
                    <video t-if="state.file.isVideo" class="o-FileViewer-view w-75 h-75" t-att-class="{ 'w-100 h-100': ui.isSmall }" t-on-click.stop="" controls="controls">
                        <source t-att-data-type="state.file.mimetype" t-att-src="state.file.defaultSource"/>
                    </video>
                </div>
                <div t-if="state.file.isImage" class="position-absolute bottom-0 d-flex" role="toolbar">
                    <div class="o-FileViewer-toolbarButton p-3 rounded-0" t-on-click.stop="zoomIn" title="Zoom In (+)" role="button">
                        <i class="fa fa-fw fa-plus" role="img"/>
                    </div>
                    <div class="o-FileViewer-toolbarButton p-3 rounded-0" t-att-class="{ 'o_disabled opacity-50': state.scale === 1 }" t-on-click.stop="resetZoom" role="button" title="Reset Zoom (0)">
                        <i class="fa fa-fw fa-search" role="img"/>
                    </div>
                    <div class="o-FileViewer-toolbarButton p-3 rounded-0" t-att-class="{ 'o_disabled opacity-50': state.scale === minScale }" t-on-click.stop="zoomOut" title="Zoom Out (-)" role="button">
                        <i class="fa fa-fw fa-minus" role="img"/>
                    </div>
                    <div class="o-FileViewer-toolbarButton p-3 rounded-0" t-on-click.stop="rotate" title="Rotate (r)" role="button">
                        <i class="fa fa-fw fa-repeat" role="img"/>
                    </div>
                    <div class="o-FileViewer-toolbarButton p-3 rounded-0" t-on-click.stop="onClickPrint" title="Print" role="button">
                        <i class="fa fa-fw fa-print" role="img"/>
                    </div>
                    <div class="o-FileViewer-download o-FileViewer-toolbarButton p-3 rounded-0 cursor-pointer" title="Download" role="button" t-on-click.stop="">
                        <a t-att-href="state.file.downloadUrl" class="text-reset" download="">
                            <i class="fa fa-download fa-fw" role="img"/>
                        </a>
                    </div>
                </div>
                <t t-if="props.files.length &gt; 1">
                    <div class="o-FileViewer-navigation position-absolute top-0 bottom-0 start-0 align-items-center justify-content-center d-flex my-auto ms-3 rounded-circle bg-dark text-white" t-on-click.stop="previous" title="Previous (Left-Arrow)" aria-label="Previous" role="button">
                        <span class="oi oi-chevron-left" role="img"/>
                    </div>
                    <div class="o-FileViewer-navigation position-absolute top-0 bottom-0 end-0 align-items-center justify-content-center d-flex my-auto me-3 rounded-circle bg-dark text-white" t-on-click.stop="next" title="Next (Right-Arrow)" aria-label="Next" role="button">
                        <span class="oi oi-chevron-right" role="img"/>
                    </div>
                </t>
            </div>
        </div>
    </t>

`);
registerTemplate("web.InstallScopedApp", `/web/static/src/core/install_scoped_app/install_scoped_app.xml`, `<t t-name="web.InstallScopedApp" xml:space="preserve">
        <div class="o_install_scoped_app o_home_menu_background h-100 w-100 d-flex align-items-center justify-content-center user-select-none">
            <button class="btn btn-link m-1 position-absolute start-0 top-0" t-on-click="() =&gt; window.close()">
                <svg xmlns="http://www.w3.org/2000/svg" style="transform:rotate(135deg);" width="28" height="28" viewBox="-7 -7 24 24" preserveAspectRatio="xMinYMin">
                    <path fill="#000" d="M8 8V1a1 1 0 1 1 2 0v8a1 1 0 0 1-1 1H1a1 1 0 1 1 0-2h7z"/>
                </svg>
            </button>
            <i t-if="!state.showInstallUI" class="fa fa-spinner fa-spin fa-2x text-primary position-absolute"/>
            <div t-attf-class="h-100 w-100 d-flex align-items-center justify-content-center flex-column fade {{state.showInstallUI ? 'show': ''}}">
                <div class="d-flex align-items-center justify-content-center flex-wrap gap-3 m-4 mw-75 mw-md-50">
                    <img style="height:100px;width:100px;" class="rounded-4 p-4 bg-white shadow" t-att-src="state.manifest.icons?.[0]?.src"/>
                    <div class="d-inline-block">
                        <div class="d-flex align-items-center">
                            <h1 class="mb-0" t-esc="state.manifest.name"/>
                            <Dropdown t-if="pwa.isAvailable" menuClass="'p-2'">
                                <button class="btn btn-link fa fa-pencil"/>
                                <t t-set-slot="content">
                                    <label class="mb-1">Application name</label>
                                    <input class="form-control" t-att-value="state.manifest.name" t-on-change="onChangeName"/>
                                </t>
                            </Dropdown>
                        </div>
                        <a class="text-primary text-decoration-none" href="https://odoo.com" alt="Odoo" target="_blank">Odoo S.A.</a>
                    </div>
                </div>
                <button t-if="pwa.isAvailable" class="btn btn-primary btn-lg rounded-5 shadow py-2 px-3" t-on-click="onInstall">Install</button>
                <div t-else="" class="p-2 px-4 overflow-hidden rounded-2 mw-75 bg-info text-white">
                    <t t-if="pwa.isSupportedOnBrowser">
                        <span t-if="pwa.hasScopeBeenInstalled()">The app seems to be installed on your device</span>
                        <span t-else="">You can install the app from the browser menu</span>
                    </t>
                    <span t-else="">The app cannot be installed with this browser</span>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("web._ModelFieldSelector", `/web/static/src/core/model_field_selector/model_field_selector.xml`, `<t t-name="web._ModelFieldSelector" xml:space="preserve">
        <div class="o_model_field_selector d-flex" aria-atomic="true" t-att-class="props.readonly ? 'o_read_mode' : 'o_edit_mode o_input'" t-on-click="(ev) =&gt; this.openPopover(ev.currentTarget)">
            <div class="o_model_field_selector_value flex-grow-1 h-100" tabindex="0" t-att-data-tooltip="state.displayNames.join(' &gt; ')" data-tooltip-position="top">
                <t t-foreach="state.displayNames" t-as="displayName" t-key="displayName_index">
                    <t t-if="!displayName_first">
                        <i class="oi oi-chevron-right m-1" role="img" aria-label="Followed by" title="Followed by"/>
                    </t>
                    <span t-attf-class="o_model_field_selector_chain_part mb-1 #{props.readonly ? 'border-0 fw-bolder' : 'px-1'} text-nowrap">
                        <t t-esc="displayName"/>
                    </span>
                </t>
            </div>
            <div t-if="!props.readonly and state.isInvalid" class="o_model_field_selector_controls ms-2" tabindex="0">
                <i class="fa fa-exclamation-triangle text-warning o_model_field_selector_warning" role="alert" aria-label="Invalid field chain" title="Invalid field chain"/>
            </div>
            <div t-if="!props.readonly and props.allowEmpty and state.displayNames.length" class="o_model_field_selector_controls ms-2" tabindex="0">
                <i class="fa fa-times" t-on-click.stop="clear" aria-label="Clear" title="Clear"/>
            </div>
        </div>
    </t>

`);
registerTemplate("web.ModelFieldSelectorPopover", `/web/static/src/core/model_field_selector/model_field_selector_popover.xml`, `<t t-name="web.ModelFieldSelectorPopover" xml:space="preserve">
        <div class="o_model_field_selector_popover" tabindex="-1" t-ref="root" t-on-keydown="onInputKeydown">
            <div class="border-bottom p-2 text-dark fw-bolder">
                <div class="d-flex justify-content-between align-items-center">
                    <t t-if="state.page.previousPage">
                        <i class="o_model_field_selector_popover_prev_page btn btn-link oi oi-arrow-left ms-n2 text-dark" title="Previous" role="img" aria-label="Previous" t-on-click="() =&gt; this.goToPreviousPage()"/>
                    </t>
                    <div class="o_model_field_selector_popover_title px-2 text-truncate">
                        <t t-esc="state.page.title"/>
                    </div>
                    <i class="o_model_field_selector_popover_close btn btn-link me-n2 fa fa-times text-dark" title="Close" role="img" aria-label="Close" t-on-click="() =&gt; props.close()"/>
                </div>
                <t t-if="props.showSearchInput">
                    <div class="o_model_field_selector_popover_search mt-1">
                        <input type="text" placeholder="Search..." class="o_input p-1 border rounded-1 bg-view" t-att-value="state.page.query" t-on-input="(ev) =&gt; this.debouncedSearchFields(ev.target.value)"/>
                    </div>
                </t>
            </div>
            <div class="o_model_field_selector_popover_body">
                <ul class="o_model_field_selector_popover_page list-unstyled mb-0 overflow-auto">
                    <t t-foreach="state.page.fieldNames" t-as="fieldName" t-key="fieldName">
                        <t t-set="fieldDef" t-value="state.page.fieldDefs[fieldName]"/>
                        <li class="o_model_field_selector_popover_item d-flex border-bottom" t-att-class="{ 'active': fieldName === state.page.focusedFieldName }" t-att-data-name="fieldName">
                            <button t-attf-class="o_model_field_selector_popover_item_name btn btn-light flex-fill border-0 rounded-0 text-start fw-normal" t-on-click="() =&gt; this.selectField(fieldDef)">
                                <t t-esc="fieldDef.string"/>
                                <t t-if="fieldDef.record_name"> (<t t-esc="fieldDef.record_name"/>)</t>
                                <div t-if="props.isDebugMode" class="o_model_field_selector_popover_item_title text-muted small"><t t-esc="fieldName"/> (<t t-esc="fieldDef.type"/>)</div>
                            </button>
                            <t t-if="(!fieldDef.is_property and fieldDef.relation and props.followRelations) or fieldDef.type === 'properties'">
                                <button class="o_model_field_selector_popover_item_relation btn btn-light border-0 border-start rounded-0" t-on-click.stop="() =&gt; this.followRelation(fieldDef)">
                                    <i class="oi oi-chevron-right o_model_field_selector_popover_relation_icon" role="img" aria-label="Relation to follow" title="Relation to follow"/>
                                </button>
                            </t>
                        </li>
                    </t>
                </ul>
            </div>
            <t t-if="showDebugInput">
                <div class="o_model_field_selector_popover_footer border-top py-1 px-2">
                    <input type="text" class="o_model_field_selector_debug o_input" t-att-value="state.page.path" t-on-change="(ev) =&gt; this.loadNewPath(ev.target.value)" t-on-keydown="onDebugInputKeydown" t-on-input="(ev) =&gt; this.props.update(ev.target.value, null, true)"/>
                </div>
            </t>
        </div>
    </t>

`);
registerTemplate("web.ModelSelector", `/web/static/src/core/model_selector/model_selector.xml`, `<t t-name="web.ModelSelector" xml:space="preserve">
        <div class="o_model_selector" t-ref="autocomplete_container">
            <input t-if="env.isSmall" type="text" class="o_input" readonly="" t-att-id="props.id" t-att-value="props.value"/>
            <AutoComplete t-else="" id="props.id" value="props.value || ''" sources="sources" placeholder.translate="Type a model here..." autoSelect="props.autoSelect" onSelect.bind="onSelect"/>
            <span class="o_dropdown_button"/>
        </div>
    </t>
`);
registerTemplate("web.Notebook", `/web/static/src/core/notebook/notebook.xml`, `<t t-name="web.Notebook" xml:space="preserve">
        <div t-attf-class="o_notebook d-flex w-100 {{ props.orientation === 'horizontal' ? 'horizontal flex-column' : 'vertical flex-row' }} {{ props.className }}" t-if="state.currentPage">
            <div class="o_notebook_headers" t-att-class="{ 'm-0': props.orientation === 'vertical' }">
                <ul t-attf-class="nav nav-tabs {{ props.orientation === 'horizontal' ? 'flex-row flex-nowrap' : 'flex-column p-0' }}">
                    <li t-foreach="navItems" t-as="navItem" t-key="navItem[0]" class="nav-item flex-nowrap cursor-pointer" t-if="navItem[1].isVisible" t-attf-class="{{ navItem[1].isDisabled ? 'disabled' : '' }}">
                        <a class="nav-link" t-attf-class="{{ navItem[0] === state.currentPage ? 'active' : '' }} {{ props.orientation === 'vertical' ? 'p-3 rounded-0' : '' }} {{ navItem[1].className || '' }}" t-att-name="navItem[1].name" t-on-click.prevent="() =&gt; this.activatePage(navItem[0])" href="#" role="tab" tabindex="0">
                            <i t-if="props.icons and props.icons[navItem[0]]" t-attf-class="fa {{ props.icons[navItem[0]] }} me-2"/>
                            <t t-esc="navItem[1].title"/>
                        </a>
                    </li>
                </ul>
            </div>
            <div class="o_notebook_content tab-content">
                <div class="tab-pane active fade" t-ref="activePane">
                    <t t-if="page" t-component="page.Component" t-key="state.currentPage" t-props="page.props"/>
                    <t t-else="" t-slot="{{ state.currentPage }}"/>
                </div>
            </div>
        </div>
    </t>

`);
registerTemplate("web.NotificationWowl", `/web/static/src/core/notifications/notification.xml`, `<t t-name="web.NotificationWowl" xml:space="preserve">
        <div t-on-mouseenter="this.props.freeze" t-on-mouseleave="this.props.refresh" t-attf-class="o_notification {{props.className}} d-flex mb-2 position-relative rounded shadow-lg" role="alert" aria-live="assertive" aria-atomic="true">
            <span t-attf-class="o_notification_bar bg-{{props.type}} rounded-start"/>
            <div class="w-100 py-3 ps-3 pe-5 border border-start-0 rounded-end text-break">
                <h5 t-if="props.title" class="o_notification_title m-0" t-out="props.title"/>
                <button type="button" class="o_notification_close btn-close position-absolute top-0 end-0 mt-3 me-3" aria-label="Close" t-on-click="props.close"/>
                <div class="o_notification_body" t-att-class="{'mt-2' : props.title}">
                    <div t-if="props.message" class="me-auto o_notification_content" t-out="props.message"/>
                    <div t-if="props.buttons.length" class="o_notification_buttons d-flex gap-2 mt-3">
                        <button t-foreach="props.buttons" t-as="button" type="button" t-key="button_index" t-attf-class="btn {{button.primary ? 'btn-primary' : 'btn-secondary'}}" t-on-click="button.onClick">
                            <t t-if="button.icon">
                                <i t-if="button.icon.indexOf('fa-') === 0" role="img" t-att-aria-label="button.name" t-att-title="button.name" t-attf-class="fa fa-fw {{button.icon}} me-1"/>
                                <img t-else="" t-att-src="button.icon" t-att-alt="button.name"/>
                            </t>
                            <span t-esc="button.name"/>
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </t>

`);
registerTemplate("web.OverlayContainer", `/web/static/src/core/overlay/overlay_container.xml`, `<t t-name="web.OverlayContainer" xml:space="preserve">
        <div class="o-overlay-container" t-ref="root">
            <t t-foreach="sortedOverlays" t-as="overlay" t-key="overlay.id">
                <ErrorHandler t-if="isVisible(overlay)" onError="(error) =&gt; this.handleError(overlay, error)">
                    <OverlayItem env="overlay.env" component="overlay.component" props="overlay.props"/>
                </ErrorHandler>
            </t>
        </div>
    </t>

    `);
registerTemplate("web.OverlayContainer.Item", `/web/static/src/core/overlay/overlay_container.xml`, `<t t-name="web.OverlayContainer.Item" xml:space="preserve">
        <div t-ref="rootRef" class="o-overlay-item">
            <t t-component="props.component" t-props="props.props"/>
        </div>
    </t>

`);
registerTemplate("web.Pager", `/web/static/src/core/pager/pager.xml`, `<t t-name="web.Pager" xml:space="preserve">
        <nav class="o_pager d-flex gap-2 h-100" aria-label="Pager">
            <span t-if="!env.isSmall" class="o_pager_counter align-self-center" t-on-click.stop="">
                <t t-if="state.isEditing">
                    <input type="text" class="o_pager_value o_input d-inline-block w-auto text-end mb-n1" size="7" t-ref="autofocus" t-att-value="value" t-on-blur="onInputBlur" t-on-change="onInputChange" t-on-keydown.stop="onInputKeydown"/>
                </t>
                <t t-else="">
                    <span class="o_pager_value d-inline-block border-bottom border-transparent mb-n1" t-esc="value" t-on-click="onValueClick"/>
                </t>
                <span> / </span>
                <t t-if="props.updateTotal">
                    <span class="o_pager_limit o_pager_limit_fetch" t-att-class="{ 'disabled': state.isDisabled }" t-on-click.stop="updateTotal"><t t-esc="props.total"/>+</span>
                </t>
                <t t-else="">
                    <span class="o_pager_limit" t-esc="props.total"/>
                </t>
            </span>
            <span class="btn-group d-print-none" aria-atomic="true">

                <button type="button" class="btn btn-secondary o_pager_previous px-2 rounded-start" aria-label="Previous" data-tooltip="Previous" tabindex="-1" t-att-data-hotkey="props.withAccessKey ? 'p' : false" t-att-disabled="state.isDisabled or isSinglePage" t-on-click.stop="() =&gt; this.navigate(-1)">
                    <i class="oi oi-chevron-left"/>
                </button>
                <button type="button" class="btn btn-secondary o_pager_next px-2 rounded-end" aria-label="Next" data-tooltip="Next" tabindex="-1" t-att-data-hotkey="props.withAccessKey ? 'n' : false" t-att-disabled="state.isDisabled or isSinglePage" t-on-click.stop="() =&gt; this.navigate(1)">
                    <i class="oi oi-chevron-right"/>
                </button>
            </span>
        </nav>
    </t>

`);
registerTemplate("web.PagerIndicator", `/web/static/src/core/pager/pager_indicator.xml`, `<t t-name="web.PagerIndicator" xml:space="preserve">
        <Transition visible="state.show" name="'o-fade'" t-slot-scope="transition" leaveDuration="400">
            <div class="o_pager_indicator position-fixed top-0 end-0 m-1 d-flex" t-att-class="transition.className">
                <span class="o_pager_indicator_inner m-1 px-1 text-center shadow">
                    <span class="o_pager_value" t-esc="state.value"/>
                    <span> / </span>
                    <span class="o_pager_limit" t-esc="state.total"/>
                </span>
            </div>
        </Transition>
    </t>

`);
registerTemplate("web.Popover", `/web/static/src/core/popover/popover.xml`, `<t t-name="web.Popover" xml:space="preserve">
        <div t-ref="ref" t-att-class="defaultClassObj" t-att-role="props.role" t-on-pointerenter="() =&gt; props.holdOnHover and position.lock()" t-on-pointerleave="() =&gt; props.holdOnHover and position.unlock()">
            <t t-component="props.component" t-props="props.componentProps" close="props.close"/>
            <div t-if="props.arrow" class="popover-arrow"/>
        </div>
    </t>

`);
registerTemplate("web.InstallPrompt", `/web/static/src/core/pwa/install_prompt.xml`, `<t t-name="web.InstallPrompt" xml:space="preserve">
        <Dialog contentClass="'o_install_prompt position-fixed px-2 py-3 m-2 user-select-none'" size="'md'" footer="false">
            <t t-set-slot="header">
                <div class="d-flex w-100">
                    <h4>How to get the application</h4>
                    <div t-on-click="onClose" type="button" class="btn-close" aria-label="Close"/>
                </div>
            </t>
            <p>Install the app on your device to access it easily. Here are the steps to follow:</p>
            <t t-call="web.InstallStepsSafari"/>
        </Dialog>
    </t>
    `);
registerTemplate("web.InstallStepsSafari", `/web/static/src/core/pwa/install_prompt.xml`, `<t t-name="web.InstallStepsSafari" xml:space="preserve">
        <t t-if="isMobileSafari">
            <ul class="mb-0">
                <li>
                    Tap on the share icon
                </li>
                <li>
                    Select "Add to home screen"
                </li>
            </ul>
        </t>
        <t t-else="">
            <ul class="mb-0">
                <li>
                    Open "File" menu from your browser
                </li>
                <li>
                    Select "Add to dock"
                </li>
            </ul>
        </t>
    </t>
`);
registerTemplate("web.MultiRecordSelector", `/web/static/src/core/record_selectors/multi_record_selector.xml`, `<t t-name="web.MultiRecordSelector" xml:space="preserve">
        <div class="o_input d-flex flex-wrap gap-1 o_multi_record_selector" t-ref="multiRecordSelector">
            <TagsList tags="tags"/>
            <RecordAutocomplete resModel="props.resModel" value="''" domain="props.domain" context="props.context" className="'o_record_autocomplete_with_caret flex-grow-1'" fieldString="props.fieldString" placeholder="placeholder" multiSelect="true" getIds.bind="getIds" update.bind="update"/>
        </div>
    </t>

`);
registerTemplate("web.RecordAutocomplete", `/web/static/src/core/record_selectors/record_autocomplete.xml`, `<t t-name="web.RecordAutocomplete" xml:space="preserve">
        <AutoComplete placeholder="props.placeholder" value="props.value" autoSelect="true" resetOnSelect="props.multiSelect" class="props.className" sources="sources" onSelect.bind="onSelect" onChange.bind="onChange"/>
    </t>

`);
registerTemplate("web.RecordSelector", `/web/static/src/core/record_selectors/record_selector.xml`, `<t t-name="web.RecordSelector" xml:space="preserve">
        <div class="o_input d-flex flex-wrap gap-1 o_record_selector">
            <RecordAutocomplete resModel="props.resModel" value="displayName" domain="props.domain" context="props.context" className="'h-100 flex-grow-1'" fieldString="props.fieldString" placeholder="props.placeholder" multiSelect="false" getIds="() =&gt; []" update.bind="update"/>
            <span class="o_dropdown_button"/>
        </div>
    </t>

`);
registerTemplate("web_studio.ResizablePanel", `/web/static/src/core/resizable_panel/resizable_panel.xml`, `<t t-name="web_studio.ResizablePanel" xml:space="preserve">
        <div class="o_resizable_panel d-flex flex-column" t-att-class="class" t-ref="containerRef">
            <t t-slot="default"/>
            <div class="o_resizable_panel_handle position-absolute top-0 bottom-0 end-0" t-att-class="props.handleSide === 'start' ? 'start-0' : 'end-0'" t-ref="handleRef"/>
        </div>
    </t>

`);
registerTemplate("web.SelectMenu", `/web/static/src/core/select_menu/select_menu.xml`, `<t t-name="web.SelectMenu" xml:space="preserve">
        <div t-att-class="\`o_select_menu border w-auto rounded-2 overflow-hidden \${props.class || ''}\`">
            <Dropdown menuClass="this.menuClass" menuRef="this.menuRef" position="'bottom-fit'" beforeOpen.bind="onBeforeOpen" onStateChanged.bind="onStateChanged" navigationOptions="{ virtualFocus: this.props.searchable }">
                <button type="button" t-att-class="\`o_select_menu_toggler btn btn-light w-100 bg-light \${props.togglerClass || ''} \${canDeselect ? 'o_can_deselect' : ''}\`" t-att-disabled="props.disabled">
                    <t t-if="props.multiSelect">
                        <div class="text-wrap text-start">
                            <t t-if="props.placeholder and !props.value.length">
                                <span class="text-muted fst-italic" t-out="props.placeholder"/>
                            </t>
                            <t else="">
                                <TagsList tags="multiSelectChoices"/>
                            </t>
                        </div>
                    </t>
                    <t t-else="">
                        <span class="o_select_menu_toggler_slot text-start text-truncate">
                            <span t-if="props.placeholder and !props.value" class="text-muted fst-italic" t-out="props.placeholder"/>
                            <t t-if="!props.slots or !props.slots.default" t-esc="displayValue"/>
                            <t t-else="" t-slot="default"/>
                        </span>
                        <span t-if="canDeselect" t-on-click.stop="() =&gt; this.props.onSelect(null)" class="o_select_menu_toggler_clear p-0 m-0">
                            <i class="fa fa-times"/>
                        </span>
                    </t>
                    <span class="o_select_menu_toggler_caret p-0 m-0">
                        <i class="fa fa-caret-down"/>
                    </span>
                </button>

                <t t-set-slot="content">
                    <input t-if="props.searchable" type="text" class="dropdown-item o_select_menu_sticky px-3 py-3 position-sticky top-0 start-0 border-bottom" t-ref="inputRef" t-on-input="debouncedOnInput" t-att-placeholder="props.searchPlaceholder" autocomplete="selectMenuAutocompleteOff" autocorrect="off" spellcheck="false"/>
                    <t t-if="state.choices.length === 0">
                        <span class="text-muted fst-italic mx-3">No result found</span>
                    </t>
                    <t t-foreach="state.displayedOptions" t-as="choice" t-key="choice_index">
                        <t t-call="{{ this.constructor.choiceItemTemplate }}">
                            <t t-set="choice" t-value="choice"/>
                        </t>
                    </t>
                    <t t-if="props.slots and props.slots.bottomArea" t-slot="bottomArea" data="state"/>
                </t>
            </Dropdown>
        </div>
    </t>

    `);
registerTemplate("web.SelectMenu.ChoiceItem", `/web/static/src/core/select_menu/select_menu.xml`, `<t t-name="web.SelectMenu.ChoiceItem" xml:space="preserve">
        <div t-if="choice.isGroup" class="o_select_menu_group position-sticky bg-light pt-2 px-1 fst-italic fw-bolder user-select-none" t-att-class="{'o_select_menu_searchable_group': props.searchable }">
            <span t-esc="choice.label"/>
            <hr class="mt-2 mb-1"/>
        </div>
        <DropdownItem t-if="!choice.isGroup" onSelected="() =&gt; this.onItemSelected(choice.value)" class="getItemClass(choice) + ' d-flex align-items-center'">
            <t t-if="props.slots and props.slots.choice" t-slot="choice" data="choice"/>
            <t t-else="">
                <div class="o_select_menu_item_label text-wrap" t-esc="choice.label || choice.value"/>
            </t>
        </DropdownItem>
    </t>

`);
registerTemplate("web.sign_svg_text", `/web/static/src/core/signature/name_and_signature.xml`, `<t t-name="web.sign_svg_text" name="SVG Signature Text" xml:space="preserve">
        <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" t-att-width="width" t-att-height="height">
            <defs>
                <style type="text/css">
                    @font-face {
                        font-family: "font";
                        src: url(data:font/ttf;base64,<t t-esc="font"/>) format("woff");
                        font-weight: normal;
                        font-style: normal;
                    }
                </style>
            </defs>

            <text t-esc="text" x="50%" t-att-y="height * 3 / 5" t-att-font-size="height * 3 / 5" t-att-textLength="width * 4 / 5 * (type === 'signature' ? Math.min(1, text.length / 7) : 1)" t-att-lengthAdjust="'spacing' + (type === 'signature' ? 'AndGlyphs' : '')" t-attf-style="font-family:'font'; stroke: none; fill: {{color}};" text-anchor="middle"/>
        </svg>
    </t>


    `);
registerTemplate("web.NameAndSignature", `/web/static/src/core/signature/name_and_signature.xml`, `<t t-name="web.NameAndSignature" xml:space="preserve">
        <div class="o_web_sign_name_and_signature">
            <div t-if="!props.noInputName" class="o_web_sign_name_group">
                <label class="col-form-label" t-att-for="'o_web_sign_name_input_' + htmlId">Full Name</label>
                <input type="text" name="signer" t-att-id="'o_web_sign_name_input_' + htmlId" class="o_web_sign_name_input form-control" t-on-input="onInputSignName" t-att-value="props.signature.name" t-ref="signNameInput" placeholder="Type your name to sign" required=""/>
            </div>


            <div t-if="state.showSignatureArea" class="o_web_sign_signature_group bg-100 card mt-3" style="overflow: hidden;">
                <div class="card-header bg-transparent">
                    <div class="row g-0">
                        <div t-if="!props.noInputName or defaultName" class="col-auto">
                            <a role="button" href="#" t-on-click.prevent="onClickSignAuto" t-attf-class="o_web_sign_auto_button me-2 btn btn-light {{ state.signMode === 'auto' ? 'active': '' }}">
                                Auto
                            </a>
                        </div>
                        <div class="col-auto">
                            <a role="button" href="#" t-on-click.prevent="() =&gt; this.setMode('draw')" t-attf-class="o_web_sign_draw_button me-2 btn btn-light {{ state.signMode === 'draw' ? 'active': '' }}">
                                Draw
                            </a>
                        </div>
                        <div class="col-auto">
                            <a role="button" href="#" t-on-click.prevent="onClickSignLoad" t-attf-class="o_web_sign_load_button me-2 btn btn-light {{ state.signMode === 'load' ? 'active': '' }}">
                                Load
                            </a>
                        </div>

                        <div class="col-auto division ms-auto"/>

                        <div t-if="state.signMode === 'auto'" class="o_web_sign_auto_select_style col-auto">
                            <Dropdown>
                                <button type="button" class="btn btn-link fa fa-font o-dropdown-caret"/>
                                <t t-set-slot="content">
                                    <t t-foreach="fonts" t-as="font" t-key="font_index">
                                        <DropdownItem onSelected="() =&gt; this.onSelectFont(font_index)">
                                            <img class="img-fluid" t-att-src="getSVGTextFont(font)"/>
                                        </DropdownItem>
                                    </t>
                                </t>
                            </Dropdown>
                        </div>

                        <div t-if="state.signMode === 'draw'" t-attf-class="o_web_sign_draw_clear col-auto">
                            <a role="button" href="#" t-on-click.prevent="onClickSignDrawClear" class="btn btn-link fa fa-trash"/>
                        </div>

                        <div t-if="state.signMode === 'load'" class="o_web_sign_load_file col-auto">
                            <button type="button" id="loadFileXml" t-on-click="uploadFile" class="btn btn-link fa fa-upload"/>
                            <input t-ref="signInputLoad" type="file" role="button" name="files[]" class="d-none" t-on-change="onChangeSignLoadInput"/>
                        </div>
                    </div>
                </div>

                <div class="o_web_sign_signature_container position-relative">
                    <div class="o_signature_stroke position-absolute"/>
                    <canvas t-if="state.showSignatureArea" t-ref="signature" class="o_web_sign_signature z-1"/>
                </div>

                <div t-if="loadIsInvalid" t-attf-class="o_web_sign_load_invalid card-footer d-none">
                    <div class="alert alert-danger mb-0" role="alert">
                        This file is invalid. Please select an image.
                    </div>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("web.SignatureDialog", `/web/static/src/core/signature/signature_dialog.xml`, `<t t-name="web.SignatureDialog" xml:space="preserve">
      <Dialog title.translate="Adopt Your Signature">
         <div>
            <NameAndSignature t-props="nameAndSignatureProps"/>
            <div class="mt16 small">By clicking Adopt &amp; Sign, I agree that the chosen signature/initials will be a valid electronic representation of my hand-written signature/initials for all purposes when it is used on documents, including legally binding contracts.</div>
        </div>
        <t t-set-slot="footer">
          <button class="btn btn-primary" t-att-disabled="signature.isSignatureEmpty" t-on-click="onClickConfirm">Adopt &amp; Sign</button>
          <button class="btn btn-secondary" t-on-click="props.close">Cancel</button>
        </t>
      </Dialog>
    </t>

`);
registerTemplate("web.TagsList", `/web/static/src/core/tags_list/tags_list.xml`, `<t t-name="web.TagsList" xml:space="preserve">
        <t t-foreach="visibleTags" t-as="tag" t-key="tag.id or tag_index">
            <span class="o_tag position-relative d-inline-flex align-items-center user-select-none mw-100" t-att-class="{                     'o_avatar opacity-trigger-hover' : tag.img,                     'o_badge badge rounded-pill lh-1': !tag.img,                     'cursor-pointer': tag.canEdit,                 }" t-attf-class="{{ !tag.img ? 'o_tag_color_' + (tag.colorIndex ? tag.colorIndex : '0') : '' }}" tabindex="-1" t-att-data-color="tag.colorIndex" t-att-title="tag.text" t-on-click="(ev) =&gt; tag.onClick and tag.onClick(ev)" t-on-keydown="tag.onKeydown">


                <span t-if="tag.img and props.displayText and tag.onDelete" class="o_avatar_backdrop position-absolute top-0 end-0 bottom-0 start-0 ms-n2 mt-n1 mb-n1 bg-view rounded border shadow opacity-0 opacity-100-hover"/>

                <img t-if="tag.img" t-att-src="tag.img" class="o_avatar o_m2m_avatar position-relative rounded" t-att-class="tag.imageClass"/>

                <i t-if="tag.icon" t-attf-class="p-1 fa {{ tag.icon }}" t-att-class="tag.className"/>

                <div t-if="props.displayText" class="o_tag_badge_text text-truncate" t-att-class="{'position-relative ms-1' : tag.img}" t-out="tag.text"/>

                <a t-if="tag.onDelete" t-on-click.stop.prevent="(ev) =&gt; tag.onDelete and tag.onDelete(ev)" class="o_delete d-flex align-items-center opacity-100-hover" t-att-class="{                             'btn btn-link position-relative py-0 px-1 text-danger opacity-0': tag.img,                             'ps-1 opacity-75': !tag.img                         }" title="Delete" aria-label="Delete" tabIndex="-1" href="#">
                        <i class="oi oi-close align-text-top"/>
                </a>
            </span>
        </t>
        <span t-if="props.tags and otherTags.length" class="o_m2m_avatar_empty rounded text-center fw-bold" data-tooltip-template="web.TagsList.Tooltip" data-tooltip-position="right" t-att-data-tooltip-info="tooltipInfo">
            <span t-if="otherTags.length &gt; 9" t-esc="'9+'"/>
            <span t-else="" t-esc="'+' + otherTags.length"/>
        </span>
    </t>

    `);
registerTemplate("web.TagsList.Tooltip", `/web/static/src/core/tags_list/tags_list.xml`, `<t t-name="web.TagsList.Tooltip" xml:space="preserve">
        <t t-foreach="tags" t-as="tag" t-key="tag.id">
            <div t-esc="tag.text"/>
        </t>
    </t>

`);
registerTemplate("web.Tooltip", `/web/static/src/core/tooltip/tooltip.xml`, `<t t-name="web.Tooltip" xml:space="preserve">
        <div class="o-tooltip tooltip-inner d-print-none text-start">
            <t t-if="props.template" t-call="{{props.template}}" t-call-context="{ env, ...props.info }"/>
            <span t-else="" t-esc="props.tooltip"/>
        </div>
    </t>

`);
registerTemplate("web.TreeEditor", `/web/static/src/core/tree_editor/tree_editor.xml`, `<t t-name="web.TreeEditor" xml:space="preserve">
        <div class="o_tree_editor w-100" aria-atomic="true" t-att-class="className">
            <div t-attf-class="o_tree_editor_node d-flex flex-column #{props.readonly ? (props.isSubTree ? 'gap-0' : 'gap-2') : 'gap-1'}">
                <t t-set="node" t-value="tree"/>
                <div class="o_tree_editor_row d-flex align-items-center flex-wrap" t-att-class="{'ps-4': props.isSubTree}">
                    <div class="o_tree_editor_connector d-flex flex-grow-1 align-items-center">
                        <t t-if="node.children.length">
                            <span t-if="!props.isSubTree">Match</span>
                            <t t-if="node.children.length &gt; 1">
                                <t t-call="web.TreeEditor.connector.dropdown"/>
                            </t>
                            <t t-else="">
                                <span class="px-1">
                                    <t t-call="web.TreeEditor.connector.title"/>
                                </span>
                            </t>
                            <span t-if="props.isSubTree">of:</span>
                            <span t-else="">of the following rules:</span>
                        </t>
                        <t t-else="">
                            <span><span t-if="!props.isSubTree">Match </span><strong>all records</strong></span>
                        </t>
                    </div>
                    <t t-slot="default"/>
                </div>
                <t t-if="node.children.length" t-call="web.TreeEditor.connector.children"/>
                <t t-if="!props.readonly">
                    <div class="o_tree_editor_row d-flex align-items-center" t-att-class="{ 'ps-4': addPadding || props.isSubTree }">
                        <a href="#" role="button" t-on-click="() =&gt; this.insertRootLeaf(node)">New Rule</a>
                    </div>
                </t>
            </div>
        </div>
    </t>

    `);
registerTemplate("web.TreeEditor.controls", `/web/static/src/core/tree_editor/tree_editor.xml`, `<t t-name="web.TreeEditor.controls" xml:space="preserve">
        <div class="o_tree_editor_node_control_panel d-flex" role="toolbar" aria-label="Domain node">
            <button class="btn px-2 fs-4" role="button" title="Add New Rule" aria-label="Add New Rule" t-on-click="() =&gt; this.insertLeaf(parent, node)" t-on-mouseenter="(ev) =&gt; this.highlightNode(ev.target, true)" t-on-mouseleave="(ev) =&gt; this.highlightNode(ev.target, false)">
                <i class="fa fa-plus"/>
            </button>
            <button class="btn px-2 fs-4" role="button" title="Add branch" aria-label="Add branch" t-on-click="() =&gt; this.insertBranch(parent, node)" t-on-mouseenter="(ev) =&gt; this.highlightNode(ev.target, true)" t-on-mouseleave="(ev) =&gt; this.highlightNode(ev.target, false)">
                <i class="fa fa-sitemap"/>
            </button>
            <button class="btn btn-link px-2 text-danger fs-4" role="button" title="Delete node" aria-label="Delete node" t-on-click="() =&gt; this.delete(parent, node)" t-on-mouseenter="(ev) =&gt; this.highlightNode(ev.target, true)" t-on-mouseleave="(ev) =&gt; this.highlightNode(ev.target, false)">
                <i class="fa fa-trash"/>
            </button>
        </div>
    </t>

    `);
registerTemplate("web.TreeEditor.connector.title", `/web/static/src/core/tree_editor/tree_editor.xml`, `<t t-name="web.TreeEditor.connector.title" xml:space="preserve">
        <t t-set="title">
            <t t-if="node.value === '|'">
                <t t-if="node.negate">none</t>
                <t t-else="">any</t>
            </t>
            <t t-else="">
                <t t-if="node.negate">not all</t>
                <t t-else="">all</t>
            </t>
        </t>
        <t t-esc="title"/>
    </t>

    `);
registerTemplate("web.TreeEditor.connector.dropdown", `/web/static/src/core/tree_editor/tree_editor.xml`, `<t t-name="web.TreeEditor.connector.dropdown" xml:space="preserve">
        <t t-if="props.readonly">
            <strong class="px-1">
                <t t-call="web.TreeEditor.connector.title"/>
            </strong>
        </t>
        <t t-else="">
            <div aria-atomic="true">
                <Dropdown>
                    <button class="btn btn-link btn-primary py-0 px-1 o-dropdown-caret">
                        <t t-call="web.TreeEditor.connector.title"/>
                    </button>
                    <t t-set-slot="content">
                        <DropdownItem onSelected="() =&gt; this.updateConnector(node, '&amp;')">all</DropdownItem>
                        <DropdownItem onSelected="() =&gt; this.updateConnector(node, '|')">any</DropdownItem>
                    </t>
                </Dropdown>
            </div>
        </t>
    </t>

    `);
registerTemplate("web.TreeEditor.connector.children", `/web/static/src/core/tree_editor/tree_editor.xml`, `<t t-name="web.TreeEditor.connector.children" xml:space="preserve">
        <t t-foreach="node.children" t-as="child" t-key="child.type + '_' + child_index">
            <div class="o_tree_editor_node" t-att-class="{ 'ps-4': addPadding || props.isSubTree }">
                <t t-call="web.TreeEditor.{{ child.type }}">
                    <t t-set="parent" t-value="node"/>
                    <t t-set="node" t-value="child"/>
                </t>
            </div>
        </t>
    </t>

    `);
registerTemplate("web.TreeEditor.connector", `/web/static/src/core/tree_editor/tree_editor.xml`, `<t t-name="web.TreeEditor.connector" xml:space="preserve">
        <div class="o_tree_editor_row d-flex align-items-center">
            <div class="o_tree_editor_connector d-flex flex-grow-1">
                <t t-call="web.TreeEditor.connector.dropdown"/>
                <span>of:</span>
            </div>
            <t t-if="!props.readonly">
                <t t-call="web.TreeEditor.controls"/>
            </t>
        </div>
        <t t-call="web.TreeEditor.connector.children">
            <t t-set="addPadding" t-value="true"/>
        </t>
    </t>

    `);
registerTemplate("web.TreeEditor.condition", `/web/static/src/core/tree_editor/tree_editor.xml`, `<t t-name="web.TreeEditor.condition" xml:space="preserve">
        <div class="o_tree_editor_row d-flex align-items-center">
            <t t-if="props.readonly">
                <t t-call="web.TreeEditor.condition:readonly"/>
            </t>
            <t t-else="">
                <t t-call="web.TreeEditor.condition:editable"/>
                <t t-call="web.TreeEditor.controls"/>
            </t>
        </div>
        <t t-if="isTree(node.value)">
            <TreeEditor t-props="props" update="(value) =&gt; this.updateLeafValue(node, value)" slots="{}" isSubTree="true" tree="node.value" resModel="getResModel(node)"/>
        </t>
    </t>

    `);
registerTemplate("web.TreeEditor.condition:readonly", `/web/static/src/core/tree_editor/tree_editor.xml`, `<t t-name="web.TreeEditor.condition:readonly" xml:space="preserve">
        <t t-set="description" t-value="getConditionDescription(node)"/>
        <div class="o_tree_editor_condition d-flex gap-1 px-2 border bg-100">
            <div class="fw-bolder text-nowrap" t-esc="description.pathDescription"/>
            <div class="fst-italic text-nowrap" t-esc="description.operatorDescription"/>
            <t t-if="description.valueDescription">
                <t t-set="values" t-value="description.valueDescription.values"/>
                <t t-set="join" t-value="description.valueDescription.join"/>
                <t t-set="addParenthesis" t-value="description.valueDescription.addParenthesis"/>
                <t t-if="addParenthesis">( </t>
                <t t-foreach="values" t-as="val" t-key="val_index">
                    <span class="text-primary fw-bolder"><t t-esc="val"/></span>
                    <t t-if="!val_last"> <t t-esc="join"/> </t>
                </t>
                <t t-if="addParenthesis"> )</t>
            </t>
        </div>
    </t>

    `);
registerTemplate("web.TreeEditor.Editor", `/web/static/src/core/tree_editor/tree_editor.xml`, `<t t-name="web.TreeEditor.Editor" xml:space="preserve">
        <t t-if="!info.isSupported(value)">
            <div t-attf-class="o_tree_editor_editor #{_classes}">
                <div class="o_input d-flex align-items-center">
                    <span class="flex-grow-1 text-truncate" t-esc="info.stringify(value)"/>
                    <i role="alert" class="fa fa-exclamation-triangle text-warning mx-2" t-att-title="(typeof info.message === 'function') ? info.message(value) : info.message"/>
                    <i class="fa fa-times" title="Clear" t-on-click="() =&gt; update(info.defaultValue())"/>
                </div>
            </div>
        </t>
        <t t-elif="info.component">
            <div t-attf-class="o_tree_editor_editor #{_classes}">
                <t t-component="info.component" t-props="info.extractProps({ update, value })"/>
            </div>
        </t>
    </t>

    `);
registerTemplate("web.TreeEditor.condition:editable", `/web/static/src/core/tree_editor/tree_editor.xml`, `<t t-name="web.TreeEditor.condition:editable" xml:space="preserve">
        <div class="o_tree_editor_condition d-flex flex-grow-1 align-items-end gap-2">
            <t t-call="web.TreeEditor.Editor">
                <t t-set="_classes" t-value="'col col-md-4 pe-0'"/>
                <t t-set="info" t-value="getPathEditorInfo()"/>
                <t t-set="value" t-value="node.path"/>
                <t t-set="update" t-value="(path) =&gt; this.updatePath(node, path)"/>
            </t>
            <t t-call="web.TreeEditor.Editor">
                <t t-set="_classes" t-value="'col col-md-2 px-3'"/>
                <t t-set="info" t-value="getOperatorEditorInfo(node)"/>
                <t t-set="value" t-value="[node.operator, node.negate]"/>
                <t t-set="update" t-value="(operator, negate) =&gt; this.updateLeafOperator(node, operator, negate)"/>
            </t>
            <t t-call="web.TreeEditor.Editor">
                <t t-set="_classes" t-value="'col ps-0 overflow-hidden'"/>
                <t t-set="info" t-value="getValueEditorInfo(node)"/>
                <t t-set="value" t-value="node.value"/>
                <t t-set="update" t-value="(value) =&gt; this.updateLeafValue(node, value)"/>
            </t>
        </div>
    </t>

    `);
registerTemplate("web.TreeEditor.complex_condition", `/web/static/src/core/tree_editor/tree_editor.xml`, `<t t-name="web.TreeEditor.complex_condition" xml:space="preserve">
        <div class="o_tree_editor_row d-flex align-items-center">
            <div class="o_tree_editor_complex_condition flex-grow-1">
                <input class="o_input w-100" t-att-value="node.value" t-att-readonly="props.readonly or !isDebugMode" t-on-change="(ev) =&gt; this.updateComplexCondition(node, ev.target.value)"/>
            </div>
            <t t-call="web.TreeEditor.controls"/>
        </div>
    </t>


`);
registerTemplate("web.TreeEditor.Input", `/web/static/src/core/tree_editor/tree_editor_components.xml`, `<t t-name="web.TreeEditor.Input" xml:space="preserve">
        <input type="text" class="o_input" t-att-value="props.startEmpty ? '' : props.value" t-on-change="(ev) =&gt; props.update(ev.target.value)"/>
    </t>

    `);
registerTemplate("web.TreeEditor.Select", `/web/static/src/core/tree_editor/tree_editor_components.xml`, `<t t-name="web.TreeEditor.Select" xml:space="preserve">
        <select class="o_input pe-3 text-truncate" t-on-change="(ev) =&gt; props.update(deserialize(ev.target.value))">
            <option t-if="props.addBlankOption" hidden="true"/>
            <t t-foreach="props.options" t-as="option" t-key="serialize(option[0])">
                <option t-att-value="serialize(option[0])" t-att-selected="!props.addBlankOption and option[0] === props.value" t-esc="option[1]"/>
            </t>
        </select>
    </t>

    `);
registerTemplate("web.TreeEditor.Range", `/web/static/src/core/tree_editor/tree_editor_components.xml`, `<t t-name="web.TreeEditor.Range" xml:space="preserve">
        <div class="d-flex align-items-center">
            <t t-call="web.TreeEditor.Editor">
                <t t-set="_classes" t-value="'overflow-hidden flex-grow-1'"/>
                <t t-set="info" t-value="props.editorInfo"/>
                <t t-set="value" t-value="props.value[0]"/>
                <t t-set="update" t-value="(val) =&gt; this.update(0, val)"/>
            </t>
            <i class="fa fa-long-arrow-right mx-2" aria-label="Arrow icon" title="Arrow"/>
            <t t-call="web.TreeEditor.Editor">
                <t t-set="_classes" t-value="'overflow-hidden flex-grow-1'"/>
                <t t-set="info" t-value="props.editorInfo"/>
                <t t-set="value" t-value="props.value[1]"/>
                <t t-set="update" t-value="(val) =&gt; this.update(1, val)"/>
            </t>
        </div>
    </t>

    `);
registerTemplate("web.TreeEditor.Within", `/web/static/src/core/tree_editor/tree_editor_components.xml`, `<t t-name="web.TreeEditor.Within" xml:space="preserve">
        <div class="d-flex align-items-center gap-2">
            <t t-call="web.TreeEditor.Editor">
                <t t-set="_classes" t-value="'overflow-hidden flex-grow-1'"/>
                <t t-set="info" t-value="props.amountEditorInfo"/>
                <t t-set="value" t-value="props.value[0]"/>
                <t t-set="update" t-value="(val) =&gt; this.update(0, val)"/>
            </t>
            <t t-call="web.TreeEditor.Editor">
                <t t-set="_classes" t-value="'overflow-hidden flex-grow-1'"/>
                <t t-set="info" t-value="props.optionEditorInfo"/>
                <t t-set="value" t-value="props.value[1]"/>
                <t t-set="update" t-value="(val) =&gt; this.update(1, val)"/>
            </t>
        </div>
    </t>

    `);
registerTemplate("web.TreeEditor.List", `/web/static/src/core/tree_editor/tree_editor_components.xml`, `<t t-name="web.TreeEditor.List" xml:space="preserve">
        <div class="o_input d-flex flex-wrap gap-1">
            <TagsList tags="tags"/>
            <div class="flex-grow-1">
                <t t-call="web.TreeEditor.Editor">
                    <t t-set="info" t-value="props.editorInfo"/>
                    <t t-set="value" t-value="props.editorInfo.defaultValue()"/>
                    <t t-set="update" t-value="(val) =&gt; this.update(val)"/>
                </t>
            </div>
        </div>
    </t>

`);
registerTemplate("web.login_user_switch", `/web/static/src/core/user_switch/user_switch.xml`, `<t t-name="web.login_user_switch" xml:space="preserve">
        <t t-if="state.users.length">
            <t t-if="state.displayUserChoice">
                <div class="oe_login_form o_user_switch user-select-none my-4" t-ref="root">
                    <p>Choose a user</p>
                    <div class="list-group my-3">
                        <t t-foreach="state.users" t-as="user" t-key="user_index">
                            <button type="button" class="list-group-item list-group-item-action d-flex justify-content-between align-items-center" t-on-click="() =&gt; this.fillForm(user.login)">
                                <span class="d-flex justify-content-begin align-items-center">
                                    <img class="o_avatar o_user_avatar rounded me-2" t-attf-src="{{getAvatarUrl(user)}}" t-att-alt="user.login"/>
                                    <t t-esc="user.name"/>
                                </span>
                                <i class="fa fa-times" title="Remove user from switcher" t-on-click.stop="() =&gt; this.remove(user)"/>
                            </button>
                        </t>
                    </div>
                    <button type="button" class="btn btn-link btn-sm w-100" t-on-click="() =&gt; this.fillForm()">
                        <i class="fa fa-user-circle-o"/> <span class="ms-1">Use another user</span>
                    </button>
                </div>
            </t>
            <t t-else="" t-portal="'label.form-label'">
                <button type="button" class="o_user_switch_btn btn btn-sm btn-link m-0 p-0" tabindex="1" t-on-click="() =&gt; this.toggleFormDisplay()">
                    Choose a user
                </button>
            </t>
        </t>
    </t>
`);
registerTemplate("web.ActionMenus", `/web/static/src/search/action_menus/action_menus.xml`, `<t t-name="web.ActionMenus" xml:space="preserve">
        <div class="o_cp_action_menus d-flex pe-2 gap-1">
            <div t-if="props.items.print?.length" class="d-inline-block">
                <Dropdown beforeOpen.bind="loadPrintItems">
                    <button class="btn btn-secondary" data-hotkey="shift+u">
                        <i class="fa fa-print me-1"/>
                        <span class="o_dropdown_title" t-out="props.printDropdownTitle"/>
                    </button>
                    <t t-set-slot="content">
                        <t t-foreach="state.printItems" t-as="item" t-key="item.key">
                            <DropdownItem class="item.class" onSelected="() =&gt; this.onItemSelected(item)" t-out="item.description"/>
                        </t>
                    </t>
                </Dropdown>
            </div>

            <div t-if="actionItems.length" class="d-inline-block">
                <Dropdown>
                    <button class="btn btn-secondary" data-hotkey="u">
                        <i class="fa fa-cog me-1"/>
                        <span class="o_dropdown_title">Actions</span>
                    </button>
                    <t t-set-slot="content">
                        <t t-foreach="actionItems" t-as="item" t-key="item.key">
                            <t t-if="currentGroup !== null and currentGroup !== item.groupNumber">
                                <div role="separator" class="dropdown-divider"/>
                            </t>
                            <t t-if="item.Component" t-component="item.Component" t-props="item.props"/>
                            <DropdownItem t-else="" class="'o_menu_item'" onSelected="() =&gt; this.onItemSelected(item)">
                                <i t-if="item.icon" t-att-class="item.icon + ' me-1 fa-fw oi-fw'"/>
                                <t t-esc="item.description"/>
                            </DropdownItem>
                            <t t-set="currentGroup" t-value="item.groupNumber"/>
                        </t>
                    </t>
                </Dropdown>
        </div>
        </div>
    </t>

`);
registerTemplate("web.Breadcrumbs", `/web/static/src/search/breadcrumbs/breadcrumbs.xml`, `<t t-name="web.Breadcrumbs" xml:space="preserve">
        <t t-set="currentBreadcrumbs" t-value="props.breadcrumbs.slice(-1)"/>
        <t t-set="visiblePathBreadcrumbs" t-value="props.breadcrumbs.slice(-3, -1)"/>
        <t t-set="collapsedBreadcrumbs" t-value="props.breadcrumbs.slice(0, -3).reverse()"/>
        <t t-set="breadcrumb" t-value="currentBreadcrumbs[0] || {}"/>

        <div t-if="collapsedBreadcrumbs.length || visiblePathBreadcrumbs.length" class="o_breadcrumb d-flex flex-row flex-md-column align-self-stretch justify-content-between min-w-0">
            <t t-if="env.isSmall">
                <t t-set="previousBreadcrumb" t-value="visiblePathBreadcrumbs.at(-1)"/>
                <button class="o_back_button btn btn-link d-print-none px-1 py-0" t-on-click.prevent="previousBreadcrumb.onSelected">
                    <i class="oi oi-fw oi-arrow-left"/>
                </button>
            </t>
            <t t-else="">
                <ol class="breadcrumb flex-nowrap text-nowrap lh-sm">
                    <li t-if="collapsedBreadcrumbs.length" class="breadcrumb-item d-inline-flex min-w-0">
                        <Dropdown>
                            <button class="btn btn-light btn-sm px-1 p-0">
                                <i class="fa fa-ellipsis-h"/>
                            </button>
                            <t t-set-slot="content">
                                <t t-foreach="collapsedBreadcrumbs" t-as="breadcrumb" t-key="breadcrumb.jsId">
                                    <DropdownItem onSelected="breadcrumb.onSelected" attrs="{ href: breadcrumb.url, 'data-tooltip': getBreadcrumbTooltip(breadcrumb)}">
                                        <t t-call="web.Breadcrumb.Name"/>
                                    </DropdownItem>
                                </t>
                            </t>
                        </Dropdown>
                    </li>
                    <t t-foreach="visiblePathBreadcrumbs" t-as="breadcrumb" t-key="breadcrumb.jsId">
                        <li class="breadcrumb-item d-inline-flex min-w-0" t-att-class="{ o_back_button: breadcrumb_last }" t-att-data-hotkey="breadcrumb_last and 'b'" t-on-click.prevent="breadcrumb.onSelected">
                            <a t-att-href="breadcrumb.url" class="fw-bold text-truncate" t-att-data-tooltip="'Back to &quot;' + breadcrumb.name + '&quot;' + (breadcrumb.isFormView ? ' form' : '')"><t t-call="web.Breadcrumb.Name"/></a>
                        </li>
                    </t>
                </ol>
            </t>
            <div class="d-flex gap-1 text-truncate">
                <div class="o_last_breadcrumb_item active d-flex gap-2 align-items-center min-w-0 lh-sm">
                    <span class="min-w-0 text-truncate" t-call="web.Breadcrumb.Name"/>
                </div>
                <t t-call="web.Breadcrumb.Actions"/>
            </div>
        </div>

        <div t-else="" class="o_breadcrumb d-flex gap-1 text-truncate">
            <div class="o_last_breadcrumb_item active d-flex fs-4 min-w-0 align-items-center">
                <span class="min-w-0 text-truncate" t-call="web.Breadcrumb.Name"/>
            </div>
            <t t-call="web.Breadcrumb.Actions"/>
        </div>

        <t t-slot="breadcrumb-status-indicator"/>
    </t>

    `);
registerTemplate("web.Breadcrumb.Actions", `/web/static/src/search/breadcrumbs/breadcrumbs.xml`, `<t t-name="web.Breadcrumb.Actions" xml:space="preserve">
        <div class="o_control_panel_breadcrumbs_actions d-inline-flex d-print-none">
            <t t-slot="breadcrumb-additional-actions"/>
        </div>
    </t>

    `);
registerTemplate("web.Breadcrumb.Name", `/web/static/src/search/breadcrumbs/breadcrumbs.xml`, `<t t-name="web.Breadcrumb.Name" xml:space="preserve">
        <t t-if="breadcrumb.name" t-out="breadcrumb.name"/>
        <em t-else="" class="text-warning">Unnamed</em>
    </t>

`);
registerTemplate("web.CogMenu", `/web/static/src/search/cog_menu/cog_menu.xml`, `<t t-name="web.CogMenu" xml:space="preserve">
        <div t-if="hasItems" class="o_cp_action_menus d-flex align-items-center gap-1" t-att-class="{'pe-2': !env.isSmall}">
            <div class="lh-1">
                <Dropdown menuClass="'lh-base'" beforeOpen.bind="loadPrintItems">
                    <button class="d-print-none btn" t-att-class="env.isSmall ? 'btn-secondary' : 'lh-sm p-0 border-0'" data-hotkey="u" data-tooltip="Actions">
                        <i class="fa fa-fw fa-cog"/>
                    </button>

                    <t t-set-slot="content">
                        <t t-if="state.printItems.length">
                            <Dropdown t-if="state.printItems.length &gt; 1">
                                <button>
                                    <i class="fa fa-print me-1"/> <t t-out="props.printDropdownTitle"/>
                                </button>
                                <t t-set-slot="content">
                                    <DropdownItem t-foreach="state.printItems" t-as="item" t-key="item.key" class="'o_menu_item'" onSelected="() =&gt; this.onItemSelected(item)">
                                        <t t-esc="item.description"/>
                                    </DropdownItem>
                                </t>
                            </Dropdown>

                            <DropdownItem t-else="" class="'o_menu_item'" onSelected="() =&gt; this.onItemSelected(state.printItems[0])">
                                <i class="fa fa-print me-1"/> <t t-out="state.printItems[0].description"/>
                            </DropdownItem>
                        </t>

                        <t t-foreach="cogItems" t-as="item" t-key="item.key">
                            <t t-if="currentGroup !== null and currentGroup !== item.groupNumber">
                                <div role="separator" class="dropdown-divider"/>
                            </t>

                            <t t-if="item.Component" t-component="item.Component" t-props="item.props"/>

                            <DropdownItem t-else="" class="'o_menu_item'" onSelected="() =&gt; this.onItemSelected(item)">
                                <i t-if="item.icon" t-att-class="item.icon" class="fa-fw oi-fw me-1"/>
                                <t t-esc="item.description"/>
                            </DropdownItem>

                            <t t-set="currentGroup" t-value="item.groupNumber"/>
                        </t>
                    </t>
                </Dropdown>
            </div>
        </div>
    </t>

`);
registerTemplate("web.ControlPanel", `/web/static/src/search/control_panel/control_panel.xml`, `<t t-name="web.ControlPanel" xml:space="preserve">
        <div class="o_control_panel d-flex flex-column gap-3 px-3 pt-2 pb-3" t-ref="root" data-command-category="actions">
            <Transition t-if="!env.isSmall" visible="state.embeddedInfos.showEmbedded" name="'o-fade'" t-slot-scope="transition" leaveDuration="500">
                <div class="o_embedded_actions overflow-hidden d-flex flex-wrap w-100 align-items-center justify-content-center gap-2" t-att-class="transition.className">
                    <t t-foreach="state.embeddedInfos.embeddedActions" t-as="action" t-key="action.id">
                        <t t-if="_checkValueLocalStorage(action)">
                            <button class="btn btn-secondary o_draggable" t-att-class="{ 'active': state.embeddedInfos.currentEmbeddedAction?.id === action.id}" t-on-click="() =&gt; this.onEmbeddedActionClick(action)" t-att-data-id="action.id">
                                <span t-out="action.name"/>
                            </button>
                        </t>
                    </t>
                    <t t-call="web.embeddedActionsDropdown"/>
                </div>
            </Transition>
            <div class="o_control_panel_main d-flex flex-wrap flex-lg-nowrap justify-content-between align-items-lg-start gap-lg-3 flex-grow-1">
                <div class="o_control_panel_breadcrumbs d-flex align-items-center gap-1 order-0 h-lg-100">
                    <div class="o_control_panel_main_buttons d-flex gap-1 d-empty-none d-print-none" t-ref="mainButtons" t-on-keydown="onMainButtonsKeydown">
                        <div t-if="env.isSmall" class="btn-group o_control_panel_collapsed_create">
                            <t t-slot="control-panel-create-button"/>
                            <button t-att-class="{invisible: display.disableDropdown}" type="button" class="btn btn-primary dropdown-toggle dropdown-toggle-split o_control_panel_collapsed_create" data-bs-toggle="dropdown" aria-expanded="false">
                                 <span class="visually-hidden">Toggle Dropdown</span>
                            </button>
                            <ul class="dropdown-menu o_control_panel_collapsed_create">
                                <t t-slot="layout-buttons"/>
                                <t t-slot="control-panel-always-buttons"/>
                            </ul>
                        </div>
                        <div t-else="" class="d-inline-flex gap-1">
                            <t t-slot="control-panel-create-button"/>
                            <t t-slot="layout-buttons"/>
                            <t t-slot="control-panel-always-buttons"/>
                        </div>
                    </div>
                    <t t-if="env.config.noBreadcrumbs">
                        <section class="o_control_panel_breadcrumbs_actions d-contents d-print-none">
                            <t t-slot="control-panel-additional-actions"/>
                            <t t-slot="control-panel-status-indicator"/>
                        </section>
                    </t>
                    <t t-elif="env.isSmall">

                        <div class="o_fallback_breadcrumbs d-contents"/>
                        <Breadcrumbs breadcrumbs="breadcrumbs" t-portal="'.o_navbar_breadcrumbs, .o_fallback_breadcrumbs'"/>
                        <section class="o_control_panel_breadcrumbs_actions d-contents">
                            <t t-slot="control-panel-additional-actions"/>
                            <t t-slot="control-panel-status-indicator"/>
                        </section>
                    </t>
                    <t t-else="">
                        <Breadcrumbs breadcrumbs="breadcrumbs">
                            <t t-set-slot="breadcrumb-status-indicator">
                                <t t-slot="control-panel-status-indicator"/>
                            </t>
                            <t t-set-slot="breadcrumb-additional-actions">
                                <t t-slot="control-panel-additional-actions"/>
                            </t>
                        </Breadcrumbs>
                    </t>
                    <div t-if="!env.isSmall" class="me-auto"/> 
                </div>

                <div class="o_control_panel_actions d-empty-none d-flex align-items-center justify-content-start justify-content-lg-around order-2 order-lg-1 w-100 mw-100 w-lg-auto">
                    <t t-if="display.layoutActions" t-slot="layout-actions"/>
                    <t t-slot="control-panel-selection-actions"/>
                </div>

                <div class="o_control_panel_navigation d-flex flex-wrap flex-md-nowrap justify-content-end gap-1 gap-xl-3 order-1 order-lg-2 flex-grow-1">
                    <t t-if="state.embeddedInfos.embeddedActions?.length and env.isSmall">
                        <t t-call="web.embeddedActionsDropdown"/>
                    </t>
                    <div t-if="pagerProps and pagerProps.total &gt; 0" class="o_cp_pager text-nowrap " role="search">
                        <Pager t-props="pagerProps"/>
                    </div>
                    <button t-if="state.embeddedInfos.embeddedActions?.length and !env.isSmall" class="btn btn-secondary" t-att-class="{active: state.embeddedInfos.showEmbedded}" t-on-click="onClickShowEmbedded">
                        <i class="fa fa-sliders"/>
                    </button>
                    <t t-if="env.config.viewSwitcherEntries?.length &gt; 1">
                        <div t-if="env.isSmall" class="o_cp_switch_buttons btn-group d-print-none">
                            <Dropdown>
                                <button class="btn btn-secondary">
                                    <t t-set="activeView" t-value="env.config.viewSwitcherEntries.find((view) =&gt; view.active)"/>
                                    <i class="oi-fw" t-att-class="activeView.icon"/>
                                </button>
                                <t t-set-slot="content">
                                    <t t-foreach="env.config.viewSwitcherEntries" t-as="view" t-key="view.type">
                                        <DropdownItem onSelected="() =&gt; this.switchView(view.type)" class="view.active ? 'selected' : ''">
                                            <i class="oi-fw" t-att-class="view.icon"/>
                                            <span class="ms-1" t-out="view.name"/>
                                        </DropdownItem>
                                    </t>
                                </t>
                            </Dropdown>
                        </div>
                        <nav t-else="" class="o_cp_switch_buttons d-print-none d-inline-flex btn-group">
                            <t t-foreach="env.config.viewSwitcherEntries" t-as="view" t-key="view.type">
                                <button class="btn btn-secondary o_switch_view " t-attf-class="o_{{view.type}} {{view.active ? 'active' : ''}}" t-att-data-tooltip="view.name" t-on-click="() =&gt; this.switchView(view.type)">
                                    <i t-att-class="view.icon"/>
                                </button>
                            </t>
                        </nav>
                    </t>
                    <t t-slot="control-panel-navigation-additional"/>
                </div>
            </div>
        </div>
    </t>

    `);
registerTemplate("web.embeddedActionsDropdown", `/web/static/src/search/control_panel/control_panel.xml`, `<t t-name="web.embeddedActionsDropdown" xml:space="preserve">
        <Dropdown menuClass="'o_embedded_actions_dropdown_menu'">
            <button class="btn btn-secondary">
                <i class="fa fa-fw fa-sliders"/>
            </button>
            <t t-set-slot="content">
                <t t-foreach="state.embeddedInfos.embeddedActions" t-as="action" t-key="action.id">
                    <DropdownItem class="this.getDropdownClass(action)" onSelected="() =&gt; this.env.isSmall ? this.onEmbeddedActionClick(action) : this._setVisibility(action.id)" closingMode="'none'">
                        <div class="d-flex p-0 pe-1 align-items-center justify-content-between">
                            <span t-out="action.name"/>
                            <i t-if="action.is_deletable" class="o_icon_right btn btn-link text-danger p-0 position-absolute end-0 fa fa-trash-o" title="Delete item" t-on-click.stop="() =&gt; this.openConfirmationDialog(action)"/>
                        </div>
                    </DropdownItem>
                </t>
                <div role="separator" class="dropdown-divider"/>
                <AccordionItem class="'o_save_current_view'" description.translate="Save View">
                    <div class="px-2 py-2">
                        <input type="text" t-ref="newActionNameRef" class="o_input mb-2" t-model.trim="state.embeddedInfos.newActionName"/>
                        <CheckBox value="state.embeddedInfos.newActionIsShared" onChange.bind="_onShareCheckboxChange">
                            <span data-tooltip="Make this embedded action available to other users">Shared</span>
                        </CheckBox>
                    </div>
                    <div class="px-3 py-2">
                        <button class="o_save_favorite btn btn-primary w-100" t-on-click="_saveNewAction">
                            Save
                        </button>
                    </div>
                </AccordionItem>
            </t>
        </Dropdown>
    </t>

`);
registerTemplate("web.CustomFavoriteItem", `/web/static/src/search/custom_favorite_item/custom_favorite_item.xml`, `<t t-name="web.CustomFavoriteItem" xml:space="preserve">
        <AccordionItem class="'o_add_favorite text-truncate'" description.translate="Save current search">
            <div class="px-3 py-2">
                <input type="text" class="o_input" t-ref="description" t-model.trim="state.description" t-on-keydown="onInputKeydown"/>
                <CheckBox value="state.isDefault" onChange.bind="onDefaultCheckboxChange">
                    <span data-tooltip="Use this filter by default when opening this view">Default filter</span>
                </CheckBox>
                <CheckBox value="state.isShared" onChange.bind="onShareCheckboxChange">
                    <span data-tooltip="Make this filter available to other users">Shared</span>
                </CheckBox>
            </div>
            <div class="px-3 py-2">
                <button class="o_save_favorite btn btn-primary w-100" t-on-click="saveFavorite">
                    Save
                </button>
            </div>
        </AccordionItem>
    </t>

`);
registerTemplate("web.CustomGroupByItem", `/web/static/src/search/custom_group_by_item/custom_group_by_item.xml`, `<t t-name="web.CustomGroupByItem" xml:space="preserve">
        <select class="o_add_custom_group_menu o_menu_item dropdown-item" t-on-change="(ev) =&gt; this.onSelected(ev)">
            <option value="" disabled="true" selected="true" hidden="true">Add Custom Group</option>
            <option t-foreach="props.fields" t-as="field" t-key="field.name" t-if="field.type !== 'properties' and !field.isProperty" t-att-value="field.name" t-esc="field.string"/>
        </select>
    </t>

`);
registerTemplate("web.Layout", `/web/static/src/search/layout.xml`, `<t t-name="web.Layout" xml:space="preserve">
        <t t-if="env.inDialog" t-portal="'#' + env.dialogId + ' .modal-footer'">
            <t t-slot="layout-buttons"/>
        </t>
        <t t-component="components.ControlPanel" slots="controlPanelSlots" t-if="props.display.controlPanel" display="props.display.controlPanel"/>
        <div t-ref="content" class="o_content" t-attf-class="{{props.className}}" t-att-class="{ 'o_component_with_search_panel': props.display.searchPanel }">
            <t t-component="components.SearchPanel" t-if="props.display.searchPanel"/>
            <t t-slot="default" contentRef="contentRef"/>
        </div>
    </t>

`);
registerTemplate("web.PropertiesGroupByItem", `/web/static/src/search/properties_group_by_item/properties_group_by_item.xml`, `<t t-name="web.PropertiesGroupByItem" xml:space="preserve">
        <AccordionItem class="'o_add_custom_group_menu text-truncate'" description="props.item.description" selected="isActive">
            <t t-set="items" t-value="state.groupByItems"/>
            <t t-if="items and items.length">
                <t t-foreach="items" t-as="item" t-key="item.name">
                    <t t-set="description" t-value="isSingleParent ? item.description : \`\${item.description} (\${item.definitionRecordName})\`"/>

                    <AccordionItem t-if="item.options" description="description" selected="item.isActive">
                        <t t-foreach="item.options" t-as="option" t-key="option.id">
                            <t t-set="optionName" t-value="\`\${item.name}:\${option.id}\`"/>
                            <CheckboxItem class="{ o_item_option: true, selected: option.isActive }" checked="option.isActive" closingMode="'none'" t-esc="option.description" onSelected="() =&gt; this.onGroup({ itemId: item.id, optionId: option.id})"/>
                        </t>
                    </AccordionItem>

                    <CheckboxItem t-else="" class="{ o_menu_item: true, selected: item.isActive }" checked="item.isActive" closingMode="'none'" t-esc="description" onSelected="() =&gt; this.onGroup({ itemId: item.id })"/>
                </t>
            </t>
            <DropdownItem t-else="" closingMode="'none'" class="'fst-italic'">
                No Properties
            </DropdownItem>
        </AccordionItem>
    </t>
`);
registerTemplate("web.SearchBar.Facets", `/web/static/src/search/search_bar/search_bar.xml`, `<t t-name="web.SearchBar.Facets" xml:space="preserve">
        <t t-foreach="env.searchModel.facets" t-as="facet" t-key="facet_index">
            <div class="o_searchview_facet position-relative d-inline-flex align-items-stretch rounded-2 bg-200 text-nowrap opacity-trigger-hover mw-100" t-att-class="{o_facet_with_domain: facet.domain }" role="listitem" aria-label="search" tabindex="0" t-on-keydown="ev =&gt; this.onFacetKeydown(facet, facet_index, ev)">


                <div class="position-absolute start-0 top-0 bottom-0 end-0 bg-view border rounded-2 shadow opacity-0 opacity-100-hover"/>

                <div class="o_searchview_facet_label position-relative rounded-start-2 px-1 rounded-end-0 p-0" t-on-click="(ev) =&gt; this.onFacetLabelClick(ev.target, facet)" t-att-role="facet.domain ? 'button' : 'img'" t-att-class="{                         'text-bg-action': facet.type == 'groupBy' || facet.type == 'comparison',                         'btn': facet.type == 'groupBy' and env.searchModel.canOrderByCount,                         'btn btn-primary': facet.type == 'field' || facet.type == 'filter',                         'btn btn-favourite': facet.type == 'favorite'                     }">
                    <i t-if="facet.icon" class="small fa-fw" t-att-class="facet.icon" role="image"/>
                    <small t-else="" class="px-1" t-esc="facet.title"/>


                    <span t-if="facet.domain" class="position-absolute start-0 top-0 bottom-0 end-0 bg-inherit opacity-0 opacity-100-hover" t-att-class="{'px-2 transition-base': !facet.icon}">
                        <i class="fa fa-fw fa-cog"/>
                    </span>
                    <span t-if="env.searchModel.canOrderByCount and facet.type === 'groupBy' and !env.searchModel.orderByCount" class="position-absolute start-0 top-0 bottom-0 end-0 bg-inherit opacity-0 opacity-100-hover" t-att-class="{'px-2 transition-base': !facet.icon}">
                        <i class="fa fa-fw fa-sort"/>
                    </span>
                </div>

                <div class="o_facet_values position-relative d-flex flex-wrap align-items-center ps-2 rounded-end-2 text-wrap overflow-hidden">
                    <t t-foreach="facet.values" t-as="facetValue" t-key="facetValue_index">
                        <em t-if="!facetValue_first" class="o_facet_values_sep small fw-bold mx-1 opacity-50" t-esc="facet.separator"/>
                        <small class="o_facet_value text-truncate" t-esc="facetValue" t-att-title="facetValue"/>
                    </t>
                    <button class="o_facet_remove oi oi-close btn btn-link py-0 px-2 text-danger d-print-none" role="button" aria-label="Remove" title="Remove" t-on-click="() =&gt; this.onFacetRemove(facet)"/>
                </div>
            </div>
        </t>
    </t>

    `);
registerTemplate("web.SearchBar.Input", `/web/static/src/search/search_bar/search_bar.xml`, `<t t-name="web.SearchBar.Input" xml:space="preserve">
        <input type="text" class="o_searchview_input o_input d-print-none flex-grow-1 w-auto border-0" accesskey="Q" placeholder="Search..." role="searchbox" t-ref="autofocus" t-on-keydown="onSearchKeydown" t-on-click="onSearchClick" t-on-input="onSearchInput"/>
    </t>

    `);
registerTemplate("web.SearchBar.Items", `/web/static/src/search/search_bar/search_bar.xml`, `<t t-name="web.SearchBar.Items" xml:space="preserve">
        <ul class="o-dropdown--menu dropdown-menu o_searchview_autocomplete show" role="menu">
            <t t-foreach="items" t-as="item" t-key="item.id">
                <li class="o_menu_item dropdown-item" t-att-class="{ o_indent: item.isChild, focus: item_index === state.focusedIndex}" t-att-id="item.id" t-on-click="() =&gt; this.selectItem(item)" t-on-mousemove="() =&gt; this.onItemMousemove(item_index)">
                    <t t-if="item.isParent">
                        <a t-att-class="{ o_expand: true, 'ms-4': item.isFieldProperty}" href="#" t-on-click.stop.prevent="() =&gt; this.toggleItem(item, !item.isExpanded)">
                            <i t-attf-class="fa fa-caret-{{ item.isExpanded ? 'down' : 'right' }}"/>
                        </a>
                    </t>
                    <a href="#" t-on-click.prevent="" t-att-class="{'ps-3 pe-2 text-truncate': item.isFieldProperty }" t-att-title="item.title">
                        <t t-if="item.isAddCustomFilterButton"><span class="text-action">Add Custom Filter</span></t>
                        <t t-elif="item.loadMore"><span class="text-action"><t t-esc="item.label"/></span></t>
                        <t t-elif="item.isChild">
                            <t t-esc="item.label"/>
                        </t>
                        <t t-elif="!item.isFieldProperty"> Search </t> <b t-esc="item.searchItemDescription"/> <t t-if="item.preposition"> <t t-esc="item.preposition"/>: <b class="fst-italic text-primary" t-esc="item.label"/> </t>
                    </a>
                </li>
            </t>
        </ul>
    </t>

    `);
registerTemplate("web.SearchBar", `/web/static/src/search/search_bar/search_bar.xml`, `<t t-name="web.SearchBar" xml:space="preserve">
        <div t-if="visibilityState.showSearchBar" class="o_cp_searchview d-flex input-group mt-1 mt-md-0" role="search" t-ref="root">
            <div class="o_searchview form-control d-print-contents d-flex align-items-center py-1 border-end-0" role="search" aria-autocomplete="list">
                <button class="d-print-none btn border-0 p-0" role="button" aria-label="Search..." title="Search..." t-on-click="this.onClickSearchIcon">
                    <i class="o_searchview_icon oi oi-search me-2" role="img"/>
                </button>
                <div class="o_searchview_input_container d-flex flex-grow-1 flex-wrap gap-1 mw-100">
                    <t t-call="web.SearchBar.Facets"/>
                    <t t-call="web.SearchBar.Input"/>
                    <t t-if="items.length">
                        <t t-call="web.SearchBar.Items"/>
                    </t>
                </div>
            </div>
            <SearchBarMenu dropdownState="searchBarDropdownState">
                <t t-slot="search-bar-additional-menu"/>
            </SearchBarMenu>
        </div>
    </t>

`);
registerTemplate("web.SearchBar.Toggler", `/web/static/src/search/search_bar/search_bar_toggler.xml`, `<t t-name="web.SearchBar.Toggler" xml:space="preserve">
        <button t-if="props.isSmall" t-attf-class="btn btn-secondary {{ props.showSearchBar ? 'active' : '' }}" t-on-click="props.toggleSearchBar">
            <i class="fa fa-fw fa-search"/>
        </button>
    </t>

`);
registerTemplate("web.SearchBarMenu", `/web/static/src/search/search_bar_menu/search_bar_menu.xml`, `<t t-name="web.SearchBarMenu" xml:space="preserve">
        <Dropdown menuClass="'o_search_bar_menu d-flex flex-wrap flex-lg-nowrap w-100 w-md-auto mx-md-auto mt-2 py-3'" position="'bottom-end'" state="this.props.dropdownState" t-if="this.env.searchModel.searchMenuTypes.size">
            <button class="o_searchview_dropdown_toggler d-print-none btn btn-outline-secondary o-dropdown-caret rounded-start-0" data-hotkey="shift+q" title="Toggle Search Panel">
            </button>
            <t t-set-slot="content">

                <t t-if="this.env.searchModel.searchMenuTypes.has('filter')">
                    <div class="o_dropdown_container o_filter_menu w-100 w-lg-auto h-100 px-3 mb-4 mb-lg-0 border-end">
                        <div class="px-3 fs-5 mb-2">
                            <i class="me-2 text-primary" t-att-class="facet_icons.filter"/>
                            <h5 class="o_dropdown_title d-inline">Filters</h5>
                        </div>
                        <t t-set="currentGroup" t-value="null"/>
                        <t t-foreach="filterItems" t-as="item" t-key="item.id">
                            <t t-if="currentGroup !== null and currentGroup !== item.groupNumber">
                                <div class="dropdown-divider" role="separator"/>
                            </t>
                            <t t-if="item.options">
                                <AccordionItem class="'text-truncate'" description="item.description" selected="item.isActive">
                                    <t t-set="subGroup" t-value="null"/>
                                    <t t-foreach="item.options" t-as="option" t-key="option.id">
                                        <t t-if="subGroup !== null and subGroup !== option.groupNumber">
                                            <div class="dropdown-divider" role="separator"/>
                                        </t>
                                        <CheckboxItem class="{ o_item_option: true, selected: option.isActive }" t-esc="option.description" checked="option.isActive" closingMode="'none'" onSelected="() =&gt; this.onFilterSelected({ itemId: item.id, optionId: option.id })"/>
                                        <t t-set="subGroup" t-value="option.groupNumber"/>
                                    </t>
                                </AccordionItem>
                            </t>
                            <t t-else="">
                                <CheckboxItem class="{ 'o_menu_item text-truncate': true, selected: item.isActive }" checked="item.isActive" closingMode="'none'" t-esc="item.description" attrs="{ title: item.description.length &gt; 15 ? item.description : ''}" onSelected="() =&gt; this.onFilterSelected({ itemId: item.id })"/>
                            </t>
                            <t t-set="currentGroup" t-value="item.groupNumber"/>
                        </t>
                        <t t-if="filterItems.length">
                            <div role="separator" class="dropdown-divider"/>
                        </t>
                        <DropdownItem class="'o_menu_item o_add_custom_filter'" onSelected.bind="onAddCustomFilterClick">Add Custom Filter</DropdownItem>
                    </div>
                </t>

                <t t-if="this.env.searchModel.searchMenuTypes.has('groupBy')">
                    <div class="o_dropdown_container o_group_by_menu w-100 w-lg-auto h-100 px-3 mb-4 mb-lg-0 border-end">
                        <div class="px-3 fs-5 mb-2">
                            <i class="me-2 text-action" t-att-class="facet_icons.groupBy"/>
                            <h5 class="o_dropdown_title d-inline">Group By</h5>
                        </div>
                        <t t-set="currentGroup" t-value="null"/>
                        <t t-foreach="groupByItems" t-as="item" t-key="item.id">
                            <t t-if="currentGroup !== null and currentGroup !== item.groupNumber">
                                <div class="dropdown-divider" role="separator"/>
                            </t>
                            <t t-if="item.fieldType === 'properties'">
                                <PropertiesGroupByItem item="item" onGroup.bind="onGroupBySelected"/>
                            </t>
                            <t t-elif="item.options">
                                <AccordionItem class="'text-truncate'" description="item.description" selected="item.isActive">
                                    <t t-set="subGroup" t-value="null"/>
                                    <t t-foreach="item.options" t-as="option" t-key="option.id">
                                        <t t-if="subGroup !== null and subGroup !== option.groupNumber">
                                            <div class="dropdown-divider" role="separator"/>
                                        </t>
                                        <CheckboxItem class="{ o_item_option: true, selected: option.isActive }" checked="option.isActive ? true : false" closingMode="'none'" t-esc="option.description" attrs="{ title: option.description.length &gt; 15 ? option.description : ''}" onSelected="() =&gt; this.onGroupBySelected({ itemId: item.id, optionId: option.id})"/>
                                        <t t-set="subGroup" t-value="option.groupNumber"/>
                                    </t>
                                </AccordionItem>
                            </t>
                            <t t-else="">
                                <CheckboxItem class="{ 'o_menu_item text-truncate': true, selected: item.isActive }" checked="item.isActive" closingMode="'none'" t-esc="item.description" attrs="{ title: item.description.length &gt; 15 ? item.description : ''}" onSelected="() =&gt; this.onGroupBySelected({ itemId: item.id })"/>
                            </t>
                            <t t-set="currentGroup" t-value="item.groupNumber"/>
                        </t>
                        <t t-if="!hideCustomGroupBy and fields.length">
                            <div t-if="groupByItems.length" role="separator" class="dropdown-divider"/>
                            <CustomGroupByItem fields="fields" onAddCustomGroup.bind="onAddCustomGroup"/>
                        </t>
                    </div>
                </t>

                <t t-if="showComparisonMenu">
                    <div class="o_dropdown_container o_comparison_menu w-100 w-lg-auto h-100 px-3 border-end">
                        <div class="px-3 fs-5 mb-2">
                            <i class="me-2 text-danger" t-att-class="facet_icons.comparison"/>
                            <h5 class="o_dropdown_title d-inline">Comparison</h5>
                        </div>
                        <t t-foreach="comparisonItems" t-as="item" t-key="item.id">
                            <CheckboxItem class="{ 'o_menu_item text-truncate': true, selected: item.isActive }" checked="item.isActive" closingMode="'none'" t-esc="item.description" attrs="{ title: item.description.length &gt; 15 ? item.description : ''}" onSelected="() =&gt; this.onComparisonSelected(item.id)"/>
                        </t>
                    </div>
                </t>

                <t t-if="this.env.searchModel.searchMenuTypes.has('favorite')">
                    <div class="o_dropdown_container o_favorite_menu w-100 w-lg-auto h-100 px-3">
                        <t t-set="sharedFavoritesItems" t-value="sharedFavorites"/>
                        <t t-set="favoriteItems" t-value="favorites"/>
                        <div class="px-3 fs-5 mb-2">
                            <i class="me-2 text-favourite" t-att-class="facet_icons.favorite"/>
                            <h5 class="o_dropdown_title d-inline">Favorites</h5>
                        </div>
                        <t t-foreach="favoriteItems" t-as="item" t-key="item.id">
                            <t t-call="web.SearchBarMenu.FavoriteItem"/>
                        </t>
                        <t t-if="favoriteItems.length">
                            <div role="separator" class="dropdown-divider"/>
                        </t>
                        <t t-if="sharedFavoritesItems.length &gt; 10">
                            <AccordionItem class="'o_shared_favorites text-truncate'" description.translate="Shared filters">
                                <t t-foreach="sharedFavoritesItems" t-as="item" t-key="item.id">
                                    <t t-call="web.SearchBarMenu.FavoriteItem"/>
                                </t>
                            </AccordionItem>
                        </t>
                        <t t-else="">
                            <t t-foreach="sharedFavoritesItems" t-as="item" t-key="item.id">
                                <t t-call="web.SearchBarMenu.FavoriteItem"/>
                            </t>
                        </t>
                        <div t-if="sharedFavoritesItems.length" role="separator" class="dropdown-divider"/>
                        <t t-set="currentGroup" t-value="null"/>
                        <t t-foreach="otherItems" t-as="item" t-key="item.key">
                            <t t-if="currentGroup !== null and currentGroup !== item.groupNumber">
                                <div role="separator" class="dropdown-divider"/>
                            </t>
                            <t t-component="item.Component"/>
                            <t t-set="currentGroup" t-value="item.groupNumber"/>
                        </t>
                    </div>
                </t>
                <t t-slot="default"/>
            </t>
        </Dropdown>
    </t>

    `);
registerTemplate("web.SearchBarMenu.FavoriteItem", `/web/static/src/search/search_bar_menu/search_bar_menu.xml`, `<t t-name="web.SearchBarMenu.FavoriteItem" xml:space="preserve">
        <t t-set="item" t-value="item"/>
        <CheckboxItem class="{ 'o_menu_item text-truncate': true, selected: item.isActive }" checked="item.isActive" closingMode="'none'" onSelected="() =&gt; this.onFavoriteSelected(item.id)">
            <span class="d-flex p-0 align-items-center justify-content-between">
                <span t-esc="item.description" t-att-title="item.description.length &gt; 15 ? item.description : ''" class="text-truncate flex-grow-1"/>
                <i class="ms-1 fa fa-trash-o" title="Delete item" t-on-click.stop="() =&gt; this.openConfirmationDialog(item.id, item.userId)"/>
            </span>
        </CheckboxItem>
    </t>

`);
registerTemplate("web.SearchPanel", `/web/static/src/search/search_panel/search_panel.xml`, `<t t-name="web.SearchPanel" xml:space="preserve">
    <t t-if="env.isSmall">
        <t t-call="web.SearchPanel.Small"/>
    </t>
    <t t-else="">
        <t t-if="state.sidebarExpanded" t-call="web.SearchPanel.Regular"/>
        <t t-else="" t-call="web.SearchPanel.Sidebar"/>
    </t>
</t>

`);
registerTemplate("web.SearchPanel.Sidebar", `/web/static/src/search/search_panel/search_panel.xml`, `<t t-name="web.SearchPanel.Sidebar" xml:space="preserve">
    <div class="bg-view h-100 o_search_panel_sidebar cursor-pointer d-print-none" t-on-click="toggleSidebar">
        <t t-set="categories" t-value="getCategorySelection()"/>
        <t t-set="filters" t-value="getFilterSelection()"/>
        <div class="d-flex">
            <button class="btn btn-light btn-sm m-1 mb-2 p-2">
                <i class="fa fa-fw fa-angle-double-right"/>
            </button>
            <div class="o_search_panel_current_selection text-truncate mx-auto">
                <t t-if="!categories.length and !filters.length">
                    All
                </t>
                <t t-else="">
                    <t t-foreach="categories" t-as="category" t-key="category_index">
                        <span class="o_search_panel_category mb-2">
                            <i t-if="category.icon" t-attf-class="o_search_panel_section_icon fa {{ category.icon }} fa-rotate-90 mb-2" t-att-style="category.color and ('color: ' + category.color)"/>
                            <t t-esc="category.values.join(' / ')"/>
                        </span>
                    </t>
                    <t t-foreach="filters" t-as="filter" t-key="filter_index">
                        <span class="o_search_panel_filter mb-2">
                            <i t-if="filter.icon" t-attf-class="o_search_panel_section_icon fa {{ filter.icon }} fa-rotate-90 mb-2" t-att-style="filter.color and ('color: ' + filter.color)"/>
                            <t t-esc="filter.values.join(', ')"/>
                        </span>
                    </t>
                </t>
            </div>
        </div>
    </div>
</t>

`);
registerTemplate("web.SearchPanelContent", `/web/static/src/search/search_panel/search_panel.xml`, `<t t-name="web.SearchPanelContent" xml:space="preserve">
    <div class="o_search_panel flex-grow-0 flex-shrink-0 h-100 pb-5 bg-view overflow-auto position-relative" t-att-class="env.searchModel.searchPanelInfo.className" t-attf-class="#{env.isSmall ? 'px-3' : 'pe-1 ps-3'}" t-ref="root">
        <button t-if="!env.isSmall" class="btn btn-light btn-sm end-0 m-2 position-absolute px-2 py-1 top-0 z-1" t-on-click="toggleSidebar">
            <i class="fa fa-fw fa-angle-double-left"/>
        </button>
        <div t-if="!sections or sections.length === 0" class="o_search_panel_empty_state me-3">
            <button class="btn mt-2 w-100 overflow-visible">
                <div class="d-flex align-items-center me-2 ms-auto">All</div>
            </button>
        </div>
        <section t-foreach="sections" t-as="section" t-key="section.id" t-attf-class="o_search_panel_section o_search_panel_{{ section.type }}">
            <header class="o_search_panel_section_header pt-4 pb-2 text-uppercase cursor-default">
                <i t-attf-class="fa {{ section.icon }} o_search_panel_section_icon {{!section.color &amp;&amp; section.type == 'filter' ? 'text-warning' : !section.color ? 'text-primary': ''}} me-2" t-att-style="section.color and ('color: ' + section.color)"/>
                <b t-esc="section.description"/>
            </header>
            <t t-call="web.SearchPanel.Section"/>
        </section>
    </div>
    <div class="h-100">
        <span class="o_search_panel_resize" t-on-click.stop.prevent="" t-on-pointerdown.stop.prevent="_onStartResize"/>
    </div>
</t>

`);
registerTemplate("web.SearchPanel.Section", `/web/static/src/search/search_panel/search_panel.xml`, `<t t-name="web.SearchPanel.Section" xml:space="preserve">
    <div t-if="section.errorMsg" class="alert alert-warning">
        <span><t t-esc="section.errorMsg"/></span>
    </div>
    <ul t-else="" class="list-group d-block o_search_panel_field px-2 px-md-0">
        <t t-if="section.type === 'category'" t-call="{{ constructor.subTemplates.category }}">
            <t t-set="values" t-value="section.rootIds"/>
        </t>
        <t t-elif="section.groups">
            <li t-foreach="section.sortedGroupIds" t-as="groupId" t-key="groupId" class="o_search_panel_filter_group list-group-item p-0 border-0" t-att-class="groupId_last? 'mb-0' : 'mb-3'">

                <t t-set="_section" t-value="section"/>
                <t t-set="group" t-value="section.groups.get(groupId)"/>
                <header class="o_search_panel_group_header pb-1">
                    <div class="form-check w-100">

                        <input type="checkbox" class="form-check-input" t-attf-id="{{ section.id }}_input_{{ groupId }})" t-on-click="() =&gt; this.toggleFilterGroup(section.id, group)"/>
                        <label t-attf-for="{{ section.id }}_input_{{ groupId }})" class="o_search_panel_label form-check-label d-flex align-items-center justify-content-between w-100 cursor-pointer" t-att-class="{ o_with_counters: group.enableCounters }" t-att-title="group.tooltip or false">
                            <span class="o_search_panel_label_title text-truncate" t-attf-class="{{ group.color_index ? 'o_tag o_badge badge rounded-pill o_tag_color_' + group.color_index : ''}}">
                                <t t-esc="group.name"/>
                            </span>
                        </label>
                    </div>
                </header>
                <ul class="list-group d-block">
                    <t t-call="{{ constructor.subTemplates.filtersGroup }}">
                        <t t-set="values" t-value="group.values"/>
                        <t t-set="isChildList" t-value="true"/>

                        <t t-set="section" t-value="_section"/>
                    </t>
                </ul>
            </li>
            <ul t-if="section.groups.get(false)" class="list-group d-block">
                <t t-call="{{ constructor.subTemplates.filtersGroup }}">
                    <t t-set="group" t-value="section.groups.get(false)"/>
                    <t t-set="values" t-value="group.values"/>

                    <t t-set="section" t-value="section"/>
                </t>
            </ul>
        </t>
        <t t-else="" t-call="{{ constructor.subTemplates.filtersGroup }}">
            <t t-set="values" t-value="section.values"/>
        </t>
    </ul>
</t>

`);
registerTemplate("web.SearchPanel.Regular", `/web/static/src/search/search_panel/search_panel.xml`, `<t t-name="web.SearchPanel.Regular" t-inherit="web.SearchPanelContent" t-inherit-mode="primary" xml:space="preserve"/>

`);
registerTemplate("web.SearchPanel.Small", `/web/static/src/search/search_panel/search_panel.xml`, `<t t-name="web.SearchPanel.Small" xml:space="preserve">
    <div class="o_search_panel w-100 overflow-visible" t-ref="root">
        <div class="d-flex overflow-auto align-items-center px-2 border-top">
            <div t-if="!sections or sections.length === 0" class="o_search_panel_empty_state me-3">
                <button class="btn w-100">
                    <div class="d-flex align-items-center me-2 ms-auto">All</div>
                </button>
            </div>
            <Dropdown t-foreach="sections" t-as="section" t-key="section.id" state="getDropdownState(section.id)" menuClass="'my-2 mx-1'" onOpened.bind="updateGroupHeadersChecked">
                <span class="btn btn-secondary my-2 mx-1 o-dropdown-caret">
                    <i t-attf-class="fa {{ section.icon }} o_search_panel_section_icon {{!section.color &amp;&amp; section.type == 'filter' ? 'text-warning' : !section.color ? 'text-primary': ''}} me-2" t-att-style="section.color and ('color: ' + section.color)"/>
                    <b class="pe-2" t-if="section.type !== 'category' || !state.active[section.id]" t-esc="section.description"/>
                    <b class="pe-2" t-else="" t-esc="section.values.get(section.activeValueId)['display_name']"/>
                </span>
                <t t-set-slot="content">
                    <div t-attf-class="o_search_panel_{{ section.type }}" class="o_search_panel_section">
                        <t t-call="web.SearchPanel.Section"/>
                    </div>
                    <div t-if="section.type !== 'category' and hasSelection(section.id)" class="text-end">
                        <a href="#" title="Clear All" class="btn btn-link text-nowrap text-uppercase" t-on-click="() =&gt; this.clearSelection(section.id)">CLEAR ALL</a>
                    </div>
                </t>
            </Dropdown>
            <a href="#" t-if="hasSelection()" title="Clear All" class="btn btn-link text-nowrap text-uppercase" t-on-click="() =&gt; this.clearSelection()">CLEAR ALL</a>
            <div t-else="" class="mx-4"/>
        </div>
    </div>
</t>

`);
registerTemplate("web.SearchPanel.Category", `/web/static/src/search/search_panel/search_panel.xml`, `<t t-name="web.SearchPanel.Category" xml:space="preserve">
    <t t-foreach="values" t-as="valueId" t-key="valueId">
        <t t-set="value" t-value="section.values.get(valueId)"/>
        <li class="o_search_panel_category_value list-group-item py-1 cursor-pointer border-0 pe-0" t-att-class="isChildList ? env.isSmall ? '' : 'o_treeEntry' : 'ps-0'">
            <header class="list-group-item list-group-item-action d-flex align-items-center px-0 py-lg-0 border-0" t-att-class="{'active text-900 fw-bold': state.active[section.id] === valueId}" t-on-click="() =&gt; this.toggleCategory(section, value)">
                <div class="o_search_panel_label d-flex align-items-center overflow-hidden w-100 cursor-pointer mb-0" t-att-class="{'o_with_counters': section.enableCounters }" t-att-data-tooltip="value.display_name">
                    <button class="o_toggle_fold btn p-0 px-1 flex-shrink-0 text-center">
                        <i t-if="value.childrenIds.length" class="fa" t-att-class="{                                 'fa-caret-down' : state.expanded[section.id][valueId],                                 'fa-caret-right':  !state.expanded[section.id][valueId]                             }"/>
                    </button>
                    <span class="o_search_panel_label_title text-truncate" t-att-class="{'fw-bold' : value.bold}" t-esc="value.display_name"/>
                </div>
                <small t-if="section.enableCounters and value.__count gt 0" class="o_search_panel_counter text-muted mx-2 fw-bold" t-esc="value.__count"/>
            </header>
            <ul t-if="value.childrenIds.length and state.expanded[section.id][valueId]" class="list-group d-block">
                <t t-call="{{ constructor.subTemplates.category }}">
                    <t t-set="values" t-value="value.childrenIds"/>
                    <t t-set="isChildList" t-value="true"/>
                </t>
            </ul>
        </li>
    </t>
</t>

`);
registerTemplate("web.SearchPanel.FiltersGroup", `/web/static/src/search/search_panel/search_panel.xml`, `<t t-name="web.SearchPanel.FiltersGroup" xml:space="preserve">
    <li t-foreach="[...values.keys()]" t-as="valueId" t-key="valueId" class="o_search_panel_filter_value list-group-item p-0 mb-1 border-0 cursor-pointer" t-att-class="{ 'ps-2' : isChildList }">
        <t t-set="value" t-value="values.get(valueId)"/>
        <div class="form-check w-100">
            <input type="checkbox" t-attf-id="{{ section.id }}_input_{{ valueId }}" t-att-checked="state.active[section.id][valueId]" class="form-check-input" t-on-click="ev =&gt; this.toggleFilterValue(section.id, valueId, ev)"/>
            <label class="o_search_panel_label form-check-label d-flex align-items-center justify-content-between w-100 cursor-pointer" t-attf-for="{{ section.id }}_input_{{ valueId }}" t-att-title="(group and group.tooltip) or false">
                <span class="o_search_panel_label_title text-truncate" t-esc="value.display_name"/>
                <span t-if="section.enableCounters and value.__count gt 0" class="o_search_panel_counter text-muted mx-2 small" t-esc="value.__count"/>
            </label>
        </div>
    </li>
</t>

`);
registerTemplate("web.WithSearch", `/web/static/src/search/with_search/with_search.xml`, `<t t-name="web.WithSearch" xml:space="preserve">
    <t t-slot="default" context="searchModel.context" domain="searchModel.domain" groupBy="searchModel.groupBy" orderBy="searchModel.orderBy" comparison="searchModel.comparison" display="searchModel.display"/>
  </t>

`);
registerTemplate("web.CalendarCommonPopover", `/web/static/src/views/calendar/calendar_common/calendar_common_popover.xml`, `<t t-name="web.CalendarCommonPopover" xml:space="preserve">
        <t t-if="env.isSmall">
            <Dialog title="props.record.title" contentClass="'o_calendar_color_'+ props.record.colorIndex">
                <t t-call="{{ constructor.subTemplates.body }}"/>
                <t t-set-slot="footer">
                    <t t-call="{{ constructor.subTemplates.footer }}"/>
                </t>
            </Dialog>
        </t>
        <t t-else="">
            <t t-call="{{ constructor.subTemplates.popover }}"/>
        </t>
    </t>

    `);
registerTemplate("web.CalendarCommonPopover.popover", `/web/static/src/views/calendar/calendar_common/calendar_common_popover.xml`, `<t t-name="web.CalendarCommonPopover.popover" xml:space="preserve">
        <div class="card-header d-flex justify-content-between py-2 pe-2">
            <span class="popover-header border-0 text-truncate" t-esc="props.record.title" t-att-data-tooltip="props.record.title"/>
            <span class="o_cw_popover_close ms-4 mt-2 me-2" t-on-click.stop="() =&gt; props.close()">
                <i class="fc-close fc-icon fc-icon-x"/>
            </span>
        </div>
        <div class="o_cw_body">
            <t t-call="{{ constructor.subTemplates.body }}"/>
            <div class="card-footer d-flex gap-1 border-top" t-att-class="{ 'o_footer_shrink': !hasFooter }">
                <t t-call="{{ constructor.subTemplates.footer }}"/>
            </div>
        </div>
    </t>

    `);
registerTemplate("web.CalendarCommonPopover.body", `/web/static/src/views/calendar/calendar_common/calendar_common_popover.xml`, `<t t-name="web.CalendarCommonPopover.body" xml:space="preserve">
        <ul class="list-group list-group-flush">
            <li t-if="date" class="list-group-item">
                <i class="fa fa-fw fa-calendar text-400"/>
                <span class="fw-bold ms-2" t-esc="date"/> <small t-if="dateDuration != 'All day'"><b t-esc="dateDuration"/></small>
            </li>
            <li t-if="time" class="list-group-item">
                <i class="fa fa-fw fa-clock-o text-400"/>
                <span class="fw-bold ms-2" t-esc="time"/> <small t-if="timeDuration"><b t-esc="\`(\${timeDuration})\`"/></small>
            </li>
        </ul>
        <ul class="list-group list-group-flush o_cw_popover_fields_secondary">
            <Record resModel="props.model.resModel" resId="props.record.id" fields="props.model.fields" activeFields="activeFields" mode="'readonly'" values="props.record.rawRecord" t-slot-scope="slot">
                <t t-foreach="Object.keys(props.model.popoverFieldNodes)" t-as="fieldId" t-key="fieldId">
                    <t t-set="fieldInfo" t-value="props.model.popoverFieldNodes[fieldId]"/>
                    <t t-set="fieldType" t-value="props.model.fields[fieldId].type"/>
                    <t t-if="!isInvisible(fieldInfo, slot.record)">
                        <li class="list-group-item d-flex text-nowrap align-items-center" t-att-class="fieldInfo.attrs.class" t-att-data-tooltip="fieldType === 'html' ? '' : getFormattedValue(fieldId, slot.record)">
                            <span class="fw-bold me-2" t-if="!fieldInfo.options.noLabel">
                                <t t-if="fieldInfo.options.icon">
                                    <i t-attf-class="fa-fw {{fieldInfo.options.icon}} text-400"/>
                                </t>
                                <t t-else="">
                                    <t t-esc="fieldInfo.string"/>
                                </t>
                            </span>
                            <div class="flex-grow-1 o_cw_popover_field overflow-hidden">
                                <Field name="fieldInfo.name" record="slot.record" fieldInfo="fieldInfo" type="fieldInfo.widget"/>
                            </div>
                        </li>
                    </t>
                </t>
            </Record>
        </ul>
    </t>

    `);
registerTemplate("web.CalendarCommonPopover.footer", `/web/static/src/views/calendar/calendar_common/calendar_common_popover.xml`, `<t t-name="web.CalendarCommonPopover.footer" xml:space="preserve">
        <t t-if="isEventEditable">
            <a href="#" class="btn btn-primary o_cw_popover_edit" t-on-click="onEditEvent">Edit</a>
        </t>
        <t t-if="isEventDeletable">
            <a href="#" class="btn btn-secondary o_cw_popover_delete" t-on-click="onDeleteEvent">Delete</a>
        </t>
    </t>

`);
registerTemplate("web.CalendarCommonRenderer", `/web/static/src/views/calendar/calendar_common/calendar_common_renderer.xml`, `<t t-name="web.CalendarCommonRenderer" xml:space="preserve">
        <div class="o_calendar_widget" t-ref="fullCalendar"/>
    </t>

    `);
registerTemplate("web.CalendarCommonRenderer.event", `/web/static/src/views/calendar/calendar_common/calendar_common_renderer.xml`, `<t t-name="web.CalendarCommonRenderer.event" xml:space="preserve">
            <t t-if="!isTimeHidden">
                <span class="d-none d-lg-inline fc-time" t-esc="startTime"/>
                <t> </t>
            </t>
            <div class="o_event_title text-truncate" t-out="title"/>
    </t>

    `);
registerTemplate("web.CalendarCommonRendererHeader", `/web/static/src/views/calendar/calendar_common/calendar_common_renderer.xml`, `<t t-name="web.CalendarCommonRendererHeader" xml:space="preserve">
        <span class="o_cw_day_name" t-esc="scale == 'day' ? weekdayLong : weekdayShort "/> <span t-if="scale != 'month'" class="fc-day-number o_cw_day_number" t-esc="day"/>
    </t>

`);
registerTemplate("web.CalendarController", `/web/static/src/views/calendar/calendar_controller.xml`, `<t t-name="web.CalendarController" xml:space="preserve">
        <div t-att-class="className" t-ref="root">
            <Layout className="model.useSampleModel ? 'o_view_sample_data' : ''" display="props.display">
                <t t-set-slot="control-panel-additional-actions">
                    <CogMenu/>
                </t>
                <t t-set-slot="layout-buttons">
                    <t t-call="{{ props.buttonTemplate }}"/>
                </t>
                <t t-set-slot="layout-actions">
                    <SearchBar toggler="searchBarToggler"/>
                </t>
                <t t-set-slot="control-panel-navigation-additional">
                    <t t-component="searchBarToggler.component" t-props="searchBarToggler.props"/>
                </t>
                <div class="o_calendar_container d-grid h-100 bg-view">
                    <div class="o_calendar_header d-flex align-items-center gap-1 px-3 pe-md-1 py-2 px-print-0 pt-print-0 border-bottom">
                        <div t-if="!env.isSmall" class="o_calendar_navigation_buttons btn-group d-print-none">
                            <button class="o_calendar_button_prev btn btn-secondary d-none d-md-block" title="Previous" aria-label="Previous" t-on-click.stop="() =&gt; this.setDate('previous')"><i class="oi oi-arrow-left"/></button>
                            <button class="o_calendar_button_next btn btn-secondary d-none d-md-block" title="Next" aria-label="Next" t-on-click.stop="() =&gt; this.setDate('next')"><i class="oi oi-arrow-right"/></button>
                        </div>
                        <ViewScaleSelector scales="scales" currentScale="model.scale" isWeekendVisible="state.isWeekendVisible" setScale.bind="setScale" toggleWeekendVisibility.bind="toggleWeekendVisibility" dropdownClass="'d-print-none order-3 order-lg-0'"/>
                        <button class="btn btn-secondary o_calendar_button_today d-print-none order-2 order-lg-0 ms-auto ms-lg-0" t-att-class="env.isSmall ? 'btn-sm btn-light' : 'btn-secondary'" t-on-click.stop="() =&gt; this.setDate('today')">   <span t-if="env.isSmall" class="position-relative pt-1"><t t-esc="today"/><i class="fa fa-calendar-o position-absolute top-50 start-50 translate-middle fs-1"/></span>
                            <t t-else="">Today</t>
                        </button>
                        <h5 class="d-inline-flex ps-lg-2 ps-print-0 mb-0">
                            <t t-if="model.meta.scale === 'year'">
                                <t t-esc="currentYear"/>
                            </t>
                            <t t-elif="model.meta.scale === 'month'">
                                <t t-esc="currentMonth"/>
                            </t>
                            <t t-elif="model.meta.scale === 'week'">
                                <t t-esc="weekHeader"/> <span t-if="model.meta.scale === 'week'" class="badge bg-100 rounded px-1 ms-1">Week <t t-esc="currentWeek"/></span>
                            </t>
                            <t t-else="">
                                <t t-esc="dayHeader"/>
                            </t>
                        </h5>
                    </div>
                    <div class="o_sidebar_toggler d-none d-md-flex d-print-none align-items-center border-bottom pe-3">
                        <button class="btn btn-light oi oi-panel-right collapsed ms-2 lh-base" t-on-click="toggleSideBar"/>
                    </div>
                    <MobileFilterPanel t-if="env.isSmall" t-props="mobileFilterPanelProps"/>
                    <div class="o_calendar_wrapper d-flex overflow-hidden">
                        <t t-if="showCalendar" t-component="props.Renderer" t-props="rendererProps"/>
                        <div t-if="showSideBar" class="o_calendar_sidebar_container d-print-none position-relative w-100 w-md-auto bg-view overflow-x-hidden overflow-y-auto">
                            <div class="o_calendar_sidebar">
                                <DatePicker t-if="!env.isSmall" t-props="datePickerProps"/>
                                <FilterPanel t-props="filterPanelProps"/>
                            </div>
                        </div>
                    </div>
                </div>
            </Layout>
        </div>
    </t>

    `);
registerTemplate("web.CalendarController.controlButtons", `/web/static/src/views/calendar/calendar_controller.xml`, `<t t-name="web.CalendarController.controlButtons" xml:space="preserve"/>

`);
registerTemplate("web.CalendarRenderer", `/web/static/src/views/calendar/calendar_renderer.xml`, `<t t-name="web.CalendarRenderer" xml:space="preserve">
        <div class="o_calendar_renderer h-100 flex-grow-1">
            <ActionSwiper t-props="actionSwiperProps">
                <t t-component="calendarComponent" t-props="props" t-key="calendarKey"/>
            </ActionSwiper>
        </div>
    </t>

`);
registerTemplate("web.CalendarYearPopover", `/web/static/src/views/calendar/calendar_year/calendar_year_popover.xml`, `<t t-name="web.CalendarYearPopover" xml:space="preserve">
        <t t-if="env.isSmall">
            <Dialog title="dialogTitle">
                <t t-call="{{ constructor.subTemplates.body }}"/>
                <t t-set-slot="footer">
                    <t t-call="{{ constructor.subTemplates.footer }}"/>
                </t>
            </Dialog>
        </t>
        <t t-else="">
            <t t-call="{{ constructor.subTemplates.popover }}"/>
        </t>
    </t>

    `);
registerTemplate("web.CalendarYearPopover.popover", `/web/static/src/views/calendar/calendar_year/calendar_year_popover.xml`, `<t t-name="web.CalendarYearPopover.popover" xml:space="preserve">
        <div class="position-absolute" style="top: .75rem; right: 1rem;">
            <span class="o_cw_popover_close" t-on-click.stop="() =&gt; props.close()">
                <i class="fc-close fc-icon fc-icon-x"/>
            </span>
        </div>
        <div class="o_cw_body popover-body d-flex flex-column gap-2">
            <t t-call="{{ constructor.subTemplates.body }}"/>
            <t t-if="props.model.canCreate">
                <t t-call="{{ constructor.subTemplates.footer }}"/>
            </t>
        </div>
    </t>

    `);
registerTemplate("web.CalendarYearPopover.body", `/web/static/src/views/calendar/calendar_year/calendar_year_popover.xml`, `<t t-name="web.CalendarYearPopover.body" xml:space="preserve">
        <div t-foreach="recordGroups" t-as="recordGroup" t-key="recordGroup.title">
            <h5 t-out="recordGroup.title"/>
            <t t-foreach="recordGroup.records" t-as="record" t-key="record.id">
                <t t-call="{{ constructor.subTemplates.record }}"/>
            </t>
        </div>
    </t>

    `);
registerTemplate("web.CalendarYearPopover.footer", `/web/static/src/views/calendar/calendar_year/calendar_year_popover.xml`, `<t t-name="web.CalendarYearPopover.footer" xml:space="preserve">
        <t t-if="props.model.canCreate">
            <a href="#" class="btn-link o_cw_popover_create" t-on-click.prevent="onCreateButtonClick">
                <i class="fa fa-plus"/>
                Create
            </a>
        </t>
        <t t-else="">
            <button class="btn btn-primary o-default-button" t-on-click="props.close">
                <t>Ok</t>
            </button>
        </t>
    </t>

    `);
registerTemplate("web.CalendarYearPopover.record", `/web/static/src/views/calendar/calendar_year/calendar_year_popover.xml`, `<t t-name="web.CalendarYearPopover.record" xml:space="preserve">
        <a href="#" t-on-click.prevent="() =&gt; this.onRecordClick(record)" t-attf-style="{{ getRecordStyle(record) }}" t-attf-class="o_cw_popover_link d-flex align-items-center gap-1 {{ getRecordClass(record) }} {{record.startHour ? 'o_event_dot' : 'o_event_allday'}}" t-att-data-id="record.id" t-att-data-title="record.title">
            <span t-if="record.startHour"><t t-out="record.startHour"/></span>
            <span t-esc="record.title"/>
        </a>
    </t>

`);
registerTemplate("web.CalendarYearRenderer", `/web/static/src/views/calendar/calendar_year/calendar_year_renderer.xml`, `<t t-name="web.CalendarYearRenderer" xml:space="preserve">
        <div class="o_calendar_widget overflow-y-auto" t-ref="root">
            <div class="fc-view-container">
                <div class="fc fc-dayGridYear-view d-flex flex-wrap justify-content-evenly gap-3 px-2 py-3">
                    <t t-foreach="months" t-as="month" t-key="month">
                        <div class="fc-month-container">
                            <div class="fc-month" t-ref="fullCalendar-{{ month }}"/>
                        </div>
                    </t>
                </div>
            </div>
        </div>
    </t>

`);
registerTemplate("web.CalendarFilterPanel", `/web/static/src/views/calendar/filter_panel/calendar_filter_panel.xml`, `<t t-name="web.CalendarFilterPanel" xml:space="preserve">
        <t t-foreach="props.model.filterSections" t-as="section" t-key="section.fieldName">
            <t t-if="section.filters.length gt 0">
                <div class="o_calendar_filter d-flex flex-column gap-1 mt-4 mb-2" t-att-class="{'o-calendar-filter-panel--section-collapsed': isSectionCollapsed(section)}" t-att-data-name="section.fieldName">
                    <t t-if="section.label">
                        <div class="o_calendar_filter_items_checkall o-checkbox form-check" data-value="section">
                            <t t-set="filterId" t-value="nextFilterId"/>
                            <input type="checkbox" name="select-all" class="form-check-input" t-attf-id="o_calendar_filter_{{filterId}}" t-att-checked="isAllActive(section)" t-on-change="(ev) =&gt; this.onAllFilterInputChange(section, ev)"/>
                             <t t-if="section.canCollapse">
                                <label class="d-flex align-items-center" type="button" t-on-click.stop.prevent="() =&gt; this.toggleSection(section, ev)">
                                    <span class="o_cw_filter_label fw-bolder" t-esc="section.label"/>
                                    <i class="o_cw_filter_collapse_icon fa ms-1" t-attf-class="fa-caret-{{ isSectionCollapsed(section) ? 'left' : 'down' }}"/>
                                </label>
                            </t>
                            <t t-else="">
                                <label class="o_cw_filter_label fw-bolder" t-esc="section.label"/>
                            </t>
                        </div>
                    </t>
                    <Transition visible="!isSectionCollapsed(section)" name="'o-section-slide'" leaveDuration="350" t-slot-scope="transition">
                        <div class="o_calendar_filter_items d-flex flex-column gap-1" t-att-class="transition.className">
                            <t t-foreach="getSortedFilters(section)" t-as="filter" t-key="filter.value">
                                <t t-set="filterId" t-value="nextFilterId"/>
                                <t t-call="{{ constructor.subTemplates.filter }}"/>
                            </t>
                        </div>
                    </Transition>
                    <t t-if="section.canAddFilter">
                        <AutoComplete t-props="getAutoCompleteProps(section)"/>
                    </t>
                </div>
            </t>
        </t>
    </t>

    `);
registerTemplate("web.CalendarFilterPanel.filter", `/web/static/src/views/calendar/filter_panel/calendar_filter_panel.xml`, `<t t-name="web.CalendarFilterPanel.filter" xml:space="preserve">
        <div class="o_calendar_filter_item o-checkbox form-check position-relative w-100 overflow-hidden cursor-pointer" t-att-class="getFilterColor(filter)" t-att-data-value="filter.value">
            <input type="checkbox" name="selection" class="o_cw_filter_input_bg form-check-input" t-att-style="filter.colorIndex and typeof filter.colorIndex !== 'number' ? \`border-color: \${filter.colorIndex}; background-color: \${filter.colorIndex};\` : ''" t-attf-id="o_calendar_filter_item_{{filterId}}" t-att-checked="filter.active" t-on-change="(ev) =&gt; this.onFilterInputChange(section, filter, ev)"/>
            <label class="d-flex align-items-center gap-1" t-attf-for="o_calendar_filter_item_{{filterId}}">
                <t t-if="section.hasAvatar and filter.hasAvatar">
                    <img class="o_cw_filter_avatar o_avatar rounded" t-attf-src="/web/image/{{ section.avatar.model }}/{{ filter.value }}/{{ section.avatar.field }}" alt="Avatar"/>
                </t>
                <t t-elif="filter.type === 'all'">
                    <i class="o_cw_filter_avatar o_avatar fa fa-users fa-fw flex-shrink-0 me-1" role="img" aria-label="Avatar" title="Avatar"/>
                </t>
                <span class="o_cw_filter_title flex-grow-1 text-truncate lh-base" t-esc="filter.label"/>
            </label>
            <t t-if="filter.canRemove">
                <button class="o_remove btn position-absolute top-50 end-0 py-0 px-2 bg-view text-700 transition-base" role="img" title="Remove this favorite from the list" aria-label="Remove this favorite from the list" t-on-click="() =&gt; this.onFilterRemoveBtnClick(section, filter)">
                    <i class="oi oi-close"/>
                </button>
            </t>
        </div>
    </t>

    `);
registerTemplate("web.CalendarFilterPanel.autocomplete.options", `/web/static/src/views/calendar/filter_panel/calendar_filter_panel.xml`, `<t t-name="web.CalendarFilterPanel.autocomplete.options" xml:space="preserve">
        <img t-if="option.value" t-attf-src="/web/image/{{option.model}}/{{option.value}}/avatar_128" class="rounded me-1 o_avatar"/>
        <t t-esc="option.label"/>
    </t>
`);
registerTemplate("web.CalendarMobileFilterPanel", `/web/static/src/views/calendar/mobile_filter_panel/calendar_mobile_filter_panel.xml`, `<t t-name="web.CalendarMobileFilterPanel" xml:space="preserve">
        <div class="o_other_calendar_panel d-flex align-items-center d-print-none" t-on-click="props.toggleSideBar">
            <div class="o_filter me-auto d-flex overflow-auto">
                <t t-foreach="props.model.filterSections" t-as="section" t-key="section.fieldName">
                    <t t-if="section.filters.length gt 0">

                        <t t-foreach="getSortedFilters(section)" t-as="filter" t-key="filter.value">
                            <span t-if="filter.active" class="d-flex align-items-center text-nowrap ms-1 me-2">
                                <i class="fa fa-fw" t-att-class="getFilterColor(filter) !== 'o_color_false' ? 'fa-circle ' + getFilterColor(filter) : 'fa-circle-o'"/>
                                <span class="ms-1 fw-bold text-nowrap" t-esc="filter.label"/>
                            </span>
                        </t>
                    </t>
                </t>
            </div>
            <i t-attf-class="oi fa-fw oi-chevron-{{caretDirection}} ms-2"/>
        </div>
    </t>

`);
registerTemplate("web.CalendarQuickCreate", `/web/static/src/views/calendar/quick_create/calendar_quick_create.xml`, `<t t-name="web.CalendarQuickCreate" xml:space="preserve">
        <Dialog size="'sm'" title="dialogTitle">
            <div class="o-calendar-quick-create mb-3">
                <label for="title" class="col-form-label o_form_label">
                    Name:
                </label>
                <input type="text" class="o_input o_required_modifier o-calendar-quick-create--input" name="title" t-ref="title" t-on-keyup="onInputKeyup" t-att-value="props.title"/>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary o-calendar-quick-create--create-btn" t-on-click="onCreateBtnClick">
                    Create
                </button>
                <button class="btn btn-secondary o-calendar-quick-create--edit-btn" t-on-click="onEditBtnClick">
                    Edit
                </button>
                <button class="btn btn-secondary o-calendar-quick-create--cancel-btn" t-on-click="onCancelBtnClick">
                    Cancel
                </button>
            </t>
        </Dialog>
    </t>

`);
registerTemplate("web.AceField", `/web/static/src/views/fields/ace/ace_field.xml`, `<t t-name="web.AceField" xml:space="preserve">

        <div class="o_field_widget oe_form_field o_ace_view_editor oe_ace_open">
            <CodeEditor value="state.initialValue" mode="mode" readonly="props.readonly" onBlur.bind="commitChanges" onChange.bind="handleChange" class="'ace-view-editor'" theme="theme" maxLines="200"/>
        </div>
    </t>

`);
registerTemplate("web.AttachmentImageField", `/web/static/src/views/fields/attachment_image/attachment_image_field.xml`, `<t t-name="web.AttachmentImageField" xml:space="preserve">
        <div class="o_attachment_image">
            <img t-if="props.record.data[props.name]" t-attf-src="/web/image/{{ props.record.data[props.name][0] }}/300x300?unique=1" t-att-title="!!env.debug and props.record.data[props.name][1]" alt="Image"/>
        </div>
    </t>

`);
registerTemplate("web.BadgeField", `/web/static/src/views/fields/badge/badge_field.xml`, `<t t-name="web.BadgeField" xml:space="preserve">
        <span t-if="props.record.data[props.name]" class="badge rounded-pill" t-att-class="classFromDecoration" t-esc="formattedValue"/>
    </t>

`);
registerTemplate("web.BadgeSelectionField", `/web/static/src/views/fields/badge_selection/badge_selection_field.xml`, `<div t-name="web.BadgeSelectionField" class="d-flex flex-wrap gap-1 mb-3" xml:space="preserve">
        <t t-if="props.readonly">
            <span t-esc="string" t-att-raw-value="value"/>
        </t>
        <t t-else="">
            <t t-foreach="options" t-as="option" t-key="option[0]">
                <span class="o_selection_badge btn btn-secondary mb-1" t-att-class="{ 'active': value === option[0], 'btn-sm': props.size === 'sm', 'btn-lg': props.size === 'lg' }" t-att-value="stringify(option[0])" t-esc="option[1]" t-on-click="() =&gt; this.onChange(option[0])"/>
            </t>
        </t>
    </div>

`);
registerTemplate("web.BinaryField", `/web/static/src/views/fields/binary/binary_field.xml`, `<t t-name="web.BinaryField" xml:space="preserve">
        <t t-if="!props.readonly">
            <t t-if="props.record.data[props.name]">
                <div class="w-100 d-inline-flex gap-1">
                    <FileUploader acceptedFileExtensions="props.acceptedFileExtensions" onUploaded.bind="update">
                        <t name="download" t-if="props.record.resId and !props.record.dirty">
                            <button class="btn btn-link btn-sm lh-1 fa fa-download o_download_file_button" data-tooltip="Download" aria-label="Download" t-on-click="onFileDownload">
                            </button>
                        </t>
                        <t t-set-slot="toggler">
                            <input type="text" class="o_input" t-att-value="fileName" readonly="readonly"/>
                            <button class="btn btn-link btn-sm lh-1 fa fa-pencil o_select_file_button" data-tooltip="Edit" aria-label="Edit">
                            </button>
                        </t>
                        <button class="btn btn-link btn-sm lh-1 fa fa-trash o_clear_file_button" data-tooltip="Clear" aria-label="Clear" t-on-click="() =&gt; this.update({})">
                        </button>
                    </FileUploader>
                </div>
            </t>
            <t t-else="">
                <label class="o_select_file_button btn btn-primary">
                    <FileUploader acceptedFileExtensions="props.acceptedFileExtensions" onUploaded.bind="update">
                        <t t-set-slot="toggler">
                            Upload your file
                        </t>
                    </FileUploader>
                </label>
            </t>
        </t>
        <t t-elif="props.record.resId and props.record.data[props.name]">
            <a class="o_form_uri" href="#" t-on-click.prevent="onFileDownload">
                <span class="fa fa-download me-2"/>
                <t t-if="fileName" t-esc="fileName"/>
            </a>
        </t>
    </t>

    `);
registerTemplate("web.ListBinaryField", `/web/static/src/views/fields/binary/binary_field.xml`, `<t t-name="web.ListBinaryField" t-inherit="web.BinaryField" xml:space="preserve">
        <xpath expr="//label[hasclass('o_select_file_button')]" position="replace">
            <label class="o_select_file_button btn btn-sm btn-link p-0">
                <FileUploader acceptedFileExtensions="props.acceptedFileExtensions" onUploaded.bind="update">
                    <t t-set-slot="toggler">
                        <i class="fa fa-upload fa-fw"/> Upload your file
                    </t>
                </FileUploader>
            </label>
        </xpath>
    </t>

`);
registerTemplate("web.BooleanField", `/web/static/src/views/fields/boolean/boolean_field.xml`, `<t t-name="web.BooleanField" xml:space="preserve">
        <CheckBox id="props.id" value="state.value" className="'d-inline-block'" disabled="props.readonly" onChange.bind="onChange"/>
    </t>

`);
registerTemplate("web.BooleanFavoriteField", `/web/static/src/views/fields/boolean_favorite/boolean_favorite_field.xml`, `<t t-name="web.BooleanFavoriteField" xml:space="preserve">
        <div class="o_favorite" t-on-click.prevent.stop="update">
            <a href="#" t-att-class="{'pe-none' : props.readonly}">
                <i t-att-class="iconClass" role="img" t-att-title="label" t-att-aria-label="label"/>
                <t t-if="!props.readonly and !props.noLabel" t-esc="label"/>
            </a>
        </div>
    </t>

`);
registerTemplate("web.BooleanIconField", `/web/static/src/views/fields/boolean_icon/boolean_icon_field.xml`, `<t t-name="web.BooleanIconField" xml:space="preserve">
        <button t-attf-class="btn btn-sm btn-{{props.record.data[props.name] ? 'primary' : 'outline-secondary'}} mx-2 py-1 fa {{props.icon}}" t-att-data-tooltip="props.label" t-on-click.prevent.stop="update"/>
    </t>

`);
registerTemplate("web.BooleanToggleField", `/web/static/src/views/fields/boolean_toggle/boolean_toggle_field.xml`, `<t t-name="web.BooleanToggleField" t-inherit="web.BooleanField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//CheckBox" position="attributes">
            <attribute name="className">'o_field_boolean o_boolean_toggle form-switch'</attribute>
        </xpath>
        <xpath expr="//CheckBox" position="inside">
            ​ 
        </xpath>
    </t>

`);
registerTemplate("web.ListBooleanToggleField", `/web/static/src/views/fields/boolean_toggle/list_boolean_toggle_field.xml`, `<t t-name="web.ListBooleanToggleField" xml:space="preserve">
        <div t-on-click="onClick">
            <t t-call="web.BooleanToggleField"/>
        </div>
    </t>

`);
registerTemplate("web.CharField", `/web/static/src/views/fields/char/char_field.xml`, `<t t-name="web.CharField" xml:space="preserve">
        <t t-if="props.readonly">
            <span t-esc="formattedValue"/>
        </t>
        <t t-else="">
            <input class="o_input" t-att-class="{                     'o_field_translate': isTranslatable,                     'o_field_placeholder': hasDynamicPlaceholder                 }" t-att-id="props.id" t-att-type="props.isPassword ? 'password' : 'text'" t-att-autocomplete="props.autocomplete or (props.isPassword ? 'new-password' : 'off')" t-att-maxlength="maxLength &gt; 0 and maxLength" t-att-placeholder="placeholder" t-on-blur="onBlur" t-ref="input"/>
            <div class="o_field_input_buttons">
                <t t-if="isTranslatable">
                    <TranslationButton fieldName="props.name" record="props.record"/>
                </t>
                <button t-if="hasDynamicPlaceholder" class="btn m-0 py-0 px-2 fa fa-magic" title="Insert Field" t-on-click="onDynamicPlaceholderOpen"/>
            </div>
        </t>
    </t>

`);
registerTemplate("web.ColorField", `/web/static/src/views/fields/color/color_field.xml`, `<t t-name="web.ColorField" xml:space="preserve">
        <div class="o_field_color d-flex" t-att-class="{ 'o_field_cursor_disabled': props.readonly }" t-attf-style="background: #{color or 'url(/web/static/img/transparent.png)'}">
            <input t-on-click.stop="" class="w-100 h-100 opacity-0" type="color" t-att-value="color" t-att-disabled="props.readonly" t-on-input="(ev) =&gt; this.color = ev.target.value" t-on-change="(ev) =&gt; this.props.record.update({ [this.props.name]: ev.target.value })"/>
        </div>
    </t>

`);
registerTemplate("web.ColorPickerField", `/web/static/src/views/fields/color_picker/color_picker_field.xml`, `<t t-name="web.ColorPickerField" xml:space="preserve">
        <ColorList canToggle="props.canToggle" colors="constructor.RECORD_COLORS" forceExpanded="isExpanded" onColorSelected.bind="switchColor" selectedColor="props.record.data[props.name] || 0"/>
    </t>

`);
registerTemplate("web.CopyClipboardField", `/web/static/src/views/fields/copy_clipboard/copy_clipboard_field.xml`, `<t t-name="web.CopyClipboardField" xml:space="preserve">
        <div class="d-grid rounded-2 overflow-hidden">
            <Field t-props="fieldProps"/>
            <CopyButton className="copyButtonClassName" content="props.record.data[props.name]" icon="copyButtonIcon" successText="successText"/>
        </div>
    </t>

    `);
registerTemplate("web.CopyClipboardButtonField", `/web/static/src/views/fields/copy_clipboard/copy_clipboard_field.xml`, `<t t-name="web.CopyClipboardButtonField" xml:space="preserve">
        <CopyButton t-if="props.record.data[props.name]" className="copyButtonClassName" content="props.record.data[props.name]" copyText="copyText" disabled="disabled" successText="successText"/>
    </t>

`);
registerTemplate("web.DateTimeField", `/web/static/src/views/fields/datetime/datetime_field.xml`, `<t t-name="web.DateTimeField" xml:space="preserve">
        <t t-set="showSeparator" t-value="shouldShowSeparator()"/>
        <div class="d-flex gap-2 align-items-center" t-ref="root">

            <t t-if="props.readonly">
                <span class="text-truncate" t-esc="getFormattedValue(0)"/>
            </t>
            <t t-elif="!props.required and !props.alwaysRange and isEmpty(startDateField) and !isEmpty(endDateField)">
                <button class="o_add_date o_add_start_date btn btn-secondary btn-sm w-100" t-on-click="() =&gt; this.addDate(0)">
                    <i class="fa fa-plus me-2"/>
                    Add start date
                </button>
            </t>
            <t t-elif="props.required or props.alwaysRange or !isEmpty(startDateField) or startDateField === props.name">
                <input t-ref="start-date" type="text" t-att-id="showSeparator ? props.endDateField and props.id : props.id" class="o_input cursor-pointer" autocomplete="off" t-att-placeholder="props.placeholder" t-att-data-field="startDateField" t-on-input="onInput"/>
                <span t-if="props.warnFuture and isDateInTheFuture(0)" class="fa fa-exclamation-triangle text-danger" title="This date is on the future. Make sure it is what you expected."/>
            </t>


            <t t-if="showSeparator">
                <i class="fa fa-long-arrow-right" aria-label="Arrow icon" title="Arrow"/>
            </t>


            <t t-if="endDateField">
                <t t-if="props.readonly">
                    <span class="text-truncate" t-esc="getFormattedValue(1)"/>
                </t>
                <t t-elif="!props.required and !props.alwaysRange and !isEmpty(startDateField) and isEmpty(endDateField)">
                    <button class="o_add_date o_add_end_date btn btn-secondary btn-sm w-100" t-on-click="() =&gt; this.addDate(1)">
                        <i class="fa fa-plus me-2"/>
                        Add end date
                    </button>
                </t>
                <t t-elif="props.required or props.alwaysRange or !isEmpty(endDateField) or endDateField === props.name">
                    <input t-ref="end-date" type="text" t-att-id="props.startDateField and props.id" class="o_input cursor-pointer" autocomplete="off" t-att-placeholder="props.placeholder" t-att-data-field="endDateField" t-on-input="onInput"/>
                    <span t-if="props.warnFuture and isDateInTheFuture(1)" class="fa fa-exclamation-triangle text-danger" title="This date is on the future. Make sure it is what you expected."/>
                </t>
            </t>
        </div>
    </t>
`);
registerTemplate("web.DomainField", `/web/static/src/views/fields/domain/domain_field.xml`, `<t t-name="web.DomainField" xml:space="preserve">
        <div t-att-class="{ o_inline_mode: !props.editInDialog }">
            <t t-set="resModel" t-value="getResModel()"/>
            <t t-if="resModel">
                <t t-if="props.isFoldable and state.folded and state.isValid">
                    <div class="d-flex align-items-center" t-on-click="() =&gt; state.folded = false">
                        <i data-tooltip="Modify filter" class="fa fa-lg fa-caret-right pe-2"/>
                        <div class="d-print-contents">
                            <t t-if="!state.facets.length">
                                <span>Match <strong>all records</strong></span>
                                <t t-if="!props.readonly">
                                    <button class="btn btn-sm btn-primary o_domain_add_first_node_button mx-2" t-on-click.stop="() =&gt; this.addCondition()">
                                        <i class="fa fa-plus"/> Add condition
                                    </button>
                                </t>
                            </t>
                            <t t-foreach="state.facets" t-as="facet" t-key="facet_index">
                                <div class="d-inline-flex align-items-stretch text-nowrap px-1 position-relative" role="listitem" tabindex="0">
                                    <div class="o_searchview_facet_label rounded-start-2 btn btn-primary rounded-end-0 p-0" role="button">
                                        <i class="px-1 small fa fa-filter" role="image"/>
                                    </div>
                                    <div class="o_facet_values d-flex align-items-center px-2 bg-200 rounded-end-2 text-wrap">
                                        <small class="o_facet_value" t-esc="facet"/>
                                    </div>
                                </div>
                            </t>
                            <t t-if="state.isValid">
                                <button class="btn btn-sm btn-link o_domain_show_selection_button" data-tooltip="Show matching records" type="button" t-on-click.stop="onButtonClick">
                                    <t t-esc="state.recordCount"/> record(s)
                                </button>
                            </t>
                        </div>
                    </div>
                </t>
                <t t-else="">
                    <div class="d-flex">
                        <a t-if="props.isFoldable and state.isValid" t-on-click="fold">
                            <i class="fa fa-lg fa-caret-down pe-2"/>
                        </a>
                        <DomainSelector resModel="resModel" domain="getDomain()" readonly="props.readonly or props.editInDialog" debugUpdate.bind="debugUpdate" update.bind="update" isDebugMode="!!env.debug" className="props.readonly ? 'o_read_mode' : 'o_edit_mode'"/>
                    </div>
                    <div class="o_field_domain_panel d-flex align-items-center gap-2 mt-1">
                        <i class="oi oi-arrow-right" role="img" aria-label="Domain" title="Domain"/>
                        <t t-if="state.isValid === null and state.recordCount === null">
                            <i class="fa fa-circle-o-notch fa-spin ms-2" role="img" aria-label="Loading" title="Loading"/>
                        </t>
                        <t t-else="">
                            <t t-if="state.isValid">
                                <button class="btn btn-sm btn-link o_domain_show_selection_button" type="button" t-on-click.stop="onButtonClick">
                                    <t t-esc="state.recordCount"/> record(s)
                                </button>
                            </t>
                            <t t-else="">
                                <span class="text-warning" role="alert">
                                    <i class="fa fa-exclamation-triangle" role="img" aria-label="Warning" title="Warning"/> Invalid domain
                                </span>
                            </t>
                            <t t-if="!!env.debug and !props.readonly">
                                <button class="btn btn-sm btn-icon fa fa-refresh o_refresh_count" role="img" aria-label="Refresh" title="Refresh" t-on-click="() =&gt; this.checkProps()"/>
                            </t>
                        </t>
                        <t t-if="props.editInDialog and !props.readonly">
                            <button class="btn btn-sm btn-primary o_field_domain_dialog_button" t-on-click.prevent="onEditDialogBtnClick">Edit Domain</button>
                        </t>
                    </div>
                </t>
            </t>
            <t t-else="">
                <div>Select a model to add a filter.</div>
            </t>
        </div>
    </t>

`);
registerTemplate("web.DynamicPlaceholderPopover", `/web/static/src/views/fields/dynamic_placeholder_popover.xml`, `<t t-name="web.DynamicPlaceholderPopover" xml:space="preserve">
        <t t-if="state.isPathSelected">
            <div class="o_model_field_selector_popover" t-on-keydown="onInputKeydown" tabindex="-1">
                <div class="border-bottom p-2">
                    <div class="d-flex justify-content-between align-items-center text-dark fw-bolder">
                        <i class="btn btn-link me-n2 fa fa-arrow-left text-dark" title="Back" role="img" aria-label="Back" t-on-click="onBack"/>
                        <div class="o_model_field_selector_popover_title">Enter a default value</div>
                        <i class="o_model_field_selector_popover_close btn btn-link me-n2 fa fa-times text-dark" title="Close" role="img" aria-label="Close" t-on-click="props.close"/>
                    </div>
                    <t t-if="state.fieldName">
                        <span t-out="state.fieldName"/>
                        <br/>
                        <span>or</span>
                    </t>
                    <div class="o_model_field_selector_default_value_input mt-2">
                        <input type="text" placeholder="What should we write if the field is empty" class="o_input" t-att-value="state.defaultValue" t-on-input="(ev) =&gt; this.setDefaultValue(ev.target.value)" t-ref="autofocus"/>
                    </div>
                </div>
                <div class="o_model_field_selector_popover_footer border-top py-1 my-2 px-2">
                    <input type="text" class="o_input o_model_field_selector_debug" disabled="disabled" t-att-value="state.path"/>
                </div>
                <div class="d-flex flex-row justify-content-around py-2">
                    <button class="btn btn-primary" t-on-click="validate">
                        Insert
                    </button>
                    <button class="btn btn-secondary" t-on-click="() =&gt; this.props.close()">
                        Discard
                    </button>
                </div>
            </div>
        </t>
        <t t-else="">
            <ModelFieldSelectorPopover close.bind="closeFieldSelector" filter.bind="filter" followRelations="true" isDebugMode="!!env.debug" path="state.path" resModel="props.resModel" showSearchInput="true" update.bind="setPath"/>
        </t>
    </t>

`);
registerTemplate("web.DynamicModelFieldSelectorChar", `/web/static/src/views/fields/dynamic_widget/dynamic_model_field_selector_char.xml`, `<t t-name="web.DynamicModelFieldSelectorChar" t-inherit="web.CharField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//input" position="attributes">
            <attribute name="class" add="d-none" separator=" "/>
        </xpath>
        <xpath expr="//span" position="attributes">
            <attribute name="class" add="d-none" separator=" "/>
        </xpath>
        <xpath expr="//t[@t-if='props.readonly']" position="before">
            <DynamicModelFieldSelector t-props="getSelectorProps"/>
        </xpath>
    </t>
`);
registerTemplate("web.EmailField", `/web/static/src/views/fields/email/email_field.xml`, `<t t-name="web.EmailField" xml:space="preserve">
        <t t-if="props.readonly">
            <div class="d-grid">
                <a class="o_form_uri o_text_overflow" t-on-click.stop="" t-att-href="props.record.data[props.name] ? 'mailto:'+props.record.data[props.name] : undefined" t-esc="props.record.data[props.name] || ''"/>
            </div>
        </t>
        <t t-else="">
            <div class="d-inline-flex w-100">
                <input class="o_input" t-att-id="props.id" type="email" autocomplete="off" t-att-placeholder="props.placeholder" t-att-required="props.required" t-ref="input"/>
            </div>
        </t>
    </t>

    `);
registerTemplate("web.FormEmailField", `/web/static/src/views/fields/email/email_field.xml`, `<t t-name="web.FormEmailField" t-inherit="web.EmailField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//input" position="after">
            <a t-if="props.record.data[props.name]" t-att-href="'mailto:'+props.record.data[props.name]" class="ms-3 d-inline-flex align-items-center" target="_blank">
                <i class="fa fa-envelope" data-tooltip="Send Email" aria-label="Send Email"/>
            </a>
        </xpath>
    </t>

`);
registerTemplate("web.Field", `/web/static/src/views/fields/field.xml`, `<t t-name="web.Field" xml:space="preserve">
        <div t-att-name="props.name" t-att-class="classNames" t-att-style="props.style" t-att-data-tooltip-template="tooltip and 'web.FieldTooltip'" t-att-data-tooltip-info="tooltip">
            <t t-component="field.component" t-props="fieldComponentProps"/>
        </div>
    </t>

`);
registerTemplate("web.FieldTooltip", `/web/static/src/views/fields/field_tooltip.xml`, `<t t-name="web.FieldTooltip" xml:space="preserve">

        <p t-if="field.help" class="o-tooltip--help" role="tooltip">
            <t t-esc="field.help"/>
        </p>

        <ul class="o-tooltip--technical" t-if="debug" role="tooltip">
            <li data-item="label" t-if="field and field.label">
                <span class="o-tooltip--technical--title">Label:</span>
                <t t-esc="field.label"/>
            </li>
            <li data-item="field" t-if="field and field.name">
                <span class="o-tooltip--technical--title">Field:</span>
                <t t-esc="field.name"/>
            </li>
            <li data-item="object" t-if="resModel">
                <span class="o-tooltip--technical--title">Model:</span>
                <t t-esc="resModel"/>
            </li>
            <t t-if="field">
                <li t-if="field.type" data-item="type">
                    <span class="o-tooltip--technical--title">Type:</span>
                    <t t-esc="field.type"/>
                </li>
                <li t-if="field.model_field" data-item="model_field">
                    <span class="o-tooltip--technical--title">Model field:</span>
                    <t t-esc="field.model_field"/>
                </li>
                <li t-if="field.widget" data-item="widget">
                    <span class="o-tooltip--technical--title">Widget:</span>
                    <t t-if="field.widgetDescription" t-esc="field.widgetDescription"/>
                    <t t-if="field.widget">
                        (<t t-esc="field.widget"/>)
                    </t>
                </li>
                <li t-if="field.context" data-item="context">
                    <span class="o-tooltip--technical--title">Context:</span>
                    <t t-esc="field.context"/>
                </li>
                <li t-if="field.domain" data-item="domain">
                    <span class="o-tooltip--technical--title">Domain:</span>
                    <t t-esc="field.domain.length === 0 ? '[]' : field.domain"/>
                </li>
                <li t-if="field.invisible" data-item="invisible">
                    <span class="o-tooltip--technical--title">Invisible:</span>
                    <t t-esc="field.invisible"/>
                </li>
                <li t-if="field.column_invisible" data-item="column_invisible">
                    <span class="o-tooltip--technical--title">Column invisible:</span>
                    <t t-esc="field.column_invisible"/>
                </li>
                <li t-if="field.required" data-item="required">
                    <span class="o-tooltip--technical--title">Required:</span>
                    <t t-esc="field.required"/>
                </li>
                <li t-if="field.readonly" data-item="readonly">
                    <span class="o-tooltip--technical--title">Readonly:</span>
                    <t t-esc="field.readonly"/>
                </li>
                <li t-if="field.default" data-item="default">
                    <span class="o-tooltip--technical--title">Default:</span>
                    <t t-esc="field.default"/>
                </li>
                <li t-if="field.changeDefault" data-item="changeDefault">
                    <span class="o-tooltip--technical--title">Change default:</span>
                    Yes
                </li>
                <li t-if="field.relation" data-item="relation">
                    <span class="o-tooltip--technical--title">Relation:</span>
                    <t t-esc="field.relation"/>
                </li>
                <li t-if="field.selection" data-item="selection">
                    <span class="o-tooltip--technical--title">Selection:</span>
                    <ul class="o-tooltip--technical">
                        <li t-foreach="field.selection" t-as="option" t-key="option_index">
                            [<t t-esc="option[0]"/>]
                            <t t-if="option[1]"> - </t>
                            <t t-esc="option[1]"/>
                        </li>
                    </ul>
                </li>
            </t>
        </ul>
    </t>

`);
registerTemplate("web.FileUploader", `/web/static/src/views/fields/file_handler.xml`, `<t t-name="web.FileUploader" xml:space="preserve">
        <t t-if="state.isUploading and props.showUploadingText">Uploading...</t>
        <span t-else="" t-on-click.prevent="onSelectFileButtonClick" style="display:contents">
            <t t-slot="toggler"/>
        </span>
        <t t-slot="default"/>
        <input type="file" t-att-name="props.inputName" t-ref="fileInput" t-attf-class="o_input_file d-none {{ props.fileUploadClass or '' }}" t-att-multiple="props.multiUpload ? 'multiple' : false" t-att-accept="props.acceptedFileExtensions or '*'" t-on-change="onFileChange"/>
    </t>

`);
registerTemplate("web.FloatField", `/web/static/src/views/fields/float/float_field.xml`, `<t t-name="web.FloatField" xml:space="preserve">
        <span t-if="props.readonly" t-esc="formattedValue"/>
        <input t-else="" t-on-focusin="onFocusIn" t-on-focusout="onFocusOut" t-att-id="props.id" t-ref="numpadDecimal" t-att-placeholder="props.placeholder" t-att-type="props.inputType" inputmode="decimal" class="o_input" autocomplete="off" t-att-step="props.step"/>
    </t>

`);
registerTemplate("web.FloatTimeField", `/web/static/src/views/fields/float_time/float_time_field.xml`, `<t t-name="web.FloatTimeField" xml:space="preserve">
        <span t-if="props.readonly" t-esc="formattedValue"/>
        <input t-else="" t-att-id="props.id" t-att-type="props.inputType" t-ref="numpadDecimal" t-att-placeholder="props.placeholder" class="o_input" autocomplete="off"/>
    </t>

`);
registerTemplate("web.FloatToggleField", `/web/static/src/views/fields/float_toggle/float_toggle_field.xml`, `<t t-name="web.FloatToggleField" xml:space="preserve">
        <span t-if="props.readonly and !props.disableReadOnly" t-esc="formattedValue"/>
        <button t-else="" class="o_field_float_toggle" t-on-click="onChange"><t t-esc="formattedValue"/></button>
    </t>

`);
registerTemplate("web.GaugeField", `/web/static/src/views/fields/gauge/gauge_field.xml`, `<t t-name="web.GaugeField" xml:space="preserve">
        <div class="oe_gauge position-relative">
            <canvas t-ref="canvas"/>
            <span class="o_gauge_value position-absolute start-0 end-0 bottom-0 text-center" t-esc="props.record.data[props.name]"/>
        </div>
    </t>

`);
registerTemplate("web.GoogleSlideViewer", `/web/static/src/views/fields/google_slide_viewer/google_slide_viewer.xml`, `<t t-name="web.GoogleSlideViewer" t-inherit="web.CharField" xml:space="preserve">
        <xpath expr="//t[@t-else='']" position="after">
            <t t-if="url">
                <div>
                    <iframe class="o_embed_iframe w-100" alt="Google Slide Viewer" t-att-src="url" t-att-name="props.name" t-on-error="onLoadFailed"/>
                </div>
            </t>
        </xpath>
    </t>

`);
registerTemplate("web.HandleField", `/web/static/src/views/fields/handle/handle_field.xml`, `<t t-name="web.HandleField" xml:space="preserve">
        <span class="o_row_handle oi oi-draggable ui-sortable-handle" t-on-click.stop=""/>
    </t>

`);
registerTemplate("web.HtmlField", `/web/static/src/views/fields/html/html_field.xml`, `<t t-name="web.HtmlField" xml:space="preserve">
        <t t-if="props.readonly">
            <span t-out="props.record.data[props.name] or ''"/>
        </t>
        <t t-else="" t-call="web.TextField"/>
    </t>

`);
registerTemplate("web.IframeWrapperField", `/web/static/src/views/fields/iframe_wrapper/iframe_wrapper_field.xml`, `<t t-name="web.IframeWrapperField" xml:space="preserve">
        <div class="o_preview_iframe_wrapper">
            <iframe src="about:blank" class="o_preview_iframe" t-ref="iframe"/>
        </div>
    </t>

`);
registerTemplate("web.ImageField", `/web/static/src/views/fields/image/image_field.xml`, `<t t-name="web.ImageField" xml:space="preserve">
        <div class="d-inline-block position-relative opacity-trigger-hover">
            <div t-if="!props.readonly and fieldType !== 'many2one'" t-attf-class="position-absolute d-flex justify-content-between w-100 bottom-0 opacity-0 opacity-100-hover {{isMobile ? 'o_mobile_controls' : ''}}" aria-atomic="true" t-att-style="sizeStyle">
                <FileUploader acceptedFileExtensions="props.acceptedFileExtensions" t-key="props.record.resId" onUploaded.bind="onFileUploaded">
                    <t t-set-slot="toggler">
                        <button class="o_select_file_button btn btn-light border-0 rounded-circle m-1 p-1" data-tooltip="Edit" aria-label="Edit">
                            <i class="fa fa-pencil fa-fw"/>
                        </button>
                    </t>
                    <button t-if="props.record.data[props.name] and state.isValid" class="o_clear_file_button btn btn-light border-0 rounded-circle m-1 p-1" data-tooltip="Clear" aria-label="Clear" t-on-click="onFileRemove">
                        <i class="fa fa-trash-o fa-fw"/>
                    </button>
                </FileUploader>
            </div>
            <img loading="lazy" t-att-class="imgClass" t-att-alt="imgAlt" t-att-src="this.getUrl(props.previewImage or props.name)" t-att-name="props.name" t-att-height="props.height" t-att-width="props.width" t-att-style="sizeStyle" t-on-error.stop="onLoadFailed" t-att-data-tooltip-template="hasTooltip and tooltipAttributes.template" t-att-data-tooltip-info="hasTooltip and tooltipAttributes.info" t-att-data-tooltip-delay="hasTooltip and props.zoomDelay"/>
        </div>
    </t>

    `);
registerTemplate("web.ImageZoomTooltip", `/web/static/src/views/fields/image/image_field.xml`, `<t t-name="web.ImageZoomTooltip" xml:space="preserve">
        <div class="o_image_zoom">
            <img t-att-src="url"/>
        </div>
    </t>

`);
registerTemplate("web.ImageUrlField", `/web/static/src/views/fields/image_url/image_url_field.xml`, `<t t-name="web.ImageUrlField" xml:space="preserve">
        <img t-if="props.record.data[props.name]" class="img img-fluid" alt="Image" t-att-src="state.src" t-att-border="props.readonly ? 0 : 1" t-att-name="props.name" t-att-height="props.height" t-att-width="props.width" t-att-style="sizeStyle" t-on-error="onLoadFailed"/>
    </t>

`);
registerTemplate("web.IntegerField", `/web/static/src/views/fields/integer/integer_field.xml`, `<t t-name="web.IntegerField" xml:space="preserve">
        <span t-if="props.readonly" t-esc="formattedValue"/>
        <input t-else="" t-ref="numpadDecimal" t-on-focusin="onFocusIn" t-on-focusout="onFocusOut" t-att-id="props.id" t-att-type="props.inputType" t-att-placeholder="props.placeholder" inputmode="numeric" class="o_input" autocomplete="off" t-att-step="props.step"/>
    </t>

`);
registerTemplate("web.JournalDashboardGraphField", `/web/static/src/views/fields/journal_dashboard_graph/journal_dashboard_graph_field.xml`, `<t t-name="web.JournalDashboardGraphField" xml:space="preserve">
        <div class="o_dashboard_graph" t-att-class="props.className" t-attf-class="o_graph_{{ props.graphType }}chart">
            <canvas t-ref="canvas"/>
        </div>
    </t>

`);
registerTemplate("web.JsonbField", `/web/static/src/views/fields/jsonb/jsonb.xml`, `<t t-name="web.JsonbField" xml:space="preserve">
        <span t-esc="formattedValue"/>
    </t>

`);
registerTemplate("web.KanbanColorPickerField", `/web/static/src/views/fields/kanban_color_picker/kanban_color_picker_field.xml`, `<t t-name="web.KanbanColorPickerField" xml:space="preserve">
        <ul t-if="!props.readonly" class="o_kanban_colorpicker mb-0 ms-2">
            <t t-foreach="colors" t-as="color" t-key="color_index">
                <li role="menuitem" t-on-click="() =&gt; this.selectColor(color_index)" t-att-title="color" t-att-aria-label="color">
                    <a href="#" t-attf-class="o_kanban_color_{{ color_index }}"/>
                </li>
            </t>
        </ul>
    </t>

`);
registerTemplate("web.LabelSelectionField", `/web/static/src/views/fields/label_selection/label_selection_field.xml`, `<t t-name="web.LabelSelectionField" xml:space="preserve">
        <span t-attf-class="badge text-bg-{{className}} " t-esc="string" t-att-raw-value="props.record.data[props.name]"/>
    </t>

`);
registerTemplate("web.Many2ManyBinaryField", `/web/static/src/views/fields/many2many_binary/many2many_binary_field.xml`, `<t t-name="web.Many2ManyBinaryField" xml:space="preserve">
        <div t-attf-class="oe_fileupload {{props.className ? props.className : ''}}" aria-atomic="true">
            <div class="o_attachments">
                <t t-foreach="files" t-as="file" t-key="file_index">
                   <t t-call="web.Many2ManyBinaryField.attachment_preview"/>
                </t>
            </div>
            <div t-if="!props.readonly &amp;&amp; (!props.numberOfFiles or files.length &lt; props.numberOfFiles)" class="oe_add">
                <FileInput acceptedFileExtensions="props.acceptedFileExtensions" multiUpload="true" onUpload.bind="onFileUploaded" resModel="props.record.resModel" resId="props.record.resId or 0">
                    <button class="btn btn-secondary o_attach" data-tooltip="Attach">
                        <span class="fa fa-paperclip" aria-label="Attach"/> <t t-esc="uploadText"/>
                    </button>
                </FileInput>
            </div>
        </div>
    </t>

`);
registerTemplate("web.Many2ManyBinaryField.attachment_preview", `/web/static/src/views/fields/many2many_binary/many2many_binary_field.xml`, `<t t-name="web.Many2ManyBinaryField.attachment_preview" xml:space="preserve">
    <t t-set="editable" t-value="!props.readonly"/>
    <div t-attf-class="o_attachment o_attachment_many2many #{ editable ? 'o_attachment_editable' : '' } #{upload ? 'o_attachment_uploading' : ''}" t-att-title="file.name">
        <div class="o_attachment_wrap">
            <t t-set="ext" t-value="getExtension(file)"/>
            <t t-set="url" t-value="getUrl(file.id)"/>
            <div class="o_image_box float-start" t-att-data-tooltip="'Download ' + file.name">
                <a t-att-href="url" aria-label="Download" download="">
                    <span class="o_image o_hover" t-att-data-mimetype="file.mimetype" t-att-data-ext="ext" role="img"/>
                </a>
            </div>

            <div class="caption">
                <a class="ml4" t-att-data-tooltip="'Download ' + file.name" t-att-href="url" download=""><t t-esc="file.name"/></a>
            </div>
            <div class="caption small">
                <a class="ml4 small text-uppercase" t-att-href="url" download=""><b><t t-esc="ext"/></b></a>
                <div t-if="editable" class="progress o_attachment_progress_bar">
                    <div class="progress-bar progress-bar-striped active" style="width: 100%">Uploading</div>
                </div>
            </div>

            <div class="o_attachment_uploaded"><i class="text-success fa fa-check" role="img" aria-label="Uploaded" title="Uploaded"/></div>
            <div t-if="editable" class="o_attachment_delete" t-on-click.stop="() =&gt; this.onFileRemove(file.id)"><span role="img" aria-label="Delete" title="Delete">×</span></div>
        </div>
    </div>
</t>

`);
registerTemplate("web.Many2ManyCheckboxesField", `/web/static/src/views/fields/many2many_checkboxes/many2many_checkboxes_field.xml`, `<t t-name="web.Many2ManyCheckboxesField" xml:space="preserve">
        <div aria-atomic="true">
            <t t-foreach="items" t-as="item" t-key="item[0]">
                <div>
                    <CheckBox value="isSelected(item)" disabled="props.readonly" onChange="(ev) =&gt; this.onChange(item[0], ev)">
                        <t t-esc="item[1]"/>
                    </CheckBox>
                </div>
            </t>
        </div>
    </t>

`);
registerTemplate("web.KanbanMany2ManyTagsField", `/web/static/src/views/fields/many2many_tags/kanban_many2many_tags_field.xml`, `<t t-name="web.KanbanMany2ManyTagsField" xml:space="preserve">
        <div class="d-flex flex-wrap gap-1">
            <TagsList tags="tags"/>
        </div>
    </t>
`);
registerTemplate("web.Many2ManyTagsField", `/web/static/src/views/fields/many2many_tags/many2many_tags_field.xml`, `<t t-name="web.Many2ManyTagsField" xml:space="preserve">
        <div class="o_field_tags d-inline-flex flex-wrap gap-1 mw-100" t-att-class="{'o_tags_input o_input': !props.readonly}" t-ref="many2ManyTagsField">
            <TagsList tags="tags"/>
            <div t-if="showM2OSelectionField" class="o_field_many2many_selection d-inline-flex w-100" t-ref="autoComplete">
                <Many2XAutocomplete id="props.id" placeholder="tags.length ? '' : props.placeholder" resModel="relation" autoSelect="true" fieldString="string" activeActions="activeActions" update="update" quickCreate="activeActions.create ? quickCreate : null" context="props.context" getDomain.bind="getDomain" isToMany="true" nameCreateField="props.nameCreateField" noSearchMore="props.noSearchMore" getOptionClassnames.bind="getOptionClassnames"/>
            </div>
        </div>
    </t>

    `);
registerTemplate("web.Many2ManyTagsFieldColorListPopover", `/web/static/src/views/fields/many2many_tags/many2many_tags_field.xml`, `<t t-name="web.Many2ManyTagsFieldColorListPopover" xml:space="preserve">
        <div class="o_tag_popover m-2">
            <ColorList colors="props.colors" forceExpanded="true" onColorSelected="(id) =&gt; props.switchTagColor(id, props.tag)"/>
            <CheckBox className="'pt-2'" value="props.tag.colorIndex === 0" onChange.alike="(isChecked) =&gt; props.onTagVisibilityChange(isChecked, props.tag)">Hide in kanban</CheckBox>
        </div>
    </t>

`);
registerTemplate("web.Many2ManyTagsAvatarField", `/web/static/src/views/fields/many2many_tags_avatar/many2many_tags_avatar_field.xml`, `<t t-name="web.Many2ManyTagsAvatarField" xml:space="preserve">
        <div class="many2many_tags_avatar_field_container o_field_tags d-inline-flex flex-wrap mw-100 gap-1" t-att-class="{'o_tags_input o_input': !props.readonly}" t-ref="many2ManyTagsField">
            <TagsList tags="tags" visibleItemsLimit="visibleItemsLimit"/>
            <div t-if="showM2OSelectionField" class="o_field_many2many_selection d-inline-flex w-100" t-ref="autoComplete">
                <Many2XAutocomplete id="props.id" placeholder="tags.length ? '' : props.placeholder" resModel="relation" autoSelect="true" fieldString="string" activeActions="activeActions" update="update" quickCreate="activeActions.create ? quickCreate : null" context="props.context" getDomain.bind="getDomain" isToMany="true" getOptionClassnames.bind="getOptionClassnames"/>
            </div>
        </div>
    </t>

    `);
registerTemplate("web.KanbanMany2ManyTagsAvatarFieldTagsList", `/web/static/src/views/fields/many2many_tags_avatar/many2many_tags_avatar_field.xml`, `<t t-name="web.KanbanMany2ManyTagsAvatarFieldTagsList" t-inherit="web.TagsList" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-foreach='visibleTags']" position="before">
            <t t-if="canDisplayQuickAssignAvatar">
                <a t-on-click.stop.prevent="openPopover" tabIndex="-1" href="#" title="Assign" aria-label="Assign" class="o_quick_assign fa fa-user-plus o_m2m_avatar btn-link d-flex align-items-center text-dark" role="button"/>
            </t>
        </xpath>
        <xpath expr="//span[hasclass('o_m2m_avatar_empty')]" position="attributes">
            <attribute name="t-on-click.stop.prevent">openPopover</attribute>
        </xpath>
    </t>

    `);
registerTemplate("web.KanbanMany2ManyTagsAvatarField", `/web/static/src/views/fields/many2many_tags_avatar/many2many_tags_avatar_field.xml`, `<t t-name="web.KanbanMany2ManyTagsAvatarField" t-inherit="web.Many2ManyTagsAvatarField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//TagsList" position="attributes">
            <attribute name="popoverProps">popoverProps</attribute>
            <attribute name="readonly">!props.isEditable</attribute>
        </xpath>
    </t>
    `);
registerTemplate("web.Many2ManyTagsAvatarFieldPopover", `/web/static/src/views/fields/many2many_tags_avatar/many2many_tags_avatar_field.xml`, `<t t-name="web.Many2ManyTagsAvatarFieldPopover" t-inherit="web.Many2ManyTagsAvatarField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_field_tags')]" position="attributes">
            <attribute name="class" add="p-2 o_m2m_tags_avatar_field_popover o_field_widget o_field_many2many_tags_avatar" remove="d-inline-flex mw-100" separator=" "/>
        </xpath>
        <xpath expr="//div[hasclass('o_field_many2many_selection')]" position="attributes">
            <attribute name="class" add="w-100" separator=" "/>
        </xpath>
        <Many2XAutocomplete position="attributes">
            <attribute name="dropdown">false</attribute>
            <attribute name="placeholder">props.placeholder</attribute>
            <attribute name="autofocus">true</attribute>
        </Many2XAutocomplete>
    </t>

`);
registerTemplate("web.Many2OneField.CreateConfirmationDialog", `/web/static/src/views/fields/many2one/many2one_field.xml`, `<t t-name="web.Many2OneField.CreateConfirmationDialog" xml:space="preserve">
        <Dialog title="title" size="'md'">
            <div>
                <t t-out="dialogContent"/>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="onCreate">Create</button>
                <button class="btn" t-on-click="() =&gt; props.close()">Discard</button>
            </t>
        </Dialog>
    </t>

    `);
registerTemplate("web.Many2OneField", `/web/static/src/views/fields/many2one/many2one_field.xml`, `<t t-name="web.Many2OneField" xml:space="preserve">
        <t t-if="props.readonly">
            <t t-if="!props.canOpen">
                <span>
                    <span t-esc="displayName"/>
                    <t t-foreach="extraLines" t-as="extraLine" t-key="extraLine_index">
                        <br/>
                        <span t-esc="extraLine"/>
                    </t>
                </span>
            </t>
            <t t-else="">
                <a t-if="value" t-attf-class="o_form_uri #{classFromDecoration}" t-att-href="value ? \`/odoo/\${urlRelation}/\${value[0]}\` : '/'" t-on-click.prevent="onClick">
                    <span t-esc="displayName"/>
                    <t t-foreach="extraLines" t-as="extraLine" t-key="extraLine_index">
                        <br/>
                        <span t-esc="extraLine"/>
                    </t>
                </a>
            </t>
        </t>
        <t t-else="">
            <div class="o_field_many2one_selection">
                <Many2XAutocomplete t-props="Many2XAutocompleteProps"/>
                <t t-if="hasExternalButton">
                    <button type="button" class="btn btn-link text-action oi o_external_button px-1" t-att-class="env.inDialog ? 'oi-launch' : 'oi-arrow-right'" tabindex="-1" draggable="false" aria-label="Internal link" data-tooltip="Internal link" t-on-click="onExternalBtnClick"/>
                </t>
                <button t-if="hasBarcodeButton" t-on-click="onBarcodeBtnClick" type="button" class="btn ms-3 o_barcode" tabindex="-1" draggable="false" aria-label="Scan barcode" title="Scan barcode" data-tooltip="Scan barcode"/>
            </div>
            <div class="o_field_many2one_extra d-empty-none">
                <t t-foreach="extraLines" t-as="extraLine" t-key="extraLine_index">
                    <br t-if="!extraLine_first"/>
                    <span t-esc="extraLine"/>
                </t>
            </div>
        </t>
    </t>

`);
registerTemplate("web.Many2OneAvatarField", `/web/static/src/views/fields/many2one_avatar/many2one_avatar_field.xml`, `<t t-name="web.Many2OneAvatarField" xml:space="preserve">
        <div class="d-flex align-items-center gap-1" t-att-data-tooltip="props.record.data[props.name][1]">
            <span class="o_avatar o_m2o_avatar">
                <span t-if="props.record.data[props.name] === false and !props.readonly" class="o_avatar_empty o_m2o_avatar_empty"/>
                <img t-if="props.record.data[props.name] !== false" t-attf-src="/web/image/{{relation}}/{{props.record.data[props.name][0]}}/avatar_128" class="rounded"/>
            </span>
            <t t-call="web.Many2OneField"/>
        </div>
    </t>

    `);
registerTemplate("web.KanbanMany2OneAvatarField", `/web/static/src/views/fields/many2one_avatar/many2one_avatar_field.xml`, `<t t-name="web.KanbanMany2OneAvatarField" t-inherit="web.Many2OneAvatarField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[hasclass('o_m2o_avatar')]" position="attributes">
            <attribute name="class" separator=" " add="d-flex"/>
        </xpath>
        <xpath expr="//span[hasclass('o_m2o_avatar_empty')]" position="replace">
            <t t-if="props.record.data[props.name] === false and props.isEditable">
                <a t-on-click.stop.prevent="openPopover" tabIndex="-1" href="#" title="Assign" aria-label="Assign" class="o_quick_assign fa fa-user-plus btn-link d-flex align-items-center text-dark" role="button"/>
            </t>
        </xpath>
    </t>

`);
registerTemplate("web.Many2OneReferenceField", `/web/static/src/views/fields/many2one_reference/many2one_reference_field.xml`, `<t t-name="web.Many2OneReferenceField" xml:space="preserve">
        <Many2OneField t-props="m2oProps"/>
    </t>

`);
registerTemplate("web.MonetaryField", `/web/static/src/views/fields/monetary/monetary_field.xml`, `<t t-name="web.MonetaryField" xml:space="preserve">
        <span t-if="props.readonly" t-esc="formattedValue"/>
        <div class="text-nowrap d-inline-flex w-100 align-items-baseline position-relative" t-else="">
            <span class="o_input position-absolute pe-none d-flex w-100">
                <span t-if="!props.hideSymbol and currency and currency.position === 'before'" t-out="currencySymbol + nbsp"/>
                <span class="opacity-0 d-inline-block overflow-hidden mw-100 o_monetary_ghost_value" t-out="state.value"/>
                <span t-if="!props.hideSymbol and currency and currency.position === 'after'" t-out="nbsp + currencySymbol"/>
            </span>
            <span class="opacity-0" t-if="!props.hideSymbol and currency and currency.position === 'before'" t-out="currencySymbol + nbsp"/>
            <input t-ref="numpadDecimal" t-on-input="onInput" t-att-id="props.id" t-att-type="props.inputType" t-att-placeholder="props.placeholder" class="o_input flex-grow-1 flex-shrink-1" autocomplete="off"/>
            <span class="opacity-0" t-if="!props.hideSymbol and currency and currency.position === 'after'" t-out="nbsp + currencySymbol"/>
        </div>
    </t>

`);
registerTemplate("web.PdfViewerField", `/web/static/src/views/fields/pdf_viewer/pdf_viewer_field.xml`, `<t t-name="web.PdfViewerField" xml:space="preserve">
        <t t-if="!props.readonly">
            <div class="o_form_pdf_controls d-flex gap-1">
                <t t-if="props.record.data[props.name]">
                    <FileUploader acceptedFileExtensions="'.pdf'" onUploaded.bind="onFileUploaded">
                        <t t-set-slot="toggler">
                            <button class="btn btn-secondary fa fa-pencil o_select_file_button" data-tooltip="Edit" aria-label="Edit"/>
                        </t>
                        <button class="btn btn-secondary fa fa-trash o_clear_file_button" data-tooltip="Clear" aria-label="Clear" t-on-click="onFileRemove"/>
                    </FileUploader>
                </t>
                <t t-else="">
                    <label class="o_select_file_button btn btn-primary">
                        <FileUploader acceptedFileExtensions="'.pdf'" onUploaded.bind="onFileUploaded">
                            <t t-set-slot="toggler">
                                Upload your file
                            </t>
                        </FileUploader>
                    </label>
                </t>
            </div>
        </t>
        <t t-if="props.record.data[props.name]">
            <iframe class="o_pdfview_iframe" alt="PDF file" t-att-src="url" t-att-name="props.name" t-on-error="onLoadFailed"/>
        </t>
    </t>

`);
registerTemplate("web.PercentPieField", `/web/static/src/views/fields/percent_pie/percent_pie_field.xml`, `<t t-name="web.PercentPieField" xml:space="preserve">
        <figure class="o_pie mb-0 rounded-circle" t-attf-style="background: conic-gradient(                     var(--PercentPieField-color-active) 0% {{props.record.data[props.name]}}%,                     var(--PercentPieField-color-static) 0% 100%                 )"/>

        <div class="o_pie_info">
            <span class="o_pie_value" t-esc="formattedValue + '%'"/>
            <span class="o_pie_text" t-esc="props.string"/>
        </div>
    </t>

`);
registerTemplate("web.PercentageField", `/web/static/src/views/fields/percentage/percentage_field.xml`, `<t t-name="web.PercentageField" xml:space="preserve">
        <t t-if="props.readonly">
            <span t-esc="formattedValue"/>
        </t>
        <t t-else="">
            <div class="d-flex">
                <input t-ref="numpadDecimal" t-attf-class="o_input" t-att-placeholder="props.placeholder" type="text" inputmode="decimal" autocomplete="off"/>
                <span>%</span>
            </div>
        </t>
    </t>

`);
registerTemplate("web.PhoneField", `/web/static/src/views/fields/phone/phone_field.xml`, `<t t-name="web.PhoneField" xml:space="preserve">
        <div class="o_phone_content d-inline-flex w-100">
            <t t-if="props.readonly">
                <a t-if="props.record.data[props.name]" class="o_form_uri" target="_blank" t-att-href="phoneHref" t-esc="props.record.data[props.name]"/>
            </t>
            <t t-else="">
                <input class="o_input" t-att-id="props.id" type="tel" autocomplete="off" t-att-placeholder="props.placeholder" t-ref="input"/>
            </t>
        </div>
    </t>

    `);
registerTemplate("web.FormPhoneField", `/web/static/src/views/fields/phone/phone_field.xml`, `<t t-name="web.FormPhoneField" t-inherit="web.PhoneField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//input" position="after">
            <a t-if="props.record.data[props.name]" t-att-href="phoneHref" target="_blank" class="o_phone_form_link ms-3 d-inline-flex align-items-center">
                <i class="fa fa-phone"/><small class="fw-bold ms-1">Call</small>
            </a>
        </xpath>
    </t>

`);
registerTemplate("web.PriorityField", `/web/static/src/views/fields/priority/priority_field.xml`, `<t t-name="web.PriorityField" xml:space="preserve">
        <div class="o_priority" role="radiogroup" name="priority" aria-label="Priority">
            <t t-foreach="options" t-as="value" t-key="value">
                <t t-if="!value_first">
                    <t t-if="props.readonly">
                        <span class="o_priority_star fa" role="radio" t-att-class="value_index lte index ? 'fa-star' : 'fa-star-o'" tabindex="0" t-att-data-tooltip="getTooltip(value[1])" t-att-aria-checked="value_index === index ? 'true' : 'false'" t-att-aria-label="value[1]"/>
                    </t>
                    <t t-else="">
                        <a href="#" class="o_priority_star fa" role="radio" t-att-class="value_index lte index ? 'fa-star' : 'fa-star-o'" tabindex="0" t-att-data-tooltip="getTooltip(value[1])" t-att-aria-checked="value_index === index ? 'true' : 'false'" t-att-aria-label="value[1]" t-on-click.prevent.stop="() =&gt; this.onStarClicked(value[0])" t-on-mouseenter="() =&gt; state.index = value_index" t-on-mouseleave="() =&gt; state.index = -1"/>
                    </t>
                </t>
            </t>
        </div>
    </t>

`);
registerTemplate("web.ProgressBarField", `/web/static/src/views/fields/progress_bar/progress_bar_field.xml`, `<t t-name="web.ProgressBarField" xml:space="preserve">
        <div class="o_progressbar w-100 d-flex align-items-center" t-ref="numpadDecimal">
            <div t-if="props.title" class="o_progressbar_title text-nowrap pe-1"><t t-esc="props.title"/></div>
            <div class="o_progress align-middle overflow-hidden" aria-valuemin="0" t-att-aria-valuemax="this.maxValue" t-att-aria-valuenow="this.currentValue">
                <div t-attf-class="{{ progressBarColorClass }} h-100" t-att-style="'width: min(' + 100 * this.currentValue / this.maxValue + '%, 100%)'"/>
            </div>
            <div class="o_progressbar_value d-flex">
                <t t-if="isPercentage">
                    <input t-if="isEditable and props.isCurrentValueEditable" t-ref="currentValue" class="o_input h-100 text-center" type="text" inputmode="decimal" autocomplete="off" t-att-value="formatCurrentValue() or ''" t-att-required="props.required" t-on-change="onCurrentValueChange" t-on-focus="onInputFocus" t-on-blur="onInputBlur"/>
                    <span t-else="" class="mx-1" t-esc="formatCurrentValue(true)"/>
                    <span>%</span>
                </t>
                <t t-else="">
                    <input t-if="isEditable and props.isCurrentValueEditable" t-ref="currentValue" class="o_input h-100 text-center" type="text" inputmode="decimal" autocomplete="off" t-att-value="formatCurrentValue()" t-on-change="onCurrentValueChange" t-on-focus="onInputFocus" t-on-blur="onInputBlur"/>
                    <span t-else="" class="mx-1" t-esc="formatCurrentValue(true)"/>
                    /
                    <input t-if="isEditable and props.isMaxValueEditable" t-ref="maxValue" class="o_input h-100 text-center" type="text" inputmode="decimal" autocomplete="off" t-att-value="formatMaxValue()" t-on-change="onMaxValueChange" t-on-focus="onInputFocus" t-on-blur="onInputBlur"/>
                    <span t-else="" class="mx-1" t-esc="formatMaxValue(true)"/>
                </t>
            </div>
        </div>
    </t>

`);
registerTemplate("web.CardPropertiesField", `/web/static/src/views/fields/properties/card_properties_field.xml`, `<t t-name="web.CardPropertiesField" xml:space="preserve">
        <div t-ref="properties" class="w-100 fw-normal text-muted">
            <div class="o_card_property_field d-inline-flex flex-column justify-content-center align-items-start w-100 mb-1" t-foreach="propertiesList" t-as="propertyConfiguration" t-key="propertyConfiguration.name" t-if="propertyConfiguration.value and propertyConfiguration.view_in_cards">

                <div class="mw-100 text-truncate d-flex gap-2" t-att-class="{'border rounded-3 ps-2' : propertyConfiguration.type === 'boolean'}">
                    <label t-if="['integer', 'float', 'date', 'datetime', 'boolean'].includes(propertyConfiguration.type)" t-att-class="{'fw-bold' : propertyConfiguration.type !== 'boolean'}" t-out="propertyConfiguration.string"/>
                    <PropertyValue id="generateUniqueDomID()" canChangeDefinition="state.canChangeDefinition" comodel="propertyConfiguration.comodel || ''" context="props.context" domain="propertyConfiguration.domain || '[]'" readonly="props.readonly" selection="propertyConfiguration.selection" string="propertyConfiguration.string" tags="propertyConfiguration.tags" type="propertyConfiguration.type" value="propertyConfiguration.value" onChange.bind="() =&gt; {}" onTagsChange.bind="() =&gt; {}"/>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("web.PropertiesField", `/web/static/src/views/fields/properties/properties_field.xml`, `<t t-name="web.PropertiesField" xml:space="preserve">
        <div t-ref="properties" class="row" t-att-class="{'d-none': propertiesList.length === 0 and !state.showAddButton}" t-att-columns="renderedColumnsCount">
            <t t-set="unfoldedSeparators" t-value="state.unfoldedSeparators"/>
            <t t-set="_groupedPropertiesList" t-value="groupedPropertiesList"/>
            <t t-foreach="groupedPropertiesList" t-as="propertiesListGroup" t-key="propertiesListGroup_index">
                <t t-set="foldable" t-value="propertiesListGroup.name and propertiesListGroup.title and propertiesListGroup.title.length"/>
                <t t-set="isFolded" t-value="propertiesListGroup.name and !unfoldedSeparators.includes(propertiesListGroup.name)"/>
                <div class="o_inner_group o_group col-lg-6 o_property_group" t-att-property-name="propertiesListGroup.name || ''">
                    <div t-if="!propertiesListGroup.invisibleLabel" class="o_field_property_label o_field_property_group_label d-flex flex-row w-100 mb-3 text-uppercase fw-bolder align-items-baseline pe-2" t-att-class="{'invisible': propertiesListGroup.columnSeparator}" t-on-click="() =&gt; this.onSeparatorClick(propertiesListGroup.name)">
                        <span t-if="propertiesListGroup.title" t-out="propertiesListGroup.title"/>
                        <i t-if="state.canChangeDefinition and !props.readonly and !propertiesListGroup.columnSeparator" class="o_field_property_open_popover fa fa-pencil ms-3" t-on-click.prevent.stop="(event) =&gt; this.onPropertyEdit(event, propertiesListGroup.name)"/>
                        <i t-if="state.canChangeDefinition and !props.readonly" class="oi oi-draggable ms-1 d-none d-sm-block"/>
                        <div t-if="foldable" class="ms-auto">
                            <i class="fa me-1" t-att-class="isFolded ? 'fa-caret-right' : 'fa-caret-down'"/>
                        </div>
                    </div>
                    <div t-foreach="propertiesListGroup.elements" t-as="propertyConfiguration" t-key="propertyConfiguration.name" class="o_property_field o_wrap_label" t-att-class="{                             'd-flex flex-row': !env.isSmall and !isFolded, 'o_property_folded': isFolded,                             'mb-4': renderedColumnsCount === 1, 'mb-3': renderedColumnsCount !== 1                         }" t-att-property-name="propertyConfiguration.name">
                        <t t-set="domId" t-value="generateUniqueDomID()"/>
                        <label class="o_field_property_label o_form_label text-break d-flex align-items-baseline mb-0" t-att-class="{'w-auto': env.isSmall}" t-att-for="domId">
                            <span t-if="propertyConfiguration.string and propertyConfiguration.string.length" t-out="propertyConfiguration.string" t-att-class="{'o_property_field_highlight': state.movedPropertyName === propertyConfiguration.name}"/>
                            <i t-else="" class="o_field_property_empty_label">
                                New Property
                            </i>
                            <i t-if="state.canChangeDefinition and !props.readonly" class="o_field_property_open_popover fa fa-pencil ms-2" t-on-click="(event) =&gt; this.onPropertyEdit(event, propertyConfiguration.name)"/>
                            <i t-if="state.canChangeDefinition and !props.readonly" class="oi oi-draggable ms-1 d-none d-sm-block"/>
                        </label>
                        <div class="o_property_field_value w-100">
                            <PropertyValue id="domId" canChangeDefinition="state.canChangeDefinition" checkDefinitionWriteAccess.bind="checkDefinitionWriteAccess ? checkDefinitionWriteAccess : () =&gt; {}" comodel="propertyConfiguration.comodel || ''" context="props.context" domain="propertyConfiguration.domain || '[]'" readonly="props.readonly" selection="propertyConfiguration.selection" string="propertyConfiguration.string" tags="propertyConfiguration.tags" type="propertyConfiguration.type" value="propertyConfiguration.value" onChange.bind="(value) =&gt; this.onPropertyValueChange(propertyConfiguration.name, value)" onTagsChange.bind="(newTags, newValue) =&gt; this.onTagsChange(propertyConfiguration.name, newTags, newValue)"/>
                        </div>
                    </div>
                    <div t-if="propertiesListGroup_index === _groupedPropertiesList.length - 1 and state.showAddButton" class="o_field_property_add d-none d-sm-block" t-att-class="{'g-col-2': props.columns !== 1}">
                        <button t-if="!props.readonly and state.canChangeDefinition and definitionRecordId" class="btn btn-light text-muted text-break m-0" t-on-click="onPropertyCreate">
                            <i class="fa fa-plus"/>
                            Add a Property
                        </button>
                    </div>
                </div>
            </t>
        </div>
    </t>
`);
registerTemplate("web.PropertyDefinition", `/web/static/src/views/fields/properties/property_definition.xml`, `<t t-name="web.PropertyDefinition" xml:space="preserve">
        <div class="o_field_property_definition o_field_widget o_form_view d-block" t-ref="propertyDefinition">
            <div class="d-flex justify-content-between px-3 border-bottom">
                <div t-if="!env.isSmall" class="border-end py-1">
                    <button t-attf-class="btn btn-link ps-0 {{this.isFirst ? 'disabled' : ''}}" t-on-click="() =&gt; this.onPropertyMove('up')" title="Move this Property up">
                        <i class="oi oi-chevron-up ms-2"/>
                    </button>
                    <button t-attf-class="btn btn-link pe-3 {{this.isLast ? 'disabled' : ''}}" t-on-click="() =&gt; this.onPropertyMove('down')" title="Move this Property down">
                        <i class="oi oi-chevron-down ms-2"/>
                    </button>
                </div>
                <button t-else="" class="btn oi oi-arrow-left my-2" t-on-click="() =&gt; this.props.close()"/>
                <button t-if="!props.readonly and props.canChangeDefinition" class="btn pe-0 text-danger float-end o_field_property_definition_delete" title="Remove Property" t-on-click="props.onDelete">
                    <i class="fa fa-trash"/> Delete
                </button>
            </div>
            <div class="o_modal_container p-3 o_inner_group grid">
                <div class="d-contents mb-3 mb-sm-0">
                    <label class="o_form_label align-self-center text-900">Label</label>
                    <h6 t-if="props.readonly" t-out="state.propertyDefinition.string" class="text-truncate"/>
                    <input class="o_input o_field_property_definition_header" type="text" required="" placeholder="Property Name" autocomplete="off" t-model="state.propertyDefinition.string" t-on-change="onPropertyLabelChange" t-on-keypress="onPropertyLabelKeypress"/>
                </div>
                <div class="d-contents mb-3 mb-sm-0">
                    <label t-att-for="getUniqueDomID('type')" class="o_form_label align-self-center text-900">
                        Field Type
                    </label>
                    <div class="o_field_property_definition_type">
                        <div t-if="props.readonly" class="d-flex align-items-center mb-2">
                            <img class="me-3" t-attf-src="/web/static/src/views/fields/properties/icons/{{state.propertyDefinition.type}}.png"/>
                            <span t-out="state.typeLabel"/>
                        </div>
                        <Dropdown t-else="" menuClass="'o_field_property_definition_type_menu'">
                            <button class="btn btn-link d-flex p-0 w-100" t-att-title="state.typeLabel">
                                <div class="o_input_dropdown w-100 o_field_property_dropdown">
                                    <img t-attf-src="/web/static/src/views/fields/properties/icons/{{state.propertyDefinition.type}}.png" class="position-relative z-1 me-n4"/>
                                    <input type="text" class="dropdown text-start w-100 o_input py-1 align-middle" t-att-id="getUniqueDomID('type')" t-att-value="state.typeLabel" readonly=""/>
                                    <span class="o_dropdown_button"/>
                                </div>
                            </button>
                            <t t-set-slot="content">
                                <t t-foreach="availablePropertyTypes" t-as="option" t-key="option[0]">
                                    <DropdownItem onSelected.bind="() =&gt; this.onPropertyTypeChange(option[0])">
                                        <div class="d-flex align-items-center">
                                            <img class="me-2" t-attf-src="/web/static/src/views/fields/properties/icons/{{option[0]}}.png"/>
                                            <span t-out="option[1]"/>
                                        </div>
                                    </DropdownItem>
                                </t>
                            </t>
                        </Dropdown>
                    </div>
                </div>

                <div t-if="state.propertyDefinition.type === 'selection'" class="d-contents mb-3 mb-sm-0">
                    <label class="o_form_label text-900">Values</label>
                    <PropertyDefinitionSelection readonly="props.readonly || !props.canChangeDefinition" canChangeDefinition="props.canChangeDefinition" default="state.propertyDefinition.default || ''" options="state.propertyDefinition.selection || []" onOptionsChange.bind="onSelectionOptionChange" onDefaultOptionChange.bind="onDefaultChange"/>
                </div>
                <div t-if="state.propertyDefinition.type === 'tags'" class="d-contents mb-3 mb-sm-0">
                    <label t-att-for="getUniqueDomID('tags')" class="o_form_label text-900">Tag</label>
                    <PropertyTags id="getUniqueDomID('tags')" selectedTags="propertyTagValues" tags="state.propertyDefinition.tags || []" readonly="props.readonly" canChangeTags="props.canChangeDefinition" checkDefinitionWriteAccess.bind="props.checkDefinitionWriteAccess ? props.checkDefinitionWriteAccess : () =&gt; {}" deleteAction="'tags'" onTagsChange.bind="onTagsChange"/>
                </div>
                <div t-if="state.propertyDefinition.type === 'many2one' || state.propertyDefinition.type === 'many2many'" class="o_field_property_definition_model d-contents mb-3 mb-sm-0">
                    <label t-att-for="getUniqueDomID('model')" class="o_form_label align-self-center text-900">Model</label>
                    <span t-if="props.readonly">
                        <t t-if="state.resModelDescription" t-out="state.resModelDescription"/>
                    </span>
                    <ModelSelector t-else="" id="getUniqueDomID('model')" value="state.resModelDescription" onModelSelected.bind="onModelChange"/>
                </div>
                <div t-if="(state.propertyDefinition.type === 'many2one' || state.propertyDefinition.type === 'many2many')                     and state.propertyDefinition.comodel and state.propertyDefinition.comodel.length" class="d-contents mb-3 mb-sm-0">
                    <label class="o_form_label text-900">Domain</label>
                    <div>
                        <DomainSelector resModel="state.propertyDefinition.comodel" domain="state.propertyDefinition.domain || '[]'" readonly="props.readonly" update.bind="onDomainChange" isDebugMode="!!env.debug" className="'d-inline-block me-2'"/>
                        <div t-if="state.matchingRecordsCount !== undefined" class="d-inline-block">
                            <i class="oi oi-arrow-right" role="img" title="Domain"/>
                            <button class="btn btn-sm btn-secondary" type="button" t-on-click.stop="onButtonDomainClick">
                                <t t-out="state.matchingRecordsCount"/> record(s)
                            </button>
                        </div>
                    </div>
                </div>
                <div t-if="!['tags', 'selection', 'separator'].includes(state.propertyDefinition.type)                     and (!['many2one', 'many2many'].includes(state.propertyDefinition.type)                     || (state.propertyDefinition.comodel and state.propertyDefinition.comodel.length))" class="o_field_property_definition_value d-contents mb-3 mb-sm-0">
                    <label t-att-for="getUniqueDomID('default')" class="o_form_label align-self-center text-900">
                        <t t-if="state.propertyDefinition.type === 'boolean'">Default State</t>
                        <t t-else="">Default Value</t>
                    </label>
                    <PropertyValue id="getUniqueDomID('default')" readonly="props.readonly" canChangeDefinition="props.canChangeDefinition" type="state.propertyDefinition.type" string="state.propertyDefinition.string" value="state.propertyDefinition.default" comodel="state.propertyDefinition.comodel || ''" domain="state.propertyDefinition.domain || '[]'" context="props.context" onChange.bind="onDefaultChange"/>
                </div>
                <div t-if="state.propertyDefinition.type !== 'separator'" class="o_field_property_definition_kanban d-contents mb-3 mb-sm-0">
                    <label t-att-for="getUniqueDomID('kanban')" class="o_form_label align-self-center text-900">
                        Display in Cards
                        <sup class="text-info" title="Whether or not this Property Field is displayed in the Calendar, Cards &amp; Kanban views">?</sup>
                    </label>
                    <CheckBox id="getUniqueDomID('kanban')" value="props.propertyDefinition.view_in_cards" disabled="props.readonly" onChange.bind="onViewInKanbanChange"/>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("web.PropertyDefinitionSelection", `/web/static/src/views/fields/properties/property_definition_selection.xml`, `<t t-name="web.PropertyDefinitionSelection" xml:space="preserve">
        <div class="o_field_property_selection d-flex" t-ref="propertyDefinitionSelection">
            <div class="w-100">
                <div t-foreach="optionsVisible" t-as="option" t-key="option[0]" class="o_field_property_selection_option d-flex flex-row align-items-center justify-content-between mb-2 rounded" t-att-option-name="option[0]">
                    <i t-if="!props.readonly and props.canChangeDefinition" class="o_field_property_selection_drag oi oi-draggable ui-sortable-handle me-2 text-center"/>
                    <span t-if="props.readonly" t-out="option[1]"/>
                    <input t-else="" class="o_input me-3" type="text" placeholder="Option Name" t-att-value="option[1]" t-on-change="(event) =&gt; this.onOptionChange(event, option_index)" t-on-blur="(event) =&gt; this.onOptionBlur(event, option_index)" t-on-keydown="(event) =&gt; this.onOptionKeyDown(event, option_index)"/>
                    <button class="btn btn-link m-0 p-0 text-muted fs-5" title="Select Default" t-on-click="() =&gt; this.onOptionSetDefault(option_index)">
                        <i t-att-class="option[0] === props.default ? 'fa fa-star align-bottom' : 'fa fa-star-o align-bottom'"/>
                    </button>
                    <button t-if="!props.readonly" class="btn btn-link link-danger ms-2 p-0 fs-5" title="Remove Property" t-on-click="() =&gt; this.onOptionDelete(option_index)">
                        <i class="fa fa-trash-o align-bottom"/>
                    </button>
                </div>
                <button t-if="!props.readonly" class="btn btn-link btn-sm" t-on-click="() =&gt; this.onOptionCreate(this.options.length)" t-ref="addButton">
                    <i class="fa fa-plus"/>
                    Add a Value
                </button>
            </div>
        </div>
    </t>
`);
registerTemplate("web.PropertyTags", `/web/static/src/views/fields/properties/property_tags.xml`, `<t t-name="web.PropertyTags" xml:space="preserve">

        <div t-attf-class="o_field_property_tag o_field_widget o_field_many2many_tags d-flex {{props.readonly ? 'readonly' : ''}}">
            <TagsList tags="tagListItems"/>
            <div t-if="!props.readonly" class="o_field_property_dropdown_menu o_input_dropdown">
                <AutoComplete id="props.id" value="''" sources="autocompleteSources" onSelect.bind="({value}) =&gt; this.onOptionSelected(value)" resetOnSelect="true"/>
                <span class="o_dropdown_button"/>
            </div>
        </div>
    </t>
    `);
registerTemplate("web.PropertyTagsColorListPopover", `/web/static/src/views/fields/properties/property_tags.xml`, `<t t-name="web.PropertyTagsColorListPopover" xml:space="preserve">
        <div class="o_tag_popover m-2">
            <ColorList colors="props.colors" forceExpanded="true" onColorSelected.bind="(id) =&gt; props.switchTagColor(id, props.tag)"/>
        </div>
    </t>
    `);
registerTemplate("web.PropertyTagsField", `/web/static/src/views/fields/properties/property_tags.xml`, `<t t-name="web.PropertyTagsField" xml:space="preserve">
        <PropertyTags t-props="propertyTagsProps"/>
    </t>
`);
registerTemplate("web.PropertyValue", `/web/static/src/views/fields/properties/property_value.xml`, `<t t-name="web.PropertyValue" xml:space="preserve">
        <t t-if="props.readonly and !['boolean', 'many2one', 'many2many', 'tags'].includes(props.type)">
            <span t-if="displayValue" t-out="displayValue"/>
        </t>
        <t t-else="">
            <t t-if="props.type === 'boolean'">
                <CheckBox id="props.id" value="propertyValue" disabled="props.readonly" onChange.bind="onValueChange"/>
            </t>
            <t t-elif="['date', 'datetime'].includes(props.type)">
                <DateTimeInput id="props.id" type="props.type" value="propertyValue" onChange.bind="onValueChange"/>
            </t>
            <t t-elif="props.type === 'integer'">
                <input t-att-id="props.id" class="o_input o_field_property_input" type="text" autocomplete="off" t-att-value="displayValue" t-on-change="(event) =&gt; this.onValueChange(event.target.value)"/>
            </t>
            <t t-elif="props.type === 'float'">
                <input t-att-id="props.id" class="o_input o_field_property_input" type="text" autocomplete="off" t-att-value="displayValue" t-on-change="(event) =&gt; this.onValueChange(event.target.value)"/>
            </t>
            <t t-elif="props.type === 'selection'">
                <select class="o_input" t-on-change="event =&gt; this.onValueChange(event.target.value)" t-att-id="props.id">
                    <option t-att-value="false"/>
                    <t t-foreach="props.selection || []" t-as="option" t-key="option[0]">
                        <option t-att-selected="option[0] === propertyValue" t-att-value="option[0]" t-out="option[1]"/>
                    </t>
                </select>
            </t>
            <t t-elif="props.type === 'tags'">
                <PropertyTags id="props.id" selectedTags="propertyValue" tags="props.tags || []" deleteAction="'value'" readonly="props.readonly" canChangeTags="props.canChangeDefinition" checkDefinitionWriteAccess.bind="props.checkDefinitionWriteAccess ? props.checkDefinitionWriteAccess : () =&gt; {}" onValueChange.bind="onValueChange" onTagsChange.bind="props.onTagsChange"/>
            </t>
            <div t-elif="props.type === 'many2one'" class="o_field_property_many2one_value d-flex flex-row align-items-center" t-att-class="{'avatar': showAvatar}">
                <t t-if="props.comodel">
                    <t t-set="hasAccess" t-value="!propertyValue || propertyValue[1]"/>
                    <img t-if="showAvatar and propertyValue[0] and hasAccess" t-attf-src="/web/image/{{props.comodel}}/{{propertyValue[0]}}/avatar_128" class="o_avatar rounded me-1"/>
                    <t t-if="props.readonly || !hasAccess">
                        <a t-if="clickableRelational || !hasAccess" t-attf-class="o_form_uri {{propertyValue and propertyValue[1] ? '' : 'disabled'}}" t-att-href="propertyValue[0] ? \`#id=\${propertyValue[0]}&amp;model=\${props.comodel}\` : '#'" t-on-click.prevent="onMany2oneClick">
                            <t t-if="hasAccess" t-out="propertyValue[1]"/>
                            <t t-else="">No Access</t>
                        </a>
                        <span t-else="" t-out="propertyValue and propertyValue[1] || ''"/>
                    </t>
                    <Many2XAutocomplete t-else="" t-key="props.id + '_' + props.comodel + '_' + props.string" value="propertyValue[1] || ''" id="props.id" resModel="props.comodel" autoSelect="true" fieldString="props.string" update.bind="onValueChange" context="props.context" getDomain.bind="() =&gt; propertyDomain" quickCreate.bind="onQuickCreate" activeActions="{ create: true, createEdit: true, write: true }"/>
                    <button t-if="!props.readonly and propertyValue and propertyValue[0] and hasAccess" type="button" class="btn btn-secondary oi oi-arrow-right o_external_button o_properties_external_button py-0" tabindex="-1" draggable="false" aria-label="Internal link" data-tooltip="Internal link" t-on-click="onExternalLinkClick"/>
                </t>
            </div>
            <t t-elif="props.type === 'many2many'">
                <div t-if="props.comodel" class="o_field_property_many2many_value d-flex flex-wrap flex-row gap-1 ms-0 pe-1 w-100 " t-attf-class="o_field_widget o_field_many2many_tags {{showAvatar ? 'avatar' : ''}} {{props.readonly ? 'readonly' : ''}}">

                    <TagsList tags="propertyValue"/>
                    <Many2XAutocomplete t-if="!props.readonly" t-key="props.id + '_' + props.comodel + '_' + props.string" id="props.id" resModel="props.comodel" autoSelect="true" fieldString="props.string" update.bind="onValueChange" context="props.context" getDomain.bind="() =&gt; propertyDomain" quickCreate.bind="onQuickCreate" activeActions="{ create: true, createEdit: true, write: true }" isToMany="true"/>
                </div>
            </t>
            <t t-else="">
                <input class="o_input" t-att-id="props.id" type="text" autocomplete="off" t-att-value="propertyValue || ''" t-on-change="(event) =&gt; this.onValueChange(event.target.value)"/>
            </t>
        </t>
    </t>
`);
registerTemplate("web.RadioField", `/web/static/src/views/fields/radio/radio_field.xml`, `<t t-name="web.RadioField" xml:space="preserve">
        <div role="radiogroup" t-attf-class="o_{{ props.orientation }}" t-att-aria-label="props.label">
            <t t-foreach="items" t-as="item" t-key="item[0]">
                <div class="form-check o_radio_item" aria-atomic="true">
                    <input type="radio" class="form-check-input o_radio_input" t-att-checked="item[0] === value" t-att-disabled="props.readonly" t-att-name="id" t-att-data-value="item[0]" t-att-data-index="item_index" t-att-id="\`\${id}_\${item[0]}\`" t-on-change="() =&gt; this.onChange(item)"/>
                    <label class="form-check-label o_form_label" t-att-for="\`\${id}_\${item[0]}\`" t-esc="item[1]"/>
                </div>
            </t>
        </div>
    </t>

`);
registerTemplate("web.ReferenceField", `/web/static/src/views/fields/reference/reference_field.xml`, `<t t-name="web.ReferenceField" xml:space="preserve">
        <div class="o_row">
            <t t-if="!props.readonly and !hideModelSelector">
                <select class="o_input" t-att-tabindex="relation ? '-1': 0" t-on-change="(ev) =&gt; this.updateModel(ev.target.value || false)">
                    <option/>
                    <t t-foreach="selection" t-as="option" t-key="option[0]">
                        <option t-att-value="option[0]" t-att-selected="option[0] === relation" t-esc="option[1]"/>
                    </t>
                </select>
            </t>
            <t t-if="relation">
                <Many2OneField t-key="m2oProps.relation" t-props="m2oProps"/>
            </t>
        </div>
    </t>

`);
registerTemplate("web.X2ManyFieldDialog", `/web/static/src/views/fields/relational_utils.xml`, `<t t-name="web.X2ManyFieldDialog" xml:space="preserve">
    <Dialog t-props="dialogProps">
        <FormRenderer record="record" archInfo="archInfo"/>
        <t t-set-slot="footer">
            <t t-if="footerArchInfo">
                <FormRenderer record="record" archInfo="footerArchInfo">
                    <t t-set-slot="default_buttons">
                        <t t-call="web.X2ManyFieldDialogDefaultButtons"/>
                    </t>
                </FormRenderer>
            </t>
            <t t-else="">
                <t t-call="web.X2ManyFieldDialogDefaultButtons"/>
            </t>
        </t>
    </Dialog>
</t>

`);
registerTemplate("web.Many2XAutocomplete", `/web/static/src/views/fields/relational_utils.xml`, `<t t-name="web.Many2XAutocomplete" xml:space="preserve">
    <div class="o_input_dropdown" t-ref="autocomplete_container">
        <input t-if="env.isSmall and props.dropdown" type="text" t-att-id="props.id" class="o_input" readonly="" autocomplete="off" t-att-placeholder="props.placeholder" t-att-value="props.value" t-on-click="onSearchMore" t-on-barcode-search="onBarcodeSearch"/>
        <AutoComplete t-else="" value="props.value" id="props.id" placeholder="props.placeholder" sources="sources" autoSelect="props.autoSelect" onSelect.bind="onSelect" onInput.bind="onInput" onChange.bind="onChange" dropdown="props.dropdown" autofocus="props.autofocus" resetOnSelect="props.value === ''" onCancel.bind="onCancel"/>
        <span class="o_dropdown_button"/>
    </div>
</t>

`);
registerTemplate("web.AvatarMany2XAutocomplete", `/web/static/src/views/fields/relational_utils.xml`, `<t t-name="web.AvatarMany2XAutocomplete" xml:space="preserve">
    <span class="o_avatar_many2x_autocomplete o_avatar d-flex align-items-center">
        <img t-if="option.value" class="rounded me-1" t-attf-src="/web/image/{{option.resModel}}/{{option.value}}/avatar_128"/>
        <t t-esc="option.label"/>
    </span>
</t>

`);
registerTemplate("web.X2ManyFieldDialogDefaultButtons", `/web/static/src/views/fields/relational_utils.xml`, `<t t-name="web.X2ManyFieldDialogDefaultButtons" xml:space="preserve">
    <t t-if="record.isInEdition">
        <t t-if="canCreate">
            <button class="btn btn-primary o_form_button_save" t-on-click="save" data-hotkey="c">Save &amp; Close</button>
            <button class="btn btn-primary o_form_button_save_new" t-on-click="saveAndNew" data-hotkey="n">Save &amp; New</button>
        </t>
        <t t-else="">
            <button class="btn btn-primary o_form_button_save" t-on-click="save" data-hotkey="c">Save</button>
        </t>
        <button class="btn btn-secondary o_form_button_cancel" t-on-click="discard" data-hotkey="j">Discard</button>

        <t t-if="props.delete">
            <button class="btn btn-secondary o_btn_remove" t-on-click="remove" data-hotkey="k">
                <t t-if="props.deleteButtonLabel" t-out="props.deleteButtonLabel"/>
                <t t-else="">Remove</t>
            </button>
        </t>
    </t>
    <t t-else="">
        <button class="btn btn-primary o_form_button_cancel" t-on-click="() =&gt; this.props.close()" data-hotkey="j">Close</button>
    </t>
</t>

`);
registerTemplate("web.RemainingDaysField", `/web/static/src/views/fields/remaining_days/remaining_days_field.xml`, `<t t-name="web.RemainingDaysField" xml:space="preserve">
        <t t-if="props.readonly">
            <div t-att-class="classNames" t-att-title="formattedValue">
                <t t-esc="diffString"/>
            </div>
        </t>
        <t t-else="">
            <DateTimeField t-props="dateTimeFieldProps"/>
        </t>
    </t>
`);
registerTemplate("web.SelectionField", `/web/static/src/views/fields/selection/selection_field.xml`, `<t t-name="web.SelectionField" xml:space="preserve">
        <t t-if="props.readonly">
            <span t-esc="string" t-att-raw-value="value"/>
        </t>
        <t t-else="">
            <select class="o_input pe-3" t-on-change="onChange" t-on-click.stop="() =&gt; {}" t-att-id="props.id">
                <option t-att-selected="false === value" t-att-value="stringify(false)" t-esc="this.props.placeholder || ''" t-attf-style="{{ props.required ? 'display:none' : '' }}"/>
                <t t-foreach="options" t-as="option" t-key="option[0]">
                    <option t-att-selected="option[0] === value" t-att-value="stringify(option[0])" t-esc="option[1]"/>
                </t>
            </select>
        </t>
    </t>

`);
registerTemplate("web.SignatureField", `/web/static/src/views/fields/signature/signature_field.xml`, `<t t-name="web.SignatureField" xml:space="preserve">
        <t t-if="value">
            <img class="o_signature img img-fluid" alt="Binary file" t-att-src="getUrl" t-att-name="props.name" t-att-style="sizeStyle" t-on-click="onClickSignature" t-on-error.stop="onLoadFailed"/>
        </t>
        <t t-else="">
            <div class="o_signature o_signature_empty" t-att-style="sizeStyle" t-on-click="onClickSignature">
                <svg t-on-error.stop="onLoadFailed"/>
                <p>SIGNATURE</p>
            </div>
        </t>
    </t>

`);
registerTemplate("web.StatInfoField", `/web/static/src/views/fields/stat_info/stat_info_field.xml`, `<t t-name="web.StatInfoField" xml:space="preserve">
        <span class="o_stat_info o_stat_value" t-esc="formattedValue"/>
        <span t-if="!props.noLabel" class="o_stat_text" t-esc="label"/>
    </t>

`);
registerTemplate("web.StateSelectionField", `/web/static/src/views/fields/state_selection/state_selection_field.xml`, `<t t-name="web.StateSelectionField" xml:space="preserve">
        <t t-if="props.readonly">
            <button class="d-flex align-items-center btn fw-normal p-0">
                <span t-attf-class="o_status {{ statusColor(currentValue) }} "/>
                <span t-if="props.showLabel" class="o_status_label ms-1" t-esc="label"/>
            </button>
        </t>
        <t t-else="">
            <Dropdown menuClass="'state_selection_field_menu'">
                <button class="btn btn-link d-flex p-0">
                    <div class="d-flex align-items-center" t-att-title="props.showLabel ? '' : label">
                        <span t-attf-class="o_status {{ statusColor(currentValue) }} "/>
                        <span t-if="props.showLabel" class="o_status_label ms-1" t-esc="label"/>
                    </div>
                </button>
                <t t-set-slot="content">
                    <t t-foreach="options" t-as="option" t-key="option[0]">
                        <DropdownItem class="\`d-flex align-items-center \${option[0] === currentValue ? 'active' : ''}\`" onSelected="() =&gt; this.updateRecord(option[0])">
                                <span t-attf-class="o_status ms-2 {{ statusColor(option[0]) }} "/>
                                <span t-esc="option[1]"/>
                        </DropdownItem>
                    </t>
                </t>
            </Dropdown>
        </t>
    </t>

`);
registerTemplate("web.StatusBarField.Dropdown", `/web/static/src/views/fields/statusbar/statusbar_field.xml`, `<t t-name="web.StatusBarField.Dropdown" xml:space="preserve">
        <t t-foreach="items" t-as="item" t-key="item.value">
            <DropdownItem class="getDropdownItemClassNames(item)" onSelected="() =&gt; this.selectItem(item)">
                <span t-esc="item.label"/>
            </DropdownItem>
        </t>
    </t>

    `);
registerTemplate("web.StatusBarField", `/web/static/src/views/fields/statusbar/statusbar_field.xml`, `<t t-name="web.StatusBarField" xml:space="preserve">
        <div class="o_statusbar_status" t-ref="root" role="radiogroup" aria-label="Statusbar">
            <Dropdown position="'bottom-end'">
                <button t-ref="after" type="button" class="btn btn-secondary dropdown-toggle o_arrow_button o_first" t-att-disabled="props.isDisabled" aria-label="More...">
                    ...
                </button>
                <t t-set-slot="content">
                    <t t-call="web.StatusBarField.Dropdown">
                        <t t-set="items" t-value="items.after"/>
                    </t>
                </t>
            </Dropdown>
            <t t-foreach="items.inline" t-as="item" t-key="item.value">
                <button type="button" class="btn btn-secondary o_arrow_button" t-att-class="{                         o_first: item_first,                         o_arrow_button_current: item.isSelected,                         o_last: item_last,                     }" t-att-disabled="props.isDisabled || item.isSelected" role="radio" t-att-aria-checked="item.isSelected.toString()" t-att-aria-current="item.isSelected and 'step'" t-att-data-value="item.value" t-esc="item.label" t-on-click="() =&gt; this.selectItem(item)"/>
            </t>
            <Dropdown position="'bottom-start'">
                <button t-ref="before" type="button" class="btn btn-secondary dropdown-toggle o_arrow_button o_last" t-att-disabled="props.isDisabled" aria-label="More...">
                    ...
                </button>
                <t t-set-slot="content">
                    <t t-call="web.StatusBarField.Dropdown">
                        <t t-set="items" t-value="items.before"/>
                    </t>
                </t>
            </Dropdown>
            <Dropdown position="'bottom-end'">
                <button t-ref="dropdown" type="button" class="btn btn-secondary dropdown-toggle" t-att-disabled="props.isDisabled">
                    <t t-out="getCurrentLabel()"/>
                </button>
                <t t-set-slot="content">
                    <t t-call="web.StatusBarField.Dropdown">
                        <t t-set="items" t-value="getAllItems()"/>
                    </t>
                </t>
            </Dropdown>
        </div>
    </t>
`);
registerTemplate("web.TextField", `/web/static/src/views/fields/text/text_field.xml`, `<t t-name="web.TextField" xml:space="preserve">
        <t t-if="props.readonly">
            <span t-esc="props.record.data[props.name] or ''"/>
        </t>
        <t t-else="">
            <div t-ref="div">
                <textarea class="o_input" t-att-class="{                         'o_field_translate': isTranslatable,                         'o_field_placeholder': props.dynamicPlaceholder,                     }" t-att-id="props.id" t-att-placeholder="props.placeholder" t-att-rows="rowCount" t-ref="textarea" t-on-blur="onBlur"/>
                <div class="o_field_input_buttons">
                    <TranslationButton t-if="isTranslatable" fieldName="props.name" record="props.record"/>
                    <button t-if="props.dynamicPlaceholder" class="btn m-0 py-0 px-2 fa fa-magic position-relative" title="Insert Field" t-on-click="onDynamicPlaceholderOpen"/>
                </div>
            </div>
        </t>
    </t>

`);
registerTemplate("web.TimezoneMismatchField", `/web/static/src/views/fields/timezone_mismatch/timezone_mismatch_field.xml`, `<t t-name="web.TimezoneMismatchField" t-inherit="web.SelectionField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="." position="inside">
            <span t-if="mismatch" class="o_tz_warning fa fa-exclamation-triangle position-static align-self-center m-0 ms-2" t-att-title="mismatchTitle"/>
        </xpath>
    </t>

`);
registerTemplate("web.TranslationButton", `/web/static/src/views/fields/translation_button.xml`, `<t t-name="web.TranslationButton" xml:space="preserve">
        <t t-if="isMultiLang">
            <span class="o_field_translate btn btn-link" t-on-click.prevent="onClick">
                <t t-esc="lang"/>
            </span>
        </t>
    </t>

`);
registerTemplate("web.TranslationDialog", `/web/static/src/views/fields/translation_dialog.xml`, `<t t-name="web.TranslationDialog" xml:space="preserve">
        <Dialog title="title">
            <div class="o_translation_dialog">
                <t t-foreach="terms" t-as="term" t-key="term.id">
                    <div class="row">
                        <div class="col-12" t-att-class="{ o_language_current: term.lang === user.lang }" t-attf-class="col-lg-{{ props.showSource ? 2 : 3 }}">
                            <t t-esc="term.langName"/>
                        </div>
                        <t t-if="props.showSource">
                            <div class="col-12 col-lg-3 source">
                                <t t-esc="term.source"/>
                            </div>
                        </t>
                        <div class="col-12 translation" t-attf-class="col-lg-{{ props.showSource ? 7 : 9 }}">
                            <t t-if="props.isText">
                                <textarea class="o_field_text o_field_translate o_field_widget o_input" t-att-value="term.value" t-att-data-id="term.id" t-att-rows="props.showSource ? 2 : 5" t-on-change="(ev) =&gt; this.updatedTerms[term.id] = ev.target.value"/>
                            </t>
                            <t t-else="">
                                <input type="text" class="o_field_char o_input" t-att-value="term.value" t-att-data-id="term.id" t-on-change="(ev) =&gt; this.updatedTerms[term.id] = ev.target.value"/>
                            </t>
                        </div>
                    </div>
                </t>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="onSave">Save</button>
                <button class="btn" t-on-click="props.close">Discard</button>
            </t>
        </Dialog>
    </t>

`);
registerTemplate("web.UrlField", `/web/static/src/views/fields/url/url_field.xml`, `<t t-name="web.UrlField" xml:space="preserve">
        <t t-if="props.readonly">
            <a class="o_field_widget o_form_uri" t-on-click.stop="" t-att-href="formattedHref" t-esc="props.text || props.record.data[props.name] || ''" target="_blank"/>
        </t>
        <t t-else="">
            <div class="d-inline-flex w-100">
                <input class="o_input" t-att-id="props.id" type="text" autocomplete="off" t-att-placeholder="props.placeholder" t-att-required="props.required" t-ref="input"/>
            </div>
        </t>
    </t>

    `);
registerTemplate("web.FormUrlField", `/web/static/src/views/fields/url/url_field.xml`, `<t t-name="web.FormUrlField" t-inherit="web.UrlField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//input" position="after">
            <a t-if="props.record.data[props.name]" t-att-href="formattedHref" class="ms-3 d-inline-flex align-items-center" target="_blank">
                <i class="fa fa-globe" data-tooltip="Go to URL" aria-label="Go to URL"/>
            </a>
        </xpath>
    </t>

`);
registerTemplate("web.ListX2ManyField", `/web/static/src/views/fields/x2many/list_x2many_field.xml`, `<t t-name="web.ListX2ManyField" xml:space="preserve">
       <t t-esc="formattedValue"/>
    </t>

`);
registerTemplate("web.X2ManyField", `/web/static/src/views/fields/x2many/x2many_field.xml`, `<t t-name="web.X2ManyField" xml:space="preserve">
        <div t-att-class="className">
            <div class="o_x2m_control_panel d-empty-none mt-1 mb-4">
                <t t-if="displayControlPanelButtons">
                    <div class="o_cp_buttons gap-1" role="toolbar" aria-label="Control panel buttons" t-ref="buttons">
                        <t t-foreach="creates" t-as="create" t-key="create_index">
                            <button t-if="create.type === 'create'" type="button" class="btn btn-secondary" t-att-class="create.class" t-on-click.stop.prevent="() =&gt; this.onAdd({ context: create.context })">
                                <t t-esc="create.string"/>
                            </button>
                            <ViewButton t-if="create.type === 'button'" className="\`\${create.className}\`" clickParams="create.clickParams" icon="create.icon" record="props.record.data[props.name]" string="create.string" title="create.title"/>
                        </t>
                    </div>
                </t>
                <div t-if="props.record.data[props.name].count &gt; props.record.data[props.name].limit" class="o_cp_pager" role="search">
                    <Pager t-props="pagerProps"/>
                </div>
            </div>
            <ListRenderer t-if="props.viewMode === 'list'" t-props="this.rendererProps"/>
            <KanbanRenderer t-elif="props.viewMode" t-props="this.rendererProps"/>
        </div>
    </t>

`);
registerTemplate("web.Form.ButtonBox", `/web/static/src/views/form/button_box/button_box.xml`, `<t t-name="web.Form.ButtonBox" xml:space="preserve">
    <div class="o-form-buttonbox d-print-none position-relative d-flex w-md-auto" t-attf-class="{{ isFull ? 'o_full w-100' : 'o_not_full'}} {{this.props.class}}">
        <t t-slot="{{ button_value }}" t-foreach="visibleButtons" t-as="button" t-key="button_value"/>
        <div t-if="additionalButtons.length" class="oe_stat_button btn position-relative p-0 border-0">
            <Dropdown position="!env.isSmall ? 'bottom-end' : ''" menuClass="'o-form-buttonbox p-0 border-0 ' + (!env.isSmall ? 'o_dropdown_more' : 'o-form-buttonbox-small')">
                <button class="o_button_more btn d-flex justify-content-center align-items-center" t-att-class="!env.isSmall ? 'o-dropdown-caret btn-outline-secondary' : 'btn-secondary'">
                    <span t-if="!env.isSmall">More</span>
                    <i t-else="" class="fa fa-fw fa-bolt lh-base" aria-hidden="true"/>
                </button>
                <t t-set-slot="content">
                    <DropdownItem t-foreach="additionalButtons" t-as="button" t-key="button_value" class="'d-flex flex-column p-0'">
                        <t t-slot="{{ button_value }}"/>
                    </DropdownItem>
                </t>
            </Dropdown>
        </div>
    </div>
</t>

`);
registerTemplate("web.FormCogMenu", `/web/static/src/views/form/form_cog_menu/form_cog_menu.xml`, `<t t-name="web.FormCogMenu" t-inherit="web.CogMenu" xml:space="preserve">
        <xpath expr="//div[hasclass('o_cp_action_menus')]" position="attributes">
            <attribute name="t-if">env.isSmall or hasItems</attribute>
        </xpath>
        <xpath expr="//t[@t-if='state.printItems.length']" position="before">
            <t t-slot="default"/>
        </xpath>
        <xpath expr="//t[@t-if='state.printItems.length']/Dropdown" position="before">
            <div role="separator" class="dropdown-divider"/>
        </xpath>
    </t>

`);
registerTemplate("web.FormView", `/web/static/src/views/form/form_controller.xml`, `<t t-name="web.FormView" xml:space="preserve">
        <div t-att-class="className" t-ref="root">
            <div class="o_form_view_container">
                <Layout className="model.useSampleModel ? 'o_view_sample_data' : ''" display="display">
                    <t t-set-slot="control-panel-create-button">
                        <t t-if="canCreate">
                            <button type="button" class="btn btn-secondary o_form_button_create" data-hotkey="c" t-on-click.stop="create">New</button>
                        </t>
                    </t>

                    <t t-set-slot="layout-buttons">
                        <t t-if="env.inDialog">
                            <t t-if="footerArchInfo">
                                <t t-component="props.Renderer" record="model.root" Compiler="props.Compiler" archInfo="footerArchInfo">
                                    <t t-set-slot="default_buttons">
                                        <t t-call="{{ props.buttonTemplate }}"/>
                                    </t>
                                </t>
                            </t>
                            <t t-else="">
                                <t t-call="{{ props.buttonTemplate }}"/>
                            </t>
                        </t>
                    </t>

                    <t t-set-slot="layout-actions">
                        <t t-if="!env.isSmall and buttonBoxTemplate">
                            <t t-call="{{ buttonBoxTemplate }}" t-call-context="{ __comp__: Object.assign(Object.create(this), { this, props: { ...this.props, record: this.model.root } }) }"/>
                        </t>
                    </t>

                    <t t-set-slot="control-panel-additional-actions">
                        <CogMenu t-props="this.cogMenuProps">
                            <t t-if="env.isSmall and statusBarDropdownItemsTemplate">
                                <t t-call="{{ statusBarDropdownItemsTemplate }}" t-call-context="{ __comp__: Object.assign(Object.create(this), { this, props: { ...this.props, record: this.model.root } }) }"/>
                            </t>
                        </CogMenu>
                        <t t-if="env.isSmall and buttonBoxTemplate">
                            <t t-call="{{ buttonBoxTemplate }}" t-call-context="{ __comp__: Object.assign(Object.create(this), { this, props: { ...this.props, record: this.model.root } }) }"/>
                        </t>
                    </t>

                    <t t-set-slot="control-panel-status-indicator">
                        <t t-if="canEdit">
                            <FormStatusIndicator model="model" discard.bind="discard" save.bind="saveButtonClicked"/>
                        </t>
                    </t>
                    <t t-set-slot="control-panel-create-button">
                        <t t-if="canCreate">
                            <button type="button" class="btn btn-outline-primary o_form_button_create" data-hotkey="c" t-on-click.stop="create">New</button>
                        </t>
                    </t>
                    <t t-component="props.Renderer" record="model.root" Compiler="props.Compiler" archInfo="archInfo" translateAlert="translateAlert" onNotebookPageChange.bind="onNotebookPageChange" activeNotebookPages="props.state and props.state.activeNotebookPages"/>
                </Layout>
            </div>
        </div>
    </t>

    `);
registerTemplate("web.FormView.Buttons", `/web/static/src/views/form/form_controller.xml`, `<t t-name="web.FormView.Buttons" xml:space="preserve">
        <div t-if="model.root.isInEdition" class="o_form_buttons_edit d-flex gap-1">
            <button type="button" class="btn btn-primary o_form_button_save" data-hotkey="s" t-on-click.stop="() =&gt; this.saveButtonClicked({closable: true})">
                Save
            </button>
            <button type="button" class="btn btn-secondary o_form_button_cancel" data-hotkey="j" t-on-click.stop="discard">
                Discard
            </button>
            <button t-if="props.removeRecord" class="btn btn-secondary o_form_button_remove" t-on-click="props.removeRecord" data-hotkey="x">
                Remove
            </button>
        </div>
        <div t-elif="canCreate" class="o_form_buttons_view">
            <button type="button" class="btn btn-secondary o_form_button_create" data-hotkey="c" t-on-click.stop="create">
                New
            </button>
        </div>
    </t>

    `);
registerTemplate("web.DefaultButtonsSlot", `/web/static/src/views/form/form_controller.xml`, `<t t-name="web.DefaultButtonsSlot" xml:space="preserve">
        <t t-slot="default_buttons"/>
    </t>
`);
registerTemplateExtension("web.ControlPanel", `/knowledge/static/src/xml/form_controller.xml`, `<t t-name="KnowledgeControlPanel" t-inherit="web.ControlPanel" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('o_cp_pager')]" position="before">
            <t t-slot="control-panel-knowledge-button"/>
        </xpath>
    </t>
    `);
registerTemplateExtension("web.FormView", `/knowledge/static/src/xml/form_controller.xml`, `<t t-name="Knowledge.FormView" t-inherit="web.FormView" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//Layout" position="inside">
            <t t-set-slot="control-panel-knowledge-button">
                <button class="o_knowledge_icon_search btn opacity-trigger-hover" t-att-class="{'btn-secondary': env.isSmall}" type="button" t-on-click="onClickSearchKnowledgeArticle" title="Search Knowledge Articles">
                    <t t-call="Knowledge.KnowledgeIcon"/>
                </button>
            </t>
        </xpath>
    </t>

    `);
registerTemplate("Knowledge.KnowledgeIcon", `/knowledge/static/src/xml/form_controller.xml`, `<t t-name="Knowledge.KnowledgeIcon" xml:space="preserve">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 50 50" class="o_ui_app_icon oi oi-fw">
            <path fill="var(--oi-color, #1AD3BB)" d="M21 0c-2 0-4 2-4 3.99V12h18v20.071l5.428 3.748A1 1 0 0 0 42 35.001V0H21Z" class="opacity-50 opacity-100-hover"/>
            <path fill="var(--oi-color, #985184)" d="M8 17.99C8 16 10 14 12 14h21v35a1 1 0 0 1-1.572.82L23 44c-1.5-1-3.5-1-5 0l-8.428 5.82A1 1 0 0 1 8 49V17.99Z"/>
            <path fill="var(--oi-color, #005E7A)" d="M33 30.658 32 30c-1.5-1-3.5-1-5 0l-8.428 5.82A1 1 0 0 1 17 35V14h16v16.658Z"/>
        </svg>
    </t>
`);
registerTemplate("web.FormErrorDialog", `/web/static/src/views/form/form_error_dialog/form_error_dialog.xml`, `<t t-name="web.FormErrorDialog" xml:space="preserve">
        <Dialog header="false" size="'md'" contentClass="'o_error_dialog'">
            <div role="alert">
                <h1 class="text-danger">Oh snap!</h1>
                <p t-esc="message" class="text-prewrap"/>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="stay">Stay here</button>
                <button class="btn btn-secondary" t-if="redirectAction" t-on-click="onRedirectBtnClicked"><t t-esc="redirectBtnLabel"/></button>
                <button class="btn btn-secondary" t-on-click="discard">Discard changes</button>
            </t>
        </Dialog>
    </t>

`);
registerTemplate("web.Form.OuterGroup", `/web/static/src/views/form/form_group/form_group.xml`, `<t t-name="web.Form.OuterGroup" xml:space="preserve">
    <div class="o_group row align-items-start" t-attf-class="{{ allClasses }}" t-att-style="props.style">
        <t t-slot="title" t-if="props.slots and props.slots.title"/>
        <t t-foreach="getItems()" t-as="item" t-key="item_index">
            <span class="o_newline" t-if="item.newline"/>
            <t t-slot="{{ item.name }}" className="item.colspan !== props.maxCols ? 'col-lg-' + item.size : ''"/>
        </t>
    </div>
</t>

`);
registerTemplate("web.Form.InnerGroup", `/web/static/src/views/form/form_group/form_group.xml`, `<t t-name="web.Form.InnerGroup" xml:space="preserve">
    <div t-attf-class="{{ allClasses }}" class="o_inner_group grid" t-att-style="props.style">
        <div t-if="props.slots and props.slots.title" t-attf-class="g-col-sm-{{ props.maxCols }}">
            <t t-slot="title"/>
        </div>
        <div t-foreach="getRows()" t-as="row" t-key="row_index" class="o_wrap_field d-flex d-sm-contents flex-column mb-3 mb-sm-0" t-if="row.isVisible">
            <t t-foreach="row" t-as="cell" t-key="cell_index">

                <t t-if="cell.subType === 'item_component'">
                    <t t-call="web.Form.InnerGroup.ItemComponent"><t t-set="cell" t-value="cell"/></t>
                </t>

                <t t-else="">
                    <div class="o_cell" t-attf-style="{{ cell.itemSpan &gt; 1 ? 'grid-column: span ' + cell.itemSpan + ';' : '' }}" t-attf-class="{{ cell.subType === 'label' ? 'o_wrap_label text-break text-900' : null }}" t-if="cell.isVisible">
                        <t t-slot="{{ cell.name }}"/>
                    </div>
                </t>

            </t>
        </div>
    </div>
</t>

`);
registerTemplate("web.Form.InnerGroup.ItemComponent", `/web/static/src/views/form/form_group/form_group.xml`, `<t t-name="web.Form.InnerGroup.ItemComponent" xml:space="preserve">
    <t t-if="cell.props.fieldInfo.field.component.name !== 'BooleanField'">
        <div class="o_cell o_wrap_label text-break text-900">
            <t t-component="cell.Component" t-if="cell.isVisible" t-props="cell.props"/>
        </div>
        <div class="o_cell o_wrap_input text-break" t-attf-style="{{ cell.itemSpan -1 &gt; 1 ? 'grid-column: span ' + (cell.itemSpan -1) + ';' : '' }}">
            <t t-slot="{{ cell.name }}"/>
        </div>
    </t>
    <t t-else="">
        <div class="o_wrap_field_boolean d-flex d-sm-contents">
            <div class="o_cell o_wrap_label flex-sm-grow-0 text-break text-900">
                <t t-component="cell.Component" t-if="cell.isVisible" t-props="cell.props"/>
            </div>
            <div class="o_cell o_wrap_input order-first flex-sm-grow-0 order-sm-0" t-attf-style="{{ cell.itemSpan -1 &gt; 1 ? 'grid-column: span ' + (cell.itemSpan -1) + ';' : '' }}">
                <t t-slot="{{ cell.name }}"/>
            </div>
        </div>
    </t>
</t>

`);
registerTemplate("web.FormLabel", `/web/static/src/views/form/form_label.xml`, `<t t-name="web.FormLabel" xml:space="preserve">
        <label class="o_form_label" t-att-for="props.id" t-att-class="className">
            <t t-esc="props.string"/><sup class="text-info p-1" t-if="hasTooltip" t-att="{'data-tooltip-template': 'web.FieldTooltip', 'data-tooltip-info': tooltipInfo, 'data-tooltip-touch-tap-to-show': 'true'}">?</sup>
        </label>
    </t>

`);
registerTemplate("web.FormStatusIndicator", `/web/static/src/views/form/form_status_indicator/form_status_indicator.xml`, `<t t-name="web.FormStatusIndicator" xml:space="preserve">
        <div class="o_form_status_indicator d-md-flex align-items-center align-self-md-end me-auto" t-att-class="{ o_form_status_indicator_new_record: props.model.root.isNew }">
            <div class="o_form_status_indicator_buttons d-flex" t-att-class="{ invisible: !(props.model.root.isNew or displayButtons) }">
                <button type="button" class="o_form_button_save btn btn-light border-0 px-1 py-0 lh-sm" data-hotkey="s" t-on-click.stop="save" data-tooltip="Save manually" aria-label="Save manually" t-ref="save">
                    <i class="fa fa-cloud-upload fa-fw"/>
                </button>
                <button type="button" class="o_form_button_cancel btn btn-light border-0 px-1 py-0 lh-sm" data-hotkey="j" t-on-click.stop="discard" data-tooltip="Discard all changes" aria-label="Discard all changes">
                    <i class="fa fa-times fa-fw"/>
                </button>
            </div>
            <span t-if="!props.model.root.isNew and indicatorMode === 'invalid'" class="text-danger small ms-2" data-tooltip="Unable to save. Correct the issue or discard all changes">
                <i class="fa fa-warning"/>
            </span>
        </div>
    </t>
`);
registerTemplate("web.Setting", `/web/static/src/views/form/setting/setting.xml`, `<t t-name="web.Setting" xml:space="preserve">
        <div t-att-class="classNames" t-att-id="props.id">
            <div class="o_setting_left_pane" t-att-data-tooltip="props.title" data-tooltip-delay="800">
                <t t-if="props.fieldName and fieldType==='boolean'">
                    <t t-slot="fieldSlot"/>
                </t>
            </div>
            <div class="o_setting_right_pane" t-att-data-tooltip="props.title" data-tooltip-delay="800">
                <FormLabel t-if="props.fieldName and props.addLabel" notMuttedLabel="notMuttedLabel" fieldName="props.fieldName" id="props.fieldId" string="labelString" record="props.record" fieldInfo="props.fieldInfo"/>
                <t t-if="labelString and !props.fieldName and props.addLabel">
                    <span class="o_form_label"><t t-esc="labelString"/></span>
                </t>
                <t t-if="labelString and props.documentation">
                    <DocumentationLink path="props.documentation" icon="'fa-question-circle'"/>
                </t>
                <t t-if="displayCompanyDependentIcon">
                    <span class="fa fa-lg fa-building-o" title="Values set here are company-specific."/>
                </t>
                <t t-if="labelString and props.help">
                    <div class="text-muted"><t t-esc="props.help"/></div>
                </t>
                <div class="mt16">
                    <t t-if="props.fieldName and fieldType!=='boolean'">
                        <t t-slot="fieldSlot"/>
                    </t>
                    <t t-slot="default"/>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("web.StatusBarButtons", `/web/static/src/views/form/status_bar_buttons/status_bar_buttons.xml`, `<t t-name="web.StatusBarButtons" xml:space="preserve">
        <div class="o_statusbar_buttons d-flex align-items-center align-content-around flex-wrap gap-1">
            <t t-foreach="visibleSlotNames" t-as="slot" t-key="slot">
                <t t-slot="{{ slot }}"/>
            </t>
        </div>
    </t>

`);
registerTemplate("web.StatusBarDropdownItems", `/web/static/src/views/form/status_bar_dropdown_items/status_bar_dropdown_items.xml`, `<t t-name="web.StatusBarDropdownItems" xml:space="preserve">
        <t t-foreach="visibleSlotNames" t-as="slot" t-key="slot">
            <DropdownItem class="'o-dropdown-item-unstyled-button'">
                <t t-slot="{{ slot }}"/>
            </DropdownItem>
        </t>
    </t>

`);
registerTemplate("web.KanbanColorPicker", `/web/static/src/views/kanban/kanban_color_picker_legacy.xml`, `<t t-name="web.KanbanColorPicker" xml:space="preserve">
        <ul t-if="this.dataState.widget.editable" class="oe_kanban_colorpicker mb-0 ms-2">

            <t t-foreach="this.props.colors" t-as="color" t-key="color_index">
                <li role="menuitem" t-on-click="() =&gt; this.selectColor(color_index)" t-att-title="color" t-att-aria-label="color">
                    <a href="#" t-attf-class="oe_kanban_color_{{ color_index }}"/>
                </li>
            </t>
        </ul>
    </t>

`);
registerTemplate("web.KanbanExamplesNotebookTemplate", `/web/static/src/views/kanban/kanban_column_examples_dialog.xml`, `<t t-name="web.KanbanExamplesNotebookTemplate" xml:space="preserve">
        <div t-if="props.description" class="o_kanban_examples_description" t-out="props.description"/>
        <div class="o_kanban_examples d-flex p-2">
            <t t-foreach="columns" t-as="column" t-key="column.title">
                <div class="o_kanban_examples_group flex-grow-1 m-3">
                    <h6><b t-esc="column.title"/></h6>
                    <div t-foreach="column.records" t-as="record" t-key="record.id" class="o_kanban_examples_ghost p-2 border bg-white" t-att-class="{ 'o_collapse': record_index &gt; 0 }">
                        <div class="o_ghost_content pb-3 bg-300"/>
                        <div class="o_ghost_content o_ghost_tag d-inline-block w-50 mt-3 pb-3 bg-300"/>
                        <span class="ms-2" t-if="record.bullet" t-out="record.bullet"/>
                    </div>
                </div>
            </t>
        </div>
    </t>


    `);
registerTemplate("web.KanbanColumnExamplesDialog", `/web/static/src/views/kanban/kanban_column_examples_dialog.xml`, `<t t-name="web.KanbanColumnExamplesDialog" xml:space="preserve">
        <Dialog contentClass="'o_kanban_examples_dialog'" title.translate="Kanban Examples">
            <Notebook orientation="'vertical'" pages="pages" onPageUpdate.bind="onPageUpdate"/>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="applyExamples" t-esc="props.applyExamplesText"/>
                <button class="btn btn-secondary" t-on-click="props.close">Close</button>
            </t>
        </Dialog>
    </t>

`);
registerTemplate("web.KanbanColumnQuickCreate", `/web/static/src/views/kanban/kanban_column_quick_create.xml`, `<t t-name="web.KanbanColumnQuickCreate" xml:space="preserve">
        <div class="o_column_quick_create d-print-none flex-shrink-0 flex-grow-1 flex-md-grow-0" t-ref="root">
            <div t-if="props.folded" class="o_quick_create_folded position-sticky z-1 my-3 text-nowrap" t-on-click="unfold">
                <button class="o_kanban_add_column btn btn-light w-100" aria-label="Add column" data-tooltip="Add column">
                    <i class="fa fa-plus me-2" role="img"/><t t-out="relatedFieldName"/>
                </button>
            </div>
            <div t-else="" class="o_quick_create_unfolded pt-3 pb-2">
                <div class="o_kanban_header top-0 pb-3">
                    <div class="input-group mb-1">
                        <input type="text" class="form-control bg-view" t-attf-placeholder="{{ relatedFieldName }}..." t-ref="autofocus" t-on-focus="() =&gt; state.hasInputFocused = true" t-on-blur="() =&gt; state.hasInputFocused = false" t-on-keydown="onInputKeydown"/>
                        <button class="btn btn-primary o_kanban_add" type="button" t-on-click="validate">
                            Add
                        </button>
                    </div>
                    <div t-if="!env.isSmall and state.hasInputFocused" t-attf-class="o_discard_msg small text-muted {{ canShowExamples ? 'float-end' : 'text-end'}}">
                        Press <kbd>Esc</kbd> to discard
                    </div>
                    <t t-if="canShowExamples and !env.isSmall">
                        <button type="button" class="btn btn-link o_kanban_examples p-0" t-on-click="showExamples">See examples</button>
                    </t>
                </div>
                <div t-foreach="[,,,]" t-as="i" t-key="i_index" class="o_kanban_muted_record mb-2 py-5 bg-300 opacity-50"/>
            </div>
        </div>
    </t>

`);
registerTemplate("web.KanbanView", `/web/static/src/views/kanban/kanban_controller.xml`, `<t t-name="web.KanbanView" xml:space="preserve">
        <div t-att-class="className" t-ref="root">
            <Layout className="model.useSampleModel ? 'o_view_sample_data' : ''" display="props.display">
                <t t-set-slot="control-panel-create-button">
                    <t t-if="canCreate and props.showButtons">
                        <button type="button" class="btn btn-primary o-kanban-button-new" accesskey="c" t-on-click="() =&gt; this.createRecord()" data-bounce-button="">
                            New
                        </button>
                    </t>
                </t>
                <t t-set-slot="layout-buttons">
                    <t t-call="{{ props.buttonTemplate }}"/>
                </t>
                <t t-set-slot="control-panel-always-buttons">
                    <t t-foreach="headerButtons" t-as="button" t-key="button.id" t-if="!evalViewModifier(button.invisible)">
                        <MultiRecordViewButton t-if="button.display === 'always'" list="model.root" className="button.className" clickParams="button.clickParams" defaultRank="'btn-secondary'" domain="props.domain" icon="button.icon" string="button.string" title="button.title" attrs="button.attrs"/>
                    </t>
                </t>
                <t t-set-slot="control-panel-additional-actions">
                    <CogMenu/>
                </t>
                <t t-set-slot="layout-actions">
                    <SearchBar toggler="searchBarToggler"/>
                </t>
                <t t-set-slot="control-panel-navigation-additional">
                    <t t-component="searchBarToggler.component" t-props="searchBarToggler.props"/>
                </t>
                <t t-component="props.Renderer" list="model.root" archInfo="props.archInfo" Compiler="props.Compiler" readonly="true" forceGlobalClick="props.forceGlobalClick" deleteRecord.bind="deleteRecord" openRecord.bind="openRecord" noContentHelp="props.info.noContentHelp" scrollTop.bind="scrollTop" canQuickCreate="canQuickCreate" quickCreateState="quickCreateState" progressBarState="progressBarState"/>
            </Layout>
        </div>
    </t>

    `);
registerTemplate("web.KanbanView.Buttons", `/web/static/src/views/kanban/kanban_controller.xml`, `<t t-name="web.KanbanView.Buttons" xml:space="preserve">
        <div t-if="props.showButtons" class="o_cp_buttons d-empty-none d-flex align-items-baseline gap-1" role="toolbar" aria-label="Main actions"/>
    </t>

`);
registerTemplate("web.KanbanCoverImageDialog", `/web/static/src/views/kanban/kanban_cover_image_dialog.xml`, `<t t-name="web.KanbanCoverImageDialog" xml:space="preserve">
        <Dialog title.translate="Set a Cover Image" size="'lg'">
            <div t-if="attachments.length" class="o_kanban_cover_container bg-100">
                <t t-foreach="attachments" t-as="attachment" t-key="attachment.id">
                    <div class="o_kanban_cover_image position-relative d-inline-block m-2 border bg-white o_cursor_pointer" t-att-class="{                         'o_selected border-primary': state.selectedAttachmentId === attachment.id,                     }">
                        <img t-attf-src="/web/image/{{attachment.id}}?unique=1" class="position-absolute start-0 end-0 top-0 bottom-0 mw-100 mh-100 m-auto" alt="Attachment" t-on-click="() =&gt; this.selectAttachment(attachment, false)" t-on-dblclick="() =&gt; this.selectAttachment(attachment, true)"/>
                    </div>
                </t>
            </div>
            <t t-else="">There is no available image to be set as cover.</t>
            <t t-set-slot="footer" t-slot-scope="dialog">
                <button t-if="attachments.length" class="btn btn-primary" t-on-click="setCover" t-att-disabled="!state.selectedAttachmentId">
                    Select
                </button>
                <FileInput autoOpen="!attachments.length" acceptedFileExtensions="'image/*'" onUpload.bind="onUpload" resModel="props.record.resModel" resId="props.record.resId">
                        <button class="btn btn-primary" t-on-click="uploadImage">
                            Upload and Set
                        </button>
                </FileInput>
                <button t-if="hasCoverImage" class="btn btn-secondary" t-on-click="removeCover">
                    Remove Cover Image
                </button>
                <button class="btn btn-secondary" t-on-click="dialog.close">
                    Discard
                </button>
            </t>
        </Dialog>
    </t>

`);
registerTemplate("web.KanbanHeader", `/web/static/src/views/kanban/kanban_header.xml`, `<t t-name="web.KanbanHeader" xml:space="preserve">
        <div class="o_kanban_header position-sticky top-0 z-1" t-ref="root" t-attf-class="{{ !env.isSmall and group.isFolded ? 'd-print-none pt-2' : 'py-2 pt-print-0' }}">
            <div class="o_kanban_header_title position-relative d-flex lh-lg">
                <div t-if="group.isFolded" class="o_column_title d-flex align-items-center pt-1 fs-4 lh-1 text-nowrap opacity-50 opacity-100-hover flex-grow-1 gap-1" t-on-mouseenter="onTitleMouseEnter" t-on-mouseleave="onTitleMouseLeave">
                    <t t-esc="groupName"/>
                    <span t-if="group.count &gt; 0 and !props.list.model.useSampleModel" t-esc="'(' + group.count + ')'"/>
                </div>
                <div t-if="!group.isFolded" class="o_column_title flex-grow-1 min-w-0 mw-100 gap-1 d-flex fs-4 fw-bold align-top text-900" t-on-mouseenter="onTitleMouseEnter" t-on-mouseleave="onTitleMouseLeave">
                    <span class="text-truncate" t-esc="groupName"/>
                    <span t-if="!progressBar and !props.list.model.useSampleModel" t-esc="'(' + group.count + ')'"/>
                </div>
                <t t-if="env.isSmall or !group.isFolded">
                    <div class="o_kanban_config d-print-none">
                        <Dropdown menuClass="'o-dropdown--kanban-config-menu'" position="'bottom-end'">
                            <button class="btn px-2">
                                <i class="fa fa-gear opacity-50 opacity-100-hover" role="img" aria-label="Settings" title="Settings"/>
                            </button>
                            <t t-set-slot="content">
                                <t t-foreach="configItems" t-as="item" t-key="item.key">
                                    <DropdownItem t-if="item.isVisible" class="item.class" onSelected="() =&gt; this[item.method]()">
                                        <t t-esc="item.label"/>
                                    </DropdownItem>
                                </t>
                            </t>
                        </Dropdown>
                    </div>
                    <button t-if="canQuickCreate()" class="o_kanban_quick_add d-print-none btn pe-2 me-n2" t-on-click="() =&gt; this.quickCreate()">
                        <i class="fa fa-plus opacity-75 opacity-100-hover" role="img" aria-label="Quick add" title="Quick add"/>
                    </button>
                </t>
                <button t-else="" class="o_column_unfold btn d-flex align-items-center justify-content-between flex-nowrap pt-2 pb-3 transition-base">
                    <i class="fa fa-caret-left lh-lg transition-base" role="img" aria-label="Unfold" title="Unfold"/>
                    <i class="fa fa-caret-right lh-lg" role="img" aria-label="Unfold" title="Unfold"/>
                </button>
            </div>
            <div t-if="(env.isSmall or !group.isFolded) and progressBar" class="o_kanban_counter position-relative d-flex align-items-center justify-content-between" t-att-class="{ 'opacity-25': !group.count }">
                <ColumnProgress group="group" progressBar="progressBar" aggregate="groupAggregate" onBarClicked.bind="onBarClicked"/>
            </div>
        </div>
    </t>

    `);
registerTemplate("web.KanbanGroupTooltip", `/web/static/src/views/kanban/kanban_header.xml`, `<t t-name="web.KanbanGroupTooltip" xml:space="preserve">
        <div class="o-tooltip text-prewrap px-2 py-1">
            <t t-foreach="props.tooltip" t-as="entry" t-key="entry_index">
                <t t-esc="entry.title"/>
                <br/>
                <t t-esc="entry.value"/>
                <br t-if="!tooltip_last"/>
            </t>
        </div>
    </t>

`);
registerTemplate("web.KanbanRecord", `/web/static/src/views/kanban/kanban_record.xml`, `<t t-name="web.KanbanRecord" xml:space="preserve">
        <article t-att-class="getRecordClasses()" t-att-data-id="props.record.id" t-att-tabindex="props.record.model.useSampleModel ? -1 : 0" t-on-click="onGlobalClick" t-ref="root">
                <t t-call="{{ this.mainTemplate }}" t-call-context="this.renderingContext"/>
                <t t-call="{{ this.constructor.menuTemplate }}"/>
        </article>
    </t>

    `);
registerTemplate("web.KanbanRecordMenu", `/web/static/src/views/kanban/kanban_record.xml`, `<t t-name="web.KanbanRecordMenu" xml:space="preserve">
        <div t-if="showMenu" class="o_dropdown_kanban bg-transparent position-absolute end-0 top-0 w-auto">
            <Dropdown menuClass="getMenuClasses()" position="'bottom-end'">
                <button class="btn o-no-caret rounded-0" title="Dropdown menu">
                    <span class="fa fa-ellipsis-v"/>
                </button>
                <t t-set-slot="content">
                    <KanbanDropdownMenuWrapper>
                        <t t-call="{{ templates[this.menuTemplateName] }}" t-call-context="renderingContext"/>
                    </KanbanDropdownMenuWrapper>
                </t>
            </Dropdown>
        </div>
    </t>
`);
registerTemplate("web.KanbanRecordQuickCreate", `/web/static/src/views/kanban/kanban_record_quick_create.xml`, `<t t-name="web.KanbanRecordQuickCreate" xml:space="preserve">
        <KanbanQuickCreateController t-if="state.isLoaded" t-props="quickCreateProps"/>
    </t>

    `);
registerTemplate("web.KanbanQuickCreateController", `/web/static/src/views/kanban/kanban_record_quick_create.xml`, `<t t-name="web.KanbanQuickCreateController" xml:space="preserve">
        <div class="o_kanban_quick_create o_field_highlight shadow" t-att-class="{ o_disabled: state.disabled, 'w-100 mx-0': props.listIsGrouped }" t-ref="root">
            <t t-component="props.Renderer" class="'o_form_view o_xxs_form_view o_kanban_quick_create_form p-0'" record="model.root" Compiler="props.Compiler" archInfo="props.archInfo"/>
            <div class="d-flex flex-wrap justify-content-end gap-1">
                <button class="btn btn-primary o_kanban_add me-1" t-on-click="() =&gt; this.validate('add')">
                    Add
                </button>
                <button class="btn btn-secondary o_kanban_edit me-1" t-on-click="() =&gt; this.validate('edit')">
                    Edit
                </button>
                <span class="flex-grow-1"/>
                <button class="btn btn-secondary o_kanban_cancel" t-on-click="() =&gt; this.cancel(true)">
                    <i class="fa fa-trash"/>
                </button>
            </div>
        </div>
    </t>

`);
registerTemplate("web.KanbanRenderer", `/web/static/src/views/kanban/kanban_renderer.xml`, `<t t-name="web.KanbanRenderer" xml:space="preserve">
        <div class="o_kanban_renderer o_renderer d-flex" t-attf-class="{{ props.list.isGrouped ? 'o_kanban_grouped align-content-stretch' : 'o_kanban_ungrouped align-content-start flex-wrap justify-content-start' }}" t-ref="root">
            <t t-foreach="getGroupsOrRecords()" t-as="groupOrRecord" t-key="groupOrRecord.key">
                <t t-if="groupOrRecord.group">
                    <t t-set="group" t-value="groupOrRecord.group"/>
                    <t t-set="isGroupProcessing" t-value="isProcessing(group.id)"/>
                    <div class="o_kanban_group flex-shrink-0 flex-grow-1 flex-md-grow-0" t-att-class="getGroupClasses(group, isGroupProcessing)" t-attf-class="{{ !env.isSmall and group.isFolded ? 'opacity-trigger-hover' : '' }}" t-att-data-id="group.id" t-on-click="(ev) =&gt; this.onGroupClick(group, ev)">
                        <KanbanHeader activeActions="props.archInfo.activeActions" canQuickCreate="props.canQuickCreate" deleteGroup="(group) =&gt; this.deleteGroup(group)" dialogClose="dialogClose" group="group" list="props.list" quickCreateState="props.quickCreateState" scrollTop="props.scrollTop" tooltipInfo="props.archInfo.tooltipInfo" progressBarState="props.progressBarState"/>
                        <t t-if="!group.isFolded">
                            <t t-if="group.id === props.quickCreateState.groupId">
                                <KanbanRecordQuickCreate group="group" onCancel="force =&gt; this.cancelQuickCreate(force)" onValidate="(record, mode) =&gt; this.validateQuickCreate(record, mode, group)" quickCreateView="props.quickCreateState.view"/>
                            </t>
                            <t t-foreach="group.list.records" t-as="record" t-key="record.id">
                                <KanbanRecord archInfo="props.archInfo" Compiler="props.Compiler" canResequence="!isGroupProcessing and !isProcessing(record.id) and canResequenceRecords" forceGlobalClick="props.forceGlobalClick" group="group" list="props.list" deleteRecord="props.deleteRecord" archiveRecord.bind="archiveRecord" openRecord="props.openRecord" readonly="props.readonly" record="record" templates="props.archInfo.templateDocs" progressBarState="props.progressBarState"/>
                            </t>
                            <t t-set="unloadedCount" t-value="getGroupUnloadedCount(group)"/>
                            <div t-if="unloadedCount &gt; 0" class="o_kanban_load_more" t-key="unloadedCount">
                                <button class="btn btn-outline-primary w-100 mt-4" t-on-click="() =&gt; this.loadMore(group)">Load more... (<t t-out="unloadedCount"/> remaining)</button>
                            </div>
                        </t>
                        <t t-elif="env.isSmall">
                            <t t-set="unloadedCount" t-value="getGroupUnloadedCount(group)"/>
                            <div t-if="unloadedCount &gt; 0" class="o_kanban_load_more">
                                <button class="btn btn-outline-primary w-100 mt-4" t-on-click="() =&gt; this.toggleGroup(group)">Load more... (<t t-out="unloadedCount"/> remaining)</button>
                            </div>
                        </t>
                    </div>
                </t>
                <t t-else="">
                    <KanbanRecord archInfo="props.archInfo" Compiler="props.Compiler" canResequence="!isProcessing(groupOrRecord.record.id) and canResequenceRecords" forceGlobalClick="props.forceGlobalClick" list="props.list" deleteRecord="props.deleteRecord" archiveRecord="(record, active) =&gt; this.archiveRecord(record, active)" openRecord="props.openRecord" readonly="props.readonly" record="groupOrRecord.record" templates="props.archInfo.templateDocs"/>
                </t>
            </t>
            <t t-if="props.list.isGrouped">
                <t t-if="canCreateGroup()">
                    <KanbanColumnQuickCreate folded="state.columnQuickCreateIsFolded" onFoldChange="folded =&gt; state.columnQuickCreateIsFolded = folded" onValidate="props.list.createGroup.bind(props.list)" exampleData="exampleData" groupByField="props.list.groupByField"/>

                    <div t-if="props.list.groups.length === 0" class="o_kanban_example_background_container d-flex opacity-50">
                        <div class="o_kanban_example_background flex-grow-1">
                            <div class="o_kanban_examples d-flex p-2">
                                <div t-foreach="ghostColumns" t-as="column" t-key="column.name" class="o_kanban_examples_group flex-grow-1 m-3">
                                    <h6><b t-esc="column.name"/></h6>
                                    <div t-foreach="column.cards" t-as="card" t-key="card_index" class="o_kanban_examples_ghost d-flex flex-wrap justify-content-between mb-3 p-2 border bg-light">
                                        <div class="o_ghost_content w-100 pb-3 bg-300"/>
                                        <div class="o_ghost_content o_ghost_tag d-inline-block w-50 mt-3 pb-3 bg-300"/>
                                        <span class="mt-2 rounded-circle bg-300">
                                            <img class="o_ghost_avatar" src="/base/static/img/avatar.png" alt="Avatar"/>
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </t>
            </t>
            <t t-else="">

                <div t-foreach="[,,,,,,]" t-as="i" t-key="i_index" class="o_kanban_record o_kanban_ghost flex-grow-1 flex-md-shrink-1 flex-shrink-0 my-0"/>
            </t>
            <t t-if="showNoContentHelper">
                <t t-if="props.noContentHelp" t-call="web.ActionHelper">
                    <t t-set="noContentHelp" t-value="props.noContentHelp"/>
                </t>
                <t t-else="" t-call="web.NoContentHelper"/>
            </t>
        </div>
    </t>

    `);
registerTemplate("web.KanbanDropdownMenuWrapper", `/web/static/src/views/kanban/kanban_renderer.xml`, `<t t-name="web.KanbanDropdownMenuWrapper" xml:space="preserve">
        <div t-on-click="onClick" style="display:contents">
            <t t-slot="default"/>
        </div>
    </t>

`);
registerTemplate("web.ExportAll", `/web/static/src/views/list/export_all/export_all.xml`, `<t t-name="web.ExportAll" xml:space="preserve">
        <DropdownItem class="'o_export_all_menu'" onSelected.bind="onDirectExportData">
            <i class="fa fa-fw fa-upload me-1"/>Export All
        </DropdownItem>
    </t>

`);
registerTemplate("web.ListCogMenu", `/web/static/src/views/list/list_cog_menu.xml`, `<t t-name="web.ListCogMenu" t-inherit="web.CogMenu" xml:space="preserve">
        <xpath expr="//t[@t-if='state.printItems.length']" position="before">
            <t t-slot="default"/>
        </xpath>
        <xpath expr="//t[@t-if='state.printItems.length']/Dropdown" position="before">
            <div role="separator" class="dropdown-divider"/>
        </xpath>
    </t>

`);
registerTemplate("web.ListView.ConfirmationModal", `/web/static/src/views/list/list_confirmation_dialog.xml`, `<t t-name="web.ListView.ConfirmationModal" xml:space="preserve">
        <Dialog size="'md'" title="props.title">
            <main role="alert">
                <p>
                    <t t-if="props.isDomainSelected">This update will only consider the records of the current page.<br/><br/></t>
                    <t t-if="props.nbRecords != props.nbValidRecords">
                        Among the <t t-esc="props.nbRecords"/> selected records,
                        <t t-esc="props.nbValidRecords"/> are valid for this update.<br/>
                    </t>
                    Are you sure you want to perform the following update on those <t t-esc="props.nbValidRecords"/> records?
                </p>
                <div class="table-responsive">
                    <table class="o_modal_changes">
                        <tbody>
                            <t t-foreach="props.fields" t-as="field" t-key="field_index">
                                <tr>
                                    <td>Field:</td>
                                    <td><t t-esc="field.label"/></td>
                                </tr>
                                <tr>
                                    <td>Update to:</td>
                                    <td style="pointer-events: none;">
                                        <Field name="field.name" record="props.record" type="field.widget" readonly="true" fieldInfo="field.fieldNode"/>
                                    </td>
                                </tr>
                            </t>
                        </tbody>
                    </table>
                </div>
            </main>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="_confirm" t-ref="autofocus">
                Confirm
                </button>
                <button t-if="props.cancel" class="btn btn-secondary" t-on-click="_cancel">
                Cancel
                </button>
            </t>
        </Dialog>
    </t>

`);
registerTemplate("web.ListView", `/web/static/src/views/list/list_controller.xml`, `<t t-name="web.ListView" xml:space="preserve">
        <div t-att-class="className" t-ref="root">
            <Layout className="model.useSampleModel ? 'o_view_sample_data' : ''" display="display">
                <t t-set-slot="control-panel-create-button">
                    <t t-if="!editedRecord and activeActions.create and props.showButtons">
                        <button type="button" class="btn btn-primary o_list_button_add" data-hotkey="c" t-on-click="onClickCreate" data-bounce-button="">
                            New
                        </button>
                    </t>
                    <t t-if="env.isSmall" t-call="{{ props.buttonTemplate }}"/>
                </t>

                <t t-set-slot="layout-buttons">
                    <t t-if="!env.isSmall" t-call="{{ props.buttonTemplate }}"/>
                </t>
                <t t-set-slot="control-panel-always-buttons">
                    <t t-foreach="archInfo.headerButtons" t-as="button" t-key="button.id" t-if="!evalViewModifier(button.invisible)">
                        <MultiRecordViewButton t-if="button.display === 'always'" list="model.root" className="button.className" clickParams="button.clickParams" defaultRank="'btn-secondary'" domain="props.domain" icon="button.icon" string="button.string" title="button.title" attrs="button.attrs"/>
                    </t>
                </t>

                <t t-set-slot="layout-actions">
                    <SearchBar toggler="searchBarToggler" autofocus="firstLoad"/>
                </t>
                <t t-set-slot="control-panel-navigation-additional">
                    <t t-if="!hasSelectedRecords" t-component="searchBarToggler.component" t-props="searchBarToggler.props"/>
                </t>

                <t t-set-slot="control-panel-additional-actions">
                    <CogMenu t-if="!hasSelectedRecords"/>
                    <CogMenu t-elif="env.isSmall and (props.info.actionMenus or archInfo.headerButtons.length)" t-props="this.actionMenuProps" hasSelectedRecords="hasSelectedRecords">
                        <t t-foreach="archInfo.headerButtons" t-as="button" t-key="button.id" t-if="!evalViewModifier(button.invisible)">
                            <DropdownItem class="'o-dropdown-item-unstyled-button'">
                                <MultiRecordViewButton t-if="button.display !== 'always'" list="model.root" className="button.className" clickParams="button.clickParams" defaultRank="'btn-secondary'" domain="props.domain" icon="button.icon" string="button.string" title="button.title" attrs="button.attrs"/>
                            </DropdownItem>
                        </t>
                    </CogMenu>
                </t>
                <t t-set-slot="control-panel-selection-actions">
                    <div t-if="hasSelectedRecords" class="o_list_selection_container m-1 m-md-0 d-flex gap-1">
                        <t t-call="web.ListView.Selection"/>
                        <t t-if="!env.isSmall">
                            <t t-foreach="archInfo.headerButtons" t-as="button" t-key="button.id" t-if="!evalViewModifier(button.invisible)">
                                <MultiRecordViewButton t-if="button.display !== 'always'" list="model.root" className="button.className" clickParams="button.clickParams" defaultRank="'btn-secondary'" domain="props.domain" icon="button.icon" string="button.string" title="button.title" attrs="button.attrs"/>
                            </t>
                            <t t-if="props.info.actionMenus">
                                <ActionMenus t-props="this.actionMenuProps"/>
                            </t>
                        </t>
                    </div>
                </t>
                <t t-component="props.Renderer" list="model.root" activeActions="activeActions" archInfo="archInfo" allowSelectors="props.allowSelectors" editable="editable" onOpenFormView="onOpenFormView" hasOpenFormViewButton="hasOpenFormViewButton" openRecord.bind="openRecord" noContentHelp="props.info.noContentHelp" onAdd.bind="createRecord" optionalActiveFields="optionalActiveFields"/>
            </Layout>
        </div>
    </t>

    `);
registerTemplate("web.ListView.Buttons", `/web/static/src/views/list/list_controller.xml`, `<t t-name="web.ListView.Buttons" xml:space="preserve">
        <div t-if="props.showButtons" class="o_list_buttons d-flex gap-1 d-empty-none align-items-baseline" role="toolbar" aria-label="Main actions">
            <t t-if="editedRecord">
                <button type="button" class="btn btn-primary o_list_button_save" data-hotkey="s" t-on-click.stop="onClickSave">
                    Save
                </button>
                <button type="button" class="btn btn-secondary o_list_button_discard" data-hotkey="j" t-on-click.stop="onClickDiscard" t-on-mousedown="onMouseDownDiscard">
                    Discard
                </button>
            </t>
        </div>
    </t>

    `);
registerTemplate("web.ListView.Selection", `/web/static/src/views/list/list_controller.xml`, `<t t-name="web.ListView.Selection" xml:space="preserve">
        <div class="o_list_selection_box list-group flex-row w-auto" t-att-class="{'m-1 gap-1': env.isSmall}" role="alert">
            <span class="list-group-item active d-flex align-items-center pe-0 py-0 rounded-1 gap-1 flex-grow-1" t-att-class="{'shadow': env.isSmall}">
                <span t-if="isDomainSelected">All <b t-esc="nbTotal"/> selected</span>
                <t t-else="">
                    <b t-esc="nbSelected"/> selected
                    <button t-if="!env.isSmall and isPageSelected and (!model.root.isRecordCountTrustable or nbTotal &gt; nbSelected)" class="o_list_select_domain btn btn-sm btn-info p-1 ms-2 me-n2 border-0 fw-normal" title="Select all records matching the search" t-on-click="onSelectDomain">
                        <i class="oi oi-fw oi-arrow-right"/>
                        Select all <span t-if="model.root.isRecordCountTrustable" t-esc="nbTotal"/>
                    </button>
                </t>
                <button title="Unselect All" class="o_list_unselect_all btn btn-link ms-auto border-0" t-on-click="onUnselectAll">
                    <i class="oi oi-close"/>
                </button>
            </span>
            <button t-if="env.isSmall and !isDomainSelected and (!model.root.isRecordCountTrustable or nbTotal &gt; nbSelected)" class="o_list_select_domain btn btn-info shadow" title="Select all records matching the search" t-on-click="onSelectDomain">
                All
            </button>
        </div>
    </t>

`);
registerTemplate("web.ListRenderer", `/web/static/src/views/list/list_renderer.xml`, `<t t-name="web.ListRenderer" xml:space="preserve">
        <t t-set="_canSelectRecord" t-value="canSelectRecord"/>
        <div class="o_list_renderer o_renderer table-responsive" tabindex="-1" t-ref="root">
            <t t-if="showNoContentHelper" t-call="web.ActionHelper">
                <t t-set="noContentHelp" t-value="props.noContentHelp"/>
            </t>
            <table t-attf-class="o_list_table table table-sm table-hover position-relative mb-0 {{props.list.isGrouped ? 'o_list_table_grouped' : 'o_list_table_ungrouped table-striped'}}" t-ref="table">
                <thead>
                    <tr>
                        <th t-if="hasSelectors" class="o_list_record_selector o_list_controller align-middle pe-1 cursor-pointer" tabindex="-1" t-on-keydown="(ev) =&gt; this.onCellKeydown(ev)" t-on-click.stop="toggleSelection">
                            <CheckBox disabled="!_canSelectRecord" value="selectAll" className="'d-flex m-0'" onChange.bind="toggleSelection"/>
                        </th>
                        <t t-foreach="columns" t-as="column" t-key="column.id">
                            <th t-if="column.type === 'field'" t-att-data-name="column.name" t-att-class="getColumnClass(column) + ' opacity-trigger-hover w-print-auto'" t-on-pointerup="onColumnTitleMouseUp" t-on-click="() =&gt; this.onClickSortColumn(column)" t-on-keydown="(ev) =&gt; this.onCellKeydown(ev)" data-tooltip-delay="1000" tabindex="-1">
                                <t t-if="column.hasLabel and column.widget !== 'handle'">
                                <t t-set="isNumeric" t-value="isNumericColumn(column)"/>
                                    <div class="d-flex" t-att-data-tooltip-template="isDebugMode ? 'web.FieldTooltip' : 'web.ListHeaderTooltip'" t-att-data-tooltip-info="makeTooltip(column)">
                                        <span class="d-block min-w-0 text-truncate flex-grow-1 flex-shrink-1" t-att-class="isNumeric ? 'o_list_number_th' : ''" t-esc="column.label"/>
                                        <div class="o_list_header_label_spacer"/>
                                        <i class="o_list_sortable_caret" t-att-class="getSortableIconClass(column)"/>
                                    </div>
                                    <span class="o_resize position-absolute top-0 end-0 bottom-0 ps-1 bg-black-25 opacity-0 opacity-50-hover z-1" t-on-pointerdown.stop.prevent="this.columnWidths.onStartResize"/>
                                </t>
                            </th>
                            <th t-else="" t-on-keydown="(ev) =&gt; this.onCellKeydown(ev)" t-att-class="{'o_list_button w-print-0 p-print-0': column.type === 'button_group'}"/>
                        </t>
                        <th t-if="hasOpenFormViewColumn" t-on-keydown="(ev) =&gt; this.onCellKeydown(ev)" class="o_list_open_form_view w-print-0 p-print-0"/>
                        <th t-if="hasActionsColumn" t-on-keydown="(ev) =&gt; this.onCellKeydown(ev)" class="o_list_controller o_list_actions_header w-print-0 p-print-0 position-sticky end-0">
                            <div t-if="displayOptionalFields or hasOptionalOpenFormViewColumn" class="o_optional_columns_dropdown d-print-none text-center border-top-0">
                                <Dropdown position="'bottom-end'">
                                    <button class="btn p-0" tabindex="-1">
                                        <i class="o_optional_columns_dropdown_toggle oi oi-fw oi-settings-adjust"/>
                                    </button>

                                    <t t-set-slot="content">
                                        <t t-foreach="optionalFieldGroups" t-as="group" t-key="group_index">
                                            <div t-if="!group_first" role="separator" class="dropdown-divider"/>
                                            <DropdownItem t-if="group.displayName" closingMode="'none'" onSelected="() =&gt; this.toggleOptionalFieldGroup(group.id)">
                                                <div class="fw-bold" t-esc="group.displayName"/>
                                            </DropdownItem>
                                            <t t-foreach="group.optionalFields" t-as="field" t-key="field_index">
                                                <DropdownItem closingMode="'none'" onSelected="() =&gt; this.toggleOptionalField(field.name)">
                                                    <CheckBox onChange="() =&gt; this.toggleOptionalField(field.name)" value="field.value" name="field.name">
                                                        <span class="d-flex align-items-center"><span class="text-truncate" t-esc="field.label"/><span class="ps-1" t-if="env.debug" t-esc="' (' + field.name + ')'"/></span>
                                                    </CheckBox>
                                                </DropdownItem>
                                            </t>
                                        </t>
                                        <div t-if="hasOptionalOpenFormViewColumn" role="separator" class="dropdown-divider"/>
                                        <DropdownItem t-if="hasOptionalOpenFormViewColumn" closingMode="'none'" onSelected="() =&gt; this.toggleDebugOpenView()">
                                            <CheckBox onChange="() =&gt; this.toggleDebugOpenView()" value="this.debugOpenView" name="'View Button'">
                                                <span class="d-flex align-items-center"><span class="text-truncate">View Button</span></span>
                                            </CheckBox>
                                        </DropdownItem>
                                    </t>
                                </Dropdown>
                            </div>
                        </th>
                    </tr>
                </thead>
                <tbody class="ui-sortable">
                    <t t-call="{{ constructor.rowsTemplate }}">
                        <t t-set="list" t-value="props.list"/>
                    </t>
                </tbody>
                <tfoot t-on-click="() =&gt; props.list.leaveEditMode()" class="o_list_footer cursor-default" t-att-class="{o_sample_data_disabled: props.list.model.useSampleModel}">
                    <tr>
                        <td t-if="hasSelectors"/>
                        <t t-foreach="columns" t-as="column" t-key="column.id">
                            <t t-set="aggregate" t-value="aggregates[column.name]"/>
                            <td t-if="aggregate" class="o_list_number">
                                <span t-esc="aggregate.value" t-att-data-tooltip="aggregate.help"/>
                            </td>
                            <td t-elif="column.type != 'field'" class="w-print-auto"/>
                            <td t-else=""/>
                        </t>
                        <td t-if="hasOpenFormViewColumn" class="w-print-0 p-print-0"/>
                        <td t-if="displayOptionalFields or activeActions.onDelete" class="w-print-0 p-print-0"/>
                    </tr>
                </tfoot>
            </table>
        </div>
    </t>

    `);
registerTemplate("web.ListRenderer.Rows", `/web/static/src/views/list/list_renderer.xml`, `<t t-name="web.ListRenderer.Rows" xml:space="preserve">
        <t t-if="!list.isGrouped">
            <t t-foreach="list.records" t-as="record" t-key="record.id">
                <t t-call="{{ constructor.recordRowTemplate }}"/>
            </t>
            <tr t-if="displayRowCreates">
                <td t-if="withHandleColumn"/>
                <td t-att-colspan="withHandleColumn ? nbCols - 1 : nbCols" class="o_field_x2many_list_row_add" t-on-keydown="(ev) =&gt; this.onCellKeydown(ev, null)">
                    <t t-foreach="creates" t-as="create" t-key="create_index">
                        <a t-if="create.type === 'create'" href="#" role="button" t-att-class="create_index !== 0 ? 'ml16' : ''" t-att-tabindex="editedRecord ? '-1' : '0'" t-on-click.stop.prevent="() =&gt; this.add({ context: create.context })">
                            <t t-esc="create.string"/>
                        </a>
                        <ViewButton t-if="create.type === 'button'" className="\`\${create.className} \${create_index !== 0 ? 'ml16' : ''}\`" clickParams="create.clickParams" icon="create.icon" record="props.list" string="create.string" title="create.title" tabindex="editedRecord ? '-1' : '0'"/>
                    </t>
                </td>
            </tr>
            <t t-if="!props.list.isGrouped and !props.noContentHelp">
                <tr t-foreach="getEmptyRowIds" t-as="emptyRowId" t-key="emptyRowId">
                    <td t-att-colspan="nbCols">​</td>
                </tr>
            </t>
        </t>
        <t t-else="">
            <t t-foreach="list.groups" t-as="group" t-key="group.id">
                <t t-call="{{ constructor.groupRowTemplate }}"/>
                <t t-if="!group.isFolded">
                    <t t-call="{{ constructor.rowsTemplate }}">
                        <t t-set="list" t-value="group.list"/>
                    </t>
                    <tr t-if="!group.list.isGrouped and props.editable and canCreate">
                        <td t-if="hasSelectors"/>
                        <td t-att-colspan="hasSelectors ?  nbCols - 1 : nbCols" class="o_group_field_row_add">
                            <a href="#" role="button" t-on-click.stop.prevent="() =&gt; this.addInGroup(group)" t-on-keydown="(ev) =&gt; this.onCellKeydown(ev)">
                                Add a line
                            </a>
                        </td>
                    </tr>
                </t>
            </t>
        </t>
    </t>

    `);
registerTemplate("web.ListRenderer.GroupRow", `/web/static/src/views/list/list_renderer.xml`, `<t t-name="web.ListRenderer.GroupRow" xml:space="preserve">
        <tr t-attf-class="{{group.count &gt; 0 ? 'o_group_has_content' : ''}} o_group_header {{!group.isFolded ? 'o_group_open' : ''}} cursor-pointer" t-on-click="(ev) =&gt; this.onGroupHeaderClicked(ev, group)">
            <th t-on-keydown="(ev) =&gt; this.onCellKeydown(ev, group)" tabindex="-1" t-attf-class="o_group_name fs-6 fw-bold {{!group.isFolded ? 'text-900' : 'text-700'}}" t-att-colspan="getGroupNameCellColSpan(group)">
                <div class="d-flex align-items-center">
                    <span t-attf-class="o_group_caret fa fa-fw {{group.isFolded ? 'fa-caret-right' : 'fa-caret-down' }} me-1" t-attf-style="--o-list-group-level: {{getGroupLevel(group)}}"/>
                    <t t-esc="getGroupDisplayName(group)"/> (<t t-esc="group.count"/>)
                    <div t-if="(groupByButtons[group.groupByField.name] and !group.isFolded and group.record.resId)" class="o_group_buttons">
                        <t t-foreach="groupByButtons[group.groupByField.name]" t-as="button" t-key="button.id">
                            <t t-if="!evalInvisible(button.invisible, group.record)">
                                <t t-if="button.clickParams.type === 'edit'">
                                    <button t-att-title="button.title" class="btn" t-on-click="() =&gt; this.editGroupRecord(group)" tabindex="-1">
                                        <i t-attf-class="fa fa-fw {{button.icon}} o_button_icon"/>
                                    </button>
                                </t>
                                <t t-else="">
                                    <ViewButton className="button.className" clickParams="button.clickParams" icon="button.icon" record="group.record" string="button.string" title="button.title" tabindex="'-1'"/>
                                </t>
                            </t>
                        </t>
                    </div>
                    <div t-if="showGroupPager(group)" t-on-click.stop="" class="ms-auto">
                        <Pager t-props="getGroupPagerProps(group)"/>
                    </div>
                </div>
            </th>
            <td t-on-keydown="(ev) =&gt; this.onCellKeydown(ev, group)" t-foreach="getAggregateColumns(group)" t-as="column" t-key="column.id" t-att-class="{'o_list_number': column.type === 'field'}">
                <t t-if="column.type === 'field'" t-esc="formatAggregateValue(group, column)"/>
            </td>
            <t t-set="groupPagerColspan" t-value="getGroupPagerCellColspan(group)"/>
            <th t-on-keydown="(ev) =&gt; this.onCellKeydown(ev, group)" t-if="groupPagerColspan &gt; 0" t-att-colspan="groupPagerColspan"/>
        </tr>
    </t>

    `);
registerTemplate("web.ListRenderer.RecordRow", `/web/static/src/views/list/list_renderer.xml`, `<t t-name="web.ListRenderer.RecordRow" xml:space="preserve">
        <tr class="o_data_row" t-att-class="getRowClass(record)" t-att-data-id="record.id" t-on-click.capture="(ev) =&gt; this.onClickCapture(record, ev)" t-on-mouseover.capture="(ev) =&gt; this.ignoreEventInSelectionMode(ev)" t-on-mouseout.capture="(ev) =&gt; this.ignoreEventInSelectionMode(ev)" t-on-mouseenter.capture="(ev) =&gt; this.ignoreEventInSelectionMode(ev)" t-on-touchstart="(ev) =&gt; this.onRowTouchStart(record, ev)" t-on-touchend="() =&gt; this.onRowTouchEnd(record)" t-on-touchmove="() =&gt; this.onRowTouchMove(record)">
            <td t-on-keydown="(ev) =&gt; this.onCellKeydown(ev, group, record)" t-if="hasSelectors" class="o_list_record_selector user-select-none" t-on-click.stop="() =&gt; this.toggleRecordSelection(record)" tabindex="-1">
                <CheckBox disabled="!_canSelectRecord" value="record.selected" onChange.alike="() =&gt; this.toggleRecordSelection(record)"/>
            </td>
            <t t-foreach="getColumns(record)" t-as="column" t-key="column.id">
                <t t-if="column.type === 'field'">
                    <t t-set="isInvisible" t-value="evalInvisible(column.invisible, record) or !(column.name in record.data)"/>
                    <td t-on-keydown="(ev) =&gt; this.onCellKeydown(ev, group, record)" class="o_data_cell cursor-pointer" t-att-class="this.getCellClass(column, record)" t-att-name="column.name" t-att-colspan="column.colspan" t-att-data-tooltip="!isInvisible ? getCellTitle(column, record) : false" data-tooltip-delay="1000" t-on-click="(ev) =&gt; this.onCellClicked(record, column, ev)" tabindex="-1">
                        <t t-if="!isInvisible">
                            <t t-if="canUseFormatter(column, record)" t-out="getFormattedValue(column, record)"/>
                            <Field t-else="" name="column.name" record="record" type="column.widget" class="getFieldClass(column)" fieldInfo="column" t-props="getFieldProps(record, column)"/>
                        </t>
                    </td>
                </t>
                <t t-if="column.type === 'button_group'">
                    <td t-on-keydown="(ev) =&gt; this.onCellKeydown(ev, group, record)" class="o_data_cell w-print-0 p-print-0 cursor-pointer" t-att-class="this.getCellClass(column, record)" t-on-click="(ev) =&gt; this.onButtonCellClicked(record, column, ev)" tabindex="-1">
                        <div class="d-flex flex-wrap gap-1">
                            <t t-foreach="column.buttons" t-as="button" t-key="button.id">
                                <ViewButton t-if="!evalInvisible(button.invisible, record)" className="button.className" clickParams="button.clickParams" defaultRank="button.defaultRank" disabled="button.disabled" icon="button.icon" record="record" string="button.string" title="button.title" tabindex="editedRecord ? '-1' : '0'" onClick="isX2Many and record.isNew ? displaySaveNotification.bind(this) : ''"/>
                            </t>
                        </div>
                    </td>
                </t>
                <t t-if="column.type === 'widget'">
                    <td class="o_data_cell" t-att-class="this.getCellClass(column, record)">
                        <Widget t-props="column.props" record="record"/>
                    </td>
                </t>
            </t>

            <t t-if="hasOpenFormViewColumn">
                <td class="o_list_record_open_form_view w-print-0 p-print-0 text-center" t-on-keydown="(ev) =&gt; this.onCellKeydown(ev, group, record)" t-on-click.stop="() =&gt; isX2Many and record.isNew ? this.displaySaveNotification() : props.onOpenFormView(record, true)" tabindex="-1">
                    <button class="btn btn-link align-top text-end" name="Open in form view" aria-label="Open in form view" tabindex="-1">View</button>
                </td>
            </t>

            <t t-set="useUnlink" t-value="'unlink' in activeActions"/>
            <t t-set="hasX2ManyAction" t-value="isX2Many and (useUnlink ? activeActions.unlink : activeActions.delete)"/>
            <t t-if="displayOptionalFields or hasX2ManyAction">
                <t t-if="hasX2ManyAction">
                    <td class="o_list_record_remove w-print-0 p-print-0 text-center" t-on-keydown="(ev) =&gt; this.onCellKeydown(ev, group, record)" t-on-click.stop="(ev) =&gt; this.onRemoveCellClicked(record, ev)" tabindex="-1">
                        <button class="fa d-print-none" t-att-class="{                                 'fa-trash-o': !useUnlink and activeActions.delete,                                 'fa-times': useUnlink and activeActions.unlink,                             }" name="delete" aria-label="Delete row" tabindex="-1"/>
                    </td>
                </t>
                <td t-else="" tabindex="-1" class="w-print-0 p-print-0"/>
            </t>
        </tr>
    </t>

    `);
registerTemplate("web.ListHeaderTooltip", `/web/static/src/views/list/list_renderer.xml`, `<t t-name="web.ListHeaderTooltip" xml:space="preserve">
        <t t-esc="field.label"/>
        <div t-if="field.help" class="mt-2" t-esc="field.help"/>
    </t>

`);
registerTemplateExtension("web.ListRenderer", `/web_enterprise/static/src/views/list/list_renderer_desktop.xml`, `<t t-inherit="web.ListRenderer" t-inherit-mode="extension" xml:space="preserve">
    <xpath expr="//Dropdown/t[@t-set-slot='content']" position="inside">
        <t t-if="this.isStudioEditable ? this.isStudioEditable() : false">
            <div t-if="hasOptionalFields" class="dropdown-divider"/>
            <DropdownItem closingMode="'none'" onSelected="() =&gt; this.onSelectedAddCustomField()" class="'dropdown-item-studio'">
                <i class="fa fa-plus fa-fw me-2"/>
                <span>Add Custom Field</span>
            </DropdownItem>
        </t>
    </xpath>
</t>

`);
registerTemplate("web.ActionHelper", `/web/static/src/views/no_content_helpers.xml`, `<t t-name="web.ActionHelper" xml:space="preserve">
        <div class="o_view_nocontent">
            <div class="o_nocontent_help">
                <t t-out="noContentHelp"/>
            </div>
        </div>
    </t>

    `);
registerTemplate("web.NoContentHelper", `/web/static/src/views/no_content_helpers.xml`, `<t t-name="web.NoContentHelper" xml:space="preserve">
        <div class="o_view_nocontent" role="alert">
            <div class="o_nocontent_help">
                <p class="o_view_nocontent_empty_folder">
                    <t t-if="title" t-esc="title"/>
                    <t t-else="">No data to display</t>
                </p>
                <p>
                <t t-if="description" t-esc="description"/>
                <t t-else="">Try to add some records, or make sure that there is no
                    active filter in the search bar.</t>
                </p>
            </div>
        </div>
    </t>

`);
registerTemplate("web.View", `/web/static/src/views/view.xml`, `<t t-name="web.View" xml:space="preserve">
      <WithSearch t-props="withSearchProps" t-slot-scope="search">
        <t t-component="Controller" t-on-click="handleActionLinks" t-props="componentProps" context="search.context" domain="search.domain" groupBy="search.groupBy" orderBy="search.orderBy" comparison="search.comparison" display="search.display"/>
      </WithSearch>
  </t>

`);
registerTemplate("web.views.ViewButton", `/web/static/src/views/view_button/view_button.xml`, `<t t-name="web.views.ViewButton" xml:space="preserve">
    <t t-tag="props.tag" t-att="props.attrs" t-att-id="props.id" t-att-class="getClassName()" t-att-disabled="disabled" t-att-name="props.clickParams.name" t-att-special="props.clickParams.special" t-att-href="props.tag === 'a' and '#'" t-att-style="props.style" t-att-type="clickParams.type" t-att-data-tooltip-template="hasBigTooltip ? 'views.ViewButtonTooltip' : false" t-att-data-tooltip-info="hasBigTooltip ? tooltip : false" t-att-data-tooltip="hasSmallToolTip ? props.title : false" t-att-tabindex="props.tabindex" t-on-click.stop="onClick">
      <t t-if="icon" t-tag="icon.tag" t-att-class="icon.class + (props.string ? ' me-1' : '')" t-att-src="icon.src"/>
      <t t-slot="contents"><span t-if="props.string" t-esc="props.string"/></t>
    </t>
  </t>

  `);
registerTemplate("views.ViewButtonTooltip", `/web/static/src/views/view_button/view_button.xml`, `<t t-name="views.ViewButtonTooltip" xml:space="preserve">
      <t t-if="debug || button.help">
        <div class="o-tooltip--string" t-if="debug || button.string" role="tooltip">
            <t t-if="debug">
                Button
                <t t-if="button.string">: </t>
                <t t-if="!button.string"> (no string)</t>
            </t>
            <t t-esc="button.string"/>
        </div>
        <p t-if="button.title" class="o-tooltip--help" role="tooltip">
            <t t-esc="button.title"/>
        </p>
        <p t-if="button.help" class="o-tooltip--help" role="tooltip">
            <t t-esc="button.help"/>
        </p>
        <ul t-if="debug" class="o-tooltip--technical" role="tooltip">
            <li data-item="object">
                <span class="o-tooltip--technical--title">Object:</span>
                <t t-esc="model"/>
            </li>
            <li t-if="button.context" data-item="context">
                <span class="o-tooltip--technical--title">Context:</span>
                <t t-esc="button.context || context"/>
            </li>
            <li t-if="'invisible' in button" data-item="invisible">
                <span class="o-tooltip--technical--title">Invisible:</span>
                <t t-esc="button.invisible"/>
            </li>
            <li t-if="'column_invisible' in button" data-item="column_invisible">
                <span class="o-tooltip--technical--title">Column invisible:</span>
                <t t-esc="button.column_invisible"/>
            </li>
            <li t-if="'required' in button" data-item="required">
                <span class="o-tooltip--technical--title">Required:</span>
                <t t-esc="button.required"/>
            </li>
            <li t-if="'readonly' in button" data-item="readonly">
                <span class="o-tooltip--technical--title">Readonly:</span>
                <t t-esc="button.readonly"/>
            </li>
            <li t-if="button.special" data-item="special">
                <span class="o-tooltip--technical--title">Special:</span>
                <t t-esc="button.special"/>
            </li>
            <t t-set="button_type" t-value="button.type"/>
            <li t-if="button_type" data-item="button_type">
                <span class="o-tooltip--technical--title">Button Type:</span>
                <t t-esc="button_type"/>
            </li>
            <li t-if="button_type === 'object'" data-item="button_method">
                <span class="o-tooltip--technical--title">Method:</span>
                <t t-esc="button.name"/>
            </li>
            <li t-if="button_type === 'action'" data-item="button_action">
                <span class="o-tooltip--technical--title">Action ID:</span>
                <t t-esc="button.name"/>
            </li>
        </ul>
      </t>
  </t>
`);
registerTemplate("web.AnimatedNumber", `/web/static/src/views/view_components/animated_number.xml`, `<t t-name="web.AnimatedNumber" xml:space="preserve">
        <div class="o_animated_number ms-2 text-900 text-nowrap cursor-default" t-att-class="state.value !== props.value and props.animationClass" t-att-title="props.title">
            <t t-slot="prefix"/>
            <span t-if="props.currency and props.currency.position === 'before'" t-esc="props.currency.symbol" class="ms-1"/>
            <b t-esc="format(state.value)"/>
            <span t-if="props.currency and props.currency.position === 'after'" t-esc="props.currency.symbol" class="ms-1"/>
        </div>
    </t>

`);
registerTemplate("web.ColumnProgress", `/web/static/src/views/view_components/column_progress.xml`, `<t t-name="web.ColumnProgress" xml:space="preserve">
        <div class="o_column_progress progress bg-300 w-75">
            <t t-set="maxWidth" t-value="100 - Math.max(0, props.progressBar.bars.filter(x =&gt; x.count &gt; 0).length - 1) * 5"/>
            <t t-foreach="props.progressBar.bars" t-as="bar" t-key="bar.value">
                <t t-set="progressWidth" t-value="Math.max(5, bar.count / (props.group.count or 1) * 100)"/>
                <div t-if="bar.count &gt; 0" role="progressbar" class="progress-bar o_bar_has_records cursor-pointer" t-att-class="{ 'progress-bar-animated progress-bar-striped': props.progressBar.activeBar === bar.value, 'border border-white': !props.group.isFolded and props.progressBar.activeBar }" t-attf-class="bg-{{ bar.color }}" t-attf-style="width: {{ Math.min(progressWidth, maxWidth) }}%;" aria-valuemin="0" t-att-aria-valuemax="props.group.count" t-att-aria-valuenow="bar.count" aria-label="Progress bar" t-attf-data-tooltip="{{ bar.count }} {{ bar.string }}" data-tooltip-delay="0" t-on-click="() =&gt; this.onBarClick(bar)"/>
            </t>
        </div>
        <AnimatedNumber value="props.aggregate.value" title="props.aggregate.title" duration="1000" currency="props.aggregate.currency" animationClass="props.aggregate.value &gt; 999 ? 'o_animated_grow' : 'o_animated_grow_huge'"/>
    </t>

`);
registerTemplate("web.ReportViewMeasures", `/web/static/src/views/view_components/report_view_measures.xml`, `<t t-name="web.ReportViewMeasures" xml:space="preserve">
      <Dropdown>
        <button class="btn btn-primary">
          Measures <i class="fa fa-caret-down ms-1"/>
        </button>
        <t t-set-slot="content">
          <t t-foreach="props.measures" t-as="measure" t-key="measure_value.name">
            <div t-if="!measure_first and measure == '__count'" role="separator" class="dropdown-divider"/>
            <DropdownItem class="{ o_menu_item: true, selected: this.props.activeMeasures.includes(measure) }" closingMode="'none'" t-esc="props.measures[measure].string" onSelected="() =&gt; this.props.onMeasureSelected({ measure: measure_value.name })"/>
          </t>
        </t>
      </Dropdown>
    </t>

`);
registerTemplate("web.ViewScaleSelector", `/web/static/src/views/view_components/view_scale_selector.xml`, `<t t-name="web.ViewScaleSelector" xml:space="preserve">
        <div t-if="Object.keys(props.scales).length &gt; 1" t-att-class="\`btn-group o_view_scale_selector \${props.dropdownClass || ''}\`">
            <Dropdown>
                <button class="btn btn-secondary scale_button_selection o-dropdown-caret" data-hotkey="v">
                    <t t-esc="props.scales[props.currentScale].description"/>
                </button>
                <t t-set-slot="content">
                    <t t-foreach="scales" t-as="scale" t-key="scale.key">
                        <DropdownItem class="\`o_scale_button_\${scale.key} \${scale.key === props.currentScale ? 'active' : ''}\`" onSelected="() =&gt; this.props.setScale(scale.key)" attrs="{ 'data-hotkey': scale.hotkey or scale.key[0] }">
                            <t t-esc="scale.description"/>
                        </DropdownItem>
                    </t>
                    <div t-if="this.props.isWeekendVisible !== undefined" class="dropdown-divider" role="separator"/>
                    <DropdownItem t-if="this.props.isWeekendVisible !== undefined" class="\`o_show_weekends \${props.isWeekendVisible ? 'active' : ''} \${props.currentScale === 'day' ? 'disabled' : ''}\`" onSelected="props.toggleWeekendVisibility">
                        Show weekends
                    </DropdownItem>
                </t>
            </Dropdown>
        </div>
    </t>

`);
registerTemplate("web.DeleteExportListDialog", `/web/static/src/views/view_dialogs/export_data_dialog.xml`, `<t t-name="web.DeleteExportListDialog" xml:space="preserve">
        <Dialog title.translate="Confirmation" size="'md'">
            <div t-esc="props.text"/>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="onDelete">Delete</button>
                <button class="btn btn-secondary" t-on-click="() =&gt; props.close()">Cancel</button>
            </t>
        </Dialog>
    </t>

    `);
registerTemplate("web.ExportDataItem", `/web/static/src/views/view_dialogs/export_data_dialog.xml`, `<t t-name="web.ExportDataItem" xml:space="preserve">
        <div t-att-data-field_id="props.field.id" t-attf-class="o_export_tree_item cursor-pointer position-relative ps-4 {{ state.subfields.length ? 'o_expanded mb-2' : '' }} {{ props.field.parent ? '' : 'pe-3'}}" role="treeitem" t-on-click.stop="() =&gt; this.toggleItem(props.field.id, true)" t-on-dblclick="() =&gt; this.onDoubleClick(props.field.id)">
            <div t-attf-class="o_tree_column d-flex align-items-center {{ props.field.required ? 'fw-bolder' : ''}}">
                <span t-if="props.isFieldExpandable(props.field.id)" t-attf-class="ms-n3 float-start o_expand_parent small oi {{ state.subfields.length ? 'oi-chevron-down' : 'oi-chevron-right' }}" role="img" aria-label="Show sub-fields" title="Show sub-fields"/>
                <span t-if="props.isDebug and props.field.id" class="overflow-hidden w-100" t-esc="\`\${props.field.string} (\${props.field.id})\`"/>
                <span t-else="" class="overflow-hidden w-100" t-esc="props.field.string"/>
                <span title="Select field" t-attf-class="fa fa-plus float-end m-1 o_add_field {{ isFieldSelected(props.field.id) ? 'o_inactive opacity-25' : '' }}" t-on-click.stop="(ev) =&gt; !this.isFieldSelected(this.props.field.id) and this.props.onAdd(this.props.field.id)"/>
            </div>
                <t t-foreach="state.subfields" t-as="field" t-key="field.id">
                    <ExportDataItem t-props="props" field="field"/>
                </t>
        </div>
    </t>

    `);
registerTemplate("web.ExportDataDialog", `/web/static/src/views/view_dialogs/export_data_dialog.xml`, `<t t-name="web.ExportDataDialog" xml:space="preserve">
        <Dialog contentClass="'o_export_data_dialog'" title.translate="Export Data" size="'lg'">
            <div class="row w-100">
                <div class="o_left_panel col-12 col-md-6 h-100 d-flex flex-column flex-nowrap">
                    <div class="o_import_compat">
                        <CheckBox className="'o_import_compat'" id="'o-update-data'" value="state.isCompatible" onChange.bind="onToggleCompatibleExport">
                            I want to update data (import-compatible export)
                        </CheckBox>
                    </div>
                    <h4 class="mt-3">Available fields</h4>
                    <input t-ref="search" type="search" class="form-control mb-3 o_export_search_input" id="o-export-search-filter" placeholder="Search" t-on-input="onSearch"/>
                    <div class="o_left_field_panel h-100 overflow-auto border">
                        <div class="o_field_tree_structure">
                            <t t-if="fieldsAvailable">
                                <t t-foreach="rootFields" t-as="field" t-key="field.id + '_' + state.search.length + '_' + state.isCompatible">
                                    <ExportDataItem exportList="state.exportList" field="field" filterSubfields.bind="filterSubfields" isFieldExpandable.bind="isFieldExpandable" isDebug="isDebug" isExpanded="state.search.length &gt; 0" loadFields.bind="loadFields" onAdd.bind="onAddItemExportList"/>
                                </t>
                            </t>
                            <h3 t-else="" class="text-center text-muted mt-5 o_no_match">No match found.</h3>
                        </div>
                    </div>
                </div>
                <div t-attf-class="o_right_panel col-12 col-md-6 {{ state.isSmall ? 'h-50' : 'h-100' }} d-flex flex-column flex-nowrap mt-3 mt-md-0">
                    <div class="o_export_format">
                        <strong>Export Format:</strong>
                        <t t-foreach="availableFormats" t-as="format" t-key="format.tag">
                            <div class="radio form-check-inline ps-5">
                                <input t-att-id="'o_radio' + format.tag" type="radio" t-att-checked="format.tag === availableFormats[state.selectedFormat].tag" name="o_export_format_name" t-att-value="format.tag" class="form-check-input" t-on-change="setFormat"/>
                                <label class="form-check-label ms-1" t-att-for="'o_radio' + format.tag" t-esc="format.label"/>
                            </div>
                        </t>
                    </div>
                    <div class="mt-3">
                        <h4>Fields to export</h4>
                    </div>
                    <div class="o_exported_lists">
                        <div class="input-group mb-3">
                            <t t-if="state.templateId === 'new_template'">
                                <label class="pt-2 mb-0 fw-bold">Save as: </label>
                                <input t-ref="exportList" class="form-control ms-4 o_save_list_name" t-att-placeholder="newTemplateText"/>
                            </t>
                            <t t-else="">
                                <label class="pt-2 mb-0 fw-bold">Template: </label>
                                <select class="form-select ms-4 o_exported_lists_select" t-on-change="onChangeExportList">
                                    <option/>
                                    <t t-foreach="templates" t-as="template" t-key="template.id">
                                        <option t-att-value="template.id" t-esc="template.name or 'undefined'" t-att-selected="state.templateId === template.id"/>
                                    </t>
                                    <option class="fst-italic" value="new_template">New template </option>
                                </select>
                            </t>
                            <t t-if="state.isEditingTemplate">
                                <button t-if="state.templateId === 'new_template'" type="button" class="btn btn-secondary ms-1 o_save_list_btn" t-on-click.stop="onSaveExportTemplate">
                                    <i class="fa fa-floppy-o"/>
                                </button>
                                <button type="button" class="btn btn-secondary ms-1 o_cancel_list_btn" t-on-click.stop="onCancelExportTemplate">
                                    <i t-attf-class="fa {{ state.templateId === 'new_template' ? 'fa-times' : 'fa-undo' }}"/>
                                </button>
                            </t>
                            <t t-else="">
                                <button t-if="state.templateId" type="button" class="btn btn-secondary ms-1 o_delete_exported_list" t-on-click.stop="onDeleteExportTemplate">
                                    <i class="fa fa-trash"/>
                                </button>
                            </t>
                        </div>
                    </div>
                    <div class="o_right_field_panel h-100 px-2 overflow-auto border">
                        <ul class="o_fields_list list-unstyled" t-ref="draggable">
                            <t t-foreach="state.exportList" t-as="field" t-key="field.id">
                                <li t-attf-class="o_export_field d-inline-block w-100 {{ state.isSmall ? '' : 'o_export_field_sortable' }}" t-att-data-field_id="field.id">
                                    <span t-if="!state.isSmall" class="fa fa-sort o_sort_field mx-1" t-attf-style="opacity:{{ state.exportList.length === 1 ? 0 : 1 }}"/>
                                    <span t-esc="isDebug and field.id ? \`\${field.string} (\${field.id})\` : field.string"/>
                                    <span class="fa fa-trash m-1 pe-2 float-end o_remove_field cursor-pointer" t-att-title="removeFieldText" t-on-click.stop="() =&gt; this.onRemoveItemExportList(field.id)"/>
                                </li>
                            </t>
                        </ul>
                    </div>
                </div>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary o_select_button" data-hotkey="v" t-on-click.stop="onClickExportButton" t-att-disabled="state.disabled">Export</button>
                <button class="btn o_form_button_cancel" t-att-class="(props.disableMultipleSelection &amp;&amp; props.noCreate) ? 'btn-primary' : 'btn-secondary'" data-hotkey="z" t-on-click.stop="props.close">Close</button>
            </t>
        </Dialog>
    </t>

`);
registerTemplate("web.FormViewDialog", `/web/static/src/views/view_dialogs/form_view_dialog.xml`, `<t t-name="web.FormViewDialog" xml:space="preserve">
    <Dialog size="props.size" title="props.title" withBodyPadding="false" modalRef="modalRef" onExpand.bind="onExpand">
      <View t-props="viewProps"/>
      <t t-set-slot="footer">
        <t t-if="props.preventEdit and props.preventCreate">
          <button class="btn btn-primary" t-on-click="() =&gt; props.close()">Close</button>
        </t>
        <t t-else="">
          <button class="btn btn-primary o-default-button" t-on-click="() =&gt; props.close()">Ok</button>
        </t>
      </t>
    </Dialog>
  </t>

  `);
registerTemplate("web.FormViewDialog.ToMany.buttons", `/web/static/src/views/view_dialogs/form_view_dialog.xml`, `<t t-name="web.FormViewDialog.ToMany.buttons" t-inherit="web.FormView.Buttons" xml:space="preserve">
    <xpath expr="//button[contains(@class, 'o_form_button_save')]" position="replace">
      <button class="btn btn-primary o_form_button_save" t-on-click="saveButtonClicked" data-hotkey="c">Save &amp; Close</button>
      <button class="btn btn-primary o_form_button_save_new" t-on-click="() =&gt; this.saveButtonClicked({saveAndNew: true})" data-hotkey="n">Save &amp; New</button>
    </xpath>
  </t>

  `);
registerTemplate("web.FormViewDialog.ToOne.buttons", `/web/static/src/views/view_dialogs/form_view_dialog.xml`, `<t t-name="web.FormViewDialog.ToOne.buttons" t-inherit="web.FormView.Buttons" xml:space="preserve">
    <xpath expr="//button[contains(@class, 'o_form_button_save')]" position="replace">
      <button class="btn btn-primary o_form_button_save" t-on-click="saveButtonClicked" data-hotkey="c">Save &amp; Close</button>
    </xpath>
  </t>

`);
registerTemplate("web.SelectCreateDialog", `/web/static/src/views/view_dialogs/select_create_dialog.xml`, `<t t-name="web.SelectCreateDialog" xml:space="preserve">
        <Dialog title="props.title" withBodyPadding="false">
            <t t-set-slot="header" t-slot-scope="scope">
                <t t-call="web.Dialog.header">
                    <t t-set="dismiss" t-value="scope.close"/>
                    <t t-set="fullscreen" t-value="scope.isFullscreen"/>
                </t>
                <button t-if="this.canUnselect" class="btn o_clear_button" t-on-click="() =&gt; this.unselect()">Clear</button>
            </t>
            <View t-props="viewProps"/>
            <t t-set-slot="footer">
                <t t-if="props.multiSelect">
                    <button class="btn btn-primary o_select_button" t-att-disabled="state.resIds.length === 0" data-hotkey="v" t-on-click="() =&gt; this.select(state.resIds)">
                        Select
                    </button>
                </t>
                <t t-if="!props.noCreate">
                    <button class="btn btn-primary o_create_button" data-hotkey="c" t-on-click="createEditRecord">New</button>
                </t>
                <button class="btn o_form_button_cancel" t-att-class="(!props.multiSelect &amp;&amp; props.noCreate) ? 'btn-primary' : 'btn-secondary'" data-hotkey="z" t-on-click="() =&gt; this.props.close()">Close</button>
            </t>
        </Dialog>
    </t>

    `);
registerTemplate("web.SelectCreateDialog.DefaultNoContentHelp", `/web/static/src/views/view_dialogs/select_create_dialog.xml`, `<t t-name="web.SelectCreateDialog.DefaultNoContentHelp" xml:space="preserve">
        <p>No record found</p>
        <p>Adjust your filters or create a new record.</p>
    </t>

`);
registerTemplate("web.AttachDocument", `/web/static/src/views/widgets/attach_document/attach_document.xml`, `<t t-name="web.AttachDocument" xml:space="preserve">
        <button t-attf-class="btn o_attachment_button #{props.highlight ? 'btn-primary' : 'btn-secondary'}" t-on-click="() =&gt; this.triggerUpload()">
            <span class="o_attach_document" t-esc="props.string"/>
        </button>
    </t>

`);
registerTemplate("web.DocumentationLink", `/web/static/src/views/widgets/documentation_link/documentation_link.xml`, `<t t-name="web.DocumentationLink" xml:space="preserve">
        <a t-att-href="url" title="Documentation" t-att-class="classes" target="_blank">
            <t t-if="!props.icon and !props.label">
                <i class="fa fa-external-link" aria-hidden="true"/>
                <span>View Documentation</span>
            </t>
            <t t-else="">
                <i t-if="props.icon" t-att-class="'fa ' + props.icon"/>
                <span t-esc="props.label"/>
            </t>
        </a>
    </t>
`);
registerTemplate("web.NotificationAlert", `/web/static/src/views/widgets/notification_alert/notification_alert.xml`, `<t t-name="web.NotificationAlert" xml:space="preserve">
        <div t-if="isNotificationBlocked" class="alert alert-primary text-center">
            Odoo Push notifications have been blocked. Go to your browser settings to allow them.
        </div>
    </t>
`);
registerTemplate("web.Ribbon", `/web/static/src/views/widgets/ribbon/ribbon.xml`, `<t t-name="web.Ribbon" xml:space="preserve">
        <div class="ribbon ribbon-top-right">
            <span t-att-class="classes" t-att-title="props.title">
                <t t-esc="props.text"/>
            </span>
        </div>
    </t>

`);
registerTemplate("web.SignatureWidget", `/web/static/src/views/widgets/signature/signature.xml`, `<t t-name="web.SignatureWidget" xml:space="preserve">
        <button t-attf-class="btn o_sign_button #{props.highlight ? 'btn-primary' : 'btn-secondary'}" t-on-click="onClickSignature">
            <span class="o_sign_label" t-esc="props.string"/>
        </button>
    </t>

`);
registerTemplate("web.WeekDays", `/web/static/src/views/widgets/week_days/week_days.xml`, `<t t-name="web.WeekDays" xml:space="preserve">
        <div class="o_recurrent_weekdays border mt-2 mb-2">
            <table class="table table-responsive mb-0">
                <tr>
                    <t t-foreach="weekdays" t-as="day" t-key="day">
                        <th class="text-center border fw-bold">
                            <div class="o_recurrent_weekday_label" t-att-data-tooltip="props.record.fields[day].string">
                                <t t-esc="props.record.fields[day].string"/>
                            </div>
                        </th>
                    </t>
                </tr>
                <tr>
                    <t t-foreach="weekdays" t-as="day" t-key="day">
                        <td>
                            <CheckBox disabled="props.readonly" value="data[day]" className="'o_recurrent_weekday_checkbox text-center'" onChange="(checked) =&gt; this.onChange(day, checked)"/>
                        </td>
                    </t>
                </tr>
            </table>
        </div>
    </t>

`);
registerTemplate("web.ActionDialog.header", `/web/static/src/webclient/actions/action_dialog.xml`, `<t t-name="web.ActionDialog.header" t-inherit="web.Dialog.header" t-inherit-mode="primary" xml:space="preserve">
    <xpath expr="//h4[contains(concat(' ',normalize-space(@class),' '),' modal-title ')]" position="before">
      <DebugMenu t-if="env.debug"/>
    </xpath>
  </t>
  `);
registerTemplate("web.ActionDialog", `/web/static/src/webclient/actions/action_dialog.xml`, `<t t-name="web.ActionDialog" t-inherit="web.Dialog" t-inherit-mode="primary" xml:space="preserve">
    <xpath expr="//main[hasclass('modal-body')]" position="attributes">
      <attribute name="t-att-class">
        {"o_act_window": props.actionType === "ir.actions.act_window"}
      </attribute>
    </xpath>
    <xpath expr="//t[@t-slot='default']" position="replace">
      <t t-if="props.ActionComponent" t-component="props.ActionComponent" t-props="props.actionProps"/>
    </xpath>
    <xpath expr="//t[@t-slot='header']" position="replace">
      <t t-call="web.ActionDialog.header">
        <t t-set="fullscreen" t-value="props.isFullscreen"/>
      </t>
    </xpath>
  </t>

`);
registerTemplate("web.ActionInstallKioskPWA", `/web/static/src/webclient/actions/action_install_kiosk_pwa.xml`, `<t t-name="web.ActionInstallKioskPWA" xml:space="preserve">
        <div class="text-center my-3">
            <div class="fs-2 mb-2">From your Kiosk, open this URL:</div>
            <i class="fa fa-share-square-o me-1 mb-3"/><a t-att-href="url" target="_blank" t-esc="url"/>
        </div>
        <footer class="border-top d-flex p-3 justify-content-center justify-content-md-end flex-wrap gap-1 w-100">
            <button class="btn btn-secondary" special="cancel" t-on-click="() =&gt; this.dialog.closeAll()">Close</button>
            <a class="btn btn-primary" t-att-href="installURL" target="_blank">Install App</a>
        </footer>
    </t>

`);
registerTemplate("web.BurgerMenu", `/web/static/src/webclient/burger_menu/burger_menu.xml`, `<div t-name="web.BurgerMenu" class="d-flex" xml:space="preserve">
    <button class="o_mobile_menu_toggle o_nav_entry o-no-caret d-md-none border-0 pe-3" title="Toggle menu" aria-label="Toggle menu" t-on-click="_openBurger">
        <img class="o_burger_menu_avatar o_image_24_cover rounded" t-att-src="'/web/image?model=res.users&amp;field=avatar_128&amp;id=' + user.userId" alt="Menu"/>
    </button>

    <t t-portal="'body'">
      <Transition name="'o-burger-slide'" visible="state.isBurgerOpened" leaveDuration="200" t-slot-scope="transition">
        <div class="o_burger_menu position-fixed top-0 bottom-0 start-100 d-flex flex-column flex-nowrap" t-att-class="transition.className" t-on-touchstart.stop="_onSwipeStart" t-on-touchend.stop="_onSwipeEnd">
          <div class="o_sidebar_topbar d-flex align-items-center justify-content-between flex-shrink-0 py-0 fs-4">
              <small class="d-flex align-items-center justify-content-between ms-2">
                  <img class="o_burger_menu_avatar o_image_24_cover rounded" t-att-src="'/web/image?model=res.users&amp;field=avatar_128&amp;id=' + user.userId" alt="Menu"/>
                  <span class="o_burger_menu_username px-2"><t t-esc="user.name"/></span>
              </small>
              <button class="o_sidebar_close oi oi-close btn d-flex align-items-center h-100 bg-transparent border-0 fs-2 text-reset" aria-label="Close menu" title="Close menu" t-on-click.stop="_closeBurger"/>
          </div>
          <nav class="o_burger_menu_content flex-grow-1 flex-shrink-1 overflow-auto o_burger_menu_app">

            <MobileSwitchCompanyMenu t-if="Object.values(company.allowedCompanies).length &gt; 1"/>
            <BurgerUserMenu/>
          </nav>
        </div>
      </Transition>
      <div t-if="state.isBurgerOpened" class="modal-backdrop show d-block d-md-none" t-on-click.stop="_closeBurger" t-on-touchstart.stop="_onSwipeStart" t-on-touchend.stop="_onSwipeEnd"/>
    </t>
</div>

`);
registerTemplate("web.BurgerUserMenu", `/web/static/src/webclient/burger_menu/burger_user_menu/burger_user_menu.xml`, `<t t-name="web.BurgerUserMenu" xml:space="preserve">
    <div class="o_user_menu_mobile mt-2 px-3">
      <t t-foreach="getElements()" t-as="element" t-key="element_index">
          <t t-if="!element.hide">
              <a t-if="element.type == 'item'" class="d-block text-body py-3 fs-4" t-att-href="element.href or ''" t-out="element.description" t-on-click.stop.prevent="() =&gt; this._onItemClicked(element.callback)"/>
              <CheckBox t-if="element.type == 'switch'" value="element.isChecked" className="'form-switch d-flex flex-row-reverse justify-content-between py-3 ps-0 fs-4 w-100'" onChange="element.callback">
                  <t t-out="element.description"/>
              </CheckBox>
              <hr t-if="element.type == 'separator'"/>
          </t>
      </t>
    </div>
  </t>

`);
registerTemplate("web.MobileSwitchCompanyMenu", `/web/static/src/webclient/burger_menu/mobile_switch_company_menu/mobile_switch_company_menu.xml`, `<t t-name="web.MobileSwitchCompanyMenu" xml:space="preserve">
    <div class="o_burger_menu_companies p-3 pb-0">
        <div class="w-100" t-on-click="() =&gt; this.toggleCollapsible()">
            <i t-if="hasLotsOfCompanies" class="fa me-2" style="width: 10px" t-att-class="{ 'fa-caret-right': !state.isOpen, 'fa-caret-down': state.isOpen }"/>
            <span class="mb-3 fs-4">Companies</span>
        </div>
        <div t-if="show" class="mt-2">
            <t t-call="web.SwitchCompanyMenu.Items"/>
        </div>
    </div>
</t>

`);
registerTemplate("web.DebugMenu.ProfilingItem", `/web/static/src/webclient/debug/profiling/profiling_item.xml`, `<t t-name="web.DebugMenu.ProfilingItem" xml:space="preserve">
        <DropdownItem class="o_debug_profiling_item_wrapper">
            <div class="o_debug_profiling_item d-flex justify-content-between">
                <div class="align-self-center">
                    <div t-if="profiling.state.isEnabled" class="alert alert-info py-2 me-3">Recording...</div>
                    <span class="o_profiling_switch">
                        <span class="form-check form-switch" t-on-click.stop.prevent="() =&gt; this.profiling.toggleProfiling()">
                            <input type="checkbox" class="form-check-input" id="enable_profiling" t-att-checked="profiling.state.isEnabled"/>
                            <label class="form-check-label">Enable profiling</label>
                        </span>
                    </span>
                    <t t-if="profiling.state.isEnabled">
                        <span class="o_profiling_switch form-check form-switch mt-2" t-on-click.stop.prevent="() =&gt; this.profiling.toggleCollector('sql')">
                            <input type="checkbox" class="form-check-input" id="profile_sql" t-att-checked="profiling.isCollectorEnabled('sql')"/>
                            <label class="form-check-label" for="profile_sql">Record sql</label>
                        </span>
                        <span class="o_profiling_switch form-check form-switch mt-2" t-on-click.stop.prevent="() =&gt; this.profiling.toggleCollector('traces_async')">
                            <input type="checkbox" class="form-check-input" id="profile_traces_async" t-att-checked="profiling.isCollectorEnabled('traces_async')"/>
                            <label class="form-check-label" for="profile_traces_async">Record traces</label>
                        </span>
                        <div t-if="profiling.isCollectorEnabled('traces_async')" class="input-group input-group-sm mt-2" t-on-click.stop.prevent="">
                            <div class="input-group-text">Interval</div>
                            <select class="profile_param form-select" t-on-change="(ev) =&gt; this.changeParam('traces_async_interval', ev)">
                                <t t-set="interval" t-value="profiling.state.params.traces_async_interval"/>
                                <option value="">Default</option>
                                <option value="0.001" t-att-selected="interval === '0.001'">0.001</option>
                                <option value="0.01" t-att-selected="interval === '0.01'">0.01</option>
                                <option value="0.1" t-att-selected="interval === '0.1'">0.1</option>
                                <option value="1" t-att-selected="interval === '1'">1</option>
                            </select>
                        </div>
                        <span t-if="profiling.isCollectorEnabled('sql') || profiling.isCollectorEnabled('traces_async')" class="o_profiling_switch form-check form-switch mt-2" t-on-click.stop.prevent="(ev) =&gt; this.toggleParam('execution_context_qweb', ev)">
                            <input type="checkbox" class="form-check-input" id="profile_execution_context_qweb" t-att-checked="!!profiling.state.params.execution_context_qweb"/>
                            <label class="form-check-label" for="profile_execution_context_qweb">Add qweb directive context</label>
                        </span>
                        <span class="o_profiling_switch form-check form-switch mt-2" t-on-click.stop.prevent="() =&gt; this.profiling.toggleCollector('qweb')">
                            <input type="checkbox" class="form-check-input" id="profile_qweb" t-att-checked="profiling.isCollectorEnabled('qweb')"/>
                            <label class="form-check-label" for="profile_qweb">Record qweb</label>
                        </span>
                    </t>
                </div>
                <a href="#" t-on-click.prevent="openProfiles" t-attf-class="btn btn-light align-self-baseline {{profiling.state.isEnabled ? 'py-2' : ''}}">
                    <i class="o_open_profiling oi oi-launch"/>
                </a>
            </div>
        </DropdownItem>
    </t>

`);
registerTemplate("web.ProfilingQwebView", `/web/static/src/webclient/debug/profiling/profiling_qweb.xml`, `<t t-name="web.ProfilingQwebView" xml:space="preserve">
    <div class="oe_form_field o_ace_view_editor oe_ace_open o_profiling_qweb_view">
        <div class="o_select_view_profiling" t-ref="selector">
            <a role="button" class="dropdown-toggle" data-bs-toggle="dropdown" aria-expanded="false" href="#"><MenuItem view="state.view" t-if="state.view"/></a>
            <div class="dropdown-menu" role="menu">
                <t t-foreach="viewObjects" t-as="view" t-key="view_index">
                    <a role="menuitem" href="#" t-att-data-id="view.id" t-on-click.prevent="_onSelectView">
                        <MenuItem view="view"/>
                    </a>
                </t>
            </div>
        </div>
        <div class="ace-view-editor" t-ref="ace"/>
        <small class="text-muted">
            It is possible that the "t-call" time does not correspond to the overall time of the
            template. Because the global time (in the drop down) does not take into account the
            duration which is not in the rendering (look for the template, read, inheritance,
            compilation...). During rendering, the global time also takes part of the time to make
            the profile as well as some part not logged in the function generated by the qweb.
        </small>
    </div>
</t>
`);
registerTemplate("web.ProfilingQwebView.menuitem", `/web/static/src/webclient/debug/profiling/profiling_qweb.xml`, `<t t-name="web.ProfilingQwebView.menuitem" xml:space="preserve">
    <div class="o_delay"><t t-if="props.view.delay" t-esc="props.view.delay"/> ms</div>
    <div class="o_query"><t t-if="props.view.delay" t-esc="props.view.query"/> query</div>
    <t t-esc="props.view.display_name"/>
    <div class="o_key text-muted">(<t t-esc="props.view.id"/>, <t t-esc="props.view.key"/>)</div>
</t>
`);
registerTemplate("web.ProfilingQwebView.hover", `/web/static/src/webclient/debug/profiling/profiling_qweb.xml`, `<t t-name="web.ProfilingQwebView.hover" xml:space="preserve">
    <div class="o_info o_detail">
        <div class="o_delay"><t t-esc="delay"/> <span>ms</span></div>
        <div class="o_query"><t t-esc="query"/> <span>query</span></div>
    </div>
</t>
`);
registerTemplate("web.ProfilingQwebView.info", `/web/static/src/webclient/debug/profiling/profiling_qweb.xml`, `<t t-name="web.ProfilingQwebView.info" xml:space="preserve">
    <div class="o_info">
        <div t-if="displayDetail" class="o_more">
            <span>*</span>
            <table class="o_detail">
                <thead>
                    <tr><th/><th>ms</th><th>query</th></tr>
                </thead>
                <tbody>
                    <tr t-foreach="groups" t-as="directive" t-key="directive_index">
                        <td><t t-esc="directive"/></td>
                        <td><t t-esc="groups[directive].delays.join(' ')"/></td>
                        <td><t t-esc="groups[directive].querys.join(' ')"/></td>
                    </tr>
                </tbody>
            </table>
        </div>
        <div class="o_delay"><t t-esc="delay"/></div>
        <div class="o_query"><t t-esc="query"/></div>
    </div>
</t>

`);
registerTemplate("web.ProfilingSystrayItem", `/web/static/src/webclient/debug/profiling/profiling_systray_item.xml`, `<t t-name="web.ProfilingSystrayItem" xml:space="preserve">
        <div class="d-flex align-items-center">
            <i class="fa fa-circle text-danger o_debug_recording"/>
        </div>
    </t>

`);
registerTemplate("web.LoadingIndicator", `/web/static/src/webclient/loading_indicator/loading_indicator.xml`, `<t t-name="web.LoadingIndicator" xml:space="preserve">
        <Transition visible="state.show" name="'o-fade'" t-slot-scope="transition" leaveDuration="400">
            <span class="o_loading_indicator" t-att-class="transition.className">Loading<t t-if="env.debug" t-esc="' (' + state.count + ')'"/></span>
        </Transition>
    </t>

`);
registerTemplate("web.AppIconCommand", `/web/static/src/webclient/menus/menu_command_item.xml`, `<t t-name="web.AppIconCommand" xml:space="preserve">
    <div class="o_command_default position-relative d-flex align-items-center px-4 py-2 cursor-pointer">
      <img t-if="props.webIconData" class="me-2 o_app_icon position-relative rounded-1" t-attf-src="{{props.webIconData}}"/>
      <div t-else="" class="me-2 o_app_icon d-flex align-items-center justify-content-center" t-attf-style="background-color:{{props.webIcon.backgroundColor}}">
        <i t-att-class="props.webIcon.iconClass" t-attf-style="color:{{props.webIcon.color}}"/>
      </div>
      <t t-slot="name"/>
      <span class="ms-auto flex-shrink-0">
        <t t-slot="focusMessage"/>
      </span>
    </div>
  </t>

`);
registerTemplate("web.NavBar", `/web/static/src/webclient/navbar/navbar.xml`, `<t t-name="web.NavBar" xml:space="preserve">
    <header class="o_navbar" t-ref="root">
      <nav class="o_main_navbar d-print-none" data-command-category="disabled">

        <t t-call="web.NavBar.AppsMenu">
          <t t-set="apps" t-value="menuService.getApps()"/>
        </t>


        <DropdownItem t-if="!env.isSmall and currentApp" t-esc="currentApp.name" class="'o_menu_brand d-flex'" onSelected="() =&gt; this.onNavBarDropdownItemSelection(currentApp)" attrs="{ href: getMenuItemHref(currentApp), 'data-menu-xmlid': currentApp.xmlid, 'data-section': currentApp.id }"/>

        <div class="o_navbar_breadcrumbs d-contents"/>

        <t t-if="!env.isSmall">

          <t t-if="currentAppSections.length" t-call="web.NavBar.SectionsMenu">
            <t t-set="sections" t-value="currentAppSections"/>
          </t>
        </t>


        <div class="o_menu_systray d-flex flex-shrink-0 ms-auto" role="menu">
          <t t-foreach="systrayItems" t-as="item" t-key="item.key">

            <div t-att-data-index="item.index"/>
            <ErrorHandler onError="error =&gt; this.handleItemError(error, item)">
                <t t-component="item.Component" t-props="item.props"/>
            </ErrorHandler>
          </t>
        </div>
      </nav>
    </header>
  </t>

  `);
registerTemplate("web.SectionMenu", `/web/static/src/webclient/navbar/navbar.xml`, `<t t-name="web.SectionMenu" xml:space="preserve">
    <li class="px-3" t-if="section.childrenTree.length">
        <div class="bg-transparent" t-att-class="{                 'fw-bolder text-900 pt-3 pb-2': !isNested,                 'border-top': !isNested &amp;&amp; subMenu_index != 0,                 'py-2': isNested,             }" t-att-data-menu-xmlid="section.xmlid" t-esc="section.name"/>
        <ul class="list-unstyled ps-0">
            <t t-foreach="section.childrenTree" t-as="subSection" t-key="subSection_index">
                <t t-call="web.SectionMenu">
                    <t t-set="section" t-value="subSection"/>
                    <t t-set="isNested" t-value="true"/>
                </t>
            </t>
        </ul>
    </li>
    <li t-else="" t-on-click="() =&gt; this._onMenuClicked(section)" t-att-data-menu-xmlid="section.xmlid" t-att-class="{             'fw-bold text-900 py-3': !isNested,             'border-top': !isNested &amp;&amp; subMenu_index != 0,             'py-2': isNested,         }">
        <t t-esc="section.name"/>
    </li>
  </t>

  `);
registerTemplate("web.NavBar.AppsMenu", `/web/static/src/webclient/navbar/navbar.xml`, `<t t-name="web.NavBar.AppsMenu" xml:space="preserve">
    <t t-if="env.isSmall">
      <a href="/odoo" class="o_menu_toggle border-0" t-att-class="{'hasImage': currentApp?.webIconData}" accesskey="h" t-ref="menuApps" t-on-click.prevent="_openAppMenuSidebar">
        <t t-call="web.NavBar.AppsMenu.Sidebar"/>
      </a>
    </t>
    <t t-else="">
      <div t-if="!isScopedApp" class="o_navbar_apps_menu">
        <Dropdown>
          <button data-hotkey="h" title="Home Menu">
            <i class="oi oi-apps"/>
          </button>
          <t t-set-slot="content">
            <DropdownItem t-foreach="apps" t-as="app" t-key="app.id" class="{ 'o_app': true, focus: menuService.getCurrentApp() === app }" onSelected="() =&gt; this.onNavBarDropdownItemSelection(app)" t-esc="app.name" attrs="{ href: getMenuItemHref(app), 'data-menu-xmlid': app.xmlid, 'data-section': app.id }"/>
          </t>
        </Dropdown>
      </div>
      <div t-else="" class="mx-2"/>
    </t>
  </t>

  `);
registerTemplate("web.NavBar.AppsMenu.Sidebar", `/web/static/src/webclient/navbar/navbar.xml`, `<t t-name="web.NavBar.AppsMenu.Sidebar" xml:space="preserve">
    <i class="fa fa-bars" aria-hidden="true"/>
    <t t-portal="'body'">
      <Transition name="'o-app-menu-sidebar'" visible="state.isAppMenuSidebarOpened" leaveDuration="200" t-slot-scope="transition">
        <div class="o_app_menu_sidebar position-fixed top-0 bottom-0 end-100 d-flex flex-column flex-nowrap" t-att-class="transition.className" t-on-touchstart.stop="_onSwipeStart" t-on-touchend.stop="_onSwipeEnd">
          <div class="o_sidebar_topbar d-flex align-items-center justify-content-between flex-shrink-0 py-0 fs-4">
              <small class="d-flex align-items-center justify-content-between ms-2">
                  <a href="/odoo" class="btn btn-primary" t-on-click.prevent="onAllAppsBtnClick"><i class="oi oi-apps"/><span class="px-2">All Apps</span></a>
              </small>
              <button class="o_sidebar_close oi oi-close btn d-flex align-items-center h-100 bg-transparent border-0 fs-2 text-reset" aria-label="Close menu" title="Close menu" t-on-click.stop="_closeAppMenuSidebar"/>
          </div>
          <nav class="o_burger_menu_content flex-grow-1 flex-shrink-1 overflow-auto o_burger_menu_app">
                <div t-if="!state.isAllAppsMenuOpened and currentApp" class="d-flex align-items-center m-3 mb-0">
                  <img style="height: 2em;" t-if="currentApp.webIconData" class="o_app_icon me-2" t-attf-src="{{currentApp.webIconData}}"/>
                  <span class="fs-4 fw-bolder"><t t-esc="currentApp.name"/></span>
                </div>
                <ul class="list-unstyled py-2 ps-0 mb-0">
                    <t t-if="!state.isAllAppsMenuOpened">
                      <t t-foreach="currentAppSections" t-as="subMenu" t-key="subMenu_index">
                        <t t-call="web.SectionMenu">
                            <t t-set="section" t-value="subMenu"/>
                        </t>
                      </t>
                    </t>

                    <t t-else="">
                      <t t-foreach="apps" t-as="app" t-key="app_index">
                        <li t-att-data-menu-xmlid="app.xmlid" class="o_app fw-bolder py-2" t-att-class="{'bg-primary-subtle': menuService.getCurrentApp() === app}" t-on-click="() =&gt; {this.onNavBarDropdownItemSelection(app); this._closeAppMenuSidebar();}">
                          <div class="d-flex align-items-center">
                            <img style="height: 3em;" t-if="app.webIconData" class="o_app_icon me-2" t-attf-src="{{app.webIconData}}"/>
                            <t t-esc="app.name"/>
                          </div>
                        </li>
                      </t>
                    </t>
                </ul>
          </nav>
        </div>
      </Transition>
      <div t-if="state.isAppMenuSidebarOpened" class="modal-backdrop show d-block d-md-none" t-on-click.stop="_closeAppMenuSidebar" t-on-touchstart.stop="_onSwipeStart" t-on-touchend.stop="_onSwipeEnd"/>
    </t>
  </t>

  `);
registerTemplate("web.NavBar.SectionsMenu", `/web/static/src/webclient/navbar/navbar.xml`, `<t t-name="web.NavBar.SectionsMenu" xml:space="preserve">
    <div class="o_menu_sections d-flex flex-grow-1 flex-shrink-1 w-0" t-ref="appSubMenus" role="menu">
        <t t-if="!env.isSmall">
            <DropdownGroup>
                <t t-foreach="sections" t-as="section" t-key="section.id">
                    <t t-set="sectionsVisibleCount" t-value="(sections.length - currentAppSectionsExtra.length)"/>

                    <t t-if="section_index lt Math.min(10, sectionsVisibleCount)">
                        <t t-set="hotkey" t-value="((section_index + 1) % 10).toString()"/>
                    </t>
                    <t t-else="">
                        <t t-set="hotkey" t-value="undefined"/>
                    </t>

                    <t t-if="!section.childrenTree.length">
                        <DropdownItem class="'o_nav_entry'" onSelected="() =&gt; this.onNavBarDropdownItemSelection(section)" t-esc="section.name" attrs="{                                 href: getMenuItemHref(section),                                 'data-hotkey': hotkey,                                 'data-menu-xmlid': section.xmlid,                                 'data-section': section.id,                             }"/>
                    </t>
                    <t t-else="">
                        <Dropdown>
                            <button t-att-data-hotkey="hotkey" t-att-data-menu-xmlid="section.xmlid">
                                <span t-esc="section.name" t-att-data-section="section.id"/>
                            </button>
                            <t t-set-slot="content">
                                <t t-call="web.NavBar.SectionsMenu.Dropdown.MenuSlot">
                                <t t-set="items" t-value="section.childrenTree"/>
                                <t t-set="decalage" t-value="20"/>
                                </t>
                            </t>
                        </Dropdown>
                    </t>
                </t>

                <t t-if="currentAppSectionsExtra.length" t-call="web.NavBar.SectionsMenu.MoreDropdown">
                    <t t-set="sections" t-value="currentAppSectionsExtra"/>
                    <t t-if="sectionsVisibleCount lt 10">
                        <t t-set="hotkey" t-value="(sectionsVisibleCount + 1 % 10).toString()"/>
                    </t>
                </t>
            </DropdownGroup>
        </t>
    </div>
  </t>

  `);
registerTemplate("web.NavBar.DropdownItem", `/web/static/src/webclient/navbar/navbar.xml`, `<t t-name="web.NavBar.DropdownItem" t-inherit="web.DropdownItem" t-inherit-mode="primary" xml:space="preserve">
    <xpath expr="//t[@t-tag]" position="attributes">
      <attribute name="t-att-style">props.style</attribute>
    </xpath>
  </t>

  `);
registerTemplate("web.NavBar.SectionsMenu.Dropdown.MenuSlot", `/web/static/src/webclient/navbar/navbar.xml`, `<t t-name="web.NavBar.SectionsMenu.Dropdown.MenuSlot" xml:space="preserve">
    <t t-set="style" t-value="\`padding-left: \${decalage}px;\`"/>
    <t t-foreach="items" t-as="item" t-key="item.id">
      <DropdownItem t-if="!item.childrenTree.length" class="{           'dropdown-item': true,           o_dropdown_menu_group_entry: decalage gt 20         }" t-esc="item.name" onSelected="() =&gt; this.onNavBarDropdownItemSelection(item)" attrs="{ style: style, href: getMenuItemHref(item), 'data-menu-xmlid': item.xmlid, 'data-section': item.id }"/>

      <t t-else="">
        <div class="dropdown-menu_group dropdown-header" t-att-style="style" t-esc="item.name"/>
        <t t-call="web.NavBar.SectionsMenu.Dropdown.MenuSlot">
          <t t-set="items" t-value="item.childrenTree"/>
          <t t-set="decalage" t-value="decalage + 12"/>
        </t>
      </t>
    </t>
  </t>

  `);
registerTemplate("web.NavBar.SectionsMenu.MoreDropdown", `/web/static/src/webclient/navbar/navbar.xml`, `<t t-name="web.NavBar.SectionsMenu.MoreDropdown" xml:space="preserve">
    <div class="o_menu_sections_more">
      <Dropdown>
        <button title="More Menu" t-att-data-hotkey="hotkey">
          <i class="fa fa-plus"/>
        </button>

        <t t-set-slot="content">
          <t t-foreach="sections" t-as="section" t-key="section.id">
            <t t-if="!section.childrenTree.length">
              <DropdownItem class="'o_more_dropdown_section'" onSelected="() =&gt; this.onNavBarDropdownItemSelection(section)" t-esc="section.name" attrs="{ href: getMenuItemHref(section), 'data-menu-xmlid': section.xmlid, 'data-section': section.id }"/>
            </t>
            <t t-else="">
              <div class="o_more_dropdown_section o_more_dropdown_section_group dropdown-header bg-100" t-esc="section.name"/>
              <t t-call="web.NavBar.SectionsMenu.Dropdown.MenuSlot">
                <t t-set="items" t-value="section.childrenTree"/>
                <t t-set="decalage" t-value="20"/>
              </t>
            </t>
          </t>
        </t>
      </Dropdown>
    </div>
  </t>

`);
registerTemplate("web.SettingsBinaryField", `/web/static/src/webclient/settings_form_view/fields/settings_binary_field/settings_binary_field.xml`, `<t t-name="web.SettingsBinaryField" t-inherit="web.BinaryField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@name='download']" position="attributes">
            <attribute name="t-if"/>
        </xpath>
    </t>

`);
registerTemplate("web.UpgradeDialog", `/web/static/src/webclient/settings_form_view/fields/upgrade_dialog.xml`, `<t t-name="web.UpgradeDialog" xml:space="preserve">
        <Dialog size="'md'" title.translate="Odoo Enterprise">
            <div class="row" role="status">
                <div class="col-6">
                    Get this feature and much more with Odoo Enterprise!
                    <ul class="list-unstyled">
                        <li><i class="fa fa-check"/> Access to all Enterprise Apps</li>
                        <li><i class="fa fa-check"/> New design</li>
                        <li><i class="fa fa-check"/> Mobile support</li>
                        <li><i class="fa fa-check"/> Upgrade to future versions</li>
                        <li><i class="fa fa-check"/> Bugfixes guarantee</li>
                        <li><a href="http://www.odoo.com/editions?utm_source=db&amp;utm_medium=enterprise" target="_blank"><i class="fa fa-plus"/> And more</a></li>
                    </ul>
                </div>
                <div class="col-6">
                    <img class="img-fluid" t-att-src="'/web/static/img/enterprise_upgrade.jpg'" draggable="false" alt="Upgrade to enterprise"/>
                </div>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="_confirmUpgrade">Upgrade now</button>
                <button class="btn btn-secondary" t-on-click="this.props.close">Cancel</button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("web.FormLabelHighlightText", `/web/static/src/webclient/settings_form_view/highlight_text/form_label_highlight_text.xml`, `<t t-name="web.FormLabelHighlightText" xml:space="preserve">
        <label class="o_form_label" t-att-for="props.id" t-att-class="className">
            <HighlightText originalText="props.string"/>
            <t t-if="upgradeEnterprise">
                <span class="badge text-bg-primary oe_inline o_enterprise_label">Enterprise</span>
            </t>
        </label>
    </t>
`);
registerTemplate("web.HighlightText", `/web/static/src/webclient/settings_form_view/highlight_text/highlight_text.xml`, `<t t-name="web.HighlightText" xml:space="preserve">
        <span t-att-searchableText="props.originalText">
            <t t-foreach="splitText" t-as="name" t-key="name_index">
                <b t-if="name_index % 2" t-out="name" t-att-class="constructor.highlightClass"/>
                <t t-else="" t-out="name"/>
            </t>
        </span>
    </t>
`);
registerTemplate("web.SettingsRadioField", `/web/static/src/webclient/settings_form_view/highlight_text/settings_radio_field.xml`, `<t t-name="web.SettingsRadioField" t-inherit="web.RadioField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//label" position="replace">
            <label class="form-check-label o_form_label" t-att-for="\`\${id}_\${item[0]}\`">
                <HighlightText originalText="item[1]"/>
            </label>
        </xpath>
    </t>

`);
registerTemplate("web.SearchableSetting", `/web/static/src/webclient/settings_form_view/settings/searchable_setting.xml`, `<t t-name="web.SearchableSetting" t-inherit="web.Setting" t-inherit-mode="primary" xml:space="preserve">
        <div t-att-class="classNames" position="attributes">
            <attribute name="t-ref">setting</attribute>
            <attribute name="t-if">visible()</attribute>
        </div>
        <span class="o_form_label" position="replace">
            <span class="o_form_label"><HighlightText originalText="labelString"/></span>
        </span>
        <div class="text-muted" position="replace">
            <div class="text-muted"><HighlightText originalText="props.help"/></div>
        </div>
    </t>
`);
registerTemplate("web.HeaderSetting", `/web/static/src/webclient/settings_form_view/settings/setting_header.xml`, `<t t-name="web.HeaderSetting" xml:space="preserve">
        <div class="app_settings_header d-flex flex-column flex-md-row align-items-baseline gap-1 gap-md-5 py-3 bg-warning bg-opacity-25">
            <label class="o_form_label" t-att-for="props.fieldId">
                <t t-esc="labelString"/>
            </label>
            <div class="input-group align-items-baseline w-auto o_field_highlight">
                <t t-slot="fieldSlot"/>
                <t t-slot="default"/>
            </div>
        </div>
    </t>
`);
registerTemplate("web.SettingsApp", `/web/static/src/webclient/settings_form_view/settings/settings_app.xml`, `<t t-name="web.SettingsApp" xml:space="preserve">
        <div class="app_settings_block" t-if="props.selectedTab === props.key or state.search.value.length !== 0" t-att-string="props.string" t-att-data-key="props.key" t-ref="settingsApp">
            <div class="settingSearchHeader h4" t-if="state.search.value.length !== 0" role="search">
                <img class="icon" t-att-src="props.imgurl" alt="Search"/>
                <span class="appName"><t t-esc="props.string"/></span>
            </div>
            <t t-slot="default"/>
        </div>
    </t>
`);
registerTemplate("web.SettingsBlock", `/web/static/src/webclient/settings_form_view/settings/settings_block.xml`, `<t t-name="web.SettingsBlock" xml:space="preserve">
        <h2 t-if="props.title" t-ref="settingsContainerTitle"><HighlightText originalText="props.title"/></h2>
        <h3 t-if="props.tip" class="o_setting_tip text-muted" t-ref="settingsContainerTip"><HighlightText originalText="props.tip"/></h3>
        <div class="row mt16 o_settings_container" t-att-class="props.class" t-ref="settingsContainer">
            <t t-slot="default"/>
        </div>
    </t>
`);
registerTemplate("web.SettingsPage", `/web/static/src/webclient/settings_form_view/settings/settings_page.xml`, `<t t-name="web.SettingsPage" xml:space="preserve">
        <div class="o_setting_container">
            <div class="position-sticky top-0 flex-grow-0 z-1">
                <div class="settings_tab h-100 border-end" t-if="!env.isSmall or state.search.value.length === 0" t-ref="settings_tab">
                    <t t-foreach="props.modules" t-as="module" t-key="module.key">
                        <a class="tab" t-if="!module.isVisible" t-att-class="{                                 'selected': state.selectedTab === module.key and state.search.value.length === 0, 'text-bg-primary shadow-none': state.selectedTab === module.key and state.search.value.length === 0 and env.isSmall                              }" t-att-data-key="module.key" role="tab" t-attf-href="#\${ctx.module.key}" t-on-click="() =&gt; this.onSettingTabClick(module.key)">
                            <span class="icon d-none d-md-block" t-attf-style="background : url('{{module.imgurl}}') no-repeat center;background-size:contain;"/> <span class="app_name"><t t-esc="module.string"/></span>
                        </a>
                    </t>
                </div>
            </div>
            <ActionSwiper onRightSwipe=" hasRightSwipe() ? {                         action: onRightSwipe.bind(this),                     } : undefined" onLeftSwipe=" hasLeftSwipe() ? {                         action: onLeftSwipe.bind(this),                     } : undefined" animationOnMove="false" animationType="'forwards'" swipeDistanceRatio="6">
                <div class="settings" t-ref="settings">
                    <t t-slot="NoContentHelper" t-if="props.slots['NoContentHelper'].isVisible"/>
                    <t t-slot="default" selectedTab="state.selectedTab"/>
                </div>
            </ActionSwiper>
        </div>
    </t>
`);
registerTemplate("web.SettingsConfirmationDialog", `/web/static/src/webclient/settings_form_view/settings_confirmation_dialog.xml`, `<t t-name="web.SettingsConfirmationDialog" xml:space="preserve">
        <Dialog size="'md'" title="props.title" modalRef="modalRef">
            <t t-esc="props.body"/>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="_confirm">
                    Save
                </button>
                <button class="btn btn-secondary" t-on-click="_stayHere">
                    Stay Here
                </button>
                <button class="btn btn-secondary" t-on-click="_cancel">
                    Discard
                </button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("web.SettingsFormView", `/web/static/src/webclient/settings_form_view/settings_form_view.xml`, `<t t-name="web.SettingsFormView" t-inherit="web.FormView" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="./div[@t-ref='root']" position="attributes">
            <attribute name="class">o-settings-form-view o_field_highlight</attribute>
        </xpath>
        <xpath expr="//Layout/t[@t-set-slot='layout-actions']" position="replace">
            <t t-set-slot="layout-actions">
                <div class="o_cp_searchview d-flex w-100" role="search">
                    <div class="o_searchview form-control d-flex align-items-center py-1" role="search" aria-autocomplete="list">
                        <i class="o_searchview_icon oi oi-search me-2" role="img" aria-label="Search..." title="Search..."/>
                        <div class="o_searchview_input_container d-flex flex-grow-1 flex-wrap gap-1">
                            <input type="text" class="o_searchview_input o_input flex-grow-1 w-auto border-0" accesskey="Q" placeholder="Search..." role="searchbox" t-model="searchState.value" t-ref="autofocus"/>
                        </div>
                    </div>
                </div>
            </t>
        </xpath>
        <xpath expr="//Layout/t[@t-set-slot='control-panel-status-indicator']" position="replace"/>
        <xpath expr="//Layout/t[@t-set-slot='control-panel-additional-actions']" position="replace"/>
        <xpath expr="//Layout/t[@t-component='props.Renderer']" position="attributes">
            <attribute name="initialApp">initialApp</attribute>
        </xpath>
        <xpath expr="//Layout/t[@t-component='props.Renderer']" position="inside">
            <t t-set-slot="NoContentHelper" isVisible="state.displayNoContent">
                <t t-call="web.NoContentHelper">
                    <t t-set="title" t-value="'No setting found'"/>
                    <t t-set="description" t-value="'Try searching for another keyword'"/>
                </t>
            </t>
        </xpath>
        <xpath expr="//Layout" position="inside">
            <t t-set-slot="control-panel-status-indicator">
                <t t-call="{{ props.buttonTemplate }}"/>
            </t>
        </xpath>
    </t>

    `);
registerTemplate("web.SettingsFormView.Buttons", `/web/static/src/webclient/settings_form_view/settings_form_view.xml`, `<t t-name="web.SettingsFormView.Buttons" t-inherit="web.FormView.Buttons" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div" position="attributes">
            <attribute name="class" add="order-first w-auto" separator=" "/>
        </xpath>
        <xpath expr="//div" position="after">
            <span t-if="model.root.dirty" class="text-muted ms-2 o_dirty_warning">Unsaved changes</span>
        </xpath>
    </t>
`);
registerTemplate("web.MobileAppsFunnel", `/web/static/src/webclient/settings_form_view/widgets/mobile_apps_funnel.xml`, `<t t-name="web.MobileAppsFunnel" xml:space="preserve">
        <Setting addLabel="false">
            <div class="d-flex">
                <div>
                    <a class="d-block mx-auto" href="https://play.google.com/store/apps/details?id=com.odoo.mobile" target="blank">
                        <img alt="On Google Play" class="d-block mx-auto img img-fluid" t-att-src="androidAppstoreImagePath"/>
                    </a>
                </div>
                <div>
                    <a class="d-block mx-auto" href="https://itunes.apple.com/us/app/odoo/id1272543640" target="blank">
                        <img alt="On Apple Store" class="d-block mx-auto img img-fluid" t-att-src="iosAppstoreImagePath"/>
                    </a>
                </div>
            </div>
        </Setting>
    </t>
`);
registerTemplate("res_config_dev_tool", `/web/static/src/webclient/settings_form_view/widgets/res_config_dev_tool.xml`, `<div t-name="res_config_dev_tool" xml:space="preserve">
        <div id="developer_tool">
            <SettingsBlock title.translate="Developer Tools">
                <Setting addLabel="false">
                        <a t-if="!isDebug" class="d-block" t-on-click="() =&gt; this.activateDebug(1)" href="#">Activate the developer mode</a>
                        <a t-if="!isAssets" class="d-block" t-on-click="() =&gt; this.activateDebug('assets')" href="#">Activate the developer mode (with assets)</a>
                        <a t-if="!isTests" class="d-block" t-on-click="() =&gt; this.activateDebug('assets,tests')" href="#">Activate the developer mode (with tests assets)</a>
                        <a t-if="isDebug" class="d-block" t-on-click="() =&gt; this.activateDebug(0)" href="#">Deactivate the developer mode</a>
                        <a t-if="isDebug and !isDemoDataActive" t-on-click.prevent="onClickForceDemo" class="o_web_settings_force_demo" href="#">Load demo data</a>
                </Setting>
            </SettingsBlock>
        </div>
    </div>
`);
registerTemplate("res_config_edition", `/web/static/src/webclient/settings_form_view/widgets/res_config_edition.xml`, `<div t-name="res_config_edition" xml:space="preserve">
        <Setting addLabel="false">
                <div class="user-heading">
                    <h3 class="px-0">
                        Odoo <t t-esc="serverVersion"/>
                        (Community Edition)
                    </h3>
                </div>
                <div>
                    <div class="tab-content">
                        <div role="tabpanel" id="settings" class="tab-pane active text-muted o_web_settings_compact_subtitle">
                            <small>Copyright © 2004 <a target="_blank" href="https://www.odoo.com" style="text-decoration: underline;">Odoo S.A.</a> <a id="license" target="_blank" href="http://www.gnu.org/licenses/lgpl.html" style="text-decoration: underline;">GNU LGPL Licensed</a></small>
                        </div>
                    </div>
                </div>
        </Setting>
    </div>
`);
registerTemplate("res_config_invite_users", `/web/static/src/webclient/settings_form_view/widgets/res_config_invite_users.xml`, `<div t-name="res_config_invite_users" xml:space="preserve">
        <p class="o_form_label">Invite New Users</p>

        <div class="d-flex">
            <input t-model="state.emails" t-att-disabled="state.status != 'idle'" class="o_user_emails o_input mt8 text-truncate" t-on-keydown="onKeydownUserEmails" type="text" placeholder="Enter an email"/>
            <button t-att-disabled="state.status != 'idle'" class="btn btn-primary o_web_settings_invite flex-shrink-0" t-on-click="sendInvite"><strong><t t-esc="inviteButtonText"/></strong></button>
        </div>
        <t t-if="state.invite.pending_users.length">
            <p class="o_form_label pt-3">Pending Invitations:</p>
            <span t-foreach="state.invite.pending_users" t-as="pending" t-key="pending[0]">
                <a href="#" class="badge rounded-pill text-primary border border-primary o_web_settings_user" t-on-click.prevent="(ev) =&gt; this.onClickUser(ev, pending)"> <t t-esc="pending[1]"/> </a>
            </span>
            <t t-if="state.invite.pending_users.length &lt; state.invite.pending_count">
                <br/>
                <a href="#" class="o_web_settings_more" t-on-click.prevent="onClickMore"><t t-esc="state.invite.pending_count - state.invite.pending_users.length"/> more </a>
            </t>
        </t>
    </div>
`);
registerTemplate("web.SwitchCompanyItem", `/web/static/src/webclient/switch_company_menu/switch_company_item.xml`, `<t t-name="web.SwitchCompanyItem" xml:space="preserve">
    <span class="d-flex o_switch_company_item dropdown-item p-0 w-100" t-att-class="{             'disabled': !isCompanyAllowed,             'o-navigable': isCompanyAllowed,             'alert-secondary': isCompanySelected,         }" tabindex="0" data-menu="company" t-att-data-company-id="props.company.id">
        <div role="menuitemcheckbox" t-att-aria-checked="isCompanySelected ? 'true' : 'false'" t-att-aria-label="props.company.name" t-att-title="(isCompanySelected ? 'Hide ' : 'Show ') + props.company.name + ' content.'" class="border-end" t-att-class="{ 'border-primary': isCompanySelected, 'disabled': !isCompanyAllowed }" t-on-click.stop="() =&gt; this.toggleCompany()">
            <span class="btn border-0 px-2" t-att-class="isCompanyAllowed ? 'btn-link text-primary' : 'disabled'">
                <i class="fa fa-fw py-1" t-att-class="isCompanySelected ? 'fa-check-square text-primary' : 'fa-square-o'"/>
            </span>
        </div>

        <div role="button" t-att-aria-pressed="isCurrent ? 'true' : 'false'" t-att-aria-label="'Switch to ' + props.company.name" t-att-title="'Switch to ' + props.company.name" class="d-flex flex-grow-1 align-items-center py-0 log_into ps-2" t-att-class="isCurrent ? 'bg-primary-subtle' : 'btn fw-normal border-0 ' + (isCompanyAllowed ? 'btn-link text-primary' : 'disabled')" t-on-click="() =&gt; this.logIntoCompany()">
            <span class="company_label text-700 text-truncate" t-attf-style="padding-left:{{props.level * 20}}px;">
                <t t-out="props.company.name"/>
            </span>
        </div>
    </span>
</t>

`);
registerTemplate("web.SwitchCompanyMenu", `/web/static/src/webclient/switch_company_menu/switch_company_menu.xml`, `<t t-name="web.SwitchCompanyMenu" xml:space="preserve">
    <div class="o_switch_company_menu d-none d-md-block">
        <DropdownGroup group="'web-navbar-group'">
            <Dropdown position="'bottom-end'" menuRef="containerRef" state="this.dropdown" onStateChanged.bind="handleDropdownChange" navigationOptions="navigationOptions" menuClass="'o_switch_company_menu_dropdown'" disabled="isSingleCompany">
                <button data-hotkey="shift+u" t-att-disabled="isSingleCompany" t-att-title="companyService.currentCompany.name">
                    <i class="fa fa-building d-lg-none"/>
                    <span class="oe_topbar_name d-none d-lg-block text-truncate" t-esc="companyService.currentCompany.name"/>
                </button>

                <t t-set-slot="content">
                    <t t-call="web.SwitchCompanyMenu.Items"/>
                </t>
            </Dropdown>
        </DropdownGroup>
    </div>
</t>

`);
registerTemplate("web.SwitchCompanyMenu.Items", `/web/static/src/webclient/switch_company_menu/switch_company_menu.xml`, `<t t-name="web.SwitchCompanyMenu.Items" xml:space="preserve">
    <div class="d-flex flex-row pe-2 mb-2" t-att-class="{ 'visually-hidden': !state.showFilter }">
        <div role="menuitemcheckbox" t-att-aria-checked="companySelector.selectedCompaniesIds.length &gt; 0 ? 'true' : 'false'" t-att-aria-label="companySelector.selectedCompaniesIds.length &gt; 0 ? 'Deselect all' : 'Select all'" t-att-title="companySelector.selectedCompaniesIds.length &gt; 0 ? 'Deselect all' : 'Select all'" t-on-click="() =&gt; companySelector.selectAll()">
            <span class="btn border-0 pt-2 px-2" t-att-class="selectAllClass">
                <i class="fa fa-fw" t-att-class="selectAllIcon"/>
            </span>
        </div>
        <div class="form-control d-flex align-items-center py-1" role="search">
            <i class="oi oi-search me-2" role="img" aria-label="Search..." title="Search..."/>
            <div class="d-flex flex-grow-1 flex-wrap gap-1">
                <input t-on-input="this.onSearch" t-att-value="this.state.searchFilter" t-ref="inputRef" type="text" class="o_input flex-grow-1 border-0 o-navigable" placeholder="Search..." role="searchbox"/>
            </div>
        </div>
    </div>

    <div class="o_switch_company_menu_items">
        <t t-foreach="companiesEntries" t-as="entry" t-key="entry.company.id">
            <SwitchCompanyItem company="entry.company" level="entry.level"/>
        </t>
    </div>

    <div t-if="companySelector.hasSelectionChanged" class="o_switch_company_menu_buttons d-flex justify-content-end gap-2 px-2 pt-2">
        <button class="btn btn-primary o-navigable flex-grow-1 text-center" t-on-click="() =&gt; this.confirm()">
            Confirm
        </button>
        <button class="btn btn-secondary o-navigable flex-grow-1 text-center" t-on-click="() =&gt; companySelector.reset()">
            Reset
        </button>
    </div>
</t>

`);
registerTemplate("web.UserMenu", `/web/static/src/webclient/user_menu/user_menu.xml`, `<t t-name="web.UserMenu" xml:space="preserve">
        <div class="o_user_menu d-none d-md-block pe-0">
            <DropdownGroup group="'web-navbar-group'">
                <Dropdown>
                    <button class="py-1 py-lg-0">
                        <img class="o_avatar o_user_avatar rounded" t-att-src="source" alt="User"/>
                        <small class="oe_topbar_name d-none ms-2 text-start smaller lh-1 text-truncate" t-att-class="{'d-lg-inline-block' : env.debug}" style="max-width: 200px">
                            <t t-esc="userName"/>
                            <mark class="d-block font-monospace text-truncate">
                                <i class="fa fa-database oi-small me-1"/><t t-esc="dbName"/>
                            </mark>
                        </small>
                    </button>
                    <t t-set-slot="content">
                        <t t-foreach="getElements()" t-as="element" t-key="element_index">
                            <t t-if="!element.hide">
                                <DropdownItem t-if="element.type == 'item' || element.type == 'switch'" attrs="{ href: element.href, 'data-menu': element.id }" onSelected="element.callback">
                                    <CheckBox t-if="element.type == 'switch'" value="element.isChecked" className="'form-switch d-flex flex-row-reverse justify-content-between p-0 w-100'" onChange="element.callback">
                                        <t t-out="element.description"/>
                                    </CheckBox>
                                    <t t-else="" t-out="element.description"/>
                                </DropdownItem>
                                <div t-if="element.type == 'separator'" role="separator" class="dropdown-divider"/>
                            </t>
                        </t>
                    </t>
                </Dropdown>
            </DropdownGroup>
        </div>
    </t>

`);
registerTemplate("web.UserMenu.ShortcutsFooterComponent", `/web/static/src/webclient/user_menu/user_menu_items.xml`, `<t t-name="web.UserMenu.ShortcutsFooterComponent" xml:space="preserve">
        <span>
            <span class="fw-bolder text-primary">TIP</span> — press <span class="fw-bolder text-primary"><t t-esc="runShortcutKey"/></span> on any screen to show shortcut overlays and <span class="fw-bolder text-primary"><t t-esc="runShortcutKey"/> + KEY</span> to trigger a shortcut.
        </span>
    </t>

`);
registerTemplate("web.WebClient", `/web/static/src/webclient/webclient.xml`, `<t t-name="web.WebClient" xml:space="preserve">
        <t t-if="!state.fullscreen">
            <NavBar/>
        </t>
        <ActionContainer/>
        <MainComponentsContainer/>
    </t>

`);
registerTemplate("web.ReportAction", `/web/static/src/webclient/actions/reports/report_action.xml`, `<t t-name="web.ReportAction" xml:space="preserve">
        <div class="o_action">
            <Layout display="{ controlPanel: {} }">
                <t t-set-slot="control-panel-create-button">
                    <button t-on-click="print" type="button" class="btn btn-primary" title="Print">Print</button>
                </t>
                <iframe t-ref="iframe" t-on-load="onIframeLoaded" class="h-100 w-100 d-block" t-att-src="reportUrl"/>
            </Layout>
        </div>
    </t>

`);
registerTemplate("web_tour.TourPointer", `/web_tour/static/src/tour_pointer/tour_pointer.xml`, `<t t-name="web_tour.TourPointer" xml:space="preserve">
        <div t-if="props.pointerState.isVisible" t-ref="pointer" t-attf-class="                 o_tour_pointer                 o_{{ position }}                 {{ isOpen ? 'o_open' : (props.bounce ? 'o_bouncing' : '') }}                 {{ props.pointerState.onClick ? 'cursor-pointer' : '' }}             " t-attf-style="                 --TourPointer__width: {{ constructor.width }}px;                 --TourPointer__height: {{ constructor.height }}px;             " t-on-mouseenter="props.pointerState.onMouseEnter or (() =&gt; {})" t-on-mouseleave="props.pointerState.onMouseLeave or (() =&gt; {})" t-on-click="props.pointerState.onClick or (() =&gt; {})">
            <div class="o_tour_pointer_tip position-absolute"/>
            <div class="o_tour_pointer_content rounded overflow-hidden px-3 py-2 w-100 h-100 position-relative" t-att-class="{ 'invisible': !isOpen }">
                <t t-out="content"/>
            </div>
        </div>
        <div class="o_tour_dropzone position-fixed pe-none" t-if="props.pointerState.isVisible and props.pointerState.isZone" t-ref="zone" style="border: 3px dashed #714b67;"/>
    </t>
`);
registerTemplate("web_tour.TourRecorder", `/web_tour/static/src/tour_service/tour_recorder/tour_recorder.xml`, `<t t-name="web_tour.TourRecorder" xml:space="preserve">
    <div class="d-flex position-fixed bottom-0 start-0 bg-primary o_tour_recorder">
        <div t-ref="tour_recorder" class="d-flex">
            <button class="o_button_record btn btn-primary rounded-0" t-on-click.prevent.stop="toggleRecording">
                <span class="px-2 me-1 rounded-circle" t-att-class="state.recording ? 'bg-danger': 'bg-secondary'" role="status" aria-hidden="true"/>
                Record
                <span class="fst-italic fw-lighter" t-if="state.editedElement"> (recording keyboard)</span>
            </button>
            <Dropdown position="'top-end'">
                <button class="o_button_steps btn btn-primary rounded-0">
                    Steps <span class="badge rounded-pill bg-danger"><t t-esc="state.steps.length"/></span>
                </button>
                <t t-set-slot="content">
                    <div class="o_tour_recorder p-2">
                        <h4>Steps:</h4>
                        <table class="table table-striped">
                            <thead>
                                <tr>
                                    <td>n°</td>
                                    <td>trigger</td>
                                    <td/>
                                </tr>
                            </thead>
                            <tbody>
                                <t t-foreach="state.steps" t-as="step" t-key="step_index">
                                    <tr class="o_tour_step" t-att-class="step.triggerNotUnique ? 'text-danger' : ''">
                                        <td><t t-esc="step_index + 1"/>.</td>
                                        <td class="o_tour_step_trigger">
                                            <t t-esc="step.trigger"/>
                                            <span t-if="step.run and step.run != 'click'" class="fst-italic fw-lighter"><br/>(run: <t t-esc="step.run"/>) </span>
                                        </td>
                                        <td><button class="o_button_delete_step btn btn-link text-danger fa fa-trash mx-1" t-on-click.prevent.stop="() =&gt; state.steps.splice(step_index, 1)"/></td>
                                    </tr>
                                </t>
                            </tbody>
                        </table>
                    </div>
                </t>
            </Dropdown>
            <Dropdown t-if="state.steps.length" position="'top-end'">
                <button class="o_button_save btn btn-primary px-1 rounded-0">
                    <i class="fa fa-floppy-o"/>
                </button>
                <t t-set-slot="content">
                    <div class="o_tour_recorder p-1" style="min-width: 30vw;">
                        <form class="p-1" t-on-submit.prevent="saveTour">
                            <label for="name" class="o_form_label my-1">Name:</label><br/>
                            <input t-att-value="state.tourName" t-on-change="(ev) =&gt; state.tourName = ev.target.value" class="o_input" placeholder="name_of_the_tour" type="text" name="name"/>
                            <label for="url" class="o_form_label my-1">Url:</label><br/>
                            <input t-att-value="state.url" t-on-change="(ev) =&gt; state.url = ev.target.value" class="o_input" type="text" name="url"/>
                            <button class="o_button_save_confirm btn btn-primary mt-3">Save</button>
                        </form>
                    </div>
                </t>
            </Dropdown>
            <button t-if="state.steps.length" class="btn btn-primary px-1" t-on-click="resetTourRecorderState"><i class="fa fa-undo"/></button>
            <button class="btn btn-primary position-absolute bottom-0 start-100 rounded-0 border-1 o_tour_recorder_close_button" t-on-click.prevent.stop="() =&gt; props.onClose()"><i class="fa fa-close"/></button>
        </div>
    </div>
</t>
`);
registerTemplate("web_tour.TourListController.Buttons", `/web_tour/static/src/views/tour_controller.xml`, `<t t-name="web_tour.TourListController.Buttons" t-inherit="web.ListView.Buttons" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="." position="inside">
            <button class="btn btn-primary me-1 o_button_tour_recorder" title="Record Tour" t-on-click="() =&gt; this.env.services.tour_service.startTourRecorder()">
                Record
            </button>
        </xpath>
    </t>
`);
registerTemplate("web_tour.TourStartWidget", `/web_tour/static/src/widgets/tour_start.xml`, `<t t-name="web_tour.TourStartWidget" xml:space="preserve">
        <button title="Start Tour" t-on-click.prevent.stop="_onStartTour" t-att-class="'o_start_tour btn ' + (this.props.link ? 'btn-link py-0' : 'btn-primary')">
            Onboarding
        </button>
        <button title="Test Tour" t-on-click.prevent.stop="_onTestTour" t-att-class="'o_test_tour btn ' + (this.props.link ? 'btn-link py-0' : 'btn-primary ms-1')">
            Testing
        </button>
    </t>
`);
registerTemplate("html_editor.HistoryDialog", `/html_editor/static/src/components/history_dialog/history_dialog.xml`, `<t t-name="html_editor.HistoryDialog" xml:space="preserve">
        <Dialog size="size" title="title" contentClass="'h-100'">
            <div class="dialog-container html-history-dialog">
                <div class="revision-list d-flex flex-column align-content-stretch">
                    <t t-if="!state.revisionsData.length">
                        <div class="text-center w-100 pb-2 pt-0 px-0 fw-bolder">No history</div>
                    </t>

                    <t t-foreach="state.revisionsData" t-as="rev" t-key="rev.revision_id">
                        <a type="object" href="#" role="button" t-attf-class="btn btn-outline-primary #{state.revisionId === rev.revision_id ? 'active' : ''}" t-on-click="() =&gt; this.updateCurrentRevision(rev.revision_id )">
                            <strong><t t-esc="this.getRevisionDate(rev)"/></strong>
                            <br/>
                            <small><t t-esc="rev.create_user_name"/></small>
                        </a>
                    </t>
                </div>
                <div class="history-container">
                    <Notebook defaultPage="'history'">
                        <t t-set-slot="history" name="'history'" isVisible="true" title="notebookTabs[0]">
                            <t t-if="state.revisionContent?.length">
                                <div class="pe-none">
                                    <HtmlViewer config="getConfig('revisionContent')"/>
                                </div>
                            </t>
                            <t t-else="" t-out="props.noContentHelper"/>
                        </t>
                        <t t-set-slot="comparison" name="'comparison'" isVisible="true" title="notebookTabs[1]">
                            <div class="pe-none">
                                <HtmlViewer config="getConfig('revisionComparison')"/>
                            </div>
                        </t>
                    </Notebook>
                </div>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="_onRestoreRevisionClick">Restore history</button>
                <button class="btn btn-secondary" t-on-click="props.close">Discard</button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("html_editor.HtmlField", `/html_editor/static/src/fields/html_field.xml`, `<t t-name="html_editor.HtmlField" xml:space="preserve">
        <t t-if="this.displayReadonly">
            <HtmlViewer config="getReadonlyConfig()"/>
        </t>
        <div t-else="" class="h-100" t-att-class="{'o_show_codeview': state.showCodeView, 'o_field_translate': isTranslatable}">
            <t t-if="state.showCodeView">
                <textarea t-ref="codeView" class="o_codeview" t-att-value="this.value" t-on-change="onChange"/>
            </t>
            <t t-if="!this.sandboxedPreview">
                <Wysiwyg config="this.getConfig()" onLoad.bind="onEditorLoad" contentClass="\`note-editable \${this.state.showCodeView ? 'd-none' : ''}\`" onBlur.bind="onBlur" t-key="wysiwygKey"/>
            </t>
            <t t-if="isTranslatable">
                <TranslationButton fieldName="props.name" record="props.record"/>
            </t>
        </div>
        <div t-if="state.showCodeView || (sandboxedPreview and !props.readonly)" t-ref="codeViewButton" id="codeview-btn-group" class="btn-group" t-on-click="toggleCodeView">
            <button class="o_codeview_btn btn btn-primary">
                <i class="fa fa-code"/>
            </button>
        </div>
    </t>
`);
registerTemplate("html_editor.HtmlViewer", `/html_editor/static/src/fields/html_viewer.xml`, `<t t-name="html_editor.HtmlViewer" xml:space="preserve">
        <t t-if="this.showIframe">
            <iframe t-ref="iframe" t-att-class="{'d-none': !this.state.iframeVisible, 'o_readonly': true}" t-att-sandbox="props.config.hasFullHtml ? 'allow-same-origin allow-popups allow-popups-to-escape-sandbox' : false"/>
        </t>
        <t t-else="">
            <div t-ref="readonlyContent" class="o_readonly" t-out="state.value"/>
        </t>
    </t>
`);
registerTemplate("html_editor.LocalOverlayContainer", `/html_editor/static/src/local_overlay_container.xml`, `<t t-name="html_editor.LocalOverlayContainer" xml:space="preserve">
        <div class="o-wysiwyg-local-overlay position-relative h-0 w-0" t-ref="localOverlay"/>
        <div class="o-wysiwyg-local-overlay position-relative h-0 w-0">
            <t t-foreach="Components.entries" t-as="C" t-key="C[0]">
                <div class="oe-local-overlay" t-att-data-oe-local-overlay-id="C[0]">
                    <ErrorHandler onError="error =&gt; this.handleComponentError(error, C)">
                        <t t-component="C[1].Component" t-props="C[1].props"/>
                    </ErrorHandler>
                </div>
            </t>
        </div>
    </t>
`);
registerTemplate("html_editor.ChatGPTAlternativesDialog", `/html_editor/static/src/main/chatgpt/chatgpt_alternatives_dialog.xml`, `<t t-name="html_editor.ChatGPTAlternativesDialog" xml:space="preserve">
    <Dialog size="'lg'" title.translate="AI Copywriter" t-on-mousedown="preventDialogMousedown">
        <div class="md-8">
            <div class="mb-3">
                <t t-foreach="Object.entries(props.alternativesModes)" t-as="alternative" t-key="alternative_index">
                    <button type="button" class="btn me-2 btn-sm btn-info" t-att-class="state.alternativesMode == alternative[0] and state.messagesInProgress ? 'btn-success' : 'btn-info'" t-on-click="switchAlternativesMode" t-att-data-mode="alternative[0]">
                        <t t-out="alternative[1]"/>
                    </button>
                </t>
            </div>
            <div class="list-group">
                <div t-if="state.messagesInProgress" class="d-flex align" t-att-class="{ 'mb-3': state.messages.length }">
                    <img src="/web/static/img/spin.svg" alt="Loading..." class="me-2" style="filter:invert(1); opacity: 0.5; width: 30px; height: 30px;"/>
                    <p class="m-0 text-muted align-self-center">
                        <em t-if="state.messagesInProgress == 1">Generating an alternative...</em>
                        <em t-else="">Generating <t t-out="state.messagesInProgress"/> alternatives...</em>
                    </p>
                </div>
                <t t-foreach="[...state.messages].reverse()" t-as="message" t-key="message.id">
                    <t t-if="message.isError">
                        <div class="list-group-item o-chatgpt-alternative border-danger bg-danger o-message-error" t-att-class="{ 'text-muted': state.currentBatchId != message.batchId }">
                            <t t-out="message.text"/>
                        </div>
                    </t>
                    <t t-else="">
                        <button type="button" class="list-group-item list-group-item-action o-chatgpt-alternative" t-on-click="selectMessage" t-att-data-message-id="message.id" t-att-class="{                                 active: state.selectedMessageId == message.id,                                 'text-muted': state.selectedMessageId != message.id and state.currentBatchId != message.batchId,                             }">
                            <span t-if="message.mode" class="badge bg-secondary float-end"><t t-out="props.alternativesModes[message.mode]"/></span>
                            <t t-out="formatContent(message.text)"/>
                        </button>
                    </t>
                </t>
            </div>
        </div>


        <t t-set-slot="footer">
            <button class="btn btn-primary" t-on-click="_confirm" t-att-disabled="typeof state.selectedMessageId !== 'number'">Insert</button>
            <button class="btn btn-secondary" t-on-click="_cancel">Cancel</button>
        </t>
    </Dialog>
</t>
`);
registerTemplate("html_editor.ChatGPTPromptDialog", `/html_editor/static/src/main/chatgpt/chatgpt_prompt_dialog.xml`, `<t t-name="html_editor.ChatGPTPromptDialog" xml:space="preserve">
    <Dialog size="'lg'" title.translate="Generate Text with AI" modalRef="modalRef">
        <div t-foreach="state.messages" t-as="message" t-key="message_index" class="position-relative py-1 px-3" t-att-class="message_index ? 'mt-2' : 'mt-0'">
            <div class="position-relative d-flex flex-shrink-0">
                <div class="d-flex flex-shrink-0" style="flex-basis: 42px; max-width: 42px;">
                    <div class="position-relative bg-view" style="width: 36px; height: 36px;">
                        <img class="w-100 h-100 rounded" t-att-src="message.author === 'user' ? userAvatarUrl : assistantAvatarUrl"/>
                    </div>
                </div>
                <div class="w-100 o-min-width-0">
                    <div class="d-flex flex-wrap align-items-baseline mb-1 lh-1">
                        <strong class="me-1 text-truncate"><t t-esc="message.author === 'user' ? 'You' : 'OdooBot'"/></strong>
                    </div>
                    <div class="position-relative d-flex">
                        <div class="o-min-width-0">
                            <div class="position-relative d-flex">
                                <div class="position-relative overflow-x-auto d-inline-block">
                                    <div class="rounded-bottom-3 position-absolute top-0 start-0 w-100 h-100 border opacity-25" t-att-class="{                                             'border-success bg-success-light': message.author === 'user' and message.isError !== true,                                             'border-info bg-info-light': message.author === 'assistant' and message.isError !== true,                                             'border-danger bg-danger': message.isError,                                         }"/>
                                    <div class="position-relative text-break mb-0 py-2 px-3 align-self-start rounded-end-3 rounded-bottom-3 o-chatgpt-message">

                                        <button t-if="message.author === 'assistant' and 'text' in message and message.isError !== true" t-att-data-message-id="message.id" class="o-message-insert d-block float-end p-1 mb-1 btn btn-info opacity-75 fst-italic ms-3" t-on-click="insertMessage">Insert</button>
                                        <div class="d-inline">

                                            <div t-if="message.author === 'assistant' and !('text' in message)" class="d-flex align">
                                                <img src="/web/static/img/spin.svg" alt="Loading..." class="me-2" style="filter:invert(1); opacity: 0.5; width: 30px; height: 30px;"/>
                                                <p class="m-0 text-muted align-self-center">
                                                    <em>Thinking...</em>
                                                </p>
                                            </div>

                                            <div t-elif="message.isError" class="o-message-error">
                                                <t t-out="message.text"/>
                                            </div>
                                            <t t-else="">
                                                <t t-out="formatContent(message.text)"/>
                                            </t>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div t-if="!state.messages.length" style="min-height: 150px;"/> 


        <t t-set-slot="footer">
            <div class="md-8 mb-8 d-flex bg-view flex-grow-1 border rounded-3">
                <div class="o-prompt-input position-relative flex-grow-1">
                    <textarea type="text" id="promptInput" t-ref="promptInput" name="promptInput" t-on-keydown="onTextareaKeydown" class="form-control bg-view px-3 border-0 overflow-auto" placeholder="Send a message" autocomplete="off" t-model="state.prompt" required="required"/>
                </div>
                <div class="border-start-0 rounded-0 rounded-end-3 align-self-center ms-2 me-3">
                    <button class="btn" t-att-class="state.prompt.trim().length ? 'btn-success' : 'disabled'" t-on-click="submitPrompt">
                        <i class="fa fa-paper-plane"/>
                    </button>
                </div>
            </div>
        </t>
    </Dialog>
</t>
`);
registerTemplate("html_editor.ChatGPTTranslateDialog", `/html_editor/static/src/main/chatgpt/chatgpt_translate_dialog.xml`, `<t t-name="html_editor.ChatGPTTranslateDialog" xml:space="preserve">
    <Dialog size="'lg'" title.translate="Translate with AI">
        <div t-if="state.translationInProgress" class="d-flex">
            <img src="/web/static/img/spin.svg" alt="Loading..." class="me-2" style="filter:invert(1); opacity: 0.5; width: 30px; height: 30px;"/>
            <p class="m-0 text-muted align-self-center">
                <em>Translating...</em>
            </p>
        </div>
        <t t-else="">
            <t t-set="message" t-value="state.messages[0]"/>
            <div t-att-data-message-id="message.id" t-att-class="message.isError ? 'o-message-error border-danger bg-danger p-2' : ''" class="o-chatgpt-translated">
                <t t-out="formatContent(message.text)"/>
            </div>
        </t>


        <t t-set-slot="footer">
            <button class="btn btn-primary" t-on-click="_confirm" t-att-disabled="state.translationInProgress || state.messages[0].isError">Insert</button>
            <button class="btn btn-secondary" t-on-click="_cancel">Cancel</button>
        </t>
    </Dialog>
</t>
`);
registerTemplate("html_editor.LanguageSelector", `/html_editor/static/src/main/chatgpt/language_selector.xml`, `<t t-name="html_editor.LanguageSelector" xml:space="preserve">
        <button t-if="state.languages.length === 1" class="btn btn-light px-1" name="translate" t-att-title="props.title" t-on-click="() =&gt; this.onSelected(state.languages[0][1])" t-att-disabled="props.isDisabled()">
                Translate
        </button>
        <Dropdown t-elif="state.languages.length &gt; 1">
            <button class="btn btn-light" name="translate" t-att-title="props.title" t-att-disabled="props.isDisabled()">
                Translate
            </button>
            <t t-set-slot="content">
                <t t-foreach="state.languages" t-as="language" t-key="language[0]">
                    <DropdownItem class="'user-select-none'" onSelected="() =&gt; this.onSelected(language[1])">
                        <div class="lang" t-esc="language[1]"/>
                    </DropdownItem>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("html_editor.ColorSelector", `/html_editor/static/src/main/font/color_selector.xml`, `<t t-name="html_editor.ColorSelector" xml:space="preserve">
        <Dropdown state="dropdown">
            <button class="btn btn-light" t-attf-class="o-select-color-{{props.type}} {{dropdown.isOpen ? 'active' : ''}}" t-att-title="props.title">
                <t t-if="mode === 'color'">
                    <i class="fa fa-fw fa-font py-1" t-att-style="this.getSelectedColorStyle()"/>
                </t>
                <t t-else="">
                    <i class="fa fa-fw fa-paint-brush py-1" t-att-style="this.getSelectedColorStyle()"/>
                </t>
            </button>
            <t t-set-slot="content">
                <div class="o_font_color_selector user-select-none" t-on-pointerdown.stop="() =&gt; {}" data-prevent-closing-overlay="true">
                    <div class="mb-1 d-flex">
                        <button class="btn btn-sm btn-light ms-1" t-att-class="{active: state.activeTab === 'solid'}" t-on-click="() =&gt; this.setTab('solid')">
                            Solid
                        </button> 
                        <button class="btn btn-sm btn-light" t-att-class="{active: state.activeTab === 'custom'}" t-on-click="() =&gt; this.setTab('custom')">
                            Custom
                        </button> 
                        <button class="btn btn-sm btn-light" t-att-class="{active: state.activeTab === 'gradient'}" t-on-click="() =&gt; this.setTab('gradient')">
                            Gradient
                        </button> 
                        <button class="btn btn-sm btn-light fa fa-trash me-1" title="Reset" t-on-click="onColorApply" t-on-mouseover="onColorHover" t-on-mouseout="onColorHoverOut"/>
                    </div>
                    <div t-ref="colorsWrapper">
                        <t t-if="state.activeTab==='solid'">
                            <div class="p-1" t-on-click="onColorApply" t-on-mouseover="onColorHover" t-on-mouseout="onColorHoverOut">
                                <div class="o_colorpicker_section">
                                    <button data-color="o-color-1" t-attf-style="background-color: var(--o-color-1)" class="btn o_color_button"/>
                                    <button data-color="o-color-3" t-attf-style="background-color: var(--o-color-3)" class="btn o_color_button"/>
                                    <button data-color="o-color-2" t-attf-style="background-color: var(--o-color-2)" class="btn o_color_button"/>
                                    <button data-color="o-color-4" t-attf-style="background-color: var(--o-color-4)" class="ms-2 btn o_color_button"/>
                                    <button data-color="o-color-5" t-attf-style="background-color: var(--o-color-5)" class="btn o_color_button"/>
                                </div>

                                <t t-foreach="DEFAULT_COLORS" t-as="line" t-key="line_index">
                                    <div class="o_color_section d-flex">
                                        <t t-foreach="line" t-as="color" t-key="color_index">
                                            <button class="o_color_button btn" t-att-class="{'selected': color === this.currentCustomColor.color?.toUpperCase()}" t-att-data-color="color" t-attf-style="background-color: {{color}}"/>
                                        </t>
                                    </div>
                                </t>
                            </div>
                        </t>
                        <t t-if="state.activeTab==='custom'">
                            <div class="p-1">
                                <div class="o_colorpicker_section" t-on-click="onColorApply" t-on-mouseover="onColorHover" t-on-mouseout="onColorHoverOut">
                                    <t t-foreach="this.usedCustomColors" t-as="color" t-key="color_index">
                                        <button t-if="color !== this.currentCustomColor.color.toLowerCase()" class="o_color_button btn" t-att-data-color="color" t-attf-style="background-color: {{color}}"/>
                                    </t>
                                    <button class="o_color_button btn selected" t-att-data-color="this.currentCustomColor.color" t-attf-style="background-color: {{this.currentCustomColor.color}}"/>
                                </div>
                                <div class="o_colorpicker_section" t-on-click="onColorApply" t-on-mouseover="onColorHover" t-on-mouseout="onColorHoverOut">
                                    <button data-color="black" class="btn o_color_button bg-black"/>
                                    <button data-color="900" class="o_color_button btn" style="background-color: var(--900)"/>
                                    <button data-color="800" class="o_color_button btn" style="background-color: var(--800)"/>
                                    <button data-color="600" class="o_color_button btn" style="background-color: var(--600)"/>
                                    <button data-color="400" class="o_color_button btn" style="background-color: var(--400)"/>
                                    <button data-color="200" class="o_color_button btn" style="background-color: var(--200)"/>
                                    <button data-color="100" class="o_color_button btn" style="background-color: var(--100)"/>
                                    <button data-color="white" class="o_color_button btn bg-white"/>
                                </div>
                                <Colorpicker defaultColor="this.defaultColor" onColorSelect.bind="(color) =&gt; this.applyColor(color.cssColor)" onColorPreview.bind="onColorPreview"/>
                            </div>
                        </t>
                        <t t-if="state.activeTab==='gradient'">
                            <div class="o_colorpicker_sections p-2" t-on-click="onColorApply" t-on-mouseover="onColorHover" t-on-mouseout="onColorHoverOut">
                                <t t-foreach="this.DEFAULT_GRADIENT_COLORS" t-as="gradient" t-key="gradient">
                                    <button class="w-50 m-0 o_color_button btn" t-attf-style="background-image: #{gradient};" t-att-data-color="gradient"/>
                                </t>
                            </div>
                            <div class="px-2">
                                <button t-attf-style="background-image: {{ getCurrentGradientColor() }};" class="w-50 border btn" title="Define a custom gradient">Custom</button>
                                <GradientPicker onGradientChange.bind="applyColor" selectedGradient="getCurrentGradientColor()"/>
                            </div>
                        </t>
                    </div>
                </div>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("html_editor.FontSelector", `/html_editor/static/src/main/font/font_selector.xml`, `<t t-name="html_editor.FontSelector" xml:space="preserve">
        <Dropdown menuClass="'o_font_selector_menu'">
            <button class="btn btn-light" t-att-title="props.title">
                <span class="px-1" t-esc="state.displayName"/>
            </button>
            <t t-set-slot="content">
                <t t-foreach="items" t-as="item" t-key="item_index">
                    <DropdownItem onSelected="() =&gt; this.onSelected(item)" t-on-pointerdown.prevent="() =&gt; {}">
                        <t t-esc="item.name"/>
                    </DropdownItem>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("html_editor.FontSizeSelector", `/html_editor/static/src/main/font/font_size_selector.xml`, `<t t-name="html_editor.FontSizeSelector" xml:space="preserve">
        <Dropdown state="dropdown" menuClass="'o_font_size_selector_menu'">
            <button class="btn btn-light" t-att-title="props.title">
                <iframe t-ref="iframeContent" style="width: 4ch; height:100%;"/>
            </button>
            <t t-set-slot="content">
                <t t-foreach="items" t-as="item" t-key="item_index">
                    <DropdownItem onSelected="() =&gt; this.onSelected(item)" t-on-pointerdown.prevent="() =&gt; {}">
                        <t t-esc="item.name"/>
                    </DropdownItem>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("html_editor.GradientPicker", `/html_editor/static/src/main/font/gradient_picker.xml`, `<t t-name="html_editor.GradientPicker" xml:space="preserve">
        <div class="d-flex flex-column">

            <div class="align-items-center d-flex justify-content-between my-2 o_type_row">
                Type
                <span class="d-flex justify-content-between">
                    <button t-attf-class="btn btn-sm btn-light {{ this.state.type === 'linear' ? 'active' : ''}}" t-on-click="() =&gt; this.selectType('linear')"> Linear </button>
                    <button t-attf-class="btn btn-sm btn-light {{ this.state.type === 'radial' ? 'active' : ''}}" t-on-click="() =&gt; this.selectType('radial')"> Radial </button>
                </span>
            </div>

            <div t-if="this.state.type === 'linear'" class="d-flex align-items-center justify-content-between">
                Angle
                <span class="d-flex justify-content-between">
                    <input name="angle" type="text" t-att-value="this.state.angle" t-on-change="onAngleChange" style="width: 5ch"/>
                    <span class="input-group-text">deg</span>
                </span>
            </div>
            <div t-else="">
                <div class="d-flex align-items-center justify-content-between">
                    Position X
                    <span class="d-flex justify-content-between">
                        <input name="positionX" t-att-value="this.positions['x']" t-on-change="(ev) =&gt; this.onPositionChange('x', ev)" class="input" type="text" style="width: 5ch"/>
                    </span>
                </div>
                <div class="d-flex align-items-center justify-content-between">
                    Position Y
                    <span class="d-flex justify-content-between">
                        <input name="positionY" t-att-value="this.positions['y']" t-on-change="(ev) =&gt; this.onPositionChange('y', ev)" class="input" type="text" style="width: 5ch"/>
                    </span>
                </div>
                <div class="d-flex align-items-center justify-content-between">
                    Size
                    <span class="d-flex justify-content-between">
                        <button t-on-click="() =&gt; this.onSizeChange('closest-side')" t-attf-class="btn btn-light p-0 {{ this.state.size === 'closest-side' ? \`active\` : ''}}" title="Extend to the closest side">
                            <svg xmlns="http://www.w3.org/2000/svg" width="16" height="20" viewBox="0 0 16 20" fill="none">
                                <rect x="1.5" y="3.5" width="13" height="13" stroke="#AAAAAD"/>
                                <path d="M3 4H9V8C9 8.55228 8.55228 9 8 9H4C3.44772 9 3 8.55228 3 8V4Z" fill="#8C8C92"/>
                                <path d="M6 11C7.65685 11 9 9.65685 9 8C9 6.34315 7.65685 5 6 5C4.34315 5 3 6.34315 3 8C3 9.65685 4.34315 11 6 11Z" fill="#74747B"/>
                                <path d="M6 10C7.10457 10 8 9.10457 8 8C8 6.89543 7.10457 6 6 6C4.89543 6 4 6.89543 4 8C4 9.10457 4.89543 10 6 10Z" fill="white"/>
                                <rect x="2" y="3" width="12" height="1" fill="white"/>
                            </svg>
                        </button>
                        <button t-on-click="() =&gt; this.onSizeChange('closest-corner')" t-attf-class="btn btn-light p-0 {{ this.state.size === 'closest-corner' ? \`active\` : ''}}" title="Extend to the closest corner">
                            <svg xmlns="http://www.w3.org/2000/svg" width="16" height="20" viewBox="0 0 16 20" fill="none">
                                <rect x="1.5" y="3.5" width="13" height="13" stroke="#AAAAAD"/>
                                <path d="M2 4H9V7C9 9.20914 7.20914 11 5 11H2V4Z" fill="#8C8C92"/>
                                <path d="M6 11C7.65685 11 9 9.65685 9 8C9 6.34315 7.65685 5 6 5C4.34315 5 3 6.34315 3 8C3 9.65685 4.34315 11 6 11Z" fill="#74747B"/>
                                <path d="M6 10C7.10457 10 8 9.10457 8 8C8 6.89543 7.10457 6 6 6C4.89543 6 4 6.89543 4 8C4 9.10457 4.89543 10 6 10Z" fill="white"/>
                                <rect x="1" y="3" width="8" height="1" fill="white"/>
                                <rect x="1" y="11" width="8" height="1" transform="rotate(-90 1 11)" fill="white"/>
                            </svg>
                        </button>
                        <button t-on-click="() =&gt; this.onSizeChange('farthest-side')" t-attf-class="btn btn-light p-0 {{ this.state.size === 'farthest-side' ? \`active\` : ''}}" title="Extend to the farthest side">
                            <svg xmlns="http://www.w3.org/2000/svg" width="16" height="20" viewBox="0 0 16 20" fill="none">
                                <rect x="1.5" y="3.5" width="13" height="13" stroke="#AAAAAD"/>
                                <path d="M7 12C10.3137 12 14 10.2091 14 8C14 5.79086 10.3137 4 7 4C3.68629 4 2 5.79086 2 8C2 10.2091 3.68629 12 7 12Z" fill="#8C8C92"/>
                                <path d="M6 11C7.65685 11 9 9.65685 9 8C9 6.34315 7.65685 5 6 5C4.34315 5 3 6.34315 3 8C3 9.65685 4.34315 11 6 11Z" fill="#74747B"/>
                                <path d="M6 10C7.10457 10 8 9.10457 8 8C8 6.89543 7.10457 6 6 6C4.89543 6 4 6.89543 4 8C4 9.10457 4.89543 10 6 10Z" fill="white"/>
                                <rect x="14" y="4" width="1" height="12" fill="white"/>
                            </svg>
                        </button>
                        <button t-on-click="() =&gt; this.onSizeChange('farthest-corner')" t-attf-class="btn btn-light p-0 {{ this.state.size === 'farthest-corner' ? \`active\`: ''}}" title="Extend to the farthest corner">
                            <svg xmlns="http://www.w3.org/2000/svg" width="16" height="20" viewBox="0 0 16 20" fill="none">
                                <rect x="1.5" y="3.5" width="13" height="13" stroke="#AAAAAD"/>
                                <path d="M2 4H14V10C14 13.3137 11.3137 16 8 16H2V4Z" fill="#8C8C92"/>
                                <path d="M6 11C7.65685 11 9 9.65685 9 8C9 6.34315 7.65685 5 6 5C4.34315 5 3 6.34315 3 8C3 9.65685 4.34315 11 6 11Z" fill="#74747B"/>
                                <path d="M6 10C7.10457 10 8 9.10457 8 8C8 6.89543 7.10457 6 6 6C4.89543 6 4 6.89543 4 8C4 9.10457 4.89543 10 6 10Z" fill="white"/>
                                <rect x="15" y="17" width="7" height="0.999999" transform="rotate(-180 15 17)" fill="white"/>
                                <rect x="15" y="10" width="7" height="1" transform="rotate(90 15 10)" fill="white"/>
                            </svg>
                        </button>
                    </span>
                </div>
            </div>

            <div>
                First color %
                <span class="d-flex justify-content-between">
                    <input name="firstColorPercentage" t-att-value="this.colors[0].percentage" t-on-click="() =&gt; this.state.currentColorIndex = 0" t-on-change="(ev) =&gt; this.onColorPercentageChange(0, ev)" class="w-100 form-range" type="range" min="0" max="100"/>
                </span>
                Second color %
                <span class="d-flex justify-content-between">
                    <input name="secondColorPercentage" t-att-value="this.colors[1].percentage" t-on-click="() =&gt; this.state.currentColorIndex = 1 " t-on-change="(ev) =&gt; this.onColorPercentageChange(1, ev)" class="w-100 form-range" type="range" min="0" max="100"/>
                </span>
            </div>

            <Colorpicker onColorSelect.bind="onColorChange" onColorPreview.bind="onColorChange" defaultColor="this.colors[this.state.currentColorIndex].hex" selectedColor="this.colors[this.state.currentColorIndex].hex"/>
        </div>
    </t>
`);
registerTemplate("html_editor.linkPopover", `/html_editor/static/src/main/link/link_popover.xml`, `<t t-name="html_editor.linkPopover" xml:space="preserve">
        <div class="o-we-linkpopover d-flex bg-white overflow-auto shadow" t-on-keydown="onKeydown">
            <div t-if="state.editing" class="container-fluid d-flex vertical-center p-2" t-ref="editing-wrapper" data-prevent-closing-overlay="true">
                <div t-if="state.isImage" class="col p-2" style="max-width: 250px;">
                    <div class="input-group mb-1">
                        <input t-ref="url" class="o_we_href_input_link form-control form-control-sm" t-model="state.url" title="URL" placeholder="Type your URL" t-on-keydown="onKeydownEnter"/>
                        <button class="o_we_apply_link btn btn-sm btn-primary" t-att-class="{'mx-1': state.type ===  ''}" t-on-click="onClickApply">Apply</button>
                    </div>
                </div>
                <div t-else="" class="d-flex">
                    <div class="col p-2" style="max-width: 250px;">
                        <div class="input-group mb-1">
                            <input t-ref="label" class="o_we_label_link form-control form-control-sm" t-model="state.label" title="Label" placeholder="Type your link label"/>
                        </div>
                        <div class="input-group mb-1">
                            <input t-ref="url" class="o_we_href_input_link form-control form-control-sm" t-model="state.url" title="URL" placeholder="Type your URL" t-on-keydown="onKeydownEnter"/>
                            <span class="ms-1" t-if="props.canUpload and !state.url">
                                or <button class="btn btn-secondary btn-sm" t-on-click="uploadFile">Upload File</button>
                            </span>

                        </div>
                        <div class="input-group" t-on-change="onChangeClasses">
                            <select name="link_type" class="form-select form-select-sm" t-att-class="{'mb-1': state.type !==  ''}" t-on-change="(ev)=&gt;this.state.type = ev.target.value">
                                <t t-foreach="this.colorsData" t-as="colorData" t-key="colorData.type">
                                    <t t-if="colorData.type !== 'custom'">
                                        <option t-att-value="colorData.type" t-att-selected="state.type === colorData.type" t-attf-class="o_btn_preview">
                                            <span t-esc="colorData.label"/>
                                        </option>
                                    </t>
                                </t>
                            </select>
                            <div t-if="state.type !== 'custom' and state.type !==  ''" class="input-group mb-1">
                                    <select name="link_style_size" class="form-select form-select-sm link-style" t-on-change="(ev)=&gt;this.state.buttonSize = ev.target.value">
                                        <t t-foreach="this.buttonSizesData" t-as="buttonSizesData" t-key="buttonSizesData.size">
                                            <option t-att-value="buttonSizesData.size" t-att-selected="state.buttonSize === buttonSizesData.size">
                                                <span t-esc="buttonSizesData.label"/>
                                            </option>
                                        </t>
                                    </select>
                                    <select name="link_style_shape" class="form-select form-select-sm link-style ms-1" t-on-change="(ev)=&gt;this.state.buttonStyle = ev.target.value">
                                        <t t-foreach="this.buttonStylesData" t-as="buttonStylesData" t-key="buttonStylesData.style">
                                            <option t-att-value="buttonStylesData.style" t-att-selected="state.buttonStyle === buttonStylesData.style">
                                                <span t-esc="buttonStylesData.label"/>
                                            </option>
                                        </t>
                                    </select>
                            </div>
                            <button class="o_we_apply_link btn btn-sm btn-primary" t-att-class="{'ms-1': state.type ===  ''}" t-on-click="onClickApply">Apply</button>
                        </div>
                    </div>

                    <div t-if="!this.ui.isSmall and state.url" class="col o_link_dialog_preview" style="max-width: 125px;border-left: 1px solid var(--border-color);">
                        <div class="text-center p-2">
                            <label>Preview</label>
                            <div style="max-width: 100px; max-height: 200px;" class="text-truncate">
                                <a href="#" t-if="state.url" id="link-preview" aria-label="Preview" title="Preview" t-attf-class="{{state.classes}} text-truncate" style="max-width: 90px;">
                                    <t t-esc="state.label or state.url"/>
                                </a>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div t-else="" style="width: 260px;" data-prevent-closing-overlay="true">
                <div class="d-flex flex-column p-2">
                    <div class="d-flex">
                        <span class="o_we_preview_favicon" style="width: 16px; height: 32px">
                            <img t-if="state.previewIcon.type === 'imgSrc'" t-att-src="state.previewIcon.value" class="align-content-center"/>
                            <span t-elif="state.previewIcon.type === 'mimetype'" class="o_image" t-att-data-mimetype="state.previewIcon.value"/>
                            <i t-else="" t-attf-class="fa fa-fw {{state.previewIcon.value}}"/>
                        </span>
                        <div class="ms-1 w-100">
                            <div class="d-flex">
                                <a href="#" target="_blank" t-attf-href="{{state.url}}" class="o_we_url_link fw-bold flex-grow-1 text-truncate" style="max-width: 160px;" t-attf-title="{{state.urlTitle}}">
                                    <t t-esc="state.urlTitle"/>
                                </a>
                                <div class="flex-grow-1 d-flex justify-content-end">
                                    <a href="#" class="mx-1 o_we_copy_link text-dark" t-on-click="onClickCopy" title="Copy Link">
                                        <i class="fa fa-clone"/>
                                    </a>
                                    <t t-if="props.canEdit">
                                        <a href="#" class="mx-1 o_we_edit_link text-dark" t-on-click="onClickEdit" title="Edit Link">
                                            <i class="fa fa-edit"/>
                                        </a>
                                        <a href="#" class="ms-1 o_we_remove_link text-dark" t-on-click="onClickRemove" title="Remove Link">
                                            <i class="fa fa-chain-broken"/>
                                        </a>
                                    </t>
                                </div>
                            </div>
                            <div t-if="state.urlTitle and state.url and state.urlTitle !== state.url" class="text-truncate" style="max-width: 200px; font-size: 12px;">
                                <span t-attf-class="o_we_full_url text-muted o_we_webkit_box" t-attf-title="{{state.url}}">
                                    <t t-esc="state.url || 'No URL specified'"/>
                                </span>
                            </div>
                        </div>
                    </div>
                    <div t-if="state.imgSrc" class="o_extra_info_card" style="align-self: center; max-width: 235px">
                            <a href="#" target="_blank" t-attf-href="{{state.url}}" title="Open in a new tab">
                                <img t-att-src="state.imgSrc" class="img-fluid mb-1" style="max-width: 230; max-height: 100%;"/>
                            </a>
                    </div>
                    <div t-if="state.urlDescription" class="d-flex">
                        <i class="fa fa-align-right align-content-center"/>
                        <span class="ms-1 o_we_description_link_preview" style="display: -webkit-box; -webkit-box-orient: vertical; -webkit-line-clamp: 2; font-size: 12px;color: gray; overflow: hidden;" t-attf-title="{{state.urlDescription}}">
                            <t t-esc="state.urlDescription"/>
                        </span>
                    </div>
                </div>
                <div t-if="state.urlTitle and ((state.url === state.label and state.urlTitle !== state.label ) || (state.url === state.label+'/' and state.urlTitle !== state.label+'/'))" class="d-flex align-items-baseline" style="background-color: var(--primary);">
                    <i class="fa fa-magic fa-fw m-1" style="color: var(--o-cc1-btn-primary-text);"/>
                    <span class="me-2 flex-grow-1" style="color: var(--o-cc1-btn-primary-text);font-size: smaller;">Replace URL with its title?</span>
                    <button class=" btn btn-sm btn-primary o_we_replace_title_btn" style="margin: 1px;font-size: smaller;" t-on-click="onClickReplaceTitle">Yes</button>
                </div>
            </div>
        </div>
    </t>

`);
registerTemplate("html_editor.ImageCrop", `/html_editor/static/src/main/media/image_crop.xml`, `<t t-name="html_editor.ImageCrop" xml:space="preserve">
        <div t-name="html_editor.ImageCrop" class="o_we_crop_widget" contenteditable="false" t-ref="el" t-on-zoom="this.onCropZoom">
            <div class="o_we_cropper_wrapper" t-ref="cropperWrapper">
                <img class="o_we_cropper_img" t-ref="imageRef"/>
                <div class="o_we_crop_buttons text-center mt16 position-fixed o_we_no_overlay" contenteditable="false">
                    <div class="btn-group btn-group-toggle" title="Aspect Ratio" data-bs-toggle="buttons">
                        <t t-foreach="this.aspectRatios" t-as="ratio" t-key="ratio">
                            <t t-set="is_active" t-value="ratio === this.aspectRatio"/>
                            <label t-attf-class="btn #{is_active and 'active' or ''}" t-on-click="() =&gt; this.setAspectRatio(ratio)">
                                <input type="radio"/><t t-esc="ratio_value.label"/>
                            </label>
                        </t>
                    </div>
                    <div class="btn-group" role="group">
                        <button type="button" title="Zoom In" t-on-click="() =&gt; this.onZoom(0.1)"><i class="fa fa-fw fa-search-plus"/></button>
                        <button type="button" title="Zoom Out" t-on-click="() =&gt; this.onZoom(-0.1)"><i class="fa fa-fw fa-search-minus"/></button>
                    </div>
                    <div class="btn-group" role="group">
                        <button type="button" title="Rotate Left" t-on-click="() =&gt; this.onRotate(-90)"><i class="fa fa-fw fa-rotate-left"/></button>
                        <button type="button" title="Rotate Right" t-on-click="() =&gt; this.onRotate(90)"><i class="fa fa-fw fa-rotate-right"/></button>
                    </div>
                    <div class="btn-group" role="group">
                        <button type="button" title="Flip Horizontal" t-on-click="() =&gt; this.onFlip('scaleX')"><i class="oi oi-fw oi-arrows-h"/></button>
                        <button type="button" title="Flip Vertical" t-on-click="() =&gt; this.onFlip('scaleY')"><i class="oi oi-fw oi-arrows-v"/></button>
                    </div>
                    <div class="btn-group" role="group">
                        <button type="button" title="Reset Image" t-on-click="this.onReset"><i class="fa fa-refresh"/> Reset Image</button>
                    </div>
                    <div class="btn-group" role="group">
                        <button type="button" title="Apply" t-on-click="this.save" class="btn btn-primary"><i class="fa fa-check"/> Apply</button>
                        <button type="button" title="Discard" t-on-click="this.closeCropper" class="btn btn-danger"><i class="fa fa-times"/> Discard</button>
                    </div>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("html_editor.ImageDescription", `/html_editor/static/src/main/media/image_description.xml`, `<t t-name="html_editor.ImageDescription" xml:space="preserve">
        <button class="btn btn-light" t-att-title="props.title" t-on-click="openDescriptionDialog">
            Description
        </button>
    </t>

    `);
registerTemplate("html_editor.ImageDescriptionDialog", `/html_editor/static/src/main/media/image_description.xml`, `<t t-name="html_editor.ImageDescriptionDialog" xml:space="preserve">
        <Dialog size="'lg'" title.translate="Change media description and tooltip">
            <div class="mb-3 row">
                <label class="col-md-3 col-form-label" for="alt" title="'Alt tag' specifies an alternate text for an image, if the image cannot be displayed (slow connection, missing image, screen reader ...).">
                    Description <small>(ALT Tag)</small>
                </label>
                <div class="col-md-8">
                    <input t-model="this.state.description" name="description" class="form-control" required="required" type="text"/>
                </div>
            </div>
            <div class="mb-3 row">
                <label class="col-md-3 col-form-label" for="title" title="'Title tag' is shown as a tooltip when you hover the picture."> 
                    Tooltip <small>(TITLE Tag)</small>
                </label>
                <div class="col-md-8">
                    <input t-model="this.state.tooltip" name="tooltip" class="form-control" required="required" type="text"/>
                </div>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="this.onSave">Save</button>
                <button class="btn btn-secondary" t-on-click="this.props.close">Discard</button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("html_editor.ImagePadding", `/html_editor/static/src/main/media/image_padding.xml`, `<t t-name="html_editor.ImagePadding" xml:space="preserve">
        <Dropdown>
            <button t-att-title="props.title" class="btn btn-light fa fa-plus-square-o"> </button>
            <t t-set-slot="content">
                <t t-foreach="this.paddings" t-as="padding" t-key="padding">
                    <DropdownItem class="'user-select-none'" onSelected="() =&gt; this.onSelected(padding)">
                        <t t-esc="padding"/>
                    </DropdownItem>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("html_editor.ImageTransformButton", `/html_editor/static/src/main/media/image_transform_button.xml`, `<t t-name="html_editor.ImageTransformButton" xml:space="preserve">
        <button class="btn btn-light" t-att-class="{active: state.active}" t-att-title="props.title" t-on-click="onButtonClick">
            <span class="fa fa-fw" t-att-class="props.icon"/>
        </button>
    </t>
`);
registerTemplate("html_editor.ImageTransformation", `/html_editor/static/src/main/media/image_transformation.xml`, `<t t-name="html_editor.ImageTransformation" xml:space="preserve">
        <div class="transfo-container" t-ref="transfoContainer" t-on-mousedown.prevent="mouseDown">
            <div class="transfo-controls" t-ref="transfoControls">
                <div style="cursor: crosshair; position: absolute; margin: -30px; top: 0; right: 0; padding: 1px 0 0 1px;" class="transfo-rotator">
                    <span class="fa-stack fa-lg">
                    <i class="fa fa-circle fa-stack-2x"/>
                    <i class="fa fa-repeat fa-stack-1x fa-inverse"/>
                    </span>
                </div>
                <div style="top: 0%; left: 0%; cursor: nw-resize;" class="transfo-scaler transfo-scaler-tl"/>
                <div style="top: 0%; left: 100%; cursor: ne-resize;" class="transfo-scaler transfo-scaler-tr"/>
                <div style="top: 100%; left: 100%; cursor: se-resize;" class="transfo-scaler transfo-scaler-br"/>
                <div style="top: 100%; left: 0%; cursor: sw-resize;" class=" transfo-scaler transfo-scaler-bl"/>
                <div style="top: 0%; left: 50%; cursor: n-resize;" class="transfo-scaler transfo-scaler-tc"/>
                <div style="top: 100%; left: 50%; cursor: s-resize;" class="transfo-scaler transfo-scaler-bc"/>
                <div style="top: 50%; left: 0%; cursor: w-resize;" class="transfo-scaler transfo-scaler-ml"/>
                <div style="top: 50%; left: 100%; cursor: e-resize;" class="transfo-scaler transfo-scaler-mr"/>
                <div style="border: 0; width: 0px; height: 0px; top: 50%; left: 50%;" class="transfo-scaler transfo-scaler-mc" t-ref="transfoCenter"/>
            </div>
        </div>
    </t>
`);
registerTemplate("html_editor.DocumentAttachment", `/html_editor/static/src/main/media/media_dialog/document_selector.xml`, `<t t-name="html_editor.DocumentAttachment" xml:space="preserve">
    <div class="o_existing_attachment_cell o_we_attachment_highlight card col-2 position-relative mb-2 p-2 opacity-trigger-hover cursor-pointer" t-att-class="{ o_we_attachment_selected: props.selected }" t-on-click="props.selectAttachment">
        <RemoveButton remove="() =&gt; this.remove()"/>
        <div t-att-data-url="props.url" role="img" t-att-aria-label="props.name" t-att-title="props.name" t-att-data-mimetype="props.mimetype" class="o_image d-flex align-items-center justify-content-center"/>
        <small class="o_file_name d-block text-truncate" t-esc="props.name"/>
    </div>
</t>

`);
registerTemplate("html_editor.DocumentsListTemplate", `/html_editor/static/src/main/media/media_dialog/document_selector.xml`, `<t t-name="html_editor.DocumentsListTemplate" xml:space="preserve">
    <div class="o_we_existing_attachments o_we_documents" t-ref="existing-attachments">
        <div t-if="!hasContent" class="o_nocontent_help">
            <p class="o_empty_folder_image">No documents found.</p>
            <p class="o_empty_folder_subtitle">You can upload documents with the button located in the top left of the screen.</p>
        </div>
        <div t-else="" class="d-flex flex-wrap gap-2">
            <t t-foreach="state.attachments" t-as="attachment" t-key="attachment.id">
                <DocumentAttachment url="attachment.url" name="attachment.name" mimetype="attachment.mimetype" id="attachment.id" onRemoved="(attachmentId) =&gt; this.onRemoved(attachmentId)" selected="this.selectedAttachmentIds.includes(attachment.id)" selectAttachment="() =&gt; this.onClickDocument(attachment)"/>
            </t>
        </div>
    </div>
</t>
`);
registerTemplate("html_editor.FileSelectorControlPanel", `/html_editor/static/src/main/media/media_dialog/file_selector.xml`, `<t t-name="html_editor.FileSelectorControlPanel" xml:space="preserve">
    <div class="o_we_file_selector_control_panel sticky-top d-flex flex-wrap gap-2 mb-1 p-3 align-items-end">
        <SearchMedia searchPlaceholder="props.searchPlaceholder" needle="props.needle" search="props.search"/>
        <div class="d-flex gap-3 justify-content-start align-items-center">
            <div t-if="props.showOptimizedOption" class="flex-shrink-0 form-check form-switch align-items-center" t-on-change="props.changeShowOptimized">
                <input class="o_we_show_optimized form-check-input" type="checkbox" t-att-checked="props.showOptimized" id="o_we_show_optimized_switch"/>
                <label class="form-check-label" for="o_we_show_optimized_switch">
                    Show optimized images
                </label>
            </div>
            <select t-if="showSearchServiceSelect" class="o_input o_we_search_select form-select" t-on-change="ev =&gt; props.changeSearchService(ev.target.value)">
                <option t-att-selected="props.searchService === 'all'" value="all">All</option>
                <option t-att-selected="props.searchService === 'database'" value="database">My Images</option>
                <option t-if="props.useMediaLibrary" t-att-selected="props.searchService === 'media-library'" value="media-library">Illustrations</option>
            </select>
        </div>
        <div class="col justify-content-end flex-nowrap input-group has-validation">
            <input type="text" class="form-control o_input o_we_url_input o_we_transition_ease flex-grow-0" t-att-class="{ o_we_horizontal_collapse: !state.showUrlInput, 'w-auto': state.showUrlInput }" name="url" t-att-placeholder="props.urlPlaceholder" t-model="state.urlInput" t-on-input="onUrlInput" t-if="state.showUrlInput"/>
            <button type="button" class="btn o_upload_media_url_button text-nowrap" t-att-class="{ 'btn-primary': state.urlInput, 'btn-secondary': !state.urlInput}" t-on-click="onUrlUploadClick" t-att-disabled="!enableUrlUploadClick">
                    <t t-esc="props.addText"/>
            </button>
            <div class="d-flex align-items-center">
                <span t-if="state.urlInput and state.isValidatingUrl" class="o_we_url_loading mx-2 fa fa-lg fa-spinner" title="Loading..."/>
                <span t-elif="state.urlInput and state.isValidUrl and state.isValidFileFormat" class="o_we_url_success text-success mx-2 fa fa-lg fa-check" title="The URL seems valid."/>
                <span t-elif="state.urlInput and !state.isValidUrl" class="o_we_url_error text-danger mx-2 fa fa-lg fa-times" title="The URL does not seem to work."/>
                <span t-elif="props.urlWarningTitle and state.urlInput and state.isValidUrl and !state.isValidFileFormat" class="o_we_url_warning text-warning mx-2 fa fa-lg fa-warning" t-att-title="props.urlWarningTitle"/>
            </div>
        </div>
        <input type="file" class="d-none o_file_input" t-on-change="onChangeFileInput" t-ref="file-input" t-att-accept="props.accept" t-att-multiple="props.multiSelect and 'multiple'"/>
        <div class="col-auto btn-group">
            <button type="button" class="btn btn-primary o_upload_media_button" t-on-click="onClickUpload">
                <t t-esc="props.uploadText"/>
            </button>
        </div>
    </div>
</t>

`);
registerTemplate("html_editor.FileSelector", `/html_editor/static/src/main/media/media_dialog/file_selector.xml`, `<t t-name="html_editor.FileSelector" xml:space="preserve">
    <div>
        <FileSelectorControlPanel uploadText="uploadText" accept="fileMimetypes" urlPlaceholder="urlPlaceholder" addText="addText" searchPlaceholder="searchPlaceholder" urlWarningTitle="urlWarningTitle" uploadUrl="(url) =&gt; this.uploadUrl(url)" uploadFiles="(files) =&gt; this.uploadFiles(files)" showOptimizedOption="showOptimizedOption" showOptimized="state.showOptimized" changeShowOptimized="showOptimized =&gt; this.state.showOptimized = !this.state.showOptimized" changeSearchService="service =&gt; this.state.searchService = service" searchService="state.searchService" needle="state.needle" search="(needle) =&gt; this.handleSearch(needle)" useMediaLibrary="props.useMediaLibrary" validateUrl="validateUrl" multiSelect="props.multiSelect"/>
        <t t-call="{{ constructor.attachmentsListTemplate }}"/>
        <div name="load_more_attachments" class="pt-3 pb-1 text-center mx-auto o_we_load_more" t-ref="load-more-button">
            <button t-if="canLoadMore" class="btn btn-primary o_load_more" type="button" t-on-click="handleLoadMore">
                Load more...
            </button>
            <div t-elif="hasContent" class="mt-2 o_load_done_msg">
                <span><i t-esc="allLoadedText"/></span>
            </div>
        </div>
        <div t-if="this.state.canScrollAttachments" class="position-sticky d-flex align-items-center mx-auto btn btn-primary rounded-circle oi oi-chevron-down o_scroll_attachments" t-on-click="handleScrollAttachments"/>
    </div>
</t>
`);
registerTemplate("html_editor.IconSelector", `/html_editor/static/src/main/media/media_dialog/icon_selector.xml`, `<t t-name="html_editor.IconSelector" xml:space="preserve">
    <div>
        <div class="o_we_file_selector_control_panel sticky-top d-flex gap-2 align-items-center mb-1 py-4 px-3">
            <SearchMedia searchPlaceholder.translate="Search a pictogram" search.bind="this.search" needle="state.needle"/>
        </div>
        <div class="font-icons-icons">
            <t t-foreach="state.fonts" t-as="font" t-key="font.base">
                <div t-if="!font.icons.length" class="o_nocontent_help">
                    <p class="o_empty_folder_image">No pictograms found.</p>
                    <p class="o_empty_folder_subtitle">Try searching with other keywords.</p>
                </div>
                <span t-foreach="font.icons" t-as="icon" t-key="icon.id" t-att-title="icon.names[0]" t-att-aria-label="icon.names[0]" role="img" class="font-icons-icon m-2 fs-2 p-3 cursor-pointer text-center" t-att-class="{ o_we_attachment_selected: this.selectedMediaIds.includes(icon.id) }" t-attf-class="{{ font.base }} {{ icon.names[0] }}" t-on-click="() =&gt; this.onClickIcon(font, icon)"/>
            </t>
        </div>
    </div>
</t>
`);
registerTemplate("html_editor.AutoResizeImage", `/html_editor/static/src/main/media/media_dialog/image_selector.xml`, `<t t-name="html_editor.AutoResizeImage" xml:space="preserve">
    <div t-ref="auto-resize-image-container" class="o_existing_attachment_cell o_we_image align-items-center justify-content-center me-1 mb-1 opacity-trigger-hover opacity-0 cursor-pointer" t-att-class="{ o_we_attachment_optimized: props.isOptimized, 'o_loaded position-relative opacity-100': state.loaded, o_we_attachment_selected: props.selected, 'position-fixed': !state.loaded }" t-on-click="props.onImageClick">
        <RemoveButton t-if="props.isRemovable" model="props.model" remove="() =&gt; this.remove()"/>
        <div class="o_we_media_dialog_img_wrapper">
            <img t-ref="auto-resize-image" class="o_we_attachment_highlight img img-fluid w-100" t-att-src="props.src" t-att-alt="props.altDescription" t-att-title="props.title" loading="lazy"/>
            <a t-if="props.author" class="o_we_media_author position-absolute start-0 bottom-0 end-0 text-truncate text-center text-primary fs-6 bg-white-50" t-att-href="props.authorLink" target="_blank" t-esc="props.author"/>
        </div>
        <span t-if="props.isOptimized" class="badge position-absolute bottom-0 end-0 m-1 text-bg-success">Optimized</span>
    </div>
</t>

`);
registerTemplate("html_editor.ExternalImage", `/html_editor/static/src/main/media/media_dialog/image_selector.xml`, `<t t-name="html_editor.ExternalImage" xml:space="preserve">
    <t t-if="record.mediaType == 'libraryMedia'">
        <AutoResizeImage author="record.author" src="record.thumbnail_url" authorLink="record.author_link" title="record.tooltip" altDescription="record.tooltip" minRowHeight="MIN_ROW_HEIGHT" selected="this.selectedMediaIds.includes(record.id)" onImageClick="() =&gt; this.onClickMedia(record)" onLoaded="(imgEl) =&gt; this.onImageLoaded(imgEl, record)"/>
    </t>
</t>

`);
registerTemplate("html_editor.ImagesListTemplate", `/html_editor/static/src/main/media/media_dialog/image_selector.xml`, `<t t-name="html_editor.ImagesListTemplate" xml:space="preserve">
    <div class="o_we_existing_attachments o_we_images d-flex flex-wrap my-0" t-ref="existing-attachments">
        <t t-if="!hasContent and !isFetching">
            <div t-if="state.needle" class="o_nocontent_help">
                <p class="o_empty_folder_image">No images found.</p>
                <p class="o_empty_folder_subtitle">Wow, it feels a bit empty in here. Upload from the button in the top right corner!</p>
            </div>
            <div t-else="" class="o_we_search_prompt">
                <h2>Discover a world of awesomeness in our copyright-free image haven. No legal drama, just nice images!</h2>
            </div>
        </t>
        <t t-else="">
            <t t-if="['all', 'database'].includes(state.searchService)">
                <t t-foreach="state.attachments" t-as="attachment" t-key="attachment.id">
                    <AutoResizeImage t-if="!attachment.original_id or state.showOptimized" id="attachment.id" isOptimized="!!attachment.original_id" isRemovable="true" onRemoved="(attachmentId) =&gt; this.onRemoved(attachmentId)" selected="this.selectedAttachmentIds.includes(attachment.id)" src="attachment.thumbnail_src or attachment.image_src" name="attachment.name" title="attachment.name" altDescription="attachment.altDescription" model="attachment.res_model" minRowHeight="MIN_ROW_HEIGHT" onImageClick="() =&gt; this.onClickAttachment(attachment)" onLoaded="(imgEl) =&gt; this.onImageLoaded(imgEl, attachment)"/>
                </t>
            </t>
            <t id="o_we_media_library_images" t-if="['all', 'media-library'].includes(state.searchService)">
                <t t-foreach="state.libraryMedia" t-as="record" t-key="record.id">
                    <t t-call="html_editor.ExternalImage"/>
                </t>
            </t>

            <t t-foreach="[...Array(20).keys()]" t-as="i" t-key="i">
                <div class="o_we_attachment_placeholder"/>
            </t>
        </t>
    </div>
</t>
`);
registerTemplate("html_editor.MediaDialog", `/html_editor/static/src/main/media/media_dialog/media_dialog.xml`, `<t t-name="html_editor.MediaDialog" xml:space="preserve">
    <Dialog contentClass="contentClass" size="size" title="title" modalRef="modalRef">
        <Notebook pages="notebookPages" onPageUpdate.bind="onTabChange" defaultPage="state.activeTab"/>
        <t t-set-slot="footer">
            <button class="btn btn-primary" t-on-click="() =&gt; this.save()" t-ref="add-button">Add</button>
            <button class="btn btn-secondary" t-on-click="() =&gt; this.props.close()">Discard</button>
        </t>
    </Dialog>
</t>
`);
registerTemplate("html_editor.ProgressBar", `/html_editor/static/src/main/media/media_dialog/upload_progress_toast/upload_progress_toast.xml`, `<t t-name="html_editor.ProgressBar" xml:space="preserve">
    <small class="text-info d-flex align-items-center me-2">
        <span t-if="!props.hasError and !props.uploaded"><i class="fa fa-circle-o-notch fa-spin me-2"/></span>
        <span class="fst-italic fw-bold text-truncate flex-grow-1 me-2" t-esc="props.name"/>
        <span class="fw-bold text-nowrap" t-esc="props.size"/>
    </small>
    <small t-if="props.uploaded or props.hasError" class="d-flex align-items-center mt-1">
        <span t-if="props.uploaded" class="text-success"><i class="fa fa-check my-1 me-1"/> File has been uploaded</span>
        <span t-else="" class="text-danger"><i class="fa fa-times float-start my-1 me-1"/> <span class="o_we_error_text" t-esc="props.errorMessage ? props.errorMessage : 'File could not be saved'"/></span>
    </small>
    <div t-else="" class="progress mt-2">
        <div class="progress-bar bg-info progress-bar-striped progress-bar-animated" role="progressbar" t-attf-style="width: {{this.progress}}%;" aria-label="Progress bar"><span t-esc="this.progress + '%'"/></div>
    </div>
    <hr/>
</t>

`);
registerTemplate("html_editor.UploadProgressToast", `/html_editor/static/src/main/media/media_dialog/upload_progress_toast/upload_progress_toast.xml`, `<t t-name="html_editor.UploadProgressToast" xml:space="preserve">
    <div class="editor_notification_manager o_notification_manager o_upload_progress_toast">
        <div t-if="state.isVisible" class="o_notification position-relative show fade mb-2 border border-info bg-white d-flex justify-content-between" role="alert" aria-live="assertive" aria-atomic="true">
            <div class="editor_notification_body o_notification_body ps-2 py-2">
                <div class="me-auto o_notification_content">
                    <div t-foreach="state.files" t-as="file" t-key="file" class="o_we_progressbar">
                        <ProgressBar progress="file_value.progress" errorMessage="file_value.errorMessage" hasError="file_value.hasError" name="file_value.name" uploaded="file_value.uploaded" size="file_value.size"/>
                    </div>
                </div>
            </div>
            <button type="button" class="btn btn-close o_notification_close p-2" aria-label="Close" t-on-click="props.close"/>
        </div>
    </div>
</t>
`);
registerTemplate("html_editor.VideoOption", `/html_editor/static/src/main/media/media_dialog/video_selector.xml`, `<t t-name="html_editor.VideoOption" xml:space="preserve">
    <div class="mb-1">
        <label class="d-flex align-items-start gap-2 cursor-pointer" t-on-change="props.onChangeOption">
            <div class="o_switch flex-shrink-0">
                <input type="checkbox" t-att-checked="props.value"/>
                <span/>
            </div>
            <span t-esc="props.label"/>
            <span t-if="props.description" class="text-muted" t-esc="props.description"/>
        </label>
    </div>
</t>

`);
registerTemplate("html_editor.VideoIframe", `/html_editor/static/src/main/media/media_dialog/video_selector.xml`, `<t t-name="html_editor.VideoIframe" xml:space="preserve">
    <iframe t-att-src="this.props.src" class="o_video_dialog_iframe mw-100 mh-100 overflow-hidden shadow" width="1280" height="720" allowfullscreen="allowfullscreen" frameborder="0"/>
</t>

`);
registerTemplate("html_editor.VideoSelector", `/html_editor/static/src/main/media/media_dialog/video_selector.xml`, `<t t-name="html_editor.VideoSelector" xml:space="preserve">
    <div class="row">
        <div class="col mt-4 o_video_dialog_form">
            <div class="mb-2">
                <label for="o_video_text">
                    <b>Video code </b>(URL or Embed)
                </label>
                <div class="text-start">
                    <small class="text-muted">Accepts <b><i>Youtube</i></b>, <b><i>Vimeo</i></b>, <b><i>Dailymotion</i></b> and <b><i>Youku</i></b> videos</small>
                </div>
                <textarea t-ref="autofocus" t-model="state.urlInput" class="form-control" id="o_video_text" placeholder="Copy-paste your URL or embed code here" t-on-input="onChangeUrl" t-att-class="{ 'is-valid': state.urlInput and !this.state.errorMessage, 'is-invalid': state.urlInput and this.state.errorMessage }"/>
            </div>
            <div t-if="shownOptions.length" class="o_video_dialog_options">
                <VideoOption t-foreach="shownOptions" t-as="option" t-key="option.id" value="option.value" onChangeOption="() =&gt; this.onChangeOption(option.id)" label="option.label" description="option.description"/>
            </div>
            <t t-if="state.vimeoPreviews.length">
                <span class="fw-bold">Suggestions</span>
                <div id="video-suggestion" class="mt-4 d-flex flex-wrap mh-75 overflow-auto">
                    <t t-foreach="state.vimeoPreviews" t-as="vimeoPreview" t-key="vimeoPreview.id">
                        <div class="o_sample_video w-25 mh-100 cursor-pointer" t-on-click="() =&gt; this.onClickSuggestion(vimeoPreview.src)">
                            <img class="mw-100 mh-100 p-1" t-att-src="vimeoPreview.thumbnailSrc"/>
                        </div>
                    </t>
                </div>
            </t>
        </div>
        <div class="col-md-6">
            <div class="o_video_preview position-relative border-0 p-3">
                <div t-if="this.state.src and !this.state.errorMessage" class="o_video_dialog_preview_text mb-2">Preview</div>
                <div class="media_iframe_video">
                    <div class="media_iframe_video_size"/>
                    <VideoIframe t-if="this.state.src and !this.state.errorMessage" src="this.state.src"/>
                    <div t-if="this.state.errorMessage" class="alert alert-warning o_video_dialog_iframe mw-100 mh-100 mb-2 mt-2" t-esc="this.state.errorMessage"/>
                </div>
            </div>
        </div>
    </div>
</t>
`);
registerTemplate("html_editor.Powerbox", `/html_editor/static/src/main/powerbox/powerbox.xml`, `<t t-name="html_editor.Powerbox" xml:space="preserve">
        <div t-ref="root" class="o-we-powerbox py-2 bg-white overflow-auto my-1" style="width:300px;max-height:40vh;" t-on-mousedown.stop="" t-on-scroll="onScroll">
            <t t-foreach="commands" t-as="command" t-key="command_index">
                <t t-if="showCategories and command.categoryId !== lastCategory">
                    <div class="o-we-category mx-3 my-1 text-uppercase"><t t-esc="command.categoryName"/></div></t>
                    <t t-set="lastCategory" t-value="command.categoryId">
                </t>
                <div class="o-we-command d-flex align-items-center px-3 py-2 cursor-pointer" t-att-class="{active: command_index === currentIndex}" t-on-mouseenter="() =&gt; this.onMouseEnter(command_index)" t-on-mousedown="(ev) =&gt; ev.preventDefault()" t-on-click="() =&gt; this.props.applyCommand(command)">
                    <div class="border rounded">
                        <i class="o-we-command-img d-flex align-items-center justify-content-center fa" t-att-class="command.icon"/>
                    </div>
                    <div class="ms-3">
                        <div class="o-we-command-name" t-esc="command.title"/>
                        <div class="o-we-command-description" t-esc="command.description"/>
                    </div>
                </div>
            </t>
        </div>
    </t>
`);
registerTemplate("html_editor.Signature", `/html_editor/static/src/main/signature.xml`, `<t t-name="html_editor.Signature" xml:space="preserve">
        <div t-att-class="signatureClass" t-out="signature"/>
    </t>
`);
registerTemplate("html_editor.TableMenu", `/html_editor/static/src/main/table/table_menu.xml`, `<t t-name="html_editor.TableMenu" xml:space="preserve">
        <Dropdown menuClass="'m-0'" position="props.type === 'column' ? 'bottom' : 'right'" state="props.dropdownState">
            <button t-att-data-type="props.type" class="o-we-table-menu fa" t-attf-class="fa-ellipsis-{{props.type === 'column' ? 'h w-100' : 'v h-100'}}"/>
            <t t-set-slot="content">
                <div t-on-pointerdown.stop="() =&gt; {}">
                    <t t-foreach="items" t-as="item" t-key="item_index">
                        <DropdownItem onSelected="() =&gt; this.onSelected(item)">
                            <div class="user-select-none" t-att-name="item.name">
                                <span t-if="item.icon" class="me-2 fa" t-att-class="item.icon"/>
                                <span t-esc="item.text"/>
                            </div>
                        </DropdownItem>
                    </t>
                 </div>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("html_editor.TablePicker", `/html_editor/static/src/main/table/table_picker.xml`, `<t t-name="html_editor.TablePicker" xml:space="preserve">
        <div class="o-we-tablepicker bg-white p-1 my-1" t-on-click="insertTable" t-on-mousedown.stop="">
            <t t-foreach="new Array(state.rows + 1)" t-as="row" t-key="row_index">
                <div class="o-we-row d-flex">
                    <t t-foreach="new Array(state.cols + 1)" t-as="col" t-key="col_index">
                        <div class="o-we-cell" t-att-class="{'active': col_index lt state.cols and row_index lt state.rows}" t-on-mouseenter="() =&gt; this.updateSize(col_index + 1, row_index + 1)"/>
                    </t>
                </div>
            </t>
            <div class="text-center"><t t-esc="state.cols"/>x<t t-esc="state.rows"/></div>
        </div>
    </t>
`);
registerTemplate("html_editor.MobileToolbar", `/html_editor/static/src/main/toolbar/mobile_toolbar.xml`, `<t t-name="html_editor.MobileToolbar" xml:space="preserve">
        <div t-ref="toolbarWrapper" class="o-toolbar-above-keyboard">
            <Toolbar t-props="this.props"/>
        </div>
    </t>
`);
registerTemplate("html_editor.Toolbar", `/html_editor/static/src/main/toolbar/toolbar.xml`, `<t t-name="html_editor.Toolbar" xml:space="preserve">
        <div class="o-we-toolbar d-flex align-items-center m-0" t-on-pointerdown.prevent="" style="overflow-x: auto; overflow-y:hidden" t-att-class="props.class">
            <t t-foreach="this.getFilteredButtonGroups()" t-as="buttonGroup" t-key="buttonGroup.id">
                <span class="o-we-toolbar-vertical-seperator"/>
                <div class="btn-group" t-att-name="buttonGroup.id">
                    <t t-foreach="buttonGroup.buttons" t-as="button" t-key="button.id">
                        <t t-if="state.buttonsAvailableState[button.id]">
                            <t t-if="button.Component">
                                <t t-component="button.Component" t-props="button.props" title="button.title" getSelection.bind="props.toolbar.getSelection"/>
                            </t>
                            <button t-else="" class="btn btn-light" t-att-class="{                                     active: state.buttonsActiveState[button.id],                                     disabled: state.buttonsDisabledState[button.id]                                 }" t-att-disabled="state.buttonsDisabledState[button.id]" t-att-title="button.title" t-att-name="button.id" t-on-click="() =&gt; this.onButtonClick(button)">
                                <span t-if="button.icon" class="fa fa-fw" t-att-class="button.icon"/>
                                <span t-if="button.text" t-esc="button.text"/>
                            </button>
                        </t>
                    </t>
                </div>
            </t>
        </div>
    </t>
`);
registerTemplate("html_editor.EmbeddedFile", `/html_editor/static/src/others/embedded_components/backend/file/file.xml`, `<t t-name="html_editor.EmbeddedFile" t-inherit="html_editor.ReadonlyEmbeddedFile" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[hasclass('o_file_name_container')]" position="after">
            <input t-attf-class="rounded border-0 mx-2 #{ localState.editFileName ? '' : 'd-none'}" t-ref="nameInput" type="text" maxLength="100" t-att-placeholder="fileModel.filename" t-on-blur="onBlurNameInput" t-on-input.stop="" t-on-keydown.stop="onKeydownNameInput" t-att-value="fileModel.filename"/>
        </xpath>
        <xpath expr="//span[hasclass('o_file_name_container')]" position="attributes">
            <attribute name="t-att-class">{
                "d-none": localState.editFileName,
                "cursor-pointer": true,
            }</attribute>
            <attribute name="t-on-focus">onFocusFileName</attribute>
            <attribute name="tabindex">-1</attribute>
        </xpath>
        <xpath expr="//span[hasclass('o_file_name')]" position="after">
            <i class="fa fa-pencil mx-1 invisible align-items-center d-inline-flex"/>
        </xpath>
    </t>
`);
registerTemplate("html_editor.EmbeddedComponentToolbar", `/html_editor/static/src/others/embedded_components/core/embedded_component_toolbar/embedded_component_toolbar.xml`, `<t t-name="html_editor.EmbeddedComponentToolbar" xml:space="preserve">
        <span class="o_embedded_toolbar d-flex justify-content-end align-items-center">
            <span t-attf-class="btn-group d-flex flex-wrap #{ props.buttonsGroupClass ? props.buttonsGroupClass : '' }">
                <t t-slot="buttons"/>
            </span>
        </span>
    </t>
    `);
registerTemplate("html_editor.EmbeddedComponentToolbarButton", `/html_editor/static/src/others/embedded_components/core/embedded_component_toolbar/embedded_component_toolbar.xml`, `<t t-name="html_editor.EmbeddedComponentToolbarButton" xml:space="preserve">
        <button t-if="!props.hidden" t-ref="buttonRef" t-on-click="props.onClick" t-att-name="props.name" t-att-title="props.title" class="btn btn-primary btn-link btn-sm border-0 py-0 text-break text-start text-o-color-2 text-capitalize fw-bold border-transparent bg-transparent">
            <i t-if="props.icon" t-attf-class="fa #{props.icon} me-1"/>
            <span class="o_embedded_toolbar_button_text" t-out="props.label"/>
        </button>
    </t>
`);
registerTemplate("html_editor.ReadonlyEmbeddedFile", `/html_editor/static/src/others/embedded_components/core/file/readonly_file.xml`, `<t t-name="html_editor.ReadonlyEmbeddedFile" t-inherit="html_editor.StaticFileBox" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[hasclass('o_file_image')]" position="inside">
            <a t-att-href="fileModel.downloadUrl" t-on-click.prevent.stop="onClickFileImage" class="w-100"/>
        </xpath>

        <xpath expr="//span[hasclass('o_file_name_container')]/a" position="replace">
            <span class="o_file_name" t-out="fileModel.filename"/>
        </xpath>

        <xpath expr="//span[hasclass('o_file_name_container')]" position="after">
            <span class="flex-grow-1 d-flex justify-content-end">

                <EmbeddedComponentToolbar>
                    <t t-set-slot="buttons"/>
                </EmbeddedComponentToolbar>
            </span>
        </xpath>

    </t>

`);
registerTemplate("html_editor.StaticFileBox", `/html_editor/static/src/others/embedded_components/core/file/static_file.xml`, `<t t-name="html_editor.StaticFileBox" xml:space="preserve">
        <span class="d-flex flex-grow-1 align-items-center alert alert-info">

            <span class="o_file_image d-flex o_image user-select-none" t-att-title="fileModel.filename" t-att-data-mimetype="fileModel.mimetype"/>

            <span class="o_file_name_container mx-2">
                <a class="o_link_readonly o-contenteditable-true" t-att-href="fileModel.downloadUrl" t-out="fileModel.filename" contenteditable="true"/>
            </span>
        </span>
    </t>
`);
registerTemplate("html_editor.EmbeddedTableOfContent", `/html_editor/static/src/others/embedded_components/core/table_of_content/table_of_content.xml`, `<t t-name="html_editor.EmbeddedTableOfContent" xml:space="preserve">
    <div class="o_embedded_toc_content">
        <t t-foreach="this.state.toc.headings" t-as="heading" t-key="heading_index">
            <a href="#" contenteditable="false" t-out="heading.name" t-on-click.prevent="() =&gt; this.onTocLinkClick(heading)" t-attf-class="o_no_link_popover py-1 pe-1 d-block o_embedded_toc_link #{'o_embedded_toc_link_depth_' + heading.depth}"/>
        </t>
    </div>
    <i class="o_embedded_toc_hint" t-if="displayTocHint()">
        Add headings in this field to fill the Table of Content
    </i>
</t>
`);
registerTemplate("html_editor.EmbeddedVideo", `/html_editor/static/src/others/embedded_components/core/video/video.xml`, `<t t-name="html_editor.EmbeddedVideo" xml:space="preserve">
        <VideoIframe src="this.src"/>
    </t>
    `);
registerTemplate("html_editor.EmbeddedVideoIframe", `/html_editor/static/src/others/embedded_components/core/video/video.xml`, `<t t-name="html_editor.EmbeddedVideoIframe" xml:space="preserve">
        <iframe t-att-src="props.src" title="Video player" frameborder="0" allowfullscreen="allowfullscreen" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share">
            Your browser does not support iframe.
        </iframe>
    </t>
`);
registerTemplate("html_editor.EmbeddedFileBlueprint", `/html_editor/static/src/others/embedded_components/plugins/embedded_file_plugin/file_blueprint.xml`, `<t t-name="html_editor.EmbeddedFileBlueprint" xml:space="preserve">
        <span t-att-data-embedded-props="embeddedProps" data-embedded="file" data-oe-protected="true" contenteditable="false" class="o_file_box o-contenteditable-false"/>
    </t>
`);
registerTemplate("html_editor.TableOfContentBlueprint", `/html_editor/static/src/others/embedded_components/plugins/table_of_content_plugin/table_of_content_blueprint.xml`, `<t t-name="html_editor.TableOfContentBlueprint" xml:space="preserve">
        <div data-embedded="tableOfContent" data-oe-protected="true" contenteditable="false"/>
    </t>
`);
registerTemplate("html_editor.EmbeddedVideoBlueprint", `/html_editor/static/src/others/embedded_components/plugins/video_plugin/video_blueprint.xml`, `<t t-name="html_editor.EmbeddedVideoBlueprint" xml:space="preserve">
        <div t-att-data-embedded-props="embeddedProps" data-embedded="video" data-oe-protected="true" contenteditable="false"/>
    </t>
`);
registerTemplate("html_editor.VideoSelectorDialog", `/html_editor/static/src/others/embedded_components/plugins/video_plugin/video_selector_dialog/video_selector_dialog.xml`, `<t t-name="html_editor.VideoSelectorDialog" xml:space="preserve">
        <Dialog size="'xl'" title.translate="Embed a video" bodyClass="'o_knowledge_video_selector_dialog'">
            <VideoSelector selectMedia.bind="selectMedia" errorMessages.bind="() =&gt; {}"/>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="onInsertVideoBtnClick" t-att-disabled="this.state.enableInsertVideoButton ? undefined : 'disabled'" data-hotkey="I">
                    Insert Video
                </button>
                <button class="btn btn-secondary" t-on-click="this.props.close.bind(this)" data-hotkey="C">
                    Cancel
                </button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("html_editor.QWebPicker", `/html_editor/static/src/others/qweb_picker.xml`, `<t t-name="html_editor.QWebPicker" xml:space="preserve">
        <div class="o-we-qweb-picker bg-white my-1">
            <t t-foreach="state.groups" t-as="group" t-key="group_index">
                <select class="form-select" t-on-change="onChange">
                    <t t-foreach="group" t-as="element" t-key="element_index">
                        <option t-attf-value="{{group_index}},{{element_index}}" t-att-selected="element.isActive">
                            <t t-esc="element.label"/>
                        </option>
                    </t>
                </select>
            </t>
        </div>
    </t>
`);
registerTemplate("html_editor.ImageField", `/html_editor/static/src/others/x2many_image_field.xml`, `<t t-name="html_editor.ImageField" t-inherit="web.ImageField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('position-relative')]//div" position="replace">
            <div t-attf-class="position-absolute d-flex justify-content-between w-100 bottom-0 opacity-0 opacity-100-hover {{isMobile ? 'o_mobile_controls' : ''}}" aria-atomic="true" t-att-style="sizeStyle">
                <button t-if="props.record.data[props.name] and state.isValid" class="o_select_file_button btn btn-light border-0 rounded-circle m-1 p-1" data-tooltip="Edit" aria-label="Edit" t-on-click.prevent.stop="onFileEdit">
                    <i class="fa fa-pencil fa-fw"/>
                </button>
                <button t-if="props.record.data[props.name] and state.isValid" class="o_clear_file_button btn btn-light border-0 rounded-circle m-1 p-1" data-tooltip="Clear" aria-label="Clear" t-on-click.prevent.stop="onFileRemove">
                    <i class="fa fa-trash-o fa-fw"/>
                </button>
            </div>
        </xpath>
    </t>
`);
registerTemplate("html_editor.X2ManyMediaViewer", `/html_editor/static/src/others/x2many_media_viewer.xml`, `<t t-name="html_editor.X2ManyMediaViewer" t-inherit="web.X2ManyField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_x2m_control_panel')]" position="before">
           <KanbanRenderer t-if="props.viewMode" t-props="rendererProps"/>
        </xpath>
        <xpath expr="//KanbanRenderer[last()]" position="replace"/>
    </t>
`);
registerTemplate("html_editor.Wysiwyg", `/html_editor/static/src/wysiwyg.xml`, `<t t-name="html_editor.Wysiwyg" xml:space="preserve">
        <div class="o-wysiwyg d-flex flex-column p-0" t-att-class="props.class" t-att-style="props.style">
            <t t-if="props.toolbar and state.showToolbar and editor.shared.toolbar">
                <Toolbar toolbar="editor.shared.toolbar.getToolbarInfo()" class="'shadow-sm'"/>
            </t>
            <LocalOverlayContainer localOverlay="overlayRef" identifier="env.localOverlayContainerKey"/>
            <div class="flex-grow-1" t-att-class="{'overflow-auto': !props.iframe}">
                <t t-if="props.iframe">
                    <iframe t-ref="content" class="w-100 h-100" t-att-data-class="props.contentClass" t-on-blur="props.onBlur"/>
                </t>
                <t t-else="">
                    <div t-att-class="props.contentClass" t-ref="content" t-on-blur="props.onBlur" contenteditable="true"/>
                </t>
            </div>
        </div>
    </t>
`);
registerTemplateExtension("html_editor.ExternalImage", `/web_unsplash/static/src/media_dialog/media_dialog.xml`, `<t t-inherit="html_editor.ExternalImage" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//t[@t-if]" position="after">
            <t t-elif="record.mediaType === 'unsplashRecord'">
                <AutoResizeImage src="record.url" author="record.user.name" authorLink="record.user.links.html" name="record.user.name" title="record.user.name" altDescription="record.alt_description" selected="this.selectedRecordIds.includes(record.id)" onImageClick="() =&gt; this.onClickRecord(record)" minRowHeight="MIN_ROW_HEIGHT" onLoaded="(imgEl) =&gt; this.onImageLoaded(imgEl, record)"/>
            </t>
        </xpath>
    </t>

    `);
registerTemplateExtension("html_editor.ImagesListTemplate", `/web_unsplash/static/src/media_dialog/media_dialog.xml`, `<t t-inherit="html_editor.ImagesListTemplate" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//t[@id='o_we_media_library_images']" position="replace">
            <t id="o_we_media_library_images" t-if="['all', 'unsplash', 'media-library'].includes(state.searchService)">
                <t t-foreach="combinedRecords" t-as="record" t-key="record.id">
                    <t t-call="web_editor.ExternalImage"/>
                </t>
            </t>
        </xpath>
    </t>

    `);
registerTemplateExtension("html_editor.FileSelector", `/web_unsplash/static/src/media_dialog/media_dialog.xml`, `<t t-inherit="html_editor.FileSelector" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[@name='load_more_attachments']" position="before">
            <div t-if="unsplashState?.unsplashError" class="d-flex mt-2 unsplash_error">
                <UnsplashError title="errorTitle" subtitle="errorSubtitle" showCredentials="['key_not_found', 401].includes(unsplashState.unsplashError)" submitCredentials="(key, appId)  =&gt; this.submitCredentials(key, appId)" hasCredentialsError="unsplashState.unsplashError === 401"/>
            </div>
        </xpath>
    </t>

    `);
registerTemplateExtension("html_editor.FileSelector", `/web_unsplash/static/src/media_dialog/media_dialog.xml`, `<t t-inherit="html_editor.FileSelector" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//FileSelectorControlPanel" position="attributes">
            <attribute name="useUnsplash">unsplashState?.useUnsplash</attribute>
        </xpath>
    </t>
`);
registerTemplateExtension("html_editor.FileSelectorControlPanel", `/web_unsplash/static/src/media_dialog/media_dialog.xml`, `<t t-inherit="html_editor.FileSelectorControlPanel" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//option[@value='media-library']" position="after">
            <option t-if="props.useUnsplash" t-att-selected="props.searchService === 'unsplash'" value="unsplash">Photos (via Unsplash)</option>
        </xpath>
    </t>

    `);
registerTemplate("web_unsplash.UnsplashCredentials", `/web_unsplash/static/src/unsplash_credentials/unsplash_credentials.xml`, `<t t-name="web_unsplash.UnsplashCredentials" xml:space="preserve">
        <div class="d-flex align-items-center flex-wrap">
            <a href="https://www.odoo.com/documentation/master/applications/websites/website/optimize/unsplash.html#generate-an-unsplash-access-key" class="me-1" target="_blank">Get an Access key</a>
            and paste it here:
            <input type="text" class="o_input o_required_modifier form-control w-auto mx-2" id="accessKeyInput" placeholder="Paste your access key here" t-model="state.key" t-on-input="() =&gt; this.state.hasKeyError = false" t-att-class="{ 'is-invalid': state.hasKeyError }"/>
            and paste
            <a href="https://www.odoo.com/documentation/master/applications/websites/website/optimize/unsplash.html#generate-an-unsplash-application-id" class="mx-1" target="_blank">Application ID</a>
            here:
            <input type="text" class="o_input o_required_modifier form-control w-auto ms-2" placeholder="Paste your application ID here" t-model="state.appId" t-on-input="() =&gt; this.state.hasAppIdError = false" t-att-class="{ 'is-invalid': state.hasAppIdError }"/>
            <button type="button" class="btn btn-primary w-auto ms-3 p-auto save_unsplash" t-on-click="() =&gt; this.submitCredentials()">Apply</button>
        </div>
    </t>
`);
registerTemplate("web_unsplash.UnsplashError", `/web_unsplash/static/src/unsplash_error/unsplash_error.xml`, `<t t-name="web_unsplash.UnsplashError" xml:space="preserve">
        <div class="alert alert-info w-100">
            <h4><t t-esc="props.title"/></h4>
            <p><t t-esc="props.subtitle"/></p>
            <UnsplashCredentials t-if="props.showCredentials" submitCredentials="props.submitCredentials" hasCredentialsError="props.hasCredentialsError"/>
        </div>
    </t>
`);
registerTemplate("mail.AttachmentList", `/mail/static/src/core/common/attachment_list.xml`, `<t t-name="mail.AttachmentList" xml:space="preserve">
        <div class="o-mail-AttachmentList overflow-y-auto d-flex flex-column mt-1" t-att-class="{                 'o-inComposer': env.inComposer,                 'o-inChatWindow': env.inChatWindow,                 'me-2 pe-4': isInChatWindowAndIsAlignedLeft and !env.inComposer,                 'ms-2 ps-4': isInChatWindowAndIsAlignedRight and !env.inComposer,             }">
            <div class="d-flex flex-grow-1 flex-wrap mx-1 align-items-center" t-att-class="{                 'justify-content-end': isInChatWindowAndIsAlignedRight and !env.inComposer,                         }" role="menu">
                <div t-foreach="images" t-as="attachment" t-key="attachment.id" t-att-aria-label="attachment.filename" class="o-mail-AttachmentImage d-flex position-relative flex-shrink-0 mw-100 mb-1 me-1 rounded o-viewable" t-att-title="attachment.name" t-att-class="{ 'o-isUploading': attachment.uploading }" tabindex="0" t-att-data-mimetype="attachment.mimetype" t-on-click="() =&gt; this.fileViewer.open(attachment, props.attachments)" role="menuitem">
                    <img class="img img-fluid my-0 mx-auto rounded" t-att-class="{ 'opacity-25': attachment.uploading }" t-att-src="getImageUrl(attachment)" t-att-alt="attachment.name" t-attf-style="max-width: min(100%, {{ imagesWidth }}px); max-height: {{ props.imagesHeight }}px;" t-on-load="onImageLoaded"/>
                    <div t-if="attachment.uploading" class="position-absolute top-0 bottom-0 start-0 end-0 d-flex align-items-center justify-content-center" title="Uploading">
                        <i class="fa fa-spin fa-spinner"/>
                    </div>
                    <ImageActions actions="getActions(attachment)" imagesHeight="props.imagesHeight"/>
                </div>
            </div>
            <div class="d-flex flex-wrap mt-1 mx-1">

                <div t-foreach="cards" t-as="attachment" t-key="attachment.id" class="o-mail-AttachmentCard d-flex rounded mb-1 me-1 mw-100 overflow-auto" t-att-class="{                                'ms-1': isInChatWindowAndIsAlignedRight,                                'me-1': !isInChatWindowAndIsAlignedRight,                                'o-viewable': attachment.isViewable,                                'o-isUploading': attachment.uploading,                                }" t-attf-class="bg-300" t-att-title="attachment.name ? attachment.name : undefined" role="menu" t-att-aria-label="attachment.name" t-on-click="() =&gt; this.fileViewer.open(attachment, props.attachments)">

                    <t t-ref="nonImageMain">
                        <div class="o-mail-AttachmentCard-image o_image flex-shrink-0 m-1" role="menuitem" aria-label="Preview" t-att-tabindex="-1" t-att-aria-disabled="false" t-att-data-mimetype="attachment.mimetype"/>
                        <div class="overflow-auto d-flex justify-content-center flex-column px-1">
                            <div t-if="attachment.name" class="text-truncate" t-out="props.messageSearch?.highlight(attachment.name) ?? attachment.name"/>
                            <small t-if="attachment.extension" class="text-uppercase" t-esc="attachment.extension"/>
                        </div>
                    </t>
                    <div class="flex-grow-1"/>
                    <div class="o-mail-AttachmentCard-aside position-relative rounded-end overflow-hidden d-flex" t-att-class="{ 'o-hasMultipleActions d-flex flex-column': showDelete and !env.inComposer }">
                        <div t-if="attachment.uploading" class="d-flex justify-content-center align-items-center w-100 h-100" title="Uploading">
                            <i class="fa fa-spin fa-spinner"/>
                        </div>
                        <div t-if="!attachment.uploading and env.inComposer" class="d-flex justify-content-center me-2 align-items-center w-100 h-100 text-primary" title="Uploaded">
                            <i class="fa fa-check"/>
                        </div>
                        <button t-if="showDelete" class="o-mail-AttachmentCard-unlink btn top-0 align-items-center justify-content-center d-flex w-100 h-100 rounded-0 border-0" t-attf-class="{{ env.inComposer ? 'o-inComposer position-absolute btn-primary transition-base justify-content-center' : 'bg-300' }}" t-on-click.stop="() =&gt; this.onClickUnlink(attachment)" title="Remove">
                            <i class="fa fa-trash" role="img" aria-label="Remove"/>
                        </button>
                        <a t-if="attachment.type === 'url'" class="btn d-flex align-items-center justify-content-center w-100 h-100 rounded-0" t-attf-class="bg-300" t-att-href="attachment.url" target="_blank" title="Open Link">
                            <i class="fa fa-external-link" role="img" aria-label="Open Link"/>
                        </a>

                        <button t-elif="canDownload(attachment)" class="btn d-flex align-items-center justify-content-center w-100 h-100 rounded-0" t-attf-class="bg-300" t-att-data-download-url="attachment.downloadUrl" t-on-click.stop="() =&gt; this.onClickDownload(attachment)" title="Download">
                            <i class="fa fa-download" role="img" aria-label="Download"/>
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </t>

    `);
registerTemplate("mail.ImageActions", `/mail/static/src/core/common/attachment_list.xml`, `<t t-name="mail.ImageActions" xml:space="preserve">
        <div class="position-absolute top-0 bottom-0 start-0 end-0 p-1 text-white o-opacity-hoverable opacity-100-hover d-flex align-items-end flax-wrap flex-column" t-att-class="{ 'opacity-0': !actionsMenuState.isOpen }">
            <button t-if="props.actions.length === 1 and props.imagesHeight gt 75" class="btn btn-sm btn-light rounded px-1 py-0" t-att-class="{ 'opacity-75 opacity-100-hover': !isMobileOS }" tabindex="0" t-att-aria-label="props.actions[0].label" t-att-title="props.actions[0].label" role="menuitem" t-on-click.stop="props.actions[0].onSelect">
                <i t-att-class="props.actions[0].icon"/>
            </button>
            <Dropdown t-else="" menuClass="'d-flex flex-column py-0' + (props.actions.length gt 1 ? ' py-0' : '')" state="actionsMenuState" position="'right-start'">
                <button class="btn btn-sm btn-light rounded px-1 py-0" t-att-class="{ 'opacity-75 opacity-100-hover': !isMobileOS }" tabindex="0" aria-label="Actions" title="Actions" role="menuitem">
                    <i class="oi oi-chevron-down"/>
                </button>
                <t t-set-slot="content">
                    <DropdownItem t-foreach="props.actions" t-as="action" t-key="action_index" class="'px-2 py-1 d-flex align-items-center rounded-0'" onSelected="action.onSelect">
                        <i class="fa-fw" t-att-class="action.icon"/>
                        <span class="mx-2" t-esc="action.label"/>
                    </DropdownItem>
                </t>
            </Dropdown>
        </div>
    </t>

`);
registerTemplate("mail.AttachmentView", `/mail/static/src/core/common/attachment_view.xml`, `<t t-name="mail.AttachmentView" xml:space="preserve">
        <div t-if="state.thread.attachmentsInWebClientView.length &gt; 0" class="o-mail-Attachment">
            <div class="o_attachment_control popout d-print-none cursor-pointer" t-on-click="onClickPopout" data-tooltip="Open preview in a separate window." data-tooltip-delay="400">
                <i class="fa fa-window-restore" aria-hidden="Pop out"/>
            </div>
            <t t-if="state.thread.mainAttachment">
                <h3 t-if="!state.thread.mainAttachment.isPdf" class="mt0 mb8 ps-2 text-muted text-center"><t t-esc="displayName"/></h3>
                <div t-if="state.thread.mainAttachment.isImage" class="o-mail-Attachment-imgContainer">
                    <img id="attachment_img" class="img img-fluid d-block" t-att-src="state.thread.mainAttachment.defaultSource"/>
                </div>
                <iframe t-if="state.thread.mainAttachment.isPdf" class="d-print-none mb48" t-att-src="state.thread.mainAttachment.defaultSource" t-ref="iframeViewerPdf"/>
                <t t-if="state.thread.attachmentsInWebClientView.length &gt; 1 or (state.thread.attachmentsInWebClientView.length &gt; 0 and !(state.thread.mainAttachment.isPdf or state.thread.mainAttachment.isImage))">
                    <a class="arrow o_move_previous text-center" href="#" t-on-click.prevent="onClickPrevious">
                        <span class="oi oi-chevron-left"/>
                    </a>
                    <a class="arrow o_move_next text-center" href="#" t-on-click.prevent="onClickNext">
                        <span class="oi oi-chevron-right"/>
                    </a>
                </t>
            </t>
        </div>
    </t>

    `);
registerTemplate("mail.PopoutAttachmentView", `/mail/static/src/core/common/attachment_view.xml`, `<t t-name="mail.PopoutAttachmentView" xml:space="preserve">
        <div class="o-mail-PopoutAttachmentView">
            <t t-call="mail.AttachmentView"/>
        </div>
    </t>

`);
registerTemplate("mail.AutoresizeInput", `/mail/static/src/core/common/autoresize_input.xml`, `<t t-name="mail.AutoresizeInput" xml:space="preserve">
    <input class="o-mail-AutoresizeInput px-1 border-1 text-truncate" t-attf-class="{{ props.className }}" t-att-class="{'o-focused': state.isFocused}" t-att-placeholder="props.placeholder" t-att-disabled="!props.enabled" t-att-title="state.value" t-model="state.value" t-on-keydown="onKeydownInput" t-on-focus="() =&gt; this.state.isFocused = true" t-on-blur="onBlurInput" t-ref="input" type="text"/>
</t>

`);
registerTemplate("mail.ChatBubble", `/mail/static/src/core/common/chat_bubble.xml`, `<t t-name="mail.ChatBubble" xml:space="preserve">
        <Dropdown t-if="!env.embedLivechat" state="preview" position="'left-middle'" menuClass="'bg-view border-0 p-0 overflow-visible rounded-3 mx-1'" arrow="true" manual="true">
            <t t-call="mail.ChatBubble.core"/>
            <t t-set-slot="content">
                <t t-call="mail.ChatBubble.preview"/>
            </t>
        </Dropdown>
        <t t-else="" t-call="mail.ChatBubble.core"/>
    </t>

    `);
registerTemplate("mail.ChatBubble.core", `/mail/static/src/core/common/chat_bubble.xml`, `<t t-name="mail.ChatBubble.core" xml:space="preserve">
        <div class="o-mail-ChatBubble bg-view position-relative" t-att-name="props.chatWindow.displayName" t-att-class="{ 'o-bouncing': state.bouncing, 'position-fixed': env.embedLivechat, 'position-relative': !env.embedLivechat, 'o-active': preview.isOpen }" t-att-style="env.embedLivechat ? \`top: \${ position.top }; left: \${ position.left };\` : ''" t-on-click="() =&gt; props.chatWindow.open()" t-on-animationend="() =&gt; state.bouncing = false" t-ref="root">
            <span class="o-mail-ChatBubble-unreadIndicator position-absolute" t-att-class="{ 'opacity-50': thread?.isUnread and !thread?.importantCounter, 'opacity-0': !thread?.isUnread or thread?.importantCounter }"><i class="fa fa-circle"/></span>
            <div t-if="thread?.importantCounter &gt; 0" class="o-mail-ChatBubble-counter position-absolute badge rounded-pill fw-bold o-discuss-badge shadow" t-out="thread?.importantCounter"/>
            <button t-if="state.showClose and !env.embedLivechat" class="o-mail-ChatBubble-close position-absolute shadow rounded-circle fw-bold bg-view" title="Close Chat Bubble" t-on-click.stop="() =&gt; this.props.chatWindow.close()"><i class="oi oi-close"/></button>
            <ImStatus t-if="thread?.correspondent?.persona?.im_status and thread?.correspondent?.persona?.im_status != 'offline'" className="'o-mail-ChatBubble-status position-absolute o-mail-brighter'" member="thread.correspondent"/>
            <CountryFlag t-if="thread?.showCorrespondentCountry" country="thread.correspondentCountry" class="'o-mail-ChatBubble-country position-absolute bottom-0 border'"/>
            <button class="o-mail-ChatHub-bubbleBtn btn bg-view">
                <img class="o-mail-ChatBubble-avatar rounded-circle o_object_fit_cover" t-att-class="{ 'o-big': env.embedLivechat }" t-att-src="thread?.avatarUrl" alt="Thread image" draggable="false"/>
            </button>
        </div>
    </t>

    `);
registerTemplate("mail.ChatBubble.preview", `/mail/static/src/core/common/chat_bubble.xml`, `<t t-name="mail.ChatBubble.preview" xml:space="preserve">
        <div class="o-mail-ChatBubble-preview o-mail-ChatBubble-menu px-0 py-1 shadow-sm border border-secondary rounded bg-100" t-ref="preview">
            <div class="text-truncate fw-bolder mb-0 mx-2" t-esc="props.chatWindow.displayName"/>
            <div t-if="previewContent" class="text-truncate small mx-2 text-muted">
                <t t-call="mail.message_preview_prefix">
                    <t t-set="message" t-value="thread?.newestPersistentNotEmptyOfAllMessage"/>
                </t>
                <t t-esc="previewContent"/>
            </div>
        </div>
    </t>


    `);
registerTemplate("mail.message_preview_prefix", `/mail/static/src/core/common/chat_bubble.xml`, `<t t-name="mail.message_preview_prefix" xml:space="preserve">
        <t t-if="message.isSelfAuthored">
            <i class="fa fa-mail-reply me-1"/>You:
        </t>
        <t t-elif="!message.author?.eq(thread.correspondent?.persona)">
            <t t-esc="message.author?.name ?? message.email_from"/>:
        </t>
    </t>

`);
registerTemplate("mail.ChatHub", `/mail/static/src/core/common/chat_hub.xml`, `<t t-name="mail.ChatHub" xml:space="preserve">
    <div class="o-mail-ChatHub" t-if="isShown or ui.isSmall">
        <t t-if="!store.chatHub.compact">
            <t t-foreach="chatHub.opened" t-as="cw" t-key="cw.localId">
                <ChatWindow chatWindow="cw" right="env.embedLivechat ? chatHub.WINDOW_GAP : (chatHub.BUBBLE_START + chatHub.BUBBLE + (chatHub.BUBBLE_OUTER*2) + (chatHub.opened.length - cw_index - 1) * (chatHub.WINDOW + chatHub.WINDOW_INBETWEEN * 2))"/>
            </t>
        </t>
        <div class="o-mail-ChatHub-bubbles position-fixed end-0 d-flex flex-column align-content-start justify-content-end align-items-center" t-att-class="{ 'bottom-0': !store.chatHub.compact or compactPosition.top === 'auto', 'o-liftUp': busMonitoring.hasConnectionIssues }" t-ref="bubbles" t-att-style="store.chatHub.compact ? \`top: \${ compactPosition.top }; left: \${ compactPosition.left };\` : ''">
            <div class="d-flex flex-column align-content-start justify-content-end align-items-center gap-1">
                <t t-if="store.chatHub.compact">
                    <t t-call="mail.ChatHub.compactButton"/>
                </t>
                <t t-else="">
                    <Dropdown t-if="(chatHub.opened.length + chatHub.folded.length) gt 0" state="options" position="'top-end'" menuClass="'d-flex flex-column bg-100 shadow-sm m-0 p-0 mb-1 border-secondary'">
                        <button class="o-mail-ChatHub-bubbleBtn btn o-mail-ChatHub-optionsBtn fa fa-ellipsis-h bg-100 mt-1" t-att-class="{ 'opacity-0': !bubblesHover.isHover and !options.isOpen, 'text-500': bubblesHover.isHover and !options.isOpen and !isMobileOS, 'o-active': bubblesHover.isHover or options.isOpen }" title="Chat Options"/>
                        <t t-set-slot="content">
                            <button class="o-mail-ChatHub-option btn border-0 d-flex align-items-center gap-2 rounded-0 fw-normal" t-on-click="() =&gt; chatHub.compact = true"><i class="fa fa-fw fa-eye-slash"/>Hide all conversations</button>
                            <button class="o-mail-ChatHub-option btn border-0 d-flex align-items-center gap-2 rounded-0 fw-normal" t-on-click="() =&gt; chatHub.closeAll()"><i class="oi fa-fw oi-close"/>Close all conversations</button>
                        </t>
                    </Dropdown>
                    <t t-foreach="chatHub.folded.slice(0, chatHub.maxFolded)" t-as="cw" t-key="cw.localId">
                        <ChatBubble chatWindow="cw"/>
                    </t>
                    <t t-if="chatHub.folded.length &gt; chatHub.maxFolded" t-call="mail.ChatHub.hiddenButton"/>
                </t>
            </div>
        </div>
    </div>
</t>

`);
registerTemplate("mail.ChatHub.compactButton", `/mail/static/src/core/common/chat_hub.xml`, `<t t-name="mail.ChatHub.compactButton" xml:space="preserve">

    <Dropdown manual="true">
        <div class="o-mail-ChatHub-bubbleBtn o-mail-ChatHub-compact o-mail-ChatBubble justify-content-center" t-ref="compact">
            <div t-if="compactCounter &gt; 0" class="o-mail-ChatHub-hiddenBtnCounter position-absolute badge rounded-pill fw-bold o-discuss-badge shadow">
                <t t-out="compactCounter"/>
            </div>
            <button class="o-mail-ChatHub-bubbleBtn btn fs-2" t-on-click="expand">
                <i class="o-mail-ChatHub-hiddenBtnIcon d-flex justify-content-center align-items-center btn rounded-circle shadow-sm fa fa-commenting"/>
            </button>
        </div>
    </Dropdown>
</t>

`);
registerTemplate("mail.ChatHub.hiddenButton", `/mail/static/src/core/common/chat_hub.xml`, `<t t-name="mail.ChatHub.hiddenButton" xml:space="preserve">
    <Dropdown t-if="chatHub.folded.length &gt; chatHub.maxFolded" state="more" position="'left-middle'" menuClass="'o-mail-ChatHub-hiddenMenu bg-100 border border-secondary shadow-sm p-0 m-0'" manual="true">
        <div class="o-mail-ChatBubble o-mail-ChatHub-hiddenBtn justify-content-center" t-att-class="{ 'o-active': more.isOpen }" t-on-click="() =&gt; store.chatHub.compact = true" t-ref="more-button">
            <div t-if="hiddenCounter &gt; 0" class="o-mail-ChatHub-hiddenBtnCounter position-absolute badge rounded-pill fw-bold o-discuss-badge shadow">
                <t t-out="hiddenCounter"/>
            </div>
            <button class="o-mail-ChatHub-bubbleBtn btn outline-0">
                <span class="o-mail-ChatHub-hiddenBtnIcon d-flex justify-content-center align-items-center btn rounded-circle shadow-sm fs-2" t-att-class="{ 'o-active': more.isOpen }">+<t t-esc="chatHub.folded.slice(chatHub.maxFolded).length"/></span>
            </button>
        </div>
        <t t-set-slot="content">
            <ul class="m-0 p-0 overflow-auto" role="menu" t-ref="more-menu">
                <t t-foreach="chatHub.folded.slice(chatHub.maxFolded)" t-as="cw" t-key="cw.localId">
                    <li class="o-mail-ChatHub-hiddenItem gap-2 px-2 py-1" role="menuitem" t-att-name="cw.displayName" t-on-click="() =&gt; cw.open()">
                        <img class="o-mail-ChatHub-hiddenAvatar rounded-circle o_object_fit_cover" t-att-src="cw.thread?.avatarUrl" alt="Thread image" draggable="false"/>
                        <p class="text-truncate fw-bold mb-0" t-esc="cw.displayName"/>
                        <div t-if="cw.thread?.importantCounter &gt; 0" class="o-mail-ChatHub-hiddenCounter badge rounded-pill fw-bold o-discuss-badge" style="padding: 3px 6px">
                            <t t-out="cw.thread?.importantCounter"/>
                        </div>
                        <button class="o-mail-ChatHub-hiddenClose o-mail-ChatBubble-close d-flex align-items-center rounded" t-on-click.stop="() =&gt; cw.close()">
                            <i class="oi oi-close"/>
                        </button>
                    </li>
                </t>
            </ul>
        </t>
    </Dropdown>
</t>

`);
registerTemplate("mail.ChatWindow", `/mail/static/src/core/common/chat_window.xml`, `<t t-name="mail.ChatWindow" xml:space="preserve">
    <t t-set="partitionedActions" t-value="threadActions.partition"/>
    <div class="o-mail-ChatWindow fixed-bottom overflow-hidden d-flex flex-column shadow-sm bg-100" t-att-style="style" t-att-class="{             'w-100 h-100 o-mobile': ui.isSmall,             'rounded-4 border border-dark mb-2': !ui.isSmall,         }" t-on-keydown="onKeydown" tabindex="1">
        <div class="o-mail-ChatWindow-header d-flex align-items-center flex-shrink-0 bg-100 z-1 shadow-sm" t-on-click="onClickHeader" t-att-class="{ 'cursor-pointer': !ui.isSmall and thread and !state.actionsDisabled, 'pt-2': !thread }">
            <t t-if="hasActionsMenu">
                <div class="d-flex text-truncate">
                    <Dropdown position="'left-start'" onStateChanged="isOpen =&gt; this.onActionsMenuStateChanged(isOpen)" menuClass="'d-flex flex-column py-0 bg-100 border-secondary'">
                        <button class="o-mail-ChatWindow-command o-actionsMenu btn rounded-0 d-flex align-items-center px-2 py-1 my-0 w-100 rounded-end-0" t-att-class="{ 'rounded-top-3': !ui.isSmall, 'o-active': state.actionsMenuOpened, 'o-hover': actionsMenuButtonHover.isHover and !parentChannelHover.isHover }" t-att-disabled="state.editingName or state.actionsDisabled" t-att-title="actionsMenuTitleText" t-ref="actionsMenuButton">
                            <t t-call="mail.ChatWindow.headerContent"/>
                            <i t-if="!state.editingName" class="fa fa-fw fa-caret-down"/>
                        </button>
                        <t t-set-slot="content">
                            <t t-set="quickActionsInDropdown" t-value="partitionedActions.quick.slice(ui.isSmall ? 2 : 4)"/>
                            <t t-if="quickActionsInDropdown.length &gt; 0">
                                <t t-set="groupBefore" t-value="true"/>
                                <t t-foreach="quickActionsInDropdown" t-as="action" t-key="action.id">
                                    <t t-call="mail.ChatWindow.dropdownAction">
                                        <t t-set="action" t-value="action"/>
                                    </t>
                                </t>
                            </t>
                            <t t-else="" t-set="groupBefore" t-value="false"/>
                            <t t-if="partitionedActions.group.length &gt; 0">
                                <hr t-if="groupBefore" class="mx-2 my-1"/>
                                <t t-set="groupBefore" t-value="true"/>
                                <t t-foreach="partitionedActions.group" t-as="group" t-key="group_index">
                                    <t t-foreach="group" t-as="action" t-key="action.id">
                                        <t t-call="mail.ChatWindow.dropdownAction">
                                            <t t-set="action" t-value="action"/>
                                        </t>
                                    </t>
                                    <hr t-if="!group_last" class="mx-2 my-1"/>
                                </t>
                            </t>
                            <t t-else="" t-set="groupBefore" t-value="false"/>
                            <t t-if="partitionedActions.other.length">
                                <hr t-if="groupBefore" class="mx-2 my-1"/>
                                <t t-foreach="partitionedActions.other" t-as="action" t-key="action.id">
                                    <t t-call="mail.ChatWindow.dropdownAction">
                                        <t t-set="action" t-value="action"/>
                                    </t>
                                </t>
                            </t>
                        </t>
                    </Dropdown>
                </div>
                <AutoresizeInput t-if="state.editingName" className="'text-truncate fw-bold flex-shrink-1 me-1 py-0 ' + (ui.isSmall ? 'fs-4' : 'fs-5')" enabled="true" autofocus="true" onValidate.bind="renameThread" value="props.chatWindow.displayName"/>
                <i t-if="state.editingName" class="fa fa-fw fa-caret-down opacity-50"/>
            </t>
            <t t-else="">
                <t t-call="mail.ChatWindow.headerContent"/>
            </t>
            <div class="flex-grow-1"/>
            <div t-if="thread and thread.importantCounter &gt; 0" class="o-mail-ChatWindow-counter mx-1 badge rounded-pill fw-bold o-discuss-badge" t-ref="needactionCounter">
                <t t-out="thread.importantCounter"/>
            </div>
            <div class="o-mail-ChatWindow-quickActions d-flex flex-shrink-0 me-2 o-gap-0_5">
                <t t-foreach="partitionedActions.quick.slice(0, ui.isSmall ? 2 : 4).reverse()" t-as="action" t-key="action.id" t-call="mail.ChatWindow.quickAction">
                    <t t-if="action_last" t-set="itemClass" t-value="ui.isSmall ? 'mx-2' : ''"/>
                </t>
            </div>
            <t t-if="this.store.inPublicPage and this.store.self.type === 'guest'">
                <button class="btn ps-1" t-if="!state.editingGuestName">
                    <img class="o-mail-Discuss-selfAvatar rounded-circle o_object_fit_cover flex-shrink-0" alt="Avatar" t-att-src="store.self.avatarUrl" t-on-click="() =&gt; state.editingGuestName = true"/>
                </button>
                <AutoresizeInput t-if="state.editingGuestName" className="'py-1 me-2'" autofocus="true" onValidate.bind="renameGuest" value="store.self.name"/>
            </t>
        </div>
        <div t-if="!props.chatWindow.folded or ui.isSmall" class="d-flex flex-column h-100 overflow-auto position-relative bg-inherit" t-att-class="{ 'opacity-50': state.editingName }" t-ref="content">
            <t t-if="thread" name="thread content">
                <div t-if="threadActions.activeAction?.componentCondition" class="h-100" t-attf-class="{{ threadActions.activeAction.panelOuterClass }}">
                    <t t-component="threadActions.activeAction.component" t-props="{ ...threadActions.activeAction.componentProps, thread }"/>
                </div>
                <t t-else="">
                    <Thread isInChatWindow="true" thread="thread" t-key="thread.localId" jumpPresent="state.jumpThreadPresent" messageEdition="messageEdition" messageToReplyTo="messageToReplyTo"/>
                    <div t-if="thread and thread.hasOtherMembersTyping" class="d-flex bg-view position-relative">
                        <div class="o-mail-ChatWindow-typing d-flex px-2 position-absolute bottom-0 start-0 w-100 bg-view align-items-center">
                            <Typing channel="thread" size="'medium'"/>
                        </div>
                    </div>
                    <Composer composer="thread.composer" autofocus="props.chatWindow.autofocus" mode="'compact'" messageEdition="messageEdition" messageToReplyTo="messageToReplyTo" onPostCallback.bind="() =&gt; this.state.jumpThreadPresent++" dropzoneRef="contentRef" type="composerType"/>
                </t>
            </t>
        </div>
    </div>
</t>

`);
registerTemplate("mail.ChatWindow.quickAction", `/mail/static/src/core/common/chat_window.xml`, `<t t-name="mail.ChatWindow.quickAction" xml:space="preserve">
    <button class="o-mail-ChatWindow-command btn d-flex opacity-100-hover align-items-center p-0 o-quick" style="aspect-ratio: 1;" t-att-class="{ 'border border-secondary rounded-circle o-small p-2 my-1': ui.isSmall }" t-attf-class="{{ itemClass }}" t-att-title="action.name" t-att-disabled="state.actionsDisabled" t-on-click.stop="() =&gt; action.onSelect()"><i class="fa-lg" t-attf-class="{{ action.icon }}"/></button>
</t>

`);
registerTemplate("mail.ChatWindow.dropdownAction", `/mail/static/src/core/common/chat_window.xml`, `<t t-name="mail.ChatWindow.dropdownAction" xml:space="preserve">
    <DropdownItem class="'o-mail-ChatWindow-command btn rounded-0 d-flex align-items-center p-2 m-0'" onSelected="() =&gt; action.onSelect()">
        <i t-att-class="action.icon"/>
        <span class="mx-2" t-out="action.name"/>
    </DropdownItem>
</t>

`);
registerTemplate("mail.ChatWindow.headerContent", `/mail/static/src/core/common/chat_window.xml`, `<t t-name="mail.ChatWindow.headerContent" xml:space="preserve">
    <div class="o-mail-ChatWindow-threadAvatar my-0 me-1" t-att-class="{         'py-1': !thread or threadActions.actions.length gt 3,         'py-2': thread and threadActions.actions.length lte 3,         'ms-1': thread,         'ms-3': !thread,         'ps-2': !hasActionsMenu,     }">
        <img t-if="thread" class="rounded o_object_fit_cover" t-att-src="thread.parent_channel_id?.avatarUrl ?? thread.avatarUrl" alt="Thread Image"/>
        <i t-else="" class="fa fa-pencil fa-lg fa-fw py-1"/>
    </div>
    <t t-if="thread?.parent_channel_id">
        <span class="fw-bold ms-1 p-1 opacity-50 opacity-100-hover cursor-pointer o-hover-text-underline rounded fs-6" t-esc="thread.parent_channel_id.displayName" title="Open Channel" t-ref="parentChannel" t-on-click.stop="() =&gt; this.thread.parent_channel_id.open()"/>
        <i class="fa fa-chevron-right o-xsmaller ms-1 text-muted opacity-50"/>
    </t>
    <ThreadIcon t-if="thread and thread.channel_type === 'chat' and thread.correspondent" thread="thread"/>
    <CountryFlag t-if="thread?.showCorrespondentCountry" country="thread.correspondentCountry" class="'o-mail-ChatWindow-country border'"/>
    <div t-if="!state.editingName" class="text-truncate fw-bold border border-transparent mx-1 my-0 py-1" t-att-title="props.chatWindow.displayName" t-esc="props.chatWindow.displayName" t-att-class="{ 'fs-4': ui.isSmall, 'fs-5': !ui.isSmall }"/>
</t>
`);
registerTemplate("mail.Composer", `/mail/static/src/core/common/composer.xml`, `<t t-name="mail.Composer" xml:space="preserve">
    <t t-set="compact" t-value="props.mode === 'compact'"/>
    <t t-set="normal" t-value="props.mode === 'normal'"/>
    <t t-set="extended" t-value="props.mode === 'extended'"/>
    <div t-ref="composer">
        <div class="o-mail-Composer d-grid flex-shrink-0 pt-0" t-att-class="{                     'pb-2': extended and !props.composer.message,                     'o-extended': extended,                     'o-isUiSmall': ui.isSmall,                     'px-3 pb-2': normal,                     'o-hasSelfAvatar': !env.inChatWindow and thread,                     'o-focused': props.composer.isFocused,                     'o-editing': props.composer.message,                     'o-chatWindow mx-2': env.inChatWindow,                     'mb-3': env.inChatWindow and !props.composer.message,                     'o-discussApp': env.inDiscussApp,                 }" t-attf-class="{{ props.className }}">
            <div class="o-mail-Composer-sidebarMain flex-shrink-0" t-if="showComposerAvatar">
                <img class="o-mail-Composer-avatar o_avatar rounded" t-att-src="store.self.avatarUrl" alt="Avatar of user"/>
            </div>
            <div class="o-mail-Composer-coreHeader text-truncate small p-2" t-if="props.composer.thread and props.messageToReplyTo?.thread?.eq(props.composer.thread)">
                <span class="cursor-pointer" t-on-click="() =&gt; env.messageHighlight?.highlightMessage(props.messageToReplyTo.message, props.composer.thread)">
                    Replying to <b t-esc="props.messageToReplyTo.message.author?.name ?? props.messageToReplyTo.message.email_from"/>
                </span>
                <span t-if="props.messageToReplyTo.message.thread.notEq(props.composer.thread)">
                    on: <b><t t-esc="props.messageToReplyTo.message.thread.displayName"/></b>
                </span>
                <i class="fa fa-lg fa-times-circle rounded-circle p-0 ms-1 cursor-pointer" title="Stop replying" t-on-click="() =&gt; props.messageToReplyTo.cancel()"/>
            </div>
            <div class="o-mail-Composer-coreMain d-flex flex-nowrap align-items-start flex-grow-1" t-att-class="{ 'flex-column' : extended }">
                <div class="d-flex o-mail-Composer-bg m-1 shadow-sm flex-grow-1 border border-secondary rounded-3" t-att-class="{                         'o-iosPwa': isIosPwa,                         'align-self-stretch' : extended,                     }" t-ref="input-container">
                    <div class="position-relative flex-grow-1">
                        <t t-set="inputClasses" t-value="'o-mail-Composer-inputStyle form-control border-0 rounded-3'"/>
                        <textarea class="o-mail-Composer-input o-mail-Composer-bg shadow-none overflow-auto" t-att-class="inputClasses" t-ref="textarea" t-on-keydown="onKeydown" t-on-focusin="onFocusin" t-on-focusout="onFocusout" t-on-click="(ev) =&gt; markEventHandled(ev, 'composer.onClickTextarea')" t-on-paste="onPaste" t-model="props.composer.text" t-att-placeholder="placeholder" t-att-readOnly="!state.active"/>

                        <textarea class="o-mail-Composer-fake position-absolute overflow-hidden" t-att-class="inputClasses" t-model="props.composer.text" t-ref="fakeTextarea" disabled="1"/>
                    </div>
                    <t t-if="!extended and !props.composer.message" t-call="mail.Composer.actions"/>
                    <t t-else="" t-call="mail.Composer.quickActions"/>
                </div>
                <div t-if="extended and !props.composer.message" class="d-flex align-items-center mt-2 gap-1 w-100 px-2">
                    <t t-call="mail.Composer.sendButton"/>
                    <span t-if="!isSendButtonDisabled and !props.composer.message and !isMobileOS" class="text-muted small ms-1" t-out="OR_PRESS_SEND_KEYBIND"/>
                    <span class="flex-grow-1"/>
                    <t t-call="mail.Composer.extraActions"/>
                </div>
            </div>
            <div class="o-mail-Composer-footer overflow-auto">
                <AttachmentList t-if="allowUpload and props.composer.attachments.length &gt; 0" attachments="props.composer.attachments" unlinkAttachment.bind="(...args) =&gt; attachmentUploader.unlink(...args)" imagesHeight="75"/>
                <Picker t-props="picker"/>
            </div>
        </div>
        <div t-if="props.composer.message" class="d-flex align-items-center gap-1 w-100 pe-2">
            <span t-if="props.composer.message" class="text-muted px-1 small" t-out="CANCEL_OR_SAVE_EDIT_TEXT" t-on-click="onClickCancelOrSaveEditText"/>
            <span class="flex-grow-1"/>
            <t t-call="mail.Composer.extraActions"/>
        </div>
    </div>
    <NavigableList t-if="suggestion" class="'o-mail-Composer-suggestionList'" t-props="navigableListProps"/>
</t>

`);
registerTemplate("mail.Composer.sendButton", `/mail/static/src/core/common/composer.xml`, `<t t-name="mail.Composer.sendButton" xml:space="preserve">
    <button class="o-mail-Composer-send btn" t-att-class="{             'btn-primary btn-sm': extended,             'btn-link rounded-circle p-0': !extended,             'me-2': env.inDiscussApp,             'border-start-0': env.inDiscussApp and !props.composer.message,             'border-0': props.composer.message,         }" t-on-click="sendMessage" t-att-disabled="isSendButtonDisabled" t-att-aria-label="SEND_TEXT">
        <t t-if="thread and thread.model !== 'discuss.channel'" t-out="SEND_TEXT"/>
        <t t-else=""><i class="fa fa-fw fa-lg fa-paper-plane-o"/></t>
    </button>
</t>

`);
registerTemplate("mail.Composer.fullComposer", `/mail/static/src/core/common/composer.xml`, `<t t-name="mail.Composer.fullComposer" xml:space="preserve">
    <button t-if="props.showFullComposer and thread and thread.model !== 'discuss.channel'" class="o-mail-Composer-fullComposer btn border-0 rounded-circle p-0" title="Full composer" aria-label="Full composer" type="button" t-on-click="onClickFullComposer" data-hotkey="shift+c">
        <i class="fa fa-fw fa-lg fa-expand"/>
    </button>
</t>

`);
registerTemplate("mail.Composer.actions", `/mail/static/src/core/common/composer.xml`, `<t t-name="mail.Composer.actions" xml:space="preserve">
    <div class="o-mail-Composer-actions d-flex" name="root" t-att-class="{             'ms-1': compact and ui.isSmall,             'mx-1': compact and !ui.isSmall,             'mx-2': extended,             'ms-3': normal,             'rounded-3': !props.composer.message,             'o-mail-Composer-bg': !extended and !props.composer.message,         }">
        <div class="o-mail-Composer-mainActions d-flex flex-grow-1 align-items-baseline gap-1" t-att-class="{ 'mt-2': !props.composer.message and !env.inChatWindow, 'mt-1': env.inChatWindow }" t-ref="main-actions">
            <t t-call="mail.Composer.emojiPicker"/>
            <t t-call="mail.Composer.attachFiles"/>
            <t t-if="ui.isSmall and props.composer.message" t-call="mail.Composer.sendButton"/>
            <t t-if="!extended" t-call="mail.Composer.fullComposer"/>
            <t t-if="hasSendButtonNonEditing" t-call="mail.Composer.sendButton"/>
        </div>
        <t t-if="extended" t-call="mail.Composer.fullComposer"/>
    </div>
</t>

`);
registerTemplate("mail.Composer.quickActions", `/mail/static/src/core/common/composer.xml`, `<t t-name="mail.Composer.quickActions" xml:space="preserve">
    <div class="o-mail-Composer-actions o-mail-Composer-quickActions d-flex rounded o-mail-Composer-bg" name="root" t-att-class="{ 'me-1': props.composer.message, 'me-2': extended }">
        <div class="o-mail-Composer-mainActions d-flex flex-grow-1 align-items-baseline mt-2" t-ref="main-actions">
            <t t-call="mail.Composer.emojiPicker"/>
        </div>
    </div>
</t>

`);
registerTemplate("mail.Composer.extraActions", `/mail/static/src/core/common/composer.xml`, `<t t-name="mail.Composer.extraActions" xml:space="preserve">
    <div class="o-mail-Composer-actions d-flex px-1 gap-1" name="root" t-att-class="{ 'mx-1': props.composer.message }">
        <div class="o-mail-Composer-mainActions d-flex flex-grow-1 align-items-baseline">
            <t t-call="mail.Composer.attachFiles"/>
            <t t-if="ui.isSmall and props.composer.message" t-call="mail.Composer.sendButton"/>
            <t t-if="!extended" t-call="mail.Composer.fullComposer"/>
            <t t-if="hasSendButtonNonEditing" t-call="mail.Composer.sendButton"/>
        </div>
        <t t-if="extended" t-call="mail.Composer.fullComposer"/>
    </div>
</t>

`);
registerTemplate("mail.Composer.emojiPicker", `/mail/static/src/core/common/composer.xml`, `<t t-name="mail.Composer.emojiPicker" xml:space="preserve">
    <button class="btn border-0 rounded-circle p-0" t-att-class="{'opacity-100': this.picker.state.picker === this.picker.PICKERS.EMOJI}" aria-label="Emojis" t-on-click="onClickAddEmoji" t-ref="emoji-button"><i class="fa fa-fw fa-lg fa-smile-o"/></button>
</t>

`);
registerTemplate("mail.Composer.attachFiles", `/mail/static/src/core/common/composer.xml`, `<t t-name="mail.Composer.attachFiles" xml:space="preserve">
    <FileUploader t-if="allowUpload" multiUpload="true" onUploaded.bind="(data) =&gt; { attachmentUploader.uploadData(data) }">
        <t t-set-slot="toggler">
            <button t-att-disabled="!state.active" class="o-mail-Composer-attachFiles btn border-0 rounded-circle p-0" title="Attach files" aria-label="Attach files" type="button" t-on-click="onClickAddAttachment"><i class="fa fa-fw fa-lg fa-paperclip"/></button>
        </t>
    </FileUploader>
</t>

    `);
registerTemplate("mail.Composer.suggestionSpecial", `/mail/static/src/core/common/composer.xml`, `<t t-name="mail.Composer.suggestionSpecial" xml:space="preserve">
        <strong class="px-2 py-1 align-self-center flex-shrink-0 text-truncate">
            <t t-esc="option.displayName"/>
        </strong>
        <em class="text-600 text-truncate align-self-center">
            <t t-esc="option.description"/>
        </em>
    </t>

    `);
registerTemplate("mail.Composer.suggestionPartner", `/mail/static/src/core/common/composer.xml`, `<t t-name="mail.Composer.suggestionPartner" xml:space="preserve">
        <t t-set="partner" t-value="option.partner"/>
        <ImStatus t-if="partner" persona="partner"/>
        <strong class="px-2 py-1 align-self-center flex-shrink-0 text-truncate">
            <t t-esc="partner.name"/>
        </strong>
        <span t-if="partner.email" class="text-600 text-truncate align-self-center">(<t t-esc="partner.email"/>)</span>
    </t>

    `);
registerTemplate("mail.Composer.suggestionThread", `/mail/static/src/core/common/composer.xml`, `<t t-name="mail.Composer.suggestionThread" xml:space="preserve">
        <strong class="px-2 py-1 align-self-center flex-shrink-0 text-truncate">
            <i t-attf-class="fa #{option.thread.parent_channel_id ? 'fa-comments-o' : 'fa-hashtag'} me-2"/>
            <t t-if="option.thread.parent_channel_id">
                <t t-esc="option.thread.parent_channel_id.displayName"/>
                <i class="oi oi-chevron-right o-xsmaller mx-1"/>
            </t>
            <t t-esc="option.thread.displayName"/>
        </strong>
    </t>

    `);
registerTemplate("mail.Composer.suggestionChannelCommand", `/mail/static/src/core/common/composer.xml`, `<t t-name="mail.Composer.suggestionChannelCommand" xml:space="preserve">
        <strong class="px-2 py-1 align-self-center flex-shrink-0 text-truncate">
            <t t-esc="option.label"/>
        </strong>
        <span class="text-600 text-truncate align-self-center">
            <t t-esc="option.help"/>
        </span>
    </t>

    `);
registerTemplate("mail.Composer.suggestionCannedResponse", `/mail/static/src/core/common/composer.xml`, `<t t-name="mail.Composer.suggestionCannedResponse" xml:space="preserve">
        <strong class="px-2 py-1 align-self-center flex-shrink-1 text-truncate">
            <t t-esc="option.source"/>
        </strong>
        <span class="text-600 text-truncate align-self-center" style="flex-basis: 20%;">
            <t t-esc="option.label"/>
        </span>
    </t>
`);
registerTemplate("mail.CountryFlag", `/mail/static/src/core/common/country_flag.xml`, `<t t-name="mail.CountryFlag" xml:space="preserve">
        <img class="o-mail-CountryFlag" t-att-class="props.class" t-att-title="props.country.name" t-att-src="props.country.flagUrl"/>
    </t>

`);
registerTemplate("mail.DateSection", `/mail/static/src/core/common/date_section.xml`, `<t t-name="mail.DateSection" xml:space="preserve">
    <div class="o-mail-DateSection d-flex align-items-center w-100 fw-bold z-1" t-attf-class="{{ props.className }}">
        <hr class="o-discuss-separator flex-grow-1"/>
        <span class="px-2 smaller text-muted opacity-75" t-att-class="{ 'user-select-none': isMobileOS }"><t t-esc="props.date"/></span>
        <hr class="o-discuss-separator flex-grow-1"/>
    </div>
</t>
`);
registerTemplate("mail.ImStatus", `/mail/static/src/core/common/im_status.xml`, `<t t-name="mail.ImStatus" xml:space="preserve">
        <div class="o-mail-ImStatus d-flex justify-content-center flex-shrink-0 align-items-center rounded-circle bg-inherit" t-attf-class="{{ props.className }}" t-att-style="props.style" t-att-class="{             'o-md': props.size === 'md' or props.size === 'medium',             'o-sm': props.size === 'sm' or props.size === 'small',         }">
            <span class="d-flex flex-column" name="icon" t-att-class="{                 'smaller': props.size === 'md' or props.size === 'medium',                 'o-xsmaller': props.size === 'sm' or props.size === 'small',             }">
                <t t-if="(!props.member or !props.member.isTyping) and persona">
                    <i t-if="persona.im_status === 'online'" class="fa fa-circle text-success" title="Online" role="img" aria-label="User is online"/>
                    <i t-elif="persona.im_status === 'away'" class="fa fa-circle o-away" title="Idle" role="img" aria-label="User is idle"/>
                    <i t-elif="persona.im_status === 'offline'" class="fa fa-circle-o text-700 opacity-75" title="Offline" role="img" aria-label="User is offline"/>
                    <i t-elif="persona.im_status === 'bot'" class="fa fa-heart text-success" title="Bot" role="img" aria-label="User is a bot"/>
                    <i t-else="" class="fa fa-fw fa-question-circle opacity-75" title="No IM status available"/>
                </t>
                <Typing t-if="props.member?.isTyping" member="props.member" channel="props.member.threadAsTyping" size="'medium'" displayText="false"/>
            </span>
        </div>
    </t>

`);
registerTemplate("mail.LinkPreview", `/mail/static/src/core/common/link_preview.xml`, `<t t-name="mail.LinkPreview" xml:space="preserve">
        <t t-if="props.linkPreview.isCard">
            <t t-call="mail.LinkPreviewCard"/>
        </t>
        <t t-if="props.linkPreview.isVideo">
            <t t-call="mail.LinkPreviewVideo"/>
        </t>
        <t t-if="props.linkPreview.isImage">
            <t t-call="mail.LinkPreviewImage"/>
        </t>
    </t>

    `);
registerTemplate("mail.LinkPreviewCard", `/mail/static/src/core/common/link_preview.xml`, `<t t-name="mail.LinkPreviewCard" xml:space="preserve">
        <div class="o-mail-LinkPreviewCard card position-relative w-100 mb-2 rounded bg-view shadow-sm overflow-hidden" t-att-class="{ 'me-2': env.inChatter }" t-attf-class="{{ className }}">
            <div class="row g-0 flex-row-reverse h-100">
                <div class="col min-w-0" t-att-class="{ 'd-flex align-items-center': !props.linkPreview.og_description }">
                    <div class="p-3">
                        <h6 class="card-title mb-0 me-2" t-attf-class="{{ props.linkPreview.og_description ? 'text-truncate' : 'overflow-hidden' }}">
                            <a t-att-href="props.linkPreview.source_url" target="_blank" t-out="props.linkPreview.og_title"/>
                        </h6>
                        <span t-if="props.linkPreview.og_site_name" t-out="props.linkPreview.og_site_name"/>
                        <p t-if="props.linkPreview.og_description" class="o-mail-LinkPreviewCard-description card-text mb-0 mt-2 text-muted small overflow-hidden" t-out="props.linkPreview.og_description"/>
                    </div>
                </div>
                <div class="o-mail-LinkPreviewCard-imageLinkWrap col-4 d-block">
                    <a t-att-href="props.linkPreview.source_url" target="_blank">
                        <img t-if="props.linkPreview.og_image" class="w-100 h-100 o_object_fit_cover" t-att-src="props.linkPreview.og_image" t-att-alt="props.linkPreview.og_title" t-on-load="onImageLoaded"/>
                        <span t-else="" class="d-flex align-items-center justify-content-center w-100 h-100 bg-100 text-300">
                            <i class="fa fa-camera fa-2x"/>
                        </span>
                    </a>
                </div>
            </div>
            <t t-if="props.deletable" t-call="mail.LinkPreview.aside">
                <t t-set="className" t-value="'fa fa-stack p-0 opacity-75 opacity-100-hover'"/>
            </t>
        </div>
    </t>

    `);
registerTemplate("mail.LinkPreviewImage", `/mail/static/src/core/common/link_preview.xml`, `<t t-name="mail.LinkPreviewImage" xml:space="preserve">
        <div class="o-mail-LinkPreviewImage position-relative mb-2 rounded" t-att-class="{ 'me-2': env.inChatter }" t-attf-class="{{ className }}">
            <a t-if="props.linkPreview.imageUrl" t-att-href="props.linkPreview.imageUrl" target="_blank">
                <img class="h-auto w-auto rounded" t-att-src="props.linkPreview.imageUrl" t-on-load="onImageLoaded"/>
            </a>
            <t t-if="props.deletable" t-call="mail.LinkPreview.aside">
                <t t-set="className" t-value="'btn btn-sm btn-dark mt-2 me-2 rounded opacity-75 opacity-100-hover'"/>
            </t>
        </div>
    </t>

    `);
registerTemplate("mail.LinkPreviewVideo", `/mail/static/src/core/common/link_preview.xml`, `<t t-name="mail.LinkPreviewVideo" xml:space="preserve">
        <div class="o-mail-LinkPreviewVideo card position-relative w-100 mb-2 rounded bg-view shadow-sm overflow-hidden" t-att-class="{ 'me-2': env.inChatter }" t-attf-class="{{ className }}">
            <div class="row g-0 flex-row-reverse h-100">
                <div class="col min-w-0" t-att-class="{ 'd-flex align-items-center': !props.linkPreview.og_description }">
                    <div class="p-3 bg-view">
                        <h6 class="o-mail-LinkPreviewVideo-title card-title mb-0 me-2" t-attf-class="{{ props.linkPreview.og_description ? 'text-truncate' : 'o-mail-LinkPreviewVideo-hasDescription overflow-hidden' }}">
                            <a t-att-href="props.linkPreview.source_url" target="_blank" t-esc="props.linkPreview.og_title"/>
                        </h6>
                        <p t-if="props.linkPreview.og_description" class="o-mail-LinkPreviewVideo-description o-mail-LinkPreviewVideo-hasDescription card-text mb-0 mt-2 text-muted small overflow-hidden" t-out="props.linkPreview.og_description"/>
                    </div>
                </div>
                <div class="o-mail-LinkPreviewVideo-videoWrap col-4 d-block">
                    <a t-att-href="props.linkPreview.source_url" target="_blank">
                        <div t-if="props.linkPreview.og_image" class="o-mail-LinkPreviewVideo-overlay position-relative h-100 opacity-trigger-hover">
                            <img class="img-fluid h-100 rounded-bottom o_object_fit_cover" t-att-src="props.linkPreview.og_image" t-att-alt="props.linkPreview.og_title" t-on-load="onImageLoaded"/>
                            <div class="position-absolute top-50 start-50 translate-middle">
                                <div class="o-mail-LinkPreviewVideo-play btn btn-lg rounded opacity-75 opacity-100-hover transition-base">
                                    <i class="fa fa-play"/>
                                </div>
                            </div>
                        </div>
                        <span t-else="" class="d-flex align-items-center justify-content-center w-100 h-100 bg-100 text-300">
                            <i class="fa fa-camera fa-2x"/>
                        </span>
                    </a>
                </div>
            </div>
            <t t-if="props.deletable" t-call="mail.LinkPreview.aside">
                <t t-set="className" t-value="'fa fa-stack p-0 opacity-75 opacity-100-hover'"/>
            </t>
        </div>
    </t>

    `);
registerTemplate("mail.LinkPreview.aside", `/mail/static/src/core/common/link_preview.xml`, `<t t-name="mail.LinkPreview.aside" xml:space="preserve">
        <div class="position-absolute top-0 end-0 small">
            <button t-attf-class="{{ className }}" class="o-mail-LinkPreview-aside btn" aria-label="Remove" t-on-click="onClick">
                <i class="fa fa-times"/>
            </button>
        </div>
    </t>
`);
registerTemplate("mail.LinkPreviewConfirmDelete", `/mail/static/src/core/common/link_preview_confirm_delete.xml`, `<t t-name="mail.LinkPreviewConfirmDelete" xml:space="preserve">
        <Dialog size="'md'" title.translate="Confirmation" modalRef="modalRef">
            <p class="mx-3 mb-3">Do you really want to delete this preview?</p>
            <t t-component="props.LinkPreview" linkPreview="props.linkPreview" deletable="false"/>
            <t t-set-slot="footer">
                <button class="btn btn-danger me-2" t-on-click="onClickOk">Delete</button>
                <button t-if="message.linkPreviews.length &gt; 1" class="btn btn-outline-danger me-2" t-on-click="onClickDeleteAll">Delete all previews</button>
                <button class="btn btn-secondary me-2" t-on-click="onClickCancel">Cancel</button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("mail.LinkPreviewList", `/mail/static/src/core/common/link_preview_list.xml`, `<t t-name="mail.LinkPreviewList" xml:space="preserve">
        <div class="o-mail-LinkPreviewList d-flex flex-column mt-2" t-att-class="{ 'me-2 pe-4': env.inChatWindow and !env.alignedRight, 'ms-2 ps-4': env.inChatWindow and env.alignedRight }">
            <div class="d-flex flex-grow-1 flex-wrap">
                <t t-foreach="props.linkPreviews" t-as="linkPreview" t-key="linkPreview.id">
                   <LinkPreview linkPreview="linkPreview" deletable="props.deletable"/>
                </t>
            </div>
        </div>
    </t>
`);
registerTemplate("mail.MailAttachmentDropzone", `/mail/static/src/core/common/mail_attachment_dropzone.xml`, `<t t-name="mail.MailAttachmentDropzone" xml:space="preserve">
        <Dropzone t-props="this.props">
            <h4>Drop Files here <i class="fa fa-paperclip"/></h4>
        </Dropzone>
    </t>
`);
registerTemplate("mail.Message", `/mail/static/src/core/common/message.xml`, `<t t-name="mail.Message" xml:space="preserve">
        <div t-if="message.isNotification" class="o-mail-NotificationMessage text-break mx-auto text-muted opacity-75 px-3 text-center smaller" t-on-click="onClickNotificationMessage" t-att-class="props.className" t-ref="root">
            <i t-if="message.notificationIcon" t-attf-class="{{ message.notificationIcon }} me-1"/>
            <span class="o-mail-NotificationMessage-author d-inline" t-if="authorName and !message.body.includes(escape(authorName))" t-esc="authorName"/> <t t-out="message.body"/>
        </div>
        <ActionSwiper t-else="" onRightSwipe="hasTouch() and props.thread?.eq(store.inbox) ? { action: () =&gt; this.message.setDone(), bgColor: 'bg-success', icon: 'fa-check-circle' } : undefined">
            <div class="o-mail-Message position-relative rounded-0" t-att-class="attClass" role="group" t-att-aria-label="messageTypeText" t-on-click="onClick" t-on-mouseenter="onMouseenter" t-on-mouseleave="onMouseleave" t-ref="root" t-if="message.exists()">
                <div class="o-mail-Message-core position-relative d-flex flex-shrink-0">
                    <div class="o-mail-Message-sidebar d-flex flex-shrink-0" t-att-class="{ 'justify-content-end': isAlignedRight, 'align-items-start justify-content-start': !isAlignedRight, 'o-inChatWindow': env.inChatWindow }">
                        <div t-if="!props.squashed" class="o-mail-Message-avatarContainer position-relative bg-view" t-att-class="getAvatarContainerAttClass()">
                            <img class="o-mail-Message-avatar w-100 h-100 rounded" t-att-src="authorAvatarUrl" t-att-class="authorAvatarAttClass"/>
                        </div>
                        <t t-elif="message.isPending" t-call="mail.Message.pendingStatus"/>
                        <t t-elif="!message.is_transient">
                            <small t-if="isActive and props.showDates" class="o-mail-Message-date o-xsmaller mt-2 text-center lh-1" t-att-title="message.datetimeShort">
                                <t t-esc="message.dateSimple"/>
                            </small>
                        </t>
                    </div>
                    <div class="w-100 o-min-width-0" t-att-class="{ 'flex-grow-1': message.composer }" t-ref="messageContent">
                        <div t-if="!props.squashed" class="o-mail-Message-header d-flex flex-wrap align-items-baseline lh-1" t-att-class="{ 'mb-1': !message.is_note }" name="header">
                            <span t-if="authorName and shouldDisplayAuthorName" class="o-mail-Message-author small" t-att-class="getAuthorAttClass()">
                                <strong class="me-1" t-esc="authorName"/>
                            </span>
                            <t t-if="!isAlignedRight" t-call="mail.Message.notification"/>
                            <small t-if="!message.is_transient" class="o-mail-Message-date o-xsmaller" t-att-title="message.datetimeShort">
                                <t t-if="message.isPending" t-call="mail.Message.pendingStatus"/>
                                <t t-else="" t-out="message.dateSimpleWithDay"/>
                            </small>
                            <small t-if="isPersistentMessageFromAnotherThread" t-on-click.prevent="openRecord" class="ms-1 text-500">
                                <t t-if="message.thread.model !== 'discuss.channel'">
                                    on <a t-att-href="message.resUrl"><t t-esc="message.thread.displayName"/></a>
                                </t>
                                <t t-else="">
                                    (from <a t-att-href="message.resUrl"><t t-esc="message.thread.prefix"/><t t-esc="message.thread.displayName or message.default_subject"/></a>)
                                </t>
                            </small>
                            <div t-if="props.message.scheduledDatetime" t-att-class="{ 'ms-2': (props.isInChatWindow and isAlignedRight) or (isPersistentMessageFromAnotherThread) }" t-att-title="props.message.scheduledDateSimple">
                                <span class="text-600 cursor-pointer">
                                    <i class="fa fa-calendar-o"/>
                                </span>
                            </div>
                            <t t-if="isAlignedRight" t-call="mail.Message.notification"/>
                            <t t-if="message.is_note" t-call="mail.Message.actions"/>
                        </div>
                        <div class="o-mail-Message-contentContainer position-relative d-flex" t-att-class="{                                    'flex-row-reverse': isAlignedRight,                                    }">
                            <div class="o-mail-Message-content o-min-width-0" t-att-class="{ 'w-100': state.isEditing, 'opacity-50': message.isPending, 'pt-1': message.is_note }">
                                <div class="o-mail-Message-textContent position-relative d-flex" t-att-class="{ 'w-100': state.isEditing }">
                                    <t t-if="message.message_type === 'notification' and message.body" t-call="mail.Message.bodyAsNotification" name="bodyAsNotification"/>
                                    <t t-if="message.message_type !== 'notification' and !message.is_transient and (message.hasTextContent or message.subtype_description or state.isEditing or message.edited)">
                                        <LinkPreviewList t-if="!state.isEditing and message.linkPreviewSquash" linkPreviews="message.linkPreviews" deletable="false"/>
                                        <t t-else="">
                                            <div class="position-relative overflow-x-auto overflow-y-hidden d-inline-block" t-att-class="{ 'w-100': state.isEditing }">
                                                <div t-if="message.bubbleColor" class="o-mail-Message-bubble rounded-bottom-3 position-absolute top-0 start-0 w-100 h-100 border" t-att-class="{                                                     'o-blue': message.bubbleColor === 'blue',                                                     'o-green': message.bubbleColor === 'green',                                                     'o-orange': message.bubbleColor === 'orange',                                                     }" t-attf-class="{{ isAlignedRight ? 'rounded-start-3' : 'rounded-end-3' }}"/>
                                                <MessageInReply t-if="message.parentMessage" message="message" onClick="props.onParentMessageClick"/>
                                                <div class="position-relative text-break o-mail-Message-body" t-att-class="{                                                             'p-1': message.is_note,                                                             'fs-1': !state.isEditing and !env.inChatter and message.onlyEmojis,                                                             'mb-0': !message.is_note,                                                             'py-2': !message.is_note and !state.isEditing,                                                             'pt-2 pb-1': !message.is_note and state.isEditing,                                                             'o-note': message.is_note,                                                             'align-self-start rounded-end-3 rounded-bottom-3': !state.isEditing and !message.is_note,                                                             'flex-grow-1': state.isEditing,                                                             }" t-ref="body">
                                                    <Composer t-if="state.isEditing" autofocus="true" composer="message.composer" onDiscardCallback.bind="exitEditMode" onPostCallback.bind="exitEditMode" mode="env.inChatter ? 'extended' : 'compact'" sidebar="false"/>
                                                    <t t-else="">
                                                        <em t-if="message.subject and !message.isSubjectSimilarToThreadName and !message.isSubjectDefault" class="d-block text-muted smaller">Subject: <t t-out="props.messageSearch?.highlight(message.subject) ?? message.subject"/></em>
                                                        <div class="overflow-x-auto" t-if="message.message_type and message.message_type.includes('email')" t-ref="shadowBody"/>
                                                        <t t-elif="state.showTranslation" t-out="message.translationValue"/>
                                                        <t t-elif="message.body" t-out="props.messageSearch?.highlight(message.body) ?? message.body"/>
                                                        <p class="fst-italic text-muted small" t-if="state.showTranslation">
                                                            <t t-if="message.translationSource" t-esc="translatedFromText"/>
                                                        </p>
                                                        <p class="fst-italic text-muted small" t-if="message.translationErrors">
                                                            <i class="text-danger fa fa-warning" role="img" aria-label="Translation Failure"/>
                                                            <t t-if="message.translationErrors" t-esc="translationFailureText"/>
                                                        </p>
                                                        <t t-if="showSubtypeDescription" t-out="props.messageSearch?.highlight(message.subtype_description) ?? message.subtype_description"/>
                                                    </t>
                                                </div>
                                                <div class="o-mail-Message-seenContainer position-absolute">
                                                    <MessageSeenIndicator t-if="showSeenIndicator" message="props.message" thread="props.thread"/>
                                                </div>
                                            </div>
                                        </t>
                                    </t>
                                    <t t-if="!message.is_note and message.hasTextContent and !env.inChatWindow" t-call="mail.Message.actions"/>
                                </div>
                                <AttachmentList t-if="message.attachment_ids.length &gt; 0" attachments="message.attachment_ids.map((a) =&gt; a)" unlinkAttachment.bind="onClickAttachmentUnlink" imagesHeight="message.attachment_ids.length === 1 ? 300 : 75" messageSearch="props.messageSearch"/>
                                <LinkPreviewList t-if="message.linkPreviews.length &gt; 0 and store.hasLinkPreviewFeature and !message.linkPreviewSquash" linkPreviews="message.linkPreviews" deletable="props.message.editable"/>
                            </div>
                            <t t-if="!message.is_note and (!message.hasTextContent or env.inChatWindow)" t-call="mail.Message.actions"/>
                        </div>
                        <MessageReactions message="message" openReactionMenu="openReactionMenu" t-if="message.reactions.length"/>
                    </div>
                </div>
            </div>
        </ActionSwiper>
    </t>

`);
registerTemplate("mail.Message.edited", `/mail/static/src/core/common/message.xml`, `<t t-name="mail.Message.edited" xml:space="preserve">
    <em class="smaller fw-bold text-500"> (edited)</em>
</t>

`);
registerTemplate("mail.Message.actions", `/mail/static/src/core/common/message.xml`, `<t t-name="mail.Message.actions" xml:space="preserve">
    <div t-if="props.hasActions and message.hasActions and !state.isEditing" class="o-mail-Message-actions d-print-none" t-att-class="{             'start-0': isAlignedRight,             'mx-1': !isMobileOS,             'mt-1': !message.is_note,             'my-n2': message.is_note,             'invisible': !isActive and !isMobileOS,             'o-expanded': optionsDropdown.isOpen         }">
        <t t-if="isMobileOS and !mobileExpanded" t-call="mail.Message.expandAction"/>
        <t t-else="">
            <t t-set="isReverse" t-value="env.inChatWindow and isAlignedRight"/>
            <div class="d-flex rounded-1 overflow-hidden" t-att-class="{ 'flex-row-reverse': isReverse }">
                <t t-set="quickActions" t-value="messageActions.actions.slice(0, messageActions.actions.length gt quickActionCount ? quickActionCount - 1 : quickActionCount)"/>
                <t t-foreach="quickActions" t-as="action" t-key="action.id">
                    <t t-set="isStart" t-value="(!isReverse and action.isFirst) or (isReverse and action.isLast)"/>
                    <t t-set="isEnd" t-value="(!isReverse and action.isLast) or (isReverse and action.isFirst)"/>
                    <t t-if="action.callComponent" t-component="action.callComponent" t-props="action.props" classNames="{                         'rounded-start-1': isStart,                         'rounded-end-1': isEnd,                     }"/>
                    <button t-else="" class="btn border-0 px-1 py-0 rounded-0" t-att-title="action.title" t-att-name="action.id" t-on-click.stop="action.onClick" t-att-class="{                         'rounded-start-1': isStart,                         'rounded-end-1': isEnd,                     }">
                        <i class="fa-lg" t-att-class="action.icon"/>
                    </button>
                </t>
                <div t-if="messageActions.actions.length gt quickActionCount" class="d-flex rounded-0">
                    <Dropdown state="optionsDropdown" position="props.message.threadAsNewest  ? 'top-start' : 'bottom-start'" menuClass="'d-flex flex-column py-0 o-mail-Message-moreMenu bg-100 border-secondary'">
                        <t t-call="mail.Message.expandAction"/>
                        <t t-set-slot="content">
                            <t t-foreach="messageActions.actions.slice(quickActionCount - 1)" t-as="action" t-key="action.id">
                                <DropdownItem class="'px-2 py-1 d-flex align-items-center rounded-0 ' + action.btnClass" onSelected="action.onClick" attrs="{ title: action.title}">
                                    <t t-if="action.callComponent" t-component="action.callComponent" t-props="action.props"/>
                                    <t t-else="">
                                        <i class="fa-fw" t-att-class="action.icon"/>
                                        <span class="mx-2" t-esc="action.title"/>
                                    </t>
                                </DropdownItem>
                            </t>
                        </t>
                    </Dropdown>
                </div>
                <t t-foreach="Array.from({ length: quickActionCount - quickActions.length - 1 })" t-as="emptyQuickAction" t-key="emptyQuickAction_index">
                    <button class="btn border-0 px-1 py-0 rounded-0 opacity-0 pe-none">
                        <i class="fa-lg fa fa-question"/>
                    </button>
                </t>
            </div>
        </t>
    </div>
</t>


`);
registerTemplate("mail.Message.expandAction", `/mail/static/src/core/common/message.xml`, `<t t-name="mail.Message.expandAction" xml:space="preserve">
    <button class="btn border-0 rounded-0" t-att-title="expandText" t-on-click="openMobileActions" t-att-class="{         'o-mail-Message-openActionMobile opacity-25 p-2 mt-n2 rounded-circle user-select-none': isMobileOS and !mobileExpanded,         'me-n2': isMobileOS and !mobileExpanded and isAlignedRight,         'ms-n2': isMobileOS and !mobileExpanded and !isAlignedRight,         'px-2 py-0': !isMobileOS,         'rounded-start-1': !isMobileOS and isReverse,         'rounded-end-1': !isMobileOS and !isReverse,     }">
        <i class="fa fa-lg fa-ellipsis-v" t-att-class="{ 'order-1': props.isInChatWindow, 'fa-fw': isMobileOS }" tabindex="1"/>
    </button>
</t>

`);
registerTemplate("mail.Message.notification", `/mail/static/src/core/common/message.xml`, `<t t-name="mail.Message.notification" xml:space="preserve">
    <div t-if="message.thread?.eq(props.thread) and message.notifications.length &gt; 0" class="mx-1">
        <span class="o-mail-Message-notification cursor-pointer opacity-100-hover" t-att-class="message.failureNotifications.length &gt; 0 ? 'text-danger opacity-75' : 'opacity-50'" role="button" tabindex="0" t-on-click="onClickNotification">
            <i t-att-class="message.notifications[0].icon" role="img" aria-label="Delivery failure"/> <span class="fw-bold small" t-if="message.notifications[0].label" t-out="message.notifications[0].label"/>
        </span>
    </div>
</t>

`);
registerTemplate("mail.Message.bodyAsNotification", `/mail/static/src/core/common/message.xml`, `<t t-name="mail.Message.bodyAsNotification" xml:space="preserve">
    <div class="o-mail-Message-body text-break mb-0 w-100" t-att-class="{'o-note': message.message_type == 'notification'}">
        <t t-out="props.messageSearch?.highlight(message.body) ?? message.body"/>
    </div>
</t>

`);
registerTemplate("mail.Message.pendingStatus", `/mail/static/src/core/common/message.xml`, `<t t-name="mail.Message.pendingStatus" xml:space="preserve">
    <button t-if="message.postFailRedo" class="btn p-0" title="Failed to post the message. Click to retry" t-on-click="() =&gt; message.postFailRedo?.()"><i class="fa fa-fw fa-warning text-warning"/></button>
    <span t-else="" class="o-mail-Message-pendingProgress"><i class="fa fa-fw fa-circle-o-notch fa-spin opacity-50"/></span>
</t>

`);
registerTemplate("mail.Message.mentionedChannelIcon", `/mail/static/src/core/common/message.xml`, `<t t-name="mail.Message.mentionedChannelIcon" xml:space="preserve">
    <i t-att-class="icon"/>
</t>

`);
registerTemplate("mail.MessageActionMenuMobile", `/mail/static/src/core/common/message_action_menu_mobile.xml`, `<t t-name="mail.MessageActionMenuMobile" xml:space="preserve">
        <Dialog size="'lg'" header="false" footer="false" contentClass="'o-discuss-mobileContextMenu d-flex position-absolute bottom-0 rounded-0 h-50 bg-100'" modalRef="modalRef" withBodyPadding="false">
            <div class="btn-group d-flex flex-column rounded-3 gap-1 p-3" t-on-click.stop="">
                <t t-foreach="messageActions.actions.slice(quickActionCount)" t-as="action" t-key="action.id">
                    <button class="btn px-3 py-3 d-flex align-items-center rounded-0 btn-group-item gap-3 user-select-none bg-200" t-att-class="{ 'rounded-top-3': action_first, 'rounded-bottom-3': action_last }" t-on-click="() =&gt; this.onClickAction(action)">
                        <i class="fa-lg fa-fw fs-2" t-att-class="action.icon"/>
                        <span class="fs-4" t-esc="action.title"/>
                    </button>
                </t>
            </div>
        </Dialog>
    </t>
`);
registerTemplate("mail.MessageCardList", `/mail/static/src/core/common/message_card_list.xml`, `<t t-name="mail.MessageCardList" xml:space="preserve">
        <div class="o-mail-MessageCardList d-flex flex-column" t-att-class="{ 'justify-content-center flex-grow-1': props.messages.length === 0 }" t-ref="message-list">
            <div class="card mb-2" t-foreach="props.messages" t-as="message" t-key="message.id">
                <div class="card-body py-2">
                    <div class="position-absolute top-0 end-0 z-1 mx-2 my-1">
                        <a role="button" class="o-mail-MessageCard-jump rounded bg-400 badge opacity-0" t-att-class="{ 'opacity-100 py-1 px-2': ui.isSmall }" t-on-click="() =&gt; this.onClickJump(message)">Jump</a>
                        <button t-if="props.mode === 'pin'" class="btn btn-link text-reset ms-2 p-0" t-att-class="{ 'fs-5': ui.isSmall }" title="Unpin" t-on-click="message.unpin">
                            <i class="oi oi-close"/>
                        </button>
                    </div>
                    <Message hasActions="false" message="message" thread="props.thread" messageSearch="props.messageSearch"/>
                </div>
            </div>
            <span t-if="props.loadMore" t-ref="load-more"/>
            <p t-if="props.showEmpty !== undefined ? props.showEmpty : props.messages.length === 0" t-esc="emptyText" class="text-center fst-italic text-500 fs-6"/>
        </div>
    </t>

`);
registerTemplate("mail.MessageConfirmDialog", `/mail/static/src/core/common/message_confirm_dialog.xml`, `<t t-name="mail.MessageConfirmDialog" xml:space="preserve">
    <Dialog size="props.size" title="props.title">
        <p class="mx-3 mb-3" t-esc="props.prompt"/>
        <blockquote class="mx-3 mb-3 fst-normal" style="pointer-events:none;">
            <t t-component="messageComponent" message="props.message" hasActions="false"/>
        </blockquote>
        <t t-set-slot="footer">
            <button class="btn me-2" t-att-class="props.confirmColor" t-on-click="onClickConfirm" t-out="props.confirmText"/>
            <button class="btn btn-secondary me-2" t-on-click="props.close">Cancel</button>
        </t>
    </Dialog>
</t>

`);
registerTemplate("mail.MessageInReply", `/mail/static/src/core/common/message_in_reply.xml`, `<t t-name="mail.MessageInReply" xml:space="preserve">
        <div class="o-mail-MessageInReply mx-2 mt-1 p-1 pb-0">
            <small class="o-mail-MessageInReply-core o-mail-Message-bubble o-muted border position-relative d-flex px-2 py-1 rounded-3 rounded-start-0 d-inline-flex" t-att-class="{                 'o-blue': props.message.parentMessage.bubbleColor === 'blue',                 'o-green': props.message.parentMessage.bubbleColor === 'green',                 'o-orange': props.message.parentMessage.bubbleColor === 'orange',             }">
                <span t-if="!props.message.parentMessage.isEmpty" class="d-inline-flex align-items-center text-muted opacity-75" t-att-class="{ 'cursor-pointer opacity-100-hover': props.onClick }" t-on-click="() =&gt; this.props.onClick?.()">
                    <img class="o-mail-MessageInReply-avatar me-2 rounded o_object_fit_cover" t-att-src="authorAvatarUrl" t-att-title="props.message.parentMessage.author?.name ?? props.message.parentMessage.email_from" alt="Avatar"/>
                    <span class="o-mail-MessageInReply-content overflow-hidden smaller">
                        <b><t t-out="props.message.parentMessage.author?.name ?? props.message.parentMessage.email_from"/></b>:
                        <span class="o-mail-MessageInReply-message ms-1 text-break">
                            <t t-if="!props.message.parentMessage.isBodyEmpty">
                                <t t-out="props.message.parentMessage.body"/>
                                <em t-if="props.message.parentMessage.edited" class="smaller fw-bold text-500"> (edited)</em>
                            </t>
                            <t t-elif="props.message.parentMessage.attachment_ids.length &gt; 0">
                                <span class="me-2 fst-italic">Click to see the attachments</span>
                                <i class="fa fa-image"/>
                            </t>
                        </span>
                    </span>
                </span>
                <i t-else="" class="text-muted ms-2">Original message was deleted</i>
            </small>
        </div>
    </t>
`);
registerTemplate("mail.MessageNotificationPopover", `/mail/static/src/core/common/message_notification_popover.xml`, `<t t-name="mail.MessageNotificationPopover" xml:space="preserve">
        <div class="o-mail-MessageNotificationPopover m-2">
            <div t-foreach="props.message.notifications" t-as="notification" t-key="notification.id">
                <i class="me-2" t-att-class="notification.statusIcon" t-att-title="notification.statusTitle" role="img"/>
                <span t-if="notification.persona" t-esc="notification.persona.name"/>
            </div>
        </div>
    </t>

`);
registerTemplate("mail.MessageReactionButton", `/mail/static/src/core/common/message_reaction_button.xml`, `<t t-name="mail.MessageReactionButton" xml:space="preserve">
        <button class="btn px-1 py-0 lh-1 rounded-0 border-0" t-att-class="props.classNames" tabindex="1" t-att-title="props.action.title" aria-label="props.action.title" t-ref="emoji-picker"><i class="fa-lg" t-att-class="props.action.icon"/></button>
    </t>

`);
registerTemplate("mail.MessageReactionList", `/mail/static/src/core/common/message_reaction_list.xml`, `<t t-name="mail.MessageReactionList" xml:space="preserve">
        <Dropdown state="preview" position="'top-middle'" menuClass="'bg-view border-0 p-0 mt-1 overflow-visible shadow-sm'" manual="true">
            <t t-call="mail.MessageReactionList.button"/>
            <t t-set-slot="content">
                <t t-call="mail.MessageReactionList.preview"/>
            </t>
        </Dropdown>
    </t>

    `);
registerTemplate("mail.MessageReactionList.button", `/mail/static/src/core/common/message_reaction_list.xml`, `<t t-name="mail.MessageReactionList.button" xml:space="preserve">
        <button class="position-relative o-mail-MessageReaction btn d-flex p-0 border rounded-2 mb-1 fs-5 px-1 gap-1 align-items-center" t-on-click="() =&gt; this.onClickReaction(props.reaction)" t-on-contextmenu="onContextMenu" t-on-mouseenter="loadEmoji" t-ref="reactionButton" t-att-class="{             'o-selfReacted border-primary text-primary fw-bold': hasSelfReacted(props.reaction),             'bg-view border-secondary': !hasSelfReacted(props.reaction),             'ms-1': env.inChatWindow and env.alignedRight,             'me-1': !(env.inChatWindow and env.alignedRight),             'cursor-default': !props.message.canAddReaction(),         }">
            <span t-esc="props.reaction.content"/>
            <span class="small" t-esc="props.reaction.count"/>
        </button>
    </t>

    `);
registerTemplate("mail.MessageReactionList.preview", `/mail/static/src/core/common/message_reaction_list.xml`, `<t t-name="mail.MessageReactionList.preview" xml:space="preserve">
        <div class="o-mail-MessageReactionList-preview px-0 py-1 border cursor-pointer d-flex" t-on-click="(ev) =&gt; this.onClickReactionList(props.reaction)" t-ref="reactionList">
            <div class="d-flex align-items-center mx-2 gap-2">
                <span class="fs-1" t-esc="props.reaction.content"/>
                <span class="o-mail-MessageReactionList-previewText small me-1" t-esc="previewText(props.reaction)"/>
            </div>
        </div>
    </t>

`);
registerTemplate("mail.MessageReactionMenu", `/mail/static/src/core/common/message_reaction_menu.xml`, `<t t-name="mail.MessageReactionMenu" xml:space="preserve">
        <Dialog size="'md'" header="false" footer="false" contentClass="'o-mail-MessageReactionMenu h-50 d-flex'">
            <div class="d-flex h-100" t-on-keydown="onKeydown" t-ref="root">
                <div class="d-flex overflow-auto flex-column bg-100 p-2 h-100 border-end">
                    <t t-foreach="props.message.reactions" t-as="reaction" t-key="reaction.content">
                        <button class="btn p-1 rounded-2 mx-2 py-0 d-flex align-items-center" t-att-class="{ 'bg-200 border-primary': reaction.eq(state.reaction) }" t-att-title="getEmojiShortcode(reaction)" t-on-click="() =&gt; state.reaction = reaction">
                            <span class="mx-1 fs-2" t-esc="reaction.content"/>
                            <span class="mx-1 pe-2" t-att-class="{ 'text-primary': reaction.eq(state.reaction) }" t-esc="reaction.count"/>
                        </button>
                    </t>
                </div>
                <div class="d-flex overflow-auto flex-column flex-grow-1 bg-view p-2 h-100">
                    <div t-foreach="state.reaction.personas" t-as="persona" t-key="persona.id" class="o-mail-MessageReactionMenu-persona d-flex p-1 align-items-center" t-att-class="{ 'o-isDeviceSmall': ui.isSmall }">
                        <img class="rounded o_object_fit_cover o-mail-MessageReactionMenu-avatar" t-att-src="persona.avatarUrl"/>
                        <span class="d-flex flex-grow-1 align-items-center">
                            <span class="mx-2 text-truncate fs-6" t-esc="persona.name"/>
                            <div class="flex-grow-1"/>
                            <button t-if="persona.eq(store.self)" class="btn btn-light fa fa-trash rounded-pill bg-inherit border-0" title="Remove" t-on-click.stop="() =&gt; state.reaction.remove()"/>
                        </span>
                    </div>
                </div>
            </div>
        </Dialog>
    </t>

`);
registerTemplate("mail.MessageReactions", `/mail/static/src/core/common/message_reactions.xml`, `<t t-name="mail.MessageReactions" xml:space="preserve">
    <div class="o-mail-MessageReactions position-relative d-flex flex-wrap mt-n1" t-att-class="{             'flex-row-reverse me-3': env.inChatWindow and env.alignedRight,             'ms-3': !(env.inChatWindow and env.alignedRight) and (props.message.is_discussion),             'o-emojiPickerOpen': emojiPicker.isOpen,         }">
        <t t-foreach="props.message.reactions" t-as="reaction" t-key="reaction.content">
            <MessageReactionList message="this.props.message" openReactionMenu="this.props.openReactionMenu" reaction="reaction"/>
        </t>
        <button t-if="props.message.canAddReaction()" class="o-mail-MessageReactions-add btn bg-inherit d-flex px-1 py-0 border-0 rounded-0 mb-1 align-items-center fs-5 opacity-75 opacity-100-hover" title="Add Reaction" t-ref="add"><i class="oi fa-fw oi-smile-add"/></button>
    </div>
</t>
`);
registerTemplate("mail.MessageSeenIndicator", `/mail/static/src/core/common/message_seen_indicator.xml`, `<t t-name="mail.MessageSeenIndicator" xml:space="preserve">
        <span class="o-mail-MessageSeenIndicator position-relative" t-att-class="{ 'opacity-50': !props.message.hasEveryoneSeen, 'text-primary opacity-75': props.message.hasEveryoneSeen, 'cursor-pointer': props.message.channelMemberHaveSeen.length }" t-att-title="summary" t-attf-class="{{ props.className }}" t-on-click="openDialog">
            <t t-if="!props.message.isMessagePreviousToLastSelfMessageSeenByEveryone">
                <i t-if="props.message.hasSomeoneFetched or props.message.hasSomeoneSeen" class="fa fa-check ps-1"/>
                <i t-if="props.message.hasSomeoneSeen" class="o-second start-0 fa fa-check position-absolute"/>
            </t>
        </span>
    </t>

    `);
registerTemplate("mail.MessageSeenIndicatorPopover.card", `/mail/static/src/core/common/message_seen_indicator.xml`, `<t t-name="mail.MessageSeenIndicatorPopover.card" xml:space="preserve">
        <div class="o-mail-MessageSeenIndicatorPopover-card d-flex align-items-center gap-2">
            <span class="o_avatar position-relative o_card_avatar" style="width: 30px;height:30px;">
                <img t-att-src="member.persona.avatarUrl" class="w-100 h-100 rounded o_object_fit_cover"/>
            </span>
            <span class="fw-bold" t-esc="member.persona.name"/>
            <span t-if="member.lastSeenDt" class="ms-auto text-muted small" t-out="member.lastSeenDt"/>
        </div>
    </t>

    `);
registerTemplate("mail.MessageSeenIndicatorDialog", `/mail/static/src/core/common/message_seen_indicator.xml`, `<t t-name="mail.MessageSeenIndicatorDialog" xml:space="preserve">
        <Dialog size="'sm'" title.translate="Seen by:" footer="false" withBodyPadding="false">
            <ul class="list-group list-group-flush list-unstyled py-1" t-ref="content">
                <li class="list-group-item py-2" t-foreach="props.message.channelMemberHaveSeen" t-as="member" t-key="member.id">
                    <t t-call="mail.MessageSeenIndicatorPopover.card"/>
                </li>
            </ul>
        </Dialog>
    </t>

`);
registerTemplate("mail.NavigableList", `/mail/static/src/core/common/navigable_list.xml`, `<t t-name="mail.NavigableList" xml:space="preserve">
        <div class="o-mail-NavigableList bg-view m-0 p-0 shadow-sm" t-ref="root" t-att-class="props.class">
            <div t-if="show" class="o-open border d-flex flex-column bg-inherit" t-on-mousedown.prevent="">
                <div t-if="state.showLoading" t-att-class="{ 'position-absolute bg-inherit smaller o-mail-NavigableList-floatingLoading': props.options.length, 'bg-300': props.options.length and state.activeIndex === 0, 'o-mail-NavigableList-item': !props.options.length }">
                    <t t-call="mail.NavigableList.spinner"/>
                </div>
                <div t-foreach="sortedOptions" t-as="option" t-key="option_index" class="o-mail-NavigableList-item" t-att-class="option.classList" t-on-mouseenter="() =&gt; this.onOptionMouseEnter(option_index)" t-on-click="(ev) =&gt; this.selectOption(ev, option_index)">
                    <hr class="my-2" t-if="option.group != lastGroup and option_index != 0"/>
                    <a role="button" class="d-flex align-items-center w-100 px-3 py-1 small" t-att-class="{ 'o-mail-NavigableList-active': state.activeIndex === option_index }">
                        <t t-if="option.optionTemplate" t-call="{{ option.optionTemplate }}"/>
                        <t t-elif="props.optionTemplate" t-call="{{ props.optionTemplate }}"/>
                        <t t-else="" t-esc="option.label"/>
                    </a>
                    <t t-set="lastGroup" t-value="option.group"/>
                </div>
                <span t-if="props.hint" class="text-muted fst-italic form-text align-self-end m-0 me-1 smaller" t-esc="props.hint"/>
            </div>
        </div>
    </t>

    `);
registerTemplate("mail.NavigableList.spinner", `/mail/static/src/core/common/navigable_list.xml`, `<t t-name="mail.NavigableList.spinner" xml:space="preserve">
        <span class="d-flex align-items-center w-100 py-2 gap-1 text-muted opacity-75" t-att-class="{ 'px-1': props.options.length, 'px-4': !props.options.length }">
            <i class="fa fa-spin fa-circle-o-notch"/>
            Loading…
        </span>
    </t>
`);
registerTemplate("mail.Picker", `/mail/static/src/core/common/picker.xml`, `<t t-name="mail.Picker" xml:space="preserve">
    <div t-if="ui.isSmall" class="o-mail-Picker d-flex flex-column w-100" t-att-class="{'d-none': props.state.picker === props.PICKERS.NONE}">
        <PickerContent t-props="contentProps"/>
    </div>
</t>

`);
registerTemplate("mail.PickerContent", `/mail/static/src/core/common/picker_content.xml`, `<t t-name="mail.PickerContent" xml:space="preserve">
    <div class="o-mail-PickerContent d-flex flex-column flex-grow-1 o-min-height-0 bg-100 rounded-2" t-on-click="onClick">
        <div class="o-mail-PickerContent-picker d-flex flex-grow-1 rounded overflow-auto">
            <div t-if="props.state.picker === props.PICKERS.EMOJI" class="o-mail-PickerContent-emojiPicker d-flex flex-grow-1 mw-100">
                <EmojiPicker close="props.close" onSelect="props.pickers.emoji" state="props.state" storeScroll="props.storeScroll"/>
            </div>
        </div>
    </div>
</t>

`);
registerTemplate("mail.SearchMessageInput", `/mail/static/src/core/common/search_message_input.xml`, `<t t-name="mail.SearchMessageInput" xml:space="preserve">
        <div class="o-mail-SearchMessageInput d-flex py-2">
            <div class="input-group">
                <div class="o_searchview form-control d-flex align-items-center bg-view p-0" role="search" aria-autocomplete="list">
                    <div class="o_searchview_input_container d-flex flex-grow-1 flex-wrap gap-1 h-100">
                        <input type="text" class="o_searchview_input flex-grow-1 w-auto border-0 rounded-start px-2" accesskey="Q" placeholder="Search" t-model="state.searchTerm" t-on-keydown="onKeydownSearch" t-ref="autofocus" role="searchbox"/>
                    </div>
                </div>
                <button class="btn" t-att-class="state.searchedTerm === state.searchTerm ? 'btn-outline-secondary' : 'btn-secondary'" t-on-click="() =&gt; this.search()" aria-label="Search button">
                    <i t-if="!props.messageSearch.searching" class="o_searchview_icon oi oi-search" role="img" aria-label="Search Messages" title="Search Messages"/>
                    <i t-else="" class="fa fa-spin fa-spinner" aria-label="Search in progress" title="Search in progress"/>
                </button>
            </div>
            <button t-if="env.inChatter" class="btn btn-outline-secondary ms-3" t-on-click="() =&gt; this.clear()" aria-label="Close button">
                <i class="o_searchview_icon oi oi-close cursor-pointer" role="img" aria-label="Close search" title="Close"/>
            </button>
        </div>
    </t>
`);
registerTemplate("mail.SearchMessageResult", `/mail/static/src/core/common/search_message_result.xml`, `<t t-name="mail.SearchMessageResult" xml:space="preserve">
        <div class="o-mail-SearchMessageResult">
            <p t-if="MESSAGE_FOUND" class="o-mail-SearchMessagesPanel-title py-1 mb-0 fw-bolder text-center text-uppercase text-muted">
                <t t-out="MESSAGE_FOUND"/>
            </p>
            <MessageCardList messages="props.messageSearch.messages" thread="props.thread" mode="'search'" messageSearch="props.messageSearch" showEmpty="props.messageSearch.messages.length === 0 and props.messageSearch.searched" onClickJump="() =&gt; this.props.onClickJump?.()" loadMore="props.messageSearch.loadMore" onLoadMoreVisible.bind="onLoadMoreVisible"/>    
        </div>
    </t>
`);
registerTemplate("mail.SearchMessagesPanel", `/mail/static/src/core/common/search_messages_panel.xml`, `<t t-name="mail.SearchMessagesPanel" xml:space="preserve">
        <ActionPanel title="title" minWidth="200" initialWidth="400" icon="'oi oi-search'">
            <SearchMessageInput closeSearch="props.closeSearch" messageSearch="messageSearch" thread="props.thread"/>
            <SearchMessageResult thread="props.thread" messageSearch="messageSearch"/>
        </ActionPanel>
    </t>
`);
registerTemplate("mail.Thread", `/mail/static/src/core/common/thread.xml`, `<t t-name="mail.Thread" xml:space="preserve">
    <t t-if="!env.inChatter" t-call="mail.Thread.jumpUnread"/>
    <div class="o-mail-Thread position-relative flex-grow-1 d-flex flex-column overflow-auto" t-att-class="{ 'pb-5': env.inChatter?.aside, 'pb-4': !env.inChatter?.aside, 'px-3': !env.inChatter and !props.isInChatWindow }" t-ref="messages" tabindex="-1">
        <t t-if="!props.thread.isEmpty or props.thread.loadOlder or props.thread.hasLoadingFailed" name="content">
            <div class="d-flex flex-column position-relative flex-grow-1" t-att-class="{'justify-content-end': !env.inChatter and props.thread.model !== 'mail.box'}">
                <span class="position-absolute w-100 invisible" t-att-class="props.order === 'asc' ? 'bottom-0' : 'top-0'" t-ref="present-treshold" t-att-style="\`height: Min(\${PRESENT_THRESHOLD}px, 100%)\`"/>
                <t t-set="currentDay" t-value="0"/>
                <t t-if="props.order === 'asc'">
                    <t t-if="props.thread.loadOlder and !props.thread.isTransient and !props.thread.hasLoadingFailed" t-call="mail.Thread.loadOlder"/>
                    <t t-if="props.thread.hasLoadingFailed" t-call="mail.Thread.loadingError"/>
                </t>
                <span t-else="" class="pt-1" t-ref="load-newer"/>
                <t t-set="messages" t-value="orderedMessages"/>
                <t t-if="state.mountedAndLoaded" t-foreach="messages" t-as="msg" t-key="msg.id">
                    <t t-set="prevMsg" t-value="messages[msg_index -1]"/>
                    <t t-if="msg.dateDay !== currentDay and props.showDates">
                        <DateSection date="msg.dateDay" className="'pt-2 px-2'"/>
                        <t t-set="currentDay" t-value="msg.dateDay"/>
                    </t>
                    <div t-if="msg.threadAsFirstUnread?.eq(props.thread)" class="o-mail-Thread-newMessage d-flex align-items-center fw-bolder z-1 px-2">
                        <hr class="flex-grow-1 border-danger opacity-100"/><span class="ps-2 pe-1 bg-danger o-text-white rounded text-uppercase">New</span>
                    </div>
                    <Message asCard="props.thread.model === 'mail.box'" className="getMessageClassName(msg)" isInChatWindow="props.isInChatWindow" message="msg" previousMessage="prevMsg" registerMessageRef="registerMessageRef" messageToReplyTo="props.messageToReplyTo" squashed="isSquashed(msg, prevMsg)" onParentMessageClick.bind="() =&gt; msg.parentMessage and env.messageHighlight?.highlightMessage(msg.parentMessage, props.thread)" thread="props.thread" messageEdition="props.messageEdition" isFirstMessage="msg_first" hasActions="props.messageActions and !msg.eq(props.thread.from_message_id)" showDates="props.showDates"/>
                </t>
                <span t-if="props.order === 'asc'" class="pt-1" t-ref="load-newer"/>
                <t t-else="">
                    <t t-if="props.thread.loadOlder and !props.thread.isTransient and !props.thread.hasLoadingFailed" t-call="mail.Thread.loadOlder"/>
                    <t t-if="props.thread.hasLoadingFailed" t-call="mail.Thread.loadingError"/>
                </t>
            </div>
        </t>
        <t t-else="">
            <div class="o-mail-Thread-empty d-flex flex-column align-items-center justify-content-center text-muted h-100 opacity-75" t-att-class="{'p-4': props.showEmptyMessage}">
                <t t-if="props.thread.isLoaded and props.showEmptyMessage">
                    <t name="empty-message">
                        <span class="fs-1" style="filter: grayscale(1);">😶</span>
                        <span>The conversation is empty.</span>
                    </t>
                </t>
            </div>
        </t>
        <t t-call="mail.Thread.jumpPresent"/>
    </div>
</t>

`);
registerTemplate("mail.Thread.jumpPresent", `/mail/static/src/core/common/thread.xml`, `<t t-name="mail.Thread.jumpPresent" xml:space="preserve">
    <button t-if="props.showJumpPresent and state.showJumpPresent" class="o-mail-Thread-jumpPresent position-fixed p-2 rounded-circle lh-1 m-n3 user-select-none btn btn-light shadow-sm border border-secondary" t-ref="jump-present" t-on-click="() =&gt; this.jumpToPresent()" title="Jump to Present"><i class="oi text-muted" t-att-class="{ 'oi-chevron-down': props.order === 'asc', 'oi-chevron-up': props.order !== 'asc' }"/></button>
</t>

`);
registerTemplate("mail.Thread.jumpUnread", `/mail/static/src/core/common/thread.xml`, `<t t-name="mail.Thread.jumpUnread" xml:space="preserve">
    <span t-if="props.thread.showUnreadBanner" class="o-mail-Thread-banner d-flex cursor-pointer border-bottom border-warning smaller fw-bolder">
        <t t-set="alertClass" t-value="'alert alert-warning m-0 border-start-0 o-mail-Thread-bannerHover rounded-0 px-2 py-1 smaller'"/>
        <span t-attf-class="{{ alertClass }} flex-grow-1" t-on-click="onClickUnreadMessagesBanner" t-esc="newMessageBannerText"/>
        <span t-attf-class="{{ alertClass }}" t-on-click="() =&gt; props.thread.markAsRead({ sync: true })">Mark as Read<i class="ms-2 fa fa-check-square"/></span>
    </span>
</t>
`);
registerTemplate("mail.Thread.loadOlder", `/mail/static/src/core/common/thread.xml`, `<t t-name="mail.Thread.loadOlder" xml:space="preserve">
    <button class="btn btn-link" t-on-click="onClickLoadOlder" t-ref="load-older">Load More</button>
</t>

`);
registerTemplate("mail.Thread.loadingError", `/mail/static/src/core/common/thread.xml`, `<t t-name="mail.Thread.loadingError" xml:space="preserve">
    <div class="d-flex flex-grow-1 align-items-center justify-content-center flex-column">
        <div class="o-mail-Thread-error">
            An error occurred while fetching messages.
        </div>
        <button class="btn btn-link" t-on-click="onClickLoadOlder">
            Click here to retry
        </button>
    </div>
</t>
`);
registerTemplate("mail.ThreadIcon", `/mail/static/src/core/common/thread_icon.xml`, `<t t-name="mail.ThreadIcon" xml:space="preserve">
        <div class="o-mail-ThreadIcon d-flex justify-content-center flex-shrink-0" t-att-class="props.className">
            <t t-set="largeClass" t-value="props.size === 'large' ? 'fa-lg' : ''"/>
            <t t-if="props.thread.channel_type === 'channel'">
                <div t-if="props.thread.authorizedGroupFullName" class="fa fa-fw fa-hashtag" t-att-class="largeClass" t-att-title="props.thread.accessRestrictedToGroupText"/>
                <div t-if="!props.thread.authorizedGroupFullName" class="fa fa-fw fa-globe" t-att-class="largeClass" title="Public Channel"/>
            </t>
            <t t-elif="props.thread.channel_type?.includes('chat') and correspondent">
                <t name="chat">
                    <t name="chat_static">
                        <div t-if="correspondent.persona.im_status === 'online'" class="fa fa-fw fa-circle text-success" title="Online"/>
                        <div t-elif="correspondent.persona.im_status === 'offline'" class="fa fa-fw fa-circle-o opacity-75" title="Offline"/>
                        <div t-elif="correspondent.persona.im_status === 'away'" class="fa fa-fw fa-circle o-yellow" title="Away"/>
                        <div t-elif="correspondent.persona.im_status === 'bot'" class="fa fa-fw fa-heart text-success" title="Bot"/>
                        <div t-else="" class="fa-fw" t-att-class="largeClass" t-attf-class="#{ defaultChatIcon.class }" t-att-title="defaultChatIcon.title"/>
                    </t>
                </t>
            </t>
            <div t-elif="props.thread.channel_type === 'group'" class="o-mail-ThreadIcon fa fa-fw fa-users" t-att-class="largeClass" title="Grouped Chat"/>
            <t t-elif="props.thread.model === 'mail.box'">
                <div t-if="props.thread.id === 'inbox'" class="fa fa-fw fa-inbox" t-att-class="largeClass" title="Inbox"/>
                <div t-elif="props.thread.id === 'starred'" class="fa fa-fw fa-star-o" t-att-class="largeClass" title="Favorites"/>
                <div t-elif="props.thread.id === 'history'" class="fa fa-fw fa-history" t-att-class="largeClass" title="History"/>
            </t>
        </div>
    </t>

`);
registerTemplate("mail.Discuss", `/mail/static/src/core/public_web/discuss.xml`, `<t t-name="mail.Discuss" xml:space="preserve">
    <t t-set="partitionedActions" t-value="threadActions.partition"/>
    <div class="o-mail-Discuss d-flex h-100 flex-grow-1" t-att-class="{ 'flex-column align-items-center bg-view': ui.isSmall }" t-ref="root">
        <DiscussSidebar t-if="!ui.isSmall and props.hasSidebar"/>
        <div t-if="!(ui.isSmall and store.discuss.activeTab !== 'main')" class="o-mail-Discuss-content d-flex flex-column h-100 w-100 overflow-auto" t-ref="content">
            <div class="o-mail-Discuss-header px-3 d-flex flex-shrink-0 align-items-center border-bottom border-secondary z-1 flex-grow-0" t-ref="header">
                <t t-if="thread">
                    <div t-if="['channel', 'group', 'chat'].includes(thread.channel_type)" class="o-mail-Discuss-threadAvatar position-relative align-self-center align-items-center mt-2 mb-2 me-2">
                        <img class="rounded o_object_fit_cover" t-att-src="thread.parent_channel_id?.avatarUrl ?? thread.avatarUrl" alt="Thread Image"/>
                        <FileUploader t-if="!thread.parent_channel_id and thread.is_editable and thread.channel_type !== 'chat'" acceptedFileExtensions="'.bmp, .jpg, .jpeg, .png, .svg'" showUploadingText="false" multiUpload="false" onUploaded.bind="(data) =&gt; this.onFileUploaded(data)">
                            <t t-set-slot="toggler">
                                <a href="#" class="position-absolute z-1 h-100 w-100 rounded start-0 bottom-0" title="Upload Avatar">
                                    <i class="position-absolute top-50 start-50 fa fa-sm fa-pencil text-white"/>
                                </a>
                            </t>
                        </FileUploader>
                    </div>
                    <t t-else="">
                        <ThreadIcon className="'me-2 align-self-center'" size="'large'" thread="thread"/>
                    </t>
                    <CountryFlag t-if="thread.showCorrespondentCountry" country="thread.correspondentCountry" class="'o-mail-Discuss-headerCountry border'"/>
                    <ImStatus t-if="thread.channel_type === 'chat' and thread.correspondent" className="'me-1'" member="thread.correspondent"/>
                    <div class="d-flex flex-grow-1 align-self-center align-items-center h-100 py-2">
                        <div t-if="thread.parent_channel_id" class="d-flex align-items-center gap-1 ms-1">
                            <span class="fw-bolder cursor-pointer opacity-75 opacity-100-hover o-hover-text-underline" t-esc="thread.parent_channel_id.displayName" t-on-click="() =&gt; this.thread.parent_channel_id.open()"/>
                            <i class="oi oi-chevron-right o-xsmaller mx-1"/>
                        </div>
                        <AutoresizeInput className="'o-mail-Discuss-threadName fw-bolder flex-shrink-1 text-dark py-0 fs-4'" enabled="thread.is_editable or thread.channel_type === 'chat'" onValidate.bind="renameThread" value="thread.displayName"/>
                        <t t-if="thread.allowDescription and (thread.is_editable or (!thread.is_editable and thread.description))">
                            <div class="flex-shrink-0 mx-1 py-2 border-start"/>
                            <t t-set="autogrowDescriptionPlaceholder">Add a description</t>
                            <AutoresizeInput className="'o-mail-Discuss-threadDescription flex-shrink-1 text-muted small pt-1'" enabled="thread.is_editable" onValidate.bind="updateThreadDescription" placeholder="thread.is_editable ? autogrowDescriptionPlaceholder : ''" value="thread.description or ''"/>
                        </t>
                    </div>
                    <div class="o-mail-Discuss-headerActions flex-shrink-0 d-flex align-items-center ms-1">
                        <span t-if="partitionedActions.quick.length" class="o-mail-Discuss-headerActionsGroup btn-group border border-dark">
                            <t t-set="groupBefore" t-value="true"/>
                            <t t-foreach="partitionedActions.quick" t-as="action" t-key="action.id" t-call="mail.Discuss.action">
                                <t t-set="action" t-value="action"/>
                            </t>
                        </span>
                        <t t-else="" t-set="groupBefore" t-value="false"/>
                        <span t-if="groupBefore" class="text-muted align-self-stretch ms-2 me-1"/>
                        <span t-if="partitionedActions.other.length" class="o-mail-Discuss-headerActionsGroup btn-group border border-dark">
                         <t t-set="groupBefore" t-value="true"/>
                            <t t-foreach="partitionedActions.other" t-as="action" t-key="action.id" t-call="mail.Discuss.action">
                                <t t-set="action" t-value="action"/>
                            </t>
                        </span>
                        <t t-else="" t-set="groupBefore" t-value="false"/>
                        <span t-if="groupBefore" class="text-muted align-self-stretch ms-2 me-1"/>
                        <t t-foreach="partitionedActions.group.slice().reverse()" t-as="group" t-key="group_index">
                            <span t-if="group.length" class="o-mail-Discuss-headerActionsGroup btn-group border border-dark">
                                <t t-foreach="group" t-as="action" t-key="action.id" t-call="mail.Discuss.action">
                                    <t t-set="action" t-value="action"/>
                                </t>
                            </span>
                            <span t-if="!group_last" class="text-muted align-self-stretch ms-2 me-1"/>
                        </t>
                        <div t-if="store.inPublicPage and !ui.isSmall" class="d-flex align-items-center">
                            <img class="o-mail-Discuss-selfAvatar mx-1 rounded-circle o_object_fit_cover flex-shrink-0" alt="Avatar" t-att-src="store.self.avatarUrl"/>
                            <div class="lead fw-bold flex-shrink-1 text-dark">
                                <t t-if="store.self.type === 'partner'" t-esc="store.self.name"/>
                                <t t-else="">
                                    <AutoresizeInput className="'py-1'" onValidate.bind="renameGuest" value="store.self.name"/>
                                </t>
                            </div>
                        </div>
                    </div>
                </t>
            </div>
            <div class="o-mail-Discuss-main d-flex overflow-hidden flex-grow-1" t-ref="main">
                <t t-if="ui.isSmall" t-call="mail.Discuss.loading"/>
                <div class="o-mail-Discuss-core overflow-auto d-flex flex-grow-1 w-100" t-ref="core">
                    <t name="core-content">
                        <t t-if="thread">
                            <div class="o-mail-Discuss-threadContainer d-flex flex-column flex-grow-1">
                                <t name="thread"><Thread thread="thread" t-key="thread.localId" jumpPresent="state.jumpThreadPresent" messageEdition="messageEdition" messageToReplyTo="messageToReplyTo"/></t>
                                <Composer t-if="thread.model !== 'mail.box' or thread.eq(messageToReplyTo.thread)" t-key="thread.localId" composer="thread.composer" autofocus="true" messageEdition="messageEdition" messageToReplyTo="messageToReplyTo" onDiscardCallback="() =&gt; messageToReplyTo.cancel()" onPostCallback.bind="() =&gt; this.state.jumpThreadPresent++" dropzoneRef="contentRef" type="messageToReplyTo?.message ? (messageToReplyTo.message.is_note ? 'note' : 'message') : undefined"/>
                            </div>
                            <div t-if="threadActions.activeAction?.componentCondition" t-attf-class="{{ threadActions.activeAction.panelOuterClass }}" class="o-mail-Discuss-panelContainer h-100 border-start border-secondary flex-shrink-0">
                                <t t-component="threadActions.activeAction.component" thread="thread" t-props="threadActions.activeAction.componentProps"/>
                            </div>
                        </t>
                        <div t-elif="(!ui.isSmall or store.discuss.activeTab === 'main') and store.discuss.hasRestoredThread" class="d-flex flex-grow-1 align-items-center justify-content-center w-100 bg-view">
                            <h4 class="text-muted"><b><i>No conversation selected.</i></b></h4>
                        </div>
                    </t>
                </div>
            </div>
        </div>
        <MessagingMenu t-if="ui.isSmall"/>
    </div>
</t>

`);
registerTemplate("mail.Discuss.action", `/mail/static/src/core/public_web/discuss.xml`, `<t t-name="mail.Discuss.action" xml:space="preserve">
    <button class="btn px-1 btn-group-item btn-secondary bg-inherit m-0 border-0" t-attf-class="{{ action.isActive ? 'o-isActive' : '' }}" t-att-disabled="action.disabledCondition" t-att-title="action.name" t-att-name="action.id" t-on-click="() =&gt; action.onSelect()">
        <i t-if="action.iconLarge" t-att-class="action.iconLarge"/> <span t-if="action.text" t-esc="action.text"/>
    </button>
</t>

`);
registerTemplate("mail.MobileMailbox", `/mail/static/src/core/public_web/discuss.xml`, `<t t-name="mail.MobileMailbox" xml:space="preserve">
    <button class="btn btn-secondary flex-grow-1 p-2" t-att-class="{             'active o-active shadow-none': mailbox.eq(store.discuss.thread),         }" t-on-click="mailbox.setAsDiscussThread" t-esc="mailbox.name"/>
</t>

`);
registerTemplate("mail.Discuss.loading", `/mail/static/src/core/public_web/discuss.xml`, `<t t-name="mail.Discuss.loading" xml:space="preserve">
    <div t-if="store.channels.status === 'fetching'" class="d-flex flex-grow-1 align-items-center justify-content-center h-100 w-100 o-pointer-events-none">
        <h4 class="text-muted opacity-50 o-visible-short-delay"><b><i class="o-mail-Discuss-mobileLoading fa fa-circle-o-notch fa-spin"/></b></h4>
    </div>
</t>

`);
registerTemplate("mail.DiscussClientAction", `/mail/static/src/core/public_web/discuss_client_action.xml`, `<t t-name="mail.DiscussClientAction" xml:space="preserve">
        <Discuss/>
    </t>

`);
registerTemplate("mail.DiscussSidebar", `/mail/static/src/core/public_web/discuss_sidebar.xml`, `<t t-name="mail.DiscussSidebar" xml:space="preserve">
        <div class="o-mail-DiscussSidebar d-flex d-print-none flex-column overflow-auto flex-shrink-0 h-100 border-end border-secondary z-1 o-mail-discussSidebarBgColor gap-1" t-att-class="{ 'o-compact': store.discuss.isSidebarCompact }">
            <div class="o-mail-DiscussSidebar-top position-sticky justify-content-center top-0 z-2 o-mail-discussSidebarBgColor" t-att-class="{ 'pt-2 pb-1': !store.inPublicPage, 'pt-1': store.inPublicPage }">
                <div class="d-flex align-items-center justify-content-center" t-att-class="{ 'flex-column gap-2': store.discuss.isSidebarCompact }">
                    <t name="options-btn">
                        <Dropdown position="'right-start'" menuClass="'o-mail-DiscussSidebar-floatingMenu bg-100 border border-secondary px-0 py-1 mx-2 my-0 min-w-0 shadow-sm'">
                            <button class="o-mail-DiscussSidebar-optionsBtn btn btn-light p-0 align-items-center justify-content-center smaller border border-dark rounded-circle opacity-25 opacity-100-hover" title="Options" t-att-class="{ 'ms-auto': !store.discuss.isSidebarCompact, 'position-absolute': !store.discuss.isSidebarCompact and !store.inPublicPage, 'o-compact': store.discuss.isSidebarCompact }"><i class="fa fa-ellipsis-h fa-fw fa-lg" style="font-size: 15px;"/></button>
                            <t t-set-slot="content">
                                <div>
                                    <DropdownItem class="'px-2 py-1 d-flex align-items-center rounded-0'" onSelected="() =&gt; this.store.discuss.isSidebarCompact = !this.store.discuss.isSidebarCompact">
                                         <i class="fa fa-fw" t-att-class="{ 'fa-expand': store.discuss.isSidebarCompact, 'fa-compress': !store.discuss.isSidebarCompact }"/>
                                         <span class="mx-2">
                                             <t t-if="store.discuss.isSidebarCompact">Expand panel</t>
                                             <t t-else="">Collapse panel</t>
                                         </span>
                                     </DropdownItem>
                                </div>
                            </t>
                        </Dropdown>
                    </t>
                </div>
            </div>
            <t t-foreach="discussSidebarItems" t-as="item" t-key="item_index" t-component="item"/>
        </div>
    </t>
`);
registerTemplate("mail.MessagingMenu", `/mail/static/src/core/public_web/messaging_menu.xml`, `<t t-name="mail.MessagingMenu" xml:space="preserve">
    <t t-if="env.inDiscussApp" t-call="mail.MessagingMenu.content"/>
</t>

`);
registerTemplate("mail.MessagingMenu.content", `/mail/static/src/core/public_web/messaging_menu.xml`, `<t t-name="mail.MessagingMenu.content" xml:space="preserve">
    <div t-if="!(ui.isSmall and env.inDiscussApp and store.discuss.activeTab === 'main')" t-att-class="\`\${discussSystray.contentClass} o-mail-MessagingMenu\`">
        <div t-if="!env.inDiscussApp or store.discuss.activeTab !== 'main'" class="o-mail-MessagingMenu-list d-flex flex-column overflow-auto flex-grow-1 list-group list-group-flush px-2 py-1 gap-1" t-ref="notification-list">
            <t t-foreach="threads" name="threads" t-as="thread" t-key="thread.localId">
                <t t-set="message" t-value="thread.isChatChannel or (thread.channel_type === 'channel' and thread.needactionMessages.length === 0) ? thread.newestPersistentNotEmptyOfAllMessage : thread.needactionMessages.at(-1)"/>
                <NotificationItem isActive="state.activeIndex === itemIndex" body="message?.inlineBody or message?.subtype_description" counter="thread.needactionCounter" datetime="message?.datetime" iconSrc="thread.avatarUrl" hasMarkAsReadButton="thread.isUnread" muted="thread.mute_until_dt ? 2 : !thread.isUnread ? 1 : 0" onClick="(isMarkAsRead) =&gt; this.onClickThread(isMarkAsRead, thread)" onSwipeRight="hasTouch() and thread.isUnread ? { action: () =&gt; this.markAsRead(thread), icon: 'fa-check-circle', bgColor: 'bg-success' } : undefined" onSwipeLeft="hasTouch() and thread.canUnpin ? { action: () =&gt; thread.unpin(), icon: 'fa-times-circle', bgColor: 'bg-danger' } : undefined" nameMaxLine="1" textMaxLine="2">
                    <t t-set-slot="name">
                        <div t-if="thread.parent_channel_id" class="d-flex align-items-center">
                            <span class="text-truncate flex-shrink-0 opacity-75 mw-50" t-esc="thread.parent_channel_id.displayName"/>
                            <i class="oi oi-chevron-right o-xsmaller mx-1"/>
                            <span class="text-truncate min-w-0" t-esc="thread.displayName"/>
                        </div>
                        <t t-else="" t-esc="thread.displayName"/>
                    </t>
                    <t t-set-slot="icon">
                        <ImStatus t-if="thread.channel_type === 'chat' and thread.correspondent" member="thread.correspondent" className="'position-absolute top-100 start-100 translate-middle mt-n1 ms-n1'"/>
                        <CountryFlag t-if="thread.showCorrespondentCountry" country="thread.correspondentCountry" class="'o-mail-NotificationItem-country position-absolute border'"/>
                    </t>
                    <t t-if="message" t-set-slot="body-icon">
                        <t t-call="mail.message_preview_prefix">
                            <t t-set="message" t-value="message"/>
                        </t>
                    </t>
                </NotificationItem>
                <t t-set="itemIndex" t-value="itemIndex + 1"/>
            </t>
            <t t-if="store.channels.status === 'fetching'">
                <div class="d-flex align-items-center justify-content-center gap-2 py-4 px-2"><span class="o-visible-short-delay"><i class="fa fa-circle-o-notch fa-spin me-1"/> Loading…</span></div>
            </t>
        </div>
    </div>
    <div t-if="ui.isSmall" class="o-mail-MessagingMenu-navbar d-flex border-top bg-view shadow-lg w-100 btn-group">
        <button t-foreach="tabs" t-key="tab.id" t-as="tab" class="o-mail-MessagingMenu-tab btn d-flex flex-column align-items-center flex-grow-1 flex-basis-0 p-2 mx-0 pb-4" t-att-class="{             'text-primary fw-bolder o-active': store.discuss.activeTab === tab.id,             'border-end': !tab_last,         }" t-on-click="() =&gt; this.onClickNavTab(tab.id)">
            <i t-attf-class="p-2 fs-4 {{ tab.icon }}"/>
            <span class="small" t-esc="tab.label"/>
        </button>
    </div>
</t>

`);
registerTemplate("mail.NotificationItem", `/mail/static/src/core/public_web/notification_item.xml`, `<t t-name="mail.NotificationItem" xml:space="preserve">
    <ActionSwiper onLeftSwipe="props.onSwipeLeft ? props.onSwipeLeft : undefined" onRightSwipe="props.onSwipeRight ? props.onSwipeRight : undefined">
        <button class="o-mail-NotificationItem list-group-item d-flex cursor-pointer align-items-center w-100 gap-2 position-relative border rounded" t-on-click="onClick" t-ref="root" t-att-class="{             'o-important': props.muted === 0,             'text-muted border-transparent': props.muted === 1,             'opacity-50 border-transparent': props.muted === 2,             'p-2 o-small': ui.isSmall,             'border-top-0': props.first,             'pe-2 py-2': !ui.isSmall,             'o-active': props.isActive,         }">
            <span class="o-mail-NotificationItem-unreadIndicator position-absolute" t-att-class="{ 'opacity-0': props.muted, 'opacity-75': !props.muted }"><i class="fa fa-circle"/></span>
            <div class="o-mail-NotificationItem-avatarContainer position-relative bg-inherit flex-shrink-0 align-self-start" t-att-class="{ 'o-small': ui.isSmall }">
                <img class="o_avatar w-100 h-100 rounded" alt="Notification Item Image" t-att-src="props.iconSrc"/>
                <t t-slot="icon"/>
            </div>
            <div class="d-flex flex-column flex-grow-1 align-self-start overflow-auto">
                <div class="d-flex text-nowrap">
                    <span class="o-mail-NotificationItem-name fw-bold" t-att-class="{ 'fw-bold': props.muted, 'fw-bolder': !props.muted }" t-att-style="props.nameMaxLine !== undefined ? webkitLineClamp(props.nameMaxLine) : ''">
                        <t t-slot="name"/>
                    </span>
                    <span class="flex-grow-1"/>
                    <div class="d-flex align-items-center">
                        <span t-if="props.counter &gt; 0 and !rootHover.isHover" t-attf-class="o-mail-NotificationItem-badge o-discuss-badge {{props.muted === 2 ? 'o-muted' : ''}} d-flex align-items-center justify-content-center m-0 badge rounded-pill fw-bold o-mail-NotificationItem-counter"><t t-esc="props.counter"/></span>
                        <span t-if="props.hasMarkAsReadButton and rootHover.isHover" class="o-mail-NotificationItem-badge o-discuss-badgeShape text-success d-flex align-items-center justify-content-center m-0 badge rounded-pill fw-bold o-mail-NotificationItem-markAsRead fa fa-check text-600 opacity-75 opacity-100-hover cursor-pointer" title="Mark As Read" t-ref="markAsRead"/>
                    </div>
                </div>
                <div class="d-flex">
                    <div class="o-mail-NotificationItem-text opacity-75" t-att-class="{ 'fw-bold': !props.muted, 'text-truncate': props.textTruncate, 'text-start': !props.textTruncate  }" t-att-style="props.textMaxLine !== undefined ? webkitLineClamp(props.textMaxLine) : ''">
                        <t t-slot="body-icon"/>
                        <t t-if="props.body" t-esc="props.body" name="notificationBody"/>
                    </div>
                    <div class="flex-grow-1"/>
                    <small t-if="props.datetime" class="o-mail-NotificationItem-date ms-2 me-1 opacity-75 flex-shrink-0 align-self-end" t-att-class="{ 'fw-bold': !props.muted }" t-att-title="props.datetime?.toLocaleString(DateTime.DATETIME_SHORT) ?? ''">
                        <t t-esc="dateText"/>
                    </small>
                </div>
            </div>
            <t t-if="props.slots and props.slots.requestContent">
                <t t-slot="requestContent"/>
            </t>
        </button>
    </ActionSwiper>
</t>

`);
registerTemplate("mail.Activity", `/mail/static/src/core/web/activity.xml`, `<t t-name="mail.Activity" xml:space="preserve">
    <div class="o-mail-Activity d-flex py-1 mb-2" t-on-click="onClick">
        <div class="o-mail-Activity-sidebar flex-shrink-0 position-relative">
            <a role="button" t-on-click="onClickAvatar">
                <img class="w-100 h-100 rounded o_object_fit_cover" t-att-src="props.activity.persona.avatarUrl"/>
            </a>
            <div class="o-mail-Activity-iconContainer position-absolute top-100 start-100 translate-middle d-flex align-items-center justify-content-center mt-n1 ms-n1 rounded-circle w-50 h-50" t-att-class="{                        'text-bg-success': props.activity.state === 'planned',                        'text-bg-warning': props.activity.state === 'today',                        'text-bg-danger': props.activity.state === 'overdue',                        }">
                <i class="fa small" t-attf-class="{{ props.activity.icon }}"/>
            </div>
        </div>
        <div class="flex-grow px-3">
            <div class="o-mail-Activity-info lh-1">
                <span class="fw-bolder text-success" t-if="delay === 1">Tomorrow:</span>
                <span class="fw-bolder text-success" t-elif="delay gt 0">Due in <t t-esc="delay"/> days:</span>
                <span class="fw-bolder text-danger" t-elif="delay === -1">Yesterday:</span>
                <span class="fw-bolder text-danger" t-elif="delay lt 0"><t t-esc="-delay"/> days overdue:</span>
                <span class="fw-bolder text-warning" t-else="">Today:</span>
                <span class="fw-bolder px-2 text-break"><t t-esc="displayName"/></span>
                <span class="o-mail-Activity-user px-1">for <t t-esc="props.activity.persona.name"/></span>
                <button class="btn btn-link btn-primary p-0 lh-1 border-0">
                    <i class="fa fa-info-circle" role="img" title="Info" aria-label="Info" t-on-click="toggleDetails"/>
                </button>
            </div>
            <div t-if="state.showDetails">
                <table class="o-mail-Activity-details table table-sm mt-2">
                    <tbody>
                        <tr><td class="text-end fw-bolder">Activity type</td><td><t t-esc="props.activity.activity_type_id[1]"/></td></tr>
                        <tr><td class="text-end fw-bolder">Created</td><td><t t-esc="props.activity.dateCreateFormatted"/> by <t t-esc="props.activity.create_uid[1]"/></td></tr>
                        <tr><td class="text-end fw-bolder">Assigned to</td><td><t t-esc="props.activity.persona.name"/></td></tr>
                        <tr><td class="text-end fw-bolder">Due on</td><td><t t-esc="props.activity.dateDeadlineFormatted"/></td></tr>
                    </tbody>
                </table>
            </div>
            <div t-if="props.activity.note" class="o-mail-Activity-note text-break" t-out="props.activity.note"/>
            <div t-if="props.activity.mail_template_ids?.length &gt; 0" class="o-mail-Activity-mailTemplates">
                <ActivityMailTemplate activity="props.activity" onActivityChanged="props.onActivityChanged"/>
            </div>
            <div t-if="props.activity.can_write" class="lh-lg">
                <t name="tools">
                    <button class="o-mail-Activity-markDone btn btn-link btn-success p-0 me-3" t-on-click="onClickMarkAsDone">
                        <i class="fa fa-check"/> Mark Done
                    </button>
                    <FileUploader t-if="props.activity.activity_category === 'upload_file'" onUploaded.bind="onFileUploaded">
                        <t t-set-slot="toggler">
                            <button class="btn btn-link text-action p-0 me-3">
                                <i t-attf-class="fa {{ props.activity.icon }}"/> <t t-out="props.activity.display_name"/>
                            </button>
                        </t>
                    </FileUploader>
                    <button class="o-mail-Activity-edit btn btn-link text-action p-0 me-3" t-on-click="edit">
                        <i class="fa fa-pencil"/> Edit
                    </button>
                    <button class="btn btn-link btn-danger p-0" t-on-click="unlink">
                        <i class="fa fa-times"/> Cancel
                    </button>
                </t>
            </div>
        </div>
    </div>
</t>

`);
registerTemplate("mail.ActivityButton", `/mail/static/src/core/web/activity_button.xml`, `<t t-name="mail.ActivityButton" xml:space="preserve">
        <a class="o-mail-ActivityButton" role="button" t-on-click.prevent.stop="onClick" t-ref="button" t-att-aria-label="title" t-att-title="title">
            <i class="fa fa-fw fa-lg" t-att-class="buttonClass" role="img"/>
        </a>
    </t>
`);
registerTemplate("mail.ActivityListPopover", `/mail/static/src/core/web/activity_list_popover.xml`, `<t t-name="mail.ActivityListPopover" xml:space="preserve">
        <div class="o-mail-ActivityListPopover d-flex flex-column" t-ref="root">
            <div class="overflow-y-auto d-flex flex-column flex-grow-1">
                <span t-if="activities.length === 0" class="p-3 text-center fst-italic text-500 border-bottom fs-6">Schedule activities to help you get things done.</span>
                <t t-if="overdueActivities.length &gt; 0">
                    <div class="d-flex bg-100 py-2 border-bottom">
                        <span class="text-danger fw-bold mx-3">Overdue</span>
                        <span class="flex-grow-1"/>
                        <span class="badge rounded-pill text-bg-danger mx-3 align-self-center" t-esc="overdueActivities.length"/>
                    </div>
                    <ActivityListPopoverItem t-foreach="overdueActivities" t-as="activity" t-key="activity.id" activity="activity" onActivityChanged="props.onActivityChanged" onClickEditActivityButton="props.close" onClickDoneAndScheduleNext="props.close"/>
                </t>
                <t t-if="todayActivities.length &gt; 0">
                    <div class="d-flex bg-100 py-2 border-bottom">
                        <span class="o-mail-ActivityListPopover-todayTitle text-warning fw-bold mx-3">Today</span>
                        <span class="flex-grow-1"/>
                        <span class="badge rounded-pill text-bg-warning mx-3 align-self-center" t-esc="todayActivities.length"/>
                    </div>
                    <ActivityListPopoverItem t-foreach="todayActivities" t-as="activity" t-key="activity.id" activity="activity" onActivityChanged="props.onActivityChanged" onClickEditActivityButton="props.close" onClickDoneAndScheduleNext="props.close"/>
                </t>
                <t t-if="plannedActivities.length &gt; 0">
                    <div class="d-flex bg-100 py-2 border-bottom">
                        <span class="text-success fw-bold mx-3">Planned</span>
                        <span class="flex-grow-1"/>
                        <span class="badge rounded-pill text-bg-success mx-3 align-self-center" t-esc="plannedActivities.length"/>
                    </div>
                    <ActivityListPopoverItem t-foreach="plannedActivities" t-as="activity" t-key="activity.id" activity="activity" onActivityChanged="props.onActivityChanged" onClickEditActivityButton="props.close" onClickDoneAndScheduleNext="props.close"/>
                </t>
                <t t-if="doneActivities.length &gt; 0">
                    <div class="o-mail-ActivityListPopover-done d-flex bg-100 py-2 border-bottom">
                        <span class="fw-bold mx-3">Done</span>
                        <span class="flex-grow-1"/>
                        <span class="badge rounded-pill text-bg-secondary mx-3 align-self-center" t-esc="doneActivities.length"/>
                    </div>
                    <ActivityListPopoverItem t-foreach="doneActivities" t-as="activity" t-key="activity.id" activity="activity" onActivityChanged="props.onActivityChanged"/>
                </t>
            </div>
            <button class="btn btn-secondary p-3 text-center" t-on-click="onClickAddActivityButton">
                <t t-if="props.resIds"><i class="fa fa-plus fa-fw"/><strong>Schedule an activity on selected records</strong></t>
                <t t-else=""><i class="fa fa-plus fa-fw"/><strong>Schedule an activity</strong></t>
            </button>
        </div>
    </t>
`);
registerTemplate("mail.ActivityListPopoverItem", `/mail/static/src/core/web/activity_list_popover_item.xml`, `<t t-name="mail.ActivityListPopoverItem" xml:space="preserve">
        <div class="o-mail-ActivityListPopoverItem d-flex flex-column border-bottom py-2">
            <div class="overflow-auto d-flex align-items-baseline ms-3 me-1">
                <t t-if="props.activity.summary">
                    <b class="text-900 me-2 text-truncate flex-grow-1 flex-basis-0" t-esc="props.activity.summary"/>
                </t>
                <t t-if="!props.activity.summary and props.activity.activity_type_id">
                    <b class="text-900 me-2 text-truncate flex-grow-1" t-esc="props.activity.activity_type_id[1]"/>
                </t>
                <t t-if="props.activity.can_write">
                    <FileUploader t-if="hasFileUploader" onUploaded.bind="onFileUploaded">
                        <t t-set-slot="toggler">
                            <button class="btn btn-sm btn-success btn-link" title="Upload file" aria-label="Upload File">
                                <i class="fa fa-upload"/>
                            </button>
                        </t>
                    </FileUploader>
                    <button t-if="hasMarkDoneButton" class="o-mail-ActivityListPopoverItem-markAsDone btn btn-sm btn-success btn-link" title="Mark as done" aria-label="Mark as done" t-on-click="onClickMarkAsDone">
                        <i class="fa fa-check"/>
                    </button>
                </t>
                <button t-if="hasEditButton" class="o-mail-ActivityListPopoverItem-editbtn btn btn-sm btn-success btn-link" title="Edit" aria-label="Edit" t-on-click="onClickEditActivityButton">
                    <i class="fa fa-pencil"/>
                </button>
                <button t-if="hasCancelButton" class="o-mail-ActivityListPopoverItem-cancel btn btn-sm btn-danger btn-link" title="Cancel" aria-label="Cancel" t-on-click="unlink">
                    <i class="fa fa-times"/>
                </button>
            </div>
            <div class="d-flex align-items-center flex-wrap mx-3">
                <img t-if="props.activity.user_id[0]" class="me-2 rounded o_object_fit_cover" t-att-src="activityAssigneeAvatar" style="max-width: 1.5rem; max-height: 1.5rem;"/>
                <div class="mt-1">
                    <t t-if="props.activity.user_id[0]">
                        <small class="text-truncate" t-esc="props.activity.user_id[1]"/>
                        <small t-if="props.activity.state !== 'today'" class="mx-1">-</small>
                    </t>
                    <small t-if="['overdue', 'planned'].includes(props.activity.state)" class="fw-bold" t-att-title="props.activity.dateDeadlineFormatted" t-esc="delayLabel"/>
                    <small t-if="props.activity.state === 'done'" class="fw-bold" t-att-title="dateDoneFormatted" t-esc="props.activity.dateDoneFormatted"/>
                </div>
            </div>
            <div t-if="props.activity.attachment_ids?.length" class="mx-5">
                <t t-foreach="props.activity.attachment_ids" t-as="attachment" t-key="attachment.id">
                    <a t-attf-href="/web/content/#{attachment.id}?download=true" t-on-click.stop="" t-out="attachment.name" class="d-inline-block text-truncate" style="max-width: 120px;"/>
                    <br t-if="!attachment_last"/>
                </t>
            </div>
            <ActivityMarkAsDone t-if="state.hasMarkDoneView" activity="props.activity" close="closeMarkAsDone" onClickDoneAndScheduleNext="props.onClickDoneAndScheduleNext" onActivityChanged="props.onActivityChanged"/>
            <div t-if="props.activity.mail_template_ids.length &gt; 0" class="mx-3 mt-2">
                <ActivityMailTemplate activity="props.activity" onClickButtons="props.onClickEditActivityButton" onActivityChanged="props.onActivityChanged"/>
            </div>
        </div>
    </t>
`);
registerTemplate("mail.ActivityMailTemplate", `/mail/static/src/core/web/activity_mail_template.xml`, `<t t-name="mail.ActivityMailTemplate" xml:space="preserve">
        <t t-foreach="props.activity.mail_template_ids" t-as="mailTemplate" t-key="mailTemplate.id">
            <div class="d-flex align-items-baseline flex-wrap">
                <div class="text-truncate">
                    <i class="fa fa-envelope-o" title="Mail" role="img"/>
                    <span class="o-mail-ActivityMailTemplate-name ms-2" t-esc="mailTemplate.name"/>
                    <span>:</span>
                </div>
                <div class="d-flex align-items-baseline">
                    <button class="o-mail-ActivityMailTemplate-preview btn btn-link py-0" t-att-data-mail-template-id="mailTemplate.id" t-on-click="(ev) =&gt; this.onClickPreview(ev, mailTemplate)">
                        Preview
                    </button>
                    <em class="text-500">or</em>
                    <button class="o-mail-ActivityMailTemplate-send btn btn-link py-0" t-att-data-mail-template-id="mailTemplate.id" t-on-click="(ev) =&gt; this.onClickSend(ev, mailTemplate)">
                        Send Now
                    </button>
                </div>
            </div>
        </t>
    </t>
`);
registerTemplate("mail.ActivityMarkAsDone", `/mail/static/src/core/web/activity_markasdone_popover.xml`, `<t t-name="mail.ActivityMarkAsDone" xml:space="preserve">
        <div class="o-mail-ActivityMarkAsDone">
            <h6 t-if="props.hasHeader" class="p-2 fw-bolder bg-200 border-bottom">Mark Done</h6>
            <div class="py-2 px-3">
                <textarea class="form-control" style="min-height: 70px" rows="3" placeholder="Write Feedback" t-model="props.activity.feedback" t-ref="textarea"/>
                <div class="mt-2">
                    <button type="button" class="btn btn-sm btn-primary" aria-label="Done and Schedule Next" t-on-click="onClickDoneAndScheduleNext">
                        Done &amp; Schedule Next
                    </button>
                    <button t-if="isSuggested" type="button" class="btn btn-sm btn-primary mx-2" aria-label="Done" t-on-click="onClickDone">
                        Done
                    </button>
                    <button type="button" class="btn btn-sm btn-link" t-on-click="props.close">
                        Discard
                    </button>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("mail.ActivityMenu", `/mail/static/src/core/web/activity_menu.xml`, `<t t-name="mail.ActivityMenu" xml:space="preserve">
    <Dropdown position="'bottom-end'" state="dropdown" beforeOpen.bind="onBeforeOpen" menuClass="discussSystray.menuClass">
        <button>
            <i class="fa fa-lg fa-clock-o" role="img" aria-label="Activities"/>
            <span t-if="store.activityCounter" class="o-mail-ActivityMenu-counter badge rounded-pill"><t t-esc="store.activityCounter"/></span>
        </button>
        <t t-set-slot="content">
            <div t-att-class="\`\${discussSystray.contentClass} o-mail-ActivityMenu\`">
                <div t-if="store.activityGroups.length === 0" class="o-mail-ActivityMenu-empty align-items-center text-muted p-2 opacity-50 d-flex justify-content-center">
                    <span>Congratulations, you're done with your activities.</span>
                </div>
                <div class="d-flex flex-column list-group list-group-flush" name="activityGroups">
                    <t t-foreach="store.activityGroups" t-as="group" t-key="group_index" name="activityGroupLoop">
                        <div class="o-mail-ActivityGroup list-group-item list-group-item-action d-flex p-2 cursor-pointer" t-att-data-model_name="group.model" t-on-click="() =&gt; this.openActivityGroup(group)">
                            <img alt="Activity" t-att-src="group.icon"/>
                            <div class="flex-grow-1 overflow-hidden">
                                <div class="d-flex px-2" name="activityTitle" t-out="group.name"/>
                                <div t-if="group.type === 'activity'" class="d-flex">
                                    <span t-attf-class="#{group.overdue_count ? 'btn btn-link' : 'text-muted'} py-0 px-2 text-truncate" t-on-click.stop="() =&gt; this.openActivityGroup(group, 'overdue')">
                                        <t t-out="group.overdue_count"/> Late
                                    </span>
                                    <span t-attf-class="#{group.today_count ? 'btn btn-link' : 'text-muted'} py-0 px-2 text-truncate" t-on-click.stop="() =&gt; this.openActivityGroup(group, 'today')">
                                        <t t-out="group.today_count"/> Today
                                    </span>
                                    <span class="flex-grow-1"/>
                                    <span t-attf-class="#{group.planned_count ? 'btn btn-link' : 'text-muted'} py-0 px-2 text-truncate" t-on-click.stop="() =&gt; this.openActivityGroup(group, 'upcoming_all')">
                                        <t t-out="group.planned_count"/> Future
                                    </span>
                                </div>
                            </div>
                        </div>
                    </t>
                    <a href="#" class="list-group-item list-group-item-action p-2 border-0 text-primary text-center" t-on-click="openMyActivities">
                        View all activities
                    </a>
                </div>
            </div>
        </t>
    </Dropdown>
</t>

`);
registerTemplate("mail.BaseRecipientsList", `/mail/static/src/core/web/base_recipients_list.xml`, `<t t-name="mail.BaseRecipientsList" xml:space="preserve">
        <t t-if="props.thread.recipients.length &gt; 0">
            <t t-out="getRecipientListToHTML()"/>
            <button class="o-mail-BaseRecipientsList-caret btn btn-link badge rounded-pill border-0 p-1" title="Show all recipients" t-on-click="onClickRecipientList">
                <i class="fa fa-caret-down"/>
            </button>
        </t>
    </t>
`);
registerTemplate("mail.DiscussCommand", `/mail/static/src/core/web/command_palette.xml`, `<t t-name="mail.DiscussCommand" xml:space="preserve">
        <div class="o_command_default d-flex align-items-center px-4 py-2">
            <img class="rounded me-2" t-if="props.imgUrl" t-att-src="props.imgUrl" style="width: 25px; height: 25px"/>
            <ImStatus t-if="props.persona" className="'me-1'" persona="props.persona"/>
            <span class="pe-1 text-ellipsis fw-bold d-flex align-items-center">
                <t t-if="props.channel?.parent_channel_id">
                    <span class="text-truncate flex-shrink-0 opacity-75 mw-50" t-esc="props.channel?.parent_channel_id.displayName"/>
                    <i class="oi oi-chevron-right o-xsmaller mx-1"/>
                </t>
                <t t-slot="name"/>
            </span>
            <span t-if="props.persona and props.persona.email" t-out="'- ' + props.persona.email"/>
            <span class="flex-grow-1"/>
            <div t-if="props.counter &gt; 0">
                <span t-attf-class="badge rounded-pill o-discuss-badge ms-3 me-1 fw-bold" t-esc="props.counter"/>
            </div>
        </div>
    </t>

`);
registerTemplateExtension("mail.Discuss", `/mail/static/src/core/web/discuss_patch.xml`, `<t t-inherit="mail.Discuss" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@t-ref='content']" position="before">
            <div t-if="ui.isSmall and store.discuss.activeTab === 'main'" class="w-100 border-bottom" t-call="mail.Discuss.mobileTopbar" t-ref="mobileTopbar"/>
        </xpath>
        <xpath expr="//*[@t-ref='root']" position="replace">
            <div class="h-100 d-flex flex-column">
                <ControlPanel t-if="!ui.isSmall"/>
                <t>$0</t>
            </div>
        </xpath>
        <xpath expr="//*[@t-ref='root']" position="attributes">
            <attribute name="class" add="h-0" remove="h-100" separator=" "/>
        </xpath>
        <xpath expr="//*[@t-ref='main']" position="inside">
            <t t-if="!ui.isSmall" t-call="mail.Discuss.loading"/>
        </xpath>
        <xpath expr="//*[@name='thread']" position="inside">
            <t t-if="!ui.isSmall" t-call="mail.Discuss.loading"/>
        </xpath>
    </t>
    `);
registerTemplate("mail.Discuss.mobileTopbar", `/mail/static/src/core/web/discuss_patch.xml`, `<t t-name="mail.Discuss.mobileTopbar" xml:space="preserve">
        <div class="btn-group d-flex w-100 p-1">
            <t t-call="mail.MobileMailbox">
                <t t-set="mailbox" t-value="store.inbox"/>
            </t>
            <t t-call="mail.MobileMailbox">
                <t t-set="mailbox" t-value="store.starred"/>
            </t>
            <t t-call="mail.MobileMailbox">
                <t t-set="mailbox" t-value="store.history"/>
            </t>
        </div>
    </t>
`);
registerTemplate("mail.DiscussSidebarMailboxes", `/mail/static/src/core/web/discuss_sidebar_mailboxes.xml`, `<t t-name="mail.DiscussSidebarMailboxes" xml:space="preserve">
        <div class="d-flex flex-column flex-grow-0 o-gap-0_5 mt-2">
            <Mailbox mailbox="store.inbox"/>
            <Mailbox mailbox="store.starred"/>
            <Mailbox mailbox="store.history"/>
        </div>
    </t>

    `);
registerTemplate("mail.Mailbox", `/mail/static/src/core/web/discuss_sidebar_mailboxes.xml`, `<t t-name="mail.Mailbox" xml:space="preserve">
        <Dropdown t-if="store.discuss.isSidebarCompact" state="floating" position="'right-middle'" menuClass="'o-mail-DiscussSidebar-floatingMenu bg-100 border border-secondary p-2 mx-2 my-2 min-w-0 shadow-sm'" manual="true">
            <t t-call="mail.Mailbox.main"/>
            <t t-set-slot="content">
                <div class="overflow-hidden" t-ref="floating">
                    <span class="text-muted user-select-none" t-esc="mailbox.name"/>
                </div>
            </t>
        </Dropdown>
        <t t-else="" t-call="mail.Mailbox.main"/>
    </t>

    `);
registerTemplate("mail.Mailbox.main", `/mail/static/src/core/web/discuss_sidebar_mailboxes.xml`, `<t t-name="mail.Mailbox.main" xml:space="preserve">
        <button class="o-mail-DiscussSidebar-item o-mail-Mailbox btn d-flex align-items-center px-0 mx-2 border-0 rounded-2 fw-normal text-reset" t-att-class="{                 'bg-inherit': mailbox.notEq(store.discuss.thread),                 'o-active': mailbox.eq(store.discuss.thread),                 'justify-content-center position-relative o-compact': store.discuss.isSidebarCompact,                 'o-py-0_5': !store.discuss.isSidebarCompact,                 'o-unread': mailbox.counter,             }" t-on-click="(ev) =&gt; this.openThread(ev)" t-ref="root">
            <ThreadIcon className="'bg-inherit ' + (store.discuss.isSidebarCompact ? '' : 'mx-2')" thread="mailbox"/>
            <t t-if="!store.discuss.isSidebarCompact">
                <div class="me-2 text-truncate small" style="line-height: 1.65;" t-esc="mailbox.name"/>
                <div t-attf-class="flex-grow-1 {{ mailbox.counter === 0 ? 'me-3': '' }}"/>
            </t>
            <span t-if="mailbox.counter &gt; 0" class="o-mail-DiscussSidebar-badge o-discuss-badge badge rounded-pill fw-bold" t-att-class="{ 'o-muted': mailbox.id === 'starred', 'mx-1': !store.discuss.isSidebarCompact, 'position-absolute top-0 o-compact': store.discuss.isSidebarCompact }" t-esc="mailbox.counter"/>
        </button>
    </t>

`);
registerTemplateExtension("mail.DiscussSidebar", `/mail/static/src/core/web/discuss_sidebar_patch.xml`, `<t t-inherit="mail.DiscussSidebar" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@name='options-btn']" position="after">
            <Dropdown t-if="store.discuss.isSidebarCompact" state="meetingFloating" position="'right-start'" menuClass="'o-mail-DiscussSidebar-floatingMenu bg-100 border border-secondary p-2 mx-2 my-0 min-w-0 shadow-sm'" manual="true">
                <t t-call="mail.DiscussSidebar.startMeetingButton"/>
                <t t-set-slot="content">
                    <div t-ref="meeting-floating">
                        <span class="text-muted user-select-none" t-esc="startMeetingText"/>
                    </div>
                </t>
            </Dropdown>
            <t t-else="" t-call="mail.DiscussSidebar.startMeetingButton"/>
        </xpath>
    </t>

    `);
registerTemplate("mail.DiscussSidebar.startMeetingButton", `/mail/static/src/core/web/discuss_sidebar_patch.xml`, `<t t-name="mail.DiscussSidebar.startMeetingButton" xml:space="preserve">
        <button class="btn btn-primary rounded d-flex align-items-center gap-1 mx-5" t-att-class="{ 'py-2': store.discuss.isSidebarCompact, 'btn-sm': !store.discuss.isSidebarCompact }" t-on-click="store.startMeeting" data-hotkey="m" t-ref="meeting-btn"><i class="fa fa-fw fa-users opacity-75"/><span t-if="!store.discuss.isSidebarCompact" t-esc="startMeetingText"/></button>
    </t>
`);
registerTemplate("mail.FollowerList", `/mail/static/src/core/web/follower_list.xml`, `<t t-name="mail.FollowerList" xml:space="preserve">
    <t t-if="props.thread.hasWriteAccess">
        <DropdownItem onSelected="() =&gt; this.onClickAddFollowers()" attrs="{ href: '#' }">
            Add Followers
        </DropdownItem>
        <div t-if="props.thread.followers.length &gt; 0" role="separator" class="dropdown-divider"/>
    </t>
    <t t-if="props.thread.selfFollower">
        <t t-call="mail.Follower">
            <t t-set="follower" t-value="props.thread.selfFollower"/>
        </t>
        <div t-if="props.thread.followers.length &gt; 0" role="separator" class="dropdown-divider"/>
    </t>
    <t t-if="props.thread.followers.length &gt; 0">
        <t t-foreach="props.thread.followers" t-as="follower" t-key="follower.id">
            <t t-call="mail.Follower">
                <t t-set="follower" t-value="follower"/>
            </t>
        </t>
        <span t-if="!props.thread.followersFullyLoaded" class="btn btn-link" t-on-click="props.thread.loadMoreFollowers" t-ref="load-more">Load more</span>
    </t>
    <div t-elif="!props.thread.hasWriteAccess" class="dropdown-item disabled">
        No Followers
    </div>
</t>

`);
registerTemplate("mail.Follower", `/mail/static/src/core/web/follower_list.xml`, `<t t-name="mail.Follower" xml:space="preserve">
    <div class="dropdown-item o-mail-Follower d-flex justify-content-between p-0">
        <a class="o-mail-Follower-details d-flex align-items-center flex-grow-1 px-3 o-min-width-0" t-att-class="{ 'o-inactive fst-italic opacity-25': !follower.is_active }" href="#" role="menuitem" t-on-click.prevent="(ev) =&gt; this.onClickDetails(ev, follower)">
            <img class="o-mail-Follower-avatar me-2 rounded o_object_fit_cover" t-att-src="follower.partner.avatarUrl" alt=""/>
            <span class="flex-shrink text-truncate" t-esc="follower.partner.name"/>
        </a>
        <t t-if="follower.isEditable">
            <button class="o-mail-Follower-action btn btn-icon rounded-0" title="Edit subscription" aria-label="Edit subscription" t-on-click="(ev) =&gt; this.onClickEdit(ev, follower)">
                <i class="fa fa-pencil"/>
            </button>
            <button class="o-mail-Follower-action btn btn-icon rounded-0" title="Remove this follower" aria-label="Remove this follower" t-on-click="(ev) =&gt; this.onClickRemove(ev, follower)">
                <i class="fa fa-remove"/>
            </button>
        </t>
    </div>
</t>

`);
registerTemplate("mail.FollowerSubtypeDialog", `/mail/static/src/core/web/follower_subtype_dialog.xml`, `<t t-name="mail.FollowerSubtypeDialog" xml:space="preserve">
        <Dialog t-if="props.follower.partner" bodyClass="'d-flex flex-column'" contentClass="'o-mail-FollowerSubtypeDialog'" size="'sm'" title="title">
            <t t-set-slot="default">
                <div t-foreach="state.subtypes" t-as="subtype" t-key="subtype.id" class="o-mail-FollowerSubtypeDialog-subtype" t-att-data-follower-subtype-id="subtype.id">
                    <label class="flex-grow-1 align-items-center d-flex mb-0 p-2 cursor-pointer">
                        <input class="form-check-input me-2" type="checkbox" t-att-checked="subtype.followed ? 'checked': ''" t-on-change="(ev) =&gt; this.onChangeCheckbox(ev, subtype)"/>
                        <t t-esc="subtype.name"/>
                    </label>
                </div>
            </t>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="onClickApply">
                    Apply
                </button>
                <button class="btn btn-secondary" t-on-click="props.close">
                    Cancel
                </button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("mail.ColumnProgress", `/mail/static/src/core/web/mail_column_progress.xml`, `<t t-name="mail.ColumnProgress" t-inherit="web.ColumnProgress" t-inherit-mode="primary" xml:space="preserve">
        <AnimatedNumber position="after">
            <t t-if="props.aggregateOn">
                <span class="text-900 text-nowrap cursor-default" t-att-title="props.aggregateOn.title">
                    /<span class="o_column_progress_aggregated_on" t-out="props.aggregateOn.value"/>
                </span>
            </t>
        </AnimatedNumber>
    </t>
`);
registerTemplate("mail.MailComposerAttachmentList", `/mail/static/src/core/web/mail_composer_attachment_list.xml`, `<t t-name="mail.MailComposerAttachmentList" xml:space="preserve">
        <ul class="list-unstyled m-0">
            <li t-foreach="files" t-as="file" t-key="file_index" class="d-flex align-items-center bg-200 p-1 ps-3 my-2">
                <a t-att-href="getUrl(file.id)" t-out="file.name" class="flex-grow-1 text-truncate"/>
                <button class="btn flex-shrink-0" t-on-click.stop="() =&gt; this.onFileRemove(file.id)">
                    <i class="fa fa-fw fa-times"/>
                </button>
            </li>
        </ul>
    </t>
`);
registerTemplate("mail.MailComposerAttachmentSelector", `/mail/static/src/core/web/mail_composer_attachment_selector.xml`, `<t t-name="mail.MailComposerAttachmentSelector" xml:space="preserve">
        <FileUploader multiUpload="true" onUploaded.bind="onFileUploaded">
            <t t-set-slot="toggler">
                <button class="btn btn-light w-auto" data-hotkey="a">
                    <i class="fa fa-fw fa-paperclip"/>
                </button>
            </t>
        </FileUploader>
    </t>
`);
registerTemplate("mail.MailComposerChatGPT", `/mail/static/src/core/web/mail_composer_chatgpt.xml`, `<t t-name="mail.MailComposerChatGPT" xml:space="preserve">
        <button class="btn btn-light" data-hotkey="c" t-on-click="onOpenChatGPTPromptDialogBtnClick" t-out="btnLabel"/>
    </t>
`);
registerTemplate("mail.MailComposerRecipientList", `/mail/static/src/core/web/mail_composer_recipient_list.xml`, `<t t-name="mail.MailComposerRecipientList" xml:space="preserve">
        <BaseRecipientsList t-if="state.thread" thread="state.thread"/>
    </t>
`);
registerTemplate("mail.MailComposerTemplateSelector", `/mail/static/src/core/web/mail_composer_template_selector.xml`, `<t t-name="mail.MailComposerTemplateSelector" xml:space="preserve">
        <Dropdown t-if="props.record.data.can_edit_body" menuClass="'mail-composer-template-dropdown'">
            <button class="btn btn-light w-auto mail-composer-template-dropdown-btn" data-hotkey="t">
                <i class="fa fa-fw fa-ellipsis-v"/>
            </button>
            <t t-set-slot="content">
                <div class="px-3 pb-1 text-muted">Insert Template</div>
                <t t-foreach="state.templates" t-as="template" t-key="template_index">
                    <DropdownItem onSelected="() =&gt; this.onLoadTemplate(template)">
                        <t t-if="template.display_name" t-out="template.display_name"/>
                        <span t-else="" class="fst-italic">Untitled</span>
                    </DropdownItem>
                </t>
                <div t-if="state.templates.length === 0" class="fst-italic px-3">
                    No saved templates
                </div>
                <DropdownItem t-if="state.templates.length &gt;= this.limit" onSelected="() =&gt; this.onSelectTemplateSearchMoreBtnClick()">
                    <a href="#">Search More...</a>
                </DropdownItem>
                <div class="dropdown-divider"/>
                <Dropdown>
                    <div>Save as Template</div>
                    <t t-set-slot="content">
                        <div class="px-3 pb-1 text-muted">Overwrite Template</div>
                        <t t-foreach="state.templates" t-as="template" t-key="template_index">
                            <DropdownItem onSelected="() =&gt; this.onOverwriteTemplate(template)">
                                <t t-if="template.display_name" t-out="template.display_name"/>
                                <span t-else="" class="fst-italic">Untitled</span>
                            </DropdownItem>
                        </t>
                        <div t-if="state.templates.length === 0" class="fst-italic px-3">
                            No saved templates
                        </div>
                        <DropdownItem t-if="state.templates.length &gt;= this.limit" onSelected="() =&gt; this.onOverwriteTemplateSearchMoreBtnClick()">
                            <a href="#">Search More...</a>
                        </DropdownItem>
                        <div class="dropdown-divider"/>
                        <DropdownItem onSelected="() =&gt; this.onSaveTemplate()">
                            Save as Template
                        </DropdownItem>
                    </t>
                </Dropdown>
                <div class="dropdown-divider"/>
                <Dropdown>
                    <div>Delete Template</div>
                    <t t-set-slot="content">
                        <div class="px-3 pb-1 text-muted">Delete Template</div>
                        <t t-foreach="state.templates" t-as="template" t-key="template_index">
                            <DropdownItem onSelected="() =&gt; this.onDeleteTemplate(template)">
                                <t t-if="template.display_name" t-out="template.display_name"/>
                                <span t-else="" class="fst-italic">Untitled</span>
                            </DropdownItem>
                        </t>
                        <div t-if="state.templates.length === 0" class="fst-italic px-3">
                            No saved templates
                        </div>
                        <DropdownItem t-if="state.templates.length &gt;= this.limit" onSelected="() =&gt; this.onDeleteTemplateSearchMoreBtnClick()">
                            <a href="#">Search More...</a>
                        </DropdownItem>
                    </t>
                </Dropdown>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("mail.Wysiwyg.mentionLink", `/mail/static/src/core/web/mention_list.xml`, `<t t-name="mail.Wysiwyg.mentionLink" xml:space="preserve">
        <a t-att-href="href" t-att-class="option.partner ? 'o_mail_redirect' : 'o_channel_redirect'" t-att-data-oe-id="option.partner ? option.partner.id : option.channel.id" t-att-data-oe-model="option.partner ? 'res.partner' : 'discuss.channel'" target="_blank" data-oe-protected="true" contenteditable="false"/>
    </t>

    `);
registerTemplate("mail.MentionList", `/mail/static/src/core/web/mention_list.xml`, `<t t-name="mail.MentionList" xml:space="preserve">
        <div class="search d-flex">
            <input type="text" class="form-control border-0 flex-grow-1 rounded-end-0" t-ref="autofocus" t-att-placeholder="placeholder" t-model="state.searchTerm" t-on-keydown="onKeydown"/>
            <i class="oi oi-search p-2 fs-5 rounded-end" title="Search..." role="img" aria-label="Search..."/>
        </div>
        <NavigableList t-props="navigableListProps"/>
    </t>
`);
registerTemplateExtension("mail.Message", `/mail/static/src/core/web/message_patch.xml`, `<t t-inherit="mail.Message" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//t[@name='bodyAsNotification']" position="replace">
            <t t-if="message.message_type === 'notification' or message.is_transient or message.trackingValues.length &gt; 0" name="hasTrackingValue">
                <div>
                    <t t-if="message.subtype_description">
                        <p class="mb-0">
                            <t t-out="props.messageSearch?.highlight(message.subtype_description) ?? message.subtype_description"/>
                        </p>
                    </t>
                    <t t-if="message.trackingValues.length">
                        <ul class="mb-0 ps-4">
                            <t name="trackingValues" t-foreach="message.trackingValues" t-as="trackingValue" t-key="trackingValue.id">
                                <li class="o-mail-Message-tracking mb-1" role="group">
                                    <span class="o-mail-Message-trackingOld me-1 px-1 text-muted fw-bold" t-esc="formatTrackingOrNone(trackingValue.fieldType, trackingValue.oldValue)"/>
                                    <i class="o-mail-Message-trackingSeparator fa fa-long-arrow-right mx-1 text-600"/>
                                    <span class="o-mail-Message-trackingNew me-1 fw-bold text-info" t-esc="formatTrackingOrNone(trackingValue.fieldType, trackingValue.newValue)"/>
                                    <span class="o-mail-Message-trackingField ms-1 fst-italic text-muted">(<t t-esc="trackingValue.changedField"/>)</span>
                                </li>
                            </t>
                        </ul>
                    </t>
                    <div t-if="message.body" t-call="mail.Message.bodyAsNotification" t-ref="body"/>
                </div>
            </t>
            <t t-else="">$0</t>
        </xpath>
        <xpath expr="//div[hasclass('o-mail-Message-avatarContainer')]" position="attributes">
            <attribute name="t-att-aria-label">getAuthorText()</attribute>
            <attribute name="t-on-click">ev =&gt; this.onClickAuthor(ev)</attribute>
        </xpath>
        <xpath expr="//span[hasclass('o-mail-Message-author')]" position="attributes">
            <attribute name="t-att-aria-label">getAuthorText()</attribute>
            <attribute name="t-on-click">ev =&gt; this.onClickAuthor(ev)</attribute>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.MessagingMenu", `/mail/static/src/core/web/messaging_menu_patch.xml`, `<t t-inherit="mail.MessagingMenu" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@t-name='mail.MessagingMenu']" position="inside">
            <div t-if="!env.inDiscussApp" t-att-class="discussSystray.class">
                <Dropdown state="dropdown" beforeOpen.bind="beforeOpen" position="'bottom-end'" menuClass="discussSystray.menuClass">
                    <button>
                        <i class="fa fa-lg fa-comments" role="img" aria-label="Messages" t-on-click="() =&gt; store.discuss.activeTab = ui.isSmall and store.discuss.activeTab === 'main' ? 'main' : store.discuss.activeTab"/>
                        <span t-if="!store.settings.mute_until_dt and counter" class="o-mail-MessagingMenu-counter badge rounded-pill"><t t-esc="counter"/></span>
                    </button>
                    <t t-set-slot="content">
                        <t t-call="mail.MessagingMenu.content"/>
                    </t>
                </Dropdown>
            </div>
        </xpath>
    </t>

    `);
registerTemplateExtension("mail.MessagingMenu.content", `/mail/static/src/core/web/messaging_menu_patch.xml`, `<t t-inherit="mail.MessagingMenu.content" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@t-ref='notification-list']" position="before">
            <div class="o-mail-MessagingMenu-header d-flex" t-att-class="{'border-start-0 border-end-0': ui.isSmall, 'flex-shrink-0': !env.inDiscussApp }">
                <t t-if="!ui.isSmall">
                    <MessagingMenuQuickSearch t-if="state.searchOpen" onClose.bind="toggleSearch"/>
                    <t t-else="">
                        <button class="o-mail-MessagingMenu-headerFilter btn btn-link px-2 py-1 m-1 lh-1" t-att-class="store.discuss.activeTab === 'main' ? 'fw-bold o-active' : 'text-muted'" type="button" role="tab" t-on-click="() =&gt; store.discuss.activeTab = 'main'">All</button>
                        <button class="o-mail-MessagingMenu-headerFilter btn btn-link px-2 py-1 m-1 lh-1" t-att-class="store.discuss.activeTab === 'chat' ? 'fw-bold o-active' : 'text-muted'" type="button" role="tab" t-on-click="() =&gt; store.discuss.activeTab = 'chat'">Chats</button>
                        <button class="o-mail-MessagingMenu-headerFilter btn btn-link px-2 py-1 m-1 lh-1" t-att-class="store.discuss.activeTab === 'channel' ? 'fw-bold o-active' : 'text-muted'" type="button" role="tab" t-on-click="() =&gt; store.discuss.activeTab = 'channel'">Channels</button>
                        <button t-if="threads.length &gt;= 20 and store.channels.status !== 'fetching'" class="btn btn-link py-1 rounded-0 text-muted" type="button" title="Quick search" t-on-click="toggleSearch"><i class="fa fa-fw fa-search"/></button>
                        <button t-if="store.channels.status === 'fetching'" class="btn btn-light py-1 rounded-0" disabled="true" type="button"><i class="fa fa-fw fa-circle-o-notch fa-spin"/></button>
                    </t>
                </t>
            </div>
        </xpath>
        <xpath expr="//*[@name='threads']" position="before">
            <div t-if="store.channels.status !== 'fetching' and !hasPreviews" class="d-flex justify-content-center py-4 px-2 text-muted">
                No conversation yet...
            </div>
            <div t-if="store.discuss.searchTerm and !threads.length" class="d-flex justify-content-center py-4 px-2 text-muted">
                No thread found.
            </div>
            <t t-set="itemIndex" t-value="0"/>
            <t t-if="installationRequest.isShown and !store.discuss.searchTerm">
                <NotificationItem isActive="state.activeIndex === itemIndex" body="installationRequest.body" iconSrc="installationRequest.iconSrc" onClick="installationRequest.onClick" onSwipeRight="hasTouch() ? { action: () =&gt; this.pwa.decline(), icon: 'fa-times-circle', bgColor: 'bg-warning' } : undefined">
                    <t t-set-slot="name"><t t-esc="installationRequest.displayName"/></t>
                    <t t-set-slot="icon">
                        <ImStatus persona="installationRequest.partner" className="'position-absolute top-100 start-100 translate-middle mt-n1 ms-n1'"/>
                    </t>
                    <t t-set-slot="requestContent">
                        <a t-if="ui.isSmall" class="btn fa fa-cloud-download"/>
                        <t t-else="">
                            <a class="btn btn-primary px-2 py-1 smaller">Install</a>
                            <span t-if="!hasTouch()" t-on-click.stop="() =&gt; this.pwa.decline()" class="text-dark bg-transparent oi oi-close opacity-50 opacity-100-hover" title="Dismiss"/>
                        </t>
                    </t>
                </NotificationItem>
                <t t-set="itemIndex" t-value="itemIndex + 1"/>
            </t>
            <t t-if="notificationRequest.isShown and !store.discuss.searchTerm">
                <NotificationItem isActive="state.activeIndex === itemIndex" body="notificationRequest.body" iconSrc="notificationRequest.iconSrc" onClick="() =&gt; notification.requestPermission()">
                    <t t-set-slot="name"><t t-esc="notificationRequest.displayName"/></t>
                    <t t-set-slot="icon">
                        <ImStatus persona="notificationRequest.partner" className="'position-absolute top-100 start-100 translate-middle mt-n1 ms-n1'"/>
                    </t>
                    <t t-set-slot="requestContent">
                        <a t-if="ui.isSmall" class="btn fa fa-bell"/>
                        <t t-else="">
                            <a class="btn btn-primary px-2 py-1 smaller">Enable</a>
                            <span t-if="!hasTouch()" t-on-click.stop="() =&gt; this.store.isNotificationPermissionDismissed = true" class="text-dark bg-transparent oi oi-close opacity-50 opacity-100-hover" title="Dismiss"/>
                        </t>
                    </t>
                </NotificationItem>
                <t t-set="itemIndex" t-value="itemIndex + 1"/>
            </t>
            <t t-if="store.discuss.activeTab === 'main' and !env.inDiscussApp and !store.discuss.searchTerm">
                <t t-foreach="store.failures" t-as="failure" t-key="failure.id">
                    <NotificationItem isActive="state.activeIndex === itemIndex" body="failure.body" counter="failure.notifications.length &gt; 1 ? failure.notifications.length : undefined" datetime="failure.datetime" iconSrc="failure.iconSrc" hasMarkAsReadButton="true" onClick="(isMarkAsRead) =&gt; isMarkAsRead ? this.cancelNotifications(failure) : this.onClickFailure(failure)" onSwipeRight="hasTouch() ? { action: () =&gt; this.cancelNotifications(failure), icon: 'fa-times-circle', bgColor: 'bg-warning' } : undefined">
                        <t t-set-slot="name"><t t-esc="getFailureNotificationName(failure)"/></t>
                    </NotificationItem>
                    <t t-set="itemIndex" t-value="itemIndex + 1"/>
                </t>
            </t>
        </xpath>
    </t>
`);
registerTemplate("mail.MessagingMenuQuickSearch", `/mail/static/src/core/web/messaging_menu_quick_search.xml`, `<t t-name="mail.MessagingMenuQuickSearch" xml:space="preserve">
    <div class="position-relative w-50 m-1" t-ref="search" t-on-keydown="onKeydownInput">
        <input t-model="store.discuss.searchTerm" t-ref="autofocus" class="form-control px-1 py-0" placeholder="Quick search…" type="text"/>
        <button class="btn btn-link text-muted p-1 position-absolute top-50 end-0 translate-middle-y" title="Close search" t-on-click="props.onClose"><i class="oi oi-close"/></button>
    </div>
</t>`);
registerTemplate("mail.RecipientList", `/mail/static/src/core/web/recipient_list.xml`, `<t t-name="mail.RecipientList" xml:space="preserve">
        <div class="o-mail-RecipientList p-2 overflow-auto">
            <ul class="list-unstyled mb-0">
                <li t-foreach="props.thread.recipients" t-as="recipient" t-key="recipient.id">
                    <t t-out="getRecipientText(recipient)"/>
                </li>
                <span t-if="!props.thread.recipientsFullyLoaded" class="btn btn-link w-100" t-on-click="props.thread.loadMoreRecipients" t-ref="load-more">Load more</span>
            </ul>
        </div>
    </t>

`);
registerTemplate("mail.SuggestedRecipients", `/mail/static/src/core/web/suggested_recipient.xml`, `<t t-name="mail.SuggestedRecipients" xml:space="preserve">
        <div class="o-mail-SuggestedRecipient" t-att-data-partner-id="props.recipient.persona?.id ? props.recipient.persona.id : false" t-att-title="titleText">
            <div class="form-check">
                <input t-attf-id="{{ props.recipient.id }}_checkbox" class="form-check-input" type="checkbox" t-att-checked="props.recipient.checked" t-on-change="onChangeCheckbox"/>
                <label class="form-check-label" t-attf-for="{{ props.recipient.id }}_checkbox">
                    <t t-if="props.recipient.name" t-esc="props.recipient.name"/>
                    <t t-if="props.recipient.email and props.recipient.email !== props.recipient.name">
                        (<t t-esc="props.recipient.email"/>)
                    </t>
                </label>
            </div>
        </div>
    </t>
`);
registerTemplate("mail.SuggestedRecipientsList", `/mail/static/src/core/web/suggested_recipient_list.xml`, `<t t-name="mail.SuggestedRecipientsList" xml:space="preserve">
        <div t-att-class="props.className" t-att-style="props.styleString">
            <SuggestedRecipient t-foreach="suggestedRecipients" t-as="recipient" t-key="recipient_index" thread="props.thread" recipient="recipient" onSuggestedRecipientAdded="props.onSuggestedRecipientAdded"/>
            <t t-if="props.thread.suggestedRecipients.length &gt; 3">
                <button t-if="!state.showMore" class="btn btn-sm btn-link" t-on-click="() =&gt; this.state.showMore = true">
                    Show more
                </button>
                <button t-else="" class="btn btn-sm btn-link" t-on-click="() =&gt; this.state.showMore = false">
                    Show less
                </button>
            </t>
        </div>
    </t>
`);
registerTemplateExtension("mail.Thread", `/mail/static/src/core/web/thread_patch.xml`, `<t t-inherit="mail.Thread" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@name='empty-message']" position="replace">
            <t t-if="props.thread.isEmpty and props.thread.model === 'mail.box'">
                <t t-if="props.thread.id === 'inbox' and state.mountedAndLoaded">
                    <div t-if="store.self.notification_preference !== 'inbox'" class="align-items-center text-center">
                        <h4 class="mb-3 fw-bolder">Your inbox is empty</h4>
                        <t t-esc="preferenceButtonText.before"/>
                        <button class="btn btn-link m-0 p-0 align-baseline o-hover-text-underline" t-on-click="onClickPreferences" t-esc="preferenceButtonText.inside"/>
                        <t t-esc="preferenceButtonText.after"/>
                    </div>
                    <div t-else="" class="align-items-center text-center">
                        <h4 class="mb-3 fw-bolder">Congratulations, your inbox is empty</h4>
                        New messages appear here.
                    </div>
                </t>
                <t t-if="props.thread.id === 'starred'">
                    <h4 class="mb-3 fw-bolder">No starred messages</h4>
                    You can mark any message as 'starred', and it shows up in this mailbox.
                </t>
                <t t-if="props.thread.id === 'history'">
                    <img src="/web/static/img/neutral_face.svg" alt="History"/>
                    <h4 class="mb-3 fw-bolder">No history messages</h4>
                    Messages marked as read will appear in the history.
                </t>
            </t>
            <t t-else="">$0</t>
        </xpath>
    </t>
`);
registerTemplate("mail.Chatter", `/mail/static/src/chatter/web/chatter.xml`, `<t t-name="mail.Chatter" xml:space="preserve">
    <div t-if="state.thread" class="o-mail-Chatter w-100 h-100 flex-grow-1 d-flex flex-column" t-att-class="{ 'overflow-auto': props.isChatterAside, 'o-chatter-disabled': props.threadId === false }" t-on-scroll="onScrollDebounced" t-ref="root">
        <div class="o-mail-Chatter-top d-print-none position-sticky top-0" t-att-class="{ 'shadow-sm': state.isTopStickyPinned }" t-ref="top">
            <div class="o-mail-Chatter-topbar d-flex flex-shrink-0 flex-grow-0 overflow-x-auto">
                <div t-if="state.isSearchOpen" class="flex-grow-1">
                    <SearchMessageInput closeSearch.bind="closeSearch" messageSearch="messageSearch" thread="state.thread"/>
                </div>
                <t t-else="" name="chatter-topbar-left-buttons">
                    <button class="o-mail-Chatter-sendMessage btn text-nowrap me-1" t-att-class="{                         'btn-primary': state.composerType !== 'note',                         'btn-secondary': state.composerType === 'note',                         'active': state.composerType === 'message',                         'my-2': !props.compactHeight                     }" t-att-disabled="!state.thread.hasWriteAccess and !(state.thread.hasReadAccess and state.thread.canPostOnReadonly) and props.threadId" data-hotkey="m" t-on-click="() =&gt; this.toggleComposer('message')">
                        Send message
                    </button>
                    <button class="o-mail-Chatter-logNote btn text-nowrap me-1" t-att-class="{                         'btn-primary active': state.composerType === 'note',                         'btn-secondary': state.composerType !== 'note',                         'my-2': !props.compactHeight                     }" t-att-disabled="!state.thread.hasWriteAccess and !(state.thread.hasReadAccess and state.thread.canPostOnReadonly) and props.threadId" data-hotkey="shift+m" t-on-click="() =&gt; this.toggleComposer('note')">
                        Log note
                    </button>
                    <button t-if="props.has_activities" class="o-mail-Chatter-activity btn btn-secondary text-nowrap" t-att-class="{ 'my-2': !props.compactHeight }" data-hotkey="shift+a" t-on-click="scheduleActivity">
                        <span>Activities</span>
                    </button>
                    <span class="o-mail-Chatter-topbarGrow flex-grow-1 pe-2"/>
                    <button class="btn btn-link text-action" aria-label="Search Messages" title="Search Messages" t-on-click="onClickSearch">
                        <i class="oi oi-search" role="img"/>
                    </button>
                </t>
                <button t-if="props.hasAttachmentPreview and state.thread.attachmentsInWebClientView.length" class="btn btn-link text-action" t-on-click="popoutAttachment">
                    <i class="fa fa-window-restore" aria-hidden="Pop out Attachments" title="Pop out Attachments"/>
                </button>
                <FileUploader t-if="attachments.length === 0" fileUploadClass="'o-mail-Chatter-fileUploader'" multiUpload="true" onUploaded.bind="onUploaded" onClick="(ev) =&gt; this.onClickAttachFile(ev)">
                    <t t-set-slot="toggler">
                        <t t-call="mail.Chatter.attachFiles"/>
                    </t>
                </FileUploader>
                <t t-else="" t-call="mail.Chatter.attachFiles"/>
                <div class="o-mail-Followers d-flex me-1">
                    <Dropdown position="'bottom-end'" menuClass="'o-mail-Followers-dropdown d-flex flex-column'" state="followerListDropdown">
                        <button t-att-class="'o-mail-Followers-button btn btn-link d-flex align-items-center text-action px-1 ' + (props.compactHeight ? '' : 'my-2')" t-att-disabled="isDisabled" t-att-title="followerButtonLabel">
                            <i class="fa fa-user-o me-1" role="img"/>
                            <i t-if="state.thread.id and state.thread.followersCount === undefined" class="fa fa-circle-o-notch fa-spin"/>
                            <sup t-else="" class="o-mail-Followers-counter" t-esc="state.thread.followersCount ?? 0"/>
                        </button>
                        <t t-set-slot="content">
                            <FollowerList onAddFollowers.bind="onAddFollowers" onFollowerChanged.bind="onFollowerChanged" thread="state.thread" dropdown="followerListDropdown"/>
                        </t>
                    </Dropdown>
                </div>
                <button t-if="state.thread.selfFollower" class="btn px-0" t-att-class="{ 'text-success': !unfollowHover.isHover, 'text-warning': unfollowHover.isHover, 'my-2': !props.compactHeight }" t-att-disabled="!props.threadId" t-on-click="onClickUnfollow" t-ref="unfollow">
                    <div class="position-relative">

                        <span class="d-flex invisible text-nowrap">
                            <t t-out="followingText.length &gt; unfollowText.length ? followingText : unfollowText"/>
                        </span>
                        <span class="o-mail-Chatter-follow position-absolute end-0 top-0" t-out="unfollowHover.isHover ? unfollowText : followingText"/>
                    </div>
                </button>
                <button t-if="!state.thread.selfFollower" class="o-mail-Chatter-follow btn btn-link  px-0 text-600" t-on-click="onClickFollow">
                    <div class="position-relative">
                        <span class="d-flex invisible text-nowrap">
                            <t t-out="followingText.length &gt; unfollowText.length ? followingText : unfollowText"/>
                        </span>
                        <span class="position-absolute end-0 top-0">
                            Follow
                        </span>
                    </div>
                </button>
                <button t-if="props.close" class="o-mail-Chatter-close btn btn-secondary flex-shrink-0 ms-2" aria-label="Close" t-on-click="props.close">
                    <i class="oi oi-close"/>
                </button>
            </div>
            <t t-if="state.composerType">
                <t t-if="state.composerType === 'message'">
                    <div class="d-flex flex-shrink-0 pt-3 text-truncate small mb-2 ms-5 gap-1">
                        <span class="fw-bold">To: </span>
                        <BaseRecipientsList t-if="state.thread.recipients.length &gt; 0" thread="state.thread"/>
                        <SuggestedRecipientsList t-elif="state.thread.suggestedRecipients.length &gt; 0" thread="state.thread" onSuggestedRecipientAdded.bind="onSuggestedRecipientAdded"/>
                        <span t-else="" class="fst-italic">No recipient</span>
                    </div>
                </t>
                <t t-set="type" t-value="state.composerType === 'message' ? 'message' : 'note'"/>
                <SuggestedRecipientsList t-if="state.composerType !== 'note' and state.thread.recipients.length &gt; 0" styleString="'margin-left:48px;'" thread="state.thread" onSuggestedRecipientAdded.bind="onSuggestedRecipientAdded"/>
                <Composer composer="state.thread.composer" autofocus="true" className="state.composerType === 'message' ? '' : 'pt-4'" mode="'extended'" onPostCallback.bind="onPostCallback" onCloseFullComposerCallback.bind="onCloseFullComposerCallback" dropzoneRef="rootRef" type="state.composerType" t-key="props.threadId"/>
            </t>
        </div>
        <div class="o-mail-Chatter-content d-flex flex-column flex-grow-1">
            <t>
                <t t-if="props.has_activities and activities.length and !messageSearch.searching and !messageSearch.searched">
                    <t t-call="mail.ActivityList"/>
                </t>
                <t t-if="scheduledMessages.length">
                    <t t-call="mail.ScheduledMessagesList"/>
                </t>
                <div t-if="state.isAttachmentBoxOpened" class="o-mail-AttachmentBox position-relative">
                    <div class="d-flex align-items-center">
                        <hr class="flex-grow-1"/>
                        <span class="p-3 fw-bold">
                            Files
                        </span>
                        <hr class="flex-grow-1"/>
                    </div>
                    <div class="d-flex flex-column">
                        <AttachmentList attachments="attachments" unlinkAttachment.bind="unlinkAttachment" imagesHeight="100"/>
                        <FileUploader multiUpload="true" fileUploadClass="'o-mail-Chatter-fileUploader'" onUploaded.bind="onUploaded" onClick="(ev) =&gt; this.onClickAttachFile(ev)">
                            <t t-set-slot="toggler">
                                <button class="btn btn-link" type="button" t-att-disabled="!state.thread.hasWriteAccess">
                                    <i class="fa fa-plus-square"/>
                                    Attach files
                                </button>
                            </t>
                        </FileUploader>
                    </div>
                </div>
                <SearchMessageResult t-if="messageSearch.searching or messageSearch.searched" thread="state.thread" messageSearch="messageSearch" onClickJump.bind="closeSearch"/>
                <Thread t-else="" thread="state.thread" t-key="state.thread.localId" order="'desc'" scrollRef="rootRef" jumpPresent="state.jumpThreadPresent"/>
            </t>
        </div>
    </div>
</t>

`);
registerTemplate("mail.ActivityList", `/mail/static/src/chatter/web/chatter.xml`, `<t t-name="mail.ActivityList" xml:space="preserve">
    <div class="o-mail-ActivityList">
        <div class="d-flex pt-2 cursor-pointer fw-bolder" t-on-click="toggleActivities">
            <hr class="flex-grow-1 fs-3"/>
            <div class="d-flex align-items-center px-3">
                <i class="fa fa-fw" t-att-class="state.showActivities ? 'fa-caret-down' : 'fa-caret-right'"/>
                Planned Activities
                <span t-if="!state.showActivities" class="badge rounded-pill ms-2 text-bg-success"><t t-esc="activities.length"/></span>
            </div>
            <hr class="flex-grow-1 fe-3"/>
        </div>
        <t t-if="state.showActivities">
            <t t-foreach="activities" t-as="activity" t-key="activity.id">
                <Activity activity="activity" onActivityChanged.bind="onActivityChanged" reloadParentView.bind="reloadParentView"/>
            </t>
        </t>
    </div>
</t>

`);
registerTemplate("mail.ScheduledMessagesList", `/mail/static/src/chatter/web/chatter.xml`, `<t t-name="mail.ScheduledMessagesList" xml:space="preserve">
    <div class="o-mail-ScheduledMessagesList">
        <div class="d-flex pt-2 cursor-pointer fw-bolder" t-on-click="toggleScheduledMessages">
            <hr class="flex-grow-1 fs-3"/>
            <div class="d-flex align-items-center px-3">
                <i class="fa fa-fw" t-att-class="state.showScheduledMessages ? 'fa-caret-down' : 'fa-caret-right'"/>
                Scheduled Messages
                <span t-if="!state.showScheduledMessages" class="badge rounded-pill ms-2 text-bg-success" t-out="scheduledMessages.length"/>
            </div>
            <hr class="flex-grow-1 fe-3"/>
        </div>
        <div t-if="state.showScheduledMessages">
            <t t-foreach="scheduledMessages" t-as="scheduledMessage" t-key="scheduledMessage.id">
                <ScheduledMessage scheduledMessage="scheduledMessage" onScheduledMessageChanged.bind="onScheduledMessageChanged"/>
            </t>
        </div>
    </div>
</t>

`);
registerTemplate("mail.Chatter.attachFiles", `/mail/static/src/chatter/web/chatter.xml`, `<t t-name="mail.Chatter.attachFiles" xml:space="preserve">
    <button class="o-mail-Chatter-attachFiles btn btn-link text-action px-1 d-flex align-items-center" aria-label="Attach files" t-att-class="{ 'my-2': !props.compactHeight }" t-on-click="onClickAddAttachments" t-att-disabled="state.isSearchOpen">
        <i class="fa fa-paperclip fa-lg me-1"/>
        <sup t-if="attachments.length &gt; 0" t-esc="attachments.length"/>
        <i t-if="!state.thread.areAttachmentsLoaded and state.thread.isLoadingAttachments and state.showAttachmentLoading" class="fa fa-circle-o-notch fa-spin" aria-label="Attachment counter loading..."/>
    </button>
</t>

`);
registerTemplateExtension("web.FormView", `/mail/static/src/chatter/web/form_controller.xml`, `<t t-inherit="web.FormView" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//Layout/t[@t-component='props.Renderer']" position="attributes">
            <attribute name="saveRecord">() =&gt; this.save()</attribute>
        </xpath>
    </t>

`);
registerTemplate("mail.MailComposerScheduleDialog", `/mail/static/src/chatter/web/mail_composer_schedule_dialog.xml`, `<t t-name="mail.MailComposerScheduleDialog" xml:space="preserve">
    <t t-if="props.isNote" t-set="dialogTitle">
        Schedule Note
    </t>
    <t t-else="" t-set="dialogTitle">
        Schedule Message
    </t>
    <Dialog title="dialogTitle" size="'md'">
        <div role="radiogroup">
            <div class="d-flex justify-content-between justify-content-md-start my-3 my-sm-2">
                <div class="form-check w-md-50">
                    <input type="radio" class="form-check-input ms-0 me-2" id="input_tomorrow_morning" value="morning" t-model="state.selectedOption"/>
                    <label class="form-check-label" for="input_tomorrow_morning">
                        Tomorrow Morning
                    </label>
                </div>
                <span class="text-muted" t-out="tomorrowMorning.toLocaleString(this.dateTimeFormat)"/>
            </div>
            <div class="d-flex justify-content-between justify-content-md-start my-3 my-sm-2">
                <div class="form-check w-md-50">
                    <input type="radio" class="form-check-input ms-0 me-2" id="input_tomorrow_afternoon" value="afternoon" t-model="state.selectedOption"/>
                    <label class="form-check-label" for="input_tomorrow_afternoon">
                        Tomorrow Afternoon
                    </label>
                </div>
                <span class="text-muted" t-out="tomorrowAfternoon.toLocaleString(this.dateTimeFormat)"/>
            </div>
            <div class="d-flex justify-content-between justify-content-md-start my-3 my-sm-2">
                <div class="form-check w-md-50">
                    <input type="radio" class="form-check-input ms-0 me-2" id="input_monday_morning" value="monday" t-model="state.selectedOption"/>
                    <label class="form-check-label" for="input_monday_morning">
                        Next Monday Morning
                    </label>
                </div>
                <span class="text-muted" t-out="mondayMorning.toLocaleString(this.dateTimeFormat)"/>
            </div>
            <div class="d-flex justify-content-between justify-content-md-start my-3 my-sm-2">
                <div class="form-check my-auto w-md-50">
                    <input type="radio" class="form-check-input ms-0 me-2" id="input_specific_date" value="custom" t-model="state.selectedOption"/>
                    <label class="form-check-label" for="input_specific_date">
                        Pick a specific time
                    </label>
                </div>
                <div class="my-2 my-sm-0" t-if="state.selectedOption === 'custom'">
                    <DateTimeInput t-props="dateTimePickerProps"/>
                </div>
            </div>
        </div>
        <t t-set-slot="footer">
            <button class="btn btn-primary" t-on-click="schedule" data-hotkey="S">
                Schedule
            </button>
            <button class="btn btn-secondary" t-on-click="props.close" data-hotkey="C">
                Close
            </button>
        </t>
    </Dialog>
</t>
`);
registerTemplate("mail.MailComposerSendDropdown", `/mail/static/src/chatter/web/mail_composer_send_dropdown.xml`, `<t t-name="mail.MailComposerSendDropdown" xml:space="preserve">
    <div class="btn-group">
        <button class="btn btn-primary w-auto o_mail_send" t-on-click="onClickSend" t-att-disabled="buttonState.disabled" data-hotkey="q">
            <t t-if="props.record.data.subtype_is_log">
                Log
            </t>
            <t t-else="">
                Send
            </t>
        </button>
        <Dropdown>
            <button class="btn btn-primary w-auto dropdown-toggle-split o-dropdown-caret" t-att-disabled="buttonState.disabled"/>
            <t t-set-slot="content">
                <DropdownItem onSelected.bind="onClickSendLater">
                    <t t-if="props.record.data.subtype_is_log">
                        Log Later
                    </t>
                    <t t-else="">
                        Send Later
                    </t>

                </DropdownItem>
            </t>
        </Dropdown>
    </div>
</t>
`);
registerTemplate("mail.ScheduledMessage", `/mail/static/src/chatter/web/scheduled_message.xml`, `<t t-name="mail.ScheduledMessage" xml:space="preserve">
    <div class="o-mail-Scheduled-Message py-1 mb-2">
        <div class="o-mail-Message-core position-relative d-flex flex-shrink-0">
            <div class="o-mail-Message-sidebar d-flex flex-shrink-0">
                <div class="o-mail-Message-avatarContainer position-relative bg-view" t-on-click="ev =&gt; this.onClickAuthor(ev)">
                    <img class="o-mail-Message-avatar w-100 h-100 rounded o_redirect cursor-pointer o_object_fit_cover" t-att-src="props.scheduledMessage.author.avatarUrl"/>
                </div>
            </div>
            <div class="w-100 o-min-width-0">
                <div class="o-mail-Message-header d-flex flex-wrap align-items-baseline mb-1 lh-1">
                    <span class="o-mail-Message-author cursor-pointer o-hover-text-underline" t-on-click="ev =&gt; this.onClickAuthor(ev)">
                        <strong class="me-1 text-truncate o_redirect cursor-pointer" t-out="props.scheduledMessage.author.name"/>
                    </span>
                    <small class="o-mail-Message-date text-muted opacity-75" t-att-title="scheduledDate">
                        <i class="fa fa-paper-plane-o mx-1"/>
                        <RelativeTime datetime="props.scheduledMessage.scheduled_date"/>
                    </small>
                </div>
                <div class="position-relative d-flex justify-content-end">
                    <div class="o-mail-Message-content o-min-width-0 w-100">
                        <div class="o-mail-Message-textContent position-relative d-flex">
                            <div class="position-relative overflow-x-auto d-inline-block">
                                <div class="o-mail-Message-bubble rounded-end-3 rounded-bottom-3 position-absolute top-0 start-0 w-100 h-100" t-att-class="{                                         'bg-success-light opacity-25': !props.scheduledMessage.is_note and props.scheduledMessage.isSelfAuthored,                                         'bg-info-light opacity-25': !props.scheduledMessage.is_note and !props.scheduledMessage.isSelfAuthored                                      }"/>
                                <div t-on-click="onClick" t-attf-class="position-relative text-break o-mail-Message-body #{props.scheduledMessage.is_note ? 'p-1' : 'mb-0 py-2 px-3 align-self-start'}">
                                    <t t-if="props.scheduledMessage.subject and !props.scheduledMessage.isSubjectThreadName">
                                        <em class="mb-1 me-2">Subject: <t t-esc="props.scheduledMessage.subject"/></em>
                                    </t>
                                    <t t-if="isShort or state.readMore" t-out="props.scheduledMessage.body || ''"/>
                                    <p t-else="" t-out="truncatedMessage"/>
                                    <button t-if="!isShort" t-attf-class="btn btn-link #{state.readMore ? '' : 'ps-0'}" t-on-click="() =&gt; this.state.readMore = !this.state.readMore">
                                        <t t-if="state.readMore">
                                            Read Less
                                        </t>
                                        <t t-else="">
                                            Read More
                                        </t>
                                    </button>
                                </div>
                            </div>
                        </div>
                        <AttachmentList t-if="props.scheduledMessage.attachment_ids.length &gt; 0" attachments="props.scheduledMessage.attachment_ids.map((a) =&gt; a)" unlinkAttachment.bind="onClickAttachmentUnlink" imagesHeight="props.scheduledMessage.attachment_ids.length === 1 ? 300 : 75"/>
                    </div>
                </div>
                <div class="o-mail-Scheduled-Message-buttons ps-1 d-flex">
                    <span class="btn btn-link btn-success p-0 me-3" t-if="props.scheduledMessage.editable" t-on-click="onClickSendNow">
                        <i class="fa fa-send"/> Send Now
                    </span>
                    <span class="btn btn-link text-action p-0 me-3" t-if="props.scheduledMessage.editable" t-on-click="onClickEdit">
                        <i class="fa fa-pencil"/> Edit
                    </span>
                    <span class="btn btn-link btn-danger p-0" t-if="props.scheduledMessage.deletable" t-on-click="onClickCancel">
                        <i class="fa fa-times"/> Cancel
                    </span>
                </div>
            </div>
        </div>
    </div>
</t>
`);
registerTemplate("mail.ActivityException", `/mail/static/src/views/web/fields/activity_exception/activity_exception.xml`, `<t t-name="mail.ActivityException" xml:space="preserve">
        <div t-if="props.record.data[props.name]" class="o-mail-ActivityException float-end mt-1" t-att-class="textClass" title="This record has an exception activity."/>
    </t>
`);
registerTemplate("mail.Avatar", `/mail/static/src/views/web/fields/avatar/avatar.xml`, `<t t-name="mail.Avatar" xml:space="preserve">
        <div class="o-mail-Avatar o_avatar d-flex align-items-center">
            <img t-attf-class="rounded {{props.noSpacing ? '' : 'me-2'}}" t-attf-src="/web/image/{{props.resModel}}/{{props.resId}}/avatar_128" t-on-click.stop.prevent="onClickAvatar"/>
            <span t-if="props.displayName" class="text-truncate w-0 flex-grow-1" t-esc="props.displayName"/>
        </div>
    </t>

`);
registerTemplate("mail.EmojisCharField", `/mail/static/src/views/web/fields/emojis_char_field/emojis_char_field.xml`, `<t t-name="mail.EmojisCharField" t-inherit="web.CharField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[1]" position="attributes">
            <attribute name="t-ref">targetReadonlyElement</attribute>
        </xpath>
        <xpath expr="//*[hasclass('o_field_input_buttons')]/button" position="before">
            <t t-call="mail.EmojisFieldButton">
                <t t-set="positionCenter" t-value="true"/>
            </t>
        </xpath>
    </t>
`);
registerTemplate("mail.EmojisFieldButton", `/mail/static/src/views/web/fields/emojis_field_common/emojis_field_common.xml`, `<t t-name="mail.EmojisFieldButton" xml:space="preserve">
        <div class="o_mail_emojis_buttons position-relative d-inline">
            <button class="btn end-0" t-attf-class="{{positionCenter ? 'pb-0 pt-0' : 'bottom-0'}}" t-ref="emojisButton">
                <i class="oi oi-smile-add" role="img" aria-label="Emojis"/>
            </button>
        </div>
    </t>
`);
registerTemplate("mail.EmojisTextField", `/mail/static/src/views/web/fields/emojis_text_field/emojis_text_field.xml`, `<t t-name="mail.EmojisTextField" t-inherit="web.TextField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[1]" position="attributes">
            <attribute name="t-ref">targetReadonlyElement</attribute>
        </xpath>
        <xpath expr="//*[hasclass('o_field_input_buttons')]" position="inside">
            <t t-call="mail.EmojisFieldButton"/>
        </xpath>
    </t>
`);
registerTemplate("mail.KanbanActivity", `/mail/static/src/views/web/fields/kanban_activity/kanban_activity.xml`, `<t t-name="mail.KanbanActivity" xml:space="preserve">
        <ActivityButton record="props.record"/>
    </t>
`);
registerTemplate("mail.ListActivity", `/mail/static/src/views/web/fields/list_activity/list_activity.xml`, `<t t-name="mail.ListActivity" xml:space="preserve">
        <ActivityButton record="props.record"/>
        <span class="o-mail-ListActivity-summary" t-out="summaryText"/>
    </t>
`);
registerTemplate("mail.Many2ManyAvatarUserTagsList", `/mail/static/src/views/web/fields/many2many_avatar_user_field/many2many_avatar_user_field.xml`, `<t t-name="mail.Many2ManyAvatarUserTagsList" t-inherit="web.TagsList" t-inherit-mode="primary" xml:space="preserve">
        <img position="attributes">
            <attribute name="t-on-click.stop.prevent">tag.onImageClicked</attribute>
        </img>
    </t>

    `);
registerTemplate("mail.KanbanMany2ManyAvatarUserTagsList", `/mail/static/src/views/web/fields/many2many_avatar_user_field/many2many_avatar_user_field.xml`, `<t t-name="mail.KanbanMany2ManyAvatarUserTagsList" t-inherit="web.KanbanMany2ManyTagsAvatarFieldTagsList" t-inherit-mode="primary" xml:space="preserve">
        <img position="attributes">
            <attribute name="t-on-click.stop.prevent">tag.onImageClicked</attribute>
        </img>
    </t>

    `);
registerTemplate("mail.ListMany2ManyTagsAvatarUserField", `/mail/static/src/views/web/fields/many2many_avatar_user_field/many2many_avatar_user_field.xml`, `<t t-name="mail.ListMany2ManyTagsAvatarUserField" t-inherit="web.Many2ManyTagsAvatarField" t-inherit-mode="primary" xml:space="preserve">
        <TagsList position="attributes">
            <attribute name="displayText">displayText</attribute>
        </TagsList>
    </t>

    `);
registerTemplate("mail.KanbanMany2ManyTagsAvatarUserField", `/mail/static/src/views/web/fields/many2many_avatar_user_field/many2many_avatar_user_field.xml`, `<t t-name="mail.KanbanMany2ManyTagsAvatarUserField" t-inherit="web.KanbanMany2ManyTagsAvatarField" t-inherit-mode="primary" xml:space="preserve">
        <TagsList position="attributes">
            <attribute name="displayText">displayText</attribute>
        </TagsList>
    </t>
`);
registerTemplate("FieldMany2ManyTagsEmailTagsList", `/mail/static/src/views/web/fields/many2many_tags_email/many2many_tags_email.xml`, `<t t-name="FieldMany2ManyTagsEmailTagsList" t-inherit="web.TagsList" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[contains(@class, 'o_tag')]" position="replace">
            <div t-if="tag.email" t-attf-class="badge rounded-pill dropdown o_tag o_tag_color_0 #{tag.email.indexOf('@') &lt; 0 ? 'o_tag_error' : ''}" t-att-data-color="tag.colorIndex" t-att-data-index="tag_index" t-att-data-id="tag.id" t-att-title="tag.text">
                <span class="o_badge_text" t-att-title="tag.email"><t t-esc="tag.text"/></span>
                <a t-if="!readonly &amp;&amp; tag.onDelete" t-on-click.stop.prevent="tag.onDelete" href="#" class="fa fa-times o_delete" title="Delete" aria-label="Delete"/>
            </div>
        </xpath>
    </t>
`);
registerTemplate("mail.Many2OneAvatarUserField", `/mail/static/src/views/web/fields/many2one_avatar_user_field/many2one_avatar_user_field.xml`, `<t t-name="mail.Many2OneAvatarUserField" t-inherit="web.Many2OneAvatarField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[hasclass('o_m2o_avatar')]" position="attributes">
            <attribute name="t-on-click.stop.prevent">onClickAvatar</attribute>
        </xpath>
    </t>

    `);
registerTemplate("mail.KanbanMany2OneAvatarUserField", `/mail/static/src/views/web/fields/many2one_avatar_user_field/many2one_avatar_user_field.xml`, `<t t-name="mail.KanbanMany2OneAvatarUserField" t-inherit="web.KanbanMany2OneAvatarField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[hasclass('o_m2o_avatar')]" position="attributes">
            <attribute name="t-on-click.stop.prevent">onClickAvatar</attribute>
        </xpath>
        <xpath expr="//t[@t-call='web.Many2OneField']" position="attributes">
            <attribute name="t-if">props.readonly and props.displayAvatarName</attribute>
        </xpath>
    </t>
`);
registerTemplateExtension("web.PropertyValue", `/mail/static/src/views/web/fields/properties_field/property_value.xml`, `<t t-inherit="web.PropertyValue" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('o_field_property_many2one_value')]//img" position="attributes">
            <attribute name="t-on-click.prevent.stop">_onAvatarClicked</attribute>
            <attribute name="t-att-comodel">props.comodel</attribute>
        </xpath>
    </t>

    `);
registerTemplate("mail.Many2manyPropertiesTagsList", `/mail/static/src/views/web/fields/properties_field/property_value.xml`, `<t t-name="mail.Many2manyPropertiesTagsList" t-inherit="web.TagsList" t-inherit-mode="primary" xml:space="preserve">
        <img position="attributes">
            <attribute name="t-on-click.prevent.stop">() =&gt; this._onAvatarClicked(tag_index)</attribute>
            <attribute name="t-att-comodel">tag.comodel</attribute>
        </img>
    </t>
`);
registerTemplate("mail.ActionPanel", `/mail/static/src/discuss/core/common/action_panel.xml`, `<t t-name="mail.ActionPanel" xml:space="preserve">
        <ResizablePanel t-if="props.resizable and !env.inChatWindow and !env.inChatter" class="classNames" handleSide="'start'" initialWidth="props.initialWidth ?? store.discuss.INSPECTOR_WIDTH" minWidth="props.minWidth ?? store.discuss.INSPECTOR_WIDTH">
            <t t-call="mail.ActionPanel.content"/>
        </ResizablePanel>
        <div t-else="" t-att-class="classNames">
            <t t-call="mail.ActionPanel.content"/>
        </div>
    </t>

    `);
registerTemplate("mail.ActionPanel.content", `/mail/static/src/discuss/core/common/action_panel.xml`, `<t t-name="mail.ActionPanel.content" xml:space="preserve">
        <div class="o-mail-ActionPanel-header position-sticky top-0 pt-2 pb-1 d-flex flex-column bg-inherit smaller" t-att-class="{ 'px-1': env.inChatWindow, 'pe-2': !env.inChatWindow }">
            <div class="d-flex align-items-baseline gap-1">
                <button t-if="env.closeActionPanel" class="btn p-1 opacity-75 opacity-100-hover" title="Close panel" t-on-click.stop="env.closeActionPanel">
                    <i class="oi oi-arrow-left fa-fw"/>
                </button>
                <i t-if="props.icon" class="text-muted opacity-50" t-att-class="props.icon"/>
                <p t-if="props.title" class="fw-bold text-uppercase m-0 text-muted opacity-75 flex-grow-1" t-esc="props.title"/>
            </div>
            <t t-slot="header"/>
        </div>
        <div class="px-1 d-flex flex-column flex-grow-1 bg-inherit">
            <t t-slot="default"/>
        </div>
    </t>

`);
registerTemplate("mail.AttachmentPanel", `/mail/static/src/discuss/core/common/attachment_panel.xml`, `<t t-name="mail.AttachmentPanel" xml:space="preserve">
        <ActionPanel title.translate="Attachments" minWidth="200" initialWidth="400" icon="'fa fa-paperclip'">
            <div class="d-flex flex-column py-2 flex-grow-1">
                <div t-if="hasToggleAllowPublicUpload" class="form-check form-switch mx-4">
                    <label class="form-check-label">
                        <input t-on-change="toggleAllowPublicUpload" class="form-check-input" type="checkbox" role="switch" t-att-checked="props.thread.allow_public_upload"/>
                        <t t-if="props.thread.allow_public_upload">File upload is enabled for external users</t>
                        <t t-else="">File upload is disabled for external users</t>
                    </label>
                </div>
                <div class="flex-grow-1" t-att-class="{                     'd-flex justify-content-center align-items-center': props.thread.attachments.length === 0,                 }">
                    <p t-if="props.thread.attachments.length === 0" class="text-center fst-italic text-500">
                        <t t-if="props.thread.channel_type === 'channel'">This channel doesn't have any attachments.</t>
                        <t t-else="">This conversation doesn't have any attachments.</t>
                    </p>
                    <div t-else="" t-foreach="attachmentsByDate" t-as="dateDay" t-key="dateDay" class="d-flex flex-column">
                        <DateSection date="dateDay" className="'my-1'"/>
                        <AttachmentList imagesHeight="100" attachments="dateDay_value" unlinkAttachment="(attachment) =&gt; this.attachmentUploadService.unlink(attachment)"/>
                    </div>
                </div>
                <span t-ref="load-older"/>
            </div>
        </ActionPanel>
    </t>
`);
registerTemplate("discuss.ChannelInvitation", `/mail/static/src/discuss/core/common/channel_invitation.xml`, `<t t-name="discuss.ChannelInvitation" xml:space="preserve">
        <ActionPanel title.translate="Invite people" resizable="false" icon="'fa fa-user-plus'">
            <div class="d-flex flex-column flex-grow-1 bg-inherit" t-att-class="{ 'o-mail-Discuss-threadActionPopover w-100': props.hasSizeConstraints }">
                <t t-if="store.self.type === 'partner'">
                    <input class="o-discuss-ChannelInvitation-search form-control lh-1 px-2 bg-white" t-ref="input" placeholder="Type the name of a person" t-on-input="onInput"/>
                    <ul class="d-flex flex-column mx-0 pt-1 pb-0 overflow-auto list-group border-0 flex-grow-1" t-att-class="{ 'align-items-center justify-content-center': state.selectablePartners.length === 0 }">
                        <div t-if="state.selectablePartners.length === 0" class="small text-muted mx-1 fst-italic">No user found that is not already a member of this channel.</div>
                        <div t-if="state.searchResultCount &gt; state.selectablePartners.length" class="smaller text-muted mx-1 fst-italic">
                            Showing
                            <t t-esc="state.selectablePartners.length"/>
                            results out of
                            <t t-esc="state.searchResultCount"/>
                            . Narrow your search to see more choices.
                        </div>
                        <t t-foreach="state.selectablePartners" t-as="selectablePartner" t-key="selectablePartner.id">
                            <li class="o-discuss-ChannelInvitation-selectable o_object_fit_cover d-flex align-items-center px-1 py-0 btn list-group-item border-0 rounded-0" t-att-class="{ 'o-odd': selectablePartner_index % 2 === 1, 'o-selected': selectablePartner.in(state.selectedPartners) }" t-on-click="() =&gt; this.onClickSelectablePartner(selectablePartner)">
                                <div class="d-flex align-items-center p-1 bg-inherit">
                                    <div class="o-discuss-ChannelInvitation-avatar position-relative d-flex flex-shrink-0 bg-inherit">
                                        <img class="w-100 h-100 rounded o_object_fit_cover" t-att-src="selectablePartner.avatarUrl"/>
                                        <ImStatus persona="selectablePartner" className="'position-absolute top-100 start-100 translate-middle mt-n1 ms-n1'" size="'md'"/>
                                    </div>
                                </div>
                                <t name="selectablePartnerDetail">
                                    <span class="flex-grow-1 mx-2 text-truncate text-start" t-esc="selectablePartner.name"/>
                                </t>
                                <input class="form-check-input flex-shrink-0 me-1" type="checkbox" t-att-checked="selectablePartner.in(state.selectedPartners) ? 'checked' : undefined"/>
                            </li>
                        </t>
                    </ul>
                </t>
                <div class="o-discuss-ChannelInvitation-invitationBox pt-0 pb-1 bg-inherit">
                    <t t-if="store.self.type === 'partner'">
                        <div t-if="state.selectedPartners.length &gt; 0" class="pt-2">
                            <div class="o-discuss-ChannelInvitation-selectedList d-flex flex-wrap overflow-auto">
                                <t t-foreach="state.selectedPartners" t-as="selectedPartner" t-key="selectedPartner.id">
                                    <button class="btn btn-light fw-bolder smaller pe-1" title="Unselect person" t-on-click="() =&gt; this.onClickSelectedPartner(selectedPartner)">
                                        <t t-esc="selectedPartner.name"/> <i class="oi oi-close border border-dark-subtle ms-1"/>
                                    </button>
                                </t>
                            </div>
                        </div>
                        <button class="btn btn-primary w-100 my-2" t-att-disabled="this.state.selectedPartners.length === 0" t-att-title="invitationButtonText" t-on-click="onClickInvite">
                            <t t-esc="invitationButtonText"/>
                        </button>
                    </t>
                    <div t-if="props.thread.invitationLink" class="input-group">
                        <input class="border border-secondary form-control lh-1 px-2 py-0 opacity-75" type="text" t-att-value="props.thread.invitationLink" readonly="" t-on-focus="onFocusInvitationLinkInput"/>
                        <button class="btn btn-primary px-2 py-1" t-on-click="onClickCopy">
                            <i class="fa fa-copy"/>
                        </button>
                    </div>
                    <div t-if="props.thread.accessRestrictedToGroupText" class="mt-2 text-muted smaller mx-1" t-esc="props.thread.accessRestrictedToGroupText"/>
                </div>
            </div>
        </ActionPanel>
    </t>

`);
registerTemplate("discuss.ChannelMemberList", `/mail/static/src/discuss/core/common/channel_member_list.xml`, `<t t-name="discuss.ChannelMemberList" xml:space="preserve">
        <ActionPanel title.translate="Members" minWidth="200" initialWidth="250" icon="'fa fa-users'">
            <button t-on-click="() =&gt; props.openChannelInvitePanel({ keepPrevious: env.inChatWindow })" class="btn btn-sm btn-secondary mt-2 d-flex align-items-center justify-content-center gap-1 rounded"><i class="fa fa-user-plus opacity-75"/><span>Invite a User</span></button>
            <t t-if="props.thread.onlineMembers.length &gt; 0">
                <t t-call="discuss.ChannelMemberList.section">
                    <t t-set="sectionName" t-value="onlineSectionText"/>
                </t>
                <div class="d-flex flex-column bg-inherit gap-1">
                    <t t-foreach="props.thread.onlineMembers" t-as="member" t-key="member.id" t-call="discuss.channel_member"/>
                </div>
            </t>
            <t name="offlineMembers" t-if="props.thread.offlineMembers.length &gt; 0">
                <t t-call="discuss.ChannelMemberList.section">
                    <t t-set="sectionName" t-value="offlineSectionText"/>
                </t>
                <div class="d-flex flex-column bg-inherit gap-1">
                    <t t-foreach="props.thread.offlineMembers" t-as="member" t-key="member.id" t-call="discuss.channel_member">
                        <t t-set="offline" t-value="1"/>
                    </t>
                </div>
            </t>
            <span t-if="props.thread.unknownMembersCount === 1" class="mx-2 mt-2">And 1 other member.</span>
            <span t-if="props.thread.unknownMembersCount &gt; 1" class="mx-2 mt-2">And <t t-esc="props.thread.unknownMembersCount"/> other members.</span>
            <div t-if="!props.thread.areAllMembersLoaded" class="mx-2 my-1">
                <button class="btn btn-secondary" title="Load more" t-on-click.stop="() =&gt; props.thread.fetchChannelMembers()">Load more</button>
            </div>
        </ActionPanel>
    </t>

    `);
registerTemplate("discuss.ChannelMemberList.section", `/mail/static/src/discuss/core/common/channel_member_list.xml`, `<t t-name="discuss.ChannelMemberList.section" xml:space="preserve">
        <h6 class="text-muted pt-4 text-uppercase o-xsmaller opacity-75" t-esc="sectionName"/>
    </t>

    `);
registerTemplate("discuss.channel_member", `/mail/static/src/discuss/core/common/channel_member_list.xml`, `<t t-name="discuss.channel_member" xml:space="preserve">
        <div class="o-discuss-ChannelMember d-flex align-items-center p-1 bg-inherit rounded" t-att-class="{ 'cursor-pointer': canOpenChatWith(member), 'o-offline': offline }" t-on-click.stop="(ev) =&gt; this.onClickAvatar(ev, member)">
            <div class="bg-inherit o-discuss-ChannelMember-avatar position-relative d-flex flex-shrink-0">
                <img class="w-100 h-100 rounded o_object_fit_cover" t-att-src="member.persona.avatarUrl"/>
                <ImStatus member="member" className="'position-absolute top-100 start-100 translate-middle mt-n1 ms-n1'" size="'md'"/>
            </div>
            <div t-ref="displayName" class="d-flex overflow-hidden flex-column">
                <span class="ms-2 text-truncate text-muted fw-bold" t-esc="member.name" t-att-title="member.name"/>
            </div>
            <span class="ms-auto">
                <span t-if="member.in(props.thread.invitedMembers)" class="p-1 fa fa-user-plus opacity-75"/>
                <span t-if="member.rtcSession?.isSelfMuted and !member.rtcSession?.isDeaf" class="p-1 fa fa-microphone-slash opacity-75"/>
                <span t-elif="member.rtcSession?.isDeaf" class="p-1 fa fa-deaf opacity-75"/>
                <span t-if="member.rtcSession?.raisingHand" class="p-1 fa fa-hand-paper-o"/>
            </span>

        </div>
    </t>

`);
registerTemplate("mail.DiscussNotificationSettings", `/mail/static/src/discuss/core/common/discuss_notification_settings.xml`, `<t t-name="mail.DiscussNotificationSettings" xml:space="preserve">
        <div class="o-mail-DiscussNotificationSettings d-flex flex-column">
            <div class="d-flex flex-column my-1">
                <label class="cursor-pointer d-flex align-items-center">
                    <h5>Mute all conversations</h5>
                    <div class="flex-grow-1"/>
                    <div class="form-check form-switch">
                        <input class="form-check-input" type="checkbox" role="switch" t-att-checked="store.settings.mute_until_dt" t-on-change="onChangeDisplayMuteDetails"/>
                    </div>
                </label>
                <span class="mt-1 text-muted small">Muting prevents unread indicators and notifications from appearing.</span>
            </div>
            <label t-if="store.settings.mute_until_dt" class="d-flex align-items-baseline my-1">
                <div class="d-flex flex-column">
                    <h6 class="flex-shrink-0 mb-1">Mute duration</h6>
                    <span class="text-muted smaller" t-esc="store.settings.getMuteUntilText(store.settings.mute_until_dt)"/>
                </div>
                <div class="flex-grow-1"/>
                <select class="form-select w-auto d-flex" t-on-change="onChangeMuteDuration">
                    <t t-foreach="store.settings.MUTES" t-as="mute" t-key="mute.label">
                        <option t-att-value="mute.value" t-esc="mute.name" t-att-selected="mute.value === state.selectedDuration"/>
                    </t>
                </select>
            </label>
            <hr class="o-discuss-separator my-1"/>
            <div class="d-flex flex-column my-1">
                <h5>Channel Notifications</h5>
                <span class="mb-1 text-muted small">This setting will be applied to all channels using the default notification settings.</span>
                <t t-foreach="store.settings.NOTIFICATIONS" t-as="notif" t-key="notif.label">
                    <button class="btn d-flex my-1" t-att-class="{'o-selected' : notif.label === store.settings.channel_notifications}" t-on-click="()=&gt; this.store.settings.setCustomNotifications(notif.label)">
                        <input class="form-check-input" type="radio" t-att-checked="notif.label === store.settings.channel_notifications"/>
                        <div class="d-flex flex-column text-start flex-grow-1 mx-3">
                            <span t-esc="notif.name"/>
                        </div>
                    </button>
                </t>
            </div>
        </div>
    </t>
`);
registerTemplate("discuss.NotificationSettings", `/mail/static/src/discuss/core/common/notification_settings.xml`, `<t t-name="discuss.NotificationSettings" xml:space="preserve">
        <ActionPanel title.translate="Notification Settings" resizable="false" icon="'fa fa-bell'">
            <div class="o-discuss-NotificationSettings">
                <div t-if="store.settings.mute_until_dt" class="d-flex flex-column alert alert-warning">
                    <span><i class="fa fa-exclamation-triangle"/> <a href="#" t-on-click="onClickAllConversationsMuted">All conversations have been muted</a></span>
                </div>
                <t t-if="props.thread.mute_until_dt">
                    <button class="btn w-100 d-flex p-1 opacity-75" t-on-click="()=&gt;this.setMute(false)">
                        <div class="d-flex flex-column flex-grow-1 px-2 py-1 w-100 rounded">
                            <span class="fs-6 fw-bold text-wrap text-start text-break">Unmute Conversation</span>
                            <span class="fw-normal smaller text-start" t-out="store.settings.getMuteUntilText(props.thread.mute_until_dt)"/>
                        </div>
                    </button>
                </t>
                <div t-elif="!store.settings.mute_until_dt" class="d-flex">
                    <Dropdown position="'right-start'" menuClass="'o-mail-NotificationSettings-submenu d-flex flex-column py-0 my-0'">
                        <button class="btn w-100 d-flex p-1 opacity-75">
                            <div class="d-flex flex-grow-1 align-items-center px-2 py-1 w-100 rounded">
                                <span class="text-wrap text-start text-break">Mute Conversation</span>
                                <div class="o-discuss-NotificationSettings-separator flex-grow-1"/>
                                <i class="oi oi-arrow-right ms-2"/>
                            </div>
                        </button>
                        <t t-set-slot="content">
                            <t t-foreach="store.settings.MUTES" t-as="mute" t-key="mute.label">
                                <DropdownItem class="'o-mail-NotificationSettings-muteDuration btn rounded-0 d-flex align-items-center px-2 py-2 m-0'" onSelected="()=&gt;this.setMute(mute.value)"><button class="btn p-0 mx-2 text-wrap text-start text-break" t-out="mute.name"/></DropdownItem>
                            </t>
                        </t>
                    </Dropdown>
                </div>
                <t t-if="props.thread.channel_type === 'channel' and !store.settings.mute_until_dt">
                    <hr class="solid m-2"/>
                    <button class="btn d-flex w-100 px-1 py-0" t-on-click="() =&gt; store.settings.setCustomNotifications(false, props.thread)">
                        <div class="d-flex flex-grow-1 align-items-center px-2 rounded">
                            <div class="d-flex flex-column align-items-start">
                                <span class="fs-6 text-wrap text-start text-break">Use Default</span>
                                <span class="fw-bolder o-xsmaller ps-2 o-discuss-NotificationSettings-defaultValue"><t t-out="store.settings.NOTIFICATIONS.find((n) =&gt; n.label === store.settings.channel_notifications).name"/></span>
                            </div>
                            <div class="o-discuss-NotificationSettings-separator flex-grow-1"/>
                            <input class="form-check-input" type="radio" t-att-checked="!props.thread.custom_notifications"/>
                        </div>
                    </button>
                    <t t-foreach="store.settings.NOTIFICATIONS" t-as="notif" t-key="notif.label">
                        <button class="btn w-100 d-flex px-1 py-0" t-on-click="() =&gt; store.settings.setCustomNotifications(notif.label, props.thread)">
                            <div class="d-flex flex-grow-1 align-items-center px-2 py-1 rounded">
                                <span class="fs-6 fw-normal text-wrap text-start text-break" t-esc="notif.name"/>
                                <div class="o-discuss-NotificationSettings-separator flex-grow-1"/>
                                <input class="form-check-input ms-2" type="radio" t-att-checked="props.thread.custom_notifications === notif.label"/>
                            </div>
                        </button>
                    </t>
                </t>
            </div>
        </ActionPanel>
    </t>

`);
registerTemplate("mail.BusConnectionAlert", `/mail/static/src/discuss/core/public_web/bus_connection_alert.xml`, `<t t-name="mail.BusConnectionAlert" xml:space="preserve">
        <div t-if="busMonitoring.isConnectionLost and store.discuss.isActive" class="o-bus-ConnectionAlert position-absolute top-0 bottom-0 end-0 start-0 pe-none">
            <div class="o-bus-ConnectionAlert-failure small d-flex align-items-baseline m-0 position-absolute bottom-0 end-0 rounded-3 rounded-bottom-0 rounded-end-0 z-1 smaller gap-1" role="alert">
                <i class="o-bus-ConnectionAlert-icon fa fa-warning text-warning o-xsmaller opacity-75"/>
                <span class="o-bus-ConnectionAlert-label lh-1 opacity-75">Real-time connection lost...</span>
            </div>
        </div>
    </t>
`);
registerTemplate("mail.DiscussSidebarCategories", `/mail/static/src/discuss/core/public_web/discuss_sidebar_categories.xml`, `<t t-name="mail.DiscussSidebarCategories" xml:space="preserve">
        <t t-if="hasQuickSearch">
            <Dropdown t-if="store.discuss.isSidebarCompact" state="quickSearchFloating" position="'right-start'" menuClass="'o-mail-DiscussSidebar-floatingMenu bg-100 border border-secondary mx-2 my-0 min-w-0 p-0 shadow-sm'" manual="true">
                <button class="o-mail-DiscussSidebarCategories-quickSearchBtn btn btn-secondary d-flex align-items-center justify-content-center px-1 mx-2 bg-inherit" t-att-class="{ 'o-active': state.quickSearchVal.length, 'opacity-50 opacity-100-hover': store.discuss.isSidebarCompact }" t-on-click="() =&gt; state.floatingQuickSearchOpen = true" t-ref="quick-search-btn"><i class="fa fa-search"/></button>
                <t t-set-slot="content">
                    <div t-att-class="{ 'p-2': !state.floatingQuickSearchOpen }" t-ref="quick-search-floating">
                        <DiscussSidebarQuickSearchInput t-if="state.floatingQuickSearchOpen" state="state" autofocus="true"/>
                        <span t-else="" class="text-muted user-select-none">Quick search</span>
                    </div>
                </t>
            </Dropdown>
            <DiscussSidebarQuickSearchInput t-else="" state="state"/>
        </t>
        <t t-foreach="store.discuss.allCategories" t-as="cat" t-key="cat.id">
            <t t-if="cat.isVisible" t-call="mail.DiscussSidebarCategories.category">
                <t t-set="category" t-value="cat"/>
            </t>
        </t>
    </t>

    `);
registerTemplate("mail.DiscussSidebarQuickSearchInput", `/mail/static/src/discuss/core/public_web/discuss_sidebar_categories.xml`, `<t t-name="mail.DiscussSidebarQuickSearchInput" xml:space="preserve">
        <div class="o-mail-DiscussSidebarQuickSearchInput d-flex align-items-center justify-content-center rounded gap-1" t-att-class="{ 'o-active': state.quickSearchVal.length, 'mx-3 mt-2 mb-1': !store.discuss.isSidebarCompact }">
            <input class="form-control rounded-3 border-0" placeholder="Quick search…" t-model="state.quickSearchVal" t-ref="root"/>
            <button t-if="state.quickSearchVal.length" class="btn btn-light p-1 rounded-0" t-on-click="() =&gt; state.quickSearchVal = ''"><i class="oi oi-close" title="Clear quick search"/></button>
        </div>
    </t>

    `);
registerTemplate("mail.DiscussSidebarCategories.category", `/mail/static/src/discuss/core/public_web/discuss_sidebar_categories.xml`, `<t t-name="mail.DiscussSidebarCategories.category" xml:space="preserve">
        <DiscussSidebarCategory category="category"/>
        <t t-if="category.open">
            <DiscussSidebarChannel t-foreach="filteredThreads(category.threads)" t-as="thread" t-key="thread.localId" thread="thread"/>
        </t>
        <DiscussSidebarChannel t-elif="store.discuss.thread?.in(category.threads)" thread="store.discuss.thread"/>
        <DiscussSidebarChannel t-elif="store.discuss.thread?.parent_channel_id?.in(category.threads)" thread="store.discuss.thread.parent_channel_id"/>
    </t>

    `);
registerTemplate("mail.DiscussSidebarCategory", `/mail/static/src/discuss/core/public_web/discuss_sidebar_categories.xml`, `<t t-name="mail.DiscussSidebarCategory" xml:space="preserve">
        <Dropdown t-if="store.discuss.isSidebarCompact" state="floating" position="'right-start'" menuClass="'o-mail-DiscussSidebar-floatingMenu bg-100 border border-secondary p-2 mx-2 my-0 min-w-0 shadow-sm'" manual="true">
            <t t-call="mail.DiscussSidebarCategory.main"/>
            <t t-set-slot="content">
                <div class="overflow-hidden" t-ref="floating">
                    <span class="fw-bold text-uppercase o-xsmaller user-select-none text-muted" t-esc="category.name"/>
                    <t t-call="mail.DiscussSidebarCategory.actions"/>
                </div>
            </t>
        </Dropdown>
        <t t-else="" t-call="mail.DiscussSidebarCategory.main"/>
    </t>

    `);
registerTemplate("mail.DiscussSidebarCategory.main", `/mail/static/src/discuss/core/public_web/discuss_sidebar_categories.xml`, `<t t-name="mail.DiscussSidebarCategory.main" xml:space="preserve">
        <div class="o-mail-DiscussSidebarCategory d-flex align-items-center" t-att-class="{ 'mx-1 my-2 position-relative': store.discuss.isSidebarCompact, 'mt-1 ms-1 me-2': !store.discuss.isSidebarCompact }" t-attf-class="#{category.extraClass}" name="header" t-ref="root">
            <button class="o-mail-DiscussSidebarCategory-toggler btn btn-link text-reset flex-grow-1 d-flex p-0 text-start opacity-100-hover" t-att-class="{ 'align-items-baseline opacity-75 o-gap-0_5': !store.discuss.isSidebarCompact, 'align-items-center justify-content-center border-0 o-compact opacity-50 gap-1': store.discuss.isSidebarCompact }" t-on-click="() =&gt; this.toggle()" name="toggler">
                <t t-if="store.discuss.isSidebarCompact">
                    <i class="o-mail-DiscussSidebarCategory-chevronCompact position-absolute fa-fw o-xxsmaller" t-att-class="{                         'oi oi-chevron-down': category.open,                         'oi oi-chevron-right opacity-50': !category.open,                     }"/>
                    <span class="rounded p-1" t-att-class="{ 'opacity-50': !category.open }"><i t-if="store.channels.status === 'fetching'" class="fa fa-fw fa-circle-o-notch fa-spin"/><i t-else="" class="fa-fw fa-lg" t-att-class="category.icon ?? 'fa fa-user'"/></span>
                </t>
                <t t-else="">
                    <span t-if="store.channels.status === 'fetching'" class="o-visible-short-delay"><i class="o-mail-DiscussSidebarCategory-icon o-xxsmaller fa fa-fw fa-circle-o-notch fa-spin opacity-50"/></span>
                    <i t-else="" class="o-mail-DiscussSidebarCategory-icon o-xxsmaller fa-fw" t-att-class="category.open ? 'oi oi-chevron-down opacity-100' : 'oi oi-chevron-right opacity-50'"/>
                    <span class="btn-sm p-0 text-uppercase text-break fw-bolder o-xsmaller text-muted" t-att-class="{ 'opacity-50': !category.open }"><t t-esc="category.name"/></span>
                </t>
            </button>
            <t t-if="actions.length and !store.discuss.isSidebarCompact" t-call="mail.DiscussSidebarCategory.actions"/>
            <div t-if="!category.open and store.getDiscussSidebarCategoryCounter(category.id) &gt; 0" class="o-mail-DiscussSidebar-badge badge rounded-pill o-discuss-badge fw-bold" t-att-class="{ 'position-absolute top-0 o-compact': store.discuss.isSidebarCompact, 'me-1': !store.discuss.isSidebarCompact }">
                <t t-esc="store.getDiscussSidebarCategoryCounter(category.id)"/>
            </div>
        </div>
    </t>

    `);
registerTemplate("mail.DiscussSidebarCategory.actions", `/mail/static/src/discuss/core/public_web/discuss_sidebar_categories.xml`, `<t t-name="mail.DiscussSidebarCategory.actions" xml:space="preserve">
        <div class="d-flex">
            <div class="o-mail-DiscussSidebarCategory-actions" t-att-class="{ 'd-flex flex-column align-items-start pt-1': store.discuss.isSidebarCompact, 'btn-group btn-group-sm mx-1 o-gap-0_5': !store.discuss.isSidebarCompact }">
                <t name="action-group">
                    <t t-foreach="actions" t-as="action" t-key="action_index">
                        <button class="btn w-100 o-opacity-35 opacity-100-hover" t-on-click="() =&gt; action.onSelect()" t-att-class="{ 'd-flex align-items-center px-1 py-0 gap-1 text-start smaller btn-secondary': store.discuss.isSidebarCompact, 'btn-light bg-transparent rounded-3 p-0 border-transparent': !store.discuss.isSidebarCompact }" t-attf-class="#{action.class}" t-att-title="store.discuss.isSidebarCompact ? '' : action.label" t-att-data-hotkey="action.hotkey">
                            <i role="img" class="fa-fw" t-att-class="action.icon"/>
                            <span t-if="store.discuss.isSidebarCompact" class="text-muted" t-esc="action.label"/>
                        </button>
                    </t>
                </t>
            </div>
        </div>
    </t>

    `);
registerTemplate("mail.DiscussSidebarChannel", `/mail/static/src/discuss/core/public_web/discuss_sidebar_categories.xml`, `<t t-name="mail.DiscussSidebarChannel" xml:space="preserve">
        <div class="o-mail-DiscussSidebarChannel-container d-flex flex-column mx-2 bg-inherit" t-att-class="attClassContainer">
            <t name="root">
                <Dropdown t-if="store.discuss.isSidebarCompact" state="floating" position="'right-start'" menuClass="'o-mail-DiscussSidebar-floatingMenu bg-100 border border-secondary p-2 mx-2 my-0 min-w-0 shadow-sm'" manual="true">
                    <t t-call="mail.DiscussSidebarChannel.main"/>
                    <t t-set-slot="content">
                        <div class="overflow-hidden" t-ref="floating">
                            <span class="fw-bolder user-select-none" t-esc="thread.displayName"/>
                            <t t-call="mail.DiscussSidebarChannel.commands"/>
                        </div>
                    </t>
                </Dropdown>
                <t t-else="" t-call="mail.DiscussSidebarChannel.main"/>
                <ul t-if="subChannels?.length &gt; 0" class="list-unstyled position-relative flex-grow-1" t-att-class="{ 'my-1 d-flex flex-column gap-1': store.discuss.isSidebarCompact, 'my-0 d-flex flex-column gap-1': !store.discuss.isSidebarCompact }">
                    <t t-foreach="subChannels" t-as="sub" t-key="sub.localId">
                        <DiscussSidebarSubchannel t-if="showThread(sub)" thread="sub" isFirst="sub_first or !thread.discussAppCategory.open"/>
                    </t>
                </ul>
            </t>
        </div>
    </t>

    `);
registerTemplate("mail.DiscussSidebarSubchannel", `/mail/static/src/discuss/core/public_web/discuss_sidebar_categories.xml`, `<t t-name="mail.DiscussSidebarSubchannel" xml:space="preserve">
        <Dropdown t-if="store.discuss.isSidebarCompact" state="floating" position="'right-start'" menuClass="'o-mail-DiscussSidebar-floatingMenu bg-100 border border-secondary p-2 mx-2 my-0 min-w-0 shadow-sm'" manual="true">
            <t t-call="mail.DiscussSidebarSubchannel.main"/>
            <t t-set-slot="content">
                <div class="overflow-hidden user-select-none" t-ref="floating" t-esc="thread.displayName"/>
            </t>
        </Dropdown>
        <t t-else="" t-call="mail.DiscussSidebarSubchannel.main"/>
    </t>

    `);
registerTemplate("mail.DiscussSidebarSubchannel.main", `/mail/static/src/discuss/core/public_web/discuss_sidebar_categories.xml`, `<t t-name="mail.DiscussSidebarSubchannel.main" xml:space="preserve">
        <li class="o-mail-DiscussSidebarSubchannel d-flex align-items-center flex-grow-1 position-relative" t-att-class="{ 'p-0': !store.discuss.isSidebarCompact }" t-ref="root">
            <t t-if="!store.discuss.isSidebarCompact">
                <svg xmlns="http://www.w3.org/2000/svg" t-if="props.isFirst" class="position-absolute opacity-75" style="top: -6px;" width="10" height="20" viewBox="0 0 10 20">
                    <line x1="0" y1="3" x2="0" y2="100%" stroke="currentColor" stroke-width="3"/>
                    <line x1="0" y1="100%" x2="100%" y2="100%" stroke="currentColor" stroke-width="3"/>
                </svg>
                <svg xmlns="http://www.w3.org/2000/svg" t-else="" class="position-absolute opacity-75" style="top: -20px;" width="10" height="34" viewBox="0 0 10 34">
                    <line x1="0" y1="3" x2="0" y2="100%" stroke="currentColor" stroke-width="3"/>
                    <line x1="0" y1="100%" x2="100%" y2="100%" stroke="currentColor" stroke-width="3"/>
                </svg>
            </t>
            <button class="o-mail-DiscussSidebarChannel-subChannel o-mail-DiscussSidebar-item btn btn-secondary border-0 bg-inherit d-flex flex-grow-1 smaller rounded text-start text-truncate align-items-center" t-att-title="store.discuss.isSidebarCompact ? undefined : thread.displayName" t-on-click="(ev) =&gt; this.openThread(ev, thread)" t-att-class="{                 'o-active': thread.eq(this.store.discuss.thread),                 'px-1 py-2 mx-1 text-wrap word-break lh-1': store.discuss.isSidebarCompact,                 'o-nonCompact me-1 p-0 ps-1': !store.discuss.isSidebarCompact,                 'o-item-unread': thread.selfMember?.message_unread_counter &gt; 0 and !thread.isMuted,                 'opacity-50': thread.isMuted,             }">
                <span class="text-truncate" t-esc="thread.displayName" t-att-class="{                     'fw-bolder': thread.selfMember?.message_unread_counter &gt; 0,                     'text-muted': !(thread.selfMember?.message_unread_counter &gt; 0 and !thread.isMuted),                 }" t-att-style="store.discuss.isSidebarCompact ? 'text-overflow: clip;' : ''"/>
                <span class="flex-grow-1"/>
                <t t-if="!store.discuss.isSidebarCompact" t-call="mail.DiscussSidebarChannel.commands"/>
                <span t-if="thread.importantCounter &gt; 0" t-attf-class="o-mail-DiscussSidebar-badge badge rounded-pill o-discuss-badge fw-bold top-0 {{thread.isMuted ? 'o-muted' : ''}}" t-att-class="{ 'mx-1': !store.discuss.isSidebarCompact, 'position-absolute top-0 o-compact': store.discuss.isSidebarCompact }" t-esc="thread.importantCounter"/>
            </button>
            <t t-if="thread.selfMember?.message_unread_counter &gt; 0 and !thread.isMuted and thread.importantCounter === 0" t-call="mail.DiscussSidebar.unreadIndicator"/>
        </li>
    </t>

    `);
registerTemplate("mail.DiscussSidebar.unreadIndicator", `/mail/static/src/discuss/core/public_web/discuss_sidebar_categories.xml`, `<t t-name="mail.DiscussSidebar.unreadIndicator" xml:space="preserve">
        <span class="o-mail-DiscussSidebar-unreadIndicator position-absolute opacity-50" t-att-class="{ 'o-compact': store.discuss.isSidebarCompact }" title="Thread has unread messages"><i class="fa fa-circle smaller"/></span>
    </t>

    `);
registerTemplate("mail.DiscussSidebarChannel.main", `/mail/static/src/discuss/core/public_web/discuss_sidebar_categories.xml`, `<t t-name="mail.DiscussSidebarChannel.main" xml:space="preserve">
        <button class="o-mail-DiscussSidebarChannel btn o-mail-DiscussSidebar-item d-flex align-items-center cursor-pointer o-py-0_5 mb-0 position-relative rounded-2 gap-1 border-0" t-att-class="attClass" t-on-click="(ev) =&gt; this.openThread(ev, thread)" t-ref="root">
            <div class="o-mail-DiscussSidebarChannel-itemMain border-0 rounded-start-2 text-reset d-flex align-items-center p-0" t-att-class="{ 'overflow-hidden': !store.discuss.isSidebarCompact }" t-att-title="store.discuss.isSidebarCompact ? undefined : thread.displayName">
                <div class="bg-inherit position-relative d-flex flex-shrink-0" style="width:26px;height:26px" t-att-class="{ 'ms-2': !store.discuss.isSidebarCompact }">
                    <img class="w-100 h-100 rounded o_object_fit_cover" t-att-src="thread.avatarUrl" alt="Thread Image"/>
                    <ThreadIcon t-if="thread.channel_type?.includes('chat') or (thread.channel_type === 'channel' and !thread.authorizedGroupFullName)" thread="thread" size="'small'" className="'o-mail-DiscussSidebarChannel-threadIcon position-absolute bottom-0 end-0 p-1 me-n1 mb-n1 d-flex align-items-center justify-content-center rounded-circle bg-inherit'"/>
                    <CountryFlag t-if="thread.showCorrespondentCountry" country="thread.correspondentCountry" class="'position-absolute o-mail-DiscussSidebarChannel-country border'"/>
                </div>
                <span t-if="!store.discuss.isSidebarCompact" class="o-mail-DiscussSidebarChannel-itemName mx-2 text-truncate" t-att-class="thread.selfMember?.message_unread_counter &gt; 0 and !thread.isMuted ? 'o-item-unread fw-bolder' : 'text-muted'">
                    <t t-esc="thread.displayName"/>
                </span>
            </div>
            <t t-if="!store.discuss.isSidebarCompact">
                <div class="flex-grow-1"/>
                <t t-call="mail.DiscussSidebarChannel.commands"/>
                <t t-foreach="indicators" t-as="indicator" t-key="indicator_index" t-component="indicator" t-props="{ thread }"/>
                <i t-if="thread.isMuted" class="fa fa-fw fa-bell-slash me-1"/>
            </t>
            <t t-else="">
                <div t-if="indicators.length" class="position-absolute rounded-circle p-0 smaller o-mail-DiscussSidebarChannel-indicatorCompact lh-1 bg-inherit" name="indicator-compact">
                    <t t-component="indicators[0]" t-props="{ thread }"/>
                </div>
            </t>
            <t t-if="thread.selfMember?.message_unread_counter &gt; 0 and !thread.isMuted and thread.importantCounter === 0" t-call="mail.DiscussSidebar.unreadIndicator"/>
            <span t-if="thread.importantCounter &gt; 0" t-attf-class="o-mail-DiscussSidebarChannel-badge o-mail-DiscussSidebar-badge badge rounded-pill o-discuss-badge flex-shrink-0 fw-bold {{thread.isMuted ? 'o-muted' : ''}}" t-att-class="{ 'mx-1': !store.discuss.isSidebarCompact, 'position-absolute top-0 o-compact': store.discuss.isSidebarCompact }" t-esc="thread.importantCounter"/>
        </button>
    </t>

    `);
registerTemplate("mail.DiscussSidebarChannel.commands", `/mail/static/src/discuss/core/public_web/discuss_sidebar_categories.xml`, `<t t-name="mail.DiscussSidebarChannel.commands" xml:space="preserve">
        <div class="o-mail-DiscussSidebarChannel-commands" t-att-class="{             'd-none': !store.discuss.isSidebarCompact,             'mx-1': !store.discuss.isSidebarCompact and thread.importantCounter === 0,             'ms-1': !store.discuss.isSidebarCompact and thread.importantCounter &gt; 0,         }">
            <div t-att-class="{ 'd-flex flex-column align-items-start ps-1 pt-1': store.discuss.isSidebarCompact, 'btn-group btn-group-sm o-gap-0_5': !store.discuss.isSidebarCompact }">
                <t t-foreach="sortedCommands" t-as="command" t-key="command_index">
                    <button class="btn o-opacity-35 opacity-100-hover" t-att-class="{ 'd-flex align-items-center px-1 py-0 gap-1 text-start smaller btn-secondary': store.discuss.isSidebarCompact, 'btn-light rounded-3 p-0 border-transparent': !store.discuss.isSidebarCompact }" t-on-click.stop="() =&gt; command.onSelect()" t-att-title="store.discuss.isSidebarCompact ? '' : command.label">
                        <i role="img" class="fa-fw" t-att-class="command.icon"/>
                        <span t-if="store.discuss.isSidebarCompact" t-esc="command.label"/>
                    </button>
                </t>
            </div>
        </div>
    </t>
`);
registerTemplate("mail.SubChannelList", `/mail/static/src/discuss/core/public_web/sub_channel_list.xml`, `<t t-name="mail.SubChannelList" xml:space="preserve">
        <ActionPanel title.translate="Threads" resizable="false" icon="'fa fa-comments-o'">
            <t t-set-slot="header">
                <div class="d-flex align-items-center my-0">
                    <div class="input-group ms-2 my-2">
                        <div class="form-control d-flex align-items-center p-0 bg-view" role="search" aria-autocomplete="list">
                            <div class="o_searchview_input_container d-flex flex-grow-1 flex-wrap gap-1 h-100">
                                <input t-ref="search" t-model="state.searchTerm" type="text" class="o_searchview_input rounded flex-grow-1 w-auto border-0 px-2" t-on-keydown="onKeydownSearch" placeholder="Search by name"/>
                            </div>
                        </div>
                        <button class="btn btn-outline-secondary px-2 py-1" aria-label="Search button" t-on-click="search">
                            <i t-if="!state.loading" class="o_searchview_icon oi oi-search" role="img" aria-label="Search Sub Channels" title="Search Sub Channels"/>
                            <i t-else="" class="fa fa-spin fa-spinner" aria-label="Search in progress" title="Search in progress"/>
                        </button>
                        <button t-if="store.self.isInternalUser" class="ms-1 btn btn-primary smaller" aria-label="Create Thread" t-on-click="onClickCreate">Create</button>
                    </div>
                </div>
            </t>
            <div class="o-mail-SubChannelList o-mail-Discuss-threadActionPopover mw-100 w-100 h-100" t-att-class="{ 'align-items-center justify-content-center': state.subChannels.length === 0 }">
                <div t-if="state.subChannels.length === 0" class="flex-grow-1 d-flex flex-column justify-content-center align-items-center">
                    <p class="my-1 pb-2 text-center fst-italic text-500">
                        <t t-if="state.searching" t-esc="NO_THREAD_FOUND"/>
                        <t t-else="">This channel has no thread yet.</t>
                    </p>
                </div>
                <div class="d-flex flex-column flex-grow-1 gap-1">
                    <t t-foreach="state.subChannels" t-as="thread" t-key="thread.localId">
                        <t t-set="message" t-value="thread.newestPersistentNotEmptyOfAllMessage ?? thread.from_message_id"/>
                        <button class="o-mail-SubChannelList-thread btn btn-light d-flex flex-column border border-secondary mx-1 px-2 py-1" t-on-click="() =&gt; this.onClickSubThread(thread)">
                            <div class="d-flex w-100">
                                <span class="fw-bold text-truncate small" t-esc="thread.displayName"/>
                                <span class="flex-grow-1"/>
                                <span t-if="message" class="text-muted smaller" t-esc="dateText(message)"/>
                            </div>
                            <div class="o-mail-SubChannelList-threadLastMessage text-start text-muted fw-normal smaller overflow-hidden ms-2">
                                <t t-if="message" t-call="mail.message_preview_prefix">
                                    <t t-set="message" t-value="message"/>
                                </t>
                                <t t-esc="message?.inlineBody"/>
                            </div>
                        </button>
                    </t>
                    <span class="pt-1" t-ref="load-more"/>
                </div>
            </div>
        </ActionPanel>
    </t>
`);
registerTemplate("discuss.ChannelSelector", `/mail/static/src/discuss/core/web/channel_selector.xml`, `<t t-name="discuss.ChannelSelector" xml:space="preserve">
    <div class="o-discuss-ChannelSelector d-flex flex-wrap form-control rounded p-0" t-ref="root">
        <TagsList t-if="props.multiple" tags="tagsList"/>
        <input class="text-truncate form-control flex-grow-1 border-0 px-2 py-1 bg-white" t-att-placeholder="inputPlaceholder" t-model="state.value" t-ref="input" t-on-click="(ev) =&gt; markEventHandled(ev, 'channelSelector.onClickInput')" t-on-keydown="onKeydownInput" type="text" maxlength="100"/>
    </div>
    <NavigableList class="'o-discuss-ChannelSelector-list z-1'" t-props="state.navigableListProps"/>
</t>

`);
registerTemplate("discuss.ChannelSelector.channel", `/mail/static/src/discuss/core/web/channel_selector.xml`, `<t t-name="discuss.ChannelSelector.channel" xml:space="preserve">
    <strong class="px-2 py-1 align-self-center flex-shrink-1 text-break">
        <t t-if="option.channelId === '__create__'">
            Create: #
        </t>
        <t t-esc="option.label"/>
    </strong>
</t>

`);
registerTemplate("discuss.ChannelSelector.chat", `/mail/static/src/discuss/core/web/channel_selector.xml`, `<t t-name="discuss.ChannelSelector.chat" xml:space="preserve">
    <ImStatus t-if="option.partner" persona="option.partner"/>
    <strong class="px-2 py-1 align-self-center text-truncate">
        <t t-esc="option.label"/>
    </strong>
</t>

`);
registerTemplateExtension("mail.ChatWindow", `/mail/static/src/discuss/core/web/chat_window_patch.xml`, `<t t-inherit="mail.ChatWindow" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//t[@name='thread content']" position="after">
            <div t-if="!thread" class="d-flex align-items-center m-3">
                <span class="flex-shrink-0 me-2">To :</span>
                <ChannelSelector autofocus="props.chatWindow.autofocus" category="store.discuss.chats" onValidate="() =&gt; this.close()" multiple="false"/>
            </div>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.DiscussSidebarCategory.main", `/mail/static/src/discuss/core/web/discuss_sidebar_categories_patch.xml`, `<t t-inherit="mail.DiscussSidebarCategory.main" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@name='header']" position="after">
            <div t-if="state.editing and !store.discuss.isSidebarCompact" class="px-2 pb-1" t-ref="selector">
                <ChannelSelector category="category" onValidate.bind="stopEditing" autofocus="true" close.bind="stopEditing"/>
            </div>
        </xpath>
    </t>
    `);
registerTemplateExtension("mail.DiscussSidebarCategory.actions", `/mail/static/src/discuss/core/web/discuss_sidebar_categories_patch.xml`, `<t t-inherit="mail.DiscussSidebarCategory.actions" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@name='action-group']" position="replace">
            <t t-if="state.editing and store.discuss.isSidebarCompact">
                <ChannelSelector category="category" onValidate.bind="stopEditing" autofocus="true" close.bind="stopEditing"/>
            </t>
            <t t-else="">
                <t>$0</t>
            </t>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.MessagingMenu.content", `/mail/static/src/discuss/core/web/messaging_menu_patch.xml`, `<t t-inherit="mail.MessagingMenu.content" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('o-mail-MessagingMenu-header')]" position="inside">
            <div class="flex-grow-1"/>
            <t name="searchBar" t-if="ui.isSmall and (store.discuss.activeTab !== 'main' or !env.inDiscussApp)">
                <div t-if="state.adding" class="w-100 p-1 bg-light" t-ref="selector">
                    <t t-if="state.adding === 'chat'" t-set="category" t-value="store.discuss.chats"/>
                    <t t-if="state.adding === 'channel'" t-set="category" t-value="store.discuss.channels"/>
                    <ChannelSelector category="category" autofocus="true"/>
                </div>
            </t>
            <button t-if="!ui.isSmall and !store.discuss.isActive" t-att-class="ui.isSmall ? 'w-50 p-2 btn btn-secondary m-1' : 'btn btn-link px-2 py-1'" t-on-click.stop="onClickNewMessage">
                New Message
            </button>
            <t t-if="ui.isSmall">
                <t t-if="store.discuss.activeTab !== 'main' or !env.inDiscussApp">
                    <button name="startMeetingButton" t-if="!state.adding" class="w-50 m-1 me-0 btn btn-primary" t-on-click.stop="onClickStartMeeting">
                        Start a meeting
                    </button>
                    <button t-if="displayStartConversation" t-att-class="ui.isSmall ? 'w-50 p-2 btn btn-secondary m-1' : 'btn btn-link p-2'" t-on-click.stop="onClickNewMessage">
                        Start a conversation
                    </button>
                </t>
                <button t-if="store.discuss.activeTab === 'channel' and !state.adding" class="w-50 p-2 btn btn-secondary m-1" t-on-click.stop="() =&gt; this.state.adding = 'channel'">
                    New Channel
                </button>
            </t>
        </xpath>
    </t>
`);
registerTemplate("discuss.Call", `/mail/static/src/discuss/call/common/call.xml`, `<t t-name="discuss.Call" xml:space="preserve">
        <PttAdBanner/>
        <div class="o-discuss-Call user-select-none d-flex position-relative" t-att-class="{             'o-fullscreen fixed-top vw-100 vh-100': state.isFullscreen,             'o-compact': props.compact and !isMobileOs,             'o-minimized': minimized,             'position-relative': !state.isFullscreen,         }">
            <div class="o-discuss-Call-main d-flex flex-grow-1 flex-column align-items-center justify-content-center position-relative overflow-auto" t-on-mouseleave="onMouseleaveMain">
                <div class="o-discuss-Call-mainCards d-flex align-items-center overflow-hidden h-100 w-100 flex-wrap justify-content-center" t-attf-style="--height:{{state.tileHeight}}px; --width:{{state.tileWidth}}px;" t-on-click="() =&gt; this.showOverlay()" t-on-mousemove="onMousemoveMain" t-ref="grid">
                    <CallParticipantCard t-foreach="visibleMainCards.slice(0,6)" t-as="cardData" t-key="cardData.key" cardData="cardData" className="'o-discuss-Call-mainCardStyle'" minimized="minimized" thread="props.thread"/>
                    <span t-if="env.inChatWindow and visibleMainCards.length &gt; 6" class="fa fa-ellipsis-h ps-1 pe-1"/>
                    <CallParticipantCard t-if="!env.inChatWindow" t-foreach="visibleMainCards.slice(6)" t-as="cardData" t-key="cardData.key" cardData="cardData" className="'o-discuss-Call-mainCardStyle p-1'" minimized="minimized" thread="props.thread"/>
                </div>


                <t t-if="hasSidebarButton">
                    <i t-if="state.sidebar" class="o-discuss-Call-sidebarToggler p-2 fs-5 cursor-pointer position-absolute oi oi-arrow-right" title="Hide sidebar" t-on-click="() =&gt; this.state.sidebar = false"/>
                    <i t-else="" class="o-discuss-Call-sidebarToggler p-2 fs-5 cursor-pointer position-absolute oi oi-arrow-left" title="Show sidebar" t-on-click="() =&gt; this.state.sidebar = true"/>
                </t>
                <div t-if="state.overlay or !isControllerFloating" class="o-discuss-Call-overlay d-flex justify-content-center w-100 pb-1" t-att-class="{ 'o-isFloating position-absolute bottom-0 pb-3': isControllerFloating }">
                    <div t-on-mousemove="onMousemoveOverlay">
                        <CallActionList thread="props.thread" compact="props.compact" fullscreen="{ isActive: state.isFullscreen, enter: () =&gt; this.enterFullScreen(), exit: () =&gt; this.exitFullScreen() }"/>
                    </div>
                </div>
                <div t-if="hasCallNotifications" class="position-absolute d-flex flex-column-reverse start-0 bottom-0" t-att-class="{ 'ps-5 pb-5': state.isFullscreen, 'ps-2 pb-2': !state.isFullscreen }">
                    <span class="text-bg-800 shadow-lg rounded-1 m-1" t-att-class="{ 'p-4 fs-4': state.isFullscreen, 'p-2': !state.isFullscreen }" t-foreach="rtc.notifications.values()" t-as="notification" t-key="notification.id" t-esc="notification.text"/>
                </div>
            </div>
            <div t-if="state.sidebar and props.thread.activeRtcSession" class="o-discuss-Call-sidebar d-flex align-items-center h-100 flex-column">
                <CallParticipantCard t-foreach="visibleCards" t-as="cardData" t-key="cardData.key" cardData="cardData" className="'o-discuss-Call-sidebarCard w-100 p-1'" thread="props.thread"/>
            </div>
            <CallParticipantCard t-if="props.thread.videoCount &gt; 0 and state.insetCard" cardData="state.insetCard" className="'o-discuss-Call-mainCardStyle o-bg-black'" thread="props.thread" inset.bind="setInset"/>
        </div>
    </t>

`);
registerTemplate("discuss.CallActionList", `/mail/static/src/discuss/call/common/call_action_list.xml`, `<t t-name="discuss.CallActionList" xml:space="preserve">
        <div class="o-discuss-CallActionList d-flex flex-column justify-content-center" t-attf-class="{{ className }}" t-ref="root">
            <div class="o-discuss-CallActionList-bar d-flex align-items-center flex-wrap justify-content-between" t-att-class="{ 'w-100 ps-2 pe-2': isSmall }">
                <t t-if="isOfActiveCall and rtc.selfSession">
                    <t t-foreach="callActions.actions.slice(0, isMobileOS ? 3 : 4)" t-as="action" t-key="action_index">
                        <t t-call="discuss.CallActionList.actionButton"/>
                    </t>
                    <Dropdown position="'top-end'" menuClass="'d-flex flex-column py-0'">
                        <button t-att-class="\`btn smaller d-flex m-1 border-0 rounded-circle shadow-none opacity-100 opacity-75-hover align-items-center \${ isSmall ? 'p-0' : 'p-1' }\`" t-att-title="MORE">
                            <i class="fa fa-ellipsis-v m-2 fa-fw" t-att-class="{ 'fa-lg': !isSmall }"/>
                        </button>
                        <t t-set-slot="content">
                            <DropdownItem t-foreach="callActions.actions.slice(isMobileOS ? 3 : 4)" t-as="action" t-key="action_index" class="'btn rounded-0 d-flex align-items-center px-2 py-2 m-0 opacity-75 opacity-100-hover'" attrs="{ title: action.name }" onSelected="action.select">
                                <i class="fa fa-fw" t-att-class="{                                     [action.inactiveIcon]: !action.isActive,                                     [action.icon]: action.isActive or !action.inactiveIcon,                                 }"/>
                                <span class="mx-2" t-out="action.name"/>
                            </DropdownItem>
                        </t>
                    </Dropdown>
                </t>
                <button t-if="props.thread.rtcInvitingSession and !isOfActiveCall" class="btn smaller btn-danger d-flex m-1 border-0 rounded-circle shadow-none align-items-center" t-att-class="{ 'p-0': isSmall, 'p-1': !isSmall }" aria-label="Reject" title="Reject" t-att-disabled="rtc.state.hasPendingRequest" t-on-click="onClickRejectCall">
                    <i class="oi oi-close fa-fw m-2" t-att-class="{ 'fa-lg': !isSmall }"/>
                </button>
                <button t-if="props.thread.rtcInvitingSession?.isCameraOn" class="btn smaller btn-success d-flex m-1 border-0 rounded-circle shadow-none align-items-center" t-att-class="{ 'p-0': isSmall, 'p-1': !isSmall }" aria-label="Accept with camera" title="Accept with camera" t-att-disabled="rtc.state.hasPendingRequest" t-on-click="(ev) =&gt; this.onClickToggleAudioCall(ev, { camera: true })">
                    <i class="fa fa-video-camera fa-fw m-2" t-att-class="{ 'fa-lg': !isSmall }"/>
                </button>
                <t t-if="props.thread.eq(rtc.state.channel)" t-set="callText">Disconnect</t>
                <t t-else="" t-set="callText">Join Call</t>
                <button class="btn smaller d-flex m-1 border-0 rounded-circle shadow-none align-items-center" t-att-aria-label="callText" t-att-class="{ 'btn-danger': isOfActiveCall, 'p-0': isSmall, 'p-1': !isSmall, 'btn-success': !isOfActiveCall }" t-att-disabled="rtc.state.hasPendingRequest" t-att-title="callText" t-on-click="onClickToggleAudioCall">
                    <i class="fa fa-phone fa-fw m-2" t-att-class="{ 'fa-lg': !isSmall }"/>
                </button>
            </div>
            <div t-if="isMobileOS and store.settings.use_push_to_talk and isOfActiveCall" class="d-flex align-items-center flex-wrap justify-content-between p-2">
                <button class="o-discuss-CallActionList-pushToTalk btn btn-primary d-flex w-100 border-0 shadow-none" aria-label="Push to talk" t-on-touchstart.stop="rtc.onPushToTalk" t-on-touchend.stop="rtc.setPttReleaseTimeout">
                    <span class="w-100 fs-4 text-center">Push to talk</span>
                </button>
            </div>
        </div>
    </t>

    `);
registerTemplate("discuss.CallActionList.actionButton", `/mail/static/src/discuss/call/common/call_action_list.xml`, `<t t-name="discuss.CallActionList.actionButton" xml:space="preserve">
        <button class="btn smaller d-flex m-1 border-0 rounded-circle shadow-none opacity-100 opacity-75-hover align-items-center" t-att-class="{ 'p-0': isSmall, 'p-1': !isSmall }" t-att-aria-label="action.name" t-att-title="action.name" t-on-click="action.select">
            <i class="fa fa-fw m-2 fa-fw" t-att-class="{                 'fa-lg': !isSmall,                 [action.inactiveIcon]: !action.isActive,                 [action.icon]: action.isActive or !action.inactiveIcon,                 [action.activeClass]: action.isActive,             }"/>
        </button>
    </t>

`);
registerTemplate("discuss.CallContextMenu", `/mail/static/src/discuss/call/common/call_context_menu.xml`, `<t t-name="discuss.CallContextMenu" xml:space="preserve">
        <div class="o-discuss-CallContextMenu d-flex flex-column p-3">
            <div class="text-center pb-2 fw-bolder" t-out="props.rtcSession.name"/>
            <input t-if="!isSelf" type="range" min="0.0" max="1" step="0.01" t-att-value="volume" t-on-change="onChangeVolume" class="form-range"/>
            <t t-if="env.debug and !isSelf and rtc.state.connectionType === rtcConnectionTypes.P2P">
                <hr class="w-100 border-top"/>
                <div><span class="fw-bolder">RTC Session ID: </span><t t-out="props.rtcSession.id"/></div>
                <div><span class="fw-bolder">Connection type: </span><t t-out="rtc.state.connectionType"/></div>
                <div><span class="fw-bolder">To peer: </span><t t-out="outboundConnectionTypeText"/></div>
                <div><span class="fw-bolder">From peer: </span><t t-out="inboundConnectionTypeText"/></div>
                <div><span class="fw-bolder">Connection: </span><t t-out="state.peerStats.connectionState"/></div>
                <div><span class="fw-bolder">ICE connection: </span><t t-out="state.peerStats.iceConnectionState"/></div>
                <div><span class="fw-bolder">ICE: </span><t t-out="state.peerStats.iceState"/></div>
                <div><span class="fw-bolder">DTLS: </span><t t-out="state.peerStats.dtlsState"/></div>
                <div><span class="fw-bolder">Data channel: </span><t t-out="state.peerStats.dataChannelState"/></div>
                <div t-if="props.rtcSession.audioError"><span class="fw-bolder">Audio player: </span><t t-out="props.rtcSession.audioError"/></div>
                <div t-if="props.rtcSession.videoError"><span class="fw-bolder">Video player: </span><t t-out="props.rtcSession.videoError"/></div>
                <hr class="w-100 border-top"/>
                <div><span class="fw-bolder">ICE gathering: </span><t t-out="state.peerStats.iceGatheringState"/></div>
                <div><span class="fw-bolder">Packets sent: </span><t t-out="state.peerStats.packetsSent"/></div>
                <div><span class="fw-bolder">Packets received: </span><t t-out="state.peerStats.packetsReceived"/></div>
                <div><span class="fw-bolder">Log step: </span><t t-out="state.peerStats.logStep"/></div>
            </t>
            <t t-elif="env.debug and isSelf and rtc.state.connectionType === rtcConnectionTypes.SERVER">
                <div><span class="fw-bolder">Connection type: </span><t t-out="rtc.state.connectionType"/></div>
                <div><span class="fw-bolder">RTC Session ID: </span><t t-out="props.rtcSession.id"/></div>
                <hr class="w-100 border-top"/>
                <div><span class="fw-bolder">Upload: </span><t t-out="outboundConnectionTypeText"/></div>
                <div><span class="fw-bolder">up ICE: </span><t t-out="state.uploadStats.iceState"/></div>
                <div><span class="fw-bolder">up DTLS: </span><t t-out="state.uploadStats.dtlsState"/></div>
                <div><span class="fw-bolder">Packets sent: </span><t t-out="state.uploadStats.packetsSent"/></div>
                <div><span class="fw-bolder">available bitrate: </span><t t-out="state.uploadStats.availableOutgoingBitrate"/></div>
                <hr class="w-100 border-top"/>
                <div><span class="fw-bolder">Download: </span><t t-out="inboundConnectionTypeText"/></div>
                <div><span class="fw-bolder">down ICE: </span><t t-out="state.downloadStats.iceState"/></div>
                <div><span class="fw-bolder">down DTLS: </span><t t-out="state.downloadStats.dtlsState"/></div>
                <div><span class="fw-bolder">Packets received: </span><t t-out="state.downloadStats.packetsReceived"/></div>
                <t t-if="state.producerStats.audio">
                    <hr class="w-100 border-top"/>
                    <div><span class="fw-bolder">microphone</span></div>
                    <div><span class="fw-bolder">codec: </span><t t-out="state.producerStats.audio.codec"/></div>
                    <div><span class="fw-bolder">clock rate: </span><t t-out="state.producerStats.audio.clockRate"/></div>
                </t>
                <t t-if="state.producerStats.camera and props.rtcSession.isCameraOn">
                    <hr class="w-100 border-top"/>
                    <div><span class="fw-bolder">camera</span></div>
                    <div><span class="fw-bolder">codec: </span><t t-out="state.producerStats.camera.codec"/></div>
                    <div><span class="fw-bolder">clock rate: </span><t t-out="state.producerStats.camera.clockRate"/></div>
                </t>
                <t t-if="state.producerStats.screen and props.rtcSession.isScreenSharingOn">
                    <hr class="w-100 border-top"/>
                    <div><span class="fw-bolder">screen</span></div>
                    <div><span class="fw-bolder">codec: </span><t t-out="state.producerStats.screen.codec"/></div>
                    <div><span class="fw-bolder">clock rate: </span><t t-out="state.producerStats.screen.clockRate"/></div>
                </t>
            </t>
        </div>
    </t>
`);
registerTemplate("discuss.CallInvitation", `/mail/static/src/discuss/call/common/call_invitation.xml`, `<t t-name="discuss.CallInvitation" xml:space="preserve">
        <div class="o-discuss-CallInvitation d-flex flex-column m-2 rounded-3 border align-items-center position-relative" t-attf-class="{{ className }}" t-ref="root" t-att-class="{             'o-cameraPreview': state.videoStream,         }">
            <div class="position-relative d-flex justify-content-center position-absolute h-100 w-100 rounded-3">
                <video class="shadow rounded bg-dark h-100 w-100 o_object_fit_cover rounded-3" autoplay="" t-ref="video"/>
            </div>
            <div t-if="props.thread.rtcInvitingSession" class="o-discuss-CallInvitation-correspondent d-flex justify-content-around align-items-center text-nowrap px-3 mb-2 z-1" t-att-class="{                 'align-self-start mt-3': state.videoStream,                 'flex-column mt-4': !state.videoStream,             }">
                <img class="o-discuss-CallInvitation-avatar mb-2 rounded-circle cursor-pointer o_object_fit_cover" t-att-src="props.thread.rtcInvitingSession.channelMember.persona.avatarUrl" t-on-click="onClickAvatar" alt="Avatar"/>
                <div class="d-flex pb-2 flex-column" t-att-class="{                     'justify-content-start ps-2': state.videoStream,                     'justify-content-center': !state.videoStream,                 }">
                    <span class="w-100 fw-bolder text-truncate overflow-hidden" t-att-class="{ 'text-center': !state.videoStream }" t-esc="props.thread.rtcInvitingSession.channelMember.persona.name"/>
                    <span class="opacity-75 smaller">
                        <t t-if="props.thread.rtcInvitingSession.isCameraOn">Incoming Video Call...</t>
                        <t t-else="">Incoming Call...</t>
                    </span>
                </div>
            </div>
            <div class="d-flex justify-content-center align-items-center w-100 px-3 mt-auto gap-2 z-1" t-att-class="{ 'pb-3': state.videoStream }">
                <button class="btn user-select-none p-1 rounded-circle border-0 btn-danger" aria-label="Refuse" title="Refuse" t-on-click="onClickRefuse">
                    <i class="fa-lg fa-fw m-2 oi oi-close"/>
                </button>
                <button t-if="props.thread.rtcInvitingSession.isCameraOn" class="btn user-select-none p-1 rounded-circle border-0 btn-success" aria-label="Accept with camera" title="Accept with camera" t-on-click="(ev) =&gt; this.onClickAccept(ev, { camera: true })">
                    <i class="fa-lg fa-fw m-2 fa fa-video-camera"/>
                </button>
                <button class="btn user-select-none p-1 rounded-circle border-0 btn-success" aria-label="Accept" title="Accept" t-on-click="onClickAccept">
                    <i class="fa-lg fa-fw m-2 fa fa-phone"/>
                </button>
            </div>
            <div t-if="!state.videoStream" class="py-3 z-1">
                <span class="fw-bold smaller px-3 opacity-50 opacity-75-hover cursor-pointer" t-on-click="onClickPreviewCamera">Preview my camera</span>
            </div>
        </div>
    </t>

`);
registerTemplate("discuss.CallInvitations", `/mail/static/src/discuss/call/common/call_invitations.xml`, `<t t-name="discuss.CallInvitations" xml:space="preserve">
        <div t-if="store.ringingThreads.length &gt; 0" class="o-discuss-CallInvitations position-fixed top-0 end-0 d-flex flex-column p-2">
            <t t-foreach="store.ringingThreads" t-as="thread" t-key="thread.localId">
                <CallInvitation thread="thread"/>
            </t>
        </div>
    </t>

`);
registerTemplate("discuss.CallMenu", `/mail/static/src/discuss/call/common/call_menu.xml`, `<t t-name="discuss.CallMenu" xml:space="preserve">
        <div class="dropdown" t-attf-class="{{ className }}" t-ref="root">
            <button t-if="rtc.state.channel" class="user-select-none dropdown-toggle o-no-caret o-dropdown--narrow" t-att-title="buttonTitle" role="button" t-on-click="rtc.state.channel.open">
                <div class="o-discuss-CallMenu-buttonContent d-flex align-items-center o-gap-0_5 rounded-3 opacity-75 opacity-100-hover px-1" t-att-class="{ 'o-isOdooCommunity': !isEnterprise }">
                    <span class="position-relative small bg-inherit">
                        <i class="me-2 fa fa-fw" t-att-class="icon"/>
                        <small class="d-flex position-absolute top-0 end-0 smaller bg-inherit">
                            <i class="o-discuss-CallMenu-animation fa fa-volume-up o-discuss-inCallIconColor bg-inherit" t-att-class="{ 'o-isOdooCommunity': !isEnterprise }"/>
                        </small>
                    </span>
                    <span class="text-truncate fw-bold pe-1" t-esc="rtc.state.channel.displayName"/>
                </div>
            </button>
        </div>
    </t>

`);
registerTemplate("discuss.CallParticipantCard", `/mail/static/src/discuss/call/common/call_participant_card.xml`, `<t t-name="discuss.CallParticipantCard" xml:space="preserve">
        <div class="o-discuss-CallParticipantCard position-relative cursor-pointer d-flex flex-column align-items-center justify-content-center mh-100 mw-100 rounded-1" t-att-class="{                 'o-isTalking': !props.minimized and isTalking,                 'o-isInvitation opacity-50': !rtcSession,                 'o-inset': props.inset,                 'o-small': props.inset and (ui.isSmall or props.minimized)             }" t-att-title="name" t-att-aria-label="name" t-attf-class="{{ props.className }}" t-on-click="onClick" t-on-contextmenu="onContextMenu" t-on-mousedown="onMouseDown" t-on-touchmove="onTouchMove" t-ref="root">

            <CallParticipantVideo t-if="hasVideo" session="rtcSession" type="props.cardData.type" inset="props.inset"/>
            <div t-else="" class="o-discuss-CallParticipantCard-avatar d-flex align-items-center justify-content-center h-100 w-100 rounded-1" t-att-class="{ 'o-minimized': props.minimized }" draggable="false">
                <img alt="Avatar" class="h-100 rounded-circle border-5 o_object_fit_cover" t-att-src="channelMember?.persona.avatarUrl" draggable="false" t-att-class="{                     'o-isTalking': isTalking,                     'o-isInvitation': !rtcSession,                 }"/>
            </div>
            <t t-if="rtcSession">

                <span class="o-discuss-CallParticipantCard-overlay z-1 position-absolute bottom-0 start-0 d-flex overflow-hidden rounded-1">
                    <span t-if="!props.minimized and !props.inset" class="px-1 text-truncate smaller opacity-75 o-discuss-CallParticipantCard-overlayBottomName" t-esc="name"/>
                    <small t-if="rtcSession.isScreenSharingOn and props.minimized and !isOfActiveCall" class="user-select-none o-minimized rounded text-bg-danger d-flex align-items-center fw-bolder p-1" title="live" aria-label="live">
                        LIVE
                    </small>
                </span>
                <div class="o-discuss-CallParticipantCard-overlay position-absolute top-0 end-0 d-flex flex-row-reverse">
                    <span t-if="hasRaisingHand" class="d-flex flex-column justify-content-center me-1 rounded-circle bg-500" t-att-class="{'o-minimized p-1': props.minimized, 'p-2': !props.minimized }" title="raising hand" aria-label="raising hand">
                        <i class="fa fa-hand-paper-o"/>
                    </span>
                    <span t-if="rtcSession.isSelfMuted and !rtcSession.isDeaf" class="d-flex flex-column justify-content-center me-1 rounded-circle o-discuss-CallParticipantCard-iconBlackBg" t-att-class="{'o-minimized p-1': props.minimized, 'p-2': !props.minimized }" title="muted" aria-label="muted">
                        <i class="fa fa-microphone-slash"/>
                    </span>
                    <span t-if="rtcSession.isDeaf" class="d-flex flex-column justify-content-center me-1 rounded-circle o-discuss-CallParticipantCard-iconBlackBg" t-att-class="{'o-minimized p-1': props.minimized, 'p-2': !props.minimized }" title="deaf" aria-label="deaf">
                        <i class="fa fa-deaf"/>
                    </span>
                    <span t-if="hasMediaError" class="o-discuss-CallParticipantCard-overlay-replayButton d-flex flex-column justify-content-center me-1 p-2 rounded-circle" title="media player Error" t-on-click.stop="onClickReplay">
                        <i t-if="rootHover.isHover" class="fa fa-repeat text-danger"/>
                        <i t-else="" class="fa fa-exclamation-triangle text-danger"/>
                    </span>
                    <span t-if="showConnectionState" class="d-flex flex-column justify-content-center me-1 p-2 rounded-circle o-discuss-CallParticipantCard-iconBlackBg" t-att-title="rtcSession.connectionState">
                        <i class="fa fa-exclamation-triangle text-warning"/>
                    </span>
                    <span t-if="rtcSession.isScreenSharingOn and !props.minimized and !isOfActiveCall" class="user-select-none rounded text-bg-danger d-flex align-items-center me-1 fw-bolder p-1" title="live" aria-label="live">
                        LIVE
                    </span>
                </div>


                <i t-if="isContextMenuAvailable" class="position-absolute bottom-0 start-50" t-ref="contextMenuAnchor"/>
            </t>
        </div>
    </t>

`);
registerTemplate("discuss.CallParticipantVideo", `/mail/static/src/discuss/call/common/call_participant_video.xml`, `<t t-name="discuss.CallParticipantVideo" xml:space="preserve">
        <video class="w-100 h-100 rounded-1 cursor-pointer" t-att-class="{ 'o-inset': props.inset }" t-att-type="props.type" playsinline="true" autoplay="true" muted="true" t-on-loadedmetadata="onVideoLoadedMetaData" t-ref="root"/>
    </t>
`);
registerTemplate("discuss.CallSettings", `/mail/static/src/discuss/call/common/call_settings.xml`, `<t t-name="discuss.CallSettings" xml:space="preserve">
        <ActionPanel t-if="props.withActionPanel" title.translate="Voice settings" icon="'fa fa-gear'">
            <t t-call="discuss.CallSettings.content"/>
        </ActionPanel>
        <t t-else="" t-call="discuss.CallSettings.content"/>
    </t>

    `);
registerTemplate("discuss.CallSettings.content", `/mail/static/src/discuss/call/common/call_settings.xml`, `<t t-name="discuss.CallSettings.content" xml:space="preserve">
        <div class="o-discuss-CallSettings d-flex flex-column">
            <label class="d-flex align-items-baseline mb-2" title="Input device" aria-label="Input device">
                <h5 class="flex-shrink-0 pe-2">
                    Input device
                </h5>
                <div class="flex-grow-1"/>
                <select name="inputDevice" class="form-select d-flex w-auto" t-on-change="onChangeSelectAudioInput">
                    <option value="">Browser default</option>
                    <t t-foreach="state.userDevices" t-as="device" t-key="device_index" device="device">
                        <option t-if="device.kind === 'audioinput'" t-att-selected="store.settings.audioInputDeviceId === device.deviceId" t-att-value="device.deviceId">
                            <t t-esc="device.label || 'audio device ' + device_index"/>
                        </option>
                    </t>
                </select>
            </label>
            <div class="d-flex flex-column">
                <button class="btn d-flex my-1" t-att-class="{'bg-300' : !store.settings.use_push_to_talk }" t-on-click="()=&gt;this.store.settings.setPushToTalk(false)">
                    <input class="form-check-input" type="radio" t-att-checked="store.settings.use_push_to_talk ? '' : 'checked'"/>
                    <span class="text-start flex-grow-1 mx-3">Voice Detection</span>
                </button>
                <button class="btn d-flex my-1" t-att-class="{'bg-300' : store.settings.use_push_to_talk }" t-on-click="()=&gt;this.store.settings.setPushToTalk(true)">
                    <input class="form-check-input" type="radio" t-att-checked="store.settings.use_push_to_talk ? 'checked' : ''"/>
                    <span class="text-start flex-grow-1 mx-3">Push to Talk</span>
                </button>
                <span t-if="store.settings.use_push_to_talk and !isMobileOS and !pttExtService.isEnabled" class="small text-muted fst-italic mb-3" t-out="pttExtService.downloadText"/>
            </div>
            <div class="d-flex flex-column">
                <label t-if="!store.settings.use_push_to_talk" class="d-flex flex-column flex-wrap flex-grow-1 align-items-start" title="Voice detection threshold" aria-label="Voice detection threshold">
                    <span class="me-2 my-1 text-truncate text-wrap">Voice detection threshold</span>
                    <div class="d-flex w-100 align-items-center">
                        <input class="flex-grow-1 form-range" type="range" min="0.001" max="1" step="0.001" t-att-value="store.settings.voiceActivationThreshold" t-on-change="onChangeThreshold"/>
                        <span class="p-1 text-end"><t t-out="Math.floor(store.settings.voiceActivationThreshold * 100)"/>%</span>
                    </div>
                </label>
                <div t-if="store.settings.use_push_to_talk" class="d-flex" t-att-class="{'flex-column': props.isCompact}">
                    <div t-if="!isMobileOS" class="d-flex flex-column align-items-center" t-att-class="{'me-1 w-50': !props.isCompact}">
                        <label class="d-flex flex-column align-items-start flex-wrap w-100" title="Push-to-talk key" aria-label="Push-to-talk key">
                            <span class="me-2 my-1 text-truncate text-wrap">Push-to-talk key</span>
                            <span class="d-flex border border-2 rounded w-100" t-attf-class="{{ store.settings.isRegisteringKey ? 'border-danger' : 'border-primary' }}">
                                <span t-if="store.settings.push_to_talk_key" class="ms-1 px-3 fs-3 flex-grow-1" t-esc="pushToTalkKeyText"/>
                                <button class="btn btn-link px-2 py-0 text-black" t-on-click="onClickRegisterKeyButton">
                                    <i t-if="store.settings.isRegisteringKey" title="Cancel" aria-label="Cancel" class="fa fa-2x fa-times-circle"/>
                                    <i t-else="" title="Register new key" aria-label="Register new key" class="fa fa-2x fa-keyboard-o"/>
                                </button>
                            </span>
                        </label>
                    </div>
                    <div class="d-flex align-items-center" t-att-class="{'ms-1 w-50': !props.isCompact}">
                        <label class="d-flex flex-column align-items-start flex-wrap h-100 w-100" title="Delay after releasing push-to-talk" aria-label="Delay after releasing push-to-talk">
                            <span class="me-2 my-1 text-truncate text-wrap">Delay after releasing push-to-talk</span>
                            <div class="d-flex w-100 align-items-center">
                                <input class="flex-grow-1 form-range" type="range" min="0" max="2000" step="1" t-att-value="store.settings.voice_active_duration" t-on-input="onChangeDelay"/>
                                <span class="p-1 text-end"><t t-out="store.settings.voice_active_duration"/>ms</span>
                            </div>
                        </label>
                    </div>
                </div>
                <span t-if="store.settings.isRegisteringKey">Press a key to register it as the push-to-talk shortcut.</span>
            </div>
            <hr class="o-discuss-separator my-2"/>
            <h4>Video Settings</h4>
            <div class="d-flex flex-column my-1">
                <t t-call="discuss.CallSettings.textToggler">
                    <t t-set="text">Show video participants only</t>
                    <t t-set="value" t-value="store.settings.showOnlyVideo"/>
                    <t t-set="onchange" t-value="onChangeShowOnlyVideo"/>
                </t>
            </div>
            <div t-if="store.settings.hasCanvasFilterSupport" class="d-flex flex-column my-1">
                <t t-call="discuss.CallSettings.textToggler">
                    <t t-set="text">Blur video background</t>
                    <t t-set="value" t-value="store.settings.useBlur"/>
                    <t t-set="onchange" t-value="onChangeBlur"/>
                </t>
            </div>
            <t t-if="store.settings.useBlur">
                <div class="d-flex mt-1" t-att-class="{'flex-column': props.isCompact}">
                    <div class="d-flex flex-column align-items-center" t-att-class="{'me-1 w-50': !props.isCompact}">
                        <label class="d-flex flex-column align-items-start flex-wrap w-100" title="Background blur intensity" aria-label="Background blur intensity">
                            <span class="me-2 text-truncate text-wrap">Background blur intensity</span>
                            <div class="d-flex w-100 flex-grow-1 align-items-center">
                                <input class="flex-grow-2 form-range" type="range" min="0" max="20" step="1" t-att-value="store.settings.backgroundBlurAmount" t-on-change="onChangeBackgroundBlurAmount"/>
                                <span class="p-1 text-end o-discuss-DiscussCallSettings-width-text-percentage"><t t-out="Math.floor(store.settings.backgroundBlurAmount * 5)"/>%</span>
                            </div>
                        </label>
                    </div>
                    <div class="d-flex align-items-center" t-att-class="{'ms-1 w-50': !props.isCompact}">
                        <label class="d-flex flex-column align-items-start flex-wrap h-100 w-100" title="Edge blur intensity" aria-label="Edge blur intensity">
                            <span class="me-2 text-truncate text-wrap">Edge blur intensity</span>
                            <div class="d-flex w-100 flex-grow-1 align-items-center">
                                <input class="flex-grow-2 form-range" type="range" min="0" max="20" step="1" t-att-value="store.settings.edgeBlurAmount" t-on-change="onChangeEdgeBlurAmount"/>
                                <span class="p-1 text-end o-discuss-DiscussCallSettings-width-text-percentage"><t t-out="Math.floor(store.settings.edgeBlurAmount * 5)"/>%</span>
                            </div>
                        </label>
                    </div>
                </div>
            </t>
            <hr class="o-discuss-separator my-2"/>
            <h4>Technical Settings</h4>
            <t t-if="env.debug">
                <div class="d-flex flex-column my-1">
                    <t t-call="discuss.CallSettings.textToggler">
                        <t t-set="text">Log RTC events</t>
                        <t t-set="value" t-value="store.settings.logRtc"/>
                        <t t-set="onchange" t-value="onChangeLogRtc"/>
                    </t>
                </div>
            </t>
            <button class="btn btn-secondary mt-1 mb-2 w-100" t-on-click="onClickDownloadLogs">Download logs</button>
        </div>
    </t>
    `);
registerTemplate("discuss.CallSettings.textToggler", `/mail/static/src/discuss/call/common/call_settings.xml`, `<t t-name="discuss.CallSettings.textToggler" xml:space="preserve">
        <div class="d-flex flex-wrap align-items-center">
            <label class="d-flex align-items-center flex-wrap mw-100" t-att-title="text" t-att-aria-label="text">
                <span class="text-truncate text-wrap" t-out="text"/>
            </label>
            <div class="flex-grow-1"/>
            <div class="form-check form-switch">
                <input class="form-check-input" type="checkbox" role="switch" t-on-change="onchange" t-att-checked="value ? 'checked' : ''" t-att-title="text" t-att-aria-label="text"/>
            </div>
        </div>
    </t>

`);
registerTemplateExtension("mail.ChatWindow", `/mail/static/src/discuss/call/common/chat_window_patch.xml`, `<t t-inherit="mail.ChatWindow" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//Thread" position="before">
            <Call t-if="thread.rtcSessions.length &gt; 0" thread="thread" compact="true"/>
        </xpath>
    </t>
`);
registerTemplate("mail.DiscussCallSettingsClientAction", `/mail/static/src/discuss/call/common/discuss_call_settings_client_action.xml`, `<t t-name="mail.DiscussCallSettingsClientAction" xml:space="preserve">
        <div class="o-mail-DiscussCallSettingsClientAction mx-3 my-2">
            <CallSettings withActionPanel="false"/>
        </div>
    </t>
`);
registerTemplate("discuss.pttAdBanner", `/mail/static/src/discuss/call/common/ptt_ad_banner.xml`, `<t t-name="discuss.pttAdBanner" xml:space="preserve">
    <span t-if="isVisible" class="o-discuss-PttAdBanner alert alert-info px-2 py-1 m-0 rounded-0">
        <div class="d-flex justify-content-between align-items-center">
            <span class="small" t-out="pttExtService.downloadText"/>
            <button class="btn d-flex opacity-75 opacity-100-hover" title="Close banner" t-on-click="onClickClose">
                <i class="fa fa-fw fa-close"/>
            </button>
        </div>
    </span>
</t>

`);
registerTemplateExtension("mail.Composer.emojiPicker", `/mail/static/src/discuss/gif_picker/common/composer_patch.xml`, `<t t-inherit="mail.Composer.emojiPicker" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@t-ref='emoji-button']" position="attributes">
            <attribute name="t-att-class">
                {'opacity-100': this.picker.state.picker === this.picker.PICKERS.EMOJI or (this.picker.state.picker === this.picker.PICKERS.GIF and this.ui.isSmall)}
            </attribute>
        </xpath>
        <xpath expr="//*[@t-ref='emoji-button']" position="after">
            <button t-if="hasGifPickerButton" class="btn border-0 rounded-circle p-0" t-att-class="{'opacity-100': this.picker.state.picker === this.picker.PICKERS.GIF}" aria-label="GIFs" t-on-click="onClickAddGif" t-ref="gif-button"><i class="oi oi-fw fa-lg oi-gif-picker"/></button>
        </xpath>
    </t>
`);
registerTemplate("discuss.GifPicker", `/mail/static/src/discuss/gif_picker/common/gif_picker.xml`, `<t t-name="discuss.GifPicker" xml:space="preserve">
        <div class="o-discuss-GifPicker bg-view d-flex flex-column" t-attf-class="{{ props.className }}">
            <div class="o-EmojiPicker-search d-flex align-items-center m-2 rounded">
                <i t-if="!state.showCategories" aria-label="back" t-on-click="openCategories" class="oi oi-arrow-left cursor-pointer p-2 fs-5"/>
                <span class="d-flex mx-1 w-100 rounded o-active">
                    <t t-call="discuss.GifPicker.searchInput">
                        <t t-if="props.state" t-set="localState" t-value="props.state"/>
                        <t t-else="" t-set="localState" t-value="state"/>
                    </t>
                    <i class="oi oi-search p-2 fs-5 rounded-start-0 rounded-3 o-active" title="Search..." role="img" aria-label="Search..."/>
                </span>
            </div>
            <div class="o-discuss-GifPicker-content overflow-y-auto overflow-x-hidden ps-2 pe-3 pb-2 h-100" t-ref="scroller">
                <div t-if="state.loadingError" class="text-center">
                    <span class="o-discuss-GifPicker-error d-block">😵‍💫</span>
                    <span class="fs-5 text-muted d-block">Failed to load gifs...</span>
                </div>
                <div t-if="state.showCategories and !state.loadingError" class="row row-cols-2 gy-2 gx-2" aria-label="list">
                    <div t-if="store.self.type === 'partner'" class="col">
                        <div class="position-relative ratio ratio-16x9 cursor-pointer rounded overflow-hidden" t-on-click="onClickFavoritesCategory" aria-label="list-item">
                            <img t-if="state.favorites.gifs.length &gt; 0" class="o-discuss-GifPicker-category" t-att-src="state.favorites.gifs[0].media_formats.tinygif.url" loading="lazy" alt="GIF Favorites"/>
                            <div class="position-absolute w-100 h-100 top-0 start-0 text-center o-text-white align-middle fs-2 o-bg-black bg-opacity-50">
                                Favorites
                            </div>
                        </div>
                    </div>
                    <t t-if="state.categories.length === 0">
                        <t t-foreach="Array(10).keys()" t-as="category" t-key="category_index">
                            <div class="col">
                                <div class="position-relative ratio ratio-16x9 cursor-pointer rounded overflow-hidden" aria-label="list-item">
                                    <div class="position-absolute w-100 h-100 top-0 start-0 text-center o-text-white align-middle fs-2 o-bg-black bg-opacity-50"/>
                                </div>
                            </div>
                        </t>
                    </t>
                    <t t-else="">
                        <t t-foreach="state.categories" t-as="category" t-key="category_index">
                            <div class="col">
                                <div class="position-relative ratio ratio-16x9 cursor-pointer rounded overflow-hidden" t-on-click="() =&gt; this.onClickCategory(category)" aria-label="list-item">
                                    <img class="o-discuss-GifPickerCategory-img img-fluid" t-att-src="category.image" loading="lazy" alt="GIF Category"/>
                                    <div class="position-absolute w-100 h-100 top-0 start-0 text-center o-text-white align-middle fs-2 o-bg-black bg-opacity-50">
                                        <t t-out="category.name"/>
                                    </div>
                                </div>
                            </div>
                        </t>
                    </t>
                </div>
                <t t-if="!state.showCategories">
                    <div class="d-flex gap-1">
                        <div>
                            <t t-foreach="state.evenGif.gifs" t-as="gif" t-key="gif_index">
                                <t t-call="discuss.Gif"/>
                            </t>
                        </div>
                        <div>
                            <t t-foreach="state.oddGif.gifs" t-as="gif" t-key="gif_index">
                                <t t-call="discuss.Gif"/>
                            </t>
                        </div>
                    </div>
                    <div t-if="state.loadingGif" class="text-center fs-6 h-100 d-flex flex-column justify-content-center">
                        <i class="fa fa-spin fa-circle-o-notch"/>
                    </div>
                    <div t-elif="showFavorite and state.evenGif.gifs.length === 0 and state.oddGif.gifs.length === 0" class="d-flex flex-column h-100 align-items-center justify-content-center text-center text-muted gap-2">
                        <i class="o-discuss-GifPicker-noFavoritesIcon fa fa-star fs-1"/>
                        <span class="fs-5">So uhh... maybe go favorite some GIFs?</span>
                    </div>
                </t>
            </div>
        </div>
    </t>

    `);
registerTemplate("discuss.Gif", `/mail/static/src/discuss/gif_picker/common/gif_picker.xml`, `<t t-name="discuss.Gif" xml:space="preserve">
        <div class="o-discuss-Gif position-relative mt-1 fs-5 cursor-pointer rounded overflow-hidden">
            <i t-if="store.self.type === 'partner'" class="position-absolute top-0 end-0 me-3 mt-3 p-2 o-bg-black bg-opacity-75 fa cursor-pointer opacity-0" t-att-class="{ 'o-text-white fa-star-o': !isFavorite(gif_value), 'fa-star o-starred': isFavorite(gif_value) }" t-on-click="() =&gt; this.onClickFavorite(gif_value)"/>
            <img class="img-fluid" t-att-src="gif_value.media_formats.tinygif.url" t-on-click="() =&gt; this.onClickGif(gif_value)" loading="lazy" alt="GIF" t-att-style="style"/>
        </div>
    </t>

    `);
registerTemplate("discuss.GifPicker.searchInput", `/mail/static/src/discuss/gif_picker/common/gif_picker.xml`, `<t t-name="discuss.GifPicker.searchInput" xml:space="preserve">
        <input class="form-control border-0 flex-grow-1 rounded-3 rounded-end-0 o-active" placeholder="Search for a GIF" t-model="localState.searchTerm" t-ref="autofocus"/>
    </t>
`);
registerTemplateExtension("mail.PickerContent", `/mail/static/src/discuss/gif_picker/common/picker_content_patch.xml`, `<t t-inherit="mail.PickerContent" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('o-mail-PickerContent-picker')]" position="before">
            <div t-if="Object.keys(props.pickers).length &gt; 1" class="o-mail-PickerContent-tab d-flex m-1">
                <nav class="btn-group w-100">
                    <button t-if="props.pickers.emoji" class="btn btn-secondary" t-on-click="() =&gt; this.props.state.picker = this.props.PICKERS.EMOJI" t-att-class="{ 'active': props.state.picker === this.props.PICKERS.EMOJI }">
                        Emoji
                    </button>
                    <button t-if="props.pickers.gif" class="btn btn-secondary" t-on-click="() =&gt; this.props.state.picker = this.props.PICKERS.GIF" t-att-class="{ 'active': props.state.picker === this.props.PICKERS.GIF }">
                        GIFs
                    </button>
                </nav>
            </div>
        </xpath>
        <xpath expr="//div[hasclass('o-mail-PickerContent-emojiPicker')]" position="after">
            <div t-if="props.state.picker === this.props.PICKERS.GIF" class="d-flex align-items-center w-100">
                <GifPicker t-if="store.hasGifPickerFeature" PICKERS="props.PICKERS" onSelect="props.pickers.gif" close="props.close" state="props.state"/>
                <div t-elif="store.self.isAdmin" class="d-flex flex-column align-items-center justify-content-center m-3">
                    <span class="o-mail-PickerContent-bigEmoji">🧑‍🍳🌶️</span>
                    <span class="fs-5 text-muted">Want to spice up your conversations with GIFs? Activate the feature in the settings!</span>
                </div>
            </div>
        </xpath>
    </t>
`);
registerTemplate("discuss.PinnedMessagesPanel", `/mail/static/src/discuss/message_pin/common/pinned_messages_panel.xml`, `<t t-name="discuss.PinnedMessagesPanel" xml:space="preserve">
        <ActionPanel title.translate="Pinned Messages" minWidth="200" initialWidth="400" icon="'fa fa-thumb-tack'">
            <MessageCardList emptyText="emptyText" messages="props.thread.pinnedMessages" thread="props.thread" mode="'pin'"/>
        </ActionPanel>
    </t>
`);
registerTemplateExtension("mail.Composer", `/mail/static/src/discuss/typing/common/composer_patch.xml`, `<t t-inherit="mail.Composer" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//AttachmentList" position="after">
            <div t-if="thread?.model === 'discuss.channel' and !compact" class="o-discuss-Typing d-flex">
                <Typing channel="thread" size="'medium'"/>
            </div>
        </xpath>
        <xpath expr="//*[hasclass('o-mail-Composer-input')]" position="attributes">
            <attribute name="t-on-input">detectTyping</attribute>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.ThreadIcon", `/mail/static/src/discuss/typing/common/thread_icon_patch.xml`, `<t t-inherit="mail.ThreadIcon" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//t[@name='chat']" position="replace">
            <Typing t-if="props.thread.hasOtherMembersTyping" channel="props.thread" size="props.size" displayText="false"/>
            <t t-else="">$0</t>
        </xpath>
    </t>
`);
registerTemplate("discuss.Typing", `/mail/static/src/discuss/typing/common/typing.xml`, `<t t-name="discuss.Typing" xml:space="preserve">
        <t t-if="props.member ? props.member.isTyping : props.channel.hasOtherMembersTyping">
            <div class="o-discuss-Typing-icon d-flex align-items-center" t-attf-class="{{ className }}" t-att-title="text">
                <span class="o-discuss-Typing-dot d-flex flex-shrink-0 rounded-pill bg-500" t-att-class="{                              'o-sizeMedium': props.size === 'medium',                              'o-sizeSmall': props.size === 'small',                              }"/>
                <span class="flex-grow-1 flex-shrink-0"/>
                <span class="o-discuss-Typing-dot o-discuss-Typing-dot2 d-flex flex-shrink-0 rounded-pill bg-500" t-att-class="{                              'o-sizeMedium': props.size === 'medium',                              'o-sizeSmall': props.size === 'small',                              }"/>
                <span class="flex-grow-1 flex-shrink-0"/>
                <span class="o-discuss-Typing-dot o-discuss-Typing-dot3 d-flex flex-shrink-0 rounded-pill bg-500" t-att-class="{                              'o-sizeMedium': props.size === 'medium',                              'o-sizeSmall': props.size === 'small',                              }"/>
            </div>
            <t t-if="props.displayText">
                <span class="ms-1"/>
                <span class="text-truncate smaller" t-out="text"/>
            </t>
        </t>
    </t>

`);
registerTemplateExtension("mail.AttachmentList", `/mail/static/src/discuss/voice_message/common/attachment_list_patch.xml`, `<t t-inherit="mail.AttachmentList" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@t-ref='nonImageMain']" position="replace">
            <t t-if="attachment.voice" class="o-mail-AttachmentCard d-flex rounded mb-1 me-1 mw-100 bg-100">
                <VoicePlayer attachment="attachment"/>
            </t>
            <t t-else="">$0</t>
        </xpath>
        <xpath expr="//div[hasclass('o-mail-AttachmentCard')]" position="attributes">
            <attribute name="t-attf-class" remove="bg-300" add="{{ attachment.voice ? 'bg-100' : 'bg-300'}}"/>
            <attribute name="t-on-click">() =&gt; !attachment.voice ? this.fileViewer.open(attachment, props.attachments) : ""</attribute>
        </xpath>
        <xpath expr="//button[hasclass('o-mail-AttachmentCard-unlink')]" position="attributes">
            <attribute name="t-attf-class">{{ env.inComposer ? 'o-inComposer position-absolute btn-primary transition-base' : (attachment.voice ? 'bg-100' : 'bg-300') }}</attribute>
        </xpath>
        <xpath expr="//button[@title='Download']" position="attributes">
            <attribute name="t-attf-class" remove="bg-300" add="{{ attachment.voice ? 'bg-100' : 'bg-300'}}"/>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.Composer.sendButton", `/mail/static/src/discuss/voice_message/common/composer_patch.xml`, `<t t-inherit="mail.Composer.sendButton" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//button[hasclass('o-mail-Composer-send')]" position="replace">
            <VoiceRecorder t-if="thread?.model === 'discuss.channel' and allowUpload" composer="props.composer" attachmentUploader="attachmentUploader" onchangeRecording.bind="() =&gt; this.state.recording = !this.state.recording"/>
            <t>$0</t>
        </xpath>
    </t>
`);
registerTemplate("mail.VoicePlayer", `/mail/static/src/discuss/voice_message/common/voice_player.xml`, `<t t-name="mail.VoicePlayer" xml:space="preserve">
        <div class="o-mail-VoicePlayer d-flex align-items-center my-1 position-relative">
            <t t-set="playOrPause"><t t-if="state.repeat">Repeat</t><t t-elif="state.playing">Pause</t><t t-else="">Play</t></t>
            <button class="border-0 btn shadow-none rounded-pill fa fa-fw ms-2 me-3 bg-100" t-att-class="{                     'fa-stop text-danger btn-sm': state.playing,                     'btn-light btn-sm': !state.playing,                     'fa-play': !state.playing and !state.repeat,                     'fa-repeat': !state.playing and state.repeat,                 }" t-att-title="playOrPause" t-on-click.stop="() =&gt; this.onClickPlayPause()"/>
            <div class="o-mail-VoicePlayer-wrapper">
                <div t-ref="wrapper" class="h-100 position-relative">
                    <div class="o-mail-VoicePlayer-drawer position-absolute top-0 bottom-0 overflow-hidden" t-ref="drawer">
                        <canvas class="position-absolute" t-ref="progress"/>
                    </div>
                    <canvas class="position-absolute" t-ref="wave"/>
                </div>
            </div>
            <div class="mx-2 text-muted" style="font-variant-numeric: tabular-nums;"><t t-esc="state.visualTime"/></div>
        </div>
    </t>

`);
registerTemplate("mail.VoiceRecorder", `/mail/static/src/discuss/voice_message/common/voice_recorder.xml`, `<t t-name="mail.VoiceRecorder" xml:space="preserve">
        <t t-set="title"><t t-if="!state.recording">Voice Message</t><t t-else="">Stop Recording</t></t>
        <button class="o-mail-VoiceRecorder d-flex align-items-center btn border-0 p-0" t-att-class="{ 'o-recording rounded-start-0 rounded-end user-select-none': state.recording, 'rounded-circle': !state.recording }" t-att-title="title" t-att-disabled="state.isActionPending or props.composer.voiceAttachment" t-on-click="onClick">
            <div class="o-mail-VoiceRecorder-elapsed" t-att-class="{                 'o-active recording ms-2 me-1': state.recording,                 'mw-0': !state.recording,                 'text-danger': state.limitWarning,             }" style="font-variant-numeric: tabular-nums;"><span class="d-flex text-truncate" t-esc="state.elapsed"/></div>
            <span class="rounded-circle" t-att-class="{ 'p-1': state.recording }"><i t-att-class="!state.recording ? 'fa fa-fw fa-lg fa-microphone' : 'fa fa-fw fa-circle text-danger o-mail-VoiceRecorder-dot'"/></span>
        </button>
    </t>

`);
registerTemplate("mail.DiscussSidebarCallIndicator", `/mail/static/src/discuss/call/public_web/discuss_sidebar_call_indicator.xml`, `<t t-name="mail.DiscussSidebarCallIndicator" xml:space="preserve">
        <div t-if="props.thread.rtcSessions.length &gt; 0" title="Ongoing call" class="o-mail-DiscussSidebarCallIndicator o-py-0_5 fa-fw rounded-circle fa fa-volume-up" t-att-class="{             'o-discuss-inCallIconColor opacity-75': props.thread.eq(rtc.state.channel),             'opacity-50': !props.thread.eq(rtc.state.channel),             'me-2': !store.discuss.isSidebarCompact,         }"/>
    </t>
`);
registerTemplate("mail.DiscussSidebarCallParticipants", `/mail/static/src/discuss/call/public_web/discuss_sidebar_call_participants.xml`, `<t t-name="mail.DiscussSidebarCallParticipants" xml:space="preserve">
        <t t-if="sessions.length gt 0">
            <Dropdown t-if="compact" state="floating" position="'right-middle'" manual="true" menuClass="'o-mail-DiscussSidebar-floatingMenu bg-100 border border-secondary py-0'">
                <t t-call="mail.DiscussSidebarCallParticipants.main"/>
                <t t-set-slot="content">
                    <div t-ref="floating">
                        <DiscussSidebarCallParticipants thread="props.thread" compact="false"/>
                    </div>
                </t>
            </Dropdown>
            <t t-else="" t-call="mail.DiscussSidebarCallParticipants.main"/>
        </t>
    </t>

    `);
registerTemplate("mail.DiscussSidebarCallParticipants.main", `/mail/static/src/discuss/call/public_web/discuss_sidebar_call_participants.xml`, `<t t-name="mail.DiscussSidebarCallParticipants.main" xml:space="preserve">
        <div class="o-mail-DiscussSidebarCallParticipants d-flex flex-column o-gap-0_5 py-1" t-ref="root" t-att-class="{             'position-relative': compact,             'ps-4 pe-2': props.compact === undefined and !compact,             'px-2': props.compact === false,             'rounded-3': props.compact === undefined,             'opacity-75': props.thread.notEq(rtc.state.channel) and compact,         }">
            <t t-if="store.discuss.isSidebarCompact" t-call="mail.DiscussSidebarCallParticipants.participant">
                <t t-set="session" t-value="lastActiveSession"/>
            </t>
            <t t-else="">
                <t t-foreach="sessions" t-as="session" t-key="session.id" t-call="mail.DiscussSidebarCallParticipants.participant">
                    <t t-set="session" t-value="session"/>
                </t>
            </t>
        </div>
    </t>

    `);
registerTemplate("mail.DiscussSidebarCallParticipants.participant", `/mail/static/src/discuss/call/public_web/discuss_sidebar_call_participants.xml`, `<t t-name="mail.DiscussSidebarCallParticipants.participant" xml:space="preserve">
        <div class="o-mail-DiscussSidebarCallParticipants-participant d-flex text-reset overflow-hidden align-items-center" t-att-class="{ 'justify-content-center bg-inherit': compact }">
            <div class="bg-inherit position-relative d-flex flex-shrink-0" style="width:24px;height:24px;padding:1px">
                <img class="o-mail-DiscussSidebarCallParticipants-avatar w-100 h-100 rounded-circle o_object_fit_cover" t-att-src="session.channelMember.persona.avatarUrl" t-att-class="{'o-isTalking shadow': !session.isMute and session.isTalking}" alt="Participant avatar"/>
            </div>
            <span t-if="!compact" class="o-mail-DiscussSidebarCallParticipants-name mx-1 text-truncate fw-bold smaller user-select-none" t-att-title="session.channelMember.persona.name" t-att-class="{ 'o-isTalking': !session.isMute and session.isTalking }">
                <t t-esc="session.channelMember.persona.name"/>
            </span>
            <div t-if="!compact" class="flex-grow-1"/>
            <div class="o-mail-DiscussSidebarCallParticipants-status small opacity-75" t-att-class="{ 'position-absolute bottom-0 end-0 bg-inherit p-0 rounded-circle o-compact d-flex o-xsmaller text-start': compact, 'ms-1 d-flex align-items-center justify-content-center': !compact }">
                <t t-if="compact">
                    <span t-if="session.shortStatus" t-att-class="{                         [\`fa \${callActionsRegistry.get('mute').icon} opacity-75\`]: session.shortStatus === 'mute',                         [\`fa \${callActionsRegistry.get('deafen').icon} opacity-75\`]: session.shortStatus === 'deafen',                         'o-live bg-danger o-text-white rounded': session.shortStatus === 'live',                     }"><t t-if="session.shortStatus === 'live'">LIVE</t></span>
                </t>
                <t t-else="">
                    <span t-if="session.isMute" class="p-1 fa opacity-75" t-att-class="callActionsRegistry.get('mute').icon"/>
                    <span t-if="session.isDeaf" class="p-1 fa opacity-75" t-att-class="callActionsRegistry.get('deafen').icon"/>
                    <span t-if="session.isScreenSharingOn" class="o-live bg-danger o-text-white rounded">LIVE</span>
                </t>
            </div>
        </div>
    </t>

`);
registerTemplateExtension("mail.DiscussSidebarChannel", `/mail/static/src/discuss/call/public_web/discuss_sidebar_categories_patch.xml`, `<t t-inherit="mail.DiscussSidebarChannel" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@name='root']" position="after">
            <DiscussSidebarCallParticipants thread="thread"/>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.Discuss", `/mail/static/src/discuss/public_web/discuss_patch.xml`, `<t t-inherit="mail.Discuss" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//Thread" position="before">
            <Call t-if="thread.rtcSessions.length &gt; 0" thread="thread"/>
        </xpath>
    </t>
`);
registerTemplate("mail.AvatarCardPopover", `/mail/static/src/discuss/web/avatar_card/avatar_card_popover.xml`, `<t t-name="mail.AvatarCardPopover" xml:space="preserve">
        <div class="o_avatar_card rounded bg-inherit">
            <div class="card-body rounded bg-inherit">
                <div class="d-flex align-items-start gap-2 bg-inherit">
                    <span class="o_avatar pt-1 position-relative o_card_avatar bg-inherit">
                        <img t-if="props.id" t-attf-src="/web/image/res.users/{{props.id}}/avatar_128" class="rounded"/>
                        <span t-if="user.im_status" name="icon" class="o_card_avatar_im_status position-absolute d-flex align-items-center justify-content-center bg-inherit">
                            <i t-if="user.im_status === 'online'" class="fa fa-fw fa-circle text-success" title="Online" role="img" aria-label="User is online"/>
                            <i t-elif="user.im_status === 'away'" class="fa fa-fw fa-circle text-warning" title="Idle" role="img" aria-label="User is idle"/>
                            <i t-elif="user.im_status === 'offline'" class="fa fa-fw fa-circle-o text-700" title="Offline" role="img" aria-label="User is offline"/>
                            <i t-elif="user.im_status === 'bot'" class="fa fa-fw fa-heart text-success" title="Bot" role="img" aria-label="User is a bot"/>
                            <i t-elif="!user.im_status" class="fa fa-fw fa-question-circle" title="No IM status available"/>
                        </span>
                    </span>
                    <div class="d-flex flex-column o_card_user_infos overflow-hidden">
                        <span class="fw-bold" t-esc="user.name"/>
                        <t t-if="userInfoTemplate" t-call="{{userInfoTemplate}}"/>
                        <a t-if="email" t-att-href="'mailto:'+email" t-att-title="email" class="text-truncate">
                            <i class="fa fa-fw fa-envelope me-1"/><t t-esc="email"/>
                        </a>
                        <a t-if="phone" class="o-mail-avatar-card-tel text-truncate" t-att-title="phone" t-att-href="'tel:'+phone">
                            <i class="fa fa-fw fa-phone me-1"/><t t-esc="phone"/>
                        </a>
                    </div>
                </div>
                <div class="flex-wrap gap-2 mt-2">
                    <div class="justify-content-end d-flex align-items-baseline">
                        <div class="d-flex gap-2 o_avatar_card_buttons">
                            <button t-if="!user.share" class="btn btn-secondary btn-sm" t-on-click.stop="onSendClick">Send message</button>
                            <button t-if="showViewProfileBtn" class="btn btn-secondary btn-sm" t-on-click.stop="onClickViewProfile" t-ref="viewProfileBtn">View Profile</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("mail.StatusBarDurationField.Dropdown", `/mail/static/src/views/fields/statusbar_duration/statusbar_duration_field.xml`, `<t t-name="mail.StatusBarDurationField.Dropdown" t-inherit="web.StatusBarField.Dropdown" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//*[@t-esc='item.label']" position="inside">
            <span t-esc="item.label"/>
            <span t-if="item.shortTimeInStage" t-att-title="item.fullTimeInStage" class="ms-2 text-muted small">
                <t t-esc="item.shortTimeInStage"/>
            </span>
        </xpath>
        <xpath expr="//*[@t-esc='item.label']" position="attributes">
            <attribute name="t-esc"/>
        </xpath>
    </t>

    `);
registerTemplate("mail.StatusBarDurationField", `/mail/static/src/views/fields/statusbar_duration/statusbar_duration_field.xml`, `<t t-name="mail.StatusBarDurationField" t-inherit="web.StatusBarField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//*[@t-call='web.StatusBarField.Dropdown']" position="attributes">
            <attribute name="t-call">mail.StatusBarDurationField.Dropdown</attribute>
        </xpath>

        <xpath expr="//*[@t-esc='item.label']" position="inside">
            <span t-esc="item.label"/>
            <span t-if="item.shortTimeInStage" t-att-title="item.fullTimeInStage" class="ms-2 text-muted small">
                <t t-esc="item.shortTimeInStage"/>
            </span>
        </xpath>
        <xpath expr="//*[@t-esc='item.label']" position="attributes">
            <attribute name="t-esc"/>
        </xpath>
    </t>
`);
registerTemplate("product.ProductPricelistReport", `/product/static/src/js/pricelist_report/product_pricelist_report.xml`, `<t t-name="product.ProductPricelistReport" xml:space="preserve">
        <div class="o_action">
            <Layout display="{ controlPanel: {} }">
                <t t-set-slot="control-panel-always-buttons">
                    <button t-on-click="onClickPrint" type="button" class="btn btn-primary" title="Print">Print</button>
                    <select name="formats" id="formats" class="form-select border-1 w-auto">
                        <option value="pdf">pdf</option>
                        <option value="csv">csv</option>
                        <option value="xlsx">xlsx</option>
                    </select>
                </t>
                <t t-set-slot="layout-actions">
                    <form class="o_pricelist_report_form d-flex flex-row gap-1">
                        <div class="d-flex align-items-center gap-3 w-100">
                            <label class="visually-hidden" for="pricelists">Username</label>
                            <div class="input-group w-auto">
                                <div class="input-group-text fw-bold">Pricelist</div>
                                <select name="pricelists" id="pricelists" class="o_select form-select border-0" t-on-change="onSelectPricelist">
                                    <option t-out="selectedPricelist.name" t-att-value="selectedPricelist.id"/>
                                    <t t-foreach="pricelists" t-as="pricelist" t-key="pricelist.id">
                                        <t t-if="pricelist.id != selectedPricelist.id">
                                            <option t-out="pricelist.name" t-att-value="pricelist.id"/>
                                        </t>
                                    </t>
                                </select>
                            </div>
                            <div class="form-check w-auto">
                                <input class="o_display_pricelist_title form-check-input ms-0 me-2" id="display_pricelist_title" type="checkbox" t-att-checked="displayPricelistTitle" t-on-click="onToggleDisplayPricelist"/>
                                <label for="display_pricelist_title" class="form-check-label">Show Name</label>
                            </div>
                        </div>
                        <div class="d-flex align-items-center gap-3 w-100">
                            <div class="input-group d-flex flex-nowrap w-50" style="min-width:210px;">
                                <span class="input-group-text fw-bold">
                                    Quantities
                                </span>
                                <input type="number" class="form-control add-quantity-input" value="1" min="1"/>
                                <button class="o_add_qty btn btn-primary fa fa-plus" type="submit" t-on-click="onClickAddQty" title="Add a quantity"/>
                            </div>
                            <div class="d-flex align-items-center w-50">
                                <span class="o_badges_list d-flex">
                                    <t t-foreach="quantities" t-as="qty" t-key="qty">
                                        <span class="text-bg-300 o_remove_qty badge rounded-pill me-2 py-1 border " t-att-value="qty">
                                            <t class="me-2" t-esc="qty"/>
                                            <i class="oi oi-close ms-1 opacity-50 opacity-100-hover text-900 cursor-pointer" title="Remove quantity" t-on-click="onClickRemoveQty"/>
                                        </span>
                                    </t>
                                </span>
                            </div>
                        </div>
                    </form>
                    <div style="margin-left:300px;">
                        <button t-on-click="onClickAddProducts" string="All Products" class="btn btn-link">
                            <i class="fa fa-pencil"/>
                            Add Products
                        </button>
                    </div>
                </t>
                <div t-on-click="onClickLink">
                    <t t-out="html"/>
                </div>
                <t t-if="noProducts">
                    <div class="o_view_nocontent" role="alert">
                        <div class="o_nocontent_help">
                            <p class="o_view_nocontent_smiling_face">
                                No products found in the report
                            </p>
                            <p class="fs-5">
                                Add products using the "Add Products" button at the top right to
                                include them in the report.
                            </p>
                        </div>
                    </div>
                </t>
           </Layout>
        </div>
    </t>

`);
registerTemplate("product.ProductDocumentKanbanView.Buttons", `/product/static/src/js/product_document_kanban/product_document_kanban_controller.xml`, `<t t-name="product.ProductDocumentKanbanView.Buttons" t-inherit="web.KanbanView.Buttons" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_cp_buttons')]" position="inside">
            <UploadButton formData="formData" allowedMIMETypes="allowedMIMETypes" load.bind="() =&gt; this.model.root.load()" uploadRoute="uploadRoute"/>
        </xpath>
    </t>
`);
registerTemplate("product.ProductDocumentKanbanRenderer", `/product/static/src/js/product_document_kanban/product_document_kanban_renderer.xml`, `<t t-name="product.ProductDocumentKanbanRenderer" t-inherit-mode="primary" t-inherit="web.KanbanRenderer" xml:space="preserve">

        <xpath expr="//t[@t-key='groupOrRecord.key']" position="before">
            <FileUploadProgressContainer fileUploads="fileUploadService.uploads" Component="constructor.components.FileUploadProgressKanbanRecord"/>
        </xpath>
    </t>
`);
registerTemplate("product.UploadButton", `/product/static/src/js/product_document_kanban/upload_button/upload_button.xml`, `<t t-name="product.UploadButton" xml:space="preserve">
        <input type="file" multiple="true" t-ref="uploadFileInput" t-att-accept="props.allowedMIMETypes" class="o_input_file o_hidden" t-on-change.stop="onFileInputChange"/>
        <button type="button" name="product_upload_document" t-attf-class="btn btn-primary" t-on-click.stop.prevent="() =&gt; this.uploadFileInputRef.el.click()">
            Upload
        </button>
    </t>
`);
registerTemplate("ProductCatalogKanbanController", `/product/static/src/product_catalog/kanban_controller.xml`, `<t t-name="ProductCatalogKanbanController" t-inherit="web.KanbanView" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//button[hasclass('o-kanban-button-new')]" position="replace">
            <button t-out="this.buttonString" type="button" class="btn btn-secondary o-kanban-button-back" t-on-click="this.backToQuotationDebounced"/>
        </xpath>
    </t>
`);
registerTemplate("ProductCatalogKanbanRecord", `/product/static/src/product_catalog/kanban_record.xml`, `<t t-name="ProductCatalogKanbanRecord" xml:space="preserve">
        <article t-att-class="getRecordClasses() + (productCatalogData.quantity ? ' o_product_added' : '')" t-att-data-id="props.record.id" t-att-tabindex="props.record.model.useSampleModel ? -1 : 0" t-on-click="onGlobalClick" t-ref="root">
            <div class="d-flex flex-column h-100">
                <t t-call="{{ templates[this.constructor.KANBAN_CARD_ATTRIBUTE] }}" t-call-context="this.renderingContext"/>
                <t t-component="orderLineComponent" productId="props.record.resId" t-props="productCatalogData"/>
            </div>
            <t t-call="{{ this.constructor.menuTemplate }}"/>
        </article>
    </t>
`);
registerTemplate("ProductCatalogKanbanRenderer", `/product/static/src/product_catalog/kanban_renderer.xml`, `<t t-name="ProductCatalogKanbanRenderer" t-inherit="web.KanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <t t-if="showNoContentHelper" position="replace">
            <t t-if="showNoContentHelper">
                <div class="o_view_nocontent" role="alert">
                    <div class="o_nocontent_help">
                        <p class="o_view_nocontent_smiling_face">
                            No products could be found.<br/>
                            <button class="mt-2 btn btn-primary" t-on-click="this.createProduct">Create a product</button>
                        </p>
                        <p>
                            You must define a product for everything you sell or purchase,
                            whether it's a storable product, a consumable or a service.
                        </p>
                    </div>
                </div>
            </t>
        </t>
    </t>
`);
registerTemplate("product.ProductCatalogOrderLine", `/product/static/src/product_catalog/order_line/order_line.xml`, `<t t-name="product.ProductCatalogOrderLine" xml:space="preserve">

        <t t-portal="\`#product-\${props.productId}-price\`" t-if="showPrice">
            <span class="o_product_catalog_price">Unit price: <t t-out="price"/></span>
        </t>
        <div t-if="props.readOnly and props.warning" class="text-danger text-truncate my-2 pt-3 border-top">
            <i class="fa fa-warning" t-att-title="props.warning"/>
            <span class="px-1" t-att-title="props.warning" t-out="props.warning"/>
        </div>
        <span t-elif="props.readOnly" class="m-2 pt-3 border-top" t-out="props.warning">
            You can't edit this product in the catalog.
        </span>
        <div t-else="" class="d-flex justify-content-end align-items-center m-2">
            <div t-if="isInOrder()" class="input-group o_product_catalog_quantity o_product_catalog_cancel_global_click w-50">
                <button class="btn btn-primary border" t-on-click.stop="this.env.decreaseQuantity" t-att-disabled="disableRemove" t-att-data-tooltip="disabledButtonTooltip">
                    <i class="fa fa-minus center"/>
                </button>
                <input class="o_input form-control border text-center text-bg-light" type="number" t-att-value="quantity" t-on-change="this.env.setQuantity" t-on-focus="_onFocus"/>
                <button class="btn btn-primary border" t-on-click.stop="(ev) =&gt; this.env.increaseQuantity()">
                    <i class="fa fa-plus"/>
                </button>
            </div>
            <t t-elif="props.warning">
                <i class="fa fa-warning text-warning" t-att-title="props.warning"/>
                <span class="text-truncate text-warning px-1" t-att-title="props.warning" t-out="props.warning"/>
            </t>
            <div class="ms-auto o_product_catalog_buttons o_product_catalog_cancel_global_click" style="min-width: max-content;">
                <button t-if="!isInOrder()" t-on-click.stop="() =&gt; this.env.addProduct()" class="btn btn-secondary">
                    <i class="fa fa-shopping-cart"/>
                    Add
                </button>
                <div t-else="" class="o_tooltip_div_remove" t-att-data-tooltip="this.disabledButtonTooltip">
                    <button t-on-click.stop="this.env.removeProduct" t-att-disabled="disableRemove" class="btn btn-light border">
                        <i class="fa fa-trash"/>
                        Remove
                    </button>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("ProductCatalogSearchPanel.FiltersGroup", `/product/static/src/product_catalog/search/search_panel.xml`, `<t t-name="ProductCatalogSearchPanel.FiltersGroup" t-inherit="web.SearchPanel.FiltersGroup" t-inherit-mode="primary" xml:space="preserve">
        <li t-foreach="[...values.keys()]" position="replace">
            <li t-foreach="[...this.state.sectionOfAttributes.keys()]" t-as="attrName" t-key="attrName" class="o_search_panel_filter_value list-group-item p-0 mb-1 border-0 o_cursor_pointer" t-att-class="{ 'ps-2' : isChildList }">
                <t t-set="attrCount" t-value="this.state.sectionOfAttributes.get(attrName).get('count')"/>
                <t t-set="attrIds" t-value="this.state.sectionOfAttributes.get(attrName).get('ids')"/>
                <div class="form-check w-100">
                    <input type="checkbox" t-attf-id="{{ section.id }}_input_{{ attrName }}" class="form-check-input" t-on-click="ev =&gt; this.toggleSectionFilterValue(section.id, attrIds, ev)"/>
                    <label class="o_search_panel_label form-check-label d-flex align-items-center justify-content-between w-100 o_cursor_pointer" t-attf-for="{{ section.id }}_input_{{ attrName }}" t-att-title="(group and group.tooltip) or false">
                        <span class="o_search_panel_label_title text-truncate" t-esc="attrName"/>
                        <span t-if="section.enableCounters and attrCount gt 0" class="o_search_panel_counter text-muted mx-2 small" t-esc="attrCount"/>
                    </label>
                </div>
            </li>
        </li>
    </t>
`);
registerTemplate("analytic.AnalyticDistribution", `/analytic/static/src/components/analytic_distribution/analytic_distribution.xml`, `<t t-name="analytic.AnalyticDistribution" xml:space="preserve">
        <div class="o_field_tags d-inline-flex flex-wrap mw-100" t-att-class="{'o_tags_input o_input': !props.readonly}" t-ref="analyticDistribution" t-on-keydown="onWidgetKeydown">
            <TagsList tags="planSummaryTags()"/>
            <div t-if="!props.readonly" class="o_input_dropdown d-inline-flex w-100" tabindex="0" t-ref="mainElement" t-on-focus="onMainElementFocus" t-on-click="onMainElementFocus">
                <span class="analytic_distribution_placeholder"/>
                <span class="o_dropdown_button"/>
                <t t-call="analytic.AnalyticDistributionPopup"/>
            </div>
        </div>
    </t>

    `);
registerTemplate("analytic.AnalyticDistributionPopup", `/analytic/static/src/components/analytic_distribution/analytic_distribution.xml`, `<t t-name="analytic.AnalyticDistributionPopup" xml:space="preserve">
        <div class="popover analytic_distribution_popup dropdown-menu o-dropdown--menu show rounded py-0 overflow-x-hidden" t-if="state.showDropdown" t-ref="analyticDropdown">
            <div class="popover-header sticky-top">
                <div class="d-flex">
                    <div class="h5 mt-2 me-auto">
                        Analytic
                        <span t-if="allowSave" class="btn btn-link" t-on-click="onSaveNew" title="Save as new analytic distribution model">New Model</span>
                    </div>
                    <div class="popupButtons">
                        <span class="btn o_button" t-on-click.stop="() =&gt; this.closeAnalyticEditor()" title="Close"><span class="fa fa-close"/></span>
                    </div>
                </div>
            </div>
            <div class="popover-body p-2 table-responsive">
                <span t-if="!allPlans.length">No analytic plans found</span>
                <table t-else="" class="o_list_table table table-sm table-hover o_analytic_table mb-2 table-striped">
                    <t t-set="totals" t-value="planTotals()"/>
                    <thead>
                        <tr class="border-bottom">
                            <th t-foreach="allPlans" t-as="plan" t-key="plan.id">
                                <span t-out="plan.name"/> (<span t-att-class="totals[plan.id].class" t-out="totals[plan.id].formattedValue"/>)
                            </th>
                            <th t-out="'Percentage'" class="numeric_column_width"/>
                            <th t-if="valueColumnEnabled" class="numeric_column_width" t-out="props.record.fields[props.amount_field].string"/>
                            <th class="deleteColumn w-20px"/>
                        </tr>
                    </thead>
                    <tbody>
                        <tr t-foreach="state.formattedData" t-as="line" t-key="line.id" t-att-id="line_index" t-att-name="'line_' + line_index">
                            <Record t-props="recordProps(line)" t-slot-scope="data">
                                <td t-foreach="Object.keys(data.record.fields).filter((f) =&gt; f.startsWith('x_plan'))" t-as="field" t-key="field">
                                    <Field id="field" name="field" record="data.record" domain="data.record.fields[field].domain" canOpen="false" canCreate="false" canCreateEdit="false" canQuickCreate="false"/>
                                </td>
                                <td class="numeric_column_width">
                                    <Field id="'percentage'" name="'percentage'" record="data.record"/>
                                </td>
                                <td t-if="valueColumnEnabled" class="numeric_column_width">
                                    <Field id="props.amount_field" name="props.amount_field" record="data.record"/>
                                </td>
                                <td class="w-20px">
                                    <span class="fa fa-trash-o cursor-pointer" t-on-click.stop="() =&gt; this.deleteLine(line_index)"/>
                                </td>
                            </Record>
                        </tr>
                        <tr>
                            <td t-on-click.stop.prevent="addLine" class="o_field_x2many_list_row_add" t-att-colspan="allPlans.length + 2 + valueColumnEnabled">
                                <a href="#" t-ref="addLineButton" tabindex="0">Add a Line</a>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </t>

`);
registerTemplate("web_editor.DocumentAttachment", `/web_editor/static/src/components/media_dialog/document_selector.xml`, `<t t-name="web_editor.DocumentAttachment" xml:space="preserve">
    <div class="o_existing_attachment_cell o_we_attachment_highlight card col-2 position-relative mb-2 p-2 opacity-trigger-hover cursor-pointer" t-att-class="{ o_we_attachment_selected: props.selected }" t-on-click="props.selectAttachment">
        <RemoveButton remove="() =&gt; this.remove()"/>
        <div t-att-data-url="props.url" role="img" t-att-aria-label="props.name" t-att-title="props.name" t-att-data-mimetype="props.mimetype" class="o_image d-flex align-items-center justify-content-center"/>
        <small class="o_file_name d-block text-truncate" t-esc="props.name"/>
    </div>
</t>

`);
registerTemplate("web_editor.DocumentsListTemplate", `/web_editor/static/src/components/media_dialog/document_selector.xml`, `<t t-name="web_editor.DocumentsListTemplate" xml:space="preserve">
    <div class="o_we_existing_attachments o_we_documents" t-ref="existing-attachments">
        <div t-if="!hasContent" class="o_nocontent_help">
            <p class="o_empty_folder_image">No documents found.</p>
            <p class="o_empty_folder_subtitle">You can upload documents with the button located in the top left of the screen.</p>
        </div>
        <div t-else="" class="d-flex flex-wrap gap-2">
            <t t-foreach="state.attachments" t-as="attachment" t-key="attachment.id">
                <DocumentAttachment url="attachment.url" name="attachment.name" mimetype="attachment.mimetype" id="attachment.id" onRemoved="(attachmentId) =&gt; this.onRemoved(attachmentId)" selected="this.selectedAttachmentIds.includes(attachment.id)" selectAttachment="() =&gt; this.onClickDocument(attachment)"/>
            </t>
        </div>
    </div>
</t>
`);
registerTemplate("web_editor.FileSelectorControlPanel", `/web_editor/static/src/components/media_dialog/file_selector.xml`, `<t t-name="web_editor.FileSelectorControlPanel" xml:space="preserve">
    <div class="o_we_file_selector_control_panel sticky-top d-flex flex-wrap gap-2 mb-1 p-3 align-items-end">
        <SearchMedia searchPlaceholder="props.searchPlaceholder" needle="props.needle" search="props.search"/>
        <div class="d-flex gap-3 justify-content-start align-items-center">
            <div t-if="props.showOptimizedOption" class="flex-shrink-0 form-check form-switch align-items-center" t-on-change="props.changeShowOptimized">
                <input class="o_we_show_optimized form-check-input" type="checkbox" t-att-checked="props.showOptimized" id="o_we_show_optimized_switch"/>
                <label class="form-check-label" for="o_we_show_optimized_switch">
                    Show optimized images
                </label>
            </div>
            <select t-if="showSearchServiceSelect" class="o_input o_we_search_select form-select" t-on-change="ev =&gt; props.changeSearchService(ev.target.value)">
                <option t-att-selected="props.searchService === 'all'" value="all">All</option>
                <option t-att-selected="props.searchService === 'database'" value="database">My Images</option>
                <option t-if="props.useMediaLibrary" t-att-selected="props.searchService === 'media-library'" value="media-library">Illustrations</option>
            </select>
        </div>
        <div class="col justify-content-end flex-nowrap input-group has-validation">
            <input type="text" class="form-control o_input o_we_url_input o_we_transition_ease flex-grow-0" t-att-class="{ o_we_horizontal_collapse: !state.showUrlInput, 'w-auto': state.showUrlInput }" name="url" t-att-placeholder="props.urlPlaceholder" t-model="state.urlInput" t-on-input="onUrlInput" t-if="state.showUrlInput"/>
            <button type="button" class="btn o_upload_media_url_button text-nowrap" t-att-class="{ 'btn-primary': state.urlInput, 'btn-secondary': !state.urlInput}" t-on-click="onUrlUploadClick" t-att-disabled="!enableUrlUploadClick">
                    <t t-esc="props.addText"/>
            </button>
            <div class="d-flex align-items-center">
                <span t-if="state.urlInput and state.isValidatingUrl" class="o_we_url_loading mx-2 fa fa-lg fa-spinner" title="Loading..."/>
                <span t-elif="state.urlInput and state.isValidUrl and state.isValidFileFormat" class="o_we_url_success text-success mx-2 fa fa-lg fa-check" title="The URL seems valid."/>
                <span t-elif="state.urlInput and !state.isValidUrl" class="o_we_url_error text-danger mx-2 fa fa-lg fa-times" title="The URL does not seem to work."/>
                <span t-elif="props.urlWarningTitle and state.urlInput and state.isValidUrl and !state.isValidFileFormat" class="o_we_url_warning text-warning mx-2 fa fa-lg fa-warning" t-att-title="props.urlWarningTitle"/>
            </div>
        </div>
        <input type="file" class="d-none o_file_input" t-on-change="onChangeFileInput" t-ref="file-input" t-att-accept="props.accept" t-att-multiple="props.multiSelect and 'multiple'"/>
        <div class="col-auto btn-group">
            <button type="button" class="btn btn-primary o_upload_media_button" t-on-click="onClickUpload">
                <t t-esc="props.uploadText"/>
            </button>
        </div>
    </div>
</t>

`);
registerTemplate("web_editor.FileSelector", `/web_editor/static/src/components/media_dialog/file_selector.xml`, `<t t-name="web_editor.FileSelector" xml:space="preserve">
    <div>
        <FileSelectorControlPanel uploadText="uploadText" accept="fileMimetypes" urlPlaceholder="urlPlaceholder" addText="addText" searchPlaceholder="searchPlaceholder" urlWarningTitle="urlWarningTitle" uploadUrl="(url) =&gt; this.uploadUrl(url)" uploadFiles="(files) =&gt; this.uploadFiles(files)" showOptimizedOption="showOptimizedOption" showOptimized="state.showOptimized" changeShowOptimized="showOptimized =&gt; this.state.showOptimized = !this.state.showOptimized" changeSearchService="service =&gt; this.state.searchService = service" searchService="state.searchService" needle="state.needle" search="(needle) =&gt; this.handleSearch(needle)" useMediaLibrary="props.useMediaLibrary" validateUrl="validateUrl" multiSelect="props.multiSelect"/>
        <t t-call="{{ constructor.attachmentsListTemplate }}"/>
        <div name="load_more_attachments" class="pt-3 pb-1 text-center mx-auto o_we_load_more" t-ref="load-more-button">
            <button t-if="canLoadMore" class="btn btn-primary o_load_more" type="button" t-on-click="handleLoadMore">
                Load more...
            </button>
            <div t-elif="hasContent" class="mt-2 o_load_done_msg">
                <span><i t-esc="allLoadedText"/></span>
            </div>
        </div>
        <div t-if="this.state.canScrollAttachments" class="position-sticky d-flex align-items-center mx-auto btn btn-primary rounded-circle oi oi-chevron-down o_scroll_attachments" t-on-click="handleScrollAttachments"/>
    </div>
</t>
`);
registerTemplate("web_editor.IconSelector", `/web_editor/static/src/components/media_dialog/icon_selector.xml`, `<t t-name="web_editor.IconSelector" xml:space="preserve">
    <div>
        <div class="o_we_file_selector_control_panel sticky-top d-flex gap-2 align-items-center mb-1 py-4 px-3">
            <SearchMedia searchPlaceholder.translate="Search a pictogram" search.bind="this.search" needle="state.needle"/>
        </div>
        <div class="font-icons-icons">
            <t t-foreach="state.fonts" t-as="font" t-key="font.base">
                <div t-if="!font.icons.length" class="o_nocontent_help">
                    <p class="o_empty_folder_image">No pictograms found.</p>
                    <p class="o_empty_folder_subtitle">Try searching with other keywords.</p>
                </div>
                <span t-foreach="font.icons" t-as="icon" t-key="icon.id" t-att-title="icon.names[0]" t-att-aria-label="icon.names[0]" role="img" class="font-icons-icon m-2 fs-2 p-3 cursor-pointer text-center" t-att-class="{ o_we_attachment_selected: this.selectedMediaIds.includes(icon.id) }" t-attf-class="{{ font.base }} {{ icon.names[0] }}" t-on-click="() =&gt; this.onClickIcon(font, icon)"/>
            </t>
        </div>
    </div>
</t>
`);
registerTemplate("web_editor.AutoResizeImage", `/web_editor/static/src/components/media_dialog/image_selector.xml`, `<t t-name="web_editor.AutoResizeImage" xml:space="preserve">
    <div t-ref="auto-resize-image-container" class="o_existing_attachment_cell o_we_image align-items-center justify-content-center me-1 mb-1 opacity-trigger-hover opacity-0" t-att-class="{ o_we_attachment_optimized: props.isOptimized, 'o_loaded position-relative opacity-100': state.loaded, o_we_attachment_selected: props.selected, 'position-fixed': !state.loaded, 'cursor-pointer': !props.unselectable }" t-on-click="props.onImageClick">
        <RemoveButton t-if="props.isRemovable" model="props.model" remove="() =&gt; this.remove()"/>
        <div class="o_we_media_dialog_img_wrapper" t-att-class="{ 'bg-light': props.unselectable }">
            <t t-set="unselectable_attachment_title">You can not use this image in a field</t>
            <img t-ref="auto-resize-image" class="o_we_attachment_highlight img img-fluid w-100" t-att-class="{ 'opacity-25': props.unselectable}" t-att-src="props.src" t-att-alt="props.altDescription" loading="lazy" t-att-title="props.unselectable ? unselectable_attachment_title : props.title"/>
            <a t-if="props.author" class="o_we_media_author position-absolute start-0 bottom-0 end-0 text-truncate text-center text-primary fs-6 bg-white-50" t-att-href="props.authorLink" target="_blank" t-esc="props.author"/>
        </div>
        <span t-if="props.isOptimized" class="badge position-absolute bottom-0 end-0 m-1 text-bg-success">Optimized</span>
    </div>
</t>

`);
registerTemplate("web_editor.ExternalImage", `/web_editor/static/src/components/media_dialog/image_selector.xml`, `<t t-name="web_editor.ExternalImage" xml:space="preserve">
    <t t-if="record.mediaType == 'libraryMedia'">
        <AutoResizeImage author="record.author" src="record.thumbnail_url" authorLink="record.author_link" title="record.tooltip" altDescription="record.tooltip" minRowHeight="MIN_ROW_HEIGHT" selected="this.selectedMediaIds.includes(record.id)" onImageClick="() =&gt; this.onClickMedia(record)" onLoaded="(imgEl) =&gt; this.onImageLoaded(imgEl, record)"/>
    </t>
</t>

`);
registerTemplate("web_editor.ImagesListTemplate", `/web_editor/static/src/components/media_dialog/image_selector.xml`, `<t t-name="web_editor.ImagesListTemplate" xml:space="preserve">
    <div class="o_we_existing_attachments o_we_images d-flex flex-wrap my-0" t-ref="existing-attachments">
        <t t-if="!hasContent and !isFetching">
            <div t-if="state.needle" class="o_nocontent_help">
                <p class="o_empty_folder_image">No images found.</p>
                <p class="o_empty_folder_subtitle">Wow, it feels a bit empty in here. Upload from the button in the top right corner!</p>
            </div>
            <div t-else="" class="o_we_search_prompt">
                <h2>Discover a world of awesomeness in our copyright-free image haven. No legal drama, just nice images!</h2>
            </div>
        </t>
        <t t-else="">
            <t t-if="['all', 'database'].includes(state.searchService)">
                <t t-foreach="state.attachments" t-as="attachment" t-key="attachment.id">
                    <AutoResizeImage t-if="!attachment.original_id or state.showOptimized" id="attachment.id" isOptimized="!!attachment.original_id" isRemovable="true" onRemoved="(attachmentId) =&gt; this.onRemoved(attachmentId)" selected="this.selectedAttachmentIds.includes(attachment.id)" src="attachment.thumbnail_src or attachment.image_src" name="attachment.name" title="attachment.name" unselectable="!!attachment.unselectable" altDescription="attachment.altDescription" model="attachment.res_model" minRowHeight="MIN_ROW_HEIGHT" onImageClick="() =&gt; this.onClickAttachment(attachment)" onLoaded="(imgEl) =&gt; this.onImageLoaded(imgEl, attachment)"/>
                </t>
            </t>
            <t id="o_we_media_library_images" t-if="['all', 'media-library'].includes(state.searchService)">
                <t t-foreach="state.libraryMedia" t-as="record" t-key="record.id">
                    <t t-call="web_editor.ExternalImage"/>
                </t>
            </t>

            <t t-foreach="[...Array(20).keys()]" t-as="i" t-key="i">
                <div class="o_we_attachment_placeholder"/>
            </t>
        </t>
    </div>
</t>
`);
registerTemplate("web_editor.MediaDialog", `/web_editor/static/src/components/media_dialog/media_dialog.xml`, `<t t-name="web_editor.MediaDialog" xml:space="preserve">
    <Dialog contentClass="contentClass" size="size" title.translate="Select a media" modalRef="modalRef">
        <Notebook pages="tabs" onPageUpdate.bind="onTabChange" defaultPage="state.activeTab"/>
        <t t-set-slot="footer">
            <button class="btn btn-primary" t-on-click="() =&gt; this.save()" t-ref="add-button">Add</button>
            <button class="btn btn-secondary" t-on-click="() =&gt; this.props.close()">Discard</button>
        </t>
    </Dialog>
</t>
`);
registerTemplate("web_editor.VideoOption", `/web_editor/static/src/components/media_dialog/video_selector.xml`, `<t t-name="web_editor.VideoOption" xml:space="preserve">
    <div class="mb-1">
        <label class="d-flex align-items-start gap-2 cursor-pointer" t-on-change="props.onChangeOption">
            <div class="o_switch flex-shrink-0">
                <input type="checkbox" t-att-checked="props.value"/>
                <span/>
            </div>
            <span t-esc="props.label"/>
            <span t-if="props.description" class="text-muted" t-esc="props.description"/>
        </label>
    </div>
</t>

`);
registerTemplate("web_editor.VideoIframe", `/web_editor/static/src/components/media_dialog/video_selector.xml`, `<t t-name="web_editor.VideoIframe" xml:space="preserve">
    <iframe t-att-src="this.props.src" class="o_video_dialog_iframe mw-100 mh-100 overflow-hidden shadow" width="1280" height="720" allowfullscreen="allowfullscreen" frameborder="0"/>
</t>

`);
registerTemplate("web_editor.VideoSelector", `/web_editor/static/src/components/media_dialog/video_selector.xml`, `<t t-name="web_editor.VideoSelector" xml:space="preserve">
    <div class="row">
        <div class="col mt-4 o_video_dialog_form">
            <div class="mb-2">
                <label for="o_video_text">
                    <b>Video code </b>(URL or Embed)
                </label>
                <div class="text-start">
                    <small class="text-muted">Accepts <b><i>Youtube</i></b>, <b><i>Vimeo</i></b>, <b><i>Dailymotion</i></b> and <b><i>Youku</i></b> videos</small>
                </div>
                <textarea t-ref="autofocus" t-model="state.urlInput" class="form-control" id="o_video_text" placeholder="Copy-paste your URL or embed code here" t-on-input="onChangeUrl" t-att-class="{ 'is-valid': state.urlInput and !this.state.errorMessage, 'is-invalid': state.urlInput and this.state.errorMessage }"/>
            </div>
            <div t-if="shownOptions.length" class="o_video_dialog_options">
                <VideoOption t-foreach="shownOptions" t-as="option" t-key="option.id" value="option.value" onChangeOption="() =&gt; this.onChangeOption(option.id)" label="option.label" description="option.description"/>
            </div>
            <t t-if="state.vimeoPreviews.length">
                <span class="fw-bold">Suggestions</span>
                <div id="video-suggestion" class="mt-4 d-flex flex-wrap mh-75 overflow-auto">
                    <t t-foreach="state.vimeoPreviews" t-as="vimeoPreview" t-key="vimeoPreview.id">
                        <div class="o_sample_video w-25 mh-100 cursor-pointer" t-on-click="() =&gt; this.onClickSuggestion(vimeoPreview.src)">
                            <img class="mw-100 mh-100 p-1" t-att-src="vimeoPreview.thumbnailSrc"/>
                        </div>
                    </t>
                </div>
            </t>
        </div>
        <div class="col-md-6">
            <div class="o_video_preview position-relative border-0 p-3">
                <div t-if="this.state.src and !this.state.errorMessage" class="o_video_dialog_preview_text mb-2">Preview</div>
                <div class="media_iframe_video">
                    <div class="media_iframe_video_size"/>
                    <VideoIframe t-if="this.state.src and !this.state.errorMessage" src="this.state.src"/>
                    <div t-if="this.state.errorMessage" class="alert alert-warning o_video_dialog_iframe mw-100 mh-100 mb-2 mt-2" t-esc="this.state.errorMessage"/>
                </div>
            </div>
        </div>
    </div>
</t>
`);
registerTemplate("web_editor.ProgressBar", `/web_editor/static/src/components/upload_progress_toast/upload_progress_toast.xml`, `<t t-name="web_editor.ProgressBar" xml:space="preserve">
    <small class="text-info d-flex align-items-center me-2">
        <span t-if="!props.hasError and !props.uploaded"><i class="fa fa-circle-o-notch fa-spin me-2"/></span>
        <span class="fst-italic fw-bold text-truncate flex-grow-1 me-2" t-esc="props.name"/>
        <span class="fw-bold text-nowrap" t-esc="props.size"/>
    </small>
    <small t-if="props.uploaded or props.hasError" class="d-flex align-items-center mt-1">
        <span t-if="props.uploaded" class="text-success"><i class="fa fa-check my-1 me-1"/> File has been uploaded</span>
        <span t-else="" class="text-danger"><i class="fa fa-times float-start my-1 me-1"/> <span class="o_we_error_text" t-esc="props.errorMessage ? props.errorMessage : 'File could not be saved'"/></span>
    </small>
    <div t-else="" class="progress">
        <div class="progress-bar bg-info progress-bar-striped progress-bar-animated" role="progressbar" t-attf-style="width: {{this.progress}}%;" aria-label="Progress bar"><span t-esc="this.progress + '%'"/></div>
    </div>
    <hr/>
</t>

`);
registerTemplate("web_editor.UploadProgressToast", `/web_editor/static/src/components/upload_progress_toast/upload_progress_toast.xml`, `<t t-name="web_editor.UploadProgressToast" xml:space="preserve">
    <div class="o_notification_manager o_upload_progress_toast">
        <div t-if="state.isVisible" class="o_notification position-relative show fade mb-2 border border-info bg-white" role="alert" aria-live="assertive" aria-atomic="true">
            <button type="button" class="btn btn-close o_notification_close p-2" aria-label="Close" t-on-click="props.close"/>
            <div class="o_notification_body ps-2 pe-4 py-2">
                <div class="me-auto o_notification_content">
                    <div t-foreach="state.files" t-as="file" t-key="file" class="o_we_progressbar">
                        <ProgressBar progress="file_value.progress" errorMessage="file_value.errorMessage" hasError="file_value.hasError" name="file_value.name" uploaded="file_value.uploaded" size="file_value.size"/>
                    </div>
                </div>
            </div>
        </div>
    </div>
</t>
`);
registerTemplateExtension("web_editor.ExternalImage", `/web_unsplash/static/src/media_dialog_legacy/image_selector.xml`, `<t t-inherit="web_editor.ExternalImage" t-inherit-mode="extension" xml:space="preserve">
    <xpath expr="//t[@t-if]" position="after">
        <t t-elif="record.mediaType == 'unsplashRecord'">
            <AutoResizeImage src="record.url" author="record.user.name" authorLink="record.user.links.html" name="record.user.name" title="record.user.name" altDescription="record.alt_description" selected="this.selectedRecordIds.includes(record.id)" onImageClick="() =&gt; this.onClickRecord(record)" minRowHeight="MIN_ROW_HEIGHT" onLoaded="(imgEl) =&gt; this.onImageLoaded(imgEl, record)"/>
        </t>
    </xpath>
</t>

`);
registerTemplateExtension("web_editor.ImagesListTemplate", `/web_unsplash/static/src/media_dialog_legacy/image_selector.xml`, `<t t-name="web_unsplash.ImagesListTemplate" t-inherit="web_editor.ImagesListTemplate" t-inherit-mode="extension" xml:space="preserve">
    <xpath expr="//t[@id='o_we_media_library_images']" position="replace">
        <t id="o_we_media_library_images" t-if="['all', 'unsplash', 'media-library'].includes(state.searchService)">
            <t t-foreach="combinedRecords" t-as="record" t-key="record.id">
                <t t-call="web_editor.ExternalImage"/>
            </t>
        </t>
    </xpath>
</t>

`);
registerTemplateExtension("web_editor.FileSelector", `/web_unsplash/static/src/media_dialog_legacy/image_selector.xml`, `<t t-inherit="web_editor.FileSelector" t-inherit-mode="extension" xml:space="preserve">
    <xpath expr="//div[@name='load_more_attachments']" position="before">
        <div t-if="state.unsplashError" class="d-flex mt-2 unsplash_error">
            <UnsplashError title="errorTitle" subtitle="errorSubtitle" showCredentials="['key_not_found', 401].includes(state.unsplashError)" submitCredentials="(key, appId)  =&gt; this.submitCredentials(key, appId)" hasCredentialsError="state.unsplashError === 401"/>
        </div>
    </xpath>
</t>

`);
registerTemplateExtension("web_editor.FileSelector", `/web_unsplash/static/src/media_dialog_legacy/image_selector.xml`, `<t t-inherit="web_editor.FileSelector" t-inherit-mode="extension" xml:space="preserve">
    <xpath expr="//FileSelectorControlPanel" position="attributes">
        <attribute name="useUnsplash">state.useUnsplash</attribute>
    </xpath>
</t>
`);
registerTemplateExtension("web_editor.FileSelectorControlPanel", `/web_unsplash/static/src/media_dialog_legacy/image_selector.xml`, `<t t-inherit="web_editor.FileSelectorControlPanel" t-inherit-mode="extension" xml:space="preserve">
    <xpath expr="//option[@value='media-library']" position="after">
        <option t-if="props.useUnsplash" t-att-selected="props.searchService === 'unsplash'" value="unsplash">Photos (via Unsplash)</option>
    </xpath>
</t>

`);
registerTemplate("web_editor.HtmlField", `/web_editor/static/src/js/backend/html_field.xml`, `<t t-name="web_editor.HtmlField" xml:space="preserve">
        <t t-if="props.readonly || props.notEditable || (sandboxedPreview and !state.showCodeView)">
            <t t-if="this.showIframe">
                <iframe t-ref="iframe" t-att-class="{'d-none': !this.state.iframeVisible, 'o_readonly': true}" t-att-sandbox="sandboxedPreview ? 'allow-same-origin allow-popups allow-popups-to-escape-sandbox' : false"/>
            </t>
            <t t-else="">
                <div t-ref="readonlyElement" class="o_readonly" t-out="markupValue"/>
            </t>
        </t>
        <div t-else="" class="h-100" t-ref="spellcheck" t-att-class="{'d-flex': this.wysiwygOptions.snippets}">
            <t t-if="state.showCodeView">
                <textarea t-ref="codeView" class="o_codeview" t-att-value="markupValue"/>
            </t>
            <t t-else="">
                <t t-component="this.Wysiwyg" t-props="{                     'options': this.wysiwygOptions,                     'startWysiwyg': this.startWysiwyg.bind(this),                     'editingValue': this.currentEditingValue,                 }"/>
            </t>
            <t t-if="isTranslatable">
                <span t-attf-style="font-size: 15px; position: absolute; right: {{this.props.codeview ? '40px' : '5px'}}; top: 5px;">
                    <TranslationButton fieldName="props.name" record="props.record"/>
                </span>
            </t>
        </div>
        <div t-if="state.showCodeView || (sandboxedPreview and !props.readonly and !props.notEditable)" t-ref="codeViewButton" id="codeview-btn-group" class="btn-group" t-on-click="toggleCodeView">
            <button class="o_codeview_btn btn btn-primary">
                <i class="fa fa-code"/>
            </button>
        </div>
    </t>

`);
registerTemplate("web_editor.FieldTextHtml.button.translate", `/web_editor/static/src/xml/backend.xml`, `<t t-name="web_editor.FieldTextHtml.button.translate" xml:space="preserve">
        <div class="btn-group float-end">
            <button t-if="widget.field.translate" class="o_field_translate btn btn-secondary" style="height: 24px; padding: 1px 17px 0px 5px" aria-label="Translate" title="Translate">
                <span class="fa fa-language fa-lg oe_input_icon"/>
            </button>
        </div>
    </t>

    `);
registerTemplate("web_editor.FieldTextHtml.fullscreen", `/web_editor/static/src/xml/backend.xml`, `<t t-name="web_editor.FieldTextHtml.fullscreen" xml:space="preserve">
        <span style="margin: 5px; position: fixed; top: 0; right: 0; z-index: 2000;">
            <button class="o_fullscreen btn btn-primary" style="width: 24px; height: 24px; background-color: #337ab7; border: 1px solid #2e6da4; border-radius: 4px; padding: 0; position: relative;">
                <img src="/web_editor/font_to_img/61541/rgb(255,255,255)/16" style="position: absolute; top: 3px; left: 4px;" alt="Fullscreen"/>
            </button>
        </span>
    </t>

`);
registerTemplate("resource.SectionListRenderer.RecordRow", `/resource/static/src/section_list_renderer.xml`, `<t t-name="resource.SectionListRenderer.RecordRow" t-inherit="web.ListRenderer.RecordRow" xml:space="preserve">
        <xpath expr="//t[@t-if='displayOptionalFields or hasX2ManyAction']" position="attributes">
            <attribute name="t-if">(displayOptionalFields or hasX2ManyAction) and !isSection(record)</attribute>
        </xpath>
    </t>

`);
registerTemplate("resource.FormViewWithHtmlExpander", `/resource/static/src/views/form_with_html_expander/form_controller_with_html_expander.xml`, `<t t-name="resource.FormViewWithHtmlExpander" t-inherit="web.FormView" xml:space="preserve">
        <xpath expr="//Layout/t[@t-component='props.Renderer']" position="attributes">
            <attribute name="reloadHtmlFieldHeight">htmlExpanderState.reload</attribute>
            <attribute name="notifyHtmlExpander.bind">notifyHTMLFieldExpanded</attribute>
        </xpath>
    </t>

`);
registerTemplate("account.BatchSendingSummary", `/account/static/src/components/account_batch_sending_summary/account_batch_sending_summary.xml`, `<t t-name="account.BatchSendingSummary" xml:space="preserve">
        <p>You are about to send</p>
        <ul>
            <li t-foreach="this.data" t-as="summary_entry" t-key="summary_entry">
                <t t-out="summary_entry_value.count"/> invoice(s)
                <t t-out="summary_entry_value.label"/>
                <t t-if="summary_entry_value.extra" t-out="summary_entry_value.extra"/>
            </li>
        </ul>
    </t>

`);
registerTemplate("account.AccountFileUploader", `/account/static/src/components/account_file_uploader/account_file_uploader.xml`, `<t t-name="account.AccountFileUploader" t-inherit="account.DocumentFileUploader" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-slot='toggler']" position="replace">
            <t t-if="props.togglerTemplate" t-call="{{ props.togglerTemplate }}"/>
            <t t-else="" t-slot="toggler"/>
         </xpath>
    </t>

    `);
registerTemplate("account.AccountViewUploadButton", `/account/static/src/components/account_file_uploader/account_file_uploader.xml`, `<t t-name="account.AccountViewUploadButton" xml:space="preserve">
        <AccountFileUploader>
            <t t-set-slot="toggler">
                <button type="button" class="btn btn-secondary o_button_upload_bill" data-hotkey="shift+i">
                    Upload
                </button>
            </t>
        </AccountFileUploader>
    </t>

    `);
registerTemplate("account.JournalUploadLink", `/account/static/src/components/account_file_uploader/account_file_uploader.xml`, `<t t-name="account.JournalUploadLink" xml:space="preserve">
        <t groups="account.group_account_invoice">
            <a t-att-class="props.btnClass" href="#" t-out="props.linkText"/>
        </t>
    </t>

`);
registerTemplate("account.AccountMoveFormNotebook", `/account/static/src/components/account_move_form/account_move_form_notebook.xml`, `<t t-name="account.AccountMoveFormNotebook" t-inherit="web.Notebook" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//a[@class='nav-link']" position="attributes">
            <attribute name="t-on-click.prevent">() =&gt; this.changeTabTo(navItem[0])</attribute>
            <attribute name="tabindex">-1</attribute>
        </xpath>
    </t>
`);
registerTemplate("account.AccountPaymentField", `/account/static/src/components/account_payment_field/account_payment.xml`, `<t t-name="account.AccountPaymentField" xml:space="preserve">
        <div>
            <t t-set="info" t-value="this.getInfo()"/>
            <t t-if="info.outstanding">
                <div>
                    <strong class="float-start" id="outstanding" t-out="info.title"/>
                </div>
            </t>
            <table style="width:100%;">
                <t t-foreach="info.lines" t-as="line" t-key="line_index">
                    <tr>
                    <t t-if="info.outstanding">
                        <td>
                            <a title="assign to invoice" role="button" class="oe_form_field btn btn-secondary outstanding_credit_assign" t-att-data-id="line.id" style="margin-right: 0px; padding-left: 5px; padding-right: 5px;" href="#" data-bs-toggle="tooltip" t-on-click.prevent="() =&gt; this.assignOutstandingCredit(info.moveId, line.id)">Add</a>
                        </td>
                        <td style="max-width: 11em;">
                            <a t-att-title="line.formattedDate" role="button" class="oe_form_field btn btn-link open_account_move" t-on-click="() =&gt; this.openMove(line.move_id)" style="margin-right: 5px; text-overflow: ellipsis; overflow: hidden; white-space: nowrap; padding-left: 0px; width:100%; text-align:left;" data-bs-toggle="tooltip" t-att-payment-id="account_payment_id" t-out="line.journal_name"/>
                        </td>
                    </t>
                    <t t-if="!info.outstanding">
                        <td>
                           <a role="button" tabindex="0" class="js_payment_info fa fa-info-circle" t-att-index="line_index" style="margin-right:5px;" aria-label="Info" title="Journal Entry Info" data-bs-toggle="tooltip" t-on-click.stop="(ev) =&gt; this.onInfoClick(ev, line)"/>
                        </td>
                        <td t-if="!line.is_exchange">
                            <i class="o_field_widget text-start o_payment_label">Paid on <t t-out="line.formattedDate"/></i>
                        </td>
                        <td t-if="line.is_exchange" colspan="2">
                            <i class="o_field_widget text-start text-muted text-start">
                                <span class="oe_form_field oe_form_field_float oe_form_field_monetary fw-bold">
                                    <t t-out="line.amount_formatted"/>
                                </span>
                                <span> Exchange Difference</span>
                            </i>
                        </td>
                    </t>
                    <td t-if="!line.is_exchange" style="text-align:right;">
                        <span class="oe_form_field oe_form_field_float oe_form_field_monetary" style="margin-left: -10px;">
                            <t t-out="line.amount_formatted"/>
                        </span>
                    </td>
                    </tr>
                </t>
            </table>
        </div>
    </t>

    `);
registerTemplate("account.AccountPaymentPopOver", `/account/static/src/components/account_payment_field/account_payment.xml`, `<t t-name="account.AccountPaymentPopOver" xml:space="preserve">
        <div class="account_payment_popover">
            <h3 t-if="props.title" class="popover-header"><t t-out="props.title"/></h3>
            <div class="px-2">
                <div>
                    <table>
                        <tr>
                            <td class="fw-bolder">Amount:</td>
                            <td class="ps-1">
                                <t t-out="props.amount_company_currency"/>
                                <t t-if="props.amount_foreign_currency">
                                    (<span class="fa fa-money"/> <t t-out="props.amount_foreign_currency"/>)
                                </t>
                            </td>
                        </tr>
                        <tr>
                            <td class="fw-bolder align-top">Memo:</td>
                            <td class="ps-1">
                                <div class="o_memo_content" t-att-data-tooltip="props.ref" data-tooltip-position="left">
                                    <t t-out="props.ref"/>
                                </div>
                            </td>
                        </tr>
                        <tr>
                            <td class="fw-bolder">Date:</td>
                            <td class="ps-1"><t t-out="props.date"/></td>
                        </tr>
                        <tr>
                            <td class="fw-bolder">Journal:</td>
                            <td class="ps-1">
                                <t t-out="props.journal_name"/>
                                <span t-if="props.payment_method_name">
                                    (<t t-out="props.payment_method_name"/>)
                                </span>
                            </td>
                        </tr>
                        <tr t-if="props.company_name">
                            <td class="fw-bolder">Branch:</td>
                            <td class="ps-1"><t t-out="props.company_name"/></td>
                        </tr>
                    </table>
                </div>
                <button class="btn btn-sm btn-primary js_unreconcile_payment float-start" t-if="!props.is_exchange" style="margin-top:5px; margin-bottom:5px;" groups="account.group_account_invoice" t-on-click="() =&gt; props._onRemoveMoveReconcile(props.move_id, props.partial_id)">Unreconcile</button>
                <button class="btn btn-sm btn-secondary js_open_payment float-end" style="margin-top:5px; margin-bottom:5px;" t-on-click="() =&gt; props._onOpenMove(props.move_id)">View</button>
            </div>
        </div>
    </t>

`);
registerTemplate("account.AccountPaymentRegisterHtmlField", `/account/static/src/components/account_payment_register_html/account_payment_register_html.xml`, `<t t-name="account.AccountPaymentRegisterHtmlField" t-inherit="web_editor.HtmlField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[@t-ref='readonlyElement']" position="attributes">
            <attribute name="t-on-click">switchInstallmentsAmount</attribute>
        </xpath>
    </t>
`);
registerTemplate("account.ResequenceRenderer", `/account/static/src/components/account_resequence/account_resequence.xml`, `<t t-name="account.ResequenceRenderer" xml:space="preserve">
            <t t-set="value" t-value="this.getValue()"/>
            <table t-if="value.changeLines.length" class="table table-sm">
                <thead><tr>
                    <th>Date</th>
                    <th>Before</th>
                    <th>After</th>
                </tr></thead>
                <tbody>
                    <t t-foreach="value.changeLines" t-as="changeLine" t-key="changeLine.id">
                        <ChangeLine changeLine="changeLine" ordering="value.ordering"/>
                    </t>
                </tbody>
            </table>
    </t>

    `);
registerTemplate("account.ResequenceChangeLine", `/account/static/src/components/account_resequence/account_resequence.xml`, `<t t-name="account.ResequenceChangeLine" xml:space="preserve">
        <tr>
            <td t-out="props.changeLine.date"/>
            <td t-out="props.changeLine.current_name"/>
            <td t-if="props.ordering == 'keep'" t-out="props.changeLine.new_by_name" t-attf-class="{{ props.changeLine.new_by_name != props.changeLine.new_by_date ? 'animate' : ''}}"/>
            <td t-else="" t-out="props.changeLine.new_by_date" t-attf-class="{{ props.changeLine.new_by_name != props.changeLine.new_by_date ? 'animate' : ''}}"/>
        </tr>
    </t>
`);
registerTemplate("account.MoveStatusBarSecuredField.ItemLabel", `/account/static/src/components/account_statusbar_secured/account_move_statusbar_secured.xml`, `<t t-name="account.MoveStatusBarSecuredField.ItemLabel" xml:space="preserve">
        <span t-esc="item.label"/>
        <t t-if="item.value == 'posted'">
            <i t-attf-class="fa fa-fw ms-1 #{isSecured ? 'fa-lock text-success' : 'fa-unlock text-warning'}"/>
        </t>
    </t>

    `);
registerTemplate("account.MoveStatusBarSecuredField.Dropdown", `/account/static/src/components/account_statusbar_secured/account_move_statusbar_secured.xml`, `<t t-name="account.MoveStatusBarSecuredField.Dropdown" t-inherit="web.StatusBarField.Dropdown" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[@t-esc='item.label']" position="replace">
            <t t-call="account.MoveStatusBarSecuredField.ItemLabel"/>
        </xpath>
    </t>

    `);
registerTemplate("account.MoveStatusBarSecuredField", `/account/static/src/components/account_statusbar_secured/account_move_statusbar_secured.xml`, `<t t-name="account.MoveStatusBarSecuredField" t-inherit="web.StatusBarField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//*[@t-call='web.StatusBarField.Dropdown']" position="attributes">
            <attribute name="t-call">account.MoveStatusBarSecuredField.Dropdown</attribute>
        </xpath>

        <xpath expr="//*[@t-esc='item.label']" position="inside">
            <t t-call="account.MoveStatusBarSecuredField.ItemLabel"/>
        </xpath>
        <xpath expr="//*[@t-esc='item.label']" position="attributes">
            <attribute name="t-esc"/>
        </xpath>

        <xpath expr="//*[@t-out='getCurrentLabel()']" position="replace">
            <t t-set="item" t-value="currentItem"/>
            <t t-call="account.MoveStatusBarSecuredField.ItemLabel"/>
        </xpath>
    </t>
`);
registerTemplate("account.AccountTypeSelection", `/account/static/src/components/account_type_selection/account_type_selection.xml`, `<t t-name="account.AccountTypeSelection" t-inherit="web.SelectionField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-foreach='options']" position="replace">
            <t t-foreach="hierarchyOptions" t-as="group" t-key="group_index">
                <optgroup t-att-label="group.name">
                    <t t-if="!!group.children">
                        <t t-foreach="group.children" t-as="child" t-key="child[0]">
                            <option t-att-selected="child[0] === value" t-att-value="stringify(child[0])" t-out="child[1]"/>
                        </t>
                    </t>
                </optgroup>
            </t>
        </xpath>
    </t>

`);
registerTemplate("account.ActionableErrors", `/account/static/src/components/actionable_errors/actionable_errors.xml`, `<t t-name="account.ActionableErrors" xml:space="preserve">
        <t t-if="this.sortedActionableErrors">
            <div class="mb-2 rounded-2 overflow-hidden d-grid gap-2">
                <t t-foreach="this.sortedActionableErrors" t-as="error" t-key="error">
                    <t t-set="level" t-value="error_value.level || 'warning'"/>
                    <div t-att-class="\`alert alert-\${level} m-0 p-1 ps-3\`" role="alert">
                        <div t-att-name="error" style="white-space: pre-wrap;">
                            <t t-out="error_value.message"/>
                            <a class="fw-bold" t-if="error_value.action" href="#" t-on-click.prevent="() =&gt; this.handleOnClick(error_value)">
                                <i class="oi oi-arrow-right ms-1"/>
                                <span class="ms-1" t-out="error_value.action_text"/>
                                <i t-if="level === 'danger'" class="fa fa-warning ms-1"/>
                            </a>
                        </div>
                    </div>
                </t>
            </div>
        </t>
    </t>
`);
registerTemplate("account.BillGuide", `/account/static/src/components/bill_guide/bill_guide.xml`, `<t t-name="account.BillGuide" xml:space="preserve">
        <div class="d-flex flex-row bill_guide_container mb-3">
            <div class="bill_guide_left flex-shrink-0 py-3">
                <div class="text-center">
                    <img class="img-fluid" src="/web/static/img/folder.svg"/>
                </div>
                <div class="text-center mt-2">
                    <span class="btn account_drag_drop_btn pe-none">Drag &amp; drop</span>
                    <div>
                        <span class="btn pe-none px-1 fw-normal">or</span>
                        <a class="btn btn-link px-0 fw-normal" href="#" type="object" name="action_create_vendor_bill" journal_type="purchase" groups="account.group_account_invoice" t-on-click="() =&gt; this.handleButtonClick('action_create_vendor_bill')">
                            try our sample
                        </a>
                    </div>
                </div>
            </div>
            <div class="separator_wrapper d-flex justify-content-center flex-shrink-1">
                <div class="word-separator d-flex flex-column align-items-center">
                    <div class="vertical-line border-start flex-grow-1 mt-2"/>
                    <div class="m-2">
                        or
                    </div>
                    <div class="vertical-line border-start flex-grow-1 mb-2"/>
                </div>
            </div>
            <div class="bill_guide_right flex-shrink-0 py-3">
                <div t-if="alias">
                    <div class="text-center">
                        <img class="img-fluid" src="/account/static/src/img/Bill.svg" alt="Email bills"/>
                    </div>
                    <div class="text-center mt-2">
                        <div class="">
                            <span class="btn pe-none px-1 fw-normal">Send a bill to</span>
                            <a class="btn btn-link px-0 fw-normal" t-attf-href="mailto:{{alias}}" t-out="alias"/>
                        </div>
                        <div>
                            <span class="btn pe-none px-1 fw-normal">or</span>
                            <a href="#" type="object" class="btn btn-link px-0 fw-normal" t-on-click="() =&gt; this.handleButtonClick('action_create_new')" groups="account.group_account_invoice">
                                Create manually
                            </a>
                        </div>
                    </div>
                </div>
                <div t-else="">
                    <div class="text-center">
                        <img class="img-fluid" src="/web/static/img/bill.svg" alt="Create bill manually"/>
                    </div>
                    <div class="text-center mt-2">
                        <div class="">
                            <a href="#" type="object" class="o_invoice_new" t-on-click="() =&gt; this.handleButtonClick('action_create_new')" groups="account.group_account_invoice">
                                Create a bill manually
                            </a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </t>

`);
registerTemplate("account.CharWithPlaceholderField", `/account/static/src/components/char_with_placeholder_field/char_with_placeholder_field.xml`, `<t t-name="account.CharWithPlaceholderField" t-inherit="web.CharField" xml:space="preserve">
        <xpath expr="//span" position="attributes">
            <attribute name="t-att-class">{'text-muted': !this.props.record.data[props.name]}</attribute>
        </xpath>
    </t>

`);
registerTemplate("account.DocumentFileUploader", `/account/static/src/components/document_file_uploader/document_file_uploader.xml`, `<t t-name="account.DocumentFileUploader" xml:space="preserve">
        <FileUploader acceptedFileExtensions="props.acceptedFileExtensions" fileUploadClass="'document_file_uploader'" multiUpload="true" onUploaded.bind="onFileUploaded" onUploadComplete.bind="onUploadComplete">
            <t t-set-slot="toggler">
                <t t-slot="toggler"/>
            </t>
            <t t-slot="default"/>
        </FileUploader>
    </t>

    `);
registerTemplate("account.DocumentViewUploadButton", `/account/static/src/components/document_file_uploader/document_file_uploader.xml`, `<t t-name="account.DocumentViewUploadButton" xml:space="preserve">
        <DocumentFileUploader resModel="props.resModel">
            <t t-set-slot="toggler">
                <button type="button" class="btn btn-secondary" data-hotkey="shift+i">
                    Upload
                </button>
            </t>
        </DocumentFileUploader>
    </t>

`);
registerTemplate("account.DocumentStatePopover", `/account/static/src/components/document_state/document_state_field.xml`, `<t t-name="account.DocumentStatePopover" xml:space="preserve">
        <div class="row m-2 mt-4 justify-content-between account_document_state_popover">
            <span class="col-10" t-out="props.message" style="white-space: pre-wrap;"/>
            <button class="col-2 btn p-0 account_document_state_popover_clone" t-on-click="() =&gt; props.copyText()">
                <i class="fa fa-clone"/>
            </button>
        </div>
    </t>

    `);
registerTemplate("account.DocumentState", `/account/static/src/components/document_state/document_state_field.xml`, `<t t-name="account.DocumentState" t-inherit="web.SelectionField" t-inherit-mode="primary" xml:space="preserve">
        <span position="after">
            <span t-if="message"> </span>
            <a t-if="message" t-on-click="(ev) =&gt; this.showMessagePopover(ev)" class="fa fa-info-circle"/>
        </span>
    </t>
`);
registerTemplate("account.GroupedListTemplate", `/account/static/src/components/grouped_view_widget/grouped_view_widget.xml`, `<t t-name="account.GroupedListTemplate" xml:space="preserve">
        <t t-set="value" t-value="this.getValue()"/>
        <table t-if="value.groups_vals.length" class="table table-sm o_list_table table table-sm table-hover table-striped o_list_table_grouped">
            <thead><tr>
                <t t-foreach="value.options.columns" t-as="col" t-key="col_index">
                    <th t-out="col['label']" t-attf-class="{{col['class']}}"/>
                </t>
            </tr></thead>
            <t t-foreach="value.groups_vals" t-as="group_vals" t-key="group_vals_index">
                <ListGroup group_vals="group_vals" options="value.options"/>
            </t>
        </table>
        <t t-if="value.options.discarded_number">
            <span><t t-out="value.options.discarded_number"/> are not shown in the preview</span>
        </t>
    </t>

    `);
registerTemplate("account.GroupedItemsTemplate", `/account/static/src/components/grouped_view_widget/grouped_view_widget.xml`, `<tbody t-name="account.GroupedItemsTemplate" xml:space="preserve">
        <tr style="background-color: #dee2e6;">
            <td t-attf-colspan="{{props.options.columns.length}}">
                <t t-out="props.group_vals.group_name"/>
            </td>
        </tr>
        <t t-foreach="props.group_vals.items_vals" t-as="item_vals" t-key="item_vals_index">
            <ListItem item_vals="item_vals[2]" options="props.options"/>
        </t>
    </tbody>

    `);
registerTemplate("account.GroupedItemTemplate", `/account/static/src/components/grouped_view_widget/grouped_view_widget.xml`, `<tr t-name="account.GroupedItemTemplate" xml:space="preserve">
        <t t-foreach="props.options.columns" t-as="col" t-key="col_index">
            <td t-out="props.item_vals[col['field']]" t-attf-class="{{col['class']}}"/>
        </t>
    </tr>

    `);
registerTemplate("account.OpenMoveTemplate", `/account/static/src/components/grouped_view_widget/grouped_view_widget.xml`, `<t t-name="account.OpenMoveTemplate" xml:space="preserve">
        <a href="#" t-out="widget.value"/>
    </t>

`);
registerTemplate("account.JournalDashboardActivity", `/account/static/src/components/journal_dashboard_activity/journal_dashboard_activity.xml`, `<t t-name="account.JournalDashboardActivity" xml:space="preserve">
        <t t-foreach="info.activities" t-as="activity" t-key="activity_index">
            <div class="row">
                <div class="col o_mail_activity">
                    <a href="#" t-att-class="(activity.status == 'late' ? 'text-danger ' : ' ') + (activity.activity_category == 'tax_report' ? 'o_open_vat_report' : 'see_activity')" t-att-data-res-id="activity.res_id" t-att-data-id="activity.id" t-att-data-model="activity.res_model" t-on-click.stop.prevent="() =&gt; this.openActivity(activity)">
                        <t t-out="activity.name"/>
                    </a>
                </div>
                <div class="col text-end text-nowrap">
                    <span><t t-out="activity.date"/></span>
                </div>
            </div>
        </t>
        <a t-if="info.more_activities" class="float-end see_all_activities" href="#" t-on-click.stop.prevent="(ev) =&gt; this.openAllActivities(ev)">See all activities</a>
    </t>

`);
registerTemplate("account.JsonCheckboxes", `/account/static/src/components/json_checkboxes/json_checkboxes.xml`, `<t t-name="account.JsonCheckboxes" xml:space="preserve">
        <div aria-atomic="true">
            <t t-foreach="checkboxes" t-as="checkbox" t-key="checkbox">
                <span class="d-inline-block me-3">
                    <CheckBox id="checkbox" value="checkbox_value['checked']" disabled="checkbox_value['readonly']" onChange="(ev) =&gt; this.onChange(checkbox, ev)">
                        <t t-esc="checkbox_value['label']"/>
                    </CheckBox>
                    <i t-if="checkbox_value['question_circle']" class="fa fa-question-circle" role="img" aria-label="Warning" t-att-title="checkbox_value['question_circle']"/>
                </span>
            </t>
        </div>
    </t>

`);
registerTemplate("account.mail_attachment_file", `/account/static/src/components/mail_attachments/mail_attachments.xml`, `<t t-name="account.mail_attachment_file" t-inherit="web.Many2ManyBinaryField.attachment_preview" t-inherit-mode="primary" xml:space="preserve">

        <xpath expr="//div[hasclass('o_image_box', 'float-start')]" position="replace">
            <div class="o_image_box float-start" t-att="{                     'data-tooltip': !file.placeholder ? \`Download \${file.name}\` : undefined,                  }">
                <a t-att="{                     'href': !file.placeholder ? url : undefined,                     'aria-label': !file.placeholder ? 'Download' : undefined,                     'download': !file.placeholder ? '' : undefined,                    }">
                    <span class="o_image o_hover" style="height:15px;width:30px;" t-att-data-mimetype="file.mimetype" t-att-data-ext="ext" role="img"/>
                </a>
            </div>
        </xpath>
        <xpath expr="//div[hasclass('caption')]/a" position="replace">
            <a class="ml4" t-att="{                 'data-tooltip': !file.placeholder ? \`Download \${file.name}\` : undefined,                 'href': !file.placeholder ? url : undefined,                 'download': !file.placeholder ? '' : undefined,                }" t-esc="file.name"/>
        </xpath>

        <xpath expr="//div[hasclass('caption', 'small')]" position="replace"/>
    </t>

    `);
registerTemplate("account.mail_attachments", `/account/static/src/components/mail_attachments/mail_attachments.xml`, `<t t-name="account.mail_attachments" xml:space="preserve">
        <t t-set="data" t-value="getValue()"/>

        <div t-attf-class="oe_fileupload" aria-atomic="true">
            <div class="o_attachments">
                <t t-foreach="data" t-as="file" t-key="file.id">
                    <t t-if="!file.skip">
                        <t t-call="account.mail_attachment_file"/>
                    </t>
                </t>
            </div>
            <div t-if="!props.readonly" class="oe_add">
                <FileInput multiUpload="true" onUpload.bind="onFileUploaded" resModel="props.record.resModel" resId="props.record.resId or 0">
                    <button class="btn btn-secondary o_attach" data-tooltip="Attach">
                        <span class="fa fa-paperclip" aria-label="Attach"/> Attachments
                    </button>
                </FileInput>
            </div>
        </div>
    </t>

`);
registerTemplate("account.Onboarding", `/account/static/src/components/onboarding/onboarding.xml`, `<t t-name="account.Onboarding" xml:space="preserve">
        <div class="">
            <div class="col-auto my-1" t-foreach="recordOnboardingSteps" t-as="step" t-key="step.id">
                <i class="fa me-2 fs-5" t-att-class="{                     'fa-circle text-secondary': step.state == 'not_done',                     'fa-check-circle text-success': step.state != 'not_done',                 }"/>
                <a href="#" t-att-data-method="step.action" data-model="onboarding.onboarding.step" t-out="step.title" t-att-title="step.description" t-on-click.stop.prevent="() =&gt; this.onboardingLinkClicked(step)"/>
            </div>

        </div>
    </t>

`);
registerTemplate("account.OpenMoveWidget", `/account/static/src/components/open_move_widget/open_move_widget.xml`, `<t t-name="account.OpenMoveWidget" xml:space="preserve">
        <a href="#" t-out="props.record.data[props.name] || '/'" t-on-click.prevent.stop="(ev) =&gt; this.openMove()"/>
    </t>

`);
registerTemplate("account.ProductLabelSectionAndNoteField", `/account/static/src/components/product_label_section_and_note_field/product_label_section_and_note_field.xml`, `<t t-name="account.ProductLabelSectionAndNoteField" xml:space="preserve">
        <div class="o_field_product_label_section_and_note_cell">
            <t t-if="props.readonly">
                <t t-if="!isSectionOrNote">
                    <t t-if="!isProductClickable">
                        <span t-if="productName" t-ref="productNodeRef" class="d-flex align-items-center justify-content-between w-100">
                            <span class="text-truncate">
                                <t t-out="productName"/>
                            </span>
                        </span>
                        <span t-if="!productName and (columnIsProductAndLabel.value and !label)" t-ref="productNodeRef" class="d-flex align-items-center justify-content-between text-muted">
                            <span class="text-truncate">Search a product</span>
                        </span>
                        <t t-if="columnIsProductAndLabel.value and label">
                            <textarea class="o_input d-print-none border-0 fst-italic" rows="1" type="text" t-att-class="sectionAndNoteClasses" t-att-value="label" t-on-change="(ev) =&gt; this.updateLabel(ev.target.value)" t-ref="labelNodeRef"/>
                        </t>
                    </t>
                    <t t-else="">
                        <a t-if="(columnIsProductAndLabel.value and value) or (!columnIsProductAndLabel.value and (productName or (!productName and !label)))" class="d-flex align-items-center justify-content-between" t-attf-class="o_form_uri #{classFromDecoration}" t-att-href="value ? \`/odoo/\${urlRelation}/\${value[0]}\` : '/'" t-on-click.prevent="onClick">
                            <span t-ref="productNodeRef" class="w-100">
                                <span t-esc="productName" class="text-truncate"/>
                            </span>
                        </a>
                        <textarea t-if="(columnIsProductAndLabel.value and label) or (!columnIsProductAndLabel.value and !productName and label)" class="o_input d-print-none border-0 fst-italic" placeholder="Enter a description" readonly="1" rows="1" type="text" t-att-class="sectionAndNoteClasses" t-att-value="label" t-on-change="(ev) =&gt; this.updateLabel(ev.target.value)" t-ref="labelNodeRef"/>
                    </t>
                </t>
                <t t-else="">
                    <t t-if="props.isSection">
                        <input class="o_input text-wrap border-0 fst-italic" placeholder="Enter a description" readonly="1" type="text" t-att-class="sectionAndNoteClasses" t-att-value="label" t-on-change="(ev) =&gt; this.updateLabel(ev.target.value)" t-ref="labelNodeRef"/>
                    </t>
                    <t t-else="">
                        <textarea class="o_input d-print-none border-0 fst-italic" placeholder="Enter a description" readonly="1" rows="1" type="text" t-att-class="sectionAndNoteClasses" t-att-value="label" t-on-change="(ev) =&gt; this.updateLabel(ev.target.value)" t-ref="labelNodeRef"/>
                    </t>
                </t>
            </t>
            <t t-else="">
                <t t-if="!isSectionOrNote">
                    <div class="d-flex align-items-center justify-content-between">
                        <Many2XAutocomplete t-props="Many2XAutocompleteProps"/>
                        <button t-if="hasExternalButton" aria-label="Internal link" class="btn btn-link text-action oi o_external_button px-2" data-tooltip="Internal link" draggable="false" tabindex="-1" type="button" t-att-class="env.inDialog ? 'oi-launch' : 'oi-arrow-right'" t-on-click="onExternalBtnClick"/>
                        <button t-if="hasBarcodeButton" aria-label="Scan barcode" class="btn ms-3 o_barcode o_external_button px-2" data-tooltip="Scan barcode" draggable="false" tabindex="-1" title="Scan barcode" type="button" t-on-click="onBarcodeBtnClick"/>
                        <button t-if="columnIsProductAndLabel.value and !label" class="btn fa fa-bars text-start o_external_button px-1" data-tooltip="Click or press enter to add a description" id="labelVisibilityButtonId" type="button" t-on-click="switchLabelVisibility"/>
                    </div>
                    <t t-if="columnIsProductAndLabel.value and (label or labelVisibility.value)">
                        <textarea class="o_input d-print-none border-0 fst-italic" placeholder="Enter a description" rows="1" type="text" t-att-class="sectionAndNoteClasses" t-att-value="label" t-on-change="(ev) =&gt; this.updateLabel(ev.target.value)" t-ref="labelNodeRef"/>
                    </t>
                </t>
                <t t-else="">
                    <t t-if="props.isSection">
                        <input class="o_input text-wrap border-0 fst-italic" type="text" t-att-class="sectionAndNoteClasses" t-att-value="label" t-on-change="(ev) =&gt; this.updateLabel(ev.target.value)" t-ref="labelNodeRef"/>
                    </t>
                    <t t-else="">
                        <textarea class="o_input d-print-none border-0 fst-italic" rows="1" type="text" t-att-class="sectionAndNoteClasses" t-att-value="label" t-on-change="(ev) =&gt; this.updateLabel(ev.target.value)" t-ref="labelNodeRef"/>
                    </t>
                </t>
            </t>
            <t t-if="isPrintMode.value">
                <div class="d-none d-print-block text-wrap" t-out="label"/>
            </t>
        </div>
    </t>

    `);
registerTemplate("account.ProductLabelSectionAndNoteFieldAutocomplete", `/account/static/src/components/product_label_section_and_note_field/product_label_section_and_note_field.xml`, `<t t-name="account.ProductLabelSectionAndNoteFieldAutocomplete" t-inherit="web.Many2XAutocomplete" xml:space="preserve">
        <xpath expr="//AutoComplete[@t-else='']" position="replace">
            <t t-else="">
                <t t-if="!isSectionOrNote">
                    <AutoComplete autofocus="props.autofocus" autoSelect="props.autoSelect" dropdown="props.dropdown" id="props.id" onChange.bind="onChange" onInput.bind="onInput" onSelect.bind="onSelect" placeholder="props.placeholder" resetOnSelect="props.value === ''" sources="sources" value="props.value"/>
                </t>
                <t t-else="">
                    <input class="o_input" type="text" t-att-id="props.id" t-att-value="props.value" t-on-keydown="onKeyDown" t-ref="section_and_note_input"/>
                </t>
            </t>
        </xpath>
        <xpath expr="//span[@class='o_dropdown_button']" position="attributes">
            <attribute name="t-if">!isSectionOrNote</attribute>
        </xpath>
    </t>

`);
registerTemplate("account.sectionAndNoteListRenderer", `/account/static/src/components/section_and_note_fields_backend/section_and_note_fields_backend.xml`, `<t t-name="account.sectionAndNoteListRenderer" t-inherit="web.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//table" position="attributes">
            <attribute name="class" add="o_section_and_note_list_view" separator=" "/>
        </xpath>
    </t>

    `);
registerTemplate("account.SectionAndNoteText", `/account/static/src/components/section_and_note_fields_backend/section_and_note_fields_backend.xml`, `<t t-name="account.SectionAndNoteText" xml:space="preserve">
        <t t-component="componentToUse" t-props="props"/>
    </t>

`);
registerTemplate("account.TaxAutoComplete", `/account/static/src/components/tax_autocomplete/tax_autocomplete.xml`, `<t t-name="account.TaxAutoComplete" t-inherit="web.AutoComplete" xml:space="preserve">
        <xpath expr="//t[@t-esc='option.label']" position="replace">
            <t t-if="option.tax_scope">
                <div class="tax_autocomplete_grid">
                    <div t-esc="option.label"/>
                    <div t-esc="option.tax_scope" class="text-muted"/>
                </div>
            </t>
            <t t-else="">
                <span t-esc="option.label"/>
            </t>
        </xpath>
    </t>
`);
registerTemplate("account.TaxGroupComponent", `/account/static/src/components/tax_totals/tax_totals.xml`, `<t t-name="account.TaxGroupComponent" xml:space="preserve">
        <tr>
            <td class="o_td_label">
                <label class="o_form_label o_tax_total_label" t-out="props.taxGroup.group_name"/>
            </td>

            <td class="o_tax_group">
                <t t-if="!props.isReadonly">
                    <t t-if="['edit', 'disable'].includes(state.value)">
                        <span class="o_tax_group_edit_input" t-ref="numpadDecimal">
                            <input type="text" t-ref="taxValueInput" class="o_field_float                                 o_field_number o_input" t-att-disabled="state.value === 'disable'" t-on-change.prevent="_onChangeTaxValue" t-on-blur="_onChangeTaxValue"/>
                        </span>
                    </t>
                    <t t-else="">
                        <span class="o_tax_group_edit" t-on-click.prevent="() =&gt; this.setState('edit')">
                            <span class="o_tax_group_amount_value o_list_monetary">
                                <i class="fa fa-pencil me-2"/> <t t-out="formatMonetary(props.taxGroup.tax_amount_currency)"/>
                            </span>
                        </span>
                    </t>
                </t>
                <t t-else="">
                    <span class="o_tax_group_amount_value o_list_monetary">
                        <t t-out="formatMonetary(props.taxGroup.tax_amount_currency)" style="white-space: nowrap;"/>
                    </span>
                </t>
            </td>
        </tr>
    </t>

    `);
registerTemplate("account.TaxTotalsField", `/account/static/src/components/tax_totals/tax_totals.xml`, `<t t-name="account.TaxTotalsField" xml:space="preserve">
        <table t-if="totals" class="float-end">
            <tbody>
                <t t-foreach="totals.subtotals" t-as="subtotal" t-key="subtotal_index">
                    <tr>
                        <td class="o_td_label">
                            <label class="o_form_label o_tax_total_label" t-out="subtotal.name"/>
                        </td>

                        <td class="o_list_monetary">
                            <span t-att-name="subtotal.name" style="white-space: nowrap; font-weight: bold;" t-out="formatMonetary(subtotal.base_amount_currency)"/>
                        </td>
                    </tr>

                    <t t-foreach="subtotal.tax_groups" t-as="taxGroup" t-key="taxGroup_index">
                        <TaxGroupComponent totals="totals" subtotal="subtotal" taxGroup="taxGroup" isReadonly="readonly" onChangeTaxGroup.bind="_onChangeTaxValueByTaxGroup" invalidate.bind="invalidate"/>
                    </t>
                </t>

                <tr t-if="'cash_rounding_base_amount_currency' in totals">
                    <td class="o_td_label">
                        <label class="o_form_label o_tax_total_label">Rounding</label>
                    </td>
                    <td class="o_list_monetary">
                        <span t-out="formatMonetary(totals.cash_rounding_base_amount_currency)"/>
                    </td>
                </tr>


                <tr>
                    <td class="o_td_label">
                        <label class="o_form_label o_tax_total_label">Total</label>
                    </td>

                    <td class="o_list_monetary">
                        <span name="amount_total" t-att-class="{'oe_subtotal_footer_separator': totals.has_tax_groups}" t-out="formatMonetary(totals.total_amount_currency)" style="font-size: 1.3em; font-weight: bold; white-space: nowrap;"/>
                    </td>
                </tr>
            </tbody>
        </table>
    </t>
`);
registerTemplate("account.UploadDropZone", `/account/static/src/components/upload_drop_zone/upload_drop_zone.xml`, `<t t-name="account.UploadDropZone" xml:space="preserve">
        <t t-if="dashboardState.isDragging or props.visible">
            <div class="o_drop_area d-flex align-items-center justify-content-center flex-column" t-att-class="{                     'drag_to_card': props.visible,                 }" t-on-click="() =&gt; this.env.setDragging(false)" t-on-dragover.prevent="()=&gt;{}" t-on-dragleave="props.hideZone" t-on-drop.prevent="onDrop">
                <t t-if="props.dragIcon and props.dragText">
                    <div class="text-align-center pe-none">
                        <img class="img-fluid" t-att-src="props.dragIcon"/>
                    </div>
                    <t t-if="props.visible">
                        <div class="position-absolute upload_badge pe-none">
                            <i class="fa fa-circle fa-stack-2x text-primary"/>
                            <i class="fa fa-upload fa-stack-1x fa-inverse"/>
                        </div>
                   </t>
                    <div class="h3 pe-none" t-att-class="{'text-primary': props.visible}">
                        <t t-out="props.dragTitle"/>
                    </div>
                  <div class="pe-none">
                      <span t-att-class="{'invisible': !props.visible, 'text-primary': props.visible}">
                          <t t-out="props.dragText"/>
                      </span>
                  </div>
                </t>
                <t t-elif="props.visible">
                    <i class="fa fa-upload fa-10x pe-none"/>
                </t>
            </div>
        </t>
    </t>

`);
registerTemplate("account.X2ManyButtons", `/account/static/src/components/x2many_buttons/x2many_buttons.xml`, `<t t-name="account.X2ManyButtons" xml:space="preserve">
        <div class="d-flex align-items-center">
            <t t-foreach="this.currentField.records.slice(0, 3)" t-as="record" t-key="record.id">
                <button class="btn btn-link p-0" t-on-click="() =&gt; this.openFormAndDiscard(record.resId)" t-att-data-hotkey="\`shift+\${record_index + 1}\`" t-out="record.data.display_name"/>
                <span t-if="!record_last" class="pe-1">,</span>
            </t>
            <t t-if="this.currentField.count gt 3">
                <button class="btn btn-link p-0" t-on-click="() =&gt; this.openTreeAndDiscard()" data-hotkey="shift+4">... (View all)</button>
            </t>
        </div>
    </t>
`);
registerTemplate("account.DashboardKanbanRecord", `/account/static/src/views/account_dashboard_kanban/account_dashboard_kanban_record.xml`, `<t t-name="account.DashboardKanbanRecord" xml:space="preserve">
        <article t-att-class="getRecordClasses()" t-att-data-id="props.canResequence and props.record.id" t-att-tabindex="props.record.model.useSampleModel ? -1 : 0" t-on-click="onGlobalClick" t-on-dragenter.stop.prevent="() =&gt; dropzoneState.visible = true" t-ref="root">
            <AccountFileUploader t-if="allowDrop" record="props.record">
                <t t-set-slot="default">
                    <UploadDropZone t-props="dropzoneProps"/>
                    <t t-call="{{ templates[this.constructor.KANBAN_CARD_ATTRIBUTE] }}" t-call-context="renderingContext"/>
                </t>
            </AccountFileUploader>
            <t t-else="" t-call="{{ templates[this.constructor.KANBAN_CARD_ATTRIBUTE] }}" t-call-context="renderingContext"/>
            <t t-call="{{ this.constructor.menuTemplate }}"/>
        </article>
    </t>

`);
registerTemplate("account.DashboardKanbanRenderer", `/account/static/src/views/account_dashboard_kanban/account_dashboard_kanban_renderer.xml`, `<t t-name="account.DashboardKanbanRenderer" t-inherit="web.KanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[@t-ref='root']" position="attributes">
            <attribute name="t-on-dragenter.prevent">kanbanDragEnter</attribute>
            <attribute name="t-on-dragleave">kanbanDragLeave</attribute>
            <attribute name="t-on-drop.prevent">kanbanDragDrop</attribute>
            <attribute name="t-on-dragover.prevent">() =&gt; {}</attribute>
        </xpath>
    </t>

`);
registerTemplate("account.AccountMoveKanbanView.Buttons", `/account/static/src/views/account_move_kanban/account_move_kanban_controller.xml`, `<t t-name="account.AccountMoveKanbanView.Buttons" t-inherit="account.FileuploadKanbanView.Buttons" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-call='account.DocumentViewUploadButton']" position="replace">
            <t t-if="showUploadButton" t-call="account.AccountViewUploadButton"/>
        </xpath>
    </t>

`);
registerTemplate("account.AccountMoveListView.Buttons", `/account/static/src/views/account_move_list/account_move_list_controller.xml`, `<t t-name="account.AccountMoveListView.Buttons" t-inherit="account.FileuploadListView.Buttons" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-call='account.DocumentViewUploadButton']" position="replace">
            <t t-if="showUploadButton" t-call="account.AccountViewUploadButton"/>
        </xpath>
    </t>

`);
registerTemplate("account.AccountMoveListRenderer", `/account/static/src/views/account_move_list/account_move_list_renderer.xml`, `<t t-name="account.AccountMoveListRenderer" t-inherit="account.FileUploadListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <t t-call="web.ActionHelper" position="replace">
            <t t-if="showNoContentHelper">
                <t t-if="this.env.searchModel._context?.default_move_type == 'in_invoice'">
                    <div class="o_view_nocontent">
                        <div class="o_nocontent_help">
                            <BillGuide/>
                        </div>
                    </div>
                </t>
                <t t-else="" t-call="web.ActionHelper">
                    <t t-set="noContentHelp" t-value="props.noContentHelp"/>
                </t>
            </t>
        </t>
    </t>

`);
registerTemplate("account.FileuploadKanbanView.Buttons", `/account/static/src/views/file_upload_kanban/file_upload_kanban_controller.xml`, `<t t-name="account.FileuploadKanbanView.Buttons" t-inherit="web.KanbanView.Buttons" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_cp_buttons')]" position="inside">
            <t t-call="account.DocumentViewUploadButton"/>
        </xpath>
    </t>

`);
registerTemplate("account.FileUploadKanbanRenderer", `/account/static/src/views/file_upload_kanban/file_upload_kanban_renderer.xml`, `<t t-name="account.FileUploadKanbanRenderer" t-inherit="web.KanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[@t-ref='root']" position="before">
            <UploadDropZone visible="dropzoneState.visible" hideZone="() =&gt; dropzoneState.visible = false"/>
        </xpath>
        <xpath expr="//div[@t-ref='root']" position="attributes">
            <attribute name="t-on-dragenter.stop.prevent">onDragStart</attribute>
            <attribute name="t-on-paste">onPaste</attribute>
        </xpath>
    </t>

`);
registerTemplate("account.FileuploadListView.Buttons", `/account/static/src/views/file_upload_list/file_upload_list_controller.xml`, `<t t-name="account.FileuploadListView.Buttons" t-inherit="web.ListView.Buttons" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_list_buttons')]" position="inside">
            <t t-call="account.DocumentViewUploadButton"/>
        </xpath>
    </t>

`);
registerTemplate("account.FileUploadListRenderer", `/account/static/src/views/file_upload_list/file_upload_list_renderer.xml`, `<t t-name="account.FileUploadListRenderer" t-inherit="web.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[@t-ref='root']" position="before">
            <UploadDropZone visible="dropzoneState.visible" hideZone="() =&gt; dropzoneState.visible = false"/>
        </xpath>
        <xpath expr="//div[@t-ref='root']" position="attributes">
            <attribute name="t-on-dragenter.stop.prevent">onDragStart</attribute>
            <attribute name="t-on-paste">onPaste</attribute>
        </xpath>
    </t>

`);
registerTemplate("sale.BadgeExtraPrice", `/sale/static/src/js/badge_extra_price/badge_extra_price.xml`, `<t t-name="sale.BadgeExtraPrice" xml:space="preserve">
        <span class="badge rounded-pill border ps-1 text-bg-light">
            <span t-out="this.props.price &gt; 0 ? '+' : '-'" class="me-1"/>
            <i t-out="getFormattedPrice()"/>
        </span>
    </t>
`);
registerTemplate("sale.SaleActionHelper", `/sale/static/src/js/sale_action_helper/sale_action_helper.xml`, `<t t-name="sale.SaleActionHelper" xml:space="preserve">
        <div class="o_view_nocontent flex-wrap pt-5">
            <div class="container">
                <div class="o_nocontent_help">
                    <div>
                        <a class="o_sale_action_preview position-relative overflow-hidden d-inline-block rounded-4" role="button" t-on-click="this.openVideoPreview">
                            <i class="position-absolute top-50 start-50 translate-middle w-auto h-auto z-1 fa fa-4x fa-play-circle"/>
                            <div class="position-absolute top-0 end-0 w-100 h-100"/>
                            <img src="/sale/static/src/img/sales_quotation_thumbnail.webp" class="img w-100"/>
                        </a>
                        <t t-out="props.noContentHelp"/>
                    </div>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("sale.SaleActionHelperDialog", `/sale/static/src/js/sale_action_helper/sale_action_helper_dialog.xml`, `<t t-name="sale.SaleActionHelperDialog" xml:space="preserve">
        <Dialog bodyClass="'shadow'" contentClass="'border-0 bg-transparent shadow-none'" footer="false" size="'xl'" technical="false" withBodyPadding="false" t-on-click="props.close">
            <div class="ratio ratio-16x9">
                <iframe allow="autoplay; encrypted-media; picture-in-picture; web-share" width="1140" height="641" t-att-src="this.props.url" title="Sale" frameborder="0" allowfullscreen="1">
                    Your browser does not support iframe.
                </iframe>
            </div>
        </Dialog>
    </t>
`);
registerTemplate("sale.ComboConfiguratorDialog", `/sale/static/src/js/combo_configurator_dialog/combo_configurator_dialog.xml`, `<t t-name="sale.ComboConfiguratorDialog" xml:space="preserve">
        <Dialog title="props.display_name" contentClass="'sale-combo-configurator-dialog'">
            <div t-foreach="props.combos" t-as="combo" t-key="combo.id">
                <span name="sale_combo_configurator_title" class="d-inline-block mt-4 mb-3 h4" t-out="combo.name"/>
                <div class="combo-item-grid d-flex d-md-grid gap-4 pb-2 pb-md-0 overflow-x-auto">
                    <t t-foreach="combo.combo_items" t-as="comboItem" t-key="comboItem.id">
                        <ProductCard product="getSelectedOrProvidedComboItem(combo.id, comboItem).product" extraPrice="comboItem.extra_price" onClick="() =&gt; this.selectComboItem(combo.id, comboItem)" isSelected="state.selectedComboItems.get(combo.id)?.id === comboItem.id"/>
                    </t>
                </div>
            </div>
            <t t-set-slot="footer">
                <button name="sale_combo_configurator_confirm_button" class="btn btn-primary" t-att-disabled="!areAllCombosSelected || state.isLoading" t-on-click="confirm">
                    Confirm
                </button>
                <button name="sale_combo_configurator_cancel_button" class="btn btn-secondary" t-on-click="cancel">
                    Cancel
                </button>

                <div style="flex: 1" class="d-none d-md-block"/>
                <div t-if="this.props.options.showQuantity" class="w-100 w-md-auto mx-0 mx-md-2">
                    <QuantityButtons quantity="state.quantity" setQuantity="quantity =&gt; this.setQuantity(quantity)" isMinusButtonDisabled="state.quantity === 1" btnClasses="'d-inline-block w-auto'"/>
                </div>
                <div class="d-flex flex-column justify-content-center">
                    <span name="sale_combo_configurator_total" class="h4 mb-0" t-out="totalMessage"/>
                    <span t-if="this.props.price_info" t-out="this.props.price_info" class="text-muted"/>
                </div>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("sale.Product", `/sale/static/src/js/product/product.xml`, `<t t-name="sale.Product" xml:space="preserve">
        <td class="o_sale_product_configurator_img py-3 px-0">
            <img class="w-100" t-att-src="imageUrl" alt="Product Image"/>
        </td>
        <td class="p-3" t-att-colspan="this.props.optional ? 2:false">
            <div class="mb-4 text-break" name="o_sale_product_configurator_name">
                <span class="h5" t-out="this.props.display_name"/>
                <div t-if="this.props.description_sale" t-out="this.props.description_sale" class="text-muted small"/>
                <div t-if="!this.env.isPossibleCombination(this.props)" class="alert alert-warning mt-3">
                    <span>This option or combination of options is not available</span>
                </div>
            </div>
            <t t-foreach="this.props.attribute_lines" t-as="ptal" t-key="ptal.id">
                <PTAL t-if="shouldShowPtal(ptal)" t-props="ptal" productTmplId="this.props.product_tmpl_id"/>
            </t>
        </td>
        <td class="o_sale_product_configurator_qty py-3 px-0 text-end">
            <t t-if="!this.props.optional &amp;&amp; env.showQuantity">
                <QuantityButtons quantity="this.props.quantity" setQuantity="quantity =&gt; this.env.setQuantity(this.props.product_tmpl_id, quantity)" isMinusButtonDisabled="this.props.quantity === 1 &amp;&amp; isMainProduct"/>
            </t>
            <t t-elif="this.props.optional &amp;&amp; env.showPrice">
                <t t-call="sale.product_price" name="sale_product_configurator_optional_price"/>
            </t>
            <a class="d-block mt-2" role="button" t-if="!this.props.optional &amp;&amp; !isMainProduct" t-on-click="() =&gt; this.env.removeProduct(this.props.product_tmpl_id)">
                Remove
            </a>
        </td>
        <td class="o_sale_product_configurator_price py-3 px-0 text-end" name="price">
            <t t-if="!this.props.optional &amp;&amp; env.showPrice">
                <t t-call="sale.product_price" name="sale_product_configurator_price"/>
            </t>
            <t t-elif="this.props.optional">
                <button name="sale_product_configurator_add_button" class="btn btn-secondary" t-att-class="{'disabled': !this.env.isPossibleCombination(this.props)}" t-on-click="() =&gt; this.env.addProduct(this.props.product_tmpl_id)">
                    <i class="fa fa-plus" role="img"/>
                    <span class="ms-2 d-none d-md-inline">Add</span>
                </button>
            </t>
        </td>
    </t>

    `);
registerTemplate("sale.product_price", `/sale/static/src/js/product/product.xml`, `<t t-name="sale.product_price" xml:space="preserve">
        <span name="sale_product_configurator_formatted_price" class="h5 text-nowrap" t-out="getFormattedPrice()"/>
        <div t-if="this.props.price_info" t-out="this.props.price_info" class="text-muted"/>
    </t>
`);
registerTemplate("sale.ProductCard", `/sale/static/src/js/product_card/product_card.xml`, `<t t-name="sale.ProductCard" xml:space="preserve">
        <article tabindex="0" t-attf-class="product-card card flex-shrink-0 w-md-auto w-50 rounded cursor-pointer {{props.isSelected ? 'selected' : ''}}" t-on-keypress="(event) =&gt; event.code === 'Space' ? props.onClick() : () =&gt; {}" t-on-click="props.onClick">
            <div class="card-header p-0">
                <img class="w-100" t-att-src="props.product.image_src || \`/web/image/product.product/\${props.product.id}/image_256\`" alt="Product Image"/>
            </div>
            <div class="card-body">
                <div class="card-title" t-out="props.product.display_name"/>
                <div class="card-subtitle text-muted">
                    <div t-foreach="props.product.ptals.filter(shouldShowPtal)" t-as="ptal" t-key="ptal.id" t-out="ptal.ptalDisplayName"/>
                </div>
                <BadgeExtraPrice t-if="props.extraPrice" price="props.extraPrice" currencyId="env.currency.id"/>
            </div>
        </article>
    </t>
`);
registerTemplate("sale.ProductConfiguratorDialog", `/sale/static/src/js/product_configurator_dialog/product_configurator_dialog.xml`, `<t t-name="sale.ProductConfiguratorDialog" xml:space="preserve">
        <Dialog size="size" title="title" contentClass="'o_sale_product_configurator_dialog'">
            <ProductList t-if="this.state.products.length" products="this.state.products"/>
            <ProductList t-if="this.state.optionalProducts.length" products="this.state.optionalProducts" areProductsOptional="true"/>
            <t t-set-slot="footer">
                <button name="sale_product_configurator_confirm_button" class="btn btn-primary" t-on-click="onConfirm" t-att-disabled="!isPossibleConfiguration()">
                    Confirm
                </button>
                <button name="sale_product_configurator_cancel_button" class="btn btn-secondary" t-on-click="onDiscard">
                    Cancel
                </button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("sale.ProductList", `/sale/static/src/js/product_list/product_list.xml`, `<t t-name="sale.ProductList" xml:space="preserve">
        <span name="sale_product_configurator_list_title" class="d-inline-block mt-4 mb-3 h4" t-if="this.props.areProductsOptional" t-out="optionalProductsTitle"/>
        <table class="o_sale_product_configurator_table table table-sm position-relative mb-0" t-att-class="{'o_sale_product_configurator_table_optional': this.props.areProductsOptional}">
            <thead t-if="!this.props.areProductsOptional">
                <tr>
                    <th class="px-0 border-bottom-0" colspan="2">Product</th>
                    <th class="px-0 text-center border-bottom-0" t-if="env.showQuantity">Quantity</th>
                    <th class="px-0 text-end border-bottom-0" t-if="env.showPrice" t-att-colspan="env.showQuantity ? 1 : 2">
                        Price
                    </th>
                </tr>
            </thead>
            <tbody class="border-top-0">
                <tr t-foreach="this.props.products" t-as="product" t-key="product.product_tmpl_id">
                    <Product t-props="product" optional="this.props.areProductsOptional"/>
                </tr>
                <tr t-if="!this.props.areProductsOptional &amp;&amp; env.showPrice">
                    <td colspan="4" class="text-end">
                        <span name="sale_product_configurator_list_total" class="h4" t-out="totalMessage"/>
                    </td>
                </tr>
            </tbody>
        </table>
    </t>
`);
registerTemplate("sale.ProductTemplateAttributeLine", `/sale/static/src/js/product_template_attribute_line/product_template_attribute_line.xml`, `<t t-name="sale.ProductTemplateAttributeLine" xml:space="preserve">
        <div name="ptal" t-attf-class="#{this.props.attribute_values.length === 1 &amp;&amp; hasPTAVCustom() ? 'd-flex' : ''}">

            <div class="d-flex flex-column flex-lg-row gap-2 mb-2">
                <label t-if="showValuesChoice || isSelectedPTAVCustom()" t-out="this.props.attribute.name" t-attf-class="fw-bold text-break #{this.props.attribute_values.length === 1                         &amp;&amp; hasPTAVCustom() ? '' : 'col-lg-3'}"/>
                <t t-if="showValuesChoice" t-call="{{getPTAVTemplate()}}"/>
            </div>
            <input class="o_input w-lg-75 mb-4 ms-lg-auto" type="text" t-att-placeholder="customValuePlaceholder" t-if="hasPTAVCustom &amp;&amp; isSelectedPTAVCustom()" t-att-value="this.props.customValue" t-on-change="updateCustomValue"/>
        </div>
    </t>

    `);
registerTemplate("sale.ptav_select", `/sale/static/src/js/product_template_attribute_line/product_template_attribute_line.xml`, `<t t-name="sale.ptav_select" xml:space="preserve">
        <select class="o_input w-lg-50 flex-grow-1" t-on-change="updateSelectedPTAV" t-att-name="'ptal-' + this.props.id">
            <option t-foreach="this.props.attribute_values" t-as="ptav" t-key="ptav.id" t-att-value="ptav.id" t-att-selected="this.props.selected_attribute_value_ids.includes(ptav.id)" t-out="getPTAVSelectName(ptav)" t-att-class="{ 'css_not_available': ptav.excluded }"/>
        </select>
    </t>
    `);
registerTemplate("sale.ptav_radio", `/sale/static/src/js/product_template_attribute_line/product_template_attribute_line.xml`, `<t t-name="sale.ptav_radio" xml:space="preserve">
        <ul class="list-unstyled flex-grow-1 m-0">
            <li t-foreach="this.props.attribute_values" t-as="ptav" t-key="ptav.id" class="mb-2">
                <div class="form-check">
                    <label class="form-check-label d-inline-flex align-items-center flex-wrap" t-att-class="{ 'css_not_available': ptav.excluded }" t-attf-for="ptav-{{ptav.id}}-input">
                        <span class="me-1" t-out="ptav.name"/>
                        <BadgeExtraPrice t-if="ptav.price_extra" price="ptav.price_extra" currencyId="this.env.currency.id"/>
                    </label>
                    <input type="radio" class="form-check-input" t-attf-id="ptav-{{ptav.id}}-input" t-att-value="ptav.id" t-att-checked="this.props.selected_attribute_value_ids.includes(ptav.id)" t-att-name="'ptal-' + this.props.id" t-on-change="updateSelectedPTAV"/>
                </div>
            </li>
        </ul>
    </t>
    `);
registerTemplate("sale.ptav_pills", `/sale/static/src/js/product_template_attribute_line/product_template_attribute_line.xml`, `<t t-name="sale.ptav_pills" xml:space="preserve">
         <ul class="list-inline list-unstyled flex-grow-1 mb-0">
            <li t-foreach="this.props.attribute_values" t-as="ptav" t-key="ptav.id" t-att-class="{'active': this.props.selected_attribute_value_ids.includes(ptav.id)}" class="o_sale_product_configurator_ptav_pills list-inline-item">
                <label class="btn btn-outline-secondary" t-att-class="{ 'css_not_available': ptav.excluded }" t-attf-for="ptav-{{ptav.id}}-input">
                    <span t-out="ptav.name"/>
                    <BadgeExtraPrice t-if="ptav.price_extra" price="ptav.price_extra" currencyId="this.env.currency.id"/>
                </label>
                <input class="btn-check" type="radio" t-attf-id="ptav-{{ptav.id}}-input" t-att-value="ptav.id" t-att-name="'ptal-' + this.props.id" t-att-checked="this.props.selected_attribute_value_ids.includes(ptav.id)" t-on-change="updateSelectedPTAV"/>
            </li>
        </ul>
    </t>
    `);
registerTemplate("sale.ptav_color", `/sale/static/src/js/product_template_attribute_line/product_template_attribute_line.xml`, `<t t-name="sale.ptav_color" xml:space="preserve">
        <ul class="list-inline flex-grow-1 mb-0">
            <li t-foreach="this.props.attribute_values" t-as="ptav" t-key="ptav.id" class="list-inline-item me-2">
                <t t-set="img_style" t-value="ptav.image ? 'background:url(/web/image/product.template.attribute.value/'+ptav.id+'/image); background-size:cover;' : ''"/>
                <t t-set="color_style" t-value="ptav.is_custom ? '' : 'background-color:' + ptav.html_color"/>
                <label class="position-relative d-inline-block rounded-pill text-center" t-att-title="ptav.name" t-attf-style="#{img_style or color_style}" t-att-class="{'o_sale_product_configurator_ptav_color': true,                                   'active': this.props.selected_attribute_value_ids.includes(ptav.id),                                   'custom_value': ptav.is_custom,                                   'transparent': !ptav.is_custom and !ptav.html_color,                                   'css_not_available': ptav.excluded }">
                    <input type="radio" t-attf-id="ptav-{{ptav.id}}-input" t-att-value="ptav.id" t-att-name="'ptal-' + this.props.id" t-att-checked="this.props.selected_attribute_value_ids.includes(ptav.id)" t-on-change="updateSelectedPTAV"/>
                </label>
            </li>
        </ul>
    </t>
    `);
registerTemplate("sale.ptav_multi", `/sale/static/src/js/product_template_attribute_line/product_template_attribute_line.xml`, `<t t-name="sale.ptav_multi" xml:space="preserve">
         <ul class="list-unstyled flex-grow-1 m-0">
            <li t-foreach="this.props.attribute_values" t-as="ptav" t-key="ptav.id" class="mb-2">
                <div class="form-check">
                    <input type="checkbox" class="form-check-input" t-attf-id="ptav-{{ptav.id}}-input" t-att-value="ptav.id" t-att-name="'ptal-' + this.props.id" t-att-checked="this.props.selected_attribute_value_ids.includes(ptav.id)" t-on-change="updateSelectedPTAV"/>
                    <label class="form-check-label" t-attf-for="ptav-{{ptav.id}}-input">
                        <span t-out="ptav.name"/>
                        <BadgeExtraPrice t-if="ptav.price_extra" price="ptav.price_extra" currencyId="this.env.currency.id"/>
                    </label>
                </div>
            </li>
        </ul>
    </t>
`);
registerTemplate("sale.QuantityButtons", `/sale/static/src/js/quantity_buttons/quantity_buttons.xml`, `<t t-name="sale.QuantityButtons" xml:space="preserve">
        <div name="quantity_buttons_wrapper" class="input-group justify-content-center">
            <button t-attf-class="btn btn-secondary {{ props.btnClasses or 'd-none d-md-inline-block' }}" name="sale_quantity_button_minus" aria-label="Remove one" t-att-disabled="props.isMinusButtonDisabled" t-on-click="decreaseQuantity">
                <i class="fa fa-minus"/>
            </button>
            <input class="form-control quantity text-center" name="sale_quantity" type="number" t-att-value="props.quantity" t-on-change="setQuantity"/>
            <button t-attf-class="btn btn-secondary {{ props.btnClasses or 'd-none d-md-inline-block' }}" name="sale_quantity_button_plus" aria-label="Add one" t-att-disabled="props.isPlusButtonDisabled" t-on-click="increaseQuantity">
                <i class="fa fa-plus"/>
            </button>
        </div>
    </t>
`);
registerTemplate("sale.ListRenderer.RecordRow", `/sale/static/src/js/sale_order_line_field/sale_order_line_field.xml`, `<t t-name="sale.ListRenderer.RecordRow" t-inherit="web.ListRenderer.RecordRow" t-inherit-mode="primary" xml:space="preserve">

        <Field position="attributes">
            <attribute name="t-if">
                !((isCombo(record) || isComboItem(record)) &amp;&amp; column.widget === 'handle')
            </attribute>
        </Field>

        <xpath expr="//td[hasclass('o_list_record_remove')]" position="attributes">
            <attribute name="t-att-class">{'d-none': isComboItem(record)}</attribute>
        </xpath>
    </t>
`);
registerTemplate("sale.SaleProductField", `/sale/static/src/xml/sale_product_field.xml`, `<t t-name="sale.SaleProductField" t-inherit="account.ProductLabelSectionAndNoteField" t-inherit-mode="primary" xml:space="preserve">

        <xpath expr="//button[@t-if='hasExternalButton']" position="before">
            <t t-if="hasConfigurationButton">
                <button type="button" class="btn btn-secondary fa fa-pencil px-2" tabindex="-1" draggable="false" t-att-aria-label="configurationButtonHelp" t-att-data-tooltip="configurationButtonHelp" t-on-click="onEditConfiguration"/>
            </t>
        </xpath>

        <t t-out="productName" position="after">
            <t t-if="isCombo">
                x <t t-out="props.record.data.product_uom_qty"/>
            </t>
        </t>
        <span t-esc="productName" class="text-truncate" position="after">
            <t t-if="isCombo">
                x <t t-out="props.record.data.product_uom_qty"/>
            </t>
        </span>
    </t>

`);
registerTemplate("sale.SaleProgressBarField", `/sale/static/src/xml/sales_team_progress_bar_template.xml`, `<t t-name="sale.SaleProgressBarField" xml:space="preserve">
        <t t-if="state.isInvoicingTargetDefined">
            <t t-call="web.ProgressBarField"/>
        </t>
        <t t-else="">

            <a t-on-click.prevent="defineInvoicingTarget" href="#" class="sale_progressbar_form_link">
                Click to define an invoicing target
            </a>
        </t>
    </t>

`);
registerTemplate("sale.SaleKanbanRenderer", `/sale/static/src/views/sale_onboarding_kanban/sale_onboarding_kanban_renderer.xml`, `<t t-name="sale.SaleKanbanRenderer" t-inherit="account.FileUploadKanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <t t-if="showNoContentHelper" position="replace">
            <t t-if="showNoContentHelper">
                <SaleActionHelper noContentHelp="props.noContentHelp"/>
            </t>
        </t>
    </t>
`);
registerTemplate("sale.SaleListRenderer", `/sale/static/src/views/sale_onboarding_list/sale_onboarding_list_renderer.xml`, `<t t-name="sale.SaleListRenderer" t-inherit="account.FileUploadListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <t t-call="web.ActionHelper" position="replace">
            <t t-if="showNoContentHelper">
                <SaleActionHelper noContentHelp="props.noContentHelp"/>
            </t>
        </t>
    </t>
`);
registerTemplateExtension("mail.ActivityListPopoverItem", `/calendar/static/src/activity/activity_list_popover_item_patch.xml`, `<t t-inherit="mail.ActivityListPopoverItem" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//button[hasclass('o-mail-ActivityListPopoverItem-editbtn')]" position="after">
            <button t-if="props.activity.calendar_event_id" class="o-mail-ActivityListPopoverItem-editbtn btn btn-sm btn-success btn-link" t-on-click="onClickReschedule">
                <i class="fa fa-calendar"/>
            </button>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.ActivityMenu", `/calendar/static/src/activity/activity_menu_patch.xml`, `<t t-inherit="mail.ActivityMenu" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@name='activityTitle']" position="after">
            <div t-if="group.type === 'meeting'">
                <t t-set="is_next_meeting" t-value="true"/>
                <t t-foreach="group.meetings" t-as="meeting" t-key="meeting.id">
                    <div class="o-calendar-meeting d-flex px-2">
                        <span class="flex-grow-1 text-truncate" t-att-class="!meeting.allday and is_next_meeting ? 'fw-bold' : ''" t-esc="meeting.name"/>
                        <span t-if="meeting.formattedStart">
                            <t t-if="meeting.allday">All Day</t>
                            <t t-else="">
                                <t t-set="is_next_meeting" t-value="false"/>
                                <t t-esc="meeting.formattedStart"/>
                            </t>
                        </span>
                    </div>
                </t>
            </div>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.Activity", `/calendar/static/src/activity/activity_patch.xml`, `<t t-inherit="mail.Activity" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//button[hasclass('o-mail-Activity-edit')]" position="attributes">
            <attribute name="t-if">!props.activity.calendar_event_id</attribute>
        </xpath>
        <xpath expr="//button[hasclass('o-mail-Activity-edit')]" position="after">
            <button t-if="props.activity.calendar_event_id" class="btn btn-link p-0 me-3" t-on-click="onClickReschedule">
                <i class="fa fa-calendar"/> Reschedule
            </button>
        </xpath>
    </t>

`);
registerTemplate("calendar.CalendarConnectProvider", `/calendar/static/src/components/calendar_provider_config/calendar_connect_provider.xml`, `<t t-name="calendar.CalendarConnectProvider" xml:space="preserve">
        <a role="button" title="Connect" class="o_calendar_activate_external_cal btn btn-primary" t-on-click="onConnect">Connect</a>
    </t>
`);
registerTemplate("calendar.AskRecurrenceUpdatePolicyDialog", `/calendar/static/src/views/ask_recurrence_update_policy_dialog.xml`, `<t t-name="calendar.AskRecurrenceUpdatePolicyDialog" xml:space="preserve">
        <Dialog size="'sm'" title.translate="Edit Recurrent event">
            <t t-foreach="Object.entries(possibleValues)" t-as="value" t-key="value[0]">
                <t t-set="name" t-value="value[0]"/>
                <t t-set="state" t-value="value[1]"/>
                <div class="form-check o_radio_item">
                    <input name="recurrence-update" type="radio" class="form-check-input o_radio_input" t-att-checked="state.checked" t-att-value="name" t-att-id="name" t-on-click="(ev) =&gt; this.selected = ev.target.value"/>
                    <label class="form-check-label o_form_label" t-att-for="name" t-esc="state.label"/>
                </div>
            </t>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="confirm">
                    Confirm
                </button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("calendar.AttendeeCalendarController", `/calendar/static/src/views/attendee_calendar/attendee_calendar_controller.xml`, `<t t-name="calendar.AttendeeCalendarController" t-inherit="web.CalendarController" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//Layout" position="inside">
            <t t-set-slot="control-panel-create-button">
                <button class="btn btn-primary o-calendar-button-new me-1" t-on-click="onClickAddButton">New</button>
            </t>
        </xpath>

        <xpath expr="//Layout//div[hasclass('o_calendar_container')]//h5[hasclass('d-inline-flex')]" position="after">
            <div id="header_synchronization_settings" class="mx-2 ms-lg-auto">
                <t t-if="(model.credentialStatus.google_calendar or model.credentialStatus.microsoft_calendar)                 and (!model.syncStatus.google_calendar or ['sync_stopped', 'missing_credentials'].includes(model.syncStatus.google_calendar))                 and (!model.syncStatus.microsoft_calendar or ['sync_stopped', 'missing_credentials'].includes(model.syncStatus.microsoft_calendar))">
                    <h5 id="synchronize_with" class="d-inline-flex">Synchronize with</h5>
                </t>
                <t t-elif="(model.googleCredentialsSet and model.syncStatus.google_calendar == 'sync_active')                 or (model.microsoftCredentialsSet and model.syncStatus.microsoft_calendar == 'sync_active')">
                    <div id="google_calendar_sync" class="o_calendar_sync mx-1 d-inline-flex">
                        <button class="btn text-nowrap" t-on-click="model.syncStatus.google_calendar == 'sync_active' ? onStopGoogleSynchronization : onStopMicrosoftSynchronization">
                            <div>
                                <i id="check_symbol" class="fa fa-check px-1 o_text_green o_calendar_check"/>
                                <i id="stop_symbol" class="fa fa-square px-1 o_text_red o_calendar_stop"/>
                                <span id="check_text" class="o_calendar_check">
                                    <t t-if="model.syncStatus.google_calendar == 'sync_active'">Google</t>
                                    <t t-else="">Outlook</t>
                                </span>
                                <span id="stop_text" class="o_text_red o_calendar_stop">Stop synchro</span>
                            </div>
                        </button>
                    </div>
                </t>
                <t t-elif="model.syncStatus.google_calendar == 'sync_paused' or model.syncStatus.microsoft_calendar =='sync_paused'">
                    <button class="btn text-nowrap" t-on-click="model.syncStatus.google_calendar == 'sync_paused' ? onUnpauseGoogleSynchronization : onUnpauseMicrosoftSynchronization">
                        <div>
                            <i id="pause_symbol" class="fa fa-pause px-1 o_text_orange o_calendar_pause"/>
                            <i id="stop_symbol" class="fa fa-square px-1 o_text_red o_calendar_stop"/>
                            <span id="pause_text" class="o_text_orange o_calendar_pause">Synchro is paused</span>
                            <span id="stop_text" class="o_text_red o_calendar_stop">Stop synchro</span>
                        </div>
                    </button>
                </t>
            </div>
        </xpath>
    </t>
`);
registerTemplate("calendar.AttendeeCalendarCommonPopover.body", `/calendar/static/src/views/attendee_calendar/common/attendee_calendar_common_popover.xml`, `<t t-name="calendar.AttendeeCalendarCommonPopover.body" t-inherit="web.CalendarCommonPopover.body" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//ul[hasclass('o_cw_popover_fields_secondary')]" position="attributes">
            <attribute name="t-if">isEventDetailsVisible</attribute>
        </xpath>
        <xpath expr="//div[hasclass('flex-grow-1')]" position="attributes">
            <attribute name="t-if">!fieldInfo.options.shouldOpenRecord</attribute>
        </xpath>
        <xpath expr="//div[hasclass('flex-grow-1')]" position="after">
            <t t-if="fieldInfo.options.shouldOpenRecord">
                <a href="#" t-on-click="onClickOpenRecord">
                    <t t-out="props.record.rawRecord.res_model_name"/>
                </a>
        </t>
        </xpath>
    </t>

    `);
registerTemplate("calendar.AttendeeCalendarCommonPopover.footer", `/calendar/static/src/views/attendee_calendar/common/attendee_calendar_common_popover.xml`, `<t t-name="calendar.AttendeeCalendarCommonPopover.footer" t-inherit="web.CalendarCommonPopover.footer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-if='isEventEditable']" position="after">
            <t t-elif="isEventViewable">
                <a href="#" class="btn btn-primary o_cw_popover_edit" t-on-click="onEditEvent">View</a>
            </t>
        </xpath>
        <xpath expr="//t[@t-if='isEventDeletable']" position="after">
            <a t-if="isEventArchivable and isEventDetailsVisible" href="#" class="btn btn-secondary o_cw_popover_archive_g" t-on-click="onClickArchive">Delete</a>
            <t t-if="displayAttendeeAnswerChoice">
                <div class="btn-group w-100 w-lg-auto ms-lg-auto order-first order-lg-0 px-2 px-lg-0">
                    <button class="btn" t-attf-class="#{selectedStatusInfo.text === 'Yes' ? 'btn-secondary active' : 'btn-outline-secondary'}" t-on-click="() =&gt; this.changeAttendeeStatus('accepted')">Yes</button>
                    <button class="btn" t-attf-class="#{selectedStatusInfo.text === 'No' ? 'btn-secondary active' : 'btn-outline-secondary'}" t-on-click="() =&gt; this.changeAttendeeStatus('declined')">No</button>
                    <button class="btn" t-attf-class="#{selectedStatusInfo.text === 'Maybe' ? 'btn-secondary active' : 'btn-outline-secondary'}" t-on-click="() =&gt; this.changeAttendeeStatus('tentative')">Maybe</button>
                </div>
            </t>
        </xpath>
    </t>
`);
registerTemplate("calendar.AttendeeCalendarCommonRenderer.event", `/calendar/static/src/views/attendee_calendar/common/attendee_calendar_common_renderer.xml`, `<t t-name="calendar.AttendeeCalendarCommonRenderer.event" xml:space="preserve">
            <span t-if="!isTimeHidden and isMonth" class="d-none d-lg-inline fc-time fw-normal" t-esc="startTime"/>
            <div t-attf-class="o_event_title text-truncate">
                <i t-if="isAlone" class="fa fa-exclamation-circle align-self-top me-1" data-tooltip="You're alone in this meeting"/>
                <span t-esc="title" t-attf-class="#{(attendeeStatus == 'accepted' || rawRecord.is_highlighted)  ? 'fw-bolder' : ''}"/>
                    <t t-if="!isAllDay and !isMonth and !isSmall">
                        <t t-if="24 &gt; duration and duration &gt; 0.5">
                            <br/><span class="fw-normal mt-1"><t t-esc="startTime"/> - <t t-esc="endTime"/></span>
                        </t>
                        <t t-else="">
                            , <t t-esc="startTime"/>
                        </t>
                    </t>
            </div>
    </t>
`);
registerTemplate("calendar.AttendeeCalendarYearPopover.body", `/calendar/static/src/views/attendee_calendar/year/attendee_calendar_year_popover.xml`, `<t t-name="calendar.AttendeeCalendarYearPopover.body" t-inherit="web.CalendarYearPopover.body" t-inherit-mode="primary" xml:space="preserve">

        <xpath expr="//t[@t-foreach='recordGroup.records']" position="attributes">
            <attribute name="t-key">record._recordId</attribute>
        </xpath>
    </t>
`);
registerTemplate("calendar.CalendarQuickCreateButtons", `/calendar/static/src/views/calendar_form/calendar_quick_create.xml`, `<t t-name="calendar.CalendarQuickCreateButtons" t-inherit="web.FormViewDialog.ToOne.buttons" xml:space="preserve">
        <xpath expr="//button[contains(@class, 'o_form_button_cancel')]" position="after">
            <button class="btn btn-link ms-auto" t-on-click="goToFullEvent">More Options</button>
        </xpath>
    </t>
`);
registerTemplate("calendar.AttendeeTagsList", `/calendar/static/src/views/fields/attendee_tags_list.xml`, `<t t-name="calendar.AttendeeTagsList" t-inherit="web.TagsList" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[hasclass('o_avatar_backdrop')]" position="attributes">
            <attribute name="class" remove="opacity-100-hover" separator=" "/>
        </xpath>

        <xpath expr="//img[hasclass('o_m2m_avatar')]" position="replace">
            <div class="o_attendee_tags_list">
                <img t-if="tag.img" t-att-src="tag.img" class="o_avatar o_m2m_avatar position-relative rounded" t-att-class="tag.imageClass"/>
                <div t-if="tag.status &amp;&amp; tag.statusIcon" t-attf-class="attendee_tag_status o_attendee_status_{{tag.status}} fa fa-fw {{tag.statusIcon}} rounded-circle"/>
            </div>
        </xpath>

        <xpath expr="//div[hasclass('o_tag_badge_text')]" position="after">
            <div t-if="tag.noEmail" title="no email" class="ms-1">
                <i class="fa fa-exclamation-triangle position-relative" role="img"/>
            </div>
        </xpath>

        <xpath expr="//span[hasclass('o_m2m_avatar_empty')]" position="attributes">
            <attribute name="class" remove="text-center" separator=" "/>
        </xpath>
    </t>
`);
registerTemplate("calendar.Many2ManyAttendee", `/calendar/static/src/views/fields/many2many_attendee.xml`, `<t t-name="calendar.Many2ManyAttendee" t-inherit="web.Many2ManyTagsAvatarField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('many2many_tags_avatar_field_container')]" position="attributes">
            <attribute name="class" add="flex-column" separator=" "/>
        </xpath>
        <xpath expr="//Many2XAutocomplete" position="attributes">
            <attribute name="placeholder">props.placeholder</attribute>
        </xpath>
    </t>
`);
registerTemplate("calendar.Many2ManyAttendeeExpandable", `/calendar/static/src/views/fields/many2many_attendee_expandable.xml`, `<t t-name="calendar.Many2ManyAttendeeExpandable" t-inherit="web.Many2ManyTagsAvatarField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('many2many_tags_avatar_field_container')]" position="attributes">
            <attribute name="class" remove="mw-100" add="w-100" separator=" "/>
        </xpath>
        <xpath expr="//TagsList" position="attributes">
            <attribute name="visibleItemsLimit">state.expanded ? tags.length : 5</attribute>
        </xpath>
        <xpath expr="//TagsList" position="before">
            <t t-if="tags.length &gt; 5">
                <div class="d-flex w-100">
                    <div class="flex-grow-1">
                        <strong><t t-out="attendeesCount"/> attendees</strong>
                        <br/><t t-out="acceptedCount"/> accepted
                        <br/><t t-out="declinedCount"/> declined
                        <br/><t t-out="uncertainCount"/> uncertain
                    </div>
                    <i role="button" t-on-click="onExpanderClick" t-att-class="state.expanded ? 'oi oi-chevron-up' : 'oi oi-chevron-down'"/>
                </div>
            </t>
        </xpath>
        <xpath expr="//TagsList" position="replace">
            <t t-if="!state.expanded &amp;&amp; tags.length &gt; 10"> </t>
            <t t-else="">$0</t>
        </xpath>
    </t>

`);
registerTemplate("calendar.WeekDays", `/calendar/static/src/views/widgets/calendar_week_days.xml`, `<t t-name="calendar.WeekDays" xml:space="preserve">
        <div class="o_recurrent_weekdays mb-2 d-flex">
        <t t-foreach="weekdays" t-as="day" t-key="day">
                <div t-attf-class="o_calendar_week_days_rounded {{data[day] ? 'text-bg-action' : 'btn-secondary'}}" t-on-click="this.props.readonly? () =&gt; {} : () =&gt; this.onChange(day)">
                    <t t-esc="props.record.fields[day].string[0]"/>
                </div>
            </t>
        </div>
    </t>
`);
registerTemplate("crm.ColumnProgress", `/crm/static/src/views/crm_kanban/crm_column_progress.xml`, `<t t-name="crm.ColumnProgress" t-inherit="web.ColumnProgress" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_column_progress')]" position="attributes">
            <attribute name="class" remove="w-75" add="w-50" separator=" "/>
        </xpath>
        <AnimatedNumber position="after">
            <t t-if="showRecurringRevenue">
                <t t-set="rrmAggregate" t-value="getRecurringRevenueGroupAggregate(props.group)"/>
                <AnimatedNumber value="rrmAggregate.value" title="rrmAggregate.title" duration="1000" currency="props.aggregate.currency" animationClass="'o_animated_grow_huge'">
                    <t t-set-slot="prefix">
                        <strong>+</strong>
                    </t>
                </AnimatedNumber>
            </t>
        </AnimatedNumber>
    </t>
`);
registerTemplate("crm.CrmKanbanHeader", `/crm/static/src/views/crm_kanban/crm_kanban_renderer.xml`, `<t t-name="crm.CrmKanbanHeader" t-inherit="web.KanbanHeader" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//ColumnProgress" position="attributes">
            <attribute name="progressBarState">props.progressBarState</attribute>
        </xpath>
    </t>
`);
registerTemplate("crm.ForecastKanbanRenderer", `/crm/static/src/views/forecast_kanban/forecast_kanban_renderer.xml`, `<t t-name="crm.ForecastKanbanRenderer" t-inherit="web.KanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <KanbanColumnQuickCreate position="replace">
            <t t-if="isGroupedByForecastField()">
                <ForecastKanbanColumnQuickCreate folded="true" onFoldChange="() =&gt; {}" onValidate.bind="addForecastColumn" exampleData="exampleData" groupByField="props.list.groupByField"/>
            </t>
            <t t-else="">$0</t>
        </KanbanColumnQuickCreate>
    </t>
`);
registerTemplate("google_recaptcha.recaptcha_legal_terms", `/google_recaptcha/static/src/xml/recaptcha.xml`, `<t t-name="google_recaptcha.recaptcha_legal_terms" xml:space="preserve">
    <small class="o_recaptcha_legal_terms">
        Protected by reCAPTCHA,
        <a href="https://policies.google.com/privacy" target="_blank">Privacy Policy</a>
        &amp;
        <a href="https://policies.google.com/terms" target="_blank">Terms of Service</a>
        apply.
    </small>
</t>

`);
registerTemplate("website.ResourceEditor", `/website/static/src/components/resource_editor/resource_editor.xml`, `<t t-name="website.ResourceEditor" xml:space="preserve">
        <div class="o_resource_editor w-100 h-100">
            <div class="o_resource_editor_title">
                <div class="btn-group o_resource_editor_type_switcher">
                    <Dropdown>
                        <button class="btn btn-info"><t t-esc="types[state.type]"/></button>
                        <t t-set-slot="content">
                            <t t-foreach="Object.keys(types)" t-as="type" t-key="type">
                                <DropdownItem onSelected="() =&gt; this.onFileTypeChange(type)">
                                    <t t-esc="types[type]"/>
                                </DropdownItem>
                            </t>
                        </t>
                    </Dropdown>
                </div>
                <SelectMenu t-props="selectMenuProps" class="'o_resource_editor_resource_list'">
                    <t t-call="website.ResourceEditor.ResourceLabel">
                        <t t-set="resource" t-value="state.currentResource"/>
                        <t t-set="label" t-value="state.type === 'xml' ? resource.name : resource.label"/>
                    </t>
                    <t t-set-slot="choice" t-slot-scope="scope">
                        <t t-call="website.ResourceEditor.ResourceLabel">
                            <t t-set="resource" t-value="state.resources[state.type][scope.data.value]"/>
                            <t t-set="label" t-value="scope.data.label"/>
                        </t>
                    </t>
                </SelectMenu>
                <label t-if="state.type === 'xml' and debug" class="o_resource_editor_filter">
                    <div class="btn-group o_resource_editor_type_switcher">
                        <Dropdown>
                            <button class="btn btn-primary">Filter</button>
                            <t t-set-slot="content">
                                <t t-foreach="Object.keys(xmlFilters)" t-as="filter" t-key="filter">
                                    <CheckboxItem class="{ selected: state.xmlFilter === filter }" checked="state.xmlFilter === filter" onSelected="() =&gt; this.onFilterChange('xml', filter)">
                                        <t t-esc="xmlFilters[filter]"/>
                                    </CheckboxItem>
                                </t>
                            </t>
                        </Dropdown>
                    </div>
                </label>
                <label t-if="state.type === 'scss' and debug" class="o_resource_editor_filter">
                    <div class="btn-group o_resource_editor_type_switcher">
                        <Dropdown>
                            <button class="btn btn-primary">Filter</button>
                            <t t-set-slot="content">
                                <t t-foreach="Object.keys(scssFilters)" t-as="filter" t-key="filter">
                                    <CheckboxItem class="{ selected: state.scssFilter === filter }" checked="state.scssFilter === filter" onSelected="() =&gt; this.onFilterChange('scss', filter)">
                                        <t t-esc="scssFilters[filter]"/>
                                    </CheckboxItem>
                                </t>
                            </t>
                        </Dropdown>
                    </div>
                </label>
                <div>
                    <button class="btn btn-primary" t-on-click="onSave"><i t-if="state.saving" class="fa fa-spin fa-spinner mr8"/>Save</button>
                    <button class="btn btn-secondary" t-on-click="this.props.close">Close</button>
                </div>
            </div>
            <div t-if="state.currentResource" id="resource-editor-id">
                <div class="float-end">
                    <button t-if="state.type !== 'xml' and isCustomResource(state.currentResource.url)" type="button" class="btn btn-sm btn-danger" t-on-click="onReset">
                        <i class="fa fa-undo"/>
                        Reset
                    </button>
                    <button t-if="state.type === 'xml'" type="button" class="btn btn-sm btn-link" t-on-click="onFormat">Format</button>
                </div>
                <span class="o_resource_editor_resource_info" t-esc="resourceInfo"/>
            </div>
            <div t-if="state.currentResource" id="resource-editor" t-ref="editor">
                <CodeEditor class="'h-100'" value="state.currentResource.arch" sessionId="state.currentResource.id" mode="typeToCodeEditorModeMap[state.type]" theme="'monokai'" onChange.bind="onEditorChange"/>
            </div>
        </div>
        <ResourceEditorWarningOverlay/>
    </t>

    `);
registerTemplate("website.ResourceEditor.ResourceLabel", `/website/static/src/components/resource_editor/resource_editor.xml`, `<t t-name="website.ResourceEditor.ResourceLabel" xml:space="preserve">
        <i t-if="resource.customized or resource.dirty" t-att-class="{ 'fa fa-floppy-o mr8': true, 'text-warning': resource.dirty, 'text-success': resource.customized }"/>
        <t t-esc="label"/>
    </t>

`);
registerTemplate("website.ResourceEditorWarningOverlay", `/website/static/src/components/resource_editor/resource_editor_warning.xml`, `<t t-name="website.ResourceEditorWarningOverlay" xml:space="preserve">
    <div t-if="state.visible" class="position-absolute top-0 start-0 bottom-0 end-0 d-flex align-items-center justify-content-center z-3 p-4 bg-light bg-opacity-75" role="alert">
        <div class="border shadow-sm p-4 bg-light text-dark rounded-2 bg-opacity-100">
            <div class="d-flex flex-row gap-4">
                <i class="fa fa-warning mb-4 fs-1 text-danger"/>
                <div>
                    <h1 class="fs-2 text-dark">Your changes might be lost during future Odoo upgrade.</h1>
                    <p>If you need to add analytics or marketing tags, inject code in your &lt;head&gt; or &lt;body&gt; instead.</p>
                    <em>Note: To embed code in this specific page, use the "Embed Code" building block</em>
                    <div class="d-flex flex-row gap-3 pt-4">
                        <button type="button" class="btn btn-primary" t-on-click="onInjectCode">Inject code in &lt;head&gt; or &lt;body&gt;</button>
                        <button type="button" class="btn btn-secondary" t-on-click="onCloseEditor">Close editor</button>
                        <button type="button" class="btn btn-link" t-on-click="onHideWarning">Edit HTML anyway</button>
                    </div>
                </div>
            </div>
        </div>

        <button type="button" class="btn btn-link position-absolute bottom-0 end-0 m-4" t-on-click="onStopAsking">
            Don't show again
        </button>
    </div>
</t>

`);
registerTemplate("website.EditHeadBodyDialog", `/website/static/src/components/edit_head_body_dialog/edit_head_body_dialog.xml`, `<t t-name="website.EditHeadBodyDialog" xml:space="preserve">
    <Dialog title.translate="Edit Head and Body Code">
        <p class="h5">Do not copy/paste code you do not understand, this could put your data at risk.</p>
        <div>Enter code that will be added into the &lt;head&gt; of every page of your site.</div>
        <CodeEditor mode="'xml'" theme="'monokai'" class="'my-2 rounded border o_website_code_editor_field'" value="state.head" onChange="v =&gt; state.head = v"/>

        <div class="mt-2">Enter code that will be added before the &lt;/body&gt; of every page of your site.</div>
        <CodeEditor mode="'xml'" theme="'monokai'" class="'my-2 rounded border o_website_code_editor_field'" value="state.body" onChange="v =&gt; state.body = v"/>

        <t t-set-slot="footer">
            <button class="btn btn-primary" t-on-click="onSave">Save</button>
            <button class="btn btn-secondary" t-on-click="props.close">Discard</button>
        </t>
    </Dialog>
</t>

`);
registerTemplate("website.AddPageConfirmDialog", `/website/static/src/components/dialog/add_page_dialog.xml`, `<t t-name="website.AddPageConfirmDialog" xml:space="preserve">
    <WebsiteDialog title.translate="New Page" primaryTitle.translate="Create" primaryClick="() =&gt; this.addPage()" close="props.close">
        <div class="row gy-4">
            <label class="col-form-label col-md-3">
                Page Title
            </label>
            <div class="col-md-9">
                <input type="text" t-model="state.name" class="form-control" required="required" t-ref="autofocus"/>
            </div>
            <Switch extraClasses="'offset-md-3 col-md-9 text-start'" label.translate="Add to menu" value="state.addMenu" onChange="(value) =&gt; this.onChangeAddMenu(value)"/>
        </div>
    </WebsiteDialog>
</t>

`);
registerTemplate("website.AddPageTemplatePreviewWrapper", `/website/static/src/components/dialog/add_page_dialog.xml`, `<t t-name="website.AddPageTemplatePreviewWrapper" xml:space="preserve">
    <div t-ref="holder" class="o_page_template position-relative placeholder-glow mx-auto transition-base" t-att-class="{ 'mt-4': !props.firstRow }">
        <div t-ref="preview" class="o_page_template_preview border border-white bg-white rounded" t-out="0"/>
        <span class="placeholder position-absolute top-0 w-100 h-100 rounded" t-attf-style="animation-duration: #{props.animationDelay + 500}ms"/>
        <div class="o_button_area position-absolute top-0 w-100 h-100 start-0 cursor-pointer rounded" t-on-click="select">
            <div t-if="props.template and props.template.name" class="position-absolute start-0 bottom-100 w-100 fw-bold lh-1 pb-1 pe-none text-center o_page_name" t-out="props.template.name"/>
        </div>
    </div>
</t>

`);
registerTemplate("website.AddPageTemplateBlank", `/website/static/src/components/dialog/add_page_dialog.xml`, `<t t-name="website.AddPageTemplateBlank" xml:space="preserve">
    <t t-call="website.AddPageTemplatePreviewWrapper">
        <div class="d-flex align-items-center justify-content-center h-100 h3-fs fw-bold text-muted">Blank Page</div>
    </t>
</t>

`);
registerTemplate("website.AddPageTemplatePreviewDynamicMessage", `/website/static/src/components/dialog/add_page_dialog.xml`, `<t t-name="website.AddPageTemplatePreviewDynamicMessage" xml:space="preserve">
    <section class="o_new_page_snippet_preview container h2">
        <div class="alert alert-info" t-out="message"/>
    </section>
</t>

`);
registerTemplate("website.AddPageTemplatePreview", `/website/static/src/components/dialog/add_page_dialog.xml`, `<t t-name="website.AddPageTemplatePreview" xml:space="preserve">
    <t t-call="website.AddPageTemplatePreviewWrapper">
        <iframe class="border-0 pe-none transition-base" t-ref="iframe" src="about:blank" aria-label="Add page template"/>
    </t>
</t>

`);
registerTemplate("website.AddPageTemplatePreviews", `/website/static/src/components/dialog/add_page_dialog.xml`, `<t t-name="website.AddPageTemplatePreviews" xml:space="preserve">
    <div class="container-fluid py-3 py-xl-4">
        <div class="row g-0">
            <div t-if="this.props.isCustom and !this.props.templates.length" class="col-12 alert alert-info d-flex">
                <i class="fa fa-2x fa-info-circle me-3"/>
                To add your page to this category, open the page properties: "Site -&gt; Properties".<br/>
                Then enable the "Is a Template" option.
            </div>
            <t t-foreach="[...this.columns.entries()]" t-as="column" t-key="column[0]">
                <div class="col-lg-4 col-12">
                    <t t-foreach="[...column[1].entries()]" t-as="template" t-key="template[0]">
                        <AddPageTemplateBlank t-if="template[1].isBlank" firstRow="template_first"/>
                        <AddPageTemplatePreview t-else="" template="template[1]" firstRow="template_first" animationDelay="(column_index * 500) + (template_index * 350)" isCustom="this.props.isCustom"/>
                    </t>
                    <t t-if="column[1].length === 0">
                        <div class="o_page_template position-relative"/>
                    </t>
                </div>
            </t>
        </div>
    </div>
</t>

`);
registerTemplate("website.AddPageTemplates", `/website/static/src/components/dialog/add_page_dialog.xml`, `<t t-name="website.AddPageTemplates" xml:space="preserve">
    <div class="overflow-hidden w-100" t-att-class="{o_loading: state.loading}">

        <div class="d-flex w-100 h-100 vertical flex-row">
            <ul t-ref="tabs" class="nav nav-pills flex-column flex-nowrap overflow-y-auto">
                <t t-foreach="state.pages" t-as="page" t-key="page.id">
                    <li class="nav-item">
                        <a t-att-data-id="page.id" t-on-click="() =&gt; this.onTabClick(page.id)" class="nav-link p-3 rounded-0" t-att-class="{active: page_first}" href="#" role="tab" tabindex="0">
                            <span t-if="page.isPreloading" class="fa fa-spin fa-spinner me-1"/>
                            <t t-out="page.title"/>
                        </a>
                    </li>
                </t>
            </ul>
            <div t-ref="panes" class="position-relative flex-grow-1 flex-shrink-1 bg-200">
                <t t-foreach="state.pages" t-as="page" t-key="page.id">
                    <div t-att-data-id="page.id" class="o_website_page_templates_pane position-absolute top-0 start-0 w-100 h-100 overflow-y-scroll bg-200" t-att-class="{active: page_first}">
                        <AddPageTemplatePreviews t-if="page_first or page.isAccessed" templates="page.props.templates" isCustom="page.props.is_custom"/>
                    </div>
                </t>
            </div>
        </div>
    </div>
</t>

`);
registerTemplate("website.AddPageDialog", `/website/static/src/components/dialog/add_page_dialog.xml`, `<t t-name="website.AddPageDialog" xml:space="preserve">
    <WebsiteDialog title.translate="New Page" contentClass="'o_website_page_templates_dialog h-100'" showFooter="false" footer="false" size="'xl'" close="props.close">
        <AddPageTemplates onTemplatePageChanged="name =&gt; this.onTemplatePageChanged(name)"/>
    </WebsiteDialog>
</t>

`);
registerTemplate("website.WebsiteDialog", `/website/static/src/components/dialog/dialog.xml`, `<t t-name="website.WebsiteDialog" xml:space="preserve">
    <Dialog contentClass="contentClasses" footer="props.showFooter ? undefined : false" size="props.size" title="props.title">
        <t t-set-slot="default">
            <t t-if="props.slots and props.slots.default" t-slot="default"/>
            <t t-else="" t-esc="props.body"/>
        </t>
        <t t-if="props.showFooter" t-set-slot="footer">
            <t t-if="props.slots and props.slots.footer" t-slot="footer"/>
            <t t-else="">
                <button class="btn btn-primary" t-on-click="protectedClick(props.primaryClick)" t-att-disabled="state.disabled">
                    <t t-esc="props.primaryTitle"/>
                </button>
                <button t-if="props.showSecondaryButton" class="btn btn-secondary" t-on-click="protectedClick(props.secondaryClick)" t-att-disabled="state.disabled">
                    <t t-esc="props.secondaryTitle"/>
                </button>
            </t>
        </t>
    </Dialog>
</t>

`);
registerTemplate("website.MenuDialog", `/website/static/src/components/dialog/edit_menu.xml`, `<t t-name="website.MenuDialog" xml:space="preserve">
    <WebsiteDialog title.translate="Add a menu item" closeOnClick="false" primaryClick.bind="this.onClickOk" secondaryClick="props.close">
        <div class="o_menu_dialog_form mb-3 row">
            <label class="col-form-label col-md-3">
                Name
            </label>
            <div class="col-md-9">
                <input type="text" t-model="name.input.value" class="form-control" t-att-class="{ 'is-invalid': name.input.hasError }" t-ref="autofocus"/>
            </div>
        </div>
        <div t-if="!props.isMegaMenu" class="mb-3 row">
            <label class="col-form-label col-md-3">
                Url or Email
            </label>
            <div class="col-md-9">
                <input id="url_input" t-ref="url-input" type="text" t-model="url.input.value" class="form-control" t-att-class="{ 'is-invalid': url.input.hasError }"/>
                <small class="form-text">Hint: Type '/' to search an existing page and '#' to link to an anchor.</small>
            </div>
        </div>
    </WebsiteDialog>
</t>

`);
registerTemplate("website.MenuRow", `/website/static/src/components/dialog/edit_menu.xml`, `<t t-name="website.MenuRow" xml:space="preserve">
    <li t-att-data-menu-id="props.menu.fields['id']" t-att-data-is-mega-menu="props.menu.fields['is_mega_menu'] ? 'true' : undefined">
        <div class="input-group mb-1">
                <span class="input-group-text bg-view fa fa-bars" role="img" aria-label="Dropdown menu" title="Dropdown menu"/>
            <span class="form-control d-flex align-items-center bg-view">
                <span class="js_menu_label o_text_overflow flex-grow-1">
                    <t t-esc="props.menu.fields['name']"/>
                </span>
                <span t-if="props.menu.fields['is_mega_menu']" class="badge text-bg-primary">Mega Menu</span>
                <i t-if="props.menu.is_homepage" class="fa fa-home ms-3" role="img" aria-label="Home" title="Home"/>
            </span>
                <button t-on-click="edit" type="button" class="btn btn-secondary js_edit_menu fa fa-pencil-square-o" aria-label="Edit Menu Item" title="Edit Menu Item"/>
                <button t-on-click="delete" type="button" class="btn btn-secondary js_delete_menu fa fa-trash-o rounded-start-0" aria-label="Delete Menu Item" title="Delete Menu Item"/>
        </div>
        <ul t-if="props.menu.children">
            <t t-foreach="props.menu.children" t-as="submenu" t-key="submenu.fields['id']">
                <MenuRow menu="submenu" edit="props.edit" delete="props.delete"/>
            </t>
        </ul>
    </li>
</t>

`);
registerTemplate("website.EditMenuDialog", `/website/static/src/components/dialog/edit_menu.xml`, `<t t-name="website.EditMenuDialog" xml:space="preserve">
    <WebsiteDialog close="props.close" title.translate="Edit Menu" primaryTitle.translate="Save" primaryClick="() =&gt; this.onClickSave()">
        <ul t-ref="menu-editor" class="oe_menu_editor list-unstyled">
            <t t-foreach="state.rootMenu.children" t-as="menu" t-key="menu.fields['id']">
                <MenuRow menu="menu" edit="(id) =&gt; this.editMenu(id)" delete="(id) =&gt; this.deleteMenu(id)"/>
            </t>
        </ul>
        <div class="mt32">
            <small class="float-end text-muted">
                Drag to the right to get a submenu
            </small>
            <a href="#" t-on-click="() =&gt; this.addMenu(false)">
                <i class="fa fa-plus-circle"/> Add Menu Item
            </a><br/>
            <a href="#" t-on-click="() =&gt; this.addMenu(true)">
                <i class="fa fa-plus-circle"/> Add Mega Menu Item
            </a>
        </div>
    </WebsiteDialog>
</t>
`);
registerTemplate("website.DuplicatePageDialog", `/website/static/src/components/dialog/page_properties.xml`, `<t t-name="website.DuplicatePageDialog" xml:space="preserve">
    <WebsiteDialog close="props.close" primaryClick="() =&gt; this.duplicate()">
        <div class="mb-3 row">
            <label class="col-form-label col-md-3">
                Page Name
            </label>
            <div class="col-md-9">
                <input type="text" t-model="state.name" class="form-control" required="required" t-ref="autofocus"/>
            </div>
        </div>
    </WebsiteDialog>
</t>

`);
registerTemplate("website.PageDependencies", `/website/static/src/components/dialog/page_properties.xml`, `<t t-name="website.PageDependencies" xml:space="preserve">
    <t t-if="!!Object.keys(state.dependencies).length">
        <t t-if="props.mode === 'popover'">
            <t t-set="depTemplate">
                <t t-call="{{ constructor.popoverTemplate }}"/>
            </t>
            <div t-att-data-bs-template="depTemplate" data-bs-html="true" title="Dependencies" t-ref="action">
                Could be used in many places, see here: <a href="#" t-on-click="showDependencies">Dependencies</a>
            </div>
        </t>
        <t t-else="">
            <p class="text-warning">We found these ones:</p>
            <div t-foreach="state.dependencies" t-as="dependency" t-key="dependency" class="ml16 mb16">
                <a class="collapsed" data-bs-toggle="collapse" t-attf-aria-controls="collapseDependencies{{ dependency_index }}" t-attf-href="#collapseDependencies{{ dependency_index }}" aria-expanded="false">
                    <i class="fa fa-caret-right me-1"/>
                    <t t-esc="dependency"/>:
                    <span class="text-muted"> <t t-esc="dependency_value.length"/> found(s)</span>
                </a>
                <div t-attf-id="collapseDependencies{{ dependency_index }}" class="collapse" aria-expanded="false">
                    <ul>
                        <li t-foreach="dependency_value" t-as="item" t-key="item_index">
                            <t t-set="link_text">This URL is contained in the “%(field)s” of the following “%(model)s”</t>
                            <a t-att-href="item.link" target="_blank">
                                <t t-out="sprintf(link_text, { field: item.field_name, model: item.model_name })"/>: <b t-out="item.record_name"/>
                            </a>
                        </li>
                    </ul>
                </div>
            </div>
        </t>
    </t>
</t>

`);
registerTemplate("website.PageDependencies.Tooltip", `/website/static/src/components/dialog/page_properties.xml`, `<t t-name="website.PageDependencies.Tooltip" xml:space="preserve">
    <t t-foreach="dependencies" t-as="dependency" t-key="dependency">
        <b><t t-esc="dependency"/></b>
        <ul>
            <li t-foreach="dependency_value" t-as="item" t-key="item_index">
                <a t-att-href="item.link" t-att-title="item.record_name" class="o_text_overflow" target="_blank">
                    <t t-out="item.record_name"/>
                </a>
            </li>
        </ul>
    </t>
</t>

`);
registerTemplate("website.DeletePageDialog", `/website/static/src/components/dialog/page_properties.xml`, `<t t-name="website.DeletePageDialog" xml:space="preserve">
    <WebsiteDialog title.translate="Delete Page" close="props.close">
        <p t-if="props.resIds.length &gt; 1">Are you sure you want to delete those pages?</p>
        <p t-else="">Are you sure you want to delete this page?</p>
        <p t-if="props.hasNewPageTemplate" class="text-warning">
            <t t-if="props.resIds.length &gt; 1">Some of these pages are used as new page templates.</t>
            <t t-else="">This page is used as a new page template.</t>
        </p>
        <p class="text-warning">Don't forget to update all links referring to it.</p>
        <PageDependencies resIds="props.resIds" resModel="props.resModel" mode="'collapse'"/>
        <CheckBox value="state.confirm" onChange.bind="onConfirmCheckboxChange">
            <p class="text-warning">I am sure about this.</p>
        </CheckBox>

        <t t-set-slot="footer">
            <button class="btn btn-primary" t-on-click="() =&gt; this.onClickDelete()" t-att-disabled="!this.state.confirm">
                Ok
            </button>
            <button class="btn btn-secondary" t-on-click="() =&gt; this.props.close()">
                Cancel
            </button>
        </t>
    </WebsiteDialog>
</t>

`);
registerTemplate("website.PagePropertiesDialogButtons", `/website/static/src/components/dialog/page_properties.xml`, `<t t-name="website.PagePropertiesDialogButtons" t-inherit="web.FormViewDialog.ToOne.buttons" xml:space="preserve">
    <xpath expr="//button[contains(@class, 'o_form_button_cancel')]" position="after">
        <button class="btn btn-link order-last ms-auto" t-on-click="props.clonePage"><i class="fa fa-fw fa-clone"/>Duplicate Page</button>
        <button class="btn btn-link order-last" t-on-click="props.deletePage"><i class="fa fa-fw fa-trash"/>Delete Page</button>
    </xpath>
</t>

`);
registerTemplate("website.MetaImage", `/website/static/src/components/dialog/seo.xml`, `<t t-name="website.MetaImage" xml:space="preserve">
    <div t-att-class="props.active ? 'o_active_image o_meta_img m-1' : 'o_meta_img m-1'" t-on-click="() =&gt; props.selectImage(props.src)">
        <span t-if="props.custom" class="o-custom-label w-100 text-white text-center">Custom</span>
        <img t-att-src="props.src"/>
    </div>
</t>

`);
registerTemplate("website.ImageSelector", `/website/static/src/components/dialog/seo.xml`, `<t t-name="website.ImageSelector" xml:space="preserve">
    <section>
        <div class="o_seo_og_image">
            <h4><small>Select an image for social share</small></h4>
            <div class="row">
                <div class="col-lg-6">
                    <t t-foreach="state.images" t-as="image" t-key="image.src">
                        <MetaImage active="image.active" custom="image.custom" src="image.src" selectImage="src =&gt; this.selectImage(src)"/>
                    </t>
                    <div class="o_meta_img_upload m-1" title="Click to choose more images" t-on-click="openMediaDialog">
                        <i class="fa fa-upload"/>
                    </div>
                </div>
                <div class="col-lg-6">
                    <div class="card p-0 mb16">
                        <div class="card-header">Social Preview</div>
                        <img class="card-img-top o_meta_active_img" t-att-src="activeMetaImage"/>
                        <div class="card-body px-3 py-2">
                            <h6 class="text-primary card-title mb0"><t t-esc="title"/></h6>
                            <small class="card-subtitle text-muted"><t t-esc="props.url"/></small>
                            <p t-esc="description"/>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
</t>

`);
registerTemplate("website.Keyword", `/website/static/src/components/dialog/seo.xml`, `<t t-name="website.Keyword" xml:space="preserve">
    <tr>
        <td t-esc="props.keyword"/>
        <td class="text-center"><i t-if="usedInH1" class="fa fa-check" t-att-title="props.keyword + ' is used in page first level heading'"/></td>
        <td class="text-center"><i t-if="usedInH2" class="fa fa-check" t-att-title="props.keyword + ' is used in page second level heading'"/></td>
        <td class="text-center"><i t-if="usedInTitle" class="fa fa-check" t-att-title="props.keyword + ' is used in page title'"/></td>
        <td class="text-center"><i t-if="usedInDescription" class=" fa fa-check" t-att-title="props.keyword + ' is used in page description'"/></td>
        <td class="text-center"><i t-if="usedInContent" class="fa fa-check" t-att-title="props.keyword + ' is used in page content'"/></td>
        <td class="o_seo_keyword_suggestion">
            <ul class="list-inline mb0">
                <span t-if="!state.suggestions.length">Loading...</span>
                <t t-foreach="state.suggestions" t-as="suggestion" t-key="suggestion">
                    <li class="list-inline-item" t-on-click="() =&gt; props.addKeyword(suggestion)">
                        <span class="o_seo_suggestion badge text-bg-info" t-att-title="'Add ' + suggestion" t-esc="suggestion"/>
                    </li>
                </t>
            </ul>
        </td>
        <td class="text-center" t-on-click="() =&gt; props.removeKeyword(props.keyword)"><a href="#" class="oe_remove" t-att-title="'Remove ' + props.keyword"><i class="fa fa-trash"/></a></td>
    </tr>
</t>

`);
registerTemplate("website.MetaKeywords", `/website/static/src/components/dialog/seo.xml`, `<t t-name="website.MetaKeywords" xml:space="preserve">
    <section>
        <label for="website_meta_keywords">
            Keywords
        </label>
        <div class="d-flex" role="form">
            <div class="input-group w-auto">
                <input t-model="state.keyword" type="text" class="form-control" t-att-placeholder="isFull ? 'Remove a keyword first' : 'Keyword'" t-att-readonly="isFull" maxlength="30" t-on-keyup="onKeyup"/>
                <select title="The language of the keyword and related keywords." t-model="state.language" class="btn btn-outline-primary pe-5 form-select">
                    <t t-foreach="languages" t-as="lang" t-key="lang[0]">
                        <option t-att-value="lang[0]"><t t-esc="lang[2]"/></option>
                    </t>
                </select>
                <button t-on-click="() =&gt; this.addKeyword(state.keyword)" t-att-disabled="isFull" class="btn btn-primary" type="button">Add</button>
            </div>
        </div>
        <div t-if="seoContext.keywords.length" class="table-responsive mt16">
            <table class="table table-sm">
                <thead>
                    <tr>
                        <th>Keyword</th>
                        <th class="text-center" title="Used in page first level heading">H1</th>
                        <th class="text-center" title="Used in page second level heading">H2</th>
                        <th class="text-center" title="Used in page title">T</th>
                        <th class="text-center" title="Used in page description">D</th>
                        <th class="text-center" title="Used in page content">C</th>
                        <th title="Most searched topics related to your keyword, ordered by importance">Related keywords</th>
                        <th class="text-center"/>
                    </tr>
                </thead>
                <t t-foreach="seoContext.keywords" t-as="keyword" t-key="keyword">
                    <Keyword language="state.language" keyword="keyword" addKeyword="(keyword) =&gt; this.addKeyword(keyword)" removeKeyword="(keyword) =&gt; this.removeKeyword(keyword)"/>
                </t>
            </table>
        </div>
    </section>
</t>

`);
registerTemplate("website.SEOPreview", `/website/static/src/components/dialog/seo.xml`, `<t t-name="website.SEOPreview" xml:space="preserve">
    <div class="oe_seo_preview_g">
        <div class="rc">
            <t t-if="props.isIndexed">
                <div class="r"><t t-esc="props.title"/></div>
                <div class="s">
                    <div class="kv mb-1 text-muted"><t t-esc="props.url"/></div>
                    <div class="st text-black"><t t-esc="description"/></div>
                </div>
            </t>
            <t t-else="">
                <div class="s">
                    <div class="st">You have hidden this page from search results. It won't be indexed by search engines.</div>
                </div>
            </t>
        </div>
    </div>
</t>

`);
registerTemplate("website.TitleDescription", `/website/static/src/components/dialog/seo.xml`, `<t t-name="website.TitleDescription" xml:space="preserve">
    <section>
        <div class="row">
            <div class="col-lg-6">
                <div class="mb-3">
                    <label for="website_meta_title">
                        Title <i class="fa fa-question-circle-o" title="The title will take a default value unless you specify one."/>
                    </label>
                    <input type="text" t-model="seoContext.title" t-att-disabled="!props.canEditTitle" class="form-control" placeholder="Keep empty to use default value" maxlength="70" size="70" t-ref="autofocus"/>
                </div>
                <div class="mb-3">
                    <label for="website_meta_description">
                        Description <i class="fa fa-question-circle-o" t-att-title="props.previewDescription"/>
                    </label>
                    <textarea t-model="seoContext.description" t-att-disabled="!props.canEditDescription" name="website_meta_description" placeholder="Keep empty to use default value" class="form-control"/>
                    <div t-if="descriptionWarning.length" class="alert alert-warning mt16 mb0 small">
                        <span t-esc="descriptionWarning"/>
                    </div>
                </div>
                <div class="mb-3" t-if="props.canEditUrl">
                    <label for="website_seo_name">
                        Custom Url <i class="fa fa-question-circle-o" t-att-title="props.seoNameHelp"/>
                    </label>
                    <div class="input-group">
                        <div class="input-group-prepend">
                            <span class="input-group-text seo_name_pre" t-esc="seoNamePre"/>
                        </div>
                        <input type="text" class="form-control" t-att-placeholder="props.seoNameDefault" t-on-input="_updateInputValue" t-att-value="seoContext.seoName"/>
                        <div class="input-group-append" title="Unalterable unique identifier">
                            <span class="input-group-text seo_name_post" t-esc="seoNamePost"/>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6">
                <div class="card-header">Preview</div>
                <div class="card mb0 p-0">
                    <div class="card-body">
                        <SEOPreview isIndexed="props.isIndexed" title="title" description="description" url="url"/>
                    </div>
                </div>
            </div>
        </div>
    </section>
</t>

`);
registerTemplate("website.OptimizeSEODialog", `/website/static/src/components/dialog/seo.xml`, `<t t-name="website.OptimizeSEODialog" xml:space="preserve">
    <WebsiteDialog close="props.close" title="title" size="size" primaryClick="() =&gt; this.save()" primaryTitle="saveButton" showFooter="canEditSeo" contentClass="contentClass">
        <div t-if="!canEditSeo" class="alert alert-warning" role="alert">
            You don't have permissions to edit this record.
        </div>
        <TitleDescription canEditDescription="canEditDescription" canEditUrl="canEditUrl" canEditTitle="canEditTitle" seoNameHelp="seoNameHelp" seoNameDefault="seoNameDefault" isIndexed="isIndexed" defaultTitle="defaultTitle" previewDescription="previewDescription" url="url"/>
        <MetaKeywords t-if="canEditSeo"/>
        <ImageSelector t-if="canEditSeo" previewDescription="socialPreviewDescription" defaultTitle="defaultTitle" hasSocialDefaultImage="hasSocialDefaultImage" pageImages="pageImages" url="url"/>
    </WebsiteDialog>
</t>
`);
registerTemplate("website.WebsiteEditorComponent", `/website/static/src/components/editor/editor.xml`, `<t t-name="website.WebsiteEditorComponent" xml:space="preserve">
    <div t-if="state.reloading" class="o_loading_dummy">
        <t t-out="this.loadingDummy"/>
    </div>
    <div t-if="state.showWysiwyg" t-ref="wysiwyg-adapter" t-att-class="{ o_w_wysiwyg_transition: !this.state.reloading, o_w_wysiwyg: this.websiteContext.snippetsLoaded }">
        <t t-component="this.WysiwygAdapterComponent" t-props="{             'editingValue': this.wysiwygOptions.value,             'options': this.wysiwygOptions,             'snippetSelector': this.reloadSelector,             'willReload': this.willReload.bind(this),             'reloadCallback': this.reload.bind(this),             'quitCallback': this.quit.bind(this),             'wysiwygReady': this.wysiwygReady.bind(this),             'editableElements': this.editableElements,             'savableSelector': this.savableSelector,             'beforeEditorActive': this.beforeEditorActive,             'removeWelcomeMessage': this.props.removeWelcomeMessage,         }"/>
    </div>
</t>
`);
registerTemplateExtension("web.NavBar", `/website/static/src/components/navbar/navbar.xml`, `<t t-inherit="web.NavBar" t-inherit-mode="extension" xml:space="preserve">
    <xpath expr="//div[hasclass('o_menu_systray')]" position="attributes">
        <attribute name="t-attf-class" add="{{shouldDisplayWebsiteSystray ? 'o_website_systray': ''}}" separator=" "/>
    </xpath>
</t>

`);
registerTemplate("website.TranslatorInfoDialog", `/website/static/src/components/translator/translator.xml`, `<div t-name="website.TranslatorInfoDialog" xml:space="preserve">
    <WebsiteDialog close="props.close" title="title" primaryTitle="strongOkButton" secondaryTitle="okButton" primaryClick="() =&gt; this.onStrongOkClick()">
        <p>You are about to enter the translation mode.</p>
        <p>Here are the visuals used to help you translate efficiently:</p>
        <ul class="oe_translate_examples">
            <li data-oe-translation-state="to_translate">Content to translate</li>
            <li data-oe-translation-state="translated">Translated content</li>
        </ul>
        <p>
            In this mode, you can only translate texts. To change the structure of the page, you must edit the master page.
            Each modification on the master page is automatically applied to all translated versions.
        </p>
    </WebsiteDialog>
</div>

`);
registerTemplate("website.AttributeTranslateDialog", `/website/static/src/components/translator/translator.xml`, `<t t-name="website.AttributeTranslateDialog" xml:space="preserve">
    <WebsiteDialog close="props.close" title="title" showSecondaryButton="false">
        <div t-ref="form-container"/>
    </WebsiteDialog>
</t>
`);
registerTemplate("website.EditInBackendSystray", `/website/static/src/systray_items/edit_in_backend.xml`, `<t t-name="website.EditInBackendSystray" xml:space="preserve">
    <div class="o_website_edit_in_backend d-flex">
        <span class="o_website_systray_separator d-none d-md-block w-0 border-start"/>
        <a href="#" class="o_nav_entry btn d-flex align-items-center mx-1 border-0 rounded-0 px-2 px-md-3" accesskey="e" t-on-click="editInBackend">
            <span class="fa fa-cog d-block d-md-none"/>
            <span class="d-none d-md-block" t-esc="state.mainObjectName"/>
        </a>
    </div>
</t>
`);
registerTemplate("website.EditWebsiteSystray", `/website/static/src/systray_items/edit_website.xml`, `<t t-name="website.EditWebsiteSystray" xml:space="preserve">
    <div class="o_menu_systray_item o_edit_website_container d-none d-md-flex">
        <a t-if="!translatable" href="#" class="o-website-btn-custo-primary btn position-relative d-flex align-items-center rounded-0 border-0 px-3" accesskey="a" t-on-click="startEdit">
            <span t-if="this.state.isLoading" class="position-absolute top-50 start-50 translate-middle">
                <i class="fa fa-refresh fa-spin"/>
            </span>
            <span t-out="label" t-attf-class="{{ this.state.isLoading ? 'opacity-0' : 'opacity-100' }}"/>
        </a>
        <Dropdown t-else="">
            <button class="o-dropdown-toggle-custo o-website-btn-custo-primary btn rounded-0 border-0 px-3" data-hotkey="a">
                <span t-out="label"/>
            </button>
            <t t-set-slot="content">
                <DropdownItem onSelected="() =&gt; this.attemptStartTranslate()" class="'o_translate_website_dropdown_item'">
                    Translate - <span class="text-muted" t-out="this.websiteService.currentWebsite.metadata.langName"/>
                </DropdownItem>
                <DropdownItem onSelected="() =&gt; this.startEdit()" class="'o_edit_website_dropdown_item'">
                    Edit - <span class="text-muted" t-out="this.websiteService.currentWebsite.metadata.defaultLangName"/>
                </DropdownItem>
            </t>
        </Dropdown>
    </div>
</t>
`);
registerTemplate("website.MobilePreviewSystray", `/website/static/src/systray_items/mobile_preview.xml`, `<t t-name="website.MobilePreviewSystray" xml:space="preserve">
    <div class="o_mobile_preview o_menu_systray_item d-none d-md-flex" t-att-class="{ 'o_mobile_preview_active': this.state.isMobile }">
        <a href="#" accesskey="v" class="o_nav_entry mx-1 px-3" t-on-click="() =&gt; this.websiteService.context.isMobile = !this.websiteService.context.isMobile">
            <span title="Mobile preview" role="img" aria-label="Mobile preview" class="fa fa-lg fa-mobile"/>
        </a>
    </div>
</t>
`);
registerTemplate("website.NewContentElement", `/website/static/src/systray_items/new_content.xml`, `<t t-name="website.NewContentElement" xml:space="preserve">
    <div class="o_new_content_element col-md-4 mb8" t-att-name="props.name">
        <a href="#" t-on-click="onClick" t-att-class="props.status === MODULE_STATUS.NOT_INSTALLED ? 'o_uninstalled_module' : ''" t-att-title="props.title" t-att-aria-label="props.title" t-att-data-module-xml-id="props.moduleXmlId">
            <t t-slot="default"/>
        </a>
    </div>
</t>

`);
registerTemplate("website.NewContentModal", `/website/static/src/systray_items/new_content.xml`, `<t t-name="website.NewContentModal" xml:space="preserve">
    <div id="o_new_content_menu_choices">
        <div class="container pt32 pb32">
            <div class="row">
                <NewContentElement t-if="isDesigner" name.translate="New Page" onClick="() =&gt; this.createNewPage()" title.translate="New Page">
                    <i class="fa fa-file-o"/>
                    <p>Page</p>
                </NewContentElement>

                <t t-foreach="sortedNewContentElements" t-as="element" t-key="element.moduleXmlId" t-if="'isDisplayed' in element ? element.isDisplayed : isSystem ">
                    <NewContentElement onClick="() =&gt; this.onClickNewContent(element)" status="element.status" title="element.title" moduleXmlId="element.moduleXmlId">
                        <t t-call="{{ element.icon }}"/>
                        <p><t t-esc="element.title"/></p>
                    </NewContentElement>
                </t>
            </div>
        </div>
    </div>
</t>

`);
registerTemplate("website.NewContentSystray", `/website/static/src/systray_items/new_content.xml`, `<t t-name="website.NewContentSystray" xml:space="preserve">
    <div class="o_menu_systray_item o_new_content_container d-none d-md-flex" t-on-click="onClick">
        <a href="#" accesskey="c" class="o-website-btn-custo-secondary btn d-flex align-items-center rounded-0 border-0 px-3">New</a>
        <NewContentModal t-if="websiteContext.showNewContentModal"/>
    </div>
</t>

`);
registerTemplate("website.InstallModuleDialog", `/website/static/src/systray_items/new_content.xml`, `<t t-name="website.InstallModuleDialog" xml:space="preserve">
    <WebsiteDialog close="props.close" title="props.title" primaryTitle="installButton" primaryClick="() =&gt; this.onClickInstall()">
        <t t-esc="props.installationText"/>
    </WebsiteDialog>
</t>
`);
registerTemplate("website.WebsiteSwitcherSystray", `/website/static/src/systray_items/website_switcher.xml`, `<t t-name="website.WebsiteSwitcherSystray" xml:space="preserve">
    <div class="o_menu_systray_item o_website_switcher_container">
        <Dropdown menuClass="{'mw-100': false}">
            <button data-hotkey="w" class="mx-1 border-0">
                <div class="d-none d-md-flex align-items-md-center">
                    <span t-esc="websiteService.currentWebsite.name" class="me-2 text-truncate" style="max-width: 200px"/>
                    <i class="fa fa-caret-down"/>
                </div>
                <div class="d-md-none">
                    <i class="fa fa-globe"/>
                </div>
            </button>
            <t t-set-slot="content">
                <t t-set="tooltipValue">This website does not have a domain configured.</t>
                <t t-foreach="getElements()" t-as="element" t-key="element_index">
                    <DropdownItem onSelected="element.callback" class="element.class" attrs="element.dataset">
                        <t t-if="!element.domain">
                            <span class="fa fa-warning me-2 text-warning"/>
                        </t>
                        <t t-out="element.name"/>
                    </DropdownItem>
                </t>
            </t>
        </Dropdown>
    </div>
    <span class="o_website_systray_separator d-none d-md-block w-0 border-start"/>
</t>
`);
registerTemplate("website.Configurator.SkipButton", `/website/static/src/client_actions/configurator/configurator.xml`, `<t t-name="website.Configurator.SkipButton" xml:space="preserve">
        <div class="container-fluid py-2 pb-md-3 text-end pe-lg-5">
            <button class="btn btn-link btn-lg" t-on-click="this.props.skip">Skip and start from scratch</button>
        </div>
    </t>

    `);
registerTemplate("website.Configurator.WelcomeScreen", `/website/static/src/client_actions/configurator/configurator.xml`, `<t t-name="website.Configurator.WelcomeScreen" xml:space="preserve">
        <div class="o_configurator_screen h-100 d-flex flex-column o_welcome_screen">
            <div class="o_configurator_odoo_logo mt-4 ms-4" style="height: 31px; width: 99px;"/>
            <div class="o_configurator_screen_content d-flex h-100">
                <div class="container align-self-center o_configurator_show">
                    <div class="display-2 mb-2">Ready to build the <br class="d-none d-lg-inline"/>
                    <b>perfect website?</b>
                </div>
                <div class="h1 fw-light mb-4 text-600">We'll set you up and running in <b>4 steps</b>
                </div>
                <button class="o_configurator_show btn btn-primary btn-lg px-4 py-2" t-on-click="goToDescription">Let's do it</button>
            </div>
        </div>
        <SkipButton skip="this.props.skip"/>
    </div>
</t>

`);
registerTemplate("website.Configurator.DescriptionScreen", `/website/static/src/client_actions/configurator/configurator.xml`, `<t t-name="website.Configurator.DescriptionScreen" xml:space="preserve">
    <div class="o_configurator_screen h-100 d-flex flex-column o_description_screen">
        <div class="o_configurator_odoo_logo mt-4 ms-5" style="height: 31px; width: 99px;"/>
        <div class="o_configurator_screen_content d-flex h-100 flex-grow-1">
            <div class="container align-self-center">
                <div class="o_configurator_typing_text d-inline d-md-block mb-md-2 mb-lg-4 o_configurator_show">
                    <span>I want </span>
                    <div t-attf-class="dropdown o_configurator_type_dd d-inline-block {{state.selectedType ? 'o_step_completed' : 'o_step_todo show'}}">
                        <div class="w-100 px-2" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                            <a class="d-flex align-items-center">
                                <i class="text-primary" t-if="state.selectedType">
                                    <t t-esc="state.getSelectedType(state.selectedType).label"/>
                                </i>
                                <i class="fa fa-angle-down ms-auto ps-2" role="img"/>
                            </a>
                        </div>
                        <div t-attf-class="dropdown-menu border-0 shadow-lg {{state.selectedType ? 'o_step_completed' : 'o_step_todo show'}}" role="menu">
                            <t t-foreach="state.getWebsiteTypes()" t-as="type" t-key="type.name">
                                <a t-att-title="type.name" t-on-click="() =&gt; this.selectWebsiteType(type.id)" class="dropdown-item o_change_website_type" role="menuitem">
                                    <t t-esc="type.label"/>
                                </a>
                            </t>
                        </div>
                    </div>
                    <span t-attf-class="me-2 {{!state.selectedType ? 'o_configurator_hide' : 'o_configurator_show'}}"> for my</span>
                </div>
                <div t-attf-class="o_configurator_typing_text d-inline d-md-flex align-items-center o_configurator_industry mb-md-2 mb-lg-4 {{!state.selectedType ? 'o_configurator_hide' : 'o_configurator_show'}}">

                    <label class="o_configurator_industry_wrapper me-2" t-ref="industrySelection">
                        <AutoComplete placeholder.translate="Clothes, Marketing, ..." value="state.selectedIndustry?.label ?? ''" sources="sources" onSelect.bind="_setSelectedIndustry"/>
                    </label>
                    <span> business</span>
                    <span t-att-class="!state.selectedIndustry ? 'o_configurator_hide' : 'o_configurator_show'">,</span>
                </div>
                <div t-attf-class="o_configurator_typing_text d-inline d-md-block mb-md-2 mb-lg-4 {{!state.selectedIndustry ? 'o_configurator_hide' : 'o_configurator_show'}}">
                    <span>with the main objective to </span>
                    <div t-attf-class="dropdown d-inline-block o_configurator_purpose_dd {{state.selectedPurpose ? 'o_step_completed' : 'o_step_todo'}}">
                        <div class="w-100 px-2" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                            <a class="d-flex align-items-center">
                                <t t-if="state.selectedPurpose">
                                    <t t-esc="state.getSelectedPurpose(state.selectedPurpose).label"/>
                                </t>
                                <i class="fa fa-angle-down ms-auto ps-2" role="img"/>
                            </a>
                        </div>
                        <div class="dropdown-menu border-0 shadow-lg" role="menu">
                            <t t-foreach="state.getWebsitePurpose()" t-as="type" t-key="type.name">
                                <a t-att-title="type.name" t-on-click="() =&gt; this.selectWebsitePurpose(type.id)" class="dropdown-item o_change_website_purpose">
                                    <t t-esc="type.label"/>
                                </a>
                            </t>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <SkipButton skip="this.props.skip"/>
    </div>
</t>

`);
registerTemplate("website.Configurator.PaletteSelectionScreen", `/website/static/src/client_actions/configurator/configurator.xml`, `<t t-name="website.Configurator.PaletteSelectionScreen" xml:space="preserve">
    <div class="o_configurator_screen h-100 d-flex flex-column o_palette_selection_screen">
        <div class="o_configurator_odoo_logo mt-4 ms-5" style="height: 31px; width: 99px;"/>
        <div class="o_configurator_screen_content container palette_selection d-flex flex-grow-1 h-100">
            <div class="o_content_container d-flex flex-row w-100 h-auto align-self-md-center o_configurator_show">
                <div class="o_detect_logo w-25 order-lg-3 my-4 my-md-0 d-flex flex-column">
                    <div class="h2 text-center">
                        <b>Detect</b> from Logo</div>
                    <div class="d-flex flex-column flex-grow-1 py-4">
                        <div t-on-click="uploadLogo" t-attf-class="o_configurator_logo_upload position-relative btn-link rounded bg-100 overflow-hidden d-flex flex-grow-1 justify-content-center align-items-center text-decoration-none {{state.logo? 'h-50' : ''}}">
                            <input type="file" class="logo_selection_input" t-on-change="changeLogo" style="display:none" name="logo_selection" t-ref="logoSelectionInput" accept="image/*"/>
                            <div class="h3 o_configurator_logo_button text-center">
                                <i t-attf-class="fa fa-cloud-upload {{state.logo? 'fa-4x' : 'fa-6x'}}"/>
                                <div class="text-center">Upload <span t-if="state.logo">a new image</span>
                                </div>
                            </div>
                            <div t-if="state.logo" class="o_configurator_logo_wrapper position-absolute d-flex justify-content-center align-items-center bg-white w-100 h-100">
                                <img style="height: 120px" t-attf-src="{{state.logo}}" alt="Logo"/>
                            </div>
                            <i t-if="state.logo" class="fa fa-2x fa-times-circle text-danger position-absolute top-0 end-0 pe-2 pt-2" t-on-click="removeLogo"/>
                        </div>
                        <div t-if="state.recommendedPalette" class="w-75 mx-auto px-2 pt-3" style="max-width: 184px;">
                            <div t-attf-class="palette_card rounded-pill overflow-hidden d-flex {{state.getSelectedPaletteName() == 'recommendedPalette' ? 'selected' : ''}}" t-on-click="() =&gt; this.selectPalette('recommendedPalette')" t-attf-style="background-color: {{state.recommendedPalette.color3}}">
                                <div class="color_sample w-100" t-attf-style="background-color: {{state.recommendedPalette.color1}}"/>
                                <div class="color_sample w-100" t-attf-style="background-color: {{state.recommendedPalette.color3}}"/>
                                <div class="color_sample w-100" t-attf-style="background-color: {{state.recommendedPalette.color2}}"/>
                            </div>
                            <button class="btn btn-primary btn-lg text-nowrap mt-3 d-block mx-auto" t-on-click="() =&gt; this.selectPalette('recommendedPalette')">
                                Let's go!<i class="fa fa-angle-right text-white-50 ps-2" role="img"/>
                            </button>
                        </div>
                    </div>
                </div>
                <div class="o_palettes_separator position-relative d-flex justify-content-center order-lg-2 w-0 py-3 py-lg-0 px-lg-5 mb-4 mb-lg-0">
                    <div class="border-top w-100"/>
                    <b class="palette_selection_or bg-view text-muted w-lg-100 text-center px-3 py-lg-3">OR</b>
                    <div class="border-start d-none d-lg-inline h-100 mx-auto w-0"/>
                </div>
                <div class="o_palettes_container w-auto flex-grow-1 o_configurator_show_fast">
                    <div class="h2 text-center">
                        <b>Choose</b> a Color Palette</div>
                    <div class="d-flex flex-wrap align-items-end">
                        <t t-foreach="state.getPalettes()" t-as="palette" t-key="palette_index">
                            <div class="o_palette_card_container w-25 px-2 pt-3">
                                <div t-attf-class="palette_card rounded-pill overflow-hidden d-flex {{state.getSelectedPaletteName() == palette.name ? 'selected' : ''}}" t-on-click="() =&gt; this.selectPalette(palette.name)" t-attf-style="background-color: {{palette.color3}}">
                                    <div class="color_sample w-100" t-attf-style="background-color: {{palette.color1}}"/>
                                    <div class="color_sample w-100" t-attf-style="background-color: {{palette.color3}}"/>
                                    <div class="color_sample w-100" t-attf-style="background-color: {{palette.color2}}"/>
                                </div>
                            </div>
                        </t>
                    </div>
                </div>
            </div>
        </div>
        <SkipButton skip="this.props.skip"/>
    </div>
</t>

`);
registerTemplate("website.Configurator.FeatureSelection", `/website/static/src/client_actions/configurator/configurator.xml`, `<t t-name="website.Configurator.FeatureSelection" xml:space="preserve">
    <div class="o_configurator_screen h-100 d-flex flex-column o_feature_selection_screen">
        <div class="o_configurator_odoo_logo mt-4 ms-5" style="height: 31px; width: 99px;"/>
        <div class="o_configurator_screen_content overflow-hidden container d-flex flex-grow-1 align-items-center">
            <div class="m-auto d-flex mh-100 flex-column">
                <div class="o_configurator_typing_text o_configurator_show_fast">Add <b class="text-info">Pages</b> and <b class="text-warning">Features</b></div>
                <h2 class="o_configurator_show_fast text-muted pb-lg-3">You'll be able to create your pages later on.</h2>
                <div class="page_feature_selection o_configurator_show overflow-auto mt-lg-3 mx-n2">
                    <div class="w-100 page_feature_selection d-flex flex-wrap">
                        <t t-foreach="state.getFeatures()" t-as="feature" t-key="feature_index">
                            <t t-set="isInstalled" t-value="feature.module_state == 'installed'"/>
                            <div class="o_feature_card_container p-2 w-25" t-if="feature.type != 'empty'">
                                <div t-attf-class="card h-100 {{isInstalled ? 'card_installed' : (feature.selected ? 'border-success' : '')}}" t-on-click="() =&gt; state.toggleFeature(feature.id)">
                                    <div class="h3 card-body py-3 px-4">
                                        <t t-if="isInstalled">
                                            <i t-attf-class="o_configurator_feature_status fa fa-check-circle text-success" title="Already installed"/>
                                        </t>
                                        <t t-else="">
                                            <i t-attf-class="o_configurator_feature_status fa {{feature.selected ? 'fa-check-circle text-success' : 'fa-circle-o text-300'}}"/>
                                        </t>
                                        <div t-attf-class="h2 mb-2 card-title d-flex align-items-center {{isInstalled ? 'text-muted' : ''}}">
                                            <i t-attf-class="me-2 fa {{feature.icon}} {{isInstalled ? 'text-muted' : (feature.type == 'page' ? 'text-info' : 'text-warning')}}"/>
                                            <h3 class="m-1">
                                                <t t-esc="feature.name"/>
                                            </h3>
                                        </div>
                                        <p class="small card-text text-muted" t-esc="feature.description"/>
                                    </div>
                                </div>
                            </div>
                        </t>
                    </div>
                </div>
                <div class="pt-2">
                    <button class="btn btn-primary btn-lg" t-on-click="buildWebsite">Build my website</button>
                </div>
            </div>
        </div>
    </div>
</t>

`);
registerTemplate("website.Configurator.ThemeSelectionScreen", `/website/static/src/client_actions/configurator/configurator.xml`, `<t t-name="website.Configurator.ThemeSelectionScreen" xml:space="preserve">
    <div class="o_configurator_screen h-100 d-flex flex-column o_theme_selection_screen">
        <div class="o_configurator_odoo_logo flex-shrink-0 mt-4 ms-5" style="height: 31px; width: 99px;"/>
        <div class="o_configurator_screen_content d-flex flex-column flex-grow-1 align-items-center">
            <div class="m-auto w-100 w-md-75 w-xl-100">
                <div class="o_configurator_typing_text text-center mt-4 mb-lg-4">Choose your favorite <b>Theme</b>
                </div>
                <div class="container">
                    <div class="row pb-4 pt-5">
                        <div class="col-12 col-lg-4 d-flex align-items-end mb-4 mb-lg-0">
                            <t t-if="state.getThemeName(1)">
                                <div class="theme_preview border rounded position-relative w-100 small o_configurator_show_fast">
                                    <h6 class="theme_preview_tip text-center text-muted">Click to select</h6>

                                    <div class="theme_svg_container rounded overflow-hidden" t-ref="ThemePreview2" dir="ltr"/>
                                    <div class="button_area" t-on-click="() =&gt; this.chooseTheme(state.getThemeName(1))"/>
                                </div>
                            </t>
                        </div>
                        <div class="col-12 col-lg-4 d-flex align-items-end mb-4 mb-lg-0">
                            <t t-if="state.getThemeName(0)">
                                <div class="theme_preview border rounded position-relative w-100 o_configurator_show">
                                    <h6 class="theme_preview_tip text-center text-muted">Click to select</h6>

                                    <div class="theme_svg_container rounded overflow-hidden" t-ref="ThemePreview1" dir="ltr"/>
                                    <div class="button_area" t-on-click="() =&gt; this.chooseTheme(state.getThemeName(0))"/>
                                </div>
                            </t>
                        </div>
                        <div class="col-12 col-lg-4 d-flex align-items-end">
                            <t t-if="state.getThemeName(2)">
                                <div class="theme_preview border rounded position-relative w-100 small o_configurator_show_fast">
                                    <h6 class="theme_preview_tip text-center text-muted">Click to select</h6>

                                    <div class="theme_svg_container rounded overflow-hidden" t-ref="ThemePreview3" dir="ltr"/>
                                    <div class="button_area" t-on-click="() =&gt; this.chooseTheme(state.getThemeName(2))"/>
                                </div>
                            </t>
                        </div>
                    </div>
                    <t t-if="showViewMoreThemesButton">
                        <p style="text-align: center;">
                            <button class="btn btn-primary btn-lg px-4 py-2 center-block" t-on-click="getMoreThemes" t-ref="extraThemesButton">View more themes</button>
                        </p>
                    </t>
                    <t t-elif="state.extraThemes.length" t-foreach="[...Array(Math.ceil(state.extraThemes.length/3)).keys()]" t-as="nbrExtraRow" t-key="nbrExtraRow">
                        <div class="row pb-4 pt-5">
                            <t t-foreach="[...Array(3).keys()]" t-as="nbrExtraCol" t-key="nbrExtraCol">
                                <div class="col-12 col-lg-4 d-flex align-items-end mb-4 mb-lg-0">
                                    <t t-set="extraThemeId" t-value="nbrExtraRow * 3 + nbrExtraCol"/>
                                    <t t-set="extraThemeName" t-value="getExtraThemeName(extraThemeId)"/>
                                    <t t-if="extraThemeName">
                                        <div class="theme_preview border rounded position-relative w-100 small o_configurator_show_fast">
                                            <h6 class="theme_preview_tip text-center text-muted">Click to select</h6>

                                            <div class="theme_svg_container rounded overflow-hidden" t-ref="ExtraThemePreview{{extraThemeId}}" dir="ltr"/>
                                            <div class="button_area" t-on-click="() =&gt; this.chooseTheme(extraThemeName)"/>
                                        </div>
                                    </t>
                                </div>
                            </t>
                        </div>
                    </t>
                </div>
            </div>
        </div>
    </div>
</t>

`);
registerTemplate("website.Configurator.Configurator", `/website/static/src/client_actions/configurator/configurator.xml`, `<t t-name="website.Configurator.Configurator" xml:space="preserve">
    <div class="o_configurator_container">
        <DescriptionScreen t-if="state.currentStep === 2" navigate.bind="navigate" skip.bind="skipConfigurator"/>
        <PaletteSelectionScreen t-elif="state.currentStep === 3" navigate.bind="navigate" skip.bind="skipConfigurator"/>
        <FeaturesSelectionScreen t-elif="state.currentStep === 4" navigate.bind="navigate" skip.bind="skipConfigurator" clearStorage.bind="clearStorage"/>
        <ThemeSelectionScreen t-elif="state.currentStep === 5" navigate.bind="navigate" clearStorage.bind="clearStorage"/>
        <WelcomeScreen t-else="" navigate.bind="navigate" skip.bind="skipConfigurator"/>
    </div>
</t>

`);
registerTemplate("website.WebsiteDashboardMain", `/website/static/src/client_actions/website_dashboard/website_dashboard.xml`, `<t t-name="website.WebsiteDashboardMain" xml:space="preserve">
    <div class="o_dashboards" t-att-class="{'has_plausible': state.dashboards.plausible_share_url}">
        <Layout display="display">
            <t t-set-slot="control-panel-navigation-additional">
                <div class="btn-group d-none d-md-inline-block float-end" style="margin-right: 20px;">
                    <t t-foreach="state.websites" t-as="website" t-key="website.id">
                        <button class="btn btn-secondary text-truncate js_website" style="max-width: 200px;" t-att-class="{'active': website.selected}" t-on-click="() =&gt; this.state.website = website.id">
                            <t t-esc="website.name"/>
                        </button>
                    </t>
                </div>
            </t>
            <t t-set-slot="control-panel-create-button">
                <a role="button" href="/" class="btn btn-primary" title="Go to Website">
                    Go to Website
                </a>
            </t>
            <div class="container-fluid o_website_dashboard">
                <div class="o_website_dashboard_content">
                    <t t-call="website.plausible_content"/>
                </div>
            </div>
        </Layout>
    </div>
</t>

`);
registerTemplate("website.plausible_content", `/website/static/src/client_actions/website_dashboard/website_dashboard.xml`, `<t t-name="website.plausible_content" xml:space="preserve">
    <div class="row o_dashboard_visits" t-if="state.groups.website_designer">
        <div t-if="state.dashboards.plausible_share_url" class="col-12">
            <div class="container">
                <div class="ratio ratio-1x1">
                    <iframe t-att-src="state.dashboards.plausible_share_url" class="embed-responsive-item" frameborder="0" loading="lazy"/>
                </div>
            </div>
        </div>
        <div t-else="" class="col-lg-12 o_box">
            <div class="o_demo_background">
                <div class="o_layer">
                </div>
                <div class="o_buttons text-center">
                    <h3>Easily track your visitor with Plausible</h3>
                    <DocumentationLink path="'/applications/websites/website/reporting/plausible.html'" label.translate="Connect Plausible"/>
                </div>
            </div>
        </div>
    </div>
</t>

`);
registerTemplate("website.BlockPreview", `/website/static/src/client_actions/website_preview/website_preview.xml`, `<t t-name="website.BlockPreview" xml:space="preserve">
    <div class="o_blockUI o_block_preview position-fixed d-flex justify-content-center align-items-center flex-column h-100 w-100 bg-black-50">
        <div class="o_spinner mb-4">
            <img src="/web/static/img/spin.svg" alt="Loading..."/>
        </div>
    </div>
</t>

`);
registerTemplate("website.WebsitePreview", `/website/static/src/client_actions/website_preview/website_preview.xml`, `<t t-name="website.WebsitePreview" xml:space="preserve">
    <div class="o_website_preview" t-ref="container" t-att-class="{ 'editor_enable editor_has_snippets': this.websiteContext.snippetsLoaded,                         'o_is_blocked': this.blockedState.isBlocked,                         'o_is_mobile': this.websiteContext.isMobile,                         'border-top': !this.websiteContext.snippetsLoaded,                         'o_is_microsoft_edge': isMicrosoftEdge,                       }">
        <BlockPreview t-if="this.blockedState.showLoader"/>
        <div class="o_iframe_container">
            <iframe t-if="!testMode" t-att-src="iframeFallbackUrl" class="o_ignore_in_tour" t-att-class="{ 'd-none': this.websiteContext.edition }" t-ref="iframefallback"/>
            <iframe t-att-src="initialUrl" class="o_iframe" t-ref="iframe" t-on-load="_onPageLoaded" is-ready="false" t-att-data-load-wysiwyg="this.websiteService.isRestrictedEditor ? 'true': 'false'"/>
            <div t-if="this.websiteContext.isMobile" class="o_mobile_preview_layout">
                <img alt="phone" src="/website/static/src/img/phone.png"/>
            </div>
        </div>
        <WebsiteEditorComponent t-if="websiteContext.edition" reloadIframe.bind="this.reloadIframe" removeWelcomeMessage.bind="this.removeWelcomeMessage"/>
        <WebsiteTranslator t-if="websiteContext.translation" reloadIframe.bind="this.reloadIframe" removeWelcomeMessage.bind="this.removeWelcomeMessage"/>
        <ResizablePanel t-if="websiteContext.showResourceEditor" handleSide="'start'" class="'o_resource_editor_wrapper position-fixed'" onResize.bind="_onResourceEditorResize" initialWidth="aceEditorWidth">
            <ResourceEditor close="() =&gt; this.websiteContext.showResourceEditor = false"/>
        </ResizablePanel>
    </div>
</t>

`);
registerTemplate("website.homepage_editor_welcome_message", `/website/static/src/client_actions/website_preview/website_preview.xml`, `<t t-name="website.homepage_editor_welcome_message" xml:space="preserve">
    <div class="container text-center o_homepage_editor_welcome_message">
        <h2 class="mt0">Welcome to your <b>Homepage</b>!</h2>
        <p class="lead d-none d-md-block">Click on <b>Edit</b> in the top right corner to start designing.</p>
    </div>
</t>
`);
registerTemplate("website.website_loader", `/website/static/src/components/website_loader/website_loader.xml`, `<t t-name="website.website_loader" xml:space="preserve">
    <div t-if="state.isVisible" class="o_website_loader_container position-fixed fixed-top fixed-left h-100 w-100 d-flex" t-att-class="currentWaitingMessage.flag ? ('o_website_loader_container_' + currentWaitingMessage.flag) : ''">
        <div class="o_website_loader_container_content position-relative d-flex flex-column p-3 p-lg-5">
            <a t-if="state.showCloseButton" href="#" class="btn" style="position: absolute; right: 0; top: 0; margin: 15px;" t-on-click="close">
                <i class="oi oi-close oi-large" role="presentation"/>
            </a>

            <div class="o_website_loader_odoo_logo mb-5" style="height: 31px; width: 78px;"/>

            <div t-if="state.showWaitingMessages" t-out="currentWaitingMessage.title" class="h4-fs text-muted mb-3"/>
            <div t-elif="state.title" t-out="state.title"/>
            <div t-elif="state.showTips">Building your website...</div>
            <div class="mt-3"/>
            <div t-if="['text', 'images', 'generic'].includes(currentWaitingMessage.flag)" class="o_website_loader_tip d-flex gap-2 h3-fs mb-2">
                <div><i class="o_website_loader_check fa fa-check fa-fw text-success" role="presentation"/></div>
                <span class="o_website_loader_done">Applying your colors and design.</span>
            </div>
            <div t-if="['text', 'generic'].includes(currentWaitingMessage.flag)" class="o_website_loader_tip d-flex gap-2 h3-fs mb-2">
                <div><i class="o_website_loader_check fa fa-check fa-fw text-success" role="presentation"/></div>
                <span class="o_website_loader_done">Searching your images.</span>
            </div>
            <div t-if="['text', 'generic'].includes(currentWaitingMessage.flag)" class="o_website_loader_tip d-flex gap-2 h3-fs mb-2">
                <div><i class="o_website_loader_check fa fa-check fa-fw text-success" role="presentation"/></div>
                <span class="o_website_loader_done">Adapting Building Blocks.</span>
            </div>
            <div t-if="['generic'].includes(currentWaitingMessage.flag)" class="o_website_loader_tip d-flex gap-2 h3-fs mb-2">
                <div><i class="o_website_loader_check fa fa-check fa-fw text-success" role="presentation"/></div>
                <span class="o_website_loader_done">Generating inspiring text.</span>
            </div>
            <div t-if="state.showWaitingMessages" class="o_website_loader_tip d-flex gap-2 h3-fs">
                <div><i class="fa fa-circle-o-notch fa-spin fa-fw"/></div><div><t t-out="currentWaitingMessage.description"/></div>
            </div>

            <p class="o_website_loader_tip mt-auto mb-3">
                <t t-if="state.bottomMessageTemplate !== undefined">
                    <t t-if="state.bottomMessageTemplate" t-call="{{state.bottomMessageTemplate}}"/>
                </t>
                <t t-elif="state.showTips">
                    <b>TIP</b>: Once loaded, follow the
                    <span class="o_tour_pointer o_bottom me-3">
                        <span class="o_tour_pointer_tip position-absolute mt-n1"/>
                    </span>
                    pointer to discover features.
                </t>
            </p>
            <div t-if="state.showLoader" class="o_website_loader_progress progress position-relative rounded-pill mb-3">
                <div role="progressbar" aria-label="Installing your features" class="progress-bar rounded-0" t-att-aria-valuemax="100" t-att-aria-valuenow="state.progressPercentage" t-attf-style="width: #{state.progressPercentage}%"/>
            </div>
        </div>
        <div id="o_website_loader_animations_steps" class="d-none d-lg-block position-relative flex-grow-1 overflow-hidden" role="presentation">
            <div id="o_website_loader_step_colors">
                <t t-foreach="[...Array(64).keys()]" t-as="cell" t-key="cell">
                    <span/>
                </t>
            </div>
            <div id="o_website_loader_step_images" class="flex-column h-100">
                <div class="o_website_loader_filmstrip d-flex w-100 overflow-hidden">
                    <div class="o_website_loader_filmstrip_inner d-flex flex-shrink-0 flex-grow-0">
                        <img src="/website/static/src/img/website_loader/1.jpg" alt="Image 1"/>
                        <img src="/website/static/src/img/website_loader/2.jpg" alt="Image 2"/>
                        <img src="/website/static/src/img/website_loader/3.jpg" alt="Image 3"/>
                        <img src="/website/static/src/img/website_loader/8.jpg" alt="Image 8"/>
                        <img src="/website/static/src/img/website_loader/5.jpg" alt="Image 5"/>
                        <img src="/website/static/src/img/website_loader/6.jpg" alt="Image 6"/>
                        <img src="/website/static/src/img/website_loader/7.jpg" alt="Image 7"/>
                        <img src="/website/static/src/img/website_loader/4.jpg" alt="Image 4"/>


                        <img src="/website/static/src/img/website_loader/1.jpg" alt="Image 1"/>
                        <img src="/website/static/src/img/website_loader/2.jpg" alt="Image 2"/>
                        <img src="/website/static/src/img/website_loader/3.jpg" alt="Image 3"/>
                        <img src="/website/static/src/img/website_loader/8.jpg" alt="Image 8"/>
                        <img src="/website/static/src/img/website_loader/5.jpg" alt="Image 5"/>
                        <img src="/website/static/src/img/website_loader/6.jpg" alt="Image 6"/>
                        <img src="/website/static/src/img/website_loader/7.jpg" alt="Image 7"/>
                        <img src="/website/static/src/img/website_loader/4.jpg" alt="Image 4"/>
                    </div>
                </div>
                <div class="o_website_loader_filmstrip o_website_loader_filmstrip_middle d-flex w-100 overflow-hidden">
                    <div class="o_website_loader_filmstrip_inner d-flex flex-shrink-0 flex-grow-0">
                        <img src="/web/image/website.s_three_columns_default_image_1" alt=""/>
                        <img src="/web/image/website.s_showcase_default_image" alt=" "/>
                        <img src="/web/image/website.s_image_title_default_image" alt=""/>
                        <img src="/web/image/website.library_image_10" alt=" "/>


                        <img src="/web/image/website.s_three_columns_default_image_1" alt=""/>
                        <img src="/web/image/website.s_showcase_default_image" alt=" "/>
                        <img src="/web/image/website.s_image_title_default_image" alt=""/>
                        <img src="/web/image/website.library_image_10" alt=" "/>
                    </div>
                </div>
                <div class="o_website_loader_filmstrip d-flex w-100 overflow-hidden mt-auto">
                    <div class="o_website_loader_filmstrip_inner d-flex flex-shrink-0 flex-grow-0">
                        <img src="/website/static/src/img/website_loader/8.jpg" alt="Image 8"/>
                        <img src="/website/static/src/img/website_loader/7.jpg" alt="Image 7"/>
                        <img src="/website/static/src/img/website_loader/6.jpg" alt="Image 6"/>
                        <img src="/website/static/src/img/website_loader/5.jpg" alt="Image 5"/>
                        <img src="/website/static/src/img/website_loader/4.jpg" alt="Image 4"/>
                        <img src="/website/static/src/img/website_loader/3.jpg" alt="Image 3"/>
                        <img src="/website/static/src/img/website_loader/2.jpg" alt="Image 2"/>
                        <img src="/website/static/src/img/website_loader/1.jpg" alt="Image 1"/>


                        <img src="/website/static/src/img/website_loader/8.jpg" alt="Image 8"/>
                        <img src="/website/static/src/img/website_loader/7.jpg" alt="Image 7"/>
                        <img src="/website/static/src/img/website_loader/6.jpg" alt="Image 6"/>
                        <img src="/website/static/src/img/website_loader/5.jpg" alt="Image 5"/>
                        <img src="/website/static/src/img/website_loader/4.jpg" alt="Image 4"/>
                        <img src="/website/static/src/img/website_loader/3.jpg" alt="Image 3"/>
                        <img src="/website/static/src/img/website_loader/2.jpg" alt="Image 2"/>
                        <img src="/website/static/src/img/website_loader/1.jpg" alt="Image 1"/>
                    </div>
                </div>
            </div>
            <div id="o_website_loader_step_text">
                <span class="o_website_loader_text_content">A</span>
                <span class="o_website_loader_text_content start-50">B</span>
                <span class="o_website_loader_text_content w-100 text-center">C</span>
            </div>
            <div id="o_website_loader_step_generic">
                <div class="o_website_loader_loader">
                    <div class="o_website_loader_circle"/>
                    <div class="o_website_loader_circle_mask overflow-hidden">
                        <div class="o_website_loader_circle_line"/>
                    </div>
                </div>
            </div>
        </div>
    </div>
</t>
`);
registerTemplate("website.hierarchy_navbar", `/website/static/src/js/backend/view_hierarchy/hierarchy_navbar.xml`, `<t t-name="website.hierarchy_navbar" xml:space="preserve">
    <nav class="o_tree_nav navbar justify-content-start w-100 bg-white shadow position-sticky top-0" t-ref="navbar">
        <div class="dropdown ms-2 border border-info rounded">
            <div class="btn-group">
                <Dropdown items="websiteNames">
                    <button class="btn btn-secondary">
                        <span t-esc="props.websites.selected"/>
                    </button>
                </Dropdown>
            </div>
        </div>
        <div class="ms-2 form-check form-switch">
            <input t-on-click="(ev) =&gt; props.toggleInactive(ev.target.checked)" id="o_show_inactive" class="form-check-input" type="checkbox"/>
            <label class="form-check-label" for="o_show_inactive">Show inactive views</label>
        </div>
        <div class="o_search input-group ms-auto col-8 col-sm-6 col-md-4 col-xl-3" role="search">
            <input type="search" name="search" class="form-control border-info" placeholder="Name, id or key" t-on-keydown="onInputKeydown" t-ref="search"/>
            <button type="submit" class="btn btn-info" aria-label="Search" title="Search" t-on-click="onInputClick">
                <i class="fa fa-search"/>
            </button>
        </div>
    </nav>
</t>

`);
registerTemplate("website.view_hierarchy", `/website/static/src/js/backend/view_hierarchy/view_hierarchy.xml`, `<t t-name="website.view_hierarchy" xml:space="preserve">
    <Layout display="{ controlPanel: {} }" className="'overflow-auto h-100'">
            <HierarchyNavbar toggleInactive.bind="toggleInactive" websites="websites" selectWebsite.bind="selectWebsite" searchView.bind="searchView"/>
            <div class="o_tree_container ms-2 container mt-2" style="margin-bottom: 50px;">
                <div t-if="siblingViews.length &gt; 0" class="alert alert-info m-1 p-1">
                    Multiple tree exists for this view
                    <a t-foreach="siblingViews" t-as="siblingView" t-key="siblingView.id" href="#" class="o_load_hierarchy" t-on-click.stop.prevent="() =&gt; this.onShowHierarchy(siblingView.id)">
                        <i class="oi oi-arrow-right me-1"/>
                        <t t-esc="siblingView.display_name"/>
                        &lt;<t t-esc="siblingView.key"/>&gt;
                        <t t-if="siblingView.website_id">
                            [<t t-esc="siblingView.website_id[1]"/>]
                        </t>
                    </a>
                </div>
                <t t-set="viewTree" t-value="state.viewTree"/>
                <t t-call="website.report_viewhierarchy_children"/>
            </div>
    </Layout>
</t>

`);
registerTemplate("website.report_viewhierarchy_children", `/website/static/src/js/backend/view_hierarchy/view_hierarchy.xml`, `<t t-name="website.report_viewhierarchy_children" xml:space="preserve">
    <p t-on-click="() =&gt; this.onCollapseClick(viewTree)" t-attf-class="o_tree_entry mb-0 d-flex align-items-center {{viewTree.active ? '': 'text-muted fw-normal'}} {{viewTree.inherit_children.length ? 'o_has_child' : ''}} {{state.searchedView.id === viewTree.id ? 'o_search_found border border-info rounded px-2': ''}}">
        <i t-if="hasChildToUnfold(viewTree)" t-attf-class="js_fold o_fold_icon fa {{ viewTree.collapsed ? 'fa-plus-square-o' : 'fa-minus-square-o' }} me-1"/>
        <i t-if="viewTree.arch_updated" class="fa fa-pencil-square me-1 o_text_pink" title="This view arch has been modified"/>

        <span class="js_fold" t-att-style="viewId === viewTree.id ? 'background-color: yellow': ''">
            <t t-esc="viewTree.name"/> (<span class="fw-bold" t-esc="viewTree.key"/>)
            <span class="o_text_orange" t-if="viewTree.website_name" t-esc="\`[\${viewTree.website_name}]\`"/>
        </span>
        <a href="#" t-on-click.stop.prevent="() =&gt; this.openFormView(viewTree.id)">
            <i class="fa fa-eye ms-2 text-muted" title="Go to View"/>
        </a>
        <a class="o_show_diff" href="#" t-on-click.stop.prevent="() =&gt; this.onShowDiffClick(viewTree.id)">
            <i class="fa fa-files-o ms-2 text-muted" title="Show Arch Diff"/>
        </a>
        <t t-if="state.searchedView.id === viewTree.id">
            <span class="o_tab_hint text-info ms-auto small fst-italic pe-2">Press &lt;Tab&gt; for next [<t t-esc="state.searchedView.index+1"/>/<t t-esc="state.searchedView.total"/>]</span>
        </t>
    </p>

    <ul t-if="viewTree.inherit_children">
        <t t-foreach="viewTree.inherit_children" t-as="child" t-key="child.id">
            <li t-if="isViewDisplayed(child)" t-attf-class="{{child.active ? '' : 'o_is_inactive'}}">
                <t t-call="website.report_viewhierarchy_children">
                    <t t-set="viewTree" t-value="child"/>
                </t>
            </li>
        </t>
    </ul>
</t>
`);
registerTemplate("website_sale.ribbonSelectItem", `/website_sale/static/src/xml/website_sale_utils.xml`, `<we-button t-name="website_sale.ribbonSelectItem" t-att-data-set-ribbon="ribbon.id" xml:space="preserve">
    <t t-out="ribbon.name"/>
    <span t-attf-class="fa fa-arrow-#{isLeft ? 'left' : 'right'} ms-1"/>
    <span t-attf-class="o_wsale_color_preview ms-1" t-attf-style="background-color: #{ribbon.bg_color}"/>
    <span t-attf-class="o_wsale_color_preview ms-1" t-attf-style="background-color: #{textColor} !important;"/>
</we-button>

`);
registerTemplate("website.PageUrlField", `/website/static/src/components/fields/fields.xml`, `<t t-name="website.PageUrlField" t-inherit="web.UrlField" t-inherit-mode="primary" xml:space="preserve">
    <xpath expr="//input" position="before">
        <t t-set="slicingLength" t-value="env.isSmall ? 30 : 45"/>
        <div class="input-group-text rounded-start text-lowercase border-0" t-esc="serverUrl.length &gt; slicingLength ? serverUrl.slice(0, (slicingLength / 2) - 1) + '..' + serverUrl.slice((-slicingLength / 2) + 1) : serverUrl"/>
    </xpath>
</t>

`);
registerTemplate("website.FieldImageRadio", `/website/static/src/components/fields/fields.xml`, `<t t-name="website.FieldImageRadio" xml:space="preserve">
    <div class="d-flex">
        <t t-foreach="values" t-as="option" t-key="option">
            <div class="flex-fill text-center">
                <img t-attf-class="o_image_radio_option w-50 {{option[0] === props.record.data[props.name] ? 'active' : ''}}" t-att-src="option[2]" t-on-click="() =&gt; this.onSelectValue(option[0])"/>
            </div>
        </t>
    </div>
</t>

`);
registerTemplate("website.PublishField", `/website/static/src/components/fields/publish_button.xml`, `<t t-name="website.PublishField" xml:space="preserve">
    <t t-set="publish">Publish</t>
    <t t-set="unpublish">Unpublish</t>
    <t t-set="published">Published</t>
    <t t-set="unpublished">Unpublished</t>
    <div class="o_stat_info">
        <span class="o_stat_text o_hover" t-att-class="props.record.data[props.name] ? 'text-danger' : 'text-success'" t-esc="props.record.data[props.name] ? unpublish : publish"/>
        <span class="o_stat_text o_not_hover" t-att-class="props.record.data[props.name] ? 'text-success' : 'text-danger'" t-esc="props.record.data[props.name] ? published : unpublished"/>
    </div>
</t>

`);
registerTemplate("website.RedirectField", `/website/static/src/components/fields/redirect_field.xml`, `<t t-name="website.RedirectField" xml:space="preserve">
    <button type="button" class="btn oe_stat_button btn-outline-secondary flex-grow-1 flex-lg-grow-0" t-on-click="onClick" t-att-aria-label="info" t-att-title="info">
        <i class="fa fa-fw o_button_icon fa-globe" t-att-class="this.props.record.data[this.props.name] ? 'text-success' : 'text-danger'"/>
        <div class="o_stat_info">
            <span class="o_stat_text">Go to<br/>Website</span>
        </div>
    </button>
</t>

`);
registerTemplate("website.iframeWidget", `/website/static/src/components/fields/widget_iframe.xml`, `<t t-name="website.iframeWidget" xml:space="preserve">
    <div t-if="props.record.data[props.name]" class="h-100" t-att-class="{ 'is_mobile': this.state.isMobile }">
        <iframe frameBorder="0" class="d-block" height="100%" width="100%" t-att-src="props.record.data[props.name]"/>
        <img t-if="this.state.isMobile" alt="phone" class="img_mobile" src="/website/static/src/img/phone.png"/>
    </div>
    <div t-else="">No Url</div>
</t>

`);
registerTemplate("website.FullscreenIndication", `/website/static/src/components/fullscreen_indication/fullscreen_indication.xml`, `<t t-name="website.FullscreenIndication" owl="1" xml:space="preserve">
        <div class="o_fullscreen_indication" t-att-class="{ o_visible: state.isVisible }">
            <p t-out="fullScreenIndicationText"/>
        </div>
    </t>

`);
registerTemplate("website.PageKanbanView", `/website/static/src/components/views/page_kanban.xml`, `<t t-name="website.PageKanbanView" t-inherit="web.KanbanView" xml:space="preserve">
    <xpath expr="//SearchBar" position="inside">
        <t t-set-slot="search-bar-additional-menu">
            <t t-call="website.RecordFilter"/>
        </t>
    </xpath>
</t>

`);
registerTemplate("website.PageListRenderer.RecordRow", `/website/static/src/components/views/page_list.xml`, `<t t-name="website.PageListRenderer.RecordRow" t-inherit="web.ListRenderer.RecordRow" xml:space="preserve">
    <xpath expr="//Field//ancestor::td/*[1]" position="before">
        <t t-if="column.name === 'name' and record.data.is_homepage and record.mode !== 'edit'">
            <i class="fa fa-fw fa-home fa-lg" title="Home page of the current website"/>
        </t>
    </xpath>
</t>

`);
registerTemplate("website.PageListView", `/website/static/src/components/views/page_list.xml`, `<t t-name="website.PageListView" t-inherit="web.ListView" xml:space="preserve">
    <xpath expr="//SearchBar" position="inside">
        <t t-set-slot="search-bar-additional-menu">
            <t t-call="website.RecordFilter"/>
        </t>
    </xpath>
</t>

`);
registerTemplate("website.RecordFilter", `/website/static/src/components/views/page_list.xml`, `<t t-name="website.RecordFilter" xml:space="preserve">
    <div t-if="websiteSelection.length &gt; 1" class="o_dropdown_container o_website_menu w-100 w-lg-auto h-100 px-3 border-start">
        <div class="px-3 fs-5 mb-2">
            <i class="me-2 fa fa-globe"/>
            <h5 class="o_dropdown_title d-inline">Website</h5>
        </div>
        <t t-foreach="websiteSelection" t-as="website" t-key="website.id">
            <CheckboxItem class="{ 'o_menu_item text-truncate': true, selected: state.activeWebsite.id === website.id }" checked="state.activeWebsite.id === website.id" closingMode="'none'" t-esc="website.name" attrs=" { title: website.name.length &gt; 15 ? website.name : '' }" onSelected="() =&gt; this.onSelectWebsite(website)"/>
            <div t-if="!website.id" class="dropdown-divider"/>
        </t>
    </div>
</t>

`);
registerTemplate("website.ThemePreviewForm.ControlPanel.BreadCrumbs", `/website/static/src/components/views/theme_preview.xml`, `<t t-name="website.ThemePreviewForm.ControlPanel.BreadCrumbs" xml:space="preserve">
        <t t-set="breadcrumb" t-value="breadcrumbs.slice(-1)[0] || {}"/>        
        <div class="o_breadcrumb d-flex gap-1">
            <div class="active d-flex flex-column">
                <h4 class="mb-0"><t t-call="web.Breadcrumb.Name"/></h4>
            </div>
        </div>
    </t>

    `);
registerTemplate("website.ThemePreviewForm.ControlPanel", `/website/static/src/components/views/theme_preview.xml`, `<t t-name="website.ThemePreviewForm.ControlPanel" t-inherit="web.ControlPanel" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//*[hasclass('o_control_panel')]" position="attributes">
            <attribute name="class" remove="pb-3" add="pb-2" separator=" "/>
        </xpath>
        <xpath expr="//*[hasclass('o_control_panel_main_buttons')]" position="inside">
            <button class="o_switch_theme btn btn-secondary d-none d-md-inline-block me-1" t-on-click.stop="this.back">
                <i class="oi oi-arrow-left" role="img" aria-label="Go Back"/>
            </button>
        </xpath>
        <xpath expr="//*[hasclass('o_control_panel_actions')]" position="attributes">
            <attribute name="class" remove="justify-content-lg-around" add="justify-content-sm-end flex-grow-1 flex-shrink-1 flex-basis-sm-0" separator=" "/>
        </xpath>
        <xpath expr="//div[hasclass('o_control_panel_navigation')]" position="replace">
            <div class="o_control_panel_switch_device d-none d-lg-flex" role="group">
                <div class="btn-group">
                    <input class="btn-check" id="themeViewerDesktop" type="radio" name="viewer" data-mode="desktop" autocomplete="off" checked="checked"/>
                    <label class="btn btn-secondary" for="themeViewerDesktop" t-on-click="this.onDesktopClick">
                        <i class="fa fa-fw fa-desktop" role="img" aria-label="Desktop"/>
                    </label>
                    <input class="btn-check" id="themeViewerMobile" type="radio" name="viewer" data-mode="mobile" autocomplete="off"/>
                    <label class="btn btn-secondary" for="themeViewerMobile" t-on-click="this.onMobileClick">
                        <i class="fa fa-fw fa-mobile" role="img" aria-label="Mobile"/>
                    </label>
                </div>
            </div>
        </xpath>
        <xpath expr="//t[@t-else]/Breadcrumbs" position="replace">
            <t t-call="website.ThemePreviewForm.ControlPanel.BreadCrumbs"/>
        </xpath>
    </t>

    `);
registerTemplate("website.ThemePreviewFormController", `/website/static/src/components/views/theme_preview.xml`, `<t t-name="website.ThemePreviewFormController" t-inherit="web.FormView" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//Layout" position="inside">
            <t t-set-slot="layout-actions">
                <ViewButton className="'btn btn-primary o_use_theme'" clickParams="{type: 'object', name: 'button_choose_theme'}" record="this.model.root">
                    <t t-set-slot="contents">Use this theme</t>
                </ViewButton>
            </t>
        </xpath>
    </t>

    `);
registerTemplate("website.ThemePreviewKanban.ControlPanel.BreadCrumbs", `/website/static/src/components/views/theme_preview.xml`, `<t t-name="website.ThemePreviewKanban.ControlPanel.BreadCrumbs" xml:space="preserve">
            <div class="o_breadcrumb d-flex gap-1">
                <div class="active d-flex flex-column">
                    <div class="fw-bold text-truncate">Pick a Theme</div>
                    <div class="text-muted small">Don't worry, you can switch later.</div>
                </div>
            </div>
    </t>

    `);
registerTemplate("website.ThemePreviewKanban.ControlPanel", `/website/static/src/components/views/theme_preview.xml`, `<t t-name="website.ThemePreviewKanban.ControlPanel" t-inherit="web.ControlPanel" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//*[hasclass('o_control_panel')]" position="attributes">
            <attribute name="class" remove="pb-3" add="pb-2" separator=" "/>
        </xpath>
        <xpath expr="//t[@t-else]/Breadcrumbs" position="replace">
            <t t-call="website.ThemePreviewKanban.ControlPanel.BreadCrumbs"/>
        </xpath>
        <xpath expr="//div[contains(@class,'o_control_panel_navigation')]" position="replace">
            <a class="btn btn-secondary align-self-center" t-on-click="this.close" aria-label="Close" data-tooltip="Close">
                <i class="fa fa-times" role="img" aria-label="close"/>
            </a>
        </xpath>
    </t>
`);
registerTemplate("website.AutoCompleteWithPages", `/website/static/src/components/autocomplete_with_pages/autocomplete_with_pages.xml`, `<t t-name="website.AutoCompleteWithPages" t-inherit="web.AutoComplete" xml:space="preserve">
        <xpath expr="//input[@t-ref='input']" position="attributes">
            <attribute name="class" add="d-none" separator=" "/>
        </xpath>
    </t>
`);
registerTemplate("website.UrlAutoComplete", `/website/static/src/components/autocomplete_with_pages/url_autocomplete.xml`, `<t t-name="website.UrlAutoComplete" xml:space="preserve">
        <AutoCompleteWithPages onInput.bind="onInput" onSelect.bind="onSelect" dropdownClass="dropdownClass" dropdownOptions="dropdownOptions" sources="sources" targetDropdown="props.targetDropdown"/>
    </t>

    `);
registerTemplate("website.AutoCompleteWithPagesItem", `/website/static/src/components/autocomplete_with_pages/url_autocomplete.xml`, `<t t-name="website.AutoCompleteWithPagesItem" xml:space="preserve">
        <div t-att-class="{             'fw-bold text-capitalize p-2': option.separator,         }">
            <t t-if="option.icon and option.icon.length">
                <img t-att-src="option.icon" width="24px" height="24px" class="me-2 rounded"/>
            </t>
            <t t-out="option.label"/>
        </div>
    </t>
`);
registerTemplate("website.prompt", `/website/static/src/xml/website.xml`, `<t t-name="website.prompt" xml:space="preserve">
        <div role="dialog" class="modal o_technical_modal" tabindex="-1">
                <div class="modal-dialog">
                <div class="modal-content">
                    <header class="modal-header" t-if="window_title">
                        <h3 class="modal-title"><t t-esc="window_title"/></h3>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"/>
                    </header>
                    <main class="modal-body">
                        <form role="form" t-att-id="id">
                            <div class="row mb0">
                                <label for="page-name" class="col-md-3 col-form-label">
                                    <t t-esc="field_name"/>
                                </label>
                                <div class="col-md-9">
                                    <input t-if="field_type == 'input'" type="text" class="form-control" required="required"/>
                                    <textarea t-if="field_type == 'textarea'" class="form-control" required="required" rows="5"/>
                                    <select t-if="field_type == 'select'" class="form-select"/>
                                </div>
                            </div>
                        </form>
                    </main>
                    <footer class="modal-footer">
                        <button type="button" class="btn btn-primary btn-continue"><t t-esc="btn_primary_title"/></button>
                        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal" aria-label="Cancel"><t t-esc="btn_secondary_title"/></button>
                    </footer>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("barcodes.BarcodeScanner", `/barcodes/static/src/components/barcode_scanner.xml`, `<t t-name="barcodes.BarcodeScanner" xml:space="preserve">
        <div class="o_barcode_mobile_container">
            <a t-if="isBarcodeScannerSupported" role="button" class="btn btn-primary o_mobile_barcode" t-on-click="openMobileScanner">
                <i class="fa fa-camera fa-2x o_barcode_mobile_camera"/>
                Tap to scan
            </a>
            <img src="/barcodes/static/img/barcode.png" alt="Barcode"/>
            <span class="o_barcode_laser"/>
        </div>
    </t>

`);
registerTemplate("barcodes.FloatScannableField", `/barcodes/static/src/float_scannable_field.xml`, `<t t-name="barcodes.FloatScannableField" t-inherit="web.FloatField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//input" position="attributes">
            <attribute name="t-on-barcode_scanned">onBarcodeScanned</attribute>
            <attribute name="t-att-data-enable-barcode">true</attribute>
            <attribute name="barcode_events">true</attribute>
        </xpath>
    </t>

`);
registerTemplate("stock.TraceabilityReport", `/stock/static/src/client_actions/stock_traceability_report_backend.xml`, `<t t-name="stock.TraceabilityReport" xml:space="preserve">
        <div class="o_action">
            <Layout display="display">
                <t t-set-slot="layout-buttons">
                    <div class="o_cp_buttons" role="toolbar" aria-label="Control panel buttons" t-ref="buttons">
                        <button type="button" class="btn btn-primary" t-on-click="() =&gt; this.onClickPrint()">Print</button>
                    </div>
                </t>

                <div class="container-fluid o_stock_reports_page o_stock_reports_no_print">
                    <t t-if="state.lines.length">
                        <h1 class="o_report_heading text-start">Traceability Report</h1>
                        <div class="o_stock_reports_table table-responsive">
                            <table class="table">
                                <thead>
                                    <tr class="o_report_header">
                                        <th class="o_report_line_header">Reference</th>
                                        <th class="o_report_line_header">Product</th>
                                        <th class="o_report_line_header">Date</th>
                                        <th class="o_report_line_header">Lot/Serial #</th>
                                        <th class="o_report_line_header">From</th>
                                        <th class="o_report_line_header">To</th>
                                        <th class="o_report_line_header">Quantity</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <t t-call="stock.ReportMRPLines">
                                        <t t-set="lines" t-value="state.lines"/>
                                        <t t-set="hasUpDown" t-value="true"/>
                                    </t>
                                </tbody>
                            </table>
                        </div>
                    </t>
                    <h1 t-else="" class="text-center">No operation made on this lot.</h1>
                </div>
            </Layout>
        </div>
    </t>

    `);
registerTemplate("stock.ReportMRPLines", `/stock/static/src/client_actions/stock_traceability_report_backend.xml`, `<t t-name="stock.ReportMRPLines" xml:space="preserve">
        <t t-foreach="lines" t-as="line" t-key="line.id">
            <t t-set="column" t-value="0"/>
            <tr t-att-class="line.model === 'stock.move.line' ? 'o_stock_reports_level0' : 'o_stock_reports_default_style'">
                <t t-foreach="line.columns" t-as="col" t-key="col_index">
                    <td t-att-class="line.unfoldable ? 'o_stock_reports_unfoldable' : ''">
                        <t t-if="col_first">
                            <span t-attf-style="margin-left: {{line.level}}px"/>
                            <t t-if="hasUpDown and line.is_used ">
                                <span role="img" title="Traceability Report" aria-label="Traceability Report" t-on-click.prevent="() =&gt; this.onClickUpDownStream(line)">
                                    <i class="fa fa-fw fa-level-up fa-rotate-270"/>
                                </span>
                            </t>
                            <t t-elif="line.unfoldable">
                                <span class="o_stock_reports_unfoldable o_stock_reports_caret_icon" t-on-click="() =&gt; this.toggleLine(line)">
                                    <i class="fa fa-fw" t-att-class="line.isFolded ? 'fa-caret-right' : 'fa-caret-down'" role="img" aria-label="Unfold" title="Unfold"/>
                                </span>
                            </t>
                        </t>

                        <span t-if="col and line.reference === col" t-att-class="!line.unfoldable ? 'o_stock_reports_nofoldable' : ''">
                            <a class="o_stock_reports_web_action" href="#" t-on-click.prevent="() =&gt; this.onClickBoundLink(line)" t-esc="col"/>
                        </span>
                        <span t-elif="col and line.lot_name === col">
                            <span class="o_stock_report_lot_action" t-esc="col"/>
                        </span>
                        <t t-elif="col" t-esc="col"/>
                    </td>
                </t>
            </tr>

            <t t-if="!line.isFolded and line.lines.length" t-call="stock.ReportMRPLines">
                <t t-set="lines" t-value="line.lines"/>
                <t t-set="hasUpDown" t-value="false"/>
            </t>
        </t>
    </t>

`);
registerTemplate("stock.ReceptionReportLine", `/stock/static/src/components/reception_report_line/stock_reception_report_line.xml`, `<tr t-name="stock.ReceptionReportLine" class="align-middle" xml:space="preserve">
        <td t-esc="data.product.display_name"/>
        <td>
            <t t-esc="formatFloat(data.quantity)"/> <t t-if="props.showUom" t-esc="data.uom"/>
            <button class="btn btn-link fa fa-area-chart" t-on-click="onClickForecast" name="forecasted_report_link"/>
        </td>
        <td t-if="data.is_qty_assignable">
            <button t-if="!data.is_assigned" t-on-click="onClickAssign" class="btn btn-sm btn-primary" name="assign_link">
                Assign
            </button>
            <button t-else="" t-on-click="onClickUnassign" class="btn btn-sm btn-primary" name="unassign_link">
                Unassign
            </button>
        </td>
        <td>
            <button t-if="data.is_qty_assignable &amp;&amp; data.source" class="btn btn-sm btn-primary" t-attf-disabled="{{ !data.is_assigned }}" name="print_label" t-on-click="onClickPrint">
                <span class="d-sm-block">Print Label</span>
            </button>
        </td>
    </tr>

`);
registerTemplate("stock.ReceptionReportMain", `/stock/static/src/components/reception_report_main/stock_reception_report_main.xml`, `<div t-name="stock.ReceptionReportMain" class="o_action" xml:space="preserve">
        <ControlPanel display="controlPanelDisplay">
            <t t-set-slot="control-panel-always-buttons">
                <div class="o_cp_buttons" role="toolbar" aria-label="Control panel buttons">
                    <div class="d-inline-block">
                        <button t-on-click="onClickPrint" type="button" class="btn btn-primary" title="Print">Print</button>
                        <button t-on-click="onClickAssignAll" class="btn btn-secondary ms-1" t-att-disabled="isAssignAllDisabled">Assign All</button>
                        <button t-on-click="onClickPrintLabels" class="btn btn-secondary ms-1" t-att-disabled="isPrintLabelDisabled">Print Labels</button>
                    </div>
                </div>
            </t>
        </ControlPanel>
        <div class="o_report_reception container-fluid justify-content-between">
            <div class="o_report_reception_header my-4">
                <h1>
                    <t t-if="data.docs">
                        <div t-foreach="data.docs" t-as="doc" t-key="doc.id">
                            <a href="#" t-on-click.prevent="() =&gt; this.onClickTitle(doc.id)" view-type="form" t-esc="doc.name"/>
                            <span t-esc="doc.display_state" t-attf-class="ms-1 align-text-top badge rounded-pill bg-opacity-50 {{ doc.state == 'done' ? 'bg-success' : 'bg-info' }}"/>
                        </div>
                    </t>
                    <t t-else="">
                        <span t-esc="data.reason"/>
                    </t>
                </h1>
            </div>
            <t t-if="hasContent">
                <table class="table table-sm">
                    <ReceptionReportTable t-foreach="state.sourcesToLines" t-as="source" t-key="source" index="source" scheduledDate="data.sources_to_formatted_scheduled_date[source]" lines="state.sourcesToLines[source]" source="data.sources_info[source]" showUom="data.show_uom" precision="data.precision"/>
                </table>
            </t>
            <p t-else="">
                No allocation need found.
            </p>
        </div>
    </div>

`);
registerTemplate("stock.ReceptionReportTable", `/stock/static/src/components/reception_report_table/stock_reception_report_table.xml`, `<t t-name="stock.ReceptionReportTable" xml:space="preserve">
        <thead>
            <tr class="bg-light">
                <th>
                    <i t-if="props.source[0].priority == '1'" class="o_priority o_priority_star fa fa-star"/>
                    <a href="#" t-on-click.prevent="() =&gt; this.onClickLink(props.source[0].model, props.source[0].id, 'form')" t-out="props.source[0].name"/>
                    <span t-if="props.source.length &gt; 1">
                        (<a href="#" t-on-click.prevent="() =&gt; this.onClickLink(props.source[1].model, props.source[1].id, 'form')" t-out="props.source[1].name"/>)
                    </span>
                    <span t-if="props.source[0].model == 'stock.picking' and props.source[0].partner_id">:
                        <a href="#" t-on-click.prevent="() =&gt; this.onClickLink('res.partner', props.source[0].partner_id, 'form')" t-out="props.source[0].partner_name"/>
                    </span>
                </th>
                <th>Expected Delivery: <t t-esc="props.scheduledDate"/></th>
                <th t-if="hasMovesIn">
                    <button t-if="hasAssignAllButton" t-on-click="onClickAssignAll" class="btn btn-sm btn-primary" t-att-disabled="isAssignAllDisabled" name="assign_source_link">
                        Assign All
                    </button>
                </th>
                <th>
                    <button t-if="hasMovesIn" t-on-click="onClickPrintLabels" class="btn btn-sm btn-primary" t-att-disabled="isPrintLabelDisabled" name="print_labels">
                        <span class="d-none d-sm-block">Print Labels</span>
                        <span class="d-block d-sm-none fa fa-print"/>
                    </button>
                </th>
            </tr>
        </thead>
        <tbody>
            <t t-foreach="props.lines" t-as="line" t-key="line.index">
                <ReceptionReportLine data="line" parentIndex="props.index" showUom="props.showUom" precision="props.precision"/>
            </t>
        </tbody>
    </t>

`);
registerTemplate("stock.ForecastedButtons", `/stock/static/src/stock_forecasted/forecasted_buttons.xml`, `<t t-name="stock.ForecastedButtons" xml:space="preserve">
        <button title="Replenish" t-on-click="_onClickReplenish" class="o_forecasted_replenish_btn btn btn-primary">
            Replenish
        </button>
        <button title="Update Quantity" t-on-click="_onClickUpdateQuantity" class="o_forecasted_update_qty_btn btn btn-secondary">
            Update Quantity
        </button>
    </t>

`);
registerTemplate("stock.ForecastedDetails", `/stock/static/src/stock_forecasted/forecasted_details.xml`, `<t t-name="stock.ForecastedDetails" xml:space="preserve">
        <table class="table table-bordered bg-view">
            <thead>
                <tr class="bg-light">
                    <td>Replenishment</td>
                    <td>Receipt</td>
                    <td t-if="props.docs.multiple_product">Product</td>
                    <td class="text-end"><t t-out="props.docs.uom"/></td>
                    <td>Used by</td>
                    <td>Delivery</td>
                </tr>
            </thead>
            <tbody>
                <tr t-if="onHandCondition">
                    <td>Inventory On Hand</td>
                    <td/>
                    <td t-if="props.docs.multiple_product"/>
                    <td class="text-end">0</td>
                    <td/>
                    <td/>
                    <td/>
                    <td/>
                </tr>
                <tr t-foreach="props.docs.lines" t-as="line" t-key="line_index" t-attf-class="#{line.is_matched and 'o_grid_match table-info'}">
                    <td t-attf-class="#{line.is_late and 'o_grid_warning table-danger'}">
                        <a t-if="line.document_in" href="#" t-on-click.prevent="() =&gt; this.props.openView(line.document_in._name, 'form', line.document_in.id)" t-out="line.document_in.name" class="fw-bold"/>

                        <t t-elif="line.reservation">
                            <a t-out="line.reservation.name" href="#" class="fw-bold" t-on-click.prevent="() =&gt; this.props.openView(line.reservation._name, 'form', line.reservation.id)"/> reserved
                            <button t-if="displayReserve(line)" class="btn btn-sm btn-primary o_report_replenish_unreserve" name="unreserve_link" t-on-click="() =&gt; this._unreserve(line.move_out.id)">
                                Unreserve
                            </button>
                        </t>
                        <t t-elif="line.in_transit">
                            <t t-if="line.move_out">
                                <span>Stock In Transit</span>
                            </t>
                            <t t-else="">
                                <span>Free Stock in Transit</span>
                            </t>
                        </t>
                        <t t-elif="line.replenishment_filled">
                            <t t-if="line.document_out">Inventory On Hand
                                <button t-if="displayReserve(line)" class="btn btn-sm btn-primary" name="reserve_link" t-on-click="() =&gt; this._reserve(line.move_out.id)">
                                    Reserve
                                </button>
                            </t>
                            <t t-else="">Free Stock</t>
                        </t>
                        <span t-else="" class="text-muted">Not Available</span>
                    </td>
                    <td t-out="line.receipt_date or ''" t-attf-class="#{line.is_late and 'o_grid_warning table-danger'}"/>
                    <td t-if="props.docs.multiple_product" t-out="line.product.display_name"/>
                    <td class="text-end"><t t-if="! line.replenishment_filled">- </t><t t-out="_formatFloat(line.quantity)"/></td>
                    <td t-attf-class="#{! line.replenishment_filled and 'o_grid_warning table-danger'}" name="usedby_cell">
                        <button t-if="line.move_out and line.move_out.picking_id" t-attf-class="o_priority o_priority_star me-1 fa fa-star#{line.move_out.picking_id.priority=='1' ? '' : '-o'}" t-on-click="() =&gt; this._onClickChangePriority('stock.picking', line.move_out.picking_id)" name="change_priority_link"/>
                        <a t-if="line.document_out" href="#" t-on-click.prevent="() =&gt; this.props.openView(line.document_out._name, 'form', line.document_out.id)" t-out="line.document_out.name" class="fw-bold"/>
                    </td>
                    <td t-out="line.delivery_date or ''" t-attf-class="#{! line.replenishment_filled and 'o_grid_warning table-danger'}"/>
                </tr>
                <tr t-if="this.props.docs.qty_to_order">
                    <td>To Order</td>
                    <td t-out="this.props.docs.lead_days_date"/>
                    <td t-out="_formatFloat(this.props.docs.qty_to_order)" class="text-end"/>
                </tr>
                <tr t-if="this.props.docs.qty_to_order !== this.props.docs.qty_to_order_with_visibility_days">
                    <td>To Order with Visibility Days</td>
                    <td t-out="this.props.docs.visibility_days_date"/>
                    <td t-out="_formatFloat(this.props.docs.qty_to_order_with_visibility_days)" class="text-end"/>
                </tr>
            </tbody>
            <thead>
                <tr class="o_forecasted_row bg-200">
                    <td colspan="2">Forecasted Inventory</td>
                    <td t-out="_formatFloat(this.props.docs.virtual_available)" class="text-end"/>
                </tr>
            </thead>
            <tbody t-if="props.docs.qty.in or props.docs.qty.out">
                <tr t-if="props.docs.draft_picking_qty.in" name="draft_picking_in">
                    <td colspan="2">Incoming Draft Transfer</td>
                    <td t-out="_formatFloat(this.props.docs.draft_picking_qty.in)" class="text-end"/>
                </tr>
                <tr t-if="props.docs.draft_picking_qty.out" name="draft_picking_out">
                    <td colspan="2">Outgoing Draft Transfer</td>
                    <td t-out="_formatFloat(this.props.docs.draft_picking_qty.out)" class="text-end"/>
                </tr>
            </tbody>
            <thead>
                <tr class="o_forecasted_row bg-200">
                    <td colspan="2">Forecasted with Pending</td>
                    <td t-out="_formatFloat(futureVirtualAvailable)" class="text-end"/>
                </tr>
            </thead>
        </table>
    </t>
`);
registerTemplate("stock.ForecastedHeader", `/stock/static/src/stock_forecasted/forecasted_header.xml`, `<t t-name="stock.ForecastedHeader" xml:space="preserve">
        <div class="d-flex flex-wrap pb-2 justify-content-between">
            <div class="o_product_name">
                <h3>
                    <t t-if="props.docs.product_templates">
                        <t t-foreach="props.docs.product_templates" t-as="product_template" t-key="product_template.id">
                            <a href="#" t-on-click.prevent="() =&gt; this.props.openView('product.template', 'form', product_template.id)" t-out="product_template.display_name"/>
                        </t>
                    </t>
                    <t t-elif="props.docs.product_variants">
                        <t t-foreach="props.docs.product_variants" t-as="product_variant" t-key="product_variant.id">
                            <a href="#" t-on-click.prevent="() =&gt; this.props.openView('product.product', 'form', product_variant.id)" t-out="product_variant.display_name"/>
                        </t>
                    </t>
                </h3>
                <h6 t-if="props.docs.product_templates and props.docs.product_variants and props.docs.product_templates.length != props.docs.product_variants.length" name="product_variants">
                    <t t-foreach="props.docs.product_variants" t-as="product_variant" t-key="product_variant.id">
                        <a href="#" t-on-click.prevent="() =&gt; this.props.openView('product.product', 'form', product_variant.id)">
                            [<t t-out="product_variant.combination_name"/>]
                        </a>
                    </t>
                </h6>
            </div>
            <div class="row">
                <div class="col-md-auto text-center">
                    <div class="h3">
                        <a href="#" t-on-click.prevent="() =&gt; this._onClickInventory()" t-out="_formatFloat(this.props.docs.quantity_on_hand)"/>
                    </div>
                    <div>On Hand</div>
                </div>
                <div class="h3 col-md-auto text-center">+</div>
                <div t-attf-class="col-md-auto text-center #{props.docs.incoming_qty}">
                    <div class="h3">
                        <t t-out="_formatFloat(this.props.docs.incoming_qty)"/>
                    </div>
                    <div>Incoming</div>
                </div>
                <div class="h3 col-md-auto text-center">-</div>
                <div t-attf-class="col-md-auto text-center #{props.docs.outgoing_qty}">
                    <div class="h3">
                        <t t-out="_formatFloat(this.props.docs.outgoing_qty)"/>
                    </div>
                    <div>Outgoing</div>
                </div>
                <div class="h3 col-md-auto text-center">=</div>
                <div t-attf-class="col-md-auto text-center #{props.docs.virtual_available &lt; 0 and 'text-danger'}" name="forecasted_value">
                    <div class="h3">
                        <span t-out="_formatFloat(this.props.docs.virtual_available)"/>
                        <span t-out="' ' + props.docs.uom" groups="uom.group_uom"/>
                    </div>
                    <div>Forecasted</div>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("stock.ForecastedWarehouseFilter", `/stock/static/src/stock_forecasted/forecasted_warehouse_filter.xml`, `<t t-name="stock.ForecastedWarehouseFilter" xml:space="preserve">
        <div t-if="displayWarehouseFilter" class="btn-group">
            <Dropdown menuClass="o_filter_menu" items="warehousesItems">
                <button class="btn btn-secondary">
                    <span class="fa fa-home"/> Warehouse: <t t-out="activeWarehouse.name"/>
                </button>
            </Dropdown>
        </div>
    </t>

`);
registerTemplate("stock.Forecasted", `/stock/static/src/stock_forecasted/stock_forecasted.xml`, `<div t-name="stock.Forecasted" class="o_action" xml:space="preserve">
        <ControlPanel>
            <t t-set-slot="layout-buttons">
                <ForecastedButtons action="props.action" reloadReport.bind="reloadReport" resModel="resModel"/>
            </t>
            <t t-set-slot="layout-actions">
                <div class="btn-group o_search_options position-static" role="search">
                    <ForecastedWarehouseFilter action="props.action" warehouses="warehouses" setWarehouseInContext.bind="updateWarehouse"/>
                </div>
            </t>
        </ControlPanel>
        <div class="o-content pt-3 container-fluid overflow-auto o_stock_forecasted_page">
            <ForecastedHeader docs="docs" openView.bind="openView"/>
            <t t-if="context.warehouse_id">
                <View type="'graph'" viewId="stock_report_view_graph" resModel="'report.stock.quantity'" domain="graphDomain" display="{controlPanel: false}" context="{fill_temporal: false}" info="graphInfo" useSampleModel="true"/>
            </t>
            <ForecastedDetails docs="docs" openView.bind="openView" reloadReport.bind="reloadReport"/>
        </div>
    </div>
`);
registerTemplate("stock.MovesListRenderer.RecordRow", `/stock/static/src/views/picking_form/stock_move_one2many.xml`, `<t t-name="stock.MovesListRenderer.RecordRow" t-inherit-mode="primary" t-inherit="web.ListRenderer.RecordRow" xml:space="preserve">
        <xpath expr="//tr/t[1]" position="inside">
            <t t-if="column.type === 'opendetailsop'">
                <td class="o_data_cell cursor-pointer o_list_button">
                    <t t-if="record.resModel === 'stock.move' &amp;&amp; record.data?.show_details_visible">
                        <button name="Open Move" class="btn btn-link fa fa-list" t-on-click="() =&gt; props.openRecord(record)"/>
                    </t>
                </td>
            </t>
        </xpath>
    </t>

`);
registerTemplate("stock.StockOrderpointSearchPanel.Regular", `/stock/static/src/views/search/stock_orderpoint_search_panel.xml`, `<t t-name="stock.StockOrderpointSearchPanel.Regular" t-inherit="web.SearchPanel.Regular" xml:space="preserve">
        <xpath expr="//div[contains(@class, 'o_search_panel')]" position="inside">
            <section class="o_search_panel_section o_search_panel_filter">
                <header class="o_search_panel_section_header pt-4 pb-2 text-uppercase cursor-default">
                    <i t-attf-class="fa fa-clock-o o_search_panel_section_icon text-warning me-2"/>
                    <b>Horizon</b>
                </header>

                <div class="input-group">
                    <input type="number" min="0" t-att-value="globalVisibilityDays.value" class="form-control" aria-describedby="days-label" t-on-change="applyGlobalVisibilityDays"/>
                    <span class="input-group-text" id="days-label">days</span>
                </div>
            </section>
        </xpath>
    </t>

    `);
registerTemplate("stock.StockOrderpointSearchPanel", `/stock/static/src/views/search/stock_orderpoint_search_panel.xml`, `<t t-name="stock.StockOrderpointSearchPanel" t-inherit="web.SearchPanel" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-call='web.SearchPanel.Regular']" position="attributes">
            <attribute name="t-call">stock.StockOrderpointSearchPanel.Regular</attribute>
        </xpath>
    </t>
`);
registerTemplate("stock.StockReportSearchPanel.Regular", `/stock/static/src/views/search/stock_report_search_panel.xml`, `<t t-name="stock.StockReportSearchPanel.Regular" t-inherit="web.SearchPanel.Regular" xml:space="preserve">
    <xpath expr="//div/section[1]" position="before">
        <section t-if="warehouses.length &gt; 1" class="o_search_panel_section o_search_panel_warehouse">
            <header class="o_search_panel_section_header pt-4 pb-2 text-uppercase o_cursor_default">
                <i t-attf-class="fa fa-filter o_search_panel_section_icon text-warning me-2"/>
                <b>Warehouses</b>
            </header>
            <ul class="list-group d-block o_search_panel_field">
                <li class="o_search_panel_filter_value list-group-item p-0 mb-1 border-0 o_cursor_pointer">
                    <span t-on-click="ev =&gt; this.clearWarehouseContext(ev)" t-att-class="{'fw-bolder': !selectedWarehouse, 'o_search_panel_label_title':true}">All Warehouses</span>
                </li>
                <li class="o_search_panel_filter_value list-group-item p-0 mb-1 border-0 o_cursor_pointer" t-foreach="warehouses" t-as="warehouse" t-key="warehouse.id">
                    <div t-out="warehouse.name" t-on-click="ev =&gt; this.applyWarehouseContext(warehouse.id, ev)" t-att-class="{'fw-bolder': selectedWarehouse === warehouse.id, 'o_search_panel_label_title':true,                         'bg-info-subtle': selectedWarehouse === warehouse.id}"/>
                </li>
            </ul>
        </section>
    </xpath>
</t>

`);
registerTemplate("stock.StockReportSearchPanel", `/stock/static/src/views/search/stock_report_search_panel.xml`, `<t t-name="stock.StockReportSearchPanel" t-inherit="web.SearchPanel" t-inherit-mode="primary" xml:space="preserve">
    <xpath expr="//t[@t-call='web.SearchPanel.Regular']" position="attributes">
        <attribute name="t-call">stock.StockReportSearchPanel.Regular</attribute>
    </xpath>
</t>

`);
registerTemplate("stock.StockListRenderer", `/stock/static/src/views/stock_empty_list_help.xml`, `<t t-name="stock.StockListRenderer" t-inherit="web.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <t t-call="web.ActionHelper" position="replace">
            <t t-if="showNoContentHelper">
                <StockActionHelper noContentHelp="props.noContentHelp"/>
            </t>
        </t>
    </t>

    `);
registerTemplate("stock.StockActionHelper", `/stock/static/src/views/stock_empty_list_help.xml`, `<t t-name="stock.StockActionHelper" xml:space="preserve">
        <div class="o_view_nocontent">
            <div t-on-click="handler" class="o_nocontent_help">
                <t t-out="props.noContentHelp"/>
            </div>
        </div>
    </t>

`);
registerTemplate("stock.StockOrderpoint.listView", `/stock/static/src/views/stock_orderpoint_list_view.xml`, `<t t-name="stock.StockOrderpoint.listView" t-inherit="web.ListView" xml:space="preserve">
        <xpath expr="//t[@t-call='web.ListView.Selection']" position="after">
            <Dropdown>
                <button class="btn btn-secondary">
                    <span class="o_dropdown_title">Replenish</span>
                    <i class="fa fa-caret-down ms-1"/>
                </button>
                <t t-set-slot="content">
                    <DropdownItem t-if="nbSelected" onSelected="() =&gt; this.onClickOrder(false)">
                        Order
                    </DropdownItem>
                    <DropdownItem t-if="nbSelected" onSelected="() =&gt; this.onClickOrder(true)">
                        Order To Max
                    </DropdownItem>
                </t>
            </Dropdown>
            <button t-if="nbSelected" type="button" t-on-click="onClickSnooze" class="o_button_snooze btn btn-secondary me-1">
                Snooze
            </button>
        </xpath>
    </t>

`);
registerTemplate("stock.ForecastWidget", `/stock/static/src/widgets/forecast_widget.xml`, `<t t-name="stock.ForecastWidget" xml:space="preserve">
        <span t-if="!forecastExpectedDate and willBeFulfilled" class="text-success">
            Available
        </span>
        <span t-elif="forecastExpectedDate and willBeFulfilled" t-att-class="forecastIsLate ? 'text-danger' : 'text-warning'">
            Exp <t t-out="forecastExpectedDate"/>
        </span>
        <span t-else="" class="text-danger">Not Available</span>
        <button t-if="props.record.data.is_storable" title="Forecasted Report" t-on-click="_openReport" t-att="resId ? {} : {'disabled': ''}" class="o_forecast_report_button btn btn-link o_icon_button ms-2 pt-0">
            <i class="fa fa-fw fa-area-chart" t-att-class="state != 'draft' and (!willBeFulfilled or forecastIsLate) ? 'text-danger' : ''"/>
        </button>
    </t>

`);
registerTemplate("stock.leadDays", `/stock/static/src/widgets/json_widget.xml`, `<div t-name="stock.leadDays" xml:space="preserve">
        <h2>Lead Times</h2>
        <hr/>
        <p>
            The forecasted stock on the <b t-esc="jsonValue.lead_days_date"/>
            is <t t-if="jsonValue.qty_to_order &lt;= 0"><b><t t-esc="qtyForecast"/></b></t><t t-else="">
            below the inventory <b>minimum of <t t-esc="productMinQty"/>
            : <t t-esc="qtyToOrder"/> should be replenished</b> to reach the maximum of
            <t t-esc="productMaxQty"/>.</t>
        </p>
        <table t-if="jsonValue.lead_days_description" class="table table-borderless table-sm">
            <tbody>
                <tr>
                    <td>Today</td>
                    <td class="text-end" t-out="jsonValue.today"/>
                </tr>
                <tr t-foreach="jsonValue.lead_days_description" t-key="descr" t-as="descr">
                    <td t-out="descr[0]"/>
                    <td class="text-end" t-out="descr[1]"/>
                </tr>
                <tr class="table-info">
                    <td>Forecasted Date</td>
                    <td class="text-end text-nowrap">
                        = <t t-out="jsonValue.lead_days_date"/>
                    </td>
                </tr>
                <tr t-if="jsonValue.visibility_days &gt; 0">
                    <td>Visibility days</td>
                    <td class="text-end text-nowrap">
                        + <t t-out="jsonValue.visibility_days"/> Day(s)
                    </td>
                </tr>
                <tr t-if="jsonValue.visibility_days &gt; 0" class="table-info fw-bold">
                    <td>Forecasted Date + Visibility Days</td>
                    <td class="text-end text-nowrap">
                        = <t t-out="jsonValue.visibility_days_date"/>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>

    `);
registerTemplate("stock.replenishmentHistory", `/stock/static/src/widgets/json_widget.xml`, `<div t-name="stock.replenishmentHistory" xml:space="preserve">
        <h2>Sales History</h2>
        <hr/>
        <table t-if="jsonValue.replenishment_history" class="table table-borderless">
            <tbody>
                <t t-foreach="jsonValue.replenishment_history" t-key="line.name" t-as="line">
                    <tr>
                        <td><t t-esc="line.name"/></td>
                        <td class="text-end text-nowrap" t-esc="line.quantity + ' ' + line.uom_name"/>
                    </tr>
                </t>
            </tbody>
        </table>
    </div>
`);
registerTemplate("stock.GenerateSerials", `/stock/static/src/widgets/lots_dialog.xml`, `<t t-name="stock.GenerateSerials" xml:space="preserve">
        <button class="btn btn-link" t-on-click="openDialog">Generate Serials/Lots</button>
    </t>
    `);
registerTemplate("stock.ImportLots", `/stock/static/src/widgets/lots_dialog.xml`, `<t t-name="stock.ImportLots" xml:space="preserve">
        <button class="btn btn-link" t-on-click="openDialog">Import Serials/Lots</button>
    </t>
    `);
registerTemplate("stock.generate_serial_dialog", `/stock/static/src/widgets/lots_dialog.xml`, `<t t-name="stock.generate_serial_dialog" xml:space="preserve">
        <Dialog size="size" title="title" withBodyPadding="false">
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="_onGenerate">Generate</button>
                <button class="btn btn-secondary" t-on-click="() =&gt; this.props.close()">
                    Discard
                </button>
            </t>
            <div class="o_form_view o_form_nosheet">
                <t t-if="props.mode === 'generate'">
                    <div class="grid o_inner_group">
                        <div class="d-flex d-sm-contents">
                            <div class="o_cell flex-grow-0 flex-sm-grow-0 text-900 pe-3">
                                <label class="o_form_label" for="next_serial_0">
                                    <t t-if="props.move.data.has_tracking === 'lot'">First Lot Number</t>
                                    <t t-else="">First Serial Number</t>
                                </label>
                            </div>
                            <div class="o_cell flex-grow-1 flex-sm-grow-0">
                                <div name="next_serial" class="o_field_widget o_field_char">
                                    <input placeholder="e.g. LOT-PR-00012" class="o_input" t-ref="nextSerial" id="next_serial_0" type="text"/>
                                </div>
                            </div>
                        </div>
                        <div class="d-flex d-sm-contents">
                            <div class="o_cell flex-grow-0 flex-sm-grow-0 text-900 pe-3">
                                <label class="o_form_label" for="next_serial_count_0">
                                    <t t-if="props.move.data.has_tracking === 'lot'">Quantity per Lot</t>
                                    <t t-else="">Number of SN</t>
                                </label>
                            </div>
                            <div class="o_row">
                                <div class="o_cell flex-grow-1 flex-sm-grow-0">
                                    <div name="next_serial_count" class="o_field_widget o_field_integer">
                                        <input inputmode="numeric" t-ref="nextSerialCount" class="o_input" id="next_serial_count_0" type="text"/>
                                    </div>
                                </div>
                                <span t-if="props.move.data.has_tracking === 'lot'" t-esc="props.move.data.product_uom[1]"/>
                            </div>
                        </div>
                        <div t-if="props.move.data.has_tracking === 'lot'" class="d-flex d-sm-contents">
                            <div class="o_cell flex-grow-0 flex-sm-grow-0 text-900 pe-3">
                                <label class="o_form_label" for="total_received_0">Quantity Received</label>
                            </div>
                            <div class="o_row">
                                <div class="o_cell flex-grow-1 flex-sm-grow-0">
                                    <div name="total_received" class="o_field_widget o_field_integer">
                                        <input inputmode="numeric" t-ref="totalReceived" class="o_input" id="total_received_0" type="text"/>
                                    </div>
                                </div>
                                <span t-esc="props.move.data.product_uom[1]"/>
                            </div>
                        </div>
                        <div class="d-flex d-sm-contents">
                            <div class="o_cell flex-grow-0 flex-sm-grow-0 text-900 pe-3">
                                <label class="o_form_label" for="keep_lines_0">Keep current lines</label>
                            </div>
                            <div class="o_cell flex-grow-1 flex-sm-grow-0">
                                <div name="keep_lines">
                                    <input type="checkbox" t-ref="keepLines" id="keep_lines_0"/>
                                </div>
                            </div>
                        </div>
                    </div>
                </t>
                <t t-if="props.mode === 'import'" class="d-flex">
                    <div class="grid o_inner_group">
                        <div class="d-flex">
                            <div class="o_cell flex-grow-0 flex-sm-grow-0 text-900 pe-3">
                                <label class="o_form_label" for="next_serial_0">
                                    <t t-if="props.move.data.has_tracking==='lot'">Lot numbers</t>
                                    <t t-else="">Serial numbers</t>
                                </label>
                            </div>
                        </div>
                        <div class="o_cell flex-grow-1 flex-sm-grow-0">
                            <div name="next_serial" class="o_field_widget o_field_char">
                                <textarea placeholder="Write one lot/serial name per line, followed by the quantity." class="o_input" t-ref="lots" id="next_serial_0" type="text"/>
                            </div>
                        </div>
                        <div class="d-flex">
                            <div class="o_cell flex-grow-0 flex-sm-grow-0 text-900 pe-3">
                                <label class="o_form_label" for="keep_lines_0">Keep current lines</label>
                            </div>
                        </div>
                        <div class="o_cell flex-grow-1 flex-sm-grow-0">
                            <div name="keep_lines">
                                <input type="checkbox" t-ref="keepLines" id="keep_lines_0"/>
                            </div>
                        </div>
                    </div>
                </t>
            </div>
        </Dialog>
    </t>
`);
registerTemplate("stock.popoverButton", `/stock/static/src/widgets/popover_widget.xml`, `<t t-name="stock.popoverButton" xml:space="preserve">
        <a tabindex="0" t-on-click.stop="showPopup" t-attf-class="p-1 fa #{ icon || 'fa-info-circle'} #{ color || 'text-primary'}"/>
    </t>

    `);
registerTemplate("stock.popoverContent", `/stock/static/src/widgets/popover_widget.xml`, `<div t-name="stock.popoverContent" class="m-3" xml:space="preserve">
        <h6 t-out="props.title"/>
        <t t-if="props.popoverTemplate" t-call="{{props.popoverTemplate}}"/>
        <t t-else="" t-out="props.msg"/>
    </div>
`);
registerTemplate("stock.PopoverStockRescheduling", `/stock/static/src/widgets/stock_rescheduling_popover.xml`, `<div t-name="stock.PopoverStockRescheduling" xml:space="preserve">
        <h6>Planning Issue</h6>
        <p>Preceding operations
        <t t-foreach="props.late_elements" t-as="late_element" t-key="late_element.id">
            <a t-out="late_element.name" t-on-click="openElement" href="#" t-att-element-id="late_element.id" t-att-element-model="late_element.model"/>,
        </t>
        planned on <t t-out="props.delay_alert_date"/>.</p>
    </div>
`);
registerTemplate("InventoryLines.Buttons", `/stock/static/src/xml/inventory_lines.xml`, `<t t-name="InventoryLines.Buttons" xml:space="preserve">
        <button type="button" class="btn btn-primary o_button_validate_inventory">
            Validate Inventory
        </button>
    </t>
`);
registerTemplate("reception_report_buttons", `/stock/static/src/xml/report_stock_reception.xml`, `<t t-name="reception_report_buttons" xml:space="preserve">
    <button name="assign_all_link" class="btn btn-secondary o_report_reception_assign o_assign_all">
        Assign All
    </button>
    <button name="print_all_labels" class="btn btn-secondary o_print_label o_print_label_all">
        Print Labels
    </button>
</t>
`);
registerTemplate("DatabaseExpirationPanel", `/web_enterprise/static/src/webclient/home_menu/expiration_panel.xml`, `<t t-name="DatabaseExpirationPanel" xml:space="preserve">
    <div role="alert" class="database_expiration_panel alert o-hidden-ios text-center mt-4" t-attf-class="alert-{{alertType}}">

        <a t-if="subscription.daysLeft &gt; 0" href="#" class="oe_instance_hide_panel float-end alert-link" t-on-click.prevent="() =&gt; subscription.hideWarning()" aria-label="Dismiss">×</a>
        <span t-if="!subscription.lastRequestStatus" class="oe_instance_register">
            <t t-if="!subscription.hasInstalledApps">You will be able to register your database once you have installed your first app.</t>
            <t t-else="">
                <t t-esc="expirationMessage"/>
                <t t-if="subscription.warningType === 'admin'">
                    <t t-if="subscription.unregistered">
                        <a class="oe_instance_register_show alert-link text-decoration-underline" href="#" t-on-click.prevent="showRegistrationForm">Register your subscription</a>
                        or
                        <a class="oe_instance_buy alert-link text-decoration-underline" href="#" t-on-click.prevent="() =&gt; subscription.buy()">buy a subscription</a>.
                    </t>
                    <t t-if="subscription.expirationReason === 'renewal'">
                        <div class="d-flex flex-wrap justify-content-center mt-2">
                            <a class="oe_instance_renew btn btn-link" href="#" t-on-click.prevent="() =&gt; subscription.renew()">Renew your subscription </a>
                            <a class="check_enterprise_status btn btn-link" href="#" t-on-click.prevent="() =&gt; subscription.checkStatus()">I paid, please recheck!</a>
                        </div>
                    </t>
                    <t t-elif="subscription.expirationReason === 'upsell'">You have more users or more apps installed than your subscription allows.<br/>
                        <div class="d-flex flex-wrap justify-content-center mt-2">
                            <a class="oe_instance_upsell btn btn-link" href="#" t-on-click.prevent="() =&gt; subscription.upsell()">Upgrade your subscription </a>
                            <a class="check_enterprise_status btn btn-link" href="#" t-on-click.prevent="() =&gt; subscription.checkStatus()">I paid, please recheck!</a>
                        </div>
                    </t>
                </t>
                <t t-elif="subscription.warningType === 'user'">Log in as an administrator to correct the issue.</t>
            </t>
        </span>
        <span t-if="subscription.lastRequestStatus === 'success'" class="oe_instance_register oe_instance_success">Thank you, your registration was successful! Your database is valid until <span><t t-esc="subscription.formattedExpirationDate"/></span>.</span>
        <span t-elif="subscription.lastRequestStatus === 'update'" class="oe_instance_register oe_subscription_updated">Your subscription was updated and is valid until <span><t t-esc="subscription.formattedExpirationDate"/></span>.</span>
        <span t-elif="subscription.lastRequestStatus === 'error'" class="oe_instance_register oe_instance_error">Something went wrong while registering your database. You can try again or contact <a class="alert-link text-decoration-underline" href="https://www.odoo.com/help" target="_blank">Odoo Support</a>.</span>
        <span t-elif="subscription.lastRequestStatus === 'link'" class="oe_instance_register oe_database_already_linked">
            Your subscription is already linked to a database.<br/>
            <span t-if="subscription.linkedEmail" class="oe_contract_email_block">
                <a href="#" class="oe_contract_send_mail alert-link text-decoration-underline" t-on-click.prevent="() =&gt; subscription.sendUnlinkEmail()">Send an email</a> to the subscription owner to confirm the change, enter a new code or <a class="oe_instance_buy" href="#" t-on-click.prevent="() =&gt; subscription.buy()">buy a subscription.</a>
                <p t-if="subscription.mailDeliveryStatus === 'ongoing'">Sending the instructions by email ...</p>
                <p t-elif="subscription.mailDeliveryStatus === 'success'">The instructions to unlink your subscription from the previous database(s) have been sent</p>
                <p t-elif="subscription.mailDeliveryStatus === 'fail'">Unable to send the instructions by email, please contact the <a href="https://www.odoo.com/help" target="_blank">Odoo Support</a><br/>
                    Error reason: <t t-esc="subscription.mailDeliveryStatusError"/>
                </p>
            </span>
            <span t-else="">Contact your sales representative to help you to unlink your previous database</span>
        </span>
        <Transition visible="state.displayRegisterForm and subscription.lastRequestStatus !== 'success'" t-slot-scope="transition" leaveDuration="400" name="'o-vertical-slide'">
            <form class="oe_instance_register oe_instance_register_form d-flex flex-wrap align-items-center overflow-hidden justify-content-center mt-4" t-att-class="transition.className">
                <label for="enterprise_code">Subscription Code: </label>
                <input type="text" class="o_input w-auto mx-2 mb-2 mb-sm-0" t-ref="input" placeholder="Paste code here" title="Your subscription code"/>
                <button class="btn btn-primary" t-on-click.prevent="onCodeSubmit"><t t-esc="buttonText"/></button>
            </form>
        </Transition>
    </div>
</t>

`);
registerTemplate("web_enterprise.HomeMenu", `/web_enterprise/static/src/webclient/home_menu/home_menu.xml`, `<t t-name="web_enterprise.HomeMenu" xml:space="preserve">
    <div t-ref="root" class="o_home_menu h-100 overflow-auto" t-att-class="{ o_ios_app: state.isIosApp }">
        <div class="container">
            <input t-ref="input" type="text" class="o_search_hidden visually-hidden w-auto" data-allow-hotkeys="true" t-on-input="_onInputSearch" t-on-blur="_onInputBlur" t-on-compositionstart="_onCompositionStart" role="combobox" t-att-aria-activedescendant="'result_app_' + state.focusedIndex" t-att-aria-expanded="displayedApps.length ? 'true' : 'false'" aria-autocomplete="list" aria-haspopup="listbox"/>

            <ExpirationPanel t-if="subscription.warningType and !subscription.isWarningHidden and subscription.daysLeft &lt;= 30 and subscription.daysLeft &gt; 0"/>
            <div t-if="displayedApps.length" role="listbox" class="o_apps row user-select-none mt-5 mx-0">
                <div t-foreach="displayedApps" t-as="app" t-key="app.id" class="col-3 col-md-2 o_draggable mb-3 px-0">
                    <a t-att-id="'result_app_' + app_index" role="option" t-att-aria-selected="state.focusedIndex === app_index ? 'true' : 'false'" class="o_app o_menuitem d-flex flex-column rounded-3 justify-content-start align-items-center w-100 p-1 p-md-2" t-att-class="{o_focused: state.focusedIndex === app_index}" t-att-data-menu-xmlid="app.xmlid" t-att-href="app.href" t-on-click.prevent="() =&gt; this._onAppClick(app)">
                        <img t-if="app.webIconData" class="o_app_icon rounded-3" t-attf-src="{{app.webIconData}}"/>
                        <div t-else="" class="o_app_icon position-relative d-flex justify-content-center align-items-center p-2 rounded-3 ratio ratio-1x1" t-attf-style="background-color: {{app.webIcon.backgroundColor}};">
                            <i t-attf-class="{{app.webIcon.iconClass}} position-relative w-auto h-auto" t-attf-style="color: {{app.webIcon.color}};"/>
                        </div>
                        <div class="o_caption w-100 text-center text-truncate mt-2" t-esc="app.label or app.name"/>
                    </a>
                </div>
            </div>
            <div t-elif="!displayedApps.length" id="result_menu_0" role="option" aria-selected="true" class="o_no_result">
                No result
            </div>
        </div>
    </div>
</t>

`);
registerTemplate("web_enterprise.HomeMenu.CommandPalette.Footer", `/web_enterprise/static/src/webclient/home_menu/home_menu.xml`, `<t t-name="web_enterprise.HomeMenu.CommandPalette.Footer" xml:space="preserve">
    <span>
        <span class="fw-bolder text-primary">TIP</span> — open me anywhere with <span t-esc="controlKey" class="fw-bolder text-primary"/> + <span class="fw-bolder text-primary">K</span>
    </span>
</t>

`);
registerTemplate("web_enterprise.EnterpriseNavBar", `/web_enterprise/static/src/webclient/navbar/navbar.xml`, `<t t-name="web_enterprise.EnterpriseNavBar" t-inherit="web.NavBar" t-inherit-mode="primary" xml:space="preserve">
    <xpath expr="//nav" position="attributes">
        <attribute name="t-ref">nav</attribute>
    </xpath>
    <xpath expr="//t[@t-call='web.NavBar.AppsMenu']" position="replace">
        <a t-if="!isScopedApp" href="/odoo" class="o_menu_toggle border-0" t-att-class="{'hasImage': currentApp?.webIconData}" accesskey="h" t-ref="menuApps" t-on-click.prevent="() =&gt; { env.isSmall ? this._openAppMenuSidebar() : this.hm.toggle() }">
            <t t-if="env.isSmall and !hm.hasHomeMenu">
                <t t-call="web.NavBar.AppsMenu.Sidebar"/>
            </t>
            <t t-else="">
                <svg xmlns="http://www.w3.org/2000/svg" class="o_menu_toggle_icon pe-none" width="14px" height="14px" viewBox="0 0 14 14">
                    <g t-foreach="[0, 5, 10]" t-as="Y" t-att-id="'o_menu_toggle_row_' + Y_index" fill="currentColor" t-key="'o_menu_toggle_row_' + Y_index">
                        <rect t-foreach="[0, 5, 10]" t-as="X" width="3" height="3" t-att-x="X" t-att-y="Y" t-key="'o_menu_toggle_cell_' + X_index"/>
                    </g>
                </svg>
                <t t-if="!env.isSmall and currentApp">
                    <img t-if="currentApp.webIconData" t-att-src="currentApp.webIconData" class="o_menu_brand_icon d-inline position-absolute start-0 h-100 ps-1 ms-2" t-att-alt="currentApp.name" t-ref="appIcon"/>
                    <span t-esc="currentApp.name" class="o_menu_brand d-flex ms-3 pe-0"/>
                </t>
            </t>
        </a>
        <a t-else="" t-att-href="pwa.startUrl" class="o_menu_toggle" t-ref="menuApps">
            <img t-if="currentApp &amp;&amp; currentApp.webIconData" t-att-src="currentApp.webIconData" class="o_menu_brand_icon d-none d-lg-inline position-absolute start-0 h-100 ps-1 ms-2" t-att-alt="currentApp.name" t-ref="appIcon"/>

            <span t-if="currentApp" t-esc="currentApp.name" class="o_menu_brand d-none d-md-flex ps-4 pe-0"/>
        </a>
    </xpath>

    <xpath expr="//DropdownItem[@t-esc='currentApp.name']" position="replace"/>
</t>

`);
registerTemplateExtension("web.NavBar.SectionsMenu", `/web_enterprise/static/src/webclient/navbar/navbar.xml`, `<t t-name="web_enterprise.EnterpriseNavBar.SectionsMenu" t-inherit="web.NavBar.SectionsMenu" t-inherit-mode="extension" xml:space="preserve">
    <xpath expr="//Dropdown/button" position="attributes">
        <attribute name="class" add="fw-normal" separator=" "/>
    </xpath>
</t>

`);
registerTemplate("web_enterprise.PromoteStudioDialog", `/web_enterprise/static/src/webclient/promote_studio_dialog/promote_studio_dialog.xml`, `<t t-name="web_enterprise.PromoteStudioDialog" xml:space="preserve">
        <Dialog title="props.title" modalRef="modalRef">
            <div class="modal-studio">
                <div id="studio_install_dialog" class="d-flex flex-row align-items-center flex-wrap">
                    <div id="studio_dialog_pitch" class="w-100 w-md-50">
                        <h4>Want to tailor-make your Odoo?</h4>
                        <p>Unleash the power of Odoo Studio:</p>
                        <ul>
                            <li>Create automation rules</li>
                            <li>Customize any screen</li>
                            <li>Customize Reports</li>
                            <li>Build new reports</li>
                            <li>Build new apps from scratch</li>
                            <li>Define webhooks</li>
                            <li>and more!</li>
                        </ul>
                        <a role="button" class="btn btn-secondary btn-block" href="https://www.odoo.com/app/studio" target="_blank"> Learn More <i class="fa fa-external-link"/>
                        </a>
                    </div>
                    <div id="studio_video" class="o_video_embed w-100 w-md-50 ratio ratio-16x9">
                        <iframe class="embed-responsive-item" t-attf-src="https://www.youtube.com/embed/xCvFZrrQq7k?autoplay=1" frameborder="0" allowfullscreen="true"/>
                    </div>
                </div>

                <t t-set-slot="footer">
                    <button class="btn btn-primary btn-block o_install_studio" t-on-click.stop="onClickInstallStudio" data-tooltip="Install Odoo Studio and its dependencies">
                        Start using Odoo Studio
                    </button>

                    <button class="btn btn-secondary btn-block" t-on-click="props.close">
                        Discard
                    </button>
                </t>
            </div>
        </Dialog>
    </t>


    `);
registerTemplate("web_enterprise.PromoteStudioAutomationDialog", `/web_enterprise/static/src/webclient/promote_studio_dialog/promote_studio_dialog.xml`, `<t t-name="web_enterprise.PromoteStudioAutomationDialog" t-inherit="web_enterprise.PromoteStudioDialog" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[@id='studio_video']" position="replace">
            <img class="w-100 w-md-50" src="/web_enterprise/static/img/automation.svg"/>
        </xpath>
    </t>

`);
registerTemplateExtension("res_config_edition", `/web_enterprise/static/src/webclient/settings_form_view/res_config_edition.xml`, `<t t-inherit="res_config_edition" t-inherit-mode="extension" xml:space="preserve">

        <xpath expr="//h3" position="replace">
            <h3 class="px-0">
                Odoo <t t-esc="serverVersion"/> (Enterprise Edition)
            </h3>
        </xpath>

        <xpath expr="//*[@id='license']" position="replace">
            <a id="license" target="_blank" href="https://www.odoo.com/documentation/master/legal/licenses.html" style="text-decoration: underline;">Odoo Enterprise Edition License V1.0</a>
        </xpath>

        <xpath expr="//h3" position="after">
            <t t-if="expirationDate">
                <h5>Database expiration: <t t-esc="expirationDate"/></h5>
            </t>
        </xpath>

    </t>

`);
registerTemplate("web_enterprise.BurgerMenu", `/web_enterprise/static/src/webclient/share_url/burger_menu.xml`, `<t t-name="web_enterprise.BurgerMenu" t-inherit="web.BurgerMenu" t-inherit-mode="primary" xml:space="preserve">
    <xpath expr="//button[hasclass('o_sidebar_close')]" position="replace">
        <div class="d-flex align-items-center h-100 bg-transparent">
            <button class="o_burger_menu_share fa fa-share-alt btn border-0 fs-5 text-reset" aria-label="Share URL" title="Share URL" t-on-click.stop="shareUrl"/>
            <button class="o_sidebar_close oi oi-close btn border-0 fs-2 text-reset" aria-label="Close menu" title="Close menu" t-on-click.stop="_closeBurger"/>
        </div>
    </xpath>
</t>

`);
registerTemplate("account_accountant.BankRecRecordFormButtonsHeaderLeft", `/account_accountant/static/src/components/bank_reconciliation/bank_rec_form.xml`, `<t t-name="account_accountant.BankRecRecordFormButtonsHeaderLeft" xml:space="preserve">
        <div class="o_statusbar_buttons o_bank_rec_stats_buttons_aside_left py-1 ps-1">
            <t t-set="areAllLinesValid" t-value="this.checkBankRecLinesInvalidFields(data)"/>
            <button accesskey="v" class="btn btn-primary" t-if="data.state === 'valid' and areAllLinesValid" t-on-click="(ev) =&gt; this.actionValidate()">
                <span>Validate</span>
            </button>
            <button class="btn btn-secondary text-muted" t-if="data.state === 'invalid' or (data.state === 'valid' and !areAllLinesValid)">
                <span>Validate</span>
            </button>
            <button accesskey="r" class="btn btn-secondary" t-if="data.state === 'reconciled'" t-on-click="(ev) =&gt; this.actionReset()">
                <span>Reset</span>
            </button>
            <button accesskey="e" class="btn btn-secondary" t-if="data.st_line_checked and areAllLinesValid" t-on-click="(ev) =&gt; this.actionToCheck()">
                <span>To Check</span>
            </button>
            <button class="btn btn-secondary text-muted" t-if="data.st_line_checked and !areAllLinesValid">
                <span>To Check</span>
            </button>
            <button accesskey="e" class="btn btn-secondary" t-if="!data.st_line_checked" t-on-click="(ev) =&gt; this.actionSetAsChecked()">
                <span>Set as Checked</span>
            </button>
        </div>
    </t>


    `);
registerTemplate("account_accountant.BankRecRecordFormButtonsHeaderRight", `/account_accountant/static/src/components/bank_reconciliation/bank_rec_form.xml`, `<t t-name="account_accountant.BankRecRecordFormButtonsHeaderRight" xml:space="preserve">
        <div t-if="hasGroupReadOnly" class="o_statusbar_buttons o_bank_rec_stats_buttons_aside_right">
            <div class="available_reco_model_ids">


                <t t-set="nb_rendered_buttons" t-value="0"/>

                <div class="o_bank_rec_reco_models_widget_div">
                    <t t-foreach="data.available_reco_model_ids.records" t-as="reco_model" t-key="reco_model.data.id">
                        <t t-set="is_selected" t-value="reco_model.data.id === data.selected_reco_model_id[0]"/>

                        <t t-if="reco_model_index lt 5 or is_selected">
                            <button t-att-accesskey="'SHIFT+'+(reco_model_index + 1)" t-on-click="() =&gt; this.actionSelectRecoModel(reco_model)" class="btn recon_model_button me-1 my-1" t-att-class="{'btn-secondary': !is_selected, 'btn-primary': is_selected}" t-out="reco_model.data.display_name"/>

                            <t t-set="nb_rendered_buttons" t-value="nb_rendered_buttons + 1"/>
                        </t>
                    </t>


                    <div t-if="data.available_reco_model_ids.records.length gt nb_rendered_buttons" class="bank_rec_reco_model_dropdown my-1">
                        <Dropdown>
                            <button class="btn btn-light">
                                More
                            </button>
                            <t t-set-slot="content">
                                <t t-foreach="data.available_reco_model_ids.records" t-as="reco_model" t-key="reco_model.data.id">
                                    <t t-set="is_selected" t-value="reco_model.data.id === data.selected_reco_model_id.id"/>
                                    <DropdownItem t-if="reco_model_index gte 5 and !is_selected" onSelected="() =&gt; this.actionSelectRecoModel(reco_model)">
                                        <t t-out="reco_model.data.display_name"/>
                                    </DropdownItem>
                                </t>
                            </t>
                        </Dropdown>
                    </div>
                </div>


                <div class="bank_rec_reco_model_dropdown">
                    <Dropdown position="'bottom-end'">
                        <button class="btn btn-light">
                            <i class="fa fa-cog"/>
                        </button>
                        <t t-set-slot="content">
                            <DropdownItem onSelected="() =&gt; this.actionCreateRecoModel()">
                                Create model
                            </DropdownItem>
                            <DropdownItem onSelected="() =&gt; this.actionViewRecoModels()">
                                View models
                            </DropdownItem>
                        </t>
                    </Dropdown>
                </div>

            </div>
        </div>
    </t>


    `);
registerTemplate("account_accountant.BankRecRecordFormLineIds", `/account_accountant/static/src/components/bank_reconciliation/bank_rec_form.xml`, `<t t-name="account_accountant.BankRecRecordFormLineIds" xml:space="preserve">
        <div name="line_ids" class="w-100">
            <div class="o_list_renderer table-responsive">
                <table class="o_list_table table table-sm position-relative mb-0 o_list_table_ungrouped table-striped o_bank_rec_lines_widget_table">
                    <thead>
                        <tr>
                            <t t-foreach="line_ids_columns" t-as="column" t-key="column[0]">
                                <t t-if="['amount_currency', 'debit', 'credit', 'balance'].includes(column[0])">
                                    <th class="o_list_number_th text-end" t-esc="column[1]"/>
                                </t>
                                <t t-elif="column[0] === '__trash'">
                                    <th class="o_list_actions_header"/>
                                </t>
                                <t t-else="">
                                    <th t-out="column[1]"/>
                                </t>
                            </t>
                        </tr>
                    </thead>
                    <tbody>
                        <t t-foreach="data.line_ids.records" t-as="line" t-key="line_index">
                            <t t-set="invalidFields" t-value="this.getBankRecLineInvalidFields(line)"/>

                            <tr class="o_data_row o_selected_row o_list_no_open o_bank_rec_expanded_line" t-att-class="{                                     'o_bank_rec_liquidity_line': line.data.flag === 'liquidity',                                     'o_bank_rec_auto_balance_line': line.data.flag === 'auto_balance',                                     'o_bank_rec_selected_line': line.data.index === data.form_index and this.state.bankRecNotebookPage === 'manual_operations_tab',                                     'table-info': line.data.index === data.form_index and this.state.bankRecNotebookPage === 'manual_operations_tab',                                 }" t-on-click="(ev) =&gt; this.handleLineClicked(ev, line)">

                                <t t-foreach="line_ids_columns" t-as="column" t-key="column[0]">
                                    <t t-if="column[0] === 'account'">
                                        <td class="o_data_cell o_field_cell o_list_many2one" t-att-class="{'o_invalid_cell': invalidFields.includes('account_id')}" field="account_id" t-att-title="line.data.account_id[1]" t-out="line.data.account_id[1]"/>
                                    </t>
                                    <t t-if="column[0] === 'partner'">
                                        <t t-if="line.data.flag === 'liquidity' and !line.data.partner_id">
                                            <td class="o_data_cell o_field_cell o_list_many2one text-muted" field="partner_id" t-att-title="data.partner_name or ''" t-out="data.partner_name or ''"/>
                                        </t>
                                        <t t-else="">
                                            <td class="o_data_cell o_field_cell o_list_many2one" field="partner_id" t-att-title="line.data.partner_id[1]" t-out="line.data.partner_id[1]"/>
                                        </t>
                                    </t>
                                    <t t-if="column[0] === 'date'">
                                        <t t-if="['manual', 'early_payment', 'auto_balance', 'tax_line'].includes(line.data.flag)">
                                            <td class="o_data_cell o_field_cell" field="date">
                                                <span field="date" class="badge text-bg-secondary">New</span>
                                            </td>
                                        </t>
                                        <t t-else="">
                                            <td class="o_data_cell o_field_cell" t-att-class="{'o_invalid_cell': invalidFields.includes('date')}" field="date" t-out="formatDateField(line.data.date)"/>
                                        </t>
                                    </t>
                                    <t t-if="column[0] === 'analytic_distribution'">
                                        <td class="o_data_cell o_field_cell o_field_widget o_field_analytic_distribution" field="analytic_distribution">
                                            <div class="o_field_tags d-inline-flex flex-wrap mw-100">
                                                <AnalyticDistribution name="'analytic_distribution'" record="line" readonly="true" t-key="getKey(line.data)"/>
                                            </div>
                                        </td>
                                    </t>
                                    <t t-if="column[0] === 'taxes'" name="col_taxes">
                                        <td class="o_data_cell o_field_cell o_field_widget o_field_many2many_tags" field="tax_ids">
                                            <div class="o_field_tags d-inline-flex flex-wrap mw-100">
                                                <TagsList tags="line.data.tax_ids.records.map((tax) =&gt; ({text: tax.data.display_name, id: tax.resId}))"/>
                                            </div>
                                        </td>
                                    </t>
                                    <t t-if="column[0] === 'amount_currency'">
                                        <t t-if="line.data.flag === 'exchange_diff'">
                                            <td/>
                                        </t>
                                        <t t-else="">
                                            <td class="o_data_cell o_field_cell o_list_number" field="amount_currency" style="justify-content: right;" t-out="isMonetaryZero(line.data.amount_currency, line.data.currency_id[0]) ? '' : formatMonetaryField(line.data.amount_currency, line.data.currency_id[0])"/>
                                        </t>
                                    </t>
                                    <t t-if="column[0] === 'currency'">
                                        <t t-if="line.data.flag === 'exchange_diff'">
                                            <td/>
                                        </t>
                                        <t t-else="">
                                            <td class="o_data_cell o_field_cell o_list_many2one" field="currency_id" t-att-title="line.data.currency_id[1]" t-out="line.data.currency_id[1]"/>
                                        </t>
                                    </t>
                                    <t t-if="column[0] === 'debit'">
                                        <td class="o_data_cell o_field_cell o_list_number" field="debit" t-out="isMonetaryZero(line.data.debit, line.data.company_currency_id[0]) ? '' : formatMonetaryField(line.data.debit, line.data.company_currency_id[0])"/>
                                    </t>
                                    <t t-if="column[0] === 'credit'">
                                        <td class="o_data_cell o_field_cell o_list_number" field="credit" t-out="isMonetaryZero(line.data.credit, line.data.company_currency_id[0]) ? '' : formatMonetaryField(line.data.credit, line.data.company_currency_id[0])"/>
                                    </t>
                                    <t t-if="column[0] === 'balance'">
                                        <td class="o_data_cell o_field_cell o_list_number" field="balance" t-out="isMonetaryZero(line.data.balance, line.data.company_currency_id[0]) ? '' : formatMonetaryField(line.data.balance, line.data.company_currency_id[0])"/>
                                    </t>
                                    <t t-if="column[0] === '__trash'">
                                        <td class="o_list_record_remove">
                                            <button t-if="['valid', 'invalid'].includes(data.state) and !['liquidity', 'auto_balance', 'tax_line'].includes(line.data.flag)" t-on-click.prevent.stop="(ev) =&gt; this.actionRemoveLine(line)" class="btn fa fa-trash-o"/>
                                        </td>
                                    </t>
                                </t>
                            </tr>

                            <tr/>
                            <tr class="o_data_row o_selected_row o_list_no_open o_bank_rec_second_line" t-att-class="{                                     'o_bank_rec_liquidity_line': line.data.flag === 'liquidity',                                     'o_bank_rec_auto_balance_line': line.data.flag === 'auto_balance',                                     'o_bank_rec_selected_line': line.data.index === data.form_index and this.state.bankRecNotebookPage === 'manual_operations_tab',                                     'table-info': line.data.index === data.form_index and this.state.bankRecNotebookPage === 'manual_operations_tab',                                 }" t-on-click="(ev) =&gt; this.handleLineClicked(ev, line)">
                                <td t-att-colspan="line_ids_columns.length - (display_currency_columns ? 5 : 3) + (hasGroupReadOnly ? 0 : 1)" class="o_data_cell o_field_cell o_list_char text-wrap fw-normal" field="name">
                                    <t t-if="line.data.source_aml_move_id[0] and (['new_aml', 'aml'].includes(line.data.flag) or (line.data.flag == 'liquidity' and data.state == 'reconciled' and hasGroupReadOnly))">
                                        <span class="o_form_uri fst-italic" t-out="line.data.source_aml_move_id[1]" t-on-click="() =&gt; this.actionRedirectToSourceMove(line)"/>
                                        <span class="me-1 fst-italic" t-if="line.data.name">:</span>
                                    </t>
                                    <span t-if="line.data.bank_account" class="text-muted fst-italic me-1" t-out="line.data.bank_account"/>
                                    <span class="text-muted fst-italic" t-out="line.data.name"/>
                                </td>
                                <td t-if="display_currency_columns" class="o_data_cell o_field_cell o_list_number" field="amount_currency">
                                    <span t-if="line.data.display_stroked_amount_currency" class="text-muted text-decoration-line-through" field="amount_currency" t-out="formatMonetaryField(line.data.source_amount_currency, line.data.currency_id[0])"/>
                                </td>
                                <td t-if="display_currency_columns" field="currency_id"/>
                                <td t-if="hasGroupReadOnly" class="o_data_cell o_field_cell o_list_number text-end" field="debit">
                                    <span t-if="line.data.display_stroked_balance and !isMonetaryZero(line.data.debit, line.data.company_currency_id[0])" class="text-muted text-decoration-line-through" field="debit" t-out="formatMonetaryField(line.data.source_debit, line.data.company_currency_id[0])"/>
                                </td>
                                <td t-if="hasGroupReadOnly" class="o_data_cell o_field_cell o_list_number text-end" field="credit">
                                    <span t-if="line.data.display_stroked_balance and !isMonetaryZero(line.data.credit, line.data.company_currency_id[0])" class="text-muted text-decoration-line-through" field="credit" t-out="formatMonetaryField(line.data.source_credit, line.data.company_currency_id[0])"/>
                                </td>
                                <td t-if="!hasGroupReadOnly" class="o_data_cell o_field_cell o_list_number text-end" field="balance">
                                    <span t-if="line.data.display_stroked_balance and (!isMonetaryZero(line.data.debit, line.data.company_currency_id[0]) or !isMonetaryZero(line.data.credit, line.data.company_currency_id[0]))" class="text-muted text-decoration-line-through" field="balance" t-out="formatMonetaryField(line.data.source_debit or line.data.source_credit, line.data.company_currency_id[0])"/>
                                </td>
                                <td class="empty_trash_cell"/>
                            </tr>
                        </t>

                        <t t-set="nb_extra_lines" t-value="5 - data.line_ids.records.length"/>
                        <tr t-foreach="[...Array(Math.max(nb_extra_lines, 0)).keys()]" t-as="i" t-key="i">
                            <td t-att-colspan="line_ids_columns.length">‍</td>
                        </tr>

                    </tbody>
                </table>
            </div>
        </div>
    </t>


    `);
registerTemplate("account_accountant.BankRecRecordNotebookAmls", `/account_accountant/static/src/components/bank_reconciliation/bank_rec_form.xml`, `<t t-name="account_accountant.BankRecRecordNotebookAmls" xml:space="preserve">
        <div class="bank_rec_widget_form_amls_list_anchor" t-if="this.state.bankRecEmbeddedViewsData">
            <BankRecViewEmbedder viewProps="this.notebookAmlsListViewProps()" t-key="data.st_line_id[0]"/>
        </div>
    </t>


    `);
registerTemplate("account_accountant.BankRecRecordNotebookManualOperations", `/account_accountant/static/src/components/bank_reconciliation/bank_rec_form.xml`, `<t t-name="account_accountant.BankRecRecordNotebookManualOperations" xml:space="preserve">
        <t t-set="line" t-value="this.getBankRecRecordLineInEdit()"/>
        <t t-set="data" t-value="this.state.bankRecRecordData"/>
        <div t-if="line" class="bank_rec_widget_manual_operations_anchor">
            <t t-set="invalidFields" t-value="this.getBankRecLineInvalidFields(line)"/>
            <t t-set="hasForcedNegativeValue" t-value="['new_aml', 'exchange_diff'].includes(line.data.flag) and (line.data.source_balance lt 0.0 || line.data.source_amount_currency lt 0.0)"/>
            <t t-set="reconciled" t-value="data.state === 'reconciled'"/>

            <div class="o_group row align-items-start">
                <div class="o_inner_group grid col-lg-4">

                    <t t-set="amountFieldReadonly" t-value="reconciled"/>
                    <t t-set="currencyFieldReadonly" t-value="reconciled or ['liquidity', 'tax_line', 'new_aml'].includes(line.data.flag)"/>
                    <div name="amount_currency" t-if="line.data.flag !== 'exchange_diff'" class="o_wrap_field d-flex d-sm-contents flex-column">
                        <div class="o_cell o_wrap_label flex-grow-1 flex-sm-grow-0 w-100 text-break text-900">
                            <label class="o_form_label" t-att-class="{'o_form_label_readonly': amountFieldReadonly}">
                                Amount
                            </label>
                        </div>
                        <div class="o_cell o_wrap_input flex-grow-1 flex-sm-grow-0 w-100">
                            <div class="d-flex gap-2">

                                <div class="o_field_widget o_field_monetary">
                                    <BankRecMonetaryField name="'amount_currency'" record="line" readonly="amountFieldReadonly" hasForcedNegativeValue="hasForcedNegativeValue"/>
                                </div>

                                <t t-if="!currencyFieldReadonly">in</t>

                                <div t-if="!currencyFieldReadonly" class="o_field_widget o_field_many2one w-50">
                                    <Many2OneField t-if="!currencyFieldReadonly" name="'currency_id'" record="line" readonly="currencyFieldReadonly" canOpen="false" canQuickCreate="false" canCreateEdit="false"/>
                                </div>
                            </div>
                        </div>
                    </div>


                    <t t-set="currencyFieldReadonly" t-value="reconciled || ['tax_line', 'new_aml'].includes(line.data.flag)"/>
                    <div name="amount_transaction_currency" t-if="data.is_multi_currency and line.data.flag === 'liquidity' and (!reconciled || reconciled and line.data.transaction_currency_id[0])" class="o_wrap_field d-flex d-sm-contents flex-column">
                        <div class="o_cell o_wrap_label flex-grow-1 flex-sm-grow-0 w-100 text-break text-900">
                            <label class="o_form_label" t-att-class="{'o_form_label_readonly': amountFieldReadonly}">
                                In Foreign Currency
                            </label>
                        </div>
                        <div class="o_cell o_wrap_input flex-grow-1 flex-sm-grow-0 w-100">
                            <div class="d-flex gap-2">

                                <div class="o_field_widget o_field_monetary">
                                    <BankRecMonetaryField t-if="line.data.transaction_currency_id" name="'amount_transaction_currency'" record="line" readonly="amountFieldReadonly" hasForcedNegativeValue="hasForcedNegativeValue"/>
                                </div>

                                <t>in</t>

                                <div class="o_field_widget o_field_many2one w-50">
                                    <Many2OneField name="'transaction_currency_id'" record="line" readonly="currencyFieldReadonly" canOpen="false" canQuickCreate="false" canCreateEdit="false" domain="[['id', '!=', line.data.currency_id[0]]]"/>
                                </div>
                            </div>
                        </div>
                    </div>


                    <t t-set="amountFieldReadonly" t-value="reconciled or (line.data.flag === 'liquidity' and line.data.company_currency_id[0] !== line.data.currency_id[0])"/>
                    <div name="balance" t-if="line.data.company_currency_id[0] !== line.data.currency_id[0] and line.data.company_currency_id[0] !== line.data.transaction_currency_id[0]" class="o_wrap_field d-flex d-sm-contents flex-column">
                        <div class="o_cell o_wrap_label flex-grow-1 flex-sm-grow-0 w-100 text-break text-900">
                            <label class="o_form_label" t-att-class="{'o_form_label_readonly': amountFieldReadonly}">
                                In Company Currency
                            </label>
                        </div>
                        <div class="o_cell o_wrap_input flex-grow-1 flex-sm-grow-0 w-100">
                            <div class="d-flex">

                                <div class="o_field_widget o_field_monetary">
                                    <BankRecMonetaryField name="'balance'" record="line" readonly="amountFieldReadonly" hasForcedNegativeValue="hasForcedNegativeValue"/>
                                </div>
                            </div>
                        </div>
                    </div>


                    <div name="suggestion" t-if="line.data.suggestion_html != ''" class="o_wrap_field d-flex d-sm-contents flex-column">
                        <div class="o_cell o_wrap_label flex-grow-1 flex-sm-grow-0 w-100 text-break text-900"/>
                        <div class="o_cell o_wrap_input flex-grow-1 flex-sm-grow-0 w-100">
                            <div t-on-click="handleSuggestionHtmlClicked">
                                <t t-out="line.data.suggestion_html"/>
                            </div>
                        </div>
                    </div>


                    <t t-set="readonly" t-value="reconciled || ['liquidity', 'new_aml', 'exchange_diff'].includes(line.data.flag)"/>
                    <div name="account_id" class="o_wrap_field d-flex d-sm-contents flex-column">
                        <div class="o_cell o_wrap_label flex-grow-1 flex-sm-grow-0 w-100 text-break text-900">
                            <label class="o_form_label" t-att-class="{'o_field_invalid': invalidFields.includes('account_id'), 'o_form_label_readonly': readonly}">
                                Account
                            </label>
                        </div>
                        <div class="o_cell o_wrap_input flex-grow-1 flex-sm-grow-0 w-100">
                            <div class="o_field_widget o_field_many2one" t-att-class="{'o_field_invalid': invalidFields.includes('account_id')}">
                                <Many2OneField name="'account_id'" record="line" readonly="readonly" canOpen="false" canQuickCreate="false"/>
                            </div>
                        </div>
                    </div>


                    <t t-set="readonly" t-value="reconciled || ['tax_line', 'new_aml', 'exchange_diff'].includes(line.data.flag)"/>
                    <div name="partner_id" class="o_wrap_field d-flex d-sm-contents flex-column">
                        <div class="o_cell o_wrap_label flex-grow-1 flex-sm-grow-0 w-100 text-break text-900">
                            <label class="o_form_label" t-att-class="{'o_form_label_readonly': readonly}">
                                Partner
                            </label>
                        </div>
                        <div class="o_field_widget o_field_many2one">
                            <Many2OneField name="'partner_id'" record="line" readonly="readonly" canQuickCreate="false" domain="[['company_id', 'in', [false, data.company_id[0]]], '|', ['parent_id', '=', false], ['is_company', '=', true]]"/>
                        </div>
                    </div>


                    <div t-if="['auto_balance', 'manual'].includes(line.data.flag)                                 and line.data.partner_receivable_account_id                                 and line.data.partner_payable_account_id" class="o_wrap_field d-flex d-sm-contents flex-column">
                        <div class="o_cell flex-grow-1 flex-sm-grow-0 o_wrap_label w-100 text-break text-900"/>
                        <div class="o_cell flex-grow-1 flex-sm-grow-0 w-100">
                            <div class="d-flex gap-1 align-items-center">
                                <button class="btn btn-link text-nowrap" t-on-click="actionSetPartnerReceivableAccount">
                                    Receivable:
                                    <div class="o_field_widget o_readonly_modifier o_field_monetary text-muted">
                                        <span t-out="formatMonetaryField(line.data.partner_receivable_amount, line.data.partner_currency_id[0])"/>
                                    </div>
                                </button>
                                <span>-</span>
                                <button class="btn btn-link text-nowrap" t-on-click="actionSetPartnerPayableAccount">
                                    Payable:
                                    <div class="o_field_widget o_readonly_modifier o_field_monetary text-muted">
                                        <span t-out="formatMonetaryField(line.data.partner_payable_amount, line.data.partner_currency_id[0])"/>
                                    </div>
                                </button>
                            </div>
                        </div>
                    </div>


                    <div name="analytic_distribution" t-if="hasGroupAnalyticAccounting" class="o_wrap_field d-flex d-sm-contents flex-column">
                        <div class="o_cell o_wrap_label flex-grow-1 flex-sm-grow-0 w-100 text-break text-900">
                            <label class="o_form_label" t-att-class="{'o_form_label_readonly': reconciled}">
                                Analytic
                            </label>
                        </div>
                        <div class="o_cell o_wrap_input flex-grow-1 flex-sm-grow-0 w-100">
                            <div class="o_field_widget o_field_analytic_distribution">

                                <AnalyticDistribution name="'analytic_distribution'" record="line" readonly="reconciled" account_field="'account_id'" business_domain="'general'" allow_save="true" t-key="line.data.index"/>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="o_inner_group grid col-lg-4">

                    <div name="date" t-if="line.data.flag === 'liquidity'" class="o_wrap_field d-flex d-sm-contents flex-column">
                        <div class="o_cell o_wrap_label flex-grow-1 flex-sm-grow-0 w-100 text-break text-900">
                            <label class="o_form_label" t-att-class="{'o_field_invalid': invalidFields.includes('date'), 'o_form_label_readonly': reconciled}">
                                Date
                            </label>
                        </div>
                        <div class="o_cell o_wrap_input flex-grow-1 flex-sm-grow-0 w-100">
                            <div class="o_field_widget o_field_date" t-att-class="{'o_field_invalid': invalidFields.includes('date')}">
                                <DateTimeField name="'date'" record="line" readonly="reconciled"/>
                            </div>
                        </div>
                    </div>

                    <div name="reference" t-if="line.data.flag === 'liquidity' and line.data.ref" class="o_wrap_field d-flex d-sm-contents flex-column">
                        <div class="o_cell o_wrap_label flex-grow-1 flex-sm-grow-0 w-100 text-break text-900">
                            <label class="o_form_label" t-att-class="{'o_form_label_readonly': readonly}">
                                Reference
                            </label>
                        </div>
                        <div class="o_cell o_wrap_input flex-grow-1 flex-sm-grow-0 w-100">
                            <div class="o_field_widget o_field_char">
                                <CharField name="'ref'" record="line" readonly="readonly"/>
                            </div>
                        </div>
                    </div>


                    <div name="bank_account" t-if="line.data.flag === 'liquidity' and line.data.bank_account" class="o_wrap_field d-flex d-sm-contents flex-column">
                        <div class="o_cell o_wrap_label flex-grow-1 flex-sm-grow-0 w-100 text-break text-900">
                            <label class="o_form_label o_form_label_readonly">
                                Bank Account
                            </label>
                        </div>
                        <div class="o_cell o_wrap_input flex-grow-1 flex-sm-grow-0 w-100">
                            <div class="o_field_widget o_field_many2one">
                                <t t-out="line.data.bank_account"/>
                            </div>
                        </div>
                    </div>


                    <div name="tax_ids" t-if="['manual', 'auto_balance'].includes(line.data.flag)" class="o_wrap_field d-flex d-sm-contents flex-column">
                        <div class="o_cell o_wrap_label flex-grow-1 flex-sm-grow-0 w-100 text-break text-900">
                            <label class="o_form_label" t-att-class="{'o_form_label_readonly': reconciled}">
                                Taxes
                            </label>
                        </div>
                        <div class="o_cell o_wrap_input flex-grow-1 flex-sm-grow-0 w-100">
                            <div class="o_field_widget o_field_many2many_tags">
                                <Many2ManyTagsField name="'tax_ids'" record="line" readonly="reconciled" canCreate="false" canQuickCreate="false" canCreateEdit="false" context="{'append_type_to_tax_name': true}"/>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="o_inner_group grid col-lg-4"/>
            </div>
            <div class="o_group row align-items-start">
                <div class="o_inner_group grid">

                    <div name="name" class="o_wrap_field d-flex d-sm-contents flex-column">
                        <div class="o_cell o_wrap_label flex-grow-1 flex-sm-grow-0 w-100 text-break text-900">
                            <label class="o_form_label" t-att-class="{'o_form_label_readonly': readonly}">
                                Label
                            </label>
                        </div>
                        <div class="o_cell o_wrap_input flex-grow-1 flex-sm-grow-0 w-100">
                            <div class="o_field_widget o_field_char">
                                <CharField name="'name'" record="line" readonly="readonly"/>
                            </div>
                        </div>
                    </div>

                    <div name="narration" t-if="line.data.flag === 'liquidity' and (!reconciled || (reconciled and line.data.narration))" class="o_wrap_field d-flex d-sm-contents flex-column">
                        <div class="o_cell o_wrap_label flex-grow-1 flex-sm-grow-0 w-100 text-break text-900">
                            <label class="o_form_label" t-att-class="{'o_form_label_readonly': reconciled}">
                                Notes
                            </label>
                        </div>
                        <div class="o_cell o_wrap_input flex-grow-1 flex-sm-grow-0 w-100">
                            <div class="o_field_widget o_field_char">
                                <HtmlField name="'narration'" record="line" readonly="reconciled" wysiwygOptions="{}"/>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </t>


    `);
registerTemplate("account_accountant.BankRecRecordNotebookChatter", `/account_accountant/static/src/components/bank_reconciliation/bank_rec_form.xml`, `<t t-name="account_accountant.BankRecRecordNotebookChatter" xml:space="preserve">
        <div class="bank_rec_widget_form_discuss_anchor">
            <Chatter threadModel="'account.move'" threadId="data.move_id[0]"/>
        </div>
    </t>


    `);
registerTemplate("account_accountant.BankRecRecordNotebookTransactionDetails", `/account_accountant/static/src/components/bank_reconciliation/bank_rec_form.xml`, `<t t-name="account_accountant.BankRecRecordNotebookTransactionDetails" xml:space="preserve">
        <div class="bank_rec_widget_form_transaction_details_anchor o_group row align-items-start">
            <div class="o_wrap_field d-flex d-sm-contents flex-column mb-3 mb-sm-0">
                <span t-out="data.st_line_transaction_details"/>
            </div>
        </div>
    </t>


    `);
registerTemplate("account_accountant.BankRecRecordForm", `/account_accountant/static/src/components/bank_reconciliation/bank_rec_form.xml`, `<t t-name="account_accountant.BankRecRecordForm" xml:space="preserve">
        <div class="o_xxl_form_view h-100 o_view_controller o_form_view">
            <t t-set="record" t-value="this.bankRecModel.root"/>
            <t t-set="data" t-value="state.bankRecRecordData"/>
            <div class="o_form_view_container" t-ref="formContainer">
                <div class="o_content">
                    <div class="o_form_nosheet o_form_editable d-block">

                        <div class="o_bank_rec_stats_buttons">
                            <t t-call="account_accountant.BankRecRecordFormButtonsHeaderLeft"/>
                            <t t-call="account_accountant.BankRecRecordFormButtonsHeaderRight"/>
                        </div>


                        <t t-call="account_accountant.BankRecRecordFormLineIds">
                            <t t-set="line_ids_columns" t-value="this.getOne2ManyColumns()"/>
                            <t t-set="display_currency_columns" t-value="!!line_ids_columns.find((c) =&gt; c[0] == 'currency')"/>
                        </t>


                        <Notebook t-key="state.bankRecStLineId" defaultPage="state.bankRecNotebookPage || ''" onPageUpdate.bind="onPageUpdate">
                            <t t-set-slot="amls_tab" name="'amls_tab'" title.translate="Match Existing Entries" isVisible="['valid', 'invalid'].includes(data.state)">
                                <t t-call="account_accountant.BankRecRecordNotebookAmls"/>
                            </t>
                            <t t-set-slot="manual_operations_tab" name="'manual_operations_tab'" title.translate="Manual Operations" isVisible="hasGroupReadOnly">
                                <t t-call="account_accountant.BankRecRecordNotebookManualOperations"/>
                            </t>
                            <t t-set-slot="discuss_tab" name="'discuss_tab'" title.translate="Discuss" isVisible="true">
                                <t t-call="account_accountant.BankRecRecordNotebookChatter"/>
                            </t>
                            <t t-set-slot="transaction_details_tab" name="'transaction_details_tab'" title.translate="Transaction Details" isVisible="data.st_line_transaction_details and data.st_line_transaction_details != ''">
                                <t t-call="account_accountant.BankRecRecordNotebookTransactionDetails"/>
                            </t>
                        </Notebook>

                    </div>
                </div>
            </div>
        </div>
    </t>

    `);
registerTemplate("account_accountant.BankRecEmbeddedListController", `/account_accountant/static/src/components/bank_reconciliation/bank_rec_form.xml`, `<t t-name="account_accountant.BankRecEmbeddedListController" t-inherit="web.ListView" t-inherit-mode="primary" xml:space="preserve">
        <t t-set-slot="control-panel-additional-actions" position="replace"/>
    </t>

`);
registerTemplate("account.BankRecQuickCreate", `/account_accountant/static/src/components/bank_reconciliation/bank_rec_quick_create.xml`, `<t t-name="account.BankRecQuickCreate" xml:space="preserve">
        <BankRecQuickCreateController t-if="state.isLoaded" t-props="quickCreateProps"/>
    </t>

    `);
registerTemplate("account.BankRecQuickCreateController", `/account_accountant/static/src/components/bank_reconciliation/bank_rec_quick_create.xml`, `<t t-name="account.BankRecQuickCreateController" xml:space="preserve">
        <div class="o_bank_rec_quick_create o_kanban_record o_form_view w-100" t-ref="root">
            <t t-component="props.Renderer" record="model.root" Compiler="props.Compiler" archInfo="props.archInfo"/>
            <div class="d-flex flex-wrap justify-content-end gap-1 button_group border-top-0 mt-2">
                <button class="btn btn-primary o_kanban_add me-1" t-on-click="() =&gt; this.validate('add')" data-hotkey="s">
                    Add &amp; New
                </button>
                <button class="btn btn-secondary o_kanban_edit me-1" t-on-click="() =&gt; this.validate('add_close')" data-hotkey="shift+s">
                    Add &amp; Close
                </button>
                <span class="flex-grow-1"/>
                <button class="btn btn-secondary o_kanban_cancel" t-on-click="() =&gt; this.cancel(true)" data-hotkey="d">
                    <i class="fa fa-trash"/>
                </button>
            </div>
        </div>
    </t>

`);
registerTemplate("account_accountant.BankRecFinishButtons", `/account_accountant/static/src/components/bank_reconciliation/finish_buttons.xml`, `<t t-name="account_accountant.BankRecFinishButtons" xml:space="preserve">
        <p t-if="otherFiltersActive" class="btn btn-primary" t-on-click="clearFilters">All Transactions</p>
        <p>
            <t t-set="linkName" t-value="breadcrumbs.length &gt; 1 ? breadcrumbs.slice(-2)[0].name : 'Dashboard'"/>
            <a href="#" t-on-click.stop.prevent="breadcrumbBackOrDashboard">Back to <t t-out="linkName"/></a>
        </p>
    </t>
`);
registerTemplate("account_accountant.BankRecGlobalInfo", `/account_accountant/static/src/components/bank_reconciliation/global_info.xml`, `<t t-name="account_accountant.BankRecGlobalInfo" xml:space="preserve">
        <div t-if="props.journalId" class="journal-balance d-flex w-100" t-att-class="{'pe-none': !hasGroupReadOnly}" t-on-click="(ev) =&gt; hasGroupReadOnly ? this.actionOpenBankGL() : {}">
            <span class="btn flex-fill text-900 text-start ps-0 fw-bold fs-4 align-self-center">
                Balance
            </span>
            <span class="btn btn-link pe-0 fw-bold fs-4 align-self-center" t-if="props.journalBalanceAmount or props.journalBalanceAmount === 0" t-esc="props.journalBalanceAmount"/>
        </div>
    </t>

`);
registerTemplate("account.BankRecoKanbanController", `/account_accountant/static/src/components/bank_reconciliation/kanban.xml`, `<t t-name="account.BankRecoKanbanController" t-inherit="web.KanbanView" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//Layout" position="attributes">
            <attribute name="className">'o_bank_rec_main_div overflow-auto'</attribute>
        </xpath>
        <xpath expr="//t[@t-component='props.Renderer']" position="after">
            <div class="o_bank_rec_right_div">
                <t t-if="state.bankRecStLineId and this.bankRecModel">
                    <t t-call="account_accountant.BankRecRecordForm"/>
                </t>
            </div>
        </xpath>
    </t>


    `);
registerTemplate("account.BankRecKanbanRecord", `/account_accountant/static/src/components/bank_reconciliation/kanban.xml`, `<t t-name="account.BankRecKanbanRecord" t-inherit="web.KanbanRecord" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//article" position="attributes">
            <attribute name="t-att-tabindex"/>
        </xpath>
    </t>


    `);
registerTemplate("account.BankRecKanbanRenderer", `/account_accountant/static/src/components/bank_reconciliation/kanban.xml`, `<t t-name="account.BankRecKanbanRenderer" t-inherit="web.KanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[@t-ref='root']" position="attributes">
            <attribute name="class" add="o_bank_rec_kanban_div" separator=" "/>
        </xpath>
        <xpath expr="//t[@t-as='groupOrRecord']" position="before">
            <t t-set="statementGroups" t-value="groups()"/>
            <BankRecGlobalInfo t-if="globalState.bankRecStLineId and globalState.journalId" journalId="globalState.journalId" journalBalanceAmount="globalState.journalBalanceAmount"/>
            <t t-if="globalState.quickCreateState.isVisible">
                <BankRecQuickCreate globalState="globalState" onValidate="(record, mode) =&gt; this.validateQuickCreate(record, mode)" onCancel="() =&gt; this.cancelQuickCreate()" quickCreateView="props.quickCreateState.view"/>
            </t>
        </xpath>
        <xpath expr="//t[@t-else='']/KanbanRecord" position="before">
            <t t-set="recData" t-value="groupOrRecord.record.data"/>
            <t t-if="recData.statement_id                      and statementGroups.length                      and recData.statement_id[0] === statementGroups[0].id">

                <t t-set="stGroup" t-value="statementGroups.shift()"/>
                <t t-set="stClass" t-value="!(recData.statement_complete and recData.statement_valid) and 'text-danger' or ''"/>
                <span t-if="stGroup" class="kanban-statement d-flex text-truncate align-self-center fw-bold w-100">
                    <span t-attf-class="{{stClass}} kanban-statement-subline text-truncate flex-fill text-start" t-att-title="stGroup.name" t-out="stGroup.name"/>
                    <span t-on-click.stop.prevent="() =&gt; this.openStatementDialog(recData.statement_id[0])" t-attf-class="kanban-statement-subline btn btn-link" name="kanban-subline-clickable-amount" t-esc="stGroup.balance"/>
                </span>
            </t>
        </xpath>
        <t t-call="web.ActionHelper" position="replace">
            <div t-if="props.noContentHelp" class="o_view_nocontent">
                <div class="o_nocontent_help">
                    <RainbowMan t-if="this.env.methods.showRainbowMan()" t-props="this.env.methods.getRainbowManContentProps()"/>
                    <t t-else="">
                        <t t-out="props.noContentHelp"/>
                        <BankRecFinishButtons/>
                    </t>
                </div>
            </div>
        </t>
    </t>

`);
registerTemplate("account_accountant.ListViewSwitcher", `/account_accountant/static/src/components/bank_reconciliation/list_view_switcher.xml`, `<t t-name="account_accountant.ListViewSwitcher" xml:space="preserve">
        <button class="btn btn-sm btn-secondary" t-on-click.stop="() =&gt; this.switchView()">
            <t t-out="buttonLabel"/>
        </button>
    </t>

`);
registerTemplate("account_accountant.BankRecMonetaryField", `/account_accountant/static/src/components/bank_reconciliation/monetary_field_auto_signed_amount.xml`, `<t t-name="account_accountant.BankRecMonetaryField" t-inherit="web.MonetaryField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[hasclass('o_input')]" position="before">
            <span t-if="props.hasForcedNegativeValue and currency and currency.position === 'after'">-</span>
        </xpath>

        <xpath expr="//input" position="before">
            <span t-if="props.hasForcedNegativeValue and currency and currency.position === 'before'">-</span>
        </xpath>
        <xpath expr="//span[hasclass('o_monetary_ghost_value')]" position="before">
            <span class="opacity-0 mx-1" t-if="props.hasForcedNegativeValue">-</span>
        </xpath>
    </t>

`);
registerTemplate("account_accountant.BankRecRainbowContent", `/account_accountant/static/src/components/bank_reconciliation/rainbowman_content.xml`, `<t t-name="account_accountant.BankRecRainbowContent" xml:space="preserve">
        <t t-set="summary" t-value="this.env.methods.getCounterSummary()"/>
        <h2>Congrats, you're all done!</h2>
        <p>You reconciled <strong t-out="summary.counter"/><t t-if="summary.counter gt 1"> transactions in </t><t t-else=""> transaction in </t><strong t-out="summary.humanDuration"/>.
            <t t-if="summary.counter gt 1">
                <br/>That's on average <b t-out="summary.secondsPerTransaction"/> seconds per transaction.
            </t>
        </p>
        <BankRecFinishButtons/>
    </t>
`);
registerTemplate("account_accountant.BankRecViewEmbedder", `/account_accountant/static/src/components/bank_reconciliation/view_embedder.xml`, `<t t-name="account_accountant.BankRecViewEmbedder" xml:space="preserve">
        <View t-props="props.viewProps"/>
    </t>

`);
registerTemplate("account_accountant.MatchingLink", `/account_accountant/static/src/components/matching_link_widget/matching_link_widget.xml`, `<t t-name="account_accountant.MatchingLink" xml:space="preserve">
        <t t-if="env.searchModel.context.is_matched_view">
            <span t-out="props.record.data[props.name]" t-attf-class="o_tag o_badge badge rounded-pill {{'o_tag_color_' + colorCode}}"/>
        </t>
        <t t-elif="props.record.data[props.name]">
            <a href="#" t-on-click.prevent="viewMatch" t-attf-class="o_tag o_badge badge rounded-pill {{'o_tag_color_' + colorCode}}">
                <span t-out="props.record.data[props.name]"/>
            </a>
        </t>
    </t>

`);
registerTemplate("account_accountant.MoveLineListView", `/account_accountant/static/src/components/move_line_list/move_line_list.xml`, `<t t-name="account_accountant.MoveLineListView" t-inherit="web.ListView" xml:space="preserve">
        <xpath expr="//div[@t-ref='root']" position="attributes" type="add">
            <attribute name="class" add="o_move_line_list_view" separator=" "/>
        </xpath>
        <xpath expr="//t[@t-component='props.Renderer']" position="attributes">
            <attribute name="setSelectedRecord.bind">this.setSelectedRecord</attribute>
        </xpath>
        <xpath expr="//Layout" position="inside">
            <t t-call="account_accountant.AttachmentPreview"/>
        </xpath>
    </t>

    `);
registerTemplate("account_accountant.AttachmentPreview", `/account_accountant/static/src/components/move_line_list/move_line_list.xml`, `<t t-name="account_accountant.AttachmentPreview" xml:space="preserve">
        <div t-if="previewEnabled" class="o_attachment_preview d-print-none" t-att-class="{'hidden': !attachmentPreviewState.displayAttachment || mailPopoutService.externalWindow}">
            <t t-if="this.attachmentPreviewState.displayAttachment || mailPopoutService.externalWindow">
                <t t-if="this.attachmentPreviewState.thread and this.attachmentPreviewState.thread.attachmentsInWebClientView.length &gt; 0">
                    <AttachmentViewMoveLine threadId="this.attachmentPreviewState.thread.id" threadModel="this.attachmentPreviewState.thread.model" openInPopout="0"/>
                </t>
                <t t-elif="!this.attachmentPreviewState.selectedRecord">
                    <p class="text-center">Choose a line to preview its attachments.</p>
                </t>
                <t t-else="">
                    <p class="text-center">No attachments linked.</p>
                </t>
            </t>
            <div class="o_attachment_control toggle" t-on-click="togglePreview" t-if="!mailPopoutService.externalWindow"/>
        </div>
        <t t-else="">
            <div class="o_popout_icon" t-on-click="() =&gt; this.setPopout(true)">
                <i class="fa fa-window-restore" title="Open attachment in pop out"/>
            </div>
            <t t-if="this.popout.active">
                <div class="o_attachment_preview d-print-none" t-if="this.attachmentPreviewState.thread?.attachmentsInWebClientView.length">
                    <AttachmentViewMoveLine threadId="this.attachmentPreviewState.thread.id" threadModel="this.attachmentPreviewState.thread.model" openInPopout="1"/>
                </div>
            </t>
        </t>
    </t>
`);
registerTemplate("account_accountant.ListViewReconcile.Buttons", `/account_accountant/static/src/components/move_line_list_reconcile/move_line_list_reconcile.xml`, `<t t-name="account_accountant.ListViewReconcile.Buttons" t-inherit="web.ListView.Buttons" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_list_buttons')]" position="inside">
            <button class="btn btn-primary" t-on-click="() =&gt; this.openAutoReconcileWizard()" groups="account.group_account_user">
                Auto-reconcile
            </button>
        </xpath>
    </t>

    `);
registerTemplate("account_accountant.AccountMoveLineReconcileGroupRow", `/account_accountant/static/src/components/move_line_list_reconcile/move_line_list_reconcile.xml`, `<t t-name="account_accountant.AccountMoveLineReconcileGroupRow" t-inherit="web.ListRenderer.GroupRow" xml:space="preserve">
        <xpath expr="//div[@class='o_group_buttons']" position="before">
            <t t-set="grouped_by_account" t-value="group.list.evalContext.default_account_id"/>
            <t t-if="group.groupByField.name == 'account_id' or (group.groupByField.name == 'partner_id' and grouped_by_account)">
                <button class="btn btn-link" t-on-click.stop.prevent="() =&gt; this.env.callAutoReconcileAction(group)" groups="account.group_account_user">
                    Auto-reconcile
                </button>
            </t>
        </xpath>
    </t>

`);
registerTemplate("purchase.OpenMatchLineWidget", `/purchase/static/src/components/open_match_line_widget/open_match_line_widget.xml`, `<t t-name="purchase.OpenMatchLineWidget" xml:space="preserve">
        <div t-out="props.record.data[props.name]" t-on-click.prevent.stop="openMatchLine"/>
    </t>

`);
registerTemplateExtension("account.TaxTotalsField", `/purchase/static/src/components/tax_totals/tax_totals.xml`, `<t t-inherit="account.TaxTotalsField" t-inherit-mode="extension" owl="1" xml:space="preserve">
        <xpath expr="//tr[2]" position="after">
            <tr t-if="totals.amount_total_cc">
                <td colspan="2">
                    <span t-out="totals.amount_total_cc" style="font-size: 1.1em;"/>
                </td>
            </tr>
        </xpath>
    </t>
`);
registerTemplate("ProductCatalogPurchaseOrderLine", `/purchase/static/src/product_catalog/purchase_order_line/purchase_order_line.xml`, `<t t-name="ProductCatalogPurchaseOrderLine" t-inherit="product.ProductCatalogOrderLine" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[hasclass('o_product_catalog_price')]" position="attributes">
            <attribute name="t-if">!this.env.displayUoM</attribute>
        </xpath>
        <xpath expr="//span[hasclass('o_product_catalog_price')]" position="after">
            <span class="o_product_catalog_price" t-if="env.displayUoM">
                Price: <t t-out="price"/>
                / <span t-att-class="{'fw-bold text-primary': props.purchase_uom}">
                    <t t-if="props.purchase_uom" t-esc="props.purchase_uom.display_name"/>
                    <t t-else="" t-esc="props.uom.display_name"/>
                </span>
            </span>
        </xpath>
        <xpath expr="//div[hasclass('o_product_catalog_quantity')]" position="inside">
            <button t-if="props.packaging" class="o_product_catalog_package_quantity btn btn-primary border" t-on-click.stop="addPackagingQty">
                <i class="fa fa-cube"/>
            </button>
        </xpath>
    </t>
`);
registerTemplate("purchase.ButtonWithNotification", `/purchase/static/src/toaster_button/toaster_button_widget.xml`, `<t t-name="purchase.ButtonWithNotification" xml:space="preserve">
        <button t-on-click="onClick" t-att-name="props.method" type="button" class="btn oe_inline btn-link" t-att-title="props.title">
            <i class="fa fa-fw o_button_icon fa-info-circle"/>
        </button>
    </t>

`);
registerTemplate("purchase.PurchaseDashboard", `/purchase/static/src/views/purchase_dashboard.xml`, `<t t-name="purchase.PurchaseDashboard" xml:space="preserve">
        <div class="o_purchase_dashboard container-fluid py-4 border-bottom bg-view">
            <div class="row justify-content-between gap-3 gap-lg-0">
                <div class="col-12 col-lg-5 col-xl-5 col-xxl-4 flex-grow-1 flex-lg-grow-0 flex-shrink-0">
                    <div class="grid gap-4">
                        <div class="g-col-3 g-col-sm-2 d-flex align-items-center py-2 justify-content-end text-end justify-content-lg-start text-lg-start text-break">
                            All RFQs
                        </div>
                        <div class="g-col-9 g-col-sm-10 grid gap-1">
                            <div class="g-col-4 p-0" t-on-click="setSearchContext" title="All Draft RFQs" filter_name="draft_rfqs">
                                <a href="#" class="btn btn-primary w-100 h-100 border-0 rounded-0 text-capitalize text-break fw-normal">
                                    <div class="fs-2" t-out="purchaseData['all_to_send']"/>To Send
                                </a>
                            </div>
                            <div class="g-col-4 p-0" t-on-click="setSearchContext" title="All Waiting RFQs" filter_name="waiting_rfqs">
                                <a href="#" class="btn btn-primary w-100 h-100 border-0 rounded-0 text-capitalize text-break fw-normal">
                                    <div class="fs-2" t-out="purchaseData['all_waiting']"/>Waiting
                                </a>
                            </div>
                            <div class="g-col-4 p-0" t-on-click="setSearchContext" title="All Late RFQs" filter_name="late_rfqs">
                                <a href="#" class="btn btn-primary w-100 h-100 border-0 rounded-0 text-capitalize text-break fw-normal">
                                    <div class="fs-2" t-out="purchaseData['all_late']"/>Late
                                </a>
                            </div>
                        </div>
                    </div>
                    <div class="grid gap-4">
                        <div class="g-col-3 g-col-sm-2 d-flex align-items-center py-2 justify-content-end text-end justify-content-lg-start text-lg-start text-break">
                            My RFQs
                        </div>
                        <div class="g-col-9 g-col-sm-10 grid gap-2">
                            <div class="g-col-4 p-0" t-on-click="setSearchContext" title="My Draft RFQs" filter_name="draft_rfqs,my_purchases">
                                <a href="#" class="btn btn-light d-flex align-items-center w-100 h-100 p-0 border-0 bg-100 fw-normal">
                                    <div class="w-100 p-2" t-out="purchaseData['my_to_send']"/>
                                </a>
                            </div>
                            <div class="g-col-4 p-0" t-on-click="setSearchContext" title="My Waiting RFQs" filter_name="waiting_rfqs,my_purchases">
                                <a href="#" class="btn btn-light d-flex align-items-center w-100 h-100 p-0 border-0 bg-100 fw-normal">
                                    <div class="w-100 p-2" t-out="purchaseData['my_waiting']"/>
                                </a>
                            </div>
                            <div class="g-col-4 p-0" t-on-click="setSearchContext" title="My Late RFQs" filter_name="late_rfqs,my_purchases">
                                <a href="#" class="btn btn-light d-flex align-items-center w-100 h-100 p-0 border-0 bg-100 fw-normal">
                                    <div class="w-100 p-2" t-out="purchaseData['my_late']"/>
                                </a>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-12 col-lg-7 col-xl-6 col-xxl-5 flex-shrink-0">
                    <div class="d-flex flex-column justify-content-between gap-2 h-100">
                        <div class="grid gap-2 h-100">
                            <div class="g-col-6 g-col-md-6 grid gap-1 gap-md-4">
                                <div class="g-col-12 g-col-sm-4 g-col-lg-6 d-flex align-items-center justify-content-center text-center justify-content-md-end text-md-end mt-4 mt-sm-0 text-break">
                                    Avg Order Value
                                </div>
                                <div class="g-col-12 g-col-sm-8 g-col-lg-5 d-flex align-items-center justify-content-center py-2 bg-100">
                                    <span><t t-out="purchaseData['all_avg_order_value']"/></span>
                                </div>
                            </div>
                            <div class="g-col-6 g-col-md-6 grid gap-1 gap-md-4">
                                <div class="g-col-12 g-col-sm-4 g-col-lg-6 d-flex align-items-center py-2 justify-content-center text-center justify-content-md-end text-md-end mt-4 mt-sm-0 text-break">
                                    Purchased Last 7 Days
                                </div>
                                <div class="g-col-12 g-col-sm-8 g-col-lg-6 d-flex align-items-center justify-content-center py-2 bg-100">
                                    <span><t t-out="purchaseData['all_total_last_7_days']"/></span>
                                </div>
                            </div>
                        </div>
                        <div class="grid gap-2 h-100">
                            <div class="g-col-6 g-col-md-6 grid gap-1 gap-md-4">
                                <div class="g-col-12 g-col-sm-4 g-col-lg-6 d-flex align-items-center justify-content-center text-center justify-content-md-end text-md-end mt-4 mt-sm-0 text-break">
                                    Lead Time to Purchase
                                </div>
                                <div class="g-col-12 g-col-sm-8 g-col-lg-5 d-flex align-items-center justify-content-center py-2 bg-100">
                                    <span><t t-out="purchaseData['all_avg_days_to_purchase']"/>  Days</span>
                                </div>
                            </div>
                            <div class="g-col-6 g-col-md-6 grid gap-1 gap-md-4">
                                <div class="g-col-12 g-col-md-4 g-col-sm-4 g-col-lg-6 d-flex align-items-center justify-content-center text-center justify-content-md-end text-md-end mt-4 mt-sm-0 text-break">
                                    RFQs Sent Last 7 Days
                                </div>
                                <div class="g-col-12 g-col-sm-8 g-col-lg-6 d-flex align-items-center justify-content-center py-2 bg-100">
                                    <span><t t-out="purchaseData['all_sent_rfqs']"/></span>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("purchase.PurchaseKanbanView", `/purchase/static/src/views/purchase_kanbanview.xml`, `<t t-name="purchase.PurchaseKanbanView" t-inherit="web.KanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_kanban_renderer')]" position="before">
            <PurchaseDashBoard/>
        </xpath>
    </t>
`);
registerTemplate("purchase.PurchaseListView", `/purchase/static/src/views/purchase_listview.xml`, `<t t-name="purchase.PurchaseListView" t-inherit="web.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_list_renderer')]" position="before">
            <PurchaseDashBoard/>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.MessagingMenu.content", `/rating/static/src/core/web/messaging_menu_patch.xml`, `<t t-inherit="mail.MessagingMenu.content" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//t[@name='threads']/NotificationItem" position="attributes">
            <attribute name="rating">message?.rating_id</attribute>
            <attribute name="onClick">(isMarkAsRead) =&gt; message?.rating_id and !isMarkAsRead ? this.openThread(thread) : this.onClickThread(isMarkAsRead, thread)</attribute>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.NotificationItem", `/rating/static/src/core/web/notification_item_patch.xml`, `<t t-inherit="mail.NotificationItem" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@name='notificationBody']" position="replace">
            <t t-if="props.rating">
                <span>Rating:</span>
                <img class="o-rating-preview-image ms-2" t-att-src="props.rating.rating_image_url" t-att-alt="props.rating.rating_text"/>
            </t>
            <t t-else="">$0</t>
        </xpath>
    </t>
`);
registerTemplate("project.NotebookTaskListRenderer.Rows", `/project/static/src/components/notebook_task_one2many_field/notebook_task_list_renderer.xml`, `<t t-name="project.NotebookTaskListRenderer.Rows" t-inherit="web.ListRenderer.Rows" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-foreach='list.records']" position="replace">
            <t t-foreach="list.records" t-as="record" t-key="record.id">
                <t t-if="!['1_done','1_canceled'].includes(record.data.state) or !hideState.hide">
                    <t t-call="{{ constructor.recordRowTemplate }}"/>
                </t>
            </t>
        </xpath>

        <xpath expr="//t[@t-foreach='creates']" position="after">
            <a t-if="ShowX2MRecords" role="button" class="ml16 o_toggle_closed_task_button" href="#" t-on-click="() =&gt; this.toggleHideClosed()">
                <t t-esc="toggleListHideLabel"/>
            </a>
        </xpath>
    </t>
`);
registerTemplate("project.ProjectMany2OneField", `/project/static/src/components/project_many2one_field/project_many2one_field.xml`, `<t t-name="project.ProjectMany2OneField" t-inherit="web.Many2OneField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-if='!props.canOpen']/span" position="attributes">
            <attribute name="t-if">props.record.data[props.name]</attribute>
        </xpath>
        <xpath expr="//t[@t-if='!props.canOpen']/span" position="after">
            <span t-elif="!props.record.data.parent_id &amp;&amp; !props.record.data.project_id" class="text-danger fst-italic text-muted"><i class="fa fa-lock"/> Private</span>
        </xpath>
        <xpath expr="//t[@t-else='']/a" position="attributes">
            <attribute name="t-if">displayName</attribute>
        </xpath>
        <xpath expr="//t[@t-else='']/a" position="after">
            <span t-elif="!props.record.data.parent_id &amp;&amp; !props.record.data.project_id" class="text-danger fst-italic text-muted"><i class="fa fa-lock"/> Private</span>
        </xpath>
        <xpath expr="//div[hasclass('o_field_many2one_selection')]" position="attributes">
            <attribute name="t-att-class">{
                private_placeholder: !props.record.data.parent_id &amp;&amp; !props.record.data.project_id,
            }</attribute>
        </xpath>
    </t>

`);
registerTemplate("project.ProjectMilestone", `/project/static/src/components/project_right_side_panel/components/project_milestone.xml`, `<t t-name="project.ProjectMilestone" xml:space="preserve">
        <div class="list-group mb-2">
            <div class="o_rightpanel_milestone list-group-item list-group-item-action d-flex justify-content-evenly px-0 cursor-pointer" t-att-class="state.colorClass">
                <span t-on-click="toggleIsReached">
                    <t t-if="milestone.is_reached" t-set="title">Mark as incomplete</t>
                    <t t-else="" t-set="title">Mark as reached</t>
                    <i class="fa position-absolute pt-1" t-att-class="state.checkboxIcon" t-att-title="title"/>
                </span>
                <div class="o_milestone_detail d-flex justify-content-between ps-3 pe-2 col-11" t-on-click="onOpenMilestone">
                    <div class="text-truncate col-7" t-att-title="milestone.name">
                        <t t-esc="milestone.name"/>
                    </div>
                    <span class="d-flex justify-content-center align-items-center">
                        <t t-esc="deadline"/>
                    </span>
                </div>
                <span class="d-flex align-items-center">
                    <a t-on-click="onDeleteMilestone" title="Delete Milestone"><i class="fa fa-trash"/></a>
                </span>
            </div>
        </div>
    </t>

`);
registerTemplate("project.ProjectProfitability", `/project/static/src/components/project_right_side_panel/components/project_profitability.xml`, `<t t-name="project.ProjectProfitability" xml:space="preserve">
        <div class="o_rightpanel_subsection pb-3 border-bottom" t-if="revenues.data.length">
            <table class="table table-sm table-striped table-hover mb-0">
                <thead class="bg-100 align-middle">
                    <tr>
                        <th>Revenues</th>
                        <th class="text-end">Expected</th>
                        <th class="text-end">To Invoice</th>
                        <th class="text-end">Invoiced</th>
                    </tr>
                </thead>
                <tbody>
                    <t t-foreach="revenues.data" t-as="revenue" t-key="revenue.id" t-if="revenue.invoiced !== 0 || revenue.to_invoice !== 0">
                        <tr class="revenue_section">
                            <t t-set="revenue_label" t-value="props.labels[revenue.id] or revenue.id"/>
                            <td class="align-middle">
                                <a class="revenue_section" t-if="revenue.action" href="#" t-on-click="() =&gt; this.props.onClick(revenue.action)">
                                    <t t-esc="revenue_label"/>
                                </a>
                                <t t-esc="revenue_label" t-else=""/>
                            </td>
                            <td t-attf-class="text-end align-middle {{ revenue.invoiced + revenue.to_invoice === 0 ? 'text-500' : ''}}"><t t-esc="props.formatMonetary(revenue.invoiced + revenue.to_invoice)"/></td>
                            <td t-attf-class="text-end align-middle {{ revenue.to_invoice === 0 ? 'text-500' : ''}}"><t t-esc="props.formatMonetary(revenue.to_invoice)"/></td>
                            <td t-attf-class="text-end align-middle {{ revenue.invoiced === 0 ? 'text-500' : ''}}"><t t-esc="props.formatMonetary(revenue.invoiced)"/></td>
                        </tr>
                    </t>
                </tbody>
                <tfoot>
                    <tr class="fw-bolder">
                        <td>Total Revenues</td>
                        <td t-attf-class="text-end {{ revenues.total.invoiced + revenues.total.to_invoice === 0 ? 'text-500' : ''}}"><t t-esc="props.formatMonetary(revenues.total.invoiced + revenues.total.to_invoice)"/></td>
                        <td t-attf-class="text-end {{ revenues.total.to_invoice === 0 ? 'text-500' : ''}}"><t t-esc="props.formatMonetary(revenues.total.to_invoice)"/></td>
                        <td t-attf-class="text-end {{ revenues.total.invoiced === 0 ? 'text-500' : ''}}"><t t-esc="props.formatMonetary(revenues.total.invoiced)"/></td>
                    </tr>
                </tfoot>
            </table>
        </div>
        <div class="o_rightpanel_subsection pb-3 border-bottom" t-if="costs.data.length">
            <table class="table table-sm table-striped table-hover mb-0">
                <thead class="bg-100">
                    <tr>
                        <th>Costs</th>
                        <th class="text-end">Expected</th>
                        <th class="text-end">To Bill</th>
                        <th class="text-end">Billed</th>
                    </tr>
                </thead>
                <tbody>
                    <tr t-foreach="costs.data" t-as="cost" t-key="cost.id" t-if="cost.billed !== 0 || cost.to_bill !== 0">
                        <t t-set="cost_label" t-value="props.labels[cost.id] or cost.id"/>
                        <td class="align-middle">
                            <a t-if="cost.action" href="#" t-on-click="() =&gt; this.props.onClick(cost.action)">
                                <t t-esc="cost_label"/>
                            </a>
                            <t t-esc="cost_label" t-else=""/>
                        </td>
                        <td t-attf-class="text-end align-middle {{ cost.billed + cost.to_bill === 0 ? 'text-500' : ''}}"><t t-esc="props.formatMonetary(cost.billed + cost.to_bill)"/></td>
                        <td t-attf-class="text-end align-middle {{ cost.to_bill === 0 ? 'text-500' : ''}}"><t t-esc="props.formatMonetary(cost.to_bill)"/></td>
                        <td t-attf-class="text-end align-middle {{ cost.billed === 0 ? 'text-500' : ''}}"><t t-esc="props.formatMonetary(cost.billed)"/></td>
                    </tr>
                </tbody>
                <tfoot>
                    <tr class="fw-bolder">
                        <td>Total Costs</td>
                        <td t-attf-class="text-end {{ costs.total.billed + costs.total.to_bill  === 0 ? 'text-500' : ''}}"><t t-esc="props.formatMonetary(costs.total.billed + costs.total.to_bill)"/></td>
                        <td t-attf-class="text-end {{ costs.total.to_bill === 0 ? 'text-500' : ''}}"><t t-esc="props.formatMonetary(costs.total.to_bill)"/></td>
                        <td t-attf-class="text-end {{ costs.total.billed === 0 ? 'text-500' : ''}}"><t t-esc="props.formatMonetary(costs.total.billed)"/></td>
                    </tr>
                </tfoot>
            </table>
        </div>
        <div class="o_rightpanel_subsection" t-if="revenues.data.length &amp;&amp; costs.data.length">
            <table class="table table-sm table-borderless w-100 mb-0">
                <thead>
                    <tr class="align-top">
                        <th>Total</th>
                        <th class="text-end" t-att-class="margin.total &lt; 0 ? 'text-danger' : 'text-success'">
                            <t t-set="total_revenue" t-value="revenues.total.to_invoice + revenues.total.invoiced"/>
                            <t t-out="props.formatMonetary(margin.total)"/><br/>
                            <t t-if="total_revenue != 0">
                                <t t-out="margin.total &gt; 0 ? '+' : ''"/><t t-out="(margin.total / total_revenue * 100).toFixed()"/>%
                            </t>
                        </th>
                        <th class="text-end" t-att-class="margin.to_invoice_to_bill &lt; 0 ? 'text-danger' : 'text-success'">
                            <t t-out="props.formatMonetary(margin.to_invoice_to_bill)"/><br/>
                            <t t-if="revenues.total.to_invoice != 0">
                                <t t-out="margin.to_invoice_to_bill &gt; 0 ? '+' : ''"/><t t-out="(margin.to_invoice_to_bill / revenues.total.to_invoice * 100).toFixed()"/>%
                            </t>
                        </th>
                        <th class="text-end" t-att-class="margin.invoiced_billed &lt; 0 ? 'text-danger' : 'text-success'">
                            <t t-out="props.formatMonetary(margin.invoiced_billed)"/><br/>
                            <t t-if="revenues.total.invoiced != 0">
                                <t t-out="margin.invoiced_billed &gt; 0 ? '+' : ''"/><t t-out="(margin.invoiced_billed / revenues.total.invoiced * 100).toFixed()"/>%
                            </t>
                        </th>
                    </tr>
                </thead>
            </table>
        </div>
    </t>
`);
registerTemplate("project.ProjectRightSidePanelSection", `/project/static/src/components/project_right_side_panel/components/project_right_side_panel_section.xml`, `<t t-name="project.ProjectRightSidePanelSection" xml:space="preserve">
        <div class="o_rightpanel_section py-0" t-att-name="props.name" t-if="props.show">
            <div class="o_rightpanel_header d-flex align-items-center justify-content-between py-2 border-bottom" t-att-class="props.headerClassName" t-if="props.header">
                <div class="o_rightpanel_title d-flex flex-row-reverse align-items-center" t-if="props.slots.title">
                    <h3 class="m-0 lh-lg ps-1"><t t-slot="title"/></h3>
                </div>
                <t t-slot="header"/>
            </div>
            <div class="o_rightpanel_data fs-6" t-if="props.showData" t-att-class="props.dataClassName">
                <t t-slot="default"/>
            </div>
        </div>
    </t>

`);
registerTemplate("project.ProjectRightSidePanel", `/project/static/src/components/project_right_side_panel/project_right_side_panel.xml`, `<t t-name="project.ProjectRightSidePanel" xml:space="preserve">
        <div t-if="panelVisible" class="o_rightpanel ps-0 pt-0 bg-view border-start border-bottom overflow-auto">
            <ProjectRightSidePanelSection name="'stat_buttons'" header="false" show="!!state.data.buttons" dataClassName="'ps-3'">
                <div class="o_form_view">
                    <div class="oe_button_box o-form-buttonbox d-print-none d-grid" t-attf-style="grid-template-columns: repeat({{ state.gridTemplateColumns }}, 1fr);">
                        <t t-foreach="state.data.buttons" t-as="button" t-key="button.sequence">
                            <ViewButton t-if="button.show" defaultRank="'oe_stat_button'" className="'h-auto py-2 border border-start-0 border-top-0 text-start rounded-0'" icon="\`fa-\${button.icon}\`" title="button.text" clickParams="_getStatButtonClickParams(button)" record="_getStatButtonRecordParams()">
                                <t t-set-slot="contents">
                                    <div class="o_field_widget o_stat_info">
                                        <span class="o_stat_value text-start">
                                            <t t-esc="button.number"/>
                                        </span>
                                        <span class="o_stat_text">
                                            <t t-esc="button.text"/>
                                        </span>
                                    </div>
                                </t>
                            </ViewButton>
                        </t>
                    </div>
                </div>
            </ProjectRightSidePanelSection>
            <ProjectRightSidePanelSection name="'milestones'" show="!!state.data.milestones &amp;&amp; !!state.data.milestones.data" dataClassName="'my-3'" headerClassName="'border-bottom'">
                <t t-set-slot="header">
                    <span class="btn btn-secondary">
                        <div class="o_add_milestone">
                            <a t-on-click="addMilestone">Add Milestone</a>
                        </div>
                    </span>
                </t>
                <t t-set-slot="title">
                    Milestones
                </t>
                <div t-foreach="state.data.milestones.data" t-as="milestone" t-key="milestone.id" class="o_rightpanel_data_row">
                    <ProjectMilestone context="context" milestone="milestone" open.bind="openFormViewDialog" load.bind="loadMilestones"/>
                </div>
                <div t-if="state.data.milestones.data.length === 0" class="ps-3">
                    <span class="text-muted fst-italic">
                        Track major progress points that must be reached to achieve success.
                    </span>
                </div>
            </ProjectRightSidePanelSection>
            <ProjectRightSidePanelSection name="'profitability'" show="state.data.show_project_profitability_helper">
                <t t-set-slot="title">
                    Profitability
                </t>
                <ProjectProfitability t-if="showProjectProfitability" data="state.data.profitability_items" labels="state.data.profitability_labels" formatMonetary="formatMonetary.bind(this)" onProjectActionClick="onProjectActionClick.bind(this)" onClick="(params) =&gt; this.onProjectActionClick(params)"/>
                <div t-elif="state.data.show_project_profitability_helper" class="ps-3">
                    <span class="text-muted fst-italic">
                        Track project costs, revenues, and margin by setting the analytic account associated with the project on relevant documents.
                    </span>
                </div>
            </ProjectRightSidePanelSection>
        </div>

        <div t-else=""/>
    </t>

`);
registerTemplate("project.ProjectStatusWithColorSelectionField", `/project/static/src/components/project_status_with_color_selection/project_status_with_color_selection_field.xml`, `<t t-name="project.ProjectStatusWithColorSelectionField" t-inherit="web.SelectionField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-if='props.readonly']/span" position="replace">
            <div class="d-flex align-items-center">
                <span t-attf-class="o_status {{ statusColor(currentValue) }} d-inline-block"/>
                <div class="ps-2">
                    <div class="o_stat_text" t-if="this.props.statusLabel" t-out="this.props.statusLabel"/>
                    <div class="o_stat_value" t-out="string" t-if="!this.props.hideStatusName" t-att-raw-value="value"/>
                    <div class="o_stat_value" t-else="">
                        <span><t t-out="this.props.record.data['update_count']"/> Status</span>
                    </div>
                </div>
            </div>
        </xpath>
    </t>

`);
registerTemplate("project.ProjectTaskNameWithSubtaskCountCharField", `/project/static/src/components/project_task_name_with_subtask_count_char_field/project_task_name_with_subtask_count_char_field.xml`, `<t t-name="project.ProjectTaskNameWithSubtaskCountCharField" t-inherit="web.CharField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[@t-esc='formattedValue']" position="after">
            <span class="text-muted ms-2 fw-normal">
                <t t-if="props.record.data.subtask_count">
                    (<t t-out="props.record.data.closed_subtask_count"/>/<t t-out="props.record.data.subtask_count"/> sub-tasks)
                </t>
            </span>
        </xpath>
    </t>

`);
registerTemplate("project.TaskStageWithStateSelection", `/project/static/src/components/project_task_state_selection/project_task_stage_state_selection/project_task_stage_with_state_selection.xml`, `<t t-name="project.TaskStageWithStateSelection" xml:space="preserve">
        <div class="d-flex gap-1">
            <Many2OneField t-props="stageProps"/>
            <ProjectTaskStateSelection t-props="stateProps"/>
        </div>
    </t>

`);
registerTemplate("project.ProjectTaskStateSelection", `/project/static/src/components/project_task_state_selection/project_task_state_selection.xml`, `<t t-name="project.ProjectTaskStateSelection" t-inherit="web.StateSelectionField" t-inherit-mode="primary" xml:space="preserve">

        <xpath expr="//t[@t-if='props.readonly']/button" position="attributes">
            <attribute name="tabindex">-1</attribute>
        </xpath>
        <xpath expr="//t[@t-if='props.readonly']/button/span[1]" position="attributes">
            <attribute name="t-attf-class">{{ stateIcon(currentValue) }} {{ statusColor(currentValue) }}</attribute>
        </xpath>
        <xpath expr="//t[@t-if='props.readonly']/button" position="attributes">
            <attribute name="style">cursor: default;</attribute>
            <attribute name="t-att-title">label</attribute>
        </xpath>

        <xpath expr="//t[@t-if='props.readonly']" position="after">
            <t t-elif="currentValue == '04_waiting_normal' and isView(['activity', 'kanban', 'list', 'calendar'])">
                <button class="d-flex align-items-center btn fw-normal p-0 justify-content-center " title="This task is blocked by another unfinished task" t-att-class="{'o_task_state_list_view': isView(['list'])}">
                    <i class="fa fa-lg fa-hourglass-o text-info"/>
                </button>
            </t>
        </xpath>

        <xpath expr="//t[@t-if='props.readonly']" position="after">
            <t t-elif="isToggleMode and currentValue == '01_in_progress'">
                <button t-if="isView(['activity', 'kanban', 'list', 'calendar']) or this.env.isSmall" class="d-flex align-items-center btn fw-normal p-0" tabindex="-1" t-att-class="{'o_task_state_list_view': isView(['list'])}" t-on-click.stop="toggleState">
                    <i t-attf-class="{{ stateIcon(currentValue) }} {{ statusColor(currentValue) }} {{ ['1_done', '1_canceled'].includes(currentValue) and isView(['activity', 'kanban']) ? 'opacity-50' : '' }}"/>
                </button>
                <button t-else="" class="o_state_button btn oe_highlight rounded-pill" style="white-space: nowrap;" tabindex="-1" t-attf-class="#{currentValue == '1_done' ? 'btn-success' : 'btn-outline-secondary'}" t-att-class="{'bg-view border' : state.isStateButtonHighlighted}" t-on-click="toggleState" t-on-mouseenter="onMouseEnterStateButton" t-on-mouseleave="onMouseLeaveStateButton">
                    <div class="d-flex align-items-center">
                        <span class="o_status_label">
                            <t t-if="state.isStateButtonHighlighted">
                                <span class="text-success oe_highlight">
                                    <i class="fa fa-fw fa-check"/>
                                    Mark as done
                                </span>
                            </t>
                            <t t-else="currentValue == '01_in_progress'">
                                In Progress
                            </t>
                        </span>
                    </div>
                </button>
            </t>
        </xpath>


        <xpath expr="//Dropdown/button/div" position="replace">
            <div t-if="isView(['activity', 'kanban', 'list', 'calendar']) or this.env.isSmall" class="d-flex align-items-center" t-att-class="{'o_task_state_list_view': isView(['list'])}" t-att-title="label">
                <i t-if="currentValue == '04_waiting_normal'" t-attf-class="{{ stateIcon(currentValue) }} {{ statusColor(currentValue) }}" style="color: #4A4F59;"/>
                <i t-else="" t-attf-class="{{ stateIcon(currentValue) }} {{ statusColor(currentValue) }} {{ ['1_done', '1_canceled'].includes(currentValue) and isView(['activity', 'kanban']) ? 'opacity-50' : '' }}"/>
            </div>
            <div t-else="" class="d-flex align-items-center">
                <t t-if="currentValue == '04_waiting_normal'">
                    <i class="fa fa-fw fa-hourglass-o"/>
                    <span class="o_status_label" title="This task is blocked by another unfinished task">
                        Waiting
                    </span>
                </t>
                <t t-elif="currentValue != '1_done' and currentValue != '1_canceled'">
                    <span t-attf-class="o_status_label" t-out="label"/>
                </t>
                <t t-else="">
                    <span class="o_status_label" t-out="label"/>
                </t>
            </div>
        </xpath>

        <xpath expr="//Dropdown" position="attributes">

            <attribute name="position">\`\${ getDropdownPosition() }\`</attribute>
            <attribute name="menuClass" separator=" + " add="' project_task_state_selection_menu'"/>
        </xpath>
        <xpath expr="//Dropdown/button" position="attributes">
            <attribute name="tooltip">''</attribute>
            <attribute name="class" remove="p-0" add="shadow-none" separator=" "/>
            <attribute name="t-att-class">getTogglerClass(currentValue)</attribute>
        </xpath>

        <xpath expr="//DropdownItem" position="before">
            <div t-if="option[0] == '1_canceled' and (currentValue != '04_waiting_normal' or this.env.isSmall)" role="separator" class="dropdown-divider"/>
        </xpath>

        <xpath expr="//DropdownItem/span[1]" position="attributes">
            <attribute name="t-attf-class" separator=" " add="{{ stateIcon(option[0]) }}" remove="o_status"/>
        </xpath>
        <xpath expr="//DropdownItem/span[2]" position="attributes">
            <attribute name="t-attf-class">{{ statusColor(option[0]) }}</attribute>
        </xpath>
    </t>
`);
registerTemplate("project.SubtaskCreate", `/project/static/src/components/subtask_kanban_list/subtask_kanban_create/subtask_kanban_create.xml`, `<div t-name="project.SubtaskCreate" class="subtask_create_input d-flex" owl="1" xml:space="preserve">
        <input type="text" title="Rename" class="border-0 border-bottom py-1" t-ref="subtaskCreateInput" t-att-value="state.name" t-att-placeholder="placeholder" t-on-input="_onInput" t-on-click="_onClick" t-on-blur="_onBlur" t-on-change="_onNameChanged" t-att-disabled="props.isReadonly"/>
        <button t-on-click="_onSaveClick" class="ms-auto fw-bold btn btn-link py-0 px-2">
            SAVE
        </button>
    </div>
`);
registerTemplate("project.SubtaskKanbanList", `/project/static/src/components/subtask_kanban_list/subtask_kanban_list.xml`, `<t t-name="project.SubtaskKanbanList" xml:space="preserve">
        <t t-if="props.record.displaySubtasks">
            <div class="subtask_list">
                <div t-foreach="closedList" t-as="record" t-key="record.id" class="subtask_list_row">
                    <a t-attf-class="subtask_name_col {{ ['1_done', '1_canceled'].includes(record.data.state) ? 'text-muted opacity-50' : '' }}" t-att-title="record.data.display_name" t-esc="record.data.display_name" t-on-click.prevent="() =&gt; this.goToSubtask(record.resId)"/>
                    <Field class="\`o_field_many2many_avatar_user subtask_user_widget_col d-inline-flex align-items-center justify-content-end me-1 \${['1_done', '1_canceled'].includes(record.data.state) ? 'opacity-50' : ''}\`" name="'user_ids'" record="record" readonly="false" isEditable="true" type="'kanban.many2many_avatar_user'"/>
                    <Field name="'state'" class="\`subtask_state_widget_col d-flex justify-content-center align-items-center\`" record="record" type="'project_task_state_selection'" fieldInfo="fieldInfo.state"/>
                </div>
                <div class="subtask_create" t-on-click.stop="(ev) =&gt; this.onSubTaskCreated(ev)">
                    <t t-if="subtaskCreate.open">
                        <SubtaskCreate name="subtaskCreate.name" isReadonly="props.isReadonly" onSubtaskCreateNameChanged.bind="_onSubtaskCreateNameChanged" onBlur.bind="_onBlur"/>
                    </t>
                    <t t-else="">
                        <i class="fa fa-plus my-2"/> New
                    </t>
                </div>
            </div>
        </t>
    </t>

`);
registerTemplate("project.ProjectTaskCalendarFilterPanel.filter", `/project/static/src/views/project_task_calendar/project_task_calendar_filter_panel/project_task_calendar_filter_panel.xml`, `<t t-name="project.ProjectTaskCalendarFilterPanel.filter" t-inherit="web.CalendarFilterPanel.filter" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[@t-esc='filter.label']" position="before">
            <span t-if="props.model.isCheckProject and !filter.value" class="text-danger pe-1">
                <i class="fa fa-lock"/>
            </span>
        </xpath>
    </t>

`);
registerTemplate("project.ProjectUpdateKanbanView", `/project/static/src/views/project_update_kanban/project_update_kanban_controller.xml`, `<t t-name="project.ProjectUpdateKanbanView" t-inherit="web.KanbanView" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-component='props.Renderer']" position="before">
            <ProjectRightSidePanel context="props.context" domain="props.domain"/>
        </xpath>
    </t>

`);
registerTemplate("project.ProjectUpdateListView", `/project/static/src/views/project_update_list/project_update_list_controller.xml`, `<t t-name="project.ProjectUpdateListView" t-inherit="web.ListView" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-component='props.Renderer']" position="before">
            <ProjectRightSidePanel context="props.context" domain="props.domain"/>
        </xpath>
    </t>

`);
registerTemplate("project.SubtaskCounter", `/project/static/src/views/widget/subtask_counter.xml`, `<t t-name="project.SubtaskCounter" owl="1" xml:space="preserve">
        <a t-att-title="counterTitle" class="subtask_list_button btn-link text-dark" t-on-click.prevent="() =&gt; this.onClick()">
            <span class="fa fa-check-square-o me-1"/>
            <t t-esc="counterDisplay"/>
        </a>
    </t>

`);
registerTemplate("project.example.generic", `/project/static/src/xml/project_task_kanban_examples.xml`, `<t t-name="project.example.generic" xml:space="preserve">
      Prioritize your tasks by marking important ones using the <a style="color: gold;" class="fa fa-star"/> button.
      <br/><br/>
      Use the <span class="o_status d-inline-block o_status_green"/> state to inform your colleagues that a task is approved for the next stage. 
      <br/>
      Use the <span class="o_status d-inline-block bg-warning"/> state to indicate a request for changes or a need for discussion on a task.
      <br/><br/>
      Use the <span class="fa fa-check-circle text-success d-inline-block"/> state to mark the task as complete.
      <br/>
      Use the <span class="fa fa-times-circle text-danger d-inline-block"/> state to mark the task as cancelled.
      <br/><br/>
      Look for the <span class="fa fa-hourglass-o d-inline-block"/> icon to see tasks waiting on other ones. Once a task is marked as complete or cancelled, all of its dependencies will be unblocked.
      <br/><br/>
      Use the <a class="fa fa-clock-o"/> icon to organize your daily activities.
    </t>

    `);
registerTemplate("project.example.agilescrum", `/project/static/src/xml/project_task_kanban_examples.xml`, `<t t-name="project.example.agilescrum" xml:space="preserve">
      Use the <span class="o_status d-inline-block o_status_green"/> state to inform your colleagues that a task is approved for the next stage. 
      <br/>
      Use the <span class="o_status d-inline-block bg-warning"/> state to indicate a request for changes or a need for discussion on a task.
      <br/><br/>
      Use the <a class="fa fa-clock-o"/> icon to organize your daily activities.
      <br/><br/>
      <a class="fa fa-lightbulb-o"/> Sort your tasks by sprint using milestones, tags, or a dedicated property. At the end of each sprint, just pick the remaining tasks in your list and move them all at once to the next sprint by editing the milestone, tag, or property.
    </t>

    `);
registerTemplate("project.example.digitalmarketing", `/project/static/src/xml/project_task_kanban_examples.xml`, `<t t-name="project.example.digitalmarketing" xml:space="preserve">
      Everyone can propose ideas, and the Editor marks the best ones as <span class="o_status d-inline-block o_status_green"/>.<br/>
      Attach all documents or links to the task directly, to have all research information centralized. 
      <br/>
      Use the <a class="fa fa-clock-o"/> icon to organize your daily activities.
    </t>

    `);
registerTemplate("project.example.customerfeedback", `/project/static/src/xml/project_task_kanban_examples.xml`, `<t t-name="project.example.customerfeedback" xml:space="preserve">
      Customers propose feedbacks by email; Odoo creates tasks automatically, and you can
      communicate on the task directly. <br/>Your managers decide which feedback is accepted
      <span class="o_status d-inline-block o_status_green"/> and which feedback is
      moved to the "Refused" column.
      <br/>
      Use the <a class="fa fa-clock-o"/> icon to organize your daily activities.
    </t>

    `);
registerTemplate("project.example.consulting", `/project/static/src/xml/project_task_kanban_examples.xml`, `<t t-name="project.example.consulting" xml:space="preserve">
      Manage the lifecycle of your project using the kanban view. Add newly acquired projects,
      assign them and use the <span class="o_status d-inline-block o_status_green"/> and
      <span class="o_status d-inline-block bg-warning"/> to define if the project is
      ready for the next step.
      <br/>
      Use the <a class="fa fa-clock-o"/> icon to organize your daily activities.
    </t>

    `);
registerTemplate("project.example.researchproject", `/project/static/src/xml/project_task_kanban_examples.xml`, `<t t-name="project.example.researchproject" xml:space="preserve">
      Handle your idea gathering within Tasks of your new Project and discuss them in the chatter of the tasks. <br/>Use the
      <span class="o_status d-inline-block o_status_green"/> and <span class="o_status d-inline-block bg-warning"/>
      to signalize what is the current status of your Idea.
      <br/>
      Use the <a class="fa fa-clock-o"/> icon to organize your daily activities.
    </t>

    `);
registerTemplate("project.example.tshirtprinting", `/project/static/src/xml/project_task_kanban_examples.xml`, `<t t-name="project.example.tshirtprinting" xml:space="preserve">
      Communicate with customers on the task using the email gateway. Attach logo designs to the task, so that information flows from
      designers to the workers who print the t-shirt. <br/>Organize priorities amongst orders using the
      <a style="color: gold;" class="fa fa-star"/> icon.
      <br/>
      Use the <a class="fa fa-clock-o"/> icon to organize your daily activities.
    </t>

`);
registerTemplate("website_sale.FieldVideoPreview", `/website_sale/static/src/xml/website_sale.xml`, `<t t-name="website_sale.FieldVideoPreview" xml:space="preserve">
        <div class="ratio ratio-16x9 mt-2" t-if="props.record.data[props.name]">
            <t t-out="props.record.data[props.name]"/>
        </div>
    </t>

`);
registerTemplate("mass_mailing.MailingFilter", `/mass_mailing/static/src/xml/mailing_filter_widget.xml`, `<t t-name="mass_mailing.MailingFilter" t-inherit="web.Many2OneField" primary="True" xml:space="preserve">
        <xpath expr="//div[hasclass('o_field_many2one_selection')]" position="inside">
            <div class="o_mass_mailing_filter_container">
                <div t-attf-class="o_mass_mailing_save_filter_container pt-1 {{ !this.filter.canSaveFilter ? 'd-none': '' }}">
                    <div class="o_mass_mailing_filter_dropdown">
                        <MailingFilterDropdown>
                            <button class="btn py-0">
                                <span class="o_mass_mailing_add_filter">
                                    <span t-attf-class="o_mass_mailing_no_filter {{ this.props.record.data.mailing_filter_count ? 'd-none' : '' }}">Save as Favorite Filter</span>
                                    <i class="fa fa-floppy-o px-1 py-1"/>
                                </span>
                            </button>
                            <t t-set-slot="content">
                                <div class="ms-2 fw-light">
                                    Add to favorite filters
                                </div>
                                <div class="d-inline-flex">
                                    <input t-ref="autofocus" type="text" class="o_mass_mailing_filter_name o_input w-auto ms-2" placeholder="e.g. &quot;VIP Customers&quot;" t-on-keydown="onFilterNameInputKeydown"/>
                                    <button class="btn btn-sm btn-primary o_mass_mailing_btn_save_filter mx-2" t-on-click="onSaveFilter">
                                        Add
                                    </button>
                                </div>
                            </t>
                        </MailingFilterDropdown>
                    </div>
                </div>
                <a t-attf-class="o_mass_mailing_remove_filter btn px-1 pt-1 pb-0 {{ !this.filter.canRemoveFilter ? 'd-none': '' }}" t-on-click="onRemoveFilter">
                    <i class="fa fa-trash px-3 py-1 align-bottom" title="Remove from Favorites"/>
                </a>
            </div>
        </xpath>
    </t>

`);
registerTemplate("mass_mailing.theme_selector", `/mass_mailing/static/src/xml/mass_mailing.xml`, `<div t-name="mass_mailing.theme_selector" class="o_mail_theme_selector" xml:space="preserve">
        <t t-foreach="themes" t-as="theme" t-key="theme_index">
            <a t-att-id="theme.name" href="#" class="dropdown-item">
                <div class="o_thumb logo" t-attf-style="background-image: url(#{theme.img}_logo.png)"/>
            </a>
        </t>
    </div>
    `);
registerTemplate("mass_mailing.theme_selector_new", `/mass_mailing/static/src/xml/mass_mailing.xml`, `<div t-name="mass_mailing.theme_selector_new" class="o_mail_theme_selector_new" xml:space="preserve">
        <div class="o_mailing_template_preview_wrapper d-inline-block w-100">
            <div t-foreach="templates" t-as="template" t-key="template_index" class="o_mail_template_preview d-inline-block dropdown-item" t-att-id="template.name" t-att-model-id="template.modelId">
                <div class="d-inline-flex flex-row align-items-center text-white border px-2 py-2 w-100">
                    <i class="fa fa-star text-warning me-2"/>
                    <span class="text-truncate" t-esc="template.subject"/>
                    <div class="ms-auto">
                        <i class="o_mail_template_remove_favorite fa fa-trash ps-2 me-1" t-att-data-id="template.id" title="Remove from Templates"/>
                        <img t-if="template.userId" t-attf-src="/web/image/res.users/#{template.userId}/avatar_128" t-att-title="template.userName"/>
                    </div>
                </div>
            </div>
        </div>
        <div class="d-inline-block w-100">
            <a t-foreach="themes" t-as="theme" t-key="theme_index" t-att-id="theme.name" role="menuitem" href="#" class="dropdown-item px-4">
                <div class="o_thumb small mb-2" t-attf-style="background-image: url(#{theme.img}_small.png)"/>
                <div class="o_thumb large mb-2" t-attf-style="background-image: url(#{theme.img}_large.png)"/>
                <h5 class="text-white text-capitalize text-truncate" t-esc="theme.title"/>
            </a>
        </div>
    </div>
`);
registerTemplate("mass_mailing.MobilePreviewDialog", `/mass_mailing/static/src/xml/mass_mailing_mobile_preview.xml`, `<t t-name="mass_mailing.MobilePreviewDialog" xml:space="preserve">
        <Dialog bodyClass="'o_mailing_mobile_preview'">
            <t t-set-slot="header" t-on-click="toggle">
                <div class="d-flex align-items-center justify-content-between flex w-100">
                    <h4 class="d-flex align-items-center justify-content-start">
                        <span class="modal-title text-break" t-esc="props.title"/>
                        <span class="fa fa-refresh ms-3"/>
                    </h4>
                    <div type="button" class="btn-close" aria-label="Close" t-on-click="props.close"/>
                </div>
            </t>
            <iframe t-ref="iframeRef" src="/mailing/mobile/preview" t-on-load="appendPreview"/>
        </Dialog>
    </t>
`);
registerTemplateExtension("project.ProjectRightSidePanelSection", `/project_enterprise/static/src/components/project_right_side_panel/components/project_right_side_panel_section.xml`, `<t t-name="project_enterprise.ProjectRightSidePanelSection" t-inherit="project.ProjectRightSidePanelSection" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('o_rightpanel_title')]" position="inside">
            <span class="me-2" t-if="env.isSmall and props.canBeClosed"><i t-attf-class="fa {{state.isClosed ? 'fa-caret-right' : 'fa-caret-down'}}"/></span>
        </xpath>
        <xpath expr="//div[hasclass('o_rightpanel_header')]" position="attributes">
            <attribute name="t-on-click">toggleSection</attribute>
        </xpath>
        <xpath expr="//div[hasclass('o_rightpanel_data')]" position="attributes">
            <attribute name="t-attf-class" separator=" " add="{{state.isClosed ? 'o_rightpanel_hidden d-none' : ''}}"/>
        </xpath>
    </t>

`);
registerTemplateExtension("project.ProjectRightSidePanel", `/project_enterprise/static/src/components/project_right_side_panel/project_right_side_panel.xml`, `<t t-inherit="project.ProjectRightSidePanel" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//ProjectRightSidePanelSection[@name=&quot;'stat_buttons'&quot;]" position="attributes">
            <attribute name="canBeClosed">false</attribute>
        </xpath>
    </t>

`);
registerTemplate("project_enterprise.SelectCreateAutoPlanDialog", `/project_enterprise/static/src/views/view_dialogs/select_auto_plan_create_dialog.xml`, `<t t-name="project_enterprise.SelectCreateAutoPlanDialog" t-inherit="web.SelectCreateDialog" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//button[hasclass('o_create_button')]" position="after">
            <button class="btn btn-secondary o_auto_plan_button" t-att-disabled="state.resIds.length === 0" data-hotkey="k" t-on-click="() =&gt; this.selectWithSmartSchedule(state.resIds)">
                Auto Plan
            </button>
        </xpath>
        <xpath expr="//button[hasclass('o_select_button')]" position="attributes">
            <attribute name="t-on-click">() =&gt; this.select(state.resIds)</attribute>
            <attribute name="data-hotkey">s</attribute>
        </xpath>
    </t>

`);
registerTemplate("industry_fsm.task_confirm_schedule_warning", `/project_enterprise/static/src/xml/task_confirm_schedule_warning.xml`, `<t t-name="industry_fsm.task_confirm_schedule_warning" xml:space="preserve">
        <div class="o-tooltip">
            <span class="text-danger" t-esc="text"/>
        </div>
    </t>
`);
registerTemplate("resource_mail.AvatarCardResourcePopover", `/resource_mail/static/src/components/avatar_card_resource/avatar_card_resource_popover.xml`, `<t t-name="resource_mail.AvatarCardResourcePopover" t-inherit="mail.AvatarCardPopover" xml:space="preserve">
        <xpath expr="//span[hasclass('o_avatar')]/img" position="attributes">
            <attribute name="t-attf-src" t-if="displayAvatar">/web/image/{{ props.recordModel }}/{{ props.id }}/avatar_128</attribute>
        </xpath>
        <xpath expr="//span[hasclass('o_card_avatar_im_status')]" position="replace">
            <span t-if="record.user_id" name="icon" class="o_card_avatar_im_status position-absolute d-flex align-items-center justify-content-center o_user_im_status bg-inherit">
                <i t-if="record.im_status === 'online'" class="fa fa-fw fa-circle text-success" title="Online" role="img" aria-label="User is online"/>
                <i t-elif="record.im_status === 'away'" class="fa fa-fw fa-circle text-warning" title="Idle" role="img" aria-label="User is idle"/>
                <i t-elif="record.im_status === 'offline'" class="fa fa-fw fa-circle-o text-700" title="Offline" role="img" aria-label="User is offline"/>
                <i t-elif="record.im_status === 'bot'" class="fa fa-fw fa-heart text-success" title="Bot" role="img" aria-label="User is a bot"/>
                <i t-elif="!record.im_status" class="fa fa-fw fa-question-circle" title="No IM status available"/>
            </span>
        </xpath>
        <xpath expr="//div[hasclass('o_card_user_infos')]/span" position="attributes">
            <attribute name="t-esc">record.name</attribute>
        </xpath>
        <xpath expr="//div[hasclass('o_avatar_card_buttons')]/button" position="attributes">
            <attribute name="t-if">record.user_id and !record.share</attribute>
        </xpath>
    </t>
`);
registerTemplate("resource_mail.AvatarResourceMany2XAutocomplete", `/resource_mail/static/src/views/fields/many2many_avatar_resource/many2many_avatar_resource_field.xml`, `<t t-name="resource_mail.AvatarResourceMany2XAutocomplete" t-inherit="web.AvatarMany2XAutocomplete" xml:space="preserve">
        <xpath expr="//span[hasclass('o_avatar_many2x_autocomplete')]/img" position="before">
            <i t-if="option.resourceType === 'material'" class="o_material_resource fa fa-wrench rounded text-center me-2             d-flex align-items-center justify-content-center" t-attf-class="o_colorlist_item_color_{{ option.color }}"/>
        </xpath>
        <xpath expr="//span[hasclass('o_avatar_many2x_autocomplete')]/img" position="attributes">
            <attribute name="t-if" add="&amp;&amp; option.resourceType !== 'material'" separator=" "/>
        </xpath>
    </t>

    `);
registerTemplate("resource_mail.Many2ManyAvatarResourceTagsList", `/resource_mail/static/src/views/fields/many2many_avatar_resource/many2many_avatar_resource_field.xml`, `<t t-name="resource_mail.Many2ManyAvatarResourceTagsList" t-inherit="mail.Many2ManyAvatarUserTagsList" xml:space="preserve">
        <xpath expr="//span[hasclass('o_tag')]/i" position="attributes">
            <attribute name="t-on-click.stop.prevent">tag.onImageClicked</attribute>
        </xpath>
    </t>
`);
registerTemplate("resource_mail.Many2OneAvatarResourceField", `/resource_mail/static/src/views/fields/many2one_avatar_resource/many2one_avatar_resource_field.xml`, `<t t-name="resource_mail.Many2OneAvatarResourceField" t-inherit="mail.Many2OneAvatarUserField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[hasclass('o_m2o_avatar')]" position="attributes">
            <attribute name="t-attf-class" add="{{ displayResourcePopover ? 'o_field_many2one_avatar': '' }}" separator=" "/>
        </xpath>
        <xpath expr="//span[hasclass('o_m2o_avatar')]/img" position="attributes">
            <attribute name="t-if">props.record.data.resource_type !== 'material' &amp;&amp; props.record.data[props.name] !== false</attribute>
        </xpath>
        <xpath expr="//span[hasclass('o_m2o_avatar')]/img" position="after">
            <t t-if="props.record.data.resource_type === 'material'">
                <span t-if="props.record.data[props.name] !== false" t-att-title="props.record.data[props.name][1]" class="d-inline-flex align-items-center justify-content-center rounded o_material_resource cursor-default me-1">
                    <i class="fa fa-wrench"/>
                </span>
                <span t-elif="!props.readonly" class="o_m2o_avatar_empty"/>
            </t>
        </xpath>
    </t>

    `);
registerTemplate("resource_mail.KanbanMany2OneAvatarResourceField", `/resource_mail/static/src/views/fields/many2one_avatar_resource/many2one_avatar_resource_field.xml`, `<t t-name="resource_mail.KanbanMany2OneAvatarResourceField" t-inherit="mail.KanbanMany2OneAvatarUserField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[hasclass('o_m2o_avatar')]/img" position="attributes">
            <attribute name="t-if">props.record.data.resource_type !== 'material' &amp;&amp; props.record.data[props.name] !== false</attribute>
        </xpath>
        <xpath expr="//span[hasclass('o_m2o_avatar')]/img" position="after">
            <t t-if="props.record.data.resource_type === 'material'">
                <span t-if="props.record.data[props.name] !== false" t-att-title="props.record.data[props.name][1]" class="d-inline-flex align-items-center justify-content-center rounded o_material_resource cursor-default me-1">
                    <i class="fa fa-wrench"/>
                </span>
                <span t-elif="!props.readonly" class="o_m2o_avatar_empty"/>
            </t>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.AvatarCardPopover", `/hr/static/src/components/avatar_card/avatar_card_popover_patch.xml`, `<t t-inherit="mail.AvatarCardPopover" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//a[hasclass('o-mail-avatar-card-tel')]" position="after">
            <span t-if="user.work_location_name" class="text-muted" data-tooltip="Work Location">
                <i t-if="user.work_location_type === 'office'" class="me-1 fa fa-fw fa-building-o"/>
                <i t-elif="user.work_location_type === 'home'" class="me-1 fa fa-fw fa-home"/>
                <i t-else="" class="me-1 fa fa-fw fa-map-marker"/>
                <t t-esc="user.work_location_name"/>
            </span>
        </xpath>
    </t>

    `);
registerTemplate("hr.avatarCardUserInfos", `/hr/static/src/components/avatar_card/avatar_card_popover_patch.xml`, `<t t-name="hr.avatarCardUserInfos" xml:space="preserve">
        <small class="text-muted text-truncate" t-if="user.job_title" t-att-title="user.job_title" t-esc="user.job_title"/>
        <span class="text-muted text-truncate" t-if="user.department_id" data-tooltip="Department" t-att-title="user.department_id[1]" t-esc="user.department_id[1]"/>
    </t>
`);
registerTemplateExtension("resource_mail.AvatarCardResourcePopover", `/hr/static/src/components/avatar_card_resource/avatar_card_resource_popover.xml`, `<t t-inherit="resource_mail.AvatarCardResourcePopover" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//span[hasclass('o_avatar')]/img" position="attributes">
            <attribute name="t-if">this.record.employee_id?.length</attribute>
        </xpath>
        <xpath expr="//span[hasclass('o_user_im_status')]" position="after">
            <span t-elif="record.show_hr_icon_display" name="icon" class="o_card_avatar_im_status position-absolute d-flex align-items-center justify-content-center o_employee_presence_status bg-inherit">

                <i t-if="record.hr_icon_display == 'presence_present'" class="fa fa-fw fa-circle text-success" title="Present" role="img" aria-label="Present"/>

                <i t-if="record.hr_icon_display == 'presence_absent'" class="fa fa-fw fa-circle text-warning" title="Absent" role="img" aria-label="Absent"/>

                <i t-if="record.hr_icon_display == 'presence_out_of_working_hour'" class="fa fa-fw fa-circle text-muted" title="Out of Working Hours" role="img" aria-label="Out of Working Hours"/>
            </span>
        </xpath>
    </t>

    `);
registerTemplate("hr.avatarCardResourceInfos", `/hr/static/src/components/avatar_card_resource/avatar_card_resource_popover.xml`, `<t t-name="hr.avatarCardResourceInfos" xml:space="preserve">
        <small class="text-muted" t-if="record.job_title" t-esc="record.job_title"/>
        <span class="text-muted" t-if="record.department_id" data-tooltip="Department" t-esc="record.department_id[1]"/>
    </t>
`);
registerTemplate("hr.BackgroundImage", `/hr/static/src/components/background_image/background_image.xml`, `<t t-name="hr.BackgroundImage" xml:space="preserve">
        <img loading="lazy" t-att-data-tooltip-template="hasTooltip and tooltipAttributes.template" t-att-data-tooltip-info="hasTooltip and tooltipAttributes.info" t-att-data-tooltip-delay="hasTooltip and props.zoomDelay" t-attf-src="#{getUrl(props.previewImage or props.name)}" alt="Binary file"/>
    </t>
`);
registerTemplate("hr.DepartmentChart", `/hr/static/src/components/department_chart/department_chart.xml`, `<t t-name="hr.DepartmentChart" xml:space="preserve">
        <div class="o_hr_department_chart">
            <div class="o_horizontal_separator mb-3 text-uppercase fw-bolder small">Department Organization</div>
            <t t-if="state.hierarchy.self">
                <div class="o_hr_department_chart_parent">
                    <t t-set="dept" t-value="state.hierarchy.parent"/>
                    <t t-set="hideTree" t-value="true"/>
                    <t t-call="hr.DepartmentChart.Department"/>
                </div>

                <div t-att-class="state.hierarchy.parent?'ms-4':''">
                    <div class="o_hr_department_chart_self">
                        <t t-set="dept" t-value="state.hierarchy.self"/>
                        <t t-set="hideTree" t-value="!state.hierarchy.parent"/>
                        <t t-call="hr.DepartmentChart.Department"/>
                    </div>

                    <t t-set="hideTree" t-value="false"/>
                    <div class="o_hr_department_chart_children ms-4">
                        <t t-foreach="state.hierarchy.children" t-as="dept" t-key="dept.name">
                            <t t-call="hr.DepartmentChart.Department"/>
                        </t>
                    </div>
                </div>
            </t>
        </div>
    </t>

    `);
registerTemplate("hr.DepartmentChart.Department", `/hr/static/src/components/department_chart/department_chart.xml`, `<t t-name="hr.DepartmentChart.Department" xml:space="preserve">
        <t t-if="dept">
            <div t-attf-class="#{hideTree?'':'o_treeEntry'} mb-0 ps-4">
                <div class="d-flex justify-content-between">
                    <span class="department_name ms-2">
                        <t t-esc="dept.name"/>
                    </span>
                    <a class="badge rounded-pill bg-300 border px-2 cursor-pointer" role="button" title="Show employees" t-on-click.prevent="() =&gt; this.openDepartmentEmployees(dept.id)">
                        <t t-esc="dept.employees"/>
                    </a>
                </div>
            </div>
        </t>
    </t>
`);
registerTemplate("hr.OpenChat", `/hr/static/src/components/employee_chat/employee_chat.xml`, `<t t-name="hr.OpenChat" xml:space="preserve">
        <a t-if="props.record.data.user_id and props.record.resId" title="Chat" icon="fa-comments" t-on-click.prevent="() =&gt; openChat(props.record.resId)" href="#" class="ml8 o_employee_chat_btn" role="button">
            <i class="fa fa-comments align-middle fs-6"/>
        </a>
    </t>
`);
registerTemplate("hr.HrPresenceStatus", `/hr/static/src/components/hr_presence_status/hr_presence_status.xml`, `<t t-name="hr.HrPresenceStatus" xml:space="preserve">
        <t t-tag="props.tag" role="img" t-att-class="classNames" t-att-aria-label="label" t-att-title="label"/>
    </t>

`);
registerTemplate("hr_homeworking.RadioImageField", `/hr/static/src/components/radio_image_field/radio_image_field.xml`, `<t t-name="hr_homeworking.RadioImageField" xml:space="preserve">
        <div role="radiogroup" class="d-flex flex-wrap" t-att-aria-label="string">
            <t t-foreach="items" t-as="item" t-key="item[0]">
                <t t-if="['office', 'home', 'other'].includes(item[0])">
                    <div class="form-check o_radio_item me-1" aria-atomic="true">
                        <input type="radio" class="form-check-input o_radio_input" t-att-checked="item[0] === value" t-att-disabled="props.readonly" t-att-name="id" t-att-data-value="item[0]" t-att-data-index="item_index" t-att-id="\`\${id}_\${item[0]}\`" t-on-change="() =&gt; this.onChange(item)"/>
                        <t t-if="item[0] === 'office'">
                            <i class="fa fa-building-o fa-2x" role="img"/>
                        </t>
                        <t t-elif="item[0] === 'home'">
                            <i class="fa fa-home fa-2x" role="img"/>
                        </t>
                        <t t-else="">
                            <i class="fa fa-map-marker fa-2x" role="img"/>
                        </t>
                    </div>
                </t>
            </t>
        </div>
    </t>


`);
registerTemplate("hr.WorkPermitUploadField", `/hr/static/src/components/work_permit_upload/work_permit_upload.xml`, `<t t-name="hr.WorkPermitUploadField" t-inherit="web.BinaryField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//label[hasclass('o_select_file_button')]" position="attributes">
            <attribute name="class" remove="btn-primary" add="btn-secondary" separator=" "/>
        </xpath>
    </t>

`);
registerTemplate("hr.EmployeeActionHelper", `/hr/static/src/views/hr_action_helper.xml`, `<t t-name="hr.EmployeeActionHelper" xml:space="preserve">
        <div class="o_view_nocontent">
            <div class="o_nocontent_help">
                <p class="o_view_nocontent_smiling_face">
                    <t t-esc="props.noContentTitle"/>
                </p>
                <p>
                    <t t-esc="props.noContentParagraph"/>
                </p>
            </div>
        </div>
    </t>
`);
registerTemplate("hr_timesheet.TimesheetUOM", `/hr_timesheet/static/src/components/timesheet_uom/timesheet_uom.xml`, `<t t-name="hr_timesheet.TimesheetUOM" xml:space="preserve">
        <t t-component="timesheetComponent" t-props="timesheetComponentProps"/>
    </t>

`);
registerTemplate("timer.TimerStartField", `/timer/static/src/component/timer_start_field/timer_start_field.xml`, `<t t-name="timer.TimerStartField" xml:space="preserve">
        <span t-if="props.record.data[props.name]" t-out="timerReactive.time"/>
    </t>

`);
registerTemplate("timer.ToggleButton", `/timer/static/src/component/timer_toggle_button/timer_toggle_button.xml`, `<t t-name="timer.ToggleButton" xml:space="preserve">
        <button type="button" t-on-click.stop.prevent="onClick" t-attf-class="px-3 py-1 border border-0 rounded-1 text-center {{buttonClass}}" t-att-title="title" t-att-aria-label="title">
            <i t-att-class="iconClass" t-att-title="title"/>
        </button>
    </t>

`);
registerTemplate("hr_org_chart.hr_org_chart_employee", `/hr_org_chart/static/src/fields/hr_org_chart.xml`, `<t t-name="hr_org_chart.hr_org_chart_employee" xml:space="preserve">
    <t t-set="is_self" t-value="employee.id == view_employee_id"/>

    <section t-if="employee_type == 'self'" t-attf-class="o_org_chart_entry_self_container #{managers.length &gt; 0 ? 'o_org_chart_has_managers' : ''}">
        <div t-attf-class="o_org_chart_entry o_org_chart_entry_#{employee_type} d-flex position-relative py-2 overflow-visible #{managers.length &gt; 0 ? 'o_treeEntry' : ''}">
            <t t-call="hr_org_chart.hr_org_chart_employee_content">
                <t t-set="is_self" t-value="is_self"/>
            </t>
        </div>
    </section>

    <div t-else="" t-attf-class="o_org_chart_entry o_org_chart_entry_#{employee_type} o_treeEntry d-flex position-relative py-2 overflow-visible">
        <t t-call="hr_org_chart.hr_org_chart_employee_content">
            <t t-set="is_self" t-value="is_self"/>
        </t>
    </div>
</t>

`);
registerTemplate("hr_org_chart.hr_org_chart_employee_content", `/hr_org_chart/static/src/fields/hr_org_chart.xml`, `<t t-name="hr_org_chart.hr_org_chart_employee_content" xml:space="preserve">
    <div class="o_media_left position-relative">

        <a t-if="! is_self" class="o_media_object d-block rounded o_employee_redirect" t-att-style="'background-image:url(\\'/web/image/hr.employee.public/' + employee.id + '/avatar_1024/\\')'" t-att-alt="employee.name" t-att-data-employee-id="employee.id" t-att-href="employee.link" t-on-click.prevent="() =&gt; this._onEmployeeRedirect(employee.id)"/>
        <div t-if="is_self" class="o_media_object d-block rounded border border-info" t-att-style="'background-image:url(\\'/web/image/hr.employee.public/' + employee.id + '/avatar_1024/\\')'"/>
    </div>

    <div class="d-flex flex-grow-1 align-items-center justify-content-between position-relative px-3">
        <a t-if="!is_self" t-att-href="employee.link" class="o_employee_redirect d-flex flex-column" t-att-data-employee-id="employee.id" t-on-click.prevent="() =&gt; this._onEmployeeRedirect(employee.id)">
            <b class="o_media_heading m-0 fs-6" t-esc="employee.name"/>
            <small class="text-muted fw-bold" t-esc="employee.job_title"/>
        </a>
        <div t-if="is_self" class="d-flex flex-column">
            <h5 class="o_media_heading m-0" t-esc="employee.name"/>
            <small class="text-muted fw-bold" t-esc="employee.job_title"/>
        </div>
        <button t-if="employee.indirect_sub_count &gt; 0" class="btn p-0 fs-3" tabindex="0" t-att-data-emp-name="employee.name" t-att-data-emp-id="employee.id" t-att-data-emp-dir-subs="employee.direct_sub_count" t-att-data-emp-ind-subs="employee.indirect_sub_count" data-bs-trigger="focus" data-bs-toggle="popover" t-on-click="(event) =&gt; this._onOpenPopover(event, employee)">
            <a href="#" t-attf-class="badge rounded-pill bg-300 border {{employee.indirect_sub_count &lt; 10 ? 'px-2' : 'px-1' }}" t-esc="employee.indirect_sub_count"/>
        </button>

    </div>
</t>

`);
registerTemplate("hr_org_chart.hr_org_chart", `/hr_org_chart/static/src/fields/hr_org_chart.xml`, `<t t-name="hr_org_chart.hr_org_chart" xml:space="preserve">

    <t t-set="emp_count" t-value="0"/>
    <div t-if="managers.length &gt; 0" class="o_org_chart_group_up position-relative">
        <div t-if="managers_more" class="o_org_chart_more pe-3">
            <a href="#" t-att-data-employee-id="managers[0].id" class="o_employee_more_managers d-block bg-100 px-3" t-on-click.prevent="() =&gt; this._onEmployeeMoreManager(managers[0].id)">
                <i class="fa fa-angle-double-up" role="img" aria-label="More managers" title="More managers"/>
            </a>
        </div>

        <t t-foreach="managers" t-as="employee" t-key="employee_index">
            <t t-set="emp_count" t-value="emp_count + 1"/>
            <t t-call="hr_org_chart.hr_org_chart_employee">
                <t t-set="employee_type" t-value="'manager'"/>
            </t>
        </t>
    </div>

    <t t-if="children.length || managers.length" t-call="hr_org_chart.hr_org_chart_employee">
        <t t-set="employee_type" t-value="'self'"/>
        <t t-set="employee" t-value="self"/>
    </t>

    <t t-if="!children.length &amp;&amp; !managers.length">
        <div class="alert alert-info" role="alert">
            <p><b>No hierarchy position.</b></p>
            <p>This employee has no manager or subordinate.</p>
            <p>In order to get an organigram, set a manager and save the record.</p>
        </div>
    </t>

    <div t-if="children.length" t-attf-class="o_org_chart_group_down position-relative #{managers.length &gt; 0 ? 'o_org_chart_has_managers' : ''}">
        <t t-foreach="children" t-as="employee" t-key="employee_index">
            <t t-set="emp_count" t-value="emp_count + 1"/>
            <t t-if="emp_count &lt; 20">
                <t t-call="hr_org_chart.hr_org_chart_employee">
                    <t t-set="employee_type" t-value="'sub'"/>
                </t>
            </t>
        </t>

        <t t-if="(children.length + managers.length) &gt; 19">
            <div class="o_org_chart_entry o_org_chart_more d-flex overflow-visible">
                <div class="o_media_left position-relative">
                    <a href="#" t-att-data-employee-id="self.id" t-att-data-employee-name="self.name" class="o_org_chart_show_more o_employee_sub_redirect btn btn-link ps-2" t-on-click.prevent="_onEmployeeSubRedirect">See All</a>
                </div>
            </div>
        </t>
    </div>
</t>

`);
registerTemplate("hr_org_chart.hr_orgchart_emp_popover", `/hr_org_chart/static/src/fields/hr_org_chart.xml`, `<t t-name="hr_org_chart.hr_orgchart_emp_popover" xml:space="preserve">
    <div class="popover o_org_chart_popup" role="tooltip">
        <div class="tooltip-arrow">

        </div>
        <h3 class="popover-header">
            <div class="d-flex align-items-center">
                <span class="flex-shrink-0" t-att-style="&quot;background-image:url(\\&quot;/web/image/hr.employee.public/&quot; + props.employee.id + &quot;/avatar_1024/\\&quot;)&quot;"/>
                <b class="flew-grow-1"><t t-esc="props.employee.name"/></b>
                <a href="#" class="ms-auto o_employee_redirect" t-att-data-employee-id="props.employee.id" t-on-click.prevent="() =&gt; this._onEmployeeRedirect(props.employee.id)"><i class="fa fa-external-link" role="img" aria-label="Redirect" title="Redirect"/></a>
            </div>
        </h3>
        <div class="popover-body">
            <table class="table table-sm table-borderless mb-0">
                <tbody>
                    <tr>
                        <td class="text-end"><b t-esc="props.employee.direct_sub_count"/></td>
                        <td>
                            <a href="#" class="o_employee_sub_redirect" data-type="direct" t-att-data-employee-name="props.employee.name" t-att-data-employee-id="props.employee.id" t-on-click.prevent="_onEmployeeSubRedirect">
                                <b>Direct subordinates</b></a>
                        </td>
                    </tr>
                    <tr>
                        <td class="text-end">
                            <b t-esc="props.employee.indirect_sub_count - props.employee.direct_sub_count"/>
                        </td>
                        <td>
                            <a href="#" class="o_employee_sub_redirect" data-type="indirect" t-att-data-employee-name="props.employee.name" t-att-data-employee-id="props.employee.id" t-on-click.prevent="_onEmployeeSubRedirect">
                                Indirect subordinates</a>
                        </td>
                    </tr>
                    <tr>
                        <td class="text-end"><b t-esc="props.employee.indirect_sub_count"/></td>
                        <td>
                            <a href="#" class="o_employee_sub_redirect" data-type="total" t-att-data-employee-name="props.employee.name" t-att-data-employee-id="props.employee.id" t-on-click.prevent="_onEmployeeSubRedirect">
                                Total</a>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
</t>

`);
registerTemplate("timesheet_grid.EmployeeOvertimeIndication", `/timesheet_grid/static/src/components/employee_overtime_indication/employee_overtime_indication.xml`, `<t t-name="timesheet_grid.EmployeeOvertimeIndication" xml:space="preserve">
        <small t-if="overtimeIndication" t-attf-class="o_timesheet_overtime_indication align-self-center mx-1 opacity-75 {{ colorClasses }}" title="Difference between the number of hours recorded and the number of hours the employee was supposed to work according to his contract">
            <t t-out="overtimeIndication"/>
        </small>
    </t>
`);
registerTemplate("timesheet_grid.GridTimerButtonCell", `/timesheet_grid/static/src/components/grid_timer_button_cell/grid_timer_button_cell.xml`, `<t t-name="timesheet_grid.GridTimerButtonCell" xml:space="preserve">
        <button type="button" class="btn_timer_line btn position-relative border-2 fa-stack" t-att-class="{                     'btn-outline-secondary': !state.timerRunning and props.hovered or !state.timerRunning and env.isSmall or !state.timerRunning,                     'btn-success': props.hovered,                     'btn-danger': state.timerRunning,                  }" t-on-click.synthetic="() =&gt; this.props.onTimerClick(this.props.row)">
            <span class="o_grid_timer_button position-absolute start-0 top-0 d-flex align-items-center justify-content-center w-100 h-100" t-att-class="{                     'bg-view bg-opacity-75' : !props.hovered and !state.timerRunning and !env.isSmall                   }">
                <span t-if="!state.timerRunning &amp;&amp; !props.hovered" class="d-none d-md-inline text-primary" t-att-class="{                         'text-lowercase': !props.addTimeMode,                         'text-muted fa fa-play': !props.hotKey,                       }" t-out="props.hotKey"/>
                <i t-if="state.timerRunning or props.hovered or env.isSmall" class="fa" t-att-class="{                     'fa-stop' : state.timerRunning,                     'fa-play' : !state.timerRunning and !props.addTimeMode,                     'fa-plus' : !state.timerRunning and props.addTimeMode,                    }"/>
            </span>
        </button>
    </t>

`);
registerTemplate("timesheet_grid.GridTimesheetTimerHeader", `/timesheet_grid/static/src/components/grid_timesheet_timer_header/grid_timesheet_timer_header.xml`, `<t t-name="timesheet_grid.GridTimesheetTimerHeader" xml:space="preserve">
        <t t-if="props.timerRunning and !props.otherCompany">
            <Record fields="fields" activeFields="activeFields" resModel="props.model.resModel" resId="props.resId" t-slot-scope="data" mode="'edit'" onRecordChanged.bind="onTimesheetChanged">
                <TimesheetTimerHeader timesheet="data.record" addTimeMode="props.addTimeMode" timerRunning="props.timerRunning" otherCompany="props.otherCompany" fields="activeFields" stepTimer="props.stepTimer" timerReactive="timerReactive" onTimerStarted="props.onTimerStarted" onTimerStopped="props.onTimerStopped" onTimerUnlinked="props.onTimerUnlinked"/>
            </Record>
        </t>
        <t t-else="">
            <TimesheetTimerHeader addTimeMode="props.addTimeMode" timerRunning="props.timerRunning" otherCompany="props.otherCompany" fields="activeFields" stepTimer="props.stepTimer" onTimerStarted="props.onTimerStarted" onTimerStopped="props.onTimerStopped" onTimerUnlinked="props.onTimerUnlinked"/>
        </t>
    </t>

`);
registerTemplate("timesheet_grid.TimesheetTimerFloatTimeField", `/timesheet_grid/static/src/components/timesheet_display_timer/timesheet_display_timer.xml`, `<t t-name="timesheet_grid.TimesheetTimerFloatTimeField" t-inherit="web.FloatTimeField" xml:space="preserve">
        <xpath expr="//span" position="attributes">
            <attribute name="t-att-class">props.timerRunning and props.displayRed ? "fw-bold text-danger" : ""</attribute>
        </xpath>
        <xpath expr="//input" position="attributes">
            <attribute name="t-att-class">props.timerRunning and props.displayRed ? "fw-bold text-danger" : ""</attribute>
        </xpath>
    </t>

    `);
registerTemplate("timesheet_grid.TimesheetDisplayTimer", `/timesheet_grid/static/src/components/timesheet_display_timer/timesheet_display_timer.xml`, `<t t-name="timesheet_grid.TimesheetDisplayTimer" xml:space="preserve">
        <TimesheetTimerFloatTimerField t-props="TimesheetTimerFloatTimerFieldProps"/>
    </t>

`);
registerTemplate("timesheet_grid.TimesheetOvertimeIndication", `/timesheet_grid/static/src/components/timesheet_overtime_indication/timesheet_overtime_indication.xml`, `<t t-name="timesheet_grid.TimesheetOvertimeIndication" t-inherit="timesheet_grid.EmployeeOvertimeIndication" xml:space="preserve">
        <xpath expr="//small" position="attributes">
            <attribute name="title"/>
            <attribute name="t-att-title">title</attribute>
        </xpath>
    </t>
`);
registerTemplate("timesheet_grid.TimesheetTimerHeader", `/timesheet_grid/static/src/components/timesheet_timer_header/timesheet_timer_header.xml`, `<t t-name="timesheet_grid.TimesheetTimerHeader" xml:space="preserve">
        <div class="timesheet-timer flex-grow-1 d-md-flex align-items-center ps-3 py-2" t-attf-style="height: {{this.isMobile ? 'auto' : '50px'}}" t-att-class="props.className" t-on-timer-started="props.onTimerStarted" t-on-timer-stopped="props.onTimerStopped" t-on-timer-unlink="props.onTimerUnlinked" t-on-click.prevent="props.onClick">
            <t t-if="_timerIsRunning">
                <div class="d-md-flex flex-grow-1 flex-wrap flex-lg-nowrap">
                    <div class="d-flex align-items-center">
                        <button class="btn btn-primary btn_stop_timer text-nowrap" name="stop_timer" t-on-click.stop="_onClickStopTimer" data-hotkey="x" t-ref="stopButton" t-att-disabled="otherCompany">
                            <i class="fa fa-stop me-2"/> Stop
                        </button>
                        <div class="o_timer_discard">
                            <button class="btn btn-muted stop-timer" t-on-click.stop="_onClickUnlinkTimer" title="Press Esc to discard" t-att-disabled="otherCompany">Discard</button>
                        </div>
                        <div name="display_timer" class="ms-auto ms-lg-0 fs-4 fw-bold">
                            <TimesheetDisplayTimer t-if="props.timesheet" record="props.timesheet" name="'unit_amount'" timerRunning="true" displayRed="false" readonly="true" timerReactive="props.timerReactive"/>
                        </div>
                    </div>
                    <div t-if="otherCompany" class="input_m2o flex-fill p-md-2 px-0">
                        <span class="px-2">
                            A timer is running in another company.
                        </span>
                    </div>
                    <div t-elif="props.timesheet" class="input_m2o d-grid align-items-center ms-lg-3 mt-3 mt-lg-0 w-100 w-lg-75" t-on-keydown="_onKeyDown" t-attf-style="                             grid-template-rows: {{ env.isSmall ? 'repeat(3, 1fr)' : '1fr' }};                             grid-template-columns: {{ env.isSmall ? '1fr' : 'repeat(3, 1fr)' }};                             grid-{{ env.isSmall ? 'row' : 'column' }}-gap: 1rem;                         ">
                        <Field name="'name'" class="!props.timesheet.isInEdition and 'd-inline align-middle pt-1'" record="props.timesheet" fieldInfo="props.fields['name']" placeholder="props.fields['name'].placeholder"/>
                        <Field name="'project_id'" class="!props.timesheet.isInEdition ? 'd-inline align-middle pt-1 o_required_modifier' : 'o_required_modifier'" record="props.timesheet" canCreateEdit="false" fieldInfo="props.fields['project_id']" placeholder="props.fields['project_id'].placeholder" canQuickCreate="getIsProjectManager()"/>
                        <Field name="'task_id'" class="!props.timesheet.isInEdition and 'd-inline align-middle pt-1'" record="props.timesheet" canCreateEdit="false" fieldInfo="fieldsInfo.task_id" placeholder="props.fields['task_id'].placeholder"/>
                    </div>
                </div>
            </t>
            <t t-else="">
                <div class="position-md-sticky start-0 d-flex align-items-center">
                    <button class="btn_start_timer btn btn-primary text-uppercase" t-on-click.stop="_onClickStartTimer" t-ref="startButton">
                        <i class="fa fa-play me-2"/> Start
                    </button>
                    <div class="ms-3">
                        <t t-if="!isMobile">
                            <t t-if="viewType == 'grid'">
                                <div>
                                    <span class="text-muted">Press</span> <b>Enter</b> <span class="text-muted">or <b>[a]</b> to launch the timer</span>
                                </div>
                                <div>
                                    <span class="text-muted">Press</span> <b>Shift</b> <span class="text-muted">+ <b>[A]</b> to add <t t-esc="props.stepTimer"/> min</span>
                                </div>
                            </t>
                            <t t-else="">
                                <div>
                                    <span class="text-muted">Press</span> <b>Enter</b> <span class="text-muted">or click on</span> <i class="fa fa-play"/> <span class="text-muted">to launch the timer</span>
                                </div>
                                <div>
                                    <span class="text-muted">Press</span> <b>Shift</b> <span class="text-muted">and click on</span> <i class="fa fa-plus"/> <span class="text-muted">to add 15 min</span>
                                </div>
                            </t>
                        </t>
                    </div>
                </div>
            </t>
        </div>
    </t>

`);
registerTemplate("timesheet_grid.TimesheetUOMHourTimer", `/timesheet_grid/static/src/components/timesheet_uom_hour_timer/timesheet_uom_hour_timer.xml`, `<t t-name="timesheet_grid.TimesheetUOMHourTimer" xml:space="preserve">
        <button type="button" t-if="displayButton" t-on-click.stop.prevent="onClick" class="o_icon_button me-2 pt-0" t-att-title="title" t-att-aria-label="title">
            <i t-attf-class="fa {{iconClass}}" t-att-title="title"/>
        </button>
        <TimesheetDisplayTimer t-props="props"/>
    </t>

`);
registerTemplate("timesheet_grid.TimesheetTimerKanbanRenderer", `/timesheet_grid/static/src/views/timesheet_kanban/timesheet_timer_kanban_renderer.xml`, `<t t-name="timesheet_grid.TimesheetTimerKanbanRenderer" t-inherit="web.KanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_kanban_renderer')]" position="before">
            <div t-if="timesheetTimerRendererHook.showTimer" class="pinned_header position-sticky start-0 z-1 d-flex flex-wrap justify-content-end align-items-center bg-view border-bottom mb-1">
                <div class="flex-grow-1" t-key="timesheetTimerRendererHook.timerState.timesheetId">
                    <TimesheetTimerHeader timesheet="timesheetTimerRendererHook.timesheet" addTimeMode="timesheetTimerRendererHook.timerState.addTimeMode" stepTimer="timesheetTimerRendererHook.timerState.stepTimer" timerRunning="timesheetTimerRendererHook.timerState.timerRunning" otherCompany="timesheetTimerRendererHook.timerState.otherCompany" fields="timesheetTimerRendererHook.fields" onTimerStarted="() =&gt; this.timesheetTimerRendererHook._onTimerStarted()" onTimerStopped="() =&gt; this.timesheetTimerRendererHook._onTimerStopped()" onTimerUnlinked="() =&gt; this.timesheetTimerRendererHook._onTimerUnlinked()"/>
                </div>
            </div>
        </xpath>
    </t>

`);
registerTemplate("timesheet_grid.TimesheetValidationKanbanView.Buttons", `/timesheet_grid/static/src/views/timesheet_kanban/timesheet_validation_kanban_controller.xml`, `<t t-name="timesheet_grid.TimesheetValidationKanbanView.Buttons" t-inherit="web.KanbanView.Buttons" xml:space="preserve">
        <xpath expr="//div[hasclass('o_cp_buttons')]" position="inside">
            <button type="button" class="btn btn-secondary" t-on-click="validateTimesheet">
                Validate
            </button>
        </xpath>
    </t>

`);
registerTemplate("timesheet_grid.TimesheetTimerListController", `/timesheet_grid/static/src/views/timesheet_list/timesheet_timer_list_controller.xml`, `<t t-name="timesheet_grid.TimesheetTimerListController" t-inherit="web.ListView" xml:space="preserve">
        <xpath expr="//t[@t-component=&quot;props.Renderer&quot;]" position="attributes">
            <attribute name="timerState">timerState</attribute>
        </xpath>
    </t>

`);
registerTemplate("timesheet_grid.TimesheetTimerListRenderer", `/timesheet_grid/static/src/views/timesheet_list/timesheet_timer_list_renderer.xml`, `<t t-name="timesheet_grid.TimesheetTimerListRenderer" t-inherit="web.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_list_renderer')]" position="before">
            <div t-if="timesheetTimerRendererHook.showTimer" class="pinned_header d-flex flex-wrap justify-content-end align-items-center bg-view border-bottom">
                <div class="flex-grow-1" t-key="timesheetTimerRendererHook.timerState.timesheetId">
                    <TimesheetTimerHeader timesheet="timesheetTimerRendererHook.timesheet" addTimeMode="timesheetTimerRendererHook.timerState.addTimeMode" stepTimer="timesheetTimerRendererHook.timerState.stepTimer" timerRunning="timesheetTimerRendererHook.timerState.timerRunning" otherCompany="timesheetTimerRendererHook.timerState.otherCompany" fields="timesheetTimerRendererHook.fields" onTimerStarted="() =&gt; this.timesheetTimerRendererHook._onTimerStarted()" onTimerStopped="() =&gt; this.timesheetTimerRendererHook._onTimerStopped()" onTimerUnlinked="() =&gt; this.timesheetTimerRendererHook._onTimerUnlinked()" onClick="() =&gt; this.timesheetTimerRendererHook.onTimerHeaderClick()" className="'h-100'"/>
                </div>
            </div>
        </xpath>
    </t>

`);
registerTemplate("hr_expense.ExpenseDashboard", `/hr_expense/static/src/components/expense_dashboard.xml`, `<t t-name="hr_expense.ExpenseDashboard" xml:space="preserve">
        <div class="d-none d-md-flex o_expense_container position-sticky start-0 d-flex o_form_statusbar">
            <t t-foreach="Object.entries(state.expenses)" t-as="expense" t-key="expense[0]">
                <t t-set="name" t-value="expense[0]"/>
                <t t-set="data" t-value="expense[1]"/>
                <div t-attf-class="o_expense_card o_arrow_button flex-grow-1 d-flex flex-column p-3 border-bottom text-center cursor-pointer" t-att-data-tooltip="data['tooltip']" t-on-click="() =&gt; this.applyFilter(name)">
                    <span t-out="renderMonetaryField(data['amount'], data['currency'])" class="h2 m-0 text-primary"/>
                    <b class="mx-2" t-out="data['description']"/>
                </div>
                <div t-if="name !== 'approved'" t-attf-class="o_expense_card o_arrow_button flex-grow-1 d-flex flex-column p-3 border-bottom text-center">
                    <i class="fa fa-angle-right fa-3x"/>
                </div>
            </t>
            <div class="fa fa-question-circle-o flex-grow-0.5 d-flex flex-column p-3 border-bottom text-center" t-if="env.debug" data-tooltip="Numbers computed from your personal expenses."/>
        </div>
    </t>
`);
registerTemplate("hr_expense.AttachmentNumber", `/hr_expense/static/src/components/nb_attachment.xml`, `<t t-if="nb_attachment &gt; 0" t-name="hr_expense.AttachmentNumber" xml:space="preserve">
        <div>
            <span class="fa fa-paperclip pe-1 align-middle"/>
            <t class="text-center" t-out="nb_attachment"/>
        </div>
    </t>
`);
registerTemplate("hr_expense.QRModalComponent", `/hr_expense/static/src/components/qrcode_action.xml`, `<t t-name="hr_expense.QRModalComponent" xml:space="preserve">
        <div style="text-align:center;" class="o_expense_modal">
            <t t-if="url">
                <h3>Scan this QR code to get the Odoo app:</h3><br/><br/>
                <img class="border border-dark rounded" t-att-src="url"/>
            </t>
        </div>
    </t>
`);
registerTemplate("hr_expense.KanbanRenderer", `/hr_expense/static/src/views/kanban.xml`, `<t t-name="hr_expense.KanbanRenderer" t-inherit="web.KanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_kanban_renderer')]" position="attributes">
            <attribute name="class" add="position-relative h-auto" separator=" "/>
        </xpath>
        <xpath expr="//div[hasclass('o_kanban_renderer')]" position="before">
            <div t-if="dragState.showDragZone" class="o_dropzone">
                <i class="fa fa-upload fa-10x"/>
            </div>
        </xpath>
    </t>

    `);
registerTemplate("hr_expense.DashboardKanbanRenderer", `/hr_expense/static/src/views/kanban.xml`, `<t t-name="hr_expense.DashboardKanbanRenderer" t-inherit="hr_expense.KanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_kanban_renderer')]" position="before">
            <ExpenseDashboard/>
        </xpath>
    </t>

    `);
registerTemplate("hr_expense.KanbanButtons", `/hr_expense/static/src/views/kanban.xml`, `<t t-name="hr_expense.KanbanButtons" t-inherit="web.KanbanView.Buttons" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_cp_buttons')]" position="attributes">

            <attribute name="class" remove="d-flex" separator=" "/>
            <attribute name="class" add="d-block d-xl-flex" separator=" "/>
        </xpath>
        <xpath expr="//div[hasclass('o_cp_buttons')]" position="inside">
            <input type="file" name="ufile" class="d-none" t-ref="fileInput" multiple="1" accept="*" t-on-change="onChangeFileInput"/>

            <t t-if="canCreate and props.showButtons and env.isSmall and displayCreateReport()">
                <button type="button" class="btn btn-primary o-kanban-button-new" data-hotkey="c" t-on-click="() =&gt; this.createRecord()" data-bounce-button="">
                    New
                </button>
            </t>
            <button t-if="displayCreateReport()" class="btn btn-secondary" t-on-click="() =&gt; this.action_show_expenses_to_submit()">
                Create Report
            </button>
        </xpath>
    </t>

    `);
registerTemplate("hr_expense.KanbanView", `/hr_expense/static/src/views/kanban.xml`, `<t t-name="hr_expense.KanbanView" t-inherit="web.KanbanView" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//button[hasclass('o-kanban-button-new')]" position="before">
            <button t-if="!env.isSmall" type="button" class="o_button_upload_expense btn btn-primary" t-on-click.prevent="uploadDocument">
                Upload
            </button>
            <button t-if="env.isSmall" type="button" t-att-class="'o_button_upload_expense btn btn-primary' + (!displayCreateReport() ? ' me-1' : '')" t-on-click.prevent="uploadDocument">
                Scan
            </button>
        </xpath>


        <xpath expr="//button[hasclass('o-kanban-button-new')]" position="attributes">
            <attribute name="t-if">!env.isSmall or (env.isSmall and !displayCreateReport())</attribute>
        </xpath>

        <xpath expr="//t[@t-component='props.Renderer']" position="attributes">
            <attribute name="uploadDocument.bind">uploadDocument</attribute>
        </xpath>
    </t>
`);
registerTemplate("hr_expense.ListButtons", `/hr_expense/static/src/views/list.xml`, `<t t-name="hr_expense.ListButtons" t-inherit="web.ListView.Buttons" t-inherit-mode="primary" xml:space="preserve">


        <xpath expr="//div[hasclass('o_list_buttons')]" position="attributes">

            <attribute name="class" remove="d-flex" separator=" "/>
            <attribute name="class" add="d-block d-xl-flex" separator=" "/>
        </xpath>
        <xpath expr="//div[hasclass('o_list_buttons')]" position="inside">
            <input type="file" name="ufile" class="d-none" t-ref="fileInput" multiple="1" accept="*" t-on-change="onChangeFileInput"/>

            <t t-if="!model.root.editedRecord and activeActions.create and props.showButtons and env.isSmall and displayCreateReport()">
                <button type="button" class="btn btn-primary o_list_button_add" data-hotkey="c" t-on-click="onClickCreate" data-bounce-button="">
                    New
                </button>
            </t>
            <button t-if="displayCreateReport()" class="btn btn-secondary" t-on-click="() =&gt; this.action_show_expenses_to_submit()">
                Create Report
            </button>
            <button t-if="displaySubmit()" class="d-none d-md-block btn btn-secondary" t-on-click="() =&gt; this.onClick('action_submit_sheet')">
                Submit
            </button>
            <button t-if="displayApprove()" class="d-none d-md-block btn btn-secondary" t-on-click="() =&gt; this.onClick('action_approve_expense_sheets')">
                Approve Report
            </button>
            <button t-if="displayPost()" class="d-none d-md-block btn btn-secondary" t-on-click="() =&gt; this.onClick('action_sheet_move_post')">
                Post Entries
            </button>
            <button t-if="displayPayment()" class="d-none d-md-block btn btn-secondary" t-on-click="() =&gt; this.onClick('action_register_payment')">
                Pay
            </button>
        </xpath>
    </t>

    `);
registerTemplate("hr_expense.ListView", `/hr_expense/static/src/views/list.xml`, `<t t-name="hr_expense.ListView" t-inherit="web.ListView" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//button[hasclass('o_list_button_add')]" position="before">
            <button t-if="!isExpenseSheet and !env.isSmall" type="button" class="o_button_upload_expense btn btn-primary" t-on-click.prevent="uploadDocument">
                Upload
            </button>
            <button t-if="!isExpenseSheet and env.isSmall" type="button" t-att-class="'o_button_upload_expense btn btn-primary' + (!displayCreateReport() ? ' me-1' : '')" t-on-click.prevent="uploadDocument">
                Scan
            </button>
        </xpath>


        <xpath expr="//button[hasclass('o_list_button_add')]" position="attributes">
            <attribute name="t-if">!env.isSmall or (env.isSmall and !displayCreateReport())</attribute>
        </xpath>

        <xpath expr="//t[@t-component='props.Renderer']" position="attributes">
            <attribute name="uploadDocument.bind">uploadDocument</attribute>
        </xpath>
    </t>

    `);
registerTemplate("hr_expense.ListRenderer", `/hr_expense/static/src/views/list.xml`, `<t t-name="hr_expense.ListRenderer" t-inherit="web.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_list_renderer')]" position="before">
            <div t-if="dragState.showDragZone" class="o_dropzone">
                <i class="fa fa-upload fa-10x"/>
            </div>
        </xpath>
        <xpath expr="//div[hasclass('o_list_renderer')]" position="attributes">
            <attribute name="class">o_list_renderer hr_expense h-auto o_forbidden_tooltip_parent</attribute>
        </xpath>
    </t>


    `);
registerTemplate("hr_expense.DashboardListRenderer", `/hr_expense/static/src/views/list.xml`, `<t t-name="hr_expense.DashboardListRenderer" t-inherit="hr_expense.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_list_renderer')]" position="before">
            <ExpenseDashboard/>
        </xpath>
    </t>
`);
registerTemplate("iap.ActionButtonsWidget", `/iap/static/src/action_buttons_widget/action_buttons_widget.xml`, `<t t-name="iap.ActionButtonsWidget" xml:space="preserve">
        <div class="row">
            <div class="col-sm">
                <button t-on-click="onManageServiceLinkClicked" class="btn btn-link px-0 o-hidden-ios text-nowrap"><i class="oi oi-arrow-right"/> Manage Service &amp; Buy Credits</button><br/>
                <button t-if="props.showServiceButtons" t-on-click="onViewServicesClicked" class="btn btn-link px-0 o-hidden-ios text-nowrap"><i class="oi oi-arrow-right"/> View My Services</button>
            </div>
        </div>
    </t>

`);
registerTemplate("iap.InsufficientCreditDialog", `/iap/static/src/xml/iap_templates.xml`, `<t t-name="iap.InsufficientCreditDialog" xml:space="preserve">
        <Dialog>
            <div t-att-style="style">
                <t t-if="props.errorData.body">
                    <div t-raw="props.errorData.body"/>
                </t>
                <t t-if="!props.errorData.body">
                    <t t-if="props.errorData.message">
                        <span t-esc="props.errorData.message"/>
                    </t>
                    <t t-if="!props.errorData.message">
                        <span>Insufficient credit to perform this service.</span>
                    </t>
                </t>
                <t t-set-slot="footer">
                    <button class="btn btn-primary" t-on-click="buyCredits" t-esc="buttonMessage"/>
                    <button class="btn" t-on-click="close">Cancel</button>
                </t>
            </div>
        </Dialog>
    </t>
`);
registerTemplateExtension("web.PhoneField", `/sms/static/src/components/phone_field/phone_field.xml`, `<t t-inherit="web.PhoneField" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('o_phone_content')]//a" position="after">
            <t t-if="props.enableButton and props.record.data[props.name].length &gt; 0">
                <SendSMSButton t-props="props"/>
            </t>
        </xpath>
    </t>

    `);
registerTemplateExtension("web.FormPhoneField", `/sms/static/src/components/phone_field/phone_field.xml`, `<t t-inherit="web.FormPhoneField" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('o_phone_content')]" position="inside">
            <t t-if="props.enableButton and props.record.data[props.name].length &gt; 0">
                <SendSMSButton t-props="props"/>
            </t>
        </xpath>
    </t>

`);
registerTemplate("sms.SendSMSButton", `/sms/static/src/components/sms_button/sms_button.xml`, `<t t-name="sms.SendSMSButton" xml:space="preserve">
        <a t-att-title="title" t-att-href="phoneHref" t-on-click.prevent.stop="onClick" class="ms-3 d-inline-flex align-items-center o_field_phone_sms"><i class="fa fa-mobile"/><small class="fw-bold ms-1">SMS</small></a>
    </t>

`);
registerTemplate("sms.SmsWidget", `/sms/static/src/components/sms_widget/fields_sms_widget.xml`, `<t t-name="sms.SmsWidget" t-inherit="mail.EmojisTextField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="/*[last()]/*[last()]" position="after">
            <div class="o_sms_container">
                <span class="text-muted o_sms_count">
                    <t t-out="nbrChar"/> characters<t t-out="nbrCharExplanation"/>, fits in <t t-out="nbrSMS"/> SMS (<t t-out="encoding"/>)
                    <a href="https://iap-services.odoo.com/iap/sms/pricing" target="_blank" title="SMS Pricing" aria-label="SMS Pricing" class="fa fa-lg fa-info-circle"/>
                </span>
            </div>
        </xpath>
    </t>
`);
registerTemplate("base_automation.ActionsOne2ManyField", `/base_automation/static/src/base_automation_actions_one2many_field.xml`, `<t t-name="base_automation.ActionsOne2ManyField" xml:space="preserve">
        <div class="d-flex align-items-center" t-ref="root">
            <t t-if="currentActions.length === 0">
                <span class="text-muted">no action defined...</span>
            </t>
            <t t-foreach="currentActions" t-as="action" t-key="action.id">
                <div style="min-width: fit-content;" t-att-data-action-id="action.id">
                    <div class="fs-5 d-flex align-items-center">
                        <i data-name="server_action_icon" t-att-title="getActionType(action)" class="fa" t-att-class="{                                 'code': 'fa-file-code-o',                                 'object_create': 'fa-edit',                                 'object_write': 'fa-refresh',                                 'multi': 'fa-list-ul',                                 'mail_post': 'fa-envelope',                                 'followers': 'fa-user-o',                                 'remove_followers': 'fa-user-times',                                 'next_activity': 'fa-clock-o',                                 'sms': 'fa-comments-o',                             }[action.data.state]"/>
                        <div class="ps-2" t-esc="action.data.name"/>
                    </div>
                </div>
                <div t-if="!action_last" class="px-3 align-self-center" t-att-data-action-id="action.id">
                    <i class="fa fa-lg fa-plus text-primary"/>
                </div>
            </t>
            <t t-if="hiddenActionsCount">
                <div class="fs-3 align-self-center text-muted">
                    <t t-out="moreText"/>
                </div>
            </t>
        </div>
    </t>
`);
registerTemplate("base_automation.ErrorDialog", `/base_automation/static/src/base_automation_error_dialog.xml`, `<t t-name="base_automation.ErrorDialog" t-inherit="web.ErrorDialog" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[@role='alert']" position="attributes">
            <attribute name="class" add="o_base_automation_error" separator=" "/>
        </xpath>
        <xpath expr="//div[@role='alert']" position="inside">
            <p class="mt-2">
                The error occurred during the execution of the automation rule
                "<t t-esc="automationName"/>"
                (ID: <t t-esc="automationId"/>).
                <br/>
            </p>
            <p t-if="isUserAdmin">
                You can disable this automation rule or edit it to solve the issue.<br/>
                Disabling this automation rule will enable you to continue your workflow
                but any data created after this could potentially be corrupted,
                as you are effectively disabling a customization that may set
                important and/or required fields.
            </p>
            <p t-else="">
                You can ask an administrator to disable or correct this automation rule.
            </p>
        </xpath>
        <xpath expr="//div[@role='alert']//button" position="after">
            <t t-if="isUserAdmin">
                <button class="btn btn-secondary mt4 o_disable_action_button me-3" t-on-click.prevent="disableAutomation">
                    <i class="fa fa-ban mr8"/>Disable Automation Rule
                </button>
                <button class="btn btn-secondary mt4 o_edit_action_button" t-on-click.prevent="editAutomation">
                    <i class="fa fa-edit mr8"/>Edit Automation Rule
                </button>
            </t>
        </xpath>
    </t>
`);
registerTemplate("base_automation.TriggerSelectionField", `/base_automation/static/src/base_automation_trigger_selection_field.xml`, `<t t-name="base_automation.TriggerSelectionField" t-inherit="web.SelectionField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-foreach='options']" position="replace">
            <t t-foreach="groupedOptions" t-as="group" t-key="group.key">
                <optgroup t-att-label="group.name">
                    <t t-foreach="group.options" t-as="option" t-key="option.value">
                        <option t-att-selected="option.value === value" t-att-value="stringify(option.value)" t-esc="option.label"/>
                    </t>
                </optgroup>
            </t>
        </xpath>
    </t>
`);
registerTemplate("web_studio.FontAwesomeIconSelector", `/web_studio/static/src/client_action/components/font_awesome_icon_selector/font_awesome_icon_selector.xml`, `<t t-name="web_studio.FontAwesomeIconSelector" xml:space="preserve">
    <SelectMenu autoSort="false" class="'o_font_awesome_icon_selector overflow-visible p-0 border-0 ' + this.props.className" menuClass="'o_font_awesome_icon_selector_menu ' + props.menuClassName" togglerClass="'p-0'" value="this.props.value" choices="iconChoices" onSelect="this.props.onSelect" required="true">
        <t t-slot="default"/>
        <t t-set-slot="choice" t-slot-scope="choice">
            <i t-att-class="'o_font_awesome_icon_selector_value d-inline-flex justify-content-center align-items-center fs-3 ' + choice.data.value" t-att-data-tooltip="getIconTooltip(choice.data.value)"/>
        </t>
    </SelectMenu>
</t>

`);
registerTemplate("web_studio.SidebarDraggableItem", `/web_studio/static/src/client_action/components/sidebar_draggable_item/sidebar_draggable_item.xml`, `<t t-name="web_studio.SidebarDraggableItem" xml:space="preserve">
    <div t-attf-class="o_web_studio_component o_web_studio_icon_container o-draggable bg-light position-relative mb-1 py-1 rounded-1 shadow fw-bolder text-nowrap overflow-hidden text-truncate {{ props.className }}" t-att-data-structure="props.structure" t-att-data-hook="props.structure.hook" t-att-data-drop="props.dropData">
        <t t-esc="props.string"/>
        <div t-if="props.description and env.debug" class="o_web_studio_component_description border border-dark p-1 font-monospace lh-1 fw-bolder text-nowrap overflow-hidden text-truncate" t-esc="props.description"/>
    </div>
</t>

`);
registerTemplate("web_studio.ThumbnailItem", `/web_studio/static/src/client_action/components/thumbnail_item/thumbnail_item.xml`, `<t t-name="web_studio.ThumbnailItem" xml:space="preserve">
    <div t-attf-class="o_web_studio_thumbnail_item shadow position-relative d-flex flex-column justify-content-center align-items-center bg-light border rounded-2 {{ this.props.className || '' }}" t-on-click="this.props.onClick">
        <div class="o_web_studio_thumbnail w-100 cursor-pointer d-flex justify-content-center align-items-center">
            <img class="m-auto" t-att-src="this.props.icon.src" t-att-alt="this.props.icon.alt"/>
        </div>
        <div class="o_web_studio_name d-flex w-100 gap-1 text-capitalize fw-bold text-black" t-att-class="hasDropdown ? 'justify-content-between ps-2' : 'justify-content-center'">
            <span class="d-block align-self-center fw-bold text-wrap text-break">
                <t t-slot="default"/>
            </span>
            <t t-if="hasDropdown">
                <Dropdown>
                    <button class="o_web_studio_more cursor-pointer p-0 rounded border-0 bg-light">
                        <i class="fa fa-ellipsis-v"/>
                    </button>
                    <t t-set-slot="content">
                        <t t-slot="dropdown"/>
                    </t>
                </Dropdown>
            </t>
        </div>
    </div>
</t>

`);
registerTemplate("StudioApprovalInfos", `/web_studio/static/src/approval/approval_infos.xml`, `<t t-name="StudioApprovalInfos" xml:space="preserve">
    <div class="o-approval-popover" t-if="props.isPopover">
        <div class="o-approval-popover--header d-flex align-items-center justify-content-between">
            <span>Approval</span>
            <button class="ms-2 btn btn-custom p-0" title="Open kanban view of approvals" t-on-click="openKanbanApprovalRules">
                <i class="oi oi-view-kanban"/>
            </button>
        </div>
        <t t-call="StudioApprovalInfos.contents"/>
    </div>
    <t t-else="">
        <Dialog title.translate="Approval" contentClass="'o-approval-dialog'">
            <h3 t-if="approval.action or approval.method">
                <strong>Action to approve:</strong> <t t-esc="approval.method ? 'method' : ''"/> <t t-esc="approval.action or approval.method"/>
            </h3>
            <t t-call="StudioApprovalInfos.contents"/>
            <t t-set-slot="footer" t-slot-scope="dialog">
                <button class="btn btn-secondary" t-on-click="() =&gt; dialog.close()">
                    <t>Close</t>
                </button>
            </t>
        </Dialog>
    </t>
</t>

`);
registerTemplate("StudioApprovalInfos.contents", `/web_studio/static/src/approval/approval_infos.xml`, `<t t-name="StudioApprovalInfos.contents" xml:space="preserve">
    <div class="o_web_studio_approval_info" t-att-data-mobile="env.isSmall">
        <t t-if="state.rules === null">
            <i class="fa fa-circle-o-notch fa-spin"/>
        </t>
        <div t-else="" t-foreach="state.rules" t-as="ruleId" t-key="ruleId" class="o_web_studio_approval_rule m-2 mb-3">
            <t t-set="rule" t-value="this.props.approval.rules[ruleId]"/>
            <t t-set="entry" t-value="getEntry(rule.id)"/>
            <div t-if="!getEntry(rule.id)" t-attf-class="o_web_studio_approval_no_entry d-flex flex-row align-items-center justify-content-center gap-2">
                <div class="o_web_studio_approval_avatar">
                    <img src="/web/static/img/user_menu_avatar.png" class="o_web_studio_approval_avatar rounded-circle border border-muted"/>
                </div>
                <div class="o_web_studio_approval_description flex-grow-1">
                    <t t-if="rule.message" t-esc="rule.message"/>
                    <t t-else="">Awaiting approval</t>
                </div>
                <t t-if="rule.can_validate">
                    <div class="o_web_studio_approval_button">
                        <button class="btn btn-primary btn-sm btn-block o_web_approval_approve" title="Approve" t-on-click="() =&gt; this.setApproval(rule.id, true)" t-att-disabled="state.syncing || !approval.resId || approval.inStudio">
                            <i class="fa fa-fw fa-check"/>
                        </button>
                    </div>
                    <div class="o_web_studio_approval_button">
                        <button class="btn btn-danger btn-sm btn-block o_web_approval_reject" title="Reject" t-on-click="() =&gt; this.setApproval(rule.id, false)" t-att-disabled="state.syncing || !approval.resId || approval.inStudio">
                            <i class="fa fa-fw fa-times"/>
                        </button>
                    </div>
                </t>
            </div>
            <div t-else="" t-attf-class="o_web_studio_approval_has_entry o_approval_{{getEntry(rule.id).approved?'success':'danger'}} d-flex flex-row align-items-center justify-content-center gap-2">
                <div class="o_web_studio_approval_avatar">
                    <img t-attf-src="/web/image/res.users/{{getEntry(rule.id).user_id[0]}}/avatar_128" t-attf-class="o_web_studio_approval_avatar rounded-circle border border-{{getEntry(rule.id).approved?'info':'danger'}}" t-att-title="getEntry(rule.id).user_id[1]"/>
                </div>
                <div class="o_web_studio_approval_description flex-grow-1" t-att-title="formatDate(getEntry(rule.id).write_date, 'DDDD')">
                    <p class="mb-0">
                        <strong t-esc="getEntry(rule.id).user_id[1]"/> <i t-if="rule.exclusive_user" class="fa fa-shield" title="This rule limits this user to a single approval for this action."/>
                        <br/>
                        <span class="small">
                            <t t-if="getEntry(rule.id).approved">Approved on </t>
                            <t t-else="">Rejected on </t>
                            <span t-esc="formatDate(getEntry(rule.id).write_date, 'DD')"/>
                        </span>
                    </p>
                </div>
                <t t-if="canRevokeEntry(ruleId)">
                    <div class="o_web_studio_approval_button">
                        <button class="btn btn-secondary btn-sm btn-block o_web_approval_cancel" title="Revoke" t-on-click="(ev) =&gt; this.cancelApproval(rule.id)" t-att-disabled="state.syncing || approval.inStudio">
                            <i class="fa fa-fw fa-undo"/>
                        </button>
                    </div>
                </t>
            </div>
        </div>
    </div>
</t>

`);
registerTemplate("StudioApproval", `/web_studio/static/src/approval/studio_approval.xml`, `<t t-name="StudioApproval" xml:space="preserve">
    <div class="o_web_studio_approval d-inline ms-2" t-on-click.stop="toggleApprovalInfo" t-ref="root">

        <t t-if="state.rules === null">
            <i class="fa fa-circle-o-notch fa-spin"/>
        </t>
        <t t-else="state.rules.length">

            <t t-set="num_rules" t-value="state.rules.length"/>
            <t t-foreach="state.rules" t-as="ruleId" t-key="ruleId">
                <t t-set="rule" t-value="this.props.approval.rules[ruleId]"/>
                <t t-if="num_rules lte 3 || (num_rules gt 3 and ruleId_index lt 2)">
                    <img t-if="getEntry(rule.id)" t-key="rule.id" t-attf-src="/web/image/res.users/{{getEntry(rule.id).user_id[0]}}/avatar_128" t-att-title="getEntry(rule.id).user_id[1]" t-att-alt="getEntry(rule.id).user_id[1]" t-attf-class="o_web_studio_approval_avatar rounded-circle border border-{{getEntry(rule.id).approved?'info':'danger'}}"/>
                    <img t-else="" t-key="rule.id" src="/web/static/img/user_menu_avatar.png" title="Waiting for approval" alt="User avatar placeholder" class="o_web_studio_approval_avatar rounded-circle border border-muted"/>
                </t>
                <t t-if="rule_last and num_rules gt 3">
                    <t t-set="extra_rules" t-value="num_rules - 2"/>
                    <span t-key="'extra_rules'" class="o_web_studio_approval_more rounded-circle bg-secondary" title="Click to see all approval rules.">
                        +<t t-esc="extra_rules"/>
                    </span>
                </t>
            </t>
            <t t-if="env.isSmall">
                <span class="o_web_studio_approval_more rounded-circle bg-primary">
                    <i class="fa fa-info"/>
                </span>
            </t>
        </t>
    </div>
</t>

`);
registerTemplateExtension("web.views.ViewButton", `/web_studio/static/src/approval/view_button_approval.xml`, `<t t-inherit="web.views.ViewButton" t-inherit-mode="extension" xml:space="preserve">
		<xpath expr="./t[@t-tag='props.tag']" position="attributes">
			<attribute name="t-attf-studio_approval">{{ approval ? true : undefined }}</attribute>
		</xpath>
		<xpath expr="//t[@t-slot='contents']" position="after">
			<StudioApproval t-if="approval" approval="approval"/>
		</xpath>
	</t>
`);
registerTemplate("web_studio.ActionEditor", `/web_studio/static/src/client_action/action_editor/action_editor.xml`, `<t t-name="web_studio.ActionEditor" xml:space="preserve">
  <div class="o_web_studio_action_editor d-flex flex-row justify-content-center h-100 w-100 overflow-auto">
      <t t-call="web_studio.ActionEditor.Sidebar"/>
      <t t-call="web_studio.ActionEditor.ViewsDashboard"/>
  </div>
</t>

`);
registerTemplate("web_studio.ActionEditor.Sidebar", `/web_studio/static/src/client_action/action_editor/action_editor.xml`, `<t t-name="web_studio.ActionEditor.Sidebar" xml:space="preserve">
  <div class="o_web_studio_sidebar flex-grow-0 flex-shrink-0 overflow-auto h-100">
      <div class="o_web_studio_sidebar_content d-flex flex-column gap-3 mt-3">
        <Record t-props="actionRecordProps" t-slot-scope="data">
          <t t-set="record" t-value="data.record"/>
          <div class="w-100">
            <label for="name" class="mb-1">Action's title</label>
            <CharField name="'name'" record="record" id="'name'"/>
          </div>
          <div class="w-100">
            <label for="help" class="mb-1">Empty List Message</label>
            <div class="o_web_studio_field_code">
              <TextField name="'help'" record="record" id="'help'"/>
            </div>
          </div>
          <div class="w-100">
            <label for="groups_id" class="mb-1">Limit visibility to groups</label>
            <div class="o_field_widget o_field_many2many_tags" name="groups_id">
              <Many2ManyTagsField id="'groups_id'" name="'groups_id'" record="record"/>
            </div>
          </div>
        </Record>
        <div t-if="env.debug" class="o_web_studio_sidebar_toolbox w-100">
          <button class="btn btn-secondary btn-lg o_web_studio_parameters" t-on-click="openFormAction"><i class="fa fa-cog me-1"/>More</button>
        </div>
      </div>
    </div>
</t>

`);
registerTemplate("web_studio.ActionEditor.ViewsDashboard", `/web_studio/static/src/client_action/action_editor/action_editor.xml`, `<t t-name="web_studio.ActionEditor.ViewsDashboard" xml:space="preserve">
  <div class="o_web_studio_views d-flex overflow-auto gap-3 p-5">
    <div class="grid w-75 justify-content-center" style="grid-template-columns: repeat(auto-fit, minmax(400px, 35%)); gap: 40px;">
      <t t-foreach="viewCategories" t-as="category" t-key="category">
        <div class="o_web_studio_view_category" t-att-name="category">
            <h6 class="mb-3 fw-bolder" t-esc="category_value.title"/>
            <div class="grid" style="grid-template-columns: repeat(3, 115px); gap: 20px;">
              <t t-foreach="getOrderedViewTypes(category_value.viewTypes)" t-as="viewInfo" t-key="viewInfo.name">
                <ThumbnailItem onClick="() =&gt; this.onThumbnailClicked(viewInfo.name)" icon="{src: viewInfo.imgUrl, alt:'View ' + viewInfo.title }" showMoreMenu="viewInfo.isActive and (viewInfo.canBeDefault or viewInfo.canBeDisabled)" className="\`o_web_studio_thumbnail_\${viewInfo.name} overflow-hidden \${viewInfo.isActive ? '' : 'disabled'}\`">
                  <t t-set-slot="default">
                    <t t-out="viewInfo.title"/>
                    <span t-if="viewInfo.isDefault" class="o_web_studio_default_view fa-stack fa-sm position-absolute top-0 end-0 text-primary m-1" role="img" aria-label="Default view" title="Default view">
                        <i class="fa fa-circle fa-stack-2x"/>
                        <i class="fa fa-home fa-stack-1x text-white"/>
                    </span>
                    <span t-if="!viewInfo.isActive" class="o_web_studio_view_label bg-black text-white bg-opacity-50 rounded-start position-absolute top-0 start-100 my-1 py-1 px-2 fw-normal text-nowrap">Activate View</span>
                  </t>
                  <t t-set-slot="dropdown">
                    <DropdownItem t-if="viewInfo.canBeDefault" onSelected="() =&gt; this.setDefaultView(viewInfo.name)" attrs="{ href: '#', 'data-action': 'set_default_view' }" class="viewInfo.isDefault ? 'pe-none opacity-50' : ''">
                      <i t-if="viewInfo.isDefault" class="fa fa-check" role="img" aria-label="Is default view" title="Is default view"/>
                      Set As Default
                    </DropdownItem>
                    <div t-if="viewInfo.canBeDefault and viewInfo.canBeDisabled" class="dropdown-divider" role="separator"/>
                    <DropdownItem t-if="env.debug" onSelected="() =&gt; this.restoreDefaultView(viewInfo.name)" attrs="{ href: '#', 'data-action': 'restore_default_view' }">
                      Restore Default View
                    </DropdownItem>
                    <DropdownItem t-if="viewInfo.canBeDisabled" onSelected="() =&gt; this.disableView(viewInfo.name)" attrs="{ 'data-action': 'disable_view' }">
                      Disable View
                    </DropdownItem>
                  </t>
                </ThumbnailItem>
              </t>
            </div>
        </div>
      </t>
    </div>
  </div>
</t>

`);
registerTemplate("web_studio.AppCreator", `/web_studio/static/src/client_action/app_creator/app_creator.xml`, `<t t-name="web_studio.AppCreator" xml:space="preserve">
    <div class="o_web_studio_app_creator h-100 overflow-auto py-5">
        <div t-if="state.step !== 'model_configuration'" class="o_web_studio_app_creator_box d-flex m-auto mt-5">
            <div class="o_web_studio_app_creator_left bg-light h-100 w-50 d-flex flex-column flex-nowrap rounded-start p-3">
                <div class="o_web_studio_app_creator_left_content flex-grow-1 pt-3">
                    <t t-if="state.step === 'welcome'">
                        <h2 class="mb0 o_web_studio_welcome fw-light mt-5">Welcome to</h2>
                        <h1 class="mt-1 mb-3">Odoo Studio</h1>
                        <h5 class="text-muted fs-6">The fastest way to create a web application.</h5>
                    </t>
                    <t t-elif="state.step === 'app'">
                        <h3 class="mb32">Create your App</h3>
                        <div class="o_web_studio_app_creator_name" t-att-class="{ o_web_studio_field_warning: !state.isFieldValid('appName') }">
                            <label for="appName">Choose an app name</label>
                            <input type="text" class="o_input" name="appName" placeholder="e.g. Real Estate" t-model="state.data.appName" t-ref="autofocus"/>
                        </div>
                    </t>
                    <t t-elif="state.step === 'model'">
                        <h3 class="w-100 mb-5">Create your first menu</h3>
                        <MenuCreator showValidation="state.showValidation" menuCreatorModel="state.menuCreatorModel"/>
                    </t>
                </div>
                <div class="o_web_studio_app_creator_buttons">
                    <button t-if="state.hasPrevious" type="button" class="o_web_studio_app_creator_previous btn text-uppercase px-3 py-1 border text-muted" aria-label="Previous" title="Previous" t-on-click="() =&gt; this.state.previous()">
                        <i class="oi oi-chevron-left"/>
                    </button>
                    <t t-set="nextStep" t-value="state.nextStep"/>
                    <button type="button" t-attf-class="o_web_studio_app_creator_next btn text-uppercase px-3 py-1 float-end {{ nextStep === false ? 'opacity-25' : 'is_ready btn-primary' }}" aria-label="Next" title="Next" t-on-click="() =&gt; this.state.next()">
                        <span class="pe-2" t-if="nextStep !== false">
                            <t t-if="nextStep">Next</t>
                            <t t-else="">Create your app</t>
                        </span>
                        <i class="oi oi-chevron-right"/>
                    </button>
                </div>
            </div>
            <div class="o_web_studio_app_creator_right h-100 w-50 d-flex justify-content-center align-items-center rounded-end" t-if="state.step !== 'model_configuration'">
                <div class="o_web_studio_app_creator_right_content">
                    <t t-if="state.step === 'welcome'">
                        <img class="o_web_studio_welcome_image rounded-3 shadow" src="/web_studio/static/src/img/studio_app_icon.png"/>
                    </t>
                    <IconCreator t-else="" t-props="state.data.iconData" editable="state.step === 'app'" onIconChange.bind="(iconData) =&gt; this.state.data.iconData = iconData"/>
                </div>
            </div>
        </div>
        <div t-if="state.step === 'model_configuration'" class="o_web_studio_model_configurator container bg-light p-0 rounded">
            <header class="p-3 border rounded-2">
                <h4 class="modal-title text-break">Suggested features for your new model</h4>
            </header>
            <ModelConfigurator label.translate="Create your app" onConfirmOptions.bind="onConfirmOptions" onPrevious="() =&gt; this.state.previous()"/>
        </div>
    </div>
</t>

`);
registerTemplate("web_studio.AppMenuEditor", `/web_studio/static/src/client_action/editor/app_menu_editor/app_menu_editor.xml`, `<t t-name="web_studio.AppMenuEditor" xml:space="preserve">
        <a t-if="menus.getCurrentApp()" href="#" class="o_web_edit_menu o_nav_entry" role="button" t-on-click="onClick">
            <i class="fa fa-fw fa-pencil"/>Edit Menu
        </a>
    </t>

    `);
registerTemplate("web_studio.AppMenuEditor.EditMenuDialog", `/web_studio/static/src/client_action/editor/app_menu_editor/app_menu_editor.xml`, `<t t-name="web_studio.AppMenuEditor.EditMenuDialog" xml:space="preserve">
        <Dialog title.translate="Edit Menu" contentClass="'o-web-studio-appmenu-editor'" size="'md'">
            <div t-ref="root" class="d-flex flex-column gap-3">
                <t t-set="item" t-value="mainItem"/>
                <div t-if="item" class="w-100">
                    <ul class="oe_menu_editor list-unstyled mb-0" t-att-data-item-id="item.id" t-key="state.renderId" t-att-id="item.id">
                        <t t-call="web_studio.InteractiveItemsList.Item"/>
                    </ul>
                </div>
                <div class="o_web_studio_edit_menu_desc small align-self-end">
                    <i class="fa fa-info-circle me-1"/>Drag a menu to the right to create a sub-menu
                </div>
            </div>

            <t t-set-slot="footer" t-slot-scope="dialog">
                <button type="button" class="btn btn-primary" t-on-click="confirm">Confirm</button>

                <button type="button" class="btn btn-secondary" t-on-click="cancel">Cancel</button>

                <button type="button" class="btn btn-secondary js_add_menu ms-auto" t-on-click="onNewMenu">
                    <i class="fa fa-fw o_button_icon fa-plus-circle"/>
                    New Menu
                </button>
            </t>
        </Dialog>
    </t>

    `);
registerTemplate("web_studio.InteractiveItemsList.Item", `/web_studio/static/src/client_action/editor/app_menu_editor/app_menu_editor.xml`, `<t t-name="web_studio.InteractiveItemsList.Item" xml:space="preserve">
        <li t-att-data-sequence="itemSequence" t-attf-class="{{ item.isDraggable ? 'o-draggable': '' }}" t-att-data-item-id="item.id" t-att-id="item.id">
            <div class="input-group mb-1">
                <span class="input-group-text fa fa-bars bg-view" role="img" aria-label="Value of list" title="Value of list" t-attf-class="{{ item.isDraggable ? 'o-draggable-handle' : '' }}" t-attf-style="{{ item.isDraggable ? 'cursor: move;' : '' }}"/>
                <span class="form-control o-web-studio-interactive-list-item-label" t-esc="item.name"/>

                <button type="button" class="btn btn-secondary fa fa-pencil-square-o o-web-studio-interactive-list-edit-item" aria-label="Edit selection" data-tooltip="Edit selection" t-on-click="() =&gt; this.editItem(item)"/>

                <button type="button" t-att-class="{ disabled: !item.isRemovable }" class="btn btn-secondary fa fa-trash-o o-web-studio-interactive-list-remove-item" aria-label="Remove selection" data-tooltip="Remove selection" t-on-click="() =&gt; this.removeItem(item)"/>
            </div>
            <ul class="p-0 ms-5" t-if="item.children">
                <t t-foreach="item.children" t-as="item" t-key="item.id">
                    <t t-call="web_studio.InteractiveItemsList.Item"/>
                </t>
            </ul>
        </li>
    </t>
`);
registerTemplate("web_studio.Editor", `/web_studio/static/src/client_action/editor/editor.xml`, `<t t-name="web_studio.Editor" xml:space="preserve">
    <div t-on-studio-edit-view="switchViewLegacy" class="o_web_studio_editor">
        <EditorMenu switchView.bind="switchView" switchTab.bind="switchTab"/>
        <StudioActionContainer reloadId="state.actionContainerId"/>
    </div>
</t>

`);
registerTemplate("web_studio.EditorMenu", `/web_studio/static/src/client_action/editor/editor_menu/editor_menu.xml`, `<t t-name="web_studio.EditorMenu" xml:space="preserve">
    <div class="o_web_studio_menu d-flex flex-row pe-3">
        <Breadcrumbs currentTab="currentTab" switchTab="props.switchTab"/>

        <t t-if="editionFlow.MenuItem" t-component="editionFlow.MenuItem.component" t-props="editionFlow.MenuItem.props"/>

        <div class="ms-auto d-flex flex-row gap-0">
            <ul class="o_menu_sections d-flex flex-row list-unstyled align-items-center gap-0 mb-0 pe-1">
                <li t-foreach="editorTabs" t-as="tab" t-key="tab.id" class="h-100 d-table px-2" role="button" t-on-click.prevent="() =&gt; this.openTab(tab.id)">
                    <a class="d-table-cell align-middle" href="#" t-esc="tab.name"/>
                </li>
            </ul>

            <div class="o_web_studio_views_icons d-flex flex-row gap-2 align-items-center border-start border-dark border-2 ps-2">
                <a href="#" t-foreach="activeViews" t-as="view" t-key="view.type" t-att-data-tooltip="view.title" t-att-aria-label="view.title" t-att-title="view.title" t-on-click.prevent="() =&gt; { this.props.switchView({viewType: view.type}); }">
                    <i t-att-class="view.iconClasses"/>
                </a>
            </div>
        </div>
    </div>
</t>

`);
registerTemplate("web_studio.EditorMenu.Breadcrumbs", `/web_studio/static/src/client_action/editor/editor_menu/editor_menu.xml`, `<t t-name="web_studio.EditorMenu.Breadcrumbs" xml:space="preserve">
    <div class="o_web_studio_breadcrumb ">
        <ol class="breadcrumb align-items-center">
            <li t-foreach="breadcrumbs" t-as="crumb" t-key="crumb.id" t-on-click="crumb.handler" class="breadcrumb-item cursor-pointer" t-att-class="{active: crumb_last, o_back_button: !crumb_last}" t-esc="crumb.data.name"/>
        </ol>
    </div>
</t>

`);
registerTemplate("web_studio.NewModelItem", `/web_studio/static/src/client_action/editor/new_model_item/new_model_item.xml`, `<t t-name="web_studio.NewModelItem" xml:space="preserve">
    <a t-if="menus.getCurrentApp()" href="#" class="o_web_create_new_model o_nav_entry" role="button" t-on-click="onClick">
      <i class="fa fa-fw fa-plus"/>New Model
    </a>
  </t>

  `);
registerTemplate("web_studio.SimpleNewModelDialog", `/web_studio/static/src/client_action/editor/new_model_item/new_model_item.xml`, `<t t-name="web_studio.SimpleNewModelDialog" xml:space="preserve">
    <Dialog size="'sm'" title.translate="Create a new Model" contentClass="'o_web_studio_new_model_modal'">
      <label t-attf-class="{{ state.showValidation and !state.modelName ? 'o_web_studio_field_warning': '' }}">Model name
        <input type="text" name="model_name" class="o_input" placeholder.translate="My model" t-model="state.modelName"/>
      </label>

      <t t-set-slot="footer">
        <button type="button" class="btn btn-primary confirm_button" t-attf-class="{{ !state.modelName ? 'opacity-50' : ''  }}" t-on-click="onConfigureModel">Configure Model</button>

        <button type="button" class="btn btn-secondary" t-on-click="_cancel">Cancel</button>
      </t>
    </Dialog>
  </t>

`);
registerTemplate("web_studio.MapNewViewDialog", `/web_studio/static/src/client_action/editor/new_view_dialogs/map_new_view_dialog.xml`, `<t t-name="web_studio.MapNewViewDialog" xml:space="preserve">
  <Dialog size="'md'" title="title">
    <div class="form-text text-muted">Select the contact field to use to get the coordinates of your records.</div>
    <div class="o_web_studio_select mt-4">
        <label for="res_partner">Contact Field</label>
        <select name="res_partner" class="o_input" t-model="fieldsChoice.res_partner">
            <option t-foreach="partnerFields" t-as="field" t-att-value="field.name" t-key="field.name">
                <t t-esc="field.string"/><span t-if="env.debug"> (<t t-esc="field.name"/>)</span>
            </option>
        </select>
    </div>
    <t t-set-slot="footer">
      <button class="btn btn-primary" t-on-click="_confirm">
        Activate View
      </button>
      <button class="btn btn-secondary" t-on-click="_cancel">
        Cancel
      </button>
    </t>
  </Dialog>
</t>
`);
registerTemplate("web_studio.NewViewDialog", `/web_studio/static/src/client_action/editor/new_view_dialogs/new_view_dialog.xml`, `<t t-name="web_studio.NewViewDialog" xml:space="preserve">
  <Dialog size="'md'" title="title">
    <div class="o_web_studio_new_view_dialog">
      <div class="o_web_studio_select">
        <label for="date_start">Start Date Field</label>
        <select name="date_start" class="o_input" t-model="fieldsChoice.date_start">
          <option t-foreach="dateFields" t-as="field" t-att-value="field.name" t-key="field.name">
            <t t-esc="field.string"/><span t-if="env.debug"> (<t t-esc="field.name"/>)</span>
          </option>
        </select>
      </div>

      <div class="o_web_studio_select">
        <label for="date_stop">Stop Date Field</label>
        <select name="date_stop" class="o_input" t-model="fieldsChoice.date_stop">
          <option t-if="!mandatoryStopDate"/>
          <option t-foreach="dateFields" t-as="field" t-att-value="field.name" t-key="field.name">
            <t t-esc="field.string"/><span t-if="env.debug"> (<t t-esc="field.name"/>)</span>
          </option>
        </select>
      </div>
    </div>
    <t t-set-slot="footer">
      <button class="btn btn-primary" t-on-click="_confirm">
        Activate View
      </button>
      <button class="btn btn-secondary" t-on-click="_cancel">
        Cancel
      </button>
    </t>
  </Dialog>
</t>

`);
registerTemplate("web_studio.IconCreator", `/web_studio/static/src/client_action/icon_creator/icon_creator.xml`, `<t t-name="web_studio.IconCreator" xml:space="preserve">
    <div class="o_web_studio_icon_creator">
        <div t-if="props.type === 'base64'" class="o_web_studio_uploaded_image mx-auto mb-4 rounded-3 shadow bg-white" t-attf-style="background-image: url({{props.webIconData}})"/>
        <t t-else="">
            <h6 t-if="props.editable">Design your Icon</h6>
            <div class="o_web_studio_icon float-start">
                <div class="o_app_icon d-flex align-items-center justify-content-center rounded-3 shadow border-2" t-attf-style="border: solid #00000050;background-color: {{props.backgroundColor}};">
                    <i t-att-class="props.iconClass" t-attf-style="color: {{props.color}};" t-key="props.iconClass"/>
                </div>
            </div>
            <t t-if="props.editable">
                <div class="o_web_studio_selectors float-end mt-2">
                    <SelectMenu autoSort="false" class="'o_web_studio_selector o_web_studio_selector_background overflow-visible p-0 border-0 m-3'" menuClass="'o_web_studio_selector_menu'" togglerClass="'p-0'" value="props.backgroundColor" choices="backgroundColorChoices" onSelect="(value) =&gt; this.onPaletteItemClick('backgroundColor', value)" required="true" searchable="false">
                        <div class="w-100 h-100 rounded-2" t-attf-style="background-color: {{props.backgroundColor}};"> </div>
                        <span class="o_web_studio_selector_pointer"/>
                        <t t-set-slot="choice" t-slot-scope="choice">
                            <div class="o_web_studio_selector_value border border-primary m-0 rounded-2 d-inline-flex" t-attf-style="background-color: {{choice.data.value}}"/>
                        </t>
                    </SelectMenu>
                    <SelectMenu autoSort="false" class="'o_web_studio_selector o_web_studio_selector_color overflow-visible p-0 border-0 m-3'" menuClass="'o_web_studio_selector_menu'" togglerClass="'p-0'" value="props.color" choices="colorChoices" onSelect="(value) =&gt; this.onPaletteItemClick('color', value)" required="true" searchable="false">
                        <div class="w-100 h-100 rounded-2" t-attf-style="background-color: {{props.color}};"> </div>
                        <span class="o_web_studio_selector_pointer"/>
                        <t t-set-slot="choice" t-slot-scope="choice">
                            <div class="o_web_studio_selector_value border border-primary m-0 rounded-2 d-inline-flex" t-attf-style="background-color: {{choice.data.value}}"/>
                        </t>
                    </SelectMenu>
                    <FontAwesomeIconSelector className="'o_web_studio_selector o_web_studio_selector_icon m-3'" menuClassName="'o_web_studio_selector_menu o_web_studio_selector_icon_menu'" value="props.iconClass" onSelect="(value) =&gt; this.onPaletteItemClick('iconClass', value)">
                        <i t-att-class="props.iconClass"/>
                        <span class="o_web_studio_selector_pointer"/>
                    </FontAwesomeIconSelector>
                </div>
                <div class="clearfix"/>
            </t>
        </t>
        <div t-if="props.editable" class="o_web_studio_upload">
            <a t-if="props.type === 'base64'" href="#" t-on-click.prevent.stop="onDesignIconClick">
                Design your Icon
            </a>
            <span> or </span>
            <FileInput t-props="fileInputProps" onUpload.bind="onFileUploaded">
                <a href="#">
                    <t t-if="props.type === 'base64'">upload one</t>
                    <t t-else="">upload it</t>
                </a>
            </FileInput>
        </div>
    </div>
</t>

`);
registerTemplate("web_studio.MenuCreator", `/web_studio/static/src/client_action/menu_creator/menu_creator.xml`, `<t t-name="web_studio.MenuCreator" xml:space="preserve">
    <div class="d-flex flex-column gap-4">
        <div class="o_web_studio_menu_creator" t-att-class="{ o_web_studio_field_warning: !isValid('menuName') }">
            <label for="menuName">Choose the name of the menu</label>
            <input type="text" class="o_input" name="menuName" placeholder="e.g. Properties" t-model="state.data.menuName" t-ref="autofocus"/>
        </div>
        <div class="o_web_studio_menu_creator_model_choice">
            <div t-foreach="state.modelChoiceSelection" t-as="item" t-key="item" class="form-check d-flex gap-2 align-items-center p-0">
                <t t-set="inputId" t-value="'model_choice_' + item"/>
                <input type="radio" class="form-check-input m-0" name="model_choice" t-att-id="inputId" t-model="state.data.modelChoice" t-att-value="item"/>
                <label class="form-check-label" t-att-for="inputId" t-esc="item_value"/>
            </div>
        </div>
        <div t-if="state.data.modelChoice === 'existing'" class="o_web_studio_menu_creator_model" t-att-class="{ o_web_studio_field_warning: !isValid('modelId') }">
            <label for="name">Model</label>
            <RecordSelector t-props="multiRecordSelectorProps"/>
        </div>
    </div>
</t>

  `);
registerTemplate("web_studio.MenuCreatorDialog", `/web_studio/static/src/client_action/menu_creator/menu_creator.xml`, `<t t-name="web_studio.MenuCreatorDialog" xml:space="preserve">
    <Dialog size="'sm'" title.translate="Create your menu" contentClass="'o_web_studio_add_menu_modal'">

        <MenuCreator showValidation="state.showValidation" menuCreatorModel="menuCreatorModel"/>

        <t t-set-slot="footer">

            <button type="button" t-if="menuCreatorModel.data.modelChoice === 'new'" class="btn btn-primary confirm_button" t-attf-class="{{ !menuCreatorModel.isValid ? 'opacity-50' : '' }}" t-on-click="onCreateNewModel">
                Configure model
            </button>

            <button t-else="" type="button" class="btn btn-primary confirm_button" t-attf-class="{{ !menuCreatorModel.isValid ? 'opacity-50' : '' }}" t-on-click="confirm">
                Confirm
            </button>

            <button type="button" class="btn btn-secondary" t-on-click="_cancel">Cancel</button>
        </t>
    </Dialog>
  </t>

`);
registerTemplate("web_studio.ModelConfigurator", `/web_studio/static/src/client_action/model_configurator/model_configurator.xml`, `<t t-name="web_studio.ModelConfigurator" xml:space="preserve">
    <div t-attf-class="{{ props.embed ? 'embed': 'p-3' }}">
        <div class="row">
            <div t-foreach="options" t-as="option" t-key="option" class="col-6">
                <div class="form-check my-3 o_web_studio_model_configurator_option">
                    <input type="checkbox" class="form-check-input" t-att-id="option" t-att-name="option" t-model="option_value.value"/>
                    <label t-att-for="option" class="form-check-label ps-2 border-start">
                        <strong t-esc="option_value.label"/>
                        <div class="form-text text-muted" t-esc="option_value.help"/>
                    </label>
                </div>
            </div>
        </div>
        <div class="o_web_studio_model_configurator_buttons d-flex justify-content-between pt-3">
            <button type="button" class="o_web_studio_model_configurator_previous btn oi oi-chevron-left rounded px-3 py-1 border text-muted" t-att-class="{ disabled: state.saving }" aria-label="Previous" title="Previous" t-on-click="props.onPrevious"/>
            <button type="button" class="o_web_studio_model_configurator_next btn rounded px-3 py-1 btn-primary" t-att-class="{ disabled: state.saving }" aria-label="Next" title="Next" t-on-click="onConfirm" t-att-disabled="state.saving">
                <span class="pe-2" t-esc="props.label"/>
                <i class="fa oi" t-att-class="{'oi-chevron-right': !state.saving, 'fa-circle-o-notch': state.saving, 'fa-spin': state.saving}"/>
            </button>
        </div>
    </div>
</t>

`);
registerTemplate("web_studio.ModelConfiguratorDialog", `/web_studio/static/src/client_action/model_configurator/model_configurator.xml`, `<t t-name="web_studio.ModelConfiguratorDialog" xml:space="preserve">
    <Dialog title.translate="Suggested features for your new model" footer="false" contentClass="'o_web_studio_model_configurator'">
        <ModelConfigurator embed="true" onConfirmOptions.bind="onConfirm" label="props.confirmLabel" onPrevious.bind="onPrevious"/>
    </Dialog>
</t>

`);
registerTemplate("web_studio.HomeMenuCustomizer", `/web_studio/static/src/client_action/navbar/home_menu_customizer/home_menu_customizer.xml`, `<t t-name="web_studio.HomeMenuCustomizer" xml:space="preserve">
    <div class="o_web_studio_home_studio_menu d-flex align-items-center mx-1">
      <div class="o_web_studio_change_background o_nav_entry" role="button">
        <FileInput acceptedFileExtensions="'image/*'" onUpload.bind="onBackgroundUpload" resId="company.currentCompany.id" resModel="'res.company'">
          Change Background
        </FileInput>
      </div>
      <div t-if="menus.getMenu('root').backgroundImage" class="o_web_studio_reset_default_background o_nav_entry" role="button" t-on-click="resetBackground">
        Reset Default Background
      </div>
      <div class="o_web_studio_export o_nav_entry" role="button" t-on-click="exportCusto">Export</div>
      <div class="o_web_studio_import o_nav_entry" role="button" t-on-click="importCusto">Import</div>
    </div>
  </t>

`);
registerTemplate("web_studio.StudioNavbar", `/web_studio/static/src/client_action/navbar/navbar.xml`, `<t t-name="web_studio.StudioNavbar" t-inherit="web_enterprise.EnterpriseNavBar" t-inherit-mode="primary" xml:space="preserve">
      <xpath expr="//nav" position="attributes">
        <attribute name="class" add="o_studio_navbar" separator=" "/>
      </xpath>

      <xpath expr="//a[contains(@class, 'o_menu_toggle')]" position="attributes">
        <attribute name="t-on-click.prevent">onMenuToggle</attribute>
      </xpath>

      <xpath expr="//nav" position="inside">
        <t t-call="web_studio.menuButtons"/>
        <t t-call="web_studio.masterButtons"/>
      </xpath>

      <xpath expr="//div[contains(@class, 'o_menu_systray')]" position="replace"/>
  </t>

  `);
registerTemplate("web_studio.menuButtons", `/web_studio/static/src/client_action/navbar/navbar.xml`, `<t t-name="web_studio.menuButtons" xml:space="preserve">
    <div class="o-studio--menu ms-auto">
      <t t-foreach="menuButtons" t-as="element" t-key="element">
        <t t-component="element_value.Component" t-props="element_value.props || {}"/>
      </t>
    </div>
  </t>

  `);
registerTemplate("web_studio.masterButtons", `/web_studio/static/src/client_action/navbar/navbar.xml`, `<t t-name="web_studio.masterButtons" xml:space="preserve">
    <div class="o_studio_buttons">
      <HomeMenuCustomizer t-if="studio.mode === studio.MODES.HOME_MENU"/>
      <div class="o_web_studio_leave d-flex" t-on-click="closeStudio">
          <a class="btn btn-primary d-flex align-items-center rounded-0 border-0">Close</a>
      </div>
    </div>
  </t>

`);
registerTemplate("web_studio.ReportEditor", `/web_studio/static/src/client_action/report_editor/report_editor.xml`, `<t t-name="web_studio.ReportEditor" xml:space="preserve">
    <div class="o-web-studio-report-editor h-100 w-100 d-flex flex-row">
        <ReportEditorWysiwyg t-if="reportEditorModel.mode === 'wysiwyg'" paperFormatStyle="paperFormatStyle"/>

        <ReportEditorXml t-if="reportEditorModel.mode === 'xml'" paperFormatStyle="paperFormatStyle"/>
    </div>
</t>

`);
registerTemplate("web_studio.ReportEditor.Iframe", `/web_studio/static/src/client_action/report_editor/report_editor.xml`, `<t t-name="web_studio.ReportEditor.Iframe" xml:space="preserve">
    <div class="h-100 w-100 overflow-auto position-relative" t-on-scroll="onContainerScroll">
        <div class="o-web-studio-report-container shadow my-0 mx-auto my-lg-5 d-flex" t-att-style="paperFormatStyle">
            <iframe t-if="!reportEditorModel.fullErrorDisplay" class="w-100" t-ref="iframeRef" t-att-srcdoc="iframeSource" t-key="iframeKey" t-att-style="iframeStyle" type="text/plain" t-on-load="onIframeLoaded"/>
            <ErrorDisplay t-if="reportEditorModel.fullErrorDisplay" error="reportEditorModel.fullErrorDisplay"/>
        </div>
    </div>
</t>

`);
registerTemplate("web_studio.ReportEditor.NotificationError", `/web_studio/static/src/client_action/report_editor/report_editor.xml`, `<t t-name="web_studio.ReportEditor.NotificationError" xml:space="preserve">
    <div>
        Saving the report "<t t-esc="reportName"/>" failed.
        <p>This may be due to an incorrect syntax in the edited parts.</p>
        <p t-if="!recordId">This could also be due to the absence of a real record to render the report with.</p>
        <div t-if="error">
            <p>Error message: <t t-esc="error.message"/></p>
            <p t-if="error.viewError">On view (ir.ui.view): <t t-esc="error.viewError.resIds.join(', ')"/></p>
        </div>
    </div>
</t>

`);
registerTemplate("web_studio.ErrorDisplay", `/web_studio/static/src/client_action/report_editor/report_editor.xml`, `<t t-name="web_studio.ErrorDisplay" xml:space="preserve">
    <div class="d-flex flex-column gap-2">
        <span>The report could not be loaded as some error occured. Usually it means that some view inherits from another but targets a node that doesn't exist. It might be due to the mutations of the base views during the upgrade process.</span>
        <div><span class="me-1">Error name:</span><strong class="fs-3" t-esc="error.name"/></div>
        <div><span class="me-1">Error message:</span><strong class="fs-4" t-esc="error.message"/></div>
        <div t-if="error.viewError" class="d-flex flex-column">
            <t t-set="viewError" t-value="error.viewError"/>
            <span class="fs-4">View in Error:</span>
            <table>
                <thead>
                    <th>IDs</th>
                    <th>Name</th>
                    <th>Model</th>
                    <th>Parent View (inherit_id)</th>
                </thead>
                <tbody>
                    <td>
                        <t t-foreach="viewError.resIds" t-as="resId" t-key="resId">
                            <a t-att-href="urlFor('ir.ui.view', resId)" t-on-click.synthetic.prevent="() =&gt; this.openRecord(viewError.viewModel, resId)" t-esc="resId"/>
                            <span class="me-2">,</span>
                        </t>
                    </td>
                    <td t-esc="viewError.completeName"/>
                    <td>
                        <t t-if="viewError.model" t-esc="viewError.model"/><t t-else="">N/A</t>
                    </td>
                    <td>
                        <t t-foreach="viewError.parentIds" t-as="resId" t-key="resId">
                            <a t-att-href="urlFor('ir.ui.view', resId)" t-on-click.synthetic.prevent="() =&gt; this.openRecord(viewError.viewModel, resId)" t-esc="resId"/>
                            <span class="me-2">,</span>
                        </t>
                    </td>
                </tbody>
            </table>
        </div>
        <div>
            <button class="btn btn-primary" t-on-click="() =&gt; state.showTrace = !state.showTrace">Show Traceback</button>
        </div>
        <div t-if="state.showTrace">
            <pre class="d-flex flex-column alert alert-info bg-100" t-esc="error.traceback"/>
        </div>
    </div>
</t>

`);
registerTemplate("web_studio.ReportEditor.SnackBar", `/web_studio/static/src/client_action/report_editor/report_editor_snackbar.xml`, `<t t-name="web_studio.ReportEditor.SnackBar" xml:space="preserve">
    <div class="d-flex flex-row">
        <button class="btn rounded-0 text-uppercase o-web-studio-save-report" t-on-click="props.onSave" t-attf-class="{{ props.state.isDirty ? 'btn-primary' : '' }}">
            <i class="fa fa-light fa-save me-2"/>Save
        </button>

        <button t-if="props.onDiscard" class="btn rounded-0 ms-1 text-uppercase o-web-studio-discard-report" t-on-click="props.onDiscard" t-attf-class="{{ props.state.isDirty ? 'btn-secondary' : '' }}">
            <i class="fa fa-times me-2"/>Discard
        </button>

        <div t-if="props.state.warningMessage" class="text-warning pb-1 px-2" style="padding-top: 6px">
            <i class="fa fa-exclamation-triangle me-2"/><t class="o-web-studio-warning-message" t-esc="props.state.warningMessage"/>
        </div>
    </div>
</t>

`);
registerTemplate("web_studio.ReportEditorWysiwyg", `/web_studio/static/src/client_action/report_editor/report_editor_wysiwyg/report_editor_wysiwyg.xml`, `<t t-name="web_studio.ReportEditorWysiwyg" xml:space="preserve">
    <t t-call="web_studio.ReportEditorWysiwyg.Sidebar"/>
    <div class="o-web-studio-report-editor-wysiwyg h-100 w-100 position-relative">
      <UndoRedo state="undoRedoState"/>
      <ReportEditorIframe iframeKey="reportEditorModel.reportQweb || ''" iframeSource="reportQweb" onIframeLoaded.bind="onIframeLoaded"/>
    </div>
</t>

`);
registerTemplate("web_studio.ReportEditorWysiwyg.Sidebar", `/web_studio/static/src/client_action/report_editor/report_editor_wysiwyg/report_editor_wysiwyg.xml`, `<t t-name="web_studio.ReportEditorWysiwyg.Sidebar" xml:space="preserve">
    <div class="o_web_studio_sidebar h-100 overflow-auto flex-grow-0 flex-shrink-0">
      <div class="o_web_studio_sidebar_content d-flex flex-column gap-3 mt-3">
        <Record t-props="reportRecordProps" t-slot-scope="scope" onRecordChanged.alike="(rec) =&gt; this.reportEditorModel.reportData = rec.data">
          <t t-set="record" t-value="scope.record"/>

          <div class="o_web_studio_sidebar_text">
            <label for="name" class="mb-1">Report name</label>
            <CharField name="'name'" record="record" id="'name'"/>
          </div>

          <div class="o_web_studio_sidebar_tags">
            <label for="paperformat_id" class="mb-1">Paper format</label>
            <Many2OneField record="record" name="'paperformat_id'" id="'paperformat_id'"/>
          </div>

          <div class="o_web_studio_sidebar_checkbox d-flex flex-row gap-1">
            <BooleanField record="record" name="'display_in_print_menu'" id="'display_in_print_menu'"/>
            <label for="display_in_print_menu">Show in print menu</label>
          </div>

          <div class="o_web_studio_sidebar_checkbox d-flex flex-row gap-1">
            <BooleanField record="record" name="'attachment_use'" id="'attachment_use'"/>
            <label for="attachment_use">Reload from attachment</label>
          </div>

          <div class="o_web_studio_sidebar_tags">
            <label for="groups_id" class="mb-1">Limit visibility to groups</label>
            <div class="o_field_widget o_field_many2many_tags" name="groups_id">
              <Many2ManyTagsField id="'groups_id'" name="'groups_id'" record="record"/>
            </div>
          </div>

        </Record>
        <div class="grid gap-2 mt-4 pt-3 border-top border-secondary">
          <button class="btn btn-info g-col-6 p-2" name="report_edit_sources" t-on-click="editSources">
            <i class="fa fa-code me-2"/>Edit sources
          </button>
          <button class="btn btn-danger g-col-6 p-2" name="report_reset_archs" t-on-click="resetReport">
            Reset report
          </button>
          <t t-set="printTooltip">
            <t t-if="!reportEditorModel.recordToDisplay">There is no record to preview</t>
          </t>
          <button class="btn btn-secondary g-col-6 p-2" name="report_print_preview" t-on-click="printPreview" t-att-data-tooltip="printTooltip">
            <i t-if="!reportEditorModel.recordToDisplay" class="fa fa-exclamation-triangle me-2"/>
            <i t-else="" class="fa fa-print me-2"/>
            Print preview
          </button>
          <button class="btn btn-secondary g-col-6 p-2" t-if="env.debug" t-on-click="openReportFormView">
            <i class="fa fa-cog me-2"/>More
          </button>
        </div>
      </div>
    </div>
</t>

`);
registerTemplate("web_studio.FieldDynamicPlaceholder", `/web_studio/static/src/client_action/report_editor/report_editor_wysiwyg/report_editor_wysiwyg.xml`, `<t t-name="web_studio.FieldDynamicPlaceholder" xml:space="preserve">
  <div class="o-web-studio-field-dynamic-placeholder">
    <div class="px-1 pt-3 bg-secondary" t-if="Object.keys(sortedVariables).length &gt; 1">
      <label class="text-small text-bold mb-2" for="o_studio_report_field_model">Current model:</label>
      <SelectMenu choices="sortedVariables" value="state.currentVar" onSelect="(value) =&gt; state.currentVar = value" required="true" searchable="false"/>
    </div>
    <StudioDynamicPlaceholderPopover showOnlyX2ManyFields="props.showOnlyX2ManyFields" resModel="currentResModel" validate.bind="validate" close="props.close" t-key="currentResModel"/>
  </div>
</t>

`);
registerTemplate("web_studio.ReportEditorWysiwyg.UndoRedo", `/web_studio/static/src/client_action/report_editor/report_editor_wysiwyg/report_editor_wysiwyg.xml`, `<t t-name="web_studio.ReportEditorWysiwyg.UndoRedo" xml:space="preserve">
  <t t-set="isActive" t-value="props.state.canUndo or props.state.canRedo"/>
  <div class="position-absolute top-0 start-0 ms-5 mt-4 rounded bg-white border border-2 d-flex flex-row o-web-studio-report-editor-undo-redo gap-2 align-items-center" t-att-class="{active: isActive}">
    <button class="btn o_web_studio_undo_redo_button text-uppercase" t-attf-class="{{ !props.state.canUndo ? 'text-muted' : 'active' }}" t-on-click="props.state.undo">
      <i class="fa fa-undo me-1"/>Undo
    </button>
    <div class="border"/>
    <button class="btn o_web_studio_undo_redo_button text-uppercase" t-attf-class="{{ !props.state.canRedo ? 'text-muted' : 'active' }}" t-on-click="props.state.redo">
      <i class="fa fa-repeat me-1"/>Redo
    </button>
  </div>
</t>

`);
registerTemplate("web_studio.ReportEditorWysiwyg.ResetConfirmationPopup", `/web_studio/static/src/client_action/report_editor/report_editor_wysiwyg/report_editor_wysiwyg.xml`, `<t t-name="web_studio.ReportEditorWysiwyg.ResetConfirmationPopup" t-inherit="web.ConfirmationDialog" t-inherit-mode="primary" xml:space="preserve">
  <xpath expr="//p[@t-out='props.body']" position="replace">
    <p>All changes done to the report's structure will be discarded and the report will be reset to its factory settings.</p>
    <div class="o_setting_box">
      <div class="o_setting_left_pane">
        <input class="form-check-input" type="checkbox" id="includeHeaderFooter" name="includeHeaderFooter" t-model="props.state.includeHeaderFooter"/>
      </div>
      <div class="o_setting_right_pane">
        <label for="includeHeaderFooter" class="o_form_label me-4">Include header and footer</label>
          <div class="text-muted">
              Header and footer are shared with other reports which may be impacted by the reset.
          </div>
      </div>
  </div>
  </xpath>
</t>

`);
registerTemplate("web_studio.StudioDynamicPlaceholderPopover", `/web_studio/static/src/client_action/report_editor/report_editor_wysiwyg/studio_dynamic_placeholder_popover.xml`, `<t t-name="web_studio.StudioDynamicPlaceholderPopover" t-inherit="web.DynamicPlaceholderPopover" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//ModelFieldSelectorPopover" position="attributes">
            <attribute name="followRelations">!props.showOnlyX2ManyFields</attribute>
        </xpath>
    </t>

`);
registerTemplate("web_studio.ReportEditorXml", `/web_studio/static/src/client_action/report_editor/report_editor_xml/report_editor_xml.xml`, `<t t-name="web_studio.ReportEditorXml" xml:space="preserve">
    <XmlResourceEditor mainResourceId="reportEditorModel.reportData.report_name" onClose.bind="onCloseXmlEditor" onCodeChange.bind="onXmlChanged" canSave="false" minWidth="minWidth" reloadSources="state.reloadSources" onResourceChange.bind="onResourceChanged" displayAlerts="false" getDefaultResource.bind="getDefaultResource">
        <t t-set-slot="additionalControlButtons" t-slot-scope="xmlEditor">
            <div class="d-flex">
                <TranslationButton resourceId="xmlEditor.currentResourceId"/>
                <button class="btn btn-link p-0" name="view_diff" t-on-click="() =&gt; this.switchToDiff(xmlEditor.currentResourceId)" t-if="env.debug and !this.state.viewIdToDiff" type="button" data-tooltip="See what changes have been made to this view">DIFF</button>
                <button class="btn btn-link p-0" name="leave_view_diff" t-on-click="() =&gt; this.switchToDiff(null)" t-if="state.viewIdToDiff" type="button">Leave DIFF</button>
            </div>
        </t>
    </XmlResourceEditor>
    <div class="h-100 w-100 position-relative overflow-hidden" t-if="!this.state.viewIdToDiff">
        <div class="position-absolute top-0 end-0 me-5 mt-4" style="z-index: 1050;">
            <ReportRecordNavigation/>
        </div>
        <ReportEditorIframe iframeKey="reportEditorModel.reportHtml" iframeSource="reportEditorModel.reportHtml" onIframeLoaded.bind="onIframeLoaded"/>
    </div>
    <div class="w-100 h-100 p-3 overflow-auto" t-if="this.state.viewIdToDiff">
        <View t-props="diffProps" className="'shadow'" t-key="state.reloadSources"/>
    </div>
</t>

`);
registerTemplate("web_studio.ReportEditor.ReportRecordNavigation", `/web_studio/static/src/client_action/report_editor/report_editor_xml/report_record_navigation.xml`, `<t t-name="web_studio.ReportEditor.ReportRecordNavigation" xml:space="preserve">
    <div class="d-flex flex-row gap-3" style="height: 35px;">
        <div class="position-relative rounded o-web-studio-report-search-record p-1 px-2 bg-white" style="max-width: 150px;">
            <i class="fa fa-search position-absolute end-0 me-3 mt-1"/>
            <RecordSelector t-props="multiRecordSelectorProps"/>
        </div>
        <div class="d-flex rounded px-3 o-web-studio-report-pager bg-white">
            <Pager t-props="pagerProps" onUpdate.bind="updatePager"/>
        </div>
    </div>
</t>

`);
registerTemplate("web_studio.StudioClientAction", `/web_studio/static/src/client_action/studio_client_action.xml`, `<t t-name="web_studio.StudioClientAction" xml:space="preserve">
    <div class="o_studio h-100">
        <StudioNavbar/>

        <StudioHomeMenu t-if="studio.mode === studio.MODES.HOME_MENU" apps="homeMenuProps.apps"/>
        <AppCreator t-elif="studio.mode === studio.MODES.APP_CREATOR" onNewAppCreated.bind="onNewAppCreated"/>
        <Editor t-elif="studio.mode === studio.MODES.EDITOR"/>
    </div>
</t>

`);
registerTemplate("web_studio.IconCreatorDialog", `/web_studio/static/src/client_action/studio_home_menu/icon_creator_dialog/icon_creator_dialog.xml`, `<t t-name="web_studio.IconCreatorDialog" xml:space="preserve">
    <Dialog title.translate="Edit Application Icon" contentClass="'o_web_studio_edit_menu_icon_modal'" bodyClass="'d-flex justify-content-center align-items-center overflow-auto'" size="'md'">
        <IconCreator editable="true" t-props="props.editedAppData" onIconChange.bind="onIconChanged"/>
        <t t-set-slot="footer">
            <button class="btn btn-primary" t-on-click="saveIcon">Confirm</button>
            <button class="btn btn-secondary" t-on-click="props.close">Cancel</button>
        </t>
    </Dialog>
</t>

`);
registerTemplate("web_studio.StudioHomeMenu", `/web_studio/static/src/client_action/studio_home_menu/studio_home_menu.xml`, `<t t-name="web_studio.StudioHomeMenu" t-inherit="web_enterprise.HomeMenu" t-inherit-mode="primary" t-translation="off" xml:space="preserve">
    <xpath expr="//div[hasclass('o_home_menu')]" position="attributes">
        <attribute name="class" add="o_studio_home_menu" separator=" "/>
        <attribute name="t-attf-style">
        {{ backgroundImageUrl ? "background-image: radial-gradient(circle, rgba(0,0,0, 0) 0%, rgba(0,0,0, 1) 100%), repeating-linear-gradient(45deg, rgba(255,255,255, .05), rgba(255,255,255, .05) 30px, rgba(0,0,0, .05) 30px, rgba(0,0,0, .05) 60px), url(" + backgroundImageUrl + ");" : '' }}
      </attribute>
    </xpath>

    <xpath expr="//div[hasclass('o_apps')]/div/a[hasclass('o_app')][hasclass('o_menuitem')]" position="attributes">
        <attribute name="t-att-class">{
            o_focused: appIndex === app_index,
            'o_web_studio_new_app': app.isNewAppButton
        }</attribute>
    </xpath>
    <xpath expr="//div[hasclass('o_draggable')]" position="attributes">
        <attribute name="t-attf-class" add="{{ app.isNewAppButton ? 'order-first' : '' }}"/>
    </xpath>

    <xpath expr="//div[hasclass('o_apps')]/div/a[hasclass('o_app')][hasclass('o_menuitem')]" position="inside">
        <a t-if="!app.isNewAppButton" class="o_web_studio_edit_icon lh-1" t-on-click.stop.prevent="() =&gt; this.onEditIconClick(app)">
            <i class="fa fa-pencil-square"/>
        </a>
    </xpath>
</t>

`);
registerTemplate("web_studio.ViewEditor.DefaultViewSidebar", `/web_studio/static/src/client_action/view_editor/default_view_sidebar/default_view_sidebar.xml`, `<t t-name="web_studio.ViewEditor.DefaultViewSidebar" xml:space="preserve">
        <InteractiveEditorSidebar>
            <t t-set-slot="view">
                <SidebarViewToolbox onMore="props.openViewInForm" canEditXml="!viewEditorModel.isEditingSubview" openDefaultValues="props.openDefaultValues"/>
            </t>
        </InteractiveEditorSidebar>
    </t>

`);
registerTemplate("web_studio.ViewEditor.CalendarEditorSidebar", `/web_studio/static/src/client_action/view_editor/editors/calendar/calendar_editor_sidebar.xml`, `<t t-name="web_studio.ViewEditor.CalendarEditorSidebar" xml:space="preserve">
        <InteractiveEditorSidebar>
            <t t-set-slot="view">
                <Property name="'quick_create'" type="'boolean'" value="archInfo.quickCreate" onChange.bind="onViewAttributeChanged">
                    Quick Create
                </Property>

                <Property t-if="env.debug and archInfo.hasQuickCreate" name="'create_name_field'" type="'selection'" value="archInfo.fieldMapping.create_name_field" childProps="{ choices: this.quickCreateFields }" onChange.bind="onViewAttributeChanged">
                    Quick Create Field
                </Property>

                <Property name="'date_start'" type="'selection'" value="archInfo.fieldMapping.date_start" childProps="{ choices: startDateFields }" onChange.bind="onViewAttributeChanged">
                    Start Date Field
                </Property>

                <Property name="'date_stop'" type="'selection'" value="archInfo.fieldMapping.date_stop" childProps="{ choices: startDateFields, required: false }" onChange.bind="onViewAttributeChanged">
                    Stop Date Field
                </Property>

                <Property name="'date_delay'" type="'selection'" value="archInfo.fieldMapping.date_delay" childProps="{ choices: delayFields, required: false }" onChange.bind="onViewAttributeChanged">
                    Delay Field
                </Property>

                <Property name="'color'" type="'selection'" value="archInfo.fieldMapping.color" childProps="{ choices: colorFields, required: false }" onChange.bind="onViewAttributeChanged">
                    Color
                </Property>

                <Property name="'all_day'" type="'selection'" value="archInfo.fieldMapping.all_day" childProps="{ choices: allDayFields, required: false }" onChange.bind="onViewAttributeChanged">
                    All Day
                </Property>

                <Property name="'mode'" type="'selection'" value="archInfo.scale" childProps="{ choices: modeChoices }" onChange.bind="onViewAttributeChanged">
                    Default Display Mode
                </Property>

                <SidebarViewToolbox onMore="props.openViewInForm" canEditXml="!viewEditorModel.isEditingSubview" openDefaultValues="props.openDefaultValues"/>
            </t>
        </InteractiveEditorSidebar>
    </t>

`);
registerTemplate("web_studio.ViewEditor.CohortEditorSidebar", `/web_studio/static/src/client_action/view_editor/editors/cohort/cohort_editor_sidebar.xml`, `<t t-name="web_studio.ViewEditor.CohortEditorSidebar" xml:space="preserve">
        <InteractiveEditorSidebar>
            <t t-set-slot="view">
                <Property name="'date_start'" type="'selection'" value="modelParams.dateStart" childProps="{ choices: this.dateFields }" onChange.bind="onViewAttributeChanged">
                    Start Date Field
                </Property>

                <Property name="'date_stop'" type="'selection'" value="modelParams.dateStop" childProps="{ choices: this.dateFields }" onChange.bind="onViewAttributeChanged">
                    Stop Date Field
                </Property>

                <Property name="'measure'" type="'selection'" value="modelParams.measure" childProps="{ choices: this.dateFields, required: false }" onChange.bind="onViewAttributeChanged">
                    Measure Field
                </Property>

                <Property name="'interval'" type="'selection'" value="modelParams.interval" childProps="{ choices: this.intervalChoices }" onChange.bind="onViewAttributeChanged">
                    Interval
                </Property>

                <Property name="'mode'" type="'selection'" value="modelParams.mode || 'retention'" childProps="{ choices: this.modeChoices }" onChange.bind="onViewAttributeChanged">
                    Mode
                </Property>

                <Property name="'timeline'" type="'selection'" value="modelParams.timeline || 'forward'" childProps="{ choices: this.timelineChoices }" onChange.bind="onViewAttributeChanged">
                    Timeline
                </Property>

                <SidebarViewToolbox onMore="props.openViewInForm" canEditXml="!viewEditorModel.isEditingSubview" openDefaultValues="props.openDefaultValues"/>
            </t>
        </InteractiveEditorSidebar>
    </t>

`);
registerTemplate("web_studio.FieldSelectorDialog", `/web_studio/static/src/client_action/view_editor/editors/components/field_selector_dialog.xml`, `<t t-name="web_studio.FieldSelectorDialog" xml:space="preserve">
    <Dialog title.translate="Select a Field">
      <div class="o_web_studio_kanban_helper">
        <label for="field">Field</label>
        <select id="field" name="field" class="o_input" t-ref="select">
            <option t-if="props.showNew" class="o_new fst-italic" value="">New Field</option>
            <option t-foreach="props.fields" t-as="field" t-key="field_index" t-att-value="field.name">
                <t t-esc="field.string"/> <span t-if="env.debug">(<t t-esc="field.name"/>)</span>
            </option>
        </select>
      </div>
      <t t-set-slot="footer">
        <button class="btn btn-primary" t-on-click="onConfirm">
            Confirm
        </button>
        <button class="btn btn-secondary" t-on-click="onCancel">
            Cancel
        </button>
      </t>
    </Dialog>
  </t>

`);
registerTemplate("web_studio.Field", `/web_studio/static/src/client_action/view_editor/editors/components/field_studio.xml`, `<t t-name="web_studio.Field" t-inherit="web.Field" xml:space="preserve">
    <xpath expr="./div" position="attributes">
        <attribute name="t-ref">rootRef</attribute>
    </xpath>

    <xpath expr="./div" position="before">
      <t t-set="isX2ManyEditable" t-value="isX2ManyEditable(props)"/>
      <t t-set="emptyPlaceholder" t-value="getEmptyPlaceholder()"/>
    </xpath>

    <xpath expr="//t[@t-component]" position="attributes">
      <attribute name="t-if">!isX2ManyEditable and !emptyPlaceholder</attribute>
    </xpath>

    <xpath expr="//t[@t-component]" position="after">
      <FieldContentOverlay t-if="isX2ManyEditable" displayOverlay="state.displayOverlay" onEditViewType.bind="onEditViewType">
        <t t-component="field.component" t-props="fieldComponentProps"/>
      </FieldContentOverlay>
      <span t-if="emptyPlaceholder" t-esc="emptyPlaceholder"/>
    </xpath>
  </t>

`);
registerTemplate("web_studio.ViewButton", `/web_studio/static/src/client_action/view_editor/editors/components/view_button_studio.xml`, `<t t-name="web_studio.ViewButton" t-inherit="web.views.ViewButton" xml:space="preserve">
    <xpath expr="./t" position="attributes">
      <attribute name="t-ref">rootRef</attribute>
    </xpath>
  </t>

`);
registerTemplate("web_studio.ViewFields.ExistingFields", `/web_studio/static/src/client_action/view_editor/editors/components/view_fields.xml`, `<t t-name="web_studio.ViewFields.ExistingFields" xml:space="preserve">
        <h3 class="o_web_studio_existing_fields_header my-3" role="button" t-on-click="() =&gt; state.folded = !state.folded">
            Existing Fields
            <i class="fa ms-2" t-attf-class="{{ state.folded ? 'fa-caret-right' : 'fa-caret-down' }}"/>
        </h3>
        <div class="o_web_studio_existing_fields_section" t-if="!state.folded">
            <h6 class="small user-select-none">The following fields are currently not in the view.</h6>
            <input type="text" class="o_web_studio_sidebar_search_input mb-2" autocomplete="studioAutocompleteOff" placeholder="Search..." t-model="state.searchValue"/>
            <div class="o_web_studio_field_type_container o_web_studio_existing_fields">
                <t t-foreach="existingFields" t-as="component" t-key="component.name">
                    <SidebarDraggableItem string="component.string || component.name" description="component.name" className="'w-100 mw-100 o_web_studio_field_' + component.classType" structure="'field'" dropData="component.dropData"/>
                </t>
            </div>
        </div>
    </t>

    `);
registerTemplate("web_studio.ViewFields.NewFields", `/web_studio/static/src/client_action/view_editor/editors/components/view_fields.xml`, `<t t-name="web_studio.ViewFields.NewFields" xml:space="preserve">
        <h3 class="my-3">New Fields</h3>
        <div class="o_web_studio_field_type_container o_web_studio_new_fields">
            <t t-foreach="newFieldsComponents" t-as="component" t-key="component.name">
                <SidebarDraggableItem string="component.string || component.name" description="component.name" className="'o_web_studio_field_' + component.classType" structure="'field'" dropData="component.dropData"/>
            </t>
        </div>
    </t>
`);
registerTemplate("web_studio.ViewStructures", `/web_studio/static/src/client_action/view_editor/editors/components/view_structures.xml`, `<t t-name="web_studio.ViewStructures" xml:space="preserve">
        <div class="o_web_studio_field_type_container o_web_studio_new_components d-flex flex-row">
            <h3 t-if="isVisible" class="w-100">Components</h3>
            <t t-foreach="props.structures" t-as="struct" t-key="struct_index">
                <SidebarDraggableItem t-if="!struct_value.isVisible || struct_value.isVisible(env.viewEditorModel)" string="struct_value.name" className="struct_value.class" structure="struct"/>
            </t>
        </div>
    </t>
`);
registerTemplate("web_studio.Widget", `/web_studio/static/src/client_action/view_editor/editors/components/widget_studio.xml`, `<t t-name="web_studio.Widget" xml:space="preserve">
    <div t-ref="rootRef" t-att-class="classNames" t-att-style="props.style">
        <t t-component="widget.component" t-props="widgetProps"/>
    </div>
  </t>

`);
registerTemplate("web_studio.ChatterContainer", `/web_studio/static/src/client_action/view_editor/editors/form/chatter_container.xml`, `<t t-name="web_studio.ChatterContainer" t-inherit="mail.Chatter" xml:space="preserve">
        <xpath expr="//div[hasclass(&quot;o-mail-Chatter&quot;)]" position="inside">
            <div class="o_web_studio_overlay"/>
        </xpath>
        <xpath expr="//div[hasclass(&quot;o-mail-Chatter&quot;)]" position="attributes">
            <attribute name="t-on-click.capture.stop">onClick</attribute>
        </xpath>
    </t>

    `);
registerTemplate("web_studio.ChatterContainerHook", `/web_studio/static/src/client_action/view_editor/editors/form/chatter_container.xml`, `<t t-name="web_studio.ChatterContainerHook" xml:space="preserve">
        <div t-if="env.viewEditorModel.isChatterAllowed" class="o_web_studio_add_chatter o_chatter" t-on-click.capture.stop="onClick">
            <span class="container">
                <span>
                <i class="fa fa-comments" style="margin-right:10px"/>
                Add Chatter Widget
                </span>
            </span>
            <div class="o_Studio_ChatterContainer">
                <Chatter threadModel="props.threadModel"/>
            </div>
        </div>
    </t>

`);
registerTemplate("web_studio.Form.OuterGroup", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_renderer/form_editor_groups.xml`, `<t t-name="web_studio.Form.OuterGroup" t-inherit="web.Form.OuterGroup" xml:space="preserve">
  <xpath expr="//div[contains(@class,'o_group')]" position="attributes">
    <attribute name="t-att-data-studio-xpath">props.studioXpath</attribute>
    <attribute name="t-ref">rootRef</attribute>
    <attribute name="t-on-click">onGroupClicked</attribute>
  </xpath>
  <xpath expr="//div[contains(@class,'o_group')]" position="after">
    <StudioHook xpath="props.studioXpath" position="'after'" type="'afterGroup'"/>
  </xpath>
</t>



`);
registerTemplate("web_studio.Form.InnerGroup", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_renderer/form_editor_groups.xml`, `<t t-name="web_studio.Form.InnerGroup" t-inherit="web.Form.InnerGroup" xml:space="preserve">
  <xpath expr="./div" position="attributes">
    <attribute name="t-att-data-studio-xpath">props.studioXpath</attribute>
    <attribute name="t-ref">rootRef</attribute>
    <attribute name="t-on-click">onGroupClicked</attribute>
  </xpath>
  <xpath expr="//div[@t-foreach='getRows()']" position="before">
    <t t-set="studioHooks" t-value="getStudioHooks()"/>
    <StudioHook t-if="studioHooks.has('beforeFirst')" t-props="studioHooks.get('beforeFirst')"/>
  </xpath>

  <xpath expr="//div[@t-foreach='getRows()']" position="inside">
    <StudioHook t-if="studioHooks.has(\`afterRow \${row_index}\`)" t-props="studioHooks.get(\`afterRow \${row_index}\`)"/>
  </xpath>

  <xpath expr="//t[@t-call='web.Form.InnerGroup.ItemComponent']" position="replace">
      <InnerGroupItemComponent t-if="cell.studioIsVisible or viewEditorModel.showInvisible" cell="cell" slots="props.slots"/>
  </xpath>

  <xpath expr="//div[@t-foreach='getRows()']" position="after">
    <StudioHook t-if="studioHooks.has('inside')" t-props="studioHooks.get('inside')"/>
  </xpath>
</t>

`);
registerTemplate("web_studio.Form.InnerGroup.ItemComponent", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_renderer/form_editor_groups.xml`, `<t t-name="web_studio.Form.InnerGroup.ItemComponent" t-inherit="web.Form.InnerGroup.ItemComponent" xml:space="preserve">
  <xpath expr="//div[hasclass('o_wrap_label')]" position="attributes">
    <attribute name="t-ref">labelRef</attribute>
    <attribute name="t-on-click">onClicked</attribute>
    <attribute name="t-att-data-field-name">cell.props.fieldName</attribute>
    <attribute name="t-att-data-studio-xpath">cell.studioXpath</attribute>
    <attribute name="data-studio-structure">field</attribute>
  </xpath>
  <xpath expr="//div[hasclass('o_wrap_field_boolean')]/div[hasclass('o_wrap_label')]" position="attributes">
    <attribute name="t-ref">labelRef</attribute>
    <attribute name="t-on-click">onClicked</attribute>
    <attribute name="t-att-data-field-name">cell.props.fieldName</attribute>
    <attribute name="t-att-data-studio-xpath">cell.studioXpath</attribute>
    <attribute name="data-studio-structure">field</attribute>
  </xpath>
  <xpath expr="//div[hasclass('o_wrap_input')]" position="attributes">
    <attribute name="t-on-click">onClicked</attribute>
    <attribute name="t-ref">fieldRef</attribute>
    <attribute name="t-on-mouseover">onMouseFieldIO</attribute>
    <attribute name="t-on-mouseout">onMouseFieldIO</attribute>
  </xpath>
</t>

`);
registerTemplate("web_studio.Notebook.Hook", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_renderer/form_editor_renderer_components.xml`, `<t t-name="web_studio.Notebook.Hook" t-inherit="web.Notebook" xml:space="preserve">
    <xpath expr="//li[@t-foreach='navItems']" position="attributes">
      <attribute name="t-att-class">{o_web_studio_show_invisible: !navItem[1].studioIsVisible, "o-web-studio-editor--element-clickable": true}</attribute>
      <attribute name="t-on-click">(ev) =&gt; env.config.onNodeClicked(navItem[1].studioXpath)</attribute>
      <attribute name="t-att-data-studio-xpath">navItem[1].studioXpath</attribute>
    </xpath>
    <xpath expr="//li[@t-foreach='navItems']" position="after">
      <li class="nav-item" t-on-click.prevent="onNewPageClicked">
        <a href="#" class="nav-link">
          <i class="fa fa-plus-square"/>
        </a>
      </li>
    </xpath>
    <xpath expr="//div[contains(@class,'tab-pane')]/t[2]" position="after">
      <t t-set="studioHookProps" t-value="props.slots[state.currentPage].studioHookProps"/>
      <StudioHook t-if="studioHookProps" t-props="studioHookProps"/>
    </xpath>
  </t>

  `);
registerTemplate("web_studio.FormViewAddButtonAction", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_renderer/form_editor_renderer_components.xml`, `<t t-name="web_studio.FormViewAddButtonAction" t-inherit="web.StatusBarButtons" xml:space="preserve">
    <xpath expr="//div/t" position="after">
      <div class="mt-2 mb-2">
        <AddButtonAction/>
      </div>
    </xpath>
  </t>

  `);
registerTemplate("web_studio.AddElementHook", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_renderer/form_editor_renderer_components.xml`, `<t t-name="web_studio.AddElementHook" xml:space="preserve">
    <button t-attf-class="o_web_studio_add_element btn btn-secondary d-flex align-items-center justify-content-center text-center bg-secondary text-primary fw-bolder py-3 {{ classNames || '' }}" t-att-data-tooltip="tooltip" t-on-click.stop="onClick" t-out="title"/>
  </t>

  `);
registerTemplate("web_studio.FormLabel", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_renderer/form_editor_renderer_components.xml`, `<t t-name="web_studio.FormLabel" t-inherit="web.FormLabel" xml:space="preserve">
    <xpath expr="./label" position="attributes">
      <attribute name="t-ref">rootRef</attribute>
    </xpath>
  </t>

  `);
registerTemplate("web_studio.ButtonBox", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_renderer/form_editor_renderer_components.xml`, `<t t-name="web_studio.ButtonBox" xml:space="preserve">
    <div class="d-flex justify-content-end my-2">
      <div class="o-form-buttonbox o_menu_item d-flex w-md-auto justify-content-end" t-attf-class="{{this.props.class}}">
        <t t-slot="{{ button_value }}" t-foreach="visibleButtons" t-as="button" t-key="button_value"/>
        <button t-ref="toggleRef" t-if="additionalButtons.length" t-on-click="toggle" type="button" aria-expanded="false" class="o_button_more o-dropdown o-dropdown-caret oe_stat_button btn btn-outline-secondary d-flex justify-content-center align-items-center">
          More
        </button>
      </div>
    </div>
    <div t-if="expanded.value and additionalButtons.length" class="o-form-buttonbox d-flex flex-wrap justify-content-end" t-attf-class="{{this.props.class}}">
      <t t-slot="{{ button_value }}" t-foreach="additionalButtons" t-as="button" t-key="button_value"/>
    </div>
</t>

`);
registerTemplate("web_studio.ViewEditor.FormEditorSidebar", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_sidebar/form_editor_sidebar.xml`, `<t t-name="web_studio.ViewEditor.FormEditorSidebar" xml:space="preserve">
        <InteractiveEditorSidebar>
            <t t-set-slot="new" isDefault="true">
                <ViewStructures structures="constructor.viewStructures"/>
                <NewFields/>
                <ExistingFields resModel="env.viewEditorModel.resModel" fields="env.viewEditorModel.fields" fieldsInArch="env.viewEditorModel.fieldsInArch"/>
            </t>
            <t t-set-slot="view">
                <Property name="'create'" value="getActiveAction('create')" type="'boolean'" onChange.bind="onAttributeChanged">
                    Can Create
                </Property>
                <Property name="'edit'" value="getActiveAction('edit')" type="'boolean'" onChange.bind="onAttributeChanged">
                    Can Edit
                </Property>
                <Property name="'delete'" value="getActiveAction('delete')" type="'boolean'" onChange.bind="onAttributeChanged">
                    Can Delete
                </Property>
                <t t-call="web_studio.ViewEditor.ShowInvisibleToggler"/>
                <SidebarViewToolbox onMore="props.openViewInForm" canEditXml="!env.viewEditorModel.isEditingSubview" openDefaultValues="props.openDefaultValues"/>
            </t>

            <t t-set-slot="properties">
                <Properties propertiesComponents="propertiesComponents"/>
            </t>
        </InteractiveEditorSidebar>
    </t>

`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.Button", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_sidebar/properties/button_properties/button_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.Button" xml:space="preserve">
    <ViewStructureProperties>
        <div class="o_web_studio_sidebar_approval border-bottom border-secondary pb-4 mb-3">
            <ModifiersProperties node="props.node" availableOptions="props.availableOptions"/>
            <div class="d-flex align-items-center mb-1">
                <h6 class="mb-0">Approvals</h6>
                <button class="ms-auto btn btn-custom" title="Open kanban view of approvals" t-on-click="openKanbanApprovalRules">
                    <i class="fs-4 oi oi-view-kanban"/>
                </button>
            </div>
            <t t-if="state.approvalSpec">
                <t t-foreach="state.approvalSpec.rules" t-as="ruleId" t-key="ruleId">
                    <t t-set="rule" t-value="state.allRules[ruleId]"/>
                    <t t-call="web_studio.ViewEditorSidebar.ApprovalRule"/>
                </t>
            </t>
            <div>
                <a href="#" role="button" class="o_web_studio_sidebar_btn_link" name="create_approval_rule" t-on-click="createApprovalRule">
                    <i class="fa fa-plus me-2" aria-hidden="true"/>Add an approval step
                </a>
            </div>
        </div>
        <t t-if="showRainbowMan">
            <RainbowEffect effect="this.props.node.attrs.effect" onChange.bind="onChangeAttribute"/>
        </t>
        <Property name="'string'" type="'string'" value="this.props.node.attrs.string" onChange.bind="onChangeAttribute">
            Label
        </Property>
        <ClassAttribute value="this.props.node.attrs.class" onChange.bind="onChangeAttribute"/>
    </ViewStructureProperties>
</t>

`);
registerTemplate("web_studio.ViewEditorSidebar.ApprovalRule", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_sidebar/properties/button_properties/button_properties.xml`, `<div t-name="web_studio.ViewEditorSidebar.ApprovalRule" class="o_studio_sidebar_approval_rule position-relative border-start border-secondary ps-2 mb-3" xml:space="preserve">
    <Record t-props="recordProps" onRecordChanged="(r, c) =&gt; this.onChangeApprovalRecord(r, c, rule.id)" values="rule" t-slot-scope="data">
        <t t-set="record" t-value="data.record"/>
        <div>
            <div>
                <div class="d-flex">
                    <label t-attf-for="rule_responsible_{{rule.id}}">
                        Approvers
                        <sup class="text-info p-1" data-tooltip="These users are able to approve or reject the step and will be assigned to an activity when their approval is requested." t-esc="'?'"/>
                    </label>
                    <div class="ms-auto">
                        <button t-attf-class="btn btn-sm btn-dark o_approval_domain {{rule.domain ? '' : 'opacity-50'}}" t-att-data-tooltip="rule.domain ? 'Edit rule condition' : 'Set condition on rule'" t-on-click="() =&gt; this.onApprovalSelectDomain(rule.id)">
                                <i class="fa fa-fw fa-filter"/>
                        </button>
                        <button class="btn btn-sm btn-dark o_approval_archive opacity-50" data-tooltip="Remove rule" t-on-click="() =&gt; this.onApprovalArchive(rule.id)">
                            <i class="fa fa-fw fa-trash"/>
                        </button>
                    </div>
                </div>
                <div class="o_field_widget o_field_many2one o_web_studio_sidebar_tags" t-attf-class="{{ !isValid('approver_ids', record) ? 'border border-danger' : ''}}" name="approver_ids">
                    <Many2ManyTagsField id="'approver_ids'" name="'approver_ids'" record="data.record" canCreate="false" canQuickCreate="false" canCreateEdit="false" domain="domainResUsers"/>
                </div>
            </div>
            <label t-attf-for="rule_group_{{rule.id}}">
                Approver Group
                <sup class="text-info p-1" data-tooltip="The users in this group are able to approve or reject the step." t-esc="'?'"/>
            </label>
            <div class="o_approval_group">
                <div class="o_field_widget o_field_many2one" name="approval_group_ids" t-attf-class="{{ !isValid('approval_group_id', record) ? 'border border-danger' : ''}}">
                    <Many2OneField id="'approval_group_id'" name="'approval_group_id'" record="data.record" canOpen="false" canCreate="false" canQuickCreate="false" canCreateEdit="false" domain="domainResUsers"/>
                </div>
            </div>
        </div>
        <div class="o_web_studio_sidebar_tags">
            <div>
                <label t-attf-for="users_to_notify_{{rule.id}}">
                    Users to Notify
                    <sup class="text-info p-1" data-tooltip="These users will receive a notification via internal note when the step is approved or rejected" t-esc="'?'"/>
                </label>
                <div class="o_field_widget o_field_many2one" name="users_to_notify">
                    <Many2ManyTagsField id="'users_to_notify'" name="'users_to_notify'" record="data.record"/>
                </div>
            </div>
        </div>
        <div class="o_web_studio_sidebar_text">
            <label t-attf-for="approval_message_{{rule.id}}">
                Description
                <sup class="text-info p-1" data-tooltip="The step description will be displayed on the button on which an approval is requested." t-esc="'?'"/>
            </label>
            <input t-attf-id="approval_message_{{rule.id}}" t-attf-name="approval_message_{{rule.id}}" type="text" t-att-value="rule.message || null" t-on-change="(ev) =&gt; this.onApprovalEdit('operation_approval_message', rule.id, ev.target.value)"/>
        </div>
        <div class="d-flex">
            <div class="o_web_studio_sidebar_text">
                <label t-attf-for="notification_order{{rule.id}}">
                    Approval Order
                    <sup class="text-info p-1" data-tooltip="Defines the sequential order in which the approvals are requested." t-esc="'?'"/>
                </label>
                <select t-attf-id="notification_order{{rule.id}}" t-on-change="(ev) =&gt; this.onChangeNotificationOrder(ev, rule.id)" class="form-select">
                    <option t-att-selected="!rule.notification_order || rule.notification_order === '1'">1</option>
                    <option t-att-selected="rule.notification_order === '2'">2</option>
                    <option t-att-selected="rule.notification_order === '3'">3</option>
                    <option t-att-selected="rule.notification_order === '4'">4</option>
                    <option t-att-selected="rule.notification_order === '5'">5</option>
                    <option t-att-selected="rule.notification_order === '6'">6</option>
                    <option t-att-selected="rule.notification_order === '7'">7</option>
                    <option t-att-selected="rule.notification_order === '8'">8</option>
                    <option t-att-selected="rule.notification_order === '9'">9</option>
                </select>
            </div>
            <div class="o_web_studio_sidebar_checkbox align-self-end ms-2" name="">
                <div data-tooltip="The user who approves this step will not be able to approve other steps for the same record.">
                    <CheckBox value="rule.exclusive_user" onChange="(value) =&gt; this.onApprovalEdit('operation_different_users', rule.id, value)" id="'exclusive_user_' + rule.id">
                        Exclusive Approval
                    </CheckBox>
                </div>
            </div>
        </div>
    </Record>
</div>

`);
registerTemplate("web_studio.NewButtonBoxDialog", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_sidebar/properties/button_properties/new_button_box_dialog.xml`, `<t t-name="web_studio.NewButtonBoxDialog" xml:space="preserve">
    <Dialog size="'sm'" title.translate="Add a Button" contentClass="'o_web_studio_new_button_dialog'">
        <div>
            <label>Label</label>
            <input class="o_input" name="string" type="text" placeholder="My Button" t-on-change="(ev) =&gt; this.text = ev.target.value"/>
        </div>
        <div>
            <label>Icon</label>
            <FontAwesomeIconSelector value="this.state.icon" onSelect="(value) =&gt; this.state.icon = value">
                <i t-att-class="this.state.icon"/>
            </FontAwesomeIconSelector>
        </div>
        <div>
            <label>Select a related field</label>
            <Many2XAutocomplete value="this.state.field?.display_name" resModel="'ir.model.fields'" fieldString.translate="Field" update.bind="update" activeActions="{}" getDomain.bind="getDomain" isToMany="false"/>
        </div>
        <t t-set-slot="footer">
            <button t-attf-class="btn btn-primary" t-on-click.stop="onConfirm">Confirm</button>
            <button class="btn btn-secondary" t-on-click.stop="props.close">Cancel</button>
        </t>
    </Dialog>
</t>

`);
registerTemplate("web_studio.ViewEditorSidebar.RainbowEffect", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_sidebar/properties/button_properties/rainbow_effect.xml`, `<t t-name="web_studio.ViewEditorSidebar.RainbowEffect" xml:space="preserve">
        <h6>Rainbow Man</h6>
        <Property name="'effect'" type="'boolean'" value="this.props.effect and this.props.effect !== 'False'" onChange.bind="toggleRainbowMan">
            Rainbow Effect
        </Property>
        <t t-if="rainbowEffect">
            <div class="o_web_studio_sidebar_text">
                <label for="rainbow_message">Message</label>
                <input id="rainbow_message" name="rainbow_message" type="text" t-att-value="rainbowEffect.message or 'Well Done!'" t-on-change="(ev) =&gt; this.onRainbowEffectChange('message', ev.target.value)"/>
            </div>
            <div t-if="rainbowEffect.fadeout" class="o_web_studio_sidebar_select">
                <label for="rainbow_fadeout">Fadeout Speed</label>
                <SelectMenu class="'border-0'" value="rainbowEffect.fadeout" choices="choices" onSelect="(value) =&gt; this.onRainbowEffectChange('fadeout', value)" searchable="false"/>
            </div>
            <div class="text-center">
                <FileInput acceptedFileExtensions="'image/*'" onUpload="(res) =&gt; this.onRainbowEffectChange('img_url', '/web/content/' + res[0].id)" resId="user.userId" resModel="'res.users'">
                    <div class="mt-3 mb8 ml64 mr64">
                        <img t-att-src="rainbowEffect.img_url or '/web/static/img/smile.svg'" class="img img-fluid cursor-pointer" alt="Great !"/>
                    </div>
                    <button class="btn btn-secondary m-1"><i class="fa fa-upload"/> Change Image</button>
                </FileInput>
                <button t-if="rainbowEffect.img_url" class="btn btn-secondary m-1" t-on-click="() =&gt; this.onRainbowEffectChange('img_url', false)"><i class="fa fa-undo"/> Reset Image</button>
            </div>
        </t>
    </t>
`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.Chatter", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_sidebar/properties/chatter_properties/chatter_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.Chatter" xml:space="preserve">
    <Property name="'email_alias'" type="'string'" value="state.mailAlias" onChange.bind="onChangeMailAlias">
            Email Alias
    </Property>
    <div class="input-group-text">
        <t t-if="state.aliasDomain" t-esc="'@' + state.aliasDomain"/>
        <t t-else=""> domain not defined </t>
    </div>
    <div t-if="state.mailAlias and state.aliasDomain" class="mt8">
        Send a <a t-att-href="'mailto:' + state.mailAlias + '@' + state.aliasDomain + '?subject=test'">test email</a>.
    </div>
    <SidebarPropertiesToolbox/>
</t>

`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.Group", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_sidebar/properties/group_properties/group_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.Group" xml:space="preserve">
        <ViewStructureProperties>
            <ModifiersProperties node="props.node" availableOptions="['invisible']"/>
            <Property name="'string'" type="'string'" value="props.node.attrs.string" onChange.bind="onChangeAttribute">
                    Label
            </Property>
        </ViewStructureProperties>
    </t>

`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.Label", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_sidebar/properties/label_properties/label_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.Label" xml:space="preserve">
    <Property name="'string'" type="'string'" value="this.props.node.attrs.string" onChange.bind="onChangeAttribute">
        <t t-esc="'Label'"/>
    </Property>
    <SidebarPropertiesToolbox/>
</t>

`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.OTdLabelProperties", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_sidebar/properties/o_td_label_properties/o_td_label_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.OTdLabelProperties" xml:space="preserve">
    <SidebarPropertiesToolbox/>
</t>

`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.Page", `/web_studio/static/src/client_action/view_editor/editors/form/form_editor_sidebar/properties/page_properties/page_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.Page" xml:space="preserve">
    <ModifiersProperties node="props.node" availableOptions="['invisible']"/>

    <Property name="'string'" type="'string'" value="props.node.attrs.string" onChange.bind="onChangeAttribute">
            Label
    </Property>

    <LimitGroupVisibility node="props.node"/>
    <PageNodeToolbox/>
</t>

`);
registerTemplate("web_studio.ViewEditor.GanttEditorSidebar", `/web_studio/static/src/client_action/view_editor/editors/gantt/gantt_editor_sidebar.xml`, `<t t-name="web_studio.ViewEditor.GanttEditorSidebar" xml:space="preserve">
        <InteractiveEditorSidebar>
            <t t-set-slot="view">
                <Property name="'create'" value="modelParams.canCreate === true" type="'boolean'" onChange.bind="onViewAttributeChanged">
                    Can Create
                </Property>
                <Property name="'edit'" value="modelParams.canEdit === true" type="'boolean'" onChange.bind="onViewAttributeChanged">
                    Can Edit
                </Property>
                <Property name="'display_unavailability'" value="modelParams.displayUnavailability === true" type="'boolean'" onChange.bind="onViewAttributeChanged">
                    Display Unavailability
                </Property>
                <Property name="'total_row'" value="modelParams.displayTotalRow === true" type="'boolean'" onChange.bind="onViewAttributeChanged">
                    Display Total row
                </Property>
                <Property name="'date_start'" type="'selection'" value="modelParams.dateStartField" childProps="{ choices: fieldsDateChoices }" onChange.bind="onViewAttributeChanged">
                    Start Date Field
                </Property>
                <Property name="'date_stop'" type="'selection'" value="modelParams.dateStopField" childProps="{ choices: fieldsDateChoices }" onChange.bind="onViewAttributeChanged">
                    Stop Date Field
                </Property>
                <Property name="'string'" type="'string'" value="modelParams.string" onChange.bind="onViewAttributeChanged">
                    Label
                </Property>
                <Property name="'default_group_by'" type="'selection'" value="modelParams.defaultGroupBy" childProps="{ choices: fieldsChoices, multiSelect: true }" onChange.bind="onDefaultGroupByChanged">
                    Default Group by
                </Property>
                <Property name="'display_mode'" type="'selection'" value="modelParams.displayMode" childProps="{ choices: displayModeChoices }" onChange.bind="onViewAttributeChanged">
                    Display Mode
                </Property>
                <Property name="'default_scale'" type="'selection'" value="modelParams.defaultScale" childProps="{ choices: defaultScalesChoices }" onChange.bind="onViewAttributeChanged">
                    Default Scale
                </Property>
                <Property name="'color'" type="'selection'" value="modelParams.colorField" childProps="{ choices: colorChoices }" onChange.bind="onViewAttributeChanged">
                    Color
                </Property>
                <Property name="'precision_day'" type="'selection'" value="currentDayPrecision" childProps="{ choices: dayPrecisionChoices }" onChange.bind="(value) =&gt; this.onPrecisionChanged(value, 'day')">
                    Day Precision
                </Property>
                <Property name="'precision_week'" type="'selection'" value="currentWeekPrecision" childProps="{ choices: weekAndMonthPrecisionChoices }" onChange.bind="(value) =&gt; this.onPrecisionChanged(value, 'week')">
                    Week Precision
                </Property>
                <Property name="'precision_month'" type="'selection'" value="currentMonthPrecision" childProps="{ choices: weekAndMonthPrecisionChoices }" onChange.bind="(value) =&gt; this.onPrecisionChanged(value, 'month')">
                    Month Precision
                </Property>

                <SidebarViewToolbox onMore="props.openViewInForm" canEditXml="!viewEditorModel.isEditingSubview" openDefaultValues="props.openDefaultValues"/>
            </t>
        </InteractiveEditorSidebar>
    </t>

`);
registerTemplate("web_studio.ViewEditor.GraphEditorSidebar", `/web_studio/static/src/client_action/view_editor/editors/graph/graph_editor_sidebar.xml`, `<t t-name="web_studio.ViewEditor.GraphEditorSidebar" xml:space="preserve">
        <InteractiveEditorSidebar>
            <t t-set-slot="view">
                <Property name="'type'" type="'selection'" value="modelParams.mode" childProps="{ choices: this.typeChoices }" onChange.bind="onViewAttributeChanged">
                    Type
                </Property>

                <Property t-if="modelParams.mode !== 'pie'" name="'order'" type="'selection'" value="modelParams.order" childProps="{ choices: this.orderChoices, required: false }" onChange.bind="onViewAttributeChanged">
                    Sorting
                </Property>


                <Property t-if="modelParams.mode !== 'line'" name="'disable_linking'" type="'boolean'" value="!modelParams.disableLinking" onChange.bind="(value, name) =&gt; this.onViewAttributeChanged(!value, name)">
                    Access records from graph
                </Property>

                <Property t-if="modelParams.mode === 'bar'" name="'stacked'" type="'boolean'" value="modelParams.stacked" onChange.bind="this.onViewAttributeChanged">
                    Stacked graph
                </Property>

                <Property name="'first_groupby'" type="'selection'" value="modelParams.groupBy[0]" childProps="{ choices: this.firstGroupbyChoices, required: false }" onChange="(value) =&gt; this.onGroupByChanged('col', value, this.oldFieldValues.firstDimension)">
                    First dimension
                </Property>

                <Property name="'second_groupby'" type="'selection'" value="modelParams.groupBy[1]" childProps="{ choices: this.secondGroupbyChoices, required: false }" onChange="(value) =&gt; this.onGroupByChanged('col', value, this.oldFieldValues.secondDimension)">
                    Second dimension
                </Property>

                <Property name="'measure'" type="'selection'" value="modelParams.measure" childProps="{ choices: this.mesureChoices, required: false }" onChange.bind="(value) =&gt; this.onGroupByChanged('measure', value, this.oldFieldValues.measure)">
                    Measure
                </Property>

                <SidebarViewToolbox onMore="props.openViewInForm" canEditXml="!viewEditorModel.isEditingSubview" openDefaultValues="props.openDefaultValues"/>
            </t>
        </InteractiveEditorSidebar>
    </t>

`);
registerTemplate("web_studio.SafeKanbanRecord", `/web_studio/static/src/client_action/view_editor/editors/kanban/kanban_editor_record.xml`, `<t t-name="web_studio.SafeKanbanRecord" t-inherit="web.KanbanRecord" xml:space="preserve">
  <xpath expr="//article" position="attributes">
    <attribute name="t-if">!safe.hasError</attribute>
  </xpath>
  <xpath expr="//article" position="after">
    <div t-else="">Preview is not available</div>
  </xpath>
</t>

`);
registerTemplate("web_studio.SafeKanbanRecordMenu", `/web_studio/static/src/client_action/view_editor/editors/kanban/kanban_editor_record.xml`, `<t t-name="web_studio.SafeKanbanRecordMenu" t-inherit="web.KanbanRecordMenu" xml:space="preserve">

 <xpath expr="//div" position="replace">
    <div t-if="showMenu" class="o_dropdown_kanban bg-transparent position-absolute end-0 top-0 w-auto o-web-studio-editor--element-clickable" t-att-studioxpath="dropdownXpath">
      <span class="fa fa-ellipsis-v p-2"/>
    </div>
    <div class="o_web_studio_hook m-1 position-absolute top-0 end-0 pe-none w-0" style="height: 50px;" data-type="t" data-position="after" data-structures="t,kanban_colorpicker"/>
  </xpath>
</t>

`);
registerTemplate("web_studio.KanbanEditorHeader", `/web_studio/static/src/client_action/view_editor/editors/kanban/kanban_editor_renderer.xml`, `<t t-name="web_studio.KanbanEditorHeader" t-inherit="web.KanbanHeader" xml:space="preserve">
  <xpath expr="//div" position="attributes">
    <attribute name="class" add="pe-none" separator=" "/>
  </xpath>
  <xpath expr="//t[@t-if='env.isSmall or !group.isFolded']" position="replace"/>
</t>

`);
registerTemplate("web_studio.KanbanEditorRenderer", `/web_studio/static/src/client_action/view_editor/editors/kanban/kanban_editor_renderer.xml`, `<t t-name="web_studio.KanbanEditorRenderer" t-inherit="web.KanbanRenderer" xml:space="preserve">

  <xpath expr="//div[contains(@class, 'o_kanban_ghost')]" position="before">
    <t t-call="web_studio.KanbanEditorRenderer.KanbanDemoRecords">
      <t t-set="demoAmount" t-value="6"/>
    </t>
  </xpath>


  <xpath expr="//div[contains(@class, 'o_kanban_group')]" position="after">
    <t t-set="demoAmount" t-value="7"/>
    <div class="o_kanban_group flex-shrink-0 flex-grow-1 flex-md-grow-0 opacity-50">
      <div class="o_kanban_header my-3 user-select-none" style="filter: blur(5px)">
        <h4>Group</h4>
        <div t-if="props.progressBarState" class="o_kanban_counter d-flex justify-content-between align-items-center">
          <div class="o_column_progress progress bg-300 w-50"/>
          <b t-out="demoAmount"/>
        </div>
      </div>
      <t t-call="web_studio.KanbanEditorRenderer.KanbanDemoRecords">
        <t t-set="additionalClass" t-value="'border-top-0'"/>
      </t>
    </div>
  </xpath>
  <xpath expr="//t[@t-foreach='group.list.records']" position="inside">
    <t t-call="web_studio.KanbanEditorRenderer.KanbanDemoRecords">
      <t t-set="demoAmount" t-value="6"/>
      <t t-set="additionalClass" t-value="'border-top-0'"/>
    </t>
  </xpath>
</t>

`);
registerTemplate("web_studio.KanbanEditorRenderer.KanbanDemoRecords", `/web_studio/static/src/client_action/view_editor/editors/kanban/kanban_editor_renderer.xml`, `<t t-name="web_studio.KanbanEditorRenderer.KanbanDemoRecords" xml:space="preserve">
  <div t-foreach="new Array(demoAmount)" t-as="d" t-key="d_index" class="o_kanban_record o_kanban_demo opacity-50 d-flex flex-grow-1 flex-md-shrink-1 flex-shrink-0" t-attf-class="{{ additionalClass }}">
      <div class="flex-grow-1"/>
  </div>
</t>

`);
registerTemplate("web_studio.ViewEditor.KanbanEditorSidebar", `/web_studio/static/src/client_action/view_editor/editors/kanban/kanban_editor_sidebar/kanban_editor_sidebar.xml`, `<t t-name="web_studio.ViewEditor.KanbanEditorSidebar" xml:space="preserve">
        <InteractiveEditorSidebar>
            <t t-set-slot="new">
                <ViewStructures structures="constructor.viewStructures"/>
                <ExistingFields resModel="env.viewEditorModel.resModel" fields="env.viewEditorModel.fields" fieldsInArch="viewEditorModel.fieldsInArch" folded="false"/>
            </t>
            <t t-set-slot="view" isDefault="true">
                <Property name="'create'" type="'boolean'" value="archInfo.activeActions.create === true" onChange.bind="editAttribute">
                    Can Create
                </Property>
                <Property name="'quick_create'" type="'boolean'" value="archInfo.activeActions.quickCreate === true" onChange.bind="editAttribute">
                    Quick Create
                </Property>
                <Property name="'sort_by'" type="'selection'" value="defaultOrder.name or null" onChange.bind="setSortBy" childProps="{ choices: sortChoices, required: false }">
                    Sort By
                </Property>
                <Property t-if="defaultOrder.name" name="'sort_order'" type="'selection'" value="defaultOrder.asc ? 'asc' : 'desc'" onChange.bind="setOrder" childProps="{ choices: orderChoices }">
                    Order
                </Property>
                <t t-call="web_studio.ViewEditor.ShowInvisibleToggler"/>
                <Property name="'can_open'" type="'boolean'" value="archInfo.canOpenRecords !== false" onChange.bind="editAttribute">
                    Open Record On Click
                </Property>
                <Property name="'highlight_color'" type="'selection'" value="archInfo.cardColorField or null" childProps="colorField" onChange.bind="editColor">
                    Highlight Color Field
                </Property>
                <Property name="'default_group_by'" type="'selection'" value="archInfo.defaultGroupBy or null" childProps="defaultGroupBy" onChange.bind="editDefaultGroupBy">
                    Default Group By
                </Property>
                <SidebarViewToolbox onMore="props.openViewInForm" canEditXml="!env.viewEditorModel.isEditingSubview" openDefaultValues="props.openDefaultValues"/>
            </t>
            <t t-set-slot="properties">
                <Properties propertiesComponents="propertiesComponents"/>
            </t>
        </InteractiveEditorSidebar>
    </t>

`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.Aside", `/web_studio/static/src/client_action/view_editor/editors/kanban/kanban_editor_sidebar/properties/aside_properties/aside_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.Aside" xml:space="preserve">
    <ViewStructureProperties>
        <ClassAttribute value="props.node.attrs.class" onChange.bind="onChangeAttribute"/>
        <Property name="'style'" type="'string'" value="props.node.attrs.style" onChange.bind="onChangeAttribute">
                CSS style
        </Property>
    </ViewStructureProperties>
</t>

`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.Div", `/web_studio/static/src/client_action/view_editor/editors/kanban/kanban_editor_sidebar/properties/div_properties/div_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.Div" xml:space="preserve">
    <ViewStructureProperties>
        <ClassAttribute value="this.props.node.attrs.class" onChange.bind="onChangeAttribute"/>
        <ModifiersProperties node="props.node" availableOptions="['invisible']"/>
        <Property name="'style'" type="'string'" value="props.node.attrs.style" onChange.bind="onChangeAttribute">
                CSS style
        </Property>
    </ViewStructureProperties>
</t>

`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.Footer", `/web_studio/static/src/client_action/view_editor/editors/kanban/kanban_editor_sidebar/properties/footer_properties/footer_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.Footer" xml:space="preserve">
    <ViewStructureProperties>
        <ClassAttribute value="this.props.node.attrs.class" onChange.bind="onChangeAttribute"/>
        <Property name="'style'" type="'string'" value="props.node.attrs.style" onChange.bind="onChangeAttribute">
                CSS style
        </Property>
    </ViewStructureProperties>
</t>

`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.KanbanButton", `/web_studio/static/src/client_action/view_editor/editors/kanban/kanban_editor_sidebar/properties/kanban_button_properties/kanban_button_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.KanbanButton" xml:space="preserve">
    <ModifiersProperties node="props.node" availableOptions="['invisible']"/>
    <ClassAttribute value="props.node.attrs.class" onChange.bind="onChangeAttribute"/>
    <Property name="'name'" type="'string'" value="props.node.attrs.name" onChange.bind="onChangeAttribute">
            Method
    </Property>
    <LimitGroupVisibility node="props.node"/>
    <SidebarPropertiesToolbox/>
</t>`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.Menu", `/web_studio/static/src/client_action/view_editor/editors/kanban/kanban_editor_sidebar/properties/menu_properties/menu_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.Menu" xml:space="preserve">
    <button t-if="colorPicker" class="btn btn-secondary o_web_studio_component o_web_studio_icon_container position-relative o_web_studio_field_color_picker w-100 py-0" t-on-click="editColorPicker">Edit Color Picker</button>
    <SidebarPropertiesToolbox/>
</t>

`);
registerTemplate("web_studio.SafeKanbanRecordLegacy", `/web_studio/static/src/client_action/view_editor/editors/kanban_legacy/kanban_editor_record_legacy.xml`, `<t t-name="web_studio.SafeKanbanRecordLegacy" t-inherit="web.KanbanRecord" xml:space="preserve">
  <xpath expr="//t[@t-call]" position="attributes">
    <attribute name="t-if">!safe.hasError</attribute>
  </xpath>
  <xpath expr="//t[@t-call]" position="after">
    <div t-else="">Preview is not available</div>
  </xpath>
</t>

`);
registerTemplate("web_studio.SafeKanbanRecordLegacyMenu", `/web_studio/static/src/client_action/view_editor/editors/kanban_legacy/kanban_editor_record_legacy.xml`, `<t t-name="web_studio.SafeKanbanRecordLegacyMenu" t-inherit="web.KanbanRecordMenu" xml:space="preserve">
  <xpath expr="//Dropdown" position="attributes">
    <attribute name="studioXpath">dropdownXpath</attribute>
    <attribute name="hasCoverSetter">dropdownHasCoverSetter</attribute>
  </xpath>
</t>

`);
registerTemplate("web_studio.KanbanEditorRecord.Dropdown", `/web_studio/static/src/client_action/view_editor/editors/kanban_legacy/kanban_editor_record_legacy.xml`, `<t t-name="web_studio.KanbanEditorRecord.Dropdown" xml:space="preserve">
  <div t-ref="root" t-on-click="() =&gt; this.handleClick()">
    <t t-slot="default"/>
  </div>
</t>

`);
registerTemplate("web_studio.KanbanEditorRecord.AvatarPlaceholder", `/web_studio/static/src/client_action/view_editor/editors/kanban_legacy/kanban_editor_record_legacy.xml`, `<t t-name="web_studio.KanbanEditorRecord.AvatarPlaceholder" xml:space="preserve">
  <div class="oe_kanban_bottom_right">
    <span class="oe_kanban_avatar">
        <i class="fa fa-user"/>
    </span>
  </div>
</t>

`);
registerTemplate("web_studio.KanbanEditorRendererLegacy", `/web_studio/static/src/client_action/view_editor/editors/kanban_legacy/kanban_editor_renderer_legacy.xml`, `<t t-name="web_studio.KanbanEditorRendererLegacy" t-inherit="web.KanbanRenderer" xml:space="preserve">
  <xpath expr="//KanbanHeader" position="replace"/>


  <xpath expr="//div[contains(@class, 'o_kanban_ghost')]" position="before">
    <t t-call="web_studio.KanbanEditorRenderer.KanbanDemoRecordsLegacy">
      <t t-set="demoAmount" t-value="6"/>
    </t>
  </xpath>


  <xpath expr="//div[contains(@class, 'o_kanban_group')]" position="after">
    <div class="o_kanban_group flex-shrink-0 flex-grow-1 flex-md-grow-0">
      <div class="o_kanban_header top-0 py-3"/>
      <t t-call="web_studio.KanbanEditorRenderer.KanbanDemoRecordsLegacy">
        <t t-set="demoAmount" t-value="7"/>
        <t t-set="additionalClass" t-value="'mt-2'"/>
      </t>
    </div>
  </xpath>
  <xpath expr="//t[@t-foreach='group.list.records']" position="inside">
    <t t-call="web_studio.KanbanEditorRenderer.KanbanDemoRecordsLegacy">
      <t t-set="demoAmount" t-value="6"/>
      <t t-set="additionalClass" t-value="'mt-2'"/>
    </t>
  </xpath>
</t>

`);
registerTemplate("web_studio.KanbanEditorRenderer.KanbanDemoRecordsLegacy", `/web_studio/static/src/client_action/view_editor/editors/kanban_legacy/kanban_editor_renderer_legacy.xml`, `<t t-name="web_studio.KanbanEditorRenderer.KanbanDemoRecordsLegacy" xml:space="preserve">
  <div t-foreach="new Array(demoAmount)" t-as="d" t-key="d_index" class="o_kanban_record o_kanban_demo opacity-50 d-flex flex-grow-1 flex-md-shrink-1 flex-shrink-0" t-attf-class="{{ additionalClass }}">
      <div class="flex-grow-1"/>
  </div>
</t>

`);
registerTemplate("web_studio.ViewEditor.KanbanEditorSidebarLegacy", `/web_studio/static/src/client_action/view_editor/editors/kanban_legacy/kanban_editor_sidebar_legacy/kanban_editor_sidebar_legacy.xml`, `<t t-name="web_studio.ViewEditor.KanbanEditorSidebarLegacy" xml:space="preserve">
        <InteractiveEditorSidebar>
            <t t-set-slot="new">
                <ExistingFields fields="env.viewEditorModel.fields" fieldsInArch="kanbanFieldsInArch" folded="false"/>
            </t>
            <t t-set-slot="view" isDefault="true">
                <Property name="'create'" type="'boolean'" value="archInfo.activeActions.create === true" onChange.bind="editAttribute">
                    Can Create
                </Property>
                <Property name="'quick_create'" type="'boolean'" value="archInfo.activeActions.quickCreate === true" onChange.bind="editAttribute">
                    Quick Create
                </Property>
                <Property name="'sort_by'" type="'selection'" value="defaultOrder.name or null" onChange.bind="setSortBy" childProps="{ choices: sortChoices, required: false }">
                    Sort By
                </Property>
                <Property t-if="defaultOrder.name" name="'sort_order'" type="'selection'" value="defaultOrder.asc ? 'asc' : 'desc'" onChange.bind="setOrder" childProps="{ choices: orderChoices }">
                    Order
                </Property>
                <t t-call="web_studio.ViewEditor.ShowInvisibleToggler"/>
                <Property name="'default_group_by'" type="'selection'" value="archInfo.defaultGroupBy or null" childProps="defaultGroupBy" onChange.bind="editDefaultGroupBy">
                    Default Group By
                </Property>
                <SidebarViewToolbox onMore="props.openViewInForm" canEditXml="!env.viewEditorModel.isEditingSubview" openDefaultValues="props.openDefaultValues"/>
            </t>

            <t t-set-slot="properties">
                <Properties propertiesComponents="propertiesComponents"/>
            </t>
        </InteractiveEditorSidebar>
    </t>

`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.KanbanCoverProperties", `/web_studio/static/src/client_action/view_editor/editors/kanban_legacy/kanban_editor_sidebar_legacy/properties/kanban_cover_properties/kanban_cover_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.KanbanCoverProperties" xml:space="preserve">
    <Property name="'cover_value'" type="'boolean'" value="coverValue" onChange.bind="onChangeCover">
        Set Cover Image
    </Property>
    <SidebarPropertiesToolbox/>
</t>

`);
registerTemplate("web_studio.ListEditorRenderer", `/web_studio/static/src/client_action/view_editor/editors/list/list_editor_renderer.xml`, `<t t-name="web_studio.ListEditorRenderer" t-inherit="web.ListRenderer" xml:space="preserve">

    <xpath expr="//*[@t-ref='table']" position="before">
      <div class="d-flex justify-content-between mt-2 mb-2">
        <div class="d-flex align-items-center align-content-around flex-wrap gap-1">
          <t t-foreach="props.archInfo.headerButtons" t-as="button" t-key="button.id">
            <button class="btn btn-secondary o-web-studio-editor--element-clickable" t-att-studioxpath="button.studioXpath" t-att-data-studio-xpath="button.studioXpath" t-att-data-tooltip-template="this.env.debug ? 'views.ViewButtonTooltip' : false" t-att-data-tooltip-info="this.env.debug ? makeTooltipButton(button) : false" data-tooltip-delay="1000" t-on-click="() =&gt; this.env.config.onNodeClicked(button.studioXpath)">
              <t t-esc="button.string"/>
            </button>
          </t>
          <AddButtonAction/>
        </div>
      </div>
    </xpath>

    <xpath expr="//*[@t-ref='table']" position="attributes">
      <attribute name="t-on-click.capture">onTableClicked</attribute>
      <attribute name="t-on-mouseover">onTableHover</attribute>
      <attribute name="t-on-mouseout">onTableHover</attribute>
    </xpath>

    <xpath expr="//thead[1]" position="attributes">
      <attribute name="t-ref">tableHead</attribute>
    </xpath>

    <xpath expr="//*[contains(@class, 'o_optional_columns_dropdown_toggle')]" position="attributes">
      <attribute name="class" add="text-muted" separator=" "/>
    </xpath>

    <xpath expr="//thead//t[@t-foreach]//*[@t-else][1]" position="before">
      <t t-elif="column.type === 'studio_hook'">
        <t t-call="web_studio.ListEditor.StudioHook">
          <t t-set="column" t-value="column"/>
          <t t-set="isHeader" t-value="true"/>
        </t>
      </t>
    </xpath>

    <xpath expr="//thead//t[@t-foreach]/th[1]" position="attributes">
      <attribute name="t-att-data-studio-xpath">column.studioXpath</attribute>
      <attribute name="class" add="o-draggable" separator=" "/>
    </xpath>

    <xpath expr="//thead//t[@t-foreach]/th[2]" position="attributes">
      <attribute name="t-att-data-studio-xpath">column.studioXpath</attribute>
    </xpath>
  </t>

  `);
registerTemplate("web_studio.ListEditorRenderer.RecordRow", `/web_studio/static/src/client_action/view_editor/editors/list/list_editor_renderer.xml`, `<t t-name="web_studio.ListEditorRenderer.RecordRow" t-inherit="web.ListRenderer.RecordRow" xml:space="preserve">
    <xpath expr="//t[@t-foreach]" position="inside">
      <t t-if="column.type === 'studio_hook'">
        <t t-call="web_studio.ListEditor.StudioHook">
          <t t-set="column" t-value="column"/>
        </t>
      </t>
    </xpath>

    <xpath expr="(//t[@t-foreach]//td)[1]" position="attributes">
      <attribute name="t-att-data-studio-xpath">column.studioXpath</attribute>
    </xpath>

    <xpath expr="(//t[@t-foreach]//td)[2]" position="attributes">
      <attribute name="data-button-group">1</attribute>
      <attribute name="t-att-data-studio-xpath">column.studioXpath</attribute>
    </xpath>

    <xpath expr="//t[@t-if='hasOpenFormViewColumn']" position="attributes">
      <attribute name="t-if">props.archInfo.openFormView</attribute>
    </xpath>

    <xpath expr="//button[@name='Open in form view']" position="attributes">
      <attribute name="class" add="disabled" separator=" "/>
    </xpath>
  </t>

  `);
registerTemplate("web_studio.ListEditor.StudioHook", `/web_studio/static/src/client_action/view_editor/editors/list/list_editor_renderer.xml`, `<t t-name="web_studio.ListEditor.StudioHook" xml:space="preserve">
    <t t-tag="isHeader ? 'th' : 'td'" t-att-data-xpath="column.xpath" t-att-data-position="column.position" class="o_web_studio_hook" t-attf-class="{{ !isHeader ? 'border-bottom-0' : ''}}">
      <i t-if="isHeader" class="fa fa-plus"/>
    </t>
  </t>

`);
registerTemplate("web_studio.ViewEditor.ListEditorSidebar", `/web_studio/static/src/client_action/view_editor/editors/list/list_editor_sidebar/list_editor_sidebar.xml`, `<t t-name="web_studio.ViewEditor.ListEditorSidebar" xml:space="preserve">
        <InteractiveEditorSidebar>
            <t t-set-slot="new" isDefault="true">
                <NewFields/>
                <ExistingFields resModel="viewEditorModel.resModel" fields="viewEditorModel.fields" fieldsInArch="viewEditorModel.fieldsInArch"/>
            </t>
            <t t-set-slot="view">
                <Property name="'create'" type="'boolean'" value="archInfo.activeActions.create === true" onChange.bind="onAttributeChanged">
                    Can Create
                </Property>
                <Property name="'edit'" type="'boolean'" value="archInfo.activeActions.edit === true" onChange.bind="onAttributeChanged">
                    Can Edit
                </Property>
                <Property name="'delete'" type="'boolean'" value="archInfo.activeActions.delete === true" onChange.bind="onAttributeChanged">
                    Can Delete
                </Property>

                <t t-call="web_studio.ViewEditor.ShowInvisibleToggler"/>

                <Property name="'editable'" type="'selection'" value="archInfo.editable or ''" onChange.bind="onAttributeChanged" childProps="{ choices: editableChoices }">
                    When Creating Record
                </Property>
                <Property t-if="archInfo.activeActions.edit === true" name="'multi_edit'" type="'boolean'" value="archInfo.multiEdit === true" onChange.bind="onAttributeChanged">
                    Enable Mass Editing
                </Property>
                <Property t-if="archInfo.editable" name="'open_form_view'" type="'boolean'" value="archInfo.openFormView === true" onChange.bind="onAttributeChanged">
                    Show link to record
                </Property>
                <Property name="'sort_by'" type="'selection'" value="defaultOrder.name or null" onChange.bind="setSortBy" childProps="{ choices: sortChoices, required: false }">
                    Sort By
                </Property>
                <Property t-if="this.defaultOrder.name" name="'sort_order'" type="'selection'" value="defaultOrder.asc ? 'asc' : 'desc'" onChange.bind="setOrder" childProps="{ choices: orderChoices }">
                    Order
                </Property>
                <Property name="'default_group_by'" type="'selection'" value="archInfo.defaultGroupBy" onChange="(value, name) =&gt; this.onAttributeChanged(value or '', name)" childProps="{ choices: defaultGroupbyChoices, required: false }">
                    Default Group By
                </Property>
                <p t-if="archInfo.defaultGroupBy" class="alert alert-dark fst-italic p-2 mt-3" role="alert">
                    <small><i class="fa fa-info-circle me-1" aria-hidden="true"/>Grouping is not applied while in Studio to allow editing.</small>
                </p>
                <SidebarViewToolbox onMore="props.openViewInForm" canEditXml="!viewEditorModel.isEditingSubview" openDefaultValues="props.openDefaultValues"/>
            </t>

            <t t-set-slot="properties">
                <Properties propertiesComponents="propertiesComponents"/>
            </t>
        </InteractiveEditorSidebar>
    </t>

`);
registerTemplate("web_studio.ViewEditor.MapEditorSidebar", `/web_studio/static/src/client_action/view_editor/editors/map/map_editor_sidebar.xml`, `<t t-name="web_studio.ViewEditor.MapEditorSidebar" xml:space="preserve">
        <InteractiveEditorSidebar>
            <t t-set-slot="view">
                <Property name="'res_partner'" type="'selection'" value="modelParams.resPartnerField" childProps="{ choices: this.contactFieldChoices, required: false }" onChange.bind="onViewAttributeChanged">
                    Contact Field
                </Property>

                <Property name="'hide_name'" type="'boolean'" value="modelParams.hideName" onChange.bind="onViewAttributeChanged">
                    Hide Name
                </Property>

                <Property name="'hide_address'" type="'boolean'" value="modelParams.hideAddress" onChange.bind="onViewAttributeChanged">
                    Hide Address
                </Property>

                <div class="o_map_popup_fields">
                    <label for="additional_fields" class="mb-1">Additional Fields</label>
                    <div class="o_field_widget o_field_many2many_tags" name="additional_fields">
                        <MultiRecordSelector t-props="multiRecordSelectorProps"/>
                    </div>
                </div>

                <Property name="'routing'" type="'boolean'" value="modelParams.routing" onChange.bind="onViewAttributeChanged">
                    Enable Routing
                </Property>

                <Property t-if="modelParams.routing === true" name="'default_order'" type="'selection'" value="modelParams.defaultOrder?.name" childProps="{ choices: this.defaultOrderChoices, required: false }" onChange.bind="onViewAttributeChanged">
                    Sort by
                </Property>

                <Property t-if="modelParams.defaultOrder                         and modelParams.fields[modelParams.defaultOrder.name].type === 'integer'                         and !modelParams.fields[modelParams.defaultOrder.name].readonly" name="'allow_resequence'" type="'boolean'" value="modelParams.allowResequence" onChange.bind="onViewAttributeChanged">
                    Allow Resequencing
                </Property>

                <SidebarViewToolbox onMore="props.openViewInForm" canEditXml="!viewEditorModel.isEditingSubview" openDefaultValues="props.openDefaultValues"/>
            </t>
        </InteractiveEditorSidebar>
    </t>

`);
registerTemplate("web_studio.ViewEditor.PivotEditorSidebar", `/web_studio/static/src/client_action/view_editor/editors/pivot/pivot_editor_sidebar.xml`, `<t t-name="web_studio.ViewEditor.PivotEditorSidebar" xml:space="preserve">
        <InteractiveEditorSidebar>
            <t t-set-slot="view">

                <Property name="'disable_linking'" type="'boolean'" value="!archInfo.disableLinking" onChange="(value, name) =&gt; this.onViewAttributeChanged(!value, name)">
                    Access records from cell
                </Property>

                <Property name="'column_groupby'" type="'selection'" value="colGroupBys[0]" childProps="{ choices: this.columnGroupbyChoices, required: false }" onChange.bind="(value) =&gt; this.onGroupByChanged('col', value, this.colGroupBys[0])">
                    Column grouping
                </Property>

                <Property name="'first_row_groupby'" type="'selection'" value="rowGroupBys[0]" childProps="{ choices: this.rowGroupbyChoices_first, required: false }" onChange.bind="(value) =&gt; this.onGroupByChanged('row', value, this.rowGroupBys[0])">
                    Row grouping - First level
                </Property>

                <Property t-if="archInfo.rowGroupBys[0]" name="'second_row_groupby'" type="'selection'" value="rowGroupBys[1]" childProps="{ choices: this.rowGroupbyChoices_second, required: false }" onChange.bind="(value) =&gt; this.onGroupByChanged('row', value, this.rowGroupBys[1])">
                    Row grouping - Second level
                </Property>

                <div class="o_pivot_measures_fields">
                    <label for="pivot_measure_fields" class="mb-1">Measures</label>
                    <div class="o_field_widget o_field_many2many_tags" name="pivot_measure_fields">
                        <MultiRecordSelector t-props="multiRecordSelectorProps"/>
                    </div>
                </div>

                <SidebarViewToolbox onMore="props.openViewInForm" canEditXml="!viewEditorModel.isEditingSubview" openDefaultValues="props.openDefaultValues"/>
            </t>
        </InteractiveEditorSidebar>
    </t>

`);
registerTemplate("web_studio.SearchEditorController", `/web_studio/static/src/client_action/view_editor/editors/search/search_editor.xml`, `<t t-name="web_studio.SearchEditorController" xml:space="preserve">
        <div class="o_web_studio_search_view_editor d-flex flex-wrap align-items-start">
            <div t-ref="root" class="o_web_studio_search_view_container position-relative bg-light m-3 overflow-hidden rounded-3 shadow">
                <div class="o_web_studio_search_sample_ui w-100 pt-1">
                    <i class="oi oi-search d-block fs-3 text-end opacity-25 m-2"/>
                    <hr class="my-0 mx-3 border"/>
                </div>
                <div class="o_web_studio_search_container d-flex p-2 w-100">
                    <div class="o_web_studio_search_sub_item o-web-studio-search--filters w-lg-auto mb-lg-0 w-100 px-3 mb-4 border-end">
                        <div class="o-web-studio-search-subitem-header">
                            <i class="fa fa-filter me-2 text-primary"/>
                            <h5 class="o_dropdown_title d-inline">Filters</h5>
                        </div>

                        <div class="d-flex flex-column">
                            <t t-set="firstHook" t-value="getFirstHookProps('filter')"/>
                            <StudioHook t-if="firstHook" t-props="firstHook"/>
                            <t t-foreach="filtersGroups" t-as="filterGroup" t-key="filterGroup_index">
                                <div t-if="filterGroup_index !== 0 and filterGroup.separator" class="o-web-studio-editor--element-clickable" t-on-click="(ev) =&gt; this.onItemClicked(ev, filterGroup.separator)" t-att-data-studio-xpath="filterGroup.separator">
                                    <hr class="border my-2"/>
                                </div>

                                <hr t-elif="filterGroup_index !== 0 and filterGroup !== filterGroup_last and filterGroup.items.length !==0"/>

                                <StudioHook t-if="filterGroup.items.length" position="'before'" xpath="filterGroup.items[0].studioXpath" type="'filter'"/>

                                <t t-foreach="getItems(filterGroup.items)" t-as="item" t-key="item_index">
                                    <div t-esc="getItemLabel('filter', item)" t-on-click="(ev) =&gt; this.onItemClicked(ev, item.studioXpath)" class="o-web-studio-editor--element-clickable p-1" t-att-data-studio-xpath="item.studioXpath"/>
                                    <StudioHook position="'after'" xpath="item.studioXpath" type="'filter'"/>
                                </t>
                            </t>
                        </div>
                    </div>
                    <div class="o_web_studio_search_sub_item o-web-studio-search--groupbys w-lg-auto mb-lg-0 w-100 px-3 mb-4 border-end">
                        <div class="o-web-studio-search-subitem-header">
                            <i class="me-2 text-action oi oi-group"/>
                            <h5 class="o_dropdown_title d-inline">Group by</h5>
                        </div>

                        <div class="d-flex flex-column p-3">
                            <t t-set="firstHook" t-value="getFirstHookProps('groupBy')"/>
                            <StudioHook t-if="firstHook" t-props="firstHook"/>
                            <t t-foreach="groupByGroups" t-as="groupByGroup" t-key="groupByGroup_index">
                                <hr t-if="groupByGroup_index !== 0 and groupByGroup !== groupByGroup_last and groupByGroup.items.length !==0"/>

                                <StudioHook t-if="groupByGroup.items.length" position="'before'" xpath="groupByGroup.items[0].studioXpath" type="'groupBy'"/>
                                <t t-foreach="getItems(groupByGroup.items)" t-as="item" t-key="item_index">
                                    <div t-esc="getItemLabel('groupBy', item)" t-on-click="(ev) =&gt; this.onItemClicked(ev, item.studioXpath)" class="o-web-studio-editor--element-clickable p-1" t-att-data-studio-xpath="item.studioXpath"/>
                                    <StudioHook position="'after'" xpath="item.studioXpath" type="'groupBy'"/>
                                </t>
                            </t>
                        </div>
                    </div>
                    <div class="o_web_studio_search_sub_item w-lg-auto w-100 px-3 mb-4">
                        <div class="o-web-studio-search-subitem-header opacity-25">
                            <i class="me-2 text-favourite fa fa-star"/>
                            <h5 class="o_dropdown_title d-inline">Favourites</h5>
                        </div>
                    </div>
                </div>
            </div>
            <div class="o_web_studio_search_autocompletion_container bg-light m-3 overflow-hidden rounded-3 shadow o-web-studio-search--fields">
                <div class="o-web-studio-search-subitem-header p-3">
                    <h3 class="fw-normal">
                        <i class="fa fa-magic me-2"/>
                        Autocompletion Fields
                    </h3>
                </div>
                <div class="d-flex flex-column border p-2">
                    <StudioHook t-if="!autoCompleteFields.length" position="'inside'" xpath="'/search'" type="'field'"/>
                    <StudioHook t-else="" position="'before'" xpath="autoCompleteFields[0].studioXpath" type="'field'"/>
                    <t t-foreach="getItems(autoCompleteFields)" t-as="item" t-key="item_index">
                        <div t-esc="getItemLabel('field', item)" t-on-click="(ev) =&gt; this.onItemClicked(ev, item.studioXpath)" class="o-web-studio-editor--element-clickable p-2" t-att-data-studio-xpath="item.studioXpath"/>
                        <StudioHook position="'after'" xpath="item.studioXpath" type="'field'"/>
                    </t>
                </div>
            </div>
        </div>
    </t>

    `);
registerTemplate("web_studio.ViewEditor.SearchEditorSidebar", `/web_studio/static/src/client_action/view_editor/editors/search/search_editor.xml`, `<t t-name="web_studio.ViewEditor.SearchEditorSidebar" xml:space="preserve">
        <InteractiveEditorSidebar>
            <t t-set-slot="new">
                <SearchComponents/>
                <ExistingFields resModel="viewEditorModel.resModel" fields="viewEditorModel.fields" fieldsInArch="viewEditorModel.fieldsInArch" folded="false" filterFields="false"/>
            </t>
            <t t-set-slot="view">
                <t t-call="web_studio.ViewEditor.ShowInvisibleToggler"/>
                <SidebarViewToolbox onMore="props.openViewInForm" canEditXml="!env.viewEditorModel.isEditingSubview" canEditDefaultValues="false"/>
            </t>
            <t t-set-slot="properties">
                <SimpleElementEditor t-if="currentNode" node="currentNode"/>
            </t>
        </InteractiveEditorSidebar>
    </t>

    `);
registerTemplate("web_studio.SearchEditor.Sidebar.Components", `/web_studio/static/src/client_action/view_editor/editors/search/search_editor.xml`, `<t t-name="web_studio.SearchEditor.Sidebar.Components" xml:space="preserve">
        <div class="o_web_studio_field_type_container o_web_studio_new_components d-flex flex-row">
            <h3 class="w-100">Components</h3>
            <t t-foreach="structures" t-as="struct" t-key="struct_index">
                <SidebarDraggableItem string="struct_value.name" className="struct_value.class" structure="struct"/>
            </t>
        </div>
    </t>

    `);
registerTemplate("web_studio.SearchEditor.SimpleElementEditor", `/web_studio/static/src/client_action/view_editor/editors/search/search_editor.xml`, `<t t-name="web_studio.SearchEditor.SimpleElementEditor" xml:space="preserve">
        <h3 class="text-capitalize" t-out="viewEditorModel.activeNode.humanName"/>
        <Property t-if="node.type !== 'separator'" name="'label'" type="'char'" value="label" onChange.bind="onChangeLabel">
            Label
        </Property>
        <Property t-if="node.type === 'filter'" name="'domain'" type="'domain'" value="domain" onChange.bind="onChangeDomain" childProps="{relation: viewEditorModel.resModel}">
            Domain
        </Property>
        <SidebarPropertiesToolbox/>
    </t>
`);
registerTemplate("web_studio.AddButtonAction", `/web_studio/static/src/client_action/view_editor/interactive_editor/action_button/action_button.xml`, `<t t-name="web_studio.AddButtonAction" xml:space="preserve">
		<button class="o-web-studio-editor--add-button-action btn btn-link" t-on-click="onClick">
			Add a button
		</button>
	</t>

	`);
registerTemplate("web_studio.DialogNewButtonStatusBar", `/web_studio/static/src/client_action/view_editor/interactive_editor/action_button/action_button.xml`, `<t t-name="web_studio.DialogNewButtonStatusBar" xml:space="preserve">
		<Dialog size="'sm'" title.translate="Buttons Properties">
			<div class="o-web-studio-editor--modal-add-action d-flex flex-column gap-4">
				<div>
					<label for="set_label">
						Label
					</label>
					<input id="set_label" placeholder="Label of the button" class="o_input" type="text" t-model="state.label"/>
				</div>
				<div>
					<label for="label">
						What should the button do
					</label>
					<div>
						<input type="radio" t-on-change="onChange" id="set_button_type_to_action" value="action" t-model="state.button_type"/>
						<label for="set_button_type_to_action" class="oe_label" style="display: inline;">
							Run a Server Action
						</label>
						<br/>
						<input type="radio" t-on-change="onChange" id="set_button_type_to_object" value="object" t-model="state.button_type"/>
						<label for="set_button_type_to_object" class="oe_label" style="display: inline;">
							Call a method
						</label>
					</div>
					<div t-if="state.button_type === 'action'">
						<label for="select_action_to_run" class="oe_label" style="display: inline;">
							Action to run
						</label>
            <RecordSelector t-props="multiRecordSelectorProps"/>
					</div>
					<div t-if="state.button_type === 'object'">
						<label for="set_method" class="oe_label" style="display: inline;">
							Method to run
						</label>
						<div t-if="state.error?.length &gt; 0" class="text-danger" t-esc="state.error"/>
						<input t-on-change="checkMethod" id="set_method" type="text" class="o_input" placeholder="Method to run" t-model="state.methodId"/>
					</div>
					<t t-set-slot="footer">
						<button t-att-disabled="checkValidity" class="o-web-studio-editor--add-button-confirm  btn btn-primary" t-on-click="onConfirm">
							Confirm
						</button>
						<button class="o-web-studio-editor--add-button-cancel btn btn-secondary" t-on-click="onCancel">
							Cancel
						</button>
					</t>
				</div>
			</div>
		</Dialog>
	</t>
`);
registerTemplate("web_studio.SelectionValuesEditor", `/web_studio/static/src/client_action/view_editor/interactive_editor/field_configuration/field_configuration.xml`, `<t t-name="web_studio.SelectionValuesEditor" xml:space="preserve">
    <SelectionContentDialog defaultChoices="selection" onConfirm.bind="onConfirm" close="this.props.cancel"/>
</t>

`);
registerTemplate("web_studio.RelationalFieldConfigurator", `/web_studio/static/src/client_action/view_editor/interactive_editor/field_configuration/field_configuration.xml`, `<t t-name="web_studio.RelationalFieldConfigurator" xml:space="preserve">
    <span t-if="props.fieldType === 'one2many'">Select the reciprocal ManyToOne field</span>
    <span t-else="">Select the model in relation to this one</span>
    <div name="relation_id">
        <RecordSelector t-props="valueSelectorProps"/>
    </div>
</t>


`);
registerTemplate("web_studio.FieldConfigurationDialog", `/web_studio/static/src/client_action/view_editor/interactive_editor/field_configuration/field_configuration.xml`, `<t t-name="web_studio.FieldConfigurationDialog" xml:space="preserve">
    <t t-if="props.isDialog">
        <t t-component="Component" t-props="props.componentProps" configurationModel="configurationModel" confirm="confirm" cancel="cancel"/>
    </t>
    <Dialog t-else="" size="props.size or 'sm'" title="title">
        <t t-component="Component" t-props="props.componentProps" configurationModel="configurationModel"/>
        <t t-set-slot="footer">
            <button type="button" class="btn btn-primary" t-att-class="{ disabled: !canConfirm }" t-on-click="confirm">Confirm</button>
            <button type="button" class="btn btn-secondary" t-on-click="cancel">Cancel</button>
        </t>
    </Dialog>
</t>

`);
registerTemplate("web_studio.FilterConfiguration", `/web_studio/static/src/client_action/view_editor/interactive_editor/field_configuration/field_configuration.xml`, `<t t-name="web_studio.FilterConfiguration" xml:space="preserve">
    <label class="mb-4">Filter label
        <input type="text" id="domain_label" class="o_input" t-model="state.filterLabel"/>
    </label>
    <DomainSelector t-props="domainSelectorProps"/>
</t>

`);
registerTemplate("web_studio.SelectionContentDialog", `/web_studio/static/src/client_action/view_editor/interactive_editor/field_configuration/selection_content_dialog.xml`, `<t t-name="web_studio.SelectionContentDialog" xml:space="preserve">
    <Dialog size="'sm'" title.translate="Field Properties" contentClass="'o_web_studio_selection_editor'">
        <div class="d-flex flex-column gap-3">
        <h5>Specify all possible values</h5>
            <div>
                <ul class="o_web_studio_selection_editor list-unstyled mb-0" t-ref="itemsList">
                    <t t-foreach="selectionToItems" t-as="item" t-key="item.key">
                        <t t-call="web_studio.InteractiveItemsList.EditableItem"/>
                    </t>
                </ul>
                <ul class="o_web_studio_add_selection list-unstyled">
                    <t t-call="web_studio.InteractiveItemsList.EditableItem">
                        <t t-set="item" t-value="newItem"/>
                    </t>
                </ul>
            </div>
            <div t-if="shouldFullEdit and editedItem" class="o_web_studio_selection_full_edit border-top d-flex flex-row flex-wrap gap-2 pt-2 align-items-end">
                <t t-set="editedSelection" t-value="getSelectionFromItem(editedItem)"/>
                <div class="flex-shrink-0 w-100">Editing item: <b t-esc="oldValue.get(editedSelection)[0]"/></div>
                <label style="max-width: 40%;">Label
                    <input t-model="editedSelection[1]" class="w-100"/>
                </label>
                <label style="max-width: 30%;">Value
                    <input t-model="editedSelection[0]" class="w-100"/>
                </label>
                <div>
                    <button class="btn btn-primary btn btn-primary fa fa-check" t-on-click="() =&gt; this.editItem(editedItem)"/>
                    <button class="btn btn-danger fa fa-times" style="height: 20%;" t-on-click="() =&gt; this.discardItemChanges(editedItem)"/>
                </div>
            </div>
        </div>
        <t t-set-slot="footer">
            <button t-attf-class="btn btn-primary {{ selection.length ? '' : 'disabled'}}" t-on-click.stop="onConfirm">Confirm</button>
            <button class="btn btn-secondary" t-on-click.stop="props.close">Cancel</button>
        </t>
    </Dialog>
</t>

`);
registerTemplate("web_studio.InteractiveItemsList.EditableItem", `/web_studio/static/src/client_action/view_editor/interactive_editor/field_configuration/selection_content_dialog.xml`, `<t t-name="web_studio.InteractiveItemsList.EditableItem" t-inherit="web_studio.InteractiveItemsList.Item" xml:space="preserve">
    <xpath expr="//span[contains(@class, 'o-web-studio-interactive-list-item-label')]" position="attributes">
        <attribute name="t-if">!item.isInEdition</attribute>
        <attribute name="t-esc">item.label</attribute>
    </xpath>
    <xpath expr="//span[contains(@class, 'o-web-studio-interactive-list-item-label')]" position="after">
        <input t-if="item.isInEdition" class="form-control o-web-studio-interactive-list-item-input" placeholder="Add new value" t-on-input="(ev) =&gt; this.setItemValue(item, ev.target.value)" t-att-value="item.id === 'new' ? item.name : item.label" t-on-keypress="(ev) =&gt; this.onKeyPressed(item, ev.key)"/>
    </xpath>

    <xpath expr="//button[contains(@class, 'o-web-studio-interactive-list-edit-item')]" position="attributes">
        <attribute name="class" remove="fa-pencil-square-o" separator=" "/>
        <attribute name="t-att-class"> { 'fa-pencil-square-o': !item.isInEdition, 'fa-check': item.isInEdition } </attribute>
        <attribute name="t-attf-data-tooltip"> {{ item.isInEdition ? 'Add selection' : 'Edit selection' }} </attribute>
    </xpath>

    <xpath expr="//button[contains(@class, 'o-web-studio-interactive-list-remove-item')]" position="attributes">
        <attribute name="t-if">!item.isInEdition</attribute>
    </xpath>
    <xpath expr="//button[contains(@class, 'o-web-studio-interactive-list-remove-item')]" position="after">
        <button t-if="item.isInEdition" type="button" class="btn btn-secondary fa fa-times o-web-studio-interactive-list-discard-changes" aria-label="Discard changes" data-tooltip="Discard changes" t-on-click="() =&gt; this.discardItemChanges(item) "/>
    </xpath>
</t>

`);
registerTemplate("web_studio.InteractiveEditor", `/web_studio/static/src/client_action/view_editor/interactive_editor/interactive_editor.xml`, `<t t-name="web_studio.InteractiveEditor" xml:space="preserve">
        <t t-component="props.editor.Sidebar or defaultSidebar" openViewInForm.bind="openViewInForm" openDefaultValues.bind="openDefaultValues"/>
        <t t-slot="default" autoClick="applyAutoClick"/>
    </t>

`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorSidebar", `/web_studio/static/src/client_action/view_editor/interactive_editor/interactive_editor_sidebar.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorSidebar" xml:space="preserve">
        <Notebook className="'o_web_studio_sidebar overflow-x-hidden'" defaultPage="defaultTab" icons="icons" onPageUpdate.bind="onTabClicked">
            <t t-set-slot="new" title="tabsDisplay.new.title" isVisible="true" isDisabled="!props.slots.new" className="tabsDisplay.new.class">
                <t t-slot="new"/>
            </t>
            <t t-set-slot="view" title="tabsDisplay.view.title" isVisible="true" className="tabsDisplay.view.class">
                <t t-slot="view"/>
            </t>
            <t t-set-slot="properties" title="tabsDisplay.properties.title" isVisible="true" isDisabled="!props.slots.properties || !env.viewEditorModel.activeNodeXpath" className="tabsDisplay.properties.class">
                <t t-slot="properties"/>
            </t>
        </Notebook>
    </t>
`);
registerTemplate("web_studio.ViewEditor.ClassAttribute", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/class_attribute/class_attribute.xml`, `<t t-name="web_studio.ViewEditor.ClassAttribute" xml:space="preserve">
    <Property name="'class'" type="'string'" value="props.value" onChange="props.onChange" tooltip="tooltip">
        Class
    </Property>
</t>

`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.Field", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/field_properties/field_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.Field" xml:space="preserve">
    <ViewStructureProperties>
        <ClassAttribute value="props.node.attrs.class" onChange.bind="onChangeAttribute"/>
        <ModifiersProperties node="props.node" availableOptions="props.availableOptions"/>


        <Property t-if="isAttributeSupported('bold')" name="'bold'" type="'boolean'" value="getBoldValue()" onChange.bind="onChangeAttribute">
            Bold
        </Property>
        <Property t-if="isAttributeSupported('optional')" name="'optional'" type="'selection'" value="props.node.attrs.optional" onChange.bind="onChangeAttribute" childProps="optionalVisibilityChoices">
            Optional
        </Property>
        <Property t-if="isAttributeSupported('string')" name="'string'" type="'string'" value="props.node.attrs.string || props.node.field.string" onChange.bind="onChangeFieldString">
            Label
        </Property>
        <Property t-if="isAttributeSupported('help')" name="'help'" type="'string'" value="props.node.attrs.help || props.node.field.help" onChange.bind="onChangeAttribute">
            Help Tooltip
        </Property>

        <TechnicalName t-if="env.debug" node="props.node"/>

        <TypeWidgetProperties node="props.node" onChangeAttribute.bind="onChangeAttribute"/>

        <t t-set="defaultValuePropertyProps" t-value="getDefaultValuePropertyProps()"/>
        <t t-if="defaultValuePropertyProps">
            <Property name="'default_value'" value="state.defaultValue" onChange.bind="onChangeDefaultValue" t-props="defaultValuePropertyProps">
                Default value
                <span t-if="multiCompany">
                for company <b t-esc="companyService.currentCompany.name"/>
                </span>
            </Property>
        </t>

        <t t-if="canEditSelectionChoices">
            <button class="btn btn-link o_web_studio_edit_selection_values" t-on-click="editSelectionChoices">
                <i class="fa fa-pencil"/> Edit Values
            </button>
        </t>
    </ViewStructureProperties>
</t>

`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.Field.TechnicalName", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/field_properties/field_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.Field.TechnicalName" xml:space="preserve">
    <Property name="'technical_name'" type="'string'" value="fieldName" isReadonly="!canEdit" onChange.bind="renameField">
        <span class="w-100 d-inline-block">Technical Name</span>
        <span t-if="canEdit" class="input-group-text d-inline-block pe-none">x_studio_</span>
    </Property>
</t>

`);
registerTemplate("web_studio.ViewEditor.LimitGroupVisibility", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/limit_group_visibility/limit_group_visibility.xml`, `<t t-name="web_studio.ViewEditor.LimitGroupVisibility" xml:space="preserve">
    <div class="o_limit_group_visibility o_web_studio_sidebar_tags">
        <label for="groups_id" class="mb-1">Allow visibility to groups</label>
        <div class="o_field_widget o_field_many2many_tags" name="groups_id">
            <MultiRecordSelector t-props="allowGroupsProps"/>
        </div>

        <label for="negated_groups_id" class="mb-1">Forbid visibility to groups</label>
        <div class="o_field_widget o_field_many2many_tags" name="negated_groups_id">
            <MultiRecordSelector t-props="forbidGroupsProps"/>
        </div>
    </div>
</t>

`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.Modifiers", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/modifiers/modifiers_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.Modifiers" xml:space="preserve">
        <t t-if="this.isAttributeSupported('invisible')" t-call="web_studio.ViewEditor.InteractiveEditorProperties.PythonExpressionCheckbox">
            <t t-set="name" t-value="'invisible'"/>
            <t t-set="value" t-value="props.node.attrs.invisible || props.node.attrs.column_invisible"/>
            <t t-set="checkboxClassName" t-value="getCheckboxClassName(value)"/>
            <t t-set="boolValue" t-value="this.valueAsBoolean(value)"/>
            <t t-set="string">Invisible</t>
        </t>

        <t t-if="this.isAttributeSupported('required')" t-call="web_studio.ViewEditor.InteractiveEditorProperties.PythonExpressionCheckbox">
            <t t-set="name" t-value="'required'"/>
            <t t-set="value" t-value="props.node.attrs.required"/>
            <t t-set="checkboxClassName" t-value="getCheckboxClassName(value)"/>
            <t t-set="boolValue" t-value="this.valueAsBoolean(value)"/>
            <t t-set="string">Required</t>
        </t>

        <t t-if="this.isAttributeSupported('readonly')" t-call="web_studio.ViewEditor.InteractiveEditorProperties.PythonExpressionCheckbox">
            <t t-set="name" t-value="'readonly'"/>
            <t t-set="value" t-value="props.node.attrs.readonly"/>
            <t t-set="checkboxClassName" t-value="getCheckboxClassName(value)"/>
            <t t-set="boolValue" t-value="this.valueAsBoolean(value)"/>
            <t t-set="string">Readonly</t>
        </t>
    </t>

    `);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.PythonExpressionCheckbox", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/modifiers/modifiers_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.PythonExpressionCheckbox" xml:space="preserve">
        <div class="o_web_studio_property clearfix o_web_studio_sidebar_checkbox d-flex" t-att-class="props.class">
            <CheckBox className="checkboxClassName" id="name" name="name" value="boolValue" onChange="(value) =&gt; this.onChangeModifier(name, value)">
                <t t-esc="string"/>
                <sup t-if="tooltip" class="text-info p-1" t-att-data-tooltip="props.tooltip" t-esc="'?'"/>
            </CheckBox>
            <a t-on-click.prevent.stop="() =&gt; this.onConditionalButtonClicked(name, value)" role="button" href="#" data-type="invisible" class="btn btn-link o_web_studio_attrs ms-auto">
                Conditional
            </a>
        </div>
    </t>
`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties" xml:space="preserve">
        <t t-if="node">
            <h3 t-attf-class="text-capitalize o_web_studio_icon_container position-relative {{ iconClass }}" t-out="node.humanName"/>
            <t t-if="propertiesComponent.component" t-component="propertiesComponent.component" t-props="propertiesComponent.props" node="node"/>
            <DefaultProperties t-else="" node="node"/>
        </t>
    </t>
`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.Toolbox", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/sidebar_properties_toolbox/sidebar_properties_toolbox.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.Toolbox" xml:space="preserve">
        <t t-set="hasMoreButton" t-value="env.debug and nodeType === 'field'"/>

        <div class="o_web_studio_sidebar_toolbox d-flex flex-wrap border-top pt-3 mt-4 gap-2 border-secondary">
            <button t-if="hasMoreButton" t-on-click="openFormAction" class="btn btn-secondary btn-lg o_web_studio_parameters me-1">
                <i class="fa fa-cog me-2"/>
                    More
            </button>
            <button t-on-click="onRemoveFromView" class="btn btn-danger btn-lg o_web_studio_remove">Remove from View</button>
        </div>
    </t>
`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.Field.TypeWidgetProperties", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/type_widget_properties/type_widget_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.Field.TypeWidgetProperties" xml:space="preserve">
    <t t-set="property_id" t-value="props.node.xpath"/>
    <Property t-if="isField" t-key="property_id + '_widget'" name="'widget'" type="'selection'" value="props.node.attrs.widget || props.node.field.type" onChange.bind="onChangeWidget" childProps="widgetChoices">
        Widget
    </Property>

    <t t-foreach="attributes.field" t-as="attribute" t-key="property_id + '_' + attribute.name" t-if="!attribute.isSubOption">
        <t t-call="web_studio.property.field"/>
    </t>
    <t t-foreach="attributes.selection" t-as="attribute" t-key="property_id + '_' + attribute.name" t-if="!attribute.isSubOption">
        <t t-call="web_studio.property.selection"/>
    </t>
    <t t-foreach="attributes.boolean" t-as="attribute" t-key="property_id + '_' + attribute.name" t-if="!attribute.isSubOption">
        <t t-call="web_studio.property.boolean"/>
    </t>
    <t t-foreach="attributes.domain" t-as="attribute" t-key="property_id + '_' + attribute.name" t-if="!attribute.isSubOption">
        <t t-call="web_studio.property.domain"/>
    </t>
    <t t-foreach="attributes.number" t-as="attribute" t-key="property_id + '_' + attribute.name" t-if="!attribute.isSubOption">
        <t t-call="web_studio.property.number"/>
    </t>
    <t t-foreach="attributes.string" t-as="attribute" t-key="property_id + '_' + attribute.name" t-if="!attribute.isSubOption">
        <t t-call="web_studio.property.string"/>
    </t>
    <t t-foreach="attributes.digits" t-as="attribute" t-key="property_id + '_' + attribute.name" t-if="!attribute.isSubOption">
        <t t-call="web_studio.property.digits"/>
    </t>
</t>

`);
registerTemplate("web_studio.property.subOptions", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/type_widget_properties/type_widget_properties.xml`, `<t t-name="web_studio.property.subOptions" xml:space="preserve">
    <t t-if="attribute.subOptions">
        <t t-foreach="attribute.subOptions" t-as="subOption" t-key="subOption">
            <t t-set="subOptionObj" t-value="getOptionObj(subOption)"/>
            <t t-call="{{ 'web_studio.property.' + subOptionObj.type }}">
                <t t-set="attribute" t-value="getPropertyFromOptions(subOptionObj, props)"/>
            </t>
        </t>
    </t>
</t>

`);
registerTemplate("web_studio.property.defaultInput", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/type_widget_properties/type_widget_properties.xml`, `<t t-name="web_studio.property.defaultInput" xml:space="preserve">
    <t t-if="attribute and !attribute.isInvisible">
        <Property name="attribute.name" type="attribute.type" value="attribute.value" onChange.bind="onChangeProperty" tooltip="attribute.help" isReadonly="attribute.isReadonly">
            <t t-esc="attribute.label"/>
        </Property>
        <t t-call="web_studio.property.subOptions"/>
    </t>
</t>
`);
registerTemplate("web_studio.property.selection", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/type_widget_properties/type_widget_properties.xml`, `<t t-name="web_studio.property.selection" xml:space="preserve">
    <t t-if="attribute and !attribute.isInvisible">
        <Property name="attribute.name" type="'selection'" value="getSelectValue(attribute.value)" childProps="{choices:attribute.choices, required: false}" onChange.bind="onChangeProperty" tooltip="attribute.help" isReadonly="attribute.isReadonly">
            <t t-esc="attribute.label"/>
        </Property>
        <t t-call="web_studio.property.subOptions"/>
    </t>
</t>
`);
registerTemplate("web_studio.property.domain", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/type_widget_properties/type_widget_properties.xml`, `<t t-name="web_studio.property.domain" xml:space="preserve">
    <t t-if="attribute and !attribute.isInvisible">
        <Property name="attribute.name" type="'domain'" value="attribute.value.domain" onChange.bind="onChangeProperty" childProps="{relation: attribute.value.relation}" tooltip="attribute.help" isReadonly="attribute.isReadonly">
            <t t-esc="attribute.label"/>
        </Property>
        <t t-call="web_studio.property.subOptions"/>
    </t>
</t>
`);
registerTemplate("web_studio.property.digits", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/type_widget_properties/type_widget_properties.xml`, `<t t-name="web_studio.property.digits" xml:space="preserve">
    <t t-if="attribute and !attribute.isInvisible">
         <Property name="attribute.name" type="'number'" value="attribute.value and attribute.value[1]" onChange.bind="onChangeProperty" tooltip="attribute.help" inputAttributes="{min: 0, max: 20, step: 1}">
            <t t-esc="attribute.label"/>
        </Property>
    </t>
</t>

`);
registerTemplate("web_studio.property.boolean", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/type_widget_properties/type_widget_properties.xml`, `<t t-name="web_studio.property.boolean" xml:space="preserve">
    <t t-call="web_studio.property.defaultInput"/>
</t>
`);
registerTemplate("web_studio.property.field", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/type_widget_properties/type_widget_properties.xml`, `<t t-name="web_studio.property.field" xml:space="preserve">
    <t t-call="web_studio.property.selection"/>
</t>
`);
registerTemplate("web_studio.property.number", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/type_widget_properties/type_widget_properties.xml`, `<t t-name="web_studio.property.number" xml:space="preserve">
    <t t-call="web_studio.property.defaultInput"/>
</t>
`);
registerTemplate("web_studio.property.string", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/type_widget_properties/type_widget_properties.xml`, `<t t-name="web_studio.property.string" xml:space="preserve">
    <t t-call="web_studio.property.defaultInput"/>
</t>

`);
registerTemplate("web_studio.ViewStructureProperties", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/view_structure_properties/view_structure_properties.xml`, `<t t-name="web_studio.ViewStructureProperties" xml:space="preserve">
    <t t-slot="default"/>
    <LimitGroupVisibility node="viewEditorModel.activeNode"/>
    <SidebarPropertiesToolbox/>
</t>

`);
registerTemplate("web_studio.ViewEditor.InteractiveEditorProperties.Widget", `/web_studio/static/src/client_action/view_editor/interactive_editor/properties/widget_properties/widget_properties.xml`, `<t t-name="web_studio.ViewEditor.InteractiveEditorProperties.Widget" xml:space="preserve">
    <ViewStructureProperties>
        <ClassAttribute value="props.node.attrs.class" onChange.bind="onChangeAttribute"/>
        <TypeWidgetProperties node="props.node" onChangeAttribute.bind="onChangeAttribute"/>
    </ViewStructureProperties>
</t>

`);
registerTemplate("web_studio.ViewEditor.ViewToolbox", `/web_studio/static/src/client_action/view_editor/interactive_editor/sidebar_view_toolbox/sidebar_view_toolbox.xml`, `<t t-name="web_studio.ViewEditor.ViewToolbox" xml:space="preserve">
    <div t-if="env.debug" class="o_web_studio_sidebar_toolbox d-flex flex-wrap border-top pt-3 mt-4 gap-2 border-secondary">
      <button class="o_web_studio_parameters btn btn-secondary btn-lg w-30" t-on-click="() =&gt; props.onMore()">
        <i class="fa fa-cog me-2"/>More
      </button>
      <button t-if="props.canEditXml" class="o_web_studio_open_xml_editor btn btn-secondary btn-lg" t-on-click="() =&gt; env.viewEditorModel.switchMode()">
        <i class="fa fa-code me-2"/>XML
      </button>
      <button t-if="props.canEditDefaultValues" class="o_web_studio_defaults btn btn-secondary btn-lg" t-on-click="props.openDefaultValues">
        Default Values
      </button>
      <button class="o_web_studio_restore btn btn-danger btn-lg mt-0 w-100" t-on-click="() =&gt; env.viewEditorModel.restoreDefaultView(env.viewEditorModel.mainView.id)">
        Restore Default View
      </button>
    </div>
  </t>

  `);
registerTemplate("web_studio.ViewEditor.ShowInvisibleToggler", `/web_studio/static/src/client_action/view_editor/interactive_editor/sidebar_view_toolbox/sidebar_view_toolbox.xml`, `<t t-name="web_studio.ViewEditor.ShowInvisibleToggler" xml:space="preserve">
    <Property name="'show_invisible'" type="'boolean'" value="env.viewEditorModel.showInvisible" onChange.bind="(value) =&gt; env.viewEditorModel.showInvisible = value">
        Show Invisible Elements
    </Property>
  </t>

`);
registerTemplate("web_studio.Property", `/web_studio/static/src/client_action/view_editor/property/property.xml`, `<t t-name="web_studio.Property" xml:space="preserve">
        <div t-if="props.type === 'selection'" class="o_web_studio_property o_web_studio_sidebar_select mt-2 mb-2" t-att-class="className" t-att-name="props.name">
            <label t-att-for="props.name">
                <t t-slot="default"/>
                <sup t-if="props.tooltip" class="text-info p-1" t-att-data-tooltip="props.tooltip" t-esc="'?'"/>
            </label>
            <t t-set="choices" t-value="props.childProps.choices"/>
            <SelectMenu t-if="choices" t-props="props.childProps" value="props.value" onSelect="(value) =&gt; this.props.onChange(value, this.props.name)" class="'border-0'" togglerClass="'p-2'" searchable="choices.length &gt; 8" required="props.childProps.required !== false"/>
        </div>

        <t t-elif="props.type === 'boolean'">
            <div class="o_web_studio_property clearfix o_web_studio_sidebar_checkbox d-flex" t-att-class="props.class">
                <CheckBox id="props.name" name="props.name" value="!!props.value" onChange="(value) =&gt; this.props.onChange(value, this.props.name)" disabled="props.isReadonly">
                    <t t-slot="default"/>
                    <sup t-if="props.tooltip" class="text-info p-1" t-att-data-tooltip="props.tooltip" t-esc="'?'"/>
                </CheckBox>
            </div>
        </t>
        <div t-elif="props.type === 'domain'" class="o_web_studio_property o_web_studio_sidebar_text my-2 d-flex flex-column" t-att-class="props.class">
            <label t-att-for="props.name">
                <t t-slot="default"/>
                <sup t-if="props.tooltip" class="text-info p-1" t-att-data-tooltip="props.tooltip" t-esc="'?'"/>
            </label>
            <span t-if="props.isReadonly" t-att-name="props.name" t-esc="props.value" class="ps-2"/>
            <input t-else="" t-att="props.inputAttributes" t-att-name="props.name" t-att-id="props.name" t-att-type="props.type" t-att-value="props.value" t-att-class="\`form-\${props.type}-input\`" t-on-click.prevent.stop="onDomainClicked"/>
        </div>

        <div t-else="" class="o_web_studio_property o_web_studio_sidebar_text my-2 d-flex flex-column" t-att-class="props.class">
            <label t-att-for="props.name">
                <t t-slot="default"/>
                <sup t-if="props.tooltip" class="text-info p-1" t-att-data-tooltip="props.tooltip" t-esc="'?'"/>
            </label>
            <span t-if="props.isReadonly" t-att-name="props.name" t-esc="props.value" class="ps-2"/>
            <input t-else="" t-att-name="props.name" t-att-id="props.name" t-att="props.inputAttributes" t-att-type="props.type" t-att-value="props.value" t-att-class="\`form-\${props.type}-input\`" t-on-change="(ev) =&gt; this.props.onChange(ev.target.value, this.props.name)"/>
        </div>
    </t>

`);
registerTemplate("web_studio.ViewEditor", `/web_studio/static/src/client_action/view_editor/view_editor.xml`, `<t t-name="web_studio.ViewEditor" xml:space="preserve">
  <div class="o_web_studio_editor_manager d-flex flex-row w-100 h-100" t-ref="root">
      <InteractiveEditor t-if="viewEditorModel.mode === 'interactive'" rendererRef="rendererRef" editor="viewEditorModel.editorInfo.editor" editorContainerRef="rootRef" t-key="interactiveEditorKey" t-slot-scope="scope">
        <t t-call="web_studio.ViewEditor.View"/>
      </InteractiveEditor>

      <t t-else="">
        <ViewXmlEditor studioViewArch="viewEditorModel.studioViewArch" mainResourceId="viewEditorModel.view.id" defaultResourceId="viewEditorModel.studioViewId || viewEditorModel.view.id" onClose.bind="onXmlEditorClose" onSave.bind="onSaveXml"/>
        <t t-call="web_studio.ViewEditor.View"/>
      </t>
  </div>
</t>

`);
registerTemplate("web_studio.ViewEditor.View", `/web_studio/static/src/client_action/view_editor/view_editor.xml`, `<t t-name="web_studio.ViewEditor.View" xml:space="preserve">
  <div class="o_web_studio_view_renderer overflow-auto h-100 pe-auto" t-ref="viewRenderer">
    <StudioView t-props="viewEditorModel.studioViewProps" t-key="viewEditorModel.studioViewKey" autoClick="scope and scope.autoClick"/>
  </div>
</t>

`);
registerTemplate("web_studio.ViewEditor.Snackbar", `/web_studio/static/src/client_action/view_editor/view_editor_snackbar.xml`, `<t t-name="web_studio.ViewEditor.Snackbar" xml:space="preserve">

        <div class="o_web_studio_menu_undo_redo d-flex d-flex-row align-items-center">
            <button class="btn cursor-default text-uppercase text-nowrap o_web_studio_undo" t-attf-class="{{ props.operations.canUndo ? 'o_web_studio_active' : '' }}" t-on-click="() =&gt; props.operations.undo()">
                <i class="fa fa-undo me-2"/>Undo
            </button>

            <div class="align-self-center"/>

            <button class="btn cursor-default text-uppercase text-nowrap o_web_studio_redo" t-attf-class="{{ props.operations.canRedo ? 'o_web_studio_active' : '' }}" t-on-click="() =&gt; props.operations.redo()">
                <i class="fa fa-repeat me-2"/>Redo
            </button>
        </div>

        <div class="o_web_studio_snackbar mx-2">
            <t t-set="state" t-value="props.saveIndicator.state"/>
            <span class="fw-bold text-nowrap" t-if="state">
                <t t-if="state ==='loading'"><i class="fa fa-circle-o-notch fa-spin me-2"/>Saving</t>
                <t t-elif="state === 'loaded'"><i class="fa fa-check me-2"/>Saved</t>
                <t t-else=""><i class="fa fa-warning me-2"/>Error</t>
            </span>
        </div>

    </t>

`);
registerTemplate("web_studio.XmlResourceEditor", `/web_studio/static/src/client_action/xml_resource_editor/xml_resource_editor.xml`, `<t t-name="web_studio.XmlResourceEditor" xml:space="preserve">
        <div class="o_web_studio_xml_editor h-100 d-flex flex-column">
            <div class="o_web_studio_xml_resource_selector p-2">
                <SelectMenu class="'o_web_studio_xml_resource_select_menu text-light'" value="this.state.currentResourceId" choices="state.resourcesOptions" onSelect.bind="onResourceChange" searchable="state.resourcesOptions.length &gt; 5" required="true"/>
                <button t-if="props.canSave" t-on-click="onSaveClick" class="btn btn-primary">Save</button>
                <button t-on-click="onCloseClick" class="btn btn-secondary">Close</button>
            </div>
            <ResizablePanel class="'h-100'" minWidth="minWidth">
                <div class="o_web_studio_code_editor_info p-3">
                    <div class="d-flex justify-content-between">
                        <p t-if="props.title" class="mb-0 text-light" t-out="props.title"/>
                        <button class="btn btn-sm btn-link p-0" type="button" t-on-click="onFormat">Format</button>
                        <t t-if="props.slots and props.slots.additionalControlButtons" t-slot="additionalControlButtons" currentResourceId="this.state.currentResourceId"/>
                    </div>
                    <t t-if="this.props.displayAlerts">
                        <div t-foreach="alerts" t-as="alert" t-key="alert" t-if="alert_value.display" class="alert alert-warning d-flex justify-content-between mt-3" role="alert">
                            <p class="mb-0" t-out="alert_value.message"/>
                            <button type="button" class="btn-close ms-2" aria-label="Close" t-on-click="() =&gt; this.hideAlert(alert)"/>
                        </div>
                    </t>
                </div>
                <CodeEditor mode="'qweb'" sessionId="state.currentResourceId" value="arch" onChange.bind="onCodeChange" theme="'monokai'" class="'o_web_studio_code_editor'" t-key="codeEditorKey"/>
            </ResizablePanel>
        </div>
    </t>

    `);
registerTemplate("web_studio.ViewSelector", `/web_studio/static/src/client_action/xml_resource_editor/xml_resource_editor.xml`, `<t t-name="web_studio.ViewSelector" t-inherit="web.SelectMenu" xml:space="preserve">
        <xpath expr="//t[@t-foreach='state.displayedOptions']" position="attributes">
            <attribute name="t-foreach">this.getMainViews()</attribute>
        </xpath>
    </t>

    `);
registerTemplate("web_studio.ViewSelector.ChoiceItemRecursive", `/web_studio/static/src/client_action/xml_resource_editor/xml_resource_editor.xml`, `<t t-name="web_studio.ViewSelector.ChoiceItemRecursive" xml:space="preserve">
        <t t-set="level" t-value="level or 0"/>
        <t t-call="web_studio.ViewSelector.ChoiceItem"/>
        <t t-set="sublevel" t-value="level + 1"/>

        <t t-set="children" t-value="this.getInherited(choice)"/>
        <t t-foreach="children" t-as="subChoice" t-key="subChoice_index">
            <t t-call="{{ this.constructor.choiceItemTemplate }}">
                <t t-set="level" t-value="sublevel"/>
                <t t-set="choice" t-value="subChoice"/>
                <t t-set="mode" t-value="'inherits'"/>
            </t>
        </t>

        <t t-set="composedBy" t-value="this.getComposedBy(choice)"/>
        <t t-foreach="composedBy" t-as="subChoice" t-key="subChoice_index">
            <t t-call="{{ this.constructor.choiceItemTemplate }}">
                <t t-set="level" t-value="sublevel"/>
                <t t-set="choice" t-value="subChoice"/>
                <t t-set="mode" t-value="'composes'"/>
            </t>
        </t>
    </t>

    `);
registerTemplate("web_studio.ViewSelector.ChoiceItem", `/web_studio/static/src/client_action/xml_resource_editor/xml_resource_editor.xml`, `<t t-name="web_studio.ViewSelector.ChoiceItem" t-inherit="web.SelectMenu.ChoiceItem" xml:space="preserve">
        <xpath expr="./*[1]" position="before">
            <t t-set="level" t-value="level or 0"/>
        </xpath>

        <xpath expr="//DropdownItem//div" position="attributes">
            <attribute name="t-att-class">choice.resource.active ? "" : "text-decoration-line-through"</attribute>
        </xpath>

        <xpath expr="//DropdownItem//div" position="before">
            <div t-attf-style="margin-left: {{ (level*10) + 5 }}px;" class="me-2">
                <span class="d-block fw-bold" style="font-size: 0.7em;">
                    <t t-if="mode==='inherits'">
                        <i class="fa fa-sitemap me-2"/>Modified by:
                    </t>
                    <t t-elif="mode==='composes'">
                        <i class="fa fa-play me-2"/>Uses:
                    </t>
                </span>
            </div>
        </xpath>
    </t>
`);
registerTemplateExtension("web_enterprise.HomeMenu", `/web_studio/static/src/home_menu/home_menu.xml`, `<t t-name="web_studio.HomeMenu" t-inherit="web_enterprise.HomeMenu" t-inherit-mode="extension" t-translation="off" xml:space="preserve">
    <xpath expr="//div" position="attributes">
      <attribute name="t-attf-style">
        {{ backgroundImageUrl ? "background-image: url(" + backgroundImageUrl + ");" : '' }}
      </attribute>
    </xpath>
  </t>

`);
registerTemplate("web_studio.SystrayItem", `/web_studio/static/src/systray_item/systray_item.xml`, `<t t-name="web_studio.SystrayItem" xml:space="preserve">
    <div t-attf-class="o_web_studio_navbar_item {{ buttonDisabled ? 'o_disabled' : ''}} d-none d-md-inline-block" t-ref="root" t-on-click.prevent="_onClick">
        <button title="Toggle Studio" aria-label="Toggle Studio" class="o_nav_entry">
            <i class="oi oi-studio" role="img"/>
        </button>
    </div>
</t>

`);
registerTemplate("web_studio.NewReportDialog", `/web_studio/static/src/views/kanban_report/new_report_dialog.xml`, `<t t-name="web_studio.NewReportDialog" xml:space="preserve">
        <Dialog title.translate="Which type of report do you want to create?" size="'md'" footer="false">
            <div class="o_web_studio_report_layout_dialog d-flex justify-content-center">
                <div t-foreach="layouts" t-as="layout" t-key="layout.name" t-att-data-layout="layout.name" class="o_web_studio_report_layout_item btn btn-outline-secondary border text-center m-3 p-3" t-on-click="() =&gt; this.createNewReport(layout.name)">
                    <h3 t-esc="layout.label"/>
                    <div t-esc="layout.description"/>
                </div>
            </div>
        </Dialog>
    </t>

`);
registerTemplate("documents.FileViewer", `/documents/static/src/attachments/document_file_viewer.xml`, `<t t-name="documents.FileViewer" t-inherit="web.FileViewer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o-FileViewer-download')]" position="before">
            <div t-if="hasSplitPdf and currentFolderId !== 'TRASH'" class="o-FileViewer-headerButton d-flex align-items-center px-3 cursor-pointer" t-on-click.stop="onClickPdfSplit" role="button" title="Split PDF">
                <i class="fa fa-scissors fa-fw" t-att-class="{ 'o-hasLabel me-2': !env.isSmall }" role="img"/>
                <t t-if="!env.isSmall">
                    <span>Split PDF</span>
                </t>
            </div>
        </xpath>
        <xpath expr="//div[hasclass('o-FileViewer-download')]" position="replace">
            <t t-if="!withDownload">$0</t>   
        </xpath>
        <xpath expr="//div[hasclass('o-FileViewer-navigation')][@aria-label='Previous']" position="attributes">
            <attribute name="class" add="bg-dark" separator=" "/>
        </xpath>
        <xpath expr="//div[hasclass('o-FileViewer-navigation')][@aria-label='Next']" position="attributes">
            <attribute name="class" add="bg-dark" separator=" "/>
        </xpath>
        <xpath expr="//span[hasclass('oi-chevron-left')]" position="attributes">
            <attribute name="class" add="pe-1 text-white" separator=" "/>
        </xpath>
        <xpath expr="//span[hasclass('oi-chevron-right')]" position="attributes">
            <attribute name="class" add="ps-1 text-white" separator=" "/>
        </xpath>
    </t>
`);
registerTemplate("documents.ExitToolsDialog", `/documents/static/src/owl/components/pdf_exit_dialog/pdf_exit_dialog.xml`, `<t t-name="documents.ExitToolsDialog" xml:space="preserve">
        <Dialog size="'md'" title.translate="Exit Split Tools" modalRef="modalRef">
            <t t-if="this.props.isEmbeddedActionApplied">
                What do you want to do with the remaining pages ?
            </t>
            <t t-else="">
                Do you want to exit without saving or gather pages into one document ?
            </t>
            <t t-set-slot="footer">
                <button t-if="props.isEmbeddedActionApplied" class="btn btn-primary" t-on-click="deleteRemainingPages">Delete</button>
                <button t-else="" class="btn btn-primary" t-on-click="deleteRemainingPages">Exit without saving</button>
                <button class="btn btn-primary" t-on-click="gatherRemainingPages">Gather in one document</button>
                <button class="btn btn-secondary" t-on-click="props.close">Stay here</button>
            </t>
        </Dialog>
    </t>

`);
registerTemplate("documents.component.PdfGroupName", `/documents/static/src/owl/components/pdf_group_name/pdf_group_name.xml`, `<t t-name="documents.component.PdfGroupName" xml:space="preserve">
        <div class="o_documents_pdf_block_title">
            <div class="o_pdf_group_name_block">
                <t t-if="props.edit">
                    <input class="o_pdf_name_input" type="text" name="group_name" t-att-value="props.name" autofocus="true" t-on-blur="onBlur" t-on-keydown="onKeyDown" t-ref="nameInput"/>
                </t>
                <t t-else="">
                    <span class="o_pdf_name_display" t-esc="props.name" t-att-title="props.name" t-on-click.stop="onClickGroupName"/>
                </t>
            </div>
        </div>
    </t>
`);
registerTemplate("documents.component.PdfManager", `/documents/static/src/owl/components/pdf_manager/pdf_manager.xml`, `<t t-name="documents.component.PdfManager" xml:space="preserve">
        <div role="dialog" class="modal d-block o_technical_modal o_dialog_split_tools position-fixed" tabindex="-1">
            <div class="o_documents_pdf_manager" t-ref="root" t-att-class="{'pe-none': state.isSelecting}">
                <div class="o_documents_pdf_manager_top_bar">
                    <input type="file" t-ref="addFileInput" class="o_input_file o_hidden" accept="application/pdf" t-on-change.stop="onFileInputChange"/>
                    <t t-if="env.isSmall" t-call="documents.component.PdfManager.ButtonsMobile"/>
                    <span t-else="" class="o_pdf_global_buttons">
                        <div>
                            <t t-call="documents.component.PdfManager.GlobalButtons"/>
                        </div>
                    </span>
                    <span class="pdf_manager_topbar_buttons_right">
                        <span class="o_pdf_archive_menu me-2" t-on-click="onClickArchive" t-if="isDebugMode">
                            <span>Archive original file(s) </span>
                            <input class="ms-2 form-check-input mt-0" id="pdf_archive" type="checkbox" name="archive" t-att-checked="state.archive" t-att-disabled="state.viewedPage"/>
                        </span>
                        <button class="btn btn-danger me-2 o_pdf_manager_button text-uppercase" t-att-class="{'o_pdf_manager_button': !env.isSmall}" aria-label="Move to trash" title="Move to trash" t-att-disabled="state.uploadingLock || state.viewedPage" t-on-click.stop="onArchive">Delete
                        </button>
                    </span>
                </div>
                <div class="o_documents_pdf_page_preview" t-att-class="{'z-0 pt-0 pb-0 h-0' : !state.viewedPage}" t-on-click="onClickExitPreview">
                    <t t-if="state.viewedPage">
                        <div class="o_top_bar_previewer">
                            <div class="o_page_name d-flex justify-content-center align-items-center px-2 text-white opacity-75">
                                <t t-esc="state.viewedPageName"/>
                            </div>
                            <div class="d-flex justify-content-center align-items-center me-3">
                                <div class="o_page_index d-flex justify-content-center align-items-center px-2 text-white opacity-75">
                                    <t t-esc="state.viewedPageIndex + 1"/>/<t t-esc="state.numberOfPages"/>
                                </div>
                                <button class="o_delete_button d-flex justify-content-center align-items-center px-2 text-white opacity-75 h-100 btn fa fa-trash" t-on-click="onArchive" title="Move this page to trash">
                                </button>
                                <button class="o_close_button d-flex justify-content-center align-items-center px-2 text-white opacity-75 h4 mb-0 h-100">
                                    <i class="fa fa-fw fa-times"/>
                                </button>
                            </div>
                        </div>
                        <div class="o_navigation_left" t-if="state.viewedPageIndex !== 0">
                            <i class="fa fa-chevron-left ps-1 text-white display-6" role="button" t-on-click="onClickPrevious"/>
                        </div>
                        <div class="o_navigation_right" t-if="state.viewedPageIndex !== state.numberOfPages - 1">
                            <i class="fa fa-chevron-right ps-1 text-white display-6" role="button" t-on-click="onClickNext"/>
                        </div>
                        <PdfPage pageId="state.viewedPage" canvas="previewCanvas" isPreview="true" toRender="true"/>
                    </t>
                </div>
                <div class="o_documents_pdf_page_viewer" t-ref="pageViewer" t-att-class="{'pe-auto': state.isSelecting}">
                    <div id="area_selection" t-ref="selectionBox" t-att-class="{ 'd-block' : state.isSelecting }" t-att-style="\` left : \${state.selectionBoxArgs.left}; top : \${state.selectionBoxArgs.top}; width : \${state.selectionBoxArgs.width}; height : \${state.selectionBoxArgs.height}; \`"/>
                    <t t-foreach="state.groupIds" t-as="groupId" t-key="groupId">
                        <t t-foreach="state.groupData[groupId].pageIds" t-as="pageId" t-key="pageId">
                            <div class="d-flex flex-md-row flex-column align-items-md-start align-items-center">
                                <div class="o_documents_pdf_page_frame" t-key="'div_' + pageId" t-att-class="{'pe-none': state.isSelecting}">
                                    <PdfPage canvas="state.pageCanvases[pageId].canvas" isPreview="false" isSelected="state.pages[pageId].isSelected" isFocused="state.focusedPage === pageId" pageId="pageId" onPageClicked.bind="onClickPage" onPageDragged.bind="onPageDragStart" onPageDropped.bind="onPageDrop" onSelectClicked.bind="onSelectClicked"/>
                                    <div t-if="pageId_first" class="o_pdf_group_name_wrapper">
                                        <PdfGroupName groupId="groupId" name="state.groupData[groupId].name" onEditName.bind="onEditName" onToggleEdit.bind="onToggleEdit" edit="groupId === state.edit"/>
                                    </div>
                                </div>
                                <div t-if="!(groupId_last and pageId_last)" class="o_page_splitter_wrapper" t-att-class="{ 'o_pdf_separator_selected': pageId_last, 'pe-none': state.isSelecting}" t-on-click.stop="() =&gt; this.onClickPageSeparator(pageId, groupId)">
                                    <div class="o_page_splitter"/>
                                    <i class="o_pdf_scissors fa fa-scissors fa-lg"/>
                                </div>
                            </div>
                        </t>
                    </t>
                </div>
            </div>
        </div>
    </t>

    `);
registerTemplate("documents.component.PdfManager.GlobalButtons", `/documents/static/src/owl/components/pdf_manager/pdf_manager.xml`, `<t t-name="documents.component.PdfManager.GlobalButtons" xml:space="preserve">
        <t t-set="isMobile" t-value="env.isSmall"/>
        <button class="btn btn-primary o_pdf_manager_button" t-att-class="{'dropdown-item': isMobile, 'm-0': isMobile, 'h-auto': isMobile}" title="Split selected pages" t-att-disabled="state.uploadingLock || state.viewedPage" t-on-click.stop="onClickSplit" data-hotkey="s">
            Split
            <span t-if="state.uploadingLock" class="fa fa-circle-o-notch fa-spin"/>
        </button>
        <button class="btn btn-secondary o_pdf_manager_button text-uppercase" t-att-class="{'dropdown-item': isMobile, 'm-0': isMobile, 'h-auto': isMobile}" title="Close split tools" t-att-disabled="state.uploadingLock || state.viewedPage" t-on-click.stop="onClickExit">
            Close
        </button>
        <button class="btn btn-secondary o_pdf_manager_button text-uppercase" t-att-class="{'dropdown-item': isMobile, 'm-0': isMobile, 'h-auto': isMobile}" title="Add new file" t-att-disabled="state.uploadingLock || state.viewedPage" t-on-click.stop="onClickGlobalAdd" data-hotkey="f">
            Add File
        </button>
        <t t-foreach="props.embeddedActions" t-as="embeddedAction" t-key="embeddedAction.id">
            <t t-set="hotkey" t-value="embeddedAction_index lt 9 ? \`shift+\${embeddedAction_index + 1}\` : undefined"/>
            <button class="btn btn-secondary o_pdf_manager_button text-uppercase" t-att-class="{'dropdown-item': isMobile, 'm-0': isMobile, 'h-auto': isMobile}" t-on-click.stop="(ev) =&gt; this.onClickEmbeddedAction(embeddedAction.id)" t-esc="embeddedAction.name" t-att-data-hotkey="hotkey" t-att-disabled="state.uploadingLock || state.viewedPage"/>
        </t>
    </t>

    `);
registerTemplate("documents.component.PdfManager.ButtonsMobile", `/documents/static/src/owl/components/pdf_manager/pdf_manager.xml`, `<div t-name="documents.component.PdfManager.ButtonsMobile" class="dropdown" data-dropdown-is-mobile="1" xml:space="preserve">
        <button class="btn btn-primary dropdown-toggle" data-bs-toggle="dropdown" aria-expanded="false">Action</button>
        <div class="dropdown-menu" role="menu">
            <t t-call="documents.component.PdfManager.GlobalButtons"/>
        </div>
    </div>
`);
registerTemplate("documents.component.PdfPage", `/documents/static/src/owl/components/pdf_page/pdf_page.xml`, `<t t-name="documents.component.PdfPage" xml:space="preserve">
        <div t-att-data-id="props.pageId" t-att-class="{ 'o_pdf_page_focused': props.isFocused, 'o_pdf_thumbnail_dragover': state.isHover,                            'o_pdf_page_selected': props.isSelected, 'o_pdf_page_preview': props.isPreview,                            'o_pdf_page': !props.isPreview }">
            <div t-if="!props.isPreview" class="o_documents_pdf_button_wrapper">
                <i class="o_documents_pdf_page_selector fa" t-att-class="{'fa-check-circle': props.isSelected, 'fa-circle-thin': !props.isSelected }" aria-label="select" title="select" t-on-click.stop="onClickSelect"/>
            </div>
            <div class="o_documents_pdf_canvas_wrapper" draggable="true" t-on-dragstart.stop="onDragStart" t-on-drop="onDrop" t-on-dragover.stop="onDragOver" t-on-dragenter.stop="onDragEnter" t-on-dragleave.stop="onDragLeave" t-on-click.stop="onClickWrapper" t-ref="canvasWrapper">
                <div t-if="!props.isPreview" class="o_bottom_selection" t-on-click.stop="onClickSelect"/>
            </div>
            <div class="o_documents_pdf_selected_overlay position-absolute start-0 bottom-0 w-100 h-100 pe-none"/>
        </div>
    </t>
`);
registerTemplate("documents.DocumentsViews.ChatterOverlay", `/documents/static/src/views/chatter/documents_chatter_overlay.xml`, `<t t-name="documents.DocumentsViews.ChatterOverlay" xml:space="preserve">
        <div class="documents_chatter_disabled_overlay light position-sticky w-100 h-100"/>
        <div class="documents_chatter_disabled_overlay dark position-sticky w-100 h-100">
            <h1 class="d-block text-center text-white">
                <t t-if="itemsNumber">
                    <t t-out="itemsNumber"/> items selected
                </t>
                <t t-else="">
                    No item selected
                </t>
                <i class="fa fa-files-o d-block mt-3"/>  
            </h1>
        </div>
    </t>
`);
registerTemplate("documents.DocumentCogMenuItem", `/documents/static/src/views/cog_menu/documents_cog_menu_item.xml`, `<t t-name="documents.DocumentCogMenuItem" xml:space="preserve">
        <DropdownItem onSelected.bind="onItemSelected">
            <i t-attf-class="fa fa-fw #{icon} me-1" aria-hidden="true"/><t t-out="label"/>
        </DropdownItem>
    </t>
`);
registerTemplate("documents.DocumentCogMenuPinAction", `/documents/static/src/views/cog_menu/documents_cog_menu_pin_actions.xml`, `<t t-name="documents.DocumentCogMenuPinAction" xml:space="preserve">
        <Dropdown>
            <button class="opacity-trigger-hover">
                <i class="fa fa-fw fa-gear" aria-hidden="true"/>Actions on Select
            </button>
            <t t-set-slot="content">
                <span t-foreach="this.documentsState.actions" t-as="action" t-key="action.id" t-on-click.stop.prevent="() =&gt; this.onEnableAction(action.id)" class="o-dropdown-item dropdown-item" t-att-class="{'selected': action.is_embedded}">
                    <t t-out="action.name"/>
                </span>
                <hr class="dropdown-divider"/>
                <span class="o-dropdown-item dropdown-item" t-on-click.stop.prevent="() =&gt; this.documentService.goToServerActionsView()">
                    Add Custom Action
                </span>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("documents.DocumentsViews.ControlPanel", `/documents/static/src/views/documents_controller_mixin.xml`, `<div t-name="documents.DocumentsViews.ControlPanel" class="o_cp_buttons d-flex gap-1" role="toolbar" aria-label="Control panel buttons" t-ref="cpButtons" xml:space="preserve">
        <t t-set="isShareable" t-value="hasShareDocuments()"/>
        <t t-set="folder" t-value="this.env.searchModel.getSelectedFolder()"/>

        <div class="btn-group me-1">
            <button type="button" class="btn btn-primary dropdown-toggle" data-bs-toggle="dropdown" aria-expanded="false" data-hotkey="c">
                New
            </button>
            <ul class="dropdown-menu o_documents_main_buttons">
                <input type="file" multiple="true" t-ref="uploadFileInput" class="o_input_file o_hidden" t-on-change.stop="onFileInputChange"/>
                <button type="button" class="btn btn-link dropdown-item o_documents_kanban_upload" t-att-disabled="!canUploadInFolder(folder)" t-on-click.prevent="() =&gt; this.uploadFileInputRef.el.click()" data-hotkey="a">
                    <i class="fa fa-upload me-2"/>
                    <span>Upload</span>
                </button>
                <button type="button" class="btn btn-link dropdown-item o_documents_kanban_request" t-if="userIsInternal" t-att-disabled="!canUploadInFolder(folder) || folder.id === 'COMPANY'" t-on-click.prevent="onClickDocumentsRequest" data-hotkey="r">
                    <i class="fa fa-paper-plane-o me-2"/>
                    <span>Request</span>
                </button>
                <button type="button" class="btn btn-link dropdown-item o_documents_kanban_url" t-if="userIsInternal" t-att-disabled="!canUploadInFolder(folder)" t-on-click.prevent="onClickDocumentsAddUrl" data-hotkey="l">
                    <i class="fa fa-link me-2"/>
                    <span>Link</span>
                </button>
                <t t-if="userIsInternal and canUploadInFolder(folder)">
                    <div class="dropdown-divider"/>
                    <button type="button" t-on-click.prevent="onClickAddFolder" class="btn btn-link dropdown-item o_documents_kanban_workspace" data-hotkey="w">
                        <i class="fa fa-folder me-2"/>
                        <span>Folder</span>
                    </button>
                </t>
            </ul>
        </div>
        <t t-set="shareTitle">
            <t t-if="this.targetRecords.length &gt; 1">You cannot share multiple documents at the same time</t>
            <t t-elif="folder.id === 'TRASH'">Documents in the Trash cannot be shared</t>
            <t t-elif="!selectionCount and (!folder.id or typeof folder.id !== 'number')">Special folders cannot be shared</t>
            <t t-else="">Open the permissions panel</t>
        </t>
    </div>
`);
registerTemplate("documents.DocumentsTypeIcon", `/documents/static/src/views/documents_type_icon/documents_type_icon.xml`, `<t t-name="documents.DocumentsTypeIcon" xml:space="preserve">
        <t t-set="recordOrShortcutTarget" t-value="this.props.record.shortcutTarget || this.props.record"/>
        <t t-set="mimetype" t-value="recordOrShortcutTarget.data['mimetype']"/>
        <t t-set="type" t-value="this.props.record.data['type']"/>

        <i t-if="type === 'folder'" class="fa fa-folder-o ms-1" title="Folder"/>
        <i t-elif="type === 'url'" class="fa fa-link ms-1" title="Link"/>
        <i t-elif="type === 'binary' and mimetype" class="o_documents_mimetype_icon o_image" t-att-data-mimetype="mimetype" t-att-title="mimetype"/>
        <i t-else="" class="fa fa-file-o ms-1" title="File"/>
    </t>

`);
registerTemplate("documents.DocumentsActionHelper", `/documents/static/src/views/helper/documents_action_helper.xml`, `<t t-name="documents.DocumentsActionHelper" xml:space="preserve">
        <div class="o_view_nocontent">
            <div class="o_nocontent_help">
                <t t-out="noContentHelp"/>
                <t t-if="selectedFolderId and !['MY', 'RECENT', 'SHARED', 'TRASH', 'COMPANY'].includes(selectedFolderId)">
                    <div t-if="state.mailTo">
                        <p class="fw-normal">Or send emails to
                            <a t-attf-href="mailto:{{state.mailTo}}">
                                <t t-esc="state.mailTo"/>
                            </a>
                        </p>
                        <p class="fw-normal"><em>Tip: configure your scanner to send all documents to this address.</em></p>
                    </div>
                    <p t-else="">No alias configured</p>
                </t>
            </div>
        </div>
    </t>
`);
registerTemplate("documents.DocumentsDropZone", `/documents/static/src/views/helper/documents_drop_zone.xml`, `<t t-name="documents.DocumentsDropZone" xml:space="preserve">
        <t t-if="state.dragOver">
            <div class="h-100 w-100 start-0 position-absolute" t-att-class="{'o_documents_drop_over_zone': canDrop, 'o_documents_drop_over_unauthorized_zone': !canDrop}" t-attf-style="top: {{state.topOffset}}px !important; z-index: 10;" t-on-drop.prevent="onDrop">
                <div class="h-100 w-100 position-sticky">
                    <div t-if="canDrop" class="o_documents_upload_text text-center text-white">
                        <i class="d-block fa fa-upload fa-9x mb-4"/>
                        <span>Drop files here to upload</span>
                    </div>
                    <div t-else="" class="o_documents_upload_text text-center text-danger">
                        <i class="d-block fa fa-times-circle fa-9x mb-4"/>
                        <span>You must be in a specific writable workspace to upload files</span>
                    </div>
                </div>
            </div>
        </t>
    </t>
`);
registerTemplate("documents.DocumentsFileViewer", `/documents/static/src/views/helper/documents_file_viewer.xml`, `<t t-name="documents.DocumentsFileViewer" xml:space="preserve">
        <div t-if="props.previewStore.attachments" t-ref="root" t-attf-style="top: {{state.topOffset}}px !important; left: {{state.leftOffset}}px !important; z-index: 990; background-color: rgba(0, 0, 0, 0.7);" class="position-absolute w-100 h-100 start-0 d-flex justify-content-center align-items-center" t-on-keydown="onGlobalKeydown">
            <FileViewer files="props.previewStore.attachments" startIndex="props.previewStore.startIndex" modal="false"/>
        </div>
    </t>
`);
registerTemplate("documents.DocumentsKanbanView", `/documents/static/src/views/kanban/documents_kanban_controller.xml`, `<t t-name="documents.DocumentsKanbanView" t-inherit="web.KanbanView" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//Layout" position="attributes">
            <attribute name="className">(model.useSampleModel ? 'o_view_sample_data' : '') + ' o_documents_content o_documents_kanban'</attribute>
        </xpath>
        <xpath expr="//Layout" position="inside">
            <t t-set-slot="control-panel-create-button">
                <t t-call="documents.DocumentsViews.ControlPanel"/>
            </t>


            <t t-set-slot="layout-actions"/>

            <t t-set-slot="control-panel-selection-actions">
                <t t-call="web.ListView.Selection" t-if="model.root.selection.length">
                    <t t-set="isDomainSelected" t-value="false"/>
                    <t t-set="isPageSelected" t-value="false"/>
                    <t t-set="nbSelected" t-value="model.root.selection.length"/>
                </t>
            </t>
        </xpath>
        <xpath expr="//t[@t-component='searchBarToggler.component']" position="attributes">
            <attribute name="t-if">!model.root.selection.length</attribute>
        </xpath>
        <xpath expr="//Layout/t[@t-component='props.Renderer']" position="attributes">
            <attribute name="previewStore">documentStates.previewStore</attribute>
        </xpath>
    </t>
`);
registerTemplate("documents.DocumentsKanbanRenderer", `/documents/static/src/views/kanban/documents_kanban_renderer.xml`, `<t t-name="documents.DocumentsKanbanRenderer" t-inherit="web.KanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_kanban_renderer')]" position="attributes">
            <attribute name="class" add="o_documents_view o_renderer_with_search_panel position-relative" separator=" "/>
            <attribute name="t-on-click">onGlobalClick</attribute>
        </xpath>
        <xpath expr="//div[hasclass('o_kanban_renderer')]" position="after">

            <t t-set="chatterRecord" t-value="targetRecords.length === 0  ? this.getContainerRecord() : targetRecords[0]"/>
            <t t-set="multipleSelection" t-value="targetRecords.length &gt; 1"/>
            <t t-set="chatterDisabled" t-value="multipleSelection || !chatterRecord.data || typeof chatterRecord.data.id !== 'number'"/>
            <div t-if="this.chatterState.visible" class="o_document_chatter_container o-mail-ChatterContainer" t-att-class="{'mt-2': isMobile, 'h-100 o-aside': !isMobile, 'documents_chatter_disabled': chatterDisabled, 'd-flex flex-column' : !chatterDisabled}" t-ref="chatterContainer">
                <t t-if="chatterDisabled" t-call="documents.DocumentsViews.ChatterOverlay">
                    <t t-if="multipleSelection" t-set="itemsNumber" t-value="targetRecords.length"/>
                </t>
                <DocumentsDetailsPanel t-if="!chatterDisabled" record="chatterRecord" nbViewItems="getNbViewItems()"/>
                <Chatter t-if="chatterRecord.data and documentService.userIsInternal" has_activities="!chatterRecord.data.res_model || chatterRecord.data.res_model === 'documents.document'" threadId="typeof chatterRecord.data.id === 'number' and chatterRecord.data.id" threadModel="'documents.document'" compactHeight="true" isChatterAside="!isMobile"/>
            </div>
        </xpath>
        <xpath expr="//div[hasclass('o_kanban_renderer')]" position="inside">
            <DocumentsDropZone parentRoot="root"/>
            <DocumentsFileViewer parentRoot="root" t-props="getDocumentsAttachmentViewerProps()"/>
        </xpath>
        <t t-foreach="getGroupsOrRecords()" position="attributes">
            <attribute name="t-if" add="!this.isRecentFolder" separator="and"/>
        </t>
        <t t-foreach="getGroupsOrRecords()" position="before">
            <div t-if="this.isRecentFolder" class="w-100">

                <div t-foreach="getGroupsOrRecords()" t-as="group" t-key="group.key" class="d-flex flex-row flex-wrap">
                    <h3 class="o_documents_title m-2 border-bottom w-100" t-out="group.group.displayName"/>
                    <t t-set="folders" t-value="group.group.list.records.filter((d) =&gt; d.data.type === 'folder')"/>
                    <t t-set="files" t-value="group.group.list.records.filter((d) =&gt; d.data.type !== 'folder')"/>
                    <div t-foreach="folders" t-as="record" t-key="record.id">
                        <t t-set="group" t-as="group.group"/>
                        <KanbanRecord archInfo="props.archInfo" list="props.list" record="record" templates="props.archInfo.templateDocs"/>
                    </div>
                    <div class="w-100"/>
                    <div t-foreach="files" t-as="record" t-key="record.id">
                        <t t-set="group" t-as="group.group"/>
                        <KanbanRecord archInfo="props.archInfo" list="props.list" record="record" templates="props.archInfo.templateDocs"/>
                    </div>
                </div>
            </div>
            <t t-if="hasFolders() and !this.props.list.isGrouped">
                <h3 class="o_documents_title m-2 w-100 fs-4">Folders</h3>
                <t t-foreach="getFolderRecords()" t-as="folderRecord" t-key="folderRecord.key">
                    <KanbanRecord archInfo="props.archInfo" list="props.list" record="folderRecord.record" templates="props.archInfo.templateDocs"/>
                </t>

                <div t-foreach="[,,,,,,]" t-as="i" t-key="i_index" class="o_kanban_record o_kanban_ghost flex-grow-1 flex-md-shrink-1 flex-shrink-0"/>
                <h3 t-if="hasFiles()" class="o_documents_title m-2 w-100 fs-4">Files</h3>
            </t>
            <FileUploadProgressContainer fileUploads="this.documentUploads" Component="constructor.components.FileUploadProgressKanbanRecord" shouldDisplay="(upload) =&gt; !upload.data.get('document_id')"/>
        </t>
        <t t-call="web.ActionHelper" position="replace">
            <t t-if="props.noContentHelp">
                <DocumentsActionHelper noContentHelp="props.noContentHelp"/>
            </t>
        </t>
    </t>
`);
registerTemplate("documents.DocumentsListController", `/documents/static/src/views/list/documents_list_controller.xml`, `<t t-name="documents.DocumentsListController" t-inherit="web.ListView" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//Layout" position="attributes">
            <attribute name="className">(model.useSampleModel ? 'o_view_sample_data' : '') + ' o_documents_content'</attribute>
        </xpath>
        <xpath expr="//Layout" position="inside">
            <t t-set-slot="control-panel-create-button">
                <t t-call="documents.DocumentsViews.ControlPanel"/>
            </t>


            <t t-set-slot="layout-actions"/>
            <t t-set-slot="control-panel-selection-actions">

                <div t-if="hasSelectedRecords" class="o_list_selection_container m-1 m-md-0 d-flex gap-1">
                    <t t-call="web.ListView.Selection"/>
                </div>
            </t>

        </xpath>
        <xpath expr="//Layout/t[@t-component='props.Renderer']" position="attributes">
            <attribute name="previewStore">documentStates.previewStore</attribute>
        </xpath>
    </t>
`);
registerTemplate("documents.DocumentsListRenderer", `/documents/static/src/views/list/documents_list_renderer.xml`, `<t t-name="documents.DocumentsListRenderer" t-inherit="web.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_list_renderer')]" position="attributes">
            <attribute name="class">o_list_renderer o_documents_view o_renderer_with_searchpanel overflow-auto position-relative</attribute>
            <attribute name="t-on-keydown">onGlobalKeydown</attribute>
            <attribute name="t-on-click">onGlobalClick</attribute>
        </xpath>
        <xpath expr="//div[hasclass('o_list_renderer')]" position="after">

            <t t-set="chatterRecord" t-value="targetRecords.length === 0  ? this.getContainerRecord() : targetRecords[0]"/>
            <t t-set="multipleSelection" t-value="targetRecords.length &gt; 1"/>
            <t t-set="chatterDisabled" t-value="multipleSelection || !chatterRecord?.data || typeof chatterRecord?.data.id !== 'number'"/>
            <div t-if="this.chatterState.visible" class="o_document_chatter_container o-mail-ChatterContainer" t-att-class="{'mt-2': isMobile, 'h-100 o-aside': !isMobile, 'documents_chatter_disabled': chatterDisabled, 'd-flex flex-column' : !chatterDisabled}" t-ref="chatterContainer">
                <t t-if="chatterDisabled" t-call="documents.DocumentsViews.ChatterOverlay">
                    <t t-if="multipleSelection" t-set="itemsNumber" t-value="targetRecords.length"/>
                </t>
                <DocumentsDetailsPanel t-if="!chatterDisabled" record="chatterRecord" nbViewItems="getNbViewItems()"/>
                <Chatter t-if="chatterRecord.data and documentService.userIsInternal" has_activities="!chatterRecord.data.res_model || chatterRecord.data.res_model === 'documents.document'" threadId="typeof chatterRecord.data.id === 'number' and chatterRecord.data.id" threadModel="'documents.document'" compactHeight="true" isChatterAside="!isMobile"/>
            </div>
        </xpath>
        <table position="before">
            <DocumentsDropZone parentRoot="root"/>
            <DocumentsFileViewer parentRoot="root" t-props="getDocumentsAttachmentViewerProps()"/>
            <FileUploadProgressContainer fileUploads="this.documentUploads" Component="constructor.components.FileUploadProgressDataRow" shouldDisplay="(upload) =&gt; !upload.data.get('document_id')"/>
        </table>
        <t t-call="web.ActionHelper" position="replace">
            <t t-if="showNoContentHelper">
                <DocumentsActionHelper noContentHelp="props.noContentHelp"/>
            </t>
        </t>
    </t>

    `);
registerTemplate("documents.DocumentsListRenderer.RecordRow", `/documents/static/src/views/list/documents_list_renderer.xml`, `<t t-name="documents.DocumentsListRenderer.RecordRow" t-inherit="web.ListRenderer.RecordRow" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//tr[hasclass('o_data_row')]" position="attributes">
            <attribute name="draggable">true</attribute>
            <attribute name="t-on-dragstart.stop">(ev) =&gt; record.onDragStart(ev)</attribute>
            <attribute name="t-on-dragenter.stop">onDragEnter</attribute>
            <attribute name="t-on-dragleave.stop">onDragLeave</attribute>
            <attribute name="t-on-dragover.stop.prevent">onDragOver</attribute>
            <attribute name="t-on-drop.stop">onDrop</attribute>
            <attribute name="t-on-click.stop.prevent.synthetic"/>
        </xpath>
        <xpath expr="//td[hasclass('o_list_record_selector')]" position="attributes">
            <attribute name="t-on-click.stop">() =&gt; this.toggleRecordSelection(record)</attribute>
        </xpath>
        <CheckBox position="replace">
            <DocumentsListRendererCheckBox disabled="!!editedRecord or props.list.model.useSampleModel" value="record.selected" onChange.bind="() =&gt; this.toggleRecordSelection(record)"/>
        </CheckBox>
    </t>

    `);
registerTemplate("documents.DocumentsListRendererCheckBox", `/documents/static/src/views/list/documents_list_renderer.xml`, `<t t-name="documents.DocumentsListRendererCheckBox" xml:space="preserve">
        <div class="form-check" t-att-class="props.className" t-ref="root">
            <input t-att-id="props.id or id" type="checkbox" class="form-check-input" t-att-disabled="props.disabled" t-att-checked="props.value" t-att-name="props.name"/>
            <label t-att-for="props.id or id" class="form-check-label">
                <t t-slot="default"/>
            </label>
        </div>
    </t>
`);
registerTemplate("documents.ControlPanel", `/documents/static/src/views/search/documents_control_panel.xml`, `<t t-name="documents.ControlPanel" t-inherit="web.ControlPanel" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-else='']/Breadcrumbs" position="replace">
            <DocumentsBreadcrumbs breadcrumbs="pathBreadcrumbs"/>
        </xpath>

        <xpath expr="//div[hasclass('o_control_panel_actions')]" position="inside">
            <t t-set="selectionCount" t-value="targetRecords.length"/>
            <t t-set="singleSelection" t-value="selectionCount === 1 and targetRecords[0]"/>
            <t t-set="someArchived" t-value="targetRecords.some((r) =&gt; !r.data.active)"/>
            <t t-set="someActive" t-value="targetRecords.some((r) =&gt; r.data.active)"/>
            <t t-set="isInTrash" t-value="currentFolderId === 'TRASH'"/>
            <t t-set="userIsInternal" t-value="documentService.userIsInternal"/>
            <t t-set="editMode" t-value="targetRecords.every((r) =&gt; r.data.user_permission === 'edit')"/>

            <SearchBar t-if="!selectionCount" toggler="env.searchBarToggler" autofocus="firstLoad"/>

            <div class="btn-group flex-wrap">
                <div t-if="selectionCount" class="ms-1 o_documents_action_dropdown btn-group">
                    <div class="dropdown" t-att-class="{'btn-group': singleSelection || targetRecords.some((r) =&gt; r.data.attachment_id and r.data?.handler !== 'spreadsheet')}">
                        <button class="btn btn-secondary o_dropdown_title" type="button" data-bs-toggle="dropdown" aria-expanded="false" t-on-click="() =&gt; this.onDropdownOpen()">
                            <i class="fa fa-gear"/>
                            Action
                        </button>
                        <ul class="dropdown-menu">
                            <button class="dropdown-item w-100 o_documents_export" t-if="this.canExport and this.documentsState.viewType === 'list'" t-on-click="() =&gt; this.onExport()">
                                <i class="fa fa-fw fa-upload me-1"/>
                                <span class="d-inline-block">Export</span>
                            </button>
                            <button class="dropdown-item w-100" t-on-click="() =&gt; this.onDuplicate()" t-if="canDuplicateSelection">
                                <i class="fa fa-fw fa-copy me-1"/>
                                <span class="d-inline-block">Duplicate</span>
                            </button>
                            <button class="dropdown-item w-100" t-on-click="() =&gt; this.onArchive()" t-if="userIsInternal and editMode and someActive">
                                <i class="fa fa-fw fa-trash me-1"/>
                                <span class="d-inline-block">Move to Trash</span>
                            </button>
                            <button class="dropdown-item w-100" t-on-click="() =&gt; this.onRestore()" t-if="someArchived">
                                <i class="fa fa-fw fa-history me-1"/>
                                <span class="d-inline-block">Restore</span>
                            </button>
                            <button class="dropdown-item w-100" t-on-click="() =&gt; this.onDelete()" t-if="areTargetRecordsDeletable">
                                <i class="fa fa-fw fa-trash me-1"/>
                                <span class="d-inline-block">Delete</span>
                            </button>
                            <div role="separator" class="dropdown-divider"/>
                            <button class="dropdown-item w-100" t-on-click="() =&gt; this.onRename()" t-if="(userIsInternal or editMode) and singleSelection and !isInTrash">
                                <i class="fa fa-fw fa-edit me-1"/>
                                <span class="d-inline-block">Rename</span>
                            </button>
                            <button class="dropdown-item w-100" t-on-click="() =&gt; this.onToggleChatter()" t-if="userIsInternal and singleSelection">
                                <i class="fa fa-fw fa-info-circle me-1"/>
                                <span class="d-inline-block">Info &amp; tags </span>
                            </button>
                            <button class="dropdown-item w-100" t-on-click="() =&gt; this.onCreateShortcut()" t-if="userIsInternal and singleSelection and !isInTrash">
                                <i class="fa fa-fw fa-external-link-square me-1"/>
                                <span class="d-inline-block">Create Shortcut</span>
                            </button>
                            <button class="o_documents_manage_versions dropdown-item w-100" t-on-click="() =&gt; this.onManageVersions()" t-if="canManageVersions">
                                <i class="fa fa-fw fa-history me-1"/>
                                <span class="d-inline-block">Manage Versions</span>
                            </button>
                            <button class="dropdown-item w-100" t-on-click="() =&gt; this.onToggleLock()" t-if="userIsInternal and singleSelection and !isInTrash">
                                <i class="fa fa-fw fa-lock me-1"/>
                                <span class="d-inline-block" t-if="singleSelection?.data.lock_uid">Unlock</span>
                                <span class="d-inline-block" t-else="">Lock</span>
                            </button>
                            <button class="dropdown-item w-100" t-on-click="() =&gt; this.onCopyLinks()" t-if="selectionCount and !isInTrash">
                                <i class="fa fa-fw fa-link me-1"/>
                                <span class="d-inline-block">Copy Links</span>
                            </button>
                            <button class="dropdown-item w-100" t-on-click="() =&gt; this.onSplitPDF()" t-if="userIsInternal and selectionCount and targetRecords.every((record) =&gt; record.isPdf()) and !isInTrash">
                                <i class="fa fa-fw fa-scissors me-1"/>
                                <span class="d-inline-block" t-if="singleSelection">Split PDF</span>
                                <span class="d-inline-block" t-else="">Merge PDFs</span>
                            </button>
                        </ul>
                    </div>
                </div>

                <button type="button" class="btn btn-secondary o_documents_share_button" t-if="!isInTrash and documentService.userIsInternal and selectionCount === 1" t-on-click="() =&gt; this.onShare()">
                    Share
                </button>

                <button type="button" class="btn btn-secondary o_documents_download_button" t-if="this.targetRecords.some((r) =&gt; !r.isRequest())" t-on-click="() =&gt; this.onDownload()">
                    Download
                </button>

                <t t-set="_embeddedActions" t-value="embeddedActions"/>
                <div t-if="!isInTrash and _embeddedActions.length" class="d-flex flex-row flex-wrap btn-group">
                    <t t-set="firstEmbeddedActions" t-value="_embeddedActions.slice(0, 2)"/>
                    <t t-set="lastEmbeddedActions" t-value="_embeddedActions.slice(2)"/>

                    <button t-foreach="firstEmbeddedActions" t-as="action" t-key="action.id" type="button" class="btn btn-secondary" t-out="action.name" t-if="!!selectionCount" t-on-click="() =&gt; this.onDoAction(action.id)"/>

                    <div class="dropdown btn-group" t-if="lastEmbeddedActions?.length">
                        <button class="btn btn-secondary o_dropdown_title dropdown-toggle" type="button" data-bs-toggle="dropdown" aria-expanded="false" t-if="!!selectionCount">
                            More
                        </button>
                        <ul class="dropdown-menu">
                            <li t-foreach="lastEmbeddedActions" t-as="action" t-key="action.id" class="d-flex flex-row">
                                <button type="button" class="dropdown-item btn btn-secondary mx-1" t-out="action.name" t-on-click="() =&gt; this.onDoAction(action.id)"/>
                            </li>
                        </ul>
                    </div>
                </div>
            </div>
        </xpath>

        <xpath expr="//*[hasclass('o_cp_switch_buttons')]" position="before">
            <button t-if="documentService.userIsInternal" t-on-click="() =&gt; this.onToggleChatter()" data-tooltip="Info &amp; tags" class="btn btn-secondary o_switch_view o_kanban" t-att-class="{'active': this.documentsState.isChatterVisible}">
                <i class="fa fa-fw fa-info-circle mt-1"/>
            </button>
        </xpath>
    </t>

`);
registerTemplate("documents.SearchPanelContent", `/documents/static/src/views/search/documents_search_panel.xml`, `<t t-name="documents.SearchPanelContent" t-inherit="web.SearchPanelContent" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_search_panel')]" position="attributes">
            <attribute name="class" remove="pe-1 ps-3"/>
        </xpath>
        <xpath expr="//section" position="attributes">
            <attribute name="t-att-data-section-id">section.id</attribute>
        </xpath>
        <xpath expr="//button[@t-on-click='toggleSidebar']" position="replace"/>
        <xpath expr="//header" position="replace"/>
    </t>

    `);
registerTemplate("documents.SearchPanel.Regular", `/documents/static/src/views/search/documents_search_panel.xml`, `<t t-name="documents.SearchPanel.Regular" t-inherit="documents.SearchPanelContent" t-inherit-mode="primary" xml:space="preserve"/>

    `);
registerTemplate("documents.SearchPanel.Category", `/documents/static/src/views/search/documents_search_panel.xml`, `<t t-name="documents.SearchPanel.Category" t-inherit="web.SearchPanel.Category" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//li[contains(@class, 'o_search_panel_category_value')]" position="attributes">
            <attribute name="t-if">valueId || !this.env.model.config.context.active_model</attribute>
            <attribute name="class" add="pe-0" separator=" "/>
            <attribute name="t-att-class">{
                    'o_treeEntry' : isChildList,
                    'o_has_treeEntry': value.childrenIds.length,
                    'o_all_or_trash_category' : !valueId || valueId === 'TRASH'
                }
            </attribute>
            <attribute name="t-att-title">value.display_name</attribute>
            <attribute name="t-att-data-value-id">valueId</attribute>
            <attribute name="t-on-dragenter.stop.prevent">(ev) =&gt; this.onDragEnter(section, value, ev)</attribute>
            <attribute name="t-on-dragleave.stop.prevent">(ev) =&gt; this.onDragLeave(section, ev)</attribute>
            <attribute name="t-on-dragover.stop.prevent">(ev) =&gt; this.onDragOver(section, value, ev)</attribute>
            <attribute name="t-on-drop.stop.prevent">(ev) =&gt; this.onDrop(section, value, ev)</attribute>
        </xpath>
        <xpath expr="//header" position="attributes">
            <attribute name="t-on-click"/>
        </xpath>
        <xpath expr="//*[hasclass('o_search_panel_label')]" position="replace">
            <div class="o_search_panel_label d-flex align-items-center overflow-hidden w-100 cursor-pointer mb-0" t-att-class="{'o_with_counters': section.enableCounters}" t-att-data-tooltip="value.display_name">
                <button class="o_toggle_fold btn p-0 px-1 flex-shrink-0 text-center" t-att-class="{'invisible': !value.childrenIds.length}" t-on-click="() =&gt; this.toggleFold(section, value)">
                    <i t-attf-class="fa fa-caret-{{ this.state.expanded[section.id][valueId] ? 'down' : 'right' }} {{ typeof valueId === 'number' ? 'mx-1' : 'me-1' }}"/>
                </button>
                <div class="w-100 d-flex align-items-baseline" t-on-click="() =&gt; this.toggleCategory(section, value)">
                    <i t-if="typeof valueId !== 'number'" t-attf-class="fa {{ this.constructor.rootIcons[valueId] }} ms-1"/>
                    <span class="o_search_panel_label_title text-truncate" t-att-class="{'fw-bold' : value.bold, 'ps-1': typeof valueId !== number}" t-out="value.display_name"/>
                    <div class="ms-auto">
                        <i t-if="value.shortcut_document_id" class="o_documents_search_panel_section_edit me-1 fa fa-external-link" title="This is a shortcut"/>
                        <span t-if="isUploadingInFolder(valueId)" class="fa fa-circle-o-notch fa-spin"/>
                    </div>
                </div>
            </div>
        </xpath>
    </t>

    `);
registerTemplate("documents.SearchPanel.FiltersGroup", `/documents/static/src/views/search/documents_search_panel.xml`, `<t t-name="documents.SearchPanel.FiltersGroup" t-inherit="web.SearchPanel.FiltersGroup" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//li[contains(@class, 'o_search_panel_filter_value')]" position="attributes">
            <attribute name="t-on-dragenter.stop.prevent">(ev) =&gt; this.onDragEnter(section, values.get(valueId), ev)</attribute>
            <attribute name="t-on-dragleave.stop.prevent">(ev) =&gt; this.onDragLeave(section, ev)</attribute>
            <attribute name="t-on-dragover.stop.prevent"> </attribute>
            <attribute name="t-on-drop.stop.prevent">(ev) =&gt; this.onDrop(section, values.get(valueId), ev)</attribute>
            <attribute name="class">o_documents_search_panel_editable</attribute>
        </xpath>
        <xpath expr="//div//label//span[contains(@class, 'o_search_panel_counter')]" position="replace"/>
        <xpath expr="//div//label//span[hasclass('o_search_panel_counter')]" position="attributes">
            <attribute name="class" add="ms-2 me-3" remove="mx-2" separator=" "/>
        </xpath>
    </t>

    `);
registerTemplate("documents.SearchPanel.Small", `/documents/static/src/views/search/documents_search_panel.xml`, `<t t-name="documents.SearchPanel.Small" t-inherit="web.SearchPanel.Small" t-inherit-mode="primary" xml:space="preserve"/>

    `);
registerTemplate("documents.SearchPanel", `/documents/static/src/views/search/documents_search_panel.xml`, `<t t-name="documents.SearchPanel" t-inherit="web.SearchPanel" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-call='web.SearchPanel.Regular']" position="attributes">
            <attribute name="t-call">documents.SearchPanel.Regular</attribute>
        </xpath>
    </t>

    `);
registerTemplate("documents.SearchPanel.Category.Small", `/documents/static/src/views/search/documents_search_panel.xml`, `<t t-name="documents.SearchPanel.Category.Small" t-inherit="documents.SearchPanel.Category" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//li[contains(@class, 'o_search_panel_category_value')]" position="attributes">
            <attribute name="t-on-touchstart">(ev) =&gt; this.onSectionValueTouchStart(ev, section, value.id)</attribute>
            <attribute name="t-on-touchend">(ev) =&gt; this.onSectionValueTouchEnd()</attribute>
            <attribute name="t-on-touchmove">(ev) =&gt; this.onSectionValueTouchMove()</attribute>
        </xpath>
    </t>

    `);
registerTemplate("documents.SearchPanel.FiltersGroup.Small", `/documents/static/src/views/search/documents_search_panel.xml`, `<t t-name="documents.SearchPanel.FiltersGroup.Small" t-inherit="web.SearchPanel.FiltersGroup" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//li[contains(@class, 'o_search_panel_filter_value')]" position="attributes">
            <attribute name="t-on-touchstart">(ev) =&gt; this.onSectionValueTouchStart(ev, section, valueId)</attribute>
            <attribute name="t-on-touchend">(ev) =&gt; this.onSectionValueTouchEnd()</attribute>
            <attribute name="t-on-touchmove">(ev) =&gt; this.onSectionValueTouchMove()</attribute>
        </xpath>
    </t>

    `);
registerTemplate("documents.DocumentsSearchPanelItemSettingsPopover", `/documents/static/src/views/search/documents_search_panel.xml`, `<t t-name="documents.DocumentsSearchPanelItemSettingsPopover" xml:space="preserve">
        <div class="o_search_panel_value_edit list-group">
            <a t-if="props.createChildEnabled" t-on-click.stop.prevent="props.onCreateChild" class="o_search_panel_value_edit_create py-1 list-group-item list-group-item-action row d-flex justify-content-between align-items-center g-0 cursor-pointer">
                New Folder
            </a>
            <a t-if="props.isEditable" t-on-click.stop.prevent="props.onEdit" class="o_search_panel_value_edit_edit py-1 list-group-item list-group-item-action row d-flex justify-content-between align-items-center g-0 cursor-pointer">
                Edit
            </a>
            <a t-if="props.isShareable" t-on-click.stop.prevent="props.onShare" class="o_search_panel_value_share py-1 list-group-item list-group-item-action row d-flex justify-content-between align-items-center g-0 cursor-pointer">
                Share
            </a>
        </div>
    </t>
`);
registerTemplateExtension("mail.ActivityMenu", `/documents/static/src/web/activity/activity_menu_patch.xml`, `<t t-inherit="mail.ActivityMenu" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@name='activityGroups']" position="inside">
            <a t-if="store.hasDocumentsUserGroup" t-on-click="onClickRequestDocument" href="#" class="o_sys_documents_request list-group-item list-group-item-action p-2 border-0 text-primary text-center">
                Request a Document
            </a>
        </xpath>
    </t>
`);
registerTemplate("documents.Breadcrumbs", `/documents/static/src/components/documents_breadcrumbs.xml`, `<t t-name="documents.Breadcrumbs" t-inherit="web.Breadcrumbs" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_breadcrumb')]" position="attributes">
            <attribute name="class" remove="align-self-stretch" add="cursor-pointer" separator=" "/>
        </xpath>
        <xpath expr="//div[hasclass('o_last_breadcrumb_item')]" position="after">
            <DocumentsCogMenu/>
        </xpath>
    </t>

`);
registerTemplate("documents.DocumentsDetailsPanel", `/documents/static/src/components/documents_details_panel/documents_details_panel.xml`, `<t t-name="documents.DocumentsDetailsPanel" xml:space="preserve">
        <div t-if="record?.data" class="o_documents_details_panel p-3 pb-2 border-bottom border-secondary w-100" t-att-class="{'o_documents_details_panel_folder': record.data.type === 'folder'}">

            <div class="mt-1 mb-3 w-100 d-flex align-items-center">
                <div class="d-flex align-items-center me-3 flex-grow-1">
                    <i class="fa fa-folder-o me-1"/>
                    <div t-if="userPermissionViewOnly">
                        <span t-out="record.data.folder_id?.[1] || rootFolderPlaceholder" class="me-1"/> / <span t-out="record.data.name" class="mx-1"/>
                    </div>
                    <t t-else="">
                        <div class="w-25">
                            <Many2OneField name="'folder_id'" record="record" canOpen="false" canCreate="false" canQuickCreate="false" canCreateEdit="false" placeholder="rootFolderPlaceholder"/>
                        </div>
                        <div>
                            /
                            <div class="o_field_widget o_field_char ms-2 w-60">
                                <CharField name="'name'" record="record"/>
                            </div>
                        </div>
                    </t>
                    <div>
                        <i class="fa fa-fw fa-lock mx-1" title="Locked" t-if="record.data.lock_uid"/>
                        <button class="btn mx-1 p-0 border-0" t-if="record.data.shortcut_document_id" t-on-click="() =&gt; record.jumpToTarget()" data-tooltip="This is a shortcut - Click to access source document">
                            <i class="fa fa-external-link"/>
                        </button>
                    </div>
                    <div t-if="fileSize" t-attf-class="text-nowrap ms-auto">
                        (<span t-if="record.isContainer"><t t-out="props.nbViewItems"/> items, </span><t t-out="fileSize"/>)
                    </div>
                </div>
            </div>


             <div t-if="record" class="basic-info mb-3 d-flex justify-content-between">
                 <div class="d-flex me-2 align-items-center">
                     <span class="fw-bold me-2">Owner</span>
                     <div class="o_field_widget o_field_many2one">
                         <Many2OneAvatarField name="'owner_id'" readonly="userPermissionViewOnly" record="record" canOpen="false" canCreate="true" canQuickCreate="false" canCreateEdit="false"/>
                     </div>
                 </div>


                 <div class="d-flex mx-auto align-items-center">
                     <span class="fw-bold me-2">Contact</span>
                     <div class="o_field_widget o_field_many2one">
                         <Many2OneAvatarField name="'partner_id'" readonly="userPermissionViewOnly" record="record" canOpen="false" canCreate="true" canQuickCreate="false" canCreateEdit="false"/>
                     </div>
                </div>
             </div>


            <div t-if="record.data.res_model and record.data.res_model !== 'documents.document'" class="mb-2">
                <span class="fw-bold me-2">Linked To</span>
                <a href="#" t-on-click.stop="openLinkedRecord" t-out="record.data.res_name"/>
            </div>


            <div t-if="record.data.type !== 'folder'" class="o_field_widget o_field_many2many_tags d-flex mb-3 w-100">
                <DocumentsDetailsMany2ManyTagsField name="'tag_ids'" readonly="userPermissionViewOnly" record="record" canCreate="true" canQuickCreate="true" canCreateEdit="true" placeholder.translate="Add a tag..." colorField="'color'"/>
            </div>


            <div t-if="record.data.type === 'folder' and !record.data.shortcut_document_id" class="text-dark d-flex mb-3 w-100">
                <span class="fw-bold me-2 text-nowrap">Email</span>
                <div t-if="!userPermissionViewOnly and !!documentService.userIsDocumentManager" class="d-flex">
                    <div t-if="false">
                        <button class="btn btn-sm btn-link mt-0 pt-0" t-on-click.stop="() =&gt; this.action.doAction('documents.settings_action')">
                            <i class="o_button_icon oi oi-fw oi-arrow-right me-1"/>
                            Choose or Configure Email Servers
                        </button>
                    </div>
                    <t t-else="">
                        <div class="o_field_widget o_field_char w-50">
                            <CharField name="'alias_name'" record="record" placeholder.translate="alias"/>
                        </div>
                        <span class="me-2">@</span>
                        <div class="o_field_widget o_field_many2one w-50">
                            <Many2OneField name="'alias_domain_id'" record="record" canOpen="false" canCreate="documentService.userIsErpManager" canCreateEdit="documentService.userIsErpManager" canQuickCreate="documentService.userIsErpManager" placeholder.translate="e.g. mycompany.com"/>
                        </div>
                    </t>
                </div>
                <div t-elif="record.data.alias_name and record.data.alias_domain_id">
                    <t t-out="record.data.alias_name"/>@<t t-out="record.data.alias_domain_id[1]"/>
                </div>
                <div t-else="" class="fw-lighter">
                    Not set
                </div>
            </div>
            <div t-if="record.data.type === 'folder' and !record.data.shortcut_document_id and record.data.alias_name and record.data.alias_domain_id" class="basic-info mb-3 d-flex justify-content-between">
                 <div class="d-flex me-2 align-items-center">
                     <span class="fw-bold me-2 text-nowrap">Activity type</span>
                    <div class="o_field_widget o_field_many2one">
                        <Many2OneField name="'create_activity_type_id'" readonly="userPermissionViewOnly" record="record" canOpen="false" canCreate="false" canCreateEdit="documentService.userIsErpManager" canQuickCreate="false" placeholder.translate="No activity"/>
                    </div>
                </div>
                <div class="o_field_widget o_field_many2one">
                    <Many2OneAvatarField name="'create_activity_user_id'" readonly="userPermissionViewOnly" record="record" canOpen="false" canCreate="false" canQuickCreate="false" canCreateEdit="false" placeholder.translate="Activity assigned to"/>
                </div>
            </div>
            <div t-if="record.data.type === 'folder' and !record.data.shortcut_document_id and record.data.alias_name and record.data.alias_domain_id" class="o_field_widget o_field_many2many_tags d-flex mb-3 w-100">
                <span class="fw-bold me-2">Tags</span>
                <DocumentsDetailsMany2ManyTagsField name="'alias_tag_ids'" readonly="userPermissionViewOnly" record="record" canCreate="true" canQuickCreate="true" canCreateEdit="true" placeholder.translate="Add an alias tag..." colorField="'color'"/>
            </div>
        </div>
    </t>
`);
registerTemplate("documents.ManageVersions", `/documents/static/src/components/documents_manage_versions_panel/documents_manage_versions_panel.xml`, `<t t-name="documents.ManageVersions" xml:space="preserve">
        <Dialog size="'md'" title="panelTitle">
            <t t-set-slot="footer">
                <button class="btn btn-secondary" t-on-click="() =&gt; this.props.close()">Close</button>
            </t>
            <section t-if="this.state.userPermission === 'edit'">
                <p>
                    Versions are displayed in the order they were uploaded to Documents.
                    If you delete the most recent version, the previous one is automatically restored as the current one.
                </p>
                <input type="file" t-ref="uploadFileInput" class="o_hidden" t-on-change.stop="onReplace"/>
                <button type="button" class="btn btn-secondary" t-on-click="onUploadNewVersion">Upload New Version</button>
            </section>
            <section>
                <div t-foreach="state.versions" t-as="version" t-key="version.id" class="d-flex flex-row flex-wrap justify-content-between w-100">
                    <hr class="w-100"/>
                    <div>
                        <div class="d-flex flex-row">
                            <i class="o_documents_mimetype_icon o_image me-2" t-att-data-mimetype="version.mimetype" t-att-title="mimetype"/>
                            <div class="fs-5">
                                <span t-if="version_index === 0" class="me-1">Current Version</span>
                                <span t-out="version.name"/>
                            </div>
                        </div>
                        <div class="d-flex flex-row mb-1">
                            <b t-out="formatDate(version.create_date)" class="me-1"/>
                            <span t-out="version.create_uid.name"/>
                        </div>
                    </div>
                    <div>
                        <button type="button" class="btn btn-secondary mx-1" t-on-click="() =&gt; this.onDownload(version.id)"><i class="fa fa-download me-1"/>Download</button>
                        <button t-if="this.state.userPermission === 'edit' and (version_index &gt; 0 || state.versions.length &gt; 1)" type="button" class="btn btn-secondary mx-1" t-on-click="() =&gt; this.onDelete(version.id)"><i class="fa fa-trash me-1"/>Delete</button>
                    </div>
                </div>
            </section>
        </Dialog>
    </t>
`);
registerTemplate("documents.AccessExpirationDateBtn", `/documents/static/src/components/documents_permission_panel/documents_access_expiration_date_btn.xml`, `<t t-name="documents.AccessExpirationDateBtn" xml:space="preserve">
        <button t-if="props.editionMode" t-ref="datetime-picker-target-{{props.accessPartner.partner_id.id}}" t-attf-class="o_documents_expiration_date_btn btn btn-primary me-2 {{ props.accessPartner.expiration_date ? 'invisible' : ''}}" t-att-disabled="props.disabled" title="Set expiration date" t-on-click.prevent="onClickDateTimePickerBtn">
            <i class="fa fa-fw fa-calendar"/>
        </button>
        <span t-else="" t-ref="datetime-picker-target-{{props.accessPartner.partner_id.id}}" class="o_documents_set_expiration_date fa fa-fw fa-edit" t-on-click.prevent="onClickDateTimePickerBtn"/>
    </t>
`);
registerTemplate("documents.AccessSettings", `/documents/static/src/components/documents_permission_panel/documents_access_settings.xml`, `<t t-name="documents.AccessSettings" xml:space="preserve">
        <h4 class="o_documents_permission_panel_access_settings_title">General access</h4>
        <div class="o_documents_permission_panel_internal_access d-flex align-items-center justify-content-between px-3 py-1">
            <DocumentsPermissionSelect ariaLabel.translate="Document Access Internal" disabled="props.disabled" label.translate="Internal Users" labelHelper="accessInternalHelper" onChange.bind="props.onChangeAccessInternal" options="props.selections.access_internal" selectClass="'w-25'" showFeedbackChange="props.access.access_internal !== props.baseAccess.access_internal" value="props.access.access_internal" noEditorMessage="errorAccessInternalEdit"/>
        </div>
        <div class="d-flex align-items-center justify-content-between px-3 pt-1">
            <DocumentsPermissionSelect ariaLabel.translate="Document Access Link" disabled="props.disabled" label.translate="Anyone with the link" labelHelper="accessLinkHelper" onChange.bind="props.onChangeAccessLink" options="props.selections.access_via_link" selectClass="'w-25'" showFeedbackChange="props.access.access_via_link !== props.baseAccess.access_via_link" value="props.access.access_via_link" noEditorMessage="errorAccessLinkEdit"/>
        </div>
        <div t-if="props.access.access_via_link !== 'none'" class="d-flex align-items-center justify-content-between px-3 py-0">
            <div class="flex-grow-1"/>
            <DocumentsPermissionSelect ariaLabel.translate="Document Access Link" disabled="props.disabled" onChange.bind="props.onChangeIsAccessLinkHidden" options="props.selections.access_via_link_options" selectClass="'w-auto'" showFeedbackChange="props.access.is_access_via_link_hidden !== props.baseAccess.is_access_via_link_hidden" value="props.access.is_access_via_link_hidden ? '1' : '0'"/>
        </div>
    </t>
`);
registerTemplate("documents.MemberInvite", `/documents/static/src/components/documents_permission_panel/documents_member_invite.xml`, `<t t-name="documents.MemberInvite" xml:space="preserve">
        <label t-if="props.invitePage" class="form-label">Add people or email addresses:</label>
        <div t-att-class="\`d-flex align-items-center \${ props.invitePage ? '' : 'px-3'} py-1 position-relative\`">
            <i t-if="!props.invitePage" class="fa fa-w fa-user-plus col-form-label ps-1 pe-4 fs-4"/>
            <DocumentsPermissionSelectMenu buttonText.translate="Add people or email addresses..." choices="state.fetchedPartners.map((p) =&gt; ({value: p.id, label: p.display_name, email: p.email}))" class="'flex-grow-1'" multiSelect="true" onSelect.bind="onSelectPartnerToInvite" onInput.bind="onSearchPartners" onOpen.bind="() =&gt; this.onSearchPartners('')" required="true" searchPlaceholder.translate="Search people" togglerClass="props.invitePage ? 'o_documents_permission_panel_select_invite' : ''" value="state.selectedPartners" fuzzyLookupFn="this.matchPartners">
                <t t-set-slot="choice" t-slot-scope="choice">
                    <span class="o_documents_permission_panel_avatar o_avatar d-flex align-items-center">
                        <img t-attf-src="/web/image?model=res.partner&amp;field=avatar_128&amp;id={{ choice.data.value }}" alt="" class="rounded me-1"/>
                        <span class="d-flex flex-column">
                            <span t-out="choice.data.label || choice.data.value"/>
                            <span class="text-muted" t-if="choice.data.email" t-out="choice.data.email"/>
                        </span>
                    </span>
                </t>
                <t t-set-slot="bottomArea" t-slot-scope="select">
                    <DropdownItem t-if="isEmail(select.data.searchValue)" class="'btn text-primary'" onSelected.bind="() =&gt; this.createPartners(select.data.searchValue)">
                            Create new contact "<i t-out="select.data.searchValue"/>"
                    </DropdownItem>
                    <DropdownItem t-if="select.data.searchValue" class="'btn text-primary'" onSelected.bind="() =&gt; this.createPartners(select.data.searchValue, true)">
                            Create and edit new contact "<i t-out="select.data.searchValue"/>"
                    </DropdownItem>
                </t>
            </DocumentsPermissionSelectMenu>
            <DocumentsPermissionSelect t-if="props.invitePage" ariaLabel.translate="User Access Role" onChange.bind="onChangeRoleForMemberToInvite" options="props.roles" value="props.selectedPartnersRole" selectClass="'ms-1 w-auto text-truncate'" noEditorMessage="noEditorMessage"/>
        </div>
        <t t-if="props.invitePage">
            <div class="py-2">
                <div class="form-check form-switch">
                    <input t-on-click="onClickNotify" class="form-check-input" type="checkbox" id="notifyCheckBox" t-att-checked="state.notify"/>
                    <label class="form-check-label" for="notifyCheckBox">Notify</label>
                </div>
                <div t-if="state.notify" class="border-bottom pt-3">
                    <Wysiwyg config="wysiwyg.config" onLoad.bind="onLoadWysiwyg"/>
                </div>
            </div>
            <t t-portal="'#o_document_member_invite_share_btn'" t-call="documents.MemberInviteShareBtn"/>
            <t t-portal="'#o_document_member_invite_discard_btn'" t-call="documents.MemberInviteDiscardBtn"/>
        </t>
        <div t-if="props.disabled" class="o_documents_permission_panel_select_menu_overlay"/>
    </t>

    `);
registerTemplate("documents.MemberInviteShareBtn", `/documents/static/src/components/documents_permission_panel/documents_member_invite.xml`, `<t t-name="documents.MemberInviteShareBtn" xml:space="preserve">
        <button type="button" class="btn btn-primary w-100" t-on-click="onShare" t-att-disabled="state.sharing">
            <span t-if="state.sharing">Sharing...</span>
            <span t-elif="state.notify">Send</span>
            <span t-else="">Share</span>
        </button>
    </t>

    `);
registerTemplate("documents.MemberInviteDiscardBtn", `/documents/static/src/components/documents_permission_panel/documents_member_invite.xml`, `<t t-name="documents.MemberInviteDiscardBtn" xml:space="preserve">
        <button type="button" class="btn btn-secondary w-100" t-on-click="onDiscard">
            <span>Discard</span>
        </button>
    </t>
`);
registerTemplate("documents.PartnerAccess", `/documents/static/src/components/documents_permission_panel/documents_partner_access.xml`, `<t t-name="documents.PartnerAccess" xml:space="preserve">
        <h4 t-if="props.ownerUser or props.accessPartners.length">People with access</h4>

        <div t-if="props.ownerUser" class="row m-0 px-3 py-1 pt-2">
            <t t-call="documents.PartnerAccess.info">
                <t t-set="partner" t-value="props.ownerUser"/>
            </t>
            <div class="col-sm-5 pe-0 d-flex justify-content-end">
                <span class="fw-bold text-muted pe-2">Owner</span>
            </div>
        </div>

        <t t-foreach="props.accessPartners" t-as="accessPartner" t-key="accessPartner_index">
            <div t-if="accessPartner.role" class="o_documents_access_partner row m-0 px-3 py-1">
                <t t-call="documents.PartnerAccess.info">
                    <t t-set="partner" t-value="accessPartner"/>
                </t>
                <div class="col-5 col-sm-5 pe-0">
                    <div class="input-group">
                       <DocumentsAccessExpirationDateBtn accessPartner="accessPartner" disabled="props.disabled" editionMode="true" setExpirationDate.bind="props.setExpirationDate"/>
                        <DocumentsRemovePartnerButton accessPartner="accessPartner" disabled="props.disabled" isInternalUser="props.isInternalUser" isCurrentUser.bind="props.isCurrentUser" removeAccess.bind="props.removeDocumentAccess"/>
                        <DocumentsPermissionSelect ariaLabel.translate="User Access Role" selectClass="'mt-2'" disabled="props.disabled" onChange.bind="(e) =&gt; props.onChangePartnerRole(e, accessPartner)" options="props.selections" showFeedbackChange="accessPartner.role !== props.basePartnersRole[accessPartner.id]" value="accessPartner.role" noEditorMessage="this.noEditorMessage(accessPartner)"/>
                    </div>
                </div>
            </div>
        </t>
    </t>

    `);
registerTemplate("documents.PartnerAccess.info", `/documents/static/src/components/documents_permission_panel/documents_partner_access.xml`, `<t t-name="documents.PartnerAccess.info" xml:space="preserve">
        <div class="col-2 col-sm-1">
            <img class="o_documents_permission_panel_avatar o_avatar rounded" t-if="partner.partner_id.id" t-attf-src="/web/image?model=res.partner&amp;field=avatar_128&amp;id={{ partner.partner_id.id }}"/>
        </div>
        <div class="col-5 col-sm-6 pe-1">
            <div t-attf-class="text-truncate {{ props.isCurrentUser(partner) ? 'd-sm-flex align-items-sm-center fw-bold text-primary' : '' }}">
                <t t-out="partner.partner_id.name"/>
                <span t-if="props.isCurrentUser(partner)" class="badge d-none d-sm-block ms-1 rounded-pill text-bg-primary">You</span>
            </div>
            <div class="text-truncate text-muted">
                <span class="o_member_email" t-if="partner.partner_id.email" t-out="partner.partner_id.email"/>
            </div>
            <div t-if="partner.expiration_date" class="text-truncate text-muted">
                <span t-att-class="{'text-primary': partner.expiration_date !== props.basePartnersAccessExpDate[partner.id]}">Exp: <t t-out="getFormattedLocalExpirationDate(partner)"/></span>
                <span t-if="!props.disabled" t-on-click="() =&gt; this.props.setExpirationDate(partner, false)" class="o_documents_unset_expiration_date fa fa-times pe-2 ps-3"/>
                <DocumentsAccessExpirationDateBtn t-if="!props.disabled" accessPartner="accessPartner" disabled="props.disabled" setExpirationDate.bind="props.setExpirationDate"/>
            </div>
        </div>
    </t>
`);
registerTemplate("documents.PermissionPanel", `/documents/static/src/components/documents_permission_panel/documents_permission_panel.xml`, `<t t-name="documents.PermissionPanel" xml:space="preserve">
        <Dialog size="'md'" title="panelTitle">
            <t t-set-slot="footer">
                <button t-if="state.mainPage" type="button" class="btn btn-primary" t-on-click="onShare" t-att-disabled="state.loading">
                        <span t-if="pendingSave">Save</span>
                        <t t-elif="state.loading"><span class="spinner-border spinner-border-sm"/> Saving...</t>
                        <span t-elif="state.access.user_permission === 'edit'">Done</span>
                        <span t-else="">Close</span>
                </button>
                <div t-if="!state.mainPage" id="o_document_member_invite_share_btn"/>
                <CopyButton className="'btn-secondary text-truncate'" copyText="copyText" content="state.access.access_url" disabled="pendingSave || !state.access.active" icon="'d-none'" successText.translate="Link copied to the clipboard."/>
                <button t-if="state.mainPage" type="button" t-attf-class="btn {{pendingSave ? '' : 'invisible'}}" t-on-click="onDiscard" t-att-disabled="state.loading" title="Revert changes">
                    <i class="fa fa-undo"/>
                </button>
                <div t-if="!state.mainPage" id="o_document_member_invite_discard_btn"/>
            </t>
            <div t-if="state.mainPage and warningMessage" class="alert alert-warning py-1 mb-1" role="alert" t-out="warningMessage"/>
            <section t-if="state.access.user_permission ==='edit' and state.access.active" t-att-class="{ 'mb-3' : state.mainPage }" class="o_documents_permission_panel_member_invite">
                <DocumentsMemberInvite access="state.access" accessPartners="state.access.access_ids" autoSave.bind="save" close.bind="close" disabled="state.loading" invitePage="!state.mainPage" pendingSave="pendingSave" roles="state.selections.doc_access_roles" selectedPartnersRole="selectedPartnersRole" showMainPage.bind="showMainPage" updateAccessRights.bind="updateAccessRights"/>
            </section>
            <t t-if="state.mainPage">
                <section class="o_documents_permission_panel_access_partners mb-3">
                    <DocumentsPartnerAccess access="state.access" accessPartners="state.access.access_ids" basePartnersRole="basePartnersRole" basePartnersAccessExpDate="basePartnersAccessExpDate" isAdmin="isAdmin" isCurrentUser="isCurrentUser" isInternalUser="isInternalUser" disabled="state.loading || state.access.user_permission !=='edit' || !state.access.active" ownerUser="state.access.owner_id" onChangePartnerRole.bind="onChangePartnerRole" removeDocumentAccess.bind="removeDocumentAccess" selections="state.selections.doc_access_roles" setExpirationDate.bind="setExpirationDate"/>
                </section>
                <section>
                    <div class="pb-2">
                        <DocumentsAccessSettings access="state.access" baseAccess="baseAccess" disabled="state.loading || state.access.user_permission !=='edit' || !state.access.active" onChangeAccessInternal.bind="onChangeDocumentAccessInternal" onChangeAccessLink.bind="onChangeDocumentAccessLink" onChangeIsAccessLinkHidden.bind="onChangeDocumentIsAccessLinkHidden" selections="state.selections"/>
                    </div>
                </section>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("documents.PermissionSelect", `/documents/static/src/components/documents_permission_panel/documents_permission_select.xml`, `<t t-name="documents.PermissionSelect" xml:space="preserve">
        <t t-if="props.labelHelper">
            <div class="w-75">
                <label t-if="props.label" class="col-form-label fs-5 pe-3 pb-0" t-out="props.label"/>
                <div class="fs-6 text-muted" t-out="props.labelHelper"/>
            </div>
        </t>
        <label t-elif="props.label" class="col-form-label pe-3" t-out="props.label"/>
        <select t-attf-class="form-select {{selectClass}}" t-att-value="props.value" t-on-change="props.onChange" t-att-disabled="props.disabled" t-att-aria-label="props.ariaLabel">
            <t t-foreach="props.options" t-as="option" t-key="option_index">
                <option t-att-value="option[0]" t-out="option[1]" t-att-selected="option[0] === props.value ? 'selected' : undefined" t-att-disabled="props.noEditorMessage and option[0] === 'edit'" t-att-title="props.noEditorMessage"/>
            </t>
        </select>
    </t>

    `);
registerTemplate("documents.PermissionSelectMenu", `/documents/static/src/components/documents_permission_panel/documents_permission_select.xml`, `<t t-name="documents.PermissionSelectMenu" t-inherit="web.SelectMenu" t-mode="primary" xml:space="preserve">
        <xpath expr="//TagsList" position="before">
            <span class="text-muted fw-normal" t-if="multiSelectChoices.length === 0" t-out="props.buttonText"/>
        </xpath>
        <xpath expr="//t[@t-if='state.choices.length === 0']" position="replace"/>
    </t>
`);
registerTemplate("documents.RemovePartnerButton", `/documents/static/src/components/documents_permission_panel/documents_remove_partner_button.xml`, `<t t-name="documents.RemovePartnerButton" xml:space="preserve">
        <t t-if="props.isInternalUser">
            <button t-if="props.isCurrentUser(props.accessPartner)" class="o_documents_remove_partner_btn btn btn-danger me-2" t-att-disabled="props.disabled" t-on-click.prevent="() =&gt; props.removeAccess(props.accessPartner)" title="Remove Access">
                <i class="fa fa-fw fa-sign-out"/>
            </button>
            <button t-else="" class="o_documents_remove_partner_btn btn btn-danger me-2" t-att-disabled="props.disabled" title="Remove Member" t-on-click.prevent="() =&gt; props.removeAccess(props.accessPartner)">
                <i class="fa fa-fw fa-times"/>
            </button>
        </t>
        <button t-else="" class="o_documents_remove_partner_btn btn btn-danger me-2" disabled="true" title="You cannot remove this partner">
            <i class="fa fa-fw fa-times"/>
        </button>
    </t>
`);
registerTemplateExtension("mail.AvatarCardPopover", `/hr_holidays/static/src/avatar_card_popover_patch.xml`, `<t t-inherit="mail.AvatarCardPopover" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//span[@name='icon']" position="inside">
            <i t-elif="user.im_status === 'leave_online'" class="fa fa-fw fa-plane text-success" title="Online" role="img" aria-label="User is online"/>
            <i t-elif="user.im_status === 'leave_away'" class="fa fa-fw fa-plane text-warning" title="Idle" role="img" aria-label="User is idle"/>
            <i t-elif="user.im_status === 'leave_offline'" class="fa fa-fw fa-plane text-700" title="Out of office" role="img" aria-label="User is out of office"/>
        </xpath>
    </t>
`);
registerTemplateExtension("resource_mail.AvatarCardResourcePopover", `/hr_holidays/static/src/avatar_card_resource_popover.xml`, `<t t-inherit="resource_mail.AvatarCardResourcePopover" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//span[@name='icon'][hasclass('o_user_im_status')]/i[hasclass('fa-question-circle')]" position="before">
            <i t-elif="record.im_status === 'leave_online'" class="fa fa-fw fa-plane text-success" title="Online" role="img" aria-label="User is online"/>
            <i t-elif="record.im_status === 'leave_away'" class="fa fa-fw fa-plane text-warning" title="Idle" role="img" aria-label="User is idle"/>
            <i t-elif="record.im_status === 'leave_offline'" class="fa fa-fw fa-plane text-700" title="Out of office" role="img" aria-label="User is out of office"/>
        </xpath>
        <xpath expr="//span[@name='icon'][hasclass('o_employee_presence_status')]" position="inside">

            <i t-if="record.hr_icon_display === 'presence_holiday_present'" class="fa fa-fw fa-plane text-success me-1" title="Active but on leave" role="img" aria-label="Active but on leave"/>

            <i t-if="record.hr_icon_display === 'presence_holiday_absent'" class="fa fa-fw fa-plane text-warning me-1" title="On Time Off" role="img" aria-label="On Time Off"/>
        </xpath>
    </t>
`);
registerTemplate("hr_holidays.FloatTimeSelectionField", `/hr_holidays/static/src/components/float_time_selection/float_time_selection.xml`, `<t t-name="hr_holidays.FloatTimeSelectionField" t-inherit="web.FloatTimeField" xml:space="preserve">
        <xpath expr="//input" position="attributes">
            <attribute name="t-on-input">handleInputChange</attribute>
            <attribute name="t-on-click">onCharHoursClick</attribute>
        </xpath>
    </t>
`);
registerTemplate("hr_holidays.FloatTimeSelectionPopover", `/hr_holidays/static/src/components/float_time_selection/float_time_selection_popover.xml`, `<t t-name="hr_holidays.FloatTimeSelectionPopover" xml:space="preserve">
        <div class="position-relative d-flex align-items-center flex-sm-row gap-1 gap-md-1 p-2">
            <select class="o_hour_selection form-control form-control-sm w-auto" t-on-change="onTimeChange" t-model="state.selectedHours">
                <t t-foreach="availableHours" t-as="unit" t-key="unit[0]">
                    <option class="text-center" t-att-value="unit[0]" t-esc="unit[1]" t-att-selected="unit[0] == state.selectedHours"/>
                </t>
            </select>
            <span>:</span>
            <select class="o_hour_selection form-control form-control-sm w-auto" t-on-change="onTimeChange" t-model="state.selectedMinutes">
                <t t-foreach="availableMinutes" t-as="unit" t-key="unit[0]">
                    <option class="text-center" t-att-value="unit[0]" t-esc="unit[1]" t-att-selected="unit[0] == state.selectedMinutes"/>
                </t>
            </select>
        </div>
    </t>
`);
registerTemplate("hr_holidays.MultipleTimeOffGeneraion", `/hr_holidays/static/src/components/multi_time_off_generation_menu/multiple_time_off_generation_menu.xml`, `<t t-name="hr_holidays.MultipleTimeOffGeneraion" xml:space="preserve">
        <DropdownItem onSelected.bind="openMatchingJobApplicants">
            <i class="fa fa-fw fa-users me-1" aria-hidden="true"/>Multiple Requests
        </DropdownItem>
    </t>
`);
registerTemplate("hr_holidays.TimeOffCard", `/hr_holidays/static/src/dashboard/time_off_card.xml`, `<div t-name="hr_holidays.TimeOffCard" class="o_timeoff_card py-3 text-primary" xml:space="preserve">
        <t t-set="data" t-value="props.data"/>
        <t t-set="duration" t-value="props.requires_allocation ? data.virtual_remaining_leaves : data.virtual_leaves_taken"/>
        <t t-set="parsed_duration" t-value="formatNumber(this.lang, duration)"/>
        <t t-set="show_popover" t-value="true"/>

        <strong class="o_timeoff_name"><t t-esc="props.name"/></strong>
        <span class="o_timeoff_duration">
            <t t-if="data and data.icon">
                <img t-att-src="data.icon"/>
            </t>
            <span t-att-style="data.holds_changes ? 'color: #B6D369;' : ''">
                <t t-esc="parsed_duration"/>
            </span>
        </span>
        <span t-att-class="'text-uppercase o_timeoff_details p-1' + (warning ? ' alert alert-warning' : '')" t-on-click.stop="(ev) =&gt; (show_popover &amp;&amp; this.onClickInfo(ev))">
            <t t-if="data.request_unit == 'hour'" name="duration_unit">hours</t>
            <t t-else="">days</t>
            <t t-if="props.requires_allocation" name="duration_type">
                available
            </t>
            <t t-else="">
                taken
            </t>
            <span t-if="show_popover" t-att-class="'o_timeoff_info fa' + (warning ? ' fa-exclamation-triangle' : ' fa-question-circle-o')"/>
        </span>
        <span t-if="props.requires_allocation and data.closest_allocation_expire !== false" class="text-uppercase o_timeoff_validity">
            <t t-if="data.closest_allocation_remaining != data.virtual_remaining_leaves">
                (<t t-esc="data.closest_allocation_remaining"/> <t t-if="data.request_unit == 'hour'">hours</t><t t-else="">days</t>
                valid until <span t-esc="data.closest_allocation_expire"/>)
            </t>
            <t t-else="">
                (valid until <span t-esc="data.closest_allocation_expire"/>)
            </t>
        </span>
    </div>

    `);
registerTemplate("hr_holidays.TimeOffCardMobile", `/hr_holidays/static/src/dashboard/time_off_card.xml`, `<t t-name="hr_holidays.TimeOffCardMobile" xml:space="preserve">
        <t t-set="data" t-value="props.data"/>
        <t t-set="duration" t-value="props.requires_allocation ? data.virtual_remaining_leaves : data.virtual_leaves_taken"/>

        <span class="float-end o_timeoff_card_mobile">
            <t t-if="props.requires_allocation" name="duration_type">
                <strong t-esc="duration" class="o_timeoff_green text-success"/> / <span t-esc="data.max_leaves"/> <t t-if="data.request_unit == 'hour'">Hours</t><t t-else="">Days</t> <span class="o_timeoff_green text-success">Available</span>
            </t>
            <t t-else="">
                <strong t-esc="duration"/> <t t-if="data.request_unit == 'hour'">Hours</t><t t-else="">Days</t> <span class="text-primary">Taken</span>
            </t>
        </span>
    </t>

    `);
registerTemplate("hr_holidays.TimeOffCardPopover", `/hr_holidays/static/src/dashboard/time_off_card.xml`, `<t t-name="hr_holidays.TimeOffCardPopover" xml:space="preserve">
        <ul class="list-unstyled p-3 mb-0">
            <li class="d-flex justify-content-between">
                <span>Allocated (<span class="btn-link p-0 cursor-pointer" t-on-click="props.onClickNewAllocationRequest">new request</span>):</span>
                <span class="ps-1" t-esc="props.allocated"/>
            </li>
            <li class="d-flex justify-content-between" t-if="props.accrual_bonus">
                Accrual (Future): <span class="ps-1" t-esc="props.accrual_bonus"/>
            </li>
            <li class="d-flex justify-content-between">Approved: <span class="ps-1" t-esc="props.approved"/></li>
            <li class="d-flex justify-content-between border-bottom">Planned: <span class="ps-1" t-esc="props.planned"/></li>
            <li class="d-flex justify-content-between">Available: <span class="ps-1" t-esc="props.left"/></li>
        </ul>
        <div t-if="props.warning" class="alert alert-warning mb-0 pb-0 o_time_off_card_popover_warning">
            <span class="d-inline-block m-0 mb-3" t-if="props.errorLeaves.length">
                Some leaves cannot be linked to any allocation. To see those leaves, 
                <a t-on-click="() =&gt; this.openLeaves()" class="cursor-pointer">click here</a>.
            </span>
            <span class="d-inline-block m-0 mb-3" t-if="props.closest &amp;&amp; props.closest &lt; props.left">
                <i class="fa fa-warning"/> Only <t t-esc="props.closest"/>
                <t t-if="props.request_unit == 'hour'"> hours</t>
                <t t-else=""> days</t>
                can be used before the allocation expires.
            </span>
            <span class="d-inline-block m-0 mb-3" t-if="props.accrualExcess">
                The leaves planned in the future are exceeding the maximum value of the allocation.
                It will not be possible to take all of them.
            </span>
        </div>
    </t>
`);
registerTemplate("hr_holidays.TimeOffDashboard", `/hr_holidays/static/src/dashboard/time_off_dashboard.xml`, `<div t-name="hr_holidays.TimeOffDashboard" class="o_timeoff_dashboard" xml:space="preserve">
        <t t-foreach="state.holidays" t-as="holiday" t-key="holiday[3]">
            <TimeOffCard name="holiday[0]" data="holiday[1]" requires_allocation="holiday[2] == 'yes'" holidayStatusId="holiday[3]" employeeId="props.employeeId"/>
        </t>
        <div class="o_timeoff_card p-0 d-flex justify-content-around">
            <div class="row justify-content-center align-items-center border-bottom h-25 w-100 p-0" t-if="hasAccrualAllocation">
                Balance at the
                <div class="p-1" style="max-width: 100px!important">
                    <DateTimeInput type="'date'" value="state.date" onChange="(date) =&gt; this.loadDashboardData(date)" minDate="state.today" placeholder.translate="Today"/>
                </div>
                <button class="o_timeoff_today_button btn btn-secondary" t-on-click="resetDate">Today</button>
            </div>
            <div class="d-flex flex-column justify-content-center align-items-center w-100">
                <strong class="o_timeoff_name">Pending Requests</strong>
                <span t-on-click="openPendingRequests" t-att-class="'o_timeoff_duration' + (state.allocationRequests ? ' cursor-pointer' : '')">
                    <t t-esc="state.allocationRequests"/>
                </span>
                <a class="text-uppercase o_timeoff_details p-1" t-on-click="newAllocationRequest">
                    <t t-if="employeeId">Grant Time</t>
                    <t t-else="">New Allocation Request</t>
                </a>
            </div>
        </div>
    </div>
`);
registerTemplateExtension("mail.ImStatus", `/hr_holidays/static/src/im_status_patch.xml`, `<t t-inherit="mail.ImStatus" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@name='icon']" position="replace">
            <i t-if="persona.im_status === 'leave_online'" class="fa fa-plane text-success" title="Online" role="img" aria-label="User is online"/>
            <i t-elif="persona.im_status === 'leave_away'" class="fa fa-plane o-away" title="Idle" role="img" aria-label="User is idle"/>
            <i t-elif="persona.im_status === 'leave_offline'" class="fa fa-plane text-700" title="Out of office" role="img" aria-label="User is out of office"/>
            <t t-else="">$0</t>
        </xpath>
    </t>
`);
registerTemplate("hr_holidays.LeaveStatsComponent", `/hr_holidays/static/src/leave_stats/leave_stats.xml`, `<div t-name="hr_holidays.LeaveStatsComponent" class="o_leave_stats" xml:space="preserve">
        <div t-if="state.employee" id="o_leave_stats_employee">
            <div class="o_hr_leave_subtitle">
                <t t-esc="state.employee[1]"/> in <t t-esc="thisYear"/>
            </div>
            <div t-if="state.leaves.length === 0">
                None
            </div>
            <div t-foreach="state.leaves" t-as="leave" t-key="leave_index" class="d-flex flex-row justify-content-between">
                <span t-esc="leave.holiday_status_id[1]"/>
                <t t-if="leave.leave_type_request_unit?.includes('hour')">
                    <span><t t-esc="leave.number_of_hours"/> hour(s)</span>
                </t>
                <t t-if="!leave.leave_type_request_unit?.includes('hour')">
                    <span><t t-esc="leave.number_of_days"/> day(s)</span>
                </t>
            </div>
        </div>
        <div t-if="state.department" id="o_leave_stats_department">
            <div class="o_horizontal_separator o_hr_leave_subtitle">
                <t t-esc="state.department[1]"/>
            </div>
            <div t-if="state.departmentLeaves.length === 0">
                None
            </div>
            <div t-foreach="state.departmentLeaves" t-as="leave" t-key="leave_index" t-attf-class="d-flex flex-row justify-content-between {{leave.sameEmployee ? 'fw-bold': ''}}">
                <span>
                    <t t-esc="leave.employee_id[1]"/>: 
                    <t t-if="leave.leave_type_request_unit === 'hour'">
                        <t t-esc="leave.number_of_hours"/> hour(s)
                    </t>
                    <t t-if="leave.leave_type_request_unit !== 'hour'">
                        <t t-esc="leave.number_of_days"/> day(s)
                    </t>
                </span>
                <div class="d-flex flex-row gap-2 align-items-center">
                    <span>
                        <t t-esc="leave.dateFrom"/>
                    </span>
                    <i class="fa fa-long-arrow-right" aria-label="Arrow icon" title="Arrow"/>
                    <span>
                        <t t-esc="leave.dateTo"/>
                    </span>
                </div>
            </div>
        </div>
    </div>
`);
registerTemplate("hr_holidays.RadioImageField", `/hr_holidays/static/src/radio_image_field/radio_image_field.xml`, `<t t-name="hr_holidays.RadioImageField" xml:space="preserve">
        <div role="radiogroup" class="d-flex flex-wrap gap-4" t-att-aria-label="string">
            <t t-if="props.readonly">
                <t t-if="value !== false">
                    <div>
                        <img t-attf-src="/hr_holidays/static/src/img/icons/{{items.find((item) =&gt; item[0] === value)[1]}}" width="48" height="48"/>
                    </div>
                </t>
            </t>
            <t t-else="">
                <t t-foreach="items" t-as="item" t-key="item[0]">
                    <div class="form-check o_radio_item" aria-atomic="true">
                        <input type="radio" class="form-check-input o_radio_input" t-att-checked="item[0] === value" t-att-disabled="props.readonly" t-att-name="id" t-att-data-value="item[0]" t-att-data-index="item_index" t-att-id="\`\${id}_\${item[0]}\`" t-on-change="() =&gt; this.onChange(item)"/>
                        <label class="form-check-label o_form_label" t-att-for="\`\${id}_\${item[0]}\`">
                            <img t-attf-src="/hr_holidays/static/src/img/icons/{{item[1]}}" width="48" height="48"/>
                        </label>
                    </div>
                </t>
            </t>
        </div>
    </t>

`);
registerTemplateExtension("mail.ThreadIcon", `/hr_holidays/static/src/thread_icon.patch.xml`, `<t t-inherit="mail.ThreadIcon" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@name='chat_static']" position="replace">
            <div t-if="correspondent.persona.im_status === 'leave_online'" class="o-mail-ThreadIcon-online fa fa-fw fa-plane text-success" title="Online"/>
            <div t-elif="correspondent.persona.im_status === 'leave_offline'" class="fa fa-fw fa-plane" title="Out of office"/>
            <div t-elif="correspondent.persona.im_status === 'leave_away'" class="fa fa-fw fa-plane o-yellow" title="Away"/>
            <t t-else="">$0</t>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.Thread", `/hr_holidays/static/src/thread_patch.xml`, `<t t-inherit="mail.Thread" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[hasclass('o-mail-Thread')]" position="before">
            <div t-if="props.thread.model === 'discuss.channel' and props.thread.correspondent?.persona.outOfOfficeText" class="alert alert-primary rounded-0" t-esc="props.thread.correspondent.persona.outOfOfficeText" role="alert"/>
        </xpath>
    </t>
`);
registerTemplate("hr_holidays.CalendarController", `/hr_holidays/static/src/views/calendar/calendar_controller.xml`, `<t t-name="hr_holidays.CalendarController" t-inherit="web.CalendarController" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//Layout" position="inside">
            <t t-set-slot="control-panel-create-button">
                <span class="o_timeoff_buttons btn-group">
                    <div class="btn-group">
                        <button class="btn btn-primary btn-time-off " t-on-click="newTimeOffRequest" type="button">
                            New
                        </button>
                    </div>
                </span>
            </t>
        </xpath>
        <DatePicker position="replace"/>
    </t>

`);
registerTemplate("hr_holidays.CalendarRenderer", `/hr_holidays/static/src/views/calendar/calendar_renderer.xml`, `<t t-name="hr_holidays.CalendarRenderer" xml:space="preserve">
        <div class="o_timeoff_calendar d-flex flex-column">
            <TimeOffDashboard t-if="showDashboard" employeeId="employeeId"/>
            <t t-call="web.CalendarRenderer"/>
        </div>
    </t>

`);
registerTemplate("hr_holidays.TimeOffCalendarCommonPopover.footer", `/hr_holidays/static/src/views/calendar/common/calendar_common_popover.xml`, `<t t-name="hr_holidays.TimeOffCalendarCommonPopover.footer" t-inherit="web.CalendarCommonPopover.footer" t-inherit-mode="primary" owl="1" xml:space="preserve">
        <xpath expr="//t" position="inside">
            <button t-attf-class="btn btn-secondary" t-if="isManager and ['confirm', 'refuse'].includes(state)" name="action_approve" t-on-click="onClickButton" data-hotkey="g">Approve</button>
            <button t-attf-class="btn btn-secondary" t-if="isManager and state === 'validate1'" name="action_validate" t-on-click="onClickButton" data-hotkey="g">Validate</button>
            <button t-attf-class="btn btn-secondary" t-if="isManager and state !== 'refuse'" name="action_refuse" t-on-click="onClickButton" data-hotkey="z">Refuse</button>
        </xpath>
    </t>
`);
registerTemplate("hr_holidays.CalendarFilterPanel", `/hr_holidays/static/src/views/calendar/filter_panel/calendar_filter_panel.xml`, `<t t-name="hr_holidays.CalendarFilterPanel" t-inherit="web.CalendarFilterPanel" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-foreach='props.model.filterSections']" position="after">
            <div class="o_calendar_filter mt-4">
                <h5>Legend</h5>
                <div class="d-flex flex-column">
                    <span class="align-middle"><img class="o_calendar_filter_plain" src="/hr/static/src/img/icons/plain.svg"/> Validated</span>
                    <span class="align-middle"><img class="o_calendar_filter_hatched" src="/hr/static/src/img/icons/hatched.svg"/> To Approve</span>
                    <span class="align-middle"><img class="o_calendar_filter_line" src="/hr/static/src/img/icons/line.svg"/> Refused</span>
                </div>

                <div class="d-flex flex-column mt-4" t-if="leaveState.mandatoryDays.length">
                    <h5>Mandatory Days</h5>
                    <ul class="ps-0">
                        <li t-foreach="leaveState.mandatoryDays" t-as="mandatoryDay" t-key="mandatoryDay.id" class="mt-2 list-unstyled">
                            <strong t-esc="getFormattedDateSpan(mandatoryDay.start, mandatoryDay.end)" t-att-class="'hr_mandatory_day_'+mandatoryDay.colorIndex"/>
                            : <t t-esc="mandatoryDay.title"/>
                        </li>
                    </ul>
                </div>

                <div class="d-flex flex-column mt-4" t-if="leaveState.bankHolidays.length">
                    <h5>Public Holidays</h5>
                    <ul class="ps-0">
                        <li t-foreach="leaveState.bankHolidays" t-as="bankHoliday" t-key="bankHoliday.id" class="mt-2 list-unstyled">
                            <strong t-esc="getFormattedDateSpan(bankHoliday.start, bankHoliday.end)"/>
                            : <t t-esc="bankHoliday.title"/>
                        </li>
                    </ul>
                </div>
            </div>
        </xpath>
    </t>


    `);
registerTemplate("hr_holidays.CalendarFilterPanel.filter", `/hr_holidays/static/src/views/calendar/filter_panel/calendar_filter_panel.xml`, `<t t-name="hr_holidays.CalendarFilterPanel.filter" t-inherit="web.CalendarFilterPanel.filter" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[@t-esc='filter.label']" position="replace">
            <span class="o_cw_filter_title flex-grow-1 text-truncate lh-base">
                <t t-esc="filter.label"/>

                <t t-if="env.isSmall">
                    <t t-set="holiday" t-value="leaveState.holidays[filter.value]"/>
                    <TimeOffCardMobile t-if="holiday" name="holiday[0]" id="holiday[3]" data="holiday[1]" requires_allocation="holiday[2] === 'yes'"/>
                </t>
            </span>
        </xpath>
    </t>
`);
registerTemplate("hr_holidays.MandatoryDayCalendarYearPopover.body", `/hr_holidays/static/src/views/calendar/year/calendar_year_popover.xml`, `<t t-name="hr_holidays.MandatoryDayCalendarYearPopover.body" xml:space="preserve">
        <t t-foreach="recordGroups" t-as="recordGroup" t-key="recordGroup.title">
            <div class="fw-bold mt-2" t-esc="recordGroup.title"/>
            <t t-foreach="recordGroup.records" t-as="record" t-key="record.id">
                <t t-if="record.id &lt; 0">
                    <p class="">
                        <t t-if="record.startHour"><t t-esc="record.startHour"/> </t>
                        <t t-esc="record.title"/>
                    </p>
                </t>
                <t t-else="">
                    <t t-call="{{ constructor.subTemplates.record }}"/>
                </t>
            </t>
        </t>
    </t>
`);
registerTemplate("hr_holidays.FormViewDialog.buttons", `/hr_holidays/static/src/views/view_dialog/form_view_dialog.xml`, `<t t-name="hr_holidays.FormViewDialog.buttons" t-inherit="web.FormViewDialog.ToOne.buttons" xml:space="preserve">
        <xpath expr="//button[contains(@class, 'o_form_button_save')]" position="replace">
            <button class="btn btn-primary o_form_button_save" t-if="!['validate1', 'validate', 'refuse'].includes(this.record.data.state)" t-on-click="saveButtonClicked" data-hotkey="q">Save</button>
        </xpath>

        <xpath expr="//button[contains(@class, 'o_form_button_cancel')]" position="attributes">
            <attribute name="class" separator=" " remove="btn-secondary"/>
            <attribute name="t-attf-class" separator=" " add="{{ ['validate1', 'validate', 'refuse'].includes(this.record.data.state) ? 'btn-primary' : 'btn-secondary' }}"/>
        </xpath>

        <xpath expr="//button[contains(@class, 'o_form_button_cancel')]" position="after">
            <button class="btn btn-secondary" t-if="canCancel" t-on-click="cancelRecord" data-hotkey="x">Cancel</button>
            <button class="btn btn-secondary" t-if="canDelete" t-on-click="deleteRecord" data-hotkey="x">Delete</button>
        </xpath>
        <xpath expr="//div" position="inside">
            <div class="ms-auto d-flex gap-1">
                <button class="btn btn-secondary" t-if="canValidate" t-on-click="() =&gt; this.onClick('action_validate')" data-hotkey="v">Validate</button>
                <button class="btn btn-secondary" t-if="canApprove" t-on-click="() =&gt; this.onClick('action_approve')" data-hotkey="g">Approve</button>
                <button class="btn btn-secondary" t-if="canRefuse" t-on-click="() =&gt; this.onClick('action_refuse')" data-hotkey="z">Refuse</button>
            </div>
        </xpath>
    </t>
`);
registerTemplate("hr_holidays.AccrualLevelsX2ManyField", `/hr_holidays/static/src/xml/x2many_field.xml`, `<t t-name="hr_holidays.AccrualLevelsX2ManyField" t-inherit="web.X2ManyField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_x2m_control_panel')]/.." position="before">
            <xpath expr="//ListRenderer" position="move"/>
            <xpath expr="//KanbanRenderer" position="move"/>
        </xpath>
    </t>
`);
registerTemplate("hr_recruitment.ApplicantCharField", `/hr_recruitment/static/src/applicant_char/applicant_char.xml`, `<t t-name="hr_recruitment.ApplicantCharField" t-inherit="web.CharField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[@t-esc='formattedValue']" position="attributes">
            <attribute name="t-on-click.prevent.stop">onClick</attribute>
        </xpath>
    </t>
`);
registerTemplate("hr_recruitment.RecruitmentActionHelper", `/hr_recruitment/static/src/views/recruitment_helper_view.xml`, `<t t-name="hr_recruitment.RecruitmentActionHelper" xml:space="preserve">
        <div class="o_view_nocontent">
            <div class="o_nocontent_help">
                <p class="o_view_nocontent_smiling_face">
                    Ready to recruit more efficiently?
                </p>
                <p>
                    Let's create a job position.
                </p>
                <t t-if="!state.hasDemoData and isRecruitmentUser">
                    <div class="d-flex gap-3 align-items-center or-separator">
                        <hr class="flex-grow-1"/> or <hr class="flex-grow-1"/>
                    </div>

                    <a type="object" class="btn btn-secondary mt-3" t-on-click="() =&gt; this.loadRecruitmentScenario()">
                        Load sample data
                    </a>
                </t>
            </div>
        </div>
    </t>
`);
registerTemplate("hr_recruitment.RecruitmentKanbanRenderer", `/hr_recruitment/static/src/views/recruitment_kanban_view.xml`, `<t t-name="hr_recruitment.RecruitmentKanbanRenderer" t-inherit="web.KanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <t t-call="web.ActionHelper" position="replace">
            <t t-if="showNoContentHelper">
                <RecruitmentActionHelper noContentHelp="props.noContentHelp"/>
            </t>
        </t>
    </t>
`);
registerTemplate("hr_recruitment.RecruitmentListRenderer", `/hr_recruitment/static/src/views/recruitment_list_view.xml`, `<t t-name="hr_recruitment.RecruitmentListRenderer" t-inherit="web.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <t t-call="web.ActionHelper" position="replace">
            <t t-if="showNoContentHelper">
                <RecruitmentActionHelper noContentHelp="props.noContentHelp"/>
            </t>
        </t>
    </t>
`);
registerTemplate("sign.DateTimeNoSeconds", `/sign/static/src/js/sign_datetime_widget.xml`, `<t t-name="sign.DateTimeNoSeconds" t-inherit="web.DateTimeField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//span[@t-esc='getFormattedValue(0)']" position="attributes">
            <attribute name="class" add="pe-1" separator=" "/>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.ActivityListPopoverItem", `/sign/static/src/activity/activity_list_popover_item_patch.xml`, `<t t-inherit="mail.ActivityListPopoverItem" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//button[hasclass('o-mail-ActivityListPopoverItem-markAsDone')]" position="after">
            <button t-if="props.activity.activity_category === 'sign_request'" class="o-mail-ActivityListPopoverItem-requestSign btn btn-sm btn-success btn-link" t-on-click="onClickRequestSign">
                <i class="fa fa-pencil-square-o"/>
            </button>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.Activity", `/sign/static/src/activity/activity_patch.xml`, `<t t-inherit="mail.Activity" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//button[hasclass('o-mail-Activity-markDone')]" position="attributes">
            <attribute name="t-if">props.activity.activity_category != "sign_request"</attribute>
        </xpath>
        <xpath expr="//button[hasclass('o-mail-Activity-markDone')]" position="after">
            <button t-if="props.activity.activity_category == 'sign_request'" class="btn btn-link p-0 me-3" t-att-data-chaining-type-activity="props.activity.chaining_type" t-att-data-previous-activity-type-id="props.activity.activity_type_id[0]" t-att-data-activity-id="props.activity.id" t-on-click="onClickRequestSign">
                <i class="fa fa-pencil-square-o"/> Request Signature
            </button>
        </xpath>
    </t>

`);
registerTemplate("sign.MobileInputBottomSheet", `/sign/static/src/components/sign_request/mobile_input_bottom_sheet.xml`, `<div t-name="sign.MobileInputBottomSheet" class="o_sign_item_bottom_sheet" xml:space="preserve">
        <label class="o_sign_label">
            <t t-esc="label"/>
            <input t-if="type === 'text'" type="text" class="o_sign_item_bottom_sheet_field" t-att-placeholder="placeholder" t-att-value="value"/>
            <textarea t-if="type === 'textarea'" class="o_sign_item_bottom_sheet_field" t-att-placeholder="placeholder" t-att-value="value" t-esc="value"/>
        </label>
        <button class="o_sign_next_button btn btn-primary btn-block">
            <t t-esc="buttonText"/>
        </button>
    </div>
`);
registerTemplate("sign.signItem", `/sign/static/src/components/sign_request/sign_items.xml`, `<t t-name="sign.signItem" xml:space="preserve">
        <t t-if="readonly">

            <t t-if="type == 'text'" t-call="sign.textSignItem"/>
            <t t-if="type == 'textarea'" t-call="sign.textareaSignItem"/>
            <t t-if="type == 'checkbox'" t-call="sign.checkboxSignItem"/>
            <t t-if="type == 'radio'" t-call="sign.radioSignItem"/>
            <t t-if="type == 'selection'" t-call="sign.selectionSignItem"/>
            <t t-if="type == 'signature' || type == 'initial'" t-call="sign.signatureSignItem"/>
        </t>
        <t t-if="!readonly">

            <button t-if="type == 'signature' || type == 'initial'" t-att-title="role" t-attf-class="{{classes}} o_sign_sign_item text-center" style="color:#757575;" t-att-style="style" t-att-data-signature="value">
                <span class="o_sign_helper"/>
                <img t-if="frame_value" t-att-src="frame_value" alt="Frame"/>
                <img t-if="value" t-att-src="value" alt="Signature"/>
                <t t-if="!value">
                    <span class="o_placeholder ps-0">
                        <t t-esc="placeholder"/>
                    </span>
                </t>
            </button>
            <input t-if="type == 'text'" t-att-title="role" type="text" t-attf-class="{{classes}} o_sign_sign_item" t-att-style="style" t-att-placeholder="placeholder" t-att-value="value"/>
            <input t-if="type == 'checkbox' and value == 'on'" t-att-title="role" type="checkbox" t-attf-class="{{classes}} o_sign_sign_item" t-att-style="style" checked="1"/>
            <input t-elif="type == 'checkbox'" t-att-title="role" type="checkbox" t-attf-class="{{classes}} o_sign_sign_item" t-att-style="style"/>
            <input t-if="type == 'radio'" t-att-title="role" type="radio" t-attf-class="{{classes}} o_sign_sign_item" t-att-style="style" t-att-value="value" t-att-name="radio_set_id"/>
            <textarea t-if="type == 'textarea'" t-att-title="role" t-attf-class="{{classes}} o_sign_sign_item" t-att-style="style" t-att-placeholder="placeholder" t-att-value="value" t-esc="value"/>
            <div t-if="type == 'selection'" t-att-title="role" t-attf-class="{{classes}} o_sign_sign_item" t-att-style="style" t-att-value="value">
                <div class="o_sign_select_options_display o_sign_select_options_display_edit">
                    <t t-foreach="options" t-key="option.value" t-as="option" t-index="index">
                        <t t-if="option_index !== 0">
                            <span class="o_sign_option_separator">/</span>
                        </t>
                        <span t-attf-class="o_sign_item_option {{ value ? (value == option.id ? 'o_sign_selected_option' : 'o_sign_not_selected_option') : ''}}" t-att-data-id="option.id" t-esc="option.value"/>
                    </t>
                </div>
            </div>
        </t>
    </t>

    `);
registerTemplate("sign.signItemConfiguration", `/sign/static/src/components/sign_request/sign_items.xml`, `<div t-name="sign.signItemConfiguration" t-attf-class="o_sign_config_area {{ isSignItemEditable &amp;&amp; type == 'text' ? 'o_sign_editable_config_area' : '' }}" xml:space="preserve">
        <div class="o_sign_config_handle" aria-label="Signature configuration" title="Signature configuration">
            <span class="fa fa-arrows" role="img"/>
        </div>
        <span t-if="isSignItemEditable" class="fa fa-times" role="img" aria-label="Delete sign item" title="Delete sign"/>
        <div class="o_sign_item_display">

            <t t-if="['checkbox','radio'].indexOf(type) == -1 || isSignItemEditable">
                <span class="o_sign_responsible_display" t-att-title="responsibleName" t-esc="responsibleName"/>
            </t>
        </div>
        <div class="o_resize_handler resize_height"/>
        <div class="o_resize_handler resize_width"/>
        <div class="o_resize_handler resize_both"/>
    </div>

    `);
registerTemplate("sign.selectionSignItem", `/sign/static/src/components/sign_request/sign_items.xml`, `<div t-name="sign.selectionSignItem" t-att-title="role" t-attf-class="{{classes}} o_sign_sign_item" t-att-data-id="id" t-att-style="style + 'white-space: normal;text-align: center;'" xml:space="preserve">
        <div class="sign_item_body">
            <t t-if="!value">
                <span class="o_placeholder ps-0">
                    <t t-esc="placeholder"/>
                </span>
            </t>
            <div class="o_sign_select_options_display">
                <t t-foreach="options" t-key="option.value" t-as="option" t-index="index">
                    <t t-if="option_index !== 0">
                        <span class="o_sign_option_separator">/</span>
                    </t>
                    <span t-attf-class="o_sign_item_option {{ value ? (value == option.id ? 'o_sign_selected_option' : 'o_sign_not_selected_option') : ''}}" t-esc="option.value"/>
                </t>
            </div>
            <t t-if="editMode" t-call="sign.signItemConfiguration"/>
        </div>
    </div>

    `);
registerTemplate("sign.signatureSignItem", `/sign/static/src/components/sign_request/sign_items.xml`, `<div t-name="sign.signatureSignItem" t-att-title="role" t-attf-class="{{classes}} o_sign_sign_item" t-att-data-id="id" t-att-style="style" t-att-data-signature="value" xml:space="preserve">
        <div class="sign_item_body">
            <span t-if="value" class="o_sign_helper"/>
            <img t-if="frame_value" t-att-src="frame_value" alt="Frame" class="o_sign_frame"/>
            <img t-if="value" t-att-src="value" alt="Signature"/>
            <t t-if="!value">
                <span class="o_placeholder ps-0">
                    <t t-esc="placeholder"/>
                </span>
            </t>
            <t t-if="editMode" t-call="sign.signItemConfiguration"/>
        </div>
    </div>

    `);
registerTemplate("sign.textareaSignItem", `/sign/static/src/components/sign_request/sign_items.xml`, `<div t-name="sign.textareaSignItem" t-att-title="role" t-attf-class="{{classes}} o_sign_sign_item o_sign_sign_textarea" t-att-style="style" t-att-data-id="id" xml:space="preserve">
        <div class="sign_item_body">
            <t t-if="!value">
                <p class="o_placeholder o_sign_field_alignment">
                    <t t-esc="placeholder"/>
                </p>
            </t>
            <t t-esc="value"/>
            <t t-if="editMode" t-call="sign.signItemConfiguration"/>
        </div>
    </div>

    `);
registerTemplate("sign.checkboxSignItem", `/sign/static/src/components/sign_request/sign_items.xml`, `<div t-name="sign.checkboxSignItem" t-att-title="role" t-attf-class="{{classes}} o_sign_sign_item" t-att-data-id="id" t-att-style="style + 'margin: 2px; padding:2px;'" xml:space="preserve">
        <div class="sign_item_body">
            <t t-if="value == 'on'">☑</t>
            <t t-if="value == 'off'">☐</t>
            <t t-if="!value">
                <span class="o_placeholder ps-0">
                    <t t-if="placeholder == '☑'"><span class="o_custom_checkbox"/></t>
                    <t t-else=""><span class="o_custom_checkbox unchecked"/></t>
                </span>
            </t>
            <t t-if="editMode" t-call="sign.signItemConfiguration"/>
        </div>
    </div>

    `);
registerTemplate("sign.radioSignItem", `/sign/static/src/components/sign_request/sign_items.xml`, `<div t-name="sign.radioSignItem" t-att-title="role" t-attf-class="{{classes}} o_sign_sign_item" t-att-data-id="id" t-att-style="style" xml:space="preserve">
        <div class="sign_item_body">
            <t t-if="value == 'on'">◉</t>
            <t t-if="value == 'off'">◯</t>
            <t t-if="!value">
                <span class="o_placeholder ps-0 o_sign_field_alignment" t-att-style="(editMode ? 'padding-left: 25px;' : '')">
                    <t t-esc="placeholder"/>
                </span>
            </t>
            <t t-if="editMode" t-call="sign.signItemConfiguration"/>
        </div>
    </div>

    `);
registerTemplate("sign.textSignItem", `/sign/static/src/components/sign_request/sign_items.xml`, `<div t-name="sign.textSignItem" t-att-title="role" t-attf-class="{{classes}} o_sign_sign_item" type="text" t-att-data-id="id" t-att-style="style" xml:space="preserve">
        <div class="sign_item_body">
            <t t-if="isSignItemEditable">
                <input t-att-placeholder="placeholder" t-att-value="value" class="o_sign_editable_input"/>
                <t t-call="sign.signItemConfiguration"/>
            </t>
            <t t-else="">
                <t t-if="!value">
                    <p class="o_placeholder ps-0 o_sign_field_alignment">
                        <t t-esc="placeholder"/>
                    </p>
                </t>
                <t t-esc="value"/>
                <t t-if="editMode" t-call="sign.signItemConfiguration"/>
            </t>
        </div>
    </div>
`);
registerTemplate("sign.SignRequestCogMenu", `/sign/static/src/backend_components/cog_menu/sign_request_cog_menu.xml`, `<t t-name="sign.SignRequestCogMenu" xml:space="preserve">
        <DropdownItem class="'o_sign_request'" onSelected.bind="signRequest">
            <i class="fa fa-file-text fa-fw"/> Request Signature
        </DropdownItem>
    </t>

`);
registerTemplate("sign.SignRequest", `/sign/static/src/backend_components/sign_request/sign_request_action.xml`, `<div t-name="sign.SignRequest" class="d-flex flex-column h-100" xml:space="preserve">
        <SignRequestControlPanel t-props="controlPanelProps"/>
        <div class="o_content">
            <div class="o_sign_document" t-ref="sign-document">
                <t t-out="markupHtml"/>
                <Document t-props="documentProps"/>
            </div>
        </div>
    </div>
`);
registerTemplate("sign.SignRequestControlPanel", `/sign/static/src/backend_components/sign_request/sign_request_control_panel.xml`, `<t t-name="sign.SignRequestControlPanel" xml:space="preserve">
        <ControlPanel display="controlPanelDisplay">
            <t t-set-slot="control-panel-always-buttons">
                <div class="d-flex gap-1">
                    <button t-if="signInfo.get('needToSign')" type="button" class="btn btn-primary me-2 o_sign_sign_directly" t-on-click="signDocument">Sign Now</button>
                    <button t-if="nextTemplate &amp;&amp; nextTemplate.template" type="button" class="btn btn-primary me-2" t-on-click="goToNextDocument">Next Document</button>
                    <button t-if="allowCancel" type="button" class="btn btn-secondary me-2 o_sign_cancel" t-on-click="cancelDocument">Cancel</button>
                    <a t-if="signInfo.get('signRequestState') == 'signed'" t-attf-href="/sign/download/{{signInfo.get('documentId')}}/{{signInfo.get('signRequestToken')}}/completed" class="btn btn-primary o_sign_download_document_button">Download Document</a>
                    <a t-if="signInfo.get('signRequestState') == 'signed'" t-attf-href="/sign/download/{{signInfo.get('documentId')}}/{{signInfo.get('signRequestToken')}}/log" class="btn btn-secondary o_sign_download_log_button">Download Certificate</a>
                </div>
            </t>
            <t t-set-slot="control-panel-navigation-additional">
                <div class="signer-status">
                    <t t-out="markupSignerStatus"/>
                </div>
            </t>
        </ControlPanel>
    </t>
`);
registerTemplate("sign.SignSignableRequestControlPanel", `/sign/static/src/backend_components/sign_request/signable_sign_request_control_panel.xml`, `<t t-name="sign.SignSignableRequestControlPanel" t-inherit="sign.SignRequestControlPanel" xml:space="preserve">
        <xpath expr="//button[@t-if='nextTemplate &amp;&amp; nextTemplate.template']" position="after">
            <button t-if="signInfo.get('refusalAllowed')" type="button" class="o_sign_refuse_document_button btn btn-secondary" t-on-click="refuseDocument">Refuse Document</button>
            <button t-if="signInfo.get('editWhileSigning')" type="button" class="o_sign_edit_button btn btn-secondary mobile-tablet-hide" t-on-click="toggleEditBar">Edit</button>
        </xpath>
    </t>
`);
registerTemplate("sign.SignItemCustomPopover", `/sign/static/src/backend_components/sign_template/sign_item_custom_popover.xml`, `<t t-name="sign.SignItemCustomPopover" xml:space="preserve">
        <div class="d-flex flex-column" style="max-width: 25rem;">
            <div class="d-flex bg-opacity-25 bg-secondary justify-content-between align-items-center">
                <span class="fs-3 fw-bold ps-2" t-esc="props.header_title"/>
                <button type="button" title="Close" class="btn btn-default oi oi-close" t-on-click="props.onClose"/>
            </div>
            <div class="d-flex p-2 flex-column">
                <div class="mb-1 clearfix o_popover_placeholder" t-if="props.debug">
                    <label for="o_sign_name" class="form-label fw-bold">Placeholder</label>
                    <input type="text" class="form-control o_input" id="o_sign_name" t-att-value="state.placeholder" t-on-change="(e) =&gt; this.onChange('placeholder', e.target.value)"/>
                </div>

                <Record t-props="recordProps" t-slot-scope="data">
                    <t t-set="record" t-value="data.record"/>
                    <div t-if="props.type === 'selection'">
                        <label for="o_sign_select_options_input" class="fw-bold">Options</label>
                        <div class="o_field_widget d-block" id="o_sign_select_options_input">
                            <Many2ManyTagsField t-props="getOptionsProps(record, 'option_ids')"/>
                        </div>
                    </div>
                    <div t-if="props.type === 'radio'" class="mb-2">
                        <div class="o_field_widget d-block d-flex" id="o_sign_select_radio_qty_input">
                            <label for="o_sign_select_radio_qty_input" class="fw-bold">Options</label>
                            <input type="number" inputmode="numeric" class="px-2 o_input" t-att-value="state.num_options" t-att-min="2" t-on-change="(e) =&gt; this.handleNumOptionsChange(e.target.value)"/>
                        </div>
                    </div>
                    <div class="mb-2">
                        <label for="o_sign_responsible_select_input" class="fw-bold">Filled by</label>
                        <div class="o_field_widget d-block" id="o_sign_responsible_select_input">
                            <Many2OneField t-props="getMany2XProps(record, 'responsible_id')" update="(value) =&gt; record.update(value)" canOpen="false"/>
                        </div>
                    </div>
                </Record>
                <div t-if="showAlignment" class="o_sign_field_align_group">
                    <label class="w-100 fw-bold">Alignment</label>
                    <div class="btn-group mb-2" role="group">
                        <button t-foreach="alignmentOptions" t-as="alignment" t-key="alignment.key" type="button" t-att-title="alignment.title" t-on-click="(e) =&gt; this.onChange('alignment', alignment.key)" t-attf-class="fa-align-{{alignment.key}} {{alignment.key === state.alignment ? 'active': ''}} btn btn-secondary fa"/>
                    </div>
                </div>
                <div class="mb-2">
                    <div class="checkbox">
                        <label for="o_sign_required_field">
                            <input type="checkbox" id="o_sign_required_field" t-att-checked="state.required" t-on-change="(e) =&gt; this.onChange('required', e.target.checked)"/> Mandatory field
                            </label>
                        </div>
                    </div>
                    <div class="mb-1 d-flex align-items-center justify-content-between">
                        <button class="btn o_sign_validate_field_button btn-primary" t-on-click="onValidate">Validate</button>
                        <button class="btn btn-secondary fa fa-trash" t-on-click="props.onDelete"/>
                    </div>
                </div>
        </div>
    </t>
`);
registerTemplate("sign.Template", `/sign/static/src/backend_components/sign_template/sign_template_action.xml`, `<div t-name="sign.Template" class="d-flex flex-column h-100" xml:space="preserve">
        <SignTemplateControlPanel actionType="actionType" hasSignRequests="hasSignRequests" responsibleCount="responsibleCount" signTemplate="signTemplate" isPDF="isPDF" goBackToKanban.bind="goBackToKanban"/>
        <SignTemplateBody isPDF="isPDF" attachmentLocation="attachmentLocation" manageTemplateAccess="manageTemplateAccess" hasSignRequests="hasSignRequests" signTemplate="signTemplate" signItemTypes="signItemTypes" signItems="signItems" signRoles="signRoles" radioSets="radioSets" signItemOptions="signItemOptions" goBackToKanban.bind="goBackToKanban" resModel="resModel"/>
    </div>
`);
registerTemplate("sign.SignTemplateBody", `/sign/static/src/backend_components/sign_template/sign_template_body.xml`, `<t t-name="sign.SignTemplateBody" xml:space="preserve">
        <SignTemplateTopBar manageTemplateAccess="props.manageTemplateAccess" hasSignRequests="props.hasSignRequests" signTemplate="props.signTemplate" resModel="props.resModel" onTemplateNameChange="(e) =&gt; this.onTemplateNameChange(e)" isPDF="props.isPDF"/>
        <iframe class="o_iframe o_sign_pdf_iframe" t-ref="PDFIframe" t-att-src="PDFViewerURL" t-att-disabled="props.hasSignRequests"/>
    </t>
`);
registerTemplate("sign.SignTemplateControlPanel", `/sign/static/src/backend_components/sign_template/sign_template_control_panel.xml`, `<t t-name="sign.SignTemplateControlPanel" xml:space="preserve">
        <ControlPanel display="controlPanelDisplay">
            <t t-set-slot="control-panel-always-buttons">
                <div class="d-flex gap-1">
                    <t t-if="props.actionType === '' || props.actionType === 'sign_send_request'">
                        <button type="button" class="btn btn-primary o_sign_template_send" t-on-click="onSendClick">Send</button>
                        <button type="button" class="btn btn-primary o_sign_template_sign_now text-nowrap" t-on-click="onSignNowClick">Sign Now</button>
                        <t t-if="showShareButton">
                            <button type="button" class="btn btn-secondary o_sign_template_share" t-on-click="onShareClick">Share</button>
                        </t>
                    </t>
                    <t t-elif="props.actionType === 'sign_template_edit'">
                        <button type="button" class="btn btn-primary o_sign_template_save" t-on-click="props.goBackToKanban">Save</button>
                        <button t-if="nextTemplate" type="button" class="btn btn-primary o_sign_template_next" t-on-click="onNextDocumentClick">
                            Next Document
                        </button>
                    </t>
                </div>
            </t>
        </ControlPanel>
    </t>
`);
registerTemplate("sign.SignTemplateTopBar", `/sign/static/src/backend_components/sign_template/sign_template_top_bar.xml`, `<t t-name="sign.SignTemplateTopBar" xml:space="preserve">
        <div class="o_sign_template_header_wrapper px-4 py-2 align-items-center d-md-flex">
            <div class="o_sign_template_header_document_name align-items-center d-flex me-auto">
                <span t-if="!props.hasSignRequests" t-on-click="editDisplayName" class="fa fa-pencil me-2" title="Edit template name" role="img" aria-label="Edit template name"/>
                <input type="text" t-ref="display-name" class="o_sign_template_name_input o_input" t-att-value="props.signTemplate.display_name" t-att-disabled="props.hasSignRequests" t-att-size="displayNameSize" t-on-change="this.props.onTemplateNameChange" t-on-input="changeInputSize" t-on-keydown="onKeyDown"/>
            </div>
            <Record t-props="recordProps" t-slot-scope="data">
                <t t-set="record" t-value="data.record"/>

                <div t-if="props.manageTemplateAccess" class="o_sign_template_authorized_ids_and_save align-items-center d-flex gap-2">
                    <span>Authorized Users:</span>
                    <div class="o_field_widget o_field_many2many_tags">
                        <Many2ManyTagsField t-props="getMany2ManyProps(record, 'authorized_ids')"/>
                    </div>
                </div>

                <div t-if="props.manageTemplateAccess" class="o_sign_template_group_id_and_save align-items-center d-flex gap-2">
                    <span>Authorized Groups:</span>
                    <div class="o_field_widget o_field_many2many_tags">
                        <Many2ManyTagsField t-props="getMany2ManyProps(record, 'group_ids')"/>
                    </div>
                </div>

                <div t-attf-class="o_sign_template_tags_and_save align-items-center d-flex me-5 gap-2 {{ !env.isSmall and !props.hasSignRequests ? 'o_sign_tags_format' : ''}}">
                    <span>Tags:</span>
                    <div class="o_field_widget o_field_many2many_tags col-lg-12">
                        <Many2ManyTagsFieldColorEditable t-props="getMany2ManyProps(record, 'tag_ids')" colorField="'color'"/>
                    </div>
                </div>
            </Record>

            <div class="float-end">
                <t t-if="showEditButton">
                    <t class="o_duplicate">
                        <button type="button" class="o_sign_template_duplicate btn btn btn-secondary me-1" t-on-click="editTemplate">
                            Edit
                        </button>
                    </t>
                </t>

                <button class="btn btn-secondary o_sign_template_edit_form" t-on-click="!props.signTemplate.active &amp;&amp; !state.properties ? onTemplateSaveClick : onTemplatePropertiesClick">
                    <t t-if="!props.signTemplate.active &amp;&amp; !state.properties">Save as Template</t>
                    <t t-else="">Template Properties</t>
                </button>
            </div>
        </div>
    </t>
`);
registerTemplate("sign.signItemTypesSidebar", `/sign/static/src/backend_components/sign_template/sign_type_buttons.xml`, `<t t-name="sign.signItemTypesSidebar" xml:space="preserve">
        <t t-set="icon_type" t-value="{             'signature': 'fa-pencil-square-o',             'initial': 'fa-pencil-square-o',             'text': 'fa-font',             'textarea': 'fa-bars',             'checkbox': 'fa-check-square-o',             'selection': 'fa-dot-circle-o',         }"/>
        <div t-attf-class="o_sign_field_type_toolbar d-flex flex-column bg-white {{ sidebarHidden ? 'd-none' : ''}}">
            <div class="o_sign_field_type_toolbar_title d-flex justify-content-center align-items-center pt-2">Fields</div>
            <div class="o_sign_field_type_toolbar_items d-flex flex-column p-2">
                <t t-foreach="signItemTypes" t-as="itemType" t-key="itemType.id">
                    <button type="button" class="o_sign_field_type_button btn btn-secondary flex-shrink-0 mb-1" t-att-data-item-type-id="itemType.id" title="Drag &amp; Drop a field in the PDF">
                        <span class="d-flex justify-content-start align-items-center">
                            <i t-attf-class="fa fa-fw #{itemType.icon ? itemType.icon : icon_type[itemType.item_type]} me-2" role="img"/>
                            <t t-esc="itemType.name"/>
                        </span>
                    </button>
                </t>
            </div>
        </div>
    </t>
`);
registerTemplate("sign.TemplateAlertDialog", `/sign/static/src/backend_components/template_alert_dialog/template_alert_dialog.xml`, `<t t-name="sign.TemplateAlertDialog" xml:space="preserve">
        <Dialog size="'md'" title="props.title" contentClass="props.contentClass">
            <p>These files cannot be read, they may be corrupted or encrypted.</p>
            <t t-foreach="props.failedTemplates" t-as="failedTemplate" t-key="failedTemplate">
                <p> - <t t-out="failedTemplate.name"/></p>
            </t>
            <p>They will be removed from the uploaded files<span t-if="props.failedTemplates.length &lt; props.successTemplateCount"> and the process will continue</span>.</p>
            <t t-set-slot="footer">
              <button class="btn btn-primary" t-on-click="_confirm" t-esc="props.confirmLabel"/>
              <button t-if="props.cancel" class="btn btn-secondary" t-on-click="_cancel" t-esc="props.cancelLabel"/>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("sign.SignViews.buttons", `/sign/static/src/views/common.xml`, `<t t-name="sign.SignViews.buttons" xml:space="preserve">
        <t t-if="!env.isSmall">
            <input type="file" multiple="true" t-ref="uploadFileInput" accept="application/pdf, application/x-pdf, application/vnd.cups-pdf" class="o_sign_template_file_input o_input_file o_hidden" t-on-change.stop="onFileInputChange"/>
            <t t-if="props.resModel === 'sign.template'" t-call="sign.SignViews.sign_template.buttons"/>
            <t t-if="props.resModel === 'sign.request'" t-call="sign.SignViews.sign_request.buttons"/>
        </t>
    </t>

    `);
registerTemplate("sign.SignViews.sign_template.buttons", `/sign/static/src/views/common.xml`, `<t t-name="sign.SignViews.sign_template.buttons" xml:space="preserve">
        <div class="btn-group">
            <button class="btn btn-primary" title="Upload a pdf that you want to sign directly" t-on-click="() =&gt; this.requestFile('sign_send_request')">
                Upload PDF
            </button>
        </div>
    </t>

    `);
registerTemplate("sign.SignViews.sign_request.buttons", `/sign/static/src/views/common.xml`, `<t t-name="sign.SignViews.sign_request.buttons" xml:space="preserve">
        <button class="btn btn-primary" title="Upload a pdf that you want to sign directly" t-on-click="() =&gt; this.requestFile('sign_send_request')">
            Upload a PDF &amp; Sign
        </button>
    </t>
`);
registerTemplate("sign.SignActionHelper", `/sign/static/src/views/helper/sign_action_helper.xml`, `<t t-name="sign.SignActionHelper" xml:space="preserve">
        <div class="o_view_nocontent">
            <div class="o_nocontent_help">
                <p class="o_view_nocontent_sign">
                    Drag and drop <span class="fw-normal">or </span>
                    <span class="btn btn-link fs-2 p-0 pb-1" t-on-click="() =&gt; this.onClickUpload('sign_send_request')">
                        Upload
                    </span>
                </p>
                <p t-if="this.props.resModel === 'sign.template'">Upload a PDF file to create a reusable template.</p>
                <p t-else="">Document to send for signature or to sign yourself.</p>
                <button class="btn btn-primary text-white o_sign_sample" t-on-click="onClicksampleSign">
                    <t t-if="this.props.resModel === 'sign.request'">Try a sample contract</t>
                    <t t-else="">Try our sample document</t>
                </button>
            </div>
            <input type="file" multiple="true" t-ref="uploadFileInput" accept="application/pdf, application/x-pdf, application/vnd.cups-pdf" class="o_sign_template_file_input o_input_file o_hidden" t-on-change.stop="onFileInputChange"/>
        </div>
    </t>
`);
registerTemplate("sign.SignKanbanController", `/sign/static/src/views/sign_kanban/sign_kanban_controller.xml`, `<t t-name="sign.SignKanbanController" t-inherit="web.KanbanView" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//Layout" position="inside">
            <t t-set-slot="control-panel-create-button">
                <t t-call="sign.SignViews.buttons"/>
            </t>
        </xpath>
    </t>
`);
registerTemplate("sign.KanbanRenderer", `/sign/static/src/views/sign_kanban/sign_kanban_renderer.xml`, `<t t-name="sign.KanbanRenderer" t-inherit="web.KanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_kanban_renderer')]" position="attributes">
            <attribute name="class" add="o_sign_view" separator=" "/>
        </xpath>
        <xpath expr="//div[hasclass('o_kanban_renderer')]" position="before">
            <div t-if="dragState.showDragZone" class="o_dropzone">
                <i class="fa fa-upload fa-10x"/>
            </div>
        </xpath>
        <t t-call="web.ActionHelper" position="replace">
            <t t-if="showNoContentHelper">
                <SignActionHelper resModel="props.list.resModel"/>
            </t>
        </t>
    </t>
`);
registerTemplate("sign.SignListController", `/sign/static/src/views/sign_list/sign_list_controller.xml`, `<t t-name="sign.SignListController" t-inherit="web.ListView" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//Layout" position="inside">
            <t t-set-slot="control-panel-create-button">
                <t t-call="sign.SignViews.buttons"/>
            </t>
        </xpath>
    </t>
`);
registerTemplate("sign.ListRenderer", `/sign/static/src/views/sign_list/sign_list_renderer.xml`, `<t t-name="sign.ListRenderer" t-inherit="web.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_list_renderer')]" position="attributes">
            <attribute name="class" add="o_sign_view" separator=" "/>
        </xpath>
        <xpath expr="//div[hasclass('o_list_renderer')]" position="before">
            <div t-if="dragState.showDragZone" class="o_dropzone">
                <i class="fa fa-upload fa-10x"/>
            </div>
        </xpath>
        <t t-call="web.ActionHelper" position="replace">
            <t t-if="showNoContentHelper">
                <SignActionHelper resModel="props.list.resModel"/>
            </t>
        </t>
    </t>
`);
registerTemplate("sign.EncryptedDialog", `/sign/static/src/dialogs/encrypted_dialog.xml`, `<t t-name="sign.EncryptedDialog" xml:space="preserve">
        <Dialog t-props="dialogProps">
            <div class="mb-3">
                <span>Your file is encrypted, PDF's password is required to generate final document. The final document will be encrypted with the same password.</span>
                <div>
                    <input type="password" t-ref="password" class="form-control"/>
                </div>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary o_sign_validate_encrypted" t-on-click="validatePassword">Generate PDF</button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("sign.InitialsAllPagesDialog", `/sign/static/src/dialogs/initial_all_pages_dialog.xml`, `<t t-name="sign.InitialsAllPagesDialog" xml:space="preserve">
        <Dialog t-props="dialogProps">
            <div class="m-2">
                <label for="responsible_select_initials_input" class="col-md-2">Responsible</label>
                <select id="responsible_select_initials_input" class="form-select w-75" t-ref="role_select">
                    <t t-foreach="props.roles" t-as="role_id" t-key="role_id">
                        <t t-set="role" t-value="props.roles[role_id]"/>
                        <option t-att-value="role_id" t-att-selected="role_id == props.responsible">
                            <t t-esc="role.name"/>
                        </option>
                    </t>
                </select>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="onAddOnceClick">Add Once</button>
                <button class="btn btn-secondary" t-on-click="onAddToAllPagesClick" t-att-hidden="props.pageCount &lt;= 1">Add to all pages</button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("sign.NextDirectSignDialog", `/sign/static/src/dialogs/next_direct_sign_dialog.xml`, `<t t-name="sign.NextDirectSignDialog" xml:space="preserve">
        <Dialog t-props="dialogProps">
            <t t-set-slot="header">
                <h4 class="modal-title text-break" t-att-class="{ 'me-auto': fullscreen }">
                    <t t-esc="title"/>
                </h4>
            </t>
            <div class="o_nextdirectsign_message">
                <p>Your signature has been saved. Next signatory is <t t-esc="nextSigner"/></p>
                <p>We will send you this document by email once everyone has signed.</p>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="goToNextSigner">Next signatory (<t t-esc="nextSigner"/>)</button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("sign.PublicSignerDialog", `/sign/static/src/dialogs/public_signer_dialog.xml`, `<t t-name="sign.PublicSignerDialog" xml:space="preserve">
        <Dialog t-props="dialogProps">
            <div class="mb-3 row">
                    <label for="o_sign_public_signer_name_input" class="col-lg-3 col-form-label">Your name</label>
                    <div class="col-lg-9">
                        <input type="text" t-ref="name" id="o_sign_public_signer_name_input" placeholder="Your name" class="form-control" t-att-value="props.name"/>
                    </div>
                </div>
                <div class="mb-3 row">
                    <label for="o_sign_public_signer_mail_input" class="col-lg-3 col-form-label">Your email</label>
                    <div class="col-lg-9">
                        <input type="email" t-ref="mail" id="o_sign_public_signer_mail_input" placeholder="Your email" class="form-control" t-att-value="props.mail"/>
                    </div>
                </div>

                <t t-set-slot="footer">
                    <button class="btn btn-primary" t-on-click="submit">Validate &amp; Send</button>
                    <button class="btn btn-link" t-on-click="props.close">Cancel</button>
                </t>
        </Dialog>
    </t>
`);
registerTemplate("sign.SignNameAndSignatureDialog", `/sign/static/src/dialogs/sign_name_and_signature_dialog.xml`, `<t t-name="sign.SignNameAndSignatureDialog" xml:space="preserve">
        <Dialog t-props="dialogProps">
            <SignNameAndSignature t-props="nameAndSignatureProps"/>
            <div class="mt16 small">
                By clicking Adopt &amp; Sign, I agree that the chosen signature/initials will be a valid electronic representation of my hand-written signature/initials for all purposes when it is used on documents, including legally binding contracts.
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-if="props.onConfirmAll" t-on-click="props.onConfirmAll" t-att-disabled="footerState.signAllButtonsDisabled">Sign all</button>
                <button class="btn btn-secondary" t-on-click="props.onConfirm" t-att-disabled="footerState.signButtonDisabled">Sign</button>
                <button class="btn btn-secondary" t-on-click="props.close">Cancel</button>
            </t>
        </Dialog>
    </t>

    `);
registerTemplate("sign.NameAndSignature", `/sign/static/src/dialogs/sign_name_and_signature_dialog.xml`, `<t t-name="sign.NameAndSignature" t-inherit="web.NameAndSignature" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('division')]" position="after">
            <div t-attf-class="col-auto form-check btn border-0 {{ showFrameCheck ? '' : 'd-none'}}">
                <input type="checkbox" t-attf-class="o_web_frame_button form-check-input" id="switchFrame" t-att-checked="state.activeFrame" t-on-change="onFrameChange"/>
                <label class="form-check-label" for="switchFrame" data-tooltip="Include a visual security frame around your signature">Frame</label>
            </div>
        </xpath>
        <xpath expr="//div[hasclass('o_signature_stroke')]" position="before">
            <div t-attf-class="o_sign_frame {{ signFrameClass }}" t-ref="signFrame">
                <p t-att-hash="props.hash" t-attf-sign_label="Signed with Odoo Sign"/>
            </div>
        </xpath>
        <xpath expr="//canvas[hasclass('o_web_sign_signature')]" position="attributes">
            <attribute name="t-on-click">onSignatureAreaClick</attribute>
        </xpath>
    </t>
`);
registerTemplate("sign.SignRefusalDialog", `/sign/static/src/dialogs/sign_refusal_dialog.xml`, `<t t-name="sign.SignRefusalDialog" xml:space="preserve">
        <Dialog t-props="dialogProps">
            <div>
                <textarea class="o_sign_refuse_confirm_message" placeholder="Why do you refuse to sign this document?" t-ref="refuse-reason" t-on-change="checkForChanges" t-on-keyup="checkForChanges" t-on-paste="checkForChanges"/>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary refuse-button" t-on-click="refuse" t-ref="refuse-button" disabled="disabled">Refuse</button>
                <button class="btn btn-secondary" t-on-click="props.close">Cancel</button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("sign.SMSSignerDialog", `/sign/static/src/dialogs/sms_signer_dialog.xml`, `<t t-name="sign.SMSSignerDialog" xml:space="preserve">
        <Dialog t-props="dialogProps">
            <div class="mb-3 row">
                <label class="col-sm-3 col-form-label" for="phone">Phone Number</label>
                <div class="col-sm">
                    <div class="input-group">
                        <input type="text" name="phone" t-ref="phone" placeholder="e.g. +1 415 555 0100" class="form-control" t-att-value="SMSInfo.phoneNumber"/>
                        <button class="btn btn-sm btn-primary o_sign_resend_sms" t-on-click="onSendSMSClick" t-ref="send-sms" t-att-disabled="state.sendingSMS">
                            <t t-if="state.sendingSMS">
                                <span>
                                    <i class="fa fa-check"/> SMS Sent
                                </span>
                            </t>
                            <t t-elif="state.SMSCount &gt; 0">
                                Re-send SMS
                            </t>
                            <t t-else="">
                                Send SMS
                            </t>
                        </button>
                    </div>
                    <span class="text-muted form-text">A SMS will be sent to the following phone number. Please update it if it's not relevant.</span>
                </div>
            </div>
            <div class="mb-3 row">
                <label class="col-sm-3 col-form-label" for="validation_code">Validation Code</label>
                <div class="col-sm">
                    <input type="text" name="validation_code" t-ref="code" id="o_sign_public_signer_sms_input" placeholder="e.g. 314159" class="form-control"/>
                    <span class="text-muted form-text">Enter the code received through SMS to complete your signature</span>
                </div>
            </div>

            <t t-set-slot="footer">
                <button class="btn btn-primary o_sign_validate_sms" t-on-click="validateSMS">Verify</button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("sign.ThankYouDialog", `/sign/static/src/dialogs/thank_you_dialog.xml`, `<t t-name="sign.ThankYouDialog" xml:space="preserve">
        <Dialog t-props="dialogProps">
            <t t-set-slot="header" t-slot-scope="scope">
                <h4 class="modal-title text-break text-center" t-att-class="{ 'me-auto': scope.isFullscreen }">
                    It's signed!
                </h4>
            </t>
            <h5 t-if="props.subtitle" id="thank-you-subtitle"><t t-esc="props.subtitle"/></h5>
            <div t-attf-class="d-flex flex-column align-items-center gap-2">
                <i class="fa fa-check fa-2x p-2 rounded-circle text-success bg-success-subtle" role="img"/>
                <div id="thank-you-message" class="o_thankyou_message">
                    <t t-esc="message"/>
                </div>
            </div>
            <t t-if="state.nextDocuments.find((doc) =&gt; !doc.canceled)">
                <hr/>
                <t t-if="isMobileOS">
                    <br/>
                </t>
                <div class="o_thankyou_message">There are other documents waiting for your signature:</div>
                <table class="table table-sm">
                    <colgroup>
                        <col span="1" class="o_thank_you_table_first_col"/>
                        <col span="1" class="o_thank_you_table_second_col"/>
                    </colgroup>
                    <tbody>
                        <t t-foreach="state.nextDocuments.filter((doc) =&gt; !doc.canceled)" t-as="doc" t-key="doc.id">
                            <tr t-attf-class="next-document">
                                <th t-attf-class="{{doc_last and 'border-0'}}">
                                    <div><strong t-out="doc.name"/></div>
                                    <span>Sent by <span t-out="doc.user"/> on <span t-out="doc.date"/></span>
                                </th>
                                <th t-attf-class="{{doc_last and 'border-0'}}">
                                    <div t-attf-class="{{ isMobileOS ? 'd-flex flex-column gap-2' : 'text-end d-flex flex-row gap-1' }}">
                                        <button class="btn btn-sm btn-primary o_thankyou_next_sign w-100" t-on-click="() =&gt; this.clickNextSign(doc.requestId, doc.accessToken)">Sign now</button>
                                        <button class="btn btn-sm btn-secondary o_thankyou_next_cancel w-100" t-on-click="() =&gt; this.clickNextCancel(doc)">Refuse</button>
                                    </div>
                                </th>
                            </tr>
                        </t>
                    </tbody>
                </table>
            </t>
            <div t-if="suggestSignUp" class="o_thankyou_message d-flex gap-2 border-top mt-3 pt-3">
                <img class="img" height="48" width="48" src="/base/static/img/icons/sign.png"/>
                <div>
                    <h6 class="mb-1">Need to sign documents?</h6>
                    <p class="mb-0"><a class="fw-bold" href="https://www.odoo.com/trial?selected_app=sign&amp;utm_source=db&amp;utm_medium=sign" target="_blank">Odoo Sign</a> is free, forever, with unlimited users - and it's fun to use!</p>
                </div>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-if="signRequestState === 'signed'" t-on-click="() =&gt; this.downloadDocument()">Download</button>
                <t t-foreach="state.buttons" t-as="button" t-key="button.name">
                    <button t-att-class="button.classes" t-on-click="button.click" t-att-disabled="button.disabled"><t t-out="button.name"/></button>
                </t>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("sign.Many2ManyBinaryField", `/sign/static/src/fields/ many2many_binary_field/ many2many_binary_field.xml`, `<t t-name="sign.Many2ManyBinaryField" t-inherit="web.Many2ManyBinaryField" t-inherit-mode="primary" xml:space="preserve">

        <xpath expr="//div//div[hasclass('oe_add')]//button" position="attributes">
            <attribute name="class" add="d-flex" separator=" "/>
        </xpath>

        <xpath expr="//div//div[hasclass('oe_add')]//button//span" position="attributes">
            <attribute name="class" add="p-1" separator=" "/>
        </xpath>

        <xpath expr="//div//div[hasclass('oe_add')]//button" position="attributes">
            <attribute name="class" add="mt-1" separator=" "/>
        </xpath>

        <xpath expr="//div//div[hasclass('oe_add')]" position="attributes">
            <attribute name="class" add="d-flex" separator=" "/>
        </xpath>
    </t>

`);
registerTemplate("sign.SignerX2Many", `/sign/static/src/fields/signer_x2many.xml`, `<t t-name="sign.SignerX2Many" xml:space="preserve">
        <div class="d-flex gap-2 mb-2 d-contents o_cell o_wrap_label flex-grow-1 flex-sm-grow-0 w-100 text-break text-900" t-foreach="list.records" t-as="record" t-key="record.id">
            <div class="d-flex flex-row">
                <div t-if="shouldShowOrder" class="o_signer_one2many_mail_sent_order me-1" t-att-class="{ 'small': env.isSmall }">
                    <IntegerField name="'mail_sent_order'" record="record"/>
                </div>
                <t t-set="labelId" t-value="record.id + partnerIdFieldInfo.name"/>
                <label t-att-for="labelId" t-out="record.data['role_id'][1]" class="o_form_label"/>
            </div>
            <div class="o_field_wrap">
                <Many2OneField id="labelId" name="partnerIdFieldInfo.name" record="record" t-props="partnerIdFieldInfo.additionalProps"/>
            </div>
        </div>
    </t>
`);
registerTemplate("knowledge.ArticleItemTemplate", `/knowledge/static/src/xml/knowledge_article_templates.xml`, `<t t-name="knowledge.ArticleItemTemplate" xml:space="preserve">
        <h1 t-out="title"/>
        <div t-att-data-embedded-props="embeddedProps" data-embedded="view" data-oe-protected="true" contenteditable="false"/>
        <p><br/></p>
    </t>
`);
registerTemplate("KnowledgeCommandTemplate", `/knowledge/static/src/xml/knowledge_command_palette.xml`, `<t t-name="KnowledgeCommandTemplate" xml:space="preserve">
        <div class="o_command_default px-4 py-2">
            <div class="o_command_palette_box_header d-flex align-items-center">
                <span class="pe-2" t-if="props.icon_string" t-out="props.icon_string"/>
                <span class="pe-2 text-ellipsis">
                    <t t-slot="name"/>
                </span>
                <icon t-if="props.isFavorite" class="fa fa-star o_favorite pe-2 position-static"/>
                <span t-if="props.subjectName" class="text-muted small pe-2">—</span>
                <span t-if="props.subjectName" class="o_command_name text-ellipsis text-muted small">
                    <t t-foreach="props.splitSubjectName" t-as="name" t-key="name_index">
                        <t t-if="name" t-out="name"/>
                        <t t-else="">Untitled</t>
                    </t>
                </span>
                <span class="ms-auto flex-shrink-0">
                    <t t-slot="focusMessage"/>
                </span>
            </div>
            <div t-if="props.headline" t-out="props.headline" class="border rounded text-muted my-2 p-2"/>
        </div>
    </t>

    `);
registerTemplate("Knowledge404CommandTemplate", `/knowledge/static/src/xml/knowledge_command_palette.xml`, `<t t-name="Knowledge404CommandTemplate" xml:space="preserve">
        <div class="o_command_hotkey">
            <span>
                No Article found.
                <span class="text-primary">
                    Create "<u t-out="props.articleName"/>"
                </span>
            </span>
        </div>
    </t>

    `);
registerTemplate("KnowledgeExtraCommandTemplate", `/knowledge/static/src/xml/knowledge_command_palette.xml`, `<t t-name="KnowledgeExtraCommandTemplate" xml:space="preserve">
        <div class="o_command_hotkey">
            <span>
                <icon class="fa fa-arrows-alt pe-2"/>
                <t t-if="props.name" t-out="props.name"/>
                <t t-else="">Untitled</t>
            </span>
            <span>
                <t t-foreach="getKeysToPress(props)" t-as="key" t-key="key_index">
                    <kbd t-out="key"/>
                    <span t-if="!key_last"> + </span>
                </t>
            </span>
        </div>
    </t>

    `);
registerTemplateExtension("web.CommandPalette", `/knowledge/static/src/xml/knowledge_command_palette.xml`, `<t t-inherit="web.CommandPalette" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('o_command_palette_search')]/input" position="after">
            <a t-if="this.state.namespace === '$'" role="button" class="btn btn-dark disabled py-0 rounded-pill">
                Hidden
            </a>
        </xpath>
    </t>
`);
registerTemplate("knowledge.ArticleFormView", `/knowledge/static/src/xml/knowledge_controller.xml`, `<t t-name="knowledge.ArticleFormView" t-inherit="web.FormView" xml:space="preserve">

        <xpath expr="//Layout" position="attributes">
            <attribute name="className" add="'o_knowledge_form_view d-flex border-top'" separator="+"/>
        </xpath>

        <xpath expr="//t[@archInfo='archInfo']" position="before">
            <KnowledgeSidebar record="model.root"/>
        </xpath>

        <xpath expr="//t[@archInfo='archInfo']" position="after">
            <div class="o_knowledge_backdrop cursor-pointer" t-on-click="() =&gt; this.toggleAsideMobile()"/>
        </xpath>

        <xpath expr="//t[@archInfo='archInfo']" position="attributes">
            <attribute name="class" add="'p-0 d-flex flex-column flex-grow-1 min-w-0 mw-100'"/>
        </xpath>

    </t>
`);
registerTemplate("knowledge.ArticleSelectionDialog", `/knowledge/static/src/components/article_selection_dialog/article_selection_dialog.xml`, `<t t-name="knowledge.ArticleSelectionDialog" xml:space="preserve">
        <Dialog size="'md'" title="this.props.title">
            <div class="m-0">
                <SelectMenu onInput.bind="fetchArticles" onSelect.bind="selectArticle" choices="this.state.knowledgeArticles || []" togglerClass="'form-control o_knowledge_select_menu show'" class="'o_knowledge_select_menu fst-normal fw-normal show'" required="true">
                    <span t-ref="togglerRef" class="fw-lighter"><t t-out="state.selectedArticleName || this.placeholderLabel"/></span>
                    <t t-set-slot="choice" t-slot-scope="choice">
                        <span>
                            <t t-out="choice.data.label"/>
                            <span t-if="choice.data.value and choice.data.value.rootArticleName" class="text-muted small">
                                - <t t-out="choice.data.value.rootArticleName"/>
                            </span>
                        </span>
                    </t>
                    <t t-set-slot="bottomArea" t-slot-scope="select">
                        <DropdownItem t-if="select.data.searchValue and this.state.isInternalUser" class="'o_select_menu_sticky o_select_menu_item position-sticky text-italic bottom-0 text-primary text-start'" onSelected="() =&gt; this.createKnowledgeArticle(select.data.searchValue)">
                            <t t-out="this.state.createLabel"/>
                        </DropdownItem>
                    </t>
                </SelectMenu>
            </div>
            <t t-set-slot="footer">
                <button t-attf-class="btn btn-primary #{!this.state.selectedArticleName ? 'disabled' : ''}" t-out="this.props.confirmLabel" t-on-click="this.confirmArticleSelection.bind(this)"/>
                <button class="btn btn-secondary" t-on-click="this.props.close.bind(this)">
                    Cancel
                </button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("knowledge.ArticleTemplatePickerDialog", `/knowledge/static/src/components/article_template_picker_dialog/article_template_picker_dialog.xml`, `<t t-name="knowledge.ArticleTemplatePickerDialog" xml:space="preserve">
        <Dialog size="size" title.translate="Select a Template" bodyClass="'o_knowledge_article_template_picker_dialog p-0'">
            <div t-if="groups.length &gt; 0" class="d-sm-flex">
                <div class="o_knowledge_template_selector flex-shrink-0 p-3">
                    <t t-foreach="groups" t-as="group" t-key="group_index">
                        <div class="text-truncate text-muted mb-2">
                            <t t-out="group[0]['template_category_id'][1]"/>
                        </div>
                        <ul class="list-unstyled">
                            <li t-foreach="group" t-as="template" t-key="template.id" t-on-click="event =&gt; this.onSelectTemplate(template.id)" t-attf-class="text-nowrap cursor-pointer #{ template.id === this.state.resId ? 'active fw-bold' : '' }">
                                <div class="d-flex align-items-center">
                                    <span class="p-1">
                                        <t t-if="template.icon" t-out="template.icon"/>
                                        <t t-else="">📄</t>
                                    </span>
                                    <div class="flex-grow-1 text-truncate px-1" t-out="template.template_name"/>
                                </div>
                            </li>
                        </ul>
                    </t>
                </div>
                <div class="d-flex flex-column flex-grow-1 min-w-0">
                    <Record resModel="'knowledge.article'" resId="this.state.resId" fieldNames="this.articleTemplateFieldNames" mode="'readonly'" t-slot-scope="slot">
                        <div class="o_knowledge_template_preview flex-grow-1 flex-basis-0" t-ref="scroll-view">
                            <img t-if="slot.record.data.cover_image_url" t-att-src="slot.record.data.cover_image_url" class="o_article_template_cover"/>
                            <div class="o_article_template_container mx-auto p-4">
                                <div t-if="slot.record.data.icon" t-out="slot.record.data.icon" class="o_article_template_emoji"/>
                                <div class="o_article_template_body mt-3 pe-none">
                                    <WithSubEnv model="slot.record.model">
                                        <KnowledgeHtmlViewer t-props="this.getHtmlViewerConfig(slot.record)"/>
                                    </WithSubEnv>
                                </div>
                            </div>
                        </div>
                        <div class="border rounded mx-4 my-3 p-3">
                            <div class="h4 m-0">
                                <span class="pe-1">
                                    <t t-if="slot.record.data.icon" t-out="slot.record.data.icon"/>
                                    <t t-else="">📄</t>
                                </span>
                                <t t-out="slot.record.data.template_name"/>
                            </div>
                            <p t-if="slot.record.data.template_description" t-out="slot.record.data.template_description" class="m-0 mt-2"/>
                        </div>
                    </Record>
                </div>
            </div>
            <div t-else="" class="o_view_nocontent position-static">

                <div class="o_nocontent_help">
                    <p class="o_view_nocontent_smiling_face">
                        No template yet.
                    </p>
                </div>
            </div>
            <t t-set-slot="footer">
                <button t-if="groups.length &gt; 0" t-on-click="onLoadTemplate" class="btn btn-primary" data-hotkey="q">Load Template</button>
                <button t-on-click="() =&gt; this.props.close()" class="btn" data-hotkey="x">Discard</button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("knowledge.KnowledgeBreadcrumbs", `/knowledge/static/src/components/breadcrumbs/breadcrumbs.xml`, `<t t-name="knowledge.KnowledgeBreadcrumbs" xml:space="preserve">
        <button class="btn btn-light" t-att-class="{'disabled': !isGoBackEnabled}" t-on-click="onClickBack">
            <i class="oi oi-chevron-left"/>
        </button>
        <button class="btn btn-light" t-att-class="{'disabled': !isGoNextEnabled}" t-on-click="onClickNext">
            <i class="oi oi-chevron-right"/>
        </button>
    </t>
`);
registerTemplate("knowledge.KnowledgeArticleChatter", `/knowledge/static/src/components/chatter_panel/chatter_panel.xml`, `<div t-name="knowledge.KnowledgeArticleChatter" t-ref="root" xml:space="preserve">
        <chatter t-if="this.state.displayChatter" class="o_FormRenderer_chatterContainer o_scroll_view_lg">
            <Chatter threadModel="'knowledge.article'" threadId="this.props.record.resId" webRecord="this.props.record" hasParentReloadOnAttachmentsChanged="true" hasParentReloadOnFollowersUpdate="true" hasParentReloadOnMessagePosted="true" isChatterAside="isChatterAside" saveRecord="props.record.save.bind(props.record, { reload: false })"/>
        </chatter>
    </div>
`);
registerTemplateExtension("web.CustomFavoriteItem", `/knowledge/static/src/components/custom_favorite_item/custom_favorite_item.xml`, `<t t-inherit="web.CustomFavoriteItem" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//CheckBox[@value='state.isShared']" position="attributes">
            <attribute name="t-if">!this.isKnowledgeEmbeddedView()</attribute>
        </xpath>
    </t>
`);
registerTemplate("knowledge.EmbeddedViewActionsMenu", `/knowledge/static/src/components/embedded_view_actions_menu/embedded_view_actions_menu.xml`, `<t t-name="knowledge.EmbeddedViewActionsMenu" xml:space="preserve">
        <DropdownItem onSelected.bind="_onOpenEmbeddedView">
            <i class="fa fa-fw fa-external-link me-1"/>Open
        </DropdownItem>
        <DropdownItem t-if="!env.isEmbeddedReadonly" onSelected.bind="_onEditEmbeddedView">
            <i class="fa fa-fw fa-pencil me-1"/>Edit
        </DropdownItem>
    </t>
`);
registerTemplate("knowledge.InsertEmbeddedViewMenu", `/knowledge/static/src/components/external_embedded_view_favorite_menu/insert_embedded_view.xml`, `<t t-name="knowledge.InsertEmbeddedViewMenu" xml:space="preserve">
        <Dropdown>
            <button class="o_knowledge_icon_search opacity-trigger-hover">
                <t t-call="Knowledge.KnowledgeIcon"/>
                Knowledge
            </button>
            <t t-set-slot="content">
                <DropdownItem onSelected.bind="onInsertEmbeddedViewInArticle" closingMode="'none'">
                    <i class="oi oi-fw oi-view me-1"/>Insert view in article
                </DropdownItem>
                <DropdownItem onSelected.bind="onInsertViewLinkInArticle" closingMode="'none'">
                    <i class="fa fa-fw fa-link me-1"/>Insert link in article
                </DropdownItem>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("knowledge.FormStatusIndicator", `/knowledge/static/src/components/form_status_indicator/form_status_indicator.xml`, `<t t-name="knowledge.FormStatusIndicator" t-inherit="web.FormStatusIndicator" xml:space="preserve">
        <xpath expr="//div[hasclass('o_form_status_indicator_buttons')]" position="before">
            <img src="/knowledge/static/src/img/form_status_indicator_saved.svg" class="align-items-center d-flex px-1 py-0 border border-transparent user-select-none" t-attf-class="{{ displayButtons ? 'd-none' : ''}}" data-tooltip="All changes saved"/>
        </xpath>
    </t>
`);
registerTemplate("knowledge.KnowledgeHierarchy", `/knowledge/static/src/components/hierarchy/hierarchy.xml`, `<t t-name="knowledge.KnowledgeHierarchy" xml:space="preserve">
        <KnowledgeBreadcrumbs record="props.record"/>

        <div t-if="rootId !== props.record.resId" class="o_hierarchy_item d-flex min-w-0 align-items-center"> 
            <a role="button" class="btn btn-light border-0 px-2 text-truncate me-1" t-on-click="() =&gt; this.env.openArticle(this.rootId)" t-out="rootName" t-att-title="rootName"/>
            <i class="fa fa-caret-right"/>
        </div>

        <div t-if="displayDropdownToggle" class="o_hierarchy_item d-flex w-auto align-items-center">
            <Dropdown beforeOpen.bind="onBeforeOpen">
                <a type="button" class="btn btn-light border-0 px-2 me-1">
                    ...
                </a>
                <t t-set-slot="content">
                    <i t-if="state.isLoadingArticleHierarchy" class="fa fa-spin fa-circle-o-notch mx-auto"/>
                    <t t-else="">
                        <t t-set="notAccessibleTitle">You do not have access to this article</t>
                        <t t-foreach="articleHierarchy" t-as="article" t-key="article.id">
                            <DropdownItem onSelected="() =&gt; this.env.openArticle(article.id)" class="article.user_has_access ? '' : 'disabled pe-auto'">
                                <span t-out="article.display_name" t-att-title="article.user_has_access ? article.display_name : notAccessibleTitle"/>
                            </DropdownItem>
                        </t>
                    </t>
                </t>
            </Dropdown>
            <i class="fa fa-caret-right"/>
        </div>

        <div t-if="parentId and parentId !== rootId" class="o_hierarchy_item d-flex min-w-0 align-items-center">
            <a role="button" class="btn btn-light border-0 px-2 text-truncate me-1" t-on-click="() =&gt; this.env.openArticle(this.parentId)" t-out="parentName" t-att-title="parentName"/>
            <i class="fa fa-caret-right"/>
        </div>

        <div class="o_hierarchy_item d-flex min-w-0 align-items-center ms-2">
            <KnowledgeIcon record="props.record" fallbackDefaultIcon="true" iconClasses="'me-1'" readonly="isReadonly"/>
            <div t-if="isReadonly" class="text-truncate me-1 fw-bold">
                <t t-if="this.props.record.data.name" t-out="this.props.record.data.name"/>
                <t t-else="">Untitled</t>
            </div>
            <div t-else="" class="o_hierarchy_article_name position-relative text-truncate" t-on-click="env.ensureArticleName">
                <input class="o_input position-absolute top-50 start-50 translate-middle fw-bold text-truncate text-700 border-0" t-model="state.articleName" t-on-change="ev =&gt; this.env.renameArticle(ev.target.value)" type="text" autocomplete="off" placeholder="Untitled"/>

                <span class="d-inline-block pe-1 fw-bold text-truncate invisible">
                    <t t-if="state.articleName" t-out="state.articleName"/>
                    <t t-else="">Untitled</t>
                </span>
            </div>
        </div>
    </t>
`);
registerTemplate("knowledge.ItemCalendarPropsDialog", `/knowledge/static/src/components/item_calendar_props_dialog/item_calendar_props_dialog.xml`, `<t t-name="knowledge.ItemCalendarPropsDialog" xml:space="preserve">
        <Dialog title.translate="Insert a Calendar View" size="'md'" bodyClass="'o_knowledge_item_calendar_props_dialog'">
            <div class="mb-3 row o_name">
                <label class="col-sm-4 col-form-label">
                    What do you want to manage?
                </label>
                <div class="col-sm-8 my-auto">
                    <input type="text" class="form-control bg-white" placeholder="e.g. Meetings" t-model="state.name" t-ref="autofocus"/>
                </div>
            </div>
            <t t-if="!autoCreateDateProperties">
                <div class="mb-3 row">
                    <label class="col-sm-4 col-form-label">
                        Date Properties
                    </label>
                    <div class="col-sm-8 d-flex justify-content-center my-auto">
                        <div class="o_knowledge_item_calendar_dialog_date_start w-100">
                            <SelectMenu onSelect.bind="selectDateStart" groups="availableDateStartProperties" value="state.dateStartPropertyId" required="true" searchPlaceholder.translate="Start typing">
                                <t t-set-slot="default">
                                    <t t-if="state.dateStartPropertyId" t-out="dateStartProperty.label"/>
                                    <span t-else="" class="text-muted opacity-25">Start Date</span>
                                </t>
                                <t t-set-slot="bottomArea" t-slot-scope="select">
                                    <DropdownItem t-if="select.data.searchValue.length" onSelected="() =&gt; this.createProperty(select.data.searchValue, 'datetime', 'dateStart')" class="'o_select_menu_item o_create_datetime mb-1 d-flex align-items-center'">
                                        <div class="o_select_menu_item_label text-wrap fst-italic ms-3">
                                            Create "<t t-out="select.data.searchValue"/>" (date and time)
                                        </div>
                                    </DropdownItem>
                                    <DropdownItem t-if="select.data.searchValue.length" onSelected="() =&gt; this.createProperty(select.data.searchValue, 'date', 'dateStart')" class="'o_select_menu_item o_create_date mb-1 d-flex align-items-center'">
                                        <div class="o_select_menu_item_label text-wrap fst-italic ms-3">
                                            Create "<t t-out="select.data.searchValue"/>" (date)
                                        </div>
                                    </DropdownItem>
                                </t>
                            </SelectMenu>
                        </div>
                        <div class="mx-2 my-auto">
                            <i class="fa fa-lg fa-fw fa-arrow-right"/>
                        </div>
                        <div t-attf-class="o_knowledge_item_calendar_dialog_date_stop w-100 #{this.state.dateStartPropertyId ? '' : 'o_disabled'}">
                            <SelectMenu onSelect.bind="selectDateStop" groups="availableDateStopProperties" value="state.dateStopPropertyId" searchPlaceholder.translate="Start typing">
                                <t t-set-slot="default">
                                    <t t-if="state.dateStopPropertyId" t-out="dateStopProperty.label"/>
                                    <span t-else="" class="text-muted opacity-25">Stop Date</span>
                                </t>
                                <t t-set-slot="bottomArea" t-slot-scope="select">
                                    <DropdownItem t-if="select.data.searchValue.length" onSelected="() =&gt; this.createProperty(select.data.searchValue, dateStartProperty.type, 'dateStop')" class="'o_select_menu_item o_create_choice mb-1 d-flex align-items-center'">
                                        <div class="o_select_menu_item_label text-wrap fst-italic ms-3">
                                            Create "<t t-out="select.data.searchValue"/>"
                                        </div>
                                    </DropdownItem>
                                </t>
                            </SelectMenu>
                        </div>
                    </div>
                </div>
                <div class="row mb-3 o_color">
                    <label class="col-sm-4 col-form-label">
                        Base Color On
                    </label>
                    <div class="col-sm-8 my-auto">
                        <SelectMenu onSelect.bind="selectColor" choices="colorChoices" value="state.colorPropertyId" searchPlaceholder="start_typing">
                            <t t-set-slot="default">
                                <t t-if="state.colorPropertyId" t-out="colorProperty.label"/>
                                <span t-else="" class="text-muted opacity-25">Property Field</span>
                            </t>
                            <t t-set-slot="bottomArea" t-slot-scope="select">
                                <DropdownItem t-if="select.data.searchValue.length" onSelected="() =&gt; this.createProperty(select.data.searchValue, 'selection', 'color')" class="'o_select_menu_item o_create_choice mb-1 d-flex align-items-center'">
                                    <div class="o_select_menu_item_label text-wrap fst-italic ms-3">
                                        Create "<t t-out="select.data.searchValue"/>" (Selection)
                                    </div>
                                </DropdownItem>
                            </t>
                        </SelectMenu>
                    </div>
                </div>
                <div class="mb-3 row o_scale">
                    <label class="col-sm-4 col-form-label">
                        Default Scale
                    </label>
                    <div class="col-sm-8 my-auto">
                        <SelectMenu onSelect.bind="selectScale" choices="scalesChoices" value="state.scale" required="true" searchable="false"/>
                    </div>
                </div>
                <div class="mb-3 row">
                    <label class="col-sm-4 col-form-label">
                        Hours Display
                    </label>
                    <div class="col-sm-8 d-flex justify-content-center my-auto">
                        <div class="o_knowledge_item_calendar_dialog_slot_min_time w-100">
                            <input type="time" t-model.lazy="state.slotMinTime"/>
                        </div>
                        <div class="mx-2 my-auto">
                            <i class="fa fa-lg fa-fw fa-arrow-right"/>
                        </div>
                        <div class="o_knowledge_item_calendar_dialog_slot_max_time w-100">
                            <input type="time" t-model.lazy="state.slotMaxTime"/>
                        </div>
                    </div>
                </div>
                <div class="mb-3 row">
                    <label class="col-sm-4 col-form-label">
                        Show Weekends?
                    </label>
                    <div class="col-sm-8 d-flex justify-content-center my-auto">
                        <div class="w-100">
                           <input type="checkbox" t-model="state.showWeekEnds"/>
                        </div>
                    </div>
                </div>
            </t>
            <t t-set-slot="footer">
                <button t-if="this.props.isNew" class="btn btn-primary" t-on-click="save" data-hotkey="I">Insert</button>
                <button t-else="" class="btn btn-primary" t-on-click="save" data-hotkey="R">Save</button>
                <button class="btn btn-secondary" t-on-click="props.close" data-hotkey="D">Discard</button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("knowledge.KnowledgeCover", `/knowledge/static/src/components/knowledge_cover/knowledge_cover.xml`, `<t t-name="knowledge.KnowledgeCover" xml:space="preserve">
        <div t-if="props.record.data.cover_image_url" t-ref="root" t-attf-class="o_knowledge_cover position-relative #{state.repositioning ? 'o_cursor_grab' : ''} #{state.grabbing ? 'o_cursor_grabbing' : ''}">
            <img t-att-src="props.record.data.cover_image_url" alt="cover" t-ref="image" t-att-class="state.repositioning ? '' : 'pe-none'" t-attf-style="object-position: 50% #{state.verticalPosition}%;"/>
            <span t-if="state.repositioning" class="o_reposition_hint position-absolute top-50 start-50 translate-middle pe-none p-1 rounded opacity-75">
                Click and hold to reposition
            </span>
            <span t-if="isEditable" class="o_knowledge_edit_cover_buttons position-absolute bottom-0 end-0 mb-2 me-3 text-muted d-print-none">
                <t t-if="state.repositioning">

                    <a role="button" class="btn btn-light text-capitalize me-3 o_knowledge_save_cover_move">
                        <i class="fa fa-lg fa-floppy-o me-1" title="Save Position"/> Save position
                    </a>
                    <a role="button" class="btn btn-light text-capitalize me-3 o_knowledge_undo_cover_move">
                        <i class="fa fa-lg fa-undo me-1"/> Cancel
                    </a>
                </t>
                <t t-else="">
                    <a role="button" t-on-click="changeCover" class="btn btn-light text-capitalize me-3 o_knowledge_replace_cover o_knowledge_option_button">
                        <i class="fa fa-lg fa-picture-o" title="Change cover"/>
                        <span class="d-none d-sm-inline ms-1">Replace cover</span>
                        <span class="d-sm-none ms-1">Replace</span>
                    </a>
                    <a t-if="!this.env.isSmall" role="button" t-on-click="repositionCover" class="btn btn-light text-capitalize me-3 o_knowledge_reposition_cover o_knowledge_option_button">
                        <i class="oi oi-large oi-arrows-v me-1" title="Reposition cover"/> Reposition
                    </a>
                    <a role="button" t-on-click="removeCover" class="btn btn-light text-capitalize o_knowledge_remove_cover o_knowledge_option_button">
                        <i class="fa fa-lg fa-trash-o" title="Remove cover"/><span class="d-none d-sm-inline ms-1">Remove</span>
                    </a>
                </t>
            </span>
        </div>
    </t>
`);
registerTemplate("knowledge.KnowledgeCoverDialog", `/knowledge/static/src/components/knowledge_cover/knowledge_cover_dialog.xml`, `<t t-name="knowledge.KnowledgeCoverDialog" xml:space="preserve">
    <Dialog contentClass="contentClass" size="size" title.translate="Choose a nice cover" modalRef="modalRef">
        <KnowledgeCoverSelector articleCoverId="props.articleCoverId" save.bind="save" searchTerm="props.articleName" selectMedia="(media)=&gt;this.selectedMedia=media" modalRef="modalRef"/>
        <t t-set-slot="footer">
            <button class="btn btn-secondary" t-on-click="() =&gt; this.props.close()">Discard</button>
        </t>
    </Dialog>
</t>

`);
registerTemplate("knowledge.CoversListTemplate", `/knowledge/static/src/components/knowledge_cover/knowledge_cover_dialog.xml`, `<t t-name="knowledge.CoversListTemplate" t-inherit="web_editor.ImagesListTemplate" t-inherit-mode="primary" xml:space="preserve">
    <xpath expr="//t[@t-foreach='state.attachments']" position="replace">
        <t t-foreach="state.attachments" t-as="attachment" t-key="attachment.id">
            <AutoResizeCover t-if="!attachment.original_id or state.showOptimized" id="attachment.id" isOptimized="!!attachment.original_id" isRemovable="true" onRemoved.bind="onRemoved" src="attachment.thumbnail_src or attachment.image_src" name="attachment.name" title="attachment.name" altDescription="attachment.altDescription" model="attachment.res_model" resId="attachment.res_id" minRowHeight="MIN_ROW_HEIGHT" onImageClick="() =&gt; this.onClickAttachment(attachment)"/>
        </t>
    </xpath>
</t>
`);
registerTemplate("knowledge.KnowledgeHtmlViewer", `/knowledge/static/src/components/knowledge_html_viewer/knowledge_html_viewer.xml`, `<t t-name="knowledge.KnowledgeHtmlViewer" t-inherit="html_editor.HtmlViewer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[@t-ref='readonlyContent']" position="before">
            <LocalOverlayContainer localOverlay="overlayRef" identifier="env.localOverlayContainerKey"/>
        </xpath>
    </t>
`);
registerTemplate("knowledge.KnowledgeIcon", `/knowledge/static/src/components/knowledge_icon/knowledge_icon.xml`, `<t t-name="knowledge.KnowledgeIcon" xml:space="preserve">
        <t t-if="icon">
            <p t-if="props.readonly" t-attf-class="o_article_emoji cursor-default m-0 #{props.iconClasses ? props.iconClasses : ''}" t-out="icon"/>
            <a t-else="" t-ref="icon" role="button" t-out="icon" t-attf-class="o_article_emoji #{props.iconClasses ? props.iconClasses : ''}"/>
        </t>
        <a t-elif="props.allowRandomIconSelection" role="button" t-on-click="selectRandomIcon" title="Add a random icon" class="text-muted opacity-75 opacity-100-hover">
            <i class="fa fa-fw fa-plus-circle"/>
        </a>
    </t>
`);
registerTemplate("knowledge.KnowledgeWysiwyg", `/knowledge/static/src/components/knowledge_wysiwyg/knowledge_wysiwyg.xml`, `<t t-name="knowledge.KnowledgeWysiwyg" t-inherit="html_editor.Wysiwyg" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o-wysiwyg')]" position="inside">
            <WysiwygArticleHelper record="this.env.model.root" editor="editor" isVisible="articleHelperState.isVisible"/>
        </xpath>
    </t>
`);
registerTemplate("knowledge.MoveArticleDialog", `/knowledge/static/src/components/move_article_dialog/move_article_dialog.xml`, `<t t-name="knowledge.MoveArticleDialog" xml:space="preserve">
        <Dialog size="size" title.translate="Move an Article">
            <t t-if="props.knowledgeArticleRecord.data.display_name">
                <t t-out="this.moveArticleLabel"/>
            </t>
            <t t-else="">
                Move the untitled article under:
            </t>
            <SelectMenu togglerClass="'o_knowledge_select_menu'" menuClass="'o_knowledge_select_menu_dropdown'" class="'o_knowledge_select_menu'" onInput.bind="fetchValues" onSelect.bind="selectArticle" groups="state.selectionDisplayGroups">
                <span class="fw-lighter" t-ref="togglerRef">
                    <img t-if="state.selectedParentArticle.value and state.selectedParentArticle.value.parentArticleId === 'private'" class="rounded-circle me-1" t-att-src="this.loggedUserPicture"/>
                    <t t-out="state.selectedParentArticle.label || this.placeholderLabel"/>
                </span>
                <t t-set-slot="choice" t-slot-scope="choice">
                    <span>
                        <img t-if="choice.data.value and choice.data.value.parentArticleId === 'private'" class="rounded me-1" t-att-src="this.loggedUserPicture"/>
                        <t t-out="choice.data.label"/>
                        <span t-if="choice.data.value and choice.data.value.rootArticleName" class="text-muted small">
                            - <t t-out="choice.data.value.rootArticleName"/>
                        </span>
                    </span>
                </t>

            </SelectMenu>
            <t t-set-slot="footer">
                <button t-attf-class="btn btn-primary #{!this.state.selectedParentArticle ? 'disabled' : ''}" t-on-click="confirmArticleMove">
                    Move Article
                </button>
                <button class="btn btn-secondary" t-on-click="props.close">
                    Cancel
                </button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("knowledge.PermissionPanel", `/knowledge/static/src/components/permission_panel/permission_panel.xml`, `<t t-name="knowledge.PermissionPanel" xml:space="preserve">
        <t t-if="state.loading">
            <div class="py-3 text-center">
                <i class="fa fa-circle-o-notch fa-2x fa-spin" title="loader" role="img"/>
            </div>
        </t>
        <div t-else="" class="o_knowledge_permission_panel">
            <div t-if="!state.is_sync and state.parent_name" class="d-flex align-items-center px-3 py-1 my-1">
                <div class="o_knowledge_share_panel_icon d-flex justify-content-center align-items-center flex-shrink-0">
                    <i class="fa fa-shield fa-2x"/>
                </div>
                <div class="px-3">Access Restricted. May not be shared with everyone from
                    <a href="#" t-if="state.parent_id" t-on-click.prevent="() =&gt; env.openArticle(state.parent_id)" t-out="state.parent_name"/>
                    <span t-else="" t-out="state.parent_name"/>
                </div>
                <button t-if="(props.record.data.user_permission === 'write' and isInternalUser) || state.user_is_admin" class="btn btn-link" t-on-click="event =&gt; this._onRestore(event)" type="button">Restore</button>
            </div>
            <div class="d-flex align-items-center px-3 py-1" t-if="isInternalUser">
                <div class="flex-shrink-0">
                    <div class="o_knowledge_share_panel_icon d-flex justify-content-center align-items-center">
                        <i class="fa fa-building fs-3"/>
                    </div>
                </div>
                <div class="flex-grow-1 min-w-0 px-3">
                    <div class="text-truncate">Default Access Rights</div>
                    <div t-if="state.based_on" class="text-truncate text-muted">
                        Based on
                        <a href="#" t-if="state.based_on_id" t-on-click.prevent="() =&gt; env.openArticle(state.based_on_id)" t-out="state.based_on"/>
                        <span t-else="" t-out="state.based_on"/>
                    </div>
                </div>
                <div class="flex-shrink-0">
                    <select class="o_permission form-select rounded" t-att-value="state.internal_permission" t-on-change="_onChangeInternalPermission" t-att-disabled="state.user_is_admin || props.record.data.user_permission === 'write' ? undefined : 'disabled'" aria-label="Internal Permission">
                        <t t-foreach="this.getInternalPermissionOptions()" t-as="option" t-key="option_index">
                            <option t-att-value="option[0]" t-out="option[1]" t-att-selected="option[0] === state.internal_permission ? 'selected' : undefined"/>
                        </t>
                    </select>
                </div>
            </div>

            <div t-if="!state.parent_id and state.internal_permission !== 'none' and isInternalUser" class="d-flex align-items-center px-3 py-1">
                <div class="flex-shrink-0">
                    <div class="o_knowledge_share_panel_icon d-flex justify-content-center align-items-center">
                        <i class="fa fa-eye fs-3"/>
                    </div>
                </div>
                <div class="flex-grow-1 px-3">Visibility</div>
                <div class="flex-shrink-0">
                    <select class="o_permission form-select rounded" t-att-value="props.record.data.is_article_visible_by_everyone ? 'join': 'everyone'" t-on-change="_onChangeVisibility" t-att-disabled="state.user_is_admin || props.record.data.user_permission === 'write' ? undefined : 'disabled'" aria-label="Visibility">
                        <option t-att-value="'join'" t-att-selected="!props.record.data.is_article_visible_by_everyone ? 'selected' : undefined">
                            Members
                        </option>
                        <option t-att-value="'everyone'" t-att-selected="props.record.data.is_article_visible_by_everyone ? 'selected' : undefined">
                            Everyone
                        </option>
                    </select>
                </div>
            </div>
            <div class="dropdown-divider" t-if="isInternalUser"/>
            <div t-if="state.user_is_admin || (props.record.data.user_permission === 'write' and isInternalUser)" class="o_knowledge_share_panel_invite d-flex align-items-center px-3 pt-1 pb-2">
                <div class="o_knowledge_share_panel_icon d-flex flex-shrink-0 justify-content-center align-items-center">
                    <i class="fa fa-user-plus fs-3" title="Invite People"/>
                </div>
                <button t-on-click="_onInviteMembersClick" class="btn input-group o_cursor_pointer d-flex flex-grow-1 min-w-0 p-0 ms-3">
                    <div class="form-control border text-start text-truncate">Add people or email addresses...</div>
                    <button class="btn btn-primary">Invite</button>
                </button>
            </div>
            <t t-foreach="state.members" t-as="member" t-key="member_index">
                <div class="d-flex align-items-center px-3 py-1">
                    <div class="flex-shrink-0">
                        <t t-if="isInternalUser">
                            <img class="o_knowledge_share_panel_image rounded" t-if="member.partner_id" t-attf-src="/web/image?model=res.partner&amp;field=avatar_128&amp;id={{ member.partner_id }}" t-on-click="event =&gt; this._onMemberAvatarClick(event, member)"/>
                        </t>
                        <t t-else="">
                            <i class="ms-2 me-1 fa fa-2x fa-user"/>
                        </t>
                    </div>
                    <div class="flex-grow-1 min-w-0 px-3">
                        <div t-attf-class="text-truncate {{ this.isLoggedUser(member) ? 'd-sm-flex align-items-sm-center fw-bold text-primary' : '' }}">
                            <t t-out="member.partner_name"/>
                            <span t-if="this.isLoggedUser(member)" class="badge d-none d-sm-block ms-1 rounded-pill text-bg-primary">You</span>
                        </div>
                        <div class="text-truncate text-muted">
                            <span t-if="member.partner_share">Guest</span>
                            <span t-if="state.user_is_admin and this.isLoggedUser(member)"><i class="fa fa-cog pe-1" title="Administrator"/>Admin</span>
                            <span t-if="(member.partner_share || (state.user_is_admin and this.isLoggedUser(member))) and member.partner_email" class="px-1">•</span>
                            <span class="o_member_email" t-if="member.partner_email" t-out="member.partner_email"/>
                        </div>
                        <div t-if="member.based_on" class="text-truncate text-muted">
                            Based on
                            <a href="#" t-if="member.based_on_id" t-on-click.prevent="() =&gt; env.openArticle(member.based_on_id)" t-out="member.based_on"/>
                            <span t-else="" t-out="member.based_on"/>
                        </div>
                    </div>
                    <div class="flex-shrink-0">
                        <div class="input-group">
                            <div t-if="!(member.based_on and member.permission === 'none')                                         and (state.user_is_admin || props.record.data.user_permission === 'write' || this.isLoggedUser(member))" class="d-flex align-items-center me-2 fs-4">

                                <button t-if="isInternalUser and this.isLoggedUser(member) and ((state.category === 'shared' and !member.is_unique_writer) || state.category !== 'shared')" class="o_delete btn btn-danger" t-on-click="event =&gt; this._onRemoveMember(event, member)" title="Leave Article">
                                    <i class="fa fa-fw fa-sign-out"/>
                                </button>
                                <button t-elif="this.isLoggedUser(member) and props.record.data.user_permission === 'read' and state.category === 'workspace' and !state.user_is_admin" class="o_delete btn btn-danger" title="As a reader, you can't leave a Workspace article" disabled="True">
                                    <i class="fa fa-fw fa-sign-out"/>
                                </button>
                                <button t-elif="this.isLoggedUser(member) and member.is_unique_writer" class="o_delete btn btn-danger" title="You can't leave an article for which you are the last writer" disabled="True">
                                    <i class="fa fa-fw fa-sign-out"/>
                                </button>

                                <button t-elif="member.is_unique_writer and isInternalUser" class="o_delete o_remove btn btn-danger" title="You can't remove the last writer of the article" disabled="True">
                                    <i class="fa fa-fw fa-times"/>
                                </button>
                                <button t-elif="isInternalUser" class="o_delete o_remove btn btn-danger" title="Remove Member" t-on-click="event =&gt; this._onRemoveMember(event, member)">
                                    <i class="fa fa-fw fa-times"/>
                                </button>

                            </div>
                            <select t-attf-class="o_permission form-select rounded {{ member.partner_share || !isInternalUser ? 'o_knowledge_share_partner' : '' }}" t-att-value="member.permission" t-on-change="event =&gt; this._onChangeMemberPermission(event, member)" t-att-disabled="member.is_unique_writer                                     || (props.record.data.user_permission !== 'write' and !state.user_is_admin) || !isInternalUser ? 'disabled' : undefined" aria-label="User Permission">
                                <t t-foreach="this.state.members_options" t-as="option" t-key="option_index">
                                    <option t-att-value="option[0]" t-out="option[1]" t-att-selected="option[0] === member.permission ? 'selected' : undefined"/>
                                </t>
                            </select>
                        </div>
                    </div>
                </div>
            </t>
            <div t-if="state.show_admin_tip" class="d-flex align-items-center px-3 py-1 my-1 text-muted">
                <i><i class="fa fa-cog me-2"/>As an administrator, you can always modify this article and its members.</i>
            </div>
        </div>
    </t>
`);
registerTemplate("knowledge.PromptEmbeddedViewNameDialog", `/knowledge/static/src/components/prompt_embedded_view_name_dialog/prompt_embedded_view_name_dialog.xml`, `<t t-name="knowledge.PromptEmbeddedViewNameDialog" xml:space="preserve">
        <Dialog title="title" size="'md'">
            <div class="mb-3 row">
                <label for="label" class="col-sm-5 col-form-label p-0 ps-3">
                    What items do you want to manage?
                </label>
                <div class="col-sm-7 ps-0">
                    <input id="label" type="text" class="form-control" t-att-placeholder="placeholder" t-att-value="this.props.defaultName or ''" t-on-keydown="onInputKeydown" t-ref="input"/>
                </div>
            </div>
            <t t-set-slot="footer">
                <button t-if="this.props.isNew" class="btn btn-primary" t-on-click="() =&gt; this.save()" data-hotkey="q">Insert</button>
                <button t-else="" class="btn btn-primary" t-on-click="() =&gt; this.save()" data-hotkey="r">Rename</button>
                <button class="btn btn-secondary" t-on-click="() =&gt; this.props.close()" data-hotkey="x">Discard</button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("knowledge.KnowledgeArticleProperties", `/knowledge/static/src/components/properties_panel/properties_panel.xml`, `<div t-name="knowledge.KnowledgeArticleProperties" t-ref="root" xml:space="preserve">
        <div class="o_knowledge_properties_field" t-if="this.state.displayPropertyPanel and this.props.record.data.parent_id">
            <div class="pt-5 o_scroll_view_lg">
                <div t-if="this.showNoContentHelper" class="o_properties_helper text-center p-4 d-flex flex-column align-items-center justify-content-end">
                    <p class="o_view_nocontent_smiling_face"/>
                    <h3>Add Property Fields</h3>
                    <p class="mt-3 mb-0">
                        Organize your database with custom fields
                        (Text, Selection, ...). <br/>
                        Those fields will be available on all articles that share the same parent.
                    </p>
                </div>
                <div class="o_field_widget o_field_properties">
                    <PropertiesField columns="1" showAddButton="true" name="'article_properties'" record="this.props.record" readonly="this.props.record.data.is_locked || !this.props.record.data.user_can_write" context="this.props.record.context"/>
                </div>
            </div>
        </div>
    </div>
`);
registerTemplate("knowledge.Sidebar", `/knowledge/static/src/components/sidebar/sidebar.xml`, `<t t-name="knowledge.Sidebar" xml:space="preserve">
        <aside class="o_knowledge_sidebar d-flex flex-shrink-0 d-print-none bg-view" t-attf-style="--knowledge-article-sidebar-size: #{state.sidebarSize}px">
            <div class="d-flex flex-column flex-grow-1 min-w-0">

                <div class="d-flex align-items-center gap-2 px-md-3 px-3 ps-2 py-3">
                    <a role="button" t-on-click="() =&gt; env.toggleAsideMobile()" class="o_knowledge_burger_icon d-md-none btn btn-light px-2 py-1">
                        <i class="fa fa-lg fa-bars" title="Toggle aside menu"/>
                    </a>
                    <a t-if="!isInternalUser" class="fa fs-3 fa-home d-inline-block me-2" href="/my" title="Home"/>
                    <div id="knowledge_search_bar" data-hotkey="f" class="d-flex align-items-center border bg-light rounded cursor-pointer flex-grow-1" t-on-click="onSearchBarClick">
                        <div class="flex-grow-1 px-2 py-1">Search an article...</div>
                        <i class="oi oi-search pe-2" title="search"/>
                    </div>
                </div>

                <div t-if="state.loading" class="p-5 text-center">
                    <i class="fa fa-circle-o-notch fa-2x fa-spin" title="loader" role="img"/>
                </div>
                <t t-else="" t-call="knowledge.ArticlesTree"/>
            </div>
            <span class="o_knowledge_article_form_resizer d-none d-md-flex opacity-75 opacity-100-hover" t-on-pointerdown="resize">
                  <span class="bg-300 pe-1 ms-1"/>
            </span>
        </aside>
    </t>

    `);
registerTemplate("knowledge.ArticlesTree", `/knowledge/static/src/components/sidebar/sidebar.xml`, `<t t-name="knowledge.ArticlesTree" xml:space="preserve">
        <div t-attf-class="o_knowledge_tree flex-fill position-relative o_scroll_view d-flex flex-column px-3 #{state.dragging ? 'o_dragging' : ''}">
            <div t-ref="favoriteTree" t-if="state.favoriteIds.length" class="o_favorite_container">
                <KnowledgeSidebarFavoriteSection rootIds="state.favoriteIds" unfoldedIds="unfoldedFavoritesIds" record="props.record"/>
            </div>
            <div t-ref="mainTree" class="d-flex flex-column flex-fill">
                <KnowledgeSidebarWorkspaceSection rootIds="state.workspaceIds" unfoldedIds="unfoldedArticlesIds" record="props.record"/>
                <KnowledgeSidebarSharedSection rootIds="state.sharedIds" unfoldedIds="unfoldedArticlesIds" record="props.record"/>
                <KnowledgeSidebarPrivateSection rootIds="state.privateIds" unfoldedIds="unfoldedArticlesIds" record="props.record"/>

                <div t-if="isInternalUser" class="o_section o_knowledge_sidebar_trash w-100 py-2 position-sticky bg-view mt-auto">
                    <a t-if="!state.dragging" href="#" role="button" t-on-click="browseTemplates" class="o_knowledge_load_template_btn btn btn-light d-block fw-normal text-black text-start text-truncate">
                        <i class="fa fa-fw fs-6 fa-paint-brush me-1"/>
                        <span>Browse Templates</span>
                    </a>
                    <div role="button" class="btn btn-light d-block fw-normal text-black text-start text-truncate" t-on-click="() =&gt; actionService.doAction('knowledge.knowledge_article_action_trashed')">
                        <i class="fa fa-fw fa-trash me-1"/>
                        <span class="flex-grow-1">
                            <t t-if="state.dragging">Drop here to delete this article</t>
                            <t t-else="">Open the Trash</t>
                        </span>
                    </div>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("knowledge.SidebarRow", `/knowledge/static/src/components/sidebar/sidebar_row.xml`, `<t t-name="knowledge.SidebarRow" xml:space="preserve">
        <li t-attf-class="o_article position-relative #{hasChildren ? 'o_article_has_children' : ''} #{isReadonly ? 'readonly' : ''}" t-att-data-article-id="props.article.id">
            <div t-attf-class="o_article_handle d-flex align-items-center #{isActive ? 'o_article_active' : ''}">
                <a class="o_article_caret btn btn-link text-muted p-0" role="button" t-on-click="onCaretClick">
                    <i t-attf-class="align-self-center fa fa-fw #{props.unfolded || !hasChildren ? 'fa-caret-down' : 'fa-caret-right'}"/>
                </a>
                <div class="w-100 d-flex min-w-0 align-items-center">
                    <KnowledgeSidebarIcon article="props.article" record="props.record" readonly="isLocked || isReadonly" iconClasses="'p-1'"/>
                    <a t-attf-class="o_article_name p-1 flex-grow-1 text-truncate #{isActive ? 'fw-bold text-900' : 'text-muted'}" role="button" t-on-click="onNameClick">
                        <t t-if="props.article.name" t-out="props.article.name"/>
                        <t t-else="">Untitled</t>
                    </a>
                    <a t-if="props.article.user_can_write" role="button" class="o_article_create p-1 opacity-75 opacity-100-hover" t-on-click="createChild">
                        <i class="fa fa-fw fa-plus" title="Create a nested article"/>
                    </a>
                </div>
            </div>
            <ul t-if="props.unfolded">
                <t t-foreach="props.article.child_ids" t-as="childId" t-key="childId">
                    <KnowledgeSidebarRow article="env.getArticle(childId)" unfolded="props.unfoldedIds.has(childId)" unfoldedIds="props.unfoldedIds" record="props.record"/>
                </t>
            </ul>
            <div t-elif="state.loading" class="p-1 text-center">
                <i class="fa fa-circle-o-notch fa-spin" title="loader" role="img"/>
            </div>
        </li>
    </t>
`);
registerTemplate("knowledge.SidebarSection", `/knowledge/static/src/components/sidebar/sidebar_section.xml`, `<t t-name="knowledge.SidebarSection" xml:space="preserve">
        <section t-attf-class="o_section #{sectionClass || ''}" t-att-data-section="dataSection">
            <div class="o_section_header d-flex h4 mb-0">
                <div class="flex-grow-1 text-truncate" t-out="sectionName"/>
                <t t-out="headerButtons"/>
            </div>
            <ul t-if="props.rootIds.length" class="o_tree">
                <t t-foreach="props.rootIds" t-as="rootId" t-key="rootId">
                    <KnowledgeSidebarRow article="env.getArticle(rootId)" unfolded="props.unfoldedIds.has(rootId)" unfoldedIds="props.unfoldedIds" record="props.record"/>
                </t>
            </ul>
            <span t-elif="noContentHelper" class="o_knowledge_empty_info text-muted">
                <i t-out="noContentHelper"/>
            </span>
        </section>
    </t>

    `);
registerTemplate("knowledge.SidebarFavoriteSection", `/knowledge/static/src/components/sidebar/sidebar_section.xml`, `<t t-name="knowledge.SidebarFavoriteSection" xml:space="preserve">
        <t t-call="knowledge.SidebarSection">
            <t t-set="sectionName">Favorites</t>
            <t t-set="dataSection" t-value="'favorites'"/>
        </t>
    </t>

    `);
registerTemplate("knowledge.SidebarWorkspaceSection", `/knowledge/static/src/components/sidebar/sidebar_section.xml`, `<t t-name="knowledge.SidebarWorkspaceSection" xml:space="preserve">
        <t t-call="knowledge.SidebarSection">
            <t t-set="sectionName">Workspace</t>
            <t t-set="sectionClass" t-value="props.rootIds.length === 0 ? 'pb-3' : ''"/>
            <t t-set="dataSection" t-value="'workspace'"/>
            <t t-if="isInternalUser" t-set="headerButtons">
                <button class="o_knowledge_join_article_members btn btn-link text-secondary rounded p-0" t-on-click="searchHiddenArticle">
                    <i class="fa fa-fw fa-eye" title="Join a hidden article"/>
                </button>
                <button class="o_section_create btn rounded p-0 ms-1" t-on-click="createRoot">
                    <i class="fa fa-fw fa-plus" title="Create a new article in workspace"/>
                </button>
            </t>
            <t t-set="noContentHelper">
                There are no Articles in your Workspace.
            </t>
        </t>
    </t>

    `);
registerTemplate("knowledge.SidebarSharedSection", `/knowledge/static/src/components/sidebar/sidebar_section.xml`, `<t t-name="knowledge.SidebarSharedSection" xml:space="preserve">
        <t t-call="knowledge.SidebarSection" t-if="props.rootIds.length">
            <t t-set="sectionName">Shared</t>
            <t t-set="dataSection" t-value="'shared'"/>
        </t>
    </t>

    `);
registerTemplate("knowledge.SidebarPrivateSection", `/knowledge/static/src/components/sidebar/sidebar_section.xml`, `<t t-name="knowledge.SidebarPrivateSection" xml:space="preserve">
        <t t-call="knowledge.SidebarSection">
            <t t-set="sectionName">Private</t>
            <t t-set="sectionClass" t-value="'flex-fill'"/>
            <t t-set="dataSection" t-value="'private'"/>
            <t t-set="headerButtons">
                <button t-attf-class="o_section_create btn rounded p-0 #{ !(isInternalUser || props.rootIds) ? 'border-0' : '' }" role="button" t-on-click="createRoot">
                    <i class="fa fa-fw fa-plus" t-attf-title="Create a new private article"/>
                </button>
            </t>
            <t t-set="noContentHelper">
                You do not have any private Article.
            </t>
        </t>
    </t>
`);
registerTemplate("knowledge.KnowledgeTopbar", `/knowledge/static/src/components/topbar/topbar.xml`, `<t t-name="knowledge.KnowledgeTopbar" xml:space="preserve">
        <div class="o_knowledge_header d-flex flex-wrap flex-md-nowrap border-bottom d-print-none bg-view px-0 py-2 px-sm-2">
            <div class="d-flex flex-wrap flex-md-nowrap flex-grow-1 gap-1 px-2 px-sm-0 pt-2 pt-sm-0 align-items-center min-w-0">
                <a role="button" class="d-md-none btn btn-light align-self-start px-2 py-1" t-on-click="() =&gt; this.env.toggleAsideMobile()">
                    <i class="fa fa-lg fa-bars" title="Toggle aside menu"/>
                </a>
                <t t-if="props.record.resId">
                    <KnowledgeHierarchy record="props.record"/>
                    <i t-if="this.props.record.data.is_locked" class="fa fa-fw fa-lock me-2" title="This article is locked"/>
                    <t t-if="props.record.data.active and !props.record.data.is_locked and props.record.data.user_can_write">
                        <KnowledgeFormStatusIndicator model="props.record.model" save="env.save" discard="env.discard"/>
                    </t>
                </t>
            </div>

            <div class="d-flex gap-1 flex-md-nowrap mx-auto justify-content-end">
                <a role="button" t-on-click="() =&gt; this.env.createArticle('private')" class="btn btn-primary btn-create text-nowrap" data-hotkey="n">New</a>
                <div class="o-dropdown dropdown" t-if="props.record.resId and props.record.data.active">
                    <a t-ref="sharePanel_button" role="button" class="btn btn-light btn-share dropdown-toggle o-no-caret" id="dropdown_share_panel" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false" data-hotkey="shift+s">
                        <i class="fa fa-fw fs-6 fa-share-alt me-1 o_knowledge_share_panel_icon"/>
                        <t t-if="isInternalUser">Share</t>
                        <t t-else="">Members</t>
                    </a>
                    <div role="menu" t-on-click.stop="" aria-labelledby="dropdown_share_panel" t-attf-class="o_knowledge_share_panel dropdown-menu user-select-none">
                        <PermissionPanel t-if="state.displaySharePanel and props.record.resId and props.record.data.active" record="props.record"/>
                    </div>
                </div>
                <a role="button" class="btn btn-light o_knowledge_toggle_favorite" t-on-click="env.toggleFavorite" t-if="props.record.resId" data-hotkey="t" t-att-title="props.record.data.is_user_favorite ? removeFavoriteLabel : addFavoriteLabel">
                    <i class="fa fa-fw fs-6 fa-star" t-if="props.record.data.is_user_favorite"/>
                    <i class="fa fa-fw fs-6 fa-star-o" t-if="!props.record.data.is_user_favorite"/>
                </a>
                <a t-ref="btn_chatter" t-if="props.record.resId and isInternalUser" role="button" t-attf-class="btn btn-light btn-chatter #{state.displayChatter ? 'active' : ''}" data-hotkey="d" t-on-click="toggleChatter" title="Toggle chatter">
                    <i class="fa fa-fw fs-6 fa-comments"/>
                </a>
                <a t-ref="btn_history" t-if="props.record.resId and isInternalUser and props.record.data.user_can_write and props.record.data['html_field_history_metadata']?.['body']" role="button" t-attf-class="btn btn-light btn-history #{state.displayHistory ? 'active' : ''}" data-hotkey="y" t-on-click="openHistory" title="Open history">
                    <i class="fa fa-fw fs-6 fa-history"/>
                </a>
                <a t-ref="btn_properties" t-if="state.addingProperty or props.record.resId and props.record.data.article_properties.length and isInternalUser" role="button" t-attf-class="btn btn-light btn-properties #{state.displayPropertyPanel ? 'active' : ''}" data-hotkey="o" title="Show Properties" t-on-click="toggleProperties">
                    <i class="fa fa-fw fs-6 fa-cogs"/>
                </a>
                <a t-ref="btn_comments" t-if="props.record.resId and displayCommentsPanelButton" role="button" t-attf-class="btn btn-light btn-comments #{commentsState.displayMode === 'panel' ? 'active' : ''}" t-on-click="toggleComments">
                    <i class="fa fa-fw fs-6 fa-commenting" title="Open comments panel"/>
                </a>
                <div class="o-dropdown dropdown" t-if="props.record.resId">
                    <a role="button" class="btn btn-light dropdown-toggle o-no-caret" data-bs-toggle="dropdown" id="dropdown_tools_panel" aria-haspopup="true" aria-expanded="false" data-hotkey="p" title="More actions" t-ref="optionsBtn">
                        <i class="fa fa-fw fs-6 fa-ellipsis-v"/>
                    </a>
                    <div class="o_knowledge_more_options_panel dropdown-menu" role="menu" aria-labelledby="dropdown_tools_panel">
                        <div>
                            <t t-if="props.record.resId and props.record.data.active and props.record.data.user_can_write">
                                <t t-if="!props.record.data.is_locked">
                                    <button class="dropdown-item o_knowledge_add_icon" t-if="!props.record.data.icon" t-on-mousedown.prevent="addIcon">
                                        <i class="me-2 fa fa-fw fa-lg fa-smile-o"/> Add Icon
                                    </button>
                                    <button class="dropdown-item" t-else="" t-on-mousedown.prevent="() =&gt; this.props.record.update({icon: false})">
                                        <i class="me-2 fa fa-fw fa-lg fa-times"/> Remove Icon
                                    </button>
                                    <t t-if="isInternalUser">
                                        <button class="dropdown-item o_knowledge_add_cover" t-if="!props.record.data.cover_image_id and isInternalUser" t-on-mousedown.prevent="addCover">
                                            <i class="me-2 fa fa-fw fa-lg fa-picture-o"/> Add Cover
                                        </button>
                                        <button class="dropdown-item" t-else="" t-on-mousedown.prevent="() =&gt; this.props.record.update({cover_image_id: false})">
                                            <i class="me-2 fa fa-fw fa-lg fa-eraser"/> Remove Cover
                                        </button>
                                    </t>
                                    <span t-if="!props.record.data.parent_id and isInternalUser" class="dropdown-item text-muted o_knowledge_add_properties" title="Properties are fields that can only be added on articles that have a parent.">
                                        <i class="me-2 fa fa-fw fa-lg fa-cogs"/> Add Properties
                                    </span>
                                    <button t-elif="!state.addingProperty and !props.record.data.article_properties.length and isInternalUser" t-on-click="addProperties" class="dropdown-item o_knowledge_add_properties">
                                        <i class="me-2 fa fa-fw fa-lg fa-cogs"/> Add Properties
                                    </button>
                                </t>
                                <div class="dropdown-item user-select-none d-inline-flex align-items-start" t-if="props.record.data.user_can_write and props.record.data.active" t-on-click.stop="() =&gt; this.toggleFullWidth()">
                                    <div class="pe-3">
                                        <i class="me-2 oi oi-fw oi-large oi-arrows-h"/> Full Width
                                    </div>
                                    <div class="form-check form-switch">
                                        <input class="form-check-input" id="full_width_input" type="checkbox" role="switch" t-att-checked="props.record.data.full_width"/>
                                    </div>
                                </div>
                            </t>
                            <div class="dropdown-divider" t-if="props.record.data.last_edition_uid or props.record.data.last_edition_date"/>
                            <button t-if="props.record.data.user_can_write and props.record.data.active and !props.record.data.is_article_item and isInternalUser" class="dropdown-item btn-move" t-on-click="onMoveArticleClick">
                                <i class="me-2 fa fa-fw fa-lg fa-angle-double-right"/> Move To
                            </button>
                            <button class="dropdown-item btn-lock" t-on-click="() =&gt; this.setLockStatus(true)" t-if="props.record.data.user_can_write and !props.record.data.is_locked and props.record.data.active">
                                <i class="me-2 fa fa-fw fa-lg fa-lock"/> Lock Content
                            </button>
                            <button class="dropdown-item btn-lock" t-on-click="() =&gt; this.setLockStatus(false)" t-if="props.record.data.user_can_write and props.record.data.is_locked and props.record.data.active">
                                <i class="me-2 fa fa-fw fa-lg fa-unlock"/> Unlock
                            </button>
                            <button class="dropdown-item" t-on-click="unarchiveArticle" t-if="props.record.data.to_delete and props.record.data.user_can_write                                       and (isInternalUser or props.record.data.category == 'private')">
                                <i class="me-2 fa fa-fw fa-lg fa-trash-o"/> Restore from Trash
                            </button>
                            <button class="dropdown-item" t-on-click="unarchiveArticle" t-if="!props.record.data.to_delete and !props.record.data.active">
                                <i class="me-2 fa fa-fw fa-lg fa-archive"/> Unarchive
                            </button>
                            <button class="dropdown-item" t-on-click="this.cloneArticle">
                                <i class="me-2 fa fa-fw fa-lg fa-copy"/> Create a Copy
                            </button>
                            <button class="dropdown-item" title="Article items are not showed in the left-side menu&#10;but are shown in inserted kanban/list views" t-if="props.record.data.user_can_write and !props.record.data.is_article_item and props.record.data.parent_id and props.record.data.active" t-on-click="() =&gt; this.setIsArticleItem(true)">
                                <i class="me-2 fa fa-fw fa-lg fa-tasks"/> Convert into Article Item
                            </button>
                            <button class="dropdown-item" t-if="props.record.data.user_can_write and props.record.data.is_article_item and !props.record.data.has_item_parent" t-on-click="() =&gt; this.setIsArticleItem(false)">
                                <i class="me-2 fa fa-fw fa-lg fa-sitemap"/> Convert into Article
                            </button>
                            <button class="dropdown-item" t-on-click="this.exportToPdf">
                                <i class="me-2 fa fa-fw fa-lg fa-download"/> Export
                            </button>
                            <button class="dropdown-item" t-on-click="sendToTrash" t-if="props.record.data.user_can_write and props.record.data.active                                       and (isInternalUser or props.record.data.category == 'private')">
                                <i class="me-2 fa fa-fw fa-lg fa-trash"/> Send to Trash
                            </button>
                            <div class="dropdown-divider" t-if="props.record.data.user_can_write and props.record.data.active"/>
                        </div>
                        <div class="dropdown-item-text ps-2" t-if="props.record.data.last_edition_uid">
                            <div class="d-flex align-items-center py-1">
                                <span class="o_m2o_avatar" t-if="isInternalUser">
                                    <img class="o_knowledge_more_options_panel_image rounded" t-if="props.record.data.last_edition_uid" t-attf-src="/web/image?model=res.users&amp;field=avatar_128&amp;id={{ props.record.data.last_edition_uid[0] }}" t-on-click="event =&gt; this._onMemberAvatarClick(event, props.record.data.last_edition_uid[0])" t-att-title="this.props.record.data.last_edition_uid[1]"/>
                                </span>
                                <i t-else="" class="ms-3 me-1 fa fa-2x fa-user"/>
                                <div class="d-flex flex-column ps-1">
                                    <div class="d-inline-flex lh-sm">
                                        <span class="ps-1 pe-1 text-nowrap">
                                            Last Edited
                                        </span>
                                        <span class="text-muted opacity-75 pe-1">·</span>
                                        <span class="text-muted text-nowrap opacity-75" t-out="this.state.editionDate" t-att-title="this.formatDateTime(this.props.record.data.last_edition_date)"/>
                                    </div>
                                    <span class="ps-1 pe-1">
                                        <t t-out="this.props.record.data.last_edition_uid[1]"/>
                                    </span>
                                </div>
                            </div>
                            <div class="d-flex align-items-center py-1">
                                <span class="o_m2o_avatar" t-if="isInternalUser">
                                    <img class="o_knowledge_more_options_panel_image rounded" t-if="props.record.data.create_uid" t-attf-src="/web/image?model=res.users&amp;field=avatar_128&amp;id={{ props.record.data.create_uid[0] }}" t-on-click="event =&gt; this._onMemberAvatarClick(event, props.record.data.create_uid[0])" t-att-title="this.props.record.data.create_uid[1]"/>
                                </span>
                                <i t-else="" class="ms-3 me-1 fa fa-2x fa-user"/>
                                <div class="d-flex flex-column ps-1">
                                    <div class="d-inline-flex lh-sm">
                                        <span class="ps-1 pe-1 text-nowrap">
                                            Created
                                        </span>
                                        <span class="text-muted opacity-75 pe-1">·</span>
                                        <span class="text-muted text-nowrap opacity-75" t-out="this.state.createDate" t-att-title="this.formatDateTime(this.props.record.data.create_date)"/>

                                    </div>
                                    <span class="ps-1 pe-1">
                                        <t t-out="this.props.record.data.create_uid[1]"/>
                                    </span>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("knowledge.WithLazyLoading", `/knowledge/static/src/components/with_lazy_loading/with_lazy_loading.xml`, `<t t-name="knowledge.WithLazyLoading" xml:space="preserve">
        <t t-if="state.isLoaded">
            <t t-slot="default"/>
        </t>
        <t t-else="">
            <div t-ref="loader" class="p-3 text-center">
                <i class="fa fa-circle-o-notch fa-2x fa-spin" title="loader" role="img"/>
            </div>
        </t>
    </t>
`);
registerTemplate("knowledge.WysiwygArticleHelper", `/knowledge/static/src/components/wysiwyg_article_helper/wysiwyg_article_helper.xml`, `<t t-name="knowledge.WysiwygArticleHelper" xml:space="preserve">
        <div t-if="props.isVisible" class="o_knowledge_helper pb-3">
            <p class="text-muted">Start typing to continue with an empty page or pick an option below to get started.</p>
            <div class="d-flex flex-column">
                <a href="#" class="o_knowledge_load_template p-2" data-hotkey="A" t-on-click="onLoadTemplateBtnClick" t-if="!isPortalUser">
                    <i class="fa fa-lg fa-paint-brush me-1"/> Load a Template
                </a>
                <a href="#" class="o_knowledge_add_item_kanban p-2" data-hotkey="K" t-on-click="onBuildItemKanbanBtnClick">
                    <i class="fa fa-lg fa-th-large me-1"/> Build an Item Kanban
                </a>
                <a href="#" class="o_knowledge_add_item_list p-2" data-hotkey="L" t-on-click="onBuildItemListBtnClick">
                    <i class="fa fa-lg fa-th-list me-1"/> Build an Item List
                </a>
                <a href="#" class="o_knowledge_add_item_calendar p-2" data-hotkey="C" t-on-click="onBuildItemCalendarBtnClick">
                    <i class="fa fa-lg fa-calendar me-1"/> Build an Item Calendar
                </a>
                <a href="#" class="o_knowledge_generate_article p-2" data-hotkey="G" t-on-click="onGenerateArticleClick">
                    <i class="fa fa-lg fa-magic me-1"/> Generate an Article with AI
                </a>
            </div>
        </div>
    </t>
`);
registerTemplate("knowledge.EmbeddedArticleIndex", `/knowledge/static/src/editor/embedded_components/backend/article_index/article_index.xml`, `<t t-name="knowledge.EmbeddedArticleIndex" t-inherit="knowledge.ReadonlyEmbeddedArticleIndex" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[contains(@class, 'o_embedded_articles_index_content')]" position="before">
            <t t-set="show_less">Show Less</t>
            <t t-set="show_all">Show All</t>
            <EmbeddedComponentToolbar>
                <t t-set-slot="buttons">
                    <EmbeddedComponentToolbarButton hidden="props.readonly" icon="embeddedState.showAllChildren ? 'fa-eye-slash' : 'fa-eye'" label="embeddedState.showAllChildren ? show_less : show_all" onClick.bind="onSwitchModeBtnClick" title.translate="Switch Mode"/>
                    <EmbeddedComponentToolbarButton hidden="props.readonly" icon="['fa-refresh', state.loading ? 'fa-spin' : ''].join(' ')" label.translate="Refresh" onClick.bind="onRefreshBtnClick" title.translate="Update"/>
                </t>
            </EmbeddedComponentToolbar>
        </xpath>
        <xpath expr="//p[contains(@t-if, 'props.articles')]" position="attributes">
            <attribute name="t-if">(embeddedState.articles || []).length === 0</attribute>
        </xpath>
        <xpath expr="//ArticleIndexList[contains(@articles, 'props.articles')]" position="attributes">
            <attribute name="articles">embeddedState.articles</attribute>
        </xpath>
    </t>
`);
registerTemplate("knowledge.MacrosEmbeddedClipboard", `/knowledge/static/src/editor/embedded_components/backend/clipboard/macros_embedded_clipboard.xml`, `<t t-name="knowledge.MacrosEmbeddedClipboard" t-inherit="knowledge.EmbeddedClipboard" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//EmbeddedComponentToolbarButton[@name=&quot;'copyToClipboard'&quot;]" position="before">
            <EmbeddedComponentToolbarButton hidden="!targetRecordInfo?.canPostMessages" icon="'fa-envelope'" label.translate="Send as Message" onClick.bind="onClickSendAsMessage"/>
            <EmbeddedComponentToolbarButton hidden="!targetRecordInfo?.withHtmlField" icon="'fa-pencil-square'" label="htmlFieldTargetMessage" onClick.bind="onClickUseAsDescription"/>
        </xpath>
    </t>
`);
registerTemplate("knowledge.EmbeddedViewLink", `/knowledge/static/src/editor/embedded_components/backend/embedded_view_link/embedded_view_link.xml`, `<t t-name="knowledge.EmbeddedViewLink" t-inherit="knowledge.ReadonlyEmbeddedViewLink" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//a" position="attributes">
            <attribute name="t-on-click">openEmbeddedViewLinkPopover</attribute>
        </xpath>
    </t>
`);
registerTemplate("knowledge.EmbeddedViewLinkEditDialog", `/knowledge/static/src/editor/embedded_components/backend/embedded_view_link/embedded_view_link_edit_dialog.xml`, `<t t-name="knowledge.EmbeddedViewLinkEditDialog" xml:space="preserve">
        <Dialog size="'lg'" title.translate="Edit Link">
            <div class="row">
                <form role="form" class="col-lg-8">
                    <div class="d-flex">
                        <label for="inputName" class="col-form-label col-md-2">Name</label>
                        <input class="form-control" id="inputName" type="text" t-model="state.name" t-att-class="{ 'is-invalid': name === '' }" t-ref="input"/>
                    </div>
                    <div class="my-3 row">
                        <label class="col-md-2">Type</label>
                        <div class="col-md-9 d-flex gap-2 ps-1">
                            <t t-foreach="Object.entries(styles)" t-as="style" t-key="style[0]">
                                <label role="button">
                                    <span class="btn btn-sm" t-att-class="style[1].class" t-on-click="updateStyle.bind(this, style[0])">
                                        <t t-out="style[1].display"/>
                                        <i class="fa fa-check ms-1" t-if="state.style === style[0]"/>
                                    </span>
                                </label>
                            </t>
                        </div>
                    </div>
                </form>
                <div class="col-lg-4 border-start">
                    <div class="mb-3 text-center overflow-auto">
                        <label>Preview</label>
                        <div class="pt-2">
                            <a href="#" t-att-class="styles[state.style].class" t-out="state.name"/>
                        </div>
                    </div>
                </div>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="onConfirm">
                    Save
                </button>
                <button class="btn btn-secondary" t-on-click="props.close">
                    Discard
                </button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("knowledge.EmbeddedViewLinkPopover", `/knowledge/static/src/editor/embedded_components/backend/embedded_view_link/embedded_view_link_popover.xml`, `<t t-name="knowledge.EmbeddedViewLinkPopover" xml:space="preserve">
        <div class="shadow p-3 d-flex">
            <div class="cursor-pointer flex-grow-1 text-primary fw-bold text-truncate pe-2" t-on-click="props.openViewLink" t-out="props.name"/>
            <div class="cursor-pointer mx-1" t-on-click="props.onCopyViewLinkClick" title="Copy Link">
                <i class="fa fa-clone"/>
            </div>
            <div class="cursor-pointer mx-1" t-on-click="props.onEditViewLinkClick" title="Edit Link">
                <i class="fa fa-edit"/>
            </div>
            <div class="cursor-pointer mx-1" t-on-click="props.onRemoveViewLinkClick" title="Remove Link">
                <i class="fa fa-chain-broken"/>
            </div>
        </div>
    </t>
`);
registerTemplate("knowledge.ReadonlyEmbeddedViewLink", `/knowledge/static/src/editor/embedded_components/backend/embedded_view_link/readonly_embedded_view_link.xml`, `<t t-name="knowledge.ReadonlyEmbeddedViewLink" xml:space="preserve">
        <a href="#" t-att-class="getLinkClass()" t-on-click="openViewLink" t-out="displayName"/>
    </t>
`);
registerTemplate("knowledge.EmbeddedFile", `/knowledge/static/src/editor/embedded_components/backend/file/macros_file.xml`, `<t t-name="knowledge.EmbeddedFile" t-inherit="html_editor.EmbeddedFile" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//EmbeddedComponentToolbar/t[@t-set-slot=&quot;buttons&quot;]" position="inside">
            <t t-call="knowledge.MacrosFileButtons"/>
        </xpath>
    </t>
`);
registerTemplate("knowledge.MacrosFileButtons", `/knowledge/static/src/editor/embedded_components/backend/file/macros_file_mixin.xml`, `<t t-name="knowledge.MacrosFileButtons" xml:space="preserve">
        <EmbeddedComponentToolbarButton hidden="!targetRecordInfo?.canAttachFiles" icon="'fa-paperclip'" label.translate="Attach" onClick.bind="onClickUseAsAttachment" title.translate="Use as Attachment"/>
        <EmbeddedComponentToolbarButton hidden="!targetRecordInfo?.canPostMessages" icon="'fa-envelope'" label.translate="Send" onClick.bind="onClickAttachToMessage" title.translate="Send as Message"/>
    </t>
`);
registerTemplate("knowledge.ReadonlyEmbeddedFile", `/knowledge/static/src/editor/embedded_components/backend/file/readonly_macros_file.xml`, `<t t-name="knowledge.ReadonlyEmbeddedFile" t-inherit="html_editor.ReadonlyEmbeddedFile" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//EmbeddedComponentToolbar/t[@t-set-slot=&quot;buttons&quot;]" position="inside">
            <t t-call="knowledge.MacrosFileButtons"/>
        </xpath>
    </t>
`);
registerTemplate("knowledge.EmbeddedView", `/knowledge/static/src/editor/embedded_components/backend/view/embedded_view.xml`, `<t t-name="knowledge.EmbeddedView" xml:space="preserve">
        <WithLazyLoading>
            <div t-if="state.error" class="o_knowledge_embedded_view_placeholder d-flex flex-column flex-grow-1 position-relative bg-white border">
                <div class="d-flex border-bottom p-5 pb-0">
                    <div class="mb-3 p-3 bg-light w-25 me-auto"/>
                    <div class="mb-3 p-3 bg-light w-50 border-bottom"/>
                </div>
                <div class="bg-light flex-grow-1 p-3 w-100"/>
                <div class="o_knowledge_embedded_view_placeholder_cover d-flex flex-column align-items-center justify-content-center">
                    <p class="o_view_nocontent_empty_folder m-0"/>
                    <p class="display-6">Something went wrong!</p>
                    <p>The view does not exist or you are not allowed to access to it.</p>
                </div>
            </div>
            <div tabindex="-1">
                <EmbeddedView t-props="embeddedViewProps"/>
            </div>
        </WithLazyLoading>
    </t>
`);
registerTemplate("knowledge.ArticleIndexList", `/knowledge/static/src/editor/embedded_components/core/article_index/article_index_list.xml`, `<t t-name="knowledge.ArticleIndexList" xml:space="preserve">
        <t t-call="knowledge.ArticleIndexNestedList">
            <t t-set="articles" t-value="props.articles"/>
        </t>
    </t>

    `);
registerTemplate("knowledge.ArticleIndexNestedList", `/knowledge/static/src/editor/embedded_components/core/article_index/article_index_list.xml`, `<t t-name="knowledge.ArticleIndexNestedList" xml:space="preserve">
        <ol>
            <t t-foreach="articles" t-as="article" t-key="article_index">
                <li>
                    <a class="d-block p-1" t-attf-href="/knowledge/article/#{article.id}" t-out="article.name" t-on-click="(ev) =&gt; this.onArticleLinkClick(ev, article.id)"/>
                </li>
                <li t-if="article.childIds and article.childIds.length !== 0">
                    <t t-call="knowledge.ArticleIndexNestedList">
                        <t t-set="articles" t-value="article.childIds"/>
                    </t>
                </li>
            </t>
        </ol>
    </t>
`);
registerTemplate("knowledge.ReadonlyEmbeddedArticleIndex", `/knowledge/static/src/editor/embedded_components/core/article_index/readonly_article_index.xml`, `<t t-name="knowledge.ReadonlyEmbeddedArticleIndex" xml:space="preserve">
        <div class="o_embedded_articles_index_content">
            <p t-if="(props.articles || []).length === 0" class="fst-italic">No article to display</p>
            <ArticleIndexList t-else="" articles="props.articles"/>
        </div>
    </t>
`);
registerTemplate("knowledge.EmbeddedClipboard", `/knowledge/static/src/editor/embedded_components/core/clipboard/embedded_clipboard.xml`, `<t t-name="knowledge.EmbeddedClipboard" xml:space="preserve">
        <div class="d-flex justify-content-between flex-wrap w-100">
            <div class="o_embedded_clipboard_label px-2 py-1 text-break">Clipboard</div>
            <EmbeddedComponentToolbar>
                <t t-set-slot="buttons">
                    <EmbeddedComponentToolbarButton buttonRef="copyToClipboardButtonRef" icon="'fa-clipboard'" label.translate="Copy" name="'copyToClipboard'" onClick.bind="onClickCopyToClipboard" title.translate="Copy to Clipboard"/>
                </t>
            </EmbeddedComponentToolbar>
        </div>
        <div class="o_embedded_content" t-ref="clipboardContent"/>
    </t>
`);
registerTemplate("knowledge.ArticleIndexBlueprint", `/knowledge/static/src/editor/embedded_components/plugins/article_index_plugin/article_index_blueprint.xml`, `<t t-name="knowledge.ArticleIndexBlueprint" xml:space="preserve">
        <div data-embedded="articleIndex" data-oe-protected="true" contenteditable="false"/>
    </t>
`);
registerTemplate("knowledge.EmbeddedClipboardBlueprint", `/knowledge/static/src/editor/embedded_components/plugins/embedded_clipboard_plugin/embedded_clipboard_blueprint.xml`, `<t t-name="knowledge.EmbeddedClipboardBlueprint" xml:space="preserve">
        <div data-embedded="clipboard" data-oe-protected="true" contenteditable="false">
            <div data-embedded-editable="clipboardContent" data-oe-protected="false" contenteditable="true">
                <t t-tag="baseContainerNodeName" t-att="baseContainerAttributes"><br/></t>
            </div>
        </div>
    </t>
`);
registerTemplate("knowledge.EmbeddedViewLinkBlueprint", `/knowledge/static/src/editor/embedded_components/plugins/embedded_view_link_plugin/embedded_view_link_blueprint.xml`, `<t t-name="knowledge.EmbeddedViewLinkBlueprint" xml:space="preserve">
        <span t-att-data-embedded-props="embeddedProps" data-embedded="viewLink" data-oe-protected="true" contenteditable="false"/>
    </t>
`);
registerTemplate("knowledge.EmbeddedViewBlueprint", `/knowledge/static/src/editor/embedded_components/plugins/embedded_view_plugin/embedded_view_blueprint.xml`, `<t t-name="knowledge.EmbeddedViewBlueprint" xml:space="preserve">
        <div t-att-data-embedded-props="embeddedProps" data-embedded="view" data-oe-protected="true" contenteditable="false">
        </div>
    </t>
`);
registerTemplate("knowledge.ArticleBlueprint", `/knowledge/static/src/editor/plugins/article_plugin/article_blueprint.xml`, `<t t-name="knowledge.ArticleBlueprint" xml:space="preserve">
        <a t-att-href="href" t-att-data-res_id="articleId" target="_blank" contenteditable="false" class="btn btn-sm o_knowledge_article_link" t-out="displayName"/>
    </t>
`);
registerTemplate("knowledge.threadBeacon", `/knowledge/static/src/editor/plugins/comments_plugin/thread_beacon.xml`, `<t t-name="knowledge.threadBeacon" xml:space="preserve">
        <a class="oe_unremovable oe_thread_beacon" data-oe-protected="true" contenteditable="false" t-att-data-id="threadId" t-att-data-oe-type="type" t-att-data-res_id="recordId" t-att-data-oe-model="recordModel" t-att-data-peer-id="peerId"/>
    </t>
`);
registerTemplate("knowledge.KnowledgeCommentsThread", `/knowledge/static/src/comments/comment/comment.xml`, `<div t-name="knowledge.KnowledgeCommentsThread" t-if="hasLoaded and (hasAllDimensions or commentsState.displayMode === 'panel')" t-ref="targetRef" t-on-mouseenter="onMouseEnter" t-on-mouseleave="onMouseLeave" t-on-click="onClick" t-att-data-thread-id="props.threadId" class="o_knowledge_comment_box" t-att-class="{             'o_knowledge_comment_resolved': isResolved(),             'commenting': isActive,             'o_focused_thread': hasFocus,             'px-0 mh-25 col-lg m-0': commentsState.displayMode === 'panel',             'pb-2': commentsState.displayMode === 'handler',         }" t-att-style="style" xml:space="preserve">
        <div class="o_knowledge_comment_small_ui o_knowledge_comment_background" t-if="smallUI" t-on-click="onClick">
            <img class="rounded p-0 o_object_fit_cover cursor-pointer" t-att-src="authorUrl"/>
        </div>
        <div t-elif="editorThread or commentsState.displayMode === 'panel'" class="o_knowledge_comment_background rounded">
            <div t-if="commentsState.displayMode === 'panel' and fullAnchorText.length" class="o_knowledge_comment_anchor list-unstyled ps-1 pt-1" t-att-class="{                     'mb-0': showReadMore,                     'cursor-pointer': editorThread,                 }" t-on-click="showEditorAnchor">
                <div class="px-2 opacity-75 word-break">
                    <CommentAnchorText anchorText="state.hasFullAnchorText ? fullAnchorText : anchorText"/>
                </div>
            </div>
            <t t-if="commentsState.displayMode === 'panel' and showReadMore">
                <button t-if="!state.hasFullAnchorText" class="btn btn-sm btn-link" t-on-click="() =&gt; this.state.hasFullAnchorText = true">
                    Show More
                </button>
                <button t-else="" class="btn btn-sm btn-link" t-on-click="() =&gt; this.state.hasFullAnchorText = false">
                    Show Less
                </button>
            </t>
            <div t-if="props.threadId !== 'undefined'" class="o_knowledge_comment_container">
                <div class="o_knowledge_comment_scrollable" t-ref="threadScrollableRef">
                    <KnowledgeThread thread="thread" showDates="false" scrollRef="threadScrollableRef" order="'asc'" showEmptyMessage="false" showJumpPresent="false"/>
                    <div class="o_knowledge_sticky_composer rounded px-2" t-ref="composerRef">
                        <Composer t-if="isActive" placeholder.translate="Add a Comment..." composer="thread.composer" type="'note'" showFullComposer="false" mode="'extended'"/>
                    </div>
                </div>
            </div>
            <div t-else="" class="pt-2 px-2 flex-grow-1" t-ref="composerRef">
                <KnowledgeCommentCreatorComposer placeholder.translate="Add a Comment..." composer="thread.composer" type="'note'" showFullComposer="false" mode="'extended'" autofocus="true" allowUpload="false" onPostCallback="commentsService.createThread" onCreateThreadCallback.bind="onCreateThreadCallback"/>
            </div>
        </div>
    </div>
`);
registerTemplate("knowledge.CommentAnchorText", `/knowledge/static/src/comments/comment/comment_anchor_text.xml`, `<t t-name="knowledge.CommentAnchorText" xml:space="preserve">
        <t t-foreach="anchorTextArray" t-as="anchorFragment" t-key="anchorFragment_index">
            <t t-out="anchorFragment"/>
            <t t-if="!anchorFragment_last">
                <br/>
            </t>
        </t>
    </t>
`);
registerTemplate("knowledge.KnowledgeCommentsHandler", `/knowledge/static/src/comments/comments_handler/comments_handler.xml`, `<div t-name="knowledge.KnowledgeCommentsHandler" t-ref="rootCommentsRef" class="o_knowledge_comments_handler position-absolute top-0 start-100 d-print-none" xml:space="preserve">
        <t t-if="commentsState.displayMode === 'handler'">
            <t t-foreach="props.commentBeaconManager.sortedThreadIds" t-as="threadId" t-key="threadId">
                <KnowledgeCommentsThread threadId="threadId" top="getThreadTop(threadId)" horizontalDimensions="state.threadDimensions.horizontal"/>
            </t>
        </t>
    </div>
`);
registerTemplate("knowledge.KnowledgeCommentsPanel", `/knowledge/static/src/comments/comments_panel/comments_panel.xml`, `<div t-name="knowledge.KnowledgeCommentsPanel" t-ref="root" xml:space="preserve">
        <div t-if="commentsState.displayMode === 'panel'" class="o_knowledge_comments_panel">
            <select t-att-value="state.mode" t-on-change="onChangeMode" class="form-select border-0 my-2">
                <option value="all">All Discussions</option>
                <option value="resolved">Resolved Discussions</option>
                <option value="unresolved">Open Discussions</option>
            </select>
            <t t-foreach="state.threadIds" t-as="threadId" t-key="threadId">
                <div t-if="canDisplayRecord(threadId)" class="card ps-0 mb-2" t-att-class="{                         'o_knowledge_comment_card_borderless': !commentsState.threads[threadId],                     }">
                    <div class="card-body p-0 m-0 row">
                        <KnowledgeCommentsThread threadId="threadId"/>
                    </div>
                </div>
            </t>
            <div t-if="couldLoadMore" class="d-flex flex-column align-items-center mb-2">
                <button class="btn btn-sm btn-link" t-on-click="loadMore" t-att-disabled="this.state.loading">
                    Load More Discussions
                </button>
            </div>
            <div t-if="!state.threadIds.length" class="o_comments_helper text-center p-4 d-flex flex-column align-items-center justify-content-end">
                <p class="o_view_nocontent_smiling_face"/>
                <h3>Nothing going on!</h3>
                <p class="mb-0">
                    Highlight content and use the <i class="fa fa-commenting"/> button to add comments
                </p>
            </div>
        </div>
    </div>
`);
registerTemplate("knowledge.KnowledgeCommentsPopover", `/knowledge/static/src/comments/comments_popover/comments_popover.xml`, `<t t-name="knowledge.KnowledgeCommentsPopover" xml:space="preserve">
        <div t-ref="rootRef" class="o_knowledge_comment_scrollable o_knowledge_comment_box">
            <t t-if="props.threadId !== 'undefined'">
                <KnowledgeThread thread="thread" order="'asc'" showDates="false" showEmptyMessage="false" showJumpPresent="false" scrollRef="rootRef"/>
                <div class="o_knowledge_sticky_composer rounded px-2">
                    <Composer composer="thread.composer" mode="'extended'" type="'note'" showFullComposer="false" placeholder.translate="Add a comment..."/>
                </div>
            </t>
            <div t-else="" class="pt-2 px-2">
                <KnowledgeCommentCreatorComposer placeholder.translate="Add a comment..." composer="thread.composer" type="'note'" showFullComposer="false" autofocus="true" mode="'extended'" allowUpload="false" onPostCallback.bind="onPostCallback" onCreateThreadCallback.bind="onCreateThreadCallback"/>
            </div>
        </div>
    </t>
`);
registerTemplateExtension("web.EmojiPicker", `/knowledge/static/src/mail/emoji_picker/emoji_picker_patch.xml`, `<t t-inherit="web.EmojiPicker" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[hasclass('o-EmojiPicker-navbar')]" position="inside">
            <button t-if="props.hasRemoveFeature" class="btn fa fa-times-circle btn-outline-danger justify-self-end flex-grow-1 h-100" title="Remove Icon" t-on-click="removeEmoji"/>
        </xpath>
    </t>
`);
registerTemplate("knowledge.ArticleItemsCalendarController", `/knowledge/static/src/views/item_calendar/item_calendar_views.xml`, `<t t-name="knowledge.ArticleItemsCalendarController" t-inherit="web.CalendarController" xml:space="preserve">
        <xpath expr="//Layout" position="inside">
            <t t-set-slot="control-panel-create-button">
                <button t-if="model.canCreate" class="btn btn-primary" t-on-click="() =&gt; this.createRecord()">New</button>
            </t>
        </xpath>
        <xpath expr="//div[hasclass('o_calendar_container')]//div[hasclass('o_sidebar_toggler')]" position="replace"/>
        <xpath expr="//div[hasclass('o_calendar_container')]" position="inside">
            <div t-if="state.missingConfiguration" class="o_view_nocontent o_knowledge_item_calendar_nocontent">
                <div class="o_nocontent_help">
                    <p class="o_view_nocontent_empty_folder"/>
                    <p class="display-6">Missing Calendar configuration.</p>
                </div>
            </div>
        </xpath>
    </t>

    `);
registerTemplate("knowledge.ArticleItemsCalendarCommonPopover.body", `/knowledge/static/src/views/item_calendar/item_calendar_views.xml`, `<t t-name="knowledge.ArticleItemsCalendarCommonPopover.body" t-inherit="web.CalendarCommonPopover.body" xml:space="preserve">
        <xpath expr="//li[@t-att-class='fieldInfo.attrs.class']" position="attributes">
            <attribute name="t-if">fieldInfo.type !== 'properties'</attribute>
        </xpath>
        <xpath expr="//li[@t-att-class='fieldInfo.attrs.class']" position="after">
            <li t-elif="slot.record.data[fieldInfo.name].some(property =&gt; property.view_in_cards and property.value)" class="list-group-item flex-shrink-0 d-flex align-items-start pt-0" t-att-class="fieldInfo.attrs.class">
                <Field name="fieldInfo.name" record="slot.record" fieldInfo="fieldInfo" type="fieldInfo.widget"/>
            </li>
        </xpath>
    </t>

    `);
registerTemplate("knowledge.ArticleItemsCalendarCommonPopover.footer", `/knowledge/static/src/views/item_calendar/item_calendar_views.xml`, `<t t-name="knowledge.ArticleItemsCalendarCommonPopover.footer" xml:space="preserve">
        <a href="#" class="btn btn-primary" t-on-click="onEditEvent">Open</a>
        <t t-if="isEventDeletable">
            <a href="#" class="btn btn-secondary ms-2" t-on-click="onDeleteEvent"><i class="fa fa-trash"/></a>
        </t>
    </t>

`);
registerTemplateExtension("mail.ChatWindow.headerContent", `/whatsapp/static/src/core/common/chat_window_patch.xml`, `<t t-name="whatsapp.ChatWindow.headerContent" t-inherit="mail.ChatWindow.headerContent" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//ThreadIcon" position="after">
            <ThreadIcon t-elif="thread and thread.channel_type === 'whatsapp' and thread.correspondent" thread="thread"/>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.Composer.actions", `/whatsapp/static/src/core/common/composer_patch.xml`, `<t t-name="whatsapp.Composer.actions" t-inherit="mail.Composer.actions" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@name='root']" position="replace">
            <t t-if="thread?.channel_type === 'whatsapp' and !state.active"/>
            <t t-else="">$0</t>
        </xpath>
    </t>
    `);
registerTemplateExtension("mail.Composer.quickActions", `/whatsapp/static/src/core/common/composer_patch.xml`, `<t t-name="whatsapp.Composer.quickActions" t-inherit="mail.Composer.quickActions" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@name='root']" position="replace">
            <t t-if="thread?.channel_type === 'whatsapp' and !state.active"/>
            <t t-else="">$0</t>
        </xpath>
    </t>
    `);
registerTemplateExtension("mail.Composer.extraActions", `/whatsapp/static/src/core/common/composer_patch.xml`, `<t t-name="whatsapp.Composer.extraActions" t-inherit="mail.Composer.extraActions" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@name='root']" position="replace">
            <t t-if="thread?.channel_type === 'whatsapp' and !state.active"/>
            <t t-else="">$0</t>
        </xpath>
    </t>
    `);
registerTemplateExtension("mail.Composer.attachFiles", `/whatsapp/static/src/core/common/composer_patch.xml`, `<t t-name="whatsapp.Composer.attachFiles" t-inherit="mail.Composer.attachFiles" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//FileUploader" position="attributes">
            <attribute name="multiUpload">thread and thread.channel_type === 'whatsapp' ? false : true</attribute>
        </xpath>
        <xpath expr="//FileUploader/t/button" position="attributes">
            <attribute name="t-att-disabled" add="or (thread and thread.channel_type === 'whatsapp' and props.composer.attachments.length &gt; 0)" separator=" "/>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.ImStatus", `/whatsapp/static/src/core/common/im_status_patch.xml`, `<t t-name="whatsapp.ImStatus" t-inherit="mail.ImStatus" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//i[@title='Bot']" position="after">
            <i t-elif="props.member?.eq(props.member.thread.whatsappMember)" class="fa fa-whatsapp text-success" title="WhatsApp User" role="img" aria-label="WhatsApp User"/>
        </xpath>
    </t>

`);
registerTemplateExtension("mail.Message", `/whatsapp/static/src/core/common/message_patch.xml`, `<t t-name="whatsapp.Message" t-inherit="mail.Message" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[contains(@class, 'o-mail-Message-header')]" position="inside">
            <t t-if="message.whatsappStatus === 'error' or message.message_type === 'whatsapp_message'">
                <span class="fa fa-whatsapp ms-1" t-att-class="message.whatsappStatus === 'error' ? 'text-danger' : 'text-success'" t-att-title="message.whatsappStatus === 'error' ? 'Failed to send': 'Sent On WhatsApp'"/>
            </t>
        </xpath>
    </t>

`);
registerTemplateExtension("mail.ThreadIcon", `/whatsapp/static/src/core/common/thread_icon_patch.xml`, `<t t-name="whatsapp.ThreadIcon" t-inherit="mail.ThreadIcon" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[contains(@class, 'o-mail-ThreadIcon')]" position="inside">
            <t t-if="props.thread.channel_type === 'whatsapp'">
                <t name="whatsapp">
                    <t name="whatsapp_static">
                        <div class="fa fa-whatsapp text-success" title="WhatsApp"/>
                    </t>
                </t>
            </t>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.DiscussSidebarChannel.main", `/whatsapp/static/src/core/web/discuss_sidebar_category_item_patch.xml`, `<t t-name="whatsapp.DiscussSidebarChannel.main" t-inherit="mail.DiscussSidebarChannel.main" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//ThreadIcon" position="attributes">
            <attribute name="t-if" add="or thread.channel_type === 'whatsapp'" separator=" "/>
        </xpath>
    </t>
`);
registerTemplateExtension("mail.MessagingMenu.content", `/whatsapp/static/src/core/web/messaging_menu_patch.xml`, `<t t-name="whatsapp.MessagingMenu.content" t-inherit="mail.MessagingMenu.content" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//t[@name='searchBar']//ChannelSelector" position="before">
            <t t-if="state.adding === 'whatsapp'" t-set="category" t-value="store.discuss.whatsapp"/>
        </xpath>

        <xpath expr="//button[@name='startMeetingButton']" position="after">
            <button t-if="store.discuss.activeTab === 'whatsapp' and !state.adding" class="w-50 p-2 btn btn-secondary m-1" t-on-click.stop="() =&gt; this.state.adding = 'whatsapp'">
                <span>Search WhatsApp Channel</span>
            </button>
        </xpath>

        <xpath expr="//t[contains(@t-foreach, 'threads')]//*[contains(@t-set-slot, 'icon')]" position="inside">
            <ThreadIcon t-if="thread.channel_type === 'whatsapp'" className="'o-mail-whatsapp-threadIcon rounded-circle align-items-center bg-inherit position-absolute top-100 start-100 translate-middle mt-n1 ms-n1'" thread="thread"/>
        </xpath>
    </t>
`);
registerTemplateExtension("discuss.ChannelMemberList", `/whatsapp/static/src/discuss/core/common/channel_member_list_patch.xml`, `<t t-name="whatsapp.ChannelMemberList" t-inherit="discuss.ChannelMemberList" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//t[@name='offlineMembers']" position="after">
            <t t-if="props.thread.whatsappMember">
                <t t-call="discuss.ChannelMemberList.section">
                    <t t-set="sectionName">WhatsApp User</t>
                </t>
                <t t-set="member" t-value="props.thread.whatsappMember"/>
                <t t-call="discuss.channel_member"/>
            </t>
        </xpath>
    </t>

`);
registerTemplateExtension("mail.Chatter", `/whatsapp/static/src/chatter/web/chatter_patch.xml`, `<t t-name="whatsapp.Chatter" t-inherit="mail.Chatter" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[contains(@class, 'o-mail-Chatter-activity')]" position="before">
            <button t-if="state.thread.canSendWhatsapp" class="btn btn-secondary text-nowrap me-1" t-att-class="{'my-2': !props.compactHeight }" data-hotkey="shift+w" t-on-click="sendWhatsapp">
                <span>WhatsApp</span>
            </button>
        </xpath>
    </t>
`);
registerTemplateExtension("web.PhoneField", `/whatsapp/static/src/components/phone_field/phone_field.xml`, `<t t-name="whatsapp.PhoneField" t-inherit="web.PhoneField" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[contains(@class, 'o_phone_content')]//a" position="after">
            <t t-if="props.enableWhatsAppButton and props.record.data[props.name].length &gt; 0">
                <SendWhatsAppButton t-props="props"/>
            </t>
        </xpath>
    </t>

    `);
registerTemplateExtension("web.FormPhoneField", `/whatsapp/static/src/components/phone_field/phone_field.xml`, `<t t-name="whatsapp.FormPhoneField" t-inherit="web.FormPhoneField" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[contains(@class, 'o_phone_content')]" position="inside">
            <t t-if="props.enableWhatsAppButton and  props.record.data[props.name].length &gt; 0">
                <SendWhatsAppButton t-props="props"/>
            </t>
        </xpath>
    </t>

`);
registerTemplate("whatsapp.SendWhatsAppButton", `/whatsapp/static/src/components/whatsapp_button/whatsapp_button.xml`, `<t t-name="whatsapp.SendWhatsAppButton" xml:space="preserve">
        <a t-att-title="title" t-att-href="'whatsapp:' + props.record.data[props.name]" t-on-click.prevent.stop="onClick" class="ms-3 d-inline-flex align-items-center o_field_phone_whatsapp">
            <i class="fa fa-whatsapp"/>
            <small class="fw-bold ms-1">WhatsApp</small>
        </a>
    </t>

`);
registerTemplate("whatsapp.WhatsappVariablesTextField", `/whatsapp/static/src/components/whatsapp_variables_text_field/whatsapp_variables_text_field.xml`, `<t t-name="whatsapp.WhatsappVariablesTextField" t-inherit="web.TextField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//textarea" position="after">
            <div class="position-relative d-inline">
                <button class="btn position-absolute end-0 text-primary py-0" t-ref="variablesButton" t-on-click="_onClickAddVariables">
                    <div class="d-flex align-items-center gap-1 lh-1">
                        <i class="fa fa-plus" role="img" title="Insert variable"/>
                        <span>variable</span>
                    </div>
                </button>
            </div>
        </xpath>
    </t>
`);
registerTemplate("helpdesk.SLATagsList", `/helpdesk/static/src/components/helpdesk_sla_tags_list/helpdesk_sla_tags_list.xml`, `<t t-name="helpdesk.SLATagsList" t-inherit="web.TagsList" xml:space="preserve">
        <xpath expr="//div[contains(@class, &quot;o_tag_badge_text&quot;)]" position="before">
            <t t-set="statusIcon" t-value="getSLAStatusIcon(tag)"/>
            <i t-if="statusIcon" t-att-class="statusIcon"/>
        </xpath>
    </t>

`);
registerTemplate("helpdesk.HelpdeskTeamDashboard", `/helpdesk/static/src/components/helpdesk_team_dashboard/helpdesk_team_dashboard.xml`, `<t t-name="helpdesk.HelpdeskTeamDashboard" xml:space="preserve">

        <div t-if="state.dashboardValues" class="o_helpdesk_banner align-items-start flex-column flex-lg-row flex-shrink-0 d-flex py-4 border-bottom bg-view">
            <div class="w-100">
                <table class="o_helpdesk_banner_table table table-sm table-borderless h-100 px-3 mb-0 text-center">
                    <tbody>
                        <tr t-if="env.isSmall">
                            <td colspan="2">
                                <h3 class="o_highlight float-start">My Tickets</h3>
                            </td>
                        </tr>
                        <tr class="h-100">
                            <td class="o_text py-2 text-start align-middle">
                                <h3 t-if="!env.isSmall" class="o_highlight">My Tickets</h3>
                                Open Tickets
                            </td>
                            <td t-attf-class="{{demoClass}} p-0">
                                <a name="helpdesk.helpdesk_my_ticket_action_no_create" title="My Tickets" data-hotkey="t" t-on-click="onActionClicked" t-attf-class="btn w-100 h-100 p-2 border-0 text-capitalize fw-normal {{state.dashboardValues.my_all.count &gt; 0 ? 'btn-primary': 'btn-light bg-100'}} {{showDemo ? 'o_cursor_default' : ''}}">
                                    <span class="d-block mb-0 fs-2" t-out="state.dashboardValues.my_all.count"/>
                                    Tickets
                                </a>
                            </td>
                            <td t-attf-class="{{demoClass}} p-0">
                                <a name="helpdesk.helpdesk_my_ticket_action_no_create" title="My Tickets" context="{'search_default_high_priority': True}" data-hotkey="p" t-on-click="onActionClicked" t-attf-class="position-relative btn w-100 h-100 p-2 border-0 text-capitalize fw-normal {{state.dashboardValues.my_high.count &gt; 0 ? 'btn-primary': 'btn-light bg-100'}} {{showDemo ? 'o_cursor_default' : ''}}">
                                    <span class="d-block mb-0 fs-2" t-out="state.dashboardValues.my_high.count"/>
                                    High Priority
                                    <small class="position-absolute top-0 end-0 justify-content-end flex-lg-column flex-xl-row d-none d-sm-flex p-2" title="Two stars, with a maximum of three" role="img" aria-label="Two stars, with a maximum of three">
                                        <i class="o_star fa fa-star"/>
                                        <i class="o_star fa fa-star"/>
                                    </small>
                                </a>
                            </td>
                            <td t-attf-class="{{demoClass}} p-0">
                                <a name="helpdesk.helpdesk_my_ticket_action_no_create" t-attf-class="position-relative btn w-100 h-100 p-2 border-0 text-capitalize fw-normal {{state.dashboardValues.my_urgent.count &gt; 0 ? 'btn-primary': 'btn-light bg-100'}} {{showDemo ? 'o_cursor_default' : ''}}" title="My Tickets" context="{'search_default_urgent_priority': True}" t-on-click="onActionClicked" data-hotkey="o">
                                    <span class="d-block mb-0 fs-2" t-out="state.dashboardValues.my_urgent.count"/>
                                    Urgent
                                    <small class="position-absolute top-0 end-0 justify-content-end flex-lg-column flex-xl-row d-none d-sm-flex p-2 small" title="Three stars, maximum score" role="img" aria-label="Three stars, maximum score">
                                        <i class="o_star fa fa-star"/>
                                        <i class="o_star fa fa-star"/>
                                        <i class="o_star fa fa-star"/>
                                    </small>
                                </a>
                            </td>
                        </tr>
                        <tr class="h-100">
                            <td class="o_text py-2 text-start align-middle">Avg Open Hours</td>
                            <td t-attf-class="{{demoClass}} p-0">
                                <a name="helpdesk.helpdesk_ticket_action_dashboard" t-attf-class="btn btn-light align-items-center d-flex w-100 h-100 p-0 border-0 bg-100 fw-normal align-middle {{showDemo ? 'o_cursor_default' : ''}}" title="Tickets Analysis" t-on-click="onActionClicked" data-hotkey="a">
                                    <div class="w-100 p-2" t-out="formatTime(state.dashboardValues.my_all.hours)"/>
                                </a>
                            </td>
                            <td t-attf-class="{{demoClass}} p-0">
                                <a name="helpdesk.helpdesk_ticket_action_dashboard" t-attf-class="btn btn-light align-items-center d-flex w-100 h-100 p-0 border-0 bg-100 fw-normal {{showDemo ? 'o_cursor_default' : ''}}" title="Tickets Analysis" t-on-click="onActionClicked" context="{'search_default_high_priority': True}" data-hotkey="b">
                                    <div class="w-100 p-2" t-out="formatTime(state.dashboardValues.my_high.hours)"/>
                                </a>
                            </td>
                            <td t-attf-class="{{demoClass}} p-0">
                                <a name="helpdesk.helpdesk_ticket_action_dashboard" t-attf-class="btn btn-light align-items-center d-flex w-100 h-100 bg-100 p-0 border-0 fw-normal {{showDemo ? 'o_cursor_default' : ''}}" title="Tickets Analysis" context="{'search_default_urgent_priority': True}" t-on-click="onActionClicked" data-hotkey="y">
                                    <div class="w-100 p-2" t-out="formatTime(state.dashboardValues.my_urgent.hours)"/>
                                </a>
                            </td>
                        </tr>
                        <tr class="h-100">
                            <td class="o_text py-2 text-start align-middle" t-if="state.dashboardValues.success_rate_enable">Failed Tickets</td>
                            <td t-if="state.dashboardValues.success_rate_enable" t-attf-class="{{demoClass}} p-0">
                                <a name="helpdesk.helpdesk_ticket_action_sla" title="My Tickets" t-attf-class="btn align-items-center d-flex w-100 h-100 p-0 border-0 fw-normal {{state.dashboardValues.my_all.failed ? 'btn-warning' : 'btn-light bg-100'}} {{showDemo ? 'o_cursor_default' : ''}}" t-on-click="onActionClicked" data-hotkey="d">
                                    <div class="w-100 p-2" t-out="state.dashboardValues.my_all.failed"/>
                                </a>
                            </td>
                            <td t-if="state.dashboardValues.success_rate_enable" t-attf-class="{{demoClass}} p-0">
                                <a name="helpdesk.helpdesk_ticket_action_sla" t-attf-class="btn align-items-center d-flex w-100 h-100 p-0 border-0 fw-normal {{state.dashboardValues.my_high.failed ? 'btn-warning' : 'btn-light bg-100'}} {{showDemo ? 'o_cursor_default' : ''}}" title="My Tickets" t-on-click="onActionClicked" context="{'search_default_high_priority': True}" data-hotkey="e">
                                    <div class="w-100 p-2" t-out="state.dashboardValues.my_high.failed"/>
                                </a>
                            </td>
                            <td t-if="state.dashboardValues.success_rate_enable" t-attf-class="{{demoClass}} p-0">
                                <a name="helpdesk.helpdesk_ticket_action_sla" t-attf-class="btn align-items-center d-flex w-100 h-100 p-0 border-0 fw-normal {{state.dashboardValues.my_urgent.failed ? 'btn-warning' : 'btn-light bg-100'}} {{showDemo ? 'o_cursor_default' : ''}}" title="My Tickets" t-on-click="onActionClicked" context="{'search_default_urgent_priority': True}" data-hotkey="f">
                                    <div class="w-100 p-2" t-out="state.dashboardValues.my_urgent.failed"/>
                                </a>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
            <div class="w-100 mt-3 mt-lg-0">
                <table class="o_helpdesk_banner_table table table-sm table-borderless h-100 px-3 mb-0 text-center">
                    <tbody>
                        <tr t-if="env.isSmall">
                            <td colspan="2">
                                <h3 class="o_highlight float-start">My Performance</h3>
                            </td>
                        </tr>
                        <tr class="h-100">
                            <td class="o_text py-2 text-start align-middle">
                                <h3 t-if="!env.isSmall" class="o_highlight">My Performance</h3>
                                Today
                            </td>
                            <td t-attf-class="{{demoClass}} p-0">
                                <a name="helpdesk.helpdesk_ticket_action_close_analysis" t-attf-class="btn w-100 h-100 p-0 border-0 text-capitalize fw-normal {{state.dashboardValues.today.count &gt;= state.dashboardValues.helpdesk_target_closed ? 'btn-success': 'btn-light bg-100'}} {{showDemo ? 'o_cursor_default' : ''}}" title="My Tickets" t-on-click="onActionClicked" data-hotkey="i">
                                    <div class="p-2">
                                        <h2 class="mb-0 text-reset" t-out="state.dashboardValues.today.count"/>
                                        Closed Tickets
                                    </div>
                                </a>
                            </td>
                            <t t-set="success_rate_percentage" t-value="\`/ %\`"/>
                            <td t-if="state.dashboardValues.success_rate_enable" t-attf-class="{{demoClass}} p-0">
                                <t t-if="state.dashboardValues.today.sla_ticket_count &gt; 0" t-set="success_rate_percentage" t-value="\`\${formatFloat(state.dashboardValues.today.success)} %\`"/>
                                <a name="helpdesk.helpdesk_ticket_action_success" title="Percentage of tickets that were closed without failing any SLAs." t-attf-class="btn w-100 h-100 p-0 border-0 text-capitalize fw-normal {{(state.dashboardValues.helpdesk_target_success &lt;= state.dashboardValues.today.success) ? 'btn-success': 'btn-light bg-100' }} {{showDemo ? 'o_cursor_default' : ''}}" t-on-click="onActionClicked" data-action-title="My Tickets" data-hotkey="k">
                                    <div class="p-2">
                                        <h2 class="mb-0 text-reset" t-out="success_rate_percentage"/>
                                        SLA Success Rate
                                    </div>
                                </a>
                            </td>
                            <td t-if="state.dashboardValues.rating_enable" t-attf-class="{{demoClass}} p-0">
                                <t t-set="success_rate_rating" t-value="\`/\`"/>
                                <t t-if="state.dashboardValues.today.rating &gt; 0" t-set="success_rate_rating" t-value="\`\${formatFloat(state.dashboardValues.today.rating, {'digits': [1, 1]})} / 5\`"/>
                                <a name="action_view_rating_today" t-attf-class="btn w-100 h-100 p-0 border-0 text-capitalize fw-normal {{(state.dashboardValues.helpdesk_target_rating &lt;= state.dashboardValues.today.rating) ? 'btn-success': 'btn-light bg-100'}} {{showDemo ? 'o_cursor_default' : ''}}" title="Today's Average Rating" type="object" t-on-click="onActionClicked" data-hotkey="j">
                                    <div class="p-2">
                                        <h2 class="mb-0 text-reset" t-out="success_rate_rating"/>
                                        Average Rating
                                    </div>
                                </a>
                            </td>
                        </tr>
                        <tr class="h-100">
                            <td class="o_text py-2 text-start align-middle">Avg Last 7 days</td>
                            <td t-attf-class="{{demoClass}} p-0">
                                <a name="helpdesk.helpdesk_ticket_action_7days_tickets" data-hotkey="l" t-on-click="onActionClicked" title="Tickets" t-attf-class="btn align-items-center d-flex w-100 h-100 p-0 border-0 fw-normal {{state.dashboardValues['7days'].count &gt;= state.dashboardValues.helpdesk_target_closed ? 'btn-success': state.dashboardValues['7days'].count &lt;= 0 ? 'btn-light bg-100' : 'btn-warning'}} {{showDemo ? 'o_cursor_default' : ''}}">
                                    <div class="w-100 p-2" t-out="state.dashboardValues['7days'].count"/>
                                </a>
                            </td>
                            <td t-if="state.dashboardValues.success_rate_enable" t-attf-class="{{demoClass}} p-0">
                                <t t-if="state.dashboardValues['7days'].sla_ticket_count &gt; 0" t-set="success_rate_percentage" t-value="\`\${formatFloat(state.dashboardValues['7days'].success)} %\`"/>
                                <a name="helpdesk.helpdesk_ticket_action_7days_success" t-attf-class="btn align-items-center d-flex w-100 h-100 p-0 border-0 fw-normal {{(state.dashboardValues.helpdesk_target_success &lt;= state.dashboardValues['7days'].success) ? 'btn-success': state.dashboardValues['7days'].success &lt;= 0 ? 'btn-light bg-100' :  'btn-warning' }} {{showDemo ? 'o_cursor_default' : ''}}" title="Percentage of tickets that were closed without failing any SLAs." t-on-click="onActionClicked" data-action-title="Tickets" data-hotkey="n">
                                    <div class="w-100 p-2" t-out="success_rate_percentage"/>
                                </a>
                            </td>
                            <td t-if="state.dashboardValues.rating_enable" t-attf-class="{{demoClass}} p-0">
                                <t t-if="state.dashboardValues['7days'].rating &gt; 0" t-set="success_rate_rating" t-value="\`\${formatFloat(state.dashboardValues['7days'].rating)} %\`"/>
                                <a name="action_view_rating_7days" t-attf-class="btn align-items-center d-flex w-100 h-100 p-0 border-0 fw-normal {{(state.dashboardValues.helpdesk_target_rating &lt;= state.dashboardValues['7days'].rating) ? 'btn-success': state.dashboardValues['7days'].rating &lt;= 0 ? 'btn-light bg-100' : 'btn-warning'}} {{showDemo ? 'o_cursor_default' : ''}}" title="Average Rating for the Past 7 Days" t-on-click="onActionClicked" data-hotkey="m">
                                    <div class="w-100 p-2" t-out="success_rate_rating"/>
                                </a>
                            </td>
                        </tr>
                        <tr class="h-100">
                            <td class="o_text py-2 text-start align-middle">Daily Target</td>
                            <HelpdeskTeamTarget update="(value) =&gt; this.updateHelpdeskTarget('helpdesk_target_closed', value)" hotkey="v" showDemo="showDemo" demoClass="demoClass" value="parseInteger(state.dashboardValues.helpdesk_target_closed)"/>
                            <HelpdeskTeamTarget t-if="state.dashboardValues.success_rate_enable" update="(value) =&gt; this.updateHelpdeskTarget('helpdesk_target_success', value)" hotkey="x" showDemo="showDemo" demoClass="demoClass" value="parseInteger(state.dashboardValues.helpdesk_target_success)" percentage="true"/>
                            <HelpdeskTeamTarget t-if="state.dashboardValues.rating_enable" update="(value) =&gt; this.updateHelpdeskTarget('helpdesk_target_rating', value)" hotkey="w" showDemo="showDemo" demoClass="demoClass" value="state.dashboardValues.helpdesk_target_rating" rating="true"/>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
        <t t-if="showDemo and state.dashboardValues">
            <div class="ribbon ribbon-top-right">
                <span class="text-bg-primary">Sample</span>
            </div>
        </t>
    </t>

`);
registerTemplate("helpdesk.HelpdeskTeamTarget", `/helpdesk/static/src/components/helpdesk_team_target/helpdesk_team_target.xml`, `<t t-name="helpdesk.HelpdeskTeamTarget" xml:space="preserve">
        <td t-attf-class="{{props.demoClass}} p-0" t-att-data-hotkey="props.hotkey">
            <input t-if="state.isFocused" t-att-value="state.value" class="form-control p-0 h-100 text-center rounded" type="text" t-ref="inputRef" t-on-blur="_toggleFocus" t-on-change="_onValueChange" t-on-keydown="_onInputKeydown"/>
            <span t-else="" class="btn btn-light justify-content-center align-items-center d-flex h-100 p-0 border-0 bg-100 fw-normal" t-att-title="this.helpdeskTeamTargetTitle" t-att-class="{'o_target_to_set': !props.showDemo}" t-on-click.stop="_toggleFocus">
                <div t-if="state.value" class="position-relative p-2">
                    <t t-esc="this.valueString"/>
                    <i class="fa fa-pencil position-absolute ms-2 mt-1 opacity-0"/>
                </div>
                <div t-else="">
                    Click to set
                </div>
            </span>
        </td>
    </t>
`);
registerTemplate("helpdesk.SmileyBadge", `/helpdesk/static/src/components/helpdesk_ticket_smiley_badge/helpdesk_ticket_smiley_badge.xml`, `<t t-name="helpdesk.SmileyBadge" owl="1" xml:space="preserve">
        <i t-if="props.record.data[props.name]" class="fa fa-fw fa-smile-o fa-lg" t-att-class="classFromDecoration"/>
    </t>

`);
registerTemplate("helpdesk.HelpdeskTeamKanbanView", `/helpdesk/static/src/views/helpdesk_team_kanban/helpdesk_team_kanban_controller.xml`, `<t t-name="helpdesk.HelpdeskTeamKanbanView" t-inherit="web.KanbanView" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-component='props.Renderer']" position="replace">
            <div class="o_helpdesk_content flex-column d-flex h-100 mw-100">
                <HelpdeskTeamDashboard/>
                <div class="o_helpdesk_wrap_kanban_view flex-grow-1">$0</div>
            </div>
        </xpath>
    </t>

`);
registerTemplate("planning.AddressRecurrencyConfirmationDialog", `/planning/static/src/components/address_recurrency_confirmation_dialog/address_recurrency_confirmation_dialog.xml`, `<t t-name="planning.AddressRecurrencyConfirmationDialog" t-inherit="web.ConfirmationDialog" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-set-slot='footer']" position="before">
            <div>
                <p>This shift is recurrent. Delete:</p>
                <div>
                    <input type="radio" id="this" class="form-check-input o_radio_input me-2" name="recurrenceUpdate" value="this" t-on-change="() =&gt; props.onChangeRecurrenceUpdate('this')" t-att-checked="props.selected === &quot;this&quot;"/>
                    <label for="this">this shift</label>
                </div>
                <div>
                    <input type="radio" id="subsequent" class="form-check-input o_radio_input me-2" name="recurrenceUpdate" value="subsequent" t-on-change="() =&gt; props.onChangeRecurrenceUpdate('subsequent')" t-att-checked="props.selected === &quot;subsequent&quot;"/>
                    <label for="subsequent">this and following shifts</label>
                </div>
                <div>
                    <input type="radio" id="all" class="form-check-input o_radio_input me-2" name="recurrenceUpdate" value="all" t-on-change="() =&gt; props.onChangeRecurrenceUpdate('all')" t-att-checked="props.selected === &quot;all&quot;"/>
                    <label for="all">all shifts</label>
                </div>
            </div>
        </xpath>
        <xpath expr="//button[@t-on-click='_confirm']" position="attributes">
            <attribute name="t-esc">props.title</attribute>
        </xpath>
    </t>
`);
registerTemplateExtension("resource_mail.AvatarCardResourcePopover", `/planning/static/src/components/avatar_card_resource/avatar_card_resource_popover.xml`, `<t t-inherit="resource_mail.AvatarCardResourcePopover" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('o_card_user_infos')]" position="inside">
            <div class="pt-1">
                <div t-if="roles?.length" class="d-flex flex-wrap gap-1 o_resource_roles_tags">
                    <span class="fa fa-fw fa-certificate align-self-center" data-tooltip="Roles"/>
                    <TagsList tags="roleTags" visibleItemsLimit="5"/>
                </div>
            </div>
        </xpath>
        <xpath expr="//div[hasclass('o_avatar_card_buttons')]" position="attributes">
            <attribute t-if="roles?.length" name="class" add="pt-1" separator=" "/>
        </xpath>
    </t>
`);
registerTemplate("planning.ConflictingSlotIdsField", `/planning/static/src/components/conflicting_slot_ids_field/conflicting_slot_ids_field.xml`, `<t t-name="planning.ConflictingSlotIdsField" xml:space="preserve">
        <t t-if="conflictingSlots.length">
            <p class="fw-bold pb-2">
                Prepare for the ultimate multi-tasking challenge:
            </p>
            <t t-foreach="conflictingSlots" t-as="slot" t-key="slot.id">
                <div t-if="slot_index &lt; 5" class="d-flex flex-column justify-content-center o_conflicting_slot pt-0">
                    <div class="d-grid" style="grid-template-columns: auto 1fr">
                        <span>
                            <t t-out="slot.data.start_datetime"/>
                            <i class="fa fa-long-arrow-right mx-2" aria-label="Arrow icon" title="Arrow"/>
                            <t t-out="slot.data.end_datetime"/>
                        </span>
                        <t t-set="message" t-value="getConflictSlotMessage(slot)"/>
                        <span class="text-truncate text-start ps-1" t-att-title="message">(<t t-out="slot.data.allocated_hours"/>) (<t t-out="slot.data.allocated_percentage"/>) <t t-if="message.length">- <t t-esc="message"/></t></span>
                    </div>
                </div>
            </t>
            <button t-on-click="showConflictedSlots" class="btn btn-link">See conflicting shifts</button>
        </t>
    </t>

`);
registerTemplateExtension("resource_mail.Many2OneAvatarResourceField", `/planning/static/src/views/fields/many2one_avatar_resource/many2one_avatar_resource_field.xml`, `<t t-inherit="resource_mail.Many2OneAvatarResourceField" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//span[hasclass('o_material_resource')]" position="attributes">
            <attribute name="t-attf-class">o_colorlist_item_color_{{ props.record.data.resource_color }}</attribute>
        </xpath>
    </t>

    `);
registerTemplateExtension("resource_mail.KanbanMany2OneAvatarResourceField", `/planning/static/src/views/fields/many2one_avatar_resource/many2one_avatar_resource_field.xml`, `<t t-inherit="resource_mail.KanbanMany2OneAvatarResourceField" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//span[hasclass('o_material_resource')]" position="attributes">
            <attribute name="t-attf-class">o_colorlist_item_color_{{ props.record.data.resource_color }}</attribute>
        </xpath>
    </t>
`);
registerTemplate("planning.PlanningCalendarCommonPopover.body", `/planning/static/src/views/planning_calendar/common/planning_calendar_common_popover.xml`, `<t t-name="planning.PlanningCalendarCommonPopover.body" t-inherit="web.CalendarCommonPopover.body" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//small[@t-if='timeDuration']" position="replace">
            <small t-if="data.allocated_hours">
                <b t-esc="\`(\${allocatedHoursFormatted})\`"/>
            </small>
            <small t-if="data.allocated_percentage and data.resource_type === 'user'">
                <b t-esc="\` (\${allocatedPercentageFormatted}%)\`"/>
            </small>
            <t t-if="timeDuration and !(data.allocated_hours or data.allocated_percentage)">$0</t>
        </xpath>

        <xpath expr="//t[@t-if='!isInvisible(fieldInfo, slot.record)']" position="attributes">
            <attribute name="t-if" add="isSet(fieldInfo.name)" separator=" and "/>
        </xpath>
    </t>
`);
registerTemplate("planning.PlanningAskRecurrenceUpdateDialog", `/planning/static/src/views/planning_calendar/planning_ask_recurrence_update/planning_ask_recurrence_update_dialog.xml`, `<t t-name="planning.PlanningAskRecurrenceUpdateDialog" xml:space="preserve">
        <Dialog size="'sm'" title.translate="Edit Recurrent Shift">
            <t t-foreach="Object.entries(possibleValues)" t-as="value" t-key="value[0]">
                <t t-set="name" t-value="value[0]"/>
                <t t-set="state" t-value="value[1]"/>
                <div class="form-check o_radio_item">
                    <input name="recurrence-update" type="radio" class="form-check-input o_radio_input" t-att-checked="state.checked" t-att-value="name" t-att-id="name" t-on-click="(ev) =&gt; this.selected = ev.target.value"/>
                    <label class="form-check-label o_form_label" t-att-for="name" t-esc="state.label"/>
                </div>
            </t>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="confirm">
                    Confirm
                </button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("planning.PlanningCalendarController", `/planning/static/src/views/planning_calendar/planning_calendar_controller.xml`, `<t t-name="planning.PlanningCalendarController" t-inherit="web.CalendarController" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_calendar_sidebar')]" position="inside">
            <div t-if="isManager" class="o_planning_legend mt-4">
                <h5>Legend</h5>
                <img src="/hr/static/src/img/icons/plain.svg" width="30px" class="mb-1"/><span>Published</span><br/>
                <img src="/hr/static/src/img/icons/hatched.svg" width="30px" class="mb-1"/><span>Draft</span><br/>
            </div>
        </xpath>
    </t>


    `);
registerTemplate("planning.PlanningCalendarController.controlButtons", `/planning/static/src/views/planning_calendar/planning_calendar_controller.xml`, `<t t-name="planning.PlanningCalendarController.controlButtons" t-inherit="web.CalendarController.controlButtons" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="." position="inside">
            <button t-if="model.canCreate &amp;&amp; model.scale === 'week'" class="btn btn-primary me-1 o_button_copy_previous_week" title="Copy previous week" t-on-click="() =&gt; this.planningControllerActions.copyPrevious()">
                Copy previous
            </button>
            <button t-if="isManager and model.scale !== 'year'" class="btn btn-primary me-1 o_button_send_all" title="Send schedule" t-on-click.prevent="() =&gt; this.planningControllerActions.publish()">
                Publish
            </button>
            <button t-if="model.canCreate" class="btn btn-secondary me-1" title="Automatically plan open shifts and sales orders" t-on-click.prevent="() =&gt; this.planningControllerActions.autoPlan()">
                Auto Plan
            </button>
        </xpath>
    </t>
`);
registerTemplate("planning.PlanningCalendarFilterPanel.filter", `/planning/static/src/views/planning_calendar/planning_filter_panel/planning_calendar_filter_panel.xml`, `<t t-name="planning.PlanningCalendarFilterPanel.filter" t-inherit="web.CalendarFilterPanel.filter" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//input[@class='o_cw_filter_input_bg form-check-input']" position="attributes">
            <attribute name="t-attf-class">{{ getNoColor(filter) }}</attribute>
        </xpath>
        <xpath expr="//t[@t-if='section.hasAvatar and filter.hasAvatar']" position="replace">
            <t t-if="section.hasAvatar and filter.hasAvatar">
                <t t-if="filter.resourceType == 'user'">
                    <img class="o_cw_filter_avatar o_avatar rounded" t-attf-src="/web/image/{{ section.avatar.model }}/{{ filter.value }}/{{ section.avatar.field }}" alt="Avatar"/>
                </t>
                <t t-elif="filter.resourceType == 'material'">
                    <i t-attf-class="o_cw_filter_avatar o_avatar rounded fa fa-wrench"/>
                </t>
            </t>
        </xpath>
    </t>
`);
registerTemplate("social.PostFormatterField", `/social/static/src/js/fields/post_formatter_field.xml`, `<t t-name="social.PostFormatterField" xml:space="preserve">
        <div t-out="formattedPost"/>
    </t>
`);
registerTemplate("social.SocialMany2manyImages", `/social/static/src/js/fields/social_many2many_images.xml`, `<t t-name="social.SocialMany2manyImages" xml:space="preserve">
        <t t-if="attachmentsIds.length &gt;= 2">
            <a class="o_social_original_post_image_more position-relative d-flex ms-1" t-on-click.stop.prevent="onClickMoreImages">
                <img t-attf-src="/web/image/{{attachmentsIds[0]}}" alt="Post Image"/>
                <div class="social_many2many_image o_social_stream_post_image_more_overlay d-flex align-items-center h-100 w-100 text-white justify-content-center position-absolute h1 m-0 user-select-none">
                    +<t t-out="attachmentsIds.length - 1"/>
                </div>
            </a>
        </t>
        <img t-elif="attachmentsIds.length === 1" class="social_many2many_image" t-attf-src="/web/image/{{attachmentsIds[0]}}" alt="Post Image" t-on-click.stop.prevent="onClickMoreImages"/>
    </t>
`);
registerTemplate("social.SocialPostSplitPerMedia", `/social/static/src/js/fields/social_post_split_per_media.xml`, `<t t-name="social.SocialPostSplitPerMedia" xml:space="preserve">
        <button class="btn btn-link" t-on-click="onClick">
            <i class="fa fa-scissors me-1"/>
            <span>Split Per Media</span>
        </button>
    </t>
`);
registerTemplate("social.StreamPostComments", `/social/static/src/xml/social_templates.xml`, `<t t-name="social.StreamPostComments" xml:space="preserve">
        <t t-set="bubble_design" t-value="false"/>
        <Dialog t-if="state.displayModal" title="props.title" footer="false" size="'md'" bodyClass="bodyClass">
            <t t-call="social.StreamPostCommentsOriginalPost"/>
            <t t-component="commentReplyComponent" originalPost="props.originalPost" mediaSpecificProps="mediaSpecificProps" classes="'bg-white p-3 border-top'" bubble_design="bubble_design" onAddComment.bind="onAddComment" preventAddComment.bind="preventAddComment"/>
            <div class="o_social_comments_messages px-3 pt-4" t-att-class="{ 'bg-100': !bubble_design }">
                <t t-component="commentListComponent" comments="comments" mediaSpecificProps="mediaSpecificProps" originalPost="originalPost" preventAddComment.bind="preventAddComment" error="props.error"/>
            </div>
            <a t-if="state.showLoadMoreComments" class="o_social_load_more_comments text-center p3-bg-white" href="#" t-on-click="loadMoreComments">
                <i class="fa fa-comments"/><span>Load more comments...</span>
            </a>
        </Dialog>
    </t>

    `);
registerTemplate("social.StreamPostCommentsOriginalPost", `/social/static/src/xml/social_templates.xml`, `<t t-name="social.StreamPostCommentsOriginalPost" xml:space="preserve">
        <div class="o_social_comments_modal_original_post d-flex bg-white pt-3 px-3">
            <div class="me-3">
                <span class="o_social_original_post_author_image o_social_author_image d-block position-relative rounded overflow-hidden"/>
            </div>
            <div class="o_social_comments_modal_original_post_content flex-grow-1">
                <div t-if="isEditable || isDeletable" class="float-end o_social_icon_dropdown dropdown">
                    <button t-attf-class="btn dropdown-toggle {{ bubble_design ? 'bg-200 px-3 rounded-pill border-0' : '' }}" type="button" id="stream_post_actions" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <i class="fa fa-ellipsis-v"/>
                    </button>
                    <div class="dropdown-menu dropdown-menu-end" aria-labelledby="stream_post_actions">
                        <a t-if="isEditable" class="dropdown-item text-decoration-none" href="#" t-on-click.prevent=" () =&gt; this.state.isEditMode = true">
                            Edit
                        </a>
                        <a t-if="isDeletable" class="dropdown-item text-decoration-none" href="#" t-on-click.prevent="onDeletePost">
                            Delete
                        </a>
                    </div>
                </div>
                <div class="d-flex align-items-center h3 mb-1">
                    <a t-if="originalPost.author_link.value" class="o_social_original_post_author d-flex align-items-center" t-att-href="originalPost.author_link.value" t-att-title="originalPost.author_name.value or 'Unknown'" target="_blank">
                        <b class="text-truncate" t-esc="originalPost.author_name.value or 'Unknown'"/>
                    </a>

                    <div t-else="" class="o_social_original_post_author d-flex align-items-center">
                         <span class="text-truncate" t-esc="originalPost.author_name.value or 'Unknown'"/>
                    </div>
                    <span class="mx-1">·</span>
                    <a t-att-href="originalPost.post_link.value" class="o_social_post_published_date" target="_blank">
                    <time class="small" t-esc="originalPost.formatted_published_date.value" t-att-title="originalPost.published_date.value"/>
                    </a>
                </div>
                <div name="o_social_original_post_message_body" class="o_social_original_post_message_body">
                    <div t-if="state.isEditMode" class="pe-4 pb-2">
                        <textarea class="o_social_add_comment form-control mx-2 my-1" t-att-class="{'bg-200 o_social_bubble_radius': props.bubble_design}" placeholder="Edit Your Post" t-on-keydown="onEditPost">
                            <t t-esc="state.message"/>
                        </textarea>
                        <small class="o_social_textarea_message text-600">
                            Press Enter to edit. Press Shift+Enter to insert a Line Break.
                        </small>
                    </div>
                    <div t-elif="state.message" t-out="_formatCommentStreamPost(state.message)" class="o_social_original_post_message_text overflow-auto mb-2"/>
                    <div t-if="originalPost.stream_post_image_ids.raw_value.length &gt; 0" class="o_social_stream_post_image o_social_stream_post_image_clickable mt-3 d-flex overflow-hidden">
                        <t t-set="images" t-value="JSON.parse(originalPost.stream_post_image_urls.raw_value)"/>
                        <t t-foreach="images.length &gt; 2 ? images.slice(0, 2) : images" t-as="image_url" t-key="image_url_index">
                            <t t-if="image_url_index == 1 &amp;&amp; images.length &gt; 2">
                                <a class="o_social_original_post_image_more position-relative d-flex ms-1" t-on-click.stop="() =&gt; this.onClickMoreImages(image_url_index, images)">
                                    <img t-att-src="images[1]" alt="Post Image"/>
                                    <div class="o_social_stream_post_image_more_overlay d-flex align-items-center h-100 w-100 text-white justify-content-center position-absolute h1 m-0" style="user-select: none;">
                                        +<t t-esc="images.length - 2"/>
                                    </div>
                                </a>
                            </t>
                            <img t-else="" class="o_social_original_post_single" t-att-src="image_url" alt="Post Image" t-on-click.stop="() =&gt; this.onClickMoreImages(image_url_index, images)"/>
                        </t>
                    </div>
                    <a t-if="originalPost.link_url.value" class="o_social_stream_post_link p-3 d-flex bg-100" t-att-href="originalPost.link_url.value" target="_blank">
                        <img t-if="originalPost.link_image_url.raw_value" class="me-3 flex-shrink-0" t-att-src="originalPost.link_image_url.raw_value" alt="Link Image"/>
                        <div class="o_social_stream_post_link_text">
                            <div class="o_social_stream_post_link_title h3 text-truncate" t-esc="originalPost.link_title.raw_value"/>
                            <p t-if="originalPost.link_description.raw_value" class="o_social_stream_post_link_description" t-esc="originalPost.link_description.raw_value"/>
                        </div>
                    </a>
                </div>
            </div>
        </div>
    </t>

    `);
registerTemplate("social.StreamPostCommentsReply", `/social/static/src/xml/social_templates.xml`, `<div t-name="social.StreamPostCommentsReply" class="o_social_write_reply" xml:space="preserve">
        <form t-attf-class="d-flex flex-nowrap align-items-start {{ props.classes }}">
            <div class="o_social_author_image position-relative rounded flex-shrink-0 overflow-hidden me-2">
                <img t-if="authorPictureSrc" t-att-src="authorPictureSrc" t-att-title="isCommentReply ? ('Write a reply as ' + props.mediaSpecificProps.accountName) : ('Write comment as ' + props.mediaSpecificProps.accountName)"/>
            </div>
            <div class="o_social_reply_container position-relative flex-grow-1">
                <div class="f-flex align-items-stretch">
                    <t t-set="write_reply_text">Write a reply...</t>
                    <t t-set="write_comment_text">Write a comment...</t>
                    <textarea name="message" t-ref="autofocus" t-attf-data-id="comment_reply_{{ isCommentReply || isCommentEdit ? comment.id : 'new' }}" t-att-data-existing-attachment-id="existingAttachmentId" t-att-data-is-comment-edit="isCommentEdit" t-att-data-is-comment-reply="isCommentReply" t-att-data-comment-id="isCommentReply || isCommentEdit ? comment.id : null" class="o_social_add_comment o_social_comment_message form-control pe-5" t-att-class="{'bg-200 o_social_bubble_radius': props.bubble_design}" t-att-placeholder="isCommentReply ? write_reply_text : write_comment_text" t-att-disabled="state.disabled" t-on-keydown="_onAddComment" t-att-value="initialValue || ''">
                    </textarea>
                    <div class="o_social_comment_controls mt-2">
                        <div t-if="canAddImage" class="o_social_comment_add_image o_social_subtle_btn px-3 py-1">
                            <FileUploader inputName="'attachment'" acceptedFileExtensions="'image/*'" onUploaded.bind="_onImageChange">
                                <t t-set-slot="toggler">
                                    <i class="fa fa-image" title="Add an image"/>
                                </t>
                            </FileUploader>
                        </div>
                        <div class="o_social_emoji_dropdown o_social_subtle_btn px-3 py-1" t-ref="emoji-picker">
                            <i class="fa fa-smile-o"/>
                        </div>
                    </div>
                </div>
                <div t-if="state.attachmentSrc" class="o_social_comment_image_preview py-4">
                    <div class="d-inline-block position-relative">
                        <img class="border shadow" style="max-height: 150px" t-att-src="state.attachmentSrc"/>
                        <span class="o_social_comment_remove_image position-absolute btn btn-dark rounded-circle mt-2 me-2" style="right: 0" t-on-click="_onImageRemove">
                            <i class="fa fa-times"/>
                        </span>
                    </div>
                </div>
                <div name="o_social_textarea_helper" t-attf-class="o_social_textarea_helper d-flex align-items-center {{ isCommentEdit? 'mt-3 mb-5' : 'mt-2' }}">
                    <small class="o_social_textarea_message text-600">
                        Press Enter to post. Press Shift+Enter to insert a Line Break.
                    </small>
                    <div t-if="isCommentEdit" class="o_social_comment_commands ms-3">
                        <a class="btn btn-sm btn-link p-0" href="#" t-on-click.prevent="props.toggleEditMode">
                            Discard
                        </a>
                    </div>
                </div>
            </div>
        </form>
    </div>

    `);
registerTemplate("social.StreamPostCommentsWrapper", `/social/static/src/xml/social_templates.xml`, `<div t-name="social.StreamPostCommentsWrapper" xml:space="preserve">
        <t t-if="comments.length">
            <t t-foreach="comments" t-as="comment" t-key="comment_index">
                <t t-component="commentComponent" comment="comment" originalPost="props.originalPost" toggleUserLikes.bind="toggleUserLikes" mediaSpecificProps="props.mediaSpecificProps" onDeleteComment="() =&gt; comments.splice(comment_index, 1)" preventAddComment="props.preventAddComment"/>
            </t>
        </t>
        <t t-else="">
            <div class="o_social_no_comment_message text-black-50 text-center">
                <t t-if="props.error" t-out="props.error"/>
                <t t-else="">No comments yet.</t>
            </div>
        </t>
    </div>

    `);
registerTemplate("social.StreamPostComment", `/social/static/src/xml/social_templates.xml`, `<div t-name="social.StreamPostComment" t-att-data-comment-id="comment.id" t-att-data-existing-attachment-id="comment.attachment &amp;&amp; comment.attachment.type === 'photo' &amp;&amp; comment.attachment.target ? comment.attachment.target.id : null" t-att-data-existing-attachment-src="comment.attachment &amp;&amp; comment.attachment.type === 'photo' ? comment.attachment.media.image.src : null" class="o_social_comment mb-3" t-att-class="{'o_social_root_comment': props.isSubComment}" xml:space="preserve">
        <t t-set="bubble_design" t-value="false"/>

        <t t-if="state.isEditMode" t-component="commentReplyComponent" comment="comment" originalPost="props.originalPost" initialValue="comment.message" isCommentEdit="true" mediaSpecificProps="props.mediaSpecificProps" toggleEditMode.bind="_toggleEditMode" bubble_design="bubble_design" onAddComment="(newComment) =&gt; props.comment = newComment" preventAddComment="props.preventAddComment"/>

        <div t-else="" class="o_social_comment_wrapper d-flex align-items-start">
            <div class="o_social_author_image position-relative rounded flex-shrink-0 me-2 overflow-hidden">
                <img t-if="authorPictureSrc" t-att-src="authorPictureSrc" t-att-title="comment.from.name"/>
            </div>

            <div class="flex-grow-1">
                <div class="o_social_comment_content">
                    <div class="o_social_comment_message">
                        <a t-att-href="authorLink" class="o_social_comment_author_name fw-bold" t-esc="comment.from.name" target="_blank"/>
                        <span class="mx-1 o_social_comment_published_date">·</span>
                        <a t-att-href="link" target="_blank" class="o_social_comment_published_date">
                           <small t-att-title="comment.created_time" t-esc="comment.formatted_created_time"/>
                        </a>
                        <span t-if="comment.likes?.summary.total_count" class="o_social_comment_likes_total badge rounded-pill py-1 ms-1">
                            <i t-attf-class="fa {{ likesClass }} me-1" title="Likes"/>
                            <span class="o_social_likes_count" t-esc="comment.likes.summary.total_count"/>
                        </span>

                        <div t-if="comment.message || comment.attachment" t-attf-class="d-flex flex-grow-1 {{ bubble_design and comment.message ? 'bg-200 py-1 ps-3 pe-1 me-2 o_social_bubble_radius' : '' }}">
                            <t t-set="originalMessage" t-value="_htmlEscape(comment.message)"/>
                            <div t-attf-class="d-flex flex-grow-1 justify-content-start align-items-center">
                                <div>
                                    <div class="o_social_comment_text text-break" t-att-data-original-message="originalMessage" t-out="formatComment(comment.message)"/>
                                    <div t-if="comment.attachment" class="o_social_comment_attachment mt-3">
                                        <a t-if="comment.attachment.type === 'share'" class="o_social_stream_post_link text-reset shadow mb-3 d-block overflow-hidden" t-att-href="comment.attachment.target.url" target="_blank">
                                            <img t-att-src="comment.attachment.media.image.src" class="img-fluid" alt="Link Image"/>
                                            <div class="o_social_stream_post_link_text bg-white p-2">
                                                <h5 class="o_social_stream_post_link_title"><b t-esc="comment.attachment.title"/></h5>
                                                <p class="o_social_stream_post_link_description" t-esc="comment.attachment.description"/>
                                            </div>
                                        </a>
                                        <img t-if="comment.attachment.type === 'photo'" class="o_social_comment_image img-fluid shadow mb-3" t-att-src="comment.attachment.media.image.src" alt="Comment Image" target="_blank">
                                        </img>
                                    </div>
                                </div>
                                <div t-if="isManageable()" class="o_social_icon_dropdown o_social_manage_comment dropdown">
                                    <button t-attf-class="btn dropdown-toggle {{ bubble_design ? 'bg-200 px-3 rounded-pill border-0' : '' }}" type="button" t-attf-id="post_actions_{{ comment.id }}" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        <i class="fa fa-ellipsis-v"/>
                                    </button>
                                    <div class="dropdown-menu dropdown-menu-end" t-attf-aria-labelledby="post_actions_{{ comment.id }}">
                                        <a t-if="isEditable" class="dropdown-item text-decoration-none" href="#" t-on-click.prevent="_toggleEditMode">Edit</a>
                                        <a t-if="isDeletable" class="dropdown-item text-decoration-none" href="#" t-on-click.prevent="_deleteComment">Delete</a>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div class="o_social_comment_commands">
                            <t t-if="isLikable">
                                <a t-attf-class="o_social_comment_like btn btn-sm btn-link px-0 {{ comment.user_likes ? 'o_social_comment_user_likes' : '' }}" href="#" t-on-click.prevent="() =&gt; props.toggleUserLikes(comment)">
                                    Like
                                </a>
                                <span class="mx-1">·</span>
                            </t>
                            <a class="o_social_comment_reply btn btn-sm btn-link px-0" href="#" t-on-click.prevent="props._onReplyComment || _onReplyComment"> Reply </a>
                            <span t-if="comment.comments and comment.comments.data.length and !action.showSubComment" class="o_social_comment_load_replies" t-on-click.prevent="_onLoadReplies">
                                <span class="mx-1">·</span>
                                <a class="btn btn-sm btn-link px-0" href="#">
                                    <i class="fa fa-comments me-1"/>View <t t-esc="comment.comments.data.length"/> replies...
                                </a>
                            </span>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div t-if="!props.isSubComment" class="ps-5 mt-2">
            <div t-if="comment.comments and action.showSubComment" class="o_social_comment_replies mt-4">
                <t t-foreach="comment.comments.data" t-as="innerComment" t-key="innerComment_index">
                    <t t-component="commentComponent" comment="innerComment" originalPost="props.originalPost" isSubComment="true" _onReplyComment.bind="_onReplyComment" mediaSpecificProps="props.mediaSpecificProps" toggleUserLikes="() =&gt; props.toggleUserLikes(innerComment)" preventAddComment="props.preventAddComment" onDeleteComment="() =&gt; comment.comments.data.splice(innerComment_index, 1)"/>
                </t>
            </div>
            <div t-if="action.showReplyComment" class="o_social_write_comment_reply">
                <t t-component="commentReplyComponent" comment="comment" originalPost="props.originalPost" isCommentReply="true" mediaSpecificProps="props.mediaSpecificProps" classes="'pe-5 mb-5'" bubble_design="bubble_design" onAddComment="(newComment) =&gt; comment.comments.data.push(newComment)" preventAddComment="props.preventAddComment"/>
            </div>
        </div>
    </div>



    `);
registerTemplate("social.AddSocialStreamDialog", `/social/static/src/xml/social_templates.xml`, `<div t-name="social.AddSocialStreamDialog" xml:space="preserve">
        <Dialog title="props.title" footer="false" size="'md'" modalRef="modalRef">
            <div class="o_social_add_stream_form bg-200">
                <t t-if="props.socialAccounts.length !== 0">
                    <t t-if="props.isSocialManager">
                        <h4>Link a new account <t t-call="social.AddStreamCompany"/></h4>
                        <div class="mb-5"><t t-call="social.AddStreamMedia"/></div>
                    </t>
                    <h4><t t-if="props.isSocialManager">Or add</t><t t-else="">Add</t> a Stream from an existing account</h4>
                    <div class="o_social_add_stream_accounts list-group">
                        <button t-foreach="props.socialAccounts" t-as="socialAccount" t-key="socialAccount_index" class="list-group-item list-group-item-action">
                            <div class="o_social_account_card d-flex align-items-center" t-att-data-media-id="socialAccount.media_id[0]" t-att-data-account-id="socialAccount.id" t-on-click.prevent="_onClickSocialAccount">
                                <img width="24" t-attf-src="/web/image/social.media/{{ socialAccount.media_id[0] }}/image/24x24" class="me-4"/>
                                <img t-if="socialAccount.image" t-attf-src="/web/image/social.account/{{ socialAccount.id }}/image/32x32" class="o_social_account_image rounded-circle border me-2"/>
                                <h4 t-esc="socialAccount.name" class="o_social_account_name fw-bold flex-grow-1 m-0"/>
                            </div>
                        </button>
                    </div>
                </t>
                <t t-else="">
                    <h5 class="mb-4">To add a stream<t t-call="social.AddStreamCompany"/>, you must first link a social media.</h5>
                    <t t-call="social.AddStreamMedia"/>
                </t>
            </div>
        </Dialog>
    </div>

    `);
registerTemplate("social.AddStreamCompany", `/social/static/src/xml/social_templates.xml`, `<t t-name="social.AddStreamCompany" t-if="props.companies &amp;&amp; props.companies.length &gt; 1" xml:space="preserve">
        for
        <select class="o_social_add_stream_form_select form-select w-25 ms-1" name="company_id">
            <option t-att-value="props.companies[0].id" t-esc="props.companies[0].name" selected="1"/>
            <option t-foreach="props.companies.slice(1)" t-as="company" t-key="company_index" t-att-value="company.id" t-esc="company.name"/>
            <option value="0">All Companies</option>
        </select>
    </t>

    `);
registerTemplate("social.AddStreamMedia", `/social/static/src/xml/social_templates.xml`, `<div t-name="social.AddStreamMedia" class="o_social_media_cards d-flex flex-wrap" xml:space="preserve">
        <t t-foreach="props.socialMedia" t-as="media" t-key="media_index">
            <div class="o_social_media card text-center justify-content-center align-items-center me-3 mb-3 p-3" t-att-data-media-id="media.id" style="width: 90px;" t-on-click.prevent="_onClickSocialMedia">
                <img width="48" height="48" t-attf-src="/web/image/social.media/{{ media.id }}/image/48x48"/>
                <h5 t-esc="media.name" class="o_social_media_name mb-0 mt-2"/>
            </div>
        </t>
    </div>



    `);
registerTemplate("social.ImagesCarouselDialog", `/social/static/src/xml/social_templates.xml`, `<t t-name="social.ImagesCarouselDialog" xml:space="preserve">
        <Dialog title="props.title" footer="false" bodyClass="'bg-900'" withBodyPadding="false">
            <t t-set="multi_images" t-value="props.images.length &gt; 1"/>
            <div id="o_stream_post_images_carousel" t-attf-class="o_stream_post_images_carousel carousel slide {{ multi_images ? 'o_stream_post_images_carousel_multi' : '' }}" data-bs-interval="false">
                <ol t-if="multi_images" class="carousel-indicators">
                    <t t-foreach="props.images" t-as="image_url" t-key="image_url">
                        <li data-bs-target="#o_stream_post_images_carousel" t-att-data-bs-slide-to="image_url_index" t-attf-class="{{ image_url_index === props.activeIndex ? 'active' : '' }}"/>
                    </t>
                </ol>
                <div class="carousel-inner h-100 d-flex align-items-center justify-content-center">
                    <t t-foreach="props.images" t-as="image_url" t-key="image_url">
                        <div t-attf-class="carousel-item m-0 w-auto {{ image_url_index === props.activeIndex ? 'active' : '' }}">
                            <img t-att-src="image_url" class="shadow" alt="Image Url"/>
                        </div>
                    </t>
                </div>
                <a t-if="multi_images" class="carousel-control-prev" href="#o_stream_post_images_carousel" role="button" data-bs-slide="prev">
                    <span class="carousel-control-prev-icon"/>
                    <span class="visually-hidden">Previous</span>
                </a>
                <a t-if="multi_images" class="carousel-control-next" href="#o_stream_post_images_carousel" role="button" data-bs-slide="next">
                    <span class="carousel-control-next-icon"/>
                    <span class="visually-hidden">Next</span>
                </a>
            </div>
        </Dialog>
    </t>



    `);
registerTemplate("social.KanbanHeader", `/social/static/src/xml/social_templates.xml`, `<t t-name="social.KanbanHeader" t-inherit="web.KanbanHeader" xml:space="preserve">
        <xpath expr="//div[hasclass('o_column_title')]" position="before">
            <img t-if="group.groupByField.name === 'stream_id'" height="20" t-attf-src="/web/image/social.stream/{{ group.value }}/media_image/20x20" class="o_kanbanheader_media_image mr8"/>
        </xpath>
    </t>

    `);
registerTemplate("StreamPostKanbanView.buttons", `/social/static/src/xml/social_templates.xml`, `<div t-name="StreamPostKanbanView.buttons" t-inherit="web.KanbanView.Buttons" xml:space="preserve">
        <xpath expr="//div[hasclass('o_cp_buttons')]" position="inside">
            <button type="button" class="btn btn-primary o_stream_post_kanban_new_stream me-1" t-on-click.prevent="_onNewStream">
                Add Stream
            </button>
            <button t-if="hasAccounts" type="button" class="btn btn-primary o_stream_post_kanban_new_post me-1" t-on-click.prevent="_onNewPost">
                New Post
            </button>
            <button t-if="hasAccounts" type="button" class="btn btn-secondary o_stream_post_kanban_refresh_now" t-att-disabled="state.disableSyncButton" t-on-click.prevent="_onRefreshStats">
                <span>Sync</span>
                <i t-if="state.disableSyncButton" class="fa fa-circle-o-notch fa-spin mx-1 align-middle"/>
                <i t-else="" class="fa fa-refresh mx-1 align-middle"/>
            </button>
        </xpath>
    </div>

    `);
registerTemplate("social.SocialKanbanView", `/social/static/src/xml/social_templates.xml`, `<t t-name="social.SocialKanbanView" t-inherit="web.KanbanView" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//Layout" position="attributes">
            <attribute name="className">model.useSampleModel ? 'o_view_sample_data o_social_stream_post_kanban_view_wrapper'
                : 'o_social_stream_post_kanban_view_wrapper'</attribute>
        </xpath>
        <xpath expr="//t[@t-component='props.Renderer']" position="before">
            <NewContentRefreshBanner refreshRequired="state.refreshRequired" onClickRefresh.bind="_refreshView"/>
            <StreamPostDashboard accounts="accounts" isSocialManager="isSocialManager"/>
        </xpath>
    </t>

    `);
registerTemplate("social.NewContentRefreshBanner", `/social/static/src/xml/social_templates.xml`, `<t t-name="social.NewContentRefreshBanner" xml:space="preserve">
        <a class="o_social_stream_post_kanban_new_content alert alert-info mb-0 text-center border-bottom py-2" t-att-class="{'d-none': !props.refreshRequired}" href="#" t-on-click="props.onClickRefresh">
            New content available
            <i class="fa fa-refresh ms-2 me-1"/>
            <b>Click to refresh.</b>
        </a>
    </t>

    `);
registerTemplate("social.KanbanDashboard", `/social/static/src/xml/social_templates.xml`, `<t t-name="social.KanbanDashboard" xml:space="preserve">
        <section class="o_social_stream_post_kanban_before d-flex flex-nowrap border-bottom" t-ref="dashboard">
            <div t-foreach="props.accounts" t-as="socialAccount" t-key="socialAccount_index" class="o_social_stream_stat_box flex-shrink-0 w-auto d-flex flex-column bg-view border-bottom border-end">
                <div class="pt-3 pb-2 px-4 d-flex justify-content-between">
                    <div class="d-flex align-items-center">
                        <img class="me-2" height="20" t-attf-src="/web/image/social.media/{{ socialAccount.media_id[0] }}/image/20x20" alt="Social Media"/>
                        <h5 class="o_social_stream_post_author_name d-block text-truncate m-0" t-esc="socialAccount.name" t-att-title="socialAccount.name"/>
                    </div>
                    <div class="d-flex align-items-center ms-4">
                        <a t-if="socialAccount.stats_link" t-att-href="socialAccount.stats_link" class="small" target="_blank">
                            Insights
                        </a>
                        <t t-set="connecting_problem_content">It appears there is an issue with the Social Media link, click here to link the account again</t>
                        <a t-if="socialAccount.is_media_disconnected" href="#" class="o_social_account_link_disconnected text-danger ms-4" t-att-data-media-id="socialAccount.media_id[0]" data-bs-toggle="popover" title="Connecting Problem" t-att-data-bs-content="connecting_problem_content" t-on-click.prevent="_onRelinkAccount">
                            <i class="fa fa-unlink"/>
                        </a>
                    </div>
                </div>

                <div class="d-flex flex-nowrap flex-grow-1 px-4 pt-2 pb-3">
                    <t t-set="audience_content">Number of Followers of your channel</t>
                    <div t-if="_hasAudience(socialAccount)" class="d-flex align-items-center flex-grow-1 pe-3" data-bs-toggle="popover" title="Audience" t-att-data-bs-content="audience_content">
                        <t t-call="social.AccountsStatsValue">
                            <t t-set="icon" t-value="'fa-bullseye'"/>
                            <t t-set="value" t-value="socialAccount.audience"/>
                            <t t-set="trend" t-value="socialAccount.audience_trend"/>
                        </t>
                    </div>
                    <t t-set="engagement_content">Number of times people have engaged with your posts (likes, comments, shares,...)</t>
                    <div t-if="_hasEngagement(socialAccount)" t-attf-class="d-flex align-items-center justify-content-center flex-grow-1 {{ _hasStories(socialAccount) ? 'px-3' : 'ps-3' }}" data-bs-toggle="popover" title="Engagement" t-att-data-bs-content="engagement_content">
                        <t t-call="social.AccountsStatsValue">
                            <t t-set="icon" t-value="'fa-hand-o-up'"/>
                            <t t-set="value" t-value="socialAccount.engagement"/>
                            <t t-set="trend" t-value="socialAccount.engagement_trend"/>
                        </t>
                    </div>
                    <t t-if="_hasStories(socialAccount)">
                        <t t-set="stories_content">Number of times people who have engaged with your channel have created stories on their friends' or followers' feed (Shares, Reposts...)</t>
                        <div class="d-flex align-items-center justify-content-end flex-grow-1 ps-3" data-bs-toggle="popover" title="Stories" t-att-data-bs-content="stories_content">
                            <t t-call="social.AccountsStatsValue">
                                <t t-set="icon" t-value="'fa-book'"/>
                                <t t-set="value" t-value="socialAccount.stories"/>
                                <t t-set="trend" t-value="socialAccount.stories_trend"/>
                            </t>
                        </div>
                    </t>
                </div>
            </div>
        </section>
    </t>

    `);
registerTemplate("social.AccountsStatsValue", `/social/static/src/xml/social_templates.xml`, `<t t-name="social.AccountsStatsValue" xml:space="preserve">
        <div class="d-flex align-items-center">
            <i t-attf-class="text-600 me-1 fa {{icon}}" style="line-height: 1"/>
            <b class="social_account_stat_value" t-esc="formatStatValue(value)" style="line-height: 1"/>
            <t t-if="socialAccount.has_trends">
                <t t-set="isNeutral" t-value="trend == 0"/>
                <t t-set="isUp" t-value="trend &gt; 0"/>
                <small t-attf-class="ms-2 fw-bold {{ isNeutral? '' : isUp ? 'text-success' : 'text-danger' }}" style="line-height: 1">
                    <t t-esc="trend"/>%
                    <t t-if="!isNeutral"><i t-attf-class="fa fa-caret-{{ isUp ? 'up' : 'down' }}" style="line-height: 1"/></t>
                </small>
            </t>
        </div>
    </t>
`);
registerTemplate("approvals.ApprovalsCategoryKanbanView.Buttons", `/approvals/static/src/views/kanban/approvals_category_kanban_controller.xml`, `<t t-name="approvals.ApprovalsCategoryKanbanView.Buttons" xml:space="preserve">
        <button type="button" class="btn btn-primary" t-on-click="OpenNewApprovalRequest">
            New Request
        </button>
    </t>
`);
registerTemplateExtension("mail.ActivityListPopoverItem", `/approvals/static/src/web/activity/activity_list_popover_item_patch.xml`, `<t t-inherit="mail.ActivityListPopoverItem" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//button[hasclass('o-mail-ActivityListPopoverItem-markAsDone')]" position="after">
            <Approval t-if="props.activity.approval" activity="this.props.activity" onChange="this.props.onActivityChanged"/>
        </xpath>
    </t>

`);
registerTemplateExtension("mail.Activity", `/approvals/static/src/web/activity/activity_patch.xml`, `<t t-inherit="mail.Activity" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//t[@name='tools']" position="replace">
            <Approval t-if="props.activity.approval" activity="props.activity" onChange="props.reloadParentView"/>
            <t t-else="">$0</t>
        </xpath>
    </t>

`);
registerTemplate("approvals.Approval", `/approvals/static/src/web/activity/approval.xml`, `<t t-name="approvals.Approval" xml:space="preserve">
        <div t-if="props.activity.approval.status === 'pending'">
            <t t-if="props.activity.user_id[0] === store.self.userId">
                <button class="btn btn-success btn-link ps-0 pt-0" t-on-click="onClickApprove">
                    <i class="fa fa-check"/> Approve
                </button>
                <button class="btn btn-danger btn-link pt-0" t-on-click="onClickRefuse">
                    <i class="fa fa-times"/> Refuse
                </button>
            </t>
            <span t-else="" class="text-warning ps-0 pt-0">
                <i class="fa fa-pencil"/> To Approve
            </span>
        </div>
    </t>

`);
registerTemplate("marketing_automation.MarketingActivityGraph", `/marketing_automation/static/src/xml/marketing_automation_graph.xml`, `<t t-name="marketing_automation.MarketingActivityGraph" xml:space="preserve">
        <div class="o_ma_activity_graph w-100">
            <div class="o_graph_canvas_container w-100">
                <canvas t-ref="canvas"/>
            </div>
        </div>
    </t>

`);
registerTemplate("marketing_automation.HierarchyKanbanRenderer", `/marketing_automation/static/src/xml/marketing_automation_one2many.xml`, `<t t-name="marketing_automation.HierarchyKanbanRenderer" t-inherit="web.KanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-else='']/KanbanRecord" position="attributes">
            <attribute name="getRecordDepth.bind">getRecordDepth</attribute>
        </xpath>
    </t>

`);
registerTemplate("marketing_automation.CampaignTemplatePickerDialog", `/marketing_automation/static/src/components/campaign_template_picker_dialog/campaign_template_picker_dialog.xml`, `<t t-name="marketing_automation.CampaignTemplatePickerDialog" xml:space="preserve">
        <Dialog size="'lg'" title.translate="Create a Marketing Automation Campaign" bodyClass="'o_ma_campaign_template_picker_dialog px-0 pt-0 pb-3 h-100'">
            <div class="d-sm-flex">
                <div class="d-flex flex-column flex-grow-1 min-w-0">
                    <div class="py-4 container">
                        <p class="mb-0">
                            Create one or load a template prepared by our experts.<br/>
                            Then sit down and let Odoo handle the rest!
                        </p>
                    </div>
                    <Notebook pages="notebookPages"/>
                </div>
            </div>
            <t t-set-slot="footer">
                <button t-on-click="onLoadTemplate" class="btn btn-primary o_ma_campaign_picker_create" data-hotkey="c">Create Campaign</button>
                <button t-on-click="props.close" class="btn btn-light o_ma_campaign_picker_discard" data-hotkey="x">Discard</button>
            </t>
        </Dialog>
    </t>

    `);
registerTemplate("marketing_automation.CampaignTemplatePickerDialogSheet", `/marketing_automation/static/src/components/campaign_template_picker_dialog/campaign_template_picker_dialog.xml`, `<t t-name="marketing_automation.CampaignTemplatePickerDialogSheet" xml:space="preserve">
        <div class="o_ma_campaign_picker_page cursor-pointer row mx-0 pt-2">
            <div t-foreach="props.templates" t-as="template" t-key="template" class="col-12 col-lg-4 py-2">
                <div class="o_ma_campaign_picker_card card rounded p-1 d-flex align-items-stretch h-100 " t-att-class="{'o_ma_campaign_picker_active': this.props.activeTemplate.name == template}" t-on-click="() =&gt; this.props.setActive(template)">
                    <div class="row m-0 w-100 h-100">
                        <div class="col-2 p-0 d-flex align-items-center justify-content-center">
                            <div class="o_ma_campaign_picker_icon d-flex align-items-center justify-content-center display-3 text-muted">
                                <img t-attf-src="{{template_value.icon}}" t-attf-alt="{{template_value.title}}" aria-hidden="true" class="img-fluid mx-auto"/>
                            </div>
                        </div>
                        <div class="col-10 col-lg-10 p-0">
                            <div class="card-body d-flex flex-column align-items-start justify-content-center h-100 p-0">
                                <h3 class="card-title" t-out="template_value.title"/>
                                <p class="card-text" t-out="template_value.description"/>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("im_livechat.ColorsResetButton", `/im_livechat/static/src/js/colors_reset_button/colors_reset_button.xml`, `<t t-name="im_livechat.ColorsResetButton" xml:space="preserve">
        <button class="btn btn-link oe_edit_only" t-on-click="onColorsResetButtonClick" aria-label="Reset to default colors" title="Reset to default colors">
            <span class="fa fa-refresh mb-4"/>
        </button>
    </t>

`);
registerTemplate("im_livechat.KanbanRecordMenu", `/im_livechat/static/src/views/livechat_channel_kanban/livechat_channel_kanban_menu.xml`, `<t t-name="im_livechat.KanbanRecordMenu" t-inherit="web.KanbanRecordMenu" xml:space="preserve">
        <xpath expr="//Dropdown" position="attributes">
            <attribute name="position">'bottom-start'</attribute>
            <attribute name="menuClass" add="\` rounded-0 \${props.record.data.available_operator_ids.count &gt; 0 ? 'o-livechat-ChannelKanban-highlighted': ''}\`" separator="+"/>
        </xpath>
        <xpath expr="//Dropdown/button" position="attributes">
            <attribute name="class" add="bg-transparent px-2" separator=" "/>
        </xpath>
    </t>
`);
registerTemplateExtension("discuss.ChannelInvitation", `/im_livechat/static/src/core/web/channel_invitation_patch.xml`, `<t t-inherit="discuss.ChannelInvitation" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@name='selectablePartnerDetail']" position="replace">
            <t t-if="props.thread.channel_type !== 'livechat' or !selectablePartner.lang_name">$0</t>
            <div t-else="" class="d-flex flex-column flex-grow-1">
                <t>$0</t>
                <span class="mx-2 text-truncate text-start fs-6">
                    <i class="fa fa-comment-o me-1" aria-label="Lang"/>
                    <t t-esc="selectablePartner.lang_name"/>
                </span>
            </div>
        </xpath>
    </t>
`);
registerTemplateExtension("discuss.channel_member", `/im_livechat/static/src/core/web/channel_member_list_patch.xml`, `<t t-inherit="discuss.channel_member" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[@t-ref='displayName']" position="inside">
                <div t-if="member.thread.channel_type === 'livechat'" class="ms-2 d-flex flex-wrap">
                    <span t-if="member.getLangName()" class="me-2">
                        <i class="fa fa-comment-o me-1" aria-label="Lang"/>
                        <t t-esc="member.getLangName()"/>
                    </span>
                    <span t-if="member.persona?.country or props.thread.anonymous_country">
                        <i class="fa fa-globe me-1" aria-label="country"/>
                        <t t-esc="member.persona?.country?.name ?? props.thread.anonymous_country.name"/>
                    </span>
                </div>
        </xpath>
    </t>
`);
registerTemplate("im_livechat.LivechatChannelCommand", `/im_livechat/static/src/core/web/command_palette.xml`, `<t t-name="im_livechat.LivechatChannelCommand" xml:space="preserve">
        <div class="o_command_default d-flex align-items-center justify-content-between px-4 py-2">
            <i class="me-2" t-att-class="props.iconClass"/>
            <span class="flex-grow-1 text-ellipsis">
                <t t-slot="name"/>
            </span>
        </div>
    </t>
`);
registerTemplateExtension("mail.Composer", `/im_livechat/static/src/core/web/composer_patch.xml`, `<t t-name="im_livechat.Composer" t-inherit="mail.Composer" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//Typing" position="replace">
            <div class="d-flex justify-content-between align-items-center w-100">
                <div class="d-flex">$0</div>
                <span t-if="displayNextLivechatHint() and !env.inChatWindow" class="text-muted fst-italic form-text">Tab to next livechat</span>
            </div>
        </xpath>
    </t>
`);
registerTemplateExtension("calendar.AttendeeCalendarController", `/appointment/static/src/views/appointment_calendar/appointment_calendar_controller.xml`, `<t t-name="appointment.CalendarController" t-inherit="calendar.AttendeeCalendarController" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('o_calendar_header')]" position="inside">
            <div class="o_appointment_scheduling_box position-fixed position-md-static start-0 bottom-0 d-flex align-items-center justify-content-center gap-2 order-last order-lg-0" t-att-class="{ 'flex-lg-row flex-column' : this.appointmentState.lastAppointment.id || this.hasSlotEvents() }">
                <t t-if="env.calendarState.mode === 'slots-creation' || appointmentState.lastAppointment.url">
                    <span t-if="appointmentState.lastAppointment.url and !appointmentState.lastAppointment.waitingCopyLinkCustomType" class="text-center">
                        <i class="fa fa-check text-success" role="img" aria-label="Link copied to your clipboard!"/> Link copied to your clipboard!
                    </span>
                    <b t-else="">
                        Pick your availabilities
                    </b>
                    <div class="d-flex align-items-center gap-1 flex-wrap">
                        <button class="o_appointment_get_link btn btn-primary flex-fill text-nowrap" t-att-class="{ 'd-none': !this.appointmentState.lastAppointment.id and !this.hasSlotEvents() }" title="Get Share Link" aria-label="Get Share Link" t-on-click="onClickGetShareLink" t-ref="copyLinkRef">
                            <i class="fa fa-copy me-1" role="img" aria-label="Copy Link"/>Copy Link
                        </button>
                        <button class="o_appointment_open_form btn btn-secondary flex-fill text-nowrap" t-att-class="{ 'd-none': !this.appointmentState.lastAppointment.id and !this.hasSlotEvents() }" aria-label="Configure" t-on-click="onClickOpenForm">
                            <i class="fa fa-cog me-1" role="img" aria-label="Configure"/>Configure
                        </button>
                        <button class="o_appointment_discard_slots btn btn-light flex-fill" aria-label="Discard" t-on-click="onClickDiscard">
                                <i class="oi oi-close" role="img" aria-label="Discard"/>
                        </button>
                    </div>
                </t>
                <div t-else="" class="btn-group w-100 w-sm-auto mx-2 mx-sm-0 px-0">
                    <t t-set="appointments" t-value="appointmentState.data.appointment_types_info"/>
                    <button t-if="isAppointmentUser" t-on-click="onClickSelectAvailabilities" class="btn btn-secondary o_appointment_select_slots" aria-label="Share Availabilities" title="Share Availabilities">
                        Share Availabilities
                    </button>

                    <div class="btn-group">
                        <Dropdown t-if="isAppointmentUser or (!isAppointmentUser and appointments.length)">
                            <button t-if="isAppointmentUser" class="btn btn-secondary dropdownAppointmentLink o-dropdown-caret"/>
                            <button t-else="" class="btn btn-secondary dropdownAppointmentLink">Share Appointment Link</button>
                            <t t-set-slot="content">
                                <button t-if="isAppointmentUser" t-on-click="onClickSelectAvailabilities" class="o_appointment_select_slots dropdown-item">
                                    <span class="align-bottom">Propose Slots</span>
                                </button>
                                <button t-if="isAppointmentUser" t-on-click="onClickSearchCreateAnytimeAppointment" class="o_appointment_button_link o_appointment_search_create_anytime_appointment dropdown-item">
                                    <span class="align-bottom">Share Calendar</span>
                                </button>
                                <button t-on-click="onClickCustomLink" class="dropdown-item">
                                    <span class="align-bottom">Custom Link</span>
                                </button>
                                <div t-if="appointments.length &gt; 0" role="separator" class="dropdown-divider"/>
                                <t t-foreach="appointments" t-as="appointment" t-key="appointment.id">
                                    <button t-att-title="appointment.name" t-on-click.stop.prevent="() =&gt; this.onClickGetAppointmentUrl(appointment.id)" class="o_appointment_button_link o_appointment_appointment_link_clipboard dropdown-item text-truncate">
                                        <span class="align-bottom" t-out="appointment.name"/>
                                    </button>
                                </t>
                            </t>
                        </Dropdown>
                    </div>
                </div>
            </div>
        </xpath>
    </t>
`);
registerTemplate("appointment.FormViewDialog.buttons", `/appointment/static/src/views/custom_appointment_form_dialog/custom_appointment_form_dialog.xml`, `<t t-name="appointment.FormViewDialog.buttons" t-inherit="web.FormViewDialog.ToOne.buttons" xml:space="preserve">
        <xpath expr="//button[contains(@class, 'o_form_button_save')]" position="replace">
            <button class="btn btn-primary o_form_button_save" t-on-click="onClickSaveAndCopy" data-hotkey="q">
            <i class="fa fa-copy me-1" role="img" aria-label="Save and Copy Link"/> Save &amp; Copy Link
            </button>
        </xpath>
    </t>
`);
registerTemplate("AppointmentTypeKanbanView.buttons", `/appointment/static/src/views/kanban/kanban_controller.xml`, `<t t-name="AppointmentTypeKanbanView.buttons" t-inherit="web.KanbanView.Buttons" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_cp_buttons')]" position="inside">
            <button t-on-click="onClickShareAppointmentLink" class="btn btn-secondary">Share</button>
        </xpath>
    </t>
`);
registerTemplate("appointment.AppointmentTypeKanbanRecordMenu", `/appointment/static/src/views/kanban/kanban_record.xml`, `<t t-name="appointment.AppointmentTypeKanbanRecordMenu" t-inherit="web.KanbanRecordMenu" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//Dropdown" position="attributes">
            <attribute name="menuClass" add="' min-w-0'" separator="+"/>
        </xpath>
        <xpath expr="//div[hasclass('o_dropdown_kanban')]" position="attributes">
            <attribute name="class" add="appointment_type_action_toggler visible" separator=" "/>
        </xpath>
        <xpath expr="//span[hasclass('fa-ellipsis-v')]" position="after">
            <span class="text-large appointment_type_action_toggler_text d-none">Action</span>
        </xpath>
        <xpath expr="//span[hasclass('fa-ellipsis-v')]" position="replace">
            <span class="fa fa-cog mx-1 d-none d-sm-inline-block"/>
            <span class="fa fa-ellipsis-v m-2 d-sm-none"/>
        </xpath>
    </t>
`);
registerTemplate("appointment.AppointmentTypeKanbanRenderer", `/appointment/static/src/views/kanban/kanban_renderer.xml`, `<t t-name="appointment.AppointmentTypeKanbanRenderer" t-inherit="web.KanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <t t-call="web.ActionHelper" position="replace">
            <t t-if="showNoContentHelper">
                <AppointmentTypeActionHelper/>
            </t>
        </t>
    </t>
`);
registerTemplate("appointment.AppointmentBookingListRenderer", `/appointment/static/src/views/list/list_renderer.xml`, `<t t-name="appointment.AppointmentBookingListRenderer" t-inherit="web.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div/table" position="before">
            <button t-if="isAppointmentManager" class="o_appointment_booking_list_button_add_leaves btn btn-primary mx-3 mt-2" t-att-class="{'btn-sm btn-link p-1': env.isSmall}" t-on-click="onClickAddLeave">Add Closing Day(s)</button>
        </xpath>
    </t>

    `);
registerTemplate("appointment.AppointmentTypeListRenderer", `/appointment/static/src/views/list/list_renderer.xml`, `<t t-name="appointment.AppointmentTypeListRenderer" t-inherit="web.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <t t-call="web.ActionHelper" position="replace">
            <t t-if="showNoContentHelper">
                <AppointmentTypeActionHelper/>
            </t>
        </t>
    </t>
`);
registerTemplate("appointment.AppointmentInviteCopyClose", `/appointment/static/src/components/appointment_invite/appointment_invite_copy_close.xml`, `<t t-name="appointment.AppointmentInviteCopyClose" xml:space="preserve">
        <a role="button" class="o_appointment_invite_copy_save btn btn-primary flex-grow-1" t-on-click="onSaveAndCopy" t-att-class="{disabled:this.props.record.data.disable_save_button}">
            Copy Link &amp; Close</a>
    </t>
`);
registerTemplate("appointment.AppointmentSyncButton", `/appointment/static/src/components/appointment_sync_button/appointment_sync_button.xml`, `<t t-name="appointment.AppointmentSyncButton" xml:space="preserve">
        <a t-on-click="onConnectCalendar" role="button" class="o_appointment_sync_btn btn btn-sm bg-transparent border-info d-flex align-items-center">
            <img t-att-src="props.iconSrc"/>
            <small>Connect<span class="ms-1" t-out="props.calendarName"/></small>
        </a>
    </t>
`);
registerTemplate("appointment.AppointmentTypeActionHelper", `/appointment/static/src/components/appointment_type_action_helper/appointment_type_action_helper.xml`, `<t t-name="appointment.AppointmentTypeActionHelper" xml:space="preserve">
        <div class="o_view_nocontent o_appointment_helper align-items-start align-items-md-stretch">
            <div class="container">
                <div class="o_activity_not_found o_nocontent_help container text-center">
                    <h1 class="fw-normal">Ready to make scheduling easy?</h1>
                    <div class="lead fw-normal">
                        <p class="mb-0">Create a Schedule from scratch or use one of our templates:</p>
                    </div>
                </div>

                <div class="o_appointment_helper_templates justify-content-center row cursor-pointer mt-4">
                    <t t-set="templateNames" t-value="Object.keys(appointmentTypeTemplateData)"/>
                    <t t-foreach="templateNames" t-as="templateName" t-key="templateName">
                        <t t-set="templateInfo" t-value="appointmentTypeTemplateData[templateName]"/>
                        <div class="col-12 col-md-6 col-lg-4 col-xl-3 py-2" t-on-click.stop.prevent="() =&gt; this.onTemplateClick(templateInfo)">
                            <div class="o_appointment_helper_template card rounded row flex-row h-100 p-3 pt-4 g-0">
                                <img class="col-3 col-md-4 col-lg-3 h-50 px-1 p-0" t-attf-src="{{templateInfo.icon}}" t-attf-alt="{{templateInfo.title}}"/>
                                <div class="col-9 col-md-8 col-lg-9 card-body d-flex flex-column py-0">
                                    <h3 class="card-title text-break" t-out="templateInfo.title"/>
                                    <p class="card-text" t-out="templateInfo.description"/>
                                </div>
                            </div>
                        </div>
                    </t>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("survey.DescriptionPageField", `/survey/static/src/question_page/description_page_field.xml`, `<t t-name="survey.DescriptionPageField" t-inherit="web.CharField" xml:space="preserve">
        <xpath expr="//t[@t-else='']" position="replace">
            <t t-else="">
                <div class="input-group">
                    <t t-call="web.CharField"/>
                    <button type="button" title="Open section" class="btn oe_edit_only o_icon_button" t-on-click.stop="onExternalBtnClick">
                        <i class="fa fa-fw o_button_icon fa-external-link"/>
                    </button>
                </div>
            </t>
        </xpath>
        <xpath expr="//span[@t-esc='formattedValue']" position="after">
            <t t-if="props.record.data.is_page">
                <i class="fa fa-fw o_button_icon fa-pencil"/>
            </t>
        </xpath>
    </t>

`);
registerTemplate("survey.surveyQuestionTrigger", `/survey/static/src/views/widgets/survey_question_trigger/survey_question_trigger.xml`, `<t t-name="survey.surveyQuestionTrigger" xml:space="preserve">
        <button t-if="this.props.record.data.triggering_question_ids.records.length" disabled="disabled" t-ref="survey_question_trigger" class="btn btn-link px-1 py-0 pe-auto" t-att-class="this.state.surveyIconWarning ? 'opacity-100' : 'icon_rotates'">
            <i class="fa fa-fw o_button_icon " t-att-class="this.state.surveyIconWarning ? 'fa-exclamation-triangle text-warning' : 'fa-code-fork'" t-att-data-tooltip="this.state.triggerTooltip"/>
        </button>
    </t>

`);
registerTemplate("project_todo.TodoChatterPanel", `/project_todo/static/src/components/todo_chatter_panel/todo_chatter_panel.xml`, `<div t-name="project_todo.TodoChatterPanel" t-ref="root" xml:space="preserve">
        <chatter t-if="state.displayChatter" class="o_FormRenderer_chatterContainer">
            <Chatter threadModel="'project.task'" threadId="props.record.resId" webRecord="props.record" hasParentReloadOnAttachmentsChanged="true" hasParentReloadOnFollowersUpdate="true" hasParentReloadOnMessagePosted="true" saveRecord="props.record.save.bind(props.record, { reload: false })"/>
        </chatter>
    </div>

`);
registerTemplate("project_todo.TodoDoneCheckmark", `/project_todo/static/src/components/todo_done_checkmark/todo_done_checkmark.xml`, `<t t-name="project_todo.TodoDoneCheckmark" xml:space="preserve">
        <t t-if="!env.isSmall">
            <a t-att-title="stateDone.isDone ? 'Mark as to-do' : 'Mark as done'" t-on-click.stop="onDoneToggled" t-on-mouseleave="actualizeDoneState" t-on-mouseover="freezeDoneState" t-attf-class="o_todo_done_button fa fa-lg fa-check-circle{{!stateDone.isDone ? '-o' : ' done_button_enabled'}}"/>
        </t>
        <t t-else="">
            <a t-att-title="stateDone.isDone ? 'Mark as to-do' : 'Mark as done'" t-on-click.stop="onDoneToggled" t-attf-class="o_todo_done_button_mobile fa fa-lg fa-check-circle{{!stateDone.isDone ? '-o' : ' done_button_enabled'}}"/>
        </t>
    </t>

`);
registerTemplate("project_todo.TodoFormControlPanel", `/project_todo/static/src/views/todo_form/todo_form_control_panel.xml`, `<t t-name="project_todo.TodoFormControlPanel" t-inherit="web.ControlPanel" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_cp_pager')]" position="before">
            <a t-if="!env.isSmall" role="button" title="Toggle chatter" data-hotkey="d" t-attf-class="btn btn-light btn-chatter todo_toggle_chatter #{state.displayChatter ? 'active' : '' }" t-on-click="toggleChatter">
                <i class="fa fa-comments"/>
            </a>
        </xpath>
    </t>

`);
registerTemplate("hr_skills.SkillsListRenderer", `/hr_skills/static/src/fields/skills_one2many/skills_one2many.xml`, `<t t-name="hr_skills.SkillsListRenderer" t-inherit-mode="primary" t-inherit="web.ListRenderer" xml:space="preserve">
        <xpath expr="//table" position="attributes">
            <attribute name="t-attf-class" add="mb-1 {{ !isEditable ? 'cursor-default' : '' }} {{ !showTable ? 'd-none' : ''}} o_skill_table" separator=" "/>
        </xpath>
        <xpath expr="//thead" position="attributes">
            <attribute name="style">visibility: collapse;</attribute>
        </xpath>
        <xpath expr="//table" position="before">
            <div name="skills_header" class="text-uppercase fw-bolder small ms-3" style="margin-top: 2rem; box-shadow: 0 1px 0 #e6e6e6">
                Skills
                <a t-if="!isEmpty &amp;&amp; showTimeline" t-on-click="openSkillsReport" class="float-end me-3 cursor-pointer">
                    <span class="fa fa-line-chart me-1"/>
                    Timeline
                </a>
            </div>
        </xpath>
        <xpath expr="//table" position="after">
            <t t-if="!showTable">
                <t t-if="!anySkills">
                    <div name="no_skills" class="ms-3 mt-3">
                        <p>
                            There are no skills defined in the library.<br/>
                            Why not try adding some ?
                        </p>
                        <button t-on-click="skillTypesAction" class="btn btn-secondary ms-4 mt-3 text-center" role="button" t-if="isEditable">
                            Create new Skills
                        </button>
                    </div>
                </t>
                <t t-else="">
                    <div name="skills_available" class="ms-3 mt-3">
                        <p class="mt-3">You can add skills from our library to the employee profile.<br/>
                        If skills are missing, they can be created by an HR officer.</p>
                        <div class="ms-5">
                             <button t-on-click="props.onAdd" class="btn btn-secondary ms-4 mt-3 text-center" role="button" t-if="isEditable">
                                Pick a skill from the list
                            </button>
                        </div>
                    </div>
                </t>
            </t>
        </xpath>
    </t>

    `);
registerTemplate("hr_skills.SkillsListRenderer.Rows", `/hr_skills/static/src/fields/skills_one2many/skills_one2many.xml`, `<t t-name="hr_skills.SkillsListRenderer.Rows" xml:space="preserve">
        <t t-foreach="Object.entries(groupedList)" t-as="skill_group" t-key="skill_group[0]">
            <tr class="o_group_has_content o_group_header">
                <th tabindex="-1" class="o_group_name" t-att-colspan="colspan">
                    <div class="d-flex justify-content-between align-items-center">
                        <span t-esc="skill_group[1].name"/>
                        <button class="btn btn-secondary btn-sm" t-if="isEditable" t-on-click="() =&gt; props.onAdd({ context: { default_skill_type_id: skill_group[1].id }})" role="button">ADD</button>
                    </div>
                </th>
            </tr>
            <t t-foreach="skill_group[1].list.records" t-as="record" t-key="record.id">
                <t t-set="group" t-value="skill_group[1]"/>
                <t t-call="{{ constructor.recordRowTemplate }}"/>
            </t>
        </t>
    </t>
`);
registerTemplate("hr_skills.X2ManyFieldDialog", `/hr_skills/static/src/fields/form_view_one2many/form_view_one2many.xml`, `<t t-name="hr_skills.X2ManyFieldDialog" t-inherit="web.X2ManyFieldDialog" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//button[hasclass('o_form_button_save')]" position="replace">
            <button class="btn btn-primary o_form_button_save" t-on-click="() =&gt; this.save()" data-hotkey="c">Select &amp; Close</button>
        </xpath>
        <xpath expr="//button[hasclass('o_form_button_save_new')]" position="replace">
            <button class="btn btn-primary o_form_button_save_new" t-on-click="saveAndNew" data-hotkey="n">Select &amp; New</button>
        </xpath>
    </t>
`);
registerTemplate("hr_skills.SkillsTagsList", `/hr_skills/static/src/fields/hr_skills_tags_list/hr_skills_tags_list.xml`, `<t t-name="hr_skills.SkillsTagsList" t-inherit="web.TagsList" xml:space="preserve">
        <xpath expr="//span[contains(@class, &quot;o_tag&quot;)]" position="attributes">
            <attribute name="t-attf-class" add="{{ getTextStyle(tag) ? 'border border-2' : '' }}" separator=" "/>
            <attribute name="t-attf-style" add="{{ getTextStyle(tag) ? 'border-color: rgb(140, 140, 140) !important ;' : ''}}" separator=" "/>
        </xpath>
        <xpath expr="//div[contains(@class, &quot;o_tag_badge_text&quot;)]" position="attributes">
            <attribute name="t-attf-class" add="{{ getTextStyle(tag) ? 'fw-bold' : '' }}" separator=" "/>
        </xpath>
    </t>

`);
registerTemplate("hr_skills.ResumeListRenderer", `/hr_skills/static/src/fields/resume_one2many/resume_one2many.xml`, `<t t-name="hr_skills.ResumeListRenderer" t-inherit-mode="primary" t-inherit="hr_skills.SkillsListRenderer" xml:space="preserve">
        <xpath expr="//table" position="attributes">
            <attribute name="t-attf-class" add="table-borderless {{ !showTable ? 'd-none' : ''}}" remove="table-striped" separator=" "/>
        </xpath>
        <xpath expr="//table" position="after">
            <t t-if="!showTable">
                <div name="no_resume_line" class="ms-3 mt-3">
                    <p>
                        There are no resume lines on this employee.
                        Why not add a new one?
                    </p>
                </div>
                <button t-on-click="props.onAdd" class="btn btn-secondary ms-4 mt-3" role="button" t-if="isEditable">
                    Create a new entry
                </button>
            </t>
        </xpath>
        <xpath expr="//div[@name='skills_header']" position="replace"/>
        <xpath expr="//thead/tr" position="replace">
            <tr>
                <th style="width: 32px; min-width: 32px;"/>
                <th class="w-100"/>
                <th t-if="isEditable" class="o_list_actions_header" style="width: 32px; min-width: 32px"/>
            </tr>
        </xpath>
        <xpath expr="//div[@name='no_skills']" position="replace"/>
    </t>

    `);
registerTemplate("hr_skills.ResumeListRenderer.Rows", `/hr_skills/static/src/fields/resume_one2many/resume_one2many.xml`, `<t t-name="hr_skills.ResumeListRenderer.Rows" t-inherit-mode="primary" t-inherit="hr_skills.SkillsListRenderer.Rows" xml:space="preserve">
        <xpath expr="//tr" position="attributes">
            <attribute name="class" add="o_resume_group_header" separator=" "/>
        </xpath>
        <xpath expr="//th[hasclass('o_group_name')]" position="after">
            <th/>
        </xpath>
    </t>

    `);
registerTemplate("hr_skills.ResumeListRenderer.RecordRow", `/hr_skills/static/src/fields/resume_one2many/resume_one2many.xml`, `<t t-name="hr_skills.ResumeListRenderer.RecordRow" t-inherit-mode="primary" t-inherit="web.ListRenderer.RecordRow" xml:space="preserve">
        <xpath expr="//t[@t-foreach='getColumns(record)']" position="replace">
            <t t-set="data" t-value="record.data"/>
            <t t-if="data.display_type === 'classic'" id="row">
                <td class="o_resume_timeline_cell position-relative pe-lg-2">
                    <div class="rounded-circle bg-info position-relative"/>
                </td>
                <td class="o_data_cell pt-0" t-on-click="(ev) =&gt; this.onCellClicked(record, null, ev)">
                    <div t-attf-class="o_resume_line {{data.display_type == 'certification' ? 'o_resume_line_display_certification' : ''}}" t-att-data-id="id">
                        <small class="o_resume_line_dates fw-bold">
                            <t t-out="formatDate(data.date_start)"/> -
                            <t t-if="data.date_end" t-out="formatDate(data.date_end)"/>
                            <t t-else="">Current</t>
                        </small>
                        <h4 class="o_resume_line_title mt-2" t-esc="data.name"/>
                        <p t-if="data.description" class="o_resume_line_desc" t-out="data.description" t-ref="link-target-blank"/>
                    </div>
                </td>
            </t>
        </xpath>
    </t>
`);
registerTemplate("hr_resume_data_row", `/hr_skills/static/src/xml/resume_templates.xml`, `<t t-name="hr_resume_data_row" xml:space="preserve">
    <tr class="o_data_row cursor-default" t-attf-class="o_data_row #{is_last? 'o_data_row_last' : ''}" t-att-data-id="id">
        <t t-if="data.display_type === 'classic'">
            <td class="o_resume_timeline_cell position-relative pe-lg-2">
                <div class="rounded-circle bg-info position-relative"/>
            </td>
            <td class="o_data_cell pt-0 w-100">
                <div class="o_resume_line" t-att-data-id="id">
                    <small class="o_resume_line_dates">
                        <b t-esc="data.date_start"/> - <b t-esc="data.date_end"/>
                    </small>
                    <h4 class="o_resume_line_title mt-2" t-esc="data.name"/>
                    <p t-if="data.description" class="o_resume_line_desc" t-esc="data.description"/>
                </div>
            </td>
        </t>
    </tr>
</t>

`);
registerTemplate("hr_trash_button", `/hr_skills/static/src/xml/resume_templates.xml`, `<t t-name="hr_trash_button" xml:space="preserve">
    <td class="o_list_record_remove pe-3">
        <button name="delete" arial-label="Delete row" class="btn btn-link text-danger">
            <i class="fa fa-trash"/>
        </button>
    </td>
</t>

`);
registerTemplate("hr_resume_group_row", `/hr_skills/static/src/xml/resume_templates.xml`, `<t t-name="hr_resume_group_row" xml:space="preserve">
    <tr class="o_resume_group_header">
        <td class="o_group_name" colspan="100%"><span class="o_horizontal_separator my-0" t-esc="display_name"/></td>
    </tr>
</t>

`);
registerTemplate("group_add_item", `/hr_skills/static/src/xml/resume_templates.xml`, `<t t-name="group_add_item" xml:space="preserve">
    <t t-set="empty" t-value="Object.keys(context).length == 2"/>

    <div t-attf-class="o_field_x2many_list_row_add #{empty? 'd-block w-100' : 'd-inline float-end'}">
        <a href="#" role="button" t-attf-class="btn btn-secondary o-kanban-button-new #{empty? 'btn-primary mt-3' : 'btn-secondary btn-sm'}" t-attf-data-context="{{ context }}">
                <t t-if="empty">CREATE A NEW ENTRY</t>
                <t t-else="">ADD</t>
            </a>
    </div>
</t>


`);
registerTemplate("hr_skill_data_row", `/hr_skills/static/src/xml/skills_templates.xml`, `<t t-name="hr_skill_data_row" xml:space="preserve">
    <tr class="o_data_row cursor-default" t-att-data-id="id">
        <td class="o_data_cell o_skill_cell w-100">
            <t t-esc="data.skill_id.data.display_name"/>
        </td>
        <td class="o_data_cell o_skill_cell pe-3">
            <t t-esc="data.skill_level_id.data.display_name"/>
        </td>
    </tr>
</t>

`);
registerTemplate("hr_default_group_row", `/hr_skills/static/src/xml/skills_templates.xml`, `<t t-name="hr_default_group_row" xml:space="preserve">
    <tr class="o_group_header o_group_has_content">
        <td class="o_group_name border-0 pe-2" colspan="99">
            <b t-esc="display_name"/>
        </td>
    </tr>
</t>


`);
registerTemplateExtension("resource_mail.AvatarCardResourcePopover", `/hr_skills/static/src/components/avatar_card_resource/avatar_card_resource_popover.xml`, `<t t-inherit="resource_mail.AvatarCardResourcePopover" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('o_card_user_infos')]" position="inside">
            <div t-if="skills?.length" class="d-flex align-items-start pt-1">
                <i class="fa fa-fw fa-graduation-cap me-1" data-tooltip="Skills"/>
                <div class="d-flex flex-wrap gap-1 o_employee_skills_tags overflow-hidden">
                    <TagsList tags="skillTags" visibleItemsLimit="5"/>
                </div>
            </div>
        </xpath>
        <xpath expr="//div[hasclass('o_avatar_card_buttons')]" position="attributes">
            <attribute t-if="skills?.length" name="class" add="pt-1" separator=" "/>
        </xpath>
    </t>
`);
registerTemplate("hr_work_entry.work_entry_button", `/hr_work_entry/static/src/xml/work_entry_templates.xml`, `<t t-name="hr_work_entry.work_entry_button" xml:space="preserve">
        <button t-if="disabled" disabled="" title="Solve conflicts first" t-attf-class="btn {{primary?'btn-primary':'btn-secondary'}} btn-work-entry {{ event_class }}" type="button" t-esc="button_text"/>
        <button t-else="" t-attf-class="btn {{primary?'btn-primary':'btn-secondary'}} btn-work-entry {{ event_class }}" type="button" t-esc="button_text"/>
    </t>
`);
registerTemplate("hr_contract.ContractWarningTooltip", `/hr_contract/static/src/widgets/tooltip_warning_widget.xml`, `<t t-name="hr_contract.ContractWarningTooltip" xml:space="preserve">
        <span class="fa fa-exclamation-triangle text-danger o_calendar_warning" data-tooltip-template="hr_contract.CalendarMismatch" t-att-data-tooltip-info="tooltipInfo"/>
    </t>
`);
registerTemplate("hr_contract.CalendarMismatch", `/hr_contract/static/src/xml/hr_contract_templates.xml`, `<t t-name="hr_contract.CalendarMismatch" xml:space="preserve">
        <p class="o-tooltip--help" t-esc="text"/>
    </t>
`);
registerTemplate("hr_work_entry_contract.WorkEntrySourceField", `/hr_work_entry_contract/static/src/components/work_entry_source_field/work_entry_source_field.xml`, `<t t-name="hr_work_entry_contract.WorkEntrySourceField" t-inherit="web.RadioField" xml:space="preserve">
        <xpath expr="//input[hasclass('o_radio_input')]" position="attributes">
            <attribute name="t-att-disabled">props.readonly or (item[0] === 'calendar' and isFullyFlexible)</attribute>
        </xpath>

        <xpath expr="//div[hasclass('o_radio_item')]" position="inside">
            <span t-if="props.readonly or (item[0] === 'calendar' and item[0] === value and isFullyFlexible)" class="fa fa-exclamation-triangle text-danger o_work_entry_source_warning ms-3" data-tooltip-template="hr_work_entry_contract.WorkEntrySourceWarning" t-att-data-tooltip-info="tooltipWarning"/>
        </xpath>

    </t>
`);
registerTemplate("hr_work_entry_contract.calendar.controlButtons", `/hr_work_entry_contract/static/src/views/work_entry_calendar/work_entry_calendar.xml`, `<t t-name="hr_work_entry_contract.calendar.controlButtons" t-inherit="web.CalendarController.controlButtons" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="." position="inside">
            <span class="btn-regenerate-work-entries">
                <button class="btn btn-secondary ms-3" t-on-click="onRegenerateWorkEntries">
                    Regenerate Work Entries
                </button>
            </span>
        </xpath>
    </t>
`);
registerTemplate("hr_work_entry_contract.WorkEntrySourceWarning", `/hr_work_entry_contract/static/src/xml/hr_work_entry_source_templates.xml`, `<t t-name="hr_work_entry_contract.WorkEntrySourceWarning" xml:space="preserve">
        <div class="o-tooltip px-1 py-2">
            <p style="font-size: 12px;" class="text-danger" t-esc="text"/>
        </div>
    </t>
`);
registerTemplate("hr_payroll.AddPayslips", `/hr_payroll/static/src/components/add_payslips/add_payslips.xml`, `<t t-name="hr_payroll.AddPayslips" xml:space="preserve">
        <button class="btn btn-secondary" t-on-click="() =&gt; this.onAddPayslips()">
            <t t-esc="props.string"/>
        </button>
    </t>
`);
registerTemplate("hr_payroll.ActionBox", `/hr_payroll/static/src/components/dashboard/action_box/action_box.xml`, `<t t-name="hr_payroll.ActionBox" xml:space="preserve">
        <div class="o_hr_payroll_dashboard_block card h-100">
            <div class="card-header bg-view border-0">
                <h2 class="card-title">
                    Warnings
                </h2>
            </div>
            <t t-if="this.state.loading">
                <div class="position-absolute top-0 bottom-0 start-0 end-0 d-flex align-items-center justify-content-center">
                    <i class="fa fa-3x fa-spin fa-spinner mx-auto text-o-color-2"/>
                </div>
            </t>
            <t t-else="">
                <div class="list-group list-group-flush">
                    <t t-foreach="this.state.warnings" t-as="action" t-key="action_index">
                        <a t-if="action.count &gt; 0" class="list-group-item list-group-item-action row d-flex justify-content-between align-items-center g-0" href="#" t-on-click="() =&gt; this.actionService.doAction(action.action)">
                            <span class="col-1 text-end" t-out="action.count"/>
                            <div class="col-10" t-attf-class="o_colorlist_warning_color_#{action.color}">
                                <t t-esc="action.string"/>
                            </div>
                        </a>
                    </t>
                </div>
            </t>
        </div>
    </t>
`);
registerTemplate("hr_payroll.Dashboard", `/hr_payroll/static/src/components/dashboard/payroll_dashboard.xml`, `<t t-name="hr_payroll.Dashboard" xml:space="preserve">
        <div class="o_hr_payroll_dashboard_sheet container-fluid h-100 overflow-auto m-2 m-md-3 p-0">
            <div class="row g-0 g-lg-3 h-lg-100">
                <div class="col-12 col-lg-7 row p-0 pe-3 pe-lg-0 m-0 h-100">
                    <div class="row g-0 g-md-3 mt-0 h-100 pe-0 ">
                        <div class="col-12 col-md-6 mb-3 mb-md-0 o_payroll_dashboard_panel">
                            <PayrollDashboardActionBox actions="dashboardData.actions"/>
                        </div>
                        <div class="col-12 col-md-6 mb-3 mb-md-0 o_payroll_dashboard_panel">
                            <PayrollDashboardPayslipBatch batches="dashboardData.batches"/>
                        </div>
                        <t t-set="stats" t-value="dashboardData.stats"/>
                        <t t-foreach="stats" t-as="stat" t-key="stat.id" t-if="stats &amp;&amp; stats.length &gt; 0">
                            <div class="col-12 col-md-6 mb-2 o_payroll_dashboard_panel">
                                <PayrollDashboardStats t-props="stat"/>
                            </div>
                        </t>
                    </div>
                </div>
                <div class="col-12 col-lg-5 h-100 m-0 pt-2 pt-md-3 pe-md-3 ps-0">
                    <PayrollDashboardTodo orderBy="[{name: 'id', asc: true}]"/>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("hr_payroll.DashboardStats", `/hr_payroll/static/src/components/dashboard/payroll_stats/payroll_stats.xml`, `<t t-name="hr_payroll.DashboardStats" xml:space="preserve">
        <div class="o_hr_payroll_dashboard_block o_hr_payroll_dashboard_block_stats card d-flex align-items-stretch flex-column h-100">
            <div class="card-header d-flex flex-wrap justify-content-between align-items-center w-100 border-0 bg-view">
                <h2 class="card-title" t-out="props.title"/>
                <i class="fa fa-question-circle-o" t-if="props.help" data-tooltip-template="hr_payroll.Tooltip" t-att-data-tooltip-info="tooltipInfo"/>
                <div class="d-flex" id="period_selection_toggle">
                    Annually
                    <div class="o_boolean_toggle cursor-pointer form-check form-switch o_switch_toggle ms-2" t-on-click.stop.prevent="toggle">
                        <input type="checkbox" class="form-check-input" role="switch" t-att-checked="state.monthly"/>
                    </div>
                    Monthly
                </div>
            </div>
            <div class="card-body d-flex flex-column justify-content-between">
                <t t-foreach="props.actions" t-as="action" t-key="action_index">
                    <a t-if="action.count &gt; 0" class="d-flex w-100" href="#" t-on-click="() =&gt; this.actionService.doAction(action.action)">
                        <span class="me-1" t-out="action.count"/>
                        <t t-esc="action.string"/>
                    </a>
                </t>
                <div t-att-class="'canvas-container mt-auto d-flex align-items-end ' + (props.type === 'line' ? 'payroll_line' : 'payroll_bar')">
                    <canvas t-ref="canvas" class="w-100"/>
                </div>
            </div>
        </div>
    </t>

    `);
registerTemplate("hr_payroll.Tooltip", `/hr_payroll/static/src/components/dashboard/payroll_stats/payroll_stats.xml`, `<t t-name="hr_payroll.Tooltip" xml:space="preserve">
        <div class="o-tooltip px-2 py-1">
            <p t-out="help"/>
        </div>
    </t>
`);
registerTemplate("hr_payroll.PayslipBatch", `/hr_payroll/static/src/components/dashboard/payslip_batch/payslip_batch.xml`, `<t t-name="hr_payroll.PayslipBatch" xml:space="preserve">
        <div class="o_hr_payroll_dashboard_block o_hr_payroll_dashboard_batches h-100 card m-auto">
            <div class="card-header border-0 d-flex justify-content-between align-items-center bg-view">
                <h2 class="card-title">
                    Batches
                </h2>
                <a class="btn btn-link" t-on-click="onClickTitle">
                    All
                </a>
            </div>
            <ul class="list-group list-group-flush">
                <a t-foreach="props.batches" t-as="batch" t-key="batch.id" class="list-group-item list-group-item-action d-flex justify-content-start align-items-center" href="#" t-on-click="() =&gt; this.onClickLine(batch.id, batch.name)">
                    <div t-att-class="'badge rounded-pill o_readonly_modifier o_required_modifier o_field_widget fs-6 ' + this.getColorFromState(batch.state)">
                        <t t-out="batch.state"/>
                    </div>
                    <div class="o_hr_payroll_dashboard_batch text-end mw-75 ms-auto p-0">
                        <t t-esc="batch.name" class="mw-100"/> <br/> <span t-esc="batch.payslip_count" class="text-nowrap"/>
                    </div>
                </a>
            </ul>
        </div>
        </t>
`);
registerTemplate("hr_payroll.TodoList", `/hr_payroll/static/src/components/dashboard/todo_list/todo_list.xml`, `<t t-name="hr_payroll.TodoList" xml:space="preserve">
        <div class="o_hr_payroll_dashboard_block o_hr_payroll_dashboard_todo card h-100 g-0 d-flex flex-column ms-md-1 ms-lg-0 me-3 me-lg-4 position-relative">
            <div class="card-header d-flex bg-view border-bottom-0 p-0 bg-view">
                <ul class="o_hr_payroll_todo_tabs nav nav-tabs flex-nowrap overflow-x-auto w-100 border-bottom-0 border-start-0">
                    <t t-foreach="state.records" t-as="rec" t-key="rec.id">
                        <t t-set="isActiveNote" t-value="rec.id === state.activeNoteId"/>
                        <li class="o_hr_payroll_todo_tab nav-item flex-shrink-0 border-end  cursor-pointer" t-att-class="((isActiveNote) ? '' : ' border-bottom ')" t-on-click="() =&gt; this.onClickNoteTab(rec)" t-on-dblclick="() =&gt; this.startNameEdition(rec)">
                            <a t-attf-class="mb-0 nav-link text-dark {{ (isActiveNote) ? 'd-flex align-items-center justify-content-between gap-2 active border-0 border-odoo border-top ' : '' }}">
                                <t t-if="state.isEditingNoteName &amp;&amp; isActiveNote">
                                    <input type="text" t-ref="autofocus" t-att-value="this.bufferedText" t-on-input="onInputNoteNameInput" t-on-keydown="onKeyDownNoteNameInput" t-on-blur="handleBlur" class="o_input"/>
                                </t>
                                <t t-else="">
                                    <t t-esc="(rec.name || 'untitled').substring(0, 30)"/>
                                    <button type="button" class="btn p-0" aria-label="Close" t-if="isActiveNote" t-on-click="onNoteDelete">
                                        <i class="oi oi-close"/>
                                    </button>
                                </t>
                            </a>
                        </li>
                    </t>
                    <li class="flex-grow-1 border-bottom border-end order-2"/>
                </ul>
                <button class="o_hr_payroll_todo_tab o_hr_payroll_todo_create btn d-flex align-items-center border-bottom rounded-0" t-on-click="onClickCreateNote">
                    <i title="Create new todo note" class="fa fa-plus"/>
                </button>
            </div>

            <div class="card-body content overflow-hidden">
                <div class="o_hr_payroll_todo_value overflow-auto h-100">
                    <Record t-if="state.activeNoteId" resModel="recordInfo.model" fieldNames="['note']" resId="state.activeNoteId" t-slot-scope="data" mode="'edit'" onRecordChanged.bind="onRecordChanged">
                        <Field name="'note'" record="data.record" class="'h-100'" isCollaborative="true"/>
                    </Record>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplateExtension("hr_work_entry_contract.calendar.controlButtons", `/hr_payroll/static/src/views/work_entry_calendar/work_entry_calendar.xml`, `<t t-name="hr_payroll.calendar.controlButtons" t-inherit="hr_work_entry_contract.calendar.controlButtons" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="." position="inside">
            <button t-if="getShowGeneratePayslipsButton()" t-att-disabled="checkConflicts()" class="btn btn-primary btn-payslip-generate ms-3" t-on-click="onGeneratePayslips">
                Generate Payslips
            </button>
        </xpath>
    </t>
`);
registerTemplate("website_hr_recruitment.CopyJobLinkButton", `/website_hr_recruitment/static/src/js/widgets/copy_link_menuitem.xml`, `<t t-name="website_hr_recruitment.CopyJobLinkButton" xml:space="preserve">
        <CopyButtonJob content="props.record.data[props.name]" copyText="copyText" successText="successText"/>
    </t>

    `);
registerTemplate("website_hr_recruitment.CopyButtonJob", `/website_hr_recruitment/static/src/js/widgets/copy_link_menuitem.xml`, `<t t-name="website_hr_recruitment.CopyButtonJob" xml:space="preserve">
        <a t-ref="button" role="button" class="oe_kanban_action" t-on-click.stop="onClick">
            <span t-esc="props.copyText"/>
        </a>
    </t>
`);
registerTemplate("website_hr_recruitment.BooleanToggleFieldLabeled", `/website_hr_recruitment/static/src/fields/boolean_toggle_labeled_field.xml`, `<t t-name="website_hr_recruitment.BooleanToggleFieldLabeled" t-inherit="web.BooleanToggleField" xml:space="preserve">
        <xpath expr="//CheckBox" position="inside">
            <label invisible="1" string="Published"/>
            <label invisible="1" string="Not Published"/>
            <t t-out="this.state.label"/>
        </xpath>
    </t>

`);
registerTemplate("stock_account.BooleanToggleConfirm", `/stock_account/static/src/fields/boolean_confirm.xml`, `<t t-name="stock_account.BooleanToggleConfirm" xml:space="preserve">
        <ConfirmCheckBox className="'o_field_boolean o_boolean_toggle'" id="props.id" value="props.record.data[props.name] or false" disabled="isReadonly" onChange="(value) =&gt; this.onChange(value)"/>
    </t>
`);
registerTemplateExtension("stock.ForecastedHeader", `/stock_account/static/src/stock_account_forecasted/forecasted_header.xml`, `<t t-name="stock_account.ForecastedHeader" t-inherit="stock.ForecastedHeader" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//h6[@name='product_variants']" position="after">
            <h6 t-if="() =&gt; env.user.has_group('stock.group_stock_manager')">
                Value On Hand:
                <a href="#" t-out="props.docs.value" t-on-click.prevent="_onClickValuation"/>
            </h6>
        </xpath>
    </t>
`);
registerTemplate("account_reports.AccountReport", `/account_reports/static/src/components/account_report/account_report.xml`, `<t t-name="account_reports.AccountReport" xml:space="preserve">
        <t t-call="{{ env.template('AccountReport') }}"/>
    </t>

    `);
registerTemplate("account_reports.AccountReportCustomizable", `/account_reports/static/src/components/account_report/account_report.xml`, `<t t-name="account_reports.AccountReportCustomizable" xml:space="preserve">
        <div class="o_action account_report" t-att-class="cssCustomClass" t-ref="root">
            <ControlPanel>

                <t t-set-slot="control-panel-create-button">
                    <AccountReportButtonsBar/>
                </t>
                <t t-set-slot="control-panel-additional-actions">
                    <AccountReportCogMenu/>
                </t>


                <t t-set-slot="layout-actions">
                   <div class="d-flex gap-1 flex-wrap">
                       <t t-if="controller.options.search_bar">
                           <AccountReportSearchBar initialQuery="initialQuery"/>
                           <br/>
                       </t>
                       <t t-component="env.component('AccountReportFilters')"/>
                   </div>
                </t>
            </ControlPanel>

            <div class="o_content">

                <t t-if="controller.options.sections.length">
                    <div id="section_selector" class="section_selector">
                        <t t-foreach="controller.options.sections" t-as="section" t-key="section_index">
                            <button t-att-class="(controller.options.selected_section_id === section.id) ? 'btn btn-secondary' : 'btn btn-primary'" t-on-click="() =&gt; controller.switchToSection(section.id)" t-out="section.name"/>
                        </t>

                        <t t-if="controller.options['has_inactive_sections']">
                            <button class="btn btn-secondary" t-on-click="(ev) =&gt; controller.reportAction(ev, 'action_display_inactive_sections')">+</button>
                        </t>
                    </div>
                </t>


                <t t-if="controller.warnings">
                    <div id="warnings" class="warnings d-print-none">
                        <t t-foreach="controller.warnings" t-as="warningTemplateRef" t-key="warningTemplateRef">
                            <t t-set="warningParams" t-value="controller.warnings[warningTemplateRef]"/>

                            <div t-att-class="\`alert alert-\${warningParams['alert_type'] || 'info'} text-center\`">
                                <t t-call="{{ warningTemplateRef }}"/>
                            </div>
                        </t>
                    </div>
                </t>

                <t t-if="controller.lines.length">

                    <div class="mx-auto fit-content w-print-100">
                        <div class="d-flex align-items-start">
                            <t t-foreach="controller.options['horizontal_split'] ? ['left', 'right'] : [null]" t-as="splitSide" t-key="splitSide">
                                <table class="table table-borderless table-hover w-print-100" t-att-class="tableClasses">
                                    <t t-component="env.component('AccountReportHeader')"/>
                                    <tbody>
                                        <t t-foreach="controller.lines" t-as="line" t-key="line.id">
                                            <t t-if="!splitSide || splitSide === (line.horizontal_split_side || 'left')">

                                                <t t-if="controller.areLinesOrdered()">
                                                    <t t-set="orderedIndex" t-value="controller.linesOrder[line_index]"/>
                                                    <t t-set="orderedLine" t-value="controller.lines[orderedIndex]"/>

                                                    <t t-component="env.component('AccountReportLine')" t-props="{ lineIndex: orderedIndex, line: orderedLine }"/>
                                                </t>
                                                <t t-else="">
                                                    <t t-component="env.component('AccountReportLine')" t-props="{ lineIndex: line_index, line: line }"/>
                                                </t>
                                            </t>
                                        </t>
                                    </tbody>
                                </table>
                            </t>
                        </div>
                    </div>
                </t>
                <t t-else="">

                    <div class="o_view_nocontent">
                        <div class="o_nocontent_help">
                            <p class="o_view_nocontent_neutral_face">No data to display !</p>
                            <p>There is no data to display for the given filters.</p>
                        </div>
                    </div>
                </t>
            </div>
        </div>
    </t>
`);
registerTemplate("account_reports.AccountReportButtonsBar", `/account_reports/static/src/components/account_report/buttons_bar/buttons_bar.xml`, `<t t-name="account_reports.AccountReportButtonsBar" xml:space="preserve">
        <t t-if="controller.buttons.length">
            <t t-foreach="barButtons" t-as="barButton" t-key="barButton_index">
                <button t-att-class="'btn text-nowrap' + (barButton.disabled ? ' disabled' : '') + (barButton_first ? ' btn-primary' : ' btn-secondary')" t-on-click="(ev) =&gt; controller.buttonAction(ev, barButton)">
                    <t t-out="barButton.name"/>
                </button>
            </t>
        </t>
    </t>
`);
registerTemplate("account_reports.AccountReportCogMenu", `/account_reports/static/src/components/account_report/cog_menu/cog_menu.xml`, `<t t-name="account_reports.AccountReportCogMenu" xml:space="preserve">
        <t t-if="cogButtons.length">
            <Dropdown>
                <button class="btn p-0 ms-1 border-0">
                    <i class="fa fa-fw fa-cog"/>
                </button>
                <t t-set-slot="content">
                    <t t-foreach="cogButtons" t-as="cogButton" t-key="cogButton_index">
                        <DropdownItem onSelected="(ev) =&gt; controller.buttonAction(ev, cogButton)">
                            <t t-out="cogButton.name"/>
                        </DropdownItem>
                    </t>
                </t>
            </Dropdown>
        </t>
    </t>
`);
registerTemplate("account_reports.AccountReportEllipsis", `/account_reports/static/src/components/account_report/ellipsis/ellipsis.xml`, `<t t-name="account_reports.AccountReportEllipsis" xml:space="preserve">
        <t t-call="{{ env.template('AccountReportEllipsis') }}"/>
    </t>

    `);
registerTemplate("account_reports.AccountReportEllipsisCustomizable", `/account_reports/static/src/components/account_report/ellipsis/ellipsis.xml`, `<t t-name="account_reports.AccountReportEllipsisCustomizable" xml:space="preserve">
        <t t-if="props.type === 'string'">
            <div class="name">
                <t t-out="(props.name) ? props.name.substring(0, props.maxCharacters) : ''"/>
            </div>

            <t t-if="triggersEllipsis">
                <button class="btn btn_ellipsis" t-on-click="(ev) =&gt; this.showEllipsisPopover(ev)">
                    <i class="fa fa-ellipsis-h"/>
                </button>
            </t>
        </t>
        <t t-else="">
            <div class="name">
                <t t-out="props.name"/>
            </div>
        </t>
    </t>
`);
registerTemplate("account_reports.AccountReportEllipsisPopover", `/account_reports/static/src/components/account_report/ellipsis/popover/ellipsis_popover.xml`, `<t t-name="account_reports.AccountReportEllipsisPopover" xml:space="preserve">
        <div class="account_report_popover_ellipsis">
            <p t-out="props.name"/>
            <button class="btn account_report_btn_clone" t-on-click="() =&gt; props.copyEllipsisText()">
                <i class="fa fa-clone"/>
            </button>
        </div>
    </t>
`);
registerTemplate("account_reports.AccountReportFilterAccountType", `/account_reports/static/src/components/account_report/filters/filter_account_type.xml`, `<t t-name="account_reports.AccountReportFilterAccountType" xml:space="preserve">
        <Dropdown>
            <button class="btn btn-secondary">
                <i class="fa fa-user me-1"/>Account: <t t-out="selectedAccountType"/>
            </button>

            <t t-set-slot="content">
                <t t-foreach="controller.options.account_type" t-as="accountTypeItem" t-key="accountTypeItem_index">
                    <DropdownItem class="{ selected: accountTypeItem.selected }" onSelected="() =&gt; this.filterClicked({ optionKey: 'account_type.' + accountTypeItem_index + '.selected', reload: true})" closingMode="'none'" t-out="accountTypeItem.name"/>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AccountReportAmlIrFilters", `/account_reports/static/src/components/account_report/filters/filter_aml_ir_filters.xml`, `<t t-name="account_reports.AccountReportAmlIrFilters" xml:space="preserve">
        <Dropdown>
            <button class="btn btn-secondary">
                <i class="fa fa-star me-1"/>Filters: <t t-out="selectedAmlIrFilters"/>
            </button>

            <t t-set-slot="content">
                <t t-foreach="controller.options.aml_ir_filters" t-as="amlIrFilter" t-key="amlIrFilter_index">
                    <DropdownItem class="{ 'selected': amlIrFilter.selected }" onSelected="() =&gt; this.filterClicked({ optionKey: 'aml_ir_filters.' + amlIrFilter_index + '.selected', reload: true})" closingMode="'none'" t-out="amlIrFilter.name"/>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AccountReportFilterAnalytic", `/account_reports/static/src/components/account_report/filters/filter_analytic.xml`, `<t t-name="account_reports.AccountReportFilterAnalytic" xml:space="preserve">
        <Dropdown menuClass="'account_report_filter analytic'">
            <button class="btn btn-secondary">
                <i class="fa fa-filter me-1"/>Analytic
            </button>

            <t t-set-slot="content">
                <div class="dropdown-item gap-2 align-items-center">
                    <label>Accounts</label>
                    <MultiRecordSelector t-props="getMultiRecordSelectorProps('account.analytic.account', 'analytic_accounts')"/>
                </div>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AccountReportFilterAnalyticGroupby", `/account_reports/static/src/components/account_report/filters/filter_analytic_groupby.xml`, `<t t-name="account_reports.AccountReportFilterAnalyticGroupby" xml:space="preserve">
        <Dropdown menuClass="'account_report_filter analytic_groupby'">
            <button class="btn btn-secondary">
                <i class="oi oi-group me-1"/>Analytic
            </button>

            <t t-set-slot="content">
                <div class="dropdown-item gap-2 align-items-center">
                    <label>Accounts</label>
                    <MultiRecordSelector t-props="getMultiRecordSelectorProps('account.analytic.account', 'analytic_accounts_groupby')"/>
                </div>

                <div class="dropdown-item gap-2 align-items-center">
                    <label>Plans</label>
                    <MultiRecordSelector t-props="getMultiRecordSelectorProps('account.analytic.plan', 'analytic_plans_groupby')"/>
                </div>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AccountReportFilterBudget", `/account_reports/static/src/components/account_report/filters/filter_budgets.xml`, `<t t-name="account_reports.AccountReportFilterBudget" xml:space="preserve">
        <Dropdown navigationOptions="dropdownProps">
            <button class="btn btn-secondary">
                <i class="fa fa-bar-chart me-1"/>Budget
            </button>

            <t t-set-slot="content">
                <t t-foreach="controller.options.budgets" t-as="budget" t-key="budget_index">
                    <div class="o-dropdown-item dropdown-item o-navigable d-flex justify-content-between ps-4 pe-1" t-att-class="{ 'selected': budget.selected }" t-on-click="() =&gt; this.selectBudget(budget)">
                        <span t-out="budget.name"/>
                        <button class="btn p-0 px-1" t-on-click.prevent.stop="() =&gt; controller.openBudget(budget)">
                            <i class="fa fa-pencil"/>
                        </button>
                    </div>
                </t>

                <div class="dropdown-divider"/>

                <t t-if="controller.options.budgets.filter(x =&gt; x.selected).length &gt; 0">
                    <DropdownItem class="{ 'filter_show_all_accounts_hook': true, 'selected': controller.options.show_all_accounts }" onSelected="() =&gt; this.filterClicked({ optionKey: 'show_all_accounts', reload: true})" closingMode="'none'">
                        Show All Accounts
                    </DropdownItem>
                </t>

                <div class="o-dropdown-item dropdown-item d-flex align-items-center ps-4 pe-1">
                    <input class="o_input" t-att-class="{ 'o_field_invalid': budgetName.invalid }" type="text" placeholder="Budget Name" t-model="budgetName.value"/>
                    <button class="btn btn-link" data-hotkey="s" t-on-click="createBudget">
                        Create
                    </button>
                </div>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AccountReportComparisonPeriod", `/account_reports/static/src/components/account_report/filters/filter_comparison.xml`, `<t t-name="account_reports.AccountReportComparisonPeriod" xml:space="preserve">
        <div t-att-class="(controller.options.comparison.filter !== filter) ? 'invisible' : ''">
            <input min="1" type="number" t-att-value="controller.options.comparison.number_period" t-on-change="(ev) =&gt; this.setNumberPeriods(ev)"/>
            <label>
                <t t-out="periodLabel"/>
            </label>
        </div>
    </t>

    `);
registerTemplate("account_reports.AccountReportFilterComparison", `/account_reports/static/src/components/account_report/filters/filter_comparison.xml`, `<t t-name="account_reports.AccountReportFilterComparison" xml:space="preserve">
        <Dropdown menuClass="'account_report_filter comparison'" navigationOptions="dropdownProps">
            <button class="btn btn-secondary">
                <i class="fa fa-percent me-1"/>
                <span>Comparison</span>
                <t t-if="controller.options.comparison.string">
                    <span>: </span>
                    <t t-if="controller.options.comparison.filter === 'previous_period'">
                        <t t-if="controller.options.comparison.number_period === 1">
                            <span>Previous Period</span>
                        </t>
                        <t t-elif="controller.options.comparison.number_period &gt; 1">
                            <t t-esc="\`\${ controller.options.comparison.number_period } \`"/>
                            <span>Previous Periods</span>
                        </t>
                    </t>
                    <t t-elif="controller.options.comparison.filter === 'same_last_year'">
                        <t t-if="controller.options.comparison.number_period === 1">
                            <span>Previous Year</span>
                        </t>
                        <t t-elif="controller.options.comparison.number_period &gt; 1">
                            <t t-esc="\`\${ controller.options.comparison.number_period } \`"/>
                            <span>Previous Years</span>
                        </t>
                    </t>
                    <t t-else="">
                        <t t-esc="\`\${ controller.options.comparison.string }\`"/>
                    </t>
                </t>
            </button>

            <t t-set-slot="content">
                <DropdownItem class="{ 'selected': (controller.options.comparison.filter === 'no_comparison') }" onSelected="() =&gt; this.filterClicked({ optionKey: 'comparison.filter', optionValue: 'no_comparison', reload: true})" closingMode="'none'">
                    No Comparison
                </DropdownItem>

                <DropdownItem class="{ 'selected': controller.options.comparison.filter === 'previous_period', 'dropdown-item': true, 'period': true }" onSelected="() =&gt; this.filterClicked({ optionKey: 'comparison.filter', optionValue: 'previous_period', reload: true})" closingMode="'none'">
                    <label class="d-flex align-items-center">
                        Previous Period
                    </label>

                    <t t-call="account_reports.AccountReportComparisonPeriod">
                        <t t-set="filter" t-value="'previous_period'"/>
                    </t>
                </DropdownItem>

                <DropdownItem class="{ 'selected': controller.options.comparison.filter === 'same_last_year', 'dropdown-item': true, 'period': true }" attrs="{ 'name': 'filter_comparison_same_period_last_year' }" onSelected="() =&gt; this.filterClicked({ optionKey: 'comparison.filter', optionValue: 'same_last_year', reload: true})" closingMode="'none'">
                    <label class="d-flex align-items-center">
                        Same Period Last Year
                    </label>

                    <t t-call="account_reports.AccountReportComparisonPeriod">
                        <t t-set="filter" t-value="'same_last_year'"/>
                    </t>
                </DropdownItem>

                <t t-if="controller.options.date.mode === 'range'">
                    <DropdownItem class="{ 'selected': controller.options.comparison.filter === 'custom', 'dropdown-item': true, 'date': true }" attrs="{ 'name': 'filter_comparison_custom' }" onSelected="() =&gt; this.filterClicked({ optionKey: 'comparison.filter', optionValue: 'custom'})" closingMode="'none'">
                        <label class="d-flex align-items-center">
                            Custom Dates
                        </label>

                        <div class="d-flex flex-row" t-att-class="(controller.options.comparison.filter !== 'custom') ? 'invisible' : ''">
                            <DateTimeInput type="'date'" value="dateFrom('comparison')" onChange="(dateFrom) =&gt; this.setDateFrom('comparison', dateFrom)"/>
                            <label class="d-flex align-items-center">
                                to
                            </label>
                            <DateTimeInput type="'date'" value="dateTo('comparison')" onChange="(dateTo) =&gt; this.setDateTo('comparison', dateTo)"/>
                        </div>
                    </DropdownItem>
                </t>

                <t t-if="controller.options.date.mode === 'single'">
                    <DropdownItem class="{ 'selected': controller.options.comparison.filter === 'custom', 'dropdown-item': true, 'date': true }" onSelected="() =&gt; this.filterClicked({ optionKey: 'comparison.filter', optionValue: 'custom'})" closingMode="'none'">
                        <label class="d-flex align-items-center">
                            Specific Date
                        </label>

                        <div t-att-class="(controller.options.comparison.filter !== 'custom') ? 'invisible' : ''">
                            <DateTimeInput type="'date'" value="dateTo('comparison')" onChange="(dateTo) =&gt; this.setDateTo('comparison', dateTo)"/>
                        </div>
                    </DropdownItem>
                </t>

                <div class="dropdown-divider"/>

                <div class="dropdown-item period order">
                    <label class="d-flex align-items-center pe-none">
                        Period order
                    </label>

                    <div>
                        <select name="select_order" class="o_input pe-3" t-on-change="(ev) =&gt; this.filterClicked({ optionKey: 'comparison.period_order', optionValue: ev.target.value, reload: true})">
                            <option t-foreach="availablePeriodOrder" t-as="order" t-key="order_index" t-att-value="order" t-att-selected="availablePeriodOrder[order] === periodOrder" t-out="availablePeriodOrder[order]"/>
                        </select>
                    </div>
                </div>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AccountReportFilterDateSelection", `/account_reports/static/src/components/account_report/filters/filter_date.xml`, `<t t-name="account_reports.AccountReportFilterDateSelection" xml:space="preserve">
        <t t-foreach="this.dateFilters(controller.options.date.mode)" t-as="dateFilter" t-key="dateFilter_index">
            <DropdownItem class="{ 'd-flex justify-content-between date_filter': true, 'selected': (this.isPeriodSelected(dateFilter.period)) }" onSelected="() =&gt; this.selectDateFilter(dateFilter.period, dateFilter.period != controller.options.date.period_type)" closingMode="'none'">
                <div class="filter_name pe-3">
                    <t t-out="dateFilter.name"/>
                </div>

                <div class="d-flex justify-content-between">
                    <button class="btn_previous_date fa fa-caret-left" t-on-click="() =&gt; this.selectPreviousPeriod(dateFilter.period)"/>
                    <time class="d-flex justify-content-center time_text">
                        <t t-out="this.displayPeriod(dateFilter.period)"/>
                    </time>
                    <button class="btn_next_date fa fa-caret-right" t-on-click="() =&gt; this.selectNextPeriod(dateFilter.period)"/>
                </div>
            </DropdownItem>
        </t>
    </t>

    `);
registerTemplate("account_reports.AccountReportFilterDate", `/account_reports/static/src/components/account_report/filters/filter_date.xml`, `<t t-name="account_reports.AccountReportFilterDate" xml:space="preserve">
        <Dropdown menuClass="'account_report_filter date'">
            <button class="btn btn-secondary">
                <i class="fa fa-calendar me-1"/>
                <t t-out="controller.options.date.string"/>
            </button>

            <t t-set-slot="content">
                <t t-if="controller.options.date.mode === 'single'">
                    <DropdownItem class="{ 'selected': controller.options.date.filter === 'today' }" onSelected="() =&gt; this.filterClicked({ optionKey: 'date.filter', optionValue: 'today', reload: true})" closingMode="'none'">
                        Today
                    </DropdownItem>

                    <t t-call="account_reports.AccountReportFilterDateSelection"/>

                    <div id="filter_date_divider_single" class="dropdown-divider"/>

                    <div class="dropdown-item date d-flex justify-content-between" t-att-class="{ 'selected': controller.options.date.filter === 'custom' }" t-on-click="() =&gt; this.filterClicked({ optionKey: 'date.filter', optionValue: 'custom'})">
                        <label class="d-flex align-items-center filter_name">
                            Specific Date
                        </label>

                        <div class="d-flex justify-content-center flex-grow-1" t-att-class="{ 'invisible': controller.options.date.filter !== 'custom' }">
                            <DateTimeInput type="'date'" value="dateTo('date')" onChange="(dateTo) =&gt; this.setDateTo('date', dateTo)"/>
                        </div>
                    </div>
                </t>

                <t t-if="controller.options.date.mode === 'range'">
                    <t t-call="account_reports.AccountReportFilterDateSelection"/>

                    <div id="filter_date_divider_range" class="dropdown-divider"/>

                    <div class="dropdown-item date d-flex flex-row justify-space-between" t-att-class="{ 'selected': controller.options.date.filter === 'custom' }" t-on-click="() =&gt; this.filterClicked({ optionKey: 'date.filter', optionValue: 'custom'})">
                        <label class="d-flex align-items-center">
                            Custom Dates
                        </label>
                        <div class="d-flex flex-row" t-att-class="{ 'invisible': controller.options.date.filter !== 'custom' }">
                            <DateTimeInput type="'date'" value="dateFrom('date')" onChange="(dateFrom) =&gt; this.setDateFrom('date', dateFrom)"/>
                            <label class="d-flex align-items-center">
                                to
                            </label>
                            <DateTimeInput type="'date'" value="dateTo('date')" onChange="(dateTo) =&gt; this.setDateTo('date', dateTo)"/>
                        </div>
                    </div>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AccountReportFilterExtraOptions", `/account_reports/static/src/components/account_report/filters/filter_extra_options.xml`, `<t t-name="account_reports.AccountReportFilterExtraOptions" xml:space="preserve">
        <Dropdown>
            <button class="btn btn-secondary">
                <i class="fa fa-sliders me-1"/>
                <t t-if="selectedExtraOptions">
                    <t t-out="selectedExtraOptions"/>
                </t>
                <t t-else="">
                    Options
                </t>
            </button>

            <t t-set-slot="content">
                <t t-if="controller.groups.account_readonly and controller.filters.show_draft">
                    <DropdownItem class="{ 'filter_show_draft_hook': true, 'selected': controller.options.all_entries }" onSelected="() =&gt; this.filterClicked({ optionKey: 'all_entries', reload: true})" closingMode="'none'">
                        Draft Entries
                    </DropdownItem>
                </t>

                <t t-if="controller.groups.account_readonly and controller.filters.show_analytic_groupby">
                    <DropdownItem class="{ 'selected': controller.options.include_analytic_without_aml }" onSelected="() =&gt; this.filterClicked({ optionKey: 'include_analytic_without_aml', reload: true})" closingMode="'none'">
                        Analytic Simulations
                    </DropdownItem>
                </t>

                <t t-if="controller.filters.show_hierarchy">
                    <DropdownItem class="{ 'selected': controller.options.hierarchy }" onSelected="() =&gt; this.filterClicked({ optionKey: 'hierarchy', reload: true})" closingMode="'none'">
                        Hierarchy and Subtotals
                    </DropdownItem>
                </t>

                <t t-if="controller.filters.show_unreconciled">
                    <DropdownItem class="{ 'selected': controller.options.unreconciled }" onSelected="() =&gt; this.filterClicked({ optionKey: 'unreconciled', reload: true})" closingMode="'none'">
                        Unreconciled Entries
                    </DropdownItem>
                </t>

                <t t-if="controller.filters.show_all">
                    <DropdownItem class="{ 'filter_show_all_hook': true, 'selected': controller.options.unfold_all }" onSelected="() =&gt; this.filterClicked({ optionKey: 'unfold_all', reload: true})" closingMode="'none'">
                        Unfold All
                    </DropdownItem>
                </t>

                <t t-if="controller.options.integer_rounding">
                    <DropdownItem class="{ 'selected': controller.options.integer_rounding_enabled }" onSelected="() =&gt; this.filterClicked({ optionKey: 'integer_rounding_enabled'})" closingMode="'none'">
                        Integer Rounding
                    </DropdownItem>
                </t>

                <div class="dropdown-divider" t-if="hasUIFilter"/>

                <t t-if="controller.filters.show_hide_0_lines !== 'never'">
                    <DropdownItem class="{ 'selected': controller.options.hide_0_lines }" onSelected="() =&gt; this.toggleHideZeroLines()">
                        Hide lines at 0
                    </DropdownItem>
                </t>

                <t t-if="'horizontal_split' in controller.options">
                    <DropdownItem class="{ 'selected': controller.options.horizontal_split }" onSelected="() =&gt; this.toggleHorizontalSplit()">
                        Split Horizontally
                    </DropdownItem>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AccountReportFilterFiscalPosition", `/account_reports/static/src/components/account_report/filters/filter_fiscal_position.xml`, `<t t-name="account_reports.AccountReportFilterFiscalPosition" xml:space="preserve">
        <Dropdown>
            <button class="btn btn-secondary">
                <i class="fa fa-book me-1"/>Fiscal Position: <t t-esc="selectedFiscalPositionName"/>
            </button>

            <t t-set-slot="content">
                <t t-if="controller.groups.account_readonly and controller.options.allow_domestic">
                    <DropdownItem class="{ 'selected': controller.options.fiscal_position === 'domestic' }" onSelected="() =&gt; this.filterClicked({ optionKey: 'fiscal_position', optionValue: 'domestic', reload: true})">
                        Domestic
                    </DropdownItem>
                </t>

                <t t-if="controller.groups.account_readonly">
                    <DropdownItem class="{ 'selected': controller.options.fiscal_position === 'all' }" onSelected="() =&gt; this.filterClicked({ optionKey: 'fiscal_position', optionValue: 'all', reload: true})">
                        All
                    </DropdownItem>
                </t>

                <t t-foreach="controller.options.available_vat_fiscal_positions" t-as="fiscalPosition" t-key="fiscalPosition_index">
                    <t t-if="fiscalPosition_first">
                        <div class="dropdown-divider"/>
                    </t>

                    <DropdownItem class="{ 'selected': controller.options.fiscal_position === fiscalPosition.id }" onSelected="() =&gt; this.filterClicked({ optionKey: 'fiscal_position', optionValue: fiscalPosition.id, reload: true})">
                        <t t-esc="fiscalPosition.name"/>
                    </DropdownItem>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AccountReportFilterHorizontalGroups", `/account_reports/static/src/components/account_report/filters/filter_horizontal_groups.xml`, `<t t-name="account_reports.AccountReportFilterHorizontalGroups" xml:space="preserve">
        <Dropdown>
            <button class="btn btn-secondary">
                <i class="fa fa-filter me-1"/>Horizontal Group: <t t-out="selectedHorizontalGroupName"/>
            </button>

            <t t-set-slot="content">
                <DropdownItem class="{ 'selected': controller.options.selected_horizontal_group_id === null }" onSelected="() =&gt; this.selectHorizontalGroup(null)" closingMode="'none'">
                    None
                </DropdownItem>

                <t t-foreach="controller.options.available_horizontal_groups" t-as="horizontalGroup" t-key="horizontalGroup_index">
                    <DropdownItem class="{ 'selected': controller.options.selected_horizontal_group_id === horizontalGroup.id }" onSelected="() =&gt; this.selectHorizontalGroup(horizontalGroup.id)" closingMode="'none'">
                        <t t-out="horizontalGroup.name"/>
                    </DropdownItem>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AccountReportFilterJournal", `/account_reports/static/src/components/account_report/filters/filter_journal.xml`, `<t t-name="account_reports.AccountReportFilterJournal" xml:space="preserve">
        <Dropdown disabled="!controller.options.journals.length">
            <button class="btn btn-secondary">
                <i class="fa fa-book me-1"/><t t-out="controller.options.name_journal_group"/>
            </button>

            <t t-set-slot="content">
                <t t-foreach="controller.options.journals" t-as="journal" t-key="journal_index">
                    <t t-if="journal.id === 'divider'">
                        <div t-att-class="'d-flex dropdown-header w-100 align-items-center' + (journal.model == 'res.company' ? ' pt-0 ps-0 mx-0 my-1' : '')">
                            <t t-if="journal.model == 'account.journal.group'">
                                <t t-out="journal.name"/>
                            </t>
                            <t t-if="journal.model == 'res.company'">
                                <button class="btn btn_foldable d-flex align-items-center w-100 border-0" t-on-click="() =&gt; this.unfoldCompanyJournals(journal)">
                                    <i t-att-class="journal.unfolded ? 'fa fa-caret-down' : 'fa fa-caret-right'"/>
                                    <span class="pt-0 mt-0 ps-2 dropdown-header" t-out="journal.name"/>
                                </button>
                           </t>
                        </div>

                    </t>
                    <t t-elif="['account.journal', 'account.journal.group'].includes(journal.model)">
                        <DropdownItem class="{ 'selected': journal.selected, 'ps-4': true, 'd-none': (journal.model == 'account.journal' and !journal.visible) }" onSelected="() =&gt; this.selectJournal(journal)" closingMode="'none'" t-out="journal.name"/>
                    </t>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AccountReportFilterPartner", `/account_reports/static/src/components/account_report/filters/filter_partner.xml`, `<t t-name="account_reports.AccountReportFilterPartner" xml:space="preserve">
        <Dropdown menuClass="'account_report_filter partner'">
            <button class="btn btn-secondary">
                <i class="fa fa-folder-open me-1"/>Partners
            </button>

            <t t-set-slot="content">
                <div class="dropdown-item gap-2 align-items-center">
                    <label>Partners</label>
                    <MultiRecordSelector t-props="getMultiRecordSelectorProps('res.partner', 'partner_ids')" domain="[['parent_id', '=', false]]"/>
                </div>

                <div class="dropdown-item gap-2 align-items-center">
                    <label>Tags</label>
                    <MultiRecordSelector t-props="getMultiRecordSelectorProps('res.partner.category', 'partner_categories')"/>
                </div>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AccountReportFilterRoundingUnit", `/account_reports/static/src/components/account_report/filters/filter_rounding_unit.xml`, `<t t-name="account_reports.AccountReportFilterRoundingUnit" xml:space="preserve">
        <Dropdown>
            <button class="btn btn-secondary">
                <t t-out="roundingUnitName(this.controller.options['rounding_unit'])"/>
            </button>

            <t t-set-slot="content">
                <t t-foreach="controller.options.rounding_unit_names" t-as="roundingUnitValue" t-key="roundingUnitValue_index">
                    <DropdownItem class="{ 'selected': (controller.options.rounding_unit == roundingUnitValue) }" onSelected="() =&gt; this.filterRoundingUnit(roundingUnitValue)">
                        <t t-out="roundingUnitName(roundingUnitValue)"/>
                    </DropdownItem>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AccountReportFilterTaxUnit", `/account_reports/static/src/components/account_report/filters/filter_tax_unit.xml`, `<t t-name="account_reports.AccountReportFilterTaxUnit" xml:space="preserve">
        <Dropdown>
            <button class="btn btn-secondary">
                <i class="fa fa-home me-1"/>Tax Unit: <t t-esc="selectedTaxUnitName"/>
            </button>

            <t t-set-slot="content">
                <t t-if="controller.groups.account_readonly">
                    <DropdownItem class="{ 'selected': controller.options.tax_unit === 'company_only' }" onSelected="() =&gt; this.filterClicked({ optionKey: 'tax_unit', optionValue: 'company_only', reload: true})">
                        Company Only
                    </DropdownItem>
                </t>

                <t t-foreach="controller.options.available_tax_units" t-as="taxUnit" t-key="taxUnit_index">
                    <t t-if="taxUnit_first">
                        <div class="dropdown-divider"/>
                    </t>

                    <DropdownItem class="{ 'selected': controller.options.tax_unit === taxUnit.id }" onSelected="() =&gt; this.filterTaxUnit(taxUnit)" t-out="taxUnit.name"/>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AccountReportFilterVariant", `/account_reports/static/src/components/account_report/filters/filter_variant.xml`, `<t t-name="account_reports.AccountReportFilterVariant" xml:space="preserve">
        <Dropdown>
            <button class="btn btn-secondary">
                <i class="fa fa-book me-1"/>Report: <t t-esc="selectedVariantName"/>
            </button>

            <t t-set-slot="content">
                <t t-foreach="controller.options.available_variants" t-as="variant" t-key="variant_index">
                    <DropdownItem class="{ 'selected': controller.options.selected_variant_id === variant.id }" onSelected="() =&gt; this.filterVariant(variant.id)" t-out="variant.name"/>
                </t>
                <t t-if="controller.options.has_inactive_variants">
                    <div role="separator" class="dropdown-divider"/>
                    <DropdownItem onSelected="(ev) =&gt; controller.reportAction(ev, 'action_view_all_variants', {})">
                        Enable more ...
                    </DropdownItem>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AccountReportFilters", `/account_reports/static/src/components/account_report/filters/filters.xml`, `<t t-name="account_reports.AccountReportFilters" xml:space="preserve">
        <t t-call="{{ env.template('AccountReportFilters') }}"/>
    </t>

    `);
registerTemplate("account_reports.AccountReportFiltersCustomizable", `/account_reports/static/src/components/account_report/filters/filters.xml`, `<t t-name="account_reports.AccountReportFiltersCustomizable" xml:space="preserve">

        <t t-if="'date' in controller.options">
            <div id="filter_date" class="filter_date">
                <t t-call="account_reports.AccountReportFilterDate"/>
            </div>
        </t>


        <t t-if="controller.filters.show_period_comparison">
            <div id="filter_comparison" class="filter_comparison">
                <t t-call="account_reports.AccountReportFilterComparison"/>
            </div>
        </t>


        <t t-if="'journals' in controller.options">
            <div id="filter_journal">
                <t t-call="account_reports.AccountReportFilterJournal"/>
            </div>
        </t>


        <t t-if="'account_type' in controller.options">
            <div id="filter_account_type">
                <t t-call="account_reports.AccountReportFilterAccountType"/>
            </div>
        </t>


        <t t-if="controller.groups.analytic_accounting and controller.filters.show_analytic">
            <div id="filter_analytic" class="filter_analytic">
                <t t-call="account_reports.AccountReportFilterAnalytic"/>
            </div>
        </t>


        <t t-if="hasAnalyticGroupbyFilter">
            <div id="filter_analytic_groupby" class="filter_analytic_groupby">
                <t t-call="account_reports.AccountReportFilterAnalyticGroupby"/>
            </div>
        </t>


        <t t-if="controller.options.available_horizontal_groups.length &gt; 0">
            <div id="filter_horizontal_groups">
                <t t-call="account_reports.AccountReportFilterHorizontalGroups"/>
            </div>
        </t>


        <t t-if="'partner' in controller.options">
            <div id="filter_partner" class="filter_partner">
                <t t-call="account_reports.AccountReportFilterPartner"/>
            </div>
        </t>


        <t t-if="hasExtraOptionsFilter">
            <div id="filter_extra_options">
                <t t-call="account_reports.AccountReportFilterExtraOptions"/>
            </div>
        </t>


        <t t-if="controller.options.available_variants.length &gt; 1">
            <div id="filter_variant">
                <t t-call="account_reports.AccountReportFilterVariant"/>
            </div>
        </t>


        <t t-if="'available_tax_units' in this.controller.options and controller.options.available_tax_units.length &gt; 0">
            <div id="filter_tax_unit">
                <t t-call="account_reports.AccountReportFilterTaxUnit"/>
            </div>
        </t>


        <t t-if="hasFiscalPositionFilter">
            <div id="filter_fiscal_position">
                <t t-call="account_reports.AccountReportFilterFiscalPosition"/>
            </div>
        </t>


        <t t-if="'budgets' in controller.options">
            <div id="filter_budget">
                <t t-call="account_reports.AccountReportFilterBudget"/>
            </div>
        </t>


        <t t-if="'aml_ir_filters' in controller.options and controller.options.aml_ir_filters.length &gt; 0">
            <div id="filter_aml_ir_filters">
                <t t-call="account_reports.AccountReportAmlIrFilters"/>
            </div>
        </t>

        <div id="filter_rounding_unit">
            <t t-call="account_reports.AccountReportFilterRoundingUnit"/>
        </div>

        <t t-if="env.debug">
            <div id="filter_configuration" class="o-dropdown dropdown o-dropdown--no-caret">
                <button class="btn btn-secondary" t-on-click="(ev) =&gt; this.controller.reportAction(ev, 'action_open_report_form', {}, true)">
                    <i class="fa fa-cogs me-1"/>
                </button>
            </div>
        </t>
    </t>
`);
registerTemplate("account_reports.AccountReportHeader", `/account_reports/static/src/components/account_report/header/header.xml`, `<t t-name="account_reports.AccountReportHeader" xml:space="preserve">
        <t t-call="{{ env.template('AccountReportHeader') }}"/>
    </t>

    `);
registerTemplate("account_reports.AccountReportHeaderCustomizable", `/account_reports/static/src/components/account_report/header/header.xml`, `<t t-name="account_reports.AccountReportHeaderCustomizable" xml:space="preserve">
        <thead id="table_header" class="sticky">

            <t t-foreach="columnHeaders" t-as="columnHeader" t-key="columnHeader_index">
                <tr>

                    <th>
                        <t t-if="columnHeader_first and controller.options.companies.length &gt; 1">
                            <span class="companies_header" t-out="controller.options.companies.map(company =&gt; company.name).join(', ')"/>
                        </t>
                    </th>


                    <t t-foreach="columnHeader" t-as="header" t-key="header_index">
                        <th class="column_header" t-att-colspan="this.columnHeadersColspan(columnHeader_index, header)">
                            <t t-out="header.name"/>
                        </th>
                    </t>

                    <t t-if="controller.options.show_horizontal_group_total">
                        <t t-if="!columnHeader_first">
                            <th class="column_header">
                                <t t-out="controller.options.available_horizontal_groups.find(group =&gt; group.id === controller.options.selected_horizontal_group_id)?.name"/>
                            </th>
                        </t>
                    </t>


                    <t t-if="controller.needsColumnPercentComparison">

                        <t t-if="columnHeader_first">
                            <th class="column_percent_comparison_header">
                                <i class="fa fa-percent"/>
                            </th>
                        </t>
                    </t>


                    <t t-if="controller.hasDebugColumn">

                        <t t-if="columnHeader_first">
                            <th class="debug_header">
                                <i class="fa fa-bug"/>
                            </th>
                        </t>
                    </t>
                </tr>
            </t>


            <t t-if="controller.hasCustomSubheaders">
                <tr>

                    <th/>


                    <t t-foreach="customSubheaders" t-as="customSubheader" t-key="customSubheader_index">
                        <th t-att-colspan="customSubheader.colspan || 1" t-att-data-expression_label="customSubheader.expression_label">
                            <t t-out="customSubheader.name"/>
                        </th>
                    </t>


                    <t t-if="controller.hasDebugColumn">

                        <th/>
                    </t>
                </tr>
            </t>


            <tr>

                <th/>


                <t t-foreach="subheaders" t-as="subheader" t-key="subheader_index">
                    <th t-att-colspan="subheader.colspan || 1" t-att-data-expression_label="subheader.expression_label">

                        <t t-if="subheader.sortable">
                            <button class="btn btn_sortable" t-on-click="() =&gt; this.sortLinesByColumn(subheader_index, subheader)">
                                <i t-att-class="sortableClasses(subheader_index)"/>
                            </button>
                        </t>

                        <t t-if="subheader.template">
                            <t t-call="{{ subheader.template }}"/>
                        </t>
                        <t t-else="">
                            <t t-out="subheader.name"/>
                        </t>
                    </th>
                </t>


                <t t-if="controller.hasDebugColumn">

                    <th/>
                </t>

                <t t-if="controller.options.show_horizontal_group_total">
                    <th>

                        <t t-out="subheaders[0].name"/>
                    </th>
                </t>
            </tr>
        </thead>
    </t>
`);
registerTemplate("account_reports.AccountReportLine", `/account_reports/static/src/components/account_report/line/line.xml`, `<t t-name="account_reports.AccountReportLine" xml:space="preserve">
        <t t-call="{{ env.template('AccountReportLine') }}"/>
    </t>

    `);
registerTemplate("account_reports.AccountReportLineCustomizable", `/account_reports/static/src/components/account_report/line/line.xml`, `<t t-name="account_reports.AccountReportLineCustomizable" xml:space="preserve">

        <t t-if="props.line.level === 0">
            <tr class="empty">
                <td/>
                <t t-foreach="props.line.columns" t-as="cell" t-key="cell_index">
                    <td/>
                </t>
                <t t-if="controller.needsColumnPercentComparison">
                    <td/>
                </t>
                <t t-if="controller.hasDebugColumn">
                    <td/>
                </t>
            </tr>
        </t>

        <tr data-id="line" t-att-class="lineClasses">

            <t t-component="env.component('AccountReportLineName')" t-props="{ lineIndex: props.lineIndex, line: props.line }"/>


            <t t-foreach="props.line.columns" t-as="cell" t-key="cell_index">

                <t t-if="cell.column_group_key?.includes('compute_budget')">
                    <AccountReportLineCellEditable t-props="{ line: props.line, cell: cell }"/>
                </t>
                <t t-else="">
                    <t t-component="env.component('AccountReportLineCell')" t-props="{ line: props.line, cell: cell }"/>
                </t>
            </t>


            <t t-if="controller.needsColumnPercentComparison">
                <t t-if="controller.lineHasGrowthComparisonData(props.lineIndex)">
                    <td t-att-class="growthComparisonClasses">
                        <t t-out="props.line.column_percent_comparison_data.name"/>
                    </td>
                </t>
                <t t-else="">
                    <td/>
                </t>
            </t>


            <t t-if="controller.hasDebugColumn">
                <td class="text-center">
                    <t t-if="props.line.code">
                        <t t-out="props.line.code"/>
                    </t>

                    <t t-if="controller.lineHasDebugData(props.lineIndex)">
                        <button class="btn btn_debug" t-on-click="(ev) =&gt; this.showDebugPopover(ev)">
                            <i class="fa fa-info-circle"/>
                        </button>
                    </t>
                </td>
            </t>

            <t t-if="controller.options.show_horizontal_group_total">
                <td t-att-class="HorizontalGroupTotalClasses">
                    <t t-out="props.line.horizontal_group_total_data?.name"/>
                </td>
            </t>
        </tr>
    </t>
`);
registerTemplate("account_reports.AccountReportDebugPopover", `/account_reports/static/src/components/account_report/line/popover/debug_popover.xml`, `<t t-name="account_reports.AccountReportDebugPopover" xml:space="preserve">
        <div class="account_report_popover_debug">
            <t t-foreach="props.expressionsDetail" t-as="expressionEngineAndTotals" t-key="expressionEngineAndTotals_index">
                <t t-set="expressionEngine" t-value="expressionEngineAndTotals[0]"/>
                <t t-set="expressionTotals" t-value="expressionEngineAndTotals[1]"/>

                <div class="line_debug">
                    <span>Engine</span>
                    <span class="fw-bold" t-out="expressionEngine"/>
                </div>

                <t t-foreach="expressionTotals" t-as="labelAndInfo" t-key="labelAndInfo_index">
                    <t t-set="expressionLabel" t-value="labelAndInfo[0]"/>
                    <t t-set="expressionInfo" t-value="labelAndInfo[1]"/>

                    <div class="line_debug">
                        <span>Label</span>
                        <span t-out="expressionLabel"/>
                    </div>

                    <div class="line_debug">
                        <span>Formula</span>
                        <code t-out="expressionInfo.formula"/>
                    </div>

                    <t t-if="expressionInfo.subformula">
                        <div class="line_debug">
                            <span>Subformula</span>
                            <code t-out="expressionInfo.subformula"/>
                        </div>
                    </t>

                    <div class="line_debug">
                        <span>Value</span>
                        <span t-out="expressionInfo.value"/>
                    </div>

                    <t t-if="!labelAndInfo_last">
                        <div class="totals_separator"/>
                    </t>
                </t>

                <t t-if="!expressionEngineAndTotals_last">
                    <div class="engine_separator"/>
                </t>
            </t>
        </div>
    </t>
`);
registerTemplate("account_reports.AccountReportLineCell", `/account_reports/static/src/components/account_report/line_cell/line_cell.xml`, `<t t-name="account_reports.AccountReportLineCell" xml:space="preserve">
        <t t-call="{{ env.template('AccountReportLineCell') }}"/>
    </t>

    `);
registerTemplate("account_reports.AccountReportLineCellCustomizable", `/account_reports/static/src/components/account_report/line_cell/line_cell.xml`, `<t t-name="account_reports.AccountReportLineCellCustomizable" xml:space="preserve">
        <td data-id="line_cell" class="line_cell" t-att-class="cellClasses" t-att-data-expression_label="props.cell.expression_label">
            <div class="wrapper">
                <t t-if="!controller.filters.show_totals or !props.line.unfolded">
                    <t t-if="props.cell.info_popup_data">
                        <a class="fa fa-question-circle me-2" t-on-click="(ev) =&gt; this.carryoverPopover(ev)"/>
                    </t>

                    <t t-if="props.cell.edit_popup_data">
                        <button class="btn btn_edit me-auto" t-on-click="(ev) =&gt; this.editPopover(ev)">
                            <i class="fa fa-pencil"/>
                        </button>
                    </t>

                    <div class="content">
                        <t t-if="props.cell.auditable">
                            <a t-on-click="() =&gt; this.audit()">
                                <t t-component="env.component('AccountReportEllipsis')" t-props="{                                     name: props.cell.name?.toString(),                                     no_format: props.cell.no_format,                                     type: props.cell.figure_type,                                     maxCharacters: 50,                                 }"/>
                            </a>
                        </t>
                        <t t-else="">
                            <t t-component="env.component('AccountReportEllipsis')" t-props="{                                 name: props.cell.name?.toString(),                                 no_format: props.cell.no_format,                                 type: props.cell.figure_type,                                 maxCharacters: 50,                             }"/>
                        </t>
                    </div>
                </t>
            </div>
        </td>
    </t>
`);
registerTemplate("account_reports.AccountReportCarryoverPopover", `/account_reports/static/src/components/account_report/line_cell/popover/carryover_popover.xml`, `<t t-name="account_reports.AccountReportCarryoverPopover" xml:space="preserve">
        <table class="carryover_popover">
            <t t-if="props.carryoverData.carryover || props.carryoverData.applied_carryover">
                <tr>
                    <td>
                        <strong>Carryover</strong>
                    </td>
                    <td/>
                </tr>

                <t t-if="props.carryoverData.applied_carryover">
                    <tr>
                        <td colspan="2">
                            <span>
                                <strong t-out="props.carryoverData.applied_carryover"/> were carried over to this line from previous period.
                            </span>
                        </td>
                    </tr>
                </t>

                <t t-if="props.carryoverData.carryover">
                    <tr>
                        <td colspan="2">
                            <t t-if="props.carryoverData.carryover_target">
                                <span>
                                    <strong t-out="props.carryoverData.carryover"/> will be carried over to <strong t-out="props.carryoverData.carryover_target"/> in the next period.
                                </span>
                            </t>
                            <t t-else="">
                                <span>
                                    <strong t-out="props.carryoverData.carryover"/> will be carried over to this line in the next period.
                                </span>
                            </t>
                        </td>
                    </tr>
                </t>

                <t t-if="props.carryoverData.allow_carryover_audit">
                    <tr>
                        <td/>
                        <td>
                            <button class="btn btn-secondary" t-on-click="() =&gt; this.viewCarryoverLinesAction(props.carryoverData.expression_id, props.carryoverData.column_group_key)">
                                View Carryover Lines
                            </button>
                        </td>
                    </tr>
                </t>
            </t>
        </table>
    </t>
`);
registerTemplate("account_reports.AccountReportEditPopover", `/account_reports/static/src/components/account_report/line_cell/popover/edit_popover.xml`, `<t t-name="account_reports.AccountReportEditPopover" xml:space="preserve">
        <div class="account_report_popover_edit">
            <t t-if="props.cell.figure_type === 'boolean'">
                <div class="edit_popover_boolean">

                    <input id="edit_popover_boolean_true" name="edit_popover_boolean" type="radio" value="1" t-att-checked="props.cell.no_format" t-ref="booleanTrue"/>
                    <label for="edit_popover_boolean_true">Yes</label>


                    <input id="edit_popover_boolean_false" name="edit_popover_boolean" type="radio" value="0" t-att-checked="!props.cell.no_format" t-ref="booleanFalse"/>
                    <label for="edit_popover_boolean_false">No</label>
                </div>
            </t>
            <t t-elif="props.cell.figure_type === 'string'">
                <textarea class="edit_popover_string" rows="3" t-ref="input">
                    <t t-out="props.cell.no_format"/>
                </textarea>
            </t>
            <t t-elif="props.cell.figure_type === 'percentage'">
                <div class="input-group">
                    <input class="form-control" type="text" inputmode="numeric" t-ref="input" t-att-value="props.cell.no_format"/>
                    <span class="input-group-text">%</span>
                </div>
            </t>
            <t t-elif="props.cell.figure_type === 'monetary' and props.cell.currency_symbol">
                <div class="input-group">
                    <input class="form-control" type="text" inputmode="numeric" t-ref="input" t-att-value="props.cell.no_format"/>
                    <span class="input-group-text">
                        <t t-out="props.cell.currency_symbol"/>
                    </span>
                </div>
            </t>
            <t t-else="">
                <input type="text" inputmode="numeric" t-ref="input" t-att-value="props.cell.no_format"/>
            </t>

            <button class="btn btn-sm mt-2" t-on-click="() =&gt; this.edit()">
                Post
            </button>
        </div>
    </t>
`);
registerTemplate("account_reports.AccountReportLineCellEditable", `/account_reports/static/src/components/account_report/line_cell_editable/line_cell_editable.xml`, `<t t-name="account_reports.AccountReportLineCellEditable" t-inherit="account_reports.AccountReportLineCellCustomizable" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[contains(@class, 'wrapper')]" position="replace">
            <t t-if="hasEditPopupData">
                <div class="content">
                    <input type="text" class="o_input text-end" t-ref="input" t-on-change="onChange" t-on-focus="onFocus" t-on-blur="onBlur" t-att-value="inputValue"/>
                </div>
            </t>
            <t t-else="">$0</t>
        </xpath>
    </t>
`);
registerTemplate("account_reports.AccountReportLineName", `/account_reports/static/src/components/account_report/line_name/line_name.xml`, `<t t-name="account_reports.AccountReportLineName" xml:space="preserve">
        <t t-call="{{ env.template('AccountReportLineName') }}"/>
    </t>

    `);
registerTemplate("account_reports.AccountReportLineNameCustomizable", `/account_reports/static/src/components/account_report/line_name/line_name.xml`, `<t t-name="account_reports.AccountReportLineNameCustomizable" xml:space="preserve">
        <td data-id="line_name" class="line_name" t-att-class="lineNameClasses" t-on-click="() =&gt; this.toggleFoldable()" t-att-colspan="props.line.colspan || 1" tabindex="-1" t-ref="lineNameCell">
            <div class="wrapper">
                <t t-if="props.line.unfoldable">

                    <button data-id="btn_foldable" class="btn btn_foldable" tabindex="-1">
                        <i t-att-class="props.line.unfolded ? 'fa fa-caret-down' : 'fa fa-caret-right'"/>
                    </button>
                </t>
                <t t-else="">

                    <button class="btn btn_foldable_empty" tabindex="-1"/>
                </t>

                <t t-if="props.line.action_id">

                    <a class="clickable" t-on-click="() =&gt; this.triggerAction()" tabindex="-1">
                        <t t-out="props.line.name"/>
                    </a>
                </t>
                <t t-elif="controller.isLoadMoreLine(props.lineIndex)">

                    <a class="clickable" t-on-click="() =&gt; this.loadMore()" tabindex="-1">
                        <t t-out="props.line.name"/>
                    </a>
                </t>
                <t t-else="">
                    <div data-id="content" class="content">
                        <t t-component="env.component('AccountReportEllipsis')" t-props="{                             name: props.line.name?.toString(),                             type: 'string',                             maxCharacters: 80,                         }"/>

                        <t t-if="props.line.visible_annotations?.length">
                            <button tabindex="-1" class="btn btn_annotation" t-on-click="toggleAnnotationPopover">
                                <i class="fa fa-commenting"/>
                            </button>
                        </t>

                        <t t-if="hasCaretOptions">

                            <Dropdown position="'right-start'">
                                <button class="btn btn_dropdown" tabindex="-1">
                                    <i class="fa fa-ellipsis-v"/>
                                </button>
                                <t t-set-slot="content">
                                    <div data-id="caret_options">
                                        <t t-foreach="caretOptions" t-as="caretOption" t-key="caretOption_index">
                                            <DropdownItem onSelected="() =&gt; this.caretAction(caretOption)">
                                                <t t-out="caretOption.name"/>
                                            </DropdownItem>
                                        </t>

                                        <t t-if="!props.line.visible_annotations?.length">
                                            <div class="o-dropdown-item dropdown-item o-navigable" t-on-click="(ev) =&gt; this.addAnnotation(ev, props.line.id)">
                                                Annotate
                                            </div>
                                        </t>
                                    </div>
                                </t>
                            </Dropdown>
                        </t>

                        <t data-id="line_buttons" t-if="!props.line['hide_line_buttons']"/>
                    </div>
                </t>
            </div>
        </td>
    </t>
`);
registerTemplate("account_reports.AccountReportAnnotationsPopover", `/account_reports/static/src/components/account_report/line_name/popover/annotations_popover.xml`, `<t t-name="account_reports.AccountReportAnnotationsPopover" xml:space="preserve">
        <div class="d-flex flex-column flex-start gap-2">
            <table class="annotation_popover" t-ref="popoverTable">
                <tr class="annotation_popover_line">
                    <th>Date</th>
                    <th>Annotation</th>
                    <th/>
                </tr>

                <t t-foreach="annotations" t-as="annotation" t-key="annotation.id">
                    <AnnotationPopoverLine annotation="this.formatAnnotation(annotation)" onDelete="(annotationId) =&gt; this.deleteAnnotation(annotationId)" onEdit="(editedAnnotation) =&gt; this.editAnnotation(editedAnnotation, annotation)"/>
                </t>
                <AnnotationPopoverLine t-if="isAddingAnnotation" annotation="newAnnotation.value" onDelete="() =&gt; this.cleanNewAnnotation()" onEdit="(annotationToCreate) =&gt; this.saveNewAnnotation(annotationToCreate)"/>
                <tr class="annotation_popover_line">
                    <td colspan="4">
                        <a class="oe_link" href="#" t-on-click.prevent="addAnnotation" data-hotkey="c">
                            Add a line
                        </a>
                    </td>
                </tr>
            </table>
        </div>
    </t>
`);
registerTemplate("account_report.AnnotationPopoverLine", `/account_reports/static/src/components/account_report/line_name/popover_line/annotation_popover_line.xml`, `<t t-name="account_report.AnnotationPopoverLine" xml:space="preserve">
        <tr class="annotation_popover_line">
            <td class="w-25">
                <DateTimeInput type="'date'" value="annotation.date" onChange="(date) =&gt; this.annotationEditDate(date)"/>
            </td>
            <td>
                <textarea class="annotation_popover_editable_cell annotation_popover_autoresize_textarea w-100" t-att-value="annotation.text" t-on-change="annotationEditText" t-ref="annotationText"/>
            </td>
            <td>
                <button class="btn btn_annotation_delete" t-on-click="deleteAnnotation">
                    <i class="fa fa-trash-o"/>
                </button>
            </td>
        </tr>
    </t>
`);
registerTemplate("account_reports.AccountReportSearchBar", `/account_reports/static/src/components/account_report/search_bar/search_bar.xml`, `<t t-name="account_reports.AccountReportSearchBar" xml:space="preserve">
        <div class="o_searchview form-control d-print-contents d-flex align-items-center py-1 w-auto" role="search" aria-autocomplete="list">
            <i class="o_searchview_icon d-print-none oi oi-search me-2" role="img" aria-label="Search..." title="Search..."/>
            <div class="o_searchview_input_container d-flex flex-grow-1 flex-wrap gap-1">
                <input type="text" class="o_searchview_input o_input d-print-none flex-grow-1 w-auto border-0" accesskey="Q" placeholder="Search..." role="searchbox" t-ref="search_bar_input" t-on-input="() =&gt; this.search()"/>
            </div>
        </div>
    </t>
`);
registerTemplate("account_reports.common_warning_tax_unit", `/account_reports/static/src/components/account_report/warnings.xml`, `<t t-name="account_reports.common_warning_tax_unit" xml:space="preserve">
        This company is part of a tax unit. You're currently not viewing the whole unit.
    </t>

    `);
registerTemplate("account_reports.common_warning_draft_in_period", `/account_reports/static/src/components/account_report/warnings.xml`, `<t t-name="account_reports.common_warning_draft_in_period" xml:space="preserve">
        There are
        <a type="button" t-on-click="(ev) =&gt; controller.reportAction(ev, 'open_unposted_moves', {})">unposted Journal Entries</a>
        prior or included in this period.
    </t>

    `);
registerTemplate("account_reports.common_possibly_unbalanced_because_cta", `/account_reports/static/src/components/account_report/warnings.xml`, `<t t-name="account_reports.common_possibly_unbalanced_because_cta" xml:space="preserve">
        This report uses the CTA conversion method to consolidate multiple companies using different currencies,
        which can lead the report to be unbalanced.
    </t>
`);
registerTemplate("account_reports.AccountReportAgingBasedOn", `/account_reports/static/src/components/aged_partner_balance/filter_aging.xml`, `<t t-name="account_reports.AccountReportAgingBasedOn" xml:space="preserve">
        <Dropdown>
            <button class="btn btn-secondary">
                <i class="fa fa-file me-1"/>Based on
                <t t-if="controller.options.aging_based_on === 'base_on_invoice_date'">
                    Invoice Date
                </t>
                <t t-else="">
                    Due Date
                </t>
            </button>
            <t t-set-slot="content">
                <DropdownItem class="{ 'selected': controller.options.aging_based_on === 'base_on_maturity_date' }" onSelected="() =&gt; this.filterClicked({ optionKey: 'aging_based_on', optionValue: 'base_on_maturity_date', reload: true})">
                    Due Date
                </DropdownItem>

                <DropdownItem class="{ 'selected': controller.options.aging_based_on === 'base_on_invoice_date' }" onSelected="() =&gt; this.filterClicked({ optionKey: 'aging_based_on', optionValue: 'base_on_invoice_date', reload: true})">
                    Invoice Date
                </DropdownItem>
            </t>
        </Dropdown>
    </t>

    `);
registerTemplate("account_reports.AccountReportAgingInterval", `/account_reports/static/src/components/aged_partner_balance/filter_aging.xml`, `<t t-name="account_reports.AccountReportAgingInterval" xml:space="preserve">
        <Dropdown menuClass="'account_report_filter intervals'">
            <button class="btn btn-secondary">
                <i class="fa fa-calendar-o me-1"/>
                <t t-out="controller.options.aging_interval"/> Days
            </button>
            <t t-set-slot="content">
                <div class="dropdown-item interval">
                    <input min="1" type="number" t-att-value="controller.options.aging_interval" t-on-change="(ev) =&gt; this.setAgingInterval(ev)"/>
                    <span class="mx-2">Days</span>
                </div>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.AgedPartnerBalanceFilterExtraOptions", `/account_reports/static/src/components/aged_partner_balance/filter_extra_options.xml`, `<t t-name="account_reports.AgedPartnerBalanceFilterExtraOptions" t-inherit="account_reports.AccountReportFilterExtraOptions" xml:space="preserve">
        <xpath expr="//DropdownItem[contains(@class, 'filter_show_all_hook')]" position="after">
            <DropdownItem t-if="controller.options.multi_currency" class="{ 'selected': controller.options.show_currency }" onSelected="() =&gt; this.filterClicked({ optionKey: 'show_currency', reload: true})" closingMode="'none'">
                Show Currency
            </DropdownItem>
            <DropdownItem class="{ 'selected': controller.options.show_account }" onSelected="() =&gt; this.filterClicked({ optionKey: 'show_account', reload: true})" closingMode="'none'">
                Show Account
            </DropdownItem>
        </xpath>
    </t>
`);
registerTemplate("account_reports.AgedPartnerBalanceFilters", `/account_reports/static/src/components/aged_partner_balance/filters.xml`, `<t t-name="account_reports.AgedPartnerBalanceFilters" t-inherit="account_reports.AccountReportFiltersCustomizable" xml:space="preserve">
        <xpath expr="//div[@id='filter_extra_options']" position="before">
            <t t-if="'aging_based_on' in controller.options">
                <div>
                    <t t-call="account_reports.AccountReportAgingBasedOn"/>
                </div>
            </t>
            <t>
                <div id="filter_aging_interval">
                    <t t-call="account_reports.AccountReportAgingInterval"/>
                </div>
            </t>
        </xpath>

        <xpath expr="//div[@id='filter_extra_options']" position="replace">
            <t t-call="account_reports.AgedPartnerBalanceFilterExtraOptions"/>
        </xpath>
    </t>
`);
registerTemplate("account_reports.AgedPartnerBalanceLineName", `/account_reports/static/src/components/aged_partner_balance/line_name/line_name.xml`, `<t t-name="account_reports.AgedPartnerBalanceLineName" t-inherit="account_reports.AccountReportLineNameCustomizable" xml:space="preserve">
        <xpath expr="//td[@data-id='line_name']" position="attributes">
            <t t-if="props.line.unfoldable">
                <attribute name="class" add="more" separator=" "/>
            </t>
        </xpath>

        <xpath expr="//t[@data-id='line_buttons']" position="inside">
            <t t-if="props.line.unfoldable">
                <button class="btn btn_action" t-on-click="(ev) =&gt; controller.reportAction(ev, 'caret_option_open_record_form', { line_id: props.line.id })">
                    Partner
                </button>

                <button class="btn btn_action" t-on-click="(ev) =&gt; controller.reportAction(ev, 'open_customer_statement', { line_id: props.line.id })">
                    Statement
                </button>
            </t>
        </xpath>

        <xpath expr="//button[@data-id='btn_foldable']" position="after">
            <t t-if="props.line.trust === 'good'">
                <i class="fa fa-circle text-success partner_trust" title="Partner is good"/>
            </t>
            <t t-elif="props.line.trust === 'bad'">
                <i class="fa fa-circle text-danger partner_trust" title="Partner is bad"/>
            </t>
        </xpath>

    </t>
`);
registerTemplate("account_reports.inconsistent_statement_warning", `/account_reports/static/src/components/bank_reconciliation_report/warnings.xml`, `<t t-name="account_reports.inconsistent_statement_warning" xml:space="preserve">
        Some
        <a t-on-click="(ev) =&gt; controller.reportAction(ev, 'bank_reconciliation_report_open_inconsistent_statements', warningParams)">statements</a>
        have a starting balance different from the previous ending balance.
    </t>

    `);
registerTemplate("account_reports.has_bank_miscellaneous_move_lines", `/account_reports/static/src/components/bank_reconciliation_report/warnings.xml`, `<t t-name="account_reports.has_bank_miscellaneous_move_lines" xml:space="preserve">
        <span>
            "<t t-out="warningParams.args"/>" account balance is affected by
            <a t-on-click="(ev) =&gt; controller.reportAction(ev, 'open_bank_miscellaneous_move_lines')">journal items</a>
            which don't originate from a bank statement nor payment.
        </span>
    </t>

    `);
registerTemplate("account_reports.journal_balance", `/account_reports/static/src/components/bank_reconciliation_report/warnings.xml`, `<t t-name="account_reports.journal_balance" xml:space="preserve">
        <span>
            The current balance in the
            <a t-on-click="(ev) =&gt; controller.reportAction(ev, 'action_redirect_to_general_ledger')">
                General Ledger
                <t t-out="warningParams.general_ledger_amount"/>
            </a>

            doesn't match the balance of your
            <a t-on-click="(ev) =&gt; controller.reportAction(ev, 'action_redirect_to_bank_statement_widget')">
                last bank statement
                <t t-out="warningParams.last_bank_statement_amount"/>
            </a>
            , leading to an unexplained difference of
            <t t-out="warningParams.unexplained_difference"/>
        </span>
    </t>
`);
registerTemplate("account_reports.DeferredFilterComparison", `/account_reports/static/src/components/deferred_reports/filters.xml`, `<t t-name="account_reports.DeferredFilterComparison" t-inherit="account_reports.AccountReportFilterComparison" xml:space="preserve">
        <xpath expr="//DropdownItem[contains(@attrs, 'filter_comparison_same_period_last_year')]" position="replace"/>
        <xpath expr="//DropdownItem[contains(@attrs, 'filter_comparison_custom')]" position="replace"/>
    </t>

    `);
registerTemplate("account_reports.DeferredFilters", `/account_reports/static/src/components/deferred_reports/filters.xml`, `<t t-name="account_reports.DeferredFilters" t-inherit="account_reports.AccountReportFiltersCustomizable" xml:space="preserve">
        <xpath expr="//div[@id='filter_comparison']/t" position="replace">
            <t t-call="account_reports.DeferredFilterComparison"/>
        </xpath>

        <xpath expr="//div[@id='filter_extra_options']" position="before">
            <t t-call="account_reports.AccountReportDeferredGroupBy"/>
        </xpath>
    </t>
`);
registerTemplate("account_reports.AccountReportDeferredGroupBy", `/account_reports/static/src/components/deferred_reports/groupby.xml`, `<t t-name="account_reports.AccountReportDeferredGroupBy" xml:space="preserve">
        <Dropdown>
            <button class="btn btn-secondary">
                <i class="fa fa-list me-1"/>Group by
                <t t-if="controller.options.deferred_grouping_field === 'account_id'">
                    Account
                </t>
                <t t-elif="controller.options.deferred_grouping_field === 'product_category_id'">
                    Product Category
                </t>
                <t t-else="">
                    Product
                </t>
            </button>

            <t t-set-slot="content">
                <DropdownItem class="{ 'selected': controller.options.deferred_grouping_field === 'account_id' }" onSelected="() =&gt; this.filterClicked({ optionKey: 'deferred_grouping_field', optionValue: 'account_id', reload: true})">
                    Account
                </DropdownItem>

                <DropdownItem class="{ 'selected': controller.options.deferred_grouping_field === 'product_category_id' }" onSelected="() =&gt; this.filterClicked({ optionKey: 'deferred_grouping_field', optionValue: 'product_category_id', reload: true})">
                    Product Category
                </DropdownItem>

                <DropdownItem class="{ 'selected': controller.options.deferred_grouping_field === 'product_id' }" onSelected="() =&gt; this.filterClicked({ optionKey: 'deferred_grouping_field', optionValue: 'product_id', reload: true})">
                    Product
                </DropdownItem>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.deferred_report_warning_partially_generated", `/account_reports/static/src/components/deferred_reports/warnings.xml`, `<t t-name="account_reports.deferred_report_warning_partially_generated" xml:space="preserve">
        Deferrals have not yet been completely generated for this period.
        <div>
            <a type="button" t-on-click="(ev) =&gt; controller.reportAction(ev, 'open_deferral_entries', {})">
                Show already generated deferrals.
            </a>
        </div>
    </t>
    `);
registerTemplate("account_reports.deferred_report_warning_never_generated", `/account_reports/static/src/components/deferred_reports/warnings.xml`, `<t t-name="account_reports.deferred_report_warning_never_generated" xml:space="preserve">
        Deferrals have not yet been generated for this period.
    </t>
    `);
registerTemplate("account_reports.deferred_report_info_fully_generated", `/account_reports/static/src/components/deferred_reports/warnings.xml`, `<t t-name="account_reports.deferred_report_info_fully_generated" xml:space="preserve">
        <a type="button" t-on-click="(ev) =&gt; controller.reportAction(ev, 'open_deferral_entries', {})">
            Show already generated deferrals.
        </a>
    </t>
`);
registerTemplate("account_reports.GeneralLedgerLineName", `/account_reports/static/src/components/general_ledger/line_name.xml`, `<t t-name="account_reports.GeneralLedgerLineName" t-inherit="account_reports.AccountReportLineNameCustomizable" xml:space="preserve">
        <xpath expr="//t[@data-id='line_buttons']" position="inside">
            <t t-if="props.line.unfoldable">
                <button class="btn btn_action" t-on-click="(ev) =&gt; controller.reportAction(ev, 'open_journal_items', {                         line_id: props.line.id,                         view_ref: 'account.view_move_line_tree_grouped_partner',                     })">
                    Journal Items
                </button>
            </t>
        </xpath>
    </t>
`);
registerTemplate("account_reports.JournalReportFilterExtraOptions", `/account_reports/static/src/components/journal_report/filter_extra_options.xml`, `<t t-name="account_reports.JournalReportFilterExtraOptions" t-inherit="account_reports.AccountReportFilterExtraOptions" xml:space="preserve">
        <xpath expr="//Dropdown/t[@t-set-slot='content']" position="inside">
            <DropdownItem class="{ 'selected': controller.options.show_payment_lines }" onSelected="() =&gt; this.filterClicked({ optionKey: 'show_payment_lines', reload: true})" closingMode="'none'">
                Include Payments
            </DropdownItem>
        </xpath>
    </t>
`);
registerTemplate("account_reports.JournalReportFilters", `/account_reports/static/src/components/journal_report/filters.xml`, `<t t-name="account_reports.JournalReportFilters" t-inherit="account_reports.AccountReportFiltersCustomizable" xml:space="preserve">
        <xpath expr="//div[@id='filter_extra_options']" position="replace">
            <t t-call="account_reports.JournalReportFilterExtraOptions"/>
        </xpath>
    </t>
`);
registerTemplate("account_reports.JournalReportLine", `/account_reports/static/src/components/journal_report/line/line.xml`, `<t t-name="account_reports.JournalReportLine" t-inherit="account_reports.AccountReportLineCustomizable" xml:space="preserve">
        <xpath expr="//tr[@data-id='line']" position="attributes">
            <attribute name="t-if">!('is_tax_section_line' in props.line)</attribute>
        </xpath>

        <xpath expr="//tr[@data-id='line']" position="after">
            <t t-else="">
                <tr id="line" class="subtable" t-att-class="lineClasses">
                    <td t-att-colspan="2">
                        <t t-if="'tax_report_lines' in props.line">
                            <t t-set="taxesByCountry" t-value="props.line.tax_report_lines"/>
                            <t t-set="hasTaxesSeveralCountries" t-value="Object.keys(taxesByCountry).length &gt; 1"/>
                            <t t-set="extraColumns" t-value="props.line.extra_columns"/>

                            <table class="table">
                                <thead>
                                    <tr>
                                        <th t-att-colspan="(taxesByCountry.length &gt; 1 ? 4 : 3) + extraColumns">
                                            Taxes Applied
                                            <t t-if="controller.groups.account_user">
                                                <a class="btn btn_action" t-on-click="(ev) =&gt; this.openTaxJournalItems(ev, 'Taxes Applied', 'tax')">
                                                    Audit
                                                </a>
                                            </t>
                                        </th>
                                    </tr>
                                    <tr>
                                        <t t-if="hasTaxesSeveralCountries">
                                            <th>Country</th>
                                        </t>
                                        <th>Name</th>
                                        <th class="text-end">Base Amount</th>
                                        <th class="text-end">Tax Amount</th>
                                        <th t-if="props.line.tax_non_deductible_column" class="text-end">Non-Deductible</th>
                                        <th t-if="props.line.tax_deductible_column" class="text-end">Deductible</th>
                                        <th t-if="props.line.tax_due_column" class="text-end">Due</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <t t-foreach="taxesByCountry" t-as="country" t-key="country_index">
                                        <t t-foreach="props.line.tax_report_lines[country]" t-as="tax" t-key="tax_index">
                                            <tr>
                                                <t t-if="hasTaxesSeveralCountries">
                                                    <td t-out="(tax_index == 0) ? country : ''"/>
                                                </t>

                                                <td>
                                                    <a class="link" t-on-click="(ev) =&gt; controller.reportAction(ev,                                                             'journal_report_action_dropdown_audit_default_tax_report', {                                                                 line_id: tax.line_id,                                                                 date_form: props.line.date_from,                                                                 date_to: props.line.date_to,                                                         })">
                                                        <t t-out="tax.name"/>
                                                    </a>
                                                </td>

                                                <td class="text-end" t-out="tax.base_amount"/>
                                                <td class="text-end" t-out="tax.tax_amount"/>
                                                <td t-if="props.line.tax_non_deductible_column" class="text-end" t-out="tax.tax_non_deductible"/>
                                                <td t-if="props.line.tax_deductible_column" class="text-end" t-out="tax.tax_deductible"/>
                                                <td t-if="props.line.tax_due_column" class="text-end" t-out="tax.tax_due"/>
                                            </tr>
                                        </t>
                                    </t>
                                </tbody>
                            </table>
                        </t>
                    </td>

                    <td t-att-colspan="5">
                        <t t-set="taxGrids" t-value="props.line.tax_grid_summary_lines"/>

                        <t t-if="'tax_grid_summary_lines' in props.line and Object.keys(taxGrids).length">
                            <t t-set="hasTaxesGridsSeveralCountries" t-value="Object.keys(taxGrids).length &gt; 1"/>
                            <table class="table">
                                <thead>
                                    <tr>
                                        <th t-att-colspan="(hasTaxesGridsSeveralCountries) ? 5 : 4">
                                            Impacted Tax Grids
                                            <t t-if="controller.groups.account_user">
                                                <a class="btn btn_action" t-on-click="(ev) =&gt; this.openTaxJournalItems(ev, 'Impacted Tax Grids', 'tag')">
                                                    Audit
                                                </a>
                                            </t>
                                        </th>
                                    </tr>
                                    <tr>
                                        <t t-if="hasTaxesGridsSeveralCountries">
                                            <th>Country</th>
                                        </t>
                                        <th>Grid</th>
                                        <th class="text-end">+</th>
                                        <th class="text-end">-</th>
                                        <th class="text-end">Impact On Grid</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <t t-foreach="taxGrids" t-as="country" t-key="country_index">
                                        <t t-foreach="taxGrids[country]" t-as="grid" t-key="grid_index">
                                            <tr>
                                                <t t-if="hasSeveralGrids">
                                                    <td t-out="(grid_index == 0) ? country : ''"/>
                                                </t>

                                                <td>
                                                    <a class="link" t-on-click="(ev) =&gt; controller.reportAction(ev,                                                             'journal_report_tax_tag_template_open_aml', {                                                                 tag_ids: taxGrids[country][grid]['tag_ids'],                                                                 date_form: props.line.date_from,                                                                 date_to: props.line.date_to,                                                         })">
                                                        <t t-out="grid"/>
                                                    </a>
                                                </td>

                                                <td class="text-end" t-out="taxGrids[country][grid]['+'] || 0"/>
                                                <td class="text-end" t-out="taxGrids[country][grid]['-'] || 0"/>
                                                <td class="text-end" t-out="taxGrids[country][grid]['impact']"/>
                                            </tr>
                                        </t>
                                    </t>
                                </tbody>
                            </table>
                        </t>
                    </td>
                </tr>
            </t>
        </xpath>
    </t>
`);
registerTemplate("account_reports.JournalReportLineName", `/account_reports/static/src/components/journal_report/line_name.xml`, `<t t-name="account_reports.JournalReportLineName" t-inherit="account_reports.AccountReportLineNameCustomizable" xml:space="preserve">
        <xpath expr="//td[@data-id='line_name']//div[@data-id='content']" position="replace">
            <t t-if="'journal_id' in props.line and 'account_id' in props.line">
                <a class="link" t-on-click="                     (ev) =&gt; controller.reportAction(                         ev,                         'journal_report_action_open_account_move_lines_by_account',                         {                             journal_id: props.line.journal_id,                             account_id: props.line.account_id                         }                     )">
                    <t t-out="props.line.name"/>
                </a>
            </t>
            <t t-else="">
                <t t-out="props.line.name"/>

                <t t-if="'journal_id' in props.line">
                    <button class="btn btn_action" t-on-click="(ev) =&gt; controller.reportAction(ev, 'journal_report_open_aml_by_move', {                             journal_id: props.line.journal_id,                             line_id: props.line.id,                         })">
                        Audit
                    </button>
                </t>
            </t>
        </xpath>
    </t>
`);
registerTemplate("account_reports.MulticurrencyRevaluationReportFilterExchangeRate", `/account_reports/static/src/components/multicurrency_revaluation_report/filters/filter_exchange_rate.xml`, `<t t-name="account_reports.MulticurrencyRevaluationReportFilterExchangeRate" xml:space="preserve">
        <Dropdown menuClass="'account_report_filter exchange_rate'" onStateChanged="(isOpen) =&gt; !isOpen ? this.applyFilters('currency_rates') : null">
            <button class="btn btn-secondary">
                <i class="fa fa-line-chart"/> Exchange Rates
            </button>

            <t t-set-slot="content">
                <div class="dropdown-header pe-none">
                    1 <t t-out="controller.options.company_currency.currency_main"/>
                </div>

                <t t-foreach="Object.values(this.controller.options.currency_rates)" t-as="currencyRate" t-key="currencyRate.currency_id">
                    <div class="dropdown-item">
                        <div>
                            <input type="text" inputmode="numeric" t-att-value="currencyRate.rate" t-att-name="currencyRate.currency_id" t-on-change="(ev) =&gt; this.filterExchangeRate(ev, currencyRate.currency_id)"/>
                        </div>
                        <label class="d-flex align-items-center" t-att-for="currencyRate.currency_id">
                            <t t-out="currencyRate.currency_name"/>
                        </label>
                    </div>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.MulticurrencyRevaluationReportFilters", `/account_reports/static/src/components/multicurrency_revaluation_report/filters/filters.xml`, `<t t-name="account_reports.MulticurrencyRevaluationReportFilters" t-inherit="account_reports.AccountReportFiltersCustomizable" xml:space="preserve">
        <xpath expr="//div[@id='filter_extra_options']" position="before">
            <t t-if="'currency_rates' in this.controller.options">
                <div id="filter_exchange_rate" class="filter_exchange_rate">
                    <t t-call="account_reports.MulticurrencyRevaluationReportFilterExchangeRate"/>
                </div>
            </t>
        </xpath>
    </t>
`);
registerTemplate("account_reports.MulticurrencyRevaluationReportLineName", `/account_reports/static/src/components/multicurrency_revaluation_report/line_name.xml`, `<t t-name="account_reports.MulticurrencyRevaluationReportLineName" t-inherit="account_reports.AccountReportLineNameCustomizable" xml:space="preserve">
        <xpath expr="//t[@data-id='line_buttons']" position="inside">
            <t t-if="props.line.cur_revaluation_line_model === 'res.currency'">
                <Dropdown position="'right-start'">
                    <button class="btn btn_more">
                        <i class="fa fa-ellipsis-v"/>
                    </button>

                    <t t-set-slot="content">
                        <DropdownItem onSelected="(ev) =&gt; controller.reportAction(ev, 'action_multi_currency_revaluation_open_currency_rates', { line_id: props.line.id })">
                            Rates
                        </DropdownItem>
                    </t>
                </Dropdown>
            </t>

            <t t-if="props.line.cur_revaluation_line_model === 'account.account'">
                <Dropdown position="'right-start'">
                    <button class="btn btn_more">
                        <i class="fa fa-ellipsis-v"/>
                    </button>

                    <t t-set-slot="content">
                        <DropdownItem onSelected="(ev) =&gt; controller.reportAction(ev, 'action_multi_currency_revaluation_open_general_ledger', { line_id: props.line.id })">
                            General Ledger
                        </DropdownItem>

                        <DropdownItem onSelected="(ev) =&gt; controller.reportAction(ev, 'action_multi_currency_revaluation_toggle_provision', { line_id: props.line.id })">
                            <t t-esc="props.line.is_included_line ? 'Exclude' : 'Include'"/>
                        </DropdownItem>
                    </t>
                </Dropdown>
            </t>
        </xpath>
    </t>
`);
registerTemplate("account_reports.multi_currency_revaluation_report_warning_custom_rate", `/account_reports/static/src/components/multicurrency_revaluation_report/warnings.xml`, `<t t-name="account_reports.multi_currency_revaluation_report_warning_custom_rate" xml:space="preserve">
        You are using custom exchange rates.
        <button class="btn btn-link p-0 align-baseline" t-on-click="() =&gt; this.controller.updateOption('currency_rates', {}, true)">
            ⇒ Reset to Odoo’s Rate
        </button>
    </t>

    `);
registerTemplate("account_reports.multi_currency_revaluation_report_warning_multicompany", `/account_reports/static/src/components/multicurrency_revaluation_report/warnings.xml`, `<t t-name="account_reports.multi_currency_revaluation_report_warning_multicompany" xml:space="preserve">
        This report only displays the data of the active company.
    </t>
`);
registerTemplate("account_reports.PartnerLedgerReportFilterExtraOptions", `/account_reports/static/src/components/partner_ledger/filter_extra_options.xml`, `<t t-name="account_reports.PartnerLedgerReportFilterExtraOptions" t-inherit="account_reports.AccountReportFilterExtraOptions" xml:space="preserve">

        <xpath expr="//DropdownItem[contains(@class, 'filter_show_all_hook')]" position="after">
            <DropdownItem t-if="'hide_account' in controller.options" class="{ 'selected': controller.options.hide_account }" onSelected="() =&gt; this.filterClicked({ optionKey: 'hide_account', reload: true})" closingMode="'none'">
                Hide Account
            </DropdownItem>
            <DropdownItem t-if="'hide_debit_credit' in controller.options" class="{ 'selected': controller.options.hide_debit_credit }" onSelected="() =&gt; this.filterClicked({ optionKey: 'hide_debit_credit', reload: true})" closingMode="'none'">
                Hide Debit/Credit
            </DropdownItem>
        </xpath>
    </t>
`);
registerTemplate("account_reports.PartnerLedgerFilters", `/account_reports/static/src/components/partner_ledger/filters.xml`, `<t t-name="account_reports.PartnerLedgerFilters" t-inherit="account_reports.AccountReportFiltersCustomizable" xml:space="preserve">
        <xpath expr="//div[@id='filter_extra_options']" position="replace">
            <t t-call="account_reports.PartnerLedgerReportFilterExtraOptions"/>
        </xpath>
    </t>
`);
registerTemplate("account_reports.PartnerLedgerLineCell", `/account_reports/static/src/components/partner_ledger/line_cell.xml`, `<t t-name="account_reports.PartnerLedgerLineCell" t-inherit="account_reports.AccountReportLineCell" xml:space="preserve"/>
`);
registerTemplate("account_reports.PartnerLedgerLineName", `/account_reports/static/src/components/partner_ledger/line_name.xml`, `<t t-name="account_reports.PartnerLedgerLineName" t-inherit="account_reports.AccountReportLineNameCustomizable" xml:space="preserve">
        <xpath expr="//td[@data-id='line_name']" position="attributes">
            <t t-if="props.line.unfoldable">
                <attribute name="class" add="more" separator=" "/>
            </t>
        </xpath>

        <xpath expr="//t[@data-id='line_buttons']" position="inside">
            <t t-if="props.line.unfoldable">
                <button class="btn btn_action" t-on-click="(ev) =&gt; controller.reportAction(ev, 'action_open_partner', { id: props.line.id })">
                    Partner
                </button>

                <button class="btn btn_action" t-on-click="(ev) =&gt; controller.reportAction(ev, 'open_journal_items', {                     line_id: props.line.id,                     view_ref: 'account.view_move_line_tree_grouped_partner',                 })">
                    Journal Items
                </button>
            </t>
        </xpath>

        <xpath expr="//button[@data-id='btn_foldable']" position="after">
            <t t-if="props.line.trust === 'good'">
                <i class="fa fa-circle text-success partner_trust" title="Partner is good"/>
            </t>
            <t t-elif="props.line.trust === 'bad'">
                <i class="fa fa-circle text-danger partner_trust" title="Partner is bad"/>
            </t>
        </xpath>
    </t>
`);
registerTemplate("account_reports.redirectAction", `/account_reports/static/src/components/redirectAction/redirectAction.xml`, `<t t-name="account_reports.redirectAction" xml:space="preserve">
        <Dialog size="'md'">
            <div role="alert">
                <p class="text-prewrap" t-esc="props.action.params.message"/>
            </div>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="openClientAction" t-esc="props.action.params.button_text"/>
                <button class="btn btn-secondary" t-on-click="close">Cancel</button>
            </t>
        </Dialog>
    </t>
`);
registerTemplate("account_reports.SalesReportFilterCode", `/account_reports/static/src/components/sales_report/filters/filter_code.xml`, `<t t-name="account_reports.SalesReportFilterCode" xml:space="preserve">
        <Dropdown>
            <button class="btn btn-secondary">
                <i class="fa fa-filter me-1"/> Codes: <t t-esc="selectedEcTaxName"/>
            </button>

            <t t-set-slot="content">
                <t t-foreach="controller.options.ec_tax_filter_selection" t-as="ecTax" t-key="ecTax_index">
                    <DropdownItem class="{ 'selected':  ecTax.selected }" onSelected="() =&gt; this.filterClicked({ optionKey: 'ec_tax_filter_selection.'+ ecTax_index + '.selected', reload: true})" closingMode="'none'" t-out="ecTax.name"/>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_reports.SalesReportFilters", `/account_reports/static/src/components/sales_report/filters/filters.xml`, `<t t-name="account_reports.SalesReportFilters" t-inherit="account_reports.AccountReportFiltersCustomizable" xml:space="preserve">
        <xpath expr="//t[@t-if='hasExtraOptionsFilter']" position="before">
            <t t-if="hasCodesFilter" t-call="account_reports.SalesReportFilterCode"/>
        </xpath>
    </t>
`);
registerTemplate("account_reports.sales_report_warning_non_ec_country", `/account_reports/static/src/components/sales_report/warnings.xml`, `<t t-name="account_reports.sales_report_warning_non_ec_country" xml:space="preserve">
        Intra-community taxes are applied on
        <a t-on-click="(ev) =&gt; controller.reportAction(ev, 'get_warning_act_window', { type: 'non_ec_country', model: 'move' })">invoices</a>
        addressed to
        <a t-on-click="(ev) =&gt; controller.reportAction(ev, 'get_warning_act_window', { type: 'non_ec_country', model: 'partner' })">partners</a>
        who are not established in any of the EC countries.
    </t>

    `);
registerTemplate("account_reports.sales_report_warning_missing_vat", `/account_reports/static/src/components/sales_report/warnings.xml`, `<t t-name="account_reports.sales_report_warning_missing_vat" xml:space="preserve">
        Intra-community taxes are applied on
        <a t-on-click="(ev) =&gt; controller.reportAction(ev, 'get_warning_act_window', { type: 'no_vat', model: 'move' })">invoices</a>
        addressed to
        <a t-on-click="(ev) =&gt; controller.reportAction(ev, 'get_warning_act_window', { type: 'no_vat', model: 'partner' })">partners</a>
        without a valid intra-community VAT number.
    </t>

    `);
registerTemplate("account_reports.sales_report_warning_same_country", `/account_reports/static/src/components/sales_report/warnings.xml`, `<t t-name="account_reports.sales_report_warning_same_country" xml:space="preserve">
        Intra-community taxes are applied on
        <a t-on-click="(ev) =&gt; controller.reportAction(ev, 'get_warning_act_window', { type: 'same_country', model: 'move' })">invoices</a>
        addressed to
        <a t-on-click="(ev) =&gt; controller.reportAction(ev, 'get_warning_act_window', { type: 'same_country', model: 'partner' })">partners</a>
        that are not established abroad.
    </t>
`);
registerTemplate("account_reports.TaxReportFilterDate", `/account_reports/static/src/components/tax_report/filters/filter_date.xml`, `<t t-name="account_reports.TaxReportFilterDate" t-inherit="account_reports.AccountReportFilterDate" xml:space="preserve">
        <xpath expr="//t[last()]/t[@t-call='account_reports.AccountReportFilterDateSelection']" position="before">
            <DropdownItem t-if="this.controller.options.show_tax_period_filter" class="{ 'd-flex justify-content-between date_filter': true, 'selected': (this.isPeriodSelected('tax_period')) }" onSelected="() =&gt; this.selectDateFilter('tax_period', controller.options.date.period_type != 'tax_period')" closingMode="'none'">
                <div class="filter_name pe-3">
                    Tax Period
                </div>

                <div class="d-flex justify-content-between">
                    <button class="btn_previous_date fa fa-caret-left" t-on-click="() =&gt; this.selectPreviousPeriod('tax_period')"/>
                    <time class="d-flex justify-content-center" style="min-width: 120px;">
                        <t t-out="this.displayPeriod('tax_period')"/>
                    </time>
                    <button class="btn_next_date fa fa-caret-right" t-on-click="() =&gt; this.selectNextPeriod('tax_period')"/>
                </div>
            </DropdownItem>
            <div id="filter_date_divider_range_period" class="dropdown-divider"/>
        </xpath>
    </t>
`);
registerTemplate("account_reports.GenericTaxReportFiltersCustomizable", `/account_reports/static/src/components/tax_report/filters/filters.xml`, `<t t-name="account_reports.GenericTaxReportFiltersCustomizable" t-inherit="account_reports.AccountReportFiltersCustomizable" xml:space="preserve">
        <xpath expr="//div[@id='filter_date']/t[@t-call]" position="replace">
            <t t-call="account_reports.TaxReportFilterDate"/>
        </xpath>
    </t>
`);
registerTemplate("account_reports.TaxReportLineName", `/account_reports/static/src/components/tax_report/line_name.xml`, `<t t-name="account_reports.TaxReportLineName" t-inherit="account_reports.AccountReportLineNameCustomizable" xml:space="preserve">
        <xpath expr="//div[@data-id='content']" position="before">
            <t t-if="props.line.alert">
                <i class="fa fa-exclamation-circle consistency_warning"/>
            </t>
        </xpath>
    </t>
`);
registerTemplate("account_reports.tax_report_warning_inactive_tags", `/account_reports/static/src/components/tax_report/warnings.xml`, `<t t-name="account_reports.tax_report_warning_inactive_tags" owl="1" xml:space="preserve">
        Some journal items appear to point to obsolete report lines.
        <a type="button" t-on-click="(ev) =&gt; controller.reportAction(ev, 'action_open_amls_with_archived_tags')">Check them</a>
        and correct their tax tags if necessary.
    </t>

    `);
registerTemplate("account_reports.tax_report_warning_lines_consistency", `/account_reports/static/src/components/tax_report/warnings.xml`, `<t t-name="account_reports.tax_report_warning_lines_consistency" owl="1" xml:space="preserve">
        This report contains inconsistencies. The affected lines are marked with a warning.
    </t>

    `);
registerTemplate("account_reports.tax_report_warning_tax_id_selected_companies", `/account_reports/static/src/components/tax_report/warnings.xml`, `<t t-name="account_reports.tax_report_warning_tax_id_selected_companies" xml:space="preserve">
        All selected companies or branches do not share the same Tax ID. Please check the Tax ID of the selected companies.
    </t>
`);
registerTemplate("account_reports.AccountReportList", `/account_reports/static/src/widgets/account_report_x2many/account_report_x2many.xml`, `<t t-name="account_reports.AccountReportList" xml:space="preserve">
        <div class="account_report_lines_list_x2many">
            <ul class="p-0" t-ref="root">

                <li class="d-flex justify-content-between">

                    <t t-foreach="columns" t-as="column" t-key="column.id">
                        <t t-set="isNameColumn" t-value="column.name === 'name'"/>

                        <span class="column fw-bold" t-att-class="{                                 'fluid': isNameColumn,                                 'fixed': !isNameColumn,                             }" t-out="column.label || column.name"/>
                    </t>


                    <t t-call="account_reports.AccountReportOptionalColumnSelector"/>
                </li>


                <t t-call="account_reports.AccountReportListTree">
                    <t t-set="lines" t-value="this.formatData()"/>
                </t>


                <t t-if="props.activeActions.create">
                    <li>
                        <a class="column overlined" href="#" role="button" t-on-click.stop.prevent="() =&gt; this.add({})">
                            Add a line
                        </a>
                    </li>
                </t>


                <span class="overlined"/>
            </ul>
        </div>
    </t>

    `);
registerTemplate("account_reports.AccountReportListTree", `/account_reports/static/src/widgets/account_report_x2many/account_report_x2many.xml`, `<t t-name="account_reports.AccountReportListTree" xml:space="preserve">
        <t t-foreach="lines" t-as="line" t-key="line.id">
            <li class="draggable" t-att-data-record_index="line.index" t-att-data-record_id="line.id" t-att-data-descendants_count="line.descendants_count">
                <div class="d-flex justify-content-between overlined">
                    <t t-set="record" t-value="this.props.list.records[line.index]"/>


                    <span class="oi oi-draggable o_row_handle"/>


                    <t t-foreach="columns" t-as="column" t-key="column.id">
                        <t t-set="isNameColumn" t-value="column.name === 'name'"/>

                        <span class="column" t-att-class="{                                 'fluid': isNameColumn,                                 'fixed': !isNameColumn,                             }" t-on-click="(ev) =&gt; this.onCellClicked(record, column, ev)">
                            <t t-out="isNameColumn ? line[column.name] : getFormattedValue(column, record)"/>

                            <t t-if="line.out_of_sequence_error">
                                <span class="text-danger" data-tooltip="This line is placed before its parent, which is not allowed. You can fix it by dragging it to the proper position.">
                                    <i class="fa fa-exclamation-circle text-danger ms-2 me-1"/>
                                    This line is out of sequence.
                                </span>
                            </t>
                        </span>
                    </t>


                    <t t-if="props.activeActions.delete">
                        <button class="trash" t-on-click="() =&gt; this.onDeleteRecord(line.index)">
                            <i class="fa fa-trash-o"/>
                        </button>
                    </t>
                </div>

                <t t-if="line.children?.length">
                    <ul>
                        <t t-call="account_reports.AccountReportListTree">
                            <t t-set="lines" t-value="line.children"/>
                        </t>
                    </ul>
                </t>
            </li>
        </t>
    </t>

    `);
registerTemplate("account_reports.AccountReportOptionalColumnSelector", `/account_reports/static/src/widgets/account_report_x2many/account_report_x2many.xml`, `<t t-name="account_reports.AccountReportOptionalColumnSelector" xml:space="preserve">
        <Dropdown position="'bottom-end'">
            <button>
                <i class="filter"/>
            </button>

            <t t-set-slot="content">
                <t t-foreach="optionalFieldGroups" t-as="group" t-key="group_index">
                    <t t-foreach="group.optionalFields" t-as="field" t-key="field_index">
                        <DropdownItem closingMode="'none'" onSelected="() =&gt; this.toggleOptionalField(field.name)">
                            <CheckBox name="field.name" value="field.value" onChange="() =&gt; this.toggleOptionalField(field.name)">
                                <span class="d-flex align-items-center">
                                    <span class="text-truncate" t-out="field.label"/>

                                    <t t-if="env.debug">
                                        <span class="ps-1" t-out="' (' + field.name + ')'"/>
                                    </t>
                                </span>
                            </CheckBox>
                        </DropdownItem>
                    </t>
                </t>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_asset.DepreciationScheduleFilters", `/account_asset/static/src/components/depreciation_schedule/filters.xml`, `<t t-name="account_asset.DepreciationScheduleFilters" t-inherit="account_reports.AccountReportFiltersCustomizable" xml:space="preserve">
        <xpath expr="//div[@id='filter_extra_options']" position="before">
            <t t-call="account_asset.DepreciationScheduleGroupBy"/>
        </xpath>
    </t>
`);
registerTemplate("account_asset.DepreciationScheduleGroupBy", `/account_asset/static/src/components/depreciation_schedule/groupby.xml`, `<t t-name="account_asset.DepreciationScheduleGroupBy" xml:space="preserve">
        <Dropdown>
            <button class="btn btn-secondary">
                <i class="fa fa-list me-1"/>
                <t t-if="controller.options.assets_grouping_field === 'account_id'">
                    Group by Account
                </t>
                <t t-elif="controller.options.assets_grouping_field === 'asset_group_id'">
                    Group by Asset Group
                </t>
                <t t-elif="controller.options.assets_grouping_field === 'none'">
                    No Grouping
                </t>
            </button>

            <t t-set-slot="content">
                <DropdownItem class="{ 'selected': controller.options.assets_grouping_field === 'account_id' }" onSelected="() =&gt; this.filterClicked({ optionKey: 'assets_grouping_field', optionValue: 'account_id', reload: true})">
                    Group By Account
                </DropdownItem>

                <DropdownItem class="{ 'selected': controller.options.assets_grouping_field === 'asset_group_id' }" onSelected="() =&gt; this.filterClicked({ optionKey: 'assets_grouping_field', optionValue: 'asset_group_id', reload: true})">
                    Group By Asset Group
                </DropdownItem>

                <DropdownItem class="{ 'selected': controller.options.assets_grouping_field === 'none'}" onSelected="() =&gt; this.filterClicked({ optionKey: 'assets_grouping_field', optionValue: 'none', reload: true})">
                    No Grouping
                </DropdownItem>
            </t>
        </Dropdown>
    </t>
`);
registerTemplate("account_asset.moveReversed", `/account_asset/static/src/components/move_reversed/move_reversed.xml`, `<t t-name="account_asset.moveReversed" xml:space="preserve">
        <i t-if="props.record.data[props.name].records.length" class="fa fa-exclamation-circle" title="This move has been reversed"/>
    </t>
`);
registerTemplate("ImportAction", `/base_import/static/src/import_action/import_action.xml`, `<t t-name="ImportAction" xml:space="preserve">
        <div t-ref="root" class="h-100 d-flex flex-column">
            <Layout className="'o_import_action d-flex h-100 overflow-auto'" display="display">
                <t t-set-slot="control-panel-create-button">
                    <t t-if="isPreviewing">
                        <button t-if="!state.isPaused" type="button" class="btn btn-primary" t-on-click="() =&gt; this.handleImport(false)">Import</button>
                        <button t-else="" type="button" class="btn btn-primary" t-on-click="() =&gt; this.handleImport(false)">Resume</button>
                        <button type="button" class="btn btn-secondary" t-on-click="() =&gt; this.handleImport(true)">Test</button>
                    </t>
                    <FileInput acceptedFileExtensions="'.csv, .xls, .xlsx, .xlsm, .ods'" onUpload.bind="(data, files) =&gt; this.handleFilesUpload(files)" resId="model.id" resModel="this.resModel" route="this.uploadFilesRoute">
                        <button t-if="isPreviewing" type="button" class="btn btn-secondary">Load Data File</button>
                        <button t-else="" type="button" class="btn btn-primary o_import_file">Upload Data File</button>
                    </FileInput>
                    <button t-on-click="() =&gt; this.exit()" type="button" class="btn btn-secondary">Cancel</button>
                </t>
                <t t-if="isPreviewing">
                    <ImportDataSidepanel filename="state.filename" options="importOptions" formattingOptions="formattingOptions" importTemplates="importTemplates" isBatched="isBatched" onOptionChanged.bind="onOptionChanged" onReload.bind="reload" hasBinaryFields="hasBinaryFields" binaryFilesParams="model.binaryFilesParams" onBinaryFilesParamsChanged.bind="(name, value) =&gt; model.onBinaryFilesParamsChanged(name, value)"/>
                    <ImportDataContent columns="model.columns" onFieldChanged.bind="onFieldChanged" onOptionChanged.bind="onOptionChanged" options="importOptions" isFieldSet.bind="isFieldSet" previewError="state.previewError" importMessages="model.importMessages"/>
                </t>
                <div t-else="" class="o_view_nocontent">
                    <div class="o_nocontent_help">
                        <p class="o_view_nocontent_smiling_face">
                            Drop or upload a file to import
                        </p>
                        <p>
                            Excel files are recommended as formatting is automatic.<br/>
                            But, you can also use .csv files
                        </p>
                        <div class="mt16 mb4">
                            Need Help? <DocumentationLink path="'/applications/general/export_import_data.html'" label.translate="Import FAQ"/>
                        </div>
                        <div t-foreach="importTemplates" t-as="template" t-key="template">
                            <a class="btn btn-outline-primary mb32 mt8" t-att-href="template.template" aria-label="Download" data-tooltip="Download">
                                <i class="fa fa-download"/> <span><t t-esc="template.label"/></span>
                            </a>
                        </div>
                    </div>
                </div>
            </Layout>
        </div>
    </t>
`);
registerTemplate("base_import.BlockUI", `/base_import/static/src/import_block_ui.xml`, `<t t-name="base_import.BlockUI" xml:space="preserve">
        <div class="o_blockUI fixed-top d-flex justify-content-center align-items-center flex-column vh-100 bg-black-50">
            <div class="o_spinner mb-4">
                <img src="/web/static/img/spin.svg" alt="Loading..."/>
            </div>
            <div t-if="props.message or props.blockComponent">
                <div class="o_message text-center px-4" t-esc="props.message"/>
                <t t-if="props.blockComponent" t-component="props.blockComponent.class" t-props="props.blockComponent.props"/>
            </div>
        </div>
    </t>

`);
registerTemplate("ImportDataColumnError", `/base_import/static/src/import_data_column_error/import_data_column_error.xml`, `<t t-name="ImportDataColumnError" xml:space="preserve">
        <div class="o_import_report alert alert-danger mb-2">
            <t t-if="props.errors.length &gt; 1">
                <p>
                    <t t-if="props.errors[0].value">No matching records found for the following name </t>
                    <t t-else="">Multiple errors occurred </t>
                      in field <b t-esc="props.fieldInfo.label"/>:
                </p>
                <ul>
                    <t t-foreach="props.errors" t-as="error" t-key="error_index">
                        <a t-if="error_index === 3" href="#" class="o_import_report_count" t-on-click="() =&gt; this.state.isExpanded = !this.state.isExpanded">
                            <i t-attf-class="fa fa-chevron-{{state.isExpanded ? 'up' : 'down'}}"/> <t t-esc="props.errors.length - error_index"/> more
                        </a>
                        <li t-if="isErrorVisible(error_index)" t-attf-class="o_import_report_more p-0 text-{{error.priority}} {{error_index &gt; 2 ? 'list-unstyled' : ''}}">
                            <t t-if="error.rows.from === error.rows.to">
                                <b t-esc="error.value"/> at row <t t-esc="error.rows.from + 1"/>
                                <t t-if="props.resultNames and props.resultNames.length &gt; error.rows.from and props.resultNames[error.rows.from] !== ''">
                                    (<t t-esc="props.resultNames[error.rows.from]"/>)
                                </t>
                            </t>
                            <t t-else=""><b t-esc="error.value || error.message"/> at multiple rows</t>
                        </li>
                    </t>
                </ul>
            </t>
            <p t-else="" t-attf-class="mb-0 p-2 alert-{{props.errors[0].type}}" t-esc="props.errors[0].message"/>
            <t t-if="moreInfo">
                <t t-if="typeof moreInfo === 'string'" t-esc="moreInfo"/>
                <div t-else="" class="o_import_moreinfo" t-on-click="onMoreInfoClicked">
                    <a href="#" class="o_import_see_all">
                        <i class="oi oi-arrow-right"/> See possible values
                    </a>
                </div>
                <ul t-if="state.moreInfoContent" class="o_import_report_more">
                    <li t-foreach="state.moreInfoContent" t-as="msg" t-key="msg_index"><t t-esc="msg"/></li>
                </ul>
            </t>
        </div>
    </t>
`);
registerTemplate("ImportDataContent", `/base_import/static/src/import_data_content/import_data_content.xml`, `<t t-name="ImportDataContent" xml:space="preserve">
        <div class="o_import_data_content flex-grow-1 overflow-auto border-start">
            <div t-if="props.previewError" class="border-bottom p-2">
                <div class="alert alert-danger mb-0">
                    <p>
                        Import preview failed due to: "
                        <t t-esc="props.previewError"/>
                        ".
                    </p>
                    <p>For CSV files, you may need to select the correct separator.</p>
                    <p t-if="props.columns.length &gt; 0">Here is the start of the file we could not import:</p>
                </div>
            </div>
            <div t-if="!props.options.has_headers" class="border-bottom p-2">
                <p class="alert alert-info mb-0">
                    If the file contains
                    the column names, Odoo can try auto-detecting the
                    field corresponding to the column. This makes imports
                    simpler especially when the file has many columns.
                </p>
            </div>
            <div t-if="props.importMessages.length &gt; 0" class="border-bottom p-2">
                <t t-foreach="props.importMessages" t-as="message" t-key="\`\${message.lines[0]}-\${message_index}\`">
                    <p t-att-class="getErrorMessageClass(props.importMessages, message.type, message_index)">
                        <t t-foreach="message.lines" t-as="line" t-key="\`\${line}-\${line_index}\`">
                            <b t-esc="line"/><br/>
                        </t>
                    </p>
                </t>
            </div>
            <table t-if="!props.previewError" class="table table-borderless w-100 bg-view">
                <thead>
                    <tr class="border-bottom">
                        <th scope="col">File Column</th>
                        <th scope="col">Odoo Field</th>
                        <th scope="col">Comments</th>
                    </tr>
                </thead>
                <tbody>
                    <t t-foreach="props.columns" t-as="column" t-key="\`\${column_index}-\${column.id}\`">
                        <tr class="border-bottom align-middle">
                            <td>
                                <div class="o_import_file_column_cell d-flex flex-column user-select-none">
                                    <span class="fw-bold text-truncate">
                                        <span class="text-truncate" t-if="column.name" t-esc="column.name"/>
                                        <span t-else="">Untitled</span>
                                    </span>
                                    <span t-if="props.options.has_headers" class="o_import_preview fst-italic small pe-2" data-tooltip-template="ImportDataContent.tooltip" t-att-data-tooltip-info="getTooltip(column)" data-tooltip-position="right">
                                        <t t-esc="column.preview"/>
                                    </span>
                                </div>
                            </td>
                            <td>
                                <SelectMenu value="column.fieldInfo ? column.fieldInfo.fieldPath : undefined" groups="getGroups(column)" onSelect="(fieldPath) =&gt; this.onFieldChanged(column, fieldPath)" searchPlaceholder.translate="Search a field..." togglerClass="column.fieldInfo ? 'ps-1' : ''">
                                    <t t-if="column.fieldInfo">
                                        <i class="o_import_field_icon border-end" t-att-class="'position-absolute d-inline-block o_import_field_icon_' + column.fieldInfo.type" data-tooltip-template="web.FieldTooltip" t-att-data-tooltip-info="getTooltipDetails(column.fieldInfo)"/>
                                        <span class="ps-5">
                                            <t t-esc="column.fieldInfo.label"/>
                                        </span>
                                    </t>
                                    <span t-else="" class="text-warning">To import, select a field...</span>

                                    <t t-set-slot="choice" t-slot-scope="choice">
                                        <div t-att-class="\`\${choice.data.value and choice.data.value.required ? 'fw-bolder text-decoration-underline' : ''}\`">
                                            <i class="o_import_field_choice o_import_field_icon position-relative d-inline-block align-middle border-end me-2" t-att-class="choice.data.iconClass"/>
                                            <t t-esc="choice.data.label"/>
                                        </div>
                                    </t>
                                </SelectMenu>
                            </td>
                            <td>
                                <t t-foreach="column.comments" t-as="comment" t-key="comment_index">
                                    <p class="m-0 p-2 alert" t-att-class="getCommentClass(column, comment, comment_index)"><t t-out="comment.content"/> <b t-if="comment.fieldName" t-out="comment.fieldName"/></p>
                                </t>
                                <ImportDataColumnError t-if="column.errors.length" errors="column.errors" resultNames="column.resultNames" fieldInfo="column.fieldInfo"/>
                                <ImportDataOptions t-if="column.errors.length or column.importOptions" importOptions="column.importOptions" fieldInfo="column.fieldInfo" onOptionChanged="props.onOptionChanged"/>
                            </td>
                        </tr>
                    </t>
                </tbody>
            </table>
        </div>
    </t>

    `);
registerTemplate("ImportDataContent.tooltip", `/base_import/static/src/import_data_content/import_data_content.xml`, `<t t-name="ImportDataContent.tooltip" xml:space="preserve">
        <h5 class="text-reset p-2 m-0">Preview</h5>
        <hr class="m-0"/>
        <div class="p-2 pe-3">
            <p t-foreach="lines" t-as="line" t-key="line_index" t-out="line" class="mb-0 fs-6"/>
        </div>
    </t>
`);
registerTemplate("ImportDataOptions", `/base_import/static/src/import_data_options/import_data_options.xml`, `<t t-name="ImportDataOptions" xml:space="preserve">
        <div t-if="isVisible and state.options.length &gt; 1" t-attf-class="o_import_dropdown o_import_field_#{props.fieldInfo.type} alert alert-danger mb-2">
            <b>When a value cannot be matched:</b>
            <select class="o_import_create_option form-select w-auto bg-light" t-att-type="props.fieldInfo.type" t-on-change="onSelectionChanged">
                <option t-foreach="state.options" t-as="option" t-key="option" t-att-value="option[0]">
                    <t t-esc="option[1]"/>
                </option>
            </select>
        </div>
    </t>
`);
registerTemplate("ImportDataProgress", `/base_import/static/src/import_data_progress/import_data_progress.xml`, `<t t-name="ImportDataProgress" xml:space="preserve">
        <div t-if="props.importProgress.step &gt; 1" class="o_import_data_progress d-flex align-items-center flex-column">
            <div class="o_import_progress_dialog_batch text-center">
                Batch <span class="o_import_progress_dialog_batch_count"><t t-esc="props.importProgress.step"/></span> out of <span t-esc="props.totalSteps"/>...
                <div t-if="props.importProgress.value and state.timeLeft and !state.isInterrupted" class="o_import_progress_dialog_time_left">
                    <span>Estimated time left:</span>
                    <t t-if="state.timeLeft &gt;= 1">
                        <span class="o_import_progress_dialog_time_left_text mx-1" t-esc="minutesLeft"/><span>minutes</span>
                    </t>
                    <t t-else="">
                        <span class="o_import_progress_dialog_time_left_text mx-1" t-esc="secondsLeft"/><span>seconds</span>
                    </t>
                </div>
            </div>
            <span t-if="state.isInterrupted" class="o_import_progress_dialog_stop">
                Finalizing current batch before interrupting...
            </span>
            <div t-else="" class="d-flex align-items-center mt-2">
                <div class="progress flex-grow-1 rounded-3">
                    <div class="progress-bar progress-bar-striped" role="progressbar" aria-valuenow="props.importProgress" aria-valuemin="0" aria-valuemax="100" aria-label="Progress bar" t-att-style="'width: ' + props.importProgress.value + '%'">
                        <span class="fs-4"><t t-esc="props.importProgress.value"/>%</span>
                    </div>
                </div>
                <a class="o_progress_stop_import ms-2" role="button" t-on-click="interrupt"><i class="fa fa-close fs-2 text-danger" aria-label="Stop Import" title="Stop Import"/></a>
            </div>
        </div>
    </t>
`);
registerTemplate("ImportDataSidepanel", `/base_import/static/src/import_data_sidepanel/import_data_sidepanel.xml`, `<t t-name="ImportDataSidepanel" xml:space="preserve">
        <div class="o_import_data_sidepanel p-3 bg-view">
            <div class="pb-4">
                <h4>Data to import</h4>
                <div class="mb-2 d-flex align-items-center">
                    <i class="fa fa-file white me-2"/>
                    <div class="fst-italic truncate"><t t-esc="fileName"/></div>
                    <span class="fst-italic"><t t-esc="fileExtension"/></span>
                </div>

                <div t-if="props.options.sheets.length &gt; 0" class="flex-row my-2">
                    <label for="o_import_sheet">Sheet:</label>
                    <select class="o_select o_import_sheet w-100 mb-3 form-select" name="o_import_sheet" t-on-change="ev =&gt; this.props.onOptionChanged('sheet', ev.target.value)" t-att-value="props.options.sheet">
                        <option t-foreach="props.options.sheets" t-as="sheet" t-key="sheet" t-att-value="sheet" t-att-selected="sheet === props.options.sheet">
                            <t t-esc="sheet"/>
                        </option>
                    </select>
                </div>
                <CheckBox value="props.options.has_headers" onChange.bind="isChecked =&gt; this.props.onOptionChanged('has_headers', isChecked)">
                    Use first row as header
                </CheckBox>
            </div>
            <div t-if="fileExtension === '.csv'" class="o_import_formatting pt-3 pb-4 border-top">
                <h4>Formatting</h4>
                <div t-foreach="Object.entries(props.formattingOptions)" t-as="option" t-key="\`\${option[0]}-\${option_index}\`" class="o_import_options">
                    <label t-att-for="\`\${option[0]}-\${option_index}\`">
                        <t t-esc="option[1].label"/>
                        <sup t-if="option[1].help" class="text-info p-1" t-att-data-tooltip="option[1].help" t-esc="'?'"/>
                    </label>
                    <input t-if="option[1].type === 'input'" t-att-id="\`\${option[0]}-\${option_index}\`" t-att-list="option[1].options ? \`list-\${ option_index }\` : null" t-attf-class="o_import_#{option[0]} o_import_dropdown w-100 mb-3" t-att-value="option[1].value" t-on-change="(ev) =&gt; this.setOptionValue(option[0], ev.target.value)"/>
                    <datalist t-if="option[1].type === 'input' and option[1].options" t-att-id="\`list-\${ option_index }\`">
                        <option t-foreach="option[1].options" t-as="opt" t-key="opt_index" t-att-value="opt.value or opt" t-att-selected="opt.value ? opt.value === option[1].value : opt === option[1].value">
                            <t t-esc="opt.label ? opt.label : opt"/>
                        </option>
                    </datalist>
                    <select t-elif="option[1].type === 'select'" t-att-class="\`o_select form-select w-100 mb-3 o_import_\${option[0]} o_import_dropdown\`" t-att-name="\`\${option[0]}-\${option_index}\`" t-on-change="(ev) =&gt; this.setOptionValue(option[0], ev.target.value)">
                        <option t-foreach="option[1].options" t-as="opt" t-key="opt_index" t-att-value="opt.value or opt.value === '' ? opt.value : opt" t-att-selected="opt.value or opt.value === '' ? opt.value === option[1].value : opt === option[1].value">
                            <t t-esc="opt.label ? opt.label : opt"/>
                        </option>
                    </select>
                </div>
                <button class="btn btn-primary w-100" t-on-click="() =&gt; this.props.onReload()">Reimport</button>
            </div>
            <div t-if="props.isBatched" class="pt-3 pb-4 border-top">
                <h4>Batch Import</h4>
                <div class="o_import_batch_alert fw-bold pb-2">
                    The file will be imported by batches
                </div>
                <div class="d-flex">
                    <div class="o_import_batch_limit w-50 pe-1">
                        <label class="mb-1" for="o_import_batch_limit">Batch limit</label>
                        <input class="w-100" id="o_import_batch_limit" t-att-value="getOptionValue('limit')" t-on-change="(ev) =&gt; this.setOptionValue('limit', ev.target.value || 1)"/>
                    </div>
                    <div class="w-50 ps-1" data-tooltip="Warning: ignores the labels line, empty lines and lines composed only of empty cells">
                        <label class="mb-1" for="o_import_row_start">Start at line</label>
                        <input class="w-100" id="o_import_row_start" t-att-value="getOptionValue('skip')" t-on-change="onLimitChange"/>
                    </div>
                </div>
            </div>
            <div t-if="props.hasBinaryFields" class="pt-3 pb-4 border-top o_import_file">
                <h4>Files to import</h4>
                <div class="o_import_grid gap-1">

                    <div class="o_import_grid_col">
                        <label>
                            <span class="btn btn-sm btn-primary">Upload your files</span>
                            <input type="file" multiple="multiple" hidden="hidden" t-on-change="(event) =&gt; this.props.onBinaryFilesParamsChanged('binaryFiles', event.target.files)"/>
                        </label>
                    </div>
                    <div class="o_import_grid_col o_grid_span_2">
                        <t t-esc="binaryFilesLabel"/>
                    </div>


                    <t t-if="env.debug">
                        <div class="o_import_grid_col">
                            <label for="o_input_maxSizePerBatch">Max size per batch</label>
                            <sup t-if="props.binaryFilesParams.maxSizePerBatch.help" class="text-info p-1 cursor-default" t-att-data-tooltip="props.binaryFilesParams.maxSizePerBatch.help" t-esc="'?'"/>
                        </div>
                        <div class="o_import_grid_col">
                                <input type="number" id="o_input_maxSizePerBatch" t-att-value="props.binaryFilesParams.maxSizePerBatch.value" t-att-max="props.binaryFilesParams.maxSizePerBatch.max" t-att-min="props.binaryFilesParams.maxSizePerBatch.min" t-on-change="(event) =&gt; this.props.onBinaryFilesParamsChanged('maxSizePerBatch', event.target.value)"/>
                        </div>
                        <div class="o_import_grid_col">
                            <label for="o_input_maxSizePerBatch">Mb</label>
                        </div>


                        <div class="o_import_grid_col">
                            <label for="o_input_delayAfterEachBatch">Delay after each batch</label>
                            <sup t-if="props.binaryFilesParams.delayAfterEachBatch.help" class="text-info p-1 cursor-default" t-att-data-tooltip="props.binaryFilesParams.delayAfterEachBatch.help" t-esc="'?'"/>
                        </div>
                        <div class="o_import_grid_col">
                                <input type="number" id="o_input_delayAfterEachBatch" t-att-value="props.binaryFilesParams.delayAfterEachBatch.value" t-att-min="props.binaryFilesParams.delayAfterEachBatch.min" t-on-change="(event) =&gt; this.props.onBinaryFilesParamsChanged('delayAfterEachBatch', event.target.value)"/>
                        </div>
                        <div class="o_import_grid_col">
                            <label for="o_input_delayAfterEachBatch">seconds</label>
                        </div>
                    </t>
                </div>

            </div>
            <div t-if="env.debug" class="o_import_debug_options pt-3 pb-4 border-top">
                <h4>Advanced</h4>
                <div data-tooltip="If the model uses openchatter, history tracking will set up subscriptions and send notifications during the import, but lead to a slower import.">
                    <CheckBox value="!props.options.tracking_disable" onChange.bind="(isChecked) =&gt; this.props.onOptionChanged('tracking_disable', !isChecked)">
                        Track history during import
                    </CheckBox>
                </div>
                <CheckBox value="props.options.advanced" onChange.bind="(isChecked) =&gt; this.props.onOptionChanged('advanced', isChecked)">
                    Allow matching with subfields
                </CheckBox>
            </div>
            <div class="pt-3 pb-4 border-top">
                <h4>Help</h4>
                <t t-foreach="props.importTemplates" t-as="template" t-key="template">
                    <a class="d-block my-2" t-att-href="template.template" aria-label="Download" data-tooltip="Download">
                        <i class="fa fa-download"/> <span><t t-esc="template.label"/></span>
                    </a>
                </t>
                <DocumentationLink path="'/applications/general/export_import_data.html'" icon="'fa-external-link'" label.translate="Go to Import FAQ"/>
            </div>
        </div>
    </t>
`);
registerTemplate("base_import.ImportRecords", `/base_import/static/src/import_records/import_records.xml`, `<t t-name="base_import.ImportRecords" xml:space="preserve">
        <DropdownItem class="'o_import_menu'" onSelected.bind="importRecords">
            <i class="fa fa-fw fa-download me-1"/>Import records
        </DropdownItem>
    </t>

`);
registerTemplate("account_accountant.NewLoan", `/account_loans/static/src/components/loans/file_upload.xml`, `<t t-name="account_accountant.NewLoan" xml:space="preserve">
        <FileUploader acceptedFileExtensions="props.acceptedFileExtensions" fileUploadClass="'new_loan'" multiUpload="false" onUploaded.bind="onFileUploaded">
            <t t-set-slot="toggler">
                <span groups="account.group_account_invoice">
                    <button class="btn btn-primary">
                        Upload
                    </button>
                </span>
            </t>
            <t t-slot="default"/>
        </FileUploader>
        <span class="ms-1" groups="account.group_account_invoice">
            <button class="btn btn-secondary" t-on-click="openComputeWizard">
                Compute
            </button>
        </span>
    </t>
`);
registerTemplateExtension("mail.Thread", `/website_livechat/static/src/web/thread_patch.xml`, `<t t-name="website_livechat.Thread" t-inherit="mail.Thread" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[hasclass('o-mail-Thread')]" position="before">
            <t t-set="visitor" t-value="props.thread.visitor"/>
            <div t-if="visitor and !env.inChatWindow" class="o-website_livechat-VisitorBanner py-4 px-2 d-flex border-bottom">
                <div t-if="props.thread.correspondent" class="o-website_livechat-VisitorBanner-sidebar me-2 d-flex justify-content-center">
                    <img class="rounded o-website_livechat-VisitorBanner-avatar o_object_fit_cover" t-att-src="props.thread.correspondent.persona.avatarUrl" alt="Avatar"/>
                </div>
                <div>
                    <div class="d-flex align-items-baseline">
                        <ImStatus t-if="visitor.is_connected" className="'me-1'" persona="visitor"/>
                        <span class="me-2 fw-bolder" t-esc="visitor.name"/>
                        <img t-if="visitor.country" class="me-2 o_country_flag align-self-center" t-att-src="visitor.country.flagUrl" t-att-alt="visitor.country.code or visitor.country.name"/>
                        <span class="me-2">
                            <i class="me-1 fa fa-comment-o" aria-label="Lang"/>
                            <t t-esc="visitor.lang_name"/>
                        </span>
                        <span t-if="visitor.website_name">
                            <i class="me-1 fa fa-globe" aria-label="Website"/>
                            <span t-esc="visitor.website_name"/>
                        </span>
                    </div>
                    <div class="mt-1">
                        <i class="me-1 fa fa-history" aria-label="History"/>
                        <span t-esc="visitor.history"/>
                    </div>
                </div>
            </div>
        </xpath>
    </t>
`);
registerTemplateExtension("stock.ForecastedDetails", `/purchase_stock/static/src/purchase_stock_forecasted/forecasted_details.xml`, `<t t-name="purchase_stock.ForecastedDetails" t-inherit="stock.ForecastedDetails" t-inherit-mode="extension" xml:space="preserve">
         <xpath expr="//tr[@name='draft_picking_in']" position="after">
            <tr t-if="props.docs.draft_purchase_qty" name="draft_po_in" t-attf-class="#{props.docs.draft_purchase_orders_matched and 'o_grid_match table-info'}">
                <td colspan="2">Requests for quotation</td>
                <td t-out="_formatFloat(props.docs.draft_purchase_qty)" class="text-end"/>
                <td>
                    <t t-foreach="props.docs.draft_purchase_orders" t-as="purchase_order" t-key="purchase_order_index">
                        <t t-if="purchase_order_index &gt; 0"> | </t>
                        <a t-attf-href="#" t-out="purchase_order.name" class="fw-bold" t-on-click.prevent="() =&gt; this.props.openView('purchase.order', 'form', purchase_order.id)"/>
                    </t>
                </td>
            </tr>
        </xpath>
    </t>
`);
registerTemplate("base_iban.iban", `/base_iban/static/src/components/iban_widget/iban_widget.xml`, `<t t-name="base_iban.iban" t-inherit="web.CharField" xml:space="preserve">
        <xpath expr="//input" position="attributes">
            <attribute name="class" add="o_iban_input_with_validator" separator=" "/>
            <attribute name="t-on-input">validateIbanDebounced</attribute>
            <attribute name="t-on-focus">validateIbanDebounced</attribute>
            <attribute name="t-on-blur">(ev) =&gt; { this.state.isValidIBAN = null; }</attribute>
        </xpath>
        <xpath expr="//input" position="after">
            <t t-if="this.state.isValidIBAN === true">
                <i class="fa fa-check o_iban text-success"/>
            </t>
            <t t-elif="this.state.isValidIBAN === false">
                <i class="fa fa-times o_iban text-danger o_iban_fail" title="Account isn't a valid IBAN"/>
            </t>
        </xpath>
    </t>
`);
registerTemplate("hr_payroll_holidays.PayslipFormController", `/hr_payroll_holidays/static/src/js/hr_payslip_form.xml`, `<t t-name="hr_payroll_holidays.PayslipFormController" t-inherit="web.FormView" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//Layout/t[@t-component='props.Renderer']" position="before">
            <TimeOffToDeferWarning t-if="timeOff.hasTimeOffToDefer"/>
        </xpath>
    </t>

`);
registerTemplate("hr_payroll_holidays.PayslipListRenderer", `/hr_payroll_holidays/static/src/js/hr_payslip_list.xml`, `<t t-name="hr_payroll_holidays.PayslipListRenderer" t-inherit="web.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_list_renderer')]" position="before">
            <TimeOffToDeferWarning t-if="timeOff.hasTimeOffToDefer"/>
        </xpath>
    </t>

`);
registerTemplate("hr_payroll_holidays.TimeOffToDeferWarning", `/hr_payroll_holidays/static/src/views/hooks.xml`, `<t t-name="hr_payroll_holidays.TimeOffToDeferWarning" xml:space="preserve">
        <div class="alert alert-warning position-sticky text-center start-0 mb-0" role="alert">
            <p class="mb-0">
                <t t-esc="timeOffButtonText.before"/>
                <button class="btn btn-link p-0 align-baseline o_open_defer_time_off" role="button" t-esc="timeOffButtonText.inside" t-on-click="onTimeOffToDefer"/>
                <t t-esc="timeOffButtonText.after"/>
            </p>
        </div>
    </t>
`);
registerTemplate("hr_payroll_holidays.WorkEntryCalendarController", `/hr_payroll_holidays/static/src/views/work_entry_calendar/hr_work_entry_calendar_controller.xml`, `<t t-name="hr_payroll_holidays.WorkEntryCalendarController" t-inherit="web.CalendarController" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_calendar_container')]" position="before">
            <TimeOffToDeferWarning t-if="timeOff.hasTimeOffToDefer"/>
        </xpath>
    </t>

`);
registerTemplate("warning.time.off.to.defer", `/hr_payroll_holidays/static/src/xml/templates.xml`, `<t t-name="warning.time.off.to.defer" xml:space="preserve">
        <div class="alert alert-warning text-center mb-0" role="alert">
            <p class="mb-0">
                You have some <button class="btn btn-link p-0 o_open_defer_time_off" role="button">time off</button> to defer to the next month.
            </p>
        </div>
    </t>
`);
registerTemplateExtension("account_accountant.BankRecFinishButtons", `/account_bank_statement_import/static/src/bank_reconciliation/finish_buttons.xml`, `<t t-name="account_bank_statement_import.BankRecFinishButtons" t-inherit="account_accountant.BankRecFinishButtons" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//p" position="before">
            <div class="mb-1" t-call="account.AccountViewUploadButton"/>
        </xpath>
    </t>
`);
registerTemplate("account.BankRecKanbanButtons", `/account_bank_statement_import/static/src/bank_reconciliation/kanban.xml`, `<t t-name="account.BankRecKanbanButtons" xml:space="preserve">
        <xpath expr="//div[hasclass('o_cp_buttons')]" position="inside">
            <t t-call="account.AccountViewUploadButton"/>
        </xpath>
    </t>

    `);
registerTemplate("account.BankRecKanbanUploadRenderer", `/account_bank_statement_import/static/src/bank_reconciliation/kanban.xml`, `<t t-name="account.BankRecKanbanUploadRenderer" t-inherit="account.BankRecKanbanRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[@t-ref='root']" position="before">
            <UploadDropZone visible="dropzoneState.visible" hideZone="() =&gt; dropzoneState.visible = false"/>
        </xpath>
        <xpath expr="//div[@t-ref='root']" position="attributes">
            <attribute name="t-on-dragenter.stop.prevent">onDragStart</attribute>
        </xpath>
    </t>

`);
registerTemplate("account.BankRecListUploadButtons", `/account_bank_statement_import/static/src/bank_reconciliation/list.xml`, `<t t-name="account.BankRecListUploadButtons" t-inherit="web.ListView.Buttons" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_list_buttons')]" position="inside">
            <t t-call="account.AccountViewUploadButton"/>
        </xpath>
    </t>

    `);
registerTemplate("account.BankRecListUploadRenderer", `/account_bank_statement_import/static/src/bank_reconciliation/list.xml`, `<t t-name="account.BankRecListUploadRenderer" t-inherit="web.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[@t-ref='root']" position="before">
            <UploadDropZone visible="dropzoneState.visible" hideZone="() =&gt; dropzoneState.visible = false"/>
        </xpath>

        <xpath expr="//div[@t-ref='root']" position="attributes">
            <attribute name="t-on-dragenter.stop.prevent">onDragStart</attribute>
        </xpath>
    </t>
`);
registerTemplate("account_invoice_extract.Status", `/iap_extract/static/src/components/status_header/status.xml`, `<t t-name="account_invoice_extract.Status" xml:space="preserve">
        <div t-if="state.status === 'error_status'" class="alert alert-danger text-center">
            <t t-out="state.errorMessage" class="oe_inline" style="width:auto !important;"/>
            <button t-att-disabled="state.retryLoading" type="object" t-on-click="retryDigitalization" class="btn btn-link">
                <i class="oi oi-fw o_button_icon oi-arrow-right"/>
                Retry
            </button>
        </div>
        <div t-if="['waiting_extraction', 'extract_not_ready'].includes(state.status)" class="alert alert-info text-center">
            All fields will be automatically populated by Artificial Intelligence, it might take 5 seconds.
            <button t-att-disabled="state.checkStatusLoading" type="object" class="btn btn-link" t-on-click="checkOcrStatus">
                <i class="oi oi-fw o_button_icon oi-arrow-right"/>
                Refresh
            </button>
        </div>
        <div t-if="state.status === 'not_enough_credit'" class="alert alert-danger text-center">
            You don't have enough credit to extract data from your document.
            <button t-att-disabled="state.retryLoading" type="object" t-on-click="buyCredits" class="btn btn-link">
                <i class="oi oi-fw o_button_icon oi-arrow-right"/>
                Buy credits
            </button>
            <button t-att-disabled="state.retryLoading" type="object" t-on-click="retryDigitalization" class="btn btn-link">
                <i class="oi oi-fw o_button_icon oi-arrow-right"/>
                Retry
            </button>
        </div>
        <div t-if="state.status === 'waiting_validation'" class="alert alert-success text-center">
            Document successfully parsed. Please refresh.
            <button type="object" class="btn btn-link" t-on-click="refreshPage">
                <i class="oi oi-fw o_button_icon oi-arrow-right"/>
                Refresh
            </button>
        </div>
    </t>
`);
registerTemplate("account_base_import.accountImportTemplate", `/account_base_import/static/src/xml/account_import.xml`, `<t t-name="account_base_import.accountImportTemplate" xml:space="preserve">
        <ControlPanel/>
        <div class="container text-justify overflow-auto h-100">
            <div class="d-flex flex-column my-5 pt-4">
                <div class="title">
                    <h1>
                        Accounting Import Options
                    </h1>
                    <p>
                        Use predefined format to import your data faster.
                    </p>
                </div>
                <t t-if="countryCode === 'BE'">
                    <div class="winbooks-import pt-4">
                        <h2 class="text-primary">
                            Winbooks
                        </h2>
                        <p>
                            Winbooks is an old school Belgian accounting software acquired by Exact.
                            Use the
                            <a class="fw-bold" href="#" t-on-click.prevent="() =&gt; this._openModuleInstallation('account_winbooks_import')">
                                Account Winbooks Import module
                            </a>
                            to import a Winbooks full back-up (Maintenance &gt; Backup) to get the chart of accounts, contacts, taxes, history of journal entries, and documents.
                            Support versions: Winbooks Desktop 5.50, 6, 7, 8.
                        </p>
                    </div>
                </t>
                <t t-if="['FR', 'LU'].includes(countryCode) || isFecImportModuleInstalled">
                    <div class="fec-import pt-4">
                        <h2 class="text-primary">
                            FEC
                        </h2>
                        <p>
                            Most accounting software in France support exporting FEC file for audit purposes.
                            Use the
                            <a class="fw-bold" href="#" t-on-click.prevent="() =&gt; this._openModuleInstallation('l10n_fr_fec_import')">
                                FEC Import module
                            </a>
                            to import the FEC file. We will setup your charts of accounts and the history of journal entries.
                        </p>
                    </div>
                </t>
                <t t-if="['DK', 'LT', 'LU', 'NO', 'RO'].includes(countryCode)">
                    <div class="saft-import pt-4">
                        <h2 class="text-primary">
                            SAF-T
                        </h2>
                        <p>
                            Most accounting software in Europe support exporting SAF-T file for audit purposes.
                            Use the
                            <a class="fw-bold" href="#" t-on-click.prevent="() =&gt; this._openModuleInstallation('account_saft_import')">
                                SAF-T Import module
                            </a>
                            to import the SAF-T file. <br/>
                            We will setup your charts of accounts and the history of journal entries, that will stay in draft.
                        </p>
                    </div>
                </t>
                <t t-if="countryCode === 'SE'">
                    <div class="sie-import pt-4">
                        <h2 class="text-odoo">
                            SIE 4/5
                        </h2>
                        <p>
                            The SIE standard file format is very common in Sweden for several purposes such as auditing, importing and exporting data
                            from and to other accounting applications. Odoo support importing data from both type 4 and 5 of SIE.
                            <ul>
                                <li>
                                    <a class="fw-bold" href="#" t-on-click.prevent="() =&gt; this._openModuleInstallation('l10n_se_sie4_import')">
                                        SIE 4 Import module
                                    </a>
                                    is required to import the SIE 4 files.
                                    By design, it's also backward compatible with previous SIE versions (version 1 up to 3).
                                    This import will not validate the correctness of the file.
                                </li>
                                <li>
                                    <a class="fw-bold" href="#" t-on-click.prevent="() =&gt; this._openModuleInstallation('l10n_se_sie_import')">
                                        SIE 5 Import module
                                    </a>
                                    is required to import the SIE 5 and SIE 5 entry files.
                                    For general SIE 5, we will set up your charts of accounts balances, journals, partners, and the history of journal entries
                                    (journals data must be present in the file).
                                    For the SIE 5 entry, only entries and partners will be created, the rest must already be present in the system.
                                </li>
                            </ul>
                        </p>
                        <div class="d-flex gap-2 sie-import-buttons"/>
                    </div>
                </t>
                <div class="excel-import pt-4">
                    <h2 class="text-primary">
                        Excel Import
                    </h2>
                    <p>
                        Use templates to import CSV or Excel for your accounting setup.
                    </p>
                    <ol class="d-flex flex-column flex-lg-row">
                        <li class="pt-4">
                            <div class="row">
                                <div class="col-lg-10">
                                    <h3>Import contacts</h3>
                                    <p>Import customers or suppliers (partners) and their contacts using a
                                        <a class="fw-bold" href="/base/static/xls/res_partner.xlsx" aria-label="Download" title="Download">
                                            template.
                                        </a>
                                    </p>
                                    <button type="button" class="btn btn-primary" t-on-click="() =&gt; this._importAccountGuideAction('account_base_import.action_partner_import')">Import Contacts</button>
                                </div>
                                <div class="col-lg-2 border-start"/>
                            </div>
                        </li>
                        <li class="pt-4">
                            <div class="row">
                                <div class="col-lg-10">
                                    <h3>Import Chart of Accounts</h3>
                                    <p>Import the Chart of Accounts and initial balances using a
                                        <a class="fw-bold" href="/account/static/xls/coa_import_template.xlsx" aria-label="Download" title="Download">
                                            template.
                                        </a>
                                    </p>
                                    <button type="button" class="btn btn-primary" t-on-click="() =&gt; this._importAccountGuideAction('account_base_import.action_account_import')" style="margin-right: 2px;">Import CoA</button>
                                    or<button type="button" class="btn btn-link px-2" t-on-click="() =&gt; this._importAccountGuideAction('account_base_import.action_open_coa_setup')">Review Manually</button>
                                </div>
                                <div class="col-lg-2 border-start"/>
                            </div>
                        </li>
                        <li class="pt-4">
                            <div class="row">
                                <div class="col-lg-10">
                                    <h3>Import Journal Items</h3>
                                    <p>Optional, but useful to import open receivables &amp; payables using a
                                        <a class="fw-bold" href="/account/static/xls/aml_import_template.xlsx" aria-label="Download" title="Download">
                                            template.
                                        </a>
                                    </p>
                                    <button type="button" class="btn btn-primary" t-on-click="() =&gt; this._importAccountGuideAction('account_base_import.action_account_move_line_import')">Import Journal Items</button>
                                </div>
                            </div>
                        </li>
                    </ol>
                    <div class="pt-5 pb-5">
                        <p>Tip: we recommend importing your initial balances using the Chart of Account import. Only use the Journal Items import for unreconciled entries in your Payable and Receivable Accounts.</p>
                    </div>
                </div>

            </div>

        </div>
    </t>

`);
registerTemplate("account_disallowed_expenses.warning_multi_rate", `/account_disallowed_expenses/static/src/components/disallowed_expenses_report/warnings.xml`, `<t t-name="account_disallowed_expenses.warning_multi_rate" xml:space="preserve">
        There are multiple disallowed expenses rates in this period
    </t>
`);
registerTemplate("account_followup.FollowupTrustWidget", `/account_followup/static/src/components/change_trust_widget/followup_trust_widget.xml`, `<t t-name="account_followup.FollowupTrustWidget" xml:space="preserve">
        <t t-set="label" t-value="this.displayTrust()"/>
        <t t-set="trust_value" t-value="this.props.record.data[this.props.name]"/>
        <i t-attf-class="fa fa-circle oe-account_followup-trust-#{trust_value}" role="img" t-att-aria-label="label" t-att-title="label" t-on-click="(ev) =&gt; this.onTrustClick(ev)"/>
    </t>

    `);
registerTemplate("account_followup.FollowupTrustPopOver", `/account_followup/static/src/components/change_trust_widget/followup_trust_widget.xml`, `<t t-name="account_followup.FollowupTrustPopOver" xml:space="preserve">
        <div class="account_payment_popover">
            <t t-foreach="this.props.record.fields.trust.selection" t-as="trust_level" t-key="trust_level_index">
                <t t-set="trust_value" t-value="trust_level[0]"/>
                <t t-set="trust_display_name" t-value="trust_level[1]"/>
                <a role="menuitem" href="#" class="dropdown-item ps-4" t-on-click="() =&gt; this.props.widget.setTrust(trust_value)">
                    <i t-attf-class="fa fa-circle oe-account_followup-trust-#{trust_value}" role="img" t-att-aria-label="trust_display_name" t-att-title="trust_display_name"/> <t t-out="trust_display_name"/>
                </a>
            </t>
        </div>
    </t>
`);
registerTemplate("account_online_synchronization.AccountDuplicateTransactionsListRenderer", `/account_online_synchronization/static/src/components/account_duplicate_transaction/account_duplicate_transactions_x2many.xml`, `<t t-name="account_online_synchronization.AccountDuplicateTransactionsListRenderer" t-inherit="web.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//th[1]" position="replace"><th><i class="fa fa-trash"/></th></xpath>
        <xpath expr="//tfoot" position="replace"/>
    </t>
    `);
registerTemplate("account_online_synchronization.AccountDuplicateTransactionsRecordRow", `/account_online_synchronization/static/src/components/account_duplicate_transaction/account_duplicate_transactions_x2many.xml`, `<t t-name="account_online_synchronization.AccountDuplicateTransactionsRecordRow" t-inherit="web.ListRenderer.RecordRow" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//td[1]" position="replace">
            <td class="o_list_record_selector user-select-none" tabindex="-1">
                <CheckBox className="'d-flex m-0'" onChange.bind="(selected) =&gt; this.toggleRecordSelection(selected, record)"/>
            </td>
        </xpath>
    </t>
`);
registerTemplate("account.BankConfigureWidget", `/account_online_synchronization/static/src/components/bank_configure/bank_configure.xml`, `<t t-name="account.BankConfigureWidget" xml:space="preserve">
        <div class="bank_configure_container d-flex flex-wrap" t-ref="container">
            <t t-if="state.isLoading">
                loading...
            </t>
            <span t-elif="!state.institutions.length">
                <button class="btn btn-primary" t-on-click="fallbackConnectBank" name="action_configure_bank_journal">Setup Bank</button>
            </span>
            <div class="d-grid" t-attf-style="{{state.gridStyle}}" t-if="!state.isLoading and state.institutions.length">
                <div class="dashboard_bank" t-on-click="() =&gt; this.connectBank()">
                    <button class="h-100 w-100 rounded btn btn-primary fw-normal" name="action_configure_bank_journal">
                        <span class="img-fluid">Search over <span class="text-nowrap">26 000</span> banks</span>
                    </button>
                </div>
                <div t-foreach="state.institutions" t-as="institution" t-key="institution.id" t-attf-class="dashboard_bank" t-on-click="() =&gt; this.connectBank(institution.id)">
                    <button class="align-self-center h-100 w-100 rounded">
                        <span t-if="institution.default_picture" t-out="institution.name"/>
                        <img t-else="" class="img-fluid p-2" t-att-src="institution.picture" t-att-title="institution.name"/>
                    </button>
                </div>
            </div>
        </div>
    </t>
`);
registerTemplate("account_online_synchronization.FetchMissingTransactions", `/account_online_synchronization/static/src/components/bank_reconciliation/fetch_missing_transactions_cog_menu.xml`, `<t t-name="account_online_synchronization.FetchMissingTransactions" xml:space="preserve">
        <DropdownItem class="'o_import_menu'" onSelected.bind="openFetchMissingTransactionsWizard">
            Find Missing Transactions
        </DropdownItem>
    </t>
`);
registerTemplate("account_online_synchronization.FindDuplicateTransactions", `/account_online_synchronization/static/src/components/bank_reconciliation/find_duplicate_transactions_cog_menu.xml`, `<t t-name="account_online_synchronization.FindDuplicateTransactions" xml:space="preserve">
        <DropdownItem class="'o_import_menu'" onSelected.bind="openFindDuplicateTransactionsWizard">
            Find Duplicate Transactions
        </DropdownItem>
    </t>
`);
registerTemplate("account_online_synchronization.ConnectedUntil", `/account_online_synchronization/static/src/components/connected_until_widget/connected_until_widget.xml`, `<t t-name="account_online_synchronization.ConnectedUntil" xml:space="preserve">
        <div t-on-mouseenter="onMouseEnter" t-on-mouseleave="onMouseLeave" t-att-class="cssClasses">
            <t t-if="state.displayReconnectButton">
                <button class="btn btn-danger" t-on-click="extendConnection">
                    Reconnect Bank
                </button>
            </t>
            <t t-else="">
                <t t-if="!this.state.isHovered">
                    <i class="fa fa-warning" t-if="isConnectionExpiredIn(3)"/>
                    Connected until <t t-out="this.props.record.data.expiring_synchronization_date.toFormat('MMM dd')"/>
                </t>
                <t t-elif="this.state.isHovered">
                    <a class="oe_inline oe_kanban_action" href="#" t-on-click="extendConnection">
                        Extend Connection
                    </a>
                </t>
            </t>
        </div>
    </t>
`);
registerTemplate("account_online_synchronization.OnlineAccountRadio", `/account_online_synchronization/static/src/components/online_account_radio/online_account_radio.xml`, `<t t-name="account_online_synchronization.OnlineAccountRadio" xml:space="preserve">
        <div role="radiogroup" t-attf-class="o_{{ props.orientation }}" t-att-aria-label="string">
            <t t-foreach="items" t-as="item" t-key="item[0]">
                <div class="form-check o_radio_item" aria-atomic="true">
                    <input type="radio" class="form-check-input o_radio_input" t-att-checked="item[0] === value" t-att-disabled="props.readonly" t-att-name="id" t-att-data-value="item[0]" t-att-data-index="item_index" t-att-id="\`\${id}_\${item[0]}\`" t-on-change="() =&gt; this.onChange(item)"/>
                    <label class="form-check-label o_form_label" t-att-for="\`\${id}_\${item[0]}\`" t-out="item[1]"/>
                    <br/>
                    <p t-out="this.getBalanceName(item[0])" t-att-class="this.isNegativeAmount(item[0]) ? 'text-danger' : ''"/>
                </div>
            </t>
        </div>
    </t>
`);
registerTemplate("account_online_synchronization.RefreshSpin", `/account_online_synchronization/static/src/components/refresh_spin_journal_widget/refresh_spin_journal_widget.xml`, `<t t-name="account_online_synchronization.RefreshSpin" xml:space="preserve">
        <t t-if="this.connectionStatus === 'success'">
            <div>
                <t t-if="!!this.state.connectionStateDetails.nb_fetched_transactions">
                    <a href="#" t-on-click.prevent.stop="openAction">
                        <t t-out="this.state.connectionStateDetails.nb_fetched_transactions"/> transactions fetched
                    </a>
                </t>
                <t t-else="">
                    0 transaction fetched
                </t>
            </div>
        </t>
        <t t-elif="this.connectionStatus === 'error'">
            <div>
                <a t-if="this.state.connectionStateDetails.error_type === 'redirect_warning'" class="text-danger" href="#" t-on-click.prevent.stop="openAction">
                    <i class="fa fa-warning"/> See error
                </a>
                <button t-else="" class="btn btn-danger" t-on-click.prevent.stop="openAction">
                    Reconnect Bank
                </button>
            </div>
        </t>
        <t t-elif="this.connectionStatus === 'fetching'">
            <div t-on-mouseenter="onMouseEnter" t-on-mouseleave="onMouseLeave">
                <t t-if="this.state.isHovered">
                    <a class="oe_inline oe_kanban_action" href="#" t-on-click="refresh">Refresh</a>
                </t>
                <t t-else="">
                    <span>Fetching... <i class="fa fa-spinner fa-spin"/></span>
                </t>
            </div>
        </t>
        <t t-else="">
            <a href="#" t-on-click.prevent.stop="fetchTransactions" class="oe_inline">
                Fetch Transactions
            </a>
        </t>
    </t>
`);
registerTemplate("account_online_synchronization.TransientBankStatementLineRenderer", `/account_online_synchronization/static/src/components/transient_bank_statement_line_list_view/transient_bank_statement_line_list_view.xml`, `<t t-name="account_online_synchronization.TransientBankStatementLineRenderer" t-inherit="web.ListRenderer" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//table" position="before">
            <t t-if="env.searchModel.context.has_manual_entries">
                <div class="alert alert-warning text-center mb-0" role="alert">
                    You have <a href="" t-on-click.prevent="() =&gt; this.openManualEntries()">entries</a>
                    within this period that were not created using the online synchronization. This might cause duplicate entries.
                </div>
            </t>
            <t t-if="env.searchModel.context.is_fetch_before_creation">
                <div class="alert alert-warning text-center mb-0" role="alert">
                    You are importing transactions before the creation of your online synchronization
                    (<t t-out="env.searchModel.context.account_online_link_create_date"/>).
                    This might cause duplicate entries.
                </div>
            </t>
        </xpath>
    </t>

    `);
registerTemplate("TransientBankStatementLineButtonTemplate", `/account_online_synchronization/static/src/components/transient_bank_statement_line_list_view/transient_bank_statement_line_list_view.xml`, `<t t-name="TransientBankStatementLineButtonTemplate" t-inherit="web.ListView.Buttons" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_list_buttons')]" position="inside">
            <button type="button" class="btn btn-primary" data-hotkey="i" t-on-click.stop="onClickImportTransactions">
                Import Transactions
            </button>
        </xpath>
    </t>
`);
registerTemplateExtension("account.BankRecoKanbanController", `/account_online_synchronization/static/src/components/views/account_online_authorization_kanban_controller.xml`, `<t t-name="account_online_synchronization.AOSKanbanView" t-inherit="account.BankRecoKanbanController" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//Layout" position="before">
            <t t-if="displayDuplicateWarning">
                <div class="alert alert-warning text-center mb-0" role="alert">
                    Some transactions <a class="alert-link" href="" t-on-click.prevent="onWarningClick">may be duplicates.</a>
                </div>
            </t>
        </xpath>
    </t>
`);
registerTemplateExtension("account_reports.AccountReportFilterExtraOptions", `/account_reports_cash_basis/static/src/components/cash_basis_report/filter_extra_options.xml`, `<t t-name="account_reports_cash_basis.CashBasisReportFilterExtraOptions" t-inherit="account_reports.AccountReportFilterExtraOptions" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//DropdownItem[contains(@class, 'filter_show_all_hook')]" position="after">
            <t t-if="controller.groups.account_user and controller.filters.show_cash_basis">
                <DropdownItem class="{ 'selected': controller.options.report_cash_basis }" onSelected="() =&gt; this.filterClicked({ optionKey: 'report_cash_basis', reload: true})" closingMode="'none'">
                    Cash Basis Method
                </DropdownItem>
            </t>
        </xpath>
    </t>
`);
registerTemplateExtension("project.ProjectMilestone", `/sale_project/static/src/components/project_right_side_panel/components/project_milestone.xml`, `<t t-inherit="project.ProjectMilestone" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//t[@t-esc='milestone.name']" position="replace">
            <span>
                <t t-esc="milestone.name"/>
                <span t-if="milestone.allow_billable &amp;&amp; milestone.quantity_percentage &amp;&amp; !milestone.sale_line_display_name" class="fst-italic text-muted">
                    (<t t-esc="(100 * milestone.quantity_percentage).toFixed(2)"/>%)
                </span>
            </span>
            <span t-if="milestone.allow_billable" t-attf-class="fst-italic {{state.colorClass || 'text-muted'}} ms-2">
                <t t-if="milestone.sale_line_display_name" t-esc="milestone.sale_line_display_name"/>
                <span t-if="milestone.quantity_percentage &amp;&amp; milestone.sale_line_display_name">
                    (<t t-esc="(100 * milestone.quantity_percentage).toFixed(2)"/>%)
                </span>
           </span>
        </xpath>
    </t>
`);
registerTemplateExtension("project.ProjectProfitability", `/sale_project/static/src/components/project_right_side_panel/components/project_profitability.xml`, `<t t-name="sale_project.ProjectProfitability" t-inherit="project.ProjectProfitability" t-inherit-mode="extension" xml:space="preserve">
       <xpath expr="//tr[hasclass('revenue_section')]" position="replace">
            <ProjectProfitabilitySection revenue="revenue" labels="props.labels" formatMonetary="props.formatMonetary.bind(this)" onProjectActionClick="props.onProjectActionClick.bind(this)" onClick="(params) =&gt; this.props.onProjectActionClick(params)" projectId="this.props.projectId" context="this.props.context"/>
        </xpath>
    </t>
`);
registerTemplate("sale_project.ProjectProfitabilitySection", `/sale_project/static/src/components/project_right_side_panel/components/project_profitability_section.xml`, `<t t-name="sale_project.ProjectProfitabilitySection" xml:space="preserve">
        <tr>
            <t t-set="revenue_label" t-value="props.labels[revenue.id] or revenue.id"/>
            <td class="align-middle">
                <t t-if="this.props.revenue.isSectionFoldable">
                    <button t-attf-class="btn o_group_caret fa fa-fw me-1 #{state.isFolded ? 'fa-caret-right' : 'fa-caret-down'}" t-on-click="() =&gt; this.toggleSaleItems()"/>
                </t>
                <a class="revenue_section" t-if="revenue.action" href="#" t-on-click="() =&gt; this.props.onClick(revenue.action)">
                    <t t-esc="revenue_label"/>
                </a>
                <t t-esc="revenue_label" t-else=""/>
            </td>
            <td t-attf-class="text-end align-middle {{ revenue.invoiced + revenue.to_invoice === 0 ? 'text-500' : ''}}"><t t-esc="props.formatMonetary(revenue.invoiced + revenue.to_invoice)"/></td>
            <td t-attf-class="text-end align-middle {{ revenue.to_invoice === 0 ? 'text-500' : ''}}"><t t-esc="props.formatMonetary(revenue.to_invoice)"/></td>
            <td t-attf-class="text-end align-middle {{ revenue.invoiced === 0 ? 'text-500' : ''}}"><t t-esc="props.formatMonetary(revenue.invoiced)"/></td>
        </tr>
        <t t-if="!state.isFolded and this.props.revenue.isSectionFoldable">
            <tr>
                <td colspan="4" class="p-0 m-0">
                    <table class="table table-sm table-striped table-hover mb-0">
                        <thead>
                            <tr class="bg-light">
                                <th style="padding-left:30px">Sales Order Items</th>
                                <th class="text-end">Sold</th>
                                <th class="text-end">Delivered</th>
                                <th class="text-end">Invoiced</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr class="bg-light" t-foreach="sale_items" t-as="sale_item" t-key="sale_item.id">
                                <t t-set="uom_name" t-value="sale_item.product_uom and sale_item.product_uom[1]"/>
                                <td style="padding-left: 30px">
                                    <a t-if="sale_item.action" href="#" t-on-click="() =&gt; this.onSaleItemActionClick(sale_item.action)">
                                        <t t-esc="sale_item.name"/>
                                    </a>
                                    <t t-else="" t-esc="sale_item.name"/>
                                </td>
                                <td class="text-end align-middle"><t t-esc="formatValue(sale_item.product_uom_qty, uom_name)"/> <t t-esc="uom_name"/></td>
                                <td class="text-end align-middle"><t t-esc="formatValue(sale_item.qty_delivered, uom_name)"/> <t t-esc="uom_name"/></td>
                                <td class="text-end align-middle"><t t-esc="formatValue(sale_item.qty_invoiced, uom_name)"/> <t t-esc="uom_name"/></td>
                            </tr>
                        </tbody>
                        <tfoot>
                            <tr class="border-0 bg-light" t-if="state.displayLoadMore">
                                <td class="text-center" colspan="4">
                                    <a class="cursor-pointer btn-link w-100" t-on-click="() =&gt; this.onLoadMoreClick(revenue)">
                                        Load more
                                    </a>
                                </td>
                            </tr>
                        </tfoot>
                    </table>
                </td>
            </tr>
        </t>
    </t>
`);
registerTemplateExtension("project.ProjectRightSidePanel", `/sale_project/static/src/components/project_right_side_panel/project_right_side_panel.xml`, `<t t-name="sale_project.ProjectRightSidePanel" t-inherit="project.ProjectRightSidePanel" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//ProjectProfitability" position="replace">
            <ProjectProfitability t-if="showProjectProfitability" data="state.data.profitability_items" labels="state.data.profitability_labels" formatMonetary="formatMonetary.bind(this)" onProjectActionClick="onProjectActionClick.bind(this)" onClick="(params) =&gt; this.onProjectActionClick(params)" projectId="projectId" context="context"/>
        </xpath>
    </t>
`);
registerTemplate("spreadsheet.SpreadsheetBinaryField", `/spreadsheet/static/src/assets_backend/spreadsheet_binary_field/spreadsheet_binary_field.xml`, `<t t-name="spreadsheet.SpreadsheetBinaryField" t-inherit="web.BinaryField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@name='download']" position="replace"/>
        <xpath expr="//span[hasclass('fa-download')]" position="replace">
            <span class="fa fa-file-text-o me-2"/>
        </xpath>
    </t>
`);
registerTemplate("spreadsheet_edition.SpreadsheetSelectorDialog", `/spreadsheet_edition/static/src/assets/components/spreadsheet_selector_dialog/spreadsheet_selector_dialog.xml`, `<t t-name="spreadsheet_edition.SpreadsheetSelectorDialog" xml:space="preserve">
        <Dialog title="title">
            <div class="o-spreadsheet-templates-dialog">
                <div class="o-sp-dialog-meta-container">
                    <div class="o-sp-dialog-meta-name">
                        <div class="o-sp-dialog-meta-name-label" t-esc="nameLabel"/>
                        <input type="text" class="o_input o_sp_name" t-model="state.name"/>
                    </div>
                    <div t-if="props.type === 'LIST'" class="o-sp-dialog-meta-threshold">
                        <div class="o-sp-dialog-meta-threshold-text">Insert the first</div>
                        <input id="threshold" type="number" class="o_input o-sp-dialog-meta-threshold-input" t-model="state.threshold"/>
                        <div class="o-sp-dialog-meta-threshold-text">records of the list.</div>
                    </div>
                </div>
                <div class="o-sp-dialog-spreadsheets">
                    <Notebook pages="noteBookPages"/>
                </div>
                <t t-set-slot="footer">
                    <button class="btn btn-primary" t-att-disabled="state.confirmationIsPending" t-on-click="_confirm">Confirm</button>
                    <button class="btn btn-secondary" t-on-click="_cancel">Cancel</button>
                </t>
            </div>
        </Dialog>
    </t>

`);
registerTemplate("spreadsheet_edition.SpreadsheetSelectorPanel", `/spreadsheet_edition/static/src/assets/components/spreadsheet_selector_dialog/spreadsheet_selector_panel.xml`, `<t t-name="spreadsheet_edition.SpreadsheetSelectorPanel" xml:space="preserve">
        <div class="o-sp-dialog-cp">
            <div class="o-sp-searchview">
                <input type="text" class="o-sp-searchview-input o_input" placeholder="Search..." t-on-input="onSearchInput"/>
                <i class="o-sp-searchview-icon oi oi-search" role="img" aria-label="Search..." title="Search..."/>
            </div>
            <div class="o-pager">
                <Pager offset="state.pagerProps.offset" limit="state.pagerProps.limit" total="state.pagerProps.total" onUpdate.bind="onUpdatePager" isEditable="false"/>
            </div>
        </div>
		<SpreadsheetSelectorGrid spreadsheets="state.spreadsheets" onSpreadsheetSelected.bind="_selectItem" onSpreadsheetDblClicked.bind="props.onSpreadsheetDblClicked" getThumbnailURL="getThumbnailURL" selectedSpreadsheetId="state.selectedSpreadsheetId" displayBlank="props.displayBlank"/>
    </t>

`);
registerTemplate("documents_spreadsheet.SpreadsheetSelectorGrid", `/spreadsheet_edition/static/src/assets/components/spreadsheet_selector_grid/spreadsheet_selector_grid.xml`, `<t t-name="documents_spreadsheet.SpreadsheetSelectorGrid" xml:space="preserve">
        <div class="o-spreadsheets-grid-container">
            <div t-foreach="spreadsheets" t-as="spreadsheet" t-key="spreadsheet.id" class="o-spreadsheet-grid" t-att-class="spreadsheet.id === null ? 'o-blank-spreadsheet-grid' : ''">
                <div tabindex="0" t-on-focus="() =&gt; this.props.onSpreadsheetSelected(spreadsheet.id)" t-on-dblclick="this.props.onSpreadsheetDblClicked" t-att-class="{'o-spreadsheet-grid-image': true, 'o-spreadsheet-grid-selected': this.props.selectedSpreadsheetId === spreadsheet.id}" t-att-data-id="spreadsheet.id">
					<t t-set="thumbnail" t-value="spreadsheet.id === null ? this.blankThumbnailPlaceholder : props.getThumbnailURL(spreadsheet)"/>
                    <img t-if="thumbnail" t-att-src="thumbnail" t-att-title="spreadsheet.display_name"/>

                    <div t-else="1" class="o-spreadsheet-grid-no-preview d-flex flex-grow-1 align-items-center justify-content-center">
                        <p class="text-truncate text-muted m-1">No preview</p>
                    </div>
                </div>
                <div class="o-spreadsheet-grid-item-name" t-esc="spreadsheet.display_name"/>
            </div>


            <div t-foreach="Array(itemsPerPage)" t-as="i" t-key="i_index" class="o-spreadsheet-grid o-spreadsheet-grid-ghost-item mh-0"/>
        </div>
    </t>
`);
registerTemplate("spreadsheet_edition.InsertActionSpreadsheet", `/spreadsheet_edition/static/src/assets/insert_action_link_menu/insert_action_link_menu.xml`, `<t t-name="spreadsheet_edition.InsertActionSpreadsheet" xml:space="preserve">
        <DropdownItem class="'o_insert_action_spreadsheet_menu'" onSelected.bind="linkInSpreadsheet" closingMode="'none'">
            <i class="fa fa-fw fa-link me-1"/>Link menu in spreadsheet
        </DropdownItem>
    </t>

`);
registerTemplate("spreadsheet_edition.InsertListSpreadsheetMenu", `/spreadsheet_edition/static/src/assets/list_view/insert_list_spreadsheet_menu.xml`, `<t t-name="spreadsheet_edition.InsertListSpreadsheetMenu" xml:space="preserve">
        <DropdownItem class="'o_insert_list_spreadsheet_menu'" onSelected.bind="_onClick">
            <i class="oi oi-fw oi-view-list me-1"/>Insert list in spreadsheet
        </DropdownItem>
    </t>
`);
registerTemplate("spreadsheet_edition.SpreadsheetCogMenu", `/spreadsheet_edition/static/src/assets/spreadsheet_cog_menu/spreadsheet_cog_menu.xml`, `<t t-name="spreadsheet_edition.SpreadsheetCogMenu" xml:space="preserve">
        <Dropdown>
            <button class="opacity-trigger-hover">
                <t t-call="spreadsheet_edition.SpreadsheetIcon"/>
                Spreadsheet
            </button>
            <t t-set-slot="content">
                <InsertViewSpreadsheet/>
                <InsertListSpreadsheetMenu t-if="env.config.viewType === 'list'"/>
            </t>
        </Dropdown>
    </t>

    `);
registerTemplate("spreadsheet_edition.SpreadsheetIcon", `/spreadsheet_edition/static/src/assets/spreadsheet_cog_menu/spreadsheet_cog_menu.xml`, `<t t-name="spreadsheet_edition.SpreadsheetIcon" xml:space="preserve">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 50 50" class="o_ui_app_icon oi-large">
            <path fill="var(--oi-color, #1AD3BB)" d="M19 19L46 19L46 42C46 44.2091 44.2091 46 42 46L19 46L19 19Z" class="opacity-50 opacity-100-hover"/>
            <path fill="var(--oi-color, #1AD3BB)" d="M17 17L4 17L4 8C4 5.79086 5.79086 4 8 4L17 4L17 17Z" class="opacity-50 opacity-100-hover"/>
            <rect fill="var(--oi-color, #03AF89)" x="4" y="19" width="13" height="27"/>
            <rect fill="var(--oi-color, #03AF89)" x="19" y="4" width="27" height="13"/>
        </svg>
    </t>

`);
registerTemplateExtension("documents.DocumentsViews.ControlPanel", `/documents_spreadsheet/static/src/documents_view/documents_spreadsheet_controller_mixin.xml`, `<t t-name="spreadsheet.DocumentsViews.Buttons" t-inherit="documents.DocumentsViews.ControlPanel" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//button[hasclass('o_documents_kanban_url')]" position="after">
            <button type="button" class="btn btn-link dropdown-item o_documents_kanban_spreadsheet" t-if="userIsInternal" t-att-disabled="!canUploadInFolder(folder)" t-on-click.prevent="onClickCreateSpreadsheet" data-hotkey="x">
                <div class="d-inline me-1"><t t-call="spreadsheet_edition.SpreadsheetIcon"/></div>
                <span>Spreadsheet</span>
            </button>
        </xpath>
    </t>
`);
registerTemplateExtension("documents.ControlPanel", `/documents_spreadsheet/static/src/documents_control_panel/documents_control_panel.xml`, `<t t-name="spreadsheet.documents.ControlPanel" t-inherit="documents.ControlPanel" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//*[hasclass('o_documents_share_button')]" position="after">
            <button type="button" class="btn btn-secondary" t-if="!isInTrash and userIsInternal and singleSelection?.data?.handler === 'spreadsheet'" t-on-click.prevent="onClickFreezeAndShareSpreadsheet" data-hotkey="s">
                <t t-call="spreadsheet_edition.SpreadsheetIcon"/> Freeze and share
            </button>
        </xpath>
        <xpath expr="//*[hasclass('o_documents_export')]" position="after">
            <button class="dropdown-item w-100" t-if="!isInTrash and userIsInternal and this.documentsState.viewType === 'list'" t-on-click="() =&gt; this.onInsertInSpreadsheet()">
                <i class="oi oi-view-list fa-fw me-1"/>
                <span class="d-inline-block">Insert in spreadsheet</span>
            </button>
        </xpath>
        <xpath expr="//*[hasclass('o_documents_download_button')]" position="attributes">
            <attribute name="t-if">
                this.targetRecords.some((r) =&gt; !r.isRequest() and r.data.handler !== "spreadsheet")
            </attribute>
        </xpath>
    </t>
`);
registerTemplate("documents_spreadsheet.SpreadsheetCloneXlsxDialog", `/documents_spreadsheet/static/src/spreadsheet_clone_xlsx_dialog/spreadsheet_clone_xlsx_dialog.xml`, `<t t-name="documents_spreadsheet.SpreadsheetCloneXlsxDialog" t-inherit="web.ConfirmationDialog" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//p[@t-out='props.body']" position="replace">
            <p>Excel files cannot be previewed or edited directly in Odoo. Opening your file with Odoo Spreadsheet will allow you to do so.</p>
            <label for="willArchive" class="o_form_label me-4">Send source file to trash</label>
            <input class="form-check-input" type="checkbox" id="willArchive" name="willArchive" t-model="this.archiveDocumentState.willArchive"/>
        </xpath>
    </t>

`);
registerTemplate("documents_spreadsheet.TemplateDialog", `/documents_spreadsheet/static/src/spreadsheet_template/template_dialog.xml`, `<t t-name="documents_spreadsheet.TemplateDialog" xml:space="preserve">
        <div>
            <Dialog t-if="state.isOpen" title="dialogTitle" contentClass="'o-spreadsheet-templates-dialog'" footer="true">
                <div class="d-flex pb-2">
                    <div t-if="!props.folderId" class="flex-grow-1">
                        <span class="text-black me-3">Workspace</span>
                        <select class="w-50 d-inline-flex o_input" t-model.number="this.documentsSpreadsheetFolderId">
                            <option t-foreach="props.folders" t-as="folder" t-key="folder.id" t-att-value="folder.id" t-esc="folder.display_name"/>
                        </select>
                    </div>
                    <div class="ms-auto w-50">
                        <SearchBar/>
                    </div>
                </div>
                <div class="o-pager">
                    <Pager t-if="state.templatesCount" total="state.templatesCount" offset="state.offset" limit="limit" isEditable="false" onUpdate.bind="_onPagerChanged"/>
                </div>
				<SpreadsheetSelectorGrid spreadsheets="state.templates" onSpreadsheetSelected.bind="_selectTemplate" onSpreadsheetDblClicked.bind="_createSpreadsheet" getThumbnailURL="getThumbnailURL" selectedSpreadsheetId="state.selectedTemplateId"/>
                <t t-set-slot="footer">
                    <button class="btn btn-primary o-spreadsheet-create" t-att-disabled="_buttonDisabled()" t-on-click="_createSpreadsheet">
                        <t>Create</t>
                    </button>
                    <button class="btn btn-secondary" t-on-click="data.close">
                        <t>Discard</t>
                    </button>
                </t>
            </Dialog>
        </div>
    </t>
`);
registerTemplateExtension("calendar.AttendeeCalendarController", `/google_calendar/static/src/views/google_calendar/google_calendar_controller.xml`, `<t t-name="google_calendar.GoogleCalendarController" t-inherit="calendar.AttendeeCalendarController" t-inherit-mode="extension" xml:space="preserve">

        <xpath expr="//div[@id='header_synchronization_settings']//h5[@id='synchronize_with']" position="after">
            <div t-if="model.googleCredentialsSet and !model.googleIsSync and !model.googleIsPaused" id="google_calendar_sync" class="mx-1 d-inline-flex">
                <button type="button" id="google_sync_pending" class="btn btn-primary text-nowrap" t-on-click="onGoogleSyncCalendar">
                    <b>Google</b>
                </button>
            </div>
        </xpath>
    </t>
`);
registerTemplateExtension("timesheet_grid.TimesheetTimerHeader", `/helpdesk_timesheet/static/src/components/timesheet_timer_header/timesheet_timer_header.xml`, `<t t-inherit="timesheet_grid.TimesheetTimerHeader" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//Field[@name=&quot;'task_id'&quot;]" position="after">
            <Field name="'helpdesk_ticket_id'" class="'mt-3 mt-md-0 px-md-2 flex-grow-1'" record="props.timesheet" fieldInfo="props.fields['helpdesk_ticket_id']" placeholder="props.fields['helpdesk_ticket_id'].placeholder" t-if="hasHelpdeskProject"/>
        </xpath>
        <xpath expr="//Field[@name=&quot;'task_id'&quot;]" position="attributes">
            <attribute name="t-if">!hasHelpdeskProject</attribute>
        </xpath>
    </t>
`);
registerTemplate("sale_timesheet_enterprise.Many2OneAvatarRankField", `/sale_timesheet_enterprise/static/src/components/many2one_avatar_rank_field/many2one_avatar_rank_field.xml`, `<t t-name="sale_timesheet_enterprise.Many2OneAvatarRankField" xml:space="preserve">
        <t t-if="props.size === 'button'">
            <div class="d-flex align-items-stretch fw-bold text-white">
                <div t-attf-class="d-flex align-items-center rounded-start-2 px-2 {{rankingClassBackground}}">#<t t-esc="props.rank"/></div>
                <img t-attf-src="{{ this.imgSrc }}" alt="Avatar" width="32" height="32" class="rounded-0 rounded-end-2"/>
            </div>
        </t>
        <t t-elif="props.size === 'small'">
            <td>#<t t-esc="props.rank"/></td>
            <td class="p-0"><img t-attf-src="{{ this.imgSrc }}" alt="Avatar" width="32" height="32" class="rounded border"/></td>
        </t>
        <div t-else="props.size === 'medium'" class="position-relative d-flex justify-content-center align-items-center">
            <img t-attf-src="{{ this.imgSrc }}" alt="Avatar" width="100" height="100" t-attf-class="position-relative rounded-3 {{rankingClassBorder}} mb-2"/>
            <div t-attf-class="position-absolute bottom-0 start-50 translate-middle-x d-flex flex-row align-items-center px-2 rounded-3 {{rankingClassBorder}} {{rankingClassBackground}} text-white text-center fw-bold">
                #<t t-esc="props.rank"/>
            </div>
        </div>
    </t>
`);
registerTemplate("sale_timesheet_enterprise.TimesheetLeaderboard", `/sale_timesheet_enterprise/static/src/components/timesheet_leaderboard/timesheet_leaderboard.xml`, `<t t-name="sale_timesheet_enterprise.TimesheetLeaderboard" xml:space="preserve">
        <div class="d-flex align-items-center z-1 o_timesheet_leaderboard">
            <img t-if="props.showLeaderboard and props.leaderboard.current_employee?.index === 0" class="o_timesheet_leaderboard_confetti position-absolute top-0 end-0 o_object_fit_cover h-100 w-100" src="/base/static/img/onboarding_confetti.svg" alt="o_timesheet_leaderboard_confetti"/>
            <div t-if="props.showLeaderboard" class="position-relative btn btn-outline-secondary d-flex align-items-center justify-content-between px-2 py-1 gap-2" t-on-click="openLeaderboardPopup" role="button">
                <t t-if="props.leaderboard.leaderboard?.length &gt; 0">
                    <t t-foreach="props.leaderboard.leaderboard.slice(0, avatarDisplayLimit)" t-as="employee" t-key="employee_index">
                        <Many2OneAvatarRankField rank="employee_index + 1" id="employee.id" size="'button'"/>
                    </t>
                    <t t-if="props.leaderboard.current_employee?.index + 1 &gt; avatarDisplayLimit">
                        <span class="fs-2">···</span>
                        <Many2OneAvatarRankField rank="props.leaderboard.current_employee.index + 1" id="props.leaderboard.current_employee.id" size="'button'"/>
                    </t>
                </t>
                <t t-else="">
                    <div class="px-1" t-foreach="[1, 2, 3].slice(0, avatarDisplayLimit)" t-as="rank" t-key="rank">
                        <Many2OneAvatarRankField rank="rank" class="'pe-1'"/>
                    </div>
                </t>
            </div>
            <div t-if="props.showIndicators" class="d-flex flex-column flex-nowrap text-muted ms-2">
                <span>
                    <t t-if="props.leaderboard.current_employee">
                        <span>Billing: </span>
                        <span t-if="!isMobile" t-esc="currentBillingText"/>
                        <span t-attf-class="{{ props.leaderboard.current_employee.billing_rate &gt;= 100 ? 'text-success' : 'text-danger' }}" t-esc="currentBillingRateText"/>
                        <br/>
                        <span>Total: </span>
                        <span t-att-class="{'text-danger': props.leaderboard.current_employee.total_valid_time &lt; props.leaderboard.total_time_target}">
                            <t t-esc="currentTotalTimeText"/>
                        </span>
                    </t>
                    <t t-else="">
                        <t t-if="props.showLeaderboard">Record timesheets to earn your rank!</t>
                        <t t-else="">Record timesheets to determine your billing rate!</t>
                    </t>
                </span>
            </div>
        </div>
    </t>

`);
registerTemplate("sale_timesheet_enterprise.TimesheetLeaderboardDialog", `/sale_timesheet_enterprise/static/src/views/timesheet_leaderboard_dialog/timesheet_leaderboard_dialog.xml`, `<t t-name="sale_timesheet_enterprise.TimesheetLeaderboardDialog" xml:space="preserve">
        <Dialog size="xl" footer="false" header="true" t-on-keyup.stop="onKeyUp">
            <t t-set-slot="header">
                <div class="d-flex align-items-center justify-content-between flex w-100">
                    <button class="btn btn-secondary dropdown-toggle fs-5" t-esc="getTitle(state.type)" type="button" id="type" data-bs-toggle="dropdown" aria-expanded="false"/>
                    <ul class="dropdown-menu" aria-labelledby="type">
                        <li class="dropdown-item" t-on-click="() =&gt; this.changeType('billing_rate')" t-esc="getTitle('billing_rate')"/>
                        <li class="dropdown-item" t-on-click="() =&gt; this.changeType('total_time')" t-esc="getTitle('total_time')"/>
                    </ul>
                    <div t-on-click="props.close" type="button" class="btn-close" aria-label="Close"/>
                </div>
            </t>
            <div class="container px-0">
                <div class="row">
                    <div class="col">
                        <div class="d-flex justify-content-between align-items-center">
                            <span class="fs-3 fw-bolder text-center" t-esc="currentFormattedDate"/>
                            <div class="btn-group">
                                <button class="btn btn-secondary" t-on-click="goLastMonth">
                                    <i class="oi oi-chevron-left"/>
                                </button>
                                <button class="btn btn-secondary" t-on-click="goCurrentMonth">
                                    This month
                                </button>
                                <button class="btn btn-secondary" t-on-click="goNextMonth">
                                    <i class="oi oi-chevron-right"/>
                                </button>
                            </div>
                        </div>
                        <div class="row mx-0 mt-3 mb-2 py-3 gap-3 gap-sm-0 rounded bg-100">
                            <t t-if="state.leaderboard.length &gt; 0">
                                <t t-foreach="state.leaderboard.slice(0, 3)" t-as="employee" t-key="employee_index">
                                    <div class="col-12 col-sm-4 mx-sm-auto">
                                        <Many2OneAvatarRankField size="'medium'" rank="employee_index + 1" id="employee.id"/>
                                        <div class="d-flex flex-column align-items-center">
                                            <span class="text-center fs-4 fw-bolder mt-1 o_employee_name" t-esc="employee.name"/>
                                            <span class="small text-center">
                                                <t t-if="state.type === 'billing_rate'" t-esc="getBillingRateText(state.leaderboard[employee_index])"/>
                                                <t t-else="" t-esc="getTotalTimeText(state.leaderboard[employee_index])"/>
                                            </span>
                                        </div>
                                    </div>
                                </t>
                            </t>
                            <t t-else="">
                                <t t-foreach="[1, 2, 3]" t-as="employee" t-key="employee">
                                    <div class="col-12 col-sm-4 mx-sm-auto">
                                        <Many2OneAvatarRankField size="'medium'" rank="employee"/>
                                    </div>
                                </t>
                            </t>
                        </div>
                        <div t-attf-class="o_leaderboard_modal_table {{ state.current_employee.index &gt; 9 ? 'o_table_height_extra' : '' }} px-1" t-if="state.leaderboard.length &gt; 2">
                            <table class="table table-borderless table-striped table-sm mb-0 overflow-auto">
                                <tbody class="align-middle o_table_height_extra">
                                    <tr t-foreach="state.leaderboard.slice(3, displayLimit)" t-as="employee" t-key="employee_index" t-attf-class="{{ employee.id === state.current_employee.id ? 'fw-bolder' : '' }}">
                                        <Many2OneAvatarRankField size="'small'" rank="employee_index + 4" id="employee.id"/>
                                        <td class="o_employee_name" t-esc="employee.name"/>
                                        <td class="text-end small">
                                            <t t-if="state.type === 'billing_rate'" t-esc="getBillingRateText(state.leaderboard[employee_index + 3])"/>
                                            <t t-else="" t-esc="getTotalTimeText(state.leaderboard[employee_index + 3])"/>
                                        </td>
                                    </tr>
                                    <t t-if="state.current_employee.index &gt; 9 and !this.state.showAll">
                                        <tr>
                                            <td colspan="4" class="text-start text-muted">
                                                <span class="ps-1">···</span>
                                            </td>
                                        </tr>
                                        <tr t-attf-class="{{ 'employee.id == state.currentEmployee.id' ? 'fw-bolder' : '' }}">
                                            <Many2OneAvatarRankField rank="state.current_employee.index + 1" id="state.current_employee.id"/>
                                            <td t-esc="state.current_employee.name"/>
                                            <td class="text-end small">
                                                <t t-if="state.type === 'billing_rate'" t-esc="getBillingRateText(state.current_employee)"/>
                                                <t t-else="" t-esc="getTotalTimeText(state.current_employee)"/>
                                            </td>
                                        </tr>
                                    </t>
                                </tbody>
                            </table>
                        </div>
                        <span t-if="state.leaderboard.length &gt; 9" class="btn btn-secondary w-100 my-2 mb-lg-0 mt-lg-2" t-on-click="() =&gt; state.showAll = !state.showAll">
                            <t t-if="state.showAll">Show less</t>
                            <t t-else="">Show more</t>
                        </span>
                    </div>
                    <div class="col-12 col-lg-6">
                        <div class="o_timesheet_leaderboard_tip h-100 d-flex flex-column justify-content-center align-items-center p-4 rounded bg-gradient">
                            <span class="text-uppercase text-muted fw-bolder">Tip of the day</span>
                            <span class="pt-4 fs-2 text-break text-center fst-italic" t-esc="this.tip"/>
                        </div>
                    </div>
                </div>
            </div>
        </Dialog>
    </t>

`);
registerTemplateExtension("timesheet_grid.TimesheetTimerKanbanRenderer", `/sale_timesheet_enterprise/static/src/views/timesheet_leaderboard_timer_kanban/timesheet_leaderboard_timer_kanban_renderer.xml`, `<t t-name="sale_timesheet_enterprise.TimesheetLeaderboardTimerKanbanRenderer" t-inherit="timesheet_grid.TimesheetTimerKanbanRenderer" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('pinned_header')]" position="attributes">
            <attribute name="t-if" add="or showLeaderboardComponent" separator=" "/>
        </xpath>
        <xpath expr="//div[hasclass('pinned_header')]" position="inside">
            <div t-if="showLeaderboardComponent and !timesheetTimerRendererHook.timerState.timerRunning" class="position-relative pe-3 py-2 d-flex justify-content-end">
                <TimesheetLeaderboard leaderboard="timesheetTimerRendererHook.leaderboard" showIndicators="showIndicators" showLeaderboard="showLeaderboard" changeType="(type) =&gt; this.timesheetTimerRendererHook.changeLeaderboardType(type)" type="timesheetTimerRendererHook.leaderboardType"/>
            </div>
        </xpath>
        <xpath expr="//div[hasclass('pinned_header')]/div" position="attributes">
            <attribute name="t-if">timesheetTimerRendererHook.showTimer</attribute>
        </xpath>
    </t>

`);
registerTemplateExtension("timesheet_grid.TimesheetTimerListRenderer", `/sale_timesheet_enterprise/static/src/views/timesheet_leaderboard_timer_list/timesheet_leaderboard_timer_list_renderer.xml`, `<t t-name="sale_timesheet_enterprise.TimesheetLeaderboardTimerListRenderer" t-inherit="timesheet_grid.TimesheetTimerListRenderer" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('pinned_header')]" position="attributes">
            <attribute name="t-if" add="or showLeaderboardComponent" separator=" "/>
        </xpath>
        <xpath expr="//div[hasclass('pinned_header')]" position="inside">
            <div t-if="showLeaderboardComponent and !timesheetTimerRendererHook.timerState.timerRunning" class="position-relative pe-3 py-2 d-flex justify-content-end">
                <TimesheetLeaderboard leaderboard="timesheetTimerRendererHook.leaderboard" showIndicators="showIndicators" showLeaderboard="showLeaderboard" changeType="(type) =&gt; this.timesheetTimerRendererHook.changeLeaderboardType(type)" type="timesheetTimerRendererHook.leaderboardType"/>
            </div>
        </xpath>
        <xpath expr="//div[hasclass('pinned_header')]/div" position="attributes">
            <attribute name="t-if">timesheetTimerRendererHook.showTimer</attribute>
        </xpath>
        <xpath expr="//div[hasclass('o_list_renderer')]" position="attributes">
            <attribute name="t-attf-class" add="{{ env.isSmall ? '' : 'overflow-visible' }}" separator=" "/>
        </xpath>
    </t>

`);
registerTemplateExtension("calendar.AttendeeTagsList", `/hr_calendar/static/src/views/fields/attendee_tags_list.xml`, `<t t-name="hr_calendar.AttendeeTagsList" t-inherit="calendar.AttendeeTagsList" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('o_tag_badge_text')]" position="after">
            <div t-if="tag.unavailableIcon" title="unavailable" class="ms-1">
                <i class="fa fa-moon-o position-relative" role="img"/>
            </div>
        </xpath>
    </t>
`);
registerTemplate("hr_recruitment_reports.RankingPanel", `/hr_recruitment_reports/static/src/components/ranking_panel.xml`, `<t t-name="hr_recruitment_reports.RankingPanel" xml:space="preserve">
    <div>
        <h3><span t-esc="props.ranked_list.title"/></h3>
        <ol class="o_ranking_list">
            <li class="o_ranking_item" t-foreach="props.ranked_list.ranking_list" t-as="ranked" t-key="ranked.name">
                <span t-esc="ranked.name"/> (<span t-esc="ranked.score"/>)
            </li>
        </ol>
    </div>
</t>

`);
registerTemplateExtension("hr_skills.ResumeListRenderer.RecordRow", `/hr_skills_survey/static/src/fields/resume_one2many/resume_one2many.xml`, `<t t-inherit="hr_skills.ResumeListRenderer.RecordRow" t-inherit-mode="extension" xml:space="preserve">
    <xpath expr="//t[@id='row']" position="after">
        <t t-if="data.display_type === 'certification'">
            <td t-on-click="(ev) =&gt; this.onCellClicked(record, null, ev)" class="o_data_cell container" colspan="2">
                <div class="o_resume_line row" t-att-data-id="id">
                    <div class="o_resume_line_dates col-lg-3">
                        <span><t t-out="formatDate(data.date_end)"/></span>
                    </div>
                    <div class="o_resume_line_desc col-lg-8">
                        <h3>
                            <i class="fa fa-trophy text-warning me-1"/>
                            <t t-esc="data.name"/>
                        </h3>
                        <t t-if="data.description" t-out="data.description"/>
                    </div>
                </div>
            </td>
        </t>
    </xpath>
</t>

`);
registerTemplateExtension("hr_resume_data_row", `/hr_skills_survey/static/src/xml/resume_templates.xml`, `<t t-inherit="hr_resume_data_row" t-inherit-mode="extension" xml:space="preserve">
    <xpath expr="//tr[hasclass('o_data_row')]" position="inside">
        <t t-if="data.display_type === 'certification'">
            <td class="o_data_cell container" colspan="2">
                <div class="o_resume_line row" t-att-data-id="id">
                    <div class="o_resume_line_dates col-lg-3">
                        <span><t t-esc="data.date_end"/></span>
                    </div>
                    <div class="o_resume_line_desc col-lg-8">
                        <h3>
                            <i class="fa fa-trophy text-warning me-1"/>
                            <t t-esc="data.name"/>
                        </h3>
                        <t t-if="data.description" t-esc="data.description"/>
                    </div>
                </div>
            </td>
        </t>
    </xpath>
</t>

`);
registerTemplateExtension("account_accountant.BankRecRecordNotebookManualOperations", `/l10n_mx_edi/static/src/components/bank_reconcilliation/bank_rec_form.xml`, `<t t-name="l10n_mx_edi.BankRecRecordNotebookManualOperations" t-inherit="account_accountant.BankRecRecordNotebookManualOperations" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[@name='suggestion']" position="before">
            <div name="payment_way" t-if="line.data.flag === 'liquidity' and line.data.country_code === 'MX'" class="o_wrap_field d-flex d-sm-contents flex-column mb-3 mb-sm-0">
                <div class="o_cell o_wrap_label flex-grow-1 flex-sm-grow-0 w-100 text-break text-900">
                    <label class="o_form_label">Payment Way</label>
                </div>
                <div class="o_cell o_wrap_input flex-grow-1 flex-sm-grow-0 w-100 mb-1">
                    <div class="o_field_widget o_field_many2one">
                        <Many2OneField name="'l10n_mx_edi_payment_method_id'" record="line" canOpen="false" canQuickCreate="false"/>
                    </div>
                </div>
            </div>
        </xpath>
    </t>
`);
registerTemplateExtension("stock.ForecastedDetails", `/sale_stock/static/src/sale_stock_forecasted/forecasted_details.xml`, `<t t-name="sale_stock.ForecastedDetails" t-inherit="stock.ForecastedDetails" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//tr[@name='draft_picking_out']" position="after">
            <tr t-if="props.docs.draft_sale_qty" name="draft_so_out" t-attf-class="#{props.docs.draft_sale_orders_matched and 'o_grid_match table-info'}">
                <td colspan="2">Quotations</td>
                <td t-out="_formatFloat(-props.docs.draft_sale_qty)" class="text-end"/>
                <td>
                    <t t-foreach="props.docs.draft_sale_orders" t-as="sale_order" t-key="sale_order_index">
                        <t t-if="sale_order_index &gt; 0"> | </t>
                        <a t-attf-href="#" t-out="sale_order.name" class="fw-bold" t-on-click.prevent="() =&gt; this.props.openView('sale.order', 'form', sale_order.id)"/>
                    </t>
                </td>
            </tr>
        </xpath>
        <xpath expr="//td[@name='usedby_cell']" position="inside">
            <span t-if="line.move_out and line.move_out.picking_id and line.move_out.picking_id.sale_id">
                | <span t-out="_formatMonetary(line.move_out.picking_id.sale_id.amount_untaxed, line.move_out.picking_id.sale_id.currency_id.id)" class="fw-bold"/>
                | <span t-out="line.move_out.picking_id.sale_id.partner_id.name"/>
            </span>
        </xpath>
    </t>
`);
registerTemplate("sale_stock.QtyAtDate", `/sale_stock/static/src/widgets/qty_at_date_widget.xml`, `<t t-name="sale_stock.QtyAtDate" xml:space="preserve">
        <a t-att-tabindex="props.record.data.display_qty_widget ? '0' : '-1'" t-on-click="showPopup" t-att-class="!props.record.data.display_qty_widget ? 'invisible' : ''" t-attf-class="fa fa-area-chart cursor-pointer {{ calcData.forecasted_issue ? 'text-danger' : '' }}"/>
    </t>

    `);
registerTemplate("sale_stock.QtyAtDatePopover", `/sale_stock/static/src/widgets/qty_at_date_widget.xml`, `<t t-name="sale_stock.QtyAtDatePopover" xml:space="preserve">
        <div class="p-2">
        <h6>Availability</h6>
        <table class="table table-borderless table-sm">
            <tbody>
                <t t-if="!props.record.data.is_mto and ['draft', 'sent'].includes(props.record.data.state)">
                    <tr>
                        <td><strong>Forecasted Stock</strong><br/><small>On <span t-out="props.calcData.delivery_date"/></small></td>
                        <td class="text-end"><b t-out="props.record.data.virtual_available_at_date"/> <t t-out="props.record.data.product_uom[1]"/></td>
                    </tr>
                    <tr>
                        <td><strong>Available</strong><br/><small>All planned operations included</small></td>
                        <td class="text-end"><b t-out="props.record.data.free_qty_today" t-att-class="!props.calcData.will_be_fulfilled ? 'text-danger': ''"/> <t t-out="props.record.data.product_uom[1]"/></td>
                    </tr>
                </t>
                <t t-elif="props.record.data.is_mto and ['draft', 'sent'].includes(props.record.data.state)">
                    <tr>
                        <td><strong>Expected Delivery</strong></td>
                        <td class="oe-right"><span t-out="props.calcData.delivery_date"/></td>
                    </tr>
                    <tr>
                        <p>This product is replenished on demand.</p>
                    </tr>
                </t>
                <t t-elif="props.record.data.state == 'sale'">
                    <tr>
                        <td>
                            <strong>Reserved</strong><br/>
                        </td>
                        <td style="min-width: 50px; text-align: right;">
                            <b t-out="props.record.data.qty_available_today"/> <t t-out="props.record.data.product_uom[1]"/>
                        </td>
                    </tr>
                    <tr t-if="props.record.data.qty_available_today &lt; props.record.data.qty_to_deliver">
                        <td>
                            <span t-if="props.calcData.will_be_fulfilled and props.calcData.forecast_expected_date_str">
                                Remaining demand available at <b t-out="props.calcData.forecast_expected_date_str" t-att-class="props.record.data.scheduled_date &lt; props.record.data.forecast_expected_date ? 'text-danger' : ''"/>
                            </span>
                            <span t-elif="!props.calcData.will_be_fulfilled and props.calcData.forecast_expected_date_str" class="text-danger">
                                Not enough future availability
                            </span>
                            <span t-elif="!props.calcData.will_be_fulfilled" class="text-danger">
                                No future availability
                            </span>
                            <span t-else="">
                                Available in stock
                            </span>
                        </td>
                    </tr>
                </t>
            </tbody>
        </table>
        <button t-if="!props.record.data.is_mto" class="text-start btn btn-link" type="button" t-on-click="openForecast">
            <i class="oi oi-fw o_button_icon oi-arrow-right"/>
            View Forecast
        </button>
        </div>
    </t>
`);
registerTemplate("sale_stock.DelayAlertWidget", `/sale_stock/static/src/xml/delay_alert.xml`, `<div t-name="sale_stock.DelayAlertWidget" class="m-1" xml:space="preserve">
        <p>The delivery
            <t t-foreach="props.late_elements" t-as="late_element" t-key="late_element.id">
                <a t-esc="late_element.name" href="#" t-on-click="openElement" t-att-element-id="late_element.id" t-att-element-model="late_element.model"/>,
            </t> will be late.
        </p>
    </div>
`);
registerTemplate("l10n_mx_reports_closing.TrialBalanceFilterDate", `/l10n_mx_reports_closing/static/src/components/trial_balance/filter_date.xml`, `<t t-name="l10n_mx_reports_closing.TrialBalanceFilterDate" t-inherit="account_reports.AccountReportFilterDate" xml:space="preserve">

        <xpath expr="//div[@id='filter_date_divider_range']" position="after">
            <t t-if="controller.groups.account_user &amp;&amp; 'l10n_mx_month_13' in controller.options &amp;&amp; controller.options.comparison.filter == 'no_comparison'">
                <DropdownItem class="{ 'd-flex justify-content-between date_filter': true, 'selected': (this.isPeriodSelected('year13')) }" onSelected="() =&gt; this.selectDateFilter('year13', 'year13' != controller.options.date.period_type)" closingMode="'none'">
                    <div class="filter_name pe-3">
                        Month 13
                    </div>

                    <div class="d-flex justify-content-between">
                        <button class="btn_previous_date fa fa-caret-left" t-on-click="() =&gt; this.selectPreviousPeriod('year13')"/>
                        <time class="d-flex justify-content-center time_text">
                            <t t-out="this.displayPeriod('year13')"/>
                        </time>
                        <button class="btn_next_date fa fa-caret-right" t-on-click="() =&gt; this.selectNextPeriod('year13')"/>
                    </div>
                </DropdownItem>

                <div class="dropdown-divider"/>
            </t>
        </xpath>
    </t>
`);
registerTemplate("l10n_mx_reports_closing.TrialBalanceFilters", `/l10n_mx_reports_closing/static/src/components/trial_balance/filters.xml`, `<t t-name="l10n_mx_reports_closing.TrialBalanceFilters" t-inherit="account_reports.AccountReportFiltersCustomizable" xml:space="preserve">
        <xpath expr="//div[@id='filter_date']/t[@t-call]" position="replace">
            <t t-call="l10n_mx_reports_closing.TrialBalanceFilterDate"/>
        </xpath>
    </t>
`);
registerTemplate("partner_autocomplete.PartnerAutoComplete", `/partner_autocomplete/static/src/xml/partner_autocomplete.xml`, `<t t-name="partner_autocomplete.PartnerAutoComplete" t-inherit="web.AutoComplete" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//ul" position="inside">
            <t t-if="this.sources &amp;&amp; this.sources.at(-1)?.options.length !== 0 &amp;&amp; !this.shouldSearchWorldwide">  
                <li class="o-autocomplete--dropdown-item ui-menu-item d-block" t-on-pointerdown="() =&gt; this.ignoreBlur = true" t-on-mouseleave="() =&gt; this.onOptionMouseLeave()" t-on-click="(ev) =&gt; this.searchWorldwide(ev)">
                    <a t-attf-id="{{props.id or 'autocomplete'}}_{{source_index}}_{{option_index}}" role="option" href="#" class="dropdown-item ui-menu-item-wrapper text-truncate text-info" t-att-class="{ 'ui-state-active': isActiveSourceOption([source_index, option_index]) }" t-att-aria-selected="isActiveSourceOption([source_index, option_index]) ? 'true' : 'false'">
                        Search Worldwide 🌎
                    </a>
                </li>
            </t>
        </xpath>
    </t>

    `);
registerTemplate("partner_autocomplete.PartnerAutoCompleteCharField", `/partner_autocomplete/static/src/xml/partner_autocomplete.xml`, `<t t-name="partner_autocomplete.PartnerAutoCompleteCharField" t-inherit="web.CharField" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//t[@t-else='']" position="before">
            <t t-elif="props.record.resModel !== 'res.partner' || props.record.data.company_type === 'company'">
                <PartnerAutoComplete value="props.record.data[props.name] || ''" sources="sources" onSelect.bind="onSelect" input="inputRef" placeholder="placeholder || ''"/>
            </t>
        </xpath>
    </t>

    `);
registerTemplate("partner_autocomplete.PartnerAutoCompleteMany2XField", `/partner_autocomplete/static/src/xml/partner_autocomplete.xml`, `<t t-name="partner_autocomplete.PartnerAutoCompleteMany2XField" t-inherit="web.Many2XAutocomplete" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//AutoComplete" position="replace">
            <PartnerAutoComplete value="this.props.value || ''" autoSelect="true" sources="sources" onSelect.bind="onSelect" onChange.bind="onChange" input="inputRef" placeholder="placeholder || ''"/>
        </xpath>
    </t>

    `);
registerTemplate("partner_autocomplete.DropdownOption", `/partner_autocomplete/static/src/xml/partner_autocomplete.xml`, `<t t-name="partner_autocomplete.DropdownOption" xml:space="preserve">
        <div style="display: flex; justify-content: space-between; align-items: center; height: 24px;">
            <div>
                <span t-esc="option.name"/>,
                <span class="text-muted" t-esc="option.description"/>
            </div>
            <img style="width: 24px; max-height: 100%" class="ms-1" t-att-src="option.logoUrl" onerror="this.style.display='none'"/>
        </div>
    </t>

    `);
registerTemplate("partner_autocomplete.InsufficientCreditNotification", `/partner_autocomplete/static/src/xml/partner_autocomplete.xml`, `<t t-name="partner_autocomplete.InsufficientCreditNotification" xml:space="preserve">
        <div class="o-hidden-ios">
            <a class="btn btn-link" t-att-href="credits_url"><i class="oi oi-arrow-right"/> Buy more credits</a>
        </div>
    </t>

    `);
registerTemplate("partner_autocomplete.AccountTokenMissingNotification", `/partner_autocomplete/static/src/xml/partner_autocomplete.xml`, `<t t-name="partner_autocomplete.AccountTokenMissingNotification" xml:space="preserve">
        <div class="">
            <a class="btn btn-link" t-att-href="account_url"><i class="oi oi-arrow-right"/> Set Your Account Token</a>
        </div>
    </t>
`);
registerTemplate("product_barcodelookup.barcodeformbarcode", `/product_barcodelookup/static/src/widgets/barcode_scanner.xml`, `<t t-name="product_barcodelookup.barcodeformbarcode" t-inherit="web.CharField" xml:space="preserve">
        <xpath expr="//input" position="after">
            <button t-on-click="onBarcodeBtnClick" class="bg-white border-0" tabindex="-1">
                <i class="fa fa-barcode"/>
            </button>
        </xpath>
    </t>
`);
registerTemplateExtension("project.ProjectRightSidePanel", `/project_account_budget/static/src/components/project_right_side_panel/project_right_side_panel.xml`, `<t t-name="project_account_budget.ProjectRightSidePanel" t-inherit="project.ProjectRightSidePanel" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//ProjectRightSidePanelSection[@name=&quot;'profitability'&quot;]" position="after">
            <t t-set="showBudget" t-value="!!state.data.budget_items and !!state.data.budget_items.data"/>
            <ProjectRightSidePanelSection name="'budgets'" show="showBudget" showData="showBudget" dataClassName="'py-3'">
                <t t-set-slot="title">
                    Budgets
                </t>
                <t t-set-slot="header">
                    <div class="o_rightpanel_button btn btn-secondary" t-if="state.data.budget_items.can_add_budget">
                        <a t-on-click="addBudget">Add Budget</a>
                    </div>
                </t>
                <div t-if="!state.data.budget_items.data.length" class="ps-3">
                    <span class="text-muted fst-italic">
                        Compare expected and actual revenues and costs.
                    </span>
                </div>
                <table t-else="" class="table table-sm table-striped table-hover mb-0">
                    <thead class="bg-100 align-middle">
                        <tr>
                            <th>Budget</th>
                            <th class="text-end">Allocated</th>
                            <th class="text-end">Spent</th>
                            <th class="text-end">Remaining</th>
                        </tr>
                    </thead>
                    <tbody>
                        <t t-foreach="state.data.budget_items.data" t-as="budget_item" t-key="budget_item.id">
                            <tr>
                                <td>
                                    <a t-if="budget_item.action" class="o_rightpanel_button" t-on-click="() =&gt; this.onProjectActionClick(budget_item.action)">
                                        <t t-call="project_account_budget.BudgetName"/>
                                    </a>
                                    <t t-else="">
                                        <t t-call="project_account_budget.BudgetName"/>
                                    </t>
                                </td>
                                <td class="text-end align-middle" t-att-class="budget_item.allocated === 0 ? 'text-500' : ''"><t t-out="formatMonetary(budget_item.allocated)"/></td>
                                <td class="text-end align-middle" t-att-class="budget_item.spent === 0 ? 'text-500' : ''"><t t-out="formatMonetary(budget_item.spent)"/></td>
                                <t t-set="budget_remaining" t-value="budget_item.spent - budget_item.allocated"/>
                                <td class="text-end align-middle" t-attf-class="text-bold text-{{ budget_item.budget_type == 'expense' and (budget_item.progress &gt;= 0.25 ? 'danger': budget_item.progress &gt;= 0 ? 'warning': 'success')                                     or budget_item.progress &gt;= 0.25 ? 'success' : budget_item.progress &gt;= 0 ? 'warning' : 'danger' }}">
                                    <t t-out="formatMonetary(budget_remaining)"/>
                                    <t t-if="budget_item.allocated"> (<t t-out="Math.abs(budget_item.spent / budget_item.allocated * 100).toFixed()"/>%)</t>
                                </td>
                            </tr>
                            <t t-foreach="budget_item['budgets']" t-as="budget" t-key="budget.id">
                                <tr>
                                    <td><span class="ms-3"><small t-out="budget.name"/></span></td>
                                    <td class="text-end align-middle" t-att-class="budget.allocated === 0 ? 'text-500' : ''"><small t-out="formatMonetary(budget.allocated)"/></td>
                                    <td class="text-end align-middle" t-att-class="budget.spent === 0 ? 'text-500' : ''"><small t-out="formatMonetary(budget.spent)"/></td>
                                    <t t-set="budget_remaining" t-value="budget.spent - budget.allocated"/>
                                    <td class="text-end align-middle" t-attf-class="text-bold text-{{ budget_item.budget_type == 'expense' and (budget_item.progress &gt;= 0.25 ? 'danger': budget_item.progress &gt;= 0 ? 'warning': 'success')                                         or budget_item.progress &gt;= 0.25 ? 'success' : budget_item.progress &gt;= 0 ? 'warning' : 'danger' }}">
                                        <small t-out="formatMonetary(budget_remaining)"/>
                                        <t t-if="budget.allocated"> (<small t-out="Math.abs(budget.spent / budget.allocated * 100).toFixed()"/>%)</t>
                                    </td>
                                </tr>
                            </t>
                        </t>
                    </tbody>
                    <tfoot>
                        <tr class="fw-bolder">
                            <td>Total</td>
                            <t t-set="budget_total" t-value="state.data.budget_items.total"/>
                            <td class="text-end" t-att-class="budget_total.allocated === 0 ? 'text-500' : ''" t-esc="formatMonetary(budget_total.allocated)"/>
                            <td class="text-end" t-att-class="budget_total.spent === 0 ? 'text-500' : ''" t-esc="formatMonetary(budget_total.spent)"/>
                            <t t-set="budget_total_remaining" t-value="budget_total.spent - budget_total.allocated"/>
                            <td class="text-end" t-attf-class="text-bold text-{{ budget_total.progress &gt;= 0.25 ? 'success' : budget_total.progress &gt;= 0 ? 'warning' : 'danger' }}">
                               <t t-out="formatMonetary(budget_total_remaining)"/>
                               <t t-if="budget_total.allocated"> (<t t-out="Math.abs(budget_total.spent / budget_total.allocated * 100).toFixed()"/>%)</t>
                            </td>
                        </tr>
                    </tfoot>
                </table>
            </ProjectRightSidePanelSection>
        </xpath>
    </t>

    `);
registerTemplate("project_account_budget.BudgetName", `/project_account_budget/static/src/components/project_right_side_panel/project_right_side_panel.xml`, `<t t-name="project_account_budget.BudgetName" xml:space="preserve">
        <t t-if="budget_item.name">
            <t t-out="budget_item.name"/>
        </t>
        <t t-else="">
            <i>No Budget</i>
        </t>
    </t>

`);
registerTemplate("sale_account_accountant.BankRecRecordNotebookSaleOrders", `/sale_account_accountant/static/src/components/bank_reconciliation/bank_rec_form.xml`, `<t t-name="sale_account_accountant.BankRecRecordNotebookSaleOrders" xml:space="preserve">
        <div class="bank_rec_widget_form_sale_orders_anchor row">
            <span>There are <button class="btn btn-link align-baseline p-0" t-on-click.stop="() =&gt; this.actionRedirectToSaleOrders()" style="padding: 0; vertical-align: baseline; text-transform: none">uninvoiced sales orders</button> matching the communication of the bank statement line.</span>
        </div>
    </t>

    `);
registerTemplateExtension("account_accountant.BankRecRecordForm", `/sale_account_accountant/static/src/components/bank_reconciliation/bank_rec_form.xml`, `<t t-name="sale_account_accountant.BankRecRecordForm" t-inherit="account_accountant.BankRecRecordForm" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//t[@t-set-slot='amls_tab']" position="after">
            <t t-set-slot="sale_orders_tab" name="'sale_orders_tab'" title.translate="Sale Orders" isVisible="['valid', 'invalid'].includes(data.state) and data.matched_sale_order_ids.currentIds.length">
                <t t-call="sale_account_accountant.BankRecRecordNotebookSaleOrders"/>
            </t>
        </xpath>
    </t>

`);
registerTemplate("sale_pdf_quote_builder.CustomContentKanbanLike", `/sale_pdf_quote_builder/static/src/js/custom_content_kanban_like_widget/custom_content_kanban_like_widget.xml`, `<t t-name="sale_pdf_quote_builder.CustomContentKanbanLike" xml:space="preserve">
        <t t-if="state.headers.files?.length">
            <t t-call="sale_pdf_quote_builder.section">
                <t t-set="section" t-value="state.headers"/>
                <t t-set="save" t-value="(lineId, docId, isSelected) =&gt; {                         this.saveQuotationDocument(docId, isSelected);                     }"/>
            </t>
        </t>
        <t t-if="state.lines?.length">
            <t t-foreach="state.lines" t-as="section" t-key="section.id">
                <t t-call="sale_pdf_quote_builder.section">
                    <t t-set="save" t-value="(lineId, docId, isSelected) =&gt; {                             this.saveProductDocument(lineId, docId, isSelected);                         }"/>
                </t>
            </t>
        </t>
        <t t-if="state.footers.files?.length">
            <t t-call="sale_pdf_quote_builder.section">
                <t t-set="section" t-value="state.footers"/>
                <t t-set="save" t-value="(lineId, docId, isSelected) =&gt; {                         this.saveQuotationDocument(docId, isSelected);                     }"/>
            </t>
        </t>
    </t>

    `);
registerTemplate("sale_pdf_quote_builder.section", `/sale_pdf_quote_builder/static/src/js/custom_content_kanban_like_widget/custom_content_kanban_like_widget.xml`, `<t t-name="sale_pdf_quote_builder.section" xml:space="preserve">

        <t t-set="id" t-value="section.id or section.name"/>
        <div class="mb-4">
            <div class="mb-2">
                <h3 t-out="section.name"/>
                <t t-foreach="section.files" t-as="doc" t-key="id+'-button-'+doc.id">
                    <input type="checkbox" class="btn-check" t-att-id="id+'-'+doc.id" t-att-checked="doc.is_selected" t-on-click="() =&gt; {                             doc.is_selected = !doc.is_selected;                             save(id, doc.id, doc.is_selected);                         }"/>
                    <label class="btn btn-secondary m-1" t-att-for="id+'-'+doc.id" t-out="doc.name"/>
                </t>
            </div>
            <t t-foreach="section.files.filter(doc =&gt; doc.is_selected)" t-as="doc" t-key="id+'-'+doc.id+'-custom_form_fields'">
                <div t-if="doc.custom_form_fields.length" t-att-class="{'pb-1 mb-3 o_horizontal_separator': !doc_last}">
                    <t t-foreach="doc.custom_form_fields" t-as="formField" t-key="id+'-'+doc.id+'-custom_form_fields'+formField_index">
                        <CustomFieldCard name="formField.name" value="formField.value" onChange="(value) =&gt; { formField.value = value; this.updateJson(); }"/>
                    </t>
                </div>
            </t>
        </div>
    </t>
`);
registerTemplate("sale_pdf_quote_builder.customFieldCard", `/sale_pdf_quote_builder/static/src/js/custom_content_kanban_like_widget/custom_field_card/custom_field_card.xml`, `<t t-name="sale_pdf_quote_builder.customFieldCard" xml:space="preserve">
        <div>
            <h5 t-out="this.props.name" class="text-primary"/>
            <div class="mb-3">
                <span t-attf-class="card-text #{this.props.value ? '' : 'text-muted'}">
                    <textarea t-ref="customFieldCardTextArea" t-model.lazy="this.props.value" t-on-change="(ev) =&gt; { this.props.onChange(this.props.value) }" t-att-placeholder="this.placeholder" class="customFieldCardTextArea form-control overflow-y-hidden"/>
                </span>
            </div>
        </div>
    </t>

`);
registerTemplate("sale_pdf_quote_builder.QuotationDocumentX2ManyField", `/sale_pdf_quote_builder/static/src/js/quotation_document_kanban/quotation_document_kanban_widget.xml`, `<t t-name="sale_pdf_quote_builder.QuotationDocumentX2ManyField" t-inherit-mode="primary" t-inherit="web.X2ManyField" xml:space="preserve">
        <xpath expr="//div[hasclass('o_cp_buttons')]" position="inside">
            <UploadButton t-if="formData.sale_order_template_id" formData="formData" allowedMIMETypes="allowedMIMETypes" load.bind="() =&gt; this.props.record.load()" uploadRoute="uploadRoute"/>
        </xpath>
    </t>
`);
registerTemplateExtension("stock.ForecastedDetails", `/sale_subscription_stock/static/src/report_stock_forecasted.xml`, `<t t-name="sale_subscription_stock.ForecastedDetails" t-inherit="stock.ForecastedDetails" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//tr[@name='draft_picking_out']" position="after">
            <tr t-if="props.docs.subscription_qty" name="subscription_picking_out">
                <td colspan="2">Subscriptions</td>
                <td t-out="_formatFloat(this.props.docs.subscription_qty)" class="text-end"/>
                <td>
                    <t t-foreach="props.docs.subscription_sale_orders" t-as="sale_order" t-key="sale_order_index">
                        <t t-if="sale_order_index &gt; 0"> | </t>
                        <a t-attf-href="#" t-out="sale_order.name" class="fw-bold" t-on-click.prevent="() =&gt; this.props.openView('sale.order', 'form', sale_order.id)"/>
                    </t>
                </td>
            </tr>
        </xpath>
    </t>
`);
registerTemplate("snailmail.SnailmailError", `/snailmail/static/src/core_ui/snailmail_error.xml`, `<t t-name="snailmail.SnailmailError" xml:space="preserve">
        <Dialog contentClass="'o-snailmail-SnailmailError'" title.translate="Failed letter">
            <t t-if="props.failureType === 'sn_credit'">
                <p class="mx-3 mb-3">
                    The letter could not be sent due to insufficient credits on your IAP account.
                </p>
                <div t-if="snailmailCreditsUrl" class="text-end mx-3 mb-3">
                    <a class="btn btn-link" t-att-href="snailmailCreditsUrl" target="_blank">
                        <i class="oi oi-arrow-right"/> Buy credits
                    </a>
                </div>
            </t>
            <t t-elif="props.failureType === 'sn_trial'">
                <p class="mx-3 mb-3">
                    You need credits on your IAP account to send a letter.
                </p>
                <div t-if="snailmailCreditsUrlTrial" class="text-end mx-3 mb-3">
                    <a class="btn btn-link" t-att-href="snailmailCreditsUrlTrial">
                        <i class="oi oi-arrow-right"/> Buy credits
                    </a>
                </div>
            </t>
            <p t-elif="props.failureType === 'sn_price'" class="mx-3 mb-3">
                The country to which you want to send the letter is not supported by our service.
            </p>
            <p t-elif="props.failureType === 'sn_error'" class="mx-3 mb-3">
                An unknown error occurred. Please contact our <a href="https://www.odoo.com/help" target="new">support</a> for further assistance.
            </p>
            <t t-set-slot="footer">
                <button t-if="['sn_credit', 'sn_trial'].includes(props.failureType)" class="btn btn-primary me-2" t-on-click="onClickResendLetter">Re-send letter</button>
                <button class="btn me-2" t-att-class="{                     'btn-primary': !hasCreditsError,                     'btn-secondary': hasCreditsError,                     }" t-on-click="onClickCancelLetter">
                    Cancel letter
                </button>
                <button class="btn btn-secondary me-2" t-on-click="() =&gt; props.close()">Close</button>
            </t>
        </Dialog>
    </t>

`);
registerTemplate("snailmail.SnailmailNotificationPopover", `/snailmail/static/src/core_ui/snailmail_notification_popover.xml`, `<t t-name="snailmail.SnailmailNotificationPopover" t-inherit="mail.MessageNotificationPopover" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o-mail-MessageNotificationPopover')]" position="replace">
            <t t-if="props.message.message_type === 'snailmail'">
                <div class="o-snailmail-SnailmailNotificationPopover m-2" t-attf-class="{{ className }}">
                    <i class="me-2" t-att-class="props.message.notifications[0].statusIcon" role="img"/>
                    <span t-esc="props.message.notifications[0].statusTitle"/>
                </div>
            </t>
            <t t-else="">$0</t>
        </xpath>
    </t>

`);
registerTemplateExtension("social.StreamPostCommentsOriginalPost", `/social_crm/static/src/xml/social_crm_button.xml`, `<t t-inherit="social.StreamPostCommentsOriginalPost" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//a[hasclass('o_social_post_published_date')]" position="after">
            <div t-if="isConvertibleToLead?.()" class="o_social_icon_dropdown o_social_manage_post dropdown">
                <button t-attf-class="btn bg-white dropdown-toggle #{bubble_design ? 'bg-200 px-3 rounded-pill' : ''}" type="button" t-attf-id="post_actions_0" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <i class="fa fa-ellipsis-v"/>
                </button>
                <div class="dropdown-menu dropdown-menu-end" t-attf-aria-labelledby="post_actions_0">
                    <a class="o_social_generate_lead_post dropdown-item text-decoration-none" href="#" t-on-click="generateLeadFromPost">
                        Create Lead
                    </a>
                </div>
            </div>
        </xpath>
    </t>

    `);
registerTemplateExtension("social.StreamPostComment", `/social_crm/static/src/xml/social_crm_button.xml`, `<t t-inherit="social.StreamPostComment" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('o_social_manage_comment')]/div[hasclass('dropdown-menu')]" position="inside">
            <a t-if="isConvertibleToLead?.()" class="o_social_generate_lead_comment dropdown-item text-decoration-none" href="#" t-on-click="generateLeadFromComment">Create Lead</a>
        </xpath>
    </t>
`);
registerTemplate("SocialFacebookReactions", `/social_facebook/static/src/components/social_facebook_reactions/social_facebook_reactions.xml`, `<t t-name="SocialFacebookReactions" xml:space="preserve">
        <span t-out="mostUsedReactions"/>
    </t>

`);
registerTemplateExtension("social.StreamPostComments", `/social_facebook/static/src/xml/social_facebook_templates.xml`, `<t t-inherit="social.StreamPostComments" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//t[@t-set='bubble_design']" position="replace">
            <t t-set="bubble_design" t-value="true" t-if="originalPost.media_type.raw_value === 'facebook'"/>
        </xpath>
    </t>

    `);
registerTemplateExtension("social.StreamPostComment", `/social_facebook/static/src/xml/social_facebook_templates.xml`, `<t t-inherit="social.StreamPostComment" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//t[@t-set='bubble_design']" position="replace">
            <t t-set="bubble_design" t-value="true" t-if="originalPost.media_type.raw_value === 'facebook'"/>
        </xpath>

        <xpath expr="//span[hasclass('o_social_comment_likes_total')]" position="after">
            <span t-if="originalPost.media_type.raw_value === 'facebook'" t-foreach="facebookReactions || []" t-as="reaction" t-key="reaction[0]" class="o_social_likes_count badge rounded-pill bg-white py-1 ms-1">
                <t t-out="reaction[0]"/>
                <t t-out="reaction[1]"/>
            </span>
        </xpath>
    </t>

    `);
registerTemplateExtension("social.StreamPostCommentsOriginalPost", `/social_facebook/static/src/xml/social_facebook_templates.xml`, `<t t-inherit="social.StreamPostCommentsOriginalPost" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//span[hasclass('o_social_original_post_author_image')]" position="inside">
            <img t-if="originalPost.facebook_author_id.raw_value" t-attf-src="https://graph.facebook.com/v17.0/{{ originalPost.facebook_author_id.raw_value }}/picture" alt="Author Image" class="rounded"/>
        </xpath>
        <xpath expr="//div[hasclass('o_social_comments_modal_original_post_content')]" position="inside">
            <div class="o_social_original_post_facebook_stats d-flex justify-content-around pt-2" t-if="originalPost.media_type.raw_value === 'facebook'">
                <div class="o_social_facebook_likes px-2 mb-2" t-att-class="{'o_social_facebook_user_likes': originalPost.facebook_user_likes.raw_value}" t-on-click="() =&gt; this._onFacebookPostLike()">
                    <t t-if="originalPost.facebook_likes_count.raw_value !== 0">
                        <t t-foreach="facebookReactions || []" t-as="reaction" t-key="reaction[0]">
                            <b t-out="reaction[0]"/>
                            <b class="o_social_likes_count mx-1" t-out="reaction[1]"/>
                        </t>
                    </t>
                    <span t-else="" class="fa fa-thumbs-o-up" title="Like"/>
                </div>
                <div class="flex-grow-1 d-flex text-muted justify-content-end">
                    <div>
                        <t t-esc="originalPost.facebook_shares_count.value"/>
                        Shares
                    </div>
                    <div class="ms-3">
                        <t t-esc="originalPost.facebook_reach.value"/>
                        Views
                    </div>
                </div>
            </div>
        </xpath>
    </t>
`);
registerTemplateExtension("social.StreamPostCommentsOriginalPost", `/social_instagram/static/src/xml/social_instagram_templates.xml`, `<t t-inherit="social.StreamPostCommentsOriginalPost" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//span[hasclass('o_social_original_post_author_image')]" position="inside">
            <img t-if="originalPost.instagram_facebook_author_id.raw_value" t-attf-src="https://graph.facebook.com/v17.0/{{ originalPost.instagram_facebook_author_id.raw_value }}/picture" alt="Author Image" class="rounded"/>
        </xpath>
        <xpath expr="//div[hasclass('o_social_comments_modal_original_post_content')]" position="inside">
            <div t-if="originalPost.media_type.raw_value === 'instagram'" class="o_social_original_post_instagram_stats d-flex justify-content-around pt-2">
                <div class="o_social_instagram_likes ps-2 pe-3" t-att-data-post-id="originalPost.id.raw_value">
                    <t t-if="originalPost.instagram_likes_count.raw_value !== 0">
                        <i class="fa fa-heart me-1" title="Likes"/>
                        <b class="o_social_likes_count" t-esc="originalPost.instagram_likes_count.value"/>
                    </t>
                </div>
                <div class="flex-grow-1"/>
            </div>
        </xpath>
    </t>
`);
registerTemplateExtension("social.StreamPostCommentsOriginalPost", `/social_linkedin/static/src/xml/social_linkedin_templates.xml`, `<t t-inherit="social.StreamPostCommentsOriginalPost" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//span[hasclass('o_social_original_post_author_image')]" position="inside">
            <img t-if="originalPost.linkedin_author_image_url.raw_value" t-att-src="originalPost.linkedin_author_image_url.raw_value" alt="Author Image" class="rounded"/>
        </xpath>
        <xpath expr="//div[hasclass('o_social_comments_modal_original_post_content')]" position="inside">
            <div t-if="originalPost.media_type.raw_value === 'linkedin'" class="text-start">
                <div t-if="originalPost.linkedin_likes_count.raw_value !== 0" class="o_social_linkedin_likes ps-2 pe-3" t-att-data-post-id="originalPost.id.raw_value">
                    <i class="fa fa-thumbs-up me-1" title="Likes"/>
                    <b class="o_social_likes_count" t-esc="originalPost.linkedin_likes_count.value"/>
                </div>
            </div>
        </xpath>
    </t>
`);
registerTemplateExtension("social.StreamPostCommentsOriginalPost", `/social_twitter/static/src/xml/social_twitter_templates.xml`, `<t t-inherit="social.StreamPostCommentsOriginalPost" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//span[hasclass('o_social_original_post_author_image')]" position="inside">
            <img t-if="originalPost.twitter_profile_image_url.value" t-att-src="originalPost.twitter_profile_image_url.value" alt="Author Image" class="rounded"/>
        </xpath>
        <xpath expr="//div[hasclass('o_social_comments_modal_original_post_content')]" position="inside">
            <div class="o_social_original_post_twitter_stats d-flex justify-content-around" t-if="originalPost.media_type.raw_value === 'twitter'">
                <div class="o_social_twitter_likes ps-2 pe-3" t-att-class="{'o_social_twitter_user_likes': originalPost.twitter_user_likes.raw_value}" t-att-data-user-likes="originalPost.twitter_user_likes.raw_value" t-att-data-post-id="originalPost.id.raw_value">
                    <t t-if="originalPost.twitter_likes_count.raw_value !== 0">
                        <i class="fa fa-heart me-1" title="Likes"/>
                        <b class="o_social_likes_count" t-esc="originalPost.twitter_likes_count.value"/>
                    </t>
                </div>
                <div class="flex-grow-1 d-flex text-muted justify-content-end">
                    <div t-if="originalPost.twitter_retweet_count.raw_value &gt; 0">
                        <t t-esc="originalPost.twitter_retweet_count.value"/>
                        Reposts
                    </div>
                </div>
            </div>
            <t t-if="originalPost.twitter_quoted_tweet_id_str?.raw_value" t-call="social_twitter.StreamPostQuotedTweet">
                <t t-set="post" t-value="originalPost"/>
                <t t-set="formattedMessage">
                    <t t-out="_formatCommentStreamPost(post.twitter_quoted_tweet_message.raw_value)"/>
                </t>
            </t>
        </xpath>
    </t>

    `);
registerTemplate("social_twitter.StreamPostQuotedTweet", `/social_twitter/static/src/xml/social_twitter_templates.xml`, `<t t-name="social_twitter.StreamPostQuotedTweet" xml:space="preserve">
        <t t-set="unknown_author_name_label">Unknown</t>
        <div class="border rounded p-2 my-2">
            <t t-set="author_info">
                <span t-if="post.twitter_profile_image_url.raw_value" class="o_social_stream_post_author_image o_social_author_image o_avatar position-relative rounded overflow-hidden">
                    <img t-att-src="post.twitter_quoted_tweet_profile_image_url.raw_value                         or '/base/static/img/avatar_grey.png'" alt="Author Image" class="rounded"/>
                </span>
                <span class="o_social_stream_post_author_image o_social_author_image o_avatar position-relative rounded overflow-hidden"/>
                <span class="o_social_stream_post_author_name text-truncate ms-2" t-esc="post.twitter_quoted_tweet_author_name.value or unknown_author_name_label" t-att-title="post.twitter_quoted_tweet_author_name.value or unknown_author_name_label"/>
            </t>
            <a t-if="post.twitter_quoted_tweet_author_link.value" class="o_social_stream_post_author d-inline-flex align-items-center" t-att-href="post.twitter_quoted_tweet_author_link.value" t-att-title="post.twitter_quoted_tweet_author_name.value or unknown_author_name_label" t-out="author_info" target="_blank"/>
            <div t-else="" class="o_social_stream_post_author d-inline-flex align-items-center" t-out="author_info"/>
            <div name="o_social_stream_post_message_text" class="o_social_stream_post_message_text overflow-hidden">
                <span t-if="formattedMessage" t-out="formattedMessage"/>
                <span t-else="" class="fst-italic">Empty post</span>
            </div>
        </div>
    </t>

    `);
registerTemplateExtension("social.StreamPostCommentsReply", `/social_twitter/static/src/xml/social_twitter_templates.xml`, `<t t-inherit="social.StreamPostCommentsReply" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//form" position="inside">
            <input t-if="comment &amp;&amp; comment.from &amp;&amp; comment.from.screen_name" type="hidden" name="answering_to" t-att-value="isCommentReply ? comment.from.screen_name : ''"/>
        </xpath>
    </t>

    `);
registerTemplate("social_twitter.TwitterQuoteDialog", `/social_twitter/static/src/xml/social_twitter_templates.xml`, `<t t-name="social_twitter.TwitterQuoteDialog" xml:space="preserve">
        <Dialog title="props.title" size="'md'" bodyClass="'o_social_quote_modal o_social_comments_modal'">
            <StreamPostCommentsReplyTwitterQuote mediaSpecificProps="props.mediaSpecificProps" originalPost="props.originalPost" onAddComment="() =&gt; {}" preventAddComment="() =&gt; {}"/>
            <t t-call="social_twitter.StreamPostCommentsOriginalPostQuote"/>
            <t t-set-slot="footer">
                <button class="btn btn-primary" t-on-click="_confirmQuoteTweet">Post</button>
                <button class="btn btn-secondary" t-on-click="() =&gt; props.close()">Cancel</button>
            </t>
        </Dialog>
    </t>

    `);
registerTemplate("social_twitter.StreamPostCommentsReplyQuote", `/social_twitter/static/src/xml/social_twitter_templates.xml`, `<t t-name="social_twitter.StreamPostCommentsReplyQuote" t-inherit="social.StreamPostCommentsReply" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//textarea[@name='message']" position="attributes">
            <attribute name="t-on-keydown"/>
        </xpath>
        <xpath expr="//div[@name='o_social_textarea_helper']" position="replace"/>
    </t>

    `);
registerTemplate("social_twitter.StreamPostCommentsOriginalPostQuote", `/social_twitter/static/src/xml/social_twitter_templates.xml`, `<t t-name="social_twitter.StreamPostCommentsOriginalPostQuote" t-inherit="social.StreamPostCommentsOriginalPost" t-inherit-mode="primary" xml:space="preserve">
        <xpath expr="//div[hasclass('o_social_comments_modal_original_post')]" position="attributes">
            <attribute name="class">d-flex bg-white p-3 mt-3 border rounded</attribute>
        </xpath>
    </t>



    `);
registerTemplate("social_twitter.users_autocomplete_element", `/social_twitter/static/src/xml/social_twitter_templates.xml`, `<t t-name="social_twitter.users_autocomplete_element" xml:space="preserve">
        <div t-attf-class="o_social_twitter_users_autocomplete_suggestion clearfix#{suggestion_index == 0 and ' active' or ''}">
            <img t-att-src="option['profile_image_url']" alt="X Profile Image"/>
            <div class="o_twitter_users_autocomplete_info">
                <strong><span class="o_twitter_users_autocomplete_info_name">
                    <t t-esc="option['name']"/> - @<t t-esc="option['username']"/>
                </span></strong>
                <br/>
                <span><small t-esc="option['description']"/></span>
            </div>
        </div>
    </t>

    `);
registerTemplate("social_twitter.TwitterUsersAutocompleteField", `/social_twitter/static/src/xml/social_twitter_templates.xml`, `<t t-name="social_twitter.TwitterUsersAutocompleteField" t-inherit="web.CharField" xml:space="preserve">
        <xpath expr="//t[@t-else='']" position="replace">
            <AutoComplete autofocus="true" value="value" sources="sources" onSelect.bind="selectTwitterUser"/>
        </xpath>
    </t>
`);
registerTemplateExtension("social.StreamPostCommentsOriginalPost", `/social_youtube/static/src/xml/social_youtube_templates.xml`, `<t t-inherit="social.StreamPostCommentsOriginalPost" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//span[hasclass('o_social_original_post_author_image')]" position="inside">
            <img t-if="originalPost.media_type.raw_value == 'youtube'" t-attf-src="/web/image/social.account/{{ originalPost.account_id.raw_value }}/image/48x48" alt="Author Image" class="rounded"/>
        </xpath>
        <xpath expr="//div[@name='o_social_original_post_message_body']" position="before">
            <div t-if="originalPost.media_type.raw_value === 'youtube'" class="pt-2 pb-3">
                <div class="fw-bold pb-3" t-esc="originalPost.link_title.value"/>
                <div class="w-100 ratio ratio-16x9 bg-200">
                    <iframe t-attf-src="https://www.youtube.com/embed/{{ originalPost.youtube_video_id.raw_value }}?origin={{ window.document.location.host }}&amp;rel=0" frameborder="0" allowfullscreen="1"/>
                </div>
            </div>
        </xpath>
        <xpath expr="//div[hasclass('o_social_comments_modal_original_post_content')]" position="inside">
            <div t-if="originalPost.media_type.raw_value === 'youtube'" class="o_social_original_post_youtube_stats d-flex pt-2">
                <div class="o_social_subtle_btn_disabled ps-2">
                    <i class="fa fa-thumbs-o-up me-1" title="Likes"/>
                    <b t-esc="originalPost.youtube_likes_count.value"/>
                </div>
                <div class="o_social_subtle_btn_disabled ps-2">
                    <b t-esc="originalPost.youtube_comments_count.value"/>
                    Comments
                </div>
                <div class="o_social_subtle_btn_disabled ps-3 fw-bold ms-auto">
                    Views
                    <t t-esc="originalPost.youtube_views_count.value"/>
                </div>
            </div>
        </xpath>
    </t>

    `);
registerTemplate("social_youtube.YoutubeUploadField", `/social_youtube/static/src/xml/social_youtube_templates.xml`, `<t t-name="social_youtube.YoutubeUploadField" xml:space="preserve">
        <t t-if="props.readonly">
            <div class="o_social_youtube_field">
                <span type="text" class="o_social_youtube_upload_filename" t-att-class="{'d-none': !this.props.record.data[this.props.name]}" t-out="this.props.record.data[this.props.name]"/>
            </div>
        </t>
        <t t-else="">
            <div class="o_field_widget o_field_binary_file o_social_youtube_field o_social_youtube_field" aria-atomic="true">
                <input type="text" class="o_input o_social_youtube_upload_filename" t-att-class="{'d-none': !this.props.record.data[this.props.name]}" readonly="readonly" t-att-name="this.props.name" t-att-value="this.props.record.data[this.props.name]"/>
                <div class="o_social_youtube_upload_bar w-100 position-relative" t-att-class="{'d-none': !this.state.uploading}">
                    <div class="position-absolute fw-bold w-100 h-100 text-center">
                        <span class="fa fa-spin fa-spinner me-1"/>
                        <span class="o_social_youtube_upload_text" t-out="this.state.socialYoutubeText"/>
                    </div>
                    <div class="o_social_youtube_upload_progress h-100" t-attf-style="width: {{this.state.uploadProgress}}%;"/>
                </div>
                <button type="button" class="btn btn-primary o_select_file_button" t-att-class="{'d-none': this.state.uploading || this.props.record.data[this.props.name]}" t-on-click="_onUploadClick" title="Select">Upload Video</button>
                <button type="button" class="btn btn-secondary fa fa-trash-o o_clear_file_button" t-att-class="{'d-none': !this.props.record.data[this.props.name]}" title="Clear" aria-label="Clear" t-on-click="this._onClearClick"/>

                <div class="o_hidden_input_file" aria-atomic="true">
                    <form method="post" enctype="multipart/form-data" class="o_form_binary_form o_social_youtube_upload_form">
                        <input type="file" class="o_input_file" name="file" accept="video/*" t-ref="fileInput" t-on-change="this._onFileChanged"/>
                    </form>
                </div>
            </div>
            <div class="alert alert-danger fw-bold w-100 h-100 mt-2 text-center" t-out="state.uploadErrorMessage" t-if="state.uploadErrorMessage"/>
        </t>
    </t>
`);
registerTemplate("spreadsheet_dashboard_edition.DashboardEditAction", `/spreadsheet_dashboard_edition/static/src/bundle/action/dashboard_edit_action.xml`, `<div t-name="spreadsheet_dashboard_edition.DashboardEditAction" class="o_dashboard_edit_action" xml:space="preserve">
        <SpreadsheetNavbar t-props="navbarProps"/>
        <SpreadsheetComponent model="model"/>
    </div>

`);
registerTemplate("spreadsheet_dashboard_edition.DashboardEdit", `/spreadsheet_dashboard_edition/static/src/bundle/components/dashboard_edit/dashboard_edit.xml`, `<div t-name="spreadsheet_dashboard_edition.DashboardEdit" xml:space="preserve">
    <button t-if="isDashboardAdmin" type="button" class="btn btn-link o_edit_dashboard fa fa-pencil" tabindex="-1" draggable="false" aria-label="Edit" data-tooltip="Edit" t-on-click.stop="onClick"/>
  </div>
`);
registerTemplate("spreadsheet_edition.DashboardPublish", `/spreadsheet_dashboard_edition/static/src/bundle/components/dashboard_publish/dashboard_publish.xml`, `<div t-name="spreadsheet_edition.DashboardPublish" class="d-flex h-100 align-items-center o_sp_publish_dashboard" t-on-click="toggleDashboardPublished" xml:space="preserve">
        <CheckBox onChange.bind="() =&gt; {}" disabled="isReadonly" value="state.isPublished" className="'boolean_toggle form-switch'"/>
        <div class="pe-1">
            <t t-if="state.isPublished">Published</t>
            <t t-else="">Unpublished</t>
        </div>
    </div>
`);
registerTemplate("spreadsheet_dashboard_documents.DocumentSelectorDialog", `/spreadsheet_dashboard_documents/static/src/assets/document_selector_dialog/document_selector_dialog.xml`, `<t t-name="spreadsheet_dashboard_documents.DocumentSelectorDialog" xml:space="preserve">
        <Dialog title.translate="Create a Dashboard or select a Spreadsheet">
            <div class="o-spreadsheet-templates-dialog">
                <div class="o-sp-dialog-spreadsheets">
                    <div class="o-sp-dialog-content">
                        <SpreadsheetSelectorPanel model="'documents.document'" onSpreadsheetSelected.bind="onSpreadsheetSelected" onSpreadsheetDblClicked.bind="_confirm"/>
                    </div>
                </div>
                <t t-set-slot="footer">
                    <button class="btn btn-primary" t-on-click="_confirm">Confirm</button>
                    <button class="btn btn-secondary" t-on-click="_cancel">Cancel</button>
                </t>
            </div>
        </Dialog>
    </t>

`);
registerTemplateExtension("website.Configurator.WelcomeScreen", `/website_enterprise/static/src/client_actions/configurator/configurator.xml`, `<t t-name="website_enterprise.Configurator.WelcomeScreen" t-inherit="website.Configurator.WelcomeScreen" t-inherit-mode="extension" xml:space="preserve">
    <xpath expr="//button[hasclass('o_configurator_show')]" position="after">
        <span class="mx-2" t-if="showWebsiteGeneratorButton">
            or <a href="#" t-on-click="goToWebsiteGeneratorRequest">import your website</a>
        </span>
    </xpath>
</t>

`);
registerTemplateExtension("knowledge.PermissionPanel", `/website_knowledge/static/src/backend/components/permission_panel/permission_panel.xml`, `<t t-name="knowledge.WebsitePublishingButton" t-inherit="knowledge.PermissionPanel" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//div[hasclass('o_knowledge_permission_panel')]/*[1]" position="before">
            <div class="d-flex px-3" t-on-click="() =&gt; this.toggleWebsitePublished()">
                <div class="o_knowledge_share_panel_icon align-self-center d-flex justify-content-center align-items-center flex-shrink-0">
                    <i class="fa fa-globe fa-2x" title="Share to web"/>
                </div>
                <div class="container">
                    <div class="row">
                        <div class="lead fw-bold col-sm-8">
                            <t t-if="this.props.record.data.website_published">
                                Article shared to web
                            </t>
                            <t t-elif="this.isInternalUser and this.props.record.data.user_can_write">
                                Share to web
                            </t>
                            <t t-else="">
                                Article not Published
                            </t>
                        </div>
                        <div class="col-sm o_knowledge_share_toggle align-self-start d-flex align-items-end pe-3 form-check form-switch" t-if="this.props.record.data.user_can_write and isInternalUser">
                            <input class="form-check-input" type="checkbox" role="switch" t-att-checked="this.props.record.data.website_published"/>
                        </div>
                    </div>
                    <div class="row text-muted ps-3">
                        <t t-if="this.props.record.data.website_published">
                            It and its published children can be read by anyone
                        </t>
                        <t t-elif="this.isInternalUser and this.props.record.data.user_can_write">
                            Publish this Article and its children on the web
                        </t>
                        <t t-else="">
                            Only specific people can access
                        </t>
                    </div>
                </div>
            </div>
            <div class="px-3 my-2 o_field_CopyClipboardChar" t-if="this.props.record.data.website_published">
                <CopyClipboardCharField name="'article_url'" record="props.record" readonly="true"/>
            </div>
            <div class="dropdown-divider" t-if="this.state.members.length !== 0"/>
        </xpath>
    </t>
`);
registerTemplateExtension("knowledge.KnowledgeTopbar", `/website_knowledge/static/src/backend/components/topbar/topbar.xml`, `<t t-name="website_knowledge.Topbar" t-inherit="knowledge.KnowledgeTopbar" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//a[@t-ref='sharePanel_button']/i[hasclass('o_knowledge_share_panel_icon')]" position="replace">
            <i t-if="props.record.data.website_published" class="fa fa-fw fs-6 fa-globe text-success me-1"/>
            <i t-else="" class="fa fa-fw fs-6 fa-share-alt me-1"/>
        </xpath>
    </t>
`);
registerTemplate("board.AddToBoard", `/board/static/src/add_to_board/add_to_board.xml`, `<t t-name="board.AddToBoard" xml:space="preserve">
        <div class="o_add_to_board">
            <Dropdown>
                <button>
                    <t t-call="Dashboard.DashboardIcon"/>
                    Dashboard
                </button>
                <t t-set-slot="content">
                    <div class="px-3 pb-2">
                        <label class="mb-2">Add to my dashboard</label>
                        <input type="text" class="o_input mb-3" t-ref="autofocus" t-model.trim="state.name" t-on-keydown="onInputKeydown"/>
                        <button type="button" class="btn btn-primary" t-on-click="addToBoard">Add</button>
                    </div>
                </t>
            </Dropdown>
        </div>
    </t>

    `);
registerTemplate("Dashboard.DashboardIcon", `/board/static/src/add_to_board/add_to_board.xml`, `<t t-name="Dashboard.DashboardIcon" xml:space="preserve">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 50 50" class="o_ui_app_icon oi-large">
            <path d="M4 8C4 5.79086 5.79086 4 8 4H25V21C25 23.2091 23.2091 25 21 25H4V8Z" fill="var(--oi-color, #FC868B)"/>
            <path d="M4 35C4 32.7909 5.79086 31 8 31H19V42C19 44.2091 17.2091 46 15 46H4V35Z" fill="var(--oi-color, #F9464C)"/>
            <path d="M25 46H29C31.2091 46 33 44.2091 33 42V31H29C26.7909 31 25 32.7909 25 35V46Z" fill="var(--oi-color, #FBB945)"/>
            <path d="M31 17L31 21C31 23.2091 32.7909 25 35 25L46 25V21C46 18.7909 44.2091 17 42 17L31 17Z" fill="var(--oi-color, #088BF5)"/>
            <path d="M31 4L31 8C31 10.2091 32.7909 12 35 12L46 12V8C46 5.79086 44.2091 4 42 4L31 4Z" fill="var(--oi-color, #2EBCFA)"/>
            <path d="M38 46H42C44.2091 46 46 44.2091 46 42V31H42C39.7909 31 38 32.7909 38 35V46Z" fill="var(--oi-color, #F78613)"/>
        </svg>
    </t>
`);
registerTemplate("board.BoardAction", `/board/static/src/board_action.xml`, `<t t-name="board.BoardAction" xml:space="preserve">
        <t t-if="isValid">
            <View t-props="viewProps"/>
        </t>
        <t t-else="">
            <div class="text-center text-warning m-1">Invalid action</div>
        </t>
    </t>
`);
registerTemplate("board.BoardView", `/board/static/src/board_controller.xml`, `<t t-name="board.BoardView" xml:space="preserve">
        <div class="o_dashboard d-flex flex-column">
            <t t-if="board.isEmpty">
                <t t-call="board.NoContent"/>
            </t>
            <t t-else="">
                <t t-call="board.Content"/>
            </t>
        </div>
    </t>

    `);
registerTemplate("board.Content", `/board/static/src/board_controller.xml`, `<t t-name="board.Content" xml:space="preserve">
        <div t-if="!env.isSmall" class="o-dashboard-header d-flex justify-content-end">
            <Dropdown>
                <button class="btn btn-secondary m-2 p-2">
                    <img t-attf-src="/board/static/img/layout_{{board.layout}}.png" width="16" height="16" alt=""/>
                    Change Layout
                </button>
                <t t-set-slot="content">
                    <t t-foreach="'1 1-1 1-1-1 1-2 2-1'.split(' ')" t-as="layout" t-key="layout">
                        <DropdownItem onSelected="() =&gt; this.selectLayout(layout)">
                            <img t-attf-src="/board/static/img/layout_{{layout}}.png" alt=""/>
                            <i t-if="layout == board.layout" class="fa fa-check fa-lg text-success" aria-label="Layout" role="img" title="Layout"/>
                        </DropdownItem>
                    </t>
                </t>
            </Dropdown>
        </div>
        <div class="o-dashboard-layout flex-grow-1" t-attf-class="o-dashboard-layout-{{board.layout}}" t-ref="main">
            <t t-foreach="board.columns" t-as="column" t-key="column_index">
                <div t-if="column_index lt board.colNumber" class="o-dashboard-column h-100" t-att-data-idx="column_index">
                    <t t-foreach="column.actions" t-as="action" t-key="action.id">
                        <div class="o-dashboard-action mx-3 my-1 bg-view border" t-att-data-idx="action_index">
                            <h3 t-attf-class="o-dashboard-action-header {{action.title ? '' : 'oe_header_empty'}} p-2 m-2">
                                <span> <t t-esc="action.title"/> </span>
                                <span t-if="!env.isSmall" class="btn float-end p-1 text-muted" t-on-click="() =&gt; this.closeAction(column, action)"><i class="fa fa-close"/></span>
                                <span class="btn float-end p-1 text-muted" t-if="!action.isFolded" t-on-click="() =&gt; this.toggleAction(action, !env.isSmall)"><i class="fa fa-window-minimize"/></span>
                                <span class="btn float-end p-1 text-muted" t-if="action.isFolded" t-on-click="() =&gt; this.toggleAction(action, !env.isSmall)"><i class="fa fa-window-maximize"/></span>
                            </h3>
                            <BoardAction t-if="!action.isFolded" action="action"/>
                        </div>
                    </t>
                </div>
            </t>
        </div>
    </t>

    `);
registerTemplate("board.NoContent", `/board/static/src/board_controller.xml`, `<t t-name="board.NoContent" xml:space="preserve">
        <div class="o_view_nocontent">
            <div class="o_nocontent_help">
                <p class="o_view_nocontent_neutral_face">
                  Your personal dashboard is empty
                </p>
                <p>
                  To add your first report into this dashboard, go to any
                  menu, switch to list or graph view, and click <i>"Add to
                  Dashboard"</i> in the extended search options.
                </p>
                <p>
                  You can filter and group data before inserting into the
                  dashboard using the search options.
                </p>
            </div>
        </div>
    </t>

    `);
registerTemplate("board.arch", `/board/static/src/board_controller.xml`, `<t t-name="board.arch" xml:space="preserve">
        <form t-att-string="title">
            <board t-att-style="layout">
                <column t-foreach="columns" t-as="column" t-key="column_index">
                    <t t-foreach="column.actions" t-as="action" t-key="action_index">
                        <action t-att-name="action.actionId" t-att-string="action.title" t-att-view_mode="action.viewMode" t-att-context="action.context" t-att-domain="action.domain" t-att-fold="action.isFolded ? 1 : 0"/>
                    </t>
                </column>
            </board>
        </form>
    </t>


`);
registerTemplate("hr_recruitment_skills.SearchJobApplicant", `/hr_recruitment_skills/static/src/components/search_job_applicant_menu/search_job_applicant_menu.xml`, `<t t-name="hr_recruitment_skills.SearchJobApplicant" xml:space="preserve">
        <DropdownItem onSelected.bind="openMatchingJobApplicants">
            <i class="fa fa-fw fa-search me-1" aria-hidden="true"/>Search Matching Applicants
        </DropdownItem>
    </t>
`);
registerTemplateExtension("calendar.AttendeeCalendarController", `/appointment_crm/static/src/views/appointment_calendar/appointment_crm_calendar_controller.xml`, `<t t-name="appointment_crm.AppointmentCrmCalendarController" t-inherit="calendar.AttendeeCalendarController" t-inherit-mode="extension" xml:space="preserve">
        <xpath expr="//span[@t-if='appointmentState.lastAppointment.url and !appointmentState.lastAppointment.waitingCopyLinkCustomType']" position="after">
            <p t-elif="getOpportunityName()" class="mx-2 user-select-none">
                Click in your calendar to pick meeting time proposals for <b t-esc="getOpportunityName()"/>
            </p>
        </xpath>
    </t>
`);
                    });
